export declare class Handle_TObj_Model {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_Model): void;
  get(): TObj_Model;
  delete(): void;
}

  export declare class Handle_TObj_Model_1 extends Handle_TObj_Model {
    constructor();
  }

  export declare class Handle_TObj_Model_2 extends Handle_TObj_Model {
    constructor(thePtr: TObj_Model);
  }

  export declare class Handle_TObj_Model_3 extends Handle_TObj_Model {
    constructor(theHandle: Handle_TObj_Model);
  }

  export declare class Handle_TObj_Model_4 extends Handle_TObj_Model {
    constructor(theHandle: Handle_TObj_Model);
  }

export declare class TObj_Model extends Standard_Transient {
  SetMessenger(theMsgr: Handle_Message_Messenger): void;
  Messenger(): Handle_Message_Messenger;
  Load(theFile: TCollection_ExtendedString): Standard_Boolean;
  SaveAs(theFile: TCollection_ExtendedString): Standard_Boolean;
  Save(): Standard_Boolean;
  Close(): Standard_Boolean;
  CloseDocument(theDoc: Handle_TDocStd_Document): void;
  static GetDocumentModel(theLabel: TDF_Label): Handle_TObj_Model;
  GetFile(): Handle_TCollection_HExtendedString;
  GetObjects(): Handle_TObj_ObjectIterator;
  GetChildren(): Handle_TObj_ObjectIterator;
  FindObject(theName: Handle_TCollection_HExtendedString, theDictionary: Handle_TObj_TNameContainer): Handle_TObj_Object;
  GetChecker(): Handle_TObj_CheckModel;
  GetRoot(): Handle_TObj_Object;
  GetMainPartition(): Handle_TObj_Partition;
  GetLabel(): TDF_Label;
  GetModelName(): Handle_TCollection_HExtendedString;
  static SetNewName(theObject: Handle_TObj_Object): void;
  IsRegisteredName(theName: Handle_TCollection_HExtendedString, theDictionary: Handle_TObj_TNameContainer): Standard_Boolean;
  RegisterName(theName: Handle_TCollection_HExtendedString, theLabel: TDF_Label, theDictionary: Handle_TObj_TNameContainer): void;
  UnRegisterName(theName: Handle_TCollection_HExtendedString, theDictionary: Handle_TObj_TNameContainer): void;
  HasOpenCommand(): Standard_Boolean;
  OpenCommand(): void;
  CommitCommand(): void;
  AbortCommand(): void;
  IsModified(): Standard_Boolean;
  SetModified(theModified: Standard_Boolean): void;
  GetApplication(): Handle_TObj_Application;
  GetFormat(): TCollection_ExtendedString;
  GetFormatVersion(): Graphic3d_ZLayerId;
  Update(): Standard_Boolean;
  GetGUID(): Standard_GUID;
  GetDictionary(): Handle_TObj_TNameContainer;
  GetDocument(): Handle_TDocStd_Document;
  SetLabel(theLabel: TDF_Label): void;
  Paste(theModel: Handle_TObj_Model, theRelocTable: Handle_TDF_RelocationTable): Standard_Boolean;
  NewEmpty(): Handle_TObj_Model;
  CopyReferences(theTarget: Handle_TObj_Model, theRelocTable: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TObj_Application extends TDocStd_Application {
  static GetInstance(): Handle_TObj_Application;
  Messenger(): Handle_Message_Messenger;
  SaveDocument(theSourceDoc: Handle_TDocStd_Document, theTargetFile: TCollection_ExtendedString): Standard_Boolean;
  LoadDocument(theSourceFile: TCollection_ExtendedString, theTargetDoc: Handle_TDocStd_Document): Standard_Boolean;
  CreateNewDocument(theDoc: Handle_TDocStd_Document, theFormat: TCollection_ExtendedString): Standard_Boolean;
  ErrorMessage_1(theMsg: TCollection_ExtendedString, theLevel: Message_Gravity): void;
  ErrorMessage_2(theMsg: TCollection_ExtendedString): void;
  SetVerbose(isVerbose: Standard_Boolean): void;
  IsVerbose(): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  ResourcesName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_Application): void;
  get(): TObj_Application;
  delete(): void;
}

  export declare class Handle_TObj_Application_1 extends Handle_TObj_Application {
    constructor();
  }

  export declare class Handle_TObj_Application_2 extends Handle_TObj_Application {
    constructor(thePtr: TObj_Application);
  }

  export declare class Handle_TObj_Application_3 extends Handle_TObj_Application {
    constructor(theHandle: Handle_TObj_Application);
  }

  export declare class Handle_TObj_Application_4 extends Handle_TObj_Application {
    constructor(theHandle: Handle_TObj_Application);
  }

export declare class Handle_TObj_TObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_TObject): void;
  get(): TObj_TObject;
  delete(): void;
}

  export declare class Handle_TObj_TObject_1 extends Handle_TObj_TObject {
    constructor();
  }

  export declare class Handle_TObj_TObject_2 extends Handle_TObj_TObject {
    constructor(thePtr: TObj_TObject);
  }

  export declare class Handle_TObj_TObject_3 extends Handle_TObj_TObject {
    constructor(theHandle: Handle_TObj_TObject);
  }

  export declare class Handle_TObj_TObject_4 extends Handle_TObj_TObject {
    constructor(theHandle: Handle_TObj_TObject);
  }

export declare class TObj_TObject extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  static Set_1(theLabel: TDF_Label, theElem: Handle_TObj_Object): Handle_TObj_TObject;
  Set_2(theElem: Handle_TObj_Object): void;
  Get(): Handle_TObj_Object;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theWith: Handle_TDF_Attribute): void;
  Paste(theInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  BeforeForget(): void;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_OcafObjectIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_OcafObjectIterator): void;
  get(): TObj_OcafObjectIterator;
  delete(): void;
}

  export declare class Handle_TObj_OcafObjectIterator_1 extends Handle_TObj_OcafObjectIterator {
    constructor();
  }

  export declare class Handle_TObj_OcafObjectIterator_2 extends Handle_TObj_OcafObjectIterator {
    constructor(thePtr: TObj_OcafObjectIterator);
  }

  export declare class Handle_TObj_OcafObjectIterator_3 extends Handle_TObj_OcafObjectIterator {
    constructor(theHandle: Handle_TObj_OcafObjectIterator);
  }

  export declare class Handle_TObj_OcafObjectIterator_4 extends Handle_TObj_OcafObjectIterator {
    constructor(theHandle: Handle_TObj_OcafObjectIterator);
  }

export declare class TObj_OcafObjectIterator extends TObj_LabelIterator {
  constructor(theLabel: TDF_Label, theType: Handle_Standard_Type, theRecursive: Standard_Boolean, theAllSubChildren: Standard_Boolean)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_HSequenceOfObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_HSequenceOfObject): void;
  get(): TObj_HSequenceOfObject;
  delete(): void;
}

  export declare class Handle_TObj_HSequenceOfObject_1 extends Handle_TObj_HSequenceOfObject {
    constructor();
  }

  export declare class Handle_TObj_HSequenceOfObject_2 extends Handle_TObj_HSequenceOfObject {
    constructor(thePtr: TObj_HSequenceOfObject);
  }

  export declare class Handle_TObj_HSequenceOfObject_3 extends Handle_TObj_HSequenceOfObject {
    constructor(theHandle: Handle_TObj_HSequenceOfObject);
  }

  export declare class Handle_TObj_HSequenceOfObject_4 extends Handle_TObj_HSequenceOfObject {
    constructor(theHandle: Handle_TObj_HSequenceOfObject);
  }

export declare class TObj_ModelIterator extends TObj_ObjectIterator {
  constructor(theModel: Handle_TObj_Model)
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_TObj_Object;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_ModelIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_ModelIterator): void;
  get(): TObj_ModelIterator;
  delete(): void;
}

  export declare class Handle_TObj_ModelIterator_1 extends Handle_TObj_ModelIterator {
    constructor();
  }

  export declare class Handle_TObj_ModelIterator_2 extends Handle_TObj_ModelIterator {
    constructor(thePtr: TObj_ModelIterator);
  }

  export declare class Handle_TObj_ModelIterator_3 extends Handle_TObj_ModelIterator {
    constructor(theHandle: Handle_TObj_ModelIterator);
  }

  export declare class Handle_TObj_ModelIterator_4 extends Handle_TObj_ModelIterator {
    constructor(theHandle: Handle_TObj_ModelIterator);
  }

export declare class TObj_HiddenPartition extends TObj_Partition {
  constructor(theLabel: TDF_Label)
  GetTypeFlags(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_HiddenPartition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_HiddenPartition): void;
  get(): TObj_HiddenPartition;
  delete(): void;
}

  export declare class Handle_TObj_HiddenPartition_1 extends Handle_TObj_HiddenPartition {
    constructor();
  }

  export declare class Handle_TObj_HiddenPartition_2 extends Handle_TObj_HiddenPartition {
    constructor(thePtr: TObj_HiddenPartition);
  }

  export declare class Handle_TObj_HiddenPartition_3 extends Handle_TObj_HiddenPartition {
    constructor(theHandle: Handle_TObj_HiddenPartition);
  }

  export declare class Handle_TObj_HiddenPartition_4 extends Handle_TObj_HiddenPartition {
    constructor(theHandle: Handle_TObj_HiddenPartition);
  }

export declare class Handle_TObj_ObjectIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_ObjectIterator): void;
  get(): TObj_ObjectIterator;
  delete(): void;
}

  export declare class Handle_TObj_ObjectIterator_1 extends Handle_TObj_ObjectIterator {
    constructor();
  }

  export declare class Handle_TObj_ObjectIterator_2 extends Handle_TObj_ObjectIterator {
    constructor(thePtr: TObj_ObjectIterator);
  }

  export declare class Handle_TObj_ObjectIterator_3 extends Handle_TObj_ObjectIterator {
    constructor(theHandle: Handle_TObj_ObjectIterator);
  }

  export declare class Handle_TObj_ObjectIterator_4 extends Handle_TObj_ObjectIterator {
    constructor(theHandle: Handle_TObj_ObjectIterator);
  }

export declare class TObj_ObjectIterator extends Standard_Transient {
  constructor();
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_TObj_Object;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_TIntSparseArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_TIntSparseArray): void;
  get(): TObj_TIntSparseArray;
  delete(): void;
}

  export declare class Handle_TObj_TIntSparseArray_1 extends Handle_TObj_TIntSparseArray {
    constructor();
  }

  export declare class Handle_TObj_TIntSparseArray_2 extends Handle_TObj_TIntSparseArray {
    constructor(thePtr: TObj_TIntSparseArray);
  }

  export declare class Handle_TObj_TIntSparseArray_3 extends Handle_TObj_TIntSparseArray {
    constructor(theHandle: Handle_TObj_TIntSparseArray);
  }

  export declare class Handle_TObj_TIntSparseArray_4 extends Handle_TObj_TIntSparseArray {
    constructor(theHandle: Handle_TObj_TIntSparseArray);
  }

export declare class TObj_TIntSparseArray extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  static Set(theLabel: TDF_Label): Handle_TObj_TIntSparseArray;
  Size(): Standard_ThreadId;
  GetIterator(): any;
  HasValue(theId: Standard_ThreadId): Standard_Boolean;
  Value(theId: Standard_ThreadId): Graphic3d_ZLayerId;
  SetValue(theId: Standard_ThreadId, theValue: Graphic3d_ZLayerId): void;
  UnsetValue(theId: Standard_ThreadId): void;
  Clear(): void;
  NewEmpty(): Handle_TDF_Attribute;
  BackupCopy(): Handle_TDF_Attribute;
  Restore(theDelta: Handle_TDF_Attribute): void;
  Paste(theInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  BeforeCommitTransaction(): void;
  DeltaOnModification(theDelta: Handle_TDF_DeltaOnModification): void;
  AfterUndo(theDelta: Handle_TDF_AttributeDelta, toForce: Standard_Boolean): Standard_Boolean;
  SetDoBackup(toDo: Standard_Boolean): void;
  ClearDelta(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_TXYZ {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_TXYZ): void;
  get(): TObj_TXYZ;
  delete(): void;
}

  export declare class Handle_TObj_TXYZ_1 extends Handle_TObj_TXYZ {
    constructor();
  }

  export declare class Handle_TObj_TXYZ_2 extends Handle_TObj_TXYZ {
    constructor(thePtr: TObj_TXYZ);
  }

  export declare class Handle_TObj_TXYZ_3 extends Handle_TObj_TXYZ {
    constructor(theHandle: Handle_TObj_TXYZ);
  }

  export declare class Handle_TObj_TXYZ_4 extends Handle_TObj_TXYZ {
    constructor(theHandle: Handle_TObj_TXYZ);
  }

export declare class TObj_TXYZ extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  static Set_1(theLabel: TDF_Label, theXYZ: gp_XYZ): Handle_TObj_TXYZ;
  Set_2(theXYZ: gp_XYZ): void;
  Get(): gp_XYZ;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theWith: Handle_TDF_Attribute): void;
  Paste(theInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_ReferenceIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_ReferenceIterator): void;
  get(): TObj_ReferenceIterator;
  delete(): void;
}

  export declare class Handle_TObj_ReferenceIterator_1 extends Handle_TObj_ReferenceIterator {
    constructor();
  }

  export declare class Handle_TObj_ReferenceIterator_2 extends Handle_TObj_ReferenceIterator {
    constructor(thePtr: TObj_ReferenceIterator);
  }

  export declare class Handle_TObj_ReferenceIterator_3 extends Handle_TObj_ReferenceIterator {
    constructor(theHandle: Handle_TObj_ReferenceIterator);
  }

  export declare class Handle_TObj_ReferenceIterator_4 extends Handle_TObj_ReferenceIterator {
    constructor(theHandle: Handle_TObj_ReferenceIterator);
  }

export declare class TObj_ReferenceIterator extends TObj_LabelIterator {
  constructor(theLabel: TDF_Label, theType: Handle_Standard_Type, theRecursive: Standard_Boolean)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TObj_Object extends Standard_Transient {
  GetModel(): Handle_TObj_Model;
  GetChildren(theType: Handle_Standard_Type): Handle_TObj_ObjectIterator;
  GetChildLabel(): TDF_Label;
  getChildLabel(theRank: Graphic3d_ZLayerId): TDF_Label;
  GetLabel(): TDF_Label;
  GetDataLabel(): TDF_Label;
  GetReferenceLabel(): TDF_Label;
  GetDictionary(): Handle_TObj_TNameContainer;
  GetName_1(): Handle_TCollection_HExtendedString;
  GetName_2(theName: TCollection_ExtendedString): Standard_Boolean;
  GetName_3(theName: XCAFDoc_PartId): Standard_Boolean;
  SetName_1(theName: Handle_TCollection_HExtendedString): Standard_Boolean;
  SetName_2(theName: Handle_TCollection_HAsciiString): Standard_Boolean;
  SetName_3(name: Standard_CString): Standard_Boolean;
  GetNameForClone(a0: Handle_TObj_Object): Handle_TCollection_HExtendedString;
  HasReference(theObject: Handle_TObj_Object): Standard_Boolean;
  GetReferences(theType: Handle_Standard_Type): Handle_TObj_ObjectIterator;
  RemoveAllReferences(): void;
  GetBackReferences(theType: Handle_Standard_Type): Handle_TObj_ObjectIterator;
  AddBackReference(theObject: Handle_TObj_Object): void;
  RemoveBackReference(theObject: Handle_TObj_Object, theSingleOnly: Standard_Boolean): void;
  RemoveBackReferences(theMode: TObj_DeletingMode): Standard_Boolean;
  ClearBackReferences(): void;
  HasBackReferences(): Standard_Boolean;
  ReplaceReference(theOldObject: Handle_TObj_Object, theNewObject: Handle_TObj_Object): void;
  GetBadReference(theRoot: TDF_Label, theBadReference: TDF_Label): Standard_Boolean;
  RelocateReferences(theFromRoot: TDF_Label, theToRoot: TDF_Label, theUpdateBackRefs: Standard_Boolean): Standard_Boolean;
  CanRemoveReference(theObject: Handle_TObj_Object): Standard_Boolean;
  RemoveReference(theObject: Handle_TObj_Object): void;
  BeforeForgetReference(a0: TDF_Label): void;
  CanDetach(theMode: TObj_DeletingMode): Standard_Boolean;
  Detach_1(theMode: TObj_DeletingMode): Standard_Boolean;
  static Detach_2(theLabel: TDF_Label, theMode: TObj_DeletingMode): Standard_Boolean;
  static GetObj(theLabel: TDF_Label, theResult: Handle_TObj_Object, isSuper: Standard_Boolean): Standard_Boolean;
  GetFatherObject(theType: Handle_Standard_Type): Handle_TObj_Object;
  IsAlive(): Standard_Boolean;
  Clone(theTargetLabel: TDF_Label, theRelocTable: Handle_TDF_RelocationTable): Handle_TObj_Object;
  CopyReferences(theTargetObject: Handle_TObj_Object, theRelocTable: Handle_TDF_RelocationTable): void;
  CopyChildren(theTargetLabel: TDF_Label, theRelocTable: Handle_TDF_RelocationTable): void;
  GetOrder(): Graphic3d_ZLayerId;
  SetOrder(theIndx: Graphic3d_ZLayerId): Standard_Boolean;
  HasModifications(): Standard_Boolean;
  GetTypeFlags(): Graphic3d_ZLayerId;
  GetFlags(): Graphic3d_ZLayerId;
  SetFlags(theMask: Graphic3d_ZLayerId): void;
  TestFlags(theMask: Graphic3d_ZLayerId): Standard_Boolean;
  ClearFlags(theMask: Graphic3d_ZLayerId): void;
  AfterRetrieval(): void;
  BeforeStoring(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_Object {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_Object): void;
  get(): TObj_Object;
  delete(): void;
}

  export declare class Handle_TObj_Object_1 extends Handle_TObj_Object {
    constructor();
  }

  export declare class Handle_TObj_Object_2 extends Handle_TObj_Object {
    constructor(thePtr: TObj_Object);
  }

  export declare class Handle_TObj_Object_3 extends Handle_TObj_Object {
    constructor(theHandle: Handle_TObj_Object);
  }

  export declare class Handle_TObj_Object_4 extends Handle_TObj_Object {
    constructor(theHandle: Handle_TObj_Object);
  }

export declare class TObj_LabelIterator extends TObj_ObjectIterator {
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_TObj_Object;
  LabelValue(): TDF_Label;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_LabelIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_LabelIterator): void;
  get(): TObj_LabelIterator;
  delete(): void;
}

  export declare class Handle_TObj_LabelIterator_1 extends Handle_TObj_LabelIterator {
    constructor();
  }

  export declare class Handle_TObj_LabelIterator_2 extends Handle_TObj_LabelIterator {
    constructor(thePtr: TObj_LabelIterator);
  }

  export declare class Handle_TObj_LabelIterator_3 extends Handle_TObj_LabelIterator {
    constructor(theHandle: Handle_TObj_LabelIterator);
  }

  export declare class Handle_TObj_LabelIterator_4 extends Handle_TObj_LabelIterator {
    constructor(theHandle: Handle_TObj_LabelIterator);
  }

export declare class TObj_TModel extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  Set(theModel: Handle_TObj_Model): void;
  Model(): Handle_TObj_Model;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theWith: Handle_TDF_Attribute): void;
  Paste(theInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_TModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_TModel): void;
  get(): TObj_TModel;
  delete(): void;
}

  export declare class Handle_TObj_TModel_1 extends Handle_TObj_TModel {
    constructor();
  }

  export declare class Handle_TObj_TModel_2 extends Handle_TObj_TModel {
    constructor(thePtr: TObj_TModel);
  }

  export declare class Handle_TObj_TModel_3 extends Handle_TObj_TModel {
    constructor(theHandle: Handle_TObj_TModel);
  }

  export declare class Handle_TObj_TModel_4 extends Handle_TObj_TModel {
    constructor(theHandle: Handle_TObj_TModel);
  }

export declare class TObj_SequenceIterator extends TObj_ObjectIterator {
  constructor(theObjects: Handle_TObj_HSequenceOfObject, theType: Handle_Standard_Type)
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_TObj_Object;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_SequenceIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_SequenceIterator): void;
  get(): TObj_SequenceIterator;
  delete(): void;
}

  export declare class Handle_TObj_SequenceIterator_1 extends Handle_TObj_SequenceIterator {
    constructor();
  }

  export declare class Handle_TObj_SequenceIterator_2 extends Handle_TObj_SequenceIterator {
    constructor(thePtr: TObj_SequenceIterator);
  }

  export declare class Handle_TObj_SequenceIterator_3 extends Handle_TObj_SequenceIterator {
    constructor(theHandle: Handle_TObj_SequenceIterator);
  }

  export declare class Handle_TObj_SequenceIterator_4 extends Handle_TObj_SequenceIterator {
    constructor(theHandle: Handle_TObj_SequenceIterator);
  }

export declare class TObj_Persistence {
  static CreateNewObject(theType: Standard_CString, theLabel: TDF_Label): Handle_TObj_Object;
  static DumpTypes(theOs: Standard_OStream): void;
  delete(): void;
}

export declare class TObj_CheckModel extends Message_Algorithm {
  constructor(theModel: Handle_TObj_Model)
  SetToFix(theToFix: Standard_Boolean): void;
  IsToFix(): Standard_Boolean;
  GetModel(): Handle_TObj_Model;
  Perform(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_CheckModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_CheckModel): void;
  get(): TObj_CheckModel;
  delete(): void;
}

  export declare class Handle_TObj_CheckModel_1 extends Handle_TObj_CheckModel {
    constructor();
  }

  export declare class Handle_TObj_CheckModel_2 extends Handle_TObj_CheckModel {
    constructor(thePtr: TObj_CheckModel);
  }

  export declare class Handle_TObj_CheckModel_3 extends Handle_TObj_CheckModel {
    constructor(theHandle: Handle_TObj_CheckModel);
  }

  export declare class Handle_TObj_CheckModel_4 extends Handle_TObj_CheckModel {
    constructor(theHandle: Handle_TObj_CheckModel);
  }

export declare class TObj_Partition extends TObj_Object {
  static Create(theLabel: TDF_Label, theSetName: Standard_Boolean): Handle_TObj_Partition;
  SetName(theName: Handle_TCollection_HExtendedString): Standard_Boolean;
  AfterRetrieval(): void;
  NewLabel(): TDF_Label;
  SetNamePrefix(thePrefix: Handle_TCollection_HExtendedString): void;
  GetNamePrefix(): Handle_TCollection_HExtendedString;
  GetNewName(theIsToChangeCount: Standard_Boolean): Handle_TCollection_HExtendedString;
  GetLastIndex(): Graphic3d_ZLayerId;
  SetLastIndex(theIndex: Graphic3d_ZLayerId): void;
  static GetPartition(theObject: Handle_TObj_Object): Handle_TObj_Partition;
  Update(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_Partition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_Partition): void;
  get(): TObj_Partition;
  delete(): void;
}

  export declare class Handle_TObj_Partition_1 extends Handle_TObj_Partition {
    constructor();
  }

  export declare class Handle_TObj_Partition_2 extends Handle_TObj_Partition {
    constructor(thePtr: TObj_Partition);
  }

  export declare class Handle_TObj_Partition_3 extends Handle_TObj_Partition {
    constructor(theHandle: Handle_TObj_Partition);
  }

  export declare class Handle_TObj_Partition_4 extends Handle_TObj_Partition {
    constructor(theHandle: Handle_TObj_Partition);
  }

export declare class TObj_TNameContainer extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  static Set_1(theLabel: TDF_Label): Handle_TObj_TNameContainer;
  RecordName(theName: Handle_TCollection_HExtendedString, theLabel: TDF_Label): void;
  RemoveName(theName: Handle_TCollection_HExtendedString): void;
  IsRegistered(theName: Handle_TCollection_HExtendedString): Standard_Boolean;
  Clear(): void;
  Set_2(theElem: TObj_DataMapOfNameLabel): void;
  Get(): TObj_DataMapOfNameLabel;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theWith: Handle_TDF_Attribute): void;
  Paste(theInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_TNameContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_TNameContainer): void;
  get(): TObj_TNameContainer;
  delete(): void;
}

  export declare class Handle_TObj_TNameContainer_1 extends Handle_TObj_TNameContainer {
    constructor();
  }

  export declare class Handle_TObj_TNameContainer_2 extends Handle_TObj_TNameContainer {
    constructor(thePtr: TObj_TNameContainer);
  }

  export declare class Handle_TObj_TNameContainer_3 extends Handle_TObj_TNameContainer {
    constructor(theHandle: Handle_TObj_TNameContainer);
  }

  export declare class Handle_TObj_TNameContainer_4 extends Handle_TObj_TNameContainer {
    constructor(theHandle: Handle_TObj_TNameContainer);
  }

export declare class TObj_TReference extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  static Set_1(theLabel: TDF_Label, theObject: Handle_TObj_Object, theMaster: Handle_TObj_Object): Handle_TObj_TReference;
  Set_2(theObject: Handle_TObj_Object, theMasterLabel: TDF_Label): void;
  Set_3(theLabel: TDF_Label, theMasterLabel: TDF_Label): void;
  Get(): Handle_TObj_Object;
  GetMasterLabel(): TDF_Label;
  GetLabel(): TDF_Label;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theWith: Handle_TDF_Attribute): void;
  Paste(theInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  BeforeForget(): void;
  BeforeUndo(theDelta: Handle_TDF_AttributeDelta, isForced: Standard_Boolean): Standard_Boolean;
  AfterUndo(theDelta: Handle_TDF_AttributeDelta, isForced: Standard_Boolean): Standard_Boolean;
  AfterResume(): void;
  AfterRetrieval(forceIt: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TObj_TReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TObj_TReference): void;
  get(): TObj_TReference;
  delete(): void;
}

  export declare class Handle_TObj_TReference_1 extends Handle_TObj_TReference {
    constructor();
  }

  export declare class Handle_TObj_TReference_2 extends Handle_TObj_TReference {
    constructor(thePtr: TObj_TReference);
  }

  export declare class Handle_TObj_TReference_3 extends Handle_TObj_TReference {
    constructor(theHandle: Handle_TObj_TReference);
  }

  export declare class Handle_TObj_TReference_4 extends Handle_TObj_TReference {
    constructor(theHandle: Handle_TObj_TReference);
  }

export declare class TObj_Assistant {
  constructor();
  static FindModel(theName: Standard_CString): Handle_TObj_Model;
  static BindModel(theModel: Handle_TObj_Model): void;
  static ClearModelMap(): void;
  static FindType(theTypeIndex: Graphic3d_ZLayerId): Handle_Standard_Type;
  static FindTypeIndex(theType: Handle_Standard_Type): Graphic3d_ZLayerId;
  static BindType(theType: Handle_Standard_Type): Graphic3d_ZLayerId;
  static ClearTypeMap(): void;
  static SetCurrentModel(theModel: Handle_TObj_Model): void;
  static GetCurrentModel(): Handle_TObj_Model;
  static UnSetCurrentModel(): void;
  static GetAppVersion(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class GeomLib_Check2dBSplineCurve {
  constructor(Curve: Handle_Geom2d_BSplineCurve, Tolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  NeedTangentFix(FirstFlag: Standard_Boolean, SecondFlag: Standard_Boolean): void;
  FixTangent(FirstFlag: Standard_Boolean, LastFlag: Standard_Boolean): void;
  FixedTangent(FirstFlag: Standard_Boolean, LastFlag: Standard_Boolean): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

export declare class GeomLib_IsPlanarSurface {
  constructor(S: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose)
  IsPlanar(): Standard_Boolean;
  Plan(): gp_Pln;
  delete(): void;
}

export declare class GeomLib_CheckBSplineCurve {
  constructor(Curve: Handle_Geom_BSplineCurve, Tolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  NeedTangentFix(FirstFlag: Standard_Boolean, SecondFlag: Standard_Boolean): void;
  FixTangent(FirstFlag: Standard_Boolean, LastFlag: Standard_Boolean): void;
  FixedTangent(FirstFlag: Standard_Boolean, LastFlag: Standard_Boolean): Handle_Geom_BSplineCurve;
  delete(): void;
}

export declare class GeomLib_PolyFunc extends math_FunctionWithDerivative {
  constructor(Coeffs: math_Vector)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class GeomLib_Interpolate {
  constructor(Degree: Graphic3d_ZLayerId, NumPoints: Graphic3d_ZLayerId, Points: TColgp_Array1OfPnt, Parameters: TColStd_Array1OfReal)
  IsDone(): Standard_Boolean;
  Error(): GeomLib_InterpolationErrors;
  Curve(): Handle_Geom_BSplineCurve;
  delete(): void;
}

export declare class GeomLib_MakeCurvefromApprox {
  constructor(Approx: AdvApprox_ApproxAFunction)
  IsDone(): Standard_Boolean;
  Nb1DSpaces(): Graphic3d_ZLayerId;
  Nb2DSpaces(): Graphic3d_ZLayerId;
  Nb3DSpaces(): Graphic3d_ZLayerId;
  Curve2d_1(Index2d: Graphic3d_ZLayerId): Handle_Geom2d_BSplineCurve;
  Curve2dFromTwo1d(Index1d: Graphic3d_ZLayerId, Index2d: Graphic3d_ZLayerId): Handle_Geom2d_BSplineCurve;
  Curve2d_2(Index1d: Graphic3d_ZLayerId, Index2d: Graphic3d_ZLayerId): Handle_Geom2d_BSplineCurve;
  Curve_1(Index3d: Graphic3d_ZLayerId): Handle_Geom_BSplineCurve;
  Curve_2(Index1D: Graphic3d_ZLayerId, Index3D: Graphic3d_ZLayerId): Handle_Geom_BSplineCurve;
  delete(): void;
}

export declare class GeomLib_LogSample extends math_FunctionSample {
  constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId)
  GetParameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GeomLib_DenominatorMultiplier {
  constructor(Surface: Handle_Geom_BSplineSurface, KnotVector: TColStd_Array1OfReal)
  Value(UParameter: Quantity_AbsorbedDose, VParameter: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare type GeomLib_InterpolationErrors = {
  GeomLib_NoError: {};
  GeomLib_NotEnoughtPoints: {};
  GeomLib_DegreeSmallerThan3: {};
  GeomLib_InversionProblem: {};
}

export declare class GeomLib_Tool {
  constructor();
  static Parameter_1(Curve: Handle_Geom_Curve, Point: gp_Pnt, MaxDist: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): Standard_Boolean;
  static Parameters(Surface: Handle_Geom_Surface, Point: gp_Pnt, MaxDist: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): Standard_Boolean;
  static Parameter_2(Curve: Handle_Geom2d_Curve, Point: gp_Pnt2d, MaxDist: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class GeomLib {
  constructor();
  static To3d(Position: gp_Ax2, Curve2d: Handle_Geom2d_Curve): Handle_Geom_Curve;
  static GTransform(Curve: Handle_Geom2d_Curve, GTrsf: gp_GTrsf2d): Handle_Geom2d_Curve;
  static SameRange(Tolerance: Quantity_AbsorbedDose, Curve2dPtr: Handle_Geom2d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, RequestedFirst: Quantity_AbsorbedDose, RequestedLast: Quantity_AbsorbedDose, NewCurve2dPtr: Handle_Geom2d_Curve): void;
  static BuildCurve3d(Tolerance: Quantity_AbsorbedDose, CurvePtr: Adaptor3d_CurveOnSurface, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, NewCurvePtr: Handle_Geom_Curve, MaxDeviation: Quantity_AbsorbedDose, AverageDeviation: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegment: Graphic3d_ZLayerId): void;
  static AdjustExtremity(Curve: Handle_Geom_BoundedCurve, P1: gp_Pnt, P2: gp_Pnt, T1: gp_Vec, T2: gp_Vec): void;
  static ExtendCurveToPoint(Curve: Handle_Geom_BoundedCurve, Point: gp_Pnt, Cont: Graphic3d_ZLayerId, After: Standard_Boolean): void;
  static ExtendSurfByLength(Surf: Handle_Geom_BoundedSurface, Length: Quantity_AbsorbedDose, Cont: Graphic3d_ZLayerId, InU: Standard_Boolean, After: Standard_Boolean): void;
  static AxeOfInertia(Points: TColgp_Array1OfPnt, Axe: gp_Ax2, IsSingular: Standard_Boolean, Tol: Quantity_AbsorbedDose): void;
  static Inertia(Points: TColgp_Array1OfPnt, Bary: gp_Pnt, XDir: gp_Dir, YDir: gp_Dir, Xgap: Quantity_AbsorbedDose, YGap: Quantity_AbsorbedDose, ZGap: Quantity_AbsorbedDose): void;
  static RemovePointsFromArray(NumPoints: Graphic3d_ZLayerId, InParameters: TColStd_Array1OfReal, OutParameters: Handle_TColStd_HArray1OfReal): void;
  static DensifyArray1OfReal(MinNumPoints: Graphic3d_ZLayerId, InParameters: TColStd_Array1OfReal, OutParameters: Handle_TColStd_HArray1OfReal): void;
  static FuseIntervals(Interval1: TColStd_Array1OfReal, Interval2: TColStd_Array1OfReal, Fusion: TColStd_SequenceOfReal, Confusion: Quantity_AbsorbedDose, IsAdjustToFirstInterval: Standard_Boolean): void;
  static EvalMaxParametricDistance(Curve: Adaptor3d_Curve, AReferenceCurve: Adaptor3d_Curve, Tolerance: Quantity_AbsorbedDose, Parameters: TColStd_Array1OfReal, MaxDistance: Quantity_AbsorbedDose): void;
  static EvalMaxDistanceAlongParameter(Curve: Adaptor3d_Curve, AReferenceCurve: Adaptor3d_Curve, Tolerance: Quantity_AbsorbedDose, Parameters: TColStd_Array1OfReal, MaxDistance: Quantity_AbsorbedDose): void;
  static CancelDenominatorDerivative(BSurf: Handle_Geom_BSplineSurface, UDirection: Standard_Boolean, VDirection: Standard_Boolean): void;
  static NormEstim(S: Handle_Geom_Surface, UV: gp_Pnt2d, Tol: Quantity_AbsorbedDose, N: gp_Dir): Graphic3d_ZLayerId;
  static IsClosed(S: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose, isUClosed: Standard_Boolean, isVClosed: Standard_Boolean): void;
  static IsBSplUClosed(S: Handle_Geom_BSplineSurface, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  static IsBSplVClosed(S: Handle_Geom_BSplineSurface, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  static IsBzUClosed(S: Handle_Geom_BezierSurface, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  static IsBzVClosed(S: Handle_Geom_BezierSurface, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  static isIsoLine(theC2D: Handle_Adaptor2d_HCurve2d, theIsU: Standard_Boolean, theParam: Quantity_AbsorbedDose, theIsForward: Standard_Boolean): Standard_Boolean;
  static buildC3dOnIsoLine(theC2D: Handle_Adaptor2d_HCurve2d, theSurf: Handle_Adaptor3d_HSurface, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theTolerance: Quantity_AbsorbedDose, theIsU: Standard_Boolean, theParam: Quantity_AbsorbedDose, theIsForward: Standard_Boolean): Handle_Geom_Curve;
  delete(): void;
}

export declare class GeomLib_Array1OfMat {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Mat): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: GeomLib_Array1OfMat): GeomLib_Array1OfMat;
  Move(theOther: GeomLib_Array1OfMat): GeomLib_Array1OfMat;
  First(): gp_Mat;
  ChangeFirst(): gp_Mat;
  Last(): gp_Mat;
  ChangeLast(): gp_Mat;
  Value(theIndex: Standard_Integer): gp_Mat;
  ChangeValue(theIndex: Standard_Integer): gp_Mat;
  SetValue(theIndex: Standard_Integer, theItem: gp_Mat): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class GeomLib_Array1OfMat_1 extends GeomLib_Array1OfMat {
    constructor();
  }

  export declare class GeomLib_Array1OfMat_2 extends GeomLib_Array1OfMat {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class GeomLib_Array1OfMat_3 extends GeomLib_Array1OfMat {
    constructor(theOther: GeomLib_Array1OfMat);
  }

  export declare class GeomLib_Array1OfMat_4 extends GeomLib_Array1OfMat {
    constructor(theOther: GeomLib_Array1OfMat);
  }

  export declare class GeomLib_Array1OfMat_5 extends GeomLib_Array1OfMat {
    constructor(theBegin: gp_Mat, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class GeomLib_CheckCurveOnSurface {
  Init_1(theCurve: Handle_Geom_Curve, theSurface: Handle_Geom_Surface, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theTolRange: Quantity_AbsorbedDose): void;
  Init_2(): void;
  Perform(thePCurve: Handle_Geom2d_Curve, isTheMultyTheradDisabled: Standard_Boolean): void;
  Curve(): Handle_Geom_Curve;
  Surface(): Handle_Geom_Surface;
  Range(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  ErrorStatus(): Graphic3d_ZLayerId;
  MaxDistance(): Quantity_AbsorbedDose;
  MaxParameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomLib_CheckCurveOnSurface_1 extends GeomLib_CheckCurveOnSurface {
    constructor();
  }

  export declare class GeomLib_CheckCurveOnSurface_2 extends GeomLib_CheckCurveOnSurface {
    constructor(theCurve: Handle_Geom_Curve, theSurface: Handle_Geom_Surface, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theTolRange: Quantity_AbsorbedDose);
  }

export declare type BiTgte_ContactType = {
  BiTgte_FaceFace: {};
  BiTgte_FaceEdge: {};
  BiTgte_FaceVertex: {};
  BiTgte_EdgeEdge: {};
  BiTgte_EdgeVertex: {};
  BiTgte_VertexVertex: {};
}

export declare class BiTgte_CurveOnEdge extends Adaptor3d_Curve {
  Init(EonF: TopoDS_Edge, Edge: TopoDS_Edge): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

  export declare class BiTgte_CurveOnEdge_1 extends BiTgte_CurveOnEdge {
    constructor();
  }

  export declare class BiTgte_CurveOnEdge_2 extends BiTgte_CurveOnEdge {
    constructor(EonF: TopoDS_Edge, Edge: TopoDS_Edge);
  }

export declare class BiTgte_CurveOnVertex extends Adaptor3d_Curve {
  Init(EonF: TopoDS_Edge, V: TopoDS_Vertex): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

  export declare class BiTgte_CurveOnVertex_1 extends BiTgte_CurveOnVertex {
    constructor();
  }

  export declare class BiTgte_CurveOnVertex_2 extends BiTgte_CurveOnVertex {
    constructor(EonF: TopoDS_Edge, V: TopoDS_Vertex);
  }

export declare class BiTgte_HCurveOnEdge extends Adaptor3d_HCurve {
  Set(C: BiTgte_CurveOnEdge): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): BiTgte_CurveOnEdge;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BiTgte_HCurveOnEdge_1 extends BiTgte_HCurveOnEdge {
    constructor();
  }

  export declare class BiTgte_HCurveOnEdge_2 extends BiTgte_HCurveOnEdge {
    constructor(C: BiTgte_CurveOnEdge);
  }

export declare class Handle_BiTgte_HCurveOnEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BiTgte_HCurveOnEdge): void;
  get(): BiTgte_HCurveOnEdge;
  delete(): void;
}

  export declare class Handle_BiTgte_HCurveOnEdge_1 extends Handle_BiTgte_HCurveOnEdge {
    constructor();
  }

  export declare class Handle_BiTgte_HCurveOnEdge_2 extends Handle_BiTgte_HCurveOnEdge {
    constructor(thePtr: BiTgte_HCurveOnEdge);
  }

  export declare class Handle_BiTgte_HCurveOnEdge_3 extends Handle_BiTgte_HCurveOnEdge {
    constructor(theHandle: Handle_BiTgte_HCurveOnEdge);
  }

  export declare class Handle_BiTgte_HCurveOnEdge_4 extends Handle_BiTgte_HCurveOnEdge {
    constructor(theHandle: Handle_BiTgte_HCurveOnEdge);
  }

export declare class BiTgte_Blend {
  Init(S: TopoDS_Shape, Radius: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, NUBS: Standard_Boolean): void;
  Clear(): void;
  SetFaces(F1: TopoDS_Face, F2: TopoDS_Face): void;
  SetEdge(Edge: TopoDS_Edge): void;
  SetStoppingFace(Face: TopoDS_Face): void;
  Perform(BuildShape: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  NbSurfaces(): Graphic3d_ZLayerId;
  Surface_1(Index: Graphic3d_ZLayerId): Handle_Geom_Surface;
  Face_1(Index: Graphic3d_ZLayerId): TopoDS_Face;
  CenterLines(LC: TopTools_ListOfShape): void;
  Surface_2(CenterLine: TopoDS_Shape): Handle_Geom_Surface;
  Face_2(CenterLine: TopoDS_Shape): TopoDS_Face;
  ContactType(Index: Graphic3d_ZLayerId): BiTgte_ContactType;
  SupportShape1(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  SupportShape2(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  CurveOnShape1(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  CurveOnShape2(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  PCurveOnFace1(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurve1OnFillet(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurveOnFace2(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurve2OnFillet(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  NbBranches(): Graphic3d_ZLayerId;
  IndicesOfBranche(Index: Graphic3d_ZLayerId, From: Graphic3d_ZLayerId, To: Graphic3d_ZLayerId): void;
  ComputeCenters(): void;
  delete(): void;
}

  export declare class BiTgte_Blend_1 extends BiTgte_Blend {
    constructor();
  }

  export declare class BiTgte_Blend_2 extends BiTgte_Blend {
    constructor(S: TopoDS_Shape, Radius: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, NUBS: Standard_Boolean);
  }

export declare class Handle_BiTgte_HCurveOnVertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BiTgte_HCurveOnVertex): void;
  get(): BiTgte_HCurveOnVertex;
  delete(): void;
}

  export declare class Handle_BiTgte_HCurveOnVertex_1 extends Handle_BiTgte_HCurveOnVertex {
    constructor();
  }

  export declare class Handle_BiTgte_HCurveOnVertex_2 extends Handle_BiTgte_HCurveOnVertex {
    constructor(thePtr: BiTgte_HCurveOnVertex);
  }

  export declare class Handle_BiTgte_HCurveOnVertex_3 extends Handle_BiTgte_HCurveOnVertex {
    constructor(theHandle: Handle_BiTgte_HCurveOnVertex);
  }

  export declare class Handle_BiTgte_HCurveOnVertex_4 extends Handle_BiTgte_HCurveOnVertex {
    constructor(theHandle: Handle_BiTgte_HCurveOnVertex);
  }

export declare class BiTgte_HCurveOnVertex extends Adaptor3d_HCurve {
  Set(C: BiTgte_CurveOnVertex): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): BiTgte_CurveOnVertex;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BiTgte_HCurveOnVertex_1 extends BiTgte_HCurveOnVertex {
    constructor();
  }

  export declare class BiTgte_HCurveOnVertex_2 extends BiTgte_HCurveOnVertex {
    constructor(C: BiTgte_CurveOnVertex);
  }

export declare class TopOpeBRepDS_PointData extends TopOpeBRepDS_GeometryData {
  SetShapes(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): void;
  GetShapes(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_PointData_1 extends TopOpeBRepDS_PointData {
    constructor();
  }

  export declare class TopOpeBRepDS_PointData_2 extends TopOpeBRepDS_PointData {
    constructor(P: TopOpeBRepDS_Point);
  }

  export declare class TopOpeBRepDS_PointData_3 extends TopOpeBRepDS_PointData {
    constructor(P: TopOpeBRepDS_Point, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId);
  }

export declare class TopOpeBRepDS_ShapeShapeInterference extends TopOpeBRepDS_Interference {
  constructor(T: TopOpeBRepDS_Transition, ST: TopOpeBRepDS_Kind, S: Graphic3d_ZLayerId, GT: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId, GBound: Standard_Boolean, C: TopOpeBRepDS_Config)
  Config(): TopOpeBRepDS_Config;
  GBound(): Standard_Boolean;
  SetGBound(b: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_ShapeShapeInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_ShapeShapeInterference): void;
  get(): TopOpeBRepDS_ShapeShapeInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_ShapeShapeInterference_1 extends Handle_TopOpeBRepDS_ShapeShapeInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_ShapeShapeInterference_2 extends Handle_TopOpeBRepDS_ShapeShapeInterference {
    constructor(thePtr: TopOpeBRepDS_ShapeShapeInterference);
  }

  export declare class Handle_TopOpeBRepDS_ShapeShapeInterference_3 extends Handle_TopOpeBRepDS_ShapeShapeInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_ShapeShapeInterference);
  }

  export declare class Handle_TopOpeBRepDS_ShapeShapeInterference_4 extends Handle_TopOpeBRepDS_ShapeShapeInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_ShapeShapeInterference);
  }

export declare class TopOpeBRepDS_Filter {
  constructor(HDS: Handle_TopOpeBRepDS_HDataStructure, pClassif: TopOpeBRepTool_PShapeClassifier)
  ProcessInterferences(): void;
  ProcessFaceInterferences_1(MEsp: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): void;
  ProcessFaceInterferences_2(I: Graphic3d_ZLayerId, MEsp: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): void;
  ProcessEdgeInterferences_1(): void;
  ProcessEdgeInterferences_2(I: Graphic3d_ZLayerId): void;
  ProcessCurveInterferences_1(): void;
  ProcessCurveInterferences_2(I: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopOpeBRepDS_EdgeInterferenceTool {
  constructor()
  Init(E: TopoDS_Shape, I: Handle_TopOpeBRepDS_Interference): void;
  Add_1(E: TopoDS_Shape, V: TopoDS_Shape, I: Handle_TopOpeBRepDS_Interference): void;
  Add_2(E: TopoDS_Shape, P: TopOpeBRepDS_Point, I: Handle_TopOpeBRepDS_Interference): void;
  Transition(I: Handle_TopOpeBRepDS_Interference): void;
  delete(): void;
}

export declare class TopOpeBRepDS_CurveIterator extends TopOpeBRepDS_InterferenceIterator {
  constructor(L: TopOpeBRepDS_ListOfInterference)
  MatchInterference(I: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  Current(): Graphic3d_ZLayerId;
  Orientation(S: TopAbs_State): TopAbs_Orientation;
  PCurve(): Handle_Geom2d_Curve;
  delete(): void;
}

export declare class TopOpeBRepDS_IndexedDataMapOfVertexPoint extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepDS_IndexedDataMapOfVertexPoint): void;
  Assign(theOther: TopOpeBRepDS_IndexedDataMapOfVertexPoint): TopOpeBRepDS_IndexedDataMapOfVertexPoint;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopOpeBRepDS_Point): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopOpeBRepDS_Point): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopOpeBRepDS_Point;
  ChangeFromIndex(theIndex: Standard_Integer): TopOpeBRepDS_Point;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopOpeBRepDS_Point;
  Seek(theKey1: TopoDS_Shape): TopOpeBRepDS_Point;
  ChangeSeek(theKey1: TopoDS_Shape): TopOpeBRepDS_Point;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_IndexedDataMapOfVertexPoint_1 extends TopOpeBRepDS_IndexedDataMapOfVertexPoint {
    constructor();
  }

  export declare class TopOpeBRepDS_IndexedDataMapOfVertexPoint_2 extends TopOpeBRepDS_IndexedDataMapOfVertexPoint {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_IndexedDataMapOfVertexPoint_3 extends TopOpeBRepDS_IndexedDataMapOfVertexPoint {
    constructor(theOther: TopOpeBRepDS_IndexedDataMapOfVertexPoint);
  }

export declare class TopOpeBRepDS_Surface {
  Assign(Other: TopOpeBRepDS_Surface): void;
  Surface(): Handle_Geom_Surface;
  Tolerance_1(): Quantity_AbsorbedDose;
  Tolerance_2(theTol: Quantity_AbsorbedDose): void;
  Keep(): Standard_Boolean;
  ChangeKeep(theToKeep: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_Surface_1 extends TopOpeBRepDS_Surface {
    constructor();
  }

  export declare class TopOpeBRepDS_Surface_2 extends TopOpeBRepDS_Surface {
    constructor(P: Handle_Geom_Surface, T: Quantity_AbsorbedDose);
  }

  export declare class TopOpeBRepDS_Surface_3 extends TopOpeBRepDS_Surface {
    constructor(Other: TopOpeBRepDS_Surface);
  }

export declare class TopOpeBRepDS_Point {
  IsEqual(other: TopOpeBRepDS_Point): Standard_Boolean;
  Point(): gp_Pnt;
  ChangePoint(): gp_Pnt;
  Tolerance_1(): Quantity_AbsorbedDose;
  Tolerance_2(Tol: Quantity_AbsorbedDose): void;
  Keep(): Standard_Boolean;
  ChangeKeep(B: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_Point_1 extends TopOpeBRepDS_Point {
    constructor();
  }

  export declare class TopOpeBRepDS_Point_2 extends TopOpeBRepDS_Point {
    constructor(P: gp_Pnt, T: Quantity_AbsorbedDose);
  }

  export declare class TopOpeBRepDS_Point_3 extends TopOpeBRepDS_Point {
    constructor(S: TopoDS_Shape);
  }

export declare class TopOpeBRepDS_Transition {
  Set_1(StateBefore: TopAbs_State, StateAfter: TopAbs_State, ShapeBefore: TopAbs_ShapeEnum, ShapeAfter: TopAbs_ShapeEnum): void;
  StateBefore(S: TopAbs_State): void;
  StateAfter(S: TopAbs_State): void;
  ShapeBefore_1(SE: TopAbs_ShapeEnum): void;
  ShapeAfter_1(SE: TopAbs_ShapeEnum): void;
  Before_1(S: TopAbs_State, ShapeBefore: TopAbs_ShapeEnum): void;
  After_1(S: TopAbs_State, ShapeAfter: TopAbs_ShapeEnum): void;
  Index_1(I: Graphic3d_ZLayerId): void;
  IndexBefore_1(I: Graphic3d_ZLayerId): void;
  IndexAfter_1(I: Graphic3d_ZLayerId): void;
  Before_2(): TopAbs_State;
  ONBefore(): TopAbs_ShapeEnum;
  After_2(): TopAbs_State;
  ONAfter(): TopAbs_ShapeEnum;
  ShapeBefore_2(): TopAbs_ShapeEnum;
  ShapeAfter_2(): TopAbs_ShapeEnum;
  Index_2(): Graphic3d_ZLayerId;
  IndexBefore_2(): Graphic3d_ZLayerId;
  IndexAfter_2(): Graphic3d_ZLayerId;
  Set_2(O: TopAbs_Orientation): void;
  Orientation(S: TopAbs_State, T: TopAbs_ShapeEnum): TopAbs_Orientation;
  Complement(): TopOpeBRepDS_Transition;
  IsUnknown(): Standard_Boolean;
  delete(): void;
}

  export declare class TopOpeBRepDS_Transition_1 extends TopOpeBRepDS_Transition {
    constructor();
  }

  export declare class TopOpeBRepDS_Transition_2 extends TopOpeBRepDS_Transition {
    constructor(StateBefore: TopAbs_State, StateAfter: TopAbs_State, ShapeBefore: TopAbs_ShapeEnum, ShapeAfter: TopAbs_ShapeEnum);
  }

  export declare class TopOpeBRepDS_Transition_3 extends TopOpeBRepDS_Transition {
    constructor(O: TopAbs_Orientation);
  }

export declare class TopOpeBRepDS_IndexedDataMapOfShapeWithState extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepDS_IndexedDataMapOfShapeWithState): void;
  Assign(theOther: TopOpeBRepDS_IndexedDataMapOfShapeWithState): TopOpeBRepDS_IndexedDataMapOfShapeWithState;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopOpeBRepDS_ShapeWithState): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopOpeBRepDS_ShapeWithState): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopOpeBRepDS_ShapeWithState;
  ChangeFromIndex(theIndex: Standard_Integer): TopOpeBRepDS_ShapeWithState;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopOpeBRepDS_ShapeWithState;
  Seek(theKey1: TopoDS_Shape): TopOpeBRepDS_ShapeWithState;
  ChangeSeek(theKey1: TopoDS_Shape): TopOpeBRepDS_ShapeWithState;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_IndexedDataMapOfShapeWithState_1 extends TopOpeBRepDS_IndexedDataMapOfShapeWithState {
    constructor();
  }

  export declare class TopOpeBRepDS_IndexedDataMapOfShapeWithState_2 extends TopOpeBRepDS_IndexedDataMapOfShapeWithState {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_IndexedDataMapOfShapeWithState_3 extends TopOpeBRepDS_IndexedDataMapOfShapeWithState {
    constructor(theOther: TopOpeBRepDS_IndexedDataMapOfShapeWithState);
  }

export declare class TopOpeBRepDS_PointIterator extends TopOpeBRepDS_InterferenceIterator {
  constructor(L: TopOpeBRepDS_ListOfInterference)
  MatchInterference(I: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  Current(): Graphic3d_ZLayerId;
  Orientation(S: TopAbs_State): TopAbs_Orientation;
  Parameter(): Quantity_AbsorbedDose;
  IsVertex(): Standard_Boolean;
  IsPoint(): Standard_Boolean;
  DiffOriented(): Standard_Boolean;
  SameOriented(): Standard_Boolean;
  Support(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TopOpeBRepDS_Reducer {
  constructor(HDS: Handle_TopOpeBRepDS_HDataStructure)
  ProcessFaceInterferences(M: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): void;
  ProcessEdgeInterferences(): void;
  delete(): void;
}

export declare class TopOpeBRepDS_Dumper {
  constructor(HDS: Handle_TopOpeBRepDS_HDataStructure)
  SDumpRefOri_1(K: TopOpeBRepDS_Kind, I: Graphic3d_ZLayerId): XCAFDoc_PartId;
  SDumpRefOri_2(S: TopoDS_Shape): XCAFDoc_PartId;
  SPrintShape_1(I: Graphic3d_ZLayerId): XCAFDoc_PartId;
  SPrintShape_2(S: TopoDS_Shape): XCAFDoc_PartId;
  SPrintShapeRefOri_1(S: TopoDS_Shape, B: XCAFDoc_PartId): XCAFDoc_PartId;
  SPrintShapeRefOri_2(L: TopTools_ListOfShape, B: XCAFDoc_PartId): XCAFDoc_PartId;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_Check {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_Check): void;
  get(): TopOpeBRepDS_Check;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_Check_1 extends Handle_TopOpeBRepDS_Check {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_Check_2 extends Handle_TopOpeBRepDS_Check {
    constructor(thePtr: TopOpeBRepDS_Check);
  }

  export declare class Handle_TopOpeBRepDS_Check_3 extends Handle_TopOpeBRepDS_Check {
    constructor(theHandle: Handle_TopOpeBRepDS_Check);
  }

  export declare class Handle_TopOpeBRepDS_Check_4 extends Handle_TopOpeBRepDS_Check {
    constructor(theHandle: Handle_TopOpeBRepDS_Check);
  }

export declare class TopOpeBRepDS_Check extends Standard_Transient {
  ChkIntg(): Standard_Boolean;
  ChkIntgInterf(LI: TopOpeBRepDS_ListOfInterference): Standard_Boolean;
  CheckDS(i: Graphic3d_ZLayerId, K: TopOpeBRepDS_Kind): Standard_Boolean;
  ChkIntgSamDom(): Standard_Boolean;
  CheckShapes(LS: TopTools_ListOfShape): Standard_Boolean;
  OneVertexOnPnt(): Standard_Boolean;
  HDS(): Handle_TopOpeBRepDS_HDataStructure;
  ChangeHDS(): Handle_TopOpeBRepDS_HDataStructure;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopOpeBRepDS_Check_1 extends TopOpeBRepDS_Check {
    constructor();
  }

  export declare class TopOpeBRepDS_Check_2 extends TopOpeBRepDS_Check {
    constructor(HDS: Handle_TopOpeBRepDS_HDataStructure);
  }

export declare class TopOpeBRepDS_Marker extends Standard_Transient {
  constructor()
  Reset(): void;
  Set_1(i: Graphic3d_ZLayerId, b: Standard_Boolean): void;
  Set_2(b: Standard_Boolean, n: Graphic3d_ZLayerId, a: Standard_Address): void;
  GetI(i: Graphic3d_ZLayerId): Standard_Boolean;
  Allocate(n: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_Marker {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_Marker): void;
  get(): TopOpeBRepDS_Marker;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_Marker_1 extends Handle_TopOpeBRepDS_Marker {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_Marker_2 extends Handle_TopOpeBRepDS_Marker {
    constructor(thePtr: TopOpeBRepDS_Marker);
  }

  export declare class Handle_TopOpeBRepDS_Marker_3 extends Handle_TopOpeBRepDS_Marker {
    constructor(theHandle: Handle_TopOpeBRepDS_Marker);
  }

  export declare class Handle_TopOpeBRepDS_Marker_4 extends Handle_TopOpeBRepDS_Marker {
    constructor(theHandle: Handle_TopOpeBRepDS_Marker);
  }

export declare class TopOpeBRepDS_CurveData extends TopOpeBRepDS_GeometryData {
  delete(): void;
}

  export declare class TopOpeBRepDS_CurveData_1 extends TopOpeBRepDS_CurveData {
    constructor();
  }

  export declare class TopOpeBRepDS_CurveData_2 extends TopOpeBRepDS_CurveData {
    constructor(C: TopOpeBRepDS_Curve);
  }

export declare class TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): void;
  Assign(theOther: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopOpeBRepDS_ListOfShapeOn1State): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopOpeBRepDS_ListOfShapeOn1State): TopOpeBRepDS_ListOfShapeOn1State;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopOpeBRepDS_ListOfShapeOn1State;
  ChangeSeek(theKey: TopoDS_Shape): TopOpeBRepDS_ListOfShapeOn1State;
  ChangeFind(theKey: TopoDS_Shape): TopOpeBRepDS_ListOfShapeOn1State;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_1 extends TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State {
    constructor();
  }

  export declare class TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_2 extends TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_3 extends TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State {
    constructor(theOther: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State);
  }

export declare class TopOpeBRepDS_DataStructure {
  constructor()
  Init(): void;
  AddSurface(S: TopOpeBRepDS_Surface): Graphic3d_ZLayerId;
  RemoveSurface(I: Graphic3d_ZLayerId): void;
  KeepSurface_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  KeepSurface_2(S: TopOpeBRepDS_Surface): Standard_Boolean;
  ChangeKeepSurface_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): void;
  ChangeKeepSurface_2(S: TopOpeBRepDS_Surface, FindKeep: Standard_Boolean): void;
  AddCurve(S: TopOpeBRepDS_Curve): Graphic3d_ZLayerId;
  RemoveCurve(I: Graphic3d_ZLayerId): void;
  KeepCurve_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  KeepCurve_2(C: TopOpeBRepDS_Curve): Standard_Boolean;
  ChangeKeepCurve_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): void;
  ChangeKeepCurve_2(C: TopOpeBRepDS_Curve, FindKeep: Standard_Boolean): void;
  AddPoint(PDS: TopOpeBRepDS_Point): Graphic3d_ZLayerId;
  AddPointSS(PDS: TopOpeBRepDS_Point, S1: TopoDS_Shape, S2: TopoDS_Shape): Graphic3d_ZLayerId;
  RemovePoint(I: Graphic3d_ZLayerId): void;
  KeepPoint_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  KeepPoint_2(P: TopOpeBRepDS_Point): Standard_Boolean;
  ChangeKeepPoint_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): void;
  ChangeKeepPoint_2(P: TopOpeBRepDS_Point, FindKeep: Standard_Boolean): void;
  AddShape_1(S: TopoDS_Shape): Graphic3d_ZLayerId;
  AddShape_2(S: TopoDS_Shape, I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  KeepShape_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): Standard_Boolean;
  KeepShape_2(S: TopoDS_Shape, FindKeep: Standard_Boolean): Standard_Boolean;
  ChangeKeepShape_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): void;
  ChangeKeepShape_2(S: TopoDS_Shape, FindKeep: Standard_Boolean): void;
  InitSectionEdges(): void;
  AddSectionEdge(E: TopoDS_Edge): Graphic3d_ZLayerId;
  SurfaceInterferences(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ChangeSurfaceInterferences(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  CurveInterferences(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ChangeCurveInterferences(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  PointInterferences(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ChangePointInterferences(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ShapeInterferences_1(S: TopoDS_Shape, FindKeep: Standard_Boolean): TopOpeBRepDS_ListOfInterference;
  ChangeShapeInterferences_1(S: TopoDS_Shape): TopOpeBRepDS_ListOfInterference;
  ShapeInterferences_2(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): TopOpeBRepDS_ListOfInterference;
  ChangeShapeInterferences_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ShapeSameDomain_1(S: TopoDS_Shape): TopTools_ListOfShape;
  ChangeShapeSameDomain_1(S: TopoDS_Shape): TopTools_ListOfShape;
  ShapeSameDomain_2(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  ChangeShapeSameDomain_2(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  ChangeShapes(): TopOpeBRepDS_MapOfShapeData;
  AddShapeSameDomain(S: TopoDS_Shape, SSD: TopoDS_Shape): void;
  RemoveShapeSameDomain(S: TopoDS_Shape, SSD: TopoDS_Shape): void;
  SameDomainRef_1(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SameDomainRef_2(S: TopoDS_Shape): Graphic3d_ZLayerId;
  SameDomainRef_3(I: Graphic3d_ZLayerId, Ref: Graphic3d_ZLayerId): void;
  SameDomainRef_4(S: TopoDS_Shape, Ref: Graphic3d_ZLayerId): void;
  SameDomainOri_1(I: Graphic3d_ZLayerId): TopOpeBRepDS_Config;
  SameDomainOri_2(S: TopoDS_Shape): TopOpeBRepDS_Config;
  SameDomainOri_3(I: Graphic3d_ZLayerId, Ori: TopOpeBRepDS_Config): void;
  SameDomainOri_4(S: TopoDS_Shape, Ori: TopOpeBRepDS_Config): void;
  SameDomainInd_1(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SameDomainInd_2(S: TopoDS_Shape): Graphic3d_ZLayerId;
  SameDomainInd_3(I: Graphic3d_ZLayerId, Ind: Graphic3d_ZLayerId): void;
  SameDomainInd_4(S: TopoDS_Shape, Ind: Graphic3d_ZLayerId): void;
  AncestorRank_1(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AncestorRank_2(S: TopoDS_Shape): Graphic3d_ZLayerId;
  AncestorRank_3(I: Graphic3d_ZLayerId, Ianc: Graphic3d_ZLayerId): void;
  AncestorRank_4(S: TopoDS_Shape, Ianc: Graphic3d_ZLayerId): void;
  AddShapeInterference(S: TopoDS_Shape, I: Handle_TopOpeBRepDS_Interference): void;
  RemoveShapeInterference(S: TopoDS_Shape, I: Handle_TopOpeBRepDS_Interference): void;
  FillShapesSameDomain_1(S1: TopoDS_Shape, S2: TopoDS_Shape, refFirst: Standard_Boolean): void;
  FillShapesSameDomain_2(S1: TopoDS_Shape, S2: TopoDS_Shape, c1: TopOpeBRepDS_Config, c2: TopOpeBRepDS_Config, refFirst: Standard_Boolean): void;
  UnfillShapesSameDomain(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  NbSurfaces(): Graphic3d_ZLayerId;
  NbCurves(): Graphic3d_ZLayerId;
  ChangeNbCurves(N: Graphic3d_ZLayerId): void;
  NbPoints(): Graphic3d_ZLayerId;
  NbShapes(): Graphic3d_ZLayerId;
  NbSectionEdges(): Graphic3d_ZLayerId;
  Surface(I: Graphic3d_ZLayerId): TopOpeBRepDS_Surface;
  ChangeSurface(I: Graphic3d_ZLayerId): TopOpeBRepDS_Surface;
  Curve(I: Graphic3d_ZLayerId): TopOpeBRepDS_Curve;
  ChangeCurve(I: Graphic3d_ZLayerId): TopOpeBRepDS_Curve;
  Point(I: Graphic3d_ZLayerId): TopOpeBRepDS_Point;
  ChangePoint(I: Graphic3d_ZLayerId): TopOpeBRepDS_Point;
  Shape_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): TopoDS_Shape;
  Shape_2(S: TopoDS_Shape, FindKeep: Standard_Boolean): Graphic3d_ZLayerId;
  SectionEdge_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): TopoDS_Edge;
  SectionEdge_2(E: TopoDS_Edge, FindKeep: Standard_Boolean): Graphic3d_ZLayerId;
  IsSectionEdge(E: TopoDS_Edge, FindKeep: Standard_Boolean): Standard_Boolean;
  HasGeometry(S: TopoDS_Shape): Standard_Boolean;
  HasShape(S: TopoDS_Shape, FindKeep: Standard_Boolean): Standard_Boolean;
  SetNewSurface(F: TopoDS_Shape, S: Handle_Geom_Surface): void;
  HasNewSurface(F: TopoDS_Shape): Standard_Boolean;
  NewSurface(F: TopoDS_Shape): Handle_Geom_Surface;
  Isfafa_1(isfafa: Standard_Boolean): void;
  Isfafa_2(): Standard_Boolean;
  ChangeMapOfShapeWithStateObj(): TopOpeBRepDS_IndexedDataMapOfShapeWithState;
  ChangeMapOfShapeWithStateTool(): TopOpeBRepDS_IndexedDataMapOfShapeWithState;
  ChangeMapOfShapeWithState(aShape: TopoDS_Shape, aFlag: Standard_Boolean): TopOpeBRepDS_IndexedDataMapOfShapeWithState;
  GetShapeWithState(aShape: TopoDS_Shape): TopOpeBRepDS_ShapeWithState;
  ChangeMapOfRejectedShapesObj(): TopTools_IndexedMapOfShape;
  ChangeMapOfRejectedShapesTool(): TopTools_IndexedMapOfShape;
  delete(): void;
}

export declare class TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TopOpeBRepDS_DataMapOfIntegerListOfInterference): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference): TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference;
  Move(theOther: TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference): TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference;
  First(): TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  ChangeFirst(): TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  Last(): TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  ChangeLast(): TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  Value(theIndex: Standard_Integer): TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  ChangeValue(theIndex: Standard_Integer): TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  SetValue(theIndex: Standard_Integer, theItem: TopOpeBRepDS_DataMapOfIntegerListOfInterference): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_1 extends TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference {
    constructor();
  }

  export declare class TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_2 extends TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_3 extends TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference {
    constructor(theOther: TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference);
  }

  export declare class TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_4 extends TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference {
    constructor(theOther: TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference);
  }

  export declare class TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_5 extends TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference {
    constructor(theBegin: TopOpeBRepDS_DataMapOfIntegerListOfInterference, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TopOpeBRepDS_EIR {
  constructor(HDS: Handle_TopOpeBRepDS_HDataStructure)
  ProcessEdgeInterferences_1(): void;
  ProcessEdgeInterferences_2(I: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopOpeBRepDS_HDataStructure extends Standard_Transient {
  constructor()
  AddAncestors_1(S: TopoDS_Shape): void;
  AddAncestors_2(S: TopoDS_Shape, T1: TopAbs_ShapeEnum, T2: TopAbs_ShapeEnum): void;
  ChkIntg(): void;
  DS(): TopOpeBRepDS_DataStructure;
  ChangeDS(): TopOpeBRepDS_DataStructure;
  NbSurfaces(): Graphic3d_ZLayerId;
  NbCurves(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  Surface(I: Graphic3d_ZLayerId): TopOpeBRepDS_Surface;
  SurfaceCurves(I: Graphic3d_ZLayerId): TopOpeBRepDS_CurveIterator;
  Curve(I: Graphic3d_ZLayerId): TopOpeBRepDS_Curve;
  ChangeCurve(I: Graphic3d_ZLayerId): TopOpeBRepDS_Curve;
  CurvePoints(I: Graphic3d_ZLayerId): TopOpeBRepDS_PointIterator;
  Point(I: Graphic3d_ZLayerId): TopOpeBRepDS_Point;
  NbShapes(): Graphic3d_ZLayerId;
  Shape_1(I: Graphic3d_ZLayerId, FindKeep: Standard_Boolean): TopoDS_Shape;
  Shape_2(S: TopoDS_Shape, FindKeep: Standard_Boolean): Graphic3d_ZLayerId;
  HasGeometry(S: TopoDS_Shape): Standard_Boolean;
  HasShape(S: TopoDS_Shape, FindKeep: Standard_Boolean): Standard_Boolean;
  HasSameDomain(S: TopoDS_Shape, FindKeep: Standard_Boolean): Standard_Boolean;
  SameDomain(S: TopoDS_Shape): TopTools_ListIteratorOfListOfShape;
  SameDomainOrientation(S: TopoDS_Shape): TopOpeBRepDS_Config;
  SameDomainReference(S: TopoDS_Shape): Graphic3d_ZLayerId;
  SolidSurfaces_1(S: TopoDS_Shape): TopOpeBRepDS_SurfaceIterator;
  SolidSurfaces_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_SurfaceIterator;
  FaceCurves_1(F: TopoDS_Shape): TopOpeBRepDS_CurveIterator;
  FaceCurves_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_CurveIterator;
  EdgePoints(E: TopoDS_Shape): TopOpeBRepDS_PointIterator;
  MakeCurve(C1: TopOpeBRepDS_Curve, C2: TopOpeBRepDS_Curve): Graphic3d_ZLayerId;
  RemoveCurve(iC: Graphic3d_ZLayerId): void;
  NbGeometry(K: TopOpeBRepDS_Kind): Graphic3d_ZLayerId;
  NbTopology_1(K: TopOpeBRepDS_Kind): Graphic3d_ZLayerId;
  NbTopology_2(): Graphic3d_ZLayerId;
  EdgesSameParameter(): Standard_Boolean;
  SortOnParameter_1(L1: TopOpeBRepDS_ListOfInterference, L2: TopOpeBRepDS_ListOfInterference): void;
  SortOnParameter_2(L: TopOpeBRepDS_ListOfInterference): void;
  MinMaxOnParameter(L: TopOpeBRepDS_ListOfInterference, Min: Quantity_AbsorbedDose, Max: Quantity_AbsorbedDose): void;
  ScanInterfList(IT: TopOpeBRepDS_ListIteratorOfListOfInterference, PDS: TopOpeBRepDS_Point): Standard_Boolean;
  GetGeometry(IT: TopOpeBRepDS_ListIteratorOfListOfInterference, PDS: TopOpeBRepDS_Point, G: Graphic3d_ZLayerId, K: TopOpeBRepDS_Kind): Standard_Boolean;
  StoreInterference_1(I: Handle_TopOpeBRepDS_Interference, LI: TopOpeBRepDS_ListOfInterference, str: XCAFDoc_PartId): void;
  StoreInterference_2(I: Handle_TopOpeBRepDS_Interference, S: TopoDS_Shape, str: XCAFDoc_PartId): void;
  StoreInterference_3(I: Handle_TopOpeBRepDS_Interference, IS: Graphic3d_ZLayerId, str: XCAFDoc_PartId): void;
  StoreInterferences_1(LI: TopOpeBRepDS_ListOfInterference, S: TopoDS_Shape, str: XCAFDoc_PartId): void;
  StoreInterferences_2(LI: TopOpeBRepDS_ListOfInterference, IS: Graphic3d_ZLayerId, str: XCAFDoc_PartId): void;
  ClearStoreInterferences_1(LI: TopOpeBRepDS_ListOfInterference, S: TopoDS_Shape, str: XCAFDoc_PartId): void;
  ClearStoreInterferences_2(LI: TopOpeBRepDS_ListOfInterference, IS: Graphic3d_ZLayerId, str: XCAFDoc_PartId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_HDataStructure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_HDataStructure): void;
  get(): TopOpeBRepDS_HDataStructure;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_HDataStructure_1 extends Handle_TopOpeBRepDS_HDataStructure {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_HDataStructure_2 extends Handle_TopOpeBRepDS_HDataStructure {
    constructor(thePtr: TopOpeBRepDS_HDataStructure);
  }

  export declare class Handle_TopOpeBRepDS_HDataStructure_3 extends Handle_TopOpeBRepDS_HDataStructure {
    constructor(theHandle: Handle_TopOpeBRepDS_HDataStructure);
  }

  export declare class Handle_TopOpeBRepDS_HDataStructure_4 extends Handle_TopOpeBRepDS_HDataStructure {
    constructor(theHandle: Handle_TopOpeBRepDS_HDataStructure);
  }

export declare class TopOpeBRepDS_ShapeData {
  constructor()
  Interferences(): TopOpeBRepDS_ListOfInterference;
  ChangeInterferences(): TopOpeBRepDS_ListOfInterference;
  Keep(): Standard_Boolean;
  ChangeKeep(B: Standard_Boolean): void;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_EdgeVertexInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_EdgeVertexInterference): void;
  get(): TopOpeBRepDS_EdgeVertexInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_EdgeVertexInterference_1 extends Handle_TopOpeBRepDS_EdgeVertexInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_EdgeVertexInterference_2 extends Handle_TopOpeBRepDS_EdgeVertexInterference {
    constructor(thePtr: TopOpeBRepDS_EdgeVertexInterference);
  }

  export declare class Handle_TopOpeBRepDS_EdgeVertexInterference_3 extends Handle_TopOpeBRepDS_EdgeVertexInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_EdgeVertexInterference);
  }

  export declare class Handle_TopOpeBRepDS_EdgeVertexInterference_4 extends Handle_TopOpeBRepDS_EdgeVertexInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_EdgeVertexInterference);
  }

export declare class TopOpeBRepDS_EdgeVertexInterference extends TopOpeBRepDS_ShapeShapeInterference {
  Parameter_1(): Quantity_AbsorbedDose;
  Parameter_2(P: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopOpeBRepDS_EdgeVertexInterference_1 extends TopOpeBRepDS_EdgeVertexInterference {
    constructor(T: TopOpeBRepDS_Transition, ST: TopOpeBRepDS_Kind, S: Graphic3d_ZLayerId, G: Graphic3d_ZLayerId, GIsBound: Standard_Boolean, C: TopOpeBRepDS_Config, P: Quantity_AbsorbedDose);
  }

  export declare class TopOpeBRepDS_EdgeVertexInterference_2 extends TopOpeBRepDS_EdgeVertexInterference {
    constructor(T: TopOpeBRepDS_Transition, S: Graphic3d_ZLayerId, G: Graphic3d_ZLayerId, GIsBound: Standard_Boolean, C: TopOpeBRepDS_Config, P: Quantity_AbsorbedDose);
  }

export declare class TopOpeBRepDS_InterferenceTool {
  constructor();
  static MakeEdgeInterference(T: TopOpeBRepDS_Transition, SK: TopOpeBRepDS_Kind, SI: Graphic3d_ZLayerId, GK: TopOpeBRepDS_Kind, GI: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose): Handle_TopOpeBRepDS_Interference;
  static MakeCurveInterference(T: TopOpeBRepDS_Transition, SK: TopOpeBRepDS_Kind, SI: Graphic3d_ZLayerId, GK: TopOpeBRepDS_Kind, GI: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose): Handle_TopOpeBRepDS_Interference;
  static DuplicateCurvePointInterference(I: Handle_TopOpeBRepDS_Interference): Handle_TopOpeBRepDS_Interference;
  static MakeFaceCurveInterference(Transition: TopOpeBRepDS_Transition, FaceI: Graphic3d_ZLayerId, CurveI: Graphic3d_ZLayerId, PC: Handle_Geom2d_Curve): Handle_TopOpeBRepDS_Interference;
  static MakeSolidSurfaceInterference(Transition: TopOpeBRepDS_Transition, SolidI: Graphic3d_ZLayerId, SurfaceI: Graphic3d_ZLayerId): Handle_TopOpeBRepDS_Interference;
  static MakeEdgeVertexInterference(Transition: TopOpeBRepDS_Transition, EdgeI: Graphic3d_ZLayerId, VertexI: Graphic3d_ZLayerId, VertexIsBound: Standard_Boolean, Config: TopOpeBRepDS_Config, param: Quantity_AbsorbedDose): Handle_TopOpeBRepDS_Interference;
  static MakeFaceEdgeInterference(Transition: TopOpeBRepDS_Transition, FaceI: Graphic3d_ZLayerId, EdgeI: Graphic3d_ZLayerId, EdgeIsBound: Standard_Boolean, Config: TopOpeBRepDS_Config): Handle_TopOpeBRepDS_Interference;
  static Parameter_1(CPI: Handle_TopOpeBRepDS_Interference): Quantity_AbsorbedDose;
  static Parameter_2(CPI: Handle_TopOpeBRepDS_Interference, Par: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class TopOpeBRepDS_GeometryData {
  Assign(Other: TopOpeBRepDS_GeometryData): void;
  Interferences(): TopOpeBRepDS_ListOfInterference;
  ChangeInterferences(): TopOpeBRepDS_ListOfInterference;
  AddInterference(I: Handle_TopOpeBRepDS_Interference): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_GeometryData_1 extends TopOpeBRepDS_GeometryData {
    constructor();
  }

  export declare class TopOpeBRepDS_GeometryData_2 extends TopOpeBRepDS_GeometryData {
    constructor(Other: TopOpeBRepDS_GeometryData);
  }

export declare class Handle_TopOpeBRepDS_FaceEdgeInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_FaceEdgeInterference): void;
  get(): TopOpeBRepDS_FaceEdgeInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_FaceEdgeInterference_1 extends Handle_TopOpeBRepDS_FaceEdgeInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_FaceEdgeInterference_2 extends Handle_TopOpeBRepDS_FaceEdgeInterference {
    constructor(thePtr: TopOpeBRepDS_FaceEdgeInterference);
  }

  export declare class Handle_TopOpeBRepDS_FaceEdgeInterference_3 extends Handle_TopOpeBRepDS_FaceEdgeInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_FaceEdgeInterference);
  }

  export declare class Handle_TopOpeBRepDS_FaceEdgeInterference_4 extends Handle_TopOpeBRepDS_FaceEdgeInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_FaceEdgeInterference);
  }

export declare class TopOpeBRepDS_FaceEdgeInterference extends TopOpeBRepDS_ShapeShapeInterference {
  constructor(T: TopOpeBRepDS_Transition, S: Graphic3d_ZLayerId, G: Graphic3d_ZLayerId, GIsBound: Standard_Boolean, C: TopOpeBRepDS_Config)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TopOpeBRepDS_ShapeWithState {
  constructor()
  Part(aState: TopAbs_State): TopTools_ListOfShape;
  AddPart(aShape: TopoDS_Shape, aState: TopAbs_State): void;
  AddParts(aListOfShape: TopTools_ListOfShape, aState: TopAbs_State): void;
  SetState(aState: TopAbs_State): void;
  State(): TopAbs_State;
  SetIsSplitted(anIsSplitted: Standard_Boolean): void;
  IsSplitted(): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepDS_DataMapOfCheckStatus extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_CheckStatus, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_CheckStatus, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopOpeBRepDS_CheckStatus): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopOpeBRepDS_CheckStatus): TopOpeBRepDS_CheckStatus;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopOpeBRepDS_CheckStatus;
  ChangeSeek(theKey: Standard_Integer): TopOpeBRepDS_CheckStatus;
  ChangeFind(theKey: Standard_Integer): TopOpeBRepDS_CheckStatus;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_DataMapOfCheckStatus_1 extends TopOpeBRepDS_DataMapOfCheckStatus {
    constructor();
  }

  export declare class TopOpeBRepDS_DataMapOfCheckStatus_2 extends TopOpeBRepDS_DataMapOfCheckStatus {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_DataMapOfCheckStatus_3 extends TopOpeBRepDS_DataMapOfCheckStatus {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_CheckStatus, TColStd_MapIntegerHasher>);
  }

export declare class TopOpeBRepDS_SolidSurfaceInterference extends TopOpeBRepDS_Interference {
  constructor(Transition: TopOpeBRepDS_Transition, SupportType: TopOpeBRepDS_Kind, Support: Graphic3d_ZLayerId, GeometryType: TopOpeBRepDS_Kind, Geometry: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_SolidSurfaceInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_SolidSurfaceInterference): void;
  get(): TopOpeBRepDS_SolidSurfaceInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_SolidSurfaceInterference_1 extends Handle_TopOpeBRepDS_SolidSurfaceInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_SolidSurfaceInterference_2 extends Handle_TopOpeBRepDS_SolidSurfaceInterference {
    constructor(thePtr: TopOpeBRepDS_SolidSurfaceInterference);
  }

  export declare class Handle_TopOpeBRepDS_SolidSurfaceInterference_3 extends Handle_TopOpeBRepDS_SolidSurfaceInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_SolidSurfaceInterference);
  }

  export declare class Handle_TopOpeBRepDS_SolidSurfaceInterference_4 extends Handle_TopOpeBRepDS_SolidSurfaceInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_SolidSurfaceInterference);
  }

export declare class Handle_TopOpeBRepDS_CurvePointInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_CurvePointInterference): void;
  get(): TopOpeBRepDS_CurvePointInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_CurvePointInterference_1 extends Handle_TopOpeBRepDS_CurvePointInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_CurvePointInterference_2 extends Handle_TopOpeBRepDS_CurvePointInterference {
    constructor(thePtr: TopOpeBRepDS_CurvePointInterference);
  }

  export declare class Handle_TopOpeBRepDS_CurvePointInterference_3 extends Handle_TopOpeBRepDS_CurvePointInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_CurvePointInterference);
  }

  export declare class Handle_TopOpeBRepDS_CurvePointInterference_4 extends Handle_TopOpeBRepDS_CurvePointInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_CurvePointInterference);
  }

export declare class TopOpeBRepDS_CurvePointInterference extends TopOpeBRepDS_Interference {
  constructor(T: TopOpeBRepDS_Transition, ST: TopOpeBRepDS_Kind, S: Graphic3d_ZLayerId, GT: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose)
  Parameter_1(): Quantity_AbsorbedDose;
  Parameter_2(P: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference): void;
  get(): TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_1 extends Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_2 extends Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference {
    constructor(thePtr: TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference);
  }

  export declare class Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_3 extends Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference);
  }

  export declare class Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_4 extends Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference);
  }

export declare class TopOpeBRepDS_MapOfShapeData extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepDS_MapOfShapeData): void;
  Assign(theOther: TopOpeBRepDS_MapOfShapeData): TopOpeBRepDS_MapOfShapeData;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopOpeBRepDS_ShapeData): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopOpeBRepDS_ShapeData): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopOpeBRepDS_ShapeData;
  ChangeFromIndex(theIndex: Standard_Integer): TopOpeBRepDS_ShapeData;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopOpeBRepDS_ShapeData;
  Seek(theKey1: TopoDS_Shape): TopOpeBRepDS_ShapeData;
  ChangeSeek(theKey1: TopoDS_Shape): TopOpeBRepDS_ShapeData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_MapOfShapeData_1 extends TopOpeBRepDS_MapOfShapeData {
    constructor();
  }

  export declare class TopOpeBRepDS_MapOfShapeData_2 extends TopOpeBRepDS_MapOfShapeData {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_MapOfShapeData_3 extends TopOpeBRepDS_MapOfShapeData {
    constructor(theOther: TopOpeBRepDS_MapOfShapeData);
  }

export declare class TopOpeBRepDS_Interference extends Standard_Transient {
  Transition_1(): TopOpeBRepDS_Transition;
  ChangeTransition(): TopOpeBRepDS_Transition;
  Transition_2(T: TopOpeBRepDS_Transition): void;
  GKGSKS(GK: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId, SK: TopOpeBRepDS_Kind, S: Graphic3d_ZLayerId): void;
  SupportType_1(): TopOpeBRepDS_Kind;
  Support_1(): Graphic3d_ZLayerId;
  GeometryType_1(): TopOpeBRepDS_Kind;
  Geometry_1(): Graphic3d_ZLayerId;
  SetGeometry(GI: Graphic3d_ZLayerId): void;
  SupportType_2(ST: TopOpeBRepDS_Kind): void;
  Support_2(S: Graphic3d_ZLayerId): void;
  GeometryType_2(GT: TopOpeBRepDS_Kind): void;
  Geometry_2(G: Graphic3d_ZLayerId): void;
  HasSameSupport(Other: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  HasSameGeometry(Other: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopOpeBRepDS_Interference_1 extends TopOpeBRepDS_Interference {
    constructor();
  }

  export declare class TopOpeBRepDS_Interference_2 extends TopOpeBRepDS_Interference {
    constructor(Transition: TopOpeBRepDS_Transition, SupportType: TopOpeBRepDS_Kind, Support: Graphic3d_ZLayerId, GeometryType: TopOpeBRepDS_Kind, Geometry: Graphic3d_ZLayerId);
  }

  export declare class TopOpeBRepDS_Interference_3 extends TopOpeBRepDS_Interference {
    constructor(I: Handle_TopOpeBRepDS_Interference);
  }

export declare class Handle_TopOpeBRepDS_Interference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_Interference): void;
  get(): TopOpeBRepDS_Interference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_Interference_1 extends Handle_TopOpeBRepDS_Interference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_Interference_2 extends Handle_TopOpeBRepDS_Interference {
    constructor(thePtr: TopOpeBRepDS_Interference);
  }

  export declare class Handle_TopOpeBRepDS_Interference_3 extends Handle_TopOpeBRepDS_Interference {
    constructor(theHandle: Handle_TopOpeBRepDS_Interference);
  }

  export declare class Handle_TopOpeBRepDS_Interference_4 extends Handle_TopOpeBRepDS_Interference {
    constructor(theHandle: Handle_TopOpeBRepDS_Interference);
  }

export declare class TopOpeBRepDS_MapOfPoint extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_PointData, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_PointData, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopOpeBRepDS_PointData): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopOpeBRepDS_PointData): TopOpeBRepDS_PointData;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopOpeBRepDS_PointData;
  ChangeSeek(theKey: Standard_Integer): TopOpeBRepDS_PointData;
  ChangeFind(theKey: Standard_Integer): TopOpeBRepDS_PointData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_MapOfPoint_1 extends TopOpeBRepDS_MapOfPoint {
    constructor();
  }

  export declare class TopOpeBRepDS_MapOfPoint_2 extends TopOpeBRepDS_MapOfPoint {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_MapOfPoint_3 extends TopOpeBRepDS_MapOfPoint {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_PointData, TColStd_MapIntegerHasher>);
  }

export declare class TopOpeBRepDS_DoubleMapOfIntegerShape extends NCollection_BaseMap {
  Exchange(theOther: TopOpeBRepDS_DoubleMapOfIntegerShape): void;
  Assign(theOther: TopOpeBRepDS_DoubleMapOfIntegerShape): TopOpeBRepDS_DoubleMapOfIntegerShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey1: Standard_Integer, theKey2: TopoDS_Shape): void;
  AreBound(theKey1: Standard_Integer, theKey2: TopoDS_Shape): Standard_Boolean;
  IsBound1(theKey1: Standard_Integer): Standard_Boolean;
  IsBound2(theKey2: TopoDS_Shape): Standard_Boolean;
  UnBind1(theKey1: Standard_Integer): Standard_Boolean;
  UnBind2(theKey2: TopoDS_Shape): Standard_Boolean;
  Find1_1(theKey1: Standard_Integer): TopoDS_Shape;
  Find1_2(theKey1: Standard_Integer, theKey2: TopoDS_Shape): Standard_Boolean;
  Seek1(theKey1: Standard_Integer): TopoDS_Shape;
  Find2_1(theKey2: TopoDS_Shape): Standard_Integer;
  Find2_2(theKey2: TopoDS_Shape, theKey1: Standard_Integer): Standard_Boolean;
  Seek2(theKey2: TopoDS_Shape): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_DoubleMapOfIntegerShape_1 extends TopOpeBRepDS_DoubleMapOfIntegerShape {
    constructor();
  }

  export declare class TopOpeBRepDS_DoubleMapOfIntegerShape_2 extends TopOpeBRepDS_DoubleMapOfIntegerShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_DoubleMapOfIntegerShape_3 extends TopOpeBRepDS_DoubleMapOfIntegerShape {
    constructor(theOther: TopOpeBRepDS_DoubleMapOfIntegerShape);
  }

export declare class TopOpeBRepDS_Association extends Standard_Transient {
  constructor()
  Associate_1(I: Handle_TopOpeBRepDS_Interference, K: Handle_TopOpeBRepDS_Interference): void;
  Associate_2(I: Handle_TopOpeBRepDS_Interference, LI: TopOpeBRepDS_ListOfInterference): void;
  HasAssociation(I: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  Associated(I: Handle_TopOpeBRepDS_Interference): TopOpeBRepDS_ListOfInterference;
  AreAssociated(I: Handle_TopOpeBRepDS_Interference, K: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepDS_Association {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_Association): void;
  get(): TopOpeBRepDS_Association;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_Association_1 extends Handle_TopOpeBRepDS_Association {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_Association_2 extends Handle_TopOpeBRepDS_Association {
    constructor(thePtr: TopOpeBRepDS_Association);
  }

  export declare class Handle_TopOpeBRepDS_Association_3 extends Handle_TopOpeBRepDS_Association {
    constructor(theHandle: Handle_TopOpeBRepDS_Association);
  }

  export declare class Handle_TopOpeBRepDS_Association_4 extends Handle_TopOpeBRepDS_Association {
    constructor(theHandle: Handle_TopOpeBRepDS_Association);
  }

export declare type TopOpeBRepDS_Kind = {
  TopOpeBRepDS_POINT: {};
  TopOpeBRepDS_CURVE: {};
  TopOpeBRepDS_SURFACE: {};
  TopOpeBRepDS_VERTEX: {};
  TopOpeBRepDS_EDGE: {};
  TopOpeBRepDS_WIRE: {};
  TopOpeBRepDS_FACE: {};
  TopOpeBRepDS_SHELL: {};
  TopOpeBRepDS_SOLID: {};
  TopOpeBRepDS_COMPSOLID: {};
  TopOpeBRepDS_COMPOUND: {};
  TopOpeBRepDS_UNKNOWN: {};
}

export declare class TopOpeBRepDS_Curve {
  DefineCurve(P: Handle_Geom_Curve, T: Quantity_AbsorbedDose, IsWalk: Standard_Boolean): void;
  Tolerance_1(tol: Quantity_AbsorbedDose): void;
  SetSCI(I1: Handle_TopOpeBRepDS_Interference, I2: Handle_TopOpeBRepDS_Interference): void;
  GetSCI1(): Handle_TopOpeBRepDS_Interference;
  GetSCI2(): Handle_TopOpeBRepDS_Interference;
  GetSCI(I1: Handle_TopOpeBRepDS_Interference, I2: Handle_TopOpeBRepDS_Interference): void;
  SetShapes(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  GetShapes(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  Shape1(): TopoDS_Shape;
  ChangeShape1(): TopoDS_Shape;
  Shape2(): TopoDS_Shape;
  ChangeShape2(): TopoDS_Shape;
  Curve_1(): Handle_Geom_Curve;
  SetRange(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Range(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  Tolerance_2(): Quantity_AbsorbedDose;
  ChangeCurve(): Handle_Geom_Curve;
  Curve_2(C3D: Handle_Geom_Curve, Tol: Quantity_AbsorbedDose): void;
  Curve1_1(): Handle_Geom2d_Curve;
  Curve1_2(PC1: Handle_Geom2d_Curve): void;
  Curve2_1(): Handle_Geom2d_Curve;
  Curve2_2(PC2: Handle_Geom2d_Curve): void;
  IsWalk(): Standard_Boolean;
  ChangeIsWalk(B: Standard_Boolean): void;
  Keep(): Standard_Boolean;
  ChangeKeep(B: Standard_Boolean): void;
  Mother(): Graphic3d_ZLayerId;
  ChangeMother(I: Graphic3d_ZLayerId): void;
  DSIndex(): Graphic3d_ZLayerId;
  ChangeDSIndex(I: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_Curve_1 extends TopOpeBRepDS_Curve {
    constructor();
  }

  export declare class TopOpeBRepDS_Curve_2 extends TopOpeBRepDS_Curve {
    constructor(P: Handle_Geom_Curve, T: Quantity_AbsorbedDose, IsWalk: Standard_Boolean);
  }

export declare class TopOpeBRepDS_BuildTool {
  GetGeomTool(): TopOpeBRepTool_GeomTool;
  ChangeGeomTool(): TopOpeBRepTool_GeomTool;
  MakeVertex(V: TopoDS_Shape, P: TopOpeBRepDS_Point): void;
  MakeEdge_1(E: TopoDS_Shape, C: TopOpeBRepDS_Curve): void;
  MakeEdge_2(E: TopoDS_Shape, C: TopOpeBRepDS_Curve, DS: TopOpeBRepDS_DataStructure): void;
  MakeEdge_3(E: TopoDS_Shape, C: Handle_Geom_Curve, Tol: Quantity_AbsorbedDose): void;
  MakeEdge_4(E: TopoDS_Shape): void;
  MakeWire(W: TopoDS_Shape): void;
  MakeFace(F: TopoDS_Shape, S: TopOpeBRepDS_Surface): void;
  MakeShell(Sh: TopoDS_Shape): void;
  MakeSolid(S: TopoDS_Shape): void;
  CopyEdge(Ein: TopoDS_Shape, Eou: TopoDS_Shape): void;
  GetOrientedEdgeVertices(E: TopoDS_Edge, Vmin: TopoDS_Vertex, Vmax: TopoDS_Vertex, Parmin: Quantity_AbsorbedDose, Parmax: Quantity_AbsorbedDose): void;
  UpdateEdgeCurveTol(F1: TopoDS_Face, F2: TopoDS_Face, E: TopoDS_Edge, C3Dnew: Handle_Geom_Curve, tol3d: Quantity_AbsorbedDose, tol2d1: Quantity_AbsorbedDose, tol2d2: Quantity_AbsorbedDose, newtol: Quantity_AbsorbedDose, newparmin: Quantity_AbsorbedDose, newparmax: Quantity_AbsorbedDose): void;
  ApproxCurves(C: TopOpeBRepDS_Curve, E: TopoDS_Edge, inewC: Graphic3d_ZLayerId, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  ComputePCurves(C: TopOpeBRepDS_Curve, E: TopoDS_Edge, newC: TopOpeBRepDS_Curve, CompPC1: Standard_Boolean, CompPC2: Standard_Boolean, CompC3D: Standard_Boolean): void;
  PutPCurves(newC: TopOpeBRepDS_Curve, E: TopoDS_Edge, CompPC1: Standard_Boolean, CompPC2: Standard_Boolean): void;
  RecomputeCurves(C: TopOpeBRepDS_Curve, oldE: TopoDS_Edge, E: TopoDS_Edge, inewC: Graphic3d_ZLayerId, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  CopyFace(Fin: TopoDS_Shape, Fou: TopoDS_Shape): void;
  AddEdgeVertex_1(Ein: TopoDS_Shape, Eou: TopoDS_Shape, V: TopoDS_Shape): void;
  AddEdgeVertex_2(E: TopoDS_Shape, V: TopoDS_Shape): void;
  AddWireEdge(W: TopoDS_Shape, E: TopoDS_Shape): void;
  AddFaceWire(F: TopoDS_Shape, W: TopoDS_Shape): void;
  AddShellFace(Sh: TopoDS_Shape, F: TopoDS_Shape): void;
  AddSolidShell(S: TopoDS_Shape, Sh: TopoDS_Shape): void;
  Parameter_1(E: TopoDS_Shape, V: TopoDS_Shape, P: Quantity_AbsorbedDose): void;
  Range(E: TopoDS_Shape, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose): void;
  UpdateEdge(Ein: TopoDS_Shape, Eou: TopoDS_Shape): void;
  Parameter_2(C: TopOpeBRepDS_Curve, E: TopoDS_Shape, V: TopoDS_Shape): void;
  Curve3D(E: TopoDS_Shape, C: Handle_Geom_Curve, Tol: Quantity_AbsorbedDose): void;
  PCurve_1(F: TopoDS_Shape, E: TopoDS_Shape, C: Handle_Geom2d_Curve): void;
  PCurve_2(F: TopoDS_Shape, E: TopoDS_Shape, CDS: TopOpeBRepDS_Curve, C: Handle_Geom2d_Curve): void;
  Orientation_1(S: TopoDS_Shape, O: TopAbs_Orientation): void;
  Orientation_2(S: TopoDS_Shape): TopAbs_Orientation;
  Closed(S: TopoDS_Shape, B: Standard_Boolean): void;
  Approximation(): Standard_Boolean;
  UpdateSurface_1(F: TopoDS_Shape, SU: Handle_Geom_Surface): void;
  UpdateSurface_2(E: TopoDS_Shape, oldF: TopoDS_Shape, newF: TopoDS_Shape): void;
  OverWrite_1(): Standard_Boolean;
  OverWrite_2(O: Standard_Boolean): void;
  Translate_1(): Standard_Boolean;
  Translate_2(T: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepDS_BuildTool_1 extends TopOpeBRepDS_BuildTool {
    constructor();
  }

  export declare class TopOpeBRepDS_BuildTool_2 extends TopOpeBRepDS_BuildTool {
    constructor(OutCurveType: TopOpeBRepTool_OutCurveType);
  }

  export declare class TopOpeBRepDS_BuildTool_3 extends TopOpeBRepDS_BuildTool {
    constructor(GT: TopOpeBRepTool_GeomTool);
  }

export declare class TopOpeBRepDS_Edge3dInterferenceTool {
  constructor()
  InitPointVertex(IsVertex: Graphic3d_ZLayerId, VonOO: TopoDS_Shape): void;
  Init(Eref: TopoDS_Shape, E: TopoDS_Shape, F: TopoDS_Shape, I: Handle_TopOpeBRepDS_Interference): void;
  Add(Eref: TopoDS_Shape, E: TopoDS_Shape, F: TopoDS_Shape, I: Handle_TopOpeBRepDS_Interference): void;
  Transition(I: Handle_TopOpeBRepDS_Interference): void;
  delete(): void;
}

export declare class TopOpeBRepDS_SurfaceExplorer {
  Init(DS: TopOpeBRepDS_DataStructure, FindOnlyKeep: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  Surface_1(): TopOpeBRepDS_Surface;
  IsSurface(I: Graphic3d_ZLayerId): Standard_Boolean;
  IsSurfaceKeep(I: Graphic3d_ZLayerId): Standard_Boolean;
  Surface_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_Surface;
  NbSurface(): Graphic3d_ZLayerId;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepDS_SurfaceExplorer_1 extends TopOpeBRepDS_SurfaceExplorer {
    constructor();
  }

  export declare class TopOpeBRepDS_SurfaceExplorer_2 extends TopOpeBRepDS_SurfaceExplorer {
    constructor(DS: TopOpeBRepDS_DataStructure, FindOnlyKeep: Standard_Boolean);
  }

export declare class TopOpeBRepDS_MapOfIntegerShapeData extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_ShapeData, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_ShapeData, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopOpeBRepDS_ShapeData): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopOpeBRepDS_ShapeData): TopOpeBRepDS_ShapeData;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopOpeBRepDS_ShapeData;
  ChangeSeek(theKey: Standard_Integer): TopOpeBRepDS_ShapeData;
  ChangeFind(theKey: Standard_Integer): TopOpeBRepDS_ShapeData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_MapOfIntegerShapeData_1 extends TopOpeBRepDS_MapOfIntegerShapeData {
    constructor();
  }

  export declare class TopOpeBRepDS_MapOfIntegerShapeData_2 extends TopOpeBRepDS_MapOfIntegerShapeData {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_MapOfIntegerShapeData_3 extends TopOpeBRepDS_MapOfIntegerShapeData {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_ShapeData, TColStd_MapIntegerHasher>);
  }

export declare class TopOpeBRepDS_PointExplorer {
  Init(DS: TopOpeBRepDS_DataStructure, FindOnlyKeep: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  Point_1(): TopOpeBRepDS_Point;
  IsPoint(I: Graphic3d_ZLayerId): Standard_Boolean;
  IsPointKeep(I: Graphic3d_ZLayerId): Standard_Boolean;
  Point_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_Point;
  NbPoint(): Graphic3d_ZLayerId;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepDS_PointExplorer_1 extends TopOpeBRepDS_PointExplorer {
    constructor();
  }

  export declare class TopOpeBRepDS_PointExplorer_2 extends TopOpeBRepDS_PointExplorer {
    constructor(DS: TopOpeBRepDS_DataStructure, FindOnlyKeep: Standard_Boolean);
  }

export declare class TopOpeBRepDS_MapOfCurve extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_CurveData, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_CurveData, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopOpeBRepDS_CurveData): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopOpeBRepDS_CurveData): TopOpeBRepDS_CurveData;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopOpeBRepDS_CurveData;
  ChangeSeek(theKey: Standard_Integer): TopOpeBRepDS_CurveData;
  ChangeFind(theKey: Standard_Integer): TopOpeBRepDS_CurveData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_MapOfCurve_1 extends TopOpeBRepDS_MapOfCurve {
    constructor();
  }

  export declare class TopOpeBRepDS_MapOfCurve_2 extends TopOpeBRepDS_MapOfCurve {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_MapOfCurve_3 extends TopOpeBRepDS_MapOfCurve {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_CurveData, TColStd_MapIntegerHasher>);
  }

export declare class TopOpeBRepDS_FIR {
  constructor(HDS: Handle_TopOpeBRepDS_HDataStructure)
  ProcessFaceInterferences_1(M: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): void;
  ProcessFaceInterferences_2(I: Graphic3d_ZLayerId, M: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State): void;
  delete(): void;
}

export declare class TopOpeBRepDS_Explorer {
  Init(HDS: Handle_TopOpeBRepDS_HDataStructure, T: TopAbs_ShapeEnum, findkeep: Standard_Boolean): void;
  Type(): TopAbs_ShapeEnum;
  More(): Standard_Boolean;
  Next(): void;
  Current(): TopoDS_Shape;
  Index(): Graphic3d_ZLayerId;
  Face(): TopoDS_Face;
  Edge(): TopoDS_Edge;
  Vertex(): TopoDS_Vertex;
  delete(): void;
}

  export declare class TopOpeBRepDS_Explorer_1 extends TopOpeBRepDS_Explorer {
    constructor();
  }

  export declare class TopOpeBRepDS_Explorer_2 extends TopOpeBRepDS_Explorer {
    constructor(HDS: Handle_TopOpeBRepDS_HDataStructure, T: TopAbs_ShapeEnum, findkeep: Standard_Boolean);
  }

export declare class TopOpeBRepDS_SurfaceCurveInterference extends TopOpeBRepDS_Interference {
  PCurve_1(): Handle_Geom2d_Curve;
  PCurve_2(PC: Handle_Geom2d_Curve): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopOpeBRepDS_SurfaceCurveInterference_1 extends TopOpeBRepDS_SurfaceCurveInterference {
    constructor();
  }

  export declare class TopOpeBRepDS_SurfaceCurveInterference_2 extends TopOpeBRepDS_SurfaceCurveInterference {
    constructor(Transition: TopOpeBRepDS_Transition, SupportType: TopOpeBRepDS_Kind, Support: Graphic3d_ZLayerId, GeometryType: TopOpeBRepDS_Kind, Geometry: Graphic3d_ZLayerId, PC: Handle_Geom2d_Curve);
  }

  export declare class TopOpeBRepDS_SurfaceCurveInterference_3 extends TopOpeBRepDS_SurfaceCurveInterference {
    constructor(I: Handle_TopOpeBRepDS_Interference);
  }

export declare class Handle_TopOpeBRepDS_SurfaceCurveInterference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_SurfaceCurveInterference): void;
  get(): TopOpeBRepDS_SurfaceCurveInterference;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_SurfaceCurveInterference_1 extends Handle_TopOpeBRepDS_SurfaceCurveInterference {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_SurfaceCurveInterference_2 extends Handle_TopOpeBRepDS_SurfaceCurveInterference {
    constructor(thePtr: TopOpeBRepDS_SurfaceCurveInterference);
  }

  export declare class Handle_TopOpeBRepDS_SurfaceCurveInterference_3 extends Handle_TopOpeBRepDS_SurfaceCurveInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_SurfaceCurveInterference);
  }

  export declare class Handle_TopOpeBRepDS_SurfaceCurveInterference_4 extends Handle_TopOpeBRepDS_SurfaceCurveInterference {
    constructor(theHandle: Handle_TopOpeBRepDS_SurfaceCurveInterference);
  }

export declare class TopOpeBRepDS_MapOfSurface extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_SurfaceData, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_SurfaceData, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopOpeBRepDS_SurfaceData): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopOpeBRepDS_SurfaceData): TopOpeBRepDS_SurfaceData;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopOpeBRepDS_SurfaceData;
  ChangeSeek(theKey: Standard_Integer): TopOpeBRepDS_SurfaceData;
  ChangeFind(theKey: Standard_Integer): TopOpeBRepDS_SurfaceData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_MapOfSurface_1 extends TopOpeBRepDS_MapOfSurface {
    constructor();
  }

  export declare class TopOpeBRepDS_MapOfSurface_2 extends TopOpeBRepDS_MapOfSurface {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_MapOfSurface_3 extends TopOpeBRepDS_MapOfSurface {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_SurfaceData, TColStd_MapIntegerHasher>);
  }

export declare class TopOpeBRepDS_DataMapOfIntegerListOfInterference extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_ListOfInterference, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_ListOfInterference, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopOpeBRepDS_ListOfInterference): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopOpeBRepDS_ListOfInterference): TopOpeBRepDS_ListOfInterference;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopOpeBRepDS_ListOfInterference;
  ChangeSeek(theKey: Standard_Integer): TopOpeBRepDS_ListOfInterference;
  ChangeFind(theKey: Standard_Integer): TopOpeBRepDS_ListOfInterference;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_DataMapOfIntegerListOfInterference_1 extends TopOpeBRepDS_DataMapOfIntegerListOfInterference {
    constructor();
  }

  export declare class TopOpeBRepDS_DataMapOfIntegerListOfInterference_2 extends TopOpeBRepDS_DataMapOfIntegerListOfInterference {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_DataMapOfIntegerListOfInterference_3 extends TopOpeBRepDS_DataMapOfIntegerListOfInterference {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopOpeBRepDS_ListOfInterference, TColStd_MapIntegerHasher>);
  }

export declare class TopOpeBRepDS_CurveExplorer {
  Init(DS: TopOpeBRepDS_DataStructure, FindOnlyKeep: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  Curve_1(): TopOpeBRepDS_Curve;
  IsCurve(I: Graphic3d_ZLayerId): Standard_Boolean;
  IsCurveKeep(I: Graphic3d_ZLayerId): Standard_Boolean;
  Curve_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_Curve;
  NbCurve(): Graphic3d_ZLayerId;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepDS_CurveExplorer_1 extends TopOpeBRepDS_CurveExplorer {
    constructor();
  }

  export declare class TopOpeBRepDS_CurveExplorer_2 extends TopOpeBRepDS_CurveExplorer {
    constructor(DS: TopOpeBRepDS_DataStructure, FindOnlyKeep: Standard_Boolean);
  }

export declare type TopOpeBRepDS_Config = {
  TopOpeBRepDS_UNSHGEOMETRY: {};
  TopOpeBRepDS_SAMEORIENTED: {};
  TopOpeBRepDS_DIFFORIENTED: {};
}

export declare type TopOpeBRepDS_CheckStatus = {
  TopOpeBRepDS_OK: {};
  TopOpeBRepDS_NOK: {};
}

export declare class TopOpeBRepDS {
  constructor();
  static SPrint_1(S: TopAbs_State): XCAFDoc_PartId;
  static SPrint_2(K: TopOpeBRepDS_Kind): XCAFDoc_PartId;
  static SPrint_3(K: TopOpeBRepDS_Kind, I: Graphic3d_ZLayerId, B: XCAFDoc_PartId, A: XCAFDoc_PartId): XCAFDoc_PartId;
  static SPrint_4(T: TopAbs_ShapeEnum): XCAFDoc_PartId;
  static SPrint_5(T: TopAbs_ShapeEnum, I: Graphic3d_ZLayerId): XCAFDoc_PartId;
  static SPrint_6(O: TopAbs_Orientation): XCAFDoc_PartId;
  static SPrint_7(C: TopOpeBRepDS_Config): XCAFDoc_PartId;
  static IsGeometry(K: TopOpeBRepDS_Kind): Standard_Boolean;
  static IsTopology(K: TopOpeBRepDS_Kind): Standard_Boolean;
  static KindToShape(K: TopOpeBRepDS_Kind): TopAbs_ShapeEnum;
  static ShapeToKind(S: TopAbs_ShapeEnum): TopOpeBRepDS_Kind;
  delete(): void;
}

export declare class TopOpeBRepDS_GapTool extends Standard_Transient {
  Init(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Interferences(IndexPoint: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  SameInterferences(I: Handle_TopOpeBRepDS_Interference): TopOpeBRepDS_ListOfInterference;
  ChangeSameInterferences(I: Handle_TopOpeBRepDS_Interference): TopOpeBRepDS_ListOfInterference;
  Curve(I: Handle_TopOpeBRepDS_Interference, C: TopOpeBRepDS_Curve): Standard_Boolean;
  EdgeSupport(I: Handle_TopOpeBRepDS_Interference, E: TopoDS_Shape): Standard_Boolean;
  FacesSupport(I: Handle_TopOpeBRepDS_Interference, F1: TopoDS_Shape, F2: TopoDS_Shape): Standard_Boolean;
  ParameterOnEdge(I: Handle_TopOpeBRepDS_Interference, E: TopoDS_Shape, U: Quantity_AbsorbedDose): Standard_Boolean;
  SetPoint(I: Handle_TopOpeBRepDS_Interference, IndexPoint: Graphic3d_ZLayerId): void;
  SetParameterOnEdge(I: Handle_TopOpeBRepDS_Interference, E: TopoDS_Shape, U: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopOpeBRepDS_GapTool_1 extends TopOpeBRepDS_GapTool {
    constructor();
  }

  export declare class TopOpeBRepDS_GapTool_2 extends TopOpeBRepDS_GapTool {
    constructor(HDS: Handle_TopOpeBRepDS_HDataStructure);
  }

export declare class Handle_TopOpeBRepDS_GapTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepDS_GapTool): void;
  get(): TopOpeBRepDS_GapTool;
  delete(): void;
}

  export declare class Handle_TopOpeBRepDS_GapTool_1 extends Handle_TopOpeBRepDS_GapTool {
    constructor();
  }

  export declare class Handle_TopOpeBRepDS_GapTool_2 extends Handle_TopOpeBRepDS_GapTool {
    constructor(thePtr: TopOpeBRepDS_GapTool);
  }

  export declare class Handle_TopOpeBRepDS_GapTool_3 extends Handle_TopOpeBRepDS_GapTool {
    constructor(theHandle: Handle_TopOpeBRepDS_GapTool);
  }

  export declare class Handle_TopOpeBRepDS_GapTool_4 extends Handle_TopOpeBRepDS_GapTool {
    constructor(theHandle: Handle_TopOpeBRepDS_GapTool);
  }

export declare class TopOpeBRepDS_TKI {
  constructor()
  Clear(): void;
  FillOnGeometry(L: TopOpeBRepDS_ListOfInterference): void;
  FillOnSupport(L: TopOpeBRepDS_ListOfInterference): void;
  IsBound(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): Standard_Boolean;
  Interferences(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ChangeInterferences(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  HasInterferences(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): Standard_Boolean;
  Add_1(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): void;
  Add_2(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId, HI: Handle_TopOpeBRepDS_Interference): void;
  DumpTKIIterator(s1: XCAFDoc_PartId, s2: XCAFDoc_PartId): void;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  ChangeValue(K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): TopOpeBRepDS_ListOfInterference;
  delete(): void;
}

export declare class TopOpeBRepDS_GapFiller {
  constructor(HDS: Handle_TopOpeBRepDS_HDataStructure)
  Perform(): void;
  FindAssociatedPoints(I: Handle_TopOpeBRepDS_Interference, LI: TopOpeBRepDS_ListOfInterference): void;
  CheckConnexity(LI: TopOpeBRepDS_ListOfInterference): Standard_Boolean;
  AddPointsOnShape(S: TopoDS_Shape, LI: TopOpeBRepDS_ListOfInterference): void;
  AddPointsOnConnexShape(F: TopoDS_Shape, LI: TopOpeBRepDS_ListOfInterference): void;
  FilterByFace(F: TopoDS_Face, LI: TopOpeBRepDS_ListOfInterference): void;
  FilterByEdge(E: TopoDS_Edge, LI: TopOpeBRepDS_ListOfInterference): void;
  FilterByIncidentDistance(F: TopoDS_Face, I: Handle_TopOpeBRepDS_Interference, LI: TopOpeBRepDS_ListOfInterference): void;
  IsOnFace(I: Handle_TopOpeBRepDS_Interference, F: TopoDS_Face): Standard_Boolean;
  IsOnEdge(I: Handle_TopOpeBRepDS_Interference, E: TopoDS_Edge): Standard_Boolean;
  BuildNewGeometries(): void;
  ReBuildGeom(I1: Handle_TopOpeBRepDS_Interference, Done: TColStd_MapOfInteger): void;
  delete(): void;
}

export declare class TopOpeBRepDS_DataMapOfShapeState extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepDS_DataMapOfShapeState): void;
  Assign(theOther: TopOpeBRepDS_DataMapOfShapeState): TopOpeBRepDS_DataMapOfShapeState;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopAbs_State): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopAbs_State): TopAbs_State;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopAbs_State;
  ChangeSeek(theKey: TopoDS_Shape): TopAbs_State;
  ChangeFind(theKey: TopoDS_Shape): TopAbs_State;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepDS_DataMapOfShapeState_1 extends TopOpeBRepDS_DataMapOfShapeState {
    constructor();
  }

  export declare class TopOpeBRepDS_DataMapOfShapeState_2 extends TopOpeBRepDS_DataMapOfShapeState {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepDS_DataMapOfShapeState_3 extends TopOpeBRepDS_DataMapOfShapeState {
    constructor(theOther: TopOpeBRepDS_DataMapOfShapeState);
  }

export declare class TopOpeBRepDS_TOOL {
  constructor();
  static EShareG(HDS: Handle_TopOpeBRepDS_HDataStructure, E: TopoDS_Edge, lEsd: TopTools_ListOfShape): Graphic3d_ZLayerId;
  static ShareG(HDS: Handle_TopOpeBRepDS_HDataStructure, is1: Graphic3d_ZLayerId, is2: Graphic3d_ZLayerId): Standard_Boolean;
  static GetEsd(HDS: Handle_TopOpeBRepDS_HDataStructure, S: TopoDS_Shape, ie: Graphic3d_ZLayerId, iesd: Graphic3d_ZLayerId): Standard_Boolean;
  static ShareSplitON(HDS: Handle_TopOpeBRepDS_HDataStructure, MspON: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State, i1: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId, spON: TopoDS_Shape): Standard_Boolean;
  static GetConfig(HDS: Handle_TopOpeBRepDS_HDataStructure, MEspON: TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State, ie: Graphic3d_ZLayerId, iesd: Graphic3d_ZLayerId, conf: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepDS_FaceInterferenceTool {
  constructor(P: TopOpeBRepDS_PDataStructure)
  Init(FI: TopoDS_Shape, E: TopoDS_Shape, Eisnew: Standard_Boolean, I: Handle_TopOpeBRepDS_Interference): void;
  Add_1(FI: TopoDS_Shape, F: TopoDS_Shape, E: TopoDS_Shape, Eisnew: Standard_Boolean, I: Handle_TopOpeBRepDS_Interference): void;
  Add_2(E: TopoDS_Shape, C: TopOpeBRepDS_Curve, I: Handle_TopOpeBRepDS_Interference): void;
  SetEdgePntPar(P: gp_Pnt, par: Quantity_AbsorbedDose): void;
  GetEdgePntPar(P: gp_Pnt, par: Quantity_AbsorbedDose): void;
  IsEdgePntParDef(): Standard_Boolean;
  Transition(I: Handle_TopOpeBRepDS_Interference): void;
  delete(): void;
}

export declare class TopOpeBRepDS_SurfaceData extends TopOpeBRepDS_GeometryData {
  delete(): void;
}

  export declare class TopOpeBRepDS_SurfaceData_1 extends TopOpeBRepDS_SurfaceData {
    constructor();
  }

  export declare class TopOpeBRepDS_SurfaceData_2 extends TopOpeBRepDS_SurfaceData {
    constructor(S: TopOpeBRepDS_Surface);
  }

export declare class TopOpeBRepDS_ListOfShapeOn1State {
  constructor()
  ListOnState(): TopTools_ListOfShape;
  ChangeListOnState(): TopTools_ListOfShape;
  IsSplit(): Standard_Boolean;
  Split(B: Standard_Boolean): void;
  Clear(): void;
  delete(): void;
}

export declare class TopOpeBRepDS_SurfaceIterator extends TopOpeBRepDS_InterferenceIterator {
  constructor(L: TopOpeBRepDS_ListOfInterference)
  Current(): Graphic3d_ZLayerId;
  Orientation(S: TopAbs_State): TopAbs_Orientation;
  delete(): void;
}

export declare class TopOpeBRepDS_InterferenceIterator {
  Init(L: TopOpeBRepDS_ListOfInterference): void;
  GeometryKind(GK: TopOpeBRepDS_Kind): void;
  Geometry(G: Graphic3d_ZLayerId): void;
  SupportKind(ST: TopOpeBRepDS_Kind): void;
  Support(S: Graphic3d_ZLayerId): void;
  Match(): void;
  MatchInterference(I: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_TopOpeBRepDS_Interference;
  ChangeIterator(): TopOpeBRepDS_ListIteratorOfListOfInterference;
  delete(): void;
}

  export declare class TopOpeBRepDS_InterferenceIterator_1 extends TopOpeBRepDS_InterferenceIterator {
    constructor();
  }

  export declare class TopOpeBRepDS_InterferenceIterator_2 extends TopOpeBRepDS_InterferenceIterator {
    constructor(L: TopOpeBRepDS_ListOfInterference);
  }

export declare class Handle_XmlXCAFDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlXCAFDrivers_DocumentStorageDriver): void;
  get(): XmlXCAFDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_XmlXCAFDrivers_DocumentStorageDriver_1 extends Handle_XmlXCAFDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_XmlXCAFDrivers_DocumentStorageDriver_2 extends Handle_XmlXCAFDrivers_DocumentStorageDriver {
    constructor(thePtr: XmlXCAFDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlXCAFDrivers_DocumentStorageDriver_3 extends Handle_XmlXCAFDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlXCAFDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlXCAFDrivers_DocumentStorageDriver_4 extends Handle_XmlXCAFDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlXCAFDrivers_DocumentStorageDriver);
  }

export declare class XmlXCAFDrivers_DocumentStorageDriver extends XmlDrivers_DocumentStorageDriver {
  constructor(theCopyright: TCollection_ExtendedString)
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlXCAFDrivers {
  constructor();
  static Factory(aGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  delete(): void;
}

export declare class Handle_XmlXCAFDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlXCAFDrivers_DocumentRetrievalDriver): void;
  get(): XmlXCAFDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_XmlXCAFDrivers_DocumentRetrievalDriver_1 extends Handle_XmlXCAFDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_XmlXCAFDrivers_DocumentRetrievalDriver_2 extends Handle_XmlXCAFDrivers_DocumentRetrievalDriver {
    constructor(thePtr: XmlXCAFDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlXCAFDrivers_DocumentRetrievalDriver_3 extends Handle_XmlXCAFDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlXCAFDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlXCAFDrivers_DocumentRetrievalDriver_4 extends Handle_XmlXCAFDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlXCAFDrivers_DocumentRetrievalDriver);
  }

export declare class XmlXCAFDrivers_DocumentRetrievalDriver extends XmlDrivers_DocumentRetrievalDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDocStd_XLinkDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDocStd_XLinkDriver): void;
  get(): XmlMDocStd_XLinkDriver;
  delete(): void;
}

  export declare class Handle_XmlMDocStd_XLinkDriver_1 extends Handle_XmlMDocStd_XLinkDriver {
    constructor();
  }

  export declare class Handle_XmlMDocStd_XLinkDriver_2 extends Handle_XmlMDocStd_XLinkDriver {
    constructor(thePtr: XmlMDocStd_XLinkDriver);
  }

  export declare class Handle_XmlMDocStd_XLinkDriver_3 extends Handle_XmlMDocStd_XLinkDriver {
    constructor(theHandle: Handle_XmlMDocStd_XLinkDriver);
  }

  export declare class Handle_XmlMDocStd_XLinkDriver_4 extends Handle_XmlMDocStd_XLinkDriver {
    constructor(theHandle: Handle_XmlMDocStd_XLinkDriver);
  }

export declare class XmlMDocStd_XLinkDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDocStd {
  constructor();
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, theMessageDriver: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class ElSLib {
  constructor();
  static Value_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pl: gp_Pln): gp_Pnt;
  static Value_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cone): gp_Pnt;
  static Value_3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cylinder): gp_Pnt;
  static Value_4(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, S: gp_Sphere): gp_Pnt;
  static Value_5(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Torus): gp_Pnt;
  static DN_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pl: gp_Pln, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static DN_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cone, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static DN_3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cylinder, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static DN_4(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, S: gp_Sphere, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static DN_5(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Torus, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static D0_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pl: gp_Pln, P: gp_Pnt): void;
  static D0_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cone, P: gp_Pnt): void;
  static D0_3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cylinder, P: gp_Pnt): void;
  static D0_4(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, S: gp_Sphere, P: gp_Pnt): void;
  static D0_5(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Torus, P: gp_Pnt): void;
  static D1_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pl: gp_Pln, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static D1_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cone, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static D1_3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cylinder, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static D1_4(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, S: gp_Sphere, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static D1_5(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Torus, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static D2_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cone, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static D2_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cylinder, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static D2_3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, S: gp_Sphere, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static D2_4(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Torus, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static D3_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cone, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static D3_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, C: gp_Cylinder, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static D3_3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, S: gp_Sphere, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static D3_4(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Torus, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static PlaneValue(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3): gp_Pnt;
  static CylinderValue(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose): gp_Pnt;
  static ConeValue(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose): gp_Pnt;
  static SphereValue(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose): gp_Pnt;
  static TorusValue(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose): gp_Pnt;
  static PlaneDN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static CylinderDN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static ConeDN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static SphereDN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static TorusDN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static PlaneD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, P: gp_Pnt): void;
  static ConeD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static CylinderD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static SphereD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static TorusD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static PlaneD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static ConeD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static CylinderD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static SphereD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static TorusD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static ConeD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static CylinderD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static SphereD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static TorusD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static ConeD3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static CylinderD3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static SphereD3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static TorusD3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static Parameters_1(Pl: gp_Pln, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static Parameters_2(C: gp_Cylinder, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static Parameters_3(C: gp_Cone, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static Parameters_4(S: gp_Sphere, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static Parameters_5(T: gp_Torus, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static PlaneParameters(Pos: gp_Ax3, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static CylinderParameters(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static ConeParameters(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static SphereParameters(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static TorusParameters(Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static PlaneUIso(Pos: gp_Ax3, U: Quantity_AbsorbedDose): gp_Lin;
  static CylinderUIso(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): gp_Lin;
  static ConeUIso(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): gp_Lin;
  static SphereUIso(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): gp_Circ;
  static TorusUIso(Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): gp_Circ;
  static PlaneVIso(Pos: gp_Ax3, V: Quantity_AbsorbedDose): gp_Lin;
  static CylinderVIso(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Circ;
  static ConeVIso(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, SAngle: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Circ;
  static SphereVIso(Pos: gp_Ax3, Radius: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Circ;
  static TorusVIso(Pos: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Circ;
  delete(): void;
}

export declare class CSLib_NormalPolyDef extends math_FunctionWithDerivative {
  constructor(k0: Graphic3d_ZLayerId, li: TColStd_Array1OfReal)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare type CSLib_NormalStatus = {
  CSLib_Singular: {};
  CSLib_Defined: {};
  CSLib_InfinityOfSolutions: {};
  CSLib_D1NuIsNull: {};
  CSLib_D1NvIsNull: {};
  CSLib_D1NIsNull: {};
  CSLib_D1NuNvRatioIsNull: {};
  CSLib_D1NvNuRatioIsNull: {};
  CSLib_D1NuIsParallelD1Nv: {};
}

export declare class CSLib {
  constructor();
  static Normal_1(D1U: gp_Vec, D1V: gp_Vec, SinTol: Quantity_AbsorbedDose, theStatus: CSLib_DerivativeStatus, Normal: gp_Dir): void;
  static Normal_2(D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, SinTol: Quantity_AbsorbedDose, Done: Standard_Boolean, theStatus: CSLib_NormalStatus, Normal: gp_Dir): void;
  static Normal_3(D1U: gp_Vec, D1V: gp_Vec, MagTol: Quantity_AbsorbedDose, theStatus: CSLib_NormalStatus, Normal: gp_Dir): void;
  static Normal_4(MaxOrder: Graphic3d_ZLayerId, DerNUV: TColgp_Array2OfVec, MagTol: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose, theStatus: CSLib_NormalStatus, Normal: gp_Dir, OrderU: Graphic3d_ZLayerId, OrderV: Graphic3d_ZLayerId): void;
  static DNNUV_1(Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId, DerSurf: TColgp_Array2OfVec): gp_Vec;
  static DNNUV_2(Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId, DerSurf1: TColgp_Array2OfVec, DerSurf2: TColgp_Array2OfVec): gp_Vec;
  static DNNormal(Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId, DerNUV: TColgp_Array2OfVec, Iduref: Graphic3d_ZLayerId, Idvref: Graphic3d_ZLayerId): gp_Vec;
  delete(): void;
}

export declare type CSLib_DerivativeStatus = {
  CSLib_Done: {};
  CSLib_D1uIsNull: {};
  CSLib_D1vIsNull: {};
  CSLib_D1IsNull: {};
  CSLib_D1uD1vRatioIsNull: {};
  CSLib_D1vD1uRatioIsNull: {};
  CSLib_D1uIsParallelD1v: {};
}

export declare class CSLib_Class2d {
  SiDans(P: gp_Pnt2d): Graphic3d_ZLayerId;
  SiDans_OnMode(P: gp_Pnt2d, Tol: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  InternalSiDans(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  InternalSiDansOuOn(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class CSLib_Class2d_1 extends CSLib_Class2d {
    constructor(thePnts2d: TColgp_Array1OfPnt2d, theTolU: Quantity_AbsorbedDose, theTolV: Quantity_AbsorbedDose, theUMin: Quantity_AbsorbedDose, theVMin: Quantity_AbsorbedDose, theUMax: Quantity_AbsorbedDose, theVMax: Quantity_AbsorbedDose);
  }

  export declare class CSLib_Class2d_2 extends CSLib_Class2d {
    constructor(thePnts2d: TColgp_SequenceOfPnt2d, theTolU: Quantity_AbsorbedDose, theTolV: Quantity_AbsorbedDose, theUMin: Quantity_AbsorbedDose, theVMin: Quantity_AbsorbedDose, theUMax: Quantity_AbsorbedDose, theVMax: Quantity_AbsorbedDose);
  }

export declare class XmlObjMgt_RRelocationTable extends TColStd_DataMapOfIntegerTransient {
  constructor();
  GetHeaderData(): Handle_Storage_HeaderData;
  SetHeaderData(theHeaderData: Handle_Storage_HeaderData): void;
  Clear(doReleaseMemory: Standard_Boolean): void;
  delete(): void;
}

export declare class XmlObjMgt_SRelocationTable extends TColStd_IndexedMapOfTransient {
  constructor();
  GetHeaderData(): Handle_Storage_HeaderData;
  SetHeaderData(theHeaderData: Handle_Storage_HeaderData): void;
  Clear(doReleaseMemory: Standard_Boolean): void;
  delete(): void;
}

export declare class XmlObjMgt_Array1 {
  CreateArrayElement(theParent: XmlObjMgt_Element, theName: XmlObjMgt_DOMString): void;
  Element(): XmlObjMgt_Element;
  Length(): Graphic3d_ZLayerId;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  SetValue(Index: Graphic3d_ZLayerId, Value: XmlObjMgt_Element): void;
  Value(Index: Graphic3d_ZLayerId): XmlObjMgt_Element;
  delete(): void;
}

  export declare class XmlObjMgt_Array1_1 extends XmlObjMgt_Array1 {
    constructor(Low: Graphic3d_ZLayerId, Up: Graphic3d_ZLayerId);
  }

  export declare class XmlObjMgt_Array1_2 extends XmlObjMgt_Array1 {
    constructor(theParent: XmlObjMgt_Element, theName: XmlObjMgt_DOMString);
  }

export declare class XmlObjMgt {
  constructor();
  static IdString(): XmlObjMgt_DOMString;
  static SetExtendedString(theElement: XmlObjMgt_Element, theString: TCollection_ExtendedString): Standard_Boolean;
  static GetExtendedString(theElement: XmlObjMgt_Element, theString: TCollection_ExtendedString): Standard_Boolean;
  static GetStringValue(theElement: XmlObjMgt_Element): XmlObjMgt_DOMString;
  static SetStringValue(theElement: XmlObjMgt_Element, theData: XmlObjMgt_DOMString, isClearText: Standard_Boolean): void;
  static GetTagEntryString(theTarget: XmlObjMgt_DOMString, theTagEntry: XCAFDoc_PartId): Standard_Boolean;
  static SetTagEntryString(theSource: XmlObjMgt_DOMString, theTagEntry: XCAFDoc_PartId): void;
  static FindChildElement(theSource: XmlObjMgt_Element, theObjId: Graphic3d_ZLayerId): XmlObjMgt_Element;
  static FindChildByRef(theSource: XmlObjMgt_Element, theRefName: XmlObjMgt_DOMString): XmlObjMgt_Element;
  static FindChildByName(theSource: XmlObjMgt_Element, theName: XmlObjMgt_DOMString): XmlObjMgt_Element;
  delete(): void;
}

export declare class XmlObjMgt_Persistent {
  CreateElement(theParent: XmlObjMgt_Element, theType: XmlObjMgt_DOMString, theID: Graphic3d_ZLayerId): void;
  SetId(theId: Graphic3d_ZLayerId): void;
  Element_1(): XmlObjMgt_Element;
  Element_2(): XmlObjMgt_Element;
  Id(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class XmlObjMgt_Persistent_1 extends XmlObjMgt_Persistent {
    constructor();
  }

  export declare class XmlObjMgt_Persistent_2 extends XmlObjMgt_Persistent {
    constructor(theElement: XmlObjMgt_Element);
  }

  export declare class XmlObjMgt_Persistent_3 extends XmlObjMgt_Persistent {
    constructor(theElement: XmlObjMgt_Element, theRef: XmlObjMgt_DOMString);
  }

export declare class XmlObjMgt_GP {
  constructor();
  static Translate_1(aTrsf: gp_Trsf): XmlObjMgt_DOMString;
  static Translate_2(aMat: gp_Mat): XmlObjMgt_DOMString;
  static Translate_3(anXYZ: gp_XYZ): XmlObjMgt_DOMString;
  static Translate_4(aStr: XmlObjMgt_DOMString, T: gp_Trsf): Standard_Boolean;
  static Translate_5(aStr: XmlObjMgt_DOMString, T: gp_Mat): Standard_Boolean;
  static Translate_6(aStr: XmlObjMgt_DOMString, T: gp_XYZ): Standard_Boolean;
  delete(): void;
}

export declare class Graphic3d_Texture1D extends Graphic3d_TextureMap {
  Name(): Graphic3d_NameOfTexture1D;
  static NumberOfTextures(): Graphic3d_ZLayerId;
  static TextureName(aRank: Graphic3d_ZLayerId): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Graphic3d_Texture1D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Texture1D): void;
  get(): Graphic3d_Texture1D;
  delete(): void;
}

  export declare class Handle_Graphic3d_Texture1D_1 extends Handle_Graphic3d_Texture1D {
    constructor();
  }

  export declare class Handle_Graphic3d_Texture1D_2 extends Handle_Graphic3d_Texture1D {
    constructor(thePtr: Graphic3d_Texture1D);
  }

  export declare class Handle_Graphic3d_Texture1D_3 extends Handle_Graphic3d_Texture1D {
    constructor(theHandle: Handle_Graphic3d_Texture1D);
  }

  export declare class Handle_Graphic3d_Texture1D_4 extends Handle_Graphic3d_Texture1D {
    constructor(theHandle: Handle_Graphic3d_Texture1D);
  }

export declare class Graphic3d_BvhCStructureSetTrsfPers {
  constructor(theBuilder: any)
  Size(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Graphic3d_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  Add(theStruct: Graphic3d_CStructure): Standard_Boolean;
  Remove(theStruct: Graphic3d_CStructure): Standard_Boolean;
  Clear(): void;
  GetStructureById(theId: Graphic3d_ZLayerId): Graphic3d_CStructure;
  Structures(): any;
  MarkDirty(): void;
  BVH(theCamera: Handle_Graphic3d_Camera, theProjectionMatrix: OpenGl_Mat4d, theWorldViewMatrix: OpenGl_Mat4d, theViewportWidth: Graphic3d_ZLayerId, theViewportHeight: Graphic3d_ZLayerId, theWVPState: Graphic3d_WorldViewProjState): any;
  Builder(): any;
  SetBuilder(theBuilder: any): void;
  delete(): void;
}

export declare class Handle_Graphic3d_GroupDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_GroupDefinitionError): void;
  get(): Graphic3d_GroupDefinitionError;
  delete(): void;
}

  export declare class Handle_Graphic3d_GroupDefinitionError_1 extends Handle_Graphic3d_GroupDefinitionError {
    constructor();
  }

  export declare class Handle_Graphic3d_GroupDefinitionError_2 extends Handle_Graphic3d_GroupDefinitionError {
    constructor(thePtr: Graphic3d_GroupDefinitionError);
  }

  export declare class Handle_Graphic3d_GroupDefinitionError_3 extends Handle_Graphic3d_GroupDefinitionError {
    constructor(theHandle: Handle_Graphic3d_GroupDefinitionError);
  }

  export declare class Handle_Graphic3d_GroupDefinitionError_4 extends Handle_Graphic3d_GroupDefinitionError {
    constructor(theHandle: Handle_Graphic3d_GroupDefinitionError);
  }

export declare class Graphic3d_GroupDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Graphic3d_GroupDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_GroupDefinitionError_1 extends Graphic3d_GroupDefinitionError {
    constructor();
  }

  export declare class Graphic3d_GroupDefinitionError_2 extends Graphic3d_GroupDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Graphic3d_FrameStatsDataTmp extends Graphic3d_FrameStatsData {
  constructor()
  FlushTimers(theNbFrames: Standard_ThreadId, theIsFinal: Standard_Boolean): void;
  Reset(): void;
  ChangeFrameRate(): Quantity_AbsorbedDose;
  ChangeFrameRateCpu(): Quantity_AbsorbedDose;
  ChangeImmediateFrameRate(): Quantity_AbsorbedDose;
  ChangeImmediateFrameRateCpu(): Quantity_AbsorbedDose;
  ChangeTimer(theTimer: Graphic3d_FrameStatsTimer): OSD_Timer;
  ChangeCounterValue(theIndex: Graphic3d_FrameStatsCounter): Standard_ThreadId;
  ChangeTimerValue(theIndex: Graphic3d_FrameStatsTimer): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Graphic3d_FrameStatsData {
  constructor()
  FrameRate(): Quantity_AbsorbedDose;
  FrameRateCpu(): Quantity_AbsorbedDose;
  ImmediateFrameRate(): Quantity_AbsorbedDose;
  ImmediateFrameRateCpu(): Quantity_AbsorbedDose;
  CounterValue(theIndex: Graphic3d_FrameStatsCounter): Standard_ThreadId;
  TimerValue(theIndex: Graphic3d_FrameStatsTimer): Quantity_AbsorbedDose;
  Reset(): void;
  FillMax(theOther: Graphic3d_FrameStatsData): void;
  delete(): void;
}

export declare class Graphic3d_Texture1Dsegment extends Graphic3d_Texture1D {
  SetSegment(theX1: Standard_ShortReal, theY1: Standard_ShortReal, theZ1: Standard_ShortReal, theX2: Standard_ShortReal, theY2: Standard_ShortReal, theZ2: Standard_ShortReal): void;
  Segment(theX1: Standard_ShortReal, theY1: Standard_ShortReal, theZ1: Standard_ShortReal, theX2: Standard_ShortReal, theY2: Standard_ShortReal, theZ2: Standard_ShortReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_Texture1Dsegment_1 extends Graphic3d_Texture1Dsegment {
    constructor(theFileName: XCAFDoc_PartId);
  }

  export declare class Graphic3d_Texture1Dsegment_2 extends Graphic3d_Texture1Dsegment {
    constructor(theNOT: Graphic3d_NameOfTexture1D);
  }

  export declare class Graphic3d_Texture1Dsegment_3 extends Graphic3d_Texture1Dsegment {
    constructor(thePixMap: Handle_Image_PixMap);
  }

export declare class Handle_Graphic3d_Texture1Dsegment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Texture1Dsegment): void;
  get(): Graphic3d_Texture1Dsegment;
  delete(): void;
}

  export declare class Handle_Graphic3d_Texture1Dsegment_1 extends Handle_Graphic3d_Texture1Dsegment {
    constructor();
  }

  export declare class Handle_Graphic3d_Texture1Dsegment_2 extends Handle_Graphic3d_Texture1Dsegment {
    constructor(thePtr: Graphic3d_Texture1Dsegment);
  }

  export declare class Handle_Graphic3d_Texture1Dsegment_3 extends Handle_Graphic3d_Texture1Dsegment {
    constructor(theHandle: Handle_Graphic3d_Texture1Dsegment);
  }

  export declare class Handle_Graphic3d_Texture1Dsegment_4 extends Handle_Graphic3d_Texture1Dsegment {
    constructor(theHandle: Handle_Graphic3d_Texture1Dsegment);
  }

export declare type Graphic3d_TypeOfConnection = {
  Graphic3d_TOC_ANCESTOR: {};
  Graphic3d_TOC_DESCENDANT: {};
}

export declare type Graphic3d_RenderingMode = {
  Graphic3d_RM_RASTERIZATION: {};
  Graphic3d_RM_RAYTRACING: {};
}

export declare class Handle_Graphic3d_ArrayOfSegments {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfSegments): void;
  get(): Graphic3d_ArrayOfSegments;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfSegments_1 extends Handle_Graphic3d_ArrayOfSegments {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfSegments_2 extends Handle_Graphic3d_ArrayOfSegments {
    constructor(thePtr: Graphic3d_ArrayOfSegments);
  }

  export declare class Handle_Graphic3d_ArrayOfSegments_3 extends Handle_Graphic3d_ArrayOfSegments {
    constructor(theHandle: Handle_Graphic3d_ArrayOfSegments);
  }

  export declare class Handle_Graphic3d_ArrayOfSegments_4 extends Handle_Graphic3d_ArrayOfSegments {
    constructor(theHandle: Handle_Graphic3d_ArrayOfSegments);
  }

export declare class Graphic3d_ArrayOfSegments extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfSegments_1 extends Graphic3d_ArrayOfSegments {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfSegments_2 extends Graphic3d_ArrayOfSegments {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theHasVColors: Standard_Boolean);
  }

export declare class Graphic3d_LightSet extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  Value(theIndex: Graphic3d_ZLayerId): Handle_Graphic3d_CLight;
  Contains(theLight: Handle_Graphic3d_CLight): Standard_Boolean;
  Add(theLight: Handle_Graphic3d_CLight): Standard_Boolean;
  Remove(theLight: Handle_Graphic3d_CLight): Standard_Boolean;
  NbLightsOfType(theType: V3d_TypeOfLight): Graphic3d_ZLayerId;
  UpdateRevision(): Standard_ThreadId;
  Revision(): Standard_ThreadId;
  NbEnabled(): Graphic3d_ZLayerId;
  NbEnabledLightsOfType(theType: V3d_TypeOfLight): Graphic3d_ZLayerId;
  AmbientColor(): OpenGl_Vec4;
  KeyEnabledLong(): XCAFDoc_PartId;
  KeyEnabledShort(): XCAFDoc_PartId;
  delete(): void;
}

export declare class Handle_Graphic3d_LightSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_LightSet): void;
  get(): Graphic3d_LightSet;
  delete(): void;
}

  export declare class Handle_Graphic3d_LightSet_1 extends Handle_Graphic3d_LightSet {
    constructor();
  }

  export declare class Handle_Graphic3d_LightSet_2 extends Handle_Graphic3d_LightSet {
    constructor(thePtr: Graphic3d_LightSet);
  }

  export declare class Handle_Graphic3d_LightSet_3 extends Handle_Graphic3d_LightSet {
    constructor(theHandle: Handle_Graphic3d_LightSet);
  }

  export declare class Handle_Graphic3d_LightSet_4 extends Handle_Graphic3d_LightSet {
    constructor(theHandle: Handle_Graphic3d_LightSet);
  }

export declare class Handle_Graphic3d_Texture2Dmanual {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Texture2Dmanual): void;
  get(): Graphic3d_Texture2Dmanual;
  delete(): void;
}

  export declare class Handle_Graphic3d_Texture2Dmanual_1 extends Handle_Graphic3d_Texture2Dmanual {
    constructor();
  }

  export declare class Handle_Graphic3d_Texture2Dmanual_2 extends Handle_Graphic3d_Texture2Dmanual {
    constructor(thePtr: Graphic3d_Texture2Dmanual);
  }

  export declare class Handle_Graphic3d_Texture2Dmanual_3 extends Handle_Graphic3d_Texture2Dmanual {
    constructor(theHandle: Handle_Graphic3d_Texture2Dmanual);
  }

  export declare class Handle_Graphic3d_Texture2Dmanual_4 extends Handle_Graphic3d_Texture2Dmanual {
    constructor(theHandle: Handle_Graphic3d_Texture2Dmanual);
  }

export declare class Graphic3d_Texture2Dmanual extends Graphic3d_Texture2D {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_Texture2Dmanual_1 extends Graphic3d_Texture2Dmanual {
    constructor(theFileName: XCAFDoc_PartId);
  }

  export declare class Graphic3d_Texture2Dmanual_2 extends Graphic3d_Texture2Dmanual {
    constructor(theNOT: Graphic3d_NameOfTexture2D);
  }

  export declare class Graphic3d_Texture2Dmanual_3 extends Graphic3d_Texture2Dmanual {
    constructor(thePixMap: Handle_Image_PixMap);
  }

export declare class Graphic3d_PresentationAttributes extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Method(): Aspect_TypeOfHighlightMethod;
  SetMethod(theMethod: Aspect_TypeOfHighlightMethod): void;
  ColorRGBA(): Quantity_ColorRGBA;
  Color(): Quantity_Color;
  SetColor(theColor: Quantity_Color): void;
  Transparency(): Standard_ShortReal;
  SetTransparency(theTranspCoef: Standard_ShortReal): void;
  ZLayer(): Graphic3d_ZLayerId;
  SetZLayer(theLayer: Graphic3d_ZLayerId): void;
  DisplayMode(): Graphic3d_ZLayerId;
  SetDisplayMode(theMode: Graphic3d_ZLayerId): void;
  BasicFillAreaAspect(): Handle_Graphic3d_AspectFillArea3d;
  SetBasicFillAreaAspect(theAspect: Handle_Graphic3d_AspectFillArea3d): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Graphic3d_PresentationAttributes {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_PresentationAttributes): void;
  get(): Graphic3d_PresentationAttributes;
  delete(): void;
}

  export declare class Handle_Graphic3d_PresentationAttributes_1 extends Handle_Graphic3d_PresentationAttributes {
    constructor();
  }

  export declare class Handle_Graphic3d_PresentationAttributes_2 extends Handle_Graphic3d_PresentationAttributes {
    constructor(thePtr: Graphic3d_PresentationAttributes);
  }

  export declare class Handle_Graphic3d_PresentationAttributes_3 extends Handle_Graphic3d_PresentationAttributes {
    constructor(theHandle: Handle_Graphic3d_PresentationAttributes);
  }

  export declare class Handle_Graphic3d_PresentationAttributes_4 extends Handle_Graphic3d_PresentationAttributes {
    constructor(theHandle: Handle_Graphic3d_PresentationAttributes);
  }

export declare class Graphic3d_ClipPlane extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetEquation_1(thePlane: gp_Pln): void;
  SetEquation_2(theEquation: OpenGl_Vec4d): void;
  GetEquation(): OpenGl_Vec4d;
  ReversedEquation(): OpenGl_Vec4d;
  IsOn(): Standard_Boolean;
  SetOn(theIsOn: Standard_Boolean): void;
  SetCapping(theIsOn: Standard_Boolean): void;
  IsCapping(): Standard_Boolean;
  ToPlane(): gp_Pln;
  Clone(): Handle_Graphic3d_ClipPlane;
  IsChain(): Standard_Boolean;
  ChainPreviousPlane(): Handle_Graphic3d_ClipPlane;
  ChainNextPlane(): Handle_Graphic3d_ClipPlane;
  NbChainNextPlanes(): Graphic3d_ZLayerId;
  SetChainNextPlane(thePlane: Handle_Graphic3d_ClipPlane): void;
  CappingColor(): Quantity_Color;
  SetCappingColor(theColor: Quantity_Color): void;
  SetCappingMaterial(theMat: Graphic3d_MaterialAspect): void;
  CappingMaterial(): Graphic3d_MaterialAspect;
  SetCappingTexture(theTexture: Handle_Graphic3d_TextureMap): void;
  CappingTexture(): Handle_Graphic3d_TextureMap;
  SetCappingHatch(theStyle: Aspect_HatchStyle): void;
  CappingHatch(): Aspect_HatchStyle;
  SetCappingCustomHatch(theStyle: Handle_Graphic3d_HatchStyle): void;
  CappingCustomHatch(): Handle_Graphic3d_HatchStyle;
  SetCappingHatchOn(): void;
  SetCappingHatchOff(): void;
  IsHatchOn(): Standard_Boolean;
  GetId(): XCAFDoc_PartId;
  CappingAspect(): Handle_Graphic3d_AspectFillArea3d;
  SetCappingAspect(theAspect: Handle_Graphic3d_AspectFillArea3d): void;
  ToUseObjectMaterial(): Standard_Boolean;
  SetUseObjectMaterial(theToUse: Standard_Boolean): void;
  ToUseObjectTexture(): Standard_Boolean;
  SetUseObjectTexture(theToUse: Standard_Boolean): void;
  ToUseObjectShader(): Standard_Boolean;
  SetUseObjectShader(theToUse: Standard_Boolean): void;
  ToUseObjectProperties(): Standard_Boolean;
  ProbePoint(thePoint: OpenGl_Vec4d): Graphic3d_ClipState;
  ProbeBox(theBox: Graphic3d_BndBox3d): Graphic3d_ClipState;
  ProbeBoxTouch(theBox: Graphic3d_BndBox3d): Standard_Boolean;
  ProbePointHalfspace(thePoint: OpenGl_Vec4d): Graphic3d_ClipState;
  ProbeBoxHalfspace(theBox: Graphic3d_BndBox3d): Graphic3d_ClipState;
  IsPointOutHalfspace(thePoint: OpenGl_Vec4d): Standard_Boolean;
  IsBoxFullOutHalfspace(theBox: Graphic3d_BndBox3d): Standard_Boolean;
  ProbeBoxMaxPointHalfspace(theBox: Graphic3d_BndBox3d): Graphic3d_ClipState;
  IsBoxFullInHalfspace(theBox: Graphic3d_BndBox3d): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  MCountEquation(): Aspect_VKeyFlags;
  MCountAspect(): Aspect_VKeyFlags;
  delete(): void;
}

  export declare class Graphic3d_ClipPlane_1 extends Graphic3d_ClipPlane {
    constructor();
  }

  export declare class Graphic3d_ClipPlane_2 extends Graphic3d_ClipPlane {
    constructor(theOther: Graphic3d_ClipPlane);
  }

  export declare class Graphic3d_ClipPlane_3 extends Graphic3d_ClipPlane {
    constructor(theEquation: OpenGl_Vec4d);
  }

  export declare class Graphic3d_ClipPlane_4 extends Graphic3d_ClipPlane {
    constructor(thePlane: gp_Pln);
  }

export declare type Graphic3d_ClipState = {
  Graphic3d_ClipState_Out: {};
  Graphic3d_ClipState_In: {};
  Graphic3d_ClipState_On: {};
}

export declare class Handle_Graphic3d_ClipPlane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ClipPlane): void;
  get(): Graphic3d_ClipPlane;
  delete(): void;
}

  export declare class Handle_Graphic3d_ClipPlane_1 extends Handle_Graphic3d_ClipPlane {
    constructor();
  }

  export declare class Handle_Graphic3d_ClipPlane_2 extends Handle_Graphic3d_ClipPlane {
    constructor(thePtr: Graphic3d_ClipPlane);
  }

  export declare class Handle_Graphic3d_ClipPlane_3 extends Handle_Graphic3d_ClipPlane {
    constructor(theHandle: Handle_Graphic3d_ClipPlane);
  }

  export declare class Handle_Graphic3d_ClipPlane_4 extends Handle_Graphic3d_ClipPlane {
    constructor(theHandle: Handle_Graphic3d_ClipPlane);
  }

export declare type Graphic3d_TypeOfAnswer = {
  Graphic3d_TOA_YES: {};
  Graphic3d_TOA_NO: {};
  Graphic3d_TOA_COMPUTE: {};
}

export declare class Graphic3d_MaterialAspect {
  static NumberOfMaterials(): Graphic3d_ZLayerId;
  static MaterialName_1(theRank: Graphic3d_ZLayerId): Standard_CString;
  static MaterialType_1(theRank: Graphic3d_ZLayerId): Graphic3d_TypeOfMaterial;
  static MaterialFromName_1(theName: Standard_CString, theMat: Graphic3d_NameOfMaterial): Standard_Boolean;
  static MaterialFromName_2(theName: Standard_CString): Graphic3d_NameOfMaterial;
  Name(): Graphic3d_NameOfMaterial;
  RequestedName(): Graphic3d_NameOfMaterial;
  StringName(): XCAFDoc_PartId;
  MaterialName_2(): Standard_CString;
  SetMaterialName(theName: XCAFDoc_PartId): void;
  Reset(): void;
  Color(): Quantity_Color;
  SetColor(theColor: Quantity_Color): void;
  Transparency(): Standard_ShortReal;
  Alpha(): Standard_ShortReal;
  SetTransparency(theValue: Standard_ShortReal): void;
  SetAlpha(theValue: Standard_ShortReal): void;
  AmbientColor(): Quantity_Color;
  SetAmbientColor(theColor: Quantity_Color): void;
  DiffuseColor(): Quantity_Color;
  SetDiffuseColor(theColor: Quantity_Color): void;
  SpecularColor(): Quantity_Color;
  SetSpecularColor(theColor: Quantity_Color): void;
  EmissiveColor(): Quantity_Color;
  SetEmissiveColor(theColor: Quantity_Color): void;
  Shininess(): Standard_ShortReal;
  SetShininess(theValue: Standard_ShortReal): void;
  IncreaseShine(theDelta: Standard_ShortReal): void;
  RefractionIndex(): Standard_ShortReal;
  SetRefractionIndex(theValue: Standard_ShortReal): void;
  BSDF(): Graphic3d_BSDF;
  SetBSDF(theBSDF: Graphic3d_BSDF): void;
  PBRMaterial(): Graphic3d_PBRMaterial;
  SetPBRMaterial(thePBRMaterial: Graphic3d_PBRMaterial): void;
  ReflectionMode(theType: Graphic3d_TypeOfReflection): Standard_Boolean;
  MaterialType_2(): Graphic3d_TypeOfMaterial;
  MaterialType_3(theType: Graphic3d_TypeOfMaterial): Standard_Boolean;
  SetMaterialType(theType: Graphic3d_TypeOfMaterial): void;
  IsDifferent(theOther: Graphic3d_MaterialAspect): Standard_Boolean;
  IsEqual(theOther: Graphic3d_MaterialAspect): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  SetReflectionModeOff(theType: Graphic3d_TypeOfReflection): void;
  delete(): void;
}

  export declare class Graphic3d_MaterialAspect_1 extends Graphic3d_MaterialAspect {
    constructor();
  }

  export declare class Graphic3d_MaterialAspect_2 extends Graphic3d_MaterialAspect {
    constructor(theName: Graphic3d_NameOfMaterial);
  }

export declare class Handle_Graphic3d_Camera {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Camera): void;
  get(): Graphic3d_Camera;
  delete(): void;
}

  export declare class Handle_Graphic3d_Camera_1 extends Handle_Graphic3d_Camera {
    constructor();
  }

  export declare class Handle_Graphic3d_Camera_2 extends Handle_Graphic3d_Camera {
    constructor(thePtr: Graphic3d_Camera);
  }

  export declare class Handle_Graphic3d_Camera_3 extends Handle_Graphic3d_Camera {
    constructor(theHandle: Handle_Graphic3d_Camera);
  }

  export declare class Handle_Graphic3d_Camera_4 extends Handle_Graphic3d_Camera {
    constructor(theHandle: Handle_Graphic3d_Camera);
  }

export declare class Graphic3d_Camera extends Standard_Transient {
  CopyMappingData(theOtherCamera: Handle_Graphic3d_Camera): void;
  CopyOrientationData(theOtherCamera: Handle_Graphic3d_Camera): void;
  Copy(theOther: Handle_Graphic3d_Camera): void;
  Direction(): gp_Dir;
  SetDirectionFromEye(theDir: gp_Dir): void;
  SetDirection(theDir: gp_Dir): void;
  Up(): gp_Dir;
  SetUp(theUp: gp_Dir): void;
  OrthogonalizeUp(): void;
  OrthogonalizedUp(): gp_Dir;
  SideRight(): gp_Dir;
  Eye(): gp_Pnt;
  MoveEyeTo(theEye: gp_Pnt): void;
  SetEyeAndCenter(theEye: gp_Pnt, theCenter: gp_Pnt): void;
  SetEye(theEye: gp_Pnt): void;
  Center(): gp_Pnt;
  SetCenter(theCenter: gp_Pnt): void;
  Distance(): Quantity_AbsorbedDose;
  SetDistance(theDistance: Quantity_AbsorbedDose): void;
  Scale(): Quantity_AbsorbedDose;
  SetScale(theScale: Quantity_AbsorbedDose): void;
  AxialScale(): gp_XYZ;
  SetAxialScale(theAxialScale: gp_XYZ): void;
  SetProjectionType(theProjection: any): void;
  ProjectionType(): any;
  IsOrthographic(): Standard_Boolean;
  IsStereo(): Standard_Boolean;
  SetFOVy(theFOVy: Quantity_AbsorbedDose): void;
  FOVy(): Quantity_AbsorbedDose;
  FOVx(): Quantity_AbsorbedDose;
  FOV2d(): Quantity_AbsorbedDose;
  SetFOV2d(theFOV: Quantity_AbsorbedDose): void;
  ZFitAll_1(theScaleFactor: Quantity_AbsorbedDose, theMinMax: Bnd_Box, theGraphicBB: Bnd_Box, theZNear: Quantity_AbsorbedDose, theZFar: Quantity_AbsorbedDose): Standard_Boolean;
  ZFitAll_2(theScaleFactor: Quantity_AbsorbedDose, theMinMax: Bnd_Box, theGraphicBB: Bnd_Box): void;
  SetZRange(theZNear: Quantity_AbsorbedDose, theZFar: Quantity_AbsorbedDose): void;
  ZNear(): Quantity_AbsorbedDose;
  ZFar(): Quantity_AbsorbedDose;
  SetAspect(theAspect: Quantity_AbsorbedDose): void;
  Aspect(): Quantity_AbsorbedDose;
  SetZFocus(theType: any, theZFocus: Quantity_AbsorbedDose): void;
  ZFocus(): Quantity_AbsorbedDose;
  ZFocusType(): any;
  SetIOD(theType: any, theIOD: Quantity_AbsorbedDose): void;
  IOD(): Quantity_AbsorbedDose;
  GetIODType(): any;
  Tile(): Graphic3d_CameraTile;
  SetTile(theTile: Graphic3d_CameraTile): void;
  Transform(theTrsf: gp_Trsf): void;
  ViewDimensions_1(): gp_XYZ;
  ViewDimensions_2(theZValue: Quantity_AbsorbedDose): gp_XYZ;
  NDC2dOffsetX(): Quantity_AbsorbedDose;
  NDC2dOffsetY(): Quantity_AbsorbedDose;
  Frustum(theLeft: gp_Pln, theRight: gp_Pln, theBottom: gp_Pln, theTop: gp_Pln, theNear: gp_Pln, theFar: gp_Pln): void;
  Project(thePnt: gp_Pnt): gp_Pnt;
  UnProject(thePnt: gp_Pnt): gp_Pnt;
  ConvertView2Proj(thePnt: gp_Pnt): gp_Pnt;
  ConvertProj2View(thePnt: gp_Pnt): gp_Pnt;
  ConvertWorld2View(thePnt: gp_Pnt): gp_Pnt;
  ConvertView2World(thePnt: gp_Pnt): gp_Pnt;
  WorldViewProjState(): Graphic3d_WorldViewProjState;
  ProjectionState(): Standard_ThreadId;
  WorldViewState(): Standard_ThreadId;
  OrientationMatrix(): OpenGl_Mat4d;
  OrientationMatrixF(): OpenGl_Mat4;
  ProjectionMatrix(): OpenGl_Mat4d;
  ProjectionMatrixF(): OpenGl_Mat4;
  ProjectionStereoLeft(): OpenGl_Mat4d;
  ProjectionStereoLeftF(): OpenGl_Mat4;
  ProjectionStereoRight(): OpenGl_Mat4d;
  ProjectionStereoRightF(): OpenGl_Mat4;
  InvalidateProjection(): void;
  InvalidateOrientation(): void;
  StereoProjection(theProjL: OpenGl_Mat4d, theHeadToEyeL: OpenGl_Mat4d, theProjR: OpenGl_Mat4d, theHeadToEyeR: OpenGl_Mat4d): void;
  StereoProjectionF(theProjL: OpenGl_Mat4, theHeadToEyeL: OpenGl_Mat4, theProjR: OpenGl_Mat4, theHeadToEyeR: OpenGl_Mat4): void;
  ResetCustomProjection(): void;
  IsCustomStereoFrustum(): Standard_Boolean;
  SetCustomStereoFrustums(theFrustumL: Aspect_FrustumLRBT<Standard_Real>, theFrustumR: Aspect_FrustumLRBT<Standard_Real>): void;
  IsCustomStereoProjection(): Standard_Boolean;
  SetCustomStereoProjection(theProjL: OpenGl_Mat4d, theHeadToEyeL: OpenGl_Mat4d, theProjR: OpenGl_Mat4d, theHeadToEyeR: OpenGl_Mat4d): void;
  IsCustomMonoProjection(): Standard_Boolean;
  SetCustomMonoProjection(theProj: OpenGl_Mat4d): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  FrustumPoints(thePoints: NCollection_Array1<Graphic3d_Vec3d>, theModelWorld: OpenGl_Mat4d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_Camera_1 extends Graphic3d_Camera {
    constructor();
  }

  export declare class Graphic3d_Camera_2 extends Graphic3d_Camera {
    constructor(theOther: Handle_Graphic3d_Camera);
  }

export declare class Graphic3d_RenderingParams {
  constructor()
  ResolutionRatio(): Standard_ShortReal;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Graphic3d_BufferType = {
  Graphic3d_BT_RGB: {};
  Graphic3d_BT_RGBA: {};
  Graphic3d_BT_Depth: {};
  Graphic3d_BT_RGB_RayTraceHdrLeft: {};
  Graphic3d_BT_Red: {};
}

export declare type Graphic3d_HorizontalTextAlignment = {
  Graphic3d_HTA_LEFT: {};
  Graphic3d_HTA_CENTER: {};
  Graphic3d_HTA_RIGHT: {};
}

export declare type Graphic3d_TypeOfBackfacingModel = {
  Graphic3d_TOBM_AUTOMATIC: {};
  Graphic3d_TOBM_FORCE: {};
  Graphic3d_TOBM_DISABLE: {};
}

export declare class Graphic3d_Layer extends Standard_Transient {
  constructor(theId: Graphic3d_ZLayerId, theNbPriorities: Graphic3d_ZLayerId, theBuilder: any)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  LayerId(): Graphic3d_ZLayerId;
  FrustumCullingBVHBuilder(): any;
  SetFrustumCullingBVHBuilder(theBuilder: any): void;
  IsImmediate(): Standard_Boolean;
  LayerSettings(): Graphic3d_ZLayerSettings;
  SetLayerSettings(theSettings: Graphic3d_ZLayerSettings): void;
  Add(theStruct: Graphic3d_CStructure, thePriority: Graphic3d_ZLayerId, isForChangePriority: Standard_Boolean): void;
  Remove(theStruct: Graphic3d_CStructure, thePriority: Graphic3d_ZLayerId, isForChangePriority: Standard_Boolean): Standard_Boolean;
  NbStructures(): Graphic3d_ZLayerId;
  NbStructuresNotCulled(): Graphic3d_ZLayerId;
  NbPriorities(): Graphic3d_ZLayerId;
  Append(theOther: OpenGl_Layer): Standard_Boolean;
  ArrayOfStructures(): Graphic3d_ArrayOfIndexedMapOfStructure;
  InvalidateBVHData(): void;
  InvalidateBoundingBox(): void;
  BoundingBox(theViewId: Graphic3d_ZLayerId, theCamera: Handle_Graphic3d_Camera, theWindowWidth: Graphic3d_ZLayerId, theWindowHeight: Graphic3d_ZLayerId, theToIncludeAuxiliary: Standard_Boolean): Bnd_Box;
  considerZoomPersistenceObjects(theViewId: Graphic3d_ZLayerId, theCamera: Handle_Graphic3d_Camera, theWindowWidth: Graphic3d_ZLayerId, theWindowHeight: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  UpdateCulling(theViewId: Graphic3d_ZLayerId, theSelector: Graphic3d_CullingTool, theFrustumCullingState: any): void;
  IsCulled(): Standard_Boolean;
  NbOfTransformPersistenceObjects(): Graphic3d_ZLayerId;
  CullableStructuresBVH(): Graphic3d_BvhCStructureSet;
  CullableTrsfPersStructuresBVH(): Graphic3d_BvhCStructureSetTrsfPers;
  NonCullableStructures(): any;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_ArrayOfIndexedMapOfStructure {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Graphic3d_IndexedMapOfStructure): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Graphic3d_ArrayOfIndexedMapOfStructure): Graphic3d_ArrayOfIndexedMapOfStructure;
  Move(theOther: Graphic3d_ArrayOfIndexedMapOfStructure): Graphic3d_ArrayOfIndexedMapOfStructure;
  First(): Graphic3d_IndexedMapOfStructure;
  ChangeFirst(): Graphic3d_IndexedMapOfStructure;
  Last(): Graphic3d_IndexedMapOfStructure;
  ChangeLast(): Graphic3d_IndexedMapOfStructure;
  Value(theIndex: Standard_Integer): Graphic3d_IndexedMapOfStructure;
  ChangeValue(theIndex: Standard_Integer): Graphic3d_IndexedMapOfStructure;
  SetValue(theIndex: Standard_Integer, theItem: Graphic3d_IndexedMapOfStructure): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfIndexedMapOfStructure_1 extends Graphic3d_ArrayOfIndexedMapOfStructure {
    constructor();
  }

  export declare class Graphic3d_ArrayOfIndexedMapOfStructure_2 extends Graphic3d_ArrayOfIndexedMapOfStructure {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Graphic3d_ArrayOfIndexedMapOfStructure_3 extends Graphic3d_ArrayOfIndexedMapOfStructure {
    constructor(theOther: Graphic3d_ArrayOfIndexedMapOfStructure);
  }

  export declare class Graphic3d_ArrayOfIndexedMapOfStructure_4 extends Graphic3d_ArrayOfIndexedMapOfStructure {
    constructor(theOther: Graphic3d_ArrayOfIndexedMapOfStructure);
  }

  export declare class Graphic3d_ArrayOfIndexedMapOfStructure_5 extends Graphic3d_ArrayOfIndexedMapOfStructure {
    constructor(theBegin: Graphic3d_IndexedMapOfStructure, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_Graphic3d_TextureMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_TextureMap): void;
  get(): Graphic3d_TextureMap;
  delete(): void;
}

  export declare class Handle_Graphic3d_TextureMap_1 extends Handle_Graphic3d_TextureMap {
    constructor();
  }

  export declare class Handle_Graphic3d_TextureMap_2 extends Handle_Graphic3d_TextureMap {
    constructor(thePtr: Graphic3d_TextureMap);
  }

  export declare class Handle_Graphic3d_TextureMap_3 extends Handle_Graphic3d_TextureMap {
    constructor(theHandle: Handle_Graphic3d_TextureMap);
  }

  export declare class Handle_Graphic3d_TextureMap_4 extends Handle_Graphic3d_TextureMap {
    constructor(theHandle: Handle_Graphic3d_TextureMap);
  }

export declare class Graphic3d_TextureMap extends Graphic3d_TextureRoot {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  EnableSmooth(): void;
  IsSmoothed(): Standard_Boolean;
  DisableSmooth(): void;
  EnableModulate(): void;
  DisableModulate(): void;
  IsModulate(): Standard_Boolean;
  EnableRepeat(): void;
  DisableRepeat(): void;
  IsRepeat(): Standard_Boolean;
  AnisoFilter(): Graphic3d_LevelOfTextureAnisotropy;
  SetAnisoFilter(theLevel: Graphic3d_LevelOfTextureAnisotropy): void;
  delete(): void;
}

export declare type Graphic3d_NameOfTextureEnv = {
  Graphic3d_NOT_ENV_CLOUDS: {};
  Graphic3d_NOT_ENV_CV: {};
  Graphic3d_NOT_ENV_MEDIT: {};
  Graphic3d_NOT_ENV_PEARL: {};
  Graphic3d_NOT_ENV_SKY1: {};
  Graphic3d_NOT_ENV_SKY2: {};
  Graphic3d_NOT_ENV_LINES: {};
  Graphic3d_NOT_ENV_ROAD: {};
  Graphic3d_NOT_ENV_UNKNOWN: {};
}

export declare type Graphic3d_DiagnosticInfo = {
  Graphic3d_DiagnosticInfo_Device: {};
  Graphic3d_DiagnosticInfo_FrameBuffer: {};
  Graphic3d_DiagnosticInfo_Limits: {};
  Graphic3d_DiagnosticInfo_Memory: {};
  Graphic3d_DiagnosticInfo_NativePlatform: {};
  Graphic3d_DiagnosticInfo_Extensions: {};
  Graphic3d_DiagnosticInfo_Short: {};
  Graphic3d_DiagnosticInfo_Basic: {};
  Graphic3d_DiagnosticInfo_Complete: {};
}

export declare class Handle_Graphic3d_BoundBuffer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_BoundBuffer): void;
  get(): Graphic3d_BoundBuffer;
  delete(): void;
}

  export declare class Handle_Graphic3d_BoundBuffer_1 extends Handle_Graphic3d_BoundBuffer {
    constructor();
  }

  export declare class Handle_Graphic3d_BoundBuffer_2 extends Handle_Graphic3d_BoundBuffer {
    constructor(thePtr: Graphic3d_BoundBuffer);
  }

  export declare class Handle_Graphic3d_BoundBuffer_3 extends Handle_Graphic3d_BoundBuffer {
    constructor(theHandle: Handle_Graphic3d_BoundBuffer);
  }

  export declare class Handle_Graphic3d_BoundBuffer_4 extends Handle_Graphic3d_BoundBuffer {
    constructor(theHandle: Handle_Graphic3d_BoundBuffer);
  }

export declare class Graphic3d_BoundBuffer extends NCollection_Buffer {
  constructor(theAlloc: Handle_NCollection_BaseAllocator)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Init(theNbBounds: Graphic3d_ZLayerId, theHasColors: Standard_Boolean): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_FrameStats extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  UpdateInterval(): Quantity_AbsorbedDose;
  SetUpdateInterval(theInterval: Quantity_AbsorbedDose): void;
  IsLongLineFormat(): Standard_Boolean;
  SetLongLineFormat(theValue: Standard_Boolean): void;
  FrameStart(theView: Handle_Graphic3d_CView, theIsImmediateOnly: Standard_Boolean): void;
  FrameEnd(theView: Handle_Graphic3d_CView, theIsImmediateOnly: Standard_Boolean): void;
  FormatStats_1(theFlags: any): XCAFDoc_PartId;
  FormatStats_2(theDict: TColStd_IndexedDataMapOfStringString, theFlags: any): void;
  FrameDuration(): Quantity_AbsorbedDose;
  FrameRate(): Quantity_AbsorbedDose;
  FrameRateCpu(): Quantity_AbsorbedDose;
  CounterValue(theCounter: Graphic3d_FrameStatsCounter): Standard_ThreadId;
  TimerValue(theTimer: Graphic3d_FrameStatsTimer): Quantity_AbsorbedDose;
  HasCulledLayers(): Standard_Boolean;
  HasCulledStructs(): Standard_Boolean;
  LastDataFrame(): Graphic3d_FrameStatsData;
  LastDataFrameIndex(): Graphic3d_ZLayerId;
  DataFrames(): any;
  ChangeDataFrames(): any;
  ChangeCounter(theCounter: Graphic3d_FrameStatsCounter): Standard_ThreadId;
  ChangeTimer(theTimer: Graphic3d_FrameStatsTimer): Quantity_AbsorbedDose;
  ActiveDataFrame(): Graphic3d_FrameStatsDataTmp;
  delete(): void;
}

export declare class Graphic3d_MediaTexture extends Graphic3d_Texture2D {
  constructor(theMutex: any, thePlane: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetImage(theSupported: any): Handle_Image_PixMap;
  Frame(): any;
  SetFrame(theFrame: any): void;
  GenerateNewId(): void;
  delete(): void;
}

export declare class Graphic3d_CullingTool {
  constructor()
  SetViewVolume(theCamera: Handle_Graphic3d_Camera, theModelWorld: OpenGl_Mat4d): void;
  SetViewportSize(theViewportWidth: Graphic3d_ZLayerId, theViewportHeight: Graphic3d_ZLayerId, theResolutionRatio: Quantity_AbsorbedDose): void;
  SetCullingDistance(theCtx: any, theDistance: Quantity_AbsorbedDose): void;
  SetCullingSize(theCtx: any, theSize: Quantity_AbsorbedDose): void;
  CacheClipPtsProjections(): void;
  IsCulled(theCtx: any, theMinPnt: OpenGl_Vec3d, theMaxPnt: OpenGl_Vec3d, theIsInside: Standard_Boolean): Standard_Boolean;
  Camera(): Handle_Graphic3d_Camera;
  ProjectionMatrix(): OpenGl_Mat4d;
  WorldViewMatrix(): OpenGl_Mat4d;
  ViewportWidth(): Graphic3d_ZLayerId;
  ViewportHeight(): Graphic3d_ZLayerId;
  WorldViewProjState(): Graphic3d_WorldViewProjState;
  CameraEye(): OpenGl_Vec3d;
  CameraDirection(): OpenGl_Vec3d;
  SignedPlanePointDistance(theNormal: OpenGl_Vec4d, thePnt: OpenGl_Vec4d): Quantity_AbsorbedDose;
  IsOutFrustum(theMinPnt: OpenGl_Vec3d, theMaxPnt: OpenGl_Vec3d, theIsInside: Standard_Boolean): Standard_Boolean;
  IsTooDistant(theCtx: any, theMinPnt: OpenGl_Vec3d, theMaxPnt: OpenGl_Vec3d, theIsInside: Standard_Boolean): Standard_Boolean;
  IsTooSmall(theCtx: any, theMinPnt: OpenGl_Vec3d, theMaxPnt: OpenGl_Vec3d): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Graphic3d_CubeMapSeparate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_CubeMapSeparate): void;
  get(): Graphic3d_CubeMapSeparate;
  delete(): void;
}

  export declare class Handle_Graphic3d_CubeMapSeparate_1 extends Handle_Graphic3d_CubeMapSeparate {
    constructor();
  }

  export declare class Handle_Graphic3d_CubeMapSeparate_2 extends Handle_Graphic3d_CubeMapSeparate {
    constructor(thePtr: Graphic3d_CubeMapSeparate);
  }

  export declare class Handle_Graphic3d_CubeMapSeparate_3 extends Handle_Graphic3d_CubeMapSeparate {
    constructor(theHandle: Handle_Graphic3d_CubeMapSeparate);
  }

  export declare class Handle_Graphic3d_CubeMapSeparate_4 extends Handle_Graphic3d_CubeMapSeparate {
    constructor(theHandle: Handle_Graphic3d_CubeMapSeparate);
  }

export declare class Graphic3d_CubeMapSeparate extends Graphic3d_CubeMap {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  CompressedValue(theSupported: any): any;
  Value(theSupported: any): Handle_Image_PixMap;
  GetImage(a0: any): Handle_Image_PixMap;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class Graphic3d_CubeMapSeparate_1 extends Graphic3d_CubeMapSeparate {
    constructor(thePaths: TColStd_Array1OfAsciiString);
  }

  export declare class Graphic3d_CubeMapSeparate_2 extends Graphic3d_CubeMapSeparate {
    constructor(theImages: any);
  }

export declare class Graphic3d_MaterialDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Graphic3d_MaterialDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_MaterialDefinitionError_1 extends Graphic3d_MaterialDefinitionError {
    constructor();
  }

  export declare class Graphic3d_MaterialDefinitionError_2 extends Graphic3d_MaterialDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Graphic3d_MaterialDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_MaterialDefinitionError): void;
  get(): Graphic3d_MaterialDefinitionError;
  delete(): void;
}

  export declare class Handle_Graphic3d_MaterialDefinitionError_1 extends Handle_Graphic3d_MaterialDefinitionError {
    constructor();
  }

  export declare class Handle_Graphic3d_MaterialDefinitionError_2 extends Handle_Graphic3d_MaterialDefinitionError {
    constructor(thePtr: Graphic3d_MaterialDefinitionError);
  }

  export declare class Handle_Graphic3d_MaterialDefinitionError_3 extends Handle_Graphic3d_MaterialDefinitionError {
    constructor(theHandle: Handle_Graphic3d_MaterialDefinitionError);
  }

  export declare class Handle_Graphic3d_MaterialDefinitionError_4 extends Handle_Graphic3d_MaterialDefinitionError {
    constructor(theHandle: Handle_Graphic3d_MaterialDefinitionError);
  }

export declare type Graphic3d_TextureUnit = {
  Graphic3d_TextureUnit_0: {};
  Graphic3d_TextureUnit_1: {};
  Graphic3d_TextureUnit_2: {};
  Graphic3d_TextureUnit_3: {};
  Graphic3d_TextureUnit_4: {};
  Graphic3d_TextureUnit_5: {};
  Graphic3d_TextureUnit_6: {};
  Graphic3d_TextureUnit_7: {};
  Graphic3d_TextureUnit_8: {};
  Graphic3d_TextureUnit_9: {};
  Graphic3d_TextureUnit_10: {};
  Graphic3d_TextureUnit_11: {};
  Graphic3d_TextureUnit_12: {};
  Graphic3d_TextureUnit_13: {};
  Graphic3d_TextureUnit_14: {};
  Graphic3d_TextureUnit_15: {};
  Graphic3d_TextureUnit_BaseColor: {};
  Graphic3d_TextureUnit_Emissive: {};
  Graphic3d_TextureUnit_Occlusion: {};
  Graphic3d_TextureUnit_Normal: {};
  Graphic3d_TextureUnit_MetallicRoughness: {};
  Graphic3d_TextureUnit_EnvMap: {};
  Graphic3d_TextureUnit_PointSprite: {};
  Graphic3d_TextureUnit_PbrEnvironmentLUT: {};
  Graphic3d_TextureUnit_PbrIblDiffuseSH: {};
  Graphic3d_TextureUnit_PbrIblSpecular: {};
}

export declare class Handle_Graphic3d_ShaderAttribute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ShaderAttribute): void;
  get(): Graphic3d_ShaderAttribute;
  delete(): void;
}

  export declare class Handle_Graphic3d_ShaderAttribute_1 extends Handle_Graphic3d_ShaderAttribute {
    constructor();
  }

  export declare class Handle_Graphic3d_ShaderAttribute_2 extends Handle_Graphic3d_ShaderAttribute {
    constructor(thePtr: Graphic3d_ShaderAttribute);
  }

  export declare class Handle_Graphic3d_ShaderAttribute_3 extends Handle_Graphic3d_ShaderAttribute {
    constructor(theHandle: Handle_Graphic3d_ShaderAttribute);
  }

  export declare class Handle_Graphic3d_ShaderAttribute_4 extends Handle_Graphic3d_ShaderAttribute {
    constructor(theHandle: Handle_Graphic3d_ShaderAttribute);
  }

export declare class Graphic3d_ShaderAttribute extends Standard_Transient {
  constructor(theName: XCAFDoc_PartId, theLocation: Standard_Integer)
  Name(): XCAFDoc_PartId;
  Location(): Standard_Integer;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Graphic3d_ArrayOfPrimitives extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static CreateArray_1(theType: Graphic3d_TypeOfPrimitiveArray, theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags): Handle_Graphic3d_ArrayOfPrimitives;
  static CreateArray_2(theType: Graphic3d_TypeOfPrimitiveArray, theMaxVertexs: Graphic3d_ZLayerId, theMaxBounds: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags): Handle_Graphic3d_ArrayOfPrimitives;
  Attributes(): Handle_Graphic3d_Buffer;
  Type(): Graphic3d_TypeOfPrimitiveArray;
  StringType(): Standard_CString;
  HasVertexNormals(): Standard_Boolean;
  HasVertexColors(): Standard_Boolean;
  HasVertexTexels(): Standard_Boolean;
  VertexNumber(): Graphic3d_ZLayerId;
  VertexNumberAllocated(): Graphic3d_ZLayerId;
  ItemNumber(): Graphic3d_ZLayerId;
  IsValid(): Standard_Boolean;
  AddVertex_1(theVertex: gp_Pnt): Graphic3d_ZLayerId;
  AddVertex_2(theVertex: OpenGl_Vec3): Graphic3d_ZLayerId;
  AddVertex_3(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  AddVertex_4(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal): Graphic3d_ZLayerId;
  AddVertex_5(theVertex: gp_Pnt, theColor: Quantity_Color): Graphic3d_ZLayerId;
  AddVertex_6(theVertex: gp_Pnt, theColor32: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddVertex_7(theVertex: gp_Pnt, theColor: OpenGl_Vec4ub): Graphic3d_ZLayerId;
  AddVertex_8(theVertex: gp_Pnt, theNormal: gp_Dir): Graphic3d_ZLayerId;
  AddVertex_9(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theNX: Quantity_AbsorbedDose, theNY: Quantity_AbsorbedDose, theNZ: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  AddVertex_10(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal, theNX: Standard_ShortReal, theNY: Standard_ShortReal, theNZ: Standard_ShortReal): Graphic3d_ZLayerId;
  AddVertex_11(theVertex: gp_Pnt, theNormal: gp_Dir, theColor: Quantity_Color): Graphic3d_ZLayerId;
  AddVertex_12(theVertex: gp_Pnt, theNormal: gp_Dir, theColor32: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddVertex_13(theVertex: gp_Pnt, theTexel: gp_Pnt2d): Graphic3d_ZLayerId;
  AddVertex_14(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theTX: Quantity_AbsorbedDose, theTY: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  AddVertex_15(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal, theTX: Standard_ShortReal, theTY: Standard_ShortReal): Graphic3d_ZLayerId;
  AddVertex_16(theVertex: gp_Pnt, theNormal: gp_Dir, theTexel: gp_Pnt2d): Graphic3d_ZLayerId;
  AddVertex_17(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theNX: Quantity_AbsorbedDose, theNY: Quantity_AbsorbedDose, theNZ: Quantity_AbsorbedDose, theTX: Quantity_AbsorbedDose, theTY: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  AddVertex_18(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal, theNX: Standard_ShortReal, theNY: Standard_ShortReal, theNZ: Standard_ShortReal, theTX: Standard_ShortReal, theTY: Standard_ShortReal): Graphic3d_ZLayerId;
  SetVertice_1(theIndex: Graphic3d_ZLayerId, theVertex: gp_Pnt): void;
  SetVertice_2(theIndex: Graphic3d_ZLayerId, theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal): void;
  SetVertexColor_1(theIndex: Graphic3d_ZLayerId, theColor: Quantity_Color): void;
  SetVertexColor_2(theIndex: Graphic3d_ZLayerId, theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): void;
  SetVertexColor_3(theIndex: Graphic3d_ZLayerId, theColor: OpenGl_Vec4ub): void;
  SetVertexColor_4(theIndex: Graphic3d_ZLayerId, theColor32: Graphic3d_ZLayerId): void;
  SetVertexNormal_1(theIndex: Graphic3d_ZLayerId, theNormal: gp_Dir): void;
  SetVertexNormal_2(theIndex: Graphic3d_ZLayerId, theNX: Quantity_AbsorbedDose, theNY: Quantity_AbsorbedDose, theNZ: Quantity_AbsorbedDose): void;
  SetVertexTexel_1(theIndex: Graphic3d_ZLayerId, theTexel: gp_Pnt2d): void;
  SetVertexTexel_2(theIndex: Graphic3d_ZLayerId, theTX: Quantity_AbsorbedDose, theTY: Quantity_AbsorbedDose): void;
  Vertice_1(theRank: Graphic3d_ZLayerId): gp_Pnt;
  Vertice_2(theRank: Graphic3d_ZLayerId, theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  VertexColor_1(theRank: Graphic3d_ZLayerId): Quantity_Color;
  VertexColor_2(theIndex: Graphic3d_ZLayerId, theColor: OpenGl_Vec4ub): void;
  VertexColor_3(theRank: Graphic3d_ZLayerId, theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): void;
  VertexColor_4(theRank: Graphic3d_ZLayerId, theColor: Graphic3d_ZLayerId): void;
  VertexNormal_1(theRank: Graphic3d_ZLayerId): gp_Dir;
  VertexNormal_2(theRank: Graphic3d_ZLayerId, theNX: Quantity_AbsorbedDose, theNY: Quantity_AbsorbedDose, theNZ: Quantity_AbsorbedDose): void;
  VertexTexel_1(theRank: Graphic3d_ZLayerId): gp_Pnt2d;
  VertexTexel_2(theRank: Graphic3d_ZLayerId, theTX: Quantity_AbsorbedDose, theTY: Quantity_AbsorbedDose): void;
  Indices(): Handle_Graphic3d_IndexBuffer;
  EdgeNumber(): Graphic3d_ZLayerId;
  EdgeNumberAllocated(): Graphic3d_ZLayerId;
  Edge(theRank: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddEdge(theVertexIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddEdges_1(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddSegmentEdges(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddEdges_2(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId, theVertexIndex3: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddTriangleEdges_1(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId, theVertexIndex3: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddTriangleEdges_2(theIndexes: OpenGl_Vec3i): Graphic3d_ZLayerId;
  AddTriangleEdges_3(theIndexes: OpenGl_Vec4i): Graphic3d_ZLayerId;
  AddEdges_3(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId, theVertexIndex3: Graphic3d_ZLayerId, theVertexIndex4: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddQuadEdges(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId, theVertexIndex3: Graphic3d_ZLayerId, theVertexIndex4: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddQuadTriangleEdges_1(theVertexIndex1: Graphic3d_ZLayerId, theVertexIndex2: Graphic3d_ZLayerId, theVertexIndex3: Graphic3d_ZLayerId, theVertexIndex4: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddQuadTriangleEdges_2(theIndexes: OpenGl_Vec4i): Graphic3d_ZLayerId;
  AddTriangleStripEdges(theVertexLower: Graphic3d_ZLayerId, theVertexUpper: Graphic3d_ZLayerId): void;
  AddTriangleFanEdges(theVertexLower: Graphic3d_ZLayerId, theVertexUpper: Graphic3d_ZLayerId, theToClose: Standard_Boolean): void;
  AddPolylineEdges(theVertexLower: Graphic3d_ZLayerId, theVertexUpper: Graphic3d_ZLayerId, theToClose: Standard_Boolean): void;
  Bounds(): Handle_Graphic3d_BoundBuffer;
  HasBoundColors(): Standard_Boolean;
  BoundNumber(): Graphic3d_ZLayerId;
  BoundNumberAllocated(): Graphic3d_ZLayerId;
  Bound(theRank: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  BoundColor_1(theRank: Graphic3d_ZLayerId): Quantity_Color;
  BoundColor_2(theRank: Graphic3d_ZLayerId, theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): void;
  AddBound_1(theEdgeNumber: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AddBound_2(theEdgeNumber: Graphic3d_ZLayerId, theBColor: Quantity_Color): Graphic3d_ZLayerId;
  AddBound_3(theEdgeNumber: Graphic3d_ZLayerId, theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  SetBoundColor_1(theIndex: Graphic3d_ZLayerId, theColor: Quantity_Color): void;
  SetBoundColor_2(theIndex: Graphic3d_ZLayerId, theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_Graphic3d_ArrayOfPrimitives {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfPrimitives): void;
  get(): Graphic3d_ArrayOfPrimitives;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfPrimitives_1 extends Handle_Graphic3d_ArrayOfPrimitives {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfPrimitives_2 extends Handle_Graphic3d_ArrayOfPrimitives {
    constructor(thePtr: Graphic3d_ArrayOfPrimitives);
  }

  export declare class Handle_Graphic3d_ArrayOfPrimitives_3 extends Handle_Graphic3d_ArrayOfPrimitives {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPrimitives);
  }

  export declare class Handle_Graphic3d_ArrayOfPrimitives_4 extends Handle_Graphic3d_ArrayOfPrimitives {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPrimitives);
  }

export declare class Handle_Graphic3d_DataStructureManager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_DataStructureManager): void;
  get(): Graphic3d_DataStructureManager;
  delete(): void;
}

  export declare class Handle_Graphic3d_DataStructureManager_1 extends Handle_Graphic3d_DataStructureManager {
    constructor();
  }

  export declare class Handle_Graphic3d_DataStructureManager_2 extends Handle_Graphic3d_DataStructureManager {
    constructor(thePtr: Graphic3d_DataStructureManager);
  }

  export declare class Handle_Graphic3d_DataStructureManager_3 extends Handle_Graphic3d_DataStructureManager {
    constructor(theHandle: Handle_Graphic3d_DataStructureManager);
  }

  export declare class Handle_Graphic3d_DataStructureManager_4 extends Handle_Graphic3d_DataStructureManager {
    constructor(theHandle: Handle_Graphic3d_DataStructureManager);
  }

export declare class Graphic3d_DataStructureManager extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Graphic3d_Structure extends Standard_Transient {
  constructor(theManager: Handle_Graphic3d_StructureManager, theLinkPrs: Handle_Graphic3d_Structure)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Clear(WithDestruction: Standard_Boolean): void;
  Display(): void;
  DisplayPriority(): Graphic3d_ZLayerId;
  Erase(): void;
  Highlight(theStyle: Handle_Graphic3d_PresentationAttributes, theToUpdateMgr: Standard_Boolean): void;
  Remove_1(): void;
  CalculateBoundBox(): void;
  SetInfiniteState(theToSet: Standard_Boolean): void;
  SetDisplayPriority(Priority: Graphic3d_ZLayerId): void;
  ResetDisplayPriority(): void;
  SetZLayer(theLayerId: Graphic3d_ZLayerId): void;
  GetZLayer(): Graphic3d_ZLayerId;
  SetClipPlanes(thePlanes: Handle_Graphic3d_SequenceOfHClipPlane): void;
  ClipPlanes(): Handle_Graphic3d_SequenceOfHClipPlane;
  SetVisible(AValue: Standard_Boolean): void;
  SetVisual(AVisual: Graphic3d_TypeOfStructure): void;
  SetZoomLimit(LimitInf: Quantity_AbsorbedDose, LimitSup: Quantity_AbsorbedDose): void;
  SetIsForHighlight(isForHighlight: Standard_Boolean): void;
  UnHighlight(): void;
  Compute(): void;
  computeHLR(theProjector: Handle_Graphic3d_Camera, theStructure: Handle_Graphic3d_Structure): void;
  ReCompute_1(): void;
  ReCompute_2(aProjector: Handle_Graphic3d_DataStructureManager): void;
  ContainsFacet(): Standard_Boolean;
  Groups(): Graphic3d_SequenceOfGroup;
  NumberOfGroups(): Graphic3d_ZLayerId;
  NewGroup(): Handle_Graphic3d_Group;
  CurrentGroup(): Handle_Graphic3d_Group;
  HighlightStyle(): Handle_Graphic3d_PresentationAttributes;
  IsDeleted(): Standard_Boolean;
  IsDisplayed(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  IsInfinite(): Standard_Boolean;
  IsHighlighted(): Standard_Boolean;
  IsTransformed(): Standard_Boolean;
  IsVisible(): Standard_Boolean;
  MinMaxValues(theToIgnoreInfiniteFlag: Standard_Boolean): Bnd_Box;
  Visual(): Graphic3d_TypeOfStructure;
  static AcceptConnection(theStructure1: Prs3d_Presentation, theStructure2: Prs3d_Presentation, theType: Graphic3d_TypeOfConnection): Standard_Boolean;
  Ancestors(SG: Graphic3d_MapOfStructure): void;
  Connect_1(theStructure: Prs3d_Presentation, theType: Graphic3d_TypeOfConnection, theWithCheck: Standard_Boolean): void;
  Connect_2(thePrs: Handle_Graphic3d_Structure): void;
  Descendants(SG: Graphic3d_MapOfStructure): void;
  Disconnect(theStructure: Prs3d_Presentation): void;
  Remove_2(thePrs: Handle_Graphic3d_Structure): void;
  DisconnectAll(AType: Graphic3d_TypeOfConnection): void;
  RemoveAll(): void;
  static Network(theStructure: Prs3d_Presentation, theType: Graphic3d_TypeOfConnection, theSet: NCollection_Map<Graphic3d_Structure >): void;
  SetOwner(theOwner: Standard_Address): void;
  Owner(): Standard_Address;
  SetHLRValidation(theFlag: Standard_Boolean): void;
  HLRValidation(): Standard_Boolean;
  Transformation(): Handle_TopLoc_Datum3D;
  SetTransformation(theTrsf: Handle_TopLoc_Datum3D): void;
  Transform(theTrsf: Handle_TopLoc_Datum3D): void;
  SetTransformPersistence(theTrsfPers: Handle_Graphic3d_TransformPers): void;
  TransformPersistence(): Handle_Graphic3d_TransformPers;
  SetMutable(theIsMutable: Standard_Boolean): void;
  IsMutable(): Standard_Boolean;
  ComputeVisual(): Graphic3d_TypeOfStructure;
  GraphicClear(WithDestruction: Standard_Boolean): void;
  GraphicConnect(theDaughter: Handle_Graphic3d_Structure): void;
  GraphicDisconnect(theDaughter: Handle_Graphic3d_Structure): void;
  GraphicTransform(theTrsf: Handle_TopLoc_Datum3D): void;
  Identification(): Graphic3d_ZLayerId;
  static PrintNetwork(AStructure: Handle_Graphic3d_Structure, AType: Graphic3d_TypeOfConnection): void;
  Remove_3(thePtr: Prs3d_Presentation, theType: Graphic3d_TypeOfConnection): void;
  SetComputeVisual(theVisual: Graphic3d_TypeOfStructure): void;
  static Transforms(theTrsf: gp_Trsf, theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theNewX: Quantity_AbsorbedDose, theNewY: Quantity_AbsorbedDose, theNewZ: Quantity_AbsorbedDose): void;
  CStructure(): Handle_Graphic3d_CStructure;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_Aspects extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  InteriorStyle(): Aspect_InteriorStyle;
  SetInteriorStyle(theStyle: Aspect_InteriorStyle): void;
  ShadingModel(): V3d_TypeOfShadingModel;
  SetShadingModel(theShadingModel: V3d_TypeOfShadingModel): void;
  AlphaMode(): Graphic3d_AlphaMode;
  AlphaCutoff(): Standard_ShortReal;
  SetAlphaMode(theMode: Graphic3d_AlphaMode, theAlphaCutoff: Standard_ShortReal): void;
  ColorRGBA(): Quantity_ColorRGBA;
  Color(): Quantity_Color;
  SetColor(theColor: Quantity_Color): void;
  InteriorColor(): Quantity_Color;
  InteriorColorRGBA(): Quantity_ColorRGBA;
  SetInteriorColor_1(theColor: Quantity_Color): void;
  SetInteriorColor_2(theColor: Quantity_ColorRGBA): void;
  BackInteriorColor(): Quantity_Color;
  BackInteriorColorRGBA(): Quantity_ColorRGBA;
  SetBackInteriorColor_1(theColor: Quantity_Color): void;
  SetBackInteriorColor_2(theColor: Quantity_ColorRGBA): void;
  FrontMaterial(): Graphic3d_MaterialAspect;
  ChangeFrontMaterial(): Graphic3d_MaterialAspect;
  SetFrontMaterial(theMaterial: Graphic3d_MaterialAspect): void;
  BackMaterial(): Graphic3d_MaterialAspect;
  ChangeBackMaterial(): Graphic3d_MaterialAspect;
  SetBackMaterial(theMaterial: Graphic3d_MaterialAspect): void;
  ToSuppressBackFaces(): Standard_Boolean;
  SetSuppressBackFaces(theToSuppress: Standard_Boolean): void;
  BackFace(): Standard_Boolean;
  AllowBackFace(): void;
  SuppressBackFace(): void;
  Distinguish(): Standard_Boolean;
  SetDistinguish(toDistinguish: Standard_Boolean): void;
  SetDistinguishOn(): void;
  SetDistinguishOff(): void;
  ShaderProgram(): Handle_Graphic3d_ShaderProgram;
  SetShaderProgram(theProgram: Handle_Graphic3d_ShaderProgram): void;
  TextureSet(): any;
  SetTextureSet(theTextures: any): void;
  TextureMap(): Handle_Graphic3d_TextureMap;
  SetTextureMap(theTexture: Handle_Graphic3d_TextureMap): void;
  ToMapTexture(): Standard_Boolean;
  TextureMapState(): Standard_Boolean;
  SetTextureMapOn_1(theToMap: Standard_Boolean): void;
  SetTextureMapOn_2(): void;
  SetTextureMapOff(): void;
  PolygonOffset(): Graphic3d_PolygonOffset;
  SetPolygonOffset(theOffset: Graphic3d_PolygonOffset): void;
  PolygonOffsets(theMode: Graphic3d_ZLayerId, theFactor: Standard_ShortReal, theUnits: Standard_ShortReal): void;
  SetPolygonOffsets(theMode: Graphic3d_ZLayerId, theFactor: Standard_ShortReal, theUnits: Standard_ShortReal): void;
  LineType(): Aspect_TypeOfLine;
  SetLineType(theType: Aspect_TypeOfLine): void;
  LinePattern(): uint16_t;
  SetLinePattern(thePattern: uint16_t): void;
  LineStippleFactor(): uint16_t;
  SetLineStippleFactor(theFactor: uint16_t): void;
  LineWidth(): Standard_ShortReal;
  SetLineWidth(theWidth: Standard_ShortReal): void;
  static DefaultLinePatternForType(theType: Aspect_TypeOfLine): uint16_t;
  static DefaultLineTypeForPattern(thePattern: uint16_t): Aspect_TypeOfLine;
  MarkerType(): Aspect_TypeOfMarker;
  SetMarkerType(theType: Aspect_TypeOfMarker): void;
  MarkerScale(): Standard_ShortReal;
  SetMarkerScale(theScale: Standard_ShortReal): void;
  MarkerImage(): Handle_Graphic3d_MarkerImage;
  SetMarkerImage(theImage: Handle_Graphic3d_MarkerImage): void;
  IsMarkerSprite(): Standard_Boolean;
  TextFont(): Handle_TCollection_HAsciiString;
  SetTextFont(theFont: Handle_TCollection_HAsciiString): void;
  TextFontAspect(): Font_FontAspect;
  SetTextFontAspect(theFontAspect: Font_FontAspect): void;
  TextDisplayType(): Aspect_TypeOfDisplayText;
  SetTextDisplayType(theType: Aspect_TypeOfDisplayText): void;
  ColorSubTitleRGBA(): Quantity_ColorRGBA;
  ColorSubTitle(): Quantity_Color;
  SetColorSubTitle_1(theColor: Quantity_Color): void;
  SetColorSubTitle_2(theColor: Quantity_ColorRGBA): void;
  IsTextZoomable(): Standard_Boolean;
  SetTextZoomable(theFlag: Standard_Boolean): void;
  TextStyle(): Aspect_TypeOfStyleText;
  SetTextStyle(theStyle: Aspect_TypeOfStyleText): void;
  TextAngle(): Standard_ShortReal;
  SetTextAngle(theAngle: Standard_ShortReal): void;
  ToDrawEdges(): Standard_Boolean;
  SetDrawEdges(theToDraw: Standard_Boolean): void;
  SetEdgeOn(): void;
  SetEdgeOff(): void;
  EdgeColor(): Quantity_Color;
  EdgeColorRGBA(): Quantity_ColorRGBA;
  SetEdgeColor_1(theColor: Quantity_Color): void;
  SetEdgeColor_2(theColor: Quantity_ColorRGBA): void;
  EdgeLineType(): Aspect_TypeOfLine;
  SetEdgeLineType(theType: Aspect_TypeOfLine): void;
  EdgeWidth(): Standard_ShortReal;
  SetEdgeWidth(theWidth: Quantity_AbsorbedDose): void;
  ToSkipFirstEdge(): Standard_Boolean;
  SetSkipFirstEdge(theToSkipFirstEdge: Standard_Boolean): void;
  ToDrawSilhouette(): Standard_Boolean;
  SetDrawSilhouette(theToDraw: Standard_Boolean): void;
  HatchStyle(): Handle_Graphic3d_HatchStyle;
  SetHatchStyle_1(theStyle: Handle_Graphic3d_HatchStyle): void;
  SetHatchStyle_2(theStyle: Aspect_HatchStyle): void;
  IsEqual(theOther: Graphic3d_Aspects): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Graphic3d_Aspects {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Aspects): void;
  get(): Graphic3d_Aspects;
  delete(): void;
}

  export declare class Handle_Graphic3d_Aspects_1 extends Handle_Graphic3d_Aspects {
    constructor();
  }

  export declare class Handle_Graphic3d_Aspects_2 extends Handle_Graphic3d_Aspects {
    constructor(thePtr: Graphic3d_Aspects);
  }

  export declare class Handle_Graphic3d_Aspects_3 extends Handle_Graphic3d_Aspects {
    constructor(theHandle: Handle_Graphic3d_Aspects);
  }

  export declare class Handle_Graphic3d_Aspects_4 extends Handle_Graphic3d_Aspects {
    constructor(theHandle: Handle_Graphic3d_Aspects);
  }

export declare type Graphic3d_TypeOfComposition = {
  Graphic3d_TOC_REPLACE: {};
  Graphic3d_TOC_POSTCONCATENATE: {};
}

export declare type Graphic3d_NameOfMaterial = {
  Graphic3d_NameOfMaterial_Brass: {};
  Graphic3d_NameOfMaterial_Bronze: {};
  Graphic3d_NameOfMaterial_Copper: {};
  Graphic3d_NameOfMaterial_Gold: {};
  Graphic3d_NameOfMaterial_Pewter: {};
  Graphic3d_NameOfMaterial_Plastered: {};
  Graphic3d_NameOfMaterial_Plastified: {};
  Graphic3d_NameOfMaterial_Silver: {};
  Graphic3d_NameOfMaterial_Steel: {};
  Graphic3d_NameOfMaterial_Stone: {};
  Graphic3d_NameOfMaterial_ShinyPlastified: {};
  Graphic3d_NameOfMaterial_Satin: {};
  Graphic3d_NameOfMaterial_Metalized: {};
  Graphic3d_NameOfMaterial_Ionized: {};
  Graphic3d_NameOfMaterial_Chrome: {};
  Graphic3d_NameOfMaterial_Aluminum: {};
  Graphic3d_NameOfMaterial_Obsidian: {};
  Graphic3d_NameOfMaterial_Neon: {};
  Graphic3d_NameOfMaterial_Jade: {};
  Graphic3d_NameOfMaterial_Charcoal: {};
  Graphic3d_NameOfMaterial_Water: {};
  Graphic3d_NameOfMaterial_Glass: {};
  Graphic3d_NameOfMaterial_Diamond: {};
  Graphic3d_NameOfMaterial_Transparent: {};
  Graphic3d_NameOfMaterial_DEFAULT: {};
  Graphic3d_NameOfMaterial_UserDefined: {};
  Graphic3d_NOM_BRASS: {};
  Graphic3d_NOM_BRONZE: {};
  Graphic3d_NOM_COPPER: {};
  Graphic3d_NOM_GOLD: {};
  Graphic3d_NOM_PEWTER: {};
  Graphic3d_NOM_PLASTER: {};
  Graphic3d_NOM_PLASTIC: {};
  Graphic3d_NOM_SILVER: {};
  Graphic3d_NOM_STEEL: {};
  Graphic3d_NOM_STONE: {};
  Graphic3d_NOM_SHINY_PLASTIC: {};
  Graphic3d_NOM_SATIN: {};
  Graphic3d_NOM_METALIZED: {};
  Graphic3d_NOM_NEON_GNC: {};
  Graphic3d_NOM_CHROME: {};
  Graphic3d_NOM_ALUMINIUM: {};
  Graphic3d_NOM_OBSIDIAN: {};
  Graphic3d_NOM_NEON_PHC: {};
  Graphic3d_NOM_JADE: {};
  Graphic3d_NOM_CHARCOAL: {};
  Graphic3d_NOM_WATER: {};
  Graphic3d_NOM_GLASS: {};
  Graphic3d_NOM_DIAMOND: {};
  Graphic3d_NOM_TRANSPARENT: {};
  Graphic3d_NOM_DEFAULT: {};
  Graphic3d_NOM_UserDefined: {};
}

export declare type Graphic3d_LevelOfTextureAnisotropy = {
  Graphic3d_LOTA_OFF: {};
  Graphic3d_LOTA_FAST: {};
  Graphic3d_LOTA_MIDDLE: {};
  Graphic3d_LOTA_QUALITY: {};
}

export declare type Graphic3d_TypeOfShaderObject = {
  Graphic3d_TOS_VERTEX: {};
  Graphic3d_TOS_TESS_CONTROL: {};
  Graphic3d_TOS_TESS_EVALUATION: {};
  Graphic3d_TOS_GEOMETRY: {};
  Graphic3d_TOS_FRAGMENT: {};
  Graphic3d_TOS_COMPUTE: {};
}

export declare class Handle_Graphic3d_ArrayOfTriangleStrips {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfTriangleStrips): void;
  get(): Graphic3d_ArrayOfTriangleStrips;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfTriangleStrips_1 extends Handle_Graphic3d_ArrayOfTriangleStrips {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfTriangleStrips_2 extends Handle_Graphic3d_ArrayOfTriangleStrips {
    constructor(thePtr: Graphic3d_ArrayOfTriangleStrips);
  }

  export declare class Handle_Graphic3d_ArrayOfTriangleStrips_3 extends Handle_Graphic3d_ArrayOfTriangleStrips {
    constructor(theHandle: Handle_Graphic3d_ArrayOfTriangleStrips);
  }

  export declare class Handle_Graphic3d_ArrayOfTriangleStrips_4 extends Handle_Graphic3d_ArrayOfTriangleStrips {
    constructor(theHandle: Handle_Graphic3d_ArrayOfTriangleStrips);
  }

export declare class Graphic3d_ArrayOfTriangleStrips extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfTriangleStrips_1 extends Graphic3d_ArrayOfTriangleStrips {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxStrips: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfTriangleStrips_2 extends Graphic3d_ArrayOfTriangleStrips {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxStrips: Graphic3d_ZLayerId, theHasVNormals: Standard_Boolean, theHasVColors: Standard_Boolean, theHasBColors: Standard_Boolean, theHasVTexels: Standard_Boolean);
  }

export declare type Graphic3d_NameOfTexture2D = {
  Graphic3d_NOT_2D_MATRA: {};
  Graphic3d_NOT_2D_ALIENSKIN: {};
  Graphic3d_NOT_2D_BLUE_ROCK: {};
  Graphic3d_NOT_2D_BLUEWHITE_PAPER: {};
  Graphic3d_NOT_2D_BRUSHED: {};
  Graphic3d_NOT_2D_BUBBLES: {};
  Graphic3d_NOT_2D_BUMP: {};
  Graphic3d_NOT_2D_CAST: {};
  Graphic3d_NOT_2D_CHIPBD: {};
  Graphic3d_NOT_2D_CLOUDS: {};
  Graphic3d_NOT_2D_FLESH: {};
  Graphic3d_NOT_2D_FLOOR: {};
  Graphic3d_NOT_2D_GALVNISD: {};
  Graphic3d_NOT_2D_GRASS: {};
  Graphic3d_NOT_2D_ALUMINUM: {};
  Graphic3d_NOT_2D_ROCK: {};
  Graphic3d_NOT_2D_KNURL: {};
  Graphic3d_NOT_2D_MAPLE: {};
  Graphic3d_NOT_2D_MARBLE: {};
  Graphic3d_NOT_2D_MOTTLED: {};
  Graphic3d_NOT_2D_RAIN: {};
  Graphic3d_NOT_2D_CHESS: {};
  Graphic3d_NOT_2D_UNKNOWN: {};
}

export declare class Graphic3d_TransformPers extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static IsZoomOrRotate_1(theMode: Graphic3d_TransModeFlags): Standard_Boolean;
  static IsTrihedronOr2d_1(theMode: Graphic3d_TransModeFlags): Standard_Boolean;
  static FromDeprecatedParams(theFlag: Graphic3d_TransModeFlags, thePoint: gp_Pnt): Handle_Graphic3d_TransformPers;
  IsZoomOrRotate_2(): Standard_Boolean;
  IsTrihedronOr2d_2(): Standard_Boolean;
  Mode(): Graphic3d_TransModeFlags;
  Flags(): Graphic3d_TransModeFlags;
  SetPersistence_1(theMode: Graphic3d_TransModeFlags, thePnt: gp_Pnt): void;
  SetPersistence_2(theMode: Graphic3d_TransModeFlags, theCorner: Aspect_TypeOfTriedronPosition, theOffset: OpenGl_Vec2i): void;
  AnchorPoint(): gp_Pnt;
  SetAnchorPoint(thePnt: gp_Pnt): void;
  Corner2d(): Aspect_TypeOfTriedronPosition;
  SetCorner2d(thePos: Aspect_TypeOfTriedronPosition): void;
  Offset2d(): OpenGl_Vec2i;
  SetOffset2d(theOffset: OpenGl_Vec2i): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Graphic3d_TransformPers_1 extends Graphic3d_TransformPers {
    constructor(theMode: Graphic3d_TransModeFlags);
  }

  export declare class Graphic3d_TransformPers_2 extends Graphic3d_TransformPers {
    constructor(theMode: Graphic3d_TransModeFlags, thePnt: gp_Pnt);
  }

  export declare class Graphic3d_TransformPers_3 extends Graphic3d_TransformPers {
    constructor(theMode: Graphic3d_TransModeFlags, theCorner: Aspect_TypeOfTriedronPosition, theOffset: OpenGl_Vec2i);
  }

export declare class Handle_Graphic3d_TransformPers {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_TransformPers): void;
  get(): Graphic3d_TransformPers;
  delete(): void;
}

  export declare class Handle_Graphic3d_TransformPers_1 extends Handle_Graphic3d_TransformPers {
    constructor();
  }

  export declare class Handle_Graphic3d_TransformPers_2 extends Handle_Graphic3d_TransformPers {
    constructor(thePtr: Graphic3d_TransformPers);
  }

  export declare class Handle_Graphic3d_TransformPers_3 extends Handle_Graphic3d_TransformPers {
    constructor(theHandle: Handle_Graphic3d_TransformPers);
  }

  export declare class Handle_Graphic3d_TransformPers_4 extends Handle_Graphic3d_TransformPers {
    constructor(theHandle: Handle_Graphic3d_TransformPers);
  }

export declare class Handle_Graphic3d_ArrayOfPoints {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfPoints): void;
  get(): Graphic3d_ArrayOfPoints;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfPoints_1 extends Handle_Graphic3d_ArrayOfPoints {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfPoints_2 extends Handle_Graphic3d_ArrayOfPoints {
    constructor(thePtr: Graphic3d_ArrayOfPoints);
  }

  export declare class Handle_Graphic3d_ArrayOfPoints_3 extends Handle_Graphic3d_ArrayOfPoints {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPoints);
  }

  export declare class Handle_Graphic3d_ArrayOfPoints_4 extends Handle_Graphic3d_ArrayOfPoints {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPoints);
  }

export declare class Graphic3d_ArrayOfPoints extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfPoints_1 extends Graphic3d_ArrayOfPoints {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfPoints_2 extends Graphic3d_ArrayOfPoints {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theHasVColors: Standard_Boolean, theHasVNormals: Standard_Boolean);
  }

export declare type Graphic3d_FresnelModel = {
  Graphic3d_FM_SCHLICK: {};
  Graphic3d_FM_CONSTANT: {};
  Graphic3d_FM_CONDUCTOR: {};
  Graphic3d_FM_DIELECTRIC: {};
}

export declare class Graphic3d_Fresnel {
  constructor()
  static CreateSchlick(theSpecularColor: OpenGl_Vec3): Graphic3d_Fresnel;
  static CreateConstant(theReflection: Standard_ShortReal): Graphic3d_Fresnel;
  static CreateDielectric(theRefractionIndex: Standard_ShortReal): Graphic3d_Fresnel;
  static CreateConductor_1(theRefractionIndex: Standard_ShortReal, theAbsorptionIndex: Standard_ShortReal): Graphic3d_Fresnel;
  static CreateConductor_2(theRefractionIndex: OpenGl_Vec3, theAbsorptionIndex: OpenGl_Vec3): Graphic3d_Fresnel;
  Serialize(): OpenGl_Vec4;
  FresnelType(): Graphic3d_FresnelModel;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_BSDF {
  constructor()
  static CreateDiffuse(theWeight: OpenGl_Vec3): Graphic3d_BSDF;
  static CreateMetallic(theWeight: OpenGl_Vec3, theFresnel: Graphic3d_Fresnel, theRoughness: Standard_ShortReal): Graphic3d_BSDF;
  static CreateTransparent(theWeight: OpenGl_Vec3, theAbsorptionColor: OpenGl_Vec3, theAbsorptionCoeff: Standard_ShortReal): Graphic3d_BSDF;
  static CreateGlass(theWeight: OpenGl_Vec3, theAbsorptionColor: OpenGl_Vec3, theAbsorptionCoeff: Standard_ShortReal, theRefractionIndex: Standard_ShortReal): Graphic3d_BSDF;
  static CreateMetallicRoughness(thePbr: Graphic3d_PBRMaterial): Graphic3d_BSDF;
  Normalize(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Graphic3d_TypeOfStructure = {
  Graphic3d_TOS_WIREFRAME: {};
  Graphic3d_TOS_SHADING: {};
  Graphic3d_TOS_COMPUTED: {};
  Graphic3d_TOS_ALL: {};
}

export declare class Graphic3d_ArrayOfTriangleFans extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfTriangleFans_1 extends Graphic3d_ArrayOfTriangleFans {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxFans: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfTriangleFans_2 extends Graphic3d_ArrayOfTriangleFans {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxFans: Graphic3d_ZLayerId, theHasVNormals: Standard_Boolean, theHasVColors: Standard_Boolean, theHasBColors: Standard_Boolean, theHasVTexels: Standard_Boolean);
  }

export declare class Handle_Graphic3d_ArrayOfTriangleFans {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfTriangleFans): void;
  get(): Graphic3d_ArrayOfTriangleFans;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfTriangleFans_1 extends Handle_Graphic3d_ArrayOfTriangleFans {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfTriangleFans_2 extends Handle_Graphic3d_ArrayOfTriangleFans {
    constructor(thePtr: Graphic3d_ArrayOfTriangleFans);
  }

  export declare class Handle_Graphic3d_ArrayOfTriangleFans_3 extends Handle_Graphic3d_ArrayOfTriangleFans {
    constructor(theHandle: Handle_Graphic3d_ArrayOfTriangleFans);
  }

  export declare class Handle_Graphic3d_ArrayOfTriangleFans_4 extends Handle_Graphic3d_ArrayOfTriangleFans {
    constructor(theHandle: Handle_Graphic3d_ArrayOfTriangleFans);
  }

export declare class Handle_Graphic3d_ArrayOfPolylines {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfPolylines): void;
  get(): Graphic3d_ArrayOfPolylines;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfPolylines_1 extends Handle_Graphic3d_ArrayOfPolylines {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfPolylines_2 extends Handle_Graphic3d_ArrayOfPolylines {
    constructor(thePtr: Graphic3d_ArrayOfPolylines);
  }

  export declare class Handle_Graphic3d_ArrayOfPolylines_3 extends Handle_Graphic3d_ArrayOfPolylines {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPolylines);
  }

  export declare class Handle_Graphic3d_ArrayOfPolylines_4 extends Handle_Graphic3d_ArrayOfPolylines {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPolylines);
  }

export declare class Graphic3d_ArrayOfPolylines extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfPolylines_1 extends Graphic3d_ArrayOfPolylines {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxBounds: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfPolylines_2 extends Graphic3d_ArrayOfPolylines {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxBounds: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theHasVColors: Standard_Boolean, theHasBColors: Standard_Boolean);
  }

export declare type Graphic3d_TypeOfTexture = {
  Graphic3d_TOT_1D: {};
  Graphic3d_TOT_2D: {};
  Graphic3d_TOT_2D_MIPMAP: {};
  Graphic3d_TOT_CUBEMAP: {};
}

export declare type Graphic3d_ToneMappingMethod = {
  Graphic3d_ToneMappingMethod_Disabled: {};
  Graphic3d_ToneMappingMethod_Filmic: {};
}

export declare type Graphic3d_GroupAspect = {
  Graphic3d_ASPECT_LINE: {};
  Graphic3d_ASPECT_TEXT: {};
  Graphic3d_ASPECT_MARKER: {};
  Graphic3d_ASPECT_FILL_AREA: {};
}

export declare class Handle_Graphic3d_Text {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Text): void;
  get(): Graphic3d_Text;
  delete(): void;
}

  export declare class Handle_Graphic3d_Text_1 extends Handle_Graphic3d_Text {
    constructor();
  }

  export declare class Handle_Graphic3d_Text_2 extends Handle_Graphic3d_Text {
    constructor(thePtr: Graphic3d_Text);
  }

  export declare class Handle_Graphic3d_Text_3 extends Handle_Graphic3d_Text {
    constructor(theHandle: Handle_Graphic3d_Text);
  }

  export declare class Handle_Graphic3d_Text_4 extends Handle_Graphic3d_Text {
    constructor(theHandle: Handle_Graphic3d_Text);
  }

export declare class Graphic3d_Text extends Standard_Transient {
  constructor(theHeight: Standard_ShortReal)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Text(): NCollection_String;
  SetText_1(theText: NCollection_String): void;
  SetText_2(theText: XCAFDoc_PartId): void;
  SetText_3(theText: Standard_CString): void;
  TextFormatter(): Handle_Font_TextFormatter;
  SetTextFormatter(theFormatter: Handle_Font_TextFormatter): void;
  Position(): gp_Pnt;
  SetPosition(thePoint: gp_Pnt): void;
  Orientation(): gp_Ax2;
  HasPlane(): Standard_Boolean;
  SetOrientation(theOrientation: gp_Ax2): void;
  ResetOrientation(): void;
  HasOwnAnchorPoint(): Standard_Boolean;
  SetOwnAnchorPoint(theHasOwnAnchor: Standard_Boolean): void;
  Height(): Standard_ShortReal;
  SetHeight(theHeight: Standard_ShortReal): void;
  HorizontalAlignment(): Graphic3d_HorizontalTextAlignment;
  SetHorizontalAlignment(theJustification: Graphic3d_HorizontalTextAlignment): void;
  VerticalAlignment(): Graphic3d_VerticalTextAlignment;
  SetVerticalAlignment(theJustification: Graphic3d_VerticalTextAlignment): void;
  delete(): void;
}

export declare class Graphic3d_ZLayerSettings {
  constructor()
  Name(): XCAFDoc_PartId;
  SetName(theName: XCAFDoc_PartId): void;
  Lights(): Handle_Graphic3d_LightSet;
  SetLights(theLights: Handle_Graphic3d_LightSet): void;
  Origin(): gp_XYZ;
  OriginTransformation(): Handle_TopLoc_Datum3D;
  SetOrigin(theOrigin: gp_XYZ): void;
  HasCullingDistance(): Standard_Boolean;
  CullingDistance(): Quantity_AbsorbedDose;
  SetCullingDistance(theDistance: Quantity_AbsorbedDose): void;
  HasCullingSize(): Standard_Boolean;
  CullingSize(): Quantity_AbsorbedDose;
  SetCullingSize(theSize: Quantity_AbsorbedDose): void;
  IsImmediate(): Standard_Boolean;
  SetImmediate(theValue: Standard_Boolean): void;
  IsRaytracable(): Standard_Boolean;
  SetRaytracable(theToRaytrace: Standard_Boolean): void;
  UseEnvironmentTexture(): Standard_Boolean;
  SetEnvironmentTexture(theValue: Standard_Boolean): void;
  ToEnableDepthTest(): Standard_Boolean;
  SetEnableDepthTest(theValue: Standard_Boolean): void;
  ToEnableDepthWrite(): Standard_Boolean;
  SetEnableDepthWrite(theValue: Standard_Boolean): void;
  ToClearDepth(): Standard_Boolean;
  SetClearDepth(theValue: Standard_Boolean): void;
  ToRenderInDepthPrepass(): Standard_Boolean;
  SetRenderInDepthPrepass(theToRender: Standard_Boolean): void;
  PolygonOffset(): Graphic3d_PolygonOffset;
  SetPolygonOffset(theParams: Graphic3d_PolygonOffset): void;
  ChangePolygonOffset(): Graphic3d_PolygonOffset;
  IsSettingEnabled(theSetting: Graphic3d_ZLayerSetting): Standard_Boolean;
  EnableSetting(theSetting: Graphic3d_ZLayerSetting): void;
  DisableSetting(theSetting: Graphic3d_ZLayerSetting): void;
  SetDepthOffsetPositive(): void;
  SetDepthOffsetNegative(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Graphic3d_ZLayerSetting = {
  Graphic3d_ZLayerDepthTest: {};
  Graphic3d_ZLayerDepthWrite: {};
  Graphic3d_ZLayerDepthClear: {};
  Graphic3d_ZLayerDepthOffset: {};
}

export declare class Handle_Graphic3d_AspectText3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_AspectText3d): void;
  get(): Graphic3d_AspectText3d;
  delete(): void;
}

  export declare class Handle_Graphic3d_AspectText3d_1 extends Handle_Graphic3d_AspectText3d {
    constructor();
  }

  export declare class Handle_Graphic3d_AspectText3d_2 extends Handle_Graphic3d_AspectText3d {
    constructor(thePtr: Graphic3d_AspectText3d);
  }

  export declare class Handle_Graphic3d_AspectText3d_3 extends Handle_Graphic3d_AspectText3d {
    constructor(theHandle: Handle_Graphic3d_AspectText3d);
  }

  export declare class Handle_Graphic3d_AspectText3d_4 extends Handle_Graphic3d_AspectText3d {
    constructor(theHandle: Handle_Graphic3d_AspectText3d);
  }

export declare class Graphic3d_AspectText3d extends Graphic3d_Aspects {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Color(): Quantity_Color;
  ColorRGBA(): Quantity_ColorRGBA;
  SetColor_1(theColor: Quantity_Color): void;
  SetColor_2(theColor: Quantity_ColorRGBA): void;
  Font(): XCAFDoc_PartId;
  SetFont_1(theFont: XCAFDoc_PartId): void;
  SetFont_2(theFont: Standard_CString): void;
  Style(): Aspect_TypeOfStyleText;
  SetStyle(theStyle: Aspect_TypeOfStyleText): void;
  DisplayType(): Aspect_TypeOfDisplayText;
  SetDisplayType(theDisplayType: Aspect_TypeOfDisplayText): void;
  GetTextZoomable(): Standard_Boolean;
  GetTextAngle(): Standard_ShortReal;
  SetTextAngle(theAngle: Quantity_AbsorbedDose): void;
  GetTextFontAspect(): Font_FontAspect;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Graphic3d_AspectText3d_1 extends Graphic3d_AspectText3d {
    constructor();
  }

  export declare class Graphic3d_AspectText3d_2 extends Graphic3d_AspectText3d {
    constructor(theColor: Quantity_Color, theFont: Standard_CString, theExpansionFactor: Quantity_AbsorbedDose, theSpace: Quantity_AbsorbedDose, theStyle: Aspect_TypeOfStyleText, theDisplayType: Aspect_TypeOfDisplayText);
  }

export declare type Graphic3d_TypeOfReflection = {
  Graphic3d_TOR_AMBIENT: {};
  Graphic3d_TOR_DIFFUSE: {};
  Graphic3d_TOR_SPECULAR: {};
  Graphic3d_TOR_EMISSION: {};
}

export declare class Handle_Graphic3d_AspectFillArea3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_AspectFillArea3d): void;
  get(): Graphic3d_AspectFillArea3d;
  delete(): void;
}

  export declare class Handle_Graphic3d_AspectFillArea3d_1 extends Handle_Graphic3d_AspectFillArea3d {
    constructor();
  }

  export declare class Handle_Graphic3d_AspectFillArea3d_2 extends Handle_Graphic3d_AspectFillArea3d {
    constructor(thePtr: Graphic3d_AspectFillArea3d);
  }

  export declare class Handle_Graphic3d_AspectFillArea3d_3 extends Handle_Graphic3d_AspectFillArea3d {
    constructor(theHandle: Handle_Graphic3d_AspectFillArea3d);
  }

  export declare class Handle_Graphic3d_AspectFillArea3d_4 extends Handle_Graphic3d_AspectFillArea3d {
    constructor(theHandle: Handle_Graphic3d_AspectFillArea3d);
  }

export declare class Graphic3d_AspectFillArea3d extends Graphic3d_Aspects {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Edge(): Standard_Boolean;
  delete(): void;
}

  export declare class Graphic3d_AspectFillArea3d_1 extends Graphic3d_AspectFillArea3d {
    constructor();
  }

  export declare class Graphic3d_AspectFillArea3d_2 extends Graphic3d_AspectFillArea3d {
    constructor(theInterior: Aspect_InteriorStyle, theInteriorColor: Quantity_Color, theEdgeColor: Quantity_Color, theEdgeLineType: Aspect_TypeOfLine, theEdgeWidth: Quantity_AbsorbedDose, theFrontMaterial: Graphic3d_MaterialAspect, theBackMaterial: Graphic3d_MaterialAspect);
  }

export declare class Handle_Graphic3d_AspectLine3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_AspectLine3d): void;
  get(): Graphic3d_AspectLine3d;
  delete(): void;
}

  export declare class Handle_Graphic3d_AspectLine3d_1 extends Handle_Graphic3d_AspectLine3d {
    constructor();
  }

  export declare class Handle_Graphic3d_AspectLine3d_2 extends Handle_Graphic3d_AspectLine3d {
    constructor(thePtr: Graphic3d_AspectLine3d);
  }

  export declare class Handle_Graphic3d_AspectLine3d_3 extends Handle_Graphic3d_AspectLine3d {
    constructor(theHandle: Handle_Graphic3d_AspectLine3d);
  }

  export declare class Handle_Graphic3d_AspectLine3d_4 extends Handle_Graphic3d_AspectLine3d {
    constructor(theHandle: Handle_Graphic3d_AspectLine3d);
  }

export declare class Graphic3d_AspectLine3d extends Graphic3d_Aspects {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Type(): Aspect_TypeOfLine;
  SetType(theType: Aspect_TypeOfLine): void;
  Width(): Standard_ShortReal;
  SetWidth_1(theWidth: Quantity_AbsorbedDose): void;
  SetWidth_2(theWidth: Standard_ShortReal): void;
  delete(): void;
}

  export declare class Graphic3d_AspectLine3d_1 extends Graphic3d_AspectLine3d {
    constructor();
  }

  export declare class Graphic3d_AspectLine3d_2 extends Graphic3d_AspectLine3d {
    constructor(theColor: Quantity_Color, theType: Aspect_TypeOfLine, theWidth: Quantity_AbsorbedDose);
  }

export declare type Graphic3d_TypeOfBackground = {
  Graphic3d_TOB_NONE: {};
  Graphic3d_TOB_GRADIENT: {};
  Graphic3d_TOB_TEXTURE: {};
  Graphic3d_TOB_CUBEMAP: {};
}

export declare class Handle_Graphic3d_ViewAffinity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ViewAffinity): void;
  get(): Graphic3d_ViewAffinity;
  delete(): void;
}

  export declare class Handle_Graphic3d_ViewAffinity_1 extends Handle_Graphic3d_ViewAffinity {
    constructor();
  }

  export declare class Handle_Graphic3d_ViewAffinity_2 extends Handle_Graphic3d_ViewAffinity {
    constructor(thePtr: Graphic3d_ViewAffinity);
  }

  export declare class Handle_Graphic3d_ViewAffinity_3 extends Handle_Graphic3d_ViewAffinity {
    constructor(theHandle: Handle_Graphic3d_ViewAffinity);
  }

  export declare class Handle_Graphic3d_ViewAffinity_4 extends Handle_Graphic3d_ViewAffinity {
    constructor(theHandle: Handle_Graphic3d_ViewAffinity);
  }

export declare class Graphic3d_ViewAffinity extends Standard_Transient {
  constructor()
  IsVisible(theViewId: Graphic3d_ZLayerId): Standard_Boolean;
  SetVisible_1(theIsVisible: Standard_Boolean): void;
  SetVisible_2(theViewId: Graphic3d_ZLayerId, theIsVisible: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Graphic3d_CubeMapOrder {
  Set_1(theOrder: Graphic3d_CubeMapOrder): Graphic3d_CubeMapOrder;
  Validated(): Graphic3d_ValidatedCubeMapOrder;
  Set_2(theCubeMapSide: Graphic3d_CubeMapSide, theValue: Standard_Byte): Graphic3d_CubeMapOrder;
  SetDefault(): Graphic3d_CubeMapOrder;
  Permute(anOrder: Graphic3d_ValidatedCubeMapOrder): Graphic3d_CubeMapOrder;
  Permuted(anOrder: Graphic3d_ValidatedCubeMapOrder): Graphic3d_CubeMapOrder;
  Swap(theFirstSide: Graphic3d_CubeMapSide, theSecondSide: Graphic3d_CubeMapSide): Graphic3d_CubeMapOrder;
  Swapped(theFirstSide: Graphic3d_CubeMapSide, theSecondSide: Graphic3d_CubeMapSide): Graphic3d_CubeMapOrder;
  Get(theCubeMapSide: Graphic3d_CubeMapSide): Standard_Byte;
  Clear(): Graphic3d_CubeMapOrder;
  IsEmpty(): Standard_Boolean;
  HasRepetitions(): Standard_Boolean;
  HasOverflows(): Standard_Boolean;
  IsValid(): Standard_Boolean;
  static Default(): Graphic3d_ValidatedCubeMapOrder;
  delete(): void;
}

  export declare class Graphic3d_CubeMapOrder_1 extends Graphic3d_CubeMapOrder {
    constructor();
  }

  export declare class Graphic3d_CubeMapOrder_2 extends Graphic3d_CubeMapOrder {
    constructor(thePosXLocation: Standard_Byte, theNegXLocation: Standard_Byte, thePosYLocation: Standard_Byte, theNegYLocation: Standard_Byte, thePosZLocation: Standard_Byte, theNegZLocation: Standard_Byte);
  }

  export declare class Graphic3d_CubeMapOrder_3 extends Graphic3d_CubeMapOrder {
    constructor(theOrder: Graphic3d_ValidatedCubeMapOrder);
  }

export declare class Graphic3d_ValidatedCubeMapOrder {
  constructor(theOther: Graphic3d_ValidatedCubeMapOrder)
  delete(): void;
}

export declare type Graphic3d_TypeOfVisualization = {
  Graphic3d_TOV_WIREFRAME: {};
  Graphic3d_TOV_SHADING: {};
}

export declare class Graphic3d_CStructure extends Standard_Transient {
  GraphicDriver(): Handle_Graphic3d_GraphicDriver;
  Groups(): Graphic3d_SequenceOfGroup;
  Transformation(): Handle_TopLoc_Datum3D;
  SetTransformation(theTrsf: Handle_TopLoc_Datum3D): void;
  TransformPersistence(): Handle_Graphic3d_TransformPers;
  SetTransformPersistence(theTrsfPers: Handle_Graphic3d_TransformPers): void;
  ClipPlanes(): Handle_Graphic3d_SequenceOfHClipPlane;
  SetClipPlanes(thePlanes: Handle_Graphic3d_SequenceOfHClipPlane): void;
  BoundingBox(): Graphic3d_BndBox3d;
  ChangeBoundingBox(): Graphic3d_BndBox3d;
  IsVisible_1(): Standard_Boolean;
  IsVisible_2(theViewId: Graphic3d_ZLayerId): Standard_Boolean;
  SetZLayer(theLayerIndex: Graphic3d_ZLayerId): void;
  ZLayer(): Graphic3d_ZLayerId;
  HighlightStyle(): Handle_Graphic3d_PresentationAttributes;
  IsCulled(): Standard_Boolean;
  SetCulled(theIsCulled: Standard_Boolean): void;
  MarkAsNotCulled(): void;
  BndBoxClipCheck(): Standard_Boolean;
  SetBndBoxClipCheck(theBndBoxClipCheck: Standard_Boolean): void;
  IsAlwaysRendered(): Standard_Boolean;
  OnVisibilityChanged(): void;
  Clear(): void;
  Connect(theStructure: Graphic3d_CStructure): void;
  Disconnect(theStructure: Graphic3d_CStructure): void;
  GraphicHighlight(theStyle: Handle_Graphic3d_PresentationAttributes): void;
  GraphicUnhighlight(): void;
  ShadowLink(theManager: Handle_Graphic3d_StructureManager): Handle_Graphic3d_CStructure;
  NewGroup(theStruct: Handle_Graphic3d_Structure): Handle_Graphic3d_Group;
  RemoveGroup(theGroup: Handle_Graphic3d_Group): void;
  updateLayerTransformation(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Graphic3d_CStructure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_CStructure): void;
  get(): Graphic3d_CStructure;
  delete(): void;
}

  export declare class Handle_Graphic3d_CStructure_1 extends Handle_Graphic3d_CStructure {
    constructor();
  }

  export declare class Handle_Graphic3d_CStructure_2 extends Handle_Graphic3d_CStructure {
    constructor(thePtr: Graphic3d_CStructure);
  }

  export declare class Handle_Graphic3d_CStructure_3 extends Handle_Graphic3d_CStructure {
    constructor(theHandle: Handle_Graphic3d_CStructure);
  }

  export declare class Handle_Graphic3d_CStructure_4 extends Handle_Graphic3d_CStructure {
    constructor(theHandle: Handle_Graphic3d_CStructure);
  }

export declare class Handle_Graphic3d_StructureDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_StructureDefinitionError): void;
  get(): Graphic3d_StructureDefinitionError;
  delete(): void;
}

  export declare class Handle_Graphic3d_StructureDefinitionError_1 extends Handle_Graphic3d_StructureDefinitionError {
    constructor();
  }

  export declare class Handle_Graphic3d_StructureDefinitionError_2 extends Handle_Graphic3d_StructureDefinitionError {
    constructor(thePtr: Graphic3d_StructureDefinitionError);
  }

  export declare class Handle_Graphic3d_StructureDefinitionError_3 extends Handle_Graphic3d_StructureDefinitionError {
    constructor(theHandle: Handle_Graphic3d_StructureDefinitionError);
  }

  export declare class Handle_Graphic3d_StructureDefinitionError_4 extends Handle_Graphic3d_StructureDefinitionError {
    constructor(theHandle: Handle_Graphic3d_StructureDefinitionError);
  }

export declare class Graphic3d_StructureDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Graphic3d_StructureDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_StructureDefinitionError_1 extends Graphic3d_StructureDefinitionError {
    constructor();
  }

  export declare class Graphic3d_StructureDefinitionError_2 extends Graphic3d_StructureDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare type Graphic3d_TypeOfShadingModel = {
  Graphic3d_TOSM_DEFAULT: {};
  Graphic3d_TOSM_UNLIT: {};
  Graphic3d_TOSM_FACET: {};
  Graphic3d_TOSM_VERTEX: {};
  Graphic3d_TOSM_FRAGMENT: {};
  Graphic3d_TOSM_PBR: {};
  Graphic3d_TOSM_PBR_FACET: {};
  Graphic3d_TOSM_NONE: {};
  V3d_COLOR: {};
  V3d_FLAT: {};
  V3d_GOURAUD: {};
  V3d_PHONG: {};
}

export declare type Graphic3d_CappingFlags = {
  Graphic3d_CappingFlags_None: {};
  Graphic3d_CappingFlags_ObjectMaterial: {};
  Graphic3d_CappingFlags_ObjectTexture: {};
  Graphic3d_CappingFlags_ObjectShader: {};
  Graphic3d_CappingFlags_ObjectAspect: {};
}

export declare type Graphic3d_NameOfTexturePlane = {
  Graphic3d_NOTP_XY: {};
  Graphic3d_NOTP_YZ: {};
  Graphic3d_NOTP_ZX: {};
  Graphic3d_NOTP_UNKNOWN: {};
}

export declare class Graphic3d_WorldViewProjState {
  IsValid(): Standard_Boolean;
  Reset(): void;
  Initialize_1(theProjectionState: Standard_ThreadId, theWorldViewState: Standard_ThreadId, theCamera: MMgt_TShared): void;
  Initialize_2(theCamera: MMgt_TShared): void;
  ProjectionState(): Standard_ThreadId;
  WorldViewState(): Standard_ThreadId;
  IsProjectionChanged(theState: Graphic3d_WorldViewProjState): Standard_Boolean;
  IsWorldViewChanged(theState: Graphic3d_WorldViewProjState): Standard_Boolean;
  IsChanged(theState: Graphic3d_WorldViewProjState): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, a1: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Graphic3d_WorldViewProjState_1 extends Graphic3d_WorldViewProjState {
    constructor();
  }

  export declare class Graphic3d_WorldViewProjState_2 extends Graphic3d_WorldViewProjState {
    constructor(theProjectionState: Standard_ThreadId, theWorldViewState: Standard_ThreadId, theCamera: MMgt_TShared);
  }

export declare type Graphic3d_TextPath = {
  Graphic3d_TP_UP: {};
  Graphic3d_TP_DOWN: {};
  Graphic3d_TP_LEFT: {};
  Graphic3d_TP_RIGHT: {};
}

export declare class Graphic3d_MutableIndexBuffer extends Graphic3d_IndexBuffer {
  constructor(theAlloc: Handle_NCollection_BaseAllocator)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsMutable(): Standard_Boolean;
  InvalidatedRange(): Graphic3d_BufferRange;
  Validate(): void;
  Invalidate_1(): void;
  Invalidate_2(theIndexLower: Graphic3d_ZLayerId, theIndexUpper: Graphic3d_ZLayerId): void;
  invalidate(theRange: Graphic3d_BufferRange): void;
  delete(): void;
}

export declare class Graphic3d_AttribBuffer extends Graphic3d_Buffer {
  constructor(theAlloc: Handle_NCollection_BaseAllocator)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Init_1(theNbElems: Graphic3d_ZLayerId, theAttribs: Graphic3d_Attribute, theNbAttribs: Graphic3d_ZLayerId): Standard_Boolean;
  Init_2(theNbElems: Graphic3d_ZLayerId, theAttribs: Graphic3d_Array1OfAttribute): Standard_Boolean;
  IsMutable(): Standard_Boolean;
  SetMutable(theMutable: Standard_Boolean): void;
  IsInterleaved(): Standard_Boolean;
  SetInterleaved(theIsInterleaved: Standard_Boolean): void;
  InvalidatedRange(): Graphic3d_BufferRange;
  Validate(): void;
  Invalidate_1(): void;
  Invalidate_2(theAttributeIndex: Graphic3d_ZLayerId): void;
  Invalidate_3(theAttributeIndex: Graphic3d_ZLayerId, theVertexLower: Graphic3d_ZLayerId, theVertexUpper: Graphic3d_ZLayerId): void;
  Invalidate_4(theVertexLower: Graphic3d_ZLayerId, theVertexUpper: Graphic3d_ZLayerId): void;
  invalidate(theRange: Graphic3d_BufferRange): void;
  delete(): void;
}

export declare type Graphic3d_VerticalTextAlignment = {
  Graphic3d_VTA_BOTTOM: {};
  Graphic3d_VTA_CENTER: {};
  Graphic3d_VTA_TOP: {};
  Graphic3d_VTA_TOPFIRSTLINE: {};
}

export declare class Handle_Graphic3d_IndexBuffer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_IndexBuffer): void;
  get(): Graphic3d_IndexBuffer;
  delete(): void;
}

  export declare class Handle_Graphic3d_IndexBuffer_1 extends Handle_Graphic3d_IndexBuffer {
    constructor();
  }

  export declare class Handle_Graphic3d_IndexBuffer_2 extends Handle_Graphic3d_IndexBuffer {
    constructor(thePtr: Graphic3d_IndexBuffer);
  }

  export declare class Handle_Graphic3d_IndexBuffer_3 extends Handle_Graphic3d_IndexBuffer {
    constructor(theHandle: Handle_Graphic3d_IndexBuffer);
  }

  export declare class Handle_Graphic3d_IndexBuffer_4 extends Handle_Graphic3d_IndexBuffer {
    constructor(theHandle: Handle_Graphic3d_IndexBuffer);
  }

export declare class Graphic3d_IndexBuffer extends Graphic3d_Buffer {
  constructor(theAlloc: Handle_NCollection_BaseAllocator)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  InitInt32(theNbElems: Graphic3d_ZLayerId): Standard_Boolean;
  Index(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetIndex(theIndex: Graphic3d_ZLayerId, theValue: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Graphic3d_TypeOfMaterial = {
  Graphic3d_MATERIAL_ASPECT: {};
  Graphic3d_MATERIAL_PHYSIC: {};
}

export declare type Graphic3d_TypeOfTextureFilter = {
  Graphic3d_TOTF_NEAREST: {};
  Graphic3d_TOTF_BILINEAR: {};
  Graphic3d_TOTF_TRILINEAR: {};
}

export declare class Graphic3d_Mat4d {
  constructor()
  static Rows(): size_t;
  static Cols(): size_t;
  GetValue(theRow: size_t, theCol: size_t): Standard_Real;
  ChangeValue(theRow: size_t, theCol: size_t): Standard_Real;
  SetValue(theRow: size_t, theCol: size_t, theValue: Standard_Real): void;
  GetRow(theRow: size_t): any;
  SetRow_1(theRow: size_t, theVec: NCollection_Vec3<Standard_Real>): void;
  SetRow_2(theRow: size_t, theVec: NCollection_Vec4<Standard_Real>): void;
  GetColumn(theCol: size_t): any;
  SetColumn_1(theCol: size_t, theVec: NCollection_Vec3<Standard_Real>): void;
  SetColumn_2(theCol: size_t, theVec: NCollection_Vec4<Standard_Real>): void;
  GetDiagonal(): any;
  SetDiagonal_1(theVec: NCollection_Vec3<Standard_Real>): void;
  SetDiagonal_2(theVec: NCollection_Vec4<Standard_Real>): void;
  InitIdentity(): void;
  IsIdentity(): boolean;
  IsEqual(theOther: Graphic3d_Mat4d): boolean;
  GetData(): Standard_Real;
  ChangeData(): Standard_Real;
  Multiply_1(theMatA: Graphic3d_Mat4d, theMatB: Graphic3d_Mat4d): Graphic3d_Mat4d;
  Multiply_2(theMat: Graphic3d_Mat4d): void;
  Multiplied_1(theMat: Graphic3d_Mat4d): Graphic3d_Mat4d;
  Multiply_3(theFactor: Standard_Real): void;
  Multiplied_2(theFactor: Standard_Real): Graphic3d_Mat4d;
  Translate(theVec: NCollection_Vec3<Standard_Real>): void;
  Transposed(): Graphic3d_Mat4d;
  Transpose(): void;
  Inverted(theOutMx: Graphic3d_Mat4d): boolean;
  static Map_1(theData: Standard_Real): Graphic3d_Mat4d;
  static Map_2(theData: Standard_Real): Graphic3d_Mat4d;
  DumpJson(theOStream: Standard_OStream, a1: Standard_Integer): void;
  delete(): void;
}

export declare class Handle_Graphic3d_ArrayOfQuadrangleStrips {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfQuadrangleStrips): void;
  get(): Graphic3d_ArrayOfQuadrangleStrips;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfQuadrangleStrips_1 extends Handle_Graphic3d_ArrayOfQuadrangleStrips {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfQuadrangleStrips_2 extends Handle_Graphic3d_ArrayOfQuadrangleStrips {
    constructor(thePtr: Graphic3d_ArrayOfQuadrangleStrips);
  }

  export declare class Handle_Graphic3d_ArrayOfQuadrangleStrips_3 extends Handle_Graphic3d_ArrayOfQuadrangleStrips {
    constructor(theHandle: Handle_Graphic3d_ArrayOfQuadrangleStrips);
  }

  export declare class Handle_Graphic3d_ArrayOfQuadrangleStrips_4 extends Handle_Graphic3d_ArrayOfQuadrangleStrips {
    constructor(theHandle: Handle_Graphic3d_ArrayOfQuadrangleStrips);
  }

export declare class Graphic3d_ArrayOfQuadrangleStrips extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfQuadrangleStrips_1 extends Graphic3d_ArrayOfQuadrangleStrips {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxStrips: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfQuadrangleStrips_2 extends Graphic3d_ArrayOfQuadrangleStrips {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxStrips: Graphic3d_ZLayerId, theHasVNormals: Standard_Boolean, theHasVColors: Standard_Boolean, theHasSColors: Standard_Boolean, theHasVTexels: Standard_Boolean);
  }

export declare class Handle_Graphic3d_Group {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Group): void;
  get(): Graphic3d_Group;
  delete(): void;
}

  export declare class Handle_Graphic3d_Group_1 extends Handle_Graphic3d_Group {
    constructor();
  }

  export declare class Handle_Graphic3d_Group_2 extends Handle_Graphic3d_Group {
    constructor(thePtr: Graphic3d_Group);
  }

  export declare class Handle_Graphic3d_Group_3 extends Handle_Graphic3d_Group {
    constructor(theHandle: Handle_Graphic3d_Group);
  }

  export declare class Handle_Graphic3d_Group_4 extends Handle_Graphic3d_Group {
    constructor(theHandle: Handle_Graphic3d_Group);
  }

export declare class Graphic3d_Group extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Clear(theUpdateStructureMgr: Standard_Boolean): void;
  Remove(): void;
  Aspects(): Handle_Graphic3d_Aspects;
  SetGroupPrimitivesAspect(theAspect: Handle_Graphic3d_Aspects): void;
  SetPrimitivesAspect(theAspect: Handle_Graphic3d_Aspects): void;
  SynchronizeAspects(): void;
  ReplaceAspects(theMap: Graphic3d_MapOfAspectsToAspects): void;
  AddText(theTextParams: Handle_Graphic3d_Text, theToEvalMinMax: Standard_Boolean): void;
  AddPrimitiveArray_1(theType: Graphic3d_TypeOfPrimitiveArray, theIndices: Handle_Graphic3d_IndexBuffer, theAttribs: Handle_Graphic3d_Buffer, theBounds: Handle_Graphic3d_BoundBuffer, theToEvalMinMax: Standard_Boolean): void;
  AddPrimitiveArray_2(thePrim: Handle_Graphic3d_ArrayOfPrimitives, theToEvalMinMax: Standard_Boolean): void;
  Marker(thePoint: Graphic3d_Vertex, theToEvalMinMax: Standard_Boolean): void;
  SetStencilTestOptions(theIsEnabled: Standard_Boolean): void;
  SetFlippingOptions(theIsEnabled: Standard_Boolean, theRefPlane: gp_Ax2): void;
  ContainsFacet(): Standard_Boolean;
  IsDeleted(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  MinMaxValues(theXMin: Quantity_AbsorbedDose, theYMin: Quantity_AbsorbedDose, theZMin: Quantity_AbsorbedDose, theXMax: Quantity_AbsorbedDose, theYMax: Quantity_AbsorbedDose, theZMax: Quantity_AbsorbedDose): void;
  SetMinMaxValues(theXMin: Quantity_AbsorbedDose, theYMin: Quantity_AbsorbedDose, theZMin: Quantity_AbsorbedDose, theXMax: Quantity_AbsorbedDose, theYMax: Quantity_AbsorbedDose, theZMax: Quantity_AbsorbedDose): void;
  BoundingBox(): Graphic3d_BndBox4f;
  ChangeBoundingBox(): Graphic3d_BndBox4f;
  Structure(): Handle_Graphic3d_Structure;
  SetClosed(theIsClosed: Standard_Boolean): void;
  IsClosed(): Standard_Boolean;
  Text_1(AText: Standard_CString, APoint: Graphic3d_Vertex, AHeight: Quantity_AbsorbedDose, AAngle: Quantity_AbsorbedDose, ATp: Graphic3d_TextPath, AHta: Graphic3d_HorizontalTextAlignment, AVta: Graphic3d_VerticalTextAlignment, EvalMinMax: Standard_Boolean): void;
  Text_2(AText: Standard_CString, APoint: Graphic3d_Vertex, AHeight: Quantity_AbsorbedDose, EvalMinMax: Standard_Boolean): void;
  Text_3(AText: TCollection_ExtendedString, APoint: Graphic3d_Vertex, AHeight: Quantity_AbsorbedDose, AAngle: Quantity_AbsorbedDose, ATp: Graphic3d_TextPath, AHta: Graphic3d_HorizontalTextAlignment, AVta: Graphic3d_VerticalTextAlignment, EvalMinMax: Standard_Boolean): void;
  Text_4(AText: TCollection_ExtendedString, APoint: Graphic3d_Vertex, AHeight: Quantity_AbsorbedDose, EvalMinMax: Standard_Boolean): void;
  Text_5(theTextUtf: Standard_CString, theOrientation: gp_Ax2, theHeight: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose, theTp: Graphic3d_TextPath, theHTA: Graphic3d_HorizontalTextAlignment, theVTA: Graphic3d_VerticalTextAlignment, theToEvalMinMax: Standard_Boolean, theHasOwnAnchor: Standard_Boolean): void;
  Text_6(theText: TCollection_ExtendedString, theOrientation: gp_Ax2, theHeight: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose, theTp: Graphic3d_TextPath, theHTA: Graphic3d_HorizontalTextAlignment, theVTA: Graphic3d_VerticalTextAlignment, theToEvalMinMax: Standard_Boolean, theHasOwnAnchor: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_ArrayOfQuadrangles extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfQuadrangles_1 extends Graphic3d_ArrayOfQuadrangles {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfQuadrangles_2 extends Graphic3d_ArrayOfQuadrangles {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theHasVNormals: Standard_Boolean, theHasVColors: Standard_Boolean, theHasVTexels: Standard_Boolean);
  }

export declare class Handle_Graphic3d_ArrayOfQuadrangles {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfQuadrangles): void;
  get(): Graphic3d_ArrayOfQuadrangles;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfQuadrangles_1 extends Handle_Graphic3d_ArrayOfQuadrangles {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfQuadrangles_2 extends Handle_Graphic3d_ArrayOfQuadrangles {
    constructor(thePtr: Graphic3d_ArrayOfQuadrangles);
  }

  export declare class Handle_Graphic3d_ArrayOfQuadrangles_3 extends Handle_Graphic3d_ArrayOfQuadrangles {
    constructor(theHandle: Handle_Graphic3d_ArrayOfQuadrangles);
  }

  export declare class Handle_Graphic3d_ArrayOfQuadrangles_4 extends Handle_Graphic3d_ArrayOfQuadrangles {
    constructor(theHandle: Handle_Graphic3d_ArrayOfQuadrangles);
  }

export declare class Graphic3d_GraphicDriver extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  InquireLimit(theType: Graphic3d_TypeOfLimit): Graphic3d_ZLayerId;
  InquireLightLimit(): Graphic3d_ZLayerId;
  InquirePlaneLimit(): Graphic3d_ZLayerId;
  InquireViewLimit(): Graphic3d_ZLayerId;
  CreateStructure(theManager: Handle_Graphic3d_StructureManager): Handle_Graphic3d_CStructure;
  RemoveStructure(theCStructure: Handle_Graphic3d_CStructure): void;
  CreateView(theMgr: Handle_Graphic3d_StructureManager): Handle_Graphic3d_CView;
  RemoveView(theView: Handle_Graphic3d_CView): void;
  EnableVBO(status: Standard_Boolean): void;
  MemoryInfo(theFreeBytes: Standard_ThreadId, theInfo: XCAFDoc_PartId): Standard_Boolean;
  DefaultTextHeight(): Standard_ShortReal;
  TextSize(theView: Handle_Graphic3d_CView, theText: Standard_CString, theHeight: Standard_ShortReal, theWidth: Standard_ShortReal, theAscent: Standard_ShortReal, theDescent: Standard_ShortReal): void;
  InsertLayerBefore(theNewLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings, theLayerAfter: Graphic3d_ZLayerId): void;
  InsertLayerAfter(theNewLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings, theLayerBefore: Graphic3d_ZLayerId): void;
  RemoveZLayer(theLayerId: Graphic3d_ZLayerId): void;
  ZLayers(theLayerSeq: TColStd_SequenceOfInteger): void;
  SetZLayerSettings(theLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings): void;
  ZLayerSettings(theLayerId: Graphic3d_ZLayerId): Graphic3d_ZLayerSettings;
  ViewExists(theWindow: Handle_Aspect_Window, theView: Handle_Graphic3d_CView): Standard_Boolean;
  GetDisplayConnection(): Handle_Aspect_DisplayConnection;
  NewIdentification(): Graphic3d_ZLayerId;
  RemoveIdentification(theId: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Graphic3d_GraphicDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_GraphicDriver): void;
  get(): Graphic3d_GraphicDriver;
  delete(): void;
}

  export declare class Handle_Graphic3d_GraphicDriver_1 extends Handle_Graphic3d_GraphicDriver {
    constructor();
  }

  export declare class Handle_Graphic3d_GraphicDriver_2 extends Handle_Graphic3d_GraphicDriver {
    constructor(thePtr: Graphic3d_GraphicDriver);
  }

  export declare class Handle_Graphic3d_GraphicDriver_3 extends Handle_Graphic3d_GraphicDriver {
    constructor(theHandle: Handle_Graphic3d_GraphicDriver);
  }

  export declare class Handle_Graphic3d_GraphicDriver_4 extends Handle_Graphic3d_GraphicDriver {
    constructor(theHandle: Handle_Graphic3d_GraphicDriver);
  }

export declare type Graphic3d_TypeOfTextureMode = {
  Graphic3d_TOTM_OBJECT: {};
  Graphic3d_TOTM_SPHERE: {};
  Graphic3d_TOTM_EYE: {};
  Graphic3d_TOTM_MANUAL: {};
  Graphic3d_TOTM_SPRITE: {};
}

export declare class Handle_Graphic3d_TransformError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_TransformError): void;
  get(): Graphic3d_TransformError;
  delete(): void;
}

  export declare class Handle_Graphic3d_TransformError_1 extends Handle_Graphic3d_TransformError {
    constructor();
  }

  export declare class Handle_Graphic3d_TransformError_2 extends Handle_Graphic3d_TransformError {
    constructor(thePtr: Graphic3d_TransformError);
  }

  export declare class Handle_Graphic3d_TransformError_3 extends Handle_Graphic3d_TransformError {
    constructor(theHandle: Handle_Graphic3d_TransformError);
  }

  export declare class Handle_Graphic3d_TransformError_4 extends Handle_Graphic3d_TransformError {
    constructor(theHandle: Handle_Graphic3d_TransformError);
  }

export declare class Graphic3d_TransformError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Graphic3d_TransformError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_TransformError_1 extends Graphic3d_TransformError {
    constructor();
  }

  export declare class Graphic3d_TransformError_2 extends Graphic3d_TransformError {
    constructor(theMessage: Standard_CString);
  }

export declare class Graphic3d_TextureEnv extends Graphic3d_TextureRoot {
  Name(): Graphic3d_NameOfTextureEnv;
  static NumberOfTextures(): Graphic3d_ZLayerId;
  static TextureName(theRank: Graphic3d_ZLayerId): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_TextureEnv_1 extends Graphic3d_TextureEnv {
    constructor(theFileName: XCAFDoc_PartId);
  }

  export declare class Graphic3d_TextureEnv_2 extends Graphic3d_TextureEnv {
    constructor(theName: Graphic3d_NameOfTextureEnv);
  }

  export declare class Graphic3d_TextureEnv_3 extends Graphic3d_TextureEnv {
    constructor(thePixMap: Handle_Image_PixMap);
  }

export declare class Handle_Graphic3d_TextureEnv {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_TextureEnv): void;
  get(): Graphic3d_TextureEnv;
  delete(): void;
}

  export declare class Handle_Graphic3d_TextureEnv_1 extends Handle_Graphic3d_TextureEnv {
    constructor();
  }

  export declare class Handle_Graphic3d_TextureEnv_2 extends Handle_Graphic3d_TextureEnv {
    constructor(thePtr: Graphic3d_TextureEnv);
  }

  export declare class Handle_Graphic3d_TextureEnv_3 extends Handle_Graphic3d_TextureEnv {
    constructor(theHandle: Handle_Graphic3d_TextureEnv);
  }

  export declare class Handle_Graphic3d_TextureEnv_4 extends Handle_Graphic3d_TextureEnv {
    constructor(theHandle: Handle_Graphic3d_TextureEnv);
  }

export declare class Graphic3d_CView extends Graphic3d_DataStructureManager {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Identification(): Graphic3d_ZLayerId;
  Activate(): void;
  Deactivate(): void;
  IsActive(): Standard_Boolean;
  Remove(): void;
  IsRemoved(): Standard_Boolean;
  Camera(): Handle_Graphic3d_Camera;
  SetCamera(theCamera: Handle_Graphic3d_Camera): void;
  ShadingModel(): V3d_TypeOfShadingModel;
  SetShadingModel(theModel: V3d_TypeOfShadingModel): void;
  VisualizationType(): Graphic3d_TypeOfVisualization;
  SetVisualizationType(theType: Graphic3d_TypeOfVisualization): void;
  SetComputedMode(theMode: Standard_Boolean): void;
  ComputedMode(): Standard_Boolean;
  ReCompute(theStructure: Handle_Graphic3d_Structure): void;
  Update(theLayerId: Graphic3d_ZLayerId): void;
  Compute(): void;
  ContainsFacet_1(): Standard_Boolean;
  ContainsFacet_2(theSet: Graphic3d_MapOfStructure): Standard_Boolean;
  DisplayedStructures(theStructures: Graphic3d_MapOfStructure): void;
  NumberOfDisplayedStructures(): Graphic3d_ZLayerId;
  HiddenObjects(): any;
  ChangeHiddenObjects(): any;
  IsComputed_1(theStructId: Graphic3d_ZLayerId, theComputedStruct: Handle_Graphic3d_Structure): Standard_Boolean;
  MinMaxValues_1(theToIncludeAuxiliary: Standard_Boolean): Bnd_Box;
  MinMaxValues_2(theSet: Graphic3d_MapOfStructure, theToIncludeAuxiliary: Standard_Boolean): Bnd_Box;
  StructureManager(): Handle_Graphic3d_StructureManager;
  Redraw(): void;
  RedrawImmediate(): void;
  Invalidate(): void;
  IsInvalidated(): Standard_Boolean;
  Resized(): void;
  SetImmediateModeDrawToFront(theDrawToFrontBuffer: Standard_Boolean): Standard_Boolean;
  SetWindow(theWindow: Handle_Aspect_Window, theContext: Aspect_RenderingContext): void;
  Window(): Handle_Aspect_Window;
  IsDefined(): Standard_Boolean;
  BufferDump(theImage: Image_PixMap, theBufferType: Graphic3d_BufferType): Standard_Boolean;
  InvalidateBVHData(theLayerId: Graphic3d_ZLayerId): void;
  InsertLayerBefore(theNewLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings, theLayerAfter: Graphic3d_ZLayerId): void;
  InsertLayerAfter(theNewLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings, theLayerBefore: Graphic3d_ZLayerId): void;
  ZLayerMax(): Graphic3d_ZLayerId;
  Layers(): any;
  Layer(theLayerId: Graphic3d_ZLayerId): any;
  InvalidateZLayerBoundingBox(theLayerId: Graphic3d_ZLayerId): void;
  RemoveZLayer(theLayerId: Graphic3d_ZLayerId): void;
  SetZLayerSettings(theLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings): void;
  ConsiderZoomPersistenceObjects(): Quantity_AbsorbedDose;
  FBO(): Handle_Standard_Transient;
  SetFBO(theFbo: Handle_Standard_Transient): void;
  FBOCreate(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): Handle_Standard_Transient;
  FBORelease(theFbo: Handle_Standard_Transient): void;
  FBOGetDimensions(theFbo: Handle_Standard_Transient, theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId, theWidthMax: Graphic3d_ZLayerId, theHeightMax: Graphic3d_ZLayerId): void;
  FBOChangeViewport(theFbo: Handle_Standard_Transient, theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  CopySettings(theOther: Handle_Graphic3d_CView): void;
  RenderingParams(): Graphic3d_RenderingParams;
  ChangeRenderingParams(): Graphic3d_RenderingParams;
  Background(): Aspect_Background;
  SetBackground(theBackground: Aspect_Background): void;
  GradientBackground(): Aspect_GradientBackground;
  SetGradientBackground(theBackground: Aspect_GradientBackground): void;
  BackgroundImage(): Handle_Graphic3d_TextureMap;
  SetBackgroundImage(theTextureMap: Handle_Graphic3d_TextureMap, theToUpdatePBREnv: Standard_Boolean): void;
  BackgroundImageStyle(): Aspect_FillMethod;
  SetBackgroundImageStyle(theFillStyle: Aspect_FillMethod): void;
  BackgroundCubeMap(): Handle_Graphic3d_CubeMap;
  GeneratePBREnvironment(): void;
  ClearPBREnvironment(): void;
  TextureEnv(): Handle_Graphic3d_TextureEnv;
  SetTextureEnv(theTextureEnv: Handle_Graphic3d_TextureEnv): void;
  BackfacingModel(): Graphic3d_TypeOfBackfacingModel;
  SetBackfacingModel(theModel: Graphic3d_TypeOfBackfacingModel): void;
  Lights(): Handle_Graphic3d_LightSet;
  SetLights(theLights: Handle_Graphic3d_LightSet): void;
  ClipPlanes(): Handle_Graphic3d_SequenceOfHClipPlane;
  SetClipPlanes(thePlanes: Handle_Graphic3d_SequenceOfHClipPlane): void;
  DiagnosticInformation(theDict: TColStd_IndexedDataMapOfStringString, theFlags: Graphic3d_DiagnosticInfo): void;
  StatisticInformation_1(): XCAFDoc_PartId;
  StatisticInformation_2(theDict: TColStd_IndexedDataMapOfStringString): void;
  UnitFactor(): Quantity_AbsorbedDose;
  SetUnitFactor(theFactor: Quantity_AbsorbedDose): void;
  XRSession(): any;
  SetXRSession(theSession: any): void;
  IsActiveXR(): Standard_Boolean;
  InitXR(): Standard_Boolean;
  ReleaseXR(): void;
  ProcessXRInput(): void;
  SetupXRPosedCamera(): void;
  UnsetXRPosedCamera(): void;
  PosedXRCamera(): Handle_Graphic3d_Camera;
  SetPosedXRCamera(theCamera: Handle_Graphic3d_Camera): void;
  BaseXRCamera(): Handle_Graphic3d_Camera;
  SetBaseXRCamera(theCamera: Handle_Graphic3d_Camera): void;
  PoseXRToWorld(thePoseXR: gp_Trsf): gp_Trsf;
  SynchronizeXRBaseToPosedCamera(): void;
  SynchronizeXRPosedToBaseCamera(): void;
  ComputeXRPosedCameraFromBase(theCam: Graphic3d_Camera, theXRTrsf: gp_Trsf): void;
  ComputeXRBaseCameraFromPosed(theCamPosed: Graphic3d_Camera, thePoseTrsf: gp_Trsf): void;
  TurnViewXRCamera(theTrsfTurn: gp_Trsf): void;
  GetGraduatedTrihedron(): Graphic3d_GraduatedTrihedron;
  GraduatedTrihedronDisplay(theTrihedronData: Graphic3d_GraduatedTrihedron): void;
  GraduatedTrihedronErase(): void;
  GraduatedTrihedronMinMaxValues(theMin: OpenGl_Vec3, theMax: OpenGl_Vec3): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Graphic3d_CView {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_CView): void;
  get(): Graphic3d_CView;
  delete(): void;
}

  export declare class Handle_Graphic3d_CView_1 extends Handle_Graphic3d_CView {
    constructor();
  }

  export declare class Handle_Graphic3d_CView_2 extends Handle_Graphic3d_CView {
    constructor(thePtr: Graphic3d_CView);
  }

  export declare class Handle_Graphic3d_CView_3 extends Handle_Graphic3d_CView {
    constructor(theHandle: Handle_Graphic3d_CView);
  }

  export declare class Handle_Graphic3d_CView_4 extends Handle_Graphic3d_CView {
    constructor(theHandle: Handle_Graphic3d_CView);
  }

export declare type Graphic3d_TypeOfData = {
  Graphic3d_TOD_USHORT: {};
  Graphic3d_TOD_UINT: {};
  Graphic3d_TOD_VEC2: {};
  Graphic3d_TOD_VEC3: {};
  Graphic3d_TOD_VEC4: {};
  Graphic3d_TOD_VEC4UB: {};
  Graphic3d_TOD_FLOAT: {};
}

export declare type Graphic3d_TypeOfAttribute = {
  Graphic3d_TOA_POS: {};
  Graphic3d_TOA_NORM: {};
  Graphic3d_TOA_UV: {};
  Graphic3d_TOA_COLOR: {};
  Graphic3d_TOA_CUSTOM: {};
}

export declare class Handle_Graphic3d_Buffer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Buffer): void;
  get(): Graphic3d_Buffer;
  delete(): void;
}

  export declare class Handle_Graphic3d_Buffer_1 extends Handle_Graphic3d_Buffer {
    constructor();
  }

  export declare class Handle_Graphic3d_Buffer_2 extends Handle_Graphic3d_Buffer {
    constructor(thePtr: Graphic3d_Buffer);
  }

  export declare class Handle_Graphic3d_Buffer_3 extends Handle_Graphic3d_Buffer {
    constructor(theHandle: Handle_Graphic3d_Buffer);
  }

  export declare class Handle_Graphic3d_Buffer_4 extends Handle_Graphic3d_Buffer {
    constructor(theHandle: Handle_Graphic3d_Buffer);
  }

export declare class Graphic3d_Buffer extends NCollection_Buffer {
  constructor(theAlloc: Handle_NCollection_BaseAllocator)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NbMaxElements(): Graphic3d_ZLayerId;
  AttributesArray(): Graphic3d_Attribute;
  Attribute(theAttribIndex: Graphic3d_ZLayerId): Graphic3d_Attribute;
  ChangeAttribute(theAttribIndex: Graphic3d_ZLayerId): Graphic3d_Attribute;
  FindAttribute(theAttrib: Graphic3d_TypeOfAttribute): Graphic3d_ZLayerId;
  AttributeOffset(theAttribIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Data_1(theAttribIndex: Graphic3d_ZLayerId): Standard_Byte;
  ChangeData_1(theAttribIndex: Graphic3d_ZLayerId): Standard_Byte;
  value(theElem: Graphic3d_ZLayerId): Standard_Byte;
  changeValue(theElem: Graphic3d_ZLayerId): Standard_Byte;
  Data_2(): Standard_Byte;
  ChangeData_2(): Standard_Byte;
  ChangeAttributeData(theAttrib: Graphic3d_TypeOfAttribute, theAttribIndex: Graphic3d_ZLayerId, theAttribStride: Standard_ThreadId): Standard_Byte;
  AttributeData(theAttrib: Graphic3d_TypeOfAttribute, theAttribIndex: Graphic3d_ZLayerId, theAttribStride: Standard_ThreadId): Standard_Byte;
  release(): void;
  Init_1(theNbElems: Graphic3d_ZLayerId, theAttribs: Graphic3d_Attribute, theNbAttribs: Graphic3d_ZLayerId): Standard_Boolean;
  Init_2(theNbElems: Graphic3d_ZLayerId, theAttribs: Graphic3d_Array1OfAttribute): Standard_Boolean;
  IsInterleaved(): Standard_Boolean;
  IsMutable(): Standard_Boolean;
  InvalidatedRange(): Graphic3d_BufferRange;
  Validate(): void;
  Invalidate(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_Attribute {
  constructor();
  Stride_1(): Graphic3d_ZLayerId;
  static Stride_2(theType: Graphic3d_TypeOfData): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Graphic3d_Array1OfAttribute {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Graphic3d_Attribute): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Graphic3d_Array1OfAttribute): Graphic3d_Array1OfAttribute;
  Move(theOther: Graphic3d_Array1OfAttribute): Graphic3d_Array1OfAttribute;
  First(): Graphic3d_Attribute;
  ChangeFirst(): Graphic3d_Attribute;
  Last(): Graphic3d_Attribute;
  ChangeLast(): Graphic3d_Attribute;
  Value(theIndex: Standard_Integer): Graphic3d_Attribute;
  ChangeValue(theIndex: Standard_Integer): Graphic3d_Attribute;
  SetValue(theIndex: Standard_Integer, theItem: Graphic3d_Attribute): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Graphic3d_Array1OfAttribute_1 extends Graphic3d_Array1OfAttribute {
    constructor();
  }

  export declare class Graphic3d_Array1OfAttribute_2 extends Graphic3d_Array1OfAttribute {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Graphic3d_Array1OfAttribute_3 extends Graphic3d_Array1OfAttribute {
    constructor(theOther: Graphic3d_Array1OfAttribute);
  }

  export declare class Graphic3d_Array1OfAttribute_4 extends Graphic3d_Array1OfAttribute {
    constructor(theOther: Graphic3d_Array1OfAttribute);
  }

  export declare class Graphic3d_Array1OfAttribute_5 extends Graphic3d_Array1OfAttribute {
    constructor(theBegin: Graphic3d_Attribute, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Graphic3d_SequenceOfHClipPlane extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ToOverrideGlobal(): Standard_Boolean;
  SetOverrideGlobal(theToOverride: Standard_Boolean): void;
  IsEmpty(): Standard_Boolean;
  Size(): Graphic3d_ZLayerId;
  Append(theItem: Handle_Graphic3d_ClipPlane): Standard_Boolean;
  Remove_1(theItem: Handle_Graphic3d_ClipPlane): Standard_Boolean;
  Remove_2(theItem: any): void;
  Clear(): void;
  First(): Handle_Graphic3d_ClipPlane;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Graphic3d_SequenceOfHClipPlane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_SequenceOfHClipPlane): void;
  get(): Graphic3d_SequenceOfHClipPlane;
  delete(): void;
}

  export declare class Handle_Graphic3d_SequenceOfHClipPlane_1 extends Handle_Graphic3d_SequenceOfHClipPlane {
    constructor();
  }

  export declare class Handle_Graphic3d_SequenceOfHClipPlane_2 extends Handle_Graphic3d_SequenceOfHClipPlane {
    constructor(thePtr: Graphic3d_SequenceOfHClipPlane);
  }

  export declare class Handle_Graphic3d_SequenceOfHClipPlane_3 extends Handle_Graphic3d_SequenceOfHClipPlane {
    constructor(theHandle: Handle_Graphic3d_SequenceOfHClipPlane);
  }

  export declare class Handle_Graphic3d_SequenceOfHClipPlane_4 extends Handle_Graphic3d_SequenceOfHClipPlane {
    constructor(theHandle: Handle_Graphic3d_SequenceOfHClipPlane);
  }

export declare class Graphic3d_ArrayOfPolygons extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfPolygons_1 extends Graphic3d_ArrayOfPolygons {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxBounds: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfPolygons_2 extends Graphic3d_ArrayOfPolygons {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxBounds: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theHasVNormals: Standard_Boolean, theHasVColors: Standard_Boolean, theHasBColors: Standard_Boolean, theHasVTexels: Standard_Boolean);
  }

export declare class Handle_Graphic3d_ArrayOfPolygons {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfPolygons): void;
  get(): Graphic3d_ArrayOfPolygons;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfPolygons_1 extends Handle_Graphic3d_ArrayOfPolygons {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfPolygons_2 extends Handle_Graphic3d_ArrayOfPolygons {
    constructor(thePtr: Graphic3d_ArrayOfPolygons);
  }

  export declare class Handle_Graphic3d_ArrayOfPolygons_3 extends Handle_Graphic3d_ArrayOfPolygons {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPolygons);
  }

  export declare class Handle_Graphic3d_ArrayOfPolygons_4 extends Handle_Graphic3d_ArrayOfPolygons {
    constructor(theHandle: Handle_Graphic3d_ArrayOfPolygons);
  }

export declare class Handle_Graphic3d_PriorityDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_PriorityDefinitionError): void;
  get(): Graphic3d_PriorityDefinitionError;
  delete(): void;
}

  export declare class Handle_Graphic3d_PriorityDefinitionError_1 extends Handle_Graphic3d_PriorityDefinitionError {
    constructor();
  }

  export declare class Handle_Graphic3d_PriorityDefinitionError_2 extends Handle_Graphic3d_PriorityDefinitionError {
    constructor(thePtr: Graphic3d_PriorityDefinitionError);
  }

  export declare class Handle_Graphic3d_PriorityDefinitionError_3 extends Handle_Graphic3d_PriorityDefinitionError {
    constructor(theHandle: Handle_Graphic3d_PriorityDefinitionError);
  }

  export declare class Handle_Graphic3d_PriorityDefinitionError_4 extends Handle_Graphic3d_PriorityDefinitionError {
    constructor(theHandle: Handle_Graphic3d_PriorityDefinitionError);
  }

export declare class Graphic3d_PriorityDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Graphic3d_PriorityDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_PriorityDefinitionError_1 extends Graphic3d_PriorityDefinitionError {
    constructor();
  }

  export declare class Graphic3d_PriorityDefinitionError_2 extends Graphic3d_PriorityDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Graphic3d_PolygonOffset {
  constructor()
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_ShaderProgram extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsDone(): Standard_Boolean;
  GetId(): XCAFDoc_PartId;
  SetId(theId: XCAFDoc_PartId): void;
  Header(): XCAFDoc_PartId;
  SetHeader(theHeader: XCAFDoc_PartId): void;
  AppendToHeader(theHeaderLine: XCAFDoc_PartId): void;
  NbLightsMax(): Graphic3d_ZLayerId;
  SetNbLightsMax(theNbLights: Graphic3d_ZLayerId): void;
  NbClipPlanesMax(): Graphic3d_ZLayerId;
  SetNbClipPlanesMax(theNbPlanes: Graphic3d_ZLayerId): void;
  AttachShader(theShader: Handle_Graphic3d_ShaderObject): Standard_Boolean;
  DetachShader(theShader: Handle_Graphic3d_ShaderObject): Standard_Boolean;
  ShaderObjects(): Graphic3d_ShaderObjectList;
  Variables(): Graphic3d_ShaderVariableList;
  VertexAttributes(): Graphic3d_ShaderAttributeList;
  SetVertexAttributes(theAttributes: Graphic3d_ShaderAttributeList): void;
  NbFragmentOutputs(): Graphic3d_ZLayerId;
  SetNbFragmentOutputs(theNbOutputs: Graphic3d_ZLayerId): void;
  HasAlphaTest(): Standard_Boolean;
  SetAlphaTest(theAlphaTest: Standard_Boolean): void;
  HasDefaultSampler(): Standard_Boolean;
  SetDefaultSampler(theHasDefSampler: Standard_Boolean): void;
  HasWeightOitOutput(): Standard_Boolean;
  SetWeightOitOutput(theOutput: Standard_Boolean): void;
  IsPBR(): Standard_Boolean;
  SetPBR(theIsPBR: Standard_Boolean): void;
  TextureSetBits(): Graphic3d_ZLayerId;
  SetTextureSetBits(theBits: Graphic3d_ZLayerId): void;
  ClearVariables(): void;
  PushVariableFloat(theName: XCAFDoc_PartId, theValue: Standard_ShortReal): Standard_Boolean;
  PushVariableVec2(theName: XCAFDoc_PartId, theValue: OpenGl_Vec2): Standard_Boolean;
  PushVariableVec3(theName: XCAFDoc_PartId, theValue: OpenGl_Vec3): Standard_Boolean;
  PushVariableVec4(theName: XCAFDoc_PartId, theValue: OpenGl_Vec4): Standard_Boolean;
  PushVariableInt(theName: XCAFDoc_PartId, theValue: Standard_Integer): Standard_Boolean;
  PushVariableVec2i(theName: XCAFDoc_PartId, theValue: OpenGl_Vec2i): Standard_Boolean;
  PushVariableVec3i(theName: XCAFDoc_PartId, theValue: OpenGl_Vec3i): Standard_Boolean;
  PushVariableVec4i(theName: XCAFDoc_PartId, theValue: OpenGl_Vec4i): Standard_Boolean;
  static ShadersFolder(): XCAFDoc_PartId;
  delete(): void;
}

export declare class Handle_Graphic3d_ShaderProgram {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ShaderProgram): void;
  get(): Graphic3d_ShaderProgram;
  delete(): void;
}

  export declare class Handle_Graphic3d_ShaderProgram_1 extends Handle_Graphic3d_ShaderProgram {
    constructor();
  }

  export declare class Handle_Graphic3d_ShaderProgram_2 extends Handle_Graphic3d_ShaderProgram {
    constructor(thePtr: Graphic3d_ShaderProgram);
  }

  export declare class Handle_Graphic3d_ShaderProgram_3 extends Handle_Graphic3d_ShaderProgram {
    constructor(theHandle: Handle_Graphic3d_ShaderProgram);
  }

  export declare class Handle_Graphic3d_ShaderProgram_4 extends Handle_Graphic3d_ShaderProgram {
    constructor(theHandle: Handle_Graphic3d_ShaderProgram);
  }

export declare class Graphic3d_AspectMarker3d extends Graphic3d_Aspects {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Scale(): Standard_ShortReal;
  SetScale_1(theScale: Standard_ShortReal): void;
  SetScale_2(theScale: Quantity_AbsorbedDose): void;
  Type(): Aspect_TypeOfMarker;
  SetType(theType: Aspect_TypeOfMarker): void;
  GetTextureSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  GetMarkerImage(): Handle_Graphic3d_MarkerImage;
  SetBitMap(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId, theTexture: Handle_TColStd_HArray1OfByte): void;
  delete(): void;
}

  export declare class Graphic3d_AspectMarker3d_1 extends Graphic3d_AspectMarker3d {
    constructor();
  }

  export declare class Graphic3d_AspectMarker3d_2 extends Graphic3d_AspectMarker3d {
    constructor(theType: Aspect_TypeOfMarker, theColor: Quantity_Color, theScale: Quantity_AbsorbedDose);
  }

  export declare class Graphic3d_AspectMarker3d_3 extends Graphic3d_AspectMarker3d {
    constructor(theColor: Quantity_Color, theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId, theTextureBitmap: Handle_TColStd_HArray1OfByte);
  }

  export declare class Graphic3d_AspectMarker3d_4 extends Graphic3d_AspectMarker3d {
    constructor(theTextureImage: Handle_Image_PixMap);
  }

export declare class Handle_Graphic3d_AspectMarker3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_AspectMarker3d): void;
  get(): Graphic3d_AspectMarker3d;
  delete(): void;
}

  export declare class Handle_Graphic3d_AspectMarker3d_1 extends Handle_Graphic3d_AspectMarker3d {
    constructor();
  }

  export declare class Handle_Graphic3d_AspectMarker3d_2 extends Handle_Graphic3d_AspectMarker3d {
    constructor(thePtr: Graphic3d_AspectMarker3d);
  }

  export declare class Handle_Graphic3d_AspectMarker3d_3 extends Handle_Graphic3d_AspectMarker3d {
    constructor(theHandle: Handle_Graphic3d_AspectMarker3d);
  }

  export declare class Handle_Graphic3d_AspectMarker3d_4 extends Handle_Graphic3d_AspectMarker3d {
    constructor(theHandle: Handle_Graphic3d_AspectMarker3d);
  }

export declare class Graphic3d_AxisAspect {
  constructor(theName: TCollection_ExtendedString, theNameColor: Quantity_Color, theColor: Quantity_Color, theValuesOffset: Graphic3d_ZLayerId, theNameOffset: Graphic3d_ZLayerId, theTickmarksNumber: Graphic3d_ZLayerId, theTickmarksLength: Graphic3d_ZLayerId, theToDrawName: Standard_Boolean, theToDrawValues: Standard_Boolean, theToDrawTickmarks: Standard_Boolean)
  SetName(theName: TCollection_ExtendedString): void;
  Name(): TCollection_ExtendedString;
  ToDrawName(): Standard_Boolean;
  SetDrawName(theToDraw: Standard_Boolean): void;
  ToDrawTickmarks(): Standard_Boolean;
  SetDrawTickmarks(theToDraw: Standard_Boolean): void;
  ToDrawValues(): Standard_Boolean;
  SetDrawValues(theToDraw: Standard_Boolean): void;
  NameColor(): Quantity_Color;
  SetNameColor(theColor: Quantity_Color): void;
  Color(): Quantity_Color;
  SetColor(theColor: Quantity_Color): void;
  TickmarksNumber(): Graphic3d_ZLayerId;
  SetTickmarksNumber(theValue: Graphic3d_ZLayerId): void;
  TickmarksLength(): Graphic3d_ZLayerId;
  SetTickmarksLength(theValue: Graphic3d_ZLayerId): void;
  ValuesOffset(): Graphic3d_ZLayerId;
  SetValuesOffset(theValue: Graphic3d_ZLayerId): void;
  NameOffset(): Graphic3d_ZLayerId;
  SetNameOffset(theValue: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_GraduatedTrihedron {
  constructor(theNamesFont: XCAFDoc_PartId, theNamesStyle: Font_FontAspect, theNamesSize: Graphic3d_ZLayerId, theValuesFont: XCAFDoc_PartId, theValuesStyle: Font_FontAspect, theValuesSize: Graphic3d_ZLayerId, theArrowsLength: Standard_ShortReal, theGridColor: Quantity_Color, theToDrawGrid: Standard_Boolean, theToDrawAxes: Standard_Boolean)
  ChangeXAxisAspect(): Graphic3d_AxisAspect;
  ChangeYAxisAspect(): Graphic3d_AxisAspect;
  ChangeZAxisAspect(): Graphic3d_AxisAspect;
  ChangeAxisAspect(theIndex: Graphic3d_ZLayerId): Graphic3d_AxisAspect;
  XAxisAspect(): Graphic3d_AxisAspect;
  YAxisAspect(): Graphic3d_AxisAspect;
  ZAxisAspect(): Graphic3d_AxisAspect;
  AxisAspect(theIndex: Graphic3d_ZLayerId): Graphic3d_AxisAspect;
  ArrowsLength(): Standard_ShortReal;
  SetArrowsLength(theValue: Standard_ShortReal): void;
  GridColor(): Quantity_Color;
  SetGridColor(theColor: Quantity_Color): void;
  ToDrawGrid(): Standard_Boolean;
  SetDrawGrid(theToDraw: Standard_Boolean): void;
  ToDrawAxes(): Standard_Boolean;
  SetDrawAxes(theToDraw: Standard_Boolean): void;
  NamesFont(): XCAFDoc_PartId;
  SetNamesFont(theFont: XCAFDoc_PartId): void;
  NamesFontAspect(): Font_FontAspect;
  SetNamesFontAspect(theAspect: Font_FontAspect): void;
  NamesSize(): Graphic3d_ZLayerId;
  SetNamesSize(theValue: Graphic3d_ZLayerId): void;
  ValuesFont(): XCAFDoc_PartId;
  SetValuesFont(theFont: XCAFDoc_PartId): void;
  ValuesFontAspect(): Font_FontAspect;
  SetValuesFontAspect(theAspect: Font_FontAspect): void;
  ValuesSize(): Graphic3d_ZLayerId;
  SetValuesSize(theValue: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_BufferRange {
  IsEmpty(): Standard_Boolean;
  Upper(): Graphic3d_ZLayerId;
  Clear(): void;
  Unite(theRange: Graphic3d_BufferRange): void;
  delete(): void;
}

  export declare class Graphic3d_BufferRange_1 extends Graphic3d_BufferRange {
    constructor();
  }

  export declare class Graphic3d_BufferRange_2 extends Graphic3d_BufferRange {
    constructor(theStart: Graphic3d_ZLayerId, theLength: Graphic3d_ZLayerId);
  }

export declare type Graphic3d_CubeMapSide = {
  Graphic3d_CMS_POS_X: {};
  Graphic3d_CMS_NEG_X: {};
  Graphic3d_CMS_POS_Y: {};
  Graphic3d_CMS_NEG_Y: {};
  Graphic3d_CMS_POS_Z: {};
  Graphic3d_CMS_NEG_Z: {};
}

export declare type Graphic3d_TypeOfPrimitiveArray = {
  Graphic3d_TOPA_UNDEFINED: {};
  Graphic3d_TOPA_POINTS: {};
  Graphic3d_TOPA_SEGMENTS: {};
  Graphic3d_TOPA_POLYLINES: {};
  Graphic3d_TOPA_TRIANGLES: {};
  Graphic3d_TOPA_TRIANGLESTRIPS: {};
  Graphic3d_TOPA_TRIANGLEFANS: {};
  Graphic3d_TOPA_LINES_ADJACENCY: {};
  Graphic3d_TOPA_LINE_STRIP_ADJACENCY: {};
  Graphic3d_TOPA_TRIANGLES_ADJACENCY: {};
  Graphic3d_TOPA_TRIANGLE_STRIP_ADJACENCY: {};
  Graphic3d_TOPA_QUADRANGLES: {};
  Graphic3d_TOPA_QUADRANGLESTRIPS: {};
  Graphic3d_TOPA_POLYGONS: {};
}

export declare class Handle_Graphic3d_ShaderObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ShaderObject): void;
  get(): Graphic3d_ShaderObject;
  delete(): void;
}

  export declare class Handle_Graphic3d_ShaderObject_1 extends Handle_Graphic3d_ShaderObject {
    constructor();
  }

  export declare class Handle_Graphic3d_ShaderObject_2 extends Handle_Graphic3d_ShaderObject {
    constructor(thePtr: Graphic3d_ShaderObject);
  }

  export declare class Handle_Graphic3d_ShaderObject_3 extends Handle_Graphic3d_ShaderObject {
    constructor(theHandle: Handle_Graphic3d_ShaderObject);
  }

  export declare class Handle_Graphic3d_ShaderObject_4 extends Handle_Graphic3d_ShaderObject {
    constructor(theHandle: Handle_Graphic3d_ShaderObject);
  }

export declare class Graphic3d_ShaderObject extends Standard_Transient {
  IsDone(): Standard_Boolean;
  Path(): OSD_Path;
  Source(): XCAFDoc_PartId;
  Type(): Graphic3d_TypeOfShaderObject;
  GetId(): XCAFDoc_PartId;
  static CreateFromFile(theType: Graphic3d_TypeOfShaderObject, thePath: XCAFDoc_PartId): Handle_Graphic3d_ShaderObject;
  static CreateFromSource(theType: Graphic3d_TypeOfShaderObject, theSource: XCAFDoc_PartId): Handle_Graphic3d_ShaderObject;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Graphic3d_TextureParams extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  TextureUnit(): Graphic3d_TextureUnit;
  SetTextureUnit(theUnit: Graphic3d_TextureUnit): void;
  IsModulate(): Standard_Boolean;
  SetModulate(theToModulate: Standard_Boolean): void;
  IsRepeat(): Standard_Boolean;
  SetRepeat(theToRepeat: Standard_Boolean): void;
  Filter(): Graphic3d_TypeOfTextureFilter;
  SetFilter(theFilter: Graphic3d_TypeOfTextureFilter): void;
  AnisoFilter(): Graphic3d_LevelOfTextureAnisotropy;
  SetAnisoFilter(theLevel: Graphic3d_LevelOfTextureAnisotropy): void;
  Rotation(): Standard_ShortReal;
  SetRotation(theAngleDegrees: Standard_ShortReal): void;
  Scale(): OpenGl_Vec2;
  SetScale(theScale: OpenGl_Vec2): void;
  Translation(): OpenGl_Vec2;
  SetTranslation(theVec: OpenGl_Vec2): void;
  GenMode(): Graphic3d_TypeOfTextureMode;
  GenPlaneS(): OpenGl_Vec4;
  GenPlaneT(): OpenGl_Vec4;
  SetGenMode(theMode: Graphic3d_TypeOfTextureMode, thePlaneS: OpenGl_Vec4, thePlaneT: OpenGl_Vec4): void;
  BaseLevel(): Graphic3d_ZLayerId;
  MaxLevel(): Graphic3d_ZLayerId;
  SetLevelsRange(theFirstLevel: Graphic3d_ZLayerId, theSecondLevel: Graphic3d_ZLayerId): void;
  SamplerRevision(): Aspect_VKeyFlags;
  delete(): void;
}

export declare class Handle_Graphic3d_TextureParams {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_TextureParams): void;
  get(): Graphic3d_TextureParams;
  delete(): void;
}

  export declare class Handle_Graphic3d_TextureParams_1 extends Handle_Graphic3d_TextureParams {
    constructor();
  }

  export declare class Handle_Graphic3d_TextureParams_2 extends Handle_Graphic3d_TextureParams {
    constructor(thePtr: Graphic3d_TextureParams);
  }

  export declare class Handle_Graphic3d_TextureParams_3 extends Handle_Graphic3d_TextureParams {
    constructor(theHandle: Handle_Graphic3d_TextureParams);
  }

  export declare class Handle_Graphic3d_TextureParams_4 extends Handle_Graphic3d_TextureParams {
    constructor(theHandle: Handle_Graphic3d_TextureParams);
  }

export declare class Handle_Graphic3d_ArrayOfTriangles {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ArrayOfTriangles): void;
  get(): Graphic3d_ArrayOfTriangles;
  delete(): void;
}

  export declare class Handle_Graphic3d_ArrayOfTriangles_1 extends Handle_Graphic3d_ArrayOfTriangles {
    constructor();
  }

  export declare class Handle_Graphic3d_ArrayOfTriangles_2 extends Handle_Graphic3d_ArrayOfTriangles {
    constructor(thePtr: Graphic3d_ArrayOfTriangles);
  }

  export declare class Handle_Graphic3d_ArrayOfTriangles_3 extends Handle_Graphic3d_ArrayOfTriangles {
    constructor(theHandle: Handle_Graphic3d_ArrayOfTriangles);
  }

  export declare class Handle_Graphic3d_ArrayOfTriangles_4 extends Handle_Graphic3d_ArrayOfTriangles {
    constructor(theHandle: Handle_Graphic3d_ArrayOfTriangles);
  }

export declare class Graphic3d_ArrayOfTriangles extends Graphic3d_ArrayOfPrimitives {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_ArrayOfTriangles_1 extends Graphic3d_ArrayOfTriangles {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theArrayFlags: Graphic3d_ArrayFlags);
  }

  export declare class Graphic3d_ArrayOfTriangles_2 extends Graphic3d_ArrayOfTriangles {
    constructor(theMaxVertexs: Graphic3d_ZLayerId, theMaxEdges: Graphic3d_ZLayerId, theHasVNormals: Standard_Boolean, theHasVColors: Standard_Boolean, theHasVTexels: Standard_Boolean);
  }

export declare class Handle_Graphic3d_Texture1Dmanual {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Texture1Dmanual): void;
  get(): Graphic3d_Texture1Dmanual;
  delete(): void;
}

  export declare class Handle_Graphic3d_Texture1Dmanual_1 extends Handle_Graphic3d_Texture1Dmanual {
    constructor();
  }

  export declare class Handle_Graphic3d_Texture1Dmanual_2 extends Handle_Graphic3d_Texture1Dmanual {
    constructor(thePtr: Graphic3d_Texture1Dmanual);
  }

  export declare class Handle_Graphic3d_Texture1Dmanual_3 extends Handle_Graphic3d_Texture1Dmanual {
    constructor(theHandle: Handle_Graphic3d_Texture1Dmanual);
  }

  export declare class Handle_Graphic3d_Texture1Dmanual_4 extends Handle_Graphic3d_Texture1Dmanual {
    constructor(theHandle: Handle_Graphic3d_Texture1Dmanual);
  }

export declare class Graphic3d_Texture1Dmanual extends Graphic3d_Texture1D {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_Texture1Dmanual_1 extends Graphic3d_Texture1Dmanual {
    constructor(theFileName: XCAFDoc_PartId);
  }

  export declare class Graphic3d_Texture1Dmanual_2 extends Graphic3d_Texture1Dmanual {
    constructor(theNOT: Graphic3d_NameOfTexture1D);
  }

  export declare class Graphic3d_Texture1Dmanual_3 extends Graphic3d_Texture1Dmanual {
    constructor(thePixMap: Handle_Image_PixMap);
  }

export declare type Graphic3d_TypeOfLimit = {
  Graphic3d_TypeOfLimit_MaxNbLights: {};
  Graphic3d_TypeOfLimit_MaxNbClipPlanes: {};
  Graphic3d_TypeOfLimit_MaxNbViews: {};
  Graphic3d_TypeOfLimit_MaxTextureSize: {};
  Graphic3d_TypeOfLimit_MaxViewDumpSizeX: {};
  Graphic3d_TypeOfLimit_MaxViewDumpSizeY: {};
  Graphic3d_TypeOfLimit_MaxCombinedTextureUnits: {};
  Graphic3d_TypeOfLimit_MaxMsaa: {};
  Graphic3d_TypeOfLimit_HasPBR: {};
  Graphic3d_TypeOfLimit_HasRayTracing: {};
  Graphic3d_TypeOfLimit_HasRayTracingTextures: {};
  Graphic3d_TypeOfLimit_HasRayTracingAdaptiveSampling: {};
  Graphic3d_TypeOfLimit_HasRayTracingAdaptiveSamplingAtomic: {};
  Graphic3d_TypeOfLimit_HasSRGB: {};
  Graphic3d_TypeOfLimit_HasBlendedOit: {};
  Graphic3d_TypeOfLimit_HasBlendedOitMsaa: {};
  Graphic3d_TypeOfLimit_HasFlatShading: {};
  Graphic3d_TypeOfLimit_HasMeshEdges: {};
  Graphic3d_TypeOfLimit_IsWorkaroundFBO: {};
  Graphic3d_TypeOfLimit_NB: {};
}

export declare type Graphic3d_TransModeFlags = {
  Graphic3d_TMF_None: {};
  Graphic3d_TMF_ZoomPers: {};
  Graphic3d_TMF_RotatePers: {};
  Graphic3d_TMF_TriedronPers: {};
  Graphic3d_TMF_2d: {};
  Graphic3d_TMF_ZoomRotatePers: {};
}

export declare type Graphic3d_StereoMode = {
  Graphic3d_StereoMode_QuadBuffer: {};
  Graphic3d_StereoMode_Anaglyph: {};
  Graphic3d_StereoMode_RowInterlaced: {};
  Graphic3d_StereoMode_ColumnInterlaced: {};
  Graphic3d_StereoMode_ChessBoard: {};
  Graphic3d_StereoMode_SideBySide: {};
  Graphic3d_StereoMode_OverUnder: {};
  Graphic3d_StereoMode_SoftPageFlip: {};
  Graphic3d_StereoMode_OpenVR: {};
  Graphic3d_StereoMode_NB: {};
}

export declare class Graphic3d_BvhCStructureSet extends BVH_PrimitiveSet3d {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Size(): Graphic3d_ZLayerId;
  Box_2(theIdx: Graphic3d_ZLayerId): Graphic3d_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  Add(theStruct: Graphic3d_CStructure): Standard_Boolean;
  Remove(theStruct: Graphic3d_CStructure): Standard_Boolean;
  Clear(): void;
  GetStructureById(theId: Graphic3d_ZLayerId): Graphic3d_CStructure;
  Structures(): any;
  delete(): void;
}

export declare class Graphic3d_CubeMapPacked extends Graphic3d_CubeMap {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  CompressedValue(theSupported: any): any;
  Value(theSupported: any): Handle_Image_PixMap;
  delete(): void;
}

  export declare class Graphic3d_CubeMapPacked_1 extends Graphic3d_CubeMapPacked {
    constructor(theFileName: XCAFDoc_PartId, theOrder: Graphic3d_ValidatedCubeMapOrder);
  }

  export declare class Graphic3d_CubeMapPacked_2 extends Graphic3d_CubeMapPacked {
    constructor(theImage: Handle_Image_PixMap, theOrder: Graphic3d_ValidatedCubeMapOrder);
  }

export declare class Handle_Graphic3d_CubeMapPacked {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_CubeMapPacked): void;
  get(): Graphic3d_CubeMapPacked;
  delete(): void;
}

  export declare class Handle_Graphic3d_CubeMapPacked_1 extends Handle_Graphic3d_CubeMapPacked {
    constructor();
  }

  export declare class Handle_Graphic3d_CubeMapPacked_2 extends Handle_Graphic3d_CubeMapPacked {
    constructor(thePtr: Graphic3d_CubeMapPacked);
  }

  export declare class Handle_Graphic3d_CubeMapPacked_3 extends Handle_Graphic3d_CubeMapPacked {
    constructor(theHandle: Handle_Graphic3d_CubeMapPacked);
  }

  export declare class Handle_Graphic3d_CubeMapPacked_4 extends Handle_Graphic3d_CubeMapPacked {
    constructor(theHandle: Handle_Graphic3d_CubeMapPacked);
  }

export declare class Handle_Graphic3d_StructureManager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_StructureManager): void;
  get(): Graphic3d_StructureManager;
  delete(): void;
}

  export declare class Handle_Graphic3d_StructureManager_1 extends Handle_Graphic3d_StructureManager {
    constructor();
  }

  export declare class Handle_Graphic3d_StructureManager_2 extends Handle_Graphic3d_StructureManager {
    constructor(thePtr: Graphic3d_StructureManager);
  }

  export declare class Handle_Graphic3d_StructureManager_3 extends Handle_Graphic3d_StructureManager {
    constructor(theHandle: Handle_Graphic3d_StructureManager);
  }

  export declare class Handle_Graphic3d_StructureManager_4 extends Handle_Graphic3d_StructureManager {
    constructor(theHandle: Handle_Graphic3d_StructureManager);
  }

export declare class Graphic3d_StructureManager extends Standard_Transient {
  constructor(theDriver: Handle_Graphic3d_GraphicDriver)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Update(theLayerId: Graphic3d_ZLayerId): void;
  Remove(): void;
  Erase_1(): void;
  DisplayedStructures(SG: Graphic3d_MapOfStructure): void;
  HighlightedStructures(SG: Graphic3d_MapOfStructure): void;
  ReCompute_1(theStructure: Handle_Graphic3d_Structure): void;
  ReCompute_2(theStructure: Handle_Graphic3d_Structure, theProjector: Handle_Graphic3d_DataStructureManager): void;
  Clear(theStructure: Prs3d_Presentation, theWithDestruction: Standard_Boolean): void;
  Connect(theMother: Prs3d_Presentation, theDaughter: Prs3d_Presentation): void;
  Disconnect(theMother: Prs3d_Presentation, theDaughter: Prs3d_Presentation): void;
  Display(theStructure: Handle_Graphic3d_Structure): void;
  Erase_2(theStructure: Handle_Graphic3d_Structure): void;
  Highlight(theStructure: Handle_Graphic3d_Structure): void;
  SetTransform(theStructure: Handle_Graphic3d_Structure, theTrsf: Handle_TopLoc_Datum3D): void;
  ChangeDisplayPriority(theStructure: Handle_Graphic3d_Structure, theOldPriority: Graphic3d_ZLayerId, theNewPriority: Graphic3d_ZLayerId): void;
  ChangeZLayer(theStructure: Handle_Graphic3d_Structure, theLayerId: Graphic3d_ZLayerId): void;
  GraphicDriver(): Handle_Graphic3d_GraphicDriver;
  Identification_1(theView: Graphic3d_CView): Graphic3d_ZLayerId;
  UnIdentification(theView: Graphic3d_CView): void;
  DefinedViews(): Graphic3d_IndexedMapOfView;
  MaxNumOfViews(): Graphic3d_ZLayerId;
  Identification_2(AId: Graphic3d_ZLayerId): Handle_Graphic3d_Structure;
  UnHighlight_1(AStructure: Handle_Graphic3d_Structure): void;
  UnHighlight_2(): void;
  RecomputeStructures_1(): void;
  RecomputeStructures_2(theStructures: NCollection_Map<Graphic3d_Structure >): void;
  RegisterObject(theObject: Handle_Standard_Transient): Handle_Graphic3d_ViewAffinity;
  UnregisterObject(theObject: Handle_Standard_Transient): void;
  ObjectAffinity(theObject: Handle_Standard_Transient): Handle_Graphic3d_ViewAffinity;
  IsDeviceLost(): Standard_Boolean;
  SetDeviceLost(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Graphic3d_MarkerImage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_MarkerImage): void;
  get(): Graphic3d_MarkerImage;
  delete(): void;
}

  export declare class Handle_Graphic3d_MarkerImage_1 extends Handle_Graphic3d_MarkerImage {
    constructor();
  }

  export declare class Handle_Graphic3d_MarkerImage_2 extends Handle_Graphic3d_MarkerImage {
    constructor(thePtr: Graphic3d_MarkerImage);
  }

  export declare class Handle_Graphic3d_MarkerImage_3 extends Handle_Graphic3d_MarkerImage {
    constructor(theHandle: Handle_Graphic3d_MarkerImage);
  }

  export declare class Handle_Graphic3d_MarkerImage_4 extends Handle_Graphic3d_MarkerImage {
    constructor(theHandle: Handle_Graphic3d_MarkerImage);
  }

export declare class Graphic3d_MarkerImage extends Standard_Transient {
  GetBitMapArray(theAlphaValue: Quantity_AbsorbedDose): Handle_TColStd_HArray1OfByte;
  GetImage(): Handle_Image_PixMap;
  GetImageAlpha(): Handle_Image_PixMap;
  GetImageId(): XCAFDoc_PartId;
  GetImageAlphaId(): XCAFDoc_PartId;
  GetTextureSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_MarkerImage_1 extends Graphic3d_MarkerImage {
    constructor(theImage: Handle_Image_PixMap);
  }

  export declare class Graphic3d_MarkerImage_2 extends Graphic3d_MarkerImage {
    constructor(theBitMap: Handle_TColStd_HArray1OfByte, theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId);
  }

export declare class Graphic3d_CTexture {
  constructor()
  delete(): void;
}

export declare class Handle_Graphic3d_Texture2D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Texture2D): void;
  get(): Graphic3d_Texture2D;
  delete(): void;
}

  export declare class Handle_Graphic3d_Texture2D_1 extends Handle_Graphic3d_Texture2D {
    constructor();
  }

  export declare class Handle_Graphic3d_Texture2D_2 extends Handle_Graphic3d_Texture2D {
    constructor(thePtr: Graphic3d_Texture2D);
  }

  export declare class Handle_Graphic3d_Texture2D_3 extends Handle_Graphic3d_Texture2D {
    constructor(theHandle: Handle_Graphic3d_Texture2D);
  }

  export declare class Handle_Graphic3d_Texture2D_4 extends Handle_Graphic3d_Texture2D {
    constructor(theHandle: Handle_Graphic3d_Texture2D);
  }

export declare class Graphic3d_Texture2D extends Graphic3d_TextureMap {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static NumberOfTextures(): Graphic3d_ZLayerId;
  static TextureName(theRank: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Name(): Graphic3d_NameOfTexture2D;
  SetImage(thePixMap: Handle_Image_PixMap): void;
  HasMipMaps(): Standard_Boolean;
  SetMipMaps(theToUse: Standard_Boolean): void;
  delete(): void;
}

export declare class Graphic3d_ValueInterface {
  TypeID(): Standard_ThreadId;
  delete(): void;
}

export declare class Graphic3d_ShaderVariable extends Standard_Transient {
  Name(): XCAFDoc_PartId;
  IsDone(): Standard_Boolean;
  Value(): Graphic3d_ValueInterface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Graphic3d_ShaderVariable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_ShaderVariable): void;
  get(): Graphic3d_ShaderVariable;
  delete(): void;
}

  export declare class Handle_Graphic3d_ShaderVariable_1 extends Handle_Graphic3d_ShaderVariable {
    constructor();
  }

  export declare class Handle_Graphic3d_ShaderVariable_2 extends Handle_Graphic3d_ShaderVariable {
    constructor(thePtr: Graphic3d_ShaderVariable);
  }

  export declare class Handle_Graphic3d_ShaderVariable_3 extends Handle_Graphic3d_ShaderVariable {
    constructor(theHandle: Handle_Graphic3d_ShaderVariable);
  }

  export declare class Handle_Graphic3d_ShaderVariable_4 extends Handle_Graphic3d_ShaderVariable {
    constructor(theHandle: Handle_Graphic3d_ShaderVariable);
  }

export declare class Graphic3d_Mat4 {
  constructor()
  static Rows(): size_t;
  static Cols(): size_t;
  GetValue(theRow: size_t, theCol: size_t): Standard_ShortReal;
  ChangeValue(theRow: size_t, theCol: size_t): Standard_ShortReal;
  SetValue(theRow: size_t, theCol: size_t, theValue: Standard_ShortReal): void;
  GetRow(theRow: size_t): any;
  SetRow_1(theRow: size_t, theVec: NCollection_Vec3<Standard_ShortReal>): void;
  SetRow_2(theRow: size_t, theVec: NCollection_Vec4<Standard_ShortReal>): void;
  GetColumn(theCol: size_t): any;
  SetColumn_1(theCol: size_t, theVec: NCollection_Vec3<Standard_ShortReal>): void;
  SetColumn_2(theCol: size_t, theVec: NCollection_Vec4<Standard_ShortReal>): void;
  GetDiagonal(): any;
  SetDiagonal_1(theVec: NCollection_Vec3<Standard_ShortReal>): void;
  SetDiagonal_2(theVec: NCollection_Vec4<Standard_ShortReal>): void;
  InitIdentity(): void;
  IsIdentity(): boolean;
  IsEqual(theOther: Graphic3d_Mat4): boolean;
  GetData(): Standard_ShortReal;
  ChangeData(): Standard_ShortReal;
  Multiply_1(theMatA: Graphic3d_Mat4, theMatB: Graphic3d_Mat4): Graphic3d_Mat4;
  Multiply_2(theMat: Graphic3d_Mat4): void;
  Multiplied_1(theMat: Graphic3d_Mat4): Graphic3d_Mat4;
  Multiply_3(theFactor: Standard_ShortReal): void;
  Multiplied_2(theFactor: Standard_ShortReal): Graphic3d_Mat4;
  Translate(theVec: NCollection_Vec3<Standard_ShortReal>): void;
  Transposed(): Graphic3d_Mat4;
  Transpose(): void;
  Inverted(theOutMx: Graphic3d_Mat4): boolean;
  static Map_1(theData: Standard_ShortReal): Graphic3d_Mat4;
  static Map_2(theData: Standard_ShortReal): Graphic3d_Mat4;
  DumpJson(theOStream: Standard_OStream, a1: Standard_Integer): void;
  delete(): void;
}

export declare type Graphic3d_AlphaMode = {
  Graphic3d_AlphaMode_Opaque: {};
  Graphic3d_AlphaMode_Mask: {};
  Graphic3d_AlphaMode_Blend: {};
  Graphic3d_AlphaMode_BlendAuto: {};
}

export declare class Handle_Graphic3d_CubeMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_CubeMap): void;
  get(): Graphic3d_CubeMap;
  delete(): void;
}

  export declare class Handle_Graphic3d_CubeMap_1 extends Handle_Graphic3d_CubeMap {
    constructor();
  }

  export declare class Handle_Graphic3d_CubeMap_2 extends Handle_Graphic3d_CubeMap {
    constructor(thePtr: Graphic3d_CubeMap);
  }

  export declare class Handle_Graphic3d_CubeMap_3 extends Handle_Graphic3d_CubeMap {
    constructor(theHandle: Handle_Graphic3d_CubeMap);
  }

  export declare class Handle_Graphic3d_CubeMap_4 extends Handle_Graphic3d_CubeMap {
    constructor(theHandle: Handle_Graphic3d_CubeMap);
  }

export declare class Handle_Graphic3d_HatchStyle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_HatchStyle): void;
  get(): Graphic3d_HatchStyle;
  delete(): void;
}

  export declare class Handle_Graphic3d_HatchStyle_1 extends Handle_Graphic3d_HatchStyle {
    constructor();
  }

  export declare class Handle_Graphic3d_HatchStyle_2 extends Handle_Graphic3d_HatchStyle {
    constructor(thePtr: Graphic3d_HatchStyle);
  }

  export declare class Handle_Graphic3d_HatchStyle_3 extends Handle_Graphic3d_HatchStyle {
    constructor(theHandle: Handle_Graphic3d_HatchStyle);
  }

  export declare class Handle_Graphic3d_HatchStyle_4 extends Handle_Graphic3d_HatchStyle {
    constructor(theHandle: Handle_Graphic3d_HatchStyle);
  }

export declare class Graphic3d_HatchStyle extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Pattern(): Standard_Byte;
  HatchType(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Graphic3d_HatchStyle_1 extends Graphic3d_HatchStyle {
    constructor(thePattern: Handle_Image_PixMap);
  }

  export declare class Graphic3d_HatchStyle_2 extends Graphic3d_HatchStyle {
    constructor(theType: Aspect_HatchStyle);
  }

export declare type Graphic3d_RenderTransparentMethod = {
  Graphic3d_RTM_BLEND_UNORDERED: {};
  Graphic3d_RTM_BLEND_OIT: {};
}

export declare class Graphic3d_PBRMaterial {
  Metallic(): Standard_ShortReal;
  SetMetallic(theMetallic: Standard_ShortReal): void;
  static Roughness_1(theNormalizedRoughness: Standard_ShortReal): Standard_ShortReal;
  Roughness_2(): Standard_ShortReal;
  NormalizedRoughness(): Standard_ShortReal;
  SetRoughness(theRoughness: Standard_ShortReal): void;
  IOR(): Standard_ShortReal;
  SetIOR(theIOR: Standard_ShortReal): void;
  Color(): Quantity_ColorRGBA;
  SetColor_1(theColor: Quantity_ColorRGBA): void;
  SetColor_2(theColor: Quantity_Color): void;
  Alpha(): Standard_ShortReal;
  SetAlpha(theAlpha: Standard_ShortReal): void;
  Emission(): OpenGl_Vec3;
  SetEmission(theEmission: OpenGl_Vec3): void;
  SetBSDF(theBSDF: Graphic3d_BSDF): void;
  static GenerateEnvLUT(theLUT: Handle_Image_PixMap, theNbIntegralSamples: Aspect_VKeyFlags): void;
  static RoughnessFromSpecular(theSpecular: Quantity_Color, theShiness: Quantity_AbsorbedDose): Standard_ShortReal;
  static MetallicFromSpecular(theSpecular: Quantity_Color): Standard_ShortReal;
  static MinRoughness(): Standard_ShortReal;
  static SpecIBLMapSamplesFactor(theProbability: Standard_ShortReal, theRoughness: Standard_ShortReal): Standard_ShortReal;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Graphic3d_PBRMaterial_1 extends Graphic3d_PBRMaterial {
    constructor();
  }

  export declare class Graphic3d_PBRMaterial_2 extends Graphic3d_PBRMaterial {
    constructor(theBSDF: Graphic3d_BSDF);
  }

export declare class Graphic3d_Vertex {
  SetCoord_1(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal): void;
  SetCoord_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  Coord_1(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal): void;
  Coord_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  X(): Standard_ShortReal;
  Y(): Standard_ShortReal;
  Z(): Standard_ShortReal;
  Distance(theOther: Graphic3d_Vertex): Standard_ShortReal;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Graphic3d_Vertex_1 extends Graphic3d_Vertex {
    constructor();
  }

  export declare class Graphic3d_Vertex_2 extends Graphic3d_Vertex {
    constructor(theX: Standard_ShortReal, theY: Standard_ShortReal, theZ: Standard_ShortReal);
  }

  export declare class Graphic3d_Vertex_3 extends Graphic3d_Vertex {
    constructor(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose);
  }

export declare type Graphic3d_FrameStatsCounter = {
  Graphic3d_FrameStatsCounter_NbLayers: {};
  Graphic3d_FrameStatsCounter_NbStructs: {};
  Graphic3d_FrameStatsCounter_EstimatedBytesGeom: {};
  Graphic3d_FrameStatsCounter_EstimatedBytesFbos: {};
  Graphic3d_FrameStatsCounter_EstimatedBytesTextures: {};
  Graphic3d_FrameStatsCounter_NbLayersNotCulled: {};
  Graphic3d_FrameStatsCounter_NbStructsNotCulled: {};
  Graphic3d_FrameStatsCounter_NbGroupsNotCulled: {};
  Graphic3d_FrameStatsCounter_NbElemsNotCulled: {};
  Graphic3d_FrameStatsCounter_NbElemsFillNotCulled: {};
  Graphic3d_FrameStatsCounter_NbElemsLineNotCulled: {};
  Graphic3d_FrameStatsCounter_NbElemsPointNotCulled: {};
  Graphic3d_FrameStatsCounter_NbElemsTextNotCulled: {};
  Graphic3d_FrameStatsCounter_NbTrianglesNotCulled: {};
  Graphic3d_FrameStatsCounter_NbLinesNotCulled: {};
  Graphic3d_FrameStatsCounter_NbPointsNotCulled: {};
  Graphic3d_FrameStatsCounter_NbLayersImmediate: {};
  Graphic3d_FrameStatsCounter_NbStructsImmediate: {};
  Graphic3d_FrameStatsCounter_NbGroupsImmediate: {};
  Graphic3d_FrameStatsCounter_NbElemsImmediate: {};
  Graphic3d_FrameStatsCounter_NbElemsFillImmediate: {};
  Graphic3d_FrameStatsCounter_NbElemsLineImmediate: {};
  Graphic3d_FrameStatsCounter_NbElemsPointImmediate: {};
  Graphic3d_FrameStatsCounter_NbElemsTextImmediate: {};
  Graphic3d_FrameStatsCounter_NbTrianglesImmediate: {};
  Graphic3d_FrameStatsCounter_NbLinesImmediate: {};
  Graphic3d_FrameStatsCounter_NbPointsImmediate: {};
}

export declare class Handle_Graphic3d_CLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_CLight): void;
  get(): Graphic3d_CLight;
  delete(): void;
}

  export declare class Handle_Graphic3d_CLight_1 extends Handle_Graphic3d_CLight {
    constructor();
  }

  export declare class Handle_Graphic3d_CLight_2 extends Handle_Graphic3d_CLight {
    constructor(thePtr: Graphic3d_CLight);
  }

  export declare class Handle_Graphic3d_CLight_3 extends Handle_Graphic3d_CLight {
    constructor(theHandle: Handle_Graphic3d_CLight);
  }

  export declare class Handle_Graphic3d_CLight_4 extends Handle_Graphic3d_CLight {
    constructor(theHandle: Handle_Graphic3d_CLight);
  }

export declare class Graphic3d_CLight extends Standard_Transient {
  constructor(theType: V3d_TypeOfLight)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Type(): V3d_TypeOfLight;
  Name(): XCAFDoc_PartId;
  SetName(theName: XCAFDoc_PartId): void;
  Color(): Quantity_Color;
  SetColor(theColor: Quantity_Color): void;
  IsEnabled(): Standard_Boolean;
  SetEnabled(theIsOn: Standard_Boolean): void;
  IsHeadlight(): Standard_Boolean;
  Headlight(): Standard_Boolean;
  SetHeadlight(theValue: Standard_Boolean): void;
  Position_1(): gp_Pnt;
  SetPosition_1(thePosition: gp_Pnt): void;
  Position_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  SetPosition_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  ConstAttenuation(): Standard_ShortReal;
  LinearAttenuation(): Standard_ShortReal;
  Attenuation(theConstAttenuation: Quantity_AbsorbedDose, theLinearAttenuation: Quantity_AbsorbedDose): void;
  SetAttenuation(theConstAttenuation: Standard_ShortReal, theLinearAttenuation: Standard_ShortReal): void;
  Direction_1(): gp_Dir;
  SetDirection_1(theDir: gp_Dir): void;
  Direction_2(theVx: Quantity_AbsorbedDose, theVy: Quantity_AbsorbedDose, theVz: Quantity_AbsorbedDose): void;
  SetDirection_2(theVx: Quantity_AbsorbedDose, theVy: Quantity_AbsorbedDose, theVz: Quantity_AbsorbedDose): void;
  Angle(): Standard_ShortReal;
  SetAngle(theAngle: Standard_ShortReal): void;
  Concentration(): Standard_ShortReal;
  SetConcentration(theConcentration: Standard_ShortReal): void;
  Intensity(): Standard_ShortReal;
  SetIntensity(theValue: Standard_ShortReal): void;
  Smoothness(): Standard_ShortReal;
  SetSmoothRadius(theValue: Standard_ShortReal): void;
  SetSmoothAngle(theValue: Standard_ShortReal): void;
  Range(): Standard_ShortReal;
  SetRange(theValue: Standard_ShortReal): void;
  GetId(): XCAFDoc_PartId;
  PackedParams(): OpenGl_Vec4;
  PackedColor(): OpenGl_Vec4;
  PackedDirectionRange(): OpenGl_Vec4;
  Revision(): Standard_ThreadId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Graphic3d_CameraTile {
  constructor()
  IsValid(): Standard_Boolean;
  OffsetLowerLeft(): OpenGl_Vec2i;
  Cropped(): Graphic3d_CameraTile;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Graphic3d_TextureSetBits = {
  Graphic3d_TextureSetBits_NONE: {};
  Graphic3d_TextureSetBits_BaseColor: {};
  Graphic3d_TextureSetBits_Emissive: {};
  Graphic3d_TextureSetBits_Occlusion: {};
  Graphic3d_TextureSetBits_Normal: {};
  Graphic3d_TextureSetBits_MetallicRoughness: {};
}

export declare type Graphic3d_NameOfTexture1D = {
  Graphic3d_NOT_1D_ELEVATION: {};
  Graphic3d_NOT_1D_UNKNOWN: {};
}

export declare class Graphic3d_TextureSet extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsEmpty(): Standard_Boolean;
  Size(): Graphic3d_ZLayerId;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  First(): Handle_Graphic3d_TextureMap;
  SetFirst(theTexture: Handle_Graphic3d_TextureMap): void;
  Value(theIndex: Graphic3d_ZLayerId): Handle_Graphic3d_TextureMap;
  SetValue(theIndex: Graphic3d_ZLayerId, theTexture: Handle_Graphic3d_TextureMap): void;
  delete(): void;
}

  export declare class Graphic3d_TextureSet_1 extends Graphic3d_TextureSet {
    constructor();
  }

  export declare class Graphic3d_TextureSet_2 extends Graphic3d_TextureSet {
    constructor(theNbTextures: Graphic3d_ZLayerId);
  }

  export declare class Graphic3d_TextureSet_3 extends Graphic3d_TextureSet {
    constructor(theTexture: Handle_Graphic3d_TextureMap);
  }

export declare class Handle_Graphic3d_TextureRoot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_TextureRoot): void;
  get(): Graphic3d_TextureRoot;
  delete(): void;
}

  export declare class Handle_Graphic3d_TextureRoot_1 extends Handle_Graphic3d_TextureRoot {
    constructor();
  }

  export declare class Handle_Graphic3d_TextureRoot_2 extends Handle_Graphic3d_TextureRoot {
    constructor(thePtr: Graphic3d_TextureRoot);
  }

  export declare class Handle_Graphic3d_TextureRoot_3 extends Handle_Graphic3d_TextureRoot {
    constructor(theHandle: Handle_Graphic3d_TextureRoot);
  }

  export declare class Handle_Graphic3d_TextureRoot_4 extends Handle_Graphic3d_TextureRoot {
    constructor(theHandle: Handle_Graphic3d_TextureRoot);
  }

export declare class Graphic3d_TextureRoot extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static TexturesFolder(): XCAFDoc_PartId;
  IsDone(): Standard_Boolean;
  Path(): OSD_Path;
  Type(): Graphic3d_TypeOfTexture;
  GetId(): XCAFDoc_PartId;
  Revision(): Standard_ThreadId;
  UpdateRevision(): void;
  GetCompressedImage(theSupported: any): any;
  GetImage_1(theSupported: any): Handle_Image_PixMap;
  GetParams(): Handle_Graphic3d_TextureParams;
  IsColorMap(): Standard_Boolean;
  SetColorMap(theIsColor: Standard_Boolean): void;
  IsTopDown(): Standard_Boolean;
  delete(): void;
}

export declare type Graphic3d_FrameStatsTimer = {
  Graphic3d_FrameStatsTimer_ElapsedFrame: {};
  Graphic3d_FrameStatsTimer_CpuFrame: {};
  Graphic3d_FrameStatsTimer_CpuCulling: {};
  Graphic3d_FrameStatsTimer_CpuPicking: {};
  Graphic3d_FrameStatsTimer_CpuDynamics: {};
}

export declare type Graphic3d_TypeOfLightSource = {
  Graphic3d_TOLS_AMBIENT: {};
  Graphic3d_TOLS_DIRECTIONAL: {};
  Graphic3d_TOLS_POSITIONAL: {};
  Graphic3d_TOLS_SPOT: {};
  V3d_AMBIENT: {};
  V3d_DIRECTIONAL: {};
  V3d_POSITIONAL: {};
  V3d_SPOT: {};
}

export declare class Graphic3d_Texture2Dplane extends Graphic3d_Texture2D {
  SetPlaneS(A: Standard_ShortReal, B: Standard_ShortReal, C: Standard_ShortReal, D: Standard_ShortReal): void;
  SetPlaneT(A: Standard_ShortReal, B: Standard_ShortReal, C: Standard_ShortReal, D: Standard_ShortReal): void;
  SetPlane(thePlane: Graphic3d_NameOfTexturePlane): void;
  SetScaleS(theVal: Standard_ShortReal): void;
  SetScaleT(theVal: Standard_ShortReal): void;
  SetTranslateS(theVal: Standard_ShortReal): void;
  SetTranslateT(theVal: Standard_ShortReal): void;
  SetRotation(theVal: Standard_ShortReal): void;
  Plane(): Graphic3d_NameOfTexturePlane;
  PlaneS(A: Standard_ShortReal, B: Standard_ShortReal, C: Standard_ShortReal, D: Standard_ShortReal): void;
  PlaneT(A: Standard_ShortReal, B: Standard_ShortReal, C: Standard_ShortReal, D: Standard_ShortReal): void;
  TranslateS(theVal: Standard_ShortReal): void;
  TranslateT(theVal: Standard_ShortReal): void;
  ScaleS(theVal: Standard_ShortReal): void;
  ScaleT(theVal: Standard_ShortReal): void;
  Rotation(theVal: Standard_ShortReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Graphic3d_Texture2Dplane_1 extends Graphic3d_Texture2Dplane {
    constructor(theFileName: XCAFDoc_PartId);
  }

  export declare class Graphic3d_Texture2Dplane_2 extends Graphic3d_Texture2Dplane {
    constructor(theNOT: Graphic3d_NameOfTexture2D);
  }

  export declare class Graphic3d_Texture2Dplane_3 extends Graphic3d_Texture2Dplane {
    constructor(thePixMap: Handle_Image_PixMap);
  }

export declare class Handle_Graphic3d_Texture2Dplane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Graphic3d_Texture2Dplane): void;
  get(): Graphic3d_Texture2Dplane;
  delete(): void;
}

  export declare class Handle_Graphic3d_Texture2Dplane_1 extends Handle_Graphic3d_Texture2Dplane {
    constructor();
  }

  export declare class Handle_Graphic3d_Texture2Dplane_2 extends Handle_Graphic3d_Texture2Dplane {
    constructor(thePtr: Graphic3d_Texture2Dplane);
  }

  export declare class Handle_Graphic3d_Texture2Dplane_3 extends Handle_Graphic3d_Texture2Dplane {
    constructor(theHandle: Handle_Graphic3d_Texture2Dplane);
  }

  export declare class Handle_Graphic3d_Texture2Dplane_4 extends Handle_Graphic3d_Texture2Dplane {
    constructor(theHandle: Handle_Graphic3d_Texture2Dplane);
  }

export declare class PCDM_ReadWriter_1 extends PCDM_ReadWriter {
  constructor()
  Version(): XCAFDoc_PartId;
  WriteReferenceCounter(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  WriteReferences(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document, theReferencerFileName: TCollection_ExtendedString): void;
  WriteExtensions(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  WriteVersion(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  ReadReferenceCounter(aFileName: TCollection_ExtendedString, theMsgDriver: Handle_Message_Messenger): Graphic3d_ZLayerId;
  ReadReferences(aFileName: TCollection_ExtendedString, theReferences: PCDM_SequenceOfReference, theMsgDriver: Handle_Message_Messenger): void;
  ReadExtensions(aFileName: TCollection_ExtendedString, theExtensions: TColStd_SequenceOfExtendedString, theMsgDriver: Handle_Message_Messenger): void;
  ReadDocumentVersion(aFileName: TCollection_ExtendedString, theMsgDriver: Handle_Message_Messenger): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class PCDM_SequenceOfReference extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: PCDM_SequenceOfReference): PCDM_SequenceOfReference;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: PCDM_Reference): void;
  Append_2(theSeq: PCDM_SequenceOfReference): void;
  Prepend_1(theItem: PCDM_Reference): void;
  Prepend_2(theSeq: PCDM_SequenceOfReference): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: PCDM_Reference): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: PCDM_SequenceOfReference): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: PCDM_SequenceOfReference): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: PCDM_Reference): void;
  Split(theIndex: Standard_Integer, theSeq: PCDM_SequenceOfReference): void;
  First(): PCDM_Reference;
  ChangeFirst(): PCDM_Reference;
  Last(): PCDM_Reference;
  ChangeLast(): PCDM_Reference;
  Value(theIndex: Standard_Integer): PCDM_Reference;
  ChangeValue(theIndex: Standard_Integer): PCDM_Reference;
  SetValue(theIndex: Standard_Integer, theItem: PCDM_Reference): void;
  delete(): void;
}

  export declare class PCDM_SequenceOfReference_1 extends PCDM_SequenceOfReference {
    constructor();
  }

  export declare class PCDM_SequenceOfReference_2 extends PCDM_SequenceOfReference {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class PCDM_SequenceOfReference_3 extends PCDM_SequenceOfReference {
    constructor(theOther: PCDM_SequenceOfReference);
  }

export declare class PCDM_Reference {
  ReferenceIdentifier(): Graphic3d_ZLayerId;
  FileName(): TCollection_ExtendedString;
  DocumentVersion(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class PCDM_Reference_1 extends PCDM_Reference {
    constructor();
  }

  export declare class PCDM_Reference_2 extends PCDM_Reference {
    constructor(aReferenceIdentifier: Graphic3d_ZLayerId, aFileName: TCollection_ExtendedString, aDocumentVersion: Graphic3d_ZLayerId);
  }

export declare type PCDM_StoreStatus = {
  PCDM_SS_OK: {};
  PCDM_SS_DriverFailure: {};
  PCDM_SS_WriteFailure: {};
  PCDM_SS_Failure: {};
  PCDM_SS_Doc_IsNull: {};
  PCDM_SS_No_Obj: {};
  PCDM_SS_Info_Section_Error: {};
  PCDM_SS_UserBreak: {};
}

export declare type PCDM_ReaderStatus = {
  PCDM_RS_OK: {};
  PCDM_RS_NoDriver: {};
  PCDM_RS_UnknownFileDriver: {};
  PCDM_RS_OpenError: {};
  PCDM_RS_NoVersion: {};
  PCDM_RS_NoSchema: {};
  PCDM_RS_NoDocument: {};
  PCDM_RS_ExtensionFailure: {};
  PCDM_RS_WrongStreamMode: {};
  PCDM_RS_FormatFailure: {};
  PCDM_RS_TypeFailure: {};
  PCDM_RS_TypeNotFoundInSchema: {};
  PCDM_RS_UnrecognizedFileFormat: {};
  PCDM_RS_MakeFailure: {};
  PCDM_RS_PermissionDenied: {};
  PCDM_RS_DriverFailure: {};
  PCDM_RS_AlreadyRetrievedAndModified: {};
  PCDM_RS_AlreadyRetrieved: {};
  PCDM_RS_UnknownDocument: {};
  PCDM_RS_WrongResource: {};
  PCDM_RS_ReaderException: {};
  PCDM_RS_NoModel: {};
  PCDM_RS_UserBreak: {};
}

export declare class PCDM_Reader extends Standard_Transient {
  CreateDocument(): Handle_CDM_Document;
  Read_1(aFileName: TCollection_ExtendedString, aNewDocument: Handle_CDM_Document, anApplication: Handle_CDM_Application, theProgress: Message_ProgressRange): void;
  Read_2(theIStream: Standard_IStream, theStorageData: Handle_Storage_Data, theDoc: Handle_CDM_Document, theApplication: Handle_CDM_Application, theProgress: Message_ProgressRange): void;
  GetStatus(): PCDM_ReaderStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PCDM_DriverError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_DriverError): void;
  get(): PCDM_DriverError;
  delete(): void;
}

  export declare class Handle_PCDM_DriverError_1 extends Handle_PCDM_DriverError {
    constructor();
  }

  export declare class Handle_PCDM_DriverError_2 extends Handle_PCDM_DriverError {
    constructor(thePtr: PCDM_DriverError);
  }

  export declare class Handle_PCDM_DriverError_3 extends Handle_PCDM_DriverError {
    constructor(theHandle: Handle_PCDM_DriverError);
  }

  export declare class Handle_PCDM_DriverError_4 extends Handle_PCDM_DriverError {
    constructor(theHandle: Handle_PCDM_DriverError);
  }

export declare class PCDM_DriverError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_PCDM_DriverError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class PCDM_DriverError_1 extends PCDM_DriverError {
    constructor();
  }

  export declare class PCDM_DriverError_2 extends PCDM_DriverError {
    constructor(theMessage: Standard_CString);
  }

export declare class PCDM {
  constructor();
  static FileDriverType_1(aFileName: XCAFDoc_PartId, aBaseDriver: Handle_Storage_BaseDriver): PCDM_TypeOfFileDriver;
  static FileDriverType_2(theIStream: Standard_IStream, theBaseDriver: Handle_Storage_BaseDriver): PCDM_TypeOfFileDriver;
  delete(): void;
}

export declare class Handle_PCDM_RetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_RetrievalDriver): void;
  get(): PCDM_RetrievalDriver;
  delete(): void;
}

  export declare class Handle_PCDM_RetrievalDriver_1 extends Handle_PCDM_RetrievalDriver {
    constructor();
  }

  export declare class Handle_PCDM_RetrievalDriver_2 extends Handle_PCDM_RetrievalDriver {
    constructor(thePtr: PCDM_RetrievalDriver);
  }

  export declare class Handle_PCDM_RetrievalDriver_3 extends Handle_PCDM_RetrievalDriver {
    constructor(theHandle: Handle_PCDM_RetrievalDriver);
  }

  export declare class Handle_PCDM_RetrievalDriver_4 extends Handle_PCDM_RetrievalDriver {
    constructor(theHandle: Handle_PCDM_RetrievalDriver);
  }

export declare class PCDM_RetrievalDriver extends PCDM_Reader {
  static DocumentVersion(theFileName: TCollection_ExtendedString, theMsgDriver: Handle_Message_Messenger): Graphic3d_ZLayerId;
  static ReferenceCounter(theFileName: TCollection_ExtendedString, theMsgDriver: Handle_Message_Messenger): Graphic3d_ZLayerId;
  SetFormat(aformat: TCollection_ExtendedString): void;
  GetFormat(): TCollection_ExtendedString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class PCDM_ReferenceIterator extends Standard_Transient {
  constructor(theMessageDriver: Handle_Message_Messenger)
  LoadReferences(aDocument: Handle_CDM_Document, aMetaData: Handle_CDM_MetaData, anApplication: Handle_CDM_Application, UseStorageConfiguration: Standard_Boolean): void;
  Init(aMetaData: Handle_CDM_MetaData): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PCDM_ReferenceIterator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_ReferenceIterator): void;
  get(): PCDM_ReferenceIterator;
  delete(): void;
}

  export declare class Handle_PCDM_ReferenceIterator_1 extends Handle_PCDM_ReferenceIterator {
    constructor();
  }

  export declare class Handle_PCDM_ReferenceIterator_2 extends Handle_PCDM_ReferenceIterator {
    constructor(thePtr: PCDM_ReferenceIterator);
  }

  export declare class Handle_PCDM_ReferenceIterator_3 extends Handle_PCDM_ReferenceIterator {
    constructor(theHandle: Handle_PCDM_ReferenceIterator);
  }

  export declare class Handle_PCDM_ReferenceIterator_4 extends Handle_PCDM_ReferenceIterator {
    constructor(theHandle: Handle_PCDM_ReferenceIterator);
  }

export declare class PCDM_Writer extends Standard_Transient {
  Write_1(aDocument: Handle_CDM_Document, aFileName: TCollection_ExtendedString, theRange: Message_ProgressRange): void;
  Write_2(theDocument: Handle_CDM_Document, theOStream: Standard_OStream, theRange: Message_ProgressRange): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PCDM_Writer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_Writer): void;
  get(): PCDM_Writer;
  delete(): void;
}

  export declare class Handle_PCDM_Writer_1 extends Handle_PCDM_Writer {
    constructor();
  }

  export declare class Handle_PCDM_Writer_2 extends Handle_PCDM_Writer {
    constructor(thePtr: PCDM_Writer);
  }

  export declare class Handle_PCDM_Writer_3 extends Handle_PCDM_Writer {
    constructor(theHandle: Handle_PCDM_Writer);
  }

  export declare class Handle_PCDM_Writer_4 extends Handle_PCDM_Writer {
    constructor(theHandle: Handle_PCDM_Writer);
  }

export declare class Handle_PCDM_StorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_StorageDriver): void;
  get(): PCDM_StorageDriver;
  delete(): void;
}

  export declare class Handle_PCDM_StorageDriver_1 extends Handle_PCDM_StorageDriver {
    constructor();
  }

  export declare class Handle_PCDM_StorageDriver_2 extends Handle_PCDM_StorageDriver {
    constructor(thePtr: PCDM_StorageDriver);
  }

  export declare class Handle_PCDM_StorageDriver_3 extends Handle_PCDM_StorageDriver {
    constructor(theHandle: Handle_PCDM_StorageDriver);
  }

  export declare class Handle_PCDM_StorageDriver_4 extends Handle_PCDM_StorageDriver {
    constructor(theHandle: Handle_PCDM_StorageDriver);
  }

export declare class PCDM_StorageDriver extends PCDM_Writer {
  constructor();
  Make_1(aDocument: Handle_CDM_Document): Handle_PCDM_Document;
  Make_2(aDocument: Handle_CDM_Document, Documents: PCDM_SequenceOfDocument): void;
  Write_1(aDocument: Handle_CDM_Document, aFileName: TCollection_ExtendedString, theRange: Message_ProgressRange): void;
  Write_2(theDocument: Handle_CDM_Document, theOStream: Standard_OStream, theRange: Message_ProgressRange): void;
  SetFormat(aformat: TCollection_ExtendedString): void;
  GetFormat(): TCollection_ExtendedString;
  IsError(): Standard_Boolean;
  SetIsError(theIsError: Standard_Boolean): void;
  GetStoreStatus(): PCDM_StoreStatus;
  SetStoreStatus(theStoreStatus: PCDM_StoreStatus): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class PCDM_Document extends Standard_Persistent {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PCDM_Document {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_Document): void;
  get(): PCDM_Document;
  delete(): void;
}

  export declare class Handle_PCDM_Document_1 extends Handle_PCDM_Document {
    constructor();
  }

  export declare class Handle_PCDM_Document_2 extends Handle_PCDM_Document {
    constructor(thePtr: PCDM_Document);
  }

  export declare class Handle_PCDM_Document_3 extends Handle_PCDM_Document {
    constructor(theHandle: Handle_PCDM_Document);
  }

  export declare class Handle_PCDM_Document_4 extends Handle_PCDM_Document {
    constructor(theHandle: Handle_PCDM_Document);
  }

export declare class PCDM_ReadWriter extends Standard_Transient {
  Version(): XCAFDoc_PartId;
  WriteReferenceCounter(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  WriteReferences(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document, theReferencerFileName: TCollection_ExtendedString): void;
  WriteExtensions(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  WriteVersion(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  ReadReferenceCounter(theFileName: TCollection_ExtendedString, theMsgDriver: Handle_Message_Messenger): Graphic3d_ZLayerId;
  ReadReferences(aFileName: TCollection_ExtendedString, theReferences: PCDM_SequenceOfReference, theMsgDriver: Handle_Message_Messenger): void;
  ReadExtensions(aFileName: TCollection_ExtendedString, theExtensions: TColStd_SequenceOfExtendedString, theMsgDriver: Handle_Message_Messenger): void;
  ReadDocumentVersion(aFileName: TCollection_ExtendedString, theMsgDriver: Handle_Message_Messenger): Graphic3d_ZLayerId;
  static Open(aDriver: Handle_Storage_BaseDriver, aFileName: TCollection_ExtendedString, anOpenMode: Storage_OpenMode): void;
  static Reader(aFileName: TCollection_ExtendedString): Handle_PCDM_ReadWriter;
  static Writer(): Handle_PCDM_ReadWriter;
  static WriteFileFormat(aData: Handle_Storage_Data, aDocument: Handle_CDM_Document): void;
  static FileFormat_1(aFileName: TCollection_ExtendedString): TCollection_ExtendedString;
  static FileFormat_2(theIStream: Standard_IStream, theData: Handle_Storage_Data): TCollection_ExtendedString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PCDM_ReadWriter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PCDM_ReadWriter): void;
  get(): PCDM_ReadWriter;
  delete(): void;
}

  export declare class Handle_PCDM_ReadWriter_1 extends Handle_PCDM_ReadWriter {
    constructor();
  }

  export declare class Handle_PCDM_ReadWriter_2 extends Handle_PCDM_ReadWriter {
    constructor(thePtr: PCDM_ReadWriter);
  }

  export declare class Handle_PCDM_ReadWriter_3 extends Handle_PCDM_ReadWriter {
    constructor(theHandle: Handle_PCDM_ReadWriter);
  }

  export declare class Handle_PCDM_ReadWriter_4 extends Handle_PCDM_ReadWriter {
    constructor(theHandle: Handle_PCDM_ReadWriter);
  }

export declare type PCDM_TypeOfFileDriver = {
  PCDM_TOFD_File: {};
  PCDM_TOFD_CmpFile: {};
  PCDM_TOFD_XmlFile: {};
  PCDM_TOFD_Unknown: {};
}

export declare class PCDM_DOMHeaderParser extends LDOMParser {
  constructor();
  SetStartElementName(aStartElementName: XCAFDoc_PartId): void;
  SetEndElementName(anEndElementName: XCAFDoc_PartId): void;
  startElement(): Standard_Boolean;
  endElement(): Standard_Boolean;
  GetElement(): XmlObjMgt_Element;
  delete(): void;
}

export declare class StepToGeom {
  constructor();
  static MakeAxis1Placement(SA: Handle_StepGeom_Axis1Placement): Handle_Geom_Axis1Placement;
  static MakeAxis2Placement(SA: Handle_StepGeom_Axis2Placement3d): Handle_Geom_Axis2Placement;
  static MakeAxisPlacement(SA: Handle_StepGeom_Axis2Placement2d): Handle_Geom2d_AxisPlacement;
  static MakeBoundedCurve(SC: Handle_StepGeom_BoundedCurve): Handle_Geom_BoundedCurve;
  static MakeBoundedCurve2d(SC: Handle_StepGeom_BoundedCurve): Handle_Geom2d_BoundedCurve;
  static MakeBoundedSurface(SS: Handle_StepGeom_BoundedSurface): Handle_Geom_BoundedSurface;
  static MakeBSplineCurve(SC: Handle_StepGeom_BSplineCurve): Handle_Geom_BSplineCurve;
  static MakeBSplineCurve2d(SC: Handle_StepGeom_BSplineCurve): Handle_Geom2d_BSplineCurve;
  static MakeBSplineSurface(SS: Handle_StepGeom_BSplineSurface): Handle_Geom_BSplineSurface;
  static MakeCartesianPoint(SP: Handle_StepGeom_CartesianPoint): Handle_Geom_CartesianPoint;
  static MakeCartesianPoint2d(SP: Handle_StepGeom_CartesianPoint): Handle_Geom2d_CartesianPoint;
  static MakeCircle(SC: Handle_StepGeom_Circle): Handle_Geom_Circle;
  static MakeCircle2d(SC: Handle_StepGeom_Circle): Handle_Geom2d_Circle;
  static MakeConic(SC: Handle_StepGeom_Conic): Handle_Geom_Conic;
  static MakeConic2d(SC: Handle_StepGeom_Conic): Handle_Geom2d_Conic;
  static MakeConicalSurface(SS: Handle_StepGeom_ConicalSurface): Handle_Geom_ConicalSurface;
  static MakeCurve(SC: Handle_StepGeom_Curve): Handle_Geom_Curve;
  static MakeCurve2d(SC: Handle_StepGeom_Curve): Handle_Geom2d_Curve;
  static MakeCylindricalSurface(SS: Handle_StepGeom_CylindricalSurface): Handle_Geom_CylindricalSurface;
  static MakeDirection(SD: Handle_StepGeom_Direction): Handle_Geom_Direction;
  static MakeDirection2d(SD: Handle_StepGeom_Direction): Handle_Geom2d_Direction;
  static MakeElementarySurface(SS: Handle_StepGeom_ElementarySurface): Handle_Geom_ElementarySurface;
  static MakeEllipse(SC: Handle_StepGeom_Ellipse): Handle_Geom_Ellipse;
  static MakeEllipse2d(SC: Handle_StepGeom_Ellipse): Handle_Geom2d_Ellipse;
  static MakeHyperbola(SC: Handle_StepGeom_Hyperbola): Handle_Geom_Hyperbola;
  static MakeHyperbola2d(SC: Handle_StepGeom_Hyperbola): Handle_Geom2d_Hyperbola;
  static MakeLine(SC: Handle_StepGeom_Line): Handle_Geom_Line;
  static MakeLine2d(SC: Handle_StepGeom_Line): Handle_Geom2d_Line;
  static MakeParabola(SC: Handle_StepGeom_Parabola): Handle_Geom_Parabola;
  static MakeParabola2d(SC: Handle_StepGeom_Parabola): Handle_Geom2d_Parabola;
  static MakePlane(SP: Handle_StepGeom_Plane): Handle_Geom_Plane;
  static MakePolyline(SPL: Handle_StepGeom_Polyline): Handle_Geom_BSplineCurve;
  static MakePolyline2d(SPL: Handle_StepGeom_Polyline): Handle_Geom2d_BSplineCurve;
  static MakeRectangularTrimmedSurface(SS: Handle_StepGeom_RectangularTrimmedSurface): Handle_Geom_RectangularTrimmedSurface;
  static MakeSphericalSurface(SS: Handle_StepGeom_SphericalSurface): Handle_Geom_SphericalSurface;
  static MakeSurface(SS: Handle_StepGeom_Surface): Handle_Geom_Surface;
  static MakeSurfaceOfLinearExtrusion(SS: Handle_StepGeom_SurfaceOfLinearExtrusion): Handle_Geom_SurfaceOfLinearExtrusion;
  static MakeSurfaceOfRevolution(SS: Handle_StepGeom_SurfaceOfRevolution): Handle_Geom_SurfaceOfRevolution;
  static MakeSweptSurface(SS: Handle_StepGeom_SweptSurface): Handle_Geom_SweptSurface;
  static MakeToroidalSurface(SS: Handle_StepGeom_ToroidalSurface): Handle_Geom_ToroidalSurface;
  static MakeTransformation2d(SCTO: Handle_StepGeom_CartesianTransformationOperator2d, CT: gp_Trsf2d): Standard_Boolean;
  static MakeTransformation3d(SCTO: Handle_StepGeom_CartesianTransformationOperator3d, CT: gp_Trsf): Standard_Boolean;
  static MakeTrimmedCurve(SC: Handle_StepGeom_TrimmedCurve): Handle_Geom_TrimmedCurve;
  static MakeTrimmedCurve2d(SC: Handle_StepGeom_TrimmedCurve): Handle_Geom2d_BSplineCurve;
  static MakeVectorWithMagnitude(SV: Handle_StepGeom_Vector): Handle_Geom_VectorWithMagnitude;
  static MakeVectorWithMagnitude2d(SV: Handle_StepGeom_Vector): Handle_Geom2d_VectorWithMagnitude;
  delete(): void;
}

export declare class GeomAPI_ProjectPointOnSurf {
  Init_1(P: gp_Pnt, Surface: Handle_Geom_Surface, Tolerance: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo): void;
  Init_2(P: gp_Pnt, Surface: Handle_Geom_Surface, Algo: Extrema_ExtAlgo): void;
  Init_3(P: gp_Pnt, Surface: Handle_Geom_Surface, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo): void;
  Init_4(P: gp_Pnt, Surface: Handle_Geom_Surface, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo): void;
  Init_5(Surface: Handle_Geom_Surface, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo): void;
  Init_6(Surface: Handle_Geom_Surface, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo): void;
  SetExtremaAlgo(theAlgo: Extrema_ExtAlgo): void;
  SetExtremaFlag(theExtFlag: Extrema_ExtFlag): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  Parameters(Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoint(): gp_Pnt;
  LowerDistanceParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtPS;
  delete(): void;
}

  export declare class GeomAPI_ProjectPointOnSurf_1 extends GeomAPI_ProjectPointOnSurf {
    constructor();
  }

  export declare class GeomAPI_ProjectPointOnSurf_2 extends GeomAPI_ProjectPointOnSurf {
    constructor(P: gp_Pnt, Surface: Handle_Geom_Surface, Algo: Extrema_ExtAlgo);
  }

  export declare class GeomAPI_ProjectPointOnSurf_3 extends GeomAPI_ProjectPointOnSurf {
    constructor(P: gp_Pnt, Surface: Handle_Geom_Surface, Tolerance: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo);
  }

  export declare class GeomAPI_ProjectPointOnSurf_4 extends GeomAPI_ProjectPointOnSurf {
    constructor(P: gp_Pnt, Surface: Handle_Geom_Surface, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo);
  }

  export declare class GeomAPI_ProjectPointOnSurf_5 extends GeomAPI_ProjectPointOnSurf {
    constructor(P: gp_Pnt, Surface: Handle_Geom_Surface, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Algo: Extrema_ExtAlgo);
  }

export declare class GeomAPI_PointsToBSplineSurface {
  Init_1(Points: TColgp_Array2OfPnt, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Interpolate_1(Points: TColgp_Array2OfPnt, thePeriodic: Standard_Boolean): void;
  Interpolate_2(Points: TColgp_Array2OfPnt, ParType: Approx_ParametrizationType, thePeriodic: Standard_Boolean): void;
  Init_2(ZPoints: TColStd_Array2OfReal, X0: Quantity_AbsorbedDose, dX: Quantity_AbsorbedDose, Y0: Quantity_AbsorbedDose, dY: Quantity_AbsorbedDose, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Interpolate_3(ZPoints: TColStd_Array2OfReal, X0: Quantity_AbsorbedDose, dX: Quantity_AbsorbedDose, Y0: Quantity_AbsorbedDose, dY: Quantity_AbsorbedDose): void;
  Init_3(Points: TColgp_Array2OfPnt, ParType: Approx_ParametrizationType, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose, thePeriodic: Standard_Boolean): void;
  Init_4(Points: TColgp_Array2OfPnt, Weight1: Quantity_AbsorbedDose, Weight2: Quantity_AbsorbedDose, Weight3: Quantity_AbsorbedDose, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Surface(): Handle_Geom_BSplineSurface;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class GeomAPI_PointsToBSplineSurface_1 extends GeomAPI_PointsToBSplineSurface {
    constructor();
  }

  export declare class GeomAPI_PointsToBSplineSurface_2 extends GeomAPI_PointsToBSplineSurface {
    constructor(Points: TColgp_Array2OfPnt, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_PointsToBSplineSurface_3 extends GeomAPI_PointsToBSplineSurface {
    constructor(Points: TColgp_Array2OfPnt, ParType: Approx_ParametrizationType, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_PointsToBSplineSurface_4 extends GeomAPI_PointsToBSplineSurface {
    constructor(Points: TColgp_Array2OfPnt, Weight1: Quantity_AbsorbedDose, Weight2: Quantity_AbsorbedDose, Weight3: Quantity_AbsorbedDose, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_PointsToBSplineSurface_5 extends GeomAPI_PointsToBSplineSurface {
    constructor(ZPoints: TColStd_Array2OfReal, X0: Quantity_AbsorbedDose, dX: Quantity_AbsorbedDose, Y0: Quantity_AbsorbedDose, dY: Quantity_AbsorbedDose, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

export declare class GeomAPI_PointsToBSpline {
  Init_1(Points: TColgp_Array1OfPnt, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Init_2(Points: TColgp_Array1OfPnt, ParType: Approx_ParametrizationType, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Init_3(Points: TColgp_Array1OfPnt, Parameters: TColStd_Array1OfReal, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Init_4(Points: TColgp_Array1OfPnt, Weight1: Quantity_AbsorbedDose, Weight2: Quantity_AbsorbedDose, Weight3: Quantity_AbsorbedDose, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose): void;
  Curve(): Handle_Geom_BSplineCurve;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class GeomAPI_PointsToBSpline_1 extends GeomAPI_PointsToBSpline {
    constructor();
  }

  export declare class GeomAPI_PointsToBSpline_2 extends GeomAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_PointsToBSpline_3 extends GeomAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt, ParType: Approx_ParametrizationType, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_PointsToBSpline_4 extends GeomAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt, Parameters: TColStd_Array1OfReal, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_PointsToBSpline_5 extends GeomAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt, Weight1: Quantity_AbsorbedDose, Weight2: Quantity_AbsorbedDose, Weight3: Quantity_AbsorbedDose, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

export declare class GeomAPI_ExtremaSurfaceSurface {
  Init_1(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface): void;
  Init_2(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, U1min: Quantity_AbsorbedDose, U1max: Quantity_AbsorbedDose, V1min: Quantity_AbsorbedDose, V1max: Quantity_AbsorbedDose, U2min: Quantity_AbsorbedDose, U2max: Quantity_AbsorbedDose, V2min: Quantity_AbsorbedDose, V2max: Quantity_AbsorbedDose): void;
  NbExtrema(): Graphic3d_ZLayerId;
  Points(Index: Graphic3d_ZLayerId, P1: gp_Pnt, P2: gp_Pnt): void;
  Parameters(Index: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoints(P1: gp_Pnt, P2: gp_Pnt): void;
  LowerDistanceParameters(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtSS;
  delete(): void;
}

  export declare class GeomAPI_ExtremaSurfaceSurface_1 extends GeomAPI_ExtremaSurfaceSurface {
    constructor();
  }

  export declare class GeomAPI_ExtremaSurfaceSurface_2 extends GeomAPI_ExtremaSurfaceSurface {
    constructor(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface);
  }

  export declare class GeomAPI_ExtremaSurfaceSurface_3 extends GeomAPI_ExtremaSurfaceSurface {
    constructor(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, U1min: Quantity_AbsorbedDose, U1max: Quantity_AbsorbedDose, V1min: Quantity_AbsorbedDose, V1max: Quantity_AbsorbedDose, U2min: Quantity_AbsorbedDose, U2max: Quantity_AbsorbedDose, V2min: Quantity_AbsorbedDose, V2max: Quantity_AbsorbedDose);
  }

export declare class GeomAPI_Interpolate {
  Load_1(InitialTangent: gp_Vec, FinalTangent: gp_Vec, Scale: Standard_Boolean): void;
  Load_2(Tangents: TColgp_Array1OfVec, TangentFlags: Handle_TColStd_HArray1OfBoolean, Scale: Standard_Boolean): void;
  Perform(): void;
  Curve(): Handle_Geom_BSplineCurve;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class GeomAPI_Interpolate_1 extends GeomAPI_Interpolate {
    constructor(Points: Handle_TColgp_HArray1OfPnt, PeriodicFlag: Standard_Boolean, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GeomAPI_Interpolate_2 extends GeomAPI_Interpolate {
    constructor(Points: Handle_TColgp_HArray1OfPnt, Parameters: Handle_TColStd_HArray1OfReal, PeriodicFlag: Standard_Boolean, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GeomAPI_ExtremaCurveCurve {
  Init_1(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve): void;
  Init_2(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve, U1min: Quantity_AbsorbedDose, U1max: Quantity_AbsorbedDose, U2min: Quantity_AbsorbedDose, U2max: Quantity_AbsorbedDose): void;
  NbExtrema(): Graphic3d_ZLayerId;
  Points(Index: Graphic3d_ZLayerId, P1: gp_Pnt, P2: gp_Pnt): void;
  Parameters(Index: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoints(P1: gp_Pnt, P2: gp_Pnt): void;
  LowerDistanceParameters(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtCC;
  TotalNearestPoints(P1: gp_Pnt, P2: gp_Pnt): Standard_Boolean;
  TotalLowerDistanceParameters(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): Standard_Boolean;
  TotalLowerDistance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomAPI_ExtremaCurveCurve_1 extends GeomAPI_ExtremaCurveCurve {
    constructor();
  }

  export declare class GeomAPI_ExtremaCurveCurve_2 extends GeomAPI_ExtremaCurveCurve {
    constructor(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve);
  }

  export declare class GeomAPI_ExtremaCurveCurve_3 extends GeomAPI_ExtremaCurveCurve {
    constructor(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve, U1min: Quantity_AbsorbedDose, U1max: Quantity_AbsorbedDose, U2min: Quantity_AbsorbedDose, U2max: Quantity_AbsorbedDose);
  }

export declare class GeomAPI_IntCS {
  Perform(C: Handle_Geom_Curve, S: Handle_Geom_Surface): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  Parameters_1(Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose): void;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  Parameters_2(Index: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class GeomAPI_IntCS_1 extends GeomAPI_IntCS {
    constructor();
  }

  export declare class GeomAPI_IntCS_2 extends GeomAPI_IntCS {
    constructor(C: Handle_Geom_Curve, S: Handle_Geom_Surface);
  }

export declare class GeomAPI_ProjectPointOnCurve {
  Init_1(P: gp_Pnt, Curve: Handle_Geom_Curve): void;
  Init_2(P: gp_Pnt, Curve: Handle_Geom_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Init_3(Curve: Handle_Geom_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  Parameter_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Parameter_2(Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoint(): gp_Pnt;
  LowerDistanceParameter(): Quantity_AbsorbedDose;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtPC;
  delete(): void;
}

  export declare class GeomAPI_ProjectPointOnCurve_1 extends GeomAPI_ProjectPointOnCurve {
    constructor();
  }

  export declare class GeomAPI_ProjectPointOnCurve_2 extends GeomAPI_ProjectPointOnCurve {
    constructor(P: gp_Pnt, Curve: Handle_Geom_Curve);
  }

  export declare class GeomAPI_ProjectPointOnCurve_3 extends GeomAPI_ProjectPointOnCurve {
    constructor(P: gp_Pnt, Curve: Handle_Geom_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

export declare class GeomAPI_ExtremaCurveSurface {
  Init_1(Curve: Handle_Geom_Curve, Surface: Handle_Geom_Surface): void;
  Init_2(Curve: Handle_Geom_Curve, Surface: Handle_Geom_Surface, Wmin: Quantity_AbsorbedDose, Wmax: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  NbExtrema(): Graphic3d_ZLayerId;
  Points(Index: Graphic3d_ZLayerId, P1: gp_Pnt, P2: gp_Pnt): void;
  Parameters(Index: Graphic3d_ZLayerId, W: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoints(PC: gp_Pnt, PS: gp_Pnt): void;
  LowerDistanceParameters(W: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtCS;
  delete(): void;
}

  export declare class GeomAPI_ExtremaCurveSurface_1 extends GeomAPI_ExtremaCurveSurface {
    constructor();
  }

  export declare class GeomAPI_ExtremaCurveSurface_2 extends GeomAPI_ExtremaCurveSurface {
    constructor(Curve: Handle_Geom_Curve, Surface: Handle_Geom_Surface);
  }

  export declare class GeomAPI_ExtremaCurveSurface_3 extends GeomAPI_ExtremaCurveSurface {
    constructor(Curve: Handle_Geom_Curve, Surface: Handle_Geom_Surface, Wmin: Quantity_AbsorbedDose, Wmax: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose);
  }

export declare class GeomAPI {
  constructor();
  static To2d(C: Handle_Geom_Curve, P: gp_Pln): Handle_Geom2d_Curve;
  static To3d(C: Handle_Geom2d_Curve, P: gp_Pln): Handle_Geom_Curve;
  delete(): void;
}

export declare class GeomAPI_IntSS {
  Perform(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  delete(): void;
}

  export declare class GeomAPI_IntSS_1 extends GeomAPI_IntSS {
    constructor();
  }

  export declare class GeomAPI_IntSS_2 extends GeomAPI_IntSS {
    constructor(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose);
  }

export declare class Handle_STEPSelections_SelectGSCurves {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_SelectGSCurves): void;
  get(): STEPSelections_SelectGSCurves;
  delete(): void;
}

  export declare class Handle_STEPSelections_SelectGSCurves_1 extends Handle_STEPSelections_SelectGSCurves {
    constructor();
  }

  export declare class Handle_STEPSelections_SelectGSCurves_2 extends Handle_STEPSelections_SelectGSCurves {
    constructor(thePtr: STEPSelections_SelectGSCurves);
  }

  export declare class Handle_STEPSelections_SelectGSCurves_3 extends Handle_STEPSelections_SelectGSCurves {
    constructor(theHandle: Handle_STEPSelections_SelectGSCurves);
  }

  export declare class Handle_STEPSelections_SelectGSCurves_4 extends Handle_STEPSelections_SelectGSCurves {
    constructor(theHandle: Handle_STEPSelections_SelectGSCurves);
  }

export declare class STEPSelections_SelectGSCurves extends IFSelect_SelectExplore {
  constructor()
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPSelections_SelectInstances {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_SelectInstances): void;
  get(): STEPSelections_SelectInstances;
  delete(): void;
}

  export declare class Handle_STEPSelections_SelectInstances_1 extends Handle_STEPSelections_SelectInstances {
    constructor();
  }

  export declare class Handle_STEPSelections_SelectInstances_2 extends Handle_STEPSelections_SelectInstances {
    constructor(thePtr: STEPSelections_SelectInstances);
  }

  export declare class Handle_STEPSelections_SelectInstances_3 extends Handle_STEPSelections_SelectInstances {
    constructor(theHandle: Handle_STEPSelections_SelectInstances);
  }

  export declare class Handle_STEPSelections_SelectInstances_4 extends Handle_STEPSelections_SelectInstances {
    constructor(theHandle: Handle_STEPSelections_SelectInstances);
  }

export declare class STEPSelections_SelectInstances extends IFSelect_SelectExplore {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPSelections_AssemblyComponent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_AssemblyComponent): void;
  get(): STEPSelections_AssemblyComponent;
  delete(): void;
}

  export declare class Handle_STEPSelections_AssemblyComponent_1 extends Handle_STEPSelections_AssemblyComponent {
    constructor();
  }

  export declare class Handle_STEPSelections_AssemblyComponent_2 extends Handle_STEPSelections_AssemblyComponent {
    constructor(thePtr: STEPSelections_AssemblyComponent);
  }

  export declare class Handle_STEPSelections_AssemblyComponent_3 extends Handle_STEPSelections_AssemblyComponent {
    constructor(theHandle: Handle_STEPSelections_AssemblyComponent);
  }

  export declare class Handle_STEPSelections_AssemblyComponent_4 extends Handle_STEPSelections_AssemblyComponent {
    constructor(theHandle: Handle_STEPSelections_AssemblyComponent);
  }

export declare class STEPSelections_AssemblyComponent extends Standard_Transient {
  GetSDR(): Handle_StepShape_ShapeDefinitionRepresentation;
  GetList(): Handle_STEPSelections_HSequenceOfAssemblyLink;
  SetSDR(sdr: Handle_StepShape_ShapeDefinitionRepresentation): void;
  SetList(list: Handle_STEPSelections_HSequenceOfAssemblyLink): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class STEPSelections_AssemblyComponent_1 extends STEPSelections_AssemblyComponent {
    constructor();
  }

  export declare class STEPSelections_AssemblyComponent_2 extends STEPSelections_AssemblyComponent {
    constructor(sdr: Handle_StepShape_ShapeDefinitionRepresentation, list: Handle_STEPSelections_HSequenceOfAssemblyLink);
  }

export declare class STEPSelections_SelectDerived extends StepSelect_StepType {
  constructor()
  Matches(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel, text: XCAFDoc_PartId, exact: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPSelections_SelectDerived {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_SelectDerived): void;
  get(): STEPSelections_SelectDerived;
  delete(): void;
}

  export declare class Handle_STEPSelections_SelectDerived_1 extends Handle_STEPSelections_SelectDerived {
    constructor();
  }

  export declare class Handle_STEPSelections_SelectDerived_2 extends Handle_STEPSelections_SelectDerived {
    constructor(thePtr: STEPSelections_SelectDerived);
  }

  export declare class Handle_STEPSelections_SelectDerived_3 extends Handle_STEPSelections_SelectDerived {
    constructor(theHandle: Handle_STEPSelections_SelectDerived);
  }

  export declare class Handle_STEPSelections_SelectDerived_4 extends Handle_STEPSelections_SelectDerived {
    constructor(theHandle: Handle_STEPSelections_SelectDerived);
  }

export declare class Handle_STEPSelections_HSequenceOfAssemblyLink {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_HSequenceOfAssemblyLink): void;
  get(): STEPSelections_HSequenceOfAssemblyLink;
  delete(): void;
}

  export declare class Handle_STEPSelections_HSequenceOfAssemblyLink_1 extends Handle_STEPSelections_HSequenceOfAssemblyLink {
    constructor();
  }

  export declare class Handle_STEPSelections_HSequenceOfAssemblyLink_2 extends Handle_STEPSelections_HSequenceOfAssemblyLink {
    constructor(thePtr: STEPSelections_HSequenceOfAssemblyLink);
  }

  export declare class Handle_STEPSelections_HSequenceOfAssemblyLink_3 extends Handle_STEPSelections_HSequenceOfAssemblyLink {
    constructor(theHandle: Handle_STEPSelections_HSequenceOfAssemblyLink);
  }

  export declare class Handle_STEPSelections_HSequenceOfAssemblyLink_4 extends Handle_STEPSelections_HSequenceOfAssemblyLink {
    constructor(theHandle: Handle_STEPSelections_HSequenceOfAssemblyLink);
  }

export declare class Handle_STEPSelections_SelectAssembly {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_SelectAssembly): void;
  get(): STEPSelections_SelectAssembly;
  delete(): void;
}

  export declare class Handle_STEPSelections_SelectAssembly_1 extends Handle_STEPSelections_SelectAssembly {
    constructor();
  }

  export declare class Handle_STEPSelections_SelectAssembly_2 extends Handle_STEPSelections_SelectAssembly {
    constructor(thePtr: STEPSelections_SelectAssembly);
  }

  export declare class Handle_STEPSelections_SelectAssembly_3 extends Handle_STEPSelections_SelectAssembly {
    constructor(theHandle: Handle_STEPSelections_SelectAssembly);
  }

  export declare class Handle_STEPSelections_SelectAssembly_4 extends Handle_STEPSelections_SelectAssembly {
    constructor(theHandle: Handle_STEPSelections_SelectAssembly);
  }

export declare class STEPSelections_SelectAssembly extends IFSelect_SelectExplore {
  constructor()
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPSelections_SelectFaces {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_SelectFaces): void;
  get(): STEPSelections_SelectFaces;
  delete(): void;
}

  export declare class Handle_STEPSelections_SelectFaces_1 extends Handle_STEPSelections_SelectFaces {
    constructor();
  }

  export declare class Handle_STEPSelections_SelectFaces_2 extends Handle_STEPSelections_SelectFaces {
    constructor(thePtr: STEPSelections_SelectFaces);
  }

  export declare class Handle_STEPSelections_SelectFaces_3 extends Handle_STEPSelections_SelectFaces {
    constructor(theHandle: Handle_STEPSelections_SelectFaces);
  }

  export declare class Handle_STEPSelections_SelectFaces_4 extends Handle_STEPSelections_SelectFaces {
    constructor(theHandle: Handle_STEPSelections_SelectFaces);
  }

export declare class STEPSelections_SelectFaces extends IFSelect_SelectExplore {
  constructor()
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class STEPSelections_AssemblyLink extends Standard_Transient {
  GetNAUO(): Handle_StepRepr_NextAssemblyUsageOccurrence;
  GetItem(): Handle_Standard_Transient;
  GetComponent(): Handle_STEPSelections_AssemblyComponent;
  SetNAUO(nauo: Handle_StepRepr_NextAssemblyUsageOccurrence): void;
  SetItem(item: Handle_Standard_Transient): void;
  SetComponent(part: Handle_STEPSelections_AssemblyComponent): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class STEPSelections_AssemblyLink_1 extends STEPSelections_AssemblyLink {
    constructor();
  }

  export declare class STEPSelections_AssemblyLink_2 extends STEPSelections_AssemblyLink {
    constructor(nauo: Handle_StepRepr_NextAssemblyUsageOccurrence, item: Handle_Standard_Transient, part: Handle_STEPSelections_AssemblyComponent);
  }

export declare class Handle_STEPSelections_AssemblyLink {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_AssemblyLink): void;
  get(): STEPSelections_AssemblyLink;
  delete(): void;
}

  export declare class Handle_STEPSelections_AssemblyLink_1 extends Handle_STEPSelections_AssemblyLink {
    constructor();
  }

  export declare class Handle_STEPSelections_AssemblyLink_2 extends Handle_STEPSelections_AssemblyLink {
    constructor(thePtr: STEPSelections_AssemblyLink);
  }

  export declare class Handle_STEPSelections_AssemblyLink_3 extends Handle_STEPSelections_AssemblyLink {
    constructor(theHandle: Handle_STEPSelections_AssemblyLink);
  }

  export declare class Handle_STEPSelections_AssemblyLink_4 extends Handle_STEPSelections_AssemblyLink {
    constructor(theHandle: Handle_STEPSelections_AssemblyLink);
  }

export declare class STEPSelections_AssemblyExplorer {
  constructor(G: Interface_Graph)
  Init(G: Interface_Graph): void;
  Dump(os: Standard_OStream): void;
  FindSDRWithProduct(product: Handle_StepBasic_ProductDefinition): Handle_StepShape_ShapeDefinitionRepresentation;
  FillListWithGraph(cmp: Handle_STEPSelections_AssemblyComponent): void;
  FindItemWithNAUO(nauo: Handle_StepRepr_NextAssemblyUsageOccurrence): Handle_Standard_Transient;
  NbAssemblies(): Graphic3d_ZLayerId;
  Root(rank: Graphic3d_ZLayerId): Handle_STEPSelections_AssemblyComponent;
  delete(): void;
}

export declare class STEPSelections_SelectForTransfer extends XSControl_SelectForTransfer {
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class STEPSelections_SelectForTransfer_1 extends STEPSelections_SelectForTransfer {
    constructor();
  }

  export declare class STEPSelections_SelectForTransfer_2 extends STEPSelections_SelectForTransfer {
    constructor(TR: Handle_XSControl_TransferReader);
  }

export declare class Handle_STEPSelections_SelectForTransfer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPSelections_SelectForTransfer): void;
  get(): STEPSelections_SelectForTransfer;
  delete(): void;
}

  export declare class Handle_STEPSelections_SelectForTransfer_1 extends Handle_STEPSelections_SelectForTransfer {
    constructor();
  }

  export declare class Handle_STEPSelections_SelectForTransfer_2 extends Handle_STEPSelections_SelectForTransfer {
    constructor(thePtr: STEPSelections_SelectForTransfer);
  }

  export declare class Handle_STEPSelections_SelectForTransfer_3 extends Handle_STEPSelections_SelectForTransfer {
    constructor(theHandle: Handle_STEPSelections_SelectForTransfer);
  }

  export declare class Handle_STEPSelections_SelectForTransfer_4 extends Handle_STEPSelections_SelectForTransfer {
    constructor(theHandle: Handle_STEPSelections_SelectForTransfer);
  }

export declare class PLib_DoubleJacobiPolynomial {
  MaxErrorU(Dimension: Graphic3d_ZLayerId, DegreeU: Graphic3d_ZLayerId, DegreeV: Graphic3d_ZLayerId, dJacCoeff: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  MaxErrorV(Dimension: Graphic3d_ZLayerId, DegreeU: Graphic3d_ZLayerId, DegreeV: Graphic3d_ZLayerId, dJacCoeff: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  MaxError(Dimension: Graphic3d_ZLayerId, MinDegreeU: Graphic3d_ZLayerId, MaxDegreeU: Graphic3d_ZLayerId, MinDegreeV: Graphic3d_ZLayerId, MaxDegreeV: Graphic3d_ZLayerId, dJacCoeff: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal, Error: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  ReduceDegree(Dimension: Graphic3d_ZLayerId, MinDegreeU: Graphic3d_ZLayerId, MaxDegreeU: Graphic3d_ZLayerId, MinDegreeV: Graphic3d_ZLayerId, MaxDegreeV: Graphic3d_ZLayerId, dJacCoeff: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal, EpmsCut: Quantity_AbsorbedDose, MaxError: Quantity_AbsorbedDose, NewDegreeU: Graphic3d_ZLayerId, NewDegreeV: Graphic3d_ZLayerId): void;
  AverageError(Dimension: Graphic3d_ZLayerId, DegreeU: Graphic3d_ZLayerId, DegreeV: Graphic3d_ZLayerId, dJacCoeff: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  WDoubleJacobiToCoefficients(Dimension: Graphic3d_ZLayerId, DegreeU: Graphic3d_ZLayerId, DegreeV: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal, Coefficients: TColStd_Array1OfReal): void;
  U(): Handle_PLib_JacobiPolynomial;
  V(): Handle_PLib_JacobiPolynomial;
  TabMaxU(): Handle_TColStd_HArray1OfReal;
  TabMaxV(): Handle_TColStd_HArray1OfReal;
  delete(): void;
}

  export declare class PLib_DoubleJacobiPolynomial_1 extends PLib_DoubleJacobiPolynomial {
    constructor();
  }

  export declare class PLib_DoubleJacobiPolynomial_2 extends PLib_DoubleJacobiPolynomial {
    constructor(JacPolU: Handle_PLib_JacobiPolynomial, JacPolV: Handle_PLib_JacobiPolynomial);
  }

export declare class PLib {
  constructor();
  static NoWeights(): TColStd_Array1OfReal;
  static NoWeights2(): TColStd_Array2OfReal;
  static SetPoles_1(Poles: TColgp_Array1OfPnt, FP: TColStd_Array1OfReal): void;
  static SetPoles_2(Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, FP: TColStd_Array1OfReal): void;
  static GetPoles_1(FP: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt): void;
  static GetPoles_2(FP: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal): void;
  static SetPoles_3(Poles: TColgp_Array1OfPnt2d, FP: TColStd_Array1OfReal): void;
  static SetPoles_4(Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, FP: TColStd_Array1OfReal): void;
  static GetPoles_3(FP: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d): void;
  static GetPoles_4(FP: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal): void;
  static Bin(N: Graphic3d_ZLayerId, P: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static RationalDerivative(Degree: Graphic3d_ZLayerId, N: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, Ders: Quantity_AbsorbedDose, RDers: Quantity_AbsorbedDose, All: Standard_Boolean): void;
  static RationalDerivatives(DerivativesRequest: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, PolesDerivatives: Quantity_AbsorbedDose, WeightsDerivatives: Quantity_AbsorbedDose, RationalDerivates: Quantity_AbsorbedDose): void;
  static EvalPolynomial(U: Quantity_AbsorbedDose, DerivativeOrder: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, PolynomialCoeff: Quantity_AbsorbedDose, Results: Quantity_AbsorbedDose): void;
  static NoDerivativeEvalPolynomial(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, DegreeDimension: Graphic3d_ZLayerId, PolynomialCoeff: Quantity_AbsorbedDose, Results: Quantity_AbsorbedDose): void;
  static EvalPoly2Var(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UDerivativeOrder: Graphic3d_ZLayerId, VDerivativeOrder: Graphic3d_ZLayerId, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, PolynomialCoeff: Quantity_AbsorbedDose, Results: Quantity_AbsorbedDose): void;
  static EvalLagrange(U: Quantity_AbsorbedDose, DerivativeOrder: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, ValueArray: Quantity_AbsorbedDose, ParameterArray: Quantity_AbsorbedDose, Results: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static EvalCubicHermite(U: Quantity_AbsorbedDose, DerivativeOrder: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, ValueArray: Quantity_AbsorbedDose, DerivativeArray: Quantity_AbsorbedDose, ParameterArray: Quantity_AbsorbedDose, Results: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static HermiteCoefficients(FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, FirstOrder: Graphic3d_ZLayerId, LastOrder: Graphic3d_ZLayerId, MatrixCoefs: math_Matrix): Standard_Boolean;
  static CoefficientsPoles_1(Coefs: TColgp_Array1OfPnt, WCoefs: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, WPoles: TColStd_Array1OfReal): void;
  static CoefficientsPoles_2(Coefs: TColgp_Array1OfPnt2d, WCoefs: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, WPoles: TColStd_Array1OfReal): void;
  static CoefficientsPoles_3(Coefs: TColStd_Array1OfReal, WCoefs: TColStd_Array1OfReal, Poles: TColStd_Array1OfReal, WPoles: TColStd_Array1OfReal): void;
  static CoefficientsPoles_4(dim: Graphic3d_ZLayerId, Coefs: TColStd_Array1OfReal, WCoefs: TColStd_Array1OfReal, Poles: TColStd_Array1OfReal, WPoles: TColStd_Array1OfReal): void;
  static Trimming_1(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Coeffs: TColgp_Array1OfPnt, WCoeffs: TColStd_Array1OfReal): void;
  static Trimming_2(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Coeffs: TColgp_Array1OfPnt2d, WCoeffs: TColStd_Array1OfReal): void;
  static Trimming_3(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Coeffs: TColStd_Array1OfReal, WCoeffs: TColStd_Array1OfReal): void;
  static Trimming_4(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, dim: Graphic3d_ZLayerId, Coeffs: TColStd_Array1OfReal, WCoeffs: TColStd_Array1OfReal): void;
  static CoefficientsPoles_5(Coefs: TColgp_Array2OfPnt, WCoefs: TColStd_Array2OfReal, Poles: TColgp_Array2OfPnt, WPoles: TColStd_Array2OfReal): void;
  static UTrimming(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Coeffs: TColgp_Array2OfPnt, WCoeffs: TColStd_Array2OfReal): void;
  static VTrimming(V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Coeffs: TColgp_Array2OfPnt, WCoeffs: TColStd_Array2OfReal): void;
  static HermiteInterpolate(Dimension: Graphic3d_ZLayerId, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, FirstOrder: Graphic3d_ZLayerId, LastOrder: Graphic3d_ZLayerId, FirstConstr: TColStd_Array2OfReal, LastConstr: TColStd_Array2OfReal, Coefficients: TColStd_Array1OfReal): Standard_Boolean;
  static JacobiParameters(ConstraintOrder: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, Code: Graphic3d_ZLayerId, NbGaussPoints: Graphic3d_ZLayerId, WorkDegree: Graphic3d_ZLayerId): void;
  static NivConstr(ConstraintOrder: GeomAbs_Shape): Graphic3d_ZLayerId;
  static ConstraintOrder(NivConstr: Graphic3d_ZLayerId): GeomAbs_Shape;
  static EvalLength_1(Degree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, PolynomialCoeff: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Length: Quantity_AbsorbedDose): void;
  static EvalLength_2(Degree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, PolynomialCoeff: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Length: Quantity_AbsorbedDose, Error: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class PLib_HermitJacobi extends PLib_Base {
  constructor(WorkDegree: Graphic3d_ZLayerId, ConstraintOrder: GeomAbs_Shape)
  MaxError(Dimension: Graphic3d_ZLayerId, HermJacCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ReduceDegree(Dimension: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, HermJacCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId, MaxError: Quantity_AbsorbedDose): void;
  AverageError(Dimension: Graphic3d_ZLayerId, HermJacCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ToCoefficients(Dimension: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, HermJacCoeff: TColStd_Array1OfReal, Coefficients: TColStd_Array1OfReal): void;
  D0(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal): void;
  D1(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal): void;
  D2(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal, BasisD2: TColStd_Array1OfReal): void;
  D3(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal, BasisD2: TColStd_Array1OfReal, BasisD3: TColStd_Array1OfReal): void;
  WorkDegree(): Graphic3d_ZLayerId;
  NivConstr(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PLib_HermitJacobi {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PLib_HermitJacobi): void;
  get(): PLib_HermitJacobi;
  delete(): void;
}

  export declare class Handle_PLib_HermitJacobi_1 extends Handle_PLib_HermitJacobi {
    constructor();
  }

  export declare class Handle_PLib_HermitJacobi_2 extends Handle_PLib_HermitJacobi {
    constructor(thePtr: PLib_HermitJacobi);
  }

  export declare class Handle_PLib_HermitJacobi_3 extends Handle_PLib_HermitJacobi {
    constructor(theHandle: Handle_PLib_HermitJacobi);
  }

  export declare class Handle_PLib_HermitJacobi_4 extends Handle_PLib_HermitJacobi {
    constructor(theHandle: Handle_PLib_HermitJacobi);
  }

export declare class PLib_JacobiPolynomial extends PLib_Base {
  constructor(WorkDegree: Graphic3d_ZLayerId, ConstraintOrder: GeomAbs_Shape)
  Points(NbGaussPoints: Graphic3d_ZLayerId, TabPoints: TColStd_Array1OfReal): void;
  Weights(NbGaussPoints: Graphic3d_ZLayerId, TabWeights: TColStd_Array2OfReal): void;
  MaxValue(TabMax: TColStd_Array1OfReal): void;
  MaxError(Dimension: Graphic3d_ZLayerId, JacCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ReduceDegree(Dimension: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, JacCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId, MaxError: Quantity_AbsorbedDose): void;
  AverageError(Dimension: Graphic3d_ZLayerId, JacCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ToCoefficients(Dimension: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, JacCoeff: TColStd_Array1OfReal, Coefficients: TColStd_Array1OfReal): void;
  D0(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal): void;
  D1(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal): void;
  D2(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal, BasisD2: TColStd_Array1OfReal): void;
  D3(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal, BasisD2: TColStd_Array1OfReal, BasisD3: TColStd_Array1OfReal): void;
  WorkDegree(): Graphic3d_ZLayerId;
  NivConstr(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PLib_JacobiPolynomial {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PLib_JacobiPolynomial): void;
  get(): PLib_JacobiPolynomial;
  delete(): void;
}

  export declare class Handle_PLib_JacobiPolynomial_1 extends Handle_PLib_JacobiPolynomial {
    constructor();
  }

  export declare class Handle_PLib_JacobiPolynomial_2 extends Handle_PLib_JacobiPolynomial {
    constructor(thePtr: PLib_JacobiPolynomial);
  }

  export declare class Handle_PLib_JacobiPolynomial_3 extends Handle_PLib_JacobiPolynomial {
    constructor(theHandle: Handle_PLib_JacobiPolynomial);
  }

  export declare class Handle_PLib_JacobiPolynomial_4 extends Handle_PLib_JacobiPolynomial {
    constructor(theHandle: Handle_PLib_JacobiPolynomial);
  }

export declare class Handle_PLib_Base {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PLib_Base): void;
  get(): PLib_Base;
  delete(): void;
}

  export declare class Handle_PLib_Base_1 extends Handle_PLib_Base {
    constructor();
  }

  export declare class Handle_PLib_Base_2 extends Handle_PLib_Base {
    constructor(thePtr: PLib_Base);
  }

  export declare class Handle_PLib_Base_3 extends Handle_PLib_Base {
    constructor(theHandle: Handle_PLib_Base);
  }

  export declare class Handle_PLib_Base_4 extends Handle_PLib_Base {
    constructor(theHandle: Handle_PLib_Base);
  }

export declare class PLib_Base extends Standard_Transient {
  ToCoefficients(Dimension: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, CoeffinBase: TColStd_Array1OfReal, Coefficients: TColStd_Array1OfReal): void;
  D0(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal): void;
  D1(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal): void;
  D2(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal, BasisD2: TColStd_Array1OfReal): void;
  D3(U: Quantity_AbsorbedDose, BasisValue: TColStd_Array1OfReal, BasisD1: TColStd_Array1OfReal, BasisD2: TColStd_Array1OfReal, BasisD3: TColStd_Array1OfReal): void;
  WorkDegree(): Graphic3d_ZLayerId;
  ReduceDegree(Dimension: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, BaseCoeff: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId, MaxError: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class gp_QuaternionNLerp {
  static Interpolate_1(theQStart: gp_Quaternion, theQEnd: gp_Quaternion, theT: Quantity_AbsorbedDose): gp_Quaternion;
  Init(theQStart: gp_Quaternion, theQEnd: gp_Quaternion): void;
  InitFromUnit(theQStart: gp_Quaternion, theQEnd: gp_Quaternion): void;
  Interpolate_2(theT: Quantity_AbsorbedDose, theResultQ: gp_Quaternion): void;
  delete(): void;
}

  export declare class gp_QuaternionNLerp_1 extends gp_QuaternionNLerp {
    constructor();
  }

  export declare class gp_QuaternionNLerp_2 extends gp_QuaternionNLerp {
    constructor(theQStart: gp_Quaternion, theQEnd: gp_Quaternion);
  }

export declare class gp_Quaternion {
  IsEqual(theOther: gp_Quaternion): Standard_Boolean;
  SetRotation_1(theVecFrom: gp_Vec, theVecTo: gp_Vec): void;
  SetRotation_2(theVecFrom: gp_Vec, theVecTo: gp_Vec, theHelpCrossVec: gp_Vec): void;
  SetVectorAndAngle(theAxis: gp_Vec, theAngle: Quantity_AbsorbedDose): void;
  GetVectorAndAngle(theAxis: gp_Vec, theAngle: Quantity_AbsorbedDose): void;
  SetMatrix(theMat: gp_Mat): void;
  GetMatrix(): gp_Mat;
  SetEulerAngles(theOrder: gp_EulerSequence, theAlpha: Quantity_AbsorbedDose, theBeta: Quantity_AbsorbedDose, theGamma: Quantity_AbsorbedDose): void;
  GetEulerAngles(theOrder: gp_EulerSequence, theAlpha: Quantity_AbsorbedDose, theBeta: Quantity_AbsorbedDose, theGamma: Quantity_AbsorbedDose): void;
  Set_1(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, w: Quantity_AbsorbedDose): void;
  Set_2(theQuaternion: gp_Quaternion): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  W(): Quantity_AbsorbedDose;
  SetIdent(): void;
  Reverse(): void;
  Reversed(): gp_Quaternion;
  Invert(): void;
  Inverted(): gp_Quaternion;
  SquareNorm(): Quantity_AbsorbedDose;
  Norm(): Quantity_AbsorbedDose;
  Scale(theScale: Quantity_AbsorbedDose): void;
  Scaled(theScale: Quantity_AbsorbedDose): gp_Quaternion;
  StabilizeLength(): void;
  Normalize(): void;
  Normalized(): gp_Quaternion;
  Negated(): gp_Quaternion;
  Added(theOther: gp_Quaternion): gp_Quaternion;
  Subtracted(theOther: gp_Quaternion): gp_Quaternion;
  Multiplied(theOther: gp_Quaternion): gp_Quaternion;
  Add(theOther: gp_Quaternion): void;
  Subtract(theOther: gp_Quaternion): void;
  Multiply_1(theOther: gp_Quaternion): void;
  Dot(theOther: gp_Quaternion): Quantity_AbsorbedDose;
  GetRotationAngle(): Quantity_AbsorbedDose;
  Multiply_2(theVec: gp_Vec): gp_Vec;
  delete(): void;
}

  export declare class gp_Quaternion_1 extends gp_Quaternion {
    constructor();
  }

  export declare class gp_Quaternion_2 extends gp_Quaternion {
    constructor(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, w: Quantity_AbsorbedDose);
  }

  export declare class gp_Quaternion_3 extends gp_Quaternion {
    constructor(theVecFrom: gp_Vec, theVecTo: gp_Vec);
  }

  export declare class gp_Quaternion_4 extends gp_Quaternion {
    constructor(theVecFrom: gp_Vec, theVecTo: gp_Vec, theHelpCrossVec: gp_Vec);
  }

  export declare class gp_Quaternion_5 extends gp_Quaternion {
    constructor(theAxis: gp_Vec, theAngle: Quantity_AbsorbedDose);
  }

  export declare class gp_Quaternion_6 extends gp_Quaternion {
    constructor(theMat: gp_Mat);
  }

export declare class gp_Sphere {
  SetLocation(Loc: gp_Pnt): void;
  SetPosition(A3: gp_Ax3): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  Area(): Quantity_AbsorbedDose;
  Coefficients(A1: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, B1: Quantity_AbsorbedDose, B2: Quantity_AbsorbedDose, B3: Quantity_AbsorbedDose, C1: Quantity_AbsorbedDose, C2: Quantity_AbsorbedDose, C3: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  UReverse(): void;
  VReverse(): void;
  Direct(): Standard_Boolean;
  Location(): gp_Pnt;
  Position(): gp_Ax3;
  Radius(): Quantity_AbsorbedDose;
  Volume(): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Sphere;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Sphere;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Sphere;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Sphere;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Sphere;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Sphere;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Sphere;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Sphere;
  delete(): void;
}

  export declare class gp_Sphere_1 extends gp_Sphere {
    constructor();
  }

  export declare class gp_Sphere_2 extends gp_Sphere {
    constructor(A3: gp_Ax3, Radius: Quantity_AbsorbedDose);
  }

export declare class gp_Ax2 {
  SetAxis(A1: gp_Ax1): void;
  SetDirection(V: gp_Dir): void;
  SetLocation(P: gp_Pnt): void;
  SetXDirection(Vx: gp_Dir): void;
  SetYDirection(Vy: gp_Dir): void;
  Angle(Other: gp_Ax2): Quantity_AbsorbedDose;
  Axis(): gp_Ax1;
  Direction(): gp_Dir;
  Location(): gp_Pnt;
  XDirection(): gp_Dir;
  YDirection(): gp_Dir;
  IsCoplanar_1(Other: gp_Ax2, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsCoplanar_2(A1: gp_Ax1, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Ax2;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Ax2;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Ax2;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Ax2;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Ax2;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Ax2;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Ax2;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Ax2;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_Ax2_1 extends gp_Ax2 {
    constructor();
  }

  export declare class gp_Ax2_2 extends gp_Ax2 {
    constructor(P: gp_Pnt, N: gp_Dir, Vx: gp_Dir);
  }

  export declare class gp_Ax2_3 extends gp_Ax2 {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

export declare class gp_Elips {
  SetAxis(A1: gp_Ax1): void;
  SetLocation(P: gp_Pnt): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  SetPosition(A2: gp_Ax2): void;
  Area(): Quantity_AbsorbedDose;
  Axis(): gp_Ax1;
  Directrix1(): gp_Ax1;
  Directrix2(): gp_Ax1;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt;
  Focus2(): gp_Pnt;
  Location(): gp_Pnt;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  Position(): gp_Ax2;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Elips;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Elips;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Elips;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Elips;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Elips;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Elips;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Elips;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Elips;
  delete(): void;
}

  export declare class gp_Elips_1 extends gp_Elips {
    constructor();
  }

  export declare class gp_Elips_2 extends gp_Elips {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class gp_XY {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeCoord(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Modulus(): Quantity_AbsorbedDose;
  SquareModulus(): Quantity_AbsorbedDose;
  IsEqual(Other: gp_XY, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Add(Other: gp_XY): void;
  Added(Other: gp_XY): gp_XY;
  Crossed(Right: gp_XY): Quantity_AbsorbedDose;
  CrossMagnitude(Right: gp_XY): Quantity_AbsorbedDose;
  CrossSquareMagnitude(Right: gp_XY): Quantity_AbsorbedDose;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): gp_XY;
  Dot(Other: gp_XY): Quantity_AbsorbedDose;
  Multiply_1(Scalar: Quantity_AbsorbedDose): void;
  Multiply_2(Other: gp_XY): void;
  Multiply_3(Matrix: gp_Mat2d): void;
  Multiplied_1(Scalar: Quantity_AbsorbedDose): gp_XY;
  Multiplied_2(Other: gp_XY): gp_XY;
  Multiplied_3(Matrix: gp_Mat2d): gp_XY;
  Normalize(): void;
  Normalized(): gp_XY;
  Reverse(): void;
  Reversed(): gp_XY;
  SetLinearForm_1(A1: Quantity_AbsorbedDose, XY1: gp_XY, A2: Quantity_AbsorbedDose, XY2: gp_XY): void;
  SetLinearForm_2(A1: Quantity_AbsorbedDose, XY1: gp_XY, A2: Quantity_AbsorbedDose, XY2: gp_XY, XY3: gp_XY): void;
  SetLinearForm_3(A1: Quantity_AbsorbedDose, XY1: gp_XY, XY2: gp_XY): void;
  SetLinearForm_4(XY1: gp_XY, XY2: gp_XY): void;
  Subtract(Right: gp_XY): void;
  Subtracted(Right: gp_XY): gp_XY;
  delete(): void;
}

  export declare class gp_XY_1 extends gp_XY {
    constructor();
  }

  export declare class gp_XY_2 extends gp_XY {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose);
  }

export declare class gp_Ax3 {
  XReverse(): void;
  YReverse(): void;
  ZReverse(): void;
  SetAxis(A1: gp_Ax1): void;
  SetDirection(V: gp_Dir): void;
  SetLocation(P: gp_Pnt): void;
  SetXDirection(Vx: gp_Dir): void;
  SetYDirection(Vy: gp_Dir): void;
  Angle(Other: gp_Ax3): Quantity_AbsorbedDose;
  Axis(): gp_Ax1;
  Ax2(): gp_Ax2;
  Direction(): gp_Dir;
  Location(): gp_Pnt;
  XDirection(): gp_Dir;
  YDirection(): gp_Dir;
  Direct(): Standard_Boolean;
  IsCoplanar_1(Other: gp_Ax3, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsCoplanar_2(A1: gp_Ax1, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Ax3;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Ax3;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Ax3;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Ax3;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Ax3;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Ax3;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Ax3;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Ax3;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_Ax3_1 extends gp_Ax3 {
    constructor();
  }

  export declare class gp_Ax3_2 extends gp_Ax3 {
    constructor(A: gp_Ax2);
  }

  export declare class gp_Ax3_3 extends gp_Ax3 {
    constructor(P: gp_Pnt, N: gp_Dir, Vx: gp_Dir);
  }

  export declare class gp_Ax3_4 extends gp_Ax3 {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

export declare class gp_Parab2d {
  SetFocal(Focal: Quantity_AbsorbedDose): void;
  SetLocation(P: gp_Pnt2d): void;
  SetMirrorAxis(A: gp_Ax2d): void;
  SetAxis(A: gp_Ax22d): void;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): void;
  Directrix(): gp_Ax2d;
  Focal(): Quantity_AbsorbedDose;
  Focus(): gp_Pnt2d;
  Location(): gp_Pnt2d;
  MirrorAxis(): gp_Ax2d;
  Axis(): gp_Ax22d;
  Parameter(): Quantity_AbsorbedDose;
  Reverse(): void;
  Reversed(): gp_Parab2d;
  IsDirect(): Standard_Boolean;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Parab2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Parab2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Parab2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Parab2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Parab2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Parab2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Parab2d;
  delete(): void;
}

  export declare class gp_Parab2d_1 extends gp_Parab2d {
    constructor();
  }

  export declare class gp_Parab2d_2 extends gp_Parab2d {
    constructor(theMirrorAxis: gp_Ax2d, theFocalLength: Quantity_AbsorbedDose, theSense: Standard_Boolean);
  }

  export declare class gp_Parab2d_3 extends gp_Parab2d {
    constructor(theAxes: gp_Ax22d, theFocalLength: Quantity_AbsorbedDose);
  }

  export declare class gp_Parab2d_4 extends gp_Parab2d {
    constructor(theDirectrix: gp_Ax2d, theFocus: gp_Pnt2d, theSense: Standard_Boolean);
  }

export declare class gp_GTrsf {
  SetAffinity_1(A1: gp_Ax1, Ratio: Quantity_AbsorbedDose): void;
  SetAffinity_2(A2: gp_Ax2, Ratio: Quantity_AbsorbedDose): void;
  SetValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  SetVectorialPart(Matrix: gp_Mat): void;
  SetTranslationPart(Coord: gp_XYZ): void;
  SetTrsf(T: gp_Trsf): void;
  IsNegative(): Standard_Boolean;
  IsSingular(): Standard_Boolean;
  Form(): gp_TrsfForm;
  SetForm(): void;
  TranslationPart(): gp_XYZ;
  VectorialPart(): gp_Mat;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Invert(): void;
  Inverted(): gp_GTrsf;
  Multiplied(T: gp_GTrsf): gp_GTrsf;
  Multiply(T: gp_GTrsf): void;
  PreMultiply(T: gp_GTrsf): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): gp_GTrsf;
  Transforms_1(Coord: gp_XYZ): void;
  Transforms_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Trsf(): gp_Trsf;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_GTrsf_1 extends gp_GTrsf {
    constructor();
  }

  export declare class gp_GTrsf_2 extends gp_GTrsf {
    constructor(T: gp_Trsf);
  }

  export declare class gp_GTrsf_3 extends gp_GTrsf {
    constructor(M: gp_Mat, V: gp_XYZ);
  }

export declare class gp_Circ2d {
  SetLocation(P: gp_Pnt2d): void;
  SetXAxis(A: gp_Ax2d): void;
  SetAxis(A: gp_Ax22d): void;
  SetYAxis(A: gp_Ax2d): void;
  SetRadius(Radius: Quantity_AbsorbedDose): void;
  Area(): Quantity_AbsorbedDose;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): void;
  Contains(P: gp_Pnt2d, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Distance(P: gp_Pnt2d): Quantity_AbsorbedDose;
  SquareDistance(P: gp_Pnt2d): Quantity_AbsorbedDose;
  Length(): Quantity_AbsorbedDose;
  Location(): gp_Pnt2d;
  Radius(): Quantity_AbsorbedDose;
  Axis(): gp_Ax22d;
  Position(): gp_Ax22d;
  XAxis(): gp_Ax2d;
  YAxis(): gp_Ax2d;
  Reverse(): void;
  Reversed(): gp_Circ2d;
  IsDirect(): Standard_Boolean;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Circ2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Circ2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Circ2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Circ2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Circ2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Circ2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Circ2d;
  delete(): void;
}

  export declare class gp_Circ2d_1 extends gp_Circ2d {
    constructor();
  }

  export declare class gp_Circ2d_2 extends gp_Circ2d {
    constructor(XAxis: gp_Ax2d, Radius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gp_Circ2d_3 extends gp_Circ2d {
    constructor(Axis: gp_Ax22d, Radius: Quantity_AbsorbedDose);
  }

export declare class gp_Ax22d {
  SetAxis(A1: gp_Ax22d): void;
  SetXAxis(A1: gp_Ax2d): void;
  SetYAxis(A1: gp_Ax2d): void;
  SetLocation(P: gp_Pnt2d): void;
  SetXDirection(Vx: gp_Dir2d): void;
  SetYDirection(Vy: gp_Dir2d): void;
  XAxis(): gp_Ax2d;
  YAxis(): gp_Ax2d;
  Location(): gp_Pnt2d;
  XDirection(): gp_Dir2d;
  YDirection(): gp_Dir2d;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Ax22d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Ax22d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Ax22d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Ax22d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Ax22d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Ax22d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Ax22d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Ax22d_1 extends gp_Ax22d {
    constructor();
  }

  export declare class gp_Ax22d_2 extends gp_Ax22d {
    constructor(P: gp_Pnt2d, Vx: gp_Dir2d, Vy: gp_Dir2d);
  }

  export declare class gp_Ax22d_3 extends gp_Ax22d {
    constructor(P: gp_Pnt2d, V: gp_Dir2d, Sense: Standard_Boolean);
  }

  export declare class gp_Ax22d_4 extends gp_Ax22d {
    constructor(A: gp_Ax2d, Sense: Standard_Boolean);
  }

export declare class gp_Ax2d {
  SetLocation(Locat: gp_Pnt2d): void;
  SetDirection(V: gp_Dir2d): void;
  Location(): gp_Pnt2d;
  Direction(): gp_Dir2d;
  IsCoaxial(Other: gp_Ax2d, AngularTolerance: Quantity_AbsorbedDose, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsNormal(Other: gp_Ax2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsOpposite(Other: gp_Ax2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsParallel(Other: gp_Ax2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Angle(Other: gp_Ax2d): Quantity_AbsorbedDose;
  Reverse(): void;
  Reversed(): gp_Ax2d;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Ax2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Ax2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Ax2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Ax2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Ax2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Ax2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Ax2d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Ax2d_1 extends gp_Ax2d {
    constructor();
  }

  export declare class gp_Ax2d_2 extends gp_Ax2d {
    constructor(P: gp_Pnt2d, V: gp_Dir2d);
  }

export declare class gp_Elips2d {
  SetLocation(P: gp_Pnt2d): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  SetAxis(A: gp_Ax22d): void;
  SetXAxis(A: gp_Ax2d): void;
  SetYAxis(A: gp_Ax2d): void;
  Area(): Quantity_AbsorbedDose;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): void;
  Directrix1(): gp_Ax2d;
  Directrix2(): gp_Ax2d;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt2d;
  Focus2(): gp_Pnt2d;
  Location(): gp_Pnt2d;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  Axis(): gp_Ax22d;
  XAxis(): gp_Ax2d;
  YAxis(): gp_Ax2d;
  Reverse(): void;
  Reversed(): gp_Elips2d;
  IsDirect(): Standard_Boolean;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Elips2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Elips2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Elips2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Elips2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Elips2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Elips2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Elips2d;
  delete(): void;
}

  export declare class gp_Elips2d_1 extends gp_Elips2d {
    constructor();
  }

  export declare class gp_Elips2d_2 extends gp_Elips2d {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gp_Elips2d_3 extends gp_Elips2d {
    constructor(A: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class gp_Pnt2d {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(Xp: Quantity_AbsorbedDose, Yp: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetXY(Coord: gp_XY): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(Xp: Quantity_AbsorbedDose, Yp: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  XY(): gp_XY;
  Coord_3(): gp_XY;
  ChangeCoord(): gp_XY;
  IsEqual(Other: gp_Pnt2d, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Distance(Other: gp_Pnt2d): Quantity_AbsorbedDose;
  SquareDistance(Other: gp_Pnt2d): Quantity_AbsorbedDose;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Pnt2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Pnt2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Pnt2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Pnt2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Pnt2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Pnt2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Pnt2d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Pnt2d_1 extends gp_Pnt2d {
    constructor();
  }

  export declare class gp_Pnt2d_2 extends gp_Pnt2d {
    constructor(Coord: gp_XY);
  }

  export declare class gp_Pnt2d_3 extends gp_Pnt2d {
    constructor(Xp: Quantity_AbsorbedDose, Yp: Quantity_AbsorbedDose);
  }

export declare class gp_Vec {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  SetXYZ(Coord: gp_XYZ): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  XYZ(): gp_XYZ;
  IsEqual(Other: gp_Vec, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsNormal(Other: gp_Vec, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsOpposite(Other: gp_Vec, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsParallel(Other: gp_Vec, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Angle(Other: gp_Vec): Quantity_AbsorbedDose;
  AngleWithRef(Other: gp_Vec, VRef: gp_Vec): Quantity_AbsorbedDose;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  Add(Other: gp_Vec): void;
  Added(Other: gp_Vec): gp_Vec;
  Subtract(Right: gp_Vec): void;
  Subtracted(Right: gp_Vec): gp_Vec;
  Multiply(Scalar: Quantity_AbsorbedDose): void;
  Multiplied(Scalar: Quantity_AbsorbedDose): gp_Vec;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): gp_Vec;
  Cross(Right: gp_Vec): void;
  Crossed(Right: gp_Vec): gp_Vec;
  CrossMagnitude(Right: gp_Vec): Quantity_AbsorbedDose;
  CrossSquareMagnitude(Right: gp_Vec): Quantity_AbsorbedDose;
  CrossCross(V1: gp_Vec, V2: gp_Vec): void;
  CrossCrossed(V1: gp_Vec, V2: gp_Vec): gp_Vec;
  Dot(Other: gp_Vec): Quantity_AbsorbedDose;
  DotCross(V1: gp_Vec, V2: gp_Vec): Quantity_AbsorbedDose;
  Normalize(): void;
  Normalized(): gp_Vec;
  Reverse(): void;
  Reversed(): gp_Vec;
  SetLinearForm_1(A1: Quantity_AbsorbedDose, V1: gp_Vec, A2: Quantity_AbsorbedDose, V2: gp_Vec, A3: Quantity_AbsorbedDose, V3: gp_Vec, V4: gp_Vec): void;
  SetLinearForm_2(A1: Quantity_AbsorbedDose, V1: gp_Vec, A2: Quantity_AbsorbedDose, V2: gp_Vec, A3: Quantity_AbsorbedDose, V3: gp_Vec): void;
  SetLinearForm_3(A1: Quantity_AbsorbedDose, V1: gp_Vec, A2: Quantity_AbsorbedDose, V2: gp_Vec, V3: gp_Vec): void;
  SetLinearForm_4(A1: Quantity_AbsorbedDose, V1: gp_Vec, A2: Quantity_AbsorbedDose, V2: gp_Vec): void;
  SetLinearForm_5(A1: Quantity_AbsorbedDose, V1: gp_Vec, V2: gp_Vec): void;
  SetLinearForm_6(V1: gp_Vec, V2: gp_Vec): void;
  Mirror_1(V: gp_Vec): void;
  Mirrored_1(V: gp_Vec): gp_Vec;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Vec;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Vec;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Vec;
  Scale(S: Quantity_AbsorbedDose): void;
  Scaled(S: Quantity_AbsorbedDose): gp_Vec;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Vec;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Vec_1 extends gp_Vec {
    constructor();
  }

  export declare class gp_Vec_2 extends gp_Vec {
    constructor(V: gp_Dir);
  }

  export declare class gp_Vec_3 extends gp_Vec {
    constructor(Coord: gp_XYZ);
  }

  export declare class gp_Vec_4 extends gp_Vec {
    constructor(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose);
  }

  export declare class gp_Vec_5 extends gp_Vec {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

export declare type gp_TrsfForm = {
  gp_Identity: {};
  gp_Rotation: {};
  gp_Translation: {};
  gp_PntMirror: {};
  gp_Ax1Mirror: {};
  gp_Ax2Mirror: {};
  gp_Scale: {};
  gp_CompoundTrsf: {};
  gp_Other: {};
}

export declare class gp_Hypr2d {
  SetLocation(P: gp_Pnt2d): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  SetAxis(A: gp_Ax22d): void;
  SetXAxis(A: gp_Ax2d): void;
  SetYAxis(A: gp_Ax2d): void;
  Asymptote1(): gp_Ax2d;
  Asymptote2(): gp_Ax2d;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): void;
  ConjugateBranch1(): gp_Hypr2d;
  ConjugateBranch2(): gp_Hypr2d;
  Directrix1(): gp_Ax2d;
  Directrix2(): gp_Ax2d;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt2d;
  Focus2(): gp_Pnt2d;
  Location(): gp_Pnt2d;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  OtherBranch(): gp_Hypr2d;
  Parameter(): Quantity_AbsorbedDose;
  Axis(): gp_Ax22d;
  XAxis(): gp_Ax2d;
  YAxis(): gp_Ax2d;
  Reverse(): void;
  Reversed(): gp_Hypr2d;
  IsDirect(): Standard_Boolean;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Hypr2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Hypr2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Hypr2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Hypr2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Hypr2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Hypr2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Hypr2d;
  delete(): void;
}

  export declare class gp_Hypr2d_1 extends gp_Hypr2d {
    constructor();
  }

  export declare class gp_Hypr2d_2 extends gp_Hypr2d {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gp_Hypr2d_3 extends gp_Hypr2d {
    constructor(A: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class gp_Ax1 {
  SetDirection(V: gp_Dir): void;
  SetLocation(P: gp_Pnt): void;
  Direction(): gp_Dir;
  Location(): gp_Pnt;
  IsCoaxial(Other: gp_Ax1, AngularTolerance: Quantity_AbsorbedDose, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsNormal(Other: gp_Ax1, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsOpposite(Other: gp_Ax1, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsParallel(Other: gp_Ax1, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Angle(Other: gp_Ax1): Quantity_AbsorbedDose;
  Reverse(): void;
  Reversed(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Ax1;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Ax1;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Ax1;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Ax1;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Ax1;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Ax1;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Ax1;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Ax1;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_Ax1_1 extends gp_Ax1 {
    constructor();
  }

  export declare class gp_Ax1_2 extends gp_Ax1 {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

export declare class gp_XYZ {
  SetCoord_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetCoord_2(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeCoord(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  GetData(): Quantity_AbsorbedDose;
  ChangeData(): Quantity_AbsorbedDose;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  Modulus(): Quantity_AbsorbedDose;
  SquareModulus(): Quantity_AbsorbedDose;
  IsEqual(Other: gp_XYZ, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Add(Other: gp_XYZ): void;
  Added(Other: gp_XYZ): gp_XYZ;
  Cross(Right: gp_XYZ): void;
  Crossed(Right: gp_XYZ): gp_XYZ;
  CrossMagnitude(Right: gp_XYZ): Quantity_AbsorbedDose;
  CrossSquareMagnitude(Right: gp_XYZ): Quantity_AbsorbedDose;
  CrossCross(Coord1: gp_XYZ, Coord2: gp_XYZ): void;
  CrossCrossed(Coord1: gp_XYZ, Coord2: gp_XYZ): gp_XYZ;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): gp_XYZ;
  Dot(Other: gp_XYZ): Quantity_AbsorbedDose;
  DotCross(Coord1: gp_XYZ, Coord2: gp_XYZ): Quantity_AbsorbedDose;
  Multiply_1(Scalar: Quantity_AbsorbedDose): void;
  Multiply_2(Other: gp_XYZ): void;
  Multiply_3(Matrix: gp_Mat): void;
  Multiplied_1(Scalar: Quantity_AbsorbedDose): gp_XYZ;
  Multiplied_2(Other: gp_XYZ): gp_XYZ;
  Multiplied_3(Matrix: gp_Mat): gp_XYZ;
  Normalize(): void;
  Normalized(): gp_XYZ;
  Reverse(): void;
  Reversed(): gp_XYZ;
  Subtract(Right: gp_XYZ): void;
  Subtracted(Right: gp_XYZ): gp_XYZ;
  SetLinearForm_1(A1: Quantity_AbsorbedDose, XYZ1: gp_XYZ, A2: Quantity_AbsorbedDose, XYZ2: gp_XYZ, A3: Quantity_AbsorbedDose, XYZ3: gp_XYZ, XYZ4: gp_XYZ): void;
  SetLinearForm_2(A1: Quantity_AbsorbedDose, XYZ1: gp_XYZ, A2: Quantity_AbsorbedDose, XYZ2: gp_XYZ, A3: Quantity_AbsorbedDose, XYZ3: gp_XYZ): void;
  SetLinearForm_3(A1: Quantity_AbsorbedDose, XYZ1: gp_XYZ, A2: Quantity_AbsorbedDose, XYZ2: gp_XYZ, XYZ3: gp_XYZ): void;
  SetLinearForm_4(A1: Quantity_AbsorbedDose, XYZ1: gp_XYZ, A2: Quantity_AbsorbedDose, XYZ2: gp_XYZ): void;
  SetLinearForm_5(A1: Quantity_AbsorbedDose, XYZ1: gp_XYZ, XYZ2: gp_XYZ): void;
  SetLinearForm_6(XYZ1: gp_XYZ, XYZ2: gp_XYZ): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_XYZ_1 extends gp_XYZ {
    constructor();
  }

  export declare class gp_XYZ_2 extends gp_XYZ {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose);
  }

export declare class gp_Torus {
  SetAxis(A1: gp_Ax1): void;
  SetLocation(Loc: gp_Pnt): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  SetPosition(A3: gp_Ax3): void;
  Area(): Quantity_AbsorbedDose;
  UReverse(): void;
  VReverse(): void;
  Direct(): Standard_Boolean;
  Axis(): gp_Ax1;
  Coefficients(Coef: TColStd_Array1OfReal): void;
  Location(): gp_Pnt;
  Position(): gp_Ax3;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  Volume(): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Torus;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Torus;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Torus;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Torus;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Torus;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Torus;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Torus;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Torus;
  delete(): void;
}

  export declare class gp_Torus_1 extends gp_Torus {
    constructor();
  }

  export declare class gp_Torus_2 extends gp_Torus {
    constructor(A3: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class gp_Cylinder {
  SetAxis(A1: gp_Ax1): void;
  SetLocation(Loc: gp_Pnt): void;
  SetPosition(A3: gp_Ax3): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  UReverse(): void;
  VReverse(): void;
  Direct(): Standard_Boolean;
  Axis(): gp_Ax1;
  Coefficients(A1: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, B1: Quantity_AbsorbedDose, B2: Quantity_AbsorbedDose, B3: Quantity_AbsorbedDose, C1: Quantity_AbsorbedDose, C2: Quantity_AbsorbedDose, C3: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  Location(): gp_Pnt;
  Position(): gp_Ax3;
  Radius(): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Cylinder;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Cylinder;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Cylinder;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Cylinder;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Cylinder;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Cylinder;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Cylinder;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Cylinder;
  delete(): void;
}

  export declare class gp_Cylinder_1 extends gp_Cylinder {
    constructor();
  }

  export declare class gp_Cylinder_2 extends gp_Cylinder {
    constructor(A3: gp_Ax3, Radius: Quantity_AbsorbedDose);
  }

export declare class gp_GTrsf2d {
  SetAffinity(A: gp_Ax2d, Ratio: Quantity_AbsorbedDose): void;
  SetValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  SetTranslationPart(Coord: gp_XY): void;
  SetTrsf2d(T: gp_Trsf2d): void;
  SetVectorialPart(Matrix: gp_Mat2d): void;
  IsNegative(): Standard_Boolean;
  IsSingular(): Standard_Boolean;
  Form(): gp_TrsfForm;
  TranslationPart(): gp_XY;
  VectorialPart(): gp_Mat2d;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Invert(): void;
  Inverted(): gp_GTrsf2d;
  Multiplied(T: gp_GTrsf2d): gp_GTrsf2d;
  Multiply(T: gp_GTrsf2d): void;
  PreMultiply(T: gp_GTrsf2d): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): gp_GTrsf2d;
  Transforms_1(Coord: gp_XY): void;
  Transformed(Coord: gp_XY): gp_XY;
  Transforms_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Trsf2d(): gp_Trsf2d;
  delete(): void;
}

  export declare class gp_GTrsf2d_1 extends gp_GTrsf2d {
    constructor();
  }

  export declare class gp_GTrsf2d_2 extends gp_GTrsf2d {
    constructor(T: gp_Trsf2d);
  }

  export declare class gp_GTrsf2d_3 extends gp_GTrsf2d {
    constructor(M: gp_Mat2d, V: gp_XY);
  }

export declare class gp_Trsf {
  SetMirror_1(P: gp_Pnt): void;
  SetMirror_2(A1: gp_Ax1): void;
  SetMirror_3(A2: gp_Ax2): void;
  SetRotation_1(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  SetRotation_2(R: gp_Quaternion): void;
  SetRotationPart(R: gp_Quaternion): void;
  SetScale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  SetDisplacement(FromSystem1: gp_Ax3, ToSystem2: gp_Ax3): void;
  SetTransformation_1(FromSystem1: gp_Ax3, ToSystem2: gp_Ax3): void;
  SetTransformation_2(ToSystem: gp_Ax3): void;
  SetTransformation_3(R: gp_Quaternion, T: gp_Vec): void;
  SetTranslation_1(V: gp_Vec): void;
  SetTranslation_2(P1: gp_Pnt, P2: gp_Pnt): void;
  SetTranslationPart(V: gp_Vec): void;
  SetScaleFactor(S: Quantity_AbsorbedDose): void;
  SetForm(P: gp_TrsfForm): void;
  SetValues(a11: Quantity_AbsorbedDose, a12: Quantity_AbsorbedDose, a13: Quantity_AbsorbedDose, a14: Quantity_AbsorbedDose, a21: Quantity_AbsorbedDose, a22: Quantity_AbsorbedDose, a23: Quantity_AbsorbedDose, a24: Quantity_AbsorbedDose, a31: Quantity_AbsorbedDose, a32: Quantity_AbsorbedDose, a33: Quantity_AbsorbedDose, a34: Quantity_AbsorbedDose): void;
  IsNegative(): Standard_Boolean;
  Form(): gp_TrsfForm;
  ScaleFactor(): Quantity_AbsorbedDose;
  TranslationPart(): gp_XYZ;
  GetRotation_1(theAxis: gp_XYZ, theAngle: Quantity_AbsorbedDose): Standard_Boolean;
  GetRotation_2(): gp_Quaternion;
  VectorialPart(): gp_Mat;
  HVectorialPart(): gp_Mat;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Invert(): void;
  Inverted(): gp_Trsf;
  Multiplied(T: gp_Trsf): gp_Trsf;
  Multiply(T: gp_Trsf): void;
  PreMultiply(T: gp_Trsf): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): gp_Trsf;
  Transforms_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Transforms_2(Coord: gp_XYZ): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_Trsf_1 extends gp_Trsf {
    constructor();
  }

  export declare class gp_Trsf_2 extends gp_Trsf {
    constructor(T: gp_Trsf2d);
  }

export declare class gp_Pnt {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(Xp: Quantity_AbsorbedDose, Yp: Quantity_AbsorbedDose, Zp: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  SetXYZ(Coord: gp_XYZ): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(Xp: Quantity_AbsorbedDose, Yp: Quantity_AbsorbedDose, Zp: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  XYZ(): gp_XYZ;
  Coord_3(): gp_XYZ;
  ChangeCoord(): gp_XYZ;
  BaryCenter(Alpha: Quantity_AbsorbedDose, P: gp_Pnt, Beta: Quantity_AbsorbedDose): void;
  IsEqual(Other: gp_Pnt, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Distance(Other: gp_Pnt): Quantity_AbsorbedDose;
  SquareDistance(Other: gp_Pnt): Quantity_AbsorbedDose;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Pnt;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Pnt;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Pnt;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Pnt;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Pnt;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Pnt;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Pnt;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Pnt;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_Pnt_1 extends gp_Pnt {
    constructor();
  }

  export declare class gp_Pnt_2 extends gp_Pnt {
    constructor(Coord: gp_XYZ);
  }

  export declare class gp_Pnt_3 extends gp_Pnt {
    constructor(Xp: Quantity_AbsorbedDose, Yp: Quantity_AbsorbedDose, Zp: Quantity_AbsorbedDose);
  }

export declare class gp_Trsf2d {
  SetMirror_1(P: gp_Pnt2d): void;
  SetMirror_2(A: gp_Ax2d): void;
  SetRotation(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  SetScale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  SetTransformation_1(FromSystem1: gp_Ax2d, ToSystem2: gp_Ax2d): void;
  SetTransformation_2(ToSystem: gp_Ax2d): void;
  SetTranslation_1(V: gp_Vec2d): void;
  SetTranslation_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  SetTranslationPart(V: gp_Vec2d): void;
  SetScaleFactor(S: Quantity_AbsorbedDose): void;
  IsNegative(): Standard_Boolean;
  Form(): gp_TrsfForm;
  ScaleFactor(): Quantity_AbsorbedDose;
  TranslationPart(): gp_XY;
  VectorialPart(): gp_Mat2d;
  HVectorialPart(): gp_Mat2d;
  RotationPart(): Quantity_AbsorbedDose;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Invert(): void;
  Inverted(): gp_Trsf2d;
  Multiplied(T: gp_Trsf2d): gp_Trsf2d;
  Multiply(T: gp_Trsf2d): void;
  PreMultiply(T: gp_Trsf2d): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): gp_Trsf2d;
  Transforms_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Transforms_2(Coord: gp_XY): void;
  SetValues(a11: Quantity_AbsorbedDose, a12: Quantity_AbsorbedDose, a13: Quantity_AbsorbedDose, a21: Quantity_AbsorbedDose, a22: Quantity_AbsorbedDose, a23: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class gp_Trsf2d_1 extends gp_Trsf2d {
    constructor();
  }

  export declare class gp_Trsf2d_2 extends gp_Trsf2d {
    constructor(T: gp_Trsf);
  }

export declare class Handle_gp_VectorWithNullMagnitude {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: gp_VectorWithNullMagnitude): void;
  get(): gp_VectorWithNullMagnitude;
  delete(): void;
}

  export declare class Handle_gp_VectorWithNullMagnitude_1 extends Handle_gp_VectorWithNullMagnitude {
    constructor();
  }

  export declare class Handle_gp_VectorWithNullMagnitude_2 extends Handle_gp_VectorWithNullMagnitude {
    constructor(thePtr: gp_VectorWithNullMagnitude);
  }

  export declare class Handle_gp_VectorWithNullMagnitude_3 extends Handle_gp_VectorWithNullMagnitude {
    constructor(theHandle: Handle_gp_VectorWithNullMagnitude);
  }

  export declare class Handle_gp_VectorWithNullMagnitude_4 extends Handle_gp_VectorWithNullMagnitude {
    constructor(theHandle: Handle_gp_VectorWithNullMagnitude);
  }

export declare class gp_QuaternionSLerp {
  static Interpolate_1(theQStart: gp_Quaternion, theQEnd: gp_Quaternion, theT: Quantity_AbsorbedDose): gp_Quaternion;
  Init(theQStart: gp_Quaternion, theQEnd: gp_Quaternion): void;
  InitFromUnit(theQStart: gp_Quaternion, theQEnd: gp_Quaternion): void;
  Interpolate_2(theT: Quantity_AbsorbedDose, theResultQ: gp_Quaternion): void;
  delete(): void;
}

  export declare class gp_QuaternionSLerp_1 extends gp_QuaternionSLerp {
    constructor();
  }

  export declare class gp_QuaternionSLerp_2 extends gp_QuaternionSLerp {
    constructor(theQStart: gp_Quaternion, theQEnd: gp_Quaternion);
  }

export declare class gp {
  constructor();
  static Resolution(): Quantity_AbsorbedDose;
  static Origin(): gp_Pnt;
  static DX(): gp_Dir;
  static DY(): gp_Dir;
  static DZ(): gp_Dir;
  static OX(): gp_Ax1;
  static OY(): gp_Ax1;
  static OZ(): gp_Ax1;
  static XOY(): gp_Ax2;
  static ZOX(): gp_Ax2;
  static YOZ(): gp_Ax2;
  static Origin2d(): gp_Pnt2d;
  static DX2d(): gp_Dir2d;
  static DY2d(): gp_Dir2d;
  static OX2d(): gp_Ax2d;
  static OY2d(): gp_Ax2d;
  delete(): void;
}

export declare class gp_Lin {
  Reverse(): void;
  Reversed(): gp_Lin;
  SetDirection(V: gp_Dir): void;
  SetLocation(P: gp_Pnt): void;
  SetPosition(A1: gp_Ax1): void;
  Direction(): gp_Dir;
  Location(): gp_Pnt;
  Position(): gp_Ax1;
  Angle(Other: gp_Lin): Quantity_AbsorbedDose;
  Contains(P: gp_Pnt, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Distance_1(P: gp_Pnt): Quantity_AbsorbedDose;
  Distance_2(Other: gp_Lin): Quantity_AbsorbedDose;
  SquareDistance_1(P: gp_Pnt): Quantity_AbsorbedDose;
  SquareDistance_2(Other: gp_Lin): Quantity_AbsorbedDose;
  Normal(P: gp_Pnt): gp_Lin;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Lin;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Lin;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Lin;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Lin;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Lin;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Lin;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Lin;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Lin;
  delete(): void;
}

  export declare class gp_Lin_1 extends gp_Lin {
    constructor();
  }

  export declare class gp_Lin_2 extends gp_Lin {
    constructor(A1: gp_Ax1);
  }

  export declare class gp_Lin_3 extends gp_Lin {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

export declare class gp_Vec2d {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetXY(Coord: gp_XY): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  XY(): gp_XY;
  IsEqual(Other: gp_Vec2d, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsNormal(Other: gp_Vec2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsOpposite(Other: gp_Vec2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsParallel(Other: gp_Vec2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Angle(Other: gp_Vec2d): Quantity_AbsorbedDose;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  Add(Other: gp_Vec2d): void;
  Added(Other: gp_Vec2d): gp_Vec2d;
  Crossed(Right: gp_Vec2d): Quantity_AbsorbedDose;
  CrossMagnitude(Right: gp_Vec2d): Quantity_AbsorbedDose;
  CrossSquareMagnitude(Right: gp_Vec2d): Quantity_AbsorbedDose;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): gp_Vec2d;
  Dot(Other: gp_Vec2d): Quantity_AbsorbedDose;
  GetNormal(): gp_Vec2d;
  Multiply(Scalar: Quantity_AbsorbedDose): void;
  Multiplied(Scalar: Quantity_AbsorbedDose): gp_Vec2d;
  Normalize(): void;
  Normalized(): gp_Vec2d;
  Reverse(): void;
  Reversed(): gp_Vec2d;
  Subtract(Right: gp_Vec2d): void;
  Subtracted(Right: gp_Vec2d): gp_Vec2d;
  SetLinearForm_1(A1: Quantity_AbsorbedDose, V1: gp_Vec2d, A2: Quantity_AbsorbedDose, V2: gp_Vec2d, V3: gp_Vec2d): void;
  SetLinearForm_2(A1: Quantity_AbsorbedDose, V1: gp_Vec2d, A2: Quantity_AbsorbedDose, V2: gp_Vec2d): void;
  SetLinearForm_3(A1: Quantity_AbsorbedDose, V1: gp_Vec2d, V2: gp_Vec2d): void;
  SetLinearForm_4(Left: gp_Vec2d, Right: gp_Vec2d): void;
  Mirror_1(V: gp_Vec2d): void;
  Mirrored_1(V: gp_Vec2d): gp_Vec2d;
  Mirror_2(A1: gp_Ax2d): void;
  Mirrored_2(A1: gp_Ax2d): gp_Vec2d;
  Rotate(Ang: Quantity_AbsorbedDose): void;
  Rotated(Ang: Quantity_AbsorbedDose): gp_Vec2d;
  Scale(S: Quantity_AbsorbedDose): void;
  Scaled(S: Quantity_AbsorbedDose): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Vec2d;
  delete(): void;
}

  export declare class gp_Vec2d_1 extends gp_Vec2d {
    constructor();
  }

  export declare class gp_Vec2d_2 extends gp_Vec2d {
    constructor(V: gp_Dir2d);
  }

  export declare class gp_Vec2d_3 extends gp_Vec2d {
    constructor(Coord: gp_XY);
  }

  export declare class gp_Vec2d_4 extends gp_Vec2d {
    constructor(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose);
  }

  export declare class gp_Vec2d_5 extends gp_Vec2d {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

export declare class gp_TrsfNLerp {
  Init(theStart: gp_Trsf, theEnd: gp_Trsf): void;
  Interpolate_2(theT: number, theResult: gp_Trsf): void;
  delete(): void;
}

  export declare class gp_TrsfNLerp_1 extends gp_TrsfNLerp {
    constructor();
  }

  export declare class gp_TrsfNLerp_2 extends gp_TrsfNLerp {
    constructor(theStart: gp_Trsf, theEnd: gp_Trsf);
  }

export declare class gp_Pln {
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  SetAxis(A1: gp_Ax1): void;
  SetLocation(Loc: gp_Pnt): void;
  SetPosition(A3: gp_Ax3): void;
  UReverse(): void;
  VReverse(): void;
  Direct(): Standard_Boolean;
  Axis(): gp_Ax1;
  Location(): gp_Pnt;
  Position(): gp_Ax3;
  Distance_1(P: gp_Pnt): Quantity_AbsorbedDose;
  Distance_2(L: gp_Lin): Quantity_AbsorbedDose;
  Distance_3(Other: gp_Pln): Quantity_AbsorbedDose;
  SquareDistance_1(P: gp_Pnt): Quantity_AbsorbedDose;
  SquareDistance_2(L: gp_Lin): Quantity_AbsorbedDose;
  SquareDistance_3(Other: gp_Pln): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Contains_1(P: gp_Pnt, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Contains_2(L: gp_Lin, LinearTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Pln;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Pln;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Pln;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Pln;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Pln;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Pln;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Pln;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Pln;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Pln_1 extends gp_Pln {
    constructor();
  }

  export declare class gp_Pln_2 extends gp_Pln {
    constructor(A3: gp_Ax3);
  }

  export declare class gp_Pln_3 extends gp_Pln {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

  export declare class gp_Pln_4 extends gp_Pln {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose);
  }

export declare type gp_EulerSequence = {
  gp_EulerAngles: {};
  gp_YawPitchRoll: {};
  gp_Extrinsic_XYZ: {};
  gp_Extrinsic_XZY: {};
  gp_Extrinsic_YZX: {};
  gp_Extrinsic_YXZ: {};
  gp_Extrinsic_ZXY: {};
  gp_Extrinsic_ZYX: {};
  gp_Intrinsic_XYZ: {};
  gp_Intrinsic_XZY: {};
  gp_Intrinsic_YZX: {};
  gp_Intrinsic_YXZ: {};
  gp_Intrinsic_ZXY: {};
  gp_Intrinsic_ZYX: {};
  gp_Extrinsic_XYX: {};
  gp_Extrinsic_XZX: {};
  gp_Extrinsic_YZY: {};
  gp_Extrinsic_YXY: {};
  gp_Extrinsic_ZYZ: {};
  gp_Extrinsic_ZXZ: {};
  gp_Intrinsic_XYX: {};
  gp_Intrinsic_XZX: {};
  gp_Intrinsic_YZY: {};
  gp_Intrinsic_YXY: {};
  gp_Intrinsic_ZXZ: {};
  gp_Intrinsic_ZYZ: {};
}

export declare class gp_Mat {
  SetCol(Col: Graphic3d_ZLayerId, Value: gp_XYZ): void;
  SetCols(Col1: gp_XYZ, Col2: gp_XYZ, Col3: gp_XYZ): void;
  SetCross(Ref: gp_XYZ): void;
  SetDiagonal(X1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, X3: Quantity_AbsorbedDose): void;
  SetDot(Ref: gp_XYZ): void;
  SetIdentity(): void;
  SetRotation(Axis: gp_XYZ, Ang: Quantity_AbsorbedDose): void;
  SetRow(Row: Graphic3d_ZLayerId, Value: gp_XYZ): void;
  SetRows(Row1: gp_XYZ, Row2: gp_XYZ, Row3: gp_XYZ): void;
  SetScale(S: Quantity_AbsorbedDose): void;
  SetValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  Column(Col: Graphic3d_ZLayerId): gp_XYZ;
  Determinant(): Quantity_AbsorbedDose;
  Diagonal(): gp_XYZ;
  Row(Row: Graphic3d_ZLayerId): gp_XYZ;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsSingular(): Standard_Boolean;
  Add(Other: gp_Mat): void;
  Added(Other: gp_Mat): gp_Mat;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): gp_Mat;
  Invert(): void;
  Inverted(): gp_Mat;
  Multiplied_1(Other: gp_Mat): gp_Mat;
  Multiply_1(Other: gp_Mat): void;
  PreMultiply(Other: gp_Mat): void;
  Multiplied_2(Scalar: Quantity_AbsorbedDose): gp_Mat;
  Multiply_2(Scalar: Quantity_AbsorbedDose): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): gp_Mat;
  Subtract(Other: gp_Mat): void;
  Subtracted(Other: gp_Mat): gp_Mat;
  Transpose(): void;
  Transposed(): gp_Mat;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Mat_1 extends gp_Mat {
    constructor();
  }

  export declare class gp_Mat_2 extends gp_Mat {
    constructor(a11: Quantity_AbsorbedDose, a12: Quantity_AbsorbedDose, a13: Quantity_AbsorbedDose, a21: Quantity_AbsorbedDose, a22: Quantity_AbsorbedDose, a23: Quantity_AbsorbedDose, a31: Quantity_AbsorbedDose, a32: Quantity_AbsorbedDose, a33: Quantity_AbsorbedDose);
  }

  export declare class gp_Mat_3 extends gp_Mat {
    constructor(Col1: gp_XYZ, Col2: gp_XYZ, Col3: gp_XYZ);
  }

export declare class gp_Cone {
  SetAxis(A1: gp_Ax1): void;
  SetLocation(Loc: gp_Pnt): void;
  SetPosition(A3: gp_Ax3): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  SetSemiAngle(Ang: Quantity_AbsorbedDose): void;
  Apex(): gp_Pnt;
  UReverse(): void;
  VReverse(): void;
  Direct(): Standard_Boolean;
  Axis(): gp_Ax1;
  Coefficients(A1: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, B1: Quantity_AbsorbedDose, B2: Quantity_AbsorbedDose, B3: Quantity_AbsorbedDose, C1: Quantity_AbsorbedDose, C2: Quantity_AbsorbedDose, C3: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  Location(): gp_Pnt;
  Position(): gp_Ax3;
  RefRadius(): Quantity_AbsorbedDose;
  SemiAngle(): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Cone;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Cone;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Cone;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Cone;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Cone;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Cone;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Cone;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Cone;
  delete(): void;
}

  export declare class gp_Cone_1 extends gp_Cone {
    constructor();
  }

  export declare class gp_Cone_2 extends gp_Cone {
    constructor(A3: gp_Ax3, Ang: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose);
  }

export declare class gp_Dir {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  SetXYZ(Coord: gp_XYZ): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  XYZ(): gp_XYZ;
  IsEqual(Other: gp_Dir, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsNormal(Other: gp_Dir, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsOpposite(Other: gp_Dir, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsParallel(Other: gp_Dir, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Angle(Other: gp_Dir): Quantity_AbsorbedDose;
  AngleWithRef(Other: gp_Dir, VRef: gp_Dir): Quantity_AbsorbedDose;
  Cross(Right: gp_Dir): void;
  Crossed(Right: gp_Dir): gp_Dir;
  CrossCross(V1: gp_Dir, V2: gp_Dir): void;
  CrossCrossed(V1: gp_Dir, V2: gp_Dir): gp_Dir;
  Dot(Other: gp_Dir): Quantity_AbsorbedDose;
  DotCross(V1: gp_Dir, V2: gp_Dir): Quantity_AbsorbedDose;
  Reverse(): void;
  Reversed(): gp_Dir;
  Mirror_1(V: gp_Dir): void;
  Mirrored_1(V: gp_Dir): gp_Dir;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Dir;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Dir;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Dir;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Dir;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class gp_Dir_1 extends gp_Dir {
    constructor();
  }

  export declare class gp_Dir_2 extends gp_Dir {
    constructor(V: gp_Vec);
  }

  export declare class gp_Dir_3 extends gp_Dir {
    constructor(Coord: gp_XYZ);
  }

  export declare class gp_Dir_4 extends gp_Dir {
    constructor(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose);
  }

export declare class gp_Lin2d {
  Reverse(): void;
  Reversed(): gp_Lin2d;
  SetDirection(V: gp_Dir2d): void;
  SetLocation(P: gp_Pnt2d): void;
  SetPosition(A: gp_Ax2d): void;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose): void;
  Direction(): gp_Dir2d;
  Location(): gp_Pnt2d;
  Position(): gp_Ax2d;
  Angle(Other: gp_Lin2d): Quantity_AbsorbedDose;
  Contains(P: gp_Pnt2d, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Distance_1(P: gp_Pnt2d): Quantity_AbsorbedDose;
  Distance_2(Other: gp_Lin2d): Quantity_AbsorbedDose;
  SquareDistance_1(P: gp_Pnt2d): Quantity_AbsorbedDose;
  SquareDistance_2(Other: gp_Lin2d): Quantity_AbsorbedDose;
  Normal(P: gp_Pnt2d): gp_Lin2d;
  Mirror_1(P: gp_Pnt2d): void;
  Mirrored_1(P: gp_Pnt2d): gp_Lin2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Lin2d;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): gp_Lin2d;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): gp_Lin2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Lin2d;
  Translate_1(V: gp_Vec2d): void;
  Translated_1(V: gp_Vec2d): gp_Lin2d;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): gp_Lin2d;
  delete(): void;
}

  export declare class gp_Lin2d_1 extends gp_Lin2d {
    constructor();
  }

  export declare class gp_Lin2d_2 extends gp_Lin2d {
    constructor(A: gp_Ax2d);
  }

  export declare class gp_Lin2d_3 extends gp_Lin2d {
    constructor(P: gp_Pnt2d, V: gp_Dir2d);
  }

  export declare class gp_Lin2d_4 extends gp_Lin2d {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose);
  }

export declare class gp_Hypr {
  SetAxis(A1: gp_Ax1): void;
  SetLocation(P: gp_Pnt): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  SetPosition(A2: gp_Ax2): void;
  Asymptote1(): gp_Ax1;
  Asymptote2(): gp_Ax1;
  Axis(): gp_Ax1;
  ConjugateBranch1(): gp_Hypr;
  ConjugateBranch2(): gp_Hypr;
  Directrix1(): gp_Ax1;
  Directrix2(): gp_Ax1;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt;
  Focus2(): gp_Pnt;
  Location(): gp_Pnt;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  OtherBranch(): gp_Hypr;
  Parameter(): Quantity_AbsorbedDose;
  Position(): gp_Ax2;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Hypr;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Hypr;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Hypr;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Hypr;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Hypr;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Hypr;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Hypr;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Hypr;
  delete(): void;
}

  export declare class gp_Hypr_1 extends gp_Hypr {
    constructor();
  }

  export declare class gp_Hypr_2 extends gp_Hypr {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class gp_Circ {
  SetAxis(A1: gp_Ax1): void;
  SetLocation(P: gp_Pnt): void;
  SetPosition(A2: gp_Ax2): void;
  SetRadius(Radius: Quantity_AbsorbedDose): void;
  Area(): Quantity_AbsorbedDose;
  Axis(): gp_Ax1;
  Length(): Quantity_AbsorbedDose;
  Location(): gp_Pnt;
  Position(): gp_Ax2;
  Radius(): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Distance(P: gp_Pnt): Quantity_AbsorbedDose;
  SquareDistance(P: gp_Pnt): Quantity_AbsorbedDose;
  Contains(P: gp_Pnt, LinearTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Circ;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Circ;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Circ;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Circ;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Circ;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Circ;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Circ;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Circ;
  delete(): void;
}

  export declare class gp_Circ_1 extends gp_Circ {
    constructor();
  }

  export declare class gp_Circ_2 extends gp_Circ {
    constructor(A2: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

export declare class gp_Dir2d {
  SetCoord_1(Index: Graphic3d_ZLayerId, Xi: Quantity_AbsorbedDose): void;
  SetCoord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetXY(Coord: gp_XY): void;
  Coord_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Coord_2(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  XY(): gp_XY;
  IsEqual(Other: gp_Dir2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsNormal(Other: gp_Dir2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsOpposite(Other: gp_Dir2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IsParallel(Other: gp_Dir2d, AngularTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Angle(Other: gp_Dir2d): Quantity_AbsorbedDose;
  Crossed(Right: gp_Dir2d): Quantity_AbsorbedDose;
  Dot(Other: gp_Dir2d): Quantity_AbsorbedDose;
  Reverse(): void;
  Reversed(): gp_Dir2d;
  Mirror_1(V: gp_Dir2d): void;
  Mirrored_1(V: gp_Dir2d): gp_Dir2d;
  Mirror_2(A: gp_Ax2d): void;
  Mirrored_2(A: gp_Ax2d): gp_Dir2d;
  Rotate(Ang: Quantity_AbsorbedDose): void;
  Rotated(Ang: Quantity_AbsorbedDose): gp_Dir2d;
  Transform(T: gp_Trsf2d): void;
  Transformed(T: gp_Trsf2d): gp_Dir2d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class gp_Dir2d_1 extends gp_Dir2d {
    constructor();
  }

  export declare class gp_Dir2d_2 extends gp_Dir2d {
    constructor(V: gp_Vec2d);
  }

  export declare class gp_Dir2d_3 extends gp_Dir2d {
    constructor(Coord: gp_XY);
  }

  export declare class gp_Dir2d_4 extends gp_Dir2d {
    constructor(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose);
  }

export declare class gp_Parab {
  SetAxis(A1: gp_Ax1): void;
  SetFocal(Focal: Quantity_AbsorbedDose): void;
  SetLocation(P: gp_Pnt): void;
  SetPosition(A2: gp_Ax2): void;
  Axis(): gp_Ax1;
  Directrix(): gp_Ax1;
  Focal(): Quantity_AbsorbedDose;
  Focus(): gp_Pnt;
  Location(): gp_Pnt;
  Parameter(): Quantity_AbsorbedDose;
  Position(): gp_Ax2;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Mirror_1(P: gp_Pnt): void;
  Mirrored_1(P: gp_Pnt): gp_Parab;
  Mirror_2(A1: gp_Ax1): void;
  Mirrored_2(A1: gp_Ax1): gp_Parab;
  Mirror_3(A2: gp_Ax2): void;
  Mirrored_3(A2: gp_Ax2): gp_Parab;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): gp_Parab;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): gp_Parab;
  Transform(T: gp_Trsf): void;
  Transformed(T: gp_Trsf): gp_Parab;
  Translate_1(V: gp_Vec): void;
  Translated_1(V: gp_Vec): gp_Parab;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): gp_Parab;
  delete(): void;
}

  export declare class gp_Parab_1 extends gp_Parab {
    constructor();
  }

  export declare class gp_Parab_2 extends gp_Parab {
    constructor(A2: gp_Ax2, Focal: Quantity_AbsorbedDose);
  }

  export declare class gp_Parab_3 extends gp_Parab {
    constructor(D: gp_Ax1, F: gp_Pnt);
  }

export declare class gp_Mat2d {
  SetCol(Col: Graphic3d_ZLayerId, Value: gp_XY): void;
  SetCols(Col1: gp_XY, Col2: gp_XY): void;
  SetDiagonal(X1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose): void;
  SetIdentity(): void;
  SetRotation(Ang: Quantity_AbsorbedDose): void;
  SetRow(Row: Graphic3d_ZLayerId, Value: gp_XY): void;
  SetRows(Row1: gp_XY, Row2: gp_XY): void;
  SetScale(S: Quantity_AbsorbedDose): void;
  SetValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  Column(Col: Graphic3d_ZLayerId): gp_XY;
  Determinant(): Quantity_AbsorbedDose;
  Diagonal(): gp_XY;
  Row(Row: Graphic3d_ZLayerId): gp_XY;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsSingular(): Standard_Boolean;
  Add(Other: gp_Mat2d): void;
  Added(Other: gp_Mat2d): gp_Mat2d;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): gp_Mat2d;
  Invert(): void;
  Inverted(): gp_Mat2d;
  Multiplied_1(Other: gp_Mat2d): gp_Mat2d;
  Multiply_1(Other: gp_Mat2d): void;
  PreMultiply(Other: gp_Mat2d): void;
  Multiplied_2(Scalar: Quantity_AbsorbedDose): gp_Mat2d;
  Multiply_2(Scalar: Quantity_AbsorbedDose): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): gp_Mat2d;
  Subtract(Other: gp_Mat2d): void;
  Subtracted(Other: gp_Mat2d): gp_Mat2d;
  Transpose(): void;
  Transposed(): gp_Mat2d;
  delete(): void;
}

  export declare class gp_Mat2d_1 extends gp_Mat2d {
    constructor();
  }

  export declare class gp_Mat2d_2 extends gp_Mat2d {
    constructor(Col1: gp_XY, Col2: gp_XY);
  }

export declare class AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_1 extends AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_2 extends AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_3 extends AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_4 extends AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class AppDef_Compute {
  Init(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean): void;
  Perform(Line: AppDef_MultiLine): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetConstraints(firstC: AppParCurves_Constraint, lastC: AppParCurves_Constraint): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(Index: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  ChangeValue(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  SplineValue(): AppParCurves_MultiBSpCurve;
  Parametrization(): Approx_ParametrizationType;
  Parameters_1(Index: Graphic3d_ZLayerId): TColStd_Array1OfReal;
  delete(): void;
}

  export declare class AppDef_Compute_1 extends AppDef_Compute {
    constructor(Line: AppDef_MultiLine, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

  export declare class AppDef_Compute_2 extends AppDef_Compute {
    constructor(Line: AppDef_MultiLine, Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class AppDef_Compute_3 extends AppDef_Compute {
    constructor(Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class AppDef_Compute_4 extends AppDef_Compute {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

export declare class AppDef_BSplineCompute {
  Interpol(Line: AppDef_MultiLine): void;
  Init(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean): void;
  Perform(Line: AppDef_MultiLine): void;
  SetParameters(ThePar: math_Vector): void;
  SetKnots(Knots: TColStd_Array1OfReal): void;
  SetKnotsAndMultiplicities(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetContinuity(C: Graphic3d_ZLayerId): void;
  SetConstraints(firstC: AppParCurves_Constraint, lastC: AppParCurves_Constraint): void;
  SetPeriodic(thePeriodic: Standard_Boolean): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  Value(): AppParCurves_MultiBSpCurve;
  ChangeValue(): AppParCurves_MultiBSpCurve;
  Parameters_1(): TColStd_Array1OfReal;
  delete(): void;
}

  export declare class AppDef_BSplineCompute_1 extends AppDef_BSplineCompute {
    constructor(Line: AppDef_MultiLine, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

  export declare class AppDef_BSplineCompute_2 extends AppDef_BSplineCompute {
    constructor(Line: AppDef_MultiLine, Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class AppDef_BSplineCompute_3 extends AppDef_BSplineCompute {
    constructor(Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class AppDef_BSplineCompute_4 extends AppDef_BSplineCompute {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

export declare class AppDef_Gradient_BFGSOfTheGradient extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class AppDef_TheGradient {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class AppDef_LinearCriteria extends AppDef_SmoothCriterion {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId)
  SetParameters(Parameters: Handle_TColStd_HArray1OfReal): void;
  SetCurve(C: Handle_FEmTool_Curve): void;
  GetCurve(C: Handle_FEmTool_Curve): void;
  SetEstimation(E1: Quantity_AbsorbedDose, E2: Quantity_AbsorbedDose, E3: Quantity_AbsorbedDose): void;
  EstLength(): Quantity_AbsorbedDose;
  GetEstimation(E1: Quantity_AbsorbedDose, E2: Quantity_AbsorbedDose, E3: Quantity_AbsorbedDose): void;
  AssemblyTable(): Handle_FEmTool_HAssemblyTable;
  DependenceTable(): Handle_TColStd_HArray2OfInteger;
  QualityValues(J1min: Quantity_AbsorbedDose, J2min: Quantity_AbsorbedDose, J3min: Quantity_AbsorbedDose, J1: Quantity_AbsorbedDose, J2: Quantity_AbsorbedDose, J3: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  ErrorValues(MaxError: Quantity_AbsorbedDose, QuadraticError: Quantity_AbsorbedDose, AverageError: Quantity_AbsorbedDose): void;
  Hessian(Element: Graphic3d_ZLayerId, Dimension1: Graphic3d_ZLayerId, Dimension2: Graphic3d_ZLayerId, H: math_Matrix): void;
  Gradient(Element: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, G: math_Vector): void;
  InputVector(X: math_Vector, AssTable: Handle_FEmTool_HAssemblyTable): void;
  SetWeight_1(QuadraticWeight: Quantity_AbsorbedDose, QualityWeight: Quantity_AbsorbedDose, percentJ1: Quantity_AbsorbedDose, percentJ2: Quantity_AbsorbedDose, percentJ3: Quantity_AbsorbedDose): void;
  GetWeight(QuadraticWeight: Quantity_AbsorbedDose, QualityWeight: Quantity_AbsorbedDose): void;
  SetWeight_2(Weight: TColStd_Array1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_AppDef_LinearCriteria {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppDef_LinearCriteria): void;
  get(): AppDef_LinearCriteria;
  delete(): void;
}

  export declare class Handle_AppDef_LinearCriteria_1 extends Handle_AppDef_LinearCriteria {
    constructor();
  }

  export declare class Handle_AppDef_LinearCriteria_2 extends Handle_AppDef_LinearCriteria {
    constructor(thePtr: AppDef_LinearCriteria);
  }

  export declare class Handle_AppDef_LinearCriteria_3 extends Handle_AppDef_LinearCriteria {
    constructor(theHandle: Handle_AppDef_LinearCriteria);
  }

  export declare class Handle_AppDef_LinearCriteria_4 extends Handle_AppDef_LinearCriteria {
    constructor(theHandle: Handle_AppDef_LinearCriteria);
  }

export declare class AppDef_MultiLine {
  NbMultiPoints(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  SetValue(Index: Graphic3d_ZLayerId, MPoint: AppDef_MultiPointConstraint): void;
  Value(Index: Graphic3d_ZLayerId): AppDef_MultiPointConstraint;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class AppDef_MultiLine_1 extends AppDef_MultiLine {
    constructor();
  }

  export declare class AppDef_MultiLine_2 extends AppDef_MultiLine {
    constructor(NbMult: Graphic3d_ZLayerId);
  }

  export declare class AppDef_MultiLine_3 extends AppDef_MultiLine {
    constructor(tabMultiP: AppDef_Array1OfMultiPointConstraint);
  }

  export declare class AppDef_MultiLine_4 extends AppDef_MultiLine {
    constructor(tabP3d: TColgp_Array1OfPnt);
  }

  export declare class AppDef_MultiLine_5 extends AppDef_MultiLine {
    constructor(tabP2d: TColgp_Array1OfPnt2d);
  }

export declare class AppDef_ParLeastSquareOfTheGradient {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class AppDef_ParLeastSquareOfTheGradient_1 extends AppDef_ParLeastSquareOfTheGradient {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfTheGradient_2 extends AppDef_ParLeastSquareOfTheGradient {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfTheGradient_3 extends AppDef_ParLeastSquareOfTheGradient {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfTheGradient_4 extends AppDef_ParLeastSquareOfTheGradient {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class AppDef_ResConstraintOfTheGradient {
  constructor(SSP: AppDef_MultiLine, SCurv: AppParCurves_MultiCurve, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, Constraints: Handle_AppParCurves_HArray1OfConstraintCouple, Bern: math_Matrix, DerivativeBern: math_Matrix, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ConstraintMatrix(): math_Matrix;
  Duale(): math_Vector;
  ConstraintDerivative(SSP: AppDef_MultiLine, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, DA: math_Matrix): math_Matrix;
  InverseMatrix(): math_Matrix;
  delete(): void;
}

export declare class AppDef_MyGradientbisOfBSplineCompute {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class AppDef_MultiPointConstraint extends AppParCurves_MultiPoint {
  SetTang(Index: Graphic3d_ZLayerId, Tang: gp_Vec): void;
  Tang(Index: Graphic3d_ZLayerId): gp_Vec;
  SetTang2d(Index: Graphic3d_ZLayerId, Tang2d: gp_Vec2d): void;
  Tang2d(Index: Graphic3d_ZLayerId): gp_Vec2d;
  SetCurv(Index: Graphic3d_ZLayerId, Curv: gp_Vec): void;
  Curv(Index: Graphic3d_ZLayerId): gp_Vec;
  SetCurv2d(Index: Graphic3d_ZLayerId, Curv2d: gp_Vec2d): void;
  Curv2d(Index: Graphic3d_ZLayerId): gp_Vec2d;
  IsTangencyPoint(): Standard_Boolean;
  IsCurvaturePoint(): Standard_Boolean;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class AppDef_MultiPointConstraint_1 extends AppDef_MultiPointConstraint {
    constructor();
  }

  export declare class AppDef_MultiPointConstraint_2 extends AppDef_MultiPointConstraint {
    constructor(NbPoints: Graphic3d_ZLayerId, NbPoints2d: Graphic3d_ZLayerId);
  }

  export declare class AppDef_MultiPointConstraint_3 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt);
  }

  export declare class AppDef_MultiPointConstraint_4 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt2d);
  }

  export declare class AppDef_MultiPointConstraint_5 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt, tabP2d: TColgp_Array1OfPnt2d);
  }

  export declare class AppDef_MultiPointConstraint_6 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt, tabP2d: TColgp_Array1OfPnt2d, tabVec: TColgp_Array1OfVec, tabVec2d: TColgp_Array1OfVec2d, tabCur: TColgp_Array1OfVec, tabCur2d: TColgp_Array1OfVec2d);
  }

  export declare class AppDef_MultiPointConstraint_7 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt, tabP2d: TColgp_Array1OfPnt2d, tabVec: TColgp_Array1OfVec, tabVec2d: TColgp_Array1OfVec2d);
  }

  export declare class AppDef_MultiPointConstraint_8 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt, tabVec: TColgp_Array1OfVec, tabCur: TColgp_Array1OfVec);
  }

  export declare class AppDef_MultiPointConstraint_9 extends AppDef_MultiPointConstraint {
    constructor(tabP: TColgp_Array1OfPnt, tabVec: TColgp_Array1OfVec);
  }

  export declare class AppDef_MultiPointConstraint_10 extends AppDef_MultiPointConstraint {
    constructor(tabP2d: TColgp_Array1OfPnt2d, tabVec2d: TColgp_Array1OfVec2d);
  }

  export declare class AppDef_MultiPointConstraint_11 extends AppDef_MultiPointConstraint {
    constructor(tabP2d: TColgp_Array1OfPnt2d, tabVec2d: TColgp_Array1OfVec2d, tabCur2d: TColgp_Array1OfVec2d);
  }

export declare class AppDef_BSpGradient_BFGSOfMyBSplGradientOfBSplineCompute extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class AppDef_ParFunctionOfMyGradientbisOfBSplineCompute extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class AppDef_MyLineTool {
  constructor();
  static FirstPoint(ML: AppDef_MultiLine): Graphic3d_ZLayerId;
  static LastPoint(ML: AppDef_MultiLine): Graphic3d_ZLayerId;
  static NbP2d(ML: AppDef_MultiLine): Graphic3d_ZLayerId;
  static NbP3d(ML: AppDef_MultiLine): Graphic3d_ZLayerId;
  static Value_1(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt): void;
  static Value_2(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabPt2d: TColgp_Array1OfPnt2d): void;
  static Value_3(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt, tabPt2d: TColgp_Array1OfPnt2d): void;
  static Tangency_1(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  static Tangency_2(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Tangency_3(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Curvature_1(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  static Curvature_2(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Curvature_3(ML: AppDef_MultiLine, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static WhatStatus(ML: AppDef_MultiLine, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): Approx_Status;
  static MakeMLBetween(ML: AppDef_MultiLine, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, NbPMin: Graphic3d_ZLayerId): AppDef_MultiLine;
  static MakeMLOneMorePoint(ML: AppDef_MultiLine, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, indbad: Graphic3d_ZLayerId, OtherLine: AppDef_MultiLine): Standard_Boolean;
  delete(): void;
}

export declare class AppDef_TheFunction extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class AppDef_SmoothCriterion extends Standard_Transient {
  SetParameters(Parameters: Handle_TColStd_HArray1OfReal): void;
  SetCurve(C: Handle_FEmTool_Curve): void;
  GetCurve(C: Handle_FEmTool_Curve): void;
  SetEstimation(E1: Quantity_AbsorbedDose, E2: Quantity_AbsorbedDose, E3: Quantity_AbsorbedDose): void;
  EstLength(): Quantity_AbsorbedDose;
  GetEstimation(E1: Quantity_AbsorbedDose, E2: Quantity_AbsorbedDose, E3: Quantity_AbsorbedDose): void;
  AssemblyTable(): Handle_FEmTool_HAssemblyTable;
  DependenceTable(): Handle_TColStd_HArray2OfInteger;
  QualityValues(J1min: Quantity_AbsorbedDose, J2min: Quantity_AbsorbedDose, J3min: Quantity_AbsorbedDose, J1: Quantity_AbsorbedDose, J2: Quantity_AbsorbedDose, J3: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  ErrorValues(MaxError: Quantity_AbsorbedDose, QuadraticError: Quantity_AbsorbedDose, AverageError: Quantity_AbsorbedDose): void;
  Hessian(Element: Graphic3d_ZLayerId, Dimension1: Graphic3d_ZLayerId, Dimension2: Graphic3d_ZLayerId, H: math_Matrix): void;
  Gradient(Element: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, G: math_Vector): void;
  InputVector(X: math_Vector, AssTable: Handle_FEmTool_HAssemblyTable): void;
  SetWeight_1(QuadraticWeight: Quantity_AbsorbedDose, QualityWeight: Quantity_AbsorbedDose, percentJ1: Quantity_AbsorbedDose, percentJ2: Quantity_AbsorbedDose, percentJ3: Quantity_AbsorbedDose): void;
  GetWeight(QuadraticWeight: Quantity_AbsorbedDose, QualityWeight: Quantity_AbsorbedDose): void;
  SetWeight_2(Weight: TColStd_Array1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_AppDef_SmoothCriterion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppDef_SmoothCriterion): void;
  get(): AppDef_SmoothCriterion;
  delete(): void;
}

  export declare class Handle_AppDef_SmoothCriterion_1 extends Handle_AppDef_SmoothCriterion {
    constructor();
  }

  export declare class Handle_AppDef_SmoothCriterion_2 extends Handle_AppDef_SmoothCriterion {
    constructor(thePtr: AppDef_SmoothCriterion);
  }

  export declare class Handle_AppDef_SmoothCriterion_3 extends Handle_AppDef_SmoothCriterion {
    constructor(theHandle: Handle_AppDef_SmoothCriterion);
  }

  export declare class Handle_AppDef_SmoothCriterion_4 extends Handle_AppDef_SmoothCriterion {
    constructor(theHandle: Handle_AppDef_SmoothCriterion);
  }

export declare class AppDef_Variational {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, MaxDegree: Graphic3d_ZLayerId, MaxSegment: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, WithMinMax: Standard_Boolean, WithCutting: Standard_Boolean, Tolerance: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  Approximate(): void;
  IsCreated(): Standard_Boolean;
  IsDone(): Standard_Boolean;
  IsOverConstrained(): Standard_Boolean;
  Value(): AppParCurves_MultiBSpCurve;
  MaxError(): Quantity_AbsorbedDose;
  MaxErrorIndex(): Graphic3d_ZLayerId;
  QuadraticError(): Quantity_AbsorbedDose;
  Distance(mat: math_Matrix): void;
  AverageError(): Quantity_AbsorbedDose;
  Parameters(): Handle_TColStd_HArray1OfReal;
  Knots(): Handle_TColStd_HArray1OfReal;
  Criterium(VFirstOrder: Quantity_AbsorbedDose, VSecondOrder: Quantity_AbsorbedDose, VThirdOrder: Quantity_AbsorbedDose): void;
  CriteriumWeight(Percent1: Quantity_AbsorbedDose, Percent2: Quantity_AbsorbedDose, Percent3: Quantity_AbsorbedDose): void;
  MaxDegree(): Graphic3d_ZLayerId;
  MaxSegment(): Graphic3d_ZLayerId;
  Continuity(): GeomAbs_Shape;
  WithMinMax(): Standard_Boolean;
  WithCutting(): Standard_Boolean;
  Tolerance(): Quantity_AbsorbedDose;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  SetConstraints(aConstrainst: Handle_AppParCurves_HArray1OfConstraintCouple): Standard_Boolean;
  SetParameters(param: Handle_TColStd_HArray1OfReal): void;
  SetKnots(knots: Handle_TColStd_HArray1OfReal): Standard_Boolean;
  SetMaxDegree(Degree: Graphic3d_ZLayerId): Standard_Boolean;
  SetMaxSegment(NbSegment: Graphic3d_ZLayerId): Standard_Boolean;
  SetContinuity(C: GeomAbs_Shape): Standard_Boolean;
  SetWithMinMax(MinMax: Standard_Boolean): void;
  SetWithCutting(Cutting: Standard_Boolean): Standard_Boolean;
  SetCriteriumWeight_1(Percent1: Quantity_AbsorbedDose, Percent2: Quantity_AbsorbedDose, Percent3: Quantity_AbsorbedDose): void;
  SetCriteriumWeight_2(Order: Graphic3d_ZLayerId, Percent: Quantity_AbsorbedDose): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  SetNbIterations(Iter: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class AppDef_MyGradientOfCompute {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class AppDef_Gradient_BFGSOfMyGradientbisOfBSplineCompute extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_1 extends AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_2 extends AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_3 extends AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_4 extends AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class AppDef_ParFunctionOfMyGradientOfCompute extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class AppDef_ParLeastSquareOfMyGradientOfCompute {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class AppDef_ParLeastSquareOfMyGradientOfCompute_1 extends AppDef_ParLeastSquareOfMyGradientOfCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfMyGradientOfCompute_2 extends AppDef_ParLeastSquareOfMyGradientOfCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfMyGradientOfCompute_3 extends AppDef_ParLeastSquareOfMyGradientOfCompute {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_ParLeastSquareOfMyGradientOfCompute_4 extends AppDef_ParLeastSquareOfMyGradientOfCompute {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class AppDef_TheResol {
  constructor(SSP: AppDef_MultiLine, SCurv: AppParCurves_MultiCurve, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, Constraints: Handle_AppParCurves_HArray1OfConstraintCouple, Bern: math_Matrix, DerivativeBern: math_Matrix, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ConstraintMatrix(): math_Matrix;
  Duale(): math_Vector;
  ConstraintDerivative(SSP: AppDef_MultiLine, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, DA: math_Matrix): math_Matrix;
  InverseMatrix(): math_Matrix;
  delete(): void;
}

export declare class AppDef_MyBSplGradientOfBSplineCompute {
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiBSpCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class AppDef_MyBSplGradientOfBSplineCompute_1 extends AppDef_MyBSplGradientOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class AppDef_MyBSplGradientOfBSplineCompute_2 extends AppDef_MyBSplGradientOfBSplineCompute {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, lambda1: Quantity_AbsorbedDose, lambda2: Quantity_AbsorbedDose);
  }

export declare class Handle_AppDef_HArray1OfMultiPointConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppDef_HArray1OfMultiPointConstraint): void;
  get(): AppDef_HArray1OfMultiPointConstraint;
  delete(): void;
}

  export declare class Handle_AppDef_HArray1OfMultiPointConstraint_1 extends Handle_AppDef_HArray1OfMultiPointConstraint {
    constructor();
  }

  export declare class Handle_AppDef_HArray1OfMultiPointConstraint_2 extends Handle_AppDef_HArray1OfMultiPointConstraint {
    constructor(thePtr: AppDef_HArray1OfMultiPointConstraint);
  }

  export declare class Handle_AppDef_HArray1OfMultiPointConstraint_3 extends Handle_AppDef_HArray1OfMultiPointConstraint {
    constructor(theHandle: Handle_AppDef_HArray1OfMultiPointConstraint);
  }

  export declare class Handle_AppDef_HArray1OfMultiPointConstraint_4 extends Handle_AppDef_HArray1OfMultiPointConstraint {
    constructor(theHandle: Handle_AppDef_HArray1OfMultiPointConstraint);
  }

export declare class AppDef_BSpParFunctionOfMyBSplGradientOfBSplineCompute extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NbPol: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiBSpCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  Index(): math_IntegerVector;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  SetFirstLambda(l1: Quantity_AbsorbedDose): void;
  SetLastLambda(l2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class AppDef_ResConstraintOfMyGradientOfCompute {
  constructor(SSP: AppDef_MultiLine, SCurv: AppParCurves_MultiCurve, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, Constraints: Handle_AppParCurves_HArray1OfConstraintCouple, Bern: math_Matrix, DerivativeBern: math_Matrix, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ConstraintMatrix(): math_Matrix;
  Duale(): math_Vector;
  ConstraintDerivative(SSP: AppDef_MultiLine, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, DA: math_Matrix): math_Matrix;
  InverseMatrix(): math_Matrix;
  delete(): void;
}

export declare class AppDef_Gradient_BFGSOfMyGradientOfCompute extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class AppDef_TheLeastSquares {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class AppDef_TheLeastSquares_1 extends AppDef_TheLeastSquares {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_TheLeastSquares_2 extends AppDef_TheLeastSquares {
    constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_TheLeastSquares_3 extends AppDef_TheLeastSquares {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppDef_TheLeastSquares_4 extends AppDef_TheLeastSquares {
    constructor(SSP: AppDef_MultiLine, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class AppDef_ResConstraintOfMyGradientbisOfBSplineCompute {
  constructor(SSP: AppDef_MultiLine, SCurv: AppParCurves_MultiCurve, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, Constraints: Handle_AppParCurves_HArray1OfConstraintCouple, Bern: math_Matrix, DerivativeBern: math_Matrix, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ConstraintMatrix(): math_Matrix;
  Duale(): math_Vector;
  ConstraintDerivative(SSP: AppDef_MultiLine, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, DA: math_Matrix): math_Matrix;
  InverseMatrix(): math_Matrix;
  delete(): void;
}

export declare class AppDef_ParFunctionOfTheGradient extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: AppDef_MultiLine, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class AppDef_Array1OfMultiPointConstraint {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: AppDef_MultiPointConstraint): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: AppDef_Array1OfMultiPointConstraint): AppDef_Array1OfMultiPointConstraint;
  Move(theOther: AppDef_Array1OfMultiPointConstraint): AppDef_Array1OfMultiPointConstraint;
  First(): AppDef_MultiPointConstraint;
  ChangeFirst(): AppDef_MultiPointConstraint;
  Last(): AppDef_MultiPointConstraint;
  ChangeLast(): AppDef_MultiPointConstraint;
  Value(theIndex: Standard_Integer): AppDef_MultiPointConstraint;
  ChangeValue(theIndex: Standard_Integer): AppDef_MultiPointConstraint;
  SetValue(theIndex: Standard_Integer, theItem: AppDef_MultiPointConstraint): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class AppDef_Array1OfMultiPointConstraint_1 extends AppDef_Array1OfMultiPointConstraint {
    constructor();
  }

  export declare class AppDef_Array1OfMultiPointConstraint_2 extends AppDef_Array1OfMultiPointConstraint {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class AppDef_Array1OfMultiPointConstraint_3 extends AppDef_Array1OfMultiPointConstraint {
    constructor(theOther: AppDef_Array1OfMultiPointConstraint);
  }

  export declare class AppDef_Array1OfMultiPointConstraint_4 extends AppDef_Array1OfMultiPointConstraint {
    constructor(theOther: AppDef_Array1OfMultiPointConstraint);
  }

  export declare class AppDef_Array1OfMultiPointConstraint_5 extends AppDef_Array1OfMultiPointConstraint {
    constructor(theBegin: AppDef_MultiPointConstraint, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TopAbs {
  constructor();
  static Compose(Or1: TopAbs_Orientation, Or2: TopAbs_Orientation): TopAbs_Orientation;
  static Reverse(Or: TopAbs_Orientation): TopAbs_Orientation;
  static Complement(Or: TopAbs_Orientation): TopAbs_Orientation;
  static ShapeTypeToString(theType: TopAbs_ShapeEnum): Standard_CString;
  static ShapeTypeFromString_1(theTypeString: Standard_CString): TopAbs_ShapeEnum;
  static ShapeTypeFromString_2(theTypeString: Standard_CString, theType: TopAbs_ShapeEnum): Standard_Boolean;
  static ShapeOrientationToString(theOrientation: TopAbs_Orientation): Standard_CString;
  static ShapeOrientationFromString_1(theOrientationString: Standard_CString): TopAbs_Orientation;
  static ShapeOrientationFromString_2(theOrientationString: Standard_CString, theOrientation: TopAbs_Orientation): Standard_Boolean;
  delete(): void;
}

export declare type TopAbs_Orientation = {
  TopAbs_FORWARD: {};
  TopAbs_REVERSED: {};
  TopAbs_INTERNAL: {};
  TopAbs_EXTERNAL: {};
}

export declare type TopAbs_State = {
  TopAbs_IN: {};
  TopAbs_OUT: {};
  TopAbs_ON: {};
  TopAbs_UNKNOWN: {};
}

export declare type TopAbs_ShapeEnum = {
  TopAbs_COMPOUND: {};
  TopAbs_COMPSOLID: {};
  TopAbs_SOLID: {};
  TopAbs_SHELL: {};
  TopAbs_FACE: {};
  TopAbs_WIRE: {};
  TopAbs_EDGE: {};
  TopAbs_VERTEX: {};
  TopAbs_SHAPE: {};
}

export declare class gce_MakeDir2d extends gce_Root {
  Value(): gp_Dir2d;
  Operator(): gp_Dir2d;
  delete(): void;
}

  export declare class gce_MakeDir2d_1 extends gce_MakeDir2d {
    constructor(V: gp_Vec2d);
  }

  export declare class gce_MakeDir2d_2 extends gce_MakeDir2d {
    constructor(Coord: gp_XY);
  }

  export declare class gce_MakeDir2d_3 extends gce_MakeDir2d {
    constructor(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeDir2d_4 extends gce_MakeDir2d {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

export declare class gce_MakeMirror {
  Value(): gp_Trsf;
  Operator(): gp_Trsf;
  delete(): void;
}

  export declare class gce_MakeMirror_1 extends gce_MakeMirror {
    constructor(Point: gp_Pnt);
  }

  export declare class gce_MakeMirror_2 extends gce_MakeMirror {
    constructor(Axis: gp_Ax1);
  }

  export declare class gce_MakeMirror_3 extends gce_MakeMirror {
    constructor(Line: gp_Lin);
  }

  export declare class gce_MakeMirror_4 extends gce_MakeMirror {
    constructor(Point: gp_Pnt, Direc: gp_Dir);
  }

  export declare class gce_MakeMirror_5 extends gce_MakeMirror {
    constructor(Plane: gp_Pln);
  }

  export declare class gce_MakeMirror_6 extends gce_MakeMirror {
    constructor(Plane: gp_Ax2);
  }

export declare class gce_MakeElips extends gce_Root {
  Value(): gp_Elips;
  Operator(): gp_Elips;
  delete(): void;
}

  export declare class gce_MakeElips_1 extends gce_MakeElips {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeElips_2 extends gce_MakeElips {
    constructor(S1: gp_Pnt, S2: gp_Pnt, Center: gp_Pnt);
  }

export declare class gce_MakeMirror2d {
  Value(): gp_Trsf2d;
  Operator(): gp_Trsf2d;
  delete(): void;
}

  export declare class gce_MakeMirror2d_1 extends gce_MakeMirror2d {
    constructor(Point: gp_Pnt2d);
  }

  export declare class gce_MakeMirror2d_2 extends gce_MakeMirror2d {
    constructor(Axis: gp_Ax2d);
  }

  export declare class gce_MakeMirror2d_3 extends gce_MakeMirror2d {
    constructor(Line: gp_Lin2d);
  }

  export declare class gce_MakeMirror2d_4 extends gce_MakeMirror2d {
    constructor(Point: gp_Pnt2d, Direc: gp_Dir2d);
  }

export declare class gce_MakeElips2d extends gce_Root {
  Value(): gp_Elips2d;
  Operator(): gp_Elips2d;
  delete(): void;
}

  export declare class gce_MakeElips2d_1 extends gce_MakeElips2d {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gce_MakeElips2d_2 extends gce_MakeElips2d {
    constructor(A: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeElips2d_3 extends gce_MakeElips2d {
    constructor(S1: gp_Pnt2d, S2: gp_Pnt2d, Center: gp_Pnt2d);
  }

export declare class gce_MakeParab extends gce_Root {
  Value(): gp_Parab;
  Operator(): gp_Parab;
  delete(): void;
}

  export declare class gce_MakeParab_1 extends gce_MakeParab {
    constructor(A2: gp_Ax2, Focal: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeParab_2 extends gce_MakeParab {
    constructor(D: gp_Ax1, F: gp_Pnt);
  }

export declare class gce_MakeCirc extends gce_Root {
  Value(): gp_Circ;
  Operator(): gp_Circ;
  delete(): void;
}

  export declare class gce_MakeCirc_1 extends gce_MakeCirc {
    constructor(A2: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc_2 extends gce_MakeCirc {
    constructor(Circ: gp_Circ, Dist: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc_3 extends gce_MakeCirc {
    constructor(Circ: gp_Circ, Point: gp_Pnt);
  }

  export declare class gce_MakeCirc_4 extends gce_MakeCirc {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class gce_MakeCirc_5 extends gce_MakeCirc {
    constructor(Center: gp_Pnt, Norm: gp_Dir, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc_6 extends gce_MakeCirc {
    constructor(Center: gp_Pnt, Plane: gp_Pln, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc_7 extends gce_MakeCirc {
    constructor(Center: gp_Pnt, Ptaxis: gp_Pnt, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc_8 extends gce_MakeCirc {
    constructor(Axis: gp_Ax1, Radius: Quantity_AbsorbedDose);
  }

export declare class gce_MakeTranslation {
  Value(): gp_Trsf;
  Operator(): gp_Trsf;
  delete(): void;
}

  export declare class gce_MakeTranslation_1 extends gce_MakeTranslation {
    constructor(Vect: gp_Vec);
  }

  export declare class gce_MakeTranslation_2 extends gce_MakeTranslation {
    constructor(Point1: gp_Pnt, Point2: gp_Pnt);
  }

export declare class gce_MakeParab2d extends gce_Root {
  Value(): gp_Parab2d;
  Operator(): gp_Parab2d;
  delete(): void;
}

  export declare class gce_MakeParab2d_1 extends gce_MakeParab2d {
    constructor(MirrorAxis: gp_Ax2d, Focal: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gce_MakeParab2d_2 extends gce_MakeParab2d {
    constructor(A: gp_Ax22d, Focal: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeParab2d_3 extends gce_MakeParab2d {
    constructor(D: gp_Ax2d, F: gp_Pnt2d, Sense: Standard_Boolean);
  }

  export declare class gce_MakeParab2d_4 extends gce_MakeParab2d {
    constructor(S1: gp_Pnt2d, Center: gp_Pnt2d, Sense: Standard_Boolean);
  }

export declare class gce_MakePln extends gce_Root {
  Value(): gp_Pln;
  Operator(): gp_Pln;
  delete(): void;
}

  export declare class gce_MakePln_1 extends gce_MakePln {
    constructor(A2: gp_Ax2);
  }

  export declare class gce_MakePln_2 extends gce_MakePln {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

  export declare class gce_MakePln_3 extends gce_MakePln {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose);
  }

  export declare class gce_MakePln_4 extends gce_MakePln {
    constructor(Pln: gp_Pln, Point: gp_Pnt);
  }

  export declare class gce_MakePln_5 extends gce_MakePln {
    constructor(Pln: gp_Pln, Dist: Quantity_AbsorbedDose);
  }

  export declare class gce_MakePln_6 extends gce_MakePln {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class gce_MakePln_7 extends gce_MakePln {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class gce_MakePln_8 extends gce_MakePln {
    constructor(Axis: gp_Ax1);
  }

export declare class gce_MakeCylinder extends gce_Root {
  Value(): gp_Cylinder;
  Operator(): gp_Cylinder;
  delete(): void;
}

  export declare class gce_MakeCylinder_1 extends gce_MakeCylinder {
    constructor(A2: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCylinder_2 extends gce_MakeCylinder {
    constructor(Cyl: gp_Cylinder, Point: gp_Pnt);
  }

  export declare class gce_MakeCylinder_3 extends gce_MakeCylinder {
    constructor(Cyl: gp_Cylinder, Dist: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCylinder_4 extends gce_MakeCylinder {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class gce_MakeCylinder_5 extends gce_MakeCylinder {
    constructor(Axis: gp_Ax1, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCylinder_6 extends gce_MakeCylinder {
    constructor(Circ: gp_Circ);
  }

export declare class gce_MakeHypr2d extends gce_Root {
  Value(): gp_Hypr2d;
  Operator(): gp_Hypr2d;
  delete(): void;
}

  export declare class gce_MakeHypr2d_1 extends gce_MakeHypr2d {
    constructor(S1: gp_Pnt2d, S2: gp_Pnt2d, Center: gp_Pnt2d);
  }

  export declare class gce_MakeHypr2d_2 extends gce_MakeHypr2d {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gce_MakeHypr2d_3 extends gce_MakeHypr2d {
    constructor(A: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class gce_MakeHypr extends gce_Root {
  Value(): gp_Hypr;
  Operator(): gp_Hypr;
  delete(): void;
}

  export declare class gce_MakeHypr_1 extends gce_MakeHypr {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeHypr_2 extends gce_MakeHypr {
    constructor(S1: gp_Pnt, S2: gp_Pnt, Center: gp_Pnt);
  }

export declare class gce_MakeCone extends gce_Root {
  Value(): gp_Cone;
  Operator(): gp_Cone;
  delete(): void;
}

  export declare class gce_MakeCone_1 extends gce_MakeCone {
    constructor(A2: gp_Ax2, Ang: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCone_2 extends gce_MakeCone {
    constructor(Cone: gp_Cone, Point: gp_Pnt);
  }

  export declare class gce_MakeCone_3 extends gce_MakeCone {
    constructor(Cone: gp_Cone, Dist: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCone_4 extends gce_MakeCone {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, P4: gp_Pnt);
  }

  export declare class gce_MakeCone_5 extends gce_MakeCone {
    constructor(Axis: gp_Ax1, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class gce_MakeCone_6 extends gce_MakeCone {
    constructor(Axis: gp_Lin, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class gce_MakeCone_7 extends gce_MakeCone {
    constructor(P1: gp_Pnt, P2: gp_Pnt, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose);
  }

export declare class gce_MakeLin extends gce_Root {
  Value(): gp_Lin;
  Operator(): gp_Lin;
  delete(): void;
}

  export declare class gce_MakeLin_1 extends gce_MakeLin {
    constructor(A1: gp_Ax1);
  }

  export declare class gce_MakeLin_2 extends gce_MakeLin {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

  export declare class gce_MakeLin_3 extends gce_MakeLin {
    constructor(Lin: gp_Lin, Point: gp_Pnt);
  }

  export declare class gce_MakeLin_4 extends gce_MakeLin {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

export declare class gce_MakeScale {
  constructor(Point: gp_Pnt, Scale: Quantity_AbsorbedDose)
  Value(): gp_Trsf;
  Operator(): gp_Trsf;
  delete(): void;
}

export declare class gce_MakeScale2d {
  constructor(Point: gp_Pnt2d, Scale: Quantity_AbsorbedDose)
  Value(): gp_Trsf2d;
  Operator(): gp_Trsf2d;
  delete(): void;
}

export declare class gce_MakeCirc2d extends gce_Root {
  Value(): gp_Circ2d;
  Operator(): gp_Circ2d;
  delete(): void;
}

  export declare class gce_MakeCirc2d_1 extends gce_MakeCirc2d {
    constructor(XAxis: gp_Ax2d, Radius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gce_MakeCirc2d_2 extends gce_MakeCirc2d {
    constructor(Axis: gp_Ax22d, Radius: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc2d_3 extends gce_MakeCirc2d {
    constructor(Circ: gp_Circ2d, Dist: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeCirc2d_4 extends gce_MakeCirc2d {
    constructor(Circ: gp_Circ2d, Point: gp_Pnt2d);
  }

  export declare class gce_MakeCirc2d_5 extends gce_MakeCirc2d {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d, P3: gp_Pnt2d);
  }

  export declare class gce_MakeCirc2d_6 extends gce_MakeCirc2d {
    constructor(Center: gp_Pnt2d, Radius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class gce_MakeCirc2d_7 extends gce_MakeCirc2d {
    constructor(Center: gp_Pnt2d, Point: gp_Pnt2d, Sense: Standard_Boolean);
  }

export declare class gce_MakeRotation2d {
  constructor(Point: gp_Pnt2d, Angle: Quantity_AbsorbedDose)
  Value(): gp_Trsf2d;
  Operator(): gp_Trsf2d;
  delete(): void;
}

export declare class gce_MakeDir extends gce_Root {
  Value(): gp_Dir;
  Operator(): gp_Dir;
  delete(): void;
}

  export declare class gce_MakeDir_1 extends gce_MakeDir {
    constructor(V: gp_Vec);
  }

  export declare class gce_MakeDir_2 extends gce_MakeDir {
    constructor(Coord: gp_XYZ);
  }

  export declare class gce_MakeDir_3 extends gce_MakeDir {
    constructor(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Zv: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeDir_4 extends gce_MakeDir {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

export declare type gce_ErrorType = {
  gce_Done: {};
  gce_ConfusedPoints: {};
  gce_NegativeRadius: {};
  gce_ColinearPoints: {};
  gce_IntersectionError: {};
  gce_NullAxis: {};
  gce_NullAngle: {};
  gce_NullRadius: {};
  gce_InvertAxis: {};
  gce_BadAngle: {};
  gce_InvertRadius: {};
  gce_NullFocusLength: {};
  gce_NullVector: {};
  gce_BadEquation: {};
}

export declare class gce_MakeLin2d extends gce_Root {
  Value(): gp_Lin2d;
  Operator(): gp_Lin2d;
  delete(): void;
}

  export declare class gce_MakeLin2d_1 extends gce_MakeLin2d {
    constructor(A: gp_Ax2d);
  }

  export declare class gce_MakeLin2d_2 extends gce_MakeLin2d {
    constructor(P: gp_Pnt2d, V: gp_Dir2d);
  }

  export declare class gce_MakeLin2d_3 extends gce_MakeLin2d {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeLin2d_4 extends gce_MakeLin2d {
    constructor(Lin: gp_Lin2d, Dist: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeLin2d_5 extends gce_MakeLin2d {
    constructor(Lin: gp_Lin2d, Point: gp_Pnt2d);
  }

  export declare class gce_MakeLin2d_6 extends gce_MakeLin2d {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

export declare class gce_MakeRotation {
  Value(): gp_Trsf;
  Operator(): gp_Trsf;
  delete(): void;
}

  export declare class gce_MakeRotation_1 extends gce_MakeRotation {
    constructor(Line: gp_Lin, Angle: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeRotation_2 extends gce_MakeRotation {
    constructor(Axis: gp_Ax1, Angle: Quantity_AbsorbedDose);
  }

  export declare class gce_MakeRotation_3 extends gce_MakeRotation {
    constructor(Point: gp_Pnt, Direc: gp_Dir, Angle: Quantity_AbsorbedDose);
  }

export declare class gce_Root {
  constructor();
  IsDone(): Standard_Boolean;
  Status(): gce_ErrorType;
  delete(): void;
}

export declare class gce_MakeTranslation2d {
  Value(): gp_Trsf2d;
  Operator(): gp_Trsf2d;
  delete(): void;
}

  export declare class gce_MakeTranslation2d_1 extends gce_MakeTranslation2d {
    constructor(Vect: gp_Vec2d);
  }

  export declare class gce_MakeTranslation2d_2 extends gce_MakeTranslation2d {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d);
  }

export declare class Precision {
  constructor();
  static Angular(): Quantity_AbsorbedDose;
  static Confusion(): Quantity_AbsorbedDose;
  static SquareConfusion(): Quantity_AbsorbedDose;
  static Intersection(): Quantity_AbsorbedDose;
  static Approximation(): Quantity_AbsorbedDose;
  static Parametric_1(P: Quantity_AbsorbedDose, T: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static PConfusion_1(T: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static SquarePConfusion(): Quantity_AbsorbedDose;
  static PIntersection_1(T: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static PApproximation_1(T: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Parametric_2(P: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static PConfusion_2(): Quantity_AbsorbedDose;
  static PIntersection_2(): Quantity_AbsorbedDose;
  static PApproximation_2(): Quantity_AbsorbedDose;
  static IsInfinite(R: Quantity_AbsorbedDose): Standard_Boolean;
  static IsPositiveInfinite(R: Quantity_AbsorbedDose): Standard_Boolean;
  static IsNegativeInfinite(R: Quantity_AbsorbedDose): Standard_Boolean;
  static Infinite(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_StdSelect_FaceFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdSelect_FaceFilter): void;
  get(): StdSelect_FaceFilter;
  delete(): void;
}

  export declare class Handle_StdSelect_FaceFilter_1 extends Handle_StdSelect_FaceFilter {
    constructor();
  }

  export declare class Handle_StdSelect_FaceFilter_2 extends Handle_StdSelect_FaceFilter {
    constructor(thePtr: StdSelect_FaceFilter);
  }

  export declare class Handle_StdSelect_FaceFilter_3 extends Handle_StdSelect_FaceFilter {
    constructor(theHandle: Handle_StdSelect_FaceFilter);
  }

  export declare class Handle_StdSelect_FaceFilter_4 extends Handle_StdSelect_FaceFilter {
    constructor(theHandle: Handle_StdSelect_FaceFilter);
  }

export declare class StdSelect_FaceFilter extends SelectMgr_Filter {
  constructor(aTypeOfFace: StdSelect_TypeOfFace)
  SetType(aNewType: StdSelect_TypeOfFace): void;
  Type(): StdSelect_TypeOfFace;
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  ActsOn(aStandardMode: TopAbs_ShapeEnum): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StdSelect_TypeOfSelectionImage = {
  StdSelect_TypeOfSelectionImage_NormalizedDepth: {};
  StdSelect_TypeOfSelectionImage_NormalizedDepthInverted: {};
  StdSelect_TypeOfSelectionImage_UnnormalizedDepth: {};
  StdSelect_TypeOfSelectionImage_ColoredDetectedObject: {};
  StdSelect_TypeOfSelectionImage_ColoredEntity: {};
  StdSelect_TypeOfSelectionImage_ColoredOwner: {};
  StdSelect_TypeOfSelectionImage_ColoredSelectionMode: {};
}

export declare class StdSelect_Shape extends PrsMgr_PresentableObject {
  constructor(theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Compute(aPresentationManager: any, aPresentation: any, aMode: Graphic3d_ZLayerId): void;
  Shape_1(): TopoDS_Shape;
  Shape_2(theShape: TopoDS_Shape): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_StdSelect_Shape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdSelect_Shape): void;
  get(): StdSelect_Shape;
  delete(): void;
}

  export declare class Handle_StdSelect_Shape_1 extends Handle_StdSelect_Shape {
    constructor();
  }

  export declare class Handle_StdSelect_Shape_2 extends Handle_StdSelect_Shape {
    constructor(thePtr: StdSelect_Shape);
  }

  export declare class Handle_StdSelect_Shape_3 extends Handle_StdSelect_Shape {
    constructor(theHandle: Handle_StdSelect_Shape);
  }

  export declare class Handle_StdSelect_Shape_4 extends Handle_StdSelect_Shape {
    constructor(theHandle: Handle_StdSelect_Shape);
  }

export declare class StdSelect_BRepOwner extends SelectMgr_EntityOwner {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  HasShape(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  HasHilightMode(): Standard_Boolean;
  SetHilightMode(theMode: Graphic3d_ZLayerId): void;
  ResetHilightMode(): void;
  HilightMode(): Graphic3d_ZLayerId;
  IsHilighted(aPM: Handle_PrsMgr_PresentationManager, aMode: Graphic3d_ZLayerId): Standard_Boolean;
  HilightWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId): void;
  Unhilight(aPM: Handle_PrsMgr_PresentationManager, aMode: Graphic3d_ZLayerId): void;
  Clear(aPM: Handle_PrsMgr_PresentationManager, aMode: Graphic3d_ZLayerId): void;
  SetLocation(aLoc: TopLoc_Location): void;
  UpdateHighlightTrsf(theViewer: Handle_V3d_Viewer, theManager: any, theDispMode: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class StdSelect_BRepOwner_1 extends StdSelect_BRepOwner {
    constructor(aPriority: Graphic3d_ZLayerId);
  }

  export declare class StdSelect_BRepOwner_2 extends StdSelect_BRepOwner {
    constructor(aShape: TopoDS_Shape, aPriority: Graphic3d_ZLayerId, ComesFromDecomposition: Standard_Boolean);
  }

  export declare class StdSelect_BRepOwner_3 extends StdSelect_BRepOwner {
    constructor(aShape: TopoDS_Shape, theOrigin: Handle_SelectMgr_SelectableObject, aPriority: Graphic3d_ZLayerId, FromDecomposition: Standard_Boolean);
  }

export declare class Handle_StdSelect_BRepOwner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdSelect_BRepOwner): void;
  get(): StdSelect_BRepOwner;
  delete(): void;
}

  export declare class Handle_StdSelect_BRepOwner_1 extends Handle_StdSelect_BRepOwner {
    constructor();
  }

  export declare class Handle_StdSelect_BRepOwner_2 extends Handle_StdSelect_BRepOwner {
    constructor(thePtr: StdSelect_BRepOwner);
  }

  export declare class Handle_StdSelect_BRepOwner_3 extends Handle_StdSelect_BRepOwner {
    constructor(theHandle: Handle_StdSelect_BRepOwner);
  }

  export declare class Handle_StdSelect_BRepOwner_4 extends Handle_StdSelect_BRepOwner {
    constructor(theHandle: Handle_StdSelect_BRepOwner);
  }

export declare type StdSelect_TypeOfEdge = {
  StdSelect_AnyEdge: {};
  StdSelect_Line: {};
  StdSelect_Circle: {};
}

export declare class StdSelect_BRepSelectionTool {
  constructor();
  static Load_1(aSelection: Handle_SelectMgr_Selection, aShape: TopoDS_Shape, aType: TopAbs_ShapeEnum, theDeflection: Quantity_AbsorbedDose, theDeviationAngle: Quantity_AbsorbedDose, AutoTriangulation: Standard_Boolean, aPriority: Graphic3d_ZLayerId, NbPOnEdge: Graphic3d_ZLayerId, MaximalParameter: Quantity_AbsorbedDose): void;
  static Load_2(aSelection: Handle_SelectMgr_Selection, Origin: Handle_SelectMgr_SelectableObject, aShape: TopoDS_Shape, aType: TopAbs_ShapeEnum, theDeflection: Quantity_AbsorbedDose, theDeviationAngle: Quantity_AbsorbedDose, AutoTriangulation: Standard_Boolean, aPriority: Graphic3d_ZLayerId, NbPOnEdge: Graphic3d_ZLayerId, MaximalParameter: Quantity_AbsorbedDose): void;
  static GetStandardPriority(theShape: TopoDS_Shape, theType: TopAbs_ShapeEnum): Graphic3d_ZLayerId;
  static ComputeSensitive(theShape: TopoDS_Shape, theOwner: Handle_SelectMgr_EntityOwner, theSelection: Handle_SelectMgr_Selection, theDeflection: Quantity_AbsorbedDose, theDeflAngle: Quantity_AbsorbedDose, theNbPOnEdge: Graphic3d_ZLayerId, theMaxiParam: Quantity_AbsorbedDose, theAutoTriang: Standard_Boolean): void;
  static GetSensitiveForFace(theFace: TopoDS_Face, theOwner: Handle_SelectMgr_EntityOwner, theOutList: Select3D_EntitySequence, theAutoTriang: Standard_Boolean, theNbPOnEdge: Graphic3d_ZLayerId, theMaxiParam: Quantity_AbsorbedDose, theInteriorFlag: Standard_Boolean): Standard_Boolean;
  static GetEdgeSensitive(theShape: TopoDS_Shape, theOwner: Handle_SelectMgr_EntityOwner, theSelection: Handle_SelectMgr_Selection, theDeflection: Quantity_AbsorbedDose, theDeviationAngle: Quantity_AbsorbedDose, theNbPOnEdge: Graphic3d_ZLayerId, theMaxiParam: Quantity_AbsorbedDose, theSensitive: Handle_Select3D_SensitiveEntity): void;
  static PreBuildBVH(theSelection: Handle_SelectMgr_Selection): void;
  delete(): void;
}

export declare class StdSelect {
  constructor();
  static SetDrawerForBRepOwner(aSelection: Handle_SelectMgr_Selection, aDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare type StdSelect_TypeOfFace = {
  StdSelect_AnyFace: {};
  StdSelect_Plane: {};
  StdSelect_Cylinder: {};
  StdSelect_Sphere: {};
  StdSelect_Torus: {};
  StdSelect_Revol: {};
  StdSelect_Cone: {};
}

export declare class Handle_StdSelect_EdgeFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdSelect_EdgeFilter): void;
  get(): StdSelect_EdgeFilter;
  delete(): void;
}

  export declare class Handle_StdSelect_EdgeFilter_1 extends Handle_StdSelect_EdgeFilter {
    constructor();
  }

  export declare class Handle_StdSelect_EdgeFilter_2 extends Handle_StdSelect_EdgeFilter {
    constructor(thePtr: StdSelect_EdgeFilter);
  }

  export declare class Handle_StdSelect_EdgeFilter_3 extends Handle_StdSelect_EdgeFilter {
    constructor(theHandle: Handle_StdSelect_EdgeFilter);
  }

  export declare class Handle_StdSelect_EdgeFilter_4 extends Handle_StdSelect_EdgeFilter {
    constructor(theHandle: Handle_StdSelect_EdgeFilter);
  }

export declare class StdSelect_EdgeFilter extends SelectMgr_Filter {
  constructor(Edge: StdSelect_TypeOfEdge)
  SetType(aNewType: StdSelect_TypeOfEdge): void;
  Type(): StdSelect_TypeOfEdge;
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  ActsOn(aStandardMode: TopAbs_ShapeEnum): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StdSelect_ShapeTypeFilter extends SelectMgr_Filter {
  constructor(aType: TopAbs_ShapeEnum)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Type(): TopAbs_ShapeEnum;
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  ActsOn(aStandardMode: TopAbs_ShapeEnum): Standard_Boolean;
  delete(): void;
}

export declare class Handle_StdSelect_ShapeTypeFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdSelect_ShapeTypeFilter): void;
  get(): StdSelect_ShapeTypeFilter;
  delete(): void;
}

  export declare class Handle_StdSelect_ShapeTypeFilter_1 extends Handle_StdSelect_ShapeTypeFilter {
    constructor();
  }

  export declare class Handle_StdSelect_ShapeTypeFilter_2 extends Handle_StdSelect_ShapeTypeFilter {
    constructor(thePtr: StdSelect_ShapeTypeFilter);
  }

  export declare class Handle_StdSelect_ShapeTypeFilter_3 extends Handle_StdSelect_ShapeTypeFilter {
    constructor(theHandle: Handle_StdSelect_ShapeTypeFilter);
  }

  export declare class Handle_StdSelect_ShapeTypeFilter_4 extends Handle_StdSelect_ShapeTypeFilter {
    constructor(theHandle: Handle_StdSelect_ShapeTypeFilter);
  }

export declare class BinMXCAFDoc_DatumDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_DatumDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_DatumDriver): void;
  get(): BinMXCAFDoc_DatumDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_DatumDriver_1 extends Handle_BinMXCAFDoc_DatumDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_DatumDriver_2 extends Handle_BinMXCAFDoc_DatumDriver {
    constructor(thePtr: BinMXCAFDoc_DatumDriver);
  }

  export declare class Handle_BinMXCAFDoc_DatumDriver_3 extends Handle_BinMXCAFDoc_DatumDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_DatumDriver);
  }

  export declare class Handle_BinMXCAFDoc_DatumDriver_4 extends Handle_BinMXCAFDoc_DatumDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_DatumDriver);
  }

export declare class BinMXCAFDoc_LocationDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  Translate_1(theSource: BinObjMgt_Persistent, theLoc: TopLoc_Location, theMap: BinObjMgt_RRelocationTable): Standard_Boolean;
  Translate_2(theLoc: TopLoc_Location, theTarget: BinObjMgt_Persistent, theMap: BinObjMgt_SRelocationTable): void;
  SetSharedLocations(theLocations: BinTools_LocationSetPtr): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_LocationDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_LocationDriver): void;
  get(): BinMXCAFDoc_LocationDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_LocationDriver_1 extends Handle_BinMXCAFDoc_LocationDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_LocationDriver_2 extends Handle_BinMXCAFDoc_LocationDriver {
    constructor(thePtr: BinMXCAFDoc_LocationDriver);
  }

  export declare class Handle_BinMXCAFDoc_LocationDriver_3 extends Handle_BinMXCAFDoc_LocationDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_LocationDriver);
  }

  export declare class Handle_BinMXCAFDoc_LocationDriver_4 extends Handle_BinMXCAFDoc_LocationDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_LocationDriver);
  }

export declare class Handle_BinMXCAFDoc_AssemblyItemRefDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_AssemblyItemRefDriver): void;
  get(): BinMXCAFDoc_AssemblyItemRefDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_AssemblyItemRefDriver_1 extends Handle_BinMXCAFDoc_AssemblyItemRefDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_AssemblyItemRefDriver_2 extends Handle_BinMXCAFDoc_AssemblyItemRefDriver {
    constructor(thePtr: BinMXCAFDoc_AssemblyItemRefDriver);
  }

  export declare class Handle_BinMXCAFDoc_AssemblyItemRefDriver_3 extends Handle_BinMXCAFDoc_AssemblyItemRefDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_AssemblyItemRefDriver);
  }

  export declare class Handle_BinMXCAFDoc_AssemblyItemRefDriver_4 extends Handle_BinMXCAFDoc_AssemblyItemRefDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_AssemblyItemRefDriver);
  }

export declare class BinMXCAFDoc_AssemblyItemRefDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_NoteDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_NoteDriver): void;
  get(): BinMXCAFDoc_NoteDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_NoteDriver_1 extends Handle_BinMXCAFDoc_NoteDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_NoteDriver_2 extends Handle_BinMXCAFDoc_NoteDriver {
    constructor(thePtr: BinMXCAFDoc_NoteDriver);
  }

  export declare class Handle_BinMXCAFDoc_NoteDriver_3 extends Handle_BinMXCAFDoc_NoteDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_NoteDriver);
  }

  export declare class Handle_BinMXCAFDoc_NoteDriver_4 extends Handle_BinMXCAFDoc_NoteDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_NoteDriver);
  }

export declare class BinMXCAFDoc_NoteDriver extends BinMDF_ADriver {
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_GraphNodeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_GraphNodeDriver): void;
  get(): BinMXCAFDoc_GraphNodeDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_GraphNodeDriver_1 extends Handle_BinMXCAFDoc_GraphNodeDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_GraphNodeDriver_2 extends Handle_BinMXCAFDoc_GraphNodeDriver {
    constructor(thePtr: BinMXCAFDoc_GraphNodeDriver);
  }

  export declare class Handle_BinMXCAFDoc_GraphNodeDriver_3 extends Handle_BinMXCAFDoc_GraphNodeDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_GraphNodeDriver);
  }

  export declare class Handle_BinMXCAFDoc_GraphNodeDriver_4 extends Handle_BinMXCAFDoc_GraphNodeDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_GraphNodeDriver);
  }

export declare class BinMXCAFDoc_GraphNodeDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMXCAFDoc_NoteCommentDriver extends BinMXCAFDoc_NoteDriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_NoteCommentDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_NoteCommentDriver): void;
  get(): BinMXCAFDoc_NoteCommentDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_NoteCommentDriver_1 extends Handle_BinMXCAFDoc_NoteCommentDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_NoteCommentDriver_2 extends Handle_BinMXCAFDoc_NoteCommentDriver {
    constructor(thePtr: BinMXCAFDoc_NoteCommentDriver);
  }

  export declare class Handle_BinMXCAFDoc_NoteCommentDriver_3 extends Handle_BinMXCAFDoc_NoteCommentDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_NoteCommentDriver);
  }

  export declare class Handle_BinMXCAFDoc_NoteCommentDriver_4 extends Handle_BinMXCAFDoc_NoteCommentDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_NoteCommentDriver);
  }

export declare class BinMXCAFDoc_NoteBinDataDriver extends BinMXCAFDoc_NoteDriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_NoteBinDataDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_NoteBinDataDriver): void;
  get(): BinMXCAFDoc_NoteBinDataDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_NoteBinDataDriver_1 extends Handle_BinMXCAFDoc_NoteBinDataDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_NoteBinDataDriver_2 extends Handle_BinMXCAFDoc_NoteBinDataDriver {
    constructor(thePtr: BinMXCAFDoc_NoteBinDataDriver);
  }

  export declare class Handle_BinMXCAFDoc_NoteBinDataDriver_3 extends Handle_BinMXCAFDoc_NoteBinDataDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_NoteBinDataDriver);
  }

  export declare class Handle_BinMXCAFDoc_NoteBinDataDriver_4 extends Handle_BinMXCAFDoc_NoteBinDataDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_NoteBinDataDriver);
  }

export declare class Handle_BinMXCAFDoc_MaterialDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_MaterialDriver): void;
  get(): BinMXCAFDoc_MaterialDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_MaterialDriver_1 extends Handle_BinMXCAFDoc_MaterialDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_MaterialDriver_2 extends Handle_BinMXCAFDoc_MaterialDriver {
    constructor(thePtr: BinMXCAFDoc_MaterialDriver);
  }

  export declare class Handle_BinMXCAFDoc_MaterialDriver_3 extends Handle_BinMXCAFDoc_MaterialDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_MaterialDriver);
  }

  export declare class Handle_BinMXCAFDoc_MaterialDriver_4 extends Handle_BinMXCAFDoc_MaterialDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_MaterialDriver);
  }

export declare class BinMXCAFDoc_MaterialDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMXCAFDoc_ColorDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_ColorDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_ColorDriver): void;
  get(): BinMXCAFDoc_ColorDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_ColorDriver_1 extends Handle_BinMXCAFDoc_ColorDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_ColorDriver_2 extends Handle_BinMXCAFDoc_ColorDriver {
    constructor(thePtr: BinMXCAFDoc_ColorDriver);
  }

  export declare class Handle_BinMXCAFDoc_ColorDriver_3 extends Handle_BinMXCAFDoc_ColorDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_ColorDriver);
  }

  export declare class Handle_BinMXCAFDoc_ColorDriver_4 extends Handle_BinMXCAFDoc_ColorDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_ColorDriver);
  }

export declare class BinMXCAFDoc {
  constructor();
  static AddDrivers(theDriverTable: Handle_BinMDF_ADriverTable, theMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class BinMXCAFDoc_VisMaterialDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_VisMaterialDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_VisMaterialDriver): void;
  get(): BinMXCAFDoc_VisMaterialDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_VisMaterialDriver_1 extends Handle_BinMXCAFDoc_VisMaterialDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_VisMaterialDriver_2 extends Handle_BinMXCAFDoc_VisMaterialDriver {
    constructor(thePtr: BinMXCAFDoc_VisMaterialDriver);
  }

  export declare class Handle_BinMXCAFDoc_VisMaterialDriver_3 extends Handle_BinMXCAFDoc_VisMaterialDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_VisMaterialDriver);
  }

  export declare class Handle_BinMXCAFDoc_VisMaterialDriver_4 extends Handle_BinMXCAFDoc_VisMaterialDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_VisMaterialDriver);
  }

export declare class Handle_BinMXCAFDoc_DimTolDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_DimTolDriver): void;
  get(): BinMXCAFDoc_DimTolDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_DimTolDriver_1 extends Handle_BinMXCAFDoc_DimTolDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_DimTolDriver_2 extends Handle_BinMXCAFDoc_DimTolDriver {
    constructor(thePtr: BinMXCAFDoc_DimTolDriver);
  }

  export declare class Handle_BinMXCAFDoc_DimTolDriver_3 extends Handle_BinMXCAFDoc_DimTolDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_DimTolDriver);
  }

  export declare class Handle_BinMXCAFDoc_DimTolDriver_4 extends Handle_BinMXCAFDoc_DimTolDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_DimTolDriver);
  }

export declare class BinMXCAFDoc_DimTolDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_CentroidDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_CentroidDriver): void;
  get(): BinMXCAFDoc_CentroidDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_CentroidDriver_1 extends Handle_BinMXCAFDoc_CentroidDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_CentroidDriver_2 extends Handle_BinMXCAFDoc_CentroidDriver {
    constructor(thePtr: BinMXCAFDoc_CentroidDriver);
  }

  export declare class Handle_BinMXCAFDoc_CentroidDriver_3 extends Handle_BinMXCAFDoc_CentroidDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_CentroidDriver);
  }

  export declare class Handle_BinMXCAFDoc_CentroidDriver_4 extends Handle_BinMXCAFDoc_CentroidDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_CentroidDriver);
  }

export declare class BinMXCAFDoc_CentroidDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMXCAFDoc_VisMaterialToolDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMXCAFDoc_VisMaterialToolDriver): void;
  get(): BinMXCAFDoc_VisMaterialToolDriver;
  delete(): void;
}

  export declare class Handle_BinMXCAFDoc_VisMaterialToolDriver_1 extends Handle_BinMXCAFDoc_VisMaterialToolDriver {
    constructor();
  }

  export declare class Handle_BinMXCAFDoc_VisMaterialToolDriver_2 extends Handle_BinMXCAFDoc_VisMaterialToolDriver {
    constructor(thePtr: BinMXCAFDoc_VisMaterialToolDriver);
  }

  export declare class Handle_BinMXCAFDoc_VisMaterialToolDriver_3 extends Handle_BinMXCAFDoc_VisMaterialToolDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_VisMaterialToolDriver);
  }

  export declare class Handle_BinMXCAFDoc_VisMaterialToolDriver_4 extends Handle_BinMXCAFDoc_VisMaterialToolDriver {
    constructor(theHandle: Handle_BinMXCAFDoc_VisMaterialToolDriver);
  }

export declare class BinMXCAFDoc_VisMaterialToolDriver extends BinMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  delete(): void;
}

export declare class BlendFunc_ConstThroat extends BlendFunc_GenChamfer {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  Set_2(aThroat: Quantity_AbsorbedDose, a1: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  GetSectionSize(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BlendFunc_EvolRad extends Blend_Function {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, Law: Handle_Law_Function)
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  TwistOnS1(): Standard_Boolean;
  TwistOnS2(): Standard_Boolean;
  Set_3(Choix: Graphic3d_ZLayerId): void;
  Set_4(TypeSection: BlendFunc_SectionShape): void;
  Section_1(Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BlendFunc_ConstThroatWithPenetrationInv extends BlendFunc_ConstThroatInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class BlendFunc_GenChamfInv extends Blend_FuncInv {
  Set_1(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  NbEquations(): Graphic3d_ZLayerId;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(Dist1: Quantity_AbsorbedDose, Dist2: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc_GenChamfer extends Blend_Function {
  NbEquations(): Graphic3d_ZLayerId;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  Set_3(Dist1: Quantity_AbsorbedDose, Dist2: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  IsRational(): Standard_Boolean;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Lin): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BlendFunc_ChamfInv extends BlendFunc_GenChamfInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  Set_2(Dist1: Quantity_AbsorbedDose, Dist2: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc_RuledInv extends Blend_FuncInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  Set(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class BlendFunc_ChAsym extends Blend_Function {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  NbEquations(): Graphic3d_ZLayerId;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  ComputeValues(X: math_Vector, DegF: Graphic3d_ZLayerId, DegL: Graphic3d_ZLayerId): Standard_Boolean;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  TwistOnS1(): Standard_Boolean;
  TwistOnS2(): Standard_Boolean;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  Section_1(Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Lin): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Set_3(Dist1: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc_ChAsymInv extends Blend_FuncInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  Set_1(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NbEquations(): Graphic3d_ZLayerId;
  ComputeValues(X: math_Vector, DegF: Graphic3d_ZLayerId, DegL: Graphic3d_ZLayerId): Standard_Boolean;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(Dist1: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc_Ruled extends Blend_Function {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  GetSection(Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, tabP: TColgp_Array1OfPnt, tabV: TColgp_Array1OfVec): Standard_Boolean;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  AxeRot(Prm: Quantity_AbsorbedDose): gp_Ax1;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BlendFunc_ConstRad extends Blend_Function {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  TwistOnS1(): Standard_Boolean;
  TwistOnS2(): Standard_Boolean;
  Set_3(Radius: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  Set_4(TypeSection: BlendFunc_SectionShape): void;
  Section_1(Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  AxeRot(Prm: Quantity_AbsorbedDose): gp_Ax1;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BlendFunc_ConstThroatWithPenetration extends BlendFunc_ConstThroat {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  GetSectionSize(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare type BlendFunc_SectionShape = {
  BlendFunc_Rational: {};
  BlendFunc_QuasiAngular: {};
  BlendFunc_Polynomial: {};
  BlendFunc_Linear: {};
}

export declare class BlendFunc_Chamfer extends BlendFunc_GenChamfer {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, CG: Handle_Adaptor3d_HCurve)
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  Set_2(Dist1: Quantity_AbsorbedDose, Dist2: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  GetSectionSize(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BlendFunc_ConstThroatInv extends BlendFunc_GenChamfInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  Set_2(theThroat: Quantity_AbsorbedDose, a1: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc {
  constructor();
  static GetShape(SectShape: BlendFunc_SectionShape, MaxAng: Quantity_AbsorbedDose, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, TypeConv: Convert_ParameterisationType): void;
  static GetMinimalWeights(SectShape: BlendFunc_SectionShape, TConv: Convert_ParameterisationType, AngleMin: Quantity_AbsorbedDose, AngleMax: Quantity_AbsorbedDose, Weigths: TColStd_Array1OfReal): void;
  static NextShape(S: GeomAbs_Shape): GeomAbs_Shape;
  static ComputeNormal(Surf: Handle_Adaptor3d_HSurface, p2d: gp_Pnt2d, Normal: gp_Vec): Standard_Boolean;
  static ComputeDNormal(Surf: Handle_Adaptor3d_HSurface, p2d: gp_Pnt2d, Normal: gp_Vec, DNu: gp_Vec, DNv: gp_Vec): Standard_Boolean;
  delete(): void;
}

export declare class BlendFunc_CSCircular extends Blend_CSFunction {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, CGuide: Handle_Adaptor3d_HCurve, L: Handle_Law_Function)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  PointOnS(): gp_Pnt;
  PointOnC(): gp_Pnt;
  Pnt2d(): gp_Pnt2d;
  ParameterOnC(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2d(): gp_Vec2d;
  TangentOnC(): gp_Vec;
  Tangent(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, TgS: gp_Vec, NormS: gp_Vec): void;
  Set_3(Radius: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  Set_4(TypeSection: BlendFunc_SectionShape): void;
  Section_1(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  GetSection(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, tabP: TColgp_Array1OfPnt, tabV: TColgp_Array1OfVec): Standard_Boolean;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BlendFunc_Tensor {
  constructor(NbRow: Graphic3d_ZLayerId, NbCol: Graphic3d_ZLayerId, NbMat: Graphic3d_ZLayerId)
  Init(InitialValue: Quantity_AbsorbedDose): void;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Mat: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Mat: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Multiply(Right: math_Vector, Product: math_Matrix): void;
  delete(): void;
}

export declare class BlendFunc_Corde {
  constructor(S: Handle_Adaptor3d_HSurface, CGuide: Handle_Adaptor3d_HCurve)
  SetParam(Param: Quantity_AbsorbedDose): void;
  SetDist(Dist: Quantity_AbsorbedDose): void;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  PointOnS(): gp_Pnt;
  PointOnGuide(): gp_Pnt;
  NPlan(): gp_Vec;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2dOnS(): gp_Vec2d;
  DerFguide(Sol: math_Vector, DerF: gp_Vec2d): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BlendFunc_ConstRadInv extends Blend_FuncInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  Set_1(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(R: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc_EvolRadInv extends Blend_FuncInv {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, Law: Handle_Law_Function)
  Set_1(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(Choix: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BlendFunc_CSConstRad extends Blend_CSFunction {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, CGuide: Handle_Adaptor3d_HCurve)
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  PointOnS(): gp_Pnt;
  PointOnC(): gp_Pnt;
  Pnt2d(): gp_Pnt2d;
  ParameterOnC(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2d(): gp_Vec2d;
  TangentOnC(): gp_Vec;
  Tangent(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, TgS: gp_Vec, NormS: gp_Vec): void;
  Set_3(Radius: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  Set_4(TypeSection: BlendFunc_SectionShape): void;
  Section_1(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  GetSection(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, tabP: TColgp_Array1OfPnt, tabV: TColgp_Array1OfVec): Standard_Boolean;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_StepDimTol_RunoutZoneDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_RunoutZoneDefinition): void;
  get(): StepDimTol_RunoutZoneDefinition;
  delete(): void;
}

  export declare class Handle_StepDimTol_RunoutZoneDefinition_1 extends Handle_StepDimTol_RunoutZoneDefinition {
    constructor();
  }

  export declare class Handle_StepDimTol_RunoutZoneDefinition_2 extends Handle_StepDimTol_RunoutZoneDefinition {
    constructor(thePtr: StepDimTol_RunoutZoneDefinition);
  }

  export declare class Handle_StepDimTol_RunoutZoneDefinition_3 extends Handle_StepDimTol_RunoutZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_RunoutZoneDefinition);
  }

  export declare class Handle_StepDimTol_RunoutZoneDefinition_4 extends Handle_StepDimTol_RunoutZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_RunoutZoneDefinition);
  }

export declare class StepDimTol_RunoutZoneDefinition extends StepDimTol_ToleranceZoneDefinition {
  constructor()
  Init(theZone: Handle_StepDimTol_ToleranceZone, theBoundaries: Handle_StepRepr_HArray1OfShapeAspect, theOrientation: Handle_StepDimTol_RunoutZoneOrientation): void;
  Orientation(): Handle_StepDimTol_RunoutZoneOrientation;
  SetOrientation(theOrientation: Handle_StepDimTol_RunoutZoneOrientation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_CommonDatum extends StepRepr_CompositeShapeAspect {
  constructor()
  Init(theShapeAspect_Name: Handle_TCollection_HAsciiString, theShapeAspect_Description: Handle_TCollection_HAsciiString, theShapeAspect_OfShape: Handle_StepRepr_ProductDefinitionShape, theShapeAspect_ProductDefinitional: StepData_Logical, theDatum_Name: Handle_TCollection_HAsciiString, theDatum_Description: Handle_TCollection_HAsciiString, theDatum_OfShape: Handle_StepRepr_ProductDefinitionShape, theDatum_ProductDefinitional: StepData_Logical, theDatum_Identification: Handle_TCollection_HAsciiString): void;
  Datum(): Handle_StepDimTol_Datum;
  SetDatum(theDatum: Handle_StepDimTol_Datum): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_CommonDatum {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_CommonDatum): void;
  get(): StepDimTol_CommonDatum;
  delete(): void;
}

  export declare class Handle_StepDimTol_CommonDatum_1 extends Handle_StepDimTol_CommonDatum {
    constructor();
  }

  export declare class Handle_StepDimTol_CommonDatum_2 extends Handle_StepDimTol_CommonDatum {
    constructor(thePtr: StepDimTol_CommonDatum);
  }

  export declare class Handle_StepDimTol_CommonDatum_3 extends Handle_StepDimTol_CommonDatum {
    constructor(theHandle: Handle_StepDimTol_CommonDatum);
  }

  export declare class Handle_StepDimTol_CommonDatum_4 extends Handle_StepDimTol_CommonDatum {
    constructor(theHandle: Handle_StepDimTol_CommonDatum);
  }

export declare class StepDimTol_ToleranceZoneDefinition extends Standard_Transient {
  constructor()
  Init(theZone: Handle_StepDimTol_ToleranceZone, theBoundaries: Handle_StepRepr_HArray1OfShapeAspect): void;
  Boundaries(): Handle_StepRepr_HArray1OfShapeAspect;
  SetBoundaries(theBoundaries: Handle_StepRepr_HArray1OfShapeAspect): void;
  NbBoundaries(): Graphic3d_ZLayerId;
  BoundariesValue(theNum: Graphic3d_ZLayerId): Handle_StepRepr_ShapeAspect;
  SetBoundariesValue(theNum: Graphic3d_ZLayerId, theItem: Handle_StepRepr_ShapeAspect): void;
  Zone(): Handle_StepDimTol_ToleranceZone;
  SetZone(theZone: Handle_StepDimTol_ToleranceZone): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_ToleranceZoneDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ToleranceZoneDefinition): void;
  get(): StepDimTol_ToleranceZoneDefinition;
  delete(): void;
}

  export declare class Handle_StepDimTol_ToleranceZoneDefinition_1 extends Handle_StepDimTol_ToleranceZoneDefinition {
    constructor();
  }

  export declare class Handle_StepDimTol_ToleranceZoneDefinition_2 extends Handle_StepDimTol_ToleranceZoneDefinition {
    constructor(thePtr: StepDimTol_ToleranceZoneDefinition);
  }

  export declare class Handle_StepDimTol_ToleranceZoneDefinition_3 extends Handle_StepDimTol_ToleranceZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_ToleranceZoneDefinition);
  }

  export declare class Handle_StepDimTol_ToleranceZoneDefinition_4 extends Handle_StepDimTol_ToleranceZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_ToleranceZoneDefinition);
  }

export declare class Handle_StepDimTol_HArray1OfDatumReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfDatumReference): void;
  get(): StepDimTol_HArray1OfDatumReference;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfDatumReference_1 extends Handle_StepDimTol_HArray1OfDatumReference {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReference_2 extends Handle_StepDimTol_HArray1OfDatumReference {
    constructor(thePtr: StepDimTol_HArray1OfDatumReference);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReference_3 extends Handle_StepDimTol_HArray1OfDatumReference {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReference);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReference_4 extends Handle_StepDimTol_HArray1OfDatumReference {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReference);
  }

export declare class StepDimTol_PlacedDatumTargetFeature extends StepDimTol_DatumTarget {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_PlacedDatumTargetFeature {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_PlacedDatumTargetFeature): void;
  get(): StepDimTol_PlacedDatumTargetFeature;
  delete(): void;
}

  export declare class Handle_StepDimTol_PlacedDatumTargetFeature_1 extends Handle_StepDimTol_PlacedDatumTargetFeature {
    constructor();
  }

  export declare class Handle_StepDimTol_PlacedDatumTargetFeature_2 extends Handle_StepDimTol_PlacedDatumTargetFeature {
    constructor(thePtr: StepDimTol_PlacedDatumTargetFeature);
  }

  export declare class Handle_StepDimTol_PlacedDatumTargetFeature_3 extends Handle_StepDimTol_PlacedDatumTargetFeature {
    constructor(theHandle: Handle_StepDimTol_PlacedDatumTargetFeature);
  }

  export declare class Handle_StepDimTol_PlacedDatumTargetFeature_4 extends Handle_StepDimTol_PlacedDatumTargetFeature {
    constructor(theHandle: Handle_StepDimTol_PlacedDatumTargetFeature);
  }

export declare class Handle_StepDimTol_HArray1OfDatumSystemOrReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfDatumSystemOrReference): void;
  get(): StepDimTol_HArray1OfDatumSystemOrReference;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfDatumSystemOrReference_1 extends Handle_StepDimTol_HArray1OfDatumSystemOrReference {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfDatumSystemOrReference_2 extends Handle_StepDimTol_HArray1OfDatumSystemOrReference {
    constructor(thePtr: StepDimTol_HArray1OfDatumSystemOrReference);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumSystemOrReference_3 extends Handle_StepDimTol_HArray1OfDatumSystemOrReference {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumSystemOrReference);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumSystemOrReference_4 extends Handle_StepDimTol_HArray1OfDatumSystemOrReference {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumSystemOrReference);
  }

export declare class StepDimTol_ToleranceZone extends StepRepr_ShapeAspect {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theOfShape: Handle_StepRepr_ProductDefinitionShape, theProductDefinitional: StepData_Logical, theDefiningTolerance: Handle_StepDimTol_HArray1OfToleranceZoneTarget, theForm: Handle_StepDimTol_ToleranceZoneForm): void;
  DefiningTolerance(): Handle_StepDimTol_HArray1OfToleranceZoneTarget;
  SetDefiningTolerance(theDefiningTolerance: Handle_StepDimTol_HArray1OfToleranceZoneTarget): void;
  NbDefiningTolerances(): Graphic3d_ZLayerId;
  DefiningToleranceValue(theNum: Graphic3d_ZLayerId): StepDimTol_ToleranceZoneTarget;
  SetDefiningToleranceValue(theNum: Graphic3d_ZLayerId, theItem: StepDimTol_ToleranceZoneTarget): void;
  Form(): Handle_StepDimTol_ToleranceZoneForm;
  SetForm(theForm: Handle_StepDimTol_ToleranceZoneForm): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_ToleranceZone {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ToleranceZone): void;
  get(): StepDimTol_ToleranceZone;
  delete(): void;
}

  export declare class Handle_StepDimTol_ToleranceZone_1 extends Handle_StepDimTol_ToleranceZone {
    constructor();
  }

  export declare class Handle_StepDimTol_ToleranceZone_2 extends Handle_StepDimTol_ToleranceZone {
    constructor(thePtr: StepDimTol_ToleranceZone);
  }

  export declare class Handle_StepDimTol_ToleranceZone_3 extends Handle_StepDimTol_ToleranceZone {
    constructor(theHandle: Handle_StepDimTol_ToleranceZone);
  }

  export declare class Handle_StepDimTol_ToleranceZone_4 extends Handle_StepDimTol_ToleranceZone {
    constructor(theHandle: Handle_StepDimTol_ToleranceZone);
  }

export declare class StepDimTol_GeometricToleranceRelationship extends Standard_Transient {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theRelatingGeometricTolerance: Handle_StepDimTol_GeometricTolerance, theRelatedGeometricTolerance: Handle_StepDimTol_GeometricTolerance): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(theName: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(theDescription: Handle_TCollection_HAsciiString): void;
  RelatingGeometricTolerance(): Handle_StepDimTol_GeometricTolerance;
  SetRelatingGeometricTolerance(theRelatingGeometricTolerance: Handle_StepDimTol_GeometricTolerance): void;
  RelatedGeometricTolerance(): Handle_StepDimTol_GeometricTolerance;
  SetRelatedGeometricTolerance(theRelatedGeometricTolerance: Handle_StepDimTol_GeometricTolerance): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeometricToleranceRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricToleranceRelationship): void;
  get(): StepDimTol_GeometricToleranceRelationship;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricToleranceRelationship_1 extends Handle_StepDimTol_GeometricToleranceRelationship {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricToleranceRelationship_2 extends Handle_StepDimTol_GeometricToleranceRelationship {
    constructor(thePtr: StepDimTol_GeometricToleranceRelationship);
  }

  export declare class Handle_StepDimTol_GeometricToleranceRelationship_3 extends Handle_StepDimTol_GeometricToleranceRelationship {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceRelationship);
  }

  export declare class Handle_StepDimTol_GeometricToleranceRelationship_4 extends Handle_StepDimTol_GeometricToleranceRelationship {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceRelationship);
  }

export declare class StepDimTol_Array1OfGeometricToleranceModifier {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepDimTol_GeometricToleranceModifier): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepDimTol_Array1OfGeometricToleranceModifier): StepDimTol_Array1OfGeometricToleranceModifier;
  Move(theOther: StepDimTol_Array1OfGeometricToleranceModifier): StepDimTol_Array1OfGeometricToleranceModifier;
  First(): StepDimTol_GeometricToleranceModifier;
  ChangeFirst(): StepDimTol_GeometricToleranceModifier;
  Last(): StepDimTol_GeometricToleranceModifier;
  ChangeLast(): StepDimTol_GeometricToleranceModifier;
  Value(theIndex: Standard_Integer): StepDimTol_GeometricToleranceModifier;
  ChangeValue(theIndex: Standard_Integer): StepDimTol_GeometricToleranceModifier;
  SetValue(theIndex: Standard_Integer, theItem: StepDimTol_GeometricToleranceModifier): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepDimTol_Array1OfGeometricToleranceModifier_1 extends StepDimTol_Array1OfGeometricToleranceModifier {
    constructor();
  }

  export declare class StepDimTol_Array1OfGeometricToleranceModifier_2 extends StepDimTol_Array1OfGeometricToleranceModifier {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepDimTol_Array1OfGeometricToleranceModifier_3 extends StepDimTol_Array1OfGeometricToleranceModifier {
    constructor(theOther: StepDimTol_Array1OfGeometricToleranceModifier);
  }

  export declare class StepDimTol_Array1OfGeometricToleranceModifier_4 extends StepDimTol_Array1OfGeometricToleranceModifier {
    constructor(theOther: StepDimTol_Array1OfGeometricToleranceModifier);
  }

  export declare class StepDimTol_Array1OfGeometricToleranceModifier_5 extends StepDimTol_Array1OfGeometricToleranceModifier {
    constructor(theBegin: StepDimTol_GeometricToleranceModifier, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepDimTol_HArray1OfToleranceZoneTarget {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfToleranceZoneTarget): void;
  get(): StepDimTol_HArray1OfToleranceZoneTarget;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfToleranceZoneTarget_1 extends Handle_StepDimTol_HArray1OfToleranceZoneTarget {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfToleranceZoneTarget_2 extends Handle_StepDimTol_HArray1OfToleranceZoneTarget {
    constructor(thePtr: StepDimTol_HArray1OfToleranceZoneTarget);
  }

  export declare class Handle_StepDimTol_HArray1OfToleranceZoneTarget_3 extends Handle_StepDimTol_HArray1OfToleranceZoneTarget {
    constructor(theHandle: Handle_StepDimTol_HArray1OfToleranceZoneTarget);
  }

  export declare class Handle_StepDimTol_HArray1OfToleranceZoneTarget_4 extends Handle_StepDimTol_HArray1OfToleranceZoneTarget {
    constructor(theHandle: Handle_StepDimTol_HArray1OfToleranceZoneTarget);
  }

export declare class StepDimTol_ToleranceZoneTarget extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DimensionalLocation(): Handle_StepShape_DimensionalLocation;
  DimensionalSize(): Handle_StepShape_DimensionalSize;
  GeometricTolerance(): Handle_StepDimTol_GeometricTolerance;
  GeneralDatumReference(): Handle_StepDimTol_GeneralDatumReference;
  delete(): void;
}

export declare class StepDimTol_LineProfileTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_LineProfileTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_LineProfileTolerance): void;
  get(): StepDimTol_LineProfileTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_LineProfileTolerance_1 extends Handle_StepDimTol_LineProfileTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_LineProfileTolerance_2 extends Handle_StepDimTol_LineProfileTolerance {
    constructor(thePtr: StepDimTol_LineProfileTolerance);
  }

  export declare class Handle_StepDimTol_LineProfileTolerance_3 extends Handle_StepDimTol_LineProfileTolerance {
    constructor(theHandle: Handle_StepDimTol_LineProfileTolerance);
  }

  export declare class Handle_StepDimTol_LineProfileTolerance_4 extends Handle_StepDimTol_LineProfileTolerance {
    constructor(theHandle: Handle_StepDimTol_LineProfileTolerance);
  }

export declare type StepDimTol_AreaUnitType = {
  StepDimTol_Circular: {};
  StepDimTol_Rectangular: {};
  StepDimTol_Square: {};
}

export declare class Handle_StepDimTol_ToleranceZoneForm {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ToleranceZoneForm): void;
  get(): StepDimTol_ToleranceZoneForm;
  delete(): void;
}

  export declare class Handle_StepDimTol_ToleranceZoneForm_1 extends Handle_StepDimTol_ToleranceZoneForm {
    constructor();
  }

  export declare class Handle_StepDimTol_ToleranceZoneForm_2 extends Handle_StepDimTol_ToleranceZoneForm {
    constructor(thePtr: StepDimTol_ToleranceZoneForm);
  }

  export declare class Handle_StepDimTol_ToleranceZoneForm_3 extends Handle_StepDimTol_ToleranceZoneForm {
    constructor(theHandle: Handle_StepDimTol_ToleranceZoneForm);
  }

  export declare class Handle_StepDimTol_ToleranceZoneForm_4 extends Handle_StepDimTol_ToleranceZoneForm {
    constructor(theHandle: Handle_StepDimTol_ToleranceZoneForm);
  }

export declare class StepDimTol_ToleranceZoneForm extends Standard_Transient {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(theName: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_StraightnessTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_StraightnessTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_StraightnessTolerance): void;
  get(): StepDimTol_StraightnessTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_StraightnessTolerance_1 extends Handle_StepDimTol_StraightnessTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_StraightnessTolerance_2 extends Handle_StepDimTol_StraightnessTolerance {
    constructor(thePtr: StepDimTol_StraightnessTolerance);
  }

  export declare class Handle_StepDimTol_StraightnessTolerance_3 extends Handle_StepDimTol_StraightnessTolerance {
    constructor(theHandle: Handle_StepDimTol_StraightnessTolerance);
  }

  export declare class Handle_StepDimTol_StraightnessTolerance_4 extends Handle_StepDimTol_StraightnessTolerance {
    constructor(theHandle: Handle_StepDimTol_StraightnessTolerance);
  }

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthMaxTol): void;
  get(): StepDimTol_GeoTolAndGeoTolWthMaxTol;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthMaxTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol);
  }

export declare class StepDimTol_GeoTolAndGeoTolWthMaxTol extends StepDimTol_GeoTolAndGeoTolWthMod {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theMaxTol: Handle_StepBasic_LengthMeasureWithUnit, theType: StepDimTol_GeometricToleranceType): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theMaxTol: Handle_StepBasic_LengthMeasureWithUnit, theType: StepDimTol_GeometricToleranceType): void;
  SetMaxTolerance(theMaxTol: Handle_StepBasic_LengthMeasureWithUnit): void;
  GetMaxTolerance(): Handle_StepBasic_LengthMeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_ModifiedGeometricTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(theGeometricTolerance_Name: Handle_TCollection_HAsciiString, theGeometricTolerance_Description: Handle_TCollection_HAsciiString, theGeometricTolerance_Magnitude: Handle_StepBasic_MeasureWithUnit, theGeometricTolerance_TolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theModifier: StepDimTol_LimitCondition): void;
  Init_2(theGeometricTolerance_Name: Handle_TCollection_HAsciiString, theGeometricTolerance_Description: Handle_TCollection_HAsciiString, theGeometricTolerance_Magnitude: Handle_StepBasic_MeasureWithUnit, theGeometricTolerance_TolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theModifier: StepDimTol_LimitCondition): void;
  Modifier(): StepDimTol_LimitCondition;
  SetModifier(theModifier: StepDimTol_LimitCondition): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_ModifiedGeometricTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ModifiedGeometricTolerance): void;
  get(): StepDimTol_ModifiedGeometricTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_ModifiedGeometricTolerance_1 extends Handle_StepDimTol_ModifiedGeometricTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_ModifiedGeometricTolerance_2 extends Handle_StepDimTol_ModifiedGeometricTolerance {
    constructor(thePtr: StepDimTol_ModifiedGeometricTolerance);
  }

  export declare class Handle_StepDimTol_ModifiedGeometricTolerance_3 extends Handle_StepDimTol_ModifiedGeometricTolerance {
    constructor(theHandle: Handle_StepDimTol_ModifiedGeometricTolerance);
  }

  export declare class Handle_StepDimTol_ModifiedGeometricTolerance_4 extends Handle_StepDimTol_ModifiedGeometricTolerance {
    constructor(theHandle: Handle_StepDimTol_ModifiedGeometricTolerance);
  }

export declare class StepDimTol_Array1OfToleranceZoneTarget {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepDimTol_ToleranceZoneTarget): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepDimTol_Array1OfToleranceZoneTarget): StepDimTol_Array1OfToleranceZoneTarget;
  Move(theOther: StepDimTol_Array1OfToleranceZoneTarget): StepDimTol_Array1OfToleranceZoneTarget;
  First(): StepDimTol_ToleranceZoneTarget;
  ChangeFirst(): StepDimTol_ToleranceZoneTarget;
  Last(): StepDimTol_ToleranceZoneTarget;
  ChangeLast(): StepDimTol_ToleranceZoneTarget;
  Value(theIndex: Standard_Integer): StepDimTol_ToleranceZoneTarget;
  ChangeValue(theIndex: Standard_Integer): StepDimTol_ToleranceZoneTarget;
  SetValue(theIndex: Standard_Integer, theItem: StepDimTol_ToleranceZoneTarget): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepDimTol_Array1OfToleranceZoneTarget_1 extends StepDimTol_Array1OfToleranceZoneTarget {
    constructor();
  }

  export declare class StepDimTol_Array1OfToleranceZoneTarget_2 extends StepDimTol_Array1OfToleranceZoneTarget {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepDimTol_Array1OfToleranceZoneTarget_3 extends StepDimTol_Array1OfToleranceZoneTarget {
    constructor(theOther: StepDimTol_Array1OfToleranceZoneTarget);
  }

  export declare class StepDimTol_Array1OfToleranceZoneTarget_4 extends StepDimTol_Array1OfToleranceZoneTarget {
    constructor(theOther: StepDimTol_Array1OfToleranceZoneTarget);
  }

  export declare class StepDimTol_Array1OfToleranceZoneTarget_5 extends StepDimTol_Array1OfToleranceZoneTarget {
    constructor(theBegin: StepDimTol_ToleranceZoneTarget, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepDimTol_UnequallyDisposedGeometricTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theDisplacement: Handle_StepBasic_LengthMeasureWithUnit): void;
  Displacement(): Handle_StepBasic_LengthMeasureWithUnit;
  SetDisplacement(theDisplacement: Handle_StepBasic_LengthMeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_UnequallyDisposedGeometricTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_UnequallyDisposedGeometricTolerance): void;
  get(): StepDimTol_UnequallyDisposedGeometricTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_UnequallyDisposedGeometricTolerance_1 extends Handle_StepDimTol_UnequallyDisposedGeometricTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_UnequallyDisposedGeometricTolerance_2 extends Handle_StepDimTol_UnequallyDisposedGeometricTolerance {
    constructor(thePtr: StepDimTol_UnequallyDisposedGeometricTolerance);
  }

  export declare class Handle_StepDimTol_UnequallyDisposedGeometricTolerance_3 extends Handle_StepDimTol_UnequallyDisposedGeometricTolerance {
    constructor(theHandle: Handle_StepDimTol_UnequallyDisposedGeometricTolerance);
  }

  export declare class Handle_StepDimTol_UnequallyDisposedGeometricTolerance_4 extends Handle_StepDimTol_UnequallyDisposedGeometricTolerance {
    constructor(theHandle: Handle_StepDimTol_UnequallyDisposedGeometricTolerance);
  }

export declare class StepDimTol_Array1OfDatumReferenceModifier {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepDimTol_DatumReferenceModifier): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepDimTol_Array1OfDatumReferenceModifier): StepDimTol_Array1OfDatumReferenceModifier;
  Move(theOther: StepDimTol_Array1OfDatumReferenceModifier): StepDimTol_Array1OfDatumReferenceModifier;
  First(): StepDimTol_DatumReferenceModifier;
  ChangeFirst(): StepDimTol_DatumReferenceModifier;
  Last(): StepDimTol_DatumReferenceModifier;
  ChangeLast(): StepDimTol_DatumReferenceModifier;
  Value(theIndex: Standard_Integer): StepDimTol_DatumReferenceModifier;
  ChangeValue(theIndex: Standard_Integer): StepDimTol_DatumReferenceModifier;
  SetValue(theIndex: Standard_Integer, theItem: StepDimTol_DatumReferenceModifier): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepDimTol_Array1OfDatumReferenceModifier_1 extends StepDimTol_Array1OfDatumReferenceModifier {
    constructor();
  }

  export declare class StepDimTol_Array1OfDatumReferenceModifier_2 extends StepDimTol_Array1OfDatumReferenceModifier {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepDimTol_Array1OfDatumReferenceModifier_3 extends StepDimTol_Array1OfDatumReferenceModifier {
    constructor(theOther: StepDimTol_Array1OfDatumReferenceModifier);
  }

  export declare class StepDimTol_Array1OfDatumReferenceModifier_4 extends StepDimTol_Array1OfDatumReferenceModifier {
    constructor(theOther: StepDimTol_Array1OfDatumReferenceModifier);
  }

  export declare class StepDimTol_Array1OfDatumReferenceModifier_5 extends StepDimTol_Array1OfDatumReferenceModifier {
    constructor(theBegin: StepDimTol_DatumReferenceModifier, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepDimTol_RunoutZoneOrientation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_RunoutZoneOrientation): void;
  get(): StepDimTol_RunoutZoneOrientation;
  delete(): void;
}

  export declare class Handle_StepDimTol_RunoutZoneOrientation_1 extends Handle_StepDimTol_RunoutZoneOrientation {
    constructor();
  }

  export declare class Handle_StepDimTol_RunoutZoneOrientation_2 extends Handle_StepDimTol_RunoutZoneOrientation {
    constructor(thePtr: StepDimTol_RunoutZoneOrientation);
  }

  export declare class Handle_StepDimTol_RunoutZoneOrientation_3 extends Handle_StepDimTol_RunoutZoneOrientation {
    constructor(theHandle: Handle_StepDimTol_RunoutZoneOrientation);
  }

  export declare class Handle_StepDimTol_RunoutZoneOrientation_4 extends Handle_StepDimTol_RunoutZoneOrientation {
    constructor(theHandle: Handle_StepDimTol_RunoutZoneOrientation);
  }

export declare class StepDimTol_RunoutZoneOrientation extends Standard_Transient {
  constructor()
  Init(theAngle: Handle_StepBasic_PlaneAngleMeasureWithUnit): void;
  Angle(): Handle_StepBasic_PlaneAngleMeasureWithUnit;
  SetAngle(theAngle: Handle_StepBasic_PlaneAngleMeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_HArray1OfDatumReferenceModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfDatumReferenceModifier): void;
  get(): StepDimTol_HArray1OfDatumReferenceModifier;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceModifier_1 extends Handle_StepDimTol_HArray1OfDatumReferenceModifier {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceModifier_2 extends Handle_StepDimTol_HArray1OfDatumReferenceModifier {
    constructor(thePtr: StepDimTol_HArray1OfDatumReferenceModifier);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceModifier_3 extends Handle_StepDimTol_HArray1OfDatumReferenceModifier {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReferenceModifier);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceModifier_4 extends Handle_StepDimTol_HArray1OfDatumReferenceModifier {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReferenceModifier);
  }

export declare class Handle_StepDimTol_DatumReferenceModifierWithValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumReferenceModifierWithValue): void;
  get(): StepDimTol_DatumReferenceModifierWithValue;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumReferenceModifierWithValue_1 extends Handle_StepDimTol_DatumReferenceModifierWithValue {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumReferenceModifierWithValue_2 extends Handle_StepDimTol_DatumReferenceModifierWithValue {
    constructor(thePtr: StepDimTol_DatumReferenceModifierWithValue);
  }

  export declare class Handle_StepDimTol_DatumReferenceModifierWithValue_3 extends Handle_StepDimTol_DatumReferenceModifierWithValue {
    constructor(theHandle: Handle_StepDimTol_DatumReferenceModifierWithValue);
  }

  export declare class Handle_StepDimTol_DatumReferenceModifierWithValue_4 extends Handle_StepDimTol_DatumReferenceModifierWithValue {
    constructor(theHandle: Handle_StepDimTol_DatumReferenceModifierWithValue);
  }

export declare class StepDimTol_DatumReferenceModifierWithValue extends Standard_Transient {
  constructor()
  Init(theModifierType: StepDimTol_DatumReferenceModifierType, theModifierValue: Handle_StepBasic_LengthMeasureWithUnit): void;
  ModifierType(): StepDimTol_DatumReferenceModifierType;
  SetModifierType(theModifierType: StepDimTol_DatumReferenceModifierType): void;
  ModifierValue(): Handle_StepBasic_LengthMeasureWithUnit;
  SetModifierValue(theModifierValue: Handle_StepBasic_LengthMeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_DatumFeature extends StepRepr_ShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_DatumFeature {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumFeature): void;
  get(): StepDimTol_DatumFeature;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumFeature_1 extends Handle_StepDimTol_DatumFeature {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumFeature_2 extends Handle_StepDimTol_DatumFeature {
    constructor(thePtr: StepDimTol_DatumFeature);
  }

  export declare class Handle_StepDimTol_DatumFeature_3 extends Handle_StepDimTol_DatumFeature {
    constructor(theHandle: Handle_StepDimTol_DatumFeature);
  }

  export declare class Handle_StepDimTol_DatumFeature_4 extends Handle_StepDimTol_DatumFeature {
    constructor(theHandle: Handle_StepDimTol_DatumFeature);
  }

export declare class StepDimTol_GeometricTolerance extends Standard_Transient {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect): void;
  Init_2(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(theName: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(theDescription: Handle_TCollection_HAsciiString): void;
  Magnitude(): Handle_StepBasic_MeasureWithUnit;
  SetMagnitude(theMagnitude: Handle_StepBasic_MeasureWithUnit): void;
  TolerancedShapeAspect(): StepDimTol_GeometricToleranceTarget;
  SetTolerancedShapeAspect_1(theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect): void;
  SetTolerancedShapeAspect_2(theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeometricTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricTolerance): void;
  get(): StepDimTol_GeometricTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricTolerance_1 extends Handle_StepDimTol_GeometricTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricTolerance_2 extends Handle_StepDimTol_GeometricTolerance {
    constructor(thePtr: StepDimTol_GeometricTolerance);
  }

  export declare class Handle_StepDimTol_GeometricTolerance_3 extends Handle_StepDimTol_GeometricTolerance {
    constructor(theHandle: Handle_StepDimTol_GeometricTolerance);
  }

  export declare class Handle_StepDimTol_GeometricTolerance_4 extends Handle_StepDimTol_GeometricTolerance {
    constructor(theHandle: Handle_StepDimTol_GeometricTolerance);
  }

export declare class Handle_StepDimTol_GeometricToleranceWithMaximumTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricToleranceWithMaximumTolerance): void;
  get(): StepDimTol_GeometricToleranceWithMaximumTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_1 extends Handle_StepDimTol_GeometricToleranceWithMaximumTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_2 extends Handle_StepDimTol_GeometricToleranceWithMaximumTolerance {
    constructor(thePtr: StepDimTol_GeometricToleranceWithMaximumTolerance);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_3 extends Handle_StepDimTol_GeometricToleranceWithMaximumTolerance {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithMaximumTolerance);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_4 extends Handle_StepDimTol_GeometricToleranceWithMaximumTolerance {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithMaximumTolerance);
  }

export declare class StepDimTol_GeometricToleranceWithMaximumTolerance extends StepDimTol_GeometricToleranceWithModifiers {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theModifiers: Handle_StepDimTol_HArray1OfGeometricToleranceModifier, theUnitSize: Handle_StepBasic_LengthMeasureWithUnit): void;
  MaximumUpperTolerance(): Handle_StepBasic_LengthMeasureWithUnit;
  SetMaximumUpperTolerance(theMaximumUpperTolerance: Handle_StepBasic_LengthMeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_SimpleDatumReferenceModifierMember extends StepData_SelectInt {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(a0: Standard_CString): Standard_Boolean;
  Kind(): Graphic3d_ZLayerId;
  EnumText(): Standard_CString;
  SetEnumText(theValue: Graphic3d_ZLayerId, theText: Standard_CString): void;
  SetValue(theValue: StepDimTol_SimpleDatumReferenceModifier): void;
  Value(): StepDimTol_SimpleDatumReferenceModifier;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_SimpleDatumReferenceModifierMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_SimpleDatumReferenceModifierMember): void;
  get(): StepDimTol_SimpleDatumReferenceModifierMember;
  delete(): void;
}

  export declare class Handle_StepDimTol_SimpleDatumReferenceModifierMember_1 extends Handle_StepDimTol_SimpleDatumReferenceModifierMember {
    constructor();
  }

  export declare class Handle_StepDimTol_SimpleDatumReferenceModifierMember_2 extends Handle_StepDimTol_SimpleDatumReferenceModifierMember {
    constructor(thePtr: StepDimTol_SimpleDatumReferenceModifierMember);
  }

  export declare class Handle_StepDimTol_SimpleDatumReferenceModifierMember_3 extends Handle_StepDimTol_SimpleDatumReferenceModifierMember {
    constructor(theHandle: Handle_StepDimTol_SimpleDatumReferenceModifierMember);
  }

  export declare class Handle_StepDimTol_SimpleDatumReferenceModifierMember_4 extends Handle_StepDimTol_SimpleDatumReferenceModifierMember {
    constructor(theHandle: Handle_StepDimTol_SimpleDatumReferenceModifierMember);
  }

export declare class Handle_StepDimTol_HArray1OfGeometricToleranceModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfGeometricToleranceModifier): void;
  get(): StepDimTol_HArray1OfGeometricToleranceModifier;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfGeometricToleranceModifier_1 extends Handle_StepDimTol_HArray1OfGeometricToleranceModifier {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfGeometricToleranceModifier_2 extends Handle_StepDimTol_HArray1OfGeometricToleranceModifier {
    constructor(thePtr: StepDimTol_HArray1OfGeometricToleranceModifier);
  }

  export declare class Handle_StepDimTol_HArray1OfGeometricToleranceModifier_3 extends Handle_StepDimTol_HArray1OfGeometricToleranceModifier {
    constructor(theHandle: Handle_StepDimTol_HArray1OfGeometricToleranceModifier);
  }

  export declare class Handle_StepDimTol_HArray1OfGeometricToleranceModifier_4 extends Handle_StepDimTol_HArray1OfGeometricToleranceModifier {
    constructor(theHandle: Handle_StepDimTol_HArray1OfGeometricToleranceModifier);
  }

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRef): void;
  get(): StepDimTol_GeoTolAndGeoTolWthDatRef;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRef {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRef {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRef);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRef {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRef);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRef {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRef);
  }

export declare class StepDimTol_GeoTolAndGeoTolWthDatRef extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, theType: StepDimTol_GeometricToleranceType): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, theType: StepDimTol_GeometricToleranceType): void;
  SetGeometricToleranceWithDatumReference(theGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference): void;
  GetGeometricToleranceWithDatumReference(): Handle_StepDimTol_GeometricToleranceWithDatumReference;
  SetGeometricToleranceType(theType: StepDimTol_GeometricToleranceType): void;
  GetToleranceType(): StepDimTol_GeometricToleranceType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_NonUniformZoneDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_NonUniformZoneDefinition): void;
  get(): StepDimTol_NonUniformZoneDefinition;
  delete(): void;
}

  export declare class Handle_StepDimTol_NonUniformZoneDefinition_1 extends Handle_StepDimTol_NonUniformZoneDefinition {
    constructor();
  }

  export declare class Handle_StepDimTol_NonUniformZoneDefinition_2 extends Handle_StepDimTol_NonUniformZoneDefinition {
    constructor(thePtr: StepDimTol_NonUniformZoneDefinition);
  }

  export declare class Handle_StepDimTol_NonUniformZoneDefinition_3 extends Handle_StepDimTol_NonUniformZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_NonUniformZoneDefinition);
  }

  export declare class Handle_StepDimTol_NonUniformZoneDefinition_4 extends Handle_StepDimTol_NonUniformZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_NonUniformZoneDefinition);
  }

export declare class StepDimTol_NonUniformZoneDefinition extends StepDimTol_ToleranceZoneDefinition {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_PerpendicularityTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_PerpendicularityTolerance): void;
  get(): StepDimTol_PerpendicularityTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_PerpendicularityTolerance_1 extends Handle_StepDimTol_PerpendicularityTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_PerpendicularityTolerance_2 extends Handle_StepDimTol_PerpendicularityTolerance {
    constructor(thePtr: StepDimTol_PerpendicularityTolerance);
  }

  export declare class Handle_StepDimTol_PerpendicularityTolerance_3 extends Handle_StepDimTol_PerpendicularityTolerance {
    constructor(theHandle: Handle_StepDimTol_PerpendicularityTolerance);
  }

  export declare class Handle_StepDimTol_PerpendicularityTolerance_4 extends Handle_StepDimTol_PerpendicularityTolerance {
    constructor(theHandle: Handle_StepDimTol_PerpendicularityTolerance);
  }

export declare class StepDimTol_PerpendicularityTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol extends StepDimTol_GeoTolAndGeoTolWthDatRef {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, theType: StepDimTol_GeometricToleranceType, theUDGT: Handle_StepDimTol_UnequallyDisposedGeometricTolerance): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, theType: StepDimTol_GeometricToleranceType, theUDGT: Handle_StepDimTol_UnequallyDisposedGeometricTolerance): void;
  SetUnequallyDisposedGeometricTolerance(theUDGT: Handle_StepDimTol_UnequallyDisposedGeometricTolerance): void;
  GetUnequallyDisposedGeometricTolerance(): Handle_StepDimTol_UnequallyDisposedGeometricTolerance;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol): void;
  get(): StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol);
  }

export declare class Handle_StepDimTol_TotalRunoutTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_TotalRunoutTolerance): void;
  get(): StepDimTol_TotalRunoutTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_TotalRunoutTolerance_1 extends Handle_StepDimTol_TotalRunoutTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_TotalRunoutTolerance_2 extends Handle_StepDimTol_TotalRunoutTolerance {
    constructor(thePtr: StepDimTol_TotalRunoutTolerance);
  }

  export declare class Handle_StepDimTol_TotalRunoutTolerance_3 extends Handle_StepDimTol_TotalRunoutTolerance {
    constructor(theHandle: Handle_StepDimTol_TotalRunoutTolerance);
  }

  export declare class Handle_StepDimTol_TotalRunoutTolerance_4 extends Handle_StepDimTol_TotalRunoutTolerance {
    constructor(theHandle: Handle_StepDimTol_TotalRunoutTolerance);
  }

export declare class StepDimTol_TotalRunoutTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_ParallelismTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ParallelismTolerance): void;
  get(): StepDimTol_ParallelismTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_ParallelismTolerance_1 extends Handle_StepDimTol_ParallelismTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_ParallelismTolerance_2 extends Handle_StepDimTol_ParallelismTolerance {
    constructor(thePtr: StepDimTol_ParallelismTolerance);
  }

  export declare class Handle_StepDimTol_ParallelismTolerance_3 extends Handle_StepDimTol_ParallelismTolerance {
    constructor(theHandle: Handle_StepDimTol_ParallelismTolerance);
  }

  export declare class Handle_StepDimTol_ParallelismTolerance_4 extends Handle_StepDimTol_ParallelismTolerance {
    constructor(theHandle: Handle_StepDimTol_ParallelismTolerance);
  }

export declare class StepDimTol_ParallelismTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_ProjectedZoneDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ProjectedZoneDefinition): void;
  get(): StepDimTol_ProjectedZoneDefinition;
  delete(): void;
}

  export declare class Handle_StepDimTol_ProjectedZoneDefinition_1 extends Handle_StepDimTol_ProjectedZoneDefinition {
    constructor();
  }

  export declare class Handle_StepDimTol_ProjectedZoneDefinition_2 extends Handle_StepDimTol_ProjectedZoneDefinition {
    constructor(thePtr: StepDimTol_ProjectedZoneDefinition);
  }

  export declare class Handle_StepDimTol_ProjectedZoneDefinition_3 extends Handle_StepDimTol_ProjectedZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_ProjectedZoneDefinition);
  }

  export declare class Handle_StepDimTol_ProjectedZoneDefinition_4 extends Handle_StepDimTol_ProjectedZoneDefinition {
    constructor(theHandle: Handle_StepDimTol_ProjectedZoneDefinition);
  }

export declare class StepDimTol_ProjectedZoneDefinition extends StepDimTol_ToleranceZoneDefinition {
  constructor()
  Init(theZone: Handle_StepDimTol_ToleranceZone, theBoundaries: Handle_StepRepr_HArray1OfShapeAspect, theProjectionEnd: Handle_StepRepr_ShapeAspect, theProjectionLength: Handle_StepBasic_LengthMeasureWithUnit): void;
  ProjectionEnd(): Handle_StepRepr_ShapeAspect;
  SetProjectionEnd(theProjectionEnd: Handle_StepRepr_ShapeAspect): void;
  ProjectionLength(): Handle_StepBasic_LengthMeasureWithUnit;
  SetProjectionLength(theProjectionLength: Handle_StepBasic_LengthMeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMod {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthMod): void;
  get(): StepDimTol_GeoTolAndGeoTolWthMod;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMod_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthMod {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMod_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthMod {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthMod);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMod_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthMod {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthMod);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthMod_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthMod {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthMod);
  }

export declare class StepDimTol_GeoTolAndGeoTolWthMod extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theType: StepDimTol_GeometricToleranceType): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theType: StepDimTol_GeometricToleranceType): void;
  SetGeometricToleranceWithModifiers(theGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers): void;
  GetGeometricToleranceWithModifiers(): Handle_StepDimTol_GeometricToleranceWithModifiers;
  SetGeometricToleranceType(theType: StepDimTol_GeometricToleranceType): void;
  GetToleranceType(): StepDimTol_GeometricToleranceType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_DatumReferenceCompartment extends StepDimTol_GeneralDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_DatumReferenceCompartment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumReferenceCompartment): void;
  get(): StepDimTol_DatumReferenceCompartment;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumReferenceCompartment_1 extends Handle_StepDimTol_DatumReferenceCompartment {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumReferenceCompartment_2 extends Handle_StepDimTol_DatumReferenceCompartment {
    constructor(thePtr: StepDimTol_DatumReferenceCompartment);
  }

  export declare class Handle_StepDimTol_DatumReferenceCompartment_3 extends Handle_StepDimTol_DatumReferenceCompartment {
    constructor(theHandle: Handle_StepDimTol_DatumReferenceCompartment);
  }

  export declare class Handle_StepDimTol_DatumReferenceCompartment_4 extends Handle_StepDimTol_DatumReferenceCompartment {
    constructor(theHandle: Handle_StepDimTol_DatumReferenceCompartment);
  }

export declare class Handle_StepDimTol_GeometricToleranceWithModifiers {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricToleranceWithModifiers): void;
  get(): StepDimTol_GeometricToleranceWithModifiers;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricToleranceWithModifiers_1 extends Handle_StepDimTol_GeometricToleranceWithModifiers {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithModifiers_2 extends Handle_StepDimTol_GeometricToleranceWithModifiers {
    constructor(thePtr: StepDimTol_GeometricToleranceWithModifiers);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithModifiers_3 extends Handle_StepDimTol_GeometricToleranceWithModifiers {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithModifiers);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithModifiers_4 extends Handle_StepDimTol_GeometricToleranceWithModifiers {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithModifiers);
  }

export declare class StepDimTol_GeometricToleranceWithModifiers extends StepDimTol_GeometricTolerance {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theModifiers: Handle_StepDimTol_HArray1OfGeometricToleranceModifier): void;
  Modifiers(): Handle_StepDimTol_HArray1OfGeometricToleranceModifier;
  SetModifiers(theModifiers: Handle_StepDimTol_HArray1OfGeometricToleranceModifier): void;
  NbModifiers(): Graphic3d_ZLayerId;
  ModifierValue(theNum: Graphic3d_ZLayerId): StepDimTol_GeometricToleranceModifier;
  SetModifierValue(theNum: Graphic3d_ZLayerId, theItem: StepDimTol_GeometricToleranceModifier): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_Array1OfDatumSystemOrReference {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepDimTol_DatumSystemOrReference): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepDimTol_Array1OfDatumSystemOrReference): StepDimTol_Array1OfDatumSystemOrReference;
  Move(theOther: StepDimTol_Array1OfDatumSystemOrReference): StepDimTol_Array1OfDatumSystemOrReference;
  First(): StepDimTol_DatumSystemOrReference;
  ChangeFirst(): StepDimTol_DatumSystemOrReference;
  Last(): StepDimTol_DatumSystemOrReference;
  ChangeLast(): StepDimTol_DatumSystemOrReference;
  Value(theIndex: Standard_Integer): StepDimTol_DatumSystemOrReference;
  ChangeValue(theIndex: Standard_Integer): StepDimTol_DatumSystemOrReference;
  SetValue(theIndex: Standard_Integer, theItem: StepDimTol_DatumSystemOrReference): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepDimTol_Array1OfDatumSystemOrReference_1 extends StepDimTol_Array1OfDatumSystemOrReference {
    constructor();
  }

  export declare class StepDimTol_Array1OfDatumSystemOrReference_2 extends StepDimTol_Array1OfDatumSystemOrReference {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepDimTol_Array1OfDatumSystemOrReference_3 extends StepDimTol_Array1OfDatumSystemOrReference {
    constructor(theOther: StepDimTol_Array1OfDatumSystemOrReference);
  }

  export declare class StepDimTol_Array1OfDatumSystemOrReference_4 extends StepDimTol_Array1OfDatumSystemOrReference {
    constructor(theOther: StepDimTol_Array1OfDatumSystemOrReference);
  }

  export declare class StepDimTol_Array1OfDatumSystemOrReference_5 extends StepDimTol_Array1OfDatumSystemOrReference {
    constructor(theBegin: StepDimTol_DatumSystemOrReference, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepDimTol_DatumReferenceElement extends StepDimTol_GeneralDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_DatumReferenceElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumReferenceElement): void;
  get(): StepDimTol_DatumReferenceElement;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumReferenceElement_1 extends Handle_StepDimTol_DatumReferenceElement {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumReferenceElement_2 extends Handle_StepDimTol_DatumReferenceElement {
    constructor(thePtr: StepDimTol_DatumReferenceElement);
  }

  export declare class Handle_StepDimTol_DatumReferenceElement_3 extends Handle_StepDimTol_DatumReferenceElement {
    constructor(theHandle: Handle_StepDimTol_DatumReferenceElement);
  }

  export declare class Handle_StepDimTol_DatumReferenceElement_4 extends Handle_StepDimTol_DatumReferenceElement {
    constructor(theHandle: Handle_StepDimTol_DatumReferenceElement);
  }

export declare class Handle_StepDimTol_GeometricToleranceWithDatumReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricToleranceWithDatumReference): void;
  get(): StepDimTol_GeometricToleranceWithDatumReference;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricToleranceWithDatumReference_1 extends Handle_StepDimTol_GeometricToleranceWithDatumReference {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDatumReference_2 extends Handle_StepDimTol_GeometricToleranceWithDatumReference {
    constructor(thePtr: StepDimTol_GeometricToleranceWithDatumReference);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDatumReference_3 extends Handle_StepDimTol_GeometricToleranceWithDatumReference {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithDatumReference);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDatumReference_4 extends Handle_StepDimTol_GeometricToleranceWithDatumReference {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithDatumReference);
  }

export declare class StepDimTol_GeometricToleranceWithDatumReference extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(theGeometricTolerance_Name: Handle_TCollection_HAsciiString, theGeometricTolerance_Description: Handle_TCollection_HAsciiString, theGeometricTolerance_Magnitude: Handle_StepBasic_MeasureWithUnit, theGeometricTolerance_TolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theDatumSystem: Handle_StepDimTol_HArray1OfDatumReference): void;
  Init_2(theGeometricTolerance_Name: Handle_TCollection_HAsciiString, theGeometricTolerance_Description: Handle_TCollection_HAsciiString, theGeometricTolerance_Magnitude: Handle_StepBasic_MeasureWithUnit, theGeometricTolerance_TolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theDatumSystem: Handle_StepDimTol_HArray1OfDatumSystemOrReference): void;
  DatumSystem(): Handle_StepDimTol_HArray1OfDatumReference;
  DatumSystemAP242(): Handle_StepDimTol_HArray1OfDatumSystemOrReference;
  SetDatumSystem_1(theDatumSystem: Handle_StepDimTol_HArray1OfDatumReference): void;
  SetDatumSystem_2(theDatumSystem: Handle_StepDimTol_HArray1OfDatumSystemOrReference): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_DatumReference extends Standard_Transient {
  constructor()
  Init(thePrecedence: Graphic3d_ZLayerId, theReferencedDatum: Handle_StepDimTol_Datum): void;
  Precedence(): Graphic3d_ZLayerId;
  SetPrecedence(thePrecedence: Graphic3d_ZLayerId): void;
  ReferencedDatum(): Handle_StepDimTol_Datum;
  SetReferencedDatum(theReferencedDatum: Handle_StepDimTol_Datum): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_DatumReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumReference): void;
  get(): StepDimTol_DatumReference;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumReference_1 extends Handle_StepDimTol_DatumReference {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumReference_2 extends Handle_StepDimTol_DatumReference {
    constructor(thePtr: StepDimTol_DatumReference);
  }

  export declare class Handle_StepDimTol_DatumReference_3 extends Handle_StepDimTol_DatumReference {
    constructor(theHandle: Handle_StepDimTol_DatumReference);
  }

  export declare class Handle_StepDimTol_DatumReference_4 extends Handle_StepDimTol_DatumReference {
    constructor(theHandle: Handle_StepDimTol_DatumReference);
  }

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod): void;
  get(): StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod);
  }

export declare class StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, theGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theType: StepDimTol_GeometricToleranceType): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, aGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theType: StepDimTol_GeometricToleranceType): void;
  SetGeometricToleranceWithDatumReference(theGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference): void;
  GetGeometricToleranceWithDatumReference(): Handle_StepDimTol_GeometricToleranceWithDatumReference;
  SetGeometricToleranceWithModifiers(theGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers): void;
  GetGeometricToleranceWithModifiers(): Handle_StepDimTol_GeometricToleranceWithModifiers;
  SetGeometricToleranceType(theType: StepDimTol_GeometricToleranceType): void;
  GetToleranceType(): StepDimTol_GeometricToleranceType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepDimTol_SimpleDatumReferenceModifier = {
  StepDimTol_SDRMAnyCrossSection: {};
  StepDimTol_SDRMAnyLongitudinalSection: {};
  StepDimTol_SDRMBasic: {};
  StepDimTol_SDRMContactingFeature: {};
  StepDimTol_SDRMDegreeOfFreedomConstraintU: {};
  StepDimTol_SDRMDegreeOfFreedomConstraintV: {};
  StepDimTol_SDRMDegreeOfFreedomConstraintW: {};
  StepDimTol_SDRMDegreeOfFreedomConstraintX: {};
  StepDimTol_SDRMDegreeOfFreedomConstraintY: {};
  StepDimTol_SDRMDegreeOfFreedomConstraintZ: {};
  StepDimTol_SDRMDistanceVariable: {};
  StepDimTol_SDRMFreeState: {};
  StepDimTol_SDRMLeastMaterialRequirement: {};
  StepDimTol_SDRMLine: {};
  StepDimTol_SDRMMajorDiameter: {};
  StepDimTol_SDRMMaximumMaterialRequirement: {};
  StepDimTol_SDRMMinorDiameter: {};
  StepDimTol_SDRMOrientation: {};
  StepDimTol_SDRMPitchDiameter: {};
  StepDimTol_SDRMPlane: {};
  StepDimTol_SDRMPoint: {};
  StepDimTol_SDRMTranslation: {};
}

export declare class Handle_StepDimTol_HArray1OfDatumReferenceElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfDatumReferenceElement): void;
  get(): StepDimTol_HArray1OfDatumReferenceElement;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceElement_1 extends Handle_StepDimTol_HArray1OfDatumReferenceElement {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceElement_2 extends Handle_StepDimTol_HArray1OfDatumReferenceElement {
    constructor(thePtr: StepDimTol_HArray1OfDatumReferenceElement);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceElement_3 extends Handle_StepDimTol_HArray1OfDatumReferenceElement {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReferenceElement);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceElement_4 extends Handle_StepDimTol_HArray1OfDatumReferenceElement {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReferenceElement);
  }

export declare class Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricToleranceWithDefinedAreaUnit): void;
  get(): StepDimTol_GeometricToleranceWithDefinedAreaUnit;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_1 extends Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_2 extends Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit {
    constructor(thePtr: StepDimTol_GeometricToleranceWithDefinedAreaUnit);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_3 extends Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_4 extends Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit);
  }

export declare class StepDimTol_GeometricToleranceWithDefinedAreaUnit extends StepDimTol_GeometricToleranceWithDefinedUnit {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theUnitSize: Handle_StepBasic_LengthMeasureWithUnit, theAreaType: StepDimTol_AreaUnitType, theHasSecondUnitSize: Standard_Boolean, theSecondUnitSize: Handle_StepBasic_LengthMeasureWithUnit): void;
  AreaType(): StepDimTol_AreaUnitType;
  SetAreaType(theAreaType: StepDimTol_AreaUnitType): void;
  SecondUnitSize(): Handle_StepBasic_LengthMeasureWithUnit;
  SetSecondUnitSize(theSecondUnitSize: Handle_StepBasic_LengthMeasureWithUnit): void;
  HasSecondUnitSize(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_DatumTarget {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumTarget): void;
  get(): StepDimTol_DatumTarget;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumTarget_1 extends Handle_StepDimTol_DatumTarget {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumTarget_2 extends Handle_StepDimTol_DatumTarget {
    constructor(thePtr: StepDimTol_DatumTarget);
  }

  export declare class Handle_StepDimTol_DatumTarget_3 extends Handle_StepDimTol_DatumTarget {
    constructor(theHandle: Handle_StepDimTol_DatumTarget);
  }

  export declare class Handle_StepDimTol_DatumTarget_4 extends Handle_StepDimTol_DatumTarget {
    constructor(theHandle: Handle_StepDimTol_DatumTarget);
  }

export declare class StepDimTol_DatumTarget extends StepRepr_ShapeAspect {
  constructor()
  Init(theShapeAspect_Name: Handle_TCollection_HAsciiString, theShapeAspect_Description: Handle_TCollection_HAsciiString, theShapeAspect_OfShape: Handle_StepRepr_ProductDefinitionShape, theShapeAspect_ProductDefinitional: StepData_Logical, theTargetId: Handle_TCollection_HAsciiString): void;
  TargetId(): Handle_TCollection_HAsciiString;
  SetTargetId(theTargetId: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_PositionTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_PositionTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_PositionTolerance): void;
  get(): StepDimTol_PositionTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_PositionTolerance_1 extends Handle_StepDimTol_PositionTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_PositionTolerance_2 extends Handle_StepDimTol_PositionTolerance {
    constructor(thePtr: StepDimTol_PositionTolerance);
  }

  export declare class Handle_StepDimTol_PositionTolerance_3 extends Handle_StepDimTol_PositionTolerance {
    constructor(theHandle: Handle_StepDimTol_PositionTolerance);
  }

  export declare class Handle_StepDimTol_PositionTolerance_4 extends Handle_StepDimTol_PositionTolerance {
    constructor(theHandle: Handle_StepDimTol_PositionTolerance);
  }

export declare type StepDimTol_LimitCondition = {
  StepDimTol_MaximumMaterialCondition: {};
  StepDimTol_LeastMaterialCondition: {};
  StepDimTol_RegardlessOfFeatureSize: {};
}

export declare class StepDimTol_RoundnessTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_RoundnessTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_RoundnessTolerance): void;
  get(): StepDimTol_RoundnessTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_RoundnessTolerance_1 extends Handle_StepDimTol_RoundnessTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_RoundnessTolerance_2 extends Handle_StepDimTol_RoundnessTolerance {
    constructor(thePtr: StepDimTol_RoundnessTolerance);
  }

  export declare class Handle_StepDimTol_RoundnessTolerance_3 extends Handle_StepDimTol_RoundnessTolerance {
    constructor(theHandle: Handle_StepDimTol_RoundnessTolerance);
  }

  export declare class Handle_StepDimTol_RoundnessTolerance_4 extends Handle_StepDimTol_RoundnessTolerance {
    constructor(theHandle: Handle_StepDimTol_RoundnessTolerance);
  }

export declare class Handle_StepDimTol_CoaxialityTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_CoaxialityTolerance): void;
  get(): StepDimTol_CoaxialityTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_CoaxialityTolerance_1 extends Handle_StepDimTol_CoaxialityTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_CoaxialityTolerance_2 extends Handle_StepDimTol_CoaxialityTolerance {
    constructor(thePtr: StepDimTol_CoaxialityTolerance);
  }

  export declare class Handle_StepDimTol_CoaxialityTolerance_3 extends Handle_StepDimTol_CoaxialityTolerance {
    constructor(theHandle: Handle_StepDimTol_CoaxialityTolerance);
  }

  export declare class Handle_StepDimTol_CoaxialityTolerance_4 extends Handle_StepDimTol_CoaxialityTolerance {
    constructor(theHandle: Handle_StepDimTol_CoaxialityTolerance);
  }

export declare class StepDimTol_CoaxialityTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_DatumSystemOrReference extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DatumSystem(): Handle_StepDimTol_DatumSystem;
  DatumReference(): Handle_StepDimTol_DatumReference;
  delete(): void;
}

export declare class Handle_StepDimTol_CircularRunoutTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_CircularRunoutTolerance): void;
  get(): StepDimTol_CircularRunoutTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_CircularRunoutTolerance_1 extends Handle_StepDimTol_CircularRunoutTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_CircularRunoutTolerance_2 extends Handle_StepDimTol_CircularRunoutTolerance {
    constructor(thePtr: StepDimTol_CircularRunoutTolerance);
  }

  export declare class Handle_StepDimTol_CircularRunoutTolerance_3 extends Handle_StepDimTol_CircularRunoutTolerance {
    constructor(theHandle: Handle_StepDimTol_CircularRunoutTolerance);
  }

  export declare class Handle_StepDimTol_CircularRunoutTolerance_4 extends Handle_StepDimTol_CircularRunoutTolerance {
    constructor(theHandle: Handle_StepDimTol_CircularRunoutTolerance);
  }

export declare class StepDimTol_CircularRunoutTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_DatumSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_DatumSystem): void;
  get(): StepDimTol_DatumSystem;
  delete(): void;
}

  export declare class Handle_StepDimTol_DatumSystem_1 extends Handle_StepDimTol_DatumSystem {
    constructor();
  }

  export declare class Handle_StepDimTol_DatumSystem_2 extends Handle_StepDimTol_DatumSystem {
    constructor(thePtr: StepDimTol_DatumSystem);
  }

  export declare class Handle_StepDimTol_DatumSystem_3 extends Handle_StepDimTol_DatumSystem {
    constructor(theHandle: Handle_StepDimTol_DatumSystem);
  }

  export declare class Handle_StepDimTol_DatumSystem_4 extends Handle_StepDimTol_DatumSystem {
    constructor(theHandle: Handle_StepDimTol_DatumSystem);
  }

export declare class StepDimTol_DatumSystem extends StepRepr_ShapeAspect {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theOfShape: Handle_StepRepr_ProductDefinitionShape, theProductDefinitional: StepData_Logical, theConstituents: Handle_StepDimTol_HArray1OfDatumReferenceCompartment): void;
  Constituents(): Handle_StepDimTol_HArray1OfDatumReferenceCompartment;
  SetConstituents(theConstituents: Handle_StepDimTol_HArray1OfDatumReferenceCompartment): void;
  NbConstituents(): Graphic3d_ZLayerId;
  ConstituentsValue_1(num: Graphic3d_ZLayerId): Handle_StepDimTol_DatumReferenceCompartment;
  ConstituentsValue_2(num: Graphic3d_ZLayerId, theItem: Handle_StepDimTol_DatumReferenceCompartment): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepDimTol_GeometricToleranceModifier = {
  StepDimTol_GTMAnyCrossSection: {};
  StepDimTol_GTMCommonZone: {};
  StepDimTol_GTMEachRadialElement: {};
  StepDimTol_GTMFreeState: {};
  StepDimTol_GTMLeastMaterialRequirement: {};
  StepDimTol_GTMLineElement: {};
  StepDimTol_GTMMajorDiameter: {};
  StepDimTol_GTMMaximumMaterialRequirement: {};
  StepDimTol_GTMMinorDiameter: {};
  StepDimTol_GTMNotConvex: {};
  StepDimTol_GTMPitchDiameter: {};
  StepDimTol_GTMReciprocityRequirement: {};
  StepDimTol_GTMSeparateRequirement: {};
  StepDimTol_GTMStatisticalTolerance: {};
  StepDimTol_GTMTangentPlane: {};
}

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol): void;
  get(): StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol);
  }

export declare class StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, aMGT: Handle_StepDimTol_ModifiedGeometricTolerance): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, aMGT: Handle_StepDimTol_ModifiedGeometricTolerance): void;
  SetGeometricToleranceWithDatumReference(aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference): void;
  GetGeometricToleranceWithDatumReference(): Handle_StepDimTol_GeometricToleranceWithDatumReference;
  SetModifiedGeometricTolerance(aMGT: Handle_StepDimTol_ModifiedGeometricTolerance): void;
  GetModifiedGeometricTolerance(): Handle_StepDimTol_ModifiedGeometricTolerance;
  SetPositionTolerance(aPT: Handle_StepDimTol_PositionTolerance): void;
  GetPositionTolerance(): Handle_StepDimTol_PositionTolerance;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_FlatnessTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_FlatnessTolerance): void;
  get(): StepDimTol_FlatnessTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_FlatnessTolerance_1 extends Handle_StepDimTol_FlatnessTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_FlatnessTolerance_2 extends Handle_StepDimTol_FlatnessTolerance {
    constructor(thePtr: StepDimTol_FlatnessTolerance);
  }

  export declare class Handle_StepDimTol_FlatnessTolerance_3 extends Handle_StepDimTol_FlatnessTolerance {
    constructor(theHandle: Handle_StepDimTol_FlatnessTolerance);
  }

  export declare class Handle_StepDimTol_FlatnessTolerance_4 extends Handle_StepDimTol_FlatnessTolerance {
    constructor(theHandle: Handle_StepDimTol_FlatnessTolerance);
  }

export declare class StepDimTol_FlatnessTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_AngularityTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_AngularityTolerance): void;
  get(): StepDimTol_AngularityTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_AngularityTolerance_1 extends Handle_StepDimTol_AngularityTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_AngularityTolerance_2 extends Handle_StepDimTol_AngularityTolerance {
    constructor(thePtr: StepDimTol_AngularityTolerance);
  }

  export declare class Handle_StepDimTol_AngularityTolerance_3 extends Handle_StepDimTol_AngularityTolerance {
    constructor(theHandle: Handle_StepDimTol_AngularityTolerance);
  }

  export declare class Handle_StepDimTol_AngularityTolerance_4 extends Handle_StepDimTol_AngularityTolerance {
    constructor(theHandle: Handle_StepDimTol_AngularityTolerance);
  }

export declare class StepDimTol_AngularityTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_CylindricityTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_CylindricityTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_CylindricityTolerance): void;
  get(): StepDimTol_CylindricityTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_CylindricityTolerance_1 extends Handle_StepDimTol_CylindricityTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_CylindricityTolerance_2 extends Handle_StepDimTol_CylindricityTolerance {
    constructor(thePtr: StepDimTol_CylindricityTolerance);
  }

  export declare class Handle_StepDimTol_CylindricityTolerance_3 extends Handle_StepDimTol_CylindricityTolerance {
    constructor(theHandle: Handle_StepDimTol_CylindricityTolerance);
  }

  export declare class Handle_StepDimTol_CylindricityTolerance_4 extends Handle_StepDimTol_CylindricityTolerance {
    constructor(theHandle: Handle_StepDimTol_CylindricityTolerance);
  }

export declare class StepDimTol_GeometricToleranceTarget extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DimensionalLocation(): Handle_StepShape_DimensionalLocation;
  DimensionalSize(): Handle_StepShape_DimensionalSize;
  ProductDefinitionShape(): Handle_StepRepr_ProductDefinitionShape;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  delete(): void;
}

export declare type StepDimTol_DatumReferenceModifierType = {
  StepDimTol_CircularOrCylindrical: {};
  StepDimTol_Distance: {};
  StepDimTol_Projected: {};
  StepDimTol_Spherical: {};
}

export declare class StepDimTol_ShapeToleranceSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  GeometricTolerance(): Handle_StepDimTol_GeometricTolerance;
  PlusMinusTolerance(): Handle_StepShape_PlusMinusTolerance;
  delete(): void;
}

export declare class StepDimTol_Datum extends StepRepr_ShapeAspect {
  constructor()
  Init(theShapeAspect_Name: Handle_TCollection_HAsciiString, theShapeAspect_Description: Handle_TCollection_HAsciiString, theShapeAspect_OfShape: Handle_StepRepr_ProductDefinitionShape, theShapeAspect_ProductDefinitional: StepData_Logical, theIdentification: Handle_TCollection_HAsciiString): void;
  Identification(): Handle_TCollection_HAsciiString;
  SetIdentification(theIdentification: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_Datum {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_Datum): void;
  get(): StepDimTol_Datum;
  delete(): void;
}

  export declare class Handle_StepDimTol_Datum_1 extends Handle_StepDimTol_Datum {
    constructor();
  }

  export declare class Handle_StepDimTol_Datum_2 extends Handle_StepDimTol_Datum {
    constructor(thePtr: StepDimTol_Datum);
  }

  export declare class Handle_StepDimTol_Datum_3 extends Handle_StepDimTol_Datum {
    constructor(theHandle: Handle_StepDimTol_Datum);
  }

  export declare class Handle_StepDimTol_Datum_4 extends Handle_StepDimTol_Datum {
    constructor(theHandle: Handle_StepDimTol_Datum);
  }

export declare class Handle_StepDimTol_HArray1OfDatumReferenceCompartment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_HArray1OfDatumReferenceCompartment): void;
  get(): StepDimTol_HArray1OfDatumReferenceCompartment;
  delete(): void;
}

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceCompartment_1 extends Handle_StepDimTol_HArray1OfDatumReferenceCompartment {
    constructor();
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceCompartment_2 extends Handle_StepDimTol_HArray1OfDatumReferenceCompartment {
    constructor(thePtr: StepDimTol_HArray1OfDatumReferenceCompartment);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceCompartment_3 extends Handle_StepDimTol_HArray1OfDatumReferenceCompartment {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReferenceCompartment);
  }

  export declare class Handle_StepDimTol_HArray1OfDatumReferenceCompartment_4 extends Handle_StepDimTol_HArray1OfDatumReferenceCompartment {
    constructor(theHandle: Handle_StepDimTol_HArray1OfDatumReferenceCompartment);
  }

export declare class StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol extends StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, theGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theMaxTol: Handle_StepBasic_LengthMeasureWithUnit, theType: StepDimTol_GeometricToleranceType): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aMagnitude: Handle_StepBasic_MeasureWithUnit, aTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, aGTWDR: Handle_StepDimTol_GeometricToleranceWithDatumReference, aGTWM: Handle_StepDimTol_GeometricToleranceWithModifiers, theMaxTol: Handle_StepBasic_LengthMeasureWithUnit, theType: StepDimTol_GeometricToleranceType): void;
  SetMaxTolerance(theMaxTol: Handle_StepBasic_LengthMeasureWithUnit): void;
  GetMaxTolerance(): Handle_StepBasic_LengthMeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol): void;
  get(): StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_1 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol {
    constructor();
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_2 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol {
    constructor(thePtr: StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_3 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol);
  }

  export declare class Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_4 extends Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol {
    constructor(theHandle: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol);
  }

export declare class Handle_StepDimTol_SymmetryTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_SymmetryTolerance): void;
  get(): StepDimTol_SymmetryTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_SymmetryTolerance_1 extends Handle_StepDimTol_SymmetryTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_SymmetryTolerance_2 extends Handle_StepDimTol_SymmetryTolerance {
    constructor(thePtr: StepDimTol_SymmetryTolerance);
  }

  export declare class Handle_StepDimTol_SymmetryTolerance_3 extends Handle_StepDimTol_SymmetryTolerance {
    constructor(theHandle: Handle_StepDimTol_SymmetryTolerance);
  }

  export declare class Handle_StepDimTol_SymmetryTolerance_4 extends Handle_StepDimTol_SymmetryTolerance {
    constructor(theHandle: Handle_StepDimTol_SymmetryTolerance);
  }

export declare class StepDimTol_SymmetryTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_DatumReferenceModifier extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DatumReferenceModifierWithValue(): Handle_StepDimTol_DatumReferenceModifierWithValue;
  SimpleDatumReferenceModifierMember(): Handle_StepDimTol_SimpleDatumReferenceModifierMember;
  delete(): void;
}

export declare class StepDimTol_GeometricToleranceWithDefinedUnit extends StepDimTol_GeometricTolerance {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: Handle_StepRepr_ShapeAspect, theUnitSize: Handle_StepBasic_LengthMeasureWithUnit): void;
  Init_2(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theMagnitude: Handle_StepBasic_MeasureWithUnit, theTolerancedShapeAspect: StepDimTol_GeometricToleranceTarget, theUnitSize: Handle_StepBasic_LengthMeasureWithUnit): void;
  UnitSize(): Handle_StepBasic_LengthMeasureWithUnit;
  SetUnitSize(theUnitSize: Handle_StepBasic_LengthMeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeometricToleranceWithDefinedUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeometricToleranceWithDefinedUnit): void;
  get(): StepDimTol_GeometricToleranceWithDefinedUnit;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedUnit_1 extends Handle_StepDimTol_GeometricToleranceWithDefinedUnit {
    constructor();
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedUnit_2 extends Handle_StepDimTol_GeometricToleranceWithDefinedUnit {
    constructor(thePtr: StepDimTol_GeometricToleranceWithDefinedUnit);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedUnit_3 extends Handle_StepDimTol_GeometricToleranceWithDefinedUnit {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithDefinedUnit);
  }

  export declare class Handle_StepDimTol_GeometricToleranceWithDefinedUnit_4 extends Handle_StepDimTol_GeometricToleranceWithDefinedUnit {
    constructor(theHandle: Handle_StepDimTol_GeometricToleranceWithDefinedUnit);
  }

export declare class Handle_StepDimTol_SurfaceProfileTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_SurfaceProfileTolerance): void;
  get(): StepDimTol_SurfaceProfileTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_SurfaceProfileTolerance_1 extends Handle_StepDimTol_SurfaceProfileTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_SurfaceProfileTolerance_2 extends Handle_StepDimTol_SurfaceProfileTolerance {
    constructor(thePtr: StepDimTol_SurfaceProfileTolerance);
  }

  export declare class Handle_StepDimTol_SurfaceProfileTolerance_3 extends Handle_StepDimTol_SurfaceProfileTolerance {
    constructor(theHandle: Handle_StepDimTol_SurfaceProfileTolerance);
  }

  export declare class Handle_StepDimTol_SurfaceProfileTolerance_4 extends Handle_StepDimTol_SurfaceProfileTolerance {
    constructor(theHandle: Handle_StepDimTol_SurfaceProfileTolerance);
  }

export declare class StepDimTol_SurfaceProfileTolerance extends StepDimTol_GeometricTolerance {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepDimTol_GeneralDatumReference extends StepRepr_ShapeAspect {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theOfShape: Handle_StepRepr_ProductDefinitionShape, theProductDefinitional: StepData_Logical, theBase: StepDimTol_DatumOrCommonDatum, theHasModifiers: Standard_Boolean, theModifiers: Handle_StepDimTol_HArray1OfDatumReferenceModifier): void;
  Base(): StepDimTol_DatumOrCommonDatum;
  SetBase(theBase: StepDimTol_DatumOrCommonDatum): void;
  HasModifiers(): Standard_Boolean;
  Modifiers(): Handle_StepDimTol_HArray1OfDatumReferenceModifier;
  SetModifiers(theModifiers: Handle_StepDimTol_HArray1OfDatumReferenceModifier): void;
  NbModifiers(): Graphic3d_ZLayerId;
  ModifiersValue_1(theNum: Graphic3d_ZLayerId): StepDimTol_DatumReferenceModifier;
  ModifiersValue_2(theNum: Graphic3d_ZLayerId, theItem: StepDimTol_DatumReferenceModifier): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepDimTol_GeneralDatumReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_GeneralDatumReference): void;
  get(): StepDimTol_GeneralDatumReference;
  delete(): void;
}

  export declare class Handle_StepDimTol_GeneralDatumReference_1 extends Handle_StepDimTol_GeneralDatumReference {
    constructor();
  }

  export declare class Handle_StepDimTol_GeneralDatumReference_2 extends Handle_StepDimTol_GeneralDatumReference {
    constructor(thePtr: StepDimTol_GeneralDatumReference);
  }

  export declare class Handle_StepDimTol_GeneralDatumReference_3 extends Handle_StepDimTol_GeneralDatumReference {
    constructor(theHandle: Handle_StepDimTol_GeneralDatumReference);
  }

  export declare class Handle_StepDimTol_GeneralDatumReference_4 extends Handle_StepDimTol_GeneralDatumReference {
    constructor(theHandle: Handle_StepDimTol_GeneralDatumReference);
  }

export declare class StepDimTol_DatumOrCommonDatum extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Datum(): Handle_StepDimTol_Datum;
  CommonDatumList(): Handle_StepDimTol_HArray1OfDatumReferenceElement;
  delete(): void;
}

export declare type StepDimTol_GeometricToleranceType = {
  StepDimTol_GTTAngularityTolerance: {};
  StepDimTol_GTTCircularRunoutTolerance: {};
  StepDimTol_GTTCoaxialityTolerance: {};
  StepDimTol_GTTConcentricityTolerance: {};
  StepDimTol_GTTCylindricityTolerance: {};
  StepDimTol_GTTFlatnessTolerance: {};
  StepDimTol_GTTLineProfileTolerance: {};
  StepDimTol_GTTParallelismTolerance: {};
  StepDimTol_GTTPerpendicularityTolerance: {};
  StepDimTol_GTTPositionTolerance: {};
  StepDimTol_GTTRoundnessTolerance: {};
  StepDimTol_GTTStraightnessTolerance: {};
  StepDimTol_GTTSurfaceProfileTolerance: {};
  StepDimTol_GTTSymmetryTolerance: {};
  StepDimTol_GTTTotalRunoutTolerance: {};
}

export declare class Handle_StepDimTol_ConcentricityTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepDimTol_ConcentricityTolerance): void;
  get(): StepDimTol_ConcentricityTolerance;
  delete(): void;
}

  export declare class Handle_StepDimTol_ConcentricityTolerance_1 extends Handle_StepDimTol_ConcentricityTolerance {
    constructor();
  }

  export declare class Handle_StepDimTol_ConcentricityTolerance_2 extends Handle_StepDimTol_ConcentricityTolerance {
    constructor(thePtr: StepDimTol_ConcentricityTolerance);
  }

  export declare class Handle_StepDimTol_ConcentricityTolerance_3 extends Handle_StepDimTol_ConcentricityTolerance {
    constructor(theHandle: Handle_StepDimTol_ConcentricityTolerance);
  }

  export declare class Handle_StepDimTol_ConcentricityTolerance_4 extends Handle_StepDimTol_ConcentricityTolerance {
    constructor(theHandle: Handle_StepDimTol_ConcentricityTolerance);
  }

export declare class StepDimTol_ConcentricityTolerance extends StepDimTol_GeometricToleranceWithDatumReference {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class AppStdL_Application extends TDocStd_Application {
  constructor();
  ResourcesName(): Standard_CString;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_AppStdL_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppStdL_Application): void;
  get(): AppStdL_Application;
  delete(): void;
}

  export declare class Handle_AppStdL_Application_1 extends Handle_AppStdL_Application {
    constructor();
  }

  export declare class Handle_AppStdL_Application_2 extends Handle_AppStdL_Application {
    constructor(thePtr: AppStdL_Application);
  }

  export declare class Handle_AppStdL_Application_3 extends Handle_AppStdL_Application {
    constructor(theHandle: Handle_AppStdL_Application);
  }

  export declare class Handle_AppStdL_Application_4 extends Handle_AppStdL_Application {
    constructor(theHandle: Handle_AppStdL_Application);
  }

export declare class TopOpeBRep_EdgesIntersector {
  constructor()
  SetFaces_1(F1: TopoDS_Shape, F2: TopoDS_Shape): void;
  SetFaces_2(F1: TopoDS_Shape, F2: TopoDS_Shape, B1: Bnd_Box, B2: Bnd_Box): void;
  ForceTolerances(Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  Dimension_1(D: Graphic3d_ZLayerId): void;
  Dimension_2(): Graphic3d_ZLayerId;
  Perform(E1: TopoDS_Shape, E2: TopoDS_Shape, ReduceSegments: Standard_Boolean): void;
  IsEmpty(): Standard_Boolean;
  HasSegment(): Standard_Boolean;
  SameDomain(): Standard_Boolean;
  Edge(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  Curve(Index: Graphic3d_ZLayerId): Geom2dAdaptor_Curve;
  Face(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  Surface(Index: Graphic3d_ZLayerId): BRepAdaptor_Surface;
  SurfacesSameOriented(): Standard_Boolean;
  FacesSameOriented(): Standard_Boolean;
  ToleranceMax(): Quantity_AbsorbedDose;
  Tolerances(tol1: Quantity_AbsorbedDose, tol2: Quantity_AbsorbedDose): void;
  NbPoints(): Graphic3d_ZLayerId;
  NbSegments(): Graphic3d_ZLayerId;
  Dump(str: XCAFDoc_PartId, ie1: Graphic3d_ZLayerId, ie2: Graphic3d_ZLayerId): void;
  InitPoint(selectkeep: Standard_Boolean): void;
  MorePoint(): Standard_Boolean;
  NextPoint(): void;
  Points(): TopOpeBRep_SequenceOfPoint2d;
  Point_1(): TopOpeBRep_Point2d;
  Point_2(I: Graphic3d_ZLayerId): TopOpeBRep_Point2d;
  ReduceSegment(P1: TopOpeBRep_Point2d, P2: TopOpeBRep_Point2d, Pn: TopOpeBRep_Point2d): Standard_Boolean;
  Status1(): TopOpeBRep_P2Dstatus;
  delete(): void;
}

export declare class TopOpeBRep_FacesFiller {
  constructor()
  Insert(F1: TopoDS_Shape, F2: TopoDS_Shape, FACINT: TopOpeBRep_FacesIntersector, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  ProcessSectionEdges(): void;
  ChangePointClassifier(): TopOpeBRep_PointClassifier;
  PShapeClassifier(): TopOpeBRepTool_PShapeClassifier;
  SetPShapeClassifier(PSC: TopOpeBRepTool_PShapeClassifier): void;
  LoadLine(L: TopOpeBRep_LineInter): void;
  CheckLine(L: TopOpeBRep_LineInter): Standard_Boolean;
  VP_Position_1(FACINT: TopOpeBRep_FacesIntersector): void;
  VP_Position_2(L: TopOpeBRep_LineInter): void;
  VP_PositionOnL(L: TopOpeBRep_LineInter): void;
  VP_PositionOnR(L: TopOpeBRep_LineInter): void;
  VP_Position_3(VP: TopOpeBRep_VPointInter, VPC: TopOpeBRep_VPointInterClassifier): void;
  ProcessLine(): void;
  ResetDSC(): void;
  ProcessRLine(): void;
  FillLineVPonR(): void;
  FillLine(): void;
  AddShapesLine(): void;
  GetESL(LES: TopTools_ListOfShape): void;
  ProcessVPR(FF: TopOpeBRep_FacesFiller, VP: TopOpeBRep_VPointInter): void;
  ProcessVPIonR(VPI: TopOpeBRep_VPointInterIterator, trans1: TopOpeBRepDS_Transition, F1: TopoDS_Shape, ShapeIndex: Graphic3d_ZLayerId): void;
  ProcessVPonR(VP: TopOpeBRep_VPointInter, trans1: TopOpeBRepDS_Transition, F1: TopoDS_Shape, ShapeIndex: Graphic3d_ZLayerId): void;
  ProcessVPonclosingR(VP: TopOpeBRep_VPointInter, F1: TopoDS_Shape, ShapeIndex: Graphic3d_ZLayerId, transEdge: TopOpeBRepDS_Transition, PVKind: TopOpeBRepDS_Kind, PVIndex: Graphic3d_ZLayerId, EPIfound: Standard_Boolean, IEPI: Handle_TopOpeBRepDS_Interference): void;
  ProcessVPondgE(VP: TopOpeBRep_VPointInter, ShapeIndex: Graphic3d_ZLayerId, PVKind: TopOpeBRepDS_Kind, PVIndex: Graphic3d_ZLayerId, EPIfound: Standard_Boolean, IEPI: Handle_TopOpeBRepDS_Interference, CPIfound: Standard_Boolean, ICPI: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  ProcessVPInotonR(VPI: TopOpeBRep_VPointInterIterator): void;
  ProcessVPnotonR(VP: TopOpeBRep_VPointInter): void;
  GetGeometry(IT: TopOpeBRepDS_ListIteratorOfListOfInterference, VP: TopOpeBRep_VPointInter, G: Graphic3d_ZLayerId, K: TopOpeBRepDS_Kind): Standard_Boolean;
  MakeGeometry(VP: TopOpeBRep_VPointInter, ShapeIndex: Graphic3d_ZLayerId, K: TopOpeBRepDS_Kind): Graphic3d_ZLayerId;
  StoreCurveInterference(I: Handle_TopOpeBRepDS_Interference): void;
  GetFFGeometry_1(DSP: TopOpeBRepDS_Point, K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): Standard_Boolean;
  GetFFGeometry_2(VP: TopOpeBRep_VPointInter, K: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId): Standard_Boolean;
  ChangeFacesIntersector(): TopOpeBRep_FacesIntersector;
  HDataStructure(): Handle_TopOpeBRepDS_HDataStructure;
  ChangeDataStructure(): TopOpeBRepDS_DataStructure;
  Face(I: Graphic3d_ZLayerId): TopoDS_Face;
  FaceFaceTransition_1(L: TopOpeBRep_LineInter, I: Graphic3d_ZLayerId): TopOpeBRepDS_Transition;
  FaceFaceTransition_2(I: Graphic3d_ZLayerId): TopOpeBRepDS_Transition;
  PFacesIntersectorDummy(): TopOpeBRep_PFacesIntersector;
  PDataStructureDummy(): TopOpeBRepDS_PDataStructure;
  PLineInterDummy(): TopOpeBRep_PLineInter;
  SetTraceIndex(exF1: Graphic3d_ZLayerId, exF2: Graphic3d_ZLayerId): void;
  GetTraceIndex(exF1: Graphic3d_ZLayerId, exF2: Graphic3d_ZLayerId): void;
  static Lminmax(L: TopOpeBRep_LineInter, pmin: Quantity_AbsorbedDose, pmax: Quantity_AbsorbedDose): void;
  static LSameDomainERL(L: TopOpeBRep_LineInter, ERL: TopTools_ListOfShape): Standard_Boolean;
  static IsVPtransLok(L: TopOpeBRep_LineInter, iVP: Graphic3d_ZLayerId, SI12: Graphic3d_ZLayerId, T: TopOpeBRepDS_Transition): Standard_Boolean;
  static TransvpOK(L: TopOpeBRep_LineInter, iVP: Graphic3d_ZLayerId, SI: Graphic3d_ZLayerId, isINOUT: Standard_Boolean): Standard_Boolean;
  static VPParamOnER(vp: TopOpeBRep_VPointInter, Lrest: TopOpeBRep_LineInter): Quantity_AbsorbedDose;
  static EqualpPonR(Lrest: TopOpeBRep_LineInter, VP1: TopOpeBRep_VPointInter, VP2: TopOpeBRep_VPointInter): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRep_Array1OfLineInter {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TopOpeBRep_LineInter): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TopOpeBRep_Array1OfLineInter): TopOpeBRep_Array1OfLineInter;
  Move(theOther: TopOpeBRep_Array1OfLineInter): TopOpeBRep_Array1OfLineInter;
  First(): TopOpeBRep_LineInter;
  ChangeFirst(): TopOpeBRep_LineInter;
  Last(): TopOpeBRep_LineInter;
  ChangeLast(): TopOpeBRep_LineInter;
  Value(theIndex: Standard_Integer): TopOpeBRep_LineInter;
  ChangeValue(theIndex: Standard_Integer): TopOpeBRep_LineInter;
  SetValue(theIndex: Standard_Integer, theItem: TopOpeBRep_LineInter): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRep_Array1OfLineInter_1 extends TopOpeBRep_Array1OfLineInter {
    constructor();
  }

  export declare class TopOpeBRep_Array1OfLineInter_2 extends TopOpeBRep_Array1OfLineInter {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TopOpeBRep_Array1OfLineInter_3 extends TopOpeBRep_Array1OfLineInter {
    constructor(theOther: TopOpeBRep_Array1OfLineInter);
  }

  export declare class TopOpeBRep_Array1OfLineInter_4 extends TopOpeBRep_Array1OfLineInter {
    constructor(theOther: TopOpeBRep_Array1OfLineInter);
  }

  export declare class TopOpeBRep_Array1OfLineInter_5 extends TopOpeBRep_Array1OfLineInter {
    constructor(theBegin: TopOpeBRep_LineInter, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TopOpeBRep_Array1OfVPointInter {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TopOpeBRep_VPointInter): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TopOpeBRep_Array1OfVPointInter): TopOpeBRep_Array1OfVPointInter;
  Move(theOther: TopOpeBRep_Array1OfVPointInter): TopOpeBRep_Array1OfVPointInter;
  First(): TopOpeBRep_VPointInter;
  ChangeFirst(): TopOpeBRep_VPointInter;
  Last(): TopOpeBRep_VPointInter;
  ChangeLast(): TopOpeBRep_VPointInter;
  Value(theIndex: Standard_Integer): TopOpeBRep_VPointInter;
  ChangeValue(theIndex: Standard_Integer): TopOpeBRep_VPointInter;
  SetValue(theIndex: Standard_Integer, theItem: TopOpeBRep_VPointInter): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRep_Array1OfVPointInter_1 extends TopOpeBRep_Array1OfVPointInter {
    constructor();
  }

  export declare class TopOpeBRep_Array1OfVPointInter_2 extends TopOpeBRep_Array1OfVPointInter {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TopOpeBRep_Array1OfVPointInter_3 extends TopOpeBRep_Array1OfVPointInter {
    constructor(theOther: TopOpeBRep_Array1OfVPointInter);
  }

  export declare class TopOpeBRep_Array1OfVPointInter_4 extends TopOpeBRep_Array1OfVPointInter {
    constructor(theOther: TopOpeBRep_Array1OfVPointInter);
  }

  export declare class TopOpeBRep_Array1OfVPointInter_5 extends TopOpeBRep_Array1OfVPointInter {
    constructor(theBegin: TopOpeBRep_VPointInter, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TopOpeBRep_Hctxff2d extends Standard_Transient {
  constructor()
  SetFaces(F1: TopoDS_Face, F2: TopoDS_Face): void;
  SetHSurfaces(S1: Handle_BRepAdaptor_HSurface, S2: Handle_BRepAdaptor_HSurface): void;
  SetTolerances(Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  GetTolerances(Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  GetMaxTolerance(): Quantity_AbsorbedDose;
  Face(I: Graphic3d_ZLayerId): TopoDS_Face;
  HSurface(I: Graphic3d_ZLayerId): Handle_BRepAdaptor_HSurface;
  SurfacesSameOriented(): Standard_Boolean;
  FacesSameOriented(): Standard_Boolean;
  FaceSameOrientedWithRef(I: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRep_Hctxff2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRep_Hctxff2d): void;
  get(): TopOpeBRep_Hctxff2d;
  delete(): void;
}

  export declare class Handle_TopOpeBRep_Hctxff2d_1 extends Handle_TopOpeBRep_Hctxff2d {
    constructor();
  }

  export declare class Handle_TopOpeBRep_Hctxff2d_2 extends Handle_TopOpeBRep_Hctxff2d {
    constructor(thePtr: TopOpeBRep_Hctxff2d);
  }

  export declare class Handle_TopOpeBRep_Hctxff2d_3 extends Handle_TopOpeBRep_Hctxff2d {
    constructor(theHandle: Handle_TopOpeBRep_Hctxff2d);
  }

  export declare class Handle_TopOpeBRep_Hctxff2d_4 extends Handle_TopOpeBRep_Hctxff2d {
    constructor(theHandle: Handle_TopOpeBRep_Hctxff2d);
  }

export declare class TopOpeBRep_FaceEdgeFiller {
  constructor()
  Insert(F: TopoDS_Shape, E: TopoDS_Shape, FEINT: TopOpeBRep_FaceEdgeIntersector, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  delete(): void;
}

export declare type TopOpeBRep_P2Dstatus = {
  TopOpeBRep_P2DUNK: {};
  TopOpeBRep_P2DINT: {};
  TopOpeBRep_P2DSGF: {};
  TopOpeBRep_P2DSGL: {};
  TopOpeBRep_P2DNEW: {};
}

export declare class TopOpeBRep_Hctxee2d extends Standard_Transient {
  constructor()
  SetEdges(E1: TopoDS_Edge, E2: TopoDS_Edge, BAS1: BRepAdaptor_Surface, BAS2: BRepAdaptor_Surface): void;
  Edge(I: Graphic3d_ZLayerId): TopoDS_Shape;
  Curve(I: Graphic3d_ZLayerId): Geom2dAdaptor_Curve;
  Domain(I: Graphic3d_ZLayerId): IntRes2d_Domain;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRep_Hctxee2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRep_Hctxee2d): void;
  get(): TopOpeBRep_Hctxee2d;
  delete(): void;
}

  export declare class Handle_TopOpeBRep_Hctxee2d_1 extends Handle_TopOpeBRep_Hctxee2d {
    constructor();
  }

  export declare class Handle_TopOpeBRep_Hctxee2d_2 extends Handle_TopOpeBRep_Hctxee2d {
    constructor(thePtr: TopOpeBRep_Hctxee2d);
  }

  export declare class Handle_TopOpeBRep_Hctxee2d_3 extends Handle_TopOpeBRep_Hctxee2d {
    constructor(theHandle: Handle_TopOpeBRep_Hctxee2d);
  }

  export declare class Handle_TopOpeBRep_Hctxee2d_4 extends Handle_TopOpeBRep_Hctxee2d {
    constructor(theHandle: Handle_TopOpeBRep_Hctxee2d);
  }

export declare class Handle_TopOpeBRep_HArray1OfLineInter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRep_HArray1OfLineInter): void;
  get(): TopOpeBRep_HArray1OfLineInter;
  delete(): void;
}

  export declare class Handle_TopOpeBRep_HArray1OfLineInter_1 extends Handle_TopOpeBRep_HArray1OfLineInter {
    constructor();
  }

  export declare class Handle_TopOpeBRep_HArray1OfLineInter_2 extends Handle_TopOpeBRep_HArray1OfLineInter {
    constructor(thePtr: TopOpeBRep_HArray1OfLineInter);
  }

  export declare class Handle_TopOpeBRep_HArray1OfLineInter_3 extends Handle_TopOpeBRep_HArray1OfLineInter {
    constructor(theHandle: Handle_TopOpeBRep_HArray1OfLineInter);
  }

  export declare class Handle_TopOpeBRep_HArray1OfLineInter_4 extends Handle_TopOpeBRep_HArray1OfLineInter {
    constructor(theHandle: Handle_TopOpeBRep_HArray1OfLineInter);
  }

export declare class TopOpeBRep_EdgesFiller {
  constructor()
  Insert(E1: TopoDS_Shape, E2: TopoDS_Shape, EI: TopOpeBRep_EdgesIntersector, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Face_1(I: Graphic3d_ZLayerId, F: TopoDS_Shape): void;
  Face_2(I: Graphic3d_ZLayerId): TopoDS_Shape;
  delete(): void;
}

export declare class TopOpeBRep_DSFiller {
  constructor()
  PShapeClassifier(): TopOpeBRepTool_PShapeClassifier;
  Insert(S1: TopoDS_Shape, S2: TopoDS_Shape, HDS: Handle_TopOpeBRepDS_HDataStructure, orientFORWARD: Standard_Boolean): void;
  InsertIntersection(S1: TopoDS_Shape, S2: TopoDS_Shape, HDS: Handle_TopOpeBRepDS_HDataStructure, orientFORWARD: Standard_Boolean): void;
  Complete(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Insert2d(S1: TopoDS_Shape, S2: TopoDS_Shape, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  InsertIntersection2d(S1: TopoDS_Shape, S2: TopoDS_Shape, HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  IsMadeOf1d(S: TopoDS_Shape): Standard_Boolean;
  IsContext1d(S: TopoDS_Shape): Standard_Boolean;
  Insert1d(S1: TopoDS_Shape, S2: TopoDS_Shape, F1: TopoDS_Face, F2: TopoDS_Face, HDS: Handle_TopOpeBRepDS_HDataStructure, orientFORWARD: Standard_Boolean): void;
  ChangeShapeIntersector(): TopOpeBRep_ShapeIntersector;
  ChangeShapeIntersector2d(): TopOpeBRep_ShapeIntersector2d;
  ChangeFacesFiller(): TopOpeBRep_FacesFiller;
  ChangeEdgesFiller(): TopOpeBRep_EdgesFiller;
  ChangeFaceEdgeFiller(): TopOpeBRep_FaceEdgeFiller;
  GapFiller(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  CompleteDS(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Filter(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Reducer(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  RemoveUnsharedGeometry(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Checker(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  CompleteDS2d(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  delete(): void;
}

export declare class TopOpeBRep_VPointInterIterator {
  Init_1(LI: TopOpeBRep_LineInter, checkkeep: Standard_Boolean): void;
  Init_2(): void;
  More(): Standard_Boolean;
  Next(): void;
  CurrentVP(): TopOpeBRep_VPointInter;
  CurrentVPIndex(): Graphic3d_ZLayerId;
  ChangeCurrentVP(): TopOpeBRep_VPointInter;
  PLineInterDummy(): TopOpeBRep_PLineInter;
  delete(): void;
}

  export declare class TopOpeBRep_VPointInterIterator_1 extends TopOpeBRep_VPointInterIterator {
    constructor();
  }

  export declare class TopOpeBRep_VPointInterIterator_2 extends TopOpeBRep_VPointInterIterator {
    constructor(LI: TopOpeBRep_LineInter);
  }

export declare class TopOpeBRep_VPointInter {
  constructor()
  SetPoint(P: IntPatch_Point): void;
  SetShapes(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): void;
  GetShapes(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): void;
  TransitionOnS1(): IntSurf_Transition;
  TransitionOnS2(): IntSurf_Transition;
  TransitionLineArc1(): IntSurf_Transition;
  TransitionLineArc2(): IntSurf_Transition;
  IsOnDomS1(): Standard_Boolean;
  IsOnDomS2(): Standard_Boolean;
  ParametersOnS1(u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): void;
  ParametersOnS2(u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  Tolerance(): Quantity_AbsorbedDose;
  ArcOnS1(): TopoDS_Shape;
  ArcOnS2(): TopoDS_Shape;
  ParameterOnLine(): Quantity_AbsorbedDose;
  ParameterOnArc1(): Quantity_AbsorbedDose;
  IsVertexOnS1(): Standard_Boolean;
  VertexOnS1(): TopoDS_Shape;
  ParameterOnArc2(): Quantity_AbsorbedDose;
  IsVertexOnS2(): Standard_Boolean;
  VertexOnS2(): TopoDS_Shape;
  IsInternal(): Standard_Boolean;
  IsMultiple(): Standard_Boolean;
  State_1(I: Graphic3d_ZLayerId): TopAbs_State;
  State_2(S: TopAbs_State, I: Graphic3d_ZLayerId): void;
  EdgeON_1(Eon: TopoDS_Shape, Par: Quantity_AbsorbedDose, I: Graphic3d_ZLayerId): void;
  EdgeON_2(I: Graphic3d_ZLayerId): TopoDS_Shape;
  EdgeONParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ShapeIndex_1(): Graphic3d_ZLayerId;
  ShapeIndex_2(I: Graphic3d_ZLayerId): void;
  Edge(I: Graphic3d_ZLayerId): TopoDS_Shape;
  EdgeParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SurfaceParameters(I: Graphic3d_ZLayerId): gp_Pnt2d;
  IsVertex(I: Graphic3d_ZLayerId): Standard_Boolean;
  Vertex(I: Graphic3d_ZLayerId): TopoDS_Shape;
  UpdateKeep(): void;
  Keep(): Standard_Boolean;
  ChangeKeep(keep: Standard_Boolean): void;
  EqualpP(VP: TopOpeBRep_VPointInter): Standard_Boolean;
  ParonE(E: TopoDS_Edge, par: Quantity_AbsorbedDose): Standard_Boolean;
  Index_1(I: Graphic3d_ZLayerId): void;
  Index_2(): Graphic3d_ZLayerId;
  PThePointOfIntersectionDummy(): TopOpeBRep_PThePointOfIntersection;
  delete(): void;
}

export declare class TopOpeBRep_PointGeomTool {
  constructor();
  static MakePoint_1(IP: TopOpeBRep_VPointInter): TopOpeBRepDS_Point;
  static MakePoint_2(P2D: TopOpeBRep_Point2d): TopOpeBRepDS_Point;
  static MakePoint_3(FEI: TopOpeBRep_FaceEdgeIntersector): TopOpeBRepDS_Point;
  static MakePoint_4(S: TopoDS_Shape): TopOpeBRepDS_Point;
  static IsEqual(DSP1: TopOpeBRepDS_Point, DSP2: TopOpeBRepDS_Point): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRep_FacesIntersector {
  constructor()
  Perform_1(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  Perform_2(S1: TopoDS_Shape, S2: TopoDS_Shape, B1: Bnd_Box, B2: Bnd_Box): void;
  IsEmpty(): Standard_Boolean;
  IsDone(): Standard_Boolean;
  SameDomain(): Standard_Boolean;
  Face(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  SurfacesSameOriented(): Standard_Boolean;
  IsRestriction(E: TopoDS_Shape): Standard_Boolean;
  Restrictions(): TopTools_IndexedMapOfShape;
  PrepareLines(): void;
  Lines(): Handle_TopOpeBRep_HArray1OfLineInter;
  NbLines(): Graphic3d_ZLayerId;
  InitLine(): void;
  MoreLine(): Standard_Boolean;
  NextLine(): void;
  CurrentLine(): TopOpeBRep_LineInter;
  CurrentLineIndex(): Graphic3d_ZLayerId;
  ChangeLine(IL: Graphic3d_ZLayerId): TopOpeBRep_LineInter;
  ForceTolerances(tolarc: Quantity_AbsorbedDose, toltang: Quantity_AbsorbedDose): void;
  GetTolerances(tolarc: Quantity_AbsorbedDose, toltang: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class TopOpeBRep_ShapeIntersector2d {
  constructor()
  InitIntersection(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  Shape(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  MoreIntersection(): Standard_Boolean;
  NextIntersection(): void;
  ChangeEdgesIntersector(): TopOpeBRep_EdgesIntersector;
  CurrentGeomShape(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  DumpCurrent(K: Graphic3d_ZLayerId): void;
  Index(K: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TopOpeBRep_WPointInterIterator {
  Init_1(LI: TopOpeBRep_LineInter): void;
  Init_2(): void;
  More(): Standard_Boolean;
  Next(): void;
  CurrentWP(): TopOpeBRep_WPointInter;
  PLineInterDummy(): TopOpeBRep_PLineInter;
  delete(): void;
}

  export declare class TopOpeBRep_WPointInterIterator_1 extends TopOpeBRep_WPointInterIterator {
    constructor();
  }

  export declare class TopOpeBRep_WPointInterIterator_2 extends TopOpeBRep_WPointInterIterator {
    constructor(LI: TopOpeBRep_LineInter);
  }

export declare class TopOpeBRep_GeomTool {
  constructor();
  static MakeCurves(min: Quantity_AbsorbedDose, max: Quantity_AbsorbedDose, L: TopOpeBRep_LineInter, S1: TopoDS_Shape, S2: TopoDS_Shape, C: TopOpeBRepDS_Curve, PC1: Handle_Geom2d_Curve, PC2: Handle_Geom2d_Curve): void;
  static MakeCurve(min: Quantity_AbsorbedDose, max: Quantity_AbsorbedDose, L: TopOpeBRep_LineInter, C: Handle_Geom_Curve): void;
  static MakeBSpline1fromWALKING3d(L: TopOpeBRep_LineInter): Handle_Geom_Curve;
  static MakeBSpline1fromWALKING2d(L: TopOpeBRep_LineInter, SI: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  delete(): void;
}

export declare class TopOpeBRep_SequenceOfPoint2d extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TopOpeBRep_SequenceOfPoint2d): TopOpeBRep_SequenceOfPoint2d;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TopOpeBRep_Point2d): void;
  Append_2(theSeq: TopOpeBRep_SequenceOfPoint2d): void;
  Prepend_1(theItem: TopOpeBRep_Point2d): void;
  Prepend_2(theSeq: TopOpeBRep_SequenceOfPoint2d): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TopOpeBRep_Point2d): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TopOpeBRep_SequenceOfPoint2d): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TopOpeBRep_SequenceOfPoint2d): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TopOpeBRep_Point2d): void;
  Split(theIndex: Standard_Integer, theSeq: TopOpeBRep_SequenceOfPoint2d): void;
  First(): TopOpeBRep_Point2d;
  ChangeFirst(): TopOpeBRep_Point2d;
  Last(): TopOpeBRep_Point2d;
  ChangeLast(): TopOpeBRep_Point2d;
  Value(theIndex: Standard_Integer): TopOpeBRep_Point2d;
  ChangeValue(theIndex: Standard_Integer): TopOpeBRep_Point2d;
  SetValue(theIndex: Standard_Integer, theItem: TopOpeBRep_Point2d): void;
  delete(): void;
}

  export declare class TopOpeBRep_SequenceOfPoint2d_1 extends TopOpeBRep_SequenceOfPoint2d {
    constructor();
  }

  export declare class TopOpeBRep_SequenceOfPoint2d_2 extends TopOpeBRep_SequenceOfPoint2d {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRep_SequenceOfPoint2d_3 extends TopOpeBRep_SequenceOfPoint2d {
    constructor(theOther: TopOpeBRep_SequenceOfPoint2d);
  }

export declare class TopOpeBRep_FaceEdgeIntersector {
  constructor()
  Perform(F: TopoDS_Shape, E: TopoDS_Shape): void;
  IsEmpty(): Standard_Boolean;
  Shape(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  ForceTolerance(tol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  NbPoints(): Graphic3d_ZLayerId;
  InitPoint(): void;
  MorePoint(): Standard_Boolean;
  NextPoint(): void;
  Value(): gp_Pnt;
  Parameter(): Quantity_AbsorbedDose;
  UVPoint(P: gp_Pnt2d): void;
  State(): TopAbs_State;
  Transition(Index: Graphic3d_ZLayerId, FaceOrientation: TopAbs_Orientation): TopOpeBRepDS_Transition;
  IsVertex_1(S: TopoDS_Shape, P: gp_Pnt, Tol: Quantity_AbsorbedDose, V: TopoDS_Vertex): Standard_Boolean;
  IsVertex_2(I: Graphic3d_ZLayerId, V: TopoDS_Vertex): Standard_Boolean;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TopOpeBRep_FFTransitionTool {
  constructor();
  static ProcessLineTransition_1(P: TopOpeBRep_VPointInter, Index: Graphic3d_ZLayerId, EdgeOrientation: TopAbs_Orientation): TopOpeBRepDS_Transition;
  static ProcessLineTransition_2(P: TopOpeBRep_VPointInter, L: TopOpeBRep_LineInter): TopOpeBRepDS_Transition;
  static ProcessEdgeTransition(P: TopOpeBRep_VPointInter, Index: Graphic3d_ZLayerId, LineOrientation: TopAbs_Orientation): TopOpeBRepDS_Transition;
  static ProcessFaceTransition(L: TopOpeBRep_LineInter, Index: Graphic3d_ZLayerId, FaceOrientation: TopAbs_Orientation): TopOpeBRepDS_Transition;
  static ProcessEdgeONTransition(VP: TopOpeBRep_VPointInter, Index: Graphic3d_ZLayerId, R: TopoDS_Shape, E: TopoDS_Shape, F: TopoDS_Shape): TopOpeBRepDS_Transition;
  delete(): void;
}

export declare class TopOpeBRep_VPointInterClassifier {
  constructor()
  VPointPosition(F: TopoDS_Shape, VP: TopOpeBRep_VPointInter, ShapeIndex: Graphic3d_ZLayerId, PC: TopOpeBRep_PointClassifier, AssumeINON: Standard_Boolean, Tol: Quantity_AbsorbedDose): TopAbs_State;
  Edge(): TopoDS_Shape;
  EdgeParameter(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_TopOpeBRep_HArray1OfVPointInter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRep_HArray1OfVPointInter): void;
  get(): TopOpeBRep_HArray1OfVPointInter;
  delete(): void;
}

  export declare class Handle_TopOpeBRep_HArray1OfVPointInter_1 extends Handle_TopOpeBRep_HArray1OfVPointInter {
    constructor();
  }

  export declare class Handle_TopOpeBRep_HArray1OfVPointInter_2 extends Handle_TopOpeBRep_HArray1OfVPointInter {
    constructor(thePtr: TopOpeBRep_HArray1OfVPointInter);
  }

  export declare class Handle_TopOpeBRep_HArray1OfVPointInter_3 extends Handle_TopOpeBRep_HArray1OfVPointInter {
    constructor(theHandle: Handle_TopOpeBRep_HArray1OfVPointInter);
  }

  export declare class Handle_TopOpeBRep_HArray1OfVPointInter_4 extends Handle_TopOpeBRep_HArray1OfVPointInter {
    constructor(theHandle: Handle_TopOpeBRep_HArray1OfVPointInter);
  }

export declare class TopOpeBRep {
  constructor();
  delete(): void;
}

export declare class TopOpeBRep_PointClassifier {
  constructor()
  Init(): void;
  Load(F: TopoDS_Face): void;
  Classify(F: TopoDS_Face, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose): TopAbs_State;
  State(): TopAbs_State;
  delete(): void;
}

export declare class TopOpeBRep_ListOfBipoint extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopOpeBRep_ListOfBipoint): TopOpeBRep_ListOfBipoint;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopOpeBRep_Bipoint;
  First_2(): TopOpeBRep_Bipoint;
  Last_1(): TopOpeBRep_Bipoint;
  Last_2(): TopOpeBRep_Bipoint;
  Append_1(theItem: TopOpeBRep_Bipoint): TopOpeBRep_Bipoint;
  Append_3(theOther: TopOpeBRep_ListOfBipoint): void;
  Prepend_1(theItem: TopOpeBRep_Bipoint): TopOpeBRep_Bipoint;
  Prepend_2(theOther: TopOpeBRep_ListOfBipoint): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopOpeBRep_ListOfBipoint_1 extends TopOpeBRep_ListOfBipoint {
    constructor();
  }

  export declare class TopOpeBRep_ListOfBipoint_2 extends TopOpeBRep_ListOfBipoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRep_ListOfBipoint_3 extends TopOpeBRep_ListOfBipoint {
    constructor(theOther: TopOpeBRep_ListOfBipoint);
  }

export declare class TopOpeBRep_WPointInter {
  constructor()
  Set(P: IntSurf_PntOn2S): void;
  ParametersOnS1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  ParametersOnS2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Parameters(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  ValueOnS1(): gp_Pnt2d;
  ValueOnS2(): gp_Pnt2d;
  Value(): gp_Pnt;
  PPntOn2SDummy(): TopOpeBRep_PPntOn2S;
  delete(): void;
}

export declare class Handle_TopOpeBRep_FFDumper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRep_FFDumper): void;
  get(): TopOpeBRep_FFDumper;
  delete(): void;
}

  export declare class Handle_TopOpeBRep_FFDumper_1 extends Handle_TopOpeBRep_FFDumper {
    constructor();
  }

  export declare class Handle_TopOpeBRep_FFDumper_2 extends Handle_TopOpeBRep_FFDumper {
    constructor(thePtr: TopOpeBRep_FFDumper);
  }

  export declare class Handle_TopOpeBRep_FFDumper_3 extends Handle_TopOpeBRep_FFDumper {
    constructor(theHandle: Handle_TopOpeBRep_FFDumper);
  }

  export declare class Handle_TopOpeBRep_FFDumper_4 extends Handle_TopOpeBRep_FFDumper {
    constructor(theHandle: Handle_TopOpeBRep_FFDumper);
  }

export declare class TopOpeBRep_FFDumper extends Standard_Transient {
  constructor(PFF: TopOpeBRep_PFacesFiller)
  Init(PFF: TopOpeBRep_PFacesFiller): void;
  DumpLine_1(I: Graphic3d_ZLayerId): void;
  DumpLine_2(L: TopOpeBRep_LineInter): void;
  DumpVP_1(VP: TopOpeBRep_VPointInter): void;
  DumpVP_2(VP: TopOpeBRep_VPointInter, ISI: Graphic3d_ZLayerId): void;
  ExploreIndex(S: TopoDS_Shape, ISI: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  DumpDSP(VP: TopOpeBRep_VPointInter, GK: TopOpeBRepDS_Kind, G: Graphic3d_ZLayerId, newinDS: Standard_Boolean): void;
  PFacesFillerDummy(): TopOpeBRep_PFacesFiller;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type TopOpeBRep_TypeLineCurve = {
  TopOpeBRep_ANALYTIC: {};
  TopOpeBRep_RESTRICTION: {};
  TopOpeBRep_WALKING: {};
  TopOpeBRep_LINE: {};
  TopOpeBRep_CIRCLE: {};
  TopOpeBRep_ELLIPSE: {};
  TopOpeBRep_PARABOLA: {};
  TopOpeBRep_HYPERBOLA: {};
  TopOpeBRep_OTHERTYPE: {};
}

export declare class TopOpeBRep_Point2d {
  constructor()
  Dump(ie1: Graphic3d_ZLayerId, ie2: Graphic3d_ZLayerId): void;
  SetPint(P: IntRes2d_IntersectionPoint): void;
  HasPint(): Standard_Boolean;
  Pint(): IntRes2d_IntersectionPoint;
  SetIsVertex(I: Graphic3d_ZLayerId, B: Standard_Boolean): void;
  IsVertex(I: Graphic3d_ZLayerId): Standard_Boolean;
  SetVertex(I: Graphic3d_ZLayerId, V: TopoDS_Vertex): void;
  Vertex(I: Graphic3d_ZLayerId): TopoDS_Vertex;
  SetTransition(I: Graphic3d_ZLayerId, T: TopOpeBRepDS_Transition): void;
  Transition(I: Graphic3d_ZLayerId): TopOpeBRepDS_Transition;
  ChangeTransition(I: Graphic3d_ZLayerId): TopOpeBRepDS_Transition;
  SetParameter(I: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose): void;
  Parameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetIsPointOfSegment(B: Standard_Boolean): void;
  IsPointOfSegment(): Standard_Boolean;
  SetSegmentAncestors(IP1: Graphic3d_ZLayerId, IP2: Graphic3d_ZLayerId): void;
  SegmentAncestors(IP1: Graphic3d_ZLayerId, IP2: Graphic3d_ZLayerId): Standard_Boolean;
  SetStatus(S: TopOpeBRep_P2Dstatus): void;
  Status(): TopOpeBRep_P2Dstatus;
  SetIndex(X: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  SetValue(P: gp_Pnt): void;
  Value(): gp_Pnt;
  SetValue2d(P: gp_Pnt2d): void;
  Value2d(): gp_Pnt2d;
  SetKeep(B: Standard_Boolean): void;
  Keep(): Standard_Boolean;
  SetEdgesConfig(C: TopOpeBRepDS_Config): void;
  EdgesConfig(): TopOpeBRepDS_Config;
  SetTolerance(T: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  SetHctxff2d(ff2d: Handle_TopOpeBRep_Hctxff2d): void;
  Hctxff2d(): Handle_TopOpeBRep_Hctxff2d;
  SetHctxee2d(ee2d: Handle_TopOpeBRep_Hctxee2d): void;
  Hctxee2d(): Handle_TopOpeBRep_Hctxee2d;
  delete(): void;
}

export declare class TopOpeBRep_Bipoint {
  I1(): Graphic3d_ZLayerId;
  I2(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRep_Bipoint_1 extends TopOpeBRep_Bipoint {
    constructor();
  }

  export declare class TopOpeBRep_Bipoint_2 extends TopOpeBRep_Bipoint {
    constructor(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId);
  }

export declare class TopOpeBRep_ShapeScanner {
  constructor()
  Clear(): void;
  AddBoxesMakeCOB(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum): void;
  Init_1(E: TopoDS_Shape): void;
  Init_2(X: TopOpeBRepTool_ShapeExplorer): void;
  More(): Standard_Boolean;
  Next(): void;
  Current(): TopoDS_Shape;
  BoxSort(): TopOpeBRepTool_BoxSort;
  ChangeBoxSort(): TopOpeBRepTool_BoxSort;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TopOpeBRep_ShapeIntersector {
  constructor()
  InitIntersection_1(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  InitIntersection_2(S1: TopoDS_Shape, S2: TopoDS_Shape, F1: TopoDS_Face, F2: TopoDS_Face): void;
  Shape(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  MoreIntersection(): Standard_Boolean;
  NextIntersection(): void;
  ChangeFacesIntersector(): TopOpeBRep_FacesIntersector;
  ChangeEdgesIntersector(): TopOpeBRep_EdgesIntersector;
  ChangeFaceEdgeIntersector(): TopOpeBRep_FaceEdgeIntersector;
  CurrentGeomShape(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  GetTolerances(tol1: Quantity_AbsorbedDose, tol2: Quantity_AbsorbedDose): void;
  DumpCurrent(K: Graphic3d_ZLayerId): void;
  Index(K: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  RejectedFaces(anObj: TopoDS_Shape, aReference: TopoDS_Shape, aListOfShape: TopTools_ListOfShape): void;
  delete(): void;
}

export declare class TopOpeBRep_LineInter {
  constructor()
  SetLine(L: Handle_IntPatch_Line, S1: BRepAdaptor_Surface, S2: BRepAdaptor_Surface): void;
  SetFaces(F1: TopoDS_Face, F2: TopoDS_Face): void;
  TypeLineCurve(): TopOpeBRep_TypeLineCurve;
  NbVPoint(): Graphic3d_ZLayerId;
  VPoint(I: Graphic3d_ZLayerId): TopOpeBRep_VPointInter;
  ChangeVPoint(I: Graphic3d_ZLayerId): TopOpeBRep_VPointInter;
  SetINL(): void;
  INL(): Standard_Boolean;
  SetIsVClosed(): void;
  IsVClosed(): Standard_Boolean;
  SetOK(B: Standard_Boolean): void;
  OK(): Standard_Boolean;
  SetHasVPonR(): void;
  HasVPonR(): Standard_Boolean;
  SetVPBounds(): void;
  VPBounds(f: Graphic3d_ZLayerId, l: Graphic3d_ZLayerId, n: Graphic3d_ZLayerId): void;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Bounds(f: Quantity_AbsorbedDose, l: Quantity_AbsorbedDose): void;
  HasVInternal(): Standard_Boolean;
  NbWPoint(): Graphic3d_ZLayerId;
  WPoint(I: Graphic3d_ZLayerId): TopOpeBRep_WPointInter;
  TransitionOnS1(): IntSurf_TypeTrans;
  TransitionOnS2(): IntSurf_TypeTrans;
  SituationS1(): IntSurf_Situation;
  SituationS2(): IntSurf_Situation;
  Curve_1(): Handle_Geom_Curve;
  Curve_2(parmin: Quantity_AbsorbedDose, parmax: Quantity_AbsorbedDose): Handle_Geom_Curve;
  Arc(): TopoDS_Shape;
  ArcIsEdge(I: Graphic3d_ZLayerId): Standard_Boolean;
  LineW(): Handle_IntPatch_WLine;
  LineG(): Handle_IntPatch_GLine;
  LineR(): Handle_IntPatch_RLine;
  HasFirstPoint(): Standard_Boolean;
  HasLastPoint(): Standard_Boolean;
  ComputeFaceFaceTransition(): void;
  FaceFaceTransition(I: Graphic3d_ZLayerId): TopOpeBRepDS_Transition;
  Index_1(I: Graphic3d_ZLayerId): void;
  Index_2(): Graphic3d_ZLayerId;
  DumpType(): void;
  DumpVPoint(I: Graphic3d_ZLayerId, s1: XCAFDoc_PartId, s2: XCAFDoc_PartId): void;
  DumpBipoint(B: TopOpeBRep_Bipoint, s1: XCAFDoc_PartId, s2: XCAFDoc_PartId): void;
  SetTraceIndex(exF1: Graphic3d_ZLayerId, exF2: Graphic3d_ZLayerId): void;
  GetTraceIndex(exF1: Graphic3d_ZLayerId, exF2: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopBas_TestInterference {
  Intersection_1(I: Quantity_AbsorbedDose): void;
  Boundary_1(B: Graphic3d_ZLayerId): void;
  Orientation_1(O: TopAbs_Orientation): void;
  Transition_1(Tr: TopAbs_Orientation): void;
  BoundaryTransition_1(BTr: TopAbs_Orientation): void;
  Intersection_2(): Quantity_AbsorbedDose;
  ChangeIntersection(): Quantity_AbsorbedDose;
  Boundary_2(): Graphic3d_ZLayerId;
  ChangeBoundary(): Graphic3d_ZLayerId;
  Orientation_2(): TopAbs_Orientation;
  Transition_2(): TopAbs_Orientation;
  BoundaryTransition_2(): TopAbs_Orientation;
  delete(): void;
}

  export declare class TopBas_TestInterference_1 extends TopBas_TestInterference {
    constructor();
  }

  export declare class TopBas_TestInterference_2 extends TopBas_TestInterference {
    constructor(Inters: Quantity_AbsorbedDose, Bound: Graphic3d_ZLayerId, Orient: TopAbs_Orientation, Trans: TopAbs_Orientation, BTrans: TopAbs_Orientation);
  }

export declare class TopBas_ListOfTestInterference extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopBas_ListOfTestInterference): TopBas_ListOfTestInterference;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopBas_TestInterference;
  First_2(): TopBas_TestInterference;
  Last_1(): TopBas_TestInterference;
  Last_2(): TopBas_TestInterference;
  Append_1(theItem: TopBas_TestInterference): TopBas_TestInterference;
  Append_3(theOther: TopBas_ListOfTestInterference): void;
  Prepend_1(theItem: TopBas_TestInterference): TopBas_TestInterference;
  Prepend_2(theOther: TopBas_ListOfTestInterference): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopBas_ListOfTestInterference_1 extends TopBas_ListOfTestInterference {
    constructor();
  }

  export declare class TopBas_ListOfTestInterference_2 extends TopBas_ListOfTestInterference {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopBas_ListOfTestInterference_3 extends TopBas_ListOfTestInterference {
    constructor(theOther: TopBas_ListOfTestInterference);
  }

export declare class Geom2dLProp_NumericCurInf2d {
  constructor()
  PerformCurExt_1(C: Handle_Geom2d_Curve, Result: LProp_CurAndInf): void;
  PerformInf_1(C: Handle_Geom2d_Curve, Result: LProp_CurAndInf): void;
  PerformCurExt_2(C: Handle_Geom2d_Curve, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, Result: LProp_CurAndInf): void;
  PerformInf_2(C: Handle_Geom2d_Curve, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, Result: LProp_CurAndInf): void;
  IsDone(): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dLProp_CLProps2d {
  SetParameter(U: Quantity_AbsorbedDose): void;
  SetCurve(C: Handle_Geom2d_Curve): void;
  Value(): gp_Pnt2d;
  D1(): gp_Vec2d;
  D2(): gp_Vec2d;
  D3(): gp_Vec2d;
  IsTangentDefined(): Standard_Boolean;
  Tangent(D: gp_Dir2d): void;
  Curvature(): Quantity_AbsorbedDose;
  Normal(N: gp_Dir2d): void;
  CentreOfCurvature(P: gp_Pnt2d): void;
  delete(): void;
}

  export declare class Geom2dLProp_CLProps2d_1 extends Geom2dLProp_CLProps2d {
    constructor(C: Handle_Geom2d_Curve, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class Geom2dLProp_CLProps2d_2 extends Geom2dLProp_CLProps2d {
    constructor(C: Handle_Geom2d_Curve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class Geom2dLProp_CLProps2d_3 extends Geom2dLProp_CLProps2d {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class Geom2dLProp_FuncCurExt extends math_FunctionWithDerivative {
  constructor(C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  IsMinKC(Param: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dLProp_Curve2dTool {
  constructor();
  static Value(C: Handle_Geom2d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Handle_Geom2d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D2(C: Handle_Geom2d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(C: Handle_Geom2d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static Continuity(C: Handle_Geom2d_Curve): Graphic3d_ZLayerId;
  static FirstParameter(C: Handle_Geom2d_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Geom2d_Curve): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Geom2dLProp_FuncCurNul extends math_FunctionWithDerivative {
  constructor(C: Handle_Geom2d_Curve)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dLProp_CurAndInf2d extends LProp_CurAndInf {
  constructor()
  Perform(C: Handle_Geom2d_Curve): void;
  PerformCurExt(C: Handle_Geom2d_Curve): void;
  PerformInf(C: Handle_Geom2d_Curve): void;
  IsDone(): Standard_Boolean;
  delete(): void;
}

export declare class ChFi3d_FilBuilder extends ChFi3d_Builder {
  constructor(S: TopoDS_Shape, FShape: ChFi3d_FilletShape, Ta: Quantity_AbsorbedDose)
  SetFilletShape(FShape: ChFi3d_FilletShape): void;
  GetFilletShape(): ChFi3d_FilletShape;
  Add_1(E: TopoDS_Edge): void;
  Add_2(Radius: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  SetRadius_1(C: Handle_Law_Function, IC: Graphic3d_ZLayerId, IinC: Graphic3d_ZLayerId): void;
  IsConstant_1(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Radius_1(IC: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ResetContour(IC: Graphic3d_ZLayerId): void;
  SetRadius_2(Radius: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, E: TopoDS_Edge): void;
  UnSet_1(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): void;
  SetRadius_3(Radius: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): void;
  UnSet_2(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): void;
  SetRadius_4(UandR: gp_XY, IC: Graphic3d_ZLayerId, IinC: Graphic3d_ZLayerId): void;
  IsConstant_2(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): Standard_Boolean;
  Radius_2(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): Quantity_AbsorbedDose;
  GetBounds(IC: Graphic3d_ZLayerId, E: TopoDS_Edge, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  GetLaw(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): Handle_Law_Function;
  SetLaw(IC: Graphic3d_ZLayerId, E: TopoDS_Edge, L: Handle_Law_Function): void;
  Simulate(IC: Graphic3d_ZLayerId): void;
  NbSurf(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Sect(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_ChFiDS_SecHArray1;
  delete(): void;
}

export declare class ChFi3d {
  constructor();
  static DefineConnectType(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, SinTol: Quantity_AbsorbedDose, CorrectPoint: Standard_Boolean): ChFiDS_TypeOfConcavity;
  static IsTangentFaces(theEdge: TopoDS_Edge, theFace1: TopoDS_Face, theFace2: TopoDS_Face, Order: GeomAbs_Shape): Standard_Boolean;
  static ConcaveSide(S1: BRepAdaptor_Surface, S2: BRepAdaptor_Surface, E: TopoDS_Edge, Or1: TopAbs_Orientation, Or2: TopAbs_Orientation): Graphic3d_ZLayerId;
  static NextSide_1(Or1: TopAbs_Orientation, Or2: TopAbs_Orientation, OrSave1: TopAbs_Orientation, OrSave2: TopAbs_Orientation, ChoixSauv: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static NextSide_2(Or: TopAbs_Orientation, OrSave: TopAbs_Orientation, OrFace: TopAbs_Orientation): void;
  static SameSide(Or: TopAbs_Orientation, OrSave1: TopAbs_Orientation, OrSave2: TopAbs_Orientation, OrFace1: TopAbs_Orientation, OrFace2: TopAbs_Orientation): Standard_Boolean;
  delete(): void;
}

export declare class ChFi3d_SearchSing extends math_FunctionWithDerivative {
  constructor(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class ChFi3d_ChBuilder extends ChFi3d_Builder {
  constructor(S: TopoDS_Shape, Ta: Quantity_AbsorbedDose)
  Add_1(E: TopoDS_Edge): void;
  Add_2(Dis: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  SetDist(Dis: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, F: TopoDS_Face): void;
  GetDist(IC: Graphic3d_ZLayerId, Dis: Quantity_AbsorbedDose): void;
  Add_3(Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face): void;
  SetDists(Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, F: TopoDS_Face): void;
  Dists(IC: Graphic3d_ZLayerId, Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose): void;
  AddDA(Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face): void;
  SetDistAngle(Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, F: TopoDS_Face): void;
  GetDistAngle(IC: Graphic3d_ZLayerId, Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose): void;
  SetMode(theMode: ChFiDS_ChamfMode): void;
  IsChamfer(IC: Graphic3d_ZLayerId): ChFiDS_ChamfMethod;
  Mode(): ChFiDS_ChamfMode;
  ResetContour(IC: Graphic3d_ZLayerId): void;
  Simulate(IC: Graphic3d_ZLayerId): void;
  NbSurf(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Sect(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_ChFiDS_SecHArray1;
  SimulSurf_1(Data: Handle_ChFiDS_SurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, PC1: Handle_BRepAdaptor_HCurve2d, Sref1: Handle_BRepAdaptor_HSurface, PCref1: Handle_BRepAdaptor_HCurve2d, Decroch1: Standard_Boolean, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, Or2: TopAbs_Orientation, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecP: Standard_Boolean, RecS: Standard_Boolean, RecRst: Standard_Boolean, Soldep: math_Vector): void;
  SimulSurf_2(Data: Handle_ChFiDS_SurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, Or1: TopAbs_Orientation, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, PC2: Handle_BRepAdaptor_HCurve2d, Sref2: Handle_BRepAdaptor_HSurface, PCref2: Handle_BRepAdaptor_HCurve2d, Decroch2: Standard_Boolean, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecP: Standard_Boolean, RecS: Standard_Boolean, RecRst: Standard_Boolean, Soldep: math_Vector): void;
  SimulSurf_3(Data: Handle_ChFiDS_SurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, PC1: Handle_BRepAdaptor_HCurve2d, Sref1: Handle_BRepAdaptor_HSurface, PCref1: Handle_BRepAdaptor_HCurve2d, Decroch1: Standard_Boolean, Or1: TopAbs_Orientation, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, PC2: Handle_BRepAdaptor_HCurve2d, Sref2: Handle_BRepAdaptor_HSurface, PCref2: Handle_BRepAdaptor_HCurve2d, Decroch2: Standard_Boolean, Or2: TopAbs_Orientation, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecP1: Standard_Boolean, RecRst1: Standard_Boolean, RecP2: Standard_Boolean, RecRst2: Standard_Boolean, Soldep: math_Vector): void;
  PerformSurf_1(Data: ChFiDS_SequenceOfSurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, MaxStep: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecOnS1: Standard_Boolean, RecOnS2: Standard_Boolean, Soldep: math_Vector, Intf: Graphic3d_ZLayerId, Intl: Graphic3d_ZLayerId): Standard_Boolean;
  PerformSurf_2(Data: ChFiDS_SequenceOfSurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, PC1: Handle_BRepAdaptor_HCurve2d, Sref1: Handle_BRepAdaptor_HSurface, PCref1: Handle_BRepAdaptor_HCurve2d, Decroch1: Standard_Boolean, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, Or2: TopAbs_Orientation, MaxStep: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecP: Standard_Boolean, RecS: Standard_Boolean, RecRst: Standard_Boolean, Soldep: math_Vector): void;
  PerformSurf_3(Data: ChFiDS_SequenceOfSurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, Or1: TopAbs_Orientation, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, PC2: Handle_BRepAdaptor_HCurve2d, Sref2: Handle_BRepAdaptor_HSurface, PCref2: Handle_BRepAdaptor_HCurve2d, Decroch2: Standard_Boolean, MaxStep: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecP: Standard_Boolean, RecS: Standard_Boolean, RecRst: Standard_Boolean, Soldep: math_Vector): void;
  PerformSurf_4(Data: ChFiDS_SequenceOfSurfData, Guide: Handle_ChFiDS_HElSpine, Spine: Handle_ChFiDS_Spine, Choix: Graphic3d_ZLayerId, S1: Handle_BRepAdaptor_HSurface, I1: Handle_Adaptor3d_TopolTool, PC1: Handle_BRepAdaptor_HCurve2d, Sref1: Handle_BRepAdaptor_HSurface, PCref1: Handle_BRepAdaptor_HCurve2d, Decroch1: Standard_Boolean, Or1: TopAbs_Orientation, S2: Handle_BRepAdaptor_HSurface, I2: Handle_Adaptor3d_TopolTool, PC2: Handle_BRepAdaptor_HCurve2d, Sref2: Handle_BRepAdaptor_HSurface, PCref2: Handle_BRepAdaptor_HCurve2d, Decroch2: Standard_Boolean, Or2: TopAbs_Orientation, MaxStep: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Inside: Standard_Boolean, Appro: Standard_Boolean, Forward: Standard_Boolean, RecP1: Standard_Boolean, RecRst1: Standard_Boolean, RecP2: Standard_Boolean, RecRst2: Standard_Boolean, Soldep: math_Vector): void;
  delete(): void;
}

export declare class ChFi3d_Builder {
  SetParams(Tang: Quantity_AbsorbedDose, Tesp: Quantity_AbsorbedDose, T2d: Quantity_AbsorbedDose, TApp3d: Quantity_AbsorbedDose, TolApp2d: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose): void;
  SetContinuity(InternalContinuity: GeomAbs_Shape, AngularTolerance: Quantity_AbsorbedDose): void;
  Remove(E: TopoDS_Edge): void;
  Contains_1(E: TopoDS_Edge): Graphic3d_ZLayerId;
  Contains_2(E: TopoDS_Edge, IndexInSpine: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbElements(): Graphic3d_ZLayerId;
  Value(I: Graphic3d_ZLayerId): Handle_ChFiDS_Spine;
  Length(IC: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  FirstVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  LastVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  Abscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  RelativeAbscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  ClosedAndTangent(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Closed(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Compute(): void;
  IsDone(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  Generated(EouV: TopoDS_Shape): TopTools_ListOfShape;
  NbFaultyContours(): Graphic3d_ZLayerId;
  FaultyContour(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbComputedSurfaces(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ComputedSurface(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_Geom_Surface;
  NbFaultyVertices(): Graphic3d_ZLayerId;
  FaultyVertex(IV: Graphic3d_ZLayerId): TopoDS_Vertex;
  HasResult(): Standard_Boolean;
  BadShape(): TopoDS_Shape;
  StripeStatus(IC: Graphic3d_ZLayerId): ChFiDS_ErrorStatus;
  Reset(): void;
  Builder(): Handle_TopOpeBRepBuild_HBuilder;
  SplitKPart(Data: Handle_ChFiDS_SurfData, SetData: ChFiDS_SequenceOfSurfData, Spine: Handle_ChFiDS_Spine, Iedge: Graphic3d_ZLayerId, S1: Handle_Adaptor3d_HSurface, I1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, I2: Handle_Adaptor3d_TopolTool, Intf: Standard_Boolean, Intl: Standard_Boolean): Standard_Boolean;
  PerformTwoCornerbyInter(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare type ChFi3d_FilletShape = {
  ChFi3d_Rational: {};
  ChFi3d_QuasiAngular: {};
  ChFi3d_Polynomial: {};
}

export declare class BRepBlend_SurfRstEvolRad extends Blend_SurfRstFunction {
  constructor(Surf: Handle_Adaptor3d_HSurface, SurfRst: Handle_Adaptor3d_HSurface, Rst: Handle_Adaptor2d_HCurve2d, CGuide: Handle_Adaptor3d_HCurve, Evol: Handle_Law_Function)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(SurfRef: Handle_Adaptor3d_HSurface, RstRef: Handle_Adaptor2d_HCurve2d): void;
  Set_2(Param: Quantity_AbsorbedDose): void;
  Set_3(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnS(): gp_Pnt;
  PointOnRst(): gp_Pnt;
  Pnt2dOnS(): gp_Pnt2d;
  Pnt2dOnRst(): gp_Pnt2d;
  ParameterOnRst(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2dOnS(): gp_Vec2d;
  TangentOnRst(): gp_Vec;
  Tangent2dOnRst(): gp_Vec2d;
  Decroch(Sol: math_Vector, NS: gp_Vec, TgS: gp_Vec): Standard_Boolean;
  Set_4(Choix: Graphic3d_ZLayerId): void;
  Set_5(TypeSection: BlendFunc_SectionShape): void;
  Section_1(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BRepBlend_RstRstLineBuilder {
  constructor(Surf1: Handle_Adaptor3d_HSurface, Rst1: Handle_Adaptor2d_HCurve2d, Domain1: Handle_Adaptor3d_TopolTool, Surf2: Handle_Adaptor3d_HSurface, Rst2: Handle_Adaptor2d_HCurve2d, Domain2: Handle_Adaptor3d_TopolTool)
  Perform(Func: Blend_RstRstFunction, Finv1: Blend_SurfCurvFuncInv, FinvP1: Blend_CurvPointFuncInv, Finv2: Blend_SurfCurvFuncInv, FinvP2: Blend_CurvPointFuncInv, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, MaxStep: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, Soldep: math_Vector, Tolesp: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, Appro: Standard_Boolean): void;
  PerformFirstSection(Func: Blend_RstRstFunction, Finv1: Blend_SurfCurvFuncInv, FinvP1: Blend_CurvPointFuncInv, Finv2: Blend_SurfCurvFuncInv, FinvP2: Blend_CurvPointFuncInv, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, Soldep: math_Vector, Tolesp: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, RecRst1: Standard_Boolean, RecP1: Standard_Boolean, RecRst2: Standard_Boolean, RecP2: Standard_Boolean, Psol: Quantity_AbsorbedDose, ParSol: math_Vector): Standard_Boolean;
  Complete(Func: Blend_RstRstFunction, Finv1: Blend_SurfCurvFuncInv, FinvP1: Blend_CurvPointFuncInv, Finv2: Blend_SurfCurvFuncInv, FinvP2: Blend_CurvPointFuncInv, Pmin: Quantity_AbsorbedDose): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Line(): Handle_BRepBlend_Line;
  Decroch1Start(): Standard_Boolean;
  Decroch1End(): Standard_Boolean;
  Decroch2Start(): Standard_Boolean;
  Decroch2End(): Standard_Boolean;
  delete(): void;
}

export declare class BRepBlend_SurfPointConstRadInv extends Blend_SurfPointFuncInv {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  Set_1(R: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(P: gp_Pnt): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepBlend_Walking {
  constructor(Surf1: Handle_Adaptor3d_HSurface, Surf2: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, Domain2: Handle_Adaptor3d_TopolTool, HGuide: Handle_ChFiDS_HElSpine)
  SetDomainsToRecadre(RecDomain1: Handle_Adaptor3d_TopolTool, RecDomain2: Handle_Adaptor3d_TopolTool): void;
  AddSingularPoint(P: Blend_Point): void;
  Perform(F: Blend_Function, FInv: Blend_FuncInv, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, MaxStep: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, Soldep: math_Vector, Tolesp: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, Appro: Standard_Boolean): void;
  PerformFirstSection_1(F: Blend_Function, Pdep: Quantity_AbsorbedDose, ParDep: math_Vector, Tolesp: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, Pos1: TopAbs_State, Pos2: TopAbs_State): Standard_Boolean;
  PerformFirstSection_2(F: Blend_Function, FInv: Blend_FuncInv, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, ParDep: math_Vector, Tolesp: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, RecOnS1: Standard_Boolean, RecOnS2: Standard_Boolean, Psol: Quantity_AbsorbedDose, ParSol: math_Vector): Standard_Boolean;
  Continu_1(F: Blend_Function, FInv: Blend_FuncInv, P: Quantity_AbsorbedDose): Standard_Boolean;
  Continu_2(F: Blend_Function, FInv: Blend_FuncInv, P: Quantity_AbsorbedDose, OnS1: Standard_Boolean): Standard_Boolean;
  Complete(F: Blend_Function, FInv: Blend_FuncInv, Pmin: Quantity_AbsorbedDose): Standard_Boolean;
  ClassificationOnS1(C: Standard_Boolean): void;
  ClassificationOnS2(C: Standard_Boolean): void;
  Check2d(C: Standard_Boolean): void;
  Check(C: Standard_Boolean): void;
  TwistOnS1(): Standard_Boolean;
  TwistOnS2(): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Line(): Handle_BRepBlend_Line;
  delete(): void;
}

export declare class BRepBlend_AppSurf extends AppBlend_Approx {
  Init(Degmin: Graphic3d_ZLayerId, Degmax: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIt: Graphic3d_ZLayerId, KnownParameters: Standard_Boolean): void;
  SetParType(ParType: Approx_ParametrizationType): void;
  SetContinuity(C: GeomAbs_Shape): void;
  SetCriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  ParType(): Approx_ParametrizationType;
  Continuity(): GeomAbs_Shape;
  CriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  Perform_1(Lin: Handle_BRepBlend_Line, SecGen: Blend_AppFunction, SpApprox: Standard_Boolean): void;
  PerformSmoothing(Lin: Handle_BRepBlend_Line, SecGen: Blend_AppFunction): void;
  Perform_2(Lin: Handle_BRepBlend_Line, SecGen: Blend_AppFunction, NbMaxP: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  SurfShape(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, NbUPoles: Graphic3d_ZLayerId, NbVPoles: Graphic3d_ZLayerId, NbUKnots: Graphic3d_ZLayerId, NbVKnots: Graphic3d_ZLayerId): void;
  Surface(TPoles: TColgp_Array2OfPnt, TWeights: TColStd_Array2OfReal, TUKnots: TColStd_Array1OfReal, TVKnots: TColStd_Array1OfReal, TUMults: TColStd_Array1OfInteger, TVMults: TColStd_Array1OfInteger): void;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  SurfPoles(): TColgp_Array2OfPnt;
  SurfWeights(): TColStd_Array2OfReal;
  SurfUKnots(): TColStd_Array1OfReal;
  SurfVKnots(): TColStd_Array1OfReal;
  SurfUMults(): TColStd_Array1OfInteger;
  SurfVMults(): TColStd_Array1OfInteger;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curves2dShape(Degree: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId): void;
  Curve2d(Index: Graphic3d_ZLayerId, TPoles: TColgp_Array1OfPnt2d, TKnots: TColStd_Array1OfReal, TMults: TColStd_Array1OfInteger): void;
  Curves2dDegree(): Graphic3d_ZLayerId;
  Curve2dPoles(Index: Graphic3d_ZLayerId): TColgp_Array1OfPnt2d;
  Curves2dKnots(): TColStd_Array1OfReal;
  Curves2dMults(): TColStd_Array1OfInteger;
  TolReached(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  TolCurveOnSurf(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepBlend_AppSurf_1 extends BRepBlend_AppSurf {
    constructor();
  }

  export declare class BRepBlend_AppSurf_2 extends BRepBlend_AppSurf {
    constructor(Degmin: Graphic3d_ZLayerId, Degmax: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIt: Graphic3d_ZLayerId, KnownParameters: Standard_Boolean);
  }

export declare class BRepBlend_HCurve2dTool {
  constructor();
  static FirstParameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Continuity(C: Handle_Adaptor2d_HCurve2d): GeomAbs_Shape;
  static NbIntervals(C: Handle_Adaptor2d_HCurve2d, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Handle_Adaptor2d_HCurve2d, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static IsClosed(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static IsPeriodic(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static Period(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Value(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose): gp_Pnt2d;
  static D0(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D2(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static DN(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static Resolution(C: Handle_Adaptor2d_HCurve2d, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Handle_Adaptor2d_HCurve2d): GeomAbs_CurveType;
  static Line(C: Handle_Adaptor2d_HCurve2d): gp_Lin2d;
  static Circle(C: Handle_Adaptor2d_HCurve2d): gp_Circ2d;
  static Ellipse(C: Handle_Adaptor2d_HCurve2d): gp_Elips2d;
  static Hyperbola(C: Handle_Adaptor2d_HCurve2d): gp_Hypr2d;
  static Parabola(C: Handle_Adaptor2d_HCurve2d): gp_Parab2d;
  static Bezier(C: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BezierCurve;
  static BSpline(C: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BSplineCurve;
  static NbSamples(C: Handle_Adaptor2d_HCurve2d, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BRepBlend_CurvPointRadInv extends Blend_CurvPointFuncInv {
  constructor(C1: Handle_Adaptor3d_HCurve, C2: Handle_Adaptor3d_HCurve)
  Set_1(Choix: Graphic3d_ZLayerId): void;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(P: gp_Pnt): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepBlend_AppFuncRstRst extends BRepBlend_AppFuncRoot {
  constructor(Line: Handle_BRepBlend_Line, Func: Blend_RstRstFunction, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose)
  Point(Func: Blend_AppFunction, Param: Quantity_AbsorbedDose, Sol: math_Vector, Pnt: Blend_Point): void;
  Vec(Sol: math_Vector, Pnt: Blend_Point): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepBlend_AppFuncRstRst {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBlend_AppFuncRstRst): void;
  get(): BRepBlend_AppFuncRstRst;
  delete(): void;
}

  export declare class Handle_BRepBlend_AppFuncRstRst_1 extends Handle_BRepBlend_AppFuncRstRst {
    constructor();
  }

  export declare class Handle_BRepBlend_AppFuncRstRst_2 extends Handle_BRepBlend_AppFuncRstRst {
    constructor(thePtr: BRepBlend_AppFuncRstRst);
  }

  export declare class Handle_BRepBlend_AppFuncRstRst_3 extends Handle_BRepBlend_AppFuncRstRst {
    constructor(theHandle: Handle_BRepBlend_AppFuncRstRst);
  }

  export declare class Handle_BRepBlend_AppFuncRstRst_4 extends Handle_BRepBlend_AppFuncRstRst {
    constructor(theHandle: Handle_BRepBlend_AppFuncRstRst);
  }

export declare class BRepBlend_AppSurface extends AppBlend_Approx {
  constructor(Funct: Handle_Approx_SweepFunction, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, TolAngular: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, Degmax: Graphic3d_ZLayerId, Segmax: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  SurfShape(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, NbUPoles: Graphic3d_ZLayerId, NbVPoles: Graphic3d_ZLayerId, NbUKnots: Graphic3d_ZLayerId, NbVKnots: Graphic3d_ZLayerId): void;
  Surface(TPoles: TColgp_Array2OfPnt, TWeights: TColStd_Array2OfReal, TUKnots: TColStd_Array1OfReal, TVKnots: TColStd_Array1OfReal, TUMults: TColStd_Array1OfInteger, TVMults: TColStd_Array1OfInteger): void;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  SurfPoles(): TColgp_Array2OfPnt;
  SurfWeights(): TColStd_Array2OfReal;
  SurfUKnots(): TColStd_Array1OfReal;
  SurfVKnots(): TColStd_Array1OfReal;
  SurfUMults(): TColStd_Array1OfInteger;
  SurfVMults(): TColStd_Array1OfInteger;
  MaxErrorOnSurf(): Quantity_AbsorbedDose;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curves2dShape(Degree: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId): void;
  Curve2d(Index: Graphic3d_ZLayerId, TPoles: TColgp_Array1OfPnt2d, TKnots: TColStd_Array1OfReal, TMults: TColStd_Array1OfInteger): void;
  Curves2dDegree(): Graphic3d_ZLayerId;
  Curve2dPoles(Index: Graphic3d_ZLayerId): TColgp_Array1OfPnt2d;
  Curves2dKnots(): TColStd_Array1OfReal;
  Curves2dMults(): TColStd_Array1OfInteger;
  TolReached(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  Max2dError(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  TolCurveOnSurf(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class BRepBlend_PointOnRst {
  SetArc(A: Handle_Adaptor2d_HCurve2d, Param: Quantity_AbsorbedDose, TLine: IntSurf_Transition, TArc: IntSurf_Transition): void;
  Arc(): Handle_Adaptor2d_HCurve2d;
  TransitionOnLine(): IntSurf_Transition;
  TransitionOnArc(): IntSurf_Transition;
  ParameterOnArc(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepBlend_PointOnRst_1 extends BRepBlend_PointOnRst {
    constructor();
  }

  export declare class BRepBlend_PointOnRst_2 extends BRepBlend_PointOnRst {
    constructor(A: Handle_Adaptor2d_HCurve2d, Param: Quantity_AbsorbedDose, TLine: IntSurf_Transition, TArc: IntSurf_Transition);
  }

export declare class BRepBlend_SequenceOfPointOnRst extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepBlend_SequenceOfPointOnRst): BRepBlend_SequenceOfPointOnRst;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: BRepBlend_PointOnRst): void;
  Append_2(theSeq: BRepBlend_SequenceOfPointOnRst): void;
  Prepend_1(theItem: BRepBlend_PointOnRst): void;
  Prepend_2(theSeq: BRepBlend_SequenceOfPointOnRst): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: BRepBlend_PointOnRst): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepBlend_SequenceOfPointOnRst): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepBlend_SequenceOfPointOnRst): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: BRepBlend_PointOnRst): void;
  Split(theIndex: Standard_Integer, theSeq: BRepBlend_SequenceOfPointOnRst): void;
  First(): BRepBlend_PointOnRst;
  ChangeFirst(): BRepBlend_PointOnRst;
  Last(): BRepBlend_PointOnRst;
  ChangeLast(): BRepBlend_PointOnRst;
  Value(theIndex: Standard_Integer): BRepBlend_PointOnRst;
  ChangeValue(theIndex: Standard_Integer): BRepBlend_PointOnRst;
  SetValue(theIndex: Standard_Integer, theItem: BRepBlend_PointOnRst): void;
  delete(): void;
}

  export declare class BRepBlend_SequenceOfPointOnRst_1 extends BRepBlend_SequenceOfPointOnRst {
    constructor();
  }

  export declare class BRepBlend_SequenceOfPointOnRst_2 extends BRepBlend_SequenceOfPointOnRst {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepBlend_SequenceOfPointOnRst_3 extends BRepBlend_SequenceOfPointOnRst {
    constructor(theOther: BRepBlend_SequenceOfPointOnRst);
  }

export declare class BRepBlend_RstRstConstRad extends Blend_RstRstFunction {
  constructor(Surf1: Handle_Adaptor3d_HSurface, Rst1: Handle_Adaptor2d_HCurve2d, Surf2: Handle_Adaptor3d_HSurface, Rst2: Handle_Adaptor2d_HCurve2d, CGuide: Handle_Adaptor3d_HCurve)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(SurfRef1: Handle_Adaptor3d_HSurface, RstRef1: Handle_Adaptor2d_HCurve2d, SurfRef2: Handle_Adaptor3d_HSurface, RstRef2: Handle_Adaptor2d_HCurve2d): void;
  Set_2(Param: Quantity_AbsorbedDose): void;
  Set_3(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnRst1(): gp_Pnt;
  PointOnRst2(): gp_Pnt;
  Pnt2dOnRst1(): gp_Pnt2d;
  Pnt2dOnRst2(): gp_Pnt2d;
  ParameterOnRst1(): Quantity_AbsorbedDose;
  ParameterOnRst2(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnRst1(): gp_Vec;
  Tangent2dOnRst1(): gp_Vec2d;
  TangentOnRst2(): gp_Vec;
  Tangent2dOnRst2(): gp_Vec2d;
  Decroch(Sol: math_Vector, NRst1: gp_Vec, TgRst1: gp_Vec, NRst2: gp_Vec, TgRst2: gp_Vec): Blend_DecrochStatus;
  Set_4(Radius: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  Set_5(TypeSection: BlendFunc_SectionShape): void;
  CenterCircleRst1Rst2(PtRst1: gp_Pnt, PtRst2: gp_Pnt, np: gp_Vec, Center: gp_Pnt, VdMed: gp_Vec): Standard_Boolean;
  Section_1(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BRepBlend_SurfCurvConstRadInv extends Blend_SurfCurvFuncInv {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, Cg: Handle_Adaptor3d_HCurve)
  Set_1(R: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(Rst: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepBlend_AppFuncRst extends BRepBlend_AppFuncRoot {
  constructor(Line: Handle_BRepBlend_Line, Func: Blend_SurfRstFunction, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose)
  Point(Func: Blend_AppFunction, Param: Quantity_AbsorbedDose, Sol: math_Vector, Pnt: Blend_Point): void;
  Vec(Sol: math_Vector, Pnt: Blend_Point): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepBlend_AppFuncRst {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBlend_AppFuncRst): void;
  get(): BRepBlend_AppFuncRst;
  delete(): void;
}

  export declare class Handle_BRepBlend_AppFuncRst_1 extends Handle_BRepBlend_AppFuncRst {
    constructor();
  }

  export declare class Handle_BRepBlend_AppFuncRst_2 extends Handle_BRepBlend_AppFuncRst {
    constructor(thePtr: BRepBlend_AppFuncRst);
  }

  export declare class Handle_BRepBlend_AppFuncRst_3 extends Handle_BRepBlend_AppFuncRst {
    constructor(theHandle: Handle_BRepBlend_AppFuncRst);
  }

  export declare class Handle_BRepBlend_AppFuncRst_4 extends Handle_BRepBlend_AppFuncRst {
    constructor(theHandle: Handle_BRepBlend_AppFuncRst);
  }

export declare class BRepBlend_RstRstEvolRad extends Blend_RstRstFunction {
  constructor(Surf1: Handle_Adaptor3d_HSurface, Rst1: Handle_Adaptor2d_HCurve2d, Surf2: Handle_Adaptor3d_HSurface, Rst2: Handle_Adaptor2d_HCurve2d, CGuide: Handle_Adaptor3d_HCurve, Evol: Handle_Law_Function)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(SurfRef1: Handle_Adaptor3d_HSurface, RstRef1: Handle_Adaptor2d_HCurve2d, SurfRef2: Handle_Adaptor3d_HSurface, RstRef2: Handle_Adaptor2d_HCurve2d): void;
  Set_2(Param: Quantity_AbsorbedDose): void;
  Set_3(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnRst1(): gp_Pnt;
  PointOnRst2(): gp_Pnt;
  Pnt2dOnRst1(): gp_Pnt2d;
  Pnt2dOnRst2(): gp_Pnt2d;
  ParameterOnRst1(): Quantity_AbsorbedDose;
  ParameterOnRst2(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnRst1(): gp_Vec;
  Tangent2dOnRst1(): gp_Vec2d;
  TangentOnRst2(): gp_Vec;
  Tangent2dOnRst2(): gp_Vec2d;
  Decroch(Sol: math_Vector, NRst1: gp_Vec, TgRst1: gp_Vec, NRst2: gp_Vec, TgRst2: gp_Vec): Blend_DecrochStatus;
  Set_4(Choix: Graphic3d_ZLayerId): void;
  Set_5(TypeSection: BlendFunc_SectionShape): void;
  CenterCircleRst1Rst2(PtRst1: gp_Pnt, PtRst2: gp_Pnt, np: gp_Vec, Center: gp_Pnt, VdMed: gp_Vec): Standard_Boolean;
  Section_1(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BRepBlend_Extremity {
  SetValue_1(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  SetValue_2(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Vtx: Handle_Adaptor3d_HVertex): void;
  SetValue_3(P: gp_Pnt, W: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  SetTangent(Tangent: gp_Vec): void;
  HasTangent(): Standard_Boolean;
  Tangent(): gp_Vec;
  Tolerance(): Quantity_AbsorbedDose;
  SetVertex(V: Handle_Adaptor3d_HVertex): void;
  AddArc(A: Handle_Adaptor2d_HCurve2d, Param: Quantity_AbsorbedDose, TLine: IntSurf_Transition, TArc: IntSurf_Transition): void;
  Parameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  IsVertex(): Standard_Boolean;
  Vertex(): Handle_Adaptor3d_HVertex;
  NbPointOnRst(): Graphic3d_ZLayerId;
  PointOnRst(Index: Graphic3d_ZLayerId): BRepBlend_PointOnRst;
  Parameter(): Quantity_AbsorbedDose;
  ParameterOnGuide(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepBlend_Extremity_1 extends BRepBlend_Extremity {
    constructor();
  }

  export declare class BRepBlend_Extremity_2 extends BRepBlend_Extremity {
    constructor(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class BRepBlend_Extremity_3 extends BRepBlend_Extremity {
    constructor(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Vtx: Handle_Adaptor3d_HVertex);
  }

  export declare class BRepBlend_Extremity_4 extends BRepBlend_Extremity {
    constructor(P: gp_Pnt, W: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class BRepBlend_Line extends Standard_Transient {
  constructor()
  Clear(): void;
  Append(P: Blend_Point): void;
  Prepend(P: Blend_Point): void;
  InsertBefore(Index: Graphic3d_ZLayerId, P: Blend_Point): void;
  Remove(FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): void;
  Set_1(TranS1: IntSurf_TypeTrans, TranS2: IntSurf_TypeTrans): void;
  Set_2(Trans: IntSurf_TypeTrans): void;
  SetStartPoints(StartPt1: BRepBlend_Extremity, StartPt2: BRepBlend_Extremity): void;
  SetEndPoints(EndPt1: BRepBlend_Extremity, EndPt2: BRepBlend_Extremity): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): Blend_Point;
  TransitionOnS1(): IntSurf_TypeTrans;
  TransitionOnS2(): IntSurf_TypeTrans;
  StartPointOnFirst(): BRepBlend_Extremity;
  StartPointOnSecond(): BRepBlend_Extremity;
  EndPointOnFirst(): BRepBlend_Extremity;
  EndPointOnSecond(): BRepBlend_Extremity;
  TransitionOnS(): IntSurf_TypeTrans;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepBlend_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBlend_Line): void;
  get(): BRepBlend_Line;
  delete(): void;
}

  export declare class Handle_BRepBlend_Line_1 extends Handle_BRepBlend_Line {
    constructor();
  }

  export declare class Handle_BRepBlend_Line_2 extends Handle_BRepBlend_Line {
    constructor(thePtr: BRepBlend_Line);
  }

  export declare class Handle_BRepBlend_Line_3 extends Handle_BRepBlend_Line {
    constructor(theHandle: Handle_BRepBlend_Line);
  }

  export declare class Handle_BRepBlend_Line_4 extends Handle_BRepBlend_Line {
    constructor(theHandle: Handle_BRepBlend_Line);
  }

export declare class BRepBlend_HCurveTool {
  constructor();
  static FirstParameter(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static Continuity(C: Handle_Adaptor3d_HCurve): GeomAbs_Shape;
  static NbIntervals(C: Handle_Adaptor3d_HCurve, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Handle_Adaptor3d_HCurve, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static IsClosed(C: Handle_Adaptor3d_HCurve): Standard_Boolean;
  static IsPeriodic(C: Handle_Adaptor3d_HCurve): Standard_Boolean;
  static Period(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static Value(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose): gp_Pnt;
  static D0(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  static D2(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static DN(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static Resolution(C: Handle_Adaptor3d_HCurve, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Handle_Adaptor3d_HCurve): GeomAbs_CurveType;
  static Line(C: Handle_Adaptor3d_HCurve): gp_Lin;
  static Circle(C: Handle_Adaptor3d_HCurve): gp_Circ;
  static Ellipse(C: Handle_Adaptor3d_HCurve): gp_Elips;
  static Hyperbola(C: Handle_Adaptor3d_HCurve): gp_Hypr;
  static Parabola(C: Handle_Adaptor3d_HCurve): gp_Parab;
  static Bezier(C: Handle_Adaptor3d_HCurve): Handle_Geom_BezierCurve;
  static BSpline(C: Handle_Adaptor3d_HCurve): Handle_Geom_BSplineCurve;
  static NbSamples(C: Handle_Adaptor3d_HCurve, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BRepBlend_AppFuncRoot extends Approx_SweepFunction {
  D0(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Nb2dCurves(): Graphic3d_ZLayerId;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Resolution(Index: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  Point(Func: Blend_AppFunction, Param: Quantity_AbsorbedDose, Sol: math_Vector, Pnt: Blend_Point): void;
  Vec(Sol: math_Vector, Pnt: Blend_Point): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepBlend_AppFuncRoot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBlend_AppFuncRoot): void;
  get(): BRepBlend_AppFuncRoot;
  delete(): void;
}

  export declare class Handle_BRepBlend_AppFuncRoot_1 extends Handle_BRepBlend_AppFuncRoot {
    constructor();
  }

  export declare class Handle_BRepBlend_AppFuncRoot_2 extends Handle_BRepBlend_AppFuncRoot {
    constructor(thePtr: BRepBlend_AppFuncRoot);
  }

  export declare class Handle_BRepBlend_AppFuncRoot_3 extends Handle_BRepBlend_AppFuncRoot {
    constructor(theHandle: Handle_BRepBlend_AppFuncRoot);
  }

  export declare class Handle_BRepBlend_AppFuncRoot_4 extends Handle_BRepBlend_AppFuncRoot {
    constructor(theHandle: Handle_BRepBlend_AppFuncRoot);
  }

export declare class BRepBlend_SurfPointEvolRadInv extends Blend_SurfPointFuncInv {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, Evol: Handle_Law_Function)
  Set_1(Choix: Graphic3d_ZLayerId): void;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(P: gp_Pnt): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepBlend_CSWalking {
  constructor(Curv: Handle_Adaptor3d_HCurve, Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool)
  Perform(F: Blend_CSFunction, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, MaxStep: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, Soldep: math_Vector, Tolesp: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, Appro: Standard_Boolean): void;
  Complete(F: Blend_CSFunction, Pmin: Quantity_AbsorbedDose): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Line(): Handle_BRepBlend_Line;
  delete(): void;
}

export declare class BRepBlend_SurfRstLineBuilder {
  constructor(Surf1: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, Surf2: Handle_Adaptor3d_HSurface, Rst: Handle_Adaptor2d_HCurve2d, Domain2: Handle_Adaptor3d_TopolTool)
  Perform(Func: Blend_SurfRstFunction, Finv: Blend_FuncInv, FinvP: Blend_SurfPointFuncInv, FinvC: Blend_SurfCurvFuncInv, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, MaxStep: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, Soldep: math_Vector, Tolesp: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, Appro: Standard_Boolean): void;
  PerformFirstSection(Func: Blend_SurfRstFunction, Finv: Blend_FuncInv, FinvP: Blend_SurfPointFuncInv, FinvC: Blend_SurfCurvFuncInv, Pdep: Quantity_AbsorbedDose, Pmax: Quantity_AbsorbedDose, Soldep: math_Vector, Tolesp: Quantity_AbsorbedDose, TolGuide: Quantity_AbsorbedDose, RecRst: Standard_Boolean, RecP: Standard_Boolean, RecS: Standard_Boolean, Psol: Quantity_AbsorbedDose, ParSol: math_Vector): Standard_Boolean;
  Complete(Func: Blend_SurfRstFunction, Finv: Blend_FuncInv, FinvP: Blend_SurfPointFuncInv, FinvC: Blend_SurfCurvFuncInv, Pmin: Quantity_AbsorbedDose): Standard_Boolean;
  ArcToRecadre(Sol: math_Vector, PrevIndex: Graphic3d_ZLayerId, pt2d: gp_Pnt2d, lastpt2d: gp_Pnt2d, ponarc: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  IsDone(): Standard_Boolean;
  Line(): Handle_BRepBlend_Line;
  DecrochStart(): Standard_Boolean;
  DecrochEnd(): Standard_Boolean;
  delete(): void;
}

export declare class BRepBlend_BlendTool {
  constructor();
  static Project(P: gp_Pnt2d, S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor2d_HCurve2d, Paramproj: Quantity_AbsorbedDose, Dist: Quantity_AbsorbedDose): Standard_Boolean;
  static Inters(P1: gp_Pnt2d, P2: gp_Pnt2d, S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor2d_HCurve2d, Param: Quantity_AbsorbedDose, Dist: Quantity_AbsorbedDose): Standard_Boolean;
  static Parameter(V: Handle_Adaptor3d_HVertex, A: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Tolerance(V: Handle_Adaptor3d_HVertex, A: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static SingularOnUMin(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static SingularOnUMax(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static SingularOnVMin(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static SingularOnVMax(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static NbSamplesU(S: Handle_Adaptor3d_HSurface, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplesV(S: Handle_Adaptor3d_HSurface, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static Bounds(C: Handle_Adaptor2d_HCurve2d, Ufirst: Quantity_AbsorbedDose, Ulast: Quantity_AbsorbedDose): void;
  static CurveOnSurf(C: Handle_Adaptor2d_HCurve2d, S: Handle_Adaptor3d_HSurface): Handle_Adaptor2d_HCurve2d;
  delete(): void;
}

export declare class Handle_BRepBlend_AppFunc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBlend_AppFunc): void;
  get(): BRepBlend_AppFunc;
  delete(): void;
}

  export declare class Handle_BRepBlend_AppFunc_1 extends Handle_BRepBlend_AppFunc {
    constructor();
  }

  export declare class Handle_BRepBlend_AppFunc_2 extends Handle_BRepBlend_AppFunc {
    constructor(thePtr: BRepBlend_AppFunc);
  }

  export declare class Handle_BRepBlend_AppFunc_3 extends Handle_BRepBlend_AppFunc {
    constructor(theHandle: Handle_BRepBlend_AppFunc);
  }

  export declare class Handle_BRepBlend_AppFunc_4 extends Handle_BRepBlend_AppFunc {
    constructor(theHandle: Handle_BRepBlend_AppFunc);
  }

export declare class BRepBlend_AppFunc extends BRepBlend_AppFuncRoot {
  constructor(Line: Handle_BRepBlend_Line, Func: Blend_Function, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose)
  Point(Func: Blend_AppFunction, Param: Quantity_AbsorbedDose, Sol: math_Vector, Pnt: Blend_Point): void;
  Vec(Sol: math_Vector, Pnt: Blend_Point): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepBlend_SurfRstConstRad extends Blend_SurfRstFunction {
  constructor(Surf: Handle_Adaptor3d_HSurface, SurfRst: Handle_Adaptor3d_HSurface, Rst: Handle_Adaptor2d_HCurve2d, CGuide: Handle_Adaptor3d_HCurve)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(SurfRef: Handle_Adaptor3d_HSurface, RstRef: Handle_Adaptor2d_HCurve2d): void;
  Set_2(Param: Quantity_AbsorbedDose): void;
  Set_3(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  PointOnS(): gp_Pnt;
  PointOnRst(): gp_Pnt;
  Pnt2dOnS(): gp_Pnt2d;
  Pnt2dOnRst(): gp_Pnt2d;
  ParameterOnRst(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2dOnS(): gp_Vec2d;
  TangentOnRst(): gp_Vec;
  Tangent2dOnRst(): gp_Vec2d;
  Decroch(Sol: math_Vector, NS: gp_Vec, TgS: gp_Vec): Standard_Boolean;
  Set_4(Radius: Quantity_AbsorbedDose, Choix: Graphic3d_ZLayerId): void;
  Set_5(TypeSection: BlendFunc_SectionShape): void;
  Section_1(Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, C: gp_Circ): void;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_4(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BRepBlend_SurfCurvEvolRadInv extends Blend_SurfCurvFuncInv {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, Cg: Handle_Adaptor3d_HCurve, Evol: Handle_Law_Function)
  Set_1(Choix: Graphic3d_ZLayerId): void;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_2(Rst: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class TopExp_Explorer {
  Init(S: TopoDS_Shape, ToFind: TopAbs_ShapeEnum, ToAvoid: TopAbs_ShapeEnum): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): TopoDS_Shape;
  Current(): TopoDS_Shape;
  ReInit(): void;
  Depth(): Graphic3d_ZLayerId;
  Clear(): void;
  Destroy(): void;
  delete(): void;
}

  export declare class TopExp_Explorer_1 extends TopExp_Explorer {
    constructor();
  }

  export declare class TopExp_Explorer_2 extends TopExp_Explorer {
    constructor(S: TopoDS_Shape, ToFind: TopAbs_ShapeEnum, ToAvoid: TopAbs_ShapeEnum);
  }

export declare class TopExp {
  constructor();
  static MapShapes_1(S: TopoDS_Shape, T: TopAbs_ShapeEnum, M: TopTools_IndexedMapOfShape): void;
  static MapShapes_2(S: TopoDS_Shape, M: TopTools_IndexedMapOfShape): void;
  static MapShapes_3(S: TopoDS_Shape, M: TopTools_MapOfShape): void;
  static MapShapesAndAncestors(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum, M: TopTools_IndexedDataMapOfShapeListOfShape): void;
  static MapShapesAndUniqueAncestors(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum, M: TopTools_IndexedDataMapOfShapeListOfShape, useOrientation: Standard_Boolean): void;
  static FirstVertex(E: TopoDS_Edge, CumOri: Standard_Boolean): TopoDS_Vertex;
  static LastVertex(E: TopoDS_Edge, CumOri: Standard_Boolean): TopoDS_Vertex;
  static Vertices_1(E: TopoDS_Edge, Vfirst: TopoDS_Vertex, Vlast: TopoDS_Vertex, CumOri: Standard_Boolean): void;
  static Vertices_2(W: TopoDS_Wire, Vfirst: TopoDS_Vertex, Vlast: TopoDS_Vertex): void;
  static CommonVertex(E1: TopoDS_Edge, E2: TopoDS_Edge, V: TopoDS_Vertex): Standard_Boolean;
  delete(): void;
}

export declare class RWStepDimTol_RWProjectedZoneDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ProjectedZoneDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ProjectedZoneDefinition): void;
  Share(ent: Handle_StepDimTol_ProjectedZoneDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthDatRef {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRef): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRef): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRef, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricToleranceWithMaximumTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricToleranceWithMaximumTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricToleranceWithMaximumTolerance): void;
  Share(ent: Handle_StepDimTol_GeometricToleranceWithMaximumTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWPositionTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_PositionTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_PositionTolerance): void;
  Share(ent: Handle_StepDimTol_PositionTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWToleranceZone {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ToleranceZone): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ToleranceZone): void;
  Share(ent: Handle_StepDimTol_ToleranceZone, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumReferenceModifierWithValue {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumReferenceModifierWithValue): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumReferenceModifierWithValue): void;
  delete(): void;
}

export declare class RWStepDimTol_RWTotalRunoutTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_TotalRunoutTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_TotalRunoutTolerance): void;
  Share(ent: Handle_StepDimTol_TotalRunoutTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricTolerance): void;
  Share(ent: Handle_StepDimTol_GeometricTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWRunoutZoneDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_RunoutZoneDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_RunoutZoneDefinition): void;
  Share(ent: Handle_StepDimTol_RunoutZoneDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWStraightnessTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_StraightnessTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_StraightnessTolerance): void;
  Share(ent: Handle_StepDimTol_StraightnessTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWLineProfileTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_LineProfileTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_LineProfileTolerance): void;
  Share(ent: Handle_StepDimTol_LineProfileTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWRunoutZoneOrientation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_RunoutZoneOrientation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_RunoutZoneOrientation): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricToleranceRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricToleranceRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricToleranceRelationship): void;
  Share(ent: Handle_StepDimTol_GeometricToleranceRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWNonUniformZoneDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_NonUniformZoneDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_NonUniformZoneDefinition): void;
  Share(ent: Handle_StepDimTol_NonUniformZoneDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumFeature {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumFeature): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumFeature): void;
  Share(ent: Handle_StepDimTol_DatumFeature, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumReferenceElement {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumReferenceElement): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumReferenceElement): void;
  Share(ent: Handle_StepDimTol_DatumReferenceElement, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWCylindricityTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_CylindricityTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_CylindricityTolerance): void;
  Share(ent: Handle_StepDimTol_CylindricityTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWSurfaceProfileTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_SurfaceProfileTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_SurfaceProfileTolerance): void;
  Share(ent: Handle_StepDimTol_SurfaceProfileTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricToleranceWithDefinedAreaUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit): void;
  Share(ent: Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthMod {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthMod): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthMod): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthMod, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWCircularRunoutTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_CircularRunoutTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_CircularRunoutTolerance): void;
  Share(ent: Handle_StepDimTol_CircularRunoutTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeneralDatumReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeneralDatumReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeneralDatumReference): void;
  Share(ent: Handle_StepDimTol_GeneralDatumReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWToleranceZoneDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ToleranceZoneDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ToleranceZoneDefinition): void;
  Share(ent: Handle_StepDimTol_ToleranceZoneDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricToleranceWithDatumReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricToleranceWithDatumReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricToleranceWithDatumReference): void;
  Share(ent: Handle_StepDimTol_GeometricToleranceWithDatumReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWToleranceZoneForm {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ToleranceZoneForm): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ToleranceZoneForm): void;
  delete(): void;
}

export declare class RWStepDimTol_RWPlacedDatumTargetFeature {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_PlacedDatumTargetFeature): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_PlacedDatumTargetFeature): void;
  Share(ent: Handle_StepDimTol_PlacedDatumTargetFeature, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWAngularityTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_AngularityTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_AngularityTolerance): void;
  Share(ent: Handle_StepDimTol_AngularityTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWCommonDatum {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_CommonDatum): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_CommonDatum): void;
  Share(ent: Handle_StepDimTol_CommonDatum, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricToleranceWithModifiers {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricToleranceWithModifiers): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricToleranceWithModifiers): void;
  Share(ent: Handle_StepDimTol_GeometricToleranceWithModifiers, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWPerpendicularityTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_PerpendicularityTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_PerpendicularityTolerance): void;
  Share(ent: Handle_StepDimTol_PerpendicularityTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumSystem): void;
  Share(ent: Handle_StepDimTol_DatumSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndUneqDisGeoTol {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeometricToleranceWithDefinedUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeometricToleranceWithDefinedUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeometricToleranceWithDefinedUnit): void;
  Share(ent: Handle_StepDimTol_GeometricToleranceWithDefinedUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWUnequallyDisposedGeometricTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_UnequallyDisposedGeometricTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_UnequallyDisposedGeometricTolerance): void;
  Share(ent: Handle_StepDimTol_UnequallyDisposedGeometricTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthMaxTol {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWCoaxialityTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_CoaxialityTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_CoaxialityTolerance): void;
  Share(ent: Handle_StepDimTol_CoaxialityTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWConcentricityTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ConcentricityTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ConcentricityTolerance): void;
  Share(ent: Handle_StepDimTol_ConcentricityTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWRoundnessTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_RoundnessTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_RoundnessTolerance): void;
  Share(ent: Handle_StepDimTol_RoundnessTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumReference): void;
  Share(ent: Handle_StepDimTol_DatumReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWSymmetryTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_SymmetryTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_SymmetryTolerance): void;
  Share(ent: Handle_StepDimTol_SymmetryTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWFlatnessTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_FlatnessTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_FlatnessTolerance): void;
  Share(ent: Handle_StepDimTol_FlatnessTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumReferenceCompartment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumReferenceCompartment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumReferenceCompartment): void;
  Share(ent: Handle_StepDimTol_DatumReferenceCompartment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndGeoTolWthMod {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod): void;
  Share(ent: Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWParallelismTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ParallelismTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ParallelismTolerance): void;
  Share(ent: Handle_StepDimTol_ParallelismTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWModifiedGeometricTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_ModifiedGeometricTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_ModifiedGeometricTolerance): void;
  Share(ent: Handle_StepDimTol_ModifiedGeometricTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatumTarget {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_DatumTarget): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_DatumTarget): void;
  Share(ent: Handle_StepDimTol_DatumTarget, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepDimTol_RWDatum {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepDimTol_Datum): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepDimTol_Datum): void;
  Share(ent: Handle_StepDimTol_Datum, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class BndLib {
  constructor();
  static Add_1(L: gp_Lin, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_2(L: gp_Lin2d, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_3(C: gp_Circ, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_4(C: gp_Circ, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_5(C: gp_Circ2d, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_6(C: gp_Circ2d, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_7(C: gp_Elips, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_8(C: gp_Elips, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_9(C: gp_Elips2d, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_10(C: gp_Elips2d, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_11(P: gp_Parab, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_12(P: gp_Parab2d, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_13(H: gp_Hypr, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_14(H: gp_Hypr2d, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_15(S: gp_Cylinder, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_16(S: gp_Cylinder, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_17(S: gp_Cone, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_18(S: gp_Cone, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_19(S: gp_Sphere, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_20(S: gp_Sphere, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_21(P: gp_Torus, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_22(P: gp_Torus, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  delete(): void;
}

export declare class BndLib_Add2dCurve {
  constructor();
  static Add_1(C: Adaptor2d_Curve2d, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_2(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static Add_3(C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose, Box: Bnd_Box2d): void;
  static Add_4(C: Handle_Geom2d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  static AddOptimal(C: Handle_Geom2d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box2d): void;
  delete(): void;
}

export declare class BndLib_AddSurface {
  constructor();
  static Add_1(S: Adaptor3d_Surface, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_2(S: Adaptor3d_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static AddOptimal_1(S: Adaptor3d_Surface, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static AddOptimal_2(S: Adaptor3d_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static AddGenSurf(S: Adaptor3d_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  delete(): void;
}

export declare class BndLib_Add3dCurve {
  constructor();
  static Add_1(C: Adaptor3d_Curve, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static Add_2(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static AddOptimal_1(C: Adaptor3d_Curve, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static AddOptimal_2(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  static AddGenCurv(C: Adaptor3d_Curve, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, B: Bnd_Box): void;
  delete(): void;
}

export declare class HLRAlgo_PolyInternalSegment {
  constructor();
  delete(): void;
}

export declare class HLRAlgo_PolyInternalNode extends Standard_Transient {
  constructor()
  Indices(): any;
  Data(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HLRAlgo_PolyInternalNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_PolyInternalNode): void;
  get(): HLRAlgo_PolyInternalNode;
  delete(): void;
}

  export declare class Handle_HLRAlgo_PolyInternalNode_1 extends Handle_HLRAlgo_PolyInternalNode {
    constructor();
  }

  export declare class Handle_HLRAlgo_PolyInternalNode_2 extends Handle_HLRAlgo_PolyInternalNode {
    constructor(thePtr: HLRAlgo_PolyInternalNode);
  }

  export declare class Handle_HLRAlgo_PolyInternalNode_3 extends Handle_HLRAlgo_PolyInternalNode {
    constructor(theHandle: Handle_HLRAlgo_PolyInternalNode);
  }

  export declare class Handle_HLRAlgo_PolyInternalNode_4 extends Handle_HLRAlgo_PolyInternalNode {
    constructor(theHandle: Handle_HLRAlgo_PolyInternalNode);
  }

export declare class Handle_HLRAlgo_EdgesBlock {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_EdgesBlock): void;
  get(): HLRAlgo_EdgesBlock;
  delete(): void;
}

  export declare class Handle_HLRAlgo_EdgesBlock_1 extends Handle_HLRAlgo_EdgesBlock {
    constructor();
  }

  export declare class Handle_HLRAlgo_EdgesBlock_2 extends Handle_HLRAlgo_EdgesBlock {
    constructor(thePtr: HLRAlgo_EdgesBlock);
  }

  export declare class Handle_HLRAlgo_EdgesBlock_3 extends Handle_HLRAlgo_EdgesBlock {
    constructor(theHandle: Handle_HLRAlgo_EdgesBlock);
  }

  export declare class Handle_HLRAlgo_EdgesBlock_4 extends Handle_HLRAlgo_EdgesBlock {
    constructor(theHandle: Handle_HLRAlgo_EdgesBlock);
  }

export declare class HLRAlgo_EdgesBlock extends Standard_Transient {
  constructor(NbEdges: Graphic3d_ZLayerId)
  NbEdges(): Graphic3d_ZLayerId;
  Edge_1(I: Graphic3d_ZLayerId, EI: Graphic3d_ZLayerId): void;
  Edge_2(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Orientation_1(I: Graphic3d_ZLayerId, Or: TopAbs_Orientation): void;
  Orientation_2(I: Graphic3d_ZLayerId): TopAbs_Orientation;
  OutLine_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  OutLine_2(I: Graphic3d_ZLayerId, B: Standard_Boolean): void;
  Internal_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  Internal_2(I: Graphic3d_ZLayerId, B: Standard_Boolean): void;
  Double_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  Double_2(I: Graphic3d_ZLayerId, B: Standard_Boolean): void;
  IsoLine_1(I: Graphic3d_ZLayerId): Standard_Boolean;
  IsoLine_2(I: Graphic3d_ZLayerId, B: Standard_Boolean): void;
  UpdateMinMax(TotMinMax: any): void;
  MinMax(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class HLRAlgo {
  constructor();
  static UpdateMinMax(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, Min: Standard_Real [16], Max: Standard_Real [16]): void;
  static EnlargeMinMax(tol: Quantity_AbsorbedDose, Min: Standard_Real [16], Max: Standard_Real [16]): void;
  static InitMinMax(Big: Quantity_AbsorbedDose, Min: Standard_Real [16], Max: Standard_Real [16]): void;
  static EncodeMinMax(Min: any, Max: any, MinMax: any): void;
  static SizeBox(Min: any, Max: any): Quantity_AbsorbedDose;
  static DecodeMinMax(MinMax: any, Min: any, Max: any): void;
  static CopyMinMax(IMin: any, IMax: any, OMin: any, OMax: any): void;
  static AddMinMax(IMin: any, IMax: any, OMin: any, OMax: any): void;
  delete(): void;
}

export declare type HLRAlgo_PolyMask = {
  HLRAlgo_PolyMask_EMskOutLin1: {};
  HLRAlgo_PolyMask_EMskOutLin2: {};
  HLRAlgo_PolyMask_EMskOutLin3: {};
  HLRAlgo_PolyMask_EMskGrALin1: {};
  HLRAlgo_PolyMask_EMskGrALin2: {};
  HLRAlgo_PolyMask_EMskGrALin3: {};
  HLRAlgo_PolyMask_FMskBack: {};
  HLRAlgo_PolyMask_FMskSide: {};
  HLRAlgo_PolyMask_FMskHiding: {};
  HLRAlgo_PolyMask_FMskFlat: {};
  HLRAlgo_PolyMask_FMskOnOutL: {};
  HLRAlgo_PolyMask_FMskOrBack: {};
  HLRAlgo_PolyMask_FMskFrBack: {};
}

export declare class HLRAlgo_EdgeIterator {
  constructor()
  InitHidden(status: HLRAlgo_EdgeStatus): void;
  MoreHidden(): Standard_Boolean;
  NextHidden(): void;
  Hidden(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  InitVisible(status: HLRAlgo_EdgeStatus): void;
  MoreVisible(): Standard_Boolean;
  NextVisible(): void;
  Visible(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  delete(): void;
}

export declare class Handle_HLRAlgo_HArray1OfPISeg {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_HArray1OfPISeg): void;
  get(): HLRAlgo_HArray1OfPISeg;
  delete(): void;
}

  export declare class Handle_HLRAlgo_HArray1OfPISeg_1 extends Handle_HLRAlgo_HArray1OfPISeg {
    constructor();
  }

  export declare class Handle_HLRAlgo_HArray1OfPISeg_2 extends Handle_HLRAlgo_HArray1OfPISeg {
    constructor(thePtr: HLRAlgo_HArray1OfPISeg);
  }

  export declare class Handle_HLRAlgo_HArray1OfPISeg_3 extends Handle_HLRAlgo_HArray1OfPISeg {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfPISeg);
  }

  export declare class Handle_HLRAlgo_HArray1OfPISeg_4 extends Handle_HLRAlgo_HArray1OfPISeg {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfPISeg);
  }

export declare class HLRAlgo_PolyShellData extends Standard_Transient {
  constructor(nbFace: Graphic3d_ZLayerId)
  UpdateGlobalMinMax(theBox: any): void;
  UpdateHiding(nbHiding: Graphic3d_ZLayerId): void;
  Hiding(): Standard_Boolean;
  PolyData(): TColStd_Array1OfTransient;
  HidingPolyData(): TColStd_Array1OfTransient;
  Edges(): HLRAlgo_ListOfBPoint;
  Indices(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HLRAlgo_PolyShellData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_PolyShellData): void;
  get(): HLRAlgo_PolyShellData;
  delete(): void;
}

  export declare class Handle_HLRAlgo_PolyShellData_1 extends Handle_HLRAlgo_PolyShellData {
    constructor();
  }

  export declare class Handle_HLRAlgo_PolyShellData_2 extends Handle_HLRAlgo_PolyShellData {
    constructor(thePtr: HLRAlgo_PolyShellData);
  }

  export declare class Handle_HLRAlgo_PolyShellData_3 extends Handle_HLRAlgo_PolyShellData {
    constructor(theHandle: Handle_HLRAlgo_PolyShellData);
  }

  export declare class Handle_HLRAlgo_PolyShellData_4 extends Handle_HLRAlgo_PolyShellData {
    constructor(theHandle: Handle_HLRAlgo_PolyShellData);
  }

export declare class HLRAlgo_Array1OfTData {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: HLRAlgo_TriangleData): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: HLRAlgo_Array1OfTData): HLRAlgo_Array1OfTData;
  Move(theOther: HLRAlgo_Array1OfTData): HLRAlgo_Array1OfTData;
  First(): HLRAlgo_TriangleData;
  ChangeFirst(): HLRAlgo_TriangleData;
  Last(): HLRAlgo_TriangleData;
  ChangeLast(): HLRAlgo_TriangleData;
  Value(theIndex: Standard_Integer): HLRAlgo_TriangleData;
  ChangeValue(theIndex: Standard_Integer): HLRAlgo_TriangleData;
  SetValue(theIndex: Standard_Integer, theItem: HLRAlgo_TriangleData): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRAlgo_Array1OfTData_1 extends HLRAlgo_Array1OfTData {
    constructor();
  }

  export declare class HLRAlgo_Array1OfTData_2 extends HLRAlgo_Array1OfTData {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class HLRAlgo_Array1OfTData_3 extends HLRAlgo_Array1OfTData {
    constructor(theOther: HLRAlgo_Array1OfTData);
  }

  export declare class HLRAlgo_Array1OfTData_4 extends HLRAlgo_Array1OfTData {
    constructor(theOther: HLRAlgo_Array1OfTData);
  }

  export declare class HLRAlgo_Array1OfTData_5 extends HLRAlgo_Array1OfTData {
    constructor(theBegin: HLRAlgo_TriangleData, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_HLRAlgo_HArray1OfPINod {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_HArray1OfPINod): void;
  get(): HLRAlgo_HArray1OfPINod;
  delete(): void;
}

  export declare class Handle_HLRAlgo_HArray1OfPINod_1 extends Handle_HLRAlgo_HArray1OfPINod {
    constructor();
  }

  export declare class Handle_HLRAlgo_HArray1OfPINod_2 extends Handle_HLRAlgo_HArray1OfPINod {
    constructor(thePtr: HLRAlgo_HArray1OfPINod);
  }

  export declare class Handle_HLRAlgo_HArray1OfPINod_3 extends Handle_HLRAlgo_HArray1OfPINod {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfPINod);
  }

  export declare class Handle_HLRAlgo_HArray1OfPINod_4 extends Handle_HLRAlgo_HArray1OfPINod {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfPINod);
  }

export declare class HLRAlgo_Coincidence {
  constructor()
  Set2D(FE: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  SetState3D(stbef: TopAbs_State, staft: TopAbs_State): void;
  Value2D(FE: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  State3D(stbef: TopAbs_State, staft: TopAbs_State): void;
  delete(): void;
}

export declare class HLRAlgo_BiPoint {
  Rg1Line_1(): Standard_Boolean;
  Rg1Line_2(B: Standard_Boolean): void;
  RgNLine_1(): Standard_Boolean;
  RgNLine_2(B: Standard_Boolean): void;
  OutLine_1(): Standard_Boolean;
  OutLine_2(B: Standard_Boolean): void;
  IntLine_1(): Standard_Boolean;
  IntLine_2(B: Standard_Boolean): void;
  Hidden_1(): Standard_Boolean;
  Hidden_2(B: Standard_Boolean): void;
  Indices(): any;
  Points(): any;
  delete(): void;
}

  export declare class HLRAlgo_BiPoint_1 extends HLRAlgo_BiPoint {
    constructor();
  }

  export declare class HLRAlgo_BiPoint_2 extends HLRAlgo_BiPoint {
    constructor(X1: Quantity_AbsorbedDose, Y1: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, Y2: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, XT1: Quantity_AbsorbedDose, YT1: Quantity_AbsorbedDose, ZT1: Quantity_AbsorbedDose, XT2: Quantity_AbsorbedDose, YT2: Quantity_AbsorbedDose, ZT2: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean);
  }

  export declare class HLRAlgo_BiPoint_3 extends HLRAlgo_BiPoint {
    constructor(X1: Quantity_AbsorbedDose, Y1: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, Y2: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, XT1: Quantity_AbsorbedDose, YT1: Quantity_AbsorbedDose, ZT1: Quantity_AbsorbedDose, XT2: Quantity_AbsorbedDose, YT2: Quantity_AbsorbedDose, ZT2: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId);
  }

  export declare class HLRAlgo_BiPoint_4 extends HLRAlgo_BiPoint {
    constructor(X1: Quantity_AbsorbedDose, Y1: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, Y2: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, XT1: Quantity_AbsorbedDose, YT1: Quantity_AbsorbedDose, ZT1: Quantity_AbsorbedDose, XT2: Quantity_AbsorbedDose, YT2: Quantity_AbsorbedDose, ZT2: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, i1: Graphic3d_ZLayerId, i1p1: Graphic3d_ZLayerId, i1p2: Graphic3d_ZLayerId, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean);
  }

  export declare class HLRAlgo_BiPoint_5 extends HLRAlgo_BiPoint {
    constructor(X1: Quantity_AbsorbedDose, Y1: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, Y2: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, XT1: Quantity_AbsorbedDose, YT1: Quantity_AbsorbedDose, ZT1: Quantity_AbsorbedDose, XT2: Quantity_AbsorbedDose, YT2: Quantity_AbsorbedDose, ZT2: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, i1: Graphic3d_ZLayerId, i1p1: Graphic3d_ZLayerId, i1p2: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId);
  }

  export declare class HLRAlgo_BiPoint_6 extends HLRAlgo_BiPoint {
    constructor(X1: Quantity_AbsorbedDose, Y1: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, Y2: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, XT1: Quantity_AbsorbedDose, YT1: Quantity_AbsorbedDose, ZT1: Quantity_AbsorbedDose, XT2: Quantity_AbsorbedDose, YT2: Quantity_AbsorbedDose, ZT2: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, i1: Graphic3d_ZLayerId, i1p1: Graphic3d_ZLayerId, i1p2: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId, i2p1: Graphic3d_ZLayerId, i2p2: Graphic3d_ZLayerId, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean);
  }

  export declare class HLRAlgo_BiPoint_7 extends HLRAlgo_BiPoint {
    constructor(X1: Quantity_AbsorbedDose, Y1: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, X2: Quantity_AbsorbedDose, Y2: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, XT1: Quantity_AbsorbedDose, YT1: Quantity_AbsorbedDose, ZT1: Quantity_AbsorbedDose, XT2: Quantity_AbsorbedDose, YT2: Quantity_AbsorbedDose, ZT2: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, i1: Graphic3d_ZLayerId, i1p1: Graphic3d_ZLayerId, i1p2: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId, i2p1: Graphic3d_ZLayerId, i2p2: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId);
  }

export declare class HLRAlgo_Projector {
  Set(T: gp_Trsf, Persp: Standard_Boolean, Focus: Quantity_AbsorbedDose): void;
  Directions(D1: gp_Vec2d, D2: gp_Vec2d, D3: gp_Vec2d): void;
  Scaled(On: Standard_Boolean): void;
  Perspective(): Standard_Boolean;
  Transformation(): gp_Trsf;
  InvertedTransformation(): gp_Trsf;
  FullTransformation(): gp_Trsf;
  Focus(): Quantity_AbsorbedDose;
  Transform_1(D: gp_Vec): void;
  Transform_2(Pnt: gp_Pnt): void;
  Project_1(P: gp_Pnt, Pout: gp_Pnt2d): void;
  Project_2(P: gp_Pnt, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Project_3(P: gp_Pnt, D1: gp_Vec, Pout: gp_Pnt2d, D1out: gp_Vec2d): void;
  Shoot(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): gp_Lin;
  delete(): void;
}

  export declare class HLRAlgo_Projector_1 extends HLRAlgo_Projector {
    constructor();
  }

  export declare class HLRAlgo_Projector_2 extends HLRAlgo_Projector {
    constructor(CS: gp_Ax2);
  }

  export declare class HLRAlgo_Projector_3 extends HLRAlgo_Projector {
    constructor(CS: gp_Ax2, Focus: Quantity_AbsorbedDose);
  }

  export declare class HLRAlgo_Projector_4 extends HLRAlgo_Projector {
    constructor(T: gp_Trsf, Persp: Standard_Boolean, Focus: Quantity_AbsorbedDose);
  }

  export declare class HLRAlgo_Projector_5 extends HLRAlgo_Projector {
    constructor(T: gp_Trsf, Persp: Standard_Boolean, Focus: Quantity_AbsorbedDose, v1: gp_Vec2d, v2: gp_Vec2d, v3: gp_Vec2d);
  }

export declare class HLRAlgo_PolyHidingData {
  constructor()
  Set(Index: Graphic3d_ZLayerId, Minim: Graphic3d_ZLayerId, Maxim: Graphic3d_ZLayerId, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  Indices(): any;
  Plane(): any;
  delete(): void;
}

export declare class Handle_HLRAlgo_PolyData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_PolyData): void;
  get(): HLRAlgo_PolyData;
  delete(): void;
}

  export declare class Handle_HLRAlgo_PolyData_1 extends Handle_HLRAlgo_PolyData {
    constructor();
  }

  export declare class Handle_HLRAlgo_PolyData_2 extends Handle_HLRAlgo_PolyData {
    constructor(thePtr: HLRAlgo_PolyData);
  }

  export declare class Handle_HLRAlgo_PolyData_3 extends Handle_HLRAlgo_PolyData {
    constructor(theHandle: Handle_HLRAlgo_PolyData);
  }

  export declare class Handle_HLRAlgo_PolyData_4 extends Handle_HLRAlgo_PolyData {
    constructor(theHandle: Handle_HLRAlgo_PolyData);
  }

export declare class HLRAlgo_PolyData extends Standard_Transient {
  constructor()
  HNodes(HNodes: Handle_TColgp_HArray1OfXYZ): void;
  HTData(HTData: Handle_HLRAlgo_HArray1OfTData): void;
  HPHDat(HPHDat: Handle_HLRAlgo_HArray1OfPHDat): void;
  FaceIndex_1(I: Graphic3d_ZLayerId): void;
  FaceIndex_2(): Graphic3d_ZLayerId;
  Nodes(): TColgp_Array1OfXYZ;
  TData(): HLRAlgo_Array1OfTData;
  PHDat(): HLRAlgo_Array1OfPHDat;
  UpdateGlobalMinMax(theBox: any): void;
  Hiding(): Standard_Boolean;
  HideByPolyData(thePoints: any, theTriangle: any, theIndices: any, HidingShell: Standard_Boolean, status: HLRAlgo_EdgeStatus): void;
  Indices(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HLRAlgo_WiresBlock {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_WiresBlock): void;
  get(): HLRAlgo_WiresBlock;
  delete(): void;
}

  export declare class Handle_HLRAlgo_WiresBlock_1 extends Handle_HLRAlgo_WiresBlock {
    constructor();
  }

  export declare class Handle_HLRAlgo_WiresBlock_2 extends Handle_HLRAlgo_WiresBlock {
    constructor(thePtr: HLRAlgo_WiresBlock);
  }

  export declare class Handle_HLRAlgo_WiresBlock_3 extends Handle_HLRAlgo_WiresBlock {
    constructor(theHandle: Handle_HLRAlgo_WiresBlock);
  }

  export declare class Handle_HLRAlgo_WiresBlock_4 extends Handle_HLRAlgo_WiresBlock {
    constructor(theHandle: Handle_HLRAlgo_WiresBlock);
  }

export declare class HLRAlgo_WiresBlock extends Standard_Transient {
  constructor(NbWires: Graphic3d_ZLayerId)
  NbWires(): Graphic3d_ZLayerId;
  Set(I: Graphic3d_ZLayerId, W: Handle_HLRAlgo_EdgesBlock): void;
  Wire(I: Graphic3d_ZLayerId): Handle_HLRAlgo_EdgesBlock;
  UpdateMinMax(theMinMaxes: any): void;
  MinMax(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HLRAlgo_PolyInternalData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_PolyInternalData): void;
  get(): HLRAlgo_PolyInternalData;
  delete(): void;
}

  export declare class Handle_HLRAlgo_PolyInternalData_1 extends Handle_HLRAlgo_PolyInternalData {
    constructor();
  }

  export declare class Handle_HLRAlgo_PolyInternalData_2 extends Handle_HLRAlgo_PolyInternalData {
    constructor(thePtr: HLRAlgo_PolyInternalData);
  }

  export declare class Handle_HLRAlgo_PolyInternalData_3 extends Handle_HLRAlgo_PolyInternalData {
    constructor(theHandle: Handle_HLRAlgo_PolyInternalData);
  }

  export declare class Handle_HLRAlgo_PolyInternalData_4 extends Handle_HLRAlgo_PolyInternalData {
    constructor(theHandle: Handle_HLRAlgo_PolyInternalData);
  }

export declare class HLRAlgo_PolyInternalData extends Standard_Transient {
  constructor(nbNod: Graphic3d_ZLayerId, nbTri: Graphic3d_ZLayerId)
  UpdateLinks_1(TData: HLRAlgo_Array1OfTData, PISeg: HLRAlgo_Array1OfPISeg, PINod: HLRAlgo_Array1OfPINod): void;
  AddNode(Nod1RValues: any, Nod2RValues: any, PINod1: HLRAlgo_Array1OfPINod, PINod2: HLRAlgo_Array1OfPINod, coef1: Quantity_AbsorbedDose, X3: Quantity_AbsorbedDose, Y3: Quantity_AbsorbedDose, Z3: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  UpdateLinks_2(ip1: Graphic3d_ZLayerId, ip2: Graphic3d_ZLayerId, ip3: Graphic3d_ZLayerId, TData1: HLRAlgo_Array1OfTData, TData2: HLRAlgo_Array1OfTData, PISeg1: HLRAlgo_Array1OfPISeg, PISeg2: HLRAlgo_Array1OfPISeg, PINod1: HLRAlgo_Array1OfPINod, PINod2: HLRAlgo_Array1OfPINod): void;
  Dump(): void;
  IncTData(TData1: HLRAlgo_Array1OfTData, TData2: HLRAlgo_Array1OfTData): void;
  IncPISeg(PISeg1: HLRAlgo_Array1OfPISeg, PISeg2: HLRAlgo_Array1OfPISeg): void;
  IncPINod(PINod1: HLRAlgo_Array1OfPINod, PINod2: HLRAlgo_Array1OfPINod): void;
  DecTData(): void;
  DecPISeg(): void;
  DecPINod(): void;
  NbTData(): Graphic3d_ZLayerId;
  NbPISeg(): Graphic3d_ZLayerId;
  NbPINod(): Graphic3d_ZLayerId;
  Planar_1(): Standard_Boolean;
  Planar_2(B: Standard_Boolean): void;
  IntOutL_1(): Standard_Boolean;
  IntOutL_2(B: Standard_Boolean): void;
  TData(): HLRAlgo_Array1OfTData;
  PISeg(): HLRAlgo_Array1OfPISeg;
  PINod(): HLRAlgo_Array1OfPINod;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class HLRAlgo_TriangleData {
  constructor();
  delete(): void;
}

export declare class HLRAlgo_EdgeStatus {
  Initialize(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  Bounds(theStart: Quantity_AbsorbedDose, theTolStart: Standard_ShortReal, theEnd: Quantity_AbsorbedDose, theTolEnd: Standard_ShortReal): void;
  NbVisiblePart(): Graphic3d_ZLayerId;
  VisiblePart(Index: Graphic3d_ZLayerId, Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  Hide(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal, OnFace: Standard_Boolean, OnBoundary: Standard_Boolean): void;
  HideAll(): void;
  ShowAll(): void;
  AllHidden_1(): Standard_Boolean;
  AllHidden_2(B: Standard_Boolean): void;
  AllVisible_1(): Standard_Boolean;
  AllVisible_2(B: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRAlgo_EdgeStatus_1 extends HLRAlgo_EdgeStatus {
    constructor();
  }

  export declare class HLRAlgo_EdgeStatus_2 extends HLRAlgo_EdgeStatus {
    constructor(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal);
  }

export declare class HLRAlgo_Array1OfPISeg {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: HLRAlgo_PolyInternalSegment): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: HLRAlgo_Array1OfPISeg): HLRAlgo_Array1OfPISeg;
  Move(theOther: HLRAlgo_Array1OfPISeg): HLRAlgo_Array1OfPISeg;
  First(): HLRAlgo_PolyInternalSegment;
  ChangeFirst(): HLRAlgo_PolyInternalSegment;
  Last(): HLRAlgo_PolyInternalSegment;
  ChangeLast(): HLRAlgo_PolyInternalSegment;
  Value(theIndex: Standard_Integer): HLRAlgo_PolyInternalSegment;
  ChangeValue(theIndex: Standard_Integer): HLRAlgo_PolyInternalSegment;
  SetValue(theIndex: Standard_Integer, theItem: HLRAlgo_PolyInternalSegment): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRAlgo_Array1OfPISeg_1 extends HLRAlgo_Array1OfPISeg {
    constructor();
  }

  export declare class HLRAlgo_Array1OfPISeg_2 extends HLRAlgo_Array1OfPISeg {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class HLRAlgo_Array1OfPISeg_3 extends HLRAlgo_Array1OfPISeg {
    constructor(theOther: HLRAlgo_Array1OfPISeg);
  }

  export declare class HLRAlgo_Array1OfPISeg_4 extends HLRAlgo_Array1OfPISeg {
    constructor(theOther: HLRAlgo_Array1OfPISeg);
  }

  export declare class HLRAlgo_Array1OfPISeg_5 extends HLRAlgo_Array1OfPISeg {
    constructor(theBegin: HLRAlgo_PolyInternalSegment, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class HLRAlgo_PolyAlgo extends Standard_Transient {
  constructor()
  Init(HShell: Handle_TColStd_HArray1OfTransient): void;
  PolyShell(): TColStd_Array1OfTransient;
  Clear(): void;
  Update(): void;
  InitHide(): void;
  MoreHide(): Standard_Boolean;
  NextHide(): void;
  Hide(status: HLRAlgo_EdgeStatus, Index: Graphic3d_ZLayerId, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean): any;
  InitShow(): void;
  MoreShow(): Standard_Boolean;
  NextShow(): void;
  Show(Index: Graphic3d_ZLayerId, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HLRAlgo_PolyAlgo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_PolyAlgo): void;
  get(): HLRAlgo_PolyAlgo;
  delete(): void;
}

  export declare class Handle_HLRAlgo_PolyAlgo_1 extends Handle_HLRAlgo_PolyAlgo {
    constructor();
  }

  export declare class Handle_HLRAlgo_PolyAlgo_2 extends Handle_HLRAlgo_PolyAlgo {
    constructor(thePtr: HLRAlgo_PolyAlgo);
  }

  export declare class Handle_HLRAlgo_PolyAlgo_3 extends Handle_HLRAlgo_PolyAlgo {
    constructor(theHandle: Handle_HLRAlgo_PolyAlgo);
  }

  export declare class Handle_HLRAlgo_PolyAlgo_4 extends Handle_HLRAlgo_PolyAlgo {
    constructor(theHandle: Handle_HLRAlgo_PolyAlgo);
  }

export declare class Handle_HLRAlgo_HArray1OfPHDat {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_HArray1OfPHDat): void;
  get(): HLRAlgo_HArray1OfPHDat;
  delete(): void;
}

  export declare class Handle_HLRAlgo_HArray1OfPHDat_1 extends Handle_HLRAlgo_HArray1OfPHDat {
    constructor();
  }

  export declare class Handle_HLRAlgo_HArray1OfPHDat_2 extends Handle_HLRAlgo_HArray1OfPHDat {
    constructor(thePtr: HLRAlgo_HArray1OfPHDat);
  }

  export declare class Handle_HLRAlgo_HArray1OfPHDat_3 extends Handle_HLRAlgo_HArray1OfPHDat {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfPHDat);
  }

  export declare class Handle_HLRAlgo_HArray1OfPHDat_4 extends Handle_HLRAlgo_HArray1OfPHDat {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfPHDat);
  }

export declare class HLRAlgo_Interference {
  Intersection_1(I: HLRAlgo_Intersection): void;
  Boundary_1(B: HLRAlgo_Coincidence): void;
  Orientation_1(O: TopAbs_Orientation): void;
  Transition_1(Tr: TopAbs_Orientation): void;
  BoundaryTransition_1(BTr: TopAbs_Orientation): void;
  Intersection_2(): HLRAlgo_Intersection;
  ChangeIntersection(): HLRAlgo_Intersection;
  Boundary_2(): HLRAlgo_Coincidence;
  ChangeBoundary(): HLRAlgo_Coincidence;
  Orientation_2(): TopAbs_Orientation;
  Transition_2(): TopAbs_Orientation;
  BoundaryTransition_2(): TopAbs_Orientation;
  delete(): void;
}

  export declare class HLRAlgo_Interference_1 extends HLRAlgo_Interference {
    constructor();
  }

  export declare class HLRAlgo_Interference_2 extends HLRAlgo_Interference {
    constructor(Inters: HLRAlgo_Intersection, Bound: HLRAlgo_Coincidence, Orient: TopAbs_Orientation, Trans: TopAbs_Orientation, BTrans: TopAbs_Orientation);
  }

export declare class HLRAlgo_InterferenceList extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: HLRAlgo_InterferenceList): HLRAlgo_InterferenceList;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): HLRAlgo_Interference;
  First_2(): HLRAlgo_Interference;
  Last_1(): HLRAlgo_Interference;
  Last_2(): HLRAlgo_Interference;
  Append_1(theItem: HLRAlgo_Interference): HLRAlgo_Interference;
  Append_3(theOther: HLRAlgo_InterferenceList): void;
  Prepend_1(theItem: HLRAlgo_Interference): HLRAlgo_Interference;
  Prepend_2(theOther: HLRAlgo_InterferenceList): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class HLRAlgo_InterferenceList_1 extends HLRAlgo_InterferenceList {
    constructor();
  }

  export declare class HLRAlgo_InterferenceList_2 extends HLRAlgo_InterferenceList {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRAlgo_InterferenceList_3 extends HLRAlgo_InterferenceList {
    constructor(theOther: HLRAlgo_InterferenceList);
  }

export declare class Handle_HLRAlgo_HArray1OfTData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRAlgo_HArray1OfTData): void;
  get(): HLRAlgo_HArray1OfTData;
  delete(): void;
}

  export declare class Handle_HLRAlgo_HArray1OfTData_1 extends Handle_HLRAlgo_HArray1OfTData {
    constructor();
  }

  export declare class Handle_HLRAlgo_HArray1OfTData_2 extends Handle_HLRAlgo_HArray1OfTData {
    constructor(thePtr: HLRAlgo_HArray1OfTData);
  }

  export declare class Handle_HLRAlgo_HArray1OfTData_3 extends Handle_HLRAlgo_HArray1OfTData {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfTData);
  }

  export declare class Handle_HLRAlgo_HArray1OfTData_4 extends Handle_HLRAlgo_HArray1OfTData {
    constructor(theHandle: Handle_HLRAlgo_HArray1OfTData);
  }

export declare class HLRAlgo_Array1OfPHDat {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: HLRAlgo_PolyHidingData): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: HLRAlgo_Array1OfPHDat): HLRAlgo_Array1OfPHDat;
  Move(theOther: HLRAlgo_Array1OfPHDat): HLRAlgo_Array1OfPHDat;
  First(): HLRAlgo_PolyHidingData;
  ChangeFirst(): HLRAlgo_PolyHidingData;
  Last(): HLRAlgo_PolyHidingData;
  ChangeLast(): HLRAlgo_PolyHidingData;
  Value(theIndex: Standard_Integer): HLRAlgo_PolyHidingData;
  ChangeValue(theIndex: Standard_Integer): HLRAlgo_PolyHidingData;
  SetValue(theIndex: Standard_Integer, theItem: HLRAlgo_PolyHidingData): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRAlgo_Array1OfPHDat_1 extends HLRAlgo_Array1OfPHDat {
    constructor();
  }

  export declare class HLRAlgo_Array1OfPHDat_2 extends HLRAlgo_Array1OfPHDat {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class HLRAlgo_Array1OfPHDat_3 extends HLRAlgo_Array1OfPHDat {
    constructor(theOther: HLRAlgo_Array1OfPHDat);
  }

  export declare class HLRAlgo_Array1OfPHDat_4 extends HLRAlgo_Array1OfPHDat {
    constructor(theOther: HLRAlgo_Array1OfPHDat);
  }

  export declare class HLRAlgo_Array1OfPHDat_5 extends HLRAlgo_Array1OfPHDat {
    constructor(theBegin: HLRAlgo_PolyHidingData, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class HLRAlgo_Intersection {
  Orientation_1(Ori: TopAbs_Orientation): void;
  Orientation_2(): TopAbs_Orientation;
  Level_1(Lev: Graphic3d_ZLayerId): void;
  Level_2(): Graphic3d_ZLayerId;
  SegIndex_1(SegInd: Graphic3d_ZLayerId): void;
  SegIndex_2(): Graphic3d_ZLayerId;
  Index_1(Ind: Graphic3d_ZLayerId): void;
  Index_2(): Graphic3d_ZLayerId;
  Parameter_1(P: Quantity_AbsorbedDose): void;
  Parameter_2(): Quantity_AbsorbedDose;
  Tolerance_1(T: Standard_ShortReal): void;
  Tolerance_2(): Standard_ShortReal;
  State_1(S: TopAbs_State): void;
  State_2(): TopAbs_State;
  delete(): void;
}

  export declare class HLRAlgo_Intersection_1 extends HLRAlgo_Intersection {
    constructor();
  }

  export declare class HLRAlgo_Intersection_2 extends HLRAlgo_Intersection {
    constructor(Ori: TopAbs_Orientation, Lev: Graphic3d_ZLayerId, SegInd: Graphic3d_ZLayerId, Ind: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose, Tol: Standard_ShortReal, S: TopAbs_State);
  }

export declare class HLRAlgo_ListOfBPoint extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: HLRAlgo_ListOfBPoint): HLRAlgo_ListOfBPoint;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): HLRAlgo_BiPoint;
  First_2(): HLRAlgo_BiPoint;
  Last_1(): HLRAlgo_BiPoint;
  Last_2(): HLRAlgo_BiPoint;
  Append_1(theItem: HLRAlgo_BiPoint): HLRAlgo_BiPoint;
  Append_3(theOther: HLRAlgo_ListOfBPoint): void;
  Prepend_1(theItem: HLRAlgo_BiPoint): HLRAlgo_BiPoint;
  Prepend_2(theOther: HLRAlgo_ListOfBPoint): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class HLRAlgo_ListOfBPoint_1 extends HLRAlgo_ListOfBPoint {
    constructor();
  }

  export declare class HLRAlgo_ListOfBPoint_2 extends HLRAlgo_ListOfBPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRAlgo_ListOfBPoint_3 extends HLRAlgo_ListOfBPoint {
    constructor(theOther: HLRAlgo_ListOfBPoint);
  }

export declare class BinLDrivers_DocumentRetrievalDriver extends PCDM_RetrievalDriver {
  constructor()
  CreateDocument(): Handle_CDM_Document;
  Read_1(theFileName: TCollection_ExtendedString, theNewDocument: Handle_CDM_Document, theApplication: Handle_CDM_Application, theProgress: Message_ProgressRange): void;
  Read_2(theIStream: Standard_IStream, theStorageData: Handle_Storage_Data, theDoc: Handle_CDM_Document, theApplication: Handle_CDM_Application, theProgress: Message_ProgressRange): void;
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinLDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinLDrivers_DocumentRetrievalDriver): void;
  get(): BinLDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_BinLDrivers_DocumentRetrievalDriver_1 extends Handle_BinLDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_BinLDrivers_DocumentRetrievalDriver_2 extends Handle_BinLDrivers_DocumentRetrievalDriver {
    constructor(thePtr: BinLDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinLDrivers_DocumentRetrievalDriver_3 extends Handle_BinLDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinLDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinLDrivers_DocumentRetrievalDriver_4 extends Handle_BinLDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinLDrivers_DocumentRetrievalDriver);
  }

export declare class Handle_BinLDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinLDrivers_DocumentStorageDriver): void;
  get(): BinLDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_BinLDrivers_DocumentStorageDriver_1 extends Handle_BinLDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_BinLDrivers_DocumentStorageDriver_2 extends Handle_BinLDrivers_DocumentStorageDriver {
    constructor(thePtr: BinLDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinLDrivers_DocumentStorageDriver_3 extends Handle_BinLDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinLDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinLDrivers_DocumentStorageDriver_4 extends Handle_BinLDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinLDrivers_DocumentStorageDriver);
  }

export declare class BinLDrivers_DocumentStorageDriver extends PCDM_StorageDriver {
  constructor()
  Write_1(theDocument: Handle_CDM_Document, theFileName: TCollection_ExtendedString, theRange: Message_ProgressRange): void;
  Write_2(theDocument: Handle_CDM_Document, theOStream: Standard_OStream, theRange: Message_ProgressRange): void;
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  AddSection(theName: XCAFDoc_PartId, isPostRead: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type BinLDrivers_Marker = {
  BinLDrivers_ENDATTRLIST: {};
  BinLDrivers_ENDLABEL: {};
}

export declare class BinLDrivers {
  constructor();
  static Factory(theGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AttributeDrivers(MsgDrv: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static StorageVersion(): XCAFDoc_PartId;
  delete(): void;
}

export declare class BinLDrivers_VectorOfDocumentSection extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BinLDrivers_VectorOfDocumentSection, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BinLDrivers_DocumentSection): BinLDrivers_DocumentSection;
  Appended(): BinLDrivers_DocumentSection;
  Value(theIndex: Standard_Integer): BinLDrivers_DocumentSection;
  First(): BinLDrivers_DocumentSection;
  ChangeFirst(): BinLDrivers_DocumentSection;
  Last(): BinLDrivers_DocumentSection;
  ChangeLast(): BinLDrivers_DocumentSection;
  ChangeValue(theIndex: Standard_Integer): BinLDrivers_DocumentSection;
  SetValue(theIndex: Standard_Integer, theValue: BinLDrivers_DocumentSection): BinLDrivers_DocumentSection;
  delete(): void;
}

  export declare class BinLDrivers_VectorOfDocumentSection_1 extends BinLDrivers_VectorOfDocumentSection {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BinLDrivers_VectorOfDocumentSection_2 extends BinLDrivers_VectorOfDocumentSection {
    constructor(theOther: BinLDrivers_VectorOfDocumentSection);
  }

export declare class BinLDrivers_DocumentSection {
  Name(): XCAFDoc_PartId;
  IsPostRead(): Standard_Boolean;
  Offset(): uint64_t;
  SetOffset(theOffset: uint64_t): void;
  Length(): uint64_t;
  SetLength(theLength: uint64_t): void;
  WriteTOC(theOS: Standard_OStream): void;
  Write(theOS: Standard_OStream, theOffset: uint64_t): void;
  static ReadTOC(theSection: BinLDrivers_DocumentSection, theIS: Standard_IStream, theDocFormatVersion: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class BinLDrivers_DocumentSection_1 extends BinLDrivers_DocumentSection {
    constructor();
  }

  export declare class BinLDrivers_DocumentSection_2 extends BinLDrivers_DocumentSection {
    constructor(theName: XCAFDoc_PartId, isPostRead: Standard_Boolean);
  }

export declare class TopoDSToStep_MakeFacetedBrep extends TopoDSToStep_Root {
  Value(): Handle_StepShape_FacetedBrep;
  delete(): void;
}

  export declare class TopoDSToStep_MakeFacetedBrep_1 extends TopoDSToStep_MakeFacetedBrep {
    constructor(S: TopoDS_Shell, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

  export declare class TopoDSToStep_MakeFacetedBrep_2 extends TopoDSToStep_MakeFacetedBrep {
    constructor(S: TopoDS_Solid, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

export declare class TopoDSToStep_MakeStepFace extends TopoDSToStep_Root {
  Init(F: TopoDS_Face, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess): void;
  Value(): Handle_StepShape_TopologicalRepresentationItem;
  Error(): TopoDSToStep_MakeFaceError;
  delete(): void;
}

  export declare class TopoDSToStep_MakeStepFace_1 extends TopoDSToStep_MakeStepFace {
    constructor();
  }

  export declare class TopoDSToStep_MakeStepFace_2 extends TopoDSToStep_MakeStepFace {
    constructor(F: TopoDS_Face, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess);
  }

export declare class TopoDSToStep_FacetedTool {
  constructor();
  static CheckTopoDSShape(SH: TopoDS_Shape): TopoDSToStep_FacetedError;
  delete(): void;
}

export declare type TopoDSToStep_BuilderError = {
  TopoDSToStep_BuilderDone: {};
  TopoDSToStep_NoFaceMapped: {};
  TopoDSToStep_BuilderOther: {};
}

export declare type TopoDSToStep_MakeFaceError = {
  TopoDSToStep_FaceDone: {};
  TopoDSToStep_InfiniteFace: {};
  TopoDSToStep_NonManifoldFace: {};
  TopoDSToStep_NoWireMapped: {};
  TopoDSToStep_FaceOther: {};
}

export declare type TopoDSToStep_MakeVertexError = {
  TopoDSToStep_VertexDone: {};
  TopoDSToStep_VertexOther: {};
}

export declare class TopoDSToStep_MakeShellBasedSurfaceModel extends TopoDSToStep_Root {
  Value(): Handle_StepShape_ShellBasedSurfaceModel;
  delete(): void;
}

  export declare class TopoDSToStep_MakeShellBasedSurfaceModel_1 extends TopoDSToStep_MakeShellBasedSurfaceModel {
    constructor(F: TopoDS_Face, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

  export declare class TopoDSToStep_MakeShellBasedSurfaceModel_2 extends TopoDSToStep_MakeShellBasedSurfaceModel {
    constructor(S: TopoDS_Shell, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

  export declare class TopoDSToStep_MakeShellBasedSurfaceModel_3 extends TopoDSToStep_MakeShellBasedSurfaceModel {
    constructor(S: TopoDS_Solid, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

export declare class TopoDSToStep_MakeStepWire extends TopoDSToStep_Root {
  Init(W: TopoDS_Wire, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess): void;
  Value(): Handle_StepShape_TopologicalRepresentationItem;
  Error(): TopoDSToStep_MakeWireError;
  delete(): void;
}

  export declare class TopoDSToStep_MakeStepWire_1 extends TopoDSToStep_MakeStepWire {
    constructor();
  }

  export declare class TopoDSToStep_MakeStepWire_2 extends TopoDSToStep_MakeStepWire {
    constructor(W: TopoDS_Wire, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess);
  }

export declare class TopoDSToStep_MakeBrepWithVoids extends TopoDSToStep_Root {
  constructor(S: TopoDS_Solid, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange)
  Value(): Handle_StepShape_BrepWithVoids;
  delete(): void;
}

export declare class TopoDSToStep {
  constructor();
  static DecodeBuilderError(E: TopoDSToStep_BuilderError): Handle_TCollection_HAsciiString;
  static DecodeFaceError(E: TopoDSToStep_MakeFaceError): Handle_TCollection_HAsciiString;
  static DecodeWireError(E: TopoDSToStep_MakeWireError): Handle_TCollection_HAsciiString;
  static DecodeEdgeError(E: TopoDSToStep_MakeEdgeError): Handle_TCollection_HAsciiString;
  static DecodeVertexError(E: TopoDSToStep_MakeVertexError): Handle_TCollection_HAsciiString;
  static AddResult_1(FP: Handle_Transfer_FinderProcess, Shape: TopoDS_Shape, entity: Handle_Standard_Transient): void;
  static AddResult_2(FP: Handle_Transfer_FinderProcess, Tool: TopoDSToStep_Tool): void;
  delete(): void;
}

export declare class TopoDSToStep_Tool {
  Init(M: MoniTool_DataMapOfShapeTransient, FacetedContext: Standard_Boolean): void;
  IsBound(S: TopoDS_Shape): Standard_Boolean;
  Bind(S: TopoDS_Shape, T: Handle_StepShape_TopologicalRepresentationItem): void;
  Find(S: TopoDS_Shape): Handle_StepShape_TopologicalRepresentationItem;
  Faceted(): Standard_Boolean;
  SetCurrentShell(S: TopoDS_Shell): void;
  CurrentShell(): TopoDS_Shell;
  SetCurrentFace(F: TopoDS_Face): void;
  CurrentFace(): TopoDS_Face;
  SetCurrentWire(W: TopoDS_Wire): void;
  CurrentWire(): TopoDS_Wire;
  SetCurrentEdge(E: TopoDS_Edge): void;
  CurrentEdge(): TopoDS_Edge;
  SetCurrentVertex(V: TopoDS_Vertex): void;
  CurrentVertex(): TopoDS_Vertex;
  Lowest3DTolerance(): Quantity_AbsorbedDose;
  SetSurfaceReversed(B: Standard_Boolean): void;
  SurfaceReversed(): Standard_Boolean;
  Map(): MoniTool_DataMapOfShapeTransient;
  PCurveMode(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopoDSToStep_Tool_1 extends TopoDSToStep_Tool {
    constructor();
  }

  export declare class TopoDSToStep_Tool_2 extends TopoDSToStep_Tool {
    constructor(M: MoniTool_DataMapOfShapeTransient, FacetedContext: Standard_Boolean);
  }

export declare class TopoDSToStep_Root {
  Tolerance(): Quantity_AbsorbedDose;
  IsDone(): Standard_Boolean;
  delete(): void;
}

export declare type TopoDSToStep_MakeWireError = {
  TopoDSToStep_WireDone: {};
  TopoDSToStep_NonManifoldWire: {};
  TopoDSToStep_WireOther: {};
}

export declare class TopoDSToStep_MakeGeometricCurveSet extends TopoDSToStep_Root {
  constructor(SH: TopoDS_Shape, FP: Handle_Transfer_FinderProcess)
  Value(): Handle_StepShape_GeometricCurveSet;
  delete(): void;
}

export declare class TopoDSToStep_MakeStepEdge extends TopoDSToStep_Root {
  Init(E: TopoDS_Edge, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess): void;
  Value(): Handle_StepShape_TopologicalRepresentationItem;
  Error(): TopoDSToStep_MakeEdgeError;
  delete(): void;
}

  export declare class TopoDSToStep_MakeStepEdge_1 extends TopoDSToStep_MakeStepEdge {
    constructor();
  }

  export declare class TopoDSToStep_MakeStepEdge_2 extends TopoDSToStep_MakeStepEdge {
    constructor(E: TopoDS_Edge, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess);
  }

export declare class TopoDSToStep_MakeManifoldSolidBrep extends TopoDSToStep_Root {
  Value(): Handle_StepShape_ManifoldSolidBrep;
  delete(): void;
}

  export declare class TopoDSToStep_MakeManifoldSolidBrep_1 extends TopoDSToStep_MakeManifoldSolidBrep {
    constructor(S: TopoDS_Shell, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

  export declare class TopoDSToStep_MakeManifoldSolidBrep_2 extends TopoDSToStep_MakeManifoldSolidBrep {
    constructor(S: TopoDS_Solid, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

export declare class TopoDSToStep_MakeFacetedBrepAndBrepWithVoids extends TopoDSToStep_Root {
  constructor(S: TopoDS_Solid, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange)
  Value(): Handle_StepShape_FacetedBrepAndBrepWithVoids;
  delete(): void;
}

export declare type TopoDSToStep_FacetedError = {
  TopoDSToStep_FacetedDone: {};
  TopoDSToStep_SurfaceNotPlane: {};
  TopoDSToStep_PCurveNotLinear: {};
}

export declare class TopoDSToStep_Builder extends TopoDSToStep_Root {
  Init(S: TopoDS_Shape, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange): void;
  Error(): TopoDSToStep_BuilderError;
  Value(): Handle_StepShape_TopologicalRepresentationItem;
  delete(): void;
}

  export declare class TopoDSToStep_Builder_1 extends TopoDSToStep_Builder {
    constructor();
  }

  export declare class TopoDSToStep_Builder_2 extends TopoDSToStep_Builder {
    constructor(S: TopoDS_Shape, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange);
  }

export declare type TopoDSToStep_MakeEdgeError = {
  TopoDSToStep_EdgeDone: {};
  TopoDSToStep_NonManifoldEdge: {};
  TopoDSToStep_EdgeOther: {};
}

export declare class TopoDSToStep_WireframeBuilder extends TopoDSToStep_Root {
  Init(S: TopoDS_Shape, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess): void;
  Error(): TopoDSToStep_BuilderError;
  Value(): Handle_TColStd_HSequenceOfTransient;
  GetTrimmedCurveFromEdge(E: TopoDS_Edge, F: TopoDS_Face, M: MoniTool_DataMapOfShapeTransient, L: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  GetTrimmedCurveFromFace(F: TopoDS_Face, M: MoniTool_DataMapOfShapeTransient, L: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  GetTrimmedCurveFromShape(S: TopoDS_Shape, M: MoniTool_DataMapOfShapeTransient, L: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  delete(): void;
}

  export declare class TopoDSToStep_WireframeBuilder_1 extends TopoDSToStep_WireframeBuilder {
    constructor();
  }

  export declare class TopoDSToStep_WireframeBuilder_2 extends TopoDSToStep_WireframeBuilder {
    constructor(S: TopoDS_Shape, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess);
  }

export declare class TopoDSToStep_MakeStepVertex extends TopoDSToStep_Root {
  Init(V: TopoDS_Vertex, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess): void;
  Value(): Handle_StepShape_TopologicalRepresentationItem;
  Error(): TopoDSToStep_MakeVertexError;
  delete(): void;
}

  export declare class TopoDSToStep_MakeStepVertex_1 extends TopoDSToStep_MakeStepVertex {
    constructor();
  }

  export declare class TopoDSToStep_MakeStepVertex_2 extends TopoDSToStep_MakeStepVertex {
    constructor(V: TopoDS_Vertex, T: TopoDSToStep_Tool, FP: Handle_Transfer_FinderProcess);
  }

export declare class RWStepFEA_RWFeaAxis2Placement3d {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaAxis2Placement3d): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaAxis2Placement3d): void;
  Share(ent: Handle_StepFEA_FeaAxis2Placement3d, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWParametricSurface3dElementCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ParametricSurface3dElementCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ParametricSurface3dElementCoordinateSystem): void;
  Share(ent: Handle_StepFEA_ParametricSurface3dElementCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaMaterialPropertyRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaMaterialPropertyRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaMaterialPropertyRepresentation): void;
  Share(ent: Handle_StepFEA_FeaMaterialPropertyRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaShellShearStiffness {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaShellShearStiffness): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaShellShearStiffness): void;
  Share(ent: Handle_StepFEA_FeaShellShearStiffness, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurveElementEndRelease {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_CurveElementEndRelease): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_CurveElementEndRelease): void;
  Share(ent: Handle_StepFEA_CurveElementEndRelease, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWParametricCurve3dElementCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ParametricCurve3dElementCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ParametricCurve3dElementCoordinateSystem): void;
  Share(ent: Handle_StepFEA_ParametricCurve3dElementCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurveElementLocation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_CurveElementLocation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_CurveElementLocation): void;
  Share(ent: Handle_StepFEA_CurveElementLocation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWElementRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ElementRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ElementRepresentation): void;
  Share(ent: Handle_StepFEA_ElementRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaShellMembraneStiffness {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaShellMembraneStiffness): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaShellMembraneStiffness): void;
  Share(ent: Handle_StepFEA_FeaShellMembraneStiffness, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurveElementIntervalLinearlyVarying {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_CurveElementIntervalLinearlyVarying): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_CurveElementIntervalLinearlyVarying): void;
  Share(ent: Handle_StepFEA_CurveElementIntervalLinearlyVarying, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaSecantCoefficientOfLinearThermalExpansion {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion): void;
  Share(ent: Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaMaterialPropertyRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaMaterialPropertyRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaMaterialPropertyRepresentationItem): void;
  Share(ent: Handle_StepFEA_FeaMaterialPropertyRepresentationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurve3dElementRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_Curve3dElementRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_Curve3dElementRepresentation): void;
  Share(ent: Handle_StepFEA_Curve3dElementRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWAlignedSurface3dElementCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_AlignedSurface3dElementCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_AlignedSurface3dElementCoordinateSystem): void;
  Share(ent: Handle_StepFEA_AlignedSurface3dElementCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNodeWithVector {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_NodeWithVector): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_NodeWithVector): void;
  Share(ent: Handle_StepFEA_NodeWithVector, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaTangentialCoefficientOfLinearThermalExpansion {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion): void;
  Share(ent: Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWElementGeometricRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ElementGeometricRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ElementGeometricRelationship): void;
  Share(ent: Handle_StepFEA_ElementGeometricRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWSurface3dElementRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_Surface3dElementRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_Surface3dElementRepresentation): void;
  Share(ent: Handle_StepFEA_Surface3dElementRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurve3dElementProperty {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_Curve3dElementProperty): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_Curve3dElementProperty): void;
  Share(ent: Handle_StepFEA_Curve3dElementProperty, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNodeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_NodeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_NodeRepresentation): void;
  Share(ent: Handle_StepFEA_NodeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNodeSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_NodeSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_NodeSet): void;
  Share(ent: Handle_StepFEA_NodeSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaParametricPoint {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaParametricPoint): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaParametricPoint): void;
  Share(ent: Handle_StepFEA_FeaParametricPoint, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaGroup {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaGroup): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaGroup): void;
  Share(ent: Handle_StepFEA_FeaGroup, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWArbitraryVolume3dElementCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem): void;
  Share(ent: Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWParametricCurve3dElementCoordinateDirection {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection): void;
  Share(ent: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWVolume3dElementRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_Volume3dElementRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_Volume3dElementRepresentation): void;
  Share(ent: Handle_StepFEA_Volume3dElementRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWDummyNode {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_DummyNode): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_DummyNode): void;
  Share(ent: Handle_StepFEA_DummyNode, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWAlignedCurve3dElementCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_AlignedCurve3dElementCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_AlignedCurve3dElementCoordinateSystem): void;
  Share(ent: Handle_StepFEA_AlignedCurve3dElementCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaCurveSectionGeometricRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaCurveSectionGeometricRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaCurveSectionGeometricRelationship): void;
  Share(ent: Handle_StepFEA_FeaCurveSectionGeometricRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNodeWithSolutionCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_NodeWithSolutionCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_NodeWithSolutionCoordinateSystem): void;
  Share(ent: Handle_StepFEA_NodeWithSolutionCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNode {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_Node): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_Node): void;
  Share(ent: Handle_StepFEA_Node, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaModel3d {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaModel3d): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaModel3d): void;
  Share(ent: Handle_StepFEA_FeaModel3d, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurveElementInterval {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_CurveElementInterval): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_CurveElementInterval): void;
  Share(ent: Handle_StepFEA_CurveElementInterval, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaShellMembraneBendingCouplingStiffness {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness): void;
  Share(ent: Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaModelDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaModelDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaModelDefinition): void;
  Share(ent: Handle_StepFEA_FeaModelDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaSurfaceSectionGeometricRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaSurfaceSectionGeometricRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaSurfaceSectionGeometricRelationship): void;
  Share(ent: Handle_StepFEA_FeaSurfaceSectionGeometricRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaAreaDensity {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaAreaDensity): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaAreaDensity): void;
  Share(ent: Handle_StepFEA_FeaAreaDensity, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaMassDensity {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaMassDensity): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaMassDensity): void;
  Share(ent: Handle_StepFEA_FeaMassDensity, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWGeometricNode {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_GeometricNode): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_GeometricNode): void;
  Share(ent: Handle_StepFEA_GeometricNode, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWElementGroup {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ElementGroup): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ElementGroup): void;
  Share(ent: Handle_StepFEA_ElementGroup, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaLinearElasticity {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaLinearElasticity): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaLinearElasticity): void;
  Share(ent: Handle_StepFEA_FeaLinearElasticity, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFreedomsList {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FreedomsList): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FreedomsList): void;
  Share(ent: Handle_StepFEA_FreedomsList, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNodeDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_NodeDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_NodeDefinition): void;
  Share(ent: Handle_StepFEA_NodeDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurveElementEndOffset {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_CurveElementEndOffset): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_CurveElementEndOffset): void;
  Share(ent: Handle_StepFEA_CurveElementEndOffset, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaMoistureAbsorption {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaMoistureAbsorption): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaMoistureAbsorption): void;
  Share(ent: Handle_StepFEA_FeaMoistureAbsorption, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFreedomAndCoefficient {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FreedomAndCoefficient): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FreedomAndCoefficient): void;
  Share(ent: Handle_StepFEA_FreedomAndCoefficient, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaShellBendingStiffness {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaShellBendingStiffness): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaShellBendingStiffness): void;
  Share(ent: Handle_StepFEA_FeaShellBendingStiffness, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaModel): void;
  Share(ent: Handle_StepFEA_FeaModel, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWNodeGroup {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_NodeGroup): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_NodeGroup): void;
  Share(ent: Handle_StepFEA_NodeGroup, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWCurveElementIntervalConstant {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_CurveElementIntervalConstant): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_CurveElementIntervalConstant): void;
  Share(ent: Handle_StepFEA_CurveElementIntervalConstant, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWConstantSurface3dElementCoordinateSystem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_ConstantSurface3dElementCoordinateSystem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_ConstantSurface3dElementCoordinateSystem): void;
  Share(ent: Handle_StepFEA_ConstantSurface3dElementCoordinateSystem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepFEA_RWFeaRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepFEA_FeaRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepFEA_FeaRepresentationItem): void;
  Share(ent: Handle_StepFEA_FeaRepresentationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class Handle_Law_S {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_S): void;
  get(): Law_S;
  delete(): void;
}

  export declare class Handle_Law_S_1 extends Handle_Law_S {
    constructor();
  }

  export declare class Handle_Law_S_2 extends Handle_Law_S {
    constructor(thePtr: Law_S);
  }

  export declare class Handle_Law_S_3 extends Handle_Law_S {
    constructor(theHandle: Handle_Law_S);
  }

  export declare class Handle_Law_S_4 extends Handle_Law_S {
    constructor(theHandle: Handle_Law_S);
  }

export declare class Law_S extends Law_BSpFunc {
  constructor()
  Set_1(Pdeb: Quantity_AbsorbedDose, Valdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, Valfin: Quantity_AbsorbedDose): void;
  Set_2(Pdeb: Quantity_AbsorbedDose, Valdeb: Quantity_AbsorbedDose, Ddeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, Valfin: Quantity_AbsorbedDose, Dfin: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Law_Function {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_Function): void;
  get(): Law_Function;
  delete(): void;
}

  export declare class Handle_Law_Function_1 extends Handle_Law_Function {
    constructor();
  }

  export declare class Handle_Law_Function_2 extends Handle_Law_Function {
    constructor(thePtr: Law_Function);
  }

  export declare class Handle_Law_Function_3 extends Handle_Law_Function {
    constructor(theHandle: Handle_Law_Function);
  }

  export declare class Handle_Law_Function_4 extends Handle_Law_Function {
    constructor(theHandle: Handle_Law_Function);
  }

export declare class Law_Function extends Standard_Transient {
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Value(X: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D1(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  D2(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): void;
  Trim(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Law_Function;
  Bounds(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Law {
  constructor();
  static MixBnd_1(Lin: Handle_Law_Linear): Handle_Law_BSpFunc;
  static MixBnd_2(Degree: Graphic3d_ZLayerId, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Lin: Handle_Law_Linear): Handle_TColStd_HArray1OfReal;
  static MixTgt(Degree: Graphic3d_ZLayerId, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NulOnTheRight: Standard_Boolean, Index: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  static Reparametrize(Curve: Adaptor3d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasDF: Standard_Boolean, HasDL: Standard_Boolean, DFirst: Quantity_AbsorbedDose, DLast: Quantity_AbsorbedDose, Rev: Standard_Boolean, NbPoints: Graphic3d_ZLayerId): Handle_Law_BSpline;
  static Scale(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasF: Standard_Boolean, HasL: Standard_Boolean, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose): Handle_Law_BSpline;
  static ScaleCub(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasF: Standard_Boolean, HasL: Standard_Boolean, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose): Handle_Law_BSpline;
  delete(): void;
}

export declare class Handle_Law_BSpline {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_BSpline): void;
  get(): Law_BSpline;
  delete(): void;
}

  export declare class Handle_Law_BSpline_1 extends Handle_Law_BSpline {
    constructor();
  }

  export declare class Handle_Law_BSpline_2 extends Handle_Law_BSpline {
    constructor(thePtr: Law_BSpline);
  }

  export declare class Handle_Law_BSpline_3 extends Handle_Law_BSpline {
    constructor(theHandle: Handle_Law_BSpline);
  }

  export declare class Handle_Law_BSpline_4 extends Handle_Law_BSpline {
    constructor(theHandle: Handle_Law_BSpline);
  }

export declare class Law_BSpline extends Standard_Transient {
  IncreaseDegree(Degree: Graphic3d_ZLayerId): void;
  IncreaseMultiplicity_1(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncreaseMultiplicity_2(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncrementMultiplicity(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  InsertKnot(U: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  InsertKnots(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  RemoveKnot(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  SetKnot_1(Index: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose): void;
  SetKnots(K: TColStd_Array1OfReal): void;
  SetKnot_2(Index: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId): void;
  PeriodicNormalization(U: Quantity_AbsorbedDose): void;
  SetPeriodic(): void;
  SetOrigin(Index: Graphic3d_ZLayerId): void;
  SetNotPeriodic(): void;
  SetPole_1(Index: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose): void;
  SetPole_2(Index: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose, Weight: Quantity_AbsorbedDose): void;
  SetWeight(Index: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  IsRational(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Degree(): Graphic3d_ZLayerId;
  Value(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: Quantity_AbsorbedDose): void;
  D1(U: Quantity_AbsorbedDose, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose): void;
  D2(U: Quantity_AbsorbedDose, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  D3(U: Quantity_AbsorbedDose, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, V3: Quantity_AbsorbedDose): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  LocalValue(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  LocalD0(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose): void;
  LocalD1(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose): void;
  LocalD2(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  LocalD3(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, V3: Quantity_AbsorbedDose): void;
  LocalDN(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  EndPoint(): Quantity_AbsorbedDose;
  FirstUKnotIndex(): Graphic3d_ZLayerId;
  FirstParameter(): Quantity_AbsorbedDose;
  Knot(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Knots(K: TColStd_Array1OfReal): void;
  KnotSequence(K: TColStd_Array1OfReal): void;
  KnotDistribution(): GeomAbs_BSplKnotDistribution;
  LastUKnotIndex(): Graphic3d_ZLayerId;
  LastParameter(): Quantity_AbsorbedDose;
  LocateU(U: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, WithKnotRepetition: Standard_Boolean): void;
  Multiplicity(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Multiplicities(M: TColStd_Array1OfInteger): void;
  NbKnots(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Pole(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Poles(P: TColStd_Array1OfReal): void;
  StartPoint(): Quantity_AbsorbedDose;
  Weight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights(W: TColStd_Array1OfReal): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  MovePointAndTangent(U: Quantity_AbsorbedDose, NewValue: Quantity_AbsorbedDose, Derivative: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, StartingCondition: Graphic3d_ZLayerId, EndingCondition: Graphic3d_ZLayerId, ErrorStatus: Graphic3d_ZLayerId): void;
  Resolution(Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Law_BSpline;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Law_BSpline_1 extends Law_BSpline {
    constructor(Poles: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Multiplicities: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean);
  }

  export declare class Law_BSpline_2 extends Law_BSpline {
    constructor(Poles: TColStd_Array1OfReal, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Multiplicities: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean);
  }

export declare class Law_Interpol extends Law_BSpFunc {
  constructor()
  Set_1(ParAndRad: TColgp_Array1OfPnt2d, Periodic: Standard_Boolean): void;
  SetInRelative_1(ParAndRad: TColgp_Array1OfPnt2d, Ud: Quantity_AbsorbedDose, Uf: Quantity_AbsorbedDose, Periodic: Standard_Boolean): void;
  Set_2(ParAndRad: TColgp_Array1OfPnt2d, Dd: Quantity_AbsorbedDose, Df: Quantity_AbsorbedDose, Periodic: Standard_Boolean): void;
  SetInRelative_2(ParAndRad: TColgp_Array1OfPnt2d, Ud: Quantity_AbsorbedDose, Uf: Quantity_AbsorbedDose, Dd: Quantity_AbsorbedDose, Df: Quantity_AbsorbedDose, Periodic: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Law_Interpol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_Interpol): void;
  get(): Law_Interpol;
  delete(): void;
}

  export declare class Handle_Law_Interpol_1 extends Handle_Law_Interpol {
    constructor();
  }

  export declare class Handle_Law_Interpol_2 extends Handle_Law_Interpol {
    constructor(thePtr: Law_Interpol);
  }

  export declare class Handle_Law_Interpol_3 extends Handle_Law_Interpol {
    constructor(theHandle: Handle_Law_Interpol);
  }

  export declare class Handle_Law_Interpol_4 extends Handle_Law_Interpol {
    constructor(theHandle: Handle_Law_Interpol);
  }

export declare class Law_BSplineKnotSplitting {
  constructor(BasisLaw: Handle_Law_BSpline, ContinuityRange: Graphic3d_ZLayerId)
  NbSplits(): Graphic3d_ZLayerId;
  Splitting(SplitValues: TColStd_Array1OfInteger): void;
  SplitValue(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Law_Linear extends Law_Function {
  constructor()
  Set(Pdeb: Quantity_AbsorbedDose, Valdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose, Valfin: Quantity_AbsorbedDose): void;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Value(X: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D1(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  D2(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): void;
  Trim(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Law_Function;
  Bounds(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Law_Linear {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_Linear): void;
  get(): Law_Linear;
  delete(): void;
}

  export declare class Handle_Law_Linear_1 extends Handle_Law_Linear {
    constructor();
  }

  export declare class Handle_Law_Linear_2 extends Handle_Law_Linear {
    constructor(thePtr: Law_Linear);
  }

  export declare class Handle_Law_Linear_3 extends Handle_Law_Linear {
    constructor(theHandle: Handle_Law_Linear);
  }

  export declare class Handle_Law_Linear_4 extends Handle_Law_Linear {
    constructor(theHandle: Handle_Law_Linear);
  }

export declare class Law_BSpFunc extends Law_Function {
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Value(X: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D1(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  D2(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): void;
  Trim(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Law_Function;
  Bounds(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose): void;
  Curve(): Handle_Law_BSpline;
  SetCurve(C: Handle_Law_BSpline): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Law_BSpFunc_1 extends Law_BSpFunc {
    constructor();
  }

  export declare class Law_BSpFunc_2 extends Law_BSpFunc {
    constructor(C: Handle_Law_BSpline, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose);
  }

export declare class Handle_Law_BSpFunc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_BSpFunc): void;
  get(): Law_BSpFunc;
  delete(): void;
}

  export declare class Handle_Law_BSpFunc_1 extends Handle_Law_BSpFunc {
    constructor();
  }

  export declare class Handle_Law_BSpFunc_2 extends Handle_Law_BSpFunc {
    constructor(thePtr: Law_BSpFunc);
  }

  export declare class Handle_Law_BSpFunc_3 extends Handle_Law_BSpFunc {
    constructor(theHandle: Handle_Law_BSpFunc);
  }

  export declare class Handle_Law_BSpFunc_4 extends Handle_Law_BSpFunc {
    constructor(theHandle: Handle_Law_BSpFunc);
  }

export declare class Law_Constant extends Law_Function {
  constructor()
  Set(Radius: Quantity_AbsorbedDose, PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose): void;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Value(X: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D1(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  D2(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): void;
  Trim(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Law_Function;
  Bounds(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Law_Constant {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_Constant): void;
  get(): Law_Constant;
  delete(): void;
}

  export declare class Handle_Law_Constant_1 extends Handle_Law_Constant {
    constructor();
  }

  export declare class Handle_Law_Constant_2 extends Handle_Law_Constant {
    constructor(thePtr: Law_Constant);
  }

  export declare class Handle_Law_Constant_3 extends Handle_Law_Constant {
    constructor(theHandle: Handle_Law_Constant);
  }

  export declare class Handle_Law_Constant_4 extends Handle_Law_Constant {
    constructor(theHandle: Handle_Law_Constant);
  }

export declare class Handle_Law_Composite {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Law_Composite): void;
  get(): Law_Composite;
  delete(): void;
}

  export declare class Handle_Law_Composite_1 extends Handle_Law_Composite {
    constructor();
  }

  export declare class Handle_Law_Composite_2 extends Handle_Law_Composite {
    constructor(thePtr: Law_Composite);
  }

  export declare class Handle_Law_Composite_3 extends Handle_Law_Composite {
    constructor(theHandle: Handle_Law_Composite);
  }

  export declare class Handle_Law_Composite_4 extends Handle_Law_Composite {
    constructor(theHandle: Handle_Law_Composite);
  }

export declare class Law_Composite extends Law_Function {
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Value(X: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D1(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  D2(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): void;
  Trim(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Law_Function;
  Bounds(PFirst: Quantity_AbsorbedDose, PLast: Quantity_AbsorbedDose): void;
  ChangeElementaryLaw(W: Quantity_AbsorbedDose): Handle_Law_Function;
  ChangeLaws(): Law_Laws;
  IsPeriodic(): Standard_Boolean;
  SetPeriodic(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Law_Composite_1 extends Law_Composite {
    constructor();
  }

  export declare class Law_Composite_2 extends Law_Composite {
    constructor(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class IntCurvesFace_Intersector {
  constructor(F: TopoDS_Face, aTol: Quantity_AbsorbedDose, aRestr: Standard_Boolean, UseBToler: Standard_Boolean)
  Perform_1(L: gp_Lin, PInf: Quantity_AbsorbedDose, PSup: Quantity_AbsorbedDose): void;
  Perform_2(HCu: Handle_Adaptor3d_HCurve, PInf: Quantity_AbsorbedDose, PSup: Quantity_AbsorbedDose): void;
  SurfaceType(): GeomAbs_SurfaceType;
  IsDone(): Standard_Boolean;
  NbPnt(): Graphic3d_ZLayerId;
  UParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  VParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  WParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Pnt(I: Graphic3d_ZLayerId): gp_Pnt;
  Transition(I: Graphic3d_ZLayerId): IntCurveSurface_TransitionOnCurve;
  State(I: Graphic3d_ZLayerId): TopAbs_State;
  IsParallel(): Standard_Boolean;
  Face(): TopoDS_Face;
  ClassifyUVPoint(Puv: gp_Pnt2d): TopAbs_State;
  Bounding(): Bnd_Box;
  SetUseBoundToler(UseBToler: Standard_Boolean): void;
  GetUseBoundToler(): Standard_Boolean;
  Destroy(): void;
  delete(): void;
}

export declare class IntCurvesFace_ShapeIntersector {
  constructor()
  Load(Sh: TopoDS_Shape, Tol: Quantity_AbsorbedDose): void;
  Perform_1(L: gp_Lin, PInf: Quantity_AbsorbedDose, PSup: Quantity_AbsorbedDose): void;
  PerformNearest(L: gp_Lin, PInf: Quantity_AbsorbedDose, PSup: Quantity_AbsorbedDose): void;
  Perform_2(HCu: Handle_Adaptor3d_HCurve, PInf: Quantity_AbsorbedDose, PSup: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbPnt(): Graphic3d_ZLayerId;
  UParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  VParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  WParameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Pnt(I: Graphic3d_ZLayerId): gp_Pnt;
  Transition(I: Graphic3d_ZLayerId): IntCurveSurface_TransitionOnCurve;
  State(I: Graphic3d_ZLayerId): TopAbs_State;
  Face(I: Graphic3d_ZLayerId): TopoDS_Face;
  SortResult(): void;
  Destroy(): void;
  delete(): void;
}

export declare class Handle_IGESSelect_DispPerSingleView {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_DispPerSingleView): void;
  get(): IGESSelect_DispPerSingleView;
  delete(): void;
}

  export declare class Handle_IGESSelect_DispPerSingleView_1 extends Handle_IGESSelect_DispPerSingleView {
    constructor();
  }

  export declare class Handle_IGESSelect_DispPerSingleView_2 extends Handle_IGESSelect_DispPerSingleView {
    constructor(thePtr: IGESSelect_DispPerSingleView);
  }

  export declare class Handle_IGESSelect_DispPerSingleView_3 extends Handle_IGESSelect_DispPerSingleView {
    constructor(theHandle: Handle_IGESSelect_DispPerSingleView);
  }

  export declare class Handle_IGESSelect_DispPerSingleView_4 extends Handle_IGESSelect_DispPerSingleView {
    constructor(theHandle: Handle_IGESSelect_DispPerSingleView);
  }

export declare class IGESSelect_DispPerSingleView extends IFSelect_Dispatch {
  constructor()
  Label(): XCAFDoc_PartId;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  CanHaveRemainder(): Standard_Boolean;
  Remainder(G: Interface_Graph): Interface_EntityIterator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_Activator extends IFSelect_Activator {
  constructor()
  Do(number: Graphic3d_ZLayerId, pilot: Handle_IFSelect_SessionPilot): IFSelect_ReturnStatus;
  Help(number: Graphic3d_ZLayerId): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_Activator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_Activator): void;
  get(): IGESSelect_Activator;
  delete(): void;
}

  export declare class Handle_IGESSelect_Activator_1 extends Handle_IGESSelect_Activator {
    constructor();
  }

  export declare class Handle_IGESSelect_Activator_2 extends Handle_IGESSelect_Activator {
    constructor(thePtr: IGESSelect_Activator);
  }

  export declare class Handle_IGESSelect_Activator_3 extends Handle_IGESSelect_Activator {
    constructor(theHandle: Handle_IGESSelect_Activator);
  }

  export declare class Handle_IGESSelect_Activator_4 extends Handle_IGESSelect_Activator {
    constructor(theHandle: Handle_IGESSelect_Activator);
  }

export declare class Handle_IGESSelect_SelectSingleViewFrom {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectSingleViewFrom): void;
  get(): IGESSelect_SelectSingleViewFrom;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectSingleViewFrom_1 extends Handle_IGESSelect_SelectSingleViewFrom {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectSingleViewFrom_2 extends Handle_IGESSelect_SelectSingleViewFrom {
    constructor(thePtr: IGESSelect_SelectSingleViewFrom);
  }

  export declare class Handle_IGESSelect_SelectSingleViewFrom_3 extends Handle_IGESSelect_SelectSingleViewFrom {
    constructor(theHandle: Handle_IGESSelect_SelectSingleViewFrom);
  }

  export declare class Handle_IGESSelect_SelectSingleViewFrom_4 extends Handle_IGESSelect_SelectSingleViewFrom {
    constructor(theHandle: Handle_IGESSelect_SelectSingleViewFrom);
  }

export declare class IGESSelect_SelectSingleViewFrom extends IFSelect_SelectDeduct {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectBypassGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectBypassGroup): void;
  get(): IGESSelect_SelectBypassGroup;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectBypassGroup_1 extends Handle_IGESSelect_SelectBypassGroup {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectBypassGroup_2 extends Handle_IGESSelect_SelectBypassGroup {
    constructor(thePtr: IGESSelect_SelectBypassGroup);
  }

  export declare class Handle_IGESSelect_SelectBypassGroup_3 extends Handle_IGESSelect_SelectBypassGroup {
    constructor(theHandle: Handle_IGESSelect_SelectBypassGroup);
  }

  export declare class Handle_IGESSelect_SelectBypassGroup_4 extends Handle_IGESSelect_SelectBypassGroup {
    constructor(theHandle: Handle_IGESSelect_SelectBypassGroup);
  }

export declare class IGESSelect_SelectBypassGroup extends IFSelect_SelectExplore {
  constructor(level: Graphic3d_ZLayerId)
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_AddFileComment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_AddFileComment): void;
  get(): IGESSelect_AddFileComment;
  delete(): void;
}

  export declare class Handle_IGESSelect_AddFileComment_1 extends Handle_IGESSelect_AddFileComment {
    constructor();
  }

  export declare class Handle_IGESSelect_AddFileComment_2 extends Handle_IGESSelect_AddFileComment {
    constructor(thePtr: IGESSelect_AddFileComment);
  }

  export declare class Handle_IGESSelect_AddFileComment_3 extends Handle_IGESSelect_AddFileComment {
    constructor(theHandle: Handle_IGESSelect_AddFileComment);
  }

  export declare class Handle_IGESSelect_AddFileComment_4 extends Handle_IGESSelect_AddFileComment {
    constructor(theHandle: Handle_IGESSelect_AddFileComment);
  }

export declare class IGESSelect_AddFileComment extends IGESSelect_FileModifier {
  constructor()
  Clear(): void;
  AddLine(line: Standard_CString): void;
  AddLines(lines: Handle_TColStd_HSequenceOfHAsciiString): void;
  NbLines(): Graphic3d_ZLayerId;
  Line(num: Graphic3d_ZLayerId): Standard_CString;
  Lines(): Handle_TColStd_HSequenceOfHAsciiString;
  Perform(ctx: IFSelect_ContextWrite, writer: IGESData_IGESWriter): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_DispPerDrawing extends IFSelect_Dispatch {
  constructor()
  Label(): XCAFDoc_PartId;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  CanHaveRemainder(): Standard_Boolean;
  Remainder(G: Interface_Graph): Interface_EntityIterator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_DispPerDrawing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_DispPerDrawing): void;
  get(): IGESSelect_DispPerDrawing;
  delete(): void;
}

  export declare class Handle_IGESSelect_DispPerDrawing_1 extends Handle_IGESSelect_DispPerDrawing {
    constructor();
  }

  export declare class Handle_IGESSelect_DispPerDrawing_2 extends Handle_IGESSelect_DispPerDrawing {
    constructor(thePtr: IGESSelect_DispPerDrawing);
  }

  export declare class Handle_IGESSelect_DispPerDrawing_3 extends Handle_IGESSelect_DispPerDrawing {
    constructor(theHandle: Handle_IGESSelect_DispPerDrawing);
  }

  export declare class Handle_IGESSelect_DispPerDrawing_4 extends Handle_IGESSelect_DispPerDrawing {
    constructor(theHandle: Handle_IGESSelect_DispPerDrawing);
  }

export declare class IGESSelect_IGESTypeForm extends IFSelect_Signature {
  constructor(withform: Standard_Boolean)
  SetForm(withform: Standard_Boolean): void;
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_IGESTypeForm {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_IGESTypeForm): void;
  get(): IGESSelect_IGESTypeForm;
  delete(): void;
}

  export declare class Handle_IGESSelect_IGESTypeForm_1 extends Handle_IGESSelect_IGESTypeForm {
    constructor();
  }

  export declare class Handle_IGESSelect_IGESTypeForm_2 extends Handle_IGESSelect_IGESTypeForm {
    constructor(thePtr: IGESSelect_IGESTypeForm);
  }

  export declare class Handle_IGESSelect_IGESTypeForm_3 extends Handle_IGESSelect_IGESTypeForm {
    constructor(theHandle: Handle_IGESSelect_IGESTypeForm);
  }

  export declare class Handle_IGESSelect_IGESTypeForm_4 extends Handle_IGESSelect_IGESTypeForm {
    constructor(theHandle: Handle_IGESSelect_IGESTypeForm);
  }

export declare class IGESSelect_SelectDrawingFrom extends IFSelect_SelectDeduct {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectDrawingFrom {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectDrawingFrom): void;
  get(): IGESSelect_SelectDrawingFrom;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectDrawingFrom_1 extends Handle_IGESSelect_SelectDrawingFrom {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectDrawingFrom_2 extends Handle_IGESSelect_SelectDrawingFrom {
    constructor(thePtr: IGESSelect_SelectDrawingFrom);
  }

  export declare class Handle_IGESSelect_SelectDrawingFrom_3 extends Handle_IGESSelect_SelectDrawingFrom {
    constructor(theHandle: Handle_IGESSelect_SelectDrawingFrom);
  }

  export declare class Handle_IGESSelect_SelectDrawingFrom_4 extends Handle_IGESSelect_SelectDrawingFrom {
    constructor(theHandle: Handle_IGESSelect_SelectDrawingFrom);
  }

export declare class IGESSelect_SelectBypassSubfigure extends IFSelect_SelectExplore {
  constructor(level: Graphic3d_ZLayerId)
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectBypassSubfigure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectBypassSubfigure): void;
  get(): IGESSelect_SelectBypassSubfigure;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectBypassSubfigure_1 extends Handle_IGESSelect_SelectBypassSubfigure {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectBypassSubfigure_2 extends Handle_IGESSelect_SelectBypassSubfigure {
    constructor(thePtr: IGESSelect_SelectBypassSubfigure);
  }

  export declare class Handle_IGESSelect_SelectBypassSubfigure_3 extends Handle_IGESSelect_SelectBypassSubfigure {
    constructor(theHandle: Handle_IGESSelect_SelectBypassSubfigure);
  }

  export declare class Handle_IGESSelect_SelectBypassSubfigure_4 extends Handle_IGESSelect_SelectBypassSubfigure {
    constructor(theHandle: Handle_IGESSelect_SelectBypassSubfigure);
  }

export declare class Handle_IGESSelect_UpdateLastChange {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_UpdateLastChange): void;
  get(): IGESSelect_UpdateLastChange;
  delete(): void;
}

  export declare class Handle_IGESSelect_UpdateLastChange_1 extends Handle_IGESSelect_UpdateLastChange {
    constructor();
  }

  export declare class Handle_IGESSelect_UpdateLastChange_2 extends Handle_IGESSelect_UpdateLastChange {
    constructor(thePtr: IGESSelect_UpdateLastChange);
  }

  export declare class Handle_IGESSelect_UpdateLastChange_3 extends Handle_IGESSelect_UpdateLastChange {
    constructor(theHandle: Handle_IGESSelect_UpdateLastChange);
  }

  export declare class Handle_IGESSelect_UpdateLastChange_4 extends Handle_IGESSelect_UpdateLastChange {
    constructor(theHandle: Handle_IGESSelect_UpdateLastChange);
  }

export declare class IGESSelect_UpdateLastChange extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectName): void;
  get(): IGESSelect_SelectName;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectName_1 extends Handle_IGESSelect_SelectName {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectName_2 extends Handle_IGESSelect_SelectName {
    constructor(thePtr: IGESSelect_SelectName);
  }

  export declare class Handle_IGESSelect_SelectName_3 extends Handle_IGESSelect_SelectName {
    constructor(theHandle: Handle_IGESSelect_SelectName);
  }

  export declare class Handle_IGESSelect_SelectName_4 extends Handle_IGESSelect_SelectName {
    constructor(theHandle: Handle_IGESSelect_SelectName);
  }

export declare class IGESSelect_SelectName extends IFSelect_SelectExtract {
  constructor()
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  SetName(name: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectBasicGeom {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectBasicGeom): void;
  get(): IGESSelect_SelectBasicGeom;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectBasicGeom_1 extends Handle_IGESSelect_SelectBasicGeom {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectBasicGeom_2 extends Handle_IGESSelect_SelectBasicGeom {
    constructor(thePtr: IGESSelect_SelectBasicGeom);
  }

  export declare class Handle_IGESSelect_SelectBasicGeom_3 extends Handle_IGESSelect_SelectBasicGeom {
    constructor(theHandle: Handle_IGESSelect_SelectBasicGeom);
  }

  export declare class Handle_IGESSelect_SelectBasicGeom_4 extends Handle_IGESSelect_SelectBasicGeom {
    constructor(theHandle: Handle_IGESSelect_SelectBasicGeom);
  }

export declare class Handle_IGESSelect_SelectVisibleStatus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectVisibleStatus): void;
  get(): IGESSelect_SelectVisibleStatus;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectVisibleStatus_1 extends Handle_IGESSelect_SelectVisibleStatus {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectVisibleStatus_2 extends Handle_IGESSelect_SelectVisibleStatus {
    constructor(thePtr: IGESSelect_SelectVisibleStatus);
  }

  export declare class Handle_IGESSelect_SelectVisibleStatus_3 extends Handle_IGESSelect_SelectVisibleStatus {
    constructor(theHandle: Handle_IGESSelect_SelectVisibleStatus);
  }

  export declare class Handle_IGESSelect_SelectVisibleStatus_4 extends Handle_IGESSelect_SelectVisibleStatus {
    constructor(theHandle: Handle_IGESSelect_SelectVisibleStatus);
  }

export declare class IGESSelect_SelectVisibleStatus extends IFSelect_SelectExtract {
  constructor()
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_ChangeLevelNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_ChangeLevelNumber): void;
  get(): IGESSelect_ChangeLevelNumber;
  delete(): void;
}

  export declare class Handle_IGESSelect_ChangeLevelNumber_1 extends Handle_IGESSelect_ChangeLevelNumber {
    constructor();
  }

  export declare class Handle_IGESSelect_ChangeLevelNumber_2 extends Handle_IGESSelect_ChangeLevelNumber {
    constructor(thePtr: IGESSelect_ChangeLevelNumber);
  }

  export declare class Handle_IGESSelect_ChangeLevelNumber_3 extends Handle_IGESSelect_ChangeLevelNumber {
    constructor(theHandle: Handle_IGESSelect_ChangeLevelNumber);
  }

  export declare class Handle_IGESSelect_ChangeLevelNumber_4 extends Handle_IGESSelect_ChangeLevelNumber {
    constructor(theHandle: Handle_IGESSelect_ChangeLevelNumber);
  }

export declare class IGESSelect_ChangeLevelNumber extends IGESSelect_ModelModifier {
  constructor()
  HasOldNumber(): Standard_Boolean;
  OldNumber(): Handle_IFSelect_IntParam;
  SetOldNumber(param: Handle_IFSelect_IntParam): void;
  NewNumber(): Handle_IFSelect_IntParam;
  SetNewNumber(param: Handle_IFSelect_IntParam): void;
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectFromSingleView {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectFromSingleView): void;
  get(): IGESSelect_SelectFromSingleView;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectFromSingleView_1 extends Handle_IGESSelect_SelectFromSingleView {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectFromSingleView_2 extends Handle_IGESSelect_SelectFromSingleView {
    constructor(thePtr: IGESSelect_SelectFromSingleView);
  }

  export declare class Handle_IGESSelect_SelectFromSingleView_3 extends Handle_IGESSelect_SelectFromSingleView {
    constructor(theHandle: Handle_IGESSelect_SelectFromSingleView);
  }

  export declare class Handle_IGESSelect_SelectFromSingleView_4 extends Handle_IGESSelect_SelectFromSingleView {
    constructor(theHandle: Handle_IGESSelect_SelectFromSingleView);
  }

export declare class IGESSelect_SelectFromSingleView extends IFSelect_SelectDeduct {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_SelectFromDrawing extends IFSelect_SelectDeduct {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectFromDrawing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectFromDrawing): void;
  get(): IGESSelect_SelectFromDrawing;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectFromDrawing_1 extends Handle_IGESSelect_SelectFromDrawing {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectFromDrawing_2 extends Handle_IGESSelect_SelectFromDrawing {
    constructor(thePtr: IGESSelect_SelectFromDrawing);
  }

  export declare class Handle_IGESSelect_SelectFromDrawing_3 extends Handle_IGESSelect_SelectFromDrawing {
    constructor(theHandle: Handle_IGESSelect_SelectFromDrawing);
  }

  export declare class Handle_IGESSelect_SelectFromDrawing_4 extends Handle_IGESSelect_SelectFromDrawing {
    constructor(theHandle: Handle_IGESSelect_SelectFromDrawing);
  }

export declare class Handle_IGESSelect_RemoveCurves {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_RemoveCurves): void;
  get(): IGESSelect_RemoveCurves;
  delete(): void;
}

  export declare class Handle_IGESSelect_RemoveCurves_1 extends Handle_IGESSelect_RemoveCurves {
    constructor();
  }

  export declare class Handle_IGESSelect_RemoveCurves_2 extends Handle_IGESSelect_RemoveCurves {
    constructor(thePtr: IGESSelect_RemoveCurves);
  }

  export declare class Handle_IGESSelect_RemoveCurves_3 extends Handle_IGESSelect_RemoveCurves {
    constructor(theHandle: Handle_IGESSelect_RemoveCurves);
  }

  export declare class Handle_IGESSelect_RemoveCurves_4 extends Handle_IGESSelect_RemoveCurves {
    constructor(theHandle: Handle_IGESSelect_RemoveCurves);
  }

export declare class IGESSelect_RemoveCurves extends IGESSelect_ModelModifier {
  constructor(UV: Standard_Boolean)
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_ModelModifier extends IFSelect_Modifier {
  Perform(ctx: IFSelect_ContextModif, target: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, TC: Interface_CopyTool): void;
  PerformProtocol(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, proto: Handle_IGESData_Protocol, TC: Interface_CopyTool): void;
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_ModelModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_ModelModifier): void;
  get(): IGESSelect_ModelModifier;
  delete(): void;
}

  export declare class Handle_IGESSelect_ModelModifier_1 extends Handle_IGESSelect_ModelModifier {
    constructor();
  }

  export declare class Handle_IGESSelect_ModelModifier_2 extends Handle_IGESSelect_ModelModifier {
    constructor(thePtr: IGESSelect_ModelModifier);
  }

  export declare class Handle_IGESSelect_ModelModifier_3 extends Handle_IGESSelect_ModelModifier {
    constructor(theHandle: Handle_IGESSelect_ModelModifier);
  }

  export declare class Handle_IGESSelect_ModelModifier_4 extends Handle_IGESSelect_ModelModifier {
    constructor(theHandle: Handle_IGESSelect_ModelModifier);
  }

export declare class Handle_IGESSelect_SetLabel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SetLabel): void;
  get(): IGESSelect_SetLabel;
  delete(): void;
}

  export declare class Handle_IGESSelect_SetLabel_1 extends Handle_IGESSelect_SetLabel {
    constructor();
  }

  export declare class Handle_IGESSelect_SetLabel_2 extends Handle_IGESSelect_SetLabel {
    constructor(thePtr: IGESSelect_SetLabel);
  }

  export declare class Handle_IGESSelect_SetLabel_3 extends Handle_IGESSelect_SetLabel {
    constructor(theHandle: Handle_IGESSelect_SetLabel);
  }

  export declare class Handle_IGESSelect_SetLabel_4 extends Handle_IGESSelect_SetLabel {
    constructor(theHandle: Handle_IGESSelect_SetLabel);
  }

export declare class IGESSelect_SetLabel extends IGESSelect_ModelModifier {
  constructor(mode: Graphic3d_ZLayerId, enforce: Standard_Boolean)
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SplineToBSpline {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SplineToBSpline): void;
  get(): IGESSelect_SplineToBSpline;
  delete(): void;
}

  export declare class Handle_IGESSelect_SplineToBSpline_1 extends Handle_IGESSelect_SplineToBSpline {
    constructor();
  }

  export declare class Handle_IGESSelect_SplineToBSpline_2 extends Handle_IGESSelect_SplineToBSpline {
    constructor(thePtr: IGESSelect_SplineToBSpline);
  }

  export declare class Handle_IGESSelect_SplineToBSpline_3 extends Handle_IGESSelect_SplineToBSpline {
    constructor(theHandle: Handle_IGESSelect_SplineToBSpline);
  }

  export declare class Handle_IGESSelect_SplineToBSpline_4 extends Handle_IGESSelect_SplineToBSpline {
    constructor(theHandle: Handle_IGESSelect_SplineToBSpline);
  }

export declare class IGESSelect_SplineToBSpline extends IFSelect_Transformer {
  constructor(tryC2: Standard_Boolean)
  OptionTryC2(): Standard_Boolean;
  Perform(G: Interface_Graph, protocol: Handle_Interface_Protocol, checks: Interface_CheckIterator, newmod: Handle_Interface_InterfaceModel): Standard_Boolean;
  Updated(entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient): Standard_Boolean;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_SignColor extends IFSelect_Signature {
  constructor(mode: Graphic3d_ZLayerId)
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SignColor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SignColor): void;
  get(): IGESSelect_SignColor;
  delete(): void;
}

  export declare class Handle_IGESSelect_SignColor_1 extends Handle_IGESSelect_SignColor {
    constructor();
  }

  export declare class Handle_IGESSelect_SignColor_2 extends Handle_IGESSelect_SignColor {
    constructor(thePtr: IGESSelect_SignColor);
  }

  export declare class Handle_IGESSelect_SignColor_3 extends Handle_IGESSelect_SignColor {
    constructor(theHandle: Handle_IGESSelect_SignColor);
  }

  export declare class Handle_IGESSelect_SignColor_4 extends Handle_IGESSelect_SignColor {
    constructor(theHandle: Handle_IGESSelect_SignColor);
  }

export declare class Handle_IGESSelect_ViewSorter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_ViewSorter): void;
  get(): IGESSelect_ViewSorter;
  delete(): void;
}

  export declare class Handle_IGESSelect_ViewSorter_1 extends Handle_IGESSelect_ViewSorter {
    constructor();
  }

  export declare class Handle_IGESSelect_ViewSorter_2 extends Handle_IGESSelect_ViewSorter {
    constructor(thePtr: IGESSelect_ViewSorter);
  }

  export declare class Handle_IGESSelect_ViewSorter_3 extends Handle_IGESSelect_ViewSorter {
    constructor(theHandle: Handle_IGESSelect_ViewSorter);
  }

  export declare class Handle_IGESSelect_ViewSorter_4 extends Handle_IGESSelect_ViewSorter {
    constructor(theHandle: Handle_IGESSelect_ViewSorter);
  }

export declare class IGESSelect_ViewSorter extends Standard_Transient {
  constructor()
  SetModel(model: Handle_IGESData_IGESModel): void;
  Clear(): void;
  Add(ent: Handle_Standard_Transient): Standard_Boolean;
  AddEntity(igesent: Handle_IGESData_IGESEntity): Standard_Boolean;
  AddList(list: Handle_TColStd_HSequenceOfTransient): void;
  AddModel(model: Handle_Interface_InterfaceModel): void;
  NbEntities(): Graphic3d_ZLayerId;
  SortSingleViews(alsoframes: Standard_Boolean): void;
  SortDrawings(G: Interface_Graph): void;
  NbSets(final: Standard_Boolean): Graphic3d_ZLayerId;
  SetItem(num: Graphic3d_ZLayerId, final: Standard_Boolean): Handle_IGESData_IGESEntity;
  Sets(final: Standard_Boolean): Handle_IFSelect_PacketList;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_RebuildGroups {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_RebuildGroups): void;
  get(): IGESSelect_RebuildGroups;
  delete(): void;
}

  export declare class Handle_IGESSelect_RebuildGroups_1 extends Handle_IGESSelect_RebuildGroups {
    constructor();
  }

  export declare class Handle_IGESSelect_RebuildGroups_2 extends Handle_IGESSelect_RebuildGroups {
    constructor(thePtr: IGESSelect_RebuildGroups);
  }

  export declare class Handle_IGESSelect_RebuildGroups_3 extends Handle_IGESSelect_RebuildGroups {
    constructor(theHandle: Handle_IGESSelect_RebuildGroups);
  }

  export declare class Handle_IGESSelect_RebuildGroups_4 extends Handle_IGESSelect_RebuildGroups {
    constructor(theHandle: Handle_IGESSelect_RebuildGroups);
  }

export declare class IGESSelect_RebuildGroups extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectFaces {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectFaces): void;
  get(): IGESSelect_SelectFaces;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectFaces_1 extends Handle_IGESSelect_SelectFaces {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectFaces_2 extends Handle_IGESSelect_SelectFaces {
    constructor(thePtr: IGESSelect_SelectFaces);
  }

  export declare class Handle_IGESSelect_SelectFaces_3 extends Handle_IGESSelect_SelectFaces {
    constructor(theHandle: Handle_IGESSelect_SelectFaces);
  }

  export declare class Handle_IGESSelect_SelectFaces_4 extends Handle_IGESSelect_SelectFaces {
    constructor(theHandle: Handle_IGESSelect_SelectFaces);
  }

export declare class IGESSelect_SelectFaces extends IFSelect_SelectExplore {
  constructor()
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_Dumper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_Dumper): void;
  get(): IGESSelect_Dumper;
  delete(): void;
}

  export declare class Handle_IGESSelect_Dumper_1 extends Handle_IGESSelect_Dumper {
    constructor();
  }

  export declare class Handle_IGESSelect_Dumper_2 extends Handle_IGESSelect_Dumper {
    constructor(thePtr: IGESSelect_Dumper);
  }

  export declare class Handle_IGESSelect_Dumper_3 extends Handle_IGESSelect_Dumper {
    constructor(theHandle: Handle_IGESSelect_Dumper);
  }

  export declare class Handle_IGESSelect_Dumper_4 extends Handle_IGESSelect_Dumper {
    constructor(theHandle: Handle_IGESSelect_Dumper);
  }

export declare class IGESSelect_Dumper extends IFSelect_SessionDumper {
  constructor()
  WriteOwn(file: IFSelect_SessionFile, item: Handle_Standard_Transient): Standard_Boolean;
  ReadOwn(file: IFSelect_SessionFile, type: XCAFDoc_PartId, item: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_UpdateFileName extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_UpdateFileName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_UpdateFileName): void;
  get(): IGESSelect_UpdateFileName;
  delete(): void;
}

  export declare class Handle_IGESSelect_UpdateFileName_1 extends Handle_IGESSelect_UpdateFileName {
    constructor();
  }

  export declare class Handle_IGESSelect_UpdateFileName_2 extends Handle_IGESSelect_UpdateFileName {
    constructor(thePtr: IGESSelect_UpdateFileName);
  }

  export declare class Handle_IGESSelect_UpdateFileName_3 extends Handle_IGESSelect_UpdateFileName {
    constructor(theHandle: Handle_IGESSelect_UpdateFileName);
  }

  export declare class Handle_IGESSelect_UpdateFileName_4 extends Handle_IGESSelect_UpdateFileName {
    constructor(theHandle: Handle_IGESSelect_UpdateFileName);
  }

export declare class Handle_IGESSelect_WorkLibrary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_WorkLibrary): void;
  get(): IGESSelect_WorkLibrary;
  delete(): void;
}

  export declare class Handle_IGESSelect_WorkLibrary_1 extends Handle_IGESSelect_WorkLibrary {
    constructor();
  }

  export declare class Handle_IGESSelect_WorkLibrary_2 extends Handle_IGESSelect_WorkLibrary {
    constructor(thePtr: IGESSelect_WorkLibrary);
  }

  export declare class Handle_IGESSelect_WorkLibrary_3 extends Handle_IGESSelect_WorkLibrary {
    constructor(theHandle: Handle_IGESSelect_WorkLibrary);
  }

  export declare class Handle_IGESSelect_WorkLibrary_4 extends Handle_IGESSelect_WorkLibrary {
    constructor(theHandle: Handle_IGESSelect_WorkLibrary);
  }

export declare class IGESSelect_WorkLibrary extends IFSelect_WorkLibrary {
  constructor(modefnes: Standard_Boolean)
  ReadFile(name: Standard_CString, model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol): Graphic3d_ZLayerId;
  WriteFile(ctx: IFSelect_ContextWrite): Standard_Boolean;
  static DefineProtocol(): Handle_IGESData_Protocol;
  DumpEntity(model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, entity: Handle_Standard_Transient, S: Standard_OStream, level: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_SetGlobalParameter extends IGESSelect_ModelModifier {
  constructor(numpar: Graphic3d_ZLayerId)
  GlobalNumber(): Graphic3d_ZLayerId;
  SetValue(text: Handle_TCollection_HAsciiString): void;
  Value(): Handle_TCollection_HAsciiString;
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SetGlobalParameter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SetGlobalParameter): void;
  get(): IGESSelect_SetGlobalParameter;
  delete(): void;
}

  export declare class Handle_IGESSelect_SetGlobalParameter_1 extends Handle_IGESSelect_SetGlobalParameter {
    constructor();
  }

  export declare class Handle_IGESSelect_SetGlobalParameter_2 extends Handle_IGESSelect_SetGlobalParameter {
    constructor(thePtr: IGESSelect_SetGlobalParameter);
  }

  export declare class Handle_IGESSelect_SetGlobalParameter_3 extends Handle_IGESSelect_SetGlobalParameter {
    constructor(theHandle: Handle_IGESSelect_SetGlobalParameter);
  }

  export declare class Handle_IGESSelect_SetGlobalParameter_4 extends Handle_IGESSelect_SetGlobalParameter {
    constructor(theHandle: Handle_IGESSelect_SetGlobalParameter);
  }

export declare class Handle_IGESSelect_AddGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_AddGroup): void;
  get(): IGESSelect_AddGroup;
  delete(): void;
}

  export declare class Handle_IGESSelect_AddGroup_1 extends Handle_IGESSelect_AddGroup {
    constructor();
  }

  export declare class Handle_IGESSelect_AddGroup_2 extends Handle_IGESSelect_AddGroup {
    constructor(thePtr: IGESSelect_AddGroup);
  }

  export declare class Handle_IGESSelect_AddGroup_3 extends Handle_IGESSelect_AddGroup {
    constructor(theHandle: Handle_IGESSelect_AddGroup);
  }

  export declare class Handle_IGESSelect_AddGroup_4 extends Handle_IGESSelect_AddGroup {
    constructor(theHandle: Handle_IGESSelect_AddGroup);
  }

export declare class IGESSelect_AddGroup extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_CounterOfLevelNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_CounterOfLevelNumber): void;
  get(): IGESSelect_CounterOfLevelNumber;
  delete(): void;
}

  export declare class Handle_IGESSelect_CounterOfLevelNumber_1 extends Handle_IGESSelect_CounterOfLevelNumber {
    constructor();
  }

  export declare class Handle_IGESSelect_CounterOfLevelNumber_2 extends Handle_IGESSelect_CounterOfLevelNumber {
    constructor(thePtr: IGESSelect_CounterOfLevelNumber);
  }

  export declare class Handle_IGESSelect_CounterOfLevelNumber_3 extends Handle_IGESSelect_CounterOfLevelNumber {
    constructor(theHandle: Handle_IGESSelect_CounterOfLevelNumber);
  }

  export declare class Handle_IGESSelect_CounterOfLevelNumber_4 extends Handle_IGESSelect_CounterOfLevelNumber {
    constructor(theHandle: Handle_IGESSelect_CounterOfLevelNumber);
  }

export declare class IGESSelect_CounterOfLevelNumber extends IFSelect_SignCounter {
  constructor(withmap: Standard_Boolean, withlist: Standard_Boolean)
  Clear(): void;
  AddSign(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): void;
  AddLevel(ent: Handle_Standard_Transient, level: Graphic3d_ZLayerId): void;
  HighestLevel(): Graphic3d_ZLayerId;
  NbTimesLevel(level: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Levels(): Handle_TColStd_HSequenceOfInteger;
  Sign(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Handle_TCollection_HAsciiString;
  PrintCount(S: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_AutoCorrect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_AutoCorrect): void;
  get(): IGESSelect_AutoCorrect;
  delete(): void;
}

  export declare class Handle_IGESSelect_AutoCorrect_1 extends Handle_IGESSelect_AutoCorrect {
    constructor();
  }

  export declare class Handle_IGESSelect_AutoCorrect_2 extends Handle_IGESSelect_AutoCorrect {
    constructor(thePtr: IGESSelect_AutoCorrect);
  }

  export declare class Handle_IGESSelect_AutoCorrect_3 extends Handle_IGESSelect_AutoCorrect {
    constructor(theHandle: Handle_IGESSelect_AutoCorrect);
  }

  export declare class Handle_IGESSelect_AutoCorrect_4 extends Handle_IGESSelect_AutoCorrect {
    constructor(theHandle: Handle_IGESSelect_AutoCorrect);
  }

export declare class IGESSelect_AutoCorrect extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_FloatFormat extends IGESSelect_FileModifier {
  constructor()
  SetDefault(digits: Graphic3d_ZLayerId): void;
  SetZeroSuppress(mode: Standard_Boolean): void;
  SetFormat(format: Standard_CString): void;
  SetFormatForRange(format: Standard_CString, Rmin: Quantity_AbsorbedDose, Rmax: Quantity_AbsorbedDose): void;
  Format(zerosup: Standard_Boolean, mainform: XCAFDoc_PartId, hasrange: Standard_Boolean, forminrange: XCAFDoc_PartId, rangemin: Quantity_AbsorbedDose, rangemax: Quantity_AbsorbedDose): void;
  Perform(ctx: IFSelect_ContextWrite, writer: IGESData_IGESWriter): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_FloatFormat {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_FloatFormat): void;
  get(): IGESSelect_FloatFormat;
  delete(): void;
}

  export declare class Handle_IGESSelect_FloatFormat_1 extends Handle_IGESSelect_FloatFormat {
    constructor();
  }

  export declare class Handle_IGESSelect_FloatFormat_2 extends Handle_IGESSelect_FloatFormat {
    constructor(thePtr: IGESSelect_FloatFormat);
  }

  export declare class Handle_IGESSelect_FloatFormat_3 extends Handle_IGESSelect_FloatFormat {
    constructor(theHandle: Handle_IGESSelect_FloatFormat);
  }

  export declare class Handle_IGESSelect_FloatFormat_4 extends Handle_IGESSelect_FloatFormat {
    constructor(theHandle: Handle_IGESSelect_FloatFormat);
  }

export declare class Handle_IGESSelect_ComputeStatus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_ComputeStatus): void;
  get(): IGESSelect_ComputeStatus;
  delete(): void;
}

  export declare class Handle_IGESSelect_ComputeStatus_1 extends Handle_IGESSelect_ComputeStatus {
    constructor();
  }

  export declare class Handle_IGESSelect_ComputeStatus_2 extends Handle_IGESSelect_ComputeStatus {
    constructor(thePtr: IGESSelect_ComputeStatus);
  }

  export declare class Handle_IGESSelect_ComputeStatus_3 extends Handle_IGESSelect_ComputeStatus {
    constructor(theHandle: Handle_IGESSelect_ComputeStatus);
  }

  export declare class Handle_IGESSelect_ComputeStatus_4 extends Handle_IGESSelect_ComputeStatus {
    constructor(theHandle: Handle_IGESSelect_ComputeStatus);
  }

export declare class IGESSelect_ComputeStatus extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_IGESName extends IFSelect_Signature {
  constructor()
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_IGESName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_IGESName): void;
  get(): IGESSelect_IGESName;
  delete(): void;
}

  export declare class Handle_IGESSelect_IGESName_1 extends Handle_IGESSelect_IGESName {
    constructor();
  }

  export declare class Handle_IGESSelect_IGESName_2 extends Handle_IGESSelect_IGESName {
    constructor(thePtr: IGESSelect_IGESName);
  }

  export declare class Handle_IGESSelect_IGESName_3 extends Handle_IGESSelect_IGESName {
    constructor(theHandle: Handle_IGESSelect_IGESName);
  }

  export declare class Handle_IGESSelect_IGESName_4 extends Handle_IGESSelect_IGESName {
    constructor(theHandle: Handle_IGESSelect_IGESName);
  }

export declare class IGESSelect {
  constructor();
  static Run(): void;
  static WhatIges(ent: Handle_IGESData_IGESEntity, G: Interface_Graph, sup: Handle_IGESData_IGESEntity, index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IGESSelect_SetVersion5 extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SetVersion5 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SetVersion5): void;
  get(): IGESSelect_SetVersion5;
  delete(): void;
}

  export declare class Handle_IGESSelect_SetVersion5_1 extends Handle_IGESSelect_SetVersion5 {
    constructor();
  }

  export declare class Handle_IGESSelect_SetVersion5_2 extends Handle_IGESSelect_SetVersion5 {
    constructor(thePtr: IGESSelect_SetVersion5);
  }

  export declare class Handle_IGESSelect_SetVersion5_3 extends Handle_IGESSelect_SetVersion5 {
    constructor(theHandle: Handle_IGESSelect_SetVersion5);
  }

  export declare class Handle_IGESSelect_SetVersion5_4 extends Handle_IGESSelect_SetVersion5 {
    constructor(theHandle: Handle_IGESSelect_SetVersion5);
  }

export declare class Handle_IGESSelect_UpdateCreationDate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_UpdateCreationDate): void;
  get(): IGESSelect_UpdateCreationDate;
  delete(): void;
}

  export declare class Handle_IGESSelect_UpdateCreationDate_1 extends Handle_IGESSelect_UpdateCreationDate {
    constructor();
  }

  export declare class Handle_IGESSelect_UpdateCreationDate_2 extends Handle_IGESSelect_UpdateCreationDate {
    constructor(thePtr: IGESSelect_UpdateCreationDate);
  }

  export declare class Handle_IGESSelect_UpdateCreationDate_3 extends Handle_IGESSelect_UpdateCreationDate {
    constructor(theHandle: Handle_IGESSelect_UpdateCreationDate);
  }

  export declare class Handle_IGESSelect_UpdateCreationDate_4 extends Handle_IGESSelect_UpdateCreationDate {
    constructor(theHandle: Handle_IGESSelect_UpdateCreationDate);
  }

export declare class IGESSelect_UpdateCreationDate extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SignStatus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SignStatus): void;
  get(): IGESSelect_SignStatus;
  delete(): void;
}

  export declare class Handle_IGESSelect_SignStatus_1 extends Handle_IGESSelect_SignStatus {
    constructor();
  }

  export declare class Handle_IGESSelect_SignStatus_2 extends Handle_IGESSelect_SignStatus {
    constructor(thePtr: IGESSelect_SignStatus);
  }

  export declare class Handle_IGESSelect_SignStatus_3 extends Handle_IGESSelect_SignStatus {
    constructor(theHandle: Handle_IGESSelect_SignStatus);
  }

  export declare class Handle_IGESSelect_SignStatus_4 extends Handle_IGESSelect_SignStatus {
    constructor(theHandle: Handle_IGESSelect_SignStatus);
  }

export declare class IGESSelect_SignStatus extends IFSelect_Signature {
  constructor()
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  Matches(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel, text: XCAFDoc_PartId, exact: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_SignLevelNumber extends IFSelect_Signature {
  constructor(countmode: Standard_Boolean)
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SignLevelNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SignLevelNumber): void;
  get(): IGESSelect_SignLevelNumber;
  delete(): void;
}

  export declare class Handle_IGESSelect_SignLevelNumber_1 extends Handle_IGESSelect_SignLevelNumber {
    constructor();
  }

  export declare class Handle_IGESSelect_SignLevelNumber_2 extends Handle_IGESSelect_SignLevelNumber {
    constructor(thePtr: IGESSelect_SignLevelNumber);
  }

  export declare class Handle_IGESSelect_SignLevelNumber_3 extends Handle_IGESSelect_SignLevelNumber {
    constructor(theHandle: Handle_IGESSelect_SignLevelNumber);
  }

  export declare class Handle_IGESSelect_SignLevelNumber_4 extends Handle_IGESSelect_SignLevelNumber {
    constructor(theHandle: Handle_IGESSelect_SignLevelNumber);
  }

export declare class IGESSelect_EditHeader extends IFSelect_Editor {
  constructor()
  Label(): XCAFDoc_PartId;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Update(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId, newval: Handle_TCollection_HAsciiString, enforce: Standard_Boolean): Standard_Boolean;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_EditHeader {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_EditHeader): void;
  get(): IGESSelect_EditHeader;
  delete(): void;
}

  export declare class Handle_IGESSelect_EditHeader_1 extends Handle_IGESSelect_EditHeader {
    constructor();
  }

  export declare class Handle_IGESSelect_EditHeader_2 extends Handle_IGESSelect_EditHeader {
    constructor(thePtr: IGESSelect_EditHeader);
  }

  export declare class Handle_IGESSelect_EditHeader_3 extends Handle_IGESSelect_EditHeader {
    constructor(theHandle: Handle_IGESSelect_EditHeader);
  }

  export declare class Handle_IGESSelect_EditHeader_4 extends Handle_IGESSelect_EditHeader {
    constructor(theHandle: Handle_IGESSelect_EditHeader);
  }

export declare class IGESSelect_SelectLevelNumber extends IFSelect_SelectExtract {
  constructor()
  SetLevelNumber(levnum: Handle_IFSelect_IntParam): void;
  LevelNumber(): Handle_IFSelect_IntParam;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectLevelNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectLevelNumber): void;
  get(): IGESSelect_SelectLevelNumber;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectLevelNumber_1 extends Handle_IGESSelect_SelectLevelNumber {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectLevelNumber_2 extends Handle_IGESSelect_SelectLevelNumber {
    constructor(thePtr: IGESSelect_SelectLevelNumber);
  }

  export declare class Handle_IGESSelect_SelectLevelNumber_3 extends Handle_IGESSelect_SelectLevelNumber {
    constructor(theHandle: Handle_IGESSelect_SelectLevelNumber);
  }

  export declare class Handle_IGESSelect_SelectLevelNumber_4 extends Handle_IGESSelect_SelectLevelNumber {
    constructor(theHandle: Handle_IGESSelect_SelectLevelNumber);
  }

export declare class IGESSelect_ChangeLevelList extends IGESSelect_ModelModifier {
  constructor()
  HasOldNumber(): Standard_Boolean;
  OldNumber(): Handle_IFSelect_IntParam;
  SetOldNumber(param: Handle_IFSelect_IntParam): void;
  HasNewNumber(): Standard_Boolean;
  NewNumber(): Handle_IFSelect_IntParam;
  SetNewNumber(param: Handle_IFSelect_IntParam): void;
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_ChangeLevelList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_ChangeLevelList): void;
  get(): IGESSelect_ChangeLevelList;
  delete(): void;
}

  export declare class Handle_IGESSelect_ChangeLevelList_1 extends Handle_IGESSelect_ChangeLevelList {
    constructor();
  }

  export declare class Handle_IGESSelect_ChangeLevelList_2 extends Handle_IGESSelect_ChangeLevelList {
    constructor(thePtr: IGESSelect_ChangeLevelList);
  }

  export declare class Handle_IGESSelect_ChangeLevelList_3 extends Handle_IGESSelect_ChangeLevelList {
    constructor(theHandle: Handle_IGESSelect_ChangeLevelList);
  }

  export declare class Handle_IGESSelect_ChangeLevelList_4 extends Handle_IGESSelect_ChangeLevelList {
    constructor(theHandle: Handle_IGESSelect_ChangeLevelList);
  }

export declare class IGESSelect_SelectPCurves extends IFSelect_SelectExplore {
  constructor(basic: Standard_Boolean)
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectPCurves {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectPCurves): void;
  get(): IGESSelect_SelectPCurves;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectPCurves_1 extends Handle_IGESSelect_SelectPCurves {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectPCurves_2 extends Handle_IGESSelect_SelectPCurves {
    constructor(thePtr: IGESSelect_SelectPCurves);
  }

  export declare class Handle_IGESSelect_SelectPCurves_3 extends Handle_IGESSelect_SelectPCurves {
    constructor(theHandle: Handle_IGESSelect_SelectPCurves);
  }

  export declare class Handle_IGESSelect_SelectPCurves_4 extends Handle_IGESSelect_SelectPCurves {
    constructor(theHandle: Handle_IGESSelect_SelectPCurves);
  }

export declare class Handle_IGESSelect_FileModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_FileModifier): void;
  get(): IGESSelect_FileModifier;
  delete(): void;
}

  export declare class Handle_IGESSelect_FileModifier_1 extends Handle_IGESSelect_FileModifier {
    constructor();
  }

  export declare class Handle_IGESSelect_FileModifier_2 extends Handle_IGESSelect_FileModifier {
    constructor(thePtr: IGESSelect_FileModifier);
  }

  export declare class Handle_IGESSelect_FileModifier_3 extends Handle_IGESSelect_FileModifier {
    constructor(theHandle: Handle_IGESSelect_FileModifier);
  }

  export declare class Handle_IGESSelect_FileModifier_4 extends Handle_IGESSelect_FileModifier {
    constructor(theHandle: Handle_IGESSelect_FileModifier);
  }

export declare class IGESSelect_FileModifier extends IFSelect_GeneralModifier {
  Perform(ctx: IFSelect_ContextWrite, writer: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_RebuildDrawings {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_RebuildDrawings): void;
  get(): IGESSelect_RebuildDrawings;
  delete(): void;
}

  export declare class Handle_IGESSelect_RebuildDrawings_1 extends Handle_IGESSelect_RebuildDrawings {
    constructor();
  }

  export declare class Handle_IGESSelect_RebuildDrawings_2 extends Handle_IGESSelect_RebuildDrawings {
    constructor(thePtr: IGESSelect_RebuildDrawings);
  }

  export declare class Handle_IGESSelect_RebuildDrawings_3 extends Handle_IGESSelect_RebuildDrawings {
    constructor(theHandle: Handle_IGESSelect_RebuildDrawings);
  }

  export declare class Handle_IGESSelect_RebuildDrawings_4 extends Handle_IGESSelect_RebuildDrawings {
    constructor(theHandle: Handle_IGESSelect_RebuildDrawings);
  }

export declare class IGESSelect_RebuildDrawings extends IGESSelect_ModelModifier {
  constructor()
  Performing(ctx: IFSelect_ContextModif, target: Handle_IGESData_IGESModel, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_EditDirPart {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_EditDirPart): void;
  get(): IGESSelect_EditDirPart;
  delete(): void;
}

  export declare class Handle_IGESSelect_EditDirPart_1 extends Handle_IGESSelect_EditDirPart {
    constructor();
  }

  export declare class Handle_IGESSelect_EditDirPart_2 extends Handle_IGESSelect_EditDirPart {
    constructor(thePtr: IGESSelect_EditDirPart);
  }

  export declare class Handle_IGESSelect_EditDirPart_3 extends Handle_IGESSelect_EditDirPart {
    constructor(theHandle: Handle_IGESSelect_EditDirPart);
  }

  export declare class Handle_IGESSelect_EditDirPart_4 extends Handle_IGESSelect_EditDirPart {
    constructor(theHandle: Handle_IGESSelect_EditDirPart);
  }

export declare class IGESSelect_EditDirPart extends IFSelect_Editor {
  constructor()
  Label(): XCAFDoc_PartId;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Update(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId, newval: Handle_TCollection_HAsciiString, enforce: Standard_Boolean): Standard_Boolean;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSelect_SelectSubordinate extends IFSelect_SelectExtract {
  constructor(status: Graphic3d_ZLayerId)
  Status(): Graphic3d_ZLayerId;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSelect_SelectSubordinate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSelect_SelectSubordinate): void;
  get(): IGESSelect_SelectSubordinate;
  delete(): void;
}

  export declare class Handle_IGESSelect_SelectSubordinate_1 extends Handle_IGESSelect_SelectSubordinate {
    constructor();
  }

  export declare class Handle_IGESSelect_SelectSubordinate_2 extends Handle_IGESSelect_SelectSubordinate {
    constructor(thePtr: IGESSelect_SelectSubordinate);
  }

  export declare class Handle_IGESSelect_SelectSubordinate_3 extends Handle_IGESSelect_SelectSubordinate {
    constructor(theHandle: Handle_IGESSelect_SelectSubordinate);
  }

  export declare class Handle_IGESSelect_SelectSubordinate_4 extends Handle_IGESSelect_SelectSubordinate {
    constructor(theHandle: Handle_IGESSelect_SelectSubordinate);
  }

export declare class IntCurve_PConic {
  SetEpsX(EpsDist: Quantity_AbsorbedDose): void;
  SetAccuracy(Nb: Graphic3d_ZLayerId): void;
  Accuracy(): Graphic3d_ZLayerId;
  EpsX(): Quantity_AbsorbedDose;
  TypeCurve(): GeomAbs_CurveType;
  Axis2(): gp_Ax22d;
  Param1(): Quantity_AbsorbedDose;
  Param2(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntCurve_PConic_1 extends IntCurve_PConic {
    constructor(PC: IntCurve_PConic);
  }

  export declare class IntCurve_PConic_2 extends IntCurve_PConic {
    constructor(E: gp_Elips2d);
  }

  export declare class IntCurve_PConic_3 extends IntCurve_PConic {
    constructor(C: gp_Circ2d);
  }

  export declare class IntCurve_PConic_4 extends IntCurve_PConic {
    constructor(P: gp_Parab2d);
  }

  export declare class IntCurve_PConic_5 extends IntCurve_PConic {
    constructor(H: gp_Hypr2d);
  }

  export declare class IntCurve_PConic_6 extends IntCurve_PConic {
    constructor(L: gp_Lin2d);
  }

export declare class IntCurve_ProjectOnPConicTool {
  constructor();
  static FindParameter_1(C: IntCurve_PConic, Pnt: gp_Pnt2d, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static FindParameter_2(C: IntCurve_PConic, Pnt: gp_Pnt2d, LowParameter: Quantity_AbsorbedDose, HighParameter: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class IntCurve_IConicTool {
  Value(X: Quantity_AbsorbedDose): gp_Pnt2d;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d, N: gp_Vec2d): void;
  Distance(P: gp_Pnt2d): Quantity_AbsorbedDose;
  GradDistance(P: gp_Pnt2d): gp_Vec2d;
  FindParameter(P: gp_Pnt2d): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntCurve_IConicTool_1 extends IntCurve_IConicTool {
    constructor();
  }

  export declare class IntCurve_IConicTool_2 extends IntCurve_IConicTool {
    constructor(IT: IntCurve_IConicTool);
  }

  export declare class IntCurve_IConicTool_3 extends IntCurve_IConicTool {
    constructor(E: gp_Elips2d);
  }

  export declare class IntCurve_IConicTool_4 extends IntCurve_IConicTool {
    constructor(L: gp_Lin2d);
  }

  export declare class IntCurve_IConicTool_5 extends IntCurve_IConicTool {
    constructor(C: gp_Circ2d);
  }

  export declare class IntCurve_IConicTool_6 extends IntCurve_IConicTool {
    constructor(P: gp_Parab2d);
  }

  export declare class IntCurve_IConicTool_7 extends IntCurve_IConicTool {
    constructor(H: gp_Hypr2d);
  }

export declare class IntCurve_IntConicConic extends IntRes2d_Intersection {
  Perform_1(L1: gp_Lin2d, D1: IntRes2d_Domain, L2: gp_Lin2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(L: gp_Lin2d, DL: IntRes2d_Domain, C: gp_Circ2d, DC: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(L: gp_Lin2d, DL: IntRes2d_Domain, E: gp_Elips2d, DE: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(L: gp_Lin2d, DL: IntRes2d_Domain, P: gp_Parab2d, DP: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(L: gp_Lin2d, DL: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_6(C1: gp_Circ2d, D1: IntRes2d_Domain, C2: gp_Circ2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_7(C: gp_Circ2d, DC: IntRes2d_Domain, E: gp_Elips2d, DE: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_8(C: gp_Circ2d, DC: IntRes2d_Domain, P: gp_Parab2d, DP: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_9(C: gp_Circ2d, DC: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_10(E1: gp_Elips2d, D1: IntRes2d_Domain, E2: gp_Elips2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_11(E: gp_Elips2d, DE: IntRes2d_Domain, P: gp_Parab2d, DP: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_12(E: gp_Elips2d, DE: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_13(P1: gp_Parab2d, D1: IntRes2d_Domain, P2: gp_Parab2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_14(P: gp_Parab2d, DP: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_15(H1: gp_Hypr2d, D1: IntRes2d_Domain, H2: gp_Hypr2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntCurve_IntConicConic_1 extends IntCurve_IntConicConic {
    constructor();
  }

  export declare class IntCurve_IntConicConic_2 extends IntCurve_IntConicConic {
    constructor(L1: gp_Lin2d, D1: IntRes2d_Domain, L2: gp_Lin2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_3 extends IntCurve_IntConicConic {
    constructor(L: gp_Lin2d, DL: IntRes2d_Domain, C: gp_Circ2d, DC: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_4 extends IntCurve_IntConicConic {
    constructor(L: gp_Lin2d, DL: IntRes2d_Domain, E: gp_Elips2d, DE: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_5 extends IntCurve_IntConicConic {
    constructor(L: gp_Lin2d, DL: IntRes2d_Domain, P: gp_Parab2d, DP: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_6 extends IntCurve_IntConicConic {
    constructor(L: gp_Lin2d, DL: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_7 extends IntCurve_IntConicConic {
    constructor(C1: gp_Circ2d, D1: IntRes2d_Domain, C2: gp_Circ2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_8 extends IntCurve_IntConicConic {
    constructor(C: gp_Circ2d, DC: IntRes2d_Domain, E: gp_Elips2d, DE: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_9 extends IntCurve_IntConicConic {
    constructor(C: gp_Circ2d, DC: IntRes2d_Domain, P: gp_Parab2d, DP: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_10 extends IntCurve_IntConicConic {
    constructor(C: gp_Circ2d, DC: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_11 extends IntCurve_IntConicConic {
    constructor(E1: gp_Elips2d, D1: IntRes2d_Domain, E2: gp_Elips2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_12 extends IntCurve_IntConicConic {
    constructor(E: gp_Elips2d, DE: IntRes2d_Domain, P: gp_Parab2d, DP: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_13 extends IntCurve_IntConicConic {
    constructor(E: gp_Elips2d, DE: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_14 extends IntCurve_IntConicConic {
    constructor(P1: gp_Parab2d, D1: IntRes2d_Domain, P2: gp_Parab2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_15 extends IntCurve_IntConicConic {
    constructor(P: gp_Parab2d, DP: IntRes2d_Domain, H: gp_Hypr2d, DH: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntCurve_IntConicConic_16 extends IntCurve_IntConicConic {
    constructor(H1: gp_Hypr2d, D1: IntRes2d_Domain, H2: gp_Hypr2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class IntCurve_IntImpConicParConic extends IntRes2d_Intersection {
  Perform(ITool: IntCurve_IConicTool, Dom1: IntRes2d_Domain, PCurve: IntCurve_PConic, Dom2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  FindU(parameter: Quantity_AbsorbedDose, point: gp_Pnt2d, TheParCurev: IntCurve_PConic, TheImpTool: IntCurve_IConicTool): Quantity_AbsorbedDose;
  FindV(parameter: Quantity_AbsorbedDose, point: gp_Pnt2d, TheImpTool: IntCurve_IConicTool, ParCurve: IntCurve_PConic, TheParCurveDomain: IntRes2d_Domain, V0: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  And_Domaine_Objet1_Intersections(TheImpTool: IntCurve_IConicTool, TheParCurve: IntCurve_PConic, TheImpCurveDomain: IntRes2d_Domain, TheParCurveDomain: IntRes2d_Domain, NbResultats: Graphic3d_ZLayerId, Inter2_And_Domain2: TColStd_Array1OfReal, Inter1: TColStd_Array1OfReal, Resultat1: TColStd_Array1OfReal, Resultat2: TColStd_Array1OfReal, EpsNul: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntCurve_IntImpConicParConic_1 extends IntCurve_IntImpConicParConic {
    constructor();
  }

  export declare class IntCurve_IntImpConicParConic_2 extends IntCurve_IntImpConicParConic {
    constructor(ITool: IntCurve_IConicTool, Dom1: IntRes2d_Domain, PCurve: IntCurve_PConic, Dom2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class PeriodicInterval {
  SetNull(): void;
  IsNull(): Standard_Boolean;
  Complement(): void;
  Length(): Quantity_AbsorbedDose;
  SetValues(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose): void;
  Normalize(): void;
  FirstIntersection(I1: PeriodicInterval): PeriodicInterval;
  SecondIntersection(I2: PeriodicInterval): PeriodicInterval;
  delete(): void;
}

  export declare class PeriodicInterval_1 extends PeriodicInterval {
    constructor(Domain: IntRes2d_Domain);
  }

  export declare class PeriodicInterval_2 extends PeriodicInterval {
    constructor();
  }

  export declare class PeriodicInterval_3 extends PeriodicInterval {
    constructor(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose);
  }

export declare class Interval {
  Length(): Quantity_AbsorbedDose;
  IntersectionWithBounded(Inter: Interval): Interval;
  delete(): void;
}

  export declare class Interval_1 extends Interval {
    constructor();
  }

  export declare class Interval_2 extends Interval {
    constructor(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose);
  }

  export declare class Interval_3 extends Interval {
    constructor(Domain: IntRes2d_Domain);
  }

  export declare class Interval_4 extends Interval {
    constructor(a: Quantity_AbsorbedDose, hf: Standard_Boolean, b: Quantity_AbsorbedDose, hl: Standard_Boolean);
  }

export declare class IntCurve_PConicTool {
  constructor();
  static EpsX(C: IntCurve_PConic): Quantity_AbsorbedDose;
  static NbSamples_1(C: IntCurve_PConic): Graphic3d_ZLayerId;
  static NbSamples_2(C: IntCurve_PConic, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static Value(C: IntCurve_PConic, X: Quantity_AbsorbedDose): gp_Pnt2d;
  static D1(C: IntCurve_PConic, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d): void;
  static D2(C: IntCurve_PConic, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d, N: gp_Vec2d): void;
  delete(): void;
}

export declare class IntCurve_MyImpParToolOfIntImpConicParConic extends math_FunctionWithDerivative {
  constructor(IT: IntCurve_IConicTool, PC: IntCurve_PConic)
  Value(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(Param: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepPrim_Wedge extends BRepPrim_GWedge {
  delete(): void;
}

  export declare class BRepPrim_Wedge_1 extends BRepPrim_Wedge {
    constructor();
  }

  export declare class BRepPrim_Wedge_2 extends BRepPrim_Wedge {
    constructor(Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Wedge_3 extends BRepPrim_Wedge {
    constructor(Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose, ltx: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Wedge_4 extends BRepPrim_Wedge {
    constructor(Axes: gp_Ax2, xmin: Quantity_AbsorbedDose, ymin: Quantity_AbsorbedDose, zmin: Quantity_AbsorbedDose, z2min: Quantity_AbsorbedDose, x2min: Quantity_AbsorbedDose, xmax: Quantity_AbsorbedDose, ymax: Quantity_AbsorbedDose, zmax: Quantity_AbsorbedDose, z2max: Quantity_AbsorbedDose, x2max: Quantity_AbsorbedDose);
  }

export declare class BRepPrim_FaceBuilder {
  Init_1(B: BRep_Builder, S: Handle_Geom_Surface): void;
  Init_2(B: BRep_Builder, S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose): void;
  Face(): TopoDS_Face;
  Edge(I: Graphic3d_ZLayerId): TopoDS_Edge;
  Vertex(I: Graphic3d_ZLayerId): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepPrim_FaceBuilder_1 extends BRepPrim_FaceBuilder {
    constructor();
  }

  export declare class BRepPrim_FaceBuilder_2 extends BRepPrim_FaceBuilder {
    constructor(B: BRep_Builder, S: Handle_Geom_Surface);
  }

  export declare class BRepPrim_FaceBuilder_3 extends BRepPrim_FaceBuilder {
    constructor(B: BRep_Builder, S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

export declare class BRepPrim_Sphere extends BRepPrim_Revolution {
  MakeEmptyLateralFace(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepPrim_Sphere_1 extends BRepPrim_Sphere {
    constructor(Radius: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Sphere_2 extends BRepPrim_Sphere {
    constructor(Center: gp_Pnt, Radius: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Sphere_3 extends BRepPrim_Sphere {
    constructor(Axes: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

export declare type BRepPrim_Direction = {
  BRepPrim_XMin: {};
  BRepPrim_XMax: {};
  BRepPrim_YMin: {};
  BRepPrim_YMax: {};
  BRepPrim_ZMin: {};
  BRepPrim_ZMax: {};
}

export declare class BRepPrim_OneAxis {
  SetMeridianOffset(MeridianOffset: Quantity_AbsorbedDose): void;
  Axes_1(): gp_Ax2;
  Axes_2(A: gp_Ax2): void;
  Angle_1(): Quantity_AbsorbedDose;
  Angle_2(A: Quantity_AbsorbedDose): void;
  VMin_1(): Quantity_AbsorbedDose;
  VMin_2(V: Quantity_AbsorbedDose): void;
  VMax_1(): Quantity_AbsorbedDose;
  VMax_2(V: Quantity_AbsorbedDose): void;
  MakeEmptyLateralFace(): TopoDS_Face;
  MakeEmptyMeridianEdge(Ang: Quantity_AbsorbedDose): TopoDS_Edge;
  SetMeridianPCurve(E: TopoDS_Edge, F: TopoDS_Face): void;
  MeridianValue(V: Quantity_AbsorbedDose): gp_Pnt2d;
  MeridianOnAxis(V: Quantity_AbsorbedDose): Standard_Boolean;
  MeridianClosed(): Standard_Boolean;
  VMaxInfinite(): Standard_Boolean;
  VMinInfinite(): Standard_Boolean;
  HasTop(): Standard_Boolean;
  HasBottom(): Standard_Boolean;
  HasSides(): Standard_Boolean;
  Shell(): TopoDS_Shell;
  LateralFace(): TopoDS_Face;
  TopFace(): TopoDS_Face;
  BottomFace(): TopoDS_Face;
  StartFace(): TopoDS_Face;
  EndFace(): TopoDS_Face;
  LateralWire(): TopoDS_Wire;
  LateralStartWire(): TopoDS_Wire;
  LateralEndWire(): TopoDS_Wire;
  TopWire(): TopoDS_Wire;
  BottomWire(): TopoDS_Wire;
  StartWire(): TopoDS_Wire;
  AxisStartWire(): TopoDS_Wire;
  EndWire(): TopoDS_Wire;
  AxisEndWire(): TopoDS_Wire;
  AxisEdge(): TopoDS_Edge;
  StartEdge(): TopoDS_Edge;
  EndEdge(): TopoDS_Edge;
  StartTopEdge(): TopoDS_Edge;
  StartBottomEdge(): TopoDS_Edge;
  EndTopEdge(): TopoDS_Edge;
  EndBottomEdge(): TopoDS_Edge;
  TopEdge(): TopoDS_Edge;
  BottomEdge(): TopoDS_Edge;
  AxisTopVertex(): TopoDS_Vertex;
  AxisBottomVertex(): TopoDS_Vertex;
  TopStartVertex(): TopoDS_Vertex;
  TopEndVertex(): TopoDS_Vertex;
  BottomStartVertex(): TopoDS_Vertex;
  BottomEndVertex(): TopoDS_Vertex;
  delete(): void;
}

export declare class BRepPrim_Builder {
  Builder(): BRep_Builder;
  MakeShell(S: TopoDS_Shell): void;
  MakeFace(F: TopoDS_Face, P: gp_Pln): void;
  MakeWire(W: TopoDS_Wire): void;
  MakeDegeneratedEdge(E: TopoDS_Edge): void;
  MakeEdge_1(E: TopoDS_Edge, L: gp_Lin): void;
  MakeEdge_2(E: TopoDS_Edge, C: gp_Circ): void;
  SetPCurve_1(E: TopoDS_Edge, F: TopoDS_Face, L: gp_Lin2d): void;
  SetPCurve_2(E: TopoDS_Edge, F: TopoDS_Face, L1: gp_Lin2d, L2: gp_Lin2d): void;
  SetPCurve_3(E: TopoDS_Edge, F: TopoDS_Face, C: gp_Circ2d): void;
  MakeVertex(V: TopoDS_Vertex, P: gp_Pnt): void;
  ReverseFace(F: TopoDS_Face): void;
  AddEdgeVertex_1(E: TopoDS_Edge, V: TopoDS_Vertex, P: Quantity_AbsorbedDose, direct: Standard_Boolean): void;
  AddEdgeVertex_2(E: TopoDS_Edge, V: TopoDS_Vertex, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose): void;
  SetParameters(E: TopoDS_Edge, V: TopoDS_Vertex, P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose): void;
  AddWireEdge(W: TopoDS_Wire, E: TopoDS_Edge, direct: Standard_Boolean): void;
  AddFaceWire(F: TopoDS_Face, W: TopoDS_Wire): void;
  AddShellFace(Sh: TopoDS_Shell, F: TopoDS_Face): void;
  CompleteEdge(E: TopoDS_Edge): void;
  CompleteWire(W: TopoDS_Wire): void;
  CompleteFace(F: TopoDS_Face): void;
  CompleteShell(S: TopoDS_Shell): void;
  delete(): void;
}

  export declare class BRepPrim_Builder_1 extends BRepPrim_Builder {
    constructor();
  }

  export declare class BRepPrim_Builder_2 extends BRepPrim_Builder {
    constructor(B: BRep_Builder);
  }

export declare class BRepPrim_Revolution extends BRepPrim_OneAxis {
  constructor(A: gp_Ax2, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, M: Handle_Geom_Curve, PM: Handle_Geom2d_Curve)
  MakeEmptyLateralFace(): TopoDS_Face;
  MakeEmptyMeridianEdge(Ang: Quantity_AbsorbedDose): TopoDS_Edge;
  MeridianValue(V: Quantity_AbsorbedDose): gp_Pnt2d;
  SetMeridianPCurve(E: TopoDS_Edge, F: TopoDS_Face): void;
  delete(): void;
}

export declare class BRepPrim_Cone extends BRepPrim_Revolution {
  MakeEmptyLateralFace(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepPrim_Cone_1 extends BRepPrim_Cone {
    constructor(Angle: Quantity_AbsorbedDose, Position: gp_Ax2, Height: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cone_2 extends BRepPrim_Cone {
    constructor(Angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cone_3 extends BRepPrim_Cone {
    constructor(Angle: Quantity_AbsorbedDose, Apex: gp_Pnt);
  }

  export declare class BRepPrim_Cone_4 extends BRepPrim_Cone {
    constructor(Angle: Quantity_AbsorbedDose, Axes: gp_Ax2);
  }

  export declare class BRepPrim_Cone_5 extends BRepPrim_Cone {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cone_6 extends BRepPrim_Cone {
    constructor(Center: gp_Pnt, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cone_7 extends BRepPrim_Cone {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

export declare class BRepPrim_Cylinder extends BRepPrim_Revolution {
  MakeEmptyLateralFace(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepPrim_Cylinder_1 extends BRepPrim_Cylinder {
    constructor(Position: gp_Ax2, Radius: Quantity_AbsorbedDose, Height: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cylinder_2 extends BRepPrim_Cylinder {
    constructor(Radius: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cylinder_3 extends BRepPrim_Cylinder {
    constructor(Center: gp_Pnt, Radius: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cylinder_4 extends BRepPrim_Cylinder {
    constructor(Axes: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cylinder_5 extends BRepPrim_Cylinder {
    constructor(R: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Cylinder_6 extends BRepPrim_Cylinder {
    constructor(Center: gp_Pnt, R: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

export declare class BRepPrim_GWedge {
  Axes(): gp_Ax2;
  GetXMin(): Quantity_AbsorbedDose;
  GetYMin(): Quantity_AbsorbedDose;
  GetZMin(): Quantity_AbsorbedDose;
  GetZ2Min(): Quantity_AbsorbedDose;
  GetX2Min(): Quantity_AbsorbedDose;
  GetXMax(): Quantity_AbsorbedDose;
  GetYMax(): Quantity_AbsorbedDose;
  GetZMax(): Quantity_AbsorbedDose;
  GetZ2Max(): Quantity_AbsorbedDose;
  GetX2Max(): Quantity_AbsorbedDose;
  Open(d1: BRepPrim_Direction): void;
  Close(d1: BRepPrim_Direction): void;
  IsInfinite(d1: BRepPrim_Direction): Standard_Boolean;
  Shell(): TopoDS_Shell;
  HasFace(d1: BRepPrim_Direction): Standard_Boolean;
  Face(d1: BRepPrim_Direction): TopoDS_Face;
  Plane(d1: BRepPrim_Direction): gp_Pln;
  HasWire(d1: BRepPrim_Direction): Standard_Boolean;
  Wire(d1: BRepPrim_Direction): TopoDS_Wire;
  HasEdge(d1: BRepPrim_Direction, d2: BRepPrim_Direction): Standard_Boolean;
  Edge(d1: BRepPrim_Direction, d2: BRepPrim_Direction): TopoDS_Edge;
  Line(d1: BRepPrim_Direction, d2: BRepPrim_Direction): gp_Lin;
  HasVertex(d1: BRepPrim_Direction, d2: BRepPrim_Direction, d3: BRepPrim_Direction): Standard_Boolean;
  Vertex(d1: BRepPrim_Direction, d2: BRepPrim_Direction, d3: BRepPrim_Direction): TopoDS_Vertex;
  Point(d1: BRepPrim_Direction, d2: BRepPrim_Direction, d3: BRepPrim_Direction): gp_Pnt;
  IsDegeneratedShape(): Standard_Boolean;
  delete(): void;
}

  export declare class BRepPrim_GWedge_1 extends BRepPrim_GWedge {
    constructor();
  }

  export declare class BRepPrim_GWedge_2 extends BRepPrim_GWedge {
    constructor(B: BRepPrim_Builder, Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_GWedge_3 extends BRepPrim_GWedge {
    constructor(B: BRepPrim_Builder, Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose, ltx: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_GWedge_4 extends BRepPrim_GWedge {
    constructor(B: BRepPrim_Builder, Axes: gp_Ax2, xmin: Quantity_AbsorbedDose, ymin: Quantity_AbsorbedDose, zmin: Quantity_AbsorbedDose, z2min: Quantity_AbsorbedDose, x2min: Quantity_AbsorbedDose, xmax: Quantity_AbsorbedDose, ymax: Quantity_AbsorbedDose, zmax: Quantity_AbsorbedDose, z2max: Quantity_AbsorbedDose, x2max: Quantity_AbsorbedDose);
  }

export declare class BRepPrim_Torus extends BRepPrim_Revolution {
  MakeEmptyLateralFace(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepPrim_Torus_1 extends BRepPrim_Torus {
    constructor(Position: gp_Ax2, Major: Quantity_AbsorbedDose, Minor: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Torus_2 extends BRepPrim_Torus {
    constructor(Major: Quantity_AbsorbedDose, Minor: Quantity_AbsorbedDose);
  }

  export declare class BRepPrim_Torus_3 extends BRepPrim_Torus {
    constructor(Center: gp_Pnt, Major: Quantity_AbsorbedDose, Minor: Quantity_AbsorbedDose);
  }

export declare class IntWalk_PWalking {
  Perform_1(ParDep: TColStd_Array1OfReal): void;
  Perform_2(ParDep: TColStd_Array1OfReal, u1min: Quantity_AbsorbedDose, v1min: Quantity_AbsorbedDose, u2min: Quantity_AbsorbedDose, v2min: Quantity_AbsorbedDose, u1max: Quantity_AbsorbedDose, v1max: Quantity_AbsorbedDose, u2max: Quantity_AbsorbedDose, v2max: Quantity_AbsorbedDose): void;
  PerformFirstPoint(ParDep: TColStd_Array1OfReal, FirstPoint: IntSurf_PntOn2S): Standard_Boolean;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  Line(): Handle_IntSurf_LineOn2S;
  TangentAtFirst(): Standard_Boolean;
  TangentAtLast(): Standard_Boolean;
  IsClosed(): Standard_Boolean;
  TangentAtLine(Index: Graphic3d_ZLayerId): gp_Dir;
  TestDeflection(ChoixIso: IntImp_ConstIsoparametric, theStatus: IntWalk_StatusDeflection): IntWalk_StatusDeflection;
  TestArret(DejaReparti: Standard_Boolean, Param: TColStd_Array1OfReal, ChoixIso: IntImp_ConstIsoparametric): Standard_Boolean;
  RepartirOuDiviser(DejaReparti: Standard_Boolean, ChoixIso: IntImp_ConstIsoparametric, Arrive: Standard_Boolean): void;
  AddAPoint(thePOn2S: IntSurf_PntOn2S): void;
  RemoveAPoint(theIndex: Graphic3d_ZLayerId): void;
  PutToBoundary(theASurf1: Handle_Adaptor3d_HSurface, theASurf2: Handle_Adaptor3d_HSurface): Standard_Boolean;
  SeekAdditionalPoints(theASurf1: Handle_Adaptor3d_HSurface, theASurf2: Handle_Adaptor3d_HSurface, theMinNbPoints: Graphic3d_ZLayerId): Standard_Boolean;
  MaxStep(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntWalk_PWalking_1 extends IntWalk_PWalking {
    constructor(Caro1: Handle_Adaptor3d_HSurface, Caro2: Handle_Adaptor3d_HSurface, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose);
  }

  export declare class IntWalk_PWalking_2 extends IntWalk_PWalking {
    constructor(Caro1: Handle_Adaptor3d_HSurface, Caro2: Handle_Adaptor3d_HSurface, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

export declare class IntWalk_TheFunctionOfTheInt2S extends math_FunctionSetWithDerivatives {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  ComputeParameters(ChoixIso: IntImp_ConstIsoparametric, Param: TColStd_Array1OfReal, UVap: math_Vector, BornInf: math_Vector, BornSup: math_Vector, Tolerance: math_Vector): void;
  Root(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(UVap: math_Vector, Param: TColStd_Array1OfReal, BestChoix: IntImp_ConstIsoparametric): Standard_Boolean;
  Direction(): gp_Dir;
  DirectionOnS1(): gp_Dir2d;
  DirectionOnS2(): gp_Dir2d;
  AuxillarSurface1(): Handle_Adaptor3d_HSurface;
  AuxillarSurface2(): Handle_Adaptor3d_HSurface;
  delete(): void;
}

export declare type IntWalk_StatusDeflection = {
  IntWalk_PasTropGrand: {};
  IntWalk_StepTooSmall: {};
  IntWalk_PointConfondu: {};
  IntWalk_ArretSurPointPrecedent: {};
  IntWalk_ArretSurPoint: {};
  IntWalk_OK: {};
}

export declare class IntWalk_WalkingData {
  constructor();
  delete(): void;
}

export declare class IntWalk_TheInt2S {
  Perform_1(Param: TColStd_Array1OfReal, Rsnld: math_FunctionSetRoot): IntImp_ConstIsoparametric;
  Perform_2(Param: TColStd_Array1OfReal, Rsnld: math_FunctionSetRoot, ChoixIso: IntImp_ConstIsoparametric): IntImp_ConstIsoparametric;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Point(): IntSurf_PntOn2S;
  IsTangent(): Standard_Boolean;
  Direction(): gp_Dir;
  DirectionOnS1(): gp_Dir2d;
  DirectionOnS2(): gp_Dir2d;
  Function(): IntWalk_TheFunctionOfTheInt2S;
  ChangePoint(): IntSurf_PntOn2S;
  delete(): void;
}

  export declare class IntWalk_TheInt2S_1 extends IntWalk_TheInt2S {
    constructor(Param: TColStd_Array1OfReal, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, TolTangency: Quantity_AbsorbedDose);
  }

  export declare class IntWalk_TheInt2S_2 extends IntWalk_TheInt2S {
    constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, TolTangency: Quantity_AbsorbedDose);
  }

export declare class Message_HArrayOfMsg {
  get_1(): Message_ArrayOfMsg;
  get_2(): Message_ArrayOfMsg;
  static DownCast(theOther: Handle_Standard_Transient): Message_HArrayOfMsg;
  delete(): void;
}

  export declare class Message_HArrayOfMsg_2 extends Message_HArrayOfMsg {
    constructor();
  }

  export declare class Message_HArrayOfMsg_3 extends Message_HArrayOfMsg {
    constructor(theObject: Message_ArrayOfMsg);
  }

export declare class Message_PrinterOStream extends Message_Printer {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static SetConsoleTextColor(theOStream: Standard_OStream, theTextColor: Message_ConsoleColor, theIsIntenseText: Standard_Boolean): void;
  Close(): void;
  ToColorize(): Standard_Boolean;
  SetToColorize(theToColorize: Standard_Boolean): void;
  delete(): void;
}

  export declare class Message_PrinterOStream_1 extends Message_PrinterOStream {
    constructor(theTraceLevel: Message_Gravity);
  }

  export declare class Message_PrinterOStream_2 extends Message_PrinterOStream {
    constructor(theFileName: Standard_CString, theDoAppend: Standard_Boolean, theTraceLevel: Message_Gravity);
  }

export declare class Handle_Message_PrinterOStream {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_PrinterOStream): void;
  get(): Message_PrinterOStream;
  delete(): void;
}

  export declare class Handle_Message_PrinterOStream_1 extends Handle_Message_PrinterOStream {
    constructor();
  }

  export declare class Handle_Message_PrinterOStream_2 extends Handle_Message_PrinterOStream {
    constructor(thePtr: Message_PrinterOStream);
  }

  export declare class Handle_Message_PrinterOStream_3 extends Handle_Message_PrinterOStream {
    constructor(theHandle: Handle_Message_PrinterOStream);
  }

  export declare class Handle_Message_PrinterOStream_4 extends Handle_Message_PrinterOStream {
    constructor(theHandle: Handle_Message_PrinterOStream);
  }

export declare class Message_ProgressRange {
  UserBreak(): Standard_Boolean;
  More(): Standard_Boolean;
  IsActive(): Standard_Boolean;
  Close(): void;
  delete(): void;
}

  export declare class Message_ProgressRange_1 extends Message_ProgressRange {
    constructor();
  }

  export declare class Message_ProgressRange_2 extends Message_ProgressRange {
    constructor(theOther: Message_ProgressRange);
  }

export declare type Message_Status = {
  Message_None: {};
  Message_Done1: {};
  Message_Done2: {};
  Message_Done3: {};
  Message_Done4: {};
  Message_Done5: {};
  Message_Done6: {};
  Message_Done7: {};
  Message_Done8: {};
  Message_Done9: {};
  Message_Done10: {};
  Message_Done11: {};
  Message_Done12: {};
  Message_Done13: {};
  Message_Done14: {};
  Message_Done15: {};
  Message_Done16: {};
  Message_Done17: {};
  Message_Done18: {};
  Message_Done19: {};
  Message_Done20: {};
  Message_Done21: {};
  Message_Done22: {};
  Message_Done23: {};
  Message_Done24: {};
  Message_Done25: {};
  Message_Done26: {};
  Message_Done27: {};
  Message_Done28: {};
  Message_Done29: {};
  Message_Done30: {};
  Message_Done31: {};
  Message_Done32: {};
  Message_Warn1: {};
  Message_Warn2: {};
  Message_Warn3: {};
  Message_Warn4: {};
  Message_Warn5: {};
  Message_Warn6: {};
  Message_Warn7: {};
  Message_Warn8: {};
  Message_Warn9: {};
  Message_Warn10: {};
  Message_Warn11: {};
  Message_Warn12: {};
  Message_Warn13: {};
  Message_Warn14: {};
  Message_Warn15: {};
  Message_Warn16: {};
  Message_Warn17: {};
  Message_Warn18: {};
  Message_Warn19: {};
  Message_Warn20: {};
  Message_Warn21: {};
  Message_Warn22: {};
  Message_Warn23: {};
  Message_Warn24: {};
  Message_Warn25: {};
  Message_Warn26: {};
  Message_Warn27: {};
  Message_Warn28: {};
  Message_Warn29: {};
  Message_Warn30: {};
  Message_Warn31: {};
  Message_Warn32: {};
  Message_Alarm1: {};
  Message_Alarm2: {};
  Message_Alarm3: {};
  Message_Alarm4: {};
  Message_Alarm5: {};
  Message_Alarm6: {};
  Message_Alarm7: {};
  Message_Alarm8: {};
  Message_Alarm9: {};
  Message_Alarm10: {};
  Message_Alarm11: {};
  Message_Alarm12: {};
  Message_Alarm13: {};
  Message_Alarm14: {};
  Message_Alarm15: {};
  Message_Alarm16: {};
  Message_Alarm17: {};
  Message_Alarm18: {};
  Message_Alarm19: {};
  Message_Alarm20: {};
  Message_Alarm21: {};
  Message_Alarm22: {};
  Message_Alarm23: {};
  Message_Alarm24: {};
  Message_Alarm25: {};
  Message_Alarm26: {};
  Message_Alarm27: {};
  Message_Alarm28: {};
  Message_Alarm29: {};
  Message_Alarm30: {};
  Message_Alarm31: {};
  Message_Alarm32: {};
  Message_Fail1: {};
  Message_Fail2: {};
  Message_Fail3: {};
  Message_Fail4: {};
  Message_Fail5: {};
  Message_Fail6: {};
  Message_Fail7: {};
  Message_Fail8: {};
  Message_Fail9: {};
  Message_Fail10: {};
  Message_Fail11: {};
  Message_Fail12: {};
  Message_Fail13: {};
  Message_Fail14: {};
  Message_Fail15: {};
  Message_Fail16: {};
  Message_Fail17: {};
  Message_Fail18: {};
  Message_Fail19: {};
  Message_Fail20: {};
  Message_Fail21: {};
  Message_Fail22: {};
  Message_Fail23: {};
  Message_Fail24: {};
  Message_Fail25: {};
  Message_Fail26: {};
  Message_Fail27: {};
  Message_Fail28: {};
  Message_Fail29: {};
  Message_Fail30: {};
  Message_Fail31: {};
  Message_Fail32: {};
}

export declare class Message_AttributeMeter extends Message_Attribute {
  constructor(theName: XCAFDoc_PartId)
  static UndefinedMetricValue(): Quantity_AbsorbedDose;
  HasMetric(theMetric: Message_MetricType): Standard_Boolean;
  IsMetricValid(theMetric: Message_MetricType): Standard_Boolean;
  StartValue(theMetric: Message_MetricType): Quantity_AbsorbedDose;
  SetStartValue(theMetric: Message_MetricType, theValue: Quantity_AbsorbedDose): void;
  StopValue(theMetric: Message_MetricType): Quantity_AbsorbedDose;
  SetStopValue(theMetric: Message_MetricType, theValue: Quantity_AbsorbedDose): void;
  static StartAlert(theAlert: Handle_Message_AlertExtended): void;
  static StopAlert(theAlert: Handle_Message_AlertExtended): void;
  static SetAlertMetrics(theAlert: Handle_Message_AlertExtended, theStartValue: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Message_Algorithm {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_Algorithm): void;
  get(): Message_Algorithm;
  delete(): void;
}

  export declare class Handle_Message_Algorithm_1 extends Handle_Message_Algorithm {
    constructor();
  }

  export declare class Handle_Message_Algorithm_2 extends Handle_Message_Algorithm {
    constructor(thePtr: Message_Algorithm);
  }

  export declare class Handle_Message_Algorithm_3 extends Handle_Message_Algorithm {
    constructor(theHandle: Handle_Message_Algorithm);
  }

  export declare class Handle_Message_Algorithm_4 extends Handle_Message_Algorithm {
    constructor(theHandle: Handle_Message_Algorithm);
  }

export declare class Message_Algorithm extends Standard_Transient {
  constructor()
  SetStatus_1(theStat: Message_Status): void;
  SetStatus_2(theStat: Message_Status, theInt: Graphic3d_ZLayerId): void;
  SetStatus_3(theStat: Message_Status, theStr: Standard_CString, noRepetitions: Standard_Boolean): void;
  SetStatus_4(theStat: Message_Status, theStr: XCAFDoc_PartId, noRepetitions: Standard_Boolean): void;
  SetStatus_5(theStat: Message_Status, theStr: Handle_TCollection_HAsciiString, noRepetitions: Standard_Boolean): void;
  SetStatus_6(theStat: Message_Status, theStr: TCollection_ExtendedString, noRepetitions: Standard_Boolean): void;
  SetStatus_7(theStat: Message_Status, theStr: Handle_TCollection_HExtendedString, noRepetitions: Standard_Boolean): void;
  SetStatus_8(theStat: Message_Status, theMsg: Message_Msg): void;
  GetStatus(): Message_ExecStatus;
  ChangeStatus(): Message_ExecStatus;
  ClearStatus(): void;
  SetMessenger(theMsgr: Handle_Message_Messenger): void;
  GetMessenger(): Handle_Message_Messenger;
  SendStatusMessages(theFilter: Message_ExecStatus, theTraceLevel: Message_Gravity, theMaxCount: Graphic3d_ZLayerId): void;
  SendMessages(theTraceLevel: Message_Gravity, theMaxCount: Graphic3d_ZLayerId): void;
  AddStatus_1(theOther: Handle_Message_Algorithm): void;
  AddStatus_2(theStatus: Message_ExecStatus, theOther: Handle_Message_Algorithm): void;
  GetMessageNumbers(theStatus: Message_Status): Handle_TColStd_HPackedMapOfInteger;
  GetMessageStrings(theStatus: Message_Status): Handle_TColStd_HSequenceOfHExtendedString;
  static PrepareReport_1(theError: Handle_TColStd_HPackedMapOfInteger, theMaxCount: Graphic3d_ZLayerId): TCollection_ExtendedString;
  static PrepareReport_2(theReportSeq: TColStd_SequenceOfHExtendedString, theMaxCount: Graphic3d_ZLayerId): TCollection_ExtendedString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type Message_StatusType = {
  Message_DONE: {};
  Message_WARN: {};
  Message_ALARM: {};
  Message_FAIL: {};
}

export declare class Handle_Message_AlertExtended {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_AlertExtended): void;
  get(): Message_AlertExtended;
  delete(): void;
}

  export declare class Handle_Message_AlertExtended_1 extends Handle_Message_AlertExtended {
    constructor();
  }

  export declare class Handle_Message_AlertExtended_2 extends Handle_Message_AlertExtended {
    constructor(thePtr: Message_AlertExtended);
  }

  export declare class Handle_Message_AlertExtended_3 extends Handle_Message_AlertExtended {
    constructor(theHandle: Handle_Message_AlertExtended);
  }

  export declare class Handle_Message_AlertExtended_4 extends Handle_Message_AlertExtended {
    constructor(theHandle: Handle_Message_AlertExtended);
  }

export declare class Message_AlertExtended extends Message_Alert {
  constructor()
  static AddAlert(theReport: Handle_Message_Report, theAttribute: Handle_Message_Attribute, theGravity: Message_Gravity): Handle_Message_Alert;
  GetMessageKey(): Standard_CString;
  Attribute(): Handle_Message_Attribute;
  SetAttribute(theAttribute: Handle_Message_Attribute): void;
  CompositeAlerts(theToCreate: Standard_Boolean): Handle_Message_CompositeAlerts;
  SupportsMerge(): Standard_Boolean;
  Merge(theTarget: Handle_Message_Alert): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Message_Messenger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_Messenger): void;
  get(): Message_Messenger;
  delete(): void;
}

  export declare class Handle_Message_Messenger_1 extends Handle_Message_Messenger {
    constructor();
  }

  export declare class Handle_Message_Messenger_2 extends Handle_Message_Messenger {
    constructor(thePtr: Message_Messenger);
  }

  export declare class Handle_Message_Messenger_3 extends Handle_Message_Messenger {
    constructor(theHandle: Handle_Message_Messenger);
  }

  export declare class Handle_Message_Messenger_4 extends Handle_Message_Messenger {
    constructor(theHandle: Handle_Message_Messenger);
  }

export declare class Message_Messenger extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  AddPrinter(thePrinter: Handle_Message_Printer): Standard_Boolean;
  RemovePrinter(thePrinter: Handle_Message_Printer): Standard_Boolean;
  RemovePrinters(theType: Handle_Standard_Type): Graphic3d_ZLayerId;
  Printers(): Message_SequenceOfPrinters;
  ChangePrinters(): Message_SequenceOfPrinters;
  Send_1(theString: Standard_CString, theGravity: Message_Gravity): void;
  Send_2(theStream: Standard_SStream, theGravity: Message_Gravity): void;
  Send_3(theString: XCAFDoc_PartId, theGravity: Message_Gravity): void;
  Send_4(theString: TCollection_ExtendedString, theGravity: Message_Gravity): void;
  Send_5(theGravity: Message_Gravity): any;
  Send_6(theObject: Handle_Standard_Transient, theGravity: Message_Gravity): void;
  SendFail_1(): any;
  SendAlarm_1(): any;
  SendWarning_1(): any;
  SendInfo_1(): any;
  SendTrace_1(): any;
  SendFail_2(theMessage: XCAFDoc_PartId): void;
  SendAlarm_2(theMessage: XCAFDoc_PartId): void;
  SendWarning_2(theMessage: XCAFDoc_PartId): void;
  SendInfo_2(theMessage: XCAFDoc_PartId): void;
  SendTrace_2(theMessage: XCAFDoc_PartId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Message_Messenger_1 extends Message_Messenger {
    constructor();
  }

  export declare class Message_Messenger_2 extends Message_Messenger {
    constructor(thePrinter: Handle_Message_Printer);
  }

export declare class Message {
  constructor();
  static DefaultMessenger(): Handle_Message_Messenger;
  static Send_1(theGravity: Message_Gravity): any;
  static Send_2(theMessage: XCAFDoc_PartId, theGravity: Message_Gravity): void;
  static SendFail_1(): any;
  static SendAlarm_1(): any;
  static SendWarning_1(): any;
  static SendInfo_1(): any;
  static SendTrace_1(): any;
  static SendFail_2(theMessage: XCAFDoc_PartId): void;
  static SendAlarm_2(theMessage: XCAFDoc_PartId): void;
  static SendWarning_2(theMessage: XCAFDoc_PartId): void;
  static SendInfo_2(theMessage: XCAFDoc_PartId): void;
  static SendTrace_2(theMessage: XCAFDoc_PartId): void;
  static FillTime(Hour: Graphic3d_ZLayerId, Minute: Graphic3d_ZLayerId, Second: Quantity_AbsorbedDose): XCAFDoc_PartId;
  static DefaultReport(theToCreate: Standard_Boolean): Handle_Message_Report;
  static MetricFromString_1(theString: Standard_CString, theType: Message_MetricType): Standard_Boolean;
  static MetricToString(theType: Message_MetricType): Standard_CString;
  static MetricFromString_2(theString: Standard_CString): Message_MetricType;
  static ToMessageMetric(theMemInfo: any, theMetric: Message_MetricType): Standard_Boolean;
  delete(): void;
}

export declare class Message_MsgFile {
  constructor();
  static Load(theDirName: Standard_CString, theFileName: Standard_CString): Standard_Boolean;
  static LoadFile(theFName: Standard_CString): Standard_Boolean;
  static LoadFromEnv(theEnvName: Standard_CString, theFileName: Standard_CString, theLangExt: Standard_CString): Standard_Boolean;
  static LoadFromString(theContent: Standard_CString, theLength: Graphic3d_ZLayerId): Standard_Boolean;
  static AddMsg(key: XCAFDoc_PartId, text: TCollection_ExtendedString): Standard_Boolean;
  static HasMsg(key: XCAFDoc_PartId): Standard_Boolean;
  static Msg_1(key: Standard_CString): TCollection_ExtendedString;
  static Msg_2(key: XCAFDoc_PartId): TCollection_ExtendedString;
  delete(): void;
}

export declare class Message_Alert extends Standard_Transient {
  constructor();
  GetMessageKey(): Standard_CString;
  SupportsMerge(): Standard_Boolean;
  Merge(theTarget: Handle_Message_Alert): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Message_Alert {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_Alert): void;
  get(): Message_Alert;
  delete(): void;
}

  export declare class Handle_Message_Alert_1 extends Handle_Message_Alert {
    constructor();
  }

  export declare class Handle_Message_Alert_2 extends Handle_Message_Alert {
    constructor(thePtr: Message_Alert);
  }

  export declare class Handle_Message_Alert_3 extends Handle_Message_Alert {
    constructor(theHandle: Handle_Message_Alert);
  }

  export declare class Handle_Message_Alert_4 extends Handle_Message_Alert {
    constructor(theHandle: Handle_Message_Alert);
  }

export declare class Message_AttributeObject extends Message_Attribute {
  constructor(theObject: Handle_Standard_Transient, theName: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Object(): Handle_Standard_Transient;
  SetObject(theObject: Handle_Standard_Transient): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Message_Report {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_Report): void;
  get(): Message_Report;
  delete(): void;
}

  export declare class Handle_Message_Report_1 extends Handle_Message_Report {
    constructor();
  }

  export declare class Handle_Message_Report_2 extends Handle_Message_Report {
    constructor(thePtr: Message_Report);
  }

  export declare class Handle_Message_Report_3 extends Handle_Message_Report {
    constructor(theHandle: Handle_Message_Report);
  }

  export declare class Handle_Message_Report_4 extends Handle_Message_Report {
    constructor(theHandle: Handle_Message_Report);
  }

export declare class Message_Report extends Standard_Transient {
  constructor()
  AddAlert(theGravity: Message_Gravity, theAlert: Handle_Message_Alert): void;
  GetAlerts(theGravity: Message_Gravity): Message_ListOfAlert;
  HasAlert_1(theType: Handle_Standard_Type): Standard_Boolean;
  HasAlert_2(theType: Handle_Standard_Type, theGravity: Message_Gravity): Standard_Boolean;
  IsActiveInMessenger(theMessenger: Handle_Message_Messenger): Standard_Boolean;
  ActivateInMessenger(toActivate: Standard_Boolean, theMessenger: Handle_Message_Messenger): void;
  UpdateActiveInMessenger(theMessenger: Handle_Message_Messenger): void;
  AddLevel(theLevel: Message_Level, theName: XCAFDoc_PartId): void;
  RemoveLevel(theLevel: Message_Level): void;
  Clear_1(): void;
  Clear_2(theGravity: Message_Gravity): void;
  Clear_3(theType: Handle_Standard_Type): void;
  ActiveMetrics(): any;
  SetActiveMetric(theMetricType: Message_MetricType, theActivate: Standard_Boolean): void;
  ClearMetrics(): void;
  Limit(): Graphic3d_ZLayerId;
  SetLimit(theLimit: Graphic3d_ZLayerId): void;
  Dump_1(theOS: Standard_OStream): void;
  Dump_2(theOS: Standard_OStream, theGravity: Message_Gravity): void;
  SendMessages_1(theMessenger: Handle_Message_Messenger): void;
  SendMessages_2(theMessenger: Handle_Message_Messenger, theGravity: Message_Gravity): void;
  Merge_1(theOther: Handle_Message_Report): void;
  Merge_2(theOther: Handle_Message_Report, theGravity: Message_Gravity): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Message_Attribute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_Attribute): void;
  get(): Message_Attribute;
  delete(): void;
}

  export declare class Handle_Message_Attribute_1 extends Handle_Message_Attribute {
    constructor();
  }

  export declare class Handle_Message_Attribute_2 extends Handle_Message_Attribute {
    constructor(thePtr: Message_Attribute);
  }

  export declare class Handle_Message_Attribute_3 extends Handle_Message_Attribute {
    constructor(theHandle: Handle_Message_Attribute);
  }

  export declare class Handle_Message_Attribute_4 extends Handle_Message_Attribute {
    constructor(theHandle: Handle_Message_Attribute);
  }

export declare class Message_Attribute extends Standard_Transient {
  constructor(theName: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetMessageKey(): Standard_CString;
  GetName(): XCAFDoc_PartId;
  SetName(theName: XCAFDoc_PartId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Message_ProgressSentry extends Message_ProgressScope {
  constructor(theRange: Message_ProgressRange, theName: Standard_CString, theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose, theStep: Quantity_AbsorbedDose, theIsInf: Standard_Boolean, theNewScopeSpan: Quantity_AbsorbedDose)
  Relieve(): void;
  delete(): void;
}

export declare class Message_ProgressIndicator extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Start_1(): Message_ProgressRange;
  static Start_2(theProgress: Handle_Message_ProgressIndicator): Message_ProgressRange;
  GetPosition(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_Message_ProgressIndicator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_ProgressIndicator): void;
  get(): Message_ProgressIndicator;
  delete(): void;
}

  export declare class Handle_Message_ProgressIndicator_1 extends Handle_Message_ProgressIndicator {
    constructor();
  }

  export declare class Handle_Message_ProgressIndicator_2 extends Handle_Message_ProgressIndicator {
    constructor(thePtr: Message_ProgressIndicator);
  }

  export declare class Handle_Message_ProgressIndicator_3 extends Handle_Message_ProgressIndicator {
    constructor(theHandle: Handle_Message_ProgressIndicator);
  }

  export declare class Handle_Message_ProgressIndicator_4 extends Handle_Message_ProgressIndicator {
    constructor(theHandle: Handle_Message_ProgressIndicator);
  }

export declare type Message_Gravity = {
  Message_Trace: {};
  Message_Info: {};
  Message_Warning: {};
  Message_Alarm: {};
  Message_Fail: {};
}

export declare type Message_MetricType = {
  Message_MetricType_None: {};
  Message_MetricType_ThreadCPUUserTime: {};
  Message_MetricType_ThreadCPUSystemTime: {};
  Message_MetricType_ProcessCPUUserTime: {};
  Message_MetricType_ProcessCPUSystemTime: {};
  Message_MetricType_MemPrivate: {};
  Message_MetricType_MemVirtual: {};
  Message_MetricType_MemWorkingSet: {};
  Message_MetricType_MemWorkingSetPeak: {};
  Message_MetricType_MemSwapUsage: {};
  Message_MetricType_MemSwapUsagePeak: {};
  Message_MetricType_MemHeapUsage: {};
}

export declare class Message_Level {
  constructor(theName: XCAFDoc_PartId)
  RootAlert(): Handle_Message_AlertExtended;
  SetRootAlert(theAlert: Handle_Message_AlertExtended, isRequiredToStart: Standard_Boolean): void;
  AddAlert(theGravity: Message_Gravity, theAlert: Handle_Message_Alert): Standard_Boolean;
  delete(): void;
}

export declare type Message_ConsoleColor = {
  Message_ConsoleColor_Default: {};
  Message_ConsoleColor_Black: {};
  Message_ConsoleColor_White: {};
  Message_ConsoleColor_Red: {};
  Message_ConsoleColor_Blue: {};
  Message_ConsoleColor_Green: {};
  Message_ConsoleColor_Yellow: {};
  Message_ConsoleColor_Cyan: {};
  Message_ConsoleColor_Magenta: {};
}

export declare class Handle_Message_PrinterToReport {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_PrinterToReport): void;
  get(): Message_PrinterToReport;
  delete(): void;
}

  export declare class Handle_Message_PrinterToReport_1 extends Handle_Message_PrinterToReport {
    constructor();
  }

  export declare class Handle_Message_PrinterToReport_2 extends Handle_Message_PrinterToReport {
    constructor(thePtr: Message_PrinterToReport);
  }

  export declare class Handle_Message_PrinterToReport_3 extends Handle_Message_PrinterToReport {
    constructor(theHandle: Handle_Message_PrinterToReport);
  }

  export declare class Handle_Message_PrinterToReport_4 extends Handle_Message_PrinterToReport {
    constructor(theHandle: Handle_Message_PrinterToReport);
  }

export declare class Message_PrinterToReport extends Message_Printer {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Report(): Handle_Message_Report;
  SetReport(theReport: Handle_Message_Report): void;
  SendStringStream(theStream: Standard_SStream, theGravity: Message_Gravity): void;
  SendObject(theObject: Handle_Standard_Transient, theGravity: Message_Gravity): void;
  delete(): void;
}

export declare class Message_ListOfMsg extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: Message_ListOfMsg): Message_ListOfMsg;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Message_Msg;
  First_2(): Message_Msg;
  Last_1(): Message_Msg;
  Last_2(): Message_Msg;
  Append_1(theItem: Message_Msg): Message_Msg;
  Append_3(theOther: Message_ListOfMsg): void;
  Prepend_1(theItem: Message_Msg): Message_Msg;
  Prepend_2(theOther: Message_ListOfMsg): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class Message_ListOfMsg_1 extends Message_ListOfMsg {
    constructor();
  }

  export declare class Message_ListOfMsg_2 extends Message_ListOfMsg {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Message_ListOfMsg_3 extends Message_ListOfMsg {
    constructor(theOther: Message_ListOfMsg);
  }

export declare class Message_ProgressScope {
  SetName_1(theName: XCAFDoc_PartId): void;
  UserBreak(): Standard_Boolean;
  More(): Standard_Boolean;
  Next(theStep: Quantity_AbsorbedDose): Message_ProgressRange;
  Show(): void;
  IsActive(): Standard_Boolean;
  Name(): Standard_CString;
  Parent(): Message_ProgressScope;
  MaxValue(): Quantity_AbsorbedDose;
  Value(): Quantity_AbsorbedDose;
  IsInfinite(): Standard_Boolean;
  GetPortion(): Quantity_AbsorbedDose;
  Close(): void;
  delete(): void;
}

  export declare class Message_ProgressScope_1 extends Message_ProgressScope {
    constructor();
  }

  export declare class Message_ProgressScope_2 extends Message_ProgressScope {
    constructor(theRange: Message_ProgressRange, theName: XCAFDoc_PartId, theMax: Quantity_AbsorbedDose, isInfinite: Standard_Boolean);
  }

  export declare class Message_ProgressScope_4 extends Message_ProgressScope {
    constructor(theRange: Message_ProgressRange, theName: any, theMax: Quantity_AbsorbedDose, isInfinite: Standard_Boolean);
  }

export declare class Message_ExecStatus {
  Set(status: Message_Status): void;
  IsSet(status: Message_Status): Standard_Boolean;
  Clear_1(status: Message_Status): void;
  IsDone(): Standard_Boolean;
  IsFail(): Standard_Boolean;
  IsWarn(): Standard_Boolean;
  IsAlarm(): Standard_Boolean;
  SetAllDone(): void;
  SetAllWarn(): void;
  SetAllAlarm(): void;
  SetAllFail(): void;
  ClearAllDone(): void;
  ClearAllWarn(): void;
  ClearAllAlarm(): void;
  ClearAllFail(): void;
  Clear_2(): void;
  Add(theOther: Message_ExecStatus): void;
  And(theOther: Message_ExecStatus): void;
  static StatusIndex(status: Message_Status): Graphic3d_ZLayerId;
  static LocalStatusIndex(status: Message_Status): Graphic3d_ZLayerId;
  static TypeOfStatus(status: Message_Status): Message_StatusType;
  static StatusByIndex(theIndex: Graphic3d_ZLayerId): Message_Status;
  delete(): void;
}

  export declare class Message_ExecStatus_1 extends Message_ExecStatus {
    constructor();
  }

  export declare class Message_ExecStatus_2 extends Message_ExecStatus {
    constructor(status: Message_Status);
  }

export declare class Message_Msg {
  Set_1(theMsg: Standard_CString): void;
  Set_2(theMsg: TCollection_ExtendedString): void;
  Arg_1(theString: Standard_CString): Message_Msg;
  Arg_2(theString: XCAFDoc_PartId): Message_Msg;
  Arg_3(theString: Handle_TCollection_HAsciiString): Message_Msg;
  Arg_4(theString: TCollection_ExtendedString): Message_Msg;
  Arg_5(theString: Handle_TCollection_HExtendedString): Message_Msg;
  Arg_6(theInt: Graphic3d_ZLayerId): Message_Msg;
  Arg_7(theReal: Quantity_AbsorbedDose): Message_Msg;
  Original(): TCollection_ExtendedString;
  Value(): TCollection_ExtendedString;
  IsEdited(): Standard_Boolean;
  Get(): TCollection_ExtendedString;
  delete(): void;
}

  export declare class Message_Msg_1 extends Message_Msg {
    constructor();
  }

  export declare class Message_Msg_2 extends Message_Msg {
    constructor(theMsg: Message_Msg);
  }

  export declare class Message_Msg_3 extends Message_Msg {
    constructor(theKey: Standard_CString);
  }

  export declare class Message_Msg_4 extends Message_Msg {
    constructor(theKey: TCollection_ExtendedString);
  }

export declare class Handle_Message_CompositeAlerts {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_CompositeAlerts): void;
  get(): Message_CompositeAlerts;
  delete(): void;
}

  export declare class Handle_Message_CompositeAlerts_1 extends Handle_Message_CompositeAlerts {
    constructor();
  }

  export declare class Handle_Message_CompositeAlerts_2 extends Handle_Message_CompositeAlerts {
    constructor(thePtr: Message_CompositeAlerts);
  }

  export declare class Handle_Message_CompositeAlerts_3 extends Handle_Message_CompositeAlerts {
    constructor(theHandle: Handle_Message_CompositeAlerts);
  }

  export declare class Handle_Message_CompositeAlerts_4 extends Handle_Message_CompositeAlerts {
    constructor(theHandle: Handle_Message_CompositeAlerts);
  }

export declare class Message_CompositeAlerts extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Alerts(theGravity: Message_Gravity): Message_ListOfAlert;
  AddAlert(theGravity: Message_Gravity, theAlert: Handle_Message_Alert): Standard_Boolean;
  RemoveAlert(theGravity: Message_Gravity, theAlert: Handle_Message_Alert): Standard_Boolean;
  HasAlert_1(theAlert: Handle_Message_Alert): Standard_Boolean;
  HasAlert_2(theType: Handle_Standard_Type, theGravity: Message_Gravity): Standard_Boolean;
  Clear_1(): void;
  Clear_2(theGravity: Message_Gravity): void;
  Clear_3(theType: Handle_Standard_Type): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Message_Printer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_Printer): void;
  get(): Message_Printer;
  delete(): void;
}

  export declare class Handle_Message_Printer_1 extends Handle_Message_Printer {
    constructor();
  }

  export declare class Handle_Message_Printer_2 extends Handle_Message_Printer {
    constructor(thePtr: Message_Printer);
  }

  export declare class Handle_Message_Printer_3 extends Handle_Message_Printer {
    constructor(theHandle: Handle_Message_Printer);
  }

  export declare class Handle_Message_Printer_4 extends Handle_Message_Printer {
    constructor(theHandle: Handle_Message_Printer);
  }

export declare class Message_Printer extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetTraceLevel(): Message_Gravity;
  SetTraceLevel(theTraceLevel: Message_Gravity): void;
  Send_1(theString: TCollection_ExtendedString, theGravity: Message_Gravity): void;
  Send_2(theString: Standard_CString, theGravity: Message_Gravity): void;
  Send_3(theString: XCAFDoc_PartId, theGravity: Message_Gravity): void;
  SendStringStream(theStream: Standard_SStream, theGravity: Message_Gravity): void;
  SendObject(theObject: Handle_Standard_Transient, theGravity: Message_Gravity): void;
  delete(): void;
}

export declare class Message_PrinterSystemLog extends Message_Printer {
  constructor(theEventSourceName: XCAFDoc_PartId, theTraceLevel: Message_Gravity)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Message_PrinterSystemLog {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Message_PrinterSystemLog): void;
  get(): Message_PrinterSystemLog;
  delete(): void;
}

  export declare class Handle_Message_PrinterSystemLog_1 extends Handle_Message_PrinterSystemLog {
    constructor();
  }

  export declare class Handle_Message_PrinterSystemLog_2 extends Handle_Message_PrinterSystemLog {
    constructor(thePtr: Message_PrinterSystemLog);
  }

  export declare class Handle_Message_PrinterSystemLog_3 extends Handle_Message_PrinterSystemLog {
    constructor(theHandle: Handle_Message_PrinterSystemLog);
  }

  export declare class Handle_Message_PrinterSystemLog_4 extends Handle_Message_PrinterSystemLog {
    constructor(theHandle: Handle_Message_PrinterSystemLog);
  }

export declare class Handle_BRepMesh_DiscretRoot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepMesh_DiscretRoot): void;
  get(): BRepMesh_DiscretRoot;
  delete(): void;
}

  export declare class Handle_BRepMesh_DiscretRoot_1 extends Handle_BRepMesh_DiscretRoot {
    constructor();
  }

  export declare class Handle_BRepMesh_DiscretRoot_2 extends Handle_BRepMesh_DiscretRoot {
    constructor(thePtr: BRepMesh_DiscretRoot);
  }

  export declare class Handle_BRepMesh_DiscretRoot_3 extends Handle_BRepMesh_DiscretRoot {
    constructor(theHandle: Handle_BRepMesh_DiscretRoot);
  }

  export declare class Handle_BRepMesh_DiscretRoot_4 extends Handle_BRepMesh_DiscretRoot {
    constructor(theHandle: Handle_BRepMesh_DiscretRoot);
  }

export declare class BRepMesh_DiscretRoot extends Standard_Transient {
  SetShape(theShape: TopoDS_Shape): void;
  Shape(): TopoDS_Shape;
  IsDone(): Standard_Boolean;
  Perform(theRange: Message_ProgressRange): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_EdgeTessellationExtractor extends IMeshTools_CurveTessellator {
  constructor(theEdge: any, theFace: any)
  PointsNb(): Graphic3d_ZLayerId;
  Value(theIndex: Graphic3d_ZLayerId, thePoint: gp_Pnt, theParameter: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_DiscretFactory {
  static Get(): BRepMesh_DiscretFactory;
  Names(): TColStd_MapOfAsciiString;
  SetDefaultName(theName: XCAFDoc_PartId): Standard_Boolean;
  DefaultName(): XCAFDoc_PartId;
  SetFunctionName(theFuncName: XCAFDoc_PartId): Standard_Boolean;
  FunctionName(): XCAFDoc_PartId;
  ErrorStatus(): BRepMesh_FactoryError;
  SetDefault(theName: XCAFDoc_PartId, theFuncName: XCAFDoc_PartId): Standard_Boolean;
  Discret(theShape: TopoDS_Shape, theLinDeflection: Quantity_AbsorbedDose, theAngDeflection: Quantity_AbsorbedDose): Handle_BRepMesh_DiscretRoot;
  delete(): void;
}

export declare class BRepMesh_UVParamRangeSplitter extends BRepMesh_DefaultRangeSplitter {
  constructor()
  Reset(theDFace: any, theParameters: IMeshTools_Parameters): void;
  GetParametersU_1(): any;
  GetParametersU_2(): any;
  GetParametersV_1(): any;
  GetParametersV_2(): any;
  delete(): void;
}

export declare class BRepMesh_ConstrainedBaseMeshAlgo extends BRepMesh_BaseMeshAlgo {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_ShapeVisitor extends IMeshTools_ShapeVisitor {
  constructor(theModel: any)
  Visit_1(theFace: TopoDS_Face): void;
  Visit_2(theEdge: TopoDS_Edge): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_ShapeTool extends Standard_Transient {
  constructor();
  static MaxFaceTolerance(theFace: TopoDS_Face): Quantity_AbsorbedDose;
  static BoxMaxDimension(theBox: Bnd_Box, theMaxDimension: Quantity_AbsorbedDose): void;
  static CheckAndUpdateFlags(theEdge: any, thePCurve: any): void;
  static AddInFace(theFace: TopoDS_Face, theTriangulation: Handle_Poly_Triangulation): void;
  static NullifyFace(theFace: TopoDS_Face): void;
  static NullifyEdge_1(theEdge: TopoDS_Edge, theTriangulation: Handle_Poly_Triangulation, theLocation: TopLoc_Location): void;
  static NullifyEdge_2(theEdge: TopoDS_Edge, theLocation: TopLoc_Location): void;
  static UpdateEdge_1(theEdge: TopoDS_Edge, thePolygon: Handle_Poly_PolygonOnTriangulation, theTriangulation: Handle_Poly_Triangulation, theLocation: TopLoc_Location): void;
  static UpdateEdge_2(theEdge: TopoDS_Edge, thePolygon: Handle_Poly_Polygon3D): void;
  static UpdateEdge_3(theEdge: TopoDS_Edge, thePolygon1: Handle_Poly_PolygonOnTriangulation, thePolygon2: Handle_Poly_PolygonOnTriangulation, theTriangulation: Handle_Poly_Triangulation, theLocation: TopLoc_Location): void;
  static UseLocation(thePnt: gp_Pnt, theLoc: TopLoc_Location): gp_Pnt;
  static UVPoints(theEdge: TopoDS_Edge, theFace: TopoDS_Face, theFirstPoint2d: gp_Pnt2d, theLastPoint2d: gp_Pnt2d, isConsiderOrientation: Standard_Boolean): Standard_Boolean;
  static Range_1(theEdge: TopoDS_Edge, theFace: TopoDS_Face, thePCurve: Handle_Geom2d_Curve, theFirstParam: Quantity_AbsorbedDose, theLastParam: Quantity_AbsorbedDose, isConsiderOrientation: Standard_Boolean): Standard_Boolean;
  static Range_2(theEdge: TopoDS_Edge, theCurve: Handle_Geom_Curve, theFirstParam: Quantity_AbsorbedDose, theLastParam: Quantity_AbsorbedDose, isConsiderOrientation: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_BaseMeshAlgo extends IMeshTools_MeshAlgo {
  Perform(theDFace: any, theParameters: IMeshTools_Parameters, theRange: Message_ProgressRange): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_ModelHealer extends IMeshTools_ModelAlgo {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_ModelBuilder extends IMeshTools_ModelBuilder {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type BRepMesh_DegreeOfFreedom = {
  BRepMesh_Free: {};
  BRepMesh_InVolume: {};
  BRepMesh_OnSurface: {};
  BRepMesh_OnCurve: {};
  BRepMesh_Fixed: {};
  BRepMesh_Frontier: {};
  BRepMesh_Deleted: {};
}

export declare class BRepMesh_Triangle {
  Initialize(theEdges: any, theOrientations: any, theMovability: BRepMesh_DegreeOfFreedom): void;
  Edges(theEdges: any, theOrientations: any): void;
  Movability(): BRepMesh_DegreeOfFreedom;
  SetMovability(theMovability: BRepMesh_DegreeOfFreedom): void;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsEqual(theOther: BRepMesh_Triangle): Standard_Boolean;
  delete(): void;
}

  export declare class BRepMesh_Triangle_1 extends BRepMesh_Triangle {
    constructor();
  }

  export declare class BRepMesh_Triangle_2 extends BRepMesh_Triangle {
    constructor(theEdges: any, theOrientations: any, theMovability: BRepMesh_DegreeOfFreedom);
  }

export declare class BRepMesh_DelabellaMeshAlgoFactory extends IMeshTools_MeshAlgoFactory {
  constructor()
  GetAlgo(theSurfaceType: GeomAbs_SurfaceType, theParameters: IMeshTools_Parameters): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_Classifier extends Standard_Transient {
  constructor()
  Perform(thePoint: gp_Pnt2d): TopAbs_State;
  RegisterWire(theWire: NCollection_Sequence< gp_Pnt2d >, theTolUV: any, theRangeU: any, theRangeV: any): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_DefaultRangeSplitter {
  constructor()
  Reset(theDFace: any, theParameters: IMeshTools_Parameters): void;
  AddPoint(thePoint: gp_Pnt2d): void;
  AdjustRange(): void;
  IsValid(): Standard_Boolean;
  Scale(thePoint: gp_Pnt2d, isToFaceBasis: Standard_Boolean): gp_Pnt2d;
  GenerateSurfaceNodes(theParameters: IMeshTools_Parameters): any;
  Point(thePoint2d: gp_Pnt2d): gp_Pnt;
  GetDFace(): any;
  GetSurface(): Handle_BRepAdaptor_HSurface;
  GetRangeU(): any;
  GetRangeV(): any;
  GetDelta(): any;
  GetToleranceUV(): any;
  delete(): void;
}

export declare class BRepMesh_IncrementalMesh extends BRepMesh_DiscretRoot {
  Perform_1(theRange: Message_ProgressRange): void;
  Perform_2(theContext: any, theRange: Message_ProgressRange): void;
  Parameters(): IMeshTools_Parameters;
  ChangeParameters(): IMeshTools_Parameters;
  IsModified(): Standard_Boolean;
  GetStatusFlags(): Graphic3d_ZLayerId;
  static Discret(theShape: TopoDS_Shape, theLinDeflection: Quantity_AbsorbedDose, theAngDeflection: Quantity_AbsorbedDose, theAlgo: BRepMesh_DiscretRoot): Graphic3d_ZLayerId;
  static IsParallelDefault(): Standard_Boolean;
  static SetParallelDefault(isInParallel: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepMesh_IncrementalMesh_1 extends BRepMesh_IncrementalMesh {
    constructor();
  }

  export declare class BRepMesh_IncrementalMesh_2 extends BRepMesh_IncrementalMesh {
    constructor(theShape: TopoDS_Shape, theLinDeflection: Quantity_AbsorbedDose, isRelative: Standard_Boolean, theAngDeflection: Quantity_AbsorbedDose, isInParallel: Standard_Boolean);
  }

  export declare class BRepMesh_IncrementalMesh_3 extends BRepMesh_IncrementalMesh {
    constructor(theShape: TopoDS_Shape, theParameters: IMeshTools_Parameters, theRange: Message_ProgressRange);
  }

export declare class BRepMesh_CurveTessellator extends IMeshTools_CurveTessellator {
  PointsNb(): Graphic3d_ZLayerId;
  Value(theIndex: Graphic3d_ZLayerId, thePoint: gp_Pnt, theParameter: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepMesh_CurveTessellator_1 extends BRepMesh_CurveTessellator {
    constructor(theEdge: any, theParameters: IMeshTools_Parameters);
  }

  export declare class BRepMesh_CurveTessellator_2 extends BRepMesh_CurveTessellator {
    constructor(theEdge: any, theOrientation: TopAbs_Orientation, theFace: any, theParameters: IMeshTools_Parameters);
  }

export declare class BRepMesh_Context extends IMeshTools_Context {
  constructor(theMeshType: IMeshTools_MeshAlgoType)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_SphereRangeSplitter extends BRepMesh_DefaultRangeSplitter {
  constructor()
  GenerateSurfaceNodes(theParameters: IMeshTools_Parameters): any;
  delete(): void;
}

export declare class BRepMesh_BoundaryParamsRangeSplitter extends BRepMesh_NURBSRangeSplitter {
  constructor()
  AddPoint(thePoint: gp_Pnt2d): void;
  delete(): void;
}

export declare class BRepMesh_CircleTool {
  Init(a0: Graphic3d_ZLayerId): void;
  SetCellSize_1(theSize: Quantity_AbsorbedDose): void;
  SetCellSize_2(theSizeX: Quantity_AbsorbedDose, theSizeY: Quantity_AbsorbedDose): void;
  SetMinMaxSize(theMin: gp_XY, theMax: gp_XY): void;
  IsEmpty(): Standard_Boolean;
  Bind_1(theIndex: Graphic3d_ZLayerId, theCircle: gp_Circ2d): void;
  static MakeCircle(thePoint1: gp_XY, thePoint2: gp_XY, thePoint3: gp_XY, theLocation: gp_XY, theRadius: Quantity_AbsorbedDose): Standard_Boolean;
  Bind_2(theIndex: Graphic3d_ZLayerId, thePoint1: gp_XY, thePoint2: gp_XY, thePoint3: gp_XY): Standard_Boolean;
  MocBind(theIndex: Graphic3d_ZLayerId): void;
  Delete(theIndex: Graphic3d_ZLayerId): void;
  Select(thePoint: gp_XY): any;
  delete(): void;
}

  export declare class BRepMesh_CircleTool_1 extends BRepMesh_CircleTool {
    constructor(theAllocator: Handle_NCollection_IncAllocator);
  }

  export declare class BRepMesh_CircleTool_2 extends BRepMesh_CircleTool {
    constructor(theReservedSize: Graphic3d_ZLayerId, theAllocator: Handle_NCollection_IncAllocator);
  }

export declare class BRepMesh_EdgeDiscret extends IMeshTools_ModelAlgo {
  constructor()
  static CreateEdgeTessellator_1(theDEdge: any, theParameters: IMeshTools_Parameters): any;
  static CreateEdgeTessellator_2(theDEdge: any, theOrientation: TopAbs_Orientation, theDFace: any, theParameters: IMeshTools_Parameters): any;
  static CreateEdgeTessellationExtractor(theDEdge: any, theDFace: any): any;
  static Tessellate3d(theDEdge: any, theTessellator: any, theUpdateEnds: Standard_Boolean): void;
  static Tessellate2d(theDEdge: any, theUpdateEnds: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_SelectorOfDataStructureOfDelaun extends Standard_Transient {
  Initialize(theMesh: any): void;
  NeighboursOf_1(theNode: BRepMesh_Vertex): void;
  NeighboursOfNode(theNodeIndex: Graphic3d_ZLayerId): void;
  NeighboursOf_2(theLink: BRepMesh_Edge): void;
  NeighboursOfLink(theLinkIndex: Graphic3d_ZLayerId): void;
  NeighboursOf_3(theElement: BRepMesh_Triangle): void;
  NeighboursOfElement(theElementIndex: Graphic3d_ZLayerId): void;
  NeighboursByEdgeOf(theElement: BRepMesh_Triangle): void;
  NeighboursOf_4(a0: BRepMesh_SelectorOfDataStructureOfDelaun): void;
  AddNeighbours(): void;
  Nodes(): any;
  Links(): any;
  Elements(): any;
  FrontierLinks(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepMesh_SelectorOfDataStructureOfDelaun_1 extends BRepMesh_SelectorOfDataStructureOfDelaun {
    constructor();
  }

  export declare class BRepMesh_SelectorOfDataStructureOfDelaun_2 extends BRepMesh_SelectorOfDataStructureOfDelaun {
    constructor(theMesh: any);
  }

export declare class BRepMesh_ModelPreProcessor extends IMeshTools_ModelAlgo {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_DataStructureOfDelaun extends Standard_Transient {
  constructor(theAllocator: Handle_NCollection_IncAllocator, theReservedNodeSize: Graphic3d_ZLayerId)
  NbNodes(): Graphic3d_ZLayerId;
  AddNode(theNode: BRepMesh_Vertex, isForceAdd: Standard_Boolean): Graphic3d_ZLayerId;
  IndexOf_1(theNode: BRepMesh_Vertex): Graphic3d_ZLayerId;
  GetNode(theIndex: Graphic3d_ZLayerId): BRepMesh_Vertex;
  SubstituteNode(theIndex: Graphic3d_ZLayerId, theNewNode: BRepMesh_Vertex): Standard_Boolean;
  RemoveNode(theIndex: Graphic3d_ZLayerId, isForce: Standard_Boolean): void;
  LinksConnectedTo(theIndex: Graphic3d_ZLayerId): any;
  NbLinks(): Graphic3d_ZLayerId;
  AddLink(theLink: BRepMesh_Edge): Graphic3d_ZLayerId;
  IndexOf_2(theLink: BRepMesh_Edge): Graphic3d_ZLayerId;
  GetLink(theIndex: Graphic3d_ZLayerId): BRepMesh_Edge;
  LinksOfDomain(): any;
  SubstituteLink(theIndex: Graphic3d_ZLayerId, theNewLink: BRepMesh_Edge): Standard_Boolean;
  RemoveLink(theIndex: Graphic3d_ZLayerId, isForce: Standard_Boolean): void;
  ElementsConnectedTo(theLinkIndex: Graphic3d_ZLayerId): BRepMesh_PairOfIndex;
  NbElements(): Graphic3d_ZLayerId;
  AddElement(theElement: BRepMesh_Triangle): Graphic3d_ZLayerId;
  GetElement(theIndex: Graphic3d_ZLayerId): BRepMesh_Triangle;
  ElementsOfDomain(): any;
  SubstituteElement(theIndex: Graphic3d_ZLayerId, theNewElement: BRepMesh_Triangle): Standard_Boolean;
  RemoveElement(theIndex: Graphic3d_ZLayerId): void;
  ElementNodes(theElement: BRepMesh_Triangle, theNodes: any): void;
  Dump(theFileNameStr: Standard_CString): void;
  Statistics(theStream: Standard_OStream): void;
  Allocator(): Handle_NCollection_IncAllocator;
  Data(): any;
  ClearDomain(): void;
  ClearDeleted(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_CircleInspector extends NCollection_CellFilter_InspectorXY {
  constructor(theTolerance: Quantity_AbsorbedDose, theReservedSize: Graphic3d_ZLayerId, theAllocator: Handle_NCollection_IncAllocator)
  Bind(theIndex: Graphic3d_ZLayerId, theCircle: BRepMesh_Circle): void;
  Circles(): any;
  Circle(theIndex: Graphic3d_ZLayerId): BRepMesh_Circle;
  SetPoint(thePoint: gp_XY): void;
  GetShotCircles(): any;
  Inspect(theTargetIndex: Graphic3d_ZLayerId): NCollection_CellFilter_Action;
  static IsEqual(theIndex: Graphic3d_ZLayerId, theTargetIndex: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class BRepMesh_DelabellaBaseMeshAlgo extends BRepMesh_CustomBaseMeshAlgo {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_Delaun {
  Init(theVertices: any): void;
  InitCirclesTool(theCellsCountU: Graphic3d_ZLayerId, theCellsCountV: Graphic3d_ZLayerId): void;
  RemoveVertex(theVertex: BRepMesh_Vertex): void;
  AddVertices(theVerticesIndices: any, theRange: Message_ProgressRange): void;
  UseEdge(theEdge: Graphic3d_ZLayerId): Standard_Boolean;
  Result(): any;
  ProcessConstraints(): void;
  Frontier(): any;
  InternalEdges(): any;
  FreeEdges(): any;
  GetVertex(theIndex: Graphic3d_ZLayerId): BRepMesh_Vertex;
  GetEdge(theIndex: Graphic3d_ZLayerId): BRepMesh_Edge;
  GetTriangle(theIndex: Graphic3d_ZLayerId): BRepMesh_Triangle;
  Circles(): BRepMesh_CircleTool;
  Contains(theTriangleId: Graphic3d_ZLayerId, theVertex: BRepMesh_Vertex, theSqTolerance: Quantity_AbsorbedDose, theEdgeOn: Graphic3d_ZLayerId): Standard_Boolean;
  SetAuxVertices(theSupVert: any): void;
  RemoveAuxElements(): void;
  delete(): void;
}

  export declare class BRepMesh_Delaun_1 extends BRepMesh_Delaun {
    constructor(theOldMesh: any, theCellsCountU: Graphic3d_ZLayerId, theCellsCountV: Graphic3d_ZLayerId, isFillCircles: Standard_Boolean);
  }

  export declare class BRepMesh_Delaun_2 extends BRepMesh_Delaun {
    constructor(theVertices: any);
  }

  export declare class BRepMesh_Delaun_3 extends BRepMesh_Delaun {
    constructor(theOldMesh: any, theVertices: any);
  }

  export declare class BRepMesh_Delaun_4 extends BRepMesh_Delaun {
    constructor(theOldMesh: any, theVertexIndices: any);
  }

  export declare class BRepMesh_Delaun_5 extends BRepMesh_Delaun {
    constructor(theOldMesh: any, theVertexIndices: any, theCellsCountU: Graphic3d_ZLayerId, theCellsCountV: Graphic3d_ZLayerId);
  }

export declare class BRepMesh_Edge extends BRepMesh_OrientedEdge {
  Movability(): BRepMesh_DegreeOfFreedom;
  SetMovability(theMovability: BRepMesh_DegreeOfFreedom): void;
  IsSameOrientation(theOther: BRepMesh_Edge): Standard_Boolean;
  IsEqual(theOther: BRepMesh_Edge): Standard_Boolean;
  delete(): void;
}

  export declare class BRepMesh_Edge_1 extends BRepMesh_Edge {
    constructor();
  }

  export declare class BRepMesh_Edge_2 extends BRepMesh_Edge {
    constructor(theFirstNode: Graphic3d_ZLayerId, theLastNode: Graphic3d_ZLayerId, theMovability: BRepMesh_DegreeOfFreedom);
  }

export declare class BRepMesh_VertexInspector extends NCollection_CellFilter_InspectorXY {
  constructor(theAllocator: Handle_NCollection_IncAllocator)
  Add(theVertex: BRepMesh_Vertex): Graphic3d_ZLayerId;
  SetTolerance_1(theTolerance: Quantity_AbsorbedDose): void;
  SetTolerance_2(theToleranceX: Quantity_AbsorbedDose, theToleranceY: Quantity_AbsorbedDose): void;
  Clear(): void;
  Delete(theIndex: Graphic3d_ZLayerId): void;
  NbVertices(): Graphic3d_ZLayerId;
  GetVertex(theIndex: Graphic3d_ZLayerId): BRepMesh_Vertex;
  SetPoint(thePoint: gp_XY): void;
  GetCoincidentPoint(): Graphic3d_ZLayerId;
  GetListOfDelPoints(): any;
  Vertices(): any;
  ChangeVertices(): any;
  Inspect(theTargetIndex: Graphic3d_ZLayerId): NCollection_CellFilter_Action;
  static IsEqual(theIndex: Graphic3d_ZLayerId, theTargetIndex: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class BRepMesh_CustomBaseMeshAlgo extends BRepMesh_ConstrainedBaseMeshAlgo {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_PairOfIndex {
  constructor()
  Clear(): void;
  Append(theIndex: Graphic3d_ZLayerId): void;
  Prepend(theIndex: Graphic3d_ZLayerId): void;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  FirstIndex(): Graphic3d_ZLayerId;
  LastIndex(): Graphic3d_ZLayerId;
  Index(thePairPos: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetIndex(thePairPos: Graphic3d_ZLayerId, theIndex: Graphic3d_ZLayerId): void;
  RemoveIndex(thePairPos: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BRepMesh_OrientedEdge {
  FirstNode(): Graphic3d_ZLayerId;
  LastNode(): Graphic3d_ZLayerId;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsEqual(theOther: BRepMesh_OrientedEdge): Standard_Boolean;
  delete(): void;
}

  export declare class BRepMesh_OrientedEdge_1 extends BRepMesh_OrientedEdge {
    constructor();
  }

  export declare class BRepMesh_OrientedEdge_2 extends BRepMesh_OrientedEdge {
    constructor(theFirstNode: Graphic3d_ZLayerId, theLastNode: Graphic3d_ZLayerId);
  }

export declare class BRepMesh_VertexTool extends Standard_Transient {
  constructor(theAllocator: Handle_NCollection_IncAllocator)
  SetCellSize_1(theSize: Quantity_AbsorbedDose): void;
  SetCellSize_2(theSizeX: Quantity_AbsorbedDose, theSizeY: Quantity_AbsorbedDose): void;
  SetTolerance_1(theTolerance: Quantity_AbsorbedDose): void;
  SetTolerance_2(theToleranceX: Quantity_AbsorbedDose, theToleranceY: Quantity_AbsorbedDose): void;
  GetTolerance(theToleranceX: Quantity_AbsorbedDose, theToleranceY: Quantity_AbsorbedDose): void;
  Add(theVertex: BRepMesh_Vertex, isForceAdd: Standard_Boolean): Graphic3d_ZLayerId;
  DeleteVertex(theIndex: Graphic3d_ZLayerId): void;
  Vertices(): any;
  ChangeVertices(): any;
  FindKey(theIndex: Graphic3d_ZLayerId): BRepMesh_Vertex;
  FindIndex(theVertex: BRepMesh_Vertex): Graphic3d_ZLayerId;
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Substitute(theIndex: Graphic3d_ZLayerId, theVertex: BRepMesh_Vertex): void;
  RemoveLast(): void;
  GetListOfDelNodes(): any;
  Statistics(theStream: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_MeshTool extends Standard_Transient {
  constructor(theStructure: any)
  GetStructure(): any;
  DumpTriangles(theFileName: Standard_CString, theTriangles: any): void;
  AddAndLegalizeTriangle(thePoint1: Graphic3d_ZLayerId, thePoint2: Graphic3d_ZLayerId, thePoint3: Graphic3d_ZLayerId): void;
  AddTriangle(thePoint1: Graphic3d_ZLayerId, thePoint2: Graphic3d_ZLayerId, thePoint3: Graphic3d_ZLayerId, theEdges: any): void;
  AddLink(theFirstNode: Graphic3d_ZLayerId, theLastNode: Graphic3d_ZLayerId, theLinkIndex: Graphic3d_ZLayerId, theLinkOri: Standard_Boolean): void;
  Legalize(theLinkIndex: Graphic3d_ZLayerId): void;
  EraseItemsConnectedTo(theNodeIndex: Graphic3d_ZLayerId): void;
  CleanFrontierLinks(): void;
  EraseTriangles(theTriangles: any, theLoopEdges: any): void;
  EraseTriangle(theTriangleIndex: Graphic3d_ZLayerId, theLoopEdges: any): void;
  EraseFreeLinks_1(): void;
  EraseFreeLinks_2(theLinks: any): void;
  GetEdgesByType(theEdgeType: BRepMesh_DegreeOfFreedom): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_Vertex {
  Initialize(theUV: gp_XY, theLocation3d: Graphic3d_ZLayerId, theMovability: BRepMesh_DegreeOfFreedom): void;
  Coord(): gp_XY;
  ChangeCoord(): gp_XY;
  Location3d(): Graphic3d_ZLayerId;
  Movability(): BRepMesh_DegreeOfFreedom;
  SetMovability(theMovability: BRepMesh_DegreeOfFreedom): void;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsEqual(theOther: BRepMesh_Vertex): Standard_Boolean;
  delete(): void;
}

  export declare class BRepMesh_Vertex_1 extends BRepMesh_Vertex {
    constructor();
  }

  export declare class BRepMesh_Vertex_2 extends BRepMesh_Vertex {
    constructor(theUV: gp_XY, theLocation3d: Graphic3d_ZLayerId, theMovability: BRepMesh_DegreeOfFreedom);
  }

  export declare class BRepMesh_Vertex_3 extends BRepMesh_Vertex {
    constructor(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theMovability: BRepMesh_DegreeOfFreedom);
  }

export declare class BRepMesh_ModelPostProcessor extends IMeshTools_ModelAlgo {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_FastDiscret {
  constructor();
  delete(): void;
}

export declare class BRepMesh_GeomTool {
  AddPoint(thePoint: gp_Pnt, theParam: Quantity_AbsorbedDose, theIsReplace: Standard_Boolean): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  Value_1(theIndex: Graphic3d_ZLayerId, theIsoParam: Quantity_AbsorbedDose, theParam: Quantity_AbsorbedDose, thePoint: gp_Pnt, theUV: gp_Pnt2d): Standard_Boolean;
  Value_2(theIndex: Graphic3d_ZLayerId, theSurface: Handle_BRepAdaptor_HSurface, theParam: Quantity_AbsorbedDose, thePoint: gp_Pnt, theUV: gp_Pnt2d): Standard_Boolean;
  static Normal(theSurface: Handle_BRepAdaptor_HSurface, theParamU: Quantity_AbsorbedDose, theParamV: Quantity_AbsorbedDose, thePoint: gp_Pnt, theNormal: gp_Dir): Standard_Boolean;
  static IntLinLin(theStartPnt1: gp_XY, theEndPnt1: gp_XY, theStartPnt2: gp_XY, theEndPnt2: gp_XY, theIntPnt: gp_XY, theParamOnSegment: any): any;
  static IntSegSeg(theStartPnt1: gp_XY, theEndPnt1: gp_XY, theStartPnt2: gp_XY, theEndPnt2: gp_XY, isConsiderEndPointTouch: Standard_Boolean, isConsiderPointOnSegment: Standard_Boolean, theIntPnt: gp_Pnt2d): any;
  static SquareDeflectionOfSegment(theFirstPoint: gp_Pnt, theLastPoint: gp_Pnt, theMidPoint: gp_Pnt): Quantity_AbsorbedDose;
  static CellsCount(theSurface: Handle_Adaptor3d_HSurface, theVerticesNb: Graphic3d_ZLayerId, theDeflection: Quantity_AbsorbedDose, theRangeSplitter: BRepMesh_DefaultRangeSplitter): MeshVS_NodePair;
  delete(): void;
}

  export declare class BRepMesh_GeomTool_1 extends BRepMesh_GeomTool {
    constructor(theCurve: BRepAdaptor_Curve, theFirstParam: Quantity_AbsorbedDose, theLastParam: Quantity_AbsorbedDose, theLinDeflection: Quantity_AbsorbedDose, theAngDeflection: Quantity_AbsorbedDose, theMinPointsNb: Graphic3d_ZLayerId, theMinSize: Quantity_AbsorbedDose);
  }

  export declare class BRepMesh_GeomTool_2 extends BRepMesh_GeomTool {
    constructor(theSurface: Handle_BRepAdaptor_HSurface, theIsoType: GeomAbs_IsoType, theParamIso: Quantity_AbsorbedDose, theFirstParam: Quantity_AbsorbedDose, theLastParam: Quantity_AbsorbedDose, theLinDeflection: Quantity_AbsorbedDose, theAngDeflection: Quantity_AbsorbedDose, theMinPointsNb: Graphic3d_ZLayerId, theMinSize: Quantity_AbsorbedDose);
  }

export declare class BRepMesh_Circle {
  SetLocation(theLocation: gp_XY): void;
  SetRadius(theRadius: Quantity_AbsorbedDose): void;
  Location(): gp_XY;
  Radius(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepMesh_Circle_1 extends BRepMesh_Circle {
    constructor();
  }

  export declare class BRepMesh_Circle_2 extends BRepMesh_Circle {
    constructor(theLocation: gp_XY, theRadius: Quantity_AbsorbedDose);
  }

export declare class BRepMesh_MeshAlgoFactory extends IMeshTools_MeshAlgoFactory {
  constructor()
  GetAlgo(theSurfaceType: GeomAbs_SurfaceType, theParameters: IMeshTools_Parameters): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_FaceDiscret extends IMeshTools_ModelAlgo {
  constructor(theAlgoFactory: any)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_CylinderRangeSplitter extends BRepMesh_DefaultRangeSplitter {
  constructor()
  Reset(theDFace: any, theParameters: IMeshTools_Parameters): void;
  GenerateSurfaceNodes(theParameters: IMeshTools_Parameters): any;
  delete(): void;
}

export declare class BRepMesh_DelaunayBaseMeshAlgo extends BRepMesh_ConstrainedBaseMeshAlgo {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type BRepMesh_FactoryError = {
  BRepMesh_FE_NOERROR: {};
  BRepMesh_FE_LIBRARYNOTFOUND: {};
  BRepMesh_FE_FUNCTIONNOTFOUND: {};
  BRepMesh_FE_CANNOTCREATEALGO: {};
}

export declare class BRepMesh_ConeRangeSplitter extends BRepMesh_DefaultRangeSplitter {
  constructor()
  GetSplitSteps(theParameters: IMeshTools_Parameters, theStepsNb: MeshVS_NodePair): any;
  GenerateSurfaceNodes(theParameters: IMeshTools_Parameters): any;
  delete(): void;
}

export declare class BRepMesh_Deflection extends Standard_Transient {
  constructor();
  static ComputeAbsoluteDeflection(theShape: TopoDS_Shape, theRelativeDeflection: Quantity_AbsorbedDose, theMaxShapeSize: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static ComputeDeflection_1(theDEdge: any, theMaxShapeSize: Quantity_AbsorbedDose, theParameters: IMeshTools_Parameters): void;
  static ComputeDeflection_2(theDWire: any, theParameters: IMeshTools_Parameters): void;
  static ComputeDeflection_3(theDFace: any, theParameters: IMeshTools_Parameters): void;
  static IsConsistent(theCurrent: Quantity_AbsorbedDose, theRequired: Quantity_AbsorbedDose, theAllowDecrease: Standard_Boolean, theRatio: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_TorusRangeSplitter extends BRepMesh_UVParamRangeSplitter {
  constructor()
  GenerateSurfaceNodes(theParameters: IMeshTools_Parameters): any;
  AddPoint(thePoint: gp_Pnt2d): void;
  delete(): void;
}

export declare class BRepMesh_FaceChecker extends Standard_Transient {
  constructor(theFace: any, theParameters: IMeshTools_Parameters)
  Perform(): Standard_Boolean;
  GetIntersectingEdges(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMesh_NURBSRangeSplitter extends BRepMesh_UVParamRangeSplitter {
  constructor()
  AdjustRange(): void;
  GenerateSurfaceNodes(theParameters: IMeshTools_Parameters): any;
  delete(): void;
}

export declare class Handle_Quantity_DateDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Quantity_DateDefinitionError): void;
  get(): Quantity_DateDefinitionError;
  delete(): void;
}

  export declare class Handle_Quantity_DateDefinitionError_1 extends Handle_Quantity_DateDefinitionError {
    constructor();
  }

  export declare class Handle_Quantity_DateDefinitionError_2 extends Handle_Quantity_DateDefinitionError {
    constructor(thePtr: Quantity_DateDefinitionError);
  }

  export declare class Handle_Quantity_DateDefinitionError_3 extends Handle_Quantity_DateDefinitionError {
    constructor(theHandle: Handle_Quantity_DateDefinitionError);
  }

  export declare class Handle_Quantity_DateDefinitionError_4 extends Handle_Quantity_DateDefinitionError {
    constructor(theHandle: Handle_Quantity_DateDefinitionError);
  }

export declare class Quantity_DateDefinitionError extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Quantity_DateDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Quantity_DateDefinitionError_1 extends Quantity_DateDefinitionError {
    constructor();
  }

  export declare class Quantity_DateDefinitionError_2 extends Quantity_DateDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare type Quantity_PhysicalQuantity = {
  Quantity_MASS: {};
  Quantity_PLANEANGLE: {};
  Quantity_SOLIDANGLE: {};
  Quantity_LENGTH: {};
  Quantity_AREA: {};
  Quantity_VOLUME: {};
  Quantity_SPEED: {};
  Quantity_VELOCITY: {};
  Quantity_ACCELERATION: {};
  Quantity_ANGULARVELOCITY: {};
  Quantity_FREQUENCY: {};
  Quantity_TEMPERATURE: {};
  Quantity_AMOUNTOFSUBSTANCE: {};
  Quantity_DENSITY: {};
  Quantity_MASSFLOW: {};
  Quantity_VOLUMEFLOW: {};
  Quantity_CONSUMPTION: {};
  Quantity_MOMENTUM: {};
  Quantity_KINETICMOMENT: {};
  Quantity_MOMENTOFINERTIA: {};
  Quantity_FORCE: {};
  Quantity_MOMENTOFAFORCE: {};
  Quantity_TORQUE: {};
  Quantity_WEIGHT: {};
  Quantity_PRESSURE: {};
  Quantity_VISCOSITY: {};
  Quantity_KINEMATICVISCOSITY: {};
  Quantity_ENERGY: {};
  Quantity_WORK: {};
  Quantity_POWER: {};
  Quantity_SURFACETENSION: {};
  Quantity_COEFFICIENTOFEXPANSION: {};
  Quantity_THERMALCONDUCTIVITY: {};
  Quantity_SPECIFICHEATCAPACITY: {};
  Quantity_ENTROPY: {};
  Quantity_ENTHALPY: {};
  Quantity_LUMINOUSINTENSITY: {};
  Quantity_LUMINOUSFLUX: {};
  Quantity_LUMINANCE: {};
  Quantity_ILLUMINANCE: {};
  Quantity_LUMINOUSEXPOSITION: {};
  Quantity_LUMINOUSEFFICACITY: {};
  Quantity_ELECTRICCHARGE: {};
  Quantity_ELECTRICCURRENT: {};
  Quantity_ELECTRICFIELDSTRENGTH: {};
  Quantity_ELECTRICPOTENTIAL: {};
  Quantity_ELECTRICCAPACITANCE: {};
  Quantity_MAGNETICFLUX: {};
  Quantity_MAGNETICFLUXDENSITY: {};
  Quantity_MAGNETICFIELDSTRENGTH: {};
  Quantity_RELUCTANCE: {};
  Quantity_RESISTANCE: {};
  Quantity_INDUCTANCE: {};
  Quantity_CAPACITANCE: {};
  Quantity_IMPEDANCE: {};
  Quantity_ADMITTANCE: {};
  Quantity_RESISTIVITY: {};
  Quantity_CONDUCTIVITY: {};
  Quantity_MOLARMASS: {};
  Quantity_MOLARVOLUME: {};
  Quantity_CONCENTRATION: {};
  Quantity_MOLARCONCENTRATION: {};
  Quantity_MOLARITY: {};
  Quantity_SOUNDINTENSITY: {};
  Quantity_ACOUSTICINTENSITY: {};
  Quantity_ACTIVITY: {};
  Quantity_ABSORBEDDOSE: {};
  Quantity_DOSEEQUIVALENT: {};
}

export declare type Quantity_TypeOfColor = {
  Quantity_TOC_RGB: {};
  Quantity_TOC_sRGB: {};
  Quantity_TOC_HLS: {};
  Quantity_TOC_CIELab: {};
  Quantity_TOC_CIELch: {};
}

export declare class Quantity_ColorHasher {
  constructor();
  static HashCode(theColor: Quantity_Color, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(theColor1: Quantity_Color, theColor2: Quantity_Color): Standard_Boolean;
  delete(): void;
}

export declare type Quantity_NameOfColor = {
  Quantity_NOC_BLACK: {};
  Quantity_NOC_MATRABLUE: {};
  Quantity_NOC_MATRAGRAY: {};
  Quantity_NOC_ALICEBLUE: {};
  Quantity_NOC_ANTIQUEWHITE: {};
  Quantity_NOC_ANTIQUEWHITE1: {};
  Quantity_NOC_ANTIQUEWHITE2: {};
  Quantity_NOC_ANTIQUEWHITE3: {};
  Quantity_NOC_ANTIQUEWHITE4: {};
  Quantity_NOC_AQUAMARINE1: {};
  Quantity_NOC_AQUAMARINE2: {};
  Quantity_NOC_AQUAMARINE4: {};
  Quantity_NOC_AZURE: {};
  Quantity_NOC_AZURE2: {};
  Quantity_NOC_AZURE3: {};
  Quantity_NOC_AZURE4: {};
  Quantity_NOC_BEIGE: {};
  Quantity_NOC_BISQUE: {};
  Quantity_NOC_BISQUE2: {};
  Quantity_NOC_BISQUE3: {};
  Quantity_NOC_BISQUE4: {};
  Quantity_NOC_BLANCHEDALMOND: {};
  Quantity_NOC_BLUE: {};
  Quantity_NOC_BLUE1: {};
  Quantity_NOC_BLUE2: {};
  Quantity_NOC_BLUE3: {};
  Quantity_NOC_BLUE4: {};
  Quantity_NOC_BLUEVIOLET: {};
  Quantity_NOC_BROWN: {};
  Quantity_NOC_BROWN1: {};
  Quantity_NOC_BROWN2: {};
  Quantity_NOC_BROWN3: {};
  Quantity_NOC_BROWN4: {};
  Quantity_NOC_BURLYWOOD: {};
  Quantity_NOC_BURLYWOOD1: {};
  Quantity_NOC_BURLYWOOD2: {};
  Quantity_NOC_BURLYWOOD3: {};
  Quantity_NOC_BURLYWOOD4: {};
  Quantity_NOC_CADETBLUE: {};
  Quantity_NOC_CADETBLUE1: {};
  Quantity_NOC_CADETBLUE2: {};
  Quantity_NOC_CADETBLUE3: {};
  Quantity_NOC_CADETBLUE4: {};
  Quantity_NOC_CHARTREUSE: {};
  Quantity_NOC_CHARTREUSE1: {};
  Quantity_NOC_CHARTREUSE2: {};
  Quantity_NOC_CHARTREUSE3: {};
  Quantity_NOC_CHARTREUSE4: {};
  Quantity_NOC_CHOCOLATE: {};
  Quantity_NOC_CHOCOLATE1: {};
  Quantity_NOC_CHOCOLATE2: {};
  Quantity_NOC_CHOCOLATE3: {};
  Quantity_NOC_CHOCOLATE4: {};
  Quantity_NOC_CORAL: {};
  Quantity_NOC_CORAL1: {};
  Quantity_NOC_CORAL2: {};
  Quantity_NOC_CORAL3: {};
  Quantity_NOC_CORAL4: {};
  Quantity_NOC_CORNFLOWERBLUE: {};
  Quantity_NOC_CORNSILK1: {};
  Quantity_NOC_CORNSILK2: {};
  Quantity_NOC_CORNSILK3: {};
  Quantity_NOC_CORNSILK4: {};
  Quantity_NOC_CYAN: {};
  Quantity_NOC_CYAN1: {};
  Quantity_NOC_CYAN2: {};
  Quantity_NOC_CYAN3: {};
  Quantity_NOC_CYAN4: {};
  Quantity_NOC_DARKGOLDENROD: {};
  Quantity_NOC_DARKGOLDENROD1: {};
  Quantity_NOC_DARKGOLDENROD2: {};
  Quantity_NOC_DARKGOLDENROD3: {};
  Quantity_NOC_DARKGOLDENROD4: {};
  Quantity_NOC_DARKGREEN: {};
  Quantity_NOC_DARKKHAKI: {};
  Quantity_NOC_DARKOLIVEGREEN: {};
  Quantity_NOC_DARKOLIVEGREEN1: {};
  Quantity_NOC_DARKOLIVEGREEN2: {};
  Quantity_NOC_DARKOLIVEGREEN3: {};
  Quantity_NOC_DARKOLIVEGREEN4: {};
  Quantity_NOC_DARKORANGE: {};
  Quantity_NOC_DARKORANGE1: {};
  Quantity_NOC_DARKORANGE2: {};
  Quantity_NOC_DARKORANGE3: {};
  Quantity_NOC_DARKORANGE4: {};
  Quantity_NOC_DARKORCHID: {};
  Quantity_NOC_DARKORCHID1: {};
  Quantity_NOC_DARKORCHID2: {};
  Quantity_NOC_DARKORCHID3: {};
  Quantity_NOC_DARKORCHID4: {};
  Quantity_NOC_DARKSALMON: {};
  Quantity_NOC_DARKSEAGREEN: {};
  Quantity_NOC_DARKSEAGREEN1: {};
  Quantity_NOC_DARKSEAGREEN2: {};
  Quantity_NOC_DARKSEAGREEN3: {};
  Quantity_NOC_DARKSEAGREEN4: {};
  Quantity_NOC_DARKSLATEBLUE: {};
  Quantity_NOC_DARKSLATEGRAY1: {};
  Quantity_NOC_DARKSLATEGRAY2: {};
  Quantity_NOC_DARKSLATEGRAY3: {};
  Quantity_NOC_DARKSLATEGRAY4: {};
  Quantity_NOC_DARKSLATEGRAY: {};
  Quantity_NOC_DARKTURQUOISE: {};
  Quantity_NOC_DARKVIOLET: {};
  Quantity_NOC_DEEPPINK: {};
  Quantity_NOC_DEEPPINK2: {};
  Quantity_NOC_DEEPPINK3: {};
  Quantity_NOC_DEEPPINK4: {};
  Quantity_NOC_DEEPSKYBLUE1: {};
  Quantity_NOC_DEEPSKYBLUE2: {};
  Quantity_NOC_DEEPSKYBLUE3: {};
  Quantity_NOC_DEEPSKYBLUE4: {};
  Quantity_NOC_DODGERBLUE1: {};
  Quantity_NOC_DODGERBLUE2: {};
  Quantity_NOC_DODGERBLUE3: {};
  Quantity_NOC_DODGERBLUE4: {};
  Quantity_NOC_FIREBRICK: {};
  Quantity_NOC_FIREBRICK1: {};
  Quantity_NOC_FIREBRICK2: {};
  Quantity_NOC_FIREBRICK3: {};
  Quantity_NOC_FIREBRICK4: {};
  Quantity_NOC_FLORALWHITE: {};
  Quantity_NOC_FORESTGREEN: {};
  Quantity_NOC_GAINSBORO: {};
  Quantity_NOC_GHOSTWHITE: {};
  Quantity_NOC_GOLD: {};
  Quantity_NOC_GOLD1: {};
  Quantity_NOC_GOLD2: {};
  Quantity_NOC_GOLD3: {};
  Quantity_NOC_GOLD4: {};
  Quantity_NOC_GOLDENROD: {};
  Quantity_NOC_GOLDENROD1: {};
  Quantity_NOC_GOLDENROD2: {};
  Quantity_NOC_GOLDENROD3: {};
  Quantity_NOC_GOLDENROD4: {};
  Quantity_NOC_GRAY: {};
  Quantity_NOC_GRAY0: {};
  Quantity_NOC_GRAY1: {};
  Quantity_NOC_GRAY2: {};
  Quantity_NOC_GRAY3: {};
  Quantity_NOC_GRAY4: {};
  Quantity_NOC_GRAY5: {};
  Quantity_NOC_GRAY6: {};
  Quantity_NOC_GRAY7: {};
  Quantity_NOC_GRAY8: {};
  Quantity_NOC_GRAY9: {};
  Quantity_NOC_GRAY10: {};
  Quantity_NOC_GRAY11: {};
  Quantity_NOC_GRAY12: {};
  Quantity_NOC_GRAY13: {};
  Quantity_NOC_GRAY14: {};
  Quantity_NOC_GRAY15: {};
  Quantity_NOC_GRAY16: {};
  Quantity_NOC_GRAY17: {};
  Quantity_NOC_GRAY18: {};
  Quantity_NOC_GRAY19: {};
  Quantity_NOC_GRAY20: {};
  Quantity_NOC_GRAY21: {};
  Quantity_NOC_GRAY22: {};
  Quantity_NOC_GRAY23: {};
  Quantity_NOC_GRAY24: {};
  Quantity_NOC_GRAY25: {};
  Quantity_NOC_GRAY26: {};
  Quantity_NOC_GRAY27: {};
  Quantity_NOC_GRAY28: {};
  Quantity_NOC_GRAY29: {};
  Quantity_NOC_GRAY30: {};
  Quantity_NOC_GRAY31: {};
  Quantity_NOC_GRAY32: {};
  Quantity_NOC_GRAY33: {};
  Quantity_NOC_GRAY34: {};
  Quantity_NOC_GRAY35: {};
  Quantity_NOC_GRAY36: {};
  Quantity_NOC_GRAY37: {};
  Quantity_NOC_GRAY38: {};
  Quantity_NOC_GRAY39: {};
  Quantity_NOC_GRAY40: {};
  Quantity_NOC_GRAY41: {};
  Quantity_NOC_GRAY42: {};
  Quantity_NOC_GRAY43: {};
  Quantity_NOC_GRAY44: {};
  Quantity_NOC_GRAY45: {};
  Quantity_NOC_GRAY46: {};
  Quantity_NOC_GRAY47: {};
  Quantity_NOC_GRAY48: {};
  Quantity_NOC_GRAY49: {};
  Quantity_NOC_GRAY50: {};
  Quantity_NOC_GRAY51: {};
  Quantity_NOC_GRAY52: {};
  Quantity_NOC_GRAY53: {};
  Quantity_NOC_GRAY54: {};
  Quantity_NOC_GRAY55: {};
  Quantity_NOC_GRAY56: {};
  Quantity_NOC_GRAY57: {};
  Quantity_NOC_GRAY58: {};
  Quantity_NOC_GRAY59: {};
  Quantity_NOC_GRAY60: {};
  Quantity_NOC_GRAY61: {};
  Quantity_NOC_GRAY62: {};
  Quantity_NOC_GRAY63: {};
  Quantity_NOC_GRAY64: {};
  Quantity_NOC_GRAY65: {};
  Quantity_NOC_GRAY66: {};
  Quantity_NOC_GRAY67: {};
  Quantity_NOC_GRAY68: {};
  Quantity_NOC_GRAY69: {};
  Quantity_NOC_GRAY70: {};
  Quantity_NOC_GRAY71: {};
  Quantity_NOC_GRAY72: {};
  Quantity_NOC_GRAY73: {};
  Quantity_NOC_GRAY74: {};
  Quantity_NOC_GRAY75: {};
  Quantity_NOC_GRAY76: {};
  Quantity_NOC_GRAY77: {};
  Quantity_NOC_GRAY78: {};
  Quantity_NOC_GRAY79: {};
  Quantity_NOC_GRAY80: {};
  Quantity_NOC_GRAY81: {};
  Quantity_NOC_GRAY82: {};
  Quantity_NOC_GRAY83: {};
  Quantity_NOC_GRAY85: {};
  Quantity_NOC_GRAY86: {};
  Quantity_NOC_GRAY87: {};
  Quantity_NOC_GRAY88: {};
  Quantity_NOC_GRAY89: {};
  Quantity_NOC_GRAY90: {};
  Quantity_NOC_GRAY91: {};
  Quantity_NOC_GRAY92: {};
  Quantity_NOC_GRAY93: {};
  Quantity_NOC_GRAY94: {};
  Quantity_NOC_GRAY95: {};
  Quantity_NOC_GRAY97: {};
  Quantity_NOC_GRAY98: {};
  Quantity_NOC_GRAY99: {};
  Quantity_NOC_GREEN: {};
  Quantity_NOC_GREEN1: {};
  Quantity_NOC_GREEN2: {};
  Quantity_NOC_GREEN3: {};
  Quantity_NOC_GREEN4: {};
  Quantity_NOC_GREENYELLOW: {};
  Quantity_NOC_HONEYDEW: {};
  Quantity_NOC_HONEYDEW2: {};
  Quantity_NOC_HONEYDEW3: {};
  Quantity_NOC_HONEYDEW4: {};
  Quantity_NOC_HOTPINK: {};
  Quantity_NOC_HOTPINK1: {};
  Quantity_NOC_HOTPINK2: {};
  Quantity_NOC_HOTPINK3: {};
  Quantity_NOC_HOTPINK4: {};
  Quantity_NOC_INDIANRED: {};
  Quantity_NOC_INDIANRED1: {};
  Quantity_NOC_INDIANRED2: {};
  Quantity_NOC_INDIANRED3: {};
  Quantity_NOC_INDIANRED4: {};
  Quantity_NOC_IVORY: {};
  Quantity_NOC_IVORY2: {};
  Quantity_NOC_IVORY3: {};
  Quantity_NOC_IVORY4: {};
  Quantity_NOC_KHAKI: {};
  Quantity_NOC_KHAKI1: {};
  Quantity_NOC_KHAKI2: {};
  Quantity_NOC_KHAKI3: {};
  Quantity_NOC_KHAKI4: {};
  Quantity_NOC_LAVENDER: {};
  Quantity_NOC_LAVENDERBLUSH1: {};
  Quantity_NOC_LAVENDERBLUSH2: {};
  Quantity_NOC_LAVENDERBLUSH3: {};
  Quantity_NOC_LAVENDERBLUSH4: {};
  Quantity_NOC_LAWNGREEN: {};
  Quantity_NOC_LEMONCHIFFON1: {};
  Quantity_NOC_LEMONCHIFFON2: {};
  Quantity_NOC_LEMONCHIFFON3: {};
  Quantity_NOC_LEMONCHIFFON4: {};
  Quantity_NOC_LIGHTBLUE: {};
  Quantity_NOC_LIGHTBLUE1: {};
  Quantity_NOC_LIGHTBLUE2: {};
  Quantity_NOC_LIGHTBLUE3: {};
  Quantity_NOC_LIGHTBLUE4: {};
  Quantity_NOC_LIGHTCORAL: {};
  Quantity_NOC_LIGHTCYAN: {};
  Quantity_NOC_LIGHTCYAN1: {};
  Quantity_NOC_LIGHTCYAN2: {};
  Quantity_NOC_LIGHTCYAN3: {};
  Quantity_NOC_LIGHTCYAN4: {};
  Quantity_NOC_LIGHTGOLDENROD: {};
  Quantity_NOC_LIGHTGOLDENROD1: {};
  Quantity_NOC_LIGHTGOLDENROD2: {};
  Quantity_NOC_LIGHTGOLDENROD3: {};
  Quantity_NOC_LIGHTGOLDENROD4: {};
  Quantity_NOC_LIGHTGOLDENRODYELLOW: {};
  Quantity_NOC_LIGHTGRAY: {};
  Quantity_NOC_LIGHTPINK: {};
  Quantity_NOC_LIGHTPINK1: {};
  Quantity_NOC_LIGHTPINK2: {};
  Quantity_NOC_LIGHTPINK3: {};
  Quantity_NOC_LIGHTPINK4: {};
  Quantity_NOC_LIGHTSALMON1: {};
  Quantity_NOC_LIGHTSALMON2: {};
  Quantity_NOC_LIGHTSALMON3: {};
  Quantity_NOC_LIGHTSALMON4: {};
  Quantity_NOC_LIGHTSEAGREEN: {};
  Quantity_NOC_LIGHTSKYBLUE: {};
  Quantity_NOC_LIGHTSKYBLUE1: {};
  Quantity_NOC_LIGHTSKYBLUE2: {};
  Quantity_NOC_LIGHTSKYBLUE3: {};
  Quantity_NOC_LIGHTSKYBLUE4: {};
  Quantity_NOC_LIGHTSLATEBLUE: {};
  Quantity_NOC_LIGHTSLATEGRAY: {};
  Quantity_NOC_LIGHTSTEELBLUE: {};
  Quantity_NOC_LIGHTSTEELBLUE1: {};
  Quantity_NOC_LIGHTSTEELBLUE2: {};
  Quantity_NOC_LIGHTSTEELBLUE3: {};
  Quantity_NOC_LIGHTSTEELBLUE4: {};
  Quantity_NOC_LIGHTYELLOW: {};
  Quantity_NOC_LIGHTYELLOW2: {};
  Quantity_NOC_LIGHTYELLOW3: {};
  Quantity_NOC_LIGHTYELLOW4: {};
  Quantity_NOC_LIMEGREEN: {};
  Quantity_NOC_LINEN: {};
  Quantity_NOC_MAGENTA: {};
  Quantity_NOC_MAGENTA1: {};
  Quantity_NOC_MAGENTA2: {};
  Quantity_NOC_MAGENTA3: {};
  Quantity_NOC_MAGENTA4: {};
  Quantity_NOC_MAROON: {};
  Quantity_NOC_MAROON1: {};
  Quantity_NOC_MAROON2: {};
  Quantity_NOC_MAROON3: {};
  Quantity_NOC_MAROON4: {};
  Quantity_NOC_MEDIUMAQUAMARINE: {};
  Quantity_NOC_MEDIUMORCHID: {};
  Quantity_NOC_MEDIUMORCHID1: {};
  Quantity_NOC_MEDIUMORCHID2: {};
  Quantity_NOC_MEDIUMORCHID3: {};
  Quantity_NOC_MEDIUMORCHID4: {};
  Quantity_NOC_MEDIUMPURPLE: {};
  Quantity_NOC_MEDIUMPURPLE1: {};
  Quantity_NOC_MEDIUMPURPLE2: {};
  Quantity_NOC_MEDIUMPURPLE3: {};
  Quantity_NOC_MEDIUMPURPLE4: {};
  Quantity_NOC_MEDIUMSEAGREEN: {};
  Quantity_NOC_MEDIUMSLATEBLUE: {};
  Quantity_NOC_MEDIUMSPRINGGREEN: {};
  Quantity_NOC_MEDIUMTURQUOISE: {};
  Quantity_NOC_MEDIUMVIOLETRED: {};
  Quantity_NOC_MIDNIGHTBLUE: {};
  Quantity_NOC_MINTCREAM: {};
  Quantity_NOC_MISTYROSE: {};
  Quantity_NOC_MISTYROSE2: {};
  Quantity_NOC_MISTYROSE3: {};
  Quantity_NOC_MISTYROSE4: {};
  Quantity_NOC_MOCCASIN: {};
  Quantity_NOC_NAVAJOWHITE1: {};
  Quantity_NOC_NAVAJOWHITE2: {};
  Quantity_NOC_NAVAJOWHITE3: {};
  Quantity_NOC_NAVAJOWHITE4: {};
  Quantity_NOC_NAVYBLUE: {};
  Quantity_NOC_OLDLACE: {};
  Quantity_NOC_OLIVEDRAB: {};
  Quantity_NOC_OLIVEDRAB1: {};
  Quantity_NOC_OLIVEDRAB2: {};
  Quantity_NOC_OLIVEDRAB3: {};
  Quantity_NOC_OLIVEDRAB4: {};
  Quantity_NOC_ORANGE: {};
  Quantity_NOC_ORANGE1: {};
  Quantity_NOC_ORANGE2: {};
  Quantity_NOC_ORANGE3: {};
  Quantity_NOC_ORANGE4: {};
  Quantity_NOC_ORANGERED: {};
  Quantity_NOC_ORANGERED1: {};
  Quantity_NOC_ORANGERED2: {};
  Quantity_NOC_ORANGERED3: {};
  Quantity_NOC_ORANGERED4: {};
  Quantity_NOC_ORCHID: {};
  Quantity_NOC_ORCHID1: {};
  Quantity_NOC_ORCHID2: {};
  Quantity_NOC_ORCHID3: {};
  Quantity_NOC_ORCHID4: {};
  Quantity_NOC_PALEGOLDENROD: {};
  Quantity_NOC_PALEGREEN: {};
  Quantity_NOC_PALEGREEN1: {};
  Quantity_NOC_PALEGREEN2: {};
  Quantity_NOC_PALEGREEN3: {};
  Quantity_NOC_PALEGREEN4: {};
  Quantity_NOC_PALETURQUOISE: {};
  Quantity_NOC_PALETURQUOISE1: {};
  Quantity_NOC_PALETURQUOISE2: {};
  Quantity_NOC_PALETURQUOISE3: {};
  Quantity_NOC_PALETURQUOISE4: {};
  Quantity_NOC_PALEVIOLETRED: {};
  Quantity_NOC_PALEVIOLETRED1: {};
  Quantity_NOC_PALEVIOLETRED2: {};
  Quantity_NOC_PALEVIOLETRED3: {};
  Quantity_NOC_PALEVIOLETRED4: {};
  Quantity_NOC_PAPAYAWHIP: {};
  Quantity_NOC_PEACHPUFF: {};
  Quantity_NOC_PEACHPUFF2: {};
  Quantity_NOC_PEACHPUFF3: {};
  Quantity_NOC_PEACHPUFF4: {};
  Quantity_NOC_PERU: {};
  Quantity_NOC_PINK: {};
  Quantity_NOC_PINK1: {};
  Quantity_NOC_PINK2: {};
  Quantity_NOC_PINK3: {};
  Quantity_NOC_PINK4: {};
  Quantity_NOC_PLUM: {};
  Quantity_NOC_PLUM1: {};
  Quantity_NOC_PLUM2: {};
  Quantity_NOC_PLUM3: {};
  Quantity_NOC_PLUM4: {};
  Quantity_NOC_POWDERBLUE: {};
  Quantity_NOC_PURPLE: {};
  Quantity_NOC_PURPLE1: {};
  Quantity_NOC_PURPLE2: {};
  Quantity_NOC_PURPLE3: {};
  Quantity_NOC_PURPLE4: {};
  Quantity_NOC_RED: {};
  Quantity_NOC_RED1: {};
  Quantity_NOC_RED2: {};
  Quantity_NOC_RED3: {};
  Quantity_NOC_RED4: {};
  Quantity_NOC_ROSYBROWN: {};
  Quantity_NOC_ROSYBROWN1: {};
  Quantity_NOC_ROSYBROWN2: {};
  Quantity_NOC_ROSYBROWN3: {};
  Quantity_NOC_ROSYBROWN4: {};
  Quantity_NOC_ROYALBLUE: {};
  Quantity_NOC_ROYALBLUE1: {};
  Quantity_NOC_ROYALBLUE2: {};
  Quantity_NOC_ROYALBLUE3: {};
  Quantity_NOC_ROYALBLUE4: {};
  Quantity_NOC_SADDLEBROWN: {};
  Quantity_NOC_SALMON: {};
  Quantity_NOC_SALMON1: {};
  Quantity_NOC_SALMON2: {};
  Quantity_NOC_SALMON3: {};
  Quantity_NOC_SALMON4: {};
  Quantity_NOC_SANDYBROWN: {};
  Quantity_NOC_SEAGREEN: {};
  Quantity_NOC_SEAGREEN1: {};
  Quantity_NOC_SEAGREEN2: {};
  Quantity_NOC_SEAGREEN3: {};
  Quantity_NOC_SEAGREEN4: {};
  Quantity_NOC_SEASHELL: {};
  Quantity_NOC_SEASHELL2: {};
  Quantity_NOC_SEASHELL3: {};
  Quantity_NOC_SEASHELL4: {};
  Quantity_NOC_BEET: {};
  Quantity_NOC_TEAL: {};
  Quantity_NOC_SIENNA: {};
  Quantity_NOC_SIENNA1: {};
  Quantity_NOC_SIENNA2: {};
  Quantity_NOC_SIENNA3: {};
  Quantity_NOC_SIENNA4: {};
  Quantity_NOC_SKYBLUE: {};
  Quantity_NOC_SKYBLUE1: {};
  Quantity_NOC_SKYBLUE2: {};
  Quantity_NOC_SKYBLUE3: {};
  Quantity_NOC_SKYBLUE4: {};
  Quantity_NOC_SLATEBLUE: {};
  Quantity_NOC_SLATEBLUE1: {};
  Quantity_NOC_SLATEBLUE2: {};
  Quantity_NOC_SLATEBLUE3: {};
  Quantity_NOC_SLATEBLUE4: {};
  Quantity_NOC_SLATEGRAY1: {};
  Quantity_NOC_SLATEGRAY2: {};
  Quantity_NOC_SLATEGRAY3: {};
  Quantity_NOC_SLATEGRAY4: {};
  Quantity_NOC_SLATEGRAY: {};
  Quantity_NOC_SNOW: {};
  Quantity_NOC_SNOW2: {};
  Quantity_NOC_SNOW3: {};
  Quantity_NOC_SNOW4: {};
  Quantity_NOC_SPRINGGREEN: {};
  Quantity_NOC_SPRINGGREEN2: {};
  Quantity_NOC_SPRINGGREEN3: {};
  Quantity_NOC_SPRINGGREEN4: {};
  Quantity_NOC_STEELBLUE: {};
  Quantity_NOC_STEELBLUE1: {};
  Quantity_NOC_STEELBLUE2: {};
  Quantity_NOC_STEELBLUE3: {};
  Quantity_NOC_STEELBLUE4: {};
  Quantity_NOC_TAN: {};
  Quantity_NOC_TAN1: {};
  Quantity_NOC_TAN2: {};
  Quantity_NOC_TAN3: {};
  Quantity_NOC_TAN4: {};
  Quantity_NOC_THISTLE: {};
  Quantity_NOC_THISTLE1: {};
  Quantity_NOC_THISTLE2: {};
  Quantity_NOC_THISTLE3: {};
  Quantity_NOC_THISTLE4: {};
  Quantity_NOC_TOMATO: {};
  Quantity_NOC_TOMATO1: {};
  Quantity_NOC_TOMATO2: {};
  Quantity_NOC_TOMATO3: {};
  Quantity_NOC_TOMATO4: {};
  Quantity_NOC_TURQUOISE: {};
  Quantity_NOC_TURQUOISE1: {};
  Quantity_NOC_TURQUOISE2: {};
  Quantity_NOC_TURQUOISE3: {};
  Quantity_NOC_TURQUOISE4: {};
  Quantity_NOC_VIOLET: {};
  Quantity_NOC_VIOLETRED: {};
  Quantity_NOC_VIOLETRED1: {};
  Quantity_NOC_VIOLETRED2: {};
  Quantity_NOC_VIOLETRED3: {};
  Quantity_NOC_VIOLETRED4: {};
  Quantity_NOC_WHEAT: {};
  Quantity_NOC_WHEAT1: {};
  Quantity_NOC_WHEAT2: {};
  Quantity_NOC_WHEAT3: {};
  Quantity_NOC_WHEAT4: {};
  Quantity_NOC_WHITESMOKE: {};
  Quantity_NOC_YELLOW: {};
  Quantity_NOC_YELLOW1: {};
  Quantity_NOC_YELLOW2: {};
  Quantity_NOC_YELLOW3: {};
  Quantity_NOC_YELLOW4: {};
  Quantity_NOC_YELLOWGREEN: {};
  Quantity_NOC_WHITE: {};
}

export declare class Handle_Quantity_HArray1OfColor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Quantity_HArray1OfColor): void;
  get(): Quantity_HArray1OfColor;
  delete(): void;
}

  export declare class Handle_Quantity_HArray1OfColor_1 extends Handle_Quantity_HArray1OfColor {
    constructor();
  }

  export declare class Handle_Quantity_HArray1OfColor_2 extends Handle_Quantity_HArray1OfColor {
    constructor(thePtr: Quantity_HArray1OfColor);
  }

  export declare class Handle_Quantity_HArray1OfColor_3 extends Handle_Quantity_HArray1OfColor {
    constructor(theHandle: Handle_Quantity_HArray1OfColor);
  }

  export declare class Handle_Quantity_HArray1OfColor_4 extends Handle_Quantity_HArray1OfColor {
    constructor(theHandle: Handle_Quantity_HArray1OfColor);
  }

export declare class Quantity_Array1OfColor {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Quantity_Color): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Quantity_Array1OfColor): Quantity_Array1OfColor;
  Move(theOther: Quantity_Array1OfColor): Quantity_Array1OfColor;
  First(): Quantity_Color;
  ChangeFirst(): Quantity_Color;
  Last(): Quantity_Color;
  ChangeLast(): Quantity_Color;
  Value(theIndex: Standard_Integer): Quantity_Color;
  ChangeValue(theIndex: Standard_Integer): Quantity_Color;
  SetValue(theIndex: Standard_Integer, theItem: Quantity_Color): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Quantity_Array1OfColor_1 extends Quantity_Array1OfColor {
    constructor();
  }

  export declare class Quantity_Array1OfColor_2 extends Quantity_Array1OfColor {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Quantity_Array1OfColor_3 extends Quantity_Array1OfColor {
    constructor(theOther: Quantity_Array1OfColor);
  }

  export declare class Quantity_Array1OfColor_4 extends Quantity_Array1OfColor {
    constructor(theOther: Quantity_Array1OfColor);
  }

  export declare class Quantity_Array1OfColor_5 extends Quantity_Array1OfColor {
    constructor(theBegin: Quantity_Color, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Quantity_Date {
  Values(mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, yy: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): void;
  SetValues(mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, yy: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): void;
  Difference(anOther: Quantity_Date): Quantity_Period;
  Subtract(aPeriod: Quantity_Period): Quantity_Date;
  Add(aPeriod: Quantity_Period): Quantity_Date;
  Year(): Graphic3d_ZLayerId;
  Month(): Graphic3d_ZLayerId;
  Day(): Graphic3d_ZLayerId;
  Hour(): Graphic3d_ZLayerId;
  Minute(): Graphic3d_ZLayerId;
  Second(): Graphic3d_ZLayerId;
  MilliSecond(): Graphic3d_ZLayerId;
  MicroSecond(): Graphic3d_ZLayerId;
  IsEqual(anOther: Quantity_Date): Standard_Boolean;
  IsEarlier(anOther: Quantity_Date): Standard_Boolean;
  IsLater(anOther: Quantity_Date): Standard_Boolean;
  static IsValid(mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, yy: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): Standard_Boolean;
  static IsLeap(yy: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Quantity_Date_1 extends Quantity_Date {
    constructor();
  }

  export declare class Quantity_Date_2 extends Quantity_Date {
    constructor(mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, yyyy: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId);
  }

export declare class Quantity_Color {
  Name_1(): Quantity_NameOfColor;
  SetValues_1(theName: Quantity_NameOfColor): void;
  Rgb(): any;
  Values(theC1: Quantity_AbsorbedDose, theC2: Quantity_AbsorbedDose, theC3: Quantity_AbsorbedDose, theType: Quantity_TypeOfColor): void;
  SetValues_2(theC1: Quantity_AbsorbedDose, theC2: Quantity_AbsorbedDose, theC3: Quantity_AbsorbedDose, theType: Quantity_TypeOfColor): void;
  Red(): Quantity_AbsorbedDose;
  Green(): Quantity_AbsorbedDose;
  Blue(): Quantity_AbsorbedDose;
  Hue(): Quantity_AbsorbedDose;
  Light(): Quantity_AbsorbedDose;
  ChangeIntensity(theDelta: Quantity_AbsorbedDose): void;
  Saturation(): Quantity_AbsorbedDose;
  ChangeContrast(theDelta: Quantity_AbsorbedDose): void;
  IsDifferent(theOther: Quantity_Color): Standard_Boolean;
  IsEqual(theOther: Quantity_Color): Standard_Boolean;
  Distance(theColor: Quantity_Color): Quantity_AbsorbedDose;
  SquareDistance(theColor: Quantity_Color): Quantity_AbsorbedDose;
  Delta(theColor: Quantity_Color, DC: Quantity_AbsorbedDose, DI: Quantity_AbsorbedDose): void;
  DeltaE2000(theOther: Quantity_Color): Quantity_AbsorbedDose;
  static Name_2(theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): Quantity_NameOfColor;
  static StringName(theColor: Quantity_NameOfColor): Standard_CString;
  static ColorFromName_1(theName: Standard_CString, theColor: Quantity_NameOfColor): Standard_Boolean;
  static ColorFromName_2(theColorNameString: Standard_CString, theColor: Quantity_Color): Standard_Boolean;
  static ColorFromHex(theHexColorString: Standard_CString, theColor: Quantity_Color): Standard_Boolean;
  static ColorToHex(theColor: Quantity_Color, theToPrefixHash: Standard_Boolean): XCAFDoc_PartId;
  static Convert_sRGB_To_HLS(theRgb: NCollection_Vec3<float>): any;
  static Convert_HLS_To_sRGB(theHls: NCollection_Vec3<float>): any;
  static Convert_LinearRGB_To_HLS(theRgb: NCollection_Vec3<float>): any;
  static Convert_HLS_To_LinearRGB(theHls: NCollection_Vec3<float>): any;
  static Convert_LinearRGB_To_Lab(theRgb: NCollection_Vec3<float>): any;
  static Convert_Lab_To_Lch(theLab: NCollection_Vec3<float>): any;
  static Convert_Lab_To_LinearRGB(theLab: NCollection_Vec3<float>): any;
  static Convert_Lch_To_Lab(theLch: NCollection_Vec3<float>): any;
  static Color2argb(theColor: Quantity_Color, theARGB: Graphic3d_ZLayerId): void;
  static Argb2color(theARGB: Graphic3d_ZLayerId, theColor: Quantity_Color): void;
  static Convert_LinearRGB_To_sRGB_1(theLinearValue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Convert_LinearRGB_To_sRGB_2(theLinearValue: Standard_ShortReal): Standard_ShortReal;
  static Convert_sRGB_To_LinearRGB_1(thesRGBValue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Convert_sRGB_To_LinearRGB_2(thesRGBValue: Standard_ShortReal): Standard_ShortReal;
  static Convert_LinearRGB_To_sRGB_approx22_1(theLinearValue: Standard_ShortReal): Standard_ShortReal;
  static Convert_sRGB_To_LinearRGB_approx22_1(thesRGBValue: Standard_ShortReal): Standard_ShortReal;
  static Convert_LinearRGB_To_sRGB_approx22_2(theRGB: NCollection_Vec3<float>): any;
  static Convert_sRGB_To_LinearRGB_approx22_2(theRGB: NCollection_Vec3<float>): any;
  static HlsRgb(theH: Quantity_AbsorbedDose, theL: Quantity_AbsorbedDose, theS: Quantity_AbsorbedDose, theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose): void;
  static RgbHls(theR: Quantity_AbsorbedDose, theG: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose, theH: Quantity_AbsorbedDose, theL: Quantity_AbsorbedDose, theS: Quantity_AbsorbedDose): void;
  static Epsilon(): Quantity_AbsorbedDose;
  static SetEpsilon(theEpsilon: Quantity_AbsorbedDose): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Quantity_Color_1 extends Quantity_Color {
    constructor();
  }

  export declare class Quantity_Color_2 extends Quantity_Color {
    constructor(theName: Quantity_NameOfColor);
  }

  export declare class Quantity_Color_3 extends Quantity_Color {
    constructor(theC1: Quantity_AbsorbedDose, theC2: Quantity_AbsorbedDose, theC3: Quantity_AbsorbedDose, theType: Quantity_TypeOfColor);
  }

  export declare class Quantity_Color_4 extends Quantity_Color {
    constructor(theRgb: NCollection_Vec3<float>);
  }

export declare class Quantity_Array2OfColor {
  Init(theValue: Quantity_Color): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: Quantity_Array2OfColor): Quantity_Array2OfColor;
  Move(theOther: Quantity_Array2OfColor): Quantity_Array2OfColor;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Quantity_Color;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Quantity_Color;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Quantity_Color): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Quantity_Array2OfColor_1 extends Quantity_Array2OfColor {
    constructor();
  }

  export declare class Quantity_Array2OfColor_2 extends Quantity_Array2OfColor {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class Quantity_Array2OfColor_3 extends Quantity_Array2OfColor {
    constructor(theOther: Quantity_Array2OfColor);
  }

  export declare class Quantity_Array2OfColor_4 extends Quantity_Array2OfColor {
    constructor(theOther: Quantity_Array2OfColor);
  }

  export declare class Quantity_Array2OfColor_5 extends Quantity_Array2OfColor {
    constructor(theBegin: Quantity_Color, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Quantity_ColorRGBAHasher {
  constructor();
  static HashCode(theColor: Quantity_ColorRGBA, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(theColor1: Quantity_ColorRGBA, theColor2: Quantity_ColorRGBA): Standard_Boolean;
  delete(): void;
}

export declare class Quantity_Period {
  Values_1(dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): void;
  Values_2(ss: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): void;
  SetValues_1(dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): void;
  SetValues_2(ss: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): void;
  Subtract(anOther: Quantity_Period): Quantity_Period;
  Add(anOther: Quantity_Period): Quantity_Period;
  IsEqual(anOther: Quantity_Period): Standard_Boolean;
  IsShorter(anOther: Quantity_Period): Standard_Boolean;
  IsLonger(anOther: Quantity_Period): Standard_Boolean;
  static IsValid_1(dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): Standard_Boolean;
  static IsValid_2(ss: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Quantity_Period_1 extends Quantity_Period {
    constructor(dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, mis: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId);
  }

  export declare class Quantity_Period_2 extends Quantity_Period {
    constructor(ss: Graphic3d_ZLayerId, mics: Graphic3d_ZLayerId);
  }

export declare class Quantity_ColorRGBA {
  SetValues(theRed: Standard_ShortReal, theGreen: Standard_ShortReal, theBlue: Standard_ShortReal, theAlpha: Standard_ShortReal): void;
  GetRGB(): Quantity_Color;
  ChangeRGB(): Quantity_Color;
  SetRGB(theRgb: Quantity_Color): void;
  Alpha(): Standard_ShortReal;
  SetAlpha(theAlpha: Standard_ShortReal): void;
  IsDifferent(theOther: Quantity_ColorRGBA): Standard_Boolean;
  IsEqual(theOther: Quantity_ColorRGBA): Standard_Boolean;
  static ColorFromName(theColorNameString: Standard_CString, theColor: Quantity_ColorRGBA): Standard_Boolean;
  static ColorFromHex(theHexColorString: Standard_Character, theColor: Quantity_ColorRGBA, theAlphaComponentIsOff: Standard_Boolean): Standard_Boolean;
  static ColorToHex(theColor: Quantity_ColorRGBA, theToPrefixHash: Standard_Boolean): XCAFDoc_PartId;
  static Convert_LinearRGB_To_sRGB(theRGB: NCollection_Vec4<float>): any;
  static Convert_sRGB_To_LinearRGB(theRGB: NCollection_Vec4<float>): any;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Quantity_ColorRGBA_1 extends Quantity_ColorRGBA {
    constructor();
  }

  export declare class Quantity_ColorRGBA_2 extends Quantity_ColorRGBA {
    constructor(theRgb: Quantity_Color);
  }

  export declare class Quantity_ColorRGBA_3 extends Quantity_ColorRGBA {
    constructor(theRgb: Quantity_Color, theAlpha: Standard_ShortReal);
  }

  export declare class Quantity_ColorRGBA_4 extends Quantity_ColorRGBA {
    constructor(theRgba: NCollection_Vec4<float>);
  }

  export declare class Quantity_ColorRGBA_5 extends Quantity_ColorRGBA {
    constructor(theRed: Standard_ShortReal, theGreen: Standard_ShortReal, theBlue: Standard_ShortReal, theAlpha: Standard_ShortReal);
  }

export declare class Handle_Quantity_PeriodDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Quantity_PeriodDefinitionError): void;
  get(): Quantity_PeriodDefinitionError;
  delete(): void;
}

  export declare class Handle_Quantity_PeriodDefinitionError_1 extends Handle_Quantity_PeriodDefinitionError {
    constructor();
  }

  export declare class Handle_Quantity_PeriodDefinitionError_2 extends Handle_Quantity_PeriodDefinitionError {
    constructor(thePtr: Quantity_PeriodDefinitionError);
  }

  export declare class Handle_Quantity_PeriodDefinitionError_3 extends Handle_Quantity_PeriodDefinitionError {
    constructor(theHandle: Handle_Quantity_PeriodDefinitionError);
  }

  export declare class Handle_Quantity_PeriodDefinitionError_4 extends Handle_Quantity_PeriodDefinitionError {
    constructor(theHandle: Handle_Quantity_PeriodDefinitionError);
  }

export declare class Quantity_PeriodDefinitionError extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Quantity_PeriodDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Quantity_PeriodDefinitionError_1 extends Quantity_PeriodDefinitionError {
    constructor();
  }

  export declare class Quantity_PeriodDefinitionError_2 extends Quantity_PeriodDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class GCPnts_QuasiUniformDeflection {
  Initialize_1(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape): void;
  Initialize_2(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape): void;
  Initialize_3(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape): void;
  Initialize_4(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Parameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Value(Index: Graphic3d_ZLayerId): gp_Pnt;
  Deflection(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GCPnts_QuasiUniformDeflection_1 extends GCPnts_QuasiUniformDeflection {
    constructor();
  }

  export declare class GCPnts_QuasiUniformDeflection_2 extends GCPnts_QuasiUniformDeflection {
    constructor(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape);
  }

  export declare class GCPnts_QuasiUniformDeflection_3 extends GCPnts_QuasiUniformDeflection {
    constructor(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape);
  }

  export declare class GCPnts_QuasiUniformDeflection_4 extends GCPnts_QuasiUniformDeflection {
    constructor(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape);
  }

  export declare class GCPnts_QuasiUniformDeflection_5 extends GCPnts_QuasiUniformDeflection {
    constructor(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape);
  }

export declare class GCPnts_QuasiUniformAbscissa {
  Initialize_1(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId): void;
  Initialize_2(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId): void;
  Initialize_4(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Parameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GCPnts_QuasiUniformAbscissa_1 extends GCPnts_QuasiUniformAbscissa {
    constructor();
  }

  export declare class GCPnts_QuasiUniformAbscissa_2 extends GCPnts_QuasiUniformAbscissa {
    constructor(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId);
  }

  export declare class GCPnts_QuasiUniformAbscissa_3 extends GCPnts_QuasiUniformAbscissa {
    constructor(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_QuasiUniformAbscissa_4 extends GCPnts_QuasiUniformAbscissa {
    constructor(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId);
  }

  export declare class GCPnts_QuasiUniformAbscissa_5 extends GCPnts_QuasiUniformAbscissa {
    constructor(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose);
  }

export declare type GCPnts_DeflectionType = {
  GCPnts_Linear: {};
  GCPnts_Circular: {};
  GCPnts_Curved: {};
  GCPnts_DefComposite: {};
}

export declare class GCPnts_UniformDeflection {
  Initialize_1(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Initialize_2(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Initialize_3(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Initialize_4(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Parameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Value(Index: Graphic3d_ZLayerId): gp_Pnt;
  Deflection(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GCPnts_UniformDeflection_1 extends GCPnts_UniformDeflection {
    constructor();
  }

  export declare class GCPnts_UniformDeflection_2 extends GCPnts_UniformDeflection {
    constructor(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

  export declare class GCPnts_UniformDeflection_3 extends GCPnts_UniformDeflection {
    constructor(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

  export declare class GCPnts_UniformDeflection_4 extends GCPnts_UniformDeflection {
    constructor(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

  export declare class GCPnts_UniformDeflection_5 extends GCPnts_UniformDeflection {
    constructor(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

export declare type GCPnts_AbscissaType = {
  GCPnts_LengthParametrized: {};
  GCPnts_Parametrized: {};
  GCPnts_AbsComposite: {};
}

export declare class GCPnts_UniformAbscissa {
  Initialize_1(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose): void;
  Initialize_2(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId, Toler: Quantity_AbsorbedDose): void;
  Initialize_4(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose): void;
  Initialize_5(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose): void;
  Initialize_6(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose): void;
  Initialize_7(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId, Toler: Quantity_AbsorbedDose): void;
  Initialize_8(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Parameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Abscissa(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GCPnts_UniformAbscissa_1 extends GCPnts_UniformAbscissa {
    constructor();
  }

  export declare class GCPnts_UniformAbscissa_2 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_3 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_4 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_5 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor3d_Curve, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_6 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_7 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_8 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId, Toler: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_UniformAbscissa_9 extends GCPnts_UniformAbscissa {
    constructor(C: Adaptor2d_Curve2d, NbPoints: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Toler: Quantity_AbsorbedDose);
  }

export declare class GCPnts_DistFunction2dMV extends math_MultipleVarFunction {
  constructor(theCurvLinDist: GCPnts_DistFunction2d)
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  NbVariables(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class GCPnts_TangentialDeflection {
  Initialize_1(C: Adaptor3d_Curve, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose): void;
  Initialize_2(C: Adaptor3d_Curve, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor2d_Curve2d, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose): void;
  Initialize_4(C: Adaptor2d_Curve2d, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose): void;
  AddPoint(thePnt: gp_Pnt, theParam: Quantity_AbsorbedDose, theIsReplace: Standard_Boolean): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  Parameter(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Value(I: Graphic3d_ZLayerId): gp_Pnt;
  static ArcAngularStep(theRadius: Quantity_AbsorbedDose, theLinearDeflection: Quantity_AbsorbedDose, theAngularDeflection: Quantity_AbsorbedDose, theMinLength: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GCPnts_TangentialDeflection_1 extends GCPnts_TangentialDeflection {
    constructor();
  }

  export declare class GCPnts_TangentialDeflection_2 extends GCPnts_TangentialDeflection {
    constructor(C: Adaptor3d_Curve, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_TangentialDeflection_3 extends GCPnts_TangentialDeflection {
    constructor(C: Adaptor3d_Curve, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_TangentialDeflection_4 extends GCPnts_TangentialDeflection {
    constructor(C: Adaptor2d_Curve2d, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_TangentialDeflection_5 extends GCPnts_TangentialDeflection {
    constructor(C: Adaptor2d_Curve2d, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose, AngularDeflection: Quantity_AbsorbedDose, CurvatureDeflection: Quantity_AbsorbedDose, MinimumOfPoints: Graphic3d_ZLayerId, UTol: Quantity_AbsorbedDose, theMinLen: Quantity_AbsorbedDose);
  }

export declare class GCPnts_DistFunctionMV extends math_MultipleVarFunction {
  constructor(theCurvLinDist: GCPnts_DistFunction)
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  NbVariables(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class GCPnts_AbscissaPoint {
  static Length_1(C: Adaptor3d_Curve): Quantity_AbsorbedDose;
  static Length_2(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static Length_3(C: Adaptor3d_Curve, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_4(C: Adaptor2d_Curve2d, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_5(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_6(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_7(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_8(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IsDone(): Standard_Boolean;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GCPnts_AbscissaPoint_1 extends GCPnts_AbscissaPoint {
    constructor();
  }

  export declare class GCPnts_AbscissaPoint_2 extends GCPnts_AbscissaPoint {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_3 extends GCPnts_AbscissaPoint {
    constructor(Tol: Quantity_AbsorbedDose, C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_4 extends GCPnts_AbscissaPoint {
    constructor(Tol: Quantity_AbsorbedDose, C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_5 extends GCPnts_AbscissaPoint {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_6 extends GCPnts_AbscissaPoint {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_7 extends GCPnts_AbscissaPoint {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_8 extends GCPnts_AbscissaPoint {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class GCPnts_AbscissaPoint_9 extends GCPnts_AbscissaPoint {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class GeomLProp {
  constructor();
  static Continuity_1(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, r1: Standard_Boolean, r2: Standard_Boolean, tl: Quantity_AbsorbedDose, ta: Quantity_AbsorbedDose): GeomAbs_Shape;
  static Continuity_2(C1: Handle_Geom_Curve, C2: Handle_Geom_Curve, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, r1: Standard_Boolean, r2: Standard_Boolean): GeomAbs_Shape;
  delete(): void;
}

export declare class GeomLProp_SLProps {
  SetSurface(S: Handle_Geom_Surface): void;
  SetParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  D1U(): gp_Vec;
  D1V(): gp_Vec;
  D2U(): gp_Vec;
  D2V(): gp_Vec;
  DUV(): gp_Vec;
  IsTangentUDefined(): Standard_Boolean;
  TangentU(D: gp_Dir): void;
  IsTangentVDefined(): Standard_Boolean;
  TangentV(D: gp_Dir): void;
  IsNormalDefined(): Standard_Boolean;
  Normal(): gp_Dir;
  IsCurvatureDefined(): Standard_Boolean;
  IsUmbilic(): Standard_Boolean;
  MaxCurvature(): Quantity_AbsorbedDose;
  MinCurvature(): Quantity_AbsorbedDose;
  CurvatureDirections(MaxD: gp_Dir, MinD: gp_Dir): void;
  MeanCurvature(): Quantity_AbsorbedDose;
  GaussianCurvature(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomLProp_SLProps_1 extends GeomLProp_SLProps {
    constructor(S: Handle_Geom_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class GeomLProp_SLProps_2 extends GeomLProp_SLProps {
    constructor(S: Handle_Geom_Surface, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class GeomLProp_SLProps_3 extends GeomLProp_SLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class GeomLProp_CurveTool {
  constructor();
  static Value(C: Handle_Geom_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: Handle_Geom_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static D2(C: Handle_Geom_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: Handle_Geom_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static Continuity(C: Handle_Geom_Curve): Graphic3d_ZLayerId;
  static FirstParameter(C: Handle_Geom_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Geom_Curve): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GeomLProp_SurfaceTool {
  constructor();
  static Value(S: Handle_Geom_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(S: Handle_Geom_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  static D2(S: Handle_Geom_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, DUV: gp_Vec): void;
  static DN(S: Handle_Geom_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, IU: Graphic3d_ZLayerId, IV: Graphic3d_ZLayerId): gp_Vec;
  static Continuity(S: Handle_Geom_Surface): Graphic3d_ZLayerId;
  static Bounds(S: Handle_Geom_Surface, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomLProp_CLProps {
  SetParameter(U: Quantity_AbsorbedDose): void;
  SetCurve(C: Handle_Geom_Curve): void;
  Value(): gp_Pnt;
  D1(): gp_Vec;
  D2(): gp_Vec;
  D3(): gp_Vec;
  IsTangentDefined(): Standard_Boolean;
  Tangent(D: gp_Dir): void;
  Curvature(): Quantity_AbsorbedDose;
  Normal(N: gp_Dir): void;
  CentreOfCurvature(P: gp_Pnt): void;
  delete(): void;
}

  export declare class GeomLProp_CLProps_1 extends GeomLProp_CLProps {
    constructor(C: Handle_Geom_Curve, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class GeomLProp_CLProps_2 extends GeomLProp_CLProps {
    constructor(C: Handle_Geom_Curve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class GeomLProp_CLProps_3 extends GeomLProp_CLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class Handle_BinXCAFDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinXCAFDrivers_DocumentRetrievalDriver): void;
  get(): BinXCAFDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_BinXCAFDrivers_DocumentRetrievalDriver_1 extends Handle_BinXCAFDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_BinXCAFDrivers_DocumentRetrievalDriver_2 extends Handle_BinXCAFDrivers_DocumentRetrievalDriver {
    constructor(thePtr: BinXCAFDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinXCAFDrivers_DocumentRetrievalDriver_3 extends Handle_BinXCAFDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinXCAFDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinXCAFDrivers_DocumentRetrievalDriver_4 extends Handle_BinXCAFDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinXCAFDrivers_DocumentRetrievalDriver);
  }

export declare class BinXCAFDrivers_DocumentRetrievalDriver extends BinDrivers_DocumentRetrievalDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinXCAFDrivers {
  constructor();
  static Factory(theGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AttributeDrivers(MsgDrv: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  delete(): void;
}

export declare class Handle_BinXCAFDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinXCAFDrivers_DocumentStorageDriver): void;
  get(): BinXCAFDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_BinXCAFDrivers_DocumentStorageDriver_1 extends Handle_BinXCAFDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_BinXCAFDrivers_DocumentStorageDriver_2 extends Handle_BinXCAFDrivers_DocumentStorageDriver {
    constructor(thePtr: BinXCAFDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinXCAFDrivers_DocumentStorageDriver_3 extends Handle_BinXCAFDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinXCAFDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinXCAFDrivers_DocumentStorageDriver_4 extends Handle_BinXCAFDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinXCAFDrivers_DocumentStorageDriver);
  }

export declare class BinXCAFDrivers_DocumentStorageDriver extends BinDrivers_DocumentStorageDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_DimensionUnits {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_DimensionUnits): void;
  get(): IGESDimen_DimensionUnits;
  delete(): void;
}

  export declare class Handle_IGESDimen_DimensionUnits_1 extends Handle_IGESDimen_DimensionUnits {
    constructor();
  }

  export declare class Handle_IGESDimen_DimensionUnits_2 extends Handle_IGESDimen_DimensionUnits {
    constructor(thePtr: IGESDimen_DimensionUnits);
  }

  export declare class Handle_IGESDimen_DimensionUnits_3 extends Handle_IGESDimen_DimensionUnits {
    constructor(theHandle: Handle_IGESDimen_DimensionUnits);
  }

  export declare class Handle_IGESDimen_DimensionUnits_4 extends Handle_IGESDimen_DimensionUnits {
    constructor(theHandle: Handle_IGESDimen_DimensionUnits);
  }

export declare class IGESDimen_DimensionUnits extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aSecondPos: Graphic3d_ZLayerId, aUnitsInd: Graphic3d_ZLayerId, aCharSet: Graphic3d_ZLayerId, aFormat: Handle_TCollection_HAsciiString, aFracFlag: Graphic3d_ZLayerId, aPrecision: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  SecondaryDimenPosition(): Graphic3d_ZLayerId;
  UnitsIndicator(): Graphic3d_ZLayerId;
  CharacterSet(): Graphic3d_ZLayerId;
  FormatString(): Handle_TCollection_HAsciiString;
  FractionFlag(): Graphic3d_ZLayerId;
  PrecisionOrDenominator(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_PointDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, anArrow: Handle_IGESDimen_LeaderArrow, aGeom: Handle_IGESData_IGESEntity): void;
  Note(): Handle_IGESDimen_GeneralNote;
  LeaderArrow(): Handle_IGESDimen_LeaderArrow;
  GeomCase(): Graphic3d_ZLayerId;
  Geom(): Handle_IGESData_IGESEntity;
  CircularArc(): Handle_IGESGeom_CircularArc;
  CompositeCurve(): Handle_IGESGeom_CompositeCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_PointDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_PointDimension): void;
  get(): IGESDimen_PointDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_PointDimension_1 extends Handle_IGESDimen_PointDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_PointDimension_2 extends Handle_IGESDimen_PointDimension {
    constructor(thePtr: IGESDimen_PointDimension);
  }

  export declare class Handle_IGESDimen_PointDimension_3 extends Handle_IGESDimen_PointDimension {
    constructor(theHandle: Handle_IGESDimen_PointDimension);
  }

  export declare class Handle_IGESDimen_PointDimension_4 extends Handle_IGESDimen_PointDimension {
    constructor(theHandle: Handle_IGESDimen_PointDimension);
  }

export declare class IGESDimen_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_SpecificModule): void;
  get(): IGESDimen_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESDimen_SpecificModule_1 extends Handle_IGESDimen_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESDimen_SpecificModule_2 extends Handle_IGESDimen_SpecificModule {
    constructor(thePtr: IGESDimen_SpecificModule);
  }

  export declare class Handle_IGESDimen_SpecificModule_3 extends Handle_IGESDimen_SpecificModule {
    constructor(theHandle: Handle_IGESDimen_SpecificModule);
  }

  export declare class Handle_IGESDimen_SpecificModule_4 extends Handle_IGESDimen_SpecificModule {
    constructor(theHandle: Handle_IGESDimen_SpecificModule);
  }

export declare class IGESDimen_ToolRadiusDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_RadiusDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_RadiusDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_RadiusDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_RadiusDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_RadiusDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_RadiusDimension, entto: Handle_IGESDimen_RadiusDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_RadiusDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_CenterLine extends IGESData_IGESEntity {
  constructor()
  Init(aDataType: Graphic3d_ZLayerId, aZdisp: Quantity_AbsorbedDose, dataPnts: Handle_TColgp_HArray1OfXY): void;
  SetCrossHair(mode: Standard_Boolean): void;
  Datatype(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  ZDisplacement(): Quantity_AbsorbedDose;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  IsCrossHair(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_CenterLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_CenterLine): void;
  get(): IGESDimen_CenterLine;
  delete(): void;
}

  export declare class Handle_IGESDimen_CenterLine_1 extends Handle_IGESDimen_CenterLine {
    constructor();
  }

  export declare class Handle_IGESDimen_CenterLine_2 extends Handle_IGESDimen_CenterLine {
    constructor(thePtr: IGESDimen_CenterLine);
  }

  export declare class Handle_IGESDimen_CenterLine_3 extends Handle_IGESDimen_CenterLine {
    constructor(theHandle: Handle_IGESDimen_CenterLine);
  }

  export declare class Handle_IGESDimen_CenterLine_4 extends Handle_IGESDimen_CenterLine {
    constructor(theHandle: Handle_IGESDimen_CenterLine);
  }

export declare class Handle_IGESDimen_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_Protocol): void;
  get(): IGESDimen_Protocol;
  delete(): void;
}

  export declare class Handle_IGESDimen_Protocol_1 extends Handle_IGESDimen_Protocol {
    constructor();
  }

  export declare class Handle_IGESDimen_Protocol_2 extends Handle_IGESDimen_Protocol {
    constructor(thePtr: IGESDimen_Protocol);
  }

  export declare class Handle_IGESDimen_Protocol_3 extends Handle_IGESDimen_Protocol {
    constructor(theHandle: Handle_IGESDimen_Protocol);
  }

  export declare class Handle_IGESDimen_Protocol_4 extends Handle_IGESDimen_Protocol {
    constructor(theHandle: Handle_IGESDimen_Protocol);
  }

export declare class IGESDimen_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_NewDimensionedGeometry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_NewDimensionedGeometry): void;
  get(): IGESDimen_NewDimensionedGeometry;
  delete(): void;
}

  export declare class Handle_IGESDimen_NewDimensionedGeometry_1 extends Handle_IGESDimen_NewDimensionedGeometry {
    constructor();
  }

  export declare class Handle_IGESDimen_NewDimensionedGeometry_2 extends Handle_IGESDimen_NewDimensionedGeometry {
    constructor(thePtr: IGESDimen_NewDimensionedGeometry);
  }

  export declare class Handle_IGESDimen_NewDimensionedGeometry_3 extends Handle_IGESDimen_NewDimensionedGeometry {
    constructor(theHandle: Handle_IGESDimen_NewDimensionedGeometry);
  }

  export declare class Handle_IGESDimen_NewDimensionedGeometry_4 extends Handle_IGESDimen_NewDimensionedGeometry {
    constructor(theHandle: Handle_IGESDimen_NewDimensionedGeometry);
  }

export declare class IGESDimen_NewDimensionedGeometry extends IGESData_IGESEntity {
  constructor()
  Init(nbDimens: Graphic3d_ZLayerId, aDimen: Handle_IGESData_IGESEntity, anOrientation: Graphic3d_ZLayerId, anAngle: Quantity_AbsorbedDose, allEntities: Handle_IGESData_HArray1OfIGESEntity, allLocations: Handle_TColStd_HArray1OfInteger, allPoints: Handle_TColgp_HArray1OfXYZ): void;
  NbDimensions(): Graphic3d_ZLayerId;
  NbGeometries(): Graphic3d_ZLayerId;
  DimensionEntity(): Handle_IGESData_IGESEntity;
  DimensionOrientationFlag(): Graphic3d_ZLayerId;
  AngleValue(): Quantity_AbsorbedDose;
  GeometryEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  DimensionLocationFlag(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_LeaderArrow extends IGESData_IGESEntity {
  constructor()
  Init(height: Quantity_AbsorbedDose, width: Quantity_AbsorbedDose, depth: Quantity_AbsorbedDose, position: gp_XY, segments: Handle_TColgp_HArray1OfXY): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  NbSegments(): Graphic3d_ZLayerId;
  ArrowHeadHeight(): Quantity_AbsorbedDose;
  ArrowHeadWidth(): Quantity_AbsorbedDose;
  ZDepth(): Quantity_AbsorbedDose;
  ArrowHead(): gp_Pnt2d;
  TransformedArrowHead(): gp_Pnt;
  SegmentTail(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  TransformedSegmentTail(Index: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_LeaderArrow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_LeaderArrow): void;
  get(): IGESDimen_LeaderArrow;
  delete(): void;
}

  export declare class Handle_IGESDimen_LeaderArrow_1 extends Handle_IGESDimen_LeaderArrow {
    constructor();
  }

  export declare class Handle_IGESDimen_LeaderArrow_2 extends Handle_IGESDimen_LeaderArrow {
    constructor(thePtr: IGESDimen_LeaderArrow);
  }

  export declare class Handle_IGESDimen_LeaderArrow_3 extends Handle_IGESDimen_LeaderArrow {
    constructor(theHandle: Handle_IGESDimen_LeaderArrow);
  }

  export declare class Handle_IGESDimen_LeaderArrow_4 extends Handle_IGESDimen_LeaderArrow {
    constructor(theHandle: Handle_IGESDimen_LeaderArrow);
  }

export declare class Handle_IGESDimen_SectionedArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_SectionedArea): void;
  get(): IGESDimen_SectionedArea;
  delete(): void;
}

  export declare class Handle_IGESDimen_SectionedArea_1 extends Handle_IGESDimen_SectionedArea {
    constructor();
  }

  export declare class Handle_IGESDimen_SectionedArea_2 extends Handle_IGESDimen_SectionedArea {
    constructor(thePtr: IGESDimen_SectionedArea);
  }

  export declare class Handle_IGESDimen_SectionedArea_3 extends Handle_IGESDimen_SectionedArea {
    constructor(theHandle: Handle_IGESDimen_SectionedArea);
  }

  export declare class Handle_IGESDimen_SectionedArea_4 extends Handle_IGESDimen_SectionedArea {
    constructor(theHandle: Handle_IGESDimen_SectionedArea);
  }

export declare class IGESDimen_SectionedArea extends IGESData_IGESEntity {
  constructor()
  Init(aCurve: Handle_IGESData_IGESEntity, aPattern: Graphic3d_ZLayerId, aPoint: gp_XYZ, aDistance: Quantity_AbsorbedDose, anAngle: Quantity_AbsorbedDose, someIslands: Handle_IGESData_HArray1OfIGESEntity): void;
  SetInverted(mode: Standard_Boolean): void;
  IsInverted(): Standard_Boolean;
  ExteriorCurve(): Handle_IGESData_IGESEntity;
  Pattern(): Graphic3d_ZLayerId;
  PassingPoint(): gp_Pnt;
  TransformedPassingPoint(): gp_Pnt;
  ZDepth(): Quantity_AbsorbedDose;
  Distance(): Quantity_AbsorbedDose;
  Angle(): Quantity_AbsorbedDose;
  NbIslands(): Graphic3d_ZLayerId;
  IslandCurve(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolCurveDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_CurveDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_CurveDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_CurveDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_CurveDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_CurveDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_CurveDimension, entto: Handle_IGESDimen_CurveDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_CurveDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolDimensionUnits {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_DimensionUnits, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_DimensionUnits, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_DimensionUnits, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_DimensionUnits): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_DimensionUnits): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_DimensionUnits, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_DimensionUnits, entto: Handle_IGESDimen_DimensionUnits, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_DimensionUnits, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_GeneralModule): void;
  get(): IGESDimen_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESDimen_GeneralModule_1 extends Handle_IGESDimen_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESDimen_GeneralModule_2 extends Handle_IGESDimen_GeneralModule {
    constructor(thePtr: IGESDimen_GeneralModule);
  }

  export declare class Handle_IGESDimen_GeneralModule_3 extends Handle_IGESDimen_GeneralModule {
    constructor(theHandle: Handle_IGESDimen_GeneralModule);
  }

  export declare class Handle_IGESDimen_GeneralModule_4 extends Handle_IGESDimen_GeneralModule {
    constructor(theHandle: Handle_IGESDimen_GeneralModule);
  }

export declare class IGESDimen_ToolLinearDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_LinearDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_LinearDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_LinearDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_LinearDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_LinearDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_LinearDimension, entto: Handle_IGESDimen_LinearDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_LinearDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolSectionedArea {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_SectionedArea, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_SectionedArea, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_SectionedArea, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_SectionedArea): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_SectionedArea, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_SectionedArea, entto: Handle_IGESDimen_SectionedArea, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_SectionedArea, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_DimensionDisplayData extends IGESData_IGESEntity {
  constructor()
  Init(numProps: Graphic3d_ZLayerId, aDimType: Graphic3d_ZLayerId, aLabelPos: Graphic3d_ZLayerId, aCharSet: Graphic3d_ZLayerId, aString: Handle_TCollection_HAsciiString, aSymbol: Graphic3d_ZLayerId, anAng: Quantity_AbsorbedDose, anAlign: Graphic3d_ZLayerId, aLevel: Graphic3d_ZLayerId, aPlace: Graphic3d_ZLayerId, anOrient: Graphic3d_ZLayerId, initVal: Quantity_AbsorbedDose, notes: Handle_TColStd_HArray1OfInteger, startInd: Handle_TColStd_HArray1OfInteger, endInd: Handle_TColStd_HArray1OfInteger): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  DimensionType(): Graphic3d_ZLayerId;
  LabelPosition(): Graphic3d_ZLayerId;
  CharacterSet(): Graphic3d_ZLayerId;
  LString(): Handle_TCollection_HAsciiString;
  DecimalSymbol(): Graphic3d_ZLayerId;
  WitnessLineAngle(): Quantity_AbsorbedDose;
  TextAlignment(): Graphic3d_ZLayerId;
  TextLevel(): Graphic3d_ZLayerId;
  TextPlacement(): Graphic3d_ZLayerId;
  ArrowHeadOrientation(): Graphic3d_ZLayerId;
  InitialValue(): Quantity_AbsorbedDose;
  NbSupplementaryNotes(): Graphic3d_ZLayerId;
  SupplementaryNote(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  StartIndex(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  EndIndex(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_DimensionDisplayData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_DimensionDisplayData): void;
  get(): IGESDimen_DimensionDisplayData;
  delete(): void;
}

  export declare class Handle_IGESDimen_DimensionDisplayData_1 extends Handle_IGESDimen_DimensionDisplayData {
    constructor();
  }

  export declare class Handle_IGESDimen_DimensionDisplayData_2 extends Handle_IGESDimen_DimensionDisplayData {
    constructor(thePtr: IGESDimen_DimensionDisplayData);
  }

  export declare class Handle_IGESDimen_DimensionDisplayData_3 extends Handle_IGESDimen_DimensionDisplayData {
    constructor(theHandle: Handle_IGESDimen_DimensionDisplayData);
  }

  export declare class Handle_IGESDimen_DimensionDisplayData_4 extends Handle_IGESDimen_DimensionDisplayData {
    constructor(theHandle: Handle_IGESDimen_DimensionDisplayData);
  }

export declare class IGESDimen_ToolNewDimensionedGeometry {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_NewDimensionedGeometry, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_NewDimensionedGeometry, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_NewDimensionedGeometry, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_NewDimensionedGeometry): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_NewDimensionedGeometry): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_NewDimensionedGeometry, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_NewDimensionedGeometry, entto: Handle_IGESDimen_NewDimensionedGeometry, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_NewDimensionedGeometry, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolDimensionDisplayData {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_DimensionDisplayData, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_DimensionDisplayData, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_DimensionDisplayData, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_DimensionDisplayData): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_DimensionDisplayData): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_DimensionDisplayData, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_DimensionDisplayData, entto: Handle_IGESDimen_DimensionDisplayData, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_DimensionDisplayData, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_GeneralSymbol extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, allGeoms: Handle_IGESData_HArray1OfIGESEntity, allLeaders: Handle_IGESDimen_HArray1OfLeaderArrow): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  HasNote(): Standard_Boolean;
  Note(): Handle_IGESDimen_GeneralNote;
  NbGeomEntities(): Graphic3d_ZLayerId;
  GeomEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  NbLeaders(): Graphic3d_ZLayerId;
  LeaderArrow(Index: Graphic3d_ZLayerId): Handle_IGESDimen_LeaderArrow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_GeneralSymbol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_GeneralSymbol): void;
  get(): IGESDimen_GeneralSymbol;
  delete(): void;
}

  export declare class Handle_IGESDimen_GeneralSymbol_1 extends Handle_IGESDimen_GeneralSymbol {
    constructor();
  }

  export declare class Handle_IGESDimen_GeneralSymbol_2 extends Handle_IGESDimen_GeneralSymbol {
    constructor(thePtr: IGESDimen_GeneralSymbol);
  }

  export declare class Handle_IGESDimen_GeneralSymbol_3 extends Handle_IGESDimen_GeneralSymbol {
    constructor(theHandle: Handle_IGESDimen_GeneralSymbol);
  }

  export declare class Handle_IGESDimen_GeneralSymbol_4 extends Handle_IGESDimen_GeneralSymbol {
    constructor(theHandle: Handle_IGESDimen_GeneralSymbol);
  }

export declare class IGESDimen_ToolSection {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_Section, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_Section, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_Section, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_Section): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_Section): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_Section, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_Section, entto: Handle_IGESDimen_Section, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_Section, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_WitnessLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_WitnessLine): void;
  get(): IGESDimen_WitnessLine;
  delete(): void;
}

  export declare class Handle_IGESDimen_WitnessLine_1 extends Handle_IGESDimen_WitnessLine {
    constructor();
  }

  export declare class Handle_IGESDimen_WitnessLine_2 extends Handle_IGESDimen_WitnessLine {
    constructor(thePtr: IGESDimen_WitnessLine);
  }

  export declare class Handle_IGESDimen_WitnessLine_3 extends Handle_IGESDimen_WitnessLine {
    constructor(theHandle: Handle_IGESDimen_WitnessLine);
  }

  export declare class Handle_IGESDimen_WitnessLine_4 extends Handle_IGESDimen_WitnessLine {
    constructor(theHandle: Handle_IGESDimen_WitnessLine);
  }

export declare class IGESDimen_WitnessLine extends IGESData_IGESEntity {
  constructor()
  Init(dataType: Graphic3d_ZLayerId, aDisp: Quantity_AbsorbedDose, dataPoints: Handle_TColgp_HArray1OfXY): void;
  Datatype(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  ZDisplacement(): Quantity_AbsorbedDose;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolDiameterDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_DiameterDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_DiameterDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_DiameterDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_DiameterDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_DiameterDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_DiameterDimension, entto: Handle_IGESDimen_DiameterDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_DiameterDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_BasicDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_BasicDimension): void;
  get(): IGESDimen_BasicDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_BasicDimension_1 extends Handle_IGESDimen_BasicDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_BasicDimension_2 extends Handle_IGESDimen_BasicDimension {
    constructor(thePtr: IGESDimen_BasicDimension);
  }

  export declare class Handle_IGESDimen_BasicDimension_3 extends Handle_IGESDimen_BasicDimension {
    constructor(theHandle: Handle_IGESDimen_BasicDimension);
  }

  export declare class Handle_IGESDimen_BasicDimension_4 extends Handle_IGESDimen_BasicDimension {
    constructor(theHandle: Handle_IGESDimen_BasicDimension);
  }

export declare class IGESDimen_BasicDimension extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, lowerLeft: gp_XY, lowerRight: gp_XY, upperRight: gp_XY, upperLeft: gp_XY): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  LowerLeft(): gp_Pnt2d;
  LowerRight(): gp_Pnt2d;
  UpperRight(): gp_Pnt2d;
  UpperLeft(): gp_Pnt2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_DiameterDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_DiameterDimension): void;
  get(): IGESDimen_DiameterDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_DiameterDimension_1 extends Handle_IGESDimen_DiameterDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_DiameterDimension_2 extends Handle_IGESDimen_DiameterDimension {
    constructor(thePtr: IGESDimen_DiameterDimension);
  }

  export declare class Handle_IGESDimen_DiameterDimension_3 extends Handle_IGESDimen_DiameterDimension {
    constructor(theHandle: Handle_IGESDimen_DiameterDimension);
  }

  export declare class Handle_IGESDimen_DiameterDimension_4 extends Handle_IGESDimen_DiameterDimension {
    constructor(theHandle: Handle_IGESDimen_DiameterDimension);
  }

export declare class IGESDimen_DiameterDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aLeader: Handle_IGESDimen_LeaderArrow, anotherLeader: Handle_IGESDimen_LeaderArrow, aCenter: gp_XY): void;
  Note(): Handle_IGESDimen_GeneralNote;
  FirstLeader(): Handle_IGESDimen_LeaderArrow;
  HasSecondLeader(): Standard_Boolean;
  SecondLeader(): Handle_IGESDimen_LeaderArrow;
  Center(): gp_Pnt2d;
  TransformedCenter(): gp_Pnt2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolOrdinateDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_OrdinateDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_OrdinateDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_OrdinateDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_OrdinateDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_OrdinateDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_OrdinateDimension, entto: Handle_IGESDimen_OrdinateDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_OrdinateDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_NewGeneralNote {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_NewGeneralNote): void;
  get(): IGESDimen_NewGeneralNote;
  delete(): void;
}

  export declare class Handle_IGESDimen_NewGeneralNote_1 extends Handle_IGESDimen_NewGeneralNote {
    constructor();
  }

  export declare class Handle_IGESDimen_NewGeneralNote_2 extends Handle_IGESDimen_NewGeneralNote {
    constructor(thePtr: IGESDimen_NewGeneralNote);
  }

  export declare class Handle_IGESDimen_NewGeneralNote_3 extends Handle_IGESDimen_NewGeneralNote {
    constructor(theHandle: Handle_IGESDimen_NewGeneralNote);
  }

  export declare class Handle_IGESDimen_NewGeneralNote_4 extends Handle_IGESDimen_NewGeneralNote {
    constructor(theHandle: Handle_IGESDimen_NewGeneralNote);
  }

export declare class IGESDimen_NewGeneralNote extends IGESData_IGESEntity {
  constructor()
  Init(width: Quantity_AbsorbedDose, height: Quantity_AbsorbedDose, justifyCode: Graphic3d_ZLayerId, areaLoc: gp_XYZ, areaRotationAngle: Quantity_AbsorbedDose, baseLinePos: gp_XYZ, normalInterlineSpace: Quantity_AbsorbedDose, charDisplays: Handle_TColStd_HArray1OfInteger, charWidths: Handle_TColStd_HArray1OfReal, charHeights: Handle_TColStd_HArray1OfReal, interCharSpc: Handle_TColStd_HArray1OfReal, interLineSpc: Handle_TColStd_HArray1OfReal, fontStyles: Handle_TColStd_HArray1OfInteger, charAngles: Handle_TColStd_HArray1OfReal, controlCodeStrings: Handle_Interface_HArray1OfHAsciiString, nbChars: Handle_TColStd_HArray1OfInteger, boxWidths: Handle_TColStd_HArray1OfReal, boxHeights: Handle_TColStd_HArray1OfReal, charSetCodes: Handle_TColStd_HArray1OfInteger, charSetEntities: Handle_IGESData_HArray1OfIGESEntity, slAngles: Handle_TColStd_HArray1OfReal, rotAngles: Handle_TColStd_HArray1OfReal, mirrorFlags: Handle_TColStd_HArray1OfInteger, rotateFlags: Handle_TColStd_HArray1OfInteger, startPoints: Handle_TColgp_HArray1OfXYZ, texts: Handle_Interface_HArray1OfHAsciiString): void;
  TextWidth(): Quantity_AbsorbedDose;
  TextHeight(): Quantity_AbsorbedDose;
  JustifyCode(): Graphic3d_ZLayerId;
  AreaLocation(): gp_Pnt;
  TransformedAreaLocation(): gp_Pnt;
  ZDepthAreaLocation(): Quantity_AbsorbedDose;
  AreaRotationAngle(): Quantity_AbsorbedDose;
  BaseLinePosition(): gp_Pnt;
  TransformedBaseLinePosition(): gp_Pnt;
  ZDepthBaseLinePosition(): Quantity_AbsorbedDose;
  NormalInterlineSpace(): Quantity_AbsorbedDose;
  NbStrings(): Graphic3d_ZLayerId;
  CharacterDisplay(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsVariable(Index: Graphic3d_ZLayerId): Standard_Boolean;
  CharacterWidth(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  CharacterHeight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  InterCharacterSpace(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  InterlineSpace(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  FontStyle(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  CharacterAngle(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ControlCodeString(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbCharacters(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  BoxWidth(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  BoxHeight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsCharSetEntity(Index: Graphic3d_ZLayerId): Standard_Boolean;
  CharSetCode(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  CharSetEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  SlantAngle(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  RotationAngle(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MirrorFlag(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsMirrored(Index: Graphic3d_ZLayerId): Standard_Boolean;
  RotateFlag(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  StartPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  TransformedStartPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  ZDepthStartPoint(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Text(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolGeneralSymbol {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_GeneralSymbol, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_GeneralSymbol, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_GeneralSymbol, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_GeneralSymbol): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_GeneralSymbol, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_GeneralSymbol, entto: Handle_IGESDimen_GeneralSymbol, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_GeneralSymbol, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_OrdinateDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aType: Standard_Boolean, aLine: Handle_IGESDimen_WitnessLine, anArrow: Handle_IGESDimen_LeaderArrow): void;
  IsLine(): Standard_Boolean;
  IsLeader(): Standard_Boolean;
  Note(): Handle_IGESDimen_GeneralNote;
  WitnessLine(): Handle_IGESDimen_WitnessLine;
  Leader(): Handle_IGESDimen_LeaderArrow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_OrdinateDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_OrdinateDimension): void;
  get(): IGESDimen_OrdinateDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_OrdinateDimension_1 extends Handle_IGESDimen_OrdinateDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_OrdinateDimension_2 extends Handle_IGESDimen_OrdinateDimension {
    constructor(thePtr: IGESDimen_OrdinateDimension);
  }

  export declare class Handle_IGESDimen_OrdinateDimension_3 extends Handle_IGESDimen_OrdinateDimension {
    constructor(theHandle: Handle_IGESDimen_OrdinateDimension);
  }

  export declare class Handle_IGESDimen_OrdinateDimension_4 extends Handle_IGESDimen_OrdinateDimension {
    constructor(theHandle: Handle_IGESDimen_OrdinateDimension);
  }

export declare class Handle_IGESDimen_GeneralNote {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_GeneralNote): void;
  get(): IGESDimen_GeneralNote;
  delete(): void;
}

  export declare class Handle_IGESDimen_GeneralNote_1 extends Handle_IGESDimen_GeneralNote {
    constructor();
  }

  export declare class Handle_IGESDimen_GeneralNote_2 extends Handle_IGESDimen_GeneralNote {
    constructor(thePtr: IGESDimen_GeneralNote);
  }

  export declare class Handle_IGESDimen_GeneralNote_3 extends Handle_IGESDimen_GeneralNote {
    constructor(theHandle: Handle_IGESDimen_GeneralNote);
  }

  export declare class Handle_IGESDimen_GeneralNote_4 extends Handle_IGESDimen_GeneralNote {
    constructor(theHandle: Handle_IGESDimen_GeneralNote);
  }

export declare class IGESDimen_GeneralNote extends IGESData_IGESEntity {
  constructor()
  Init(nbChars: Handle_TColStd_HArray1OfInteger, widths: Handle_TColStd_HArray1OfReal, heights: Handle_TColStd_HArray1OfReal, fontCodes: Handle_TColStd_HArray1OfInteger, fonts: Handle_IGESGraph_HArray1OfTextFontDef, slants: Handle_TColStd_HArray1OfReal, rotations: Handle_TColStd_HArray1OfReal, mirrorFlags: Handle_TColStd_HArray1OfInteger, rotFlags: Handle_TColStd_HArray1OfInteger, start: Handle_TColgp_HArray1OfXYZ, texts: Handle_Interface_HArray1OfHAsciiString): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  NbStrings(): Graphic3d_ZLayerId;
  NbCharacters(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  BoxWidth(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  BoxHeight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsFontEntity(Index: Graphic3d_ZLayerId): Standard_Boolean;
  FontCode(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  FontEntity(Index: Graphic3d_ZLayerId): Handle_IGESGraph_TextFontDef;
  SlantAngle(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  RotationAngle(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MirrorFlag(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  RotateFlag(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  StartPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  TransformedStartPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  ZDepthStartPoint(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Text(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolGeneralNote {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_GeneralNote, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_GeneralNote, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_GeneralNote, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_GeneralNote): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_GeneralNote, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_GeneralNote, entto: Handle_IGESDimen_GeneralNote, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_GeneralNote, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolCenterLine {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_CenterLine, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_CenterLine, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_CenterLine, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_CenterLine): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_CenterLine): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_CenterLine, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_CenterLine, entto: Handle_IGESDimen_CenterLine, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_CenterLine, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_RadiusDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_RadiusDimension): void;
  get(): IGESDimen_RadiusDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_RadiusDimension_1 extends Handle_IGESDimen_RadiusDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_RadiusDimension_2 extends Handle_IGESDimen_RadiusDimension {
    constructor(thePtr: IGESDimen_RadiusDimension);
  }

  export declare class Handle_IGESDimen_RadiusDimension_3 extends Handle_IGESDimen_RadiusDimension {
    constructor(theHandle: Handle_IGESDimen_RadiusDimension);
  }

  export declare class Handle_IGESDimen_RadiusDimension_4 extends Handle_IGESDimen_RadiusDimension {
    constructor(theHandle: Handle_IGESDimen_RadiusDimension);
  }

export declare class IGESDimen_RadiusDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, anArrow: Handle_IGESDimen_LeaderArrow, arcCenter: gp_XY, anotherArrow: Handle_IGESDimen_LeaderArrow): void;
  InitForm(form: Graphic3d_ZLayerId): void;
  Note(): Handle_IGESDimen_GeneralNote;
  Leader(): Handle_IGESDimen_LeaderArrow;
  Center(): gp_Pnt2d;
  TransformedCenter(): gp_Pnt;
  HasLeader2(): Standard_Boolean;
  Leader2(): Handle_IGESDimen_LeaderArrow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolAngularDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_AngularDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_AngularDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_AngularDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_AngularDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_AngularDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_AngularDimension, entto: Handle_IGESDimen_AngularDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_AngularDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_Section {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_Section): void;
  get(): IGESDimen_Section;
  delete(): void;
}

  export declare class Handle_IGESDimen_Section_1 extends Handle_IGESDimen_Section {
    constructor();
  }

  export declare class Handle_IGESDimen_Section_2 extends Handle_IGESDimen_Section {
    constructor(thePtr: IGESDimen_Section);
  }

  export declare class Handle_IGESDimen_Section_3 extends Handle_IGESDimen_Section {
    constructor(theHandle: Handle_IGESDimen_Section);
  }

  export declare class Handle_IGESDimen_Section_4 extends Handle_IGESDimen_Section {
    constructor(theHandle: Handle_IGESDimen_Section);
  }

export declare class IGESDimen_Section extends IGESData_IGESEntity {
  constructor()
  Init(dataType: Graphic3d_ZLayerId, aDisp: Quantity_AbsorbedDose, dataPoints: Handle_TColgp_HArray1OfXY): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  Datatype(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  ZDisplacement(): Quantity_AbsorbedDose;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESDimen_Protocol;
  delete(): void;
}

export declare class Handle_IGESDimen_FlagNote {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_FlagNote): void;
  get(): IGESDimen_FlagNote;
  delete(): void;
}

  export declare class Handle_IGESDimen_FlagNote_1 extends Handle_IGESDimen_FlagNote {
    constructor();
  }

  export declare class Handle_IGESDimen_FlagNote_2 extends Handle_IGESDimen_FlagNote {
    constructor(thePtr: IGESDimen_FlagNote);
  }

  export declare class Handle_IGESDimen_FlagNote_3 extends Handle_IGESDimen_FlagNote {
    constructor(theHandle: Handle_IGESDimen_FlagNote);
  }

  export declare class Handle_IGESDimen_FlagNote_4 extends Handle_IGESDimen_FlagNote {
    constructor(theHandle: Handle_IGESDimen_FlagNote);
  }

export declare class IGESDimen_FlagNote extends IGESData_IGESEntity {
  constructor()
  Init(leftCorner: gp_XYZ, anAngle: Quantity_AbsorbedDose, aNote: Handle_IGESDimen_GeneralNote, someLeaders: Handle_IGESDimen_HArray1OfLeaderArrow): void;
  LowerLeftCorner(): gp_Pnt;
  TransformedLowerLeftCorner(): gp_Pnt;
  Angle(): Quantity_AbsorbedDose;
  Note(): Handle_IGESDimen_GeneralNote;
  NbLeaders(): Graphic3d_ZLayerId;
  Leader(Index: Graphic3d_ZLayerId): Handle_IGESDimen_LeaderArrow;
  Height(): Quantity_AbsorbedDose;
  CharacterHeight(): Quantity_AbsorbedDose;
  Length(): Quantity_AbsorbedDose;
  TextWidth(): Quantity_AbsorbedDose;
  TipLength(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ToolFlagNote {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_FlagNote, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_FlagNote, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_FlagNote, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_FlagNote): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_FlagNote, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_FlagNote, entto: Handle_IGESDimen_FlagNote, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_FlagNote, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_AngularDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aLine: Handle_IGESDimen_WitnessLine, anotherLine: Handle_IGESDimen_WitnessLine, aVertex: gp_XY, aRadius: Quantity_AbsorbedDose, aLeader: Handle_IGESDimen_LeaderArrow, anotherLeader: Handle_IGESDimen_LeaderArrow): void;
  Note(): Handle_IGESDimen_GeneralNote;
  HasFirstWitnessLine(): Standard_Boolean;
  FirstWitnessLine(): Handle_IGESDimen_WitnessLine;
  HasSecondWitnessLine(): Standard_Boolean;
  SecondWitnessLine(): Handle_IGESDimen_WitnessLine;
  Vertex(): gp_Pnt2d;
  TransformedVertex(): gp_Pnt2d;
  Radius(): Quantity_AbsorbedDose;
  FirstLeader(): Handle_IGESDimen_LeaderArrow;
  SecondLeader(): Handle_IGESDimen_LeaderArrow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_AngularDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_AngularDimension): void;
  get(): IGESDimen_AngularDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_AngularDimension_1 extends Handle_IGESDimen_AngularDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_AngularDimension_2 extends Handle_IGESDimen_AngularDimension {
    constructor(thePtr: IGESDimen_AngularDimension);
  }

  export declare class Handle_IGESDimen_AngularDimension_3 extends Handle_IGESDimen_AngularDimension {
    constructor(theHandle: Handle_IGESDimen_AngularDimension);
  }

  export declare class Handle_IGESDimen_AngularDimension_4 extends Handle_IGESDimen_AngularDimension {
    constructor(theHandle: Handle_IGESDimen_AngularDimension);
  }

export declare class IGESDimen_ToolNewGeneralNote {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_NewGeneralNote, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_NewGeneralNote, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_NewGeneralNote, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_NewGeneralNote): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_NewGeneralNote, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_NewGeneralNote, entto: Handle_IGESDimen_NewGeneralNote, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_NewGeneralNote, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_GeneralLabel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_GeneralLabel): void;
  get(): IGESDimen_GeneralLabel;
  delete(): void;
}

  export declare class Handle_IGESDimen_GeneralLabel_1 extends Handle_IGESDimen_GeneralLabel {
    constructor();
  }

  export declare class Handle_IGESDimen_GeneralLabel_2 extends Handle_IGESDimen_GeneralLabel {
    constructor(thePtr: IGESDimen_GeneralLabel);
  }

  export declare class Handle_IGESDimen_GeneralLabel_3 extends Handle_IGESDimen_GeneralLabel {
    constructor(theHandle: Handle_IGESDimen_GeneralLabel);
  }

  export declare class Handle_IGESDimen_GeneralLabel_4 extends Handle_IGESDimen_GeneralLabel {
    constructor(theHandle: Handle_IGESDimen_GeneralLabel);
  }

export declare class IGESDimen_GeneralLabel extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, someLeaders: Handle_IGESDimen_HArray1OfLeaderArrow): void;
  Note(): Handle_IGESDimen_GeneralNote;
  NbLeaders(): Graphic3d_ZLayerId;
  Leader(Index: Graphic3d_ZLayerId): Handle_IGESDimen_LeaderArrow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_ReadWriteModule): void;
  get(): IGESDimen_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESDimen_ReadWriteModule_1 extends Handle_IGESDimen_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESDimen_ReadWriteModule_2 extends Handle_IGESDimen_ReadWriteModule {
    constructor(thePtr: IGESDimen_ReadWriteModule);
  }

  export declare class Handle_IGESDimen_ReadWriteModule_3 extends Handle_IGESDimen_ReadWriteModule {
    constructor(theHandle: Handle_IGESDimen_ReadWriteModule);
  }

  export declare class Handle_IGESDimen_ReadWriteModule_4 extends Handle_IGESDimen_ReadWriteModule {
    constructor(theHandle: Handle_IGESDimen_ReadWriteModule);
  }

export declare class IGESDimen_ToolDimensionedGeometry {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_DimensionedGeometry, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_DimensionedGeometry, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_DimensionedGeometry, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_DimensionedGeometry): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_DimensionedGeometry): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_DimensionedGeometry, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_DimensionedGeometry, entto: Handle_IGESDimen_DimensionedGeometry, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_DimensionedGeometry, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolGeneralLabel {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_GeneralLabel, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_GeneralLabel, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_GeneralLabel, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_GeneralLabel): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_GeneralLabel, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_GeneralLabel, entto: Handle_IGESDimen_GeneralLabel, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_GeneralLabel, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_DimensionTolerance extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aSecTolFlag: Graphic3d_ZLayerId, aTolType: Graphic3d_ZLayerId, aTolPlaceFlag: Graphic3d_ZLayerId, anUpperTol: Quantity_AbsorbedDose, aLowerTol: Quantity_AbsorbedDose, aSignFlag: Standard_Boolean, aFracFlag: Graphic3d_ZLayerId, aPrecision: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  SecondaryToleranceFlag(): Graphic3d_ZLayerId;
  ToleranceType(): Graphic3d_ZLayerId;
  TolerancePlacementFlag(): Graphic3d_ZLayerId;
  UpperTolerance(): Quantity_AbsorbedDose;
  LowerTolerance(): Quantity_AbsorbedDose;
  SignSuppressionFlag(): Standard_Boolean;
  FractionFlag(): Graphic3d_ZLayerId;
  Precision(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_DimensionTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_DimensionTolerance): void;
  get(): IGESDimen_DimensionTolerance;
  delete(): void;
}

  export declare class Handle_IGESDimen_DimensionTolerance_1 extends Handle_IGESDimen_DimensionTolerance {
    constructor();
  }

  export declare class Handle_IGESDimen_DimensionTolerance_2 extends Handle_IGESDimen_DimensionTolerance {
    constructor(thePtr: IGESDimen_DimensionTolerance);
  }

  export declare class Handle_IGESDimen_DimensionTolerance_3 extends Handle_IGESDimen_DimensionTolerance {
    constructor(theHandle: Handle_IGESDimen_DimensionTolerance);
  }

  export declare class Handle_IGESDimen_DimensionTolerance_4 extends Handle_IGESDimen_DimensionTolerance {
    constructor(theHandle: Handle_IGESDimen_DimensionTolerance);
  }

export declare class IGESDimen_ToolDimensionTolerance {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_DimensionTolerance, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_DimensionTolerance, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_DimensionTolerance, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_DimensionTolerance): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_DimensionTolerance): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_DimensionTolerance, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_DimensionTolerance, entto: Handle_IGESDimen_DimensionTolerance, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_DimensionTolerance, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDimen_LinearDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_LinearDimension): void;
  get(): IGESDimen_LinearDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_LinearDimension_1 extends Handle_IGESDimen_LinearDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_LinearDimension_2 extends Handle_IGESDimen_LinearDimension {
    constructor(thePtr: IGESDimen_LinearDimension);
  }

  export declare class Handle_IGESDimen_LinearDimension_3 extends Handle_IGESDimen_LinearDimension {
    constructor(theHandle: Handle_IGESDimen_LinearDimension);
  }

  export declare class Handle_IGESDimen_LinearDimension_4 extends Handle_IGESDimen_LinearDimension {
    constructor(theHandle: Handle_IGESDimen_LinearDimension);
  }

export declare class IGESDimen_LinearDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aLeader: Handle_IGESDimen_LeaderArrow, anotherLeader: Handle_IGESDimen_LeaderArrow, aWitness: Handle_IGESDimen_WitnessLine, anotherWitness: Handle_IGESDimen_WitnessLine): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  Note(): Handle_IGESDimen_GeneralNote;
  FirstLeader(): Handle_IGESDimen_LeaderArrow;
  SecondLeader(): Handle_IGESDimen_LeaderArrow;
  HasFirstWitness(): Standard_Boolean;
  FirstWitness(): Handle_IGESDimen_WitnessLine;
  HasSecondWitness(): Standard_Boolean;
  SecondWitness(): Handle_IGESDimen_WitnessLine;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDimen_CurveDimension extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aCurve: Handle_IGESData_IGESEntity, anotherCurve: Handle_IGESData_IGESEntity, aLeader: Handle_IGESDimen_LeaderArrow, anotherLeader: Handle_IGESDimen_LeaderArrow, aLine: Handle_IGESDimen_WitnessLine, anotherLine: Handle_IGESDimen_WitnessLine): void;
  Note(): Handle_IGESDimen_GeneralNote;
  FirstCurve(): Handle_IGESData_IGESEntity;
  HasSecondCurve(): Standard_Boolean;
  SecondCurve(): Handle_IGESData_IGESEntity;
  FirstLeader(): Handle_IGESDimen_LeaderArrow;
  SecondLeader(): Handle_IGESDimen_LeaderArrow;
  HasFirstWitnessLine(): Standard_Boolean;
  FirstWitnessLine(): Handle_IGESDimen_WitnessLine;
  HasSecondWitnessLine(): Standard_Boolean;
  SecondWitnessLine(): Handle_IGESDimen_WitnessLine;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_CurveDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_CurveDimension): void;
  get(): IGESDimen_CurveDimension;
  delete(): void;
}

  export declare class Handle_IGESDimen_CurveDimension_1 extends Handle_IGESDimen_CurveDimension {
    constructor();
  }

  export declare class Handle_IGESDimen_CurveDimension_2 extends Handle_IGESDimen_CurveDimension {
    constructor(thePtr: IGESDimen_CurveDimension);
  }

  export declare class Handle_IGESDimen_CurveDimension_3 extends Handle_IGESDimen_CurveDimension {
    constructor(theHandle: Handle_IGESDimen_CurveDimension);
  }

  export declare class Handle_IGESDimen_CurveDimension_4 extends Handle_IGESDimen_CurveDimension {
    constructor(theHandle: Handle_IGESDimen_CurveDimension);
  }

export declare class Handle_IGESDimen_HArray1OfLeaderArrow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_HArray1OfLeaderArrow): void;
  get(): IGESDimen_HArray1OfLeaderArrow;
  delete(): void;
}

  export declare class Handle_IGESDimen_HArray1OfLeaderArrow_1 extends Handle_IGESDimen_HArray1OfLeaderArrow {
    constructor();
  }

  export declare class Handle_IGESDimen_HArray1OfLeaderArrow_2 extends Handle_IGESDimen_HArray1OfLeaderArrow {
    constructor(thePtr: IGESDimen_HArray1OfLeaderArrow);
  }

  export declare class Handle_IGESDimen_HArray1OfLeaderArrow_3 extends Handle_IGESDimen_HArray1OfLeaderArrow {
    constructor(theHandle: Handle_IGESDimen_HArray1OfLeaderArrow);
  }

  export declare class Handle_IGESDimen_HArray1OfLeaderArrow_4 extends Handle_IGESDimen_HArray1OfLeaderArrow {
    constructor(theHandle: Handle_IGESDimen_HArray1OfLeaderArrow);
  }

export declare class IGESDimen_DimensionedGeometry extends IGESData_IGESEntity {
  constructor()
  Init(nbDims: Graphic3d_ZLayerId, aDimension: Handle_IGESData_IGESEntity, entities: Handle_IGESData_HArray1OfIGESEntity): void;
  NbDimensions(): Graphic3d_ZLayerId;
  NbGeometryEntities(): Graphic3d_ZLayerId;
  DimensionEntity(): Handle_IGESData_IGESEntity;
  GeometryEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDimen_DimensionedGeometry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_DimensionedGeometry): void;
  get(): IGESDimen_DimensionedGeometry;
  delete(): void;
}

  export declare class Handle_IGESDimen_DimensionedGeometry_1 extends Handle_IGESDimen_DimensionedGeometry {
    constructor();
  }

  export declare class Handle_IGESDimen_DimensionedGeometry_2 extends Handle_IGESDimen_DimensionedGeometry {
    constructor(thePtr: IGESDimen_DimensionedGeometry);
  }

  export declare class Handle_IGESDimen_DimensionedGeometry_3 extends Handle_IGESDimen_DimensionedGeometry {
    constructor(theHandle: Handle_IGESDimen_DimensionedGeometry);
  }

  export declare class Handle_IGESDimen_DimensionedGeometry_4 extends Handle_IGESDimen_DimensionedGeometry {
    constructor(theHandle: Handle_IGESDimen_DimensionedGeometry);
  }

export declare class Handle_IGESDimen_HArray1OfGeneralNote {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDimen_HArray1OfGeneralNote): void;
  get(): IGESDimen_HArray1OfGeneralNote;
  delete(): void;
}

  export declare class Handle_IGESDimen_HArray1OfGeneralNote_1 extends Handle_IGESDimen_HArray1OfGeneralNote {
    constructor();
  }

  export declare class Handle_IGESDimen_HArray1OfGeneralNote_2 extends Handle_IGESDimen_HArray1OfGeneralNote {
    constructor(thePtr: IGESDimen_HArray1OfGeneralNote);
  }

  export declare class Handle_IGESDimen_HArray1OfGeneralNote_3 extends Handle_IGESDimen_HArray1OfGeneralNote {
    constructor(theHandle: Handle_IGESDimen_HArray1OfGeneralNote);
  }

  export declare class Handle_IGESDimen_HArray1OfGeneralNote_4 extends Handle_IGESDimen_HArray1OfGeneralNote {
    constructor(theHandle: Handle_IGESDimen_HArray1OfGeneralNote);
  }

export declare class IGESDimen_ToolBasicDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_BasicDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_BasicDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_BasicDimension, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_BasicDimension): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_BasicDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_BasicDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_BasicDimension, entto: Handle_IGESDimen_BasicDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_BasicDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolPointDimension {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_PointDimension, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_PointDimension, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_PointDimension, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_PointDimension): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_PointDimension, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_PointDimension, entto: Handle_IGESDimen_PointDimension, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_PointDimension, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolWitnessLine {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_WitnessLine, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_WitnessLine, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_WitnessLine, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDimen_WitnessLine): Standard_Boolean;
  DirChecker(ent: Handle_IGESDimen_WitnessLine): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_WitnessLine, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_WitnessLine, entto: Handle_IGESDimen_WitnessLine, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_WitnessLine, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDimen_ToolLeaderArrow {
  constructor()
  ReadOwnParams(ent: Handle_IGESDimen_LeaderArrow, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDimen_LeaderArrow, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDimen_LeaderArrow, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDimen_LeaderArrow): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDimen_LeaderArrow, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDimen_LeaderArrow, entto: Handle_IGESDimen_LeaderArrow, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDimen_LeaderArrow, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class XCAFApp_Application extends TDocStd_Application {
  ResourcesName(): Standard_CString;
  InitDocument(aDoc: Handle_TDocStd_Document): void;
  static GetApplication(): Handle_XCAFApp_Application;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFApp_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFApp_Application): void;
  get(): XCAFApp_Application;
  delete(): void;
}

  export declare class Handle_XCAFApp_Application_1 extends Handle_XCAFApp_Application {
    constructor();
  }

  export declare class Handle_XCAFApp_Application_2 extends Handle_XCAFApp_Application {
    constructor(thePtr: XCAFApp_Application);
  }

  export declare class Handle_XCAFApp_Application_3 extends Handle_XCAFApp_Application {
    constructor(theHandle: Handle_XCAFApp_Application);
  }

  export declare class Handle_XCAFApp_Application_4 extends Handle_XCAFApp_Application {
    constructor(theHandle: Handle_XCAFApp_Application);
  }

export declare class Handle_TColStd_HSequenceOfHExtendedString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfHExtendedString): void;
  get(): TColStd_HSequenceOfHExtendedString;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfHExtendedString_1 extends Handle_TColStd_HSequenceOfHExtendedString {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfHExtendedString_2 extends Handle_TColStd_HSequenceOfHExtendedString {
    constructor(thePtr: TColStd_HSequenceOfHExtendedString);
  }

  export declare class Handle_TColStd_HSequenceOfHExtendedString_3 extends Handle_TColStd_HSequenceOfHExtendedString {
    constructor(theHandle: Handle_TColStd_HSequenceOfHExtendedString);
  }

  export declare class Handle_TColStd_HSequenceOfHExtendedString_4 extends Handle_TColStd_HSequenceOfHExtendedString {
    constructor(theHandle: Handle_TColStd_HSequenceOfHExtendedString);
  }

export declare class Handle_TColStd_HSequenceOfTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfTransient): void;
  get(): TColStd_HSequenceOfTransient;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfTransient_1 extends Handle_TColStd_HSequenceOfTransient {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfTransient_2 extends Handle_TColStd_HSequenceOfTransient {
    constructor(thePtr: TColStd_HSequenceOfTransient);
  }

  export declare class Handle_TColStd_HSequenceOfTransient_3 extends Handle_TColStd_HSequenceOfTransient {
    constructor(theHandle: Handle_TColStd_HSequenceOfTransient);
  }

  export declare class Handle_TColStd_HSequenceOfTransient_4 extends Handle_TColStd_HSequenceOfTransient {
    constructor(theHandle: Handle_TColStd_HSequenceOfTransient);
  }

export declare class TColStd_MapRealHasher {
  constructor();
  static HashCode(theKey: Standard_Real, theUpperBound: Standard_Integer): Standard_Integer;
  static IsEqual(theKey1: Standard_Real, theKey2: Standard_Real): Standard_Boolean;
  delete(): void;
}

export declare class TColStd_MapOfInteger extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Add(K: Standard_Integer): Standard_Boolean;
  Added(K: Standard_Integer): Standard_Integer;
  Contains_1(K: Standard_Integer): Standard_Boolean;
  Remove(K: Standard_Integer): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  Contains_2(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  Union(theLeft: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>, theRight: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): void;
  Unite(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  HasIntersection(theMap: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  Intersection(theLeft: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>, theRight: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): void;
  Intersect(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  Subtraction(theLeft: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>, theRight: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): void;
  Subtract(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  Difference(theLeft: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>, theRight: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): void;
  Differ(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>): Standard_Boolean;
  delete(): void;
}

  export declare class TColStd_MapOfInteger_1 extends TColStd_MapOfInteger {
    constructor();
  }

  export declare class TColStd_MapOfInteger_2 extends TColStd_MapOfInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_MapOfInteger_3 extends TColStd_MapOfInteger {
    constructor(theOther: NCollection_Map<Standard_Integer, TColStd_MapIntegerHasher>);
  }

export declare class TColStd_DataMapOfIntegerInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, Standard_Integer, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, Standard_Integer, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): Standard_Integer;
  ChangeSeek(theKey: Standard_Integer): Standard_Integer;
  ChangeFind(theKey: Standard_Integer): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_DataMapOfIntegerInteger_1 extends TColStd_DataMapOfIntegerInteger {
    constructor();
  }

  export declare class TColStd_DataMapOfIntegerInteger_2 extends TColStd_DataMapOfIntegerInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_DataMapOfIntegerInteger_3 extends TColStd_DataMapOfIntegerInteger {
    constructor(theOther: NCollection_DataMap<Standard_Integer, Standard_Integer, TColStd_MapIntegerHasher>);
  }

export declare class TColStd_IndexedMapOfReal extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_IndexedMap<Standard_Real, TColStd_MapRealHasher>): void;
  Assign(theOther: NCollection_IndexedMap<Standard_Real, TColStd_MapRealHasher>): any;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: Standard_Real): Standard_Integer;
  Contains(theKey1: Standard_Real): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: Standard_Real): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: Standard_Real): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): Standard_Real;
  FindIndex(theKey1: Standard_Real): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_IndexedMapOfReal_1 extends TColStd_IndexedMapOfReal {
    constructor();
  }

  export declare class TColStd_IndexedMapOfReal_2 extends TColStd_IndexedMapOfReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_IndexedMapOfReal_3 extends TColStd_IndexedMapOfReal {
    constructor(theOther: NCollection_IndexedMap<Standard_Real, TColStd_MapRealHasher>);
  }

export declare class TColStd_Array1OfExtendedString {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TCollection_ExtendedString): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfExtendedString): TColStd_Array1OfExtendedString;
  Move(theOther: TColStd_Array1OfExtendedString): TColStd_Array1OfExtendedString;
  First(): TCollection_ExtendedString;
  ChangeFirst(): TCollection_ExtendedString;
  Last(): TCollection_ExtendedString;
  ChangeLast(): TCollection_ExtendedString;
  Value(theIndex: Standard_Integer): TCollection_ExtendedString;
  ChangeValue(theIndex: Standard_Integer): TCollection_ExtendedString;
  SetValue(theIndex: Standard_Integer, theItem: TCollection_ExtendedString): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfExtendedString_1 extends TColStd_Array1OfExtendedString {
    constructor();
  }

  export declare class TColStd_Array1OfExtendedString_2 extends TColStd_Array1OfExtendedString {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfExtendedString_3 extends TColStd_Array1OfExtendedString {
    constructor(theOther: TColStd_Array1OfExtendedString);
  }

  export declare class TColStd_Array1OfExtendedString_4 extends TColStd_Array1OfExtendedString {
    constructor(theOther: TColStd_Array1OfExtendedString);
  }

  export declare class TColStd_Array1OfExtendedString_5 extends TColStd_Array1OfExtendedString {
    constructor(theBegin: TCollection_ExtendedString, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColStd_HSequenceOfExtendedString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfExtendedString): void;
  get(): TColStd_HSequenceOfExtendedString;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfExtendedString_1 extends Handle_TColStd_HSequenceOfExtendedString {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfExtendedString_2 extends Handle_TColStd_HSequenceOfExtendedString {
    constructor(thePtr: TColStd_HSequenceOfExtendedString);
  }

  export declare class Handle_TColStd_HSequenceOfExtendedString_3 extends Handle_TColStd_HSequenceOfExtendedString {
    constructor(theHandle: Handle_TColStd_HSequenceOfExtendedString);
  }

  export declare class Handle_TColStd_HSequenceOfExtendedString_4 extends Handle_TColStd_HSequenceOfExtendedString {
    constructor(theHandle: Handle_TColStd_HSequenceOfExtendedString);
  }

export declare class TColStd_SequenceOfExtendedString extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColStd_SequenceOfExtendedString): TColStd_SequenceOfExtendedString;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TCollection_ExtendedString): void;
  Append_2(theSeq: TColStd_SequenceOfExtendedString): void;
  Prepend_1(theItem: TCollection_ExtendedString): void;
  Prepend_2(theSeq: TColStd_SequenceOfExtendedString): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TCollection_ExtendedString): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfExtendedString): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfExtendedString): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TCollection_ExtendedString): void;
  Split(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfExtendedString): void;
  First(): TCollection_ExtendedString;
  ChangeFirst(): TCollection_ExtendedString;
  Last(): TCollection_ExtendedString;
  ChangeLast(): TCollection_ExtendedString;
  Value(theIndex: Standard_Integer): TCollection_ExtendedString;
  ChangeValue(theIndex: Standard_Integer): TCollection_ExtendedString;
  SetValue(theIndex: Standard_Integer, theItem: TCollection_ExtendedString): void;
  delete(): void;
}

  export declare class TColStd_SequenceOfExtendedString_1 extends TColStd_SequenceOfExtendedString {
    constructor();
  }

  export declare class TColStd_SequenceOfExtendedString_2 extends TColStd_SequenceOfExtendedString {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_SequenceOfExtendedString_3 extends TColStd_SequenceOfExtendedString {
    constructor(theOther: TColStd_SequenceOfExtendedString);
  }

export declare class TColStd_Array1OfBoolean {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Standard_Boolean): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfBoolean): TColStd_Array1OfBoolean;
  Move(theOther: TColStd_Array1OfBoolean): TColStd_Array1OfBoolean;
  First(): Standard_Boolean;
  ChangeFirst(): Standard_Boolean;
  Last(): Standard_Boolean;
  ChangeLast(): Standard_Boolean;
  Value(theIndex: Standard_Integer): Standard_Boolean;
  ChangeValue(theIndex: Standard_Integer): Standard_Boolean;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Boolean): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfBoolean_1 extends TColStd_Array1OfBoolean {
    constructor();
  }

  export declare class TColStd_Array1OfBoolean_2 extends TColStd_Array1OfBoolean {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfBoolean_3 extends TColStd_Array1OfBoolean {
    constructor(theOther: TColStd_Array1OfBoolean);
  }

  export declare class TColStd_Array1OfBoolean_4 extends TColStd_Array1OfBoolean {
    constructor(theOther: TColStd_Array1OfBoolean);
  }

  export declare class TColStd_Array1OfBoolean_5 extends TColStd_Array1OfBoolean {
    constructor(theBegin: Standard_Boolean, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColStd_SequenceOfBoolean extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColStd_SequenceOfBoolean): TColStd_SequenceOfBoolean;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Standard_Boolean): void;
  Append_2(theSeq: TColStd_SequenceOfBoolean): void;
  Prepend_1(theItem: Standard_Boolean): void;
  Prepend_2(theSeq: TColStd_SequenceOfBoolean): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Standard_Boolean): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfBoolean): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfBoolean): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Standard_Boolean): void;
  Split(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfBoolean): void;
  First(): Standard_Boolean;
  ChangeFirst(): Standard_Boolean;
  Last(): Standard_Boolean;
  ChangeLast(): Standard_Boolean;
  Value(theIndex: Standard_Integer): Standard_Boolean;
  ChangeValue(theIndex: Standard_Integer): Standard_Boolean;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_SequenceOfBoolean_1 extends TColStd_SequenceOfBoolean {
    constructor();
  }

  export declare class TColStd_SequenceOfBoolean_2 extends TColStd_SequenceOfBoolean {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_SequenceOfBoolean_3 extends TColStd_SequenceOfBoolean {
    constructor(theOther: TColStd_SequenceOfBoolean);
  }

export declare class Handle_TColStd_HArray2OfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray2OfInteger): void;
  get(): TColStd_HArray2OfInteger;
  delete(): void;
}

  export declare class Handle_TColStd_HArray2OfInteger_1 extends Handle_TColStd_HArray2OfInteger {
    constructor();
  }

  export declare class Handle_TColStd_HArray2OfInteger_2 extends Handle_TColStd_HArray2OfInteger {
    constructor(thePtr: TColStd_HArray2OfInteger);
  }

  export declare class Handle_TColStd_HArray2OfInteger_3 extends Handle_TColStd_HArray2OfInteger {
    constructor(theHandle: Handle_TColStd_HArray2OfInteger);
  }

  export declare class Handle_TColStd_HArray2OfInteger_4 extends Handle_TColStd_HArray2OfInteger {
    constructor(theHandle: Handle_TColStd_HArray2OfInteger);
  }

export declare class Handle_TColStd_HArray1OfByte {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfByte): void;
  get(): TColStd_HArray1OfByte;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfByte_1 extends Handle_TColStd_HArray1OfByte {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfByte_2 extends Handle_TColStd_HArray1OfByte {
    constructor(thePtr: TColStd_HArray1OfByte);
  }

  export declare class Handle_TColStd_HArray1OfByte_3 extends Handle_TColStd_HArray1OfByte {
    constructor(theHandle: Handle_TColStd_HArray1OfByte);
  }

  export declare class Handle_TColStd_HArray1OfByte_4 extends Handle_TColStd_HArray1OfByte {
    constructor(theHandle: Handle_TColStd_HArray1OfByte);
  }

export declare class Handle_TColStd_HArray1OfExtendedString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfExtendedString): void;
  get(): TColStd_HArray1OfExtendedString;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfExtendedString_1 extends Handle_TColStd_HArray1OfExtendedString {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfExtendedString_2 extends Handle_TColStd_HArray1OfExtendedString {
    constructor(thePtr: TColStd_HArray1OfExtendedString);
  }

  export declare class Handle_TColStd_HArray1OfExtendedString_3 extends Handle_TColStd_HArray1OfExtendedString {
    constructor(theHandle: Handle_TColStd_HArray1OfExtendedString);
  }

  export declare class Handle_TColStd_HArray1OfExtendedString_4 extends Handle_TColStd_HArray1OfExtendedString {
    constructor(theHandle: Handle_TColStd_HArray1OfExtendedString);
  }

export declare class TColStd_Array1OfInteger {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Standard_Integer): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfInteger): TColStd_Array1OfInteger;
  Move(theOther: TColStd_Array1OfInteger): TColStd_Array1OfInteger;
  First(): Standard_Integer;
  ChangeFirst(): Standard_Integer;
  Last(): Standard_Integer;
  ChangeLast(): Standard_Integer;
  Value(theIndex: Standard_Integer): Standard_Integer;
  ChangeValue(theIndex: Standard_Integer): Standard_Integer;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Integer): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfInteger_1 extends TColStd_Array1OfInteger {
    constructor();
  }

  export declare class TColStd_Array1OfInteger_2 extends TColStd_Array1OfInteger {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfInteger_3 extends TColStd_Array1OfInteger {
    constructor(theOther: TColStd_Array1OfInteger);
  }

  export declare class TColStd_Array1OfInteger_4 extends TColStd_Array1OfInteger {
    constructor(theOther: TColStd_Array1OfInteger);
  }

  export declare class TColStd_Array1OfInteger_5 extends TColStd_Array1OfInteger {
    constructor(theBegin: Standard_Integer, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColStd_SequenceOfAddress extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColStd_SequenceOfAddress): TColStd_SequenceOfAddress;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Standard_Address): void;
  Append_2(theSeq: TColStd_SequenceOfAddress): void;
  Prepend_1(theItem: Standard_Address): void;
  Prepend_2(theSeq: TColStd_SequenceOfAddress): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Standard_Address): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfAddress): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfAddress): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Standard_Address): void;
  Split(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfAddress): void;
  First(): Standard_Address;
  ChangeFirst(): Standard_Address;
  Last(): Standard_Address;
  ChangeLast(): Standard_Address;
  Value(theIndex: Standard_Integer): Standard_Address;
  ChangeValue(theIndex: Standard_Integer): Standard_Address;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Address): void;
  delete(): void;
}

  export declare class TColStd_SequenceOfAddress_1 extends TColStd_SequenceOfAddress {
    constructor();
  }

  export declare class TColStd_SequenceOfAddress_2 extends TColStd_SequenceOfAddress {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_SequenceOfAddress_3 extends TColStd_SequenceOfAddress {
    constructor(theOther: TColStd_SequenceOfAddress);
  }

export declare class Handle_TColStd_HSequenceOfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfReal): void;
  get(): TColStd_HSequenceOfReal;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfReal_1 extends Handle_TColStd_HSequenceOfReal {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfReal_2 extends Handle_TColStd_HSequenceOfReal {
    constructor(thePtr: TColStd_HSequenceOfReal);
  }

  export declare class Handle_TColStd_HSequenceOfReal_3 extends Handle_TColStd_HSequenceOfReal {
    constructor(theHandle: Handle_TColStd_HSequenceOfReal);
  }

  export declare class Handle_TColStd_HSequenceOfReal_4 extends Handle_TColStd_HSequenceOfReal {
    constructor(theHandle: Handle_TColStd_HSequenceOfReal);
  }

export declare class TColStd_DataMapOfStringInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TColStd_DataMapOfStringInteger): void;
  Assign(theOther: TColStd_DataMapOfStringInteger): TColStd_DataMapOfStringInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_ExtendedString, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: TCollection_ExtendedString, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: TCollection_ExtendedString): Standard_Boolean;
  UnBind(theKey: TCollection_ExtendedString): Standard_Boolean;
  Seek(theKey: TCollection_ExtendedString): Standard_Integer;
  ChangeSeek(theKey: TCollection_ExtendedString): Standard_Integer;
  ChangeFind(theKey: TCollection_ExtendedString): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_DataMapOfStringInteger_1 extends TColStd_DataMapOfStringInteger {
    constructor();
  }

  export declare class TColStd_DataMapOfStringInteger_2 extends TColStd_DataMapOfStringInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_DataMapOfStringInteger_3 extends TColStd_DataMapOfStringInteger {
    constructor(theOther: TColStd_DataMapOfStringInteger);
  }

export declare class TColStd_Array1OfByte {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Standard_Byte): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfByte): TColStd_Array1OfByte;
  Move(theOther: TColStd_Array1OfByte): TColStd_Array1OfByte;
  First(): Standard_Byte;
  ChangeFirst(): Standard_Byte;
  Last(): Standard_Byte;
  ChangeLast(): Standard_Byte;
  Value(theIndex: Standard_Integer): Standard_Byte;
  ChangeValue(theIndex: Standard_Integer): Standard_Byte;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Byte): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfByte_1 extends TColStd_Array1OfByte {
    constructor();
  }

  export declare class TColStd_Array1OfByte_2 extends TColStd_Array1OfByte {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfByte_3 extends TColStd_Array1OfByte {
    constructor(theOther: TColStd_Array1OfByte);
  }

  export declare class TColStd_Array1OfByte_4 extends TColStd_Array1OfByte {
    constructor(theOther: TColStd_Array1OfByte);
  }

  export declare class TColStd_Array1OfByte_5 extends TColStd_Array1OfByte {
    constructor(theBegin: Standard_Byte, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColStd_MapOfAsciiString extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TColStd_MapOfAsciiString): void;
  Assign(theOther: TColStd_MapOfAsciiString): TColStd_MapOfAsciiString;
  ReSize(N: Standard_Integer): void;
  Add(K: TCollection_AsciiString): Standard_Boolean;
  Added(K: TCollection_AsciiString): TCollection_AsciiString;
  Contains_1(K: TCollection_AsciiString): Standard_Boolean;
  Remove(K: TCollection_AsciiString): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: TColStd_MapOfAsciiString): Standard_Boolean;
  Contains_2(theOther: TColStd_MapOfAsciiString): Standard_Boolean;
  Union(theLeft: TColStd_MapOfAsciiString, theRight: TColStd_MapOfAsciiString): void;
  Unite(theOther: TColStd_MapOfAsciiString): Standard_Boolean;
  HasIntersection(theMap: TColStd_MapOfAsciiString): Standard_Boolean;
  Intersection(theLeft: TColStd_MapOfAsciiString, theRight: TColStd_MapOfAsciiString): void;
  Intersect(theOther: TColStd_MapOfAsciiString): Standard_Boolean;
  Subtraction(theLeft: TColStd_MapOfAsciiString, theRight: TColStd_MapOfAsciiString): void;
  Subtract(theOther: TColStd_MapOfAsciiString): Standard_Boolean;
  Difference(theLeft: TColStd_MapOfAsciiString, theRight: TColStd_MapOfAsciiString): void;
  Differ(theOther: TColStd_MapOfAsciiString): Standard_Boolean;
  delete(): void;
}

  export declare class TColStd_MapOfAsciiString_1 extends TColStd_MapOfAsciiString {
    constructor();
  }

  export declare class TColStd_MapOfAsciiString_2 extends TColStd_MapOfAsciiString {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_MapOfAsciiString_3 extends TColStd_MapOfAsciiString {
    constructor(theOther: TColStd_MapOfAsciiString);
  }

export declare class TColStd_PackedMapOfInteger {
  Assign(a0: TColStd_PackedMapOfInteger): TColStd_PackedMapOfInteger;
  ReSize(NbBuckets: Graphic3d_ZLayerId): void;
  Clear(): void;
  Add(aKey: Graphic3d_ZLayerId): Standard_Boolean;
  Contains(aKey: Graphic3d_ZLayerId): Standard_Boolean;
  Remove(aKey: Graphic3d_ZLayerId): Standard_Boolean;
  NbBuckets(): Graphic3d_ZLayerId;
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Statistics(outStream: Standard_OStream): void;
  GetMinimalMapped(): Graphic3d_ZLayerId;
  GetMaximalMapped(): Graphic3d_ZLayerId;
  Union(a0: TColStd_PackedMapOfInteger, a1: TColStd_PackedMapOfInteger): void;
  Unite(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  Intersection(a0: TColStd_PackedMapOfInteger, a1: TColStd_PackedMapOfInteger): void;
  Intersect(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  Subtraction(a0: TColStd_PackedMapOfInteger, a1: TColStd_PackedMapOfInteger): void;
  Subtract(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  Difference(a0: TColStd_PackedMapOfInteger, a1: TColStd_PackedMapOfInteger): void;
  Differ(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  IsEqual(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  IsSubset(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  HasIntersection(a0: TColStd_PackedMapOfInteger): Standard_Boolean;
  delete(): void;
}

  export declare class TColStd_PackedMapOfInteger_1 extends TColStd_PackedMapOfInteger {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TColStd_PackedMapOfInteger_2 extends TColStd_PackedMapOfInteger {
    constructor(theOther: TColStd_PackedMapOfInteger);
  }

export declare class TColStd_Array1OfListOfInteger {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TColStd_ListOfInteger): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfListOfInteger): TColStd_Array1OfListOfInteger;
  Move(theOther: TColStd_Array1OfListOfInteger): TColStd_Array1OfListOfInteger;
  First(): TColStd_ListOfInteger;
  ChangeFirst(): TColStd_ListOfInteger;
  Last(): TColStd_ListOfInteger;
  ChangeLast(): TColStd_ListOfInteger;
  Value(theIndex: Standard_Integer): TColStd_ListOfInteger;
  ChangeValue(theIndex: Standard_Integer): TColStd_ListOfInteger;
  SetValue(theIndex: Standard_Integer, theItem: TColStd_ListOfInteger): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfListOfInteger_1 extends TColStd_Array1OfListOfInteger {
    constructor();
  }

  export declare class TColStd_Array1OfListOfInteger_2 extends TColStd_Array1OfListOfInteger {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfListOfInteger_3 extends TColStd_Array1OfListOfInteger {
    constructor(theOther: TColStd_Array1OfListOfInteger);
  }

  export declare class TColStd_Array1OfListOfInteger_4 extends TColStd_Array1OfListOfInteger {
    constructor(theOther: TColStd_Array1OfListOfInteger);
  }

  export declare class TColStd_Array1OfListOfInteger_5 extends TColStd_Array1OfListOfInteger {
    constructor(theBegin: TColStd_ListOfInteger, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColStd_HArray2OfTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray2OfTransient): void;
  get(): TColStd_HArray2OfTransient;
  delete(): void;
}

  export declare class Handle_TColStd_HArray2OfTransient_1 extends Handle_TColStd_HArray2OfTransient {
    constructor();
  }

  export declare class Handle_TColStd_HArray2OfTransient_2 extends Handle_TColStd_HArray2OfTransient {
    constructor(thePtr: TColStd_HArray2OfTransient);
  }

  export declare class Handle_TColStd_HArray2OfTransient_3 extends Handle_TColStd_HArray2OfTransient {
    constructor(theHandle: Handle_TColStd_HArray2OfTransient);
  }

  export declare class Handle_TColStd_HArray2OfTransient_4 extends Handle_TColStd_HArray2OfTransient {
    constructor(theHandle: Handle_TColStd_HArray2OfTransient);
  }

export declare class Handle_TColStd_HArray2OfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray2OfReal): void;
  get(): TColStd_HArray2OfReal;
  delete(): void;
}

  export declare class Handle_TColStd_HArray2OfReal_1 extends Handle_TColStd_HArray2OfReal {
    constructor();
  }

  export declare class Handle_TColStd_HArray2OfReal_2 extends Handle_TColStd_HArray2OfReal {
    constructor(thePtr: TColStd_HArray2OfReal);
  }

  export declare class Handle_TColStd_HArray2OfReal_3 extends Handle_TColStd_HArray2OfReal {
    constructor(theHandle: Handle_TColStd_HArray2OfReal);
  }

  export declare class Handle_TColStd_HArray2OfReal_4 extends Handle_TColStd_HArray2OfReal {
    constructor(theHandle: Handle_TColStd_HArray2OfReal);
  }

export declare class TColStd_Array2OfReal {
  Init(theValue: Standard_Real): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColStd_Array2OfReal): TColStd_Array2OfReal;
  Move(theOther: TColStd_Array2OfReal): TColStd_Array2OfReal;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Real;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Real;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Standard_Real): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array2OfReal_1 extends TColStd_Array2OfReal {
    constructor();
  }

  export declare class TColStd_Array2OfReal_2 extends TColStd_Array2OfReal {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColStd_Array2OfReal_3 extends TColStd_Array2OfReal {
    constructor(theOther: TColStd_Array2OfReal);
  }

  export declare class TColStd_Array2OfReal_4 extends TColStd_Array2OfReal {
    constructor(theOther: TColStd_Array2OfReal);
  }

  export declare class TColStd_Array2OfReal_5 extends TColStd_Array2OfReal {
    constructor(theBegin: Standard_Real, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TColStd_HArray1OfCharacter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfCharacter): void;
  get(): TColStd_HArray1OfCharacter;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfCharacter_1 extends Handle_TColStd_HArray1OfCharacter {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfCharacter_2 extends Handle_TColStd_HArray1OfCharacter {
    constructor(thePtr: TColStd_HArray1OfCharacter);
  }

  export declare class Handle_TColStd_HArray1OfCharacter_3 extends Handle_TColStd_HArray1OfCharacter {
    constructor(theHandle: Handle_TColStd_HArray1OfCharacter);
  }

  export declare class Handle_TColStd_HArray1OfCharacter_4 extends Handle_TColStd_HArray1OfCharacter {
    constructor(theHandle: Handle_TColStd_HArray1OfCharacter);
  }

export declare class TColStd_SequenceOfAsciiString extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColStd_SequenceOfAsciiString): TColStd_SequenceOfAsciiString;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TCollection_AsciiString): void;
  Append_2(theSeq: TColStd_SequenceOfAsciiString): void;
  Prepend_1(theItem: TCollection_AsciiString): void;
  Prepend_2(theSeq: TColStd_SequenceOfAsciiString): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TCollection_AsciiString): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfAsciiString): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfAsciiString): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TCollection_AsciiString): void;
  Split(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfAsciiString): void;
  First(): TCollection_AsciiString;
  ChangeFirst(): TCollection_AsciiString;
  Last(): TCollection_AsciiString;
  ChangeLast(): TCollection_AsciiString;
  Value(theIndex: Standard_Integer): TCollection_AsciiString;
  ChangeValue(theIndex: Standard_Integer): TCollection_AsciiString;
  SetValue(theIndex: Standard_Integer, theItem: TCollection_AsciiString): void;
  delete(): void;
}

  export declare class TColStd_SequenceOfAsciiString_1 extends TColStd_SequenceOfAsciiString {
    constructor();
  }

  export declare class TColStd_SequenceOfAsciiString_2 extends TColStd_SequenceOfAsciiString {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_SequenceOfAsciiString_3 extends TColStd_SequenceOfAsciiString {
    constructor(theOther: TColStd_SequenceOfAsciiString);
  }

export declare class TColStd_DataMapOfIntegerListOfInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TColStd_ListOfInteger, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TColStd_ListOfInteger, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TColStd_ListOfInteger): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TColStd_ListOfInteger): TColStd_ListOfInteger;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TColStd_ListOfInteger;
  ChangeSeek(theKey: Standard_Integer): TColStd_ListOfInteger;
  ChangeFind(theKey: Standard_Integer): TColStd_ListOfInteger;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_DataMapOfIntegerListOfInteger_1 extends TColStd_DataMapOfIntegerListOfInteger {
    constructor();
  }

  export declare class TColStd_DataMapOfIntegerListOfInteger_2 extends TColStd_DataMapOfIntegerListOfInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_DataMapOfIntegerListOfInteger_3 extends TColStd_DataMapOfIntegerListOfInteger {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TColStd_ListOfInteger, TColStd_MapIntegerHasher>);
  }

export declare class Handle_TColStd_HArray2OfBoolean {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray2OfBoolean): void;
  get(): TColStd_HArray2OfBoolean;
  delete(): void;
}

  export declare class Handle_TColStd_HArray2OfBoolean_1 extends Handle_TColStd_HArray2OfBoolean {
    constructor();
  }

  export declare class Handle_TColStd_HArray2OfBoolean_2 extends Handle_TColStd_HArray2OfBoolean {
    constructor(thePtr: TColStd_HArray2OfBoolean);
  }

  export declare class Handle_TColStd_HArray2OfBoolean_3 extends Handle_TColStd_HArray2OfBoolean {
    constructor(theHandle: Handle_TColStd_HArray2OfBoolean);
  }

  export declare class Handle_TColStd_HArray2OfBoolean_4 extends Handle_TColStd_HArray2OfBoolean {
    constructor(theHandle: Handle_TColStd_HArray2OfBoolean);
  }

export declare class Handle_TColStd_HArray1OfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfInteger): void;
  get(): TColStd_HArray1OfInteger;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfInteger_1 extends Handle_TColStd_HArray1OfInteger {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfInteger_2 extends Handle_TColStd_HArray1OfInteger {
    constructor(thePtr: TColStd_HArray1OfInteger);
  }

  export declare class Handle_TColStd_HArray1OfInteger_3 extends Handle_TColStd_HArray1OfInteger {
    constructor(theHandle: Handle_TColStd_HArray1OfInteger);
  }

  export declare class Handle_TColStd_HArray1OfInteger_4 extends Handle_TColStd_HArray1OfInteger {
    constructor(theHandle: Handle_TColStd_HArray1OfInteger);
  }

export declare class TColStd_DataMapOfAsciiStringInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TColStd_DataMapOfAsciiStringInteger): void;
  Assign(theOther: TColStd_DataMapOfAsciiStringInteger): TColStd_DataMapOfAsciiStringInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_AsciiString, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: TCollection_AsciiString, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: TCollection_AsciiString): Standard_Boolean;
  UnBind(theKey: TCollection_AsciiString): Standard_Boolean;
  Seek(theKey: TCollection_AsciiString): Standard_Integer;
  ChangeSeek(theKey: TCollection_AsciiString): Standard_Integer;
  ChangeFind(theKey: TCollection_AsciiString): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_DataMapOfAsciiStringInteger_1 extends TColStd_DataMapOfAsciiStringInteger {
    constructor();
  }

  export declare class TColStd_DataMapOfAsciiStringInteger_2 extends TColStd_DataMapOfAsciiStringInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_DataMapOfAsciiStringInteger_3 extends TColStd_DataMapOfAsciiStringInteger {
    constructor(theOther: TColStd_DataMapOfAsciiStringInteger);
  }

export declare class TColStd_ListOfInteger extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TColStd_ListOfInteger): TColStd_ListOfInteger;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Standard_Integer;
  First_2(): Standard_Integer;
  Last_1(): Standard_Integer;
  Last_2(): Standard_Integer;
  Append_1(theItem: Standard_Integer): Standard_Integer;
  Append_3(theOther: TColStd_ListOfInteger): void;
  Prepend_1(theItem: Standard_Integer): Standard_Integer;
  Prepend_2(theOther: TColStd_ListOfInteger): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TColStd_ListOfInteger_1 extends TColStd_ListOfInteger {
    constructor();
  }

  export declare class TColStd_ListOfInteger_2 extends TColStd_ListOfInteger {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_ListOfInteger_3 extends TColStd_ListOfInteger {
    constructor(theOther: TColStd_ListOfInteger);
  }

export declare class TColStd_ListOfAsciiString extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TColStd_ListOfAsciiString): TColStd_ListOfAsciiString;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TCollection_AsciiString;
  First_2(): TCollection_AsciiString;
  Last_1(): TCollection_AsciiString;
  Last_2(): TCollection_AsciiString;
  Append_1(theItem: TCollection_AsciiString): TCollection_AsciiString;
  Append_3(theOther: TColStd_ListOfAsciiString): void;
  Prepend_1(theItem: TCollection_AsciiString): TCollection_AsciiString;
  Prepend_2(theOther: TColStd_ListOfAsciiString): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TColStd_ListOfAsciiString_1 extends TColStd_ListOfAsciiString {
    constructor();
  }

  export declare class TColStd_ListOfAsciiString_2 extends TColStd_ListOfAsciiString {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_ListOfAsciiString_3 extends TColStd_ListOfAsciiString {
    constructor(theOther: TColStd_ListOfAsciiString);
  }

export declare class TColStd_SequenceOfReal extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColStd_SequenceOfReal): TColStd_SequenceOfReal;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Standard_Real): void;
  Append_2(theSeq: TColStd_SequenceOfReal): void;
  Prepend_1(theItem: Standard_Real): void;
  Prepend_2(theSeq: TColStd_SequenceOfReal): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Standard_Real): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfReal): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfReal): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Standard_Real): void;
  Split(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfReal): void;
  First(): Standard_Real;
  ChangeFirst(): Standard_Real;
  Last(): Standard_Real;
  ChangeLast(): Standard_Real;
  Value(theIndex: Standard_Integer): Standard_Real;
  ChangeValue(theIndex: Standard_Integer): Standard_Real;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Real): void;
  delete(): void;
}

  export declare class TColStd_SequenceOfReal_1 extends TColStd_SequenceOfReal {
    constructor();
  }

  export declare class TColStd_SequenceOfReal_2 extends TColStd_SequenceOfReal {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_SequenceOfReal_3 extends TColStd_SequenceOfReal {
    constructor(theOther: TColStd_SequenceOfReal);
  }

export declare class Handle_TColStd_HArray2OfCharacter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray2OfCharacter): void;
  get(): TColStd_HArray2OfCharacter;
  delete(): void;
}

  export declare class Handle_TColStd_HArray2OfCharacter_1 extends Handle_TColStd_HArray2OfCharacter {
    constructor();
  }

  export declare class Handle_TColStd_HArray2OfCharacter_2 extends Handle_TColStd_HArray2OfCharacter {
    constructor(thePtr: TColStd_HArray2OfCharacter);
  }

  export declare class Handle_TColStd_HArray2OfCharacter_3 extends Handle_TColStd_HArray2OfCharacter {
    constructor(theHandle: Handle_TColStd_HArray2OfCharacter);
  }

  export declare class Handle_TColStd_HArray2OfCharacter_4 extends Handle_TColStd_HArray2OfCharacter {
    constructor(theHandle: Handle_TColStd_HArray2OfCharacter);
  }

export declare class TColStd_Array1OfAsciiString {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TCollection_AsciiString): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfAsciiString): TColStd_Array1OfAsciiString;
  Move(theOther: TColStd_Array1OfAsciiString): TColStd_Array1OfAsciiString;
  First(): TCollection_AsciiString;
  ChangeFirst(): TCollection_AsciiString;
  Last(): TCollection_AsciiString;
  ChangeLast(): TCollection_AsciiString;
  Value(theIndex: Standard_Integer): TCollection_AsciiString;
  ChangeValue(theIndex: Standard_Integer): TCollection_AsciiString;
  SetValue(theIndex: Standard_Integer, theItem: TCollection_AsciiString): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfAsciiString_1 extends TColStd_Array1OfAsciiString {
    constructor();
  }

  export declare class TColStd_Array1OfAsciiString_2 extends TColStd_Array1OfAsciiString {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfAsciiString_3 extends TColStd_Array1OfAsciiString {
    constructor(theOther: TColStd_Array1OfAsciiString);
  }

  export declare class TColStd_Array1OfAsciiString_4 extends TColStd_Array1OfAsciiString {
    constructor(theOther: TColStd_Array1OfAsciiString);
  }

  export declare class TColStd_Array1OfAsciiString_5 extends TColStd_Array1OfAsciiString {
    constructor(theBegin: TCollection_AsciiString, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColStd_HSequenceOfAsciiString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfAsciiString): void;
  get(): TColStd_HSequenceOfAsciiString;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfAsciiString_1 extends Handle_TColStd_HSequenceOfAsciiString {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfAsciiString_2 extends Handle_TColStd_HSequenceOfAsciiString {
    constructor(thePtr: TColStd_HSequenceOfAsciiString);
  }

  export declare class Handle_TColStd_HSequenceOfAsciiString_3 extends Handle_TColStd_HSequenceOfAsciiString {
    constructor(theHandle: Handle_TColStd_HSequenceOfAsciiString);
  }

  export declare class Handle_TColStd_HSequenceOfAsciiString_4 extends Handle_TColStd_HSequenceOfAsciiString {
    constructor(theHandle: Handle_TColStd_HSequenceOfAsciiString);
  }

export declare class TColStd_IndexedDataMapOfStringString extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TColStd_IndexedDataMapOfStringString): void;
  Assign(theOther: TColStd_IndexedDataMapOfStringString): TColStd_IndexedDataMapOfStringString;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TCollection_AsciiString, theItem: TCollection_AsciiString): Standard_Integer;
  Contains(theKey1: TCollection_AsciiString): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TCollection_AsciiString, theItem: TCollection_AsciiString): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TCollection_AsciiString): void;
  FindKey(theIndex: Standard_Integer): TCollection_AsciiString;
  FindFromIndex(theIndex: Standard_Integer): TCollection_AsciiString;
  ChangeFromIndex(theIndex: Standard_Integer): TCollection_AsciiString;
  FindIndex(theKey1: TCollection_AsciiString): Standard_Integer;
  ChangeFromKey(theKey1: TCollection_AsciiString): TCollection_AsciiString;
  Seek(theKey1: TCollection_AsciiString): TCollection_AsciiString;
  ChangeSeek(theKey1: TCollection_AsciiString): TCollection_AsciiString;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_IndexedDataMapOfStringString_1 extends TColStd_IndexedDataMapOfStringString {
    constructor();
  }

  export declare class TColStd_IndexedDataMapOfStringString_2 extends TColStd_IndexedDataMapOfStringString {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_IndexedDataMapOfStringString_3 extends TColStd_IndexedDataMapOfStringString {
    constructor(theOther: TColStd_IndexedDataMapOfStringString);
  }

export declare class Handle_TColStd_HArray1OfAsciiString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfAsciiString): void;
  get(): TColStd_HArray1OfAsciiString;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfAsciiString_1 extends Handle_TColStd_HArray1OfAsciiString {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfAsciiString_2 extends Handle_TColStd_HArray1OfAsciiString {
    constructor(thePtr: TColStd_HArray1OfAsciiString);
  }

  export declare class Handle_TColStd_HArray1OfAsciiString_3 extends Handle_TColStd_HArray1OfAsciiString {
    constructor(theHandle: Handle_TColStd_HArray1OfAsciiString);
  }

  export declare class Handle_TColStd_HArray1OfAsciiString_4 extends Handle_TColStd_HArray1OfAsciiString {
    constructor(theHandle: Handle_TColStd_HArray1OfAsciiString);
  }

export declare class TColStd_HPackedMapOfInteger extends Standard_Transient {
  Map(): TColStd_PackedMapOfInteger;
  ChangeMap(): TColStd_PackedMapOfInteger;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TColStd_HPackedMapOfInteger_1 extends TColStd_HPackedMapOfInteger {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TColStd_HPackedMapOfInteger_2 extends TColStd_HPackedMapOfInteger {
    constructor(theOther: TColStd_PackedMapOfInteger);
  }

export declare class Handle_TColStd_HPackedMapOfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HPackedMapOfInteger): void;
  get(): TColStd_HPackedMapOfInteger;
  delete(): void;
}

  export declare class Handle_TColStd_HPackedMapOfInteger_1 extends Handle_TColStd_HPackedMapOfInteger {
    constructor();
  }

  export declare class Handle_TColStd_HPackedMapOfInteger_2 extends Handle_TColStd_HPackedMapOfInteger {
    constructor(thePtr: TColStd_HPackedMapOfInteger);
  }

  export declare class Handle_TColStd_HPackedMapOfInteger_3 extends Handle_TColStd_HPackedMapOfInteger {
    constructor(theHandle: Handle_TColStd_HPackedMapOfInteger);
  }

  export declare class Handle_TColStd_HPackedMapOfInteger_4 extends Handle_TColStd_HPackedMapOfInteger {
    constructor(theHandle: Handle_TColStd_HPackedMapOfInteger);
  }

export declare class Handle_TColStd_HArray1OfListOfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfListOfInteger): void;
  get(): TColStd_HArray1OfListOfInteger;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfListOfInteger_1 extends Handle_TColStd_HArray1OfListOfInteger {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfListOfInteger_2 extends Handle_TColStd_HArray1OfListOfInteger {
    constructor(thePtr: TColStd_HArray1OfListOfInteger);
  }

  export declare class Handle_TColStd_HArray1OfListOfInteger_3 extends Handle_TColStd_HArray1OfListOfInteger {
    constructor(theHandle: Handle_TColStd_HArray1OfListOfInteger);
  }

  export declare class Handle_TColStd_HArray1OfListOfInteger_4 extends Handle_TColStd_HArray1OfListOfInteger {
    constructor(theHandle: Handle_TColStd_HArray1OfListOfInteger);
  }

export declare class TColStd_IndexedMapOfInteger extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_IndexedMap<Standard_Integer, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_IndexedMap<Standard_Integer, TColStd_MapIntegerHasher>): any;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: Standard_Integer): Standard_Integer;
  Contains(theKey1: Standard_Integer): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: Standard_Integer): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: Standard_Integer): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): Standard_Integer;
  FindIndex(theKey1: Standard_Integer): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_IndexedMapOfInteger_1 extends TColStd_IndexedMapOfInteger {
    constructor();
  }

  export declare class TColStd_IndexedMapOfInteger_2 extends TColStd_IndexedMapOfInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_IndexedMapOfInteger_3 extends TColStd_IndexedMapOfInteger {
    constructor(theOther: NCollection_IndexedMap<Standard_Integer, TColStd_MapIntegerHasher>);
  }

export declare class TColStd_Array1OfCharacter {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Standard_Character): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfCharacter): TColStd_Array1OfCharacter;
  Move(theOther: TColStd_Array1OfCharacter): TColStd_Array1OfCharacter;
  First(): Standard_Character;
  ChangeFirst(): Standard_Character;
  Last(): Standard_Character;
  ChangeLast(): Standard_Character;
  Value(theIndex: Standard_Integer): Standard_Character;
  ChangeValue(theIndex: Standard_Integer): Standard_Character;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Character): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfCharacter_1 extends TColStd_Array1OfCharacter {
    constructor();
  }

  export declare class TColStd_Array1OfCharacter_2 extends TColStd_Array1OfCharacter {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfCharacter_3 extends TColStd_Array1OfCharacter {
    constructor(theOther: TColStd_Array1OfCharacter);
  }

  export declare class TColStd_Array1OfCharacter_4 extends TColStd_Array1OfCharacter {
    constructor(theOther: TColStd_Array1OfCharacter);
  }

  export declare class TColStd_Array1OfCharacter_5 extends TColStd_Array1OfCharacter {
    constructor(theBegin: Standard_Character, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColStd_HSequenceOfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfInteger): void;
  get(): TColStd_HSequenceOfInteger;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfInteger_1 extends Handle_TColStd_HSequenceOfInteger {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfInteger_2 extends Handle_TColStd_HSequenceOfInteger {
    constructor(thePtr: TColStd_HSequenceOfInteger);
  }

  export declare class Handle_TColStd_HSequenceOfInteger_3 extends Handle_TColStd_HSequenceOfInteger {
    constructor(theHandle: Handle_TColStd_HSequenceOfInteger);
  }

  export declare class Handle_TColStd_HSequenceOfInteger_4 extends Handle_TColStd_HSequenceOfInteger {
    constructor(theHandle: Handle_TColStd_HSequenceOfInteger);
  }

export declare class Handle_TColStd_HArray1OfTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfTransient): void;
  get(): TColStd_HArray1OfTransient;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfTransient_1 extends Handle_TColStd_HArray1OfTransient {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfTransient_2 extends Handle_TColStd_HArray1OfTransient {
    constructor(thePtr: TColStd_HArray1OfTransient);
  }

  export declare class Handle_TColStd_HArray1OfTransient_3 extends Handle_TColStd_HArray1OfTransient {
    constructor(theHandle: Handle_TColStd_HArray1OfTransient);
  }

  export declare class Handle_TColStd_HArray1OfTransient_4 extends Handle_TColStd_HArray1OfTransient {
    constructor(theHandle: Handle_TColStd_HArray1OfTransient);
  }

export declare class TColStd_ListOfReal extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TColStd_ListOfReal): TColStd_ListOfReal;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Standard_Real;
  First_2(): Standard_Real;
  Last_1(): Standard_Real;
  Last_2(): Standard_Real;
  Append_1(theItem: Standard_Real): Standard_Real;
  Append_3(theOther: TColStd_ListOfReal): void;
  Prepend_1(theItem: Standard_Real): Standard_Real;
  Prepend_2(theOther: TColStd_ListOfReal): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TColStd_ListOfReal_1 extends TColStd_ListOfReal {
    constructor();
  }

  export declare class TColStd_ListOfReal_2 extends TColStd_ListOfReal {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_ListOfReal_3 extends TColStd_ListOfReal {
    constructor(theOther: TColStd_ListOfReal);
  }

export declare class Handle_TColStd_HSequenceOfHAsciiString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HSequenceOfHAsciiString): void;
  get(): TColStd_HSequenceOfHAsciiString;
  delete(): void;
}

  export declare class Handle_TColStd_HSequenceOfHAsciiString_1 extends Handle_TColStd_HSequenceOfHAsciiString {
    constructor();
  }

  export declare class Handle_TColStd_HSequenceOfHAsciiString_2 extends Handle_TColStd_HSequenceOfHAsciiString {
    constructor(thePtr: TColStd_HSequenceOfHAsciiString);
  }

  export declare class Handle_TColStd_HSequenceOfHAsciiString_3 extends Handle_TColStd_HSequenceOfHAsciiString {
    constructor(theHandle: Handle_TColStd_HSequenceOfHAsciiString);
  }

  export declare class Handle_TColStd_HSequenceOfHAsciiString_4 extends Handle_TColStd_HSequenceOfHAsciiString {
    constructor(theHandle: Handle_TColStd_HSequenceOfHAsciiString);
  }

export declare class TColStd_Array2OfBoolean {
  Init(theValue: Standard_Boolean): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColStd_Array2OfBoolean): TColStd_Array2OfBoolean;
  Move(theOther: TColStd_Array2OfBoolean): TColStd_Array2OfBoolean;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Boolean;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Boolean;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Standard_Boolean): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array2OfBoolean_1 extends TColStd_Array2OfBoolean {
    constructor();
  }

  export declare class TColStd_Array2OfBoolean_2 extends TColStd_Array2OfBoolean {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColStd_Array2OfBoolean_3 extends TColStd_Array2OfBoolean {
    constructor(theOther: TColStd_Array2OfBoolean);
  }

  export declare class TColStd_Array2OfBoolean_4 extends TColStd_Array2OfBoolean {
    constructor(theOther: TColStd_Array2OfBoolean);
  }

  export declare class TColStd_Array2OfBoolean_5 extends TColStd_Array2OfBoolean {
    constructor(theBegin: Standard_Boolean, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColStd_Array2OfInteger {
  Init(theValue: Standard_Integer): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColStd_Array2OfInteger): TColStd_Array2OfInteger;
  Move(theOther: TColStd_Array2OfInteger): TColStd_Array2OfInteger;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Integer;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Integer;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Standard_Integer): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array2OfInteger_1 extends TColStd_Array2OfInteger {
    constructor();
  }

  export declare class TColStd_Array2OfInteger_2 extends TColStd_Array2OfInteger {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColStd_Array2OfInteger_3 extends TColStd_Array2OfInteger {
    constructor(theOther: TColStd_Array2OfInteger);
  }

  export declare class TColStd_Array2OfInteger_4 extends TColStd_Array2OfInteger {
    constructor(theOther: TColStd_Array2OfInteger);
  }

  export declare class TColStd_Array2OfInteger_5 extends TColStd_Array2OfInteger {
    constructor(theBegin: Standard_Integer, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColStd_MapOfReal extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): void;
  Assign(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): any;
  ReSize(N: Standard_Integer): void;
  Add(K: Standard_Real): Standard_Boolean;
  Added(K: Standard_Real): Standard_Real;
  Contains_1(K: Standard_Real): Standard_Boolean;
  Remove(K: Standard_Real): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  Contains_2(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  Union(theLeft: NCollection_Map<Standard_Real, TColStd_MapRealHasher>, theRight: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): void;
  Unite(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  HasIntersection(theMap: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  Intersection(theLeft: NCollection_Map<Standard_Real, TColStd_MapRealHasher>, theRight: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): void;
  Intersect(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  Subtraction(theLeft: NCollection_Map<Standard_Real, TColStd_MapRealHasher>, theRight: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): void;
  Subtract(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  Difference(theLeft: NCollection_Map<Standard_Real, TColStd_MapRealHasher>, theRight: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): void;
  Differ(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>): Standard_Boolean;
  delete(): void;
}

  export declare class TColStd_MapOfReal_1 extends TColStd_MapOfReal {
    constructor();
  }

  export declare class TColStd_MapOfReal_2 extends TColStd_MapOfReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_MapOfReal_3 extends TColStd_MapOfReal {
    constructor(theOther: NCollection_Map<Standard_Real, TColStd_MapRealHasher>);
  }

export declare class Handle_TColStd_HArray1OfBoolean {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfBoolean): void;
  get(): TColStd_HArray1OfBoolean;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfBoolean_1 extends Handle_TColStd_HArray1OfBoolean {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfBoolean_2 extends Handle_TColStd_HArray1OfBoolean {
    constructor(thePtr: TColStd_HArray1OfBoolean);
  }

  export declare class Handle_TColStd_HArray1OfBoolean_3 extends Handle_TColStd_HArray1OfBoolean {
    constructor(theHandle: Handle_TColStd_HArray1OfBoolean);
  }

  export declare class Handle_TColStd_HArray1OfBoolean_4 extends Handle_TColStd_HArray1OfBoolean {
    constructor(theHandle: Handle_TColStd_HArray1OfBoolean);
  }

export declare class TColStd_Array1OfReal {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Standard_Real): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColStd_Array1OfReal): TColStd_Array1OfReal;
  Move(theOther: TColStd_Array1OfReal): TColStd_Array1OfReal;
  First(): Standard_Real;
  ChangeFirst(): Standard_Real;
  Last(): Standard_Real;
  ChangeLast(): Standard_Real;
  Value(theIndex: Standard_Integer): Standard_Real;
  ChangeValue(theIndex: Standard_Integer): Standard_Real;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Real): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array1OfReal_1 extends TColStd_Array1OfReal {
    constructor();
  }

  export declare class TColStd_Array1OfReal_2 extends TColStd_Array1OfReal {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColStd_Array1OfReal_3 extends TColStd_Array1OfReal {
    constructor(theOther: TColStd_Array1OfReal);
  }

  export declare class TColStd_Array1OfReal_4 extends TColStd_Array1OfReal {
    constructor(theOther: TColStd_Array1OfReal);
  }

  export declare class TColStd_Array1OfReal_5 extends TColStd_Array1OfReal {
    constructor(theBegin: Standard_Real, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColStd_HArray1OfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColStd_HArray1OfReal): void;
  get(): TColStd_HArray1OfReal;
  delete(): void;
}

  export declare class Handle_TColStd_HArray1OfReal_1 extends Handle_TColStd_HArray1OfReal {
    constructor();
  }

  export declare class Handle_TColStd_HArray1OfReal_2 extends Handle_TColStd_HArray1OfReal {
    constructor(thePtr: TColStd_HArray1OfReal);
  }

  export declare class Handle_TColStd_HArray1OfReal_3 extends Handle_TColStd_HArray1OfReal {
    constructor(theHandle: Handle_TColStd_HArray1OfReal);
  }

  export declare class Handle_TColStd_HArray1OfReal_4 extends Handle_TColStd_HArray1OfReal {
    constructor(theHandle: Handle_TColStd_HArray1OfReal);
  }

export declare class TColStd_SequenceOfInteger extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColStd_SequenceOfInteger): TColStd_SequenceOfInteger;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Standard_Integer): void;
  Append_2(theSeq: TColStd_SequenceOfInteger): void;
  Prepend_1(theItem: Standard_Integer): void;
  Prepend_2(theSeq: TColStd_SequenceOfInteger): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Standard_Integer): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfInteger): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfInteger): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Standard_Integer): void;
  Split(theIndex: Standard_Integer, theSeq: TColStd_SequenceOfInteger): void;
  First(): Standard_Integer;
  ChangeFirst(): Standard_Integer;
  Last(): Standard_Integer;
  ChangeLast(): Standard_Integer;
  Value(theIndex: Standard_Integer): Standard_Integer;
  ChangeValue(theIndex: Standard_Integer): Standard_Integer;
  SetValue(theIndex: Standard_Integer, theItem: Standard_Integer): void;
  delete(): void;
}

  export declare class TColStd_SequenceOfInteger_1 extends TColStd_SequenceOfInteger {
    constructor();
  }

  export declare class TColStd_SequenceOfInteger_2 extends TColStd_SequenceOfInteger {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_SequenceOfInteger_3 extends TColStd_SequenceOfInteger {
    constructor(theOther: TColStd_SequenceOfInteger);
  }

export declare class TColStd_DataMapOfIntegerReal extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, Standard_Real, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, Standard_Real, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: Standard_Real): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: Standard_Real): Standard_Real;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): Standard_Real;
  ChangeSeek(theKey: Standard_Integer): Standard_Real;
  ChangeFind(theKey: Standard_Integer): Standard_Real;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TColStd_DataMapOfIntegerReal_1 extends TColStd_DataMapOfIntegerReal {
    constructor();
  }

  export declare class TColStd_DataMapOfIntegerReal_2 extends TColStd_DataMapOfIntegerReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColStd_DataMapOfIntegerReal_3 extends TColStd_DataMapOfIntegerReal {
    constructor(theOther: NCollection_DataMap<Standard_Integer, Standard_Real, TColStd_MapIntegerHasher>);
  }

export declare class TColStd_Array2OfCharacter {
  Init(theValue: Standard_Character): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColStd_Array2OfCharacter): TColStd_Array2OfCharacter;
  Move(theOther: TColStd_Array2OfCharacter): TColStd_Array2OfCharacter;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Character;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Standard_Character;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Standard_Character): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColStd_Array2OfCharacter_1 extends TColStd_Array2OfCharacter {
    constructor();
  }

  export declare class TColStd_Array2OfCharacter_2 extends TColStd_Array2OfCharacter {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColStd_Array2OfCharacter_3 extends TColStd_Array2OfCharacter {
    constructor(theOther: TColStd_Array2OfCharacter);
  }

  export declare class TColStd_Array2OfCharacter_4 extends TColStd_Array2OfCharacter {
    constructor(theOther: TColStd_Array2OfCharacter);
  }

  export declare class TColStd_Array2OfCharacter_5 extends TColStd_Array2OfCharacter {
    constructor(theBegin: Standard_Character, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColStd_MapIntegerHasher {
  constructor();
  static HashCode(theKey: Standard_Integer, theUpperBound: Standard_Integer): Standard_Integer;
  static IsEqual(theKey1: Standard_Integer, theKey2: Standard_Integer): Standard_Boolean;
  delete(): void;
}

export declare class Aspect_Touch {
  Delta(): Graphic3d_Vec2d;
  delete(): void;
}

  export declare class Aspect_Touch_1 extends Aspect_Touch {
    constructor();
  }

  export declare class Aspect_Touch_2 extends Aspect_Touch {
    constructor(thePnt: Graphic3d_Vec2d, theIsPreciseDevice: Standard_Boolean);
  }

  export declare class Aspect_Touch_3 extends Aspect_Touch {
    constructor(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theIsPreciseDevice: Standard_Boolean);
  }

export declare type Aspect_GridType = {
  Aspect_GT_Rectangular: {};
  Aspect_GT_Circular: {};
}

export declare class Aspect_XRHapticActionData {
  constructor()
  IsValid(): Standard_Boolean;
  delete(): void;
}

export declare class Aspect_DisplayConnectionDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_DisplayConnectionDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_DisplayConnectionDefinitionError_1 extends Aspect_DisplayConnectionDefinitionError {
    constructor();
  }

  export declare class Aspect_DisplayConnectionDefinitionError_2 extends Aspect_DisplayConnectionDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Aspect_DisplayConnectionDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_DisplayConnectionDefinitionError): void;
  get(): Aspect_DisplayConnectionDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_DisplayConnectionDefinitionError_1 extends Handle_Aspect_DisplayConnectionDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_DisplayConnectionDefinitionError_2 extends Handle_Aspect_DisplayConnectionDefinitionError {
    constructor(thePtr: Aspect_DisplayConnectionDefinitionError);
  }

  export declare class Handle_Aspect_DisplayConnectionDefinitionError_3 extends Handle_Aspect_DisplayConnectionDefinitionError {
    constructor(theHandle: Handle_Aspect_DisplayConnectionDefinitionError);
  }

  export declare class Handle_Aspect_DisplayConnectionDefinitionError_4 extends Handle_Aspect_DisplayConnectionDefinitionError {
    constructor(theHandle: Handle_Aspect_DisplayConnectionDefinitionError);
  }

export declare type Aspect_GridDrawMode = {
  Aspect_GDM_Lines: {};
  Aspect_GDM_Points: {};
  Aspect_GDM_None: {};
}

export declare class Aspect_XRDigitalActionData {
  constructor()
  delete(): void;
}

export declare type Aspect_TypeOfHighlightMethod = {
  Aspect_TOHM_COLOR: {};
  Aspect_TOHM_BOUNDBOX: {};
}

export declare class Aspect_Background {
  SetColor(AColor: Quantity_Color): void;
  Color(): Quantity_Color;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Aspect_Background_1 extends Aspect_Background {
    constructor();
  }

  export declare class Aspect_Background_2 extends Aspect_Background {
    constructor(AColor: Quantity_Color);
  }

export declare class Aspect_TrackedDevicePoseArray {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Aspect_TrackedDevicePose): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Aspect_TrackedDevicePoseArray): Aspect_TrackedDevicePoseArray;
  Move(theOther: Aspect_TrackedDevicePoseArray): Aspect_TrackedDevicePoseArray;
  First(): Aspect_TrackedDevicePose;
  ChangeFirst(): Aspect_TrackedDevicePose;
  Last(): Aspect_TrackedDevicePose;
  ChangeLast(): Aspect_TrackedDevicePose;
  Value(theIndex: Standard_Integer): Aspect_TrackedDevicePose;
  ChangeValue(theIndex: Standard_Integer): Aspect_TrackedDevicePose;
  SetValue(theIndex: Standard_Integer, theItem: Aspect_TrackedDevicePose): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Aspect_TrackedDevicePoseArray_1 extends Aspect_TrackedDevicePoseArray {
    constructor();
  }

  export declare class Aspect_TrackedDevicePoseArray_2 extends Aspect_TrackedDevicePoseArray {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Aspect_TrackedDevicePoseArray_3 extends Aspect_TrackedDevicePoseArray {
    constructor(theOther: Aspect_TrackedDevicePoseArray);
  }

  export declare class Aspect_TrackedDevicePoseArray_4 extends Aspect_TrackedDevicePoseArray {
    constructor(theOther: Aspect_TrackedDevicePoseArray);
  }

  export declare class Aspect_TrackedDevicePoseArray_5 extends Aspect_TrackedDevicePoseArray {
    constructor(theBegin: Aspect_TrackedDevicePose, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Aspect_TrackedDevicePose {
  constructor()
  delete(): void;
}

export declare type Aspect_GraphicsLibrary = {
  Aspect_GraphicsLibrary_OpenGL: {};
  Aspect_GraphicsLibrary_OpenGLES: {};
}

export declare class Aspect_AspectFillAreaDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_AspectFillAreaDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_AspectFillAreaDefinitionError_1 extends Aspect_AspectFillAreaDefinitionError {
    constructor();
  }

  export declare class Aspect_AspectFillAreaDefinitionError_2 extends Aspect_AspectFillAreaDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Aspect_AspectFillAreaDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_AspectFillAreaDefinitionError): void;
  get(): Aspect_AspectFillAreaDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_AspectFillAreaDefinitionError_1 extends Handle_Aspect_AspectFillAreaDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_AspectFillAreaDefinitionError_2 extends Handle_Aspect_AspectFillAreaDefinitionError {
    constructor(thePtr: Aspect_AspectFillAreaDefinitionError);
  }

  export declare class Handle_Aspect_AspectFillAreaDefinitionError_3 extends Handle_Aspect_AspectFillAreaDefinitionError {
    constructor(theHandle: Handle_Aspect_AspectFillAreaDefinitionError);
  }

  export declare class Handle_Aspect_AspectFillAreaDefinitionError_4 extends Handle_Aspect_AspectFillAreaDefinitionError {
    constructor(theHandle: Handle_Aspect_AspectFillAreaDefinitionError);
  }

export declare class Aspect_SequenceOfColor extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Aspect_SequenceOfColor): Aspect_SequenceOfColor;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Quantity_Color): void;
  Append_2(theSeq: Aspect_SequenceOfColor): void;
  Prepend_1(theItem: Quantity_Color): void;
  Prepend_2(theSeq: Aspect_SequenceOfColor): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Quantity_Color): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Aspect_SequenceOfColor): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Aspect_SequenceOfColor): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Quantity_Color): void;
  Split(theIndex: Standard_Integer, theSeq: Aspect_SequenceOfColor): void;
  First(): Quantity_Color;
  ChangeFirst(): Quantity_Color;
  Last(): Quantity_Color;
  ChangeLast(): Quantity_Color;
  Value(theIndex: Standard_Integer): Quantity_Color;
  ChangeValue(theIndex: Standard_Integer): Quantity_Color;
  SetValue(theIndex: Standard_Integer, theItem: Quantity_Color): void;
  delete(): void;
}

  export declare class Aspect_SequenceOfColor_1 extends Aspect_SequenceOfColor {
    constructor();
  }

  export declare class Aspect_SequenceOfColor_2 extends Aspect_SequenceOfColor {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Aspect_SequenceOfColor_3 extends Aspect_SequenceOfColor {
    constructor(theOther: Aspect_SequenceOfColor);
  }

export declare class Handle_Aspect_DisplayConnection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_DisplayConnection): void;
  get(): Aspect_DisplayConnection;
  delete(): void;
}

  export declare class Handle_Aspect_DisplayConnection_1 extends Handle_Aspect_DisplayConnection {
    constructor();
  }

  export declare class Handle_Aspect_DisplayConnection_2 extends Handle_Aspect_DisplayConnection {
    constructor(thePtr: Aspect_DisplayConnection);
  }

  export declare class Handle_Aspect_DisplayConnection_3 extends Handle_Aspect_DisplayConnection {
    constructor(theHandle: Handle_Aspect_DisplayConnection);
  }

  export declare class Handle_Aspect_DisplayConnection_4 extends Handle_Aspect_DisplayConnection {
    constructor(theHandle: Handle_Aspect_DisplayConnection);
  }

export declare class Aspect_DisplayConnection extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Aspect_GenId {
  Free_1(): void;
  Free_2(theId: Graphic3d_ZLayerId): void;
  HasFree(): Standard_Boolean;
  Available(): Graphic3d_ZLayerId;
  Lower(): Graphic3d_ZLayerId;
  Next_1(): Graphic3d_ZLayerId;
  Next_2(theId: Graphic3d_ZLayerId): Standard_Boolean;
  Upper(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Aspect_GenId_1 extends Aspect_GenId {
    constructor();
  }

  export declare class Aspect_GenId_2 extends Aspect_GenId {
    constructor(theLow: Graphic3d_ZLayerId, theUpper: Graphic3d_ZLayerId);
  }

export declare class Handle_Aspect_RectangularGrid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_RectangularGrid): void;
  get(): Aspect_RectangularGrid;
  delete(): void;
}

  export declare class Handle_Aspect_RectangularGrid_1 extends Handle_Aspect_RectangularGrid {
    constructor();
  }

  export declare class Handle_Aspect_RectangularGrid_2 extends Handle_Aspect_RectangularGrid {
    constructor(thePtr: Aspect_RectangularGrid);
  }

  export declare class Handle_Aspect_RectangularGrid_3 extends Handle_Aspect_RectangularGrid {
    constructor(theHandle: Handle_Aspect_RectangularGrid);
  }

  export declare class Handle_Aspect_RectangularGrid_4 extends Handle_Aspect_RectangularGrid {
    constructor(theHandle: Handle_Aspect_RectangularGrid);
  }

export declare class Aspect_RectangularGrid extends Aspect_Grid {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetXStep(aStep: Quantity_AbsorbedDose): void;
  SetYStep(aStep: Quantity_AbsorbedDose): void;
  SetAngle(anAngle1: Quantity_AbsorbedDose, anAngle2: Quantity_AbsorbedDose): void;
  SetGridValues(XOrigin: Quantity_AbsorbedDose, YOrigin: Quantity_AbsorbedDose, XStep: Quantity_AbsorbedDose, YStep: Quantity_AbsorbedDose, RotationAngle: Quantity_AbsorbedDose): void;
  Compute(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, gridX: Quantity_AbsorbedDose, gridY: Quantity_AbsorbedDose): void;
  XStep(): Quantity_AbsorbedDose;
  YStep(): Quantity_AbsorbedDose;
  FirstAngle(): Quantity_AbsorbedDose;
  SecondAngle(): Quantity_AbsorbedDose;
  Init(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Aspect_CircularGrid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_CircularGrid): void;
  get(): Aspect_CircularGrid;
  delete(): void;
}

  export declare class Handle_Aspect_CircularGrid_1 extends Handle_Aspect_CircularGrid {
    constructor();
  }

  export declare class Handle_Aspect_CircularGrid_2 extends Handle_Aspect_CircularGrid {
    constructor(thePtr: Aspect_CircularGrid);
  }

  export declare class Handle_Aspect_CircularGrid_3 extends Handle_Aspect_CircularGrid {
    constructor(theHandle: Handle_Aspect_CircularGrid);
  }

  export declare class Handle_Aspect_CircularGrid_4 extends Handle_Aspect_CircularGrid {
    constructor(theHandle: Handle_Aspect_CircularGrid);
  }

export declare class Aspect_CircularGrid extends Aspect_Grid {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetRadiusStep(aStep: Quantity_AbsorbedDose): void;
  SetDivisionNumber(aNumber: Graphic3d_ZLayerId): void;
  SetGridValues(XOrigin: Quantity_AbsorbedDose, YOrigin: Quantity_AbsorbedDose, RadiusStep: Quantity_AbsorbedDose, DivisionNumber: Graphic3d_ZLayerId, RotationAngle: Quantity_AbsorbedDose): void;
  Compute(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, gridX: Quantity_AbsorbedDose, gridY: Quantity_AbsorbedDose): void;
  RadiusStep(): Quantity_AbsorbedDose;
  DivisionNumber(): Graphic3d_ZLayerId;
  Init(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Aspect_ScrollDelta {
  HasPoint(): Standard_Boolean;
  ResetPoint(): void;
  delete(): void;
}

  export declare class Aspect_ScrollDelta_1 extends Aspect_ScrollDelta {
    constructor();
  }

  export declare class Aspect_ScrollDelta_2 extends Aspect_ScrollDelta {
    constructor(thePnt: NCollection_Vec2<int>, theValue: Quantity_AbsorbedDose, theFlags: Aspect_VKeyFlags);
  }

  export declare class Aspect_ScrollDelta_3 extends Aspect_ScrollDelta {
    constructor(theValue: Quantity_AbsorbedDose, theFlags: Aspect_VKeyFlags);
  }

export declare class Handle_Aspect_GraphicDeviceDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_GraphicDeviceDefinitionError): void;
  get(): Aspect_GraphicDeviceDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_GraphicDeviceDefinitionError_1 extends Handle_Aspect_GraphicDeviceDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_GraphicDeviceDefinitionError_2 extends Handle_Aspect_GraphicDeviceDefinitionError {
    constructor(thePtr: Aspect_GraphicDeviceDefinitionError);
  }

  export declare class Handle_Aspect_GraphicDeviceDefinitionError_3 extends Handle_Aspect_GraphicDeviceDefinitionError {
    constructor(theHandle: Handle_Aspect_GraphicDeviceDefinitionError);
  }

  export declare class Handle_Aspect_GraphicDeviceDefinitionError_4 extends Handle_Aspect_GraphicDeviceDefinitionError {
    constructor(theHandle: Handle_Aspect_GraphicDeviceDefinitionError);
  }

export declare class Aspect_GraphicDeviceDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_GraphicDeviceDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_GraphicDeviceDefinitionError_1 extends Aspect_GraphicDeviceDefinitionError {
    constructor();
  }

  export declare class Aspect_GraphicDeviceDefinitionError_2 extends Aspect_GraphicDeviceDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Aspect_IdentDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_IdentDefinitionError): void;
  get(): Aspect_IdentDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_IdentDefinitionError_1 extends Handle_Aspect_IdentDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_IdentDefinitionError_2 extends Handle_Aspect_IdentDefinitionError {
    constructor(thePtr: Aspect_IdentDefinitionError);
  }

  export declare class Handle_Aspect_IdentDefinitionError_3 extends Handle_Aspect_IdentDefinitionError {
    constructor(theHandle: Handle_Aspect_IdentDefinitionError);
  }

  export declare class Handle_Aspect_IdentDefinitionError_4 extends Handle_Aspect_IdentDefinitionError {
    constructor(theHandle: Handle_Aspect_IdentDefinitionError);
  }

export declare class Aspect_IdentDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_IdentDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_IdentDefinitionError_1 extends Aspect_IdentDefinitionError {
    constructor();
  }

  export declare class Aspect_IdentDefinitionError_2 extends Aspect_IdentDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Aspect_Grid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_Grid): void;
  get(): Aspect_Grid;
  delete(): void;
}

  export declare class Handle_Aspect_Grid_1 extends Handle_Aspect_Grid {
    constructor();
  }

  export declare class Handle_Aspect_Grid_2 extends Handle_Aspect_Grid {
    constructor(thePtr: Aspect_Grid);
  }

  export declare class Handle_Aspect_Grid_3 extends Handle_Aspect_Grid {
    constructor(theHandle: Handle_Aspect_Grid);
  }

  export declare class Handle_Aspect_Grid_4 extends Handle_Aspect_Grid {
    constructor(theHandle: Handle_Aspect_Grid);
  }

export declare class Aspect_Grid extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetXOrigin(anOrigin: Quantity_AbsorbedDose): void;
  SetYOrigin(anOrigin: Quantity_AbsorbedDose): void;
  SetRotationAngle(anAngle: Quantity_AbsorbedDose): void;
  Rotate(anAngle: Quantity_AbsorbedDose): void;
  Translate(aDx: Quantity_AbsorbedDose, aDy: Quantity_AbsorbedDose): void;
  SetColors(aColor: Quantity_Color, aTenthColor: Quantity_Color): void;
  Hit(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, gridX: Quantity_AbsorbedDose, gridY: Quantity_AbsorbedDose): void;
  Compute(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, gridX: Quantity_AbsorbedDose, gridY: Quantity_AbsorbedDose): void;
  Activate(): void;
  Deactivate(): void;
  XOrigin(): Quantity_AbsorbedDose;
  YOrigin(): Quantity_AbsorbedDose;
  RotationAngle(): Quantity_AbsorbedDose;
  IsActive(): Standard_Boolean;
  Colors(aColor: Quantity_Color, aTenthColor: Quantity_Color): void;
  SetDrawMode(aDrawMode: Aspect_GridDrawMode): void;
  DrawMode(): Aspect_GridDrawMode;
  Display(): void;
  Erase(): void;
  IsDisplayed(): Standard_Boolean;
  Init(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Aspect_XRTrackedDeviceRole = {
  Aspect_XRTrackedDeviceRole_Head: {};
  Aspect_XRTrackedDeviceRole_LeftHand: {};
  Aspect_XRTrackedDeviceRole_RightHand: {};
  Aspect_XRTrackedDeviceRole_Other: {};
}

export declare type Aspect_HatchStyle = {
  Aspect_HS_SOLID: {};
  Aspect_HS_HORIZONTAL: {};
  Aspect_HS_HORIZONTAL_WIDE: {};
  Aspect_HS_VERTICAL: {};
  Aspect_HS_VERTICAL_WIDE: {};
  Aspect_HS_DIAGONAL_45: {};
  Aspect_HS_DIAGONAL_45_WIDE: {};
  Aspect_HS_DIAGONAL_135: {};
  Aspect_HS_DIAGONAL_135_WIDE: {};
  Aspect_HS_GRID: {};
  Aspect_HS_GRID_WIDE: {};
  Aspect_HS_GRID_DIAGONAL: {};
  Aspect_HS_GRID_DIAGONAL_WIDE: {};
  Aspect_HS_NB: {};
}

export declare type Aspect_TypeOfColorScaleOrientation = {
  Aspect_TOCSO_NONE: {};
  Aspect_TOCSO_LEFT: {};
  Aspect_TOCSO_RIGHT: {};
  Aspect_TOCSO_CENTER: {};
}

export declare class Aspect_VKeySet extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Modifiers(): Aspect_VKeyFlags;
  DownTime(theKey: Aspect_VKey): Standard_Real;
  TimeUp(theKey: Aspect_VKey): Standard_Real;
  IsFreeKey(theKey: Aspect_VKey): Standard_Boolean;
  IsKeyDown(theKey: Aspect_VKey): Standard_Boolean;
  Reset(): void;
  KeyDown(theKey: Aspect_VKey, theTime: Standard_Real, thePressure: Standard_Real): void;
  KeyUp(theKey: Aspect_VKey, theTime: Standard_Real): void;
  KeyFromAxis(theNegative: Aspect_VKey, thePositive: Aspect_VKey, theTime: Standard_Real, thePressure: Standard_Real): void;
  HoldDuration_1(theKey: Aspect_VKey, theTime: Standard_Real, theDuration: Standard_Real): Standard_Boolean;
  HoldDuration_2(theKey: Aspect_VKey, theTime: Standard_Real, theDuration: Standard_Real, thePressure: Standard_Real): Standard_Boolean;
  delete(): void;
}

export declare type Aspect_WidthOfLine = {
  Aspect_WOL_THIN: {};
  Aspect_WOL_MEDIUM: {};
  Aspect_WOL_THICK: {};
  Aspect_WOL_VERYTHICK: {};
  Aspect_WOL_USERDEFINED: {};
}

export declare type Aspect_TypeOfDeflection = {
  Aspect_TOD_RELATIVE: {};
  Aspect_TOD_ABSOLUTE: {};
}

export declare type Aspect_XRGenericAction = {
  Aspect_XRGenericAction_IsHeadsetOn: {};
  Aspect_XRGenericAction_InputAppMenu: {};
  Aspect_XRGenericAction_InputSysMenu: {};
  Aspect_XRGenericAction_InputTriggerPull: {};
  Aspect_XRGenericAction_InputTriggerClick: {};
  Aspect_XRGenericAction_InputGripClick: {};
  Aspect_XRGenericAction_InputTrackPadPosition: {};
  Aspect_XRGenericAction_InputTrackPadTouch: {};
  Aspect_XRGenericAction_InputTrackPadClick: {};
  Aspect_XRGenericAction_InputThumbstickPosition: {};
  Aspect_XRGenericAction_InputThumbstickTouch: {};
  Aspect_XRGenericAction_InputThumbstickClick: {};
  Aspect_XRGenericAction_InputPoseBase: {};
  Aspect_XRGenericAction_InputPoseFront: {};
  Aspect_XRGenericAction_InputPoseHandGrip: {};
  Aspect_XRGenericAction_InputPoseFingerTip: {};
  Aspect_XRGenericAction_OutputHaptic: {};
}

export declare type Aspect_XRActionType = {
  Aspect_XRActionType_InputDigital: {};
  Aspect_XRActionType_InputAnalog: {};
  Aspect_XRActionType_InputPose: {};
  Aspect_XRActionType_InputSkeletal: {};
  Aspect_XRActionType_OutputHaptic: {};
}

export declare type Aspect_XAtom = {
  Aspect_XA_DELETE_WINDOW: {};
}

export declare type Aspect_VKeyBasic = {
  Aspect_VKey_UNKNOWN: {};
  Aspect_VKey_A: {};
  Aspect_VKey_B: {};
  Aspect_VKey_C: {};
  Aspect_VKey_D: {};
  Aspect_VKey_E: {};
  Aspect_VKey_F: {};
  Aspect_VKey_G: {};
  Aspect_VKey_H: {};
  Aspect_VKey_I: {};
  Aspect_VKey_J: {};
  Aspect_VKey_K: {};
  Aspect_VKey_L: {};
  Aspect_VKey_M: {};
  Aspect_VKey_N: {};
  Aspect_VKey_O: {};
  Aspect_VKey_P: {};
  Aspect_VKey_Q: {};
  Aspect_VKey_R: {};
  Aspect_VKey_S: {};
  Aspect_VKey_T: {};
  Aspect_VKey_U: {};
  Aspect_VKey_V: {};
  Aspect_VKey_W: {};
  Aspect_VKey_X: {};
  Aspect_VKey_Y: {};
  Aspect_VKey_Z: {};
  Aspect_VKey_0: {};
  Aspect_VKey_1: {};
  Aspect_VKey_2: {};
  Aspect_VKey_3: {};
  Aspect_VKey_4: {};
  Aspect_VKey_5: {};
  Aspect_VKey_6: {};
  Aspect_VKey_7: {};
  Aspect_VKey_8: {};
  Aspect_VKey_9: {};
  Aspect_VKey_F1: {};
  Aspect_VKey_F2: {};
  Aspect_VKey_F3: {};
  Aspect_VKey_F4: {};
  Aspect_VKey_F5: {};
  Aspect_VKey_F6: {};
  Aspect_VKey_F7: {};
  Aspect_VKey_F8: {};
  Aspect_VKey_F9: {};
  Aspect_VKey_F10: {};
  Aspect_VKey_F11: {};
  Aspect_VKey_F12: {};
  Aspect_VKey_Up: {};
  Aspect_VKey_Down: {};
  Aspect_VKey_Left: {};
  Aspect_VKey_Right: {};
  Aspect_VKey_Plus: {};
  Aspect_VKey_Minus: {};
  Aspect_VKey_Equal: {};
  Aspect_VKey_PageUp: {};
  Aspect_VKey_PageDown: {};
  Aspect_VKey_Home: {};
  Aspect_VKey_End: {};
  Aspect_VKey_Escape: {};
  Aspect_VKey_Back: {};
  Aspect_VKey_Enter: {};
  Aspect_VKey_Backspace: {};
  Aspect_VKey_Space: {};
  Aspect_VKey_Delete: {};
  Aspect_VKey_Tilde: {};
  Aspect_VKey_Tab: {};
  Aspect_VKey_Comma: {};
  Aspect_VKey_Period: {};
  Aspect_VKey_Semicolon: {};
  Aspect_VKey_Slash: {};
  Aspect_VKey_BracketLeft: {};
  Aspect_VKey_Backslash: {};
  Aspect_VKey_BracketRight: {};
  Aspect_VKey_Apostrophe: {};
  Aspect_VKey_Numlock: {};
  Aspect_VKey_Scroll: {};
  Aspect_VKey_Numpad0: {};
  Aspect_VKey_Numpad1: {};
  Aspect_VKey_Numpad2: {};
  Aspect_VKey_Numpad3: {};
  Aspect_VKey_Numpad4: {};
  Aspect_VKey_Numpad5: {};
  Aspect_VKey_Numpad6: {};
  Aspect_VKey_Numpad7: {};
  Aspect_VKey_Numpad8: {};
  Aspect_VKey_Numpad9: {};
  Aspect_VKey_NumpadMultiply: {};
  Aspect_VKey_NumpadAdd: {};
  Aspect_VKey_NumpadSubtract: {};
  Aspect_VKey_NumpadDivide: {};
  Aspect_VKey_MediaNextTrack: {};
  Aspect_VKey_MediaPreviousTrack: {};
  Aspect_VKey_MediaStop: {};
  Aspect_VKey_MediaPlayPause: {};
  Aspect_VKey_VolumeMute: {};
  Aspect_VKey_VolumeDown: {};
  Aspect_VKey_VolumeUp: {};
  Aspect_VKey_BrowserBack: {};
  Aspect_VKey_BrowserForward: {};
  Aspect_VKey_BrowserRefresh: {};
  Aspect_VKey_BrowserStop: {};
  Aspect_VKey_BrowserSearch: {};
  Aspect_VKey_BrowserFavorites: {};
  Aspect_VKey_BrowserHome: {};
  Aspect_VKey_ViewTop: {};
  Aspect_VKey_ViewBottom: {};
  Aspect_VKey_ViewLeft: {};
  Aspect_VKey_ViewRight: {};
  Aspect_VKey_ViewFront: {};
  Aspect_VKey_ViewBack: {};
  Aspect_VKey_ViewAxoLeftProj: {};
  Aspect_VKey_ViewAxoRightProj: {};
  Aspect_VKey_ViewFitAll: {};
  Aspect_VKey_ViewRoll90CW: {};
  Aspect_VKey_ViewRoll90CCW: {};
  Aspect_VKey_ViewSwitchRotate: {};
  Aspect_VKey_Shift: {};
  Aspect_VKey_Control: {};
  Aspect_VKey_Alt: {};
  Aspect_VKey_Menu: {};
  Aspect_VKey_Meta: {};
  Aspect_VKey_NavInteract: {};
  Aspect_VKey_NavForward: {};
  Aspect_VKey_NavBackward: {};
  Aspect_VKey_NavSlideLeft: {};
  Aspect_VKey_NavSlideRight: {};
  Aspect_VKey_NavSlideUp: {};
  Aspect_VKey_NavSlideDown: {};
  Aspect_VKey_NavRollCCW: {};
  Aspect_VKey_NavRollCW: {};
  Aspect_VKey_NavLookLeft: {};
  Aspect_VKey_NavLookRight: {};
  Aspect_VKey_NavLookUp: {};
  Aspect_VKey_NavLookDown: {};
  Aspect_VKey_NavCrouch: {};
  Aspect_VKey_NavJump: {};
  Aspect_VKey_NavThrustForward: {};
  Aspect_VKey_NavThrustBackward: {};
  Aspect_VKey_NavThrustStop: {};
  Aspect_VKey_NavSpeedIncrease: {};
  Aspect_VKey_NavSpeedDecrease: {};
}

export declare class Handle_Aspect_Window {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_Window): void;
  get(): Aspect_Window;
  delete(): void;
}

  export declare class Handle_Aspect_Window_1 extends Handle_Aspect_Window {
    constructor();
  }

  export declare class Handle_Aspect_Window_2 extends Handle_Aspect_Window {
    constructor(thePtr: Aspect_Window);
  }

  export declare class Handle_Aspect_Window_3 extends Handle_Aspect_Window {
    constructor(theHandle: Handle_Aspect_Window);
  }

  export declare class Handle_Aspect_Window_4 extends Handle_Aspect_Window {
    constructor(theHandle: Handle_Aspect_Window);
  }

export declare class Aspect_Window extends Standard_Transient {
  SetBackground_1(ABack: Aspect_Background): void;
  SetBackground_2(color: Quantity_Color): void;
  SetBackground_3(ABackground: Aspect_GradientBackground): void;
  SetBackground_4(theFirstColor: Quantity_Color, theSecondColor: Quantity_Color, theFillMethod: Aspect_GradientFillMethod): void;
  Map(): void;
  Unmap(): void;
  DoResize(): Aspect_TypeOfResize;
  DoMapping(): Standard_Boolean;
  Background(): Aspect_Background;
  BackgroundFillMethod(): Aspect_FillMethod;
  GradientBackground(): Aspect_GradientBackground;
  IsMapped(): Standard_Boolean;
  IsVirtual(): Standard_Boolean;
  SetVirtual(theVirtual: Standard_Boolean): void;
  Ratio(): Quantity_AbsorbedDose;
  Position(X1: Graphic3d_ZLayerId, Y1: Graphic3d_ZLayerId, X2: Graphic3d_ZLayerId, Y2: Graphic3d_ZLayerId): void;
  Size(Width: Graphic3d_ZLayerId, Height: Graphic3d_ZLayerId): void;
  NativeHandle(): Aspect_Drawable;
  NativeParentHandle(): Aspect_Drawable;
  NativeFBConfig(): Aspect_FBConfig;
  SetTitle(theTitle: XCAFDoc_PartId): void;
  InvalidateContent(theDisp: Handle_Aspect_DisplayConnection): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type Aspect_TypeOfTriedronPosition = {
  Aspect_TOTP_CENTER: {};
  Aspect_TOTP_TOP: {};
  Aspect_TOTP_BOTTOM: {};
  Aspect_TOTP_LEFT: {};
  Aspect_TOTP_RIGHT: {};
  Aspect_TOTP_LEFT_LOWER: {};
  Aspect_TOTP_LEFT_UPPER: {};
  Aspect_TOTP_RIGHT_LOWER: {};
  Aspect_TOTP_RIGHT_UPPER: {};
}

export declare class Aspect_XRAnalogActionData {
  constructor()
  IsChanged(): Standard_Boolean;
  delete(): void;
}

export declare type Aspect_FillMethod = {
  Aspect_FM_NONE: {};
  Aspect_FM_CENTERED: {};
  Aspect_FM_TILED: {};
  Aspect_FM_STRETCH: {};
}

export declare type Aspect_TypeOfColorScalePosition = {
  Aspect_TOCSP_NONE: {};
  Aspect_TOCSP_LEFT: {};
  Aspect_TOCSP_RIGHT: {};
  Aspect_TOCSP_CENTER: {};
}

export declare class Aspect_OpenVRSession extends Aspect_XRSession {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static IsHmdPresent(): Standard_Boolean;
  IsOpen(): Standard_Boolean;
  Open(): Standard_Boolean;
  Close(): void;
  WaitPoses(): Standard_Boolean;
  RecommendedViewport(): any;
  EyeToHeadTransform(theEye: Aspect_Eye): any;
  ProjectionMatrix(theEye: Aspect_Eye, theZNear: Standard_Real, theZFar: Standard_Real): any;
  HasProjectionFrustums(): Standard_Boolean;
  ProcessEvents(): void;
  SubmitEye(theTexture: C_f, theGraphicsLib: Aspect_GraphicsLibrary, theColorSpace: Aspect_ColorSpace, theEye: Aspect_Eye): Standard_Boolean;
  GetString(theInfo: any): XCAFDoc_PartId;
  NamedTrackedDevice(theDevice: Aspect_XRTrackedDeviceRole): Graphic3d_ZLayerId;
  GetDigitalActionData(theAction: any): Aspect_XRDigitalActionData;
  GetAnalogActionData(theAction: any): Aspect_XRAnalogActionData;
  GetPoseActionDataForNextFrame(theAction: any): Aspect_XRPoseActionData;
  SetTrackingOrigin(theOrigin: any): void;
  delete(): void;
}

export declare class Aspect_XRSession extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsOpen(): Standard_Boolean;
  Open(): Standard_Boolean;
  Close(): void;
  WaitPoses(): Standard_Boolean;
  RecommendedViewport(): any;
  EyeToHeadTransform(theEye: Aspect_Eye): any;
  HeadToEyeTransform(theEye: Aspect_Eye): any;
  ProjectionMatrix(theEye: Aspect_Eye, theZNear: Standard_Real, theZFar: Standard_Real): any;
  HasProjectionFrustums(): Standard_Boolean;
  ProcessEvents(): void;
  SubmitEye(theTexture: C_f, theGraphicsLib: Aspect_GraphicsLibrary, theColorSpace: Aspect_ColorSpace, theEye: Aspect_Eye): Standard_Boolean;
  UnitFactor(): Quantity_AbsorbedDose;
  SetUnitFactor(theFactor: Quantity_AbsorbedDose): void;
  Aspect(): Quantity_AbsorbedDose;
  FieldOfView(): Quantity_AbsorbedDose;
  IOD(): Quantity_AbsorbedDose;
  DisplayFrequency(): Standard_ShortReal;
  ProjectionFrustum(theEye: Aspect_Eye): any;
  HeadPose(): gp_Trsf;
  LeftHandPose(): gp_Trsf;
  RightHandPose(): gp_Trsf;
  TrackedPoses(): Aspect_TrackedDevicePoseArray;
  HasTrackedPose(theDevice: Graphic3d_ZLayerId): Standard_Boolean;
  NamedTrackedDevice(theDevice: Aspect_XRTrackedDeviceRole): Graphic3d_ZLayerId;
  LoadRenderModel_1(theDevice: Graphic3d_ZLayerId, theTexture: any): Handle_Graphic3d_ArrayOfTriangles;
  LoadRenderModel_2(theDevice: Graphic3d_ZLayerId, theToApplyUnitFactor: Standard_Boolean, theTexture: any): Handle_Graphic3d_ArrayOfTriangles;
  GetDigitalActionData(theAction: any): Aspect_XRDigitalActionData;
  GetAnalogActionData(theAction: any): Aspect_XRAnalogActionData;
  GetPoseActionDataForNextFrame(theAction: any): Aspect_XRPoseActionData;
  TriggerHapticVibrationAction(theAction: any, theParams: Aspect_XRHapticActionData): void;
  AbortHapticVibrationAction(theAction: any): void;
  TrackingOrigin(): any;
  SetTrackingOrigin(theOrigin: any): void;
  GenericAction(theDevice: Aspect_XRTrackedDeviceRole, theAction: Aspect_XRGenericAction): any;
  GetString(theInfo: any): XCAFDoc_PartId;
  delete(): void;
}

export declare class Aspect_GradientBackground extends Aspect_Background {
  SetColors(AColor1: Quantity_Color, AColor2: Quantity_Color, AMethod: Aspect_GradientFillMethod): void;
  Colors(AColor1: Quantity_Color, AColor2: Quantity_Color): void;
  BgGradientFillMethod(): Aspect_GradientFillMethod;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Aspect_GradientBackground_1 extends Aspect_GradientBackground {
    constructor();
  }

  export declare class Aspect_GradientBackground_2 extends Aspect_GradientBackground {
    constructor(AColor1: Quantity_Color, AColor2: Quantity_Color, AMethod: Aspect_GradientFillMethod);
  }

export declare class Handle_Aspect_WindowDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_WindowDefinitionError): void;
  get(): Aspect_WindowDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_WindowDefinitionError_1 extends Handle_Aspect_WindowDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_WindowDefinitionError_2 extends Handle_Aspect_WindowDefinitionError {
    constructor(thePtr: Aspect_WindowDefinitionError);
  }

  export declare class Handle_Aspect_WindowDefinitionError_3 extends Handle_Aspect_WindowDefinitionError {
    constructor(theHandle: Handle_Aspect_WindowDefinitionError);
  }

  export declare class Handle_Aspect_WindowDefinitionError_4 extends Handle_Aspect_WindowDefinitionError {
    constructor(theHandle: Handle_Aspect_WindowDefinitionError);
  }

export declare class Aspect_WindowDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_WindowDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_WindowDefinitionError_1 extends Aspect_WindowDefinitionError {
    constructor();
  }

  export declare class Aspect_WindowDefinitionError_2 extends Aspect_WindowDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare type Aspect_TypeOfDisplayText = {
  Aspect_TODT_NORMAL: {};
  Aspect_TODT_SUBTITLE: {};
  Aspect_TODT_DEKALE: {};
  Aspect_TODT_BLEND: {};
  Aspect_TODT_DIMENSION: {};
  Aspect_TODT_SHADOW: {};
}

export declare class Handle_Aspect_NeutralWindow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_NeutralWindow): void;
  get(): Aspect_NeutralWindow;
  delete(): void;
}

  export declare class Handle_Aspect_NeutralWindow_1 extends Handle_Aspect_NeutralWindow {
    constructor();
  }

  export declare class Handle_Aspect_NeutralWindow_2 extends Handle_Aspect_NeutralWindow {
    constructor(thePtr: Aspect_NeutralWindow);
  }

  export declare class Handle_Aspect_NeutralWindow_3 extends Handle_Aspect_NeutralWindow {
    constructor(theHandle: Handle_Aspect_NeutralWindow);
  }

  export declare class Handle_Aspect_NeutralWindow_4 extends Handle_Aspect_NeutralWindow {
    constructor(theHandle: Handle_Aspect_NeutralWindow);
  }

export declare class Aspect_NeutralWindow extends Aspect_Window {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NativeHandle(): Aspect_Drawable;
  NativeParentHandle(): Aspect_Drawable;
  NativeFBConfig(): Aspect_FBConfig;
  SetNativeHandle(theWindow: Aspect_Drawable): Standard_Boolean;
  SetNativeHandles(theWindow: Aspect_Drawable, theParentWindow: Aspect_Drawable, theFbConfig: Aspect_FBConfig): Standard_Boolean;
  IsMapped(): Standard_Boolean;
  Map(): void;
  Unmap(): void;
  DoResize(): Aspect_TypeOfResize;
  DoMapping(): Standard_Boolean;
  Ratio(): Quantity_AbsorbedDose;
  Position(theX1: Graphic3d_ZLayerId, theY1: Graphic3d_ZLayerId, theX2: Graphic3d_ZLayerId, theY2: Graphic3d_ZLayerId): void;
  SetPosition_1(theX1: Graphic3d_ZLayerId, theY1: Graphic3d_ZLayerId): Standard_Boolean;
  SetPosition_2(theX1: Graphic3d_ZLayerId, theY1: Graphic3d_ZLayerId, theX2: Graphic3d_ZLayerId, theY2: Graphic3d_ZLayerId): Standard_Boolean;
  Size(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  SetSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare type Aspect_InteriorStyle = {
  Aspect_IS_EMPTY: {};
  Aspect_IS_SOLID: {};
  Aspect_IS_HATCH: {};
  Aspect_IS_HIDDENLINE: {};
  Aspect_IS_POINT: {};
  Aspect_IS_HOLLOW: {};
}

export declare type Aspect_GradientFillMethod = {
  Aspect_GFM_NONE: {};
  Aspect_GFM_HOR: {};
  Aspect_GFM_VER: {};
  Aspect_GFM_DIAG1: {};
  Aspect_GFM_DIAG2: {};
  Aspect_GFM_CORNER1: {};
  Aspect_GFM_CORNER2: {};
  Aspect_GFM_CORNER3: {};
  Aspect_GFM_CORNER4: {};
}

export declare class Aspect_AspectLineDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_AspectLineDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_AspectLineDefinitionError_1 extends Aspect_AspectLineDefinitionError {
    constructor();
  }

  export declare class Aspect_AspectLineDefinitionError_2 extends Aspect_AspectLineDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Aspect_AspectLineDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_AspectLineDefinitionError): void;
  get(): Aspect_AspectLineDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_AspectLineDefinitionError_1 extends Handle_Aspect_AspectLineDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_AspectLineDefinitionError_2 extends Handle_Aspect_AspectLineDefinitionError {
    constructor(thePtr: Aspect_AspectLineDefinitionError);
  }

  export declare class Handle_Aspect_AspectLineDefinitionError_3 extends Handle_Aspect_AspectLineDefinitionError {
    constructor(theHandle: Handle_Aspect_AspectLineDefinitionError);
  }

  export declare class Handle_Aspect_AspectLineDefinitionError_4 extends Handle_Aspect_AspectLineDefinitionError {
    constructor(theHandle: Handle_Aspect_AspectLineDefinitionError);
  }

export declare type Aspect_TypeOfStyleText = {
  Aspect_TOST_NORMAL: {};
  Aspect_TOST_ANNOTATION: {};
}

export declare type Aspect_ColorSpace = {
  Aspect_ColorSpace_sRGB: {};
  Aspect_ColorSpace_Linear: {};
}

export declare class Aspect_XRPoseActionData {
  constructor()
  delete(): void;
}

export declare type Aspect_TypeOfFacingModel = {
  Aspect_TOFM_BOTH_SIDE: {};
  Aspect_TOFM_BACK_SIDE: {};
  Aspect_TOFM_FRONT_SIDE: {};
}

export declare type Aspect_Eye = {
  Aspect_Eye_Left: {};
  Aspect_Eye_Right: {};
}

export declare type Aspect_TypeOfColorScaleData = {
  Aspect_TOCSD_AUTO: {};
  Aspect_TOCSD_USER: {};
}

export declare class Aspect_XRAction extends Standard_Transient {
  constructor(theId: XCAFDoc_PartId, theType: Aspect_XRActionType)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Id(): XCAFDoc_PartId;
  Type(): Aspect_XRActionType;
  IsValid(): Standard_Boolean;
  RawHandle(): uint64_t;
  SetRawHandle(theHande: uint64_t): void;
  delete(): void;
}

export declare class Aspect_AspectMarkerDefinitionError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_AspectMarkerDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_AspectMarkerDefinitionError_1 extends Aspect_AspectMarkerDefinitionError {
    constructor();
  }

  export declare class Aspect_AspectMarkerDefinitionError_2 extends Aspect_AspectMarkerDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Aspect_AspectMarkerDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_AspectMarkerDefinitionError): void;
  get(): Aspect_AspectMarkerDefinitionError;
  delete(): void;
}

  export declare class Handle_Aspect_AspectMarkerDefinitionError_1 extends Handle_Aspect_AspectMarkerDefinitionError {
    constructor();
  }

  export declare class Handle_Aspect_AspectMarkerDefinitionError_2 extends Handle_Aspect_AspectMarkerDefinitionError {
    constructor(thePtr: Aspect_AspectMarkerDefinitionError);
  }

  export declare class Handle_Aspect_AspectMarkerDefinitionError_3 extends Handle_Aspect_AspectMarkerDefinitionError {
    constructor(theHandle: Handle_Aspect_AspectMarkerDefinitionError);
  }

  export declare class Handle_Aspect_AspectMarkerDefinitionError_4 extends Handle_Aspect_AspectMarkerDefinitionError {
    constructor(theHandle: Handle_Aspect_AspectMarkerDefinitionError);
  }

export declare type Aspect_TypeOfMarker = {
  Aspect_TOM_EMPTY: {};
  Aspect_TOM_POINT: {};
  Aspect_TOM_PLUS: {};
  Aspect_TOM_STAR: {};
  Aspect_TOM_X: {};
  Aspect_TOM_O: {};
  Aspect_TOM_O_POINT: {};
  Aspect_TOM_O_PLUS: {};
  Aspect_TOM_O_STAR: {};
  Aspect_TOM_O_X: {};
  Aspect_TOM_RING1: {};
  Aspect_TOM_RING2: {};
  Aspect_TOM_RING3: {};
  Aspect_TOM_BALL: {};
  Aspect_TOM_USERDEFINED: {};
}

export declare type Aspect_TypeOfLine = {
  Aspect_TOL_EMPTY: {};
  Aspect_TOL_SOLID: {};
  Aspect_TOL_DASH: {};
  Aspect_TOL_DOT: {};
  Aspect_TOL_DOTDASH: {};
  Aspect_TOL_USERDEFINED: {};
}

export declare type Aspect_TypeOfResize = {
  Aspect_TOR_UNKNOWN: {};
  Aspect_TOR_NO_BORDER: {};
  Aspect_TOR_TOP_BORDER: {};
  Aspect_TOR_RIGHT_BORDER: {};
  Aspect_TOR_BOTTOM_BORDER: {};
  Aspect_TOR_LEFT_BORDER: {};
  Aspect_TOR_TOP_AND_RIGHT_BORDER: {};
  Aspect_TOR_RIGHT_AND_BOTTOM_BORDER: {};
  Aspect_TOR_BOTTOM_AND_LEFT_BORDER: {};
  Aspect_TOR_LEFT_AND_TOP_BORDER: {};
}

export declare class Handle_Aspect_WindowError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Aspect_WindowError): void;
  get(): Aspect_WindowError;
  delete(): void;
}

  export declare class Handle_Aspect_WindowError_1 extends Handle_Aspect_WindowError {
    constructor();
  }

  export declare class Handle_Aspect_WindowError_2 extends Handle_Aspect_WindowError {
    constructor(thePtr: Aspect_WindowError);
  }

  export declare class Handle_Aspect_WindowError_3 extends Handle_Aspect_WindowError {
    constructor(theHandle: Handle_Aspect_WindowError);
  }

  export declare class Handle_Aspect_WindowError_4 extends Handle_Aspect_WindowError {
    constructor(theHandle: Handle_Aspect_WindowError);
  }

export declare class Aspect_WindowError extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Aspect_WindowError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Aspect_WindowError_1 extends Aspect_WindowError {
    constructor();
  }

  export declare class Aspect_WindowError_2 extends Aspect_WindowError {
    constructor(theMessage: Standard_CString);
  }

export declare class Aspect_XRActionSet extends Standard_Transient {
  constructor(theId: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Id(): XCAFDoc_PartId;
  RawHandle(): uint64_t;
  SetRawHandle(theHande: uint64_t): void;
  AddAction(theAction: any): void;
  Actions(): Aspect_XRActionMap;
  delete(): void;
}

export declare class Hatch_SequenceOfParameter extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Hatch_SequenceOfParameter): Hatch_SequenceOfParameter;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Hatch_Parameter): void;
  Append_2(theSeq: Hatch_SequenceOfParameter): void;
  Prepend_1(theItem: Hatch_Parameter): void;
  Prepend_2(theSeq: Hatch_SequenceOfParameter): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Hatch_Parameter): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Hatch_SequenceOfParameter): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Hatch_SequenceOfParameter): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Hatch_Parameter): void;
  Split(theIndex: Standard_Integer, theSeq: Hatch_SequenceOfParameter): void;
  First(): Hatch_Parameter;
  ChangeFirst(): Hatch_Parameter;
  Last(): Hatch_Parameter;
  ChangeLast(): Hatch_Parameter;
  Value(theIndex: Standard_Integer): Hatch_Parameter;
  ChangeValue(theIndex: Standard_Integer): Hatch_Parameter;
  SetValue(theIndex: Standard_Integer, theItem: Hatch_Parameter): void;
  delete(): void;
}

  export declare class Hatch_SequenceOfParameter_1 extends Hatch_SequenceOfParameter {
    constructor();
  }

  export declare class Hatch_SequenceOfParameter_2 extends Hatch_SequenceOfParameter {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Hatch_SequenceOfParameter_3 extends Hatch_SequenceOfParameter {
    constructor(theOther: Hatch_SequenceOfParameter);
  }

export declare type Hatch_LineForm = {
  Hatch_XLINE: {};
  Hatch_YLINE: {};
  Hatch_ANYLINE: {};
}

export declare class Hatch_SequenceOfLine extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Hatch_SequenceOfLine): Hatch_SequenceOfLine;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Hatch_Line): void;
  Append_2(theSeq: Hatch_SequenceOfLine): void;
  Prepend_1(theItem: Hatch_Line): void;
  Prepend_2(theSeq: Hatch_SequenceOfLine): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Hatch_Line): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Hatch_SequenceOfLine): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Hatch_SequenceOfLine): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Hatch_Line): void;
  Split(theIndex: Standard_Integer, theSeq: Hatch_SequenceOfLine): void;
  First(): Hatch_Line;
  ChangeFirst(): Hatch_Line;
  Last(): Hatch_Line;
  ChangeLast(): Hatch_Line;
  Value(theIndex: Standard_Integer): Hatch_Line;
  ChangeValue(theIndex: Standard_Integer): Hatch_Line;
  SetValue(theIndex: Standard_Integer, theItem: Hatch_Line): void;
  delete(): void;
}

  export declare class Hatch_SequenceOfLine_1 extends Hatch_SequenceOfLine {
    constructor();
  }

  export declare class Hatch_SequenceOfLine_2 extends Hatch_SequenceOfLine {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Hatch_SequenceOfLine_3 extends Hatch_SequenceOfLine {
    constructor(theOther: Hatch_SequenceOfLine);
  }

export declare class Hatch_Parameter {
  delete(): void;
}

  export declare class Hatch_Parameter_1 extends Hatch_Parameter {
    constructor();
  }

  export declare class Hatch_Parameter_2 extends Hatch_Parameter {
    constructor(Par1: Quantity_AbsorbedDose, Start: Standard_Boolean, Index: Graphic3d_ZLayerId, Par2: Quantity_AbsorbedDose);
  }

export declare class Hatch_Hatcher {
  constructor(Tol: Quantity_AbsorbedDose, Oriented: Standard_Boolean)
  Tolerance_1(Tol: Quantity_AbsorbedDose): void;
  Tolerance_2(): Quantity_AbsorbedDose;
  AddLine_1(L: gp_Lin2d, T: Hatch_LineForm): void;
  AddLine_2(D: gp_Dir2d, Dist: Quantity_AbsorbedDose): void;
  AddXLine(X: Quantity_AbsorbedDose): void;
  AddYLine(Y: Quantity_AbsorbedDose): void;
  Trim_1(L: gp_Lin2d, Index: Graphic3d_ZLayerId): void;
  Trim_2(L: gp_Lin2d, Start: Quantity_AbsorbedDose, End: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId): void;
  Trim_3(P1: gp_Pnt2d, P2: gp_Pnt2d, Index: Graphic3d_ZLayerId): void;
  NbIntervals_1(): Graphic3d_ZLayerId;
  NbLines(): Graphic3d_ZLayerId;
  Line(I: Graphic3d_ZLayerId): gp_Lin2d;
  LineForm(I: Graphic3d_ZLayerId): Hatch_LineForm;
  IsXLine(I: Graphic3d_ZLayerId): Standard_Boolean;
  IsYLine(I: Graphic3d_ZLayerId): Standard_Boolean;
  Coordinate(I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbIntervals_2(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Start(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  StartIndex(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Par2: Quantity_AbsorbedDose): void;
  End(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  EndIndex(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Par2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Hatch_Line {
  AddIntersection(Par1: Quantity_AbsorbedDose, Start: Standard_Boolean, Index: Graphic3d_ZLayerId, Par2: Quantity_AbsorbedDose, theToler: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Hatch_Line_1 extends Hatch_Line {
    constructor();
  }

  export declare class Hatch_Line_2 extends Hatch_Line {
    constructor(L: gp_Lin2d, T: Hatch_LineForm);
  }

export declare class PrsDim_LengthDimension extends PrsDim_Dimension {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  FirstPoint(): gp_Pnt;
  SecondPoint(): gp_Pnt;
  FirstShape(): TopoDS_Shape;
  SecondShape(): TopoDS_Shape;
  SetMeasuredGeometry_1(theFirstPoint: gp_Pnt, theSecondPoint: gp_Pnt, thePlane: gp_Pln): void;
  SetMeasuredGeometry_2(theEdge: TopoDS_Edge, thePlane: gp_Pln): void;
  SetMeasuredGeometry_3(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face): void;
  SetMeasuredGeometry_4(theFace: TopoDS_Face, theEdge: TopoDS_Edge): void;
  SetMeasuredShapes(theFirstShape: TopoDS_Shape, theSecondShape: TopoDS_Shape): void;
  GetDisplayUnits(): XCAFDoc_PartId;
  GetModelUnits(): XCAFDoc_PartId;
  SetDisplayUnits(theUnits: XCAFDoc_PartId): void;
  SetModelUnits(theUnits: XCAFDoc_PartId): void;
  SetTextPosition(theTextPos: gp_Pnt): void;
  GetTextPosition(): gp_Pnt;
  SetDirection(theDirection: gp_Dir, theUseDirection: Standard_Boolean): void;
  delete(): void;
}

  export declare class PrsDim_LengthDimension_1 extends PrsDim_LengthDimension {
    constructor(theFace: TopoDS_Face, theEdge: TopoDS_Edge);
  }

  export declare class PrsDim_LengthDimension_2 extends PrsDim_LengthDimension {
    constructor(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face);
  }

  export declare class PrsDim_LengthDimension_3 extends PrsDim_LengthDimension {
    constructor(theFirstPoint: gp_Pnt, theSecondPoint: gp_Pnt, thePlane: gp_Pln);
  }

  export declare class PrsDim_LengthDimension_4 extends PrsDim_LengthDimension {
    constructor(theFirstShape: TopoDS_Shape, theSecondShape: TopoDS_Shape, thePlane: gp_Pln);
  }

  export declare class PrsDim_LengthDimension_5 extends PrsDim_LengthDimension {
    constructor(theEdge: TopoDS_Edge, thePlane: gp_Pln);
  }

export declare class Handle_PrsDim_LengthDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_LengthDimension): void;
  get(): PrsDim_LengthDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_LengthDimension_1 extends Handle_PrsDim_LengthDimension {
    constructor();
  }

  export declare class Handle_PrsDim_LengthDimension_2 extends Handle_PrsDim_LengthDimension {
    constructor(thePtr: PrsDim_LengthDimension);
  }

  export declare class Handle_PrsDim_LengthDimension_3 extends Handle_PrsDim_LengthDimension {
    constructor(theHandle: Handle_PrsDim_LengthDimension);
  }

  export declare class Handle_PrsDim_LengthDimension_4 extends Handle_PrsDim_LengthDimension {
    constructor(theHandle: Handle_PrsDim_LengthDimension);
  }

export declare type PrsDim_KindOfSurface = {
  PrsDim_KOS_Plane: {};
  PrsDim_KOS_Cylinder: {};
  PrsDim_KOS_Cone: {};
  PrsDim_KOS_Sphere: {};
  PrsDim_KOS_Torus: {};
  PrsDim_KOS_Revolution: {};
  PrsDim_KOS_Extrusion: {};
  PrsDim_KOS_OtherSurface: {};
}

export declare type PrsDim_KindOfRelation = {
  PrsDim_KOR_NONE: {};
  PrsDim_KOR_CONCENTRIC: {};
  PrsDim_KOR_EQUALDISTANCE: {};
  PrsDim_KOR_EQUALRADIUS: {};
  PrsDim_KOR_FIX: {};
  PrsDim_KOR_IDENTIC: {};
  PrsDim_KOR_OFFSET: {};
  PrsDim_KOR_PARALLEL: {};
  PrsDim_KOR_PERPENDICULAR: {};
  PrsDim_KOR_TANGENT: {};
  PrsDim_KOR_SYMMETRIC: {};
}

export declare class PrsDim_AngleDimension extends PrsDim_Dimension {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  FirstPoint(): gp_Pnt;
  SecondPoint(): gp_Pnt;
  CenterPoint(): gp_Pnt;
  FirstShape(): TopoDS_Shape;
  SecondShape(): TopoDS_Shape;
  ThirdShape(): TopoDS_Shape;
  SetMeasuredGeometry_1(theFirstEdge: TopoDS_Edge, theSecondEdge: TopoDS_Edge): void;
  SetMeasuredGeometry_2(theFirstPoint: gp_Pnt, theSecondPoint: gp_Pnt, theThridPoint: gp_Pnt): void;
  SetMeasuredGeometry_3(theFirstVertex: TopoDS_Vertex, theSecondVertex: TopoDS_Vertex, theThirdVertex: TopoDS_Vertex): void;
  SetMeasuredGeometry_4(theCone: TopoDS_Face): void;
  SetMeasuredGeometry_5(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face): void;
  SetMeasuredGeometry_6(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face, thePoint: gp_Pnt): void;
  GetDisplayUnits(): XCAFDoc_PartId;
  GetModelUnits(): XCAFDoc_PartId;
  SetDisplayUnits(theUnits: XCAFDoc_PartId): void;
  SetModelUnits(theUnits: XCAFDoc_PartId): void;
  SetTextPosition(theTextPos: gp_Pnt): void;
  GetTextPosition(): gp_Pnt;
  SetType(theType: PrsDim_TypeOfAngle): void;
  GetType(): PrsDim_TypeOfAngle;
  SetArrowsVisibility(theType: PrsDim_TypeOfAngleArrowVisibility): void;
  GetArrowsVisibility(): PrsDim_TypeOfAngleArrowVisibility;
  delete(): void;
}

  export declare class PrsDim_AngleDimension_1 extends PrsDim_AngleDimension {
    constructor(theFirstEdge: TopoDS_Edge, theSecondEdge: TopoDS_Edge);
  }

  export declare class PrsDim_AngleDimension_2 extends PrsDim_AngleDimension {
    constructor(theFirstPoint: gp_Pnt, theSecondPoint: gp_Pnt, theThirdPoint: gp_Pnt);
  }

  export declare class PrsDim_AngleDimension_3 extends PrsDim_AngleDimension {
    constructor(theFirstVertex: TopoDS_Vertex, theSecondVertex: TopoDS_Vertex, theThirdVertex: TopoDS_Vertex);
  }

  export declare class PrsDim_AngleDimension_4 extends PrsDim_AngleDimension {
    constructor(theCone: TopoDS_Face);
  }

  export declare class PrsDim_AngleDimension_5 extends PrsDim_AngleDimension {
    constructor(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face);
  }

  export declare class PrsDim_AngleDimension_6 extends PrsDim_AngleDimension {
    constructor(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face, thePoint: gp_Pnt);
  }

export declare class Handle_PrsDim_AngleDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_AngleDimension): void;
  get(): PrsDim_AngleDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_AngleDimension_1 extends Handle_PrsDim_AngleDimension {
    constructor();
  }

  export declare class Handle_PrsDim_AngleDimension_2 extends Handle_PrsDim_AngleDimension {
    constructor(thePtr: PrsDim_AngleDimension);
  }

  export declare class Handle_PrsDim_AngleDimension_3 extends Handle_PrsDim_AngleDimension {
    constructor(theHandle: Handle_PrsDim_AngleDimension);
  }

  export declare class Handle_PrsDim_AngleDimension_4 extends Handle_PrsDim_AngleDimension {
    constructor(theHandle: Handle_PrsDim_AngleDimension);
  }

export declare type PrsDim_DimensionSelectionMode = {
  PrsDim_DimensionSelectionMode_All: {};
  PrsDim_DimensionSelectionMode_Line: {};
  PrsDim_DimensionSelectionMode_Text: {};
}

export declare class Handle_PrsDim_MidPointRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_MidPointRelation): void;
  get(): PrsDim_MidPointRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_MidPointRelation_1 extends Handle_PrsDim_MidPointRelation {
    constructor();
  }

  export declare class Handle_PrsDim_MidPointRelation_2 extends Handle_PrsDim_MidPointRelation {
    constructor(thePtr: PrsDim_MidPointRelation);
  }

  export declare class Handle_PrsDim_MidPointRelation_3 extends Handle_PrsDim_MidPointRelation {
    constructor(theHandle: Handle_PrsDim_MidPointRelation);
  }

  export declare class Handle_PrsDim_MidPointRelation_4 extends Handle_PrsDim_MidPointRelation {
    constructor(theHandle: Handle_PrsDim_MidPointRelation);
  }

export declare class PrsDim_MidPointRelation extends PrsDim_Relation {
  constructor(aSymmTool: TopoDS_Shape, FirstShape: TopoDS_Shape, SecondShape: TopoDS_Shape, aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsMovable(): Standard_Boolean;
  SetTool(aMidPointTool: TopoDS_Shape): void;
  GetTool(): TopoDS_Shape;
  delete(): void;
}

export declare class Handle_PrsDim_DiameterDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_DiameterDimension): void;
  get(): PrsDim_DiameterDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_DiameterDimension_1 extends Handle_PrsDim_DiameterDimension {
    constructor();
  }

  export declare class Handle_PrsDim_DiameterDimension_2 extends Handle_PrsDim_DiameterDimension {
    constructor(thePtr: PrsDim_DiameterDimension);
  }

  export declare class Handle_PrsDim_DiameterDimension_3 extends Handle_PrsDim_DiameterDimension {
    constructor(theHandle: Handle_PrsDim_DiameterDimension);
  }

  export declare class Handle_PrsDim_DiameterDimension_4 extends Handle_PrsDim_DiameterDimension {
    constructor(theHandle: Handle_PrsDim_DiameterDimension);
  }

export declare class PrsDim_DiameterDimension extends PrsDim_Dimension {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Circle(): gp_Circ;
  AnchorPoint(): gp_Pnt;
  Shape(): TopoDS_Shape;
  SetMeasuredGeometry_1(theCircle: gp_Circ): void;
  SetMeasuredGeometry_2(theShape: TopoDS_Shape): void;
  GetDisplayUnits(): XCAFDoc_PartId;
  GetModelUnits(): XCAFDoc_PartId;
  SetDisplayUnits(theUnits: XCAFDoc_PartId): void;
  SetModelUnits(theUnits: XCAFDoc_PartId): void;
  SetTextPosition(theTextPos: gp_Pnt): void;
  GetTextPosition(): gp_Pnt;
  delete(): void;
}

  export declare class PrsDim_DiameterDimension_1 extends PrsDim_DiameterDimension {
    constructor(theCircle: gp_Circ);
  }

  export declare class PrsDim_DiameterDimension_2 extends PrsDim_DiameterDimension {
    constructor(theCircle: gp_Circ, thePlane: gp_Pln);
  }

  export declare class PrsDim_DiameterDimension_3 extends PrsDim_DiameterDimension {
    constructor(theShape: TopoDS_Shape);
  }

  export declare class PrsDim_DiameterDimension_4 extends PrsDim_DiameterDimension {
    constructor(theShape: TopoDS_Shape, thePlane: gp_Pln);
  }

export declare class PrsDim_OffsetDimension extends PrsDim_Relation {
  constructor(FistShape: TopoDS_Shape, SecondShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  KindOfDimension(): PrsDim_KindOfDimension;
  IsMovable(): Standard_Boolean;
  SetRelativePos(aTrsf: gp_Trsf): void;
  delete(): void;
}

export declare class Handle_PrsDim_OffsetDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_OffsetDimension): void;
  get(): PrsDim_OffsetDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_OffsetDimension_1 extends Handle_PrsDim_OffsetDimension {
    constructor();
  }

  export declare class Handle_PrsDim_OffsetDimension_2 extends Handle_PrsDim_OffsetDimension {
    constructor(thePtr: PrsDim_OffsetDimension);
  }

  export declare class Handle_PrsDim_OffsetDimension_3 extends Handle_PrsDim_OffsetDimension {
    constructor(theHandle: Handle_PrsDim_OffsetDimension);
  }

  export declare class Handle_PrsDim_OffsetDimension_4 extends Handle_PrsDim_OffsetDimension {
    constructor(theHandle: Handle_PrsDim_OffsetDimension);
  }

export declare class PrsDim_MinRadiusDimension extends PrsDim_EllipseRadiusDimension {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class PrsDim_MinRadiusDimension_1 extends PrsDim_MinRadiusDimension {
    constructor(aShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString);
  }

  export declare class PrsDim_MinRadiusDimension_2 extends PrsDim_MinRadiusDimension {
    constructor(aShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aPosition: gp_Pnt, aSymbolPrs: DsgPrs_ArrowSide, anArrowSize: Quantity_AbsorbedDose);
  }

export declare class Handle_PrsDim_MinRadiusDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_MinRadiusDimension): void;
  get(): PrsDim_MinRadiusDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_MinRadiusDimension_1 extends Handle_PrsDim_MinRadiusDimension {
    constructor();
  }

  export declare class Handle_PrsDim_MinRadiusDimension_2 extends Handle_PrsDim_MinRadiusDimension {
    constructor(thePtr: PrsDim_MinRadiusDimension);
  }

  export declare class Handle_PrsDim_MinRadiusDimension_3 extends Handle_PrsDim_MinRadiusDimension {
    constructor(theHandle: Handle_PrsDim_MinRadiusDimension);
  }

  export declare class Handle_PrsDim_MinRadiusDimension_4 extends Handle_PrsDim_MinRadiusDimension {
    constructor(theHandle: Handle_PrsDim_MinRadiusDimension);
  }

export declare class PrsDim_EqualDistanceRelation extends PrsDim_Relation {
  constructor(aShape1: TopoDS_Shape, aShape2: TopoDS_Shape, aShape3: TopoDS_Shape, aShape4: TopoDS_Shape, aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetShape3(aShape: TopoDS_Shape): void;
  Shape3(): TopoDS_Shape;
  SetShape4(aShape: TopoDS_Shape): void;
  Shape4(): TopoDS_Shape;
  static ComputeTwoEdgesLength(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, ArrowSize: Quantity_AbsorbedDose, FirstEdge: TopoDS_Edge, SecondEdge: TopoDS_Edge, Plane: Handle_Geom_Plane, AutomaticPos: Standard_Boolean, IsSetBndBox: Standard_Boolean, BndBox: Bnd_Box, Position: gp_Pnt, FirstAttach: gp_Pnt, SecondAttach: gp_Pnt, FirstExtreme: gp_Pnt, SecondExtreme: gp_Pnt, SymbolPrs: DsgPrs_ArrowSide): void;
  static ComputeTwoVerticesLength(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, ArrowSize: Quantity_AbsorbedDose, FirstVertex: TopoDS_Vertex, SecondVertex: TopoDS_Vertex, Plane: Handle_Geom_Plane, AutomaticPos: Standard_Boolean, IsSetBndBox: Standard_Boolean, BndBox: Bnd_Box, TypeDist: PrsDim_TypeOfDist, Position: gp_Pnt, FirstAttach: gp_Pnt, SecondAttach: gp_Pnt, FirstExtreme: gp_Pnt, SecondExtreme: gp_Pnt, SymbolPrs: DsgPrs_ArrowSide): void;
  static ComputeOneEdgeOneVertexLength(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, ArrowSize: Quantity_AbsorbedDose, FirstShape: TopoDS_Shape, SecondShape: TopoDS_Shape, Plane: Handle_Geom_Plane, AutomaticPos: Standard_Boolean, IsSetBndBox: Standard_Boolean, BndBox: Bnd_Box, Position: gp_Pnt, FirstAttach: gp_Pnt, SecondAttach: gp_Pnt, FirstExtreme: gp_Pnt, SecondExtreme: gp_Pnt, SymbolPrs: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class Handle_PrsDim_EqualDistanceRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_EqualDistanceRelation): void;
  get(): PrsDim_EqualDistanceRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_EqualDistanceRelation_1 extends Handle_PrsDim_EqualDistanceRelation {
    constructor();
  }

  export declare class Handle_PrsDim_EqualDistanceRelation_2 extends Handle_PrsDim_EqualDistanceRelation {
    constructor(thePtr: PrsDim_EqualDistanceRelation);
  }

  export declare class Handle_PrsDim_EqualDistanceRelation_3 extends Handle_PrsDim_EqualDistanceRelation {
    constructor(theHandle: Handle_PrsDim_EqualDistanceRelation);
  }

  export declare class Handle_PrsDim_EqualDistanceRelation_4 extends Handle_PrsDim_EqualDistanceRelation {
    constructor(theHandle: Handle_PrsDim_EqualDistanceRelation);
  }

export declare class Handle_PrsDim_Dimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_Dimension): void;
  get(): PrsDim_Dimension;
  delete(): void;
}

  export declare class Handle_PrsDim_Dimension_1 extends Handle_PrsDim_Dimension {
    constructor();
  }

  export declare class Handle_PrsDim_Dimension_2 extends Handle_PrsDim_Dimension {
    constructor(thePtr: PrsDim_Dimension);
  }

  export declare class Handle_PrsDim_Dimension_3 extends Handle_PrsDim_Dimension {
    constructor(theHandle: Handle_PrsDim_Dimension);
  }

  export declare class Handle_PrsDim_Dimension_4 extends Handle_PrsDim_Dimension {
    constructor(theHandle: Handle_PrsDim_Dimension);
  }

export declare type PrsDim_TypeOfAngleArrowVisibility = {
  PrsDim_TypeOfAngleArrowVisibility_Both: {};
  PrsDim_TypeOfAngleArrowVisibility_First: {};
  PrsDim_TypeOfAngleArrowVisibility_Second: {};
  PrsDim_TypeOfAngleArrowVisibility_None: {};
}

export declare class Handle_PrsDim_DimensionOwner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_DimensionOwner): void;
  get(): PrsDim_DimensionOwner;
  delete(): void;
}

  export declare class Handle_PrsDim_DimensionOwner_1 extends Handle_PrsDim_DimensionOwner {
    constructor();
  }

  export declare class Handle_PrsDim_DimensionOwner_2 extends Handle_PrsDim_DimensionOwner {
    constructor(thePtr: PrsDim_DimensionOwner);
  }

  export declare class Handle_PrsDim_DimensionOwner_3 extends Handle_PrsDim_DimensionOwner {
    constructor(theHandle: Handle_PrsDim_DimensionOwner);
  }

  export declare class Handle_PrsDim_DimensionOwner_4 extends Handle_PrsDim_DimensionOwner {
    constructor(theHandle: Handle_PrsDim_DimensionOwner);
  }

export declare class PrsDim_DimensionOwner extends SelectMgr_EntityOwner {
  constructor(theSelObject: Handle_SelectMgr_SelectableObject, theSelMode: PrsDim_DimensionSelectionMode, thePriority: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SelectionMode(): PrsDim_DimensionSelectionMode;
  HilightWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId): void;
  IsHilighted(thePM: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Unhilight(thePM: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class PrsDim_EllipseRadiusDimension extends PrsDim_Relation {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  KindOfDimension(): PrsDim_KindOfDimension;
  IsMovable(): Standard_Boolean;
  ComputeGeometry(): void;
  delete(): void;
}

export declare class Handle_PrsDim_EllipseRadiusDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_EllipseRadiusDimension): void;
  get(): PrsDim_EllipseRadiusDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_EllipseRadiusDimension_1 extends Handle_PrsDim_EllipseRadiusDimension {
    constructor();
  }

  export declare class Handle_PrsDim_EllipseRadiusDimension_2 extends Handle_PrsDim_EllipseRadiusDimension {
    constructor(thePtr: PrsDim_EllipseRadiusDimension);
  }

  export declare class Handle_PrsDim_EllipseRadiusDimension_3 extends Handle_PrsDim_EllipseRadiusDimension {
    constructor(theHandle: Handle_PrsDim_EllipseRadiusDimension);
  }

  export declare class Handle_PrsDim_EllipseRadiusDimension_4 extends Handle_PrsDim_EllipseRadiusDimension {
    constructor(theHandle: Handle_PrsDim_EllipseRadiusDimension);
  }

export declare class Handle_PrsDim_PerpendicularRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_PerpendicularRelation): void;
  get(): PrsDim_PerpendicularRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_PerpendicularRelation_1 extends Handle_PrsDim_PerpendicularRelation {
    constructor();
  }

  export declare class Handle_PrsDim_PerpendicularRelation_2 extends Handle_PrsDim_PerpendicularRelation {
    constructor(thePtr: PrsDim_PerpendicularRelation);
  }

  export declare class Handle_PrsDim_PerpendicularRelation_3 extends Handle_PrsDim_PerpendicularRelation {
    constructor(theHandle: Handle_PrsDim_PerpendicularRelation);
  }

  export declare class Handle_PrsDim_PerpendicularRelation_4 extends Handle_PrsDim_PerpendicularRelation {
    constructor(theHandle: Handle_PrsDim_PerpendicularRelation);
  }

export declare class PrsDim_PerpendicularRelation extends PrsDim_Relation {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class PrsDim_PerpendicularRelation_1 extends PrsDim_PerpendicularRelation {
    constructor(aFShape: TopoDS_Shape, aSShape: TopoDS_Shape, aPlane: Handle_Geom_Plane);
  }

  export declare class PrsDim_PerpendicularRelation_2 extends PrsDim_PerpendicularRelation {
    constructor(aFShape: TopoDS_Shape, aSShape: TopoDS_Shape);
  }

export declare type PrsDim_DisplaySpecialSymbol = {
  PrsDim_DisplaySpecialSymbol_No: {};
  PrsDim_DisplaySpecialSymbol_Before: {};
  PrsDim_DisplaySpecialSymbol_After: {};
}

export declare class PrsDim_MaxRadiusDimension extends PrsDim_EllipseRadiusDimension {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class PrsDim_MaxRadiusDimension_1 extends PrsDim_MaxRadiusDimension {
    constructor(aShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString);
  }

  export declare class PrsDim_MaxRadiusDimension_2 extends PrsDim_MaxRadiusDimension {
    constructor(aShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aPosition: gp_Pnt, aSymbolPrs: DsgPrs_ArrowSide, anArrowSize: Quantity_AbsorbedDose);
  }

export declare class Handle_PrsDim_MaxRadiusDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_MaxRadiusDimension): void;
  get(): PrsDim_MaxRadiusDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_MaxRadiusDimension_1 extends Handle_PrsDim_MaxRadiusDimension {
    constructor();
  }

  export declare class Handle_PrsDim_MaxRadiusDimension_2 extends Handle_PrsDim_MaxRadiusDimension {
    constructor(thePtr: PrsDim_MaxRadiusDimension);
  }

  export declare class Handle_PrsDim_MaxRadiusDimension_3 extends Handle_PrsDim_MaxRadiusDimension {
    constructor(theHandle: Handle_PrsDim_MaxRadiusDimension);
  }

  export declare class Handle_PrsDim_MaxRadiusDimension_4 extends Handle_PrsDim_MaxRadiusDimension {
    constructor(theHandle: Handle_PrsDim_MaxRadiusDimension);
  }

export declare class PrsDim_EqualRadiusRelation extends PrsDim_Relation {
  constructor(aFirstEdge: TopoDS_Edge, aSecondEdge: TopoDS_Edge, aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PrsDim_EqualRadiusRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_EqualRadiusRelation): void;
  get(): PrsDim_EqualRadiusRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_EqualRadiusRelation_1 extends Handle_PrsDim_EqualRadiusRelation {
    constructor();
  }

  export declare class Handle_PrsDim_EqualRadiusRelation_2 extends Handle_PrsDim_EqualRadiusRelation {
    constructor(thePtr: PrsDim_EqualRadiusRelation);
  }

  export declare class Handle_PrsDim_EqualRadiusRelation_3 extends Handle_PrsDim_EqualRadiusRelation {
    constructor(theHandle: Handle_PrsDim_EqualRadiusRelation);
  }

  export declare class Handle_PrsDim_EqualRadiusRelation_4 extends Handle_PrsDim_EqualRadiusRelation {
    constructor(theHandle: Handle_PrsDim_EqualRadiusRelation);
  }

export declare class PrsDim_Chamf2dDimension extends PrsDim_Relation {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  KindOfDimension(): PrsDim_KindOfDimension;
  IsMovable(): Standard_Boolean;
  delete(): void;
}

  export declare class PrsDim_Chamf2dDimension_1 extends PrsDim_Chamf2dDimension {
    constructor(aFShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString);
  }

  export declare class PrsDim_Chamf2dDimension_2 extends PrsDim_Chamf2dDimension {
    constructor(aFShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aPosition: gp_Pnt, aSymbolPrs: DsgPrs_ArrowSide, anArrowSize: Quantity_AbsorbedDose);
  }

export declare class Handle_PrsDim_Chamf2dDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_Chamf2dDimension): void;
  get(): PrsDim_Chamf2dDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_Chamf2dDimension_1 extends Handle_PrsDim_Chamf2dDimension {
    constructor();
  }

  export declare class Handle_PrsDim_Chamf2dDimension_2 extends Handle_PrsDim_Chamf2dDimension {
    constructor(thePtr: PrsDim_Chamf2dDimension);
  }

  export declare class Handle_PrsDim_Chamf2dDimension_3 extends Handle_PrsDim_Chamf2dDimension {
    constructor(theHandle: Handle_PrsDim_Chamf2dDimension);
  }

  export declare class Handle_PrsDim_Chamf2dDimension_4 extends Handle_PrsDim_Chamf2dDimension {
    constructor(theHandle: Handle_PrsDim_Chamf2dDimension);
  }

export declare class Handle_PrsDim_RadiusDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_RadiusDimension): void;
  get(): PrsDim_RadiusDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_RadiusDimension_1 extends Handle_PrsDim_RadiusDimension {
    constructor();
  }

  export declare class Handle_PrsDim_RadiusDimension_2 extends Handle_PrsDim_RadiusDimension {
    constructor(thePtr: PrsDim_RadiusDimension);
  }

  export declare class Handle_PrsDim_RadiusDimension_3 extends Handle_PrsDim_RadiusDimension {
    constructor(theHandle: Handle_PrsDim_RadiusDimension);
  }

  export declare class Handle_PrsDim_RadiusDimension_4 extends Handle_PrsDim_RadiusDimension {
    constructor(theHandle: Handle_PrsDim_RadiusDimension);
  }

export declare class PrsDim_RadiusDimension extends PrsDim_Dimension {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Circle(): gp_Circ;
  AnchorPoint(): gp_Pnt;
  Shape(): TopoDS_Shape;
  SetMeasuredGeometry_1(theCircle: gp_Circ): void;
  SetMeasuredGeometry_2(theCircle: gp_Circ, theAnchorPoint: gp_Pnt, theHasAnchor: Standard_Boolean): void;
  SetMeasuredGeometry_3(theShape: TopoDS_Shape): void;
  SetMeasuredGeometry_4(theShape: TopoDS_Shape, theAnchorPoint: gp_Pnt, theHasAnchor: Standard_Boolean): void;
  GetDisplayUnits(): XCAFDoc_PartId;
  GetModelUnits(): XCAFDoc_PartId;
  SetDisplayUnits(theUnits: XCAFDoc_PartId): void;
  SetModelUnits(theUnits: XCAFDoc_PartId): void;
  SetTextPosition(theTextPos: gp_Pnt): void;
  GetTextPosition(): gp_Pnt;
  delete(): void;
}

  export declare class PrsDim_RadiusDimension_1 extends PrsDim_RadiusDimension {
    constructor(theCircle: gp_Circ);
  }

  export declare class PrsDim_RadiusDimension_2 extends PrsDim_RadiusDimension {
    constructor(theCircle: gp_Circ, theAnchorPoint: gp_Pnt);
  }

  export declare class PrsDim_RadiusDimension_3 extends PrsDim_RadiusDimension {
    constructor(theShape: TopoDS_Shape);
  }

export declare class Handle_PrsDim_ParallelRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_ParallelRelation): void;
  get(): PrsDim_ParallelRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_ParallelRelation_1 extends Handle_PrsDim_ParallelRelation {
    constructor();
  }

  export declare class Handle_PrsDim_ParallelRelation_2 extends Handle_PrsDim_ParallelRelation {
    constructor(thePtr: PrsDim_ParallelRelation);
  }

  export declare class Handle_PrsDim_ParallelRelation_3 extends Handle_PrsDim_ParallelRelation {
    constructor(theHandle: Handle_PrsDim_ParallelRelation);
  }

  export declare class Handle_PrsDim_ParallelRelation_4 extends Handle_PrsDim_ParallelRelation {
    constructor(theHandle: Handle_PrsDim_ParallelRelation);
  }

export declare class PrsDim_ParallelRelation extends PrsDim_Relation {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsMovable(): Standard_Boolean;
  delete(): void;
}

  export declare class PrsDim_ParallelRelation_1 extends PrsDim_ParallelRelation {
    constructor(aFShape: TopoDS_Shape, aSShape: TopoDS_Shape, aPlane: Handle_Geom_Plane);
  }

  export declare class PrsDim_ParallelRelation_2 extends PrsDim_ParallelRelation {
    constructor(aFShape: TopoDS_Shape, aSShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, aPosition: gp_Pnt, aSymbolPrs: DsgPrs_ArrowSide, anArrowSize: Quantity_AbsorbedDose);
  }

export declare class PrsDim {
  constructor();
  static Nearest_1(aShape: TopoDS_Shape, aPoint: gp_Pnt): gp_Pnt;
  static Nearest_2(theLine: gp_Lin, thePoint: gp_Pnt): gp_Pnt;
  static Nearest_3(theCurve: Handle_Geom_Curve, thePoint: gp_Pnt, theFirstPoint: gp_Pnt, theLastPoint: gp_Pnt, theNearestPoint: gp_Pnt): Standard_Boolean;
  static Farest(aShape: TopoDS_Shape, aPoint: gp_Pnt): gp_Pnt;
  static ComputeGeometry_1(theEdge: TopoDS_Edge, theCurve: Handle_Geom_Curve, theFirstPnt: gp_Pnt, theLastPnt: gp_Pnt): Standard_Boolean;
  static ComputeGeometry_2(theEdge: TopoDS_Edge, theCurve: Handle_Geom_Curve, theFirstPnt: gp_Pnt, theLastPnt: gp_Pnt, theIsInfinite: Standard_Boolean): Standard_Boolean;
  static ComputeGeometry_3(theEdge: TopoDS_Edge, theCurve: Handle_Geom_Curve, theFirstPnt: gp_Pnt, theLastPnt: gp_Pnt, theExtCurve: Handle_Geom_Curve, theIsInfinite: Standard_Boolean, theIsOnPlane: Standard_Boolean, thePlane: Handle_Geom_Plane): Standard_Boolean;
  static ComputeGeometry_4(theFirstEdge: TopoDS_Edge, theSecondEdge: TopoDS_Edge, theFirstCurve: Handle_Geom_Curve, theSecondCurve: Handle_Geom_Curve, theFirstPnt1: gp_Pnt, theLastPnt1: gp_Pnt, theFirstPnt2: gp_Pnt, theLastPnt2: gp_Pnt, thePlane: Handle_Geom_Plane): Standard_Boolean;
  static ComputeGeometry_5(theFirstEdge: TopoDS_Edge, theSecondEdge: TopoDS_Edge, theFirstCurve: Handle_Geom_Curve, theSecondCurve: Handle_Geom_Curve, theFirstPnt1: gp_Pnt, theLastPnt1: gp_Pnt, theFirstPnt2: gp_Pnt, theLastPnt2: gp_Pnt, theIsinfinite1: Standard_Boolean, theIsinfinite2: Standard_Boolean): Standard_Boolean;
  static ComputeGeometry_6(theFirstEdge: TopoDS_Edge, theSecondEdge: TopoDS_Edge, theExtIndex: Graphic3d_ZLayerId, theFirstCurve: Handle_Geom_Curve, theSecondCurve: Handle_Geom_Curve, theFirstPnt1: gp_Pnt, theLastPnt1: gp_Pnt, theFirstPnt2: gp_Pnt, theLastPnt2: gp_Pnt, theExtCurve: Handle_Geom_Curve, theIsinfinite1: Standard_Boolean, theIsinfinite2: Standard_Boolean, thePlane: Handle_Geom_Plane): Standard_Boolean;
  static ComputeGeomCurve(aCurve: Handle_Geom_Curve, first1: Quantity_AbsorbedDose, last1: Quantity_AbsorbedDose, FirstPnt1: gp_Pnt, LastPnt1: gp_Pnt, aPlane: Handle_Geom_Plane, isOnPlane: Standard_Boolean): Standard_Boolean;
  static ComputeGeometry_7(aVertex: TopoDS_Vertex, point: gp_Pnt, aPlane: Handle_Geom_Plane, isOnPlane: Standard_Boolean): Standard_Boolean;
  static GetPlaneFromFace(aFace: TopoDS_Face, aPlane: gp_Pln, aSurf: Handle_Geom_Surface, aSurfType: PrsDim_KindOfSurface, Offset: Quantity_AbsorbedDose): Standard_Boolean;
  static InitFaceLength(aFace: TopoDS_Face, aPlane: gp_Pln, aSurface: Handle_Geom_Surface, aSurfaceType: PrsDim_KindOfSurface, anOffset: Quantity_AbsorbedDose): void;
  static InitLengthBetweenCurvilinearFaces(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face, theFirstSurf: Handle_Geom_Surface, theSecondSurf: Handle_Geom_Surface, theFirstAttach: gp_Pnt, theSecondAttach: gp_Pnt, theDirOnPlane: gp_Dir): void;
  static InitAngleBetweenPlanarFaces(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face, theCenter: gp_Pnt, theFirstAttach: gp_Pnt, theSecondAttach: gp_Pnt, theIsFirstPointSet: Standard_Boolean): Standard_Boolean;
  static InitAngleBetweenCurvilinearFaces(theFirstFace: TopoDS_Face, theSecondFace: TopoDS_Face, theFirstSurfType: PrsDim_KindOfSurface, theSecondSurfType: PrsDim_KindOfSurface, theCenter: gp_Pnt, theFirstAttach: gp_Pnt, theSecondAttach: gp_Pnt, theIsFirstPointSet: Standard_Boolean): Standard_Boolean;
  static ProjectPointOnPlane(aPoint: gp_Pnt, aPlane: gp_Pln): gp_Pnt;
  static ProjectPointOnLine(aPoint: gp_Pnt, aLine: gp_Lin): gp_Pnt;
  static TranslatePointToBound(aPoint: gp_Pnt, aDir: gp_Dir, aBndBox: Bnd_Box): gp_Pnt;
  static InDomain(aFirstPar: Quantity_AbsorbedDose, aLastPar: Quantity_AbsorbedDose, anAttachPar: Quantity_AbsorbedDose): Standard_Boolean;
  static NearestApex(elips: gp_Elips, pApex: gp_Pnt, nApex: gp_Pnt, fpara: Quantity_AbsorbedDose, lpara: Quantity_AbsorbedDose, IsInDomain: Standard_Boolean): gp_Pnt;
  static DistanceFromApex(elips: gp_Elips, Apex: gp_Pnt, par: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static ComputeProjEdgePresentation(aPres: any, aDrawer: Handle_Prs3d_Drawer, anEdge: TopoDS_Edge, ProjCurve: Handle_Geom_Curve, FirstP: gp_Pnt, LastP: gp_Pnt, aColor: Quantity_NameOfColor, aWidth: Quantity_AbsorbedDose, aProjTOL: Aspect_TypeOfLine, aCallTOL: Aspect_TypeOfLine): void;
  static ComputeProjVertexPresentation(aPres: any, aDrawer: Handle_Prs3d_Drawer, aVertex: TopoDS_Vertex, ProjPoint: gp_Pnt, aColor: Quantity_NameOfColor, aWidth: Quantity_AbsorbedDose, aProjTOM: Aspect_TypeOfMarker, aCallTOL: Aspect_TypeOfLine): void;
  delete(): void;
}

export declare class PrsDim_IdenticRelation extends PrsDim_Relation {
  constructor(FirstShape: TopoDS_Shape, SecondShape: TopoDS_Shape, aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  HasUsers(): Standard_Boolean;
  Users(): TColStd_ListOfTransient;
  AddUser(theUser: Handle_Standard_Transient): void;
  ClearUsers(): void;
  IsMovable(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_PrsDim_IdenticRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_IdenticRelation): void;
  get(): PrsDim_IdenticRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_IdenticRelation_1 extends Handle_PrsDim_IdenticRelation {
    constructor();
  }

  export declare class Handle_PrsDim_IdenticRelation_2 extends Handle_PrsDim_IdenticRelation {
    constructor(thePtr: PrsDim_IdenticRelation);
  }

  export declare class Handle_PrsDim_IdenticRelation_3 extends Handle_PrsDim_IdenticRelation {
    constructor(theHandle: Handle_PrsDim_IdenticRelation);
  }

  export declare class Handle_PrsDim_IdenticRelation_4 extends Handle_PrsDim_IdenticRelation {
    constructor(theHandle: Handle_PrsDim_IdenticRelation);
  }

export declare class PrsDim_ConcentricRelation extends PrsDim_Relation {
  constructor(aFShape: TopoDS_Shape, aSShape: TopoDS_Shape, aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_PrsDim_ConcentricRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_ConcentricRelation): void;
  get(): PrsDim_ConcentricRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_ConcentricRelation_1 extends Handle_PrsDim_ConcentricRelation {
    constructor();
  }

  export declare class Handle_PrsDim_ConcentricRelation_2 extends Handle_PrsDim_ConcentricRelation {
    constructor(thePtr: PrsDim_ConcentricRelation);
  }

  export declare class Handle_PrsDim_ConcentricRelation_3 extends Handle_PrsDim_ConcentricRelation {
    constructor(theHandle: Handle_PrsDim_ConcentricRelation);
  }

  export declare class Handle_PrsDim_ConcentricRelation_4 extends Handle_PrsDim_ConcentricRelation {
    constructor(theHandle: Handle_PrsDim_ConcentricRelation);
  }

export declare type PrsDim_TypeOfAngle = {
  PrsDim_TypeOfAngle_Interior: {};
  PrsDim_TypeOfAngle_Exterior: {};
}

export declare class PrsDim_SymmetricRelation extends PrsDim_Relation {
  constructor(aSymmTool: TopoDS_Shape, FirstShape: TopoDS_Shape, SecondShape: TopoDS_Shape, aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsMovable(): Standard_Boolean;
  SetTool(aSymmetricTool: TopoDS_Shape): void;
  GetTool(): TopoDS_Shape;
  delete(): void;
}

export declare class Handle_PrsDim_SymmetricRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_SymmetricRelation): void;
  get(): PrsDim_SymmetricRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_SymmetricRelation_1 extends Handle_PrsDim_SymmetricRelation {
    constructor();
  }

  export declare class Handle_PrsDim_SymmetricRelation_2 extends Handle_PrsDim_SymmetricRelation {
    constructor(thePtr: PrsDim_SymmetricRelation);
  }

  export declare class Handle_PrsDim_SymmetricRelation_3 extends Handle_PrsDim_SymmetricRelation {
    constructor(theHandle: Handle_PrsDim_SymmetricRelation);
  }

  export declare class Handle_PrsDim_SymmetricRelation_4 extends Handle_PrsDim_SymmetricRelation {
    constructor(theHandle: Handle_PrsDim_SymmetricRelation);
  }

export declare class Handle_PrsDim_FixRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_FixRelation): void;
  get(): PrsDim_FixRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_FixRelation_1 extends Handle_PrsDim_FixRelation {
    constructor();
  }

  export declare class Handle_PrsDim_FixRelation_2 extends Handle_PrsDim_FixRelation {
    constructor(thePtr: PrsDim_FixRelation);
  }

  export declare class Handle_PrsDim_FixRelation_3 extends Handle_PrsDim_FixRelation {
    constructor(theHandle: Handle_PrsDim_FixRelation);
  }

  export declare class Handle_PrsDim_FixRelation_4 extends Handle_PrsDim_FixRelation {
    constructor(theHandle: Handle_PrsDim_FixRelation);
  }

export declare class PrsDim_FixRelation extends PrsDim_Relation {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Wire(): TopoDS_Wire;
  SetWire(aWire: TopoDS_Wire): void;
  IsMovable(): Standard_Boolean;
  delete(): void;
}

  export declare class PrsDim_FixRelation_1 extends PrsDim_FixRelation {
    constructor(aShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, aWire: TopoDS_Wire);
  }

  export declare class PrsDim_FixRelation_2 extends PrsDim_FixRelation {
    constructor(aShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, aWire: TopoDS_Wire, aPosition: gp_Pnt, anArrowSize: Quantity_AbsorbedDose);
  }

  export declare class PrsDim_FixRelation_3 extends PrsDim_FixRelation {
    constructor(aShape: TopoDS_Shape, aPlane: Handle_Geom_Plane);
  }

  export declare class PrsDim_FixRelation_4 extends PrsDim_FixRelation {
    constructor(aShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, aPosition: gp_Pnt, anArrowSize: Quantity_AbsorbedDose);
  }

export declare class Handle_PrsDim_Chamf3dDimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_Chamf3dDimension): void;
  get(): PrsDim_Chamf3dDimension;
  delete(): void;
}

  export declare class Handle_PrsDim_Chamf3dDimension_1 extends Handle_PrsDim_Chamf3dDimension {
    constructor();
  }

  export declare class Handle_PrsDim_Chamf3dDimension_2 extends Handle_PrsDim_Chamf3dDimension {
    constructor(thePtr: PrsDim_Chamf3dDimension);
  }

  export declare class Handle_PrsDim_Chamf3dDimension_3 extends Handle_PrsDim_Chamf3dDimension {
    constructor(theHandle: Handle_PrsDim_Chamf3dDimension);
  }

  export declare class Handle_PrsDim_Chamf3dDimension_4 extends Handle_PrsDim_Chamf3dDimension {
    constructor(theHandle: Handle_PrsDim_Chamf3dDimension);
  }

export declare class PrsDim_Chamf3dDimension extends PrsDim_Relation {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  KindOfDimension(): PrsDim_KindOfDimension;
  IsMovable(): Standard_Boolean;
  delete(): void;
}

  export declare class PrsDim_Chamf3dDimension_1 extends PrsDim_Chamf3dDimension {
    constructor(aFShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString);
  }

  export declare class PrsDim_Chamf3dDimension_2 extends PrsDim_Chamf3dDimension {
    constructor(aFShape: TopoDS_Shape, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aPosition: gp_Pnt, aSymbolPrs: DsgPrs_ArrowSide, anArrowSize: Quantity_AbsorbedDose);
  }

export declare type PrsDim_KindOfDimension = {
  PrsDim_KOD_NONE: {};
  PrsDim_KOD_LENGTH: {};
  PrsDim_KOD_PLANEANGLE: {};
  PrsDim_KOD_SOLIDANGLE: {};
  PrsDim_KOD_AREA: {};
  PrsDim_KOD_VOLUME: {};
  PrsDim_KOD_MASS: {};
  PrsDim_KOD_TIME: {};
  PrsDim_KOD_RADIUS: {};
  PrsDim_KOD_DIAMETER: {};
  PrsDim_KOD_CHAMF2D: {};
  PrsDim_KOD_CHAMF3D: {};
  PrsDim_KOD_OFFSET: {};
  PrsDim_KOD_ELLIPSERADIUS: {};
}

export declare class Handle_PrsDim_TangentRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_TangentRelation): void;
  get(): PrsDim_TangentRelation;
  delete(): void;
}

  export declare class Handle_PrsDim_TangentRelation_1 extends Handle_PrsDim_TangentRelation {
    constructor();
  }

  export declare class Handle_PrsDim_TangentRelation_2 extends Handle_PrsDim_TangentRelation {
    constructor(thePtr: PrsDim_TangentRelation);
  }

  export declare class Handle_PrsDim_TangentRelation_3 extends Handle_PrsDim_TangentRelation {
    constructor(theHandle: Handle_PrsDim_TangentRelation);
  }

  export declare class Handle_PrsDim_TangentRelation_4 extends Handle_PrsDim_TangentRelation {
    constructor(theHandle: Handle_PrsDim_TangentRelation);
  }

export declare class PrsDim_TangentRelation extends PrsDim_Relation {
  constructor(aFShape: TopoDS_Shape, aSShape: TopoDS_Shape, aPlane: Handle_Geom_Plane, anExternRef: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ExternRef(): Graphic3d_ZLayerId;
  SetExternRef(aRef: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_PrsDim_Relation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsDim_Relation): void;
  get(): PrsDim_Relation;
  delete(): void;
}

  export declare class Handle_PrsDim_Relation_1 extends Handle_PrsDim_Relation {
    constructor();
  }

  export declare class Handle_PrsDim_Relation_2 extends Handle_PrsDim_Relation {
    constructor(thePtr: PrsDim_Relation);
  }

  export declare class Handle_PrsDim_Relation_3 extends Handle_PrsDim_Relation {
    constructor(theHandle: Handle_PrsDim_Relation);
  }

  export declare class Handle_PrsDim_Relation_4 extends Handle_PrsDim_Relation {
    constructor(theHandle: Handle_PrsDim_Relation);
  }

export declare class PrsDim_Relation extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  Type(): AIS_KindOfInteractive;
  KindOfDimension(): PrsDim_KindOfDimension;
  IsMovable(): Standard_Boolean;
  FirstShape(): TopoDS_Shape;
  SetFirstShape(aFShape: TopoDS_Shape): void;
  SecondShape(): TopoDS_Shape;
  SetSecondShape(aSShape: TopoDS_Shape): void;
  SetBndBox(theXmin: Quantity_AbsorbedDose, theYmin: Quantity_AbsorbedDose, theZmin: Quantity_AbsorbedDose, theXmax: Quantity_AbsorbedDose, theYmax: Quantity_AbsorbedDose, theZmax: Quantity_AbsorbedDose): void;
  UnsetBndBox(): void;
  Plane(): Handle_Geom_Plane;
  SetPlane(thePlane: Handle_Geom_Plane): void;
  Value(): Quantity_AbsorbedDose;
  SetValue(theVal: Quantity_AbsorbedDose): void;
  Position(): gp_Pnt;
  SetPosition(thePosition: gp_Pnt): void;
  Text(): TCollection_ExtendedString;
  SetText(theText: TCollection_ExtendedString): void;
  ArrowSize(): Quantity_AbsorbedDose;
  SetArrowSize(theArrowSize: Quantity_AbsorbedDose): void;
  SymbolPrs(): DsgPrs_ArrowSide;
  SetSymbolPrs(theSymbolPrs: DsgPrs_ArrowSide): void;
  SetExtShape(theIndex: Graphic3d_ZLayerId): void;
  ExtShape(): Graphic3d_ZLayerId;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  SetAutomaticPosition(theStatus: Standard_Boolean): void;
  AutomaticPosition(): Standard_Boolean;
  delete(): void;
}

export declare type PrsDim_TypeOfDist = {
  PrsDim_TypeOfDist_Unknown: {};
  PrsDim_TypeOfDist_Horizontal: {};
  PrsDim_TypeOfDist_Vertical: {};
}

export declare class ElCLib {
  constructor();
  static InPeriod(U: Quantity_AbsorbedDose, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static AdjustPeriodic(UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, Precision: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  static Value_1(U: Quantity_AbsorbedDose, L: gp_Lin): gp_Pnt;
  static Value_2(U: Quantity_AbsorbedDose, C: gp_Circ): gp_Pnt;
  static Value_3(U: Quantity_AbsorbedDose, E: gp_Elips): gp_Pnt;
  static Value_4(U: Quantity_AbsorbedDose, H: gp_Hypr): gp_Pnt;
  static Value_5(U: Quantity_AbsorbedDose, Prb: gp_Parab): gp_Pnt;
  static D1_1(U: Quantity_AbsorbedDose, L: gp_Lin, P: gp_Pnt, V1: gp_Vec): void;
  static D1_2(U: Quantity_AbsorbedDose, C: gp_Circ, P: gp_Pnt, V1: gp_Vec): void;
  static D1_3(U: Quantity_AbsorbedDose, E: gp_Elips, P: gp_Pnt, V1: gp_Vec): void;
  static D1_4(U: Quantity_AbsorbedDose, H: gp_Hypr, P: gp_Pnt, V1: gp_Vec): void;
  static D1_5(U: Quantity_AbsorbedDose, Prb: gp_Parab, P: gp_Pnt, V1: gp_Vec): void;
  static D2_1(U: Quantity_AbsorbedDose, C: gp_Circ, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D2_2(U: Quantity_AbsorbedDose, E: gp_Elips, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D2_3(U: Quantity_AbsorbedDose, H: gp_Hypr, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D2_4(U: Quantity_AbsorbedDose, Prb: gp_Parab, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3_1(U: Quantity_AbsorbedDose, C: gp_Circ, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static D3_2(U: Quantity_AbsorbedDose, E: gp_Elips, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static D3_3(U: Quantity_AbsorbedDose, H: gp_Hypr, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static DN_1(U: Quantity_AbsorbedDose, L: gp_Lin, N: Graphic3d_ZLayerId): gp_Vec;
  static DN_2(U: Quantity_AbsorbedDose, C: gp_Circ, N: Graphic3d_ZLayerId): gp_Vec;
  static DN_3(U: Quantity_AbsorbedDose, E: gp_Elips, N: Graphic3d_ZLayerId): gp_Vec;
  static DN_4(U: Quantity_AbsorbedDose, H: gp_Hypr, N: Graphic3d_ZLayerId): gp_Vec;
  static DN_5(U: Quantity_AbsorbedDose, Prb: gp_Parab, N: Graphic3d_ZLayerId): gp_Vec;
  static Value_6(U: Quantity_AbsorbedDose, L: gp_Lin2d): gp_Pnt2d;
  static Value_7(U: Quantity_AbsorbedDose, C: gp_Circ2d): gp_Pnt2d;
  static Value_8(U: Quantity_AbsorbedDose, E: gp_Elips2d): gp_Pnt2d;
  static Value_9(U: Quantity_AbsorbedDose, H: gp_Hypr2d): gp_Pnt2d;
  static Value_10(U: Quantity_AbsorbedDose, Prb: gp_Parab2d): gp_Pnt2d;
  static D1_6(U: Quantity_AbsorbedDose, L: gp_Lin2d, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D1_7(U: Quantity_AbsorbedDose, C: gp_Circ2d, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D1_8(U: Quantity_AbsorbedDose, E: gp_Elips2d, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D1_9(U: Quantity_AbsorbedDose, H: gp_Hypr2d, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D1_10(U: Quantity_AbsorbedDose, Prb: gp_Parab2d, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D2_5(U: Quantity_AbsorbedDose, C: gp_Circ2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D2_6(U: Quantity_AbsorbedDose, E: gp_Elips2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D2_7(U: Quantity_AbsorbedDose, H: gp_Hypr2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D2_8(U: Quantity_AbsorbedDose, Prb: gp_Parab2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3_4(U: Quantity_AbsorbedDose, C: gp_Circ2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static D3_5(U: Quantity_AbsorbedDose, E: gp_Elips2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static D3_6(U: Quantity_AbsorbedDose, H: gp_Hypr2d, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static DN_6(U: Quantity_AbsorbedDose, L: gp_Lin2d, N: Graphic3d_ZLayerId): gp_Vec2d;
  static DN_7(U: Quantity_AbsorbedDose, C: gp_Circ2d, N: Graphic3d_ZLayerId): gp_Vec2d;
  static DN_8(U: Quantity_AbsorbedDose, E: gp_Elips2d, N: Graphic3d_ZLayerId): gp_Vec2d;
  static DN_9(U: Quantity_AbsorbedDose, H: gp_Hypr2d, N: Graphic3d_ZLayerId): gp_Vec2d;
  static DN_10(U: Quantity_AbsorbedDose, Prb: gp_Parab2d, N: Graphic3d_ZLayerId): gp_Vec2d;
  static LineValue_1(U: Quantity_AbsorbedDose, Pos: gp_Ax1): gp_Pnt;
  static CircleValue_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Radius: Quantity_AbsorbedDose): gp_Pnt;
  static EllipseValue_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose): gp_Pnt;
  static HyperbolaValue_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose): gp_Pnt;
  static ParabolaValue_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Focal: Quantity_AbsorbedDose): gp_Pnt;
  static LineD1_1(U: Quantity_AbsorbedDose, Pos: gp_Ax1, P: gp_Pnt, V1: gp_Vec): void;
  static CircleD1_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Radius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static EllipseD1_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static HyperbolaD1_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static ParabolaD1_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Focal: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static CircleD2_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Radius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static EllipseD2_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static HyperbolaD2_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static ParabolaD2_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Focal: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static CircleD3_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Radius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static EllipseD3_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static HyperbolaD3_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static LineDN_1(U: Quantity_AbsorbedDose, Pos: gp_Ax1, N: Graphic3d_ZLayerId): gp_Vec;
  static CircleDN_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Radius: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static EllipseDN_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static HyperbolaDN_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static ParabolaDN_1(U: Quantity_AbsorbedDose, Pos: gp_Ax2, Focal: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static LineValue_2(U: Quantity_AbsorbedDose, Pos: gp_Ax2d): gp_Pnt2d;
  static CircleValue_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Radius: Quantity_AbsorbedDose): gp_Pnt2d;
  static EllipseValue_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose): gp_Pnt2d;
  static HyperbolaValue_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose): gp_Pnt2d;
  static ParabolaValue_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Focal: Quantity_AbsorbedDose): gp_Pnt2d;
  static LineD1_2(U: Quantity_AbsorbedDose, Pos: gp_Ax2d, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static CircleD1_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Radius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static EllipseD1_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static HyperbolaD1_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static ParabolaD1_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Focal: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static CircleD2_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Radius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static EllipseD2_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static HyperbolaD2_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static ParabolaD2_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Focal: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static CircleD3_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Radius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static EllipseD3_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static HyperbolaD3_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static LineDN_2(U: Quantity_AbsorbedDose, Pos: gp_Ax2d, N: Graphic3d_ZLayerId): gp_Vec2d;
  static CircleDN_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Radius: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static EllipseDN_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static HyperbolaDN_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static ParabolaDN_2(U: Quantity_AbsorbedDose, Pos: gp_Ax22d, Focal: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static Parameter_1(L: gp_Lin, P: gp_Pnt): Quantity_AbsorbedDose;
  static Parameter_2(L: gp_Lin2d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static Parameter_3(C: gp_Circ, P: gp_Pnt): Quantity_AbsorbedDose;
  static Parameter_4(C: gp_Circ2d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static Parameter_5(E: gp_Elips, P: gp_Pnt): Quantity_AbsorbedDose;
  static Parameter_6(E: gp_Elips2d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static Parameter_7(H: gp_Hypr, P: gp_Pnt): Quantity_AbsorbedDose;
  static Parameter_8(H: gp_Hypr2d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static Parameter_9(Prb: gp_Parab, P: gp_Pnt): Quantity_AbsorbedDose;
  static Parameter_10(Prb: gp_Parab2d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static LineParameter_1(Pos: gp_Ax1, P: gp_Pnt): Quantity_AbsorbedDose;
  static LineParameter_2(Pos: gp_Ax2d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static CircleParameter_1(Pos: gp_Ax2, P: gp_Pnt): Quantity_AbsorbedDose;
  static CircleParameter_2(Pos: gp_Ax22d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static EllipseParameter_1(Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt): Quantity_AbsorbedDose;
  static EllipseParameter_2(Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static HyperbolaParameter_1(Pos: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt): Quantity_AbsorbedDose;
  static HyperbolaParameter_2(Pos: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static ParabolaParameter_1(Pos: gp_Ax2, P: gp_Pnt): Quantity_AbsorbedDose;
  static ParabolaParameter_2(Pos: gp_Ax22d, P: gp_Pnt2d): Quantity_AbsorbedDose;
  static To3d_1(Pos: gp_Ax2, P: gp_Pnt2d): gp_Pnt;
  static To3d_2(Pos: gp_Ax2, V: gp_Vec2d): gp_Vec;
  static To3d_3(Pos: gp_Ax2, V: gp_Dir2d): gp_Dir;
  static To3d_4(Pos: gp_Ax2, A: gp_Ax2d): gp_Ax1;
  static To3d_5(Pos: gp_Ax2, A: gp_Ax22d): gp_Ax2;
  static To3d_6(Pos: gp_Ax2, L: gp_Lin2d): gp_Lin;
  static To3d_7(Pos: gp_Ax2, C: gp_Circ2d): gp_Circ;
  static To3d_8(Pos: gp_Ax2, E: gp_Elips2d): gp_Elips;
  static To3d_9(Pos: gp_Ax2, H: gp_Hypr2d): gp_Hypr;
  static To3d_10(Pos: gp_Ax2, Prb: gp_Parab2d): gp_Parab;
  delete(): void;
}

export declare class BRepFeat_RibSlot extends BRepBuilderAPI_MakeShape {
  IsDeleted(F: TopoDS_Shape): Standard_Boolean;
  Modified(F: TopoDS_Shape): TopTools_ListOfShape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  FirstShape(): TopTools_ListOfShape;
  LastShape(): TopTools_ListOfShape;
  FacesForDraft(): TopTools_ListOfShape;
  NewEdges(): TopTools_ListOfShape;
  TgtEdges(): TopTools_ListOfShape;
  static IntPar(C: Handle_Geom_Curve, P: gp_Pnt): Quantity_AbsorbedDose;
  static ChoiceOfFaces(faces: TopTools_ListOfShape, cc: Handle_Geom_Curve, par: Quantity_AbsorbedDose, bnd: Quantity_AbsorbedDose, Pln: Handle_Geom_Plane): TopoDS_Face;
  CurrentStatusError(): BRepFeat_StatusError;
  delete(): void;
}

export declare class BRepFeat_SplitShape extends BRepBuilderAPI_MakeShape {
  Add_1(theEdges: TopTools_SequenceOfShape): Standard_Boolean;
  Init(S: TopoDS_Shape): void;
  SetCheckInterior(ToCheckInterior: Standard_Boolean): void;
  Add_2(W: TopoDS_Wire, F: TopoDS_Face): void;
  Add_3(E: TopoDS_Edge, F: TopoDS_Face): void;
  Add_4(Comp: TopoDS_Compound, F: TopoDS_Face): void;
  Add_5(E: TopoDS_Edge, EOn: TopoDS_Edge): void;
  DirectLeft(): TopTools_ListOfShape;
  Left(): TopTools_ListOfShape;
  Right(): TopTools_ListOfShape;
  Build(): void;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  Modified(F: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepFeat_SplitShape_1 extends BRepFeat_SplitShape {
    constructor();
  }

  export declare class BRepFeat_SplitShape_2 extends BRepFeat_SplitShape {
    constructor(S: TopoDS_Shape);
  }

export declare class BRepFeat_Gluer extends BRepBuilderAPI_MakeShape {
  Init(Snew: TopoDS_Shape, Sbase: TopoDS_Shape): void;
  Bind_1(Fnew: TopoDS_Face, Fbase: TopoDS_Face): void;
  Bind_2(Enew: TopoDS_Edge, Ebase: TopoDS_Edge): void;
  OpeType(): LocOpe_Operation;
  BasisShape(): TopoDS_Shape;
  GluedShape(): TopoDS_Shape;
  Build(): void;
  IsDeleted(F: TopoDS_Shape): Standard_Boolean;
  Modified(F: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepFeat_Gluer_1 extends BRepFeat_Gluer {
    constructor();
  }

  export declare class BRepFeat_Gluer_2 extends BRepFeat_Gluer {
    constructor(Snew: TopoDS_Shape, Sbase: TopoDS_Shape);
  }

export declare class BRepFeat_Builder extends BOPAlgo_BOP {
  constructor()
  Clear(): void;
  Init_1(theShape: TopoDS_Shape): void;
  Init_2(theShape: TopoDS_Shape, theTool: TopoDS_Shape): void;
  SetOperation_1(theFuse: Graphic3d_ZLayerId): void;
  SetOperation_2(theFuse: Graphic3d_ZLayerId, theFlag: Standard_Boolean): void;
  PartsOfTool(theLT: TopTools_ListOfShape): void;
  KeepParts(theIm: TopTools_ListOfShape): void;
  KeepPart(theS: TopoDS_Shape): void;
  PerformResult(): void;
  RebuildFaces(): void;
  RebuildEdge(theE: TopoDS_Shape, theF: TopoDS_Face, theME: TopTools_MapOfShape, aLEIm: TopTools_ListOfShape): void;
  CheckSolidImages(): void;
  FillRemoved_1(): void;
  FillRemoved_2(theS: TopoDS_Shape, theM: TopTools_MapOfShape): void;
  delete(): void;
}

export declare class BRepFeat_MakePrism extends BRepFeat_Form {
  Init(Sbase: TopoDS_Shape, Pbase: TopoDS_Shape, Skface: TopoDS_Face, Direction: gp_Dir, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean): void;
  Add(E: TopoDS_Edge, OnFace: TopoDS_Face): void;
  Perform_1(Length: Quantity_AbsorbedDose): void;
  Perform_2(Until: TopoDS_Shape): void;
  Perform_3(From: TopoDS_Shape, Until: TopoDS_Shape): void;
  PerformUntilEnd(): void;
  PerformFromEnd(FUntil: TopoDS_Shape): void;
  PerformThruAll(): void;
  PerformUntilHeight(Until: TopoDS_Shape, Length: Quantity_AbsorbedDose): void;
  Curves(S: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  delete(): void;
}

  export declare class BRepFeat_MakePrism_1 extends BRepFeat_MakePrism {
    constructor();
  }

  export declare class BRepFeat_MakePrism_2 extends BRepFeat_MakePrism {
    constructor(Sbase: TopoDS_Shape, Pbase: TopoDS_Shape, Skface: TopoDS_Face, Direction: gp_Dir, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean);
  }

export declare type BRepFeat_PerfSelection = {
  BRepFeat_NoSelection: {};
  BRepFeat_SelectionFU: {};
  BRepFeat_SelectionU: {};
  BRepFeat_SelectionSh: {};
  BRepFeat_SelectionShU: {};
}

export declare type BRepFeat_StatusError = {
  BRepFeat_OK: {};
  BRepFeat_BadDirect: {};
  BRepFeat_BadIntersect: {};
  BRepFeat_EmptyBaryCurve: {};
  BRepFeat_EmptyCutResult: {};
  BRepFeat_FalseSide: {};
  BRepFeat_IncDirection: {};
  BRepFeat_IncSlidFace: {};
  BRepFeat_IncParameter: {};
  BRepFeat_IncTypes: {};
  BRepFeat_IntervalOverlap: {};
  BRepFeat_InvFirstShape: {};
  BRepFeat_InvOption: {};
  BRepFeat_InvShape: {};
  BRepFeat_LocOpeNotDone: {};
  BRepFeat_LocOpeInvNotDone: {};
  BRepFeat_NoExtFace: {};
  BRepFeat_NoFaceProf: {};
  BRepFeat_NoGluer: {};
  BRepFeat_NoIntersectF: {};
  BRepFeat_NoIntersectU: {};
  BRepFeat_NoParts: {};
  BRepFeat_NoProjPt: {};
  BRepFeat_NotInitialized: {};
  BRepFeat_NotYetImplemented: {};
  BRepFeat_NullRealTool: {};
  BRepFeat_NullToolF: {};
  BRepFeat_NullToolU: {};
}

export declare class BRepFeat_MakePipe extends BRepFeat_Form {
  Init(Sbase: TopoDS_Shape, Pbase: TopoDS_Shape, Skface: TopoDS_Face, Spine: TopoDS_Wire, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean): void;
  Add(E: TopoDS_Edge, OnFace: TopoDS_Face): void;
  Perform_1(): void;
  Perform_2(Until: TopoDS_Shape): void;
  Perform_3(From: TopoDS_Shape, Until: TopoDS_Shape): void;
  Curves(S: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  delete(): void;
}

  export declare class BRepFeat_MakePipe_1 extends BRepFeat_MakePipe {
    constructor();
  }

  export declare class BRepFeat_MakePipe_2 extends BRepFeat_MakePipe {
    constructor(Sbase: TopoDS_Shape, Pbase: TopoDS_Shape, Skface: TopoDS_Face, Spine: TopoDS_Wire, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean);
  }

export declare class BRepFeat_MakeDPrism extends BRepFeat_Form {
  Init(Sbase: TopoDS_Shape, Pbase: TopoDS_Face, Skface: TopoDS_Face, Angle: Quantity_AbsorbedDose, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean): void;
  Add(E: TopoDS_Edge, OnFace: TopoDS_Face): void;
  Perform_1(Height: Quantity_AbsorbedDose): void;
  Perform_2(Until: TopoDS_Shape): void;
  Perform_3(From: TopoDS_Shape, Until: TopoDS_Shape): void;
  PerformUntilEnd(): void;
  PerformFromEnd(FUntil: TopoDS_Shape): void;
  PerformThruAll(): void;
  PerformUntilHeight(Until: TopoDS_Shape, Height: Quantity_AbsorbedDose): void;
  Curves(S: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  BossEdges(sig: Graphic3d_ZLayerId): void;
  TopEdges(): TopTools_ListOfShape;
  LatEdges(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepFeat_MakeDPrism_1 extends BRepFeat_MakeDPrism {
    constructor(Sbase: TopoDS_Shape, Pbase: TopoDS_Face, Skface: TopoDS_Face, Angle: Quantity_AbsorbedDose, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean);
  }

  export declare class BRepFeat_MakeDPrism_2 extends BRepFeat_MakeDPrism {
    constructor();
  }

export declare class BRepFeat_MakeRevol extends BRepFeat_Form {
  Init(Sbase: TopoDS_Shape, Pbase: TopoDS_Shape, Skface: TopoDS_Face, Axis: gp_Ax1, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean): void;
  Add(E: TopoDS_Edge, OnFace: TopoDS_Face): void;
  Perform_1(Angle: Quantity_AbsorbedDose): void;
  Perform_2(Until: TopoDS_Shape): void;
  Perform_3(From: TopoDS_Shape, Until: TopoDS_Shape): void;
  PerformThruAll(): void;
  PerformUntilAngle(Until: TopoDS_Shape, Angle: Quantity_AbsorbedDose): void;
  Curves(S: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  delete(): void;
}

  export declare class BRepFeat_MakeRevol_1 extends BRepFeat_MakeRevol {
    constructor();
  }

  export declare class BRepFeat_MakeRevol_2 extends BRepFeat_MakeRevol {
    constructor(Sbase: TopoDS_Shape, Pbase: TopoDS_Shape, Skface: TopoDS_Face, Axis: gp_Ax1, Fuse: Graphic3d_ZLayerId, Modify: Standard_Boolean);
  }

export declare class BRepFeat_Form extends BRepBuilderAPI_MakeShape {
  Modified(F: TopoDS_Shape): TopTools_ListOfShape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  FirstShape(): TopTools_ListOfShape;
  LastShape(): TopTools_ListOfShape;
  NewEdges(): TopTools_ListOfShape;
  TgtEdges(): TopTools_ListOfShape;
  BasisShapeValid(): void;
  GeneratedShapeValid(): void;
  ShapeFromValid(): void;
  ShapeUntilValid(): void;
  GluedFacesValid(): void;
  SketchFaceValid(): void;
  PerfSelectionValid(): void;
  Curves(S: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  CurrentStatusError(): BRepFeat_StatusError;
  delete(): void;
}

export declare type BRepFeat_Status = {
  BRepFeat_NoError: {};
  BRepFeat_InvalidPlacement: {};
  BRepFeat_HoleTooLong: {};
}

export declare class BRepFeat_MakeCylindricalHole extends BRepFeat_Builder {
  constructor()
  Init_1(Axis: gp_Ax1): void;
  Init_2(S: TopoDS_Shape, Axis: gp_Ax1): void;
  Perform_1(Radius: Quantity_AbsorbedDose): void;
  Perform_2(Radius: Quantity_AbsorbedDose, PFrom: Quantity_AbsorbedDose, PTo: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  PerformThruNext(Radius: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  PerformUntilEnd(Radius: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  PerformBlind(Radius: Quantity_AbsorbedDose, Length: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Status(): BRepFeat_Status;
  Build(): void;
  delete(): void;
}

export declare class BRepFeat_MakeRevolutionForm extends BRepFeat_RibSlot {
  Init(Sbase: TopoDS_Shape, W: TopoDS_Wire, Plane: Handle_Geom_Plane, Axis: gp_Ax1, Height1: Quantity_AbsorbedDose, Height2: Quantity_AbsorbedDose, Fuse: Graphic3d_ZLayerId, Sliding: Standard_Boolean): void;
  Add(E: TopoDS_Edge, OnFace: TopoDS_Face): void;
  Perform(): void;
  Propagate(L: TopTools_ListOfShape, F: TopoDS_Face, FPoint: gp_Pnt, LPoint: gp_Pnt, falseside: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

  export declare class BRepFeat_MakeRevolutionForm_1 extends BRepFeat_MakeRevolutionForm {
    constructor();
  }

  export declare class BRepFeat_MakeRevolutionForm_2 extends BRepFeat_MakeRevolutionForm {
    constructor(Sbase: TopoDS_Shape, W: TopoDS_Wire, Plane: Handle_Geom_Plane, Axis: gp_Ax1, Height1: Quantity_AbsorbedDose, Height2: Quantity_AbsorbedDose, Fuse: Graphic3d_ZLayerId, Sliding: Standard_Boolean);
  }

export declare class GeomToIGES_GeomPoint extends GeomToIGES_GeomEntity {
  TransferPoint_1(start: Handle_Geom_Point): Handle_IGESGeom_Point;
  TransferPoint_2(start: Handle_Geom_CartesianPoint): Handle_IGESGeom_Point;
  delete(): void;
}

  export declare class GeomToIGES_GeomPoint_1 extends GeomToIGES_GeomPoint {
    constructor();
  }

  export declare class GeomToIGES_GeomPoint_2 extends GeomToIGES_GeomPoint {
    constructor(GE: GeomToIGES_GeomEntity);
  }

export declare class GeomToIGES_GeomVector extends GeomToIGES_GeomEntity {
  TransferVector_1(start: Handle_Geom_Vector): Handle_IGESGeom_Direction;
  TransferVector_2(start: Handle_Geom_VectorWithMagnitude): Handle_IGESGeom_Direction;
  TransferVector_3(start: Handle_Geom_Direction): Handle_IGESGeom_Direction;
  delete(): void;
}

  export declare class GeomToIGES_GeomVector_1 extends GeomToIGES_GeomVector {
    constructor();
  }

  export declare class GeomToIGES_GeomVector_2 extends GeomToIGES_GeomVector {
    constructor(GE: GeomToIGES_GeomEntity);
  }

export declare class GeomToIGES_GeomCurve extends GeomToIGES_GeomEntity {
  TransferCurve_1(start: Handle_Geom_Curve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_2(start: Handle_Geom_BoundedCurve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_3(start: Handle_Geom_BSplineCurve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_4(start: Handle_Geom_BezierCurve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_5(start: Handle_Geom_TrimmedCurve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_6(start: Handle_Geom_Conic, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_7(start: Handle_Geom_Circle, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_8(start: Handle_Geom_Ellipse, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_9(start: Handle_Geom_Hyperbola, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_10(start: Handle_Geom_Line, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_11(start: Handle_Geom_Parabola, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCurve_12(start: Handle_Geom_OffsetCurve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  delete(): void;
}

  export declare class GeomToIGES_GeomCurve_1 extends GeomToIGES_GeomCurve {
    constructor();
  }

  export declare class GeomToIGES_GeomCurve_2 extends GeomToIGES_GeomCurve {
    constructor(GE: GeomToIGES_GeomEntity);
  }

export declare class GeomToIGES_GeomSurface extends GeomToIGES_GeomEntity {
  TransferSurface_1(start: Handle_Geom_Surface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_2(start: Handle_Geom_BoundedSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_3(start: Handle_Geom_BSplineSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_4(start: Handle_Geom_BezierSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_5(start: Handle_Geom_RectangularTrimmedSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_6(start: Handle_Geom_ElementarySurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_7(start: Handle_Geom_Plane, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_8(start: Handle_Geom_CylindricalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_9(start: Handle_Geom_ConicalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_10(start: Handle_Geom_SphericalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_11(start: Handle_Geom_ToroidalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_12(start: Handle_Geom_SweptSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_13(start: Handle_Geom_SurfaceOfLinearExtrusion, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_14(start: Handle_Geom_SurfaceOfRevolution, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSurface_15(start: Handle_Geom_OffsetSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferPlaneSurface(start: Handle_Geom_Plane, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferCylindricalSurface(start: Handle_Geom_CylindricalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferConicalSurface(start: Handle_Geom_ConicalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferSphericalSurface(start: Handle_Geom_SphericalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferToroidalSurface(start: Handle_Geom_ToroidalSurface, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose, Vdeb: Quantity_AbsorbedDose, Vfin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  Length(): Quantity_AbsorbedDose;
  GetBRepMode(): Standard_Boolean;
  SetBRepMode(flag: Standard_Boolean): void;
  GetAnalyticMode(): Standard_Boolean;
  SetAnalyticMode(flag: Standard_Boolean): void;
  delete(): void;
}

  export declare class GeomToIGES_GeomSurface_1 extends GeomToIGES_GeomSurface {
    constructor();
  }

  export declare class GeomToIGES_GeomSurface_2 extends GeomToIGES_GeomSurface {
    constructor(GE: GeomToIGES_GeomEntity);
  }

export declare class GeomToIGES_GeomEntity {
  SetModel(model: Handle_IGESData_IGESModel): void;
  GetModel(): Handle_IGESData_IGESModel;
  SetUnit(unit: Quantity_AbsorbedDose): void;
  GetUnit(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomToIGES_GeomEntity_1 extends GeomToIGES_GeomEntity {
    constructor();
  }

  export declare class GeomToIGES_GeomEntity_2 extends GeomToIGES_GeomEntity {
    constructor(GE: GeomToIGES_GeomEntity);
  }

export declare class Handle_PrsMgr_Presentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsMgr_Presentation): void;
  get(): PrsMgr_Presentation;
  delete(): void;
}

  export declare class Handle_PrsMgr_Presentation_1 extends Handle_PrsMgr_Presentation {
    constructor();
  }

  export declare class Handle_PrsMgr_Presentation_2 extends Handle_PrsMgr_Presentation {
    constructor(thePtr: PrsMgr_Presentation);
  }

  export declare class Handle_PrsMgr_Presentation_3 extends Handle_PrsMgr_Presentation {
    constructor(theHandle: Handle_PrsMgr_Presentation);
  }

  export declare class Handle_PrsMgr_Presentation_4 extends Handle_PrsMgr_Presentation {
    constructor(theHandle: Handle_PrsMgr_Presentation);
  }

export declare class PrsMgr_Presentation extends Graphic3d_Structure {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Presentation(): Prs3d_Presentation;
  PresentationManager(): Handle_PrsMgr_PresentationManager;
  SetUpdateStatus(theUpdateStatus: Standard_Boolean): void;
  MustBeUpdated(): Standard_Boolean;
  Mode(): Graphic3d_ZLayerId;
  Display(): void;
  Erase(): void;
  Highlight(theStyle: Handle_Prs3d_Drawer): void;
  Unhighlight(): void;
  IsDisplayed(): Standard_Boolean;
  Clear(theWithDestruction: Standard_Boolean): void;
  Compute(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_PrsMgr_PresentableObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsMgr_PresentableObject): void;
  get(): PrsMgr_PresentableObject;
  delete(): void;
}

  export declare class Handle_PrsMgr_PresentableObject_1 extends Handle_PrsMgr_PresentableObject {
    constructor();
  }

  export declare class Handle_PrsMgr_PresentableObject_2 extends Handle_PrsMgr_PresentableObject {
    constructor(thePtr: PrsMgr_PresentableObject);
  }

  export declare class Handle_PrsMgr_PresentableObject_3 extends Handle_PrsMgr_PresentableObject {
    constructor(theHandle: Handle_PrsMgr_PresentableObject);
  }

  export declare class Handle_PrsMgr_PresentableObject_4 extends Handle_PrsMgr_PresentableObject {
    constructor(theHandle: Handle_PrsMgr_PresentableObject);
  }

export declare class PrsMgr_PresentableObject extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Presentations(): PrsMgr_Presentations;
  ZLayer(): Graphic3d_ZLayerId;
  SetZLayer(theLayerId: Graphic3d_ZLayerId): void;
  IsMutable(): Standard_Boolean;
  SetMutable(theIsMutable: Standard_Boolean): void;
  HasDisplayMode(): Standard_Boolean;
  DisplayMode(): Graphic3d_ZLayerId;
  SetDisplayMode(theMode: Graphic3d_ZLayerId): void;
  UnsetDisplayMode(): void;
  HasHilightMode(): Standard_Boolean;
  HilightMode(): Graphic3d_ZLayerId;
  SetHilightMode(theMode: Graphic3d_ZLayerId): void;
  UnsetHilightMode(): void;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  DefaultDisplayMode(): Graphic3d_ZLayerId;
  ToBeUpdated_1(theToIncludeHidden: Standard_Boolean): Standard_Boolean;
  SetToUpdate_1(theMode: Graphic3d_ZLayerId): void;
  SetToUpdate_2(): void;
  IsInfinite(): Standard_Boolean;
  SetInfiniteState(theFlag: Standard_Boolean): void;
  TypeOfPresentation3d(): PrsMgr_TypeOfPresentation3d;
  SetTypeOfPresentation(theType: PrsMgr_TypeOfPresentation3d): void;
  Attributes(): Handle_Prs3d_Drawer;
  SetAttributes(theDrawer: Handle_Prs3d_Drawer): void;
  HilightAttributes(): Handle_Prs3d_Drawer;
  SetHilightAttributes(theDrawer: Handle_Prs3d_Drawer): void;
  DynamicHilightAttributes(): Handle_Prs3d_Drawer;
  SetDynamicHilightAttributes(theDrawer: Handle_Prs3d_Drawer): void;
  UnsetHilightAttributes(): void;
  SynchronizeAspects(): void;
  TransformPersistence(): Handle_Graphic3d_TransformPers;
  SetTransformPersistence_1(theTrsfPers: Handle_Graphic3d_TransformPers): void;
  LocalTransformationGeom(): Handle_TopLoc_Datum3D;
  SetLocalTransformation_1(theTrsf: gp_Trsf): void;
  SetLocalTransformation_2(theTrsf: Handle_TopLoc_Datum3D): void;
  HasTransformation(): Standard_Boolean;
  TransformationGeom(): Handle_TopLoc_Datum3D;
  LocalTransformation(): gp_Trsf;
  Transformation(): gp_Trsf;
  InversedTransformation(): gp_GTrsf;
  CombinedParentTransformation(): Handle_TopLoc_Datum3D;
  ResetTransformation(): void;
  UpdateTransformation(): void;
  ClipPlanes(): Handle_Graphic3d_SequenceOfHClipPlane;
  SetClipPlanes_1(thePlanes: Handle_Graphic3d_SequenceOfHClipPlane): void;
  AddClipPlane(thePlane: Handle_Graphic3d_ClipPlane): void;
  RemoveClipPlane(thePlane: Handle_Graphic3d_ClipPlane): void;
  Parent(): PrsMgr_PresentableObject;
  Children(): PrsMgr_ListOfPresentableObjects;
  AddChild(theObject: Handle_PrsMgr_PresentableObject): void;
  AddChildWithCurrentTransformation(theObject: Handle_PrsMgr_PresentableObject): void;
  RemoveChild(theObject: Handle_PrsMgr_PresentableObject): void;
  RemoveChildWithRestoreTransformation(theObject: Handle_PrsMgr_PresentableObject): void;
  HasOwnPresentations(): Standard_Boolean;
  BoundingBox(theBndBox: Bnd_Box): void;
  SetIsoOnTriangulation(theIsEnabled: Standard_Boolean): void;
  CurrentFacingModel(): Aspect_TypeOfFacingModel;
  SetCurrentFacingModel(theModel: Aspect_TypeOfFacingModel): void;
  HasColor(): Standard_Boolean;
  Color(theColor: Quantity_Color): void;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  HasWidth(): Standard_Boolean;
  Width(): Quantity_AbsorbedDose;
  SetWidth(theWidth: Quantity_AbsorbedDose): void;
  UnsetWidth(): void;
  HasMaterial(): Standard_Boolean;
  Material(): Graphic3d_NameOfMaterial;
  SetMaterial(aName: Graphic3d_MaterialAspect): void;
  UnsetMaterial(): void;
  IsTransparent(): Standard_Boolean;
  Transparency(): Quantity_AbsorbedDose;
  SetTransparency(aValue: Quantity_AbsorbedDose): void;
  UnsetTransparency(): void;
  HasPolygonOffsets(): Standard_Boolean;
  PolygonOffsets(aMode: Graphic3d_ZLayerId, aFactor: Standard_ShortReal, aUnits: Standard_ShortReal): void;
  SetPolygonOffsets(aMode: Graphic3d_ZLayerId, aFactor: Standard_ShortReal, aUnits: Standard_ShortReal): void;
  UnsetAttributes(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  ToBeUpdated_2(ListOfMode: TColStd_ListOfInteger): void;
  SetClipPlanes_2(thePlanes: Graphic3d_SequenceOfHClipPlane): void;
  SetTransformPersistence_2(theMode: Graphic3d_TransModeFlags, thePoint: gp_Pnt): void;
  GetTransformPersistenceMode(): Graphic3d_TransModeFlags;
  GetTransformPersistencePoint(): gp_Pnt;
  ToPropagateVisualState(): Standard_Boolean;
  SetPropagateVisualState(theFlag: Standard_Boolean): void;
  delete(): void;
}

export declare class PrsMgr_PresentationManager extends Standard_Transient {
  constructor(theStructureManager: Handle_Graphic3d_StructureManager)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Display(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): void;
  Erase(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): void;
  Clear(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): void;
  SetVisibility(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId, theValue: Standard_Boolean): void;
  Unhighlight_1(thePrsObject: Handle_PrsMgr_PresentableObject): void;
  Unhighlight_2(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): void;
  SetDisplayPriority(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId, theNewPrior: Graphic3d_ZLayerId): void;
  DisplayPriority(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetZLayer(thePrsObject: Handle_PrsMgr_PresentableObject, theLayerId: Graphic3d_ZLayerId): void;
  GetZLayer(thePrsObject: Handle_PrsMgr_PresentableObject): Graphic3d_ZLayerId;
  IsDisplayed(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  IsHighlighted(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Update(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): void;
  BeginImmediateDraw(): void;
  ClearImmediateDraw(): void;
  AddToImmediateList(thePrs: any): void;
  EndImmediateDraw(theViewer: Handle_V3d_Viewer): void;
  RedrawImmediate(theViewer: Handle_V3d_Viewer): void;
  IsImmediateModeOn(): Standard_Boolean;
  Color(thePrsObject: Handle_PrsMgr_PresentableObject, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId, theSelObj: Handle_PrsMgr_PresentableObject, theImmediateStructLayerId: Graphic3d_ZLayerId): void;
  Connect(thePrsObject: Handle_PrsMgr_PresentableObject, theOtherObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId, theOtherMode: Graphic3d_ZLayerId): void;
  Transform(thePrsObject: Handle_PrsMgr_PresentableObject, theTransformation: Handle_TopLoc_Datum3D, theMode: Graphic3d_ZLayerId): void;
  StructureManager(): Handle_Graphic3d_StructureManager;
  HasPresentation(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Presentation(thePrsObject: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId, theToCreate: Standard_Boolean, theSelObj: Handle_PrsMgr_PresentableObject): Handle_PrsMgr_Presentation;
  UpdateHighlightTrsf(theViewer: Handle_V3d_Viewer, theObj: Handle_PrsMgr_PresentableObject, theMode: Graphic3d_ZLayerId, theSelObj: Handle_PrsMgr_PresentableObject): void;
  delete(): void;
}

export declare class Handle_PrsMgr_PresentationManager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: PrsMgr_PresentationManager): void;
  get(): PrsMgr_PresentationManager;
  delete(): void;
}

  export declare class Handle_PrsMgr_PresentationManager_1 extends Handle_PrsMgr_PresentationManager {
    constructor();
  }

  export declare class Handle_PrsMgr_PresentationManager_2 extends Handle_PrsMgr_PresentationManager {
    constructor(thePtr: PrsMgr_PresentationManager);
  }

  export declare class Handle_PrsMgr_PresentationManager_3 extends Handle_PrsMgr_PresentationManager {
    constructor(theHandle: Handle_PrsMgr_PresentationManager);
  }

  export declare class Handle_PrsMgr_PresentationManager_4 extends Handle_PrsMgr_PresentationManager {
    constructor(theHandle: Handle_PrsMgr_PresentationManager);
  }

export declare type PrsMgr_TypeOfPresentation3d = {
  PrsMgr_TOP_AllView: {};
  PrsMgr_TOP_ProjectorDependant: {};
}

export declare class Handle_VrmlData_Faceted {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Faceted): void;
  get(): VrmlData_Faceted;
  delete(): void;
}

  export declare class Handle_VrmlData_Faceted_1 extends Handle_VrmlData_Faceted {
    constructor();
  }

  export declare class Handle_VrmlData_Faceted_2 extends Handle_VrmlData_Faceted {
    constructor(thePtr: VrmlData_Faceted);
  }

  export declare class Handle_VrmlData_Faceted_3 extends Handle_VrmlData_Faceted {
    constructor(theHandle: Handle_VrmlData_Faceted);
  }

  export declare class Handle_VrmlData_Faceted_4 extends Handle_VrmlData_Faceted {
    constructor(theHandle: Handle_VrmlData_Faceted);
  }

export declare class VrmlData_Faceted extends VrmlData_Geometry {
  IsCCW(): Standard_Boolean;
  IsSolid(): Standard_Boolean;
  IsConvex(): Standard_Boolean;
  CreaseAngle(): Quantity_AbsorbedDose;
  SetCCW(theValue: Standard_Boolean): void;
  SetSolid(theValue: Standard_Boolean): void;
  SetConvex(theValue: Standard_Boolean): void;
  SetCreaseAngle(theValue: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class VrmlData_Normal extends VrmlData_ArrayVec3d {
  Normal(i: Graphic3d_ZLayerId): gp_XYZ;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Normal_1 extends VrmlData_Normal {
    constructor();
  }

  export declare class VrmlData_Normal_2 extends VrmlData_Normal {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, nVec: Standard_Size, arrVec: gp_XYZ);
  }

export declare class Handle_VrmlData_Normal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Normal): void;
  get(): VrmlData_Normal;
  delete(): void;
}

  export declare class Handle_VrmlData_Normal_1 extends Handle_VrmlData_Normal {
    constructor();
  }

  export declare class Handle_VrmlData_Normal_2 extends Handle_VrmlData_Normal {
    constructor(thePtr: VrmlData_Normal);
  }

  export declare class Handle_VrmlData_Normal_3 extends Handle_VrmlData_Normal {
    constructor(theHandle: Handle_VrmlData_Normal);
  }

  export declare class Handle_VrmlData_Normal_4 extends Handle_VrmlData_Normal {
    constructor(theHandle: Handle_VrmlData_Normal);
  }

export declare class Handle_VrmlData_Sphere {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Sphere): void;
  get(): VrmlData_Sphere;
  delete(): void;
}

  export declare class Handle_VrmlData_Sphere_1 extends Handle_VrmlData_Sphere {
    constructor();
  }

  export declare class Handle_VrmlData_Sphere_2 extends Handle_VrmlData_Sphere {
    constructor(thePtr: VrmlData_Sphere);
  }

  export declare class Handle_VrmlData_Sphere_3 extends Handle_VrmlData_Sphere {
    constructor(theHandle: Handle_VrmlData_Sphere);
  }

  export declare class Handle_VrmlData_Sphere_4 extends Handle_VrmlData_Sphere {
    constructor(theHandle: Handle_VrmlData_Sphere);
  }

export declare class VrmlData_Sphere extends VrmlData_Geometry {
  Radius(): Quantity_AbsorbedDose;
  SetRadius(theRadius: Quantity_AbsorbedDose): void;
  TShape(): Handle_TopoDS_TShape;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Sphere_1 extends VrmlData_Sphere {
    constructor();
  }

  export declare class VrmlData_Sphere_2 extends VrmlData_Sphere {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theRadius: Quantity_AbsorbedDose);
  }

export declare class VrmlData_Material extends VrmlData_Node {
  AmbientIntensity(): Quantity_AbsorbedDose;
  Shininess(): Quantity_AbsorbedDose;
  Transparency(): Quantity_AbsorbedDose;
  DiffuseColor(): Quantity_Color;
  EmissiveColor(): Quantity_Color;
  SpecularColor(): Quantity_Color;
  SetAmbientIntensity(theAmbientIntensity: Quantity_AbsorbedDose): void;
  SetShininess(theShininess: Quantity_AbsorbedDose): void;
  SetTransparency(theTransparency: Quantity_AbsorbedDose): void;
  SetDiffuseColor(theColor: Quantity_Color): void;
  SetEmissiveColor(theColor: Quantity_Color): void;
  SetSpecularColor(theColor: Quantity_Color): void;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  IsDefault(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Material_1 extends VrmlData_Material {
    constructor();
  }

  export declare class VrmlData_Material_2 extends VrmlData_Material {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theAmbientIntensity: Quantity_AbsorbedDose, theShininess: Quantity_AbsorbedDose, theTransparency: Quantity_AbsorbedDose);
  }

export declare class Handle_VrmlData_Material {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Material): void;
  get(): VrmlData_Material;
  delete(): void;
}

  export declare class Handle_VrmlData_Material_1 extends Handle_VrmlData_Material {
    constructor();
  }

  export declare class Handle_VrmlData_Material_2 extends Handle_VrmlData_Material {
    constructor(thePtr: VrmlData_Material);
  }

  export declare class Handle_VrmlData_Material_3 extends Handle_VrmlData_Material {
    constructor(theHandle: Handle_VrmlData_Material);
  }

  export declare class Handle_VrmlData_Material_4 extends Handle_VrmlData_Material {
    constructor(theHandle: Handle_VrmlData_Material);
  }

export declare class Handle_VrmlData_Cylinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Cylinder): void;
  get(): VrmlData_Cylinder;
  delete(): void;
}

  export declare class Handle_VrmlData_Cylinder_1 extends Handle_VrmlData_Cylinder {
    constructor();
  }

  export declare class Handle_VrmlData_Cylinder_2 extends Handle_VrmlData_Cylinder {
    constructor(thePtr: VrmlData_Cylinder);
  }

  export declare class Handle_VrmlData_Cylinder_3 extends Handle_VrmlData_Cylinder {
    constructor(theHandle: Handle_VrmlData_Cylinder);
  }

  export declare class Handle_VrmlData_Cylinder_4 extends Handle_VrmlData_Cylinder {
    constructor(theHandle: Handle_VrmlData_Cylinder);
  }

export declare class VrmlData_Cylinder extends VrmlData_Geometry {
  Radius(): Quantity_AbsorbedDose;
  Height(): Quantity_AbsorbedDose;
  HasBottom(): Standard_Boolean;
  HasSide(): Standard_Boolean;
  HasTop(): Standard_Boolean;
  SetRadius(theRadius: Quantity_AbsorbedDose): void;
  SetHeight(theHeight: Quantity_AbsorbedDose): void;
  SetFaces(hasBottom: Standard_Boolean, hasSide: Standard_Boolean, hasTop: Standard_Boolean): void;
  TShape(): Handle_TopoDS_TShape;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Cylinder_1 extends VrmlData_Cylinder {
    constructor();
  }

  export declare class VrmlData_Cylinder_2 extends VrmlData_Cylinder {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theRadius: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose);
  }

export declare class VrmlData_Node extends Standard_Transient {
  Name(): Standard_Character;
  ReadNode(theBuffer: VrmlData_InBuffer, theNode: Handle_VrmlData_Node, Type: Handle_Standard_Type): VrmlData_ErrorStatus;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  IsDefault(): Standard_Boolean;
  WriteClosing(): VrmlData_ErrorStatus;
  Clone(a0: Handle_VrmlData_Node): Handle_VrmlData_Node;
  static ReadBoolean(theBuffer: VrmlData_InBuffer, theResult: Standard_Boolean): VrmlData_ErrorStatus;
  static ReadString(theBuffer: VrmlData_InBuffer, theRes: XCAFDoc_PartId): VrmlData_ErrorStatus;
  static ReadMultiString(theBuffer: VrmlData_InBuffer, theRes: TColStd_ListOfAsciiString): VrmlData_ErrorStatus;
  static ReadInteger(theBuffer: VrmlData_InBuffer, theResult: logical): VrmlData_ErrorStatus;
  static OK_1(theStat: VrmlData_ErrorStatus): Standard_Boolean;
  static OK_2(outStat: VrmlData_ErrorStatus, theStat: VrmlData_ErrorStatus): Standard_Boolean;
  static GlobalIndent(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_VrmlData_Node {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Node): void;
  get(): VrmlData_Node;
  delete(): void;
}

  export declare class Handle_VrmlData_Node_1 extends Handle_VrmlData_Node {
    constructor();
  }

  export declare class Handle_VrmlData_Node_2 extends Handle_VrmlData_Node {
    constructor(thePtr: VrmlData_Node);
  }

  export declare class Handle_VrmlData_Node_3 extends Handle_VrmlData_Node {
    constructor(theHandle: Handle_VrmlData_Node);
  }

  export declare class Handle_VrmlData_Node_4 extends Handle_VrmlData_Node {
    constructor(theHandle: Handle_VrmlData_Node);
  }

export declare class Handle_VrmlData_Appearance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Appearance): void;
  get(): VrmlData_Appearance;
  delete(): void;
}

  export declare class Handle_VrmlData_Appearance_1 extends Handle_VrmlData_Appearance {
    constructor();
  }

  export declare class Handle_VrmlData_Appearance_2 extends Handle_VrmlData_Appearance {
    constructor(thePtr: VrmlData_Appearance);
  }

  export declare class Handle_VrmlData_Appearance_3 extends Handle_VrmlData_Appearance {
    constructor(theHandle: Handle_VrmlData_Appearance);
  }

  export declare class Handle_VrmlData_Appearance_4 extends Handle_VrmlData_Appearance {
    constructor(theHandle: Handle_VrmlData_Appearance);
  }

export declare class VrmlData_Appearance extends VrmlData_Node {
  Material(): Handle_VrmlData_Material;
  Texture(): Handle_VrmlData_Texture;
  TextureTransform(): Handle_VrmlData_TextureTransform;
  SetMaterial(theMat: Handle_VrmlData_Material): void;
  SetTexture(theTexture: Handle_VrmlData_Texture): void;
  SetTextureTransform(theTT: Handle_VrmlData_TextureTransform): void;
  Clone(a0: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  IsDefault(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Appearance_1 extends VrmlData_Appearance {
    constructor();
  }

  export declare class VrmlData_Appearance_2 extends VrmlData_Appearance {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character);
  }

export declare class VrmlData_Color extends VrmlData_ArrayVec3d {
  Color(i: Graphic3d_ZLayerId): Quantity_Color;
  SetColors(nColors: Standard_Size, arrColors: gp_XYZ): void;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Color_1 extends VrmlData_Color {
    constructor();
  }

  export declare class VrmlData_Color_2 extends VrmlData_Color {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, nColors: Standard_Size, arrColors: gp_XYZ);
  }

export declare class Handle_VrmlData_Color {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Color): void;
  get(): VrmlData_Color;
  delete(): void;
}

  export declare class Handle_VrmlData_Color_1 extends Handle_VrmlData_Color {
    constructor();
  }

  export declare class Handle_VrmlData_Color_2 extends Handle_VrmlData_Color {
    constructor(thePtr: VrmlData_Color);
  }

  export declare class Handle_VrmlData_Color_3 extends Handle_VrmlData_Color {
    constructor(theHandle: Handle_VrmlData_Color);
  }

  export declare class Handle_VrmlData_Color_4 extends Handle_VrmlData_Color {
    constructor(theHandle: Handle_VrmlData_Color);
  }

export declare class VrmlData_Group extends VrmlData_Node {
  AddNode(theNode: Handle_VrmlData_Node): Handle_VrmlData_Node;
  RemoveNode(theNode: Handle_VrmlData_Node): Standard_Boolean;
  NodeIterator(): any;
  Box(): Bnd_B3f;
  SetBox(theBox: Bnd_B3f): void;
  SetTransform(theTrsf: gp_Trsf): Standard_Boolean;
  GetTransform(): gp_Trsf;
  IsTransform(): Standard_Boolean;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  FindNode(theName: Standard_Character, theLocation: gp_Trsf): Handle_VrmlData_Node;
  Shape(theShape: TopoDS_Shape, pMapApp: VrmlData_DataMapOfShapeAppearance): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Group_1 extends VrmlData_Group {
    constructor(isTransform: Standard_Boolean);
  }

  export declare class VrmlData_Group_2 extends VrmlData_Group {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, isTransform: Standard_Boolean);
  }

export declare class Handle_VrmlData_Group {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Group): void;
  get(): VrmlData_Group;
  delete(): void;
}

  export declare class Handle_VrmlData_Group_1 extends Handle_VrmlData_Group {
    constructor();
  }

  export declare class Handle_VrmlData_Group_2 extends Handle_VrmlData_Group {
    constructor(thePtr: VrmlData_Group);
  }

  export declare class Handle_VrmlData_Group_3 extends Handle_VrmlData_Group {
    constructor(theHandle: Handle_VrmlData_Group);
  }

  export declare class Handle_VrmlData_Group_4 extends Handle_VrmlData_Group {
    constructor(theHandle: Handle_VrmlData_Group);
  }

export declare class Handle_VrmlData_UnknownNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_UnknownNode): void;
  get(): VrmlData_UnknownNode;
  delete(): void;
}

  export declare class Handle_VrmlData_UnknownNode_1 extends Handle_VrmlData_UnknownNode {
    constructor();
  }

  export declare class Handle_VrmlData_UnknownNode_2 extends Handle_VrmlData_UnknownNode {
    constructor(thePtr: VrmlData_UnknownNode);
  }

  export declare class Handle_VrmlData_UnknownNode_3 extends Handle_VrmlData_UnknownNode {
    constructor(theHandle: Handle_VrmlData_UnknownNode);
  }

  export declare class Handle_VrmlData_UnknownNode_4 extends Handle_VrmlData_UnknownNode {
    constructor(theHandle: Handle_VrmlData_UnknownNode);
  }

export declare class VrmlData_UnknownNode extends VrmlData_Node {
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  GetTitle(): XCAFDoc_PartId;
  IsDefault(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_UnknownNode_1 extends VrmlData_UnknownNode {
    constructor();
  }

  export declare class VrmlData_UnknownNode_2 extends VrmlData_UnknownNode {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theTitle: Standard_Character);
  }

export declare class Handle_VrmlData_IndexedFaceSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_IndexedFaceSet): void;
  get(): VrmlData_IndexedFaceSet;
  delete(): void;
}

  export declare class Handle_VrmlData_IndexedFaceSet_1 extends Handle_VrmlData_IndexedFaceSet {
    constructor();
  }

  export declare class Handle_VrmlData_IndexedFaceSet_2 extends Handle_VrmlData_IndexedFaceSet {
    constructor(thePtr: VrmlData_IndexedFaceSet);
  }

  export declare class Handle_VrmlData_IndexedFaceSet_3 extends Handle_VrmlData_IndexedFaceSet {
    constructor(theHandle: Handle_VrmlData_IndexedFaceSet);
  }

  export declare class Handle_VrmlData_IndexedFaceSet_4 extends Handle_VrmlData_IndexedFaceSet {
    constructor(theHandle: Handle_VrmlData_IndexedFaceSet);
  }

export declare class VrmlData_Geometry extends VrmlData_Node {
  TShape(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_VrmlData_Geometry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Geometry): void;
  get(): VrmlData_Geometry;
  delete(): void;
}

  export declare class Handle_VrmlData_Geometry_1 extends Handle_VrmlData_Geometry {
    constructor();
  }

  export declare class Handle_VrmlData_Geometry_2 extends Handle_VrmlData_Geometry {
    constructor(thePtr: VrmlData_Geometry);
  }

  export declare class Handle_VrmlData_Geometry_3 extends Handle_VrmlData_Geometry {
    constructor(theHandle: Handle_VrmlData_Geometry);
  }

  export declare class Handle_VrmlData_Geometry_4 extends Handle_VrmlData_Geometry {
    constructor(theHandle: Handle_VrmlData_Geometry);
  }

export declare class VrmlData_ArrayVec3d extends VrmlData_Node {
  Length(): Standard_ThreadId;
  Values(): gp_XYZ;
  AllocateValues(theLength: Standard_ThreadId): Standard_Boolean;
  SetValues(nValues: Standard_ThreadId, arrValues: gp_XYZ): void;
  ReadArray(theBuffer: VrmlData_InBuffer, theName: Standard_Character, isScale: Standard_Boolean): VrmlData_ErrorStatus;
  WriteArray(theName: Standard_Character, isScale: Standard_Boolean): VrmlData_ErrorStatus;
  IsDefault(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_VrmlData_ArrayVec3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_ArrayVec3d): void;
  get(): VrmlData_ArrayVec3d;
  delete(): void;
}

  export declare class Handle_VrmlData_ArrayVec3d_1 extends Handle_VrmlData_ArrayVec3d {
    constructor();
  }

  export declare class Handle_VrmlData_ArrayVec3d_2 extends Handle_VrmlData_ArrayVec3d {
    constructor(thePtr: VrmlData_ArrayVec3d);
  }

  export declare class Handle_VrmlData_ArrayVec3d_3 extends Handle_VrmlData_ArrayVec3d {
    constructor(theHandle: Handle_VrmlData_ArrayVec3d);
  }

  export declare class Handle_VrmlData_ArrayVec3d_4 extends Handle_VrmlData_ArrayVec3d {
    constructor(theHandle: Handle_VrmlData_ArrayVec3d);
  }

export declare class Handle_VrmlData_Texture {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Texture): void;
  get(): VrmlData_Texture;
  delete(): void;
}

  export declare class Handle_VrmlData_Texture_1 extends Handle_VrmlData_Texture {
    constructor();
  }

  export declare class Handle_VrmlData_Texture_2 extends Handle_VrmlData_Texture {
    constructor(thePtr: VrmlData_Texture);
  }

  export declare class Handle_VrmlData_Texture_3 extends Handle_VrmlData_Texture {
    constructor(theHandle: Handle_VrmlData_Texture);
  }

  export declare class Handle_VrmlData_Texture_4 extends Handle_VrmlData_Texture {
    constructor(theHandle: Handle_VrmlData_Texture);
  }

export declare class VrmlData_Texture extends VrmlData_Node {
  RepeatS(): Standard_Boolean;
  RepeatT(): Standard_Boolean;
  SetRepeatS(theFlag: Standard_Boolean): void;
  SetRepeatT(theFlag: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class VrmlData_Box extends VrmlData_Geometry {
  Size(): gp_XYZ;
  SetSize(theSize: gp_XYZ): void;
  TShape(): Handle_TopoDS_TShape;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Box_1 extends VrmlData_Box {
    constructor();
  }

  export declare class VrmlData_Box_2 extends VrmlData_Box {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, sizeX: Quantity_AbsorbedDose, sizeY: Quantity_AbsorbedDose, sizeZ: Quantity_AbsorbedDose);
  }

export declare class Handle_VrmlData_Box {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Box): void;
  get(): VrmlData_Box;
  delete(): void;
}

  export declare class Handle_VrmlData_Box_1 extends Handle_VrmlData_Box {
    constructor();
  }

  export declare class Handle_VrmlData_Box_2 extends Handle_VrmlData_Box {
    constructor(thePtr: VrmlData_Box);
  }

  export declare class Handle_VrmlData_Box_3 extends Handle_VrmlData_Box {
    constructor(theHandle: Handle_VrmlData_Box);
  }

  export declare class Handle_VrmlData_Box_4 extends Handle_VrmlData_Box {
    constructor(theHandle: Handle_VrmlData_Box);
  }

export declare class Handle_VrmlData_WorldInfo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_WorldInfo): void;
  get(): VrmlData_WorldInfo;
  delete(): void;
}

  export declare class Handle_VrmlData_WorldInfo_1 extends Handle_VrmlData_WorldInfo {
    constructor();
  }

  export declare class Handle_VrmlData_WorldInfo_2 extends Handle_VrmlData_WorldInfo {
    constructor(thePtr: VrmlData_WorldInfo);
  }

  export declare class Handle_VrmlData_WorldInfo_3 extends Handle_VrmlData_WorldInfo {
    constructor(theHandle: Handle_VrmlData_WorldInfo);
  }

  export declare class Handle_VrmlData_WorldInfo_4 extends Handle_VrmlData_WorldInfo {
    constructor(theHandle: Handle_VrmlData_WorldInfo);
  }

export declare class VrmlData_WorldInfo extends VrmlData_Node {
  SetTitle(theString: Standard_Character): void;
  AddInfo(theString: Standard_Character): void;
  Title(): Standard_Character;
  InfoIterator(): any;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  IsDefault(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_WorldInfo_1 extends VrmlData_WorldInfo {
    constructor();
  }

  export declare class VrmlData_WorldInfo_2 extends VrmlData_WorldInfo {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theTitle: Standard_Character);
  }

export declare class VrmlData_ShapeConvert {
  constructor(theScene: VrmlData_Scene, theScale: Quantity_AbsorbedDose)
  AddShape(theShape: TopoDS_Shape, theName: Standard_Character): void;
  Convert(theExtractFaces: Standard_Boolean, theExtractEdges: Standard_Boolean, theDeflection: Quantity_AbsorbedDose, theDeflAngle: Quantity_AbsorbedDose): void;
  ConvertDocument(theDoc: Handle_TDocStd_Document): void;
  delete(): void;
}

export declare class VrmlData_TextureTransform extends VrmlData_Node {
  Center(): gp_XY;
  Rotation(): Quantity_AbsorbedDose;
  Scale(): gp_XY;
  Translation(): gp_XY;
  SetCenter(V: gp_XY): void;
  SetRotation(V: Quantity_AbsorbedDose): void;
  SetScale(V: gp_XY): void;
  SetTranslation(V: gp_XY): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_VrmlData_TextureTransform {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_TextureTransform): void;
  get(): VrmlData_TextureTransform;
  delete(): void;
}

  export declare class Handle_VrmlData_TextureTransform_1 extends Handle_VrmlData_TextureTransform {
    constructor();
  }

  export declare class Handle_VrmlData_TextureTransform_2 extends Handle_VrmlData_TextureTransform {
    constructor(thePtr: VrmlData_TextureTransform);
  }

  export declare class Handle_VrmlData_TextureTransform_3 extends Handle_VrmlData_TextureTransform {
    constructor(theHandle: Handle_VrmlData_TextureTransform);
  }

  export declare class Handle_VrmlData_TextureTransform_4 extends Handle_VrmlData_TextureTransform {
    constructor(theHandle: Handle_VrmlData_TextureTransform);
  }

export declare class Handle_VrmlData_ShapeNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_ShapeNode): void;
  get(): VrmlData_ShapeNode;
  delete(): void;
}

  export declare class Handle_VrmlData_ShapeNode_1 extends Handle_VrmlData_ShapeNode {
    constructor();
  }

  export declare class Handle_VrmlData_ShapeNode_2 extends Handle_VrmlData_ShapeNode {
    constructor(thePtr: VrmlData_ShapeNode);
  }

  export declare class Handle_VrmlData_ShapeNode_3 extends Handle_VrmlData_ShapeNode {
    constructor(theHandle: Handle_VrmlData_ShapeNode);
  }

  export declare class Handle_VrmlData_ShapeNode_4 extends Handle_VrmlData_ShapeNode {
    constructor(theHandle: Handle_VrmlData_ShapeNode);
  }

export declare class VrmlData_ShapeNode extends VrmlData_Node {
  Appearance(): Handle_VrmlData_Appearance;
  Geometry(): Handle_VrmlData_Geometry;
  SetAppearance(theAppear: Handle_VrmlData_Appearance): void;
  SetGeometry(theGeometry: Handle_VrmlData_Geometry): void;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  IsDefault(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_ShapeNode_1 extends VrmlData_ShapeNode {
    constructor();
  }

  export declare class VrmlData_ShapeNode_2 extends VrmlData_ShapeNode {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character);
  }

export declare class Handle_VrmlData_IndexedLineSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_IndexedLineSet): void;
  get(): VrmlData_IndexedLineSet;
  delete(): void;
}

  export declare class Handle_VrmlData_IndexedLineSet_1 extends Handle_VrmlData_IndexedLineSet {
    constructor();
  }

  export declare class Handle_VrmlData_IndexedLineSet_2 extends Handle_VrmlData_IndexedLineSet {
    constructor(thePtr: VrmlData_IndexedLineSet);
  }

  export declare class Handle_VrmlData_IndexedLineSet_3 extends Handle_VrmlData_IndexedLineSet {
    constructor(theHandle: Handle_VrmlData_IndexedLineSet);
  }

  export declare class Handle_VrmlData_IndexedLineSet_4 extends Handle_VrmlData_IndexedLineSet {
    constructor(theHandle: Handle_VrmlData_IndexedLineSet);
  }

export declare class VrmlData_TextureCoordinate extends VrmlData_Node {
  AllocateValues(theLength: Standard_ThreadId): Standard_Boolean;
  Length(): Standard_Size;
  Points(): gp_XY;
  SetPoints(nPoints: Standard_Size, arrPoints: gp_XY): void;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_TextureCoordinate_1 extends VrmlData_TextureCoordinate {
    constructor();
  }

  export declare class VrmlData_TextureCoordinate_2 extends VrmlData_TextureCoordinate {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, nPoints: Standard_Size, arrPoints: gp_XY);
  }

export declare class Handle_VrmlData_TextureCoordinate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_TextureCoordinate): void;
  get(): VrmlData_TextureCoordinate;
  delete(): void;
}

  export declare class Handle_VrmlData_TextureCoordinate_1 extends Handle_VrmlData_TextureCoordinate {
    constructor();
  }

  export declare class Handle_VrmlData_TextureCoordinate_2 extends Handle_VrmlData_TextureCoordinate {
    constructor(thePtr: VrmlData_TextureCoordinate);
  }

  export declare class Handle_VrmlData_TextureCoordinate_3 extends Handle_VrmlData_TextureCoordinate {
    constructor(theHandle: Handle_VrmlData_TextureCoordinate);
  }

  export declare class Handle_VrmlData_TextureCoordinate_4 extends Handle_VrmlData_TextureCoordinate {
    constructor(theHandle: Handle_VrmlData_TextureCoordinate);
  }

export declare type VrmlData_ErrorStatus = {
  VrmlData_StatusOK: {};
  VrmlData_EmptyData: {};
  VrmlData_UnrecoverableError: {};
  VrmlData_GeneralError: {};
  VrmlData_EndOfFile: {};
  VrmlData_NotVrmlFile: {};
  VrmlData_CannotOpenFile: {};
  VrmlData_VrmlFormatError: {};
  VrmlData_NumericInputError: {};
  VrmlData_IrrelevantNumber: {};
  VrmlData_BooleanInputError: {};
  VrmlData_StringInputError: {};
  VrmlData_NodeNameUnknown: {};
  VrmlData_NonPositiveSize: {};
  VrmlData_ReadUnknownNode: {};
  VrmlData_NonSupportedFeature: {};
  VrmlData_OutputStreamUndefined: {};
  VrmlData_NotImplemented: {};
}

export declare class Handle_VrmlData_Coordinate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Coordinate): void;
  get(): VrmlData_Coordinate;
  delete(): void;
}

  export declare class Handle_VrmlData_Coordinate_1 extends Handle_VrmlData_Coordinate {
    constructor();
  }

  export declare class Handle_VrmlData_Coordinate_2 extends Handle_VrmlData_Coordinate {
    constructor(thePtr: VrmlData_Coordinate);
  }

  export declare class Handle_VrmlData_Coordinate_3 extends Handle_VrmlData_Coordinate {
    constructor(theHandle: Handle_VrmlData_Coordinate);
  }

  export declare class Handle_VrmlData_Coordinate_4 extends Handle_VrmlData_Coordinate {
    constructor(theHandle: Handle_VrmlData_Coordinate);
  }

export declare class VrmlData_Coordinate extends VrmlData_ArrayVec3d {
  Coordinate(i: Graphic3d_ZLayerId): gp_XYZ;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Coordinate_1 extends VrmlData_Coordinate {
    constructor();
  }

  export declare class VrmlData_Coordinate_2 extends VrmlData_Coordinate {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, nPoints: Standard_Size, arrPoints: gp_XYZ);
  }

export declare class Handle_VrmlData_Cone {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_Cone): void;
  get(): VrmlData_Cone;
  delete(): void;
}

  export declare class Handle_VrmlData_Cone_1 extends Handle_VrmlData_Cone {
    constructor();
  }

  export declare class Handle_VrmlData_Cone_2 extends Handle_VrmlData_Cone {
    constructor(thePtr: VrmlData_Cone);
  }

  export declare class Handle_VrmlData_Cone_3 extends Handle_VrmlData_Cone {
    constructor(theHandle: Handle_VrmlData_Cone);
  }

  export declare class Handle_VrmlData_Cone_4 extends Handle_VrmlData_Cone {
    constructor(theHandle: Handle_VrmlData_Cone);
  }

export declare class VrmlData_Cone extends VrmlData_Geometry {
  BottomRadius(): Quantity_AbsorbedDose;
  Height(): Quantity_AbsorbedDose;
  HasBottom(): Standard_Boolean;
  HasSide(): Standard_Boolean;
  SetBottomRadius(theRadius: Quantity_AbsorbedDose): void;
  SetHeight(theHeight: Quantity_AbsorbedDose): void;
  SetFaces(hasBottom: Standard_Boolean, hasSide: Standard_Boolean): void;
  TShape(): Handle_TopoDS_TShape;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_Cone_1 extends VrmlData_Cone {
    constructor();
  }

  export declare class VrmlData_Cone_2 extends VrmlData_Cone {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theBottomRadius: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose);
  }

export declare class Handle_VrmlData_ImageTexture {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlData_ImageTexture): void;
  get(): VrmlData_ImageTexture;
  delete(): void;
}

  export declare class Handle_VrmlData_ImageTexture_1 extends Handle_VrmlData_ImageTexture {
    constructor();
  }

  export declare class Handle_VrmlData_ImageTexture_2 extends Handle_VrmlData_ImageTexture {
    constructor(thePtr: VrmlData_ImageTexture);
  }

  export declare class Handle_VrmlData_ImageTexture_3 extends Handle_VrmlData_ImageTexture {
    constructor(theHandle: Handle_VrmlData_ImageTexture);
  }

  export declare class Handle_VrmlData_ImageTexture_4 extends Handle_VrmlData_ImageTexture {
    constructor(theHandle: Handle_VrmlData_ImageTexture);
  }

export declare class VrmlData_ImageTexture extends VrmlData_Texture {
  URL(): TColStd_ListOfAsciiString;
  Clone(theOther: Handle_VrmlData_Node): Handle_VrmlData_Node;
  Read(theBuffer: VrmlData_InBuffer): VrmlData_ErrorStatus;
  Write(thePrefix: Standard_Character): VrmlData_ErrorStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlData_ImageTexture_1 extends VrmlData_ImageTexture {
    constructor();
  }

  export declare class VrmlData_ImageTexture_2 extends VrmlData_ImageTexture {
    constructor(theScene: VrmlData_Scene, theName: Standard_Character, theURL: Standard_Character, theRepS: Standard_Boolean, theRepT: Standard_Boolean);
  }

export declare class VrmlData_InBuffer {
  constructor(theStream: Standard_IStream)
  delete(): void;
}

export declare class Handle_BinMNaming_NamingDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMNaming_NamingDriver): void;
  get(): BinMNaming_NamingDriver;
  delete(): void;
}

  export declare class Handle_BinMNaming_NamingDriver_1 extends Handle_BinMNaming_NamingDriver {
    constructor();
  }

  export declare class Handle_BinMNaming_NamingDriver_2 extends Handle_BinMNaming_NamingDriver {
    constructor(thePtr: BinMNaming_NamingDriver);
  }

  export declare class Handle_BinMNaming_NamingDriver_3 extends Handle_BinMNaming_NamingDriver {
    constructor(theHandle: Handle_BinMNaming_NamingDriver);
  }

  export declare class Handle_BinMNaming_NamingDriver_4 extends Handle_BinMNaming_NamingDriver {
    constructor(theHandle: Handle_BinMNaming_NamingDriver);
  }

export declare class BinMNaming_NamingDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMNaming {
  constructor();
  static AddDrivers(theDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class Handle_BinMNaming_NamedShapeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMNaming_NamedShapeDriver): void;
  get(): BinMNaming_NamedShapeDriver;
  delete(): void;
}

  export declare class Handle_BinMNaming_NamedShapeDriver_1 extends Handle_BinMNaming_NamedShapeDriver {
    constructor();
  }

  export declare class Handle_BinMNaming_NamedShapeDriver_2 extends Handle_BinMNaming_NamedShapeDriver {
    constructor(thePtr: BinMNaming_NamedShapeDriver);
  }

  export declare class Handle_BinMNaming_NamedShapeDriver_3 extends Handle_BinMNaming_NamedShapeDriver {
    constructor(theHandle: Handle_BinMNaming_NamedShapeDriver);
  }

  export declare class Handle_BinMNaming_NamedShapeDriver_4 extends Handle_BinMNaming_NamedShapeDriver {
    constructor(theHandle: Handle_BinMNaming_NamedShapeDriver);
  }

export declare class BinMNaming_NamedShapeDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  ReadShapeSection(theIS: Standard_IStream, therange: Message_ProgressRange): void;
  WriteShapeSection(theOS: Standard_OStream, therange: Message_ProgressRange): void;
  Clear(): void;
  IsWithTriangles(): Standard_Boolean;
  SetWithTriangles(isWithTriangles: Standard_Boolean): void;
  SetFormatNb(theFormat: Graphic3d_ZLayerId): void;
  GetFormatNb(): Graphic3d_ZLayerId;
  GetShapesLocations(): BinTools_LocationSet;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapePersistent {
  constructor();
  static BindTypes(theMap: StdObjMgt_MapOfInstantiators): void;
  delete(): void;
}

export declare class ShapePersistent_HSequence {
  constructor();
  delete(): void;
}

export declare class ShapePersistent_HArray1 {
  constructor();
  delete(): void;
}

export declare class ShapePersistent_HArray2 {
  constructor();
  delete(): void;
}

export declare type ShapePersistent_TriangleMode = {
  ShapePersistent_WithTriangle: {};
  ShapePersistent_WithoutTriangle: {};
}

export declare class STEPConstruct_PointHasher {
  constructor();
  static HashCode(thePoint: gp_Pnt, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(Point1: gp_Pnt, Point2: gp_Pnt): Standard_Boolean;
  delete(): void;
}

export declare class STEPConstruct_ExternRefs extends STEPConstruct_Tool {
  Init(WS: Handle_XSControl_WorkSession): Standard_Boolean;
  Clear(): void;
  LoadExternRefs(): Standard_Boolean;
  NbExternRefs(): Graphic3d_ZLayerId;
  FileName(num: Graphic3d_ZLayerId): Standard_CString;
  ProdDef(num: Graphic3d_ZLayerId): Handle_StepBasic_ProductDefinition;
  DocFile(num: Graphic3d_ZLayerId): Handle_StepBasic_DocumentFile;
  Format(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  AddExternRef(filename: Standard_CString, PD: Handle_StepBasic_ProductDefinition, format: Standard_CString): Graphic3d_ZLayerId;
  checkAP214Shared(): void;
  WriteExternRefs(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetAP214APD(APD: Handle_StepBasic_ApplicationProtocolDefinition): void;
  GetAP214APD(): Handle_StepBasic_ApplicationProtocolDefinition;
  delete(): void;
}

  export declare class STEPConstruct_ExternRefs_1 extends STEPConstruct_ExternRefs {
    constructor();
  }

  export declare class STEPConstruct_ExternRefs_2 extends STEPConstruct_ExternRefs {
    constructor(WS: Handle_XSControl_WorkSession);
  }

export declare class STEPConstruct_ContextTool {
  SetModel(aStepModel: Handle_StepData_StepModel): void;
  GetAPD(): Handle_StepBasic_ApplicationProtocolDefinition;
  AddAPD(enforce: Standard_Boolean): void;
  IsAP203(): Standard_Boolean;
  IsAP214(): Standard_Boolean;
  IsAP242(): Standard_Boolean;
  GetACstatus(): Handle_TCollection_HAsciiString;
  GetACschemaName(): Handle_TCollection_HAsciiString;
  GetACyear(): Graphic3d_ZLayerId;
  GetACname(): Handle_TCollection_HAsciiString;
  SetACstatus(status: Handle_TCollection_HAsciiString): void;
  SetACschemaName(schemaName: Handle_TCollection_HAsciiString): void;
  SetACyear(year: Graphic3d_ZLayerId): void;
  SetACname(name: Handle_TCollection_HAsciiString): void;
  GetDefaultAxis(): Handle_StepGeom_Axis2Placement3d;
  AP203Context(): STEPConstruct_AP203Context;
  Level(): Graphic3d_ZLayerId;
  NextLevel(): void;
  PrevLevel(): void;
  SetLevel(lev: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  NextIndex(): void;
  PrevIndex(): void;
  SetIndex(ind: Graphic3d_ZLayerId): void;
  GetProductName(): Handle_TCollection_HAsciiString;
  GetRootsForPart(SDRTool: STEPConstruct_Part): Handle_TColStd_HSequenceOfTransient;
  GetRootsForAssemblyLink(assembly: STEPConstruct_Assembly): Handle_TColStd_HSequenceOfTransient;
  delete(): void;
}

  export declare class STEPConstruct_ContextTool_1 extends STEPConstruct_ContextTool {
    constructor();
  }

  export declare class STEPConstruct_ContextTool_2 extends STEPConstruct_ContextTool {
    constructor(aStepModel: Handle_StepData_StepModel);
  }

export declare class STEPConstruct_Styles extends STEPConstruct_Tool {
  Init(WS: Handle_XSControl_WorkSession): Standard_Boolean;
  NbStyles(): Graphic3d_ZLayerId;
  Style(i: Graphic3d_ZLayerId): Handle_StepVisual_StyledItem;
  ClearStyles(): void;
  AddStyle_1(style: Handle_StepVisual_StyledItem): void;
  AddStyle_2(item: Handle_StepRepr_RepresentationItem, PSA: Handle_StepVisual_PresentationStyleAssignment, Override: Handle_StepVisual_StyledItem): Handle_StepVisual_StyledItem;
  AddStyle_3(Shape: TopoDS_Shape, PSA: Handle_StepVisual_PresentationStyleAssignment, Override: Handle_StepVisual_StyledItem): Handle_StepVisual_StyledItem;
  CreateMDGPR(Context: Handle_StepRepr_RepresentationContext, MDGPR: Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation): Standard_Boolean;
  CreateNAUOSRD(Context: Handle_StepRepr_RepresentationContext, CDSR: Handle_StepShape_ContextDependentShapeRepresentation, initPDS: Handle_StepRepr_ProductDefinitionShape): Standard_Boolean;
  FindContext(Shape: TopoDS_Shape): Handle_StepRepr_RepresentationContext;
  LoadStyles(): Standard_Boolean;
  LoadInvisStyles(InvSyles: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  MakeColorPSA(item: Handle_StepRepr_RepresentationItem, SurfCol: Handle_StepVisual_Colour, CurveCol: Handle_StepVisual_Colour, RenderCol: Handle_StepVisual_Colour, RenderTransp: Quantity_AbsorbedDose, isForNAUO: Standard_Boolean): Handle_StepVisual_PresentationStyleAssignment;
  GetColorPSA(item: Handle_StepRepr_RepresentationItem, Col: Handle_StepVisual_Colour): Handle_StepVisual_PresentationStyleAssignment;
  GetColors(style: Handle_StepVisual_StyledItem, SurfCol: Handle_StepVisual_Colour, BoundCol: Handle_StepVisual_Colour, CurveCol: Handle_StepVisual_Colour, RenderCol: Handle_StepVisual_Colour, RenderTransp: Quantity_AbsorbedDose, IsComponent: Standard_Boolean): Standard_Boolean;
  static EncodeColor_1(Col: Quantity_Color): Handle_StepVisual_Colour;
  static EncodeColor_2(Col: Quantity_Color, DPDCs: STEPConstruct_DataMapOfAsciiStringTransient, ColRGBs: STEPConstruct_DataMapOfPointTransient): Handle_StepVisual_Colour;
  static DecodeColor(Colour: Handle_StepVisual_Colour, Col: Quantity_Color): Standard_Boolean;
  delete(): void;
}

  export declare class STEPConstruct_Styles_1 extends STEPConstruct_Styles {
    constructor();
  }

  export declare class STEPConstruct_Styles_2 extends STEPConstruct_Styles {
    constructor(WS: Handle_XSControl_WorkSession);
  }

export declare class STEPConstruct_Part {
  constructor()
  MakeSDR(aShape: Handle_StepShape_ShapeRepresentation, aName: Handle_TCollection_HAsciiString, AC: Handle_StepBasic_ApplicationContext): void;
  ReadSDR(aShape: Handle_StepShape_ShapeDefinitionRepresentation): void;
  IsDone(): Standard_Boolean;
  SDRValue(): Handle_StepShape_ShapeDefinitionRepresentation;
  SRValue(): Handle_StepShape_ShapeRepresentation;
  PC(): Handle_StepBasic_ProductContext;
  PCname(): Handle_TCollection_HAsciiString;
  PCdisciplineType(): Handle_TCollection_HAsciiString;
  SetPCname(name: Handle_TCollection_HAsciiString): void;
  SetPCdisciplineType(label: Handle_TCollection_HAsciiString): void;
  AC(): Handle_StepBasic_ApplicationContext;
  ACapplication(): Handle_TCollection_HAsciiString;
  SetACapplication(text: Handle_TCollection_HAsciiString): void;
  PDC(): Handle_StepBasic_ProductDefinitionContext;
  PDCname(): Handle_TCollection_HAsciiString;
  PDCstage(): Handle_TCollection_HAsciiString;
  SetPDCname(label: Handle_TCollection_HAsciiString): void;
  SetPDCstage(label: Handle_TCollection_HAsciiString): void;
  Product(): Handle_StepBasic_Product;
  Pid(): Handle_TCollection_HAsciiString;
  Pname(): Handle_TCollection_HAsciiString;
  Pdescription(): Handle_TCollection_HAsciiString;
  SetPid(id: Handle_TCollection_HAsciiString): void;
  SetPname(label: Handle_TCollection_HAsciiString): void;
  SetPdescription(text: Handle_TCollection_HAsciiString): void;
  PDF(): Handle_StepBasic_ProductDefinitionFormation;
  PDFid(): Handle_TCollection_HAsciiString;
  PDFdescription(): Handle_TCollection_HAsciiString;
  SetPDFid(id: Handle_TCollection_HAsciiString): void;
  SetPDFdescription(text: Handle_TCollection_HAsciiString): void;
  PD(): Handle_StepBasic_ProductDefinition;
  PDdescription(): Handle_TCollection_HAsciiString;
  SetPDdescription(text: Handle_TCollection_HAsciiString): void;
  PDS(): Handle_StepRepr_ProductDefinitionShape;
  PDSname(): Handle_TCollection_HAsciiString;
  PDSdescription(): Handle_TCollection_HAsciiString;
  SetPDSname(label: Handle_TCollection_HAsciiString): void;
  SetPDSdescription(text: Handle_TCollection_HAsciiString): void;
  PRPC(): Handle_StepBasic_ProductRelatedProductCategory;
  PRPCname(): Handle_TCollection_HAsciiString;
  PRPCdescription(): Handle_TCollection_HAsciiString;
  SetPRPCname(label: Handle_TCollection_HAsciiString): void;
  SetPRPCdescription(text: Handle_TCollection_HAsciiString): void;
  delete(): void;
}

export declare class STEPConstruct_UnitContext {
  constructor()
  Init(Tol3d: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Value(): Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx;
  ComputeFactors_1(aContext: Handle_StepRepr_GlobalUnitAssignedContext): Graphic3d_ZLayerId;
  ComputeFactors_2(aUnit: Handle_StepBasic_NamedUnit): Graphic3d_ZLayerId;
  ComputeTolerance(aContext: Handle_StepRepr_GlobalUncertaintyAssignedContext): Graphic3d_ZLayerId;
  LengthFactor(): Quantity_AbsorbedDose;
  PlaneAngleFactor(): Quantity_AbsorbedDose;
  SolidAngleFactor(): Quantity_AbsorbedDose;
  Uncertainty(): Quantity_AbsorbedDose;
  AreaFactor(): Quantity_AbsorbedDose;
  VolumeFactor(): Quantity_AbsorbedDose;
  HasUncertainty(): Standard_Boolean;
  LengthDone(): Standard_Boolean;
  PlaneAngleDone(): Standard_Boolean;
  SolidAngleDone(): Standard_Boolean;
  AreaDone(): Standard_Boolean;
  VolumeDone(): Standard_Boolean;
  StatusMessage(status: Graphic3d_ZLayerId): Standard_CString;
  static ConvertSiPrefix(aPrefix: StepBasic_SiPrefix): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class STEPConstruct_Tool {
  WS(): Handle_XSControl_WorkSession;
  Model(): Handle_Interface_InterfaceModel;
  Graph(recompute: Standard_Boolean): Interface_Graph;
  TransientProcess(): Handle_Transfer_TransientProcess;
  FinderProcess(): Handle_Transfer_FinderProcess;
  delete(): void;
}

  export declare class STEPConstruct_Tool_1 extends STEPConstruct_Tool {
    constructor();
  }

  export declare class STEPConstruct_Tool_2 extends STEPConstruct_Tool {
    constructor(WS: Handle_XSControl_WorkSession);
  }

export declare class STEPConstruct_AP203Context {
  constructor()
  DefaultApproval(): Handle_StepBasic_Approval;
  SetDefaultApproval(app: Handle_StepBasic_Approval): void;
  DefaultDateAndTime(): Handle_StepBasic_DateAndTime;
  SetDefaultDateAndTime(dt: Handle_StepBasic_DateAndTime): void;
  DefaultPersonAndOrganization(): Handle_StepBasic_PersonAndOrganization;
  SetDefaultPersonAndOrganization(po: Handle_StepBasic_PersonAndOrganization): void;
  DefaultSecurityClassificationLevel(): Handle_StepBasic_SecurityClassificationLevel;
  SetDefaultSecurityClassificationLevel(sc: Handle_StepBasic_SecurityClassificationLevel): void;
  RoleCreator(): Handle_StepBasic_PersonAndOrganizationRole;
  RoleDesignOwner(): Handle_StepBasic_PersonAndOrganizationRole;
  RoleDesignSupplier(): Handle_StepBasic_PersonAndOrganizationRole;
  RoleClassificationOfficer(): Handle_StepBasic_PersonAndOrganizationRole;
  RoleCreationDate(): Handle_StepBasic_DateTimeRole;
  RoleClassificationDate(): Handle_StepBasic_DateTimeRole;
  RoleApprover(): Handle_StepBasic_ApprovalRole;
  Init_1(sdr: Handle_StepShape_ShapeDefinitionRepresentation): void;
  Init_2(SDRTool: STEPConstruct_Part): void;
  Init_3(nauo: Handle_StepRepr_NextAssemblyUsageOccurrence): void;
  GetCreator(): Handle_StepAP203_CcDesignPersonAndOrganizationAssignment;
  GetDesignOwner(): Handle_StepAP203_CcDesignPersonAndOrganizationAssignment;
  GetDesignSupplier(): Handle_StepAP203_CcDesignPersonAndOrganizationAssignment;
  GetClassificationOfficer(): Handle_StepAP203_CcDesignPersonAndOrganizationAssignment;
  GetSecurity(): Handle_StepAP203_CcDesignSecurityClassification;
  GetCreationDate(): Handle_StepAP203_CcDesignDateAndTimeAssignment;
  GetClassificationDate(): Handle_StepAP203_CcDesignDateAndTimeAssignment;
  GetApproval(): Handle_StepAP203_CcDesignApproval;
  GetApprover(): Handle_StepBasic_ApprovalPersonOrganization;
  GetApprovalDateTime(): Handle_StepBasic_ApprovalDateTime;
  GetProductCategoryRelationship(): Handle_StepBasic_ProductCategoryRelationship;
  Clear(): void;
  InitRoles(): void;
  InitAssembly(nauo: Handle_StepRepr_NextAssemblyUsageOccurrence): void;
  InitSecurityRequisites(): void;
  InitApprovalRequisites(): void;
  delete(): void;
}

export declare class STEPConstruct_Assembly {
  constructor()
  Init(aSR: Handle_StepShape_ShapeDefinitionRepresentation, SDR0: Handle_StepShape_ShapeDefinitionRepresentation, Ax0: Handle_StepGeom_Axis2Placement3d, Loc: Handle_StepGeom_Axis2Placement3d): void;
  MakeRelationship(): void;
  ItemValue(): Handle_Standard_Transient;
  ItemLocation(): Handle_StepGeom_Axis2Placement3d;
  GetNAUO(): Handle_StepRepr_NextAssemblyUsageOccurrence;
  static CheckSRRReversesNAUO(theGraph: Interface_Graph, CDSR: Handle_StepShape_ContextDependentShapeRepresentation): Standard_Boolean;
  delete(): void;
}

export declare class STEPConstruct {
  constructor();
  static FindEntity_1(FinderProcess: Handle_Transfer_FinderProcess, Shape: TopoDS_Shape): Handle_StepRepr_RepresentationItem;
  static FindEntity_2(FinderProcess: Handle_Transfer_FinderProcess, Shape: TopoDS_Shape, Loc: TopLoc_Location): Handle_StepRepr_RepresentationItem;
  static FindShape(TransientProcess: Handle_Transfer_TransientProcess, item: Handle_StepRepr_RepresentationItem): TopoDS_Shape;
  static FindCDSR(ComponentBinder: Handle_Transfer_Binder, AssemblySDR: Handle_StepShape_ShapeDefinitionRepresentation, ComponentCDSR: Handle_StepShape_ContextDependentShapeRepresentation): Standard_Boolean;
  delete(): void;
}

export declare class STEPConstruct_ValidationProps extends STEPConstruct_Tool {
  Init(WS: Handle_XSControl_WorkSession): Standard_Boolean;
  AddProp_1(Shape: TopoDS_Shape, Prop: Handle_StepRepr_RepresentationItem, Descr: Standard_CString, instance: Standard_Boolean): Standard_Boolean;
  AddProp_2(target: StepRepr_CharacterizedDefinition, Context: Handle_StepRepr_RepresentationContext, Prop: Handle_StepRepr_RepresentationItem, Descr: Standard_CString): Standard_Boolean;
  AddArea(Shape: TopoDS_Shape, Area: Quantity_AbsorbedDose): Standard_Boolean;
  AddVolume(Shape: TopoDS_Shape, Vol: Quantity_AbsorbedDose): Standard_Boolean;
  AddCentroid(Shape: TopoDS_Shape, Pnt: gp_Pnt, instance: Standard_Boolean): Standard_Boolean;
  FindTarget(S: TopoDS_Shape, target: StepRepr_CharacterizedDefinition, Context: Handle_StepRepr_RepresentationContext, instance: Standard_Boolean): Standard_Boolean;
  LoadProps(seq: TColStd_SequenceOfTransient): Standard_Boolean;
  GetPropNAUO(PD: Handle_StepRepr_PropertyDefinition): Handle_StepRepr_NextAssemblyUsageOccurrence;
  GetPropPD(PD: Handle_StepRepr_PropertyDefinition): Handle_StepBasic_ProductDefinition;
  GetPropShape_1(ProdDef: Handle_StepBasic_ProductDefinition): TopoDS_Shape;
  GetPropShape_2(PD: Handle_StepRepr_PropertyDefinition): TopoDS_Shape;
  GetPropReal(item: Handle_StepRepr_RepresentationItem, Val: Quantity_AbsorbedDose, isArea: Standard_Boolean): Standard_Boolean;
  GetPropPnt(item: Handle_StepRepr_RepresentationItem, Context: Handle_StepRepr_RepresentationContext, Pnt: gp_Pnt): Standard_Boolean;
  SetAssemblyShape(shape: TopoDS_Shape): void;
  delete(): void;
}

  export declare class STEPConstruct_ValidationProps_1 extends STEPConstruct_ValidationProps {
    constructor();
  }

  export declare class STEPConstruct_ValidationProps_2 extends STEPConstruct_ValidationProps {
    constructor(WS: Handle_XSControl_WorkSession);
  }

export declare class StdDrivers {
  constructor();
  static Factory(aGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static BindTypes(theMap: StdObjMgt_MapOfInstantiators): void;
  delete(): void;
}

export declare class StdDrivers_DocumentRetrievalDriver extends StdLDrivers_DocumentRetrievalDriver {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepMAT2d_Explorer {
  Clear(): void;
  Perform(aFace: TopoDS_Face): void;
  NumberOfContours(): Graphic3d_ZLayerId;
  NumberOfCurves(IndexContour: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Init(IndexContour: Graphic3d_ZLayerId): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Geom2d_Curve;
  Shape(): TopoDS_Shape;
  Contour(IndexContour: Graphic3d_ZLayerId): TColGeom2d_SequenceOfCurve;
  IsModified(aShape: TopoDS_Shape): Standard_Boolean;
  ModifiedShape(aShape: TopoDS_Shape): TopoDS_Shape;
  GetIsClosed(): TColStd_SequenceOfBoolean;
  delete(): void;
}

  export declare class BRepMAT2d_Explorer_1 extends BRepMAT2d_Explorer {
    constructor();
  }

  export declare class BRepMAT2d_Explorer_2 extends BRepMAT2d_Explorer {
    constructor(aFace: TopoDS_Face);
  }

export declare class BRepMAT2d_DataMapOfShapeSequenceOfBasicElt extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepMAT2d_DataMapOfShapeSequenceOfBasicElt): void;
  Assign(theOther: BRepMAT2d_DataMapOfShapeSequenceOfBasicElt): BRepMAT2d_DataMapOfShapeSequenceOfBasicElt;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: MAT_SequenceOfBasicElt): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: MAT_SequenceOfBasicElt): MAT_SequenceOfBasicElt;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): MAT_SequenceOfBasicElt;
  ChangeSeek(theKey: TopoDS_Shape): MAT_SequenceOfBasicElt;
  ChangeFind(theKey: TopoDS_Shape): MAT_SequenceOfBasicElt;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_1 extends BRepMAT2d_DataMapOfShapeSequenceOfBasicElt {
    constructor();
  }

  export declare class BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_2 extends BRepMAT2d_DataMapOfShapeSequenceOfBasicElt {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_3 extends BRepMAT2d_DataMapOfShapeSequenceOfBasicElt {
    constructor(theOther: BRepMAT2d_DataMapOfShapeSequenceOfBasicElt);
  }

export declare class BRepMAT2d_BisectingLocus {
  constructor()
  Compute(anExplo: BRepMAT2d_Explorer, LineIndex: Graphic3d_ZLayerId, aSide: MAT_Side, aJoinType: GeomAbs_JoinType, IsOpenResult: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Graph(): Handle_MAT_Graph;
  NumberOfContours(): Graphic3d_ZLayerId;
  NumberOfElts(IndLine: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NumberOfSections(IndLine: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  BasicElt(IndLine: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId): Handle_MAT_BasicElt;
  GeomElt_1(aBasicElt: Handle_MAT_BasicElt): Handle_Geom2d_Geometry;
  GeomElt_2(aNode: Handle_MAT_Node): gp_Pnt2d;
  GeomBis(anArc: Handle_MAT_Arc, Reverse: Standard_Boolean): Bisector_Bisec;
  delete(): void;
}

export declare class BRepMAT2d_LinkTopoBilo {
  Perform(Explo: BRepMAT2d_Explorer, BiLo: BRepMAT2d_BisectingLocus): void;
  Init(S: TopoDS_Shape): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_MAT_BasicElt;
  GeneratingShape(aBE: Handle_MAT_BasicElt): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepMAT2d_LinkTopoBilo_1 extends BRepMAT2d_LinkTopoBilo {
    constructor();
  }

  export declare class BRepMAT2d_LinkTopoBilo_2 extends BRepMAT2d_LinkTopoBilo {
    constructor(Explo: BRepMAT2d_Explorer, BiLo: BRepMAT2d_BisectingLocus);
  }

export declare class TShort_Array1OfShortReal {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Standard_ShortReal): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TShort_Array1OfShortReal): TShort_Array1OfShortReal;
  Move(theOther: TShort_Array1OfShortReal): TShort_Array1OfShortReal;
  First(): Standard_ShortReal;
  ChangeFirst(): Standard_ShortReal;
  Last(): Standard_ShortReal;
  ChangeLast(): Standard_ShortReal;
  Value(theIndex: Standard_Integer): Standard_ShortReal;
  ChangeValue(theIndex: Standard_Integer): Standard_ShortReal;
  SetValue(theIndex: Standard_Integer, theItem: Standard_ShortReal): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TShort_Array1OfShortReal_1 extends TShort_Array1OfShortReal {
    constructor();
  }

  export declare class TShort_Array1OfShortReal_2 extends TShort_Array1OfShortReal {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TShort_Array1OfShortReal_3 extends TShort_Array1OfShortReal {
    constructor(theOther: TShort_Array1OfShortReal);
  }

  export declare class TShort_Array1OfShortReal_4 extends TShort_Array1OfShortReal {
    constructor(theOther: TShort_Array1OfShortReal);
  }

  export declare class TShort_Array1OfShortReal_5 extends TShort_Array1OfShortReal {
    constructor(theBegin: Standard_ShortReal, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TShort_HArray1OfShortReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TShort_HArray1OfShortReal): void;
  get(): TShort_HArray1OfShortReal;
  delete(): void;
}

  export declare class Handle_TShort_HArray1OfShortReal_1 extends Handle_TShort_HArray1OfShortReal {
    constructor();
  }

  export declare class Handle_TShort_HArray1OfShortReal_2 extends Handle_TShort_HArray1OfShortReal {
    constructor(thePtr: TShort_HArray1OfShortReal);
  }

  export declare class Handle_TShort_HArray1OfShortReal_3 extends Handle_TShort_HArray1OfShortReal {
    constructor(theHandle: Handle_TShort_HArray1OfShortReal);
  }

  export declare class Handle_TShort_HArray1OfShortReal_4 extends Handle_TShort_HArray1OfShortReal {
    constructor(theHandle: Handle_TShort_HArray1OfShortReal);
  }

export declare class TShort_Array2OfShortReal {
  Init(theValue: Standard_ShortReal): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TShort_Array2OfShortReal): TShort_Array2OfShortReal;
  Move(theOther: TShort_Array2OfShortReal): TShort_Array2OfShortReal;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Standard_ShortReal;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Standard_ShortReal;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Standard_ShortReal): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TShort_Array2OfShortReal_1 extends TShort_Array2OfShortReal {
    constructor();
  }

  export declare class TShort_Array2OfShortReal_2 extends TShort_Array2OfShortReal {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TShort_Array2OfShortReal_3 extends TShort_Array2OfShortReal {
    constructor(theOther: TShort_Array2OfShortReal);
  }

  export declare class TShort_Array2OfShortReal_4 extends TShort_Array2OfShortReal {
    constructor(theOther: TShort_Array2OfShortReal);
  }

  export declare class TShort_Array2OfShortReal_5 extends TShort_Array2OfShortReal {
    constructor(theBegin: Standard_ShortReal, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TShort_HSequenceOfShortReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TShort_HSequenceOfShortReal): void;
  get(): TShort_HSequenceOfShortReal;
  delete(): void;
}

  export declare class Handle_TShort_HSequenceOfShortReal_1 extends Handle_TShort_HSequenceOfShortReal {
    constructor();
  }

  export declare class Handle_TShort_HSequenceOfShortReal_2 extends Handle_TShort_HSequenceOfShortReal {
    constructor(thePtr: TShort_HSequenceOfShortReal);
  }

  export declare class Handle_TShort_HSequenceOfShortReal_3 extends Handle_TShort_HSequenceOfShortReal {
    constructor(theHandle: Handle_TShort_HSequenceOfShortReal);
  }

  export declare class Handle_TShort_HSequenceOfShortReal_4 extends Handle_TShort_HSequenceOfShortReal {
    constructor(theHandle: Handle_TShort_HSequenceOfShortReal);
  }

export declare class TShort_SequenceOfShortReal extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TShort_SequenceOfShortReal): TShort_SequenceOfShortReal;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Standard_ShortReal): void;
  Append_2(theSeq: TShort_SequenceOfShortReal): void;
  Prepend_1(theItem: Standard_ShortReal): void;
  Prepend_2(theSeq: TShort_SequenceOfShortReal): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Standard_ShortReal): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TShort_SequenceOfShortReal): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TShort_SequenceOfShortReal): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Standard_ShortReal): void;
  Split(theIndex: Standard_Integer, theSeq: TShort_SequenceOfShortReal): void;
  First(): Standard_ShortReal;
  ChangeFirst(): Standard_ShortReal;
  Last(): Standard_ShortReal;
  ChangeLast(): Standard_ShortReal;
  Value(theIndex: Standard_Integer): Standard_ShortReal;
  ChangeValue(theIndex: Standard_Integer): Standard_ShortReal;
  SetValue(theIndex: Standard_Integer, theItem: Standard_ShortReal): void;
  delete(): void;
}

  export declare class TShort_SequenceOfShortReal_1 extends TShort_SequenceOfShortReal {
    constructor();
  }

  export declare class TShort_SequenceOfShortReal_2 extends TShort_SequenceOfShortReal {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TShort_SequenceOfShortReal_3 extends TShort_SequenceOfShortReal {
    constructor(theOther: TShort_SequenceOfShortReal);
  }

export declare class Handle_TShort_HArray2OfShortReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TShort_HArray2OfShortReal): void;
  get(): TShort_HArray2OfShortReal;
  delete(): void;
}

  export declare class Handle_TShort_HArray2OfShortReal_1 extends Handle_TShort_HArray2OfShortReal {
    constructor();
  }

  export declare class Handle_TShort_HArray2OfShortReal_2 extends Handle_TShort_HArray2OfShortReal {
    constructor(thePtr: TShort_HArray2OfShortReal);
  }

  export declare class Handle_TShort_HArray2OfShortReal_3 extends Handle_TShort_HArray2OfShortReal {
    constructor(theHandle: Handle_TShort_HArray2OfShortReal);
  }

  export declare class Handle_TShort_HArray2OfShortReal_4 extends Handle_TShort_HArray2OfShortReal {
    constructor(theHandle: Handle_TShort_HArray2OfShortReal);
  }

export declare class Convert_SphereToBSplineSurface extends Convert_ElementarySurfaceToBSplineSurface {
  delete(): void;
}

  export declare class Convert_SphereToBSplineSurface_1 extends Convert_SphereToBSplineSurface {
    constructor(Sph: gp_Sphere, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

  export declare class Convert_SphereToBSplineSurface_2 extends Convert_SphereToBSplineSurface {
    constructor(Sph: gp_Sphere, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, UTrim: Standard_Boolean);
  }

  export declare class Convert_SphereToBSplineSurface_3 extends Convert_SphereToBSplineSurface {
    constructor(Sph: gp_Sphere);
  }

export declare class Convert_CompPolynomialToPoles {
  NbPoles(): Graphic3d_ZLayerId;
  Poles(Poles: Handle_TColStd_HArray2OfReal): void;
  Degree(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Knots(K: Handle_TColStd_HArray1OfReal): void;
  Multiplicities(M: Handle_TColStd_HArray1OfInteger): void;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class Convert_CompPolynomialToPoles_1 extends Convert_CompPolynomialToPoles {
    constructor(NumCurves: Graphic3d_ZLayerId, Continuity: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId, NumCoeffPerCurve: Handle_TColStd_HArray1OfInteger, Coefficients: Handle_TColStd_HArray1OfReal, PolynomialIntervals: Handle_TColStd_HArray2OfReal, TrueIntervals: Handle_TColStd_HArray1OfReal);
  }

  export declare class Convert_CompPolynomialToPoles_2 extends Convert_CompPolynomialToPoles {
    constructor(NumCurves: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId, Continuity: TColStd_Array1OfInteger, NumCoeffPerCurve: TColStd_Array1OfInteger, Coefficients: TColStd_Array1OfReal, PolynomialIntervals: TColStd_Array2OfReal, TrueIntervals: TColStd_Array1OfReal);
  }

  export declare class Convert_CompPolynomialToPoles_3 extends Convert_CompPolynomialToPoles {
    constructor(Dimension: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Coefficients: TColStd_Array1OfReal, PolynomialIntervals: TColStd_Array1OfReal, TrueIntervals: TColStd_Array1OfReal);
  }

export declare class Convert_ElementarySurfaceToBSplineSurface {
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  Pole(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): gp_Pnt;
  Weight(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  UKnot(UIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  VKnot(UIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  UMultiplicity(UIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  VMultiplicity(VIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare type Convert_ParameterisationType = {
  Convert_TgtThetaOver2: {};
  Convert_TgtThetaOver2_1: {};
  Convert_TgtThetaOver2_2: {};
  Convert_TgtThetaOver2_3: {};
  Convert_TgtThetaOver2_4: {};
  Convert_QuasiAngular: {};
  Convert_RationalC1: {};
  Convert_Polynomial: {};
}

export declare class Convert_EllipseToBSplineCurve extends Convert_ConicToBSplineCurve {
  delete(): void;
}

  export declare class Convert_EllipseToBSplineCurve_1 extends Convert_EllipseToBSplineCurve {
    constructor(E: gp_Elips2d, Parameterisation: Convert_ParameterisationType);
  }

  export declare class Convert_EllipseToBSplineCurve_2 extends Convert_EllipseToBSplineCurve {
    constructor(E: gp_Elips2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Parameterisation: Convert_ParameterisationType);
  }

export declare class Convert_TorusToBSplineSurface extends Convert_ElementarySurfaceToBSplineSurface {
  delete(): void;
}

  export declare class Convert_TorusToBSplineSurface_1 extends Convert_TorusToBSplineSurface {
    constructor(T: gp_Torus, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

  export declare class Convert_TorusToBSplineSurface_2 extends Convert_TorusToBSplineSurface {
    constructor(T: gp_Torus, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, UTrim: Standard_Boolean);
  }

  export declare class Convert_TorusToBSplineSurface_3 extends Convert_TorusToBSplineSurface {
    constructor(T: gp_Torus);
  }

export declare class Convert_CylinderToBSplineSurface extends Convert_ElementarySurfaceToBSplineSurface {
  delete(): void;
}

  export declare class Convert_CylinderToBSplineSurface_1 extends Convert_CylinderToBSplineSurface {
    constructor(Cyl: gp_Cylinder, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

  export declare class Convert_CylinderToBSplineSurface_2 extends Convert_CylinderToBSplineSurface {
    constructor(Cyl: gp_Cylinder, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

export declare class Convert_GridPolynomialToPoles {
  Perform(UContinuity: Graphic3d_ZLayerId, VContinuity: Graphic3d_ZLayerId, MaxUDegree: Graphic3d_ZLayerId, MaxVDegree: Graphic3d_ZLayerId, NumCoeffPerSurface: Handle_TColStd_HArray2OfInteger, Coefficients: Handle_TColStd_HArray1OfReal, PolynomialUIntervals: Handle_TColStd_HArray1OfReal, PolynomialVIntervals: Handle_TColStd_HArray1OfReal, TrueUIntervals: Handle_TColStd_HArray1OfReal, TrueVIntervals: Handle_TColStd_HArray1OfReal): void;
  NbUPoles(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  Poles(): Handle_TColgp_HArray2OfPnt;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  UKnots(): Handle_TColStd_HArray1OfReal;
  VKnots(): Handle_TColStd_HArray1OfReal;
  UMultiplicities(): Handle_TColStd_HArray1OfInteger;
  VMultiplicities(): Handle_TColStd_HArray1OfInteger;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class Convert_GridPolynomialToPoles_1 extends Convert_GridPolynomialToPoles {
    constructor(MaxUDegree: Graphic3d_ZLayerId, MaxVDegree: Graphic3d_ZLayerId, NumCoeff: Handle_TColStd_HArray1OfInteger, Coefficients: Handle_TColStd_HArray1OfReal, PolynomialUIntervals: Handle_TColStd_HArray1OfReal, PolynomialVIntervals: Handle_TColStd_HArray1OfReal);
  }

  export declare class Convert_GridPolynomialToPoles_2 extends Convert_GridPolynomialToPoles {
    constructor(NbUSurfaces: Graphic3d_ZLayerId, NBVSurfaces: Graphic3d_ZLayerId, UContinuity: Graphic3d_ZLayerId, VContinuity: Graphic3d_ZLayerId, MaxUDegree: Graphic3d_ZLayerId, MaxVDegree: Graphic3d_ZLayerId, NumCoeffPerSurface: Handle_TColStd_HArray2OfInteger, Coefficients: Handle_TColStd_HArray1OfReal, PolynomialUIntervals: Handle_TColStd_HArray1OfReal, PolynomialVIntervals: Handle_TColStd_HArray1OfReal, TrueUIntervals: Handle_TColStd_HArray1OfReal, TrueVIntervals: Handle_TColStd_HArray1OfReal);
  }

export declare class Convert_ConeToBSplineSurface extends Convert_ElementarySurfaceToBSplineSurface {
  delete(): void;
}

  export declare class Convert_ConeToBSplineSurface_1 extends Convert_ConeToBSplineSurface {
    constructor(C: gp_Cone, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

  export declare class Convert_ConeToBSplineSurface_2 extends Convert_ConeToBSplineSurface {
    constructor(C: gp_Cone, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

export declare class Convert_ConicToBSplineCurve {
  Degree(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  IsPeriodic(): Standard_Boolean;
  Pole(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  Weight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Knot(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Multiplicity(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  BuildCosAndSin_1(Parametrisation: Convert_ParameterisationType, CosNumerator: Handle_TColStd_HArray1OfReal, SinNumerator: Handle_TColStd_HArray1OfReal, Denominator: Handle_TColStd_HArray1OfReal, Degree: Graphic3d_ZLayerId, Knots: Handle_TColStd_HArray1OfReal, Mults: Handle_TColStd_HArray1OfInteger): void;
  BuildCosAndSin_2(Parametrisation: Convert_ParameterisationType, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, CosNumerator: Handle_TColStd_HArray1OfReal, SinNumerator: Handle_TColStd_HArray1OfReal, Denominator: Handle_TColStd_HArray1OfReal, Degree: Graphic3d_ZLayerId, Knots: Handle_TColStd_HArray1OfReal, Mults: Handle_TColStd_HArray1OfInteger): void;
  delete(): void;
}

export declare class Convert_CompBezierCurves2dToBSplineCurve2d {
  constructor(AngularTolerance: Quantity_AbsorbedDose)
  AddCurve(Poles: TColgp_Array1OfPnt2d): void;
  Perform(): void;
  Degree(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Poles(Poles: TColgp_Array1OfPnt2d): void;
  NbKnots(): Graphic3d_ZLayerId;
  KnotsAndMults(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger): void;
  delete(): void;
}

export declare class Convert_HyperbolaToBSplineCurve extends Convert_ConicToBSplineCurve {
  constructor(H: gp_Hypr2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose)
  delete(): void;
}

export declare class Convert_CircleToBSplineCurve extends Convert_ConicToBSplineCurve {
  delete(): void;
}

  export declare class Convert_CircleToBSplineCurve_1 extends Convert_CircleToBSplineCurve {
    constructor(C: gp_Circ2d, Parameterisation: Convert_ParameterisationType);
  }

  export declare class Convert_CircleToBSplineCurve_2 extends Convert_CircleToBSplineCurve {
    constructor(C: gp_Circ2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Parameterisation: Convert_ParameterisationType);
  }

export declare class Convert_ParabolaToBSplineCurve extends Convert_ConicToBSplineCurve {
  constructor(Prb: gp_Parab2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose)
  delete(): void;
}

export declare class Convert_CompBezierCurvesToBSplineCurve {
  constructor(AngularTolerance: Quantity_AbsorbedDose)
  AddCurve(Poles: TColgp_Array1OfPnt): void;
  Perform(): void;
  Degree(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Poles(Poles: TColgp_Array1OfPnt): void;
  NbKnots(): Graphic3d_ZLayerId;
  KnotsAndMults(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger): void;
  delete(): void;
}

export declare class AppParCurves {
  constructor();
  static BernsteinMatrix(NbPoles: Graphic3d_ZLayerId, U: math_Vector, A: math_Matrix): void;
  static Bernstein(NbPoles: Graphic3d_ZLayerId, U: math_Vector, A: math_Matrix, DA: math_Matrix): void;
  static SecondDerivativeBernstein(U: Quantity_AbsorbedDose, DDA: math_Vector): void;
  static SplineFunction(NbPoles: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Parameters: math_Vector, FlatKnots: math_Vector, A: math_Matrix, DA: math_Matrix, Index: math_IntegerVector): void;
  delete(): void;
}

export declare class Handle_AppParCurves_HArray1OfMultiPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppParCurves_HArray1OfMultiPoint): void;
  get(): AppParCurves_HArray1OfMultiPoint;
  delete(): void;
}

  export declare class Handle_AppParCurves_HArray1OfMultiPoint_1 extends Handle_AppParCurves_HArray1OfMultiPoint {
    constructor();
  }

  export declare class Handle_AppParCurves_HArray1OfMultiPoint_2 extends Handle_AppParCurves_HArray1OfMultiPoint {
    constructor(thePtr: AppParCurves_HArray1OfMultiPoint);
  }

  export declare class Handle_AppParCurves_HArray1OfMultiPoint_3 extends Handle_AppParCurves_HArray1OfMultiPoint {
    constructor(theHandle: Handle_AppParCurves_HArray1OfMultiPoint);
  }

  export declare class Handle_AppParCurves_HArray1OfMultiPoint_4 extends Handle_AppParCurves_HArray1OfMultiPoint {
    constructor(theHandle: Handle_AppParCurves_HArray1OfMultiPoint);
  }

export declare class Handle_AppParCurves_HArray1OfMultiBSpCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppParCurves_HArray1OfMultiBSpCurve): void;
  get(): AppParCurves_HArray1OfMultiBSpCurve;
  delete(): void;
}

  export declare class Handle_AppParCurves_HArray1OfMultiBSpCurve_1 extends Handle_AppParCurves_HArray1OfMultiBSpCurve {
    constructor();
  }

  export declare class Handle_AppParCurves_HArray1OfMultiBSpCurve_2 extends Handle_AppParCurves_HArray1OfMultiBSpCurve {
    constructor(thePtr: AppParCurves_HArray1OfMultiBSpCurve);
  }

  export declare class Handle_AppParCurves_HArray1OfMultiBSpCurve_3 extends Handle_AppParCurves_HArray1OfMultiBSpCurve {
    constructor(theHandle: Handle_AppParCurves_HArray1OfMultiBSpCurve);
  }

  export declare class Handle_AppParCurves_HArray1OfMultiBSpCurve_4 extends Handle_AppParCurves_HArray1OfMultiBSpCurve {
    constructor(theHandle: Handle_AppParCurves_HArray1OfMultiBSpCurve);
  }

export declare class AppParCurves_Array1OfMultiPoint {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: AppParCurves_MultiPoint): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: AppParCurves_Array1OfMultiPoint): AppParCurves_Array1OfMultiPoint;
  Move(theOther: AppParCurves_Array1OfMultiPoint): AppParCurves_Array1OfMultiPoint;
  First(): AppParCurves_MultiPoint;
  ChangeFirst(): AppParCurves_MultiPoint;
  Last(): AppParCurves_MultiPoint;
  ChangeLast(): AppParCurves_MultiPoint;
  Value(theIndex: Standard_Integer): AppParCurves_MultiPoint;
  ChangeValue(theIndex: Standard_Integer): AppParCurves_MultiPoint;
  SetValue(theIndex: Standard_Integer, theItem: AppParCurves_MultiPoint): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class AppParCurves_Array1OfMultiPoint_1 extends AppParCurves_Array1OfMultiPoint {
    constructor();
  }

  export declare class AppParCurves_Array1OfMultiPoint_2 extends AppParCurves_Array1OfMultiPoint {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class AppParCurves_Array1OfMultiPoint_3 extends AppParCurves_Array1OfMultiPoint {
    constructor(theOther: AppParCurves_Array1OfMultiPoint);
  }

  export declare class AppParCurves_Array1OfMultiPoint_4 extends AppParCurves_Array1OfMultiPoint {
    constructor(theOther: AppParCurves_Array1OfMultiPoint);
  }

  export declare class AppParCurves_Array1OfMultiPoint_5 extends AppParCurves_Array1OfMultiPoint {
    constructor(theBegin: AppParCurves_MultiPoint, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class AppParCurves_ConstraintCouple {
  Index(): Graphic3d_ZLayerId;
  Constraint(): AppParCurves_Constraint;
  SetIndex(TheIndex: Graphic3d_ZLayerId): void;
  SetConstraint(Cons: AppParCurves_Constraint): void;
  delete(): void;
}

  export declare class AppParCurves_ConstraintCouple_1 extends AppParCurves_ConstraintCouple {
    constructor();
  }

  export declare class AppParCurves_ConstraintCouple_2 extends AppParCurves_ConstraintCouple {
    constructor(TheIndex: Graphic3d_ZLayerId, Cons: AppParCurves_Constraint);
  }

export declare class AppParCurves_Array1OfConstraintCouple {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: AppParCurves_ConstraintCouple): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: AppParCurves_Array1OfConstraintCouple): AppParCurves_Array1OfConstraintCouple;
  Move(theOther: AppParCurves_Array1OfConstraintCouple): AppParCurves_Array1OfConstraintCouple;
  First(): AppParCurves_ConstraintCouple;
  ChangeFirst(): AppParCurves_ConstraintCouple;
  Last(): AppParCurves_ConstraintCouple;
  ChangeLast(): AppParCurves_ConstraintCouple;
  Value(theIndex: Standard_Integer): AppParCurves_ConstraintCouple;
  ChangeValue(theIndex: Standard_Integer): AppParCurves_ConstraintCouple;
  SetValue(theIndex: Standard_Integer, theItem: AppParCurves_ConstraintCouple): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class AppParCurves_Array1OfConstraintCouple_1 extends AppParCurves_Array1OfConstraintCouple {
    constructor();
  }

  export declare class AppParCurves_Array1OfConstraintCouple_2 extends AppParCurves_Array1OfConstraintCouple {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class AppParCurves_Array1OfConstraintCouple_3 extends AppParCurves_Array1OfConstraintCouple {
    constructor(theOther: AppParCurves_Array1OfConstraintCouple);
  }

  export declare class AppParCurves_Array1OfConstraintCouple_4 extends AppParCurves_Array1OfConstraintCouple {
    constructor(theOther: AppParCurves_Array1OfConstraintCouple);
  }

  export declare class AppParCurves_Array1OfConstraintCouple_5 extends AppParCurves_Array1OfConstraintCouple {
    constructor(theBegin: AppParCurves_ConstraintCouple, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class AppParCurves_Array1OfMultiCurve {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: AppParCurves_MultiCurve): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: AppParCurves_Array1OfMultiCurve): AppParCurves_Array1OfMultiCurve;
  Move(theOther: AppParCurves_Array1OfMultiCurve): AppParCurves_Array1OfMultiCurve;
  First(): AppParCurves_MultiCurve;
  ChangeFirst(): AppParCurves_MultiCurve;
  Last(): AppParCurves_MultiCurve;
  ChangeLast(): AppParCurves_MultiCurve;
  Value(theIndex: Standard_Integer): AppParCurves_MultiCurve;
  ChangeValue(theIndex: Standard_Integer): AppParCurves_MultiCurve;
  SetValue(theIndex: Standard_Integer, theItem: AppParCurves_MultiCurve): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class AppParCurves_Array1OfMultiCurve_1 extends AppParCurves_Array1OfMultiCurve {
    constructor();
  }

  export declare class AppParCurves_Array1OfMultiCurve_2 extends AppParCurves_Array1OfMultiCurve {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class AppParCurves_Array1OfMultiCurve_3 extends AppParCurves_Array1OfMultiCurve {
    constructor(theOther: AppParCurves_Array1OfMultiCurve);
  }

  export declare class AppParCurves_Array1OfMultiCurve_4 extends AppParCurves_Array1OfMultiCurve {
    constructor(theOther: AppParCurves_Array1OfMultiCurve);
  }

  export declare class AppParCurves_Array1OfMultiCurve_5 extends AppParCurves_Array1OfMultiCurve {
    constructor(theBegin: AppParCurves_MultiCurve, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class AppParCurves_SequenceOfMultiCurve extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: AppParCurves_SequenceOfMultiCurve): AppParCurves_SequenceOfMultiCurve;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: AppParCurves_MultiCurve): void;
  Append_2(theSeq: AppParCurves_SequenceOfMultiCurve): void;
  Prepend_1(theItem: AppParCurves_MultiCurve): void;
  Prepend_2(theSeq: AppParCurves_SequenceOfMultiCurve): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: AppParCurves_MultiCurve): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: AppParCurves_SequenceOfMultiCurve): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: AppParCurves_SequenceOfMultiCurve): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: AppParCurves_MultiCurve): void;
  Split(theIndex: Standard_Integer, theSeq: AppParCurves_SequenceOfMultiCurve): void;
  First(): AppParCurves_MultiCurve;
  ChangeFirst(): AppParCurves_MultiCurve;
  Last(): AppParCurves_MultiCurve;
  ChangeLast(): AppParCurves_MultiCurve;
  Value(theIndex: Standard_Integer): AppParCurves_MultiCurve;
  ChangeValue(theIndex: Standard_Integer): AppParCurves_MultiCurve;
  SetValue(theIndex: Standard_Integer, theItem: AppParCurves_MultiCurve): void;
  delete(): void;
}

  export declare class AppParCurves_SequenceOfMultiCurve_1 extends AppParCurves_SequenceOfMultiCurve {
    constructor();
  }

  export declare class AppParCurves_SequenceOfMultiCurve_2 extends AppParCurves_SequenceOfMultiCurve {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class AppParCurves_SequenceOfMultiCurve_3 extends AppParCurves_SequenceOfMultiCurve {
    constructor(theOther: AppParCurves_SequenceOfMultiCurve);
  }

export declare class AppParCurves_MultiPoint {
  SetPoint(Index: Graphic3d_ZLayerId, Point: gp_Pnt): void;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  SetPoint2d(Index: Graphic3d_ZLayerId, Point: gp_Pnt2d): void;
  Point2d(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  Dimension(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  NbPoints2d(): Graphic3d_ZLayerId;
  Transform(CuIndex: Graphic3d_ZLayerId, x: Quantity_AbsorbedDose, dx: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose): void;
  Transform2d(CuIndex: Graphic3d_ZLayerId, x: Quantity_AbsorbedDose, dx: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class AppParCurves_MultiPoint_1 extends AppParCurves_MultiPoint {
    constructor();
  }

  export declare class AppParCurves_MultiPoint_2 extends AppParCurves_MultiPoint {
    constructor(NbPoints: Graphic3d_ZLayerId, NbPoints2d: Graphic3d_ZLayerId);
  }

  export declare class AppParCurves_MultiPoint_3 extends AppParCurves_MultiPoint {
    constructor(tabP: TColgp_Array1OfPnt);
  }

  export declare class AppParCurves_MultiPoint_4 extends AppParCurves_MultiPoint {
    constructor(tabP2d: TColgp_Array1OfPnt2d);
  }

  export declare class AppParCurves_MultiPoint_5 extends AppParCurves_MultiPoint {
    constructor(tabP: TColgp_Array1OfPnt, tabP2d: TColgp_Array1OfPnt2d);
  }

export declare class Handle_AppParCurves_HArray1OfMultiCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppParCurves_HArray1OfMultiCurve): void;
  get(): AppParCurves_HArray1OfMultiCurve;
  delete(): void;
}

  export declare class Handle_AppParCurves_HArray1OfMultiCurve_1 extends Handle_AppParCurves_HArray1OfMultiCurve {
    constructor();
  }

  export declare class Handle_AppParCurves_HArray1OfMultiCurve_2 extends Handle_AppParCurves_HArray1OfMultiCurve {
    constructor(thePtr: AppParCurves_HArray1OfMultiCurve);
  }

  export declare class Handle_AppParCurves_HArray1OfMultiCurve_3 extends Handle_AppParCurves_HArray1OfMultiCurve {
    constructor(theHandle: Handle_AppParCurves_HArray1OfMultiCurve);
  }

  export declare class Handle_AppParCurves_HArray1OfMultiCurve_4 extends Handle_AppParCurves_HArray1OfMultiCurve {
    constructor(theHandle: Handle_AppParCurves_HArray1OfMultiCurve);
  }

export declare type AppParCurves_Constraint = {
  AppParCurves_NoConstraint: {};
  AppParCurves_PassPoint: {};
  AppParCurves_TangencyPoint: {};
  AppParCurves_CurvaturePoint: {};
}

export declare class Handle_AppParCurves_HArray1OfConstraintCouple {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppParCurves_HArray1OfConstraintCouple): void;
  get(): AppParCurves_HArray1OfConstraintCouple;
  delete(): void;
}

  export declare class Handle_AppParCurves_HArray1OfConstraintCouple_1 extends Handle_AppParCurves_HArray1OfConstraintCouple {
    constructor();
  }

  export declare class Handle_AppParCurves_HArray1OfConstraintCouple_2 extends Handle_AppParCurves_HArray1OfConstraintCouple {
    constructor(thePtr: AppParCurves_HArray1OfConstraintCouple);
  }

  export declare class Handle_AppParCurves_HArray1OfConstraintCouple_3 extends Handle_AppParCurves_HArray1OfConstraintCouple {
    constructor(theHandle: Handle_AppParCurves_HArray1OfConstraintCouple);
  }

  export declare class Handle_AppParCurves_HArray1OfConstraintCouple_4 extends Handle_AppParCurves_HArray1OfConstraintCouple {
    constructor(theHandle: Handle_AppParCurves_HArray1OfConstraintCouple);
  }

export declare class AppParCurves_Array1OfMultiBSpCurve {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: AppParCurves_MultiBSpCurve): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: AppParCurves_Array1OfMultiBSpCurve): AppParCurves_Array1OfMultiBSpCurve;
  Move(theOther: AppParCurves_Array1OfMultiBSpCurve): AppParCurves_Array1OfMultiBSpCurve;
  First(): AppParCurves_MultiBSpCurve;
  ChangeFirst(): AppParCurves_MultiBSpCurve;
  Last(): AppParCurves_MultiBSpCurve;
  ChangeLast(): AppParCurves_MultiBSpCurve;
  Value(theIndex: Standard_Integer): AppParCurves_MultiBSpCurve;
  ChangeValue(theIndex: Standard_Integer): AppParCurves_MultiBSpCurve;
  SetValue(theIndex: Standard_Integer, theItem: AppParCurves_MultiBSpCurve): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class AppParCurves_Array1OfMultiBSpCurve_1 extends AppParCurves_Array1OfMultiBSpCurve {
    constructor();
  }

  export declare class AppParCurves_Array1OfMultiBSpCurve_2 extends AppParCurves_Array1OfMultiBSpCurve {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class AppParCurves_Array1OfMultiBSpCurve_3 extends AppParCurves_Array1OfMultiBSpCurve {
    constructor(theOther: AppParCurves_Array1OfMultiBSpCurve);
  }

  export declare class AppParCurves_Array1OfMultiBSpCurve_4 extends AppParCurves_Array1OfMultiBSpCurve {
    constructor(theOther: AppParCurves_Array1OfMultiBSpCurve);
  }

  export declare class AppParCurves_Array1OfMultiBSpCurve_5 extends AppParCurves_Array1OfMultiBSpCurve {
    constructor(theBegin: AppParCurves_MultiBSpCurve, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class AppParCurves_MultiBSpCurve extends AppParCurves_MultiCurve {
  SetKnots(theKnots: TColStd_Array1OfReal): void;
  SetMultiplicities(theMults: TColStd_Array1OfInteger): void;
  Knots(): TColStd_Array1OfReal;
  Multiplicities(): TColStd_Array1OfInteger;
  Degree(): Graphic3d_ZLayerId;
  Value_1(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt): void;
  Value_2(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt2d): void;
  D1_1(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt, V1: gp_Vec): void;
  D1_2(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt2d, V1: gp_Vec2d): void;
  D2_1(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D2_2(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class AppParCurves_MultiBSpCurve_1 extends AppParCurves_MultiBSpCurve {
    constructor();
  }

  export declare class AppParCurves_MultiBSpCurve_2 extends AppParCurves_MultiBSpCurve {
    constructor(NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppParCurves_MultiBSpCurve_3 extends AppParCurves_MultiBSpCurve {
    constructor(tabMU: AppParCurves_Array1OfMultiPoint, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger);
  }

  export declare class AppParCurves_MultiBSpCurve_4 extends AppParCurves_MultiBSpCurve {
    constructor(SC: AppParCurves_MultiCurve, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger);
  }

export declare class AppParCurves_SequenceOfMultiBSpCurve extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: AppParCurves_SequenceOfMultiBSpCurve): AppParCurves_SequenceOfMultiBSpCurve;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: AppParCurves_MultiBSpCurve): void;
  Append_2(theSeq: AppParCurves_SequenceOfMultiBSpCurve): void;
  Prepend_1(theItem: AppParCurves_MultiBSpCurve): void;
  Prepend_2(theSeq: AppParCurves_SequenceOfMultiBSpCurve): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: AppParCurves_MultiBSpCurve): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: AppParCurves_SequenceOfMultiBSpCurve): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: AppParCurves_SequenceOfMultiBSpCurve): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: AppParCurves_MultiBSpCurve): void;
  Split(theIndex: Standard_Integer, theSeq: AppParCurves_SequenceOfMultiBSpCurve): void;
  First(): AppParCurves_MultiBSpCurve;
  ChangeFirst(): AppParCurves_MultiBSpCurve;
  Last(): AppParCurves_MultiBSpCurve;
  ChangeLast(): AppParCurves_MultiBSpCurve;
  Value(theIndex: Standard_Integer): AppParCurves_MultiBSpCurve;
  ChangeValue(theIndex: Standard_Integer): AppParCurves_MultiBSpCurve;
  SetValue(theIndex: Standard_Integer, theItem: AppParCurves_MultiBSpCurve): void;
  delete(): void;
}

  export declare class AppParCurves_SequenceOfMultiBSpCurve_1 extends AppParCurves_SequenceOfMultiBSpCurve {
    constructor();
  }

  export declare class AppParCurves_SequenceOfMultiBSpCurve_2 extends AppParCurves_SequenceOfMultiBSpCurve {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class AppParCurves_SequenceOfMultiBSpCurve_3 extends AppParCurves_SequenceOfMultiBSpCurve {
    constructor(theOther: AppParCurves_SequenceOfMultiBSpCurve);
  }

export declare class AppParCurves_MultiCurve {
  SetNbPoles(nbPoles: Graphic3d_ZLayerId): void;
  SetValue(Index: Graphic3d_ZLayerId, MPoint: AppParCurves_MultiPoint): void;
  NbCurves(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Degree(): Graphic3d_ZLayerId;
  Dimension(CuIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Curve_1(CuIndex: Graphic3d_ZLayerId, TabPnt: TColgp_Array1OfPnt): void;
  Curve_2(CuIndex: Graphic3d_ZLayerId, TabPnt: TColgp_Array1OfPnt2d): void;
  Value_1(Index: Graphic3d_ZLayerId): AppParCurves_MultiPoint;
  Pole(CuIndex: Graphic3d_ZLayerId, Nieme: Graphic3d_ZLayerId): gp_Pnt;
  Pole2d(CuIndex: Graphic3d_ZLayerId, Nieme: Graphic3d_ZLayerId): gp_Pnt2d;
  Transform(CuIndex: Graphic3d_ZLayerId, x: Quantity_AbsorbedDose, dx: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose): void;
  Transform2d(CuIndex: Graphic3d_ZLayerId, x: Quantity_AbsorbedDose, dx: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose): void;
  Value_2(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt): void;
  Value_3(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt2d): void;
  D1_1(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt, V1: gp_Vec): void;
  D1_2(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt2d, V1: gp_Vec2d): void;
  D2_1(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D2_2(CuIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, Pt: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class AppParCurves_MultiCurve_1 extends AppParCurves_MultiCurve {
    constructor();
  }

  export declare class AppParCurves_MultiCurve_2 extends AppParCurves_MultiCurve {
    constructor(NbPol: Graphic3d_ZLayerId);
  }

  export declare class AppParCurves_MultiCurve_3 extends AppParCurves_MultiCurve {
    constructor(tabMU: AppParCurves_Array1OfMultiPoint);
  }

export declare class Font_SystemFont extends Standard_Transient {
  constructor(theFontName: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  FontKey(): XCAFDoc_PartId;
  FontName(): XCAFDoc_PartId;
  FontPath(theAspect: Font_FontAspect): XCAFDoc_PartId;
  FontFaceId(theAspect: Font_FontAspect): Graphic3d_ZLayerId;
  SetFontPath(theAspect: Font_FontAspect, thePath: XCAFDoc_PartId, theFaceId: Graphic3d_ZLayerId): void;
  HasFontAspect(theAspect: Font_FontAspect): Standard_Boolean;
  FontPathAny(theAspect: Font_FontAspect, theToSynthesizeItalic: Standard_Boolean, theFaceId: Graphic3d_ZLayerId): XCAFDoc_PartId;
  IsEqual_1(theOtherFont: Handle_Font_SystemFont): Standard_Boolean;
  IsSingleStrokeFont(): Standard_Boolean;
  SetSingleStrokeFont(theIsSingleLine: Standard_Boolean): void;
  ToString(): XCAFDoc_PartId;
  static HashCode(theSystemFont: Handle_Font_SystemFont, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual_2(theFont1: Handle_Font_SystemFont, theFont2: Handle_Font_SystemFont): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Font_SystemFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Font_SystemFont): void;
  get(): Font_SystemFont;
  delete(): void;
}

  export declare class Handle_Font_SystemFont_1 extends Handle_Font_SystemFont {
    constructor();
  }

  export declare class Handle_Font_SystemFont_2 extends Handle_Font_SystemFont {
    constructor(thePtr: Font_SystemFont);
  }

  export declare class Handle_Font_SystemFont_3 extends Handle_Font_SystemFont {
    constructor(theHandle: Handle_Font_SystemFont);
  }

  export declare class Handle_Font_SystemFont_4 extends Handle_Font_SystemFont {
    constructor(theHandle: Handle_Font_SystemFont);
  }

export declare type Font_UnicodeSubset = {
  Font_UnicodeSubset_Western: {};
  Font_UnicodeSubset_Korean: {};
  Font_UnicodeSubset_CJK: {};
  Font_UnicodeSubset_Arabic: {};
}

export declare class Handle_Font_FTLibrary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Font_FTLibrary): void;
  get(): Font_FTLibrary;
  delete(): void;
}

  export declare class Handle_Font_FTLibrary_1 extends Handle_Font_FTLibrary {
    constructor();
  }

  export declare class Handle_Font_FTLibrary_2 extends Handle_Font_FTLibrary {
    constructor(thePtr: Font_FTLibrary);
  }

  export declare class Handle_Font_FTLibrary_3 extends Handle_Font_FTLibrary {
    constructor(theHandle: Handle_Font_FTLibrary);
  }

  export declare class Handle_Font_FTLibrary_4 extends Handle_Font_FTLibrary {
    constructor(theHandle: Handle_Font_FTLibrary);
  }

export declare class Font_FTLibrary extends Standard_Transient {
  constructor()
  IsValid(): Standard_Boolean;
  Instance(): FT_Library;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type Font_FontAspect = {
  Font_FontAspect_UNDEFINED: {};
  Font_FontAspect_Regular: {};
  Font_FontAspect_Bold: {};
  Font_FontAspect_Italic: {};
  Font_FontAspect_BoldItalic: {};
  Font_FA_Undefined: {};
  Font_FA_Regular: {};
  Font_FA_Bold: {};
  Font_FA_Italic: {};
  Font_FA_BoldItalic: {};
}

export declare type Font_StrictLevel = {
  Font_StrictLevel_Strict: {};
  Font_StrictLevel_Aliases: {};
  Font_StrictLevel_Any: {};
}

export declare class Font_Rect {
  constructor();
  TopLeft_1(): any;
  TopLeft_2(theVec: NCollection_Vec2<float>): any;
  TopRight(theVec: NCollection_Vec2<float>): any;
  BottomLeft(theVec: NCollection_Vec2<float>): any;
  BottomRight(theVec: NCollection_Vec2<float>): any;
  Width(): Standard_ShortReal;
  Height(): Standard_ShortReal;
  DumpJson(theOStream: Standard_OStream, a1: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Font_FontMgr extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetInstance(): Handle_Font_FontMgr;
  static FontAspectToString(theAspect: Font_FontAspect): Standard_Character;
  static ToUseUnicodeSubsetFallback(): Standard_Boolean;
  AvailableFonts(theList: Font_NListOfSystemFont): void;
  GetAvailableFonts(): Font_NListOfSystemFont;
  GetAvailableFontsNames(theFontsNames: TColStd_SequenceOfHAsciiString): void;
  GetFont_1(theFontName: Handle_TCollection_HAsciiString, theFontAspect: Font_FontAspect, theFontSize: Graphic3d_ZLayerId): Handle_Font_SystemFont;
  GetFont_2(theFontName: XCAFDoc_PartId): Handle_Font_SystemFont;
  FindFont_1(theFontName: XCAFDoc_PartId, theStrictLevel: Font_StrictLevel, theFontAspect: Font_FontAspect, theDoFailMsg: Standard_Boolean): Handle_Font_SystemFont;
  FindFont_2(theFontName: XCAFDoc_PartId, theFontAspect: Font_FontAspect): Handle_Font_SystemFont;
  FindFallbackFont(theSubset: Font_UnicodeSubset, theFontAspect: Font_FontAspect): Handle_Font_SystemFont;
  CheckFont_1(theFonts: any, theFontPath: XCAFDoc_PartId): Standard_Boolean;
  CheckFont_2(theFontPath: Standard_CString): Handle_Font_SystemFont;
  RegisterFont(theFont: Handle_Font_SystemFont, theToOverride: Standard_Boolean): Standard_Boolean;
  RegisterFonts(theFonts: any, theToOverride: Standard_Boolean): Standard_Boolean;
  ToTraceAliases(): Standard_Boolean;
  SetTraceAliases(theToTrace: Standard_Boolean): void;
  GetAllAliases(theAliases: TColStd_SequenceOfHAsciiString): void;
  GetFontAliases(theFontNames: TColStd_SequenceOfHAsciiString, theAliasName: XCAFDoc_PartId): void;
  AddFontAlias(theAliasName: XCAFDoc_PartId, theFontName: XCAFDoc_PartId): Standard_Boolean;
  RemoveFontAlias(theAliasName: XCAFDoc_PartId, theFontName: XCAFDoc_PartId): Standard_Boolean;
  InitFontDataBase(): void;
  ClearFontDataBase(): void;
  static EmbedFallbackFont(): Handle_NCollection_Buffer;
  delete(): void;
}

export declare class Handle_Font_FontMgr {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Font_FontMgr): void;
  get(): Font_FontMgr;
  delete(): void;
}

  export declare class Handle_Font_FontMgr_1 extends Handle_Font_FontMgr {
    constructor();
  }

  export declare class Handle_Font_FontMgr_2 extends Handle_Font_FontMgr {
    constructor(thePtr: Font_FontMgr);
  }

  export declare class Handle_Font_FontMgr_3 extends Handle_Font_FontMgr {
    constructor(theHandle: Handle_Font_FontMgr);
  }

  export declare class Handle_Font_FontMgr_4 extends Handle_Font_FontMgr {
    constructor(theHandle: Handle_Font_FontMgr);
  }

export declare class Font_FTFontParams {
  delete(): void;
}

  export declare class Font_FTFontParams_1 extends Font_FTFontParams {
    constructor();
  }

  export declare class Font_FTFontParams_2 extends Font_FTFontParams {
    constructor(thePointSize: Aspect_VKeyFlags, theResolution: Aspect_VKeyFlags);
  }

export declare class Font_FTFont extends Standard_Transient {
  constructor(theFTLib: Handle_Font_FTLibrary)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static FindAndCreate(theFontName: XCAFDoc_PartId, theFontAspect: Font_FontAspect, theParams: Font_FTFontParams, theStrictLevel: Font_StrictLevel): Handle_Font_FTFont;
  static IsCharFromCJK(theUChar: Standard_Utf32Char): Standard_Boolean;
  static IsCharFromHiragana(theUChar: Standard_Utf32Char): Standard_Boolean;
  static IsCharFromKatakana(theUChar: Standard_Utf32Char): Standard_Boolean;
  static IsCharFromKorean(theUChar: Standard_Utf32Char): Standard_Boolean;
  static IsCharFromArabic(theUChar: Standard_Utf32Char): Standard_Boolean;
  static IsCharRightToLeft(theUChar: Standard_Utf32Char): Standard_Boolean;
  static CharSubset(theUChar: Standard_Utf32Char): Font_UnicodeSubset;
  IsValid(): Standard_Boolean;
  Init_1(theFontPath: XCAFDoc_PartId, theParams: Font_FTFontParams, theFaceId: Graphic3d_ZLayerId): Standard_Boolean;
  Init_2(theData: Handle_NCollection_Buffer, theFileName: XCAFDoc_PartId, theParams: Font_FTFontParams, theFaceId: Graphic3d_ZLayerId): Standard_Boolean;
  FindAndInit(theFontName: XCAFDoc_PartId, theFontAspect: Font_FontAspect, theParams: Font_FTFontParams, theStrictLevel: Font_StrictLevel): Standard_Boolean;
  ToUseUnicodeSubsetFallback(): Standard_Boolean;
  SetUseUnicodeSubsetFallback(theToFallback: Standard_Boolean): void;
  IsSingleStrokeFont(): Standard_Boolean;
  SetSingleStrokeFont(theIsSingleLine: Standard_Boolean): void;
  ToSynthesizeItalic(): Standard_Boolean;
  Release(): void;
  RenderGlyph(theChar: Standard_Utf32Char): Standard_Boolean;
  GlyphMaxSizeX(theToIncludeFallback: Standard_Boolean): Aspect_VKeyFlags;
  GlyphMaxSizeY(theToIncludeFallback: Standard_Boolean): Aspect_VKeyFlags;
  Ascender(): Standard_ShortReal;
  Descender(): Standard_ShortReal;
  LineSpacing(): Standard_ShortReal;
  PointSize(): Aspect_VKeyFlags;
  WidthScaling(): Standard_ShortReal;
  SetWidthScaling(theScaleFactor: Standard_ShortReal): void;
  HasSymbol(theUChar: Standard_Utf32Char): Standard_Boolean;
  AdvanceX_1(theUCharNext: Standard_Utf32Char): Standard_ShortReal;
  AdvanceX_2(theUChar: Standard_Utf32Char, theUCharNext: Standard_Utf32Char): Standard_ShortReal;
  AdvanceY_1(theUCharNext: Standard_Utf32Char): Standard_ShortReal;
  AdvanceY_2(theUChar: Standard_Utf32Char, theUCharNext: Standard_Utf32Char): Standard_ShortReal;
  GlyphsNumber(theToIncludeFallback: Standard_Boolean): Graphic3d_ZLayerId;
  GlyphRect(theRect: Font_Rect): void;
  BoundingBox(theString: NCollection_String, theAlignX: Graphic3d_HorizontalTextAlignment, theAlignY: Graphic3d_VerticalTextAlignment): Font_Rect;
  renderGlyphOutline(theChar: Standard_Utf32Char): FT_Outline;
  Init_3(theFontPath: NCollection_String, thePointSize: Aspect_VKeyFlags, theResolution: Aspect_VKeyFlags): Standard_Boolean;
  Init_4(theFontName: NCollection_String, theFontAspect: Font_FontAspect, thePointSize: Aspect_VKeyFlags, theResolution: Aspect_VKeyFlags): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Font_FTFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Font_FTFont): void;
  get(): Font_FTFont;
  delete(): void;
}

  export declare class Handle_Font_FTFont_1 extends Handle_Font_FTFont {
    constructor();
  }

  export declare class Handle_Font_FTFont_2 extends Handle_Font_FTFont {
    constructor(thePtr: Font_FTFont);
  }

  export declare class Handle_Font_FTFont_3 extends Handle_Font_FTFont {
    constructor(theHandle: Handle_Font_FTFont);
  }

  export declare class Handle_Font_FTFont_4 extends Handle_Font_FTFont {
    constructor(theHandle: Handle_Font_FTFont);
  }

export declare class Font_TextFormatter extends Standard_Transient {
  constructor()
  SetupAlignment(theAlignX: Graphic3d_HorizontalTextAlignment, theAlignY: Graphic3d_VerticalTextAlignment): void;
  Reset(): void;
  Append(theString: NCollection_String, theFont: Font_FTFont): void;
  Format(): void;
  TopLeft(theIndex: Graphic3d_ZLayerId): Graphic3d_Vec2;
  BottomLeft(theIndex: Graphic3d_ZLayerId): Graphic3d_Vec2;
  String(): NCollection_String;
  GlyphBoundingBox(theIndex: Graphic3d_ZLayerId, theBndBox: Font_Rect): Standard_Boolean;
  LineHeight(theIndex: Graphic3d_ZLayerId): Standard_ShortReal;
  LineWidth(theIndex: Graphic3d_ZLayerId): Standard_ShortReal;
  IsLFSymbol(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  FirstPosition(): Standard_ShortReal;
  LinePositionIndex(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  LineIndex(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  TabSize(): Graphic3d_ZLayerId;
  HorizontalTextAlignment(): Graphic3d_HorizontalTextAlignment;
  VerticalTextAlignment(): Graphic3d_VerticalTextAlignment;
  SetWrapping(theWidth: Standard_ShortReal): void;
  HasWrapping(): Standard_Boolean;
  Wrapping(): Standard_ShortReal;
  ResultWidth(): Standard_ShortReal;
  ResultHeight(): Standard_ShortReal;
  MaximumSymbolWidth(): Standard_ShortReal;
  BndBox(theBndBox: Font_Rect): void;
  Corners(): any;
  NewLines(): any;
  static IsCommandSymbol(theSymbol: Standard_Utf32Char): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Font_TextFormatter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Font_TextFormatter): void;
  get(): Font_TextFormatter;
  delete(): void;
}

  export declare class Handle_Font_TextFormatter_1 extends Handle_Font_TextFormatter {
    constructor();
  }

  export declare class Handle_Font_TextFormatter_2 extends Handle_Font_TextFormatter {
    constructor(thePtr: Font_TextFormatter);
  }

  export declare class Handle_Font_TextFormatter_3 extends Handle_Font_TextFormatter {
    constructor(theHandle: Handle_Font_TextFormatter);
  }

  export declare class Handle_Font_TextFormatter_4 extends Handle_Font_TextFormatter {
    constructor(theHandle: Handle_Font_TextFormatter);
  }

export declare class StepSelect_StepType extends IFSelect_Signature {
  constructor()
  SetProtocol(proto: Handle_Interface_Protocol): void;
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepSelect_StepType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepSelect_StepType): void;
  get(): StepSelect_StepType;
  delete(): void;
}

  export declare class Handle_StepSelect_StepType_1 extends Handle_StepSelect_StepType {
    constructor();
  }

  export declare class Handle_StepSelect_StepType_2 extends Handle_StepSelect_StepType {
    constructor(thePtr: StepSelect_StepType);
  }

  export declare class Handle_StepSelect_StepType_3 extends Handle_StepSelect_StepType {
    constructor(theHandle: Handle_StepSelect_StepType);
  }

  export declare class Handle_StepSelect_StepType_4 extends Handle_StepSelect_StepType {
    constructor(theHandle: Handle_StepSelect_StepType);
  }

export declare class Handle_StepSelect_WorkLibrary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepSelect_WorkLibrary): void;
  get(): StepSelect_WorkLibrary;
  delete(): void;
}

  export declare class Handle_StepSelect_WorkLibrary_1 extends Handle_StepSelect_WorkLibrary {
    constructor();
  }

  export declare class Handle_StepSelect_WorkLibrary_2 extends Handle_StepSelect_WorkLibrary {
    constructor(thePtr: StepSelect_WorkLibrary);
  }

  export declare class Handle_StepSelect_WorkLibrary_3 extends Handle_StepSelect_WorkLibrary {
    constructor(theHandle: Handle_StepSelect_WorkLibrary);
  }

  export declare class Handle_StepSelect_WorkLibrary_4 extends Handle_StepSelect_WorkLibrary {
    constructor(theHandle: Handle_StepSelect_WorkLibrary);
  }

export declare class StepSelect_WorkLibrary extends IFSelect_WorkLibrary {
  constructor(copymode: Standard_Boolean)
  SetDumpLabel(mode: Graphic3d_ZLayerId): void;
  ReadFile(name: Standard_CString, model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol): Graphic3d_ZLayerId;
  ReadStream(theName: Standard_CString, theIStream: Standard_IStream, model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol): Graphic3d_ZLayerId;
  WriteFile(ctx: IFSelect_ContextWrite): Standard_Boolean;
  CopyModel(original: Handle_Interface_InterfaceModel, newmodel: Handle_Interface_InterfaceModel, list: Interface_EntityIterator, TC: Interface_CopyTool): Standard_Boolean;
  DumpEntity(model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, entity: Handle_Standard_Transient, S: Standard_OStream, level: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepSelect_ModelModifier extends IFSelect_Modifier {
  Perform(ctx: IFSelect_ContextModif, target: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, TC: Interface_CopyTool): void;
  PerformProtocol(ctx: IFSelect_ContextModif, target: Handle_StepData_StepModel, proto: Handle_StepData_Protocol, TC: Interface_CopyTool): void;
  Performing(ctx: IFSelect_ContextModif, target: Handle_StepData_StepModel, TC: Interface_CopyTool): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepSelect_ModelModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepSelect_ModelModifier): void;
  get(): StepSelect_ModelModifier;
  delete(): void;
}

  export declare class Handle_StepSelect_ModelModifier_1 extends Handle_StepSelect_ModelModifier {
    constructor();
  }

  export declare class Handle_StepSelect_ModelModifier_2 extends Handle_StepSelect_ModelModifier {
    constructor(thePtr: StepSelect_ModelModifier);
  }

  export declare class Handle_StepSelect_ModelModifier_3 extends Handle_StepSelect_ModelModifier {
    constructor(theHandle: Handle_StepSelect_ModelModifier);
  }

  export declare class Handle_StepSelect_ModelModifier_4 extends Handle_StepSelect_ModelModifier {
    constructor(theHandle: Handle_StepSelect_ModelModifier);
  }

export declare class Handle_StepSelect_FloatFormat {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepSelect_FloatFormat): void;
  get(): StepSelect_FloatFormat;
  delete(): void;
}

  export declare class Handle_StepSelect_FloatFormat_1 extends Handle_StepSelect_FloatFormat {
    constructor();
  }

  export declare class Handle_StepSelect_FloatFormat_2 extends Handle_StepSelect_FloatFormat {
    constructor(thePtr: StepSelect_FloatFormat);
  }

  export declare class Handle_StepSelect_FloatFormat_3 extends Handle_StepSelect_FloatFormat {
    constructor(theHandle: Handle_StepSelect_FloatFormat);
  }

  export declare class Handle_StepSelect_FloatFormat_4 extends Handle_StepSelect_FloatFormat {
    constructor(theHandle: Handle_StepSelect_FloatFormat);
  }

export declare class StepSelect_FloatFormat extends StepSelect_FileModifier {
  constructor()
  SetDefault(digits: Graphic3d_ZLayerId): void;
  SetZeroSuppress(mode: Standard_Boolean): void;
  SetFormat(format: Standard_CString): void;
  SetFormatForRange(format: Standard_CString, Rmin: Quantity_AbsorbedDose, Rmax: Quantity_AbsorbedDose): void;
  Format(zerosup: Standard_Boolean, mainform: XCAFDoc_PartId, hasrange: Standard_Boolean, forminrange: XCAFDoc_PartId, rangemin: Quantity_AbsorbedDose, rangemax: Quantity_AbsorbedDose): void;
  Perform(ctx: IFSelect_ContextWrite, writer: StepData_StepWriter): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepSelect_FileModifier extends IFSelect_GeneralModifier {
  Perform(ctx: IFSelect_ContextWrite, writer: StepData_StepWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepSelect_FileModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepSelect_FileModifier): void;
  get(): StepSelect_FileModifier;
  delete(): void;
}

  export declare class Handle_StepSelect_FileModifier_1 extends Handle_StepSelect_FileModifier {
    constructor();
  }

  export declare class Handle_StepSelect_FileModifier_2 extends Handle_StepSelect_FileModifier {
    constructor(thePtr: StepSelect_FileModifier);
  }

  export declare class Handle_StepSelect_FileModifier_3 extends Handle_StepSelect_FileModifier {
    constructor(theHandle: Handle_StepSelect_FileModifier);
  }

  export declare class Handle_StepSelect_FileModifier_4 extends Handle_StepSelect_FileModifier {
    constructor(theHandle: Handle_StepSelect_FileModifier);
  }

export declare class StepSelect_Activator extends IFSelect_Activator {
  constructor()
  Do(number: Graphic3d_ZLayerId, pilot: Handle_IFSelect_SessionPilot): IFSelect_ReturnStatus;
  Help(number: Graphic3d_ZLayerId): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepSelect_Activator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepSelect_Activator): void;
  get(): StepSelect_Activator;
  delete(): void;
}

  export declare class Handle_StepSelect_Activator_1 extends Handle_StepSelect_Activator {
    constructor();
  }

  export declare class Handle_StepSelect_Activator_2 extends Handle_StepSelect_Activator {
    constructor(thePtr: StepSelect_Activator);
  }

  export declare class Handle_StepSelect_Activator_3 extends Handle_StepSelect_Activator {
    constructor(theHandle: Handle_StepSelect_Activator);
  }

  export declare class Handle_StepSelect_Activator_4 extends Handle_StepSelect_Activator {
    constructor(theHandle: Handle_StepSelect_Activator);
  }

export declare class BRepToIGES_BRWire extends BRepToIGES_BREntity {
  TransferWire_1(start: TopoDS_Shape): Handle_IGESData_IGESEntity;
  TransferVertex_1(myvertex: TopoDS_Vertex): Handle_IGESData_IGESEntity;
  TransferVertex_2(myvertex: TopoDS_Vertex, myedge: TopoDS_Edge, parameter: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferVertex_3(myvertex: TopoDS_Vertex, myedge: TopoDS_Edge, myface: TopoDS_Face, parameter: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferVertex_4(myvertex: TopoDS_Vertex, myedge: TopoDS_Edge, mysurface: Handle_Geom_Surface, myloc: TopLoc_Location, parameter: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferVertex_5(myvertex: TopoDS_Vertex, myface: TopoDS_Face, mypoint: gp_Pnt2d): Handle_IGESData_IGESEntity;
  TransferEdge_1(myedge: TopoDS_Edge, isBRepMode: Standard_Boolean): Handle_IGESData_IGESEntity;
  TransferEdge_2(myedge: TopoDS_Edge, myface: TopoDS_Face, length: Quantity_AbsorbedDose, isBRepMode: Standard_Boolean): Handle_IGESData_IGESEntity;
  TransferWire_2(mywire: TopoDS_Wire): Handle_IGESData_IGESEntity;
  TransferWire_3(mywire: TopoDS_Wire, myface: TopoDS_Face, mycurve2d: Handle_IGESData_IGESEntity, length: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  delete(): void;
}

  export declare class BRepToIGES_BRWire_1 extends BRepToIGES_BRWire {
    constructor();
  }

  export declare class BRepToIGES_BRWire_2 extends BRepToIGES_BRWire {
    constructor(BR: BRepToIGES_BREntity);
  }

export declare class BRepToIGES_BREntity {
  constructor()
  Init(): void;
  SetModel(model: Handle_IGESData_IGESModel): void;
  GetModel(): Handle_IGESData_IGESModel;
  GetUnit(): Quantity_AbsorbedDose;
  SetTransferProcess(TP: Handle_Transfer_FinderProcess): void;
  GetTransferProcess(): Handle_Transfer_FinderProcess;
  TransferShape(start: TopoDS_Shape, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  AddFail_1(start: TopoDS_Shape, amess: Standard_CString): void;
  AddWarning_1(start: TopoDS_Shape, amess: Standard_CString): void;
  AddFail_2(start: Handle_Standard_Transient, amess: Standard_CString): void;
  AddWarning_2(start: Handle_Standard_Transient, amess: Standard_CString): void;
  HasShapeResult_1(start: TopoDS_Shape): Standard_Boolean;
  GetShapeResult_1(start: TopoDS_Shape): Handle_Standard_Transient;
  SetShapeResult_1(start: TopoDS_Shape, result: Handle_Standard_Transient): void;
  HasShapeResult_2(start: Handle_Standard_Transient): Standard_Boolean;
  GetShapeResult_2(start: Handle_Standard_Transient): Handle_Standard_Transient;
  SetShapeResult_2(start: Handle_Standard_Transient, result: Handle_Standard_Transient): void;
  GetConvertSurfaceMode(): Standard_Boolean;
  GetPCurveMode(): Standard_Boolean;
  delete(): void;
}

export declare class BRepToIGES_BRSolid extends BRepToIGES_BREntity {
  TransferSolid_1(start: TopoDS_Shape, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferSolid_2(start: TopoDS_Solid, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferCompSolid(start: TopoDS_CompSolid, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferCompound(start: TopoDS_Compound, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  delete(): void;
}

  export declare class BRepToIGES_BRSolid_1 extends BRepToIGES_BRSolid {
    constructor();
  }

  export declare class BRepToIGES_BRSolid_2 extends BRepToIGES_BRSolid {
    constructor(BR: BRepToIGES_BREntity);
  }

export declare class BRepToIGES_BRShell extends BRepToIGES_BREntity {
  TransferShell_1(start: TopoDS_Shape, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferShell_2(start: TopoDS_Shell, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferFace(start: TopoDS_Face, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  delete(): void;
}

  export declare class BRepToIGES_BRShell_1 extends BRepToIGES_BRShell {
    constructor();
  }

  export declare class BRepToIGES_BRShell_2 extends BRepToIGES_BRShell {
    constructor(BR: BRepToIGES_BREntity);
  }

export declare class IntAna_Int3Pln {
  Perform(P1: gp_Pln, P2: gp_Pln, P3: gp_Pln): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Value(): gp_Pnt;
  delete(): void;
}

  export declare class IntAna_Int3Pln_1 extends IntAna_Int3Pln {
    constructor();
  }

  export declare class IntAna_Int3Pln_2 extends IntAna_Int3Pln {
    constructor(P1: gp_Pln, P2: gp_Pln, P3: gp_Pln);
  }

export declare type IntAna_ResultType = {
  IntAna_Point: {};
  IntAna_Line: {};
  IntAna_Circle: {};
  IntAna_PointAndCircle: {};
  IntAna_Ellipse: {};
  IntAna_Parabola: {};
  IntAna_Hyperbola: {};
  IntAna_Empty: {};
  IntAna_Same: {};
  IntAna_NoGeometricSolution: {};
}

export declare class IntAna_IntConicQuad {
  Perform_1(L: gp_Lin, Q: IntAna_Quadric): void;
  Perform_2(C: gp_Circ, Q: IntAna_Quadric): void;
  Perform_3(E: gp_Elips, Q: IntAna_Quadric): void;
  Perform_4(P: gp_Parab, Q: IntAna_Quadric): void;
  Perform_5(H: gp_Hypr, Q: IntAna_Quadric): void;
  Perform_6(L: gp_Lin, P: gp_Pln, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Len: Quantity_AbsorbedDose): void;
  Perform_7(C: gp_Circ, P: gp_Pln, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_8(E: gp_Elips, P: gp_Pln, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_9(Pb: gp_Parab, P: gp_Pln, Tolang: Quantity_AbsorbedDose): void;
  Perform_10(H: gp_Hypr, P: gp_Pln, Tolang: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsInQuadric(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(N: Graphic3d_ZLayerId): gp_Pnt;
  ParamOnConic(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntAna_IntConicQuad_1 extends IntAna_IntConicQuad {
    constructor();
  }

  export declare class IntAna_IntConicQuad_2 extends IntAna_IntConicQuad {
    constructor(L: gp_Lin, Q: IntAna_Quadric);
  }

  export declare class IntAna_IntConicQuad_3 extends IntAna_IntConicQuad {
    constructor(C: gp_Circ, Q: IntAna_Quadric);
  }

  export declare class IntAna_IntConicQuad_4 extends IntAna_IntConicQuad {
    constructor(E: gp_Elips, Q: IntAna_Quadric);
  }

  export declare class IntAna_IntConicQuad_5 extends IntAna_IntConicQuad {
    constructor(P: gp_Parab, Q: IntAna_Quadric);
  }

  export declare class IntAna_IntConicQuad_6 extends IntAna_IntConicQuad {
    constructor(H: gp_Hypr, Q: IntAna_Quadric);
  }

  export declare class IntAna_IntConicQuad_7 extends IntAna_IntConicQuad {
    constructor(L: gp_Lin, P: gp_Pln, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Len: Quantity_AbsorbedDose);
  }

  export declare class IntAna_IntConicQuad_8 extends IntAna_IntConicQuad {
    constructor(C: gp_Circ, P: gp_Pln, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_IntConicQuad_9 extends IntAna_IntConicQuad {
    constructor(E: gp_Elips, P: gp_Pln, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_IntConicQuad_10 extends IntAna_IntConicQuad {
    constructor(Pb: gp_Parab, P: gp_Pln, Tolang: Quantity_AbsorbedDose);
  }

  export declare class IntAna_IntConicQuad_11 extends IntAna_IntConicQuad {
    constructor(H: gp_Hypr, P: gp_Pln, Tolang: Quantity_AbsorbedDose);
  }

export declare class IntAna_IntQuadQuad {
  Perform_1(C: gp_Cylinder, Q: IntAna_Quadric, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C: gp_Cone, Q: IntAna_Quadric, Tol: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IdenticalElements(): Standard_Boolean;
  NbCurve(): Graphic3d_ZLayerId;
  Curve(N: Graphic3d_ZLayerId): IntAna_Curve;
  NbPnt(): Graphic3d_ZLayerId;
  Point(N: Graphic3d_ZLayerId): gp_Pnt;
  Parameters(N: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  HasNextCurve(I: Graphic3d_ZLayerId): Standard_Boolean;
  NextCurve(I: Graphic3d_ZLayerId, theOpposite: Standard_Boolean): Graphic3d_ZLayerId;
  HasPreviousCurve(I: Graphic3d_ZLayerId): Standard_Boolean;
  PreviousCurve(I: Graphic3d_ZLayerId, theOpposite: Standard_Boolean): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class IntAna_IntQuadQuad_1 extends IntAna_IntQuadQuad {
    constructor();
  }

  export declare class IntAna_IntQuadQuad_2 extends IntAna_IntQuadQuad {
    constructor(C: gp_Cylinder, Q: IntAna_Quadric, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_IntQuadQuad_3 extends IntAna_IntQuadQuad {
    constructor(C: gp_Cone, Q: IntAna_Quadric, Tol: Quantity_AbsorbedDose);
  }

export declare class IntAna_IntLinTorus {
  Perform(L: gp_Lin, T: gp_Torus): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): gp_Pnt;
  ParamOnLine(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ParamOnTorus(Index: Graphic3d_ZLayerId, FI: Quantity_AbsorbedDose, THETA: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntAna_IntLinTorus_1 extends IntAna_IntLinTorus {
    constructor();
  }

  export declare class IntAna_IntLinTorus_2 extends IntAna_IntLinTorus {
    constructor(L: gp_Lin, T: gp_Torus);
  }

export declare class IntAna_QuadQuadGeo {
  Perform_1(P1: gp_Pln, P2: gp_Pln, TolAng: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(P: gp_Pln, C: gp_Cylinder, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose): void;
  Perform_3(P: gp_Pln, S: gp_Sphere): void;
  Perform_4(P: gp_Pln, C: gp_Cone, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(Cyl1: gp_Cylinder, Cyl2: gp_Cylinder, Tol: Quantity_AbsorbedDose): void;
  Perform_6(Cyl: gp_Cylinder, Sph: gp_Sphere, Tol: Quantity_AbsorbedDose): void;
  Perform_7(Cyl: gp_Cylinder, Con: gp_Cone, Tol: Quantity_AbsorbedDose): void;
  Perform_8(Sph1: gp_Sphere, Sph2: gp_Sphere, Tol: Quantity_AbsorbedDose): void;
  Perform_9(Sph: gp_Sphere, Con: gp_Cone, Tol: Quantity_AbsorbedDose): void;
  Perform_10(Con1: gp_Cone, Con2: gp_Cone, Tol: Quantity_AbsorbedDose): void;
  Perform_11(Pln: gp_Pln, Tor: gp_Torus, Tol: Quantity_AbsorbedDose): void;
  Perform_12(Cyl: gp_Cylinder, Tor: gp_Torus, Tol: Quantity_AbsorbedDose): void;
  Perform_13(Con: gp_Cone, Tor: gp_Torus, Tol: Quantity_AbsorbedDose): void;
  Perform_14(Sph: gp_Sphere, Tor: gp_Torus, Tol: Quantity_AbsorbedDose): void;
  Perform_15(Tor1: gp_Torus, Tor2: gp_Torus, Tol: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  TypeInter(): IntAna_ResultType;
  NbSolutions(): Graphic3d_ZLayerId;
  Point(Num: Graphic3d_ZLayerId): gp_Pnt;
  Line(Num: Graphic3d_ZLayerId): gp_Lin;
  Circle(Num: Graphic3d_ZLayerId): gp_Circ;
  Ellipse(Num: Graphic3d_ZLayerId): gp_Elips;
  Parabola(Num: Graphic3d_ZLayerId): gp_Parab;
  Hyperbola(Num: Graphic3d_ZLayerId): gp_Hypr;
  HasCommonGen(): Standard_Boolean;
  PChar(): gp_Pnt;
  delete(): void;
}

  export declare class IntAna_QuadQuadGeo_1 extends IntAna_QuadQuadGeo {
    constructor();
  }

  export declare class IntAna_QuadQuadGeo_2 extends IntAna_QuadQuadGeo {
    constructor(P1: gp_Pln, P2: gp_Pln, TolAng: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_3 extends IntAna_QuadQuadGeo {
    constructor(P: gp_Pln, C: gp_Cylinder, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_4 extends IntAna_QuadQuadGeo {
    constructor(P: gp_Pln, S: gp_Sphere);
  }

  export declare class IntAna_QuadQuadGeo_5 extends IntAna_QuadQuadGeo {
    constructor(P: gp_Pln, C: gp_Cone, Tolang: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_6 extends IntAna_QuadQuadGeo {
    constructor(Cyl1: gp_Cylinder, Cyl2: gp_Cylinder, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_7 extends IntAna_QuadQuadGeo {
    constructor(Cyl: gp_Cylinder, Sph: gp_Sphere, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_8 extends IntAna_QuadQuadGeo {
    constructor(Cyl: gp_Cylinder, Con: gp_Cone, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_9 extends IntAna_QuadQuadGeo {
    constructor(Sph1: gp_Sphere, Sph2: gp_Sphere, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_10 extends IntAna_QuadQuadGeo {
    constructor(Sph: gp_Sphere, Con: gp_Cone, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_11 extends IntAna_QuadQuadGeo {
    constructor(Con1: gp_Cone, Con2: gp_Cone, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_12 extends IntAna_QuadQuadGeo {
    constructor(Pln: gp_Pln, Tor: gp_Torus, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_13 extends IntAna_QuadQuadGeo {
    constructor(Cyl: gp_Cylinder, Tor: gp_Torus, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_14 extends IntAna_QuadQuadGeo {
    constructor(Con: gp_Cone, Tor: gp_Torus, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_15 extends IntAna_QuadQuadGeo {
    constructor(Sph: gp_Sphere, Tor: gp_Torus, Tol: Quantity_AbsorbedDose);
  }

  export declare class IntAna_QuadQuadGeo_16 extends IntAna_QuadQuadGeo {
    constructor(Tor1: gp_Torus, Tor2: gp_Torus, Tol: Quantity_AbsorbedDose);
  }

export declare class IntAna_Curve {
  constructor()
  SetCylinderQuadValues(Cylinder: gp_Cylinder, Qxx: Quantity_AbsorbedDose, Qyy: Quantity_AbsorbedDose, Qzz: Quantity_AbsorbedDose, Qxy: Quantity_AbsorbedDose, Qxz: Quantity_AbsorbedDose, Qyz: Quantity_AbsorbedDose, Qx: Quantity_AbsorbedDose, Qy: Quantity_AbsorbedDose, Qz: Quantity_AbsorbedDose, Q1: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, DomInf: Quantity_AbsorbedDose, DomSup: Quantity_AbsorbedDose, TwoZForATheta: Standard_Boolean, ZIsPositive: Standard_Boolean): void;
  SetConeQuadValues(Cone: gp_Cone, Qxx: Quantity_AbsorbedDose, Qyy: Quantity_AbsorbedDose, Qzz: Quantity_AbsorbedDose, Qxy: Quantity_AbsorbedDose, Qxz: Quantity_AbsorbedDose, Qyz: Quantity_AbsorbedDose, Qx: Quantity_AbsorbedDose, Qy: Quantity_AbsorbedDose, Qz: Quantity_AbsorbedDose, Q1: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, DomInf: Quantity_AbsorbedDose, DomSup: Quantity_AbsorbedDose, TwoZForATheta: Standard_Boolean, ZIsPositive: Standard_Boolean): void;
  IsOpen(): Standard_Boolean;
  Domain(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): void;
  IsConstant(): Standard_Boolean;
  IsFirstOpen(): Standard_Boolean;
  IsLastOpen(): Standard_Boolean;
  Value(Theta: Quantity_AbsorbedDose): gp_Pnt;
  D1u(Theta: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): Standard_Boolean;
  FindParameter(P: gp_Pnt, theParams: TColStd_ListOfReal): void;
  SetIsFirstOpen(Flag: Standard_Boolean): void;
  SetIsLastOpen(Flag: Standard_Boolean): void;
  SetDomain(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class IntAna_ListOfCurve extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: IntAna_ListOfCurve): IntAna_ListOfCurve;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): IntAna_Curve;
  First_2(): IntAna_Curve;
  Last_1(): IntAna_Curve;
  Last_2(): IntAna_Curve;
  Append_1(theItem: IntAna_Curve): IntAna_Curve;
  Append_3(theOther: IntAna_ListOfCurve): void;
  Prepend_1(theItem: IntAna_Curve): IntAna_Curve;
  Prepend_2(theOther: IntAna_ListOfCurve): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class IntAna_ListOfCurve_1 extends IntAna_ListOfCurve {
    constructor();
  }

  export declare class IntAna_ListOfCurve_2 extends IntAna_ListOfCurve {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntAna_ListOfCurve_3 extends IntAna_ListOfCurve {
    constructor(theOther: IntAna_ListOfCurve);
  }

export declare class IntAna_Quadric {
  SetQuadric_1(P: gp_Pln): void;
  SetQuadric_2(Sph: gp_Sphere): void;
  SetQuadric_3(Con: gp_Cone): void;
  SetQuadric_4(Cyl: gp_Cylinder): void;
  Coefficients(xCXX: Quantity_AbsorbedDose, xCYY: Quantity_AbsorbedDose, xCZZ: Quantity_AbsorbedDose, xCXY: Quantity_AbsorbedDose, xCXZ: Quantity_AbsorbedDose, xCYZ: Quantity_AbsorbedDose, xCX: Quantity_AbsorbedDose, xCY: Quantity_AbsorbedDose, xCZ: Quantity_AbsorbedDose, xCCte: Quantity_AbsorbedDose): void;
  NewCoefficients(xCXX: Quantity_AbsorbedDose, xCYY: Quantity_AbsorbedDose, xCZZ: Quantity_AbsorbedDose, xCXY: Quantity_AbsorbedDose, xCXZ: Quantity_AbsorbedDose, xCYZ: Quantity_AbsorbedDose, xCX: Quantity_AbsorbedDose, xCY: Quantity_AbsorbedDose, xCZ: Quantity_AbsorbedDose, xCCte: Quantity_AbsorbedDose, Axis: gp_Ax3): void;
  SpecialPoints(): QANCollection_ListOfPnt;
  delete(): void;
}

  export declare class IntAna_Quadric_1 extends IntAna_Quadric {
    constructor();
  }

  export declare class IntAna_Quadric_2 extends IntAna_Quadric {
    constructor(P: gp_Pln);
  }

  export declare class IntAna_Quadric_3 extends IntAna_Quadric {
    constructor(Sph: gp_Sphere);
  }

  export declare class IntAna_Quadric_4 extends IntAna_Quadric {
    constructor(Cyl: gp_Cylinder);
  }

  export declare class IntAna_Quadric_5 extends IntAna_Quadric {
    constructor(Cone: gp_Cone);
  }

export declare class TPrsStd_AISPresentation extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(L: TDF_Label, driver: Standard_GUID): Handle_TPrsStd_AISPresentation;
  static Unset(L: TDF_Label): void;
  static Set_2(master: Handle_TDF_Attribute): Handle_TPrsStd_AISPresentation;
  SetDisplayed(B: Standard_Boolean): void;
  Display(update: Standard_Boolean): void;
  Erase(remove: Standard_Boolean): void;
  Update(): void;
  GetDriverGUID(): Standard_GUID;
  SetDriverGUID(guid: Standard_GUID): void;
  IsDisplayed(): Standard_Boolean;
  GetAIS(): Handle_AIS_InteractiveObject;
  Material(): Graphic3d_NameOfMaterial;
  SetMaterial(aName: Graphic3d_NameOfMaterial): void;
  HasOwnMaterial(): Standard_Boolean;
  UnsetMaterial(): void;
  SetTransparency(aValue: Quantity_AbsorbedDose): void;
  Transparency(): Quantity_AbsorbedDose;
  HasOwnTransparency(): Standard_Boolean;
  UnsetTransparency(): void;
  Color(): Quantity_NameOfColor;
  SetColor(aColor: Quantity_NameOfColor): void;
  HasOwnColor(): Standard_Boolean;
  UnsetColor(): void;
  Width(): Quantity_AbsorbedDose;
  SetWidth(aWidth: Quantity_AbsorbedDose): void;
  HasOwnWidth(): Standard_Boolean;
  UnsetWidth(): void;
  Mode(): Graphic3d_ZLayerId;
  SetMode(theMode: Graphic3d_ZLayerId): void;
  HasOwnMode(): Standard_Boolean;
  UnsetMode(): void;
  GetNbSelectionModes(): Graphic3d_ZLayerId;
  SelectionMode(index: Standard_Integer): Graphic3d_ZLayerId;
  SetSelectionMode(theSelectionMode: Graphic3d_ZLayerId, theTransaction: Standard_Boolean): void;
  AddSelectionMode(theSelectionMode: Graphic3d_ZLayerId, theTransaction: Standard_Boolean): void;
  HasOwnSelectionMode(): Standard_Boolean;
  UnsetSelectionMode(): void;
  ID(): Standard_GUID;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  BackupCopy(): Handle_TDF_Attribute;
  AfterAddition(): void;
  BeforeRemoval(): void;
  BeforeForget(): void;
  AfterResume(): void;
  BeforeUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_AISPresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_AISPresentation): void;
  get(): TPrsStd_AISPresentation;
  delete(): void;
}

  export declare class Handle_TPrsStd_AISPresentation_1 extends Handle_TPrsStd_AISPresentation {
    constructor();
  }

  export declare class Handle_TPrsStd_AISPresentation_2 extends Handle_TPrsStd_AISPresentation {
    constructor(thePtr: TPrsStd_AISPresentation);
  }

  export declare class Handle_TPrsStd_AISPresentation_3 extends Handle_TPrsStd_AISPresentation {
    constructor(theHandle: Handle_TPrsStd_AISPresentation);
  }

  export declare class Handle_TPrsStd_AISPresentation_4 extends Handle_TPrsStd_AISPresentation {
    constructor(theHandle: Handle_TPrsStd_AISPresentation);
  }

export declare class TPrsStd_ConstraintDriver extends TPrsStd_Driver {
  constructor()
  Update(aLabel: TDF_Label, anAISObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_ConstraintDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_ConstraintDriver): void;
  get(): TPrsStd_ConstraintDriver;
  delete(): void;
}

  export declare class Handle_TPrsStd_ConstraintDriver_1 extends Handle_TPrsStd_ConstraintDriver {
    constructor();
  }

  export declare class Handle_TPrsStd_ConstraintDriver_2 extends Handle_TPrsStd_ConstraintDriver {
    constructor(thePtr: TPrsStd_ConstraintDriver);
  }

  export declare class Handle_TPrsStd_ConstraintDriver_3 extends Handle_TPrsStd_ConstraintDriver {
    constructor(theHandle: Handle_TPrsStd_ConstraintDriver);
  }

  export declare class Handle_TPrsStd_ConstraintDriver_4 extends Handle_TPrsStd_ConstraintDriver {
    constructor(theHandle: Handle_TPrsStd_ConstraintDriver);
  }

export declare class TPrsStd_Driver extends Standard_Transient {
  Update(L: TDF_Label, ais: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_Driver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_Driver): void;
  get(): TPrsStd_Driver;
  delete(): void;
}

  export declare class Handle_TPrsStd_Driver_1 extends Handle_TPrsStd_Driver {
    constructor();
  }

  export declare class Handle_TPrsStd_Driver_2 extends Handle_TPrsStd_Driver {
    constructor(thePtr: TPrsStd_Driver);
  }

  export declare class Handle_TPrsStd_Driver_3 extends Handle_TPrsStd_Driver {
    constructor(theHandle: Handle_TPrsStd_Driver);
  }

  export declare class Handle_TPrsStd_Driver_4 extends Handle_TPrsStd_Driver {
    constructor(theHandle: Handle_TPrsStd_Driver);
  }

export declare class TPrsStd_GeometryDriver extends TPrsStd_Driver {
  constructor()
  Update(aLabel: TDF_Label, anAISObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_GeometryDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_GeometryDriver): void;
  get(): TPrsStd_GeometryDriver;
  delete(): void;
}

  export declare class Handle_TPrsStd_GeometryDriver_1 extends Handle_TPrsStd_GeometryDriver {
    constructor();
  }

  export declare class Handle_TPrsStd_GeometryDriver_2 extends Handle_TPrsStd_GeometryDriver {
    constructor(thePtr: TPrsStd_GeometryDriver);
  }

  export declare class Handle_TPrsStd_GeometryDriver_3 extends Handle_TPrsStd_GeometryDriver {
    constructor(theHandle: Handle_TPrsStd_GeometryDriver);
  }

  export declare class Handle_TPrsStd_GeometryDriver_4 extends Handle_TPrsStd_GeometryDriver {
    constructor(theHandle: Handle_TPrsStd_GeometryDriver);
  }

export declare class TPrsStd_PointDriver extends TPrsStd_Driver {
  constructor()
  Update(aLabel: TDF_Label, anAISObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_PointDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_PointDriver): void;
  get(): TPrsStd_PointDriver;
  delete(): void;
}

  export declare class Handle_TPrsStd_PointDriver_1 extends Handle_TPrsStd_PointDriver {
    constructor();
  }

  export declare class Handle_TPrsStd_PointDriver_2 extends Handle_TPrsStd_PointDriver {
    constructor(thePtr: TPrsStd_PointDriver);
  }

  export declare class Handle_TPrsStd_PointDriver_3 extends Handle_TPrsStd_PointDriver {
    constructor(theHandle: Handle_TPrsStd_PointDriver);
  }

  export declare class Handle_TPrsStd_PointDriver_4 extends Handle_TPrsStd_PointDriver {
    constructor(theHandle: Handle_TPrsStd_PointDriver);
  }

export declare class TPrsStd_ConstraintTools {
  constructor();
  static UpdateOnlyValue(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeDistance(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeParallel(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeTangent(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputePerpendicular(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeConcentric(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeSymmetry(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeMidPoint(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeAngle(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeRadius(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeMinRadius(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeMaxRadius(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeEqualDistance(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeEqualRadius(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeFix(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeDiameter(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeOffset(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputePlacement(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeCoincident(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeRound(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeOthers(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  static ComputeTextAndValue(aConst: Handle_TDataXtd_Constraint, aValue: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, anIsAngle: Standard_Boolean): void;
  static ComputeAngleForOneFace(aConst: Handle_TDataXtd_Constraint, anAIS: Handle_AIS_InteractiveObject): void;
  delete(): void;
}

export declare class Handle_TPrsStd_PlaneDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_PlaneDriver): void;
  get(): TPrsStd_PlaneDriver;
  delete(): void;
}

  export declare class Handle_TPrsStd_PlaneDriver_1 extends Handle_TPrsStd_PlaneDriver {
    constructor();
  }

  export declare class Handle_TPrsStd_PlaneDriver_2 extends Handle_TPrsStd_PlaneDriver {
    constructor(thePtr: TPrsStd_PlaneDriver);
  }

  export declare class Handle_TPrsStd_PlaneDriver_3 extends Handle_TPrsStd_PlaneDriver {
    constructor(theHandle: Handle_TPrsStd_PlaneDriver);
  }

  export declare class Handle_TPrsStd_PlaneDriver_4 extends Handle_TPrsStd_PlaneDriver {
    constructor(theHandle: Handle_TPrsStd_PlaneDriver);
  }

export declare class TPrsStd_PlaneDriver extends TPrsStd_Driver {
  constructor()
  Update(aLabel: TDF_Label, anAISObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TPrsStd_NamedShapeDriver extends TPrsStd_Driver {
  constructor()
  Update(aLabel: TDF_Label, anAISObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_NamedShapeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_NamedShapeDriver): void;
  get(): TPrsStd_NamedShapeDriver;
  delete(): void;
}

  export declare class Handle_TPrsStd_NamedShapeDriver_1 extends Handle_TPrsStd_NamedShapeDriver {
    constructor();
  }

  export declare class Handle_TPrsStd_NamedShapeDriver_2 extends Handle_TPrsStd_NamedShapeDriver {
    constructor(thePtr: TPrsStd_NamedShapeDriver);
  }

  export declare class Handle_TPrsStd_NamedShapeDriver_3 extends Handle_TPrsStd_NamedShapeDriver {
    constructor(theHandle: Handle_TPrsStd_NamedShapeDriver);
  }

  export declare class Handle_TPrsStd_NamedShapeDriver_4 extends Handle_TPrsStd_NamedShapeDriver {
    constructor(theHandle: Handle_TPrsStd_NamedShapeDriver);
  }

export declare class TPrsStd_AxisDriver extends TPrsStd_Driver {
  constructor()
  Update(aLabel: TDF_Label, anAISObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_AxisDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_AxisDriver): void;
  get(): TPrsStd_AxisDriver;
  delete(): void;
}

  export declare class Handle_TPrsStd_AxisDriver_1 extends Handle_TPrsStd_AxisDriver {
    constructor();
  }

  export declare class Handle_TPrsStd_AxisDriver_2 extends Handle_TPrsStd_AxisDriver {
    constructor(thePtr: TPrsStd_AxisDriver);
  }

  export declare class Handle_TPrsStd_AxisDriver_3 extends Handle_TPrsStd_AxisDriver {
    constructor(theHandle: Handle_TPrsStd_AxisDriver);
  }

  export declare class Handle_TPrsStd_AxisDriver_4 extends Handle_TPrsStd_AxisDriver {
    constructor(theHandle: Handle_TPrsStd_AxisDriver);
  }

export declare class TPrsStd_AISViewer extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Has(acces: TDF_Label): Standard_Boolean;
  static New_1(access: TDF_Label, selector: Handle_AIS_InteractiveContext): Handle_TPrsStd_AISViewer;
  static New_2(acces: TDF_Label, viewer: Handle_V3d_Viewer): Handle_TPrsStd_AISViewer;
  static Find_1(acces: TDF_Label, A: Handle_TPrsStd_AISViewer): Standard_Boolean;
  static Find_2(acces: TDF_Label, IC: Handle_AIS_InteractiveContext): Standard_Boolean;
  static Find_3(acces: TDF_Label, V: Handle_V3d_Viewer): Standard_Boolean;
  static Update_1(acces: TDF_Label): void;
  Update_2(): void;
  SetInteractiveContext(ctx: Handle_AIS_InteractiveContext): void;
  GetInteractiveContext(): Handle_AIS_InteractiveContext;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TPrsStd_AISViewer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_AISViewer): void;
  get(): TPrsStd_AISViewer;
  delete(): void;
}

  export declare class Handle_TPrsStd_AISViewer_1 extends Handle_TPrsStd_AISViewer {
    constructor();
  }

  export declare class Handle_TPrsStd_AISViewer_2 extends Handle_TPrsStd_AISViewer {
    constructor(thePtr: TPrsStd_AISViewer);
  }

  export declare class Handle_TPrsStd_AISViewer_3 extends Handle_TPrsStd_AISViewer {
    constructor(theHandle: Handle_TPrsStd_AISViewer);
  }

  export declare class Handle_TPrsStd_AISViewer_4 extends Handle_TPrsStd_AISViewer {
    constructor(theHandle: Handle_TPrsStd_AISViewer);
  }

export declare class Handle_TPrsStd_DriverTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TPrsStd_DriverTable): void;
  get(): TPrsStd_DriverTable;
  delete(): void;
}

  export declare class Handle_TPrsStd_DriverTable_1 extends Handle_TPrsStd_DriverTable {
    constructor();
  }

  export declare class Handle_TPrsStd_DriverTable_2 extends Handle_TPrsStd_DriverTable {
    constructor(thePtr: TPrsStd_DriverTable);
  }

  export declare class Handle_TPrsStd_DriverTable_3 extends Handle_TPrsStd_DriverTable {
    constructor(theHandle: Handle_TPrsStd_DriverTable);
  }

  export declare class Handle_TPrsStd_DriverTable_4 extends Handle_TPrsStd_DriverTable {
    constructor(theHandle: Handle_TPrsStd_DriverTable);
  }

export declare class TPrsStd_DriverTable extends Standard_Transient {
  constructor()
  static Get(): Handle_TPrsStd_DriverTable;
  InitStandardDrivers(): void;
  AddDriver(guid: Standard_GUID, driver: Handle_TPrsStd_Driver): Standard_Boolean;
  FindDriver(guid: Standard_GUID, driver: Handle_TPrsStd_Driver): Standard_Boolean;
  RemoveDriver(guid: Standard_GUID): Standard_Boolean;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type GeomAbs_CurveType = {
  GeomAbs_Line: {};
  GeomAbs_Circle: {};
  GeomAbs_Ellipse: {};
  GeomAbs_Hyperbola: {};
  GeomAbs_Parabola: {};
  GeomAbs_BezierCurve: {};
  GeomAbs_BSplineCurve: {};
  GeomAbs_OffsetCurve: {};
  GeomAbs_OtherCurve: {};
}

export declare type GeomAbs_BSplKnotDistribution = {
  GeomAbs_NonUniform: {};
  GeomAbs_Uniform: {};
  GeomAbs_QuasiUniform: {};
  GeomAbs_PiecewiseBezier: {};
}

export declare type GeomAbs_Shape = {
  GeomAbs_C0: {};
  GeomAbs_G1: {};
  GeomAbs_C1: {};
  GeomAbs_G2: {};
  GeomAbs_C2: {};
  GeomAbs_C3: {};
  GeomAbs_CN: {};
}

export declare type GeomAbs_JoinType = {
  GeomAbs_Arc: {};
  GeomAbs_Tangent: {};
  GeomAbs_Intersection: {};
}

export declare type GeomAbs_SurfaceType = {
  GeomAbs_Plane: {};
  GeomAbs_Cylinder: {};
  GeomAbs_Cone: {};
  GeomAbs_Sphere: {};
  GeomAbs_Torus: {};
  GeomAbs_BezierSurface: {};
  GeomAbs_BSplineSurface: {};
  GeomAbs_SurfaceOfRevolution: {};
  GeomAbs_SurfaceOfExtrusion: {};
  GeomAbs_OffsetSurface: {};
  GeomAbs_OtherSurface: {};
}

export declare type GeomAbs_IsoType = {
  GeomAbs_IsoU: {};
  GeomAbs_IsoV: {};
  GeomAbs_NoneIso: {};
}

export declare class Handle_Bisector_BisecCC {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bisector_BisecCC): void;
  get(): Bisector_BisecCC;
  delete(): void;
}

  export declare class Handle_Bisector_BisecCC_1 extends Handle_Bisector_BisecCC {
    constructor();
  }

  export declare class Handle_Bisector_BisecCC_2 extends Handle_Bisector_BisecCC {
    constructor(thePtr: Bisector_BisecCC);
  }

  export declare class Handle_Bisector_BisecCC_3 extends Handle_Bisector_BisecCC {
    constructor(theHandle: Handle_Bisector_BisecCC);
  }

  export declare class Handle_Bisector_BisecCC_4 extends Handle_Bisector_BisecCC {
    constructor(theHandle: Handle_Bisector_BisecCC);
  }

export declare class Bisector_BisecCC extends Bisector_Curve {
  Perform(Cu1: Handle_Geom2d_Curve, Cu2: Handle_Geom2d_Curve, Side1: Quantity_AbsorbedDose, Side2: Quantity_AbsorbedDose, Origin: gp_Pnt2d, DistMax: Quantity_AbsorbedDose): void;
  IsExtendAtStart(): Standard_Boolean;
  IsExtendAtEnd(): Standard_Boolean;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  ChangeGuide(): Handle_Bisector_BisecCC;
  Copy(): Handle_Geom2d_Geometry;
  Transform(T: gp_Trsf2d): void;
  FirstParameter_1(): Quantity_AbsorbedDose;
  LastParameter_1(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(): Graphic3d_ZLayerId;
  IntervalFirst(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IntervalLast(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IntervalContinuity(): GeomAbs_Shape;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  ValueAndDist(U: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Distance: Quantity_AbsorbedDose): gp_Pnt2d;
  ValueByInt(U: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Distance: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  IsEmpty_1(): Standard_Boolean;
  LinkBisCurve(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  LinkCurveBis(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Parameter(P: gp_Pnt2d): Quantity_AbsorbedDose;
  Curve_1(IndCurve: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  Polygon_1(): Bisector_PolyBis;
  Dump(Deep: Graphic3d_ZLayerId, Offset: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Bisector_BisecCC_1 extends Bisector_BisecCC {
    constructor();
  }

  export declare class Bisector_BisecCC_2 extends Bisector_BisecCC {
    constructor(Cu1: Handle_Geom2d_Curve, Cu2: Handle_Geom2d_Curve, Side1: Quantity_AbsorbedDose, Side2: Quantity_AbsorbedDose, Origin: gp_Pnt2d, DistMax: Quantity_AbsorbedDose);
  }

export declare class Bisector_BisecAna extends Bisector_Curve {
  constructor()
  Perform_1(Cu1: Handle_Geom2d_Curve, Cu2: Handle_Geom2d_Curve, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, jointype: GeomAbs_JoinType, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Perform_2(Cu: Handle_Geom2d_Curve, Pnt: Handle_Geom2d_Point, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Perform_3(Pnt: Handle_Geom2d_Point, Cu: Handle_Geom2d_Curve, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Perform_4(Pnt1: Handle_Geom2d_Point, Pnt2: Handle_Geom2d_Point, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Init(bisector: Handle_Geom2d_TrimmedCurve): void;
  IsExtendAtStart(): Standard_Boolean;
  IsExtendAtEnd(): Standard_Boolean;
  SetTrim_1(Cu: Handle_Geom2d_Curve): void;
  SetTrim_2(uf: Quantity_AbsorbedDose, ul: Quantity_AbsorbedDose): void;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  Copy(): Handle_Geom2d_Geometry;
  Transform(T: gp_Trsf2d): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Geom2dCurve(): Handle_Geom2d_Curve;
  Parameter(P: gp_Pnt2d): Quantity_AbsorbedDose;
  ParameterOfStartPoint(): Quantity_AbsorbedDose;
  ParameterOfEndPoint(): Quantity_AbsorbedDose;
  NbIntervals(): Graphic3d_ZLayerId;
  IntervalFirst(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IntervalLast(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Dump(Deep: Graphic3d_ZLayerId, Offset: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Bisector_BisecAna {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bisector_BisecAna): void;
  get(): Bisector_BisecAna;
  delete(): void;
}

  export declare class Handle_Bisector_BisecAna_1 extends Handle_Bisector_BisecAna {
    constructor();
  }

  export declare class Handle_Bisector_BisecAna_2 extends Handle_Bisector_BisecAna {
    constructor(thePtr: Bisector_BisecAna);
  }

  export declare class Handle_Bisector_BisecAna_3 extends Handle_Bisector_BisecAna {
    constructor(theHandle: Handle_Bisector_BisecAna);
  }

  export declare class Handle_Bisector_BisecAna_4 extends Handle_Bisector_BisecAna {
    constructor(theHandle: Handle_Bisector_BisecAna);
  }

export declare class Bisector_FunctionInter extends math_FunctionWithDerivative {
  Perform(C: Handle_Geom2d_Curve, Bis1: Handle_Bisector_Curve, Bis2: Handle_Bisector_Curve): void;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class Bisector_FunctionInter_1 extends Bisector_FunctionInter {
    constructor();
  }

  export declare class Bisector_FunctionInter_2 extends Bisector_FunctionInter {
    constructor(C: Handle_Geom2d_Curve, Bis1: Handle_Bisector_Curve, Bis2: Handle_Bisector_Curve);
  }

export declare class Bisector {
  constructor();
  static IsConvex(Cu: Handle_Geom2d_Curve, Sign: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Bisector_FunctionH extends math_FunctionWithDerivative {
  constructor(C2: Handle_Geom2d_Curve, P1: gp_Pnt2d, T1: gp_Vec2d)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Bisector_Bisec {
  constructor()
  Perform_1(Cu1: Handle_Geom2d_Curve, Cu2: Handle_Geom2d_Curve, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, ajointype: GeomAbs_JoinType, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Perform_2(Cu: Handle_Geom2d_Curve, Pnt: Handle_Geom2d_Point, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Perform_3(Pnt: Handle_Geom2d_Point, Cu: Handle_Geom2d_Curve, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Perform_4(Pnt1: Handle_Geom2d_Point, Pnt2: Handle_Geom2d_Point, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, Sense: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, oncurve: Standard_Boolean): void;
  Value(): Handle_Geom2d_TrimmedCurve;
  ChangeValue(): Handle_Geom2d_TrimmedCurve;
  delete(): void;
}

export declare class Bisector_Inter extends IntRes2d_Intersection {
  Perform(C1: Bisector_Bisec, D1: IntRes2d_Domain, C2: Bisector_Bisec, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, ComunElement: Standard_Boolean): void;
  delete(): void;
}

  export declare class Bisector_Inter_1 extends Bisector_Inter {
    constructor();
  }

  export declare class Bisector_Inter_2 extends Bisector_Inter {
    constructor(C1: Bisector_Bisec, D1: IntRes2d_Domain, C2: Bisector_Bisec, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, ComunElement: Standard_Boolean);
  }

export declare class Bisector_BisecPC extends Bisector_Curve {
  Perform(Cu: Handle_Geom2d_Curve, P: gp_Pnt2d, Side: Quantity_AbsorbedDose, DistMax: Quantity_AbsorbedDose): void;
  IsExtendAtStart(): Standard_Boolean;
  IsExtendAtEnd(): Standard_Boolean;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Copy(): Handle_Geom2d_Geometry;
  Transform(T: gp_Trsf2d): void;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(): Graphic3d_ZLayerId;
  IntervalFirst(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IntervalLast(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IntervalContinuity(): GeomAbs_Shape;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Distance(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Dump(Deep: Graphic3d_ZLayerId, Offset: Graphic3d_ZLayerId): void;
  LinkBisCurve(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  LinkCurveBis(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Parameter(P: gp_Pnt2d): Quantity_AbsorbedDose;
  IsEmpty(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Bisector_BisecPC_1 extends Bisector_BisecPC {
    constructor();
  }

  export declare class Bisector_BisecPC_2 extends Bisector_BisecPC {
    constructor(Cu: Handle_Geom2d_Curve, P: gp_Pnt2d, Side: Quantity_AbsorbedDose, DistMax: Quantity_AbsorbedDose);
  }

  export declare class Bisector_BisecPC_3 extends Bisector_BisecPC {
    constructor(Cu: Handle_Geom2d_Curve, P: gp_Pnt2d, Side: Quantity_AbsorbedDose, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose);
  }

export declare class Handle_Bisector_BisecPC {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bisector_BisecPC): void;
  get(): Bisector_BisecPC;
  delete(): void;
}

  export declare class Handle_Bisector_BisecPC_1 extends Handle_Bisector_BisecPC {
    constructor();
  }

  export declare class Handle_Bisector_BisecPC_2 extends Handle_Bisector_BisecPC {
    constructor(thePtr: Bisector_BisecPC);
  }

  export declare class Handle_Bisector_BisecPC_3 extends Handle_Bisector_BisecPC {
    constructor(theHandle: Handle_Bisector_BisecPC);
  }

  export declare class Handle_Bisector_BisecPC_4 extends Handle_Bisector_BisecPC {
    constructor(theHandle: Handle_Bisector_BisecPC);
  }

export declare class Bisector_PolyBis {
  constructor()
  Append(Point: Bisector_PointOnBis): void;
  Length(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Value(Index: Graphic3d_ZLayerId): Bisector_PointOnBis;
  First(): Bisector_PointOnBis;
  Last(): Bisector_PointOnBis;
  Interval(U: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Transform(T: gp_Trsf2d): void;
  delete(): void;
}

export declare class Handle_Bisector_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bisector_Curve): void;
  get(): Bisector_Curve;
  delete(): void;
}

  export declare class Handle_Bisector_Curve_1 extends Handle_Bisector_Curve {
    constructor();
  }

  export declare class Handle_Bisector_Curve_2 extends Handle_Bisector_Curve {
    constructor(thePtr: Bisector_Curve);
  }

  export declare class Handle_Bisector_Curve_3 extends Handle_Bisector_Curve {
    constructor(theHandle: Handle_Bisector_Curve);
  }

  export declare class Handle_Bisector_Curve_4 extends Handle_Bisector_Curve {
    constructor(theHandle: Handle_Bisector_Curve);
  }

export declare class Bisector_Curve extends Geom2d_Curve {
  Parameter(P: gp_Pnt2d): Quantity_AbsorbedDose;
  IsExtendAtStart(): Standard_Boolean;
  IsExtendAtEnd(): Standard_Boolean;
  NbIntervals(): Graphic3d_ZLayerId;
  IntervalFirst(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IntervalLast(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Bisector_PointOnBis {
  ParamOnC1_1(Param: Quantity_AbsorbedDose): void;
  ParamOnC2_1(Param: Quantity_AbsorbedDose): void;
  ParamOnBis_1(Param: Quantity_AbsorbedDose): void;
  Distance_1(Distance: Quantity_AbsorbedDose): void;
  IsInfinite_1(Infinite: Standard_Boolean): void;
  Point_1(P: gp_Pnt2d): void;
  ParamOnC1_2(): Quantity_AbsorbedDose;
  ParamOnC2_2(): Quantity_AbsorbedDose;
  ParamOnBis_2(): Quantity_AbsorbedDose;
  Distance_2(): Quantity_AbsorbedDose;
  Point_2(): gp_Pnt2d;
  IsInfinite_2(): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

  export declare class Bisector_PointOnBis_1 extends Bisector_PointOnBis {
    constructor();
  }

  export declare class Bisector_PointOnBis_2 extends Bisector_PointOnBis {
    constructor(Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, ParamBis: Quantity_AbsorbedDose, Distance: Quantity_AbsorbedDose, Point: gp_Pnt2d);
  }

export declare class Geom2dAPI_InterCurveCurve {
  Init_1(C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): void;
  Init_2(C1: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(Index: Graphic3d_ZLayerId, Curve1: Handle_Geom2d_Curve, Curve2: Handle_Geom2d_Curve): void;
  Intersector(): Geom2dInt_GInter;
  delete(): void;
}

  export declare class Geom2dAPI_InterCurveCurve_1 extends Geom2dAPI_InterCurveCurve {
    constructor();
  }

  export declare class Geom2dAPI_InterCurveCurve_2 extends Geom2dAPI_InterCurveCurve {
    constructor(C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dAPI_InterCurveCurve_3 extends Geom2dAPI_InterCurveCurve {
    constructor(C1: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose);
  }

export declare class Geom2dAPI_Interpolate {
  Load_1(InitialTangent: gp_Vec2d, FinalTangent: gp_Vec2d, Scale: Standard_Boolean): void;
  Load_2(Tangents: TColgp_Array1OfVec2d, TangentFlags: Handle_TColStd_HArray1OfBoolean, Scale: Standard_Boolean): void;
  Perform(): void;
  Curve(): Handle_Geom2d_BSplineCurve;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dAPI_Interpolate_1 extends Geom2dAPI_Interpolate {
    constructor(Points: Handle_TColgp_HArray1OfPnt2d, PeriodicFlag: Standard_Boolean, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dAPI_Interpolate_2 extends Geom2dAPI_Interpolate {
    constructor(Points: Handle_TColgp_HArray1OfPnt2d, Parameters: Handle_TColStd_HArray1OfReal, PeriodicFlag: Standard_Boolean, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dAPI_ProjectPointOnCurve {
  Init_1(P: gp_Pnt2d, Curve: Handle_Geom2d_Curve): void;
  Init_2(P: gp_Pnt2d, Curve: Handle_Geom2d_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  Parameter_1(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Parameter_2(Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoint(): gp_Pnt2d;
  LowerDistanceParameter(): Quantity_AbsorbedDose;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtPC2d;
  delete(): void;
}

  export declare class Geom2dAPI_ProjectPointOnCurve_1 extends Geom2dAPI_ProjectPointOnCurve {
    constructor();
  }

  export declare class Geom2dAPI_ProjectPointOnCurve_2 extends Geom2dAPI_ProjectPointOnCurve {
    constructor(P: gp_Pnt2d, Curve: Handle_Geom2d_Curve);
  }

  export declare class Geom2dAPI_ProjectPointOnCurve_3 extends Geom2dAPI_ProjectPointOnCurve {
    constructor(P: gp_Pnt2d, Curve: Handle_Geom2d_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

export declare class Geom2dAPI_PointsToBSpline {
  Init_1(Points: TColgp_Array1OfPnt2d, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose): void;
  Init_2(YValues: TColStd_Array1OfReal, X0: Quantity_AbsorbedDose, DX: Quantity_AbsorbedDose, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose): void;
  Init_3(Points: TColgp_Array1OfPnt2d, ParType: Approx_ParametrizationType, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose): void;
  Init_4(Points: TColgp_Array1OfPnt2d, Parameters: TColStd_Array1OfReal, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose): void;
  Init_5(Points: TColgp_Array1OfPnt2d, Weight1: Quantity_AbsorbedDose, Weight2: Quantity_AbsorbedDose, Weight3: Quantity_AbsorbedDose, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose): void;
  Curve(): Handle_Geom2d_BSplineCurve;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dAPI_PointsToBSpline_1 extends Geom2dAPI_PointsToBSpline {
    constructor();
  }

  export declare class Geom2dAPI_PointsToBSpline_2 extends Geom2dAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt2d, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose);
  }

  export declare class Geom2dAPI_PointsToBSpline_3 extends Geom2dAPI_PointsToBSpline {
    constructor(YValues: TColStd_Array1OfReal, X0: Quantity_AbsorbedDose, DX: Quantity_AbsorbedDose, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose);
  }

  export declare class Geom2dAPI_PointsToBSpline_4 extends Geom2dAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt2d, ParType: Approx_ParametrizationType, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose);
  }

  export declare class Geom2dAPI_PointsToBSpline_5 extends Geom2dAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt2d, Parameters: TColStd_Array1OfReal, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol2D: Quantity_AbsorbedDose);
  }

  export declare class Geom2dAPI_PointsToBSpline_6 extends Geom2dAPI_PointsToBSpline {
    constructor(Points: TColgp_Array1OfPnt2d, Weight1: Quantity_AbsorbedDose, Weight2: Quantity_AbsorbedDose, Weight3: Quantity_AbsorbedDose, DegMax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, Tol3D: Quantity_AbsorbedDose);
  }

export declare class Geom2dAPI_ExtremaCurveCurve {
  constructor(C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, U1min: Quantity_AbsorbedDose, U1max: Quantity_AbsorbedDose, U2min: Quantity_AbsorbedDose, U2max: Quantity_AbsorbedDose)
  NbExtrema(): Graphic3d_ZLayerId;
  Points(Index: Graphic3d_ZLayerId, P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Parameters(Index: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  Distance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NearestPoints(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  LowerDistanceParameters(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  LowerDistance(): Quantity_AbsorbedDose;
  Extrema(): Extrema_ExtCC2d;
  delete(): void;
}

export declare class RWStepAP242_RWItemIdentifiedRepresentationUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP242_ItemIdentifiedRepresentationUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP242_ItemIdentifiedRepresentationUsage): void;
  Share(ent: Handle_StepAP242_ItemIdentifiedRepresentationUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP242_RWDraughtingModelItemAssociation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP242_DraughtingModelItemAssociation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP242_DraughtingModelItemAssociation): void;
  Share(ent: Handle_StepAP242_DraughtingModelItemAssociation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP242_RWGeometricItemSpecificUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP242_GeometricItemSpecificUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP242_GeometricItemSpecificUsage): void;
  Share(ent: Handle_StepAP242_GeometricItemSpecificUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP242_RWIdAttribute {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP242_IdAttribute): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP242_IdAttribute): void;
  Share(ent: Handle_StepAP242_IdAttribute, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class Handle_IGESDefs_GenericData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_GenericData): void;
  get(): IGESDefs_GenericData;
  delete(): void;
}

  export declare class Handle_IGESDefs_GenericData_1 extends Handle_IGESDefs_GenericData {
    constructor();
  }

  export declare class Handle_IGESDefs_GenericData_2 extends Handle_IGESDefs_GenericData {
    constructor(thePtr: IGESDefs_GenericData);
  }

  export declare class Handle_IGESDefs_GenericData_3 extends Handle_IGESDefs_GenericData {
    constructor(theHandle: Handle_IGESDefs_GenericData);
  }

  export declare class Handle_IGESDefs_GenericData_4 extends Handle_IGESDefs_GenericData {
    constructor(theHandle: Handle_IGESDefs_GenericData);
  }

export declare class IGESDefs_GenericData extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aName: Handle_TCollection_HAsciiString, allTypes: Handle_TColStd_HArray1OfInteger, allValues: Handle_TColStd_HArray1OfTransient): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  Name(): Handle_TCollection_HAsciiString;
  NbTypeValuePairs(): Graphic3d_ZLayerId;
  Type(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): Handle_Standard_Transient;
  ValueAsInteger(ValueNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ValueAsReal(ValueNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ValueAsString(ValueNum: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  ValueAsEntity(ValueNum: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  ValueAsLogical(ValueNum: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDefs_ToolMacroDef {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_MacroDef, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_MacroDef, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_MacroDef, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_MacroDef): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_MacroDef, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_MacroDef, entto: Handle_IGESDefs_MacroDef, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_MacroDef, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDefs_AttributeDef extends IGESData_IGESEntity {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aListType: Graphic3d_ZLayerId, attrTypes: Handle_TColStd_HArray1OfInteger, attrValueDataTypes: Handle_TColStd_HArray1OfInteger, attrValueCounts: Handle_TColStd_HArray1OfInteger, attrValues: Handle_TColStd_HArray1OfTransient, attrValuePointers: Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate): void;
  HasTableName(): Standard_Boolean;
  TableName(): Handle_TCollection_HAsciiString;
  ListType(): Graphic3d_ZLayerId;
  NbAttributes(): Graphic3d_ZLayerId;
  AttributeType(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AttributeValueDataType(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AttributeValueCount(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  HasValues(): Standard_Boolean;
  HasTextDisplay(): Standard_Boolean;
  AttributeTextDisplay(AttrNum: Graphic3d_ZLayerId, PointerNum: Graphic3d_ZLayerId): Handle_IGESGraph_TextDisplayTemplate;
  AttributeList(AttrNum: Graphic3d_ZLayerId): Handle_Standard_Transient;
  AttributeAsInteger(AttrNum: Graphic3d_ZLayerId, ValueNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AttributeAsReal(AttrNum: Graphic3d_ZLayerId, ValueNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  AttributeAsString(AttrNum: Graphic3d_ZLayerId, ValueNum: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  AttributeAsEntity(AttrNum: Graphic3d_ZLayerId, ValueNum: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  AttributeAsLogical(AttrNum: Graphic3d_ZLayerId, ValueNum: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_AttributeDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_AttributeDef): void;
  get(): IGESDefs_AttributeDef;
  delete(): void;
}

  export declare class Handle_IGESDefs_AttributeDef_1 extends Handle_IGESDefs_AttributeDef {
    constructor();
  }

  export declare class Handle_IGESDefs_AttributeDef_2 extends Handle_IGESDefs_AttributeDef {
    constructor(thePtr: IGESDefs_AttributeDef);
  }

  export declare class Handle_IGESDefs_AttributeDef_3 extends Handle_IGESDefs_AttributeDef {
    constructor(theHandle: Handle_IGESDefs_AttributeDef);
  }

  export declare class Handle_IGESDefs_AttributeDef_4 extends Handle_IGESDefs_AttributeDef {
    constructor(theHandle: Handle_IGESDefs_AttributeDef);
  }

export declare class IGESDefs_ToolAttributeDef {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_AttributeDef, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_AttributeDef, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_AttributeDef, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_AttributeDef): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_AttributeDef, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_AttributeDef, entto: Handle_IGESDefs_AttributeDef, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_AttributeDef, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_HArray1OfHArray1OfTextDisplayTemplate): void;
  get(): IGESDefs_HArray1OfHArray1OfTextDisplayTemplate;
  delete(): void;
}

  export declare class Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_1 extends Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate {
    constructor();
  }

  export declare class Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_2 extends Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate {
    constructor(thePtr: IGESDefs_HArray1OfHArray1OfTextDisplayTemplate);
  }

  export declare class Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_3 extends Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate {
    constructor(theHandle: Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate);
  }

  export declare class Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_4 extends Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate {
    constructor(theHandle: Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate);
  }

export declare class IGESDefs_HArray1OfHArray1OfTextDisplayTemplate extends Standard_Transient {
  constructor(low: Graphic3d_ZLayerId, up: Graphic3d_ZLayerId)
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_IGESGraph_HArray1OfTextDisplayTemplate): void;
  Value(num: Graphic3d_ZLayerId): Handle_IGESGraph_HArray1OfTextDisplayTemplate;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_ReadWriteModule): void;
  get(): IGESDefs_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESDefs_ReadWriteModule_1 extends Handle_IGESDefs_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESDefs_ReadWriteModule_2 extends Handle_IGESDefs_ReadWriteModule {
    constructor(thePtr: IGESDefs_ReadWriteModule);
  }

  export declare class Handle_IGESDefs_ReadWriteModule_3 extends Handle_IGESDefs_ReadWriteModule {
    constructor(theHandle: Handle_IGESDefs_ReadWriteModule);
  }

  export declare class Handle_IGESDefs_ReadWriteModule_4 extends Handle_IGESDefs_ReadWriteModule {
    constructor(theHandle: Handle_IGESDefs_ReadWriteModule);
  }

export declare class IGESDefs_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_TabularData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_TabularData): void;
  get(): IGESDefs_TabularData;
  delete(): void;
}

  export declare class Handle_IGESDefs_TabularData_1 extends Handle_IGESDefs_TabularData {
    constructor();
  }

  export declare class Handle_IGESDefs_TabularData_2 extends Handle_IGESDefs_TabularData {
    constructor(thePtr: IGESDefs_TabularData);
  }

  export declare class Handle_IGESDefs_TabularData_3 extends Handle_IGESDefs_TabularData {
    constructor(theHandle: Handle_IGESDefs_TabularData);
  }

  export declare class Handle_IGESDefs_TabularData_4 extends Handle_IGESDefs_TabularData {
    constructor(theHandle: Handle_IGESDefs_TabularData);
  }

export declare class IGESDefs_TabularData extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, propType: Graphic3d_ZLayerId, typesInd: Handle_TColStd_HArray1OfInteger, nbValuesInd: Handle_TColStd_HArray1OfInteger, valuesInd: Handle_IGESBasic_HArray1OfHArray1OfReal, valuesDep: Handle_IGESBasic_HArray1OfHArray1OfReal): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  ComputedNbPropertyValues(): Graphic3d_ZLayerId;
  OwnCorrect(): Standard_Boolean;
  PropertyType(): Graphic3d_ZLayerId;
  NbDependents(): Graphic3d_ZLayerId;
  NbIndependents(): Graphic3d_ZLayerId;
  TypeOfIndependents(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbValues(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IndependentValue(variablenum: Graphic3d_ZLayerId, valuenum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  DependentValues(num: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  DependentValue(variablenum: Graphic3d_ZLayerId, valuenum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDefs_MacroDef extends IGESData_IGESEntity {
  constructor()
  Init(macro: Handle_TCollection_HAsciiString, entityTypeID: Graphic3d_ZLayerId, langStatements: Handle_Interface_HArray1OfHAsciiString, endMacro: Handle_TCollection_HAsciiString): void;
  NbStatements(): Graphic3d_ZLayerId;
  MACRO(): Handle_TCollection_HAsciiString;
  EntityTypeID(): Graphic3d_ZLayerId;
  LanguageStatement(StatNum: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  ENDMACRO(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_MacroDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_MacroDef): void;
  get(): IGESDefs_MacroDef;
  delete(): void;
}

  export declare class Handle_IGESDefs_MacroDef_1 extends Handle_IGESDefs_MacroDef {
    constructor();
  }

  export declare class Handle_IGESDefs_MacroDef_2 extends Handle_IGESDefs_MacroDef {
    constructor(thePtr: IGESDefs_MacroDef);
  }

  export declare class Handle_IGESDefs_MacroDef_3 extends Handle_IGESDefs_MacroDef {
    constructor(theHandle: Handle_IGESDefs_MacroDef);
  }

  export declare class Handle_IGESDefs_MacroDef_4 extends Handle_IGESDefs_MacroDef {
    constructor(theHandle: Handle_IGESDefs_MacroDef);
  }

export declare class IGESDefs_ToolAssociativityDef {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_AssociativityDef, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_AssociativityDef, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_AssociativityDef, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_AssociativityDef): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_AssociativityDef, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_AssociativityDef, entto: Handle_IGESDefs_AssociativityDef, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_AssociativityDef, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDefs_ToolUnitsData {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_UnitsData, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_UnitsData, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_UnitsData, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_UnitsData): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_UnitsData, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_UnitsData, entto: Handle_IGESDefs_UnitsData, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_UnitsData, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDefs_AttributeTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_AttributeTable): void;
  get(): IGESDefs_AttributeTable;
  delete(): void;
}

  export declare class Handle_IGESDefs_AttributeTable_1 extends Handle_IGESDefs_AttributeTable {
    constructor();
  }

  export declare class Handle_IGESDefs_AttributeTable_2 extends Handle_IGESDefs_AttributeTable {
    constructor(thePtr: IGESDefs_AttributeTable);
  }

  export declare class Handle_IGESDefs_AttributeTable_3 extends Handle_IGESDefs_AttributeTable {
    constructor(theHandle: Handle_IGESDefs_AttributeTable);
  }

  export declare class Handle_IGESDefs_AttributeTable_4 extends Handle_IGESDefs_AttributeTable {
    constructor(theHandle: Handle_IGESDefs_AttributeTable);
  }

export declare class IGESDefs_AttributeTable extends IGESData_IGESEntity {
  constructor()
  Init(attributes: Handle_TColStd_HArray2OfTransient): void;
  SetDefinition(def: Handle_IGESDefs_AttributeDef): void;
  Definition(): Handle_IGESDefs_AttributeDef;
  NbRows(): Graphic3d_ZLayerId;
  NbAttributes(): Graphic3d_ZLayerId;
  DataType(Atnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ValueCount(Atnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AttributeList(Attribnum: Graphic3d_ZLayerId, Rownum: Graphic3d_ZLayerId): Handle_Standard_Transient;
  AttributeAsInteger(AtNum: Graphic3d_ZLayerId, Rownum: Graphic3d_ZLayerId, ValNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  AttributeAsReal(AtNum: Graphic3d_ZLayerId, Rownum: Graphic3d_ZLayerId, ValNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  AttributeAsString(AtNum: Graphic3d_ZLayerId, Rownum: Graphic3d_ZLayerId, ValNum: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  AttributeAsEntity(AtNum: Graphic3d_ZLayerId, Rownum: Graphic3d_ZLayerId, ValNum: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  AttributeAsLogical(AtNum: Graphic3d_ZLayerId, Rownum: Graphic3d_ZLayerId, ValNum: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDefs {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESDefs_Protocol;
  delete(): void;
}

export declare class IGESDefs_ToolAttributeTable {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_AttributeTable, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_AttributeTable, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_AttributeTable, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_AttributeTable): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_AttributeTable, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_AttributeTable, entto: Handle_IGESDefs_AttributeTable, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_AttributeTable, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDefs_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_SpecificModule): void;
  get(): IGESDefs_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESDefs_SpecificModule_1 extends Handle_IGESDefs_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESDefs_SpecificModule_2 extends Handle_IGESDefs_SpecificModule {
    constructor(thePtr: IGESDefs_SpecificModule);
  }

  export declare class Handle_IGESDefs_SpecificModule_3 extends Handle_IGESDefs_SpecificModule {
    constructor(theHandle: Handle_IGESDefs_SpecificModule);
  }

  export declare class Handle_IGESDefs_SpecificModule_4 extends Handle_IGESDefs_SpecificModule {
    constructor(theHandle: Handle_IGESDefs_SpecificModule);
  }

export declare class Handle_IGESDefs_UnitsData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_UnitsData): void;
  get(): IGESDefs_UnitsData;
  delete(): void;
}

  export declare class Handle_IGESDefs_UnitsData_1 extends Handle_IGESDefs_UnitsData {
    constructor();
  }

  export declare class Handle_IGESDefs_UnitsData_2 extends Handle_IGESDefs_UnitsData {
    constructor(thePtr: IGESDefs_UnitsData);
  }

  export declare class Handle_IGESDefs_UnitsData_3 extends Handle_IGESDefs_UnitsData {
    constructor(theHandle: Handle_IGESDefs_UnitsData);
  }

  export declare class Handle_IGESDefs_UnitsData_4 extends Handle_IGESDefs_UnitsData {
    constructor(theHandle: Handle_IGESDefs_UnitsData);
  }

export declare class IGESDefs_UnitsData extends IGESData_IGESEntity {
  constructor()
  Init(unitTypes: Handle_Interface_HArray1OfHAsciiString, unitValues: Handle_Interface_HArray1OfHAsciiString, unitScales: Handle_TColStd_HArray1OfReal): void;
  NbUnits(): Graphic3d_ZLayerId;
  UnitType(UnitNum: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  UnitValue(UnitNum: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  ScaleFactor(UnitNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_AssociativityDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_AssociativityDef): void;
  get(): IGESDefs_AssociativityDef;
  delete(): void;
}

  export declare class Handle_IGESDefs_AssociativityDef_1 extends Handle_IGESDefs_AssociativityDef {
    constructor();
  }

  export declare class Handle_IGESDefs_AssociativityDef_2 extends Handle_IGESDefs_AssociativityDef {
    constructor(thePtr: IGESDefs_AssociativityDef);
  }

  export declare class Handle_IGESDefs_AssociativityDef_3 extends Handle_IGESDefs_AssociativityDef {
    constructor(theHandle: Handle_IGESDefs_AssociativityDef);
  }

  export declare class Handle_IGESDefs_AssociativityDef_4 extends Handle_IGESDefs_AssociativityDef {
    constructor(theHandle: Handle_IGESDefs_AssociativityDef);
  }

export declare class IGESDefs_AssociativityDef extends IGESData_IGESEntity {
  constructor()
  Init(requirements: Handle_TColStd_HArray1OfInteger, orders: Handle_TColStd_HArray1OfInteger, numItems: Handle_TColStd_HArray1OfInteger, items: Handle_IGESBasic_HArray1OfHArray1OfInteger): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  NbClassDefs(): Graphic3d_ZLayerId;
  IsBackPointerReq(ClassNum: Graphic3d_ZLayerId): Standard_Boolean;
  BackPointerReq(ClassNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsOrdered(ClassNum: Graphic3d_ZLayerId): Standard_Boolean;
  ClassOrder(ClassNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbItemsPerClass(ClassNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Item(ClassNum: Graphic3d_ZLayerId, ItemNum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDefs_ToolGenericData {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_GenericData, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_GenericData, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_GenericData, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_GenericData): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_GenericData, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_GenericData, entto: Handle_IGESDefs_GenericData, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_GenericData, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDefs_ToolTabularData {
  constructor()
  ReadOwnParams(ent: Handle_IGESDefs_TabularData, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDefs_TabularData, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDefs_TabularData, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDefs_TabularData): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDefs_TabularData, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDefs_TabularData, entto: Handle_IGESDefs_TabularData, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDefs_TabularData, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDefs_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_Protocol): void;
  get(): IGESDefs_Protocol;
  delete(): void;
}

  export declare class Handle_IGESDefs_Protocol_1 extends Handle_IGESDefs_Protocol {
    constructor();
  }

  export declare class Handle_IGESDefs_Protocol_2 extends Handle_IGESDefs_Protocol {
    constructor(thePtr: IGESDefs_Protocol);
  }

  export declare class Handle_IGESDefs_Protocol_3 extends Handle_IGESDefs_Protocol {
    constructor(theHandle: Handle_IGESDefs_Protocol);
  }

  export declare class Handle_IGESDefs_Protocol_4 extends Handle_IGESDefs_Protocol {
    constructor(theHandle: Handle_IGESDefs_Protocol);
  }

export declare class IGESDefs_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDefs_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_GeneralModule): void;
  get(): IGESDefs_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESDefs_GeneralModule_1 extends Handle_IGESDefs_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESDefs_GeneralModule_2 extends Handle_IGESDefs_GeneralModule {
    constructor(thePtr: IGESDefs_GeneralModule);
  }

  export declare class Handle_IGESDefs_GeneralModule_3 extends Handle_IGESDefs_GeneralModule {
    constructor(theHandle: Handle_IGESDefs_GeneralModule);
  }

  export declare class Handle_IGESDefs_GeneralModule_4 extends Handle_IGESDefs_GeneralModule {
    constructor(theHandle: Handle_IGESDefs_GeneralModule);
  }

export declare class Handle_IGESDefs_HArray1OfTabularData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDefs_HArray1OfTabularData): void;
  get(): IGESDefs_HArray1OfTabularData;
  delete(): void;
}

  export declare class Handle_IGESDefs_HArray1OfTabularData_1 extends Handle_IGESDefs_HArray1OfTabularData {
    constructor();
  }

  export declare class Handle_IGESDefs_HArray1OfTabularData_2 extends Handle_IGESDefs_HArray1OfTabularData {
    constructor(thePtr: IGESDefs_HArray1OfTabularData);
  }

  export declare class Handle_IGESDefs_HArray1OfTabularData_3 extends Handle_IGESDefs_HArray1OfTabularData {
    constructor(theHandle: Handle_IGESDefs_HArray1OfTabularData);
  }

  export declare class Handle_IGESDefs_HArray1OfTabularData_4 extends Handle_IGESDefs_HArray1OfTabularData {
    constructor(theHandle: Handle_IGESDefs_HArray1OfTabularData);
  }

export declare class IntCurveSurface_TheCSFunctionOfHInter extends math_FunctionSetWithDerivatives {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Point(): gp_Pnt;
  Root(): Quantity_AbsorbedDose;
  AuxillarSurface(): Handle_Adaptor3d_HSurface;
  AuxillarCurve(): Handle_Adaptor3d_HCurve;
  delete(): void;
}

export declare class IntCurveSurface_IntersectionSegment {
  SetValues(P1: IntCurveSurface_IntersectionPoint, P2: IntCurveSurface_IntersectionPoint): void;
  Values(P1: IntCurveSurface_IntersectionPoint, P2: IntCurveSurface_IntersectionPoint): void;
  FirstPoint_1(P1: IntCurveSurface_IntersectionPoint): void;
  SecondPoint_1(P2: IntCurveSurface_IntersectionPoint): void;
  FirstPoint_2(): IntCurveSurface_IntersectionPoint;
  SecondPoint_2(): IntCurveSurface_IntersectionPoint;
  Dump(): void;
  delete(): void;
}

  export declare class IntCurveSurface_IntersectionSegment_1 extends IntCurveSurface_IntersectionSegment {
    constructor();
  }

  export declare class IntCurveSurface_IntersectionSegment_2 extends IntCurveSurface_IntersectionSegment {
    constructor(P1: IntCurveSurface_IntersectionPoint, P2: IntCurveSurface_IntersectionPoint);
  }

export declare class IntCurveSurface_TheExactHInter {
  Perform(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Rsnld: math_FunctionSetRoot, u0: Quantity_AbsorbedDose, v0: Quantity_AbsorbedDose, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, w0: Quantity_AbsorbedDose, w1: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Point(): gp_Pnt;
  ParameterOnCurve(): Quantity_AbsorbedDose;
  ParameterOnSurface(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Function(): IntCurveSurface_TheCSFunctionOfHInter;
  delete(): void;
}

  export declare class IntCurveSurface_TheExactHInter_1 extends IntCurveSurface_TheExactHInter {
    constructor(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, F: IntCurveSurface_TheCSFunctionOfHInter, TolTangency: Quantity_AbsorbedDose, MarginCoef: Quantity_AbsorbedDose);
  }

  export declare class IntCurveSurface_TheExactHInter_2 extends IntCurveSurface_TheExactHInter {
    constructor(F: IntCurveSurface_TheCSFunctionOfHInter, TolTangency: Quantity_AbsorbedDose);
  }

export declare class IntCurveSurface_SequenceOfSeg extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntCurveSurface_SequenceOfSeg): IntCurveSurface_SequenceOfSeg;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntCurveSurface_IntersectionSegment): void;
  Append_2(theSeq: IntCurveSurface_SequenceOfSeg): void;
  Prepend_1(theItem: IntCurveSurface_IntersectionSegment): void;
  Prepend_2(theSeq: IntCurveSurface_SequenceOfSeg): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntCurveSurface_IntersectionSegment): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntCurveSurface_SequenceOfSeg): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntCurveSurface_SequenceOfSeg): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntCurveSurface_IntersectionSegment): void;
  Split(theIndex: Standard_Integer, theSeq: IntCurveSurface_SequenceOfSeg): void;
  First(): IntCurveSurface_IntersectionSegment;
  ChangeFirst(): IntCurveSurface_IntersectionSegment;
  Last(): IntCurveSurface_IntersectionSegment;
  ChangeLast(): IntCurveSurface_IntersectionSegment;
  Value(theIndex: Standard_Integer): IntCurveSurface_IntersectionSegment;
  ChangeValue(theIndex: Standard_Integer): IntCurveSurface_IntersectionSegment;
  SetValue(theIndex: Standard_Integer, theItem: IntCurveSurface_IntersectionSegment): void;
  delete(): void;
}

  export declare class IntCurveSurface_SequenceOfSeg_1 extends IntCurveSurface_SequenceOfSeg {
    constructor();
  }

  export declare class IntCurveSurface_SequenceOfSeg_2 extends IntCurveSurface_SequenceOfSeg {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntCurveSurface_SequenceOfSeg_3 extends IntCurveSurface_SequenceOfSeg {
    constructor(theOther: IntCurveSurface_SequenceOfSeg);
  }

export declare class IntCurveSurface_TheQuadCurvFuncOfTheQuadCurvExactHInter extends math_FunctionWithDerivative {
  constructor(Q: IntSurf_Quadric, C: Handle_Adaptor3d_HCurve)
  Value(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(Param: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class IntCurveSurface_ThePolygonToolOfHInter {
  constructor();
  static Bounding(thePolygon: IntCurveSurface_ThePolygonOfHInter): Bnd_Box;
  static DeflectionOverEstimation(thePolygon: IntCurveSurface_ThePolygonOfHInter): Quantity_AbsorbedDose;
  static Closed(thePolygon: IntCurveSurface_ThePolygonOfHInter): Standard_Boolean;
  static NbSegments(thePolygon: IntCurveSurface_ThePolygonOfHInter): Graphic3d_ZLayerId;
  static BeginOfSeg(thePolygon: IntCurveSurface_ThePolygonOfHInter, Index: Graphic3d_ZLayerId): gp_Pnt;
  static EndOfSeg(thePolygon: IntCurveSurface_ThePolygonOfHInter, Index: Graphic3d_ZLayerId): gp_Pnt;
  static Dump(thePolygon: IntCurveSurface_ThePolygonOfHInter): void;
  delete(): void;
}

export declare class IntCurveSurface_ThePolyhedronToolOfHInter {
  constructor();
  static Bounding(thePolyh: IntCurveSurface_ThePolyhedronOfHInter): Bnd_Box;
  static ComponentsBounding(thePolyh: IntCurveSurface_ThePolyhedronOfHInter): Handle_Bnd_HArray1OfBox;
  static DeflectionOverEstimation(thePolyh: IntCurveSurface_ThePolyhedronOfHInter): Quantity_AbsorbedDose;
  static NbTriangles(thePolyh: IntCurveSurface_ThePolyhedronOfHInter): Graphic3d_ZLayerId;
  static Triangle(thePolyh: IntCurveSurface_ThePolyhedronOfHInter, Index: Graphic3d_ZLayerId, P1: Graphic3d_ZLayerId, P2: Graphic3d_ZLayerId, P3: Graphic3d_ZLayerId): void;
  static Point(thePolyh: IntCurveSurface_ThePolyhedronOfHInter, Index: Graphic3d_ZLayerId): gp_Pnt;
  static TriConnex(thePolyh: IntCurveSurface_ThePolyhedronOfHInter, Triang: Graphic3d_ZLayerId, Pivot: Graphic3d_ZLayerId, Pedge: Graphic3d_ZLayerId, TriCon: Graphic3d_ZLayerId, OtherP: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsOnBound(thePolyh: IntCurveSurface_ThePolyhedronOfHInter, Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId): Standard_Boolean;
  static GetBorderDeflection(thePolyh: IntCurveSurface_ThePolyhedronOfHInter): Quantity_AbsorbedDose;
  static Dump(thePolyh: IntCurveSurface_ThePolyhedronOfHInter): void;
  delete(): void;
}

export declare type IntCurveSurface_TransitionOnCurve = {
  IntCurveSurface_Tangent: {};
  IntCurveSurface_In: {};
  IntCurveSurface_Out: {};
}

export declare class IntCurveSurface_IntersectionPoint {
  SetValues(P: gp_Pnt, USurf: Quantity_AbsorbedDose, VSurf: Quantity_AbsorbedDose, UCurv: Quantity_AbsorbedDose, TrCurv: IntCurveSurface_TransitionOnCurve): void;
  Values(P: gp_Pnt, USurf: Quantity_AbsorbedDose, VSurf: Quantity_AbsorbedDose, UCurv: Quantity_AbsorbedDose, TrCurv: IntCurveSurface_TransitionOnCurve): void;
  Pnt(): gp_Pnt;
  U(): Quantity_AbsorbedDose;
  V(): Quantity_AbsorbedDose;
  W(): Quantity_AbsorbedDose;
  Transition(): IntCurveSurface_TransitionOnCurve;
  Dump(): void;
  delete(): void;
}

  export declare class IntCurveSurface_IntersectionPoint_1 extends IntCurveSurface_IntersectionPoint {
    constructor();
  }

  export declare class IntCurveSurface_IntersectionPoint_2 extends IntCurveSurface_IntersectionPoint {
    constructor(P: gp_Pnt, USurf: Quantity_AbsorbedDose, VSurf: Quantity_AbsorbedDose, UCurv: Quantity_AbsorbedDose, TrCurv: IntCurveSurface_TransitionOnCurve);
  }

export declare class IntCurveSurface_SequenceOfPnt extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntCurveSurface_SequenceOfPnt): IntCurveSurface_SequenceOfPnt;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntCurveSurface_IntersectionPoint): void;
  Append_2(theSeq: IntCurveSurface_SequenceOfPnt): void;
  Prepend_1(theItem: IntCurveSurface_IntersectionPoint): void;
  Prepend_2(theSeq: IntCurveSurface_SequenceOfPnt): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntCurveSurface_IntersectionPoint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntCurveSurface_SequenceOfPnt): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntCurveSurface_SequenceOfPnt): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntCurveSurface_IntersectionPoint): void;
  Split(theIndex: Standard_Integer, theSeq: IntCurveSurface_SequenceOfPnt): void;
  First(): IntCurveSurface_IntersectionPoint;
  ChangeFirst(): IntCurveSurface_IntersectionPoint;
  Last(): IntCurveSurface_IntersectionPoint;
  ChangeLast(): IntCurveSurface_IntersectionPoint;
  Value(theIndex: Standard_Integer): IntCurveSurface_IntersectionPoint;
  ChangeValue(theIndex: Standard_Integer): IntCurveSurface_IntersectionPoint;
  SetValue(theIndex: Standard_Integer, theItem: IntCurveSurface_IntersectionPoint): void;
  delete(): void;
}

  export declare class IntCurveSurface_SequenceOfPnt_1 extends IntCurveSurface_SequenceOfPnt {
    constructor();
  }

  export declare class IntCurveSurface_SequenceOfPnt_2 extends IntCurveSurface_SequenceOfPnt {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntCurveSurface_SequenceOfPnt_3 extends IntCurveSurface_SequenceOfPnt {
    constructor(theOther: IntCurveSurface_SequenceOfPnt);
  }

export declare class IntCurveSurface_ThePolygonOfHInter {
  Bounding(): Bnd_Box;
  DeflectionOverEstimation(): Quantity_AbsorbedDose;
  SetDeflectionOverEstimation(x: Quantity_AbsorbedDose): void;
  Closed_1(clos: Standard_Boolean): void;
  Closed_2(): Standard_Boolean;
  NbSegments(): Graphic3d_ZLayerId;
  BeginOfSeg(Index: Graphic3d_ZLayerId): gp_Pnt;
  EndOfSeg(Index: Graphic3d_ZLayerId): gp_Pnt;
  InfParameter(): Quantity_AbsorbedDose;
  SupParameter(): Quantity_AbsorbedDose;
  ApproxParamOnCurve(Index: Graphic3d_ZLayerId, ParamOnLine: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Dump(): void;
  delete(): void;
}

  export declare class IntCurveSurface_ThePolygonOfHInter_1 extends IntCurveSurface_ThePolygonOfHInter {
    constructor(Curve: Handle_Adaptor3d_HCurve, NbPnt: Graphic3d_ZLayerId);
  }

  export declare class IntCurveSurface_ThePolygonOfHInter_2 extends IntCurveSurface_ThePolygonOfHInter {
    constructor(Curve: Handle_Adaptor3d_HCurve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, NbPnt: Graphic3d_ZLayerId);
  }

  export declare class IntCurveSurface_ThePolygonOfHInter_3 extends IntCurveSurface_ThePolygonOfHInter {
    constructor(Curve: Handle_Adaptor3d_HCurve, Upars: TColStd_Array1OfReal);
  }

export declare class IntCurveSurface_TheInterferenceOfHInter extends Intf_Interference {
  Perform_1(thePolyg: IntCurveSurface_ThePolygonOfHInter, thePolyh: IntCurveSurface_ThePolyhedronOfHInter): void;
  Perform_2(theLin: gp_Lin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter): void;
  Perform_3(theLins: Intf_Array1OfLin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter): void;
  Perform_4(thePolyg: IntCurveSurface_ThePolygonOfHInter, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox): void;
  Perform_5(theLin: gp_Lin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox): void;
  Perform_6(theLins: Intf_Array1OfLin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox): void;
  Interference_1(thePolyg: IntCurveSurface_ThePolygonOfHInter, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox): void;
  Interference_2(thePolyg: IntCurveSurface_ThePolygonOfHInter, thePolyh: IntCurveSurface_ThePolyhedronOfHInter): void;
  delete(): void;
}

  export declare class IntCurveSurface_TheInterferenceOfHInter_1 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor();
  }

  export declare class IntCurveSurface_TheInterferenceOfHInter_2 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor(thePolyg: IntCurveSurface_ThePolygonOfHInter, thePolyh: IntCurveSurface_ThePolyhedronOfHInter);
  }

  export declare class IntCurveSurface_TheInterferenceOfHInter_3 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor(theLin: gp_Lin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter);
  }

  export declare class IntCurveSurface_TheInterferenceOfHInter_4 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor(theLins: Intf_Array1OfLin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter);
  }

  export declare class IntCurveSurface_TheInterferenceOfHInter_5 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor(thePolyg: IntCurveSurface_ThePolygonOfHInter, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox);
  }

  export declare class IntCurveSurface_TheInterferenceOfHInter_6 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor(theLin: gp_Lin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox);
  }

  export declare class IntCurveSurface_TheInterferenceOfHInter_7 extends IntCurveSurface_TheInterferenceOfHInter {
    constructor(theLins: Intf_Array1OfLin, thePolyh: IntCurveSurface_ThePolyhedronOfHInter, theBoundSB: Bnd_BoundSortBox);
  }

export declare class IntCurveSurface_HInter extends IntCurveSurface_Intersection {
  constructor()
  Perform_1(Curve: Handle_Adaptor3d_HCurve, Surface: Handle_Adaptor3d_HSurface): void;
  Perform_2(Curve: Handle_Adaptor3d_HCurve, Polygon: IntCurveSurface_ThePolygonOfHInter, Surface: Handle_Adaptor3d_HSurface): void;
  Perform_3(Curve: Handle_Adaptor3d_HCurve, ThePolygon: IntCurveSurface_ThePolygonOfHInter, Surface: Handle_Adaptor3d_HSurface, Polyhedron: IntCurveSurface_ThePolyhedronOfHInter): void;
  Perform_4(Curve: Handle_Adaptor3d_HCurve, ThePolygon: IntCurveSurface_ThePolygonOfHInter, Surface: Handle_Adaptor3d_HSurface, Polyhedron: IntCurveSurface_ThePolyhedronOfHInter, BndBSB: Bnd_BoundSortBox): void;
  Perform_5(Curve: Handle_Adaptor3d_HCurve, Surface: Handle_Adaptor3d_HSurface, Polyhedron: IntCurveSurface_ThePolyhedronOfHInter): void;
  delete(): void;
}

export declare class IntCurveSurface_TheHCurveTool {
  constructor();
  static FirstParameter(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static Continuity(C: Handle_Adaptor3d_HCurve): GeomAbs_Shape;
  static NbIntervals(C: Handle_Adaptor3d_HCurve, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Handle_Adaptor3d_HCurve, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static IsClosed(C: Handle_Adaptor3d_HCurve): Standard_Boolean;
  static IsPeriodic(C: Handle_Adaptor3d_HCurve): Standard_Boolean;
  static Period(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static Value(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose): gp_Pnt;
  static D0(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  static D2(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static DN(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static Resolution(C: Handle_Adaptor3d_HCurve, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Handle_Adaptor3d_HCurve): GeomAbs_CurveType;
  static Line(C: Handle_Adaptor3d_HCurve): gp_Lin;
  static Circle(C: Handle_Adaptor3d_HCurve): gp_Circ;
  static Ellipse(C: Handle_Adaptor3d_HCurve): gp_Elips;
  static Hyperbola(C: Handle_Adaptor3d_HCurve): gp_Hypr;
  static Parabola(C: Handle_Adaptor3d_HCurve): gp_Parab;
  static Bezier(C: Handle_Adaptor3d_HCurve): Handle_Geom_BezierCurve;
  static BSpline(C: Handle_Adaptor3d_HCurve): Handle_Geom_BSplineCurve;
  static NbSamples(C: Handle_Adaptor3d_HCurve, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static SamplePars(C: Handle_Adaptor3d_HCurve, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, Defl: Quantity_AbsorbedDose, NbMin: Graphic3d_ZLayerId, Pars: Handle_TColStd_HArray1OfReal): void;
  delete(): void;
}

export declare class IntCurveSurface_Intersection {
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntCurveSurface_IntersectionPoint;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(Index: Graphic3d_ZLayerId): IntCurveSurface_IntersectionSegment;
  IsParallel(): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

export declare class IntCurveSurface_TheQuadCurvExactHInter {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  IsDone(): Standard_Boolean;
  NbRoots(): Graphic3d_ZLayerId;
  Root(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbIntervals(): Graphic3d_ZLayerId;
  Intervals(Index: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StdStorage_HeaderData extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Read(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  Write(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  CreationDate(): XCAFDoc_PartId;
  StorageVersion(): XCAFDoc_PartId;
  SchemaVersion(): XCAFDoc_PartId;
  SetApplicationVersion(aVersion: XCAFDoc_PartId): void;
  ApplicationVersion(): XCAFDoc_PartId;
  SetApplicationName(aName: TCollection_ExtendedString): void;
  ApplicationName(): TCollection_ExtendedString;
  SetDataType(aType: TCollection_ExtendedString): void;
  DataType(): TCollection_ExtendedString;
  AddToUserInfo(theUserInfo: XCAFDoc_PartId): void;
  UserInfo(): TColStd_SequenceOfAsciiString;
  AddToComments(aComment: TCollection_ExtendedString): void;
  Comments(): TColStd_SequenceOfExtendedString;
  NumberOfObjects(): Graphic3d_ZLayerId;
  ErrorStatus(): Storage_Error;
  ErrorStatusExtension(): XCAFDoc_PartId;
  ClearErrorStatus(): void;
  SetNumberOfObjects(anObjectNumber: Graphic3d_ZLayerId): void;
  SetStorageVersion(aVersion: XCAFDoc_PartId): void;
  SetCreationDate(aDate: XCAFDoc_PartId): void;
  SetSchemaVersion(aVersion: XCAFDoc_PartId): void;
  SetSchemaName(aName: XCAFDoc_PartId): void;
  delete(): void;
}

export declare class Handle_StdStorage_HeaderData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdStorage_HeaderData): void;
  get(): StdStorage_HeaderData;
  delete(): void;
}

  export declare class Handle_StdStorage_HeaderData_1 extends Handle_StdStorage_HeaderData {
    constructor();
  }

  export declare class Handle_StdStorage_HeaderData_2 extends Handle_StdStorage_HeaderData {
    constructor(thePtr: StdStorage_HeaderData);
  }

  export declare class Handle_StdStorage_HeaderData_3 extends Handle_StdStorage_HeaderData {
    constructor(theHandle: Handle_StdStorage_HeaderData);
  }

  export declare class Handle_StdStorage_HeaderData_4 extends Handle_StdStorage_HeaderData {
    constructor(theHandle: Handle_StdStorage_HeaderData);
  }

export declare class Handle_StdStorage_HSequenceOfRoots {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdStorage_HSequenceOfRoots): void;
  get(): StdStorage_HSequenceOfRoots;
  delete(): void;
}

  export declare class Handle_StdStorage_HSequenceOfRoots_1 extends Handle_StdStorage_HSequenceOfRoots {
    constructor();
  }

  export declare class Handle_StdStorage_HSequenceOfRoots_2 extends Handle_StdStorage_HSequenceOfRoots {
    constructor(thePtr: StdStorage_HSequenceOfRoots);
  }

  export declare class Handle_StdStorage_HSequenceOfRoots_3 extends Handle_StdStorage_HSequenceOfRoots {
    constructor(theHandle: Handle_StdStorage_HSequenceOfRoots);
  }

  export declare class Handle_StdStorage_HSequenceOfRoots_4 extends Handle_StdStorage_HSequenceOfRoots {
    constructor(theHandle: Handle_StdStorage_HSequenceOfRoots);
  }

export declare class StdStorage {
  constructor();
  static Version(): XCAFDoc_PartId;
  static Read_1(theFileName: XCAFDoc_PartId, theData: any): Storage_Error;
  static Read_2(theDriver: Handle_Storage_BaseDriver, theData: any): Storage_Error;
  static Write(theDriver: Handle_Storage_BaseDriver, theData: any): Storage_Error;
  delete(): void;
}

export declare class StdStorage_BucketIterator {
  constructor(a: StdStorage_BucketOfPersistent)
  Init(a0: StdStorage_BucketOfPersistent): void;
  Reset(): void;
  Value(): StdObjMgt_Persistent;
  More(): Standard_Boolean;
  Next(): void;
  delete(): void;
}

export declare class StdStorage_BucketOfPersistent {
  constructor(theBucketSize: Graphic3d_ZLayerId, theBucketNumber: Graphic3d_ZLayerId)
  Length(): Graphic3d_ZLayerId;
  Append(sp: any): void;
  Value(theIndex: Graphic3d_ZLayerId): StdObjMgt_Persistent;
  Clear(): void;
  delete(): void;
}

export declare class StdStorage_Bucket {
  Clear(): void;
  delete(): void;
}

  export declare class StdStorage_Bucket_1 extends StdStorage_Bucket {
    constructor();
  }

  export declare class StdStorage_Bucket_2 extends StdStorage_Bucket {
    constructor(theSpaceSize: Graphic3d_ZLayerId);
  }

export declare class Handle_StdStorage_TypeData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdStorage_TypeData): void;
  get(): StdStorage_TypeData;
  delete(): void;
}

  export declare class Handle_StdStorage_TypeData_1 extends Handle_StdStorage_TypeData {
    constructor();
  }

  export declare class Handle_StdStorage_TypeData_2 extends Handle_StdStorage_TypeData {
    constructor(thePtr: StdStorage_TypeData);
  }

  export declare class Handle_StdStorage_TypeData_3 extends Handle_StdStorage_TypeData {
    constructor(theHandle: Handle_StdStorage_TypeData);
  }

  export declare class Handle_StdStorage_TypeData_4 extends Handle_StdStorage_TypeData {
    constructor(theHandle: Handle_StdStorage_TypeData);
  }

export declare class StdStorage_TypeData extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Read(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  Write(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  NumberOfTypes(): Graphic3d_ZLayerId;
  AddType_1(aTypeName: XCAFDoc_PartId, aTypeNum: Graphic3d_ZLayerId): void;
  AddType_2(aPObj: any): Graphic3d_ZLayerId;
  Type_1(aTypeNum: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Type_2(aTypeName: XCAFDoc_PartId): Graphic3d_ZLayerId;
  Instantiator(aTypeNum: Graphic3d_ZLayerId): any;
  IsType(aName: XCAFDoc_PartId): Standard_Boolean;
  Types(): Handle_TColStd_HSequenceOfAsciiString;
  ErrorStatus(): Storage_Error;
  ErrorStatusExtension(): XCAFDoc_PartId;
  ClearErrorStatus(): void;
  Clear(): void;
  delete(): void;
}

export declare class StdStorage_RootData extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Read(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  Write(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  NumberOfRoots(): Graphic3d_ZLayerId;
  AddRoot(aRoot: Handle_StdStorage_Root): void;
  Roots(): Handle_StdStorage_HSequenceOfRoots;
  Find(aName: XCAFDoc_PartId): Handle_StdStorage_Root;
  IsRoot(aName: XCAFDoc_PartId): Standard_Boolean;
  RemoveRoot(aName: XCAFDoc_PartId): void;
  ErrorStatus(): Storage_Error;
  ErrorStatusExtension(): XCAFDoc_PartId;
  ClearErrorStatus(): void;
  Clear(): void;
  delete(): void;
}

export declare class Handle_StdStorage_RootData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdStorage_RootData): void;
  get(): StdStorage_RootData;
  delete(): void;
}

  export declare class Handle_StdStorage_RootData_1 extends Handle_StdStorage_RootData {
    constructor();
  }

  export declare class Handle_StdStorage_RootData_2 extends Handle_StdStorage_RootData {
    constructor(thePtr: StdStorage_RootData);
  }

  export declare class Handle_StdStorage_RootData_3 extends Handle_StdStorage_RootData {
    constructor(theHandle: Handle_StdStorage_RootData);
  }

  export declare class Handle_StdStorage_RootData_4 extends Handle_StdStorage_RootData {
    constructor(theHandle: Handle_StdStorage_RootData);
  }

export declare class Handle_StdStorage_Root {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdStorage_Root): void;
  get(): StdStorage_Root;
  delete(): void;
}

  export declare class Handle_StdStorage_Root_1 extends Handle_StdStorage_Root {
    constructor();
  }

  export declare class Handle_StdStorage_Root_2 extends Handle_StdStorage_Root {
    constructor(thePtr: StdStorage_Root);
  }

  export declare class Handle_StdStorage_Root_3 extends Handle_StdStorage_Root {
    constructor(theHandle: Handle_StdStorage_Root);
  }

  export declare class Handle_StdStorage_Root_4 extends Handle_StdStorage_Root {
    constructor(theHandle: Handle_StdStorage_Root);
  }

export declare class StdStorage_Root extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Name(): XCAFDoc_PartId;
  SetName(theName: XCAFDoc_PartId): void;
  Object(): any;
  SetObject(anObject: any): void;
  Type(): XCAFDoc_PartId;
  SetType(aType: XCAFDoc_PartId): void;
  Reference(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class StdStorage_Root_1 extends StdStorage_Root {
    constructor();
  }

  export declare class StdStorage_Root_2 extends StdStorage_Root {
    constructor(theName: XCAFDoc_PartId, theObject: any);
  }

export declare class StdStorage_Data extends Standard_Transient {
  constructor()
  Clear(): void;
  HeaderData(): Handle_StdStorage_HeaderData;
  TypeData(): Handle_StdStorage_TypeData;
  RootData(): Handle_StdStorage_RootData;
  delete(): void;
}

export declare class Handle_Select3D_SensitiveSegment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveSegment): void;
  get(): Select3D_SensitiveSegment;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveSegment_1 extends Handle_Select3D_SensitiveSegment {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveSegment_2 extends Handle_Select3D_SensitiveSegment {
    constructor(thePtr: Select3D_SensitiveSegment);
  }

  export declare class Handle_Select3D_SensitiveSegment_3 extends Handle_Select3D_SensitiveSegment {
    constructor(theHandle: Handle_Select3D_SensitiveSegment);
  }

  export declare class Handle_Select3D_SensitiveSegment_4 extends Handle_Select3D_SensitiveSegment {
    constructor(theHandle: Handle_Select3D_SensitiveSegment);
  }

export declare class Select3D_SensitiveSegment extends Select3D_SensitiveEntity {
  constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theFirstPnt: gp_Pnt, theLastPnt: gp_Pnt)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetStartPoint(thePnt: gp_Pnt): void;
  SetEndPoint(thePnt: gp_Pnt): void;
  StartPoint_1(): gp_Pnt;
  EndPoint_1(): gp_Pnt;
  NbSubElements(): Graphic3d_ZLayerId;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  CenterOfGeometry(): gp_Pnt;
  BoundingBox(): Select3D_BndBox3d;
  ToBuildBVH(): Standard_Boolean;
  StartPoint_2(thePnt: gp_Pnt): void;
  EndPoint_2(thePnt: gp_Pnt): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Select3D_TypeOfSensitivity = {
  Select3D_TOS_INTERIOR: {};
  Select3D_TOS_BOUNDARY: {};
}

export declare class Select3D_SensitiveSet extends Select3D_SensitiveEntity {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static DefaultBVHBuilder(): any;
  static SetDefaultBVHBuilder(theBuilder: any): void;
  Size(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  BVH(): void;
  ToBuildBVH(): Standard_Boolean;
  SetBuilder(theBuilder: any): void;
  MarkDirty(): void;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  Clear(): void;
  GetLeafNodeSize(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Select3D_SensitiveSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveSet): void;
  get(): Select3D_SensitiveSet;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveSet_1 extends Handle_Select3D_SensitiveSet {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveSet_2 extends Handle_Select3D_SensitiveSet {
    constructor(thePtr: Select3D_SensitiveSet);
  }

  export declare class Handle_Select3D_SensitiveSet_3 extends Handle_Select3D_SensitiveSet {
    constructor(theHandle: Handle_Select3D_SensitiveSet);
  }

  export declare class Handle_Select3D_SensitiveSet_4 extends Handle_Select3D_SensitiveSet {
    constructor(theHandle: Handle_Select3D_SensitiveSet);
  }

export declare class Handle_Select3D_SensitiveCircle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveCircle): void;
  get(): Select3D_SensitiveCircle;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveCircle_1 extends Handle_Select3D_SensitiveCircle {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveCircle_2 extends Handle_Select3D_SensitiveCircle {
    constructor(thePtr: Select3D_SensitiveCircle);
  }

  export declare class Handle_Select3D_SensitiveCircle_3 extends Handle_Select3D_SensitiveCircle {
    constructor(theHandle: Handle_Select3D_SensitiveCircle);
  }

  export declare class Handle_Select3D_SensitiveCircle_4 extends Handle_Select3D_SensitiveCircle {
    constructor(theHandle: Handle_Select3D_SensitiveCircle);
  }

export declare class Select3D_SensitiveCircle extends Select3D_SensitivePoly {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  CenterOfGeometry(): gp_Pnt;
  BVH(): void;
  ToBuildBVH(): Standard_Boolean;
  delete(): void;
}

  export declare class Select3D_SensitiveCircle_1 extends Select3D_SensitiveCircle {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theCircle: gp_Circ, theIsFilled: Standard_Boolean, theNbPnts: Graphic3d_ZLayerId);
  }

  export declare class Select3D_SensitiveCircle_2 extends Select3D_SensitiveCircle {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theCircle: gp_Circ, theU1: Quantity_AbsorbedDose, theU2: Quantity_AbsorbedDose, theIsFilled: Standard_Boolean, theNbPnts: Graphic3d_ZLayerId);
  }

  export declare class Select3D_SensitiveCircle_3 extends Select3D_SensitiveCircle {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePnts3d: Handle_TColgp_HArray1OfPnt, theIsFilled: Standard_Boolean);
  }

  export declare class Select3D_SensitiveCircle_4 extends Select3D_SensitiveCircle {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePnts3d: TColgp_Array1OfPnt, theIsFilled: Standard_Boolean);
  }

export declare class Select3D_PointData {
  constructor(theNbPoints: Graphic3d_ZLayerId)
  SetPnt_1(theIndex: Graphic3d_ZLayerId, theValue: Select3D_Pnt): void;
  SetPnt_2(theIndex: Graphic3d_ZLayerId, theValue: gp_Pnt): void;
  Pnt(theIndex: Graphic3d_ZLayerId): Select3D_Pnt;
  Pnt3d(theIndex: Graphic3d_ZLayerId): gp_Pnt;
  Size(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_Select3D_SensitiveWire {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveWire): void;
  get(): Select3D_SensitiveWire;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveWire_1 extends Handle_Select3D_SensitiveWire {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveWire_2 extends Handle_Select3D_SensitiveWire {
    constructor(thePtr: Select3D_SensitiveWire);
  }

  export declare class Handle_Select3D_SensitiveWire_3 extends Handle_Select3D_SensitiveWire {
    constructor(theHandle: Handle_Select3D_SensitiveWire);
  }

  export declare class Handle_Select3D_SensitiveWire_4 extends Handle_Select3D_SensitiveWire {
    constructor(theHandle: Handle_Select3D_SensitiveWire);
  }

export declare class Select3D_SensitiveWire extends Select3D_SensitiveSet {
  constructor(theOwnerId: Handle_SelectMgr_EntityOwner)
  Add(theSensitive: Handle_Select3D_SensitiveEntity): void;
  NbSubElements(): Graphic3d_ZLayerId;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  GetEdges(): any;
  Set(theOwnerId: Handle_SelectMgr_EntityOwner): void;
  GetLastDetected(): Handle_Select3D_SensitiveEntity;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  Size(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Select3D_SensitivePrimitiveArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitivePrimitiveArray): void;
  get(): Select3D_SensitivePrimitiveArray;
  delete(): void;
}

  export declare class Handle_Select3D_SensitivePrimitiveArray_1 extends Handle_Select3D_SensitivePrimitiveArray {
    constructor();
  }

  export declare class Handle_Select3D_SensitivePrimitiveArray_2 extends Handle_Select3D_SensitivePrimitiveArray {
    constructor(thePtr: Select3D_SensitivePrimitiveArray);
  }

  export declare class Handle_Select3D_SensitivePrimitiveArray_3 extends Handle_Select3D_SensitivePrimitiveArray {
    constructor(theHandle: Handle_Select3D_SensitivePrimitiveArray);
  }

  export declare class Handle_Select3D_SensitivePrimitiveArray_4 extends Handle_Select3D_SensitivePrimitiveArray {
    constructor(theHandle: Handle_Select3D_SensitivePrimitiveArray);
  }

export declare class Select3D_SensitivePrimitiveArray extends Select3D_SensitiveSet {
  constructor(theOwnerId: Handle_SelectMgr_EntityOwner)
  PatchSizeMax(): Graphic3d_ZLayerId;
  SetPatchSizeMax(thePatchSizeMax: Graphic3d_ZLayerId): void;
  PatchDistance(): Standard_ShortReal;
  SetPatchDistance(thePatchDistMax: Standard_ShortReal): void;
  InitTriangulation_1(theVerts: Handle_Graphic3d_Buffer, theIndices: Handle_Graphic3d_IndexBuffer, theInitLoc: TopLoc_Location, theIndexLower: Graphic3d_ZLayerId, theIndexUpper: Graphic3d_ZLayerId, theToEvalMinMax: Standard_Boolean, theNbGroups: Graphic3d_ZLayerId): Standard_Boolean;
  InitTriangulation_2(theVerts: Handle_Graphic3d_Buffer, theIndices: Handle_Graphic3d_IndexBuffer, theInitLoc: TopLoc_Location, theToEvalMinMax: Standard_Boolean, theNbGroups: Graphic3d_ZLayerId): Standard_Boolean;
  InitPoints_1(theVerts: Handle_Graphic3d_Buffer, theIndices: Handle_Graphic3d_IndexBuffer, theInitLoc: TopLoc_Location, theIndexLower: Graphic3d_ZLayerId, theIndexUpper: Graphic3d_ZLayerId, theToEvalMinMax: Standard_Boolean, theNbGroups: Graphic3d_ZLayerId): Standard_Boolean;
  InitPoints_2(theVerts: Handle_Graphic3d_Buffer, theIndices: Handle_Graphic3d_IndexBuffer, theInitLoc: TopLoc_Location, theToEvalMinMax: Standard_Boolean, theNbGroups: Graphic3d_ZLayerId): Standard_Boolean;
  InitPoints_3(theVerts: Handle_Graphic3d_Buffer, theInitLoc: TopLoc_Location, theToEvalMinMax: Standard_Boolean, theNbGroups: Graphic3d_ZLayerId): Standard_Boolean;
  SetMinMax(theMinX: Standard_Real, theMinY: Standard_Real, theMinZ: Standard_Real, theMaxX: Standard_Real, theMaxY: Standard_Real, theMaxZ: Standard_Real): void;
  ToDetectElements(): Standard_Boolean;
  SetDetectElements(theToDetect: Standard_Boolean): void;
  ToDetectElementMap(): Standard_Boolean;
  SetDetectElementMap(theToDetect: Standard_Boolean): void;
  ToDetectNodes(): Standard_Boolean;
  SetDetectNodes(theToDetect: Standard_Boolean): void;
  ToDetectNodeMap(): Standard_Boolean;
  SetDetectNodeMap(theToDetect: Standard_Boolean): void;
  ToDetectEdges(): Standard_Boolean;
  SetDetectEdges(theToDetect: Standard_Boolean): void;
  LastDetectedElement(): Graphic3d_ZLayerId;
  LastDetectedElementMap(): Handle_TColStd_HPackedMapOfInteger;
  LastDetectedNode(): Graphic3d_ZLayerId;
  LastDetectedNodeMap(): Handle_TColStd_HPackedMapOfInteger;
  LastDetectedEdgeNode1(): Graphic3d_ZLayerId;
  LastDetectedEdgeNode2(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Size(): Graphic3d_ZLayerId;
  NbSubElements(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  HasInitLocation(): Standard_Boolean;
  InvInitLocation(): gp_GTrsf;
  Set(theOwnerId: Handle_SelectMgr_EntityOwner): void;
  BVH(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Select3D_SensitiveFace extends Select3D_SensitiveEntity {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetPoints(theHArrayOfPnt: Handle_TColgp_HArray1OfPnt): void;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  BVH(): void;
  ToBuildBVH(): Standard_Boolean;
  NbSubElements(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Select3D_SensitiveFace_1 extends Select3D_SensitiveFace {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: TColgp_Array1OfPnt, theType: Select3D_TypeOfSensitivity);
  }

  export declare class Select3D_SensitiveFace_2 extends Select3D_SensitiveFace {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: Handle_TColgp_HArray1OfPnt, theType: Select3D_TypeOfSensitivity);
  }

export declare class Handle_Select3D_SensitiveFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveFace): void;
  get(): Select3D_SensitiveFace;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveFace_1 extends Handle_Select3D_SensitiveFace {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveFace_2 extends Handle_Select3D_SensitiveFace {
    constructor(thePtr: Select3D_SensitiveFace);
  }

  export declare class Handle_Select3D_SensitiveFace_3 extends Handle_Select3D_SensitiveFace {
    constructor(theHandle: Handle_Select3D_SensitiveFace);
  }

  export declare class Handle_Select3D_SensitiveFace_4 extends Handle_Select3D_SensitiveFace {
    constructor(theHandle: Handle_Select3D_SensitiveFace);
  }

export declare class Handle_Select3D_InteriorSensitivePointSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_InteriorSensitivePointSet): void;
  get(): Select3D_InteriorSensitivePointSet;
  delete(): void;
}

  export declare class Handle_Select3D_InteriorSensitivePointSet_1 extends Handle_Select3D_InteriorSensitivePointSet {
    constructor();
  }

  export declare class Handle_Select3D_InteriorSensitivePointSet_2 extends Handle_Select3D_InteriorSensitivePointSet {
    constructor(thePtr: Select3D_InteriorSensitivePointSet);
  }

  export declare class Handle_Select3D_InteriorSensitivePointSet_3 extends Handle_Select3D_InteriorSensitivePointSet {
    constructor(theHandle: Handle_Select3D_InteriorSensitivePointSet);
  }

  export declare class Handle_Select3D_InteriorSensitivePointSet_4 extends Handle_Select3D_InteriorSensitivePointSet {
    constructor(theHandle: Handle_Select3D_InteriorSensitivePointSet);
  }

export declare class Select3D_InteriorSensitivePointSet extends Select3D_SensitiveSet {
  constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: TColgp_Array1OfPnt)
  GetPoints(theHArrayOfPnt: Handle_TColgp_HArray1OfPnt): void;
  Size(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  NbSubElements(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Select3D_SensitivePoly extends Select3D_SensitiveSet {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NbSubElements(): Graphic3d_ZLayerId;
  Points3D(theHArrayOfPnt: Handle_TColgp_HArray1OfPnt): void;
  ArrayBounds(theLow: Graphic3d_ZLayerId, theUp: Graphic3d_ZLayerId): void;
  GetPoint3d(thePntIdx: Graphic3d_ZLayerId): gp_Pnt;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  Size(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Select3D_SensitivePoly_1 extends Select3D_SensitivePoly {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: TColgp_Array1OfPnt, theIsBVHEnabled: Standard_Boolean);
  }

  export declare class Select3D_SensitivePoly_2 extends Select3D_SensitivePoly {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: Handle_TColgp_HArray1OfPnt, theIsBVHEnabled: Standard_Boolean);
  }

  export declare class Select3D_SensitivePoly_3 extends Select3D_SensitivePoly {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theIsBVHEnabled: Standard_Boolean, theNbPnts: Graphic3d_ZLayerId);
  }

export declare class Handle_Select3D_SensitivePoly {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitivePoly): void;
  get(): Select3D_SensitivePoly;
  delete(): void;
}

  export declare class Handle_Select3D_SensitivePoly_1 extends Handle_Select3D_SensitivePoly {
    constructor();
  }

  export declare class Handle_Select3D_SensitivePoly_2 extends Handle_Select3D_SensitivePoly {
    constructor(thePtr: Select3D_SensitivePoly);
  }

  export declare class Handle_Select3D_SensitivePoly_3 extends Handle_Select3D_SensitivePoly {
    constructor(theHandle: Handle_Select3D_SensitivePoly);
  }

  export declare class Handle_Select3D_SensitivePoly_4 extends Handle_Select3D_SensitivePoly {
    constructor(theHandle: Handle_Select3D_SensitivePoly);
  }

export declare class Select3D_Pnt {
  constructor();
  delete(): void;
}

export declare class Select3D_SensitiveBox extends Select3D_SensitiveEntity {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NbSubElements(): Graphic3d_ZLayerId;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Box(): Bnd_Box;
  CenterOfGeometry(): gp_Pnt;
  BoundingBox(): Select3D_BndBox3d;
  ToBuildBVH(): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Select3D_SensitiveBox_1 extends Select3D_SensitiveBox {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theBox: Bnd_Box);
  }

  export declare class Select3D_SensitiveBox_2 extends Select3D_SensitiveBox {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theXMin: Quantity_AbsorbedDose, theYMin: Quantity_AbsorbedDose, theZMin: Quantity_AbsorbedDose, theXMax: Quantity_AbsorbedDose, theYMax: Quantity_AbsorbedDose, theZMax: Quantity_AbsorbedDose);
  }

export declare class Handle_Select3D_SensitiveBox {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveBox): void;
  get(): Select3D_SensitiveBox;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveBox_1 extends Handle_Select3D_SensitiveBox {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveBox_2 extends Handle_Select3D_SensitiveBox {
    constructor(thePtr: Select3D_SensitiveBox);
  }

  export declare class Handle_Select3D_SensitiveBox_3 extends Handle_Select3D_SensitiveBox {
    constructor(theHandle: Handle_Select3D_SensitiveBox);
  }

  export declare class Handle_Select3D_SensitiveBox_4 extends Handle_Select3D_SensitiveBox {
    constructor(theHandle: Handle_Select3D_SensitiveBox);
  }

export declare class Select3D_BVHIndexBuffer extends Graphic3d_Buffer {
  constructor(theAlloc: Handle_NCollection_BaseAllocator)
  HasPatches(): Standard_Boolean;
  Init(theNbElems: Graphic3d_ZLayerId, theHasPatches: Standard_Boolean): Standard_Boolean;
  Index(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  PatchSize(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetIndex_1(theIndex: Graphic3d_ZLayerId, theValue: Graphic3d_ZLayerId): void;
  SetIndex_2(theIndex: Graphic3d_ZLayerId, theValue: Graphic3d_ZLayerId, thePatchSize: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Select3D_BVHIndexBuffer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_BVHIndexBuffer): void;
  get(): Select3D_BVHIndexBuffer;
  delete(): void;
}

  export declare class Handle_Select3D_BVHIndexBuffer_1 extends Handle_Select3D_BVHIndexBuffer {
    constructor();
  }

  export declare class Handle_Select3D_BVHIndexBuffer_2 extends Handle_Select3D_BVHIndexBuffer {
    constructor(thePtr: Select3D_BVHIndexBuffer);
  }

  export declare class Handle_Select3D_BVHIndexBuffer_3 extends Handle_Select3D_BVHIndexBuffer {
    constructor(theHandle: Handle_Select3D_BVHIndexBuffer);
  }

  export declare class Handle_Select3D_BVHIndexBuffer_4 extends Handle_Select3D_BVHIndexBuffer {
    constructor(theHandle: Handle_Select3D_BVHIndexBuffer);
  }

export declare class Handle_Select3D_SensitiveEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveEntity): void;
  get(): Select3D_SensitiveEntity;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveEntity_1 extends Handle_Select3D_SensitiveEntity {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveEntity_2 extends Handle_Select3D_SensitiveEntity {
    constructor(thePtr: Select3D_SensitiveEntity);
  }

  export declare class Handle_Select3D_SensitiveEntity_3 extends Handle_Select3D_SensitiveEntity {
    constructor(theHandle: Handle_Select3D_SensitiveEntity);
  }

  export declare class Handle_Select3D_SensitiveEntity_4 extends Handle_Select3D_SensitiveEntity {
    constructor(theHandle: Handle_Select3D_SensitiveEntity);
  }

export declare class Select3D_SensitiveEntity extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  OwnerId(): Handle_SelectMgr_EntityOwner;
  Set(theOwnerId: Handle_SelectMgr_EntityOwner): void;
  SensitivityFactor(): Graphic3d_ZLayerId;
  SetSensitivityFactor(theNewSens: Graphic3d_ZLayerId): void;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  NbSubElements(): Graphic3d_ZLayerId;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  BVH(): void;
  ToBuildBVH(): Standard_Boolean;
  Clear(): void;
  HasInitLocation(): Standard_Boolean;
  InvInitLocation(): gp_GTrsf;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Select3D_SensitiveGroup extends Select3D_SensitiveSet {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Entities(): Select3D_IndexedMapOfEntity;
  SubEntity(theIndex: Graphic3d_ZLayerId): Handle_Select3D_SensitiveEntity;
  LastDetectedEntity(): Handle_Select3D_SensitiveEntity;
  LastDetectedEntityIndex(): Graphic3d_ZLayerId;
  Add_1(theEntities: Select3D_EntitySequence): void;
  Add_2(theSensitive: Handle_Select3D_SensitiveEntity): void;
  Remove(theSensitive: Handle_Select3D_SensitiveEntity): void;
  Clear(): void;
  IsIn(theSensitive: Handle_Select3D_SensitiveEntity): Standard_Boolean;
  SetMatchType(theIsMustMatchAll: Standard_Boolean): void;
  MustMatchAll(): Standard_Boolean;
  ToCheckOverlapAll(): Standard_Boolean;
  SetCheckOverlapAll(theToCheckAll: Standard_Boolean): void;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  NbSubElements(): Graphic3d_ZLayerId;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Set(theOwnerId: Handle_SelectMgr_EntityOwner): void;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  Size(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Select3D_SensitiveGroup_1 extends Select3D_SensitiveGroup {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theIsMustMatchAll: Standard_Boolean);
  }

  export declare class Select3D_SensitiveGroup_2 extends Select3D_SensitiveGroup {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theEntities: Select3D_EntitySequence, theIsMustMatchAll: Standard_Boolean);
  }

export declare class Handle_Select3D_SensitiveGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveGroup): void;
  get(): Select3D_SensitiveGroup;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveGroup_1 extends Handle_Select3D_SensitiveGroup {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveGroup_2 extends Handle_Select3D_SensitiveGroup {
    constructor(thePtr: Select3D_SensitiveGroup);
  }

  export declare class Handle_Select3D_SensitiveGroup_3 extends Handle_Select3D_SensitiveGroup {
    constructor(theHandle: Handle_Select3D_SensitiveGroup);
  }

  export declare class Handle_Select3D_SensitiveGroup_4 extends Handle_Select3D_SensitiveGroup {
    constructor(theHandle: Handle_Select3D_SensitiveGroup);
  }

export declare class Handle_Select3D_SensitivePoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitivePoint): void;
  get(): Select3D_SensitivePoint;
  delete(): void;
}

  export declare class Handle_Select3D_SensitivePoint_1 extends Handle_Select3D_SensitivePoint {
    constructor();
  }

  export declare class Handle_Select3D_SensitivePoint_2 extends Handle_Select3D_SensitivePoint {
    constructor(thePtr: Select3D_SensitivePoint);
  }

  export declare class Handle_Select3D_SensitivePoint_3 extends Handle_Select3D_SensitivePoint {
    constructor(theHandle: Handle_Select3D_SensitivePoint);
  }

  export declare class Handle_Select3D_SensitivePoint_4 extends Handle_Select3D_SensitivePoint {
    constructor(theHandle: Handle_Select3D_SensitivePoint);
  }

export declare class Select3D_SensitivePoint extends Select3D_SensitiveEntity {
  constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoint: gp_Pnt)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NbSubElements(): Graphic3d_ZLayerId;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Point(): gp_Pnt;
  CenterOfGeometry(): gp_Pnt;
  BoundingBox(): Select3D_BndBox3d;
  ToBuildBVH(): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Select3D_SensitiveCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveCurve): void;
  get(): Select3D_SensitiveCurve;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveCurve_1 extends Handle_Select3D_SensitiveCurve {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveCurve_2 extends Handle_Select3D_SensitiveCurve {
    constructor(thePtr: Select3D_SensitiveCurve);
  }

  export declare class Handle_Select3D_SensitiveCurve_3 extends Handle_Select3D_SensitiveCurve {
    constructor(theHandle: Handle_Select3D_SensitiveCurve);
  }

  export declare class Handle_Select3D_SensitiveCurve_4 extends Handle_Select3D_SensitiveCurve {
    constructor(theHandle: Handle_Select3D_SensitiveCurve);
  }

export declare class Select3D_SensitiveCurve extends Select3D_SensitivePoly {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  delete(): void;
}

  export declare class Select3D_SensitiveCurve_1 extends Select3D_SensitiveCurve {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theCurve: Handle_Geom_Curve, theNbPnts: Graphic3d_ZLayerId);
  }

  export declare class Select3D_SensitiveCurve_2 extends Select3D_SensitiveCurve {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: Handle_TColgp_HArray1OfPnt);
  }

  export declare class Select3D_SensitiveCurve_3 extends Select3D_SensitiveCurve {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePoints: TColgp_Array1OfPnt);
  }

export declare class Handle_Select3D_SensitiveTriangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveTriangulation): void;
  get(): Select3D_SensitiveTriangulation;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveTriangulation_1 extends Handle_Select3D_SensitiveTriangulation {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveTriangulation_2 extends Handle_Select3D_SensitiveTriangulation {
    constructor(thePtr: Select3D_SensitiveTriangulation);
  }

  export declare class Handle_Select3D_SensitiveTriangulation_3 extends Handle_Select3D_SensitiveTriangulation {
    constructor(theHandle: Handle_Select3D_SensitiveTriangulation);
  }

  export declare class Handle_Select3D_SensitiveTriangulation_4 extends Handle_Select3D_SensitiveTriangulation {
    constructor(theHandle: Handle_Select3D_SensitiveTriangulation);
  }

export declare class Select3D_SensitiveTriangulation extends Select3D_SensitiveSet {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NbSubElements(): Graphic3d_ZLayerId;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  Triangulation(): Handle_Poly_Triangulation;
  Size(): Graphic3d_ZLayerId;
  Box(theIdx: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIdx: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIdx1: Graphic3d_ZLayerId, theIdx2: Graphic3d_ZLayerId): void;
  BoundingBox(): Select3D_BndBox3d;
  CenterOfGeometry(): gp_Pnt;
  HasInitLocation(): Standard_Boolean;
  InvInitLocation(): gp_GTrsf;
  GetInitLocation(): TopLoc_Location;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Select3D_SensitiveTriangulation_1 extends Select3D_SensitiveTriangulation {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theTrg: Handle_Poly_Triangulation, theInitLoc: TopLoc_Location, theIsInterior: Standard_Boolean);
  }

  export declare class Select3D_SensitiveTriangulation_2 extends Select3D_SensitiveTriangulation {
    constructor(theOwnerId: Handle_SelectMgr_EntityOwner, theTrg: Handle_Poly_Triangulation, theInitLoc: TopLoc_Location, theFreeEdges: Handle_TColStd_HArray1OfInteger, theCOG: gp_Pnt, theIsInterior: Standard_Boolean);
  }

export declare class Handle_Select3D_SensitiveTriangle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Select3D_SensitiveTriangle): void;
  get(): Select3D_SensitiveTriangle;
  delete(): void;
}

  export declare class Handle_Select3D_SensitiveTriangle_1 extends Handle_Select3D_SensitiveTriangle {
    constructor();
  }

  export declare class Handle_Select3D_SensitiveTriangle_2 extends Handle_Select3D_SensitiveTriangle {
    constructor(thePtr: Select3D_SensitiveTriangle);
  }

  export declare class Handle_Select3D_SensitiveTriangle_3 extends Handle_Select3D_SensitiveTriangle {
    constructor(theHandle: Handle_Select3D_SensitiveTriangle);
  }

  export declare class Handle_Select3D_SensitiveTriangle_4 extends Handle_Select3D_SensitiveTriangle {
    constructor(theHandle: Handle_Select3D_SensitiveTriangle);
  }

export declare class Select3D_SensitiveTriangle extends Select3D_SensitiveEntity {
  constructor(theOwnerId: Handle_SelectMgr_EntityOwner, thePnt0: gp_Pnt, thePnt1: gp_Pnt, thePnt2: gp_Pnt, theType: Select3D_TypeOfSensitivity)
  Matches(theMgr: SelectBasics_SelectingVolumeManager, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Points3D(thePnt0: gp_Pnt, thePnt1: gp_Pnt, thePnt2: gp_Pnt): void;
  Center3D(): gp_Pnt;
  GetConnected(): Handle_Select3D_SensitiveEntity;
  BoundingBox(): Select3D_BndBox3d;
  ToBuildBVH(): Standard_Boolean;
  NbSubElements(): Graphic3d_ZLayerId;
  CenterOfGeometry(): gp_Pnt;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Extrema_PCFOfEPCOfExtPC extends math_FunctionWithDerivative {
  Initialize(C: Adaptor3d_Curve): void;
  SetPoint(P: gp_Pnt): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_PCFOfEPCOfExtPC_1 extends Extrema_PCFOfEPCOfExtPC {
    constructor();
  }

  export declare class Extrema_PCFOfEPCOfExtPC_2 extends Extrema_PCFOfEPCOfExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve);
  }

export declare class Extrema_LocEPCOfLocateExtPC {
  Initialize(C: Adaptor3d_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt, U0: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  IsMin(): Standard_Boolean;
  Point(): Extrema_POnCurv;
  delete(): void;
}

  export declare class Extrema_LocEPCOfLocateExtPC_1 extends Extrema_LocEPCOfLocateExtPC {
    constructor();
  }

  export declare class Extrema_LocEPCOfLocateExtPC_2 extends Extrema_LocEPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, U0: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

  export declare class Extrema_LocEPCOfLocateExtPC_3 extends Extrema_LocEPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, U0: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

export declare class Extrema_ExtPC {
  Initialize(C: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbExt(): Graphic3d_ZLayerId;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  TrimmedSquareDistances(dist1: Quantity_AbsorbedDose, dist2: Quantity_AbsorbedDose, P1: gp_Pnt, P2: gp_Pnt): void;
  delete(): void;
}

  export declare class Extrema_ExtPC_1 extends Extrema_ExtPC {
    constructor();
  }

  export declare class Extrema_ExtPC_2 extends Extrema_ExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPC_3 extends Extrema_ExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_PCLocFOfLocEPCOfLocateExtPC2d extends math_FunctionWithDerivative {
  Initialize(C: Adaptor2d_Curve2d): void;
  SetPoint(P: gp_Pnt2d): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_PCLocFOfLocEPCOfLocateExtPC2d_1 extends Extrema_PCLocFOfLocEPCOfLocateExtPC2d {
    constructor();
  }

  export declare class Extrema_PCLocFOfLocEPCOfLocateExtPC2d_2 extends Extrema_PCLocFOfLocEPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d);
  }

export declare class Extrema_ELPCOfLocateExtPC2d {
  Initialize(C: Adaptor2d_Curve2d, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d): void;
  IsDone(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbExt(): Graphic3d_ZLayerId;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  TrimmedSquareDistances(dist1: Quantity_AbsorbedDose, dist2: Quantity_AbsorbedDose, P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  delete(): void;
}

  export declare class Extrema_ELPCOfLocateExtPC2d_1 extends Extrema_ELPCOfLocateExtPC2d {
    constructor();
  }

  export declare class Extrema_ELPCOfLocateExtPC2d_2 extends Extrema_ELPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ELPCOfLocateExtPC2d_3 extends Extrema_ELPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_Array1OfPOnSurf {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Extrema_POnSurf): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Extrema_Array1OfPOnSurf): Extrema_Array1OfPOnSurf;
  Move(theOther: Extrema_Array1OfPOnSurf): Extrema_Array1OfPOnSurf;
  First(): Extrema_POnSurf;
  ChangeFirst(): Extrema_POnSurf;
  Last(): Extrema_POnSurf;
  ChangeLast(): Extrema_POnSurf;
  Value(theIndex: Standard_Integer): Extrema_POnSurf;
  ChangeValue(theIndex: Standard_Integer): Extrema_POnSurf;
  SetValue(theIndex: Standard_Integer, theItem: Extrema_POnSurf): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array1OfPOnSurf_1 extends Extrema_Array1OfPOnSurf {
    constructor();
  }

  export declare class Extrema_Array1OfPOnSurf_2 extends Extrema_Array1OfPOnSurf {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Extrema_Array1OfPOnSurf_3 extends Extrema_Array1OfPOnSurf {
    constructor(theOther: Extrema_Array1OfPOnSurf);
  }

  export declare class Extrema_Array1OfPOnSurf_4 extends Extrema_Array1OfPOnSurf {
    constructor(theOther: Extrema_Array1OfPOnSurf);
  }

  export declare class Extrema_Array1OfPOnSurf_5 extends Extrema_Array1OfPOnSurf {
    constructor(theBegin: Extrema_POnSurf, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Extrema_SequenceOfPOnCurv extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Extrema_SequenceOfPOnCurv): Extrema_SequenceOfPOnCurv;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Extrema_POnCurv): void;
  Append_2(theSeq: Extrema_SequenceOfPOnCurv): void;
  Prepend_1(theItem: Extrema_POnCurv): void;
  Prepend_2(theSeq: Extrema_SequenceOfPOnCurv): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Extrema_POnCurv): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnCurv): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnCurv): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Extrema_POnCurv): void;
  Split(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnCurv): void;
  First(): Extrema_POnCurv;
  ChangeFirst(): Extrema_POnCurv;
  Last(): Extrema_POnCurv;
  ChangeLast(): Extrema_POnCurv;
  Value(theIndex: Standard_Integer): Extrema_POnCurv;
  ChangeValue(theIndex: Standard_Integer): Extrema_POnCurv;
  SetValue(theIndex: Standard_Integer, theItem: Extrema_POnCurv): void;
  delete(): void;
}

  export declare class Extrema_SequenceOfPOnCurv_1 extends Extrema_SequenceOfPOnCurv {
    constructor();
  }

  export declare class Extrema_SequenceOfPOnCurv_2 extends Extrema_SequenceOfPOnCurv {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Extrema_SequenceOfPOnCurv_3 extends Extrema_SequenceOfPOnCurv {
    constructor(theOther: Extrema_SequenceOfPOnCurv);
  }

export declare class Extrema_FuncPSNorm extends math_FunctionSetWithDerivatives {
  Initialize(S: Adaptor3d_Surface): void;
  SetPoint(P: gp_Pnt): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(UV: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(UV: math_Vector, DF: math_Matrix): Standard_Boolean;
  Values(UV: math_Vector, F: math_Vector, DF: math_Matrix): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_FuncPSNorm_1 extends Extrema_FuncPSNorm {
    constructor();
  }

  export declare class Extrema_FuncPSNorm_2 extends Extrema_FuncPSNorm {
    constructor(P: gp_Pnt, S: Adaptor3d_Surface);
  }

export declare class Extrema_ExtCS {
  Initialize(S: Adaptor3d_Surface, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolC: Quantity_AbsorbedDose, TolS: Quantity_AbsorbedDose): void;
  Perform(C: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv, P2: Extrema_POnSurf): void;
  delete(): void;
}

  export declare class Extrema_ExtCS_1 extends Extrema_ExtCS {
    constructor();
  }

  export declare class Extrema_ExtCS_2 extends Extrema_ExtCS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface, TolC: Quantity_AbsorbedDose, TolS: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtCS_3 extends Extrema_ExtCS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface, UCinf: Quantity_AbsorbedDose, UCsup: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolC: Quantity_AbsorbedDose, TolS: Quantity_AbsorbedDose);
  }

export declare class Extrema_EPCOfELPCOfLocateExtPC2d {
  Initialize_1(C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_2(C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor2d_Curve2d): void;
  Initialize_4(NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class Extrema_EPCOfELPCOfLocateExtPC2d_1 extends Extrema_EPCOfELPCOfLocateExtPC2d {
    constructor();
  }

  export declare class Extrema_EPCOfELPCOfLocateExtPC2d_2 extends Extrema_EPCOfELPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_EPCOfELPCOfLocateExtPC2d_3 extends Extrema_EPCOfELPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_ExtElSS {
  Perform_1(S1: gp_Pln, S2: gp_Pln): void;
  Perform_2(S1: gp_Pln, S2: gp_Sphere): void;
  Perform_3(S1: gp_Sphere, S2: gp_Sphere): void;
  Perform_4(S1: gp_Sphere, S2: gp_Cylinder): void;
  Perform_5(S1: gp_Sphere, S2: gp_Cone): void;
  Perform_6(S1: gp_Sphere, S2: gp_Torus): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnSurf, P2: Extrema_POnSurf): void;
  delete(): void;
}

  export declare class Extrema_ExtElSS_1 extends Extrema_ExtElSS {
    constructor();
  }

  export declare class Extrema_ExtElSS_2 extends Extrema_ExtElSS {
    constructor(S1: gp_Pln, S2: gp_Pln);
  }

  export declare class Extrema_ExtElSS_3 extends Extrema_ExtElSS {
    constructor(S1: gp_Pln, S2: gp_Sphere);
  }

  export declare class Extrema_ExtElSS_4 extends Extrema_ExtElSS {
    constructor(S1: gp_Sphere, S2: gp_Sphere);
  }

  export declare class Extrema_ExtElSS_5 extends Extrema_ExtElSS {
    constructor(S1: gp_Sphere, S2: gp_Cylinder);
  }

  export declare class Extrema_ExtElSS_6 extends Extrema_ExtElSS {
    constructor(S1: gp_Sphere, S2: gp_Cone);
  }

  export declare class Extrema_ExtElSS_7 extends Extrema_ExtElSS {
    constructor(S1: gp_Sphere, S2: gp_Torus);
  }

export declare class Extrema_CCLocFOfLocECC extends math_FunctionSetWithDerivatives {
  SetCurve(theRank: Graphic3d_ZLayerId, C1: Adaptor3d_Curve): void;
  SetTolerance(theTol: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(UV: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(UV: math_Vector, DF: math_Matrix): Standard_Boolean;
  Values(UV: math_Vector, F: math_Vector, DF: math_Matrix): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv, P2: Extrema_POnCurv): void;
  CurvePtr(theRank: Graphic3d_ZLayerId): Standard_Address;
  Tolerance(): Quantity_AbsorbedDose;
  SubIntervalInitialize(theUfirst: math_Vector, theUlast: math_Vector): void;
  SearchOfTolerance(C: Standard_Address): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_CCLocFOfLocECC_1 extends Extrema_CCLocFOfLocECC {
    constructor(thetol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_CCLocFOfLocECC_2 extends Extrema_CCLocFOfLocECC {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, thetol: Quantity_AbsorbedDose);
  }

export declare class Extrema_ELPCOfLocateExtPC {
  Initialize(C: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbExt(): Graphic3d_ZLayerId;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  TrimmedSquareDistances(dist1: Quantity_AbsorbedDose, dist2: Quantity_AbsorbedDose, P1: gp_Pnt, P2: gp_Pnt): void;
  delete(): void;
}

  export declare class Extrema_ELPCOfLocateExtPC_1 extends Extrema_ELPCOfLocateExtPC {
    constructor();
  }

  export declare class Extrema_ELPCOfLocateExtPC_2 extends Extrema_ELPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ELPCOfLocateExtPC_3 extends Extrema_ELPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_ECC2d {
  SetParams(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  SetSingleSolutionFlag(theSingleSolutionFlag: Standard_Boolean): void;
  GetSingleSolutionFlag(): Standard_Boolean;
  Perform(): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv2d, P2: Extrema_POnCurv2d): void;
  delete(): void;
}

  export declare class Extrema_ECC2d_1 extends Extrema_ECC2d {
    constructor();
  }

  export declare class Extrema_ECC2d_2 extends Extrema_ECC2d {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d);
  }

  export declare class Extrema_ECC2d_3 extends Extrema_ECC2d {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose);
  }

export declare class Extrema_FuncExtSS extends math_FunctionSetWithDerivatives {
  Initialize(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(UV: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(UV: math_Vector, DF: math_Matrix): Standard_Boolean;
  Values(UV: math_Vector, F: math_Vector, DF: math_Matrix): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  PointOnS1(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  PointOnS2(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_FuncExtSS_1 extends Extrema_FuncExtSS {
    constructor();
  }

  export declare class Extrema_FuncExtSS_2 extends Extrema_FuncExtSS {
    constructor(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface);
  }

export declare class Extrema_ExtPElS {
  Perform_1(P: gp_Pnt, S: gp_Cylinder, Tol: Quantity_AbsorbedDose): void;
  Perform_2(P: gp_Pnt, S: gp_Pln, Tol: Quantity_AbsorbedDose): void;
  Perform_3(P: gp_Pnt, S: gp_Cone, Tol: Quantity_AbsorbedDose): void;
  Perform_4(P: gp_Pnt, S: gp_Torus, Tol: Quantity_AbsorbedDose): void;
  Perform_5(P: gp_Pnt, S: gp_Sphere, Tol: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_ExtPElS_1 extends Extrema_ExtPElS {
    constructor();
  }

  export declare class Extrema_ExtPElS_2 extends Extrema_ExtPElS {
    constructor(P: gp_Pnt, S: gp_Cylinder, Tol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElS_3 extends Extrema_ExtPElS {
    constructor(P: gp_Pnt, S: gp_Pln, Tol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElS_4 extends Extrema_ExtPElS {
    constructor(P: gp_Pnt, S: gp_Cone, Tol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElS_5 extends Extrema_ExtPElS {
    constructor(P: gp_Pnt, S: gp_Torus, Tol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElS_6 extends Extrema_ExtPElS {
    constructor(P: gp_Pnt, S: gp_Sphere, Tol: Quantity_AbsorbedDose);
  }

export declare class Extrema_GenLocateExtPS {
  constructor(theS: Adaptor3d_Surface, theTolU: Quantity_AbsorbedDose, theTolV: Quantity_AbsorbedDose)
  Perform(theP: gp_Pnt, theU0: Quantity_AbsorbedDose, theV0: Quantity_AbsorbedDose, isDistanceCriteria: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  Point(): Extrema_POnSurf;
  delete(): void;
}

export declare class Extrema_ExtElC {
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv, P2: Extrema_POnCurv): void;
  delete(): void;
}

  export declare class Extrema_ExtElC_1 extends Extrema_ExtElC {
    constructor();
  }

  export declare class Extrema_ExtElC_2 extends Extrema_ExtElC {
    constructor(C1: gp_Lin, C2: gp_Lin, AngTol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtElC_3 extends Extrema_ExtElC {
    constructor(C1: gp_Lin, C2: gp_Circ, Tol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtElC_4 extends Extrema_ExtElC {
    constructor(C1: gp_Lin, C2: gp_Elips);
  }

  export declare class Extrema_ExtElC_5 extends Extrema_ExtElC {
    constructor(C1: gp_Lin, C2: gp_Hypr);
  }

  export declare class Extrema_ExtElC_6 extends Extrema_ExtElC {
    constructor(C1: gp_Lin, C2: gp_Parab);
  }

  export declare class Extrema_ExtElC_7 extends Extrema_ExtElC {
    constructor(C1: gp_Circ, C2: gp_Circ);
  }

export declare class Extrema_LocECC {
  constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, U0: Quantity_AbsorbedDose, V0: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  Point(P1: Extrema_POnCurv, P2: Extrema_POnCurv): void;
  delete(): void;
}

export declare class Extrema_LocateExtPC2d {
  Initialize(C: Adaptor2d_Curve2d, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d, U0: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  IsMin(): Standard_Boolean;
  Point(): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class Extrema_LocateExtPC2d_1 extends Extrema_LocateExtPC2d {
    constructor();
  }

  export declare class Extrema_LocateExtPC2d_2 extends Extrema_LocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_LocateExtPC2d_3 extends Extrema_LocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_Array2OfPOnSurfParams {
  Init(theValue: Extrema_POnSurfParams): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: Extrema_Array2OfPOnSurfParams): Extrema_Array2OfPOnSurfParams;
  Move(theOther: Extrema_Array2OfPOnSurfParams): Extrema_Array2OfPOnSurfParams;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnSurfParams;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnSurfParams;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Extrema_POnSurfParams): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array2OfPOnSurfParams_1 extends Extrema_Array2OfPOnSurfParams {
    constructor();
  }

  export declare class Extrema_Array2OfPOnSurfParams_2 extends Extrema_Array2OfPOnSurfParams {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class Extrema_Array2OfPOnSurfParams_3 extends Extrema_Array2OfPOnSurfParams {
    constructor(theOther: Extrema_Array2OfPOnSurfParams);
  }

  export declare class Extrema_Array2OfPOnSurfParams_4 extends Extrema_Array2OfPOnSurfParams {
    constructor(theOther: Extrema_Array2OfPOnSurfParams);
  }

  export declare class Extrema_Array2OfPOnSurfParams_5 extends Extrema_Array2OfPOnSurfParams {
    constructor(theBegin: Extrema_POnSurfParams, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Extrema_FuncPSDist extends math_MultipleVarFunctionWithGradient {
  constructor(theS: Adaptor3d_Surface, theP: gp_Pnt)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class Extrema_ExtCC {
  SetCurve_1(theRank: Graphic3d_ZLayerId, C: Adaptor3d_Curve): void;
  SetCurve_2(theRank: Graphic3d_ZLayerId, C: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  SetRange(theRank: Graphic3d_ZLayerId, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  SetTolerance(theRank: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  IsParallel(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv, P2: Extrema_POnCurv): void;
  TrimmedSquareDistances(dist11: Quantity_AbsorbedDose, distP12: Quantity_AbsorbedDose, distP21: Quantity_AbsorbedDose, distP22: Quantity_AbsorbedDose, P11: gp_Pnt, P12: gp_Pnt, P21: gp_Pnt, P22: gp_Pnt): void;
  SetSingleSolutionFlag(theSingleSolutionFlag: Standard_Boolean): void;
  GetSingleSolutionFlag(): Standard_Boolean;
  delete(): void;
}

  export declare class Extrema_ExtCC_1 extends Extrema_ExtCC {
    constructor(TolC1: Quantity_AbsorbedDose, TolC2: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtCC_2 extends Extrema_ExtCC {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, TolC1: Quantity_AbsorbedDose, TolC2: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtCC_3 extends Extrema_ExtCC {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TolC1: Quantity_AbsorbedDose, TolC2: Quantity_AbsorbedDose);
  }

export declare class Extrema_ExtPS {
  Initialize(S: Adaptor3d_Surface, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  TrimmedSquareDistances(dUfVf: Quantity_AbsorbedDose, dUfVl: Quantity_AbsorbedDose, dUlVf: Quantity_AbsorbedDose, dUlVl: Quantity_AbsorbedDose, PUfVf: gp_Pnt, PUfVl: gp_Pnt, PUlVf: gp_Pnt, PUlVl: gp_Pnt): void;
  SetFlag(F: Extrema_ExtFlag): void;
  SetAlgo(A: Extrema_ExtAlgo): void;
  delete(): void;
}

  export declare class Extrema_ExtPS_1 extends Extrema_ExtPS {
    constructor();
  }

  export declare class Extrema_ExtPS_2 extends Extrema_ExtPS {
    constructor(P: gp_Pnt, S: Adaptor3d_Surface, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

  export declare class Extrema_ExtPS_3 extends Extrema_ExtPS {
    constructor(P: gp_Pnt, S: Adaptor3d_Surface, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

export declare class Handle_Extrema_HArray2OfPOnCurv {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray2OfPOnCurv): void;
  get(): Extrema_HArray2OfPOnCurv;
  delete(): void;
}

  export declare class Handle_Extrema_HArray2OfPOnCurv_1 extends Handle_Extrema_HArray2OfPOnCurv {
    constructor();
  }

  export declare class Handle_Extrema_HArray2OfPOnCurv_2 extends Handle_Extrema_HArray2OfPOnCurv {
    constructor(thePtr: Extrema_HArray2OfPOnCurv);
  }

  export declare class Handle_Extrema_HArray2OfPOnCurv_3 extends Handle_Extrema_HArray2OfPOnCurv {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnCurv);
  }

  export declare class Handle_Extrema_HArray2OfPOnCurv_4 extends Handle_Extrema_HArray2OfPOnCurv {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnCurv);
  }

export declare class Handle_Extrema_HArray1OfPOnSurf {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray1OfPOnSurf): void;
  get(): Extrema_HArray1OfPOnSurf;
  delete(): void;
}

  export declare class Handle_Extrema_HArray1OfPOnSurf_1 extends Handle_Extrema_HArray1OfPOnSurf {
    constructor();
  }

  export declare class Handle_Extrema_HArray1OfPOnSurf_2 extends Handle_Extrema_HArray1OfPOnSurf {
    constructor(thePtr: Extrema_HArray1OfPOnSurf);
  }

  export declare class Handle_Extrema_HArray1OfPOnSurf_3 extends Handle_Extrema_HArray1OfPOnSurf {
    constructor(theHandle: Handle_Extrema_HArray1OfPOnSurf);
  }

  export declare class Handle_Extrema_HArray1OfPOnSurf_4 extends Handle_Extrema_HArray1OfPOnSurf {
    constructor(theHandle: Handle_Extrema_HArray1OfPOnSurf);
  }

export declare type Extrema_ElementType = {
  Extrema_Node: {};
  Extrema_UIsoEdge: {};
  Extrema_VIsoEdge: {};
  Extrema_Face: {};
}

export declare class Extrema_ExtPC2d {
  Initialize(C: Adaptor2d_Curve2d, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d): void;
  IsDone(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbExt(): Graphic3d_ZLayerId;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  TrimmedSquareDistances(dist1: Quantity_AbsorbedDose, dist2: Quantity_AbsorbedDose, P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  delete(): void;
}

  export declare class Extrema_ExtPC2d_1 extends Extrema_ExtPC2d {
    constructor();
  }

  export declare class Extrema_ExtPC2d_2 extends Extrema_ExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPC2d_3 extends Extrema_ExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_GlobOptFuncCCC0 extends math_MultipleVarFunction {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class Extrema_GlobOptFuncCCC0_1 extends Extrema_GlobOptFuncCCC0 {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve);
  }

  export declare class Extrema_GlobOptFuncCCC0_2 extends Extrema_GlobOptFuncCCC0 {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d);
  }

export declare class Extrema_GlobOptFuncCCC2 extends math_MultipleVarFunctionWithHessian {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values_1(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  Values_2(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector, H: math_Matrix): Standard_Boolean;
  delete(): void;
}

  export declare class Extrema_GlobOptFuncCCC2_1 extends Extrema_GlobOptFuncCCC2 {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve);
  }

  export declare class Extrema_GlobOptFuncCCC2_2 extends Extrema_GlobOptFuncCCC2 {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d);
  }

export declare class Extrema_GlobOptFuncCCC1 extends math_MultipleVarFunctionWithGradient {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  delete(): void;
}

  export declare class Extrema_GlobOptFuncCCC1_1 extends Extrema_GlobOptFuncCCC1 {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve);
  }

  export declare class Extrema_GlobOptFuncCCC1_2 extends Extrema_GlobOptFuncCCC1 {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d);
  }

export declare class Extrema_Array2OfPOnCurv2d {
  Init(theValue: Extrema_POnCurv2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: Extrema_Array2OfPOnCurv2d): Extrema_Array2OfPOnCurv2d;
  Move(theOther: Extrema_Array2OfPOnCurv2d): Extrema_Array2OfPOnCurv2d;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnCurv2d;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnCurv2d;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Extrema_POnCurv2d): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array2OfPOnCurv2d_1 extends Extrema_Array2OfPOnCurv2d {
    constructor();
  }

  export declare class Extrema_Array2OfPOnCurv2d_2 extends Extrema_Array2OfPOnCurv2d {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class Extrema_Array2OfPOnCurv2d_3 extends Extrema_Array2OfPOnCurv2d {
    constructor(theOther: Extrema_Array2OfPOnCurv2d);
  }

  export declare class Extrema_Array2OfPOnCurv2d_4 extends Extrema_Array2OfPOnCurv2d {
    constructor(theOther: Extrema_Array2OfPOnCurv2d);
  }

  export declare class Extrema_Array2OfPOnCurv2d_5 extends Extrema_Array2OfPOnCurv2d {
    constructor(theBegin: Extrema_POnCurv2d, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Extrema_GlobOptFuncCQuadric extends math_MultipleVarFunction {
  LoadQuad(S: Adaptor3d_Surface, theUf: Quantity_AbsorbedDose, theUl: Quantity_AbsorbedDose, theVf: Quantity_AbsorbedDose, theVl: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  Value(theX: math_Vector, theF: Quantity_AbsorbedDose): Standard_Boolean;
  QuadricParameters(theCT: math_Vector, theUV: math_Vector): void;
  delete(): void;
}

  export declare class Extrema_GlobOptFuncCQuadric_1 extends Extrema_GlobOptFuncCQuadric {
    constructor(C: Adaptor3d_Curve);
  }

  export declare class Extrema_GlobOptFuncCQuadric_2 extends Extrema_GlobOptFuncCQuadric {
    constructor(C: Adaptor3d_Curve, theTf: Quantity_AbsorbedDose, theTl: Quantity_AbsorbedDose);
  }

  export declare class Extrema_GlobOptFuncCQuadric_3 extends Extrema_GlobOptFuncCQuadric {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface);
  }

export declare class Extrema_SequenceOfPOnSurf extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Extrema_SequenceOfPOnSurf): Extrema_SequenceOfPOnSurf;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Extrema_POnSurf): void;
  Append_2(theSeq: Extrema_SequenceOfPOnSurf): void;
  Prepend_1(theItem: Extrema_POnSurf): void;
  Prepend_2(theSeq: Extrema_SequenceOfPOnSurf): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Extrema_POnSurf): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnSurf): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnSurf): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Extrema_POnSurf): void;
  Split(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnSurf): void;
  First(): Extrema_POnSurf;
  ChangeFirst(): Extrema_POnSurf;
  Last(): Extrema_POnSurf;
  ChangeLast(): Extrema_POnSurf;
  Value(theIndex: Standard_Integer): Extrema_POnSurf;
  ChangeValue(theIndex: Standard_Integer): Extrema_POnSurf;
  SetValue(theIndex: Standard_Integer, theItem: Extrema_POnSurf): void;
  delete(): void;
}

  export declare class Extrema_SequenceOfPOnSurf_1 extends Extrema_SequenceOfPOnSurf {
    constructor();
  }

  export declare class Extrema_SequenceOfPOnSurf_2 extends Extrema_SequenceOfPOnSurf {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Extrema_SequenceOfPOnSurf_3 extends Extrema_SequenceOfPOnSurf {
    constructor(theOther: Extrema_SequenceOfPOnSurf);
  }

export declare class Extrema_PCFOfEPCOfExtPC2d extends math_FunctionWithDerivative {
  Initialize(C: Adaptor2d_Curve2d): void;
  SetPoint(P: gp_Pnt2d): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_PCFOfEPCOfExtPC2d_1 extends Extrema_PCFOfEPCOfExtPC2d {
    constructor();
  }

  export declare class Extrema_PCFOfEPCOfExtPC2d_2 extends Extrema_PCFOfEPCOfExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d);
  }

export declare class Handle_Extrema_HArray2OfPOnSurfParams {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray2OfPOnSurfParams): void;
  get(): Extrema_HArray2OfPOnSurfParams;
  delete(): void;
}

  export declare class Handle_Extrema_HArray2OfPOnSurfParams_1 extends Handle_Extrema_HArray2OfPOnSurfParams {
    constructor();
  }

  export declare class Handle_Extrema_HArray2OfPOnSurfParams_2 extends Handle_Extrema_HArray2OfPOnSurfParams {
    constructor(thePtr: Extrema_HArray2OfPOnSurfParams);
  }

  export declare class Handle_Extrema_HArray2OfPOnSurfParams_3 extends Handle_Extrema_HArray2OfPOnSurfParams {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnSurfParams);
  }

  export declare class Handle_Extrema_HArray2OfPOnSurfParams_4 extends Handle_Extrema_HArray2OfPOnSurfParams {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnSurfParams);
  }

export declare class Handle_Extrema_HArray2OfPOnSurf {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray2OfPOnSurf): void;
  get(): Extrema_HArray2OfPOnSurf;
  delete(): void;
}

  export declare class Handle_Extrema_HArray2OfPOnSurf_1 extends Handle_Extrema_HArray2OfPOnSurf {
    constructor();
  }

  export declare class Handle_Extrema_HArray2OfPOnSurf_2 extends Handle_Extrema_HArray2OfPOnSurf {
    constructor(thePtr: Extrema_HArray2OfPOnSurf);
  }

  export declare class Handle_Extrema_HArray2OfPOnSurf_3 extends Handle_Extrema_HArray2OfPOnSurf {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnSurf);
  }

  export declare class Handle_Extrema_HArray2OfPOnSurf_4 extends Handle_Extrema_HArray2OfPOnSurf {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnSurf);
  }

export declare class Extrema_ExtElC2d {
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv2d, P2: Extrema_POnCurv2d): void;
  delete(): void;
}

  export declare class Extrema_ExtElC2d_1 extends Extrema_ExtElC2d {
    constructor();
  }

  export declare class Extrema_ExtElC2d_2 extends Extrema_ExtElC2d {
    constructor(C1: gp_Lin2d, C2: gp_Lin2d, AngTol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtElC2d_3 extends Extrema_ExtElC2d {
    constructor(C1: gp_Lin2d, C2: gp_Circ2d, Tol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtElC2d_4 extends Extrema_ExtElC2d {
    constructor(C1: gp_Lin2d, C2: gp_Elips2d);
  }

  export declare class Extrema_ExtElC2d_5 extends Extrema_ExtElC2d {
    constructor(C1: gp_Lin2d, C2: gp_Hypr2d);
  }

  export declare class Extrema_ExtElC2d_6 extends Extrema_ExtElC2d {
    constructor(C1: gp_Lin2d, C2: gp_Parab2d);
  }

  export declare class Extrema_ExtElC2d_7 extends Extrema_ExtElC2d {
    constructor(C1: gp_Circ2d, C2: gp_Circ2d);
  }

  export declare class Extrema_ExtElC2d_8 extends Extrema_ExtElC2d {
    constructor(C1: gp_Circ2d, C2: gp_Elips2d);
  }

  export declare class Extrema_ExtElC2d_9 extends Extrema_ExtElC2d {
    constructor(C1: gp_Circ2d, C2: gp_Hypr2d);
  }

  export declare class Extrema_ExtElC2d_10 extends Extrema_ExtElC2d {
    constructor(C1: gp_Circ2d, C2: gp_Parab2d);
  }

export declare class Extrema_GenLocateExtSS {
  Perform(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  PointOnS1(): Extrema_POnSurf;
  PointOnS2(): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_GenLocateExtSS_1 extends Extrema_GenLocateExtSS {
    constructor();
  }

  export declare class Extrema_GenLocateExtSS_2 extends Extrema_GenLocateExtSS {
    constructor(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

export declare class Handle_Extrema_HArray1OfPOnCurv2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray1OfPOnCurv2d): void;
  get(): Extrema_HArray1OfPOnCurv2d;
  delete(): void;
}

  export declare class Handle_Extrema_HArray1OfPOnCurv2d_1 extends Handle_Extrema_HArray1OfPOnCurv2d {
    constructor();
  }

  export declare class Handle_Extrema_HArray1OfPOnCurv2d_2 extends Handle_Extrema_HArray1OfPOnCurv2d {
    constructor(thePtr: Extrema_HArray1OfPOnCurv2d);
  }

  export declare class Handle_Extrema_HArray1OfPOnCurv2d_3 extends Handle_Extrema_HArray1OfPOnCurv2d {
    constructor(theHandle: Handle_Extrema_HArray1OfPOnCurv2d);
  }

  export declare class Handle_Extrema_HArray1OfPOnCurv2d_4 extends Handle_Extrema_HArray1OfPOnCurv2d {
    constructor(theHandle: Handle_Extrema_HArray1OfPOnCurv2d);
  }

export declare class Extrema_GenExtSS {
  Initialize_1(S2: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Tol2: Quantity_AbsorbedDose): void;
  Initialize_2(S2: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, U2min: Quantity_AbsorbedDose, U2sup: Quantity_AbsorbedDose, V2min: Quantity_AbsorbedDose, V2sup: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  Perform_1(S1: Adaptor3d_Surface, Tol1: Quantity_AbsorbedDose): void;
  Perform_2(S1: Adaptor3d_Surface, U1min: Quantity_AbsorbedDose, U1sup: Quantity_AbsorbedDose, V1min: Quantity_AbsorbedDose, V1sup: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  PointOnS1(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  PointOnS2(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_GenExtSS_1 extends Extrema_GenExtSS {
    constructor();
  }

  export declare class Extrema_GenExtSS_2 extends Extrema_GenExtSS {
    constructor(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

  export declare class Extrema_GenExtSS_3 extends Extrema_GenExtSS {
    constructor(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, U1min: Quantity_AbsorbedDose, U1sup: Quantity_AbsorbedDose, V1min: Quantity_AbsorbedDose, V1sup: Quantity_AbsorbedDose, U2min: Quantity_AbsorbedDose, U2sup: Quantity_AbsorbedDose, V2min: Quantity_AbsorbedDose, V2sup: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

export declare class Extrema_POnCurv2d {
  SetValues(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  Value(): gp_Pnt2d;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_POnCurv2d_1 extends Extrema_POnCurv2d {
    constructor();
  }

  export declare class Extrema_POnCurv2d_2 extends Extrema_POnCurv2d {
    constructor(U: Quantity_AbsorbedDose, P: gp_Pnt2d);
  }

export declare class Extrema_Array1OfPOnCurv {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Extrema_POnCurv): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Extrema_Array1OfPOnCurv): Extrema_Array1OfPOnCurv;
  Move(theOther: Extrema_Array1OfPOnCurv): Extrema_Array1OfPOnCurv;
  First(): Extrema_POnCurv;
  ChangeFirst(): Extrema_POnCurv;
  Last(): Extrema_POnCurv;
  ChangeLast(): Extrema_POnCurv;
  Value(theIndex: Standard_Integer): Extrema_POnCurv;
  ChangeValue(theIndex: Standard_Integer): Extrema_POnCurv;
  SetValue(theIndex: Standard_Integer, theItem: Extrema_POnCurv): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array1OfPOnCurv_1 extends Extrema_Array1OfPOnCurv {
    constructor();
  }

  export declare class Extrema_Array1OfPOnCurv_2 extends Extrema_Array1OfPOnCurv {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Extrema_Array1OfPOnCurv_3 extends Extrema_Array1OfPOnCurv {
    constructor(theOther: Extrema_Array1OfPOnCurv);
  }

  export declare class Extrema_Array1OfPOnCurv_4 extends Extrema_Array1OfPOnCurv {
    constructor(theOther: Extrema_Array1OfPOnCurv);
  }

  export declare class Extrema_Array1OfPOnCurv_5 extends Extrema_Array1OfPOnCurv {
    constructor(theBegin: Extrema_POnCurv, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Extrema_PCLocFOfLocEPCOfLocateExtPC extends math_FunctionWithDerivative {
  Initialize(C: Adaptor3d_Curve): void;
  SetPoint(P: gp_Pnt): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_PCLocFOfLocEPCOfLocateExtPC_1 extends Extrema_PCLocFOfLocEPCOfLocateExtPC {
    constructor();
  }

  export declare class Extrema_PCLocFOfLocEPCOfLocateExtPC_2 extends Extrema_PCLocFOfLocEPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve);
  }

export declare class Extrema_EPCOfExtPC {
  Initialize_1(C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_2(C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor3d_Curve): void;
  Initialize_4(NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  delete(): void;
}

  export declare class Extrema_EPCOfExtPC_1 extends Extrema_EPCOfExtPC {
    constructor();
  }

  export declare class Extrema_EPCOfExtPC_2 extends Extrema_EPCOfExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_EPCOfExtPC_3 extends Extrema_EPCOfExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

export declare class Handle_Extrema_ExtPExtS {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_ExtPExtS): void;
  get(): Extrema_ExtPExtS;
  delete(): void;
}

  export declare class Handle_Extrema_ExtPExtS_1 extends Handle_Extrema_ExtPExtS {
    constructor();
  }

  export declare class Handle_Extrema_ExtPExtS_2 extends Handle_Extrema_ExtPExtS {
    constructor(thePtr: Extrema_ExtPExtS);
  }

  export declare class Handle_Extrema_ExtPExtS_3 extends Handle_Extrema_ExtPExtS {
    constructor(theHandle: Handle_Extrema_ExtPExtS);
  }

  export declare class Handle_Extrema_ExtPExtS_4 extends Handle_Extrema_ExtPExtS {
    constructor(theHandle: Handle_Extrema_ExtPExtS);
  }

export declare class Extrema_ExtPExtS extends Standard_Transient {
  Initialize(S: Handle_GeomAdaptor_HSurfaceOfLinearExtrusion, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Extrema_ExtPExtS_1 extends Extrema_ExtPExtS {
    constructor();
  }

  export declare class Extrema_ExtPExtS_2 extends Extrema_ExtPExtS {
    constructor(P: gp_Pnt, S: Handle_GeomAdaptor_HSurfaceOfLinearExtrusion, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPExtS_3 extends Extrema_ExtPExtS {
    constructor(P: gp_Pnt, S: Handle_GeomAdaptor_HSurfaceOfLinearExtrusion, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

export declare class Extrema_ExtSS {
  Initialize(S2: Adaptor3d_Surface, Uinf2: Quantity_AbsorbedDose, Usup2: Quantity_AbsorbedDose, Vinf2: Quantity_AbsorbedDose, Vsup2: Quantity_AbsorbedDose, TolS1: Quantity_AbsorbedDose): void;
  Perform(S1: Adaptor3d_Surface, Uinf1: Quantity_AbsorbedDose, Usup1: Quantity_AbsorbedDose, Vinf1: Quantity_AbsorbedDose, Vsup1: Quantity_AbsorbedDose, TolS1: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnSurf, P2: Extrema_POnSurf): void;
  delete(): void;
}

  export declare class Extrema_ExtSS_1 extends Extrema_ExtSS {
    constructor();
  }

  export declare class Extrema_ExtSS_2 extends Extrema_ExtSS {
    constructor(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface, TolS1: Quantity_AbsorbedDose, TolS2: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtSS_3 extends Extrema_ExtSS {
    constructor(S1: Adaptor3d_Surface, S2: Adaptor3d_Surface, Uinf1: Quantity_AbsorbedDose, Usup1: Quantity_AbsorbedDose, Vinf1: Quantity_AbsorbedDose, Vsup1: Quantity_AbsorbedDose, Uinf2: Quantity_AbsorbedDose, Usup2: Quantity_AbsorbedDose, Vinf2: Quantity_AbsorbedDose, Vsup2: Quantity_AbsorbedDose, TolS1: Quantity_AbsorbedDose, TolS2: Quantity_AbsorbedDose);
  }

export declare class Extrema_PCFOfEPCOfELPCOfLocateExtPC2d extends math_FunctionWithDerivative {
  Initialize(C: Adaptor2d_Curve2d): void;
  SetPoint(P: gp_Pnt2d): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_PCFOfEPCOfELPCOfLocateExtPC2d_1 extends Extrema_PCFOfEPCOfELPCOfLocateExtPC2d {
    constructor();
  }

  export declare class Extrema_PCFOfEPCOfELPCOfLocateExtPC2d_2 extends Extrema_PCFOfEPCOfELPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d);
  }

export declare class Extrema_ExtElCS {
  Perform_1(C: gp_Lin, S: gp_Pln): void;
  Perform_2(C: gp_Lin, S: gp_Cylinder): void;
  Perform_3(C: gp_Lin, S: gp_Cone): void;
  Perform_4(C: gp_Lin, S: gp_Sphere): void;
  Perform_5(C: gp_Lin, S: gp_Torus): void;
  Perform_6(C: gp_Circ, S: gp_Pln): void;
  Perform_7(C: gp_Circ, S: gp_Cylinder): void;
  Perform_8(C: gp_Circ, S: gp_Cone): void;
  Perform_9(C: gp_Circ, S: gp_Sphere): void;
  Perform_10(C: gp_Circ, S: gp_Torus): void;
  Perform_11(C: gp_Hypr, S: gp_Pln): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv, P2: Extrema_POnSurf): void;
  delete(): void;
}

  export declare class Extrema_ExtElCS_1 extends Extrema_ExtElCS {
    constructor();
  }

  export declare class Extrema_ExtElCS_2 extends Extrema_ExtElCS {
    constructor(C: gp_Lin, S: gp_Pln);
  }

  export declare class Extrema_ExtElCS_3 extends Extrema_ExtElCS {
    constructor(C: gp_Lin, S: gp_Cylinder);
  }

  export declare class Extrema_ExtElCS_4 extends Extrema_ExtElCS {
    constructor(C: gp_Lin, S: gp_Cone);
  }

  export declare class Extrema_ExtElCS_5 extends Extrema_ExtElCS {
    constructor(C: gp_Lin, S: gp_Sphere);
  }

  export declare class Extrema_ExtElCS_6 extends Extrema_ExtElCS {
    constructor(C: gp_Lin, S: gp_Torus);
  }

  export declare class Extrema_ExtElCS_7 extends Extrema_ExtElCS {
    constructor(C: gp_Circ, S: gp_Pln);
  }

  export declare class Extrema_ExtElCS_8 extends Extrema_ExtElCS {
    constructor(C: gp_Circ, S: gp_Cylinder);
  }

  export declare class Extrema_ExtElCS_9 extends Extrema_ExtElCS {
    constructor(C: gp_Circ, S: gp_Cone);
  }

  export declare class Extrema_ExtElCS_10 extends Extrema_ExtElCS {
    constructor(C: gp_Circ, S: gp_Sphere);
  }

  export declare class Extrema_ExtElCS_11 extends Extrema_ExtElCS {
    constructor(C: gp_Circ, S: gp_Torus);
  }

  export declare class Extrema_ExtElCS_12 extends Extrema_ExtElCS {
    constructor(C: gp_Hypr, S: gp_Pln);
  }

export declare class Extrema_LocateExtPC {
  Initialize(C: Adaptor3d_Curve, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt, U0: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  IsMin(): Standard_Boolean;
  Point(): Extrema_POnCurv;
  delete(): void;
}

  export declare class Extrema_LocateExtPC_1 extends Extrema_LocateExtPC {
    constructor();
  }

  export declare class Extrema_LocateExtPC_2 extends Extrema_LocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, U0: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_LocateExtPC_3 extends Extrema_LocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, U0: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_ExtPElC {
  Perform_1(P: gp_Pnt, C: gp_Lin, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_2(P: gp_Pnt, C: gp_Circ, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_3(P: gp_Pnt, C: gp_Elips, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_4(P: gp_Pnt, C: gp_Hypr, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_5(P: gp_Pnt, C: gp_Parab, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  delete(): void;
}

  export declare class Extrema_ExtPElC_1 extends Extrema_ExtPElC {
    constructor();
  }

  export declare class Extrema_ExtPElC_2 extends Extrema_ExtPElC {
    constructor(P: gp_Pnt, C: gp_Lin, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC_3 extends Extrema_ExtPElC {
    constructor(P: gp_Pnt, C: gp_Circ, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC_4 extends Extrema_ExtPElC {
    constructor(P: gp_Pnt, C: gp_Elips, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC_5 extends Extrema_ExtPElC {
    constructor(P: gp_Pnt, C: gp_Hypr, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC_6 extends Extrema_ExtPElC {
    constructor(P: gp_Pnt, C: gp_Parab, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

export declare class Extrema_POnCurv {
  SetValues(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  Value(): gp_Pnt;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_POnCurv_1 extends Extrema_POnCurv {
    constructor();
  }

  export declare class Extrema_POnCurv_2 extends Extrema_POnCurv {
    constructor(U: Quantity_AbsorbedDose, P: gp_Pnt);
  }

export declare class Extrema_EPCOfELPCOfLocateExtPC {
  Initialize_1(C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_2(C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor3d_Curve): void;
  Initialize_4(NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  delete(): void;
}

  export declare class Extrema_EPCOfELPCOfLocateExtPC_1 extends Extrema_EPCOfELPCOfLocateExtPC {
    constructor();
  }

  export declare class Extrema_EPCOfELPCOfLocateExtPC_2 extends Extrema_EPCOfELPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_EPCOfELPCOfLocateExtPC_3 extends Extrema_EPCOfELPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

export declare class Extrema_ECC {
  SetParams(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  SetSingleSolutionFlag(theSingleSolutionFlag: Standard_Boolean): void;
  GetSingleSolutionFlag(): Standard_Boolean;
  Perform(): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv, P2: Extrema_POnCurv): void;
  delete(): void;
}

  export declare class Extrema_ECC_1 extends Extrema_ECC {
    constructor();
  }

  export declare class Extrema_ECC_2 extends Extrema_ECC {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve);
  }

  export declare class Extrema_ECC_3 extends Extrema_ECC {
    constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vinf: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose);
  }

export declare class Extrema_ExtCC2d {
  Initialize(C2: Adaptor2d_Curve2d, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TolC1: Quantity_AbsorbedDose, TolC2: Quantity_AbsorbedDose): void;
  Perform(C1: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  IsParallel(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv2d, P2: Extrema_POnCurv2d): void;
  TrimmedSquareDistances(dist11: Quantity_AbsorbedDose, distP12: Quantity_AbsorbedDose, distP21: Quantity_AbsorbedDose, distP22: Quantity_AbsorbedDose, P11: gp_Pnt2d, P12: gp_Pnt2d, P21: gp_Pnt2d, P22: gp_Pnt2d): void;
  SetSingleSolutionFlag(theSingleSolutionFlag: Standard_Boolean): void;
  GetSingleSolutionFlag(): Standard_Boolean;
  delete(): void;
}

  export declare class Extrema_ExtCC2d_1 extends Extrema_ExtCC2d {
    constructor();
  }

  export declare class Extrema_ExtCC2d_2 extends Extrema_ExtCC2d {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, TolC1: Quantity_AbsorbedDose, TolC2: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtCC2d_3 extends Extrema_ExtCC2d {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TolC1: Quantity_AbsorbedDose, TolC2: Quantity_AbsorbedDose);
  }

export declare class Extrema_Array2OfPOnCurv {
  Init(theValue: Extrema_POnCurv): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: Extrema_Array2OfPOnCurv): Extrema_Array2OfPOnCurv;
  Move(theOther: Extrema_Array2OfPOnCurv): Extrema_Array2OfPOnCurv;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnCurv;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnCurv;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Extrema_POnCurv): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array2OfPOnCurv_1 extends Extrema_Array2OfPOnCurv {
    constructor();
  }

  export declare class Extrema_Array2OfPOnCurv_2 extends Extrema_Array2OfPOnCurv {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class Extrema_Array2OfPOnCurv_3 extends Extrema_Array2OfPOnCurv {
    constructor(theOther: Extrema_Array2OfPOnCurv);
  }

  export declare class Extrema_Array2OfPOnCurv_4 extends Extrema_Array2OfPOnCurv {
    constructor(theOther: Extrema_Array2OfPOnCurv);
  }

  export declare class Extrema_Array2OfPOnCurv_5 extends Extrema_Array2OfPOnCurv {
    constructor(theBegin: Extrema_POnCurv, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Extrema_Curve2dTool {
  constructor();
  static FirstParameter(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static LastParameter(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static Continuity(C: Adaptor2d_Curve2d): GeomAbs_Shape;
  static NbIntervals(C: Adaptor2d_Curve2d, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Adaptor2d_Curve2d, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static DeflCurvIntervals(C: Adaptor2d_Curve2d): Handle_TColStd_HArray1OfReal;
  static IsClosed(C: Adaptor2d_Curve2d): Standard_Boolean;
  static IsPeriodic(C: Adaptor2d_Curve2d): Standard_Boolean;
  static Period(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static Value(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose): gp_Pnt2d;
  static D0(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D2(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static DN(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static Resolution(C: Adaptor2d_Curve2d, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Adaptor2d_Curve2d): GeomAbs_CurveType;
  static Line(C: Adaptor2d_Curve2d): gp_Lin2d;
  static Circle(C: Adaptor2d_Curve2d): gp_Circ2d;
  static Ellipse(C: Adaptor2d_Curve2d): gp_Elips2d;
  static Hyperbola(C: Adaptor2d_Curve2d): gp_Hypr2d;
  static Parabola(C: Adaptor2d_Curve2d): gp_Parab2d;
  static Degree(C: Adaptor2d_Curve2d): Graphic3d_ZLayerId;
  static IsRational(C: Adaptor2d_Curve2d): Standard_Boolean;
  static NbPoles(C: Adaptor2d_Curve2d): Graphic3d_ZLayerId;
  static NbKnots(C: Adaptor2d_Curve2d): Graphic3d_ZLayerId;
  static Bezier(C: Adaptor2d_Curve2d): Handle_Geom2d_BezierCurve;
  static BSpline(C: Adaptor2d_Curve2d): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

export declare class Extrema_GenExtCS {
  Initialize_1(S: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Tol2: Quantity_AbsorbedDose): void;
  Initialize_2(S: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  Perform_1(C: Adaptor3d_Curve, NbT: Graphic3d_ZLayerId, Tol1: Quantity_AbsorbedDose): void;
  Perform_2(C: Adaptor3d_Curve, NbT: Graphic3d_ZLayerId, tmin: Quantity_AbsorbedDose, tsup: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  PointOnCurve(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  PointOnSurface(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_GenExtCS_1 extends Extrema_GenExtCS {
    constructor();
  }

  export declare class Extrema_GenExtCS_2 extends Extrema_GenExtCS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface, NbT: Graphic3d_ZLayerId, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

  export declare class Extrema_GenExtCS_3 extends Extrema_GenExtCS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface, NbT: Graphic3d_ZLayerId, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, tmin: Quantity_AbsorbedDose, tsup: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

export declare class Extrema_Array2OfPOnSurf {
  Init(theValue: Extrema_POnSurf): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: Extrema_Array2OfPOnSurf): Extrema_Array2OfPOnSurf;
  Move(theOther: Extrema_Array2OfPOnSurf): Extrema_Array2OfPOnSurf;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnSurf;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): Extrema_POnSurf;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: Extrema_POnSurf): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array2OfPOnSurf_1 extends Extrema_Array2OfPOnSurf {
    constructor();
  }

  export declare class Extrema_Array2OfPOnSurf_2 extends Extrema_Array2OfPOnSurf {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class Extrema_Array2OfPOnSurf_3 extends Extrema_Array2OfPOnSurf {
    constructor(theOther: Extrema_Array2OfPOnSurf);
  }

  export declare class Extrema_Array2OfPOnSurf_4 extends Extrema_Array2OfPOnSurf {
    constructor(theOther: Extrema_Array2OfPOnSurf);
  }

  export declare class Extrema_Array2OfPOnSurf_5 extends Extrema_Array2OfPOnSurf {
    constructor(theBegin: Extrema_POnSurf, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Extrema_LocECC2d {
  constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, V0: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  Point(P1: Extrema_POnCurv2d, P2: Extrema_POnCurv2d): void;
  delete(): void;
}

export declare class Extrema_LocEPCOfLocateExtPC2d {
  Initialize(C: Adaptor2d_Curve2d, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d, U0: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  IsMin(): Standard_Boolean;
  Point(): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class Extrema_LocEPCOfLocateExtPC2d_1 extends Extrema_LocEPCOfLocateExtPC2d {
    constructor();
  }

  export declare class Extrema_LocEPCOfLocateExtPC2d_2 extends Extrema_LocEPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

  export declare class Extrema_LocEPCOfLocateExtPC2d_3 extends Extrema_LocEPCOfLocateExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

export declare class Extrema_FuncExtCS extends math_FunctionSetWithDerivatives {
  Initialize(C: Adaptor3d_Curve, S: Adaptor3d_Surface): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(UV: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(UV: math_Vector, DF: math_Matrix): Standard_Boolean;
  Values(UV: math_Vector, F: math_Vector, DF: math_Matrix): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  PointOnCurve(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  PointOnSurface(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  SquareDistances(): TColStd_SequenceOfReal;
  PointsOnCurve(): Extrema_SequenceOfPOnCurv;
  PointsOnSurf(): Extrema_SequenceOfPOnSurf;
  delete(): void;
}

  export declare class Extrema_FuncExtCS_1 extends Extrema_FuncExtCS {
    constructor();
  }

  export declare class Extrema_FuncExtCS_2 extends Extrema_FuncExtCS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface);
  }

export declare class Extrema_LocateExtCC2d {
  constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, V0: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  Point(P1: Extrema_POnCurv2d, P2: Extrema_POnCurv2d): void;
  delete(): void;
}

export declare class Extrema_ExtPElC2d {
  Perform_1(P: gp_Pnt2d, L: gp_Lin2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_2(P: gp_Pnt2d, C: gp_Circ2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_3(P: gp_Pnt2d, C: gp_Elips2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_4(P: gp_Pnt2d, C: gp_Hypr2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  Perform_5(P: gp_Pnt2d, C: gp_Parab2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class Extrema_ExtPElC2d_1 extends Extrema_ExtPElC2d {
    constructor();
  }

  export declare class Extrema_ExtPElC2d_2 extends Extrema_ExtPElC2d {
    constructor(P: gp_Pnt2d, C: gp_Lin2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC2d_3 extends Extrema_ExtPElC2d {
    constructor(P: gp_Pnt2d, C: gp_Circ2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC2d_4 extends Extrema_ExtPElC2d {
    constructor(P: gp_Pnt2d, C: gp_Elips2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC2d_5 extends Extrema_ExtPElC2d {
    constructor(P: gp_Pnt2d, C: gp_Hypr2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPElC2d_6 extends Extrema_ExtPElC2d {
    constructor(P: gp_Pnt2d, C: gp_Parab2d, Tol: Quantity_AbsorbedDose, Uinf: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose);
  }

export declare class Extrema_SequenceOfPOnCurv2d extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Extrema_SequenceOfPOnCurv2d): Extrema_SequenceOfPOnCurv2d;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Extrema_POnCurv2d): void;
  Append_2(theSeq: Extrema_SequenceOfPOnCurv2d): void;
  Prepend_1(theItem: Extrema_POnCurv2d): void;
  Prepend_2(theSeq: Extrema_SequenceOfPOnCurv2d): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Extrema_POnCurv2d): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnCurv2d): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnCurv2d): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Extrema_POnCurv2d): void;
  Split(theIndex: Standard_Integer, theSeq: Extrema_SequenceOfPOnCurv2d): void;
  First(): Extrema_POnCurv2d;
  ChangeFirst(): Extrema_POnCurv2d;
  Last(): Extrema_POnCurv2d;
  ChangeLast(): Extrema_POnCurv2d;
  Value(theIndex: Standard_Integer): Extrema_POnCurv2d;
  ChangeValue(theIndex: Standard_Integer): Extrema_POnCurv2d;
  SetValue(theIndex: Standard_Integer, theItem: Extrema_POnCurv2d): void;
  delete(): void;
}

  export declare class Extrema_SequenceOfPOnCurv2d_1 extends Extrema_SequenceOfPOnCurv2d {
    constructor();
  }

  export declare class Extrema_SequenceOfPOnCurv2d_2 extends Extrema_SequenceOfPOnCurv2d {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Extrema_SequenceOfPOnCurv2d_3 extends Extrema_SequenceOfPOnCurv2d {
    constructor(theOther: Extrema_SequenceOfPOnCurv2d);
  }

export declare class Extrema_EPCOfExtPC2d {
  Initialize_1(C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_2(C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Initialize_3(C: Adaptor2d_Curve2d): void;
  Initialize_4(NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class Extrema_EPCOfExtPC2d_1 extends Extrema_EPCOfExtPC2d {
    constructor();
  }

  export declare class Extrema_EPCOfExtPC2d_2 extends Extrema_EPCOfExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

  export declare class Extrema_EPCOfExtPC2d_3 extends Extrema_EPCOfExtPC2d {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, NbU: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolF: Quantity_AbsorbedDose);
  }

export declare type Extrema_ExtAlgo = {
  Extrema_ExtAlgo_Grad: {};
  Extrema_ExtAlgo_Tree: {};
}

export declare class Handle_Extrema_ExtPRevS {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_ExtPRevS): void;
  get(): Extrema_ExtPRevS;
  delete(): void;
}

  export declare class Handle_Extrema_ExtPRevS_1 extends Handle_Extrema_ExtPRevS {
    constructor();
  }

  export declare class Handle_Extrema_ExtPRevS_2 extends Handle_Extrema_ExtPRevS {
    constructor(thePtr: Extrema_ExtPRevS);
  }

  export declare class Handle_Extrema_ExtPRevS_3 extends Handle_Extrema_ExtPRevS {
    constructor(theHandle: Handle_Extrema_ExtPRevS);
  }

  export declare class Handle_Extrema_ExtPRevS_4 extends Handle_Extrema_ExtPRevS {
    constructor(theHandle: Handle_Extrema_ExtPRevS);
  }

export declare class Extrema_ExtPRevS extends Standard_Transient {
  Initialize(S: Handle_GeomAdaptor_HSurfaceOfRevolution, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Extrema_ExtPRevS_1 extends Extrema_ExtPRevS {
    constructor();
  }

  export declare class Extrema_ExtPRevS_2 extends Extrema_ExtPRevS {
    constructor(P: gp_Pnt, S: Handle_GeomAdaptor_HSurfaceOfRevolution, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

  export declare class Extrema_ExtPRevS_3 extends Extrema_ExtPRevS {
    constructor(P: gp_Pnt, S: Handle_GeomAdaptor_HSurfaceOfRevolution, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

export declare class Extrema_Array1OfPOnCurv2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Extrema_POnCurv2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Extrema_Array1OfPOnCurv2d): Extrema_Array1OfPOnCurv2d;
  Move(theOther: Extrema_Array1OfPOnCurv2d): Extrema_Array1OfPOnCurv2d;
  First(): Extrema_POnCurv2d;
  ChangeFirst(): Extrema_POnCurv2d;
  Last(): Extrema_POnCurv2d;
  ChangeLast(): Extrema_POnCurv2d;
  Value(theIndex: Standard_Integer): Extrema_POnCurv2d;
  ChangeValue(theIndex: Standard_Integer): Extrema_POnCurv2d;
  SetValue(theIndex: Standard_Integer, theItem: Extrema_POnCurv2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Extrema_Array1OfPOnCurv2d_1 extends Extrema_Array1OfPOnCurv2d {
    constructor();
  }

  export declare class Extrema_Array1OfPOnCurv2d_2 extends Extrema_Array1OfPOnCurv2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Extrema_Array1OfPOnCurv2d_3 extends Extrema_Array1OfPOnCurv2d {
    constructor(theOther: Extrema_Array1OfPOnCurv2d);
  }

  export declare class Extrema_Array1OfPOnCurv2d_4 extends Extrema_Array1OfPOnCurv2d {
    constructor(theOther: Extrema_Array1OfPOnCurv2d);
  }

  export declare class Extrema_Array1OfPOnCurv2d_5 extends Extrema_Array1OfPOnCurv2d {
    constructor(theBegin: Extrema_POnCurv2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Extrema_GlobOptFuncCS extends math_MultipleVarFunctionWithHessian {
  constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface)
  NbVariables(): Graphic3d_ZLayerId;
  Value(theX: math_Vector, theF: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(theX: math_Vector, theG: math_Vector): Standard_Boolean;
  Values_1(theX: math_Vector, theF: Quantity_AbsorbedDose, theG: math_Vector): Standard_Boolean;
  Values_2(theX: math_Vector, theF: Quantity_AbsorbedDose, theG: math_Vector, theH: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Extrema_HArray2OfPOnCurv2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray2OfPOnCurv2d): void;
  get(): Extrema_HArray2OfPOnCurv2d;
  delete(): void;
}

  export declare class Handle_Extrema_HArray2OfPOnCurv2d_1 extends Handle_Extrema_HArray2OfPOnCurv2d {
    constructor();
  }

  export declare class Handle_Extrema_HArray2OfPOnCurv2d_2 extends Handle_Extrema_HArray2OfPOnCurv2d {
    constructor(thePtr: Extrema_HArray2OfPOnCurv2d);
  }

  export declare class Handle_Extrema_HArray2OfPOnCurv2d_3 extends Handle_Extrema_HArray2OfPOnCurv2d {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnCurv2d);
  }

  export declare class Handle_Extrema_HArray2OfPOnCurv2d_4 extends Handle_Extrema_HArray2OfPOnCurv2d {
    constructor(theHandle: Handle_Extrema_HArray2OfPOnCurv2d);
  }

export declare class Extrema_GlobOptFuncConicS extends math_MultipleVarFunction {
  LoadConic(S: Adaptor3d_Curve, theTf: Quantity_AbsorbedDose, theTl: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  Value(theX: math_Vector, theF: Quantity_AbsorbedDose): Standard_Boolean;
  ConicParameter(theUV: math_Vector): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_GlobOptFuncConicS_1 extends Extrema_GlobOptFuncConicS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface);
  }

  export declare class Extrema_GlobOptFuncConicS_2 extends Extrema_GlobOptFuncConicS {
    constructor(S: Adaptor3d_Surface);
  }

  export declare class Extrema_GlobOptFuncConicS_3 extends Extrema_GlobOptFuncConicS {
    constructor(S: Adaptor3d_Surface, theUf: Quantity_AbsorbedDose, theUl: Quantity_AbsorbedDose, theVf: Quantity_AbsorbedDose, theVl: Quantity_AbsorbedDose);
  }

export declare class Extrema_CurveTool {
  constructor();
  static FirstParameter(C: Adaptor3d_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: Adaptor3d_Curve): Quantity_AbsorbedDose;
  static Continuity(C: Adaptor3d_Curve): GeomAbs_Shape;
  static NbIntervals(C: Adaptor3d_Curve, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Adaptor3d_Curve, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static DeflCurvIntervals(C: Adaptor3d_Curve): Handle_TColStd_HArray1OfReal;
  static IsPeriodic(C: Adaptor3d_Curve): Standard_Boolean;
  static Period(C: Adaptor3d_Curve): Quantity_AbsorbedDose;
  static Resolution(C: Adaptor3d_Curve, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Adaptor3d_Curve): GeomAbs_CurveType;
  static Value(C: Adaptor3d_Curve, U: Quantity_AbsorbedDose): gp_Pnt;
  static D0(C: Adaptor3d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: Adaptor3d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  static D2(C: Adaptor3d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: Adaptor3d_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static DN(C: Adaptor3d_Curve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static Line(C: Adaptor3d_Curve): gp_Lin;
  static Circle(C: Adaptor3d_Curve): gp_Circ;
  static Ellipse(C: Adaptor3d_Curve): gp_Elips;
  static Hyperbola(C: Adaptor3d_Curve): gp_Hypr;
  static Parabola(C: Adaptor3d_Curve): gp_Parab;
  static Degree(C: Adaptor3d_Curve): Graphic3d_ZLayerId;
  static IsRational(C: Adaptor3d_Curve): Standard_Boolean;
  static NbPoles(C: Adaptor3d_Curve): Graphic3d_ZLayerId;
  static NbKnots(C: Adaptor3d_Curve): Graphic3d_ZLayerId;
  static Bezier(C: Adaptor3d_Curve): Handle_Geom_BezierCurve;
  static BSpline(C: Adaptor3d_Curve): Handle_Geom_BSplineCurve;
  delete(): void;
}

export declare type Extrema_ExtFlag = {
  Extrema_ExtFlag_MIN: {};
  Extrema_ExtFlag_MAX: {};
  Extrema_ExtFlag_MINMAX: {};
}

export declare class Extrema_GenExtPS {
  Initialize_1(S: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Initialize_2(S: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt): void;
  SetFlag(F: Extrema_ExtFlag): void;
  SetAlgo(A: Extrema_ExtAlgo): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_GenExtPS_1 extends Extrema_GenExtPS {
    constructor();
  }

  export declare class Extrema_GenExtPS_2 extends Extrema_GenExtPS {
    constructor(P: gp_Pnt, S: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

  export declare class Extrema_GenExtPS_3 extends Extrema_GenExtPS {
    constructor(P: gp_Pnt, S: Adaptor3d_Surface, NbU: Graphic3d_ZLayerId, NbV: Graphic3d_ZLayerId, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vsup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

export declare class Extrema_POnSurf {
  Value(): gp_Pnt;
  SetParameters(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, thePnt: gp_Pnt): void;
  Parameter(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Extrema_POnSurf_1 extends Extrema_POnSurf {
    constructor();
  }

  export declare class Extrema_POnSurf_2 extends Extrema_POnSurf {
    constructor(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt);
  }

export declare class Extrema_HUBTreeOfSphere {
  get_1(): Extrema_UBTreeOfSphere;
  get_2(): Extrema_UBTreeOfSphere;
  static DownCast(theOther: Handle_Standard_Transient): Extrema_HUBTreeOfSphere;
  delete(): void;
}

  export declare class Extrema_HUBTreeOfSphere_2 extends Extrema_HUBTreeOfSphere {
    constructor();
  }

  export declare class Extrema_HUBTreeOfSphere_3 extends Extrema_HUBTreeOfSphere {
    constructor(theObject: Extrema_UBTreeOfSphere);
  }

export declare class Extrema_PCFOfEPCOfELPCOfLocateExtPC extends math_FunctionWithDerivative {
  Initialize(C: Adaptor3d_Curve): void;
  SetPoint(P: gp_Pnt): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_PCFOfEPCOfELPCOfLocateExtPC_1 extends Extrema_PCFOfEPCOfELPCOfLocateExtPC {
    constructor();
  }

  export declare class Extrema_PCFOfEPCOfELPCOfLocateExtPC_2 extends Extrema_PCFOfEPCOfELPCOfLocateExtPC {
    constructor(P: gp_Pnt, C: Adaptor3d_Curve);
  }

export declare class Extrema_GenLocateExtCS {
  Perform(C: Adaptor3d_Curve, S: Adaptor3d_Surface, T: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  PointOnCurve(): Extrema_POnCurv;
  PointOnSurface(): Extrema_POnSurf;
  delete(): void;
}

  export declare class Extrema_GenLocateExtCS_1 extends Extrema_GenLocateExtCS {
    constructor();
  }

  export declare class Extrema_GenLocateExtCS_2 extends Extrema_GenLocateExtCS {
    constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface, T: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

export declare class Extrema_POnSurfParams extends Extrema_POnSurf {
  SetSqrDistance(theSqrDistance: Quantity_AbsorbedDose): void;
  GetSqrDistance(): Quantity_AbsorbedDose;
  SetElementType(theElementType: Extrema_ElementType): void;
  GetElementType(): Extrema_ElementType;
  SetIndices(theIndexU: Graphic3d_ZLayerId, theIndexV: Graphic3d_ZLayerId): void;
  GetIndices(theIndexU: Graphic3d_ZLayerId, theIndexV: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Extrema_POnSurfParams_1 extends Extrema_POnSurfParams {
    constructor();
  }

  export declare class Extrema_POnSurfParams_2 extends Extrema_POnSurfParams {
    constructor(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, thePnt: gp_Pnt);
  }

export declare class Extrema_CCLocFOfLocECC2d extends math_FunctionSetWithDerivatives {
  SetCurve(theRank: Graphic3d_ZLayerId, C1: Adaptor2d_Curve2d): void;
  SetTolerance(theTol: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(UV: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(UV: math_Vector, DF: math_Matrix): Standard_Boolean;
  Values(UV: math_Vector, F: math_Vector, DF: math_Matrix): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Points(N: Graphic3d_ZLayerId, P1: Extrema_POnCurv2d, P2: Extrema_POnCurv2d): void;
  CurvePtr(theRank: Graphic3d_ZLayerId): Standard_Address;
  Tolerance(): Quantity_AbsorbedDose;
  SubIntervalInitialize(theUfirst: math_Vector, theUlast: math_Vector): void;
  SearchOfTolerance(C: Standard_Address): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Extrema_CCLocFOfLocECC2d_1 extends Extrema_CCLocFOfLocECC2d {
    constructor(thetol: Quantity_AbsorbedDose);
  }

  export declare class Extrema_CCLocFOfLocECC2d_2 extends Extrema_CCLocFOfLocECC2d {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, thetol: Quantity_AbsorbedDose);
  }

export declare class Handle_Extrema_HArray1OfPOnCurv {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Extrema_HArray1OfPOnCurv): void;
  get(): Extrema_HArray1OfPOnCurv;
  delete(): void;
}

  export declare class Handle_Extrema_HArray1OfPOnCurv_1 extends Handle_Extrema_HArray1OfPOnCurv {
    constructor();
  }

  export declare class Handle_Extrema_HArray1OfPOnCurv_2 extends Handle_Extrema_HArray1OfPOnCurv {
    constructor(thePtr: Extrema_HArray1OfPOnCurv);
  }

  export declare class Handle_Extrema_HArray1OfPOnCurv_3 extends Handle_Extrema_HArray1OfPOnCurv {
    constructor(theHandle: Handle_Extrema_HArray1OfPOnCurv);
  }

  export declare class Handle_Extrema_HArray1OfPOnCurv_4 extends Handle_Extrema_HArray1OfPOnCurv {
    constructor(theHandle: Handle_Extrema_HArray1OfPOnCurv);
  }

export declare class Extrema_LocateExtCC {
  constructor(C1: Adaptor3d_Curve, C2: Adaptor3d_Curve, U0: Quantity_AbsorbedDose, V0: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  Point(P1: Extrema_POnCurv, P2: Extrema_POnCurv): void;
  delete(): void;
}

export declare type BinDrivers_Marker = {
  BinDrivers_ENDATTRLIST: {};
  BinDrivers_ENDLABEL: {};
}

export declare class Handle_BinDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinDrivers_DocumentStorageDriver): void;
  get(): BinDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_BinDrivers_DocumentStorageDriver_1 extends Handle_BinDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_BinDrivers_DocumentStorageDriver_2 extends Handle_BinDrivers_DocumentStorageDriver {
    constructor(thePtr: BinDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinDrivers_DocumentStorageDriver_3 extends Handle_BinDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinDrivers_DocumentStorageDriver_4 extends Handle_BinDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinDrivers_DocumentStorageDriver);
  }

export declare class BinDrivers_DocumentStorageDriver extends BinLDrivers_DocumentStorageDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  WriteShapeSection(theDocSection: BinLDrivers_DocumentSection, theOS: Standard_OStream, theRange: Message_ProgressRange): void;
  IsWithTriangles(): Standard_Boolean;
  SetWithTriangles(theMessageDriver: Handle_Message_Messenger, theWithTriangulation: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinDrivers_DocumentRetrievalDriver extends BinLDrivers_DocumentRetrievalDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  ReadShapeSection(theSection: BinLDrivers_DocumentSection, theIS: Standard_IStream, isMess: Standard_Boolean, theRange: Message_ProgressRange): void;
  CheckShapeSection(thePos: Storage_Position, theIS: Standard_IStream): void;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinDrivers_DocumentRetrievalDriver): void;
  get(): BinDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_BinDrivers_DocumentRetrievalDriver_1 extends Handle_BinDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_BinDrivers_DocumentRetrievalDriver_2 extends Handle_BinDrivers_DocumentRetrievalDriver {
    constructor(thePtr: BinDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinDrivers_DocumentRetrievalDriver_3 extends Handle_BinDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinDrivers_DocumentRetrievalDriver_4 extends Handle_BinDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinDrivers_DocumentRetrievalDriver);
  }

export declare class BinDrivers {
  constructor();
  static Factory(theGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AttributeDrivers(MsgDrv: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static StorageVersion(): XCAFDoc_PartId;
  delete(): void;
}

export declare class BRepBuilderAPI_BndBoxTreeSelector {
  constructor()
  Reject(theBox: Bnd_Box): Standard_Boolean;
  Accept(theObj: Graphic3d_ZLayerId): Standard_Boolean;
  ClearResList(): void;
  SetCurrent(theBox: Bnd_Box): void;
  ResInd(): TColStd_ListOfInteger;
  delete(): void;
}

export declare class BRepBuilderAPI_ModifyShape extends BRepBuilderAPI_MakeShape {
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  ModifiedShape(S: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

export declare class BRepBuilderAPI_MakeShell extends BRepBuilderAPI_MakeShape {
  Init(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Segment: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Error(): BRepBuilderAPI_ShellError;
  Shell(): TopoDS_Shell;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakeShell_1 extends BRepBuilderAPI_MakeShell {
    constructor();
  }

  export declare class BRepBuilderAPI_MakeShell_2 extends BRepBuilderAPI_MakeShell {
    constructor(S: Handle_Geom_Surface, Segment: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeShell_3 extends BRepBuilderAPI_MakeShell {
    constructor(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Segment: Standard_Boolean);
  }

export declare class Handle_BRepBuilderAPI_Sewing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBuilderAPI_Sewing): void;
  get(): BRepBuilderAPI_Sewing;
  delete(): void;
}

  export declare class Handle_BRepBuilderAPI_Sewing_1 extends Handle_BRepBuilderAPI_Sewing {
    constructor();
  }

  export declare class Handle_BRepBuilderAPI_Sewing_2 extends Handle_BRepBuilderAPI_Sewing {
    constructor(thePtr: BRepBuilderAPI_Sewing);
  }

  export declare class Handle_BRepBuilderAPI_Sewing_3 extends Handle_BRepBuilderAPI_Sewing {
    constructor(theHandle: Handle_BRepBuilderAPI_Sewing);
  }

  export declare class Handle_BRepBuilderAPI_Sewing_4 extends Handle_BRepBuilderAPI_Sewing {
    constructor(theHandle: Handle_BRepBuilderAPI_Sewing);
  }

export declare class BRepBuilderAPI_Sewing extends Standard_Transient {
  constructor(tolerance: Quantity_AbsorbedDose, option1: Standard_Boolean, option2: Standard_Boolean, option3: Standard_Boolean, option4: Standard_Boolean)
  Init(tolerance: Quantity_AbsorbedDose, option1: Standard_Boolean, option2: Standard_Boolean, option3: Standard_Boolean, option4: Standard_Boolean): void;
  Load(shape: TopoDS_Shape): void;
  Add(shape: TopoDS_Shape): void;
  Perform(theProgress: Message_ProgressRange): void;
  SewedShape(): TopoDS_Shape;
  SetContext(theContext: Handle_BRepTools_ReShape): void;
  GetContext(): Handle_BRepTools_ReShape;
  NbFreeEdges(): Graphic3d_ZLayerId;
  FreeEdge(index: Graphic3d_ZLayerId): TopoDS_Edge;
  NbMultipleEdges(): Graphic3d_ZLayerId;
  MultipleEdge(index: Graphic3d_ZLayerId): TopoDS_Edge;
  NbContigousEdges(): Graphic3d_ZLayerId;
  ContigousEdge(index: Graphic3d_ZLayerId): TopoDS_Edge;
  ContigousEdgeCouple(index: Graphic3d_ZLayerId): TopTools_ListOfShape;
  IsSectionBound(section: TopoDS_Edge): Standard_Boolean;
  SectionToBoundary(section: TopoDS_Edge): TopoDS_Edge;
  NbDegeneratedShapes(): Graphic3d_ZLayerId;
  DegeneratedShape(index: Graphic3d_ZLayerId): TopoDS_Shape;
  IsDegenerated(shape: TopoDS_Shape): Standard_Boolean;
  IsModified(shape: TopoDS_Shape): Standard_Boolean;
  Modified(shape: TopoDS_Shape): TopoDS_Shape;
  IsModifiedSubShape(shape: TopoDS_Shape): Standard_Boolean;
  ModifiedSubShape(shape: TopoDS_Shape): TopoDS_Shape;
  Dump(): void;
  NbDeletedFaces(): Graphic3d_ZLayerId;
  DeletedFace(index: Graphic3d_ZLayerId): TopoDS_Face;
  WhichFace(theEdg: TopoDS_Edge, index: Graphic3d_ZLayerId): TopoDS_Face;
  SameParameterMode(): Standard_Boolean;
  SetSameParameterMode(SameParameterMode: Standard_Boolean): void;
  Tolerance(): Quantity_AbsorbedDose;
  SetTolerance(theToler: Quantity_AbsorbedDose): void;
  MinTolerance(): Quantity_AbsorbedDose;
  SetMinTolerance(theMinToler: Quantity_AbsorbedDose): void;
  MaxTolerance(): Quantity_AbsorbedDose;
  SetMaxTolerance(theMaxToler: Quantity_AbsorbedDose): void;
  FaceMode(): Standard_Boolean;
  SetFaceMode(theFaceMode: Standard_Boolean): void;
  FloatingEdgesMode(): Standard_Boolean;
  SetFloatingEdgesMode(theFloatingEdgesMode: Standard_Boolean): void;
  LocalTolerancesMode(): Standard_Boolean;
  SetLocalTolerancesMode(theLocalTolerancesMode: Standard_Boolean): void;
  SetNonManifoldMode(theNonManifoldMode: Standard_Boolean): void;
  NonManifoldMode(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepBuilderAPI_NurbsConvert extends BRepBuilderAPI_ModifyShape {
  Perform(S: TopoDS_Shape, Copy: Standard_Boolean): void;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  ModifiedShape(S: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepBuilderAPI_NurbsConvert_1 extends BRepBuilderAPI_NurbsConvert {
    constructor();
  }

  export declare class BRepBuilderAPI_NurbsConvert_2 extends BRepBuilderAPI_NurbsConvert {
    constructor(S: TopoDS_Shape, Copy: Standard_Boolean);
  }

export declare type BRepBuilderAPI_EdgeError = {
  BRepBuilderAPI_EdgeDone: {};
  BRepBuilderAPI_PointProjectionFailed: {};
  BRepBuilderAPI_ParameterOutOfRange: {};
  BRepBuilderAPI_DifferentPointsOnClosedCurve: {};
  BRepBuilderAPI_PointWithInfiniteParameter: {};
  BRepBuilderAPI_DifferentsPointAndParameter: {};
  BRepBuilderAPI_LineThroughIdenticPoints: {};
}

export declare class BRepBuilderAPI_MakeEdge2d extends BRepBuilderAPI_MakeShape {
  Init_1(C: Handle_Geom2d_Curve): void;
  Init_2(C: Handle_Geom2d_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_3(C: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Init_4(C: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  Init_5(C: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_6(C: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Error(): BRepBuilderAPI_EdgeError;
  Edge(): TopoDS_Edge;
  Vertex1(): TopoDS_Vertex;
  Vertex2(): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakeEdge2d_1 extends BRepBuilderAPI_MakeEdge2d {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_2 extends BRepBuilderAPI_MakeEdge2d {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_3 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Lin2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_4 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Lin2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_5 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Lin2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_6 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Lin2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_7 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Circ2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_8 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Circ2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_9 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Circ2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_10 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Circ2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_11 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Elips2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_12 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Elips2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_13 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Elips2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_14 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Elips2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_15 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Hypr2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_16 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Hypr2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_17 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Hypr2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_18 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Hypr2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_19 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Parab2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_20 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Parab2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_21 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Parab2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_22 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: gp_Parab2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_23 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_24 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_25 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_26 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_27 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge2d_28 extends BRepBuilderAPI_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

export declare type BRepBuilderAPI_ShapeModification = {
  BRepBuilderAPI_Preserved: {};
  BRepBuilderAPI_Deleted: {};
  BRepBuilderAPI_Trimmed: {};
  BRepBuilderAPI_Merged: {};
  BRepBuilderAPI_BoundaryModified: {};
}

export declare type BRepBuilderAPI_ShellError = {
  BRepBuilderAPI_ShellDone: {};
  BRepBuilderAPI_EmptyShell: {};
  BRepBuilderAPI_DisconnectedShell: {};
  BRepBuilderAPI_ShellParametersOutOfRange: {};
}

export declare class BRepBuilderAPI_MakeSolid extends BRepBuilderAPI_MakeShape {
  Add(S: TopoDS_Shell): void;
  IsDone(): Standard_Boolean;
  Solid(): TopoDS_Solid;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakeSolid_1 extends BRepBuilderAPI_MakeSolid {
    constructor();
  }

  export declare class BRepBuilderAPI_MakeSolid_2 extends BRepBuilderAPI_MakeSolid {
    constructor(S: TopoDS_CompSolid);
  }

  export declare class BRepBuilderAPI_MakeSolid_3 extends BRepBuilderAPI_MakeSolid {
    constructor(S: TopoDS_Shell);
  }

  export declare class BRepBuilderAPI_MakeSolid_4 extends BRepBuilderAPI_MakeSolid {
    constructor(S1: TopoDS_Shell, S2: TopoDS_Shell);
  }

  export declare class BRepBuilderAPI_MakeSolid_5 extends BRepBuilderAPI_MakeSolid {
    constructor(S1: TopoDS_Shell, S2: TopoDS_Shell, S3: TopoDS_Shell);
  }

  export declare class BRepBuilderAPI_MakeSolid_6 extends BRepBuilderAPI_MakeSolid {
    constructor(So: TopoDS_Solid);
  }

  export declare class BRepBuilderAPI_MakeSolid_7 extends BRepBuilderAPI_MakeSolid {
    constructor(So: TopoDS_Solid, S: TopoDS_Shell);
  }

export declare class BRepBuilderAPI_MakeVertex extends BRepBuilderAPI_MakeShape {
  constructor(P: gp_Pnt)
  Vertex(): TopoDS_Vertex;
  delete(): void;
}

export declare type BRepBuilderAPI_PipeError = {
  BRepBuilderAPI_PipeDone: {};
  BRepBuilderAPI_PipeNotDone: {};
  BRepBuilderAPI_PlaneNotIntersectGuide: {};
  BRepBuilderAPI_ImpossibleContact: {};
}

export declare class BRepBuilderAPI_Command {
  IsDone(): Standard_Boolean;
  Check(): void;
  delete(): void;
}

export declare type BRepBuilderAPI_FaceError = {
  BRepBuilderAPI_FaceDone: {};
  BRepBuilderAPI_NoFace: {};
  BRepBuilderAPI_NotPlanar: {};
  BRepBuilderAPI_CurveProjectionFailed: {};
  BRepBuilderAPI_ParametersOutOfRange: {};
}

export declare class Handle_BRepBuilderAPI_FastSewing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepBuilderAPI_FastSewing): void;
  get(): BRepBuilderAPI_FastSewing;
  delete(): void;
}

  export declare class Handle_BRepBuilderAPI_FastSewing_1 extends Handle_BRepBuilderAPI_FastSewing {
    constructor();
  }

  export declare class Handle_BRepBuilderAPI_FastSewing_2 extends Handle_BRepBuilderAPI_FastSewing {
    constructor(thePtr: BRepBuilderAPI_FastSewing);
  }

  export declare class Handle_BRepBuilderAPI_FastSewing_3 extends Handle_BRepBuilderAPI_FastSewing {
    constructor(theHandle: Handle_BRepBuilderAPI_FastSewing);
  }

  export declare class Handle_BRepBuilderAPI_FastSewing_4 extends Handle_BRepBuilderAPI_FastSewing {
    constructor(theHandle: Handle_BRepBuilderAPI_FastSewing);
  }

export declare class BRepBuilderAPI_FastSewing extends Standard_Transient {
  constructor(theTolerance: Quantity_AbsorbedDose)
  Add_1(theShape: TopoDS_Shape): Standard_Boolean;
  Add_2(theSurface: Handle_Geom_Surface): Standard_Boolean;
  Perform(): void;
  SetTolerance(theToler: Quantity_AbsorbedDose): void;
  GetTolerance(): Quantity_AbsorbedDose;
  GetResult(): TopoDS_Shape;
  GetStatuses(theOS: Standard_OStream): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepBuilderAPI_Transform extends BRepBuilderAPI_ModifyShape {
  Perform(S: TopoDS_Shape, Copy: Standard_Boolean): void;
  ModifiedShape(S: TopoDS_Shape): TopoDS_Shape;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepBuilderAPI_Transform_1 extends BRepBuilderAPI_Transform {
    constructor(T: gp_Trsf);
  }

  export declare class BRepBuilderAPI_Transform_2 extends BRepBuilderAPI_Transform {
    constructor(S: TopoDS_Shape, T: gp_Trsf, Copy: Standard_Boolean);
  }

export declare class BRepBuilderAPI_Collect {
  constructor()
  Add(SI: TopoDS_Shape, MKS: BRepBuilderAPI_MakeShape): void;
  AddGenerated(S: TopoDS_Shape, Gen: TopoDS_Shape): void;
  AddModif(S: TopoDS_Shape, Mod: TopoDS_Shape): void;
  Filter(SF: TopoDS_Shape): void;
  Modification(): TopTools_DataMapOfShapeListOfShape;
  Generated(): TopTools_DataMapOfShapeListOfShape;
  delete(): void;
}

export declare class BRepBuilderAPI_MakePolygon extends BRepBuilderAPI_MakeShape {
  Add_1(P: gp_Pnt): void;
  Add_2(V: TopoDS_Vertex): void;
  Added(): Standard_Boolean;
  Close(): void;
  FirstVertex(): TopoDS_Vertex;
  LastVertex(): TopoDS_Vertex;
  IsDone(): Standard_Boolean;
  Edge(): TopoDS_Edge;
  Wire(): TopoDS_Wire;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakePolygon_1 extends BRepBuilderAPI_MakePolygon {
    constructor();
  }

  export declare class BRepBuilderAPI_MakePolygon_2 extends BRepBuilderAPI_MakePolygon {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakePolygon_3 extends BRepBuilderAPI_MakePolygon {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, Close: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakePolygon_4 extends BRepBuilderAPI_MakePolygon {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, P4: gp_Pnt, Close: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakePolygon_5 extends BRepBuilderAPI_MakePolygon {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakePolygon_6 extends BRepBuilderAPI_MakePolygon {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex, V3: TopoDS_Vertex, Close: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakePolygon_7 extends BRepBuilderAPI_MakePolygon {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex, V3: TopoDS_Vertex, V4: TopoDS_Vertex, Close: Standard_Boolean);
  }

export declare class VectorOfPoint extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: VectorOfPoint, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: gp_XYZ): gp_XYZ;
  Appended(): gp_XYZ;
  Value(theIndex: Standard_Integer): gp_XYZ;
  First(): gp_XYZ;
  ChangeFirst(): gp_XYZ;
  Last(): gp_XYZ;
  ChangeLast(): gp_XYZ;
  ChangeValue(theIndex: Standard_Integer): gp_XYZ;
  SetValue(theIndex: Standard_Integer, theValue: gp_XYZ): gp_XYZ;
  delete(): void;
}

  export declare class VectorOfPoint_1 extends VectorOfPoint {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class VectorOfPoint_2 extends VectorOfPoint {
    constructor(theOther: VectorOfPoint);
  }

export declare class BRepBuilderAPI_VertexInspector extends NCollection_CellFilter_InspectorXYZ {
  constructor(theTol: Quantity_AbsorbedDose)
  Add(thePnt: gp_XYZ): void;
  ClearResList(): void;
  SetCurrent(theCurPnt: gp_XYZ): void;
  ResInd(): TColStd_ListOfInteger;
  Inspect(theTarget: Graphic3d_ZLayerId): NCollection_CellFilter_Action;
  delete(): void;
}

export declare class BRepBuilderAPI_MakeWire extends BRepBuilderAPI_MakeShape {
  Add_1(E: TopoDS_Edge): void;
  Add_2(W: TopoDS_Wire): void;
  Add_3(L: TopTools_ListOfShape): void;
  IsDone(): Standard_Boolean;
  Error(): BRepBuilderAPI_WireError;
  Wire(): TopoDS_Wire;
  Edge(): TopoDS_Edge;
  Vertex(): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakeWire_1 extends BRepBuilderAPI_MakeWire {
    constructor();
  }

  export declare class BRepBuilderAPI_MakeWire_2 extends BRepBuilderAPI_MakeWire {
    constructor(E: TopoDS_Edge);
  }

  export declare class BRepBuilderAPI_MakeWire_3 extends BRepBuilderAPI_MakeWire {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge);
  }

  export declare class BRepBuilderAPI_MakeWire_4 extends BRepBuilderAPI_MakeWire {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge, E3: TopoDS_Edge);
  }

  export declare class BRepBuilderAPI_MakeWire_5 extends BRepBuilderAPI_MakeWire {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge, E3: TopoDS_Edge, E4: TopoDS_Edge);
  }

  export declare class BRepBuilderAPI_MakeWire_6 extends BRepBuilderAPI_MakeWire {
    constructor(W: TopoDS_Wire);
  }

  export declare class BRepBuilderAPI_MakeWire_7 extends BRepBuilderAPI_MakeWire {
    constructor(W: TopoDS_Wire, E: TopoDS_Edge);
  }

export declare class BRepBuilderAPI_GTransform extends BRepBuilderAPI_ModifyShape {
  Perform(S: TopoDS_Shape, Copy: Standard_Boolean): void;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  ModifiedShape(S: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepBuilderAPI_GTransform_1 extends BRepBuilderAPI_GTransform {
    constructor(T: gp_GTrsf);
  }

  export declare class BRepBuilderAPI_GTransform_2 extends BRepBuilderAPI_GTransform {
    constructor(S: TopoDS_Shape, T: gp_GTrsf, Copy: Standard_Boolean);
  }

export declare type BRepBuilderAPI_WireError = {
  BRepBuilderAPI_WireDone: {};
  BRepBuilderAPI_EmptyWire: {};
  BRepBuilderAPI_DisconnectedWire: {};
  BRepBuilderAPI_NonManifoldWire: {};
}

export declare class BRepBuilderAPI_FindPlane {
  Init(S: TopoDS_Shape, Tol: Quantity_AbsorbedDose): void;
  Found(): Standard_Boolean;
  Plane(): Handle_Geom_Plane;
  delete(): void;
}

  export declare class BRepBuilderAPI_FindPlane_1 extends BRepBuilderAPI_FindPlane {
    constructor();
  }

  export declare class BRepBuilderAPI_FindPlane_2 extends BRepBuilderAPI_FindPlane {
    constructor(S: TopoDS_Shape, Tol: Quantity_AbsorbedDose);
  }

export declare class BRepBuilderAPI_MakeShape extends BRepBuilderAPI_Command {
  Build(): void;
  Shape(): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

export declare type BRepBuilderAPI_TransitionMode = {
  BRepBuilderAPI_Transformed: {};
  BRepBuilderAPI_RightCorner: {};
  BRepBuilderAPI_RoundCorner: {};
}

export declare class BRepBuilderAPI_Copy extends BRepBuilderAPI_ModifyShape {
  Perform(S: TopoDS_Shape, copyGeom: Standard_Boolean, copyMesh: Standard_Boolean): void;
  delete(): void;
}

  export declare class BRepBuilderAPI_Copy_1 extends BRepBuilderAPI_Copy {
    constructor();
  }

  export declare class BRepBuilderAPI_Copy_2 extends BRepBuilderAPI_Copy {
    constructor(S: TopoDS_Shape, copyGeom: Standard_Boolean, copyMesh: Standard_Boolean);
  }

export declare class BRepBuilderAPI_MakeEdge extends BRepBuilderAPI_MakeShape {
  Init_1(C: Handle_Geom_Curve): void;
  Init_2(C: Handle_Geom_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_3(C: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt): void;
  Init_4(C: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  Init_5(C: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_6(C: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_7(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface): void;
  Init_8(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_9(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt): void;
  Init_10(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  Init_11(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_12(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Error(): BRepBuilderAPI_EdgeError;
  Edge(): TopoDS_Edge;
  Vertex1(): TopoDS_Vertex;
  Vertex2(): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakeEdge_1 extends BRepBuilderAPI_MakeEdge {
    constructor();
  }

  export declare class BRepBuilderAPI_MakeEdge_2 extends BRepBuilderAPI_MakeEdge {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_3 extends BRepBuilderAPI_MakeEdge {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_4 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Lin);
  }

  export declare class BRepBuilderAPI_MakeEdge_5 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Lin, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_6 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Lin, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_7 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Lin, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_8 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Circ);
  }

  export declare class BRepBuilderAPI_MakeEdge_9 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Circ, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_10 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Circ, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_11 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Circ, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_12 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Elips);
  }

  export declare class BRepBuilderAPI_MakeEdge_13 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Elips, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_14 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Elips, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_15 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Elips, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_16 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Hypr);
  }

  export declare class BRepBuilderAPI_MakeEdge_17 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Hypr, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_18 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Hypr, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_19 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Hypr, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_20 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Parab);
  }

  export declare class BRepBuilderAPI_MakeEdge_21 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Parab, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_22 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Parab, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_23 extends BRepBuilderAPI_MakeEdge {
    constructor(L: gp_Parab, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_24 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom_Curve);
  }

  export declare class BRepBuilderAPI_MakeEdge_25 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_26 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_27 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_28 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_29 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_30 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface);
  }

  export declare class BRepBuilderAPI_MakeEdge_31 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_32 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepBuilderAPI_MakeEdge_33 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepBuilderAPI_MakeEdge_34 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeEdge_35 extends BRepBuilderAPI_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

export declare class BRepBuilderAPI_MakeFace extends BRepBuilderAPI_MakeShape {
  Init_1(F: TopoDS_Face): void;
  Init_2(S: Handle_Geom_Surface, Bound: Standard_Boolean, TolDegen: Quantity_AbsorbedDose): void;
  Init_3(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, TolDegen: Quantity_AbsorbedDose): void;
  Add(W: TopoDS_Wire): void;
  IsDone(): Standard_Boolean;
  Error(): BRepBuilderAPI_FaceError;
  Face(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepBuilderAPI_MakeFace_1 extends BRepBuilderAPI_MakeFace {
    constructor();
  }

  export declare class BRepBuilderAPI_MakeFace_2 extends BRepBuilderAPI_MakeFace {
    constructor(F: TopoDS_Face);
  }

  export declare class BRepBuilderAPI_MakeFace_3 extends BRepBuilderAPI_MakeFace {
    constructor(P: gp_Pln);
  }

  export declare class BRepBuilderAPI_MakeFace_4 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Cylinder);
  }

  export declare class BRepBuilderAPI_MakeFace_5 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Cone);
  }

  export declare class BRepBuilderAPI_MakeFace_6 extends BRepBuilderAPI_MakeFace {
    constructor(S: gp_Sphere);
  }

  export declare class BRepBuilderAPI_MakeFace_7 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Torus);
  }

  export declare class BRepBuilderAPI_MakeFace_8 extends BRepBuilderAPI_MakeFace {
    constructor(S: Handle_Geom_Surface, TolDegen: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_9 extends BRepBuilderAPI_MakeFace {
    constructor(P: gp_Pln, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_10 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Cylinder, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_11 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Cone, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_12 extends BRepBuilderAPI_MakeFace {
    constructor(S: gp_Sphere, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_13 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Torus, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_14 extends BRepBuilderAPI_MakeFace {
    constructor(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, TolDegen: Quantity_AbsorbedDose);
  }

  export declare class BRepBuilderAPI_MakeFace_15 extends BRepBuilderAPI_MakeFace {
    constructor(W: TopoDS_Wire, OnlyPlane: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_16 extends BRepBuilderAPI_MakeFace {
    constructor(P: gp_Pln, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_17 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Cylinder, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_18 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Cone, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_19 extends BRepBuilderAPI_MakeFace {
    constructor(S: gp_Sphere, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_20 extends BRepBuilderAPI_MakeFace {
    constructor(C: gp_Torus, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_21 extends BRepBuilderAPI_MakeFace {
    constructor(S: Handle_Geom_Surface, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepBuilderAPI_MakeFace_22 extends BRepBuilderAPI_MakeFace {
    constructor(F: TopoDS_Face, W: TopoDS_Wire);
  }

export declare class BRepBuilderAPI {
  constructor();
  static Plane_1(P: Handle_Geom_Plane): void;
  static Plane_2(): Handle_Geom_Plane;
  static Precision_1(P: Quantity_AbsorbedDose): void;
  static Precision_2(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepLib {
  constructor();
  static Precision_1(P: Quantity_AbsorbedDose): void;
  static Precision_2(): Quantity_AbsorbedDose;
  static Plane_1(P: Handle_Geom_Plane): void;
  static Plane_2(): Handle_Geom_Plane;
  static CheckSameRange(E: TopoDS_Edge, Confusion: Quantity_AbsorbedDose): Standard_Boolean;
  static SameRange(E: TopoDS_Edge, Tolerance: Quantity_AbsorbedDose): void;
  static BuildCurve3d(E: TopoDS_Edge, Tolerance: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegment: Graphic3d_ZLayerId): Standard_Boolean;
  static BuildCurves3d_1(S: TopoDS_Shape, Tolerance: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegment: Graphic3d_ZLayerId): Standard_Boolean;
  static BuildCurves3d_2(S: TopoDS_Shape): Standard_Boolean;
  static BuildPCurveForEdgeOnPlane_1(theE: TopoDS_Edge, theF: TopoDS_Face): void;
  static BuildPCurveForEdgeOnPlane_2(theE: TopoDS_Edge, theF: TopoDS_Face, aC2D: Handle_Geom2d_Curve, bToUpdate: Standard_Boolean): void;
  static UpdateEdgeTol(E: TopoDS_Edge, MinToleranceRequest: Quantity_AbsorbedDose, MaxToleranceToCheck: Quantity_AbsorbedDose): Standard_Boolean;
  static UpdateEdgeTolerance(S: TopoDS_Shape, MinToleranceRequest: Quantity_AbsorbedDose, MaxToleranceToCheck: Quantity_AbsorbedDose): Standard_Boolean;
  static SameParameter_1(theEdge: TopoDS_Edge, Tolerance: Quantity_AbsorbedDose): void;
  static SameParameter_2(theEdge: TopoDS_Edge, theTolerance: Quantity_AbsorbedDose, theNewTol: Quantity_AbsorbedDose, IsUseOldEdge: Standard_Boolean): TopoDS_Edge;
  static SameParameter_3(S: TopoDS_Shape, Tolerance: Quantity_AbsorbedDose, forced: Standard_Boolean): void;
  static SameParameter_4(S: TopoDS_Shape, theReshaper: BRepTools_ReShape, Tolerance: Quantity_AbsorbedDose, forced: Standard_Boolean): void;
  static UpdateTolerances_1(S: TopoDS_Shape, verifyFaceTolerance: Standard_Boolean): void;
  static UpdateTolerances_2(S: TopoDS_Shape, theReshaper: BRepTools_ReShape, verifyFaceTolerance: Standard_Boolean): void;
  static UpdateInnerTolerances(S: TopoDS_Shape): void;
  static OrientClosedSolid(solid: TopoDS_Solid): Standard_Boolean;
  static EncodeRegularity_1(S: TopoDS_Shape, TolAng: Quantity_AbsorbedDose): void;
  static EncodeRegularity_2(S: TopoDS_Shape, LE: TopTools_ListOfShape, TolAng: Quantity_AbsorbedDose): void;
  static EncodeRegularity_3(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, TolAng: Quantity_AbsorbedDose): void;
  static SortFaces(S: TopoDS_Shape, LF: TopTools_ListOfShape): void;
  static ReverseSortFaces(S: TopoDS_Shape, LF: TopTools_ListOfShape): void;
  static EnsureNormalConsistency(S: TopoDS_Shape, theAngTol: Quantity_AbsorbedDose, ForceComputeNormals: Standard_Boolean): Standard_Boolean;
  static BoundingVertex(theLV: TopoDS_ListOfShape, theNewCenter: gp_Pnt, theNewTol: Quantity_AbsorbedDose): void;
  static FindValidRange_1(theCurve: Adaptor3d_Curve, theTolE: Quantity_AbsorbedDose, theParV1: Quantity_AbsorbedDose, thePntV1: gp_Pnt, theTolV1: Quantity_AbsorbedDose, theParV2: Quantity_AbsorbedDose, thePntV2: gp_Pnt, theTolV2: Quantity_AbsorbedDose, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): Standard_Boolean;
  static FindValidRange_2(theEdge: TopoDS_Edge, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): Standard_Boolean;
  static ExtendFace(theF: TopoDS_Face, theExtVal: Quantity_AbsorbedDose, theExtUMin: Standard_Boolean, theExtUMax: Standard_Boolean, theExtVMin: Standard_Boolean, theExtVMax: Standard_Boolean, theFExtended: TopoDS_Face): void;
  delete(): void;
}

export declare class BRepLib_MakeSolid extends BRepLib_MakeShape {
  Add(S: TopoDS_Shell): void;
  Solid(): TopoDS_Solid;
  FaceStatus(F: TopoDS_Face): BRepLib_ShapeModification;
  delete(): void;
}

  export declare class BRepLib_MakeSolid_1 extends BRepLib_MakeSolid {
    constructor();
  }

  export declare class BRepLib_MakeSolid_2 extends BRepLib_MakeSolid {
    constructor(S: TopoDS_CompSolid);
  }

  export declare class BRepLib_MakeSolid_3 extends BRepLib_MakeSolid {
    constructor(S: TopoDS_Shell);
  }

  export declare class BRepLib_MakeSolid_4 extends BRepLib_MakeSolid {
    constructor(S1: TopoDS_Shell, S2: TopoDS_Shell);
  }

  export declare class BRepLib_MakeSolid_5 extends BRepLib_MakeSolid {
    constructor(S1: TopoDS_Shell, S2: TopoDS_Shell, S3: TopoDS_Shell);
  }

  export declare class BRepLib_MakeSolid_6 extends BRepLib_MakeSolid {
    constructor(So: TopoDS_Solid);
  }

  export declare class BRepLib_MakeSolid_7 extends BRepLib_MakeSolid {
    constructor(So: TopoDS_Solid, S: TopoDS_Shell);
  }

export declare class BRepLib_MakeFace extends BRepLib_MakeShape {
  Init_1(F: TopoDS_Face): void;
  Init_2(S: Handle_Geom_Surface, Bound: Standard_Boolean, TolDegen: Quantity_AbsorbedDose): void;
  Init_3(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, TolDegen: Quantity_AbsorbedDose): void;
  Add(W: TopoDS_Wire): void;
  Error(): BRepLib_FaceError;
  Face(): TopoDS_Face;
  static IsDegenerated(theCurve: Handle_Geom_Curve, theMaxTol: Quantity_AbsorbedDose, theActTol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class BRepLib_MakeFace_1 extends BRepLib_MakeFace {
    constructor();
  }

  export declare class BRepLib_MakeFace_2 extends BRepLib_MakeFace {
    constructor(F: TopoDS_Face);
  }

  export declare class BRepLib_MakeFace_3 extends BRepLib_MakeFace {
    constructor(P: gp_Pln);
  }

  export declare class BRepLib_MakeFace_4 extends BRepLib_MakeFace {
    constructor(C: gp_Cylinder);
  }

  export declare class BRepLib_MakeFace_5 extends BRepLib_MakeFace {
    constructor(C: gp_Cone);
  }

  export declare class BRepLib_MakeFace_6 extends BRepLib_MakeFace {
    constructor(S: gp_Sphere);
  }

  export declare class BRepLib_MakeFace_7 extends BRepLib_MakeFace {
    constructor(C: gp_Torus);
  }

  export declare class BRepLib_MakeFace_8 extends BRepLib_MakeFace {
    constructor(S: Handle_Geom_Surface, TolDegen: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_9 extends BRepLib_MakeFace {
    constructor(P: gp_Pln, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_10 extends BRepLib_MakeFace {
    constructor(C: gp_Cylinder, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_11 extends BRepLib_MakeFace {
    constructor(C: gp_Cone, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_12 extends BRepLib_MakeFace {
    constructor(S: gp_Sphere, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_13 extends BRepLib_MakeFace {
    constructor(C: gp_Torus, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_14 extends BRepLib_MakeFace {
    constructor(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, TolDegen: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeFace_15 extends BRepLib_MakeFace {
    constructor(W: TopoDS_Wire, OnlyPlane: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_16 extends BRepLib_MakeFace {
    constructor(P: gp_Pln, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_17 extends BRepLib_MakeFace {
    constructor(C: gp_Cylinder, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_18 extends BRepLib_MakeFace {
    constructor(C: gp_Cone, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_19 extends BRepLib_MakeFace {
    constructor(S: gp_Sphere, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_20 extends BRepLib_MakeFace {
    constructor(C: gp_Torus, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_21 extends BRepLib_MakeFace {
    constructor(S: Handle_Geom_Surface, W: TopoDS_Wire, Inside: Standard_Boolean);
  }

  export declare class BRepLib_MakeFace_22 extends BRepLib_MakeFace {
    constructor(F: TopoDS_Face, W: TopoDS_Wire);
  }

export declare class BRepLib_MakeShape extends BRepLib_Command {
  Build(): void;
  Shape(): TopoDS_Shape;
  FaceStatus(F: TopoDS_Face): BRepLib_ShapeModification;
  HasDescendants(F: TopoDS_Face): Standard_Boolean;
  DescendantFaces(F: TopoDS_Face): TopTools_ListOfShape;
  NbSurfaces(): Graphic3d_ZLayerId;
  NewFaces(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  FacesFromEdges(E: TopoDS_Edge): TopTools_ListOfShape;
  delete(): void;
}

export declare type BRepLib_FaceError = {
  BRepLib_FaceDone: {};
  BRepLib_NoFace: {};
  BRepLib_NotPlanar: {};
  BRepLib_CurveProjectionFailed: {};
  BRepLib_ParametersOutOfRange: {};
}

export declare class BRepLib_MakePolygon extends BRepLib_MakeShape {
  Add_1(P: gp_Pnt): void;
  Add_2(V: TopoDS_Vertex): void;
  Added(): Standard_Boolean;
  Close(): void;
  FirstVertex(): TopoDS_Vertex;
  LastVertex(): TopoDS_Vertex;
  Edge(): TopoDS_Edge;
  Wire(): TopoDS_Wire;
  delete(): void;
}

  export declare class BRepLib_MakePolygon_1 extends BRepLib_MakePolygon {
    constructor();
  }

  export declare class BRepLib_MakePolygon_2 extends BRepLib_MakePolygon {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakePolygon_3 extends BRepLib_MakePolygon {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, Close: Standard_Boolean);
  }

  export declare class BRepLib_MakePolygon_4 extends BRepLib_MakePolygon {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, P4: gp_Pnt, Close: Standard_Boolean);
  }

  export declare class BRepLib_MakePolygon_5 extends BRepLib_MakePolygon {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakePolygon_6 extends BRepLib_MakePolygon {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex, V3: TopoDS_Vertex, Close: Standard_Boolean);
  }

  export declare class BRepLib_MakePolygon_7 extends BRepLib_MakePolygon {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex, V3: TopoDS_Vertex, V4: TopoDS_Vertex, Close: Standard_Boolean);
  }

export declare class BRepLib_MakeVertex extends BRepLib_MakeShape {
  constructor(P: gp_Pnt)
  Vertex(): TopoDS_Vertex;
  delete(): void;
}

export declare class BRepLib_MakeWire extends BRepLib_MakeShape {
  Add_1(E: TopoDS_Edge): void;
  Add_2(W: TopoDS_Wire): void;
  Add_3(L: TopTools_ListOfShape): void;
  Error(): BRepLib_WireError;
  Wire(): TopoDS_Wire;
  Edge(): TopoDS_Edge;
  Vertex(): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepLib_MakeWire_1 extends BRepLib_MakeWire {
    constructor();
  }

  export declare class BRepLib_MakeWire_2 extends BRepLib_MakeWire {
    constructor(E: TopoDS_Edge);
  }

  export declare class BRepLib_MakeWire_3 extends BRepLib_MakeWire {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge);
  }

  export declare class BRepLib_MakeWire_4 extends BRepLib_MakeWire {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge, E3: TopoDS_Edge);
  }

  export declare class BRepLib_MakeWire_5 extends BRepLib_MakeWire {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge, E3: TopoDS_Edge, E4: TopoDS_Edge);
  }

  export declare class BRepLib_MakeWire_6 extends BRepLib_MakeWire {
    constructor(W: TopoDS_Wire);
  }

  export declare class BRepLib_MakeWire_7 extends BRepLib_MakeWire {
    constructor(W: TopoDS_Wire, E: TopoDS_Edge);
  }

export declare class BRepLib_FuseEdges {
  constructor(theShape: TopoDS_Shape, PerformNow: Standard_Boolean)
  AvoidEdges(theMapEdg: TopTools_IndexedMapOfShape): void;
  SetConcatBSpl(theConcatBSpl: Standard_Boolean): void;
  Edges(theMapLstEdg: TopTools_DataMapOfIntegerListOfShape): void;
  ResultEdges(theMapEdg: TopTools_DataMapOfIntegerShape): void;
  Faces(theMapFac: TopTools_DataMapOfShapeShape): void;
  Shape(): TopoDS_Shape;
  NbVertices(): Graphic3d_ZLayerId;
  Perform(): void;
  delete(): void;
}

export declare class BRepLib_FindSurface {
  Init(S: TopoDS_Shape, Tol: Quantity_AbsorbedDose, OnlyPlane: Standard_Boolean, OnlyClosed: Standard_Boolean): void;
  Found(): Standard_Boolean;
  Surface(): Handle_Geom_Surface;
  Tolerance(): Quantity_AbsorbedDose;
  ToleranceReached(): Quantity_AbsorbedDose;
  Existed(): Standard_Boolean;
  Location(): TopLoc_Location;
  delete(): void;
}

  export declare class BRepLib_FindSurface_1 extends BRepLib_FindSurface {
    constructor();
  }

  export declare class BRepLib_FindSurface_2 extends BRepLib_FindSurface {
    constructor(S: TopoDS_Shape, Tol: Quantity_AbsorbedDose, OnlyPlane: Standard_Boolean, OnlyClosed: Standard_Boolean);
  }

export declare type BRepLib_ShapeModification = {
  BRepLib_Preserved: {};
  BRepLib_Deleted: {};
  BRepLib_Trimmed: {};
  BRepLib_Merged: {};
  BRepLib_BoundaryModified: {};
}

export declare class BRepLib_CheckCurveOnSurface {
  Init(theEdge: TopoDS_Edge, theFace: TopoDS_Face): void;
  Perform(isTheMultyTheradDisabled: Standard_Boolean): void;
  Curve(): Handle_Geom_Curve;
  PCurve(): Handle_Geom2d_Curve;
  PCurve2(): Handle_Geom2d_Curve;
  Surface(): Handle_Geom_Surface;
  Range(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  ErrorStatus(): Graphic3d_ZLayerId;
  MaxDistance(): Quantity_AbsorbedDose;
  MaxParameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepLib_CheckCurveOnSurface_1 extends BRepLib_CheckCurveOnSurface {
    constructor();
  }

  export declare class BRepLib_CheckCurveOnSurface_2 extends BRepLib_CheckCurveOnSurface {
    constructor(theEdge: TopoDS_Edge, theFace: TopoDS_Face);
  }

export declare type BRepLib_ShellError = {
  BRepLib_ShellDone: {};
  BRepLib_EmptyShell: {};
  BRepLib_DisconnectedShell: {};
  BRepLib_ShellParametersOutOfRange: {};
}

export declare class BRepLib_MakeEdge2d extends BRepLib_MakeShape {
  Init_1(C: Handle_Geom2d_Curve): void;
  Init_2(C: Handle_Geom2d_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_3(C: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Init_4(C: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  Init_5(C: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_6(C: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Error(): BRepLib_EdgeError;
  Edge(): TopoDS_Edge;
  Vertex1(): TopoDS_Vertex;
  Vertex2(): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepLib_MakeEdge2d_1 extends BRepLib_MakeEdge2d {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_2 extends BRepLib_MakeEdge2d {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_3 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Lin2d);
  }

  export declare class BRepLib_MakeEdge2d_4 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Lin2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_5 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Lin2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_6 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Lin2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_7 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Circ2d);
  }

  export declare class BRepLib_MakeEdge2d_8 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Circ2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_9 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Circ2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_10 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Circ2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_11 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Elips2d);
  }

  export declare class BRepLib_MakeEdge2d_12 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Elips2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_13 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Elips2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_14 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Elips2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_15 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Hypr2d);
  }

  export declare class BRepLib_MakeEdge2d_16 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Hypr2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_17 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Hypr2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_18 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Hypr2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_19 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Parab2d);
  }

  export declare class BRepLib_MakeEdge2d_20 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Parab2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_21 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Parab2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_22 extends BRepLib_MakeEdge2d {
    constructor(L: gp_Parab2d, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_23 extends BRepLib_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve);
  }

  export declare class BRepLib_MakeEdge2d_24 extends BRepLib_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_25 extends BRepLib_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class BRepLib_MakeEdge2d_26 extends BRepLib_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge2d_27 extends BRepLib_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge2d_28 extends BRepLib_MakeEdge2d {
    constructor(L: Handle_Geom2d_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

export declare class BRepLib_Command {
  IsDone(): Standard_Boolean;
  Check(): void;
  delete(): void;
}

export declare class BRepLib_MakeShell extends BRepLib_MakeShape {
  Init(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Segment: Standard_Boolean): void;
  Error(): BRepLib_ShellError;
  Shell(): TopoDS_Shell;
  delete(): void;
}

  export declare class BRepLib_MakeShell_1 extends BRepLib_MakeShell {
    constructor();
  }

  export declare class BRepLib_MakeShell_2 extends BRepLib_MakeShell {
    constructor(S: Handle_Geom_Surface, Segment: Standard_Boolean);
  }

  export declare class BRepLib_MakeShell_3 extends BRepLib_MakeShell {
    constructor(S: Handle_Geom_Surface, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, Segment: Standard_Boolean);
  }

export declare class BRepLib_MakeEdge extends BRepLib_MakeShape {
  Init_1(C: Handle_Geom_Curve): void;
  Init_2(C: Handle_Geom_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_3(C: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt): void;
  Init_4(C: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  Init_5(C: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_6(C: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_7(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface): void;
  Init_8(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_9(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt): void;
  Init_10(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  Init_11(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Init_12(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  Error(): BRepLib_EdgeError;
  Edge(): TopoDS_Edge;
  Vertex1(): TopoDS_Vertex;
  Vertex2(): TopoDS_Vertex;
  delete(): void;
}

  export declare class BRepLib_MakeEdge_1 extends BRepLib_MakeEdge {
    constructor();
  }

  export declare class BRepLib_MakeEdge_2 extends BRepLib_MakeEdge {
    constructor(V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_3 extends BRepLib_MakeEdge {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_4 extends BRepLib_MakeEdge {
    constructor(L: gp_Lin);
  }

  export declare class BRepLib_MakeEdge_5 extends BRepLib_MakeEdge {
    constructor(L: gp_Lin, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_6 extends BRepLib_MakeEdge {
    constructor(L: gp_Lin, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_7 extends BRepLib_MakeEdge {
    constructor(L: gp_Lin, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_8 extends BRepLib_MakeEdge {
    constructor(L: gp_Circ);
  }

  export declare class BRepLib_MakeEdge_9 extends BRepLib_MakeEdge {
    constructor(L: gp_Circ, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_10 extends BRepLib_MakeEdge {
    constructor(L: gp_Circ, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_11 extends BRepLib_MakeEdge {
    constructor(L: gp_Circ, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_12 extends BRepLib_MakeEdge {
    constructor(L: gp_Elips);
  }

  export declare class BRepLib_MakeEdge_13 extends BRepLib_MakeEdge {
    constructor(L: gp_Elips, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_14 extends BRepLib_MakeEdge {
    constructor(L: gp_Elips, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_15 extends BRepLib_MakeEdge {
    constructor(L: gp_Elips, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_16 extends BRepLib_MakeEdge {
    constructor(L: gp_Hypr);
  }

  export declare class BRepLib_MakeEdge_17 extends BRepLib_MakeEdge {
    constructor(L: gp_Hypr, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_18 extends BRepLib_MakeEdge {
    constructor(L: gp_Hypr, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_19 extends BRepLib_MakeEdge {
    constructor(L: gp_Hypr, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_20 extends BRepLib_MakeEdge {
    constructor(L: gp_Parab);
  }

  export declare class BRepLib_MakeEdge_21 extends BRepLib_MakeEdge {
    constructor(L: gp_Parab, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_22 extends BRepLib_MakeEdge {
    constructor(L: gp_Parab, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_23 extends BRepLib_MakeEdge {
    constructor(L: gp_Parab, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_24 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom_Curve);
  }

  export declare class BRepLib_MakeEdge_25 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom_Curve, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_26 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_27 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_28 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_29 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom_Curve, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_30 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface);
  }

  export declare class BRepLib_MakeEdge_31 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_32 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepLib_MakeEdge_33 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex);
  }

  export declare class BRepLib_MakeEdge_34 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, P1: gp_Pnt, P2: gp_Pnt, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

  export declare class BRepLib_MakeEdge_35 extends BRepLib_MakeEdge {
    constructor(L: Handle_Geom2d_Curve, S: Handle_Geom_Surface, V1: TopoDS_Vertex, V2: TopoDS_Vertex, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose);
  }

export declare type BRepLib_WireError = {
  BRepLib_WireDone: {};
  BRepLib_EmptyWire: {};
  BRepLib_DisconnectedWire: {};
  BRepLib_NonManifoldWire: {};
}

export declare type BRepLib_EdgeError = {
  BRepLib_EdgeDone: {};
  BRepLib_PointProjectionFailed: {};
  BRepLib_ParameterOutOfRange: {};
  BRepLib_DifferentPointsOnClosedCurve: {};
  BRepLib_PointWithInfiniteParameter: {};
  BRepLib_DifferentsPointAndParameter: {};
  BRepLib_LineThroughIdenticPoints: {};
}

export declare class IGESDraw_NetworkSubfigureDef extends IGESData_IGESEntity {
  constructor()
  Init(aDepth: Graphic3d_ZLayerId, aName: Handle_TCollection_HAsciiString, allEntities: Handle_IGESData_HArray1OfIGESEntity, aTypeFlag: Graphic3d_ZLayerId, aDesignator: Handle_TCollection_HAsciiString, aTemplate: Handle_IGESGraph_TextDisplayTemplate, allPointEntities: Handle_IGESDraw_HArray1OfConnectPoint): void;
  Depth(): Graphic3d_ZLayerId;
  Name(): Handle_TCollection_HAsciiString;
  NbEntities(): Graphic3d_ZLayerId;
  Entity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  TypeFlag(): Graphic3d_ZLayerId;
  Designator(): Handle_TCollection_HAsciiString;
  HasDesignatorTemplate(): Standard_Boolean;
  DesignatorTemplate(): Handle_IGESGraph_TextDisplayTemplate;
  NbPointEntities(): Graphic3d_ZLayerId;
  HasPointEntity(Index: Graphic3d_ZLayerId): Standard_Boolean;
  PointEntity(Index: Graphic3d_ZLayerId): Handle_IGESDraw_ConnectPoint;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_NetworkSubfigureDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_NetworkSubfigureDef): void;
  get(): IGESDraw_NetworkSubfigureDef;
  delete(): void;
}

  export declare class Handle_IGESDraw_NetworkSubfigureDef_1 extends Handle_IGESDraw_NetworkSubfigureDef {
    constructor();
  }

  export declare class Handle_IGESDraw_NetworkSubfigureDef_2 extends Handle_IGESDraw_NetworkSubfigureDef {
    constructor(thePtr: IGESDraw_NetworkSubfigureDef);
  }

  export declare class Handle_IGESDraw_NetworkSubfigureDef_3 extends Handle_IGESDraw_NetworkSubfigureDef {
    constructor(theHandle: Handle_IGESDraw_NetworkSubfigureDef);
  }

  export declare class Handle_IGESDraw_NetworkSubfigureDef_4 extends Handle_IGESDraw_NetworkSubfigureDef {
    constructor(theHandle: Handle_IGESDraw_NetworkSubfigureDef);
  }

export declare class IGESDraw_ViewsVisible extends IGESData_ViewKindEntity {
  constructor()
  Init(allViewEntities: Handle_IGESDraw_HArray1OfViewKindEntity, allDisplayEntity: Handle_IGESData_HArray1OfIGESEntity): void;
  InitImplied(allDisplayEntity: Handle_IGESData_HArray1OfIGESEntity): void;
  IsSingle(): Standard_Boolean;
  NbViews(): Graphic3d_ZLayerId;
  NbDisplayedEntities(): Graphic3d_ZLayerId;
  ViewItem(Index: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  DisplayedEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_ViewsVisible {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_ViewsVisible): void;
  get(): IGESDraw_ViewsVisible;
  delete(): void;
}

  export declare class Handle_IGESDraw_ViewsVisible_1 extends Handle_IGESDraw_ViewsVisible {
    constructor();
  }

  export declare class Handle_IGESDraw_ViewsVisible_2 extends Handle_IGESDraw_ViewsVisible {
    constructor(thePtr: IGESDraw_ViewsVisible);
  }

  export declare class Handle_IGESDraw_ViewsVisible_3 extends Handle_IGESDraw_ViewsVisible {
    constructor(theHandle: Handle_IGESDraw_ViewsVisible);
  }

  export declare class Handle_IGESDraw_ViewsVisible_4 extends Handle_IGESDraw_ViewsVisible {
    constructor(theHandle: Handle_IGESDraw_ViewsVisible);
  }

export declare class IGESDraw_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  OwnImpliedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  OwnRenewCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  OwnDeleteCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_GeneralModule): void;
  get(): IGESDraw_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESDraw_GeneralModule_1 extends Handle_IGESDraw_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESDraw_GeneralModule_2 extends Handle_IGESDraw_GeneralModule {
    constructor(thePtr: IGESDraw_GeneralModule);
  }

  export declare class Handle_IGESDraw_GeneralModule_3 extends Handle_IGESDraw_GeneralModule {
    constructor(theHandle: Handle_IGESDraw_GeneralModule);
  }

  export declare class Handle_IGESDraw_GeneralModule_4 extends Handle_IGESDraw_GeneralModule {
    constructor(theHandle: Handle_IGESDraw_GeneralModule);
  }

export declare class Handle_IGESDraw_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_Protocol): void;
  get(): IGESDraw_Protocol;
  delete(): void;
}

  export declare class Handle_IGESDraw_Protocol_1 extends Handle_IGESDraw_Protocol {
    constructor();
  }

  export declare class Handle_IGESDraw_Protocol_2 extends Handle_IGESDraw_Protocol {
    constructor(thePtr: IGESDraw_Protocol);
  }

  export declare class Handle_IGESDraw_Protocol_3 extends Handle_IGESDraw_Protocol {
    constructor(theHandle: Handle_IGESDraw_Protocol);
  }

  export declare class Handle_IGESDraw_Protocol_4 extends Handle_IGESDraw_Protocol {
    constructor(theHandle: Handle_IGESDraw_Protocol);
  }

export declare class IGESDraw_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolLabelDisplay {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_LabelDisplay, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_LabelDisplay, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_LabelDisplay, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_LabelDisplay): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_LabelDisplay, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_LabelDisplay, entto: Handle_IGESDraw_LabelDisplay, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_LabelDisplay, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDraw_PerspectiveView {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_PerspectiveView): void;
  get(): IGESDraw_PerspectiveView;
  delete(): void;
}

  export declare class Handle_IGESDraw_PerspectiveView_1 extends Handle_IGESDraw_PerspectiveView {
    constructor();
  }

  export declare class Handle_IGESDraw_PerspectiveView_2 extends Handle_IGESDraw_PerspectiveView {
    constructor(thePtr: IGESDraw_PerspectiveView);
  }

  export declare class Handle_IGESDraw_PerspectiveView_3 extends Handle_IGESDraw_PerspectiveView {
    constructor(theHandle: Handle_IGESDraw_PerspectiveView);
  }

  export declare class Handle_IGESDraw_PerspectiveView_4 extends Handle_IGESDraw_PerspectiveView {
    constructor(theHandle: Handle_IGESDraw_PerspectiveView);
  }

export declare class IGESDraw_PerspectiveView extends IGESData_ViewKindEntity {
  constructor()
  Init(aViewNumber: Graphic3d_ZLayerId, aScaleFactor: Quantity_AbsorbedDose, aViewNormalVector: gp_XYZ, aViewReferencePoint: gp_XYZ, aCenterOfProjection: gp_XYZ, aViewUpVector: gp_XYZ, aViewPlaneDistance: Quantity_AbsorbedDose, aTopLeft: gp_XY, aBottomRight: gp_XY, aDepthClip: Graphic3d_ZLayerId, aBackPlaneDistance: Quantity_AbsorbedDose, aFrontPlaneDistance: Quantity_AbsorbedDose): void;
  IsSingle(): Standard_Boolean;
  NbViews(): Graphic3d_ZLayerId;
  ViewItem(num: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  ViewNumber(): Graphic3d_ZLayerId;
  ScaleFactor(): Quantity_AbsorbedDose;
  ViewNormalVector(): gp_Vec;
  ViewReferencePoint(): gp_Pnt;
  CenterOfProjection(): gp_Pnt;
  ViewUpVector(): gp_Vec;
  ViewPlaneDistance(): Quantity_AbsorbedDose;
  TopLeft(): gp_Pnt2d;
  BottomRight(): gp_Pnt2d;
  DepthClip(): Graphic3d_ZLayerId;
  BackPlaneDistance(): Quantity_AbsorbedDose;
  FrontPlaneDistance(): Quantity_AbsorbedDose;
  ViewMatrix(): Handle_IGESData_TransfEntity;
  ModelToView(coords: gp_XYZ): gp_XYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolViewsVisible {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_ViewsVisible, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_ViewsVisible, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_ViewsVisible, iter: Interface_EntityIterator): void;
  OwnImplied(ent: Handle_IGESDraw_ViewsVisible, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_ViewsVisible): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_ViewsVisible, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_ViewsVisible, entto: Handle_IGESDraw_ViewsVisible, TC: Interface_CopyTool): void;
  OwnRenew(entfrom: Handle_IGESDraw_ViewsVisible, entto: Handle_IGESDraw_ViewsVisible, TC: Interface_CopyTool): void;
  OwnWhenDelete(ent: Handle_IGESDraw_ViewsVisible): void;
  OwnDump(ent: Handle_IGESDraw_ViewsVisible, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(ent: Handle_IGESDraw_ViewsVisible): Standard_Boolean;
  delete(): void;
}

export declare class IGESDraw_ToolSegmentedViewsVisible {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_SegmentedViewsVisible, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_SegmentedViewsVisible, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_SegmentedViewsVisible, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_SegmentedViewsVisible): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_SegmentedViewsVisible, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_SegmentedViewsVisible, entto: Handle_IGESDraw_SegmentedViewsVisible, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_SegmentedViewsVisible, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDraw_Planar {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_Planar): void;
  get(): IGESDraw_Planar;
  delete(): void;
}

  export declare class Handle_IGESDraw_Planar_1 extends Handle_IGESDraw_Planar {
    constructor();
  }

  export declare class Handle_IGESDraw_Planar_2 extends Handle_IGESDraw_Planar {
    constructor(thePtr: IGESDraw_Planar);
  }

  export declare class Handle_IGESDraw_Planar_3 extends Handle_IGESDraw_Planar {
    constructor(theHandle: Handle_IGESDraw_Planar);
  }

  export declare class Handle_IGESDraw_Planar_4 extends Handle_IGESDraw_Planar {
    constructor(theHandle: Handle_IGESDraw_Planar);
  }

export declare class IGESDraw_Planar extends IGESData_IGESEntity {
  constructor()
  Init(nbMats: Graphic3d_ZLayerId, aTransformationMatrix: Handle_IGESGeom_TransformationMatrix, allEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  NbMatrices(): Graphic3d_ZLayerId;
  NbEntities(): Graphic3d_ZLayerId;
  IsIdentityMatrix(): Standard_Boolean;
  TransformMatrix(): Handle_IGESGeom_TransformationMatrix;
  Entity(EntityIndex: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESDraw_Protocol;
  delete(): void;
}

export declare class Handle_IGESDraw_ConnectPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_ConnectPoint): void;
  get(): IGESDraw_ConnectPoint;
  delete(): void;
}

  export declare class Handle_IGESDraw_ConnectPoint_1 extends Handle_IGESDraw_ConnectPoint {
    constructor();
  }

  export declare class Handle_IGESDraw_ConnectPoint_2 extends Handle_IGESDraw_ConnectPoint {
    constructor(thePtr: IGESDraw_ConnectPoint);
  }

  export declare class Handle_IGESDraw_ConnectPoint_3 extends Handle_IGESDraw_ConnectPoint {
    constructor(theHandle: Handle_IGESDraw_ConnectPoint);
  }

  export declare class Handle_IGESDraw_ConnectPoint_4 extends Handle_IGESDraw_ConnectPoint {
    constructor(theHandle: Handle_IGESDraw_ConnectPoint);
  }

export declare class IGESDraw_ConnectPoint extends IGESData_IGESEntity {
  constructor()
  Init(aPoint: gp_XYZ, aDisplaySymbol: Handle_IGESData_IGESEntity, aTypeFlag: Graphic3d_ZLayerId, aFunctionFlag: Graphic3d_ZLayerId, aFunctionIdentifier: Handle_TCollection_HAsciiString, anIdentifierTemplate: Handle_IGESGraph_TextDisplayTemplate, aFunctionName: Handle_TCollection_HAsciiString, aFunctionTemplate: Handle_IGESGraph_TextDisplayTemplate, aPointIdentifier: Graphic3d_ZLayerId, aFunctionCode: Graphic3d_ZLayerId, aSwapFlag: Graphic3d_ZLayerId, anOwnerSubfigure: Handle_IGESData_IGESEntity): void;
  Point(): gp_Pnt;
  TransformedPoint(): gp_Pnt;
  HasDisplaySymbol(): Standard_Boolean;
  DisplaySymbol(): Handle_IGESData_IGESEntity;
  TypeFlag(): Graphic3d_ZLayerId;
  FunctionFlag(): Graphic3d_ZLayerId;
  FunctionIdentifier(): Handle_TCollection_HAsciiString;
  HasIdentifierTemplate(): Standard_Boolean;
  IdentifierTemplate(): Handle_IGESGraph_TextDisplayTemplate;
  FunctionName(): Handle_TCollection_HAsciiString;
  HasFunctionTemplate(): Standard_Boolean;
  FunctionTemplate(): Handle_IGESGraph_TextDisplayTemplate;
  PointIdentifier(): Graphic3d_ZLayerId;
  FunctionCode(): Graphic3d_ZLayerId;
  SwapFlag(): Standard_Boolean;
  HasOwnerSubfigure(): Standard_Boolean;
  OwnerSubfigure(): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_HArray1OfConnectPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_HArray1OfConnectPoint): void;
  get(): IGESDraw_HArray1OfConnectPoint;
  delete(): void;
}

  export declare class Handle_IGESDraw_HArray1OfConnectPoint_1 extends Handle_IGESDraw_HArray1OfConnectPoint {
    constructor();
  }

  export declare class Handle_IGESDraw_HArray1OfConnectPoint_2 extends Handle_IGESDraw_HArray1OfConnectPoint {
    constructor(thePtr: IGESDraw_HArray1OfConnectPoint);
  }

  export declare class Handle_IGESDraw_HArray1OfConnectPoint_3 extends Handle_IGESDraw_HArray1OfConnectPoint {
    constructor(theHandle: Handle_IGESDraw_HArray1OfConnectPoint);
  }

  export declare class Handle_IGESDraw_HArray1OfConnectPoint_4 extends Handle_IGESDraw_HArray1OfConnectPoint {
    constructor(theHandle: Handle_IGESDraw_HArray1OfConnectPoint);
  }

export declare class IGESDraw_ToolPlanar {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_Planar, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_Planar, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_Planar, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDraw_Planar): Standard_Boolean;
  DirChecker(ent: Handle_IGESDraw_Planar): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_Planar, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_Planar, entto: Handle_IGESDraw_Planar, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_Planar, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDraw_SegmentedViewsVisible extends IGESData_ViewKindEntity {
  constructor()
  Init(allViews: Handle_IGESDraw_HArray1OfViewKindEntity, allBreakpointParameters: Handle_TColStd_HArray1OfReal, allDisplayFlags: Handle_TColStd_HArray1OfInteger, allColorValues: Handle_TColStd_HArray1OfInteger, allColorDefinitions: Handle_IGESGraph_HArray1OfColor, allLineFontValues: Handle_TColStd_HArray1OfInteger, allLineFontDefinitions: Handle_IGESBasic_HArray1OfLineFontEntity, allLineWeights: Handle_TColStd_HArray1OfInteger): void;
  IsSingle(): Standard_Boolean;
  NbViews(): Graphic3d_ZLayerId;
  NbSegmentBlocks(): Graphic3d_ZLayerId;
  ViewItem(ViewIndex: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  BreakpointParameter(BreakpointIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  DisplayFlag(FlagIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsColorDefinition(ColorIndex: Graphic3d_ZLayerId): Standard_Boolean;
  ColorValue(ColorIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ColorDefinition(ColorIndex: Graphic3d_ZLayerId): Handle_IGESGraph_Color;
  IsFontDefinition(FontIndex: Graphic3d_ZLayerId): Standard_Boolean;
  LineFontValue(FontIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  LineFontDefinition(FontIndex: Graphic3d_ZLayerId): Handle_IGESData_LineFontEntity;
  LineWeightItem(WeightIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_SegmentedViewsVisible {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_SegmentedViewsVisible): void;
  get(): IGESDraw_SegmentedViewsVisible;
  delete(): void;
}

  export declare class Handle_IGESDraw_SegmentedViewsVisible_1 extends Handle_IGESDraw_SegmentedViewsVisible {
    constructor();
  }

  export declare class Handle_IGESDraw_SegmentedViewsVisible_2 extends Handle_IGESDraw_SegmentedViewsVisible {
    constructor(thePtr: IGESDraw_SegmentedViewsVisible);
  }

  export declare class Handle_IGESDraw_SegmentedViewsVisible_3 extends Handle_IGESDraw_SegmentedViewsVisible {
    constructor(theHandle: Handle_IGESDraw_SegmentedViewsVisible);
  }

  export declare class Handle_IGESDraw_SegmentedViewsVisible_4 extends Handle_IGESDraw_SegmentedViewsVisible {
    constructor(theHandle: Handle_IGESDraw_SegmentedViewsVisible);
  }

export declare class IGESDraw_ToolView {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_View, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_View, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_View, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_View): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_View, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_View, entto: Handle_IGESDraw_View, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_View, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDraw_ViewsVisibleWithAttr {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_ViewsVisibleWithAttr): void;
  get(): IGESDraw_ViewsVisibleWithAttr;
  delete(): void;
}

  export declare class Handle_IGESDraw_ViewsVisibleWithAttr_1 extends Handle_IGESDraw_ViewsVisibleWithAttr {
    constructor();
  }

  export declare class Handle_IGESDraw_ViewsVisibleWithAttr_2 extends Handle_IGESDraw_ViewsVisibleWithAttr {
    constructor(thePtr: IGESDraw_ViewsVisibleWithAttr);
  }

  export declare class Handle_IGESDraw_ViewsVisibleWithAttr_3 extends Handle_IGESDraw_ViewsVisibleWithAttr {
    constructor(theHandle: Handle_IGESDraw_ViewsVisibleWithAttr);
  }

  export declare class Handle_IGESDraw_ViewsVisibleWithAttr_4 extends Handle_IGESDraw_ViewsVisibleWithAttr {
    constructor(theHandle: Handle_IGESDraw_ViewsVisibleWithAttr);
  }

export declare class IGESDraw_ViewsVisibleWithAttr extends IGESData_ViewKindEntity {
  constructor()
  Init(allViewEntities: Handle_IGESDraw_HArray1OfViewKindEntity, allLineFonts: Handle_TColStd_HArray1OfInteger, allLineDefinitions: Handle_IGESBasic_HArray1OfLineFontEntity, allColorValues: Handle_TColStd_HArray1OfInteger, allColorDefinitions: Handle_IGESGraph_HArray1OfColor, allLineWeights: Handle_TColStd_HArray1OfInteger, allDisplayEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  InitImplied(allDisplayEntity: Handle_IGESData_HArray1OfIGESEntity): void;
  IsSingle(): Standard_Boolean;
  NbViews(): Graphic3d_ZLayerId;
  NbDisplayedEntities(): Graphic3d_ZLayerId;
  ViewItem(Index: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  LineFontValue(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsFontDefinition(Index: Graphic3d_ZLayerId): Standard_Boolean;
  FontDefinition(Index: Graphic3d_ZLayerId): Handle_IGESData_LineFontEntity;
  ColorValue(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsColorDefinition(Index: Graphic3d_ZLayerId): Standard_Boolean;
  ColorDefinition(Index: Graphic3d_ZLayerId): Handle_IGESGraph_Color;
  LineWeightItem(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  DisplayedEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolViewsVisibleWithAttr {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_ViewsVisibleWithAttr, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_ViewsVisibleWithAttr, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_ViewsVisibleWithAttr, iter: Interface_EntityIterator): void;
  OwnImplied(ent: Handle_IGESDraw_ViewsVisibleWithAttr, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_ViewsVisibleWithAttr): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_ViewsVisibleWithAttr, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_ViewsVisibleWithAttr, entto: Handle_IGESDraw_ViewsVisibleWithAttr, TC: Interface_CopyTool): void;
  OwnRenew(entfrom: Handle_IGESDraw_ViewsVisibleWithAttr, entto: Handle_IGESDraw_ViewsVisibleWithAttr, TC: Interface_CopyTool): void;
  OwnWhenDelete(ent: Handle_IGESDraw_ViewsVisibleWithAttr): void;
  OwnDump(ent: Handle_IGESDraw_ViewsVisibleWithAttr, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(ent: Handle_IGESDraw_ViewsVisibleWithAttr): Standard_Boolean;
  delete(): void;
}

export declare class Handle_IGESDraw_NetworkSubfigure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_NetworkSubfigure): void;
  get(): IGESDraw_NetworkSubfigure;
  delete(): void;
}

  export declare class Handle_IGESDraw_NetworkSubfigure_1 extends Handle_IGESDraw_NetworkSubfigure {
    constructor();
  }

  export declare class Handle_IGESDraw_NetworkSubfigure_2 extends Handle_IGESDraw_NetworkSubfigure {
    constructor(thePtr: IGESDraw_NetworkSubfigure);
  }

  export declare class Handle_IGESDraw_NetworkSubfigure_3 extends Handle_IGESDraw_NetworkSubfigure {
    constructor(theHandle: Handle_IGESDraw_NetworkSubfigure);
  }

  export declare class Handle_IGESDraw_NetworkSubfigure_4 extends Handle_IGESDraw_NetworkSubfigure {
    constructor(theHandle: Handle_IGESDraw_NetworkSubfigure);
  }

export declare class IGESDraw_NetworkSubfigure extends IGESData_IGESEntity {
  constructor()
  Init(aDefinition: Handle_IGESDraw_NetworkSubfigureDef, aTranslation: gp_XYZ, aScaleFactor: gp_XYZ, aTypeFlag: Graphic3d_ZLayerId, aDesignator: Handle_TCollection_HAsciiString, aTemplate: Handle_IGESGraph_TextDisplayTemplate, allConnectPoints: Handle_IGESDraw_HArray1OfConnectPoint): void;
  SubfigureDefinition(): Handle_IGESDraw_NetworkSubfigureDef;
  Translation(): gp_XYZ;
  TransformedTranslation(): gp_XYZ;
  ScaleFactors(): gp_XYZ;
  TypeFlag(): Graphic3d_ZLayerId;
  ReferenceDesignator(): Handle_TCollection_HAsciiString;
  HasDesignatorTemplate(): Standard_Boolean;
  DesignatorTemplate(): Handle_IGESGraph_TextDisplayTemplate;
  NbConnectPoints(): Graphic3d_ZLayerId;
  ConnectPoint(Index: Graphic3d_ZLayerId): Handle_IGESDraw_ConnectPoint;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolConnectPoint {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_ConnectPoint, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_ConnectPoint, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_ConnectPoint, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_ConnectPoint): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_ConnectPoint, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_ConnectPoint, entto: Handle_IGESDraw_ConnectPoint, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_ConnectPoint, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDraw_HArray1OfViewKindEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_HArray1OfViewKindEntity): void;
  get(): IGESDraw_HArray1OfViewKindEntity;
  delete(): void;
}

  export declare class Handle_IGESDraw_HArray1OfViewKindEntity_1 extends Handle_IGESDraw_HArray1OfViewKindEntity {
    constructor();
  }

  export declare class Handle_IGESDraw_HArray1OfViewKindEntity_2 extends Handle_IGESDraw_HArray1OfViewKindEntity {
    constructor(thePtr: IGESDraw_HArray1OfViewKindEntity);
  }

  export declare class Handle_IGESDraw_HArray1OfViewKindEntity_3 extends Handle_IGESDraw_HArray1OfViewKindEntity {
    constructor(theHandle: Handle_IGESDraw_HArray1OfViewKindEntity);
  }

  export declare class Handle_IGESDraw_HArray1OfViewKindEntity_4 extends Handle_IGESDraw_HArray1OfViewKindEntity {
    constructor(theHandle: Handle_IGESDraw_HArray1OfViewKindEntity);
  }

export declare class IGESDraw_DrawingWithRotation extends IGESData_IGESEntity {
  constructor()
  Init(allViews: Handle_IGESDraw_HArray1OfViewKindEntity, allViewOrigins: Handle_TColgp_HArray1OfXY, allOrientationAngles: Handle_TColStd_HArray1OfReal, allAnnotations: Handle_IGESData_HArray1OfIGESEntity): void;
  NbViews(): Graphic3d_ZLayerId;
  ViewItem(Index: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  ViewOrigin(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  OrientationAngle(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbAnnotations(): Graphic3d_ZLayerId;
  Annotation(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  ViewToDrawing(NumView: Graphic3d_ZLayerId, ViewCoords: gp_XYZ): gp_XY;
  DrawingUnit(value: Quantity_AbsorbedDose): Standard_Boolean;
  DrawingSize(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_DrawingWithRotation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_DrawingWithRotation): void;
  get(): IGESDraw_DrawingWithRotation;
  delete(): void;
}

  export declare class Handle_IGESDraw_DrawingWithRotation_1 extends Handle_IGESDraw_DrawingWithRotation {
    constructor();
  }

  export declare class Handle_IGESDraw_DrawingWithRotation_2 extends Handle_IGESDraw_DrawingWithRotation {
    constructor(thePtr: IGESDraw_DrawingWithRotation);
  }

  export declare class Handle_IGESDraw_DrawingWithRotation_3 extends Handle_IGESDraw_DrawingWithRotation {
    constructor(theHandle: Handle_IGESDraw_DrawingWithRotation);
  }

  export declare class Handle_IGESDraw_DrawingWithRotation_4 extends Handle_IGESDraw_DrawingWithRotation {
    constructor(theHandle: Handle_IGESDraw_DrawingWithRotation);
  }

export declare class Handle_IGESDraw_CircArraySubfigure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_CircArraySubfigure): void;
  get(): IGESDraw_CircArraySubfigure;
  delete(): void;
}

  export declare class Handle_IGESDraw_CircArraySubfigure_1 extends Handle_IGESDraw_CircArraySubfigure {
    constructor();
  }

  export declare class Handle_IGESDraw_CircArraySubfigure_2 extends Handle_IGESDraw_CircArraySubfigure {
    constructor(thePtr: IGESDraw_CircArraySubfigure);
  }

  export declare class Handle_IGESDraw_CircArraySubfigure_3 extends Handle_IGESDraw_CircArraySubfigure {
    constructor(theHandle: Handle_IGESDraw_CircArraySubfigure);
  }

  export declare class Handle_IGESDraw_CircArraySubfigure_4 extends Handle_IGESDraw_CircArraySubfigure {
    constructor(theHandle: Handle_IGESDraw_CircArraySubfigure);
  }

export declare class IGESDraw_CircArraySubfigure extends IGESData_IGESEntity {
  constructor()
  Init(aBase: Handle_IGESData_IGESEntity, aNumLocs: Graphic3d_ZLayerId, aCenter: gp_XYZ, aRadius: Quantity_AbsorbedDose, aStAngle: Quantity_AbsorbedDose, aDelAngle: Quantity_AbsorbedDose, aFlag: Graphic3d_ZLayerId, allNumPos: Handle_TColStd_HArray1OfInteger): void;
  BaseEntity(): Handle_IGESData_IGESEntity;
  NbLocations(): Graphic3d_ZLayerId;
  CenterPoint(): gp_Pnt;
  TransformedCenterPoint(): gp_Pnt;
  CircleRadius(): Quantity_AbsorbedDose;
  StartAngle(): Quantity_AbsorbedDose;
  DeltaAngle(): Quantity_AbsorbedDose;
  ListCount(): Graphic3d_ZLayerId;
  DisplayFlag(): Standard_Boolean;
  DoDontFlag(): Standard_Boolean;
  PositionNum(Index: Graphic3d_ZLayerId): Standard_Boolean;
  ListPosition(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolCircArraySubfigure {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_CircArraySubfigure, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_CircArraySubfigure, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_CircArraySubfigure, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_CircArraySubfigure): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_CircArraySubfigure, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_CircArraySubfigure, entto: Handle_IGESDraw_CircArraySubfigure, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_CircArraySubfigure, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDraw_View extends IGESData_ViewKindEntity {
  constructor()
  Init(aViewNum: Graphic3d_ZLayerId, aScale: Quantity_AbsorbedDose, aLeftPlane: Handle_IGESGeom_Plane, aTopPlane: Handle_IGESGeom_Plane, aRightPlane: Handle_IGESGeom_Plane, aBottomPlane: Handle_IGESGeom_Plane, aBackPlane: Handle_IGESGeom_Plane, aFrontPlane: Handle_IGESGeom_Plane): void;
  IsSingle(): Standard_Boolean;
  NbViews(): Graphic3d_ZLayerId;
  ViewItem(num: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  ViewNumber(): Graphic3d_ZLayerId;
  ScaleFactor(): Quantity_AbsorbedDose;
  HasLeftPlane(): Standard_Boolean;
  LeftPlane(): Handle_IGESGeom_Plane;
  HasTopPlane(): Standard_Boolean;
  TopPlane(): Handle_IGESGeom_Plane;
  HasRightPlane(): Standard_Boolean;
  RightPlane(): Handle_IGESGeom_Plane;
  HasBottomPlane(): Standard_Boolean;
  BottomPlane(): Handle_IGESGeom_Plane;
  HasBackPlane(): Standard_Boolean;
  BackPlane(): Handle_IGESGeom_Plane;
  HasFrontPlane(): Standard_Boolean;
  FrontPlane(): Handle_IGESGeom_Plane;
  ViewMatrix(): Handle_IGESData_TransfEntity;
  ModelToView(coords: gp_XYZ): gp_XYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_View {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_View): void;
  get(): IGESDraw_View;
  delete(): void;
}

  export declare class Handle_IGESDraw_View_1 extends Handle_IGESDraw_View {
    constructor();
  }

  export declare class Handle_IGESDraw_View_2 extends Handle_IGESDraw_View {
    constructor(thePtr: IGESDraw_View);
  }

  export declare class Handle_IGESDraw_View_3 extends Handle_IGESDraw_View {
    constructor(theHandle: Handle_IGESDraw_View);
  }

  export declare class Handle_IGESDraw_View_4 extends Handle_IGESDraw_View {
    constructor(theHandle: Handle_IGESDraw_View);
  }

export declare class IGESDraw_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_SpecificModule): void;
  get(): IGESDraw_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESDraw_SpecificModule_1 extends Handle_IGESDraw_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESDraw_SpecificModule_2 extends Handle_IGESDraw_SpecificModule {
    constructor(thePtr: IGESDraw_SpecificModule);
  }

  export declare class Handle_IGESDraw_SpecificModule_3 extends Handle_IGESDraw_SpecificModule {
    constructor(theHandle: Handle_IGESDraw_SpecificModule);
  }

  export declare class Handle_IGESDraw_SpecificModule_4 extends Handle_IGESDraw_SpecificModule {
    constructor(theHandle: Handle_IGESDraw_SpecificModule);
  }

export declare class IGESDraw_RectArraySubfigure extends IGESData_IGESEntity {
  constructor()
  Init(aBase: Handle_IGESData_IGESEntity, aScale: Quantity_AbsorbedDose, aCorner: gp_XYZ, nbCols: Graphic3d_ZLayerId, nbRows: Graphic3d_ZLayerId, hDisp: Quantity_AbsorbedDose, vtDisp: Quantity_AbsorbedDose, rotationAngle: Quantity_AbsorbedDose, doDont: Graphic3d_ZLayerId, allNumPos: Handle_TColStd_HArray1OfInteger): void;
  BaseEntity(): Handle_IGESData_IGESEntity;
  ScaleFactor(): Quantity_AbsorbedDose;
  LowerLeftCorner(): gp_Pnt;
  TransformedLowerLeftCorner(): gp_Pnt;
  NbColumns(): Graphic3d_ZLayerId;
  NbRows(): Graphic3d_ZLayerId;
  ColumnSeparation(): Quantity_AbsorbedDose;
  RowSeparation(): Quantity_AbsorbedDose;
  RotationAngle(): Quantity_AbsorbedDose;
  DisplayFlag(): Standard_Boolean;
  ListCount(): Graphic3d_ZLayerId;
  DoDontFlag(): Standard_Boolean;
  PositionNum(Index: Graphic3d_ZLayerId): Standard_Boolean;
  ListPosition(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_RectArraySubfigure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_RectArraySubfigure): void;
  get(): IGESDraw_RectArraySubfigure;
  delete(): void;
}

  export declare class Handle_IGESDraw_RectArraySubfigure_1 extends Handle_IGESDraw_RectArraySubfigure {
    constructor();
  }

  export declare class Handle_IGESDraw_RectArraySubfigure_2 extends Handle_IGESDraw_RectArraySubfigure {
    constructor(thePtr: IGESDraw_RectArraySubfigure);
  }

  export declare class Handle_IGESDraw_RectArraySubfigure_3 extends Handle_IGESDraw_RectArraySubfigure {
    constructor(theHandle: Handle_IGESDraw_RectArraySubfigure);
  }

  export declare class Handle_IGESDraw_RectArraySubfigure_4 extends Handle_IGESDraw_RectArraySubfigure {
    constructor(theHandle: Handle_IGESDraw_RectArraySubfigure);
  }

export declare class IGESDraw_ToolNetworkSubfigure {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_NetworkSubfigure, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_NetworkSubfigure, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_NetworkSubfigure, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_NetworkSubfigure): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_NetworkSubfigure, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_NetworkSubfigure, entto: Handle_IGESDraw_NetworkSubfigure, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_NetworkSubfigure, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDraw_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESDraw_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_ReadWriteModule): void;
  get(): IGESDraw_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESDraw_ReadWriteModule_1 extends Handle_IGESDraw_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESDraw_ReadWriteModule_2 extends Handle_IGESDraw_ReadWriteModule {
    constructor(thePtr: IGESDraw_ReadWriteModule);
  }

  export declare class Handle_IGESDraw_ReadWriteModule_3 extends Handle_IGESDraw_ReadWriteModule {
    constructor(theHandle: Handle_IGESDraw_ReadWriteModule);
  }

  export declare class Handle_IGESDraw_ReadWriteModule_4 extends Handle_IGESDraw_ReadWriteModule {
    constructor(theHandle: Handle_IGESDraw_ReadWriteModule);
  }

export declare class IGESDraw_ToolDrawing {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_Drawing, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_Drawing, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_Drawing, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDraw_Drawing): Standard_Boolean;
  DirChecker(ent: Handle_IGESDraw_Drawing): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_Drawing, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_Drawing, entto: Handle_IGESDraw_Drawing, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_Drawing, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDraw_Drawing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_Drawing): void;
  get(): IGESDraw_Drawing;
  delete(): void;
}

  export declare class Handle_IGESDraw_Drawing_1 extends Handle_IGESDraw_Drawing {
    constructor();
  }

  export declare class Handle_IGESDraw_Drawing_2 extends Handle_IGESDraw_Drawing {
    constructor(thePtr: IGESDraw_Drawing);
  }

  export declare class Handle_IGESDraw_Drawing_3 extends Handle_IGESDraw_Drawing {
    constructor(theHandle: Handle_IGESDraw_Drawing);
  }

  export declare class Handle_IGESDraw_Drawing_4 extends Handle_IGESDraw_Drawing {
    constructor(theHandle: Handle_IGESDraw_Drawing);
  }

export declare class IGESDraw_Drawing extends IGESData_IGESEntity {
  constructor()
  Init(allViews: Handle_IGESDraw_HArray1OfViewKindEntity, allViewOrigins: Handle_TColgp_HArray1OfXY, allAnnotations: Handle_IGESData_HArray1OfIGESEntity): void;
  NbViews(): Graphic3d_ZLayerId;
  ViewItem(ViewIndex: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  ViewOrigin(TViewIndex: Graphic3d_ZLayerId): gp_Pnt2d;
  NbAnnotations(): Graphic3d_ZLayerId;
  Annotation(AnnotationIndex: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  ViewToDrawing(NumView: Graphic3d_ZLayerId, ViewCoords: gp_XYZ): gp_XY;
  DrawingUnit(value: Quantity_AbsorbedDose): Standard_Boolean;
  DrawingSize(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolDrawingWithRotation {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_DrawingWithRotation, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_DrawingWithRotation, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_DrawingWithRotation, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESDraw_DrawingWithRotation): Standard_Boolean;
  DirChecker(ent: Handle_IGESDraw_DrawingWithRotation): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_DrawingWithRotation, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_DrawingWithRotation, entto: Handle_IGESDraw_DrawingWithRotation, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_DrawingWithRotation, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDraw_ToolPerspectiveView {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_PerspectiveView, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_PerspectiveView, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_PerspectiveView, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_PerspectiveView): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_PerspectiveView, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_PerspectiveView, entto: Handle_IGESDraw_PerspectiveView, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_PerspectiveView, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESDraw_LabelDisplay {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESDraw_LabelDisplay): void;
  get(): IGESDraw_LabelDisplay;
  delete(): void;
}

  export declare class Handle_IGESDraw_LabelDisplay_1 extends Handle_IGESDraw_LabelDisplay {
    constructor();
  }

  export declare class Handle_IGESDraw_LabelDisplay_2 extends Handle_IGESDraw_LabelDisplay {
    constructor(thePtr: IGESDraw_LabelDisplay);
  }

  export declare class Handle_IGESDraw_LabelDisplay_3 extends Handle_IGESDraw_LabelDisplay {
    constructor(theHandle: Handle_IGESDraw_LabelDisplay);
  }

  export declare class Handle_IGESDraw_LabelDisplay_4 extends Handle_IGESDraw_LabelDisplay {
    constructor(theHandle: Handle_IGESDraw_LabelDisplay);
  }

export declare class IGESDraw_LabelDisplay extends IGESData_LabelDisplayEntity {
  constructor()
  Init(allViews: Handle_IGESDraw_HArray1OfViewKindEntity, allTextLocations: Handle_TColgp_HArray1OfXYZ, allLeaderEntities: Handle_IGESDimen_HArray1OfLeaderArrow, allLabelLevels: Handle_TColStd_HArray1OfInteger, allDisplayedEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  NbLabels(): Graphic3d_ZLayerId;
  ViewItem(ViewIndex: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  TextLocation(ViewIndex: Graphic3d_ZLayerId): gp_Pnt;
  LeaderEntity(ViewIndex: Graphic3d_ZLayerId): Handle_IGESDimen_LeaderArrow;
  LabelLevel(ViewIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  DisplayedEntity(EntityIndex: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  TransformedTextLocation(ViewIndex: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESDraw_ToolNetworkSubfigureDef {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_NetworkSubfigureDef, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_NetworkSubfigureDef, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_NetworkSubfigureDef, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_NetworkSubfigureDef): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_NetworkSubfigureDef, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_NetworkSubfigureDef, entto: Handle_IGESDraw_NetworkSubfigureDef, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_NetworkSubfigureDef, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESDraw_ToolRectArraySubfigure {
  constructor()
  ReadOwnParams(ent: Handle_IGESDraw_RectArraySubfigure, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESDraw_RectArraySubfigure, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESDraw_RectArraySubfigure, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESDraw_RectArraySubfigure): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESDraw_RectArraySubfigure, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESDraw_RectArraySubfigure, entto: Handle_IGESDraw_RectArraySubfigure, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESDraw_RectArraySubfigure, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class XSAlgo {
  constructor();
  static Init(): void;
  static SetAlgoContainer(aContainer: Handle_XSAlgo_AlgoContainer): void;
  static AlgoContainer(): Handle_XSAlgo_AlgoContainer;
  delete(): void;
}

export declare type XSAlgo_Caller = {
  XSAlgo_DEFAULT: {};
  XSAlgo_IGES: {};
  XSAlgo_STEP: {};
}

export declare class Handle_XSAlgo_ToolContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSAlgo_ToolContainer): void;
  get(): XSAlgo_ToolContainer;
  delete(): void;
}

  export declare class Handle_XSAlgo_ToolContainer_1 extends Handle_XSAlgo_ToolContainer {
    constructor();
  }

  export declare class Handle_XSAlgo_ToolContainer_2 extends Handle_XSAlgo_ToolContainer {
    constructor(thePtr: XSAlgo_ToolContainer);
  }

  export declare class Handle_XSAlgo_ToolContainer_3 extends Handle_XSAlgo_ToolContainer {
    constructor(theHandle: Handle_XSAlgo_ToolContainer);
  }

  export declare class Handle_XSAlgo_ToolContainer_4 extends Handle_XSAlgo_ToolContainer {
    constructor(theHandle: Handle_XSAlgo_ToolContainer);
  }

export declare class XSAlgo_ToolContainer extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XSAlgo_AlgoContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSAlgo_AlgoContainer): void;
  get(): XSAlgo_AlgoContainer;
  delete(): void;
}

  export declare class Handle_XSAlgo_AlgoContainer_1 extends Handle_XSAlgo_AlgoContainer {
    constructor();
  }

  export declare class Handle_XSAlgo_AlgoContainer_2 extends Handle_XSAlgo_AlgoContainer {
    constructor(thePtr: XSAlgo_AlgoContainer);
  }

  export declare class Handle_XSAlgo_AlgoContainer_3 extends Handle_XSAlgo_AlgoContainer {
    constructor(theHandle: Handle_XSAlgo_AlgoContainer);
  }

  export declare class Handle_XSAlgo_AlgoContainer_4 extends Handle_XSAlgo_AlgoContainer {
    constructor(theHandle: Handle_XSAlgo_AlgoContainer);
  }

export declare class XSAlgo_AlgoContainer extends Standard_Transient {
  constructor()
  SetToolContainer(TC: Handle_XSAlgo_ToolContainer): void;
  ToolContainer(): Handle_XSAlgo_ToolContainer;
  PrepareForTransfer(): void;
  ProcessShape(shape: TopoDS_Shape, Prec: Quantity_AbsorbedDose, MaxTol: Quantity_AbsorbedDose, rscfile: Standard_CString, seq: Standard_CString, info: Handle_Standard_Transient, theProgress: Message_ProgressRange, NonManifold: Standard_Boolean): TopoDS_Shape;
  CheckPCurve(edge: TopoDS_Edge, face: TopoDS_Face, preci: Quantity_AbsorbedDose, isSeam: Standard_Boolean): Standard_Boolean;
  MergeTransferInfo_1(TP: Handle_Transfer_TransientProcess, info: Handle_Standard_Transient, startTPitem: Graphic3d_ZLayerId): void;
  MergeTransferInfo_2(FP: Handle_Transfer_FinderProcess, info: Handle_Standard_Transient): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_BSplineCurve extends IGESData_IGESEntity {
  constructor()
  Init(anIndex: Graphic3d_ZLayerId, aDegree: Graphic3d_ZLayerId, aPlanar: Standard_Boolean, aClosed: Standard_Boolean, aPolynom: Standard_Boolean, aPeriodic: Standard_Boolean, allKnots: Handle_TColStd_HArray1OfReal, allWeights: Handle_TColStd_HArray1OfReal, allPoles: Handle_TColgp_HArray1OfXYZ, aUmin: Quantity_AbsorbedDose, aUmax: Quantity_AbsorbedDose, aNorm: gp_XYZ): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  UpperIndex(): Graphic3d_ZLayerId;
  Degree(): Graphic3d_ZLayerId;
  IsPlanar(): Standard_Boolean;
  IsClosed(): Standard_Boolean;
  IsPolynomial(flag: Standard_Boolean): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  NbKnots(): Graphic3d_ZLayerId;
  Knot(anIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbPoles(): Graphic3d_ZLayerId;
  Weight(anIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Pole(anIndex: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPole(anIndex: Graphic3d_ZLayerId): gp_Pnt;
  UMin(): Quantity_AbsorbedDose;
  UMax(): Quantity_AbsorbedDose;
  Normal(): gp_XYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_BSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_BSplineCurve): void;
  get(): IGESGeom_BSplineCurve;
  delete(): void;
}

  export declare class Handle_IGESGeom_BSplineCurve_1 extends Handle_IGESGeom_BSplineCurve {
    constructor();
  }

  export declare class Handle_IGESGeom_BSplineCurve_2 extends Handle_IGESGeom_BSplineCurve {
    constructor(thePtr: IGESGeom_BSplineCurve);
  }

  export declare class Handle_IGESGeom_BSplineCurve_3 extends Handle_IGESGeom_BSplineCurve {
    constructor(theHandle: Handle_IGESGeom_BSplineCurve);
  }

  export declare class Handle_IGESGeom_BSplineCurve_4 extends Handle_IGESGeom_BSplineCurve {
    constructor(theHandle: Handle_IGESGeom_BSplineCurve);
  }

export declare class IGESGeom_ToolDirection {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_Direction, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_Direction, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_Direction, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_Direction): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_Direction, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_Direction, entto: Handle_IGESGeom_Direction, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_Direction, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolOffsetCurve {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_OffsetCurve, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_OffsetCurve, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_OffsetCurve, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGeom_OffsetCurve): Standard_Boolean;
  DirChecker(ent: Handle_IGESGeom_OffsetCurve): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_OffsetCurve, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_OffsetCurve, entto: Handle_IGESGeom_OffsetCurve, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_OffsetCurve, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolCompositeCurve {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_CompositeCurve, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_CompositeCurve, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_CompositeCurve, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_CompositeCurve): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_CompositeCurve, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_CompositeCurve, entto: Handle_IGESGeom_CompositeCurve, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_CompositeCurve, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolRuledSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_RuledSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_RuledSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_RuledSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_RuledSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_RuledSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_RuledSurface, entto: Handle_IGESGeom_RuledSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_RuledSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_ReadWriteModule): void;
  get(): IGESGeom_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESGeom_ReadWriteModule_1 extends Handle_IGESGeom_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESGeom_ReadWriteModule_2 extends Handle_IGESGeom_ReadWriteModule {
    constructor(thePtr: IGESGeom_ReadWriteModule);
  }

  export declare class Handle_IGESGeom_ReadWriteModule_3 extends Handle_IGESGeom_ReadWriteModule {
    constructor(theHandle: Handle_IGESGeom_ReadWriteModule);
  }

  export declare class Handle_IGESGeom_ReadWriteModule_4 extends Handle_IGESGeom_ReadWriteModule {
    constructor(theHandle: Handle_IGESGeom_ReadWriteModule);
  }

export declare class IGESGeom_ToolBoundedSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_BoundedSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_BoundedSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_BoundedSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_BoundedSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_BoundedSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_BoundedSurface, entto: Handle_IGESGeom_BoundedSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_BoundedSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolConicArc {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_ConicArc, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_ConicArc, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_ConicArc, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGeom_ConicArc): Standard_Boolean;
  DirChecker(ent: Handle_IGESGeom_ConicArc): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_ConicArc, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_ConicArc, entto: Handle_IGESGeom_ConicArc, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_ConicArc, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolBoundary {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_Boundary, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_Boundary, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_Boundary, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGeom_Boundary): Standard_Boolean;
  DirChecker(ent: Handle_IGESGeom_Boundary): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_Boundary, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_Boundary, entto: Handle_IGESGeom_Boundary, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_Boundary, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_Point {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Point): void;
  get(): IGESGeom_Point;
  delete(): void;
}

  export declare class Handle_IGESGeom_Point_1 extends Handle_IGESGeom_Point {
    constructor();
  }

  export declare class Handle_IGESGeom_Point_2 extends Handle_IGESGeom_Point {
    constructor(thePtr: IGESGeom_Point);
  }

  export declare class Handle_IGESGeom_Point_3 extends Handle_IGESGeom_Point {
    constructor(theHandle: Handle_IGESGeom_Point);
  }

  export declare class Handle_IGESGeom_Point_4 extends Handle_IGESGeom_Point {
    constructor(theHandle: Handle_IGESGeom_Point);
  }

export declare class IGESGeom_Point extends IGESData_IGESEntity {
  constructor()
  Init(aPoint: gp_XYZ, aSymbol: Handle_IGESBasic_SubfigureDef): void;
  Value(): gp_Pnt;
  TransformedValue(): gp_Pnt;
  HasDisplaySymbol(): Standard_Boolean;
  DisplaySymbol(): Handle_IGESBasic_SubfigureDef;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_ToolOffsetSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_OffsetSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_OffsetSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_OffsetSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_OffsetSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_OffsetSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_OffsetSurface, entto: Handle_IGESGeom_OffsetSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_OffsetSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_RuledSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_RuledSurface): void;
  get(): IGESGeom_RuledSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_RuledSurface_1 extends Handle_IGESGeom_RuledSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_RuledSurface_2 extends Handle_IGESGeom_RuledSurface {
    constructor(thePtr: IGESGeom_RuledSurface);
  }

  export declare class Handle_IGESGeom_RuledSurface_3 extends Handle_IGESGeom_RuledSurface {
    constructor(theHandle: Handle_IGESGeom_RuledSurface);
  }

  export declare class Handle_IGESGeom_RuledSurface_4 extends Handle_IGESGeom_RuledSurface {
    constructor(theHandle: Handle_IGESGeom_RuledSurface);
  }

export declare class IGESGeom_RuledSurface extends IGESData_IGESEntity {
  constructor()
  Init(aCurve: Handle_IGESData_IGESEntity, anotherCurve: Handle_IGESData_IGESEntity, aDirFlag: Graphic3d_ZLayerId, aDevFlag: Graphic3d_ZLayerId): void;
  SetRuledByParameter(mode: Standard_Boolean): void;
  IsRuledByParameter(): Standard_Boolean;
  FirstCurve(): Handle_IGESData_IGESEntity;
  SecondCurve(): Handle_IGESData_IGESEntity;
  DirectionFlag(): Graphic3d_ZLayerId;
  IsDevelopable(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_TrimmedSurface extends IGESData_IGESEntity {
  constructor()
  Init(aSurface: Handle_IGESData_IGESEntity, aFlag: Graphic3d_ZLayerId, anOuter: Handle_IGESGeom_CurveOnSurface, allInners: Handle_IGESGeom_HArray1OfCurveOnSurface): void;
  Surface(): Handle_IGESData_IGESEntity;
  HasOuterContour(): Standard_Boolean;
  OuterContour(): Handle_IGESGeom_CurveOnSurface;
  OuterBoundaryType(): Graphic3d_ZLayerId;
  NbInnerContours(): Graphic3d_ZLayerId;
  InnerContour(Index: Graphic3d_ZLayerId): Handle_IGESGeom_CurveOnSurface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_TrimmedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_TrimmedSurface): void;
  get(): IGESGeom_TrimmedSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_TrimmedSurface_1 extends Handle_IGESGeom_TrimmedSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_TrimmedSurface_2 extends Handle_IGESGeom_TrimmedSurface {
    constructor(thePtr: IGESGeom_TrimmedSurface);
  }

  export declare class Handle_IGESGeom_TrimmedSurface_3 extends Handle_IGESGeom_TrimmedSurface {
    constructor(theHandle: Handle_IGESGeom_TrimmedSurface);
  }

  export declare class Handle_IGESGeom_TrimmedSurface_4 extends Handle_IGESGeom_TrimmedSurface {
    constructor(theHandle: Handle_IGESGeom_TrimmedSurface);
  }

export declare class IGESGeom_ToolCurveOnSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_CurveOnSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_CurveOnSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_CurveOnSurface, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGeom_CurveOnSurface): Standard_Boolean;
  DirChecker(ent: Handle_IGESGeom_CurveOnSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_CurveOnSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_CurveOnSurface, entto: Handle_IGESGeom_CurveOnSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_CurveOnSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_CurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_CurveOnSurface): void;
  get(): IGESGeom_CurveOnSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_CurveOnSurface_1 extends Handle_IGESGeom_CurveOnSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_CurveOnSurface_2 extends Handle_IGESGeom_CurveOnSurface {
    constructor(thePtr: IGESGeom_CurveOnSurface);
  }

  export declare class Handle_IGESGeom_CurveOnSurface_3 extends Handle_IGESGeom_CurveOnSurface {
    constructor(theHandle: Handle_IGESGeom_CurveOnSurface);
  }

  export declare class Handle_IGESGeom_CurveOnSurface_4 extends Handle_IGESGeom_CurveOnSurface {
    constructor(theHandle: Handle_IGESGeom_CurveOnSurface);
  }

export declare class IGESGeom_CurveOnSurface extends IGESData_IGESEntity {
  constructor()
  Init(aMode: Graphic3d_ZLayerId, aSurface: Handle_IGESData_IGESEntity, aCurveUV: Handle_IGESData_IGESEntity, aCurve3D: Handle_IGESData_IGESEntity, aPreference: Graphic3d_ZLayerId): void;
  CreationMode(): Graphic3d_ZLayerId;
  Surface(): Handle_IGESData_IGESEntity;
  CurveUV(): Handle_IGESData_IGESEntity;
  Curve3D(): Handle_IGESData_IGESEntity;
  PreferenceMode(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_CompositeCurve extends IGESData_IGESEntity {
  constructor()
  Init(allEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  NbCurves(): Graphic3d_ZLayerId;
  Curve(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_CompositeCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_CompositeCurve): void;
  get(): IGESGeom_CompositeCurve;
  delete(): void;
}

  export declare class Handle_IGESGeom_CompositeCurve_1 extends Handle_IGESGeom_CompositeCurve {
    constructor();
  }

  export declare class Handle_IGESGeom_CompositeCurve_2 extends Handle_IGESGeom_CompositeCurve {
    constructor(thePtr: IGESGeom_CompositeCurve);
  }

  export declare class Handle_IGESGeom_CompositeCurve_3 extends Handle_IGESGeom_CompositeCurve {
    constructor(theHandle: Handle_IGESGeom_CompositeCurve);
  }

  export declare class Handle_IGESGeom_CompositeCurve_4 extends Handle_IGESGeom_CompositeCurve {
    constructor(theHandle: Handle_IGESGeom_CompositeCurve);
  }

export declare class IGESGeom_ToolFlash {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_Flash, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_Flash, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_Flash, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGeom_Flash): Standard_Boolean;
  DirChecker(ent: Handle_IGESGeom_Flash): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_Flash, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_Flash, entto: Handle_IGESGeom_Flash, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_Flash, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Line): void;
  get(): IGESGeom_Line;
  delete(): void;
}

  export declare class Handle_IGESGeom_Line_1 extends Handle_IGESGeom_Line {
    constructor();
  }

  export declare class Handle_IGESGeom_Line_2 extends Handle_IGESGeom_Line {
    constructor(thePtr: IGESGeom_Line);
  }

  export declare class Handle_IGESGeom_Line_3 extends Handle_IGESGeom_Line {
    constructor(theHandle: Handle_IGESGeom_Line);
  }

  export declare class Handle_IGESGeom_Line_4 extends Handle_IGESGeom_Line {
    constructor(theHandle: Handle_IGESGeom_Line);
  }

export declare class IGESGeom_Line extends IGESData_IGESEntity {
  constructor()
  Init(aStart: gp_XYZ, anEnd: gp_XYZ): void;
  Infinite(): Graphic3d_ZLayerId;
  SetInfinite(status: Graphic3d_ZLayerId): void;
  StartPoint(): gp_Pnt;
  TransformedStartPoint(): gp_Pnt;
  EndPoint(): gp_Pnt;
  TransformedEndPoint(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_GeneralModule): void;
  get(): IGESGeom_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESGeom_GeneralModule_1 extends Handle_IGESGeom_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESGeom_GeneralModule_2 extends Handle_IGESGeom_GeneralModule {
    constructor(thePtr: IGESGeom_GeneralModule);
  }

  export declare class Handle_IGESGeom_GeneralModule_3 extends Handle_IGESGeom_GeneralModule {
    constructor(theHandle: Handle_IGESGeom_GeneralModule);
  }

  export declare class Handle_IGESGeom_GeneralModule_4 extends Handle_IGESGeom_GeneralModule {
    constructor(theHandle: Handle_IGESGeom_GeneralModule);
  }

export declare class IGESGeom_ToolTransformationMatrix {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_TransformationMatrix, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_TransformationMatrix, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_TransformationMatrix, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGeom_TransformationMatrix): Standard_Boolean;
  DirChecker(ent: Handle_IGESGeom_TransformationMatrix): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_TransformationMatrix, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_TransformationMatrix, entto: Handle_IGESGeom_TransformationMatrix, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_TransformationMatrix, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_CircularArc extends IGESData_IGESEntity {
  constructor()
  Init(aZT: Quantity_AbsorbedDose, aCenter: gp_XY, aStart: gp_XY, anEnd: gp_XY): void;
  Center(): gp_Pnt2d;
  TransformedCenter(): gp_Pnt;
  StartPoint(): gp_Pnt2d;
  TransformedStartPoint(): gp_Pnt;
  ZPlane(): Quantity_AbsorbedDose;
  EndPoint(): gp_Pnt2d;
  TransformedEndPoint(): gp_Pnt;
  Radius(): Quantity_AbsorbedDose;
  Angle(): Quantity_AbsorbedDose;
  Axis(): gp_Dir;
  TransformedAxis(): gp_Dir;
  IsClosed(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_CircularArc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_CircularArc): void;
  get(): IGESGeom_CircularArc;
  delete(): void;
}

  export declare class Handle_IGESGeom_CircularArc_1 extends Handle_IGESGeom_CircularArc {
    constructor();
  }

  export declare class Handle_IGESGeom_CircularArc_2 extends Handle_IGESGeom_CircularArc {
    constructor(thePtr: IGESGeom_CircularArc);
  }

  export declare class Handle_IGESGeom_CircularArc_3 extends Handle_IGESGeom_CircularArc {
    constructor(theHandle: Handle_IGESGeom_CircularArc);
  }

  export declare class Handle_IGESGeom_CircularArc_4 extends Handle_IGESGeom_CircularArc {
    constructor(theHandle: Handle_IGESGeom_CircularArc);
  }

export declare class IGESGeom_TransformationMatrix extends IGESData_TransfEntity {
  constructor()
  Init(aMatrix: Handle_TColStd_HArray2OfReal): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  Data(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Value(): gp_GTrsf;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_TransformationMatrix {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_TransformationMatrix): void;
  get(): IGESGeom_TransformationMatrix;
  delete(): void;
}

  export declare class Handle_IGESGeom_TransformationMatrix_1 extends Handle_IGESGeom_TransformationMatrix {
    constructor();
  }

  export declare class Handle_IGESGeom_TransformationMatrix_2 extends Handle_IGESGeom_TransformationMatrix {
    constructor(thePtr: IGESGeom_TransformationMatrix);
  }

  export declare class Handle_IGESGeom_TransformationMatrix_3 extends Handle_IGESGeom_TransformationMatrix {
    constructor(theHandle: Handle_IGESGeom_TransformationMatrix);
  }

  export declare class Handle_IGESGeom_TransformationMatrix_4 extends Handle_IGESGeom_TransformationMatrix {
    constructor(theHandle: Handle_IGESGeom_TransformationMatrix);
  }

export declare class IGESGeom_ToolCopiousData {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_CopiousData, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_CopiousData, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_CopiousData, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_CopiousData): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_CopiousData, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_CopiousData, entto: Handle_IGESGeom_CopiousData, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_CopiousData, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolSurfaceOfRevolution {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_SurfaceOfRevolution, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_SurfaceOfRevolution, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_SurfaceOfRevolution, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_SurfaceOfRevolution): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_SurfaceOfRevolution, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_SurfaceOfRevolution, entto: Handle_IGESGeom_SurfaceOfRevolution, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_SurfaceOfRevolution, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolBSplineSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_BSplineSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_BSplineSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_BSplineSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_BSplineSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_BSplineSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_BSplineSurface, entto: Handle_IGESGeom_BSplineSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_BSplineSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_HArray1OfTransformationMatrix {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_HArray1OfTransformationMatrix): void;
  get(): IGESGeom_HArray1OfTransformationMatrix;
  delete(): void;
}

  export declare class Handle_IGESGeom_HArray1OfTransformationMatrix_1 extends Handle_IGESGeom_HArray1OfTransformationMatrix {
    constructor();
  }

  export declare class Handle_IGESGeom_HArray1OfTransformationMatrix_2 extends Handle_IGESGeom_HArray1OfTransformationMatrix {
    constructor(thePtr: IGESGeom_HArray1OfTransformationMatrix);
  }

  export declare class Handle_IGESGeom_HArray1OfTransformationMatrix_3 extends Handle_IGESGeom_HArray1OfTransformationMatrix {
    constructor(theHandle: Handle_IGESGeom_HArray1OfTransformationMatrix);
  }

  export declare class Handle_IGESGeom_HArray1OfTransformationMatrix_4 extends Handle_IGESGeom_HArray1OfTransformationMatrix {
    constructor(theHandle: Handle_IGESGeom_HArray1OfTransformationMatrix);
  }

export declare class Handle_IGESGeom_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_SpecificModule): void;
  get(): IGESGeom_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESGeom_SpecificModule_1 extends Handle_IGESGeom_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESGeom_SpecificModule_2 extends Handle_IGESGeom_SpecificModule {
    constructor(thePtr: IGESGeom_SpecificModule);
  }

  export declare class Handle_IGESGeom_SpecificModule_3 extends Handle_IGESGeom_SpecificModule {
    constructor(theHandle: Handle_IGESGeom_SpecificModule);
  }

  export declare class Handle_IGESGeom_SpecificModule_4 extends Handle_IGESGeom_SpecificModule {
    constructor(theHandle: Handle_IGESGeom_SpecificModule);
  }

export declare class IGESGeom_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_HArray1OfCurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_HArray1OfCurveOnSurface): void;
  get(): IGESGeom_HArray1OfCurveOnSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_HArray1OfCurveOnSurface_1 extends Handle_IGESGeom_HArray1OfCurveOnSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_HArray1OfCurveOnSurface_2 extends Handle_IGESGeom_HArray1OfCurveOnSurface {
    constructor(thePtr: IGESGeom_HArray1OfCurveOnSurface);
  }

  export declare class Handle_IGESGeom_HArray1OfCurveOnSurface_3 extends Handle_IGESGeom_HArray1OfCurveOnSurface {
    constructor(theHandle: Handle_IGESGeom_HArray1OfCurveOnSurface);
  }

  export declare class Handle_IGESGeom_HArray1OfCurveOnSurface_4 extends Handle_IGESGeom_HArray1OfCurveOnSurface {
    constructor(theHandle: Handle_IGESGeom_HArray1OfCurveOnSurface);
  }

export declare class IGESGeom_ToolPoint {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_Point, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_Point, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_Point, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_Point): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_Point, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_Point, entto: Handle_IGESGeom_Point, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_Point, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_Plane extends IGESData_IGESEntity {
  constructor()
  Init(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, aCurve: Handle_IGESData_IGESEntity, attach: gp_XYZ, aSize: Quantity_AbsorbedDose): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  Equation(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  TransformedEquation(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  HasBoundingCurve(): Standard_Boolean;
  HasBoundingCurveHole(): Standard_Boolean;
  BoundingCurve(): Handle_IGESData_IGESEntity;
  HasSymbolAttach(): Standard_Boolean;
  SymbolAttach(): gp_Pnt;
  TransformedSymbolAttach(): gp_Pnt;
  SymbolSize(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_Plane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Plane): void;
  get(): IGESGeom_Plane;
  delete(): void;
}

  export declare class Handle_IGESGeom_Plane_1 extends Handle_IGESGeom_Plane {
    constructor();
  }

  export declare class Handle_IGESGeom_Plane_2 extends Handle_IGESGeom_Plane {
    constructor(thePtr: IGESGeom_Plane);
  }

  export declare class Handle_IGESGeom_Plane_3 extends Handle_IGESGeom_Plane {
    constructor(theHandle: Handle_IGESGeom_Plane);
  }

  export declare class Handle_IGESGeom_Plane_4 extends Handle_IGESGeom_Plane {
    constructor(theHandle: Handle_IGESGeom_Plane);
  }

export declare class IGESGeom_TabulatedCylinder extends IGESData_IGESEntity {
  constructor()
  Init(aDirectrix: Handle_IGESData_IGESEntity, anEnd: gp_XYZ): void;
  Directrix(): Handle_IGESData_IGESEntity;
  EndPoint(): gp_Pnt;
  TransformedEndPoint(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_TabulatedCylinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_TabulatedCylinder): void;
  get(): IGESGeom_TabulatedCylinder;
  delete(): void;
}

  export declare class Handle_IGESGeom_TabulatedCylinder_1 extends Handle_IGESGeom_TabulatedCylinder {
    constructor();
  }

  export declare class Handle_IGESGeom_TabulatedCylinder_2 extends Handle_IGESGeom_TabulatedCylinder {
    constructor(thePtr: IGESGeom_TabulatedCylinder);
  }

  export declare class Handle_IGESGeom_TabulatedCylinder_3 extends Handle_IGESGeom_TabulatedCylinder {
    constructor(theHandle: Handle_IGESGeom_TabulatedCylinder);
  }

  export declare class Handle_IGESGeom_TabulatedCylinder_4 extends Handle_IGESGeom_TabulatedCylinder {
    constructor(theHandle: Handle_IGESGeom_TabulatedCylinder);
  }

export declare class Handle_IGESGeom_CopiousData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_CopiousData): void;
  get(): IGESGeom_CopiousData;
  delete(): void;
}

  export declare class Handle_IGESGeom_CopiousData_1 extends Handle_IGESGeom_CopiousData {
    constructor();
  }

  export declare class Handle_IGESGeom_CopiousData_2 extends Handle_IGESGeom_CopiousData {
    constructor(thePtr: IGESGeom_CopiousData);
  }

  export declare class Handle_IGESGeom_CopiousData_3 extends Handle_IGESGeom_CopiousData {
    constructor(theHandle: Handle_IGESGeom_CopiousData);
  }

  export declare class Handle_IGESGeom_CopiousData_4 extends Handle_IGESGeom_CopiousData {
    constructor(theHandle: Handle_IGESGeom_CopiousData);
  }

export declare class IGESGeom_CopiousData extends IGESData_IGESEntity {
  constructor()
  Init(aDataType: Graphic3d_ZLayerId, aZPlane: Quantity_AbsorbedDose, allData: Handle_TColStd_HArray1OfReal): void;
  SetPolyline(mode: Standard_Boolean): void;
  SetClosedPath2D(): void;
  IsPointSet(): Standard_Boolean;
  IsPolyline(): Standard_Boolean;
  IsClosedPath2D(): Standard_Boolean;
  DataType(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  Data(NumPoint: Graphic3d_ZLayerId, NumData: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ZPlane(): Quantity_AbsorbedDose;
  Point(anIndex: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPoint(anIndex: Graphic3d_ZLayerId): gp_Pnt;
  Vector(anIndex: Graphic3d_ZLayerId): gp_Vec;
  TransformedVector(anIndex: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_SplineSurface extends IGESData_IGESEntity {
  constructor()
  Init(aBoundaryType: Graphic3d_ZLayerId, aPatchType: Graphic3d_ZLayerId, allUBreakpoints: Handle_TColStd_HArray1OfReal, allVBreakpoints: Handle_TColStd_HArray1OfReal, allXCoeffs: Handle_IGESBasic_HArray2OfHArray1OfReal, allYCoeffs: Handle_IGESBasic_HArray2OfHArray1OfReal, allZCoeffs: Handle_IGESBasic_HArray2OfHArray1OfReal): void;
  NbUSegments(): Graphic3d_ZLayerId;
  NbVSegments(): Graphic3d_ZLayerId;
  BoundaryType(): Graphic3d_ZLayerId;
  PatchType(): Graphic3d_ZLayerId;
  UBreakPoint(anIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  VBreakPoint(anIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  XPolynomial(anIndex1: Graphic3d_ZLayerId, anIndex2: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  YPolynomial(anIndex1: Graphic3d_ZLayerId, anIndex2: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  ZPolynomial(anIndex1: Graphic3d_ZLayerId, anIndex2: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  Polynomials(XCoef: Handle_IGESBasic_HArray2OfHArray1OfReal, YCoef: Handle_IGESBasic_HArray2OfHArray1OfReal, ZCoef: Handle_IGESBasic_HArray2OfHArray1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_SplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_SplineSurface): void;
  get(): IGESGeom_SplineSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_SplineSurface_1 extends Handle_IGESGeom_SplineSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_SplineSurface_2 extends Handle_IGESGeom_SplineSurface {
    constructor(thePtr: IGESGeom_SplineSurface);
  }

  export declare class Handle_IGESGeom_SplineSurface_3 extends Handle_IGESGeom_SplineSurface {
    constructor(theHandle: Handle_IGESGeom_SplineSurface);
  }

  export declare class Handle_IGESGeom_SplineSurface_4 extends Handle_IGESGeom_SplineSurface {
    constructor(theHandle: Handle_IGESGeom_SplineSurface);
  }

export declare class IGESGeom_ToolPlane {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_Plane, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_Plane, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_Plane, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_Plane): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_Plane, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_Plane, entto: Handle_IGESGeom_Plane, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_Plane, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_SplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_SplineCurve): void;
  get(): IGESGeom_SplineCurve;
  delete(): void;
}

  export declare class Handle_IGESGeom_SplineCurve_1 extends Handle_IGESGeom_SplineCurve {
    constructor();
  }

  export declare class Handle_IGESGeom_SplineCurve_2 extends Handle_IGESGeom_SplineCurve {
    constructor(thePtr: IGESGeom_SplineCurve);
  }

  export declare class Handle_IGESGeom_SplineCurve_3 extends Handle_IGESGeom_SplineCurve {
    constructor(theHandle: Handle_IGESGeom_SplineCurve);
  }

  export declare class Handle_IGESGeom_SplineCurve_4 extends Handle_IGESGeom_SplineCurve {
    constructor(theHandle: Handle_IGESGeom_SplineCurve);
  }

export declare class IGESGeom_SplineCurve extends IGESData_IGESEntity {
  constructor()
  Init(aType: Graphic3d_ZLayerId, aDegree: Graphic3d_ZLayerId, nbDimensions: Graphic3d_ZLayerId, allBreakPoints: Handle_TColStd_HArray1OfReal, allXPolynomials: Handle_TColStd_HArray2OfReal, allYPolynomials: Handle_TColStd_HArray2OfReal, allZPolynomials: Handle_TColStd_HArray2OfReal, allXvalues: Handle_TColStd_HArray1OfReal, allYvalues: Handle_TColStd_HArray1OfReal, allZvalues: Handle_TColStd_HArray1OfReal): void;
  SplineType(): Graphic3d_ZLayerId;
  Degree(): Graphic3d_ZLayerId;
  NbDimensions(): Graphic3d_ZLayerId;
  NbSegments(): Graphic3d_ZLayerId;
  BreakPoint(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  XCoordPolynomial(Index: Graphic3d_ZLayerId, AX: Quantity_AbsorbedDose, BX: Quantity_AbsorbedDose, CX: Quantity_AbsorbedDose, DX: Quantity_AbsorbedDose): void;
  YCoordPolynomial(Index: Graphic3d_ZLayerId, AY: Quantity_AbsorbedDose, BY: Quantity_AbsorbedDose, CY: Quantity_AbsorbedDose, DY: Quantity_AbsorbedDose): void;
  ZCoordPolynomial(Index: Graphic3d_ZLayerId, AZ: Quantity_AbsorbedDose, BZ: Quantity_AbsorbedDose, CZ: Quantity_AbsorbedDose, DZ: Quantity_AbsorbedDose): void;
  XValues(TPX0: Quantity_AbsorbedDose, TPX1: Quantity_AbsorbedDose, TPX2: Quantity_AbsorbedDose, TPX3: Quantity_AbsorbedDose): void;
  YValues(TPY0: Quantity_AbsorbedDose, TPY1: Quantity_AbsorbedDose, TPY2: Quantity_AbsorbedDose, TPY3: Quantity_AbsorbedDose): void;
  ZValues(TPZ0: Quantity_AbsorbedDose, TPZ1: Quantity_AbsorbedDose, TPZ2: Quantity_AbsorbedDose, TPZ3: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESGeom_Protocol;
  delete(): void;
}

export declare class Handle_IGESGeom_OffsetCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_OffsetCurve): void;
  get(): IGESGeom_OffsetCurve;
  delete(): void;
}

  export declare class Handle_IGESGeom_OffsetCurve_1 extends Handle_IGESGeom_OffsetCurve {
    constructor();
  }

  export declare class Handle_IGESGeom_OffsetCurve_2 extends Handle_IGESGeom_OffsetCurve {
    constructor(thePtr: IGESGeom_OffsetCurve);
  }

  export declare class Handle_IGESGeom_OffsetCurve_3 extends Handle_IGESGeom_OffsetCurve {
    constructor(theHandle: Handle_IGESGeom_OffsetCurve);
  }

  export declare class Handle_IGESGeom_OffsetCurve_4 extends Handle_IGESGeom_OffsetCurve {
    constructor(theHandle: Handle_IGESGeom_OffsetCurve);
  }

export declare class IGESGeom_OffsetCurve extends IGESData_IGESEntity {
  constructor()
  Init(aBaseCurve: Handle_IGESData_IGESEntity, anOffsetType: Graphic3d_ZLayerId, aFunction: Handle_IGESData_IGESEntity, aFunctionCoord: Graphic3d_ZLayerId, aTaperedOffsetType: Graphic3d_ZLayerId, offDistance1: Quantity_AbsorbedDose, arcLength1: Quantity_AbsorbedDose, offDistance2: Quantity_AbsorbedDose, arcLength2: Quantity_AbsorbedDose, aNormalVec: gp_XYZ, anOffsetParam: Quantity_AbsorbedDose, anotherOffsetParam: Quantity_AbsorbedDose): void;
  BaseCurve(): Handle_IGESData_IGESEntity;
  OffsetType(): Graphic3d_ZLayerId;
  Function(): Handle_IGESData_IGESEntity;
  HasFunction(): Standard_Boolean;
  FunctionParameter(): Graphic3d_ZLayerId;
  TaperedOffsetType(): Graphic3d_ZLayerId;
  FirstOffsetDistance(): Quantity_AbsorbedDose;
  ArcLength1(): Quantity_AbsorbedDose;
  SecondOffsetDistance(): Quantity_AbsorbedDose;
  ArcLength2(): Quantity_AbsorbedDose;
  NormalVector(): gp_Vec;
  TransformedNormalVector(): gp_Vec;
  Parameters(StartParam: Quantity_AbsorbedDose, EndParam: Quantity_AbsorbedDose): void;
  StartParameter(): Quantity_AbsorbedDose;
  EndParameter(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_ToolTrimmedSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_TrimmedSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_TrimmedSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_TrimmedSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_TrimmedSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_TrimmedSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_TrimmedSurface, entto: Handle_IGESGeom_TrimmedSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_TrimmedSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolTabulatedCylinder {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_TabulatedCylinder, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_TabulatedCylinder, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_TabulatedCylinder, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_TabulatedCylinder): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_TabulatedCylinder, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_TabulatedCylinder, entto: Handle_IGESGeom_TabulatedCylinder, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_TabulatedCylinder, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolSplineSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_SplineSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_SplineSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_SplineSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_SplineSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_SplineSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_SplineSurface, entto: Handle_IGESGeom_SplineSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_SplineSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_BSplineSurface extends IGESData_IGESEntity {
  constructor()
  Init(anIndexU: Graphic3d_ZLayerId, anIndexV: Graphic3d_ZLayerId, aDegU: Graphic3d_ZLayerId, aDegV: Graphic3d_ZLayerId, aCloseU: Standard_Boolean, aCloseV: Standard_Boolean, aPolynom: Standard_Boolean, aPeriodU: Standard_Boolean, aPeriodV: Standard_Boolean, allKnotsU: Handle_TColStd_HArray1OfReal, allKnotsV: Handle_TColStd_HArray1OfReal, allWeights: Handle_TColStd_HArray2OfReal, allPoles: Handle_TColgp_HArray2OfXYZ, aUmin: Quantity_AbsorbedDose, aUmax: Quantity_AbsorbedDose, aVmin: Quantity_AbsorbedDose, aVmax: Quantity_AbsorbedDose): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  UpperIndexU(): Graphic3d_ZLayerId;
  UpperIndexV(): Graphic3d_ZLayerId;
  DegreeU(): Graphic3d_ZLayerId;
  DegreeV(): Graphic3d_ZLayerId;
  IsClosedU(): Standard_Boolean;
  IsClosedV(): Standard_Boolean;
  IsPolynomial(flag: Standard_Boolean): Standard_Boolean;
  IsPeriodicU(): Standard_Boolean;
  IsPeriodicV(): Standard_Boolean;
  NbKnotsU(): Graphic3d_ZLayerId;
  NbKnotsV(): Graphic3d_ZLayerId;
  KnotU(anIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  KnotV(anIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbPolesU(): Graphic3d_ZLayerId;
  NbPolesV(): Graphic3d_ZLayerId;
  Weight(anIndex1: Graphic3d_ZLayerId, anIndex2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Pole(anIndex1: Graphic3d_ZLayerId, anIndex2: Graphic3d_ZLayerId): gp_Pnt;
  TransformedPole(anIndex1: Graphic3d_ZLayerId, anIndex2: Graphic3d_ZLayerId): gp_Pnt;
  UMin(): Quantity_AbsorbedDose;
  UMax(): Quantity_AbsorbedDose;
  VMin(): Quantity_AbsorbedDose;
  VMax(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_BSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_BSplineSurface): void;
  get(): IGESGeom_BSplineSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_BSplineSurface_1 extends Handle_IGESGeom_BSplineSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_BSplineSurface_2 extends Handle_IGESGeom_BSplineSurface {
    constructor(thePtr: IGESGeom_BSplineSurface);
  }

  export declare class Handle_IGESGeom_BSplineSurface_3 extends Handle_IGESGeom_BSplineSurface {
    constructor(theHandle: Handle_IGESGeom_BSplineSurface);
  }

  export declare class Handle_IGESGeom_BSplineSurface_4 extends Handle_IGESGeom_BSplineSurface {
    constructor(theHandle: Handle_IGESGeom_BSplineSurface);
  }

export declare class IGESGeom_SurfaceOfRevolution extends IGESData_IGESEntity {
  constructor()
  Init(anAxis: Handle_IGESGeom_Line, aGeneratrix: Handle_IGESData_IGESEntity, aStartAngle: Quantity_AbsorbedDose, anEndAngle: Quantity_AbsorbedDose): void;
  AxisOfRevolution(): Handle_IGESGeom_Line;
  Generatrix(): Handle_IGESData_IGESEntity;
  StartAngle(): Quantity_AbsorbedDose;
  EndAngle(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_SurfaceOfRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_SurfaceOfRevolution): void;
  get(): IGESGeom_SurfaceOfRevolution;
  delete(): void;
}

  export declare class Handle_IGESGeom_SurfaceOfRevolution_1 extends Handle_IGESGeom_SurfaceOfRevolution {
    constructor();
  }

  export declare class Handle_IGESGeom_SurfaceOfRevolution_2 extends Handle_IGESGeom_SurfaceOfRevolution {
    constructor(thePtr: IGESGeom_SurfaceOfRevolution);
  }

  export declare class Handle_IGESGeom_SurfaceOfRevolution_3 extends Handle_IGESGeom_SurfaceOfRevolution {
    constructor(theHandle: Handle_IGESGeom_SurfaceOfRevolution);
  }

  export declare class Handle_IGESGeom_SurfaceOfRevolution_4 extends Handle_IGESGeom_SurfaceOfRevolution {
    constructor(theHandle: Handle_IGESGeom_SurfaceOfRevolution);
  }

export declare class Handle_IGESGeom_Direction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Direction): void;
  get(): IGESGeom_Direction;
  delete(): void;
}

  export declare class Handle_IGESGeom_Direction_1 extends Handle_IGESGeom_Direction {
    constructor();
  }

  export declare class Handle_IGESGeom_Direction_2 extends Handle_IGESGeom_Direction {
    constructor(thePtr: IGESGeom_Direction);
  }

  export declare class Handle_IGESGeom_Direction_3 extends Handle_IGESGeom_Direction {
    constructor(theHandle: Handle_IGESGeom_Direction);
  }

  export declare class Handle_IGESGeom_Direction_4 extends Handle_IGESGeom_Direction {
    constructor(theHandle: Handle_IGESGeom_Direction);
  }

export declare class IGESGeom_Direction extends IGESData_IGESEntity {
  constructor()
  Init(aDirection: gp_XYZ): void;
  Value(): gp_Vec;
  TransformedValue(): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_ToolCircularArc {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_CircularArc, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_CircularArc, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_CircularArc, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_CircularArc): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_CircularArc, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_CircularArc, entto: Handle_IGESGeom_CircularArc, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_CircularArc, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Protocol): void;
  get(): IGESGeom_Protocol;
  delete(): void;
}

  export declare class Handle_IGESGeom_Protocol_1 extends Handle_IGESGeom_Protocol {
    constructor();
  }

  export declare class Handle_IGESGeom_Protocol_2 extends Handle_IGESGeom_Protocol {
    constructor(thePtr: IGESGeom_Protocol);
  }

  export declare class Handle_IGESGeom_Protocol_3 extends Handle_IGESGeom_Protocol {
    constructor(theHandle: Handle_IGESGeom_Protocol);
  }

  export declare class Handle_IGESGeom_Protocol_4 extends Handle_IGESGeom_Protocol {
    constructor(theHandle: Handle_IGESGeom_Protocol);
  }

export declare class IGESGeom_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_Boundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Boundary): void;
  get(): IGESGeom_Boundary;
  delete(): void;
}

  export declare class Handle_IGESGeom_Boundary_1 extends Handle_IGESGeom_Boundary {
    constructor();
  }

  export declare class Handle_IGESGeom_Boundary_2 extends Handle_IGESGeom_Boundary {
    constructor(thePtr: IGESGeom_Boundary);
  }

  export declare class Handle_IGESGeom_Boundary_3 extends Handle_IGESGeom_Boundary {
    constructor(theHandle: Handle_IGESGeom_Boundary);
  }

  export declare class Handle_IGESGeom_Boundary_4 extends Handle_IGESGeom_Boundary {
    constructor(theHandle: Handle_IGESGeom_Boundary);
  }

export declare class IGESGeom_Boundary extends IGESData_IGESEntity {
  constructor()
  Init(aType: Graphic3d_ZLayerId, aPreference: Graphic3d_ZLayerId, aSurface: Handle_IGESData_IGESEntity, allModelCurves: Handle_IGESData_HArray1OfIGESEntity, allSenses: Handle_TColStd_HArray1OfInteger, allParameterCurves: Handle_IGESBasic_HArray1OfHArray1OfIGESEntity): void;
  BoundaryType(): Graphic3d_ZLayerId;
  PreferenceType(): Graphic3d_ZLayerId;
  Surface(): Handle_IGESData_IGESEntity;
  NbModelSpaceCurves(): Graphic3d_ZLayerId;
  ModelSpaceCurve(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  Sense(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbParameterCurves(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ParameterCurves(Index: Graphic3d_ZLayerId): Handle_IGESData_HArray1OfIGESEntity;
  ParameterCurve(Index: Graphic3d_ZLayerId, Num: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGeom_ToolSplineCurve {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_SplineCurve, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_SplineCurve, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_SplineCurve, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_SplineCurve): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_SplineCurve, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_SplineCurve, entto: Handle_IGESGeom_SplineCurve, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_SplineCurve, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_ToolLine {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_Line, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_Line, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_Line, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_Line): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_Line, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_Line, entto: Handle_IGESGeom_Line, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_Line, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGeom_BoundedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_BoundedSurface): void;
  get(): IGESGeom_BoundedSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_BoundedSurface_1 extends Handle_IGESGeom_BoundedSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_BoundedSurface_2 extends Handle_IGESGeom_BoundedSurface {
    constructor(thePtr: IGESGeom_BoundedSurface);
  }

  export declare class Handle_IGESGeom_BoundedSurface_3 extends Handle_IGESGeom_BoundedSurface {
    constructor(theHandle: Handle_IGESGeom_BoundedSurface);
  }

  export declare class Handle_IGESGeom_BoundedSurface_4 extends Handle_IGESGeom_BoundedSurface {
    constructor(theHandle: Handle_IGESGeom_BoundedSurface);
  }

export declare class IGESGeom_BoundedSurface extends IGESData_IGESEntity {
  constructor()
  Init(aType: Graphic3d_ZLayerId, aSurface: Handle_IGESData_IGESEntity, allBounds: Handle_IGESGeom_HArray1OfBoundary): void;
  RepresentationType(): Graphic3d_ZLayerId;
  Surface(): Handle_IGESData_IGESEntity;
  NbBoundaries(): Graphic3d_ZLayerId;
  Boundary(Index: Graphic3d_ZLayerId): Handle_IGESGeom_Boundary;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_HArray1OfBoundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_HArray1OfBoundary): void;
  get(): IGESGeom_HArray1OfBoundary;
  delete(): void;
}

  export declare class Handle_IGESGeom_HArray1OfBoundary_1 extends Handle_IGESGeom_HArray1OfBoundary {
    constructor();
  }

  export declare class Handle_IGESGeom_HArray1OfBoundary_2 extends Handle_IGESGeom_HArray1OfBoundary {
    constructor(thePtr: IGESGeom_HArray1OfBoundary);
  }

  export declare class Handle_IGESGeom_HArray1OfBoundary_3 extends Handle_IGESGeom_HArray1OfBoundary {
    constructor(theHandle: Handle_IGESGeom_HArray1OfBoundary);
  }

  export declare class Handle_IGESGeom_HArray1OfBoundary_4 extends Handle_IGESGeom_HArray1OfBoundary {
    constructor(theHandle: Handle_IGESGeom_HArray1OfBoundary);
  }

export declare class IGESGeom_Flash extends IGESData_IGESEntity {
  constructor()
  Init(aPoint: gp_XY, aDim: Quantity_AbsorbedDose, anotherDim: Quantity_AbsorbedDose, aRotation: Quantity_AbsorbedDose, aReference: Handle_IGESData_IGESEntity): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  ReferencePoint(): gp_Pnt2d;
  TransformedReferencePoint(): gp_Pnt;
  Dimension1(): Quantity_AbsorbedDose;
  Dimension2(): Quantity_AbsorbedDose;
  Rotation(): Quantity_AbsorbedDose;
  ReferenceEntity(): Handle_IGESData_IGESEntity;
  HasReferenceEntity(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_Flash {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_Flash): void;
  get(): IGESGeom_Flash;
  delete(): void;
}

  export declare class Handle_IGESGeom_Flash_1 extends Handle_IGESGeom_Flash {
    constructor();
  }

  export declare class Handle_IGESGeom_Flash_2 extends Handle_IGESGeom_Flash {
    constructor(thePtr: IGESGeom_Flash);
  }

  export declare class Handle_IGESGeom_Flash_3 extends Handle_IGESGeom_Flash {
    constructor(theHandle: Handle_IGESGeom_Flash);
  }

  export declare class Handle_IGESGeom_Flash_4 extends Handle_IGESGeom_Flash {
    constructor(theHandle: Handle_IGESGeom_Flash);
  }

export declare class IGESGeom_ToolBSplineCurve {
  constructor()
  ReadOwnParams(ent: Handle_IGESGeom_BSplineCurve, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGeom_BSplineCurve, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGeom_BSplineCurve, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGeom_BSplineCurve): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGeom_BSplineCurve, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGeom_BSplineCurve, entto: Handle_IGESGeom_BSplineCurve, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGeom_BSplineCurve, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGeom_OffsetSurface extends IGESData_IGESEntity {
  constructor()
  Init(anIndicatoR: gp_XYZ, aDistance: Quantity_AbsorbedDose, aSurface: Handle_IGESData_IGESEntity): void;
  OffsetIndicator(): gp_Vec;
  TransformedOffsetIndicator(): gp_Vec;
  Distance(): Quantity_AbsorbedDose;
  Surface(): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGeom_OffsetSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_OffsetSurface): void;
  get(): IGESGeom_OffsetSurface;
  delete(): void;
}

  export declare class Handle_IGESGeom_OffsetSurface_1 extends Handle_IGESGeom_OffsetSurface {
    constructor();
  }

  export declare class Handle_IGESGeom_OffsetSurface_2 extends Handle_IGESGeom_OffsetSurface {
    constructor(thePtr: IGESGeom_OffsetSurface);
  }

  export declare class Handle_IGESGeom_OffsetSurface_3 extends Handle_IGESGeom_OffsetSurface {
    constructor(theHandle: Handle_IGESGeom_OffsetSurface);
  }

  export declare class Handle_IGESGeom_OffsetSurface_4 extends Handle_IGESGeom_OffsetSurface {
    constructor(theHandle: Handle_IGESGeom_OffsetSurface);
  }

export declare class Handle_IGESGeom_ConicArc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGeom_ConicArc): void;
  get(): IGESGeom_ConicArc;
  delete(): void;
}

  export declare class Handle_IGESGeom_ConicArc_1 extends Handle_IGESGeom_ConicArc {
    constructor();
  }

  export declare class Handle_IGESGeom_ConicArc_2 extends Handle_IGESGeom_ConicArc {
    constructor(thePtr: IGESGeom_ConicArc);
  }

  export declare class Handle_IGESGeom_ConicArc_3 extends Handle_IGESGeom_ConicArc {
    constructor(theHandle: Handle_IGESGeom_ConicArc);
  }

  export declare class Handle_IGESGeom_ConicArc_4 extends Handle_IGESGeom_ConicArc {
    constructor(theHandle: Handle_IGESGeom_ConicArc);
  }

export declare class IGESGeom_ConicArc extends IGESData_IGESEntity {
  constructor()
  Init(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, ZT: Quantity_AbsorbedDose, aStart: gp_XY, anEnd: gp_XY): void;
  OwnCorrect(): Standard_Boolean;
  ComputedFormNumber(): Graphic3d_ZLayerId;
  Equation(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): void;
  ZPlane(): Quantity_AbsorbedDose;
  StartPoint(): gp_Pnt2d;
  TransformedStartPoint(): gp_Pnt;
  EndPoint(): gp_Pnt2d;
  TransformedEndPoint(): gp_Pnt;
  IsFromEllipse(): Standard_Boolean;
  IsFromParabola(): Standard_Boolean;
  IsFromHyperbola(): Standard_Boolean;
  IsClosed(): Standard_Boolean;
  Axis(): gp_Dir;
  TransformedAxis(): gp_Dir;
  Definition(Center: gp_Pnt, MainAxis: gp_Dir, rmin: Quantity_AbsorbedDose, rmax: Quantity_AbsorbedDose): void;
  TransformedDefinition(Center: gp_Pnt, MainAxis: gp_Dir, rmin: Quantity_AbsorbedDose, rmax: Quantity_AbsorbedDose): void;
  ComputedDefinition(Xcen: Quantity_AbsorbedDose, Ycen: Quantity_AbsorbedDose, Xax: Quantity_AbsorbedDose, Yax: Quantity_AbsorbedDose, Rmin: Quantity_AbsorbedDose, Rmax: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TFunction_Iterator {
  Init(Access: TDF_Label): void;
  SetUsageOfExecutionStatus(usage: Standard_Boolean): void;
  GetUsageOfExecutionStatus(): Standard_Boolean;
  GetMaxNbThreads(): Graphic3d_ZLayerId;
  Current(): TDF_LabelList;
  More(): Standard_Boolean;
  Next(): void;
  GetStatus(func: TDF_Label): TFunction_ExecutionStatus;
  SetStatus(func: TDF_Label, status: TFunction_ExecutionStatus): void;
  delete(): void;
}

  export declare class TFunction_Iterator_1 extends TFunction_Iterator {
    constructor();
  }

  export declare class TFunction_Iterator_2 extends TFunction_Iterator {
    constructor(Access: TDF_Label);
  }

export declare class TFunction_Driver extends Standard_Transient {
  Init(L: TDF_Label): void;
  Label(): TDF_Label;
  Validate(log: Handle_TFunction_Logbook): void;
  MustExecute(log: Handle_TFunction_Logbook): Standard_Boolean;
  Execute(log: Handle_TFunction_Logbook): Graphic3d_ZLayerId;
  Arguments(args: TDF_LabelList): void;
  Results(res: TDF_LabelList): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TFunction_Driver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_Driver): void;
  get(): TFunction_Driver;
  delete(): void;
}

  export declare class Handle_TFunction_Driver_1 extends Handle_TFunction_Driver {
    constructor();
  }

  export declare class Handle_TFunction_Driver_2 extends Handle_TFunction_Driver {
    constructor(thePtr: TFunction_Driver);
  }

  export declare class Handle_TFunction_Driver_3 extends Handle_TFunction_Driver {
    constructor(theHandle: Handle_TFunction_Driver);
  }

  export declare class Handle_TFunction_Driver_4 extends Handle_TFunction_Driver {
    constructor(theHandle: Handle_TFunction_Driver);
  }

export declare class TFunction_DataMapOfLabelListOfLabel extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TFunction_DataMapOfLabelListOfLabel): void;
  Assign(theOther: TFunction_DataMapOfLabelListOfLabel): TFunction_DataMapOfLabelListOfLabel;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TDF_Label, theItem: TDF_LabelList): Standard_Boolean;
  Bound(theKey: TDF_Label, theItem: TDF_LabelList): TDF_LabelList;
  IsBound(theKey: TDF_Label): Standard_Boolean;
  UnBind(theKey: TDF_Label): Standard_Boolean;
  Seek(theKey: TDF_Label): TDF_LabelList;
  ChangeSeek(theKey: TDF_Label): TDF_LabelList;
  ChangeFind(theKey: TDF_Label): TDF_LabelList;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TFunction_DataMapOfLabelListOfLabel_1 extends TFunction_DataMapOfLabelListOfLabel {
    constructor();
  }

  export declare class TFunction_DataMapOfLabelListOfLabel_2 extends TFunction_DataMapOfLabelListOfLabel {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TFunction_DataMapOfLabelListOfLabel_3 extends TFunction_DataMapOfLabelListOfLabel {
    constructor(theOther: TFunction_DataMapOfLabelListOfLabel);
  }

export declare class Handle_TFunction_DriverTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_DriverTable): void;
  get(): TFunction_DriverTable;
  delete(): void;
}

  export declare class Handle_TFunction_DriverTable_1 extends Handle_TFunction_DriverTable {
    constructor();
  }

  export declare class Handle_TFunction_DriverTable_2 extends Handle_TFunction_DriverTable {
    constructor(thePtr: TFunction_DriverTable);
  }

  export declare class Handle_TFunction_DriverTable_3 extends Handle_TFunction_DriverTable {
    constructor(theHandle: Handle_TFunction_DriverTable);
  }

  export declare class Handle_TFunction_DriverTable_4 extends Handle_TFunction_DriverTable {
    constructor(theHandle: Handle_TFunction_DriverTable);
  }

export declare class TFunction_DriverTable extends Standard_Transient {
  constructor()
  static Get(): Handle_TFunction_DriverTable;
  AddDriver(guid: Standard_GUID, driver: Handle_TFunction_Driver, thread: Graphic3d_ZLayerId): Standard_Boolean;
  HasDriver(guid: Standard_GUID, thread: Graphic3d_ZLayerId): Standard_Boolean;
  FindDriver(guid: Standard_GUID, driver: Handle_TFunction_Driver, thread: Graphic3d_ZLayerId): Standard_Boolean;
  RemoveDriver(guid: Standard_GUID, thread: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TFunction_DoubleMapOfIntegerLabel extends NCollection_BaseMap {
  Exchange(theOther: TFunction_DoubleMapOfIntegerLabel): void;
  Assign(theOther: TFunction_DoubleMapOfIntegerLabel): TFunction_DoubleMapOfIntegerLabel;
  ReSize(N: Standard_Integer): void;
  Bind(theKey1: Standard_Integer, theKey2: TDF_Label): void;
  AreBound(theKey1: Standard_Integer, theKey2: TDF_Label): Standard_Boolean;
  IsBound1(theKey1: Standard_Integer): Standard_Boolean;
  IsBound2(theKey2: TDF_Label): Standard_Boolean;
  UnBind1(theKey1: Standard_Integer): Standard_Boolean;
  UnBind2(theKey2: TDF_Label): Standard_Boolean;
  Find1_1(theKey1: Standard_Integer): TDF_Label;
  Find1_2(theKey1: Standard_Integer, theKey2: TDF_Label): Standard_Boolean;
  Seek1(theKey1: Standard_Integer): TDF_Label;
  Find2_1(theKey2: TDF_Label): Standard_Integer;
  Find2_2(theKey2: TDF_Label, theKey1: Standard_Integer): Standard_Boolean;
  Seek2(theKey2: TDF_Label): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TFunction_DoubleMapOfIntegerLabel_1 extends TFunction_DoubleMapOfIntegerLabel {
    constructor();
  }

  export declare class TFunction_DoubleMapOfIntegerLabel_2 extends TFunction_DoubleMapOfIntegerLabel {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TFunction_DoubleMapOfIntegerLabel_3 extends TFunction_DoubleMapOfIntegerLabel {
    constructor(theOther: TFunction_DoubleMapOfIntegerLabel);
  }

export declare class Handle_TFunction_HArray1OfDataMapOfGUIDDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_HArray1OfDataMapOfGUIDDriver): void;
  get(): TFunction_HArray1OfDataMapOfGUIDDriver;
  delete(): void;
}

  export declare class Handle_TFunction_HArray1OfDataMapOfGUIDDriver_1 extends Handle_TFunction_HArray1OfDataMapOfGUIDDriver {
    constructor();
  }

  export declare class Handle_TFunction_HArray1OfDataMapOfGUIDDriver_2 extends Handle_TFunction_HArray1OfDataMapOfGUIDDriver {
    constructor(thePtr: TFunction_HArray1OfDataMapOfGUIDDriver);
  }

  export declare class Handle_TFunction_HArray1OfDataMapOfGUIDDriver_3 extends Handle_TFunction_HArray1OfDataMapOfGUIDDriver {
    constructor(theHandle: Handle_TFunction_HArray1OfDataMapOfGUIDDriver);
  }

  export declare class Handle_TFunction_HArray1OfDataMapOfGUIDDriver_4 extends Handle_TFunction_HArray1OfDataMapOfGUIDDriver {
    constructor(theHandle: Handle_TFunction_HArray1OfDataMapOfGUIDDriver);
  }

export declare class TFunction_IFunction {
  static NewFunction(L: TDF_Label, ID: Standard_GUID): Standard_Boolean;
  static DeleteFunction(L: TDF_Label): Standard_Boolean;
  static UpdateDependencies_1(Access: TDF_Label): Standard_Boolean;
  Init(L: TDF_Label): void;
  Label(): TDF_Label;
  UpdateDependencies_2(): Standard_Boolean;
  Arguments(args: TDF_LabelList): void;
  Results(res: TDF_LabelList): void;
  GetPrevious(prev: TDF_LabelList): void;
  GetNext(prev: TDF_LabelList): void;
  GetStatus(): TFunction_ExecutionStatus;
  SetStatus(status: TFunction_ExecutionStatus): void;
  GetAllFunctions(): TFunction_DoubleMapOfIntegerLabel;
  GetLogbook(): Handle_TFunction_Logbook;
  GetDriver(thread: Graphic3d_ZLayerId): Handle_TFunction_Driver;
  GetGraphNode(): Handle_TFunction_GraphNode;
  delete(): void;
}

  export declare class TFunction_IFunction_1 extends TFunction_IFunction {
    constructor();
  }

  export declare class TFunction_IFunction_2 extends TFunction_IFunction {
    constructor(L: TDF_Label);
  }

export declare class TFunction_GraphNode extends TDF_Attribute {
  constructor()
  static Set(L: TDF_Label): Handle_TFunction_GraphNode;
  static GetID(): Standard_GUID;
  AddPrevious_1(funcID: Graphic3d_ZLayerId): Standard_Boolean;
  AddPrevious_2(func: TDF_Label): Standard_Boolean;
  RemovePrevious_1(funcID: Graphic3d_ZLayerId): Standard_Boolean;
  RemovePrevious_2(func: TDF_Label): Standard_Boolean;
  GetPrevious(): TColStd_MapOfInteger;
  RemoveAllPrevious(): void;
  AddNext_1(funcID: Graphic3d_ZLayerId): Standard_Boolean;
  AddNext_2(func: TDF_Label): Standard_Boolean;
  RemoveNext_1(funcID: Graphic3d_ZLayerId): Standard_Boolean;
  RemoveNext_2(func: TDF_Label): Standard_Boolean;
  GetNext(): TColStd_MapOfInteger;
  RemoveAllNext(): void;
  GetStatus(): TFunction_ExecutionStatus;
  SetStatus(status: TFunction_ExecutionStatus): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  NewEmpty(): Handle_TDF_Attribute;
  References(aDataSet: Handle_TDF_DataSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TFunction_GraphNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_GraphNode): void;
  get(): TFunction_GraphNode;
  delete(): void;
}

  export declare class Handle_TFunction_GraphNode_1 extends Handle_TFunction_GraphNode {
    constructor();
  }

  export declare class Handle_TFunction_GraphNode_2 extends Handle_TFunction_GraphNode {
    constructor(thePtr: TFunction_GraphNode);
  }

  export declare class Handle_TFunction_GraphNode_3 extends Handle_TFunction_GraphNode {
    constructor(theHandle: Handle_TFunction_GraphNode);
  }

  export declare class Handle_TFunction_GraphNode_4 extends Handle_TFunction_GraphNode {
    constructor(theHandle: Handle_TFunction_GraphNode);
  }

export declare class TFunction_Array1OfDataMapOfGUIDDriver {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TFunction_DataMapOfGUIDDriver): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TFunction_Array1OfDataMapOfGUIDDriver): TFunction_Array1OfDataMapOfGUIDDriver;
  Move(theOther: TFunction_Array1OfDataMapOfGUIDDriver): TFunction_Array1OfDataMapOfGUIDDriver;
  First(): TFunction_DataMapOfGUIDDriver;
  ChangeFirst(): TFunction_DataMapOfGUIDDriver;
  Last(): TFunction_DataMapOfGUIDDriver;
  ChangeLast(): TFunction_DataMapOfGUIDDriver;
  Value(theIndex: Standard_Integer): TFunction_DataMapOfGUIDDriver;
  ChangeValue(theIndex: Standard_Integer): TFunction_DataMapOfGUIDDriver;
  SetValue(theIndex: Standard_Integer, theItem: TFunction_DataMapOfGUIDDriver): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TFunction_Array1OfDataMapOfGUIDDriver_1 extends TFunction_Array1OfDataMapOfGUIDDriver {
    constructor();
  }

  export declare class TFunction_Array1OfDataMapOfGUIDDriver_2 extends TFunction_Array1OfDataMapOfGUIDDriver {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TFunction_Array1OfDataMapOfGUIDDriver_3 extends TFunction_Array1OfDataMapOfGUIDDriver {
    constructor(theOther: TFunction_Array1OfDataMapOfGUIDDriver);
  }

  export declare class TFunction_Array1OfDataMapOfGUIDDriver_4 extends TFunction_Array1OfDataMapOfGUIDDriver {
    constructor(theOther: TFunction_Array1OfDataMapOfGUIDDriver);
  }

  export declare class TFunction_Array1OfDataMapOfGUIDDriver_5 extends TFunction_Array1OfDataMapOfGUIDDriver {
    constructor(theBegin: TFunction_DataMapOfGUIDDriver, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TFunction_Scope extends TDF_Attribute {
  constructor()
  static Set(Access: TDF_Label): Handle_TFunction_Scope;
  static GetID(): Standard_GUID;
  AddFunction(L: TDF_Label): Standard_Boolean;
  RemoveFunction_1(L: TDF_Label): Standard_Boolean;
  RemoveFunction_2(ID: Graphic3d_ZLayerId): Standard_Boolean;
  RemoveAllFunctions(): void;
  HasFunction_1(ID: Graphic3d_ZLayerId): Standard_Boolean;
  HasFunction_2(L: TDF_Label): Standard_Boolean;
  GetFunction_1(L: TDF_Label): Graphic3d_ZLayerId;
  GetFunction_2(ID: Graphic3d_ZLayerId): TDF_Label;
  GetLogbook(): Handle_TFunction_Logbook;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  NewEmpty(): Handle_TDF_Attribute;
  GetFunctions(): TFunction_DoubleMapOfIntegerLabel;
  ChangeFunctions(): TFunction_DoubleMapOfIntegerLabel;
  SetFreeID(ID: Graphic3d_ZLayerId): void;
  GetFreeID(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TFunction_Scope {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_Scope): void;
  get(): TFunction_Scope;
  delete(): void;
}

  export declare class Handle_TFunction_Scope_1 extends Handle_TFunction_Scope {
    constructor();
  }

  export declare class Handle_TFunction_Scope_2 extends Handle_TFunction_Scope {
    constructor(thePtr: TFunction_Scope);
  }

  export declare class Handle_TFunction_Scope_3 extends Handle_TFunction_Scope {
    constructor(theHandle: Handle_TFunction_Scope);
  }

  export declare class Handle_TFunction_Scope_4 extends Handle_TFunction_Scope {
    constructor(theHandle: Handle_TFunction_Scope);
  }

export declare class Handle_TFunction_Logbook {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_Logbook): void;
  get(): TFunction_Logbook;
  delete(): void;
}

  export declare class Handle_TFunction_Logbook_1 extends Handle_TFunction_Logbook {
    constructor();
  }

  export declare class Handle_TFunction_Logbook_2 extends Handle_TFunction_Logbook {
    constructor(thePtr: TFunction_Logbook);
  }

  export declare class Handle_TFunction_Logbook_3 extends Handle_TFunction_Logbook {
    constructor(theHandle: Handle_TFunction_Logbook);
  }

  export declare class Handle_TFunction_Logbook_4 extends Handle_TFunction_Logbook {
    constructor(theHandle: Handle_TFunction_Logbook);
  }

export declare class TFunction_Logbook extends TDF_Attribute {
  constructor()
  static Set(Access: TDF_Label): Handle_TFunction_Logbook;
  static GetID(): Standard_GUID;
  Clear(): void;
  IsEmpty(): Standard_Boolean;
  SetTouched(L: TDF_Label): void;
  SetImpacted(L: TDF_Label, WithChildren: Standard_Boolean): void;
  SetValid_1(L: TDF_Label, WithChildren: Standard_Boolean): void;
  SetValid_2(Ls: TDF_LabelMap): void;
  IsModified(L: TDF_Label, WithChildren: Standard_Boolean): Standard_Boolean;
  GetTouched(): TDF_LabelMap;
  GetImpacted(): TDF_LabelMap;
  GetValid_1(): TDF_LabelMap;
  GetValid_2(Ls: TDF_LabelMap): void;
  Done(status: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare type TFunction_ExecutionStatus = {
  TFunction_ES_WrongDefinition: {};
  TFunction_ES_NotExecuted: {};
  TFunction_ES_Executing: {};
  TFunction_ES_Succeeded: {};
  TFunction_ES_Failed: {};
}

export declare class Handle_TFunction_Function {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TFunction_Function): void;
  get(): TFunction_Function;
  delete(): void;
}

  export declare class Handle_TFunction_Function_1 extends Handle_TFunction_Function {
    constructor();
  }

  export declare class Handle_TFunction_Function_2 extends Handle_TFunction_Function {
    constructor(thePtr: TFunction_Function);
  }

  export declare class Handle_TFunction_Function_3 extends Handle_TFunction_Function {
    constructor(theHandle: Handle_TFunction_Function);
  }

  export declare class Handle_TFunction_Function_4 extends Handle_TFunction_Function {
    constructor(theHandle: Handle_TFunction_Function);
  }

export declare class TFunction_Function extends TDF_Attribute {
  constructor()
  static Set_1(L: TDF_Label): Handle_TFunction_Function;
  static Set_2(L: TDF_Label, DriverID: Standard_GUID): Handle_TFunction_Function;
  static GetID(): Standard_GUID;
  GetDriverGUID(): Standard_GUID;
  SetDriverGUID(guid: Standard_GUID): void;
  Failed(): Standard_Boolean;
  SetFailure(mode: Graphic3d_ZLayerId): void;
  GetFailure(): Graphic3d_ZLayerId;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  NewEmpty(): Handle_TDF_Attribute;
  References(aDataSet: Handle_TDF_DataSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StdObject_Shape {
  constructor()
  Import(): TopoDS_Shape;
  PChildren(theChildren: any): void;
  delete(): void;
}

export declare class StdObject_Location {
  constructor();
  PChildren(theChildren: any): void;
  Import(): TopLoc_Location;
  static Translate(theLoc: TopLoc_Location, theMap: StdObjMgt_TransientPersistentMap): StdObject_Location;
  delete(): void;
}

export declare class Sweep_NumShapeIterator {
  constructor()
  Init(aShape: Sweep_NumShape): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Sweep_NumShape;
  Orientation(): TopAbs_Orientation;
  delete(): void;
}

export declare class Sweep_NumShapeTool {
  constructor(aShape: Sweep_NumShape)
  NbShapes(): Graphic3d_ZLayerId;
  Index(aShape: Sweep_NumShape): Graphic3d_ZLayerId;
  Shape(anIndex: Graphic3d_ZLayerId): Sweep_NumShape;
  Type(aShape: Sweep_NumShape): TopAbs_ShapeEnum;
  Orientation(aShape: Sweep_NumShape): TopAbs_Orientation;
  HasFirstVertex(): Standard_Boolean;
  HasLastVertex(): Standard_Boolean;
  FirstVertex(): Sweep_NumShape;
  LastVertex(): Sweep_NumShape;
  delete(): void;
}

export declare class Sweep_NumShape {
  Init(Index: Graphic3d_ZLayerId, Type: TopAbs_ShapeEnum, Closed: Standard_Boolean, BegInf: Standard_Boolean, EndInf: Standard_Boolean): void;
  Index(): Graphic3d_ZLayerId;
  Type(): TopAbs_ShapeEnum;
  Closed(): Standard_Boolean;
  BegInfinite(): Standard_Boolean;
  EndInfinite(): Standard_Boolean;
  Orientation(): TopAbs_Orientation;
  delete(): void;
}

  export declare class Sweep_NumShape_1 extends Sweep_NumShape {
    constructor();
  }

  export declare class Sweep_NumShape_2 extends Sweep_NumShape {
    constructor(Index: Graphic3d_ZLayerId, Type: TopAbs_ShapeEnum, Closed: Standard_Boolean, BegInf: Standard_Boolean, EndInf: Standard_Boolean);
  }

export declare class RWStepVisual_RWDraughtingModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_DraughtingModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_DraughtingModel): void;
  Share(ent: Handle_StepVisual_DraughtingModel, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleTransparent {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleTransparent): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleTransparent): void;
  Share(ent: Handle_StepVisual_SurfaceStyleTransparent, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWAnnotationCurveOccurrenceAndGeomReprItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem): void;
  Share(ent: Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCurveStyleFont {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CurveStyleFont): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CurveStyleFont): void;
  Share(ent: Handle_StepVisual_CurveStyleFont, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCoordinatesList {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CoordinatesList): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CoordinatesList): void;
  delete(): void;
}

export declare class RWStepVisual_RWAreaInSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AreaInSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AreaInSet): void;
  Share(ent: Handle_StepVisual_AreaInSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWAnnotationFillAreaOccurrence {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AnnotationFillAreaOccurrence): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AnnotationFillAreaOccurrence): void;
  Share(ent: Handle_StepVisual_AnnotationFillAreaOccurrence, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationLayerAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationLayerAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationLayerAssignment): void;
  Share(ent: Handle_StepVisual_PresentationLayerAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPlanarBox {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PlanarBox): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PlanarBox): void;
  Share(ent: Handle_StepVisual_PlanarBox, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWDraughtingCallout {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_DraughtingCallout): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_DraughtingCallout): void;
  Share(ent: Handle_StepVisual_DraughtingCallout, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWAnnotationFillArea {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AnnotationFillArea): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AnnotationFillArea): void;
  Share(ent: Handle_StepVisual_AnnotationFillArea, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPreDefinedCurveFont {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PreDefinedCurveFont): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PreDefinedCurveFont): void;
  delete(): void;
}

export declare class RWStepVisual_RWDraughtingPreDefinedColour {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_DraughtingPreDefinedColour): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_DraughtingPreDefinedColour): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleUsage): void;
  Share(ent: Handle_StepVisual_SurfaceStyleUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPlanarExtent {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PlanarExtent): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PlanarExtent): void;
  delete(): void;
}

export declare class RWStepVisual_RWStyledItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_StyledItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_StyledItem): void;
  Share(ent: Handle_StepVisual_StyledItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWAnnotationOccurrence {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AnnotationOccurrence): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AnnotationOccurrence): void;
  Share(ent: Handle_StepVisual_AnnotationOccurrence, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPointStyle {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PointStyle): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PointStyle): void;
  Share(ent: Handle_StepVisual_PointStyle, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleRenderingWithProperties {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleRenderingWithProperties): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleRenderingWithProperties): void;
  Share(ent: Handle_StepVisual_SurfaceStyleRenderingWithProperties, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleBoundary {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleBoundary): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleBoundary): void;
  Share(ent: Handle_StepVisual_SurfaceStyleBoundary, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWInvisibility {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_Invisibility): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_Invisibility): void;
  Share(ent: Handle_StepVisual_Invisibility, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWMechanicalDesignGeometricPresentationRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation): void;
  Share(ent: Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWAnnotationCurveOccurrence {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AnnotationCurveOccurrence): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AnnotationCurveOccurrence): void;
  Share(ent: Handle_StepVisual_AnnotationCurveOccurrence, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleRendering {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleRendering): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleRendering): void;
  Share(ent: Handle_StepVisual_SurfaceStyleRendering, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleParameterLine {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleParameterLine): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleParameterLine): void;
  Share(ent: Handle_StepVisual_SurfaceStyleParameterLine, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCompositeText {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CompositeText): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CompositeText): void;
  Share(ent: Handle_StepVisual_CompositeText, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraImage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraImage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraImage): void;
  Share(ent: Handle_StepVisual_CameraImage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTemplate {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_Template): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_Template): void;
  Share(ent: Handle_StepVisual_Template, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTessellatedAnnotationOccurrence {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TessellatedAnnotationOccurrence): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TessellatedAnnotationOccurrence): void;
  Share(ent: Handle_StepVisual_TessellatedAnnotationOccurrence, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraModelD3MultiClipping {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraModelD3MultiClipping): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraModelD3MultiClipping): void;
  Share(ent: Handle_StepVisual_CameraModelD3MultiClipping, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWColourRgb {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_ColourRgb): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_ColourRgb): void;
  delete(): void;
}

export declare class RWStepVisual_RWCurveStyleFontPattern {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CurveStyleFontPattern): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CurveStyleFontPattern): void;
  delete(): void;
}

export declare class RWStepVisual_RWTextStyleWithBoxCharacteristics {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TextStyleWithBoxCharacteristics): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TextStyleWithBoxCharacteristics): void;
  Share(ent: Handle_StepVisual_TextStyleWithBoxCharacteristics, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationView {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationView): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationView): void;
  Share(ent: Handle_StepVisual_PresentationView, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTextLiteral {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TextLiteral): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TextLiteral): void;
  Share(ent: Handle_StepVisual_TextLiteral, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWFillAreaStyleColour {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_FillAreaStyleColour): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_FillAreaStyleColour): void;
  Share(ent: Handle_StepVisual_FillAreaStyleColour, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleControlGrid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleControlGrid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleControlGrid): void;
  Share(ent: Handle_StepVisual_SurfaceStyleControlGrid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWAnnotationPlane {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_AnnotationPlane): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_AnnotationPlane): void;
  Share(ent: Handle_StepVisual_AnnotationPlane, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWViewVolume {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_ViewVolume): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_ViewVolume): void;
  Share(ent: Handle_StepVisual_ViewVolume, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCurveStyle {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CurveStyle): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CurveStyle): void;
  Share(ent: Handle_StepVisual_CurveStyle, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTessellatedCurveSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TessellatedCurveSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TessellatedCurveSet): void;
  Share(ent: Handle_StepVisual_TessellatedCurveSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraModelD3 {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraModelD3): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraModelD3): void;
  Share(ent: Handle_StepVisual_CameraModelD3, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWContextDependentInvisibility {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_ContextDependentInvisibility): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_ContextDependentInvisibility): void;
  Share(ent: Handle_StepVisual_ContextDependentInvisibility, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTessellatedItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TessellatedItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TessellatedItem): void;
  delete(): void;
}

export declare class RWStepVisual_RWOverRidingStyledItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_OverRidingStyledItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_OverRidingStyledItem): void;
  Share(ent: Handle_StepVisual_OverRidingStyledItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraUsage): void;
  Share(ent: Handle_StepVisual_CameraUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCompositeTextWithExtent {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CompositeTextWithExtent): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CompositeTextWithExtent): void;
  Share(ent: Handle_StepVisual_CompositeTextWithExtent, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTessellatedGeometricSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TessellatedGeometricSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TessellatedGeometricSet): void;
  Share(ent: Handle_StepVisual_TessellatedGeometricSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationSet): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraModelD3MultiClippingUnion {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraModelD3MultiClippingUnion): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraModelD3MultiClippingUnion): void;
  Share(ent: Handle_StepVisual_CameraModelD3MultiClippingUnion, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentedItemRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentedItemRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentedItemRepresentation): void;
  Share(ent: Handle_StepVisual_PresentedItemRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCharacterizedObjAndRepresentationAndDraughtingModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel): void;
  Share(ent: Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraModelD2 {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraModelD2): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraModelD2): void;
  Share(ent: Handle_StepVisual_CameraModelD2, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationArea {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationArea): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationArea): void;
  Share(ent: Handle_StepVisual_PresentationArea, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleFillArea {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleFillArea): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleFillArea): void;
  Share(ent: Handle_StepVisual_SurfaceStyleFillArea, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationStyleByContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationStyleByContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationStyleByContext): void;
  Share(ent: Handle_StepVisual_PresentationStyleByContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationLayerUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationLayerUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationLayerUsage): void;
  Share(ent: Handle_StepVisual_PresentationLayerUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTextStyle {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TextStyle): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TextStyle): void;
  Share(ent: Handle_StepVisual_TextStyle, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraModel): void;
  delete(): void;
}

export declare class RWStepVisual_RWPreDefinedColour {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PreDefinedColour): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PreDefinedColour): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationSize {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationSize): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationSize): void;
  Share(ent: Handle_StepVisual_PresentationSize, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWMechanicalDesignGeometricPresentationArea {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_MechanicalDesignGeometricPresentationArea): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_MechanicalDesignGeometricPresentationArea): void;
  Share(ent: Handle_StepVisual_MechanicalDesignGeometricPresentationArea, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWBackgroundColour {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_BackgroundColour): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_BackgroundColour): void;
  Share(ent: Handle_StepVisual_BackgroundColour, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWContextDependentOverRidingStyledItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_ContextDependentOverRidingStyledItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_ContextDependentOverRidingStyledItem): void;
  Share(ent: Handle_StepVisual_ContextDependentOverRidingStyledItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWFillAreaStyle {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_FillAreaStyle): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_FillAreaStyle): void;
  Share(ent: Handle_StepVisual_FillAreaStyle, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWExternallyDefinedCurveFont {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_ExternallyDefinedCurveFont): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_ExternallyDefinedCurveFont): void;
  Share(ent: Handle_StepVisual_ExternallyDefinedCurveFont, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleReflectanceAmbient {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleReflectanceAmbient): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleReflectanceAmbient): void;
  Share(ent: Handle_StepVisual_SurfaceStyleReflectanceAmbient, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPreDefinedItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PreDefinedItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PreDefinedItem): void;
  delete(): void;
}

export declare class RWStepVisual_RWCameraModelD3MultiClippingIntersection {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_CameraModelD3MultiClippingIntersection): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_CameraModelD3MultiClippingIntersection): void;
  Share(ent: Handle_StepVisual_CameraModelD3MultiClippingIntersection, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTemplateInstance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TemplateInstance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TemplateInstance): void;
  Share(ent: Handle_StepVisual_TemplateInstance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWTextStyleForDefinedFont {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_TextStyleForDefinedFont): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_TextStyleForDefinedFont): void;
  Share(ent: Handle_StepVisual_TextStyleForDefinedFont, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleSegmentationCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleSegmentationCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleSegmentationCurve): void;
  Share(ent: Handle_StepVisual_SurfaceStyleSegmentationCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWDraughtingPreDefinedCurveFont {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_DraughtingPreDefinedCurveFont): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_DraughtingPreDefinedCurveFont): void;
  delete(): void;
}

export declare class RWStepVisual_RWColour {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_Colour): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_Colour): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceStyleSilhouette {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceStyleSilhouette): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceStyleSilhouette): void;
  Share(ent: Handle_StepVisual_SurfaceStyleSilhouette, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationStyleAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationStyleAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationStyleAssignment): void;
  Share(ent: Handle_StepVisual_PresentationStyleAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWPresentationRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_PresentationRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_PresentationRepresentation): void;
  Share(ent: Handle_StepVisual_PresentationRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepVisual_RWColourSpecification {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_ColourSpecification): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_ColourSpecification): void;
  delete(): void;
}

export declare class RWStepVisual_RWSurfaceSideStyle {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepVisual_SurfaceSideStyle): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepVisual_SurfaceSideStyle): void;
  Share(ent: Handle_StepVisual_SurfaceSideStyle, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class BRepAlgo_FaceRestrictor {
  constructor()
  Init(F: TopoDS_Face, Proj: Standard_Boolean, ControlOrientation: Standard_Boolean): void;
  Add(W: TopoDS_Wire): void;
  Clear(): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  More(): Standard_Boolean;
  Next(): void;
  Current(): TopoDS_Face;
  delete(): void;
}

export declare class BRepAlgo {
  constructor();
  static ConcatenateWire(Wire: TopoDS_Wire, Option: GeomAbs_Shape, AngularTolerance: Quantity_AbsorbedDose): TopoDS_Wire;
  static ConcatenateWireC0(Wire: TopoDS_Wire): TopoDS_Edge;
  static IsValid_1(S: TopoDS_Shape): Standard_Boolean;
  static IsValid_2(theArgs: TopTools_ListOfShape, theResult: TopoDS_Shape, closedSolid: Standard_Boolean, GeomCtrl: Standard_Boolean): Standard_Boolean;
  static IsTopologicallyValid(S: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

export declare class BRepAlgo_Image {
  constructor()
  SetRoot(S: TopoDS_Shape): void;
  Bind_1(OldS: TopoDS_Shape, NewS: TopoDS_Shape): void;
  Bind_2(OldS: TopoDS_Shape, NewS: TopTools_ListOfShape): void;
  Add_1(OldS: TopoDS_Shape, NewS: TopoDS_Shape): void;
  Add_2(OldS: TopoDS_Shape, NewS: TopTools_ListOfShape): void;
  Clear(): void;
  Remove(S: TopoDS_Shape): void;
  RemoveRoot(Root: TopoDS_Shape): void;
  ReplaceRoot(OldRoot: TopoDS_Shape, NewRoot: TopoDS_Shape): void;
  Roots(): TopTools_ListOfShape;
  IsImage(S: TopoDS_Shape): Standard_Boolean;
  ImageFrom(S: TopoDS_Shape): TopoDS_Shape;
  Root(S: TopoDS_Shape): TopoDS_Shape;
  HasImage(S: TopoDS_Shape): Standard_Boolean;
  Image(S: TopoDS_Shape): TopTools_ListOfShape;
  LastImage(S: TopoDS_Shape, L: TopTools_ListOfShape): void;
  Compact(): void;
  Filter(S: TopoDS_Shape, ShapeType: TopAbs_ShapeEnum): void;
  delete(): void;
}

export declare class BRepAlgo_BooleanOperation extends BRepBuilderAPI_MakeShape {
  PerformDS(): void;
  Perform(St1: TopAbs_State, St2: TopAbs_State): void;
  Builder(): Handle_TopOpeBRepBuild_HBuilder;
  Shape1(): TopoDS_Shape;
  Shape2(): TopoDS_Shape;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

export declare class BRepAlgo_Common extends BRepAlgo_BooleanOperation {
  constructor(S1: TopoDS_Shape, S2: TopoDS_Shape)
  delete(): void;
}

export declare class BRepAlgo_AsDes extends Standard_Transient {
  constructor()
  Clear(): void;
  Add_1(S: TopoDS_Shape, SS: TopoDS_Shape): void;
  Add_2(S: TopoDS_Shape, SS: TopTools_ListOfShape): void;
  HasAscendant(S: TopoDS_Shape): Standard_Boolean;
  HasDescendant(S: TopoDS_Shape): Standard_Boolean;
  Ascendant(S: TopoDS_Shape): TopTools_ListOfShape;
  Descendant(S: TopoDS_Shape): TopTools_ListOfShape;
  ChangeDescendant(S: TopoDS_Shape): TopTools_ListOfShape;
  Replace(OldS: TopoDS_Shape, NewS: TopoDS_Shape): void;
  Remove(S: TopoDS_Shape): void;
  HasCommonDescendant(S1: TopoDS_Shape, S2: TopoDS_Shape, LC: TopTools_ListOfShape): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepAlgo_AsDes {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepAlgo_AsDes): void;
  get(): BRepAlgo_AsDes;
  delete(): void;
}

  export declare class Handle_BRepAlgo_AsDes_1 extends Handle_BRepAlgo_AsDes {
    constructor();
  }

  export declare class Handle_BRepAlgo_AsDes_2 extends Handle_BRepAlgo_AsDes {
    constructor(thePtr: BRepAlgo_AsDes);
  }

  export declare class Handle_BRepAlgo_AsDes_3 extends Handle_BRepAlgo_AsDes {
    constructor(theHandle: Handle_BRepAlgo_AsDes);
  }

  export declare class Handle_BRepAlgo_AsDes_4 extends Handle_BRepAlgo_AsDes {
    constructor(theHandle: Handle_BRepAlgo_AsDes);
  }

export declare type BRepAlgo_CheckStatus = {
  BRepAlgo_OK: {};
  BRepAlgo_NOK: {};
}

export declare class BRepAlgo_NormalProjection {
  Init(S: TopoDS_Shape): void;
  Add(ToProj: TopoDS_Shape): void;
  SetParams(Tol3D: Quantity_AbsorbedDose, Tol2D: Quantity_AbsorbedDose, InternalContinuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSeg: Graphic3d_ZLayerId): void;
  SetDefaultParams(): void;
  SetMaxDistance(MaxDist: Quantity_AbsorbedDose): void;
  Compute3d(With3d: Standard_Boolean): void;
  SetLimit(FaceBoundaries: Standard_Boolean): void;
  Build(): void;
  IsDone(): Standard_Boolean;
  Projection(): TopoDS_Shape;
  Ancestor(E: TopoDS_Edge): TopoDS_Shape;
  Couple(E: TopoDS_Edge): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  IsElementary(C: Adaptor3d_Curve): Standard_Boolean;
  BuildWire(Liste: TopTools_ListOfShape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepAlgo_NormalProjection_1 extends BRepAlgo_NormalProjection {
    constructor();
  }

  export declare class BRepAlgo_NormalProjection_2 extends BRepAlgo_NormalProjection {
    constructor(S: TopoDS_Shape);
  }

export declare class BRepAlgo_Cut extends BRepAlgo_BooleanOperation {
  constructor(S1: TopoDS_Shape, S2: TopoDS_Shape)
  delete(): void;
}

export declare class BRepAlgo_Fuse extends BRepAlgo_BooleanOperation {
  constructor(S1: TopoDS_Shape, S2: TopoDS_Shape)
  delete(): void;
}

export declare class BRepAlgo_Section extends BRepAlgo_BooleanOperation {
  Init1_1(S1: TopoDS_Shape): void;
  Init1_2(Pl: gp_Pln): void;
  Init1_3(Sf: Handle_Geom_Surface): void;
  Init2_1(S2: TopoDS_Shape): void;
  Init2_2(Pl: gp_Pln): void;
  Init2_3(Sf: Handle_Geom_Surface): void;
  Approximation(B: Standard_Boolean): void;
  ComputePCurveOn1(B: Standard_Boolean): void;
  ComputePCurveOn2(B: Standard_Boolean): void;
  Build(): void;
  HasAncestorFaceOn1(E: TopoDS_Shape, F: TopoDS_Shape): Standard_Boolean;
  HasAncestorFaceOn2(E: TopoDS_Shape, F: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepAlgo_Section_1 extends BRepAlgo_Section {
    constructor(Sh1: TopoDS_Shape, Sh2: TopoDS_Shape, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgo_Section_2 extends BRepAlgo_Section {
    constructor(Sh: TopoDS_Shape, Pl: gp_Pln, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgo_Section_3 extends BRepAlgo_Section {
    constructor(Sh: TopoDS_Shape, Sf: Handle_Geom_Surface, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgo_Section_4 extends BRepAlgo_Section {
    constructor(Sf: Handle_Geom_Surface, Sh: TopoDS_Shape, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgo_Section_5 extends BRepAlgo_Section {
    constructor(Sf1: Handle_Geom_Surface, Sf2: Handle_Geom_Surface, PerformNow: Standard_Boolean);
  }

export declare class BRepAlgo_Tool {
  constructor();
  static Deboucle3D(S: TopoDS_Shape, Boundary: TopTools_MapOfShape): TopoDS_Shape;
  delete(): void;
}

export declare class BRepAlgo_Loop {
  constructor()
  Init(F: TopoDS_Face): void;
  AddEdge(E: TopoDS_Edge, LV: TopTools_ListOfShape): void;
  AddConstEdge(E: TopoDS_Edge): void;
  AddConstEdges(LE: TopTools_ListOfShape): void;
  SetImageVV(theImageVV: BRepAlgo_Image): void;
  Perform(): void;
  UpdateVEmap(theVEmap: TopTools_IndexedDataMapOfShapeListOfShape): void;
  CutEdge(E: TopoDS_Edge, VonE: TopTools_ListOfShape, NE: TopTools_ListOfShape): void;
  NewWires(): TopTools_ListOfShape;
  WiresToFaces(): void;
  NewFaces(): TopTools_ListOfShape;
  NewEdges(E: TopoDS_Edge): TopTools_ListOfShape;
  GetVerticesForSubstitute(VerVerMap: TopTools_DataMapOfShapeShape): void;
  VerticesForSubstitute(VerVerMap: TopTools_DataMapOfShapeShape): void;
  delete(): void;
}

export declare class BinMDF {
  constructor();
  static AddDrivers(aDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class BinMDF_ReferenceDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDF_ReferenceDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDF_ReferenceDriver): void;
  get(): BinMDF_ReferenceDriver;
  delete(): void;
}

  export declare class Handle_BinMDF_ReferenceDriver_1 extends Handle_BinMDF_ReferenceDriver {
    constructor();
  }

  export declare class Handle_BinMDF_ReferenceDriver_2 extends Handle_BinMDF_ReferenceDriver {
    constructor(thePtr: BinMDF_ReferenceDriver);
  }

  export declare class Handle_BinMDF_ReferenceDriver_3 extends Handle_BinMDF_ReferenceDriver {
    constructor(theHandle: Handle_BinMDF_ReferenceDriver);
  }

  export declare class Handle_BinMDF_ReferenceDriver_4 extends Handle_BinMDF_ReferenceDriver {
    constructor(theHandle: Handle_BinMDF_ReferenceDriver);
  }

export declare class BinMDF_DerivedDriver extends BinMDF_ADriver {
  constructor(theDerivative: Handle_TDF_Attribute, theBaseDriver: Handle_BinMDF_ADriver)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  delete(): void;
}

export declare class Handle_BinMDF_TagSourceDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDF_TagSourceDriver): void;
  get(): BinMDF_TagSourceDriver;
  delete(): void;
}

  export declare class Handle_BinMDF_TagSourceDriver_1 extends Handle_BinMDF_TagSourceDriver {
    constructor();
  }

  export declare class Handle_BinMDF_TagSourceDriver_2 extends Handle_BinMDF_TagSourceDriver {
    constructor(thePtr: BinMDF_TagSourceDriver);
  }

  export declare class Handle_BinMDF_TagSourceDriver_3 extends Handle_BinMDF_TagSourceDriver {
    constructor(theHandle: Handle_BinMDF_TagSourceDriver);
  }

  export declare class Handle_BinMDF_TagSourceDriver_4 extends Handle_BinMDF_TagSourceDriver {
    constructor(theHandle: Handle_BinMDF_TagSourceDriver);
  }

export declare class BinMDF_TagSourceDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDF_ADriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDF_ADriver): void;
  get(): BinMDF_ADriver;
  delete(): void;
}

  export declare class Handle_BinMDF_ADriver_1 extends Handle_BinMDF_ADriver {
    constructor();
  }

  export declare class Handle_BinMDF_ADriver_2 extends Handle_BinMDF_ADriver {
    constructor(thePtr: BinMDF_ADriver);
  }

  export declare class Handle_BinMDF_ADriver_3 extends Handle_BinMDF_ADriver {
    constructor(theHandle: Handle_BinMDF_ADriver);
  }

  export declare class Handle_BinMDF_ADriver_4 extends Handle_BinMDF_ADriver {
    constructor(theHandle: Handle_BinMDF_ADriver);
  }

export declare class BinMDF_ADriver extends Standard_Transient {
  NewEmpty(): Handle_TDF_Attribute;
  SourceType(): Handle_Standard_Type;
  TypeName(): XCAFDoc_PartId;
  Paste_1(aSource: BinObjMgt_Persistent, aTarget: Handle_TDF_Attribute, aRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(aSource: Handle_TDF_Attribute, aTarget: BinObjMgt_Persistent, aRelocTable: BinObjMgt_SRelocationTable): void;
  MessageDriver(): Handle_Message_Messenger;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDF_ADriverTable extends Standard_Transient {
  constructor()
  AddDriver(theDriver: Handle_BinMDF_ADriver): void;
  AddDerivedDriver_1(theInstance: Handle_TDF_Attribute): void;
  AddDerivedDriver_2(theDerivedType: Standard_CString): Handle_Standard_Type;
  AssignIds_1(theTypes: BinObjMgt_SRelocationTable): void;
  AssignIds_2(theTypeNames: TColStd_SequenceOfAsciiString): void;
  GetDriver_1(theType: Handle_Standard_Type, theDriver: Handle_BinMDF_ADriver): Graphic3d_ZLayerId;
  GetDriver_2(theTypeId: Graphic3d_ZLayerId): Handle_BinMDF_ADriver;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDF_ADriverTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDF_ADriverTable): void;
  get(): BinMDF_ADriverTable;
  delete(): void;
}

  export declare class Handle_BinMDF_ADriverTable_1 extends Handle_BinMDF_ADriverTable {
    constructor();
  }

  export declare class Handle_BinMDF_ADriverTable_2 extends Handle_BinMDF_ADriverTable {
    constructor(thePtr: BinMDF_ADriverTable);
  }

  export declare class Handle_BinMDF_ADriverTable_3 extends Handle_BinMDF_ADriverTable {
    constructor(theHandle: Handle_BinMDF_ADriverTable);
  }

  export declare class Handle_BinMDF_ADriverTable_4 extends Handle_BinMDF_ADriverTable {
    constructor(theHandle: Handle_BinMDF_ADriverTable);
  }

export declare class IGESSolid_ToolFace {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Face, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Face, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Face, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Face): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Face, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Face, entto: Handle_IGESSolid_Face, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Face, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolShell {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Shell, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Shell, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Shell, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Shell): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Shell, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Shell, entto: Handle_IGESSolid_Shell, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Shell, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolConicalSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_ConicalSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_ConicalSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_ConicalSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_ConicalSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_ConicalSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_ConicalSurface, entto: Handle_IGESSolid_ConicalSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_ConicalSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolEdgeList {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_EdgeList, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_EdgeList, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_EdgeList, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_EdgeList): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_EdgeList, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_EdgeList, entto: Handle_IGESSolid_EdgeList, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_EdgeList, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_Block {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Block): void;
  get(): IGESSolid_Block;
  delete(): void;
}

  export declare class Handle_IGESSolid_Block_1 extends Handle_IGESSolid_Block {
    constructor();
  }

  export declare class Handle_IGESSolid_Block_2 extends Handle_IGESSolid_Block {
    constructor(thePtr: IGESSolid_Block);
  }

  export declare class Handle_IGESSolid_Block_3 extends Handle_IGESSolid_Block {
    constructor(theHandle: Handle_IGESSolid_Block);
  }

  export declare class Handle_IGESSolid_Block_4 extends Handle_IGESSolid_Block {
    constructor(theHandle: Handle_IGESSolid_Block);
  }

export declare class IGESSolid_Block extends IGESData_IGESEntity {
  constructor()
  Init(aSize: gp_XYZ, aCorner: gp_XYZ, aXAxis: gp_XYZ, aZAxis: gp_XYZ): void;
  Size(): gp_XYZ;
  XLength(): Quantity_AbsorbedDose;
  YLength(): Quantity_AbsorbedDose;
  ZLength(): Quantity_AbsorbedDose;
  Corner(): gp_Pnt;
  TransformedCorner(): gp_Pnt;
  XAxis(): gp_Dir;
  TransformedXAxis(): gp_Dir;
  YAxis(): gp_Dir;
  TransformedYAxis(): gp_Dir;
  ZAxis(): gp_Dir;
  TransformedZAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_ToroidalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_ToroidalSurface): void;
  get(): IGESSolid_ToroidalSurface;
  delete(): void;
}

  export declare class Handle_IGESSolid_ToroidalSurface_1 extends Handle_IGESSolid_ToroidalSurface {
    constructor();
  }

  export declare class Handle_IGESSolid_ToroidalSurface_2 extends Handle_IGESSolid_ToroidalSurface {
    constructor(thePtr: IGESSolid_ToroidalSurface);
  }

  export declare class Handle_IGESSolid_ToroidalSurface_3 extends Handle_IGESSolid_ToroidalSurface {
    constructor(theHandle: Handle_IGESSolid_ToroidalSurface);
  }

  export declare class Handle_IGESSolid_ToroidalSurface_4 extends Handle_IGESSolid_ToroidalSurface {
    constructor(theHandle: Handle_IGESSolid_ToroidalSurface);
  }

export declare class IGESSolid_ToroidalSurface extends IGESData_IGESEntity {
  constructor()
  Init(aCenter: Handle_IGESGeom_Point, anAxis: Handle_IGESGeom_Direction, majRadius: Quantity_AbsorbedDose, minRadius: Quantity_AbsorbedDose, Refdir: Handle_IGESGeom_Direction): void;
  Center(): Handle_IGESGeom_Point;
  TransformedCenter(): gp_Pnt;
  Axis(): Handle_IGESGeom_Direction;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  ReferenceDir(): Handle_IGESGeom_Direction;
  IsParametrised(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_Shell extends IGESData_IGESEntity {
  constructor()
  Init(allFaces: Handle_IGESSolid_HArray1OfFace, allOrient: Handle_TColStd_HArray1OfInteger): void;
  IsClosed(): Standard_Boolean;
  SetClosed(closed: Standard_Boolean): void;
  NbFaces(): Graphic3d_ZLayerId;
  Face(Index: Graphic3d_ZLayerId): Handle_IGESSolid_Face;
  Orientation(Index: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_Shell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Shell): void;
  get(): IGESSolid_Shell;
  delete(): void;
}

  export declare class Handle_IGESSolid_Shell_1 extends Handle_IGESSolid_Shell {
    constructor();
  }

  export declare class Handle_IGESSolid_Shell_2 extends Handle_IGESSolid_Shell {
    constructor(thePtr: IGESSolid_Shell);
  }

  export declare class Handle_IGESSolid_Shell_3 extends Handle_IGESSolid_Shell {
    constructor(theHandle: Handle_IGESSolid_Shell);
  }

  export declare class Handle_IGESSolid_Shell_4 extends Handle_IGESSolid_Shell {
    constructor(theHandle: Handle_IGESSolid_Shell);
  }

export declare class IGESSolid_Loop extends IGESData_IGESEntity {
  constructor()
  Init(types: Handle_TColStd_HArray1OfInteger, edges: Handle_IGESData_HArray1OfIGESEntity, index: Handle_TColStd_HArray1OfInteger, orient: Handle_TColStd_HArray1OfInteger, nbParameterCurves: Handle_TColStd_HArray1OfInteger, isoparametricFlags: Handle_IGESBasic_HArray1OfHArray1OfInteger, curves: Handle_IGESBasic_HArray1OfHArray1OfIGESEntity): void;
  IsBound(): Standard_Boolean;
  SetBound(bound: Standard_Boolean): void;
  NbEdges(): Graphic3d_ZLayerId;
  EdgeType(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Edge(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  Orientation(Index: Graphic3d_ZLayerId): Standard_Boolean;
  NbParameterCurves(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsIsoparametric(EdgeIndex: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Standard_Boolean;
  ParametricCurve(EdgeIndex: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  ListIndex(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_Loop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Loop): void;
  get(): IGESSolid_Loop;
  delete(): void;
}

  export declare class Handle_IGESSolid_Loop_1 extends Handle_IGESSolid_Loop {
    constructor();
  }

  export declare class Handle_IGESSolid_Loop_2 extends Handle_IGESSolid_Loop {
    constructor(thePtr: IGESSolid_Loop);
  }

  export declare class Handle_IGESSolid_Loop_3 extends Handle_IGESSolid_Loop {
    constructor(theHandle: Handle_IGESSolid_Loop);
  }

  export declare class Handle_IGESSolid_Loop_4 extends Handle_IGESSolid_Loop {
    constructor(theHandle: Handle_IGESSolid_Loop);
  }

export declare class IGESSolid_ToolVertexList {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_VertexList, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_VertexList, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_VertexList, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_VertexList): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_VertexList, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_VertexList, entto: Handle_IGESSolid_VertexList, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_VertexList, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolLoop {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Loop, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Loop, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Loop, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Loop): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Loop, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Loop, entto: Handle_IGESSolid_Loop, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Loop, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolSolidOfLinearExtrusion {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_SolidOfLinearExtrusion, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_SolidOfLinearExtrusion, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_SolidOfLinearExtrusion, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_SolidOfLinearExtrusion): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_SolidOfLinearExtrusion, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_SolidOfLinearExtrusion, entto: Handle_IGESSolid_SolidOfLinearExtrusion, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_SolidOfLinearExtrusion, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolSphericalSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_SphericalSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_SphericalSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_SphericalSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_SphericalSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_SphericalSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_SphericalSurface, entto: Handle_IGESSolid_SphericalSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_SphericalSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_SolidInstance extends IGESData_IGESEntity {
  constructor()
  Init(anEntity: Handle_IGESData_IGESEntity): void;
  IsBrep(): Standard_Boolean;
  SetBrep(brep: Standard_Boolean): void;
  Entity(): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_SolidInstance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SolidInstance): void;
  get(): IGESSolid_SolidInstance;
  delete(): void;
}

  export declare class Handle_IGESSolid_SolidInstance_1 extends Handle_IGESSolid_SolidInstance {
    constructor();
  }

  export declare class Handle_IGESSolid_SolidInstance_2 extends Handle_IGESSolid_SolidInstance {
    constructor(thePtr: IGESSolid_SolidInstance);
  }

  export declare class Handle_IGESSolid_SolidInstance_3 extends Handle_IGESSolid_SolidInstance {
    constructor(theHandle: Handle_IGESSolid_SolidInstance);
  }

  export declare class Handle_IGESSolid_SolidInstance_4 extends Handle_IGESSolid_SolidInstance {
    constructor(theHandle: Handle_IGESSolid_SolidInstance);
  }

export declare class IGESSolid_ToolCylindricalSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_CylindricalSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_CylindricalSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_CylindricalSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_CylindricalSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_CylindricalSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_CylindricalSurface, entto: Handle_IGESSolid_CylindricalSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_CylindricalSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_Cylinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Cylinder): void;
  get(): IGESSolid_Cylinder;
  delete(): void;
}

  export declare class Handle_IGESSolid_Cylinder_1 extends Handle_IGESSolid_Cylinder {
    constructor();
  }

  export declare class Handle_IGESSolid_Cylinder_2 extends Handle_IGESSolid_Cylinder {
    constructor(thePtr: IGESSolid_Cylinder);
  }

  export declare class Handle_IGESSolid_Cylinder_3 extends Handle_IGESSolid_Cylinder {
    constructor(theHandle: Handle_IGESSolid_Cylinder);
  }

  export declare class Handle_IGESSolid_Cylinder_4 extends Handle_IGESSolid_Cylinder {
    constructor(theHandle: Handle_IGESSolid_Cylinder);
  }

export declare class IGESSolid_Cylinder extends IGESData_IGESEntity {
  constructor()
  Init(aHeight: Quantity_AbsorbedDose, aRadius: Quantity_AbsorbedDose, aCenter: gp_XYZ, anAxis: gp_XYZ): void;
  Height(): Quantity_AbsorbedDose;
  Radius(): Quantity_AbsorbedDose;
  FaceCenter(): gp_Pnt;
  TransformedFaceCenter(): gp_Pnt;
  Axis(): gp_Dir;
  TransformedAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_SolidOfRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SolidOfRevolution): void;
  get(): IGESSolid_SolidOfRevolution;
  delete(): void;
}

  export declare class Handle_IGESSolid_SolidOfRevolution_1 extends Handle_IGESSolid_SolidOfRevolution {
    constructor();
  }

  export declare class Handle_IGESSolid_SolidOfRevolution_2 extends Handle_IGESSolid_SolidOfRevolution {
    constructor(thePtr: IGESSolid_SolidOfRevolution);
  }

  export declare class Handle_IGESSolid_SolidOfRevolution_3 extends Handle_IGESSolid_SolidOfRevolution {
    constructor(theHandle: Handle_IGESSolid_SolidOfRevolution);
  }

  export declare class Handle_IGESSolid_SolidOfRevolution_4 extends Handle_IGESSolid_SolidOfRevolution {
    constructor(theHandle: Handle_IGESSolid_SolidOfRevolution);
  }

export declare class IGESSolid_SolidOfRevolution extends IGESData_IGESEntity {
  constructor()
  Init(aCurve: Handle_IGESData_IGESEntity, aFract: Quantity_AbsorbedDose, aAxisPnt: gp_XYZ, aDirection: gp_XYZ): void;
  SetClosedToAxis(mode: Standard_Boolean): void;
  IsClosedToAxis(): Standard_Boolean;
  Curve(): Handle_IGESData_IGESEntity;
  Fraction(): Quantity_AbsorbedDose;
  AxisPoint(): gp_Pnt;
  TransformedAxisPoint(): gp_Pnt;
  Axis(): gp_Dir;
  TransformedAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_ToolToroidalSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_ToroidalSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_ToroidalSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_ToroidalSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_ToroidalSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_ToroidalSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_ToroidalSurface, entto: Handle_IGESSolid_ToroidalSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_ToroidalSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_GeneralModule): void;
  get(): IGESSolid_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESSolid_GeneralModule_1 extends Handle_IGESSolid_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESSolid_GeneralModule_2 extends Handle_IGESSolid_GeneralModule {
    constructor(thePtr: IGESSolid_GeneralModule);
  }

  export declare class Handle_IGESSolid_GeneralModule_3 extends Handle_IGESSolid_GeneralModule {
    constructor(theHandle: Handle_IGESSolid_GeneralModule);
  }

  export declare class Handle_IGESSolid_GeneralModule_4 extends Handle_IGESSolid_GeneralModule {
    constructor(theHandle: Handle_IGESSolid_GeneralModule);
  }

export declare class IGESSolid_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_HArray1OfFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_HArray1OfFace): void;
  get(): IGESSolid_HArray1OfFace;
  delete(): void;
}

  export declare class Handle_IGESSolid_HArray1OfFace_1 extends Handle_IGESSolid_HArray1OfFace {
    constructor();
  }

  export declare class Handle_IGESSolid_HArray1OfFace_2 extends Handle_IGESSolid_HArray1OfFace {
    constructor(thePtr: IGESSolid_HArray1OfFace);
  }

  export declare class Handle_IGESSolid_HArray1OfFace_3 extends Handle_IGESSolid_HArray1OfFace {
    constructor(theHandle: Handle_IGESSolid_HArray1OfFace);
  }

  export declare class Handle_IGESSolid_HArray1OfFace_4 extends Handle_IGESSolid_HArray1OfFace {
    constructor(theHandle: Handle_IGESSolid_HArray1OfFace);
  }

export declare class IGESSolid_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Protocol): void;
  get(): IGESSolid_Protocol;
  delete(): void;
}

  export declare class Handle_IGESSolid_Protocol_1 extends Handle_IGESSolid_Protocol {
    constructor();
  }

  export declare class Handle_IGESSolid_Protocol_2 extends Handle_IGESSolid_Protocol {
    constructor(thePtr: IGESSolid_Protocol);
  }

  export declare class Handle_IGESSolid_Protocol_3 extends Handle_IGESSolid_Protocol {
    constructor(theHandle: Handle_IGESSolid_Protocol);
  }

  export declare class Handle_IGESSolid_Protocol_4 extends Handle_IGESSolid_Protocol {
    constructor(theHandle: Handle_IGESSolid_Protocol);
  }

export declare class Handle_IGESSolid_ManifoldSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_ManifoldSolid): void;
  get(): IGESSolid_ManifoldSolid;
  delete(): void;
}

  export declare class Handle_IGESSolid_ManifoldSolid_1 extends Handle_IGESSolid_ManifoldSolid {
    constructor();
  }

  export declare class Handle_IGESSolid_ManifoldSolid_2 extends Handle_IGESSolid_ManifoldSolid {
    constructor(thePtr: IGESSolid_ManifoldSolid);
  }

  export declare class Handle_IGESSolid_ManifoldSolid_3 extends Handle_IGESSolid_ManifoldSolid {
    constructor(theHandle: Handle_IGESSolid_ManifoldSolid);
  }

  export declare class Handle_IGESSolid_ManifoldSolid_4 extends Handle_IGESSolid_ManifoldSolid {
    constructor(theHandle: Handle_IGESSolid_ManifoldSolid);
  }

export declare class IGESSolid_ManifoldSolid extends IGESData_IGESEntity {
  constructor()
  Init(aShell: Handle_IGESSolid_Shell, shellflag: Standard_Boolean, voidShells: Handle_IGESSolid_HArray1OfShell, voidShellFlags: Handle_TColStd_HArray1OfInteger): void;
  Shell(): Handle_IGESSolid_Shell;
  OrientationFlag(): Standard_Boolean;
  NbVoidShells(): Graphic3d_ZLayerId;
  VoidShell(Index: Graphic3d_ZLayerId): Handle_IGESSolid_Shell;
  VoidOrientationFlag(Index: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_ToolBlock {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Block, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Block, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Block, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Block): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Block, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Block, entto: Handle_IGESSolid_Block, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Block, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolEllipsoid {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Ellipsoid, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Ellipsoid, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Ellipsoid, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Ellipsoid): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Ellipsoid, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Ellipsoid, entto: Handle_IGESSolid_Ellipsoid, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Ellipsoid, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_Face {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Face): void;
  get(): IGESSolid_Face;
  delete(): void;
}

  export declare class Handle_IGESSolid_Face_1 extends Handle_IGESSolid_Face {
    constructor();
  }

  export declare class Handle_IGESSolid_Face_2 extends Handle_IGESSolid_Face {
    constructor(thePtr: IGESSolid_Face);
  }

  export declare class Handle_IGESSolid_Face_3 extends Handle_IGESSolid_Face {
    constructor(theHandle: Handle_IGESSolid_Face);
  }

  export declare class Handle_IGESSolid_Face_4 extends Handle_IGESSolid_Face {
    constructor(theHandle: Handle_IGESSolid_Face);
  }

export declare class IGESSolid_Face extends IGESData_IGESEntity {
  constructor()
  Init(aSurface: Handle_IGESData_IGESEntity, outerLoopFlag: Standard_Boolean, loops: Handle_IGESSolid_HArray1OfLoop): void;
  Surface(): Handle_IGESData_IGESEntity;
  NbLoops(): Graphic3d_ZLayerId;
  HasOuterLoop(): Standard_Boolean;
  Loop(Index: Graphic3d_ZLayerId): Handle_IGESSolid_Loop;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_Ellipsoid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Ellipsoid): void;
  get(): IGESSolid_Ellipsoid;
  delete(): void;
}

  export declare class Handle_IGESSolid_Ellipsoid_1 extends Handle_IGESSolid_Ellipsoid {
    constructor();
  }

  export declare class Handle_IGESSolid_Ellipsoid_2 extends Handle_IGESSolid_Ellipsoid {
    constructor(thePtr: IGESSolid_Ellipsoid);
  }

  export declare class Handle_IGESSolid_Ellipsoid_3 extends Handle_IGESSolid_Ellipsoid {
    constructor(theHandle: Handle_IGESSolid_Ellipsoid);
  }

  export declare class Handle_IGESSolid_Ellipsoid_4 extends Handle_IGESSolid_Ellipsoid {
    constructor(theHandle: Handle_IGESSolid_Ellipsoid);
  }

export declare class IGESSolid_Ellipsoid extends IGESData_IGESEntity {
  constructor()
  Init(aSize: gp_XYZ, aCenter: gp_XYZ, anXAxis: gp_XYZ, anZAxis: gp_XYZ): void;
  Size(): gp_XYZ;
  XLength(): Quantity_AbsorbedDose;
  YLength(): Quantity_AbsorbedDose;
  ZLength(): Quantity_AbsorbedDose;
  Center(): gp_Pnt;
  TransformedCenter(): gp_Pnt;
  XAxis(): gp_Dir;
  TransformedXAxis(): gp_Dir;
  YAxis(): gp_Dir;
  TransformedYAxis(): gp_Dir;
  ZAxis(): gp_Dir;
  TransformedZAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_PlaneSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_PlaneSurface): void;
  get(): IGESSolid_PlaneSurface;
  delete(): void;
}

  export declare class Handle_IGESSolid_PlaneSurface_1 extends Handle_IGESSolid_PlaneSurface {
    constructor();
  }

  export declare class Handle_IGESSolid_PlaneSurface_2 extends Handle_IGESSolid_PlaneSurface {
    constructor(thePtr: IGESSolid_PlaneSurface);
  }

  export declare class Handle_IGESSolid_PlaneSurface_3 extends Handle_IGESSolid_PlaneSurface {
    constructor(theHandle: Handle_IGESSolid_PlaneSurface);
  }

  export declare class Handle_IGESSolid_PlaneSurface_4 extends Handle_IGESSolid_PlaneSurface {
    constructor(theHandle: Handle_IGESSolid_PlaneSurface);
  }

export declare class IGESSolid_PlaneSurface extends IGESData_IGESEntity {
  constructor()
  Init(aLocation: Handle_IGESGeom_Point, aNormal: Handle_IGESGeom_Direction, refdir: Handle_IGESGeom_Direction): void;
  LocationPoint(): Handle_IGESGeom_Point;
  Normal(): Handle_IGESGeom_Direction;
  ReferenceDir(): Handle_IGESGeom_Direction;
  IsParametrised(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_SelectedComponent extends IGESData_IGESEntity {
  constructor()
  Init(anEntity: Handle_IGESSolid_BooleanTree, selectPnt: gp_XYZ): void;
  Component(): Handle_IGESSolid_BooleanTree;
  SelectPoint(): gp_Pnt;
  TransformedSelectPoint(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_SelectedComponent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SelectedComponent): void;
  get(): IGESSolid_SelectedComponent;
  delete(): void;
}

  export declare class Handle_IGESSolid_SelectedComponent_1 extends Handle_IGESSolid_SelectedComponent {
    constructor();
  }

  export declare class Handle_IGESSolid_SelectedComponent_2 extends Handle_IGESSolid_SelectedComponent {
    constructor(thePtr: IGESSolid_SelectedComponent);
  }

  export declare class Handle_IGESSolid_SelectedComponent_3 extends Handle_IGESSolid_SelectedComponent {
    constructor(theHandle: Handle_IGESSolid_SelectedComponent);
  }

  export declare class Handle_IGESSolid_SelectedComponent_4 extends Handle_IGESSolid_SelectedComponent {
    constructor(theHandle: Handle_IGESSolid_SelectedComponent);
  }

export declare class IGESSolid {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESSolid_Protocol;
  delete(): void;
}

export declare class IGESSolid_ToolSelectedComponent {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_SelectedComponent, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_SelectedComponent, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_SelectedComponent, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_SelectedComponent): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_SelectedComponent, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_SelectedComponent, entto: Handle_IGESSolid_SelectedComponent, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_SelectedComponent, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_SolidAssembly extends IGESData_IGESEntity {
  constructor()
  Init(allItems: Handle_IGESData_HArray1OfIGESEntity, allMatrices: Handle_IGESGeom_HArray1OfTransformationMatrix): void;
  HasBrep(): Standard_Boolean;
  SetBrep(hasbrep: Standard_Boolean): void;
  NbItems(): Graphic3d_ZLayerId;
  Item(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  TransfMatrix(Index: Graphic3d_ZLayerId): Handle_IGESGeom_TransformationMatrix;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_SolidAssembly {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SolidAssembly): void;
  get(): IGESSolid_SolidAssembly;
  delete(): void;
}

  export declare class Handle_IGESSolid_SolidAssembly_1 extends Handle_IGESSolid_SolidAssembly {
    constructor();
  }

  export declare class Handle_IGESSolid_SolidAssembly_2 extends Handle_IGESSolid_SolidAssembly {
    constructor(thePtr: IGESSolid_SolidAssembly);
  }

  export declare class Handle_IGESSolid_SolidAssembly_3 extends Handle_IGESSolid_SolidAssembly {
    constructor(theHandle: Handle_IGESSolid_SolidAssembly);
  }

  export declare class Handle_IGESSolid_SolidAssembly_4 extends Handle_IGESSolid_SolidAssembly {
    constructor(theHandle: Handle_IGESSolid_SolidAssembly);
  }

export declare class IGESSolid_ToolSolidOfRevolution {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_SolidOfRevolution, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_SolidOfRevolution, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_SolidOfRevolution, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_SolidOfRevolution): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_SolidOfRevolution, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_SolidOfRevolution, entto: Handle_IGESSolid_SolidOfRevolution, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_SolidOfRevolution, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolRightAngularWedge {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_RightAngularWedge, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_RightAngularWedge, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_RightAngularWedge, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_RightAngularWedge): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_RightAngularWedge, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_RightAngularWedge, entto: Handle_IGESSolid_RightAngularWedge, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_RightAngularWedge, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SpecificModule): void;
  get(): IGESSolid_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESSolid_SpecificModule_1 extends Handle_IGESSolid_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESSolid_SpecificModule_2 extends Handle_IGESSolid_SpecificModule {
    constructor(thePtr: IGESSolid_SpecificModule);
  }

  export declare class Handle_IGESSolid_SpecificModule_3 extends Handle_IGESSolid_SpecificModule {
    constructor(theHandle: Handle_IGESSolid_SpecificModule);
  }

  export declare class Handle_IGESSolid_SpecificModule_4 extends Handle_IGESSolid_SpecificModule {
    constructor(theHandle: Handle_IGESSolid_SpecificModule);
  }

export declare class IGESSolid_CylindricalSurface extends IGESData_IGESEntity {
  constructor()
  Init(aLocation: Handle_IGESGeom_Point, anAxis: Handle_IGESGeom_Direction, aRadius: Quantity_AbsorbedDose, aRefdir: Handle_IGESGeom_Direction): void;
  LocationPoint(): Handle_IGESGeom_Point;
  Axis(): Handle_IGESGeom_Direction;
  Radius(): Quantity_AbsorbedDose;
  IsParametrised(): Standard_Boolean;
  ReferenceDir(): Handle_IGESGeom_Direction;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_CylindricalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_CylindricalSurface): void;
  get(): IGESSolid_CylindricalSurface;
  delete(): void;
}

  export declare class Handle_IGESSolid_CylindricalSurface_1 extends Handle_IGESSolid_CylindricalSurface {
    constructor();
  }

  export declare class Handle_IGESSolid_CylindricalSurface_2 extends Handle_IGESSolid_CylindricalSurface {
    constructor(thePtr: IGESSolid_CylindricalSurface);
  }

  export declare class Handle_IGESSolid_CylindricalSurface_3 extends Handle_IGESSolid_CylindricalSurface {
    constructor(theHandle: Handle_IGESSolid_CylindricalSurface);
  }

  export declare class Handle_IGESSolid_CylindricalSurface_4 extends Handle_IGESSolid_CylindricalSurface {
    constructor(theHandle: Handle_IGESSolid_CylindricalSurface);
  }

export declare class IGESSolid_BooleanTree extends IGESData_IGESEntity {
  constructor()
  Init(operands: Handle_IGESData_HArray1OfIGESEntity, operations: Handle_TColStd_HArray1OfInteger): void;
  Length(): Graphic3d_ZLayerId;
  IsOperand(Index: Graphic3d_ZLayerId): Standard_Boolean;
  Operand(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  Operation(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_BooleanTree {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_BooleanTree): void;
  get(): IGESSolid_BooleanTree;
  delete(): void;
}

  export declare class Handle_IGESSolid_BooleanTree_1 extends Handle_IGESSolid_BooleanTree {
    constructor();
  }

  export declare class Handle_IGESSolid_BooleanTree_2 extends Handle_IGESSolid_BooleanTree {
    constructor(thePtr: IGESSolid_BooleanTree);
  }

  export declare class Handle_IGESSolid_BooleanTree_3 extends Handle_IGESSolid_BooleanTree {
    constructor(theHandle: Handle_IGESSolid_BooleanTree);
  }

  export declare class Handle_IGESSolid_BooleanTree_4 extends Handle_IGESSolid_BooleanTree {
    constructor(theHandle: Handle_IGESSolid_BooleanTree);
  }

export declare class IGESSolid_ToolManifoldSolid {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_ManifoldSolid, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_ManifoldSolid, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_ManifoldSolid, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_ManifoldSolid): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_ManifoldSolid, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_ManifoldSolid, entto: Handle_IGESSolid_ManifoldSolid, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_ManifoldSolid, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_ConicalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_ConicalSurface): void;
  get(): IGESSolid_ConicalSurface;
  delete(): void;
}

  export declare class Handle_IGESSolid_ConicalSurface_1 extends Handle_IGESSolid_ConicalSurface {
    constructor();
  }

  export declare class Handle_IGESSolid_ConicalSurface_2 extends Handle_IGESSolid_ConicalSurface {
    constructor(thePtr: IGESSolid_ConicalSurface);
  }

  export declare class Handle_IGESSolid_ConicalSurface_3 extends Handle_IGESSolid_ConicalSurface {
    constructor(theHandle: Handle_IGESSolid_ConicalSurface);
  }

  export declare class Handle_IGESSolid_ConicalSurface_4 extends Handle_IGESSolid_ConicalSurface {
    constructor(theHandle: Handle_IGESSolid_ConicalSurface);
  }

export declare class IGESSolid_ConicalSurface extends IGESData_IGESEntity {
  constructor()
  Init(aLocation: Handle_IGESGeom_Point, anAxis: Handle_IGESGeom_Direction, aRadius: Quantity_AbsorbedDose, anAngle: Quantity_AbsorbedDose, aRefdir: Handle_IGESGeom_Direction): void;
  LocationPoint(): Handle_IGESGeom_Point;
  Axis(): Handle_IGESGeom_Direction;
  Radius(): Quantity_AbsorbedDose;
  SemiAngle(): Quantity_AbsorbedDose;
  ReferenceDir(): Handle_IGESGeom_Direction;
  IsParametrised(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_ToolSolidAssembly {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_SolidAssembly, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_SolidAssembly, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_SolidAssembly, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_SolidAssembly): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_SolidAssembly, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_SolidAssembly, entto: Handle_IGESSolid_SolidAssembly, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_SolidAssembly, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolBooleanTree {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_BooleanTree, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_BooleanTree, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_BooleanTree, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_BooleanTree): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_BooleanTree, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_BooleanTree, entto: Handle_IGESSolid_BooleanTree, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_BooleanTree, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolPlaneSurface {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_PlaneSurface, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_PlaneSurface, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_PlaneSurface, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_PlaneSurface): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_PlaneSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_PlaneSurface, entto: Handle_IGESSolid_PlaneSurface, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_PlaneSurface, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_RightAngularWedge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_RightAngularWedge): void;
  get(): IGESSolid_RightAngularWedge;
  delete(): void;
}

  export declare class Handle_IGESSolid_RightAngularWedge_1 extends Handle_IGESSolid_RightAngularWedge {
    constructor();
  }

  export declare class Handle_IGESSolid_RightAngularWedge_2 extends Handle_IGESSolid_RightAngularWedge {
    constructor(thePtr: IGESSolid_RightAngularWedge);
  }

  export declare class Handle_IGESSolid_RightAngularWedge_3 extends Handle_IGESSolid_RightAngularWedge {
    constructor(theHandle: Handle_IGESSolid_RightAngularWedge);
  }

  export declare class Handle_IGESSolid_RightAngularWedge_4 extends Handle_IGESSolid_RightAngularWedge {
    constructor(theHandle: Handle_IGESSolid_RightAngularWedge);
  }

export declare class IGESSolid_RightAngularWedge extends IGESData_IGESEntity {
  constructor()
  Init(aSize: gp_XYZ, lowX: Quantity_AbsorbedDose, aCorner: gp_XYZ, anXAxis: gp_XYZ, anZAxis: gp_XYZ): void;
  Size(): gp_XYZ;
  XBigLength(): Quantity_AbsorbedDose;
  XSmallLength(): Quantity_AbsorbedDose;
  YLength(): Quantity_AbsorbedDose;
  ZLength(): Quantity_AbsorbedDose;
  Corner(): gp_Pnt;
  TransformedCorner(): gp_Pnt;
  XAxis(): gp_Dir;
  TransformedXAxis(): gp_Dir;
  YAxis(): gp_Dir;
  TransformedYAxis(): gp_Dir;
  ZAxis(): gp_Dir;
  TransformedZAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_Sphere {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Sphere): void;
  get(): IGESSolid_Sphere;
  delete(): void;
}

  export declare class Handle_IGESSolid_Sphere_1 extends Handle_IGESSolid_Sphere {
    constructor();
  }

  export declare class Handle_IGESSolid_Sphere_2 extends Handle_IGESSolid_Sphere {
    constructor(thePtr: IGESSolid_Sphere);
  }

  export declare class Handle_IGESSolid_Sphere_3 extends Handle_IGESSolid_Sphere {
    constructor(theHandle: Handle_IGESSolid_Sphere);
  }

  export declare class Handle_IGESSolid_Sphere_4 extends Handle_IGESSolid_Sphere {
    constructor(theHandle: Handle_IGESSolid_Sphere);
  }

export declare class IGESSolid_Sphere extends IGESData_IGESEntity {
  constructor()
  Init(aRadius: Quantity_AbsorbedDose, aCenter: gp_XYZ): void;
  Radius(): Quantity_AbsorbedDose;
  Center(): gp_Pnt;
  TransformedCenter(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_ReadWriteModule): void;
  get(): IGESSolid_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESSolid_ReadWriteModule_1 extends Handle_IGESSolid_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESSolid_ReadWriteModule_2 extends Handle_IGESSolid_ReadWriteModule {
    constructor(thePtr: IGESSolid_ReadWriteModule);
  }

  export declare class Handle_IGESSolid_ReadWriteModule_3 extends Handle_IGESSolid_ReadWriteModule {
    constructor(theHandle: Handle_IGESSolid_ReadWriteModule);
  }

  export declare class Handle_IGESSolid_ReadWriteModule_4 extends Handle_IGESSolid_ReadWriteModule {
    constructor(theHandle: Handle_IGESSolid_ReadWriteModule);
  }

export declare class IGESSolid_ConeFrustum extends IGESData_IGESEntity {
  constructor()
  Init(Ht: Quantity_AbsorbedDose, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, Center: gp_XYZ, anAxis: gp_XYZ): void;
  Height(): Quantity_AbsorbedDose;
  LargerRadius(): Quantity_AbsorbedDose;
  SmallerRadius(): Quantity_AbsorbedDose;
  FaceCenter(): gp_Pnt;
  TransformedFaceCenter(): gp_Pnt;
  Axis(): gp_Dir;
  TransformedAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_ConeFrustum {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_ConeFrustum): void;
  get(): IGESSolid_ConeFrustum;
  delete(): void;
}

  export declare class Handle_IGESSolid_ConeFrustum_1 extends Handle_IGESSolid_ConeFrustum {
    constructor();
  }

  export declare class Handle_IGESSolid_ConeFrustum_2 extends Handle_IGESSolid_ConeFrustum {
    constructor(thePtr: IGESSolid_ConeFrustum);
  }

  export declare class Handle_IGESSolid_ConeFrustum_3 extends Handle_IGESSolid_ConeFrustum {
    constructor(theHandle: Handle_IGESSolid_ConeFrustum);
  }

  export declare class Handle_IGESSolid_ConeFrustum_4 extends Handle_IGESSolid_ConeFrustum {
    constructor(theHandle: Handle_IGESSolid_ConeFrustum);
  }

export declare class IGESSolid_Torus extends IGESData_IGESEntity {
  constructor()
  Init(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, aPoint: gp_XYZ, anAxisdir: gp_XYZ): void;
  MajorRadius(): Quantity_AbsorbedDose;
  DiscRadius(): Quantity_AbsorbedDose;
  AxisPoint(): gp_Pnt;
  TransformedAxisPoint(): gp_Pnt;
  Axis(): gp_Dir;
  TransformedAxis(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_Torus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_Torus): void;
  get(): IGESSolid_Torus;
  delete(): void;
}

  export declare class Handle_IGESSolid_Torus_1 extends Handle_IGESSolid_Torus {
    constructor();
  }

  export declare class Handle_IGESSolid_Torus_2 extends Handle_IGESSolid_Torus {
    constructor(thePtr: IGESSolid_Torus);
  }

  export declare class Handle_IGESSolid_Torus_3 extends Handle_IGESSolid_Torus {
    constructor(theHandle: Handle_IGESSolid_Torus);
  }

  export declare class Handle_IGESSolid_Torus_4 extends Handle_IGESSolid_Torus {
    constructor(theHandle: Handle_IGESSolid_Torus);
  }

export declare class IGESSolid_VertexList extends IGESData_IGESEntity {
  constructor()
  Init(vertices: Handle_TColgp_HArray1OfXYZ): void;
  NbVertices(): Graphic3d_ZLayerId;
  Vertex(num: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_VertexList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_VertexList): void;
  get(): IGESSolid_VertexList;
  delete(): void;
}

  export declare class Handle_IGESSolid_VertexList_1 extends Handle_IGESSolid_VertexList {
    constructor();
  }

  export declare class Handle_IGESSolid_VertexList_2 extends Handle_IGESSolid_VertexList {
    constructor(thePtr: IGESSolid_VertexList);
  }

  export declare class Handle_IGESSolid_VertexList_3 extends Handle_IGESSolid_VertexList {
    constructor(theHandle: Handle_IGESSolid_VertexList);
  }

  export declare class Handle_IGESSolid_VertexList_4 extends Handle_IGESSolid_VertexList {
    constructor(theHandle: Handle_IGESSolid_VertexList);
  }

export declare class IGESSolid_ToolCylinder {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Cylinder, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Cylinder, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Cylinder, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Cylinder): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Cylinder, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Cylinder, entto: Handle_IGESSolid_Cylinder, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Cylinder, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_HArray1OfLoop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_HArray1OfLoop): void;
  get(): IGESSolid_HArray1OfLoop;
  delete(): void;
}

  export declare class Handle_IGESSolid_HArray1OfLoop_1 extends Handle_IGESSolid_HArray1OfLoop {
    constructor();
  }

  export declare class Handle_IGESSolid_HArray1OfLoop_2 extends Handle_IGESSolid_HArray1OfLoop {
    constructor(thePtr: IGESSolid_HArray1OfLoop);
  }

  export declare class Handle_IGESSolid_HArray1OfLoop_3 extends Handle_IGESSolid_HArray1OfLoop {
    constructor(theHandle: Handle_IGESSolid_HArray1OfLoop);
  }

  export declare class Handle_IGESSolid_HArray1OfLoop_4 extends Handle_IGESSolid_HArray1OfLoop {
    constructor(theHandle: Handle_IGESSolid_HArray1OfLoop);
  }

export declare class IGESSolid_EdgeList extends IGESData_IGESEntity {
  constructor()
  Init(curves: Handle_IGESData_HArray1OfIGESEntity, startVertexList: Handle_IGESSolid_HArray1OfVertexList, startVertexIndex: Handle_TColStd_HArray1OfInteger, endVertexList: Handle_IGESSolid_HArray1OfVertexList, endVertexIndex: Handle_TColStd_HArray1OfInteger): void;
  NbEdges(): Graphic3d_ZLayerId;
  Curve(num: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  StartVertexList(num: Graphic3d_ZLayerId): Handle_IGESSolid_VertexList;
  StartVertexIndex(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  EndVertexList(num: Graphic3d_ZLayerId): Handle_IGESSolid_VertexList;
  EndVertexIndex(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_EdgeList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_EdgeList): void;
  get(): IGESSolid_EdgeList;
  delete(): void;
}

  export declare class Handle_IGESSolid_EdgeList_1 extends Handle_IGESSolid_EdgeList {
    constructor();
  }

  export declare class Handle_IGESSolid_EdgeList_2 extends Handle_IGESSolid_EdgeList {
    constructor(thePtr: IGESSolid_EdgeList);
  }

  export declare class Handle_IGESSolid_EdgeList_3 extends Handle_IGESSolid_EdgeList {
    constructor(theHandle: Handle_IGESSolid_EdgeList);
  }

  export declare class Handle_IGESSolid_EdgeList_4 extends Handle_IGESSolid_EdgeList {
    constructor(theHandle: Handle_IGESSolid_EdgeList);
  }

export declare class IGESSolid_ToolConeFrustum {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_ConeFrustum, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_ConeFrustum, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_ConeFrustum, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_ConeFrustum): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_ConeFrustum, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_ConeFrustum, entto: Handle_IGESSolid_ConeFrustum, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_ConeFrustum, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_SphericalSurface extends IGESData_IGESEntity {
  constructor()
  Init(aCenter: Handle_IGESGeom_Point, aRadius: Quantity_AbsorbedDose, anAxis: Handle_IGESGeom_Direction, aRefdir: Handle_IGESGeom_Direction): void;
  Center(): Handle_IGESGeom_Point;
  TransformedCenter(): gp_Pnt;
  Radius(): Quantity_AbsorbedDose;
  Axis(): Handle_IGESGeom_Direction;
  ReferenceDir(): Handle_IGESGeom_Direction;
  IsParametrised(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESSolid_SphericalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SphericalSurface): void;
  get(): IGESSolid_SphericalSurface;
  delete(): void;
}

  export declare class Handle_IGESSolid_SphericalSurface_1 extends Handle_IGESSolid_SphericalSurface {
    constructor();
  }

  export declare class Handle_IGESSolid_SphericalSurface_2 extends Handle_IGESSolid_SphericalSurface {
    constructor(thePtr: IGESSolid_SphericalSurface);
  }

  export declare class Handle_IGESSolid_SphericalSurface_3 extends Handle_IGESSolid_SphericalSurface {
    constructor(theHandle: Handle_IGESSolid_SphericalSurface);
  }

  export declare class Handle_IGESSolid_SphericalSurface_4 extends Handle_IGESSolid_SphericalSurface {
    constructor(theHandle: Handle_IGESSolid_SphericalSurface);
  }

export declare class IGESSolid_TopoBuilder {
  constructor()
  Clear(): void;
  AddVertex(val: gp_XYZ): void;
  NbVertices(): Graphic3d_ZLayerId;
  Vertex(num: Graphic3d_ZLayerId): gp_XYZ;
  VertexList(): Handle_IGESSolid_VertexList;
  AddEdge(curve: Handle_IGESData_IGESEntity, vstart: Graphic3d_ZLayerId, vend: Graphic3d_ZLayerId): void;
  NbEdges(): Graphic3d_ZLayerId;
  Edge(num: Graphic3d_ZLayerId, curve: Handle_IGESData_IGESEntity, vstart: Graphic3d_ZLayerId, vend: Graphic3d_ZLayerId): void;
  EdgeList(): Handle_IGESSolid_EdgeList;
  MakeLoop(): void;
  MakeEdge(edgetype: Graphic3d_ZLayerId, edge3d: Graphic3d_ZLayerId, orientation: Graphic3d_ZLayerId): void;
  AddCurveUV(curve: Handle_IGESData_IGESEntity, iso: Graphic3d_ZLayerId): void;
  EndEdge(): void;
  MakeFace(surface: Handle_IGESData_IGESEntity): void;
  SetOuter(): void;
  AddInner(): void;
  EndFace(orientation: Graphic3d_ZLayerId): void;
  MakeShell(): void;
  EndSimpleShell(): void;
  SetMainShell(orientation: Graphic3d_ZLayerId): void;
  AddVoidShell(orientation: Graphic3d_ZLayerId): void;
  EndSolid(): void;
  Shell(): Handle_IGESSolid_Shell;
  Solid(): Handle_IGESSolid_ManifoldSolid;
  delete(): void;
}

export declare class Handle_IGESSolid_HArray1OfShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_HArray1OfShell): void;
  get(): IGESSolid_HArray1OfShell;
  delete(): void;
}

  export declare class Handle_IGESSolid_HArray1OfShell_1 extends Handle_IGESSolid_HArray1OfShell {
    constructor();
  }

  export declare class Handle_IGESSolid_HArray1OfShell_2 extends Handle_IGESSolid_HArray1OfShell {
    constructor(thePtr: IGESSolid_HArray1OfShell);
  }

  export declare class Handle_IGESSolid_HArray1OfShell_3 extends Handle_IGESSolid_HArray1OfShell {
    constructor(theHandle: Handle_IGESSolid_HArray1OfShell);
  }

  export declare class Handle_IGESSolid_HArray1OfShell_4 extends Handle_IGESSolid_HArray1OfShell {
    constructor(theHandle: Handle_IGESSolid_HArray1OfShell);
  }

export declare class Handle_IGESSolid_HArray1OfVertexList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_HArray1OfVertexList): void;
  get(): IGESSolid_HArray1OfVertexList;
  delete(): void;
}

  export declare class Handle_IGESSolid_HArray1OfVertexList_1 extends Handle_IGESSolid_HArray1OfVertexList {
    constructor();
  }

  export declare class Handle_IGESSolid_HArray1OfVertexList_2 extends Handle_IGESSolid_HArray1OfVertexList {
    constructor(thePtr: IGESSolid_HArray1OfVertexList);
  }

  export declare class Handle_IGESSolid_HArray1OfVertexList_3 extends Handle_IGESSolid_HArray1OfVertexList {
    constructor(theHandle: Handle_IGESSolid_HArray1OfVertexList);
  }

  export declare class Handle_IGESSolid_HArray1OfVertexList_4 extends Handle_IGESSolid_HArray1OfVertexList {
    constructor(theHandle: Handle_IGESSolid_HArray1OfVertexList);
  }

export declare class IGESSolid_ToolSphere {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Sphere, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Sphere, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Sphere, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Sphere): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Sphere, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Sphere, entto: Handle_IGESSolid_Sphere, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Sphere, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESSolid_ToolTorus {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_Torus, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_Torus, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_Torus, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_Torus): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_Torus, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_Torus, entto: Handle_IGESSolid_Torus, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_Torus, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESSolid_SolidOfLinearExtrusion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESSolid_SolidOfLinearExtrusion): void;
  get(): IGESSolid_SolidOfLinearExtrusion;
  delete(): void;
}

  export declare class Handle_IGESSolid_SolidOfLinearExtrusion_1 extends Handle_IGESSolid_SolidOfLinearExtrusion {
    constructor();
  }

  export declare class Handle_IGESSolid_SolidOfLinearExtrusion_2 extends Handle_IGESSolid_SolidOfLinearExtrusion {
    constructor(thePtr: IGESSolid_SolidOfLinearExtrusion);
  }

  export declare class Handle_IGESSolid_SolidOfLinearExtrusion_3 extends Handle_IGESSolid_SolidOfLinearExtrusion {
    constructor(theHandle: Handle_IGESSolid_SolidOfLinearExtrusion);
  }

  export declare class Handle_IGESSolid_SolidOfLinearExtrusion_4 extends Handle_IGESSolid_SolidOfLinearExtrusion {
    constructor(theHandle: Handle_IGESSolid_SolidOfLinearExtrusion);
  }

export declare class IGESSolid_SolidOfLinearExtrusion extends IGESData_IGESEntity {
  constructor()
  Init(aCurve: Handle_IGESData_IGESEntity, aLength: Quantity_AbsorbedDose, aDirection: gp_XYZ): void;
  Curve(): Handle_IGESData_IGESEntity;
  ExtrusionLength(): Quantity_AbsorbedDose;
  ExtrusionDirection(): gp_Dir;
  TransformedExtrusionDirection(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESSolid_ToolSolidInstance {
  constructor()
  ReadOwnParams(ent: Handle_IGESSolid_SolidInstance, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESSolid_SolidInstance, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESSolid_SolidInstance, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESSolid_SolidInstance): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESSolid_SolidInstance, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESSolid_SolidInstance, entto: Handle_IGESSolid_SolidInstance, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESSolid_SolidInstance, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BRepPreviewAPI_MakeBox extends BRepPrimAPI_MakeBox {
  constructor()
  Build(): void;
  delete(): void;
}

export declare class LocOpe_CurveShapeIntersector {
  Init_1(Axis: gp_Ax1, S: TopoDS_Shape): void;
  Init_2(C: gp_Circ, S: TopoDS_Shape): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): LocOpe_PntFace;
  LocalizeAfter_1(From: Quantity_AbsorbedDose, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  LocalizeBefore_1(From: Quantity_AbsorbedDose, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  LocalizeAfter_2(FromInd: Graphic3d_ZLayerId, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  LocalizeBefore_2(FromInd: Graphic3d_ZLayerId, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class LocOpe_CurveShapeIntersector_1 extends LocOpe_CurveShapeIntersector {
    constructor();
  }

  export declare class LocOpe_CurveShapeIntersector_2 extends LocOpe_CurveShapeIntersector {
    constructor(Axis: gp_Ax1, S: TopoDS_Shape);
  }

  export declare class LocOpe_CurveShapeIntersector_3 extends LocOpe_CurveShapeIntersector {
    constructor(C: gp_Circ, S: TopoDS_Shape);
  }

export declare class LocOpe_Generator {
  Init(S: TopoDS_Shape): void;
  Perform(G: Handle_LocOpe_GeneratedShape): void;
  IsDone(): Standard_Boolean;
  ResultingShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  DescendantFace(F: TopoDS_Face): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_Generator_1 extends LocOpe_Generator {
    constructor();
  }

  export declare class LocOpe_Generator_2 extends LocOpe_Generator {
    constructor(S: TopoDS_Shape);
  }

export declare class LocOpe_SequenceOfLin extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: LocOpe_SequenceOfLin): LocOpe_SequenceOfLin;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Lin): void;
  Append_2(theSeq: LocOpe_SequenceOfLin): void;
  Prepend_1(theItem: gp_Lin): void;
  Prepend_2(theSeq: LocOpe_SequenceOfLin): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Lin): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfLin): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfLin): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Lin): void;
  Split(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfLin): void;
  First(): gp_Lin;
  ChangeFirst(): gp_Lin;
  Last(): gp_Lin;
  ChangeLast(): gp_Lin;
  Value(theIndex: Standard_Integer): gp_Lin;
  ChangeValue(theIndex: Standard_Integer): gp_Lin;
  SetValue(theIndex: Standard_Integer, theItem: gp_Lin): void;
  delete(): void;
}

  export declare class LocOpe_SequenceOfLin_1 extends LocOpe_SequenceOfLin {
    constructor();
  }

  export declare class LocOpe_SequenceOfLin_2 extends LocOpe_SequenceOfLin {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class LocOpe_SequenceOfLin_3 extends LocOpe_SequenceOfLin {
    constructor(theOther: LocOpe_SequenceOfLin);
  }

export declare class Handle_LocOpe_GeneratedShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: LocOpe_GeneratedShape): void;
  get(): LocOpe_GeneratedShape;
  delete(): void;
}

  export declare class Handle_LocOpe_GeneratedShape_1 extends Handle_LocOpe_GeneratedShape {
    constructor();
  }

  export declare class Handle_LocOpe_GeneratedShape_2 extends Handle_LocOpe_GeneratedShape {
    constructor(thePtr: LocOpe_GeneratedShape);
  }

  export declare class Handle_LocOpe_GeneratedShape_3 extends Handle_LocOpe_GeneratedShape {
    constructor(theHandle: Handle_LocOpe_GeneratedShape);
  }

  export declare class Handle_LocOpe_GeneratedShape_4 extends Handle_LocOpe_GeneratedShape {
    constructor(theHandle: Handle_LocOpe_GeneratedShape);
  }

export declare class LocOpe_GeneratedShape extends Standard_Transient {
  GeneratingEdges(): TopTools_ListOfShape;
  Generated_1(V: TopoDS_Vertex): TopoDS_Edge;
  Generated_2(E: TopoDS_Edge): TopoDS_Face;
  OrientedFaces(): TopTools_ListOfShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class LocOpe_Gluer {
  Init(Sbase: TopoDS_Shape, Snew: TopoDS_Shape): void;
  Bind_1(Fnew: TopoDS_Face, Fbase: TopoDS_Face): void;
  Bind_2(Enew: TopoDS_Edge, Ebase: TopoDS_Edge): void;
  OpeType(): LocOpe_Operation;
  Perform(): void;
  IsDone(): Standard_Boolean;
  ResultingShape(): TopoDS_Shape;
  DescendantFaces(F: TopoDS_Face): TopTools_ListOfShape;
  BasisShape(): TopoDS_Shape;
  GluedShape(): TopoDS_Shape;
  Edges(): TopTools_ListOfShape;
  TgtEdges(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_Gluer_1 extends LocOpe_Gluer {
    constructor();
  }

  export declare class LocOpe_Gluer_2 extends LocOpe_Gluer {
    constructor(Sbase: TopoDS_Shape, Snew: TopoDS_Shape);
  }

export declare class LocOpe_Prism {
  Perform_1(Base: TopoDS_Shape, V: gp_Vec): void;
  Perform_2(Base: TopoDS_Shape, V: gp_Vec, Vtra: gp_Vec): void;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  Shapes(S: TopoDS_Shape): TopTools_ListOfShape;
  Curves(SCurves: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  delete(): void;
}

  export declare class LocOpe_Prism_1 extends LocOpe_Prism {
    constructor();
  }

  export declare class LocOpe_Prism_2 extends LocOpe_Prism {
    constructor(Base: TopoDS_Shape, V: gp_Vec);
  }

  export declare class LocOpe_Prism_3 extends LocOpe_Prism {
    constructor(Base: TopoDS_Shape, V: gp_Vec, Vectra: gp_Vec);
  }

export declare class LocOpe_BuildWires {
  Perform(Ledges: TopTools_ListOfShape, PW: Handle_LocOpe_WiresOnShape): void;
  IsDone(): Standard_Boolean;
  Result(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_BuildWires_1 extends LocOpe_BuildWires {
    constructor();
  }

  export declare class LocOpe_BuildWires_2 extends LocOpe_BuildWires {
    constructor(Ledges: TopTools_ListOfShape, PW: Handle_LocOpe_WiresOnShape);
  }

export declare class LocOpe {
  constructor();
  static Closed_1(W: TopoDS_Wire, OnF: TopoDS_Face): Standard_Boolean;
  static Closed_2(E: TopoDS_Edge, OnF: TopoDS_Face): Standard_Boolean;
  static TgtFaces(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face): Standard_Boolean;
  static SampleEdges(S: TopoDS_Shape, Pt: TColgp_SequenceOfPnt): void;
  delete(): void;
}

export declare class LocOpe_PntFace {
  Pnt(): gp_Pnt;
  Face(): TopoDS_Face;
  Orientation(): TopAbs_Orientation;
  ChangeOrientation(): TopAbs_Orientation;
  Parameter(): Quantity_AbsorbedDose;
  UParameter(): Quantity_AbsorbedDose;
  VParameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class LocOpe_PntFace_1 extends LocOpe_PntFace {
    constructor();
  }

  export declare class LocOpe_PntFace_2 extends LocOpe_PntFace {
    constructor(P: gp_Pnt, F: TopoDS_Face, Or: TopAbs_Orientation, Param: Quantity_AbsorbedDose, UPar: Quantity_AbsorbedDose, VPar: Quantity_AbsorbedDose);
  }

export declare class LocOpe_SequenceOfPntFace extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: LocOpe_SequenceOfPntFace): LocOpe_SequenceOfPntFace;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: LocOpe_PntFace): void;
  Append_2(theSeq: LocOpe_SequenceOfPntFace): void;
  Prepend_1(theItem: LocOpe_PntFace): void;
  Prepend_2(theSeq: LocOpe_SequenceOfPntFace): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: LocOpe_PntFace): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfPntFace): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfPntFace): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: LocOpe_PntFace): void;
  Split(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfPntFace): void;
  First(): LocOpe_PntFace;
  ChangeFirst(): LocOpe_PntFace;
  Last(): LocOpe_PntFace;
  ChangeLast(): LocOpe_PntFace;
  Value(theIndex: Standard_Integer): LocOpe_PntFace;
  ChangeValue(theIndex: Standard_Integer): LocOpe_PntFace;
  SetValue(theIndex: Standard_Integer, theItem: LocOpe_PntFace): void;
  delete(): void;
}

  export declare class LocOpe_SequenceOfPntFace_1 extends LocOpe_SequenceOfPntFace {
    constructor();
  }

  export declare class LocOpe_SequenceOfPntFace_2 extends LocOpe_SequenceOfPntFace {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class LocOpe_SequenceOfPntFace_3 extends LocOpe_SequenceOfPntFace {
    constructor(theOther: LocOpe_SequenceOfPntFace);
  }

export declare class LocOpe_GluedShape extends LocOpe_GeneratedShape {
  Init(S: TopoDS_Shape): void;
  GlueOnFace(F: TopoDS_Face): void;
  GeneratingEdges(): TopTools_ListOfShape;
  Generated_1(V: TopoDS_Vertex): TopoDS_Edge;
  Generated_2(E: TopoDS_Edge): TopoDS_Face;
  OrientedFaces(): TopTools_ListOfShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class LocOpe_GluedShape_1 extends LocOpe_GluedShape {
    constructor();
  }

  export declare class LocOpe_GluedShape_2 extends LocOpe_GluedShape {
    constructor(S: TopoDS_Shape);
  }

export declare class Handle_LocOpe_GluedShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: LocOpe_GluedShape): void;
  get(): LocOpe_GluedShape;
  delete(): void;
}

  export declare class Handle_LocOpe_GluedShape_1 extends Handle_LocOpe_GluedShape {
    constructor();
  }

  export declare class Handle_LocOpe_GluedShape_2 extends Handle_LocOpe_GluedShape {
    constructor(thePtr: LocOpe_GluedShape);
  }

  export declare class Handle_LocOpe_GluedShape_3 extends Handle_LocOpe_GluedShape {
    constructor(theHandle: Handle_LocOpe_GluedShape);
  }

  export declare class Handle_LocOpe_GluedShape_4 extends Handle_LocOpe_GluedShape {
    constructor(theHandle: Handle_LocOpe_GluedShape);
  }

export declare class LocOpe_SplitShape {
  Init(S: TopoDS_Shape): void;
  CanSplit(E: TopoDS_Edge): Standard_Boolean;
  Add_1(V: TopoDS_Vertex, P: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  Add_2(W: TopoDS_Wire, F: TopoDS_Face): Standard_Boolean;
  Add_3(Lwires: TopTools_ListOfShape, F: TopoDS_Face): Standard_Boolean;
  Shape(): TopoDS_Shape;
  DescendantShapes(S: TopoDS_Shape): TopTools_ListOfShape;
  LeftOf(W: TopoDS_Wire, F: TopoDS_Face): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_SplitShape_1 extends LocOpe_SplitShape {
    constructor();
  }

  export declare class LocOpe_SplitShape_2 extends LocOpe_SplitShape {
    constructor(S: TopoDS_Shape);
  }

export declare class LocOpe_Pipe {
  constructor(Spine: TopoDS_Wire, Profile: TopoDS_Shape)
  Spine(): TopoDS_Shape;
  Profile(): TopoDS_Shape;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  Shapes(S: TopoDS_Shape): TopTools_ListOfShape;
  Curves(Spt: TColgp_SequenceOfPnt): TColGeom_SequenceOfCurve;
  BarycCurve(): Handle_Geom_Curve;
  delete(): void;
}

export declare class LocOpe_Spliter {
  Init(S: TopoDS_Shape): void;
  Perform(PW: Handle_LocOpe_WiresOnShape): void;
  IsDone(): Standard_Boolean;
  ResultingShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  DirectLeft(): TopTools_ListOfShape;
  Left(): TopTools_ListOfShape;
  DescendantShapes(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_Spliter_1 extends LocOpe_Spliter {
    constructor();
  }

  export declare class LocOpe_Spliter_2 extends LocOpe_Spliter {
    constructor(S: TopoDS_Shape);
  }

export declare class LocOpe_LinearForm {
  Perform_1(Base: TopoDS_Shape, V: gp_Vec, Pnt1: gp_Pnt, Pnt2: gp_Pnt): void;
  Perform_2(Base: TopoDS_Shape, V: gp_Vec, Vectra: gp_Vec, Pnt1: gp_Pnt, Pnt2: gp_Pnt): void;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  Shapes(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_LinearForm_1 extends LocOpe_LinearForm {
    constructor();
  }

  export declare class LocOpe_LinearForm_2 extends LocOpe_LinearForm {
    constructor(Base: TopoDS_Shape, V: gp_Vec, Pnt1: gp_Pnt, Pnt2: gp_Pnt);
  }

  export declare class LocOpe_LinearForm_3 extends LocOpe_LinearForm {
    constructor(Base: TopoDS_Shape, V: gp_Vec, Vectra: gp_Vec, Pnt1: gp_Pnt, Pnt2: gp_Pnt);
  }

export declare class LocOpe_SplitDrafts {
  Init(S: TopoDS_Shape): void;
  Perform_1(F: TopoDS_Face, W: TopoDS_Wire, Extractg: gp_Dir, NPlg: gp_Pln, Angleg: Quantity_AbsorbedDose, Extractd: gp_Dir, NPld: gp_Pln, Angled: Quantity_AbsorbedDose, ModifyLeft: Standard_Boolean, ModifyRight: Standard_Boolean): void;
  Perform_2(F: TopoDS_Face, W: TopoDS_Wire, Extract: gp_Dir, NPl: gp_Pln, Angle: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  OriginalShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  ShapesFromShape(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class LocOpe_SplitDrafts_1 extends LocOpe_SplitDrafts {
    constructor();
  }

  export declare class LocOpe_SplitDrafts_2 extends LocOpe_SplitDrafts {
    constructor(S: TopoDS_Shape);
  }

export declare class Handle_LocOpe_WiresOnShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: LocOpe_WiresOnShape): void;
  get(): LocOpe_WiresOnShape;
  delete(): void;
}

  export declare class Handle_LocOpe_WiresOnShape_1 extends Handle_LocOpe_WiresOnShape {
    constructor();
  }

  export declare class Handle_LocOpe_WiresOnShape_2 extends Handle_LocOpe_WiresOnShape {
    constructor(thePtr: LocOpe_WiresOnShape);
  }

  export declare class Handle_LocOpe_WiresOnShape_3 extends Handle_LocOpe_WiresOnShape {
    constructor(theHandle: Handle_LocOpe_WiresOnShape);
  }

  export declare class Handle_LocOpe_WiresOnShape_4 extends Handle_LocOpe_WiresOnShape {
    constructor(theHandle: Handle_LocOpe_WiresOnShape);
  }

export declare class LocOpe_WiresOnShape extends Standard_Transient {
  constructor(S: TopoDS_Shape)
  Init(S: TopoDS_Shape): void;
  Add(theEdges: TopTools_SequenceOfShape): Standard_Boolean;
  SetCheckInterior(ToCheckInterior: Standard_Boolean): void;
  Bind_1(W: TopoDS_Wire, F: TopoDS_Face): void;
  Bind_2(Comp: TopoDS_Compound, F: TopoDS_Face): void;
  Bind_3(E: TopoDS_Edge, F: TopoDS_Face): void;
  Bind_4(EfromW: TopoDS_Edge, EonFace: TopoDS_Edge): void;
  BindAll(): void;
  IsDone(): Standard_Boolean;
  InitEdgeIterator(): void;
  MoreEdge(): Standard_Boolean;
  Edge(): TopoDS_Edge;
  OnFace(): TopoDS_Face;
  OnEdge_1(E: TopoDS_Edge): Standard_Boolean;
  NextEdge(): void;
  OnVertex(Vwire: TopoDS_Vertex, Vshape: TopoDS_Vertex): Standard_Boolean;
  OnEdge_2(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose): Standard_Boolean;
  OnEdge_3(V: TopoDS_Vertex, EdgeFrom: TopoDS_Edge, E: TopoDS_Edge, P: Quantity_AbsorbedDose): Standard_Boolean;
  IsFaceWithSection(aFace: TopoDS_Shape): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class LocOpe_DPrism {
  IsDone(): Standard_Boolean;
  Spine(): TopoDS_Shape;
  Profile(): TopoDS_Shape;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  Shapes(S: TopoDS_Shape): TopTools_ListOfShape;
  Curves(SCurves: TColGeom_SequenceOfCurve): void;
  BarycCurve(): Handle_Geom_Curve;
  delete(): void;
}

  export declare class LocOpe_DPrism_1 extends LocOpe_DPrism {
    constructor(Spine: TopoDS_Face, Height1: Quantity_AbsorbedDose, Height2: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose);
  }

  export declare class LocOpe_DPrism_2 extends LocOpe_DPrism {
    constructor(Spine: TopoDS_Face, Height: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose);
  }

export declare class LocOpe_FindEdges {
  Set(FFrom: TopoDS_Shape, FTo: TopoDS_Shape): void;
  InitIterator(): void;
  More(): Standard_Boolean;
  EdgeFrom(): TopoDS_Edge;
  EdgeTo(): TopoDS_Edge;
  Next(): void;
  delete(): void;
}

  export declare class LocOpe_FindEdges_1 extends LocOpe_FindEdges {
    constructor();
  }

  export declare class LocOpe_FindEdges_2 extends LocOpe_FindEdges {
    constructor(FFrom: TopoDS_Shape, FTo: TopoDS_Shape);
  }

export declare class LocOpe_FindEdgesInFace {
  Set(S: TopoDS_Shape, F: TopoDS_Face): void;
  Init(): void;
  More(): Standard_Boolean;
  Edge(): TopoDS_Edge;
  Next(): void;
  delete(): void;
}

  export declare class LocOpe_FindEdgesInFace_1 extends LocOpe_FindEdgesInFace {
    constructor();
  }

  export declare class LocOpe_FindEdgesInFace_2 extends LocOpe_FindEdgesInFace {
    constructor(S: TopoDS_Shape, F: TopoDS_Face);
  }

export declare class LocOpe_CSIntersector {
  Init(S: TopoDS_Shape): void;
  Perform_1(Slin: LocOpe_SequenceOfLin): void;
  Perform_2(Scir: LocOpe_SequenceOfCirc): void;
  Perform_3(Scur: TColGeom_SequenceOfCurve): void;
  IsDone(): Standard_Boolean;
  NbPoints(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Point(I: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId): LocOpe_PntFace;
  LocalizeAfter_1(I: Graphic3d_ZLayerId, From: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  LocalizeBefore_1(I: Graphic3d_ZLayerId, From: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  LocalizeAfter_2(I: Graphic3d_ZLayerId, FromInd: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  LocalizeBefore_2(I: Graphic3d_ZLayerId, FromInd: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, Or: TopAbs_Orientation, IndFrom: Graphic3d_ZLayerId, IndTo: Graphic3d_ZLayerId): Standard_Boolean;
  Destroy(): void;
  delete(): void;
}

  export declare class LocOpe_CSIntersector_1 extends LocOpe_CSIntersector {
    constructor();
  }

  export declare class LocOpe_CSIntersector_2 extends LocOpe_CSIntersector {
    constructor(S: TopoDS_Shape);
  }

export declare class LocOpe_SequenceOfCirc extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: LocOpe_SequenceOfCirc): LocOpe_SequenceOfCirc;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Circ): void;
  Append_2(theSeq: LocOpe_SequenceOfCirc): void;
  Prepend_1(theItem: gp_Circ): void;
  Prepend_2(theSeq: LocOpe_SequenceOfCirc): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Circ): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfCirc): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfCirc): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Circ): void;
  Split(theIndex: Standard_Integer, theSeq: LocOpe_SequenceOfCirc): void;
  First(): gp_Circ;
  ChangeFirst(): gp_Circ;
  Last(): gp_Circ;
  ChangeLast(): gp_Circ;
  Value(theIndex: Standard_Integer): gp_Circ;
  ChangeValue(theIndex: Standard_Integer): gp_Circ;
  SetValue(theIndex: Standard_Integer, theItem: gp_Circ): void;
  delete(): void;
}

  export declare class LocOpe_SequenceOfCirc_1 extends LocOpe_SequenceOfCirc {
    constructor();
  }

  export declare class LocOpe_SequenceOfCirc_2 extends LocOpe_SequenceOfCirc {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class LocOpe_SequenceOfCirc_3 extends LocOpe_SequenceOfCirc {
    constructor(theOther: LocOpe_SequenceOfCirc);
  }

export declare type LocOpe_Operation = {
  LocOpe_FUSE: {};
  LocOpe_CUT: {};
  LocOpe_INVALID: {};
}

export declare class LocOpe_BuildShape {
  Perform(L: TopTools_ListOfShape): void;
  Shape(): TopoDS_Shape;
  delete(): void;
}

  export declare class LocOpe_BuildShape_1 extends LocOpe_BuildShape {
    constructor();
  }

  export declare class LocOpe_BuildShape_2 extends LocOpe_BuildShape {
    constructor(L: TopTools_ListOfShape);
  }

export declare class LocOpe_DataMapOfShapePnt extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: LocOpe_DataMapOfShapePnt): void;
  Assign(theOther: LocOpe_DataMapOfShapePnt): LocOpe_DataMapOfShapePnt;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: gp_Pnt): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: gp_Pnt): gp_Pnt;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): gp_Pnt;
  ChangeSeek(theKey: TopoDS_Shape): gp_Pnt;
  ChangeFind(theKey: TopoDS_Shape): gp_Pnt;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class LocOpe_DataMapOfShapePnt_1 extends LocOpe_DataMapOfShapePnt {
    constructor();
  }

  export declare class LocOpe_DataMapOfShapePnt_2 extends LocOpe_DataMapOfShapePnt {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class LocOpe_DataMapOfShapePnt_3 extends LocOpe_DataMapOfShapePnt {
    constructor(theOther: LocOpe_DataMapOfShapePnt);
  }

export declare class MAT2d_DataMapOfBiIntInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: MAT2d_DataMapOfBiIntInteger): void;
  Assign(theOther: MAT2d_DataMapOfBiIntInteger): MAT2d_DataMapOfBiIntInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: MAT2d_BiInt, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: MAT2d_BiInt, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: MAT2d_BiInt): Standard_Boolean;
  UnBind(theKey: MAT2d_BiInt): Standard_Boolean;
  Seek(theKey: MAT2d_BiInt): Standard_Integer;
  ChangeSeek(theKey: MAT2d_BiInt): Standard_Integer;
  ChangeFind(theKey: MAT2d_BiInt): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class MAT2d_DataMapOfBiIntInteger_1 extends MAT2d_DataMapOfBiIntInteger {
    constructor();
  }

  export declare class MAT2d_DataMapOfBiIntInteger_2 extends MAT2d_DataMapOfBiIntInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_DataMapOfBiIntInteger_3 extends MAT2d_DataMapOfBiIntInteger {
    constructor(theOther: MAT2d_DataMapOfBiIntInteger);
  }

export declare class Handle_MAT2d_Connexion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT2d_Connexion): void;
  get(): MAT2d_Connexion;
  delete(): void;
}

  export declare class Handle_MAT2d_Connexion_1 extends Handle_MAT2d_Connexion {
    constructor();
  }

  export declare class Handle_MAT2d_Connexion_2 extends Handle_MAT2d_Connexion {
    constructor(thePtr: MAT2d_Connexion);
  }

  export declare class Handle_MAT2d_Connexion_3 extends Handle_MAT2d_Connexion {
    constructor(theHandle: Handle_MAT2d_Connexion);
  }

  export declare class Handle_MAT2d_Connexion_4 extends Handle_MAT2d_Connexion {
    constructor(theHandle: Handle_MAT2d_Connexion);
  }

export declare class MAT2d_Connexion extends Standard_Transient {
  IndexFirstLine_1(): Graphic3d_ZLayerId;
  IndexSecondLine_1(): Graphic3d_ZLayerId;
  IndexItemOnFirst_1(): Graphic3d_ZLayerId;
  IndexItemOnSecond_1(): Graphic3d_ZLayerId;
  ParameterOnFirst_1(): Quantity_AbsorbedDose;
  ParameterOnSecond_1(): Quantity_AbsorbedDose;
  PointOnFirst_1(): gp_Pnt2d;
  PointOnSecond_1(): gp_Pnt2d;
  Distance_1(): Quantity_AbsorbedDose;
  IndexFirstLine_2(anIndex: Graphic3d_ZLayerId): void;
  IndexSecondLine_2(anIndex: Graphic3d_ZLayerId): void;
  IndexItemOnFirst_2(anIndex: Graphic3d_ZLayerId): void;
  IndexItemOnSecond_2(anIndex: Graphic3d_ZLayerId): void;
  ParameterOnFirst_2(aParameter: Quantity_AbsorbedDose): void;
  ParameterOnSecond_2(aParameter: Quantity_AbsorbedDose): void;
  PointOnFirst_2(aPoint: gp_Pnt2d): void;
  PointOnSecond_2(aPoint: gp_Pnt2d): void;
  Distance_2(aDistance: Quantity_AbsorbedDose): void;
  Reverse(): Handle_MAT2d_Connexion;
  IsAfter(aConnexion: Handle_MAT2d_Connexion, aSense: Quantity_AbsorbedDose): Standard_Boolean;
  Dump(Deep: Graphic3d_ZLayerId, Offset: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class MAT2d_Connexion_1 extends MAT2d_Connexion {
    constructor();
  }

  export declare class MAT2d_Connexion_2 extends MAT2d_Connexion {
    constructor(LineA: Graphic3d_ZLayerId, LineB: Graphic3d_ZLayerId, ItemA: Graphic3d_ZLayerId, ItemB: Graphic3d_ZLayerId, Distance: Quantity_AbsorbedDose, ParameterOnA: Quantity_AbsorbedDose, ParameterOnB: Quantity_AbsorbedDose, PointA: gp_Pnt2d, PointB: gp_Pnt2d);
  }

export declare class MAT2d_MapBiIntHasher {
  constructor();
  static HashCode(theKey: MAT2d_BiInt, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(Key1: MAT2d_BiInt, Key2: MAT2d_BiInt): Standard_Boolean;
  delete(): void;
}

export declare class MAT2d_MiniPath {
  constructor()
  Perform(Figure: MAT2d_SequenceOfSequenceOfGeometry, IndStart: Graphic3d_ZLayerId, Sense: Standard_Boolean): void;
  RunOnConnexions(): void;
  Path(): MAT2d_SequenceOfConnexion;
  IsConnexionsFrom(Index: Graphic3d_ZLayerId): Standard_Boolean;
  ConnexionsFrom(Index: Graphic3d_ZLayerId): MAT2d_SequenceOfConnexion;
  IsRoot(Index: Graphic3d_ZLayerId): Standard_Boolean;
  Father(Index: Graphic3d_ZLayerId): Handle_MAT2d_Connexion;
  delete(): void;
}

export declare class MAT2d_DataMapOfIntegerPnt2d extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, gp_Pnt2d, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, gp_Pnt2d, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: gp_Pnt2d): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: gp_Pnt2d): gp_Pnt2d;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): gp_Pnt2d;
  ChangeSeek(theKey: Standard_Integer): gp_Pnt2d;
  ChangeFind(theKey: Standard_Integer): gp_Pnt2d;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class MAT2d_DataMapOfIntegerPnt2d_1 extends MAT2d_DataMapOfIntegerPnt2d {
    constructor();
  }

  export declare class MAT2d_DataMapOfIntegerPnt2d_2 extends MAT2d_DataMapOfIntegerPnt2d {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_DataMapOfIntegerPnt2d_3 extends MAT2d_DataMapOfIntegerPnt2d {
    constructor(theOther: NCollection_DataMap<Standard_Integer, gp_Pnt2d, TColStd_MapIntegerHasher>);
  }

export declare class MAT2d_DataMapOfIntegerBisec extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, Bisector_Bisec, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, Bisector_Bisec, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: Bisector_Bisec): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: Bisector_Bisec): Bisector_Bisec;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): Bisector_Bisec;
  ChangeSeek(theKey: Standard_Integer): Bisector_Bisec;
  ChangeFind(theKey: Standard_Integer): Bisector_Bisec;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class MAT2d_DataMapOfIntegerBisec_1 extends MAT2d_DataMapOfIntegerBisec {
    constructor();
  }

  export declare class MAT2d_DataMapOfIntegerBisec_2 extends MAT2d_DataMapOfIntegerBisec {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_DataMapOfIntegerBisec_3 extends MAT2d_DataMapOfIntegerBisec {
    constructor(theOther: NCollection_DataMap<Standard_Integer, Bisector_Bisec, TColStd_MapIntegerHasher>);
  }

export declare class MAT2d_SequenceOfSequenceOfGeometry extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: MAT2d_SequenceOfSequenceOfGeometry): MAT2d_SequenceOfSequenceOfGeometry;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TColGeom2d_SequenceOfGeometry): void;
  Append_2(theSeq: MAT2d_SequenceOfSequenceOfGeometry): void;
  Prepend_1(theItem: TColGeom2d_SequenceOfGeometry): void;
  Prepend_2(theSeq: MAT2d_SequenceOfSequenceOfGeometry): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TColGeom2d_SequenceOfGeometry): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: MAT2d_SequenceOfSequenceOfGeometry): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: MAT2d_SequenceOfSequenceOfGeometry): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TColGeom2d_SequenceOfGeometry): void;
  Split(theIndex: Standard_Integer, theSeq: MAT2d_SequenceOfSequenceOfGeometry): void;
  First(): TColGeom2d_SequenceOfGeometry;
  ChangeFirst(): TColGeom2d_SequenceOfGeometry;
  Last(): TColGeom2d_SequenceOfGeometry;
  ChangeLast(): TColGeom2d_SequenceOfGeometry;
  Value(theIndex: Standard_Integer): TColGeom2d_SequenceOfGeometry;
  ChangeValue(theIndex: Standard_Integer): TColGeom2d_SequenceOfGeometry;
  SetValue(theIndex: Standard_Integer, theItem: TColGeom2d_SequenceOfGeometry): void;
  delete(): void;
}

  export declare class MAT2d_SequenceOfSequenceOfGeometry_1 extends MAT2d_SequenceOfSequenceOfGeometry {
    constructor();
  }

  export declare class MAT2d_SequenceOfSequenceOfGeometry_2 extends MAT2d_SequenceOfSequenceOfGeometry {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_SequenceOfSequenceOfGeometry_3 extends MAT2d_SequenceOfSequenceOfGeometry {
    constructor(theOther: MAT2d_SequenceOfSequenceOfGeometry);
  }

export declare class MAT2d_DataMapOfIntegerSequenceOfConnexion extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, MAT2d_SequenceOfConnexion, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, MAT2d_SequenceOfConnexion, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: MAT2d_SequenceOfConnexion): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: MAT2d_SequenceOfConnexion): MAT2d_SequenceOfConnexion;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): MAT2d_SequenceOfConnexion;
  ChangeSeek(theKey: Standard_Integer): MAT2d_SequenceOfConnexion;
  ChangeFind(theKey: Standard_Integer): MAT2d_SequenceOfConnexion;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class MAT2d_DataMapOfIntegerSequenceOfConnexion_1 extends MAT2d_DataMapOfIntegerSequenceOfConnexion {
    constructor();
  }

  export declare class MAT2d_DataMapOfIntegerSequenceOfConnexion_2 extends MAT2d_DataMapOfIntegerSequenceOfConnexion {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_DataMapOfIntegerSequenceOfConnexion_3 extends MAT2d_DataMapOfIntegerSequenceOfConnexion {
    constructor(theOther: NCollection_DataMap<Standard_Integer, MAT2d_SequenceOfConnexion, TColStd_MapIntegerHasher>);
  }

export declare class MAT2d_Tool2d {
  constructor()
  Sense(aside: MAT_Side): void;
  SetJoinType(aJoinType: GeomAbs_JoinType): void;
  InitItems(aCircuit: Handle_MAT2d_Circuit): void;
  NumberOfItems(): Graphic3d_ZLayerId;
  ToleranceOfConfusion(): Quantity_AbsorbedDose;
  FirstPoint(anitem: Graphic3d_ZLayerId, dist: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  TangentBefore(anitem: Graphic3d_ZLayerId, IsOpenResult: Standard_Boolean): Graphic3d_ZLayerId;
  TangentAfter(anitem: Graphic3d_ZLayerId, IsOpenResult: Standard_Boolean): Graphic3d_ZLayerId;
  Tangent(bisector: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  CreateBisector(abisector: Handle_MAT_Bisector): void;
  TrimBisector_1(abisector: Handle_MAT_Bisector): Standard_Boolean;
  TrimBisector_2(abisector: Handle_MAT_Bisector, apoint: Graphic3d_ZLayerId): Standard_Boolean;
  IntersectBisector(bisectorone: Handle_MAT_Bisector, bisectortwo: Handle_MAT_Bisector, intpnt: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Distance(abisector: Handle_MAT_Bisector, param1: Quantity_AbsorbedDose, param2: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Dump(bisector: Graphic3d_ZLayerId, erease: Graphic3d_ZLayerId): void;
  GeomBis(Index: Graphic3d_ZLayerId): Bisector_Bisec;
  GeomElt(Index: Graphic3d_ZLayerId): Handle_Geom2d_Geometry;
  GeomPnt(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  GeomVec(Index: Graphic3d_ZLayerId): gp_Vec2d;
  Circuit(): Handle_MAT2d_Circuit;
  BisecFusion(Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId): void;
  ChangeGeomBis(Index: Graphic3d_ZLayerId): Bisector_Bisec;
  delete(): void;
}

export declare class MAT2d_BiInt {
  constructor(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId)
  FirstIndex_1(): Graphic3d_ZLayerId;
  SecondIndex_1(): Graphic3d_ZLayerId;
  FirstIndex_2(I1: Graphic3d_ZLayerId): void;
  SecondIndex_2(I2: Graphic3d_ZLayerId): void;
  IsEqual(B: MAT2d_BiInt): Standard_Boolean;
  delete(): void;
}

export declare class MAT2d_DataMapOfIntegerVec2d extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, gp_Vec2d, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, gp_Vec2d, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: gp_Vec2d): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: gp_Vec2d): gp_Vec2d;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): gp_Vec2d;
  ChangeSeek(theKey: Standard_Integer): gp_Vec2d;
  ChangeFind(theKey: Standard_Integer): gp_Vec2d;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class MAT2d_DataMapOfIntegerVec2d_1 extends MAT2d_DataMapOfIntegerVec2d {
    constructor();
  }

  export declare class MAT2d_DataMapOfIntegerVec2d_2 extends MAT2d_DataMapOfIntegerVec2d {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_DataMapOfIntegerVec2d_3 extends MAT2d_DataMapOfIntegerVec2d {
    constructor(theOther: NCollection_DataMap<Standard_Integer, gp_Vec2d, TColStd_MapIntegerHasher>);
  }

export declare class MAT2d_SequenceOfSequenceOfCurve extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: MAT2d_SequenceOfSequenceOfCurve): MAT2d_SequenceOfSequenceOfCurve;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TColGeom2d_SequenceOfCurve): void;
  Append_2(theSeq: MAT2d_SequenceOfSequenceOfCurve): void;
  Prepend_1(theItem: TColGeom2d_SequenceOfCurve): void;
  Prepend_2(theSeq: MAT2d_SequenceOfSequenceOfCurve): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TColGeom2d_SequenceOfCurve): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: MAT2d_SequenceOfSequenceOfCurve): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: MAT2d_SequenceOfSequenceOfCurve): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TColGeom2d_SequenceOfCurve): void;
  Split(theIndex: Standard_Integer, theSeq: MAT2d_SequenceOfSequenceOfCurve): void;
  First(): TColGeom2d_SequenceOfCurve;
  ChangeFirst(): TColGeom2d_SequenceOfCurve;
  Last(): TColGeom2d_SequenceOfCurve;
  ChangeLast(): TColGeom2d_SequenceOfCurve;
  Value(theIndex: Standard_Integer): TColGeom2d_SequenceOfCurve;
  ChangeValue(theIndex: Standard_Integer): TColGeom2d_SequenceOfCurve;
  SetValue(theIndex: Standard_Integer, theItem: TColGeom2d_SequenceOfCurve): void;
  delete(): void;
}

  export declare class MAT2d_SequenceOfSequenceOfCurve_1 extends MAT2d_SequenceOfSequenceOfCurve {
    constructor();
  }

  export declare class MAT2d_SequenceOfSequenceOfCurve_2 extends MAT2d_SequenceOfSequenceOfCurve {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_SequenceOfSequenceOfCurve_3 extends MAT2d_SequenceOfSequenceOfCurve {
    constructor(theOther: MAT2d_SequenceOfSequenceOfCurve);
  }

export declare class MAT2d_DataMapOfBiIntSequenceOfInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: MAT2d_DataMapOfBiIntSequenceOfInteger): void;
  Assign(theOther: MAT2d_DataMapOfBiIntSequenceOfInteger): MAT2d_DataMapOfBiIntSequenceOfInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: MAT2d_BiInt, theItem: TColStd_SequenceOfInteger): Standard_Boolean;
  Bound(theKey: MAT2d_BiInt, theItem: TColStd_SequenceOfInteger): TColStd_SequenceOfInteger;
  IsBound(theKey: MAT2d_BiInt): Standard_Boolean;
  UnBind(theKey: MAT2d_BiInt): Standard_Boolean;
  Seek(theKey: MAT2d_BiInt): TColStd_SequenceOfInteger;
  ChangeSeek(theKey: MAT2d_BiInt): TColStd_SequenceOfInteger;
  ChangeFind(theKey: MAT2d_BiInt): TColStd_SequenceOfInteger;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class MAT2d_DataMapOfBiIntSequenceOfInteger_1 extends MAT2d_DataMapOfBiIntSequenceOfInteger {
    constructor();
  }

  export declare class MAT2d_DataMapOfBiIntSequenceOfInteger_2 extends MAT2d_DataMapOfBiIntSequenceOfInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class MAT2d_DataMapOfBiIntSequenceOfInteger_3 extends MAT2d_DataMapOfBiIntSequenceOfInteger {
    constructor(theOther: MAT2d_DataMapOfBiIntSequenceOfInteger);
  }

export declare class MAT2d_Mat2d {
  constructor(IsOpenResult: Standard_Boolean)
  CreateMat(aTool: MAT2d_Tool2d): void;
  CreateMatOpen(aTool: MAT2d_Tool2d): void;
  IsDone(): Standard_Boolean;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Bisector(): Handle_MAT_Bisector;
  SemiInfinite(): Standard_Boolean;
  NumberOfBisectors(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class MAT2d_Circuit extends Standard_Transient {
  constructor(aJoinType: GeomAbs_JoinType, IsOpenResult: Standard_Boolean)
  Perform(aFigure: MAT2d_SequenceOfSequenceOfGeometry, IsClosed: TColStd_SequenceOfBoolean, IndRefLine: Graphic3d_ZLayerId, Trigo: Standard_Boolean): void;
  NumberOfItems(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): Handle_Geom2d_Geometry;
  LineLength(IndexLine: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  RefToEqui(IndLine: Graphic3d_ZLayerId, IndCurve: Graphic3d_ZLayerId): TColStd_SequenceOfInteger;
  Connexion(Index: Graphic3d_ZLayerId): Handle_MAT2d_Connexion;
  ConnexionOn(Index: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MAT2d_Circuit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT2d_Circuit): void;
  get(): MAT2d_Circuit;
  delete(): void;
}

  export declare class Handle_MAT2d_Circuit_1 extends Handle_MAT2d_Circuit {
    constructor();
  }

  export declare class Handle_MAT2d_Circuit_2 extends Handle_MAT2d_Circuit {
    constructor(thePtr: MAT2d_Circuit);
  }

  export declare class Handle_MAT2d_Circuit_3 extends Handle_MAT2d_Circuit {
    constructor(theHandle: Handle_MAT2d_Circuit);
  }

  export declare class Handle_MAT2d_Circuit_4 extends Handle_MAT2d_Circuit {
    constructor(theHandle: Handle_MAT2d_Circuit);
  }

export declare class Handle_BRep_PointRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PointRepresentation): void;
  get(): BRep_PointRepresentation;
  delete(): void;
}

  export declare class Handle_BRep_PointRepresentation_1 extends Handle_BRep_PointRepresentation {
    constructor();
  }

  export declare class Handle_BRep_PointRepresentation_2 extends Handle_BRep_PointRepresentation {
    constructor(thePtr: BRep_PointRepresentation);
  }

  export declare class Handle_BRep_PointRepresentation_3 extends Handle_BRep_PointRepresentation {
    constructor(theHandle: Handle_BRep_PointRepresentation);
  }

  export declare class Handle_BRep_PointRepresentation_4 extends Handle_BRep_PointRepresentation {
    constructor(theHandle: Handle_BRep_PointRepresentation);
  }

export declare class BRep_PointRepresentation extends Standard_Transient {
  IsPointOnCurve_1(): Standard_Boolean;
  IsPointOnCurveOnSurface_1(): Standard_Boolean;
  IsPointOnSurface_1(): Standard_Boolean;
  IsPointOnCurve_2(C: Handle_Geom_Curve, L: TopLoc_Location): Standard_Boolean;
  IsPointOnCurveOnSurface_2(PC: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  IsPointOnSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  Location_1(): TopLoc_Location;
  Location_2(L: TopLoc_Location): void;
  Parameter_1(): Quantity_AbsorbedDose;
  Parameter_2(P: Quantity_AbsorbedDose): void;
  Parameter2_1(): Quantity_AbsorbedDose;
  Parameter2_2(P: Quantity_AbsorbedDose): void;
  Curve_1(): Handle_Geom_Curve;
  Curve_2(C: Handle_Geom_Curve): void;
  PCurve_1(): Handle_Geom2d_Curve;
  PCurve_2(C: Handle_Geom2d_Curve): void;
  Surface_1(): Handle_Geom_Surface;
  Surface_2(S: Handle_Geom_Surface): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_PolygonOnClosedTriangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PolygonOnClosedTriangulation): void;
  get(): BRep_PolygonOnClosedTriangulation;
  delete(): void;
}

  export declare class Handle_BRep_PolygonOnClosedTriangulation_1 extends Handle_BRep_PolygonOnClosedTriangulation {
    constructor();
  }

  export declare class Handle_BRep_PolygonOnClosedTriangulation_2 extends Handle_BRep_PolygonOnClosedTriangulation {
    constructor(thePtr: BRep_PolygonOnClosedTriangulation);
  }

  export declare class Handle_BRep_PolygonOnClosedTriangulation_3 extends Handle_BRep_PolygonOnClosedTriangulation {
    constructor(theHandle: Handle_BRep_PolygonOnClosedTriangulation);
  }

  export declare class Handle_BRep_PolygonOnClosedTriangulation_4 extends Handle_BRep_PolygonOnClosedTriangulation {
    constructor(theHandle: Handle_BRep_PolygonOnClosedTriangulation);
  }

export declare class BRep_PolygonOnClosedTriangulation extends BRep_PolygonOnTriangulation {
  constructor(P1: Handle_Poly_PolygonOnTriangulation, P2: Handle_Poly_PolygonOnTriangulation, Tr: Handle_Poly_Triangulation, L: TopLoc_Location)
  IsPolygonOnClosedTriangulation(): Standard_Boolean;
  PolygonOnTriangulation2_1(P2: Handle_Poly_PolygonOnTriangulation): void;
  PolygonOnTriangulation2_2(): Handle_Poly_PolygonOnTriangulation;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_PolygonOnTriangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PolygonOnTriangulation): void;
  get(): BRep_PolygonOnTriangulation;
  delete(): void;
}

  export declare class Handle_BRep_PolygonOnTriangulation_1 extends Handle_BRep_PolygonOnTriangulation {
    constructor();
  }

  export declare class Handle_BRep_PolygonOnTriangulation_2 extends Handle_BRep_PolygonOnTriangulation {
    constructor(thePtr: BRep_PolygonOnTriangulation);
  }

  export declare class Handle_BRep_PolygonOnTriangulation_3 extends Handle_BRep_PolygonOnTriangulation {
    constructor(theHandle: Handle_BRep_PolygonOnTriangulation);
  }

  export declare class Handle_BRep_PolygonOnTriangulation_4 extends Handle_BRep_PolygonOnTriangulation {
    constructor(theHandle: Handle_BRep_PolygonOnTriangulation);
  }

export declare class BRep_PolygonOnTriangulation extends BRep_CurveRepresentation {
  constructor(P: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, L: TopLoc_Location)
  IsPolygonOnTriangulation_1(): Standard_Boolean;
  IsPolygonOnTriangulation_2(T: Handle_Poly_Triangulation, L: TopLoc_Location): Standard_Boolean;
  PolygonOnTriangulation_1(P: Handle_Poly_PolygonOnTriangulation): void;
  Triangulation(): Handle_Poly_Triangulation;
  PolygonOnTriangulation_2(): Handle_Poly_PolygonOnTriangulation;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_CurveOnClosedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_CurveOnClosedSurface): void;
  get(): BRep_CurveOnClosedSurface;
  delete(): void;
}

  export declare class Handle_BRep_CurveOnClosedSurface_1 extends Handle_BRep_CurveOnClosedSurface {
    constructor();
  }

  export declare class Handle_BRep_CurveOnClosedSurface_2 extends Handle_BRep_CurveOnClosedSurface {
    constructor(thePtr: BRep_CurveOnClosedSurface);
  }

  export declare class Handle_BRep_CurveOnClosedSurface_3 extends Handle_BRep_CurveOnClosedSurface {
    constructor(theHandle: Handle_BRep_CurveOnClosedSurface);
  }

  export declare class Handle_BRep_CurveOnClosedSurface_4 extends Handle_BRep_CurveOnClosedSurface {
    constructor(theHandle: Handle_BRep_CurveOnClosedSurface);
  }

export declare class BRep_CurveOnClosedSurface extends BRep_CurveOnSurface {
  constructor(PC1: Handle_Geom2d_Curve, PC2: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, C: GeomAbs_Shape)
  SetUVPoints2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  UVPoints2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  IsCurveOnClosedSurface(): Standard_Boolean;
  IsRegularity_1(): Standard_Boolean;
  IsRegularity_2(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location): Standard_Boolean;
  PCurve2_1(): Handle_Geom2d_Curve;
  Surface2(): Handle_Geom_Surface;
  Location2(): TopLoc_Location;
  Continuity_1(): GeomAbs_Shape;
  Continuity_2(C: GeomAbs_Shape): void;
  PCurve2_2(C: Handle_Geom2d_Curve): void;
  Copy(): Handle_BRep_CurveRepresentation;
  Update(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRep_Tool {
  constructor();
  static IsClosed_1(S: TopoDS_Shape): Standard_Boolean;
  static Surface_1(F: TopoDS_Face, L: TopLoc_Location): Handle_Geom_Surface;
  static Surface_2(F: TopoDS_Face): Handle_Geom_Surface;
  static Triangulation(F: TopoDS_Face, L: TopLoc_Location): Handle_Poly_Triangulation;
  static Tolerance_1(F: TopoDS_Face): Quantity_AbsorbedDose;
  static NaturalRestriction(F: TopoDS_Face): Standard_Boolean;
  static IsGeometric_1(F: TopoDS_Face): Standard_Boolean;
  static IsGeometric_2(E: TopoDS_Edge): Standard_Boolean;
  static Curve_1(E: TopoDS_Edge, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Handle_Geom_Curve;
  static Curve_2(E: TopoDS_Edge, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Handle_Geom_Curve;
  static Polygon3D(E: TopoDS_Edge, L: TopLoc_Location): Handle_Poly_Polygon3D;
  static CurveOnSurface_1(E: TopoDS_Edge, F: TopoDS_Face, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, theIsStored: Standard_Boolean): Handle_Geom2d_Curve;
  static CurveOnSurface_2(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, theIsStored: Standard_Boolean): Handle_Geom2d_Curve;
  static CurveOnPlane(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  static CurveOnSurface_3(E: TopoDS_Edge, C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  static CurveOnSurface_4(E: TopoDS_Edge, C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId): void;
  static PolygonOnSurface_1(E: TopoDS_Edge, F: TopoDS_Face): Handle_Poly_Polygon2D;
  static PolygonOnSurface_2(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location): Handle_Poly_Polygon2D;
  static PolygonOnSurface_3(E: TopoDS_Edge, C: Handle_Poly_Polygon2D, S: Handle_Geom_Surface, L: TopLoc_Location): void;
  static PolygonOnSurface_4(E: TopoDS_Edge, C: Handle_Poly_Polygon2D, S: Handle_Geom_Surface, L: TopLoc_Location, Index: Graphic3d_ZLayerId): void;
  static PolygonOnTriangulation_1(E: TopoDS_Edge, T: Handle_Poly_Triangulation, L: TopLoc_Location): Handle_Poly_PolygonOnTriangulation;
  static PolygonOnTriangulation_2(E: TopoDS_Edge, P: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, L: TopLoc_Location): void;
  static PolygonOnTriangulation_3(E: TopoDS_Edge, P: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, L: TopLoc_Location, Index: Graphic3d_ZLayerId): void;
  static IsClosed_2(E: TopoDS_Edge, F: TopoDS_Face): Standard_Boolean;
  static IsClosed_3(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  static IsClosed_4(E: TopoDS_Edge, T: Handle_Poly_Triangulation, L: TopLoc_Location): Standard_Boolean;
  static Tolerance_2(E: TopoDS_Edge): Quantity_AbsorbedDose;
  static SameParameter(E: TopoDS_Edge): Standard_Boolean;
  static SameRange(E: TopoDS_Edge): Standard_Boolean;
  static Degenerated(E: TopoDS_Edge): Standard_Boolean;
  static Range_1(E: TopoDS_Edge, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  static Range_2(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  static Range_3(E: TopoDS_Edge, F: TopoDS_Face, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  static UVPoints_1(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, PFirst: gp_Pnt2d, PLast: gp_Pnt2d): void;
  static UVPoints_2(E: TopoDS_Edge, F: TopoDS_Face, PFirst: gp_Pnt2d, PLast: gp_Pnt2d): void;
  static SetUVPoints_1(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, PFirst: gp_Pnt2d, PLast: gp_Pnt2d): void;
  static SetUVPoints_2(E: TopoDS_Edge, F: TopoDS_Face, PFirst: gp_Pnt2d, PLast: gp_Pnt2d): void;
  static HasContinuity_1(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face): Standard_Boolean;
  static Continuity_1(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face): GeomAbs_Shape;
  static HasContinuity_2(E: TopoDS_Edge, S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location): Standard_Boolean;
  static Continuity_2(E: TopoDS_Edge, S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location): GeomAbs_Shape;
  static HasContinuity_3(E: TopoDS_Edge): Standard_Boolean;
  static MaxContinuity(theEdge: TopoDS_Edge): GeomAbs_Shape;
  static Pnt(V: TopoDS_Vertex): gp_Pnt;
  static Tolerance_3(V: TopoDS_Vertex): Quantity_AbsorbedDose;
  static Parameter_1(theV: TopoDS_Vertex, theE: TopoDS_Edge, theParam: Quantity_AbsorbedDose): Standard_Boolean;
  static Parameter_2(V: TopoDS_Vertex, E: TopoDS_Edge): Quantity_AbsorbedDose;
  static Parameter_3(V: TopoDS_Vertex, E: TopoDS_Edge, F: TopoDS_Face): Quantity_AbsorbedDose;
  static Parameter_4(V: TopoDS_Vertex, E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location): Quantity_AbsorbedDose;
  static Parameters(V: TopoDS_Vertex, F: TopoDS_Face): gp_Pnt2d;
  static MaxTolerance(theShape: TopoDS_Shape, theSubShape: TopAbs_ShapeEnum): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRep_TEdge extends TopoDS_TEdge {
  constructor()
  Tolerance_1(): Quantity_AbsorbedDose;
  Tolerance_2(T: Quantity_AbsorbedDose): void;
  UpdateTolerance(T: Quantity_AbsorbedDose): void;
  SameParameter_1(): Standard_Boolean;
  SameParameter_2(S: Standard_Boolean): void;
  SameRange_1(): Standard_Boolean;
  SameRange_2(S: Standard_Boolean): void;
  Degenerated_1(): Standard_Boolean;
  Degenerated_2(S: Standard_Boolean): void;
  Curves(): BRep_ListOfCurveRepresentation;
  ChangeCurves(): BRep_ListOfCurveRepresentation;
  EmptyCopy(): Handle_TopoDS_TShape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_TEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_TEdge): void;
  get(): BRep_TEdge;
  delete(): void;
}

  export declare class Handle_BRep_TEdge_1 extends Handle_BRep_TEdge {
    constructor();
  }

  export declare class Handle_BRep_TEdge_2 extends Handle_BRep_TEdge {
    constructor(thePtr: BRep_TEdge);
  }

  export declare class Handle_BRep_TEdge_3 extends Handle_BRep_TEdge {
    constructor(theHandle: Handle_BRep_TEdge);
  }

  export declare class Handle_BRep_TEdge_4 extends Handle_BRep_TEdge {
    constructor(theHandle: Handle_BRep_TEdge);
  }

export declare class BRep_PolygonOnClosedSurface extends BRep_PolygonOnSurface {
  constructor(P1: Handle_Poly_Polygon2D, P2: Handle_Poly_Polygon2D, S: Handle_Geom_Surface, L: TopLoc_Location)
  IsPolygonOnClosedSurface(): Standard_Boolean;
  Polygon2_1(): Handle_Poly_Polygon2D;
  Polygon2_2(P: Handle_Poly_Polygon2D): void;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_PolygonOnClosedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PolygonOnClosedSurface): void;
  get(): BRep_PolygonOnClosedSurface;
  delete(): void;
}

  export declare class Handle_BRep_PolygonOnClosedSurface_1 extends Handle_BRep_PolygonOnClosedSurface {
    constructor();
  }

  export declare class Handle_BRep_PolygonOnClosedSurface_2 extends Handle_BRep_PolygonOnClosedSurface {
    constructor(thePtr: BRep_PolygonOnClosedSurface);
  }

  export declare class Handle_BRep_PolygonOnClosedSurface_3 extends Handle_BRep_PolygonOnClosedSurface {
    constructor(theHandle: Handle_BRep_PolygonOnClosedSurface);
  }

  export declare class Handle_BRep_PolygonOnClosedSurface_4 extends Handle_BRep_PolygonOnClosedSurface {
    constructor(theHandle: Handle_BRep_PolygonOnClosedSurface);
  }

export declare class BRep_PointOnSurface extends BRep_PointsOnSurface {
  constructor(P1: Quantity_AbsorbedDose, P2: Quantity_AbsorbedDose, S: Handle_Geom_Surface, L: TopLoc_Location)
  IsPointOnSurface_1(): Standard_Boolean;
  IsPointOnSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  Parameter2_1(): Quantity_AbsorbedDose;
  Parameter2_2(P: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_PointOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PointOnSurface): void;
  get(): BRep_PointOnSurface;
  delete(): void;
}

  export declare class Handle_BRep_PointOnSurface_1 extends Handle_BRep_PointOnSurface {
    constructor();
  }

  export declare class Handle_BRep_PointOnSurface_2 extends Handle_BRep_PointOnSurface {
    constructor(thePtr: BRep_PointOnSurface);
  }

  export declare class Handle_BRep_PointOnSurface_3 extends Handle_BRep_PointOnSurface {
    constructor(theHandle: Handle_BRep_PointOnSurface);
  }

  export declare class Handle_BRep_PointOnSurface_4 extends Handle_BRep_PointOnSurface {
    constructor(theHandle: Handle_BRep_PointOnSurface);
  }

export declare class BRep_GCurve extends BRep_CurveRepresentation {
  SetRange(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Range(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  First_1(): Quantity_AbsorbedDose;
  Last_1(): Quantity_AbsorbedDose;
  First_2(F: Quantity_AbsorbedDose): void;
  Last_2(L: Quantity_AbsorbedDose): void;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  Update(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_GCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_GCurve): void;
  get(): BRep_GCurve;
  delete(): void;
}

  export declare class Handle_BRep_GCurve_1 extends Handle_BRep_GCurve {
    constructor();
  }

  export declare class Handle_BRep_GCurve_2 extends Handle_BRep_GCurve {
    constructor(thePtr: BRep_GCurve);
  }

  export declare class Handle_BRep_GCurve_3 extends Handle_BRep_GCurve {
    constructor(theHandle: Handle_BRep_GCurve);
  }

  export declare class Handle_BRep_GCurve_4 extends Handle_BRep_GCurve {
    constructor(theHandle: Handle_BRep_GCurve);
  }

export declare class Handle_BRep_CurveRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_CurveRepresentation): void;
  get(): BRep_CurveRepresentation;
  delete(): void;
}

  export declare class Handle_BRep_CurveRepresentation_1 extends Handle_BRep_CurveRepresentation {
    constructor();
  }

  export declare class Handle_BRep_CurveRepresentation_2 extends Handle_BRep_CurveRepresentation {
    constructor(thePtr: BRep_CurveRepresentation);
  }

  export declare class Handle_BRep_CurveRepresentation_3 extends Handle_BRep_CurveRepresentation {
    constructor(theHandle: Handle_BRep_CurveRepresentation);
  }

  export declare class Handle_BRep_CurveRepresentation_4 extends Handle_BRep_CurveRepresentation {
    constructor(theHandle: Handle_BRep_CurveRepresentation);
  }

export declare class BRep_CurveRepresentation extends Standard_Transient {
  IsCurve3D(): Standard_Boolean;
  IsCurveOnSurface_1(): Standard_Boolean;
  IsRegularity_1(): Standard_Boolean;
  IsCurveOnClosedSurface(): Standard_Boolean;
  IsCurveOnSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  IsRegularity_2(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location): Standard_Boolean;
  IsPolygon3D(): Standard_Boolean;
  IsPolygonOnTriangulation_1(): Standard_Boolean;
  IsPolygonOnTriangulation_2(T: Handle_Poly_Triangulation, L: TopLoc_Location): Standard_Boolean;
  IsPolygonOnClosedTriangulation(): Standard_Boolean;
  IsPolygonOnSurface_1(): Standard_Boolean;
  IsPolygonOnSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  IsPolygonOnClosedSurface(): Standard_Boolean;
  Location_1(): TopLoc_Location;
  Location_2(L: TopLoc_Location): void;
  Curve3D_1(): Handle_Geom_Curve;
  Curve3D_2(C: Handle_Geom_Curve): void;
  Surface(): Handle_Geom_Surface;
  PCurve_1(): Handle_Geom2d_Curve;
  PCurve_2(C: Handle_Geom2d_Curve): void;
  PCurve2_1(): Handle_Geom2d_Curve;
  PCurve2_2(C: Handle_Geom2d_Curve): void;
  Polygon3D_1(): Handle_Poly_Polygon3D;
  Polygon3D_2(P: Handle_Poly_Polygon3D): void;
  Polygon_1(): Handle_Poly_Polygon2D;
  Polygon_2(P: Handle_Poly_Polygon2D): void;
  Polygon2_1(): Handle_Poly_Polygon2D;
  Polygon2_2(P: Handle_Poly_Polygon2D): void;
  Triangulation(): Handle_Poly_Triangulation;
  PolygonOnTriangulation_1(): Handle_Poly_PolygonOnTriangulation;
  PolygonOnTriangulation_2(P: Handle_Poly_PolygonOnTriangulation): void;
  PolygonOnTriangulation2_1(): Handle_Poly_PolygonOnTriangulation;
  PolygonOnTriangulation2_2(P2: Handle_Poly_PolygonOnTriangulation): void;
  Surface2(): Handle_Geom_Surface;
  Location2(): TopLoc_Location;
  Continuity_1(): GeomAbs_Shape;
  Continuity_2(C: GeomAbs_Shape): void;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRep_PointOnCurveOnSurface extends BRep_PointsOnSurface {
  constructor(P: Quantity_AbsorbedDose, C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location)
  IsPointOnCurveOnSurface_1(): Standard_Boolean;
  IsPointOnCurveOnSurface_2(PC: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  PCurve_1(): Handle_Geom2d_Curve;
  PCurve_2(C: Handle_Geom2d_Curve): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_PointOnCurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PointOnCurveOnSurface): void;
  get(): BRep_PointOnCurveOnSurface;
  delete(): void;
}

  export declare class Handle_BRep_PointOnCurveOnSurface_1 extends Handle_BRep_PointOnCurveOnSurface {
    constructor();
  }

  export declare class Handle_BRep_PointOnCurveOnSurface_2 extends Handle_BRep_PointOnCurveOnSurface {
    constructor(thePtr: BRep_PointOnCurveOnSurface);
  }

  export declare class Handle_BRep_PointOnCurveOnSurface_3 extends Handle_BRep_PointOnCurveOnSurface {
    constructor(theHandle: Handle_BRep_PointOnCurveOnSurface);
  }

  export declare class Handle_BRep_PointOnCurveOnSurface_4 extends Handle_BRep_PointOnCurveOnSurface {
    constructor(theHandle: Handle_BRep_PointOnCurveOnSurface);
  }

export declare class BRep_Curve3D extends BRep_GCurve {
  constructor(C: Handle_Geom_Curve, L: TopLoc_Location)
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  IsCurve3D(): Standard_Boolean;
  Curve3D_1(): Handle_Geom_Curve;
  Curve3D_2(C: Handle_Geom_Curve): void;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_Curve3D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_Curve3D): void;
  get(): BRep_Curve3D;
  delete(): void;
}

  export declare class Handle_BRep_Curve3D_1 extends Handle_BRep_Curve3D {
    constructor();
  }

  export declare class Handle_BRep_Curve3D_2 extends Handle_BRep_Curve3D {
    constructor(thePtr: BRep_Curve3D);
  }

  export declare class Handle_BRep_Curve3D_3 extends Handle_BRep_Curve3D {
    constructor(theHandle: Handle_BRep_Curve3D);
  }

  export declare class Handle_BRep_Curve3D_4 extends Handle_BRep_Curve3D {
    constructor(theHandle: Handle_BRep_Curve3D);
  }

export declare class Handle_BRep_PolygonOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PolygonOnSurface): void;
  get(): BRep_PolygonOnSurface;
  delete(): void;
}

  export declare class Handle_BRep_PolygonOnSurface_1 extends Handle_BRep_PolygonOnSurface {
    constructor();
  }

  export declare class Handle_BRep_PolygonOnSurface_2 extends Handle_BRep_PolygonOnSurface {
    constructor(thePtr: BRep_PolygonOnSurface);
  }

  export declare class Handle_BRep_PolygonOnSurface_3 extends Handle_BRep_PolygonOnSurface {
    constructor(theHandle: Handle_BRep_PolygonOnSurface);
  }

  export declare class Handle_BRep_PolygonOnSurface_4 extends Handle_BRep_PolygonOnSurface {
    constructor(theHandle: Handle_BRep_PolygonOnSurface);
  }

export declare class BRep_PolygonOnSurface extends BRep_CurveRepresentation {
  constructor(P: Handle_Poly_Polygon2D, S: Handle_Geom_Surface, L: TopLoc_Location)
  IsPolygonOnSurface_1(): Standard_Boolean;
  IsPolygonOnSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  Surface(): Handle_Geom_Surface;
  Polygon_1(): Handle_Poly_Polygon2D;
  Polygon_2(P: Handle_Poly_Polygon2D): void;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRep_Polygon3D extends BRep_CurveRepresentation {
  constructor(P: Handle_Poly_Polygon3D, L: TopLoc_Location)
  IsPolygon3D(): Standard_Boolean;
  Polygon3D_1(): Handle_Poly_Polygon3D;
  Polygon3D_2(P: Handle_Poly_Polygon3D): void;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_Polygon3D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_Polygon3D): void;
  get(): BRep_Polygon3D;
  delete(): void;
}

  export declare class Handle_BRep_Polygon3D_1 extends Handle_BRep_Polygon3D {
    constructor();
  }

  export declare class Handle_BRep_Polygon3D_2 extends Handle_BRep_Polygon3D {
    constructor(thePtr: BRep_Polygon3D);
  }

  export declare class Handle_BRep_Polygon3D_3 extends Handle_BRep_Polygon3D {
    constructor(theHandle: Handle_BRep_Polygon3D);
  }

  export declare class Handle_BRep_Polygon3D_4 extends Handle_BRep_Polygon3D {
    constructor(theHandle: Handle_BRep_Polygon3D);
  }

export declare class BRep_Builder extends TopoDS_Builder {
  constructor();
  MakeFace_1(F: TopoDS_Face): void;
  MakeFace_2(F: TopoDS_Face, S: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose): void;
  MakeFace_3(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  MakeFace_4(F: TopoDS_Face, T: Handle_Poly_Triangulation): void;
  UpdateFace_1(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  UpdateFace_2(F: TopoDS_Face, T: Handle_Poly_Triangulation): void;
  UpdateFace_3(F: TopoDS_Face, Tol: Quantity_AbsorbedDose): void;
  NaturalRestriction(F: TopoDS_Face, N: Standard_Boolean): void;
  MakeEdge_1(E: TopoDS_Edge): void;
  MakeEdge_2(E: TopoDS_Edge, C: Handle_Geom_Curve, Tol: Quantity_AbsorbedDose): void;
  MakeEdge_3(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  MakeEdge_4(E: TopoDS_Edge, P: Handle_Poly_Polygon3D): void;
  MakeEdge_5(E: TopoDS_Edge, N: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation): void;
  MakeEdge_6(E: TopoDS_Edge, N: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, L: TopLoc_Location): void;
  UpdateEdge_1(E: TopoDS_Edge, C: Handle_Geom_Curve, Tol: Quantity_AbsorbedDose): void;
  UpdateEdge_2(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  UpdateEdge_3(E: TopoDS_Edge, C: Handle_Geom2d_Curve, F: TopoDS_Face, Tol: Quantity_AbsorbedDose): void;
  UpdateEdge_4(E: TopoDS_Edge, C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, F: TopoDS_Face, Tol: Quantity_AbsorbedDose): void;
  UpdateEdge_5(E: TopoDS_Edge, C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  UpdateEdge_6(E: TopoDS_Edge, C: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, Pf: gp_Pnt2d, Pl: gp_Pnt2d): void;
  UpdateEdge_7(E: TopoDS_Edge, C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  UpdateEdge_8(E: TopoDS_Edge, C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, Pf: gp_Pnt2d, Pl: gp_Pnt2d): void;
  UpdateEdge_9(E: TopoDS_Edge, P: Handle_Poly_Polygon3D): void;
  UpdateEdge_10(E: TopoDS_Edge, P: Handle_Poly_Polygon3D, L: TopLoc_Location): void;
  UpdateEdge_11(E: TopoDS_Edge, N: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation): void;
  UpdateEdge_12(E: TopoDS_Edge, N: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, L: TopLoc_Location): void;
  UpdateEdge_13(E: TopoDS_Edge, N1: Handle_Poly_PolygonOnTriangulation, N2: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation): void;
  UpdateEdge_14(E: TopoDS_Edge, N1: Handle_Poly_PolygonOnTriangulation, N2: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, L: TopLoc_Location): void;
  UpdateEdge_15(E: TopoDS_Edge, P: Handle_Poly_Polygon2D, S: TopoDS_Face): void;
  UpdateEdge_16(E: TopoDS_Edge, P: Handle_Poly_Polygon2D, S: Handle_Geom_Surface, T: TopLoc_Location): void;
  UpdateEdge_17(E: TopoDS_Edge, P1: Handle_Poly_Polygon2D, P2: Handle_Poly_Polygon2D, S: TopoDS_Face): void;
  UpdateEdge_18(E: TopoDS_Edge, P1: Handle_Poly_Polygon2D, P2: Handle_Poly_Polygon2D, S: Handle_Geom_Surface, L: TopLoc_Location): void;
  UpdateEdge_19(E: TopoDS_Edge, Tol: Quantity_AbsorbedDose): void;
  Continuity_1(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, C: GeomAbs_Shape): void;
  Continuity_2(E: TopoDS_Edge, S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location, C: GeomAbs_Shape): void;
  SameParameter(E: TopoDS_Edge, S: Standard_Boolean): void;
  SameRange(E: TopoDS_Edge, S: Standard_Boolean): void;
  Degenerated(E: TopoDS_Edge, D: Standard_Boolean): void;
  Range_1(E: TopoDS_Edge, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Only3d: Standard_Boolean): void;
  Range_2(E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Range_3(E: TopoDS_Edge, F: TopoDS_Face, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Transfert_1(Ein: TopoDS_Edge, Eout: TopoDS_Edge): void;
  MakeVertex_1(V: TopoDS_Vertex): void;
  MakeVertex_2(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): void;
  UpdateVertex_1(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): void;
  UpdateVertex_2(V: TopoDS_Vertex, P: Quantity_AbsorbedDose, E: TopoDS_Edge, Tol: Quantity_AbsorbedDose): void;
  UpdateVertex_3(V: TopoDS_Vertex, P: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face, Tol: Quantity_AbsorbedDose): void;
  UpdateVertex_4(V: TopoDS_Vertex, P: Quantity_AbsorbedDose, E: TopoDS_Edge, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): void;
  UpdateVertex_5(Ve: TopoDS_Vertex, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, F: TopoDS_Face, Tol: Quantity_AbsorbedDose): void;
  UpdateVertex_6(V: TopoDS_Vertex, Tol: Quantity_AbsorbedDose): void;
  Transfert_2(Ein: TopoDS_Edge, Eout: TopoDS_Edge, Vin: TopoDS_Vertex, Vout: TopoDS_Vertex): void;
  delete(): void;
}

export declare class BRep_CurveOn2Surfaces extends BRep_CurveRepresentation {
  constructor(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location, C: GeomAbs_Shape)
  IsRegularity_1(): Standard_Boolean;
  IsRegularity_2(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, L1: TopLoc_Location, L2: TopLoc_Location): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  Surface(): Handle_Geom_Surface;
  Surface2(): Handle_Geom_Surface;
  Location2(): TopLoc_Location;
  Continuity_1(): GeomAbs_Shape;
  Continuity_2(C: GeomAbs_Shape): void;
  Copy(): Handle_BRep_CurveRepresentation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_CurveOn2Surfaces {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_CurveOn2Surfaces): void;
  get(): BRep_CurveOn2Surfaces;
  delete(): void;
}

  export declare class Handle_BRep_CurveOn2Surfaces_1 extends Handle_BRep_CurveOn2Surfaces {
    constructor();
  }

  export declare class Handle_BRep_CurveOn2Surfaces_2 extends Handle_BRep_CurveOn2Surfaces {
    constructor(thePtr: BRep_CurveOn2Surfaces);
  }

  export declare class Handle_BRep_CurveOn2Surfaces_3 extends Handle_BRep_CurveOn2Surfaces {
    constructor(theHandle: Handle_BRep_CurveOn2Surfaces);
  }

  export declare class Handle_BRep_CurveOn2Surfaces_4 extends Handle_BRep_CurveOn2Surfaces {
    constructor(theHandle: Handle_BRep_CurveOn2Surfaces);
  }

export declare class Handle_BRep_PointOnCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PointOnCurve): void;
  get(): BRep_PointOnCurve;
  delete(): void;
}

  export declare class Handle_BRep_PointOnCurve_1 extends Handle_BRep_PointOnCurve {
    constructor();
  }

  export declare class Handle_BRep_PointOnCurve_2 extends Handle_BRep_PointOnCurve {
    constructor(thePtr: BRep_PointOnCurve);
  }

  export declare class Handle_BRep_PointOnCurve_3 extends Handle_BRep_PointOnCurve {
    constructor(theHandle: Handle_BRep_PointOnCurve);
  }

  export declare class Handle_BRep_PointOnCurve_4 extends Handle_BRep_PointOnCurve {
    constructor(theHandle: Handle_BRep_PointOnCurve);
  }

export declare class BRep_PointOnCurve extends BRep_PointRepresentation {
  constructor(P: Quantity_AbsorbedDose, C: Handle_Geom_Curve, L: TopLoc_Location)
  IsPointOnCurve_1(): Standard_Boolean;
  IsPointOnCurve_2(C: Handle_Geom_Curve, L: TopLoc_Location): Standard_Boolean;
  Curve_1(): Handle_Geom_Curve;
  Curve_2(C: Handle_Geom_Curve): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_TFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_TFace): void;
  get(): BRep_TFace;
  delete(): void;
}

  export declare class Handle_BRep_TFace_1 extends Handle_BRep_TFace {
    constructor();
  }

  export declare class Handle_BRep_TFace_2 extends Handle_BRep_TFace {
    constructor(thePtr: BRep_TFace);
  }

  export declare class Handle_BRep_TFace_3 extends Handle_BRep_TFace {
    constructor(theHandle: Handle_BRep_TFace);
  }

  export declare class Handle_BRep_TFace_4 extends Handle_BRep_TFace {
    constructor(theHandle: Handle_BRep_TFace);
  }

export declare class BRep_TFace extends TopoDS_TFace {
  constructor()
  Surface_1(): Handle_Geom_Surface;
  Triangulation_1(): Handle_Poly_Triangulation;
  Location_1(): TopLoc_Location;
  Tolerance_1(): Quantity_AbsorbedDose;
  Surface_2(S: Handle_Geom_Surface): void;
  Triangulation_2(T: Handle_Poly_Triangulation): void;
  Location_2(L: TopLoc_Location): void;
  Tolerance_2(T: Quantity_AbsorbedDose): void;
  NaturalRestriction_1(): Standard_Boolean;
  NaturalRestriction_2(N: Standard_Boolean): void;
  EmptyCopy(): Handle_TopoDS_TShape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRep_PointsOnSurface extends BRep_PointRepresentation {
  Surface_1(): Handle_Geom_Surface;
  Surface_2(S: Handle_Geom_Surface): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_PointsOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_PointsOnSurface): void;
  get(): BRep_PointsOnSurface;
  delete(): void;
}

  export declare class Handle_BRep_PointsOnSurface_1 extends Handle_BRep_PointsOnSurface {
    constructor();
  }

  export declare class Handle_BRep_PointsOnSurface_2 extends Handle_BRep_PointsOnSurface {
    constructor(thePtr: BRep_PointsOnSurface);
  }

  export declare class Handle_BRep_PointsOnSurface_3 extends Handle_BRep_PointsOnSurface {
    constructor(theHandle: Handle_BRep_PointsOnSurface);
  }

  export declare class Handle_BRep_PointsOnSurface_4 extends Handle_BRep_PointsOnSurface {
    constructor(theHandle: Handle_BRep_PointsOnSurface);
  }

export declare class BRep_CurveOnSurface extends BRep_GCurve {
  constructor(PC: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location)
  SetUVPoints(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  UVPoints(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  IsCurveOnSurface_1(): Standard_Boolean;
  IsCurveOnSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): Standard_Boolean;
  Surface(): Handle_Geom_Surface;
  PCurve_1(): Handle_Geom2d_Curve;
  PCurve_2(C: Handle_Geom2d_Curve): void;
  Copy(): Handle_BRep_CurveRepresentation;
  Update(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRep_CurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_CurveOnSurface): void;
  get(): BRep_CurveOnSurface;
  delete(): void;
}

  export declare class Handle_BRep_CurveOnSurface_1 extends Handle_BRep_CurveOnSurface {
    constructor();
  }

  export declare class Handle_BRep_CurveOnSurface_2 extends Handle_BRep_CurveOnSurface {
    constructor(thePtr: BRep_CurveOnSurface);
  }

  export declare class Handle_BRep_CurveOnSurface_3 extends Handle_BRep_CurveOnSurface {
    constructor(theHandle: Handle_BRep_CurveOnSurface);
  }

  export declare class Handle_BRep_CurveOnSurface_4 extends Handle_BRep_CurveOnSurface {
    constructor(theHandle: Handle_BRep_CurveOnSurface);
  }

export declare class Handle_BRep_TVertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRep_TVertex): void;
  get(): BRep_TVertex;
  delete(): void;
}

  export declare class Handle_BRep_TVertex_1 extends Handle_BRep_TVertex {
    constructor();
  }

  export declare class Handle_BRep_TVertex_2 extends Handle_BRep_TVertex {
    constructor(thePtr: BRep_TVertex);
  }

  export declare class Handle_BRep_TVertex_3 extends Handle_BRep_TVertex {
    constructor(theHandle: Handle_BRep_TVertex);
  }

  export declare class Handle_BRep_TVertex_4 extends Handle_BRep_TVertex {
    constructor(theHandle: Handle_BRep_TVertex);
  }

export declare class BRep_TVertex extends TopoDS_TVertex {
  constructor()
  Tolerance_1(): Quantity_AbsorbedDose;
  Tolerance_2(T: Quantity_AbsorbedDose): void;
  UpdateTolerance(T: Quantity_AbsorbedDose): void;
  Pnt_1(): gp_Pnt;
  Pnt_2(P: gp_Pnt): void;
  Points(): BRep_ListOfPointRepresentation;
  ChangePoints(): BRep_ListOfPointRepresentation;
  EmptyCopy(): Handle_TopoDS_TShape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESToBRep_BRepEntity extends IGESToBRep_CurveAndSurface {
  TransferBRepEntity(start: Handle_IGESData_IGESEntity, theProgress: Message_ProgressRange): TopoDS_Shape;
  TransferVertex(start: Handle_IGESSolid_VertexList, index: Graphic3d_ZLayerId): TopoDS_Vertex;
  TransferEdge(start: Handle_IGESSolid_EdgeList, index: Graphic3d_ZLayerId): TopoDS_Shape;
  TransferLoop(start: Handle_IGESSolid_Loop, Face: TopoDS_Face, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose): TopoDS_Shape;
  TransferFace(start: Handle_IGESSolid_Face): TopoDS_Shape;
  TransferShell(start: Handle_IGESSolid_Shell, theProgress: Message_ProgressRange): TopoDS_Shape;
  TransferManifoldSolid(start: Handle_IGESSolid_ManifoldSolid, theProgress: Message_ProgressRange): TopoDS_Shape;
  delete(): void;
}

  export declare class IGESToBRep_BRepEntity_1 extends IGESToBRep_BRepEntity {
    constructor();
  }

  export declare class IGESToBRep_BRepEntity_2 extends IGESToBRep_BRepEntity {
    constructor(CS: IGESToBRep_CurveAndSurface);
  }

  export declare class IGESToBRep_BRepEntity_3 extends IGESToBRep_BRepEntity {
    constructor(eps: Quantity_AbsorbedDose, epsGeom: Quantity_AbsorbedDose, epsCoeff: Quantity_AbsorbedDose, mode: Standard_Boolean, modeapprox: Standard_Boolean, optimized: Standard_Boolean);
  }

export declare class IGESToBRep_TopoCurve extends IGESToBRep_CurveAndSurface {
  TransferTopoCurve(start: Handle_IGESData_IGESEntity): TopoDS_Shape;
  Transfer2dTopoCurve(start: Handle_IGESData_IGESEntity, face: TopoDS_Face, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose): TopoDS_Shape;
  TransferTopoBasicCurve(start: Handle_IGESData_IGESEntity): TopoDS_Shape;
  Transfer2dTopoBasicCurve(start: Handle_IGESData_IGESEntity, face: TopoDS_Face, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose): TopoDS_Shape;
  TransferPoint(start: Handle_IGESGeom_Point): TopoDS_Vertex;
  Transfer2dPoint(start: Handle_IGESGeom_Point): TopoDS_Vertex;
  TransferCompositeCurve(start: Handle_IGESGeom_CompositeCurve): TopoDS_Shape;
  Transfer2dCompositeCurve(start: Handle_IGESGeom_CompositeCurve, face: TopoDS_Face, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose): TopoDS_Shape;
  TransferOffsetCurve(start: Handle_IGESGeom_OffsetCurve): TopoDS_Shape;
  Transfer2dOffsetCurve(start: Handle_IGESGeom_OffsetCurve, face: TopoDS_Face, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose): TopoDS_Shape;
  TransferCurveOnSurface(start: Handle_IGESGeom_CurveOnSurface): TopoDS_Shape;
  TransferCurveOnFace(face: TopoDS_Face, start: Handle_IGESGeom_CurveOnSurface, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose, IsCurv: Standard_Boolean): TopoDS_Shape;
  TransferBoundary(start: Handle_IGESGeom_Boundary): TopoDS_Shape;
  TransferBoundaryOnFace(face: TopoDS_Face, start: Handle_IGESGeom_Boundary, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose): TopoDS_Shape;
  ApproxBSplineCurve(start: Handle_Geom_BSplineCurve): void;
  NbCurves(): Graphic3d_ZLayerId;
  Curve(num: Graphic3d_ZLayerId): Handle_Geom_Curve;
  Approx2dBSplineCurve(start: Handle_Geom2d_BSplineCurve): void;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curve2d(num: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  SetBadCase(value: Standard_Boolean): void;
  BadCase(): Standard_Boolean;
  delete(): void;
}

  export declare class IGESToBRep_TopoCurve_1 extends IGESToBRep_TopoCurve {
    constructor();
  }

  export declare class IGESToBRep_TopoCurve_2 extends IGESToBRep_TopoCurve {
    constructor(CS: IGESToBRep_CurveAndSurface);
  }

  export declare class IGESToBRep_TopoCurve_3 extends IGESToBRep_TopoCurve {
    constructor(CS: IGESToBRep_TopoCurve);
  }

  export declare class IGESToBRep_TopoCurve_4 extends IGESToBRep_TopoCurve {
    constructor(eps: Quantity_AbsorbedDose, epsGeom: Quantity_AbsorbedDose, epsCoeff: Quantity_AbsorbedDose, mode: Standard_Boolean, modeapprox: Standard_Boolean, optimized: Standard_Boolean);
  }

export declare class IGESToBRep_BasicSurface extends IGESToBRep_CurveAndSurface {
  TransferBasicSurface(start: Handle_IGESData_IGESEntity): Handle_Geom_Surface;
  TransferPlaneSurface(start: Handle_IGESSolid_PlaneSurface): Handle_Geom_Plane;
  TransferRigthCylindricalSurface(start: Handle_IGESSolid_CylindricalSurface): Handle_Geom_CylindricalSurface;
  TransferRigthConicalSurface(start: Handle_IGESSolid_ConicalSurface): Handle_Geom_ConicalSurface;
  TransferSphericalSurface(start: Handle_IGESSolid_SphericalSurface): Handle_Geom_SphericalSurface;
  TransferToroidalSurface(start: Handle_IGESSolid_ToroidalSurface): Handle_Geom_ToroidalSurface;
  TransferSplineSurface(start: Handle_IGESGeom_SplineSurface): Handle_Geom_BSplineSurface;
  TransferBSplineSurface(start: Handle_IGESGeom_BSplineSurface): Handle_Geom_BSplineSurface;
  delete(): void;
}

  export declare class IGESToBRep_BasicSurface_1 extends IGESToBRep_BasicSurface {
    constructor();
  }

  export declare class IGESToBRep_BasicSurface_2 extends IGESToBRep_BasicSurface {
    constructor(CS: IGESToBRep_CurveAndSurface);
  }

  export declare class IGESToBRep_BasicSurface_3 extends IGESToBRep_BasicSurface {
    constructor(eps: Quantity_AbsorbedDose, epsGeom: Quantity_AbsorbedDose, epsCoeff: Quantity_AbsorbedDose, mode: Standard_Boolean, modeapprox: Standard_Boolean, optimized: Standard_Boolean);
  }

export declare class Handle_IGESToBRep_AlgoContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESToBRep_AlgoContainer): void;
  get(): IGESToBRep_AlgoContainer;
  delete(): void;
}

  export declare class Handle_IGESToBRep_AlgoContainer_1 extends Handle_IGESToBRep_AlgoContainer {
    constructor();
  }

  export declare class Handle_IGESToBRep_AlgoContainer_2 extends Handle_IGESToBRep_AlgoContainer {
    constructor(thePtr: IGESToBRep_AlgoContainer);
  }

  export declare class Handle_IGESToBRep_AlgoContainer_3 extends Handle_IGESToBRep_AlgoContainer {
    constructor(theHandle: Handle_IGESToBRep_AlgoContainer);
  }

  export declare class Handle_IGESToBRep_AlgoContainer_4 extends Handle_IGESToBRep_AlgoContainer {
    constructor(theHandle: Handle_IGESToBRep_AlgoContainer);
  }

export declare class IGESToBRep_AlgoContainer extends Standard_Transient {
  constructor()
  SetToolContainer(TC: Handle_IGESToBRep_ToolContainer): void;
  ToolContainer(): Handle_IGESToBRep_ToolContainer;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESToBRep_Reader {
  constructor()
  LoadFile(filename: Standard_CString): Graphic3d_ZLayerId;
  SetModel(model: Handle_IGESData_IGESModel): void;
  Model(): Handle_IGESData_IGESModel;
  SetTransientProcess(TP: Handle_Transfer_TransientProcess): void;
  TransientProcess(): Handle_Transfer_TransientProcess;
  Actor(): Handle_IGESToBRep_Actor;
  Clear(): void;
  Check(withprint: Standard_Boolean): Standard_Boolean;
  TransferRoots(onlyvisible: Standard_Boolean, theProgress: Message_ProgressRange): void;
  Transfer(num: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): Standard_Boolean;
  IsDone(): Standard_Boolean;
  UsedTolerance(): Quantity_AbsorbedDose;
  NbShapes(): Graphic3d_ZLayerId;
  Shape(num: Graphic3d_ZLayerId): TopoDS_Shape;
  OneShape(): TopoDS_Shape;
  delete(): void;
}

export declare class Handle_IGESToBRep_ToolContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESToBRep_ToolContainer): void;
  get(): IGESToBRep_ToolContainer;
  delete(): void;
}

  export declare class Handle_IGESToBRep_ToolContainer_1 extends Handle_IGESToBRep_ToolContainer {
    constructor();
  }

  export declare class Handle_IGESToBRep_ToolContainer_2 extends Handle_IGESToBRep_ToolContainer {
    constructor(thePtr: IGESToBRep_ToolContainer);
  }

  export declare class Handle_IGESToBRep_ToolContainer_3 extends Handle_IGESToBRep_ToolContainer {
    constructor(theHandle: Handle_IGESToBRep_ToolContainer);
  }

  export declare class Handle_IGESToBRep_ToolContainer_4 extends Handle_IGESToBRep_ToolContainer {
    constructor(theHandle: Handle_IGESToBRep_ToolContainer);
  }

export declare class IGESToBRep_ToolContainer extends Standard_Transient {
  constructor()
  IGESBoundary(): Handle_IGESToBRep_IGESBoundary;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESToBRep_CurveAndSurface {
  Init(): void;
  SetEpsilon(eps: Quantity_AbsorbedDose): void;
  GetEpsilon(): Quantity_AbsorbedDose;
  SetEpsCoeff(eps: Quantity_AbsorbedDose): void;
  GetEpsCoeff(): Quantity_AbsorbedDose;
  SetEpsGeom(eps: Quantity_AbsorbedDose): void;
  GetEpsGeom(): Quantity_AbsorbedDose;
  SetMinTol(mintol: Quantity_AbsorbedDose): void;
  SetMaxTol(maxtol: Quantity_AbsorbedDose): void;
  UpdateMinMaxTol(): void;
  GetMinTol(): Quantity_AbsorbedDose;
  GetMaxTol(): Quantity_AbsorbedDose;
  SetModeApprox(mode: Standard_Boolean): void;
  GetModeApprox(): Standard_Boolean;
  SetModeTransfer(mode: Standard_Boolean): void;
  GetModeTransfer(): Standard_Boolean;
  SetOptimized(optimized: Standard_Boolean): void;
  GetOptimized(): Standard_Boolean;
  GetUnitFactor(): Quantity_AbsorbedDose;
  SetSurfaceCurve(ival: Graphic3d_ZLayerId): void;
  GetSurfaceCurve(): Graphic3d_ZLayerId;
  SetModel(model: Handle_IGESData_IGESModel): void;
  GetModel(): Handle_IGESData_IGESModel;
  SetContinuity(continuity: Graphic3d_ZLayerId): void;
  GetContinuity(): Graphic3d_ZLayerId;
  SetTransferProcess(TP: Handle_Transfer_TransientProcess): void;
  GetTransferProcess(): Handle_Transfer_TransientProcess;
  TransferCurveAndSurface(start: Handle_IGESData_IGESEntity, theProgress: Message_ProgressRange): TopoDS_Shape;
  TransferGeometry(start: Handle_IGESData_IGESEntity, theProgress: Message_ProgressRange): TopoDS_Shape;
  SendFail(start: Handle_IGESData_IGESEntity, amsg: Message_Msg): void;
  SendWarning(start: Handle_IGESData_IGESEntity, amsg: Message_Msg): void;
  SendMsg(start: Handle_IGESData_IGESEntity, amsg: Message_Msg): void;
  HasShapeResult(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  GetShapeResult_1(start: Handle_IGESData_IGESEntity): TopoDS_Shape;
  SetShapeResult(start: Handle_IGESData_IGESEntity, result: TopoDS_Shape): void;
  NbShapeResult(start: Handle_IGESData_IGESEntity): Graphic3d_ZLayerId;
  GetShapeResult_2(start: Handle_IGESData_IGESEntity, num: Graphic3d_ZLayerId): TopoDS_Shape;
  AddShapeResult(start: Handle_IGESData_IGESEntity, result: TopoDS_Shape): void;
  SetSurface(theSurface: Handle_Geom_Surface): void;
  Surface(): Handle_Geom_Surface;
  GetUVResolution(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IGESToBRep_CurveAndSurface_1 extends IGESToBRep_CurveAndSurface {
    constructor();
  }

  export declare class IGESToBRep_CurveAndSurface_2 extends IGESToBRep_CurveAndSurface {
    constructor(eps: Quantity_AbsorbedDose, epsGeom: Quantity_AbsorbedDose, epsCoeff: Quantity_AbsorbedDose, mode: Standard_Boolean, modeapprox: Standard_Boolean, optimized: Standard_Boolean);
  }

export declare class IGESToBRep_IGESBoundary extends Standard_Transient {
  Init(CS: IGESToBRep_CurveAndSurface, entity: Handle_IGESData_IGESEntity, face: TopoDS_Face, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose, filepreference: Graphic3d_ZLayerId): void;
  WireData(): Handle_ShapeExtend_WireData;
  WireData3d(): Handle_ShapeExtend_WireData;
  WireData2d(): Handle_ShapeExtend_WireData;
  Transfer_1(okCurve: Standard_Boolean, okCurve3d: Standard_Boolean, okCurve2d: Standard_Boolean, curve3d: Handle_IGESData_IGESEntity, toreverse3d: Standard_Boolean, curves2d: Handle_IGESData_HArray1OfIGESEntity, number: Graphic3d_ZLayerId): Standard_Boolean;
  Transfer_2(okCurve: Standard_Boolean, okCurve3d: Standard_Boolean, okCurve2d: Standard_Boolean, curve3d: Handle_ShapeExtend_WireData, curves2d: Handle_IGESData_HArray1OfIGESEntity, toreverse2d: Standard_Boolean, number: Graphic3d_ZLayerId, lsewd: Handle_ShapeExtend_WireData): Standard_Boolean;
  Check(result: Standard_Boolean, checkclosure: Standard_Boolean, okCurve3d: Standard_Boolean, okCurve2d: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IGESToBRep_IGESBoundary_1 extends IGESToBRep_IGESBoundary {
    constructor();
  }

  export declare class IGESToBRep_IGESBoundary_2 extends IGESToBRep_IGESBoundary {
    constructor(CS: IGESToBRep_CurveAndSurface);
  }

export declare class Handle_IGESToBRep_IGESBoundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESToBRep_IGESBoundary): void;
  get(): IGESToBRep_IGESBoundary;
  delete(): void;
}

  export declare class Handle_IGESToBRep_IGESBoundary_1 extends Handle_IGESToBRep_IGESBoundary {
    constructor();
  }

  export declare class Handle_IGESToBRep_IGESBoundary_2 extends Handle_IGESToBRep_IGESBoundary {
    constructor(thePtr: IGESToBRep_IGESBoundary);
  }

  export declare class Handle_IGESToBRep_IGESBoundary_3 extends Handle_IGESToBRep_IGESBoundary {
    constructor(theHandle: Handle_IGESToBRep_IGESBoundary);
  }

  export declare class Handle_IGESToBRep_IGESBoundary_4 extends Handle_IGESToBRep_IGESBoundary {
    constructor(theHandle: Handle_IGESToBRep_IGESBoundary);
  }

export declare class IGESToBRep_BasicCurve extends IGESToBRep_CurveAndSurface {
  TransferBasicCurve(start: Handle_IGESData_IGESEntity): Handle_Geom_Curve;
  Transfer2dBasicCurve(start: Handle_IGESData_IGESEntity): Handle_Geom2d_Curve;
  TransferBSplineCurve(start: Handle_IGESGeom_BSplineCurve): Handle_Geom_Curve;
  Transfer2dBSplineCurve(start: Handle_IGESGeom_BSplineCurve): Handle_Geom2d_Curve;
  TransferCircularArc(start: Handle_IGESGeom_CircularArc): Handle_Geom_Curve;
  Transfer2dCircularArc(start: Handle_IGESGeom_CircularArc): Handle_Geom2d_Curve;
  TransferConicArc(start: Handle_IGESGeom_ConicArc): Handle_Geom_Curve;
  Transfer2dConicArc(start: Handle_IGESGeom_ConicArc): Handle_Geom2d_Curve;
  TransferCopiousData(start: Handle_IGESGeom_CopiousData): Handle_Geom_BSplineCurve;
  Transfer2dCopiousData(start: Handle_IGESGeom_CopiousData): Handle_Geom2d_BSplineCurve;
  TransferLine(start: Handle_IGESGeom_Line): Handle_Geom_Curve;
  Transfer2dLine(start: Handle_IGESGeom_Line): Handle_Geom2d_Curve;
  TransferSplineCurve(start: Handle_IGESGeom_SplineCurve): Handle_Geom_BSplineCurve;
  Transfer2dSplineCurve(start: Handle_IGESGeom_SplineCurve): Handle_Geom2d_BSplineCurve;
  TransferTransformation(start: Handle_IGESGeom_TransformationMatrix): Handle_Geom_Transformation;
  delete(): void;
}

  export declare class IGESToBRep_BasicCurve_1 extends IGESToBRep_BasicCurve {
    constructor();
  }

  export declare class IGESToBRep_BasicCurve_2 extends IGESToBRep_BasicCurve {
    constructor(CS: IGESToBRep_CurveAndSurface);
  }

  export declare class IGESToBRep_BasicCurve_3 extends IGESToBRep_BasicCurve {
    constructor(eps: Quantity_AbsorbedDose, epsGeom: Quantity_AbsorbedDose, epsCoeff: Quantity_AbsorbedDose, mode: Standard_Boolean, modeapprox: Standard_Boolean, optimized: Standard_Boolean);
  }

export declare class IGESToBRep {
  constructor();
  static Init(): void;
  static SetAlgoContainer(aContainer: Handle_IGESToBRep_AlgoContainer): void;
  static AlgoContainer(): Handle_IGESToBRep_AlgoContainer;
  static IsCurveAndSurface(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  static IsBasicCurve(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  static IsBasicSurface(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  static IsTopoCurve(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  static IsTopoSurface(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  static IsBRepEntity(start: Handle_IGESData_IGESEntity): Standard_Boolean;
  static IGESCurveToSequenceOfIGESCurve(curve: Handle_IGESData_IGESEntity, sequence: Handle_TColStd_HSequenceOfTransient): Graphic3d_ZLayerId;
  static TransferPCurve(fromedge: TopoDS_Edge, toedge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  delete(): void;
}

export declare class Handle_IGESToBRep_Actor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESToBRep_Actor): void;
  get(): IGESToBRep_Actor;
  delete(): void;
}

  export declare class Handle_IGESToBRep_Actor_1 extends Handle_IGESToBRep_Actor {
    constructor();
  }

  export declare class Handle_IGESToBRep_Actor_2 extends Handle_IGESToBRep_Actor {
    constructor(thePtr: IGESToBRep_Actor);
  }

  export declare class Handle_IGESToBRep_Actor_3 extends Handle_IGESToBRep_Actor {
    constructor(theHandle: Handle_IGESToBRep_Actor);
  }

  export declare class Handle_IGESToBRep_Actor_4 extends Handle_IGESToBRep_Actor {
    constructor(theHandle: Handle_IGESToBRep_Actor);
  }

export declare class IGESToBRep_Actor extends Transfer_ActorOfTransientProcess {
  constructor()
  SetModel(model: Handle_Interface_InterfaceModel): void;
  SetContinuity(continuity: Graphic3d_ZLayerId): void;
  GetContinuity(): Graphic3d_ZLayerId;
  Recognize(start: Handle_Standard_Transient): Standard_Boolean;
  Transfer(start: Handle_Standard_Transient, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  UsedTolerance(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type XCAFDimTolObjects_DimensionType = {
  XCAFDimTolObjects_DimensionType_Location_None: {};
  XCAFDimTolObjects_DimensionType_Location_CurvedDistance: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromCenterToOuter: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromCenterToInner: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromOuterToCenter: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromOuterToOuter: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromOuterToInner: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromInnerToCenter: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromInnerToOuter: {};
  XCAFDimTolObjects_DimensionType_Location_LinearDistance_FromInnerToInner: {};
  XCAFDimTolObjects_DimensionType_Location_Angular: {};
  XCAFDimTolObjects_DimensionType_Location_Oriented: {};
  XCAFDimTolObjects_DimensionType_Location_WithPath: {};
  XCAFDimTolObjects_DimensionType_Size_CurveLength: {};
  XCAFDimTolObjects_DimensionType_Size_Diameter: {};
  XCAFDimTolObjects_DimensionType_Size_SphericalDiameter: {};
  XCAFDimTolObjects_DimensionType_Size_Radius: {};
  XCAFDimTolObjects_DimensionType_Size_SphericalRadius: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalMinorDiameter: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalMajorDiameter: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalMinorRadius: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalMajorRadius: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalHighMajorDiameter: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalLowMajorDiameter: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalHighMajorRadius: {};
  XCAFDimTolObjects_DimensionType_Size_ToroidalLowMajorRadius: {};
  XCAFDimTolObjects_DimensionType_Size_Thickness: {};
  XCAFDimTolObjects_DimensionType_Size_Angular: {};
  XCAFDimTolObjects_DimensionType_Size_WithPath: {};
  XCAFDimTolObjects_DimensionType_CommonLabel: {};
  XCAFDimTolObjects_DimensionType_DimensionPresentation: {};
}

export declare class XCAFDimTolObjects_GeomToleranceModifiersSequence extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: XCAFDimTolObjects_GeomToleranceModifiersSequence): XCAFDimTolObjects_GeomToleranceModifiersSequence;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: XCAFDimTolObjects_GeomToleranceModif): void;
  Append_2(theSeq: XCAFDimTolObjects_GeomToleranceModifiersSequence): void;
  Prepend_1(theItem: XCAFDimTolObjects_GeomToleranceModif): void;
  Prepend_2(theSeq: XCAFDimTolObjects_GeomToleranceModifiersSequence): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: XCAFDimTolObjects_GeomToleranceModif): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: XCAFDimTolObjects_GeomToleranceModifiersSequence): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: XCAFDimTolObjects_GeomToleranceModifiersSequence): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: XCAFDimTolObjects_GeomToleranceModif): void;
  Split(theIndex: Standard_Integer, theSeq: XCAFDimTolObjects_GeomToleranceModifiersSequence): void;
  First(): XCAFDimTolObjects_GeomToleranceModif;
  ChangeFirst(): XCAFDimTolObjects_GeomToleranceModif;
  Last(): XCAFDimTolObjects_GeomToleranceModif;
  ChangeLast(): XCAFDimTolObjects_GeomToleranceModif;
  Value(theIndex: Standard_Integer): XCAFDimTolObjects_GeomToleranceModif;
  ChangeValue(theIndex: Standard_Integer): XCAFDimTolObjects_GeomToleranceModif;
  SetValue(theIndex: Standard_Integer, theItem: XCAFDimTolObjects_GeomToleranceModif): void;
  delete(): void;
}

  export declare class XCAFDimTolObjects_GeomToleranceModifiersSequence_1 extends XCAFDimTolObjects_GeomToleranceModifiersSequence {
    constructor();
  }

  export declare class XCAFDimTolObjects_GeomToleranceModifiersSequence_2 extends XCAFDimTolObjects_GeomToleranceModifiersSequence {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class XCAFDimTolObjects_GeomToleranceModifiersSequence_3 extends XCAFDimTolObjects_GeomToleranceModifiersSequence {
    constructor(theOther: XCAFDimTolObjects_GeomToleranceModifiersSequence);
  }

export declare class XCAFDimTolObjects_DimensionModifiersSequence extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: XCAFDimTolObjects_DimensionModifiersSequence): XCAFDimTolObjects_DimensionModifiersSequence;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: XCAFDimTolObjects_DimensionModif): void;
  Append_2(theSeq: XCAFDimTolObjects_DimensionModifiersSequence): void;
  Prepend_1(theItem: XCAFDimTolObjects_DimensionModif): void;
  Prepend_2(theSeq: XCAFDimTolObjects_DimensionModifiersSequence): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: XCAFDimTolObjects_DimensionModif): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: XCAFDimTolObjects_DimensionModifiersSequence): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: XCAFDimTolObjects_DimensionModifiersSequence): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: XCAFDimTolObjects_DimensionModif): void;
  Split(theIndex: Standard_Integer, theSeq: XCAFDimTolObjects_DimensionModifiersSequence): void;
  First(): XCAFDimTolObjects_DimensionModif;
  ChangeFirst(): XCAFDimTolObjects_DimensionModif;
  Last(): XCAFDimTolObjects_DimensionModif;
  ChangeLast(): XCAFDimTolObjects_DimensionModif;
  Value(theIndex: Standard_Integer): XCAFDimTolObjects_DimensionModif;
  ChangeValue(theIndex: Standard_Integer): XCAFDimTolObjects_DimensionModif;
  SetValue(theIndex: Standard_Integer, theItem: XCAFDimTolObjects_DimensionModif): void;
  delete(): void;
}

  export declare class XCAFDimTolObjects_DimensionModifiersSequence_1 extends XCAFDimTolObjects_DimensionModifiersSequence {
    constructor();
  }

  export declare class XCAFDimTolObjects_DimensionModifiersSequence_2 extends XCAFDimTolObjects_DimensionModifiersSequence {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class XCAFDimTolObjects_DimensionModifiersSequence_3 extends XCAFDimTolObjects_DimensionModifiersSequence {
    constructor(theOther: XCAFDimTolObjects_DimensionModifiersSequence);
  }

export declare type XCAFDimTolObjects_DimensionGrade = {
  XCAFDimTolObjects_DimensionGrade_IT01: {};
  XCAFDimTolObjects_DimensionGrade_IT0: {};
  XCAFDimTolObjects_DimensionGrade_IT1: {};
  XCAFDimTolObjects_DimensionGrade_IT2: {};
  XCAFDimTolObjects_DimensionGrade_IT3: {};
  XCAFDimTolObjects_DimensionGrade_IT4: {};
  XCAFDimTolObjects_DimensionGrade_IT5: {};
  XCAFDimTolObjects_DimensionGrade_IT6: {};
  XCAFDimTolObjects_DimensionGrade_IT7: {};
  XCAFDimTolObjects_DimensionGrade_IT8: {};
  XCAFDimTolObjects_DimensionGrade_IT9: {};
  XCAFDimTolObjects_DimensionGrade_IT10: {};
  XCAFDimTolObjects_DimensionGrade_IT11: {};
  XCAFDimTolObjects_DimensionGrade_IT12: {};
  XCAFDimTolObjects_DimensionGrade_IT13: {};
  XCAFDimTolObjects_DimensionGrade_IT14: {};
  XCAFDimTolObjects_DimensionGrade_IT15: {};
  XCAFDimTolObjects_DimensionGrade_IT16: {};
  XCAFDimTolObjects_DimensionGrade_IT17: {};
  XCAFDimTolObjects_DimensionGrade_IT18: {};
}

export declare type XCAFDimTolObjects_GeomToleranceZoneModif = {
  XCAFDimTolObjects_GeomToleranceZoneModif_None: {};
  XCAFDimTolObjects_GeomToleranceZoneModif_Projected: {};
  XCAFDimTolObjects_GeomToleranceZoneModif_Runout: {};
  XCAFDimTolObjects_GeomToleranceZoneModif_NonUniform: {};
}

export declare type XCAFDimTolObjects_GeomToleranceModif = {
  XCAFDimTolObjects_GeomToleranceModif_Any_Cross_Section: {};
  XCAFDimTolObjects_GeomToleranceModif_Common_Zone: {};
  XCAFDimTolObjects_GeomToleranceModif_Each_Radial_Element: {};
  XCAFDimTolObjects_GeomToleranceModif_Free_State: {};
  XCAFDimTolObjects_GeomToleranceModif_Least_Material_Requirement: {};
  XCAFDimTolObjects_GeomToleranceModif_Line_Element: {};
  XCAFDimTolObjects_GeomToleranceModif_Major_Diameter: {};
  XCAFDimTolObjects_GeomToleranceModif_Maximum_Material_Requirement: {};
  XCAFDimTolObjects_GeomToleranceModif_Minor_Diameter: {};
  XCAFDimTolObjects_GeomToleranceModif_Not_Convex: {};
  XCAFDimTolObjects_GeomToleranceModif_Pitch_Diameter: {};
  XCAFDimTolObjects_GeomToleranceModif_Reciprocity_Requirement: {};
  XCAFDimTolObjects_GeomToleranceModif_Separate_Requirement: {};
  XCAFDimTolObjects_GeomToleranceModif_Statistical_Tolerance: {};
  XCAFDimTolObjects_GeomToleranceModif_Tangent_Plane: {};
  XCAFDimTolObjects_GeomToleranceModif_All_Around: {};
  XCAFDimTolObjects_GeomToleranceModif_All_Over: {};
}

export declare type XCAFDimTolObjects_GeomToleranceTypeValue = {
  XCAFDimTolObjects_GeomToleranceTypeValue_None: {};
  XCAFDimTolObjects_GeomToleranceTypeValue_Diameter: {};
  XCAFDimTolObjects_GeomToleranceTypeValue_SphericalDiameter: {};
}

export declare type XCAFDimTolObjects_DimensionFormVariance = {
  XCAFDimTolObjects_DimensionFormVariance_None: {};
  XCAFDimTolObjects_DimensionFormVariance_A: {};
  XCAFDimTolObjects_DimensionFormVariance_B: {};
  XCAFDimTolObjects_DimensionFormVariance_C: {};
  XCAFDimTolObjects_DimensionFormVariance_CD: {};
  XCAFDimTolObjects_DimensionFormVariance_D: {};
  XCAFDimTolObjects_DimensionFormVariance_E: {};
  XCAFDimTolObjects_DimensionFormVariance_EF: {};
  XCAFDimTolObjects_DimensionFormVariance_F: {};
  XCAFDimTolObjects_DimensionFormVariance_FG: {};
  XCAFDimTolObjects_DimensionFormVariance_G: {};
  XCAFDimTolObjects_DimensionFormVariance_H: {};
  XCAFDimTolObjects_DimensionFormVariance_JS: {};
  XCAFDimTolObjects_DimensionFormVariance_J: {};
  XCAFDimTolObjects_DimensionFormVariance_K: {};
  XCAFDimTolObjects_DimensionFormVariance_M: {};
  XCAFDimTolObjects_DimensionFormVariance_N: {};
  XCAFDimTolObjects_DimensionFormVariance_P: {};
  XCAFDimTolObjects_DimensionFormVariance_R: {};
  XCAFDimTolObjects_DimensionFormVariance_S: {};
  XCAFDimTolObjects_DimensionFormVariance_T: {};
  XCAFDimTolObjects_DimensionFormVariance_U: {};
  XCAFDimTolObjects_DimensionFormVariance_V: {};
  XCAFDimTolObjects_DimensionFormVariance_X: {};
  XCAFDimTolObjects_DimensionFormVariance_Y: {};
  XCAFDimTolObjects_DimensionFormVariance_Z: {};
  XCAFDimTolObjects_DimensionFormVariance_ZA: {};
  XCAFDimTolObjects_DimensionFormVariance_ZB: {};
  XCAFDimTolObjects_DimensionFormVariance_ZC: {};
}

export declare class XCAFDimTolObjects_DimensionObject extends Standard_Transient {
  GetSemanticName(): Handle_TCollection_HAsciiString;
  SetSemanticName(theName: Handle_TCollection_HAsciiString): void;
  SetQualifier(theQualifier: XCAFDimTolObjects_DimensionQualifier): void;
  GetQualifier(): XCAFDimTolObjects_DimensionQualifier;
  HasQualifier(): Standard_Boolean;
  SetType(theTyupe: XCAFDimTolObjects_DimensionType): void;
  GetType(): XCAFDimTolObjects_DimensionType;
  GetValue(): Quantity_AbsorbedDose;
  GetValues(): Handle_TColStd_HArray1OfReal;
  SetValue(theValue: Quantity_AbsorbedDose): void;
  SetValues(theValue: Handle_TColStd_HArray1OfReal): void;
  IsDimWithRange(): Standard_Boolean;
  SetUpperBound(theUpperBound: Quantity_AbsorbedDose): void;
  SetLowerBound(theLowerBound: Quantity_AbsorbedDose): void;
  GetUpperBound(): Quantity_AbsorbedDose;
  GetLowerBound(): Quantity_AbsorbedDose;
  IsDimWithPlusMinusTolerance(): Standard_Boolean;
  SetUpperTolValue(theUperTolValue: Quantity_AbsorbedDose): Standard_Boolean;
  SetLowerTolValue(theLowerTolValue: Quantity_AbsorbedDose): Standard_Boolean;
  GetUpperTolValue(): Quantity_AbsorbedDose;
  GetLowerTolValue(): Quantity_AbsorbedDose;
  IsDimWithClassOfTolerance(): Standard_Boolean;
  SetClassOfTolerance(theHole: Standard_Boolean, theFormVariance: XCAFDimTolObjects_DimensionFormVariance, theGrade: XCAFDimTolObjects_DimensionGrade): void;
  GetClassOfTolerance(theHole: Standard_Boolean, theFormVariance: XCAFDimTolObjects_DimensionFormVariance, theGrade: XCAFDimTolObjects_DimensionGrade): Standard_Boolean;
  SetNbOfDecimalPlaces(theL: Graphic3d_ZLayerId, theR: Graphic3d_ZLayerId): void;
  GetNbOfDecimalPlaces(theL: Graphic3d_ZLayerId, theR: Graphic3d_ZLayerId): void;
  GetModifiers(): XCAFDimTolObjects_DimensionModifiersSequence;
  SetModifiers(theModifiers: XCAFDimTolObjects_DimensionModifiersSequence): void;
  AddModifier(theModifier: XCAFDimTolObjects_DimensionModif): void;
  GetPath(): TopoDS_Edge;
  SetPath(thePath: TopoDS_Edge): void;
  GetDirection(theDir: gp_Dir): Standard_Boolean;
  SetDirection(theDir: gp_Dir): Standard_Boolean;
  SetPointTextAttach(thePntText: gp_Pnt): void;
  GetPointTextAttach(): gp_Pnt;
  HasTextPoint(): Standard_Boolean;
  SetPlane(thePlane: gp_Ax2): void;
  GetPlane(): gp_Ax2;
  HasPlane(): Standard_Boolean;
  HasPoint(): Standard_Boolean;
  HasPoint2(): Standard_Boolean;
  SetPoint(thePnt: gp_Pnt): void;
  SetPoint2(thePnt: gp_Pnt): void;
  GetPoint(): gp_Pnt;
  GetPoint2(): gp_Pnt;
  SetPresentation(thePresentation: TopoDS_Shape, thePresentationName: Handle_TCollection_HAsciiString): void;
  GetPresentation(): TopoDS_Shape;
  GetPresentationName(): Handle_TCollection_HAsciiString;
  HasDescriptions(): Standard_Boolean;
  NbDescriptions(): Graphic3d_ZLayerId;
  GetDescription(theNumber: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  GetDescriptionName(theNumber: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  RemoveDescription(theNumber: Graphic3d_ZLayerId): void;
  AddDescription(theDescription: Handle_TCollection_HAsciiString, theName: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XCAFDimTolObjects_DimensionObject_1 extends XCAFDimTolObjects_DimensionObject {
    constructor();
  }

  export declare class XCAFDimTolObjects_DimensionObject_2 extends XCAFDimTolObjects_DimensionObject {
    constructor(theObj: Handle_XCAFDimTolObjects_DimensionObject);
  }

export declare class Handle_XCAFDimTolObjects_DimensionObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDimTolObjects_DimensionObject): void;
  get(): XCAFDimTolObjects_DimensionObject;
  delete(): void;
}

  export declare class Handle_XCAFDimTolObjects_DimensionObject_1 extends Handle_XCAFDimTolObjects_DimensionObject {
    constructor();
  }

  export declare class Handle_XCAFDimTolObjects_DimensionObject_2 extends Handle_XCAFDimTolObjects_DimensionObject {
    constructor(thePtr: XCAFDimTolObjects_DimensionObject);
  }

  export declare class Handle_XCAFDimTolObjects_DimensionObject_3 extends Handle_XCAFDimTolObjects_DimensionObject {
    constructor(theHandle: Handle_XCAFDimTolObjects_DimensionObject);
  }

  export declare class Handle_XCAFDimTolObjects_DimensionObject_4 extends Handle_XCAFDimTolObjects_DimensionObject {
    constructor(theHandle: Handle_XCAFDimTolObjects_DimensionObject);
  }

export declare type XCAFDimTolObjects_DatumModifWithValue = {
  XCAFDimTolObjects_DatumModifWithValue_None: {};
  XCAFDimTolObjects_DatumModifWithValue_CircularOrCylindrical: {};
  XCAFDimTolObjects_DatumModifWithValue_Distance: {};
  XCAFDimTolObjects_DatumModifWithValue_Projected: {};
  XCAFDimTolObjects_DatumModifWithValue_Spherical: {};
}

export declare type XCAFDimTolObjects_DatumSingleModif = {
  XCAFDimTolObjects_DatumSingleModif_AnyCrossSection: {};
  XCAFDimTolObjects_DatumSingleModif_Any_LongitudinalSection: {};
  XCAFDimTolObjects_DatumSingleModif_Basic: {};
  XCAFDimTolObjects_DatumSingleModif_ContactingFeature: {};
  XCAFDimTolObjects_DatumSingleModif_DegreeOfFreedomConstraintU: {};
  XCAFDimTolObjects_DatumSingleModif_DegreeOfFreedomConstraintV: {};
  XCAFDimTolObjects_DatumSingleModif_DegreeOfFreedomConstraintW: {};
  XCAFDimTolObjects_DatumSingleModif_DegreeOfFreedomConstraintX: {};
  XCAFDimTolObjects_DatumSingleModif_DegreeOfFreedomConstraintY: {};
  XCAFDimTolObjects_DatumSingleModif_DegreeOfFreedomConstraintZ: {};
  XCAFDimTolObjects_DatumSingleModif_DistanceVariable: {};
  XCAFDimTolObjects_DatumSingleModif_FreeState: {};
  XCAFDimTolObjects_DatumSingleModif_LeastMaterialRequirement: {};
  XCAFDimTolObjects_DatumSingleModif_Line: {};
  XCAFDimTolObjects_DatumSingleModif_MajorDiameter: {};
  XCAFDimTolObjects_DatumSingleModif_MaximumMaterialRequirement: {};
  XCAFDimTolObjects_DatumSingleModif_MinorDiameter: {};
  XCAFDimTolObjects_DatumSingleModif_Orientation: {};
  XCAFDimTolObjects_DatumSingleModif_PitchDiameter: {};
  XCAFDimTolObjects_DatumSingleModif_Plane: {};
  XCAFDimTolObjects_DatumSingleModif_Point: {};
  XCAFDimTolObjects_DatumSingleModif_Translation: {};
}

export declare type XCAFDimTolObjects_ToleranceZoneAffectedPlane = {
  XCAFDimTolObjects_ToleranceZoneAffectedPlane_None: {};
  XCAFDimTolObjects_ToleranceZoneAffectedPlane_Intersection: {};
  XCAFDimTolObjects_ToleranceZoneAffectedPlane_Orientation: {};
}

export declare class XCAFDimTolObjects_Tool {
  constructor(theDoc: Handle_TDocStd_Document)
  GetDimensions(theDimensionObjectSequence: XCAFDimTolObjects_DimensionObjectSequence): void;
  GetRefDimensions(theShape: TopoDS_Shape, theDimensions: XCAFDimTolObjects_DimensionObjectSequence): Standard_Boolean;
  GetGeomTolerances(theGeomToleranceObjectSequence: XCAFDimTolObjects_GeomToleranceObjectSequence, theDatumObjectSequence: XCAFDimTolObjects_DatumObjectSequence, theMap: XCAFDimTolObjects_DataMapOfToleranceDatum): void;
  GetRefGeomTolerances(theShape: TopoDS_Shape, theGeomToleranceObjectSequence: XCAFDimTolObjects_GeomToleranceObjectSequence, theDatumObjectSequence: XCAFDimTolObjects_DatumObjectSequence, theMap: XCAFDimTolObjects_DataMapOfToleranceDatum): Standard_Boolean;
  GetRefDatum(theShape: TopoDS_Shape, theDatum: Handle_XCAFDimTolObjects_DatumObject): Standard_Boolean;
  delete(): void;
}

export declare type XCAFDimTolObjects_GeomToleranceType = {
  XCAFDimTolObjects_GeomToleranceType_None: {};
  XCAFDimTolObjects_GeomToleranceType_Angularity: {};
  XCAFDimTolObjects_GeomToleranceType_CircularRunout: {};
  XCAFDimTolObjects_GeomToleranceType_CircularityOrRoundness: {};
  XCAFDimTolObjects_GeomToleranceType_Coaxiality: {};
  XCAFDimTolObjects_GeomToleranceType_Concentricity: {};
  XCAFDimTolObjects_GeomToleranceType_Cylindricity: {};
  XCAFDimTolObjects_GeomToleranceType_Flatness: {};
  XCAFDimTolObjects_GeomToleranceType_Parallelism: {};
  XCAFDimTolObjects_GeomToleranceType_Perpendicularity: {};
  XCAFDimTolObjects_GeomToleranceType_Position: {};
  XCAFDimTolObjects_GeomToleranceType_ProfileOfLine: {};
  XCAFDimTolObjects_GeomToleranceType_ProfileOfSurface: {};
  XCAFDimTolObjects_GeomToleranceType_Straightness: {};
  XCAFDimTolObjects_GeomToleranceType_Symmetry: {};
  XCAFDimTolObjects_GeomToleranceType_TotalRunout: {};
}

export declare type XCAFDimTolObjects_DatumTargetType = {
  XCAFDimTolObjects_DatumTargetType_Point: {};
  XCAFDimTolObjects_DatumTargetType_Line: {};
  XCAFDimTolObjects_DatumTargetType_Rectangle: {};
  XCAFDimTolObjects_DatumTargetType_Circle: {};
  XCAFDimTolObjects_DatumTargetType_Area: {};
}

export declare class XCAFDimTolObjects_GeomToleranceObject extends Standard_Transient {
  GetSemanticName(): Handle_TCollection_HAsciiString;
  SetSemanticName(theName: Handle_TCollection_HAsciiString): void;
  SetType(theType: XCAFDimTolObjects_GeomToleranceType): void;
  GetType(): XCAFDimTolObjects_GeomToleranceType;
  SetTypeOfValue(theTypeOfValue: XCAFDimTolObjects_GeomToleranceTypeValue): void;
  GetTypeOfValue(): XCAFDimTolObjects_GeomToleranceTypeValue;
  SetValue(theValue: Quantity_AbsorbedDose): void;
  GetValue(): Quantity_AbsorbedDose;
  SetMaterialRequirementModifier(theMatReqModif: XCAFDimTolObjects_GeomToleranceMatReqModif): void;
  GetMaterialRequirementModifier(): XCAFDimTolObjects_GeomToleranceMatReqModif;
  SetZoneModifier(theZoneModif: XCAFDimTolObjects_GeomToleranceZoneModif): void;
  GetZoneModifier(): XCAFDimTolObjects_GeomToleranceZoneModif;
  SetValueOfZoneModifier(theValue: Quantity_AbsorbedDose): void;
  GetValueOfZoneModifier(): Quantity_AbsorbedDose;
  SetModifiers(theModifiers: XCAFDimTolObjects_GeomToleranceModifiersSequence): void;
  AddModifier(theModifier: XCAFDimTolObjects_GeomToleranceModif): void;
  GetModifiers(): XCAFDimTolObjects_GeomToleranceModifiersSequence;
  SetMaxValueModifier(theModifier: Quantity_AbsorbedDose): void;
  GetMaxValueModifier(): Quantity_AbsorbedDose;
  SetAxis(theAxis: gp_Ax2): void;
  GetAxis(): gp_Ax2;
  HasAxis(): Standard_Boolean;
  SetPlane(thePlane: gp_Ax2): void;
  GetPlane(): gp_Ax2;
  SetPoint(thePnt: gp_Pnt): void;
  GetPoint(): gp_Pnt;
  SetPointTextAttach(thePntText: gp_Pnt): void;
  GetPointTextAttach(): gp_Pnt;
  HasPlane(): Standard_Boolean;
  HasPoint(): Standard_Boolean;
  HasPointText(): Standard_Boolean;
  SetPresentation(thePresentation: TopoDS_Shape, thePresentationName: Handle_TCollection_HAsciiString): void;
  GetPresentation(): TopoDS_Shape;
  GetPresentationName(): Handle_TCollection_HAsciiString;
  HasAffectedPlane(): Standard_Boolean;
  GetAffectedPlaneType(): XCAFDimTolObjects_ToleranceZoneAffectedPlane;
  SetAffectedPlaneType(theType: XCAFDimTolObjects_ToleranceZoneAffectedPlane): void;
  SetAffectedPlane_1(thePlane: gp_Pln): void;
  SetAffectedPlane_2(thePlane: gp_Pln, theType: XCAFDimTolObjects_ToleranceZoneAffectedPlane): void;
  GetAffectedPlane(): gp_Pln;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XCAFDimTolObjects_GeomToleranceObject_1 extends XCAFDimTolObjects_GeomToleranceObject {
    constructor();
  }

  export declare class XCAFDimTolObjects_GeomToleranceObject_2 extends XCAFDimTolObjects_GeomToleranceObject {
    constructor(theObj: Handle_XCAFDimTolObjects_GeomToleranceObject);
  }

export declare class Handle_XCAFDimTolObjects_GeomToleranceObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDimTolObjects_GeomToleranceObject): void;
  get(): XCAFDimTolObjects_GeomToleranceObject;
  delete(): void;
}

  export declare class Handle_XCAFDimTolObjects_GeomToleranceObject_1 extends Handle_XCAFDimTolObjects_GeomToleranceObject {
    constructor();
  }

  export declare class Handle_XCAFDimTolObjects_GeomToleranceObject_2 extends Handle_XCAFDimTolObjects_GeomToleranceObject {
    constructor(thePtr: XCAFDimTolObjects_GeomToleranceObject);
  }

  export declare class Handle_XCAFDimTolObjects_GeomToleranceObject_3 extends Handle_XCAFDimTolObjects_GeomToleranceObject {
    constructor(theHandle: Handle_XCAFDimTolObjects_GeomToleranceObject);
  }

  export declare class Handle_XCAFDimTolObjects_GeomToleranceObject_4 extends Handle_XCAFDimTolObjects_GeomToleranceObject {
    constructor(theHandle: Handle_XCAFDimTolObjects_GeomToleranceObject);
  }

export declare type XCAFDimTolObjects_GeomToleranceMatReqModif = {
  XCAFDimTolObjects_GeomToleranceMatReqModif_None: {};
  XCAFDimTolObjects_GeomToleranceMatReqModif_M: {};
  XCAFDimTolObjects_GeomToleranceMatReqModif_L: {};
}

export declare type XCAFDimTolObjects_DimensionQualifier = {
  XCAFDimTolObjects_DimensionQualifier_None: {};
  XCAFDimTolObjects_DimensionQualifier_Min: {};
  XCAFDimTolObjects_DimensionQualifier_Max: {};
  XCAFDimTolObjects_DimensionQualifier_Avg: {};
}

export declare type XCAFDimTolObjects_DimensionModif = {
  XCAFDimTolObjects_DimensionModif_ControlledRadius: {};
  XCAFDimTolObjects_DimensionModif_Square: {};
  XCAFDimTolObjects_DimensionModif_StatisticalTolerance: {};
  XCAFDimTolObjects_DimensionModif_ContinuousFeature: {};
  XCAFDimTolObjects_DimensionModif_TwoPointSize: {};
  XCAFDimTolObjects_DimensionModif_LocalSizeDefinedBySphere: {};
  XCAFDimTolObjects_DimensionModif_LeastSquaresAssociationCriterion: {};
  XCAFDimTolObjects_DimensionModif_MaximumInscribedAssociation: {};
  XCAFDimTolObjects_DimensionModif_MinimumCircumscribedAssociation: {};
  XCAFDimTolObjects_DimensionModif_CircumferenceDiameter: {};
  XCAFDimTolObjects_DimensionModif_AreaDiameter: {};
  XCAFDimTolObjects_DimensionModif_VolumeDiameter: {};
  XCAFDimTolObjects_DimensionModif_MaximumSize: {};
  XCAFDimTolObjects_DimensionModif_MinimumSize: {};
  XCAFDimTolObjects_DimensionModif_AverageSize: {};
  XCAFDimTolObjects_DimensionModif_MedianSize: {};
  XCAFDimTolObjects_DimensionModif_MidRangeSize: {};
  XCAFDimTolObjects_DimensionModif_RangeOfSizes: {};
  XCAFDimTolObjects_DimensionModif_AnyRestrictedPortionOfFeature: {};
  XCAFDimTolObjects_DimensionModif_AnyCrossSection: {};
  XCAFDimTolObjects_DimensionModif_SpecificFixedCrossSection: {};
  XCAFDimTolObjects_DimensionModif_CommonTolerance: {};
  XCAFDimTolObjects_DimensionModif_FreeStateCondition: {};
  XCAFDimTolObjects_DimensionModif_Between: {};
}

export declare class Handle_XCAFDimTolObjects_DatumObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDimTolObjects_DatumObject): void;
  get(): XCAFDimTolObjects_DatumObject;
  delete(): void;
}

  export declare class Handle_XCAFDimTolObjects_DatumObject_1 extends Handle_XCAFDimTolObjects_DatumObject {
    constructor();
  }

  export declare class Handle_XCAFDimTolObjects_DatumObject_2 extends Handle_XCAFDimTolObjects_DatumObject {
    constructor(thePtr: XCAFDimTolObjects_DatumObject);
  }

  export declare class Handle_XCAFDimTolObjects_DatumObject_3 extends Handle_XCAFDimTolObjects_DatumObject {
    constructor(theHandle: Handle_XCAFDimTolObjects_DatumObject);
  }

  export declare class Handle_XCAFDimTolObjects_DatumObject_4 extends Handle_XCAFDimTolObjects_DatumObject {
    constructor(theHandle: Handle_XCAFDimTolObjects_DatumObject);
  }

export declare class XCAFDimTolObjects_DatumObject extends Standard_Transient {
  GetSemanticName(): Handle_TCollection_HAsciiString;
  SetSemanticName(theName: Handle_TCollection_HAsciiString): void;
  GetName(): Handle_TCollection_HAsciiString;
  SetName(theTag: Handle_TCollection_HAsciiString): void;
  GetModifiers(): XCAFDimTolObjects_DatumModifiersSequence;
  SetModifiers(theModifiers: XCAFDimTolObjects_DatumModifiersSequence): void;
  GetModifierWithValue(theModifier: XCAFDimTolObjects_DatumModifWithValue, theValue: Quantity_AbsorbedDose): void;
  SetModifierWithValue(theModifier: XCAFDimTolObjects_DatumModifWithValue, theValue: Quantity_AbsorbedDose): void;
  AddModifier(theModifier: XCAFDimTolObjects_DatumSingleModif): void;
  GetDatumTarget(): TopoDS_Shape;
  SetDatumTarget(theShape: TopoDS_Shape): void;
  GetPosition(): Graphic3d_ZLayerId;
  SetPosition(thePosition: Graphic3d_ZLayerId): void;
  IsDatumTarget_1(): Standard_Boolean;
  IsDatumTarget_2(theIsDT: Standard_Boolean): void;
  GetDatumTargetType(): XCAFDimTolObjects_DatumTargetType;
  SetDatumTargetType(theType: XCAFDimTolObjects_DatumTargetType): void;
  GetDatumTargetAxis(): gp_Ax2;
  SetDatumTargetAxis(theAxis: gp_Ax2): void;
  GetDatumTargetLength(): Quantity_AbsorbedDose;
  SetDatumTargetLength(theLength: Quantity_AbsorbedDose): void;
  GetDatumTargetWidth(): Quantity_AbsorbedDose;
  SetDatumTargetWidth(theWidth: Quantity_AbsorbedDose): void;
  GetDatumTargetNumber(): Graphic3d_ZLayerId;
  SetDatumTargetNumber(theNumber: Graphic3d_ZLayerId): void;
  SetPlane(thePlane: gp_Ax2): void;
  GetPlane(): gp_Ax2;
  SetPoint(thePnt: gp_Pnt): void;
  GetPoint(): gp_Pnt;
  SetPointTextAttach(thePntText: gp_Pnt): void;
  GetPointTextAttach(): gp_Pnt;
  HasPlane(): Standard_Boolean;
  HasPoint(): Standard_Boolean;
  HasPointText(): Standard_Boolean;
  SetPresentation(thePresentation: TopoDS_Shape, thePresentationName: Handle_TCollection_HAsciiString): void;
  GetPresentation(): TopoDS_Shape;
  GetPresentationName(): Handle_TCollection_HAsciiString;
  HasDatumTargetParams(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XCAFDimTolObjects_DatumObject_1 extends XCAFDimTolObjects_DatumObject {
    constructor();
  }

  export declare class XCAFDimTolObjects_DatumObject_2 extends XCAFDimTolObjects_DatumObject {
    constructor(theObj: Handle_XCAFDimTolObjects_DatumObject);
  }

export declare class Handle_IFSelect_SelectInList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectInList): void;
  get(): IFSelect_SelectInList;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectInList_1 extends Handle_IFSelect_SelectInList {
    constructor();
  }

  export declare class Handle_IFSelect_SelectInList_2 extends Handle_IFSelect_SelectInList {
    constructor(thePtr: IFSelect_SelectInList);
  }

  export declare class Handle_IFSelect_SelectInList_3 extends Handle_IFSelect_SelectInList {
    constructor(theHandle: Handle_IFSelect_SelectInList);
  }

  export declare class Handle_IFSelect_SelectInList_4 extends Handle_IFSelect_SelectInList {
    constructor(theHandle: Handle_IFSelect_SelectInList);
  }

export declare class IFSelect_SelectInList extends IFSelect_SelectAnyList {
  ListedEntity(num: Graphic3d_ZLayerId, ent: Handle_Standard_Transient): Handle_Standard_Transient;
  FillResult(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, result: Interface_EntityIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_ParamEditor extends IFSelect_Editor {
  constructor(nbmax: Graphic3d_ZLayerId, label: Standard_CString)
  AddValue(val: Handle_Interface_TypedValue, shortname: Standard_CString): void;
  AddConstantText(val: Standard_CString, shortname: Standard_CString, completename: Standard_CString): void;
  Label(): XCAFDoc_PartId;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static StaticEditor(list: Handle_TColStd_HSequenceOfHAsciiString, label: Standard_CString): Handle_IFSelect_ParamEditor;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_ParamEditor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_ParamEditor): void;
  get(): IFSelect_ParamEditor;
  delete(): void;
}

  export declare class Handle_IFSelect_ParamEditor_1 extends Handle_IFSelect_ParamEditor {
    constructor();
  }

  export declare class Handle_IFSelect_ParamEditor_2 extends Handle_IFSelect_ParamEditor {
    constructor(thePtr: IFSelect_ParamEditor);
  }

  export declare class Handle_IFSelect_ParamEditor_3 extends Handle_IFSelect_ParamEditor {
    constructor(theHandle: Handle_IFSelect_ParamEditor);
  }

  export declare class Handle_IFSelect_ParamEditor_4 extends Handle_IFSelect_ParamEditor {
    constructor(theHandle: Handle_IFSelect_ParamEditor);
  }

export declare class IFSelect_SelectEntityNumber extends IFSelect_SelectBase {
  constructor()
  SetNumber(num: Handle_IFSelect_IntParam): void;
  Number(): Handle_IFSelect_IntParam;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectEntityNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectEntityNumber): void;
  get(): IFSelect_SelectEntityNumber;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectEntityNumber_1 extends Handle_IFSelect_SelectEntityNumber {
    constructor();
  }

  export declare class Handle_IFSelect_SelectEntityNumber_2 extends Handle_IFSelect_SelectEntityNumber {
    constructor(thePtr: IFSelect_SelectEntityNumber);
  }

  export declare class Handle_IFSelect_SelectEntityNumber_3 extends Handle_IFSelect_SelectEntityNumber {
    constructor(theHandle: Handle_IFSelect_SelectEntityNumber);
  }

  export declare class Handle_IFSelect_SelectEntityNumber_4 extends Handle_IFSelect_SelectEntityNumber {
    constructor(theHandle: Handle_IFSelect_SelectEntityNumber);
  }

export declare class Handle_IFSelect_IntParam {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_IntParam): void;
  get(): IFSelect_IntParam;
  delete(): void;
}

  export declare class Handle_IFSelect_IntParam_1 extends Handle_IFSelect_IntParam {
    constructor();
  }

  export declare class Handle_IFSelect_IntParam_2 extends Handle_IFSelect_IntParam {
    constructor(thePtr: IFSelect_IntParam);
  }

  export declare class Handle_IFSelect_IntParam_3 extends Handle_IFSelect_IntParam {
    constructor(theHandle: Handle_IFSelect_IntParam);
  }

  export declare class Handle_IFSelect_IntParam_4 extends Handle_IFSelect_IntParam {
    constructor(theHandle: Handle_IFSelect_IntParam);
  }

export declare class IFSelect_SelectSignature extends IFSelect_SelectExtract {
  Signature(): Handle_IFSelect_Signature;
  Counter(): Handle_IFSelect_SignCounter;
  SortInGraph(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph): Standard_Boolean;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  SignatureText(): XCAFDoc_PartId;
  IsExact(): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IFSelect_SelectSignature_1 extends IFSelect_SelectSignature {
    constructor(matcher: Handle_IFSelect_Signature, signtext: Standard_CString, exact: Standard_Boolean);
  }

  export declare class IFSelect_SelectSignature_2 extends IFSelect_SelectSignature {
    constructor(matcher: Handle_IFSelect_Signature, signtext: XCAFDoc_PartId, exact: Standard_Boolean);
  }

  export declare class IFSelect_SelectSignature_3 extends IFSelect_SelectSignature {
    constructor(matcher: Handle_IFSelect_SignCounter, signtext: Standard_CString, exact: Standard_Boolean);
  }

export declare class Handle_IFSelect_SelectSignature {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectSignature): void;
  get(): IFSelect_SelectSignature;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectSignature_1 extends Handle_IFSelect_SelectSignature {
    constructor();
  }

  export declare class Handle_IFSelect_SelectSignature_2 extends Handle_IFSelect_SelectSignature {
    constructor(thePtr: IFSelect_SelectSignature);
  }

  export declare class Handle_IFSelect_SelectSignature_3 extends Handle_IFSelect_SelectSignature {
    constructor(theHandle: Handle_IFSelect_SelectSignature);
  }

  export declare class Handle_IFSelect_SelectSignature_4 extends Handle_IFSelect_SelectSignature {
    constructor(theHandle: Handle_IFSelect_SelectSignature);
  }

export declare class IFSelect_SelectSharing extends IFSelect_SelectDeduct {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectSharing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectSharing): void;
  get(): IFSelect_SelectSharing;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectSharing_1 extends Handle_IFSelect_SelectSharing {
    constructor();
  }

  export declare class Handle_IFSelect_SelectSharing_2 extends Handle_IFSelect_SelectSharing {
    constructor(thePtr: IFSelect_SelectSharing);
  }

  export declare class Handle_IFSelect_SelectSharing_3 extends Handle_IFSelect_SelectSharing {
    constructor(theHandle: Handle_IFSelect_SelectSharing);
  }

  export declare class Handle_IFSelect_SelectSharing_4 extends Handle_IFSelect_SelectSharing {
    constructor(theHandle: Handle_IFSelect_SelectSharing);
  }

export declare class IFSelect_ContextWrite {
  Model(): Handle_Interface_InterfaceModel;
  Protocol(): Handle_Interface_Protocol;
  FileName(): Standard_CString;
  AppliedModifiers(): Handle_IFSelect_AppliedModifiers;
  Graph(): Interface_Graph;
  NbModifiers(): Graphic3d_ZLayerId;
  SetModifier(numod: Graphic3d_ZLayerId): Standard_Boolean;
  FileModifier(): Handle_IFSelect_GeneralModifier;
  IsForNone(): Standard_Boolean;
  IsForAll(): Standard_Boolean;
  NbEntities(): Graphic3d_ZLayerId;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Standard_Transient;
  AddCheck(check: Handle_Interface_Check): void;
  AddWarning(start: Handle_Standard_Transient, mess: Standard_CString, orig: Standard_CString): void;
  AddFail(start: Handle_Standard_Transient, mess: Standard_CString, orig: Standard_CString): void;
  CCheck_1(num: Graphic3d_ZLayerId): Handle_Interface_Check;
  CCheck_2(start: Handle_Standard_Transient): Handle_Interface_Check;
  CheckList(): Interface_CheckIterator;
  delete(): void;
}

  export declare class IFSelect_ContextWrite_1 extends IFSelect_ContextWrite {
    constructor(model: Handle_Interface_InterfaceModel, proto: Handle_Interface_Protocol, applieds: Handle_IFSelect_AppliedModifiers, filename: Standard_CString);
  }

  export declare class IFSelect_ContextWrite_2 extends IFSelect_ContextWrite {
    constructor(hgraph: Handle_Interface_HGraph, proto: Handle_Interface_Protocol, applieds: Handle_IFSelect_AppliedModifiers, filename: Standard_CString);
  }

export declare class Handle_IFSelect_Activator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Activator): void;
  get(): IFSelect_Activator;
  delete(): void;
}

  export declare class Handle_IFSelect_Activator_1 extends Handle_IFSelect_Activator {
    constructor();
  }

  export declare class Handle_IFSelect_Activator_2 extends Handle_IFSelect_Activator {
    constructor(thePtr: IFSelect_Activator);
  }

  export declare class Handle_IFSelect_Activator_3 extends Handle_IFSelect_Activator {
    constructor(theHandle: Handle_IFSelect_Activator);
  }

  export declare class Handle_IFSelect_Activator_4 extends Handle_IFSelect_Activator {
    constructor(theHandle: Handle_IFSelect_Activator);
  }

export declare class IFSelect_Activator extends Standard_Transient {
  static Adding(actor: Handle_IFSelect_Activator, number: Graphic3d_ZLayerId, command: Standard_CString, mode: Graphic3d_ZLayerId): void;
  Add(number: Graphic3d_ZLayerId, command: Standard_CString): void;
  AddSet(number: Graphic3d_ZLayerId, command: Standard_CString): void;
  static Remove(command: Standard_CString): void;
  static Select(command: Standard_CString, number: Graphic3d_ZLayerId, actor: Handle_IFSelect_Activator): Standard_Boolean;
  static Mode(command: Standard_CString): Graphic3d_ZLayerId;
  static Commands(mode: Graphic3d_ZLayerId, command: Standard_CString): Handle_TColStd_HSequenceOfAsciiString;
  Do(number: Graphic3d_ZLayerId, pilot: Handle_IFSelect_SessionPilot): IFSelect_ReturnStatus;
  Help(number: Graphic3d_ZLayerId): Standard_CString;
  Group(): Standard_CString;
  File(): Standard_CString;
  SetForGroup(group: Standard_CString, file: Standard_CString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectFlag {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectFlag): void;
  get(): IFSelect_SelectFlag;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectFlag_1 extends Handle_IFSelect_SelectFlag {
    constructor();
  }

  export declare class Handle_IFSelect_SelectFlag_2 extends Handle_IFSelect_SelectFlag {
    constructor(thePtr: IFSelect_SelectFlag);
  }

  export declare class Handle_IFSelect_SelectFlag_3 extends Handle_IFSelect_SelectFlag {
    constructor(theHandle: Handle_IFSelect_SelectFlag);
  }

  export declare class Handle_IFSelect_SelectFlag_4 extends Handle_IFSelect_SelectFlag {
    constructor(theHandle: Handle_IFSelect_SelectFlag);
  }

export declare class IFSelect_SelectFlag extends IFSelect_SelectExtract {
  constructor(flagname: Standard_CString)
  FlagName(): Standard_CString;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_HSeqOfSelection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_HSeqOfSelection): void;
  get(): IFSelect_HSeqOfSelection;
  delete(): void;
}

  export declare class Handle_IFSelect_HSeqOfSelection_1 extends Handle_IFSelect_HSeqOfSelection {
    constructor();
  }

  export declare class Handle_IFSelect_HSeqOfSelection_2 extends Handle_IFSelect_HSeqOfSelection {
    constructor(thePtr: IFSelect_HSeqOfSelection);
  }

  export declare class Handle_IFSelect_HSeqOfSelection_3 extends Handle_IFSelect_HSeqOfSelection {
    constructor(theHandle: Handle_IFSelect_HSeqOfSelection);
  }

  export declare class Handle_IFSelect_HSeqOfSelection_4 extends Handle_IFSelect_HSeqOfSelection {
    constructor(theHandle: Handle_IFSelect_HSeqOfSelection);
  }

export declare class Handle_IFSelect_SelectIncorrectEntities {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectIncorrectEntities): void;
  get(): IFSelect_SelectIncorrectEntities;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectIncorrectEntities_1 extends Handle_IFSelect_SelectIncorrectEntities {
    constructor();
  }

  export declare class Handle_IFSelect_SelectIncorrectEntities_2 extends Handle_IFSelect_SelectIncorrectEntities {
    constructor(thePtr: IFSelect_SelectIncorrectEntities);
  }

  export declare class Handle_IFSelect_SelectIncorrectEntities_3 extends Handle_IFSelect_SelectIncorrectEntities {
    constructor(theHandle: Handle_IFSelect_SelectIncorrectEntities);
  }

  export declare class Handle_IFSelect_SelectIncorrectEntities_4 extends Handle_IFSelect_SelectIncorrectEntities {
    constructor(theHandle: Handle_IFSelect_SelectIncorrectEntities);
  }

export declare class IFSelect_SelectIncorrectEntities extends IFSelect_SelectFlag {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SelectRootComps extends IFSelect_SelectExtract {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectRootComps {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectRootComps): void;
  get(): IFSelect_SelectRootComps;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectRootComps_1 extends Handle_IFSelect_SelectRootComps {
    constructor();
  }

  export declare class Handle_IFSelect_SelectRootComps_2 extends Handle_IFSelect_SelectRootComps {
    constructor(thePtr: IFSelect_SelectRootComps);
  }

  export declare class Handle_IFSelect_SelectRootComps_3 extends Handle_IFSelect_SelectRootComps {
    constructor(theHandle: Handle_IFSelect_SelectRootComps);
  }

  export declare class Handle_IFSelect_SelectRootComps_4 extends Handle_IFSelect_SelectRootComps {
    constructor(theHandle: Handle_IFSelect_SelectRootComps);
  }

export declare class Handle_IFSelect_GeneralModifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_GeneralModifier): void;
  get(): IFSelect_GeneralModifier;
  delete(): void;
}

  export declare class Handle_IFSelect_GeneralModifier_1 extends Handle_IFSelect_GeneralModifier {
    constructor();
  }

  export declare class Handle_IFSelect_GeneralModifier_2 extends Handle_IFSelect_GeneralModifier {
    constructor(thePtr: IFSelect_GeneralModifier);
  }

  export declare class Handle_IFSelect_GeneralModifier_3 extends Handle_IFSelect_GeneralModifier {
    constructor(theHandle: Handle_IFSelect_GeneralModifier);
  }

  export declare class Handle_IFSelect_GeneralModifier_4 extends Handle_IFSelect_GeneralModifier {
    constructor(theHandle: Handle_IFSelect_GeneralModifier);
  }

export declare class IFSelect_GeneralModifier extends Standard_Transient {
  MayChangeGraph(): Standard_Boolean;
  SetDispatch(disp: Handle_IFSelect_Dispatch): void;
  Dispatch(): Handle_IFSelect_Dispatch;
  Applies(disp: Handle_IFSelect_Dispatch): Standard_Boolean;
  SetSelection(sel: Handle_IFSelect_Selection): void;
  ResetSelection(): void;
  HasSelection(): Standard_Boolean;
  Selection(): Handle_IFSelect_Selection;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SessionDumper extends Standard_Transient {
  static First(): Handle_IFSelect_SessionDumper;
  Next(): Handle_IFSelect_SessionDumper;
  WriteOwn(file: IFSelect_SessionFile, item: Handle_Standard_Transient): Standard_Boolean;
  ReadOwn(file: IFSelect_SessionFile, type: XCAFDoc_PartId, item: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SessionDumper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SessionDumper): void;
  get(): IFSelect_SessionDumper;
  delete(): void;
}

  export declare class Handle_IFSelect_SessionDumper_1 extends Handle_IFSelect_SessionDumper {
    constructor();
  }

  export declare class Handle_IFSelect_SessionDumper_2 extends Handle_IFSelect_SessionDumper {
    constructor(thePtr: IFSelect_SessionDumper);
  }

  export declare class Handle_IFSelect_SessionDumper_3 extends Handle_IFSelect_SessionDumper {
    constructor(theHandle: Handle_IFSelect_SessionDumper);
  }

  export declare class Handle_IFSelect_SessionDumper_4 extends Handle_IFSelect_SessionDumper {
    constructor(theHandle: Handle_IFSelect_SessionDumper);
  }

export declare class IFSelect_GraphCounter extends IFSelect_SignCounter {
  constructor(withmap: Standard_Boolean, withlist: Standard_Boolean)
  Applied(): Handle_IFSelect_SelectDeduct;
  SetApplied(sel: Handle_IFSelect_SelectDeduct): void;
  AddWithGraph(list: Handle_TColStd_HSequenceOfTransient, graph: Interface_Graph): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_GraphCounter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_GraphCounter): void;
  get(): IFSelect_GraphCounter;
  delete(): void;
}

  export declare class Handle_IFSelect_GraphCounter_1 extends Handle_IFSelect_GraphCounter {
    constructor();
  }

  export declare class Handle_IFSelect_GraphCounter_2 extends Handle_IFSelect_GraphCounter {
    constructor(thePtr: IFSelect_GraphCounter);
  }

  export declare class Handle_IFSelect_GraphCounter_3 extends Handle_IFSelect_GraphCounter {
    constructor(theHandle: Handle_IFSelect_GraphCounter);
  }

  export declare class Handle_IFSelect_GraphCounter_4 extends Handle_IFSelect_GraphCounter {
    constructor(theHandle: Handle_IFSelect_GraphCounter);
  }

export declare class IFSelect_SelectType extends IFSelect_SelectAnyType {
  SetType(atype: Handle_Standard_Type): void;
  TypeForMatch(): Handle_Standard_Type;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IFSelect_SelectType_1 extends IFSelect_SelectType {
    constructor();
  }

  export declare class IFSelect_SelectType_2 extends IFSelect_SelectType {
    constructor(atype: Handle_Standard_Type);
  }

export declare class Handle_IFSelect_SelectType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectType): void;
  get(): IFSelect_SelectType;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectType_1 extends Handle_IFSelect_SelectType {
    constructor();
  }

  export declare class Handle_IFSelect_SelectType_2 extends Handle_IFSelect_SelectType {
    constructor(thePtr: IFSelect_SelectType);
  }

  export declare class Handle_IFSelect_SelectType_3 extends Handle_IFSelect_SelectType {
    constructor(theHandle: Handle_IFSelect_SelectType);
  }

  export declare class Handle_IFSelect_SelectType_4 extends Handle_IFSelect_SelectType {
    constructor(theHandle: Handle_IFSelect_SelectType);
  }

export declare class IFSelect_PacketList extends Standard_Transient {
  constructor(model: Handle_Interface_InterfaceModel)
  SetName(name: Standard_CString): void;
  Name(): Standard_CString;
  Model(): Handle_Interface_InterfaceModel;
  AddPacket(): void;
  Add(ent: Handle_Standard_Transient): void;
  AddList(list: Handle_TColStd_HSequenceOfTransient): void;
  NbPackets(): Graphic3d_ZLayerId;
  NbEntities(numpack: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Entities(numpack: Graphic3d_ZLayerId): Interface_EntityIterator;
  HighestDuplicationCount(): Graphic3d_ZLayerId;
  NbDuplicated(count: Graphic3d_ZLayerId, andmore: Standard_Boolean): Graphic3d_ZLayerId;
  Duplicated(count: Graphic3d_ZLayerId, andmore: Standard_Boolean): Interface_EntityIterator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_PacketList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_PacketList): void;
  get(): IFSelect_PacketList;
  delete(): void;
}

  export declare class Handle_IFSelect_PacketList_1 extends Handle_IFSelect_PacketList {
    constructor();
  }

  export declare class Handle_IFSelect_PacketList_2 extends Handle_IFSelect_PacketList {
    constructor(thePtr: IFSelect_PacketList);
  }

  export declare class Handle_IFSelect_PacketList_3 extends Handle_IFSelect_PacketList {
    constructor(theHandle: Handle_IFSelect_PacketList);
  }

  export declare class Handle_IFSelect_PacketList_4 extends Handle_IFSelect_PacketList {
    constructor(theHandle: Handle_IFSelect_PacketList);
  }

export declare class IFSelect_ModifEditForm extends IFSelect_Modifier {
  constructor(editform: Handle_IFSelect_EditForm)
  EditForm(): Handle_IFSelect_EditForm;
  Perform(ctx: IFSelect_ContextModif, target: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_ModifEditForm {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_ModifEditForm): void;
  get(): IFSelect_ModifEditForm;
  delete(): void;
}

  export declare class Handle_IFSelect_ModifEditForm_1 extends Handle_IFSelect_ModifEditForm {
    constructor();
  }

  export declare class Handle_IFSelect_ModifEditForm_2 extends Handle_IFSelect_ModifEditForm {
    constructor(thePtr: IFSelect_ModifEditForm);
  }

  export declare class Handle_IFSelect_ModifEditForm_3 extends Handle_IFSelect_ModifEditForm {
    constructor(theHandle: Handle_IFSelect_ModifEditForm);
  }

  export declare class Handle_IFSelect_ModifEditForm_4 extends Handle_IFSelect_ModifEditForm {
    constructor(theHandle: Handle_IFSelect_ModifEditForm);
  }

export declare class IFSelect_SelectShared extends IFSelect_SelectDeduct {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectShared {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectShared): void;
  get(): IFSelect_SelectShared;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectShared_1 extends Handle_IFSelect_SelectShared {
    constructor();
  }

  export declare class Handle_IFSelect_SelectShared_2 extends Handle_IFSelect_SelectShared {
    constructor(thePtr: IFSelect_SelectShared);
  }

  export declare class Handle_IFSelect_SelectShared_3 extends Handle_IFSelect_SelectShared {
    constructor(theHandle: Handle_IFSelect_SelectShared);
  }

  export declare class Handle_IFSelect_SelectShared_4 extends Handle_IFSelect_SelectShared {
    constructor(theHandle: Handle_IFSelect_SelectShared);
  }

export declare class IFSelect_ShareOutResult {
  ShareOut(): Handle_IFSelect_ShareOut;
  Graph(): Interface_Graph;
  Reset(): void;
  Evaluate(): void;
  Packets(complete: Standard_Boolean): Handle_IFSelect_PacketList;
  NbPackets(): Graphic3d_ZLayerId;
  Prepare(): void;
  More(): Standard_Boolean;
  Next(): void;
  NextDispatch(): void;
  Dispatch(): Handle_IFSelect_Dispatch;
  DispatchRank(): Graphic3d_ZLayerId;
  PacketsInDispatch(numpack: Graphic3d_ZLayerId, nbpacks: Graphic3d_ZLayerId): void;
  PacketRoot(): Interface_EntityIterator;
  PacketContent(): Interface_EntityIterator;
  FileName(): XCAFDoc_PartId;
  delete(): void;
}

  export declare class IFSelect_ShareOutResult_1 extends IFSelect_ShareOutResult {
    constructor(sho: Handle_IFSelect_ShareOut, mod: Handle_Interface_InterfaceModel);
  }

  export declare class IFSelect_ShareOutResult_2 extends IFSelect_ShareOutResult {
    constructor(sho: Handle_IFSelect_ShareOut, G: Interface_Graph);
  }

  export declare class IFSelect_ShareOutResult_3 extends IFSelect_ShareOutResult {
    constructor(disp: Handle_IFSelect_Dispatch, mod: Handle_Interface_InterfaceModel);
  }

  export declare class IFSelect_ShareOutResult_4 extends IFSelect_ShareOutResult {
    constructor(disp: Handle_IFSelect_Dispatch, G: Interface_Graph);
  }

export declare class IFSelect_Editor extends Standard_Transient {
  SetValue(num: Graphic3d_ZLayerId, typval: Handle_Interface_TypedValue, shortname: Standard_CString, accessmode: IFSelect_EditValue): void;
  SetList(num: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): void;
  NbValues(): Graphic3d_ZLayerId;
  TypedValue(num: Graphic3d_ZLayerId): Handle_Interface_TypedValue;
  IsList(num: Graphic3d_ZLayerId): Standard_Boolean;
  MaxList(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Name(num: Graphic3d_ZLayerId, isshort: Standard_Boolean): Standard_CString;
  EditMode(num: Graphic3d_ZLayerId): IFSelect_EditValue;
  NameNumber(name: Standard_CString): Graphic3d_ZLayerId;
  PrintNames(S: Standard_OStream): void;
  PrintDefs(S: Standard_OStream, labels: Standard_Boolean): void;
  MaxNameLength(what: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Label(): XCAFDoc_PartId;
  Form(readonly: Standard_Boolean, undoable: Standard_Boolean): Handle_IFSelect_EditForm;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  ListEditor(num: Graphic3d_ZLayerId): Handle_IFSelect_ListEditor;
  ListValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TColStd_HSequenceOfHAsciiString;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Update(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId, newval: Handle_TCollection_HAsciiString, enforce: Standard_Boolean): Standard_Boolean;
  UpdateList(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId, newlist: Handle_TColStd_HSequenceOfHAsciiString, enforce: Standard_Boolean): Standard_Boolean;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_Editor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Editor): void;
  get(): IFSelect_Editor;
  delete(): void;
}

  export declare class Handle_IFSelect_Editor_1 extends Handle_IFSelect_Editor {
    constructor();
  }

  export declare class Handle_IFSelect_Editor_2 extends Handle_IFSelect_Editor {
    constructor(thePtr: IFSelect_Editor);
  }

  export declare class Handle_IFSelect_Editor_3 extends Handle_IFSelect_Editor {
    constructor(theHandle: Handle_IFSelect_Editor);
  }

  export declare class Handle_IFSelect_Editor_4 extends Handle_IFSelect_Editor {
    constructor(theHandle: Handle_IFSelect_Editor);
  }

export declare class Handle_IFSelect_ModifReorder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_ModifReorder): void;
  get(): IFSelect_ModifReorder;
  delete(): void;
}

  export declare class Handle_IFSelect_ModifReorder_1 extends Handle_IFSelect_ModifReorder {
    constructor();
  }

  export declare class Handle_IFSelect_ModifReorder_2 extends Handle_IFSelect_ModifReorder {
    constructor(thePtr: IFSelect_ModifReorder);
  }

  export declare class Handle_IFSelect_ModifReorder_3 extends Handle_IFSelect_ModifReorder {
    constructor(theHandle: Handle_IFSelect_ModifReorder);
  }

  export declare class Handle_IFSelect_ModifReorder_4 extends Handle_IFSelect_ModifReorder {
    constructor(theHandle: Handle_IFSelect_ModifReorder);
  }

export declare class IFSelect_ModifReorder extends IFSelect_Modifier {
  constructor(rootlast: Standard_Boolean)
  Perform(ctx: IFSelect_ContextModif, target: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, TC: Interface_CopyTool): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectExtract {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectExtract): void;
  get(): IFSelect_SelectExtract;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectExtract_1 extends Handle_IFSelect_SelectExtract {
    constructor();
  }

  export declare class Handle_IFSelect_SelectExtract_2 extends Handle_IFSelect_SelectExtract {
    constructor(thePtr: IFSelect_SelectExtract);
  }

  export declare class Handle_IFSelect_SelectExtract_3 extends Handle_IFSelect_SelectExtract {
    constructor(theHandle: Handle_IFSelect_SelectExtract);
  }

  export declare class Handle_IFSelect_SelectExtract_4 extends Handle_IFSelect_SelectExtract {
    constructor(theHandle: Handle_IFSelect_SelectExtract);
  }

export declare class IFSelect_SelectExtract extends IFSelect_SelectDeduct {
  IsDirect(): Standard_Boolean;
  SetDirect(direct: Standard_Boolean): void;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  SortInGraph(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph): Standard_Boolean;
  Label(): XCAFDoc_PartId;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_WorkSession {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_WorkSession): void;
  get(): IFSelect_WorkSession;
  delete(): void;
}

  export declare class Handle_IFSelect_WorkSession_1 extends Handle_IFSelect_WorkSession {
    constructor();
  }

  export declare class Handle_IFSelect_WorkSession_2 extends Handle_IFSelect_WorkSession {
    constructor(thePtr: IFSelect_WorkSession);
  }

  export declare class Handle_IFSelect_WorkSession_3 extends Handle_IFSelect_WorkSession {
    constructor(theHandle: Handle_IFSelect_WorkSession);
  }

  export declare class Handle_IFSelect_WorkSession_4 extends Handle_IFSelect_WorkSession {
    constructor(theHandle: Handle_IFSelect_WorkSession);
  }

export declare class IFSelect_WorkSession extends Standard_Transient {
  constructor()
  SetErrorHandle(toHandle: Standard_Boolean): void;
  ErrorHandle(): Standard_Boolean;
  ShareOut(): Handle_IFSelect_ShareOut;
  SetShareOut(shareout: Handle_IFSelect_ShareOut): void;
  SetModeStat(theMode: Standard_Boolean): void;
  GetModeStat(): Standard_Boolean;
  SetLibrary(theLib: Handle_IFSelect_WorkLibrary): void;
  WorkLibrary(): Handle_IFSelect_WorkLibrary;
  SetProtocol(protocol: Handle_Interface_Protocol): void;
  Protocol(): Handle_Interface_Protocol;
  SetSignType(signtype: Handle_IFSelect_Signature): void;
  SignType(): Handle_IFSelect_Signature;
  HasModel(): Standard_Boolean;
  SetModel(model: Handle_Interface_InterfaceModel, clearpointed: Standard_Boolean): void;
  Model(): Handle_Interface_InterfaceModel;
  SetLoadedFile(theFileName: Standard_CString): void;
  LoadedFile(): Standard_CString;
  ReadFile(filename: Standard_CString): IFSelect_ReturnStatus;
  ReadStream(theName: Standard_CString, theIStream: Standard_IStream): IFSelect_ReturnStatus;
  NbStartingEntities(): Graphic3d_ZLayerId;
  StartingEntity(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  StartingNumber(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NumberFromLabel(val: Standard_CString, afternum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  EntityLabel(ent: Handle_Standard_Transient): Handle_TCollection_HAsciiString;
  EntityName(ent: Handle_Standard_Transient): Handle_TCollection_HAsciiString;
  CategoryNumber(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CategoryName(ent: Handle_Standard_Transient): Standard_CString;
  ValidityName(ent: Handle_Standard_Transient): Standard_CString;
  ClearData(mode: Graphic3d_ZLayerId): void;
  ComputeGraph(enforce: Standard_Boolean): Standard_Boolean;
  HGraph(): Handle_Interface_HGraph;
  Graph(): Interface_Graph;
  Shareds(ent: Handle_Standard_Transient): Handle_TColStd_HSequenceOfTransient;
  Sharings(ent: Handle_Standard_Transient): Handle_TColStd_HSequenceOfTransient;
  IsLoaded(): Standard_Boolean;
  ComputeCheck(enforce: Standard_Boolean): Standard_Boolean;
  ModelCheckList(complete: Standard_Boolean): Interface_CheckIterator;
  CheckOne(ent: Handle_Standard_Transient, complete: Standard_Boolean): Interface_CheckIterator;
  LastRunCheckList(): Interface_CheckIterator;
  MaxIdent(): Graphic3d_ZLayerId;
  Item(id: Graphic3d_ZLayerId): Handle_Standard_Transient;
  ItemIdent(item: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NamedItem_1(name: Standard_CString): Handle_Standard_Transient;
  NamedItem_2(name: Handle_TCollection_HAsciiString): Handle_Standard_Transient;
  NameIdent(name: Standard_CString): Graphic3d_ZLayerId;
  HasName(item: Handle_Standard_Transient): Standard_Boolean;
  Name(item: Handle_Standard_Transient): Handle_TCollection_HAsciiString;
  AddItem(item: Handle_Standard_Transient, active: Standard_Boolean): Graphic3d_ZLayerId;
  AddNamedItem(name: Standard_CString, item: Handle_Standard_Transient, active: Standard_Boolean): Graphic3d_ZLayerId;
  SetActive(item: Handle_Standard_Transient, mode: Standard_Boolean): Standard_Boolean;
  RemoveNamedItem(name: Standard_CString): Standard_Boolean;
  RemoveName(name: Standard_CString): Standard_Boolean;
  RemoveItem(item: Handle_Standard_Transient): Standard_Boolean;
  ClearItems(): void;
  ItemLabel(id: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  ItemIdents(type: Handle_Standard_Type): Handle_TColStd_HSequenceOfInteger;
  ItemNames(type: Handle_Standard_Type): Handle_TColStd_HSequenceOfHAsciiString;
  ItemNamesForLabel(label: Standard_CString): Handle_TColStd_HSequenceOfHAsciiString;
  NextIdentForLabel(label: Standard_CString, id: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NewParamFromStatic(statname: Standard_CString, name: Standard_CString): Handle_Standard_Transient;
  IntParam(id: Graphic3d_ZLayerId): Handle_IFSelect_IntParam;
  IntValue(it: Handle_IFSelect_IntParam): Graphic3d_ZLayerId;
  NewIntParam(name: Standard_CString): Handle_IFSelect_IntParam;
  SetIntValue(it: Handle_IFSelect_IntParam, val: Graphic3d_ZLayerId): Standard_Boolean;
  TextParam(id: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  TextValue(par: Handle_TCollection_HAsciiString): XCAFDoc_PartId;
  NewTextParam(name: Standard_CString): Handle_TCollection_HAsciiString;
  SetTextValue(par: Handle_TCollection_HAsciiString, val: Standard_CString): Standard_Boolean;
  Signature(id: Graphic3d_ZLayerId): Handle_IFSelect_Signature;
  SignValue(sign: Handle_IFSelect_Signature, ent: Handle_Standard_Transient): Standard_CString;
  Selection(id: Graphic3d_ZLayerId): Handle_IFSelect_Selection;
  EvalSelection(sel: Handle_IFSelect_Selection): Interface_EntityIterator;
  Sources(sel: Handle_IFSelect_Selection): IFSelect_SelectionIterator;
  SelectionResult(sel: Handle_IFSelect_Selection): Handle_TColStd_HSequenceOfTransient;
  SelectionResultFromList(sel: Handle_IFSelect_Selection, list: Handle_TColStd_HSequenceOfTransient): Handle_TColStd_HSequenceOfTransient;
  SetItemSelection(item: Handle_Standard_Transient, sel: Handle_IFSelect_Selection): Standard_Boolean;
  ResetItemSelection(item: Handle_Standard_Transient): Standard_Boolean;
  ItemSelection(item: Handle_Standard_Transient): Handle_IFSelect_Selection;
  SignCounter(id: Graphic3d_ZLayerId): Handle_IFSelect_SignCounter;
  ComputeCounter(counter: Handle_IFSelect_SignCounter, forced: Standard_Boolean): Standard_Boolean;
  ComputeCounterFromList(counter: Handle_IFSelect_SignCounter, list: Handle_TColStd_HSequenceOfTransient, clear: Standard_Boolean): Standard_Boolean;
  AppliedDispatches(): Handle_TColStd_HSequenceOfInteger;
  ClearShareOut(onlydisp: Standard_Boolean): void;
  Dispatch(id: Graphic3d_ZLayerId): Handle_IFSelect_Dispatch;
  DispatchRank(disp: Handle_IFSelect_Dispatch): Graphic3d_ZLayerId;
  ModelCopier(): Handle_IFSelect_ModelCopier;
  SetModelCopier(copier: Handle_IFSelect_ModelCopier): void;
  NbFinalModifiers(formodel: Standard_Boolean): Graphic3d_ZLayerId;
  FinalModifierIdents(formodel: Standard_Boolean): Handle_TColStd_HSequenceOfInteger;
  GeneralModifier(id: Graphic3d_ZLayerId): Handle_IFSelect_GeneralModifier;
  ModelModifier(id: Graphic3d_ZLayerId): Handle_IFSelect_Modifier;
  ModifierRank(item: Handle_IFSelect_GeneralModifier): Graphic3d_ZLayerId;
  ChangeModifierRank(formodel: Standard_Boolean, before: Graphic3d_ZLayerId, after: Graphic3d_ZLayerId): Standard_Boolean;
  ClearFinalModifiers(): void;
  SetAppliedModifier(modif: Handle_IFSelect_GeneralModifier, item: Handle_Standard_Transient): Standard_Boolean;
  ResetAppliedModifier(modif: Handle_IFSelect_GeneralModifier): Standard_Boolean;
  UsesAppliedModifier(modif: Handle_IFSelect_GeneralModifier): Handle_Standard_Transient;
  Transformer(id: Graphic3d_ZLayerId): Handle_IFSelect_Transformer;
  RunTransformer(transf: Handle_IFSelect_Transformer): Graphic3d_ZLayerId;
  RunModifier(modif: Handle_IFSelect_Modifier, copy: Standard_Boolean): Graphic3d_ZLayerId;
  RunModifierSelected(modif: Handle_IFSelect_Modifier, sel: Handle_IFSelect_Selection, copy: Standard_Boolean): Graphic3d_ZLayerId;
  NewTransformStandard(copy: Standard_Boolean, name: Standard_CString): Handle_IFSelect_Transformer;
  SetModelContent(sel: Handle_IFSelect_Selection, keep: Standard_Boolean): Standard_Boolean;
  FilePrefix(): Handle_TCollection_HAsciiString;
  DefaultFileRoot(): Handle_TCollection_HAsciiString;
  FileExtension(): Handle_TCollection_HAsciiString;
  FileRoot(disp: Handle_IFSelect_Dispatch): Handle_TCollection_HAsciiString;
  SetFilePrefix(name: Standard_CString): void;
  SetDefaultFileRoot(name: Standard_CString): Standard_Boolean;
  SetFileExtension(name: Standard_CString): void;
  SetFileRoot(disp: Handle_IFSelect_Dispatch, name: Standard_CString): Standard_Boolean;
  GiveFileRoot(file: Standard_CString): Standard_CString;
  GiveFileComplete(file: Standard_CString): Standard_CString;
  ClearFile(): void;
  EvaluateFile(): void;
  NbFiles(): Graphic3d_ZLayerId;
  FileModel(num: Graphic3d_ZLayerId): Handle_Interface_InterfaceModel;
  FileName(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  BeginSentFiles(record: Standard_Boolean): void;
  SentFiles(): Handle_TColStd_HSequenceOfHAsciiString;
  SendSplit(): Standard_Boolean;
  EvalSplit(): Handle_IFSelect_PacketList;
  SentList(count: Graphic3d_ZLayerId): Interface_EntityIterator;
  MaxSendingCount(): Graphic3d_ZLayerId;
  SetRemaining(mode: IFSelect_RemainMode): Standard_Boolean;
  SendAll(filename: Standard_CString, computegraph: Standard_Boolean): IFSelect_ReturnStatus;
  SendSelected(filename: Standard_CString, sel: Handle_IFSelect_Selection, computegraph: Standard_Boolean): IFSelect_ReturnStatus;
  WriteFile_1(filename: Standard_CString): IFSelect_ReturnStatus;
  WriteFile_2(filename: Standard_CString, sel: Handle_IFSelect_Selection): IFSelect_ReturnStatus;
  NbSources(sel: Handle_IFSelect_Selection): Graphic3d_ZLayerId;
  Source(sel: Handle_IFSelect_Selection, num: Graphic3d_ZLayerId): Handle_IFSelect_Selection;
  IsReversedSelectExtract(sel: Handle_IFSelect_Selection): Standard_Boolean;
  ToggleSelectExtract(sel: Handle_IFSelect_Selection): Standard_Boolean;
  SetInputSelection(sel: Handle_IFSelect_Selection, input: Handle_IFSelect_Selection): Standard_Boolean;
  SetControl(sel: Handle_IFSelect_Selection, sc: Handle_IFSelect_Selection, formain: Standard_Boolean): Standard_Boolean;
  CombineAdd(selcomb: Handle_IFSelect_Selection, seladd: Handle_IFSelect_Selection, atnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  CombineRemove(selcomb: Handle_IFSelect_Selection, selrem: Handle_IFSelect_Selection): Standard_Boolean;
  NewSelectPointed(list: Handle_TColStd_HSequenceOfTransient, name: Standard_CString): Handle_IFSelect_Selection;
  SetSelectPointed(sel: Handle_IFSelect_Selection, list: Handle_TColStd_HSequenceOfTransient, mode: Graphic3d_ZLayerId): Standard_Boolean;
  GiveSelection(selname: Standard_CString): Handle_IFSelect_Selection;
  GiveList_1(obj: Handle_Standard_Transient): Handle_TColStd_HSequenceOfTransient;
  GiveList_2(first: Standard_CString, second: Standard_CString): Handle_TColStd_HSequenceOfTransient;
  GiveListFromList(selname: Standard_CString, ent: Handle_Standard_Transient): Handle_TColStd_HSequenceOfTransient;
  GiveListCombined(l1: Handle_TColStd_HSequenceOfTransient, l2: Handle_TColStd_HSequenceOfTransient, mode: Graphic3d_ZLayerId): Handle_TColStd_HSequenceOfTransient;
  QueryCheckList(chl: Interface_CheckIterator): void;
  QueryCheckStatus(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  QueryParent(entdad: Handle_Standard_Transient, entson: Handle_Standard_Transient): Graphic3d_ZLayerId;
  SetParams(params: any, uselist: NCollection_Vector<Standard_Integer>): void;
  TraceStatics(use: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  DumpShare(): void;
  ListItems(label: Standard_CString): void;
  ListFinalModifiers(formodel: Standard_Boolean): void;
  DumpSelection(sel: Handle_IFSelect_Selection): void;
  DumpModel(level: Graphic3d_ZLayerId, S: Standard_OStream): void;
  TraceDumpModel(mode: Graphic3d_ZLayerId): void;
  DumpEntity(ent: Handle_Standard_Transient, level: Graphic3d_ZLayerId, S: Standard_OStream): void;
  PrintEntityStatus(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  TraceDumpEntity(ent: Handle_Standard_Transient, level: Graphic3d_ZLayerId): void;
  PrintCheckList(S: Standard_OStream, checklist: Interface_CheckIterator, failsonly: Standard_Boolean, mode: IFSelect_PrintCount): void;
  PrintSignatureList(S: Standard_OStream, signlist: Handle_IFSelect_SignatureList, mode: IFSelect_PrintCount): void;
  EvaluateSelection(sel: Handle_IFSelect_Selection): void;
  EvaluateDispatch(disp: Handle_IFSelect_Dispatch, mode: Graphic3d_ZLayerId): void;
  EvaluateComplete(mode: Graphic3d_ZLayerId): void;
  ListEntities(iter: Interface_EntityIterator, mode: Graphic3d_ZLayerId, S: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_Modifier extends IFSelect_GeneralModifier {
  Perform(ctx: IFSelect_ContextModif, target: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, TC: Interface_CopyTool): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_Modifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Modifier): void;
  get(): IFSelect_Modifier;
  delete(): void;
}

  export declare class Handle_IFSelect_Modifier_1 extends Handle_IFSelect_Modifier {
    constructor();
  }

  export declare class Handle_IFSelect_Modifier_2 extends Handle_IFSelect_Modifier {
    constructor(thePtr: IFSelect_Modifier);
  }

  export declare class Handle_IFSelect_Modifier_3 extends Handle_IFSelect_Modifier {
    constructor(theHandle: Handle_IFSelect_Modifier);
  }

  export declare class Handle_IFSelect_Modifier_4 extends Handle_IFSelect_Modifier {
    constructor(theHandle: Handle_IFSelect_Modifier);
  }

export declare class Handle_IFSelect_ListEditor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_ListEditor): void;
  get(): IFSelect_ListEditor;
  delete(): void;
}

  export declare class Handle_IFSelect_ListEditor_1 extends Handle_IFSelect_ListEditor {
    constructor();
  }

  export declare class Handle_IFSelect_ListEditor_2 extends Handle_IFSelect_ListEditor {
    constructor(thePtr: IFSelect_ListEditor);
  }

  export declare class Handle_IFSelect_ListEditor_3 extends Handle_IFSelect_ListEditor {
    constructor(theHandle: Handle_IFSelect_ListEditor);
  }

  export declare class Handle_IFSelect_ListEditor_4 extends Handle_IFSelect_ListEditor {
    constructor(theHandle: Handle_IFSelect_ListEditor);
  }

export declare class IFSelect_ListEditor extends Standard_Transient {
  LoadModel(model: Handle_Interface_InterfaceModel): void;
  LoadValues(vals: Handle_TColStd_HSequenceOfHAsciiString): void;
  SetTouched(): void;
  ClearEdit(): void;
  LoadEdited(list: Handle_TColStd_HSequenceOfHAsciiString): Standard_Boolean;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_TCollection_HAsciiString): Standard_Boolean;
  AddValue(val: Handle_TCollection_HAsciiString, atnum: Graphic3d_ZLayerId): Standard_Boolean;
  Remove(num: Graphic3d_ZLayerId, howmany: Graphic3d_ZLayerId): Standard_Boolean;
  OriginalValues(): Handle_TColStd_HSequenceOfHAsciiString;
  EditedValues(): Handle_TColStd_HSequenceOfHAsciiString;
  NbValues(edited: Standard_Boolean): Graphic3d_ZLayerId;
  Value(num: Graphic3d_ZLayerId, edited: Standard_Boolean): Handle_TCollection_HAsciiString;
  IsChanged(num: Graphic3d_ZLayerId): Standard_Boolean;
  IsModified(num: Graphic3d_ZLayerId): Standard_Boolean;
  IsAdded(num: Graphic3d_ZLayerId): Standard_Boolean;
  IsTouched(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IFSelect_ListEditor_1 extends IFSelect_ListEditor {
    constructor();
  }

  export declare class IFSelect_ListEditor_2 extends IFSelect_ListEditor {
    constructor(def: Handle_Interface_TypedValue, max: Graphic3d_ZLayerId);
  }

export declare class IFSelect_SelectRange extends IFSelect_SelectExtract {
  constructor()
  SetRange(rankfrom: Handle_IFSelect_IntParam, rankto: Handle_IFSelect_IntParam): void;
  SetOne(rank: Handle_IFSelect_IntParam): void;
  SetFrom(rankfrom: Handle_IFSelect_IntParam): void;
  SetUntil(rankto: Handle_IFSelect_IntParam): void;
  HasLower(): Standard_Boolean;
  Lower(): Handle_IFSelect_IntParam;
  LowerValue(): Graphic3d_ZLayerId;
  HasUpper(): Standard_Boolean;
  Upper(): Handle_IFSelect_IntParam;
  UpperValue(): Graphic3d_ZLayerId;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectRange {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectRange): void;
  get(): IFSelect_SelectRange;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectRange_1 extends Handle_IFSelect_SelectRange {
    constructor();
  }

  export declare class Handle_IFSelect_SelectRange_2 extends Handle_IFSelect_SelectRange {
    constructor(thePtr: IFSelect_SelectRange);
  }

  export declare class Handle_IFSelect_SelectRange_3 extends Handle_IFSelect_SelectRange {
    constructor(theHandle: Handle_IFSelect_SelectRange);
  }

  export declare class Handle_IFSelect_SelectRange_4 extends Handle_IFSelect_SelectRange {
    constructor(theHandle: Handle_IFSelect_SelectRange);
  }

export declare class Handle_IFSelect_ShareOut {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_ShareOut): void;
  get(): IFSelect_ShareOut;
  delete(): void;
}

  export declare class Handle_IFSelect_ShareOut_1 extends Handle_IFSelect_ShareOut {
    constructor();
  }

  export declare class Handle_IFSelect_ShareOut_2 extends Handle_IFSelect_ShareOut {
    constructor(thePtr: IFSelect_ShareOut);
  }

  export declare class Handle_IFSelect_ShareOut_3 extends Handle_IFSelect_ShareOut {
    constructor(theHandle: Handle_IFSelect_ShareOut);
  }

  export declare class Handle_IFSelect_ShareOut_4 extends Handle_IFSelect_ShareOut {
    constructor(theHandle: Handle_IFSelect_ShareOut);
  }

export declare class IFSelect_ShareOut extends Standard_Transient {
  constructor()
  Clear(onlydisp: Standard_Boolean): void;
  ClearResult(alsoname: Standard_Boolean): void;
  RemoveItem(item: Handle_Standard_Transient): Standard_Boolean;
  LastRun(): Graphic3d_ZLayerId;
  SetLastRun(last: Graphic3d_ZLayerId): void;
  NbDispatches(): Graphic3d_ZLayerId;
  DispatchRank(disp: Handle_IFSelect_Dispatch): Graphic3d_ZLayerId;
  Dispatch(num: Graphic3d_ZLayerId): Handle_IFSelect_Dispatch;
  AddDispatch(disp: Handle_IFSelect_Dispatch): void;
  RemoveDispatch(rank: Graphic3d_ZLayerId): Standard_Boolean;
  AddModifier_1(modifier: Handle_IFSelect_GeneralModifier, atnum: Graphic3d_ZLayerId): void;
  AddModifier_2(modifier: Handle_IFSelect_GeneralModifier, dispnum: Graphic3d_ZLayerId, atnum: Graphic3d_ZLayerId): void;
  AddModif(modifier: Handle_IFSelect_GeneralModifier, formodel: Standard_Boolean, atnum: Graphic3d_ZLayerId): void;
  NbModifiers(formodel: Standard_Boolean): Graphic3d_ZLayerId;
  GeneralModifier(formodel: Standard_Boolean, num: Graphic3d_ZLayerId): Handle_IFSelect_GeneralModifier;
  ModelModifier(num: Graphic3d_ZLayerId): Handle_IFSelect_Modifier;
  ModifierRank(modifier: Handle_IFSelect_GeneralModifier): Graphic3d_ZLayerId;
  RemoveModifier(formodel: Standard_Boolean, num: Graphic3d_ZLayerId): Standard_Boolean;
  ChangeModifierRank(formodel: Standard_Boolean, befor: Graphic3d_ZLayerId, after: Graphic3d_ZLayerId): Standard_Boolean;
  SetRootName(num: Graphic3d_ZLayerId, name: Handle_TCollection_HAsciiString): Standard_Boolean;
  HasRootName(num: Graphic3d_ZLayerId): Standard_Boolean;
  RootName(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  RootNumber(name: Handle_TCollection_HAsciiString): Graphic3d_ZLayerId;
  SetPrefix(pref: Handle_TCollection_HAsciiString): void;
  SetDefaultRootName(defrt: Handle_TCollection_HAsciiString): Standard_Boolean;
  SetExtension(ext: Handle_TCollection_HAsciiString): void;
  Prefix(): Handle_TCollection_HAsciiString;
  DefaultRootName(): Handle_TCollection_HAsciiString;
  Extension(): Handle_TCollection_HAsciiString;
  FileName(dnum: Graphic3d_ZLayerId, pnum: Graphic3d_ZLayerId, nbpack: Graphic3d_ZLayerId): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_EditForm {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_EditForm): void;
  get(): IFSelect_EditForm;
  delete(): void;
}

  export declare class Handle_IFSelect_EditForm_1 extends Handle_IFSelect_EditForm {
    constructor();
  }

  export declare class Handle_IFSelect_EditForm_2 extends Handle_IFSelect_EditForm {
    constructor(thePtr: IFSelect_EditForm);
  }

  export declare class Handle_IFSelect_EditForm_3 extends Handle_IFSelect_EditForm {
    constructor(theHandle: Handle_IFSelect_EditForm);
  }

  export declare class Handle_IFSelect_EditForm_4 extends Handle_IFSelect_EditForm {
    constructor(theHandle: Handle_IFSelect_EditForm);
  }

export declare class IFSelect_Signature extends Interface_SignType {
  SetIntCase(hasmin: Standard_Boolean, valmin: Graphic3d_ZLayerId, hasmax: Standard_Boolean, valmax: Graphic3d_ZLayerId): void;
  IsIntCase(hasmin: Standard_Boolean, valmin: Graphic3d_ZLayerId, hasmax: Standard_Boolean, valmax: Graphic3d_ZLayerId): Standard_Boolean;
  AddCase(acase: Standard_CString): void;
  CaseList(): Handle_TColStd_HSequenceOfAsciiString;
  Name(): Standard_CString;
  Label(): XCAFDoc_PartId;
  Matches(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel, text: XCAFDoc_PartId, exact: Standard_Boolean): Standard_Boolean;
  static MatchValue(val: Standard_CString, text: XCAFDoc_PartId, exact: Standard_Boolean): Standard_Boolean;
  static IntValue(val: Graphic3d_ZLayerId): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_Signature {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Signature): void;
  get(): IFSelect_Signature;
  delete(): void;
}

  export declare class Handle_IFSelect_Signature_1 extends Handle_IFSelect_Signature {
    constructor();
  }

  export declare class Handle_IFSelect_Signature_2 extends Handle_IFSelect_Signature {
    constructor(thePtr: IFSelect_Signature);
  }

  export declare class Handle_IFSelect_Signature_3 extends Handle_IFSelect_Signature {
    constructor(theHandle: Handle_IFSelect_Signature);
  }

  export declare class Handle_IFSelect_Signature_4 extends Handle_IFSelect_Signature {
    constructor(theHandle: Handle_IFSelect_Signature);
  }

export declare class IFSelect_SelectionIterator {
  AddFromIter(iter: IFSelect_SelectionIterator): void;
  AddItem(sel: Handle_IFSelect_Selection): void;
  AddList(list: IFSelect_TSeqOfSelection): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_IFSelect_Selection;
  delete(): void;
}

  export declare class IFSelect_SelectionIterator_1 extends IFSelect_SelectionIterator {
    constructor();
  }

  export declare class IFSelect_SelectionIterator_2 extends IFSelect_SelectionIterator {
    constructor(sel: Handle_IFSelect_Selection);
  }

export declare class Handle_IFSelect_DispPerCount {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_DispPerCount): void;
  get(): IFSelect_DispPerCount;
  delete(): void;
}

  export declare class Handle_IFSelect_DispPerCount_1 extends Handle_IFSelect_DispPerCount {
    constructor();
  }

  export declare class Handle_IFSelect_DispPerCount_2 extends Handle_IFSelect_DispPerCount {
    constructor(thePtr: IFSelect_DispPerCount);
  }

  export declare class Handle_IFSelect_DispPerCount_3 extends Handle_IFSelect_DispPerCount {
    constructor(theHandle: Handle_IFSelect_DispPerCount);
  }

  export declare class Handle_IFSelect_DispPerCount_4 extends Handle_IFSelect_DispPerCount {
    constructor(theHandle: Handle_IFSelect_DispPerCount);
  }

export declare class IFSelect_DispPerCount extends IFSelect_Dispatch {
  constructor()
  Count(): Handle_IFSelect_IntParam;
  SetCount(count: Handle_IFSelect_IntParam): void;
  CountValue(): Graphic3d_ZLayerId;
  Label(): XCAFDoc_PartId;
  LimitedMax(nbent: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_Boolean;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectControl {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectControl): void;
  get(): IFSelect_SelectControl;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectControl_1 extends Handle_IFSelect_SelectControl {
    constructor();
  }

  export declare class Handle_IFSelect_SelectControl_2 extends Handle_IFSelect_SelectControl {
    constructor(thePtr: IFSelect_SelectControl);
  }

  export declare class Handle_IFSelect_SelectControl_3 extends Handle_IFSelect_SelectControl {
    constructor(theHandle: Handle_IFSelect_SelectControl);
  }

  export declare class Handle_IFSelect_SelectControl_4 extends Handle_IFSelect_SelectControl {
    constructor(theHandle: Handle_IFSelect_SelectControl);
  }

export declare class IFSelect_SelectControl extends IFSelect_Selection {
  MainInput(): Handle_IFSelect_Selection;
  HasSecondInput(): Standard_Boolean;
  SecondInput(): Handle_IFSelect_Selection;
  SetMainInput(sel: Handle_IFSelect_Selection): void;
  SetSecondInput(sel: Handle_IFSelect_Selection): void;
  FillIterator(iter: IFSelect_SelectionIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SelectSignedShared extends IFSelect_SelectExplore {
  constructor(matcher: Handle_IFSelect_Signature, signtext: Standard_CString, exact: Standard_Boolean, level: Graphic3d_ZLayerId)
  Signature(): Handle_IFSelect_Signature;
  SignatureText(): XCAFDoc_PartId;
  IsExact(): Standard_Boolean;
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectSignedShared {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectSignedShared): void;
  get(): IFSelect_SelectSignedShared;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectSignedShared_1 extends Handle_IFSelect_SelectSignedShared {
    constructor();
  }

  export declare class Handle_IFSelect_SelectSignedShared_2 extends Handle_IFSelect_SelectSignedShared {
    constructor(thePtr: IFSelect_SelectSignedShared);
  }

  export declare class Handle_IFSelect_SelectSignedShared_3 extends Handle_IFSelect_SelectSignedShared {
    constructor(theHandle: Handle_IFSelect_SelectSignedShared);
  }

  export declare class Handle_IFSelect_SelectSignedShared_4 extends Handle_IFSelect_SelectSignedShared {
    constructor(theHandle: Handle_IFSelect_SelectSignedShared);
  }

export declare class IFSelect_Selection extends Standard_Transient {
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  UniqueResult(G: Interface_Graph): Interface_EntityIterator;
  CompleteResult(G: Interface_Graph): Interface_EntityIterator;
  FillIterator(iter: IFSelect_SelectionIterator): void;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_Selection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Selection): void;
  get(): IFSelect_Selection;
  delete(): void;
}

  export declare class Handle_IFSelect_Selection_1 extends Handle_IFSelect_Selection {
    constructor();
  }

  export declare class Handle_IFSelect_Selection_2 extends Handle_IFSelect_Selection {
    constructor(thePtr: IFSelect_Selection);
  }

  export declare class Handle_IFSelect_Selection_3 extends Handle_IFSelect_Selection {
    constructor(theHandle: Handle_IFSelect_Selection);
  }

  export declare class Handle_IFSelect_Selection_4 extends Handle_IFSelect_Selection {
    constructor(theHandle: Handle_IFSelect_Selection);
  }

export declare class IFSelect_BasicDumper extends IFSelect_SessionDumper {
  constructor()
  WriteOwn(file: IFSelect_SessionFile, item: Handle_Standard_Transient): Standard_Boolean;
  ReadOwn(file: IFSelect_SessionFile, type: XCAFDoc_PartId, item: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_BasicDumper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_BasicDumper): void;
  get(): IFSelect_BasicDumper;
  delete(): void;
}

  export declare class Handle_IFSelect_BasicDumper_1 extends Handle_IFSelect_BasicDumper {
    constructor();
  }

  export declare class Handle_IFSelect_BasicDumper_2 extends Handle_IFSelect_BasicDumper {
    constructor(thePtr: IFSelect_BasicDumper);
  }

  export declare class Handle_IFSelect_BasicDumper_3 extends Handle_IFSelect_BasicDumper {
    constructor(theHandle: Handle_IFSelect_BasicDumper);
  }

  export declare class Handle_IFSelect_BasicDumper_4 extends Handle_IFSelect_BasicDumper {
    constructor(theHandle: Handle_IFSelect_BasicDumper);
  }

export declare class Handle_IFSelect_SelectCombine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectCombine): void;
  get(): IFSelect_SelectCombine;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectCombine_1 extends Handle_IFSelect_SelectCombine {
    constructor();
  }

  export declare class Handle_IFSelect_SelectCombine_2 extends Handle_IFSelect_SelectCombine {
    constructor(thePtr: IFSelect_SelectCombine);
  }

  export declare class Handle_IFSelect_SelectCombine_3 extends Handle_IFSelect_SelectCombine {
    constructor(theHandle: Handle_IFSelect_SelectCombine);
  }

  export declare class Handle_IFSelect_SelectCombine_4 extends Handle_IFSelect_SelectCombine {
    constructor(theHandle: Handle_IFSelect_SelectCombine);
  }

export declare class IFSelect_SelectCombine extends IFSelect_Selection {
  NbInputs(): Graphic3d_ZLayerId;
  Input(num: Graphic3d_ZLayerId): Handle_IFSelect_Selection;
  InputRank(sel: Handle_IFSelect_Selection): Graphic3d_ZLayerId;
  Add(sel: Handle_IFSelect_Selection, atnum: Graphic3d_ZLayerId): void;
  Remove_1(sel: Handle_IFSelect_Selection): Standard_Boolean;
  Remove_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  FillIterator(iter: IFSelect_SelectionIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectDiff {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectDiff): void;
  get(): IFSelect_SelectDiff;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectDiff_1 extends Handle_IFSelect_SelectDiff {
    constructor();
  }

  export declare class Handle_IFSelect_SelectDiff_2 extends Handle_IFSelect_SelectDiff {
    constructor(thePtr: IFSelect_SelectDiff);
  }

  export declare class Handle_IFSelect_SelectDiff_3 extends Handle_IFSelect_SelectDiff {
    constructor(theHandle: Handle_IFSelect_SelectDiff);
  }

  export declare class Handle_IFSelect_SelectDiff_4 extends Handle_IFSelect_SelectDiff {
    constructor(theHandle: Handle_IFSelect_SelectDiff);
  }

export declare class IFSelect_SelectDiff extends IFSelect_SelectControl {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_Functions {
  constructor();
  static GiveEntity(WS: Handle_IFSelect_WorkSession, name: Standard_CString): Handle_Standard_Transient;
  static GiveEntityNumber(WS: Handle_IFSelect_WorkSession, name: Standard_CString): Graphic3d_ZLayerId;
  static GiveList(WS: Handle_IFSelect_WorkSession, first: Standard_CString, second: Standard_CString): Handle_TColStd_HSequenceOfTransient;
  static GiveDispatch(WS: Handle_IFSelect_WorkSession, name: Standard_CString, mode: Standard_Boolean): Handle_IFSelect_Dispatch;
  static Init(): void;
  delete(): void;
}

export declare class Handle_IFSelect_SelectSignedSharing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectSignedSharing): void;
  get(): IFSelect_SelectSignedSharing;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectSignedSharing_1 extends Handle_IFSelect_SelectSignedSharing {
    constructor();
  }

  export declare class Handle_IFSelect_SelectSignedSharing_2 extends Handle_IFSelect_SelectSignedSharing {
    constructor(thePtr: IFSelect_SelectSignedSharing);
  }

  export declare class Handle_IFSelect_SelectSignedSharing_3 extends Handle_IFSelect_SelectSignedSharing {
    constructor(theHandle: Handle_IFSelect_SelectSignedSharing);
  }

  export declare class Handle_IFSelect_SelectSignedSharing_4 extends Handle_IFSelect_SelectSignedSharing {
    constructor(theHandle: Handle_IFSelect_SelectSignedSharing);
  }

export declare class IFSelect_SelectSignedSharing extends IFSelect_SelectExplore {
  constructor(matcher: Handle_IFSelect_Signature, signtext: Standard_CString, exact: Standard_Boolean, level: Graphic3d_ZLayerId)
  Signature(): Handle_IFSelect_Signature;
  SignatureText(): XCAFDoc_PartId;
  IsExact(): Standard_Boolean;
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_Transformer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Transformer): void;
  get(): IFSelect_Transformer;
  delete(): void;
}

  export declare class Handle_IFSelect_Transformer_1 extends Handle_IFSelect_Transformer {
    constructor();
  }

  export declare class Handle_IFSelect_Transformer_2 extends Handle_IFSelect_Transformer {
    constructor(thePtr: IFSelect_Transformer);
  }

  export declare class Handle_IFSelect_Transformer_3 extends Handle_IFSelect_Transformer {
    constructor(theHandle: Handle_IFSelect_Transformer);
  }

  export declare class Handle_IFSelect_Transformer_4 extends Handle_IFSelect_Transformer {
    constructor(theHandle: Handle_IFSelect_Transformer);
  }

export declare class IFSelect_Transformer extends Standard_Transient {
  Perform(G: Interface_Graph, protocol: Handle_Interface_Protocol, checks: Interface_CheckIterator, newmod: Handle_Interface_InterfaceModel): Standard_Boolean;
  ChangeProtocol(newproto: Handle_Interface_Protocol): Standard_Boolean;
  Updated(entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient): Standard_Boolean;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect {
  constructor();
  static SaveSession(WS: Handle_IFSelect_WorkSession, file: Standard_CString): Standard_Boolean;
  static RestoreSession(WS: Handle_IFSelect_WorkSession, file: Standard_CString): Standard_Boolean;
  delete(): void;
}

export declare class IFSelect_CheckCounter extends IFSelect_SignatureList {
  constructor(withlist: Standard_Boolean)
  SetSignature(sign: Handle_MoniTool_SignText): void;
  Signature(): Handle_MoniTool_SignText;
  Analyse(list: Interface_CheckIterator, model: Handle_Interface_InterfaceModel, original: Standard_Boolean, failsonly: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_CheckCounter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_CheckCounter): void;
  get(): IFSelect_CheckCounter;
  delete(): void;
}

  export declare class Handle_IFSelect_CheckCounter_1 extends Handle_IFSelect_CheckCounter {
    constructor();
  }

  export declare class Handle_IFSelect_CheckCounter_2 extends Handle_IFSelect_CheckCounter {
    constructor(thePtr: IFSelect_CheckCounter);
  }

  export declare class Handle_IFSelect_CheckCounter_3 extends Handle_IFSelect_CheckCounter {
    constructor(theHandle: Handle_IFSelect_CheckCounter);
  }

  export declare class Handle_IFSelect_CheckCounter_4 extends Handle_IFSelect_CheckCounter {
    constructor(theHandle: Handle_IFSelect_CheckCounter);
  }

export declare class Handle_IFSelect_SelectAnyType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectAnyType): void;
  get(): IFSelect_SelectAnyType;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectAnyType_1 extends Handle_IFSelect_SelectAnyType {
    constructor();
  }

  export declare class Handle_IFSelect_SelectAnyType_2 extends Handle_IFSelect_SelectAnyType {
    constructor(thePtr: IFSelect_SelectAnyType);
  }

  export declare class Handle_IFSelect_SelectAnyType_3 extends Handle_IFSelect_SelectAnyType {
    constructor(theHandle: Handle_IFSelect_SelectAnyType);
  }

  export declare class Handle_IFSelect_SelectAnyType_4 extends Handle_IFSelect_SelectAnyType {
    constructor(theHandle: Handle_IFSelect_SelectAnyType);
  }

export declare class IFSelect_SelectAnyType extends IFSelect_SelectExtract {
  TypeForMatch(): Handle_Standard_Type;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectDeduct {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectDeduct): void;
  get(): IFSelect_SelectDeduct;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectDeduct_1 extends Handle_IFSelect_SelectDeduct {
    constructor();
  }

  export declare class Handle_IFSelect_SelectDeduct_2 extends Handle_IFSelect_SelectDeduct {
    constructor(thePtr: IFSelect_SelectDeduct);
  }

  export declare class Handle_IFSelect_SelectDeduct_3 extends Handle_IFSelect_SelectDeduct {
    constructor(theHandle: Handle_IFSelect_SelectDeduct);
  }

  export declare class Handle_IFSelect_SelectDeduct_4 extends Handle_IFSelect_SelectDeduct {
    constructor(theHandle: Handle_IFSelect_SelectDeduct);
  }

export declare class IFSelect_SelectDeduct extends IFSelect_Selection {
  SetInput(sel: Handle_IFSelect_Selection): void;
  Input(): Handle_IFSelect_Selection;
  HasInput(): Standard_Boolean;
  HasAlternate(): Standard_Boolean;
  Alternate(): Handle_IFSelect_SelectPointed;
  InputResult(G: Interface_Graph): Interface_EntityIterator;
  FillIterator(iter: IFSelect_SelectionIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SignAncestor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignAncestor): void;
  get(): IFSelect_SignAncestor;
  delete(): void;
}

  export declare class Handle_IFSelect_SignAncestor_1 extends Handle_IFSelect_SignAncestor {
    constructor();
  }

  export declare class Handle_IFSelect_SignAncestor_2 extends Handle_IFSelect_SignAncestor {
    constructor(thePtr: IFSelect_SignAncestor);
  }

  export declare class Handle_IFSelect_SignAncestor_3 extends Handle_IFSelect_SignAncestor {
    constructor(theHandle: Handle_IFSelect_SignAncestor);
  }

  export declare class Handle_IFSelect_SignAncestor_4 extends Handle_IFSelect_SignAncestor {
    constructor(theHandle: Handle_IFSelect_SignAncestor);
  }

export declare class IFSelect_SignAncestor extends IFSelect_SignType {
  constructor(nopk: Standard_Boolean)
  Matches(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel, text: XCAFDoc_PartId, exact: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SignMultiple {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignMultiple): void;
  get(): IFSelect_SignMultiple;
  delete(): void;
}

  export declare class Handle_IFSelect_SignMultiple_1 extends Handle_IFSelect_SignMultiple {
    constructor();
  }

  export declare class Handle_IFSelect_SignMultiple_2 extends Handle_IFSelect_SignMultiple {
    constructor(thePtr: IFSelect_SignMultiple);
  }

  export declare class Handle_IFSelect_SignMultiple_3 extends Handle_IFSelect_SignMultiple {
    constructor(theHandle: Handle_IFSelect_SignMultiple);
  }

  export declare class Handle_IFSelect_SignMultiple_4 extends Handle_IFSelect_SignMultiple {
    constructor(theHandle: Handle_IFSelect_SignMultiple);
  }

export declare class IFSelect_SignMultiple extends IFSelect_Signature {
  constructor(name: Standard_CString)
  Add(subsign: Handle_IFSelect_Signature, width: Graphic3d_ZLayerId, maxi: Standard_Boolean): void;
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  Matches(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel, text: XCAFDoc_PartId, exact: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_DispPerSignature {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_DispPerSignature): void;
  get(): IFSelect_DispPerSignature;
  delete(): void;
}

  export declare class Handle_IFSelect_DispPerSignature_1 extends Handle_IFSelect_DispPerSignature {
    constructor();
  }

  export declare class Handle_IFSelect_DispPerSignature_2 extends Handle_IFSelect_DispPerSignature {
    constructor(thePtr: IFSelect_DispPerSignature);
  }

  export declare class Handle_IFSelect_DispPerSignature_3 extends Handle_IFSelect_DispPerSignature {
    constructor(theHandle: Handle_IFSelect_DispPerSignature);
  }

  export declare class Handle_IFSelect_DispPerSignature_4 extends Handle_IFSelect_DispPerSignature {
    constructor(theHandle: Handle_IFSelect_DispPerSignature);
  }

export declare class IFSelect_DispPerSignature extends IFSelect_Dispatch {
  constructor()
  SignCounter(): Handle_IFSelect_SignCounter;
  SetSignCounter(sign: Handle_IFSelect_SignCounter): void;
  SignName(): Standard_CString;
  Label(): XCAFDoc_PartId;
  LimitedMax(nbent: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_Boolean;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SignType extends IFSelect_Signature {
  constructor(nopk: Standard_Boolean)
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SignType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignType): void;
  get(): IFSelect_SignType;
  delete(): void;
}

  export declare class Handle_IFSelect_SignType_1 extends Handle_IFSelect_SignType {
    constructor();
  }

  export declare class Handle_IFSelect_SignType_2 extends Handle_IFSelect_SignType {
    constructor(thePtr: IFSelect_SignType);
  }

  export declare class Handle_IFSelect_SignType_3 extends Handle_IFSelect_SignType {
    constructor(theHandle: Handle_IFSelect_SignType);
  }

  export declare class Handle_IFSelect_SignType_4 extends Handle_IFSelect_SignType {
    constructor(theHandle: Handle_IFSelect_SignType);
  }

export declare class Handle_IFSelect_Dispatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Dispatch): void;
  get(): IFSelect_Dispatch;
  delete(): void;
}

  export declare class Handle_IFSelect_Dispatch_1 extends Handle_IFSelect_Dispatch {
    constructor();
  }

  export declare class Handle_IFSelect_Dispatch_2 extends Handle_IFSelect_Dispatch {
    constructor(thePtr: IFSelect_Dispatch);
  }

  export declare class Handle_IFSelect_Dispatch_3 extends Handle_IFSelect_Dispatch {
    constructor(theHandle: Handle_IFSelect_Dispatch);
  }

  export declare class Handle_IFSelect_Dispatch_4 extends Handle_IFSelect_Dispatch {
    constructor(theHandle: Handle_IFSelect_Dispatch);
  }

export declare class IFSelect_Dispatch extends Standard_Transient {
  SetRootName(name: Handle_TCollection_HAsciiString): void;
  HasRootName(): Standard_Boolean;
  RootName(): Handle_TCollection_HAsciiString;
  SetFinalSelection(sel: Handle_IFSelect_Selection): void;
  FinalSelection(): Handle_IFSelect_Selection;
  Selections(): IFSelect_SelectionIterator;
  CanHaveRemainder(): Standard_Boolean;
  LimitedMax(nbent: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_Boolean;
  Label(): XCAFDoc_PartId;
  GetEntities(G: Interface_Graph): Interface_EntityIterator;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  Packeted(G: Interface_Graph): Interface_EntityIterator;
  Remainder(G: Interface_Graph): Interface_EntityIterator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_TransformStandard {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_TransformStandard): void;
  get(): IFSelect_TransformStandard;
  delete(): void;
}

  export declare class Handle_IFSelect_TransformStandard_1 extends Handle_IFSelect_TransformStandard {
    constructor();
  }

  export declare class Handle_IFSelect_TransformStandard_2 extends Handle_IFSelect_TransformStandard {
    constructor(thePtr: IFSelect_TransformStandard);
  }

  export declare class Handle_IFSelect_TransformStandard_3 extends Handle_IFSelect_TransformStandard {
    constructor(theHandle: Handle_IFSelect_TransformStandard);
  }

  export declare class Handle_IFSelect_TransformStandard_4 extends Handle_IFSelect_TransformStandard {
    constructor(theHandle: Handle_IFSelect_TransformStandard);
  }

export declare class IFSelect_TransformStandard extends IFSelect_Transformer {
  constructor()
  SetCopyOption(option: Standard_Boolean): void;
  CopyOption(): Standard_Boolean;
  SetSelection(sel: Handle_IFSelect_Selection): void;
  Selection(): Handle_IFSelect_Selection;
  NbModifiers(): Graphic3d_ZLayerId;
  Modifier(num: Graphic3d_ZLayerId): Handle_IFSelect_Modifier;
  ModifierRank(modif: Handle_IFSelect_Modifier): Graphic3d_ZLayerId;
  AddModifier(modif: Handle_IFSelect_Modifier, atnum: Graphic3d_ZLayerId): Standard_Boolean;
  RemoveModifier_1(modif: Handle_IFSelect_Modifier): Standard_Boolean;
  RemoveModifier_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  Perform(G: Interface_Graph, protocol: Handle_Interface_Protocol, checks: Interface_CheckIterator, newmod: Handle_Interface_InterfaceModel): Standard_Boolean;
  Copy(G: Interface_Graph, TC: Interface_CopyTool, newmod: Handle_Interface_InterfaceModel): void;
  StandardCopy(G: Interface_Graph, TC: Interface_CopyTool, newmod: Handle_Interface_InterfaceModel): void;
  OnTheSpot(G: Interface_Graph, TC: Interface_CopyTool, newmod: Handle_Interface_InterfaceModel): void;
  ApplyModifiers(G: Interface_Graph, protocol: Handle_Interface_Protocol, TC: Interface_CopyTool, checks: Interface_CheckIterator, newmod: Handle_Interface_InterfaceModel): Standard_Boolean;
  Updated(entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient): Standard_Boolean;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SelectUnion extends IFSelect_SelectCombine {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectUnion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectUnion): void;
  get(): IFSelect_SelectUnion;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectUnion_1 extends Handle_IFSelect_SelectUnion {
    constructor();
  }

  export declare class Handle_IFSelect_SelectUnion_2 extends Handle_IFSelect_SelectUnion {
    constructor(thePtr: IFSelect_SelectUnion);
  }

  export declare class Handle_IFSelect_SelectUnion_3 extends Handle_IFSelect_SelectUnion {
    constructor(theHandle: Handle_IFSelect_SelectUnion);
  }

  export declare class Handle_IFSelect_SelectUnion_4 extends Handle_IFSelect_SelectUnion {
    constructor(theHandle: Handle_IFSelect_SelectUnion);
  }

export declare class Handle_IFSelect_SelectUnknownEntities {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectUnknownEntities): void;
  get(): IFSelect_SelectUnknownEntities;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectUnknownEntities_1 extends Handle_IFSelect_SelectUnknownEntities {
    constructor();
  }

  export declare class Handle_IFSelect_SelectUnknownEntities_2 extends Handle_IFSelect_SelectUnknownEntities {
    constructor(thePtr: IFSelect_SelectUnknownEntities);
  }

  export declare class Handle_IFSelect_SelectUnknownEntities_3 extends Handle_IFSelect_SelectUnknownEntities {
    constructor(theHandle: Handle_IFSelect_SelectUnknownEntities);
  }

  export declare class Handle_IFSelect_SelectUnknownEntities_4 extends Handle_IFSelect_SelectUnknownEntities {
    constructor(theHandle: Handle_IFSelect_SelectUnknownEntities);
  }

export declare class IFSelect_SelectUnknownEntities extends IFSelect_SelectExtract {
  constructor()
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type IFSelect_PrintCount = {
  IFSelect_ItemsByEntity: {};
  IFSelect_CountByItem: {};
  IFSelect_ShortByItem: {};
  IFSelect_ListByItem: {};
  IFSelect_EntitiesByItem: {};
  IFSelect_CountSummary: {};
  IFSelect_GeneralInfo: {};
  IFSelect_Mapping: {};
  IFSelect_ResultCount: {};
}

export declare class IFSelect_AppliedModifiers extends Standard_Transient {
  constructor(nbmax: Graphic3d_ZLayerId, nbent: Graphic3d_ZLayerId)
  AddModif(modif: Handle_IFSelect_GeneralModifier): Standard_Boolean;
  AddNum(nument: Graphic3d_ZLayerId): Standard_Boolean;
  Count(): Graphic3d_ZLayerId;
  Item(num: Graphic3d_ZLayerId, modif: Handle_IFSelect_GeneralModifier, entcount: Graphic3d_ZLayerId): Standard_Boolean;
  ItemNum(nument: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ItemList(): Handle_TColStd_HSequenceOfInteger;
  IsForAll(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_AppliedModifiers {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_AppliedModifiers): void;
  get(): IFSelect_AppliedModifiers;
  delete(): void;
}

  export declare class Handle_IFSelect_AppliedModifiers_1 extends Handle_IFSelect_AppliedModifiers {
    constructor();
  }

  export declare class Handle_IFSelect_AppliedModifiers_2 extends Handle_IFSelect_AppliedModifiers {
    constructor(thePtr: IFSelect_AppliedModifiers);
  }

  export declare class Handle_IFSelect_AppliedModifiers_3 extends Handle_IFSelect_AppliedModifiers {
    constructor(theHandle: Handle_IFSelect_AppliedModifiers);
  }

  export declare class Handle_IFSelect_AppliedModifiers_4 extends Handle_IFSelect_AppliedModifiers {
    constructor(theHandle: Handle_IFSelect_AppliedModifiers);
  }

export declare class IFSelect_SelectSuite extends IFSelect_SelectDeduct {
  constructor()
  AddInput(item: Handle_IFSelect_Selection): Standard_Boolean;
  AddPrevious(item: Handle_IFSelect_SelectDeduct): void;
  AddNext(item: Handle_IFSelect_SelectDeduct): void;
  NbItems(): Graphic3d_ZLayerId;
  Item(num: Graphic3d_ZLayerId): Handle_IFSelect_SelectDeduct;
  SetLabel(lab: Standard_CString): void;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectSuite {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectSuite): void;
  get(): IFSelect_SelectSuite;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectSuite_1 extends Handle_IFSelect_SelectSuite {
    constructor();
  }

  export declare class Handle_IFSelect_SelectSuite_2 extends Handle_IFSelect_SelectSuite {
    constructor(thePtr: IFSelect_SelectSuite);
  }

  export declare class Handle_IFSelect_SelectSuite_3 extends Handle_IFSelect_SelectSuite {
    constructor(theHandle: Handle_IFSelect_SelectSuite);
  }

  export declare class Handle_IFSelect_SelectSuite_4 extends Handle_IFSelect_SelectSuite {
    constructor(theHandle: Handle_IFSelect_SelectSuite);
  }

export declare type IFSelect_EditValue = {
  IFSelect_Optional: {};
  IFSelect_Editable: {};
  IFSelect_EditProtected: {};
  IFSelect_EditComputed: {};
  IFSelect_EditRead: {};
  IFSelect_EditDynamic: {};
}

export declare class IFSelect_SelectSent extends IFSelect_SelectExtract {
  constructor(sentcount: Graphic3d_ZLayerId, atleast: Standard_Boolean)
  SentCount(): Graphic3d_ZLayerId;
  AtLeast(): Standard_Boolean;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectSent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectSent): void;
  get(): IFSelect_SelectSent;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectSent_1 extends Handle_IFSelect_SelectSent {
    constructor();
  }

  export declare class Handle_IFSelect_SelectSent_2 extends Handle_IFSelect_SelectSent {
    constructor(thePtr: IFSelect_SelectSent);
  }

  export declare class Handle_IFSelect_SelectSent_3 extends Handle_IFSelect_SelectSent {
    constructor(theHandle: Handle_IFSelect_SelectSent);
  }

  export declare class Handle_IFSelect_SelectSent_4 extends Handle_IFSelect_SelectSent {
    constructor(theHandle: Handle_IFSelect_SelectSent);
  }

export declare type IFSelect_PrintFail = {
  IFSelect_FailOnly: {};
  IFSelect_FailAndWarn: {};
}

export declare class Handle_IFSelect_SignCounter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignCounter): void;
  get(): IFSelect_SignCounter;
  delete(): void;
}

  export declare class Handle_IFSelect_SignCounter_1 extends Handle_IFSelect_SignCounter {
    constructor();
  }

  export declare class Handle_IFSelect_SignCounter_2 extends Handle_IFSelect_SignCounter {
    constructor(thePtr: IFSelect_SignCounter);
  }

  export declare class Handle_IFSelect_SignCounter_3 extends Handle_IFSelect_SignCounter {
    constructor(theHandle: Handle_IFSelect_SignCounter);
  }

  export declare class Handle_IFSelect_SignCounter_4 extends Handle_IFSelect_SignCounter {
    constructor(theHandle: Handle_IFSelect_SignCounter);
  }

export declare class IFSelect_SignCounter extends IFSelect_SignatureList {
  Signature(): Handle_IFSelect_Signature;
  SetMap(withmap: Standard_Boolean): void;
  AddEntity(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  AddSign(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): void;
  AddList(list: Handle_TColStd_HSequenceOfTransient, model: Handle_Interface_InterfaceModel): void;
  AddWithGraph(list: Handle_TColStd_HSequenceOfTransient, graph: Interface_Graph): void;
  AddModel(model: Handle_Interface_InterfaceModel): void;
  AddFromSelection(sel: Handle_IFSelect_Selection, G: Interface_Graph): void;
  SetSelection(sel: Handle_IFSelect_Selection): void;
  Selection(): Handle_IFSelect_Selection;
  SetSelMode(selmode: Graphic3d_ZLayerId): void;
  SelMode(): Graphic3d_ZLayerId;
  ComputeSelected(G: Interface_Graph, forced: Standard_Boolean): Standard_Boolean;
  Sign(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Handle_TCollection_HAsciiString;
  ComputedSign(ent: Handle_Standard_Transient, G: Interface_Graph): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IFSelect_SignCounter_1 extends IFSelect_SignCounter {
    constructor(withmap: Standard_Boolean, withlist: Standard_Boolean);
  }

  export declare class IFSelect_SignCounter_2 extends IFSelect_SignCounter {
    constructor(matcher: Handle_IFSelect_Signature, withmap: Standard_Boolean, withlist: Standard_Boolean);
  }

export declare class IFSelect_DispGlobal extends IFSelect_Dispatch {
  constructor()
  Label(): XCAFDoc_PartId;
  LimitedMax(nbent: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_Boolean;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_DispGlobal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_DispGlobal): void;
  get(): IFSelect_DispGlobal;
  delete(): void;
}

  export declare class Handle_IFSelect_DispGlobal_1 extends Handle_IFSelect_DispGlobal {
    constructor();
  }

  export declare class Handle_IFSelect_DispGlobal_2 extends Handle_IFSelect_DispGlobal {
    constructor(thePtr: IFSelect_DispGlobal);
  }

  export declare class Handle_IFSelect_DispGlobal_3 extends Handle_IFSelect_DispGlobal {
    constructor(theHandle: Handle_IFSelect_DispGlobal);
  }

  export declare class Handle_IFSelect_DispGlobal_4 extends Handle_IFSelect_DispGlobal {
    constructor(theHandle: Handle_IFSelect_DispGlobal);
  }

export declare class Handle_IFSelect_SignValidity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignValidity): void;
  get(): IFSelect_SignValidity;
  delete(): void;
}

  export declare class Handle_IFSelect_SignValidity_1 extends Handle_IFSelect_SignValidity {
    constructor();
  }

  export declare class Handle_IFSelect_SignValidity_2 extends Handle_IFSelect_SignValidity {
    constructor(thePtr: IFSelect_SignValidity);
  }

  export declare class Handle_IFSelect_SignValidity_3 extends Handle_IFSelect_SignValidity {
    constructor(theHandle: Handle_IFSelect_SignValidity);
  }

  export declare class Handle_IFSelect_SignValidity_4 extends Handle_IFSelect_SignValidity {
    constructor(theHandle: Handle_IFSelect_SignValidity);
  }

export declare class IFSelect_SignValidity extends IFSelect_Signature {
  constructor()
  static CVal(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectIntersection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectIntersection): void;
  get(): IFSelect_SelectIntersection;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectIntersection_1 extends Handle_IFSelect_SelectIntersection {
    constructor();
  }

  export declare class Handle_IFSelect_SelectIntersection_2 extends Handle_IFSelect_SelectIntersection {
    constructor(thePtr: IFSelect_SelectIntersection);
  }

  export declare class Handle_IFSelect_SelectIntersection_3 extends Handle_IFSelect_SelectIntersection {
    constructor(theHandle: Handle_IFSelect_SelectIntersection);
  }

  export declare class Handle_IFSelect_SelectIntersection_4 extends Handle_IFSelect_SelectIntersection {
    constructor(theHandle: Handle_IFSelect_SelectIntersection);
  }

export declare class IFSelect_SelectIntersection extends IFSelect_SelectCombine {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectModelRoots {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectModelRoots): void;
  get(): IFSelect_SelectModelRoots;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectModelRoots_1 extends Handle_IFSelect_SelectModelRoots {
    constructor();
  }

  export declare class Handle_IFSelect_SelectModelRoots_2 extends Handle_IFSelect_SelectModelRoots {
    constructor(thePtr: IFSelect_SelectModelRoots);
  }

  export declare class Handle_IFSelect_SelectModelRoots_3 extends Handle_IFSelect_SelectModelRoots {
    constructor(theHandle: Handle_IFSelect_SelectModelRoots);
  }

  export declare class Handle_IFSelect_SelectModelRoots_4 extends Handle_IFSelect_SelectModelRoots {
    constructor(theHandle: Handle_IFSelect_SelectModelRoots);
  }

export declare class IFSelect_SelectModelRoots extends IFSelect_SelectBase {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SignatureList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignatureList): void;
  get(): IFSelect_SignatureList;
  delete(): void;
}

  export declare class Handle_IFSelect_SignatureList_1 extends Handle_IFSelect_SignatureList {
    constructor();
  }

  export declare class Handle_IFSelect_SignatureList_2 extends Handle_IFSelect_SignatureList {
    constructor(thePtr: IFSelect_SignatureList);
  }

  export declare class Handle_IFSelect_SignatureList_3 extends Handle_IFSelect_SignatureList {
    constructor(theHandle: Handle_IFSelect_SignatureList);
  }

  export declare class Handle_IFSelect_SignatureList_4 extends Handle_IFSelect_SignatureList {
    constructor(theHandle: Handle_IFSelect_SignatureList);
  }

export declare class IFSelect_SignatureList extends Standard_Transient {
  constructor(withlist: Standard_Boolean)
  SetList(withlist: Standard_Boolean): void;
  ModeSignOnly(): Standard_Boolean;
  Clear(): void;
  Add(ent: Handle_Standard_Transient, sign: Standard_CString): void;
  LastValue(): Standard_CString;
  Init(name: Standard_CString, count: NCollection_IndexedDataMap<TCollection_AsciiString, Standard_Integer>, list: any, nbnuls: Graphic3d_ZLayerId): void;
  List(root: Standard_CString): Handle_TColStd_HSequenceOfHAsciiString;
  HasEntities(): Standard_Boolean;
  NbNulls(): Graphic3d_ZLayerId;
  NbTimes(sign: Standard_CString): Graphic3d_ZLayerId;
  Entities(sign: Standard_CString): Handle_TColStd_HSequenceOfTransient;
  SetName(name: Standard_CString): void;
  Name(): Standard_CString;
  PrintCount(S: Standard_OStream): void;
  PrintList(S: Standard_OStream, model: Handle_Interface_InterfaceModel, mod: IFSelect_PrintCount): void;
  PrintSum(S: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_DispPerFiles {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_DispPerFiles): void;
  get(): IFSelect_DispPerFiles;
  delete(): void;
}

  export declare class Handle_IFSelect_DispPerFiles_1 extends Handle_IFSelect_DispPerFiles {
    constructor();
  }

  export declare class Handle_IFSelect_DispPerFiles_2 extends Handle_IFSelect_DispPerFiles {
    constructor(thePtr: IFSelect_DispPerFiles);
  }

  export declare class Handle_IFSelect_DispPerFiles_3 extends Handle_IFSelect_DispPerFiles {
    constructor(theHandle: Handle_IFSelect_DispPerFiles);
  }

  export declare class Handle_IFSelect_DispPerFiles_4 extends Handle_IFSelect_DispPerFiles {
    constructor(theHandle: Handle_IFSelect_DispPerFiles);
  }

export declare class IFSelect_DispPerFiles extends IFSelect_Dispatch {
  constructor()
  Count(): Handle_IFSelect_IntParam;
  SetCount(count: Handle_IFSelect_IntParam): void;
  CountValue(): Graphic3d_ZLayerId;
  Label(): XCAFDoc_PartId;
  LimitedMax(nbent: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_Boolean;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_Act extends IFSelect_Activator {
  constructor(name: Standard_CString, help: Standard_CString, func: IFSelect_ActFunc)
  Do(number: Graphic3d_ZLayerId, pilot: Handle_IFSelect_SessionPilot): IFSelect_ReturnStatus;
  Help(number: Graphic3d_ZLayerId): Standard_CString;
  static SetGroup(group: Standard_CString, file: Standard_CString): void;
  static AddFunc(name: Standard_CString, help: Standard_CString, func: IFSelect_ActFunc): void;
  static AddFSet(name: Standard_CString, help: Standard_CString, func: IFSelect_ActFunc): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_Act {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_Act): void;
  get(): IFSelect_Act;
  delete(): void;
}

  export declare class Handle_IFSelect_Act_1 extends Handle_IFSelect_Act {
    constructor();
  }

  export declare class Handle_IFSelect_Act_2 extends Handle_IFSelect_Act {
    constructor(thePtr: IFSelect_Act);
  }

  export declare class Handle_IFSelect_Act_3 extends Handle_IFSelect_Act {
    constructor(theHandle: Handle_IFSelect_Act);
  }

  export declare class Handle_IFSelect_Act_4 extends Handle_IFSelect_Act {
    constructor(theHandle: Handle_IFSelect_Act);
  }

export declare class Handle_IFSelect_WorkLibrary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_WorkLibrary): void;
  get(): IFSelect_WorkLibrary;
  delete(): void;
}

  export declare class Handle_IFSelect_WorkLibrary_1 extends Handle_IFSelect_WorkLibrary {
    constructor();
  }

  export declare class Handle_IFSelect_WorkLibrary_2 extends Handle_IFSelect_WorkLibrary {
    constructor(thePtr: IFSelect_WorkLibrary);
  }

  export declare class Handle_IFSelect_WorkLibrary_3 extends Handle_IFSelect_WorkLibrary {
    constructor(theHandle: Handle_IFSelect_WorkLibrary);
  }

  export declare class Handle_IFSelect_WorkLibrary_4 extends Handle_IFSelect_WorkLibrary {
    constructor(theHandle: Handle_IFSelect_WorkLibrary);
  }

export declare class IFSelect_WorkLibrary extends Standard_Transient {
  ReadFile(name: Standard_CString, model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol): Graphic3d_ZLayerId;
  ReadStream(theName: Standard_CString, theIStream: Standard_IStream, model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol): Graphic3d_ZLayerId;
  WriteFile(ctx: IFSelect_ContextWrite): Standard_Boolean;
  CopyModel(original: Handle_Interface_InterfaceModel, newmodel: Handle_Interface_InterfaceModel, list: Interface_EntityIterator, TC: Interface_CopyTool): Standard_Boolean;
  DumpEntity_1(model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, entity: Handle_Standard_Transient, S: Standard_OStream, level: Graphic3d_ZLayerId): void;
  DumpEntity_2(model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol, entity: Handle_Standard_Transient, S: Standard_OStream): void;
  SetDumpLevels(def: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): void;
  DumpLevels(def: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): void;
  SetDumpHelp(level: Graphic3d_ZLayerId, help: Standard_CString): void;
  DumpHelp(level: Graphic3d_ZLayerId): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SelectModelEntities extends IFSelect_SelectBase {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  CompleteResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectModelEntities {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectModelEntities): void;
  get(): IFSelect_SelectModelEntities;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectModelEntities_1 extends Handle_IFSelect_SelectModelEntities {
    constructor();
  }

  export declare class Handle_IFSelect_SelectModelEntities_2 extends Handle_IFSelect_SelectModelEntities {
    constructor(thePtr: IFSelect_SelectModelEntities);
  }

  export declare class Handle_IFSelect_SelectModelEntities_3 extends Handle_IFSelect_SelectModelEntities {
    constructor(theHandle: Handle_IFSelect_SelectModelEntities);
  }

  export declare class Handle_IFSelect_SelectModelEntities_4 extends Handle_IFSelect_SelectModelEntities {
    constructor(theHandle: Handle_IFSelect_SelectModelEntities);
  }

export declare type IFSelect_ReturnStatus = {
  IFSelect_RetVoid: {};
  IFSelect_RetDone: {};
  IFSelect_RetError: {};
  IFSelect_RetFail: {};
  IFSelect_RetStop: {};
}

export declare class Handle_IFSelect_DispPerOne {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_DispPerOne): void;
  get(): IFSelect_DispPerOne;
  delete(): void;
}

  export declare class Handle_IFSelect_DispPerOne_1 extends Handle_IFSelect_DispPerOne {
    constructor();
  }

  export declare class Handle_IFSelect_DispPerOne_2 extends Handle_IFSelect_DispPerOne {
    constructor(thePtr: IFSelect_DispPerOne);
  }

  export declare class Handle_IFSelect_DispPerOne_3 extends Handle_IFSelect_DispPerOne {
    constructor(theHandle: Handle_IFSelect_DispPerOne);
  }

  export declare class Handle_IFSelect_DispPerOne_4 extends Handle_IFSelect_DispPerOne {
    constructor(theHandle: Handle_IFSelect_DispPerOne);
  }

export declare class IFSelect_DispPerOne extends IFSelect_Dispatch {
  constructor()
  Label(): XCAFDoc_PartId;
  LimitedMax(nbent: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_Boolean;
  Packets(G: Interface_Graph, packs: IFGraph_SubPartsIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SignCategory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SignCategory): void;
  get(): IFSelect_SignCategory;
  delete(): void;
}

  export declare class Handle_IFSelect_SignCategory_1 extends Handle_IFSelect_SignCategory {
    constructor();
  }

  export declare class Handle_IFSelect_SignCategory_2 extends Handle_IFSelect_SignCategory {
    constructor(thePtr: IFSelect_SignCategory);
  }

  export declare class Handle_IFSelect_SignCategory_3 extends Handle_IFSelect_SignCategory {
    constructor(theHandle: Handle_IFSelect_SignCategory);
  }

  export declare class Handle_IFSelect_SignCategory_4 extends Handle_IFSelect_SignCategory {
    constructor(theHandle: Handle_IFSelect_SignCategory);
  }

export declare class IFSelect_SignCategory extends IFSelect_Signature {
  constructor()
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectAnyList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectAnyList): void;
  get(): IFSelect_SelectAnyList;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectAnyList_1 extends Handle_IFSelect_SelectAnyList {
    constructor();
  }

  export declare class Handle_IFSelect_SelectAnyList_2 extends Handle_IFSelect_SelectAnyList {
    constructor(thePtr: IFSelect_SelectAnyList);
  }

  export declare class Handle_IFSelect_SelectAnyList_3 extends Handle_IFSelect_SelectAnyList {
    constructor(theHandle: Handle_IFSelect_SelectAnyList);
  }

  export declare class Handle_IFSelect_SelectAnyList_4 extends Handle_IFSelect_SelectAnyList {
    constructor(theHandle: Handle_IFSelect_SelectAnyList);
  }

export declare class IFSelect_SelectAnyList extends IFSelect_SelectDeduct {
  KeepInputEntity(iter: Interface_EntityIterator): void;
  NbItems(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  SetRange(rankfrom: Handle_IFSelect_IntParam, rankto: Handle_IFSelect_IntParam): void;
  SetOne(rank: Handle_IFSelect_IntParam): void;
  SetFrom(rankfrom: Handle_IFSelect_IntParam): void;
  SetUntil(rankto: Handle_IFSelect_IntParam): void;
  HasLower(): Standard_Boolean;
  Lower(): Handle_IFSelect_IntParam;
  LowerValue(): Graphic3d_ZLayerId;
  HasUpper(): Standard_Boolean;
  Upper(): Handle_IFSelect_IntParam;
  UpperValue(): Graphic3d_ZLayerId;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  FillResult(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, res: Interface_EntityIterator): void;
  Label(): XCAFDoc_PartId;
  ListLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SelectRoots extends IFSelect_SelectExtract {
  constructor()
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectRoots {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectRoots): void;
  get(): IFSelect_SelectRoots;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectRoots_1 extends Handle_IFSelect_SelectRoots {
    constructor();
  }

  export declare class Handle_IFSelect_SelectRoots_2 extends Handle_IFSelect_SelectRoots {
    constructor(thePtr: IFSelect_SelectRoots);
  }

  export declare class Handle_IFSelect_SelectRoots_3 extends Handle_IFSelect_SelectRoots {
    constructor(theHandle: Handle_IFSelect_SelectRoots);
  }

  export declare class Handle_IFSelect_SelectRoots_4 extends Handle_IFSelect_SelectRoots {
    constructor(theHandle: Handle_IFSelect_SelectRoots);
  }

export declare class IFSelect_ModelCopier extends Standard_Transient {
  constructor()
  SetShareOut(sho: Handle_IFSelect_ShareOut): void;
  ClearResult(): void;
  AddFile(filename: XCAFDoc_PartId, content: Handle_Interface_InterfaceModel): Standard_Boolean;
  NameFile(num: Graphic3d_ZLayerId, filename: XCAFDoc_PartId): Standard_Boolean;
  ClearFile(num: Graphic3d_ZLayerId): Standard_Boolean;
  SetAppliedModifiers(num: Graphic3d_ZLayerId, applied: Handle_IFSelect_AppliedModifiers): Standard_Boolean;
  ClearAppliedModifiers(num: Graphic3d_ZLayerId): Standard_Boolean;
  Copy(eval: IFSelect_ShareOutResult, WL: Handle_IFSelect_WorkLibrary, protocol: Handle_Interface_Protocol): Interface_CheckIterator;
  SendCopied(WL: Handle_IFSelect_WorkLibrary, protocol: Handle_Interface_Protocol): Interface_CheckIterator;
  Send(eval: IFSelect_ShareOutResult, WL: Handle_IFSelect_WorkLibrary, protocol: Handle_Interface_Protocol): Interface_CheckIterator;
  SendAll(filename: Standard_CString, G: Interface_Graph, WL: Handle_IFSelect_WorkLibrary, protocol: Handle_Interface_Protocol): Interface_CheckIterator;
  SendSelected(filename: Standard_CString, G: Interface_Graph, WL: Handle_IFSelect_WorkLibrary, protocol: Handle_Interface_Protocol, iter: Interface_EntityIterator): Interface_CheckIterator;
  CopiedRemaining(G: Interface_Graph, WL: Handle_IFSelect_WorkLibrary, TC: Interface_CopyTool, newmod: Handle_Interface_InterfaceModel): void;
  SetRemaining(CG: Interface_Graph): Standard_Boolean;
  NbFiles(): Graphic3d_ZLayerId;
  FileName(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  FileModel(num: Graphic3d_ZLayerId): Handle_Interface_InterfaceModel;
  AppliedModifiers(num: Graphic3d_ZLayerId): Handle_IFSelect_AppliedModifiers;
  BeginSentFiles(sho: Handle_IFSelect_ShareOut, record: Standard_Boolean): void;
  AddSentFile(filename: Standard_CString): void;
  SentFiles(): Handle_TColStd_HSequenceOfHAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_ModelCopier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_ModelCopier): void;
  get(): IFSelect_ModelCopier;
  delete(): void;
}

  export declare class Handle_IFSelect_ModelCopier_1 extends Handle_IFSelect_ModelCopier {
    constructor();
  }

  export declare class Handle_IFSelect_ModelCopier_2 extends Handle_IFSelect_ModelCopier {
    constructor(thePtr: IFSelect_ModelCopier);
  }

  export declare class Handle_IFSelect_ModelCopier_3 extends Handle_IFSelect_ModelCopier {
    constructor(theHandle: Handle_IFSelect_ModelCopier);
  }

  export declare class Handle_IFSelect_ModelCopier_4 extends Handle_IFSelect_ModelCopier {
    constructor(theHandle: Handle_IFSelect_ModelCopier);
  }

export declare class IFSelect_SessionFile {
  ClearLines(): void;
  NbLines(): Graphic3d_ZLayerId;
  Line(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  AddLine(line: Standard_CString): void;
  RemoveLastLine(): void;
  WriteFile(name: Standard_CString): Standard_Boolean;
  ReadFile(name: Standard_CString): Standard_Boolean;
  RecognizeFile(headerline: Standard_CString): Standard_Boolean;
  Write(filename: Standard_CString): Graphic3d_ZLayerId;
  Read(filename: Standard_CString): Graphic3d_ZLayerId;
  WriteSession(): Graphic3d_ZLayerId;
  WriteEnd(): Graphic3d_ZLayerId;
  WriteLine(line: Standard_CString, follow: Standard_Character): void;
  WriteOwn(item: Handle_Standard_Transient): Standard_Boolean;
  ReadSession(): Graphic3d_ZLayerId;
  ReadEnd(): Graphic3d_ZLayerId;
  ReadLine(): Standard_Boolean;
  SplitLine(line: Standard_CString): void;
  ReadOwn(item: Handle_Standard_Transient): Standard_Boolean;
  AddItem(item: Handle_Standard_Transient, active: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  WorkSession(): Handle_IFSelect_WorkSession;
  NewItem(ident: Graphic3d_ZLayerId, par: Handle_Standard_Transient): void;
  SetOwn(mode: Standard_Boolean): void;
  SendVoid(): void;
  SendItem(par: Handle_Standard_Transient): void;
  SendText(text: Standard_CString): void;
  SetLastGeneral(lastgen: Graphic3d_ZLayerId): void;
  NbParams(): Graphic3d_ZLayerId;
  IsVoid(num: Graphic3d_ZLayerId): Standard_Boolean;
  IsText(num: Graphic3d_ZLayerId): Standard_Boolean;
  ParamValue(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  TextValue(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  ItemValue(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  Destroy(): void;
  delete(): void;
}

  export declare class IFSelect_SessionFile_1 extends IFSelect_SessionFile {
    constructor(WS: Handle_IFSelect_WorkSession);
  }

  export declare class IFSelect_SessionFile_2 extends IFSelect_SessionFile {
    constructor(WS: Handle_IFSelect_WorkSession, filename: Standard_CString);
  }

export declare class IFSelect_SessionPilot extends IFSelect_Activator {
  constructor(prompt: Standard_CString)
  Session(): Handle_IFSelect_WorkSession;
  Library(): Handle_IFSelect_WorkLibrary;
  RecordMode(): Standard_Boolean;
  SetSession(WS: Handle_IFSelect_WorkSession): void;
  SetLibrary(WL: Handle_IFSelect_WorkLibrary): void;
  SetRecordMode(mode: Standard_Boolean): void;
  SetCommandLine(command: XCAFDoc_PartId): void;
  CommandLine(): XCAFDoc_PartId;
  CommandPart(numarg: Graphic3d_ZLayerId): Standard_CString;
  NbWords(): Graphic3d_ZLayerId;
  Word(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Arg(num: Graphic3d_ZLayerId): Standard_CString;
  RemoveWord(num: Graphic3d_ZLayerId): Standard_Boolean;
  NbCommands(): Graphic3d_ZLayerId;
  Command(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  RecordItem(item: Handle_Standard_Transient): IFSelect_ReturnStatus;
  RecordedItem(): Handle_Standard_Transient;
  Clear(): void;
  ReadScript(file: Standard_CString): IFSelect_ReturnStatus;
  Perform(): IFSelect_ReturnStatus;
  ExecuteAlias(aliasname: XCAFDoc_PartId): IFSelect_ReturnStatus;
  Execute(command: XCAFDoc_PartId): IFSelect_ReturnStatus;
  ExecuteCounter(counter: Handle_IFSelect_SignCounter, numword: Graphic3d_ZLayerId, mode: IFSelect_PrintCount): IFSelect_ReturnStatus;
  Number(val: Standard_CString): Graphic3d_ZLayerId;
  Do(number: Graphic3d_ZLayerId, session: Handle_IFSelect_SessionPilot): IFSelect_ReturnStatus;
  Help(number: Graphic3d_ZLayerId): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SessionPilot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SessionPilot): void;
  get(): IFSelect_SessionPilot;
  delete(): void;
}

  export declare class Handle_IFSelect_SessionPilot_1 extends Handle_IFSelect_SessionPilot {
    constructor();
  }

  export declare class Handle_IFSelect_SessionPilot_2 extends Handle_IFSelect_SessionPilot {
    constructor(thePtr: IFSelect_SessionPilot);
  }

  export declare class Handle_IFSelect_SessionPilot_3 extends Handle_IFSelect_SessionPilot {
    constructor(theHandle: Handle_IFSelect_SessionPilot);
  }

  export declare class Handle_IFSelect_SessionPilot_4 extends Handle_IFSelect_SessionPilot {
    constructor(theHandle: Handle_IFSelect_SessionPilot);
  }

export declare type IFSelect_RemainMode = {
  IFSelect_RemainForget: {};
  IFSelect_RemainCompute: {};
  IFSelect_RemainDisplay: {};
  IFSelect_RemainUndo: {};
}

export declare class Handle_IFSelect_SelectExplore {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectExplore): void;
  get(): IFSelect_SelectExplore;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectExplore_1 extends Handle_IFSelect_SelectExplore {
    constructor();
  }

  export declare class Handle_IFSelect_SelectExplore_2 extends Handle_IFSelect_SelectExplore {
    constructor(thePtr: IFSelect_SelectExplore);
  }

  export declare class Handle_IFSelect_SelectExplore_3 extends Handle_IFSelect_SelectExplore {
    constructor(theHandle: Handle_IFSelect_SelectExplore);
  }

  export declare class Handle_IFSelect_SelectExplore_4 extends Handle_IFSelect_SelectExplore {
    constructor(theHandle: Handle_IFSelect_SelectExplore);
  }

export declare class IFSelect_SelectExplore extends IFSelect_SelectDeduct {
  Level(): Graphic3d_ZLayerId;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  Label(): XCAFDoc_PartId;
  ExploreLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectErrorEntities {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectErrorEntities): void;
  get(): IFSelect_SelectErrorEntities;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectErrorEntities_1 extends Handle_IFSelect_SelectErrorEntities {
    constructor();
  }

  export declare class Handle_IFSelect_SelectErrorEntities_2 extends Handle_IFSelect_SelectErrorEntities {
    constructor(thePtr: IFSelect_SelectErrorEntities);
  }

  export declare class Handle_IFSelect_SelectErrorEntities_3 extends Handle_IFSelect_SelectErrorEntities {
    constructor(theHandle: Handle_IFSelect_SelectErrorEntities);
  }

  export declare class Handle_IFSelect_SelectErrorEntities_4 extends Handle_IFSelect_SelectErrorEntities {
    constructor(theHandle: Handle_IFSelect_SelectErrorEntities);
  }

export declare class IFSelect_SelectErrorEntities extends IFSelect_SelectExtract {
  constructor()
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectPointed {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectPointed): void;
  get(): IFSelect_SelectPointed;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectPointed_1 extends Handle_IFSelect_SelectPointed {
    constructor();
  }

  export declare class Handle_IFSelect_SelectPointed_2 extends Handle_IFSelect_SelectPointed {
    constructor(thePtr: IFSelect_SelectPointed);
  }

  export declare class Handle_IFSelect_SelectPointed_3 extends Handle_IFSelect_SelectPointed {
    constructor(theHandle: Handle_IFSelect_SelectPointed);
  }

  export declare class Handle_IFSelect_SelectPointed_4 extends Handle_IFSelect_SelectPointed {
    constructor(theHandle: Handle_IFSelect_SelectPointed);
  }

export declare class IFSelect_SelectPointed extends IFSelect_SelectBase {
  constructor()
  Clear(): void;
  IsSet(): Standard_Boolean;
  SetEntity(item: Handle_Standard_Transient): void;
  SetList(list: Handle_TColStd_HSequenceOfTransient): void;
  Add(item: Handle_Standard_Transient): Standard_Boolean;
  Remove(item: Handle_Standard_Transient): Standard_Boolean;
  Toggle(item: Handle_Standard_Transient): Standard_Boolean;
  AddList(list: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  RemoveList(list: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  ToggleList(list: Handle_TColStd_HSequenceOfTransient): Standard_Boolean;
  Rank(item: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NbItems(): Graphic3d_ZLayerId;
  Item(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  Update_1(control: Handle_Interface_CopyControl): void;
  Update_2(trf: Handle_IFSelect_Transformer): void;
  RootResult(G: Interface_Graph): Interface_EntityIterator;
  Label(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IFSelect_SelectBase extends IFSelect_Selection {
  FillIterator(iter: IFSelect_SelectionIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IFSelect_SelectBase {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IFSelect_SelectBase): void;
  get(): IFSelect_SelectBase;
  delete(): void;
}

  export declare class Handle_IFSelect_SelectBase_1 extends Handle_IFSelect_SelectBase {
    constructor();
  }

  export declare class Handle_IFSelect_SelectBase_2 extends Handle_IFSelect_SelectBase {
    constructor(thePtr: IFSelect_SelectBase);
  }

  export declare class Handle_IFSelect_SelectBase_3 extends Handle_IFSelect_SelectBase {
    constructor(theHandle: Handle_IFSelect_SelectBase);
  }

  export declare class Handle_IFSelect_SelectBase_4 extends Handle_IFSelect_SelectBase {
    constructor(theHandle: Handle_IFSelect_SelectBase);
  }

export declare class RWStl_Reader extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Read(theFile: Standard_Character, theProgress: Message_ProgressRange): Standard_Boolean;
  IsAscii(theStream: Standard_IStream, isSeekgAvailable: Standard_Boolean): Standard_Boolean;
  ReadBinary(theStream: Standard_IStream, theProgress: Message_ProgressRange): Standard_Boolean;
  ReadAscii(theStream: Standard_IStream, theBuffer: Standard_ReadLineBuffer, theUntilPos: any, theProgress: Message_ProgressRange): Standard_Boolean;
  AddNode(thePnt: gp_XYZ): Graphic3d_ZLayerId;
  AddTriangle(theN1: Graphic3d_ZLayerId, theN2: Graphic3d_ZLayerId, theN3: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class RWStl {
  constructor();
  static WriteBinary(theMesh: Handle_Poly_Triangulation, thePath: OSD_Path, theProgress: Message_ProgressRange): Standard_Boolean;
  static WriteAscii(theMesh: Handle_Poly_Triangulation, thePath: OSD_Path, theProgress: Message_ProgressRange): Standard_Boolean;
  static ReadFile_1(theFile: OSD_Path, aProgInd: Message_ProgressRange): Handle_Poly_Triangulation;
  static ReadFile_2(theFile: Standard_CString, aProgInd: Message_ProgressRange): Handle_Poly_Triangulation;
  static ReadBinary(thePath: OSD_Path, theProgress: Message_ProgressRange): Handle_Poly_Triangulation;
  static ReadAscii(thePath: OSD_Path, theProgress: Message_ProgressRange): Handle_Poly_Triangulation;
  delete(): void;
}

export declare class Handle_HeaderSection_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HeaderSection_Protocol): void;
  get(): HeaderSection_Protocol;
  delete(): void;
}

  export declare class Handle_HeaderSection_Protocol_1 extends Handle_HeaderSection_Protocol {
    constructor();
  }

  export declare class Handle_HeaderSection_Protocol_2 extends Handle_HeaderSection_Protocol {
    constructor(thePtr: HeaderSection_Protocol);
  }

  export declare class Handle_HeaderSection_Protocol_3 extends Handle_HeaderSection_Protocol {
    constructor(theHandle: Handle_HeaderSection_Protocol);
  }

  export declare class Handle_HeaderSection_Protocol_4 extends Handle_HeaderSection_Protocol {
    constructor(theHandle: Handle_HeaderSection_Protocol);
  }

export declare class HeaderSection_Protocol extends StepData_Protocol {
  constructor()
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  SchemaName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HeaderSection_FileDescription {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HeaderSection_FileDescription): void;
  get(): HeaderSection_FileDescription;
  delete(): void;
}

  export declare class Handle_HeaderSection_FileDescription_1 extends Handle_HeaderSection_FileDescription {
    constructor();
  }

  export declare class Handle_HeaderSection_FileDescription_2 extends Handle_HeaderSection_FileDescription {
    constructor(thePtr: HeaderSection_FileDescription);
  }

  export declare class Handle_HeaderSection_FileDescription_3 extends Handle_HeaderSection_FileDescription {
    constructor(theHandle: Handle_HeaderSection_FileDescription);
  }

  export declare class Handle_HeaderSection_FileDescription_4 extends Handle_HeaderSection_FileDescription {
    constructor(theHandle: Handle_HeaderSection_FileDescription);
  }

export declare class HeaderSection_FileDescription extends Standard_Transient {
  constructor()
  Init(aDescription: Handle_Interface_HArray1OfHAsciiString, aImplementationLevel: Handle_TCollection_HAsciiString): void;
  SetDescription(aDescription: Handle_Interface_HArray1OfHAsciiString): void;
  Description(): Handle_Interface_HArray1OfHAsciiString;
  DescriptionValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbDescription(): Graphic3d_ZLayerId;
  SetImplementationLevel(aImplementationLevel: Handle_TCollection_HAsciiString): void;
  ImplementationLevel(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HeaderSection_FileSchema {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HeaderSection_FileSchema): void;
  get(): HeaderSection_FileSchema;
  delete(): void;
}

  export declare class Handle_HeaderSection_FileSchema_1 extends Handle_HeaderSection_FileSchema {
    constructor();
  }

  export declare class Handle_HeaderSection_FileSchema_2 extends Handle_HeaderSection_FileSchema {
    constructor(thePtr: HeaderSection_FileSchema);
  }

  export declare class Handle_HeaderSection_FileSchema_3 extends Handle_HeaderSection_FileSchema {
    constructor(theHandle: Handle_HeaderSection_FileSchema);
  }

  export declare class Handle_HeaderSection_FileSchema_4 extends Handle_HeaderSection_FileSchema {
    constructor(theHandle: Handle_HeaderSection_FileSchema);
  }

export declare class HeaderSection_FileSchema extends Standard_Transient {
  constructor()
  Init(aSchemaIdentifiers: Handle_Interface_HArray1OfHAsciiString): void;
  SetSchemaIdentifiers(aSchemaIdentifiers: Handle_Interface_HArray1OfHAsciiString): void;
  SchemaIdentifiers(): Handle_Interface_HArray1OfHAsciiString;
  SchemaIdentifiersValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbSchemaIdentifiers(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class HeaderSection_FileName extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aTimeStamp: Handle_TCollection_HAsciiString, aAuthor: Handle_Interface_HArray1OfHAsciiString, aOrganization: Handle_Interface_HArray1OfHAsciiString, aPreprocessorVersion: Handle_TCollection_HAsciiString, aOriginatingSystem: Handle_TCollection_HAsciiString, aAuthorisation: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetTimeStamp(aTimeStamp: Handle_TCollection_HAsciiString): void;
  TimeStamp(): Handle_TCollection_HAsciiString;
  SetAuthor(aAuthor: Handle_Interface_HArray1OfHAsciiString): void;
  Author(): Handle_Interface_HArray1OfHAsciiString;
  AuthorValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbAuthor(): Graphic3d_ZLayerId;
  SetOrganization(aOrganization: Handle_Interface_HArray1OfHAsciiString): void;
  Organization(): Handle_Interface_HArray1OfHAsciiString;
  OrganizationValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbOrganization(): Graphic3d_ZLayerId;
  SetPreprocessorVersion(aPreprocessorVersion: Handle_TCollection_HAsciiString): void;
  PreprocessorVersion(): Handle_TCollection_HAsciiString;
  SetOriginatingSystem(aOriginatingSystem: Handle_TCollection_HAsciiString): void;
  OriginatingSystem(): Handle_TCollection_HAsciiString;
  SetAuthorisation(aAuthorisation: Handle_TCollection_HAsciiString): void;
  Authorisation(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HeaderSection_FileName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HeaderSection_FileName): void;
  get(): HeaderSection_FileName;
  delete(): void;
}

  export declare class Handle_HeaderSection_FileName_1 extends Handle_HeaderSection_FileName {
    constructor();
  }

  export declare class Handle_HeaderSection_FileName_2 extends Handle_HeaderSection_FileName {
    constructor(thePtr: HeaderSection_FileName);
  }

  export declare class Handle_HeaderSection_FileName_3 extends Handle_HeaderSection_FileName {
    constructor(theHandle: Handle_HeaderSection_FileName);
  }

  export declare class Handle_HeaderSection_FileName_4 extends Handle_HeaderSection_FileName {
    constructor(theHandle: Handle_HeaderSection_FileName);
  }

export declare class HeaderSection {
  constructor();
  static Protocol(): Handle_HeaderSection_Protocol;
  delete(): void;
}

export declare class IGESConvGeom_GeomBuilder {
  constructor()
  Clear(): void;
  AddXY(val: gp_XY): void;
  AddXYZ(val: gp_XYZ): void;
  AddVec(val: gp_XYZ): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(num: Graphic3d_ZLayerId): gp_XYZ;
  MakeCopiousData(datatype: Graphic3d_ZLayerId, polyline: Standard_Boolean): Handle_IGESGeom_CopiousData;
  Position(): gp_Trsf;
  SetPosition_1(pos: gp_Trsf): void;
  SetPosition_2(pos: gp_Ax3): void;
  SetPosition_3(pos: gp_Ax2): void;
  SetPosition_4(pos: gp_Ax1): void;
  IsIdentity(): Standard_Boolean;
  IsTranslation(): Standard_Boolean;
  IsZOnly(): Standard_Boolean;
  EvalXYZ(val: gp_XYZ, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  MakeTransformation(unit: Quantity_AbsorbedDose): Handle_IGESGeom_TransformationMatrix;
  delete(): void;
}

export declare class IGESConvGeom {
  constructor();
  static SplineCurveFromIGES(igesent: Handle_IGESGeom_SplineCurve, epscoef: Quantity_AbsorbedDose, epsgeom: Quantity_AbsorbedDose, result: Handle_Geom_BSplineCurve): Graphic3d_ZLayerId;
  static IncreaseCurveContinuity_1(curve: Handle_Geom_BSplineCurve, epsgeom: Quantity_AbsorbedDose, continuity: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IncreaseCurveContinuity_2(curve: Handle_Geom2d_BSplineCurve, epsgeom: Quantity_AbsorbedDose, continuity: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static SplineSurfaceFromIGES(igesent: Handle_IGESGeom_SplineSurface, epscoef: Quantity_AbsorbedDose, epsgeom: Quantity_AbsorbedDose, result: Handle_Geom_BSplineSurface): Graphic3d_ZLayerId;
  static IncreaseSurfaceContinuity(surface: Handle_Geom_BSplineSurface, epsgeom: Quantity_AbsorbedDose, continuity: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IntTools_ListOfSurfaceRangeSample extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: IntTools_ListOfSurfaceRangeSample): IntTools_ListOfSurfaceRangeSample;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): IntTools_SurfaceRangeSample;
  First_2(): IntTools_SurfaceRangeSample;
  Last_1(): IntTools_SurfaceRangeSample;
  Last_2(): IntTools_SurfaceRangeSample;
  Append_1(theItem: IntTools_SurfaceRangeSample): IntTools_SurfaceRangeSample;
  Append_3(theOther: IntTools_ListOfSurfaceRangeSample): void;
  Prepend_1(theItem: IntTools_SurfaceRangeSample): IntTools_SurfaceRangeSample;
  Prepend_2(theOther: IntTools_ListOfSurfaceRangeSample): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class IntTools_ListOfSurfaceRangeSample_1 extends IntTools_ListOfSurfaceRangeSample {
    constructor();
  }

  export declare class IntTools_ListOfSurfaceRangeSample_2 extends IntTools_ListOfSurfaceRangeSample {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_ListOfSurfaceRangeSample_3 extends IntTools_ListOfSurfaceRangeSample {
    constructor(theOther: IntTools_ListOfSurfaceRangeSample);
  }

export declare class IntTools_CurveRangeLocalizeData {
  constructor(theNbSample: Graphic3d_ZLayerId, theMinRange: Quantity_AbsorbedDose)
  GetNbSample(): Graphic3d_ZLayerId;
  GetMinRange(): Quantity_AbsorbedDose;
  AddOutRange(theRange: IntTools_CurveRangeSample): void;
  AddBox(theRange: IntTools_CurveRangeSample, theBox: Bnd_Box): void;
  FindBox(theRange: IntTools_CurveRangeSample, theBox: Bnd_Box): Standard_Boolean;
  IsRangeOut(theRange: IntTools_CurveRangeSample): Standard_Boolean;
  ListRangeOut(theList: IntTools_ListOfCurveRangeSample): void;
  delete(): void;
}

export declare class IntTools_Tools {
  constructor();
  static ComputeVV(V1: TopoDS_Vertex, V2: TopoDS_Vertex): Graphic3d_ZLayerId;
  static HasInternalEdge(aW: TopoDS_Wire): Standard_Boolean;
  static MakeFaceFromWireAndFace(aW: TopoDS_Wire, aF: TopoDS_Face, aFNew: TopoDS_Face): void;
  static ClassifyPointByFace(aF: TopoDS_Face, P: gp_Pnt2d): TopAbs_State;
  static IsVertex_1(E: TopoDS_Edge, t: Quantity_AbsorbedDose): Standard_Boolean;
  static IsVertex_2(E: TopoDS_Edge, V: TopoDS_Vertex, t: Quantity_AbsorbedDose): Standard_Boolean;
  static IsVertex_3(aCmnPrt: IntTools_CommonPrt): Standard_Boolean;
  static IsMiddlePointsEqual(E1: TopoDS_Edge, E2: TopoDS_Edge): Standard_Boolean;
  static IsVertex_4(aP: gp_Pnt, aTolPV: Quantity_AbsorbedDose, aV: TopoDS_Vertex): Standard_Boolean;
  static IntermediatePoint(aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static SplitCurve(aC: IntTools_Curve, aS: IntTools_SequenceOfCurves): Graphic3d_ZLayerId;
  static RejectLines(aSIn: IntTools_SequenceOfCurves, aSOut: IntTools_SequenceOfCurves): void;
  static IsDirsCoinside_1(D1: gp_Dir, D2: gp_Dir): Standard_Boolean;
  static IsDirsCoinside_2(D1: gp_Dir, D2: gp_Dir, aTol: Quantity_AbsorbedDose): Standard_Boolean;
  static IsClosed(aC: Handle_Geom_Curve): Standard_Boolean;
  static CurveTolerance(aC: Handle_Geom_Curve, aTolBase: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static CheckCurve(theCurve: IntTools_Curve, theBox: Bnd_Box): Standard_Boolean;
  static IsOnPave(theT: Quantity_AbsorbedDose, theRange: IntTools_Range, theTol: Quantity_AbsorbedDose): Standard_Boolean;
  static VertexParameters(theCP: IntTools_CommonPrt, theT1: Quantity_AbsorbedDose, theT2: Quantity_AbsorbedDose): void;
  static VertexParameter(theCP: IntTools_CommonPrt, theT: Quantity_AbsorbedDose): void;
  static IsOnPave1(theT: Quantity_AbsorbedDose, theRange: IntTools_Range, theTol: Quantity_AbsorbedDose): Standard_Boolean;
  static IsInRange(theRRef: IntTools_Range, theR: IntTools_Range, theTol: Quantity_AbsorbedDose): Standard_Boolean;
  static SegPln(theLin: gp_Lin, theTLin1: Quantity_AbsorbedDose, theTLin2: Quantity_AbsorbedDose, theTolLin: Quantity_AbsorbedDose, thePln: gp_Pln, theTolPln: Quantity_AbsorbedDose, theP: gp_Pnt, theT: Quantity_AbsorbedDose, theTolP: Quantity_AbsorbedDose, theTmin: Quantity_AbsorbedDose, theTmax: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static ComputeTolerance(theCurve3D: Handle_Geom_Curve, theCurve2D: Handle_Geom2d_Curve, theSurf: Handle_Geom_Surface, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theMaxDist: Quantity_AbsorbedDose, theMaxPar: Quantity_AbsorbedDose, theTolRange: Quantity_AbsorbedDose): Standard_Boolean;
  static ComputeIntRange(theTol1: Quantity_AbsorbedDose, theTol2: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class IntTools_DataMapOfSurfaceSampleBox extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: IntTools_DataMapOfSurfaceSampleBox): void;
  Assign(theOther: IntTools_DataMapOfSurfaceSampleBox): IntTools_DataMapOfSurfaceSampleBox;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: IntTools_SurfaceRangeSample, theItem: Bnd_Box): Standard_Boolean;
  Bound(theKey: IntTools_SurfaceRangeSample, theItem: Bnd_Box): Bnd_Box;
  IsBound(theKey: IntTools_SurfaceRangeSample): Standard_Boolean;
  UnBind(theKey: IntTools_SurfaceRangeSample): Standard_Boolean;
  Seek(theKey: IntTools_SurfaceRangeSample): Bnd_Box;
  ChangeSeek(theKey: IntTools_SurfaceRangeSample): Bnd_Box;
  ChangeFind(theKey: IntTools_SurfaceRangeSample): Bnd_Box;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class IntTools_DataMapOfSurfaceSampleBox_1 extends IntTools_DataMapOfSurfaceSampleBox {
    constructor();
  }

  export declare class IntTools_DataMapOfSurfaceSampleBox_2 extends IntTools_DataMapOfSurfaceSampleBox {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_DataMapOfSurfaceSampleBox_3 extends IntTools_DataMapOfSurfaceSampleBox {
    constructor(theOther: IntTools_DataMapOfSurfaceSampleBox);
  }

export declare class IntTools_WLineTool {
  constructor();
  static NotUseSurfacesForApprox(aF1: TopoDS_Face, aF2: TopoDS_Face, WL: Handle_IntPatch_WLine, ifprm: Graphic3d_ZLayerId, ilprm: Graphic3d_ZLayerId): Standard_Boolean;
  static DecompositionOfWLine(theWLine: Handle_IntPatch_WLine, theSurface1: Handle_GeomAdaptor_HSurface, theSurface2: Handle_GeomAdaptor_HSurface, theFace1: TopoDS_Face, theFace2: TopoDS_Face, theLConstructor: GeomInt_LineConstructor, theAvoidLConstructor: Standard_Boolean, theTol: Quantity_AbsorbedDose, theNewLines: IntPatch_SequenceOfLine, theReachedTol3d: Quantity_AbsorbedDose, a10: Handle_IntTools_Context): Standard_Boolean;
  delete(): void;
}

export declare class IntTools_MapOfSurfaceSample extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: IntTools_MapOfSurfaceSample): void;
  Assign(theOther: IntTools_MapOfSurfaceSample): IntTools_MapOfSurfaceSample;
  ReSize(N: Standard_Integer): void;
  Add(K: IntTools_SurfaceRangeSample): Standard_Boolean;
  Added(K: IntTools_SurfaceRangeSample): IntTools_SurfaceRangeSample;
  Contains_1(K: IntTools_SurfaceRangeSample): Standard_Boolean;
  Remove(K: IntTools_SurfaceRangeSample): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: IntTools_MapOfSurfaceSample): Standard_Boolean;
  Contains_2(theOther: IntTools_MapOfSurfaceSample): Standard_Boolean;
  Union(theLeft: IntTools_MapOfSurfaceSample, theRight: IntTools_MapOfSurfaceSample): void;
  Unite(theOther: IntTools_MapOfSurfaceSample): Standard_Boolean;
  HasIntersection(theMap: IntTools_MapOfSurfaceSample): Standard_Boolean;
  Intersection(theLeft: IntTools_MapOfSurfaceSample, theRight: IntTools_MapOfSurfaceSample): void;
  Intersect(theOther: IntTools_MapOfSurfaceSample): Standard_Boolean;
  Subtraction(theLeft: IntTools_MapOfSurfaceSample, theRight: IntTools_MapOfSurfaceSample): void;
  Subtract(theOther: IntTools_MapOfSurfaceSample): Standard_Boolean;
  Difference(theLeft: IntTools_MapOfSurfaceSample, theRight: IntTools_MapOfSurfaceSample): void;
  Differ(theOther: IntTools_MapOfSurfaceSample): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_MapOfSurfaceSample_1 extends IntTools_MapOfSurfaceSample {
    constructor();
  }

  export declare class IntTools_MapOfSurfaceSample_2 extends IntTools_MapOfSurfaceSample {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_MapOfSurfaceSample_3 extends IntTools_MapOfSurfaceSample {
    constructor(theOther: IntTools_MapOfSurfaceSample);
  }

export declare class IntTools_ListOfCurveRangeSample extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: IntTools_ListOfCurveRangeSample): IntTools_ListOfCurveRangeSample;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): IntTools_CurveRangeSample;
  First_2(): IntTools_CurveRangeSample;
  Last_1(): IntTools_CurveRangeSample;
  Last_2(): IntTools_CurveRangeSample;
  Append_1(theItem: IntTools_CurveRangeSample): IntTools_CurveRangeSample;
  Append_3(theOther: IntTools_ListOfCurveRangeSample): void;
  Prepend_1(theItem: IntTools_CurveRangeSample): IntTools_CurveRangeSample;
  Prepend_2(theOther: IntTools_ListOfCurveRangeSample): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class IntTools_ListOfCurveRangeSample_1 extends IntTools_ListOfCurveRangeSample {
    constructor();
  }

  export declare class IntTools_ListOfCurveRangeSample_2 extends IntTools_ListOfCurveRangeSample {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_ListOfCurveRangeSample_3 extends IntTools_ListOfCurveRangeSample {
    constructor(theOther: IntTools_ListOfCurveRangeSample);
  }

export declare class IntTools_Array1OfRoots {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: IntTools_Root): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: IntTools_Array1OfRoots): IntTools_Array1OfRoots;
  Move(theOther: IntTools_Array1OfRoots): IntTools_Array1OfRoots;
  First(): IntTools_Root;
  ChangeFirst(): IntTools_Root;
  Last(): IntTools_Root;
  ChangeLast(): IntTools_Root;
  Value(theIndex: Standard_Integer): IntTools_Root;
  ChangeValue(theIndex: Standard_Integer): IntTools_Root;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_Root): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class IntTools_Array1OfRoots_1 extends IntTools_Array1OfRoots {
    constructor();
  }

  export declare class IntTools_Array1OfRoots_2 extends IntTools_Array1OfRoots {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class IntTools_Array1OfRoots_3 extends IntTools_Array1OfRoots {
    constructor(theOther: IntTools_Array1OfRoots);
  }

  export declare class IntTools_Array1OfRoots_4 extends IntTools_Array1OfRoots {
    constructor(theOther: IntTools_Array1OfRoots);
  }

  export declare class IntTools_Array1OfRoots_5 extends IntTools_Array1OfRoots {
    constructor(theBegin: IntTools_Root, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class IntTools_EdgeEdge {
  SetEdge1_1(theEdge: TopoDS_Edge): void;
  SetEdge1_2(theEdge: TopoDS_Edge, aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose): void;
  SetRange1_1(theRange1: IntTools_Range): void;
  SetRange1_2(aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose): void;
  SetEdge2_1(theEdge: TopoDS_Edge): void;
  SetEdge2_2(theEdge: TopoDS_Edge, aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose): void;
  SetRange2_1(theRange: IntTools_Range): void;
  SetRange2_2(aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose): void;
  SetFuzzyValue(theFuzz: Quantity_AbsorbedDose): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  FuzzyValue(): Quantity_AbsorbedDose;
  CommonParts(): IntTools_SequenceOfCommonPrts;
  UseQuickCoincidenceCheck(bFlag: Standard_Boolean): void;
  IsCoincidenceCheckedQuickly(): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_EdgeEdge_1 extends IntTools_EdgeEdge {
    constructor();
  }

  export declare class IntTools_EdgeEdge_2 extends IntTools_EdgeEdge {
    constructor(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge);
  }

  export declare class IntTools_EdgeEdge_3 extends IntTools_EdgeEdge {
    constructor(theEdge1: TopoDS_Edge, aT11: Quantity_AbsorbedDose, aT12: Quantity_AbsorbedDose, theEdge2: TopoDS_Edge, aT21: Quantity_AbsorbedDose, aT22: Quantity_AbsorbedDose);
  }

export declare class IntTools_CurveRangeSampleMapHasher {
  constructor();
  static HashCode(theKey: IntTools_CurveRangeSample, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(S1: IntTools_CurveRangeSample, S2: IntTools_CurveRangeSample): Standard_Boolean;
  delete(): void;
}

export declare class Handle_IntTools_Context {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntTools_Context): void;
  get(): IntTools_Context;
  delete(): void;
}

  export declare class Handle_IntTools_Context_1 extends Handle_IntTools_Context {
    constructor();
  }

  export declare class Handle_IntTools_Context_2 extends Handle_IntTools_Context {
    constructor(thePtr: IntTools_Context);
  }

  export declare class Handle_IntTools_Context_3 extends Handle_IntTools_Context {
    constructor(theHandle: Handle_IntTools_Context);
  }

  export declare class Handle_IntTools_Context_4 extends Handle_IntTools_Context {
    constructor(theHandle: Handle_IntTools_Context);
  }

export declare class IntTools_SequenceOfRoots extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntTools_SequenceOfRoots): IntTools_SequenceOfRoots;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntTools_Root): void;
  Append_2(theSeq: IntTools_SequenceOfRoots): void;
  Prepend_1(theItem: IntTools_Root): void;
  Prepend_2(theSeq: IntTools_SequenceOfRoots): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntTools_Root): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfRoots): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfRoots): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntTools_Root): void;
  Split(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfRoots): void;
  First(): IntTools_Root;
  ChangeFirst(): IntTools_Root;
  Last(): IntTools_Root;
  ChangeLast(): IntTools_Root;
  Value(theIndex: Standard_Integer): IntTools_Root;
  ChangeValue(theIndex: Standard_Integer): IntTools_Root;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_Root): void;
  delete(): void;
}

  export declare class IntTools_SequenceOfRoots_1 extends IntTools_SequenceOfRoots {
    constructor();
  }

  export declare class IntTools_SequenceOfRoots_2 extends IntTools_SequenceOfRoots {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_SequenceOfRoots_3 extends IntTools_SequenceOfRoots {
    constructor(theOther: IntTools_SequenceOfRoots);
  }

export declare class IntTools_SurfaceRangeLocalizeData {
  Assign(Other: IntTools_SurfaceRangeLocalizeData): IntTools_SurfaceRangeLocalizeData;
  GetNbSampleU(): Graphic3d_ZLayerId;
  GetNbSampleV(): Graphic3d_ZLayerId;
  GetMinRangeU(): Quantity_AbsorbedDose;
  GetMinRangeV(): Quantity_AbsorbedDose;
  AddOutRange(theRange: IntTools_SurfaceRangeSample): void;
  AddBox(theRange: IntTools_SurfaceRangeSample, theBox: Bnd_Box): void;
  FindBox(theRange: IntTools_SurfaceRangeSample, theBox: Bnd_Box): Standard_Boolean;
  IsRangeOut(theRange: IntTools_SurfaceRangeSample): Standard_Boolean;
  ListRangeOut(theList: IntTools_ListOfSurfaceRangeSample): void;
  RemoveRangeOutAll(): void;
  SetGridDeflection(theDeflection: Quantity_AbsorbedDose): void;
  GetGridDeflection(): Quantity_AbsorbedDose;
  SetRangeUGrid(theNbUGrid: Graphic3d_ZLayerId): void;
  GetRangeUGrid(): Graphic3d_ZLayerId;
  SetUParam(theIndex: Graphic3d_ZLayerId, theUParam: Quantity_AbsorbedDose): void;
  GetUParam(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetRangeVGrid(theNbVGrid: Graphic3d_ZLayerId): void;
  GetRangeVGrid(): Graphic3d_ZLayerId;
  SetVParam(theIndex: Graphic3d_ZLayerId, theVParam: Quantity_AbsorbedDose): void;
  GetVParam(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetGridPoint(theUIndex: Graphic3d_ZLayerId, theVIndex: Graphic3d_ZLayerId, thePoint: gp_Pnt): void;
  GetGridPoint(theUIndex: Graphic3d_ZLayerId, theVIndex: Graphic3d_ZLayerId): gp_Pnt;
  SetFrame(theUMin: Quantity_AbsorbedDose, theUMax: Quantity_AbsorbedDose, theVMin: Quantity_AbsorbedDose, theVMax: Quantity_AbsorbedDose): void;
  GetNBUPointsInFrame(): Graphic3d_ZLayerId;
  GetNBVPointsInFrame(): Graphic3d_ZLayerId;
  GetPointInFrame(theUIndex: Graphic3d_ZLayerId, theVIndex: Graphic3d_ZLayerId): gp_Pnt;
  GetUParamInFrame(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  GetVParamInFrame(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ClearGrid(): void;
  delete(): void;
}

  export declare class IntTools_SurfaceRangeLocalizeData_1 extends IntTools_SurfaceRangeLocalizeData {
    constructor();
  }

  export declare class IntTools_SurfaceRangeLocalizeData_2 extends IntTools_SurfaceRangeLocalizeData {
    constructor(theNbSampleU: Graphic3d_ZLayerId, theNbSampleV: Graphic3d_ZLayerId, theMinRangeU: Quantity_AbsorbedDose, theMinRangeV: Quantity_AbsorbedDose);
  }

  export declare class IntTools_SurfaceRangeLocalizeData_3 extends IntTools_SurfaceRangeLocalizeData {
    constructor(Other: IntTools_SurfaceRangeLocalizeData);
  }

export declare class IntTools_DataMapOfCurveSampleBox extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: IntTools_DataMapOfCurveSampleBox): void;
  Assign(theOther: IntTools_DataMapOfCurveSampleBox): IntTools_DataMapOfCurveSampleBox;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: IntTools_CurveRangeSample, theItem: Bnd_Box): Standard_Boolean;
  Bound(theKey: IntTools_CurveRangeSample, theItem: Bnd_Box): Bnd_Box;
  IsBound(theKey: IntTools_CurveRangeSample): Standard_Boolean;
  UnBind(theKey: IntTools_CurveRangeSample): Standard_Boolean;
  Seek(theKey: IntTools_CurveRangeSample): Bnd_Box;
  ChangeSeek(theKey: IntTools_CurveRangeSample): Bnd_Box;
  ChangeFind(theKey: IntTools_CurveRangeSample): Bnd_Box;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class IntTools_DataMapOfCurveSampleBox_1 extends IntTools_DataMapOfCurveSampleBox {
    constructor();
  }

  export declare class IntTools_DataMapOfCurveSampleBox_2 extends IntTools_DataMapOfCurveSampleBox {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_DataMapOfCurveSampleBox_3 extends IntTools_DataMapOfCurveSampleBox {
    constructor(theOther: IntTools_DataMapOfCurveSampleBox);
  }

export declare class IntTools_EdgeFace {
  constructor()
  SetEdge(theEdge: TopoDS_Edge): void;
  Edge(): TopoDS_Edge;
  SetFace(theFace: TopoDS_Face): void;
  Face(): TopoDS_Face;
  SetRange_1(theRange: IntTools_Range): void;
  SetRange_2(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose): void;
  Range(): IntTools_Range;
  SetContext(theContext: Handle_IntTools_Context): void;
  Context(): Handle_IntTools_Context;
  SetFuzzyValue(theFuzz: Quantity_AbsorbedDose): void;
  FuzzyValue(): Quantity_AbsorbedDose;
  UseQuickCoincidenceCheck(theFlag: Standard_Boolean): void;
  IsCoincidenceCheckedQuickly(): Standard_Boolean;
  Perform(): void;
  IsDone(): Standard_Boolean;
  ErrorStatus(): Graphic3d_ZLayerId;
  CommonParts(): IntTools_SequenceOfCommonPrts;
  MinimalDistance(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class IntTools_BaseRangeSample {
  SetDepth(theDepth: Graphic3d_ZLayerId): void;
  GetDepth(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class IntTools_BaseRangeSample_1 extends IntTools_BaseRangeSample {
    constructor();
  }

  export declare class IntTools_BaseRangeSample_2 extends IntTools_BaseRangeSample {
    constructor(theDepth: Graphic3d_ZLayerId);
  }

export declare class IntTools_PntOn2Faces {
  SetP1(aP1: IntTools_PntOnFace): void;
  SetP2(aP2: IntTools_PntOnFace): void;
  SetValid(bF: Standard_Boolean): void;
  P1(): IntTools_PntOnFace;
  P2(): IntTools_PntOnFace;
  IsValid(): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_PntOn2Faces_1 extends IntTools_PntOn2Faces {
    constructor();
  }

  export declare class IntTools_PntOn2Faces_2 extends IntTools_PntOn2Faces {
    constructor(aP1: IntTools_PntOnFace, aP2: IntTools_PntOnFace);
  }

export declare class IntTools_FaceFace {
  constructor()
  SetParameters(ApproxCurves: Standard_Boolean, ComputeCurveOnS1: Standard_Boolean, ComputeCurveOnS2: Standard_Boolean, ApproximationTolerance: Quantity_AbsorbedDose): void;
  Perform(F1: TopoDS_Face, F2: TopoDS_Face): void;
  IsDone(): Standard_Boolean;
  Lines(): IntTools_SequenceOfCurves;
  Points(): IntTools_SequenceOfPntOn2Faces;
  Face1(): TopoDS_Face;
  Face2(): TopoDS_Face;
  TangentFaces(): Standard_Boolean;
  PrepareLines3D(bToSplit: Standard_Boolean): void;
  SetList(ListOfPnts: IntSurf_ListOfPntOn2S): void;
  SetContext(aContext: Handle_IntTools_Context): void;
  SetFuzzyValue(theFuzz: Quantity_AbsorbedDose): void;
  FuzzyValue(): Quantity_AbsorbedDose;
  Context(): Handle_IntTools_Context;
  delete(): void;
}

export declare class IntTools {
  constructor();
  static Length(E: TopoDS_Edge): Quantity_AbsorbedDose;
  static RemoveIdenticalRoots(aSeq: IntTools_SequenceOfRoots, anEpsT: Quantity_AbsorbedDose): void;
  static SortRoots(aSeq: IntTools_SequenceOfRoots, anEpsT: Quantity_AbsorbedDose): void;
  static FindRootStates(aSeq: IntTools_SequenceOfRoots, anEpsNull: Quantity_AbsorbedDose): void;
  static Parameter(P: gp_Pnt, Curve: Handle_Geom_Curve, aParm: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static GetRadius(C: BRepAdaptor_Curve, t1: Quantity_AbsorbedDose, t3: Quantity_AbsorbedDose, R: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static PrepareArgs(C: BRepAdaptor_Curve, tMax: Quantity_AbsorbedDose, tMin: Quantity_AbsorbedDose, Discret: Graphic3d_ZLayerId, Deflect: Quantity_AbsorbedDose, anArgs: IntTools_CArray1OfReal): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IntTools_MarkedRangeSet {
  SetBoundaries(theFirstBoundary: Quantity_AbsorbedDose, theLastBoundary: Quantity_AbsorbedDose, theInitFlag: Graphic3d_ZLayerId): void;
  SetRanges(theSortedArray: IntTools_CArray1OfReal, theInitFlag: Graphic3d_ZLayerId): void;
  InsertRange_1(theFirstBoundary: Quantity_AbsorbedDose, theLastBoundary: Quantity_AbsorbedDose, theFlag: Graphic3d_ZLayerId): Standard_Boolean;
  InsertRange_2(theRange: IntTools_Range, theFlag: Graphic3d_ZLayerId): Standard_Boolean;
  InsertRange_3(theFirstBoundary: Quantity_AbsorbedDose, theLastBoundary: Quantity_AbsorbedDose, theFlag: Graphic3d_ZLayerId, theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  InsertRange_4(theRange: IntTools_Range, theFlag: Graphic3d_ZLayerId, theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  SetFlag(theIndex: Graphic3d_ZLayerId, theFlag: Graphic3d_ZLayerId): void;
  Flag(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetIndex_1(theValue: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  GetIndices(theValue: Quantity_AbsorbedDose): TColStd_SequenceOfInteger;
  GetIndex_2(theValue: Quantity_AbsorbedDose, UseLower: Standard_Boolean): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  Range(theIndex: Graphic3d_ZLayerId): IntTools_Range;
  delete(): void;
}

  export declare class IntTools_MarkedRangeSet_1 extends IntTools_MarkedRangeSet {
    constructor();
  }

  export declare class IntTools_MarkedRangeSet_2 extends IntTools_MarkedRangeSet {
    constructor(theFirstBoundary: Quantity_AbsorbedDose, theLastBoundary: Quantity_AbsorbedDose, theInitFlag: Graphic3d_ZLayerId);
  }

  export declare class IntTools_MarkedRangeSet_3 extends IntTools_MarkedRangeSet {
    constructor(theSortedArray: IntTools_CArray1OfReal, theInitFlag: Graphic3d_ZLayerId);
  }

export declare class IntTools_MapOfCurveSample extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: IntTools_MapOfCurveSample): void;
  Assign(theOther: IntTools_MapOfCurveSample): IntTools_MapOfCurveSample;
  ReSize(N: Standard_Integer): void;
  Add(K: IntTools_CurveRangeSample): Standard_Boolean;
  Added(K: IntTools_CurveRangeSample): IntTools_CurveRangeSample;
  Contains_1(K: IntTools_CurveRangeSample): Standard_Boolean;
  Remove(K: IntTools_CurveRangeSample): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: IntTools_MapOfCurveSample): Standard_Boolean;
  Contains_2(theOther: IntTools_MapOfCurveSample): Standard_Boolean;
  Union(theLeft: IntTools_MapOfCurveSample, theRight: IntTools_MapOfCurveSample): void;
  Unite(theOther: IntTools_MapOfCurveSample): Standard_Boolean;
  HasIntersection(theMap: IntTools_MapOfCurveSample): Standard_Boolean;
  Intersection(theLeft: IntTools_MapOfCurveSample, theRight: IntTools_MapOfCurveSample): void;
  Intersect(theOther: IntTools_MapOfCurveSample): Standard_Boolean;
  Subtraction(theLeft: IntTools_MapOfCurveSample, theRight: IntTools_MapOfCurveSample): void;
  Subtract(theOther: IntTools_MapOfCurveSample): Standard_Boolean;
  Difference(theLeft: IntTools_MapOfCurveSample, theRight: IntTools_MapOfCurveSample): void;
  Differ(theOther: IntTools_MapOfCurveSample): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_MapOfCurveSample_1 extends IntTools_MapOfCurveSample {
    constructor();
  }

  export declare class IntTools_MapOfCurveSample_2 extends IntTools_MapOfCurveSample {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_MapOfCurveSample_3 extends IntTools_MapOfCurveSample {
    constructor(theOther: IntTools_MapOfCurveSample);
  }

export declare class IntTools_SequenceOfCurves extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntTools_SequenceOfCurves): IntTools_SequenceOfCurves;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntTools_Curve): void;
  Append_2(theSeq: IntTools_SequenceOfCurves): void;
  Prepend_1(theItem: IntTools_Curve): void;
  Prepend_2(theSeq: IntTools_SequenceOfCurves): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntTools_Curve): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfCurves): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfCurves): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntTools_Curve): void;
  Split(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfCurves): void;
  First(): IntTools_Curve;
  ChangeFirst(): IntTools_Curve;
  Last(): IntTools_Curve;
  ChangeLast(): IntTools_Curve;
  Value(theIndex: Standard_Integer): IntTools_Curve;
  ChangeValue(theIndex: Standard_Integer): IntTools_Curve;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_Curve): void;
  delete(): void;
}

  export declare class IntTools_SequenceOfCurves_1 extends IntTools_SequenceOfCurves {
    constructor();
  }

  export declare class IntTools_SequenceOfCurves_2 extends IntTools_SequenceOfCurves {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_SequenceOfCurves_3 extends IntTools_SequenceOfCurves {
    constructor(theOther: IntTools_SequenceOfCurves);
  }

export declare class Handle_IntTools_TopolTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntTools_TopolTool): void;
  get(): IntTools_TopolTool;
  delete(): void;
}

  export declare class Handle_IntTools_TopolTool_1 extends Handle_IntTools_TopolTool {
    constructor();
  }

  export declare class Handle_IntTools_TopolTool_2 extends Handle_IntTools_TopolTool {
    constructor(thePtr: IntTools_TopolTool);
  }

  export declare class Handle_IntTools_TopolTool_3 extends Handle_IntTools_TopolTool {
    constructor(theHandle: Handle_IntTools_TopolTool);
  }

  export declare class Handle_IntTools_TopolTool_4 extends Handle_IntTools_TopolTool {
    constructor(theHandle: Handle_IntTools_TopolTool);
  }

export declare class IntTools_TopolTool extends Adaptor3d_TopolTool {
  Initialize_1(): void;
  Initialize_2(theSurface: Handle_Adaptor3d_HSurface): void;
  ComputeSamplePoints(): void;
  NbSamplesU(): Graphic3d_ZLayerId;
  NbSamplesV(): Graphic3d_ZLayerId;
  NbSamples(): Graphic3d_ZLayerId;
  SamplePoint(Index: Graphic3d_ZLayerId, P2d: gp_Pnt2d, P3d: gp_Pnt): void;
  SamplePnts(theDefl: Quantity_AbsorbedDose, theNUmin: Graphic3d_ZLayerId, theNVmin: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IntTools_TopolTool_1 extends IntTools_TopolTool {
    constructor();
  }

  export declare class IntTools_TopolTool_2 extends IntTools_TopolTool {
    constructor(theSurface: Handle_Adaptor3d_HSurface);
  }

export declare class IntTools_CurveRangeSample extends IntTools_BaseRangeSample {
  SetRangeIndex(theIndex: Graphic3d_ZLayerId): void;
  GetRangeIndex(): Graphic3d_ZLayerId;
  IsEqual(Other: IntTools_CurveRangeSample): Standard_Boolean;
  GetRange(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theNbSample: Graphic3d_ZLayerId): IntTools_Range;
  GetRangeIndexDeeper(theNbSample: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class IntTools_CurveRangeSample_1 extends IntTools_CurveRangeSample {
    constructor();
  }

  export declare class IntTools_CurveRangeSample_2 extends IntTools_CurveRangeSample {
    constructor(theIndex: Graphic3d_ZLayerId);
  }

export declare class IntTools_Array1OfRange {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: IntTools_Range): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: IntTools_Array1OfRange): IntTools_Array1OfRange;
  Move(theOther: IntTools_Array1OfRange): IntTools_Array1OfRange;
  First(): IntTools_Range;
  ChangeFirst(): IntTools_Range;
  Last(): IntTools_Range;
  ChangeLast(): IntTools_Range;
  Value(theIndex: Standard_Integer): IntTools_Range;
  ChangeValue(theIndex: Standard_Integer): IntTools_Range;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_Range): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class IntTools_Array1OfRange_1 extends IntTools_Array1OfRange {
    constructor();
  }

  export declare class IntTools_Array1OfRange_2 extends IntTools_Array1OfRange {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class IntTools_Array1OfRange_3 extends IntTools_Array1OfRange {
    constructor(theOther: IntTools_Array1OfRange);
  }

  export declare class IntTools_Array1OfRange_4 extends IntTools_Array1OfRange {
    constructor(theOther: IntTools_Array1OfRange);
  }

  export declare class IntTools_Array1OfRange_5 extends IntTools_Array1OfRange {
    constructor(theBegin: IntTools_Range, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class IntTools_ShrunkRange {
  constructor()
  SetData(aE: TopoDS_Edge, aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose, aV1: TopoDS_Vertex, aV2: TopoDS_Vertex): void;
  SetContext(aCtx: Handle_IntTools_Context): void;
  Context(): Handle_IntTools_Context;
  SetShrunkRange(aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose): void;
  ShrunkRange(aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose): void;
  BndBox(): Bnd_Box;
  Edge(): TopoDS_Edge;
  Perform(): void;
  IsDone(): Standard_Boolean;
  IsSplittable(): Standard_Boolean;
  Length(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class IntTools_FClass2d {
  Init(F: TopoDS_Face, Tol: Quantity_AbsorbedDose): void;
  PerformInfinitePoint(): TopAbs_State;
  Perform(Puv: gp_Pnt2d, RecadreOnPeriodic: Standard_Boolean): TopAbs_State;
  Destroy(): void;
  TestOnRestriction(Puv: gp_Pnt2d, Tol: Quantity_AbsorbedDose, RecadreOnPeriodic: Standard_Boolean): TopAbs_State;
  IsHole(): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_FClass2d_1 extends IntTools_FClass2d {
    constructor();
  }

  export declare class IntTools_FClass2d_2 extends IntTools_FClass2d {
    constructor(F: TopoDS_Face, Tol: Quantity_AbsorbedDose);
  }

export declare class IntTools_SequenceOfCommonPrts extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntTools_SequenceOfCommonPrts): IntTools_SequenceOfCommonPrts;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntTools_CommonPrt): void;
  Append_2(theSeq: IntTools_SequenceOfCommonPrts): void;
  Prepend_1(theItem: IntTools_CommonPrt): void;
  Prepend_2(theSeq: IntTools_SequenceOfCommonPrts): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntTools_CommonPrt): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfCommonPrts): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfCommonPrts): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntTools_CommonPrt): void;
  Split(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfCommonPrts): void;
  First(): IntTools_CommonPrt;
  ChangeFirst(): IntTools_CommonPrt;
  Last(): IntTools_CommonPrt;
  ChangeLast(): IntTools_CommonPrt;
  Value(theIndex: Standard_Integer): IntTools_CommonPrt;
  ChangeValue(theIndex: Standard_Integer): IntTools_CommonPrt;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_CommonPrt): void;
  delete(): void;
}

  export declare class IntTools_SequenceOfCommonPrts_1 extends IntTools_SequenceOfCommonPrts {
    constructor();
  }

  export declare class IntTools_SequenceOfCommonPrts_2 extends IntTools_SequenceOfCommonPrts {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_SequenceOfCommonPrts_3 extends IntTools_SequenceOfCommonPrts {
    constructor(theOther: IntTools_SequenceOfCommonPrts);
  }

export declare class IntTools_SurfaceRangeSample {
  Assign(Other: IntTools_SurfaceRangeSample): IntTools_SurfaceRangeSample;
  SetRanges(theRangeU: IntTools_CurveRangeSample, theRangeV: IntTools_CurveRangeSample): void;
  GetRanges(theRangeU: IntTools_CurveRangeSample, theRangeV: IntTools_CurveRangeSample): void;
  SetIndexes(theIndexU: Graphic3d_ZLayerId, theIndexV: Graphic3d_ZLayerId): void;
  GetIndexes(theIndexU: Graphic3d_ZLayerId, theIndexV: Graphic3d_ZLayerId): void;
  GetDepths(theDepthU: Graphic3d_ZLayerId, theDepthV: Graphic3d_ZLayerId): void;
  SetSampleRangeU(theRangeSampleU: IntTools_CurveRangeSample): void;
  GetSampleRangeU(): IntTools_CurveRangeSample;
  SetSampleRangeV(theRangeSampleV: IntTools_CurveRangeSample): void;
  GetSampleRangeV(): IntTools_CurveRangeSample;
  SetIndexU(theIndexU: Graphic3d_ZLayerId): void;
  GetIndexU(): Graphic3d_ZLayerId;
  SetIndexV(theIndexV: Graphic3d_ZLayerId): void;
  GetIndexV(): Graphic3d_ZLayerId;
  SetDepthU(theDepthU: Graphic3d_ZLayerId): void;
  GetDepthU(): Graphic3d_ZLayerId;
  SetDepthV(theDepthV: Graphic3d_ZLayerId): void;
  GetDepthV(): Graphic3d_ZLayerId;
  GetRangeU(theFirstU: Quantity_AbsorbedDose, theLastU: Quantity_AbsorbedDose, theNbSampleU: Graphic3d_ZLayerId): IntTools_Range;
  GetRangeV(theFirstV: Quantity_AbsorbedDose, theLastV: Quantity_AbsorbedDose, theNbSampleV: Graphic3d_ZLayerId): IntTools_Range;
  IsEqual(Other: IntTools_SurfaceRangeSample): Standard_Boolean;
  GetRangeIndexUDeeper(theNbSampleU: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetRangeIndexVDeeper(theNbSampleV: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class IntTools_SurfaceRangeSample_1 extends IntTools_SurfaceRangeSample {
    constructor();
  }

  export declare class IntTools_SurfaceRangeSample_2 extends IntTools_SurfaceRangeSample {
    constructor(theIndexU: Graphic3d_ZLayerId, theDepthU: Graphic3d_ZLayerId, theIndexV: Graphic3d_ZLayerId, theDepthV: Graphic3d_ZLayerId);
  }

  export declare class IntTools_SurfaceRangeSample_3 extends IntTools_SurfaceRangeSample {
    constructor(theRangeU: IntTools_CurveRangeSample, theRangeV: IntTools_CurveRangeSample);
  }

  export declare class IntTools_SurfaceRangeSample_4 extends IntTools_SurfaceRangeSample {
    constructor(Other: IntTools_SurfaceRangeSample);
  }

export declare class IntTools_Root {
  SetRoot(aRoot: Quantity_AbsorbedDose): void;
  SetType(aType: Graphic3d_ZLayerId): void;
  SetStateBefore(aState: TopAbs_State): void;
  SetStateAfter(aState: TopAbs_State): void;
  SetLayerHeight(aHeight: Quantity_AbsorbedDose): void;
  SetInterval(t1: Quantity_AbsorbedDose, t2: Quantity_AbsorbedDose, f1: Quantity_AbsorbedDose, f2: Quantity_AbsorbedDose): void;
  Root(): Quantity_AbsorbedDose;
  Type(): Graphic3d_ZLayerId;
  StateBefore(): TopAbs_State;
  StateAfter(): TopAbs_State;
  LayerHeight(): Quantity_AbsorbedDose;
  IsValid(): Standard_Boolean;
  Interval(t1: Quantity_AbsorbedDose, t2: Quantity_AbsorbedDose, f1: Quantity_AbsorbedDose, f2: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntTools_Root_1 extends IntTools_Root {
    constructor();
  }

  export declare class IntTools_Root_2 extends IntTools_Root {
    constructor(aRoot: Quantity_AbsorbedDose, aType: Graphic3d_ZLayerId);
  }

export declare class IntTools_CArray1OfReal {
  Init(V: Quantity_AbsorbedDose): void;
  Resize(theNewLength: Graphic3d_ZLayerId): void;
  Destroy(): void;
  Length(): Graphic3d_ZLayerId;
  Append(Value: Quantity_AbsorbedDose): void;
  SetValue(Index: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  Value(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeValue(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsEqual(Other: IntTools_CArray1OfReal): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_CArray1OfReal_1 extends IntTools_CArray1OfReal {
    constructor(Length: Graphic3d_ZLayerId);
  }

  export declare class IntTools_CArray1OfReal_2 extends IntTools_CArray1OfReal {
    constructor(Item: Quantity_AbsorbedDose, Length: Graphic3d_ZLayerId);
  }

export declare class IntTools_CommonPrt {
  Assign(Other: IntTools_CommonPrt): IntTools_CommonPrt;
  SetEdge1(anE: TopoDS_Edge): void;
  SetEdge2(anE: TopoDS_Edge): void;
  SetType(aType: TopAbs_ShapeEnum): void;
  SetRange1_1(aR: IntTools_Range): void;
  SetRange1_2(tf: Quantity_AbsorbedDose, tl: Quantity_AbsorbedDose): void;
  AppendRange2_1(aR: IntTools_Range): void;
  AppendRange2_2(tf: Quantity_AbsorbedDose, tl: Quantity_AbsorbedDose): void;
  SetVertexParameter1(tV: Quantity_AbsorbedDose): void;
  SetVertexParameter2(tV: Quantity_AbsorbedDose): void;
  Edge1(): TopoDS_Edge;
  Edge2(): TopoDS_Edge;
  Type(): TopAbs_ShapeEnum;
  Range1_1(): IntTools_Range;
  Range1_2(tf: Quantity_AbsorbedDose, tl: Quantity_AbsorbedDose): void;
  Ranges2(): IntTools_SequenceOfRanges;
  ChangeRanges2(): IntTools_SequenceOfRanges;
  VertexParameter1(): Quantity_AbsorbedDose;
  VertexParameter2(): Quantity_AbsorbedDose;
  Copy(anOther: IntTools_CommonPrt): void;
  AllNullFlag(): Standard_Boolean;
  SetAllNullFlag(aFlag: Standard_Boolean): void;
  SetBoundingPoints(aP1: gp_Pnt, aP2: gp_Pnt): void;
  BoundingPoints(aP1: gp_Pnt, aP2: gp_Pnt): void;
  delete(): void;
}

  export declare class IntTools_CommonPrt_1 extends IntTools_CommonPrt {
    constructor();
  }

  export declare class IntTools_CommonPrt_2 extends IntTools_CommonPrt {
    constructor(aCPrt: IntTools_CommonPrt);
  }

export declare class IntTools_Curve {
  SetCurves(the3dCurve: Handle_Geom_Curve, the2dCurve1: Handle_Geom2d_Curve, the2dCurve2: Handle_Geom2d_Curve): void;
  SetCurve(the3dCurve: Handle_Geom_Curve): void;
  SetFirstCurve2d(the2dCurve1: Handle_Geom2d_Curve): void;
  SetSecondCurve2d(the2dCurve2: Handle_Geom2d_Curve): void;
  SetTolerance(theTolerance: Quantity_AbsorbedDose): void;
  SetTangentialTolerance(theTangentialTolerance: Quantity_AbsorbedDose): void;
  Curve(): Handle_Geom_Curve;
  FirstCurve2d(): Handle_Geom2d_Curve;
  SecondCurve2d(): Handle_Geom2d_Curve;
  Tolerance(): Quantity_AbsorbedDose;
  TangentialTolerance(): Quantity_AbsorbedDose;
  HasBounds(): Standard_Boolean;
  Bounds(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theFirstPnt: gp_Pnt, theLastPnt: gp_Pnt): Standard_Boolean;
  D0(thePar: Quantity_AbsorbedDose, thePnt: gp_Pnt): Standard_Boolean;
  Type(): GeomAbs_CurveType;
  delete(): void;
}

  export declare class IntTools_Curve_1 extends IntTools_Curve {
    constructor();
  }

  export declare class IntTools_Curve_2 extends IntTools_Curve {
    constructor(the3dCurve3d: Handle_Geom_Curve, the2dCurve1: Handle_Geom2d_Curve, the2dCurve2: Handle_Geom2d_Curve, theTolerance: Quantity_AbsorbedDose, theTangentialTolerance: Quantity_AbsorbedDose);
  }

export declare class IntTools_BeanFaceIntersector {
  Init_1(theEdge: TopoDS_Edge, theFace: TopoDS_Face): void;
  Init_2(theCurve: BRepAdaptor_Curve, theSurface: BRepAdaptor_Surface, theBeanTolerance: Quantity_AbsorbedDose, theFaceTolerance: Quantity_AbsorbedDose): void;
  Init_3(theCurve: BRepAdaptor_Curve, theSurface: BRepAdaptor_Surface, theFirstParOnCurve: Quantity_AbsorbedDose, theLastParOnCurve: Quantity_AbsorbedDose, theUMinParameter: Quantity_AbsorbedDose, theUMaxParameter: Quantity_AbsorbedDose, theVMinParameter: Quantity_AbsorbedDose, theVMaxParameter: Quantity_AbsorbedDose, theBeanTolerance: Quantity_AbsorbedDose, theFaceTolerance: Quantity_AbsorbedDose): void;
  SetContext(theContext: Handle_IntTools_Context): void;
  Context(): Handle_IntTools_Context;
  SetBeanParameters(theFirstParOnCurve: Quantity_AbsorbedDose, theLastParOnCurve: Quantity_AbsorbedDose): void;
  SetSurfaceParameters(theUMinParameter: Quantity_AbsorbedDose, theUMaxParameter: Quantity_AbsorbedDose, theVMinParameter: Quantity_AbsorbedDose, theVMaxParameter: Quantity_AbsorbedDose): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  Result_1(): IntTools_SequenceOfRanges;
  Result_2(theResults: IntTools_SequenceOfRanges): void;
  MinimalSquareDistance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntTools_BeanFaceIntersector_1 extends IntTools_BeanFaceIntersector {
    constructor();
  }

  export declare class IntTools_BeanFaceIntersector_2 extends IntTools_BeanFaceIntersector {
    constructor(theEdge: TopoDS_Edge, theFace: TopoDS_Face);
  }

  export declare class IntTools_BeanFaceIntersector_3 extends IntTools_BeanFaceIntersector {
    constructor(theCurve: BRepAdaptor_Curve, theSurface: BRepAdaptor_Surface, theBeanTolerance: Quantity_AbsorbedDose, theFaceTolerance: Quantity_AbsorbedDose);
  }

  export declare class IntTools_BeanFaceIntersector_4 extends IntTools_BeanFaceIntersector {
    constructor(theCurve: BRepAdaptor_Curve, theSurface: BRepAdaptor_Surface, theFirstParOnCurve: Quantity_AbsorbedDose, theLastParOnCurve: Quantity_AbsorbedDose, theUMinParameter: Quantity_AbsorbedDose, theUMaxParameter: Quantity_AbsorbedDose, theVMinParameter: Quantity_AbsorbedDose, theVMaxParameter: Quantity_AbsorbedDose, theBeanTolerance: Quantity_AbsorbedDose, theFaceTolerance: Quantity_AbsorbedDose);
  }

export declare class IntTools_SequenceOfPntOn2Faces extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntTools_SequenceOfPntOn2Faces): IntTools_SequenceOfPntOn2Faces;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntTools_PntOn2Faces): void;
  Append_2(theSeq: IntTools_SequenceOfPntOn2Faces): void;
  Prepend_1(theItem: IntTools_PntOn2Faces): void;
  Prepend_2(theSeq: IntTools_SequenceOfPntOn2Faces): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntTools_PntOn2Faces): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfPntOn2Faces): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfPntOn2Faces): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntTools_PntOn2Faces): void;
  Split(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfPntOn2Faces): void;
  First(): IntTools_PntOn2Faces;
  ChangeFirst(): IntTools_PntOn2Faces;
  Last(): IntTools_PntOn2Faces;
  ChangeLast(): IntTools_PntOn2Faces;
  Value(theIndex: Standard_Integer): IntTools_PntOn2Faces;
  ChangeValue(theIndex: Standard_Integer): IntTools_PntOn2Faces;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_PntOn2Faces): void;
  delete(): void;
}

  export declare class IntTools_SequenceOfPntOn2Faces_1 extends IntTools_SequenceOfPntOn2Faces {
    constructor();
  }

  export declare class IntTools_SequenceOfPntOn2Faces_2 extends IntTools_SequenceOfPntOn2Faces {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_SequenceOfPntOn2Faces_3 extends IntTools_SequenceOfPntOn2Faces {
    constructor(theOther: IntTools_SequenceOfPntOn2Faces);
  }

export declare class IntTools_SequenceOfRanges extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntTools_SequenceOfRanges): IntTools_SequenceOfRanges;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntTools_Range): void;
  Append_2(theSeq: IntTools_SequenceOfRanges): void;
  Prepend_1(theItem: IntTools_Range): void;
  Prepend_2(theSeq: IntTools_SequenceOfRanges): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntTools_Range): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfRanges): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfRanges): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntTools_Range): void;
  Split(theIndex: Standard_Integer, theSeq: IntTools_SequenceOfRanges): void;
  First(): IntTools_Range;
  ChangeFirst(): IntTools_Range;
  Last(): IntTools_Range;
  ChangeLast(): IntTools_Range;
  Value(theIndex: Standard_Integer): IntTools_Range;
  ChangeValue(theIndex: Standard_Integer): IntTools_Range;
  SetValue(theIndex: Standard_Integer, theItem: IntTools_Range): void;
  delete(): void;
}

  export declare class IntTools_SequenceOfRanges_1 extends IntTools_SequenceOfRanges {
    constructor();
  }

  export declare class IntTools_SequenceOfRanges_2 extends IntTools_SequenceOfRanges {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_SequenceOfRanges_3 extends IntTools_SequenceOfRanges {
    constructor(theOther: IntTools_SequenceOfRanges);
  }

export declare class IntTools_SurfaceRangeSampleMapHasher {
  constructor();
  static HashCode(theKey: IntTools_SurfaceRangeSample, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(S1: IntTools_SurfaceRangeSample, S2: IntTools_SurfaceRangeSample): Standard_Boolean;
  delete(): void;
}

export declare class IntTools_ListOfBox extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: IntTools_ListOfBox): IntTools_ListOfBox;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Bnd_Box;
  First_2(): Bnd_Box;
  Last_1(): Bnd_Box;
  Last_2(): Bnd_Box;
  Append_1(theItem: Bnd_Box): Bnd_Box;
  Append_3(theOther: IntTools_ListOfBox): void;
  Prepend_1(theItem: Bnd_Box): Bnd_Box;
  Prepend_2(theOther: IntTools_ListOfBox): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class IntTools_ListOfBox_1 extends IntTools_ListOfBox {
    constructor();
  }

  export declare class IntTools_ListOfBox_2 extends IntTools_ListOfBox {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntTools_ListOfBox_3 extends IntTools_ListOfBox {
    constructor(theOther: IntTools_ListOfBox);
  }

export declare class IntTools_Range {
  SetFirst(aFirst: Quantity_AbsorbedDose): void;
  SetLast(aLast: Quantity_AbsorbedDose): void;
  First(): Quantity_AbsorbedDose;
  Last(): Quantity_AbsorbedDose;
  Range(aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntTools_Range_1 extends IntTools_Range {
    constructor();
  }

  export declare class IntTools_Range_2 extends IntTools_Range {
    constructor(aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose);
  }

export declare class IntTools_CArray1OfInteger {
  Init(V: Graphic3d_ZLayerId): void;
  Resize(theNewLength: Graphic3d_ZLayerId): void;
  Destroy(): void;
  Length(): Graphic3d_ZLayerId;
  Append(Value: Graphic3d_ZLayerId): void;
  SetValue(Index: Graphic3d_ZLayerId, Value: Graphic3d_ZLayerId): void;
  Value(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ChangeValue(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsEqual(Other: IntTools_CArray1OfInteger): Standard_Boolean;
  delete(): void;
}

  export declare class IntTools_CArray1OfInteger_1 extends IntTools_CArray1OfInteger {
    constructor(Length: Graphic3d_ZLayerId);
  }

  export declare class IntTools_CArray1OfInteger_2 extends IntTools_CArray1OfInteger {
    constructor(Item: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId);
  }

export declare class BinTools_CurveSet {
  constructor()
  Clear(): void;
  Add(C: Handle_Geom_Curve): Graphic3d_ZLayerId;
  Curve(I: Graphic3d_ZLayerId): Handle_Geom_Curve;
  Index(C: Handle_Geom_Curve): Graphic3d_ZLayerId;
  Write(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  Read(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  static WriteCurve(C: Handle_Geom_Curve, OS: Standard_OStream): void;
  delete(): void;
}

export declare class BinTools_Curve2dSet {
  constructor()
  Clear(): void;
  Add(C: Handle_Geom2d_Curve): Graphic3d_ZLayerId;
  Curve2d(I: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  Index(C: Handle_Geom2d_Curve): Graphic3d_ZLayerId;
  Write(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  Read(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  static WriteCurve2d(C: Handle_Geom2d_Curve, OS: Standard_OStream): void;
  delete(): void;
}

export declare class BinTools_ShapeSet {
  constructor(isWithTriangles: Standard_Boolean)
  IsWithTriangles(): Standard_Boolean;
  SetWithTriangles(isWithTriangles: Standard_Boolean): void;
  SetFormatNb(theFormatNb: Graphic3d_ZLayerId): void;
  FormatNb(): Graphic3d_ZLayerId;
  Clear(): void;
  Add(S: TopoDS_Shape): Graphic3d_ZLayerId;
  Shape(I: Graphic3d_ZLayerId): TopoDS_Shape;
  Index(S: TopoDS_Shape): Graphic3d_ZLayerId;
  Locations(): BinTools_LocationSet;
  ChangeLocations(): BinTools_LocationSet;
  NbShapes(): Graphic3d_ZLayerId;
  Write_1(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  Read_1(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  Write_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  WriteGeometry_1(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  ReadGeometry_1(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  Read_2(S: TopoDS_Shape, IS: Standard_IStream, NbShapes: Graphic3d_ZLayerId): void;
  WriteGeometry_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  ReadGeometry_2(T: TopAbs_ShapeEnum, IS: Standard_IStream, S: TopoDS_Shape): void;
  AddGeometry(S: TopoDS_Shape): void;
  AddShapes(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  ReadPolygon3D(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  WritePolygon3D(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  ReadTriangulation(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  WriteTriangulation(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  ReadPolygonOnTriangulation(IS: Standard_IStream, theRange: Message_ProgressRange): void;
  WritePolygonOnTriangulation(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  delete(): void;
}

export declare class BinTools {
  constructor();
  static Write_1(theShape: TopoDS_Shape, theStream: Standard_OStream, theRange: Message_ProgressRange): void;
  static Read_1(theShape: TopoDS_Shape, theStream: Standard_IStream, theRange: Message_ProgressRange): void;
  static Write_2(theShape: TopoDS_Shape, theFile: Standard_CString, theRange: Message_ProgressRange): Standard_Boolean;
  static Read_2(theShape: TopoDS_Shape, theFile: Standard_CString, theRange: Message_ProgressRange): Standard_Boolean;
  delete(): void;
}

export declare class BinTools_LocationSet {
  constructor()
  Clear(): void;
  Add(L: TopLoc_Location): Graphic3d_ZLayerId;
  Location(I: Graphic3d_ZLayerId): TopLoc_Location;
  Index(L: TopLoc_Location): Graphic3d_ZLayerId;
  NbLocations(): Graphic3d_ZLayerId;
  Write(OS: Standard_OStream): void;
  Read(IS: Standard_IStream): void;
  delete(): void;
}

export declare class BinTools_SurfaceSet {
  constructor()
  Clear(): void;
  Add(S: Handle_Geom_Surface): Graphic3d_ZLayerId;
  Surface(I: Graphic3d_ZLayerId): Handle_Geom_Surface;
  Index(S: Handle_Geom_Surface): Graphic3d_ZLayerId;
  Write(OS: Standard_OStream, theRange: Message_ProgressRange): void;
  Read(IS: Standard_IStream, therange: Message_ProgressRange): void;
  static WriteSurface(S: Handle_Geom_Surface, OS: Standard_OStream): void;
  delete(): void;
}

export declare class Plugin {
  constructor();
  static Load(aGUID: Standard_GUID, theVerbose: Standard_Boolean): Handle_Standard_Transient;
  delete(): void;
}

export declare class Plugin_MapOfFunctions extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Plugin_MapOfFunctions): void;
  Assign(theOther: Plugin_MapOfFunctions): Plugin_MapOfFunctions;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_AsciiString, theItem: OSD_Function): Standard_Boolean;
  Bound(theKey: TCollection_AsciiString, theItem: OSD_Function): OSD_Function;
  IsBound(theKey: TCollection_AsciiString): Standard_Boolean;
  UnBind(theKey: TCollection_AsciiString): Standard_Boolean;
  Seek(theKey: TCollection_AsciiString): OSD_Function;
  ChangeSeek(theKey: TCollection_AsciiString): OSD_Function;
  ChangeFind(theKey: TCollection_AsciiString): OSD_Function;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Plugin_MapOfFunctions_1 extends Plugin_MapOfFunctions {
    constructor();
  }

  export declare class Plugin_MapOfFunctions_2 extends Plugin_MapOfFunctions {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Plugin_MapOfFunctions_3 extends Plugin_MapOfFunctions {
    constructor(theOther: Plugin_MapOfFunctions);
  }

export declare class Plugin_Failure extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Plugin_Failure;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Plugin_Failure_1 extends Plugin_Failure {
    constructor();
  }

  export declare class Plugin_Failure_2 extends Plugin_Failure {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Plugin_Failure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Plugin_Failure): void;
  get(): Plugin_Failure;
  delete(): void;
}

  export declare class Handle_Plugin_Failure_1 extends Handle_Plugin_Failure {
    constructor();
  }

  export declare class Handle_Plugin_Failure_2 extends Handle_Plugin_Failure {
    constructor(thePtr: Plugin_Failure);
  }

  export declare class Handle_Plugin_Failure_3 extends Handle_Plugin_Failure {
    constructor(theHandle: Handle_Plugin_Failure);
  }

  export declare class Handle_Plugin_Failure_4 extends Handle_Plugin_Failure {
    constructor(theHandle: Handle_Plugin_Failure);
  }

export declare class Handle_Units_UnitsSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_UnitsSystem): void;
  get(): Units_UnitsSystem;
  delete(): void;
}

  export declare class Handle_Units_UnitsSystem_1 extends Handle_Units_UnitsSystem {
    constructor();
  }

  export declare class Handle_Units_UnitsSystem_2 extends Handle_Units_UnitsSystem {
    constructor(thePtr: Units_UnitsSystem);
  }

  export declare class Handle_Units_UnitsSystem_3 extends Handle_Units_UnitsSystem {
    constructor(theHandle: Handle_Units_UnitsSystem);
  }

  export declare class Handle_Units_UnitsSystem_4 extends Handle_Units_UnitsSystem {
    constructor(theHandle: Handle_Units_UnitsSystem);
  }

export declare class Units_UnitsSystem extends Standard_Transient {
  QuantitiesSequence(): Handle_Units_QuantitiesSequence;
  ActiveUnitsSequence(): Handle_TColStd_HSequenceOfInteger;
  Specify(aquantity: Standard_CString, aunit: Standard_CString): void;
  Remove(aquantity: Standard_CString, aunit: Standard_CString): void;
  Activate(aquantity: Standard_CString, aunit: Standard_CString): void;
  Activates(): void;
  ActiveUnit(aquantity: Standard_CString): XCAFDoc_PartId;
  ConvertValueToUserSystem(aquantity: Standard_CString, avalue: Quantity_AbsorbedDose, aunit: Standard_CString): Quantity_AbsorbedDose;
  ConvertSIValueToUserSystem(aquantity: Standard_CString, avalue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  ConvertUserSystemValueToSI(aquantity: Standard_CString, avalue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Dump(): void;
  IsEmpty(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Units_UnitsSystem_1 extends Units_UnitsSystem {
    constructor();
  }

  export declare class Units_UnitsSystem_2 extends Units_UnitsSystem {
    constructor(aName: Standard_CString, Verbose: Standard_Boolean);
  }

export declare class Handle_Units_NoSuchType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_NoSuchType): void;
  get(): Units_NoSuchType;
  delete(): void;
}

  export declare class Handle_Units_NoSuchType_1 extends Handle_Units_NoSuchType {
    constructor();
  }

  export declare class Handle_Units_NoSuchType_2 extends Handle_Units_NoSuchType {
    constructor(thePtr: Units_NoSuchType);
  }

  export declare class Handle_Units_NoSuchType_3 extends Handle_Units_NoSuchType {
    constructor(theHandle: Handle_Units_NoSuchType);
  }

  export declare class Handle_Units_NoSuchType_4 extends Handle_Units_NoSuchType {
    constructor(theHandle: Handle_Units_NoSuchType);
  }

export declare class Units_NoSuchType extends Standard_NoSuchObject {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Units_NoSuchType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Units_NoSuchType_1 extends Units_NoSuchType {
    constructor();
  }

  export declare class Units_NoSuchType_2 extends Units_NoSuchType {
    constructor(theMessage: Standard_CString);
  }

export declare class Units_UnitSentence extends Units_Sentence {
  Analyse(): void;
  SetUnits(aquantitiessequence: Handle_Units_QuantitiesSequence): void;
  delete(): void;
}

  export declare class Units_UnitSentence_1 extends Units_UnitSentence {
    constructor(astring: Standard_CString);
  }

  export declare class Units_UnitSentence_2 extends Units_UnitSentence {
    constructor(astring: Standard_CString, aquantitiessequence: Handle_Units_QuantitiesSequence);
  }

export declare class Handle_Units_Quantity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_Quantity): void;
  get(): Units_Quantity;
  delete(): void;
}

  export declare class Handle_Units_Quantity_1 extends Handle_Units_Quantity {
    constructor();
  }

  export declare class Handle_Units_Quantity_2 extends Handle_Units_Quantity {
    constructor(thePtr: Units_Quantity);
  }

  export declare class Handle_Units_Quantity_3 extends Handle_Units_Quantity {
    constructor(theHandle: Handle_Units_Quantity);
  }

  export declare class Handle_Units_Quantity_4 extends Handle_Units_Quantity {
    constructor(theHandle: Handle_Units_Quantity);
  }

export declare class Units_Quantity extends Standard_Transient {
  constructor(aname: Standard_CString, adimensions: Handle_Units_Dimensions, aunitssequence: Handle_Units_UnitsSequence)
  Name(): XCAFDoc_PartId;
  Dimensions(): Handle_Units_Dimensions;
  Sequence(): Handle_Units_UnitsSequence;
  IsEqual(astring: Standard_CString): Standard_Boolean;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Units_QuantitiesSequence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_QuantitiesSequence): void;
  get(): Units_QuantitiesSequence;
  delete(): void;
}

  export declare class Handle_Units_QuantitiesSequence_1 extends Handle_Units_QuantitiesSequence {
    constructor();
  }

  export declare class Handle_Units_QuantitiesSequence_2 extends Handle_Units_QuantitiesSequence {
    constructor(thePtr: Units_QuantitiesSequence);
  }

  export declare class Handle_Units_QuantitiesSequence_3 extends Handle_Units_QuantitiesSequence {
    constructor(theHandle: Handle_Units_QuantitiesSequence);
  }

  export declare class Handle_Units_QuantitiesSequence_4 extends Handle_Units_QuantitiesSequence {
    constructor(theHandle: Handle_Units_QuantitiesSequence);
  }

export declare class Units_MathSentence extends Units_Sentence {
  constructor(astring: Standard_CString)
  delete(): void;
}

export declare class Handle_Units_Token {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_Token): void;
  get(): Units_Token;
  delete(): void;
}

  export declare class Handle_Units_Token_1 extends Handle_Units_Token {
    constructor();
  }

  export declare class Handle_Units_Token_2 extends Handle_Units_Token {
    constructor(thePtr: Units_Token);
  }

  export declare class Handle_Units_Token_3 extends Handle_Units_Token {
    constructor(theHandle: Handle_Units_Token);
  }

  export declare class Handle_Units_Token_4 extends Handle_Units_Token {
    constructor(theHandle: Handle_Units_Token);
  }

export declare class Units_Token extends Standard_Transient {
  Creates(): Handle_Units_Token;
  Length(): Graphic3d_ZLayerId;
  Word_1(): XCAFDoc_PartId;
  Word_2(aword: Standard_CString): void;
  Mean_1(): XCAFDoc_PartId;
  Mean_2(amean: Standard_CString): void;
  Value_1(): Quantity_AbsorbedDose;
  Value_2(avalue: Quantity_AbsorbedDose): void;
  Dimensions_1(): Handle_Units_Dimensions;
  Dimensions_2(adimensions: Handle_Units_Dimensions): void;
  Update(amean: Standard_CString): void;
  Add_1(aninteger: Graphic3d_ZLayerId): Handle_Units_Token;
  Add_2(atoken: Handle_Units_Token): Handle_Units_Token;
  Subtract(atoken: Handle_Units_Token): Handle_Units_Token;
  Multiply(atoken: Handle_Units_Token): Handle_Units_Token;
  Multiplied(avalue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Divide(atoken: Handle_Units_Token): Handle_Units_Token;
  Divided(avalue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Power_1(atoken: Handle_Units_Token): Handle_Units_Token;
  Power_2(anexponent: Quantity_AbsorbedDose): Handle_Units_Token;
  IsEqual_1(astring: Standard_CString): Standard_Boolean;
  IsEqual_2(atoken: Handle_Units_Token): Standard_Boolean;
  IsNotEqual_1(astring: Standard_CString): Standard_Boolean;
  IsNotEqual_2(atoken: Handle_Units_Token): Standard_Boolean;
  IsLessOrEqual(astring: Standard_CString): Standard_Boolean;
  IsGreater_1(astring: Standard_CString): Standard_Boolean;
  IsGreater_2(atoken: Handle_Units_Token): Standard_Boolean;
  IsGreaterOrEqual(atoken: Handle_Units_Token): Standard_Boolean;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Units_Token_1 extends Units_Token {
    constructor();
  }

  export declare class Units_Token_2 extends Units_Token {
    constructor(aword: Standard_CString);
  }

  export declare class Units_Token_3 extends Units_Token {
    constructor(atoken: Handle_Units_Token);
  }

  export declare class Units_Token_4 extends Units_Token {
    constructor(aword: Standard_CString, amean: Standard_CString);
  }

  export declare class Units_Token_5 extends Units_Token {
    constructor(aword: Standard_CString, amean: Standard_CString, avalue: Quantity_AbsorbedDose);
  }

  export declare class Units_Token_6 extends Units_Token {
    constructor(aword: Standard_CString, amean: Standard_CString, avalue: Quantity_AbsorbedDose, adimension: Handle_Units_Dimensions);
  }

export declare class Handle_Units_TokensSequence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_TokensSequence): void;
  get(): Units_TokensSequence;
  delete(): void;
}

  export declare class Handle_Units_TokensSequence_1 extends Handle_Units_TokensSequence {
    constructor();
  }

  export declare class Handle_Units_TokensSequence_2 extends Handle_Units_TokensSequence {
    constructor(thePtr: Units_TokensSequence);
  }

  export declare class Handle_Units_TokensSequence_3 extends Handle_Units_TokensSequence {
    constructor(theHandle: Handle_Units_TokensSequence);
  }

  export declare class Handle_Units_TokensSequence_4 extends Handle_Units_TokensSequence {
    constructor(theHandle: Handle_Units_TokensSequence);
  }

export declare class Units_Sentence {
  constructor(alexicon: Handle_Units_Lexicon, astring: Standard_CString)
  SetConstants(): void;
  Sequence_1(): Handle_Units_TokensSequence;
  Sequence_2(asequenceoftokens: Handle_Units_TokensSequence): void;
  Evaluate(): Handle_Units_Token;
  IsDone(): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

export declare class Handle_Units_ShiftedToken {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_ShiftedToken): void;
  get(): Units_ShiftedToken;
  delete(): void;
}

  export declare class Handle_Units_ShiftedToken_1 extends Handle_Units_ShiftedToken {
    constructor();
  }

  export declare class Handle_Units_ShiftedToken_2 extends Handle_Units_ShiftedToken {
    constructor(thePtr: Units_ShiftedToken);
  }

  export declare class Handle_Units_ShiftedToken_3 extends Handle_Units_ShiftedToken {
    constructor(theHandle: Handle_Units_ShiftedToken);
  }

  export declare class Handle_Units_ShiftedToken_4 extends Handle_Units_ShiftedToken {
    constructor(theHandle: Handle_Units_ShiftedToken);
  }

export declare class Units_ShiftedToken extends Units_Token {
  constructor(aword: Standard_CString, amean: Standard_CString, avalue: Quantity_AbsorbedDose, amove: Quantity_AbsorbedDose, adimensions: Handle_Units_Dimensions)
  Creates(): Handle_Units_Token;
  Move(): Quantity_AbsorbedDose;
  Multiplied(avalue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Divided(avalue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Units_UnitsSequence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_UnitsSequence): void;
  get(): Units_UnitsSequence;
  delete(): void;
}

  export declare class Handle_Units_UnitsSequence_1 extends Handle_Units_UnitsSequence {
    constructor();
  }

  export declare class Handle_Units_UnitsSequence_2 extends Handle_Units_UnitsSequence {
    constructor(thePtr: Units_UnitsSequence);
  }

  export declare class Handle_Units_UnitsSequence_3 extends Handle_Units_UnitsSequence {
    constructor(theHandle: Handle_Units_UnitsSequence);
  }

  export declare class Handle_Units_UnitsSequence_4 extends Handle_Units_UnitsSequence {
    constructor(theHandle: Handle_Units_UnitsSequence);
  }

export declare class Handle_Units_ShiftedUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_ShiftedUnit): void;
  get(): Units_ShiftedUnit;
  delete(): void;
}

  export declare class Handle_Units_ShiftedUnit_1 extends Handle_Units_ShiftedUnit {
    constructor();
  }

  export declare class Handle_Units_ShiftedUnit_2 extends Handle_Units_ShiftedUnit {
    constructor(thePtr: Units_ShiftedUnit);
  }

  export declare class Handle_Units_ShiftedUnit_3 extends Handle_Units_ShiftedUnit {
    constructor(theHandle: Handle_Units_ShiftedUnit);
  }

  export declare class Handle_Units_ShiftedUnit_4 extends Handle_Units_ShiftedUnit {
    constructor(theHandle: Handle_Units_ShiftedUnit);
  }

export declare class Units_ShiftedUnit extends Units_Unit {
  Move_1(amove: Quantity_AbsorbedDose): void;
  Move_2(): Quantity_AbsorbedDose;
  Token(): Handle_Units_Token;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Units_ShiftedUnit_1 extends Units_ShiftedUnit {
    constructor(aname: Standard_CString, asymbol: Standard_CString, avalue: Quantity_AbsorbedDose, amove: Quantity_AbsorbedDose, aquantity: Handle_Units_Quantity);
  }

  export declare class Units_ShiftedUnit_2 extends Units_ShiftedUnit {
    constructor(aname: Standard_CString, asymbol: Standard_CString);
  }

  export declare class Units_ShiftedUnit_3 extends Units_ShiftedUnit {
    constructor(aname: Standard_CString);
  }

export declare class Units_Explorer {
  Init_1(aunitssystem: Handle_Units_UnitsSystem): void;
  Init_2(aunitsdictionary: Handle_Units_UnitsDictionary): void;
  Init_3(aunitssystem: Handle_Units_UnitsSystem, aquantity: Standard_CString): void;
  Init_4(aunitsdictionary: Handle_Units_UnitsDictionary, aquantity: Standard_CString): void;
  MoreQuantity(): Standard_Boolean;
  NextQuantity(): void;
  Quantity(): XCAFDoc_PartId;
  MoreUnit(): Standard_Boolean;
  NextUnit(): void;
  Unit(): XCAFDoc_PartId;
  IsActive(): Standard_Boolean;
  delete(): void;
}

  export declare class Units_Explorer_1 extends Units_Explorer {
    constructor();
  }

  export declare class Units_Explorer_2 extends Units_Explorer {
    constructor(aunitssystem: Handle_Units_UnitsSystem);
  }

  export declare class Units_Explorer_3 extends Units_Explorer {
    constructor(aunitsdictionary: Handle_Units_UnitsDictionary);
  }

  export declare class Units_Explorer_4 extends Units_Explorer {
    constructor(aunitssystem: Handle_Units_UnitsSystem, aquantity: Standard_CString);
  }

  export declare class Units_Explorer_5 extends Units_Explorer {
    constructor(aunitsdictionary: Handle_Units_UnitsDictionary, aquantity: Standard_CString);
  }

export declare class Handle_Units_Dimensions {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_Dimensions): void;
  get(): Units_Dimensions;
  delete(): void;
}

  export declare class Handle_Units_Dimensions_1 extends Handle_Units_Dimensions {
    constructor();
  }

  export declare class Handle_Units_Dimensions_2 extends Handle_Units_Dimensions {
    constructor(thePtr: Units_Dimensions);
  }

  export declare class Handle_Units_Dimensions_3 extends Handle_Units_Dimensions {
    constructor(theHandle: Handle_Units_Dimensions);
  }

  export declare class Handle_Units_Dimensions_4 extends Handle_Units_Dimensions {
    constructor(theHandle: Handle_Units_Dimensions);
  }

export declare class Units_Dimensions extends Standard_Transient {
  constructor(amass: Quantity_AbsorbedDose, alength: Quantity_AbsorbedDose, atime: Quantity_AbsorbedDose, anelectriccurrent: Quantity_AbsorbedDose, athermodynamictemperature: Quantity_AbsorbedDose, anamountofsubstance: Quantity_AbsorbedDose, aluminousintensity: Quantity_AbsorbedDose, aplaneangle: Quantity_AbsorbedDose, asolidangle: Quantity_AbsorbedDose)
  Mass(): Quantity_AbsorbedDose;
  Length(): Quantity_AbsorbedDose;
  Time(): Quantity_AbsorbedDose;
  ElectricCurrent(): Quantity_AbsorbedDose;
  ThermodynamicTemperature(): Quantity_AbsorbedDose;
  AmountOfSubstance(): Quantity_AbsorbedDose;
  LuminousIntensity(): Quantity_AbsorbedDose;
  PlaneAngle(): Quantity_AbsorbedDose;
  SolidAngle(): Quantity_AbsorbedDose;
  Quantity(): Standard_CString;
  Multiply(adimensions: Handle_Units_Dimensions): Handle_Units_Dimensions;
  Divide(adimensions: Handle_Units_Dimensions): Handle_Units_Dimensions;
  Power(anexponent: Quantity_AbsorbedDose): Handle_Units_Dimensions;
  IsEqual(adimensions: Handle_Units_Dimensions): Standard_Boolean;
  IsNotEqual(adimensions: Handle_Units_Dimensions): Standard_Boolean;
  Dump(ashift: Graphic3d_ZLayerId): void;
  static ALess(): Handle_Units_Dimensions;
  static AMass(): Handle_Units_Dimensions;
  static ALength(): Handle_Units_Dimensions;
  static ATime(): Handle_Units_Dimensions;
  static AElectricCurrent(): Handle_Units_Dimensions;
  static AThermodynamicTemperature(): Handle_Units_Dimensions;
  static AAmountOfSubstance(): Handle_Units_Dimensions;
  static ALuminousIntensity(): Handle_Units_Dimensions;
  static APlaneAngle(): Handle_Units_Dimensions;
  static ASolidAngle(): Handle_Units_Dimensions;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Units_NoSuchUnit extends Standard_NoSuchObject {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Units_NoSuchUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Units_NoSuchUnit_1 extends Units_NoSuchUnit {
    constructor();
  }

  export declare class Units_NoSuchUnit_2 extends Units_NoSuchUnit {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Units_NoSuchUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_NoSuchUnit): void;
  get(): Units_NoSuchUnit;
  delete(): void;
}

  export declare class Handle_Units_NoSuchUnit_1 extends Handle_Units_NoSuchUnit {
    constructor();
  }

  export declare class Handle_Units_NoSuchUnit_2 extends Handle_Units_NoSuchUnit {
    constructor(thePtr: Units_NoSuchUnit);
  }

  export declare class Handle_Units_NoSuchUnit_3 extends Handle_Units_NoSuchUnit {
    constructor(theHandle: Handle_Units_NoSuchUnit);
  }

  export declare class Handle_Units_NoSuchUnit_4 extends Handle_Units_NoSuchUnit {
    constructor(theHandle: Handle_Units_NoSuchUnit);
  }

export declare class Handle_Units_UnitsLexicon {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_UnitsLexicon): void;
  get(): Units_UnitsLexicon;
  delete(): void;
}

  export declare class Handle_Units_UnitsLexicon_1 extends Handle_Units_UnitsLexicon {
    constructor();
  }

  export declare class Handle_Units_UnitsLexicon_2 extends Handle_Units_UnitsLexicon {
    constructor(thePtr: Units_UnitsLexicon);
  }

  export declare class Handle_Units_UnitsLexicon_3 extends Handle_Units_UnitsLexicon {
    constructor(theHandle: Handle_Units_UnitsLexicon);
  }

  export declare class Handle_Units_UnitsLexicon_4 extends Handle_Units_UnitsLexicon {
    constructor(theHandle: Handle_Units_UnitsLexicon);
  }

export declare class Units_UnitsLexicon extends Units_Lexicon {
  constructor()
  Creates(amode: Standard_Boolean): void;
  Dump(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Units_Lexicon {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_Lexicon): void;
  get(): Units_Lexicon;
  delete(): void;
}

  export declare class Handle_Units_Lexicon_1 extends Handle_Units_Lexicon {
    constructor();
  }

  export declare class Handle_Units_Lexicon_2 extends Handle_Units_Lexicon {
    constructor(thePtr: Units_Lexicon);
  }

  export declare class Handle_Units_Lexicon_3 extends Handle_Units_Lexicon {
    constructor(theHandle: Handle_Units_Lexicon);
  }

  export declare class Handle_Units_Lexicon_4 extends Handle_Units_Lexicon {
    constructor(theHandle: Handle_Units_Lexicon);
  }

export declare class Units_Lexicon extends Standard_Transient {
  constructor()
  Creates(): void;
  Sequence(): Handle_Units_TokensSequence;
  AddToken(aword: Standard_CString, amean: Standard_CString, avalue: Quantity_AbsorbedDose): void;
  Dump(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Units_UnitsDictionary extends Standard_Transient {
  constructor()
  Creates(): void;
  Sequence(): Handle_Units_QuantitiesSequence;
  ActiveUnit(aquantity: Standard_CString): XCAFDoc_PartId;
  Dump_1(alevel: Graphic3d_ZLayerId): void;
  Dump_2(adimensions: Handle_Units_Dimensions): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Units_UnitsDictionary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_UnitsDictionary): void;
  get(): Units_UnitsDictionary;
  delete(): void;
}

  export declare class Handle_Units_UnitsDictionary_1 extends Handle_Units_UnitsDictionary {
    constructor();
  }

  export declare class Handle_Units_UnitsDictionary_2 extends Handle_Units_UnitsDictionary {
    constructor(thePtr: Units_UnitsDictionary);
  }

  export declare class Handle_Units_UnitsDictionary_3 extends Handle_Units_UnitsDictionary {
    constructor(theHandle: Handle_Units_UnitsDictionary);
  }

  export declare class Handle_Units_UnitsDictionary_4 extends Handle_Units_UnitsDictionary {
    constructor(theHandle: Handle_Units_UnitsDictionary);
  }

export declare class Units_Unit extends Standard_Transient {
  Name(): XCAFDoc_PartId;
  Symbol(asymbol: Standard_CString): void;
  Value_1(): Quantity_AbsorbedDose;
  Quantity_1(): Handle_Units_Quantity;
  SymbolsSequence(): Handle_TColStd_HSequenceOfHAsciiString;
  Value_2(avalue: Quantity_AbsorbedDose): void;
  Quantity_2(aquantity: Handle_Units_Quantity): void;
  Token(): Handle_Units_Token;
  IsEqual(astring: Standard_CString): Standard_Boolean;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Units_Unit_1 extends Units_Unit {
    constructor(aname: Standard_CString, asymbol: Standard_CString, avalue: Quantity_AbsorbedDose, aquantity: Handle_Units_Quantity);
  }

  export declare class Units_Unit_2 extends Units_Unit {
    constructor(aname: Standard_CString, asymbol: Standard_CString);
  }

  export declare class Units_Unit_3 extends Units_Unit {
    constructor(aname: Standard_CString);
  }

export declare class Handle_Units_Unit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Units_Unit): void;
  get(): Units_Unit;
  delete(): void;
}

  export declare class Handle_Units_Unit_1 extends Handle_Units_Unit {
    constructor();
  }

  export declare class Handle_Units_Unit_2 extends Handle_Units_Unit {
    constructor(thePtr: Units_Unit);
  }

  export declare class Handle_Units_Unit_3 extends Handle_Units_Unit {
    constructor(theHandle: Handle_Units_Unit);
  }

  export declare class Handle_Units_Unit_4 extends Handle_Units_Unit {
    constructor(theHandle: Handle_Units_Unit);
  }

export declare class Units_Measurement {
  Convert(aunit: Standard_CString): void;
  Integer(): Units_Measurement;
  Fractional(): Units_Measurement;
  Measurement(): Quantity_AbsorbedDose;
  Token(): Handle_Units_Token;
  Add(ameasurement: Units_Measurement): Units_Measurement;
  Subtract(ameasurement: Units_Measurement): Units_Measurement;
  Multiply_1(ameasurement: Units_Measurement): Units_Measurement;
  Multiply_2(avalue: Quantity_AbsorbedDose): Units_Measurement;
  Divide_1(ameasurement: Units_Measurement): Units_Measurement;
  Divide_2(avalue: Quantity_AbsorbedDose): Units_Measurement;
  Power(anexponent: Quantity_AbsorbedDose): Units_Measurement;
  HasToken(): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

  export declare class Units_Measurement_1 extends Units_Measurement {
    constructor();
  }

  export declare class Units_Measurement_2 extends Units_Measurement {
    constructor(avalue: Quantity_AbsorbedDose, atoken: Handle_Units_Token);
  }

  export declare class Units_Measurement_3 extends Units_Measurement {
    constructor(avalue: Quantity_AbsorbedDose, aunit: Standard_CString);
  }

export declare class Units {
  constructor();
  static UnitsFile(afile: Standard_CString): void;
  static LexiconFile(afile: Standard_CString): void;
  static DictionaryOfUnits(amode: Standard_Boolean): Handle_Units_UnitsDictionary;
  static Quantity(aquantity: Standard_CString): Handle_Units_Quantity;
  static FirstQuantity(aunit: Standard_CString): Standard_CString;
  static LexiconUnits(amode: Standard_Boolean): Handle_Units_Lexicon;
  static LexiconFormula(): Handle_Units_Lexicon;
  static NullDimensions(): Handle_Units_Dimensions;
  static Convert(avalue: Quantity_AbsorbedDose, afirstunit: Standard_CString, asecondunit: Standard_CString): Quantity_AbsorbedDose;
  static ToSI_1(aData: Quantity_AbsorbedDose, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static ToSI_2(aData: Quantity_AbsorbedDose, aUnit: Standard_CString, aDim: Handle_Units_Dimensions): Quantity_AbsorbedDose;
  static FromSI_1(aData: Quantity_AbsorbedDose, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static FromSI_2(aData: Quantity_AbsorbedDose, aUnit: Standard_CString, aDim: Handle_Units_Dimensions): Quantity_AbsorbedDose;
  static Dimensions(aType: Standard_CString): Handle_Units_Dimensions;
  delete(): void;
}

export declare class ShapeCustom_SweptToElementary extends ShapeCustom_Modification {
  constructor()
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeCustom_SweptToElementary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_SweptToElementary): void;
  get(): ShapeCustom_SweptToElementary;
  delete(): void;
}

  export declare class Handle_ShapeCustom_SweptToElementary_1 extends Handle_ShapeCustom_SweptToElementary {
    constructor();
  }

  export declare class Handle_ShapeCustom_SweptToElementary_2 extends Handle_ShapeCustom_SweptToElementary {
    constructor(thePtr: ShapeCustom_SweptToElementary);
  }

  export declare class Handle_ShapeCustom_SweptToElementary_3 extends Handle_ShapeCustom_SweptToElementary {
    constructor(theHandle: Handle_ShapeCustom_SweptToElementary);
  }

  export declare class Handle_ShapeCustom_SweptToElementary_4 extends Handle_ShapeCustom_SweptToElementary {
    constructor(theHandle: Handle_ShapeCustom_SweptToElementary);
  }

export declare class ShapeCustom_Curve {
  Init(C: Handle_Geom_Curve): void;
  ConvertToPeriodic(substitute: Standard_Boolean, preci: Quantity_AbsorbedDose): Handle_Geom_Curve;
  delete(): void;
}

  export declare class ShapeCustom_Curve_1 extends ShapeCustom_Curve {
    constructor();
  }

  export declare class ShapeCustom_Curve_2 extends ShapeCustom_Curve {
    constructor(C: Handle_Geom_Curve);
  }

export declare class Handle_ShapeCustom_ConvertToBSpline {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_ConvertToBSpline): void;
  get(): ShapeCustom_ConvertToBSpline;
  delete(): void;
}

  export declare class Handle_ShapeCustom_ConvertToBSpline_1 extends Handle_ShapeCustom_ConvertToBSpline {
    constructor();
  }

  export declare class Handle_ShapeCustom_ConvertToBSpline_2 extends Handle_ShapeCustom_ConvertToBSpline {
    constructor(thePtr: ShapeCustom_ConvertToBSpline);
  }

  export declare class Handle_ShapeCustom_ConvertToBSpline_3 extends Handle_ShapeCustom_ConvertToBSpline {
    constructor(theHandle: Handle_ShapeCustom_ConvertToBSpline);
  }

  export declare class Handle_ShapeCustom_ConvertToBSpline_4 extends Handle_ShapeCustom_ConvertToBSpline {
    constructor(theHandle: Handle_ShapeCustom_ConvertToBSpline);
  }

export declare class ShapeCustom_ConvertToBSpline extends ShapeCustom_Modification {
  constructor()
  SetExtrusionMode(extrMode: Standard_Boolean): void;
  SetRevolutionMode(revolMode: Standard_Boolean): void;
  SetOffsetMode(offsetMode: Standard_Boolean): void;
  SetPlaneMode(planeMode: Standard_Boolean): void;
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeCustom_ConvertToRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_ConvertToRevolution): void;
  get(): ShapeCustom_ConvertToRevolution;
  delete(): void;
}

  export declare class Handle_ShapeCustom_ConvertToRevolution_1 extends Handle_ShapeCustom_ConvertToRevolution {
    constructor();
  }

  export declare class Handle_ShapeCustom_ConvertToRevolution_2 extends Handle_ShapeCustom_ConvertToRevolution {
    constructor(thePtr: ShapeCustom_ConvertToRevolution);
  }

  export declare class Handle_ShapeCustom_ConvertToRevolution_3 extends Handle_ShapeCustom_ConvertToRevolution {
    constructor(theHandle: Handle_ShapeCustom_ConvertToRevolution);
  }

  export declare class Handle_ShapeCustom_ConvertToRevolution_4 extends Handle_ShapeCustom_ConvertToRevolution {
    constructor(theHandle: Handle_ShapeCustom_ConvertToRevolution);
  }

export declare class ShapeCustom_ConvertToRevolution extends ShapeCustom_Modification {
  constructor()
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeCustom_RestrictionParameters {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_RestrictionParameters): void;
  get(): ShapeCustom_RestrictionParameters;
  delete(): void;
}

  export declare class Handle_ShapeCustom_RestrictionParameters_1 extends Handle_ShapeCustom_RestrictionParameters {
    constructor();
  }

  export declare class Handle_ShapeCustom_RestrictionParameters_2 extends Handle_ShapeCustom_RestrictionParameters {
    constructor(thePtr: ShapeCustom_RestrictionParameters);
  }

  export declare class Handle_ShapeCustom_RestrictionParameters_3 extends Handle_ShapeCustom_RestrictionParameters {
    constructor(theHandle: Handle_ShapeCustom_RestrictionParameters);
  }

  export declare class Handle_ShapeCustom_RestrictionParameters_4 extends Handle_ShapeCustom_RestrictionParameters {
    constructor(theHandle: Handle_ShapeCustom_RestrictionParameters);
  }

export declare class ShapeCustom_RestrictionParameters extends Standard_Transient {
  constructor()
  GMaxDegree(): Graphic3d_ZLayerId;
  GMaxSeg(): Graphic3d_ZLayerId;
  ConvertPlane(): Standard_Boolean;
  ConvertBezierSurf(): Standard_Boolean;
  ConvertRevolutionSurf(): Standard_Boolean;
  ConvertExtrusionSurf(): Standard_Boolean;
  ConvertOffsetSurf(): Standard_Boolean;
  ConvertCylindricalSurf(): Standard_Boolean;
  ConvertConicalSurf(): Standard_Boolean;
  ConvertToroidalSurf(): Standard_Boolean;
  ConvertSphericalSurf(): Standard_Boolean;
  SegmentSurfaceMode(): Standard_Boolean;
  ConvertCurve3d(): Standard_Boolean;
  ConvertOffsetCurv3d(): Standard_Boolean;
  ConvertCurve2d(): Standard_Boolean;
  ConvertOffsetCurv2d(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeCustom {
  constructor();
  static ApplyModifier(S: TopoDS_Shape, M: Handle_BRepTools_Modification, context: TopTools_DataMapOfShapeShape, MD: BRepTools_Modifier, theProgress: Message_ProgressRange, aReShape: Handle_ShapeBuild_ReShape): TopoDS_Shape;
  static DirectFaces(S: TopoDS_Shape): TopoDS_Shape;
  static ScaleShape(S: TopoDS_Shape, scale: Quantity_AbsorbedDose): TopoDS_Shape;
  static BSplineRestriction(S: TopoDS_Shape, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, MaxDegree: Graphic3d_ZLayerId, MaxNbSegment: Graphic3d_ZLayerId, Continuity3d: GeomAbs_Shape, Continuity2d: GeomAbs_Shape, Degree: Standard_Boolean, Rational: Standard_Boolean, aParameters: Handle_ShapeCustom_RestrictionParameters): TopoDS_Shape;
  static ConvertToRevolution(S: TopoDS_Shape): TopoDS_Shape;
  static SweptToElementary(S: TopoDS_Shape): TopoDS_Shape;
  static ConvertToBSpline(S: TopoDS_Shape, extrMode: Standard_Boolean, revolMode: Standard_Boolean, offsetMode: Standard_Boolean, planeMode: Standard_Boolean): TopoDS_Shape;
  delete(): void;
}

export declare class ShapeCustom_DirectModification extends ShapeCustom_Modification {
  constructor()
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeCustom_DirectModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_DirectModification): void;
  get(): ShapeCustom_DirectModification;
  delete(): void;
}

  export declare class Handle_ShapeCustom_DirectModification_1 extends Handle_ShapeCustom_DirectModification {
    constructor();
  }

  export declare class Handle_ShapeCustom_DirectModification_2 extends Handle_ShapeCustom_DirectModification {
    constructor(thePtr: ShapeCustom_DirectModification);
  }

  export declare class Handle_ShapeCustom_DirectModification_3 extends Handle_ShapeCustom_DirectModification {
    constructor(theHandle: Handle_ShapeCustom_DirectModification);
  }

  export declare class Handle_ShapeCustom_DirectModification_4 extends Handle_ShapeCustom_DirectModification {
    constructor(theHandle: Handle_ShapeCustom_DirectModification);
  }

export declare class ShapeCustom_Modification extends BRepTools_Modification {
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  MsgRegistrator(): Handle_ShapeExtend_BasicMsgRegistrator;
  SendMsg(shape: TopoDS_Shape, message: Message_Msg, gravity: Message_Gravity): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeCustom_Modification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_Modification): void;
  get(): ShapeCustom_Modification;
  delete(): void;
}

  export declare class Handle_ShapeCustom_Modification_1 extends Handle_ShapeCustom_Modification {
    constructor();
  }

  export declare class Handle_ShapeCustom_Modification_2 extends Handle_ShapeCustom_Modification {
    constructor(thePtr: ShapeCustom_Modification);
  }

  export declare class Handle_ShapeCustom_Modification_3 extends Handle_ShapeCustom_Modification {
    constructor(theHandle: Handle_ShapeCustom_Modification);
  }

  export declare class Handle_ShapeCustom_Modification_4 extends Handle_ShapeCustom_Modification {
    constructor(theHandle: Handle_ShapeCustom_Modification);
  }

export declare class ShapeCustom_BSplineRestriction extends ShapeCustom_Modification {
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  ConvertSurface(aSurface: Handle_Geom_Surface, S: Handle_Geom_Surface, UF: Quantity_AbsorbedDose, UL: Quantity_AbsorbedDose, VF: Quantity_AbsorbedDose, VL: Quantity_AbsorbedDose, IsOf: Standard_Boolean): Standard_Boolean;
  ConvertCurve(aCurve: Handle_Geom_Curve, C: Handle_Geom_Curve, IsConvert: Standard_Boolean, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, TolCur: Quantity_AbsorbedDose, IsOf: Standard_Boolean): Standard_Boolean;
  ConvertCurve2d(aCurve: Handle_Geom2d_Curve, C: Handle_Geom2d_Curve, IsConvert: Standard_Boolean, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, TolCur: Quantity_AbsorbedDose, IsOf: Standard_Boolean): Standard_Boolean;
  SetTol3d(Tol3d: Quantity_AbsorbedDose): void;
  SetTol2d(Tol2d: Quantity_AbsorbedDose): void;
  ModifyApproxSurfaceFlag(): Standard_Boolean;
  ModifyApproxCurve3dFlag(): Standard_Boolean;
  ModifyApproxCurve2dFlag(): Standard_Boolean;
  SetContinuity3d(Continuity3d: GeomAbs_Shape): void;
  SetContinuity2d(Continuity2d: GeomAbs_Shape): void;
  SetMaxDegree(MaxDegree: Graphic3d_ZLayerId): void;
  SetMaxNbSegments(MaxNbSegments: Graphic3d_ZLayerId): void;
  SetPriority(Degree: Standard_Boolean): void;
  SetConvRational(Rational: Standard_Boolean): void;
  GetRestrictionParameters(): Handle_ShapeCustom_RestrictionParameters;
  SetRestrictionParameters(aModes: Handle_ShapeCustom_RestrictionParameters): void;
  Curve3dError(): Quantity_AbsorbedDose;
  Curve2dError(): Quantity_AbsorbedDose;
  SurfaceError(): Quantity_AbsorbedDose;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  MaxErrors(aCurve3dErr: Quantity_AbsorbedDose, aCurve2dErr: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  NbOfSpan(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeCustom_BSplineRestriction_1 extends ShapeCustom_BSplineRestriction {
    constructor();
  }

  export declare class ShapeCustom_BSplineRestriction_2 extends ShapeCustom_BSplineRestriction {
    constructor(anApproxSurfaceFlag: Standard_Boolean, anApproxCurve3dFlag: Standard_Boolean, anApproxCurve2dFlag: Standard_Boolean, aTol3d: Quantity_AbsorbedDose, aTol2d: Quantity_AbsorbedDose, aContinuity3d: GeomAbs_Shape, aContinuity2d: GeomAbs_Shape, aMaxDegree: Graphic3d_ZLayerId, aNbMaxSeg: Graphic3d_ZLayerId, Degree: Standard_Boolean, Rational: Standard_Boolean);
  }

  export declare class ShapeCustom_BSplineRestriction_3 extends ShapeCustom_BSplineRestriction {
    constructor(anApproxSurfaceFlag: Standard_Boolean, anApproxCurve3dFlag: Standard_Boolean, anApproxCurve2dFlag: Standard_Boolean, aTol3d: Quantity_AbsorbedDose, aTol2d: Quantity_AbsorbedDose, aContinuity3d: GeomAbs_Shape, aContinuity2d: GeomAbs_Shape, aMaxDegree: Graphic3d_ZLayerId, aNbMaxSeg: Graphic3d_ZLayerId, Degree: Standard_Boolean, Rational: Standard_Boolean, aModes: Handle_ShapeCustom_RestrictionParameters);
  }

export declare class Handle_ShapeCustom_BSplineRestriction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_BSplineRestriction): void;
  get(): ShapeCustom_BSplineRestriction;
  delete(): void;
}

  export declare class Handle_ShapeCustom_BSplineRestriction_1 extends Handle_ShapeCustom_BSplineRestriction {
    constructor();
  }

  export declare class Handle_ShapeCustom_BSplineRestriction_2 extends Handle_ShapeCustom_BSplineRestriction {
    constructor(thePtr: ShapeCustom_BSplineRestriction);
  }

  export declare class Handle_ShapeCustom_BSplineRestriction_3 extends Handle_ShapeCustom_BSplineRestriction {
    constructor(theHandle: Handle_ShapeCustom_BSplineRestriction);
  }

  export declare class Handle_ShapeCustom_BSplineRestriction_4 extends Handle_ShapeCustom_BSplineRestriction {
    constructor(theHandle: Handle_ShapeCustom_BSplineRestriction);
  }

export declare class ShapeCustom_TrsfModification extends BRepTools_TrsfModification {
  constructor(T: gp_Trsf)
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeCustom_TrsfModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeCustom_TrsfModification): void;
  get(): ShapeCustom_TrsfModification;
  delete(): void;
}

  export declare class Handle_ShapeCustom_TrsfModification_1 extends Handle_ShapeCustom_TrsfModification {
    constructor();
  }

  export declare class Handle_ShapeCustom_TrsfModification_2 extends Handle_ShapeCustom_TrsfModification {
    constructor(thePtr: ShapeCustom_TrsfModification);
  }

  export declare class Handle_ShapeCustom_TrsfModification_3 extends Handle_ShapeCustom_TrsfModification {
    constructor(theHandle: Handle_ShapeCustom_TrsfModification);
  }

  export declare class Handle_ShapeCustom_TrsfModification_4 extends Handle_ShapeCustom_TrsfModification {
    constructor(theHandle: Handle_ShapeCustom_TrsfModification);
  }

export declare class ShapeCustom_Surface {
  Init(S: Handle_Geom_Surface): void;
  Gap(): Quantity_AbsorbedDose;
  ConvertToAnalytical(tol: Quantity_AbsorbedDose, substitute: Standard_Boolean): Handle_Geom_Surface;
  ConvertToPeriodic(substitute: Standard_Boolean, preci: Quantity_AbsorbedDose): Handle_Geom_Surface;
  delete(): void;
}

  export declare class ShapeCustom_Surface_1 extends ShapeCustom_Surface {
    constructor();
  }

  export declare class ShapeCustom_Surface_2 extends ShapeCustom_Surface {
    constructor(S: Handle_Geom_Surface);
  }

export declare class ShapeCustom_Curve2d {
  constructor();
  static IsLinear(thePoles: TColgp_Array1OfPnt2d, theTolerance: Quantity_AbsorbedDose, theDeviation: Quantity_AbsorbedDose): Standard_Boolean;
  static ConvertToLine2d(theCurve: Handle_Geom2d_Curve, theFirstIn: Quantity_AbsorbedDose, theLastIn: Quantity_AbsorbedDose, theTolerance: Quantity_AbsorbedDose, theNewFirst: Quantity_AbsorbedDose, theNewLast: Quantity_AbsorbedDose, theDeviation: Quantity_AbsorbedDose): Handle_Geom2d_Line;
  static SimplifyBSpline2d(theBSpline2d: Handle_Geom2d_BSplineCurve, theTolerance: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepGProp_Face {
  Load_1(F: TopoDS_Face): void;
  VIntegrationOrder(): Graphic3d_ZLayerId;
  NaturalRestriction(): Standard_Boolean;
  GetFace(): TopoDS_Face;
  Value2d(U: Quantity_AbsorbedDose): gp_Pnt2d;
  SIntOrder(Eps: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  SVIntSubs(): Graphic3d_ZLayerId;
  SUIntSubs(): Graphic3d_ZLayerId;
  UKnots(Knots: TColStd_Array1OfReal): void;
  VKnots(Knots: TColStd_Array1OfReal): void;
  LIntOrder(Eps: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  LIntSubs(): Graphic3d_ZLayerId;
  LKnots(Knots: TColStd_Array1OfReal): void;
  UIntegrationOrder(): Graphic3d_ZLayerId;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Normal(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, VNor: gp_Vec): void;
  Load_2(E: TopoDS_Edge): Standard_Boolean;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IntegrationOrder(): Graphic3d_ZLayerId;
  D12d(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  Load_3(IsFirstParam: Standard_Boolean, theIsoType: GeomAbs_IsoType): void;
  GetUKnots(theUMin: Quantity_AbsorbedDose, theUMax: Quantity_AbsorbedDose, theUKnots: Handle_TColStd_HArray1OfReal): void;
  GetTKnots(theTMin: Quantity_AbsorbedDose, theTMax: Quantity_AbsorbedDose, theTKnots: Handle_TColStd_HArray1OfReal): void;
  delete(): void;
}

  export declare class BRepGProp_Face_1 extends BRepGProp_Face {
    constructor(IsUseSpan: Standard_Boolean);
  }

  export declare class BRepGProp_Face_2 extends BRepGProp_Face {
    constructor(F: TopoDS_Face, IsUseSpan: Standard_Boolean);
  }

export declare class BRepGProp {
  constructor();
  static LinearProperties(S: TopoDS_Shape, LProps: GProp_GProps, SkipShared: Standard_Boolean, UseTriangulation: Standard_Boolean): void;
  static SurfaceProperties_1(S: TopoDS_Shape, SProps: GProp_GProps, SkipShared: Standard_Boolean, UseTriangulation: Standard_Boolean): void;
  static SurfaceProperties_2(S: TopoDS_Shape, SProps: GProp_GProps, Eps: Quantity_AbsorbedDose, SkipShared: Standard_Boolean): Quantity_AbsorbedDose;
  static VolumeProperties_1(S: TopoDS_Shape, VProps: GProp_GProps, OnlyClosed: Standard_Boolean, SkipShared: Standard_Boolean, UseTriangulation: Standard_Boolean): void;
  static VolumeProperties_2(S: TopoDS_Shape, VProps: GProp_GProps, Eps: Quantity_AbsorbedDose, OnlyClosed: Standard_Boolean, SkipShared: Standard_Boolean): Quantity_AbsorbedDose;
  static VolumePropertiesGK_1(S: TopoDS_Shape, VProps: GProp_GProps, Eps: Quantity_AbsorbedDose, OnlyClosed: Standard_Boolean, IsUseSpan: Standard_Boolean, CGFlag: Standard_Boolean, IFlag: Standard_Boolean, SkipShared: Standard_Boolean): Quantity_AbsorbedDose;
  static VolumePropertiesGK_2(S: TopoDS_Shape, VProps: GProp_GProps, thePln: gp_Pln, Eps: Quantity_AbsorbedDose, OnlyClosed: Standard_Boolean, IsUseSpan: Standard_Boolean, CGFlag: Standard_Boolean, IFlag: Standard_Boolean, SkipShared: Standard_Boolean): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepGProp_MeshCinert extends GProp_GProps {
  constructor()
  SetLocation(CLocation: gp_Pnt): void;
  Perform(theNodes: TColgp_Array1OfPnt): void;
  static PreparePolygon(theE: TopoDS_Edge, thePolyg: Handle_TColgp_HArray1OfPnt): void;
  delete(): void;
}

export declare class BRepGProp_Sinert extends GProp_GProps {
  SetLocation(SLocation: gp_Pnt): void;
  Perform_1(S: BRepGProp_Face): void;
  Perform_2(S: BRepGProp_Face, D: BRepGProp_Domain): void;
  Perform_3(S: BRepGProp_Face, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Perform_4(S: BRepGProp_Face, D: BRepGProp_Domain, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetEpsilon(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepGProp_Sinert_1 extends BRepGProp_Sinert {
    constructor();
  }

  export declare class BRepGProp_Sinert_2 extends BRepGProp_Sinert {
    constructor(S: BRepGProp_Face, SLocation: gp_Pnt);
  }

  export declare class BRepGProp_Sinert_3 extends BRepGProp_Sinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, SLocation: gp_Pnt);
  }

  export declare class BRepGProp_Sinert_4 extends BRepGProp_Sinert {
    constructor(S: BRepGProp_Face, SLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

  export declare class BRepGProp_Sinert_5 extends BRepGProp_Sinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, SLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

export declare class BRepGProp_Vinert extends GProp_GProps {
  SetLocation(VLocation: gp_Pnt): void;
  Perform_1(S: BRepGProp_Face): void;
  Perform_2(S: BRepGProp_Face, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Perform_3(S: BRepGProp_Face, O: gp_Pnt): void;
  Perform_4(S: BRepGProp_Face, O: gp_Pnt, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Perform_5(S: BRepGProp_Face, Pl: gp_Pln): void;
  Perform_6(S: BRepGProp_Face, Pl: gp_Pln, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Perform_7(S: BRepGProp_Face, D: BRepGProp_Domain): void;
  Perform_8(S: BRepGProp_Face, D: BRepGProp_Domain, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Perform_9(S: BRepGProp_Face, D: BRepGProp_Domain, O: gp_Pnt): void;
  Perform_10(S: BRepGProp_Face, D: BRepGProp_Domain, O: gp_Pnt, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Perform_11(S: BRepGProp_Face, D: BRepGProp_Domain, Pl: gp_Pln): void;
  Perform_12(S: BRepGProp_Face, D: BRepGProp_Domain, Pl: gp_Pln, Eps: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetEpsilon(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepGProp_Vinert_1 extends BRepGProp_Vinert {
    constructor();
  }

  export declare class BRepGProp_Vinert_2 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, VLocation: gp_Pnt);
  }

  export declare class BRepGProp_Vinert_3 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, VLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

  export declare class BRepGProp_Vinert_4 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, O: gp_Pnt, VLocation: gp_Pnt);
  }

  export declare class BRepGProp_Vinert_5 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, O: gp_Pnt, VLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

  export declare class BRepGProp_Vinert_6 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, Pl: gp_Pln, VLocation: gp_Pnt);
  }

  export declare class BRepGProp_Vinert_7 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, Pl: gp_Pln, VLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

  export declare class BRepGProp_Vinert_8 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, VLocation: gp_Pnt);
  }

  export declare class BRepGProp_Vinert_9 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, VLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

  export declare class BRepGProp_Vinert_10 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, O: gp_Pnt, VLocation: gp_Pnt);
  }

  export declare class BRepGProp_Vinert_11 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, O: gp_Pnt, VLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

  export declare class BRepGProp_Vinert_12 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, Pl: gp_Pln, VLocation: gp_Pnt);
  }

  export declare class BRepGProp_Vinert_13 extends BRepGProp_Vinert {
    constructor(S: BRepGProp_Face, D: BRepGProp_Domain, Pl: gp_Pln, VLocation: gp_Pnt, Eps: Quantity_AbsorbedDose);
  }

export declare class BRepGProp_MeshProps extends GProp_GProps {
  constructor(theType: any)
  SetLocation(theLocation: gp_Pnt): void;
  Perform_1(theMesh: Handle_Poly_Triangulation, theLoc: TopLoc_Location, theOri: TopAbs_Orientation): void;
  Perform_2(theNodes: TColgp_Array1OfPnt, theTriangles: Poly_Array1OfTriangle, theOri: TopAbs_Orientation): void;
  static CalculateProps(p1: gp_Pnt, p2: gp_Pnt, p3: gp_Pnt, Apex: gp_Pnt, isVolume: Standard_Boolean, GProps: Standard_Real [10], NbGaussPoints: Graphic3d_ZLayerId, GaussPnts: Quantity_AbsorbedDose): void;
  GetMeshObjType(): any;
  delete(): void;
}

export declare class BRepGProp_Domain {
  Init_1(F: TopoDS_Face): void;
  More(): Standard_Boolean;
  Init_2(): void;
  Value(): TopoDS_Edge;
  Next(): void;
  delete(): void;
}

  export declare class BRepGProp_Domain_1 extends BRepGProp_Domain {
    constructor();
  }

  export declare class BRepGProp_Domain_2 extends BRepGProp_Domain {
    constructor(F: TopoDS_Face);
  }

export declare class BRepGProp_Cinert extends GProp_GProps {
  SetLocation(CLocation: gp_Pnt): void;
  Perform(C: BRepAdaptor_Curve): void;
  delete(): void;
}

  export declare class BRepGProp_Cinert_1 extends BRepGProp_Cinert {
    constructor();
  }

  export declare class BRepGProp_Cinert_2 extends BRepGProp_Cinert {
    constructor(C: BRepAdaptor_Curve, CLocation: gp_Pnt);
  }

export declare class BRepGProp_EdgeTool {
  constructor();
  static FirstParameter(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  static IntegrationOrder(C: BRepAdaptor_Curve): Graphic3d_ZLayerId;
  static Value(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose): gp_Pnt;
  static D1(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static NbIntervals(C: BRepAdaptor_Curve, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: BRepAdaptor_Curve, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  delete(): void;
}

export declare class BRepGProp_TFunction extends math_Function {
  constructor(theSurface: BRepGProp_Face, theVertex: gp_Pnt, IsByPoint: Standard_Boolean, theCoeffs: Standard_Address, theUMin: Quantity_AbsorbedDose, theTolerance: Quantity_AbsorbedDose)
  Init(): void;
  SetNbKronrodPoints(theNbPoints: Graphic3d_ZLayerId): void;
  SetValueType(aType: GProp_ValueType): void;
  SetTolerance(aTol: Quantity_AbsorbedDose): void;
  ErrorReached(): Quantity_AbsorbedDose;
  AbsolutError(): Quantity_AbsorbedDose;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BRepGProp_UFunction extends math_Function {
  constructor(theSurface: BRepGProp_Face, theVertex: gp_Pnt, IsByPoint: Standard_Boolean, theCoeffs: Standard_Address)
  SetValueType(theType: GProp_ValueType): void;
  SetVParam(theVParam: Quantity_AbsorbedDose): void;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox2d extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepTool_IndexedDataMapOfShapeBox2d): void;
  Assign(theOther: TopOpeBRepTool_IndexedDataMapOfShapeBox2d): TopOpeBRepTool_IndexedDataMapOfShapeBox2d;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: Bnd_Box2d): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: Bnd_Box2d): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): Bnd_Box2d;
  ChangeFromIndex(theIndex: Standard_Integer): Bnd_Box2d;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): Bnd_Box2d;
  Seek(theKey1: TopoDS_Shape): Bnd_Box2d;
  ChangeSeek(theKey1: TopoDS_Shape): Bnd_Box2d;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox2d_1 extends TopOpeBRepTool_IndexedDataMapOfShapeBox2d {
    constructor();
  }

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox2d_2 extends TopOpeBRepTool_IndexedDataMapOfShapeBox2d {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox2d_3 extends TopOpeBRepTool_IndexedDataMapOfShapeBox2d {
    constructor(theOther: TopOpeBRepTool_IndexedDataMapOfShapeBox2d);
  }

export declare class TopOpeBRepTool_ShapeTool {
  constructor();
  static Tolerance(S: TopoDS_Shape): Quantity_AbsorbedDose;
  static Pnt(S: TopoDS_Shape): gp_Pnt;
  static BASISCURVE_1(C: Handle_Geom_Curve): Handle_Geom_Curve;
  static BASISCURVE_2(E: TopoDS_Edge): Handle_Geom_Curve;
  static BASISSURFACE_1(S: Handle_Geom_Surface): Handle_Geom_Surface;
  static BASISSURFACE_2(F: TopoDS_Face): Handle_Geom_Surface;
  static UVBOUNDS_1(S: Handle_Geom_Surface, UPeri: Standard_Boolean, VPeri: Standard_Boolean, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  static UVBOUNDS_2(F: TopoDS_Face, UPeri: Standard_Boolean, VPeri: Standard_Boolean, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  static AdjustOnPeriodic(S: TopoDS_Shape, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): void;
  static Closed(S1: TopoDS_Shape, S2: TopoDS_Shape): Standard_Boolean;
  static PeriodizeParameter(par: Quantity_AbsorbedDose, EE: TopoDS_Shape, FF: TopoDS_Shape): Quantity_AbsorbedDose;
  static ShapesSameOriented(S1: TopoDS_Shape, S2: TopoDS_Shape): Standard_Boolean;
  static SurfacesSameOriented(S1: BRepAdaptor_Surface, S2: BRepAdaptor_Surface): Standard_Boolean;
  static FacesSameOriented(F1: TopoDS_Shape, F2: TopoDS_Shape): Standard_Boolean;
  static CurvesSameOriented(C1: BRepAdaptor_Curve, C2: BRepAdaptor_Curve): Standard_Boolean;
  static EdgesSameOriented(E1: TopoDS_Shape, E2: TopoDS_Shape): Standard_Boolean;
  static EdgeData_1(BRAC: BRepAdaptor_Curve, P: Quantity_AbsorbedDose, T: gp_Dir, N: gp_Dir, C: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static EdgeData_2(E: TopoDS_Shape, P: Quantity_AbsorbedDose, T: gp_Dir, N: gp_Dir, C: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Resolution3dU(SU: Handle_Geom_Surface, Tol2d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Resolution3dV(SU: Handle_Geom_Surface, Tol2d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Resolution3d_1(SU: Handle_Geom_Surface, Tol2d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Resolution3d_2(F: TopoDS_Face, Tol2d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class TopOpeBRepTool_C2DF {
  SetPC(PC: Handle_Geom2d_Curve, f2d: Quantity_AbsorbedDose, l2d: Quantity_AbsorbedDose, tol: Quantity_AbsorbedDose): void;
  SetFace(F: TopoDS_Face): void;
  PC(f2d: Quantity_AbsorbedDose, l2d: Quantity_AbsorbedDose, tol: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  Face(): TopoDS_Face;
  IsPC(PC: Handle_Geom2d_Curve): Standard_Boolean;
  IsFace(F: TopoDS_Face): Standard_Boolean;
  delete(): void;
}

  export declare class TopOpeBRepTool_C2DF_1 extends TopOpeBRepTool_C2DF {
    constructor();
  }

  export declare class TopOpeBRepTool_C2DF_2 extends TopOpeBRepTool_C2DF {
    constructor(PC: Handle_Geom2d_Curve, f2d: Quantity_AbsorbedDose, l2d: Quantity_AbsorbedDose, tol: Quantity_AbsorbedDose, F: TopoDS_Face);
  }

export declare class TopOpeBRepTool_FuseEdges {
  constructor(theShape: TopoDS_Shape, PerformNow: Standard_Boolean)
  AvoidEdges(theMapEdg: TopTools_IndexedMapOfShape): void;
  Edges(theMapLstEdg: TopTools_DataMapOfIntegerListOfShape): void;
  ResultEdges(theMapEdg: TopTools_DataMapOfIntegerShape): void;
  Faces(theMapFac: TopTools_DataMapOfShapeShape): void;
  Shape(): TopoDS_Shape;
  NbVertices(): Graphic3d_ZLayerId;
  Perform(): void;
  delete(): void;
}

export declare type TopOpeBRepTool_OutCurveType = {
  TopOpeBRepTool_BSPLINE1: {};
  TopOpeBRepTool_APPROX: {};
  TopOpeBRepTool_INTERPOL: {};
}

export declare class TopOpeBRepTool_PurgeInternalEdges {
  constructor(theShape: TopoDS_Shape, PerformNow: Standard_Boolean)
  Faces(theMapFacLstEdg: TopTools_DataMapOfShapeListOfShape): void;
  Shape(): TopoDS_Shape;
  NbEdges(): Graphic3d_ZLayerId;
  IsDone(): Standard_Boolean;
  Perform(): void;
  delete(): void;
}

export declare class TopOpeBRepTool_DataMapOfOrientedShapeC2DF extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepTool_DataMapOfOrientedShapeC2DF): void;
  Assign(theOther: TopOpeBRepTool_DataMapOfOrientedShapeC2DF): TopOpeBRepTool_DataMapOfOrientedShapeC2DF;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopOpeBRepTool_C2DF): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopOpeBRepTool_C2DF): TopOpeBRepTool_C2DF;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopOpeBRepTool_C2DF;
  ChangeSeek(theKey: TopoDS_Shape): TopOpeBRepTool_C2DF;
  ChangeFind(theKey: TopoDS_Shape): TopOpeBRepTool_C2DF;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepTool_DataMapOfOrientedShapeC2DF_1 extends TopOpeBRepTool_DataMapOfOrientedShapeC2DF {
    constructor();
  }

  export declare class TopOpeBRepTool_DataMapOfOrientedShapeC2DF_2 extends TopOpeBRepTool_DataMapOfOrientedShapeC2DF {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_DataMapOfOrientedShapeC2DF_3 extends TopOpeBRepTool_DataMapOfOrientedShapeC2DF {
    constructor(theOther: TopOpeBRepTool_DataMapOfOrientedShapeC2DF);
  }

export declare class TopOpeBRepTool_DataMapOfShapeListOfC2DF extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepTool_DataMapOfShapeListOfC2DF): void;
  Assign(theOther: TopOpeBRepTool_DataMapOfShapeListOfC2DF): TopOpeBRepTool_DataMapOfShapeListOfC2DF;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopOpeBRepTool_ListOfC2DF): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopOpeBRepTool_ListOfC2DF): TopOpeBRepTool_ListOfC2DF;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopOpeBRepTool_ListOfC2DF;
  ChangeSeek(theKey: TopoDS_Shape): TopOpeBRepTool_ListOfC2DF;
  ChangeFind(theKey: TopoDS_Shape): TopOpeBRepTool_ListOfC2DF;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepTool_DataMapOfShapeListOfC2DF_1 extends TopOpeBRepTool_DataMapOfShapeListOfC2DF {
    constructor();
  }

  export declare class TopOpeBRepTool_DataMapOfShapeListOfC2DF_2 extends TopOpeBRepTool_DataMapOfShapeListOfC2DF {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_DataMapOfShapeListOfC2DF_3 extends TopOpeBRepTool_DataMapOfShapeListOfC2DF {
    constructor(theOther: TopOpeBRepTool_DataMapOfShapeListOfC2DF);
  }

export declare class TopOpeBRepTool_ShapeClassifier {
  ClearAll(): void;
  ClearCurrent(): void;
  SetReference(SRef: TopoDS_Shape): void;
  StateShapeShape_1(S: TopoDS_Shape, SRef: TopoDS_Shape, samedomain: Graphic3d_ZLayerId): TopAbs_State;
  SameDomain_1(): Graphic3d_ZLayerId;
  SameDomain_2(samedomain: Graphic3d_ZLayerId): void;
  StateShapeShape_2(S: TopoDS_Shape, AvoidS: TopoDS_Shape, SRef: TopoDS_Shape): TopAbs_State;
  StateShapeShape_3(S: TopoDS_Shape, LAvoidS: TopTools_ListOfShape, SRef: TopoDS_Shape): TopAbs_State;
  StateShapeReference_1(S: TopoDS_Shape, AvoidS: TopoDS_Shape): TopAbs_State;
  StateShapeReference_2(S: TopoDS_Shape, LAvoidS: TopTools_ListOfShape): TopAbs_State;
  ChangeSolidClassifier(): TopOpeBRepTool_SolidClassifier;
  StateP2DReference(P2D: gp_Pnt2d): void;
  StateP3DReference(P3D: gp_Pnt): void;
  State(): TopAbs_State;
  P2D(): gp_Pnt2d;
  P3D(): gp_Pnt;
  delete(): void;
}

  export declare class TopOpeBRepTool_ShapeClassifier_1 extends TopOpeBRepTool_ShapeClassifier {
    constructor();
  }

  export declare class TopOpeBRepTool_ShapeClassifier_2 extends TopOpeBRepTool_ShapeClassifier {
    constructor(SRef: TopoDS_Shape);
  }

export declare class TopOpeBRepTool_connexity {
  SetKey(Key: TopoDS_Shape): void;
  Key(): TopoDS_Shape;
  Item(OriKey: Graphic3d_ZLayerId, Item: TopTools_ListOfShape): Graphic3d_ZLayerId;
  AllItems(Item: TopTools_ListOfShape): Graphic3d_ZLayerId;
  AddItem_1(OriKey: Graphic3d_ZLayerId, Item: TopTools_ListOfShape): void;
  AddItem_2(OriKey: Graphic3d_ZLayerId, Item: TopoDS_Shape): void;
  RemoveItem_1(OriKey: Graphic3d_ZLayerId, Item: TopoDS_Shape): Standard_Boolean;
  RemoveItem_2(Item: TopoDS_Shape): Standard_Boolean;
  ChangeItem(OriKey: Graphic3d_ZLayerId): TopTools_ListOfShape;
  IsMultiple(): Standard_Boolean;
  IsFaulty(): Standard_Boolean;
  IsInternal(Item: TopTools_ListOfShape): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepTool_connexity_1 extends TopOpeBRepTool_connexity {
    constructor();
  }

  export declare class TopOpeBRepTool_connexity_2 extends TopOpeBRepTool_connexity {
    constructor(Key: TopoDS_Shape);
  }

export declare class TopOpeBRepTool_SolidClassifier {
  constructor()
  Clear(): void;
  LoadSolid(S: TopoDS_Solid): void;
  Classify_1(S: TopoDS_Solid, P: gp_Pnt, Tol: Quantity_AbsorbedDose): TopAbs_State;
  LoadShell(S: TopoDS_Shell): void;
  Classify_2(S: TopoDS_Shell, P: gp_Pnt, Tol: Quantity_AbsorbedDose): TopAbs_State;
  State(): TopAbs_State;
  delete(): void;
}

export declare class TopOpeBRepTool_DataMapOfShapeface extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepTool_DataMapOfShapeface): void;
  Assign(theOther: TopOpeBRepTool_DataMapOfShapeface): TopOpeBRepTool_DataMapOfShapeface;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopOpeBRepTool_face): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopOpeBRepTool_face): TopOpeBRepTool_face;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopOpeBRepTool_face;
  ChangeSeek(theKey: TopoDS_Shape): TopOpeBRepTool_face;
  ChangeFind(theKey: TopoDS_Shape): TopOpeBRepTool_face;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepTool_DataMapOfShapeface_1 extends TopOpeBRepTool_DataMapOfShapeface {
    constructor();
  }

  export declare class TopOpeBRepTool_DataMapOfShapeface_2 extends TopOpeBRepTool_DataMapOfShapeface {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_DataMapOfShapeface_3 extends TopOpeBRepTool_DataMapOfShapeface {
    constructor(theOther: TopOpeBRepTool_DataMapOfShapeface);
  }

export declare class TopOpeBRepTool_face {
  constructor()
  Init(W: TopoDS_Wire, Fref: TopoDS_Face): Standard_Boolean;
  W(): TopoDS_Wire;
  IsDone(): Standard_Boolean;
  Finite(): Standard_Boolean;
  Ffinite(): TopoDS_Face;
  RealF(): TopoDS_Face;
  delete(): void;
}

export declare class TopOpeBRepTool_CLASSI {
  constructor()
  Init2d(Fref: TopoDS_Face): void;
  HasInit2d(): Standard_Boolean;
  Add2d(S: TopoDS_Shape): Standard_Boolean;
  GetBox2d(S: TopoDS_Shape, Box2d: Bnd_Box2d): Standard_Boolean;
  ClassiBnd2d(S1: TopoDS_Shape, S2: TopoDS_Shape, tol: Quantity_AbsorbedDose, checklarge: Standard_Boolean): Graphic3d_ZLayerId;
  Classip2d(S1: TopoDS_Shape, S2: TopoDS_Shape, stabnd2d12: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Getface(S: TopoDS_Shape, fa: TopOpeBRepTool_face): Standard_Boolean;
  Classilist(lS: TopTools_ListOfShape, mapgreasma: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_AncestorsTool {
  constructor();
  static MakeAncestors(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum, M: TopTools_IndexedDataMapOfShapeListOfShape): void;
  delete(): void;
}

export declare class TopOpeBRepTool_TOOL {
  constructor();
  static OriinSor(sub: TopoDS_Shape, S: TopoDS_Shape, checkclo: Standard_Boolean): Graphic3d_ZLayerId;
  static OriinSorclosed(sub: TopoDS_Shape, S: TopoDS_Shape): Graphic3d_ZLayerId;
  static ClosedE(E: TopoDS_Edge, vclo: TopoDS_Vertex): Standard_Boolean;
  static ClosedS(F: TopoDS_Face): Standard_Boolean;
  static IsClosingE_1(E: TopoDS_Edge, F: TopoDS_Face): Standard_Boolean;
  static IsClosingE_2(E: TopoDS_Edge, W: TopoDS_Shape, F: TopoDS_Face): Standard_Boolean;
  static Vertices(E: TopoDS_Edge, Vces: TopTools_Array1OfShape): void;
  static Vertex(Iv: Graphic3d_ZLayerId, E: TopoDS_Edge): TopoDS_Vertex;
  static ParE(Iv: Graphic3d_ZLayerId, E: TopoDS_Edge): Quantity_AbsorbedDose;
  static OnBoundary(par: Quantity_AbsorbedDose, E: TopoDS_Edge): Graphic3d_ZLayerId;
  static UVF(par: Quantity_AbsorbedDose, C2DF: TopOpeBRepTool_C2DF): gp_Pnt2d;
  static ParISO(p2d: gp_Pnt2d, e: TopoDS_Edge, f: TopoDS_Face, pare: Quantity_AbsorbedDose): Standard_Boolean;
  static ParE2d(p2d: gp_Pnt2d, e: TopoDS_Edge, f: TopoDS_Face, par: Quantity_AbsorbedDose, dist: Quantity_AbsorbedDose): Standard_Boolean;
  static Getduv(f: TopoDS_Face, uv: gp_Pnt2d, dir: gp_Vec, factor: Quantity_AbsorbedDose, duv: gp_Dir2d): Standard_Boolean;
  static uvApp(f: TopoDS_Face, e: TopoDS_Edge, par: Quantity_AbsorbedDose, eps: Quantity_AbsorbedDose, uvapp: gp_Pnt2d): Standard_Boolean;
  static TolUV(F: TopoDS_Face, tol3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static TolP(E: TopoDS_Edge, F: TopoDS_Face): Quantity_AbsorbedDose;
  static minDUV(F: TopoDS_Face): Quantity_AbsorbedDose;
  static outUVbounds(uv: gp_Pnt2d, F: TopoDS_Face): Standard_Boolean;
  static stuvF(uv: gp_Pnt2d, F: TopoDS_Face, onU: Graphic3d_ZLayerId, onV: Graphic3d_ZLayerId): void;
  static TggeomE_1(par: Quantity_AbsorbedDose, BC: BRepAdaptor_Curve, Tg: gp_Vec): Standard_Boolean;
  static TggeomE_2(par: Quantity_AbsorbedDose, E: TopoDS_Edge, Tg: gp_Vec): Standard_Boolean;
  static TgINSIDE(v: TopoDS_Vertex, E: TopoDS_Edge, Tg: gp_Vec, OvinE: Graphic3d_ZLayerId): Standard_Boolean;
  static Tg2d(iv: Graphic3d_ZLayerId, E: TopoDS_Edge, C2DF: TopOpeBRepTool_C2DF): gp_Vec2d;
  static Tg2dApp(iv: Graphic3d_ZLayerId, E: TopoDS_Edge, C2DF: TopOpeBRepTool_C2DF, factor: Quantity_AbsorbedDose): gp_Vec2d;
  static tryTg2dApp(iv: Graphic3d_ZLayerId, E: TopoDS_Edge, C2DF: TopOpeBRepTool_C2DF, factor: Quantity_AbsorbedDose): gp_Vec2d;
  static XX(uv: gp_Pnt2d, f: TopoDS_Face, par: Quantity_AbsorbedDose, e: TopoDS_Edge, xx: gp_Dir): Standard_Boolean;
  static Nt(uv: gp_Pnt2d, f: TopoDS_Face, normt: gp_Dir): Standard_Boolean;
  static NggeomF(uv: gp_Pnt2d, F: TopoDS_Face, ng: gp_Vec): Standard_Boolean;
  static NgApp(par: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face, tola: Quantity_AbsorbedDose, ngApp: gp_Dir): Standard_Boolean;
  static tryNgApp(par: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face, tola: Quantity_AbsorbedDose, ng: gp_Dir): Standard_Boolean;
  static tryOriEinF(par: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face): Graphic3d_ZLayerId;
  static IsQuad_1(E: TopoDS_Edge): Standard_Boolean;
  static IsQuad_2(F: TopoDS_Face): Standard_Boolean;
  static CurvE(E: TopoDS_Edge, par: Quantity_AbsorbedDose, tg0: gp_Dir, Curv: Quantity_AbsorbedDose): Standard_Boolean;
  static CurvF(F: TopoDS_Face, uv: gp_Pnt2d, tg0: gp_Dir, Curv: Quantity_AbsorbedDose, direct: Standard_Boolean): Standard_Boolean;
  static UVISO_1(PC: Handle_Geom2d_Curve, isou: Standard_Boolean, isov: Standard_Boolean, d2d: gp_Dir2d, o2d: gp_Pnt2d): Standard_Boolean;
  static UVISO_2(C2DF: TopOpeBRepTool_C2DF, isou: Standard_Boolean, isov: Standard_Boolean, d2d: gp_Dir2d, o2d: gp_Pnt2d): Standard_Boolean;
  static UVISO_3(E: TopoDS_Edge, F: TopoDS_Face, isou: Standard_Boolean, isov: Standard_Boolean, d2d: gp_Dir2d, o2d: gp_Pnt2d): Standard_Boolean;
  static IsonCLO_1(PC: Handle_Geom2d_Curve, onU: Standard_Boolean, xfirst: Quantity_AbsorbedDose, xperiod: Quantity_AbsorbedDose, xtol: Quantity_AbsorbedDose): Standard_Boolean;
  static IsonCLO_2(C2DF: TopOpeBRepTool_C2DF, onU: Standard_Boolean, xfirst: Quantity_AbsorbedDose, xperiod: Quantity_AbsorbedDose, xtol: Quantity_AbsorbedDose): Standard_Boolean;
  static TrslUV(t2d: gp_Vec2d, C2DF: TopOpeBRepTool_C2DF): void;
  static TrslUVModifE(t2d: gp_Vec2d, F: TopoDS_Face, E: TopoDS_Edge): Standard_Boolean;
  static Matter_1(d1: gp_Vec, d2: gp_Vec, ref: gp_Vec): Quantity_AbsorbedDose;
  static Matter_2(d1: gp_Vec2d, d2: gp_Vec2d): Quantity_AbsorbedDose;
  static Matter_3(xx1: gp_Dir, nt1: gp_Dir, xx2: gp_Dir, nt2: gp_Dir, tola: Quantity_AbsorbedDose, Ang: Quantity_AbsorbedDose): Standard_Boolean;
  static Matter_4(f1: TopoDS_Face, f2: TopoDS_Face, e: TopoDS_Edge, pare: Quantity_AbsorbedDose, tola: Quantity_AbsorbedDose, Ang: Quantity_AbsorbedDose): Standard_Boolean;
  static MatterKPtg(f1: TopoDS_Face, f2: TopoDS_Face, e: TopoDS_Edge, Ang: Quantity_AbsorbedDose): Standard_Boolean;
  static Getstp3dF(p: gp_Pnt, f: TopoDS_Face, uv: gp_Pnt2d, st: TopAbs_State): Standard_Boolean;
  static SplitE(Eanc: TopoDS_Edge, Splits: TopTools_ListOfShape): Standard_Boolean;
  static MkShell(lF: TopTools_ListOfShape, She: TopoDS_Shape): void;
  static Remove(loS: TopTools_ListOfShape, toremove: TopoDS_Shape): Standard_Boolean;
  static WireToFace(Fref: TopoDS_Face, mapWlow: TopTools_DataMapOfShapeListOfShape, lFs: TopTools_ListOfShape): Standard_Boolean;
  static EdgeONFace(par: Quantity_AbsorbedDose, ed: TopoDS_Edge, uv: gp_Pnt2d, fa: TopoDS_Face, isonfa: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_CORRISO {
  Fref(): TopoDS_Face;
  GASref(): GeomAdaptor_Surface;
  Refclosed(x: Graphic3d_ZLayerId, xperiod: Quantity_AbsorbedDose): Standard_Boolean;
  Init(S: TopoDS_Shape): Standard_Boolean;
  S(): TopoDS_Shape;
  Eds(): TopTools_ListOfShape;
  UVClosed(): Standard_Boolean;
  Tol(I: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  PurgeFyClosingE(ClEds: TopTools_ListOfShape, fyClEds: TopTools_ListOfShape): Standard_Boolean;
  EdgeOUTofBoundsUV(E: TopoDS_Edge, onU: Standard_Boolean, tolx: Quantity_AbsorbedDose, parspE: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  EdgesOUTofBoundsUV(EdsToCheck: TopTools_ListOfShape, onU: Standard_Boolean, tolx: Quantity_AbsorbedDose, FyEds: TopTools_DataMapOfOrientedShapeInteger): Standard_Boolean;
  EdgeWithFaultyUV_1(E: TopoDS_Edge, Ivfaulty: Graphic3d_ZLayerId): Standard_Boolean;
  EdgesWithFaultyUV(EdsToCheck: TopTools_ListOfShape, nfybounds: Graphic3d_ZLayerId, FyEds: TopTools_DataMapOfOrientedShapeInteger, stopatfirst: Standard_Boolean): Standard_Boolean;
  EdgeWithFaultyUV_2(EdsToCheck: TopTools_ListOfShape, nfybounds: Graphic3d_ZLayerId, fyE: TopoDS_Shape, Ifaulty: Graphic3d_ZLayerId): Standard_Boolean;
  TrslUV(onU: Standard_Boolean, FyEds: TopTools_DataMapOfOrientedShapeInteger): Standard_Boolean;
  GetnewS(newS: TopoDS_Face): Standard_Boolean;
  UVRep(E: TopoDS_Edge, C2DF: TopOpeBRepTool_C2DF): Standard_Boolean;
  SetUVRep(E: TopoDS_Edge, C2DF: TopOpeBRepTool_C2DF): Standard_Boolean;
  Connexity(V: TopoDS_Vertex, Eds: TopTools_ListOfShape): Standard_Boolean;
  SetConnexity(V: TopoDS_Vertex, Eds: TopTools_ListOfShape): Standard_Boolean;
  AddNewConnexity(V: TopoDS_Vertex, E: TopoDS_Edge): Standard_Boolean;
  RemoveOldConnexity(V: TopoDS_Vertex, E: TopoDS_Edge): Standard_Boolean;
  delete(): void;
}

  export declare class TopOpeBRepTool_CORRISO_1 extends TopOpeBRepTool_CORRISO {
    constructor();
  }

  export declare class TopOpeBRepTool_CORRISO_2 extends TopOpeBRepTool_CORRISO {
    constructor(FRef: TopoDS_Face);
  }

export declare class TopOpeBRepTool_BoxSort {
  SetHBoxTool(T: Handle_TopOpeBRepTool_HBoxTool): void;
  HBoxTool(): Handle_TopOpeBRepTool_HBoxTool;
  Clear(): void;
  AddBoxes(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum): void;
  MakeHAB(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum): void;
  HAB(): Handle_Bnd_HArray1OfBox;
  static MakeHABCOB(HAB: Handle_Bnd_HArray1OfBox, COB: Bnd_Box): void;
  HABShape(I: Graphic3d_ZLayerId): TopoDS_Shape;
  MakeCOB(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum): void;
  AddBoxesMakeCOB(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum): void;
  Compare(S: TopoDS_Shape): TColStd_ListIteratorOfListOfInteger;
  TouchedShape(I: TColStd_ListIteratorOfListOfInteger): TopoDS_Shape;
  Box(S: TopoDS_Shape): Bnd_Box;
  delete(): void;
}

  export declare class TopOpeBRepTool_BoxSort_1 extends TopOpeBRepTool_BoxSort {
    constructor();
  }

  export declare class TopOpeBRepTool_BoxSort_2 extends TopOpeBRepTool_BoxSort {
    constructor(T: Handle_TopOpeBRepTool_HBoxTool);
  }

export declare class TopOpeBRepTool_REGUS {
  constructor()
  Init(S: TopoDS_Shape): void;
  S(): TopoDS_Shape;
  MapS(): Standard_Boolean;
  static WireToFace(Fanc: TopoDS_Face, nWs: TopTools_ListOfShape, nFs: TopTools_ListOfShape): Standard_Boolean;
  static SplitF(Fanc: TopoDS_Face, FSplits: TopTools_ListOfShape): Standard_Boolean;
  SplitFaces(): Standard_Boolean;
  REGU(): Standard_Boolean;
  SetFsplits(Fsplits: TopTools_DataMapOfShapeListOfShape): void;
  GetFsplits(Fsplits: TopTools_DataMapOfShapeListOfShape): void;
  SetOshNsh(OshNsh: TopTools_DataMapOfShapeListOfShape): void;
  GetOshNsh(OshNsh: TopTools_DataMapOfShapeListOfShape): void;
  InitBlock(): Standard_Boolean;
  NextinBlock(): Standard_Boolean;
  NearestF(e: TopoDS_Edge, lof: TopTools_ListOfShape, ffound: TopoDS_Face): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_GeomTool {
  constructor(TypeC3D: TopOpeBRepTool_OutCurveType, CompC3D: Standard_Boolean, CompPC1: Standard_Boolean, CompPC2: Standard_Boolean)
  Define_1(TypeC3D: TopOpeBRepTool_OutCurveType, CompC3D: Standard_Boolean, CompPC1: Standard_Boolean, CompPC2: Standard_Boolean): void;
  Define_2(TypeC3D: TopOpeBRepTool_OutCurveType): void;
  DefineCurves(CompC3D: Standard_Boolean): void;
  DefinePCurves1(CompPC1: Standard_Boolean): void;
  DefinePCurves2(CompPC2: Standard_Boolean): void;
  Define_3(GT: TopOpeBRepTool_GeomTool): void;
  GetTolerances(tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  SetTolerances(tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbPntMax(): Graphic3d_ZLayerId;
  SetNbPntMax(NbPntMax: Graphic3d_ZLayerId): void;
  TypeC3D(): TopOpeBRepTool_OutCurveType;
  CompC3D(): Standard_Boolean;
  CompPC1(): Standard_Boolean;
  CompPC2(): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_CurveTool {
  ChangeGeomTool(): TopOpeBRepTool_GeomTool;
  GetGeomTool(): TopOpeBRepTool_GeomTool;
  SetGeomTool(GT: TopOpeBRepTool_GeomTool): void;
  MakeCurves(min: Quantity_AbsorbedDose, max: Quantity_AbsorbedDose, C3D: Handle_Geom_Curve, PC1: Handle_Geom2d_Curve, PC2: Handle_Geom2d_Curve, S1: TopoDS_Shape, S2: TopoDS_Shape, C3DN: Handle_Geom_Curve, PC1N: Handle_Geom2d_Curve, PC2N: Handle_Geom2d_Curve, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): Standard_Boolean;
  static MakeBSpline1fromPnt(P: TColgp_Array1OfPnt): Handle_Geom_Curve;
  static MakeBSpline1fromPnt2d(P: TColgp_Array1OfPnt2d): Handle_Geom2d_Curve;
  static IsProjectable(S: TopoDS_Shape, C: Handle_Geom_Curve): Standard_Boolean;
  static MakePCurveOnFace(S: TopoDS_Shape, C: Handle_Geom_Curve, TolReached2d: Quantity_AbsorbedDose, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  delete(): void;
}

  export declare class TopOpeBRepTool_CurveTool_1 extends TopOpeBRepTool_CurveTool {
    constructor();
  }

  export declare class TopOpeBRepTool_CurveTool_2 extends TopOpeBRepTool_CurveTool {
    constructor(OCT: TopOpeBRepTool_OutCurveType);
  }

  export declare class TopOpeBRepTool_CurveTool_3 extends TopOpeBRepTool_CurveTool {
    constructor(GT: TopOpeBRepTool_GeomTool);
  }

export declare class TopOpeBRepTool_mkTondgE {
  constructor()
  Initialize(dgE: TopoDS_Edge, F: TopoDS_Face, uvi: gp_Pnt2d, Fi: TopoDS_Face): Standard_Boolean;
  SetclE(clE: TopoDS_Edge): Standard_Boolean;
  IsT2d(): Standard_Boolean;
  SetRest(pari: Quantity_AbsorbedDose, Ei: TopoDS_Edge): Standard_Boolean;
  GetAllRest(lEi: TopTools_ListOfShape): Graphic3d_ZLayerId;
  MkTonE_1(mkT: Graphic3d_ZLayerId, par1: Quantity_AbsorbedDose, par2: Quantity_AbsorbedDose): Standard_Boolean;
  MkTonE_2(Ei: TopoDS_Edge, mkT: Graphic3d_ZLayerId, par1: Quantity_AbsorbedDose, par2: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepTool_IndexedDataMapOfShapeBox): void;
  Assign(theOther: TopOpeBRepTool_IndexedDataMapOfShapeBox): TopOpeBRepTool_IndexedDataMapOfShapeBox;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: Bnd_Box): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: Bnd_Box): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): Bnd_Box;
  ChangeFromIndex(theIndex: Standard_Integer): Bnd_Box;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): Bnd_Box;
  Seek(theKey1: TopoDS_Shape): Bnd_Box;
  ChangeSeek(theKey1: TopoDS_Shape): Bnd_Box;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox_1 extends TopOpeBRepTool_IndexedDataMapOfShapeBox {
    constructor();
  }

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox_2 extends TopOpeBRepTool_IndexedDataMapOfShapeBox {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeBox_3 extends TopOpeBRepTool_IndexedDataMapOfShapeBox {
    constructor(theOther: TopOpeBRepTool_IndexedDataMapOfShapeBox);
  }

export declare class TopOpeBRepTool_ShapeExplorer extends TopExp_Explorer {
  Init(S: TopoDS_Shape, ToFind: TopAbs_ShapeEnum, ToAvoid: TopAbs_ShapeEnum): void;
  Next(): void;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepTool_ShapeExplorer_1 extends TopOpeBRepTool_ShapeExplorer {
    constructor();
  }

  export declare class TopOpeBRepTool_ShapeExplorer_2 extends TopOpeBRepTool_ShapeExplorer {
    constructor(S: TopoDS_Shape, ToFind: TopAbs_ShapeEnum, ToAvoid: TopAbs_ShapeEnum);
  }

export declare class TopOpeBRepTool_makeTransition {
  constructor()
  Initialize(E: TopoDS_Edge, pbef: Quantity_AbsorbedDose, paft: Quantity_AbsorbedDose, parE: Quantity_AbsorbedDose, FS: TopoDS_Face, uv: gp_Pnt2d, factor: Quantity_AbsorbedDose): Standard_Boolean;
  Setfactor(factor: Quantity_AbsorbedDose): void;
  Getfactor(): Quantity_AbsorbedDose;
  IsT2d(): Standard_Boolean;
  SetRest(ES: TopoDS_Edge, parES: Quantity_AbsorbedDose): Standard_Boolean;
  HasRest(): Standard_Boolean;
  MkT2donE(stb: TopAbs_State, sta: TopAbs_State): Standard_Boolean;
  MkT3onE(stb: TopAbs_State, sta: TopAbs_State): Standard_Boolean;
  MkT3dproj(stb: TopAbs_State, sta: TopAbs_State): Standard_Boolean;
  MkTonE(stb: TopAbs_State, sta: TopAbs_State): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_REGUW {
  constructor(FRef: TopoDS_Face)
  Fref(): TopoDS_Face;
  SetEsplits(Esplits: TopTools_DataMapOfShapeListOfShape): void;
  GetEsplits(Esplits: TopTools_DataMapOfShapeListOfShape): void;
  SetOwNw(OwNw: TopTools_DataMapOfShapeListOfShape): void;
  GetOwNw(OwNw: TopTools_DataMapOfShapeListOfShape): void;
  SplitEds(): Standard_Boolean;
  Init(S: TopoDS_Shape): void;
  S(): TopoDS_Shape;
  HasInit(): Standard_Boolean;
  MapS(): Standard_Boolean;
  REGU_1(istep: Graphic3d_ZLayerId, Scur: TopoDS_Shape, Splits: TopTools_ListOfShape): Standard_Boolean;
  REGU_2(): Standard_Boolean;
  GetSplits(Splits: TopTools_ListOfShape): Standard_Boolean;
  InitBlock(): Standard_Boolean;
  NextinBlock(): Standard_Boolean;
  NearestE(loe: TopTools_ListOfShape, efound: TopoDS_Edge): Standard_Boolean;
  Connexity(v: TopoDS_Vertex, co: TopOpeBRepTool_connexity): Standard_Boolean;
  AddNewConnexity(v: TopoDS_Vertex, OriKey: Graphic3d_ZLayerId, e: TopoDS_Edge): Standard_Boolean;
  RemoveOldConnexity(v: TopoDS_Vertex, OriKey: Graphic3d_ZLayerId, e: TopoDS_Edge): Standard_Boolean;
  UpdateMultiple(v: TopoDS_Vertex): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_IndexedDataMapOfShapeconnexity extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepTool_IndexedDataMapOfShapeconnexity): void;
  Assign(theOther: TopOpeBRepTool_IndexedDataMapOfShapeconnexity): TopOpeBRepTool_IndexedDataMapOfShapeconnexity;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopOpeBRepTool_connexity): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopOpeBRepTool_connexity): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopOpeBRepTool_connexity;
  ChangeFromIndex(theIndex: Standard_Integer): TopOpeBRepTool_connexity;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopOpeBRepTool_connexity;
  Seek(theKey1: TopoDS_Shape): TopOpeBRepTool_connexity;
  ChangeSeek(theKey1: TopoDS_Shape): TopOpeBRepTool_connexity;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeconnexity_1 extends TopOpeBRepTool_IndexedDataMapOfShapeconnexity {
    constructor();
  }

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeconnexity_2 extends TopOpeBRepTool_IndexedDataMapOfShapeconnexity {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_IndexedDataMapOfShapeconnexity_3 extends TopOpeBRepTool_IndexedDataMapOfShapeconnexity {
    constructor(theOther: TopOpeBRepTool_IndexedDataMapOfShapeconnexity);
  }

export declare class TopOpeBRepTool_ListOfC2DF extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopOpeBRepTool_ListOfC2DF): TopOpeBRepTool_ListOfC2DF;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopOpeBRepTool_C2DF;
  First_2(): TopOpeBRepTool_C2DF;
  Last_1(): TopOpeBRepTool_C2DF;
  Last_2(): TopOpeBRepTool_C2DF;
  Append_1(theItem: TopOpeBRepTool_C2DF): TopOpeBRepTool_C2DF;
  Append_3(theOther: TopOpeBRepTool_ListOfC2DF): void;
  Prepend_1(theItem: TopOpeBRepTool_C2DF): TopOpeBRepTool_C2DF;
  Prepend_2(theOther: TopOpeBRepTool_ListOfC2DF): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopOpeBRepTool_ListOfC2DF_1 extends TopOpeBRepTool_ListOfC2DF {
    constructor();
  }

  export declare class TopOpeBRepTool_ListOfC2DF_2 extends TopOpeBRepTool_ListOfC2DF {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepTool_ListOfC2DF_3 extends TopOpeBRepTool_ListOfC2DF {
    constructor(theOther: TopOpeBRepTool_ListOfC2DF);
  }

export declare class TopOpeBRepTool {
  constructor();
  static PurgeClosingEdges_1(F: TopoDS_Face, FF: TopoDS_Face, MWisOld: TopTools_DataMapOfShapeInteger, MshNOK: TopTools_IndexedMapOfOrientedShape): Standard_Boolean;
  static PurgeClosingEdges_2(F: TopoDS_Face, LOF: TopTools_ListOfShape, MWisOld: TopTools_DataMapOfShapeInteger, MshNOK: TopTools_IndexedMapOfOrientedShape): Standard_Boolean;
  static CorrectONUVISO(F: TopoDS_Face, Fsp: TopoDS_Face): Standard_Boolean;
  static MakeFaces(F: TopoDS_Face, LOF: TopTools_ListOfShape, MshNOK: TopTools_IndexedMapOfOrientedShape, LOFF: TopTools_ListOfShape): Standard_Boolean;
  static Regularize(aFace: TopoDS_Face, aListOfFaces: TopTools_ListOfShape, ESplits: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  static RegularizeWires(aFace: TopoDS_Face, OldWiresNewWires: TopTools_DataMapOfShapeListOfShape, ESplits: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  static RegularizeFace(aFace: TopoDS_Face, OldWiresnewWires: TopTools_DataMapOfShapeListOfShape, aListOfFaces: TopTools_ListOfShape): Standard_Boolean;
  static RegularizeShells(aSolid: TopoDS_Solid, OldSheNewShe: TopTools_DataMapOfShapeListOfShape, FSplits: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepTool_HBoxTool extends Standard_Transient {
  constructor()
  Clear(): void;
  AddBoxes(S: TopoDS_Shape, TS: TopAbs_ShapeEnum, TA: TopAbs_ShapeEnum): void;
  AddBox(S: TopoDS_Shape): void;
  static ComputeBox(S: TopoDS_Shape, B: Bnd_Box): void;
  static ComputeBoxOnVertices(S: TopoDS_Shape, B: Bnd_Box): void;
  static DumpB(B: Bnd_Box): void;
  Box_1(S: TopoDS_Shape): Bnd_Box;
  Box_2(I: Graphic3d_ZLayerId): Bnd_Box;
  HasBox(S: TopoDS_Shape): Standard_Boolean;
  Shape(I: Graphic3d_ZLayerId): TopoDS_Shape;
  Index(S: TopoDS_Shape): Graphic3d_ZLayerId;
  Extent(): Graphic3d_ZLayerId;
  ChangeIMS(): TopOpeBRepTool_IndexedDataMapOfShapeBox;
  IMS(): TopOpeBRepTool_IndexedDataMapOfShapeBox;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepTool_HBoxTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepTool_HBoxTool): void;
  get(): TopOpeBRepTool_HBoxTool;
  delete(): void;
}

  export declare class Handle_TopOpeBRepTool_HBoxTool_1 extends Handle_TopOpeBRepTool_HBoxTool {
    constructor();
  }

  export declare class Handle_TopOpeBRepTool_HBoxTool_2 extends Handle_TopOpeBRepTool_HBoxTool {
    constructor(thePtr: TopOpeBRepTool_HBoxTool);
  }

  export declare class Handle_TopOpeBRepTool_HBoxTool_3 extends Handle_TopOpeBRepTool_HBoxTool {
    constructor(theHandle: Handle_TopOpeBRepTool_HBoxTool);
  }

  export declare class Handle_TopOpeBRepTool_HBoxTool_4 extends Handle_TopOpeBRepTool_HBoxTool {
    constructor(theHandle: Handle_TopOpeBRepTool_HBoxTool);
  }

export declare class Handle_StepData_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_GeneralModule): void;
  get(): StepData_GeneralModule;
  delete(): void;
}

  export declare class Handle_StepData_GeneralModule_1 extends Handle_StepData_GeneralModule {
    constructor();
  }

  export declare class Handle_StepData_GeneralModule_2 extends Handle_StepData_GeneralModule {
    constructor(thePtr: StepData_GeneralModule);
  }

  export declare class Handle_StepData_GeneralModule_3 extends Handle_StepData_GeneralModule {
    constructor(theHandle: Handle_StepData_GeneralModule);
  }

  export declare class Handle_StepData_GeneralModule_4 extends Handle_StepData_GeneralModule {
    constructor(theHandle: Handle_StepData_GeneralModule);
  }

export declare class StepData_SelectType {
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Matches(ent: Handle_Standard_Transient): Standard_Boolean;
  SetValue(ent: Handle_Standard_Transient): void;
  Nullify(): void;
  Value(): Handle_Standard_Transient;
  IsNull(): Standard_Boolean;
  Type(): Handle_Standard_Type;
  CaseNumber(): Graphic3d_ZLayerId;
  Description(): Handle_StepData_PDescr;
  NewMember(): Handle_StepData_SelectMember;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  CaseMember(): Graphic3d_ZLayerId;
  Member(): Handle_StepData_SelectMember;
  SelectName(): Standard_CString;
  Int(): Graphic3d_ZLayerId;
  SetInt(val: Graphic3d_ZLayerId): void;
  Integer(): Graphic3d_ZLayerId;
  SetInteger(val: Graphic3d_ZLayerId, name: Standard_CString): void;
  Boolean(): Standard_Boolean;
  SetBoolean(val: Standard_Boolean, name: Standard_CString): void;
  Logical(): StepData_Logical;
  SetLogical(val: StepData_Logical, name: Standard_CString): void;
  Real(): Quantity_AbsorbedDose;
  SetReal(val: Quantity_AbsorbedDose, name: Standard_CString): void;
  delete(): void;
}

export declare class StepData_ReadWriteModule extends Interface_ReaderModule {
  CaseNum(data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  CaseStep_1(atype: XCAFDoc_PartId): Graphic3d_ZLayerId;
  CaseStep_2(types: TColStd_SequenceOfAsciiString): Graphic3d_ZLayerId;
  IsComplex(CN: Graphic3d_ZLayerId): Standard_Boolean;
  StepType(CN: Graphic3d_ZLayerId): XCAFDoc_PartId;
  ShortType(CN: Graphic3d_ZLayerId): XCAFDoc_PartId;
  ComplexType(CN: Graphic3d_ZLayerId, types: TColStd_SequenceOfAsciiString): Standard_Boolean;
  Read(CN: Graphic3d_ZLayerId, data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): void;
  ReadStep(CN: Graphic3d_ZLayerId, data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): void;
  WriteStep(CN: Graphic3d_ZLayerId, SW: StepData_StepWriter, ent: Handle_Standard_Transient): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_ReadWriteModule): void;
  get(): StepData_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_StepData_ReadWriteModule_1 extends Handle_StepData_ReadWriteModule {
    constructor();
  }

  export declare class Handle_StepData_ReadWriteModule_2 extends Handle_StepData_ReadWriteModule {
    constructor(thePtr: StepData_ReadWriteModule);
  }

  export declare class Handle_StepData_ReadWriteModule_3 extends Handle_StepData_ReadWriteModule {
    constructor(theHandle: Handle_StepData_ReadWriteModule);
  }

  export declare class Handle_StepData_ReadWriteModule_4 extends Handle_StepData_ReadWriteModule {
    constructor(theHandle: Handle_StepData_ReadWriteModule);
  }

export declare class StepData_FieldList {
  constructor()
  NbFields(): Graphic3d_ZLayerId;
  Field(num: Graphic3d_ZLayerId): StepData_Field;
  CField(num: Graphic3d_ZLayerId): StepData_Field;
  FillShared(iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class StepData_StepModel extends Interface_InterfaceModel {
  constructor()
  Entity(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  GetFromAnother(other: Handle_Interface_InterfaceModel): void;
  NewEmptyModel(): Handle_Interface_InterfaceModel;
  Header(): Interface_EntityIterator;
  HasHeaderEntity(atype: Handle_Standard_Type): Standard_Boolean;
  HeaderEntity(atype: Handle_Standard_Type): Handle_Standard_Transient;
  ClearHeader(): void;
  AddHeaderEntity(ent: Handle_Standard_Transient): void;
  VerifyCheck(ach: Handle_Interface_Check): void;
  DumpHeader(S: Standard_OStream, level: Graphic3d_ZLayerId): void;
  ClearLabels(): void;
  SetIdentLabel(ent: Handle_Standard_Transient, ident: Graphic3d_ZLayerId): void;
  IdentLabel(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PrintLabel(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  StringLabel(ent: Handle_Standard_Transient): Handle_TCollection_HAsciiString;
  SourceCodePage(): Resource_FormatType;
  SetSourceCodePage(theCode: Resource_FormatType): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_StepModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_StepModel): void;
  get(): StepData_StepModel;
  delete(): void;
}

  export declare class Handle_StepData_StepModel_1 extends Handle_StepData_StepModel {
    constructor();
  }

  export declare class Handle_StepData_StepModel_2 extends Handle_StepData_StepModel {
    constructor(thePtr: StepData_StepModel);
  }

  export declare class Handle_StepData_StepModel_3 extends Handle_StepData_StepModel {
    constructor(theHandle: Handle_StepData_StepModel);
  }

  export declare class Handle_StepData_StepModel_4 extends Handle_StepData_StepModel {
    constructor(theHandle: Handle_StepData_StepModel);
  }

export declare class StepData_Field {
  CopyFrom(other: StepData_Field): void;
  Clear(kind: Graphic3d_ZLayerId): void;
  SetDerived(): void;
  SetInt_1(val: Graphic3d_ZLayerId): void;
  SetInteger_1(val: Graphic3d_ZLayerId): void;
  SetBoolean_1(val: Standard_Boolean): void;
  SetLogical_1(val: StepData_Logical): void;
  SetReal_1(val: Quantity_AbsorbedDose): void;
  SetString_1(val: Standard_CString): void;
  SetEnum_1(val: Graphic3d_ZLayerId, text: Standard_CString): void;
  SetSelectMember(val: Handle_StepData_SelectMember): void;
  SetEntity_1(val: Handle_Standard_Transient): void;
  SetEntity_2(): void;
  SetList(size: Graphic3d_ZLayerId, first: Graphic3d_ZLayerId): void;
  SetList2(siz1: Graphic3d_ZLayerId, siz2: Graphic3d_ZLayerId, f1: Graphic3d_ZLayerId, f2: Graphic3d_ZLayerId): void;
  Set(val: Handle_Standard_Transient): void;
  ClearItem(num: Graphic3d_ZLayerId): void;
  SetInt_2(num: Graphic3d_ZLayerId, val: Graphic3d_ZLayerId, kind: Graphic3d_ZLayerId): void;
  SetInteger_2(num: Graphic3d_ZLayerId, val: Graphic3d_ZLayerId): void;
  SetBoolean_2(num: Graphic3d_ZLayerId, val: Standard_Boolean): void;
  SetLogical_2(num: Graphic3d_ZLayerId, val: StepData_Logical): void;
  SetEnum_2(num: Graphic3d_ZLayerId, val: Graphic3d_ZLayerId, text: Standard_CString): void;
  SetReal_2(num: Graphic3d_ZLayerId, val: Quantity_AbsorbedDose): void;
  SetString_2(num: Graphic3d_ZLayerId, val: Standard_CString): void;
  SetEntity_3(num: Graphic3d_ZLayerId, val: Handle_Standard_Transient): void;
  IsSet(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Standard_Boolean;
  ItemKind(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Kind(type: Standard_Boolean): Graphic3d_ZLayerId;
  Arity(): Graphic3d_ZLayerId;
  Length(index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Lower(index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Int(): Graphic3d_ZLayerId;
  Integer(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Boolean(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Standard_Boolean;
  Logical(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): StepData_Logical;
  Real(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  String(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Standard_CString;
  Enum(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  EnumText(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Standard_CString;
  Entity(n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): Handle_Standard_Transient;
  Transient(): Handle_Standard_Transient;
  delete(): void;
}

  export declare class StepData_Field_1 extends StepData_Field {
    constructor();
  }

  export declare class StepData_Field_2 extends StepData_Field {
    constructor(other: StepData_Field, copy: Standard_Boolean);
  }

export declare class Handle_StepData_GlobalNodeOfWriterLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_GlobalNodeOfWriterLib): void;
  get(): StepData_GlobalNodeOfWriterLib;
  delete(): void;
}

  export declare class Handle_StepData_GlobalNodeOfWriterLib_1 extends Handle_StepData_GlobalNodeOfWriterLib {
    constructor();
  }

  export declare class Handle_StepData_GlobalNodeOfWriterLib_2 extends Handle_StepData_GlobalNodeOfWriterLib {
    constructor(thePtr: StepData_GlobalNodeOfWriterLib);
  }

  export declare class Handle_StepData_GlobalNodeOfWriterLib_3 extends Handle_StepData_GlobalNodeOfWriterLib {
    constructor(theHandle: Handle_StepData_GlobalNodeOfWriterLib);
  }

  export declare class Handle_StepData_GlobalNodeOfWriterLib_4 extends Handle_StepData_GlobalNodeOfWriterLib {
    constructor(theHandle: Handle_StepData_GlobalNodeOfWriterLib);
  }

export declare class StepData_GlobalNodeOfWriterLib extends Standard_Transient {
  constructor()
  Add(amodule: Handle_StepData_ReadWriteModule, aprotocol: Handle_StepData_Protocol): void;
  Module(): Handle_StepData_ReadWriteModule;
  Protocol(): Handle_StepData_Protocol;
  Next(): Handle_StepData_GlobalNodeOfWriterLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_Described {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_Described): void;
  get(): StepData_Described;
  delete(): void;
}

  export declare class Handle_StepData_Described_1 extends Handle_StepData_Described {
    constructor();
  }

  export declare class Handle_StepData_Described_2 extends Handle_StepData_Described {
    constructor(thePtr: StepData_Described);
  }

  export declare class Handle_StepData_Described_3 extends Handle_StepData_Described {
    constructor(theHandle: Handle_StepData_Described);
  }

  export declare class Handle_StepData_Described_4 extends Handle_StepData_Described {
    constructor(theHandle: Handle_StepData_Described);
  }

export declare class StepData_Described extends Standard_Transient {
  Description(): Handle_StepData_EDescr;
  IsComplex(): Standard_Boolean;
  Matches(steptype: Standard_CString): Standard_Boolean;
  As(steptype: Standard_CString): Handle_StepData_Simple;
  HasField(name: Standard_CString): Standard_Boolean;
  Field(name: Standard_CString): StepData_Field;
  CField(name: Standard_CString): StepData_Field;
  Check(ach: Handle_Interface_Check): void;
  Shared(list: Interface_EntityIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepData_FieldListN extends StepData_FieldList {
  constructor(nb: Graphic3d_ZLayerId)
  NbFields(): Graphic3d_ZLayerId;
  Field(num: Graphic3d_ZLayerId): StepData_Field;
  CField(num: Graphic3d_ZLayerId): StepData_Field;
  delete(): void;
}

export declare class StepData_FieldListD extends StepData_FieldList {
  constructor(nb: Graphic3d_ZLayerId)
  SetNb(nb: Graphic3d_ZLayerId): void;
  NbFields(): Graphic3d_ZLayerId;
  Field(num: Graphic3d_ZLayerId): StepData_Field;
  CField(num: Graphic3d_ZLayerId): StepData_Field;
  delete(): void;
}

export declare class StepData_PDescr extends Standard_Transient {
  constructor()
  SetName(name: Standard_CString): void;
  Name(): Standard_CString;
  SetSelect(): void;
  AddMember(member: Handle_StepData_PDescr): void;
  SetMemberName(memname: Standard_CString): void;
  SetInteger(): void;
  SetReal(): void;
  SetString(): void;
  SetBoolean(): void;
  SetLogical(): void;
  SetEnum(): void;
  AddEnumDef(enumdef: Standard_CString): void;
  SetType(atype: Handle_Standard_Type): void;
  SetDescr(dscnam: Standard_CString): void;
  AddArity(arity: Graphic3d_ZLayerId): void;
  SetArity(arity: Graphic3d_ZLayerId): void;
  SetFrom(other: Handle_StepData_PDescr): void;
  SetOptional(opt: Standard_Boolean): void;
  SetDerived(der: Standard_Boolean): void;
  SetField(name: Standard_CString, rank: Graphic3d_ZLayerId): void;
  IsSelect(): Standard_Boolean;
  Member(name: Standard_CString): Handle_StepData_PDescr;
  IsInteger(): Standard_Boolean;
  IsReal(): Standard_Boolean;
  IsString(): Standard_Boolean;
  IsBoolean(): Standard_Boolean;
  IsLogical(): Standard_Boolean;
  IsEnum(): Standard_Boolean;
  EnumMax(): Graphic3d_ZLayerId;
  EnumValue(name: Standard_CString): Graphic3d_ZLayerId;
  EnumText(val: Graphic3d_ZLayerId): Standard_CString;
  IsEntity(): Standard_Boolean;
  IsType(atype: Handle_Standard_Type): Standard_Boolean;
  Type(): Handle_Standard_Type;
  IsDescr(descr: Handle_StepData_EDescr): Standard_Boolean;
  DescrName(): Standard_CString;
  Arity(): Graphic3d_ZLayerId;
  Simple(): Handle_StepData_PDescr;
  IsOptional(): Standard_Boolean;
  IsDerived(): Standard_Boolean;
  IsField(): Standard_Boolean;
  FieldName(): Standard_CString;
  FieldRank(): Graphic3d_ZLayerId;
  Check(afild: StepData_Field, ach: Handle_Interface_Check): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_PDescr {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_PDescr): void;
  get(): StepData_PDescr;
  delete(): void;
}

  export declare class Handle_StepData_PDescr_1 extends Handle_StepData_PDescr {
    constructor();
  }

  export declare class Handle_StepData_PDescr_2 extends Handle_StepData_PDescr {
    constructor(thePtr: StepData_PDescr);
  }

  export declare class Handle_StepData_PDescr_3 extends Handle_StepData_PDescr {
    constructor(theHandle: Handle_StepData_PDescr);
  }

  export declare class Handle_StepData_PDescr_4 extends Handle_StepData_PDescr {
    constructor(theHandle: Handle_StepData_PDescr);
  }

export declare class StepData_FieldList1 extends StepData_FieldList {
  constructor()
  NbFields(): Graphic3d_ZLayerId;
  Field(num: Graphic3d_ZLayerId): StepData_Field;
  CField(num: Graphic3d_ZLayerId): StepData_Field;
  delete(): void;
}

export declare class Handle_StepData_ECDescr {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_ECDescr): void;
  get(): StepData_ECDescr;
  delete(): void;
}

  export declare class Handle_StepData_ECDescr_1 extends Handle_StepData_ECDescr {
    constructor();
  }

  export declare class Handle_StepData_ECDescr_2 extends Handle_StepData_ECDescr {
    constructor(thePtr: StepData_ECDescr);
  }

  export declare class Handle_StepData_ECDescr_3 extends Handle_StepData_ECDescr {
    constructor(theHandle: Handle_StepData_ECDescr);
  }

  export declare class Handle_StepData_ECDescr_4 extends Handle_StepData_ECDescr {
    constructor(theHandle: Handle_StepData_ECDescr);
  }

export declare class StepData_ECDescr extends StepData_EDescr {
  constructor()
  Add(member: Handle_StepData_ESDescr): void;
  NbMembers(): Graphic3d_ZLayerId;
  Member(num: Graphic3d_ZLayerId): Handle_StepData_ESDescr;
  TypeList(): Handle_TColStd_HSequenceOfAsciiString;
  Matches(steptype: Standard_CString): Standard_Boolean;
  IsComplex(): Standard_Boolean;
  NewEntity(): Handle_StepData_Described;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_FreeFormEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_FreeFormEntity): void;
  get(): StepData_FreeFormEntity;
  delete(): void;
}

  export declare class Handle_StepData_FreeFormEntity_1 extends Handle_StepData_FreeFormEntity {
    constructor();
  }

  export declare class Handle_StepData_FreeFormEntity_2 extends Handle_StepData_FreeFormEntity {
    constructor(thePtr: StepData_FreeFormEntity);
  }

  export declare class Handle_StepData_FreeFormEntity_3 extends Handle_StepData_FreeFormEntity {
    constructor(theHandle: Handle_StepData_FreeFormEntity);
  }

  export declare class Handle_StepData_FreeFormEntity_4 extends Handle_StepData_FreeFormEntity {
    constructor(theHandle: Handle_StepData_FreeFormEntity);
  }

export declare class StepData_Array1OfField {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepData_Field): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepData_Array1OfField): StepData_Array1OfField;
  Move(theOther: StepData_Array1OfField): StepData_Array1OfField;
  First(): StepData_Field;
  ChangeFirst(): StepData_Field;
  Last(): StepData_Field;
  ChangeLast(): StepData_Field;
  Value(theIndex: Standard_Integer): StepData_Field;
  ChangeValue(theIndex: Standard_Integer): StepData_Field;
  SetValue(theIndex: Standard_Integer, theItem: StepData_Field): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepData_Array1OfField_1 extends StepData_Array1OfField {
    constructor();
  }

  export declare class StepData_Array1OfField_2 extends StepData_Array1OfField {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepData_Array1OfField_3 extends StepData_Array1OfField {
    constructor(theOther: StepData_Array1OfField);
  }

  export declare class StepData_Array1OfField_4 extends StepData_Array1OfField {
    constructor(theOther: StepData_Array1OfField);
  }

  export declare class StepData_Array1OfField_5 extends StepData_Array1OfField {
    constructor(theBegin: StepData_Field, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepData_StepReaderTool extends Interface_FileReaderTool {
  constructor(reader: Handle_StepData_StepReaderData, protocol: Handle_StepData_Protocol)
  Prepare_1(optimize: Standard_Boolean): void;
  Prepare_2(reco: Handle_StepData_FileRecognizer, optimize: Standard_Boolean): void;
  Recognize(num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): Standard_Boolean;
  PrepareHeader(reco: Handle_StepData_FileRecognizer): void;
  BeginRead(amodel: Handle_Interface_InterfaceModel): void;
  AnalyseRecord(num: Graphic3d_ZLayerId, anent: Handle_Standard_Transient, acheck: Handle_Interface_Check): Standard_Boolean;
  EndRead(amodel: Handle_Interface_InterfaceModel): void;
  delete(): void;
}

export declare class Handle_StepData_SelectInt {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_SelectInt): void;
  get(): StepData_SelectInt;
  delete(): void;
}

  export declare class Handle_StepData_SelectInt_1 extends Handle_StepData_SelectInt {
    constructor();
  }

  export declare class Handle_StepData_SelectInt_2 extends Handle_StepData_SelectInt {
    constructor(thePtr: StepData_SelectInt);
  }

  export declare class Handle_StepData_SelectInt_3 extends Handle_StepData_SelectInt {
    constructor(theHandle: Handle_StepData_SelectInt);
  }

  export declare class Handle_StepData_SelectInt_4 extends Handle_StepData_SelectInt {
    constructor(theHandle: Handle_StepData_SelectInt);
  }

export declare class StepData_SelectInt extends StepData_SelectMember {
  constructor()
  Kind(): Graphic3d_ZLayerId;
  SetKind(kind: Graphic3d_ZLayerId): void;
  Int(): Graphic3d_ZLayerId;
  SetInt(val: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_ESDescr {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_ESDescr): void;
  get(): StepData_ESDescr;
  delete(): void;
}

  export declare class Handle_StepData_ESDescr_1 extends Handle_StepData_ESDescr {
    constructor();
  }

  export declare class Handle_StepData_ESDescr_2 extends Handle_StepData_ESDescr {
    constructor(thePtr: StepData_ESDescr);
  }

  export declare class Handle_StepData_ESDescr_3 extends Handle_StepData_ESDescr {
    constructor(theHandle: Handle_StepData_ESDescr);
  }

  export declare class Handle_StepData_ESDescr_4 extends Handle_StepData_ESDescr {
    constructor(theHandle: Handle_StepData_ESDescr);
  }

export declare class StepData_ESDescr extends StepData_EDescr {
  constructor(name: Standard_CString)
  SetNbFields(nb: Graphic3d_ZLayerId): void;
  SetField(num: Graphic3d_ZLayerId, name: Standard_CString, descr: Handle_StepData_PDescr): void;
  SetBase(base: Handle_StepData_ESDescr): void;
  SetSuper(super_: Handle_StepData_ESDescr): void;
  TypeName(): Standard_CString;
  StepType(): XCAFDoc_PartId;
  Base(): Handle_StepData_ESDescr;
  Super(): Handle_StepData_ESDescr;
  IsSub(other: Handle_StepData_ESDescr): Standard_Boolean;
  NbFields(): Graphic3d_ZLayerId;
  Rank(name: Standard_CString): Graphic3d_ZLayerId;
  Name(num: Graphic3d_ZLayerId): Standard_CString;
  Field(num: Graphic3d_ZLayerId): Handle_StepData_PDescr;
  NamedField(name: Standard_CString): Handle_StepData_PDescr;
  Matches(steptype: Standard_CString): Standard_Boolean;
  IsComplex(): Standard_Boolean;
  NewEntity(): Handle_StepData_Described;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_EDescr {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_EDescr): void;
  get(): StepData_EDescr;
  delete(): void;
}

  export declare class Handle_StepData_EDescr_1 extends Handle_StepData_EDescr {
    constructor();
  }

  export declare class Handle_StepData_EDescr_2 extends Handle_StepData_EDescr {
    constructor(thePtr: StepData_EDescr);
  }

  export declare class Handle_StepData_EDescr_3 extends Handle_StepData_EDescr {
    constructor(theHandle: Handle_StepData_EDescr);
  }

  export declare class Handle_StepData_EDescr_4 extends Handle_StepData_EDescr {
    constructor(theHandle: Handle_StepData_EDescr);
  }

export declare class StepData_EDescr extends Standard_Transient {
  Matches(steptype: Standard_CString): Standard_Boolean;
  IsComplex(): Standard_Boolean;
  NewEntity(): Handle_StepData_Described;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_SelectArrReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_SelectArrReal): void;
  get(): StepData_SelectArrReal;
  delete(): void;
}

  export declare class Handle_StepData_SelectArrReal_1 extends Handle_StepData_SelectArrReal {
    constructor();
  }

  export declare class Handle_StepData_SelectArrReal_2 extends Handle_StepData_SelectArrReal {
    constructor(thePtr: StepData_SelectArrReal);
  }

  export declare class Handle_StepData_SelectArrReal_3 extends Handle_StepData_SelectArrReal {
    constructor(theHandle: Handle_StepData_SelectArrReal);
  }

  export declare class Handle_StepData_SelectArrReal_4 extends Handle_StepData_SelectArrReal {
    constructor(theHandle: Handle_StepData_SelectArrReal);
  }

export declare class StepData_SelectArrReal extends StepData_SelectNamed {
  constructor()
  Kind(): Graphic3d_ZLayerId;
  ArrReal(): Handle_TColStd_HArray1OfReal;
  SetArrReal(arr: Handle_TColStd_HArray1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepData_Simple extends StepData_Described {
  constructor(descr: Handle_StepData_ESDescr)
  ESDescr(): Handle_StepData_ESDescr;
  StepType(): Standard_CString;
  IsComplex(): Standard_Boolean;
  Matches(steptype: Standard_CString): Standard_Boolean;
  As(steptype: Standard_CString): Handle_StepData_Simple;
  HasField(name: Standard_CString): Standard_Boolean;
  Field(name: Standard_CString): StepData_Field;
  CField(name: Standard_CString): StepData_Field;
  NbFields(): Graphic3d_ZLayerId;
  FieldNum(num: Graphic3d_ZLayerId): StepData_Field;
  CFieldNum(num: Graphic3d_ZLayerId): StepData_Field;
  Fields(): StepData_FieldListN;
  CFields(): StepData_FieldListN;
  Check(ach: Handle_Interface_Check): void;
  Shared(list: Interface_EntityIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_Simple {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_Simple): void;
  get(): StepData_Simple;
  delete(): void;
}

  export declare class Handle_StepData_Simple_1 extends Handle_StepData_Simple {
    constructor();
  }

  export declare class Handle_StepData_Simple_2 extends Handle_StepData_Simple {
    constructor(thePtr: StepData_Simple);
  }

  export declare class Handle_StepData_Simple_3 extends Handle_StepData_Simple {
    constructor(theHandle: Handle_StepData_Simple);
  }

  export declare class Handle_StepData_Simple_4 extends Handle_StepData_Simple {
    constructor(theHandle: Handle_StepData_Simple);
  }

export declare class StepData_FileRecognizer extends Standard_Transient {
  Evaluate(akey: XCAFDoc_PartId, res: Handle_Standard_Transient): Standard_Boolean;
  Result(): Handle_Standard_Transient;
  Add(reco: Handle_StepData_FileRecognizer): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_FileRecognizer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_FileRecognizer): void;
  get(): StepData_FileRecognizer;
  delete(): void;
}

  export declare class Handle_StepData_FileRecognizer_1 extends Handle_StepData_FileRecognizer {
    constructor();
  }

  export declare class Handle_StepData_FileRecognizer_2 extends Handle_StepData_FileRecognizer {
    constructor(thePtr: StepData_FileRecognizer);
  }

  export declare class Handle_StepData_FileRecognizer_3 extends Handle_StepData_FileRecognizer {
    constructor(theHandle: Handle_StepData_FileRecognizer);
  }

  export declare class Handle_StepData_FileRecognizer_4 extends Handle_StepData_FileRecognizer {
    constructor(theHandle: Handle_StepData_FileRecognizer);
  }

export declare class Handle_StepData_StepReaderData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_StepReaderData): void;
  get(): StepData_StepReaderData;
  delete(): void;
}

  export declare class Handle_StepData_StepReaderData_1 extends Handle_StepData_StepReaderData {
    constructor();
  }

  export declare class Handle_StepData_StepReaderData_2 extends Handle_StepData_StepReaderData {
    constructor(thePtr: StepData_StepReaderData);
  }

  export declare class Handle_StepData_StepReaderData_3 extends Handle_StepData_StepReaderData {
    constructor(theHandle: Handle_StepData_StepReaderData);
  }

  export declare class Handle_StepData_StepReaderData_4 extends Handle_StepData_StepReaderData {
    constructor(theHandle: Handle_StepData_StepReaderData);
  }

export declare class StepData_StepReaderData extends Interface_FileReaderData {
  constructor(nbheader: Graphic3d_ZLayerId, nbtotal: Graphic3d_ZLayerId, nbpar: Graphic3d_ZLayerId, theSourceCodePage: Resource_FormatType)
  SetRecord(num: Graphic3d_ZLayerId, ident: Standard_CString, type: Standard_CString, nbpar: Graphic3d_ZLayerId): void;
  AddStepParam(num: Graphic3d_ZLayerId, aval: Standard_CString, atype: Interface_ParamType, nument: Graphic3d_ZLayerId): void;
  RecordType(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  CType(num: Graphic3d_ZLayerId): Standard_CString;
  RecordIdent(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SubListNumber(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, aslast: Standard_Boolean): Graphic3d_ZLayerId;
  IsComplex(num: Graphic3d_ZLayerId): Standard_Boolean;
  ComplexType(num: Graphic3d_ZLayerId, types: TColStd_SequenceOfAsciiString): void;
  NextForComplex(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NamedForComplex_1(name: Standard_CString, num0: Graphic3d_ZLayerId, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check): Standard_Boolean;
  NamedForComplex_2(theName: Standard_CString, theShortName: Standard_CString, num0: Graphic3d_ZLayerId, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check): Standard_Boolean;
  CheckNbParams(num: Graphic3d_ZLayerId, nbreq: Graphic3d_ZLayerId, ach: Handle_Interface_Check, mess: Standard_CString): Standard_Boolean;
  ReadSubList(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, numsub: Graphic3d_ZLayerId, optional: Standard_Boolean, lenmin: Graphic3d_ZLayerId, lenmax: Graphic3d_ZLayerId): Standard_Boolean;
  ReadSub(numsub: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, descr: Handle_StepData_PDescr, val: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ReadMember_1(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, val: Handle_StepData_SelectMember): Standard_Boolean;
  ReadField(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, descr: Handle_StepData_PDescr, fild: StepData_Field): Standard_Boolean;
  ReadList(num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, descr: Handle_StepData_ESDescr, list: StepData_FieldList): Standard_Boolean;
  ReadAny(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, descr: Handle_StepData_PDescr, val: Handle_Standard_Transient): Standard_Boolean;
  ReadXY(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Standard_Boolean;
  ReadXYZ(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): Standard_Boolean;
  ReadReal(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, val: Quantity_AbsorbedDose): Standard_Boolean;
  ReadEntity_1(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, atype: Handle_Standard_Type, ent: Handle_Standard_Transient): Standard_Boolean;
  ReadEntity_3(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, sel: StepData_SelectType): Standard_Boolean;
  ReadInteger(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, val: Graphic3d_ZLayerId): Standard_Boolean;
  ReadBoolean(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, flag: Standard_Boolean): Standard_Boolean;
  ReadLogical(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, flag: StepData_Logical): Standard_Boolean;
  ReadString(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, val: Handle_TCollection_HAsciiString): Standard_Boolean;
  FailEnumValue(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check): void;
  ReadEnum(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, enumtool: StepData_EnumTool, val: Graphic3d_ZLayerId): Standard_Boolean;
  ReadTypedParam(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mustbetyped: Standard_Boolean, mess: Standard_CString, ach: Handle_Interface_Check, numr: Graphic3d_ZLayerId, numrp: Graphic3d_ZLayerId, typ: XCAFDoc_PartId): Standard_Boolean;
  CheckDerived(num: Graphic3d_ZLayerId, nump: Graphic3d_ZLayerId, mess: Standard_CString, ach: Handle_Interface_Check, errstat: Standard_Boolean): Standard_Boolean;
  NbEntities(): Graphic3d_ZLayerId;
  FindNextRecord(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetEntityNumbers(withmap: Standard_Boolean): void;
  FindNextHeaderRecord(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  PrepareHeader(): void;
  GlobalCheck(): Handle_Interface_Check;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_HArray1OfField {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_HArray1OfField): void;
  get(): StepData_HArray1OfField;
  delete(): void;
}

  export declare class Handle_StepData_HArray1OfField_1 extends Handle_StepData_HArray1OfField {
    constructor();
  }

  export declare class Handle_StepData_HArray1OfField_2 extends Handle_StepData_HArray1OfField {
    constructor(thePtr: StepData_HArray1OfField);
  }

  export declare class Handle_StepData_HArray1OfField_3 extends Handle_StepData_HArray1OfField {
    constructor(theHandle: Handle_StepData_HArray1OfField);
  }

  export declare class Handle_StepData_HArray1OfField_4 extends Handle_StepData_HArray1OfField {
    constructor(theHandle: Handle_StepData_HArray1OfField);
  }

export declare class Handle_StepData_Plex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_Plex): void;
  get(): StepData_Plex;
  delete(): void;
}

  export declare class Handle_StepData_Plex_1 extends Handle_StepData_Plex {
    constructor();
  }

  export declare class Handle_StepData_Plex_2 extends Handle_StepData_Plex {
    constructor(thePtr: StepData_Plex);
  }

  export declare class Handle_StepData_Plex_3 extends Handle_StepData_Plex {
    constructor(theHandle: Handle_StepData_Plex);
  }

  export declare class Handle_StepData_Plex_4 extends Handle_StepData_Plex {
    constructor(theHandle: Handle_StepData_Plex);
  }

export declare class StepData_Plex extends StepData_Described {
  constructor(descr: Handle_StepData_ECDescr)
  Add(member: Handle_StepData_Simple): void;
  ECDescr(): Handle_StepData_ECDescr;
  IsComplex(): Standard_Boolean;
  Matches(steptype: Standard_CString): Standard_Boolean;
  As(steptype: Standard_CString): Handle_StepData_Simple;
  HasField(name: Standard_CString): Standard_Boolean;
  Field(name: Standard_CString): StepData_Field;
  CField(name: Standard_CString): StepData_Field;
  NbMembers(): Graphic3d_ZLayerId;
  Member(num: Graphic3d_ZLayerId): Handle_StepData_Simple;
  TypeList(): Handle_TColStd_HSequenceOfAsciiString;
  Check(ach: Handle_Interface_Check): void;
  Shared(list: Interface_EntityIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepData_FileProtocol extends StepData_Protocol {
  constructor()
  Add(protocol: Handle_StepData_Protocol): void;
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  GlobalCheck(G: Interface_Graph, ach: Handle_Interface_Check): Standard_Boolean;
  SchemaName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_FileProtocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_FileProtocol): void;
  get(): StepData_FileProtocol;
  delete(): void;
}

  export declare class Handle_StepData_FileProtocol_1 extends Handle_StepData_FileProtocol {
    constructor();
  }

  export declare class Handle_StepData_FileProtocol_2 extends Handle_StepData_FileProtocol {
    constructor(thePtr: StepData_FileProtocol);
  }

  export declare class Handle_StepData_FileProtocol_3 extends Handle_StepData_FileProtocol {
    constructor(theHandle: Handle_StepData_FileProtocol);
  }

  export declare class Handle_StepData_FileProtocol_4 extends Handle_StepData_FileProtocol {
    constructor(theHandle: Handle_StepData_FileProtocol);
  }

export declare class StepData_StepDumper {
  constructor(amodel: Handle_StepData_StepModel, protocol: Handle_StepData_Protocol, mode: Graphic3d_ZLayerId)
  StepWriter(): StepData_StepWriter;
  Dump_1(S: Standard_OStream, ent: Handle_Standard_Transient, level: Graphic3d_ZLayerId): Standard_Boolean;
  Dump_2(S: Standard_OStream, num: Graphic3d_ZLayerId, level: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class StepData_SelectNamed extends StepData_SelectMember {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Field(): StepData_Field;
  CField(): StepData_Field;
  Kind(): Graphic3d_ZLayerId;
  SetKind(kind: Graphic3d_ZLayerId): void;
  Int(): Graphic3d_ZLayerId;
  SetInt(val: Graphic3d_ZLayerId): void;
  Real(): Quantity_AbsorbedDose;
  SetReal(val: Quantity_AbsorbedDose): void;
  String(): Standard_CString;
  SetString(val: Standard_CString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_SelectNamed {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_SelectNamed): void;
  get(): StepData_SelectNamed;
  delete(): void;
}

  export declare class Handle_StepData_SelectNamed_1 extends Handle_StepData_SelectNamed {
    constructor();
  }

  export declare class Handle_StepData_SelectNamed_2 extends Handle_StepData_SelectNamed {
    constructor(thePtr: StepData_SelectNamed);
  }

  export declare class Handle_StepData_SelectNamed_3 extends Handle_StepData_SelectNamed {
    constructor(theHandle: Handle_StepData_SelectNamed);
  }

  export declare class Handle_StepData_SelectNamed_4 extends Handle_StepData_SelectNamed {
    constructor(theHandle: Handle_StepData_SelectNamed);
  }

export declare class StepData_EnumTool {
  constructor(e0: Standard_CString, e1: Standard_CString, e2: Standard_CString, e3: Standard_CString, e4: Standard_CString, e5: Standard_CString, e6: Standard_CString, e7: Standard_CString, e8: Standard_CString, e9: Standard_CString, e10: Standard_CString, e11: Standard_CString, e12: Standard_CString, e13: Standard_CString, e14: Standard_CString, e15: Standard_CString, e16: Standard_CString, e17: Standard_CString, e18: Standard_CString, e19: Standard_CString, e20: Standard_CString, e21: Standard_CString, e22: Standard_CString, e23: Standard_CString, e24: Standard_CString, e25: Standard_CString, e26: Standard_CString, e27: Standard_CString, e28: Standard_CString, e29: Standard_CString, e30: Standard_CString, e31: Standard_CString, e32: Standard_CString, e33: Standard_CString, e34: Standard_CString, e35: Standard_CString, e36: Standard_CString, e37: Standard_CString, e38: Standard_CString, e39: Standard_CString)
  AddDefinition(term: Standard_CString): void;
  IsSet(): Standard_Boolean;
  MaxValue(): Graphic3d_ZLayerId;
  Optional(mode: Standard_Boolean): void;
  NullValue(): Graphic3d_ZLayerId;
  Text(num: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Value_1(txt: Standard_CString): Graphic3d_ZLayerId;
  Value_2(txt: XCAFDoc_PartId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare type StepData_Logical = {
  StepData_LFalse: {};
  StepData_LTrue: {};
  StepData_LUnknown: {};
}

export declare class StepData_Protocol extends Interface_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  CaseNumber(obj: Handle_Standard_Transient): Graphic3d_ZLayerId;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  SchemaName(): Standard_CString;
  NewModel(): Handle_Interface_InterfaceModel;
  IsSuitableModel(model: Handle_Interface_InterfaceModel): Standard_Boolean;
  UnknownEntity(): Handle_Standard_Transient;
  IsUnknownEntity(ent: Handle_Standard_Transient): Standard_Boolean;
  DescrNumber(adescr: Handle_StepData_EDescr): Graphic3d_ZLayerId;
  AddDescr(adescr: Handle_StepData_EDescr, CN: Graphic3d_ZLayerId): void;
  HasDescr(): Standard_Boolean;
  Descr_1(num: Graphic3d_ZLayerId): Handle_StepData_EDescr;
  Descr_2(name: Standard_CString, anylevel: Standard_Boolean): Handle_StepData_EDescr;
  ESDescr(name: Standard_CString, anylevel: Standard_Boolean): Handle_StepData_ESDescr;
  ECDescr(names: TColStd_SequenceOfAsciiString, anylevel: Standard_Boolean): Handle_StepData_ECDescr;
  AddPDescr(pdescr: Handle_StepData_PDescr): void;
  PDescr(name: Standard_CString, anylevel: Standard_Boolean): Handle_StepData_PDescr;
  AddBasicDescr(esdescr: Handle_StepData_ESDescr): void;
  BasicDescr(name: Standard_CString, anylevel: Standard_Boolean): Handle_StepData_EDescr;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_Protocol): void;
  get(): StepData_Protocol;
  delete(): void;
}

  export declare class Handle_StepData_Protocol_1 extends Handle_StepData_Protocol {
    constructor();
  }

  export declare class Handle_StepData_Protocol_2 extends Handle_StepData_Protocol {
    constructor(thePtr: StepData_Protocol);
  }

  export declare class Handle_StepData_Protocol_3 extends Handle_StepData_Protocol {
    constructor(theHandle: Handle_StepData_Protocol);
  }

  export declare class Handle_StepData_Protocol_4 extends Handle_StepData_Protocol {
    constructor(theHandle: Handle_StepData_Protocol);
  }

export declare class StepData_StepWriter {
  constructor(amodel: Handle_StepData_StepModel)
  LabelMode(): Graphic3d_ZLayerId;
  TypeMode(): Graphic3d_ZLayerId;
  FloatWriter(): Interface_FloatWriter;
  SetScope(numscope: Graphic3d_ZLayerId, numin: Graphic3d_ZLayerId): void;
  IsInScope(num: Graphic3d_ZLayerId): Standard_Boolean;
  SendModel(protocol: Handle_StepData_Protocol, headeronly: Standard_Boolean): void;
  SendHeader(): void;
  SendData(): void;
  SendEntity(nument: Graphic3d_ZLayerId, lib: StepData_WriterLib): void;
  EndSec(): void;
  EndFile(): void;
  NewLine(evenempty: Standard_Boolean): void;
  JoinLast(newline: Standard_Boolean): void;
  Indent(onent: Standard_Boolean): void;
  SendIdent(ident: Graphic3d_ZLayerId): void;
  SendScope(): void;
  SendEndscope(): void;
  Comment(mode: Standard_Boolean): void;
  SendComment_1(text: Handle_TCollection_HAsciiString): void;
  SendComment_2(text: Standard_CString): void;
  StartEntity(atype: XCAFDoc_PartId): void;
  StartComplex(): void;
  EndComplex(): void;
  SendField(fild: StepData_Field, descr: Handle_StepData_PDescr): void;
  SendSelect(sm: Handle_StepData_SelectMember, descr: Handle_StepData_PDescr): void;
  SendList(list: StepData_FieldList, descr: Handle_StepData_ESDescr): void;
  OpenSub(): void;
  OpenTypedSub(subtype: Standard_CString): void;
  CloseSub(): void;
  AddParam(): void;
  Send_1(val: Graphic3d_ZLayerId): void;
  Send_2(val: Quantity_AbsorbedDose): void;
  Send_3(val: XCAFDoc_PartId): void;
  Send_4(val: Handle_Standard_Transient): void;
  SendBoolean(val: Standard_Boolean): void;
  SendLogical(val: StepData_Logical): void;
  SendString_1(val: XCAFDoc_PartId): void;
  SendString_2(val: Standard_CString): void;
  SendEnum_1(val: XCAFDoc_PartId): void;
  SendEnum_2(val: Standard_CString): void;
  SendArrReal(anArr: Handle_TColStd_HArray1OfReal): void;
  SendUndef(): void;
  SendDerived(): void;
  EndEntity(): void;
  CheckList(): Interface_CheckIterator;
  NbLines(): Graphic3d_ZLayerId;
  Line(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Print(S: Standard_OStream): Standard_Boolean;
  delete(): void;
}

export declare class Handle_StepData_DefaultGeneral {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_DefaultGeneral): void;
  get(): StepData_DefaultGeneral;
  delete(): void;
}

  export declare class Handle_StepData_DefaultGeneral_1 extends Handle_StepData_DefaultGeneral {
    constructor();
  }

  export declare class Handle_StepData_DefaultGeneral_2 extends Handle_StepData_DefaultGeneral {
    constructor(thePtr: StepData_DefaultGeneral);
  }

  export declare class Handle_StepData_DefaultGeneral_3 extends Handle_StepData_DefaultGeneral {
    constructor(theHandle: Handle_StepData_DefaultGeneral);
  }

  export declare class Handle_StepData_DefaultGeneral_4 extends Handle_StepData_DefaultGeneral {
    constructor(theHandle: Handle_StepData_DefaultGeneral);
  }

export declare class Handle_StepData_UndefinedEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_UndefinedEntity): void;
  get(): StepData_UndefinedEntity;
  delete(): void;
}

  export declare class Handle_StepData_UndefinedEntity_1 extends Handle_StepData_UndefinedEntity {
    constructor();
  }

  export declare class Handle_StepData_UndefinedEntity_2 extends Handle_StepData_UndefinedEntity {
    constructor(thePtr: StepData_UndefinedEntity);
  }

  export declare class Handle_StepData_UndefinedEntity_3 extends Handle_StepData_UndefinedEntity {
    constructor(theHandle: Handle_StepData_UndefinedEntity);
  }

  export declare class Handle_StepData_UndefinedEntity_4 extends Handle_StepData_UndefinedEntity {
    constructor(theHandle: Handle_StepData_UndefinedEntity);
  }

export declare class Handle_StepData_NodeOfWriterLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_NodeOfWriterLib): void;
  get(): StepData_NodeOfWriterLib;
  delete(): void;
}

  export declare class Handle_StepData_NodeOfWriterLib_1 extends Handle_StepData_NodeOfWriterLib {
    constructor();
  }

  export declare class Handle_StepData_NodeOfWriterLib_2 extends Handle_StepData_NodeOfWriterLib {
    constructor(thePtr: StepData_NodeOfWriterLib);
  }

  export declare class Handle_StepData_NodeOfWriterLib_3 extends Handle_StepData_NodeOfWriterLib {
    constructor(theHandle: Handle_StepData_NodeOfWriterLib);
  }

  export declare class Handle_StepData_NodeOfWriterLib_4 extends Handle_StepData_NodeOfWriterLib {
    constructor(theHandle: Handle_StepData_NodeOfWriterLib);
  }

export declare class StepData_NodeOfWriterLib extends Standard_Transient {
  constructor()
  AddNode(anode: Handle_StepData_GlobalNodeOfWriterLib): void;
  Module(): Handle_StepData_ReadWriteModule;
  Protocol(): Handle_StepData_Protocol;
  Next(): Handle_StepData_NodeOfWriterLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepData {
  constructor();
  static HeaderProtocol(): Handle_StepData_Protocol;
  static AddHeaderProtocol(headerproto: Handle_StepData_Protocol): void;
  static Init(): void;
  static Protocol(): Handle_StepData_Protocol;
  delete(): void;
}

export declare class StepData_WriterLib {
  static SetGlobal(amodule: Handle_StepData_ReadWriteModule, aprotocol: Handle_StepData_Protocol): void;
  AddProtocol(aprotocol: Handle_Standard_Transient): void;
  Clear(): void;
  SetComplete(): void;
  Select(obj: Handle_Standard_Transient, module: Handle_StepData_ReadWriteModule, CN: Graphic3d_ZLayerId): Standard_Boolean;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Module(): Handle_StepData_ReadWriteModule;
  Protocol(): Handle_StepData_Protocol;
  delete(): void;
}

  export declare class StepData_WriterLib_1 extends StepData_WriterLib {
    constructor(aprotocol: Handle_StepData_Protocol);
  }

  export declare class StepData_WriterLib_2 extends StepData_WriterLib {
    constructor();
  }

export declare class Handle_StepData_SelectReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_SelectReal): void;
  get(): StepData_SelectReal;
  delete(): void;
}

  export declare class Handle_StepData_SelectReal_1 extends Handle_StepData_SelectReal {
    constructor();
  }

  export declare class Handle_StepData_SelectReal_2 extends Handle_StepData_SelectReal {
    constructor(thePtr: StepData_SelectReal);
  }

  export declare class Handle_StepData_SelectReal_3 extends Handle_StepData_SelectReal {
    constructor(theHandle: Handle_StepData_SelectReal);
  }

  export declare class Handle_StepData_SelectReal_4 extends Handle_StepData_SelectReal {
    constructor(theHandle: Handle_StepData_SelectReal);
  }

export declare class StepData_SelectReal extends StepData_SelectMember {
  constructor()
  Kind(): Graphic3d_ZLayerId;
  Real(): Quantity_AbsorbedDose;
  SetReal(val: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepData_SelectMember extends Standard_Transient {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  Kind(): Graphic3d_ZLayerId;
  SetKind(kind: Graphic3d_ZLayerId): void;
  ParamType(): Interface_ParamType;
  Int(): Graphic3d_ZLayerId;
  SetInt(val: Graphic3d_ZLayerId): void;
  Integer(): Graphic3d_ZLayerId;
  SetInteger(val: Graphic3d_ZLayerId): void;
  Boolean(): Standard_Boolean;
  SetBoolean(val: Standard_Boolean): void;
  Logical(): StepData_Logical;
  SetLogical(val: StepData_Logical): void;
  Real(): Quantity_AbsorbedDose;
  SetReal(val: Quantity_AbsorbedDose): void;
  String(): Standard_CString;
  SetString(val: Standard_CString): void;
  Enum(): Graphic3d_ZLayerId;
  EnumText(): Standard_CString;
  SetEnum(val: Graphic3d_ZLayerId, text: Standard_CString): void;
  SetEnumText(val: Graphic3d_ZLayerId, text: Standard_CString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepData_SelectMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepData_SelectMember): void;
  get(): StepData_SelectMember;
  delete(): void;
}

  export declare class Handle_StepData_SelectMember_1 extends Handle_StepData_SelectMember {
    constructor();
  }

  export declare class Handle_StepData_SelectMember_2 extends Handle_StepData_SelectMember {
    constructor(thePtr: StepData_SelectMember);
  }

  export declare class Handle_StepData_SelectMember_3 extends Handle_StepData_SelectMember {
    constructor(theHandle: Handle_StepData_SelectMember);
  }

  export declare class Handle_StepData_SelectMember_4 extends Handle_StepData_SelectMember {
    constructor(theHandle: Handle_StepData_SelectMember);
  }

export declare class Adaptor3d_CurveOnSurface extends Adaptor3d_Curve {
  Load_1(S: Handle_Adaptor3d_HSurface): void;
  Load_2(C: Handle_Adaptor2d_HCurve2d): void;
  Load_3(C: Handle_Adaptor2d_HCurve2d, S: Handle_Adaptor3d_HSurface): void;
  GetCurve(): Handle_Adaptor2d_HCurve2d;
  GetSurface(): Handle_Adaptor3d_HSurface;
  ChangeCurve(): Handle_Adaptor2d_HCurve2d;
  ChangeSurface(): Handle_Adaptor3d_HSurface;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

  export declare class Adaptor3d_CurveOnSurface_1 extends Adaptor3d_CurveOnSurface {
    constructor();
  }

  export declare class Adaptor3d_CurveOnSurface_2 extends Adaptor3d_CurveOnSurface {
    constructor(S: Handle_Adaptor3d_HSurface);
  }

  export declare class Adaptor3d_CurveOnSurface_3 extends Adaptor3d_CurveOnSurface {
    constructor(C: Handle_Adaptor2d_HCurve2d, S: Handle_Adaptor3d_HSurface);
  }

export declare class Adaptor3d_HSurfaceTool {
  constructor();
  static FirstUParameter(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static FirstVParameter(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static LastUParameter(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static LastVParameter(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static NbUIntervals(S: Handle_Adaptor3d_HSurface, Sh: GeomAbs_Shape): Graphic3d_ZLayerId;
  static NbVIntervals(S: Handle_Adaptor3d_HSurface, Sh: GeomAbs_Shape): Graphic3d_ZLayerId;
  static UIntervals(S: Handle_Adaptor3d_HSurface, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static VIntervals(S: Handle_Adaptor3d_HSurface, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static UTrim(S: Handle_Adaptor3d_HSurface, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  static VTrim(S: Handle_Adaptor3d_HSurface, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  static IsUClosed(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static IsVClosed(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static IsUPeriodic(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static UPeriod(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static IsVPeriodic(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static VPeriod(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static Value(S: Handle_Adaptor3d_HSurface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): gp_Pnt;
  static D0(S: Handle_Adaptor3d_HSurface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(S: Handle_Adaptor3d_HSurface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1u: gp_Vec, D1v: gp_Vec): void;
  static D2(S: Handle_Adaptor3d_HSurface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  static D3(S: Handle_Adaptor3d_HSurface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  static DN(S: Handle_Adaptor3d_HSurface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static UResolution(S: Handle_Adaptor3d_HSurface, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static VResolution(S: Handle_Adaptor3d_HSurface, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(S: Handle_Adaptor3d_HSurface): GeomAbs_SurfaceType;
  static Plane(S: Handle_Adaptor3d_HSurface): gp_Pln;
  static Cylinder(S: Handle_Adaptor3d_HSurface): gp_Cylinder;
  static Cone(S: Handle_Adaptor3d_HSurface): gp_Cone;
  static Torus(S: Handle_Adaptor3d_HSurface): gp_Torus;
  static Sphere(S: Handle_Adaptor3d_HSurface): gp_Sphere;
  static Bezier(S: Handle_Adaptor3d_HSurface): Handle_Geom_BezierSurface;
  static BSpline(S: Handle_Adaptor3d_HSurface): Handle_Geom_BSplineSurface;
  static AxeOfRevolution(S: Handle_Adaptor3d_HSurface): gp_Ax1;
  static Direction(S: Handle_Adaptor3d_HSurface): gp_Dir;
  static BasisCurve(S: Handle_Adaptor3d_HSurface): Handle_Adaptor3d_HCurve;
  static BasisSurface(S: Handle_Adaptor3d_HSurface): Handle_Adaptor3d_HSurface;
  static OffsetValue(S: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  static NbSamplesU_1(S: Handle_Adaptor3d_HSurface): Graphic3d_ZLayerId;
  static NbSamplesV_1(S: Handle_Adaptor3d_HSurface): Graphic3d_ZLayerId;
  static NbSamplesU_2(S: Handle_Adaptor3d_HSurface, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplesV_2(S: Handle_Adaptor3d_HSurface, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Adaptor3d_HCurve extends Standard_Transient {
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  OffsetCurve(): Handle_Geom_OffsetCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Adaptor3d_HCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor3d_HCurve): void;
  get(): Adaptor3d_HCurve;
  delete(): void;
}

  export declare class Handle_Adaptor3d_HCurve_1 extends Handle_Adaptor3d_HCurve {
    constructor();
  }

  export declare class Handle_Adaptor3d_HCurve_2 extends Handle_Adaptor3d_HCurve {
    constructor(thePtr: Adaptor3d_HCurve);
  }

  export declare class Handle_Adaptor3d_HCurve_3 extends Handle_Adaptor3d_HCurve {
    constructor(theHandle: Handle_Adaptor3d_HCurve);
  }

  export declare class Handle_Adaptor3d_HCurve_4 extends Handle_Adaptor3d_HCurve {
    constructor(theHandle: Handle_Adaptor3d_HCurve);
  }

export declare class Adaptor3d_Surface {
  constructor();
  FirstUParameter(): Quantity_AbsorbedDose;
  LastUParameter(): Quantity_AbsorbedDose;
  FirstVParameter(): Quantity_AbsorbedDose;
  LastVParameter(): Quantity_AbsorbedDose;
  UContinuity(): GeomAbs_Shape;
  VContinuity(): GeomAbs_Shape;
  NbUIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  NbVIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  UIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  VIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  UTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  VTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  UResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Sphere(): gp_Sphere;
  Torus(): gp_Torus;
  UDegree(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bezier(): Handle_Geom_BezierSurface;
  BSpline(): Handle_Geom_BSplineSurface;
  AxeOfRevolution(): gp_Ax1;
  Direction(): gp_Dir;
  BasisCurve(): Handle_Adaptor3d_HCurve;
  BasisSurface(): Handle_Adaptor3d_HSurface;
  OffsetValue(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Adaptor3d_Curve {
  constructor();
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  OffsetCurve(): Handle_Geom_OffsetCurve;
  delete(): void;
}

export declare class Handle_Adaptor3d_HSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor3d_HSurface): void;
  get(): Adaptor3d_HSurface;
  delete(): void;
}

  export declare class Handle_Adaptor3d_HSurface_1 extends Handle_Adaptor3d_HSurface {
    constructor();
  }

  export declare class Handle_Adaptor3d_HSurface_2 extends Handle_Adaptor3d_HSurface {
    constructor(thePtr: Adaptor3d_HSurface);
  }

  export declare class Handle_Adaptor3d_HSurface_3 extends Handle_Adaptor3d_HSurface {
    constructor(theHandle: Handle_Adaptor3d_HSurface);
  }

  export declare class Handle_Adaptor3d_HSurface_4 extends Handle_Adaptor3d_HSurface {
    constructor(theHandle: Handle_Adaptor3d_HSurface);
  }

export declare class Adaptor3d_HSurface extends Standard_Transient {
  Surface(): Adaptor3d_Surface;
  FirstUParameter(): Quantity_AbsorbedDose;
  LastUParameter(): Quantity_AbsorbedDose;
  FirstVParameter(): Quantity_AbsorbedDose;
  LastVParameter(): Quantity_AbsorbedDose;
  UContinuity(): GeomAbs_Shape;
  VContinuity(): GeomAbs_Shape;
  NbUIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  NbVIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  UIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  VIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  UTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  VTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  UResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Sphere(): gp_Sphere;
  Torus(): gp_Torus;
  UDegree(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bezier(): Handle_Geom_BezierSurface;
  BSpline(): Handle_Geom_BSplineSurface;
  AxeOfRevolution(): gp_Ax1;
  Direction(): gp_Dir;
  BasisCurve(): Handle_Adaptor3d_HCurve;
  BasisSurface(): Handle_Adaptor3d_HSurface;
  OffsetValue(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Adaptor3d_TopolTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor3d_TopolTool): void;
  get(): Adaptor3d_TopolTool;
  delete(): void;
}

  export declare class Handle_Adaptor3d_TopolTool_1 extends Handle_Adaptor3d_TopolTool {
    constructor();
  }

  export declare class Handle_Adaptor3d_TopolTool_2 extends Handle_Adaptor3d_TopolTool {
    constructor(thePtr: Adaptor3d_TopolTool);
  }

  export declare class Handle_Adaptor3d_TopolTool_3 extends Handle_Adaptor3d_TopolTool {
    constructor(theHandle: Handle_Adaptor3d_TopolTool);
  }

  export declare class Handle_Adaptor3d_TopolTool_4 extends Handle_Adaptor3d_TopolTool {
    constructor(theHandle: Handle_Adaptor3d_TopolTool);
  }

export declare class Adaptor3d_TopolTool extends Standard_Transient {
  Initialize_1(): void;
  Initialize_2(S: Handle_Adaptor3d_HSurface): void;
  Initialize_3(Curve: Handle_Adaptor2d_HCurve2d): void;
  Init(): void;
  More(): Standard_Boolean;
  Value(): Handle_Adaptor2d_HCurve2d;
  Next(): void;
  InitVertexIterator(): void;
  MoreVertex(): Standard_Boolean;
  Vertex(): Handle_Adaptor3d_HVertex;
  NextVertex(): void;
  Classify(P: gp_Pnt2d, Tol: Quantity_AbsorbedDose, ReacdreOnPeriodic: Standard_Boolean): TopAbs_State;
  IsThePointOn(P: gp_Pnt2d, Tol: Quantity_AbsorbedDose, ReacdreOnPeriodic: Standard_Boolean): Standard_Boolean;
  Orientation_1(C: Handle_Adaptor2d_HCurve2d): TopAbs_Orientation;
  Orientation_2(V: Handle_Adaptor3d_HVertex): TopAbs_Orientation;
  Identical(V1: Handle_Adaptor3d_HVertex, V2: Handle_Adaptor3d_HVertex): Standard_Boolean;
  Has3d(): Standard_Boolean;
  Tol3d_1(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  Tol3d_2(V: Handle_Adaptor3d_HVertex): Quantity_AbsorbedDose;
  Pnt(V: Handle_Adaptor3d_HVertex): gp_Pnt;
  ComputeSamplePoints(): void;
  NbSamplesU(): Graphic3d_ZLayerId;
  NbSamplesV(): Graphic3d_ZLayerId;
  NbSamples(): Graphic3d_ZLayerId;
  UParameters(theArray: TColStd_Array1OfReal): void;
  VParameters(theArray: TColStd_Array1OfReal): void;
  SamplePoint(Index: Graphic3d_ZLayerId, P2d: gp_Pnt2d, P3d: gp_Pnt): void;
  DomainIsInfinite(): Standard_Boolean;
  Edge(): Standard_Address;
  SamplePnts(theDefl: Quantity_AbsorbedDose, theNUmin: Graphic3d_ZLayerId, theNVmin: Graphic3d_ZLayerId): void;
  BSplSamplePnts(theDefl: Quantity_AbsorbedDose, theNUmin: Graphic3d_ZLayerId, theNVmin: Graphic3d_ZLayerId): void;
  IsUniformSampling(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Adaptor3d_TopolTool_1 extends Adaptor3d_TopolTool {
    constructor();
  }

  export declare class Adaptor3d_TopolTool_2 extends Adaptor3d_TopolTool {
    constructor(Surface: Handle_Adaptor3d_HSurface);
  }

export declare class Adaptor3d_HVertex extends Standard_Transient {
  Value(): gp_Pnt2d;
  Parameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  Resolution(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  Orientation(): TopAbs_Orientation;
  IsSame(Other: Handle_Adaptor3d_HVertex): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Adaptor3d_HVertex_1 extends Adaptor3d_HVertex {
    constructor();
  }

  export declare class Adaptor3d_HVertex_2 extends Adaptor3d_HVertex {
    constructor(P: gp_Pnt2d, Ori: TopAbs_Orientation, Resolution: Quantity_AbsorbedDose);
  }

export declare class Handle_Adaptor3d_HVertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor3d_HVertex): void;
  get(): Adaptor3d_HVertex;
  delete(): void;
}

  export declare class Handle_Adaptor3d_HVertex_1 extends Handle_Adaptor3d_HVertex {
    constructor();
  }

  export declare class Handle_Adaptor3d_HVertex_2 extends Handle_Adaptor3d_HVertex {
    constructor(thePtr: Adaptor3d_HVertex);
  }

  export declare class Handle_Adaptor3d_HVertex_3 extends Handle_Adaptor3d_HVertex {
    constructor(theHandle: Handle_Adaptor3d_HVertex);
  }

  export declare class Handle_Adaptor3d_HVertex_4 extends Handle_Adaptor3d_HVertex {
    constructor(theHandle: Handle_Adaptor3d_HVertex);
  }

export declare class Adaptor3d_HCurveOnSurface extends Adaptor3d_HCurve {
  Set(C: Adaptor3d_CurveOnSurface): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): Adaptor3d_CurveOnSurface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Adaptor3d_HCurveOnSurface_1 extends Adaptor3d_HCurveOnSurface {
    constructor();
  }

  export declare class Adaptor3d_HCurveOnSurface_2 extends Adaptor3d_HCurveOnSurface {
    constructor(C: Adaptor3d_CurveOnSurface);
  }

export declare class Handle_Adaptor3d_HCurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor3d_HCurveOnSurface): void;
  get(): Adaptor3d_HCurveOnSurface;
  delete(): void;
}

  export declare class Handle_Adaptor3d_HCurveOnSurface_1 extends Handle_Adaptor3d_HCurveOnSurface {
    constructor();
  }

  export declare class Handle_Adaptor3d_HCurveOnSurface_2 extends Handle_Adaptor3d_HCurveOnSurface {
    constructor(thePtr: Adaptor3d_HCurveOnSurface);
  }

  export declare class Handle_Adaptor3d_HCurveOnSurface_3 extends Handle_Adaptor3d_HCurveOnSurface {
    constructor(theHandle: Handle_Adaptor3d_HCurveOnSurface);
  }

  export declare class Handle_Adaptor3d_HCurveOnSurface_4 extends Handle_Adaptor3d_HCurveOnSurface {
    constructor(theHandle: Handle_Adaptor3d_HCurveOnSurface);
  }

export declare class Adaptor3d_InterFunc extends math_FunctionWithDerivative {
  constructor(C: Handle_Adaptor2d_HCurve2d, FixVal: Quantity_AbsorbedDose, Fix: Graphic3d_ZLayerId)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Adaptor3d_HIsoCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor3d_HIsoCurve): void;
  get(): Adaptor3d_HIsoCurve;
  delete(): void;
}

  export declare class Handle_Adaptor3d_HIsoCurve_1 extends Handle_Adaptor3d_HIsoCurve {
    constructor();
  }

  export declare class Handle_Adaptor3d_HIsoCurve_2 extends Handle_Adaptor3d_HIsoCurve {
    constructor(thePtr: Adaptor3d_HIsoCurve);
  }

  export declare class Handle_Adaptor3d_HIsoCurve_3 extends Handle_Adaptor3d_HIsoCurve {
    constructor(theHandle: Handle_Adaptor3d_HIsoCurve);
  }

  export declare class Handle_Adaptor3d_HIsoCurve_4 extends Handle_Adaptor3d_HIsoCurve {
    constructor(theHandle: Handle_Adaptor3d_HIsoCurve);
  }

export declare class Adaptor3d_HIsoCurve extends Adaptor3d_HCurve {
  Set(C: Adaptor3d_IsoCurve): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): Adaptor3d_IsoCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Adaptor3d_HIsoCurve_1 extends Adaptor3d_HIsoCurve {
    constructor();
  }

  export declare class Adaptor3d_HIsoCurve_2 extends Adaptor3d_HIsoCurve {
    constructor(C: Adaptor3d_IsoCurve);
  }

export declare class Adaptor3d_IsoCurve extends Adaptor3d_Curve {
  Load_1(S: Handle_Adaptor3d_HSurface): void;
  Load_2(Iso: GeomAbs_IsoType, Param: Quantity_AbsorbedDose): void;
  Load_3(Iso: GeomAbs_IsoType, Param: Quantity_AbsorbedDose, WFirst: Quantity_AbsorbedDose, WLast: Quantity_AbsorbedDose): void;
  Surface(): Handle_Adaptor3d_HSurface;
  Iso(): GeomAbs_IsoType;
  Parameter(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

  export declare class Adaptor3d_IsoCurve_1 extends Adaptor3d_IsoCurve {
    constructor();
  }

  export declare class Adaptor3d_IsoCurve_2 extends Adaptor3d_IsoCurve {
    constructor(S: Handle_Adaptor3d_HSurface);
  }

  export declare class Adaptor3d_IsoCurve_3 extends Adaptor3d_IsoCurve {
    constructor(S: Handle_Adaptor3d_HSurface, Iso: GeomAbs_IsoType, Param: Quantity_AbsorbedDose);
  }

  export declare class Adaptor3d_IsoCurve_4 extends Adaptor3d_IsoCurve {
    constructor(S: Handle_Adaptor3d_HSurface, Iso: GeomAbs_IsoType, Param: Quantity_AbsorbedDose, WFirst: Quantity_AbsorbedDose, WLast: Quantity_AbsorbedDose);
  }

export declare class Vrml_ShapeHints {
  constructor(aVertexOrdering: Vrml_VertexOrdering, aShapeType: Vrml_ShapeType, aFaceType: Vrml_FaceType, aAngle: Quantity_AbsorbedDose)
  SetVertexOrdering(aVertexOrdering: Vrml_VertexOrdering): void;
  VertexOrdering(): Vrml_VertexOrdering;
  SetShapeType(aShapeType: Vrml_ShapeType): void;
  ShapeType(): Vrml_ShapeType;
  SetFaceType(aFaceType: Vrml_FaceType): void;
  FaceType(): Vrml_FaceType;
  SetAngle(aAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_Vrml_IndexedLineSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_IndexedLineSet): void;
  get(): Vrml_IndexedLineSet;
  delete(): void;
}

  export declare class Handle_Vrml_IndexedLineSet_1 extends Handle_Vrml_IndexedLineSet {
    constructor();
  }

  export declare class Handle_Vrml_IndexedLineSet_2 extends Handle_Vrml_IndexedLineSet {
    constructor(thePtr: Vrml_IndexedLineSet);
  }

  export declare class Handle_Vrml_IndexedLineSet_3 extends Handle_Vrml_IndexedLineSet {
    constructor(theHandle: Handle_Vrml_IndexedLineSet);
  }

  export declare class Handle_Vrml_IndexedLineSet_4 extends Handle_Vrml_IndexedLineSet {
    constructor(theHandle: Handle_Vrml_IndexedLineSet);
  }

export declare class Vrml_IndexedLineSet extends Standard_Transient {
  SetCoordIndex(aCoordIndex: Handle_TColStd_HArray1OfInteger): void;
  CoordIndex(): Handle_TColStd_HArray1OfInteger;
  SetMaterialIndex(aMaterialIndex: Handle_TColStd_HArray1OfInteger): void;
  MaterialIndex(): Handle_TColStd_HArray1OfInteger;
  SetNormalIndex(aNormalIndex: Handle_TColStd_HArray1OfInteger): void;
  NormalIndex(): Handle_TColStd_HArray1OfInteger;
  SetTextureCoordIndex(aTextureCoordIndex: Handle_TColStd_HArray1OfInteger): void;
  TextureCoordIndex(): Handle_TColStd_HArray1OfInteger;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_IndexedLineSet_1 extends Vrml_IndexedLineSet {
    constructor(aCoordIndex: Handle_TColStd_HArray1OfInteger, aMaterialIndex: Handle_TColStd_HArray1OfInteger, aNormalIndex: Handle_TColStd_HArray1OfInteger, aTextureCoordIndex: Handle_TColStd_HArray1OfInteger);
  }

  export declare class Vrml_IndexedLineSet_2 extends Vrml_IndexedLineSet {
    constructor();
  }

export declare class Vrml_Switch {
  constructor(aWhichChild: Graphic3d_ZLayerId)
  SetWhichChild(aWhichChild: Graphic3d_ZLayerId): void;
  WhichChild(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare type Vrml_MaterialBindingAndNormalBinding = {
  Vrml_DEFAULT: {};
  Vrml_OVERALL: {};
  Vrml_PER_PART: {};
  Vrml_PER_PART_INDEXED: {};
  Vrml_PER_FACE: {};
  Vrml_PER_FACE_INDEXED: {};
  Vrml_PER_VERTEX: {};
  Vrml_PER_VERTEX_INDEXED: {};
}

export declare class Vrml_Info {
  constructor(aString: XCAFDoc_PartId)
  SetString(aString: XCAFDoc_PartId): void;
  String(): XCAFDoc_PartId;
  delete(): void;
}

export declare type Vrml_SeparatorRenderCulling = {
  Vrml_OFF: {};
  Vrml_ON: {};
  Vrml_AUTO: {};
}

export declare class Vrml_PointLight {
  SetOnOff(aOnOff: Standard_Boolean): void;
  OnOff(): Standard_Boolean;
  SetIntensity(aIntensity: Quantity_AbsorbedDose): void;
  Intensity(): Quantity_AbsorbedDose;
  SetColor(aColor: Quantity_Color): void;
  Color(): Quantity_Color;
  SetLocation(aLocation: gp_Vec): void;
  Location(): gp_Vec;
  delete(): void;
}

  export declare class Vrml_PointLight_1 extends Vrml_PointLight {
    constructor();
  }

  export declare class Vrml_PointLight_2 extends Vrml_PointLight {
    constructor(aOnOff: Standard_Boolean, aIntensity: Quantity_AbsorbedDose, aColor: Quantity_Color, aLocation: gp_Vec);
  }

export declare type Vrml_VertexOrdering = {
  Vrml_UNKNOWN_ORDERING: {};
  Vrml_CLOCKWISE: {};
  Vrml_COUNTERCLOCKWISE: {};
}

export declare type Vrml_SFImageNumber = {
  Vrml_NULL: {};
  Vrml_ONE: {};
  Vrml_TWO: {};
  Vrml_THREE: {};
  Vrml_FOUR: {};
}

export declare type Vrml_AsciiTextJustification = {
  Vrml_LEFT: {};
  Vrml_CENTER: {};
  Vrml_RIGHT: {};
}

export declare class Vrml_DirectionalLight {
  SetOnOff(aOnOff: Standard_Boolean): void;
  OnOff(): Standard_Boolean;
  SetIntensity(aIntensity: Quantity_AbsorbedDose): void;
  Intensity(): Quantity_AbsorbedDose;
  SetColor(aColor: Quantity_Color): void;
  Color(): Quantity_Color;
  SetDirection(aDirection: gp_Vec): void;
  Direction(): gp_Vec;
  delete(): void;
}

  export declare class Vrml_DirectionalLight_1 extends Vrml_DirectionalLight {
    constructor();
  }

  export declare class Vrml_DirectionalLight_2 extends Vrml_DirectionalLight {
    constructor(aOnOff: Standard_Boolean, aIntensity: Quantity_AbsorbedDose, aColor: Quantity_Color, aDirection: gp_Vec);
  }

export declare class Vrml {
  constructor();
  delete(): void;
}

export declare type Vrml_ConeParts = {
  Vrml_ConeSIDES: {};
  Vrml_ConeBOTTOM: {};
  Vrml_ConeALL: {};
}

export declare class Vrml_Cube {
  constructor(aWidth: Quantity_AbsorbedDose, aHeight: Quantity_AbsorbedDose, aDepth: Quantity_AbsorbedDose)
  SetWidth(aWidth: Quantity_AbsorbedDose): void;
  Width(): Quantity_AbsorbedDose;
  SetHeight(aHeight: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  SetDepth(aDepth: Quantity_AbsorbedDose): void;
  Depth(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Vrml_Scale {
  SetScaleFactor(aScaleFactor: gp_Vec): void;
  ScaleFactor(): gp_Vec;
  delete(): void;
}

  export declare class Vrml_Scale_1 extends Vrml_Scale {
    constructor();
  }

  export declare class Vrml_Scale_2 extends Vrml_Scale {
    constructor(aScaleFactor: gp_Vec);
  }

export declare class Vrml_PerspectiveCamera {
  SetPosition(aPosition: gp_Vec): void;
  Position(): gp_Vec;
  SetOrientation(aOrientation: Vrml_SFRotation): void;
  Orientation(): Vrml_SFRotation;
  SetFocalDistance(aFocalDistance: Quantity_AbsorbedDose): void;
  FocalDistance(): Quantity_AbsorbedDose;
  SetAngle(aHeightAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Vrml_PerspectiveCamera_1 extends Vrml_PerspectiveCamera {
    constructor();
  }

  export declare class Vrml_PerspectiveCamera_2 extends Vrml_PerspectiveCamera {
    constructor(aPosition: gp_Vec, aOrientation: Vrml_SFRotation, aFocalDistance: Quantity_AbsorbedDose, aHeightAngle: Quantity_AbsorbedDose);
  }

export declare class Vrml_Transform {
  SetTranslation(aTranslation: gp_Vec): void;
  Translation(): gp_Vec;
  SetRotation(aRotation: Vrml_SFRotation): void;
  Rotation(): Vrml_SFRotation;
  SetScaleFactor(aScaleFactor: gp_Vec): void;
  ScaleFactor(): gp_Vec;
  SetScaleOrientation(aScaleOrientation: Vrml_SFRotation): void;
  ScaleOrientation(): Vrml_SFRotation;
  SetCenter(aCenter: gp_Vec): void;
  Center(): gp_Vec;
  delete(): void;
}

  export declare class Vrml_Transform_1 extends Vrml_Transform {
    constructor();
  }

  export declare class Vrml_Transform_2 extends Vrml_Transform {
    constructor(aTranslation: gp_Vec, aRotation: Vrml_SFRotation, aScaleFactor: gp_Vec, aScaleOrientation: Vrml_SFRotation, aCenter: gp_Vec);
  }

export declare class Vrml_Texture2Transform {
  SetTranslation(aTranslation: gp_Vec2d): void;
  Translation(): gp_Vec2d;
  SetRotation(aRotation: Quantity_AbsorbedDose): void;
  Rotation(): Quantity_AbsorbedDose;
  SetScaleFactor(aScaleFactor: gp_Vec2d): void;
  ScaleFactor(): gp_Vec2d;
  SetCenter(aCenter: gp_Vec2d): void;
  Center(): gp_Vec2d;
  delete(): void;
}

  export declare class Vrml_Texture2Transform_1 extends Vrml_Texture2Transform {
    constructor();
  }

  export declare class Vrml_Texture2Transform_2 extends Vrml_Texture2Transform {
    constructor(aTranslation: gp_Vec2d, aRotation: Quantity_AbsorbedDose, aScaleFactor: gp_Vec2d, aCenter: gp_Vec2d);
  }

export declare type Vrml_FontStyleFamily = {
  Vrml_SERIF: {};
  Vrml_SANS: {};
  Vrml_TYPEWRITER: {};
}

export declare class Vrml_Group {
  constructor()
  delete(): void;
}

export declare class Vrml_OrthographicCamera {
  SetPosition(aPosition: gp_Vec): void;
  Position(): gp_Vec;
  SetOrientation(aOrientation: Vrml_SFRotation): void;
  Orientation(): Vrml_SFRotation;
  SetFocalDistance(aFocalDistance: Quantity_AbsorbedDose): void;
  FocalDistance(): Quantity_AbsorbedDose;
  SetHeight(aHeight: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Vrml_OrthographicCamera_1 extends Vrml_OrthographicCamera {
    constructor();
  }

  export declare class Vrml_OrthographicCamera_2 extends Vrml_OrthographicCamera {
    constructor(aPosition: gp_Vec, aOrientation: Vrml_SFRotation, aFocalDistance: Quantity_AbsorbedDose, aHeight: Quantity_AbsorbedDose);
  }

export declare class Handle_Vrml_TextureCoordinate2 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_TextureCoordinate2): void;
  get(): Vrml_TextureCoordinate2;
  delete(): void;
}

  export declare class Handle_Vrml_TextureCoordinate2_1 extends Handle_Vrml_TextureCoordinate2 {
    constructor();
  }

  export declare class Handle_Vrml_TextureCoordinate2_2 extends Handle_Vrml_TextureCoordinate2 {
    constructor(thePtr: Vrml_TextureCoordinate2);
  }

  export declare class Handle_Vrml_TextureCoordinate2_3 extends Handle_Vrml_TextureCoordinate2 {
    constructor(theHandle: Handle_Vrml_TextureCoordinate2);
  }

  export declare class Handle_Vrml_TextureCoordinate2_4 extends Handle_Vrml_TextureCoordinate2 {
    constructor(theHandle: Handle_Vrml_TextureCoordinate2);
  }

export declare class Vrml_TextureCoordinate2 extends Standard_Transient {
  SetPoint(aPoint: Handle_TColgp_HArray1OfVec2d): void;
  Point(): Handle_TColgp_HArray1OfVec2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_TextureCoordinate2_1 extends Vrml_TextureCoordinate2 {
    constructor();
  }

  export declare class Vrml_TextureCoordinate2_2 extends Vrml_TextureCoordinate2 {
    constructor(aPoint: Handle_TColgp_HArray1OfVec2d);
  }

export declare type Vrml_Texture2Wrap = {
  Vrml_REPEAT: {};
  Vrml_CLAMP: {};
}

export declare class Vrml_LOD extends Standard_Transient {
  SetRange(aRange: Handle_TColStd_HArray1OfReal): void;
  Range(): Handle_TColStd_HArray1OfReal;
  SetCenter(aCenter: gp_Vec): void;
  Center(): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_LOD_1 extends Vrml_LOD {
    constructor();
  }

  export declare class Vrml_LOD_2 extends Vrml_LOD {
    constructor(aRange: Handle_TColStd_HArray1OfReal, aCenter: gp_Vec);
  }

export declare class Handle_Vrml_LOD {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_LOD): void;
  get(): Vrml_LOD;
  delete(): void;
}

  export declare class Handle_Vrml_LOD_1 extends Handle_Vrml_LOD {
    constructor();
  }

  export declare class Handle_Vrml_LOD_2 extends Handle_Vrml_LOD {
    constructor(thePtr: Vrml_LOD);
  }

  export declare class Handle_Vrml_LOD_3 extends Handle_Vrml_LOD {
    constructor(theHandle: Handle_Vrml_LOD);
  }

  export declare class Handle_Vrml_LOD_4 extends Handle_Vrml_LOD {
    constructor(theHandle: Handle_Vrml_LOD);
  }

export declare type Vrml_FaceType = {
  Vrml_UNKNOWN_FACE_TYPE: {};
  Vrml_CONVEX: {};
}

export declare class Vrml_PointSet {
  constructor(aStartIndex: Graphic3d_ZLayerId, aNumPoints: Graphic3d_ZLayerId)
  SetStartIndex(aStartIndex: Graphic3d_ZLayerId): void;
  StartIndex(): Graphic3d_ZLayerId;
  SetNumPoints(aNumPoints: Graphic3d_ZLayerId): void;
  NumPoints(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Vrml_Material extends Standard_Transient {
  SetAmbientColor(aAmbientColor: Handle_Quantity_HArray1OfColor): void;
  AmbientColor(): Handle_Quantity_HArray1OfColor;
  SetDiffuseColor(aDiffuseColor: Handle_Quantity_HArray1OfColor): void;
  DiffuseColor(): Handle_Quantity_HArray1OfColor;
  SetSpecularColor(aSpecularColor: Handle_Quantity_HArray1OfColor): void;
  SpecularColor(): Handle_Quantity_HArray1OfColor;
  SetEmissiveColor(aEmissiveColor: Handle_Quantity_HArray1OfColor): void;
  EmissiveColor(): Handle_Quantity_HArray1OfColor;
  SetShininess(aShininess: Handle_TColStd_HArray1OfReal): void;
  Shininess(): Handle_TColStd_HArray1OfReal;
  SetTransparency(aTransparency: Handle_TColStd_HArray1OfReal): void;
  Transparency(): Handle_TColStd_HArray1OfReal;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_Material_1 extends Vrml_Material {
    constructor(aAmbientColor: Handle_Quantity_HArray1OfColor, aDiffuseColor: Handle_Quantity_HArray1OfColor, aSpecularColor: Handle_Quantity_HArray1OfColor, aEmissiveColor: Handle_Quantity_HArray1OfColor, aShininess: Handle_TColStd_HArray1OfReal, aTransparency: Handle_TColStd_HArray1OfReal);
  }

  export declare class Vrml_Material_2 extends Vrml_Material {
    constructor();
  }

export declare class Handle_Vrml_Material {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_Material): void;
  get(): Vrml_Material;
  delete(): void;
}

  export declare class Handle_Vrml_Material_1 extends Handle_Vrml_Material {
    constructor();
  }

  export declare class Handle_Vrml_Material_2 extends Handle_Vrml_Material {
    constructor(thePtr: Vrml_Material);
  }

  export declare class Handle_Vrml_Material_3 extends Handle_Vrml_Material {
    constructor(theHandle: Handle_Vrml_Material);
  }

  export declare class Handle_Vrml_Material_4 extends Handle_Vrml_Material {
    constructor(theHandle: Handle_Vrml_Material);
  }

export declare class Vrml_WWWInline {
  SetName(aName: XCAFDoc_PartId): void;
  Name(): XCAFDoc_PartId;
  SetBboxSize(aBboxSize: gp_Vec): void;
  BboxSize(): gp_Vec;
  SetBboxCenter(aBboxCenter: gp_Vec): void;
  BboxCenter(): gp_Vec;
  delete(): void;
}

  export declare class Vrml_WWWInline_1 extends Vrml_WWWInline {
    constructor();
  }

  export declare class Vrml_WWWInline_2 extends Vrml_WWWInline {
    constructor(aName: XCAFDoc_PartId, aBboxSize: gp_Vec, aBboxCenter: gp_Vec);
  }

export declare class Handle_Vrml_Coordinate3 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_Coordinate3): void;
  get(): Vrml_Coordinate3;
  delete(): void;
}

  export declare class Handle_Vrml_Coordinate3_1 extends Handle_Vrml_Coordinate3 {
    constructor();
  }

  export declare class Handle_Vrml_Coordinate3_2 extends Handle_Vrml_Coordinate3 {
    constructor(thePtr: Vrml_Coordinate3);
  }

  export declare class Handle_Vrml_Coordinate3_3 extends Handle_Vrml_Coordinate3 {
    constructor(theHandle: Handle_Vrml_Coordinate3);
  }

  export declare class Handle_Vrml_Coordinate3_4 extends Handle_Vrml_Coordinate3 {
    constructor(theHandle: Handle_Vrml_Coordinate3);
  }

export declare class Vrml_Coordinate3 extends Standard_Transient {
  SetPoint(aPoint: Handle_TColgp_HArray1OfVec): void;
  Point(): Handle_TColgp_HArray1OfVec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_Coordinate3_1 extends Vrml_Coordinate3 {
    constructor(aPoint: Handle_TColgp_HArray1OfVec);
  }

  export declare class Vrml_Coordinate3_2 extends Vrml_Coordinate3 {
    constructor();
  }

export declare type Vrml_ShapeType = {
  Vrml_UNKNOWN_SHAPE_TYPE: {};
  Vrml_SOLID: {};
}

export declare class Vrml_MaterialBinding {
  SetValue(aValue: Vrml_MaterialBindingAndNormalBinding): void;
  Value(): Vrml_MaterialBindingAndNormalBinding;
  delete(): void;
}

  export declare class Vrml_MaterialBinding_1 extends Vrml_MaterialBinding {
    constructor(aValue: Vrml_MaterialBindingAndNormalBinding);
  }

  export declare class Vrml_MaterialBinding_2 extends Vrml_MaterialBinding {
    constructor();
  }

export declare class Handle_Vrml_IndexedFaceSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_IndexedFaceSet): void;
  get(): Vrml_IndexedFaceSet;
  delete(): void;
}

  export declare class Handle_Vrml_IndexedFaceSet_1 extends Handle_Vrml_IndexedFaceSet {
    constructor();
  }

  export declare class Handle_Vrml_IndexedFaceSet_2 extends Handle_Vrml_IndexedFaceSet {
    constructor(thePtr: Vrml_IndexedFaceSet);
  }

  export declare class Handle_Vrml_IndexedFaceSet_3 extends Handle_Vrml_IndexedFaceSet {
    constructor(theHandle: Handle_Vrml_IndexedFaceSet);
  }

  export declare class Handle_Vrml_IndexedFaceSet_4 extends Handle_Vrml_IndexedFaceSet {
    constructor(theHandle: Handle_Vrml_IndexedFaceSet);
  }

export declare class Vrml_IndexedFaceSet extends Standard_Transient {
  SetCoordIndex(aCoordIndex: Handle_TColStd_HArray1OfInteger): void;
  CoordIndex(): Handle_TColStd_HArray1OfInteger;
  SetMaterialIndex(aMaterialIndex: Handle_TColStd_HArray1OfInteger): void;
  MaterialIndex(): Handle_TColStd_HArray1OfInteger;
  SetNormalIndex(aNormalIndex: Handle_TColStd_HArray1OfInteger): void;
  NormalIndex(): Handle_TColStd_HArray1OfInteger;
  SetTextureCoordIndex(aTextureCoordIndex: Handle_TColStd_HArray1OfInteger): void;
  TextureCoordIndex(): Handle_TColStd_HArray1OfInteger;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_IndexedFaceSet_1 extends Vrml_IndexedFaceSet {
    constructor(aCoordIndex: Handle_TColStd_HArray1OfInteger, aMaterialIndex: Handle_TColStd_HArray1OfInteger, aNormalIndex: Handle_TColStd_HArray1OfInteger, aTextureCoordIndex: Handle_TColStd_HArray1OfInteger);
  }

  export declare class Vrml_IndexedFaceSet_2 extends Vrml_IndexedFaceSet {
    constructor();
  }

export declare class Vrml_Separator {
  SetRenderCulling(aRenderCulling: Vrml_SeparatorRenderCulling): void;
  RenderCulling(): Vrml_SeparatorRenderCulling;
  delete(): void;
}

  export declare class Vrml_Separator_1 extends Vrml_Separator {
    constructor(aRenderCulling: Vrml_SeparatorRenderCulling);
  }

  export declare class Vrml_Separator_2 extends Vrml_Separator {
    constructor();
  }

export declare class Vrml_Cylinder {
  constructor(aParts: Vrml_CylinderParts, aRadius: Quantity_AbsorbedDose, aHeight: Quantity_AbsorbedDose)
  SetParts(aParts: Vrml_CylinderParts): void;
  Parts(): Vrml_CylinderParts;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  SetHeight(aHeight: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Vrml_Rotation {
  SetRotation(aRotation: Vrml_SFRotation): void;
  Rotation(): Vrml_SFRotation;
  delete(): void;
}

  export declare class Vrml_Rotation_1 extends Vrml_Rotation {
    constructor();
  }

  export declare class Vrml_Rotation_2 extends Vrml_Rotation {
    constructor(aRotation: Vrml_SFRotation);
  }

export declare class Vrml_Translation {
  SetTranslation(aTranslation: gp_Vec): void;
  Translation(): gp_Vec;
  delete(): void;
}

  export declare class Vrml_Translation_1 extends Vrml_Translation {
    constructor();
  }

  export declare class Vrml_Translation_2 extends Vrml_Translation {
    constructor(aTranslation: gp_Vec);
  }

export declare type Vrml_CylinderParts = {
  Vrml_CylinderSIDES: {};
  Vrml_CylinderTOP: {};
  Vrml_CylinderBOTTOM: {};
  Vrml_CylinderALL: {};
}

export declare class Vrml_SpotLight {
  SetOnOff(anOnOff: Standard_Boolean): void;
  OnOff(): Standard_Boolean;
  SetIntensity(aIntensity: Quantity_AbsorbedDose): void;
  Intensity(): Quantity_AbsorbedDose;
  SetColor(aColor: Quantity_Color): void;
  Color(): Quantity_Color;
  SetLocation(aLocation: gp_Vec): void;
  Location(): gp_Vec;
  SetDirection(aDirection: gp_Vec): void;
  Direction(): gp_Vec;
  SetDropOffRate(aDropOffRate: Quantity_AbsorbedDose): void;
  DropOffRate(): Quantity_AbsorbedDose;
  SetCutOffAngle(aCutOffAngle: Quantity_AbsorbedDose): void;
  CutOffAngle(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Vrml_SpotLight_1 extends Vrml_SpotLight {
    constructor();
  }

  export declare class Vrml_SpotLight_2 extends Vrml_SpotLight {
    constructor(aOnOff: Standard_Boolean, aIntensity: Quantity_AbsorbedDose, aColor: Quantity_Color, aLocation: gp_Vec, aDirection: gp_Vec, aDropOffRate: Quantity_AbsorbedDose, aCutOffAngle: Quantity_AbsorbedDose);
  }

export declare class Handle_Vrml_SFImage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_SFImage): void;
  get(): Vrml_SFImage;
  delete(): void;
}

  export declare class Handle_Vrml_SFImage_1 extends Handle_Vrml_SFImage {
    constructor();
  }

  export declare class Handle_Vrml_SFImage_2 extends Handle_Vrml_SFImage {
    constructor(thePtr: Vrml_SFImage);
  }

  export declare class Handle_Vrml_SFImage_3 extends Handle_Vrml_SFImage {
    constructor(theHandle: Handle_Vrml_SFImage);
  }

  export declare class Handle_Vrml_SFImage_4 extends Handle_Vrml_SFImage {
    constructor(theHandle: Handle_Vrml_SFImage);
  }

export declare class Vrml_SFImage extends Standard_Transient {
  SetWidth(aWidth: Graphic3d_ZLayerId): void;
  Width(): Graphic3d_ZLayerId;
  SetHeight(aHeight: Graphic3d_ZLayerId): void;
  Height(): Graphic3d_ZLayerId;
  SetNumber(aNumber: Vrml_SFImageNumber): void;
  Number(): Vrml_SFImageNumber;
  SetArray(anArray: Handle_TColStd_HArray1OfInteger): void;
  Array(): Handle_TColStd_HArray1OfInteger;
  ArrayFlag(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_SFImage_1 extends Vrml_SFImage {
    constructor();
  }

  export declare class Vrml_SFImage_2 extends Vrml_SFImage {
    constructor(aWidth: Graphic3d_ZLayerId, aHeight: Graphic3d_ZLayerId, aNumber: Vrml_SFImageNumber, anArray: Handle_TColStd_HArray1OfInteger);
  }

export declare class Vrml_Cone {
  constructor(aParts: Vrml_ConeParts, aBottomRadius: Quantity_AbsorbedDose, aHeight: Quantity_AbsorbedDose)
  SetParts(aParts: Vrml_ConeParts): void;
  Parts(): Vrml_ConeParts;
  SetBottomRadius(aBottomRadius: Quantity_AbsorbedDose): void;
  BottomRadius(): Quantity_AbsorbedDose;
  SetHeight(aHeight: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_Vrml_Normal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_Normal): void;
  get(): Vrml_Normal;
  delete(): void;
}

  export declare class Handle_Vrml_Normal_1 extends Handle_Vrml_Normal {
    constructor();
  }

  export declare class Handle_Vrml_Normal_2 extends Handle_Vrml_Normal {
    constructor(thePtr: Vrml_Normal);
  }

  export declare class Handle_Vrml_Normal_3 extends Handle_Vrml_Normal {
    constructor(theHandle: Handle_Vrml_Normal);
  }

  export declare class Handle_Vrml_Normal_4 extends Handle_Vrml_Normal {
    constructor(theHandle: Handle_Vrml_Normal);
  }

export declare class Vrml_Normal extends Standard_Transient {
  SetVector(aVector: Handle_TColgp_HArray1OfVec): void;
  Vector(): Handle_TColgp_HArray1OfVec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_Normal_1 extends Vrml_Normal {
    constructor(aVector: Handle_TColgp_HArray1OfVec);
  }

  export declare class Vrml_Normal_2 extends Vrml_Normal {
    constructor();
  }

export declare class Vrml_TransformSeparator {
  constructor()
  delete(): void;
}

export declare class Vrml_Sphere {
  constructor(aRadius: Quantity_AbsorbedDose)
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Vrml_AsciiText extends Standard_Transient {
  SetString(aString: Handle_TColStd_HArray1OfAsciiString): void;
  String(): Handle_TColStd_HArray1OfAsciiString;
  SetSpacing(aSpacing: Quantity_AbsorbedDose): void;
  Spacing(): Quantity_AbsorbedDose;
  SetJustification(aJustification: Vrml_AsciiTextJustification): void;
  Justification(): Vrml_AsciiTextJustification;
  SetWidth(aWidth: Quantity_AbsorbedDose): void;
  Width(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Vrml_AsciiText_1 extends Vrml_AsciiText {
    constructor();
  }

  export declare class Vrml_AsciiText_2 extends Vrml_AsciiText {
    constructor(aString: Handle_TColStd_HArray1OfAsciiString, aSpacing: Quantity_AbsorbedDose, aJustification: Vrml_AsciiTextJustification, aWidth: Quantity_AbsorbedDose);
  }

export declare class Handle_Vrml_AsciiText {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Vrml_AsciiText): void;
  get(): Vrml_AsciiText;
  delete(): void;
}

  export declare class Handle_Vrml_AsciiText_1 extends Handle_Vrml_AsciiText {
    constructor();
  }

  export declare class Handle_Vrml_AsciiText_2 extends Handle_Vrml_AsciiText {
    constructor(thePtr: Vrml_AsciiText);
  }

  export declare class Handle_Vrml_AsciiText_3 extends Handle_Vrml_AsciiText {
    constructor(theHandle: Handle_Vrml_AsciiText);
  }

  export declare class Handle_Vrml_AsciiText_4 extends Handle_Vrml_AsciiText {
    constructor(theHandle: Handle_Vrml_AsciiText);
  }

export declare class Vrml_MatrixTransform {
  SetMatrix(aMatrix: gp_Trsf): void;
  Matrix(): gp_Trsf;
  delete(): void;
}

  export declare class Vrml_MatrixTransform_1 extends Vrml_MatrixTransform {
    constructor();
  }

  export declare class Vrml_MatrixTransform_2 extends Vrml_MatrixTransform {
    constructor(aMatrix: gp_Trsf);
  }

export declare class Vrml_WWWAnchor {
  constructor(aName: XCAFDoc_PartId, aDescription: XCAFDoc_PartId, aMap: Vrml_WWWAnchorMap)
  SetName(aName: XCAFDoc_PartId): void;
  Name(): XCAFDoc_PartId;
  SetDescription(aDescription: XCAFDoc_PartId): void;
  Description(): XCAFDoc_PartId;
  SetMap(aMap: Vrml_WWWAnchorMap): void;
  Map(): Vrml_WWWAnchorMap;
  delete(): void;
}

export declare class Vrml_Texture2 {
  SetFilename(aFilename: XCAFDoc_PartId): void;
  Filename(): XCAFDoc_PartId;
  SetImage(aImage: Handle_Vrml_SFImage): void;
  Image(): Handle_Vrml_SFImage;
  SetWrapS(aWrapS: Vrml_Texture2Wrap): void;
  WrapS(): Vrml_Texture2Wrap;
  SetWrapT(aWrapT: Vrml_Texture2Wrap): void;
  WrapT(): Vrml_Texture2Wrap;
  delete(): void;
}

  export declare class Vrml_Texture2_1 extends Vrml_Texture2 {
    constructor();
  }

  export declare class Vrml_Texture2_2 extends Vrml_Texture2 {
    constructor(aFilename: XCAFDoc_PartId, aImage: Handle_Vrml_SFImage, aWrapS: Vrml_Texture2Wrap, aWrapT: Vrml_Texture2Wrap);
  }

export declare class Vrml_FontStyle {
  constructor(aSize: Quantity_AbsorbedDose, aFamily: Vrml_FontStyleFamily, aStyle: Vrml_FontStyleStyle)
  SetSize(aSize: Quantity_AbsorbedDose): void;
  Size(): Quantity_AbsorbedDose;
  SetFamily(aFamily: Vrml_FontStyleFamily): void;
  Family(): Vrml_FontStyleFamily;
  SetStyle(aStyle: Vrml_FontStyleStyle): void;
  Style(): Vrml_FontStyleStyle;
  delete(): void;
}

export declare class Vrml_NormalBinding {
  SetValue(aValue: Vrml_MaterialBindingAndNormalBinding): void;
  Value(): Vrml_MaterialBindingAndNormalBinding;
  delete(): void;
}

  export declare class Vrml_NormalBinding_1 extends Vrml_NormalBinding {
    constructor(aValue: Vrml_MaterialBindingAndNormalBinding);
  }

  export declare class Vrml_NormalBinding_2 extends Vrml_NormalBinding {
    constructor();
  }

export declare class Vrml_Instancing {
  constructor(aString: XCAFDoc_PartId)
  delete(): void;
}

export declare class Vrml_SFRotation {
  SetRotationX(aRotationX: Quantity_AbsorbedDose): void;
  RotationX(): Quantity_AbsorbedDose;
  SetRotationY(aRotationY: Quantity_AbsorbedDose): void;
  RotationY(): Quantity_AbsorbedDose;
  SetRotationZ(aRotationZ: Quantity_AbsorbedDose): void;
  RotationZ(): Quantity_AbsorbedDose;
  SetAngle(anAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Vrml_SFRotation_1 extends Vrml_SFRotation {
    constructor();
  }

  export declare class Vrml_SFRotation_2 extends Vrml_SFRotation {
    constructor(aRotationX: Quantity_AbsorbedDose, aRotationY: Quantity_AbsorbedDose, aRotationZ: Quantity_AbsorbedDose, anAngle: Quantity_AbsorbedDose);
  }

export declare type Vrml_FontStyleStyle = {
  Vrml_NONE: {};
  Vrml_BOLD: {};
  Vrml_ITALIC: {};
}

export declare type Vrml_WWWAnchorMap = {
  Vrml_MAP_NONE: {};
  Vrml_POINT: {};
}

export declare class IGESCAFControl_Reader extends IGESControl_Reader {
  Transfer(theDoc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_1(theFileName: XCAFDoc_PartId, theDoc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_2(theFileName: Standard_CString, theDoc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  SetColorMode(theMode: Standard_Boolean): void;
  GetColorMode(): Standard_Boolean;
  SetNameMode(theMode: Standard_Boolean): void;
  GetNameMode(): Standard_Boolean;
  SetLayerMode(theMode: Standard_Boolean): void;
  GetLayerMode(): Standard_Boolean;
  delete(): void;
}

  export declare class IGESCAFControl_Reader_1 extends IGESCAFControl_Reader {
    constructor();
  }

  export declare class IGESCAFControl_Reader_2 extends IGESCAFControl_Reader {
    constructor(theWS: Handle_XSControl_WorkSession, FromScratch: Standard_Boolean);
  }

export declare class IGESCAFControl_Writer extends IGESControl_Writer {
  Transfer_1(doc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  Transfer_2(labels: TDF_LabelSequence, theProgress: Message_ProgressRange): Standard_Boolean;
  Transfer_3(label: TDF_Label, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_1(doc: Handle_TDocStd_Document, filename: XCAFDoc_PartId, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_2(doc: Handle_TDocStd_Document, filename: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  SetColorMode(colormode: Standard_Boolean): void;
  GetColorMode(): Standard_Boolean;
  SetNameMode(namemode: Standard_Boolean): void;
  GetNameMode(): Standard_Boolean;
  SetLayerMode(layermode: Standard_Boolean): void;
  GetLayerMode(): Standard_Boolean;
  delete(): void;
}

  export declare class IGESCAFControl_Writer_1 extends IGESCAFControl_Writer {
    constructor();
  }

  export declare class IGESCAFControl_Writer_2 extends IGESCAFControl_Writer {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class IGESCAFControl {
  constructor();
  static DecodeColor(col: Graphic3d_ZLayerId): Quantity_Color;
  static EncodeColor(col: Quantity_Color): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class GeomConvert_BSplineSurfaceKnotSplitting {
  constructor(BasisSurface: Handle_Geom_BSplineSurface, UContinuityRange: Graphic3d_ZLayerId, VContinuityRange: Graphic3d_ZLayerId)
  NbUSplits(): Graphic3d_ZLayerId;
  NbVSplits(): Graphic3d_ZLayerId;
  Splitting(USplit: TColStd_Array1OfInteger, VSplit: TColStd_Array1OfInteger): void;
  USplitValue(UIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  VSplitValue(VIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class GeomConvert_CompCurveToBSplineCurve {
  Add_1(NewCurve: Handle_Geom_BoundedCurve, Tolerance: Quantity_AbsorbedDose, After: Standard_Boolean, WithRatio: Standard_Boolean, MinM: Graphic3d_ZLayerId): Standard_Boolean;
  BSplineCurve(): Handle_Geom_BSplineCurve;
  Clear(): void;
  delete(): void;
}

  export declare class GeomConvert_CompCurveToBSplineCurve_1 extends GeomConvert_CompCurveToBSplineCurve {
    constructor(Parameterisation: Convert_ParameterisationType);
  }

  export declare class GeomConvert_CompCurveToBSplineCurve_2 extends GeomConvert_CompCurveToBSplineCurve {
    constructor(BasisCurve: Handle_Geom_BoundedCurve, Parameterisation: Convert_ParameterisationType);
  }

export declare class GeomConvert_ApproxCurve {
  Curve(): Handle_Geom_BSplineCurve;
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  MaxError(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class GeomConvert_ApproxCurve_1 extends GeomConvert_ApproxCurve {
    constructor(Curve: Handle_Geom_Curve, Tol3d: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId);
  }

  export declare class GeomConvert_ApproxCurve_2 extends GeomConvert_ApproxCurve {
    constructor(Curve: Handle_Adaptor3d_HCurve, Tol3d: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId);
  }

export declare class GeomConvert_CompBezierSurfacesToBSplineSurface {
  NbUKnots(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  Poles(): Handle_TColgp_HArray2OfPnt;
  UKnots(): Handle_TColStd_HArray1OfReal;
  UDegree(): Graphic3d_ZLayerId;
  VKnots(): Handle_TColStd_HArray1OfReal;
  VDegree(): Graphic3d_ZLayerId;
  UMultiplicities(): Handle_TColStd_HArray1OfInteger;
  VMultiplicities(): Handle_TColStd_HArray1OfInteger;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class GeomConvert_CompBezierSurfacesToBSplineSurface_1 extends GeomConvert_CompBezierSurfacesToBSplineSurface {
    constructor(Beziers: TColGeom_Array2OfBezierSurface);
  }

  export declare class GeomConvert_CompBezierSurfacesToBSplineSurface_2 extends GeomConvert_CompBezierSurfacesToBSplineSurface {
    constructor(Beziers: TColGeom_Array2OfBezierSurface, Tolerance: Quantity_AbsorbedDose, RemoveKnots: Standard_Boolean);
  }

  export declare class GeomConvert_CompBezierSurfacesToBSplineSurface_3 extends GeomConvert_CompBezierSurfacesToBSplineSurface {
    constructor(Beziers: TColGeom_Array2OfBezierSurface, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UContinuity: GeomAbs_Shape, VContinuity: GeomAbs_Shape, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GeomConvert {
  constructor();
  static SplitBSplineCurve_1(C: Handle_Geom_BSplineCurve, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, SameOrientation: Standard_Boolean): Handle_Geom_BSplineCurve;
  static SplitBSplineCurve_2(C: Handle_Geom_BSplineCurve, FromU1: Quantity_AbsorbedDose, ToU2: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, SameOrientation: Standard_Boolean): Handle_Geom_BSplineCurve;
  static SplitBSplineSurface_1(S: Handle_Geom_BSplineSurface, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId, SameUOrientation: Standard_Boolean, SameVOrientation: Standard_Boolean): Handle_Geom_BSplineSurface;
  static SplitBSplineSurface_2(S: Handle_Geom_BSplineSurface, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, USplit: Standard_Boolean, SameOrientation: Standard_Boolean): Handle_Geom_BSplineSurface;
  static SplitBSplineSurface_3(S: Handle_Geom_BSplineSurface, FromU1: Quantity_AbsorbedDose, ToU2: Quantity_AbsorbedDose, FromV1: Quantity_AbsorbedDose, ToV2: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, SameUOrientation: Standard_Boolean, SameVOrientation: Standard_Boolean): Handle_Geom_BSplineSurface;
  static SplitBSplineSurface_4(S: Handle_Geom_BSplineSurface, FromParam1: Quantity_AbsorbedDose, ToParam2: Quantity_AbsorbedDose, USplit: Standard_Boolean, ParametricTolerance: Quantity_AbsorbedDose, SameOrientation: Standard_Boolean): Handle_Geom_BSplineSurface;
  static CurveToBSplineCurve(C: Handle_Geom_Curve, Parameterisation: Convert_ParameterisationType): Handle_Geom_BSplineCurve;
  static SurfaceToBSplineSurface(S: Handle_Geom_Surface): Handle_Geom_BSplineSurface;
  static ConcatG1(ArrayOfCurves: TColGeom_Array1OfBSplineCurve, ArrayOfToler: TColStd_Array1OfReal, ArrayOfConcatenated: Handle_TColGeom_HArray1OfBSplineCurve, ClosedFlag: Standard_Boolean, ClosedTolerance: Quantity_AbsorbedDose): void;
  static ConcatC1_1(ArrayOfCurves: TColGeom_Array1OfBSplineCurve, ArrayOfToler: TColStd_Array1OfReal, ArrayOfIndices: Handle_TColStd_HArray1OfInteger, ArrayOfConcatenated: Handle_TColGeom_HArray1OfBSplineCurve, ClosedFlag: Standard_Boolean, ClosedTolerance: Quantity_AbsorbedDose): void;
  static ConcatC1_2(ArrayOfCurves: TColGeom_Array1OfBSplineCurve, ArrayOfToler: TColStd_Array1OfReal, ArrayOfIndices: Handle_TColStd_HArray1OfInteger, ArrayOfConcatenated: Handle_TColGeom_HArray1OfBSplineCurve, ClosedFlag: Standard_Boolean, ClosedTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): void;
  static C0BSplineToC1BSplineCurve(BS: Handle_Geom_BSplineCurve, tolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): void;
  static C0BSplineToArrayOfC1BSplineCurve_1(BS: Handle_Geom_BSplineCurve, tabBS: Handle_TColGeom_HArray1OfBSplineCurve, tolerance: Quantity_AbsorbedDose): void;
  static C0BSplineToArrayOfC1BSplineCurve_2(BS: Handle_Geom_BSplineCurve, tabBS: Handle_TColGeom_HArray1OfBSplineCurve, AngularTolerance: Quantity_AbsorbedDose, tolerance: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomConvert_BSplineSurfaceToBezierSurface {
  Patch(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): Handle_Geom_BezierSurface;
  Patches(Surfaces: TColGeom_Array2OfBezierSurface): void;
  UKnots(TKnots: TColStd_Array1OfReal): void;
  VKnots(TKnots: TColStd_Array1OfReal): void;
  NbUPatches(): Graphic3d_ZLayerId;
  NbVPatches(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class GeomConvert_BSplineSurfaceToBezierSurface_1 extends GeomConvert_BSplineSurfaceToBezierSurface {
    constructor(BasisSurface: Handle_Geom_BSplineSurface);
  }

  export declare class GeomConvert_BSplineSurfaceToBezierSurface_2 extends GeomConvert_BSplineSurfaceToBezierSurface {
    constructor(BasisSurface: Handle_Geom_BSplineSurface, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose);
  }

export declare class GeomConvert_BSplineCurveKnotSplitting {
  constructor(BasisCurve: Handle_Geom_BSplineCurve, ContinuityRange: Graphic3d_ZLayerId)
  NbSplits(): Graphic3d_ZLayerId;
  Splitting(SplitValues: TColStd_Array1OfInteger): void;
  SplitValue(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class GeomConvert_BSplineCurveToBezierCurve {
  Arc(Index: Graphic3d_ZLayerId): Handle_Geom_BezierCurve;
  Arcs(Curves: TColGeom_Array1OfBezierCurve): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  NbArcs(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class GeomConvert_BSplineCurveToBezierCurve_1 extends GeomConvert_BSplineCurveToBezierCurve {
    constructor(BasisCurve: Handle_Geom_BSplineCurve);
  }

  export declare class GeomConvert_BSplineCurveToBezierCurve_2 extends GeomConvert_BSplineCurveToBezierCurve {
    constructor(BasisCurve: Handle_Geom_BSplineCurve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose);
  }

export declare class GeomConvert_ApproxSurface {
  Surface(): Handle_Geom_BSplineSurface;
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  MaxError(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class GeomConvert_ApproxSurface_1 extends GeomConvert_ApproxSurface {
    constructor(Surf: Handle_Geom_Surface, Tol3d: Quantity_AbsorbedDose, UContinuity: GeomAbs_Shape, VContinuity: GeomAbs_Shape, MaxDegU: Graphic3d_ZLayerId, MaxDegV: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId, PrecisCode: Graphic3d_ZLayerId);
  }

  export declare class GeomConvert_ApproxSurface_2 extends GeomConvert_ApproxSurface {
    constructor(Surf: Handle_Adaptor3d_HSurface, Tol3d: Quantity_AbsorbedDose, UContinuity: GeomAbs_Shape, VContinuity: GeomAbs_Shape, MaxDegU: Graphic3d_ZLayerId, MaxDegV: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId, PrecisCode: Graphic3d_ZLayerId);
  }

export declare class DsgPrs_SymbPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, OffsetPoint: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_EllipseRadiusPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, AttachmentPoint: gp_Pnt, anEndOfArrow: gp_Pnt, aCenter: gp_Pnt, IsMaxRadius: Standard_Boolean, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, anEllipse: gp_Elips, AttachmentPoint: gp_Pnt, anEndOfArrow: gp_Pnt, aCenter: gp_Pnt, uFirst: Quantity_AbsorbedDose, IsInDomain: Standard_Boolean, IsMaxRadius: Standard_Boolean, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_3(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aCurve: Handle_Geom_OffsetCurve, AttachmentPoint: gp_Pnt, anEndOfArrow: gp_Pnt, aCenter: gp_Pnt, uFirst: Quantity_AbsorbedDose, IsInDomain: Standard_Boolean, IsMaxRadius: Standard_Boolean, ArrowSide: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class DsgPrs_FilletRadiusPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, thevalue: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aPosition: gp_Pnt, aNormalDir: gp_Dir, aBasePnt: gp_Pnt, aFirstPoint: gp_Pnt, aSecondPoint: gp_Pnt, aCenter: gp_Pnt, ArrowPrs: DsgPrs_ArrowSide, drawRevers: Standard_Boolean, DrawPosition: gp_Pnt, EndOfArrow: gp_Pnt, TrimCurve: Handle_Geom_TrimmedCurve, HasCircle: Standard_Boolean): void;
  delete(): void;
}

export declare class DsgPrs_TangentPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, OffsetPoint: gp_Pnt, aDirection: gp_Dir, aLength: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class DsgPrs_XYZAxisPresentation {
  constructor();
  static Add_1(aPresentation: any, anLineAspect: Handle_Prs3d_LineAspect, aDir: gp_Dir, aVal: Quantity_AbsorbedDose, aText: Standard_CString, aPfirst: gp_Pnt, aPlast: gp_Pnt): void;
  static Add_2(aPresentation: any, aLineAspect: Handle_Prs3d_LineAspect, anArrowAspect: Handle_Prs3d_ArrowAspect, aTextAspect: Handle_Prs3d_TextAspect, aDir: gp_Dir, aVal: Quantity_AbsorbedDose, aText: Standard_CString, aPfirst: gp_Pnt, aPlast: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_ConcentricPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aCenter: gp_Pnt, aRadius: Quantity_AbsorbedDose, aNorm: gp_Dir, aPoint: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_ShadedPlanePresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aPt1: gp_Pnt, aPt2: gp_Pnt, aPt3: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_Chamf2dPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aPntAttach: gp_Pnt, aPntEnd: gp_Pnt, aText: TCollection_ExtendedString): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aPntAttach: gp_Pnt, aPntEnd: gp_Pnt, aText: TCollection_ExtendedString, ArrowSide: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class DsgPrs_DiameterPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint: gp_Pnt, aCircle: gp_Circ, ArrowSide: DsgPrs_ArrowSide, IsDiamSymbol: Standard_Boolean): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint: gp_Pnt, aCircle: gp_Circ, uFirst: Quantity_AbsorbedDose, uLast: Quantity_AbsorbedDose, ArrowSide: DsgPrs_ArrowSide, IsDiamSymbol: Standard_Boolean): void;
  delete(): void;
}

export declare class DsgPrs_DatumPrs extends Prs3d_Root {
  constructor();
  static Add(thePresentation: any, theDatum: gp_Ax2, theDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare class DsgPrs_ParalPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, OffsetPoint: gp_Pnt): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, OffsetPoint: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class DsgPrs_SymmetricPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection1: gp_Dir, aAxis: gp_Lin, OffsetPoint: gp_Pnt): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aCircle1: gp_Circ, aAxis: gp_Lin, OffsetPoint: gp_Pnt): void;
  static Add_3(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aAxis: gp_Lin, OffsetPoint: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_PerpenPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, pAx1: gp_Pnt, pAx2: gp_Pnt, pnt1: gp_Pnt, pnt2: gp_Pnt, OffsetPoint: gp_Pnt, intOut1: Standard_Boolean, intOut2: Standard_Boolean): void;
  delete(): void;
}

export declare class DsgPrs {
  constructor();
  static ComputeSymbol(aPresentation: any, anAspect: Handle_Prs3d_DimensionAspect, pt1: gp_Pnt, pt2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, ArrowSide: DsgPrs_ArrowSide, drawFromCenter: Standard_Boolean): void;
  static ComputePlanarFacesLengthPresentation(FirstArrowLength: Quantity_AbsorbedDose, SecondArrowLength: Quantity_AbsorbedDose, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, DirAttach: gp_Dir, OffsetPoint: gp_Pnt, PlaneOfFaces: gp_Pln, EndOfArrow1: gp_Pnt, EndOfArrow2: gp_Pnt, DirOfArrow1: gp_Dir): void;
  static ComputeCurvilinearFacesLengthPresentation(FirstArrowLength: Quantity_AbsorbedDose, SecondArrowLength: Quantity_AbsorbedDose, SecondSurf: Handle_Geom_Surface, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, DirAttach: gp_Dir, EndOfArrow2: gp_Pnt, DirOfArrow1: gp_Dir, VCurve: Handle_Geom_Curve, UCurve: Handle_Geom_Curve, FirstU: Quantity_AbsorbedDose, deltaU: Quantity_AbsorbedDose, FirstV: Quantity_AbsorbedDose, deltaV: Quantity_AbsorbedDose): void;
  static ComputeFacesAnglePresentation(ArrowLength: Quantity_AbsorbedDose, Value: Quantity_AbsorbedDose, CenterPoint: gp_Pnt, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, axisdir: gp_Dir, isPlane: Standard_Boolean, AxisOfSurf: gp_Ax1, OffsetPoint: gp_Pnt, AngleCirc: gp_Circ, FirstParAngleCirc: Quantity_AbsorbedDose, LastParAngleCirc: Quantity_AbsorbedDose, EndOfArrow1: gp_Pnt, EndOfArrow2: gp_Pnt, DirOfArrow1: gp_Dir, DirOfArrow2: gp_Dir, ProjAttachPoint2: gp_Pnt, AttachCirc: gp_Circ, FirstParAttachCirc: Quantity_AbsorbedDose, LastParAttachCirc: Quantity_AbsorbedDose): void;
  static ComputeRadiusLine(aCenter: gp_Pnt, anEndOfArrow: gp_Pnt, aPosition: gp_Pnt, drawFromCenter: Standard_Boolean, aRadLineOrign: gp_Pnt, aRadLineEnd: gp_Pnt): void;
  static ComputeFilletRadiusPresentation(ArrowLength: Quantity_AbsorbedDose, Value: Quantity_AbsorbedDose, Position: gp_Pnt, NormalDir: gp_Dir, FirstPoint: gp_Pnt, SecondPoint: gp_Pnt, Center: gp_Pnt, BasePnt: gp_Pnt, drawRevers: Standard_Boolean, SpecCase: Standard_Boolean, FilletCirc: gp_Circ, FirstParCirc: Quantity_AbsorbedDose, LastParCirc: Quantity_AbsorbedDose, EndOfArrow: gp_Pnt, DirOfArrow: gp_Dir, DrawPosition: gp_Pnt): void;
  static DistanceFromApex(elips: gp_Elips, Apex: gp_Pnt, par: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class DsgPrs_OffsetPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, aDirection2: gp_Dir, OffsetPoint: gp_Pnt): void;
  static AddAxes(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, aDirection2: gp_Dir, OffsetPoint: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_EqualDistancePresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, Point1: gp_Pnt, Point2: gp_Pnt, Point3: gp_Pnt, Point4: gp_Pnt, Plane: Handle_Geom_Plane): void;
  static AddInterval(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aPoint1: gp_Pnt, aPoint2: gp_Pnt, aDir: gp_Dir, aPosition: gp_Pnt, anArrowSide: DsgPrs_ArrowSide, anExtremePnt1: gp_Pnt, anExtremePnt2: gp_Pnt): void;
  static AddIntervalBetweenTwoArcs(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aCircle1: gp_Circ, aCircle2: gp_Circ, aPoint1: gp_Pnt, aPoint2: gp_Pnt, aPoint3: gp_Pnt, aPoint4: gp_Pnt, anArrowSide: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class DsgPrs_MidPointPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theAxe: gp_Ax2, MidPoint: gp_Pnt, Position: gp_Pnt, AttachPoint: gp_Pnt, first: Standard_Boolean): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theAxe: gp_Ax2, MidPoint: gp_Pnt, Position: gp_Pnt, AttachPoint: gp_Pnt, Point1: gp_Pnt, Point2: gp_Pnt, first: Standard_Boolean): void;
  static Add_3(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aCircle: gp_Circ, MidPoint: gp_Pnt, Position: gp_Pnt, AttachPoint: gp_Pnt, Point1: gp_Pnt, Point2: gp_Pnt, first: Standard_Boolean): void;
  static Add_4(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, anElips: gp_Elips, MidPoint: gp_Pnt, Position: gp_Pnt, AttachPoint: gp_Pnt, Point1: gp_Pnt, Point2: gp_Pnt, first: Standard_Boolean): void;
  delete(): void;
}

export declare type DsgPrs_ArrowSide = {
  DsgPrs_AS_NONE: {};
  DsgPrs_AS_FIRSTAR: {};
  DsgPrs_AS_LASTAR: {};
  DsgPrs_AS_BOTHAR: {};
  DsgPrs_AS_FIRSTPT: {};
  DsgPrs_AS_LASTPT: {};
  DsgPrs_AS_BOTHPT: {};
  DsgPrs_AS_FIRSTAR_LASTPT: {};
  DsgPrs_AS_FIRSTPT_LASTAR: {};
}

export declare class DsgPrs_AnglePresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aVal: Quantity_AbsorbedDose, aText: TCollection_ExtendedString, aCircle: gp_Circ, aPosition: gp_Pnt, Apex: gp_Pnt, VminCircle: gp_Circ, VmaxCircle: gp_Circ, aArrowSize: Quantity_AbsorbedDose): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, CenterPoint: gp_Pnt, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, OffsetPoint: gp_Pnt): void;
  static Add_3(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, thevalstring: TCollection_ExtendedString, CenterPoint: gp_Pnt, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, OffsetPoint: gp_Pnt): void;
  static Add_4(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, thevalstring: TCollection_ExtendedString, CenterPoint: gp_Pnt, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, OffsetPoint: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_5(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, thevalstring: TCollection_ExtendedString, CenterPoint: gp_Pnt, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, axisdir: gp_Dir, OffsetPoint: gp_Pnt): void;
  static Add_6(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, thevalstring: TCollection_ExtendedString, CenterPoint: gp_Pnt, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, dir1: gp_Dir, dir2: gp_Dir, axisdir: gp_Dir, isPlane: Standard_Boolean, AxisOfSurf: gp_Ax1, OffsetPoint: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_7(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, theval: Quantity_AbsorbedDose, theCenter: gp_Pnt, AttachmentPoint1: gp_Pnt, theAxe: gp_Ax1, ArrowSide: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class DsgPrs_FixPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aPntAttach: gp_Pnt, aPntEnd: gp_Pnt, aNormPln: gp_Dir, aSymbSize: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class DsgPrs_IdenticPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, aPntAttach: gp_Pnt, aPntOffset: gp_Pnt): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, aFAttach: gp_Pnt, aSAttach: gp_Pnt, aPntOffset: gp_Pnt): void;
  static Add_3(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, aAx2: gp_Ax2, aCenter: gp_Pnt, aFAttach: gp_Pnt, aSAttach: gp_Pnt, aPntOffset: gp_Pnt): void;
  static Add_4(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, aAx2: gp_Ax2, aCenter: gp_Pnt, aFAttach: gp_Pnt, aSAttach: gp_Pnt, aPntOffset: gp_Pnt, aPntOnCirc: gp_Pnt): void;
  static Add_5(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, anEllipse: gp_Elips, aFAttach: gp_Pnt, aSAttach: gp_Pnt, aPntOffset: gp_Pnt, aPntOnElli: gp_Pnt): void;
  delete(): void;
}

export declare class DsgPrs_EqualRadiusPresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, FirstCenter: gp_Pnt, SecondCenter: gp_Pnt, FirstPoint: gp_Pnt, SecondPoint: gp_Pnt, Plane: Handle_Geom_Plane): void;
  delete(): void;
}

export declare class DsgPrs_ShapeDirPresentation {
  constructor();
  static Add(prs: any, aDrawer: Handle_Prs3d_Drawer, shape: TopoDS_Shape, mode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class DsgPrs_LengthPresentation {
  constructor();
  static Add_1(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, OffsetPoint: gp_Pnt): void;
  static Add_2(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, OffsetPoint: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_3(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, PlaneOfFaces: gp_Pln, aDirection: gp_Dir, OffsetPoint: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_4(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aText: TCollection_ExtendedString, SecondSurf: Handle_Geom_Surface, AttachmentPoint1: gp_Pnt, AttachmentPoint2: gp_Pnt, aDirection: gp_Dir, OffsetPoint: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  static Add_5(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, Pt1: gp_Pnt, Pt2: gp_Pnt, ArrowSide: DsgPrs_ArrowSide): void;
  delete(): void;
}

export declare class DsgPrs_XYZPlanePresentation {
  constructor();
  static Add(aPresentation: any, aDrawer: Handle_Prs3d_Drawer, aPt1: gp_Pnt, aPt2: gp_Pnt, aPt3: gp_Pnt): void;
  delete(): void;
}

export declare type AdvApp2Var_CriterionType = {
  AdvApp2Var_Absolute: {};
  AdvApp2Var_Relative: {};
}

export declare class Namelist {
  constructor();
  delete(): void;
}

export declare class Vardesc {
  constructor();
  delete(): void;
}

export declare class AdvApp2Var_SequenceOfStrip extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: AdvApp2Var_SequenceOfStrip): AdvApp2Var_SequenceOfStrip;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: AdvApp2Var_Strip): void;
  Append_2(theSeq: AdvApp2Var_SequenceOfStrip): void;
  Prepend_1(theItem: AdvApp2Var_Strip): void;
  Prepend_2(theSeq: AdvApp2Var_SequenceOfStrip): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: AdvApp2Var_Strip): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: AdvApp2Var_SequenceOfStrip): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: AdvApp2Var_SequenceOfStrip): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: AdvApp2Var_Strip): void;
  Split(theIndex: Standard_Integer, theSeq: AdvApp2Var_SequenceOfStrip): void;
  First(): AdvApp2Var_Strip;
  ChangeFirst(): AdvApp2Var_Strip;
  Last(): AdvApp2Var_Strip;
  ChangeLast(): AdvApp2Var_Strip;
  Value(theIndex: Standard_Integer): AdvApp2Var_Strip;
  ChangeValue(theIndex: Standard_Integer): AdvApp2Var_Strip;
  SetValue(theIndex: Standard_Integer, theItem: AdvApp2Var_Strip): void;
  delete(): void;
}

  export declare class AdvApp2Var_SequenceOfStrip_1 extends AdvApp2Var_SequenceOfStrip {
    constructor();
  }

  export declare class AdvApp2Var_SequenceOfStrip_2 extends AdvApp2Var_SequenceOfStrip {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class AdvApp2Var_SequenceOfStrip_3 extends AdvApp2Var_SequenceOfStrip {
    constructor(theOther: AdvApp2Var_SequenceOfStrip);
  }

export declare type AdvApp2Var_CriterionRepartition = {
  AdvApp2Var_Regular: {};
  AdvApp2Var_Incremental: {};
}

export declare class mlgdrtl_1_ {
  constructor();
  delete(): void;
}

export declare class mmapgs1_1_ {
  constructor();
  delete(): void;
}

export declare class maovpar_1_ {
  constructor();
  delete(): void;
}

export declare class mmjcobi_1_ {
  constructor();
  delete(): void;
}

export declare class mmapgs0_1_ {
  constructor();
  delete(): void;
}

export declare class minombr_1_ {
  constructor();
  delete(): void;
}

export declare class mmapgss_1_ {
  constructor();
  delete(): void;
}

export declare class maovpch_1_ {
  constructor();
  delete(): void;
}

export declare class mmapgs2_1_ {
  constructor();
  delete(): void;
}

export declare class mdnombr_1_ {
  constructor();
  delete(): void;
}

export declare class mmcmcnp_1_ {
  constructor();
  delete(): void;
}

export declare class RWStepShape_RWTransitionalShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_TransitionalShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_TransitionalShapeRepresentation): void;
  Share(ent: Handle_StepShape_TransitionalShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWShapeDimensionRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ShapeDimensionRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ShapeDimensionRepresentation): void;
  Share(ent: Handle_StepShape_ShapeDimensionRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWConnectedEdgeSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ConnectedEdgeSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ConnectedEdgeSet): void;
  Share(ent: Handle_StepShape_ConnectedEdgeSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWShellBasedSurfaceModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ShellBasedSurfaceModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ShellBasedSurfaceModel): void;
  Share(ent: Handle_StepShape_ShellBasedSurfaceModel, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWOrientedClosedShell {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_OrientedClosedShell): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_OrientedClosedShell): void;
  Share(ent: Handle_StepShape_OrientedClosedShell, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ShapeRepresentation): void;
  Share(ent: Handle_StepShape_ShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWBoxedHalfSpace {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_BoxedHalfSpace): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_BoxedHalfSpace): void;
  Share(ent: Handle_StepShape_BoxedHalfSpace, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWHalfSpaceSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_HalfSpaceSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_HalfSpaceSolid): void;
  Share(ent: Handle_StepShape_HalfSpaceSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWVertexPoint {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_VertexPoint): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_VertexPoint): void;
  Share(ent: Handle_StepShape_VertexPoint, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWContextDependentShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ContextDependentShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ContextDependentShapeRepresentation): void;
  Share(ent: Handle_StepShape_ContextDependentShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWValueFormatTypeQualifier {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ValueFormatTypeQualifier): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ValueFormatTypeQualifier): void;
  delete(): void;
}

export declare class RWStepShape_RWDimensionalCharacteristicRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_DimensionalCharacteristicRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_DimensionalCharacteristicRepresentation): void;
  Share(ent: Handle_StepShape_DimensionalCharacteristicRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWToleranceValue {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ToleranceValue): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ToleranceValue): void;
  Share(ent: Handle_StepShape_ToleranceValue, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSeamEdge {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_SeamEdge): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_SeamEdge): void;
  Share(ent: Handle_StepShape_SeamEdge, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWTorus {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Torus): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Torus): void;
  Share(ent: Handle_StepShape_Torus, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWDefinitionalRepresentationAndShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation): void;
  Share(ent: Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWDimensionalSizeWithPath {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_DimensionalSizeWithPath): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_DimensionalSizeWithPath): void;
  Share(ent: Handle_StepShape_DimensionalSizeWithPath, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWGeometricallyBoundedSurfaceShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation): void;
  Share(ent: Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWOrientedOpenShell {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_OrientedOpenShell): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_OrientedOpenShell): void;
  Share(ent: Handle_StepShape_OrientedOpenShell, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSolidModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_SolidModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_SolidModel): void;
  delete(): void;
}

export declare class RWStepShape_RWOrientedPath {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_OrientedPath): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_OrientedPath): void;
  Share(ent: Handle_StepShape_OrientedPath, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSweptFaceSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_SweptFaceSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_SweptFaceSolid): void;
  Share(ent: Handle_StepShape_SweptFaceSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWManifoldSurfaceShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ManifoldSurfaceShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ManifoldSurfaceShapeRepresentation): void;
  Share(ent: Handle_StepShape_ManifoldSurfaceShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWQualifiedRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_QualifiedRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_QualifiedRepresentationItem): void;
  Share(ent: Handle_StepShape_QualifiedRepresentationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSolidReplica {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_SolidReplica): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_SolidReplica): void;
  Share(ent: Handle_StepShape_SolidReplica, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWManifoldSolidBrep {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ManifoldSolidBrep): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ManifoldSolidBrep): void;
  Share(ent: Handle_StepShape_ManifoldSolidBrep, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWAngularLocation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_AngularLocation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_AngularLocation): void;
  Share(ent: Handle_StepShape_AngularLocation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWMeasureQualification {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_MeasureQualification): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_MeasureQualification): void;
  Share(ent: Handle_StepShape_MeasureQualification, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWExtrudedAreaSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ExtrudedAreaSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ExtrudedAreaSolid): void;
  Share(ent: Handle_StepShape_ExtrudedAreaSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSphere {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Sphere): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Sphere): void;
  Share(ent: Handle_StepShape_Sphere, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWEdgeBasedWireframeModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_EdgeBasedWireframeModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_EdgeBasedWireframeModel): void;
  Share(ent: Handle_StepShape_EdgeBasedWireframeModel, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWFaceOuterBound {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_FaceOuterBound): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_FaceOuterBound): void;
  Share(ent: Handle_StepShape_FaceOuterBound, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWClosedShell {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ClosedShell): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ClosedShell): void;
  Share(ent: Handle_StepShape_ClosedShell, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWFacetedBrepShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_FacetedBrepShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_FacetedBrepShapeRepresentation): void;
  Share(ent: Handle_StepShape_FacetedBrepShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWCsgSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_CsgSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_CsgSolid): void;
  Share(ent: Handle_StepShape_CsgSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWNonManifoldSurfaceShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_NonManifoldSurfaceShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_NonManifoldSurfaceShapeRepresentation): void;
  Share(ent: Handle_StepShape_NonManifoldSurfaceShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWFaceBasedSurfaceModel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_FaceBasedSurfaceModel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_FaceBasedSurfaceModel): void;
  Share(ent: Handle_StepShape_FaceBasedSurfaceModel, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWTypeQualifier {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_TypeQualifier): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_TypeQualifier): void;
  delete(): void;
}

export declare class RWStepShape_RWPrecisionQualifier {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_PrecisionQualifier): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_PrecisionQualifier): void;
  delete(): void;
}

export declare class RWStepShape_RWAdvancedBrepShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_AdvancedBrepShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_AdvancedBrepShapeRepresentation): void;
  Share(ent: Handle_StepShape_AdvancedBrepShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWConnectedFaceShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ConnectedFaceShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ConnectedFaceShapeRepresentation): void;
  Share(ent: Handle_StepShape_ConnectedFaceShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWTopologicalRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_TopologicalRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_TopologicalRepresentationItem): void;
  delete(): void;
}

export declare class RWStepShape_RWPolyLoop {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_PolyLoop): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_PolyLoop): void;
  Share(ent: Handle_StepShape_PolyLoop, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSubedge {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Subedge): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Subedge): void;
  Share(ent: Handle_StepShape_Subedge, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWVertexLoop {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_VertexLoop): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_VertexLoop): void;
  Share(ent: Handle_StepShape_VertexLoop, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWPlusMinusTolerance {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_PlusMinusTolerance): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_PlusMinusTolerance): void;
  Share(ent: Handle_StepShape_PlusMinusTolerance, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWFaceSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_FaceSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_FaceSurface): void;
  Share(ent: Handle_StepShape_FaceSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWConnectedFaceSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ConnectedFaceSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ConnectedFaceSet): void;
  Share(ent: Handle_StepShape_ConnectedFaceSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWOrientedFace {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_OrientedFace): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_OrientedFace): void;
  Share(ent: Handle_StepShape_OrientedFace, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWBooleanResult {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_BooleanResult): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_BooleanResult): void;
  Share(ent: Handle_StepShape_BooleanResult, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWExtrudedFaceSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ExtrudedFaceSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ExtrudedFaceSolid): void;
  Share(ent: Handle_StepShape_ExtrudedFaceSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWDimensionalLocationWithPath {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_DimensionalLocationWithPath): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_DimensionalLocationWithPath): void;
  Share(ent: Handle_StepShape_DimensionalLocationWithPath, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWPointRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_PointRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_PointRepresentation): void;
  Share(ent: Handle_StepShape_PointRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWGeometricallyBoundedWireframeShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation): void;
  Share(ent: Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWGeometricCurveSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_GeometricCurveSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_GeometricCurveSet): void;
  Share(ent: Handle_StepShape_GeometricCurveSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWCsgShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_CsgShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_CsgShapeRepresentation): void;
  Share(ent: Handle_StepShape_CsgShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSweptAreaSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_SweptAreaSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_SweptAreaSolid): void;
  Share(ent: Handle_StepShape_SweptAreaSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWShapeDefinitionRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ShapeDefinitionRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ShapeDefinitionRepresentation): void;
  Share(ent: Handle_StepShape_ShapeDefinitionRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWFace {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Face): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Face): void;
  Share(ent: Handle_StepShape_Face, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWLimitsAndFits {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_LimitsAndFits): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_LimitsAndFits): void;
  delete(): void;
}

export declare class RWStepShape_RWOpenShell {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_OpenShell): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_OpenShell): void;
  Share(ent: Handle_StepShape_OpenShell, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWLoop {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Loop): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Loop): void;
  delete(): void;
}

export declare class RWStepShape_RWRightAngularWedge {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_RightAngularWedge): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_RightAngularWedge): void;
  Share(ent: Handle_StepShape_RightAngularWedge, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWSubface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Subface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Subface): void;
  Share(ent: Handle_StepShape_Subface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWFacetedBrep {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_FacetedBrep): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_FacetedBrep): void;
  Share(ent: Handle_StepShape_FacetedBrep, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWRightCircularCylinder {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_RightCircularCylinder): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_RightCircularCylinder): void;
  Share(ent: Handle_StepShape_RightCircularCylinder, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWCompoundShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_CompoundShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_CompoundShapeRepresentation): void;
  Share(ent: Handle_StepShape_CompoundShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWLoopAndPath {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_LoopAndPath): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_LoopAndPath): void;
  Share(ent: Handle_StepShape_LoopAndPath, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWRightCircularCone {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_RightCircularCone): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_RightCircularCone): void;
  Share(ent: Handle_StepShape_RightCircularCone, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWPath {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Path): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Path): void;
  Share(ent: Handle_StepShape_Path, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWAngularSize {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_AngularSize): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_AngularSize): void;
  Share(ent: Handle_StepShape_AngularSize, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWEdge {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Edge): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Edge): void;
  Share(ent: Handle_StepShape_Edge, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWDimensionalLocation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_DimensionalLocation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_DimensionalLocation): void;
  Share(ent: Handle_StepShape_DimensionalLocation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWAdvancedFace {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_AdvancedFace): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_AdvancedFace): void;
  Share(ent: Handle_StepShape_AdvancedFace, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWEdgeBasedWireframeShapeRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_EdgeBasedWireframeShapeRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_EdgeBasedWireframeShapeRepresentation): void;
  Share(ent: Handle_StepShape_EdgeBasedWireframeShapeRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWBlock {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Block): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Block): void;
  Share(ent: Handle_StepShape_Block, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWConnectedFaceSubSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ConnectedFaceSubSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ConnectedFaceSubSet): void;
  Share(ent: Handle_StepShape_ConnectedFaceSubSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWOrientedEdge {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_OrientedEdge): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_OrientedEdge): void;
  Share(ent: Handle_StepShape_OrientedEdge, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWBoxDomain {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_BoxDomain): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_BoxDomain): void;
  Share(ent: Handle_StepShape_BoxDomain, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWShapeRepresentationWithParameters {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_ShapeRepresentationWithParameters): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_ShapeRepresentationWithParameters): void;
  Share(ent: Handle_StepShape_ShapeRepresentationWithParameters, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWVertex {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_Vertex): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_Vertex): void;
  delete(): void;
}

export declare class RWStepShape_RWFacetedBrepAndBrepWithVoids {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_FacetedBrepAndBrepWithVoids): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_FacetedBrepAndBrepWithVoids): void;
  Share(ent: Handle_StepShape_FacetedBrepAndBrepWithVoids, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWRevolvedFaceSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_RevolvedFaceSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_RevolvedFaceSolid): void;
  Share(ent: Handle_StepShape_RevolvedFaceSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWMeasureRepresentationItemAndQualifiedRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem): void;
  Share(ent: Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWRevolvedAreaSolid {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_RevolvedAreaSolid): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_RevolvedAreaSolid): void;
  Share(ent: Handle_StepShape_RevolvedAreaSolid, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWDimensionalSize {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_DimensionalSize): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_DimensionalSize): void;
  Share(ent: Handle_StepShape_DimensionalSize, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepShape_RWGeometricSet {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepShape_GeometricSet): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepShape_GeometricSet): void;
  Share(ent: Handle_StepShape_GeometricSet, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class XmlMDataStd_UAttributeDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_UAttributeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_UAttributeDriver): void;
  get(): XmlMDataStd_UAttributeDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_UAttributeDriver_1 extends Handle_XmlMDataStd_UAttributeDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_UAttributeDriver_2 extends Handle_XmlMDataStd_UAttributeDriver {
    constructor(thePtr: XmlMDataStd_UAttributeDriver);
  }

  export declare class Handle_XmlMDataStd_UAttributeDriver_3 extends Handle_XmlMDataStd_UAttributeDriver {
    constructor(theHandle: Handle_XmlMDataStd_UAttributeDriver);
  }

  export declare class Handle_XmlMDataStd_UAttributeDriver_4 extends Handle_XmlMDataStd_UAttributeDriver {
    constructor(theHandle: Handle_XmlMDataStd_UAttributeDriver);
  }

export declare class XmlMDataStd {
  constructor();
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, anMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class Handle_XmlMDataStd_ExtStringArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_ExtStringArrayDriver): void;
  get(): XmlMDataStd_ExtStringArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_ExtStringArrayDriver_1 extends Handle_XmlMDataStd_ExtStringArrayDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_ExtStringArrayDriver_2 extends Handle_XmlMDataStd_ExtStringArrayDriver {
    constructor(thePtr: XmlMDataStd_ExtStringArrayDriver);
  }

  export declare class Handle_XmlMDataStd_ExtStringArrayDriver_3 extends Handle_XmlMDataStd_ExtStringArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_ExtStringArrayDriver);
  }

  export declare class Handle_XmlMDataStd_ExtStringArrayDriver_4 extends Handle_XmlMDataStd_ExtStringArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_ExtStringArrayDriver);
  }

export declare class XmlMDataStd_ExtStringArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDataStd_RealDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_RealDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_RealDriver): void;
  get(): XmlMDataStd_RealDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_RealDriver_1 extends Handle_XmlMDataStd_RealDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_RealDriver_2 extends Handle_XmlMDataStd_RealDriver {
    constructor(thePtr: XmlMDataStd_RealDriver);
  }

  export declare class Handle_XmlMDataStd_RealDriver_3 extends Handle_XmlMDataStd_RealDriver {
    constructor(theHandle: Handle_XmlMDataStd_RealDriver);
  }

  export declare class Handle_XmlMDataStd_RealDriver_4 extends Handle_XmlMDataStd_RealDriver {
    constructor(theHandle: Handle_XmlMDataStd_RealDriver);
  }

export declare class XmlMDataStd_ReferenceArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_ReferenceArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_ReferenceArrayDriver): void;
  get(): XmlMDataStd_ReferenceArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_ReferenceArrayDriver_1 extends Handle_XmlMDataStd_ReferenceArrayDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_ReferenceArrayDriver_2 extends Handle_XmlMDataStd_ReferenceArrayDriver {
    constructor(thePtr: XmlMDataStd_ReferenceArrayDriver);
  }

  export declare class Handle_XmlMDataStd_ReferenceArrayDriver_3 extends Handle_XmlMDataStd_ReferenceArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_ReferenceArrayDriver);
  }

  export declare class Handle_XmlMDataStd_ReferenceArrayDriver_4 extends Handle_XmlMDataStd_ReferenceArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_ReferenceArrayDriver);
  }

export declare class Handle_XmlMDataStd_GenericEmptyDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_GenericEmptyDriver): void;
  get(): XmlMDataStd_GenericEmptyDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_GenericEmptyDriver_1 extends Handle_XmlMDataStd_GenericEmptyDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_GenericEmptyDriver_2 extends Handle_XmlMDataStd_GenericEmptyDriver {
    constructor(thePtr: XmlMDataStd_GenericEmptyDriver);
  }

  export declare class Handle_XmlMDataStd_GenericEmptyDriver_3 extends Handle_XmlMDataStd_GenericEmptyDriver {
    constructor(theHandle: Handle_XmlMDataStd_GenericEmptyDriver);
  }

  export declare class Handle_XmlMDataStd_GenericEmptyDriver_4 extends Handle_XmlMDataStd_GenericEmptyDriver {
    constructor(theHandle: Handle_XmlMDataStd_GenericEmptyDriver);
  }

export declare class XmlMDataStd_GenericEmptyDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  SourceType(): Handle_Standard_Type;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_BooleanArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_BooleanArrayDriver): void;
  get(): XmlMDataStd_BooleanArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_BooleanArrayDriver_1 extends Handle_XmlMDataStd_BooleanArrayDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_BooleanArrayDriver_2 extends Handle_XmlMDataStd_BooleanArrayDriver {
    constructor(thePtr: XmlMDataStd_BooleanArrayDriver);
  }

  export declare class Handle_XmlMDataStd_BooleanArrayDriver_3 extends Handle_XmlMDataStd_BooleanArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_BooleanArrayDriver);
  }

  export declare class Handle_XmlMDataStd_BooleanArrayDriver_4 extends Handle_XmlMDataStd_BooleanArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_BooleanArrayDriver);
  }

export declare class XmlMDataStd_BooleanArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDataStd_IntPackedMapDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_IntPackedMapDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_IntPackedMapDriver): void;
  get(): XmlMDataStd_IntPackedMapDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_IntPackedMapDriver_1 extends Handle_XmlMDataStd_IntPackedMapDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_IntPackedMapDriver_2 extends Handle_XmlMDataStd_IntPackedMapDriver {
    constructor(thePtr: XmlMDataStd_IntPackedMapDriver);
  }

  export declare class Handle_XmlMDataStd_IntPackedMapDriver_3 extends Handle_XmlMDataStd_IntPackedMapDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntPackedMapDriver);
  }

  export declare class Handle_XmlMDataStd_IntPackedMapDriver_4 extends Handle_XmlMDataStd_IntPackedMapDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntPackedMapDriver);
  }

export declare class Handle_XmlMDataStd_RealArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_RealArrayDriver): void;
  get(): XmlMDataStd_RealArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_RealArrayDriver_1 extends Handle_XmlMDataStd_RealArrayDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_RealArrayDriver_2 extends Handle_XmlMDataStd_RealArrayDriver {
    constructor(thePtr: XmlMDataStd_RealArrayDriver);
  }

  export declare class Handle_XmlMDataStd_RealArrayDriver_3 extends Handle_XmlMDataStd_RealArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_RealArrayDriver);
  }

  export declare class Handle_XmlMDataStd_RealArrayDriver_4 extends Handle_XmlMDataStd_RealArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_RealArrayDriver);
  }

export declare class XmlMDataStd_RealArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_IntegerListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_IntegerListDriver): void;
  get(): XmlMDataStd_IntegerListDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_IntegerListDriver_1 extends Handle_XmlMDataStd_IntegerListDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_IntegerListDriver_2 extends Handle_XmlMDataStd_IntegerListDriver {
    constructor(thePtr: XmlMDataStd_IntegerListDriver);
  }

  export declare class Handle_XmlMDataStd_IntegerListDriver_3 extends Handle_XmlMDataStd_IntegerListDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntegerListDriver);
  }

  export declare class Handle_XmlMDataStd_IntegerListDriver_4 extends Handle_XmlMDataStd_IntegerListDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntegerListDriver);
  }

export declare class XmlMDataStd_IntegerListDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_TreeNodeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_TreeNodeDriver): void;
  get(): XmlMDataStd_TreeNodeDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_TreeNodeDriver_1 extends Handle_XmlMDataStd_TreeNodeDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_TreeNodeDriver_2 extends Handle_XmlMDataStd_TreeNodeDriver {
    constructor(thePtr: XmlMDataStd_TreeNodeDriver);
  }

  export declare class Handle_XmlMDataStd_TreeNodeDriver_3 extends Handle_XmlMDataStd_TreeNodeDriver {
    constructor(theHandle: Handle_XmlMDataStd_TreeNodeDriver);
  }

  export declare class Handle_XmlMDataStd_TreeNodeDriver_4 extends Handle_XmlMDataStd_TreeNodeDriver {
    constructor(theHandle: Handle_XmlMDataStd_TreeNodeDriver);
  }

export declare class XmlMDataStd_TreeNodeDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_IntegerDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_IntegerDriver): void;
  get(): XmlMDataStd_IntegerDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_IntegerDriver_1 extends Handle_XmlMDataStd_IntegerDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_IntegerDriver_2 extends Handle_XmlMDataStd_IntegerDriver {
    constructor(thePtr: XmlMDataStd_IntegerDriver);
  }

  export declare class Handle_XmlMDataStd_IntegerDriver_3 extends Handle_XmlMDataStd_IntegerDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntegerDriver);
  }

  export declare class Handle_XmlMDataStd_IntegerDriver_4 extends Handle_XmlMDataStd_IntegerDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntegerDriver);
  }

export declare class XmlMDataStd_IntegerDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDataStd_AsciiStringDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_AsciiStringDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_AsciiStringDriver): void;
  get(): XmlMDataStd_AsciiStringDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_AsciiStringDriver_1 extends Handle_XmlMDataStd_AsciiStringDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_AsciiStringDriver_2 extends Handle_XmlMDataStd_AsciiStringDriver {
    constructor(thePtr: XmlMDataStd_AsciiStringDriver);
  }

  export declare class Handle_XmlMDataStd_AsciiStringDriver_3 extends Handle_XmlMDataStd_AsciiStringDriver {
    constructor(theHandle: Handle_XmlMDataStd_AsciiStringDriver);
  }

  export declare class Handle_XmlMDataStd_AsciiStringDriver_4 extends Handle_XmlMDataStd_AsciiStringDriver {
    constructor(theHandle: Handle_XmlMDataStd_AsciiStringDriver);
  }

export declare class Handle_XmlMDataStd_VariableDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_VariableDriver): void;
  get(): XmlMDataStd_VariableDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_VariableDriver_1 extends Handle_XmlMDataStd_VariableDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_VariableDriver_2 extends Handle_XmlMDataStd_VariableDriver {
    constructor(thePtr: XmlMDataStd_VariableDriver);
  }

  export declare class Handle_XmlMDataStd_VariableDriver_3 extends Handle_XmlMDataStd_VariableDriver {
    constructor(theHandle: Handle_XmlMDataStd_VariableDriver);
  }

  export declare class Handle_XmlMDataStd_VariableDriver_4 extends Handle_XmlMDataStd_VariableDriver {
    constructor(theHandle: Handle_XmlMDataStd_VariableDriver);
  }

export declare class XmlMDataStd_VariableDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_ExpressionDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_ExpressionDriver): void;
  get(): XmlMDataStd_ExpressionDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_ExpressionDriver_1 extends Handle_XmlMDataStd_ExpressionDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_ExpressionDriver_2 extends Handle_XmlMDataStd_ExpressionDriver {
    constructor(thePtr: XmlMDataStd_ExpressionDriver);
  }

  export declare class Handle_XmlMDataStd_ExpressionDriver_3 extends Handle_XmlMDataStd_ExpressionDriver {
    constructor(theHandle: Handle_XmlMDataStd_ExpressionDriver);
  }

  export declare class Handle_XmlMDataStd_ExpressionDriver_4 extends Handle_XmlMDataStd_ExpressionDriver {
    constructor(theHandle: Handle_XmlMDataStd_ExpressionDriver);
  }

export declare class XmlMDataStd_ExpressionDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_RealListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_RealListDriver): void;
  get(): XmlMDataStd_RealListDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_RealListDriver_1 extends Handle_XmlMDataStd_RealListDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_RealListDriver_2 extends Handle_XmlMDataStd_RealListDriver {
    constructor(thePtr: XmlMDataStd_RealListDriver);
  }

  export declare class Handle_XmlMDataStd_RealListDriver_3 extends Handle_XmlMDataStd_RealListDriver {
    constructor(theHandle: Handle_XmlMDataStd_RealListDriver);
  }

  export declare class Handle_XmlMDataStd_RealListDriver_4 extends Handle_XmlMDataStd_RealListDriver {
    constructor(theHandle: Handle_XmlMDataStd_RealListDriver);
  }

export declare class XmlMDataStd_RealListDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDataStd_GenericExtStringDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  SourceType(): Handle_Standard_Type;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_GenericExtStringDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_GenericExtStringDriver): void;
  get(): XmlMDataStd_GenericExtStringDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_GenericExtStringDriver_1 extends Handle_XmlMDataStd_GenericExtStringDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_GenericExtStringDriver_2 extends Handle_XmlMDataStd_GenericExtStringDriver {
    constructor(thePtr: XmlMDataStd_GenericExtStringDriver);
  }

  export declare class Handle_XmlMDataStd_GenericExtStringDriver_3 extends Handle_XmlMDataStd_GenericExtStringDriver {
    constructor(theHandle: Handle_XmlMDataStd_GenericExtStringDriver);
  }

  export declare class Handle_XmlMDataStd_GenericExtStringDriver_4 extends Handle_XmlMDataStd_GenericExtStringDriver {
    constructor(theHandle: Handle_XmlMDataStd_GenericExtStringDriver);
  }

export declare class XmlMDataStd_ExtStringListDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_ExtStringListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_ExtStringListDriver): void;
  get(): XmlMDataStd_ExtStringListDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_ExtStringListDriver_1 extends Handle_XmlMDataStd_ExtStringListDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_ExtStringListDriver_2 extends Handle_XmlMDataStd_ExtStringListDriver {
    constructor(thePtr: XmlMDataStd_ExtStringListDriver);
  }

  export declare class Handle_XmlMDataStd_ExtStringListDriver_3 extends Handle_XmlMDataStd_ExtStringListDriver {
    constructor(theHandle: Handle_XmlMDataStd_ExtStringListDriver);
  }

  export declare class Handle_XmlMDataStd_ExtStringListDriver_4 extends Handle_XmlMDataStd_ExtStringListDriver {
    constructor(theHandle: Handle_XmlMDataStd_ExtStringListDriver);
  }

export declare class XmlMDataStd_ByteArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_ByteArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_ByteArrayDriver): void;
  get(): XmlMDataStd_ByteArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_ByteArrayDriver_1 extends Handle_XmlMDataStd_ByteArrayDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_ByteArrayDriver_2 extends Handle_XmlMDataStd_ByteArrayDriver {
    constructor(thePtr: XmlMDataStd_ByteArrayDriver);
  }

  export declare class Handle_XmlMDataStd_ByteArrayDriver_3 extends Handle_XmlMDataStd_ByteArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_ByteArrayDriver);
  }

  export declare class Handle_XmlMDataStd_ByteArrayDriver_4 extends Handle_XmlMDataStd_ByteArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_ByteArrayDriver);
  }

export declare class XmlMDataStd_NamedDataDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_NamedDataDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_NamedDataDriver): void;
  get(): XmlMDataStd_NamedDataDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_NamedDataDriver_1 extends Handle_XmlMDataStd_NamedDataDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_NamedDataDriver_2 extends Handle_XmlMDataStd_NamedDataDriver {
    constructor(thePtr: XmlMDataStd_NamedDataDriver);
  }

  export declare class Handle_XmlMDataStd_NamedDataDriver_3 extends Handle_XmlMDataStd_NamedDataDriver {
    constructor(theHandle: Handle_XmlMDataStd_NamedDataDriver);
  }

  export declare class Handle_XmlMDataStd_NamedDataDriver_4 extends Handle_XmlMDataStd_NamedDataDriver {
    constructor(theHandle: Handle_XmlMDataStd_NamedDataDriver);
  }

export declare class XmlMDataStd_ReferenceListDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_ReferenceListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_ReferenceListDriver): void;
  get(): XmlMDataStd_ReferenceListDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_ReferenceListDriver_1 extends Handle_XmlMDataStd_ReferenceListDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_ReferenceListDriver_2 extends Handle_XmlMDataStd_ReferenceListDriver {
    constructor(thePtr: XmlMDataStd_ReferenceListDriver);
  }

  export declare class Handle_XmlMDataStd_ReferenceListDriver_3 extends Handle_XmlMDataStd_ReferenceListDriver {
    constructor(theHandle: Handle_XmlMDataStd_ReferenceListDriver);
  }

  export declare class Handle_XmlMDataStd_ReferenceListDriver_4 extends Handle_XmlMDataStd_ReferenceListDriver {
    constructor(theHandle: Handle_XmlMDataStd_ReferenceListDriver);
  }

export declare class Handle_XmlMDataStd_IntegerArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_IntegerArrayDriver): void;
  get(): XmlMDataStd_IntegerArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_IntegerArrayDriver_1 extends Handle_XmlMDataStd_IntegerArrayDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_IntegerArrayDriver_2 extends Handle_XmlMDataStd_IntegerArrayDriver {
    constructor(thePtr: XmlMDataStd_IntegerArrayDriver);
  }

  export declare class Handle_XmlMDataStd_IntegerArrayDriver_3 extends Handle_XmlMDataStd_IntegerArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntegerArrayDriver);
  }

  export declare class Handle_XmlMDataStd_IntegerArrayDriver_4 extends Handle_XmlMDataStd_IntegerArrayDriver {
    constructor(theHandle: Handle_XmlMDataStd_IntegerArrayDriver);
  }

export declare class XmlMDataStd_IntegerArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataStd_BooleanListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataStd_BooleanListDriver): void;
  get(): XmlMDataStd_BooleanListDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataStd_BooleanListDriver_1 extends Handle_XmlMDataStd_BooleanListDriver {
    constructor();
  }

  export declare class Handle_XmlMDataStd_BooleanListDriver_2 extends Handle_XmlMDataStd_BooleanListDriver {
    constructor(thePtr: XmlMDataStd_BooleanListDriver);
  }

  export declare class Handle_XmlMDataStd_BooleanListDriver_3 extends Handle_XmlMDataStd_BooleanListDriver {
    constructor(theHandle: Handle_XmlMDataStd_BooleanListDriver);
  }

  export declare class Handle_XmlMDataStd_BooleanListDriver_4 extends Handle_XmlMDataStd_BooleanListDriver {
    constructor(theHandle: Handle_XmlMDataStd_BooleanListDriver);
  }

export declare class XmlMDataStd_BooleanListDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ApproxInt_SvSurfaces {
  Compute(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Pt: gp_Pnt, Tg: gp_Vec, Tguv1: gp_Vec2d, Tguv2: gp_Vec2d): Standard_Boolean;
  Pnt(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, P: gp_Pnt): void;
  SeekPoint(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Point: IntSurf_PntOn2S): Standard_Boolean;
  Tangency(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec): Standard_Boolean;
  TangencyOnSurf1(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  TangencyOnSurf2(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  delete(): void;
}

export declare class ApproxInt_KnotTools {
  constructor();
  static BuildKnots(thePntsXYZ: TColgp_Array1OfPnt, thePntsU1V1: TColgp_Array1OfPnt2d, thePntsU2V2: TColgp_Array1OfPnt2d, thePars: math_Vector, theApproxXYZ: Standard_Boolean, theApproxU1V1: Standard_Boolean, theApproxU2V2: Standard_Boolean, theMinNbPnts: Graphic3d_ZLayerId, theKnots: NCollection_Vector<Standard_Integer>): void;
  delete(): void;
}

export declare class NCollection_BaseList {
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Allocator(): Handle_NCollection_BaseAllocator;
  delete(): void;
}

export declare class NCollection_BaseMap {
  NbBuckets(): Graphic3d_ZLayerId;
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Statistics(S: Standard_OStream): void;
  Allocator(): Handle_NCollection_BaseAllocator;
  delete(): void;
}

export declare class Handle_NCollection_WinHeapAllocator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_WinHeapAllocator): void;
  get(): NCollection_WinHeapAllocator;
  delete(): void;
}

  export declare class Handle_NCollection_WinHeapAllocator_1 extends Handle_NCollection_WinHeapAllocator {
    constructor();
  }

  export declare class Handle_NCollection_WinHeapAllocator_2 extends Handle_NCollection_WinHeapAllocator {
    constructor(thePtr: NCollection_WinHeapAllocator);
  }

  export declare class Handle_NCollection_WinHeapAllocator_3 extends Handle_NCollection_WinHeapAllocator {
    constructor(theHandle: Handle_NCollection_WinHeapAllocator);
  }

  export declare class Handle_NCollection_WinHeapAllocator_4 extends Handle_NCollection_WinHeapAllocator {
    constructor(theHandle: Handle_NCollection_WinHeapAllocator);
  }

export declare class NCollection_WinHeapAllocator extends NCollection_BaseAllocator {
  constructor(theInitSizeBytes: Standard_Size)
  Allocate(theSize: Standard_ThreadId): C_f;
  Free(theAddress: C_f): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class NCollection_HeapAllocator extends NCollection_BaseAllocator {
  Allocate(theSize: Standard_ThreadId): C_f;
  Free(anAddress: C_f): void;
  static GlobalHeapAllocator(): Handle_NCollection_HeapAllocator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NCollection_HeapAllocator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_HeapAllocator): void;
  get(): NCollection_HeapAllocator;
  delete(): void;
}

  export declare class Handle_NCollection_HeapAllocator_1 extends Handle_NCollection_HeapAllocator {
    constructor();
  }

  export declare class Handle_NCollection_HeapAllocator_2 extends Handle_NCollection_HeapAllocator {
    constructor(thePtr: NCollection_HeapAllocator);
  }

  export declare class Handle_NCollection_HeapAllocator_3 extends Handle_NCollection_HeapAllocator {
    constructor(theHandle: Handle_NCollection_HeapAllocator);
  }

  export declare class Handle_NCollection_HeapAllocator_4 extends Handle_NCollection_HeapAllocator {
    constructor(theHandle: Handle_NCollection_HeapAllocator);
  }

export declare class Handle_NCollection_BaseAllocator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_BaseAllocator): void;
  get(): NCollection_BaseAllocator;
  delete(): void;
}

  export declare class Handle_NCollection_BaseAllocator_1 extends Handle_NCollection_BaseAllocator {
    constructor();
  }

  export declare class Handle_NCollection_BaseAllocator_2 extends Handle_NCollection_BaseAllocator {
    constructor(thePtr: NCollection_BaseAllocator);
  }

  export declare class Handle_NCollection_BaseAllocator_3 extends Handle_NCollection_BaseAllocator {
    constructor(theHandle: Handle_NCollection_BaseAllocator);
  }

  export declare class Handle_NCollection_BaseAllocator_4 extends Handle_NCollection_BaseAllocator {
    constructor(theHandle: Handle_NCollection_BaseAllocator);
  }

export declare class NCollection_BaseAllocator extends Standard_Transient {
  Allocate(size: Standard_Size): C_f;
  Free(anAddress: C_f): void;
  static CommonBaseAllocator(): Handle_NCollection_BaseAllocator;
  static StandardCallBack(theIsAlloc: Standard_Boolean, theStorage: Standard_Address, theRoundSize: Standard_ThreadId, theSize: Standard_ThreadId): void;
  static PrintMemUsageStatistics(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class NCollection_BaseSequence {
  IsEmpty(): Standard_Boolean;
  Length(): Graphic3d_ZLayerId;
  Allocator(): Handle_NCollection_BaseAllocator;
  delete(): void;
}

export declare class NCollection_AccAllocator extends NCollection_BaseAllocator {
  constructor(theBlockSize: Standard_Size)
  Allocate(theSize: Standard_Size): C_f;
  Free(theAddress: C_f): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NCollection_AccAllocator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_AccAllocator): void;
  get(): NCollection_AccAllocator;
  delete(): void;
}

  export declare class Handle_NCollection_AccAllocator_1 extends Handle_NCollection_AccAllocator {
    constructor();
  }

  export declare class Handle_NCollection_AccAllocator_2 extends Handle_NCollection_AccAllocator {
    constructor(thePtr: NCollection_AccAllocator);
  }

  export declare class Handle_NCollection_AccAllocator_3 extends Handle_NCollection_AccAllocator {
    constructor(theHandle: Handle_NCollection_AccAllocator);
  }

  export declare class Handle_NCollection_AccAllocator_4 extends Handle_NCollection_AccAllocator {
    constructor(theHandle: Handle_NCollection_AccAllocator);
  }

export declare class NCollection_BaseVector {
  Clear(): void;
  SetIncrement(aIncrement: Graphic3d_ZLayerId): void;
  Allocator(): Handle_NCollection_BaseAllocator;
  delete(): void;
}

export declare class NCollection_Buffer extends Standard_Transient {
  constructor(theAlloc: Handle_NCollection_BaseAllocator, theSize: Standard_ThreadId, theData: Standard_Byte)
  Data(): Standard_Byte;
  ChangeData(): Standard_Byte;
  IsEmpty(): Standard_Boolean;
  Size(): Standard_ThreadId;
  Allocator(): Handle_NCollection_BaseAllocator;
  SetAllocator(theAlloc: Handle_NCollection_BaseAllocator): void;
  Allocate(theSize: Standard_ThreadId): Standard_Boolean;
  Free(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NCollection_Buffer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_Buffer): void;
  get(): NCollection_Buffer;
  delete(): void;
}

  export declare class Handle_NCollection_Buffer_1 extends Handle_NCollection_Buffer {
    constructor();
  }

  export declare class Handle_NCollection_Buffer_2 extends Handle_NCollection_Buffer {
    constructor(thePtr: NCollection_Buffer);
  }

  export declare class Handle_NCollection_Buffer_3 extends Handle_NCollection_Buffer {
    constructor(theHandle: Handle_NCollection_Buffer);
  }

  export declare class Handle_NCollection_Buffer_4 extends Handle_NCollection_Buffer {
    constructor(theHandle: Handle_NCollection_Buffer);
  }

export declare class NCollection_AlignedAllocator extends NCollection_BaseAllocator {
  constructor(theAlignment: Standard_Size)
  Allocate(theSize: Standard_Size): C_f;
  Free(thePtr: C_f): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NCollection_AlignedAllocator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_AlignedAllocator): void;
  get(): NCollection_AlignedAllocator;
  delete(): void;
}

  export declare class Handle_NCollection_AlignedAllocator_1 extends Handle_NCollection_AlignedAllocator {
    constructor();
  }

  export declare class Handle_NCollection_AlignedAllocator_2 extends Handle_NCollection_AlignedAllocator {
    constructor(thePtr: NCollection_AlignedAllocator);
  }

  export declare class Handle_NCollection_AlignedAllocator_3 extends Handle_NCollection_AlignedAllocator {
    constructor(theHandle: Handle_NCollection_AlignedAllocator);
  }

  export declare class Handle_NCollection_AlignedAllocator_4 extends Handle_NCollection_AlignedAllocator {
    constructor(theHandle: Handle_NCollection_AlignedAllocator);
  }

export declare class NCollection_SparseArrayBase {
  Clear(): void;
  Size(): Standard_ThreadId;
  HasValue(theIndex: Standard_ThreadId): Standard_Boolean;
  UnsetValue(theIndex: Standard_ThreadId): Standard_Boolean;
  delete(): void;
}

export declare class NCollection_UtfWideString {
  Iterator(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  GetChar(theCharIndex: Standard_Integer): Standard_Utf32Char;
  GetCharBuffer(theCharIndex: Standard_Integer): Standard_WideChar;
  FromLocale(theString: string, theLength: Standard_Integer): void;
  IsEqual(theCompare: NCollection_UtfWideString): boolean;
  SubString(theStart: Standard_Integer, theEnd: Standard_Integer): NCollection_UtfWideString;
  ToCString(): Standard_WideChar;
  ToUtf8(): NCollection_Utf8String;
  ToUtf16(): NCollection_Utf16String;
  ToUtf32(): NCollection_Utf32String;
  ToUtfWide(): NCollection_UtfWideString;
  ToLocale(theBuffer: string, theSizeBytes: Standard_Integer): boolean;
  IsEmpty(): boolean;
  Clear(): void;
  Assign(theOther: NCollection_UtfWideString): NCollection_UtfWideString;
  Swap(theOther: NCollection_UtfWideString): void;
  delete(): void;
}

  export declare class NCollection_UtfWideString_1 extends NCollection_UtfWideString {
    constructor();
  }

  export declare class NCollection_UtfWideString_2 extends NCollection_UtfWideString {
    constructor(theCopy: NCollection_UtfWideString);
  }

  export declare class NCollection_UtfWideString_3 extends NCollection_UtfWideString {
    constructor(theOther: NCollection_UtfWideString);
  }

  export declare class NCollection_UtfWideString_4 extends NCollection_UtfWideString {
    constructor(theCopyUtf8: string, theLength: Standard_Integer);
  }

  export declare class NCollection_UtfWideString_5 extends NCollection_UtfWideString {
    constructor(theCopyUtf16: Standard_Utf16Char, theLength: Standard_Integer);
  }

  export declare class NCollection_UtfWideString_6 extends NCollection_UtfWideString {
    constructor(theCopyUtf32: Standard_Utf32Char, theLength: Standard_Integer);
  }

  export declare class NCollection_UtfWideString_7 extends NCollection_UtfWideString {
    constructor(theCopyUtfWide: Standard_WideChar, theLength: Standard_Integer);
  }

export declare class NCollection_Utf16String {
  Iterator(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  GetChar(theCharIndex: Standard_Integer): Standard_Utf32Char;
  GetCharBuffer(theCharIndex: Standard_Integer): Standard_Utf16Char;
  FromLocale(theString: string, theLength: Standard_Integer): void;
  IsEqual(theCompare: NCollection_Utf16String): boolean;
  SubString(theStart: Standard_Integer, theEnd: Standard_Integer): NCollection_Utf16String;
  ToCString(): Standard_Utf16Char;
  ToUtf8(): NCollection_Utf8String;
  ToUtf16(): NCollection_Utf16String;
  ToUtf32(): NCollection_Utf32String;
  ToUtfWide(): NCollection_UtfWideString;
  ToLocale(theBuffer: string, theSizeBytes: Standard_Integer): boolean;
  IsEmpty(): boolean;
  Clear(): void;
  Assign(theOther: NCollection_Utf16String): NCollection_Utf16String;
  Swap(theOther: NCollection_Utf16String): void;
  delete(): void;
}

  export declare class NCollection_Utf16String_1 extends NCollection_Utf16String {
    constructor();
  }

  export declare class NCollection_Utf16String_2 extends NCollection_Utf16String {
    constructor(theCopy: NCollection_Utf16String);
  }

  export declare class NCollection_Utf16String_3 extends NCollection_Utf16String {
    constructor(theOther: NCollection_Utf16String);
  }

  export declare class NCollection_Utf16String_4 extends NCollection_Utf16String {
    constructor(theCopyUtf8: string, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf16String_5 extends NCollection_Utf16String {
    constructor(theCopyUtf16: Standard_Utf16Char, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf16String_6 extends NCollection_Utf16String {
    constructor(theCopyUtf32: Standard_Utf32Char, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf16String_7 extends NCollection_Utf16String {
    constructor(theCopyUtfWide: Standard_WideChar, theLength: Standard_Integer);
  }

export declare class NCollection_Utf8String {
  Iterator(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  GetChar(theCharIndex: Standard_Integer): Standard_Utf32Char;
  GetCharBuffer(theCharIndex: Standard_Integer): Standard_Utf8Char;
  FromLocale(theString: string, theLength: Standard_Integer): void;
  IsEqual(theCompare: NCollection_Utf8String): boolean;
  SubString(theStart: Standard_Integer, theEnd: Standard_Integer): NCollection_Utf8String;
  ToCString(): Standard_Utf8Char;
  ToUtf8(): NCollection_Utf8String;
  ToUtf16(): NCollection_Utf16String;
  ToUtf32(): NCollection_Utf32String;
  ToUtfWide(): NCollection_UtfWideString;
  ToLocale(theBuffer: string, theSizeBytes: Standard_Integer): boolean;
  IsEmpty(): boolean;
  Clear(): void;
  Assign(theOther: NCollection_Utf8String): NCollection_Utf8String;
  Swap(theOther: NCollection_Utf8String): void;
  delete(): void;
}

  export declare class NCollection_Utf8String_1 extends NCollection_Utf8String {
    constructor();
  }

  export declare class NCollection_Utf8String_2 extends NCollection_Utf8String {
    constructor(theCopy: NCollection_Utf8String);
  }

  export declare class NCollection_Utf8String_3 extends NCollection_Utf8String {
    constructor(theOther: NCollection_Utf8String);
  }

  export declare class NCollection_Utf8String_4 extends NCollection_Utf8String {
    constructor(theCopyUtf8: string, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf8String_5 extends NCollection_Utf8String {
    constructor(theCopyUtf16: Standard_Utf16Char, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf8String_6 extends NCollection_Utf8String {
    constructor(theCopyUtf32: Standard_Utf32Char, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf8String_7 extends NCollection_Utf8String {
    constructor(theCopyUtfWide: Standard_WideChar, theLength: Standard_Integer);
  }

export declare class NCollection_Utf32String {
  Iterator(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  GetChar(theCharIndex: Standard_Integer): Standard_Utf32Char;
  GetCharBuffer(theCharIndex: Standard_Integer): Standard_Utf32Char;
  FromLocale(theString: string, theLength: Standard_Integer): void;
  IsEqual(theCompare: NCollection_Utf32String): boolean;
  SubString(theStart: Standard_Integer, theEnd: Standard_Integer): NCollection_Utf32String;
  ToCString(): Standard_Utf32Char;
  ToUtf8(): NCollection_Utf8String;
  ToUtf16(): NCollection_Utf16String;
  ToUtf32(): NCollection_Utf32String;
  ToUtfWide(): NCollection_UtfWideString;
  ToLocale(theBuffer: string, theSizeBytes: Standard_Integer): boolean;
  IsEmpty(): boolean;
  Clear(): void;
  Assign(theOther: NCollection_Utf32String): NCollection_Utf32String;
  Swap(theOther: NCollection_Utf32String): void;
  delete(): void;
}

  export declare class NCollection_Utf32String_1 extends NCollection_Utf32String {
    constructor();
  }

  export declare class NCollection_Utf32String_2 extends NCollection_Utf32String {
    constructor(theCopy: NCollection_Utf32String);
  }

  export declare class NCollection_Utf32String_3 extends NCollection_Utf32String {
    constructor(theOther: NCollection_Utf32String);
  }

  export declare class NCollection_Utf32String_4 extends NCollection_Utf32String {
    constructor(theCopyUtf8: string, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf32String_5 extends NCollection_Utf32String {
    constructor(theCopyUtf16: Standard_Utf16Char, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf32String_6 extends NCollection_Utf32String {
    constructor(theCopyUtf32: Standard_Utf32Char, theLength: Standard_Integer);
  }

  export declare class NCollection_Utf32String_7 extends NCollection_Utf32String {
    constructor(theCopyUtfWide: Standard_WideChar, theLength: Standard_Integer);
  }

export declare type NCollection_CellFilter_Action = {
  CellFilter_Keep: {};
  CellFilter_Purge: {};
}

export declare class NCollection_CellFilter_InspectorXYZ {
  constructor();
  static Coord(i: Standard_Integer, thePnt: any): Quantity_AbsorbedDose;
  Shift(thePnt: any, theTol: Quantity_AbsorbedDose): any;
  delete(): void;
}

export declare class NCollection_CellFilter_InspectorXY {
  constructor();
  static Coord(i: Standard_Integer, thePnt: any): Quantity_AbsorbedDose;
  Shift(thePnt: any, theTol: Quantity_AbsorbedDose): any;
  delete(): void;
}

export declare class NCollection_UtfStringTool {
  constructor()
  FromLocale(theString: Standard_Character): Standard_WideChar;
  static ToLocale(theWideString: Standard_WideChar, theBuffer: Standard_Character, theSizeBytes: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class NCollection_IncAllocator extends NCollection_BaseAllocator {
  constructor(theBlockSize: Standard_Size)
  SetThreadSafe(theIsThreadSafe: Standard_Boolean): void;
  Allocate(size: Standard_Size): C_f;
  Free(anAddress: C_f): void;
  GetMemSize(): Standard_Size;
  Reallocate(anAddress: C_f, oldSize: Standard_Size, newSize: Standard_Size): C_f;
  Reset(doReleaseMem: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NCollection_IncAllocator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NCollection_IncAllocator): void;
  get(): NCollection_IncAllocator;
  delete(): void;
}

  export declare class Handle_NCollection_IncAllocator_1 extends Handle_NCollection_IncAllocator {
    constructor();
  }

  export declare class Handle_NCollection_IncAllocator_2 extends Handle_NCollection_IncAllocator {
    constructor(thePtr: NCollection_IncAllocator);
  }

  export declare class Handle_NCollection_IncAllocator_3 extends Handle_NCollection_IncAllocator {
    constructor(theHandle: Handle_NCollection_IncAllocator);
  }

  export declare class Handle_NCollection_IncAllocator_4 extends Handle_NCollection_IncAllocator {
    constructor(theHandle: Handle_NCollection_IncAllocator);
  }

export declare class Handle_TColGeom_HArray1OfBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HArray1OfBSplineCurve): void;
  get(): TColGeom_HArray1OfBSplineCurve;
  delete(): void;
}

  export declare class Handle_TColGeom_HArray1OfBSplineCurve_1 extends Handle_TColGeom_HArray1OfBSplineCurve {
    constructor();
  }

  export declare class Handle_TColGeom_HArray1OfBSplineCurve_2 extends Handle_TColGeom_HArray1OfBSplineCurve {
    constructor(thePtr: TColGeom_HArray1OfBSplineCurve);
  }

  export declare class Handle_TColGeom_HArray1OfBSplineCurve_3 extends Handle_TColGeom_HArray1OfBSplineCurve {
    constructor(theHandle: Handle_TColGeom_HArray1OfBSplineCurve);
  }

  export declare class Handle_TColGeom_HArray1OfBSplineCurve_4 extends Handle_TColGeom_HArray1OfBSplineCurve {
    constructor(theHandle: Handle_TColGeom_HArray1OfBSplineCurve);
  }

export declare class Handle_TColGeom_HArray1OfSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HArray1OfSurface): void;
  get(): TColGeom_HArray1OfSurface;
  delete(): void;
}

  export declare class Handle_TColGeom_HArray1OfSurface_1 extends Handle_TColGeom_HArray1OfSurface {
    constructor();
  }

  export declare class Handle_TColGeom_HArray1OfSurface_2 extends Handle_TColGeom_HArray1OfSurface {
    constructor(thePtr: TColGeom_HArray1OfSurface);
  }

  export declare class Handle_TColGeom_HArray1OfSurface_3 extends Handle_TColGeom_HArray1OfSurface {
    constructor(theHandle: Handle_TColGeom_HArray1OfSurface);
  }

  export declare class Handle_TColGeom_HArray1OfSurface_4 extends Handle_TColGeom_HArray1OfSurface {
    constructor(theHandle: Handle_TColGeom_HArray1OfSurface);
  }

export declare class Handle_TColGeom_HArray2OfSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HArray2OfSurface): void;
  get(): TColGeom_HArray2OfSurface;
  delete(): void;
}

  export declare class Handle_TColGeom_HArray2OfSurface_1 extends Handle_TColGeom_HArray2OfSurface {
    constructor();
  }

  export declare class Handle_TColGeom_HArray2OfSurface_2 extends Handle_TColGeom_HArray2OfSurface {
    constructor(thePtr: TColGeom_HArray2OfSurface);
  }

  export declare class Handle_TColGeom_HArray2OfSurface_3 extends Handle_TColGeom_HArray2OfSurface {
    constructor(theHandle: Handle_TColGeom_HArray2OfSurface);
  }

  export declare class Handle_TColGeom_HArray2OfSurface_4 extends Handle_TColGeom_HArray2OfSurface {
    constructor(theHandle: Handle_TColGeom_HArray2OfSurface);
  }

export declare class Handle_TColGeom_HArray1OfCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HArray1OfCurve): void;
  get(): TColGeom_HArray1OfCurve;
  delete(): void;
}

  export declare class Handle_TColGeom_HArray1OfCurve_1 extends Handle_TColGeom_HArray1OfCurve {
    constructor();
  }

  export declare class Handle_TColGeom_HArray1OfCurve_2 extends Handle_TColGeom_HArray1OfCurve {
    constructor(thePtr: TColGeom_HArray1OfCurve);
  }

  export declare class Handle_TColGeom_HArray1OfCurve_3 extends Handle_TColGeom_HArray1OfCurve {
    constructor(theHandle: Handle_TColGeom_HArray1OfCurve);
  }

  export declare class Handle_TColGeom_HArray1OfCurve_4 extends Handle_TColGeom_HArray1OfCurve {
    constructor(theHandle: Handle_TColGeom_HArray1OfCurve);
  }

export declare class Handle_TColGeom_HArray1OfBezierCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HArray1OfBezierCurve): void;
  get(): TColGeom_HArray1OfBezierCurve;
  delete(): void;
}

  export declare class Handle_TColGeom_HArray1OfBezierCurve_1 extends Handle_TColGeom_HArray1OfBezierCurve {
    constructor();
  }

  export declare class Handle_TColGeom_HArray1OfBezierCurve_2 extends Handle_TColGeom_HArray1OfBezierCurve {
    constructor(thePtr: TColGeom_HArray1OfBezierCurve);
  }

  export declare class Handle_TColGeom_HArray1OfBezierCurve_3 extends Handle_TColGeom_HArray1OfBezierCurve {
    constructor(theHandle: Handle_TColGeom_HArray1OfBezierCurve);
  }

  export declare class Handle_TColGeom_HArray1OfBezierCurve_4 extends Handle_TColGeom_HArray1OfBezierCurve {
    constructor(theHandle: Handle_TColGeom_HArray1OfBezierCurve);
  }

export declare class Handle_TColGeom_HSequenceOfBoundedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HSequenceOfBoundedCurve): void;
  get(): TColGeom_HSequenceOfBoundedCurve;
  delete(): void;
}

  export declare class Handle_TColGeom_HSequenceOfBoundedCurve_1 extends Handle_TColGeom_HSequenceOfBoundedCurve {
    constructor();
  }

  export declare class Handle_TColGeom_HSequenceOfBoundedCurve_2 extends Handle_TColGeom_HSequenceOfBoundedCurve {
    constructor(thePtr: TColGeom_HSequenceOfBoundedCurve);
  }

  export declare class Handle_TColGeom_HSequenceOfBoundedCurve_3 extends Handle_TColGeom_HSequenceOfBoundedCurve {
    constructor(theHandle: Handle_TColGeom_HSequenceOfBoundedCurve);
  }

  export declare class Handle_TColGeom_HSequenceOfBoundedCurve_4 extends Handle_TColGeom_HSequenceOfBoundedCurve {
    constructor(theHandle: Handle_TColGeom_HSequenceOfBoundedCurve);
  }

export declare class Handle_TColGeom_HSequenceOfCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom_HSequenceOfCurve): void;
  get(): TColGeom_HSequenceOfCurve;
  delete(): void;
}

  export declare class Handle_TColGeom_HSequenceOfCurve_1 extends Handle_TColGeom_HSequenceOfCurve {
    constructor();
  }

  export declare class Handle_TColGeom_HSequenceOfCurve_2 extends Handle_TColGeom_HSequenceOfCurve {
    constructor(thePtr: TColGeom_HSequenceOfCurve);
  }

  export declare class Handle_TColGeom_HSequenceOfCurve_3 extends Handle_TColGeom_HSequenceOfCurve {
    constructor(theHandle: Handle_TColGeom_HSequenceOfCurve);
  }

  export declare class Handle_TColGeom_HSequenceOfCurve_4 extends Handle_TColGeom_HSequenceOfCurve {
    constructor(theHandle: Handle_TColGeom_HSequenceOfCurve);
  }

export declare class Handle_BinMDataStd_RealListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_RealListDriver): void;
  get(): BinMDataStd_RealListDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_RealListDriver_1 extends Handle_BinMDataStd_RealListDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_RealListDriver_2 extends Handle_BinMDataStd_RealListDriver {
    constructor(thePtr: BinMDataStd_RealListDriver);
  }

  export declare class Handle_BinMDataStd_RealListDriver_3 extends Handle_BinMDataStd_RealListDriver {
    constructor(theHandle: Handle_BinMDataStd_RealListDriver);
  }

  export declare class Handle_BinMDataStd_RealListDriver_4 extends Handle_BinMDataStd_RealListDriver {
    constructor(theHandle: Handle_BinMDataStd_RealListDriver);
  }

export declare class BinMDataStd_RealListDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_RealArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_RealArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_RealArrayDriver): void;
  get(): BinMDataStd_RealArrayDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_RealArrayDriver_1 extends Handle_BinMDataStd_RealArrayDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_RealArrayDriver_2 extends Handle_BinMDataStd_RealArrayDriver {
    constructor(thePtr: BinMDataStd_RealArrayDriver);
  }

  export declare class Handle_BinMDataStd_RealArrayDriver_3 extends Handle_BinMDataStd_RealArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_RealArrayDriver);
  }

  export declare class Handle_BinMDataStd_RealArrayDriver_4 extends Handle_BinMDataStd_RealArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_RealArrayDriver);
  }

export declare class Handle_BinMDataStd_ByteArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_ByteArrayDriver): void;
  get(): BinMDataStd_ByteArrayDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_ByteArrayDriver_1 extends Handle_BinMDataStd_ByteArrayDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_ByteArrayDriver_2 extends Handle_BinMDataStd_ByteArrayDriver {
    constructor(thePtr: BinMDataStd_ByteArrayDriver);
  }

  export declare class Handle_BinMDataStd_ByteArrayDriver_3 extends Handle_BinMDataStd_ByteArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_ByteArrayDriver);
  }

  export declare class Handle_BinMDataStd_ByteArrayDriver_4 extends Handle_BinMDataStd_ByteArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_ByteArrayDriver);
  }

export declare class BinMDataStd_ByteArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_GenericEmptyDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  SourceType(): Handle_Standard_Type;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_GenericEmptyDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_GenericEmptyDriver): void;
  get(): BinMDataStd_GenericEmptyDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_GenericEmptyDriver_1 extends Handle_BinMDataStd_GenericEmptyDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_GenericEmptyDriver_2 extends Handle_BinMDataStd_GenericEmptyDriver {
    constructor(thePtr: BinMDataStd_GenericEmptyDriver);
  }

  export declare class Handle_BinMDataStd_GenericEmptyDriver_3 extends Handle_BinMDataStd_GenericEmptyDriver {
    constructor(theHandle: Handle_BinMDataStd_GenericEmptyDriver);
  }

  export declare class Handle_BinMDataStd_GenericEmptyDriver_4 extends Handle_BinMDataStd_GenericEmptyDriver {
    constructor(theHandle: Handle_BinMDataStd_GenericEmptyDriver);
  }

export declare class Handle_BinMDataStd_TreeNodeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_TreeNodeDriver): void;
  get(): BinMDataStd_TreeNodeDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_TreeNodeDriver_1 extends Handle_BinMDataStd_TreeNodeDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_TreeNodeDriver_2 extends Handle_BinMDataStd_TreeNodeDriver {
    constructor(thePtr: BinMDataStd_TreeNodeDriver);
  }

  export declare class Handle_BinMDataStd_TreeNodeDriver_3 extends Handle_BinMDataStd_TreeNodeDriver {
    constructor(theHandle: Handle_BinMDataStd_TreeNodeDriver);
  }

  export declare class Handle_BinMDataStd_TreeNodeDriver_4 extends Handle_BinMDataStd_TreeNodeDriver {
    constructor(theHandle: Handle_BinMDataStd_TreeNodeDriver);
  }

export declare class BinMDataStd_TreeNodeDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_BooleanListDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_BooleanListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_BooleanListDriver): void;
  get(): BinMDataStd_BooleanListDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_BooleanListDriver_1 extends Handle_BinMDataStd_BooleanListDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_BooleanListDriver_2 extends Handle_BinMDataStd_BooleanListDriver {
    constructor(thePtr: BinMDataStd_BooleanListDriver);
  }

  export declare class Handle_BinMDataStd_BooleanListDriver_3 extends Handle_BinMDataStd_BooleanListDriver {
    constructor(theHandle: Handle_BinMDataStd_BooleanListDriver);
  }

  export declare class Handle_BinMDataStd_BooleanListDriver_4 extends Handle_BinMDataStd_BooleanListDriver {
    constructor(theHandle: Handle_BinMDataStd_BooleanListDriver);
  }

export declare class Handle_BinMDataStd_UAttributeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_UAttributeDriver): void;
  get(): BinMDataStd_UAttributeDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_UAttributeDriver_1 extends Handle_BinMDataStd_UAttributeDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_UAttributeDriver_2 extends Handle_BinMDataStd_UAttributeDriver {
    constructor(thePtr: BinMDataStd_UAttributeDriver);
  }

  export declare class Handle_BinMDataStd_UAttributeDriver_3 extends Handle_BinMDataStd_UAttributeDriver {
    constructor(theHandle: Handle_BinMDataStd_UAttributeDriver);
  }

  export declare class Handle_BinMDataStd_UAttributeDriver_4 extends Handle_BinMDataStd_UAttributeDriver {
    constructor(theHandle: Handle_BinMDataStd_UAttributeDriver);
  }

export declare class BinMDataStd_UAttributeDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_ReferenceListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_ReferenceListDriver): void;
  get(): BinMDataStd_ReferenceListDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_ReferenceListDriver_1 extends Handle_BinMDataStd_ReferenceListDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_ReferenceListDriver_2 extends Handle_BinMDataStd_ReferenceListDriver {
    constructor(thePtr: BinMDataStd_ReferenceListDriver);
  }

  export declare class Handle_BinMDataStd_ReferenceListDriver_3 extends Handle_BinMDataStd_ReferenceListDriver {
    constructor(theHandle: Handle_BinMDataStd_ReferenceListDriver);
  }

  export declare class Handle_BinMDataStd_ReferenceListDriver_4 extends Handle_BinMDataStd_ReferenceListDriver {
    constructor(theHandle: Handle_BinMDataStd_ReferenceListDriver);
  }

export declare class BinMDataStd_ReferenceListDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_VariableDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_VariableDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_VariableDriver): void;
  get(): BinMDataStd_VariableDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_VariableDriver_1 extends Handle_BinMDataStd_VariableDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_VariableDriver_2 extends Handle_BinMDataStd_VariableDriver {
    constructor(thePtr: BinMDataStd_VariableDriver);
  }

  export declare class Handle_BinMDataStd_VariableDriver_3 extends Handle_BinMDataStd_VariableDriver {
    constructor(theHandle: Handle_BinMDataStd_VariableDriver);
  }

  export declare class Handle_BinMDataStd_VariableDriver_4 extends Handle_BinMDataStd_VariableDriver {
    constructor(theHandle: Handle_BinMDataStd_VariableDriver);
  }

export declare class Handle_BinMDataStd_RealDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_RealDriver): void;
  get(): BinMDataStd_RealDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_RealDriver_1 extends Handle_BinMDataStd_RealDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_RealDriver_2 extends Handle_BinMDataStd_RealDriver {
    constructor(thePtr: BinMDataStd_RealDriver);
  }

  export declare class Handle_BinMDataStd_RealDriver_3 extends Handle_BinMDataStd_RealDriver {
    constructor(theHandle: Handle_BinMDataStd_RealDriver);
  }

  export declare class Handle_BinMDataStd_RealDriver_4 extends Handle_BinMDataStd_RealDriver {
    constructor(theHandle: Handle_BinMDataStd_RealDriver);
  }

export declare class BinMDataStd_RealDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_IntegerArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_IntegerArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_IntegerArrayDriver): void;
  get(): BinMDataStd_IntegerArrayDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_IntegerArrayDriver_1 extends Handle_BinMDataStd_IntegerArrayDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_IntegerArrayDriver_2 extends Handle_BinMDataStd_IntegerArrayDriver {
    constructor(thePtr: BinMDataStd_IntegerArrayDriver);
  }

  export declare class Handle_BinMDataStd_IntegerArrayDriver_3 extends Handle_BinMDataStd_IntegerArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_IntegerArrayDriver);
  }

  export declare class Handle_BinMDataStd_IntegerArrayDriver_4 extends Handle_BinMDataStd_IntegerArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_IntegerArrayDriver);
  }

export declare class Handle_BinMDataStd_GenericExtStringDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_GenericExtStringDriver): void;
  get(): BinMDataStd_GenericExtStringDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_GenericExtStringDriver_1 extends Handle_BinMDataStd_GenericExtStringDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_GenericExtStringDriver_2 extends Handle_BinMDataStd_GenericExtStringDriver {
    constructor(thePtr: BinMDataStd_GenericExtStringDriver);
  }

  export declare class Handle_BinMDataStd_GenericExtStringDriver_3 extends Handle_BinMDataStd_GenericExtStringDriver {
    constructor(theHandle: Handle_BinMDataStd_GenericExtStringDriver);
  }

  export declare class Handle_BinMDataStd_GenericExtStringDriver_4 extends Handle_BinMDataStd_GenericExtStringDriver {
    constructor(theHandle: Handle_BinMDataStd_GenericExtStringDriver);
  }

export declare class BinMDataStd_GenericExtStringDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  SourceType(): Handle_Standard_Type;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_AsciiStringDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_AsciiStringDriver): void;
  get(): BinMDataStd_AsciiStringDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_AsciiStringDriver_1 extends Handle_BinMDataStd_AsciiStringDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_AsciiStringDriver_2 extends Handle_BinMDataStd_AsciiStringDriver {
    constructor(thePtr: BinMDataStd_AsciiStringDriver);
  }

  export declare class Handle_BinMDataStd_AsciiStringDriver_3 extends Handle_BinMDataStd_AsciiStringDriver {
    constructor(theHandle: Handle_BinMDataStd_AsciiStringDriver);
  }

  export declare class Handle_BinMDataStd_AsciiStringDriver_4 extends Handle_BinMDataStd_AsciiStringDriver {
    constructor(theHandle: Handle_BinMDataStd_AsciiStringDriver);
  }

export declare class BinMDataStd_AsciiStringDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_ExpressionDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_ExpressionDriver): void;
  get(): BinMDataStd_ExpressionDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_ExpressionDriver_1 extends Handle_BinMDataStd_ExpressionDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_ExpressionDriver_2 extends Handle_BinMDataStd_ExpressionDriver {
    constructor(thePtr: BinMDataStd_ExpressionDriver);
  }

  export declare class Handle_BinMDataStd_ExpressionDriver_3 extends Handle_BinMDataStd_ExpressionDriver {
    constructor(theHandle: Handle_BinMDataStd_ExpressionDriver);
  }

  export declare class Handle_BinMDataStd_ExpressionDriver_4 extends Handle_BinMDataStd_ExpressionDriver {
    constructor(theHandle: Handle_BinMDataStd_ExpressionDriver);
  }

export declare class BinMDataStd_ExpressionDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd {
  constructor();
  static AddDrivers(theDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class Handle_BinMDataStd_IntegerListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_IntegerListDriver): void;
  get(): BinMDataStd_IntegerListDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_IntegerListDriver_1 extends Handle_BinMDataStd_IntegerListDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_IntegerListDriver_2 extends Handle_BinMDataStd_IntegerListDriver {
    constructor(thePtr: BinMDataStd_IntegerListDriver);
  }

  export declare class Handle_BinMDataStd_IntegerListDriver_3 extends Handle_BinMDataStd_IntegerListDriver {
    constructor(theHandle: Handle_BinMDataStd_IntegerListDriver);
  }

  export declare class Handle_BinMDataStd_IntegerListDriver_4 extends Handle_BinMDataStd_IntegerListDriver {
    constructor(theHandle: Handle_BinMDataStd_IntegerListDriver);
  }

export declare class BinMDataStd_IntegerListDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_ReferenceArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_ReferenceArrayDriver): void;
  get(): BinMDataStd_ReferenceArrayDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_ReferenceArrayDriver_1 extends Handle_BinMDataStd_ReferenceArrayDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_ReferenceArrayDriver_2 extends Handle_BinMDataStd_ReferenceArrayDriver {
    constructor(thePtr: BinMDataStd_ReferenceArrayDriver);
  }

  export declare class Handle_BinMDataStd_ReferenceArrayDriver_3 extends Handle_BinMDataStd_ReferenceArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_ReferenceArrayDriver);
  }

  export declare class Handle_BinMDataStd_ReferenceArrayDriver_4 extends Handle_BinMDataStd_ReferenceArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_ReferenceArrayDriver);
  }

export declare class BinMDataStd_ReferenceArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_BooleanArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_BooleanArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_BooleanArrayDriver): void;
  get(): BinMDataStd_BooleanArrayDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_BooleanArrayDriver_1 extends Handle_BinMDataStd_BooleanArrayDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_BooleanArrayDriver_2 extends Handle_BinMDataStd_BooleanArrayDriver {
    constructor(thePtr: BinMDataStd_BooleanArrayDriver);
  }

  export declare class Handle_BinMDataStd_BooleanArrayDriver_3 extends Handle_BinMDataStd_BooleanArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_BooleanArrayDriver);
  }

  export declare class Handle_BinMDataStd_BooleanArrayDriver_4 extends Handle_BinMDataStd_BooleanArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_BooleanArrayDriver);
  }

export declare class BinMDataStd_NamedDataDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_NamedDataDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_NamedDataDriver): void;
  get(): BinMDataStd_NamedDataDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_NamedDataDriver_1 extends Handle_BinMDataStd_NamedDataDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_NamedDataDriver_2 extends Handle_BinMDataStd_NamedDataDriver {
    constructor(thePtr: BinMDataStd_NamedDataDriver);
  }

  export declare class Handle_BinMDataStd_NamedDataDriver_3 extends Handle_BinMDataStd_NamedDataDriver {
    constructor(theHandle: Handle_BinMDataStd_NamedDataDriver);
  }

  export declare class Handle_BinMDataStd_NamedDataDriver_4 extends Handle_BinMDataStd_NamedDataDriver {
    constructor(theHandle: Handle_BinMDataStd_NamedDataDriver);
  }

export declare class BinMDataStd_ExtStringListDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_ExtStringListDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_ExtStringListDriver): void;
  get(): BinMDataStd_ExtStringListDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_ExtStringListDriver_1 extends Handle_BinMDataStd_ExtStringListDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_ExtStringListDriver_2 extends Handle_BinMDataStd_ExtStringListDriver {
    constructor(thePtr: BinMDataStd_ExtStringListDriver);
  }

  export declare class Handle_BinMDataStd_ExtStringListDriver_3 extends Handle_BinMDataStd_ExtStringListDriver {
    constructor(theHandle: Handle_BinMDataStd_ExtStringListDriver);
  }

  export declare class Handle_BinMDataStd_ExtStringListDriver_4 extends Handle_BinMDataStd_ExtStringListDriver {
    constructor(theHandle: Handle_BinMDataStd_ExtStringListDriver);
  }

export declare class BinMDataStd_ExtStringArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_ExtStringArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_ExtStringArrayDriver): void;
  get(): BinMDataStd_ExtStringArrayDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_ExtStringArrayDriver_1 extends Handle_BinMDataStd_ExtStringArrayDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_ExtStringArrayDriver_2 extends Handle_BinMDataStd_ExtStringArrayDriver {
    constructor(thePtr: BinMDataStd_ExtStringArrayDriver);
  }

  export declare class Handle_BinMDataStd_ExtStringArrayDriver_3 extends Handle_BinMDataStd_ExtStringArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_ExtStringArrayDriver);
  }

  export declare class Handle_BinMDataStd_ExtStringArrayDriver_4 extends Handle_BinMDataStd_ExtStringArrayDriver {
    constructor(theHandle: Handle_BinMDataStd_ExtStringArrayDriver);
  }

export declare class Handle_BinMDataStd_IntPackedMapDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_IntPackedMapDriver): void;
  get(): BinMDataStd_IntPackedMapDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_IntPackedMapDriver_1 extends Handle_BinMDataStd_IntPackedMapDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_IntPackedMapDriver_2 extends Handle_BinMDataStd_IntPackedMapDriver {
    constructor(thePtr: BinMDataStd_IntPackedMapDriver);
  }

  export declare class Handle_BinMDataStd_IntPackedMapDriver_3 extends Handle_BinMDataStd_IntPackedMapDriver {
    constructor(theHandle: Handle_BinMDataStd_IntPackedMapDriver);
  }

  export declare class Handle_BinMDataStd_IntPackedMapDriver_4 extends Handle_BinMDataStd_IntPackedMapDriver {
    constructor(theHandle: Handle_BinMDataStd_IntPackedMapDriver);
  }

export declare class BinMDataStd_IntPackedMapDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataStd_IntegerDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataStd_IntegerDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataStd_IntegerDriver): void;
  get(): BinMDataStd_IntegerDriver;
  delete(): void;
}

  export declare class Handle_BinMDataStd_IntegerDriver_1 extends Handle_BinMDataStd_IntegerDriver {
    constructor();
  }

  export declare class Handle_BinMDataStd_IntegerDriver_2 extends Handle_BinMDataStd_IntegerDriver {
    constructor(thePtr: BinMDataStd_IntegerDriver);
  }

  export declare class Handle_BinMDataStd_IntegerDriver_3 extends Handle_BinMDataStd_IntegerDriver {
    constructor(theHandle: Handle_BinMDataStd_IntegerDriver);
  }

  export declare class Handle_BinMDataStd_IntegerDriver_4 extends Handle_BinMDataStd_IntegerDriver {
    constructor(theHandle: Handle_BinMDataStd_IntegerDriver);
  }

export declare class Blend_AppFunction extends math_FunctionSetWithDerivatives {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  Pnt1(): gp_Pnt;
  Pnt2(): gp_Pnt;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Resolution(IC2d: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Parameter(P: Blend_Point): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Blend_SurfPointFuncInv extends math_FunctionSetWithDerivatives {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set(P: gp_Pnt): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare type Blend_Status = {
  Blend_StepTooLarge: {};
  Blend_StepTooSmall: {};
  Blend_Backward: {};
  Blend_SamePoints: {};
  Blend_OnRst1: {};
  Blend_OnRst2: {};
  Blend_OnRst12: {};
  Blend_OK: {};
}

export declare class Blend_Point {
  SetValue_1(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Tg1: gp_Vec, Tg2: gp_Vec, Tg12d: gp_Vec2d, Tg22d: gp_Vec2d): void;
  SetValue_2(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  SetValue_3(Pts: gp_Pnt, Ptc: gp_Pnt, Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Tgs: gp_Vec, Tgc: gp_Vec, Tg2d: gp_Vec2d): void;
  SetValue_4(Pts: gp_Pnt, Ptc: gp_Pnt, Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose): void;
  SetValue_5(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC: Quantity_AbsorbedDose, Tg1: gp_Vec, Tg2: gp_Vec, Tg12d: gp_Vec2d, Tg22d: gp_Vec2d): void;
  SetValue_6(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC: Quantity_AbsorbedDose): void;
  SetValue_7(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC1: Quantity_AbsorbedDose, PC2: Quantity_AbsorbedDose, Tg1: gp_Vec, Tg2: gp_Vec, Tg12d: gp_Vec2d, Tg22d: gp_Vec2d): void;
  SetValue_8(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC1: Quantity_AbsorbedDose, PC2: Quantity_AbsorbedDose): void;
  SetValue_9(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, PC1: Quantity_AbsorbedDose, PC2: Quantity_AbsorbedDose): void;
  SetParameter(Param: Quantity_AbsorbedDose): void;
  Parameter(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  ParametersOnS1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  ParametersOnS2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  TangentOnS1(): gp_Vec;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  Tangent2dOnS2(): gp_Vec2d;
  PointOnS(): gp_Pnt;
  PointOnC(): gp_Pnt;
  ParametersOnS(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  ParameterOnC(): Quantity_AbsorbedDose;
  TangentOnS(): gp_Vec;
  TangentOnC(): gp_Vec;
  Tangent2d(): gp_Vec2d;
  PointOnC1(): gp_Pnt;
  PointOnC2(): gp_Pnt;
  ParameterOnC1(): Quantity_AbsorbedDose;
  ParameterOnC2(): Quantity_AbsorbedDose;
  TangentOnC1(): gp_Vec;
  TangentOnC2(): gp_Vec;
  delete(): void;
}

  export declare class Blend_Point_1 extends Blend_Point {
    constructor();
  }

  export declare class Blend_Point_2 extends Blend_Point {
    constructor(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Tg1: gp_Vec, Tg2: gp_Vec, Tg12d: gp_Vec2d, Tg22d: gp_Vec2d);
  }

  export declare class Blend_Point_3 extends Blend_Point {
    constructor(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose);
  }

  export declare class Blend_Point_4 extends Blend_Point {
    constructor(Pts: gp_Pnt, Ptc: gp_Pnt, Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Tgs: gp_Vec, Tgc: gp_Vec, Tg2d: gp_Vec2d);
  }

  export declare class Blend_Point_5 extends Blend_Point {
    constructor(Pts: gp_Pnt, Ptc: gp_Pnt, Param: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose);
  }

  export declare class Blend_Point_6 extends Blend_Point {
    constructor(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC: Quantity_AbsorbedDose, Tg1: gp_Vec, Tg2: gp_Vec, Tg12d: gp_Vec2d, Tg22d: gp_Vec2d);
  }

  export declare class Blend_Point_7 extends Blend_Point {
    constructor(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC: Quantity_AbsorbedDose);
  }

  export declare class Blend_Point_8 extends Blend_Point {
    constructor(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC1: Quantity_AbsorbedDose, PC2: Quantity_AbsorbedDose, Tg1: gp_Vec, Tg2: gp_Vec, Tg12d: gp_Vec2d, Tg22d: gp_Vec2d);
  }

  export declare class Blend_Point_9 extends Blend_Point {
    constructor(Pt1: gp_Pnt, Pt2: gp_Pnt, Param: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, PC1: Quantity_AbsorbedDose, PC2: Quantity_AbsorbedDose);
  }

export declare class Blend_RstRstFunction extends Blend_AppFunction {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  Pnt1(): gp_Pnt;
  Pnt2(): gp_Pnt;
  PointOnRst1(): gp_Pnt;
  PointOnRst2(): gp_Pnt;
  Pnt2dOnRst1(): gp_Pnt2d;
  Pnt2dOnRst2(): gp_Pnt2d;
  ParameterOnRst1(): Quantity_AbsorbedDose;
  ParameterOnRst2(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnRst1(): gp_Vec;
  Tangent2dOnRst1(): gp_Vec2d;
  TangentOnRst2(): gp_Vec;
  Tangent2dOnRst2(): gp_Vec2d;
  Decroch(Sol: math_Vector, NRst1: gp_Vec, TgRst1: gp_Vec, NRst2: gp_Vec, TgRst2: gp_Vec): Blend_DecrochStatus;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  delete(): void;
}

export declare type Blend_DecrochStatus = {
  Blend_NoDecroch: {};
  Blend_DecrochRst1: {};
  Blend_DecrochRst2: {};
  Blend_DecrochBoth: {};
}

export declare class Blend_CSFunction extends Blend_AppFunction {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  Pnt1(): gp_Pnt;
  Pnt2(): gp_Pnt;
  PointOnS(): gp_Pnt;
  PointOnC(): gp_Pnt;
  Pnt2d(): gp_Pnt2d;
  ParameterOnC(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2d(): gp_Vec2d;
  TangentOnC(): gp_Vec;
  Tangent(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, TgS: gp_Vec, NormS: gp_Vec): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  delete(): void;
}

export declare class Blend_SurfRstFunction extends Blend_AppFunction {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set_1(Param: Quantity_AbsorbedDose): void;
  Set_2(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance_1(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  GetMinimalDistance(): Quantity_AbsorbedDose;
  Pnt1(): gp_Pnt;
  Pnt2(): gp_Pnt;
  PointOnS(): gp_Pnt;
  PointOnRst(): gp_Pnt;
  Pnt2dOnS(): gp_Pnt2d;
  Pnt2dOnRst(): gp_Pnt2d;
  ParameterOnRst(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS(): gp_Vec;
  Tangent2dOnS(): gp_Vec2d;
  TangentOnRst(): gp_Vec;
  Tangent2dOnRst(): gp_Vec2d;
  Decroch(Sol: math_Vector, NS: gp_Vec, TgS: gp_Vec): Standard_Boolean;
  IsRational(): Standard_Boolean;
  GetSectionSize(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  GetTolerance_2(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: math_Vector, Tol1D: math_Vector): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_3(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  delete(): void;
}

export declare class Blend_CurvPointFuncInv extends math_FunctionSetWithDerivatives {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set(P: gp_Pnt): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Blend_SurfCurvFuncInv extends math_FunctionSetWithDerivatives {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set(Rst: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Blend_FuncInv extends math_FunctionSetWithDerivatives {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Set(OnFirst: Standard_Boolean, COnSurf: Handle_Adaptor2d_HCurve2d): void;
  GetTolerance(Tolerance: math_Vector, Tol: Quantity_AbsorbedDose): void;
  GetBounds(InfBound: math_Vector, SupBound: math_Vector): void;
  IsSolution(Sol: math_Vector, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Blend_Function extends Blend_AppFunction {
  NbVariables(): Graphic3d_ZLayerId;
  Pnt1(): gp_Pnt;
  Pnt2(): gp_Pnt;
  PointOnS1(): gp_Pnt;
  PointOnS2(): gp_Pnt;
  IsTangencyPoint(): Standard_Boolean;
  TangentOnS1(): gp_Vec;
  Tangent2dOnS1(): gp_Vec2d;
  TangentOnS2(): gp_Vec;
  Tangent2dOnS2(): gp_Vec2d;
  Tangent(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TgFirst: gp_Vec, TgLast: gp_Vec, NormFirst: gp_Vec, NormLast: gp_Vec): void;
  TwistOnS1(): Standard_Boolean;
  TwistOnS2(): Standard_Boolean;
  Section_1(P: Blend_Point, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Section_2(P: Blend_Point, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  delete(): void;
}

export declare class Blend_SequenceOfPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Blend_SequenceOfPoint): Blend_SequenceOfPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Blend_Point): void;
  Append_2(theSeq: Blend_SequenceOfPoint): void;
  Prepend_1(theItem: Blend_Point): void;
  Prepend_2(theSeq: Blend_SequenceOfPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Blend_Point): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Blend_SequenceOfPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Blend_SequenceOfPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Blend_Point): void;
  Split(theIndex: Standard_Integer, theSeq: Blend_SequenceOfPoint): void;
  First(): Blend_Point;
  ChangeFirst(): Blend_Point;
  Last(): Blend_Point;
  ChangeLast(): Blend_Point;
  Value(theIndex: Standard_Integer): Blend_Point;
  ChangeValue(theIndex: Standard_Integer): Blend_Point;
  SetValue(theIndex: Standard_Integer, theItem: Blend_Point): void;
  delete(): void;
}

  export declare class Blend_SequenceOfPoint_1 extends Blend_SequenceOfPoint {
    constructor();
  }

  export declare class Blend_SequenceOfPoint_2 extends Blend_SequenceOfPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Blend_SequenceOfPoint_3 extends Blend_SequenceOfPoint {
    constructor(theOther: Blend_SequenceOfPoint);
  }

export declare class RWStepElement_RWElementDescriptor {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_ElementDescriptor): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_ElementDescriptor): void;
  Share(ent: Handle_StepElement_ElementDescriptor, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWVolume3dElementDescriptor {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_Volume3dElementDescriptor): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_Volume3dElementDescriptor): void;
  Share(ent: Handle_StepElement_Volume3dElementDescriptor, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWSurfaceElementProperty {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_SurfaceElementProperty): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_SurfaceElementProperty): void;
  Share(ent: Handle_StepElement_SurfaceElementProperty, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWElementMaterial {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_ElementMaterial): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_ElementMaterial): void;
  Share(ent: Handle_StepElement_ElementMaterial, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWSurfaceSectionFieldConstant {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_SurfaceSectionFieldConstant): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_SurfaceSectionFieldConstant): void;
  Share(ent: Handle_StepElement_SurfaceSectionFieldConstant, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWSurfaceSectionFieldVarying {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_SurfaceSectionFieldVarying): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_SurfaceSectionFieldVarying): void;
  Share(ent: Handle_StepElement_SurfaceSectionFieldVarying, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWSurface3dElementDescriptor {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_Surface3dElementDescriptor): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_Surface3dElementDescriptor): void;
  Share(ent: Handle_StepElement_Surface3dElementDescriptor, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWAnalysisItemWithinRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  Share(ent: Handle_StepElement_AnalysisItemWithinRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWCurve3dElementDescriptor {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_Curve3dElementDescriptor): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_Curve3dElementDescriptor): void;
  Share(ent: Handle_StepElement_Curve3dElementDescriptor, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWSurfaceSection {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_SurfaceSection): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_SurfaceSection): void;
  Share(ent: Handle_StepElement_SurfaceSection, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWCurveElementSectionDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_CurveElementSectionDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_CurveElementSectionDefinition): void;
  Share(ent: Handle_StepElement_CurveElementSectionDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWUniformSurfaceSection {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_UniformSurfaceSection): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_UniformSurfaceSection): void;
  Share(ent: Handle_StepElement_UniformSurfaceSection, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWCurveElementEndReleasePacket {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_CurveElementEndReleasePacket): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_CurveElementEndReleasePacket): void;
  Share(ent: Handle_StepElement_CurveElementEndReleasePacket, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWSurfaceSectionField {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_SurfaceSectionField): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_SurfaceSectionField): void;
  Share(ent: Handle_StepElement_SurfaceSectionField, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepElement_RWCurveElementSectionDerivedDefinitions {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepElement_CurveElementSectionDerivedDefinitions): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepElement_CurveElementSectionDerivedDefinitions): void;
  Share(ent: Handle_StepElement_CurveElementSectionDerivedDefinitions, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare type WNT_OrientationType = {
  WNT_OT_PORTRAIT: {};
  WNT_OT_LANDSCAPE: {};
}

export declare class Handle_WNT_ClassDefinitionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: WNT_ClassDefinitionError): void;
  get(): WNT_ClassDefinitionError;
  delete(): void;
}

  export declare class Handle_WNT_ClassDefinitionError_1 extends Handle_WNT_ClassDefinitionError {
    constructor();
  }

  export declare class Handle_WNT_ClassDefinitionError_2 extends Handle_WNT_ClassDefinitionError {
    constructor(thePtr: WNT_ClassDefinitionError);
  }

  export declare class Handle_WNT_ClassDefinitionError_3 extends Handle_WNT_ClassDefinitionError {
    constructor(theHandle: Handle_WNT_ClassDefinitionError);
  }

  export declare class Handle_WNT_ClassDefinitionError_4 extends Handle_WNT_ClassDefinitionError {
    constructor(theHandle: Handle_WNT_ClassDefinitionError);
  }

export declare class WNT_ClassDefinitionError extends Standard_ConstructionError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_WNT_ClassDefinitionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class WNT_ClassDefinitionError_1 extends WNT_ClassDefinitionError {
    constructor();
  }

  export declare class WNT_ClassDefinitionError_2 extends WNT_ClassDefinitionError {
    constructor(theMessage: Standard_CString);
  }

export declare class LDOM_CharReference {
  constructor();
  static Decode(theSrc: Standard_Character, theLen: Graphic3d_ZLayerId): Standard_Character;
  static Encode(theSrc: Standard_Character, theLen: Graphic3d_ZLayerId, isAttribute: Standard_Boolean): Standard_Character;
  delete(): void;
}

export declare class LDOM_NodeList {
  item(a0: Graphic3d_ZLayerId): LDOM_Node;
  getLength(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class LDOM_NodeList_1 extends LDOM_NodeList {
    constructor();
  }

  export declare class LDOM_NodeList_2 extends LDOM_NodeList {
    constructor(theOther: LDOM_NodeList);
  }

export declare class LDOM_CDATASection extends LDOM_Text {
  delete(): void;
}

  export declare class LDOM_CDATASection_1 extends LDOM_CDATASection {
    constructor();
  }

  export declare class LDOM_CDATASection_2 extends LDOM_CDATASection {
    constructor(theOther: LDOM_CDATASection);
  }

export declare class LDOM_XmlReader {
  constructor(aDocument: Handle_LDOM_MemManager, anErrorString: XCAFDoc_PartId, theTagPerStep: Standard_Boolean)
  ReadRecord(theIStream: Standard_IStream, theData: LDOM_OSStream): any;
  GetElement(): LDOM_BasicElement;
  CreateElement(theName: Standard_Character, theLen: Graphic3d_ZLayerId): void;
  static getInteger(theValue: LDOMBasicString, theStart: Standard_Character, theEnd: Standard_Character): Standard_Boolean;
  GetBOM(): any;
  delete(): void;
}

export declare class LDOM_Text extends LDOM_CharacterData {
  delete(): void;
}

  export declare class LDOM_Text_1 extends LDOM_Text {
    constructor();
  }

  export declare class LDOM_Text_2 extends LDOM_Text {
    constructor(anOther: LDOM_Text);
  }

export declare class LDOM_MemManager extends Standard_Transient {
  constructor(aBlockSize: Graphic3d_ZLayerId)
  Allocate(aSize: Graphic3d_ZLayerId): C_f;
  HashedAllocate_1(aString: Standard_Character, theLen: Graphic3d_ZLayerId, theHash: Graphic3d_ZLayerId): Standard_Character;
  HashedAllocate_2(aString: Standard_Character, theLen: Graphic3d_ZLayerId, theResult: LDOMBasicString): void;
  static Hash(theString: Standard_Character, theLen: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static CompareStrings(theString: Standard_Character, theHashValue: Graphic3d_ZLayerId, theHashedStr: Standard_Character): Standard_Boolean;
  RootElement(): LDOM_BasicElement;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_LDOM_MemManager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: LDOM_MemManager): void;
  get(): LDOM_MemManager;
  delete(): void;
}

  export declare class Handle_LDOM_MemManager_1 extends Handle_LDOM_MemManager {
    constructor();
  }

  export declare class Handle_LDOM_MemManager_2 extends Handle_LDOM_MemManager {
    constructor(thePtr: LDOM_MemManager);
  }

  export declare class Handle_LDOM_MemManager_3 extends Handle_LDOM_MemManager {
    constructor(theHandle: Handle_LDOM_MemManager);
  }

  export declare class Handle_LDOM_MemManager_4 extends Handle_LDOM_MemManager {
    constructor(theHandle: Handle_LDOM_MemManager);
  }

export declare class LDOM_Attr extends LDOM_Node {
  getName(): XmlObjMgt_DOMString;
  getValue(): XmlObjMgt_DOMString;
  setValue(aValue: XmlObjMgt_DOMString): void;
  delete(): void;
}

  export declare class LDOM_Attr_1 extends LDOM_Attr {
    constructor();
  }

  export declare class LDOM_Attr_2 extends LDOM_Attr {
    constructor(anOther: LDOM_Attr);
  }

export declare class LDOM_OSStream extends Standard_OStream {
  constructor(theMaxBuf: Graphic3d_ZLayerId)
  str(): Standard_CString;
  Length(): Graphic3d_ZLayerId;
  Clear(): void;
  delete(): void;
}

export declare class LDOM_SBuffer {
  constructor(theMaxBuf: Graphic3d_ZLayerId)
  str(): Standard_CString;
  Length(): Graphic3d_ZLayerId;
  Clear(): void;
  overflow(c: Standard_Integer): Standard_Integer;
  underflow(): Standard_Integer;
  xsputn(s: Standard_Character, n: any): any;
  delete(): void;
}

export declare class LDOMBasicString {
  Type(): any;
  GetInteger(aResult: Graphic3d_ZLayerId): Standard_Boolean;
  GetString(): Standard_Character;
  equals(anOther: LDOMBasicString): Standard_Boolean;
  delete(): void;
}

  export declare class LDOMBasicString_1 extends LDOMBasicString {
    constructor();
  }

  export declare class LDOMBasicString_2 extends LDOMBasicString {
    constructor(anOther: LDOMBasicString);
  }

  export declare class LDOMBasicString_3 extends LDOMBasicString {
    constructor(aValue: Graphic3d_ZLayerId);
  }

  export declare class LDOMBasicString_4 extends LDOMBasicString {
    constructor(aValue: Standard_Character);
  }

  export declare class LDOMBasicString_5 extends LDOMBasicString {
    constructor(aValue: Standard_Character, aDoc: Handle_LDOM_MemManager);
  }

  export declare class LDOMBasicString_6 extends LDOMBasicString {
    constructor(aValue: Standard_Character, aLen: Graphic3d_ZLayerId, aDoc: Handle_LDOM_MemManager);
  }

export declare class LDOM_BasicText extends LDOM_BasicNode {
  constructor()
  GetData(): LDOMBasicString;
  SetData(aValue: LDOMBasicString, aDoc: Handle_LDOM_MemManager): void;
  delete(): void;
}

export declare class LDOM_CharacterData extends LDOM_Node {
  getData(): XmlObjMgt_DOMString;
  setData(aValue: XmlObjMgt_DOMString): void;
  getLength(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class LDOM_CharacterData_1 extends LDOM_CharacterData {
    constructor();
  }

  export declare class LDOM_CharacterData_2 extends LDOM_CharacterData {
    constructor(theOther: LDOM_CharacterData);
  }

export declare class LDOM_BasicAttribute extends LDOM_BasicNode {
  constructor()
  GetName(): Standard_Character;
  GetValue(): LDOMBasicString;
  SetValue(aValue: LDOMBasicString, aDoc: Handle_LDOM_MemManager): void;
  delete(): void;
}

export declare class LDOM_Node {
  isNull(): Standard_Boolean;
  getNodeType(): any;
  getNodeName(): XmlObjMgt_DOMString;
  getNodeValue(): XmlObjMgt_DOMString;
  getFirstChild(): LDOM_Node;
  getLastChild(): LDOM_Node;
  getNextSibling(): LDOM_Node;
  removeChild(aChild: LDOM_Node): void;
  appendChild(aChild: LDOM_Node): void;
  hasChildNodes(): Standard_Boolean;
  SetValueClear(): void;
  delete(): void;
}

  export declare class LDOM_Node_1 extends LDOM_Node {
    constructor();
  }

  export declare class LDOM_Node_2 extends LDOM_Node {
    constructor(anOther: LDOM_Node);
  }

export declare class LDOM_LDOMImplementation {
  constructor();
  static createDocument(aNamespaceURI: XmlObjMgt_DOMString, aQualifiedName: XmlObjMgt_DOMString, aDocType: LDOM_DocumentType): XmlObjMgt_Document;
  delete(): void;
}

export declare class LDOMParser {
  constructor()
  getDocument(): XmlObjMgt_Document;
  parse_1(aFileName: Standard_Character): Standard_Boolean;
  parse_2(anInput: Standard_IStream, theTagPerStep: Standard_Boolean, theWithoutRoot: Standard_Boolean): Standard_Boolean;
  GetError(aData: XCAFDoc_PartId): XCAFDoc_PartId;
  GetBOM(): any;
  delete(): void;
}

export declare class LDOM_Element extends LDOM_Node {
  getTagName(): XmlObjMgt_DOMString;
  getAttribute(aName: XmlObjMgt_DOMString): XmlObjMgt_DOMString;
  getAttributeNode(aName: XmlObjMgt_DOMString): LDOM_Attr;
  getElementsByTagName(aName: XmlObjMgt_DOMString): LDOM_NodeList;
  setAttribute(aName: XmlObjMgt_DOMString, aValue: XmlObjMgt_DOMString): void;
  setAttributeNode(aNewAttr: LDOM_Attr): void;
  removeAttribute(aName: XmlObjMgt_DOMString): void;
  GetChildByTagName(aTagName: XmlObjMgt_DOMString): XmlObjMgt_Element;
  GetSiblingByTagName(): XmlObjMgt_Element;
  ReplaceElement(anOther: XmlObjMgt_Element): void;
  GetAttributesList(): LDOM_NodeList;
  delete(): void;
}

  export declare class LDOM_Element_1 extends LDOM_Element {
    constructor();
  }

  export declare class LDOM_Element_2 extends LDOM_Element {
    constructor(anOther: XmlObjMgt_Element);
  }

export declare class LDOM_DocumentType {
  constructor()
  delete(): void;
}

export declare class LDOM_BasicNode {
  isNull(): Standard_Boolean;
  getNodeType(): any;
  GetSibling(): LDOM_BasicNode;
  delete(): void;
}

export declare class LDOM_Comment extends LDOM_CharacterData {
  delete(): void;
}

  export declare class LDOM_Comment_1 extends LDOM_Comment {
    constructor();
  }

  export declare class LDOM_Comment_2 extends LDOM_Comment {
    constructor(theOther: LDOM_Comment);
  }

export declare class LDOM_XmlWriter {
  constructor(theEncoding: Standard_Character)
  SetIndentation(theIndent: Graphic3d_ZLayerId): void;
  Write_1(theOStream: Standard_OStream, theDoc: XmlObjMgt_Document): void;
  Write_2(theOStream: Standard_OStream, theNode: LDOM_Node): void;
  delete(): void;
}

export declare class LDOM_BasicElement extends LDOM_BasicNode {
  constructor()
  static Create(aName: Standard_Character, aLength: Graphic3d_ZLayerId, aDoc: Handle_LDOM_MemManager): LDOM_BasicElement;
  GetTagName(): Standard_Character;
  GetFirstChild(): LDOM_BasicNode;
  GetLastChild(): LDOM_BasicNode;
  GetAttribute(aName: LDOMBasicString, aLastCh: LDOM_BasicNode): LDOM_BasicAttribute;
  delete(): void;
}

export declare class LDOM_Document {
  static createDocument(theQualifiedName: XmlObjMgt_DOMString): XmlObjMgt_Document;
  createElement(theTagName: XmlObjMgt_DOMString): XmlObjMgt_Element;
  createCDATASection(theData: XmlObjMgt_DOMString): LDOM_CDATASection;
  createComment(theData: XmlObjMgt_DOMString): LDOM_Comment;
  createTextNode(theData: XmlObjMgt_DOMString): LDOM_Text;
  getDocumentElement(): XmlObjMgt_Element;
  getElementsByTagName(theTagName: XmlObjMgt_DOMString): LDOM_NodeList;
  isNull(): Standard_Boolean;
  delete(): void;
}

  export declare class LDOM_Document_1 extends LDOM_Document {
    constructor();
  }

  export declare class LDOM_Document_2 extends LDOM_Document {
    constructor(aMemManager: LDOM_MemManager);
  }

export declare class LDOMString extends LDOMBasicString {
  delete(): void;
}

  export declare class LDOMString_1 extends LDOMString {
    constructor();
  }

  export declare class LDOMString_2 extends LDOMString {
    constructor(anOther: XmlObjMgt_DOMString);
  }

  export declare class LDOMString_3 extends LDOMString {
    constructor(aValue: Graphic3d_ZLayerId);
  }

  export declare class LDOMString_4 extends LDOMString {
    constructor(aValue: Standard_Character);
  }

export declare class IGESGraph_TextFontDef extends IGESData_IGESEntity {
  constructor()
  Init(aFontCode: Graphic3d_ZLayerId, aFontName: Handle_TCollection_HAsciiString, aSupersededFont: Graphic3d_ZLayerId, aSupersededEntity: Handle_IGESGraph_TextFontDef, aScale: Graphic3d_ZLayerId, allASCIICodes: Handle_TColStd_HArray1OfInteger, allNextCharX: Handle_TColStd_HArray1OfInteger, allNextCharY: Handle_TColStd_HArray1OfInteger, allPenMotions: Handle_TColStd_HArray1OfInteger, allPenFlags: Handle_IGESBasic_HArray1OfHArray1OfInteger, allMovePenToX: Handle_IGESBasic_HArray1OfHArray1OfInteger, allMovePenToY: Handle_IGESBasic_HArray1OfHArray1OfInteger): void;
  FontCode(): Graphic3d_ZLayerId;
  FontName(): Handle_TCollection_HAsciiString;
  IsSupersededFontEntity(): Standard_Boolean;
  SupersededFontCode(): Graphic3d_ZLayerId;
  SupersededFontEntity(): Handle_IGESGraph_TextFontDef;
  Scale(): Graphic3d_ZLayerId;
  NbCharacters(): Graphic3d_ZLayerId;
  ASCIICode(Chnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NextCharOrigin(Chnum: Graphic3d_ZLayerId, NX: Graphic3d_ZLayerId, NY: Graphic3d_ZLayerId): void;
  NbPenMotions(Chnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsPenUp(Chnum: Graphic3d_ZLayerId, Motionnum: Graphic3d_ZLayerId): Standard_Boolean;
  NextPenPosition(Chnum: Graphic3d_ZLayerId, Motionnum: Graphic3d_ZLayerId, IX: Graphic3d_ZLayerId, IY: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_TextFontDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_TextFontDef): void;
  get(): IGESGraph_TextFontDef;
  delete(): void;
}

  export declare class Handle_IGESGraph_TextFontDef_1 extends Handle_IGESGraph_TextFontDef {
    constructor();
  }

  export declare class Handle_IGESGraph_TextFontDef_2 extends Handle_IGESGraph_TextFontDef {
    constructor(thePtr: IGESGraph_TextFontDef);
  }

  export declare class Handle_IGESGraph_TextFontDef_3 extends Handle_IGESGraph_TextFontDef {
    constructor(theHandle: Handle_IGESGraph_TextFontDef);
  }

  export declare class Handle_IGESGraph_TextFontDef_4 extends Handle_IGESGraph_TextFontDef {
    constructor(theHandle: Handle_IGESGraph_TextFontDef);
  }

export declare class IGESGraph_IntercharacterSpacing extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, anISpace: Quantity_AbsorbedDose): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  ISpace(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_IntercharacterSpacing {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_IntercharacterSpacing): void;
  get(): IGESGraph_IntercharacterSpacing;
  delete(): void;
}

  export declare class Handle_IGESGraph_IntercharacterSpacing_1 extends Handle_IGESGraph_IntercharacterSpacing {
    constructor();
  }

  export declare class Handle_IGESGraph_IntercharacterSpacing_2 extends Handle_IGESGraph_IntercharacterSpacing {
    constructor(thePtr: IGESGraph_IntercharacterSpacing);
  }

  export declare class Handle_IGESGraph_IntercharacterSpacing_3 extends Handle_IGESGraph_IntercharacterSpacing {
    constructor(theHandle: Handle_IGESGraph_IntercharacterSpacing);
  }

  export declare class Handle_IGESGraph_IntercharacterSpacing_4 extends Handle_IGESGraph_IntercharacterSpacing {
    constructor(theHandle: Handle_IGESGraph_IntercharacterSpacing);
  }

export declare class IGESGraph_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_ReadWriteModule): void;
  get(): IGESGraph_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESGraph_ReadWriteModule_1 extends Handle_IGESGraph_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESGraph_ReadWriteModule_2 extends Handle_IGESGraph_ReadWriteModule {
    constructor(thePtr: IGESGraph_ReadWriteModule);
  }

  export declare class Handle_IGESGraph_ReadWriteModule_3 extends Handle_IGESGraph_ReadWriteModule {
    constructor(theHandle: Handle_IGESGraph_ReadWriteModule);
  }

  export declare class Handle_IGESGraph_ReadWriteModule_4 extends Handle_IGESGraph_ReadWriteModule {
    constructor(theHandle: Handle_IGESGraph_ReadWriteModule);
  }

export declare class IGESGraph_TextDisplayTemplate extends IGESData_IGESEntity {
  constructor()
  Init(aWidth: Quantity_AbsorbedDose, aHeight: Quantity_AbsorbedDose, aFontCode: Graphic3d_ZLayerId, aFontEntity: Handle_IGESGraph_TextFontDef, aSlantAngle: Quantity_AbsorbedDose, aRotationAngle: Quantity_AbsorbedDose, aMirrorFlag: Graphic3d_ZLayerId, aRotationFlag: Graphic3d_ZLayerId, aCorner: gp_XYZ): void;
  SetIncremental(mode: Standard_Boolean): void;
  IsIncremental(): Standard_Boolean;
  BoxWidth(): Quantity_AbsorbedDose;
  BoxHeight(): Quantity_AbsorbedDose;
  IsFontEntity(): Standard_Boolean;
  FontCode(): Graphic3d_ZLayerId;
  FontEntity(): Handle_IGESGraph_TextFontDef;
  SlantAngle(): Quantity_AbsorbedDose;
  RotationAngle(): Quantity_AbsorbedDose;
  MirrorFlag(): Graphic3d_ZLayerId;
  RotateFlag(): Graphic3d_ZLayerId;
  StartingCorner(): gp_Pnt;
  TransformedStartingCorner(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_TextDisplayTemplate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_TextDisplayTemplate): void;
  get(): IGESGraph_TextDisplayTemplate;
  delete(): void;
}

  export declare class Handle_IGESGraph_TextDisplayTemplate_1 extends Handle_IGESGraph_TextDisplayTemplate {
    constructor();
  }

  export declare class Handle_IGESGraph_TextDisplayTemplate_2 extends Handle_IGESGraph_TextDisplayTemplate {
    constructor(thePtr: IGESGraph_TextDisplayTemplate);
  }

  export declare class Handle_IGESGraph_TextDisplayTemplate_3 extends Handle_IGESGraph_TextDisplayTemplate {
    constructor(theHandle: Handle_IGESGraph_TextDisplayTemplate);
  }

  export declare class Handle_IGESGraph_TextDisplayTemplate_4 extends Handle_IGESGraph_TextDisplayTemplate {
    constructor(theHandle: Handle_IGESGraph_TextDisplayTemplate);
  }

export declare class IGESGraph_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_SpecificModule): void;
  get(): IGESGraph_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESGraph_SpecificModule_1 extends Handle_IGESGraph_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESGraph_SpecificModule_2 extends Handle_IGESGraph_SpecificModule {
    constructor(thePtr: IGESGraph_SpecificModule);
  }

  export declare class Handle_IGESGraph_SpecificModule_3 extends Handle_IGESGraph_SpecificModule {
    constructor(theHandle: Handle_IGESGraph_SpecificModule);
  }

  export declare class Handle_IGESGraph_SpecificModule_4 extends Handle_IGESGraph_SpecificModule {
    constructor(theHandle: Handle_IGESGraph_SpecificModule);
  }

export declare class IGESGraph_LineFontPredefined extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, aLineFontPatternCode: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  LineFontPatternCode(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_LineFontPredefined {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_LineFontPredefined): void;
  get(): IGESGraph_LineFontPredefined;
  delete(): void;
}

  export declare class Handle_IGESGraph_LineFontPredefined_1 extends Handle_IGESGraph_LineFontPredefined {
    constructor();
  }

  export declare class Handle_IGESGraph_LineFontPredefined_2 extends Handle_IGESGraph_LineFontPredefined {
    constructor(thePtr: IGESGraph_LineFontPredefined);
  }

  export declare class Handle_IGESGraph_LineFontPredefined_3 extends Handle_IGESGraph_LineFontPredefined {
    constructor(theHandle: Handle_IGESGraph_LineFontPredefined);
  }

  export declare class Handle_IGESGraph_LineFontPredefined_4 extends Handle_IGESGraph_LineFontPredefined {
    constructor(theHandle: Handle_IGESGraph_LineFontPredefined);
  }

export declare class Handle_IGESGraph_DrawingSize {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_DrawingSize): void;
  get(): IGESGraph_DrawingSize;
  delete(): void;
}

  export declare class Handle_IGESGraph_DrawingSize_1 extends Handle_IGESGraph_DrawingSize {
    constructor();
  }

  export declare class Handle_IGESGraph_DrawingSize_2 extends Handle_IGESGraph_DrawingSize {
    constructor(thePtr: IGESGraph_DrawingSize);
  }

  export declare class Handle_IGESGraph_DrawingSize_3 extends Handle_IGESGraph_DrawingSize {
    constructor(theHandle: Handle_IGESGraph_DrawingSize);
  }

  export declare class Handle_IGESGraph_DrawingSize_4 extends Handle_IGESGraph_DrawingSize {
    constructor(theHandle: Handle_IGESGraph_DrawingSize);
  }

export declare class IGESGraph_DrawingSize extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, aXSize: Quantity_AbsorbedDose, aYSize: Quantity_AbsorbedDose): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  XSize(): Quantity_AbsorbedDose;
  YSize(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_ToolUniformRectGrid {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_UniformRectGrid, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_UniformRectGrid, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_UniformRectGrid, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_UniformRectGrid): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_UniformRectGrid): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_UniformRectGrid, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_UniformRectGrid, entto: Handle_IGESGraph_UniformRectGrid, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_UniformRectGrid, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGraph {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESGraph_Protocol;
  delete(): void;
}

export declare class Handle_IGESGraph_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_Protocol): void;
  get(): IGESGraph_Protocol;
  delete(): void;
}

  export declare class Handle_IGESGraph_Protocol_1 extends Handle_IGESGraph_Protocol {
    constructor();
  }

  export declare class Handle_IGESGraph_Protocol_2 extends Handle_IGESGraph_Protocol {
    constructor(thePtr: IGESGraph_Protocol);
  }

  export declare class Handle_IGESGraph_Protocol_3 extends Handle_IGESGraph_Protocol {
    constructor(theHandle: Handle_IGESGraph_Protocol);
  }

  export declare class Handle_IGESGraph_Protocol_4 extends Handle_IGESGraph_Protocol {
    constructor(theHandle: Handle_IGESGraph_Protocol);
  }

export declare class IGESGraph_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_ToolIntercharacterSpacing {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_IntercharacterSpacing, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_IntercharacterSpacing, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_IntercharacterSpacing, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_IntercharacterSpacing): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_IntercharacterSpacing): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_IntercharacterSpacing, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_IntercharacterSpacing, entto: Handle_IGESGraph_IntercharacterSpacing, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_IntercharacterSpacing, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGraph_ToolLineFontPredefined {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_LineFontPredefined, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_LineFontPredefined, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_LineFontPredefined, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_LineFontPredefined): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_LineFontPredefined): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_LineFontPredefined, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_LineFontPredefined, entto: Handle_IGESGraph_LineFontPredefined, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_LineFontPredefined, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGraph_ToolPick {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_Pick, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_Pick, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_Pick, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_Pick): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_Pick): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_Pick, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_Pick, entto: Handle_IGESGraph_Pick, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_Pick, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_LineFontDefTemplate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_LineFontDefTemplate): void;
  get(): IGESGraph_LineFontDefTemplate;
  delete(): void;
}

  export declare class Handle_IGESGraph_LineFontDefTemplate_1 extends Handle_IGESGraph_LineFontDefTemplate {
    constructor();
  }

  export declare class Handle_IGESGraph_LineFontDefTemplate_2 extends Handle_IGESGraph_LineFontDefTemplate {
    constructor(thePtr: IGESGraph_LineFontDefTemplate);
  }

  export declare class Handle_IGESGraph_LineFontDefTemplate_3 extends Handle_IGESGraph_LineFontDefTemplate {
    constructor(theHandle: Handle_IGESGraph_LineFontDefTemplate);
  }

  export declare class Handle_IGESGraph_LineFontDefTemplate_4 extends Handle_IGESGraph_LineFontDefTemplate {
    constructor(theHandle: Handle_IGESGraph_LineFontDefTemplate);
  }

export declare class IGESGraph_LineFontDefTemplate extends IGESData_LineFontEntity {
  constructor()
  Init(anOrientation: Graphic3d_ZLayerId, aTemplate: Handle_IGESBasic_SubfigureDef, aDistance: Quantity_AbsorbedDose, aScale: Quantity_AbsorbedDose): void;
  Orientation(): Graphic3d_ZLayerId;
  TemplateEntity(): Handle_IGESBasic_SubfigureDef;
  Distance(): Quantity_AbsorbedDose;
  Scale(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_ToolLineFontDefTemplate {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_LineFontDefTemplate, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_LineFontDefTemplate, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_LineFontDefTemplate, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGraph_LineFontDefTemplate): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_LineFontDefTemplate, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_LineFontDefTemplate, entto: Handle_IGESGraph_LineFontDefTemplate, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_LineFontDefTemplate, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGraph_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_GeneralModule): void;
  get(): IGESGraph_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESGraph_GeneralModule_1 extends Handle_IGESGraph_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESGraph_GeneralModule_2 extends Handle_IGESGraph_GeneralModule {
    constructor(thePtr: IGESGraph_GeneralModule);
  }

  export declare class Handle_IGESGraph_GeneralModule_3 extends Handle_IGESGraph_GeneralModule {
    constructor(theHandle: Handle_IGESGraph_GeneralModule);
  }

  export declare class Handle_IGESGraph_GeneralModule_4 extends Handle_IGESGraph_GeneralModule {
    constructor(theHandle: Handle_IGESGraph_GeneralModule);
  }

export declare class IGESGraph_DrawingUnits extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, aFlag: Graphic3d_ZLayerId, aUnit: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  Flag(): Graphic3d_ZLayerId;
  Unit(): Handle_TCollection_HAsciiString;
  UnitValue(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_DrawingUnits {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_DrawingUnits): void;
  get(): IGESGraph_DrawingUnits;
  delete(): void;
}

  export declare class Handle_IGESGraph_DrawingUnits_1 extends Handle_IGESGraph_DrawingUnits {
    constructor();
  }

  export declare class Handle_IGESGraph_DrawingUnits_2 extends Handle_IGESGraph_DrawingUnits {
    constructor(thePtr: IGESGraph_DrawingUnits);
  }

  export declare class Handle_IGESGraph_DrawingUnits_3 extends Handle_IGESGraph_DrawingUnits {
    constructor(theHandle: Handle_IGESGraph_DrawingUnits);
  }

  export declare class Handle_IGESGraph_DrawingUnits_4 extends Handle_IGESGraph_DrawingUnits {
    constructor(theHandle: Handle_IGESGraph_DrawingUnits);
  }

export declare class IGESGraph_ToolHighLight {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_HighLight, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_HighLight, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_HighLight, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_HighLight): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_HighLight): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_HighLight, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_HighLight, entto: Handle_IGESGraph_HighLight, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_HighLight, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_NominalSize {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_NominalSize): void;
  get(): IGESGraph_NominalSize;
  delete(): void;
}

  export declare class Handle_IGESGraph_NominalSize_1 extends Handle_IGESGraph_NominalSize {
    constructor();
  }

  export declare class Handle_IGESGraph_NominalSize_2 extends Handle_IGESGraph_NominalSize {
    constructor(thePtr: IGESGraph_NominalSize);
  }

  export declare class Handle_IGESGraph_NominalSize_3 extends Handle_IGESGraph_NominalSize {
    constructor(theHandle: Handle_IGESGraph_NominalSize);
  }

  export declare class Handle_IGESGraph_NominalSize_4 extends Handle_IGESGraph_NominalSize {
    constructor(theHandle: Handle_IGESGraph_NominalSize);
  }

export declare class IGESGraph_NominalSize extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, aNominalSizeValue: Quantity_AbsorbedDose, aNominalSizeName: Handle_TCollection_HAsciiString, aStandardName: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  NominalSizeValue(): Quantity_AbsorbedDose;
  NominalSizeName(): Handle_TCollection_HAsciiString;
  HasStandardName(): Standard_Boolean;
  StandardName(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_ToolTextDisplayTemplate {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_TextDisplayTemplate, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_TextDisplayTemplate, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_TextDisplayTemplate, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGraph_TextDisplayTemplate): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_TextDisplayTemplate, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_TextDisplayTemplate, entto: Handle_IGESGraph_TextDisplayTemplate, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_TextDisplayTemplate, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_Pick {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_Pick): void;
  get(): IGESGraph_Pick;
  delete(): void;
}

  export declare class Handle_IGESGraph_Pick_1 extends Handle_IGESGraph_Pick {
    constructor();
  }

  export declare class Handle_IGESGraph_Pick_2 extends Handle_IGESGraph_Pick {
    constructor(thePtr: IGESGraph_Pick);
  }

  export declare class Handle_IGESGraph_Pick_3 extends Handle_IGESGraph_Pick {
    constructor(theHandle: Handle_IGESGraph_Pick);
  }

  export declare class Handle_IGESGraph_Pick_4 extends Handle_IGESGraph_Pick {
    constructor(theHandle: Handle_IGESGraph_Pick);
  }

export declare class IGESGraph_Pick extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, aPickStatus: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  PickFlag(): Graphic3d_ZLayerId;
  IsPickable(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_HighLight extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, aHighLightStatus: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  HighLightStatus(): Graphic3d_ZLayerId;
  IsHighLighted(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_HighLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_HighLight): void;
  get(): IGESGraph_HighLight;
  delete(): void;
}

  export declare class Handle_IGESGraph_HighLight_1 extends Handle_IGESGraph_HighLight {
    constructor();
  }

  export declare class Handle_IGESGraph_HighLight_2 extends Handle_IGESGraph_HighLight {
    constructor(thePtr: IGESGraph_HighLight);
  }

  export declare class Handle_IGESGraph_HighLight_3 extends Handle_IGESGraph_HighLight {
    constructor(theHandle: Handle_IGESGraph_HighLight);
  }

  export declare class Handle_IGESGraph_HighLight_4 extends Handle_IGESGraph_HighLight {
    constructor(theHandle: Handle_IGESGraph_HighLight);
  }

export declare class IGESGraph_LineFontDefPattern extends IGESData_LineFontEntity {
  constructor()
  Init(allSegLength: Handle_TColStd_HArray1OfReal, aPattern: Handle_TCollection_HAsciiString): void;
  NbSegments(): Graphic3d_ZLayerId;
  Length(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  DisplayPattern(): Handle_TCollection_HAsciiString;
  IsVisible(Index: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_LineFontDefPattern {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_LineFontDefPattern): void;
  get(): IGESGraph_LineFontDefPattern;
  delete(): void;
}

  export declare class Handle_IGESGraph_LineFontDefPattern_1 extends Handle_IGESGraph_LineFontDefPattern {
    constructor();
  }

  export declare class Handle_IGESGraph_LineFontDefPattern_2 extends Handle_IGESGraph_LineFontDefPattern {
    constructor(thePtr: IGESGraph_LineFontDefPattern);
  }

  export declare class Handle_IGESGraph_LineFontDefPattern_3 extends Handle_IGESGraph_LineFontDefPattern {
    constructor(theHandle: Handle_IGESGraph_LineFontDefPattern);
  }

  export declare class Handle_IGESGraph_LineFontDefPattern_4 extends Handle_IGESGraph_LineFontDefPattern {
    constructor(theHandle: Handle_IGESGraph_LineFontDefPattern);
  }

export declare class IGESGraph_ToolDefinitionLevel {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_DefinitionLevel, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_DefinitionLevel, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_DefinitionLevel, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGraph_DefinitionLevel): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_DefinitionLevel, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_DefinitionLevel, entto: Handle_IGESGraph_DefinitionLevel, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_DefinitionLevel, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_HArray1OfTextFontDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_HArray1OfTextFontDef): void;
  get(): IGESGraph_HArray1OfTextFontDef;
  delete(): void;
}

  export declare class Handle_IGESGraph_HArray1OfTextFontDef_1 extends Handle_IGESGraph_HArray1OfTextFontDef {
    constructor();
  }

  export declare class Handle_IGESGraph_HArray1OfTextFontDef_2 extends Handle_IGESGraph_HArray1OfTextFontDef {
    constructor(thePtr: IGESGraph_HArray1OfTextFontDef);
  }

  export declare class Handle_IGESGraph_HArray1OfTextFontDef_3 extends Handle_IGESGraph_HArray1OfTextFontDef {
    constructor(theHandle: Handle_IGESGraph_HArray1OfTextFontDef);
  }

  export declare class Handle_IGESGraph_HArray1OfTextFontDef_4 extends Handle_IGESGraph_HArray1OfTextFontDef {
    constructor(theHandle: Handle_IGESGraph_HArray1OfTextFontDef);
  }

export declare class IGESGraph_ToolNominalSize {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_NominalSize, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_NominalSize, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_NominalSize, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_NominalSize): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_NominalSize): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_NominalSize, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_NominalSize, entto: Handle_IGESGraph_NominalSize, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_NominalSize, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGraph_ToolTextFontDef {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_TextFontDef, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_TextFontDef, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_TextFontDef, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGraph_TextFontDef): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_TextFontDef, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_TextFontDef, entto: Handle_IGESGraph_TextFontDef, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_TextFontDef, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_HArray1OfTextDisplayTemplate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_HArray1OfTextDisplayTemplate): void;
  get(): IGESGraph_HArray1OfTextDisplayTemplate;
  delete(): void;
}

  export declare class Handle_IGESGraph_HArray1OfTextDisplayTemplate_1 extends Handle_IGESGraph_HArray1OfTextDisplayTemplate {
    constructor();
  }

  export declare class Handle_IGESGraph_HArray1OfTextDisplayTemplate_2 extends Handle_IGESGraph_HArray1OfTextDisplayTemplate {
    constructor(thePtr: IGESGraph_HArray1OfTextDisplayTemplate);
  }

  export declare class Handle_IGESGraph_HArray1OfTextDisplayTemplate_3 extends Handle_IGESGraph_HArray1OfTextDisplayTemplate {
    constructor(theHandle: Handle_IGESGraph_HArray1OfTextDisplayTemplate);
  }

  export declare class Handle_IGESGraph_HArray1OfTextDisplayTemplate_4 extends Handle_IGESGraph_HArray1OfTextDisplayTemplate {
    constructor(theHandle: Handle_IGESGraph_HArray1OfTextDisplayTemplate);
  }

export declare class IGESGraph_ToolLineFontDefPattern {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_LineFontDefPattern, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_LineFontDefPattern, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_LineFontDefPattern, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGraph_LineFontDefPattern): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_LineFontDefPattern, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_LineFontDefPattern, entto: Handle_IGESGraph_LineFontDefPattern, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_LineFontDefPattern, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_HArray1OfColor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_HArray1OfColor): void;
  get(): IGESGraph_HArray1OfColor;
  delete(): void;
}

  export declare class Handle_IGESGraph_HArray1OfColor_1 extends Handle_IGESGraph_HArray1OfColor {
    constructor();
  }

  export declare class Handle_IGESGraph_HArray1OfColor_2 extends Handle_IGESGraph_HArray1OfColor {
    constructor(thePtr: IGESGraph_HArray1OfColor);
  }

  export declare class Handle_IGESGraph_HArray1OfColor_3 extends Handle_IGESGraph_HArray1OfColor {
    constructor(theHandle: Handle_IGESGraph_HArray1OfColor);
  }

  export declare class Handle_IGESGraph_HArray1OfColor_4 extends Handle_IGESGraph_HArray1OfColor {
    constructor(theHandle: Handle_IGESGraph_HArray1OfColor);
  }

export declare class IGESGraph_DefinitionLevel extends IGESData_LevelListEntity {
  constructor()
  Init(allLevelNumbers: Handle_TColStd_HArray1OfInteger): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  NbLevelNumbers(): Graphic3d_ZLayerId;
  LevelNumber(LevelIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESGraph_DefinitionLevel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_DefinitionLevel): void;
  get(): IGESGraph_DefinitionLevel;
  delete(): void;
}

  export declare class Handle_IGESGraph_DefinitionLevel_1 extends Handle_IGESGraph_DefinitionLevel {
    constructor();
  }

  export declare class Handle_IGESGraph_DefinitionLevel_2 extends Handle_IGESGraph_DefinitionLevel {
    constructor(thePtr: IGESGraph_DefinitionLevel);
  }

  export declare class Handle_IGESGraph_DefinitionLevel_3 extends Handle_IGESGraph_DefinitionLevel {
    constructor(theHandle: Handle_IGESGraph_DefinitionLevel);
  }

  export declare class Handle_IGESGraph_DefinitionLevel_4 extends Handle_IGESGraph_DefinitionLevel {
    constructor(theHandle: Handle_IGESGraph_DefinitionLevel);
  }

export declare class Handle_IGESGraph_UniformRectGrid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_UniformRectGrid): void;
  get(): IGESGraph_UniformRectGrid;
  delete(): void;
}

  export declare class Handle_IGESGraph_UniformRectGrid_1 extends Handle_IGESGraph_UniformRectGrid {
    constructor();
  }

  export declare class Handle_IGESGraph_UniformRectGrid_2 extends Handle_IGESGraph_UniformRectGrid {
    constructor(thePtr: IGESGraph_UniformRectGrid);
  }

  export declare class Handle_IGESGraph_UniformRectGrid_3 extends Handle_IGESGraph_UniformRectGrid {
    constructor(theHandle: Handle_IGESGraph_UniformRectGrid);
  }

  export declare class Handle_IGESGraph_UniformRectGrid_4 extends Handle_IGESGraph_UniformRectGrid {
    constructor(theHandle: Handle_IGESGraph_UniformRectGrid);
  }

export declare class IGESGraph_UniformRectGrid extends IGESData_IGESEntity {
  constructor()
  Init(nbProps: Graphic3d_ZLayerId, finite: Graphic3d_ZLayerId, line: Graphic3d_ZLayerId, weighted: Graphic3d_ZLayerId, aGridPoint: gp_XY, aGridSpacing: gp_XY, pointsX: Graphic3d_ZLayerId, pointsY: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  IsFinite(): Standard_Boolean;
  IsLine(): Standard_Boolean;
  IsWeighted(): Standard_Boolean;
  GridPoint(): gp_Pnt2d;
  GridSpacing(): gp_Vec2d;
  NbPointsX(): Graphic3d_ZLayerId;
  NbPointsY(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_ToolColor {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_Color, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_Color, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_Color, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESGraph_Color): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_Color, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_Color, entto: Handle_IGESGraph_Color, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_Color, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESGraph_ToolDrawingUnits {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_DrawingUnits, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_DrawingUnits, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_DrawingUnits, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_DrawingUnits): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_DrawingUnits): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_DrawingUnits, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_DrawingUnits, entto: Handle_IGESGraph_DrawingUnits, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_DrawingUnits, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESGraph_Color {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESGraph_Color): void;
  get(): IGESGraph_Color;
  delete(): void;
}

  export declare class Handle_IGESGraph_Color_1 extends Handle_IGESGraph_Color {
    constructor();
  }

  export declare class Handle_IGESGraph_Color_2 extends Handle_IGESGraph_Color {
    constructor(thePtr: IGESGraph_Color);
  }

  export declare class Handle_IGESGraph_Color_3 extends Handle_IGESGraph_Color {
    constructor(theHandle: Handle_IGESGraph_Color);
  }

  export declare class Handle_IGESGraph_Color_4 extends Handle_IGESGraph_Color {
    constructor(theHandle: Handle_IGESGraph_Color);
  }

export declare class IGESGraph_Color extends IGESData_ColorEntity {
  constructor()
  Init(red: Quantity_AbsorbedDose, green: Quantity_AbsorbedDose, blue: Quantity_AbsorbedDose, aColorName: Handle_TCollection_HAsciiString): void;
  RGBIntensity(Red: Quantity_AbsorbedDose, Green: Quantity_AbsorbedDose, Blue: Quantity_AbsorbedDose): void;
  CMYIntensity(Cyan: Quantity_AbsorbedDose, Magenta: Quantity_AbsorbedDose, Yellow: Quantity_AbsorbedDose): void;
  HLSPercentage(Hue: Quantity_AbsorbedDose, Lightness: Quantity_AbsorbedDose, Saturation: Quantity_AbsorbedDose): void;
  HasColorName(): Standard_Boolean;
  ColorName(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESGraph_ToolDrawingSize {
  constructor()
  ReadOwnParams(ent: Handle_IGESGraph_DrawingSize, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESGraph_DrawingSize, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESGraph_DrawingSize, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESGraph_DrawingSize): Standard_Boolean;
  DirChecker(ent: Handle_IGESGraph_DrawingSize): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESGraph_DrawingSize, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESGraph_DrawingSize, entto: Handle_IGESGraph_DrawingSize, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESGraph_DrawingSize, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Intrv_Interval {
  Start(): Quantity_AbsorbedDose;
  End(): Quantity_AbsorbedDose;
  TolStart(): Standard_ShortReal;
  TolEnd(): Standard_ShortReal;
  Bounds(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  SetStart(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal): void;
  FuseAtStart(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal): void;
  CutAtStart(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal): void;
  SetEnd(End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  FuseAtEnd(End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  CutAtEnd(End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  IsProbablyEmpty(): Standard_Boolean;
  Position(Other: Intrv_Interval): Intrv_Position;
  IsBefore(Other: Intrv_Interval): Standard_Boolean;
  IsAfter(Other: Intrv_Interval): Standard_Boolean;
  IsInside(Other: Intrv_Interval): Standard_Boolean;
  IsEnclosing(Other: Intrv_Interval): Standard_Boolean;
  IsJustEnclosingAtStart(Other: Intrv_Interval): Standard_Boolean;
  IsJustEnclosingAtEnd(Other: Intrv_Interval): Standard_Boolean;
  IsJustBefore(Other: Intrv_Interval): Standard_Boolean;
  IsJustAfter(Other: Intrv_Interval): Standard_Boolean;
  IsOverlappingAtStart(Other: Intrv_Interval): Standard_Boolean;
  IsOverlappingAtEnd(Other: Intrv_Interval): Standard_Boolean;
  IsJustOverlappingAtStart(Other: Intrv_Interval): Standard_Boolean;
  IsJustOverlappingAtEnd(Other: Intrv_Interval): Standard_Boolean;
  IsSimilar(Other: Intrv_Interval): Standard_Boolean;
  delete(): void;
}

  export declare class Intrv_Interval_1 extends Intrv_Interval {
    constructor();
  }

  export declare class Intrv_Interval_2 extends Intrv_Interval {
    constructor(Start: Quantity_AbsorbedDose, End: Quantity_AbsorbedDose);
  }

  export declare class Intrv_Interval_3 extends Intrv_Interval {
    constructor(Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal);
  }

export declare type Intrv_Position = {
  Intrv_Before: {};
  Intrv_JustBefore: {};
  Intrv_OverlappingAtStart: {};
  Intrv_JustEnclosingAtEnd: {};
  Intrv_Enclosing: {};
  Intrv_JustOverlappingAtStart: {};
  Intrv_Similar: {};
  Intrv_JustEnclosingAtStart: {};
  Intrv_Inside: {};
  Intrv_JustOverlappingAtEnd: {};
  Intrv_OverlappingAtEnd: {};
  Intrv_JustAfter: {};
  Intrv_After: {};
}

export declare class Intrv_SequenceOfInterval extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Intrv_SequenceOfInterval): Intrv_SequenceOfInterval;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Intrv_Interval): void;
  Append_2(theSeq: Intrv_SequenceOfInterval): void;
  Prepend_1(theItem: Intrv_Interval): void;
  Prepend_2(theSeq: Intrv_SequenceOfInterval): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Intrv_Interval): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Intrv_SequenceOfInterval): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Intrv_SequenceOfInterval): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Intrv_Interval): void;
  Split(theIndex: Standard_Integer, theSeq: Intrv_SequenceOfInterval): void;
  First(): Intrv_Interval;
  ChangeFirst(): Intrv_Interval;
  Last(): Intrv_Interval;
  ChangeLast(): Intrv_Interval;
  Value(theIndex: Standard_Integer): Intrv_Interval;
  ChangeValue(theIndex: Standard_Integer): Intrv_Interval;
  SetValue(theIndex: Standard_Integer, theItem: Intrv_Interval): void;
  delete(): void;
}

  export declare class Intrv_SequenceOfInterval_1 extends Intrv_SequenceOfInterval {
    constructor();
  }

  export declare class Intrv_SequenceOfInterval_2 extends Intrv_SequenceOfInterval {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Intrv_SequenceOfInterval_3 extends Intrv_SequenceOfInterval {
    constructor(theOther: Intrv_SequenceOfInterval);
  }

export declare class Intrv_Intervals {
  Intersect_1(Tool: Intrv_Interval): void;
  Intersect_2(Tool: Intrv_Intervals): void;
  Subtract_1(Tool: Intrv_Interval): void;
  Subtract_2(Tool: Intrv_Intervals): void;
  Unite_1(Tool: Intrv_Interval): void;
  Unite_2(Tool: Intrv_Intervals): void;
  XUnite_1(Tool: Intrv_Interval): void;
  XUnite_2(Tool: Intrv_Intervals): void;
  NbIntervals(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): Intrv_Interval;
  delete(): void;
}

  export declare class Intrv_Intervals_1 extends Intrv_Intervals {
    constructor();
  }

  export declare class Intrv_Intervals_2 extends Intrv_Intervals {
    constructor(Int: Intrv_Interval);
  }

export declare class Handle_XCAFNoteObjects_NoteObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFNoteObjects_NoteObject): void;
  get(): XCAFNoteObjects_NoteObject;
  delete(): void;
}

  export declare class Handle_XCAFNoteObjects_NoteObject_1 extends Handle_XCAFNoteObjects_NoteObject {
    constructor();
  }

  export declare class Handle_XCAFNoteObjects_NoteObject_2 extends Handle_XCAFNoteObjects_NoteObject {
    constructor(thePtr: XCAFNoteObjects_NoteObject);
  }

  export declare class Handle_XCAFNoteObjects_NoteObject_3 extends Handle_XCAFNoteObjects_NoteObject {
    constructor(theHandle: Handle_XCAFNoteObjects_NoteObject);
  }

  export declare class Handle_XCAFNoteObjects_NoteObject_4 extends Handle_XCAFNoteObjects_NoteObject {
    constructor(theHandle: Handle_XCAFNoteObjects_NoteObject);
  }

export declare class XCAFNoteObjects_NoteObject extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  HasPlane(): Standard_Boolean;
  GetPlane(): gp_Ax2;
  SetPlane(thePlane: gp_Ax2): void;
  HasPoint(): Standard_Boolean;
  GetPoint(): gp_Pnt;
  SetPoint(thePnt: gp_Pnt): void;
  HasPointText(): Standard_Boolean;
  GetPointText(): gp_Pnt;
  SetPointText(thePnt: gp_Pnt): void;
  GetPresentation(): TopoDS_Shape;
  SetPresentation(thePresentation: TopoDS_Shape): void;
  Reset(): void;
  delete(): void;
}

  export declare class XCAFNoteObjects_NoteObject_1 extends XCAFNoteObjects_NoteObject {
    constructor();
  }

  export declare class XCAFNoteObjects_NoteObject_2 extends XCAFNoteObjects_NoteObject {
    constructor(theObj: Handle_XCAFNoteObjects_NoteObject);
  }

export declare class Geom2dHatch_MapOfElements extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, Geom2dHatch_Element, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, Geom2dHatch_Element, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: Geom2dHatch_Element): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: Geom2dHatch_Element): Geom2dHatch_Element;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): Geom2dHatch_Element;
  ChangeSeek(theKey: Standard_Integer): Geom2dHatch_Element;
  ChangeFind(theKey: Standard_Integer): Geom2dHatch_Element;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Geom2dHatch_MapOfElements_1 extends Geom2dHatch_MapOfElements {
    constructor();
  }

  export declare class Geom2dHatch_MapOfElements_2 extends Geom2dHatch_MapOfElements {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Geom2dHatch_MapOfElements_3 extends Geom2dHatch_MapOfElements {
    constructor(theOther: NCollection_DataMap<Standard_Integer, Geom2dHatch_Element, TColStd_MapIntegerHasher>);
  }

export declare class Geom2dHatch_Hatchings extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, Geom2dHatch_Hatching, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, Geom2dHatch_Hatching, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: Geom2dHatch_Hatching): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: Geom2dHatch_Hatching): Geom2dHatch_Hatching;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): Geom2dHatch_Hatching;
  ChangeSeek(theKey: Standard_Integer): Geom2dHatch_Hatching;
  ChangeFind(theKey: Standard_Integer): Geom2dHatch_Hatching;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Geom2dHatch_Hatchings_1 extends Geom2dHatch_Hatchings {
    constructor();
  }

  export declare class Geom2dHatch_Hatchings_2 extends Geom2dHatch_Hatchings {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Geom2dHatch_Hatchings_3 extends Geom2dHatch_Hatchings {
    constructor(theOther: NCollection_DataMap<Standard_Integer, Geom2dHatch_Hatching, TColStd_MapIntegerHasher>);
  }

export declare class Geom2dHatch_Hatcher {
  constructor(Intersector: Geom2dHatch_Intersector, Confusion2d: Quantity_AbsorbedDose, Confusion3d: Quantity_AbsorbedDose, KeepPnt: Standard_Boolean, KeepSeg: Standard_Boolean)
  Intersector_1(Intersector: Geom2dHatch_Intersector): void;
  Intersector_2(): Geom2dHatch_Intersector;
  ChangeIntersector(): Geom2dHatch_Intersector;
  Confusion2d_1(Confusion: Quantity_AbsorbedDose): void;
  Confusion2d_2(): Quantity_AbsorbedDose;
  Confusion3d_1(Confusion: Quantity_AbsorbedDose): void;
  Confusion3d_2(): Quantity_AbsorbedDose;
  KeepPoints_1(Keep: Standard_Boolean): void;
  KeepPoints_2(): Standard_Boolean;
  KeepSegments_1(Keep: Standard_Boolean): void;
  KeepSegments_2(): Standard_Boolean;
  Clear(): void;
  ElementCurve(IndE: Graphic3d_ZLayerId): Geom2dAdaptor_Curve;
  AddElement_1(Curve: Geom2dAdaptor_Curve, Orientation: TopAbs_Orientation): Graphic3d_ZLayerId;
  AddElement_2(Curve: Handle_Geom2d_Curve, Orientation: TopAbs_Orientation): Graphic3d_ZLayerId;
  RemElement(IndE: Graphic3d_ZLayerId): void;
  ClrElements(): void;
  HatchingCurve(IndH: Graphic3d_ZLayerId): Geom2dAdaptor_Curve;
  AddHatching(Curve: Geom2dAdaptor_Curve): Graphic3d_ZLayerId;
  RemHatching(IndH: Graphic3d_ZLayerId): void;
  ClrHatchings(): void;
  NbPoints(IndH: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Point(IndH: Graphic3d_ZLayerId, IndP: Graphic3d_ZLayerId): HatchGen_PointOnHatching;
  Trim_1(): void;
  Trim_2(Curve: Geom2dAdaptor_Curve): Graphic3d_ZLayerId;
  Trim_3(IndH: Graphic3d_ZLayerId): void;
  ComputeDomains_1(): void;
  ComputeDomains_2(IndH: Graphic3d_ZLayerId): void;
  TrimDone(IndH: Graphic3d_ZLayerId): Standard_Boolean;
  TrimFailed(IndH: Graphic3d_ZLayerId): Standard_Boolean;
  Status(IndH: Graphic3d_ZLayerId): HatchGen_ErrorStatus;
  NbDomains(IndH: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Domain(IndH: Graphic3d_ZLayerId, IDom: Graphic3d_ZLayerId): HatchGen_Domain;
  Dump(): void;
  delete(): void;
}

export declare class Geom2dHatch_Hatching {
  Curve(): Geom2dAdaptor_Curve;
  ChangeCurve(): Geom2dAdaptor_Curve;
  TrimDone_1(Flag: Standard_Boolean): void;
  TrimDone_2(): Standard_Boolean;
  TrimFailed_1(Flag: Standard_Boolean): void;
  TrimFailed_2(): Standard_Boolean;
  IsDone_1(Flag: Standard_Boolean): void;
  IsDone_2(): Standard_Boolean;
  Status_1(theStatus: HatchGen_ErrorStatus): void;
  Status_2(): HatchGen_ErrorStatus;
  AddPoint(Point: HatchGen_PointOnHatching, Confusion: Quantity_AbsorbedDose): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): HatchGen_PointOnHatching;
  ChangePoint(Index: Graphic3d_ZLayerId): HatchGen_PointOnHatching;
  RemPoint(Index: Graphic3d_ZLayerId): void;
  ClrPoints(): void;
  AddDomain(Domain: HatchGen_Domain): void;
  NbDomains(): Graphic3d_ZLayerId;
  Domain(Index: Graphic3d_ZLayerId): HatchGen_Domain;
  RemDomain(Index: Graphic3d_ZLayerId): void;
  ClrDomains(): void;
  ClassificationPoint(): gp_Pnt2d;
  delete(): void;
}

  export declare class Geom2dHatch_Hatching_1 extends Geom2dHatch_Hatching {
    constructor();
  }

  export declare class Geom2dHatch_Hatching_2 extends Geom2dHatch_Hatching {
    constructor(Curve: Geom2dAdaptor_Curve);
  }

export declare class Geom2dHatch_Intersector extends Geom2dInt_GInter {
  ConfusionTolerance(): Quantity_AbsorbedDose;
  SetConfusionTolerance(Confusion: Quantity_AbsorbedDose): void;
  TangencyTolerance(): Quantity_AbsorbedDose;
  SetTangencyTolerance(Tangency: Quantity_AbsorbedDose): void;
  Intersect(C1: Geom2dAdaptor_Curve, C2: Geom2dAdaptor_Curve): void;
  Perform(L: gp_Lin2d, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, E: Geom2dAdaptor_Curve): void;
  LocalGeometry(E: Geom2dAdaptor_Curve, U: Quantity_AbsorbedDose, T: gp_Dir2d, N: gp_Dir2d, C: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Geom2dHatch_Intersector_1 extends Geom2dHatch_Intersector {
    constructor(Confusion: Quantity_AbsorbedDose, Tangency: Quantity_AbsorbedDose);
  }

  export declare class Geom2dHatch_Intersector_2 extends Geom2dHatch_Intersector {
    constructor();
  }

export declare class Geom2dHatch_Element {
  Curve(): Geom2dAdaptor_Curve;
  ChangeCurve(): Geom2dAdaptor_Curve;
  Orientation_1(Orientation: TopAbs_Orientation): void;
  Orientation_2(): TopAbs_Orientation;
  delete(): void;
}

  export declare class Geom2dHatch_Element_1 extends Geom2dHatch_Element {
    constructor();
  }

  export declare class Geom2dHatch_Element_2 extends Geom2dHatch_Element {
    constructor(Curve: Geom2dAdaptor_Curve, Orientation: TopAbs_Orientation);
  }

export declare class Geom2dHatch_FClass2dOfClassifier {
  constructor()
  Reset(L: gp_Lin2d, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Compare(E: Geom2dAdaptor_Curve, Or: TopAbs_Orientation): void;
  Parameter(): Quantity_AbsorbedDose;
  Intersector(): Geom2dHatch_Intersector;
  ClosestIntersection(): Graphic3d_ZLayerId;
  State(): TopAbs_State;
  IsHeadOrEnd(): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dHatch_Classifier {
  Perform(F: Geom2dHatch_Elements, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose): void;
  State(): TopAbs_State;
  Rejected(): Standard_Boolean;
  NoWires(): Standard_Boolean;
  Edge(): Geom2dAdaptor_Curve;
  EdgeParameter(): Quantity_AbsorbedDose;
  Position(): IntRes2d_Position;
  delete(): void;
}

  export declare class Geom2dHatch_Classifier_1 extends Geom2dHatch_Classifier {
    constructor();
  }

  export declare class Geom2dHatch_Classifier_2 extends Geom2dHatch_Classifier {
    constructor(F: Geom2dHatch_Elements, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose);
  }

export declare class Geom2dHatch_Elements {
  Clear(): void;
  Bind(K: Graphic3d_ZLayerId, I: Geom2dHatch_Element): Standard_Boolean;
  IsBound(K: Graphic3d_ZLayerId): Standard_Boolean;
  UnBind(K: Graphic3d_ZLayerId): Standard_Boolean;
  Find(K: Graphic3d_ZLayerId): Geom2dHatch_Element;
  ChangeFind(K: Graphic3d_ZLayerId): Geom2dHatch_Element;
  CheckPoint(P: gp_Pnt2d): Standard_Boolean;
  Reject(P: gp_Pnt2d): Standard_Boolean;
  Segment(P: gp_Pnt2d, L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  OtherSegment(P: gp_Pnt2d, L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  InitWires(): void;
  MoreWires(): Standard_Boolean;
  NextWire(): void;
  RejectWire(L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  InitEdges(): void;
  MoreEdges(): Standard_Boolean;
  NextEdge(): void;
  RejectEdge(L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  CurrentEdge(E: Geom2dAdaptor_Curve, Or: TopAbs_Orientation): void;
  delete(): void;
}

  export declare class Geom2dHatch_Elements_1 extends Geom2dHatch_Elements {
    constructor();
  }

  export declare class Geom2dHatch_Elements_2 extends Geom2dHatch_Elements {
    constructor(Other: Geom2dHatch_Elements);
  }

export declare class IntAna2d_AnaIntersection {
  Perform_1(L1: gp_Lin2d, L2: gp_Lin2d): void;
  Perform_2(C1: gp_Circ2d, C2: gp_Circ2d): void;
  Perform_3(L: gp_Lin2d, C: gp_Circ2d): void;
  Perform_4(L: gp_Lin2d, C: IntAna2d_Conic): void;
  Perform_5(C: gp_Circ2d, Co: IntAna2d_Conic): void;
  Perform_6(E: gp_Elips2d, C: IntAna2d_Conic): void;
  Perform_7(P: gp_Parab2d, C: IntAna2d_Conic): void;
  Perform_8(H: gp_Hypr2d, C: IntAna2d_Conic): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  IdenticalElements(): Standard_Boolean;
  ParallelElements(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(N: Graphic3d_ZLayerId): IntAna2d_IntPoint;
  delete(): void;
}

  export declare class IntAna2d_AnaIntersection_1 extends IntAna2d_AnaIntersection {
    constructor();
  }

  export declare class IntAna2d_AnaIntersection_2 extends IntAna2d_AnaIntersection {
    constructor(L1: gp_Lin2d, L2: gp_Lin2d);
  }

  export declare class IntAna2d_AnaIntersection_3 extends IntAna2d_AnaIntersection {
    constructor(C1: gp_Circ2d, C2: gp_Circ2d);
  }

  export declare class IntAna2d_AnaIntersection_4 extends IntAna2d_AnaIntersection {
    constructor(L: gp_Lin2d, C: gp_Circ2d);
  }

  export declare class IntAna2d_AnaIntersection_5 extends IntAna2d_AnaIntersection {
    constructor(L: gp_Lin2d, C: IntAna2d_Conic);
  }

  export declare class IntAna2d_AnaIntersection_6 extends IntAna2d_AnaIntersection {
    constructor(C: gp_Circ2d, Co: IntAna2d_Conic);
  }

  export declare class IntAna2d_AnaIntersection_7 extends IntAna2d_AnaIntersection {
    constructor(E: gp_Elips2d, C: IntAna2d_Conic);
  }

  export declare class IntAna2d_AnaIntersection_8 extends IntAna2d_AnaIntersection {
    constructor(P: gp_Parab2d, C: IntAna2d_Conic);
  }

  export declare class IntAna2d_AnaIntersection_9 extends IntAna2d_AnaIntersection {
    constructor(H: gp_Hypr2d, C: IntAna2d_Conic);
  }

export declare class MyDirectPolynomialRoots {
  NbSolutions(): Graphic3d_ZLayerId;
  Value(i: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsDone(): Quantity_AbsorbedDose;
  InfiniteRoots(): Standard_Boolean;
  delete(): void;
}

  export declare class MyDirectPolynomialRoots_1 extends MyDirectPolynomialRoots {
    constructor(A4: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A1: Quantity_AbsorbedDose, A0: Quantity_AbsorbedDose);
  }

  export declare class MyDirectPolynomialRoots_2 extends MyDirectPolynomialRoots {
    constructor(A2: Quantity_AbsorbedDose, A1: Quantity_AbsorbedDose, A0: Quantity_AbsorbedDose);
  }

export declare class IntAna2d_IntPoint {
  SetValue_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  SetValue_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt2d;
  SecondIsImplicit(): Standard_Boolean;
  ParamOnFirst(): Quantity_AbsorbedDose;
  ParamOnSecond(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntAna2d_IntPoint_1 extends IntAna2d_IntPoint {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose);
  }

  export declare class IntAna2d_IntPoint_2 extends IntAna2d_IntPoint {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose);
  }

  export declare class IntAna2d_IntPoint_3 extends IntAna2d_IntPoint {
    constructor();
  }

export declare class IntAna2d_Conic {
  Value(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Grad(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): gp_XY;
  ValAndGrad(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Val: Quantity_AbsorbedDose, Grd: gp_XY): void;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): void;
  NewCoefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, Axis: gp_Ax2d): void;
  delete(): void;
}

  export declare class IntAna2d_Conic_1 extends IntAna2d_Conic {
    constructor(C: gp_Circ2d);
  }

  export declare class IntAna2d_Conic_2 extends IntAna2d_Conic {
    constructor(C: gp_Lin2d);
  }

  export declare class IntAna2d_Conic_3 extends IntAna2d_Conic {
    constructor(C: gp_Parab2d);
  }

  export declare class IntAna2d_Conic_4 extends IntAna2d_Conic {
    constructor(C: gp_Hypr2d);
  }

  export declare class IntAna2d_Conic_5 extends IntAna2d_Conic {
    constructor(C: gp_Elips2d);
  }

export declare class BRepFilletAPI_LocalOperation extends BRepBuilderAPI_MakeShape {
  Add(E: TopoDS_Edge): void;
  ResetContour(IC: Graphic3d_ZLayerId): void;
  NbContours(): Graphic3d_ZLayerId;
  Contour(E: TopoDS_Edge): Graphic3d_ZLayerId;
  NbEdges(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Edge(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): TopoDS_Edge;
  Remove(E: TopoDS_Edge): void;
  Length(IC: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  FirstVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  LastVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  Abscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  RelativeAbscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  ClosedAndTangent(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Closed(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Reset(): void;
  Simulate(IC: Graphic3d_ZLayerId): void;
  NbSurf(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Sect(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_ChFiDS_SecHArray1;
  delete(): void;
}

export declare class BRepFilletAPI_MakeFillet extends BRepFilletAPI_LocalOperation {
  constructor(S: TopoDS_Shape, FShape: ChFi3d_FilletShape)
  SetParams(Tang: Quantity_AbsorbedDose, Tesp: Quantity_AbsorbedDose, T2d: Quantity_AbsorbedDose, TApp3d: Quantity_AbsorbedDose, TolApp2d: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose): void;
  SetContinuity(InternalContinuity: GeomAbs_Shape, AngularTolerance: Quantity_AbsorbedDose): void;
  Add_1(E: TopoDS_Edge): void;
  Add_2(Radius: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  Add_3(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  Add_4(L: Handle_Law_Function, E: TopoDS_Edge): void;
  Add_5(UandR: TColgp_Array1OfPnt2d, E: TopoDS_Edge): void;
  SetRadius_1(Radius: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, IinC: Graphic3d_ZLayerId): void;
  SetRadius_2(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, IinC: Graphic3d_ZLayerId): void;
  SetRadius_3(L: Handle_Law_Function, IC: Graphic3d_ZLayerId, IinC: Graphic3d_ZLayerId): void;
  SetRadius_4(UandR: TColgp_Array1OfPnt2d, IC: Graphic3d_ZLayerId, IinC: Graphic3d_ZLayerId): void;
  ResetContour(IC: Graphic3d_ZLayerId): void;
  IsConstant_1(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Radius_1(IC: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsConstant_2(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): Standard_Boolean;
  Radius_2(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): Quantity_AbsorbedDose;
  SetRadius_5(Radius: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, E: TopoDS_Edge): void;
  SetRadius_6(Radius: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): void;
  GetBounds(IC: Graphic3d_ZLayerId, E: TopoDS_Edge, F: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose): Standard_Boolean;
  GetLaw(IC: Graphic3d_ZLayerId, E: TopoDS_Edge): Handle_Law_Function;
  SetLaw(IC: Graphic3d_ZLayerId, E: TopoDS_Edge, L: Handle_Law_Function): void;
  SetFilletShape(FShape: ChFi3d_FilletShape): void;
  GetFilletShape(): ChFi3d_FilletShape;
  NbContours(): Graphic3d_ZLayerId;
  Contour(E: TopoDS_Edge): Graphic3d_ZLayerId;
  NbEdges(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Edge(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): TopoDS_Edge;
  Remove(E: TopoDS_Edge): void;
  Length(IC: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  FirstVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  LastVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  Abscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  RelativeAbscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  ClosedAndTangent(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Closed(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Build(): void;
  Reset(): void;
  Builder(): Handle_TopOpeBRepBuild_HBuilder;
  Generated(EorV: TopoDS_Shape): TopTools_ListOfShape;
  Modified(F: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(F: TopoDS_Shape): Standard_Boolean;
  NbSurfaces(): Graphic3d_ZLayerId;
  NewFaces(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  Simulate(IC: Graphic3d_ZLayerId): void;
  NbSurf(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Sect(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_ChFiDS_SecHArray1;
  NbFaultyContours(): Graphic3d_ZLayerId;
  FaultyContour(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbComputedSurfaces(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ComputedSurface(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_Geom_Surface;
  NbFaultyVertices(): Graphic3d_ZLayerId;
  FaultyVertex(IV: Graphic3d_ZLayerId): TopoDS_Vertex;
  HasResult(): Standard_Boolean;
  BadShape(): TopoDS_Shape;
  StripeStatus(IC: Graphic3d_ZLayerId): ChFiDS_ErrorStatus;
  delete(): void;
}

export declare class BRepFilletAPI_MakeFillet2d extends BRepBuilderAPI_MakeShape {
  Init_1(F: TopoDS_Face): void;
  Init_2(RefFace: TopoDS_Face, ModFace: TopoDS_Face): void;
  AddFillet(V: TopoDS_Vertex, Radius: Quantity_AbsorbedDose): TopoDS_Edge;
  ModifyFillet(Fillet: TopoDS_Edge, Radius: Quantity_AbsorbedDose): TopoDS_Edge;
  RemoveFillet(Fillet: TopoDS_Edge): TopoDS_Vertex;
  AddChamfer_1(E1: TopoDS_Edge, E2: TopoDS_Edge, D1: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): TopoDS_Edge;
  AddChamfer_2(E: TopoDS_Edge, V: TopoDS_Vertex, D: Quantity_AbsorbedDose, Ang: Quantity_AbsorbedDose): TopoDS_Edge;
  ModifyChamfer_1(Chamfer: TopoDS_Edge, E1: TopoDS_Edge, E2: TopoDS_Edge, D1: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): TopoDS_Edge;
  ModifyChamfer_2(Chamfer: TopoDS_Edge, E: TopoDS_Edge, D: Quantity_AbsorbedDose, Ang: Quantity_AbsorbedDose): TopoDS_Edge;
  RemoveChamfer(Chamfer: TopoDS_Edge): TopoDS_Vertex;
  IsModified(E: TopoDS_Edge): Standard_Boolean;
  FilletEdges(): TopTools_SequenceOfShape;
  NbFillet(): Graphic3d_ZLayerId;
  ChamferEdges(): TopTools_SequenceOfShape;
  NbChamfer(): Graphic3d_ZLayerId;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  NbCurves(): Graphic3d_ZLayerId;
  NewEdges(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  HasDescendant(E: TopoDS_Edge): Standard_Boolean;
  DescendantEdge(E: TopoDS_Edge): TopoDS_Edge;
  BasisEdge(E: TopoDS_Edge): TopoDS_Edge;
  Status(): ChFi2d_ConstructionError;
  Build(): void;
  delete(): void;
}

  export declare class BRepFilletAPI_MakeFillet2d_1 extends BRepFilletAPI_MakeFillet2d {
    constructor();
  }

  export declare class BRepFilletAPI_MakeFillet2d_2 extends BRepFilletAPI_MakeFillet2d {
    constructor(F: TopoDS_Face);
  }

export declare class BRepFilletAPI_MakeChamfer extends BRepFilletAPI_LocalOperation {
  constructor(S: TopoDS_Shape)
  Add_1(E: TopoDS_Edge): void;
  Add_2(Dis: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  SetDist(Dis: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, F: TopoDS_Face): void;
  GetDist(IC: Graphic3d_ZLayerId, Dis: Quantity_AbsorbedDose): void;
  Add_3(Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face): void;
  SetDists(Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, F: TopoDS_Face): void;
  Dists(IC: Graphic3d_ZLayerId, Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose): void;
  AddDA(Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose, E: TopoDS_Edge, F: TopoDS_Face): void;
  SetDistAngle(Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose, IC: Graphic3d_ZLayerId, F: TopoDS_Face): void;
  GetDistAngle(IC: Graphic3d_ZLayerId, Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose): void;
  SetMode(theMode: ChFiDS_ChamfMode): void;
  IsSymetric(IC: Graphic3d_ZLayerId): Standard_Boolean;
  IsTwoDistances(IC: Graphic3d_ZLayerId): Standard_Boolean;
  IsDistanceAngle(IC: Graphic3d_ZLayerId): Standard_Boolean;
  ResetContour(IC: Graphic3d_ZLayerId): void;
  NbContours(): Graphic3d_ZLayerId;
  Contour(E: TopoDS_Edge): Graphic3d_ZLayerId;
  NbEdges(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Edge(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): TopoDS_Edge;
  Remove(E: TopoDS_Edge): void;
  Length(IC: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  FirstVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  LastVertex(IC: Graphic3d_ZLayerId): TopoDS_Vertex;
  Abscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  RelativeAbscissa(IC: Graphic3d_ZLayerId, V: TopoDS_Vertex): Quantity_AbsorbedDose;
  ClosedAndTangent(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Closed(IC: Graphic3d_ZLayerId): Standard_Boolean;
  Build(): void;
  Reset(): void;
  Builder(): Handle_TopOpeBRepBuild_HBuilder;
  Generated(EorV: TopoDS_Shape): TopTools_ListOfShape;
  Modified(F: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(F: TopoDS_Shape): Standard_Boolean;
  Simulate(IC: Graphic3d_ZLayerId): void;
  NbSurf(IC: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Sect(IC: Graphic3d_ZLayerId, IS: Graphic3d_ZLayerId): Handle_ChFiDS_SecHArray1;
  delete(): void;
}

export declare type SelectMgr_TypeOfDepthTolerance = {
  SelectMgr_TypeOfDepthTolerance_Uniform: {};
  SelectMgr_TypeOfDepthTolerance_UniformPixels: {};
  SelectMgr_TypeOfDepthTolerance_SensitivityFactor: {};
}

export declare class SelectMgr_BaseFrustum extends Standard_Transient {
  constructor()
  Camera(): Handle_Graphic3d_Camera;
  SetCamera_1(theCamera: Handle_Graphic3d_Camera): void;
  SetCamera_2(theProjection: OpenGl_Mat4d, theWorldView: OpenGl_Mat4d, theIsOrthographic: Standard_Boolean, theWVPState: Graphic3d_WorldViewProjState): void;
  ProjectionMatrix(): OpenGl_Mat4d;
  WorldViewMatrix(): OpenGl_Mat4d;
  WorldViewProjState(): Graphic3d_WorldViewProjState;
  SetPixelTolerance(theTol: Graphic3d_ZLayerId): void;
  SetWindowSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  WindowSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  SetViewport(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theWidth: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose): void;
  SetBuilder(theBuilder: Handle_SelectMgr_FrustumBuilder): void;
  Build_1(a0: gp_Pnt2d): void;
  Build_2(a0: gp_Pnt2d, a1: gp_Pnt2d): void;
  Build_3(a0: gp_Pnt2d, a1: gp_Pnt2d, a2: gp_Pnt2d): void;
  Build_4(a0: TColgp_Array1OfPnt2d): void;
  ScaleAndTransform(a0: Graphic3d_ZLayerId, a1: gp_GTrsf): any;
  Overlaps_1(theBoxMin: SelectMgr_Vec3, theBoxMax: SelectMgr_Vec3, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_2(theBoxMin: SelectMgr_Vec3, theBoxMax: SelectMgr_Vec3, theInside: Standard_Boolean): Standard_Boolean;
  Overlaps_3(thePnt: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_4(thePnt: gp_Pnt): Standard_Boolean;
  Overlaps_5(theArrayOfPnts: TColgp_Array1OfPnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_6(thePnt1: gp_Pnt, thePnt2: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_7(thePt1: gp_Pnt, thePt2: gp_Pnt, thePt3: gp_Pnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  DistToGeometryCenter(theCOG: gp_Pnt): Quantity_AbsorbedDose;
  DetectedPoint(theDepth: Quantity_AbsorbedDose): gp_Pnt;
  GetPlanes(thePlaneEquations: NCollection_Vector<SelectMgr_Vec4>): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_SelectMgr_AndFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_AndFilter): void;
  get(): SelectMgr_AndFilter;
  delete(): void;
}

  export declare class Handle_SelectMgr_AndFilter_1 extends Handle_SelectMgr_AndFilter {
    constructor();
  }

  export declare class Handle_SelectMgr_AndFilter_2 extends Handle_SelectMgr_AndFilter {
    constructor(thePtr: SelectMgr_AndFilter);
  }

  export declare class Handle_SelectMgr_AndFilter_3 extends Handle_SelectMgr_AndFilter {
    constructor(theHandle: Handle_SelectMgr_AndFilter);
  }

  export declare class Handle_SelectMgr_AndFilter_4 extends Handle_SelectMgr_AndFilter {
    constructor(theHandle: Handle_SelectMgr_AndFilter);
  }

export declare class SelectMgr_AndFilter extends SelectMgr_CompositionFilter {
  constructor()
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class SelectMgr_BVHThreadPool extends Standard_Transient {
  constructor(theNbThreads: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  AddEntity(theEntity: Handle_Select3D_SensitiveEntity): void;
  StopThreads(): void;
  WaitThreads(): void;
  Threads(): any;
  delete(): void;
}

export declare class SelectMgr_SelectionManager extends Standard_Transient {
  constructor(theSelector: Handle_SelectMgr_ViewerSelector)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Selector(): Handle_SelectMgr_ViewerSelector;
  Contains(theObject: Handle_SelectMgr_SelectableObject): Standard_Boolean;
  Load(theObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): void;
  Remove(theObject: Handle_SelectMgr_SelectableObject): void;
  Activate(theObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): void;
  Deactivate(theObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): void;
  IsActivated(theObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  ClearSelectionStructures(theObj: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): void;
  RestoreSelectionStructures(theObj: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): void;
  RecomputeSelection(theObject: Handle_SelectMgr_SelectableObject, theIsForce: Standard_Boolean, theMode: Graphic3d_ZLayerId): void;
  Update(theObject: Handle_SelectMgr_SelectableObject, theIsForce: Standard_Boolean): void;
  SetUpdateMode_1(theObject: Handle_SelectMgr_SelectableObject, theType: SelectMgr_TypeOfUpdate): void;
  SetUpdateMode_2(theObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId, theType: SelectMgr_TypeOfUpdate): void;
  SetSelectionSensitivity(theObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId, theNewSens: Graphic3d_ZLayerId): void;
  UpdateSelection(theObj: Handle_SelectMgr_SelectableObject): void;
  delete(): void;
}

export declare class Handle_SelectMgr_SelectionManager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_SelectionManager): void;
  get(): SelectMgr_SelectionManager;
  delete(): void;
}

  export declare class Handle_SelectMgr_SelectionManager_1 extends Handle_SelectMgr_SelectionManager {
    constructor();
  }

  export declare class Handle_SelectMgr_SelectionManager_2 extends Handle_SelectMgr_SelectionManager {
    constructor(thePtr: SelectMgr_SelectionManager);
  }

  export declare class Handle_SelectMgr_SelectionManager_3 extends Handle_SelectMgr_SelectionManager {
    constructor(theHandle: Handle_SelectMgr_SelectionManager);
  }

  export declare class Handle_SelectMgr_SelectionManager_4 extends Handle_SelectMgr_SelectionManager {
    constructor(theHandle: Handle_SelectMgr_SelectionManager);
  }

export declare class Handle_SelectMgr_AndOrFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_AndOrFilter): void;
  get(): SelectMgr_AndOrFilter;
  delete(): void;
}

  export declare class Handle_SelectMgr_AndOrFilter_1 extends Handle_SelectMgr_AndOrFilter {
    constructor();
  }

  export declare class Handle_SelectMgr_AndOrFilter_2 extends Handle_SelectMgr_AndOrFilter {
    constructor(thePtr: SelectMgr_AndOrFilter);
  }

  export declare class Handle_SelectMgr_AndOrFilter_3 extends Handle_SelectMgr_AndOrFilter {
    constructor(theHandle: Handle_SelectMgr_AndOrFilter);
  }

  export declare class Handle_SelectMgr_AndOrFilter_4 extends Handle_SelectMgr_AndOrFilter {
    constructor(theHandle: Handle_SelectMgr_AndOrFilter);
  }

export declare class SelectMgr_AndOrFilter extends SelectMgr_CompositionFilter {
  constructor(theFilterType: SelectMgr_FilterType)
  IsOk(theObj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  SetDisabledObjects(theObjects: any): void;
  FilterType(): SelectMgr_FilterType;
  SetFilterType(theFilterType: SelectMgr_FilterType): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class SelectMgr_TriangularFrustum {
  constructor()
  Build(theP1: gp_Pnt2d, theP2: gp_Pnt2d, theP3: gp_Pnt2d): void;
  ScaleAndTransform(theScale: Graphic3d_ZLayerId, theTrsf: gp_GTrsf): any;
  Overlaps_1(theMinPnt: SelectMgr_Vec3, theMaxPnt: SelectMgr_Vec3, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_2(theMinPt: SelectMgr_Vec3, theMaxPt: SelectMgr_Vec3, theInside: Standard_Boolean): Standard_Boolean;
  Overlaps_3(thePnt: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_4(theArrayOfPnts: TColgp_Array1OfPnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_5(thePnt1: gp_Pnt, thePnt2: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_6(thePnt1: gp_Pnt, thePnt2: gp_Pnt, thePnt3: gp_Pnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Clear(): void;
  GetPlanes(thePlaneEquations: NCollection_Vector<SelectMgr_Vec4>): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class SelectMgr_SortCriterion {
  constructor()
  IsCloserDepth(theOther: SelectMgr_SortCriterion): Standard_Boolean;
  IsHigherPriority(theOther: SelectMgr_SortCriterion): Standard_Boolean;
  delete(): void;
}

export declare type SelectMgr_TypeOfBVHUpdate = {
  SelectMgr_TBU_Add: {};
  SelectMgr_TBU_Remove: {};
  SelectMgr_TBU_Renew: {};
  SelectMgr_TBU_Invalidate: {};
  SelectMgr_TBU_None: {};
}

export declare class SelectMgr {
  constructor();
  static ComputeSensitivePrs(theStructure: Handle_Graphic3d_Structure, theSel: Handle_SelectMgr_Selection, theLoc: gp_Trsf, theTrsfPers: Handle_Graphic3d_TransformPers): void;
  delete(): void;
}

export declare class SelectMgr_ToleranceMap {
  constructor()
  Add(theTolerance: Graphic3d_ZLayerId): void;
  Decrement(theTolerance: Graphic3d_ZLayerId): void;
  Tolerance(): Graphic3d_ZLayerId;
  SetCustomTolerance(theTolerance: Graphic3d_ZLayerId): void;
  ResetDefaults(): void;
  CustomTolerance(): Graphic3d_ZLayerId;
  IsCustomTolSet(): Standard_Boolean;
  delete(): void;
}

export declare type SelectMgr_StateOfSelection = {
  SelectMgr_SOS_Any: {};
  SelectMgr_SOS_Unknown: {};
  SelectMgr_SOS_Deactivated: {};
  SelectMgr_SOS_Activated: {};
}

export declare class SelectMgr_SelectingVolumeManager extends SelectBasics_SelectingVolumeManager {
  constructor(theToAllocateFrustums: Standard_Boolean)
  ScaleAndTransform(theScaleFactor: Graphic3d_ZLayerId, theTrsf: gp_GTrsf, theBuilder: Handle_SelectMgr_FrustumBuilder): SelectMgr_SelectingVolumeManager;
  GetActiveSelectionType(): Graphic3d_ZLayerId;
  SetActiveSelectionType(theType: any): void;
  Camera(): Handle_Graphic3d_Camera;
  SetCamera_1(theCamera: Handle_Graphic3d_Camera): void;
  SetCamera_2(theProjection: OpenGl_Mat4d, theWorldView: OpenGl_Mat4d, theIsOrthographic: Standard_Boolean, theWVPState: Graphic3d_WorldViewProjState): void;
  ProjectionMatrix(): OpenGl_Mat4d;
  WorldViewMatrix(): OpenGl_Mat4d;
  WindowSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  WorldViewProjState(): Graphic3d_WorldViewProjState;
  SetViewport(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theWidth: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose): void;
  SetPixelTolerance(theTolerance: Graphic3d_ZLayerId): void;
  SetWindowSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  BuildSelectingVolume_1(thePoint: gp_Pnt2d): void;
  BuildSelectingVolume_2(theMinPt: gp_Pnt2d, theMaxPt: gp_Pnt2d): void;
  BuildSelectingVolume_3(thePoints: TColgp_Array1OfPnt2d): void;
  Overlaps_1(theBoxMin: SelectMgr_Vec3, theBoxMax: SelectMgr_Vec3, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_2(theBoxMin: SelectMgr_Vec3, theBoxMax: SelectMgr_Vec3, theInside: Standard_Boolean): Standard_Boolean;
  Overlaps_3(thePnt: gp_Pnt, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_4(thePnt: gp_Pnt): Standard_Boolean;
  Overlaps_5(theArrayOfPts: Handle_TColgp_HArray1OfPnt, theSensType: Graphic3d_ZLayerId, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_6(theArrayOfPts: TColgp_Array1OfPnt, theSensType: Graphic3d_ZLayerId, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_7(thePnt1: gp_Pnt, thePnt2: gp_Pnt, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_8(thePnt1: gp_Pnt, thePnt2: gp_Pnt, thePnt3: gp_Pnt, theSensType: Graphic3d_ZLayerId, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  DistToGeometryCenter(theCOG: gp_Pnt): Quantity_AbsorbedDose;
  DetectedPoint(theDepth: Quantity_AbsorbedDose): gp_Pnt;
  AllowOverlapDetection(theIsToAllow: Standard_Boolean): void;
  IsOverlapAllowed(): Standard_Boolean;
  ViewClipping(): Handle_Graphic3d_SequenceOfHClipPlane;
  ObjectClipping(): Handle_Graphic3d_SequenceOfHClipPlane;
  SetViewClipping_1(theViewPlanes: Handle_Graphic3d_SequenceOfHClipPlane, theObjPlanes: Handle_Graphic3d_SequenceOfHClipPlane, theWorldSelMgr: SelectMgr_SelectingVolumeManager): void;
  SetViewClipping_2(theOther: SelectMgr_SelectingVolumeManager): void;
  ViewClipRanges(): SelectMgr_ViewClipRange;
  SetViewClipRanges(theRange: SelectMgr_ViewClipRange): void;
  GetVertices(): gp_Pnt;
  GetNearPickedPnt(): gp_Pnt;
  GetFarPickedPnt(): gp_Pnt;
  GetMousePosition(): gp_Pnt2d;
  ActiveVolume(): any;
  GetPlanes(thePlaneEquations: NCollection_Vector<SelectMgr_Vec4>): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class SelectMgr_SelectionImageFiller extends Standard_Transient {
  static CreateFiller(thePixMap: Image_PixMap, theSelector: SelectMgr_ViewerSelector, theType: StdSelect_TypeOfSelectionImage): any;
  Fill(theCol: Graphic3d_ZLayerId, theRow: Graphic3d_ZLayerId, thePicked: Graphic3d_ZLayerId): void;
  Flush(): void;
  delete(): void;
}

export declare type SelectMgr_TypeOfUpdate = {
  SelectMgr_TOU_Full: {};
  SelectMgr_TOU_Partial: {};
  SelectMgr_TOU_None: {};
}

export declare class SelectMgr_Selection extends Standard_Transient {
  constructor(theModeIdx: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Destroy(): void;
  Add(theSensitive: Handle_Select3D_SensitiveEntity): void;
  Clear(): void;
  IsEmpty(): Standard_Boolean;
  Mode(): Graphic3d_ZLayerId;
  Entities(): any;
  ChangeEntities(): any;
  UpdateStatus_1(): SelectMgr_TypeOfUpdate;
  UpdateStatus_2(theStatus: SelectMgr_TypeOfUpdate): void;
  UpdateBVHStatus(theStatus: SelectMgr_TypeOfBVHUpdate): void;
  BVHUpdateStatus(): SelectMgr_TypeOfBVHUpdate;
  GetSelectionState(): SelectMgr_StateOfSelection;
  SetSelectionState(theState: SelectMgr_StateOfSelection): void;
  Sensitivity(): Graphic3d_ZLayerId;
  SetSensitivity(theNewSens: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_SelectMgr_Selection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_Selection): void;
  get(): SelectMgr_Selection;
  delete(): void;
}

  export declare class Handle_SelectMgr_Selection_1 extends Handle_SelectMgr_Selection {
    constructor();
  }

  export declare class Handle_SelectMgr_Selection_2 extends Handle_SelectMgr_Selection {
    constructor(thePtr: SelectMgr_Selection);
  }

  export declare class Handle_SelectMgr_Selection_3 extends Handle_SelectMgr_Selection {
    constructor(theHandle: Handle_SelectMgr_Selection);
  }

  export declare class Handle_SelectMgr_Selection_4 extends Handle_SelectMgr_Selection {
    constructor(theHandle: Handle_SelectMgr_Selection);
  }

export declare class SelectMgr_OrFilter extends SelectMgr_CompositionFilter {
  constructor()
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_SelectMgr_OrFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_OrFilter): void;
  get(): SelectMgr_OrFilter;
  delete(): void;
}

  export declare class Handle_SelectMgr_OrFilter_1 extends Handle_SelectMgr_OrFilter {
    constructor();
  }

  export declare class Handle_SelectMgr_OrFilter_2 extends Handle_SelectMgr_OrFilter {
    constructor(thePtr: SelectMgr_OrFilter);
  }

  export declare class Handle_SelectMgr_OrFilter_3 extends Handle_SelectMgr_OrFilter {
    constructor(theHandle: Handle_SelectMgr_OrFilter);
  }

  export declare class Handle_SelectMgr_OrFilter_4 extends Handle_SelectMgr_OrFilter {
    constructor(theHandle: Handle_SelectMgr_OrFilter);
  }

export declare class SelectMgr_Filter extends Standard_Transient {
  IsOk(anObj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  ActsOn(aStandardMode: TopAbs_ShapeEnum): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_SelectMgr_Filter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_Filter): void;
  get(): SelectMgr_Filter;
  delete(): void;
}

  export declare class Handle_SelectMgr_Filter_1 extends Handle_SelectMgr_Filter {
    constructor();
  }

  export declare class Handle_SelectMgr_Filter_2 extends Handle_SelectMgr_Filter {
    constructor(thePtr: SelectMgr_Filter);
  }

  export declare class Handle_SelectMgr_Filter_3 extends Handle_SelectMgr_Filter {
    constructor(theHandle: Handle_SelectMgr_Filter);
  }

  export declare class Handle_SelectMgr_Filter_4 extends Handle_SelectMgr_Filter {
    constructor(theHandle: Handle_SelectMgr_Filter);
  }

export declare class SelectMgr_SelectableObjectSet {
  constructor()
  Append(theObject: Handle_SelectMgr_SelectableObject): Standard_Boolean;
  Remove(theObject: Handle_SelectMgr_SelectableObject): Standard_Boolean;
  ChangeSubset(theObject: Handle_SelectMgr_SelectableObject): void;
  UpdateBVH(theCamera: Handle_Graphic3d_Camera, theProjectionMat: OpenGl_Mat4d, theWorldViewMat: OpenGl_Mat4d, theViewState: Graphic3d_WorldViewProjState, theViewportWidth: Graphic3d_ZLayerId, theViewportHeight: Graphic3d_ZLayerId): void;
  MarkDirty(): void;
  Contains(theObject: Handle_SelectMgr_SelectableObject): Standard_Boolean;
  IsEmpty_1(): Standard_Boolean;
  IsEmpty_2(theSubset: any): Standard_Boolean;
  GetObjectById(theSubset: any, theIndex: Graphic3d_ZLayerId): Handle_SelectMgr_SelectableObject;
  BVH(theSubset: any): any;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_SelectMgr_SelectableObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_SelectableObject): void;
  get(): SelectMgr_SelectableObject;
  delete(): void;
}

  export declare class Handle_SelectMgr_SelectableObject_1 extends Handle_SelectMgr_SelectableObject {
    constructor();
  }

  export declare class Handle_SelectMgr_SelectableObject_2 extends Handle_SelectMgr_SelectableObject {
    constructor(thePtr: SelectMgr_SelectableObject);
  }

  export declare class Handle_SelectMgr_SelectableObject_3 extends Handle_SelectMgr_SelectableObject {
    constructor(theHandle: Handle_SelectMgr_SelectableObject);
  }

  export declare class Handle_SelectMgr_SelectableObject_4 extends Handle_SelectMgr_SelectableObject {
    constructor(theHandle: Handle_SelectMgr_SelectableObject);
  }

export declare class SelectMgr_SelectableObject extends PrsMgr_PresentableObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ComputeSelection(theSelection: Handle_SelectMgr_Selection, theMode: Graphic3d_ZLayerId): void;
  AcceptShapeDecomposition(): Standard_Boolean;
  RecomputePrimitives_1(): void;
  RecomputePrimitives_2(theMode: Graphic3d_ZLayerId): void;
  AddSelection(aSelection: Handle_SelectMgr_Selection, aMode: Graphic3d_ZLayerId): void;
  ClearSelections(update: Standard_Boolean): void;
  Selection(theMode: Graphic3d_ZLayerId): Handle_SelectMgr_Selection;
  HasSelection(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Selections(): SelectMgr_SequenceOfSelection;
  ResetTransformation(): void;
  UpdateTransformation(): void;
  UpdateTransformations(aSelection: Handle_SelectMgr_Selection): void;
  HilightSelected(thePrsMgr: Handle_PrsMgr_PresentationManager, theSeq: SelectMgr_SequenceOfOwner): void;
  ClearSelected(): void;
  ClearDynamicHighlight(theMgr: Handle_PrsMgr_PresentationManager): void;
  HilightOwnerWithColor(thePM: Handle_PrsMgr_PresentationManager, theStyle: Handle_Prs3d_Drawer, theOwner: Handle_SelectMgr_EntityOwner): void;
  IsAutoHilight(): Standard_Boolean;
  SetAutoHilight(theAutoHilight: Standard_Boolean): void;
  GetHilightPresentation(thePrsMgr: Handle_PrsMgr_PresentationManager): any;
  GetSelectPresentation(thePrsMgr: Handle_PrsMgr_PresentationManager): any;
  ErasePresentations(theToRemove: Standard_Boolean): void;
  SetZLayer(theLayerId: Graphic3d_ZLayerId): void;
  UpdateSelection(theMode: Graphic3d_ZLayerId): void;
  SetAssemblyOwner(theOwner: Handle_SelectMgr_EntityOwner, theMode: Graphic3d_ZLayerId): void;
  BndBoxOfSelected(theOwners: any): Bnd_Box;
  GlobalSelectionMode(): Graphic3d_ZLayerId;
  GlobalSelOwner(): Handle_SelectMgr_EntityOwner;
  GetAssemblyOwner(): Handle_SelectMgr_EntityOwner;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type SelectMgr_FilterType = {
  SelectMgr_FilterType_AND: {};
  SelectMgr_FilterType_OR: {};
}

export declare class SelectMgr_SensitiveEntitySet extends BVH_PrimitiveSet3d {
  constructor(theBuilder: any)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Append_1(theEntity: Handle_SelectMgr_SensitiveEntity): void;
  Append_2(theSelection: Handle_SelectMgr_Selection): void;
  Remove(theSelection: Handle_SelectMgr_Selection): void;
  Box_1(theIndex: Graphic3d_ZLayerId): Select3D_BndBox3d;
  Center(theIndex: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  Size(): Graphic3d_ZLayerId;
  GetSensitiveById(theIndex: Graphic3d_ZLayerId): Handle_SelectMgr_SensitiveEntity;
  Sensitives(): SelectMgr_IndexedMapOfHSensitive;
  delete(): void;
}

export declare class SelectMgr_CompositionFilter extends SelectMgr_Filter {
  Add(afilter: Handle_SelectMgr_Filter): void;
  Remove(aFilter: Handle_SelectMgr_Filter): void;
  IsEmpty(): Standard_Boolean;
  IsIn(aFilter: Handle_SelectMgr_Filter): Standard_Boolean;
  StoredFilters(): SelectMgr_ListOfFilter;
  Clear(): void;
  ActsOn(aStandardMode: TopAbs_ShapeEnum): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_SelectMgr_CompositionFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_CompositionFilter): void;
  get(): SelectMgr_CompositionFilter;
  delete(): void;
}

  export declare class Handle_SelectMgr_CompositionFilter_1 extends Handle_SelectMgr_CompositionFilter {
    constructor();
  }

  export declare class Handle_SelectMgr_CompositionFilter_2 extends Handle_SelectMgr_CompositionFilter {
    constructor(thePtr: SelectMgr_CompositionFilter);
  }

  export declare class Handle_SelectMgr_CompositionFilter_3 extends Handle_SelectMgr_CompositionFilter {
    constructor(theHandle: Handle_SelectMgr_CompositionFilter);
  }

  export declare class Handle_SelectMgr_CompositionFilter_4 extends Handle_SelectMgr_CompositionFilter {
    constructor(theHandle: Handle_SelectMgr_CompositionFilter);
  }

export declare class SelectMgr_SensitiveEntity extends Standard_Transient {
  constructor(theEntity: Handle_Select3D_SensitiveEntity)
  Clear(): void;
  BaseSensitive(): Handle_Select3D_SensitiveEntity;
  IsActiveForSelection(): Standard_Boolean;
  ResetSelectionActiveStatus(): void;
  SetActiveForSelection(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_SelectMgr_SensitiveEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_SensitiveEntity): void;
  get(): SelectMgr_SensitiveEntity;
  delete(): void;
}

  export declare class Handle_SelectMgr_SensitiveEntity_1 extends Handle_SelectMgr_SensitiveEntity {
    constructor();
  }

  export declare class Handle_SelectMgr_SensitiveEntity_2 extends Handle_SelectMgr_SensitiveEntity {
    constructor(thePtr: SelectMgr_SensitiveEntity);
  }

  export declare class Handle_SelectMgr_SensitiveEntity_3 extends Handle_SelectMgr_SensitiveEntity {
    constructor(theHandle: Handle_SelectMgr_SensitiveEntity);
  }

  export declare class Handle_SelectMgr_SensitiveEntity_4 extends Handle_SelectMgr_SensitiveEntity {
    constructor(theHandle: Handle_SelectMgr_SensitiveEntity);
  }

export declare class Handle_SelectMgr_ViewerSelector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_ViewerSelector): void;
  get(): SelectMgr_ViewerSelector;
  delete(): void;
}

  export declare class Handle_SelectMgr_ViewerSelector_1 extends Handle_SelectMgr_ViewerSelector {
    constructor();
  }

  export declare class Handle_SelectMgr_ViewerSelector_2 extends Handle_SelectMgr_ViewerSelector {
    constructor(thePtr: SelectMgr_ViewerSelector);
  }

  export declare class Handle_SelectMgr_ViewerSelector_3 extends Handle_SelectMgr_ViewerSelector {
    constructor(theHandle: Handle_SelectMgr_ViewerSelector);
  }

  export declare class Handle_SelectMgr_ViewerSelector_4 extends Handle_SelectMgr_ViewerSelector {
    constructor(theHandle: Handle_SelectMgr_ViewerSelector);
  }

export declare class SelectMgr_ViewerSelector extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Clear(): void;
  CustomPixelTolerance(): Graphic3d_ZLayerId;
  SetPixelTolerance(theTolerance: Graphic3d_ZLayerId): void;
  Sensitivity(): Quantity_AbsorbedDose;
  PixelTolerance(): Graphic3d_ZLayerId;
  SortResult(): void;
  OnePicked(): Handle_SelectMgr_EntityOwner;
  ToPickClosest(): Standard_Boolean;
  SetPickClosest(theToPreferClosest: Standard_Boolean): void;
  DepthToleranceType(): SelectMgr_TypeOfDepthTolerance;
  DepthTolerance(): Quantity_AbsorbedDose;
  SetDepthTolerance(theType: SelectMgr_TypeOfDepthTolerance, theTolerance: Quantity_AbsorbedDose): void;
  NbPicked(): Graphic3d_ZLayerId;
  ClearPicked(): void;
  Picked_1(theRank: Graphic3d_ZLayerId): Handle_SelectMgr_EntityOwner;
  PickedData(theRank: Graphic3d_ZLayerId): SelectMgr_SortCriterion;
  PickedEntity(theRank: Graphic3d_ZLayerId): Handle_Select3D_SensitiveEntity;
  PickedPoint(theRank: Graphic3d_ZLayerId): gp_Pnt;
  Contains(theObject: Handle_SelectMgr_SelectableObject): Standard_Boolean;
  EntitySetBuilder(): any;
  SetEntitySetBuilder(theBuilder: any): void;
  Modes(theSelectableObject: Handle_SelectMgr_SelectableObject, theModeList: TColStd_ListOfInteger, theWantedState: SelectMgr_StateOfSelection): Standard_Boolean;
  IsActive(theSelectableObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  IsInside(theSelectableObject: Handle_SelectMgr_SelectableObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Status_1(theSelection: Handle_SelectMgr_Selection): SelectMgr_StateOfSelection;
  Status_2(theSelectableObject: Handle_SelectMgr_SelectableObject): XCAFDoc_PartId;
  ActiveOwners(theOwners: AIS_NListOfEntityOwner): void;
  AddSelectableObject(theObject: Handle_SelectMgr_SelectableObject): void;
  AddSelectionToObject(theObject: Handle_SelectMgr_SelectableObject, theSelection: Handle_SelectMgr_Selection): void;
  MoveSelectableObject(theObject: Handle_SelectMgr_SelectableObject): void;
  RemoveSelectableObject(theObject: Handle_SelectMgr_SelectableObject): void;
  RemoveSelectionOfObject(theObject: Handle_SelectMgr_SelectableObject, theSelection: Handle_SelectMgr_Selection): void;
  RebuildObjectsTree(theIsForce: Standard_Boolean): void;
  RebuildSensitivesTree(theObject: Handle_SelectMgr_SelectableObject, theIsForce: Standard_Boolean): void;
  GetManager(): SelectMgr_SelectingVolumeManager;
  SelectableObjects(): SelectMgr_SelectableObjectSet;
  ResetSelectionActivationStatus(): void;
  AllowOverlapDetection(theIsToAllow: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Picked_2(): Handle_SelectMgr_EntityOwner;
  InitDetected(): void;
  NextDetected(): void;
  MoreDetected(): Standard_Boolean;
  DetectedEntity(): Handle_Select3D_SensitiveEntity;
  SetToPrebuildBVH(theToPrebuild: Standard_Boolean, theThreadsNum: Graphic3d_ZLayerId): void;
  QueueBVHBuild(theEntity: Handle_Select3D_SensitiveEntity): void;
  WaitForBVHBuild(): void;
  ToPrebuildBVH(): Standard_Boolean;
  delete(): void;
}

export declare class SelectMgr_TriangularFrustumSet extends SelectMgr_BaseFrustum {
  constructor()
  Build(thePoints: TColgp_Array1OfPnt2d): void;
  ScaleAndTransform(theScale: Graphic3d_ZLayerId, theTrsf: gp_GTrsf): any;
  Overlaps_1(theMinPnt: SelectMgr_Vec3, theMaxPnt: SelectMgr_Vec3, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_2(theMinPnt: SelectMgr_Vec3, theMaxPnt: SelectMgr_Vec3, theInside: Standard_Boolean): Standard_Boolean;
  Overlaps_3(thePnt: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_4(theArrayOfPnts: TColgp_Array1OfPnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_5(thePnt1: gp_Pnt, thePnt2: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_6(thePnt1: gp_Pnt, thePnt2: gp_Pnt, thePnt3: gp_Pnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  GetPlanes(thePlaneEquations: NCollection_Vector<SelectMgr_Vec4>): void;
  SetAllowOverlapDetection(theIsToAllow: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type SelectMgr_PickingStrategy = {
  SelectMgr_PickingStrategy_FirstAcceptable: {};
  SelectMgr_PickingStrategy_OnlyTopmost: {};
}

export declare class SelectMgr_EntityOwner extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Priority(): Graphic3d_ZLayerId;
  SetPriority(thePriority: Graphic3d_ZLayerId): void;
  HasSelectable(): Standard_Boolean;
  Selectable(): Handle_SelectMgr_SelectableObject;
  SetSelectable(theSelObj: Handle_SelectMgr_SelectableObject): void;
  HandleMouseClick(thePoint: OpenGl_Vec2i, theButton: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsDoubleClick: Standard_Boolean): Standard_Boolean;
  IsHilighted(thePrsMgr: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  HilightWithColor(thePrsMgr: Handle_PrsMgr_PresentationManager, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId): void;
  Unhilight(thePrsMgr: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  Clear(thePrsMgr: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  HasLocation(): Standard_Boolean;
  Location(): TopLoc_Location;
  SetLocation(theLocation: TopLoc_Location): void;
  IsSelected(): Standard_Boolean;
  SetSelected(theIsSelected: Standard_Boolean): void;
  State_1(): Graphic3d_ZLayerId;
  State_2(theStatus: Graphic3d_ZLayerId): void;
  IsAutoHilight(): Standard_Boolean;
  IsForcedHilight(): Standard_Boolean;
  SetZLayer(theLayerId: Graphic3d_ZLayerId): void;
  UpdateHighlightTrsf(theViewer: Handle_V3d_Viewer, theManager: Handle_PrsMgr_PresentationManager, theDispMode: Graphic3d_ZLayerId): void;
  IsSameSelectable(theOther: Handle_SelectMgr_SelectableObject): Standard_Boolean;
  ComesFromDecomposition(): Standard_Boolean;
  SetComesFromDecomposition(theIsFromDecomposition: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  Set_1(theSelObj: Handle_SelectMgr_SelectableObject): void;
  Set_2(thePriority: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class SelectMgr_EntityOwner_1 extends SelectMgr_EntityOwner {
    constructor(aPriority: Graphic3d_ZLayerId);
  }

  export declare class SelectMgr_EntityOwner_2 extends SelectMgr_EntityOwner {
    constructor(aSO: Handle_SelectMgr_SelectableObject, aPriority: Graphic3d_ZLayerId);
  }

  export declare class SelectMgr_EntityOwner_3 extends SelectMgr_EntityOwner {
    constructor(theOwner: Handle_SelectMgr_EntityOwner, aPriority: Graphic3d_ZLayerId);
  }

export declare class Handle_SelectMgr_EntityOwner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_EntityOwner): void;
  get(): SelectMgr_EntityOwner;
  delete(): void;
}

  export declare class Handle_SelectMgr_EntityOwner_1 extends Handle_SelectMgr_EntityOwner {
    constructor();
  }

  export declare class Handle_SelectMgr_EntityOwner_2 extends Handle_SelectMgr_EntityOwner {
    constructor(thePtr: SelectMgr_EntityOwner);
  }

  export declare class Handle_SelectMgr_EntityOwner_3 extends Handle_SelectMgr_EntityOwner {
    constructor(theHandle: Handle_SelectMgr_EntityOwner);
  }

  export declare class Handle_SelectMgr_EntityOwner_4 extends Handle_SelectMgr_EntityOwner {
    constructor(theHandle: Handle_SelectMgr_EntityOwner);
  }

export declare class SelectMgr_ViewerSelector3d extends SelectMgr_ViewerSelector {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Pick_1(theXPix: Graphic3d_ZLayerId, theYPix: Graphic3d_ZLayerId, theView: Handle_V3d_View): void;
  Pick_2(theXPMin: Graphic3d_ZLayerId, theYPMin: Graphic3d_ZLayerId, theXPMax: Graphic3d_ZLayerId, theYPMax: Graphic3d_ZLayerId, theView: Handle_V3d_View): void;
  Pick_3(thePolyline: TColgp_Array1OfPnt2d, theView: Handle_V3d_View): void;
  ToPixMap(theImage: Image_PixMap, theView: Handle_V3d_View, theType: StdSelect_TypeOfSelectionImage, thePickedIndex: Graphic3d_ZLayerId): Standard_Boolean;
  DisplaySensitive_1(theView: Handle_V3d_View): void;
  ClearSensitive(theView: Handle_V3d_View): void;
  DisplaySensitive_2(theSel: Handle_SelectMgr_Selection, theTrsf: gp_Trsf, theView: Handle_V3d_View, theToClearOthers: Standard_Boolean): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_SelectMgr_ViewerSelector3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_ViewerSelector3d): void;
  get(): SelectMgr_ViewerSelector3d;
  delete(): void;
}

  export declare class Handle_SelectMgr_ViewerSelector3d_1 extends Handle_SelectMgr_ViewerSelector3d {
    constructor();
  }

  export declare class Handle_SelectMgr_ViewerSelector3d_2 extends Handle_SelectMgr_ViewerSelector3d {
    constructor(thePtr: SelectMgr_ViewerSelector3d);
  }

  export declare class Handle_SelectMgr_ViewerSelector3d_3 extends Handle_SelectMgr_ViewerSelector3d {
    constructor(theHandle: Handle_SelectMgr_ViewerSelector3d);
  }

  export declare class Handle_SelectMgr_ViewerSelector3d_4 extends Handle_SelectMgr_ViewerSelector3d {
    constructor(theHandle: Handle_SelectMgr_ViewerSelector3d);
  }

export declare class SelectMgr_FrustumBuilder extends Standard_Transient {
  constructor()
  SetWorldViewMatrix(theWorldViewMatrix: OpenGl_Mat4d): void;
  WorldViewMatrix(): OpenGl_Mat4d;
  SetProjectionMatrix(theProjection: OpenGl_Mat4d): void;
  ProjectionMatrix(): OpenGl_Mat4d;
  SetWorldViewProjState(theState: Graphic3d_WorldViewProjState): void;
  WorldViewProjState(): Graphic3d_WorldViewProjState;
  SetWindowSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  SetViewport(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theWidth: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose): void;
  InvalidateViewport(): void;
  WindowSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  SignedPlanePntDist(theEq: SelectMgr_Vec3, thePnt: SelectMgr_Vec3): Quantity_AbsorbedDose;
  ProjectPntOnViewPlane(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_SelectMgr_FrustumBuilder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: SelectMgr_FrustumBuilder): void;
  get(): SelectMgr_FrustumBuilder;
  delete(): void;
}

  export declare class Handle_SelectMgr_FrustumBuilder_1 extends Handle_SelectMgr_FrustumBuilder {
    constructor();
  }

  export declare class Handle_SelectMgr_FrustumBuilder_2 extends Handle_SelectMgr_FrustumBuilder {
    constructor(thePtr: SelectMgr_FrustumBuilder);
  }

  export declare class Handle_SelectMgr_FrustumBuilder_3 extends Handle_SelectMgr_FrustumBuilder {
    constructor(theHandle: Handle_SelectMgr_FrustumBuilder);
  }

  export declare class Handle_SelectMgr_FrustumBuilder_4 extends Handle_SelectMgr_FrustumBuilder {
    constructor(theHandle: Handle_SelectMgr_FrustumBuilder);
  }

export declare class SelectMgr_RectangularFrustum {
  constructor()
  Build_1(thePoint: gp_Pnt2d): void;
  Build_2(theMinPnt: gp_Pnt2d, theMaxPnt: gp_Pnt2d): void;
  ScaleAndTransform(theScaleFactor: Graphic3d_ZLayerId, theTrsf: gp_GTrsf): any;
  Overlaps_1(theBoxMin: SelectMgr_Vec3, theBoxMax: SelectMgr_Vec3, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_2(theBoxMin: SelectMgr_Vec3, theBoxMax: SelectMgr_Vec3, theInside: Standard_Boolean): Standard_Boolean;
  Overlaps_3(thePnt: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_4(thePnt: gp_Pnt): Standard_Boolean;
  Overlaps_5(theArrayOfPnts: TColgp_Array1OfPnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_6(thePnt1: gp_Pnt, thePnt2: gp_Pnt, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_7(thePnt1: gp_Pnt, thePnt2: gp_Pnt, thePnt3: gp_Pnt, theSensType: Select3D_TypeOfSensitivity, theClipRange: SelectMgr_ViewClipRange, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  DistToGeometryCenter(theCOG: gp_Pnt): Quantity_AbsorbedDose;
  DetectedPoint(theDepth: Quantity_AbsorbedDose): gp_Pnt;
  GetVertices(): gp_Pnt;
  GetNearPnt(): gp_Pnt;
  GetFarPnt(): gp_Pnt;
  GetViewRayDirection(): gp_Dir;
  GetMousePosition(): gp_Pnt2d;
  GetPlanes(thePlaneEquations: NCollection_Vector<SelectMgr_Vec4>): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class SelectMgr_ViewClipRange {
  constructor()
  IsClipped(theDepth: Quantity_AbsorbedDose): Standard_Boolean;
  GetNearestDepth(theRange: Bnd_Range, theDepth: Quantity_AbsorbedDose): Standard_Boolean;
  SetVoid(): void;
  AddClippingPlanes(thePlanes: Graphic3d_SequenceOfHClipPlane, thePickRay: gp_Ax1): void;
  ChangeUnclipRange(): Bnd_Range;
  AddClipSubRange(theRange: Bnd_Range): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_TransferBRep_HSequenceOfTransferResultInfo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_HSequenceOfTransferResultInfo): void;
  get(): TransferBRep_HSequenceOfTransferResultInfo;
  delete(): void;
}

  export declare class Handle_TransferBRep_HSequenceOfTransferResultInfo_1 extends Handle_TransferBRep_HSequenceOfTransferResultInfo {
    constructor();
  }

  export declare class Handle_TransferBRep_HSequenceOfTransferResultInfo_2 extends Handle_TransferBRep_HSequenceOfTransferResultInfo {
    constructor(thePtr: TransferBRep_HSequenceOfTransferResultInfo);
  }

  export declare class Handle_TransferBRep_HSequenceOfTransferResultInfo_3 extends Handle_TransferBRep_HSequenceOfTransferResultInfo {
    constructor(theHandle: Handle_TransferBRep_HSequenceOfTransferResultInfo);
  }

  export declare class Handle_TransferBRep_HSequenceOfTransferResultInfo_4 extends Handle_TransferBRep_HSequenceOfTransferResultInfo {
    constructor(theHandle: Handle_TransferBRep_HSequenceOfTransferResultInfo);
  }

export declare class TransferBRep_ShapeInfo {
  constructor();
  static Type(ent: TopoDS_Shape): Handle_Standard_Type;
  static TypeName(ent: TopoDS_Shape): Standard_CString;
  delete(): void;
}

export declare class Handle_TransferBRep_ShapeMapper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_ShapeMapper): void;
  get(): TransferBRep_ShapeMapper;
  delete(): void;
}

  export declare class Handle_TransferBRep_ShapeMapper_1 extends Handle_TransferBRep_ShapeMapper {
    constructor();
  }

  export declare class Handle_TransferBRep_ShapeMapper_2 extends Handle_TransferBRep_ShapeMapper {
    constructor(thePtr: TransferBRep_ShapeMapper);
  }

  export declare class Handle_TransferBRep_ShapeMapper_3 extends Handle_TransferBRep_ShapeMapper {
    constructor(theHandle: Handle_TransferBRep_ShapeMapper);
  }

  export declare class Handle_TransferBRep_ShapeMapper_4 extends Handle_TransferBRep_ShapeMapper {
    constructor(theHandle: Handle_TransferBRep_ShapeMapper);
  }

export declare class TransferBRep_ShapeMapper extends Transfer_Finder {
  constructor(akey: TopoDS_Shape)
  Value(): TopoDS_Shape;
  Equates(other: Handle_Transfer_Finder): Standard_Boolean;
  ValueType(): Handle_Standard_Type;
  ValueTypeName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TransferBRep_ShapeListBinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_ShapeListBinder): void;
  get(): TransferBRep_ShapeListBinder;
  delete(): void;
}

  export declare class Handle_TransferBRep_ShapeListBinder_1 extends Handle_TransferBRep_ShapeListBinder {
    constructor();
  }

  export declare class Handle_TransferBRep_ShapeListBinder_2 extends Handle_TransferBRep_ShapeListBinder {
    constructor(thePtr: TransferBRep_ShapeListBinder);
  }

  export declare class Handle_TransferBRep_ShapeListBinder_3 extends Handle_TransferBRep_ShapeListBinder {
    constructor(theHandle: Handle_TransferBRep_ShapeListBinder);
  }

  export declare class Handle_TransferBRep_ShapeListBinder_4 extends Handle_TransferBRep_ShapeListBinder {
    constructor(theHandle: Handle_TransferBRep_ShapeListBinder);
  }

export declare class TransferBRep_ShapeListBinder extends Transfer_Binder {
  IsMultiple(): Standard_Boolean;
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  AddResult(res: TopoDS_Shape): void;
  Result(): Handle_TopTools_HSequenceOfShape;
  SetResult(num: Graphic3d_ZLayerId, res: TopoDS_Shape): void;
  NbShapes(): Graphic3d_ZLayerId;
  Shape(num: Graphic3d_ZLayerId): TopoDS_Shape;
  ShapeType(num: Graphic3d_ZLayerId): TopAbs_ShapeEnum;
  Vertex(num: Graphic3d_ZLayerId): TopoDS_Vertex;
  Edge(num: Graphic3d_ZLayerId): TopoDS_Edge;
  Wire(num: Graphic3d_ZLayerId): TopoDS_Wire;
  Face(num: Graphic3d_ZLayerId): TopoDS_Face;
  Shell(num: Graphic3d_ZLayerId): TopoDS_Shell;
  Solid(num: Graphic3d_ZLayerId): TopoDS_Solid;
  CompSolid(num: Graphic3d_ZLayerId): TopoDS_CompSolid;
  Compound(num: Graphic3d_ZLayerId): TopoDS_Compound;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TransferBRep_ShapeListBinder_1 extends TransferBRep_ShapeListBinder {
    constructor();
  }

  export declare class TransferBRep_ShapeListBinder_2 extends TransferBRep_ShapeListBinder {
    constructor(list: Handle_TopTools_HSequenceOfShape);
  }

export declare class TransferBRep_Reader {
  constructor()
  SetProtocol(protocol: Handle_Interface_Protocol): void;
  Protocol(): Handle_Interface_Protocol;
  SetActor(actor: Handle_Transfer_ActorOfTransientProcess): void;
  Actor(): Handle_Transfer_ActorOfTransientProcess;
  SetFileStatus(status: Graphic3d_ZLayerId): void;
  FileStatus(): Graphic3d_ZLayerId;
  FileNotFound(): Standard_Boolean;
  SyntaxError(): Standard_Boolean;
  SetModel(model: Handle_Interface_InterfaceModel): void;
  Model(): Handle_Interface_InterfaceModel;
  Clear(): void;
  CheckStatusModel(withprint: Standard_Boolean): Standard_Boolean;
  CheckListModel(): Interface_CheckIterator;
  ModeNewTransfer(): Standard_Boolean;
  BeginTransfer(): Standard_Boolean;
  EndTransfer(): void;
  PrepareTransfer(): void;
  TransferRoots(theProgress: Message_ProgressRange): void;
  Transfer(num: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): Standard_Boolean;
  TransferList(list: Handle_TColStd_HSequenceOfTransient, theProgress: Message_ProgressRange): void;
  IsDone(): Standard_Boolean;
  NbShapes(): Graphic3d_ZLayerId;
  Shapes(): Handle_TopTools_HSequenceOfShape;
  Shape(num: Graphic3d_ZLayerId): TopoDS_Shape;
  ShapeResult(ent: Handle_Standard_Transient): TopoDS_Shape;
  OneShape(): TopoDS_Shape;
  NbTransients(): Graphic3d_ZLayerId;
  Transients(): Handle_TColStd_HSequenceOfTransient;
  Transient(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  CheckStatusResult(withprints: Standard_Boolean): Standard_Boolean;
  CheckListResult(): Interface_CheckIterator;
  TransientProcess(): Handle_Transfer_TransientProcess;
  delete(): void;
}

export declare class Handle_TransferBRep_OrientedShapeMapper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_OrientedShapeMapper): void;
  get(): TransferBRep_OrientedShapeMapper;
  delete(): void;
}

  export declare class Handle_TransferBRep_OrientedShapeMapper_1 extends Handle_TransferBRep_OrientedShapeMapper {
    constructor();
  }

  export declare class Handle_TransferBRep_OrientedShapeMapper_2 extends Handle_TransferBRep_OrientedShapeMapper {
    constructor(thePtr: TransferBRep_OrientedShapeMapper);
  }

  export declare class Handle_TransferBRep_OrientedShapeMapper_3 extends Handle_TransferBRep_OrientedShapeMapper {
    constructor(theHandle: Handle_TransferBRep_OrientedShapeMapper);
  }

  export declare class Handle_TransferBRep_OrientedShapeMapper_4 extends Handle_TransferBRep_OrientedShapeMapper {
    constructor(theHandle: Handle_TransferBRep_OrientedShapeMapper);
  }

export declare class TransferBRep_OrientedShapeMapper extends Transfer_Finder {
  constructor(akey: TopoDS_Shape)
  Value(): TopoDS_Shape;
  Equates(other: Handle_Transfer_Finder): Standard_Boolean;
  ValueType(): Handle_Standard_Type;
  ValueTypeName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TransferBRep_TransferResultInfo extends Standard_Transient {
  constructor()
  Clear(): void;
  Result(): Graphic3d_ZLayerId;
  ResultWarning(): Graphic3d_ZLayerId;
  ResultFail(): Graphic3d_ZLayerId;
  ResultWarningFail(): Graphic3d_ZLayerId;
  NoResult(): Graphic3d_ZLayerId;
  NoResultWarning(): Graphic3d_ZLayerId;
  NoResultFail(): Graphic3d_ZLayerId;
  NoResultWarningFail(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TransferBRep_TransferResultInfo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_TransferResultInfo): void;
  get(): TransferBRep_TransferResultInfo;
  delete(): void;
}

  export declare class Handle_TransferBRep_TransferResultInfo_1 extends Handle_TransferBRep_TransferResultInfo {
    constructor();
  }

  export declare class Handle_TransferBRep_TransferResultInfo_2 extends Handle_TransferBRep_TransferResultInfo {
    constructor(thePtr: TransferBRep_TransferResultInfo);
  }

  export declare class Handle_TransferBRep_TransferResultInfo_3 extends Handle_TransferBRep_TransferResultInfo {
    constructor(theHandle: Handle_TransferBRep_TransferResultInfo);
  }

  export declare class Handle_TransferBRep_TransferResultInfo_4 extends Handle_TransferBRep_TransferResultInfo {
    constructor(theHandle: Handle_TransferBRep_TransferResultInfo);
  }

export declare class TransferBRep_BinderOfShape extends Transfer_Binder {
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  SetResult(res: TopoDS_Shape): void;
  Result(): TopoDS_Shape;
  CResult(): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TransferBRep_BinderOfShape_1 extends TransferBRep_BinderOfShape {
    constructor();
  }

  export declare class TransferBRep_BinderOfShape_2 extends TransferBRep_BinderOfShape {
    constructor(res: TopoDS_Shape);
  }

export declare class Handle_TransferBRep_BinderOfShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_BinderOfShape): void;
  get(): TransferBRep_BinderOfShape;
  delete(): void;
}

  export declare class Handle_TransferBRep_BinderOfShape_1 extends Handle_TransferBRep_BinderOfShape {
    constructor();
  }

  export declare class Handle_TransferBRep_BinderOfShape_2 extends Handle_TransferBRep_BinderOfShape {
    constructor(thePtr: TransferBRep_BinderOfShape);
  }

  export declare class Handle_TransferBRep_BinderOfShape_3 extends Handle_TransferBRep_BinderOfShape {
    constructor(theHandle: Handle_TransferBRep_BinderOfShape);
  }

  export declare class Handle_TransferBRep_BinderOfShape_4 extends Handle_TransferBRep_BinderOfShape {
    constructor(theHandle: Handle_TransferBRep_BinderOfShape);
  }

export declare class Handle_TransferBRep_ShapeBinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TransferBRep_ShapeBinder): void;
  get(): TransferBRep_ShapeBinder;
  delete(): void;
}

  export declare class Handle_TransferBRep_ShapeBinder_1 extends Handle_TransferBRep_ShapeBinder {
    constructor();
  }

  export declare class Handle_TransferBRep_ShapeBinder_2 extends Handle_TransferBRep_ShapeBinder {
    constructor(thePtr: TransferBRep_ShapeBinder);
  }

  export declare class Handle_TransferBRep_ShapeBinder_3 extends Handle_TransferBRep_ShapeBinder {
    constructor(theHandle: Handle_TransferBRep_ShapeBinder);
  }

  export declare class Handle_TransferBRep_ShapeBinder_4 extends Handle_TransferBRep_ShapeBinder {
    constructor(theHandle: Handle_TransferBRep_ShapeBinder);
  }

export declare class TransferBRep_ShapeBinder extends TransferBRep_BinderOfShape {
  ShapeType(): TopAbs_ShapeEnum;
  Vertex(): TopoDS_Vertex;
  Edge(): TopoDS_Edge;
  Wire(): TopoDS_Wire;
  Face(): TopoDS_Face;
  Shell(): TopoDS_Shell;
  Solid(): TopoDS_Solid;
  CompSolid(): TopoDS_CompSolid;
  Compound(): TopoDS_Compound;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TransferBRep_ShapeBinder_1 extends TransferBRep_ShapeBinder {
    constructor();
  }

  export declare class TransferBRep_ShapeBinder_2 extends TransferBRep_ShapeBinder {
    constructor(res: TopoDS_Shape);
  }

export declare class HLRBRep_FaceIterator {
  constructor()
  InitEdge(fd: HLRBRep_FaceData): void;
  MoreEdge(): Standard_Boolean;
  NextEdge(): void;
  BeginningOfWire(): Standard_Boolean;
  EndOfWire(): Standard_Boolean;
  SkipWire(): void;
  Wire(): Handle_HLRAlgo_EdgesBlock;
  Edge(): Graphic3d_ZLayerId;
  Orientation(): TopAbs_Orientation;
  OutLine(): Standard_Boolean;
  Internal(): Standard_Boolean;
  Double(): Standard_Boolean;
  IsoLine(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_HLRBRep_Data {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRBRep_Data): void;
  get(): HLRBRep_Data;
  delete(): void;
}

  export declare class Handle_HLRBRep_Data_1 extends Handle_HLRBRep_Data {
    constructor();
  }

  export declare class Handle_HLRBRep_Data_2 extends Handle_HLRBRep_Data {
    constructor(thePtr: HLRBRep_Data);
  }

  export declare class Handle_HLRBRep_Data_3 extends Handle_HLRBRep_Data {
    constructor(theHandle: Handle_HLRBRep_Data);
  }

  export declare class Handle_HLRBRep_Data_4 extends Handle_HLRBRep_Data {
    constructor(theHandle: Handle_HLRBRep_Data);
  }

export declare class HLRBRep_Data extends Standard_Transient {
  constructor(NV: Graphic3d_ZLayerId, NE: Graphic3d_ZLayerId, NF: Graphic3d_ZLayerId)
  Write(DS: Handle_HLRBRep_Data, dv: Graphic3d_ZLayerId, de: Graphic3d_ZLayerId, df: Graphic3d_ZLayerId): void;
  EDataArray(): HLRBRep_Array1OfEData;
  FDataArray(): HLRBRep_Array1OfFData;
  Tolerance_1(tol: Standard_ShortReal): void;
  Tolerance_2(): Standard_ShortReal;
  Update(P: HLRAlgo_Projector): void;
  Projector(): HLRAlgo_Projector;
  NbVertices(): Graphic3d_ZLayerId;
  NbEdges(): Graphic3d_ZLayerId;
  NbFaces(): Graphic3d_ZLayerId;
  EdgeMap(): TopTools_IndexedMapOfShape;
  FaceMap(): TopTools_IndexedMapOfShape;
  InitBoundSort(MinMaxTot: any, e1: Graphic3d_ZLayerId, e2: Graphic3d_ZLayerId): void;
  InitEdge(FI: Graphic3d_ZLayerId, MST: BRepTopAdaptor_MapOfShapeTool): void;
  MoreEdge(): Standard_Boolean;
  NextEdge(skip: Standard_Boolean): void;
  Edge(): Graphic3d_ZLayerId;
  HidingTheFace(): Standard_Boolean;
  SimpleHidingFace(): Standard_Boolean;
  InitInterference(): void;
  MoreInterference(): Standard_Boolean;
  NextInterference(): void;
  RejectedInterference(): Standard_Boolean;
  AboveInterference(): Standard_Boolean;
  Interference(): HLRAlgo_Interference;
  LocalLEGeometry2D(Param: Quantity_AbsorbedDose, Tg: gp_Dir2d, Nm: gp_Dir2d, Cu: Quantity_AbsorbedDose): void;
  LocalFEGeometry2D(FE: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose, Tg: gp_Dir2d, Nm: gp_Dir2d, Cu: Quantity_AbsorbedDose): void;
  EdgeState(p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose, stbef: TopAbs_State, staf: TopAbs_State): void;
  EdgeOfTheHidingFace(E: Graphic3d_ZLayerId, ED: HLRBRep_EdgeData): Standard_Boolean;
  HidingStartLevel(E: Graphic3d_ZLayerId, ED: HLRBRep_EdgeData, IL: HLRAlgo_InterferenceList): Graphic3d_ZLayerId;
  Compare(E: Graphic3d_ZLayerId, ED: HLRBRep_EdgeData): TopAbs_State;
  SimplClassify(E: Graphic3d_ZLayerId, ED: HLRBRep_EdgeData, Nbp: Graphic3d_ZLayerId, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): TopAbs_State;
  Classify(E: Graphic3d_ZLayerId, ED: HLRBRep_EdgeData, LevelFlag: Standard_Boolean, Level: Graphic3d_ZLayerId, param: Quantity_AbsorbedDose): TopAbs_State;
  IsBadFace(): Standard_Boolean;
  Destroy(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class HLRBRep_EdgeFaceTool {
  constructor();
  static CurvatureValue(F: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Tg: gp_Dir): Quantity_AbsorbedDose;
  static UVPoint(Par: Quantity_AbsorbedDose, E: Standard_Address, F: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class HLRBRep_ShapeBounds {
  Translate(NV: Graphic3d_ZLayerId, NE: Graphic3d_ZLayerId, NF: Graphic3d_ZLayerId): void;
  Shape_1(S: Handle_HLRTopoBRep_OutLiner): void;
  Shape_2(): Handle_HLRTopoBRep_OutLiner;
  ShapeData_1(SD: Handle_Standard_Transient): void;
  ShapeData_2(): Handle_Standard_Transient;
  NbOfIso_1(nbIso: Graphic3d_ZLayerId): void;
  NbOfIso_2(): Graphic3d_ZLayerId;
  Sizes(NV: Graphic3d_ZLayerId, NE: Graphic3d_ZLayerId, NF: Graphic3d_ZLayerId): void;
  Bounds(V1: Graphic3d_ZLayerId, V2: Graphic3d_ZLayerId, E1: Graphic3d_ZLayerId, E2: Graphic3d_ZLayerId, F1: Graphic3d_ZLayerId, F2: Graphic3d_ZLayerId): void;
  UpdateMinMax(theTotMinMax: any): void;
  MinMax(): any;
  delete(): void;
}

  export declare class HLRBRep_ShapeBounds_1 extends HLRBRep_ShapeBounds {
    constructor();
  }

  export declare class HLRBRep_ShapeBounds_2 extends HLRBRep_ShapeBounds {
    constructor(S: Handle_HLRTopoBRep_OutLiner, SData: Handle_Standard_Transient, nbIso: Graphic3d_ZLayerId, V1: Graphic3d_ZLayerId, V2: Graphic3d_ZLayerId, E1: Graphic3d_ZLayerId, E2: Graphic3d_ZLayerId, F1: Graphic3d_ZLayerId, F2: Graphic3d_ZLayerId);
  }

  export declare class HLRBRep_ShapeBounds_3 extends HLRBRep_ShapeBounds {
    constructor(S: Handle_HLRTopoBRep_OutLiner, nbIso: Graphic3d_ZLayerId, V1: Graphic3d_ZLayerId, V2: Graphic3d_ZLayerId, E1: Graphic3d_ZLayerId, E2: Graphic3d_ZLayerId, F1: Graphic3d_ZLayerId, F2: Graphic3d_ZLayerId);
  }

export declare class HLRBRep_HLRToShape {
  constructor(A: Handle_HLRBRep_Algo)
  VCompound_1(): TopoDS_Shape;
  VCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  Rg1LineVCompound_1(): TopoDS_Shape;
  Rg1LineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  RgNLineVCompound_1(): TopoDS_Shape;
  RgNLineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  OutLineVCompound_1(): TopoDS_Shape;
  OutLineVCompound3d(): TopoDS_Shape;
  OutLineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  IsoLineVCompound_1(): TopoDS_Shape;
  IsoLineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  HCompound_1(): TopoDS_Shape;
  HCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  Rg1LineHCompound_1(): TopoDS_Shape;
  Rg1LineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  RgNLineHCompound_1(): TopoDS_Shape;
  RgNLineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  OutLineHCompound_1(): TopoDS_Shape;
  OutLineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  IsoLineHCompound_1(): TopoDS_Shape;
  IsoLineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  CompoundOfEdges_1(type: HLRBRep_TypeOfResultingEdge, visible: Standard_Boolean, In3d: Standard_Boolean): TopoDS_Shape;
  CompoundOfEdges_2(S: TopoDS_Shape, type: HLRBRep_TypeOfResultingEdge, visible: Standard_Boolean, In3d: Standard_Boolean): TopoDS_Shape;
  delete(): void;
}

export declare class HLRBRep_TheInterferenceOfInterCSurf extends Intf_Interference {
  Perform_1(thePolyg: HLRBRep_ThePolygonOfInterCSurf, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): void;
  Perform_2(theLin: gp_Lin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): void;
  Perform_3(theLins: Intf_Array1OfLin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): void;
  Perform_4(thePolyg: HLRBRep_ThePolygonOfInterCSurf, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox): void;
  Perform_5(theLin: gp_Lin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox): void;
  Perform_6(theLins: Intf_Array1OfLin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox): void;
  Interference_1(thePolyg: HLRBRep_ThePolygonOfInterCSurf, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox): void;
  Interference_2(thePolyg: HLRBRep_ThePolygonOfInterCSurf, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): void;
  delete(): void;
}

  export declare class HLRBRep_TheInterferenceOfInterCSurf_1 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor();
  }

  export declare class HLRBRep_TheInterferenceOfInterCSurf_2 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor(thePolyg: HLRBRep_ThePolygonOfInterCSurf, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf);
  }

  export declare class HLRBRep_TheInterferenceOfInterCSurf_3 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor(theLin: gp_Lin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf);
  }

  export declare class HLRBRep_TheInterferenceOfInterCSurf_4 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor(theLins: Intf_Array1OfLin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf);
  }

  export declare class HLRBRep_TheInterferenceOfInterCSurf_5 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor(thePolyg: HLRBRep_ThePolygonOfInterCSurf, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox);
  }

  export declare class HLRBRep_TheInterferenceOfInterCSurf_6 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor(theLin: gp_Lin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox);
  }

  export declare class HLRBRep_TheInterferenceOfInterCSurf_7 extends HLRBRep_TheInterferenceOfInterCSurf {
    constructor(theLins: Intf_Array1OfLin, thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, theBoundSB: Bnd_BoundSortBox);
  }

export declare class HLRBRep_CurveTool {
  constructor();
  static FirstParameter(C: Standard_Address): Quantity_AbsorbedDose;
  static LastParameter(C: Standard_Address): Quantity_AbsorbedDose;
  static Continuity(C: Standard_Address): GeomAbs_Shape;
  static NbIntervals(C: Standard_Address): Graphic3d_ZLayerId;
  static Intervals(C: Standard_Address, T: TColStd_Array1OfReal): void;
  static GetInterval(C: Standard_Address, Index: Graphic3d_ZLayerId, Tab: TColStd_Array1OfReal, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  static IsClosed(C: Standard_Address): Standard_Boolean;
  static IsPeriodic(C: Standard_Address): Standard_Boolean;
  static Period(C: Standard_Address): Quantity_AbsorbedDose;
  static Value(C: Standard_Address, U: Quantity_AbsorbedDose): gp_Pnt2d;
  static D0(C: Standard_Address, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Standard_Address, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D2(C: Standard_Address, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(C: Standard_Address, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static DN(C: Standard_Address, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static Resolution(C: Standard_Address, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Standard_Address): GeomAbs_CurveType;
  static TheType(C: Standard_Address): GeomAbs_CurveType;
  static Line(C: Standard_Address): gp_Lin2d;
  static Circle(C: Standard_Address): gp_Circ2d;
  static Ellipse(C: Standard_Address): gp_Elips2d;
  static Hyperbola(C: Standard_Address): gp_Hypr2d;
  static Parabola(C: Standard_Address): gp_Parab2d;
  static Bezier(C: Standard_Address): Handle_Geom2d_BezierCurve;
  static BSpline(C: Standard_Address): Handle_Geom2d_BSplineCurve;
  static EpsX(C: Standard_Address): Quantity_AbsorbedDose;
  static NbSamples_1(C: Standard_Address, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamples_2(C: Standard_Address): Graphic3d_ZLayerId;
  static Degree(C: Standard_Address): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class HLRBRep_CInter extends IntRes2d_Intersection {
  Perform_1(C1: Standard_Address, D1: IntRes2d_Domain, C2: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C1: Standard_Address, C2: Standard_Address, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(C1: Standard_Address, D1: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(C1: Standard_Address, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(C1: Standard_Address, D1: IntRes2d_Domain, C2: Standard_Address, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_6(C1: Standard_Address, C2: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  ComputeDomain(C1: Standard_Address, TolDomain: Quantity_AbsorbedDose): IntRes2d_Domain;
  SetMinNbSamples(theMinNbSamples: Graphic3d_ZLayerId): void;
  GetMinNbSamples(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class HLRBRep_CInter_1 extends HLRBRep_CInter {
    constructor();
  }

  export declare class HLRBRep_CInter_2 extends HLRBRep_CInter {
    constructor(C: Standard_Address, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_CInter_3 extends HLRBRep_CInter {
    constructor(C: Standard_Address, D: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_CInter_4 extends HLRBRep_CInter {
    constructor(C1: Standard_Address, C2: Standard_Address, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_CInter_5 extends HLRBRep_CInter {
    constructor(C1: Standard_Address, D1: IntRes2d_Domain, C2: Standard_Address, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_CInter_6 extends HLRBRep_CInter {
    constructor(C1: Standard_Address, C2: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_CInter_7 extends HLRBRep_CInter {
    constructor(C1: Standard_Address, D1: IntRes2d_Domain, C2: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_Algo extends HLRBRep_InternalAlgo {
  Add_1(S: TopoDS_Shape, SData: Handle_Standard_Transient, nbIso: Graphic3d_ZLayerId): void;
  Add_2(S: TopoDS_Shape, nbIso: Graphic3d_ZLayerId): void;
  Index(S: TopoDS_Shape): Graphic3d_ZLayerId;
  OutLinedShapeNullify(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class HLRBRep_Algo_1 extends HLRBRep_Algo {
    constructor();
  }

  export declare class HLRBRep_Algo_2 extends HLRBRep_Algo {
    constructor(A: Handle_HLRBRep_Algo);
  }

export declare class Handle_HLRBRep_Algo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRBRep_Algo): void;
  get(): HLRBRep_Algo;
  delete(): void;
}

  export declare class Handle_HLRBRep_Algo_1 extends Handle_HLRBRep_Algo {
    constructor();
  }

  export declare class Handle_HLRBRep_Algo_2 extends Handle_HLRBRep_Algo {
    constructor(thePtr: HLRBRep_Algo);
  }

  export declare class Handle_HLRBRep_Algo_3 extends Handle_HLRBRep_Algo {
    constructor(theHandle: Handle_HLRBRep_Algo);
  }

  export declare class Handle_HLRBRep_Algo_4 extends Handle_HLRBRep_Algo {
    constructor(theHandle: Handle_HLRBRep_Algo);
  }

export declare class HLRBRep_ListOfBPoint extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: HLRBRep_ListOfBPoint): HLRBRep_ListOfBPoint;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): HLRBRep_BiPoint;
  First_2(): HLRBRep_BiPoint;
  Last_1(): HLRBRep_BiPoint;
  Last_2(): HLRBRep_BiPoint;
  Append_1(theItem: HLRBRep_BiPoint): HLRBRep_BiPoint;
  Append_3(theOther: HLRBRep_ListOfBPoint): void;
  Prepend_1(theItem: HLRBRep_BiPoint): HLRBRep_BiPoint;
  Prepend_2(theOther: HLRBRep_ListOfBPoint): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class HLRBRep_ListOfBPoint_1 extends HLRBRep_ListOfBPoint {
    constructor();
  }

  export declare class HLRBRep_ListOfBPoint_2 extends HLRBRep_ListOfBPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRBRep_ListOfBPoint_3 extends HLRBRep_ListOfBPoint {
    constructor(theOther: HLRBRep_ListOfBPoint);
  }

export declare class HLRBRep_ThePolygonOfInterCSurf {
  Bounding(): Bnd_Box;
  DeflectionOverEstimation(): Quantity_AbsorbedDose;
  SetDeflectionOverEstimation(x: Quantity_AbsorbedDose): void;
  Closed_1(clos: Standard_Boolean): void;
  Closed_2(): Standard_Boolean;
  NbSegments(): Graphic3d_ZLayerId;
  BeginOfSeg(Index: Graphic3d_ZLayerId): gp_Pnt;
  EndOfSeg(Index: Graphic3d_ZLayerId): gp_Pnt;
  InfParameter(): Quantity_AbsorbedDose;
  SupParameter(): Quantity_AbsorbedDose;
  ApproxParamOnCurve(Index: Graphic3d_ZLayerId, ParamOnLine: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Dump(): void;
  delete(): void;
}

  export declare class HLRBRep_ThePolygonOfInterCSurf_1 extends HLRBRep_ThePolygonOfInterCSurf {
    constructor(Curve: gp_Lin, NbPnt: Graphic3d_ZLayerId);
  }

  export declare class HLRBRep_ThePolygonOfInterCSurf_2 extends HLRBRep_ThePolygonOfInterCSurf {
    constructor(Curve: gp_Lin, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, NbPnt: Graphic3d_ZLayerId);
  }

  export declare class HLRBRep_ThePolygonOfInterCSurf_3 extends HLRBRep_ThePolygonOfInterCSurf {
    constructor(Curve: gp_Lin, Upars: TColStd_Array1OfReal);
  }

export declare class HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter extends math_FunctionWithDerivative {
  Initialize(C: Standard_Address): void;
  SetPoint(P: gp_Pnt2d): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter_1 extends HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter {
    constructor();
  }

  export declare class HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter_2 extends HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter {
    constructor(P: gp_Pnt2d, C: Standard_Address);
  }

export declare class HLRBRep_CLPropsATool {
  constructor();
  static Value(A: HLRBRep_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(A: HLRBRep_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  static D2(A: HLRBRep_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(A: HLRBRep_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static Continuity(A: HLRBRep_Curve): Graphic3d_ZLayerId;
  static FirstParameter(A: HLRBRep_Curve): Quantity_AbsorbedDose;
  static LastParameter(A: HLRBRep_Curve): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class HLRBRep_SLProps {
  SetSurface(S: Standard_Address): void;
  SetParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  D1U(): gp_Vec;
  D1V(): gp_Vec;
  D2U(): gp_Vec;
  D2V(): gp_Vec;
  DUV(): gp_Vec;
  IsTangentUDefined(): Standard_Boolean;
  TangentU(D: gp_Dir): void;
  IsTangentVDefined(): Standard_Boolean;
  TangentV(D: gp_Dir): void;
  IsNormalDefined(): Standard_Boolean;
  Normal(): gp_Dir;
  IsCurvatureDefined(): Standard_Boolean;
  IsUmbilic(): Standard_Boolean;
  MaxCurvature(): Quantity_AbsorbedDose;
  MinCurvature(): Quantity_AbsorbedDose;
  CurvatureDirections(MaxD: gp_Dir, MinD: gp_Dir): void;
  MeanCurvature(): Quantity_AbsorbedDose;
  GaussianCurvature(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class HLRBRep_SLProps_1 extends HLRBRep_SLProps {
    constructor(S: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_SLProps_2 extends HLRBRep_SLProps {
    constructor(S: Standard_Address, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_SLProps_3 extends HLRBRep_SLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_TheCSFunctionOfInterCSurf extends math_FunctionSetWithDerivatives {
  constructor(S: Standard_Address, C: gp_Lin)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Point(): gp_Pnt;
  Root(): Quantity_AbsorbedDose;
  AuxillarSurface(): Standard_Address;
  AuxillarCurve(): gp_Lin;
  delete(): void;
}

export declare class HLRBRep_TheDistBetweenPCurvesOfTheIntPCurvePCurveOfCInter extends math_FunctionSetWithDerivatives {
  constructor(curve1: Standard_Address, curve2: Standard_Address)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class HLRBRep_InterCSurf extends IntCurveSurface_Intersection {
  constructor()
  Perform_1(Curve: gp_Lin, Surface: Standard_Address): void;
  Perform_2(Curve: gp_Lin, Polygon: HLRBRep_ThePolygonOfInterCSurf, Surface: Standard_Address): void;
  Perform_3(Curve: gp_Lin, ThePolygon: HLRBRep_ThePolygonOfInterCSurf, Surface: Standard_Address, Polyhedron: HLRBRep_ThePolyhedronOfInterCSurf): void;
  Perform_4(Curve: gp_Lin, ThePolygon: HLRBRep_ThePolygonOfInterCSurf, Surface: Standard_Address, Polyhedron: HLRBRep_ThePolyhedronOfInterCSurf, BndBSB: Bnd_BoundSortBox): void;
  Perform_5(Curve: gp_Lin, Surface: Standard_Address, Polyhedron: HLRBRep_ThePolyhedronOfInterCSurf): void;
  delete(): void;
}

export declare class HLRBRep_TheIntPCurvePCurveOfCInter extends IntRes2d_Intersection {
  constructor()
  Perform_1(Curve1: Standard_Address, Domain1: IntRes2d_Domain, Curve2: Standard_Address, Domain2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(Curve1: Standard_Address, Domain1: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  SetMinNbSamples(theMinNbSamples: Graphic3d_ZLayerId): void;
  GetMinNbSamples(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class HLRBRep_ListOfBPnt2D extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: HLRBRep_ListOfBPnt2D): HLRBRep_ListOfBPnt2D;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): HLRBRep_BiPnt2D;
  First_2(): HLRBRep_BiPnt2D;
  Last_1(): HLRBRep_BiPnt2D;
  Last_2(): HLRBRep_BiPnt2D;
  Append_1(theItem: HLRBRep_BiPnt2D): HLRBRep_BiPnt2D;
  Append_3(theOther: HLRBRep_ListOfBPnt2D): void;
  Prepend_1(theItem: HLRBRep_BiPnt2D): HLRBRep_BiPnt2D;
  Prepend_2(theOther: HLRBRep_ListOfBPnt2D): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class HLRBRep_ListOfBPnt2D_1 extends HLRBRep_ListOfBPnt2D {
    constructor();
  }

  export declare class HLRBRep_ListOfBPnt2D_2 extends HLRBRep_ListOfBPnt2D {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRBRep_ListOfBPnt2D_3 extends HLRBRep_ListOfBPnt2D {
    constructor(theOther: HLRBRep_ListOfBPnt2D);
  }

export declare class HLRBRep_SLPropsATool {
  constructor();
  static Value(A: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(A: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  static D2(A: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, DUV: gp_Vec): void;
  static DN(A: Standard_Address, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static Continuity(A: Standard_Address): Graphic3d_ZLayerId;
  static Bounds(A: Standard_Address, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_HLRBRep_InternalAlgo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRBRep_InternalAlgo): void;
  get(): HLRBRep_InternalAlgo;
  delete(): void;
}

  export declare class Handle_HLRBRep_InternalAlgo_1 extends Handle_HLRBRep_InternalAlgo {
    constructor();
  }

  export declare class Handle_HLRBRep_InternalAlgo_2 extends Handle_HLRBRep_InternalAlgo {
    constructor(thePtr: HLRBRep_InternalAlgo);
  }

  export declare class Handle_HLRBRep_InternalAlgo_3 extends Handle_HLRBRep_InternalAlgo {
    constructor(theHandle: Handle_HLRBRep_InternalAlgo);
  }

  export declare class Handle_HLRBRep_InternalAlgo_4 extends Handle_HLRBRep_InternalAlgo {
    constructor(theHandle: Handle_HLRBRep_InternalAlgo);
  }

export declare class HLRBRep_InternalAlgo extends Standard_Transient {
  Projector_1(P: HLRAlgo_Projector): void;
  Projector_2(): HLRAlgo_Projector;
  Update(): void;
  Load_1(S: Handle_HLRTopoBRep_OutLiner, SData: Handle_Standard_Transient, nbIso: Graphic3d_ZLayerId): void;
  Load_2(S: Handle_HLRTopoBRep_OutLiner, nbIso: Graphic3d_ZLayerId): void;
  Index(S: Handle_HLRTopoBRep_OutLiner): Graphic3d_ZLayerId;
  Remove(I: Graphic3d_ZLayerId): void;
  ShapeData(I: Graphic3d_ZLayerId, SData: Handle_Standard_Transient): void;
  SeqOfShapeBounds(): HLRBRep_SeqOfShapeBounds;
  NbShapes(): Graphic3d_ZLayerId;
  ShapeBounds(I: Graphic3d_ZLayerId): HLRBRep_ShapeBounds;
  InitEdgeStatus(): void;
  Select_1(): void;
  Select_2(I: Graphic3d_ZLayerId): void;
  SelectEdge(I: Graphic3d_ZLayerId): void;
  SelectFace(I: Graphic3d_ZLayerId): void;
  ShowAll_1(): void;
  ShowAll_2(I: Graphic3d_ZLayerId): void;
  HideAll_1(): void;
  HideAll_2(I: Graphic3d_ZLayerId): void;
  PartialHide(): void;
  Hide_1(): void;
  Hide_2(I: Graphic3d_ZLayerId): void;
  Hide_3(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): void;
  Debug_1(deb: Standard_Boolean): void;
  Debug_2(): Standard_Boolean;
  DataStructure(): Handle_HLRBRep_Data;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class HLRBRep_InternalAlgo_1 extends HLRBRep_InternalAlgo {
    constructor();
  }

  export declare class HLRBRep_InternalAlgo_2 extends HLRBRep_InternalAlgo {
    constructor(A: Handle_HLRBRep_InternalAlgo);
  }

export declare class HLRBRep_Array1OfFData {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: HLRBRep_FaceData): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: HLRBRep_Array1OfFData): HLRBRep_Array1OfFData;
  Move(theOther: HLRBRep_Array1OfFData): HLRBRep_Array1OfFData;
  First(): HLRBRep_FaceData;
  ChangeFirst(): HLRBRep_FaceData;
  Last(): HLRBRep_FaceData;
  ChangeLast(): HLRBRep_FaceData;
  Value(theIndex: Standard_Integer): HLRBRep_FaceData;
  ChangeValue(theIndex: Standard_Integer): HLRBRep_FaceData;
  SetValue(theIndex: Standard_Integer, theItem: HLRBRep_FaceData): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRBRep_Array1OfFData_1 extends HLRBRep_Array1OfFData {
    constructor();
  }

  export declare class HLRBRep_Array1OfFData_2 extends HLRBRep_Array1OfFData {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class HLRBRep_Array1OfFData_3 extends HLRBRep_Array1OfFData {
    constructor(theOther: HLRBRep_Array1OfFData);
  }

  export declare class HLRBRep_Array1OfFData_4 extends HLRBRep_Array1OfFData {
    constructor(theOther: HLRBRep_Array1OfFData);
  }

  export declare class HLRBRep_Array1OfFData_5 extends HLRBRep_Array1OfFData {
    constructor(theBegin: HLRBRep_FaceData, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class HLRBRep_IntConicCurveOfCInter extends IntRes2d_Intersection {
  Perform_1(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class HLRBRep_IntConicCurveOfCInter_1 extends HLRBRep_IntConicCurveOfCInter {
    constructor();
  }

  export declare class HLRBRep_IntConicCurveOfCInter_2 extends HLRBRep_IntConicCurveOfCInter {
    constructor(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_IntConicCurveOfCInter_3 extends HLRBRep_IntConicCurveOfCInter {
    constructor(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_IntConicCurveOfCInter_4 extends HLRBRep_IntConicCurveOfCInter {
    constructor(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_IntConicCurveOfCInter_5 extends HLRBRep_IntConicCurveOfCInter {
    constructor(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_IntConicCurveOfCInter_6 extends HLRBRep_IntConicCurveOfCInter {
    constructor(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_SeqOfShapeBounds extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: HLRBRep_SeqOfShapeBounds): HLRBRep_SeqOfShapeBounds;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: HLRBRep_ShapeBounds): void;
  Append_2(theSeq: HLRBRep_SeqOfShapeBounds): void;
  Prepend_1(theItem: HLRBRep_ShapeBounds): void;
  Prepend_2(theSeq: HLRBRep_SeqOfShapeBounds): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: HLRBRep_ShapeBounds): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: HLRBRep_SeqOfShapeBounds): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: HLRBRep_SeqOfShapeBounds): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: HLRBRep_ShapeBounds): void;
  Split(theIndex: Standard_Integer, theSeq: HLRBRep_SeqOfShapeBounds): void;
  First(): HLRBRep_ShapeBounds;
  ChangeFirst(): HLRBRep_ShapeBounds;
  Last(): HLRBRep_ShapeBounds;
  ChangeLast(): HLRBRep_ShapeBounds;
  Value(theIndex: Standard_Integer): HLRBRep_ShapeBounds;
  ChangeValue(theIndex: Standard_Integer): HLRBRep_ShapeBounds;
  SetValue(theIndex: Standard_Integer, theItem: HLRBRep_ShapeBounds): void;
  delete(): void;
}

  export declare class HLRBRep_SeqOfShapeBounds_1 extends HLRBRep_SeqOfShapeBounds {
    constructor();
  }

  export declare class HLRBRep_SeqOfShapeBounds_2 extends HLRBRep_SeqOfShapeBounds {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRBRep_SeqOfShapeBounds_3 extends HLRBRep_SeqOfShapeBounds {
    constructor(theOther: HLRBRep_SeqOfShapeBounds);
  }

export declare class HLRBRep_BCurveTool {
  constructor();
  static FirstParameter(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  static Continuity(C: BRepAdaptor_Curve): GeomAbs_Shape;
  static NbIntervals(C: BRepAdaptor_Curve, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: BRepAdaptor_Curve, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static IsClosed(C: BRepAdaptor_Curve): Standard_Boolean;
  static IsPeriodic(C: BRepAdaptor_Curve): Standard_Boolean;
  static Period(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  static Value(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose): gp_Pnt;
  static D0(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  static D2(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static DN(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static Resolution(C: BRepAdaptor_Curve, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: BRepAdaptor_Curve): GeomAbs_CurveType;
  static Line(C: BRepAdaptor_Curve): gp_Lin;
  static Circle(C: BRepAdaptor_Curve): gp_Circ;
  static Ellipse(C: BRepAdaptor_Curve): gp_Elips;
  static Hyperbola(C: BRepAdaptor_Curve): gp_Hypr;
  static Parabola(C: BRepAdaptor_Curve): gp_Parab;
  static Bezier(C: BRepAdaptor_Curve): Handle_Geom_BezierCurve;
  static BSpline(C: BRepAdaptor_Curve): Handle_Geom_BSplineCurve;
  static Degree(C: BRepAdaptor_Curve): Graphic3d_ZLayerId;
  static IsRational(C: BRepAdaptor_Curve): Standard_Boolean;
  static NbPoles(C: BRepAdaptor_Curve): Graphic3d_ZLayerId;
  static NbKnots(C: BRepAdaptor_Curve): Graphic3d_ZLayerId;
  static Poles(C: BRepAdaptor_Curve, T: TColgp_Array1OfPnt): void;
  static PolesAndWeights(C: BRepAdaptor_Curve, T: TColgp_Array1OfPnt, W: TColStd_Array1OfReal): void;
  static NbSamples(C: BRepAdaptor_Curve, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class HLRBRep_EdgeInterferenceTool {
  constructor(DS: Handle_HLRBRep_Data)
  LoadEdge(): void;
  InitVertices(): void;
  MoreVertices(): Standard_Boolean;
  NextVertex(): void;
  CurrentVertex(): HLRAlgo_Intersection;
  CurrentOrientation(): TopAbs_Orientation;
  CurrentParameter(): Quantity_AbsorbedDose;
  IsPeriodic(): Standard_Boolean;
  EdgeGeometry(Param: Quantity_AbsorbedDose, Tgt: gp_Dir, Nrm: gp_Dir, Curv: Quantity_AbsorbedDose): void;
  ParameterOfInterference(I: HLRAlgo_Interference): Quantity_AbsorbedDose;
  SameInterferences(I1: HLRAlgo_Interference, I2: HLRAlgo_Interference): Standard_Boolean;
  SameVertexAndInterference(I: HLRAlgo_Interference): Standard_Boolean;
  InterferenceBoundaryGeometry(I: HLRAlgo_Interference, Tang: gp_Dir, Norm: gp_Dir, Curv: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter {
  Initialize(C: Standard_Address, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d, U0: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  IsMin(): Standard_Boolean;
  Point(): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_1 extends HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter {
    constructor();
  }

  export declare class HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_2 extends HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter {
    constructor(P: gp_Pnt2d, C: Standard_Address, U0: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_3 extends HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter {
    constructor(P: gp_Pnt2d, C: Standard_Address, U0: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_ThePolygon2dOfTheIntPCurvePCurveOfCInter extends Intf_Polygon2d {
  constructor(Curve: Standard_Address, NbPnt: Graphic3d_ZLayerId, Domain: IntRes2d_Domain, Tol: Quantity_AbsorbedDose)
  ComputeWithBox(Curve: Standard_Address, OtherBox: Bnd_Box2d): void;
  DeflectionOverEstimation(): Quantity_AbsorbedDose;
  SetDeflectionOverEstimation(x: Quantity_AbsorbedDose): void;
  Closed_1(clos: Standard_Boolean): void;
  Closed_2(): Standard_Boolean;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(theIndex: Graphic3d_ZLayerId, theBegin: gp_Pnt2d, theEnd: gp_Pnt2d): void;
  InfParameter(): Quantity_AbsorbedDose;
  SupParameter(): Quantity_AbsorbedDose;
  AutoIntersectionIsPossible(): Standard_Boolean;
  ApproxParamOnCurve(Index: Graphic3d_ZLayerId, ParamOnLine: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  CalculRegion(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, x1: Quantity_AbsorbedDose, x2: Quantity_AbsorbedDose, y1: Quantity_AbsorbedDose, y2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Dump(): void;
  delete(): void;
}

export declare class HLRBRep_PolyHLRToShape {
  constructor()
  Update(A: Handle_HLRBRep_PolyAlgo): void;
  Show(): void;
  Hide(): void;
  VCompound_1(): TopoDS_Shape;
  VCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  Rg1LineVCompound_1(): TopoDS_Shape;
  Rg1LineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  RgNLineVCompound_1(): TopoDS_Shape;
  RgNLineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  OutLineVCompound_1(): TopoDS_Shape;
  OutLineVCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  HCompound_1(): TopoDS_Shape;
  HCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  Rg1LineHCompound_1(): TopoDS_Shape;
  Rg1LineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  RgNLineHCompound_1(): TopoDS_Shape;
  RgNLineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  OutLineHCompound_1(): TopoDS_Shape;
  OutLineHCompound_2(S: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

export declare type HLRBRep_TypeOfResultingEdge = {
  HLRBRep_Undefined: {};
  HLRBRep_IsoLine: {};
  HLRBRep_OutLine: {};
  HLRBRep_Rg1Line: {};
  HLRBRep_RgNLine: {};
  HLRBRep_Sharp: {};
}

export declare class HLRBRep_FaceData {
  constructor()
  Set(FG: TopoDS_Face, Or: TopAbs_Orientation, Cl: Standard_Boolean, NW: Graphic3d_ZLayerId): void;
  SetWire(WI: Graphic3d_ZLayerId, NE: Graphic3d_ZLayerId): void;
  SetWEdge(WI: Graphic3d_ZLayerId, EWI: Graphic3d_ZLayerId, EI: Graphic3d_ZLayerId, Or: TopAbs_Orientation, OutL: Standard_Boolean, Inte: Standard_Boolean, Dble: Standard_Boolean, IsoL: Standard_Boolean): void;
  Selected_1(): Standard_Boolean;
  Selected_2(B: Standard_Boolean): void;
  Back_1(): Standard_Boolean;
  Back_2(B: Standard_Boolean): void;
  Side_1(): Standard_Boolean;
  Side_2(B: Standard_Boolean): void;
  Closed_1(): Standard_Boolean;
  Closed_2(B: Standard_Boolean): void;
  Hiding_1(): Standard_Boolean;
  Hiding_2(B: Standard_Boolean): void;
  Simple_1(): Standard_Boolean;
  Simple_2(B: Standard_Boolean): void;
  Cut_1(): Standard_Boolean;
  Cut_2(B: Standard_Boolean): void;
  WithOutL_1(): Standard_Boolean;
  WithOutL_2(B: Standard_Boolean): void;
  Plane_1(): Standard_Boolean;
  Plane_2(B: Standard_Boolean): void;
  Cylinder_1(): Standard_Boolean;
  Cylinder_2(B: Standard_Boolean): void;
  Cone_1(): Standard_Boolean;
  Cone_2(B: Standard_Boolean): void;
  Sphere_1(): Standard_Boolean;
  Sphere_2(B: Standard_Boolean): void;
  Torus_1(): Standard_Boolean;
  Torus_2(B: Standard_Boolean): void;
  Size_1(): Quantity_AbsorbedDose;
  Size_2(S: Quantity_AbsorbedDose): void;
  Orientation_1(): TopAbs_Orientation;
  Orientation_2(O: TopAbs_Orientation): void;
  Wires(): Handle_HLRAlgo_WiresBlock;
  Geometry(): HLRBRep_Surface;
  Tolerance(): Standard_ShortReal;
  delete(): void;
}

export declare class HLRBRep_BiPoint {
  P1(): gp_Pnt;
  P2(): gp_Pnt;
  Shape_1(): TopoDS_Shape;
  Shape_2(S: TopoDS_Shape): void;
  Rg1Line_1(): Standard_Boolean;
  Rg1Line_2(B: Standard_Boolean): void;
  RgNLine_1(): Standard_Boolean;
  RgNLine_2(B: Standard_Boolean): void;
  OutLine_1(): Standard_Boolean;
  OutLine_2(B: Standard_Boolean): void;
  IntLine_1(): Standard_Boolean;
  IntLine_2(B: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRBRep_BiPoint_1 extends HLRBRep_BiPoint {
    constructor();
  }

  export declare class HLRBRep_BiPoint_2 extends HLRBRep_BiPoint {
    constructor(x1: Quantity_AbsorbedDose, y1: Quantity_AbsorbedDose, z1: Quantity_AbsorbedDose, x2: Quantity_AbsorbedDose, y2: Quantity_AbsorbedDose, z2: Quantity_AbsorbedDose, S: TopoDS_Shape, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean);
  }

export declare class HLRBRep_ThePolygonToolOfInterCSurf {
  constructor();
  static Bounding(thePolygon: HLRBRep_ThePolygonOfInterCSurf): Bnd_Box;
  static DeflectionOverEstimation(thePolygon: HLRBRep_ThePolygonOfInterCSurf): Quantity_AbsorbedDose;
  static Closed(thePolygon: HLRBRep_ThePolygonOfInterCSurf): Standard_Boolean;
  static NbSegments(thePolygon: HLRBRep_ThePolygonOfInterCSurf): Graphic3d_ZLayerId;
  static BeginOfSeg(thePolygon: HLRBRep_ThePolygonOfInterCSurf, Index: Graphic3d_ZLayerId): gp_Pnt;
  static EndOfSeg(thePolygon: HLRBRep_ThePolygonOfInterCSurf, Index: Graphic3d_ZLayerId): gp_Pnt;
  static Dump(thePolygon: HLRBRep_ThePolygonOfInterCSurf): void;
  delete(): void;
}

export declare class HLRBRep_AreaLimit extends Standard_Transient {
  constructor(V: HLRAlgo_Intersection, Boundary: Standard_Boolean, Interference: Standard_Boolean, StateBefore: TopAbs_State, StateAfter: TopAbs_State, EdgeBefore: TopAbs_State, EdgeAfter: TopAbs_State)
  StateBefore_1(St: TopAbs_State): void;
  StateAfter_1(St: TopAbs_State): void;
  EdgeBefore_1(St: TopAbs_State): void;
  EdgeAfter_1(St: TopAbs_State): void;
  Previous_1(P: Handle_HLRBRep_AreaLimit): void;
  Next_1(N: Handle_HLRBRep_AreaLimit): void;
  Vertex(): HLRAlgo_Intersection;
  IsBoundary(): Standard_Boolean;
  IsInterference(): Standard_Boolean;
  StateBefore_2(): TopAbs_State;
  StateAfter_2(): TopAbs_State;
  EdgeBefore_2(): TopAbs_State;
  EdgeAfter_2(): TopAbs_State;
  Previous_2(): Handle_HLRBRep_AreaLimit;
  Next_2(): Handle_HLRBRep_AreaLimit;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_HLRBRep_AreaLimit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRBRep_AreaLimit): void;
  get(): HLRBRep_AreaLimit;
  delete(): void;
}

  export declare class Handle_HLRBRep_AreaLimit_1 extends Handle_HLRBRep_AreaLimit {
    constructor();
  }

  export declare class Handle_HLRBRep_AreaLimit_2 extends Handle_HLRBRep_AreaLimit {
    constructor(thePtr: HLRBRep_AreaLimit);
  }

  export declare class Handle_HLRBRep_AreaLimit_3 extends Handle_HLRBRep_AreaLimit {
    constructor(theHandle: Handle_HLRBRep_AreaLimit);
  }

  export declare class Handle_HLRBRep_AreaLimit_4 extends Handle_HLRBRep_AreaLimit {
    constructor(theHandle: Handle_HLRBRep_AreaLimit);
  }

export declare class HLRBRep_TheProjPCurOfCInter {
  constructor();
  static FindParameter_1(C: Standard_Address, Pnt: gp_Pnt2d, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static FindParameter_2(C: Standard_Address, Pnt: gp_Pnt2d, LowParameter: Quantity_AbsorbedDose, HighParameter: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class HLRBRep_ThePolyhedronToolOfInterCSurf {
  constructor();
  static Bounding(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): Bnd_Box;
  static ComponentsBounding(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): Handle_Bnd_HArray1OfBox;
  static DeflectionOverEstimation(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): Quantity_AbsorbedDose;
  static NbTriangles(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): Graphic3d_ZLayerId;
  static Triangle(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, Index: Graphic3d_ZLayerId, P1: Graphic3d_ZLayerId, P2: Graphic3d_ZLayerId, P3: Graphic3d_ZLayerId): void;
  static Point(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, Index: Graphic3d_ZLayerId): gp_Pnt;
  static TriConnex(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, Triang: Graphic3d_ZLayerId, Pivot: Graphic3d_ZLayerId, Pedge: Graphic3d_ZLayerId, TriCon: Graphic3d_ZLayerId, OtherP: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsOnBound(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf, Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId): Standard_Boolean;
  static GetBorderDeflection(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): Quantity_AbsorbedDose;
  static Dump(thePolyh: HLRBRep_ThePolyhedronOfInterCSurf): void;
  delete(): void;
}

export declare class HLRBRep_BiPnt2D {
  P1(): gp_Pnt2d;
  P2(): gp_Pnt2d;
  Shape_1(): TopoDS_Shape;
  Shape_2(S: TopoDS_Shape): void;
  Rg1Line_1(): Standard_Boolean;
  Rg1Line_2(B: Standard_Boolean): void;
  RgNLine_1(): Standard_Boolean;
  RgNLine_2(B: Standard_Boolean): void;
  OutLine_1(): Standard_Boolean;
  OutLine_2(B: Standard_Boolean): void;
  IntLine_1(): Standard_Boolean;
  IntLine_2(B: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRBRep_BiPnt2D_1 extends HLRBRep_BiPnt2D {
    constructor();
  }

  export declare class HLRBRep_BiPnt2D_2 extends HLRBRep_BiPnt2D {
    constructor(x1: Quantity_AbsorbedDose, y1: Quantity_AbsorbedDose, x2: Quantity_AbsorbedDose, y2: Quantity_AbsorbedDose, S: TopoDS_Shape, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean);
  }

  export declare class HLRBRep_BiPnt2D_3 extends HLRBRep_BiPnt2D {
    constructor(thePoint1: gp_XY, thePoint2: gp_XY, S: TopoDS_Shape, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean);
  }

export declare class HLRBRep_EdgeData {
  constructor()
  Set(Reg1: Standard_Boolean, RegN: Standard_Boolean, EG: TopoDS_Edge, V1: Graphic3d_ZLayerId, V2: Graphic3d_ZLayerId, Out1: Standard_Boolean, Out2: Standard_Boolean, Cut1: Standard_Boolean, Cut2: Standard_Boolean, Start: Quantity_AbsorbedDose, TolStart: Standard_ShortReal, End: Quantity_AbsorbedDose, TolEnd: Standard_ShortReal): void;
  Selected_1(): Standard_Boolean;
  Selected_2(B: Standard_Boolean): void;
  Rg1Line_1(): Standard_Boolean;
  Rg1Line_2(B: Standard_Boolean): void;
  RgNLine_1(): Standard_Boolean;
  RgNLine_2(B: Standard_Boolean): void;
  Vertical_1(): Standard_Boolean;
  Vertical_2(B: Standard_Boolean): void;
  Simple_1(): Standard_Boolean;
  Simple_2(B: Standard_Boolean): void;
  OutLVSta_1(): Standard_Boolean;
  OutLVSta_2(B: Standard_Boolean): void;
  OutLVEnd_1(): Standard_Boolean;
  OutLVEnd_2(B: Standard_Boolean): void;
  CutAtSta_1(): Standard_Boolean;
  CutAtSta_2(B: Standard_Boolean): void;
  CutAtEnd_1(): Standard_Boolean;
  CutAtEnd_2(B: Standard_Boolean): void;
  VerAtSta_1(): Standard_Boolean;
  VerAtSta_2(B: Standard_Boolean): void;
  VerAtEnd_1(): Standard_Boolean;
  VerAtEnd_2(B: Standard_Boolean): void;
  AutoIntersectionDone_1(): Standard_Boolean;
  AutoIntersectionDone_2(B: Standard_Boolean): void;
  Used_1(): Standard_Boolean;
  Used_2(B: Standard_Boolean): void;
  HideCount_1(): Graphic3d_ZLayerId;
  HideCount_2(I: Graphic3d_ZLayerId): void;
  VSta_1(): Graphic3d_ZLayerId;
  VSta_2(I: Graphic3d_ZLayerId): void;
  VEnd_1(): Graphic3d_ZLayerId;
  VEnd_2(I: Graphic3d_ZLayerId): void;
  UpdateMinMax(theTotMinMax: any): void;
  MinMax(): any;
  Status(): HLRAlgo_EdgeStatus;
  ChangeGeometry(): HLRBRep_Curve;
  Geometry(): HLRBRep_Curve;
  Curve(): HLRBRep_Curve;
  Tolerance(): Standard_ShortReal;
  delete(): void;
}

export declare class HLRBRep_Curve {
  constructor()
  Projector(Proj: HLRAlgo_Projector): void;
  Curve_1(): BRepAdaptor_Curve;
  Curve_2(E: TopoDS_Edge): void;
  GetCurve(): BRepAdaptor_Curve;
  Parameter2d(P3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Parameter3d(P2d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Update(TotMin: Standard_Real [16], TotMax: Standard_Real [16]): Quantity_AbsorbedDose;
  UpdateMinMax(TotMin: Standard_Real [16], TotMax: Standard_Real [16]): Quantity_AbsorbedDose;
  Z(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Value3D(U: Quantity_AbsorbedDose): gp_Pnt;
  D0_1(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1_1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  Tangent(AtStart: Standard_Boolean, P: gp_Pnt2d, D: gp_Dir2d): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0_2(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1_2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  IsRational(): Standard_Boolean;
  Degree(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Poles_1(TP: TColgp_Array1OfPnt2d): void;
  Poles_2(aCurve: Handle_Geom_BSplineCurve, TP: TColgp_Array1OfPnt2d): void;
  PolesAndWeights_1(TP: TColgp_Array1OfPnt2d, TW: TColStd_Array1OfReal): void;
  PolesAndWeights_2(aCurve: Handle_Geom_BSplineCurve, TP: TColgp_Array1OfPnt2d, TW: TColStd_Array1OfReal): void;
  NbKnots(): Graphic3d_ZLayerId;
  Knots(kn: TColStd_Array1OfReal): void;
  Multiplicities(mu: TColStd_Array1OfInteger): void;
  delete(): void;
}

export declare class HLRBRep_LineTool {
  constructor();
  static FirstParameter(C: gp_Lin): Quantity_AbsorbedDose;
  static LastParameter(C: gp_Lin): Quantity_AbsorbedDose;
  static Continuity(C: gp_Lin): GeomAbs_Shape;
  static NbIntervals(C: gp_Lin, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: gp_Lin, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static IntervalFirst(C: gp_Lin): Quantity_AbsorbedDose;
  static IntervalLast(C: gp_Lin): Quantity_AbsorbedDose;
  static IntervalContinuity(C: gp_Lin): GeomAbs_Shape;
  static IsClosed(C: gp_Lin): Standard_Boolean;
  static IsPeriodic(C: gp_Lin): Standard_Boolean;
  static Period(C: gp_Lin): Quantity_AbsorbedDose;
  static Value(C: gp_Lin, U: Quantity_AbsorbedDose): gp_Pnt;
  static D0(C: gp_Lin, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: gp_Lin, U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  static D2(C: gp_Lin, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: gp_Lin, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static DN(C: gp_Lin, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  static Resolution(C: gp_Lin, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: gp_Lin): GeomAbs_CurveType;
  static Line(C: gp_Lin): gp_Lin;
  static Circle(C: gp_Lin): gp_Circ;
  static Ellipse(C: gp_Lin): gp_Elips;
  static Hyperbola(C: gp_Lin): gp_Hypr;
  static Parabola(C: gp_Lin): gp_Parab;
  static Bezier(C: gp_Lin): Handle_Geom_BezierCurve;
  static BSpline(C: gp_Lin): Handle_Geom_BSplineCurve;
  static Degree(C: gp_Lin): Graphic3d_ZLayerId;
  static NbPoles(C: gp_Lin): Graphic3d_ZLayerId;
  static Poles(C: gp_Lin, TP: TColgp_Array1OfPnt): void;
  static IsRational(C: gp_Lin): Standard_Boolean;
  static PolesAndWeights(C: gp_Lin, TP: TColgp_Array1OfPnt, TW: TColStd_Array1OfReal): void;
  static NbKnots(C: gp_Lin): Graphic3d_ZLayerId;
  static KnotsAndMultiplicities(C: gp_Lin, TK: TColStd_Array1OfReal, TM: TColStd_Array1OfInteger): void;
  static NbSamples(C: gp_Lin, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static SamplePars(C: gp_Lin, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, Defl: Quantity_AbsorbedDose, NbMin: Graphic3d_ZLayerId, Pars: Handle_TColStd_HArray1OfReal): void;
  delete(): void;
}

export declare class HLRBRep_Hider {
  constructor(DS: Handle_HLRBRep_Data)
  OwnHiding(FI: Graphic3d_ZLayerId): void;
  Hide(FI: Graphic3d_ZLayerId, MST: BRepTopAdaptor_MapOfShapeTool): void;
  delete(): void;
}

export declare class HLRBRep_ExactIntersectionPointOfTheIntPCurvePCurveOfCInter {
  constructor(C1: Standard_Address, C2: Standard_Address, Tol: Quantity_AbsorbedDose)
  Perform_1(Poly1: HLRBRep_ThePolygon2dOfTheIntPCurvePCurveOfCInter, Poly2: HLRBRep_ThePolygon2dOfTheIntPCurvePCurveOfCInter, NumSegOn1: Graphic3d_ZLayerId, NumSegOn2: Graphic3d_ZLayerId, ParamOnSeg1: Quantity_AbsorbedDose, ParamOnSeg2: Quantity_AbsorbedDose): void;
  Perform_2(Uo: Quantity_AbsorbedDose, Vo: Quantity_AbsorbedDose, UInf: Quantity_AbsorbedDose, VInf: Quantity_AbsorbedDose, USup: Quantity_AbsorbedDose, VSup: Quantity_AbsorbedDose): void;
  NbRoots(): Graphic3d_ZLayerId;
  Roots(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  AnErrorOccurred(): Standard_Boolean;
  delete(): void;
}

export declare class HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter extends IntRes2d_Intersection {
  Perform(ITool: IntCurve_IConicTool, Dom1: IntRes2d_Domain, PCurve: Standard_Address, Dom2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  FindU(parameter: Quantity_AbsorbedDose, point: gp_Pnt2d, TheParCurev: Standard_Address, IntCurve_IConicTool: IntCurve_IConicTool): Quantity_AbsorbedDose;
  FindV(parameter: Quantity_AbsorbedDose, point: gp_Pnt2d, IntCurve_IConicTool: IntCurve_IConicTool, ParCurve: Standard_Address, TheParCurveDomain: IntRes2d_Domain, V0: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  And_Domaine_Objet1_Intersections(IntCurve_IConicTool: IntCurve_IConicTool, TheParCurve: Standard_Address, TheImpCurveDomain: IntRes2d_Domain, TheParCurveDomain: IntRes2d_Domain, NbResultats: Graphic3d_ZLayerId, Inter2_And_Domain2: TColStd_Array1OfReal, Inter1: TColStd_Array1OfReal, Resultat1: TColStd_Array1OfReal, Resultat2: TColStd_Array1OfReal, EpsNul: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter_1 extends HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter {
    constructor();
  }

  export declare class HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter_2 extends HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter {
    constructor(ITool: IntCurve_IConicTool, Dom1: IntRes2d_Domain, PCurve: Standard_Address, Dom2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_ShapeToHLR {
  constructor();
  static Load(S: Handle_HLRTopoBRep_OutLiner, P: HLRAlgo_Projector, MST: BRepTopAdaptor_MapOfShapeTool, nbIso: Graphic3d_ZLayerId): Handle_HLRBRep_Data;
  delete(): void;
}

export declare class HLRBRep_EdgeIList {
  constructor();
  static AddInterference(IL: HLRAlgo_InterferenceList, I: HLRAlgo_Interference, T: HLRBRep_EdgeInterferenceTool): void;
  static ProcessComplex(IL: HLRAlgo_InterferenceList, T: HLRBRep_EdgeInterferenceTool): void;
  delete(): void;
}

export declare class HLRBRep {
  constructor();
  static MakeEdge(ec: HLRBRep_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): TopoDS_Edge;
  static MakeEdge3d(ec: HLRBRep_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): TopoDS_Edge;
  static PolyHLRAngleAndDeflection(InAngl: Quantity_AbsorbedDose, OutAngl: Quantity_AbsorbedDose, OutDefl: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class HLRBRep_TheIntConicCurveOfCInter extends IntRes2d_Intersection {
  Perform_1(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class HLRBRep_TheIntConicCurveOfCInter_1 extends HLRBRep_TheIntConicCurveOfCInter {
    constructor();
  }

  export declare class HLRBRep_TheIntConicCurveOfCInter_2 extends HLRBRep_TheIntConicCurveOfCInter {
    constructor(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_TheIntConicCurveOfCInter_3 extends HLRBRep_TheIntConicCurveOfCInter {
    constructor(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_TheIntConicCurveOfCInter_4 extends HLRBRep_TheIntConicCurveOfCInter {
    constructor(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_TheIntConicCurveOfCInter_5 extends HLRBRep_TheIntConicCurveOfCInter {
    constructor(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_TheIntConicCurveOfCInter_6 extends HLRBRep_TheIntConicCurveOfCInter {
    constructor(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Standard_Address, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_Array1OfEData {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: HLRBRep_EdgeData): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: HLRBRep_Array1OfEData): HLRBRep_Array1OfEData;
  Move(theOther: HLRBRep_Array1OfEData): HLRBRep_Array1OfEData;
  First(): HLRBRep_EdgeData;
  ChangeFirst(): HLRBRep_EdgeData;
  Last(): HLRBRep_EdgeData;
  ChangeLast(): HLRBRep_EdgeData;
  Value(theIndex: Standard_Integer): HLRBRep_EdgeData;
  ChangeValue(theIndex: Standard_Integer): HLRBRep_EdgeData;
  SetValue(theIndex: Standard_Integer, theItem: HLRBRep_EdgeData): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class HLRBRep_Array1OfEData_1 extends HLRBRep_Array1OfEData {
    constructor();
  }

  export declare class HLRBRep_Array1OfEData_2 extends HLRBRep_Array1OfEData {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class HLRBRep_Array1OfEData_3 extends HLRBRep_Array1OfEData {
    constructor(theOther: HLRBRep_Array1OfEData);
  }

  export declare class HLRBRep_Array1OfEData_4 extends HLRBRep_Array1OfEData {
    constructor(theOther: HLRBRep_Array1OfEData);
  }

  export declare class HLRBRep_Array1OfEData_5 extends HLRBRep_Array1OfEData {
    constructor(theBegin: HLRBRep_EdgeData, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class HLRBRep_EdgeBuilder {
  constructor(VList: HLRBRep_VertexList)
  InitAreas(): void;
  NextArea(): void;
  PreviousArea(): void;
  HasArea(): Standard_Boolean;
  AreaState(): TopAbs_State;
  AreaEdgeState(): TopAbs_State;
  LeftLimit(): Handle_HLRBRep_AreaLimit;
  RightLimit(): Handle_HLRBRep_AreaLimit;
  Builds(ToBuild: TopAbs_State): void;
  MoreEdges(): Standard_Boolean;
  NextEdge(): void;
  MoreVertices(): Standard_Boolean;
  NextVertex(): void;
  Current(): HLRAlgo_Intersection;
  IsBoundary(): Standard_Boolean;
  IsInterference(): Standard_Boolean;
  Orientation(): TopAbs_Orientation;
  Destroy(): void;
  delete(): void;
}

export declare class HLRBRep_TheQuadCurvFuncOfTheQuadCurvExactInterCSurf extends math_FunctionWithDerivative {
  constructor(Q: IntSurf_Quadric, C: gp_Lin)
  Value(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(Param: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class HLRBRep_PolyAlgo extends Standard_Transient {
  NbShapes(): Graphic3d_ZLayerId;
  Shape(I: Graphic3d_ZLayerId): TopoDS_Shape;
  Remove(I: Graphic3d_ZLayerId): void;
  Index(S: TopoDS_Shape): Graphic3d_ZLayerId;
  Load(theShape: TopoDS_Shape): void;
  Algo(): Handle_HLRAlgo_PolyAlgo;
  Projector_1(): HLRAlgo_Projector;
  Projector_2(theProj: HLRAlgo_Projector): void;
  TolAngular_1(): Quantity_AbsorbedDose;
  TolAngular_2(theTol: Quantity_AbsorbedDose): void;
  TolCoef_1(): Quantity_AbsorbedDose;
  TolCoef_2(theTol: Quantity_AbsorbedDose): void;
  Update(): void;
  InitHide(): void;
  MoreHide(): Standard_Boolean;
  NextHide(): void;
  Hide(status: HLRAlgo_EdgeStatus, S: TopoDS_Shape, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean): any;
  InitShow(): void;
  MoreShow(): Standard_Boolean;
  NextShow(): void;
  Show(S: TopoDS_Shape, reg1: Standard_Boolean, regn: Standard_Boolean, outl: Standard_Boolean, intl: Standard_Boolean): any;
  OutLinedShape(S: TopoDS_Shape): TopoDS_Shape;
  Debug_1(): Standard_Boolean;
  Debug_2(theDebug: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class HLRBRep_PolyAlgo_1 extends HLRBRep_PolyAlgo {
    constructor();
  }

  export declare class HLRBRep_PolyAlgo_2 extends HLRBRep_PolyAlgo {
    constructor(A: Handle_HLRBRep_PolyAlgo);
  }

  export declare class HLRBRep_PolyAlgo_3 extends HLRBRep_PolyAlgo {
    constructor(S: TopoDS_Shape);
  }

export declare class Handle_HLRBRep_PolyAlgo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRBRep_PolyAlgo): void;
  get(): HLRBRep_PolyAlgo;
  delete(): void;
}

  export declare class Handle_HLRBRep_PolyAlgo_1 extends Handle_HLRBRep_PolyAlgo {
    constructor();
  }

  export declare class Handle_HLRBRep_PolyAlgo_2 extends Handle_HLRBRep_PolyAlgo {
    constructor(thePtr: HLRBRep_PolyAlgo);
  }

  export declare class Handle_HLRBRep_PolyAlgo_3 extends Handle_HLRBRep_PolyAlgo {
    constructor(theHandle: Handle_HLRBRep_PolyAlgo);
  }

  export declare class Handle_HLRBRep_PolyAlgo_4 extends Handle_HLRBRep_PolyAlgo {
    constructor(theHandle: Handle_HLRBRep_PolyAlgo);
  }

export declare class HLRBRep_TheExactInterCSurf {
  Perform(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Rsnld: math_FunctionSetRoot, u0: Quantity_AbsorbedDose, v0: Quantity_AbsorbedDose, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, w0: Quantity_AbsorbedDose, w1: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Point(): gp_Pnt;
  ParameterOnCurve(): Quantity_AbsorbedDose;
  ParameterOnSurface(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Function(): HLRBRep_TheCSFunctionOfInterCSurf;
  delete(): void;
}

  export declare class HLRBRep_TheExactInterCSurf_1 extends HLRBRep_TheExactInterCSurf {
    constructor(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, F: HLRBRep_TheCSFunctionOfInterCSurf, TolTangency: Quantity_AbsorbedDose, MarginCoef: Quantity_AbsorbedDose);
  }

  export declare class HLRBRep_TheExactInterCSurf_2 extends HLRBRep_TheExactInterCSurf {
    constructor(F: HLRBRep_TheCSFunctionOfInterCSurf, TolTangency: Quantity_AbsorbedDose);
  }

export declare class HLRBRep_MyImpParToolOfTheIntersectorOfTheIntConicCurveOfCInter extends math_FunctionWithDerivative {
  constructor(IT: IntCurve_IConicTool, PC: Standard_Address)
  Value(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(Param: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class HLRBRep_SurfaceTool {
  constructor();
  static FirstUParameter(S: Standard_Address): Quantity_AbsorbedDose;
  static FirstVParameter(S: Standard_Address): Quantity_AbsorbedDose;
  static LastUParameter(S: Standard_Address): Quantity_AbsorbedDose;
  static LastVParameter(S: Standard_Address): Quantity_AbsorbedDose;
  static NbUIntervals(S: Standard_Address, Sh: GeomAbs_Shape): Graphic3d_ZLayerId;
  static NbVIntervals(S: Standard_Address, Sh: GeomAbs_Shape): Graphic3d_ZLayerId;
  static UIntervals(S: Standard_Address, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static VIntervals(S: Standard_Address, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static UTrim(S: Standard_Address, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  static VTrim(S: Standard_Address, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  static IsUClosed(S: Standard_Address): Standard_Boolean;
  static IsVClosed(S: Standard_Address): Standard_Boolean;
  static IsUPeriodic(S: Standard_Address): Standard_Boolean;
  static UPeriod(S: Standard_Address): Quantity_AbsorbedDose;
  static IsVPeriodic(S: Standard_Address): Standard_Boolean;
  static VPeriod(S: Standard_Address): Quantity_AbsorbedDose;
  static Value(S: Standard_Address, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): gp_Pnt;
  static D0(S: Standard_Address, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(S: Standard_Address, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1u: gp_Vec, D1v: gp_Vec): void;
  static D2(S: Standard_Address, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  static D3(S: Standard_Address, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  static DN(S: Standard_Address, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static UResolution(S: Standard_Address, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static VResolution(S: Standard_Address, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(S: Standard_Address): GeomAbs_SurfaceType;
  static Plane(S: Standard_Address): gp_Pln;
  static Cylinder(S: Standard_Address): gp_Cylinder;
  static Cone(S: Standard_Address): gp_Cone;
  static Torus(S: Standard_Address): gp_Torus;
  static Sphere(S: Standard_Address): gp_Sphere;
  static Bezier(S: Standard_Address): Handle_Geom_BezierSurface;
  static BSpline(S: Standard_Address): Handle_Geom_BSplineSurface;
  static AxeOfRevolution(S: Standard_Address): gp_Ax1;
  static Direction(S: Standard_Address): gp_Dir;
  static BasisCurve(S: Standard_Address): Handle_Adaptor3d_HCurve;
  static BasisSurface(S: Standard_Address): Handle_Adaptor3d_HSurface;
  static OffsetValue(S: Standard_Address): Quantity_AbsorbedDose;
  static NbSamplesU_1(S: Standard_Address): Graphic3d_ZLayerId;
  static NbSamplesV_1(S: Standard_Address): Graphic3d_ZLayerId;
  static NbSamplesU_2(S: Standard_Address, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplesV_2(S: Standard_Address, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class HLRBRep_VertexList {
  constructor(T: HLRBRep_EdgeInterferenceTool, I: HLRAlgo_ListIteratorOfInterferenceList)
  IsPeriodic(): Standard_Boolean;
  More(): Standard_Boolean;
  Next(): void;
  Current(): HLRAlgo_Intersection;
  IsBoundary(): Standard_Boolean;
  IsInterference(): Standard_Boolean;
  Orientation(): TopAbs_Orientation;
  Transition(): TopAbs_Orientation;
  BoundaryTransition(): TopAbs_Orientation;
  delete(): void;
}

export declare class HLRBRep_TheQuadCurvExactInterCSurf {
  constructor(S: Standard_Address, C: gp_Lin)
  IsDone(): Standard_Boolean;
  NbRoots(): Graphic3d_ZLayerId;
  Root(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbIntervals(): Graphic3d_ZLayerId;
  Intervals(Index: Graphic3d_ZLayerId, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class XCAFPrs_DocumentIdIterator {
  constructor(thePath: XCAFDoc_PartId)
  More(): Standard_Boolean;
  Value(): XCAFDoc_PartId;
  Next(): void;
  delete(): void;
}

export declare class XCAFPrs_DataMapOfStyleShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: XCAFPrs_DataMapOfStyleShape): void;
  Assign(theOther: XCAFPrs_DataMapOfStyleShape): XCAFPrs_DataMapOfStyleShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: XCAFPrs_Style, theItem: TopoDS_Shape): Standard_Boolean;
  Bound(theKey: XCAFPrs_Style, theItem: TopoDS_Shape): TopoDS_Shape;
  IsBound(theKey: XCAFPrs_Style): Standard_Boolean;
  UnBind(theKey: XCAFPrs_Style): Standard_Boolean;
  Seek(theKey: XCAFPrs_Style): TopoDS_Shape;
  ChangeSeek(theKey: XCAFPrs_Style): TopoDS_Shape;
  ChangeFind(theKey: XCAFPrs_Style): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class XCAFPrs_DataMapOfStyleShape_1 extends XCAFPrs_DataMapOfStyleShape {
    constructor();
  }

  export declare class XCAFPrs_DataMapOfStyleShape_2 extends XCAFPrs_DataMapOfStyleShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class XCAFPrs_DataMapOfStyleShape_3 extends XCAFPrs_DataMapOfStyleShape {
    constructor(theOther: XCAFPrs_DataMapOfStyleShape);
  }

export declare class XCAFPrs_Texture extends Graphic3d_Texture2Dmanual {
  constructor(theImageSource: Image_Texture, theUnit: Graphic3d_TextureUnit)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetCompressedImage(theSupported: any): any;
  GetImage(theSupported: any): Handle_Image_PixMap;
  GetImageSource(): Image_Texture;
  delete(): void;
}

export declare class XCAFPrs_IndexedDataMapOfShapeStyle extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: XCAFPrs_IndexedDataMapOfShapeStyle): void;
  Assign(theOther: XCAFPrs_IndexedDataMapOfShapeStyle): XCAFPrs_IndexedDataMapOfShapeStyle;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: XCAFPrs_Style): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: XCAFPrs_Style): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): XCAFPrs_Style;
  ChangeFromIndex(theIndex: Standard_Integer): XCAFPrs_Style;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): XCAFPrs_Style;
  Seek(theKey1: TopoDS_Shape): XCAFPrs_Style;
  ChangeSeek(theKey1: TopoDS_Shape): XCAFPrs_Style;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class XCAFPrs_IndexedDataMapOfShapeStyle_1 extends XCAFPrs_IndexedDataMapOfShapeStyle {
    constructor();
  }

  export declare class XCAFPrs_IndexedDataMapOfShapeStyle_2 extends XCAFPrs_IndexedDataMapOfShapeStyle {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class XCAFPrs_IndexedDataMapOfShapeStyle_3 extends XCAFPrs_IndexedDataMapOfShapeStyle {
    constructor(theOther: XCAFPrs_IndexedDataMapOfShapeStyle);
  }

export declare class XCAFPrs_DocumentNode {
  constructor()
  static HashCode(theNode: XCAFPrs_DocumentNode, theN: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(theNode1: XCAFPrs_DocumentNode, theNode2: XCAFPrs_DocumentNode): Standard_Boolean;
  delete(): void;
}

export declare class XCAFPrs {
  constructor();
  static CollectStyleSettings(L: TDF_Label, loc: TopLoc_Location, settings: XCAFPrs_IndexedDataMapOfShapeStyle, theLayerColor: Quantity_ColorRGBA): void;
  static SetViewNameMode(viewNameMode: Standard_Boolean): void;
  static GetViewNameMode(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_XCAFPrs_AISObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFPrs_AISObject): void;
  get(): XCAFPrs_AISObject;
  delete(): void;
}

  export declare class Handle_XCAFPrs_AISObject_1 extends Handle_XCAFPrs_AISObject {
    constructor();
  }

  export declare class Handle_XCAFPrs_AISObject_2 extends Handle_XCAFPrs_AISObject {
    constructor(thePtr: XCAFPrs_AISObject);
  }

  export declare class Handle_XCAFPrs_AISObject_3 extends Handle_XCAFPrs_AISObject {
    constructor(theHandle: Handle_XCAFPrs_AISObject);
  }

  export declare class Handle_XCAFPrs_AISObject_4 extends Handle_XCAFPrs_AISObject {
    constructor(theHandle: Handle_XCAFPrs_AISObject);
  }

export declare class XCAFPrs_AISObject extends AIS_ColoredShape {
  constructor(theLabel: TDF_Label)
  GetLabel(): TDF_Label;
  SetLabel(theLabel: TDF_Label): void;
  DispatchStyles(theToSyncStyles: Standard_Boolean): void;
  SetMaterial(theMaterial: Graphic3d_MaterialAspect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XCAFPrs_DocumentExplorer {
  static DefineChildId(theLabel: TDF_Label, theParentId: XCAFDoc_PartId): XCAFDoc_PartId;
  static FindLabelFromPathId_1(theDocument: Handle_TDocStd_Document, theId: XCAFDoc_PartId, theParentLocation: TopLoc_Location, theLocation: TopLoc_Location): TDF_Label;
  static FindLabelFromPathId_2(theDocument: Handle_TDocStd_Document, theId: XCAFDoc_PartId, theLocation: TopLoc_Location): TDF_Label;
  static FindShapeFromPathId(theDocument: Handle_TDocStd_Document, theId: XCAFDoc_PartId): TopoDS_Shape;
  Init_1(theDocument: Handle_TDocStd_Document, theRoot: TDF_Label, theFlags: XCAFPrs_DocumentExplorerFlags, theDefStyle: XCAFPrs_Style): void;
  Init_2(theDocument: Handle_TDocStd_Document, theRoots: TDF_LabelSequence, theFlags: XCAFPrs_DocumentExplorerFlags, theDefStyle: XCAFPrs_Style): void;
  More(): Standard_Boolean;
  Current_1(): XCAFPrs_DocumentNode;
  ChangeCurrent(): XCAFPrs_DocumentNode;
  Current_2(theDepth: Graphic3d_ZLayerId): XCAFPrs_DocumentNode;
  CurrentDepth(): Graphic3d_ZLayerId;
  Next(): void;
  ColorTool(): Handle_XCAFDoc_ColorTool;
  VisMaterialTool(): Handle_XCAFDoc_VisMaterialTool;
  delete(): void;
}

  export declare class XCAFPrs_DocumentExplorer_1 extends XCAFPrs_DocumentExplorer {
    constructor();
  }

  export declare class XCAFPrs_DocumentExplorer_2 extends XCAFPrs_DocumentExplorer {
    constructor(theDocument: Handle_TDocStd_Document, theFlags: XCAFPrs_DocumentExplorerFlags, theDefStyle: XCAFPrs_Style);
  }

  export declare class XCAFPrs_DocumentExplorer_3 extends XCAFPrs_DocumentExplorer {
    constructor(theDocument: Handle_TDocStd_Document, theRoots: TDF_LabelSequence, theFlags: XCAFPrs_DocumentExplorerFlags, theDefStyle: XCAFPrs_Style);
  }

export declare class XCAFPrs_Driver extends TPrsStd_Driver {
  constructor();
  Update(L: TDF_Label, ais: Handle_AIS_InteractiveObject): Standard_Boolean;
  static GetID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFPrs_Driver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFPrs_Driver): void;
  get(): XCAFPrs_Driver;
  delete(): void;
}

  export declare class Handle_XCAFPrs_Driver_1 extends Handle_XCAFPrs_Driver {
    constructor();
  }

  export declare class Handle_XCAFPrs_Driver_2 extends Handle_XCAFPrs_Driver {
    constructor(thePtr: XCAFPrs_Driver);
  }

  export declare class Handle_XCAFPrs_Driver_3 extends Handle_XCAFPrs_Driver {
    constructor(theHandle: Handle_XCAFPrs_Driver);
  }

  export declare class Handle_XCAFPrs_Driver_4 extends Handle_XCAFPrs_Driver {
    constructor(theHandle: Handle_XCAFPrs_Driver);
  }

export declare class XCAFPrs_Style {
  constructor()
  IsEmpty(): Standard_Boolean;
  Material(): Handle_XCAFDoc_VisMaterial;
  SetMaterial(theMaterial: Handle_XCAFDoc_VisMaterial): void;
  IsSetColorSurf(): Standard_Boolean;
  GetColorSurf(): Quantity_Color;
  SetColorSurf_1(theColor: Quantity_Color): void;
  GetColorSurfRGBA(): Quantity_ColorRGBA;
  SetColorSurf_2(theColor: Quantity_ColorRGBA): void;
  UnSetColorSurf(): void;
  IsSetColorCurv(): Standard_Boolean;
  GetColorCurv(): Quantity_Color;
  SetColorCurv(col: Quantity_Color): void;
  UnSetColorCurv(): void;
  SetVisibility(theVisibility: Standard_Boolean): void;
  IsVisible(): Standard_Boolean;
  IsEqual_1(theOther: XCAFPrs_Style): Standard_Boolean;
  static HashCode(theStyle: XCAFPrs_Style, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual_2(theS1: XCAFPrs_Style, theS2: XCAFPrs_Style): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_XmlMDataXtd_PresentationDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataXtd_PresentationDriver): void;
  get(): XmlMDataXtd_PresentationDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataXtd_PresentationDriver_1 extends Handle_XmlMDataXtd_PresentationDriver {
    constructor();
  }

  export declare class Handle_XmlMDataXtd_PresentationDriver_2 extends Handle_XmlMDataXtd_PresentationDriver {
    constructor(thePtr: XmlMDataXtd_PresentationDriver);
  }

  export declare class Handle_XmlMDataXtd_PresentationDriver_3 extends Handle_XmlMDataXtd_PresentationDriver {
    constructor(theHandle: Handle_XmlMDataXtd_PresentationDriver);
  }

  export declare class Handle_XmlMDataXtd_PresentationDriver_4 extends Handle_XmlMDataXtd_PresentationDriver {
    constructor(theHandle: Handle_XmlMDataXtd_PresentationDriver);
  }

export declare class XmlMDataXtd_PresentationDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataXtd_TriangulationDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataXtd_TriangulationDriver): void;
  get(): XmlMDataXtd_TriangulationDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataXtd_TriangulationDriver_1 extends Handle_XmlMDataXtd_TriangulationDriver {
    constructor();
  }

  export declare class Handle_XmlMDataXtd_TriangulationDriver_2 extends Handle_XmlMDataXtd_TriangulationDriver {
    constructor(thePtr: XmlMDataXtd_TriangulationDriver);
  }

  export declare class Handle_XmlMDataXtd_TriangulationDriver_3 extends Handle_XmlMDataXtd_TriangulationDriver {
    constructor(theHandle: Handle_XmlMDataXtd_TriangulationDriver);
  }

  export declare class Handle_XmlMDataXtd_TriangulationDriver_4 extends Handle_XmlMDataXtd_TriangulationDriver {
    constructor(theHandle: Handle_XmlMDataXtd_TriangulationDriver);
  }

export declare class XmlMDataXtd_TriangulationDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataXtd_PatternStdDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataXtd_PatternStdDriver): void;
  get(): XmlMDataXtd_PatternStdDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataXtd_PatternStdDriver_1 extends Handle_XmlMDataXtd_PatternStdDriver {
    constructor();
  }

  export declare class Handle_XmlMDataXtd_PatternStdDriver_2 extends Handle_XmlMDataXtd_PatternStdDriver {
    constructor(thePtr: XmlMDataXtd_PatternStdDriver);
  }

  export declare class Handle_XmlMDataXtd_PatternStdDriver_3 extends Handle_XmlMDataXtd_PatternStdDriver {
    constructor(theHandle: Handle_XmlMDataXtd_PatternStdDriver);
  }

  export declare class Handle_XmlMDataXtd_PatternStdDriver_4 extends Handle_XmlMDataXtd_PatternStdDriver {
    constructor(theHandle: Handle_XmlMDataXtd_PatternStdDriver);
  }

export declare class XmlMDataXtd_PatternStdDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDataXtd_ConstraintDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataXtd_ConstraintDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataXtd_ConstraintDriver): void;
  get(): XmlMDataXtd_ConstraintDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataXtd_ConstraintDriver_1 extends Handle_XmlMDataXtd_ConstraintDriver {
    constructor();
  }

  export declare class Handle_XmlMDataXtd_ConstraintDriver_2 extends Handle_XmlMDataXtd_ConstraintDriver {
    constructor(thePtr: XmlMDataXtd_ConstraintDriver);
  }

  export declare class Handle_XmlMDataXtd_ConstraintDriver_3 extends Handle_XmlMDataXtd_ConstraintDriver {
    constructor(theHandle: Handle_XmlMDataXtd_ConstraintDriver);
  }

  export declare class Handle_XmlMDataXtd_ConstraintDriver_4 extends Handle_XmlMDataXtd_ConstraintDriver {
    constructor(theHandle: Handle_XmlMDataXtd_ConstraintDriver);
  }

export declare class XmlMDataXtd_PositionDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDataXtd_PositionDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataXtd_PositionDriver): void;
  get(): XmlMDataXtd_PositionDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataXtd_PositionDriver_1 extends Handle_XmlMDataXtd_PositionDriver {
    constructor();
  }

  export declare class Handle_XmlMDataXtd_PositionDriver_2 extends Handle_XmlMDataXtd_PositionDriver {
    constructor(thePtr: XmlMDataXtd_PositionDriver);
  }

  export declare class Handle_XmlMDataXtd_PositionDriver_3 extends Handle_XmlMDataXtd_PositionDriver {
    constructor(theHandle: Handle_XmlMDataXtd_PositionDriver);
  }

  export declare class Handle_XmlMDataXtd_PositionDriver_4 extends Handle_XmlMDataXtd_PositionDriver {
    constructor(theHandle: Handle_XmlMDataXtd_PositionDriver);
  }

export declare class XmlMDataXtd {
  constructor();
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, anMsgDrv: Handle_Message_Messenger): void;
  static SetDocumentVersion(DocVersion: Graphic3d_ZLayerId): void;
  static DocumentVersion(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_XmlMDataXtd_GeometryDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDataXtd_GeometryDriver): void;
  get(): XmlMDataXtd_GeometryDriver;
  delete(): void;
}

  export declare class Handle_XmlMDataXtd_GeometryDriver_1 extends Handle_XmlMDataXtd_GeometryDriver {
    constructor();
  }

  export declare class Handle_XmlMDataXtd_GeometryDriver_2 extends Handle_XmlMDataXtd_GeometryDriver {
    constructor(thePtr: XmlMDataXtd_GeometryDriver);
  }

  export declare class Handle_XmlMDataXtd_GeometryDriver_3 extends Handle_XmlMDataXtd_GeometryDriver {
    constructor(theHandle: Handle_XmlMDataXtd_GeometryDriver);
  }

  export declare class Handle_XmlMDataXtd_GeometryDriver_4 extends Handle_XmlMDataXtd_GeometryDriver {
    constructor(theHandle: Handle_XmlMDataXtd_GeometryDriver);
  }

export declare class XmlMDataXtd_GeometryDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDocStd_Application extends CDF_Application {
  constructor()
  IsDriverLoaded(): Standard_Boolean;
  Resources(): Handle_Resource_Manager;
  ResourcesName(): Standard_CString;
  DefineFormat(theFormat: XCAFDoc_PartId, theDescription: XCAFDoc_PartId, theExtension: XCAFDoc_PartId, theReader: Handle_PCDM_RetrievalDriver, theWriter: Handle_PCDM_StorageDriver): void;
  ReadingFormats(theFormats: TColStd_SequenceOfAsciiString): void;
  WritingFormats(theFormats: TColStd_SequenceOfAsciiString): void;
  NbDocuments(): Graphic3d_ZLayerId;
  GetDocument(index: Graphic3d_ZLayerId, aDoc: Handle_TDocStd_Document): void;
  NewDocument(format: TCollection_ExtendedString, aDoc: Handle_TDocStd_Document): void;
  InitDocument(aDoc: Handle_TDocStd_Document): void;
  Close(aDoc: Handle_TDocStd_Document): void;
  IsInSession(path: TCollection_ExtendedString): Graphic3d_ZLayerId;
  Open_1(path: TCollection_ExtendedString, aDoc: Handle_TDocStd_Document, theRange: Message_ProgressRange): PCDM_ReaderStatus;
  Open_2(theIStream: Standard_IStream, theDoc: Handle_TDocStd_Document, theRange: Message_ProgressRange): PCDM_ReaderStatus;
  SaveAs_1(aDoc: Handle_TDocStd_Document, path: TCollection_ExtendedString, theRange: Message_ProgressRange): PCDM_StoreStatus;
  SaveAs_2(theDoc: Handle_TDocStd_Document, theOStream: Standard_OStream, theRange: Message_ProgressRange): PCDM_StoreStatus;
  Save_1(aDoc: Handle_TDocStd_Document, theRange: Message_ProgressRange): PCDM_StoreStatus;
  SaveAs_3(aDoc: Handle_TDocStd_Document, path: TCollection_ExtendedString, theStatusMessage: TCollection_ExtendedString, theRange: Message_ProgressRange): PCDM_StoreStatus;
  SaveAs_4(theDoc: Handle_TDocStd_Document, theOStream: Standard_OStream, theStatusMessage: TCollection_ExtendedString, theRange: Message_ProgressRange): PCDM_StoreStatus;
  Save_2(aDoc: Handle_TDocStd_Document, theStatusMessage: TCollection_ExtendedString, theRange: Message_ProgressRange): PCDM_StoreStatus;
  OnOpenTransaction(theDoc: Handle_TDocStd_Document): void;
  OnCommitTransaction(theDoc: Handle_TDocStd_Document): void;
  OnAbortTransaction(theDoc: Handle_TDocStd_Document): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_Application): void;
  get(): TDocStd_Application;
  delete(): void;
}

  export declare class Handle_TDocStd_Application_1 extends Handle_TDocStd_Application {
    constructor();
  }

  export declare class Handle_TDocStd_Application_2 extends Handle_TDocStd_Application {
    constructor(thePtr: TDocStd_Application);
  }

  export declare class Handle_TDocStd_Application_3 extends Handle_TDocStd_Application {
    constructor(theHandle: Handle_TDocStd_Application);
  }

  export declare class Handle_TDocStd_Application_4 extends Handle_TDocStd_Application {
    constructor(theHandle: Handle_TDocStd_Application);
  }

export declare class TDocStd_XLink extends TDF_Attribute {
  constructor()
  static Set(atLabel: TDF_Label): Handle_TDocStd_XLink;
  Update(): Handle_TDF_Reference;
  ID(): Standard_GUID;
  static GetID(): Standard_GUID;
  DocumentEntry_1(aDocEntry: XCAFDoc_PartId): void;
  DocumentEntry_2(): XCAFDoc_PartId;
  LabelEntry_1(aLabel: TDF_Label): void;
  LabelEntry_2(aLabEntry: XCAFDoc_PartId): void;
  LabelEntry_3(): XCAFDoc_PartId;
  AfterAddition(): void;
  BeforeRemoval(): void;
  BeforeUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  BackupCopy(): Handle_TDF_Attribute;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocationTable: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_XLink {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_XLink): void;
  get(): TDocStd_XLink;
  delete(): void;
}

  export declare class Handle_TDocStd_XLink_1 extends Handle_TDocStd_XLink {
    constructor();
  }

  export declare class Handle_TDocStd_XLink_2 extends Handle_TDocStd_XLink {
    constructor(thePtr: TDocStd_XLink);
  }

  export declare class Handle_TDocStd_XLink_3 extends Handle_TDocStd_XLink {
    constructor(theHandle: Handle_TDocStd_XLink);
  }

  export declare class Handle_TDocStd_XLink_4 extends Handle_TDocStd_XLink {
    constructor(theHandle: Handle_TDocStd_XLink);
  }

export declare class TDocStd {
  constructor();
  static IDList(anIDList: TDF_IDList): void;
  delete(): void;
}

export declare class TDocStd_ApplicationDelta extends Standard_Transient {
  constructor()
  GetDocuments(): TDocStd_SequenceOfDocument;
  GetName(): TCollection_ExtendedString;
  SetName(theName: TCollection_ExtendedString): void;
  Dump(anOS: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_ApplicationDelta {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_ApplicationDelta): void;
  get(): TDocStd_ApplicationDelta;
  delete(): void;
}

  export declare class Handle_TDocStd_ApplicationDelta_1 extends Handle_TDocStd_ApplicationDelta {
    constructor();
  }

  export declare class Handle_TDocStd_ApplicationDelta_2 extends Handle_TDocStd_ApplicationDelta {
    constructor(thePtr: TDocStd_ApplicationDelta);
  }

  export declare class Handle_TDocStd_ApplicationDelta_3 extends Handle_TDocStd_ApplicationDelta {
    constructor(theHandle: Handle_TDocStd_ApplicationDelta);
  }

  export declare class Handle_TDocStd_ApplicationDelta_4 extends Handle_TDocStd_ApplicationDelta {
    constructor(theHandle: Handle_TDocStd_ApplicationDelta);
  }

export declare class TDocStd_XLinkIterator {
  Initialize(D: Handle_TDocStd_Document): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): TDocStd_XLinkPtr;
  delete(): void;
}

  export declare class TDocStd_XLinkIterator_1 extends TDocStd_XLinkIterator {
    constructor();
  }

  export declare class TDocStd_XLinkIterator_2 extends TDocStd_XLinkIterator {
    constructor(D: Handle_TDocStd_Document);
  }

export declare class Handle_TDocStd_MultiTransactionManager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_MultiTransactionManager): void;
  get(): TDocStd_MultiTransactionManager;
  delete(): void;
}

  export declare class Handle_TDocStd_MultiTransactionManager_1 extends Handle_TDocStd_MultiTransactionManager {
    constructor();
  }

  export declare class Handle_TDocStd_MultiTransactionManager_2 extends Handle_TDocStd_MultiTransactionManager {
    constructor(thePtr: TDocStd_MultiTransactionManager);
  }

  export declare class Handle_TDocStd_MultiTransactionManager_3 extends Handle_TDocStd_MultiTransactionManager {
    constructor(theHandle: Handle_TDocStd_MultiTransactionManager);
  }

  export declare class Handle_TDocStd_MultiTransactionManager_4 extends Handle_TDocStd_MultiTransactionManager {
    constructor(theHandle: Handle_TDocStd_MultiTransactionManager);
  }

export declare class TDocStd_MultiTransactionManager extends Standard_Transient {
  constructor()
  SetUndoLimit(theLimit: Graphic3d_ZLayerId): void;
  GetUndoLimit(): Graphic3d_ZLayerId;
  Undo(): void;
  Redo(): void;
  GetAvailableUndos(): TDocStd_SequenceOfApplicationDelta;
  GetAvailableRedos(): TDocStd_SequenceOfApplicationDelta;
  OpenCommand(): void;
  AbortCommand(): void;
  CommitCommand_1(): Standard_Boolean;
  CommitCommand_2(theName: TCollection_ExtendedString): Standard_Boolean;
  HasOpenCommand(): Standard_Boolean;
  RemoveLastUndo(): void;
  DumpTransaction(theOS: Standard_OStream): void;
  AddDocument(theDoc: Handle_TDocStd_Document): void;
  RemoveDocument(theDoc: Handle_TDocStd_Document): void;
  Documents(): TDocStd_SequenceOfDocument;
  SetNestedTransactionMode(isAllowed: Standard_Boolean): void;
  IsNestedTransactionMode(): Standard_Boolean;
  SetModificationMode(theTransactionOnly: Standard_Boolean): void;
  ModificationMode(): Standard_Boolean;
  ClearUndos(): void;
  ClearRedos(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDocStd_Document extends CDM_Document {
  constructor(astorageformat: TCollection_ExtendedString)
  static Get(L: TDF_Label): Handle_TDocStd_Document;
  IsSaved(): Standard_Boolean;
  IsChanged(): Standard_Boolean;
  SetSaved(): void;
  SetSavedTime(theTime: Graphic3d_ZLayerId): void;
  GetSavedTime(): Graphic3d_ZLayerId;
  GetName(): TCollection_ExtendedString;
  GetPath(): TCollection_ExtendedString;
  SetData(data: Handle_TDF_Data): void;
  GetData(): Handle_TDF_Data;
  Main(): TDF_Label;
  IsEmpty(): Standard_Boolean;
  IsValid(): Standard_Boolean;
  SetModified(L: TDF_Label): void;
  PurgeModified(): void;
  GetModified(): TDF_LabelMap;
  NewCommand(): void;
  HasOpenCommand(): Standard_Boolean;
  OpenCommand(): void;
  CommitCommand(): Standard_Boolean;
  AbortCommand(): void;
  GetUndoLimit(): Graphic3d_ZLayerId;
  SetUndoLimit(L: Graphic3d_ZLayerId): void;
  ClearUndos(): void;
  ClearRedos(): void;
  GetAvailableUndos(): Graphic3d_ZLayerId;
  Undo(): Standard_Boolean;
  GetAvailableRedos(): Graphic3d_ZLayerId;
  Redo(): Standard_Boolean;
  GetUndos(): TDF_DeltaList;
  GetRedos(): TDF_DeltaList;
  RemoveFirstUndo(): void;
  InitDeltaCompaction(): Standard_Boolean;
  PerformDeltaCompaction(): Standard_Boolean;
  UpdateReferences(aDocEntry: XCAFDoc_PartId): void;
  Recompute(): void;
  Update(aToDocument: Handle_CDM_Document, aReferenceIdentifier: Graphic3d_ZLayerId, aModifContext: Standard_Address): void;
  StorageFormat(): TCollection_ExtendedString;
  SetEmptyLabelsSavingMode(isAllowed: Standard_Boolean): void;
  EmptyLabelsSavingMode(): Standard_Boolean;
  ChangeStorageFormat(newStorageFormat: TCollection_ExtendedString): void;
  SetNestedTransactionMode(isAllowed: Standard_Boolean): void;
  IsNestedTransactionMode(): Standard_Boolean;
  SetModificationMode(theTransactionOnly: Standard_Boolean): void;
  ModificationMode(): Standard_Boolean;
  BeforeClose(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_Document {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_Document): void;
  get(): TDocStd_Document;
  delete(): void;
}

  export declare class Handle_TDocStd_Document_1 extends Handle_TDocStd_Document {
    constructor();
  }

  export declare class Handle_TDocStd_Document_2 extends Handle_TDocStd_Document {
    constructor(thePtr: TDocStd_Document);
  }

  export declare class Handle_TDocStd_Document_3 extends Handle_TDocStd_Document {
    constructor(theHandle: Handle_TDocStd_Document);
  }

  export declare class Handle_TDocStd_Document_4 extends Handle_TDocStd_Document {
    constructor(theHandle: Handle_TDocStd_Document);
  }

export declare class TDocStd_Context {
  constructor()
  SetModifiedReferences(Mod: Standard_Boolean): void;
  ModifiedReferences(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_TDocStd_Owner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_Owner): void;
  get(): TDocStd_Owner;
  delete(): void;
}

  export declare class Handle_TDocStd_Owner_1 extends Handle_TDocStd_Owner {
    constructor();
  }

  export declare class Handle_TDocStd_Owner_2 extends Handle_TDocStd_Owner {
    constructor(thePtr: TDocStd_Owner);
  }

  export declare class Handle_TDocStd_Owner_3 extends Handle_TDocStd_Owner {
    constructor(theHandle: Handle_TDocStd_Owner);
  }

  export declare class Handle_TDocStd_Owner_4 extends Handle_TDocStd_Owner {
    constructor(theHandle: Handle_TDocStd_Owner);
  }

export declare class TDocStd_Owner extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static SetDocument_1(indata: Handle_TDF_Data, doc: Handle_TDocStd_Document): void;
  static SetDocument_2(indata: Handle_TDF_Data, doc: TDocStd_Document): void;
  static GetDocument_1(ofdata: Handle_TDF_Data): Handle_TDocStd_Document;
  SetDocument_3(document: Handle_TDocStd_Document): void;
  SetDocument_4(document: TDocStd_Document): void;
  GetDocument_2(): Handle_TDocStd_Document;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDocStd_LabelIDMapDataMap extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDocStd_LabelIDMapDataMap): void;
  Assign(theOther: TDocStd_LabelIDMapDataMap): TDocStd_LabelIDMapDataMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TDF_Label, theItem: TDF_IDMap): Standard_Boolean;
  Bound(theKey: TDF_Label, theItem: TDF_IDMap): TDF_IDMap;
  IsBound(theKey: TDF_Label): Standard_Boolean;
  UnBind(theKey: TDF_Label): Standard_Boolean;
  Seek(theKey: TDF_Label): TDF_IDMap;
  ChangeSeek(theKey: TDF_Label): TDF_IDMap;
  ChangeFind(theKey: TDF_Label): TDF_IDMap;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDocStd_LabelIDMapDataMap_1 extends TDocStd_LabelIDMapDataMap {
    constructor();
  }

  export declare class TDocStd_LabelIDMapDataMap_2 extends TDocStd_LabelIDMapDataMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDocStd_LabelIDMapDataMap_3 extends TDocStd_LabelIDMapDataMap {
    constructor(theOther: TDocStd_LabelIDMapDataMap);
  }

export declare class TDocStd_XLinkTool {
  constructor()
  CopyWithLink(intarget: TDF_Label, fromsource: TDF_Label): void;
  UpdateLink(L: TDF_Label): void;
  Copy(intarget: TDF_Label, fromsource: TDF_Label): void;
  IsDone(): Standard_Boolean;
  DataSet(): Handle_TDF_DataSet;
  RelocationTable(): Handle_TDF_RelocationTable;
  delete(): void;
}

export declare class TDocStd_CompoundDelta extends TDF_Delta {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_CompoundDelta {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_CompoundDelta): void;
  get(): TDocStd_CompoundDelta;
  delete(): void;
}

  export declare class Handle_TDocStd_CompoundDelta_1 extends Handle_TDocStd_CompoundDelta {
    constructor();
  }

  export declare class Handle_TDocStd_CompoundDelta_2 extends Handle_TDocStd_CompoundDelta {
    constructor(thePtr: TDocStd_CompoundDelta);
  }

  export declare class Handle_TDocStd_CompoundDelta_3 extends Handle_TDocStd_CompoundDelta {
    constructor(theHandle: Handle_TDocStd_CompoundDelta);
  }

  export declare class Handle_TDocStd_CompoundDelta_4 extends Handle_TDocStd_CompoundDelta {
    constructor(theHandle: Handle_TDocStd_CompoundDelta);
  }

export declare class TDocStd_XLinkRoot extends TDF_Attribute {
  static GetID(): Standard_GUID;
  static Set(aDF: Handle_TDF_Data): Handle_TDocStd_XLinkRoot;
  static Insert(anXLinkPtr: TDocStd_XLinkPtr): void;
  static Remove(anXLinkPtr: TDocStd_XLinkPtr): void;
  ID(): Standard_GUID;
  BackupCopy(): Handle_TDF_Attribute;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocationTable: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_XLinkRoot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_XLinkRoot): void;
  get(): TDocStd_XLinkRoot;
  delete(): void;
}

  export declare class Handle_TDocStd_XLinkRoot_1 extends Handle_TDocStd_XLinkRoot {
    constructor();
  }

  export declare class Handle_TDocStd_XLinkRoot_2 extends Handle_TDocStd_XLinkRoot {
    constructor(thePtr: TDocStd_XLinkRoot);
  }

  export declare class Handle_TDocStd_XLinkRoot_3 extends Handle_TDocStd_XLinkRoot {
    constructor(theHandle: Handle_TDocStd_XLinkRoot);
  }

  export declare class Handle_TDocStd_XLinkRoot_4 extends Handle_TDocStd_XLinkRoot {
    constructor(theHandle: Handle_TDocStd_XLinkRoot);
  }

export declare class TDocStd_PathParser {
  constructor(path: TCollection_ExtendedString)
  Parse(): void;
  Trek(): TCollection_ExtendedString;
  Name(): TCollection_ExtendedString;
  Extension(): TCollection_ExtendedString;
  Path(): TCollection_ExtendedString;
  Length(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TDocStd_Modified extends TDF_Attribute {
  constructor()
  static IsEmpty_1(access: TDF_Label): Standard_Boolean;
  static Add(alabel: TDF_Label): Standard_Boolean;
  static Remove(alabel: TDF_Label): Standard_Boolean;
  static Contains(alabel: TDF_Label): Standard_Boolean;
  static Get_1(access: TDF_Label): TDF_LabelMap;
  static Clear_1(access: TDF_Label): void;
  static GetID(): Standard_GUID;
  IsEmpty_2(): Standard_Boolean;
  Clear_2(): void;
  AddLabel(L: TDF_Label): Standard_Boolean;
  RemoveLabel(L: TDF_Label): Standard_Boolean;
  Get_2(): TDF_LabelMap;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDocStd_Modified {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDocStd_Modified): void;
  get(): TDocStd_Modified;
  delete(): void;
}

  export declare class Handle_TDocStd_Modified_1 extends Handle_TDocStd_Modified {
    constructor();
  }

  export declare class Handle_TDocStd_Modified_2 extends Handle_TDocStd_Modified {
    constructor(thePtr: TDocStd_Modified);
  }

  export declare class Handle_TDocStd_Modified_3 extends Handle_TDocStd_Modified {
    constructor(theHandle: Handle_TDocStd_Modified);
  }

  export declare class Handle_TDocStd_Modified_4 extends Handle_TDocStd_Modified {
    constructor(theHandle: Handle_TDocStd_Modified);
  }

export declare class SelectBasics_PickResult {
  static Min(thePickResult1: SelectBasics_PickResult, thePickResult2: SelectBasics_PickResult): SelectBasics_PickResult;
  IsValid(): Standard_Boolean;
  Invalidate(): void;
  Depth(): Quantity_AbsorbedDose;
  SetDepth(theDepth: Quantity_AbsorbedDose): void;
  HasPickedPoint(): Standard_Boolean;
  PickedPoint(): gp_Pnt;
  SetPickedPoint(theObjPickedPnt: gp_Pnt): void;
  DistToGeomCenter(): Quantity_AbsorbedDose;
  SetDistToGeomCenter(theDistToCenter: Quantity_AbsorbedDose): void;
  SurfaceNormal(): any;
  SetSurfaceNormal_1(theNormal: NCollection_Vec3<float>): void;
  SetSurfaceNormal_2(theNormal: gp_Vec): void;
  delete(): void;
}

  export declare class SelectBasics_PickResult_1 extends SelectBasics_PickResult {
    constructor();
  }

  export declare class SelectBasics_PickResult_2 extends SelectBasics_PickResult {
    constructor(theDepth: Quantity_AbsorbedDose, theDistToCenter: Quantity_AbsorbedDose, theObjPickedPnt: gp_Pnt);
  }

export declare class SelectBasics_SelectingVolumeManager {
  GetActiveSelectionType(): Graphic3d_ZLayerId;
  Overlaps_1(theBoxMin: Graphic3d_Vec3d, theBoxMax: Graphic3d_Vec3d, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_2(theBoxMin: Graphic3d_Vec3d, theBoxMax: Graphic3d_Vec3d, theInside: Standard_Boolean): Standard_Boolean;
  Overlaps_3(thePnt: gp_Pnt, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_4(thePnt: gp_Pnt): Standard_Boolean;
  Overlaps_5(theArrayOfPts: Handle_TColgp_HArray1OfPnt, theSensType: Graphic3d_ZLayerId, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_6(theArrayOfPts: TColgp_Array1OfPnt, theSensType: Graphic3d_ZLayerId, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_7(thePt1: gp_Pnt, thePt2: gp_Pnt, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  Overlaps_8(thePt1: gp_Pnt, thePt2: gp_Pnt, thePt3: gp_Pnt, theSensType: Graphic3d_ZLayerId, thePickResult: SelectBasics_PickResult): Standard_Boolean;
  DistToGeometryCenter(theCOG: gp_Pnt): Quantity_AbsorbedDose;
  DetectedPoint(theDepth: Quantity_AbsorbedDose): gp_Pnt;
  IsOverlapAllowed(): Standard_Boolean;
  GetNearPickedPnt(): gp_Pnt;
  GetFarPickedPnt(): gp_Pnt;
  GetMousePosition(): gp_Pnt2d;
  GetPlanes(thePlaneEquations: NCollection_Vector<NCollection_Vec4<Standard_Real>>): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class SelectBasics {
  constructor();
  static MaxOwnerPriority(): Graphic3d_ZLayerId;
  static MinOwnerPriority(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class StepAP209_Construct extends STEPConstruct_Tool {
  Init(WS: Handle_XSControl_WorkSession): Standard_Boolean;
  IsDesing(PD: Handle_StepBasic_ProductDefinitionFormation): Standard_Boolean;
  IsAnalys(PD: Handle_StepBasic_ProductDefinitionFormation): Standard_Boolean;
  FeaModel_1(Prod: Handle_StepBasic_Product): Handle_StepFEA_FeaModel;
  FeaModel_2(PDF: Handle_StepBasic_ProductDefinitionFormation): Handle_StepFEA_FeaModel;
  GetFeaAxis2Placement3d(theFeaModel: Handle_StepFEA_FeaModel): Handle_StepFEA_FeaAxis2Placement3d;
  IdealShape_1(Prod: Handle_StepBasic_Product): Handle_StepShape_ShapeRepresentation;
  IdealShape_2(PDF: Handle_StepBasic_ProductDefinitionFormation): Handle_StepShape_ShapeRepresentation;
  NominShape_1(Prod: Handle_StepBasic_Product): Handle_StepShape_ShapeRepresentation;
  NominShape_2(PDF: Handle_StepBasic_ProductDefinitionFormation): Handle_StepShape_ShapeRepresentation;
  GetElementMaterial(): Handle_StepElement_HSequenceOfElementMaterial;
  GetElemGeomRelat(): Handle_StepFEA_HSequenceOfElementGeometricRelationship;
  GetElements1D(theFeaModel: Handle_StepFEA_FeaModel): Handle_StepFEA_HSequenceOfElementRepresentation;
  GetElements2D(theFEAModel: Handle_StepFEA_FeaModel): Handle_StepFEA_HSequenceOfElementRepresentation;
  GetElements3D(theFEAModel: Handle_StepFEA_FeaModel): Handle_StepFEA_HSequenceOfElementRepresentation;
  GetCurElemSection(ElemRepr: Handle_StepFEA_Curve3dElementRepresentation): Handle_StepElement_HSequenceOfCurveElementSectionDefinition;
  GetShReprForElem(ElemRepr: Handle_StepFEA_ElementRepresentation): Handle_StepShape_ShapeRepresentation;
  CreateAnalysStructure(Prod: Handle_StepBasic_Product): Standard_Boolean;
  CreateFeaStructure(Prod: Handle_StepBasic_Product): Standard_Boolean;
  ReplaceCcDesingToApplied(): Standard_Boolean;
  CreateAddingEntities(AnaPD: Handle_StepBasic_ProductDefinition): Standard_Boolean;
  CreateAP203Structure(): Handle_StepData_StepModel;
  CreateAdding203Entities(PD: Handle_StepBasic_ProductDefinition, aModel: Handle_StepData_StepModel): Standard_Boolean;
  FeaModel_3(PDS: Handle_StepRepr_ProductDefinitionShape): Handle_StepFEA_FeaModel;
  FeaModel_4(PD: Handle_StepBasic_ProductDefinition): Handle_StepFEA_FeaModel;
  IdealShape_3(PD: Handle_StepBasic_ProductDefinition): Handle_StepShape_ShapeRepresentation;
  IdealShape_4(PDS: Handle_StepRepr_ProductDefinitionShape): Handle_StepShape_ShapeRepresentation;
  delete(): void;
}

  export declare class StepAP209_Construct_1 extends StepAP209_Construct {
    constructor();
  }

  export declare class StepAP209_Construct_2 extends StepAP209_Construct {
    constructor(WS: Handle_XSControl_WorkSession);
  }

export declare class Geom2dToIGES_Geom2dCurve extends Geom2dToIGES_Geom2dEntity {
  Transfer2dCurve(start: Handle_Geom2d_Curve, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  delete(): void;
}

  export declare class Geom2dToIGES_Geom2dCurve_1 extends Geom2dToIGES_Geom2dCurve {
    constructor();
  }

  export declare class Geom2dToIGES_Geom2dCurve_2 extends Geom2dToIGES_Geom2dCurve {
    constructor(G2dE: Geom2dToIGES_Geom2dEntity);
  }

export declare class Geom2dToIGES_Geom2dPoint extends Geom2dToIGES_Geom2dEntity {
  Transfer2dPoint_1(start: Handle_Geom2d_Point): Handle_IGESGeom_Point;
  Transfer2dPoint_2(start: Handle_Geom2d_CartesianPoint): Handle_IGESGeom_Point;
  delete(): void;
}

  export declare class Geom2dToIGES_Geom2dPoint_1 extends Geom2dToIGES_Geom2dPoint {
    constructor();
  }

  export declare class Geom2dToIGES_Geom2dPoint_2 extends Geom2dToIGES_Geom2dPoint {
    constructor(G2dE: Geom2dToIGES_Geom2dEntity);
  }

export declare class Geom2dToIGES_Geom2dVector extends Geom2dToIGES_Geom2dEntity {
  Transfer2dVector_1(start: Handle_Geom2d_Vector): Handle_IGESGeom_Direction;
  Transfer2dVector_2(start: Handle_Geom2d_VectorWithMagnitude): Handle_IGESGeom_Direction;
  Transfer2dVector_3(start: Handle_Geom2d_Direction): Handle_IGESGeom_Direction;
  delete(): void;
}

  export declare class Geom2dToIGES_Geom2dVector_1 extends Geom2dToIGES_Geom2dVector {
    constructor();
  }

  export declare class Geom2dToIGES_Geom2dVector_2 extends Geom2dToIGES_Geom2dVector {
    constructor(G2dE: Geom2dToIGES_Geom2dEntity);
  }

export declare class Geom2dToIGES_Geom2dEntity {
  SetModel(model: Handle_IGESData_IGESModel): void;
  GetModel(): Handle_IGESData_IGESModel;
  SetUnit(unit: Quantity_AbsorbedDose): void;
  GetUnit(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Geom2dToIGES_Geom2dEntity_1 extends Geom2dToIGES_Geom2dEntity {
    constructor();
  }

  export declare class Geom2dToIGES_Geom2dEntity_2 extends Geom2dToIGES_Geom2dEntity {
    constructor(GE: Geom2dToIGES_Geom2dEntity);
  }

export declare class BRepClass3d_Intersector3d {
  constructor()
  Perform(L: gp_Lin, Prm: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, F: TopoDS_Face): void;
  IsDone(): Standard_Boolean;
  HasAPoint(): Standard_Boolean;
  UParameter(): Quantity_AbsorbedDose;
  VParameter(): Quantity_AbsorbedDose;
  WParameter(): Quantity_AbsorbedDose;
  Pnt(): gp_Pnt;
  Transition(): IntCurveSurface_TransitionOnCurve;
  State(): TopAbs_State;
  Face(): TopoDS_Face;
  delete(): void;
}

export declare class BRepClass3d_SolidClassifier extends BRepClass3d_SClassifier {
  Load(S: TopoDS_Shape): void;
  Perform(P: gp_Pnt, Tol: Quantity_AbsorbedDose): void;
  PerformInfinitePoint(Tol: Quantity_AbsorbedDose): void;
  Destroy(): void;
  delete(): void;
}

  export declare class BRepClass3d_SolidClassifier_1 extends BRepClass3d_SolidClassifier {
    constructor();
  }

  export declare class BRepClass3d_SolidClassifier_2 extends BRepClass3d_SolidClassifier {
    constructor(S: TopoDS_Shape);
  }

  export declare class BRepClass3d_SolidClassifier_3 extends BRepClass3d_SolidClassifier {
    constructor(S: TopoDS_Shape, P: gp_Pnt, Tol: Quantity_AbsorbedDose);
  }

export declare class BRepClass3d_SolidPassiveClassifier {
  constructor()
  Reset(L: gp_Lin, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Compare(F: TopoDS_Face, Or: TopAbs_Orientation): void;
  Parameter(): Quantity_AbsorbedDose;
  HasIntersection(): Standard_Boolean;
  Intersector(): BRepClass3d_Intersector3d;
  State(): TopAbs_State;
  delete(): void;
}

export declare class BRepClass3d_MapOfInter extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepClass3d_MapOfInter): void;
  Assign(theOther: BRepClass3d_MapOfInter): BRepClass3d_MapOfInter;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Standard_Address): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Standard_Address): Standard_Address;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Standard_Address;
  ChangeSeek(theKey: TopoDS_Shape): Standard_Address;
  ChangeFind(theKey: TopoDS_Shape): Standard_Address;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepClass3d_MapOfInter_1 extends BRepClass3d_MapOfInter {
    constructor();
  }

  export declare class BRepClass3d_MapOfInter_2 extends BRepClass3d_MapOfInter {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepClass3d_MapOfInter_3 extends BRepClass3d_MapOfInter {
    constructor(theOther: BRepClass3d_MapOfInter);
  }

export declare class BRepClass3d_BndBoxTreeSelectorPoint {
  constructor(theMapOfShape: TopTools_IndexedMapOfShape)
  Reject(theBox: Bnd_Box): Standard_Boolean;
  Accept(theObj: Graphic3d_ZLayerId): Standard_Boolean;
  SetCurrentPoint(theP: gp_Pnt): void;
  delete(): void;
}

export declare class BRepClass3d_BndBoxTreeSelectorLine {
  constructor(theMapOfShape: TopTools_IndexedMapOfShape)
  Reject(theBox: Bnd_Box): Standard_Boolean;
  Accept(theObj: Graphic3d_ZLayerId): Standard_Boolean;
  SetCurrentLine(theL: gp_Lin, theMaxParam: Quantity_AbsorbedDose): void;
  GetEdgeParam(i: Graphic3d_ZLayerId, theOutE: TopoDS_Edge, theOutParam: Quantity_AbsorbedDose, outLParam: Quantity_AbsorbedDose): void;
  GetVertParam(i: Graphic3d_ZLayerId, theOutV: TopoDS_Vertex, outLParam: Quantity_AbsorbedDose): void;
  GetNbEdgeParam(): Graphic3d_ZLayerId;
  GetNbVertParam(): Graphic3d_ZLayerId;
  ClearResults(): void;
  IsCorrect(): Standard_Boolean;
  delete(): void;
}

export declare class BRepClass3d_SolidExplorer {
  InitShape(S: TopoDS_Shape): void;
  Reject(P: gp_Pnt): Standard_Boolean;
  static FindAPointInTheFace_1(F: TopoDS_Face, P: gp_Pnt, Param: Quantity_AbsorbedDose): Standard_Boolean;
  static FindAPointInTheFace_2(F: TopoDS_Face, P: gp_Pnt, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose): Standard_Boolean;
  static FindAPointInTheFace_3(F: TopoDS_Face, P: gp_Pnt, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, theVecD1U: gp_Vec, theVecD1V: gp_Vec): Standard_Boolean;
  static FindAPointInTheFace_4(F: TopoDS_Face, P: gp_Pnt, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): Standard_Boolean;
  static FindAPointInTheFace_5(F: TopoDS_Face, P: gp_Pnt): Standard_Boolean;
  static FindAPointInTheFace_6(F: TopoDS_Face, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): Standard_Boolean;
  PointInTheFace_1(F: TopoDS_Face, P: gp_Pnt, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId): Standard_Boolean;
  PointInTheFace_2(F: TopoDS_Face, P: gp_Pnt, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, surf: Handle_BRepAdaptor_HSurface, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Standard_Boolean;
  PointInTheFace_3(F: TopoDS_Face, P: gp_Pnt, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Param: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, surf: Handle_BRepAdaptor_HSurface, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, theVecD1U: gp_Vec, theVecD1V: gp_Vec): Standard_Boolean;
  InitShell(): void;
  MoreShell(): Standard_Boolean;
  NextShell(): void;
  CurrentShell(): TopoDS_Shell;
  RejectShell(L: gp_Lin): Standard_Boolean;
  InitFace(): void;
  MoreFace(): Standard_Boolean;
  NextFace(): void;
  CurrentFace(): TopoDS_Face;
  RejectFace(L: gp_Lin): Standard_Boolean;
  Segment(P: gp_Pnt, L: gp_Lin, Par: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  OtherSegment(P: gp_Pnt, L: gp_Lin, Par: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  GetFaceSegmentIndex(): Graphic3d_ZLayerId;
  DumpSegment(P: gp_Pnt, L: gp_Lin, Par: Quantity_AbsorbedDose, S: TopAbs_State): void;
  Box(): Bnd_Box;
  GetShape(): TopoDS_Shape;
  Intersector(F: TopoDS_Face): IntCurvesFace_Intersector;
  GetMapEV(): TopTools_IndexedMapOfShape;
  Destroy(): void;
  delete(): void;
}

  export declare class BRepClass3d_SolidExplorer_1 extends BRepClass3d_SolidExplorer {
    constructor();
  }

  export declare class BRepClass3d_SolidExplorer_2 extends BRepClass3d_SolidExplorer {
    constructor(S: TopoDS_Shape);
  }

export declare class BRepClass3d {
  constructor();
  static OuterShell(S: TopoDS_Solid): TopoDS_Shell;
  delete(): void;
}

export declare class BRepClass3d_SClassifier {
  Perform(S: BRepClass3d_SolidExplorer, P: gp_Pnt, Tol: Quantity_AbsorbedDose): void;
  PerformInfinitePoint(S: BRepClass3d_SolidExplorer, Tol: Quantity_AbsorbedDose): void;
  Rejected(): Standard_Boolean;
  State(): TopAbs_State;
  IsOnAFace(): Standard_Boolean;
  Face(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepClass3d_SClassifier_1 extends BRepClass3d_SClassifier {
    constructor();
  }

  export declare class BRepClass3d_SClassifier_2 extends BRepClass3d_SClassifier {
    constructor(S: BRepClass3d_SolidExplorer, P: gp_Pnt, Tol: Quantity_AbsorbedDose);
  }

export declare type UnitsAPI_SystemUnits = {
  UnitsAPI_DEFAULT: {};
  UnitsAPI_SI: {};
  UnitsAPI_MDTV: {};
}

export declare class UnitsAPI {
  constructor();
  static CurrentToLS(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString): Quantity_AbsorbedDose;
  static CurrentToSI(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString): Quantity_AbsorbedDose;
  static CurrentFromLS(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString): Quantity_AbsorbedDose;
  static CurrentFromSI(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString): Quantity_AbsorbedDose;
  static AnyToLS_1(aData: Quantity_AbsorbedDose, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static AnyToLS_2(aData: Quantity_AbsorbedDose, aUnit: Standard_CString, aDim: Handle_Units_Dimensions): Quantity_AbsorbedDose;
  static AnyToSI_1(aData: Quantity_AbsorbedDose, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static AnyToSI_2(aData: Quantity_AbsorbedDose, aUnit: Standard_CString, aDim: Handle_Units_Dimensions): Quantity_AbsorbedDose;
  static AnyFromLS(aData: Quantity_AbsorbedDose, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static AnyFromSI(aData: Quantity_AbsorbedDose, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static CurrentToAny(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static CurrentFromAny(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString, aUnit: Standard_CString): Quantity_AbsorbedDose;
  static AnyToAny(aData: Quantity_AbsorbedDose, aUnit1: Standard_CString, aUnit2: Standard_CString): Quantity_AbsorbedDose;
  static LSToSI(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString): Quantity_AbsorbedDose;
  static SIToLS(aData: Quantity_AbsorbedDose, aQuantity: Standard_CString): Quantity_AbsorbedDose;
  static SetLocalSystem(aSystemUnit: UnitsAPI_SystemUnits): void;
  static LocalSystem(): UnitsAPI_SystemUnits;
  static SetCurrentUnit(aQuantity: Standard_CString, aUnit: Standard_CString): void;
  static CurrentUnit(aQuantity: Standard_CString): Standard_CString;
  static Save(): void;
  static Reload(): void;
  static Dimensions(aQuantity: Standard_CString): Handle_Units_Dimensions;
  static DimensionLess(): Handle_Units_Dimensions;
  static DimensionMass(): Handle_Units_Dimensions;
  static DimensionLength(): Handle_Units_Dimensions;
  static DimensionTime(): Handle_Units_Dimensions;
  static DimensionElectricCurrent(): Handle_Units_Dimensions;
  static DimensionThermodynamicTemperature(): Handle_Units_Dimensions;
  static DimensionAmountOfSubstance(): Handle_Units_Dimensions;
  static DimensionLuminousIntensity(): Handle_Units_Dimensions;
  static DimensionPlaneAngle(): Handle_Units_Dimensions;
  static DimensionSolidAngle(): Handle_Units_Dimensions;
  static Check(aQuantity: Standard_CString, aUnit: Standard_CString): Standard_Boolean;
  delete(): void;
}

export declare class IntRes2d_IntersectionSegment {
  IsOpposite(): Standard_Boolean;
  HasFirstPoint(): Standard_Boolean;
  FirstPoint(): IntRes2d_IntersectionPoint;
  HasLastPoint(): Standard_Boolean;
  LastPoint(): IntRes2d_IntersectionPoint;
  delete(): void;
}

  export declare class IntRes2d_IntersectionSegment_1 extends IntRes2d_IntersectionSegment {
    constructor();
  }

  export declare class IntRes2d_IntersectionSegment_2 extends IntRes2d_IntersectionSegment {
    constructor(P1: IntRes2d_IntersectionPoint, P2: IntRes2d_IntersectionPoint, Oppos: Standard_Boolean, ReverseFlag: Standard_Boolean);
  }

  export declare class IntRes2d_IntersectionSegment_3 extends IntRes2d_IntersectionSegment {
    constructor(P: IntRes2d_IntersectionPoint, First: Standard_Boolean, Oppos: Standard_Boolean, ReverseFlag: Standard_Boolean);
  }

  export declare class IntRes2d_IntersectionSegment_4 extends IntRes2d_IntersectionSegment {
    constructor(Oppos: Standard_Boolean);
  }

export declare type IntRes2d_TypeTrans = {
  IntRes2d_In: {};
  IntRes2d_Out: {};
  IntRes2d_Touch: {};
  IntRes2d_Undecided: {};
}

export declare type IntRes2d_Position = {
  IntRes2d_Head: {};
  IntRes2d_Middle: {};
  IntRes2d_End: {};
}

export declare class IntRes2d_Transition {
  SetValue_1(Tangent: Standard_Boolean, Pos: IntRes2d_Position, Type: IntRes2d_TypeTrans): void;
  SetValue_2(Tangent: Standard_Boolean, Pos: IntRes2d_Position, Situ: IntRes2d_Situation, Oppos: Standard_Boolean): void;
  SetValue_3(Pos: IntRes2d_Position): void;
  SetPosition(Pos: IntRes2d_Position): void;
  PositionOnCurve(): IntRes2d_Position;
  TransitionType(): IntRes2d_TypeTrans;
  IsTangent(): Standard_Boolean;
  Situation(): IntRes2d_Situation;
  IsOpposite(): Standard_Boolean;
  delete(): void;
}

  export declare class IntRes2d_Transition_1 extends IntRes2d_Transition {
    constructor();
  }

  export declare class IntRes2d_Transition_2 extends IntRes2d_Transition {
    constructor(Tangent: Standard_Boolean, Pos: IntRes2d_Position, Type: IntRes2d_TypeTrans);
  }

  export declare class IntRes2d_Transition_3 extends IntRes2d_Transition {
    constructor(Tangent: Standard_Boolean, Pos: IntRes2d_Position, Situ: IntRes2d_Situation, Oppos: Standard_Boolean);
  }

  export declare class IntRes2d_Transition_4 extends IntRes2d_Transition {
    constructor(Pos: IntRes2d_Position);
  }

export declare class IntRes2d_SequenceOfIntersectionPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntRes2d_SequenceOfIntersectionPoint): IntRes2d_SequenceOfIntersectionPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntRes2d_IntersectionPoint): void;
  Append_2(theSeq: IntRes2d_SequenceOfIntersectionPoint): void;
  Prepend_1(theItem: IntRes2d_IntersectionPoint): void;
  Prepend_2(theSeq: IntRes2d_SequenceOfIntersectionPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntRes2d_IntersectionPoint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntRes2d_SequenceOfIntersectionPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntRes2d_SequenceOfIntersectionPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntRes2d_IntersectionPoint): void;
  Split(theIndex: Standard_Integer, theSeq: IntRes2d_SequenceOfIntersectionPoint): void;
  First(): IntRes2d_IntersectionPoint;
  ChangeFirst(): IntRes2d_IntersectionPoint;
  Last(): IntRes2d_IntersectionPoint;
  ChangeLast(): IntRes2d_IntersectionPoint;
  Value(theIndex: Standard_Integer): IntRes2d_IntersectionPoint;
  ChangeValue(theIndex: Standard_Integer): IntRes2d_IntersectionPoint;
  SetValue(theIndex: Standard_Integer, theItem: IntRes2d_IntersectionPoint): void;
  delete(): void;
}

  export declare class IntRes2d_SequenceOfIntersectionPoint_1 extends IntRes2d_SequenceOfIntersectionPoint {
    constructor();
  }

  export declare class IntRes2d_SequenceOfIntersectionPoint_2 extends IntRes2d_SequenceOfIntersectionPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntRes2d_SequenceOfIntersectionPoint_3 extends IntRes2d_SequenceOfIntersectionPoint {
    constructor(theOther: IntRes2d_SequenceOfIntersectionPoint);
  }

export declare class IntRes2d_Domain {
  SetValues_1(Pnt1: gp_Pnt2d, Par1: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Pnt2: gp_Pnt2d, Par2: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose): void;
  SetValues_2(): void;
  SetValues_3(Pnt: gp_Pnt2d, Par: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, First: Standard_Boolean): void;
  SetEquivalentParameters(zero: Quantity_AbsorbedDose, period: Quantity_AbsorbedDose): void;
  HasFirstPoint(): Standard_Boolean;
  FirstParameter(): Quantity_AbsorbedDose;
  FirstPoint(): gp_Pnt2d;
  FirstTolerance(): Quantity_AbsorbedDose;
  HasLastPoint(): Standard_Boolean;
  LastParameter(): Quantity_AbsorbedDose;
  LastPoint(): gp_Pnt2d;
  LastTolerance(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  EquivalentParameters(zero: Quantity_AbsorbedDose, zeroplusperiod: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntRes2d_Domain_1 extends IntRes2d_Domain {
    constructor();
  }

  export declare class IntRes2d_Domain_2 extends IntRes2d_Domain {
    constructor(Pnt1: gp_Pnt2d, Par1: Quantity_AbsorbedDose, Tol1: Quantity_AbsorbedDose, Pnt2: gp_Pnt2d, Par2: Quantity_AbsorbedDose, Tol2: Quantity_AbsorbedDose);
  }

  export declare class IntRes2d_Domain_3 extends IntRes2d_Domain {
    constructor(Pnt: gp_Pnt2d, Par: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, First: Standard_Boolean);
  }

export declare type IntRes2d_Situation = {
  IntRes2d_Inside: {};
  IntRes2d_Outside: {};
  IntRes2d_Unknown: {};
}

export declare class IntRes2d_IntersectionPoint {
  SetValues(P: gp_Pnt2d, Uc1: Quantity_AbsorbedDose, Uc2: Quantity_AbsorbedDose, Trans1: IntRes2d_Transition, Trans2: IntRes2d_Transition, ReversedFlag: Standard_Boolean): void;
  Value(): gp_Pnt2d;
  ParamOnFirst(): Quantity_AbsorbedDose;
  ParamOnSecond(): Quantity_AbsorbedDose;
  TransitionOfFirst(): IntRes2d_Transition;
  TransitionOfSecond(): IntRes2d_Transition;
  delete(): void;
}

  export declare class IntRes2d_IntersectionPoint_1 extends IntRes2d_IntersectionPoint {
    constructor();
  }

  export declare class IntRes2d_IntersectionPoint_2 extends IntRes2d_IntersectionPoint {
    constructor(P: gp_Pnt2d, Uc1: Quantity_AbsorbedDose, Uc2: Quantity_AbsorbedDose, Trans1: IntRes2d_Transition, Trans2: IntRes2d_Transition, ReversedFlag: Standard_Boolean);
  }

export declare class IntRes2d_SequenceOfIntersectionSegment extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntRes2d_SequenceOfIntersectionSegment): IntRes2d_SequenceOfIntersectionSegment;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntRes2d_IntersectionSegment): void;
  Append_2(theSeq: IntRes2d_SequenceOfIntersectionSegment): void;
  Prepend_1(theItem: IntRes2d_IntersectionSegment): void;
  Prepend_2(theSeq: IntRes2d_SequenceOfIntersectionSegment): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntRes2d_IntersectionSegment): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntRes2d_SequenceOfIntersectionSegment): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntRes2d_SequenceOfIntersectionSegment): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntRes2d_IntersectionSegment): void;
  Split(theIndex: Standard_Integer, theSeq: IntRes2d_SequenceOfIntersectionSegment): void;
  First(): IntRes2d_IntersectionSegment;
  ChangeFirst(): IntRes2d_IntersectionSegment;
  Last(): IntRes2d_IntersectionSegment;
  ChangeLast(): IntRes2d_IntersectionSegment;
  Value(theIndex: Standard_Integer): IntRes2d_IntersectionSegment;
  ChangeValue(theIndex: Standard_Integer): IntRes2d_IntersectionSegment;
  SetValue(theIndex: Standard_Integer, theItem: IntRes2d_IntersectionSegment): void;
  delete(): void;
}

  export declare class IntRes2d_SequenceOfIntersectionSegment_1 extends IntRes2d_SequenceOfIntersectionSegment {
    constructor();
  }

  export declare class IntRes2d_SequenceOfIntersectionSegment_2 extends IntRes2d_SequenceOfIntersectionSegment {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntRes2d_SequenceOfIntersectionSegment_3 extends IntRes2d_SequenceOfIntersectionSegment {
    constructor(theOther: IntRes2d_SequenceOfIntersectionSegment);
  }

export declare class IntRes2d_Intersection {
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(N: Graphic3d_ZLayerId): IntRes2d_IntersectionPoint;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(N: Graphic3d_ZLayerId): IntRes2d_IntersectionSegment;
  SetReversedParameters(Reverseflag: Standard_Boolean): void;
  delete(): void;
}

export declare class Geom2dConvert {
  constructor();
  static SplitBSplineCurve_1(C: Handle_Geom2d_BSplineCurve, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, SameOrientation: Standard_Boolean): Handle_Geom2d_BSplineCurve;
  static SplitBSplineCurve_2(C: Handle_Geom2d_BSplineCurve, FromU1: Quantity_AbsorbedDose, ToU2: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, SameOrientation: Standard_Boolean): Handle_Geom2d_BSplineCurve;
  static CurveToBSplineCurve(C: Handle_Geom2d_Curve, Parameterisation: Convert_ParameterisationType): Handle_Geom2d_BSplineCurve;
  static ConcatG1(ArrayOfCurves: TColGeom2d_Array1OfBSplineCurve, ArrayOfToler: TColStd_Array1OfReal, ArrayOfConcatenated: Handle_TColGeom2d_HArray1OfBSplineCurve, ClosedFlag: Standard_Boolean, ClosedTolerance: Quantity_AbsorbedDose): void;
  static ConcatC1_1(ArrayOfCurves: TColGeom2d_Array1OfBSplineCurve, ArrayOfToler: TColStd_Array1OfReal, ArrayOfIndices: Handle_TColStd_HArray1OfInteger, ArrayOfConcatenated: Handle_TColGeom2d_HArray1OfBSplineCurve, ClosedFlag: Standard_Boolean, ClosedTolerance: Quantity_AbsorbedDose): void;
  static ConcatC1_2(ArrayOfCurves: TColGeom2d_Array1OfBSplineCurve, ArrayOfToler: TColStd_Array1OfReal, ArrayOfIndices: Handle_TColStd_HArray1OfInteger, ArrayOfConcatenated: Handle_TColGeom2d_HArray1OfBSplineCurve, ClosedFlag: Standard_Boolean, ClosedTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): void;
  static C0BSplineToC1BSplineCurve(BS: Handle_Geom2d_BSplineCurve, Tolerance: Quantity_AbsorbedDose): void;
  static C0BSplineToArrayOfC1BSplineCurve_1(BS: Handle_Geom2d_BSplineCurve, tabBS: Handle_TColGeom2d_HArray1OfBSplineCurve, Tolerance: Quantity_AbsorbedDose): void;
  static C0BSplineToArrayOfC1BSplineCurve_2(BS: Handle_Geom2d_BSplineCurve, tabBS: Handle_TColGeom2d_HArray1OfBSplineCurve, AngularTolerance: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Geom2dConvert_BSplineCurveKnotSplitting {
  constructor(BasisCurve: Handle_Geom2d_BSplineCurve, ContinuityRange: Graphic3d_ZLayerId)
  NbSplits(): Graphic3d_ZLayerId;
  Splitting(SplitValues: TColStd_Array1OfInteger): void;
  SplitValue(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Geom2dConvert_CompCurveToBSplineCurve {
  Add_1(NewCurve: Handle_Geom2d_BoundedCurve, Tolerance: Quantity_AbsorbedDose, After: Standard_Boolean): Standard_Boolean;
  BSplineCurve(): Handle_Geom2d_BSplineCurve;
  Clear(): void;
  delete(): void;
}

  export declare class Geom2dConvert_CompCurveToBSplineCurve_1 extends Geom2dConvert_CompCurveToBSplineCurve {
    constructor(Parameterisation: Convert_ParameterisationType);
  }

  export declare class Geom2dConvert_CompCurveToBSplineCurve_2 extends Geom2dConvert_CompCurveToBSplineCurve {
    constructor(BasisCurve: Handle_Geom2d_BoundedCurve, Parameterisation: Convert_ParameterisationType);
  }

export declare class Geom2dConvert_ApproxCurve {
  Curve(): Handle_Geom2d_BSplineCurve;
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  MaxError(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class Geom2dConvert_ApproxCurve_1 extends Geom2dConvert_ApproxCurve {
    constructor(Curve: Handle_Geom2d_Curve, Tol2d: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId);
  }

  export declare class Geom2dConvert_ApproxCurve_2 extends Geom2dConvert_ApproxCurve {
    constructor(Curve: Handle_Adaptor2d_HCurve2d, Tol2d: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId);
  }

export declare class Geom2dConvert_BSplineCurveToBezierCurve {
  Arc(Index: Graphic3d_ZLayerId): Handle_Geom2d_BezierCurve;
  Arcs(Curves: TColGeom2d_Array1OfBezierCurve): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  NbArcs(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Geom2dConvert_BSplineCurveToBezierCurve_1 extends Geom2dConvert_BSplineCurveToBezierCurve {
    constructor(BasisCurve: Handle_Geom2d_BSplineCurve);
  }

  export declare class Geom2dConvert_BSplineCurveToBezierCurve_2 extends Geom2dConvert_BSplineCurveToBezierCurve {
    constructor(BasisCurve: Handle_Geom2d_BSplineCurve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose);
  }

export declare class BinMDataXtd_PositionDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataXtd_PositionDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataXtd_PositionDriver): void;
  get(): BinMDataXtd_PositionDriver;
  delete(): void;
}

  export declare class Handle_BinMDataXtd_PositionDriver_1 extends Handle_BinMDataXtd_PositionDriver {
    constructor();
  }

  export declare class Handle_BinMDataXtd_PositionDriver_2 extends Handle_BinMDataXtd_PositionDriver {
    constructor(thePtr: BinMDataXtd_PositionDriver);
  }

  export declare class Handle_BinMDataXtd_PositionDriver_3 extends Handle_BinMDataXtd_PositionDriver {
    constructor(theHandle: Handle_BinMDataXtd_PositionDriver);
  }

  export declare class Handle_BinMDataXtd_PositionDriver_4 extends Handle_BinMDataXtd_PositionDriver {
    constructor(theHandle: Handle_BinMDataXtd_PositionDriver);
  }

export declare class Handle_BinMDataXtd_GeometryDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataXtd_GeometryDriver): void;
  get(): BinMDataXtd_GeometryDriver;
  delete(): void;
}

  export declare class Handle_BinMDataXtd_GeometryDriver_1 extends Handle_BinMDataXtd_GeometryDriver {
    constructor();
  }

  export declare class Handle_BinMDataXtd_GeometryDriver_2 extends Handle_BinMDataXtd_GeometryDriver {
    constructor(thePtr: BinMDataXtd_GeometryDriver);
  }

  export declare class Handle_BinMDataXtd_GeometryDriver_3 extends Handle_BinMDataXtd_GeometryDriver {
    constructor(theHandle: Handle_BinMDataXtd_GeometryDriver);
  }

  export declare class Handle_BinMDataXtd_GeometryDriver_4 extends Handle_BinMDataXtd_GeometryDriver {
    constructor(theHandle: Handle_BinMDataXtd_GeometryDriver);
  }

export declare class BinMDataXtd_GeometryDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataXtd_PatternStdDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataXtd_PatternStdDriver): void;
  get(): BinMDataXtd_PatternStdDriver;
  delete(): void;
}

  export declare class Handle_BinMDataXtd_PatternStdDriver_1 extends Handle_BinMDataXtd_PatternStdDriver {
    constructor();
  }

  export declare class Handle_BinMDataXtd_PatternStdDriver_2 extends Handle_BinMDataXtd_PatternStdDriver {
    constructor(thePtr: BinMDataXtd_PatternStdDriver);
  }

  export declare class Handle_BinMDataXtd_PatternStdDriver_3 extends Handle_BinMDataXtd_PatternStdDriver {
    constructor(theHandle: Handle_BinMDataXtd_PatternStdDriver);
  }

  export declare class Handle_BinMDataXtd_PatternStdDriver_4 extends Handle_BinMDataXtd_PatternStdDriver {
    constructor(theHandle: Handle_BinMDataXtd_PatternStdDriver);
  }

export declare class BinMDataXtd_PatternStdDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataXtd_TriangulationDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataXtd_TriangulationDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataXtd_TriangulationDriver): void;
  get(): BinMDataXtd_TriangulationDriver;
  delete(): void;
}

  export declare class Handle_BinMDataXtd_TriangulationDriver_1 extends Handle_BinMDataXtd_TriangulationDriver {
    constructor();
  }

  export declare class Handle_BinMDataXtd_TriangulationDriver_2 extends Handle_BinMDataXtd_TriangulationDriver {
    constructor(thePtr: BinMDataXtd_TriangulationDriver);
  }

  export declare class Handle_BinMDataXtd_TriangulationDriver_3 extends Handle_BinMDataXtd_TriangulationDriver {
    constructor(theHandle: Handle_BinMDataXtd_TriangulationDriver);
  }

  export declare class Handle_BinMDataXtd_TriangulationDriver_4 extends Handle_BinMDataXtd_TriangulationDriver {
    constructor(theHandle: Handle_BinMDataXtd_TriangulationDriver);
  }

export declare class BinMDataXtd {
  constructor();
  static AddDrivers(theDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  static SetDocumentVersion(DocVersion: Graphic3d_ZLayerId): void;
  static DocumentVersion(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_BinMDataXtd_ConstraintDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataXtd_ConstraintDriver): void;
  get(): BinMDataXtd_ConstraintDriver;
  delete(): void;
}

  export declare class Handle_BinMDataXtd_ConstraintDriver_1 extends Handle_BinMDataXtd_ConstraintDriver {
    constructor();
  }

  export declare class Handle_BinMDataXtd_ConstraintDriver_2 extends Handle_BinMDataXtd_ConstraintDriver {
    constructor(thePtr: BinMDataXtd_ConstraintDriver);
  }

  export declare class Handle_BinMDataXtd_ConstraintDriver_3 extends Handle_BinMDataXtd_ConstraintDriver {
    constructor(theHandle: Handle_BinMDataXtd_ConstraintDriver);
  }

  export declare class Handle_BinMDataXtd_ConstraintDriver_4 extends Handle_BinMDataXtd_ConstraintDriver {
    constructor(theHandle: Handle_BinMDataXtd_ConstraintDriver);
  }

export declare class BinMDataXtd_ConstraintDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDataXtd_PresentationDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMDataXtd_PresentationDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDataXtd_PresentationDriver): void;
  get(): BinMDataXtd_PresentationDriver;
  delete(): void;
}

  export declare class Handle_BinMDataXtd_PresentationDriver_1 extends Handle_BinMDataXtd_PresentationDriver {
    constructor();
  }

  export declare class Handle_BinMDataXtd_PresentationDriver_2 extends Handle_BinMDataXtd_PresentationDriver {
    constructor(thePtr: BinMDataXtd_PresentationDriver);
  }

  export declare class Handle_BinMDataXtd_PresentationDriver_3 extends Handle_BinMDataXtd_PresentationDriver {
    constructor(theHandle: Handle_BinMDataXtd_PresentationDriver);
  }

  export declare class Handle_BinMDataXtd_PresentationDriver_4 extends Handle_BinMDataXtd_PresentationDriver {
    constructor(theHandle: Handle_BinMDataXtd_PresentationDriver);
  }

export declare class BRepSweep_Translation extends BRepSweep_Trsf {
  constructor(S: TopoDS_Shape, N: Sweep_NumShape, L: TopLoc_Location, V: gp_Vec, C: Standard_Boolean, Canonize: Standard_Boolean)
  MakeEmptyVertex(aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyDirectingEdge(aGenV: TopoDS_Shape, aDirE: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyGeneratingEdge(aGenE: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  SetParameters(aNewFace: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenF: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  SetDirectingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape): void;
  SetGeneratingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  MakeEmptyFace(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopoDS_Shape;
  SetPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenF: TopoDS_Shape, aGenE: TopoDS_Shape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetGeneratingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetDirectingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, orien: TopAbs_Orientation): void;
  DirectSolid(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopAbs_Orientation;
  GGDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  GDDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aDirS: Sweep_NumShape, aSubDirS: Sweep_NumShape): Standard_Boolean;
  SeparatedWires(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  HasShape(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  IsInvariant(aGenS: TopoDS_Shape): Standard_Boolean;
  Vec(): gp_Vec;
  delete(): void;
}

export declare class BRepSweep_Prism {
  Shape_1(): TopoDS_Shape;
  Shape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  FirstShape_1(): TopoDS_Shape;
  FirstShape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  LastShape_1(): TopoDS_Shape;
  LastShape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  Vec(): gp_Vec;
  IsUsed(aGenS: TopoDS_Shape): Standard_Boolean;
  GenIsUsed(theS: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepSweep_Prism_1 extends BRepSweep_Prism {
    constructor(S: TopoDS_Shape, V: gp_Vec, Copy: Standard_Boolean, Canonize: Standard_Boolean);
  }

  export declare class BRepSweep_Prism_2 extends BRepSweep_Prism {
    constructor(S: TopoDS_Shape, D: gp_Dir, Inf: Standard_Boolean, Copy: Standard_Boolean, Canonize: Standard_Boolean);
  }

export declare class BRepSweep_Revol {
  Shape_1(): TopoDS_Shape;
  Shape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  FirstShape_1(): TopoDS_Shape;
  FirstShape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  LastShape_1(): TopoDS_Shape;
  LastShape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  Axe_1(): gp_Ax1;
  Angle_1(): Quantity_AbsorbedDose;
  IsUsed(aGenS: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepSweep_Revol_1 extends BRepSweep_Revol {
    constructor(S: TopoDS_Shape, A: gp_Ax1, D: Quantity_AbsorbedDose, C: Standard_Boolean);
  }

  export declare class BRepSweep_Revol_2 extends BRepSweep_Revol {
    constructor(S: TopoDS_Shape, A: gp_Ax1, C: Standard_Boolean);
  }

export declare class BRepSweep_Rotation extends BRepSweep_Trsf {
  constructor(S: TopoDS_Shape, N: Sweep_NumShape, L: TopLoc_Location, A: gp_Ax1, D: Quantity_AbsorbedDose, C: Standard_Boolean)
  MakeEmptyVertex(aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyDirectingEdge(aGenV: TopoDS_Shape, aDirE: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyGeneratingEdge(aGenE: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  SetParameters(aNewFace: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenF: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  SetDirectingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape): void;
  SetGeneratingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  MakeEmptyFace(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopoDS_Shape;
  SetPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenF: TopoDS_Shape, aGenE: TopoDS_Shape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetGeneratingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetDirectingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, orien: TopAbs_Orientation): void;
  DirectSolid(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopAbs_Orientation;
  GGDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  GDDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aDirS: Sweep_NumShape, aSubDirS: Sweep_NumShape): Standard_Boolean;
  SeparatedWires(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  SplitShell(aNewShape: TopoDS_Shape): TopoDS_Shape;
  HasShape(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  IsInvariant(aGenS: TopoDS_Shape): Standard_Boolean;
  Axe(): gp_Ax1;
  Angle(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepSweep_Builder {
  constructor(aBuilder: BRep_Builder)
  Builder(): BRep_Builder;
  MakeCompound(aCompound: TopoDS_Shape): void;
  MakeCompSolid(aCompSolid: TopoDS_Shape): void;
  MakeSolid(aSolid: TopoDS_Shape): void;
  MakeShell(aShell: TopoDS_Shape): void;
  MakeWire(aWire: TopoDS_Shape): void;
  Add_1(aShape1: TopoDS_Shape, aShape2: TopoDS_Shape, Orient: TopAbs_Orientation): void;
  Add_2(aShape1: TopoDS_Shape, aShape2: TopoDS_Shape): void;
  delete(): void;
}

export declare class BRepSweep_Iterator {
  constructor()
  Init(aShape: TopoDS_Shape): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): TopoDS_Shape;
  Orientation(): TopAbs_Orientation;
  delete(): void;
}

export declare class BRepSweep_Trsf extends BRepSweep_NumLinearRegularSweep {
  Init(): void;
  Process(aGenS: TopoDS_Shape, aDirV: Sweep_NumShape): Standard_Boolean;
  MakeEmptyVertex(aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyDirectingEdge(aGenV: TopoDS_Shape, aDirE: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyGeneratingEdge(aGenE: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  SetParameters(aNewFace: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenF: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  SetDirectingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape): void;
  SetGeneratingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  MakeEmptyFace(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopoDS_Shape;
  SetPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenF: TopoDS_Shape, aGenE: TopoDS_Shape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetGeneratingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetDirectingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, orien: TopAbs_Orientation): void;
  GGDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  GDDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aDirS: Sweep_NumShape, aSubDirS: Sweep_NumShape): Standard_Boolean;
  SeparatedWires(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  HasShape(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  IsInvariant(aGenS: TopoDS_Shape): Standard_Boolean;
  SetContinuity(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): void;
  delete(): void;
}

export declare class BRepSweep_NumLinearRegularSweep {
  MakeEmptyVertex(aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyDirectingEdge(aGenV: TopoDS_Shape, aDirE: Sweep_NumShape): TopoDS_Shape;
  MakeEmptyGeneratingEdge(aGenE: TopoDS_Shape, aDirV: Sweep_NumShape): TopoDS_Shape;
  SetParameters(aNewFace: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenF: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  SetDirectingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape): void;
  SetGeneratingParameter(aNewEdge: TopoDS_Shape, aNewVertex: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirV: Sweep_NumShape): void;
  MakeEmptyFace(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopoDS_Shape;
  SetPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenF: TopoDS_Shape, aGenE: TopoDS_Shape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetGeneratingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aDirE: Sweep_NumShape, aDirV: Sweep_NumShape, orien: TopAbs_Orientation): void;
  SetDirectingPCurve(aNewFace: TopoDS_Shape, aNewEdge: TopoDS_Shape, aGenE: TopoDS_Shape, aGenV: TopoDS_Shape, aDirE: Sweep_NumShape, orien: TopAbs_Orientation): void;
  DirectSolid(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopAbs_Orientation;
  GGDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  GDDShapeIsToAdd(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aDirS: Sweep_NumShape, aSubDirS: Sweep_NumShape): Standard_Boolean;
  SeparatedWires(aNewShape: TopoDS_Shape, aNewSubShape: TopoDS_Shape, aGenS: TopoDS_Shape, aSubGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  SplitShell(aNewShape: TopoDS_Shape): TopoDS_Shape;
  SetContinuity(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): void;
  HasShape(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): Standard_Boolean;
  IsInvariant(aGenS: TopoDS_Shape): Standard_Boolean;
  Shape_1(aGenS: TopoDS_Shape, aDirS: Sweep_NumShape): TopoDS_Shape;
  Shape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  IsUsed(aGenS: TopoDS_Shape): Standard_Boolean;
  GenIsUsed(theS: TopoDS_Shape): Standard_Boolean;
  Shape_3(): TopoDS_Shape;
  FirstShape_1(): TopoDS_Shape;
  LastShape_1(): TopoDS_Shape;
  FirstShape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  LastShape_2(aGenS: TopoDS_Shape): TopoDS_Shape;
  Closed(): Standard_Boolean;
  delete(): void;
}

export declare class BRepSweep_Tool {
  constructor(aShape: TopoDS_Shape)
  NbShapes(): Graphic3d_ZLayerId;
  Index(aShape: TopoDS_Shape): Graphic3d_ZLayerId;
  Shape(anIndex: Graphic3d_ZLayerId): TopoDS_Shape;
  Type(aShape: TopoDS_Shape): TopAbs_ShapeEnum;
  Orientation(aShape: TopoDS_Shape): TopAbs_Orientation;
  SetOrientation(aShape: TopoDS_Shape, Or: TopAbs_Orientation): void;
  delete(): void;
}

export declare class UnitsMethods {
  constructor();
  static InitializeFactors(LengthFactor: Quantity_AbsorbedDose, PlaneAngleFactor: Quantity_AbsorbedDose, SolidAngleFactor: Quantity_AbsorbedDose): void;
  static LengthFactor(): Quantity_AbsorbedDose;
  static PlaneAngleFactor(): Quantity_AbsorbedDose;
  static SolidAngleFactor(): Quantity_AbsorbedDose;
  static Set3dConversion(B: Standard_Boolean): void;
  static Convert3d(): Standard_Boolean;
  static RadianToDegree(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface): Handle_Geom2d_Curve;
  static DegreeToRadian(C: Handle_Geom2d_Curve, S: Handle_Geom_Surface): Handle_Geom2d_Curve;
  static MirrorPCurve(C: Handle_Geom2d_Curve): Handle_Geom2d_Curve;
  static GetLengthFactorValue(param: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static GetCasCadeLengthUnit(): Quantity_AbsorbedDose;
  static SetCasCadeLengthUnit(param: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Adaptor2d_HCurve2d extends Standard_Transient {
  Curve2d(): Adaptor2d_Curve2d;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Adaptor2d_HCurve2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor2d_HCurve2d): void;
  get(): Adaptor2d_HCurve2d;
  delete(): void;
}

  export declare class Handle_Adaptor2d_HCurve2d_1 extends Handle_Adaptor2d_HCurve2d {
    constructor();
  }

  export declare class Handle_Adaptor2d_HCurve2d_2 extends Handle_Adaptor2d_HCurve2d {
    constructor(thePtr: Adaptor2d_HCurve2d);
  }

  export declare class Handle_Adaptor2d_HCurve2d_3 extends Handle_Adaptor2d_HCurve2d {
    constructor(theHandle: Handle_Adaptor2d_HCurve2d);
  }

  export declare class Handle_Adaptor2d_HCurve2d_4 extends Handle_Adaptor2d_HCurve2d {
    constructor(theHandle: Handle_Adaptor2d_HCurve2d);
  }

export declare class Adaptor2d_OffsetCurve extends Adaptor2d_Curve2d {
  Load_1(S: Handle_Adaptor2d_HCurve2d): void;
  Load_2(Offset: Quantity_AbsorbedDose): void;
  Load_3(Offset: Quantity_AbsorbedDose, WFirst: Quantity_AbsorbedDose, WLast: Quantity_AbsorbedDose): void;
  Curve(): Handle_Adaptor2d_HCurve2d;
  Offset(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  NbSamples(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Adaptor2d_OffsetCurve_1 extends Adaptor2d_OffsetCurve {
    constructor();
  }

  export declare class Adaptor2d_OffsetCurve_2 extends Adaptor2d_OffsetCurve {
    constructor(C: Handle_Adaptor2d_HCurve2d);
  }

  export declare class Adaptor2d_OffsetCurve_3 extends Adaptor2d_OffsetCurve {
    constructor(C: Handle_Adaptor2d_HCurve2d, Offset: Quantity_AbsorbedDose);
  }

  export declare class Adaptor2d_OffsetCurve_4 extends Adaptor2d_OffsetCurve {
    constructor(C: Handle_Adaptor2d_HCurve2d, Offset: Quantity_AbsorbedDose, WFirst: Quantity_AbsorbedDose, WLast: Quantity_AbsorbedDose);
  }

export declare class Adaptor2d_HLine2d extends Adaptor2d_HCurve2d {
  Set(C: Adaptor2d_Line2d): void;
  Curve2d(): Adaptor2d_Curve2d;
  ChangeCurve2d(): Adaptor2d_Line2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Adaptor2d_HLine2d_1 extends Adaptor2d_HLine2d {
    constructor();
  }

  export declare class Adaptor2d_HLine2d_2 extends Adaptor2d_HLine2d {
    constructor(C: Adaptor2d_Line2d);
  }

export declare class Handle_Adaptor2d_HLine2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor2d_HLine2d): void;
  get(): Adaptor2d_HLine2d;
  delete(): void;
}

  export declare class Handle_Adaptor2d_HLine2d_1 extends Handle_Adaptor2d_HLine2d {
    constructor();
  }

  export declare class Handle_Adaptor2d_HLine2d_2 extends Handle_Adaptor2d_HLine2d {
    constructor(thePtr: Adaptor2d_HLine2d);
  }

  export declare class Handle_Adaptor2d_HLine2d_3 extends Handle_Adaptor2d_HLine2d {
    constructor(theHandle: Handle_Adaptor2d_HLine2d);
  }

  export declare class Handle_Adaptor2d_HLine2d_4 extends Handle_Adaptor2d_HLine2d {
    constructor(theHandle: Handle_Adaptor2d_HLine2d);
  }

export declare class Adaptor2d_Line2d extends Adaptor2d_Curve2d {
  Load_1(L: gp_Lin2d): void;
  Load_2(L: gp_Lin2d, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(X: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(X: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(X: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(X: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(X: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

  export declare class Adaptor2d_Line2d_1 extends Adaptor2d_Line2d {
    constructor();
  }

  export declare class Adaptor2d_Line2d_2 extends Adaptor2d_Line2d {
    constructor(P: gp_Pnt2d, D: gp_Dir2d, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose);
  }

export declare class Handle_Adaptor2d_HOffsetCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Adaptor2d_HOffsetCurve): void;
  get(): Adaptor2d_HOffsetCurve;
  delete(): void;
}

  export declare class Handle_Adaptor2d_HOffsetCurve_1 extends Handle_Adaptor2d_HOffsetCurve {
    constructor();
  }

  export declare class Handle_Adaptor2d_HOffsetCurve_2 extends Handle_Adaptor2d_HOffsetCurve {
    constructor(thePtr: Adaptor2d_HOffsetCurve);
  }

  export declare class Handle_Adaptor2d_HOffsetCurve_3 extends Handle_Adaptor2d_HOffsetCurve {
    constructor(theHandle: Handle_Adaptor2d_HOffsetCurve);
  }

  export declare class Handle_Adaptor2d_HOffsetCurve_4 extends Handle_Adaptor2d_HOffsetCurve {
    constructor(theHandle: Handle_Adaptor2d_HOffsetCurve);
  }

export declare class Adaptor2d_HOffsetCurve extends Adaptor2d_HCurve2d {
  Set(C: Adaptor2d_OffsetCurve): void;
  Curve2d(): Adaptor2d_Curve2d;
  ChangeCurve2d(): Adaptor2d_OffsetCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Adaptor2d_HOffsetCurve_1 extends Adaptor2d_HOffsetCurve {
    constructor();
  }

  export declare class Adaptor2d_HOffsetCurve_2 extends Adaptor2d_HOffsetCurve {
    constructor(C: Adaptor2d_OffsetCurve);
  }

export declare class Adaptor2d_Curve2d {
  constructor();
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  NbSamples(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

export declare class BRepProj_Projection {
  IsDone(): Standard_Boolean;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Current(): TopoDS_Wire;
  Shape(): TopoDS_Compound;
  delete(): void;
}

  export declare class BRepProj_Projection_1 extends BRepProj_Projection {
    constructor(Wire: TopoDS_Shape, Shape: TopoDS_Shape, D: gp_Dir);
  }

  export declare class BRepProj_Projection_2 extends BRepProj_Projection {
    constructor(Wire: TopoDS_Shape, Shape: TopoDS_Shape, P: gp_Pnt);
  }

export declare class HatchGen_PointsOnElement extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: HatchGen_PointsOnElement): HatchGen_PointsOnElement;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: HatchGen_PointOnElement): void;
  Append_2(theSeq: HatchGen_PointsOnElement): void;
  Prepend_1(theItem: HatchGen_PointOnElement): void;
  Prepend_2(theSeq: HatchGen_PointsOnElement): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: HatchGen_PointOnElement): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: HatchGen_PointsOnElement): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: HatchGen_PointsOnElement): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: HatchGen_PointOnElement): void;
  Split(theIndex: Standard_Integer, theSeq: HatchGen_PointsOnElement): void;
  First(): HatchGen_PointOnElement;
  ChangeFirst(): HatchGen_PointOnElement;
  Last(): HatchGen_PointOnElement;
  ChangeLast(): HatchGen_PointOnElement;
  Value(theIndex: Standard_Integer): HatchGen_PointOnElement;
  ChangeValue(theIndex: Standard_Integer): HatchGen_PointOnElement;
  SetValue(theIndex: Standard_Integer, theItem: HatchGen_PointOnElement): void;
  delete(): void;
}

  export declare class HatchGen_PointsOnElement_1 extends HatchGen_PointsOnElement {
    constructor();
  }

  export declare class HatchGen_PointsOnElement_2 extends HatchGen_PointsOnElement {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HatchGen_PointsOnElement_3 extends HatchGen_PointsOnElement {
    constructor(theOther: HatchGen_PointsOnElement);
  }

export declare class HatchGen_PointOnElement extends HatchGen_IntersectionPoint {
  SetIntersectionType(Type: HatchGen_IntersectionType): void;
  IntersectionType(): HatchGen_IntersectionType;
  IsIdentical(Point: HatchGen_PointOnElement, Confusion: Quantity_AbsorbedDose): Standard_Boolean;
  IsDifferent(Point: HatchGen_PointOnElement, Confusion: Quantity_AbsorbedDose): Standard_Boolean;
  Dump(Index: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class HatchGen_PointOnElement_1 extends HatchGen_PointOnElement {
    constructor();
  }

  export declare class HatchGen_PointOnElement_2 extends HatchGen_PointOnElement {
    constructor(Point: IntRes2d_IntersectionPoint);
  }

export declare class HatchGen_IntersectionPoint {
  SetIndex(Index: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  SetParameter(Parameter: Quantity_AbsorbedDose): void;
  Parameter(): Quantity_AbsorbedDose;
  SetPosition(Position: TopAbs_Orientation): void;
  Position(): TopAbs_Orientation;
  SetStateBefore(State: TopAbs_State): void;
  StateBefore(): TopAbs_State;
  SetStateAfter(State: TopAbs_State): void;
  StateAfter(): TopAbs_State;
  SetSegmentBeginning(State: Standard_Boolean): void;
  SegmentBeginning(): Standard_Boolean;
  SetSegmentEnd(State: Standard_Boolean): void;
  SegmentEnd(): Standard_Boolean;
  Dump(Index: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type HatchGen_ErrorStatus = {
  HatchGen_NoProblem: {};
  HatchGen_TrimFailure: {};
  HatchGen_TransitionFailure: {};
  HatchGen_IncoherentParity: {};
  HatchGen_IncompatibleStates: {};
}

export declare class HatchGen_PointsOnHatching extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: HatchGen_PointsOnHatching): HatchGen_PointsOnHatching;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: HatchGen_PointOnHatching): void;
  Append_2(theSeq: HatchGen_PointsOnHatching): void;
  Prepend_1(theItem: HatchGen_PointOnHatching): void;
  Prepend_2(theSeq: HatchGen_PointsOnHatching): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: HatchGen_PointOnHatching): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: HatchGen_PointsOnHatching): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: HatchGen_PointsOnHatching): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: HatchGen_PointOnHatching): void;
  Split(theIndex: Standard_Integer, theSeq: HatchGen_PointsOnHatching): void;
  First(): HatchGen_PointOnHatching;
  ChangeFirst(): HatchGen_PointOnHatching;
  Last(): HatchGen_PointOnHatching;
  ChangeLast(): HatchGen_PointOnHatching;
  Value(theIndex: Standard_Integer): HatchGen_PointOnHatching;
  ChangeValue(theIndex: Standard_Integer): HatchGen_PointOnHatching;
  SetValue(theIndex: Standard_Integer, theItem: HatchGen_PointOnHatching): void;
  delete(): void;
}

  export declare class HatchGen_PointsOnHatching_1 extends HatchGen_PointsOnHatching {
    constructor();
  }

  export declare class HatchGen_PointsOnHatching_2 extends HatchGen_PointsOnHatching {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HatchGen_PointsOnHatching_3 extends HatchGen_PointsOnHatching {
    constructor(theOther: HatchGen_PointsOnHatching);
  }

export declare type HatchGen_IntersectionType = {
  HatchGen_TRUE: {};
  HatchGen_TOUCH: {};
  HatchGen_TANGENT: {};
  HatchGen_UNDETERMINED: {};
}

export declare class HatchGen_Domain {
  SetPoints_1(P1: HatchGen_PointOnHatching, P2: HatchGen_PointOnHatching): void;
  SetPoints_2(): void;
  SetFirstPoint_1(P: HatchGen_PointOnHatching): void;
  SetFirstPoint_2(): void;
  SetSecondPoint_1(P: HatchGen_PointOnHatching): void;
  SetSecondPoint_2(): void;
  HasFirstPoint(): Standard_Boolean;
  FirstPoint(): HatchGen_PointOnHatching;
  HasSecondPoint(): Standard_Boolean;
  SecondPoint(): HatchGen_PointOnHatching;
  Dump(Index: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class HatchGen_Domain_1 extends HatchGen_Domain {
    constructor();
  }

  export declare class HatchGen_Domain_2 extends HatchGen_Domain {
    constructor(P1: HatchGen_PointOnHatching, P2: HatchGen_PointOnHatching);
  }

  export declare class HatchGen_Domain_3 extends HatchGen_Domain {
    constructor(P: HatchGen_PointOnHatching, First: Standard_Boolean);
  }

export declare class HatchGen_Domains extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: HatchGen_Domains): HatchGen_Domains;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: HatchGen_Domain): void;
  Append_2(theSeq: HatchGen_Domains): void;
  Prepend_1(theItem: HatchGen_Domain): void;
  Prepend_2(theSeq: HatchGen_Domains): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: HatchGen_Domain): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: HatchGen_Domains): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: HatchGen_Domains): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: HatchGen_Domain): void;
  Split(theIndex: Standard_Integer, theSeq: HatchGen_Domains): void;
  First(): HatchGen_Domain;
  ChangeFirst(): HatchGen_Domain;
  Last(): HatchGen_Domain;
  ChangeLast(): HatchGen_Domain;
  Value(theIndex: Standard_Integer): HatchGen_Domain;
  ChangeValue(theIndex: Standard_Integer): HatchGen_Domain;
  SetValue(theIndex: Standard_Integer, theItem: HatchGen_Domain): void;
  delete(): void;
}

  export declare class HatchGen_Domains_1 extends HatchGen_Domains {
    constructor();
  }

  export declare class HatchGen_Domains_2 extends HatchGen_Domains {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HatchGen_Domains_3 extends HatchGen_Domains {
    constructor(theOther: HatchGen_Domains);
  }

export declare class HatchGen_PointOnHatching extends HatchGen_IntersectionPoint {
  AddPoint(Point: HatchGen_PointOnElement, Confusion: Quantity_AbsorbedDose): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): HatchGen_PointOnElement;
  RemPoint(Index: Graphic3d_ZLayerId): void;
  ClrPoints(): void;
  IsLower(Point: HatchGen_PointOnHatching, Confusion: Quantity_AbsorbedDose): Standard_Boolean;
  IsEqual(Point: HatchGen_PointOnHatching, Confusion: Quantity_AbsorbedDose): Standard_Boolean;
  IsGreater(Point: HatchGen_PointOnHatching, Confusion: Quantity_AbsorbedDose): Standard_Boolean;
  Dump(Index: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class HatchGen_PointOnHatching_1 extends HatchGen_PointOnHatching {
    constructor();
  }

  export declare class HatchGen_PointOnHatching_2 extends HatchGen_PointOnHatching {
    constructor(Point: IntRes2d_IntersectionPoint);
  }

export declare class IMeshData_PCurve extends IMeshData_ParametersList {
  InsertPoint(thePosition: Graphic3d_ZLayerId, thePoint: gp_Pnt2d, theParamOnPCurve: Quantity_AbsorbedDose): void;
  AddPoint(thePoint: gp_Pnt2d, theParamOnPCurve: Quantity_AbsorbedDose): void;
  GetPoint(theIndex: Graphic3d_ZLayerId): gp_Pnt2d;
  GetIndex(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  RemovePoint(theIndex: Graphic3d_ZLayerId): void;
  IsForward(): Standard_Boolean;
  IsInternal(): Standard_Boolean;
  GetOrientation(): TopAbs_Orientation;
  GetFace(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshData_Curve extends IMeshData_ParametersList {
  InsertPoint(thePosition: Graphic3d_ZLayerId, thePoint: gp_Pnt, theParamOnPCurve: Quantity_AbsorbedDose): void;
  AddPoint(thePoint: gp_Pnt, theParamOnCurve: Quantity_AbsorbedDose): void;
  GetPoint(theIndex: Graphic3d_ZLayerId): gp_Pnt;
  RemovePoint(theIndex: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshData_StatusOwner {
  IsEqual(theValue: IMeshData_Status): Standard_Boolean;
  IsSet(theValue: IMeshData_Status): Standard_Boolean;
  SetStatus(theValue: IMeshData_Status): void;
  UnsetStatus(theValue: IMeshData_Status): void;
  GetStatusMask(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IMeshData_Shape extends Standard_Transient {
  SetShape(theShape: TopoDS_Shape): void;
  GetShape(): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshData_TessellatedShape extends IMeshData_Shape {
  GetDeflection(): Quantity_AbsorbedDose;
  SetDeflection(theValue: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshData_Model extends IMeshData_Shape {
  GetMaxSize(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  FacesNb(): Graphic3d_ZLayerId;
  AddFace(theFace: TopoDS_Face): any;
  GetFace(theIndex: Graphic3d_ZLayerId): any;
  EdgesNb(): Graphic3d_ZLayerId;
  AddEdge(theEdge: TopoDS_Edge): any;
  GetEdge(theIndex: Graphic3d_ZLayerId): any;
  delete(): void;
}

export declare class IMeshData_ParametersList extends Standard_Transient {
  GetParameter(theIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ParametersNb(): Graphic3d_ZLayerId;
  Clear(isKeepEndPoints: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type IMeshData_Status = {
  IMeshData_NoError: {};
  IMeshData_OpenWire: {};
  IMeshData_SelfIntersectingWire: {};
  IMeshData_Failure: {};
  IMeshData_ReMesh: {};
  IMeshData_UnorientedWire: {};
  IMeshData_TooFewPoints: {};
  IMeshData_Outdated: {};
  IMeshData_Reused: {};
  IMeshData_UserBreak: {};
}

export declare class Handle_XmlMNaming_NamingDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMNaming_NamingDriver): void;
  get(): XmlMNaming_NamingDriver;
  delete(): void;
}

  export declare class Handle_XmlMNaming_NamingDriver_1 extends Handle_XmlMNaming_NamingDriver {
    constructor();
  }

  export declare class Handle_XmlMNaming_NamingDriver_2 extends Handle_XmlMNaming_NamingDriver {
    constructor(thePtr: XmlMNaming_NamingDriver);
  }

  export declare class Handle_XmlMNaming_NamingDriver_3 extends Handle_XmlMNaming_NamingDriver {
    constructor(theHandle: Handle_XmlMNaming_NamingDriver);
  }

  export declare class Handle_XmlMNaming_NamingDriver_4 extends Handle_XmlMNaming_NamingDriver {
    constructor(theHandle: Handle_XmlMNaming_NamingDriver);
  }

export declare class XmlMNaming_NamingDriver extends XmlMDF_ADriver {
  constructor(aMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMNaming_NamedShapeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMNaming_NamedShapeDriver): void;
  get(): XmlMNaming_NamedShapeDriver;
  delete(): void;
}

  export declare class Handle_XmlMNaming_NamedShapeDriver_1 extends Handle_XmlMNaming_NamedShapeDriver {
    constructor();
  }

  export declare class Handle_XmlMNaming_NamedShapeDriver_2 extends Handle_XmlMNaming_NamedShapeDriver {
    constructor(thePtr: XmlMNaming_NamedShapeDriver);
  }

  export declare class Handle_XmlMNaming_NamedShapeDriver_3 extends Handle_XmlMNaming_NamedShapeDriver {
    constructor(theHandle: Handle_XmlMNaming_NamedShapeDriver);
  }

  export declare class Handle_XmlMNaming_NamedShapeDriver_4 extends Handle_XmlMNaming_NamedShapeDriver {
    constructor(theHandle: Handle_XmlMNaming_NamedShapeDriver);
  }

export declare class XmlMNaming_NamedShapeDriver extends XmlMDF_ADriver {
  constructor(aMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  ReadShapeSection(anElement: XmlObjMgt_Element, theRange: Message_ProgressRange): void;
  WriteShapeSection(anElement: XmlObjMgt_Element, theRange: Message_ProgressRange): void;
  Clear(): void;
  GetShapesLocations(): TopTools_LocationSet;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMNaming_Shape1 {
  Element_1(): XmlObjMgt_Element;
  Element_2(): XmlObjMgt_Element;
  TShapeId(): Graphic3d_ZLayerId;
  LocId(): Graphic3d_ZLayerId;
  Orientation(): TopAbs_Orientation;
  SetShape(ID: Graphic3d_ZLayerId, LocID: Graphic3d_ZLayerId, Orient: TopAbs_Orientation): void;
  SetVertex(theVertex: TopoDS_Shape): void;
  delete(): void;
}

  export declare class XmlMNaming_Shape1_1 extends XmlMNaming_Shape1 {
    constructor(Doc: XmlObjMgt_Document);
  }

  export declare class XmlMNaming_Shape1_2 extends XmlMNaming_Shape1 {
    constructor(E: XmlObjMgt_Element);
  }

export declare class XmlMNaming {
  constructor();
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, aMessageDriver: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class FilletSurf_Builder {
  constructor(S: TopoDS_Shape, E: TopTools_ListOfShape, R: Quantity_AbsorbedDose, Ta: Quantity_AbsorbedDose, Tapp3d: Quantity_AbsorbedDose, Tapp2d: Quantity_AbsorbedDose)
  Perform(): void;
  Simulate(): void;
  IsDone(): FilletSurf_StatusDone;
  StatusError(): FilletSurf_ErrorTypeStatus;
  NbSurface(): Graphic3d_ZLayerId;
  SurfaceFillet(Index: Graphic3d_ZLayerId): Handle_Geom_Surface;
  TolApp3d(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SupportFace1(Index: Graphic3d_ZLayerId): TopoDS_Face;
  SupportFace2(Index: Graphic3d_ZLayerId): TopoDS_Face;
  CurveOnFace1(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  CurveOnFace2(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  PCurveOnFace1(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurve1OnFillet(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurveOnFace2(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurve2OnFillet(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  StartSectionStatus(): FilletSurf_StatusType;
  EndSectionStatus(): FilletSurf_StatusType;
  NbSection(IndexSurf: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Section(IndexSurf: Graphic3d_ZLayerId, IndexSec: Graphic3d_ZLayerId, Circ: Handle_Geom_TrimmedCurve): void;
  delete(): void;
}

export declare type FilletSurf_StatusType = {
  FilletSurf_TwoExtremityOnEdge: {};
  FilletSurf_OneExtremityOnEdge: {};
  FilletSurf_NoExtremityOnEdge: {};
}

export declare type FilletSurf_ErrorTypeStatus = {
  FilletSurf_EmptyList: {};
  FilletSurf_EdgeNotG1: {};
  FilletSurf_FacesNotG1: {};
  FilletSurf_EdgeNotOnShape: {};
  FilletSurf_NotSharpEdge: {};
  FilletSurf_PbFilletCompute: {};
}

export declare class FilletSurf_InternalBuilder extends ChFi3d_FilBuilder {
  constructor(S: TopoDS_Shape, FShape: ChFi3d_FilletShape, Ta: Quantity_AbsorbedDose, Tapp3d: Quantity_AbsorbedDose, Tapp2d: Quantity_AbsorbedDose)
  Add(E: TopTools_ListOfShape, R: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Perform(): void;
  Done(): Standard_Boolean;
  NbSurface(): Graphic3d_ZLayerId;
  SurfaceFillet(Index: Graphic3d_ZLayerId): Handle_Geom_Surface;
  TolApp3d(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SupportFace1(Index: Graphic3d_ZLayerId): TopoDS_Face;
  SupportFace2(Index: Graphic3d_ZLayerId): TopoDS_Face;
  CurveOnFace1(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  CurveOnFace2(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  PCurveOnFace1(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurve1OnFillet(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurveOnFace2(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  PCurve2OnFillet(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  StartSectionStatus(): FilletSurf_StatusType;
  EndSectionStatus(): FilletSurf_StatusType;
  Simulate(): void;
  NbSection(IndexSurf: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Section(IndexSurf: Graphic3d_ZLayerId, IndexSec: Graphic3d_ZLayerId, Circ: Handle_Geom_TrimmedCurve): void;
  delete(): void;
}

export declare type FilletSurf_StatusDone = {
  FilletSurf_IsOk: {};
  FilletSurf_IsNotOk: {};
  FilletSurf_IsPartial: {};
}

export declare class Handle_StepShape_EdgeCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_EdgeCurve): void;
  get(): StepShape_EdgeCurve;
  delete(): void;
}

  export declare class Handle_StepShape_EdgeCurve_1 extends Handle_StepShape_EdgeCurve {
    constructor();
  }

  export declare class Handle_StepShape_EdgeCurve_2 extends Handle_StepShape_EdgeCurve {
    constructor(thePtr: StepShape_EdgeCurve);
  }

  export declare class Handle_StepShape_EdgeCurve_3 extends Handle_StepShape_EdgeCurve {
    constructor(theHandle: Handle_StepShape_EdgeCurve);
  }

  export declare class Handle_StepShape_EdgeCurve_4 extends Handle_StepShape_EdgeCurve {
    constructor(theHandle: Handle_StepShape_EdgeCurve);
  }

export declare class StepShape_EdgeCurve extends StepShape_Edge {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aEdgeStart: Handle_StepShape_Vertex, aEdgeEnd: Handle_StepShape_Vertex, aEdgeGeometry: Handle_StepGeom_Curve, aSameSense: Standard_Boolean): void;
  SetEdgeGeometry(aEdgeGeometry: Handle_StepGeom_Curve): void;
  EdgeGeometry(): Handle_StepGeom_Curve;
  SetSameSense(aSameSense: Standard_Boolean): void;
  SameSense(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Block {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Block): void;
  get(): StepShape_Block;
  delete(): void;
}

  export declare class Handle_StepShape_Block_1 extends Handle_StepShape_Block {
    constructor();
  }

  export declare class Handle_StepShape_Block_2 extends Handle_StepShape_Block {
    constructor(thePtr: StepShape_Block);
  }

  export declare class Handle_StepShape_Block_3 extends Handle_StepShape_Block {
    constructor(theHandle: Handle_StepShape_Block);
  }

  export declare class Handle_StepShape_Block_4 extends Handle_StepShape_Block {
    constructor(theHandle: Handle_StepShape_Block);
  }

export declare class StepShape_Block extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aX: Quantity_AbsorbedDose, aY: Quantity_AbsorbedDose, aZ: Quantity_AbsorbedDose): void;
  SetPosition(aPosition: Handle_StepGeom_Axis2Placement3d): void;
  Position(): Handle_StepGeom_Axis2Placement3d;
  SetX(aX: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  SetY(aY: Quantity_AbsorbedDose): void;
  Y(): Quantity_AbsorbedDose;
  SetZ(aZ: Quantity_AbsorbedDose): void;
  Z(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_ReversibleTopologyItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Edge(): Handle_StepShape_Edge;
  Path(): Handle_StepShape_Path;
  Face(): Handle_StepShape_Face;
  FaceBound(): Handle_StepShape_FaceBound;
  ClosedShell(): Handle_StepShape_ClosedShell;
  OpenShell(): Handle_StepShape_OpenShell;
  delete(): void;
}

export declare class Handle_StepShape_DimensionalCharacteristicRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DimensionalCharacteristicRepresentation): void;
  get(): StepShape_DimensionalCharacteristicRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_DimensionalCharacteristicRepresentation_1 extends Handle_StepShape_DimensionalCharacteristicRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_DimensionalCharacteristicRepresentation_2 extends Handle_StepShape_DimensionalCharacteristicRepresentation {
    constructor(thePtr: StepShape_DimensionalCharacteristicRepresentation);
  }

  export declare class Handle_StepShape_DimensionalCharacteristicRepresentation_3 extends Handle_StepShape_DimensionalCharacteristicRepresentation {
    constructor(theHandle: Handle_StepShape_DimensionalCharacteristicRepresentation);
  }

  export declare class Handle_StepShape_DimensionalCharacteristicRepresentation_4 extends Handle_StepShape_DimensionalCharacteristicRepresentation {
    constructor(theHandle: Handle_StepShape_DimensionalCharacteristicRepresentation);
  }

export declare class StepShape_DimensionalCharacteristicRepresentation extends Standard_Transient {
  constructor()
  Init(aDimension: StepShape_DimensionalCharacteristic, aRepresentation: Handle_StepShape_ShapeDimensionRepresentation): void;
  Dimension(): StepShape_DimensionalCharacteristic;
  SetDimension(Dimension: StepShape_DimensionalCharacteristic): void;
  Representation(): Handle_StepShape_ShapeDimensionRepresentation;
  SetRepresentation(Representation: Handle_StepShape_ShapeDimensionRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ExtrudedAreaSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ExtrudedAreaSolid): void;
  get(): StepShape_ExtrudedAreaSolid;
  delete(): void;
}

  export declare class Handle_StepShape_ExtrudedAreaSolid_1 extends Handle_StepShape_ExtrudedAreaSolid {
    constructor();
  }

  export declare class Handle_StepShape_ExtrudedAreaSolid_2 extends Handle_StepShape_ExtrudedAreaSolid {
    constructor(thePtr: StepShape_ExtrudedAreaSolid);
  }

  export declare class Handle_StepShape_ExtrudedAreaSolid_3 extends Handle_StepShape_ExtrudedAreaSolid {
    constructor(theHandle: Handle_StepShape_ExtrudedAreaSolid);
  }

  export declare class Handle_StepShape_ExtrudedAreaSolid_4 extends Handle_StepShape_ExtrudedAreaSolid {
    constructor(theHandle: Handle_StepShape_ExtrudedAreaSolid);
  }

export declare class StepShape_ExtrudedAreaSolid extends StepShape_SweptAreaSolid {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepGeom_CurveBoundedSurface, aExtrudedDirection: Handle_StepGeom_Direction, aDepth: Quantity_AbsorbedDose): void;
  SetExtrudedDirection(aExtrudedDirection: Handle_StepGeom_Direction): void;
  ExtrudedDirection(): Handle_StepGeom_Direction;
  SetDepth(aDepth: Quantity_AbsorbedDose): void;
  Depth(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_SweptFaceSolid extends StepShape_SolidModel {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepShape_FaceSurface): void;
  SetSweptFace(aSweptArea: Handle_StepShape_FaceSurface): void;
  SweptFace(): Handle_StepShape_FaceSurface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_SweptFaceSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_SweptFaceSolid): void;
  get(): StepShape_SweptFaceSolid;
  delete(): void;
}

  export declare class Handle_StepShape_SweptFaceSolid_1 extends Handle_StepShape_SweptFaceSolid {
    constructor();
  }

  export declare class Handle_StepShape_SweptFaceSolid_2 extends Handle_StepShape_SweptFaceSolid {
    constructor(thePtr: StepShape_SweptFaceSolid);
  }

  export declare class Handle_StepShape_SweptFaceSolid_3 extends Handle_StepShape_SweptFaceSolid {
    constructor(theHandle: Handle_StepShape_SweptFaceSolid);
  }

  export declare class Handle_StepShape_SweptFaceSolid_4 extends Handle_StepShape_SweptFaceSolid {
    constructor(theHandle: Handle_StepShape_SweptFaceSolid);
  }

export declare class StepShape_DirectedDimensionalLocation extends StepShape_DimensionalLocation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_DirectedDimensionalLocation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DirectedDimensionalLocation): void;
  get(): StepShape_DirectedDimensionalLocation;
  delete(): void;
}

  export declare class Handle_StepShape_DirectedDimensionalLocation_1 extends Handle_StepShape_DirectedDimensionalLocation {
    constructor();
  }

  export declare class Handle_StepShape_DirectedDimensionalLocation_2 extends Handle_StepShape_DirectedDimensionalLocation {
    constructor(thePtr: StepShape_DirectedDimensionalLocation);
  }

  export declare class Handle_StepShape_DirectedDimensionalLocation_3 extends Handle_StepShape_DirectedDimensionalLocation {
    constructor(theHandle: Handle_StepShape_DirectedDimensionalLocation);
  }

  export declare class Handle_StepShape_DirectedDimensionalLocation_4 extends Handle_StepShape_DirectedDimensionalLocation {
    constructor(theHandle: Handle_StepShape_DirectedDimensionalLocation);
  }

export declare class StepShape_GeometricSetSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Point(): Handle_StepGeom_Point;
  Curve(): Handle_StepGeom_Curve;
  Surface(): Handle_StepGeom_Surface;
  delete(): void;
}

export declare class Handle_StepShape_VertexPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_VertexPoint): void;
  get(): StepShape_VertexPoint;
  delete(): void;
}

  export declare class Handle_StepShape_VertexPoint_1 extends Handle_StepShape_VertexPoint {
    constructor();
  }

  export declare class Handle_StepShape_VertexPoint_2 extends Handle_StepShape_VertexPoint {
    constructor(thePtr: StepShape_VertexPoint);
  }

  export declare class Handle_StepShape_VertexPoint_3 extends Handle_StepShape_VertexPoint {
    constructor(theHandle: Handle_StepShape_VertexPoint);
  }

  export declare class Handle_StepShape_VertexPoint_4 extends Handle_StepShape_VertexPoint {
    constructor(theHandle: Handle_StepShape_VertexPoint);
  }

export declare class StepShape_VertexPoint extends StepShape_Vertex {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aVertexGeometry: Handle_StepGeom_Point): void;
  SetVertexGeometry(aVertexGeometry: Handle_StepGeom_Point): void;
  VertexGeometry(): Handle_StepGeom_Point;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_HArray1OfOrientedClosedShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfOrientedClosedShell): void;
  get(): StepShape_HArray1OfOrientedClosedShell;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfOrientedClosedShell_1 extends Handle_StepShape_HArray1OfOrientedClosedShell {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfOrientedClosedShell_2 extends Handle_StepShape_HArray1OfOrientedClosedShell {
    constructor(thePtr: StepShape_HArray1OfOrientedClosedShell);
  }

  export declare class Handle_StepShape_HArray1OfOrientedClosedShell_3 extends Handle_StepShape_HArray1OfOrientedClosedShell {
    constructor(theHandle: Handle_StepShape_HArray1OfOrientedClosedShell);
  }

  export declare class Handle_StepShape_HArray1OfOrientedClosedShell_4 extends Handle_StepShape_HArray1OfOrientedClosedShell {
    constructor(theHandle: Handle_StepShape_HArray1OfOrientedClosedShell);
  }

export declare class StepShape_ManifoldSurfaceShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ManifoldSurfaceShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ManifoldSurfaceShapeRepresentation): void;
  get(): StepShape_ManifoldSurfaceShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_ManifoldSurfaceShapeRepresentation_1 extends Handle_StepShape_ManifoldSurfaceShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_ManifoldSurfaceShapeRepresentation_2 extends Handle_StepShape_ManifoldSurfaceShapeRepresentation {
    constructor(thePtr: StepShape_ManifoldSurfaceShapeRepresentation);
  }

  export declare class Handle_StepShape_ManifoldSurfaceShapeRepresentation_3 extends Handle_StepShape_ManifoldSurfaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ManifoldSurfaceShapeRepresentation);
  }

  export declare class Handle_StepShape_ManifoldSurfaceShapeRepresentation_4 extends Handle_StepShape_ManifoldSurfaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ManifoldSurfaceShapeRepresentation);
  }

export declare class Handle_StepShape_HArray1OfShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfShell): void;
  get(): StepShape_HArray1OfShell;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfShell_1 extends Handle_StepShape_HArray1OfShell {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfShell_2 extends Handle_StepShape_HArray1OfShell {
    constructor(thePtr: StepShape_HArray1OfShell);
  }

  export declare class Handle_StepShape_HArray1OfShell_3 extends Handle_StepShape_HArray1OfShell {
    constructor(theHandle: Handle_StepShape_HArray1OfShell);
  }

  export declare class Handle_StepShape_HArray1OfShell_4 extends Handle_StepShape_HArray1OfShell {
    constructor(theHandle: Handle_StepShape_HArray1OfShell);
  }

export declare class StepShape_RevolvedAreaSolid extends StepShape_SweptAreaSolid {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepGeom_CurveBoundedSurface, aAxis: Handle_StepGeom_Axis1Placement, aAngle: Quantity_AbsorbedDose): void;
  SetAxis(aAxis: Handle_StepGeom_Axis1Placement): void;
  Axis(): Handle_StepGeom_Axis1Placement;
  SetAngle(aAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_RevolvedAreaSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_RevolvedAreaSolid): void;
  get(): StepShape_RevolvedAreaSolid;
  delete(): void;
}

  export declare class Handle_StepShape_RevolvedAreaSolid_1 extends Handle_StepShape_RevolvedAreaSolid {
    constructor();
  }

  export declare class Handle_StepShape_RevolvedAreaSolid_2 extends Handle_StepShape_RevolvedAreaSolid {
    constructor(thePtr: StepShape_RevolvedAreaSolid);
  }

  export declare class Handle_StepShape_RevolvedAreaSolid_3 extends Handle_StepShape_RevolvedAreaSolid {
    constructor(theHandle: Handle_StepShape_RevolvedAreaSolid);
  }

  export declare class Handle_StepShape_RevolvedAreaSolid_4 extends Handle_StepShape_RevolvedAreaSolid {
    constructor(theHandle: Handle_StepShape_RevolvedAreaSolid);
  }

export declare class StepShape_FaceSurface extends StepShape_Face {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBounds: Handle_StepShape_HArray1OfFaceBound, aFaceGeometry: Handle_StepGeom_Surface, aSameSense: Standard_Boolean): void;
  SetFaceGeometry(aFaceGeometry: Handle_StepGeom_Surface): void;
  FaceGeometry(): Handle_StepGeom_Surface;
  SetSameSense(aSameSense: Standard_Boolean): void;
  SameSense(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_FaceSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FaceSurface): void;
  get(): StepShape_FaceSurface;
  delete(): void;
}

  export declare class Handle_StepShape_FaceSurface_1 extends Handle_StepShape_FaceSurface {
    constructor();
  }

  export declare class Handle_StepShape_FaceSurface_2 extends Handle_StepShape_FaceSurface {
    constructor(thePtr: StepShape_FaceSurface);
  }

  export declare class Handle_StepShape_FaceSurface_3 extends Handle_StepShape_FaceSurface {
    constructor(theHandle: Handle_StepShape_FaceSurface);
  }

  export declare class Handle_StepShape_FaceSurface_4 extends Handle_StepShape_FaceSurface {
    constructor(theHandle: Handle_StepShape_FaceSurface);
  }

export declare class Handle_StepShape_FaceBound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FaceBound): void;
  get(): StepShape_FaceBound;
  delete(): void;
}

  export declare class Handle_StepShape_FaceBound_1 extends Handle_StepShape_FaceBound {
    constructor();
  }

  export declare class Handle_StepShape_FaceBound_2 extends Handle_StepShape_FaceBound {
    constructor(thePtr: StepShape_FaceBound);
  }

  export declare class Handle_StepShape_FaceBound_3 extends Handle_StepShape_FaceBound {
    constructor(theHandle: Handle_StepShape_FaceBound);
  }

  export declare class Handle_StepShape_FaceBound_4 extends Handle_StepShape_FaceBound {
    constructor(theHandle: Handle_StepShape_FaceBound);
  }

export declare class StepShape_FaceBound extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBound: Handle_StepShape_Loop, aOrientation: Standard_Boolean): void;
  SetBound(aBound: Handle_StepShape_Loop): void;
  Bound(): Handle_StepShape_Loop;
  SetOrientation(aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_Loop extends StepShape_TopologicalRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Loop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Loop): void;
  get(): StepShape_Loop;
  delete(): void;
}

  export declare class Handle_StepShape_Loop_1 extends Handle_StepShape_Loop {
    constructor();
  }

  export declare class Handle_StepShape_Loop_2 extends Handle_StepShape_Loop {
    constructor(thePtr: StepShape_Loop);
  }

  export declare class Handle_StepShape_Loop_3 extends Handle_StepShape_Loop {
    constructor(theHandle: Handle_StepShape_Loop);
  }

  export declare class Handle_StepShape_Loop_4 extends Handle_StepShape_Loop {
    constructor(theHandle: Handle_StepShape_Loop);
  }

export declare class StepShape_Shell extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  OpenShell(): Handle_StepShape_OpenShell;
  ClosedShell(): Handle_StepShape_ClosedShell;
  delete(): void;
}

export declare class StepShape_HalfSpaceSolid extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBaseSurface: Handle_StepGeom_Surface, aAgreementFlag: Standard_Boolean): void;
  SetBaseSurface(aBaseSurface: Handle_StepGeom_Surface): void;
  BaseSurface(): Handle_StepGeom_Surface;
  SetAgreementFlag(aAgreementFlag: Standard_Boolean): void;
  AgreementFlag(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_HalfSpaceSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HalfSpaceSolid): void;
  get(): StepShape_HalfSpaceSolid;
  delete(): void;
}

  export declare class Handle_StepShape_HalfSpaceSolid_1 extends Handle_StepShape_HalfSpaceSolid {
    constructor();
  }

  export declare class Handle_StepShape_HalfSpaceSolid_2 extends Handle_StepShape_HalfSpaceSolid {
    constructor(thePtr: StepShape_HalfSpaceSolid);
  }

  export declare class Handle_StepShape_HalfSpaceSolid_3 extends Handle_StepShape_HalfSpaceSolid {
    constructor(theHandle: Handle_StepShape_HalfSpaceSolid);
  }

  export declare class Handle_StepShape_HalfSpaceSolid_4 extends Handle_StepShape_HalfSpaceSolid {
    constructor(theHandle: Handle_StepShape_HalfSpaceSolid);
  }

export declare class StepShape_BoxedHalfSpace extends StepShape_HalfSpaceSolid {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBaseSurface: Handle_StepGeom_Surface, aAgreementFlag: Standard_Boolean, aEnclosure: Handle_StepShape_BoxDomain): void;
  SetEnclosure(aEnclosure: Handle_StepShape_BoxDomain): void;
  Enclosure(): Handle_StepShape_BoxDomain;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_BoxedHalfSpace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_BoxedHalfSpace): void;
  get(): StepShape_BoxedHalfSpace;
  delete(): void;
}

  export declare class Handle_StepShape_BoxedHalfSpace_1 extends Handle_StepShape_BoxedHalfSpace {
    constructor();
  }

  export declare class Handle_StepShape_BoxedHalfSpace_2 extends Handle_StepShape_BoxedHalfSpace {
    constructor(thePtr: StepShape_BoxedHalfSpace);
  }

  export declare class Handle_StepShape_BoxedHalfSpace_3 extends Handle_StepShape_BoxedHalfSpace {
    constructor(theHandle: Handle_StepShape_BoxedHalfSpace);
  }

  export declare class Handle_StepShape_BoxedHalfSpace_4 extends Handle_StepShape_BoxedHalfSpace {
    constructor(theHandle: Handle_StepShape_BoxedHalfSpace);
  }

export declare class StepShape_ShapeDimensionRepresentationItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CompoundRepresentationItem(): Handle_StepRepr_CompoundRepresentationItem;
  DescriptiveRepresentationItem(): Handle_StepRepr_DescriptiveRepresentationItem;
  MeasureRepresentationItem(): Handle_StepRepr_MeasureRepresentationItem;
  Placement(): Handle_StepGeom_Placement;
  delete(): void;
}

export declare class Handle_StepShape_FacetedBrepAndBrepWithVoids {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FacetedBrepAndBrepWithVoids): void;
  get(): StepShape_FacetedBrepAndBrepWithVoids;
  delete(): void;
}

  export declare class Handle_StepShape_FacetedBrepAndBrepWithVoids_1 extends Handle_StepShape_FacetedBrepAndBrepWithVoids {
    constructor();
  }

  export declare class Handle_StepShape_FacetedBrepAndBrepWithVoids_2 extends Handle_StepShape_FacetedBrepAndBrepWithVoids {
    constructor(thePtr: StepShape_FacetedBrepAndBrepWithVoids);
  }

  export declare class Handle_StepShape_FacetedBrepAndBrepWithVoids_3 extends Handle_StepShape_FacetedBrepAndBrepWithVoids {
    constructor(theHandle: Handle_StepShape_FacetedBrepAndBrepWithVoids);
  }

  export declare class Handle_StepShape_FacetedBrepAndBrepWithVoids_4 extends Handle_StepShape_FacetedBrepAndBrepWithVoids {
    constructor(theHandle: Handle_StepShape_FacetedBrepAndBrepWithVoids);
  }

export declare class StepShape_FacetedBrepAndBrepWithVoids extends StepShape_ManifoldSolidBrep {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aOuter: Handle_StepShape_ClosedShell, aFacetedBrep: Handle_StepShape_FacetedBrep, aBrepWithVoids: Handle_StepShape_BrepWithVoids): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aOuter: Handle_StepShape_ClosedShell, aVoids: Handle_StepShape_HArray1OfOrientedClosedShell): void;
  SetFacetedBrep(aFacetedBrep: Handle_StepShape_FacetedBrep): void;
  FacetedBrep(): Handle_StepShape_FacetedBrep;
  SetBrepWithVoids(aBrepWithVoids: Handle_StepShape_BrepWithVoids): void;
  BrepWithVoids(): Handle_StepShape_BrepWithVoids;
  SetVoids(aVoids: Handle_StepShape_HArray1OfOrientedClosedShell): void;
  Voids(): Handle_StepShape_HArray1OfOrientedClosedShell;
  VoidsValue(num: Graphic3d_ZLayerId): Handle_StepShape_OrientedClosedShell;
  NbVoids(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ConnectedEdgeSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ConnectedEdgeSet): void;
  get(): StepShape_ConnectedEdgeSet;
  delete(): void;
}

  export declare class Handle_StepShape_ConnectedEdgeSet_1 extends Handle_StepShape_ConnectedEdgeSet {
    constructor();
  }

  export declare class Handle_StepShape_ConnectedEdgeSet_2 extends Handle_StepShape_ConnectedEdgeSet {
    constructor(thePtr: StepShape_ConnectedEdgeSet);
  }

  export declare class Handle_StepShape_ConnectedEdgeSet_3 extends Handle_StepShape_ConnectedEdgeSet {
    constructor(theHandle: Handle_StepShape_ConnectedEdgeSet);
  }

  export declare class Handle_StepShape_ConnectedEdgeSet_4 extends Handle_StepShape_ConnectedEdgeSet {
    constructor(theHandle: Handle_StepShape_ConnectedEdgeSet);
  }

export declare class StepShape_ConnectedEdgeSet extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aCesEdges: Handle_StepShape_HArray1OfEdge): void;
  CesEdges(): Handle_StepShape_HArray1OfEdge;
  SetCesEdges(CesEdges: Handle_StepShape_HArray1OfEdge): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_LoopAndPath {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_LoopAndPath): void;
  get(): StepShape_LoopAndPath;
  delete(): void;
}

  export declare class Handle_StepShape_LoopAndPath_1 extends Handle_StepShape_LoopAndPath {
    constructor();
  }

  export declare class Handle_StepShape_LoopAndPath_2 extends Handle_StepShape_LoopAndPath {
    constructor(thePtr: StepShape_LoopAndPath);
  }

  export declare class Handle_StepShape_LoopAndPath_3 extends Handle_StepShape_LoopAndPath {
    constructor(theHandle: Handle_StepShape_LoopAndPath);
  }

  export declare class Handle_StepShape_LoopAndPath_4 extends Handle_StepShape_LoopAndPath {
    constructor(theHandle: Handle_StepShape_LoopAndPath);
  }

export declare class StepShape_LoopAndPath extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aLoop: Handle_StepShape_Loop, aPath: Handle_StepShape_Path): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  SetLoop(aLoop: Handle_StepShape_Loop): void;
  Loop(): Handle_StepShape_Loop;
  SetPath(aPath: Handle_StepShape_Path): void;
  Path(): Handle_StepShape_Path;
  SetEdgeList(aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  EdgeList(): Handle_StepShape_HArray1OfOrientedEdge;
  EdgeListValue(num: Graphic3d_ZLayerId): Handle_StepShape_OrientedEdge;
  NbEdgeList(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_BrepWithVoids {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_BrepWithVoids): void;
  get(): StepShape_BrepWithVoids;
  delete(): void;
}

  export declare class Handle_StepShape_BrepWithVoids_1 extends Handle_StepShape_BrepWithVoids {
    constructor();
  }

  export declare class Handle_StepShape_BrepWithVoids_2 extends Handle_StepShape_BrepWithVoids {
    constructor(thePtr: StepShape_BrepWithVoids);
  }

  export declare class Handle_StepShape_BrepWithVoids_3 extends Handle_StepShape_BrepWithVoids {
    constructor(theHandle: Handle_StepShape_BrepWithVoids);
  }

  export declare class Handle_StepShape_BrepWithVoids_4 extends Handle_StepShape_BrepWithVoids {
    constructor(theHandle: Handle_StepShape_BrepWithVoids);
  }

export declare class StepShape_BrepWithVoids extends StepShape_ManifoldSolidBrep {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aOuter: Handle_StepShape_ClosedShell, aVoids: Handle_StepShape_HArray1OfOrientedClosedShell): void;
  SetVoids(aVoids: Handle_StepShape_HArray1OfOrientedClosedShell): void;
  Voids(): Handle_StepShape_HArray1OfOrientedClosedShell;
  VoidsValue(num: Graphic3d_ZLayerId): Handle_StepShape_OrientedClosedShell;
  NbVoids(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_NonManifoldSurfaceShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_NonManifoldSurfaceShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_NonManifoldSurfaceShapeRepresentation): void;
  get(): StepShape_NonManifoldSurfaceShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_NonManifoldSurfaceShapeRepresentation_1 extends Handle_StepShape_NonManifoldSurfaceShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_NonManifoldSurfaceShapeRepresentation_2 extends Handle_StepShape_NonManifoldSurfaceShapeRepresentation {
    constructor(thePtr: StepShape_NonManifoldSurfaceShapeRepresentation);
  }

  export declare class Handle_StepShape_NonManifoldSurfaceShapeRepresentation_3 extends Handle_StepShape_NonManifoldSurfaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_NonManifoldSurfaceShapeRepresentation);
  }

  export declare class Handle_StepShape_NonManifoldSurfaceShapeRepresentation_4 extends Handle_StepShape_NonManifoldSurfaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_NonManifoldSurfaceShapeRepresentation);
  }

export declare class Handle_StepShape_RightCircularCone {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_RightCircularCone): void;
  get(): StepShape_RightCircularCone;
  delete(): void;
}

  export declare class Handle_StepShape_RightCircularCone_1 extends Handle_StepShape_RightCircularCone {
    constructor();
  }

  export declare class Handle_StepShape_RightCircularCone_2 extends Handle_StepShape_RightCircularCone {
    constructor(thePtr: StepShape_RightCircularCone);
  }

  export declare class Handle_StepShape_RightCircularCone_3 extends Handle_StepShape_RightCircularCone {
    constructor(theHandle: Handle_StepShape_RightCircularCone);
  }

  export declare class Handle_StepShape_RightCircularCone_4 extends Handle_StepShape_RightCircularCone {
    constructor(theHandle: Handle_StepShape_RightCircularCone);
  }

export declare class StepShape_RightCircularCone extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis1Placement, aHeight: Quantity_AbsorbedDose, aRadius: Quantity_AbsorbedDose, aSemiAngle: Quantity_AbsorbedDose): void;
  SetPosition(aPosition: Handle_StepGeom_Axis1Placement): void;
  Position(): Handle_StepGeom_Axis1Placement;
  SetHeight(aHeight: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  SetSemiAngle(aSemiAngle: Quantity_AbsorbedDose): void;
  SemiAngle(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_RightAngularWedge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_RightAngularWedge): void;
  get(): StepShape_RightAngularWedge;
  delete(): void;
}

  export declare class Handle_StepShape_RightAngularWedge_1 extends Handle_StepShape_RightAngularWedge {
    constructor();
  }

  export declare class Handle_StepShape_RightAngularWedge_2 extends Handle_StepShape_RightAngularWedge {
    constructor(thePtr: StepShape_RightAngularWedge);
  }

  export declare class Handle_StepShape_RightAngularWedge_3 extends Handle_StepShape_RightAngularWedge {
    constructor(theHandle: Handle_StepShape_RightAngularWedge);
  }

  export declare class Handle_StepShape_RightAngularWedge_4 extends Handle_StepShape_RightAngularWedge {
    constructor(theHandle: Handle_StepShape_RightAngularWedge);
  }

export declare class StepShape_RightAngularWedge extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aX: Quantity_AbsorbedDose, aY: Quantity_AbsorbedDose, aZ: Quantity_AbsorbedDose, aLtx: Quantity_AbsorbedDose): void;
  SetPosition(aPosition: Handle_StepGeom_Axis2Placement3d): void;
  Position(): Handle_StepGeom_Axis2Placement3d;
  SetX(aX: Quantity_AbsorbedDose): void;
  X(): Quantity_AbsorbedDose;
  SetY(aY: Quantity_AbsorbedDose): void;
  Y(): Quantity_AbsorbedDose;
  SetZ(aZ: Quantity_AbsorbedDose): void;
  Z(): Quantity_AbsorbedDose;
  SetLtx(aLtx: Quantity_AbsorbedDose): void;
  Ltx(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_RevolvedFaceSolid extends StepShape_SweptFaceSolid {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepShape_FaceSurface): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepShape_FaceSurface, aAxis: Handle_StepGeom_Axis1Placement, aAngle: Quantity_AbsorbedDose): void;
  SetAxis(aAxis: Handle_StepGeom_Axis1Placement): void;
  Axis(): Handle_StepGeom_Axis1Placement;
  SetAngle(aAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_RevolvedFaceSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_RevolvedFaceSolid): void;
  get(): StepShape_RevolvedFaceSolid;
  delete(): void;
}

  export declare class Handle_StepShape_RevolvedFaceSolid_1 extends Handle_StepShape_RevolvedFaceSolid {
    constructor();
  }

  export declare class Handle_StepShape_RevolvedFaceSolid_2 extends Handle_StepShape_RevolvedFaceSolid {
    constructor(thePtr: StepShape_RevolvedFaceSolid);
  }

  export declare class Handle_StepShape_RevolvedFaceSolid_3 extends Handle_StepShape_RevolvedFaceSolid {
    constructor(theHandle: Handle_StepShape_RevolvedFaceSolid);
  }

  export declare class Handle_StepShape_RevolvedFaceSolid_4 extends Handle_StepShape_RevolvedFaceSolid {
    constructor(theHandle: Handle_StepShape_RevolvedFaceSolid);
  }

export declare class StepShape_TransitionalShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_TransitionalShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_TransitionalShapeRepresentation): void;
  get(): StepShape_TransitionalShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_TransitionalShapeRepresentation_1 extends Handle_StepShape_TransitionalShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_TransitionalShapeRepresentation_2 extends Handle_StepShape_TransitionalShapeRepresentation {
    constructor(thePtr: StepShape_TransitionalShapeRepresentation);
  }

  export declare class Handle_StepShape_TransitionalShapeRepresentation_3 extends Handle_StepShape_TransitionalShapeRepresentation {
    constructor(theHandle: Handle_StepShape_TransitionalShapeRepresentation);
  }

  export declare class Handle_StepShape_TransitionalShapeRepresentation_4 extends Handle_StepShape_TransitionalShapeRepresentation {
    constructor(theHandle: Handle_StepShape_TransitionalShapeRepresentation);
  }

export declare class Handle_StepShape_Path {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Path): void;
  get(): StepShape_Path;
  delete(): void;
}

  export declare class Handle_StepShape_Path_1 extends Handle_StepShape_Path {
    constructor();
  }

  export declare class Handle_StepShape_Path_2 extends Handle_StepShape_Path {
    constructor(thePtr: StepShape_Path);
  }

  export declare class Handle_StepShape_Path_3 extends Handle_StepShape_Path {
    constructor(theHandle: Handle_StepShape_Path);
  }

  export declare class Handle_StepShape_Path_4 extends Handle_StepShape_Path {
    constructor(theHandle: Handle_StepShape_Path);
  }

export declare class StepShape_Path extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  SetEdgeList(aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  EdgeList(): Handle_StepShape_HArray1OfOrientedEdge;
  EdgeListValue(num: Graphic3d_ZLayerId): Handle_StepShape_OrientedEdge;
  NbEdgeList(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_HArray1OfFaceBound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfFaceBound): void;
  get(): StepShape_HArray1OfFaceBound;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfFaceBound_1 extends Handle_StepShape_HArray1OfFaceBound {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfFaceBound_2 extends Handle_StepShape_HArray1OfFaceBound {
    constructor(thePtr: StepShape_HArray1OfFaceBound);
  }

  export declare class Handle_StepShape_HArray1OfFaceBound_3 extends Handle_StepShape_HArray1OfFaceBound {
    constructor(theHandle: Handle_StepShape_HArray1OfFaceBound);
  }

  export declare class Handle_StepShape_HArray1OfFaceBound_4 extends Handle_StepShape_HArray1OfFaceBound {
    constructor(theHandle: Handle_StepShape_HArray1OfFaceBound);
  }

export declare type StepShape_AngleRelator = {
  StepShape_Equal: {};
  StepShape_Large: {};
  StepShape_Small: {};
}

export declare class Handle_StepShape_HArray1OfValueQualifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfValueQualifier): void;
  get(): StepShape_HArray1OfValueQualifier;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfValueQualifier_1 extends Handle_StepShape_HArray1OfValueQualifier {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfValueQualifier_2 extends Handle_StepShape_HArray1OfValueQualifier {
    constructor(thePtr: StepShape_HArray1OfValueQualifier);
  }

  export declare class Handle_StepShape_HArray1OfValueQualifier_3 extends Handle_StepShape_HArray1OfValueQualifier {
    constructor(theHandle: Handle_StepShape_HArray1OfValueQualifier);
  }

  export declare class Handle_StepShape_HArray1OfValueQualifier_4 extends Handle_StepShape_HArray1OfValueQualifier {
    constructor(theHandle: Handle_StepShape_HArray1OfValueQualifier);
  }

export declare class Handle_StepShape_AngularLocation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_AngularLocation): void;
  get(): StepShape_AngularLocation;
  delete(): void;
}

  export declare class Handle_StepShape_AngularLocation_1 extends Handle_StepShape_AngularLocation {
    constructor();
  }

  export declare class Handle_StepShape_AngularLocation_2 extends Handle_StepShape_AngularLocation {
    constructor(thePtr: StepShape_AngularLocation);
  }

  export declare class Handle_StepShape_AngularLocation_3 extends Handle_StepShape_AngularLocation {
    constructor(theHandle: Handle_StepShape_AngularLocation);
  }

  export declare class Handle_StepShape_AngularLocation_4 extends Handle_StepShape_AngularLocation {
    constructor(theHandle: Handle_StepShape_AngularLocation);
  }

export declare class StepShape_AngularLocation extends StepShape_DimensionalLocation {
  constructor()
  Init(aShapeAspectRelationship_Name: Handle_TCollection_HAsciiString, hasShapeAspectRelationship_Description: Standard_Boolean, aShapeAspectRelationship_Description: Handle_TCollection_HAsciiString, aShapeAspectRelationship_RelatingShapeAspect: Handle_StepRepr_ShapeAspect, aShapeAspectRelationship_RelatedShapeAspect: Handle_StepRepr_ShapeAspect, aAngleSelection: StepShape_AngleRelator): void;
  AngleSelection(): StepShape_AngleRelator;
  SetAngleSelection(AngleSelection: StepShape_AngleRelator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_SweptAreaSolid extends StepShape_SolidModel {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepGeom_CurveBoundedSurface): void;
  SetSweptArea(aSweptArea: Handle_StepGeom_CurveBoundedSurface): void;
  SweptArea(): Handle_StepGeom_CurveBoundedSurface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_SweptAreaSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_SweptAreaSolid): void;
  get(): StepShape_SweptAreaSolid;
  delete(): void;
}

  export declare class Handle_StepShape_SweptAreaSolid_1 extends Handle_StepShape_SweptAreaSolid {
    constructor();
  }

  export declare class Handle_StepShape_SweptAreaSolid_2 extends Handle_StepShape_SweptAreaSolid {
    constructor(thePtr: StepShape_SweptAreaSolid);
  }

  export declare class Handle_StepShape_SweptAreaSolid_3 extends Handle_StepShape_SweptAreaSolid {
    constructor(theHandle: Handle_StepShape_SweptAreaSolid);
  }

  export declare class Handle_StepShape_SweptAreaSolid_4 extends Handle_StepShape_SweptAreaSolid {
    constructor(theHandle: Handle_StepShape_SweptAreaSolid);
  }

export declare class Handle_StepShape_PolyLoop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_PolyLoop): void;
  get(): StepShape_PolyLoop;
  delete(): void;
}

  export declare class Handle_StepShape_PolyLoop_1 extends Handle_StepShape_PolyLoop {
    constructor();
  }

  export declare class Handle_StepShape_PolyLoop_2 extends Handle_StepShape_PolyLoop {
    constructor(thePtr: StepShape_PolyLoop);
  }

  export declare class Handle_StepShape_PolyLoop_3 extends Handle_StepShape_PolyLoop {
    constructor(theHandle: Handle_StepShape_PolyLoop);
  }

  export declare class Handle_StepShape_PolyLoop_4 extends Handle_StepShape_PolyLoop {
    constructor(theHandle: Handle_StepShape_PolyLoop);
  }

export declare class StepShape_PolyLoop extends StepShape_Loop {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPolygon: Handle_StepGeom_HArray1OfCartesianPoint): void;
  SetPolygon(aPolygon: Handle_StepGeom_HArray1OfCartesianPoint): void;
  Polygon(): Handle_StepGeom_HArray1OfCartesianPoint;
  PolygonValue(num: Graphic3d_ZLayerId): Handle_StepGeom_CartesianPoint;
  NbPolygon(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_CompoundShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_CompoundShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_CompoundShapeRepresentation): void;
  get(): StepShape_CompoundShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_CompoundShapeRepresentation_1 extends Handle_StepShape_CompoundShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_CompoundShapeRepresentation_2 extends Handle_StepShape_CompoundShapeRepresentation {
    constructor(thePtr: StepShape_CompoundShapeRepresentation);
  }

  export declare class Handle_StepShape_CompoundShapeRepresentation_3 extends Handle_StepShape_CompoundShapeRepresentation {
    constructor(theHandle: Handle_StepShape_CompoundShapeRepresentation);
  }

  export declare class Handle_StepShape_CompoundShapeRepresentation_4 extends Handle_StepShape_CompoundShapeRepresentation {
    constructor(theHandle: Handle_StepShape_CompoundShapeRepresentation);
  }

export declare class StepShape_EdgeBasedWireframeShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_EdgeBasedWireframeShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_EdgeBasedWireframeShapeRepresentation): void;
  get(): StepShape_EdgeBasedWireframeShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_EdgeBasedWireframeShapeRepresentation_1 extends Handle_StepShape_EdgeBasedWireframeShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_EdgeBasedWireframeShapeRepresentation_2 extends Handle_StepShape_EdgeBasedWireframeShapeRepresentation {
    constructor(thePtr: StepShape_EdgeBasedWireframeShapeRepresentation);
  }

  export declare class Handle_StepShape_EdgeBasedWireframeShapeRepresentation_3 extends Handle_StepShape_EdgeBasedWireframeShapeRepresentation {
    constructor(theHandle: Handle_StepShape_EdgeBasedWireframeShapeRepresentation);
  }

  export declare class Handle_StepShape_EdgeBasedWireframeShapeRepresentation_4 extends Handle_StepShape_EdgeBasedWireframeShapeRepresentation {
    constructor(theHandle: Handle_StepShape_EdgeBasedWireframeShapeRepresentation);
  }

export declare class Handle_StepShape_HArray1OfEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfEdge): void;
  get(): StepShape_HArray1OfEdge;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfEdge_1 extends Handle_StepShape_HArray1OfEdge {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfEdge_2 extends Handle_StepShape_HArray1OfEdge {
    constructor(thePtr: StepShape_HArray1OfEdge);
  }

  export declare class Handle_StepShape_HArray1OfEdge_3 extends Handle_StepShape_HArray1OfEdge {
    constructor(theHandle: Handle_StepShape_HArray1OfEdge);
  }

  export declare class Handle_StepShape_HArray1OfEdge_4 extends Handle_StepShape_HArray1OfEdge {
    constructor(theHandle: Handle_StepShape_HArray1OfEdge);
  }

export declare class Handle_StepShape_OrientedPath {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_OrientedPath): void;
  get(): StepShape_OrientedPath;
  delete(): void;
}

  export declare class Handle_StepShape_OrientedPath_1 extends Handle_StepShape_OrientedPath {
    constructor();
  }

  export declare class Handle_StepShape_OrientedPath_2 extends Handle_StepShape_OrientedPath {
    constructor(thePtr: StepShape_OrientedPath);
  }

  export declare class Handle_StepShape_OrientedPath_3 extends Handle_StepShape_OrientedPath {
    constructor(theHandle: Handle_StepShape_OrientedPath);
  }

  export declare class Handle_StepShape_OrientedPath_4 extends Handle_StepShape_OrientedPath {
    constructor(theHandle: Handle_StepShape_OrientedPath);
  }

export declare class StepShape_OrientedPath extends StepShape_Path {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPathElement: Handle_StepShape_EdgeLoop, aOrientation: Standard_Boolean): void;
  SetPathElement(aPathElement: Handle_StepShape_EdgeLoop): void;
  PathElement(): Handle_StepShape_EdgeLoop;
  SetOrientation(aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  SetEdgeList(aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  EdgeList(): Handle_StepShape_HArray1OfOrientedEdge;
  EdgeListValue(num: Graphic3d_ZLayerId): Handle_StepShape_OrientedEdge;
  NbEdgeList(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Subface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Subface): void;
  get(): StepShape_Subface;
  delete(): void;
}

  export declare class Handle_StepShape_Subface_1 extends Handle_StepShape_Subface {
    constructor();
  }

  export declare class Handle_StepShape_Subface_2 extends Handle_StepShape_Subface {
    constructor(thePtr: StepShape_Subface);
  }

  export declare class Handle_StepShape_Subface_3 extends Handle_StepShape_Subface {
    constructor(theHandle: Handle_StepShape_Subface);
  }

  export declare class Handle_StepShape_Subface_4 extends Handle_StepShape_Subface {
    constructor(theHandle: Handle_StepShape_Subface);
  }

export declare class StepShape_Subface extends StepShape_Face {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFace_Bounds: Handle_StepShape_HArray1OfFaceBound, aParentFace: Handle_StepShape_Face): void;
  ParentFace(): Handle_StepShape_Face;
  SetParentFace(ParentFace: Handle_StepShape_Face): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_DimensionalLocation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DimensionalLocation): void;
  get(): StepShape_DimensionalLocation;
  delete(): void;
}

  export declare class Handle_StepShape_DimensionalLocation_1 extends Handle_StepShape_DimensionalLocation {
    constructor();
  }

  export declare class Handle_StepShape_DimensionalLocation_2 extends Handle_StepShape_DimensionalLocation {
    constructor(thePtr: StepShape_DimensionalLocation);
  }

  export declare class Handle_StepShape_DimensionalLocation_3 extends Handle_StepShape_DimensionalLocation {
    constructor(theHandle: Handle_StepShape_DimensionalLocation);
  }

  export declare class Handle_StepShape_DimensionalLocation_4 extends Handle_StepShape_DimensionalLocation {
    constructor(theHandle: Handle_StepShape_DimensionalLocation);
  }

export declare class StepShape_DimensionalLocation extends StepRepr_ShapeAspectRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_CsgPrimitive extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Sphere(): Handle_StepShape_Sphere;
  Block(): Handle_StepShape_Block;
  RightAngularWedge(): Handle_StepShape_RightAngularWedge;
  Torus(): Handle_StepShape_Torus;
  RightCircularCone(): Handle_StepShape_RightCircularCone;
  RightCircularCylinder(): Handle_StepShape_RightCircularCylinder;
  delete(): void;
}

export declare class Handle_StepShape_Sphere {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Sphere): void;
  get(): StepShape_Sphere;
  delete(): void;
}

  export declare class Handle_StepShape_Sphere_1 extends Handle_StepShape_Sphere {
    constructor();
  }

  export declare class Handle_StepShape_Sphere_2 extends Handle_StepShape_Sphere {
    constructor(thePtr: StepShape_Sphere);
  }

  export declare class Handle_StepShape_Sphere_3 extends Handle_StepShape_Sphere {
    constructor(theHandle: Handle_StepShape_Sphere);
  }

  export declare class Handle_StepShape_Sphere_4 extends Handle_StepShape_Sphere {
    constructor(theHandle: Handle_StepShape_Sphere);
  }

export declare class StepShape_Sphere extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aRadius: Quantity_AbsorbedDose, aCentre: Handle_StepGeom_Point): void;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  SetCentre(aCentre: Handle_StepGeom_Point): void;
  Centre(): Handle_StepGeom_Point;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_Array1OfShapeDimensionRepresentationItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepShape_ShapeDimensionRepresentationItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepShape_Array1OfShapeDimensionRepresentationItem): StepShape_Array1OfShapeDimensionRepresentationItem;
  Move(theOther: StepShape_Array1OfShapeDimensionRepresentationItem): StepShape_Array1OfShapeDimensionRepresentationItem;
  First(): StepShape_ShapeDimensionRepresentationItem;
  ChangeFirst(): StepShape_ShapeDimensionRepresentationItem;
  Last(): StepShape_ShapeDimensionRepresentationItem;
  ChangeLast(): StepShape_ShapeDimensionRepresentationItem;
  Value(theIndex: Standard_Integer): StepShape_ShapeDimensionRepresentationItem;
  ChangeValue(theIndex: Standard_Integer): StepShape_ShapeDimensionRepresentationItem;
  SetValue(theIndex: Standard_Integer, theItem: StepShape_ShapeDimensionRepresentationItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepShape_Array1OfShapeDimensionRepresentationItem_1 extends StepShape_Array1OfShapeDimensionRepresentationItem {
    constructor();
  }

  export declare class StepShape_Array1OfShapeDimensionRepresentationItem_2 extends StepShape_Array1OfShapeDimensionRepresentationItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepShape_Array1OfShapeDimensionRepresentationItem_3 extends StepShape_Array1OfShapeDimensionRepresentationItem {
    constructor(theOther: StepShape_Array1OfShapeDimensionRepresentationItem);
  }

  export declare class StepShape_Array1OfShapeDimensionRepresentationItem_4 extends StepShape_Array1OfShapeDimensionRepresentationItem {
    constructor(theOther: StepShape_Array1OfShapeDimensionRepresentationItem);
  }

  export declare class StepShape_Array1OfShapeDimensionRepresentationItem_5 extends StepShape_Array1OfShapeDimensionRepresentationItem {
    constructor(theBegin: StepShape_ShapeDimensionRepresentationItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepShape_ConnectedFaceSubSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ConnectedFaceSubSet): void;
  get(): StepShape_ConnectedFaceSubSet;
  delete(): void;
}

  export declare class Handle_StepShape_ConnectedFaceSubSet_1 extends Handle_StepShape_ConnectedFaceSubSet {
    constructor();
  }

  export declare class Handle_StepShape_ConnectedFaceSubSet_2 extends Handle_StepShape_ConnectedFaceSubSet {
    constructor(thePtr: StepShape_ConnectedFaceSubSet);
  }

  export declare class Handle_StepShape_ConnectedFaceSubSet_3 extends Handle_StepShape_ConnectedFaceSubSet {
    constructor(theHandle: Handle_StepShape_ConnectedFaceSubSet);
  }

  export declare class Handle_StepShape_ConnectedFaceSubSet_4 extends Handle_StepShape_ConnectedFaceSubSet {
    constructor(theHandle: Handle_StepShape_ConnectedFaceSubSet);
  }

export declare class StepShape_ConnectedFaceSubSet extends StepShape_ConnectedFaceSet {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aConnectedFaceSet_CfsFaces: Handle_StepShape_HArray1OfFace, aParentFaceSet: Handle_StepShape_ConnectedFaceSet): void;
  ParentFaceSet(): Handle_StepShape_ConnectedFaceSet;
  SetParentFaceSet(ParentFaceSet: Handle_StepShape_ConnectedFaceSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_HArray1OfConnectedFaceSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfConnectedFaceSet): void;
  get(): StepShape_HArray1OfConnectedFaceSet;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfConnectedFaceSet_1 extends Handle_StepShape_HArray1OfConnectedFaceSet {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfConnectedFaceSet_2 extends Handle_StepShape_HArray1OfConnectedFaceSet {
    constructor(thePtr: StepShape_HArray1OfConnectedFaceSet);
  }

  export declare class Handle_StepShape_HArray1OfConnectedFaceSet_3 extends Handle_StepShape_HArray1OfConnectedFaceSet {
    constructor(theHandle: Handle_StepShape_HArray1OfConnectedFaceSet);
  }

  export declare class Handle_StepShape_HArray1OfConnectedFaceSet_4 extends Handle_StepShape_HArray1OfConnectedFaceSet {
    constructor(theHandle: Handle_StepShape_HArray1OfConnectedFaceSet);
  }

export declare class StepShape_CsgShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_CsgShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_CsgShapeRepresentation): void;
  get(): StepShape_CsgShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_CsgShapeRepresentation_1 extends Handle_StepShape_CsgShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_CsgShapeRepresentation_2 extends Handle_StepShape_CsgShapeRepresentation {
    constructor(thePtr: StepShape_CsgShapeRepresentation);
  }

  export declare class Handle_StepShape_CsgShapeRepresentation_3 extends Handle_StepShape_CsgShapeRepresentation {
    constructor(theHandle: Handle_StepShape_CsgShapeRepresentation);
  }

  export declare class Handle_StepShape_CsgShapeRepresentation_4 extends Handle_StepShape_CsgShapeRepresentation {
    constructor(theHandle: Handle_StepShape_CsgShapeRepresentation);
  }

export declare class StepShape_ContextDependentShapeRepresentation extends Standard_Transient {
  constructor()
  Init(aRepRel: Handle_StepRepr_ShapeRepresentationRelationship, aProRel: Handle_StepRepr_ProductDefinitionShape): void;
  RepresentationRelation(): Handle_StepRepr_ShapeRepresentationRelationship;
  SetRepresentationRelation(aRepRel: Handle_StepRepr_ShapeRepresentationRelationship): void;
  RepresentedProductRelation(): Handle_StepRepr_ProductDefinitionShape;
  SetRepresentedProductRelation(aProRel: Handle_StepRepr_ProductDefinitionShape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ContextDependentShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ContextDependentShapeRepresentation): void;
  get(): StepShape_ContextDependentShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_ContextDependentShapeRepresentation_1 extends Handle_StepShape_ContextDependentShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_ContextDependentShapeRepresentation_2 extends Handle_StepShape_ContextDependentShapeRepresentation {
    constructor(thePtr: StepShape_ContextDependentShapeRepresentation);
  }

  export declare class Handle_StepShape_ContextDependentShapeRepresentation_3 extends Handle_StepShape_ContextDependentShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ContextDependentShapeRepresentation);
  }

  export declare class Handle_StepShape_ContextDependentShapeRepresentation_4 extends Handle_StepShape_ContextDependentShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ContextDependentShapeRepresentation);
  }

export declare class StepShape_CsgSelect {
  constructor()
  SetTypeOfContent(aTypeOfContent: Graphic3d_ZLayerId): void;
  TypeOfContent(): Graphic3d_ZLayerId;
  BooleanResult(): Handle_StepShape_BooleanResult;
  SetBooleanResult(aBooleanResult: Handle_StepShape_BooleanResult): void;
  CsgPrimitive(): StepShape_CsgPrimitive;
  SetCsgPrimitive(aCsgPrimitive: StepShape_CsgPrimitive): void;
  delete(): void;
}

export declare class StepShape_Array1OfValueQualifier {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepShape_ValueQualifier): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepShape_Array1OfValueQualifier): StepShape_Array1OfValueQualifier;
  Move(theOther: StepShape_Array1OfValueQualifier): StepShape_Array1OfValueQualifier;
  First(): StepShape_ValueQualifier;
  ChangeFirst(): StepShape_ValueQualifier;
  Last(): StepShape_ValueQualifier;
  ChangeLast(): StepShape_ValueQualifier;
  Value(theIndex: Standard_Integer): StepShape_ValueQualifier;
  ChangeValue(theIndex: Standard_Integer): StepShape_ValueQualifier;
  SetValue(theIndex: Standard_Integer, theItem: StepShape_ValueQualifier): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepShape_Array1OfValueQualifier_1 extends StepShape_Array1OfValueQualifier {
    constructor();
  }

  export declare class StepShape_Array1OfValueQualifier_2 extends StepShape_Array1OfValueQualifier {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepShape_Array1OfValueQualifier_3 extends StepShape_Array1OfValueQualifier {
    constructor(theOther: StepShape_Array1OfValueQualifier);
  }

  export declare class StepShape_Array1OfValueQualifier_4 extends StepShape_Array1OfValueQualifier {
    constructor(theOther: StepShape_Array1OfValueQualifier);
  }

  export declare class StepShape_Array1OfValueQualifier_5 extends StepShape_Array1OfValueQualifier {
    constructor(theBegin: StepShape_ValueQualifier, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepShape_HArray1OfFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfFace): void;
  get(): StepShape_HArray1OfFace;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfFace_1 extends Handle_StepShape_HArray1OfFace {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfFace_2 extends Handle_StepShape_HArray1OfFace {
    constructor(thePtr: StepShape_HArray1OfFace);
  }

  export declare class Handle_StepShape_HArray1OfFace_3 extends Handle_StepShape_HArray1OfFace {
    constructor(theHandle: Handle_StepShape_HArray1OfFace);
  }

  export declare class Handle_StepShape_HArray1OfFace_4 extends Handle_StepShape_HArray1OfFace {
    constructor(theHandle: Handle_StepShape_HArray1OfFace);
  }

export declare class Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DefinitionalRepresentationAndShapeRepresentation): void;
  get(): StepShape_DefinitionalRepresentationAndShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_1 extends Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_2 extends Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation {
    constructor(thePtr: StepShape_DefinitionalRepresentationAndShapeRepresentation);
  }

  export declare class Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_3 extends Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation {
    constructor(theHandle: Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation);
  }

  export declare class Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_4 extends Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation {
    constructor(theHandle: Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation);
  }

export declare class StepShape_DefinitionalRepresentationAndShapeRepresentation extends StepRepr_DefinitionalRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_ManifoldSolidBrep extends StepShape_SolidModel {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aOuter: Handle_StepShape_ClosedShell): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aOuter: Handle_StepShape_ConnectedFaceSet): void;
  SetOuter(aOuter: Handle_StepShape_ConnectedFaceSet): void;
  Outer(): Handle_StepShape_ConnectedFaceSet;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ManifoldSolidBrep {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ManifoldSolidBrep): void;
  get(): StepShape_ManifoldSolidBrep;
  delete(): void;
}

  export declare class Handle_StepShape_ManifoldSolidBrep_1 extends Handle_StepShape_ManifoldSolidBrep {
    constructor();
  }

  export declare class Handle_StepShape_ManifoldSolidBrep_2 extends Handle_StepShape_ManifoldSolidBrep {
    constructor(thePtr: StepShape_ManifoldSolidBrep);
  }

  export declare class Handle_StepShape_ManifoldSolidBrep_3 extends Handle_StepShape_ManifoldSolidBrep {
    constructor(theHandle: Handle_StepShape_ManifoldSolidBrep);
  }

  export declare class Handle_StepShape_ManifoldSolidBrep_4 extends Handle_StepShape_ManifoldSolidBrep {
    constructor(theHandle: Handle_StepShape_ManifoldSolidBrep);
  }

export declare class StepShape_ToleranceMethodDefinition extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ToleranceValue(): Handle_StepShape_ToleranceValue;
  LimitsAndFits(): Handle_StepShape_LimitsAndFits;
  delete(): void;
}

export declare class StepShape_DimensionalLocationWithPath extends StepShape_DimensionalLocation {
  constructor()
  Init(aShapeAspectRelationship_Name: Handle_TCollection_HAsciiString, hasShapeAspectRelationship_Description: Standard_Boolean, aShapeAspectRelationship_Description: Handle_TCollection_HAsciiString, aShapeAspectRelationship_RelatingShapeAspect: Handle_StepRepr_ShapeAspect, aShapeAspectRelationship_RelatedShapeAspect: Handle_StepRepr_ShapeAspect, aPath: Handle_StepRepr_ShapeAspect): void;
  Path(): Handle_StepRepr_ShapeAspect;
  SetPath(Path: Handle_StepRepr_ShapeAspect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_DimensionalLocationWithPath {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DimensionalLocationWithPath): void;
  get(): StepShape_DimensionalLocationWithPath;
  delete(): void;
}

  export declare class Handle_StepShape_DimensionalLocationWithPath_1 extends Handle_StepShape_DimensionalLocationWithPath {
    constructor();
  }

  export declare class Handle_StepShape_DimensionalLocationWithPath_2 extends Handle_StepShape_DimensionalLocationWithPath {
    constructor(thePtr: StepShape_DimensionalLocationWithPath);
  }

  export declare class Handle_StepShape_DimensionalLocationWithPath_3 extends Handle_StepShape_DimensionalLocationWithPath {
    constructor(theHandle: Handle_StepShape_DimensionalLocationWithPath);
  }

  export declare class Handle_StepShape_DimensionalLocationWithPath_4 extends Handle_StepShape_DimensionalLocationWithPath {
    constructor(theHandle: Handle_StepShape_DimensionalLocationWithPath);
  }

export declare class Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_GeometricallyBoundedWireframeShapeRepresentation): void;
  get(): StepShape_GeometricallyBoundedWireframeShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_1 extends Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_2 extends Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation {
    constructor(thePtr: StepShape_GeometricallyBoundedWireframeShapeRepresentation);
  }

  export declare class Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_3 extends Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation {
    constructor(theHandle: Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation);
  }

  export declare class Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_4 extends Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation {
    constructor(theHandle: Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation);
  }

export declare class StepShape_GeometricallyBoundedWireframeShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ExtrudedFaceSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ExtrudedFaceSolid): void;
  get(): StepShape_ExtrudedFaceSolid;
  delete(): void;
}

  export declare class Handle_StepShape_ExtrudedFaceSolid_1 extends Handle_StepShape_ExtrudedFaceSolid {
    constructor();
  }

  export declare class Handle_StepShape_ExtrudedFaceSolid_2 extends Handle_StepShape_ExtrudedFaceSolid {
    constructor(thePtr: StepShape_ExtrudedFaceSolid);
  }

  export declare class Handle_StepShape_ExtrudedFaceSolid_3 extends Handle_StepShape_ExtrudedFaceSolid {
    constructor(theHandle: Handle_StepShape_ExtrudedFaceSolid);
  }

  export declare class Handle_StepShape_ExtrudedFaceSolid_4 extends Handle_StepShape_ExtrudedFaceSolid {
    constructor(theHandle: Handle_StepShape_ExtrudedFaceSolid);
  }

export declare class StepShape_ExtrudedFaceSolid extends StepShape_SweptFaceSolid {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptArea: Handle_StepShape_FaceSurface, aExtrudedDirection: Handle_StepGeom_Direction, aDepth: Quantity_AbsorbedDose): void;
  SetExtrudedDirection(aExtrudedDirection: Handle_StepGeom_Direction): void;
  ExtrudedDirection(): Handle_StepGeom_Direction;
  SetDepth(aDepth: Quantity_AbsorbedDose): void;
  Depth(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_DimensionalSize extends Standard_Transient {
  constructor()
  Init(aAppliesTo: Handle_StepRepr_ShapeAspect, aName: Handle_TCollection_HAsciiString): void;
  AppliesTo(): Handle_StepRepr_ShapeAspect;
  SetAppliesTo(AppliesTo: Handle_StepRepr_ShapeAspect): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_DimensionalSize {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DimensionalSize): void;
  get(): StepShape_DimensionalSize;
  delete(): void;
}

  export declare class Handle_StepShape_DimensionalSize_1 extends Handle_StepShape_DimensionalSize {
    constructor();
  }

  export declare class Handle_StepShape_DimensionalSize_2 extends Handle_StepShape_DimensionalSize {
    constructor(thePtr: StepShape_DimensionalSize);
  }

  export declare class Handle_StepShape_DimensionalSize_3 extends Handle_StepShape_DimensionalSize {
    constructor(theHandle: Handle_StepShape_DimensionalSize);
  }

  export declare class Handle_StepShape_DimensionalSize_4 extends Handle_StepShape_DimensionalSize {
    constructor(theHandle: Handle_StepShape_DimensionalSize);
  }

export declare class Handle_StepShape_GeometricSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_GeometricSet): void;
  get(): StepShape_GeometricSet;
  delete(): void;
}

  export declare class Handle_StepShape_GeometricSet_1 extends Handle_StepShape_GeometricSet {
    constructor();
  }

  export declare class Handle_StepShape_GeometricSet_2 extends Handle_StepShape_GeometricSet {
    constructor(thePtr: StepShape_GeometricSet);
  }

  export declare class Handle_StepShape_GeometricSet_3 extends Handle_StepShape_GeometricSet {
    constructor(theHandle: Handle_StepShape_GeometricSet);
  }

  export declare class Handle_StepShape_GeometricSet_4 extends Handle_StepShape_GeometricSet {
    constructor(theHandle: Handle_StepShape_GeometricSet);
  }

export declare class StepShape_GeometricSet extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aElements: Handle_StepShape_HArray1OfGeometricSetSelect): void;
  SetElements(aElements: Handle_StepShape_HArray1OfGeometricSetSelect): void;
  Elements(): Handle_StepShape_HArray1OfGeometricSetSelect;
  ElementsValue(num: Graphic3d_ZLayerId): StepShape_GeometricSetSelect;
  NbElements(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_PlusMinusTolerance extends Standard_Transient {
  constructor()
  Init(range: StepShape_ToleranceMethodDefinition, toleranced_dimension: StepShape_DimensionalCharacteristic): void;
  Range(): StepShape_ToleranceMethodDefinition;
  SetRange(range: StepShape_ToleranceMethodDefinition): void;
  TolerancedDimension(): StepShape_DimensionalCharacteristic;
  SetTolerancedDimension(toleranced_dimension: StepShape_DimensionalCharacteristic): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_PlusMinusTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_PlusMinusTolerance): void;
  get(): StepShape_PlusMinusTolerance;
  delete(): void;
}

  export declare class Handle_StepShape_PlusMinusTolerance_1 extends Handle_StepShape_PlusMinusTolerance {
    constructor();
  }

  export declare class Handle_StepShape_PlusMinusTolerance_2 extends Handle_StepShape_PlusMinusTolerance {
    constructor(thePtr: StepShape_PlusMinusTolerance);
  }

  export declare class Handle_StepShape_PlusMinusTolerance_3 extends Handle_StepShape_PlusMinusTolerance {
    constructor(theHandle: Handle_StepShape_PlusMinusTolerance);
  }

  export declare class Handle_StepShape_PlusMinusTolerance_4 extends Handle_StepShape_PlusMinusTolerance {
    constructor(theHandle: Handle_StepShape_PlusMinusTolerance);
  }

export declare class Handle_StepShape_LimitsAndFits {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_LimitsAndFits): void;
  get(): StepShape_LimitsAndFits;
  delete(): void;
}

  export declare class Handle_StepShape_LimitsAndFits_1 extends Handle_StepShape_LimitsAndFits {
    constructor();
  }

  export declare class Handle_StepShape_LimitsAndFits_2 extends Handle_StepShape_LimitsAndFits {
    constructor(thePtr: StepShape_LimitsAndFits);
  }

  export declare class Handle_StepShape_LimitsAndFits_3 extends Handle_StepShape_LimitsAndFits {
    constructor(theHandle: Handle_StepShape_LimitsAndFits);
  }

  export declare class Handle_StepShape_LimitsAndFits_4 extends Handle_StepShape_LimitsAndFits {
    constructor(theHandle: Handle_StepShape_LimitsAndFits);
  }

export declare class StepShape_LimitsAndFits extends Standard_Transient {
  constructor()
  Init(form_variance: Handle_TCollection_HAsciiString, zone_variance: Handle_TCollection_HAsciiString, grade: Handle_TCollection_HAsciiString, source: Handle_TCollection_HAsciiString): void;
  FormVariance(): Handle_TCollection_HAsciiString;
  SetFormVariance(form_variance: Handle_TCollection_HAsciiString): void;
  ZoneVariance(): Handle_TCollection_HAsciiString;
  SetZoneVariance(zone_variance: Handle_TCollection_HAsciiString): void;
  Grade(): Handle_TCollection_HAsciiString;
  SetGrade(grade: Handle_TCollection_HAsciiString): void;
  Source(): Handle_TCollection_HAsciiString;
  SetSource(source: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_ShapeRepresentation extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ShapeRepresentation): void;
  get(): StepShape_ShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_ShapeRepresentation_1 extends Handle_StepShape_ShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_ShapeRepresentation_2 extends Handle_StepShape_ShapeRepresentation {
    constructor(thePtr: StepShape_ShapeRepresentation);
  }

  export declare class Handle_StepShape_ShapeRepresentation_3 extends Handle_StepShape_ShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ShapeRepresentation);
  }

  export declare class Handle_StepShape_ShapeRepresentation_4 extends Handle_StepShape_ShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ShapeRepresentation);
  }

export declare class StepShape_SolidModel extends StepGeom_GeometricRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_SolidModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_SolidModel): void;
  get(): StepShape_SolidModel;
  delete(): void;
}

  export declare class Handle_StepShape_SolidModel_1 extends Handle_StepShape_SolidModel {
    constructor();
  }

  export declare class Handle_StepShape_SolidModel_2 extends Handle_StepShape_SolidModel {
    constructor(thePtr: StepShape_SolidModel);
  }

  export declare class Handle_StepShape_SolidModel_3 extends Handle_StepShape_SolidModel {
    constructor(theHandle: Handle_StepShape_SolidModel);
  }

  export declare class Handle_StepShape_SolidModel_4 extends Handle_StepShape_SolidModel {
    constructor(theHandle: Handle_StepShape_SolidModel);
  }

export declare class StepShape_PrecisionQualifier extends Standard_Transient {
  constructor()
  Init(precision_value: Graphic3d_ZLayerId): void;
  PrecisionValue(): Graphic3d_ZLayerId;
  SetPrecisionValue(precision_value: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_PrecisionQualifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_PrecisionQualifier): void;
  get(): StepShape_PrecisionQualifier;
  delete(): void;
}

  export declare class Handle_StepShape_PrecisionQualifier_1 extends Handle_StepShape_PrecisionQualifier {
    constructor();
  }

  export declare class Handle_StepShape_PrecisionQualifier_2 extends Handle_StepShape_PrecisionQualifier {
    constructor(thePtr: StepShape_PrecisionQualifier);
  }

  export declare class Handle_StepShape_PrecisionQualifier_3 extends Handle_StepShape_PrecisionQualifier {
    constructor(theHandle: Handle_StepShape_PrecisionQualifier);
  }

  export declare class Handle_StepShape_PrecisionQualifier_4 extends Handle_StepShape_PrecisionQualifier {
    constructor(theHandle: Handle_StepShape_PrecisionQualifier);
  }

export declare class Handle_StepShape_FaceOuterBound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FaceOuterBound): void;
  get(): StepShape_FaceOuterBound;
  delete(): void;
}

  export declare class Handle_StepShape_FaceOuterBound_1 extends Handle_StepShape_FaceOuterBound {
    constructor();
  }

  export declare class Handle_StepShape_FaceOuterBound_2 extends Handle_StepShape_FaceOuterBound {
    constructor(thePtr: StepShape_FaceOuterBound);
  }

  export declare class Handle_StepShape_FaceOuterBound_3 extends Handle_StepShape_FaceOuterBound {
    constructor(theHandle: Handle_StepShape_FaceOuterBound);
  }

  export declare class Handle_StepShape_FaceOuterBound_4 extends Handle_StepShape_FaceOuterBound {
    constructor(theHandle: Handle_StepShape_FaceOuterBound);
  }

export declare class StepShape_FaceOuterBound extends StepShape_FaceBound {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_SolidReplica extends StepShape_SolidModel {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aParentSolid: Handle_StepShape_SolidModel, aTransformation: Handle_StepGeom_CartesianTransformationOperator3d): void;
  SetParentSolid(aParentSolid: Handle_StepShape_SolidModel): void;
  ParentSolid(): Handle_StepShape_SolidModel;
  SetTransformation(aTransformation: Handle_StepGeom_CartesianTransformationOperator3d): void;
  Transformation(): Handle_StepGeom_CartesianTransformationOperator3d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_SolidReplica {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_SolidReplica): void;
  get(): StepShape_SolidReplica;
  delete(): void;
}

  export declare class Handle_StepShape_SolidReplica_1 extends Handle_StepShape_SolidReplica {
    constructor();
  }

  export declare class Handle_StepShape_SolidReplica_2 extends Handle_StepShape_SolidReplica {
    constructor(thePtr: StepShape_SolidReplica);
  }

  export declare class Handle_StepShape_SolidReplica_3 extends Handle_StepShape_SolidReplica {
    constructor(theHandle: Handle_StepShape_SolidReplica);
  }

  export declare class Handle_StepShape_SolidReplica_4 extends Handle_StepShape_SolidReplica {
    constructor(theHandle: Handle_StepShape_SolidReplica);
  }

export declare class StepShape_ShapeRepresentationWithParameters extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ShapeRepresentationWithParameters {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ShapeRepresentationWithParameters): void;
  get(): StepShape_ShapeRepresentationWithParameters;
  delete(): void;
}

  export declare class Handle_StepShape_ShapeRepresentationWithParameters_1 extends Handle_StepShape_ShapeRepresentationWithParameters {
    constructor();
  }

  export declare class Handle_StepShape_ShapeRepresentationWithParameters_2 extends Handle_StepShape_ShapeRepresentationWithParameters {
    constructor(thePtr: StepShape_ShapeRepresentationWithParameters);
  }

  export declare class Handle_StepShape_ShapeRepresentationWithParameters_3 extends Handle_StepShape_ShapeRepresentationWithParameters {
    constructor(theHandle: Handle_StepShape_ShapeRepresentationWithParameters);
  }

  export declare class Handle_StepShape_ShapeRepresentationWithParameters_4 extends Handle_StepShape_ShapeRepresentationWithParameters {
    constructor(theHandle: Handle_StepShape_ShapeRepresentationWithParameters);
  }

export declare class Handle_StepShape_OrientedOpenShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_OrientedOpenShell): void;
  get(): StepShape_OrientedOpenShell;
  delete(): void;
}

  export declare class Handle_StepShape_OrientedOpenShell_1 extends Handle_StepShape_OrientedOpenShell {
    constructor();
  }

  export declare class Handle_StepShape_OrientedOpenShell_2 extends Handle_StepShape_OrientedOpenShell {
    constructor(thePtr: StepShape_OrientedOpenShell);
  }

  export declare class Handle_StepShape_OrientedOpenShell_3 extends Handle_StepShape_OrientedOpenShell {
    constructor(theHandle: Handle_StepShape_OrientedOpenShell);
  }

  export declare class Handle_StepShape_OrientedOpenShell_4 extends Handle_StepShape_OrientedOpenShell {
    constructor(theHandle: Handle_StepShape_OrientedOpenShell);
  }

export declare class StepShape_OrientedOpenShell extends StepShape_OpenShell {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aOpenShellElement: Handle_StepShape_OpenShell, aOrientation: Standard_Boolean): void;
  SetOpenShellElement(aOpenShellElement: Handle_StepShape_OpenShell): void;
  OpenShellElement(): Handle_StepShape_OpenShell;
  SetOrientation(aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  SetCfsFaces(aCfsFaces: Handle_StepShape_HArray1OfFace): void;
  CfsFaces(): Handle_StepShape_HArray1OfFace;
  CfsFacesValue(num: Graphic3d_ZLayerId): Handle_StepShape_Face;
  NbCfsFaces(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_RightCircularCylinder extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis1Placement, aHeight: Quantity_AbsorbedDose, aRadius: Quantity_AbsorbedDose): void;
  SetPosition(aPosition: Handle_StepGeom_Axis1Placement): void;
  Position(): Handle_StepGeom_Axis1Placement;
  SetHeight(aHeight: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_RightCircularCylinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_RightCircularCylinder): void;
  get(): StepShape_RightCircularCylinder;
  delete(): void;
}

  export declare class Handle_StepShape_RightCircularCylinder_1 extends Handle_StepShape_RightCircularCylinder {
    constructor();
  }

  export declare class Handle_StepShape_RightCircularCylinder_2 extends Handle_StepShape_RightCircularCylinder {
    constructor(thePtr: StepShape_RightCircularCylinder);
  }

  export declare class Handle_StepShape_RightCircularCylinder_3 extends Handle_StepShape_RightCircularCylinder {
    constructor(theHandle: Handle_StepShape_RightCircularCylinder);
  }

  export declare class Handle_StepShape_RightCircularCylinder_4 extends Handle_StepShape_RightCircularCylinder {
    constructor(theHandle: Handle_StepShape_RightCircularCylinder);
  }

export declare class Handle_StepShape_ShapeDefinitionRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ShapeDefinitionRepresentation): void;
  get(): StepShape_ShapeDefinitionRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_ShapeDefinitionRepresentation_1 extends Handle_StepShape_ShapeDefinitionRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_ShapeDefinitionRepresentation_2 extends Handle_StepShape_ShapeDefinitionRepresentation {
    constructor(thePtr: StepShape_ShapeDefinitionRepresentation);
  }

  export declare class Handle_StepShape_ShapeDefinitionRepresentation_3 extends Handle_StepShape_ShapeDefinitionRepresentation {
    constructor(theHandle: Handle_StepShape_ShapeDefinitionRepresentation);
  }

  export declare class Handle_StepShape_ShapeDefinitionRepresentation_4 extends Handle_StepShape_ShapeDefinitionRepresentation {
    constructor(theHandle: Handle_StepShape_ShapeDefinitionRepresentation);
  }

export declare class StepShape_ShapeDefinitionRepresentation extends StepRepr_PropertyDefinitionRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_GeometricCurveSet extends StepShape_GeometricSet {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_GeometricCurveSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_GeometricCurveSet): void;
  get(): StepShape_GeometricCurveSet;
  delete(): void;
}

  export declare class Handle_StepShape_GeometricCurveSet_1 extends Handle_StepShape_GeometricCurveSet {
    constructor();
  }

  export declare class Handle_StepShape_GeometricCurveSet_2 extends Handle_StepShape_GeometricCurveSet {
    constructor(thePtr: StepShape_GeometricCurveSet);
  }

  export declare class Handle_StepShape_GeometricCurveSet_3 extends Handle_StepShape_GeometricCurveSet {
    constructor(theHandle: Handle_StepShape_GeometricCurveSet);
  }

  export declare class Handle_StepShape_GeometricCurveSet_4 extends Handle_StepShape_GeometricCurveSet {
    constructor(theHandle: Handle_StepShape_GeometricCurveSet);
  }

export declare class Handle_StepShape_QualifiedRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_QualifiedRepresentationItem): void;
  get(): StepShape_QualifiedRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepShape_QualifiedRepresentationItem_1 extends Handle_StepShape_QualifiedRepresentationItem {
    constructor();
  }

  export declare class Handle_StepShape_QualifiedRepresentationItem_2 extends Handle_StepShape_QualifiedRepresentationItem {
    constructor(thePtr: StepShape_QualifiedRepresentationItem);
  }

  export declare class Handle_StepShape_QualifiedRepresentationItem_3 extends Handle_StepShape_QualifiedRepresentationItem {
    constructor(theHandle: Handle_StepShape_QualifiedRepresentationItem);
  }

  export declare class Handle_StepShape_QualifiedRepresentationItem_4 extends Handle_StepShape_QualifiedRepresentationItem {
    constructor(theHandle: Handle_StepShape_QualifiedRepresentationItem);
  }

export declare class StepShape_QualifiedRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, qualifiers: Handle_StepShape_HArray1OfValueQualifier): void;
  Qualifiers(): Handle_StepShape_HArray1OfValueQualifier;
  NbQualifiers(): Graphic3d_ZLayerId;
  SetQualifiers(qualifiers: Handle_StepShape_HArray1OfValueQualifier): void;
  QualifiersValue(num: Graphic3d_ZLayerId): StepShape_ValueQualifier;
  SetQualifiersValue(num: Graphic3d_ZLayerId, aqualifier: StepShape_ValueQualifier): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_OrientedFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_OrientedFace): void;
  get(): StepShape_OrientedFace;
  delete(): void;
}

  export declare class Handle_StepShape_OrientedFace_1 extends Handle_StepShape_OrientedFace {
    constructor();
  }

  export declare class Handle_StepShape_OrientedFace_2 extends Handle_StepShape_OrientedFace {
    constructor(thePtr: StepShape_OrientedFace);
  }

  export declare class Handle_StepShape_OrientedFace_3 extends Handle_StepShape_OrientedFace {
    constructor(theHandle: Handle_StepShape_OrientedFace);
  }

  export declare class Handle_StepShape_OrientedFace_4 extends Handle_StepShape_OrientedFace {
    constructor(theHandle: Handle_StepShape_OrientedFace);
  }

export declare class StepShape_OrientedFace extends StepShape_Face {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aFaceElement: Handle_StepShape_Face, aOrientation: Standard_Boolean): void;
  SetFaceElement(aFaceElement: Handle_StepShape_Face): void;
  FaceElement(): Handle_StepShape_Face;
  SetOrientation(aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  SetBounds(aBounds: Handle_StepShape_HArray1OfFaceBound): void;
  Bounds(): Handle_StepShape_HArray1OfFaceBound;
  BoundsValue(num: Graphic3d_ZLayerId): Handle_StepShape_FaceBound;
  NbBounds(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_HArray1OfConnectedEdgeSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfConnectedEdgeSet): void;
  get(): StepShape_HArray1OfConnectedEdgeSet;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfConnectedEdgeSet_1 extends Handle_StepShape_HArray1OfConnectedEdgeSet {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfConnectedEdgeSet_2 extends Handle_StepShape_HArray1OfConnectedEdgeSet {
    constructor(thePtr: StepShape_HArray1OfConnectedEdgeSet);
  }

  export declare class Handle_StepShape_HArray1OfConnectedEdgeSet_3 extends Handle_StepShape_HArray1OfConnectedEdgeSet {
    constructor(theHandle: Handle_StepShape_HArray1OfConnectedEdgeSet);
  }

  export declare class Handle_StepShape_HArray1OfConnectedEdgeSet_4 extends Handle_StepShape_HArray1OfConnectedEdgeSet {
    constructor(theHandle: Handle_StepShape_HArray1OfConnectedEdgeSet);
  }

export declare class Handle_StepShape_OrientedEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_OrientedEdge): void;
  get(): StepShape_OrientedEdge;
  delete(): void;
}

  export declare class Handle_StepShape_OrientedEdge_1 extends Handle_StepShape_OrientedEdge {
    constructor();
  }

  export declare class Handle_StepShape_OrientedEdge_2 extends Handle_StepShape_OrientedEdge {
    constructor(thePtr: StepShape_OrientedEdge);
  }

  export declare class Handle_StepShape_OrientedEdge_3 extends Handle_StepShape_OrientedEdge {
    constructor(theHandle: Handle_StepShape_OrientedEdge);
  }

  export declare class Handle_StepShape_OrientedEdge_4 extends Handle_StepShape_OrientedEdge {
    constructor(theHandle: Handle_StepShape_OrientedEdge);
  }

export declare class StepShape_OrientedEdge extends StepShape_Edge {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aEdgeElement: Handle_StepShape_Edge, aOrientation: Standard_Boolean): void;
  SetEdgeElement(aEdgeElement: Handle_StepShape_Edge): void;
  EdgeElement(): Handle_StepShape_Edge;
  SetOrientation(aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  SetEdgeStart(aEdgeStart: Handle_StepShape_Vertex): void;
  EdgeStart(): Handle_StepShape_Vertex;
  SetEdgeEnd(aEdgeEnd: Handle_StepShape_Vertex): void;
  EdgeEnd(): Handle_StepShape_Vertex;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_Vertex extends StepShape_TopologicalRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Vertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Vertex): void;
  get(): StepShape_Vertex;
  delete(): void;
}

  export declare class Handle_StepShape_Vertex_1 extends Handle_StepShape_Vertex {
    constructor();
  }

  export declare class Handle_StepShape_Vertex_2 extends Handle_StepShape_Vertex {
    constructor(thePtr: StepShape_Vertex);
  }

  export declare class Handle_StepShape_Vertex_3 extends Handle_StepShape_Vertex {
    constructor(theHandle: Handle_StepShape_Vertex);
  }

  export declare class Handle_StepShape_Vertex_4 extends Handle_StepShape_Vertex {
    constructor(theHandle: Handle_StepShape_Vertex);
  }

export declare class StepShape_AdvancedFace extends StepShape_FaceSurface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_AdvancedFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_AdvancedFace): void;
  get(): StepShape_AdvancedFace;
  delete(): void;
}

  export declare class Handle_StepShape_AdvancedFace_1 extends Handle_StepShape_AdvancedFace {
    constructor();
  }

  export declare class Handle_StepShape_AdvancedFace_2 extends Handle_StepShape_AdvancedFace {
    constructor(thePtr: StepShape_AdvancedFace);
  }

  export declare class Handle_StepShape_AdvancedFace_3 extends Handle_StepShape_AdvancedFace {
    constructor(theHandle: Handle_StepShape_AdvancedFace);
  }

  export declare class Handle_StepShape_AdvancedFace_4 extends Handle_StepShape_AdvancedFace {
    constructor(theHandle: Handle_StepShape_AdvancedFace);
  }

export declare class StepShape_AdvancedBrepShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_AdvancedBrepShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_AdvancedBrepShapeRepresentation): void;
  get(): StepShape_AdvancedBrepShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_AdvancedBrepShapeRepresentation_1 extends Handle_StepShape_AdvancedBrepShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_AdvancedBrepShapeRepresentation_2 extends Handle_StepShape_AdvancedBrepShapeRepresentation {
    constructor(thePtr: StepShape_AdvancedBrepShapeRepresentation);
  }

  export declare class Handle_StepShape_AdvancedBrepShapeRepresentation_3 extends Handle_StepShape_AdvancedBrepShapeRepresentation {
    constructor(theHandle: Handle_StepShape_AdvancedBrepShapeRepresentation);
  }

  export declare class Handle_StepShape_AdvancedBrepShapeRepresentation_4 extends Handle_StepShape_AdvancedBrepShapeRepresentation {
    constructor(theHandle: Handle_StepShape_AdvancedBrepShapeRepresentation);
  }

export declare class Handle_StepShape_HArray1OfOrientedEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfOrientedEdge): void;
  get(): StepShape_HArray1OfOrientedEdge;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfOrientedEdge_1 extends Handle_StepShape_HArray1OfOrientedEdge {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfOrientedEdge_2 extends Handle_StepShape_HArray1OfOrientedEdge {
    constructor(thePtr: StepShape_HArray1OfOrientedEdge);
  }

  export declare class Handle_StepShape_HArray1OfOrientedEdge_3 extends Handle_StepShape_HArray1OfOrientedEdge {
    constructor(theHandle: Handle_StepShape_HArray1OfOrientedEdge);
  }

  export declare class Handle_StepShape_HArray1OfOrientedEdge_4 extends Handle_StepShape_HArray1OfOrientedEdge {
    constructor(theHandle: Handle_StepShape_HArray1OfOrientedEdge);
  }

export declare class StepShape_OrientedClosedShell extends StepShape_ClosedShell {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aClosedShellElement: Handle_StepShape_ClosedShell, aOrientation: Standard_Boolean): void;
  SetClosedShellElement(aClosedShellElement: Handle_StepShape_ClosedShell): void;
  ClosedShellElement(): Handle_StepShape_ClosedShell;
  SetOrientation(aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  SetCfsFaces(aCfsFaces: Handle_StepShape_HArray1OfFace): void;
  CfsFaces(): Handle_StepShape_HArray1OfFace;
  CfsFacesValue(num: Graphic3d_ZLayerId): Handle_StepShape_Face;
  NbCfsFaces(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_OrientedClosedShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_OrientedClosedShell): void;
  get(): StepShape_OrientedClosedShell;
  delete(): void;
}

  export declare class Handle_StepShape_OrientedClosedShell_1 extends Handle_StepShape_OrientedClosedShell {
    constructor();
  }

  export declare class Handle_StepShape_OrientedClosedShell_2 extends Handle_StepShape_OrientedClosedShell {
    constructor(thePtr: StepShape_OrientedClosedShell);
  }

  export declare class Handle_StepShape_OrientedClosedShell_3 extends Handle_StepShape_OrientedClosedShell {
    constructor(theHandle: Handle_StepShape_OrientedClosedShell);
  }

  export declare class Handle_StepShape_OrientedClosedShell_4 extends Handle_StepShape_OrientedClosedShell {
    constructor(theHandle: Handle_StepShape_OrientedClosedShell);
  }

export declare class StepShape_ValueQualifier extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PrecisionQualifier(): Handle_StepShape_PrecisionQualifier;
  TypeQualifier(): Handle_StepShape_TypeQualifier;
  ValueFormatTypeQualifier(): Handle_StepShape_ValueFormatTypeQualifier;
  delete(): void;
}

export declare class StepShape_BooleanOperand {
  constructor()
  SetTypeOfContent(aTypeOfContent: Graphic3d_ZLayerId): void;
  TypeOfContent(): Graphic3d_ZLayerId;
  SolidModel(): Handle_StepShape_SolidModel;
  SetSolidModel(aSolidModel: Handle_StepShape_SolidModel): void;
  HalfSpaceSolid(): Handle_StepShape_HalfSpaceSolid;
  SetHalfSpaceSolid(aHalfSpaceSolid: Handle_StepShape_HalfSpaceSolid): void;
  CsgPrimitive(): StepShape_CsgPrimitive;
  SetCsgPrimitive(aCsgPrimitive: StepShape_CsgPrimitive): void;
  BooleanResult(): Handle_StepShape_BooleanResult;
  SetBooleanResult(aBooleanResult: Handle_StepShape_BooleanResult): void;
  delete(): void;
}

export declare class StepShape_Array1OfShell {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepShape_Shell): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepShape_Array1OfShell): StepShape_Array1OfShell;
  Move(theOther: StepShape_Array1OfShell): StepShape_Array1OfShell;
  First(): StepShape_Shell;
  ChangeFirst(): StepShape_Shell;
  Last(): StepShape_Shell;
  ChangeLast(): StepShape_Shell;
  Value(theIndex: Standard_Integer): StepShape_Shell;
  ChangeValue(theIndex: Standard_Integer): StepShape_Shell;
  SetValue(theIndex: Standard_Integer, theItem: StepShape_Shell): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepShape_Array1OfShell_1 extends StepShape_Array1OfShell {
    constructor();
  }

  export declare class StepShape_Array1OfShell_2 extends StepShape_Array1OfShell {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepShape_Array1OfShell_3 extends StepShape_Array1OfShell {
    constructor(theOther: StepShape_Array1OfShell);
  }

  export declare class StepShape_Array1OfShell_4 extends StepShape_Array1OfShell {
    constructor(theOther: StepShape_Array1OfShell);
  }

  export declare class StepShape_Array1OfShell_5 extends StepShape_Array1OfShell {
    constructor(theBegin: StepShape_Shell, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem): void;
  get(): StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_1 extends Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem {
    constructor();
  }

  export declare class Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_2 extends Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem {
    constructor(thePtr: StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem);
  }

  export declare class Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_3 extends Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem {
    constructor(theHandle: Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem);
  }

  export declare class Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_4 extends Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem {
    constructor(theHandle: Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem);
  }

export declare class StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aValueComponent: Handle_StepBasic_MeasureValueMember, aUnitComponent: StepBasic_Unit, qualifiers: Handle_StepShape_HArray1OfValueQualifier): void;
  SetMeasure(Measure: Handle_StepBasic_MeasureWithUnit): void;
  Measure(): Handle_StepBasic_MeasureWithUnit;
  Qualifiers(): Handle_StepShape_HArray1OfValueQualifier;
  NbQualifiers(): Graphic3d_ZLayerId;
  SetQualifiers(qualifiers: Handle_StepShape_HArray1OfValueQualifier): void;
  QualifiersValue(num: Graphic3d_ZLayerId): StepShape_ValueQualifier;
  SetQualifiersValue(num: Graphic3d_ZLayerId, aqualifier: StepShape_ValueQualifier): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_BooleanResult extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aOperator: StepShape_BooleanOperator, aFirstOperand: StepShape_BooleanOperand, aSecondOperand: StepShape_BooleanOperand): void;
  SetOperator(aOperator: StepShape_BooleanOperator): void;
  Operator(): StepShape_BooleanOperator;
  SetFirstOperand(aFirstOperand: StepShape_BooleanOperand): void;
  FirstOperand(): StepShape_BooleanOperand;
  SetSecondOperand(aSecondOperand: StepShape_BooleanOperand): void;
  SecondOperand(): StepShape_BooleanOperand;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_BooleanResult {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_BooleanResult): void;
  get(): StepShape_BooleanResult;
  delete(): void;
}

  export declare class Handle_StepShape_BooleanResult_1 extends Handle_StepShape_BooleanResult {
    constructor();
  }

  export declare class Handle_StepShape_BooleanResult_2 extends Handle_StepShape_BooleanResult {
    constructor(thePtr: StepShape_BooleanResult);
  }

  export declare class Handle_StepShape_BooleanResult_3 extends Handle_StepShape_BooleanResult {
    constructor(theHandle: Handle_StepShape_BooleanResult);
  }

  export declare class Handle_StepShape_BooleanResult_4 extends Handle_StepShape_BooleanResult {
    constructor(theHandle: Handle_StepShape_BooleanResult);
  }

export declare class StepShape_FacetedBrepShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_FacetedBrepShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FacetedBrepShapeRepresentation): void;
  get(): StepShape_FacetedBrepShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_FacetedBrepShapeRepresentation_1 extends Handle_StepShape_FacetedBrepShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_FacetedBrepShapeRepresentation_2 extends Handle_StepShape_FacetedBrepShapeRepresentation {
    constructor(thePtr: StepShape_FacetedBrepShapeRepresentation);
  }

  export declare class Handle_StepShape_FacetedBrepShapeRepresentation_3 extends Handle_StepShape_FacetedBrepShapeRepresentation {
    constructor(theHandle: Handle_StepShape_FacetedBrepShapeRepresentation);
  }

  export declare class Handle_StepShape_FacetedBrepShapeRepresentation_4 extends Handle_StepShape_FacetedBrepShapeRepresentation {
    constructor(theHandle: Handle_StepShape_FacetedBrepShapeRepresentation);
  }

export declare class Handle_StepShape_HArray1OfShapeDimensionRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfShapeDimensionRepresentationItem): void;
  get(): StepShape_HArray1OfShapeDimensionRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_1 extends Handle_StepShape_HArray1OfShapeDimensionRepresentationItem {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_2 extends Handle_StepShape_HArray1OfShapeDimensionRepresentationItem {
    constructor(thePtr: StepShape_HArray1OfShapeDimensionRepresentationItem);
  }

  export declare class Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_3 extends Handle_StepShape_HArray1OfShapeDimensionRepresentationItem {
    constructor(theHandle: Handle_StepShape_HArray1OfShapeDimensionRepresentationItem);
  }

  export declare class Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_4 extends Handle_StepShape_HArray1OfShapeDimensionRepresentationItem {
    constructor(theHandle: Handle_StepShape_HArray1OfShapeDimensionRepresentationItem);
  }

export declare class Handle_StepShape_EdgeLoop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_EdgeLoop): void;
  get(): StepShape_EdgeLoop;
  delete(): void;
}

  export declare class Handle_StepShape_EdgeLoop_1 extends Handle_StepShape_EdgeLoop {
    constructor();
  }

  export declare class Handle_StepShape_EdgeLoop_2 extends Handle_StepShape_EdgeLoop {
    constructor(thePtr: StepShape_EdgeLoop);
  }

  export declare class Handle_StepShape_EdgeLoop_3 extends Handle_StepShape_EdgeLoop {
    constructor(theHandle: Handle_StepShape_EdgeLoop);
  }

  export declare class Handle_StepShape_EdgeLoop_4 extends Handle_StepShape_EdgeLoop {
    constructor(theHandle: Handle_StepShape_EdgeLoop);
  }

export declare class StepShape_EdgeLoop extends StepShape_Loop {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  SetEdgeList(aEdgeList: Handle_StepShape_HArray1OfOrientedEdge): void;
  EdgeList(): Handle_StepShape_HArray1OfOrientedEdge;
  EdgeListValue(num: Graphic3d_ZLayerId): Handle_StepShape_OrientedEdge;
  NbEdgeList(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ToleranceValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ToleranceValue): void;
  get(): StepShape_ToleranceValue;
  delete(): void;
}

  export declare class Handle_StepShape_ToleranceValue_1 extends Handle_StepShape_ToleranceValue {
    constructor();
  }

  export declare class Handle_StepShape_ToleranceValue_2 extends Handle_StepShape_ToleranceValue {
    constructor(thePtr: StepShape_ToleranceValue);
  }

  export declare class Handle_StepShape_ToleranceValue_3 extends Handle_StepShape_ToleranceValue {
    constructor(theHandle: Handle_StepShape_ToleranceValue);
  }

  export declare class Handle_StepShape_ToleranceValue_4 extends Handle_StepShape_ToleranceValue {
    constructor(theHandle: Handle_StepShape_ToleranceValue);
  }

export declare class StepShape_ToleranceValue extends Standard_Transient {
  constructor()
  Init(lower_bound: Handle_Standard_Transient, upper_bound: Handle_Standard_Transient): void;
  LowerBound(): Handle_Standard_Transient;
  SetLowerBound(lower_bound: Handle_Standard_Transient): void;
  UpperBound(): Handle_Standard_Transient;
  SetUpperBound(upper_bound: Handle_Standard_Transient): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_HArray1OfGeometricSetSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_HArray1OfGeometricSetSelect): void;
  get(): StepShape_HArray1OfGeometricSetSelect;
  delete(): void;
}

  export declare class Handle_StepShape_HArray1OfGeometricSetSelect_1 extends Handle_StepShape_HArray1OfGeometricSetSelect {
    constructor();
  }

  export declare class Handle_StepShape_HArray1OfGeometricSetSelect_2 extends Handle_StepShape_HArray1OfGeometricSetSelect {
    constructor(thePtr: StepShape_HArray1OfGeometricSetSelect);
  }

  export declare class Handle_StepShape_HArray1OfGeometricSetSelect_3 extends Handle_StepShape_HArray1OfGeometricSetSelect {
    constructor(theHandle: Handle_StepShape_HArray1OfGeometricSetSelect);
  }

  export declare class Handle_StepShape_HArray1OfGeometricSetSelect_4 extends Handle_StepShape_HArray1OfGeometricSetSelect {
    constructor(theHandle: Handle_StepShape_HArray1OfGeometricSetSelect);
  }

export declare class StepShape_ConnectedFaceSet extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCfsFaces: Handle_StepShape_HArray1OfFace): void;
  SetCfsFaces(aCfsFaces: Handle_StepShape_HArray1OfFace): void;
  CfsFaces(): Handle_StepShape_HArray1OfFace;
  CfsFacesValue(num: Graphic3d_ZLayerId): Handle_StepShape_Face;
  NbCfsFaces(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ConnectedFaceSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ConnectedFaceSet): void;
  get(): StepShape_ConnectedFaceSet;
  delete(): void;
}

  export declare class Handle_StepShape_ConnectedFaceSet_1 extends Handle_StepShape_ConnectedFaceSet {
    constructor();
  }

  export declare class Handle_StepShape_ConnectedFaceSet_2 extends Handle_StepShape_ConnectedFaceSet {
    constructor(thePtr: StepShape_ConnectedFaceSet);
  }

  export declare class Handle_StepShape_ConnectedFaceSet_3 extends Handle_StepShape_ConnectedFaceSet {
    constructor(theHandle: Handle_StepShape_ConnectedFaceSet);
  }

  export declare class Handle_StepShape_ConnectedFaceSet_4 extends Handle_StepShape_ConnectedFaceSet {
    constructor(theHandle: Handle_StepShape_ConnectedFaceSet);
  }

export declare class StepShape_DimensionalCharacteristic extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DimensionalLocation(): Handle_StepShape_DimensionalLocation;
  DimensionalSize(): Handle_StepShape_DimensionalSize;
  delete(): void;
}

export declare class StepShape_TopologicalRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_TopologicalRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_TopologicalRepresentationItem): void;
  get(): StepShape_TopologicalRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepShape_TopologicalRepresentationItem_1 extends Handle_StepShape_TopologicalRepresentationItem {
    constructor();
  }

  export declare class Handle_StepShape_TopologicalRepresentationItem_2 extends Handle_StepShape_TopologicalRepresentationItem {
    constructor(thePtr: StepShape_TopologicalRepresentationItem);
  }

  export declare class Handle_StepShape_TopologicalRepresentationItem_3 extends Handle_StepShape_TopologicalRepresentationItem {
    constructor(theHandle: Handle_StepShape_TopologicalRepresentationItem);
  }

  export declare class Handle_StepShape_TopologicalRepresentationItem_4 extends Handle_StepShape_TopologicalRepresentationItem {
    constructor(theHandle: Handle_StepShape_TopologicalRepresentationItem);
  }

export declare class Handle_StepShape_ConnectedFaceShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ConnectedFaceShapeRepresentation): void;
  get(): StepShape_ConnectedFaceShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_ConnectedFaceShapeRepresentation_1 extends Handle_StepShape_ConnectedFaceShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_ConnectedFaceShapeRepresentation_2 extends Handle_StepShape_ConnectedFaceShapeRepresentation {
    constructor(thePtr: StepShape_ConnectedFaceShapeRepresentation);
  }

  export declare class Handle_StepShape_ConnectedFaceShapeRepresentation_3 extends Handle_StepShape_ConnectedFaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ConnectedFaceShapeRepresentation);
  }

  export declare class Handle_StepShape_ConnectedFaceShapeRepresentation_4 extends Handle_StepShape_ConnectedFaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_ConnectedFaceShapeRepresentation);
  }

export declare class StepShape_ConnectedFaceShapeRepresentation extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_VertexLoop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_VertexLoop): void;
  get(): StepShape_VertexLoop;
  delete(): void;
}

  export declare class Handle_StepShape_VertexLoop_1 extends Handle_StepShape_VertexLoop {
    constructor();
  }

  export declare class Handle_StepShape_VertexLoop_2 extends Handle_StepShape_VertexLoop {
    constructor(thePtr: StepShape_VertexLoop);
  }

  export declare class Handle_StepShape_VertexLoop_3 extends Handle_StepShape_VertexLoop {
    constructor(theHandle: Handle_StepShape_VertexLoop);
  }

  export declare class Handle_StepShape_VertexLoop_4 extends Handle_StepShape_VertexLoop {
    constructor(theHandle: Handle_StepShape_VertexLoop);
  }

export declare class StepShape_VertexLoop extends StepShape_Loop {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aLoopVertex: Handle_StepShape_Vertex): void;
  SetLoopVertex(aLoopVertex: Handle_StepShape_Vertex): void;
  LoopVertex(): Handle_StepShape_Vertex;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_FacetedBrep {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FacetedBrep): void;
  get(): StepShape_FacetedBrep;
  delete(): void;
}

  export declare class Handle_StepShape_FacetedBrep_1 extends Handle_StepShape_FacetedBrep {
    constructor();
  }

  export declare class Handle_StepShape_FacetedBrep_2 extends Handle_StepShape_FacetedBrep {
    constructor(thePtr: StepShape_FacetedBrep);
  }

  export declare class Handle_StepShape_FacetedBrep_3 extends Handle_StepShape_FacetedBrep {
    constructor(theHandle: Handle_StepShape_FacetedBrep);
  }

  export declare class Handle_StepShape_FacetedBrep_4 extends Handle_StepShape_FacetedBrep {
    constructor(theHandle: Handle_StepShape_FacetedBrep);
  }

export declare class StepShape_FacetedBrep extends StepShape_ManifoldSolidBrep {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_MeasureQualification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_MeasureQualification): void;
  get(): StepShape_MeasureQualification;
  delete(): void;
}

  export declare class Handle_StepShape_MeasureQualification_1 extends Handle_StepShape_MeasureQualification {
    constructor();
  }

  export declare class Handle_StepShape_MeasureQualification_2 extends Handle_StepShape_MeasureQualification {
    constructor(thePtr: StepShape_MeasureQualification);
  }

  export declare class Handle_StepShape_MeasureQualification_3 extends Handle_StepShape_MeasureQualification {
    constructor(theHandle: Handle_StepShape_MeasureQualification);
  }

  export declare class Handle_StepShape_MeasureQualification_4 extends Handle_StepShape_MeasureQualification {
    constructor(theHandle: Handle_StepShape_MeasureQualification);
  }

export declare class StepShape_MeasureQualification extends Standard_Transient {
  constructor()
  Init(name: Handle_TCollection_HAsciiString, description: Handle_TCollection_HAsciiString, qualified_measure: Handle_StepBasic_MeasureWithUnit, qualifiers: Handle_StepShape_HArray1OfValueQualifier): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(description: Handle_TCollection_HAsciiString): void;
  QualifiedMeasure(): Handle_StepBasic_MeasureWithUnit;
  SetQualifiedMeasure(qualified_measure: Handle_StepBasic_MeasureWithUnit): void;
  Qualifiers(): Handle_StepShape_HArray1OfValueQualifier;
  NbQualifiers(): Graphic3d_ZLayerId;
  SetQualifiers(qualifiers: Handle_StepShape_HArray1OfValueQualifier): void;
  QualifiersValue(num: Graphic3d_ZLayerId): StepShape_ValueQualifier;
  SetQualifiersValue(num: Graphic3d_ZLayerId, aqualifier: StepShape_ValueQualifier): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_OpenShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_OpenShell): void;
  get(): StepShape_OpenShell;
  delete(): void;
}

  export declare class Handle_StepShape_OpenShell_1 extends Handle_StepShape_OpenShell {
    constructor();
  }

  export declare class Handle_StepShape_OpenShell_2 extends Handle_StepShape_OpenShell {
    constructor(thePtr: StepShape_OpenShell);
  }

  export declare class Handle_StepShape_OpenShell_3 extends Handle_StepShape_OpenShell {
    constructor(theHandle: Handle_StepShape_OpenShell);
  }

  export declare class Handle_StepShape_OpenShell_4 extends Handle_StepShape_OpenShell {
    constructor(theHandle: Handle_StepShape_OpenShell);
  }

export declare class StepShape_OpenShell extends StepShape_ConnectedFaceSet {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_SeamEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_SeamEdge): void;
  get(): StepShape_SeamEdge;
  delete(): void;
}

  export declare class Handle_StepShape_SeamEdge_1 extends Handle_StepShape_SeamEdge {
    constructor();
  }

  export declare class Handle_StepShape_SeamEdge_2 extends Handle_StepShape_SeamEdge {
    constructor(thePtr: StepShape_SeamEdge);
  }

  export declare class Handle_StepShape_SeamEdge_3 extends Handle_StepShape_SeamEdge {
    constructor(theHandle: Handle_StepShape_SeamEdge);
  }

  export declare class Handle_StepShape_SeamEdge_4 extends Handle_StepShape_SeamEdge {
    constructor(theHandle: Handle_StepShape_SeamEdge);
  }

export declare class StepShape_SeamEdge extends StepShape_OrientedEdge {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aOrientedEdge_EdgeElement: Handle_StepShape_Edge, aOrientedEdge_Orientation: Standard_Boolean, aPcurveReference: Handle_StepGeom_Pcurve): void;
  PcurveReference(): Handle_StepGeom_Pcurve;
  SetPcurveReference(PcurveReference: Handle_StepGeom_Pcurve): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_Face extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBounds: Handle_StepShape_HArray1OfFaceBound): void;
  SetBounds(aBounds: Handle_StepShape_HArray1OfFaceBound): void;
  Bounds(): Handle_StepShape_HArray1OfFaceBound;
  BoundsValue(num: Graphic3d_ZLayerId): Handle_StepShape_FaceBound;
  NbBounds(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Face {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Face): void;
  get(): StepShape_Face;
  delete(): void;
}

  export declare class Handle_StepShape_Face_1 extends Handle_StepShape_Face {
    constructor();
  }

  export declare class Handle_StepShape_Face_2 extends Handle_StepShape_Face {
    constructor(thePtr: StepShape_Face);
  }

  export declare class Handle_StepShape_Face_3 extends Handle_StepShape_Face {
    constructor(theHandle: Handle_StepShape_Face);
  }

  export declare class Handle_StepShape_Face_4 extends Handle_StepShape_Face {
    constructor(theHandle: Handle_StepShape_Face);
  }

export declare class StepShape_SurfaceModel extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ShellBasedSurfaceModel(): Handle_StepShape_ShellBasedSurfaceModel;
  delete(): void;
}

export declare class StepShape_Torus extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis1Placement, aMajorRadius: Quantity_AbsorbedDose, aMinorRadius: Quantity_AbsorbedDose): void;
  SetPosition(aPosition: Handle_StepGeom_Axis1Placement): void;
  Position(): Handle_StepGeom_Axis1Placement;
  SetMajorRadius(aMajorRadius: Quantity_AbsorbedDose): void;
  MajorRadius(): Quantity_AbsorbedDose;
  SetMinorRadius(aMinorRadius: Quantity_AbsorbedDose): void;
  MinorRadius(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Torus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Torus): void;
  get(): StepShape_Torus;
  delete(): void;
}

  export declare class Handle_StepShape_Torus_1 extends Handle_StepShape_Torus {
    constructor();
  }

  export declare class Handle_StepShape_Torus_2 extends Handle_StepShape_Torus {
    constructor(thePtr: StepShape_Torus);
  }

  export declare class Handle_StepShape_Torus_3 extends Handle_StepShape_Torus {
    constructor(theHandle: Handle_StepShape_Torus);
  }

  export declare class Handle_StepShape_Torus_4 extends Handle_StepShape_Torus {
    constructor(theHandle: Handle_StepShape_Torus);
  }

export declare class Handle_StepShape_ShapeDimensionRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ShapeDimensionRepresentation): void;
  get(): StepShape_ShapeDimensionRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_ShapeDimensionRepresentation_1 extends Handle_StepShape_ShapeDimensionRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_ShapeDimensionRepresentation_2 extends Handle_StepShape_ShapeDimensionRepresentation {
    constructor(thePtr: StepShape_ShapeDimensionRepresentation);
  }

  export declare class Handle_StepShape_ShapeDimensionRepresentation_3 extends Handle_StepShape_ShapeDimensionRepresentation {
    constructor(theHandle: Handle_StepShape_ShapeDimensionRepresentation);
  }

  export declare class Handle_StepShape_ShapeDimensionRepresentation_4 extends Handle_StepShape_ShapeDimensionRepresentation {
    constructor(theHandle: Handle_StepShape_ShapeDimensionRepresentation);
  }

export declare class StepShape_ShapeDimensionRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  Init_1(theName: Handle_TCollection_HAsciiString, theItems: Handle_StepRepr_HArray1OfRepresentationItem, theContextOfItems: Handle_StepRepr_RepresentationContext): void;
  Init_2(theName: Handle_TCollection_HAsciiString, theItems: Handle_StepShape_HArray1OfShapeDimensionRepresentationItem, theContextOfItems: Handle_StepRepr_RepresentationContext): void;
  SetItemsAP242(theItems: Handle_StepShape_HArray1OfShapeDimensionRepresentationItem): void;
  ItemsAP242(): Handle_StepShape_HArray1OfShapeDimensionRepresentationItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_TypeQualifier extends Standard_Transient {
  constructor()
  Init(name: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(name: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_TypeQualifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_TypeQualifier): void;
  get(): StepShape_TypeQualifier;
  delete(): void;
}

  export declare class Handle_StepShape_TypeQualifier_1 extends Handle_StepShape_TypeQualifier {
    constructor();
  }

  export declare class Handle_StepShape_TypeQualifier_2 extends Handle_StepShape_TypeQualifier {
    constructor(thePtr: StepShape_TypeQualifier);
  }

  export declare class Handle_StepShape_TypeQualifier_3 extends Handle_StepShape_TypeQualifier {
    constructor(theHandle: Handle_StepShape_TypeQualifier);
  }

  export declare class Handle_StepShape_TypeQualifier_4 extends Handle_StepShape_TypeQualifier {
    constructor(theHandle: Handle_StepShape_TypeQualifier);
  }

export declare class Handle_StepShape_EdgeBasedWireframeModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_EdgeBasedWireframeModel): void;
  get(): StepShape_EdgeBasedWireframeModel;
  delete(): void;
}

  export declare class Handle_StepShape_EdgeBasedWireframeModel_1 extends Handle_StepShape_EdgeBasedWireframeModel {
    constructor();
  }

  export declare class Handle_StepShape_EdgeBasedWireframeModel_2 extends Handle_StepShape_EdgeBasedWireframeModel {
    constructor(thePtr: StepShape_EdgeBasedWireframeModel);
  }

  export declare class Handle_StepShape_EdgeBasedWireframeModel_3 extends Handle_StepShape_EdgeBasedWireframeModel {
    constructor(theHandle: Handle_StepShape_EdgeBasedWireframeModel);
  }

  export declare class Handle_StepShape_EdgeBasedWireframeModel_4 extends Handle_StepShape_EdgeBasedWireframeModel {
    constructor(theHandle: Handle_StepShape_EdgeBasedWireframeModel);
  }

export declare class StepShape_EdgeBasedWireframeModel extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aEbwmBoundary: Handle_StepShape_HArray1OfConnectedEdgeSet): void;
  EbwmBoundary(): Handle_StepShape_HArray1OfConnectedEdgeSet;
  SetEbwmBoundary(EbwmBoundary: Handle_StepShape_HArray1OfConnectedEdgeSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ClosedShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ClosedShell): void;
  get(): StepShape_ClosedShell;
  delete(): void;
}

  export declare class Handle_StepShape_ClosedShell_1 extends Handle_StepShape_ClosedShell {
    constructor();
  }

  export declare class Handle_StepShape_ClosedShell_2 extends Handle_StepShape_ClosedShell {
    constructor(thePtr: StepShape_ClosedShell);
  }

  export declare class Handle_StepShape_ClosedShell_3 extends Handle_StepShape_ClosedShell {
    constructor(theHandle: Handle_StepShape_ClosedShell);
  }

  export declare class Handle_StepShape_ClosedShell_4 extends Handle_StepShape_ClosedShell {
    constructor(theHandle: Handle_StepShape_ClosedShell);
  }

export declare class StepShape_ClosedShell extends StepShape_ConnectedFaceSet {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_ValueFormatTypeQualifier extends Standard_Transient {
  constructor()
  Init(theFormatType: Handle_TCollection_HAsciiString): void;
  FormatType(): Handle_TCollection_HAsciiString;
  SetFormatType(theFormatType: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ValueFormatTypeQualifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ValueFormatTypeQualifier): void;
  get(): StepShape_ValueFormatTypeQualifier;
  delete(): void;
}

  export declare class Handle_StepShape_ValueFormatTypeQualifier_1 extends Handle_StepShape_ValueFormatTypeQualifier {
    constructor();
  }

  export declare class Handle_StepShape_ValueFormatTypeQualifier_2 extends Handle_StepShape_ValueFormatTypeQualifier {
    constructor(thePtr: StepShape_ValueFormatTypeQualifier);
  }

  export declare class Handle_StepShape_ValueFormatTypeQualifier_3 extends Handle_StepShape_ValueFormatTypeQualifier {
    constructor(theHandle: Handle_StepShape_ValueFormatTypeQualifier);
  }

  export declare class Handle_StepShape_ValueFormatTypeQualifier_4 extends Handle_StepShape_ValueFormatTypeQualifier {
    constructor(theHandle: Handle_StepShape_ValueFormatTypeQualifier);
  }

export declare class StepShape_BoxDomain extends Standard_Transient {
  constructor()
  Init(aCorner: Handle_StepGeom_CartesianPoint, aXlength: Quantity_AbsorbedDose, aYlength: Quantity_AbsorbedDose, aZlength: Quantity_AbsorbedDose): void;
  SetCorner(aCorner: Handle_StepGeom_CartesianPoint): void;
  Corner(): Handle_StepGeom_CartesianPoint;
  SetXlength(aXlength: Quantity_AbsorbedDose): void;
  Xlength(): Quantity_AbsorbedDose;
  SetYlength(aYlength: Quantity_AbsorbedDose): void;
  Ylength(): Quantity_AbsorbedDose;
  SetZlength(aZlength: Quantity_AbsorbedDose): void;
  Zlength(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_BoxDomain {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_BoxDomain): void;
  get(): StepShape_BoxDomain;
  delete(): void;
}

  export declare class Handle_StepShape_BoxDomain_1 extends Handle_StepShape_BoxDomain {
    constructor();
  }

  export declare class Handle_StepShape_BoxDomain_2 extends Handle_StepShape_BoxDomain {
    constructor(thePtr: StepShape_BoxDomain);
  }

  export declare class Handle_StepShape_BoxDomain_3 extends Handle_StepShape_BoxDomain {
    constructor(theHandle: Handle_StepShape_BoxDomain);
  }

  export declare class Handle_StepShape_BoxDomain_4 extends Handle_StepShape_BoxDomain {
    constructor(theHandle: Handle_StepShape_BoxDomain);
  }

export declare class StepShape_Array1OfGeometricSetSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepShape_GeometricSetSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepShape_Array1OfGeometricSetSelect): StepShape_Array1OfGeometricSetSelect;
  Move(theOther: StepShape_Array1OfGeometricSetSelect): StepShape_Array1OfGeometricSetSelect;
  First(): StepShape_GeometricSetSelect;
  ChangeFirst(): StepShape_GeometricSetSelect;
  Last(): StepShape_GeometricSetSelect;
  ChangeLast(): StepShape_GeometricSetSelect;
  Value(theIndex: Standard_Integer): StepShape_GeometricSetSelect;
  ChangeValue(theIndex: Standard_Integer): StepShape_GeometricSetSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepShape_GeometricSetSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepShape_Array1OfGeometricSetSelect_1 extends StepShape_Array1OfGeometricSetSelect {
    constructor();
  }

  export declare class StepShape_Array1OfGeometricSetSelect_2 extends StepShape_Array1OfGeometricSetSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepShape_Array1OfGeometricSetSelect_3 extends StepShape_Array1OfGeometricSetSelect {
    constructor(theOther: StepShape_Array1OfGeometricSetSelect);
  }

  export declare class StepShape_Array1OfGeometricSetSelect_4 extends StepShape_Array1OfGeometricSetSelect {
    constructor(theOther: StepShape_Array1OfGeometricSetSelect);
  }

  export declare class StepShape_Array1OfGeometricSetSelect_5 extends StepShape_Array1OfGeometricSetSelect {
    constructor(theBegin: StepShape_GeometricSetSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepShape_Edge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Edge): void;
  get(): StepShape_Edge;
  delete(): void;
}

  export declare class Handle_StepShape_Edge_1 extends Handle_StepShape_Edge {
    constructor();
  }

  export declare class Handle_StepShape_Edge_2 extends Handle_StepShape_Edge {
    constructor(thePtr: StepShape_Edge);
  }

  export declare class Handle_StepShape_Edge_3 extends Handle_StepShape_Edge {
    constructor(theHandle: Handle_StepShape_Edge);
  }

  export declare class Handle_StepShape_Edge_4 extends Handle_StepShape_Edge {
    constructor(theHandle: Handle_StepShape_Edge);
  }

export declare class StepShape_Edge extends StepShape_TopologicalRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aEdgeStart: Handle_StepShape_Vertex, aEdgeEnd: Handle_StepShape_Vertex): void;
  SetEdgeStart(aEdgeStart: Handle_StepShape_Vertex): void;
  EdgeStart(): Handle_StepShape_Vertex;
  SetEdgeEnd(aEdgeEnd: Handle_StepShape_Vertex): void;
  EdgeEnd(): Handle_StepShape_Vertex;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_CsgSolid extends StepShape_SolidModel {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aTreeRootExpression: StepShape_CsgSelect): void;
  SetTreeRootExpression(aTreeRootExpression: StepShape_CsgSelect): void;
  TreeRootExpression(): StepShape_CsgSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_CsgSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_CsgSolid): void;
  get(): StepShape_CsgSolid;
  delete(): void;
}

  export declare class Handle_StepShape_CsgSolid_1 extends Handle_StepShape_CsgSolid {
    constructor();
  }

  export declare class Handle_StepShape_CsgSolid_2 extends Handle_StepShape_CsgSolid {
    constructor(thePtr: StepShape_CsgSolid);
  }

  export declare class Handle_StepShape_CsgSolid_3 extends Handle_StepShape_CsgSolid {
    constructor(theHandle: Handle_StepShape_CsgSolid);
  }

  export declare class Handle_StepShape_CsgSolid_4 extends Handle_StepShape_CsgSolid {
    constructor(theHandle: Handle_StepShape_CsgSolid);
  }

export declare class Handle_StepShape_DimensionalSizeWithPath {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_DimensionalSizeWithPath): void;
  get(): StepShape_DimensionalSizeWithPath;
  delete(): void;
}

  export declare class Handle_StepShape_DimensionalSizeWithPath_1 extends Handle_StepShape_DimensionalSizeWithPath {
    constructor();
  }

  export declare class Handle_StepShape_DimensionalSizeWithPath_2 extends Handle_StepShape_DimensionalSizeWithPath {
    constructor(thePtr: StepShape_DimensionalSizeWithPath);
  }

  export declare class Handle_StepShape_DimensionalSizeWithPath_3 extends Handle_StepShape_DimensionalSizeWithPath {
    constructor(theHandle: Handle_StepShape_DimensionalSizeWithPath);
  }

  export declare class Handle_StepShape_DimensionalSizeWithPath_4 extends Handle_StepShape_DimensionalSizeWithPath {
    constructor(theHandle: Handle_StepShape_DimensionalSizeWithPath);
  }

export declare class StepShape_DimensionalSizeWithPath extends StepShape_DimensionalSize {
  constructor()
  Init(aDimensionalSize_AppliesTo: Handle_StepRepr_ShapeAspect, aDimensionalSize_Name: Handle_TCollection_HAsciiString, aPath: Handle_StepRepr_ShapeAspect): void;
  Path(): Handle_StepRepr_ShapeAspect;
  SetPath(Path: Handle_StepRepr_ShapeAspect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepShape_BooleanOperator = {
  StepShape_boDifference: {};
  StepShape_boIntersection: {};
  StepShape_boUnion: {};
}

export declare class StepShape_Subedge extends StepShape_Edge {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aEdge_EdgeStart: Handle_StepShape_Vertex, aEdge_EdgeEnd: Handle_StepShape_Vertex, aParentEdge: Handle_StepShape_Edge): void;
  ParentEdge(): Handle_StepShape_Edge;
  SetParentEdge(ParentEdge: Handle_StepShape_Edge): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_Subedge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_Subedge): void;
  get(): StepShape_Subedge;
  delete(): void;
}

  export declare class Handle_StepShape_Subedge_1 extends Handle_StepShape_Subedge {
    constructor();
  }

  export declare class Handle_StepShape_Subedge_2 extends Handle_StepShape_Subedge {
    constructor(thePtr: StepShape_Subedge);
  }

  export declare class Handle_StepShape_Subedge_3 extends Handle_StepShape_Subedge {
    constructor(theHandle: Handle_StepShape_Subedge);
  }

  export declare class Handle_StepShape_Subedge_4 extends Handle_StepShape_Subedge {
    constructor(theHandle: Handle_StepShape_Subedge);
  }

export declare class StepShape_FaceBasedSurfaceModel extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFbsmFaces: Handle_StepShape_HArray1OfConnectedFaceSet): void;
  FbsmFaces(): Handle_StepShape_HArray1OfConnectedFaceSet;
  SetFbsmFaces(FbsmFaces: Handle_StepShape_HArray1OfConnectedFaceSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_FaceBasedSurfaceModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_FaceBasedSurfaceModel): void;
  get(): StepShape_FaceBasedSurfaceModel;
  delete(): void;
}

  export declare class Handle_StepShape_FaceBasedSurfaceModel_1 extends Handle_StepShape_FaceBasedSurfaceModel {
    constructor();
  }

  export declare class Handle_StepShape_FaceBasedSurfaceModel_2 extends Handle_StepShape_FaceBasedSurfaceModel {
    constructor(thePtr: StepShape_FaceBasedSurfaceModel);
  }

  export declare class Handle_StepShape_FaceBasedSurfaceModel_3 extends Handle_StepShape_FaceBasedSurfaceModel {
    constructor(theHandle: Handle_StepShape_FaceBasedSurfaceModel);
  }

  export declare class Handle_StepShape_FaceBasedSurfaceModel_4 extends Handle_StepShape_FaceBasedSurfaceModel {
    constructor(theHandle: Handle_StepShape_FaceBasedSurfaceModel);
  }

export declare class Handle_StepShape_AngularSize {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_AngularSize): void;
  get(): StepShape_AngularSize;
  delete(): void;
}

  export declare class Handle_StepShape_AngularSize_1 extends Handle_StepShape_AngularSize {
    constructor();
  }

  export declare class Handle_StepShape_AngularSize_2 extends Handle_StepShape_AngularSize {
    constructor(thePtr: StepShape_AngularSize);
  }

  export declare class Handle_StepShape_AngularSize_3 extends Handle_StepShape_AngularSize {
    constructor(theHandle: Handle_StepShape_AngularSize);
  }

  export declare class Handle_StepShape_AngularSize_4 extends Handle_StepShape_AngularSize {
    constructor(theHandle: Handle_StepShape_AngularSize);
  }

export declare class StepShape_AngularSize extends StepShape_DimensionalSize {
  constructor()
  Init(aDimensionalSize_AppliesTo: Handle_StepRepr_ShapeAspect, aDimensionalSize_Name: Handle_TCollection_HAsciiString, aAngleSelection: StepShape_AngleRelator): void;
  AngleSelection(): StepShape_AngleRelator;
  SetAngleSelection(AngleSelection: StepShape_AngleRelator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_ShellBasedSurfaceModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_ShellBasedSurfaceModel): void;
  get(): StepShape_ShellBasedSurfaceModel;
  delete(): void;
}

  export declare class Handle_StepShape_ShellBasedSurfaceModel_1 extends Handle_StepShape_ShellBasedSurfaceModel {
    constructor();
  }

  export declare class Handle_StepShape_ShellBasedSurfaceModel_2 extends Handle_StepShape_ShellBasedSurfaceModel {
    constructor(thePtr: StepShape_ShellBasedSurfaceModel);
  }

  export declare class Handle_StepShape_ShellBasedSurfaceModel_3 extends Handle_StepShape_ShellBasedSurfaceModel {
    constructor(theHandle: Handle_StepShape_ShellBasedSurfaceModel);
  }

  export declare class Handle_StepShape_ShellBasedSurfaceModel_4 extends Handle_StepShape_ShellBasedSurfaceModel {
    constructor(theHandle: Handle_StepShape_ShellBasedSurfaceModel);
  }

export declare class StepShape_ShellBasedSurfaceModel extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSbsmBoundary: Handle_StepShape_HArray1OfShell): void;
  SetSbsmBoundary(aSbsmBoundary: Handle_StepShape_HArray1OfShell): void;
  SbsmBoundary(): Handle_StepShape_HArray1OfShell;
  SbsmBoundaryValue(num: Graphic3d_ZLayerId): StepShape_Shell;
  NbSbsmBoundary(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_PointRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_PointRepresentation): void;
  get(): StepShape_PointRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_PointRepresentation_1 extends Handle_StepShape_PointRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_PointRepresentation_2 extends Handle_StepShape_PointRepresentation {
    constructor(thePtr: StepShape_PointRepresentation);
  }

  export declare class Handle_StepShape_PointRepresentation_3 extends Handle_StepShape_PointRepresentation {
    constructor(theHandle: Handle_StepShape_PointRepresentation);
  }

  export declare class Handle_StepShape_PointRepresentation_4 extends Handle_StepShape_PointRepresentation {
    constructor(theHandle: Handle_StepShape_PointRepresentation);
  }

export declare class StepShape_PointRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepShape_GeometricallyBoundedSurfaceShapeRepresentation extends StepShape_ShapeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepShape_GeometricallyBoundedSurfaceShapeRepresentation): void;
  get(): StepShape_GeometricallyBoundedSurfaceShapeRepresentation;
  delete(): void;
}

  export declare class Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_1 extends Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation {
    constructor();
  }

  export declare class Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_2 extends Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation {
    constructor(thePtr: StepShape_GeometricallyBoundedSurfaceShapeRepresentation);
  }

  export declare class Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_3 extends Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation);
  }

  export declare class Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_4 extends Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation {
    constructor(theHandle: Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation);
  }

export declare class BOPAlgo_BuilderSolid extends BOPAlgo_BuilderArea {
  Perform(): void;
  GetBoxesMap(): TopTools_DataMapOfShapeBox;
  delete(): void;
}

  export declare class BOPAlgo_BuilderSolid_1 extends BOPAlgo_BuilderSolid {
    constructor();
  }

  export declare class BOPAlgo_BuilderSolid_2 extends BOPAlgo_BuilderSolid {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_ListOfCheckResult extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BOPAlgo_ListOfCheckResult): BOPAlgo_ListOfCheckResult;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BOPAlgo_CheckResult;
  First_2(): BOPAlgo_CheckResult;
  Last_1(): BOPAlgo_CheckResult;
  Last_2(): BOPAlgo_CheckResult;
  Append_1(theItem: BOPAlgo_CheckResult): BOPAlgo_CheckResult;
  Append_3(theOther: BOPAlgo_ListOfCheckResult): void;
  Prepend_1(theItem: BOPAlgo_CheckResult): BOPAlgo_CheckResult;
  Prepend_2(theOther: BOPAlgo_ListOfCheckResult): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BOPAlgo_ListOfCheckResult_1 extends BOPAlgo_ListOfCheckResult {
    constructor();
  }

  export declare class BOPAlgo_ListOfCheckResult_2 extends BOPAlgo_ListOfCheckResult {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPAlgo_ListOfCheckResult_3 extends BOPAlgo_ListOfCheckResult {
    constructor(theOther: BOPAlgo_ListOfCheckResult);
  }

export declare class BOPAlgo_MakePeriodic extends BOPAlgo_Options {
  constructor()
  SetShape(theShape: TopoDS_Shape): void;
  SetPeriodicityParameters(theParams: any): void;
  PeriodicityParameters(): any;
  MakePeriodic(theDirectionID: Graphic3d_ZLayerId, theIsPeriodic: Standard_Boolean, thePeriod: Quantity_AbsorbedDose): void;
  IsPeriodic(theDirectionID: Graphic3d_ZLayerId): Standard_Boolean;
  Period(theDirectionID: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MakeXPeriodic(theIsPeriodic: Standard_Boolean, thePeriod: Quantity_AbsorbedDose): void;
  IsXPeriodic(): Standard_Boolean;
  XPeriod(): Quantity_AbsorbedDose;
  MakeYPeriodic(theIsPeriodic: Standard_Boolean, thePeriod: Quantity_AbsorbedDose): void;
  IsYPeriodic(): Standard_Boolean;
  YPeriod(): Quantity_AbsorbedDose;
  MakeZPeriodic(theIsPeriodic: Standard_Boolean, thePeriod: Quantity_AbsorbedDose): void;
  IsZPeriodic(): Standard_Boolean;
  ZPeriod(): Quantity_AbsorbedDose;
  SetTrimmed(theDirectionID: Graphic3d_ZLayerId, theIsTrimmed: Standard_Boolean, theFirst: Quantity_AbsorbedDose): void;
  IsInputTrimmed(theDirectionID: Graphic3d_ZLayerId): Standard_Boolean;
  PeriodFirst(theDirectionID: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetXTrimmed(theIsTrimmed: Standard_Boolean, theFirst: Standard_Boolean): void;
  IsInputXTrimmed(): Standard_Boolean;
  XPeriodFirst(): Quantity_AbsorbedDose;
  SetYTrimmed(theIsTrimmed: Standard_Boolean, theFirst: Standard_Boolean): void;
  IsInputYTrimmed(): Standard_Boolean;
  YPeriodFirst(): Quantity_AbsorbedDose;
  SetZTrimmed(theIsTrimmed: Standard_Boolean, theFirst: Standard_Boolean): void;
  IsInputZTrimmed(): Standard_Boolean;
  ZPeriodFirst(): Quantity_AbsorbedDose;
  Perform(): void;
  RepeatShape(theDirectionID: Graphic3d_ZLayerId, theTimes: Graphic3d_ZLayerId): TopoDS_Shape;
  XRepeat(theTimes: Graphic3d_ZLayerId): TopoDS_Shape;
  YRepeat(theTimes: Graphic3d_ZLayerId): TopoDS_Shape;
  ZRepeat(theTimes: Graphic3d_ZLayerId): TopoDS_Shape;
  RepeatedShape(): TopoDS_Shape;
  ClearRepetitions(): void;
  Shape(): TopoDS_Shape;
  GetTwins(theS: TopoDS_Shape): TopTools_ListOfShape;
  History(): Handle_BRepTools_History;
  Clear(): void;
  static ToDirectionID(theDirectionID: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BOPAlgo_CheckerSI extends BOPAlgo_PaveFiller {
  constructor()
  Perform(): void;
  SetLevelOfCheck(theLevel: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BOPAlgo_SectionAttribute {
  Approximation_1(theApprox: Standard_Boolean): void;
  PCurveOnS1_1(thePCurveOnS1: Standard_Boolean): void;
  PCurveOnS2_1(thePCurveOnS2: Standard_Boolean): void;
  Approximation_2(): Standard_Boolean;
  PCurveOnS1_2(): Standard_Boolean;
  PCurveOnS2_2(): Standard_Boolean;
  delete(): void;
}

  export declare class BOPAlgo_SectionAttribute_1 extends BOPAlgo_SectionAttribute {
    constructor();
  }

  export declare class BOPAlgo_SectionAttribute_2 extends BOPAlgo_SectionAttribute {
    constructor(theAproximation: Standard_Boolean, thePCurveOnS1: Standard_Boolean, thePCurveOnS2: Standard_Boolean);
  }

export declare class BOPAlgo_BOP extends BOPAlgo_ToolsProvider {
  Clear(): void;
  SetOperation(theOperation: BOPAlgo_Operation): void;
  Operation(): BOPAlgo_Operation;
  Perform(): void;
  delete(): void;
}

  export declare class BOPAlgo_BOP_1 extends BOPAlgo_BOP {
    constructor();
  }

  export declare class BOPAlgo_BOP_2 extends BOPAlgo_BOP {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_BuilderShape extends BOPAlgo_Algo {
  Shape(): TopoDS_Shape;
  Modified(theS: TopoDS_Shape): TopTools_ListOfShape;
  Generated(theS: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(theS: TopoDS_Shape): Standard_Boolean;
  HasModified(): Standard_Boolean;
  HasGenerated(): Standard_Boolean;
  HasDeleted(): Standard_Boolean;
  History(): Handle_BRepTools_History;
  SetToFillHistory(theHistFlag: Standard_Boolean): void;
  HasHistory(): Standard_Boolean;
  delete(): void;
}

export declare type BOPAlgo_Operation = {
  BOPAlgo_COMMON: {};
  BOPAlgo_FUSE: {};
  BOPAlgo_CUT: {};
  BOPAlgo_CUT21: {};
  BOPAlgo_SECTION: {};
  BOPAlgo_UNKNOWN: {};
}

export declare class BOPAlgo_MakerVolume extends BOPAlgo_Builder {
  Clear(): void;
  SetIntersect(bIntersect: Standard_Boolean): void;
  IsIntersect(): Standard_Boolean;
  Box(): TopoDS_Solid;
  Faces(): TopTools_ListOfShape;
  SetAvoidInternalShapes(theAvoidInternal: Standard_Boolean): void;
  IsAvoidInternalShapes(): Standard_Boolean;
  Perform(): void;
  delete(): void;
}

  export declare class BOPAlgo_MakerVolume_1 extends BOPAlgo_MakerVolume {
    constructor();
  }

  export declare class BOPAlgo_MakerVolume_2 extends BOPAlgo_MakerVolume {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_Section extends BOPAlgo_Builder {
  delete(): void;
}

  export declare class BOPAlgo_Section_1 extends BOPAlgo_Section {
    constructor();
  }

  export declare class BOPAlgo_Section_2 extends BOPAlgo_Section {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_WireSplitter extends BOPAlgo_Algo {
  SetWES(theWES: BOPAlgo_WireEdgeSet): void;
  WES(): BOPAlgo_WireEdgeSet;
  SetContext(theContext: Handle_IntTools_Context): void;
  Context(): Handle_IntTools_Context;
  Perform(): void;
  static MakeWire(theLE: TopTools_ListOfShape, theW: TopoDS_Wire): void;
  static SplitBlock(theF: TopoDS_Face, theCB: BOPTools_ConnexityBlock, theContext: Handle_IntTools_Context): void;
  delete(): void;
}

  export declare class BOPAlgo_WireSplitter_1 extends BOPAlgo_WireSplitter {
    constructor();
  }

  export declare class BOPAlgo_WireSplitter_2 extends BOPAlgo_WireSplitter {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_Builder extends BOPAlgo_BuilderShape {
  Clear(): void;
  PPaveFiller(): BOPAlgo_PPaveFiller;
  PDS(): BOPDS_PDS;
  Context(): Handle_IntTools_Context;
  AddArgument(theShape: TopoDS_Shape): void;
  SetArguments(theLS: TopTools_ListOfShape): void;
  Arguments(): TopTools_ListOfShape;
  SetNonDestructive(theFlag: Standard_Boolean): void;
  NonDestructive(): Standard_Boolean;
  SetGlue(theGlue: BOPAlgo_GlueEnum): void;
  Glue(): BOPAlgo_GlueEnum;
  SetCheckInverted(theCheck: Standard_Boolean): void;
  CheckInverted(): Standard_Boolean;
  Perform(): void;
  PerformWithFiller(theFiller: BOPAlgo_PaveFiller): void;
  BuildBOP_1(theObjects: TopTools_ListOfShape, theObjState: TopAbs_State, theTools: TopTools_ListOfShape, theToolsState: TopAbs_State, theReport: Handle_Message_Report): void;
  BuildBOP_2(theObjects: TopTools_ListOfShape, theTools: TopTools_ListOfShape, theOperation: BOPAlgo_Operation, theReport: Handle_Message_Report): void;
  Images(): TopTools_DataMapOfShapeListOfShape;
  Origins(): TopTools_DataMapOfShapeListOfShape;
  ShapesSD(): TopTools_DataMapOfShapeShape;
  delete(): void;
}

  export declare class BOPAlgo_Builder_1 extends BOPAlgo_Builder {
    constructor();
  }

  export declare class BOPAlgo_Builder_2 extends BOPAlgo_Builder {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_BuilderFace extends BOPAlgo_BuilderArea {
  SetFace(theFace: TopoDS_Face): void;
  Face(): TopoDS_Face;
  Perform(): void;
  Orientation(): TopAbs_Orientation;
  delete(): void;
}

  export declare class BOPAlgo_BuilderFace_1 extends BOPAlgo_BuilderFace {
    constructor();
  }

  export declare class BOPAlgo_BuilderFace_2 extends BOPAlgo_BuilderFace {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_Algo extends BOPAlgo_Options {
  Perform(): void;
  delete(): void;
}

export declare class BOPAlgo_RemoveFeatures extends BOPAlgo_BuilderShape {
  constructor()
  SetShape(theShape: TopoDS_Shape): void;
  InputShape(): TopoDS_Shape;
  AddFaceToRemove(theFace: TopoDS_Shape): void;
  AddFacesToRemove(theFaces: TopTools_ListOfShape): void;
  FacesToRemove(): TopTools_ListOfShape;
  Perform(): void;
  Clear(): void;
  delete(): void;
}

export declare class BOPAlgo_ListOfEdgeInfo extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BOPAlgo_ListOfEdgeInfo): BOPAlgo_ListOfEdgeInfo;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BOPAlgo_EdgeInfo;
  First_2(): BOPAlgo_EdgeInfo;
  Last_1(): BOPAlgo_EdgeInfo;
  Last_2(): BOPAlgo_EdgeInfo;
  Append_1(theItem: BOPAlgo_EdgeInfo): BOPAlgo_EdgeInfo;
  Append_3(theOther: BOPAlgo_ListOfEdgeInfo): void;
  Prepend_1(theItem: BOPAlgo_EdgeInfo): BOPAlgo_EdgeInfo;
  Prepend_2(theOther: BOPAlgo_ListOfEdgeInfo): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BOPAlgo_ListOfEdgeInfo_1 extends BOPAlgo_ListOfEdgeInfo {
    constructor();
  }

  export declare class BOPAlgo_ListOfEdgeInfo_2 extends BOPAlgo_ListOfEdgeInfo {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPAlgo_ListOfEdgeInfo_3 extends BOPAlgo_ListOfEdgeInfo {
    constructor(theOther: BOPAlgo_ListOfEdgeInfo);
  }

export declare class BOPAlgo_EdgeInfo {
  constructor()
  SetEdge(theE: TopoDS_Edge): void;
  Edge(): TopoDS_Edge;
  SetPassed(theFlag: Standard_Boolean): void;
  Passed(): Standard_Boolean;
  SetInFlag(theFlag: Standard_Boolean): void;
  IsIn(): Standard_Boolean;
  SetAngle(theAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  IsInside(): Standard_Boolean;
  SetIsInside(theIsInside: Standard_Boolean): void;
  delete(): void;
}

export declare class BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo): void;
  Assign(theOther: BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo): BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: BOPAlgo_ListOfEdgeInfo): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: BOPAlgo_ListOfEdgeInfo): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): BOPAlgo_ListOfEdgeInfo;
  ChangeFromIndex(theIndex: Standard_Integer): BOPAlgo_ListOfEdgeInfo;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): BOPAlgo_ListOfEdgeInfo;
  Seek(theKey1: TopoDS_Shape): BOPAlgo_ListOfEdgeInfo;
  ChangeSeek(theKey1: TopoDS_Shape): BOPAlgo_ListOfEdgeInfo;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_1 extends BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo {
    constructor();
  }

  export declare class BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_2 extends BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_3 extends BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo {
    constructor(theOther: BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo);
  }

export declare class BOPAlgo_BuilderArea extends BOPAlgo_Algo {
  SetContext(theContext: Handle_IntTools_Context): void;
  Shapes(): TopTools_ListOfShape;
  SetShapes(theLS: TopTools_ListOfShape): void;
  Loops(): TopTools_ListOfShape;
  Areas(): TopTools_ListOfShape;
  SetAvoidInternalShapes(theAvoidInternal: Standard_Boolean): void;
  IsAvoidInternalShapes(): Standard_Boolean;
  delete(): void;
}

export declare type BOPAlgo_CheckStatus = {
  BOPAlgo_CheckUnknown: {};
  BOPAlgo_BadType: {};
  BOPAlgo_SelfIntersect: {};
  BOPAlgo_TooSmallEdge: {};
  BOPAlgo_NonRecoverableFace: {};
  BOPAlgo_IncompatibilityOfVertex: {};
  BOPAlgo_IncompatibilityOfEdge: {};
  BOPAlgo_IncompatibilityOfFace: {};
  BOPAlgo_OperationAborted: {};
  BOPAlgo_GeomAbs_C0: {};
  BOPAlgo_InvalidCurveOnSurface: {};
  BOPAlgo_NotValid: {};
}

export declare class BOPAlgo_ArgumentAnalyzer extends BOPAlgo_Algo {
  constructor()
  SetShape1(TheShape: TopoDS_Shape): void;
  SetShape2(TheShape: TopoDS_Shape): void;
  GetShape1(): TopoDS_Shape;
  GetShape2(): TopoDS_Shape;
  OperationType(): BOPAlgo_Operation;
  StopOnFirstFaulty(): Standard_Boolean;
  ArgumentTypeMode(): Standard_Boolean;
  SelfInterMode(): Standard_Boolean;
  SmallEdgeMode(): Standard_Boolean;
  RebuildFaceMode(): Standard_Boolean;
  TangentMode(): Standard_Boolean;
  MergeVertexMode(): Standard_Boolean;
  MergeEdgeMode(): Standard_Boolean;
  ContinuityMode(): Standard_Boolean;
  CurveOnSurfaceMode(): Standard_Boolean;
  Perform(): void;
  HasFaulty(): Standard_Boolean;
  GetCheckResult(): BOPAlgo_ListOfCheckResult;
  delete(): void;
}

export declare class BOPAlgo_MakeConnected extends BOPAlgo_Options {
  constructor()
  SetArguments(theArgs: TopTools_ListOfShape): void;
  AddArgument(theS: TopoDS_Shape): void;
  Arguments(): TopTools_ListOfShape;
  Perform(): void;
  MakePeriodic(theParams: any): void;
  RepeatShape(theDirectionID: Graphic3d_ZLayerId, theTimes: Graphic3d_ZLayerId): void;
  ClearRepetitions(): void;
  PeriodicityTool(): BOPAlgo_MakePeriodic;
  MaterialsOnPositiveSide(theS: TopoDS_Shape): TopTools_ListOfShape;
  MaterialsOnNegativeSide(theS: TopoDS_Shape): TopTools_ListOfShape;
  History(): Handle_BRepTools_History;
  GetModified(theS: TopoDS_Shape): TopTools_ListOfShape;
  GetOrigins(theS: TopoDS_Shape): TopTools_ListOfShape;
  Shape(): TopoDS_Shape;
  PeriodicShape(): TopoDS_Shape;
  Clear(): void;
  delete(): void;
}

export declare class BOPAlgo_WireEdgeSet {
  Clear(): void;
  SetFace(aF: TopoDS_Face): void;
  Face(): TopoDS_Face;
  AddStartElement(sS: TopoDS_Shape): void;
  StartElements(): TopTools_ListOfShape;
  AddShape(sS: TopoDS_Shape): void;
  Shapes(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BOPAlgo_WireEdgeSet_1 extends BOPAlgo_WireEdgeSet {
    constructor();
  }

  export declare class BOPAlgo_WireEdgeSet_2 extends BOPAlgo_WireEdgeSet {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_ShellSplitter extends BOPAlgo_Algo {
  AddStartElement(theS: TopoDS_Shape): void;
  StartElements(): TopTools_ListOfShape;
  Perform(): void;
  Shells(): TopTools_ListOfShape;
  static SplitBlock(theCB: BOPTools_ConnexityBlock): void;
  delete(): void;
}

  export declare class BOPAlgo_ShellSplitter_1 extends BOPAlgo_ShellSplitter {
    constructor();
  }

  export declare class BOPAlgo_ShellSplitter_2 extends BOPAlgo_ShellSplitter {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_CellsBuilder extends BOPAlgo_Builder {
  Clear(): void;
  AddToResult(theLSToTake: TopTools_ListOfShape, theLSToAvoid: TopTools_ListOfShape, theMaterial: Graphic3d_ZLayerId, theUpdate: Standard_Boolean): void;
  AddAllToResult(theMaterial: Graphic3d_ZLayerId, theUpdate: Standard_Boolean): void;
  RemoveFromResult(theLSToTake: TopTools_ListOfShape, theLSToAvoid: TopTools_ListOfShape): void;
  RemoveAllFromResult(): void;
  RemoveInternalBoundaries(): void;
  GetAllParts(): TopoDS_Shape;
  MakeContainers(): void;
  delete(): void;
}

  export declare class BOPAlgo_CellsBuilder_1 extends BOPAlgo_CellsBuilder {
    constructor();
  }

  export declare class BOPAlgo_CellsBuilder_2 extends BOPAlgo_CellsBuilder {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_Options {
  Allocator(): Handle_NCollection_BaseAllocator;
  Clear(): void;
  AddError(theAlert: Handle_Message_Alert): void;
  AddWarning(theAlert: Handle_Message_Alert): void;
  HasErrors(): Standard_Boolean;
  HasError(theType: Handle_Standard_Type): Standard_Boolean;
  HasWarnings(): Standard_Boolean;
  HasWarning(theType: Handle_Standard_Type): Standard_Boolean;
  GetReport(): Handle_Message_Report;
  DumpErrors(theOS: Standard_OStream): void;
  DumpWarnings(theOS: Standard_OStream): void;
  ClearWarnings(): void;
  static GetParallelMode(): Standard_Boolean;
  static SetParallelMode(theNewMode: Standard_Boolean): void;
  SetRunParallel(theFlag: Standard_Boolean): void;
  RunParallel(): Standard_Boolean;
  SetFuzzyValue(theFuzz: Quantity_AbsorbedDose): void;
  FuzzyValue(): Quantity_AbsorbedDose;
  SetProgressIndicator(theProgress: Message_ProgressScope): void;
  SetUseOBB(theUseOBB: Standard_Boolean): void;
  UseOBB(): Standard_Boolean;
  delete(): void;
}

  export declare class BOPAlgo_Options_1 extends BOPAlgo_Options {
    constructor();
  }

  export declare class BOPAlgo_Options_2 extends BOPAlgo_Options {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_CheckResult {
  constructor()
  SetShape1(TheShape: TopoDS_Shape): void;
  AddFaultyShape1(TheShape: TopoDS_Shape): void;
  SetShape2(TheShape: TopoDS_Shape): void;
  AddFaultyShape2(TheShape: TopoDS_Shape): void;
  GetShape1(): TopoDS_Shape;
  GetShape2(): TopoDS_Shape;
  GetFaultyShapes1(): TopTools_ListOfShape;
  GetFaultyShapes2(): TopTools_ListOfShape;
  SetCheckStatus(TheStatus: BOPAlgo_CheckStatus): void;
  GetCheckStatus(): BOPAlgo_CheckStatus;
  SetMaxDistance1(theDist: Quantity_AbsorbedDose): void;
  SetMaxDistance2(theDist: Quantity_AbsorbedDose): void;
  SetMaxParameter1(thePar: Quantity_AbsorbedDose): void;
  SetMaxParameter2(thePar: Quantity_AbsorbedDose): void;
  GetMaxDistance1(): Quantity_AbsorbedDose;
  GetMaxDistance2(): Quantity_AbsorbedDose;
  GetMaxParameter1(): Quantity_AbsorbedDose;
  GetMaxParameter2(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BOPAlgo_AlertNoFiller extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertIntersectionFailed extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertBuilderFailed extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToMakeClosedEdgeOnFace extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnknownShape extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertBOPNotAllowed extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertRemoveFeaturesFailed extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToMakePeriodic extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertBadPositioning extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertBuildingPCurveFailed extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertMultipleArguments extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertMultiDimensionalArguments extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertNoPeriodicityRequired extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToRemoveTheFeature extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToRepeat extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertBOPNotSet extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertRemovalOfIBForSolidsFailed extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertEmptyShape extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertSelfInterferingShape extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertRemovalOfIBForFacesFailed extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToOrientTheShape extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertNullInputShapes extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertShapeIsNotPeriodic extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertNotSplittableEdge extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnsupportedType extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToTrim extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertRemovalOfIBForMDimShapes extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertFaceBuilderUnusedEdges extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToMakeIdentical extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertPostTreatFF extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertAcquiredSelfIntersection extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertSolidBuilderFailed extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertSolidBuilderUnusedFaces extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertUnableToGlue extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertShellSplitterFailed extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertNoFacesToRemove extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertTooSmallEdge extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertTooFewArguments extends Message_Alert {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertIntersectionOfPairOfShapesFailed extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPAlgo_AlertRemovalOfIBForEdgesFailed extends TopoDS_AlertWithShape {
  constructor(theShape: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type BOPAlgo_GlueEnum = {
  BOPAlgo_GlueOff: {};
  BOPAlgo_GlueShift: {};
  BOPAlgo_GlueFull: {};
}

export declare class BOPAlgo_Tools {
  constructor();
  static FillMap_2(thePB1: Handle_BOPDS_PaveBlock, theF: Graphic3d_ZLayerId, theMILI: BOPDS_IndexedDataMapOfPaveBlockListOfInteger, theAllocator: Handle_NCollection_BaseAllocator): void;
  static ComputeToleranceOfCB(theCB: Handle_BOPDS_CommonBlock, theDS: BOPDS_PDS, theContext: Handle_IntTools_Context): Quantity_AbsorbedDose;
  static EdgesToWires(theEdges: TopoDS_Shape, theWires: TopoDS_Shape, theShared: Standard_Boolean, theAngTol: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static WiresToFaces(theWires: TopoDS_Shape, theFaces: TopoDS_Shape, theAngTol: Quantity_AbsorbedDose): Standard_Boolean;
  static IntersectVertices(theVertices: TopTools_IndexedDataMapOfShapeReal, theFuzzyValue: Quantity_AbsorbedDose, theChains: TopTools_ListOfListOfShape): void;
  static ClassifyFaces(theFaces: TopTools_ListOfShape, theSolids: TopTools_ListOfShape, theRunParallel: Standard_Boolean, theContext: Handle_IntTools_Context, theInParts: TopTools_IndexedDataMapOfShapeListOfShape, theShapeBoxMap: TopTools_DataMapOfShapeBox, theSolidsIF: TopTools_DataMapOfShapeListOfShape): void;
  static FillInternals(theSolids: TopTools_ListOfShape, theParts: TopTools_ListOfShape, theImages: TopTools_DataMapOfShapeListOfShape, theContext: Handle_IntTools_Context): void;
  static TrsfToPoint(theBox1: Bnd_Box, theBox2: Bnd_Box, theTrsf: gp_Trsf, thePoint: gp_Pnt, theCriteria: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BOPAlgo_ToolsProvider extends BOPAlgo_Builder {
  Clear(): void;
  AddTool(theShape: TopoDS_Shape): void;
  SetTools(theShapes: TopTools_ListOfShape): void;
  Tools(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BOPAlgo_ToolsProvider_1 extends BOPAlgo_ToolsProvider {
    constructor();
  }

  export declare class BOPAlgo_ToolsProvider_2 extends BOPAlgo_ToolsProvider {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPAlgo_Splitter extends BOPAlgo_ToolsProvider {
  Perform(): void;
  delete(): void;
}

  export declare class BOPAlgo_Splitter_1 extends BOPAlgo_Splitter {
    constructor();
  }

  export declare class BOPAlgo_Splitter_2 extends BOPAlgo_Splitter {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class ShapeProcessAPI_ApplySequence {
  constructor(rscName: Standard_CString, seqName: Standard_CString)
  Context(): Handle_ShapeProcess_ShapeContext;
  PrepareShape(shape: TopoDS_Shape, fillmap: Standard_Boolean, until: TopAbs_ShapeEnum, theProgress: Message_ProgressRange): TopoDS_Shape;
  ClearMap(): void;
  Map(): TopTools_DataMapOfShapeShape;
  PrintPreparationResult(): void;
  delete(): void;
}

export declare class RWStepGeom_RWBSplineCurveWithKnotsAndRationalBSplineCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve): void;
  Share(ent: Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWBezierSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BezierSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BezierSurface): void;
  Share(ent: Handle_StepGeom_BezierSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBezierSurfaceAndRationalBSplineSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface): void;
  Share(ent: Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBSplineSurfaceWithKnotsAndRationalBSplineSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface): void;
  Share(ent: Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWParabola {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Parabola): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Parabola): void;
  Share(ent: Handle_StepGeom_Parabola, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWOuterBoundaryCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_OuterBoundaryCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_OuterBoundaryCurve): void;
  Share(ent: Handle_StepGeom_OuterBoundaryCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCircle {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Circle): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Circle): void;
  Share(ent: Handle_StepGeom_Circle, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWPointReplica {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_PointReplica): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_PointReplica): void;
  Share(ent: Handle_StepGeom_PointReplica, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurfacePatch {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SurfacePatch): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SurfacePatch): void;
  Share(ent: Handle_StepGeom_SurfacePatch, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWDirection {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Direction): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Direction): void;
  Check(ent: Handle_StepGeom_Direction, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWGeometricRepresentationContextAndParametricRepresentationContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext): void;
  Share(ent: Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWUniformCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_UniformCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_UniformCurve): void;
  Share(ent: Handle_StepGeom_UniformCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWConic {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Conic): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Conic): void;
  Share(ent: Handle_StepGeom_Conic, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurfaceCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SurfaceCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SurfaceCurve): void;
  Share(ent: Handle_StepGeom_SurfaceCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCurveReplica {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CurveReplica): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CurveReplica): void;
  Share(ent: Handle_StepGeom_CurveReplica, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBSplineCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BSplineCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BSplineCurve): void;
  Share(ent: Handle_StepGeom_BSplineCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBezierCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BezierCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BezierCurve): void;
  Share(ent: Handle_StepGeom_BezierCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBSplineSurfaceWithKnots {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BSplineSurfaceWithKnots): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BSplineSurfaceWithKnots): void;
  Share(ent: Handle_StepGeom_BSplineSurfaceWithKnots, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_BSplineSurfaceWithKnots, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurfaceReplica {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SurfaceReplica): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SurfaceReplica): void;
  Share(ent: Handle_StepGeom_SurfaceReplica, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCylindricalSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CylindricalSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CylindricalSurface): void;
  Share(ent: Handle_StepGeom_CylindricalSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWEllipse {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Ellipse): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Ellipse): void;
  Share(ent: Handle_StepGeom_Ellipse, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_Ellipse, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWOffsetSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_OffsetSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_OffsetSurface): void;
  Share(ent: Handle_StepGeom_OffsetSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWAxis2Placement3d {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Axis2Placement3d): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Axis2Placement3d): void;
  Share(ent: Handle_StepGeom_Axis2Placement3d, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWUniformCurveAndRationalBSplineCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_UniformCurveAndRationalBSplineCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_UniformCurveAndRationalBSplineCurve): void;
  Share(ent: Handle_StepGeom_UniformCurveAndRationalBSplineCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWUniformSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_UniformSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_UniformSurface): void;
  Share(ent: Handle_StepGeom_UniformSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBoundaryCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BoundaryCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BoundaryCurve): void;
  Share(ent: Handle_StepGeom_BoundaryCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWElementarySurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_ElementarySurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_ElementarySurface): void;
  Share(ent: Handle_StepGeom_ElementarySurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurfaceOfRevolution {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SurfaceOfRevolution): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SurfaceOfRevolution): void;
  Share(ent: Handle_StepGeom_SurfaceOfRevolution, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWPlane {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Plane): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Plane): void;
  Share(ent: Handle_StepGeom_Plane, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWOffsetCurve3d {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_OffsetCurve3d): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_OffsetCurve3d): void;
  Share(ent: Handle_StepGeom_OffsetCurve3d, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWHyperbola {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Hyperbola): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Hyperbola): void;
  Share(ent: Handle_StepGeom_Hyperbola, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBezierCurveAndRationalBSplineCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BezierCurveAndRationalBSplineCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BezierCurveAndRationalBSplineCurve): void;
  Share(ent: Handle_StepGeom_BezierCurveAndRationalBSplineCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWQuasiUniformSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_QuasiUniformSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_QuasiUniformSurface): void;
  Share(ent: Handle_StepGeom_QuasiUniformSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCompositeCurveOnSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CompositeCurveOnSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CompositeCurveOnSurface): void;
  Share(ent: Handle_StepGeom_CompositeCurveOnSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWConicalSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_ConicalSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_ConicalSurface): void;
  Share(ent: Handle_StepGeom_ConicalSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWPoint {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Point): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Point): void;
  delete(): void;
}

export declare class RWStepGeom_RWPointOnCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_PointOnCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_PointOnCurve): void;
  Share(ent: Handle_StepGeom_PointOnCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWRationalBSplineSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_RationalBSplineSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_RationalBSplineSurface): void;
  Share(ent: Handle_StepGeom_RationalBSplineSurface, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_RationalBSplineSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWCurveBoundedSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CurveBoundedSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CurveBoundedSurface): void;
  Share(ent: Handle_StepGeom_CurveBoundedSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWEvaluatedDegeneratePcurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_EvaluatedDegeneratePcurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_EvaluatedDegeneratePcurve): void;
  Share(ent: Handle_StepGeom_EvaluatedDegeneratePcurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWToroidalSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_ToroidalSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_ToroidalSurface): void;
  Share(ent: Handle_StepGeom_ToroidalSurface, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_ToroidalSurface, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWIntersectionCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_IntersectionCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_IntersectionCurve): void;
  Share(ent: Handle_StepGeom_IntersectionCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWQuasiUniformCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_QuasiUniformCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_QuasiUniformCurve): void;
  Share(ent: Handle_StepGeom_QuasiUniformCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Surface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Surface): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurfaceCurveAndBoundedCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SurfaceCurveAndBoundedCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SurfaceCurveAndBoundedCurve): void;
  Share(ent: Handle_StepGeom_SurfaceCurveAndBoundedCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWPointOnSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_PointOnSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_PointOnSurface): void;
  Share(ent: Handle_StepGeom_PointOnSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCartesianTransformationOperator {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CartesianTransformationOperator): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CartesianTransformationOperator): void;
  Share(ent: Handle_StepGeom_CartesianTransformationOperator, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWAxis1Placement {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Axis1Placement): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Axis1Placement): void;
  Share(ent: Handle_StepGeom_Axis1Placement, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWQuasiUniformCurveAndRationalBSplineCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve): void;
  Share(ent: Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWDegenerateToroidalSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_DegenerateToroidalSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_DegenerateToroidalSurface): void;
  Share(ent: Handle_StepGeom_DegenerateToroidalSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBoundedCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BoundedCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BoundedCurve): void;
  delete(): void;
}

export declare class RWStepGeom_RWSeamCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SeamCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SeamCurve): void;
  Share(ent: Handle_StepGeom_SeamCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWQuasiUniformSurfaceAndRationalBSplineSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface): void;
  Share(ent: Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWGeometricRepresentationContextAndGlobalUnitAssignedContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext): void;
  Share(ent: Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWGeometricRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_GeometricRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_GeometricRepresentationItem): void;
  delete(): void;
}

export declare class RWStepGeom_RWCartesianPoint {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CartesianPoint): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CartesianPoint): void;
  delete(): void;
}

export declare class RWStepGeom_RWRationalBSplineCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_RationalBSplineCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_RationalBSplineCurve): void;
  Share(ent: Handle_StepGeom_RationalBSplineCurve, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_RationalBSplineCurve, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWRectangularTrimmedSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_RectangularTrimmedSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_RectangularTrimmedSurface): void;
  Share(ent: Handle_StepGeom_RectangularTrimmedSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWOrientedSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_OrientedSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_OrientedSurface): void;
  Share(ent: Handle_StepGeom_OrientedSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCartesianTransformationOperator3d {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CartesianTransformationOperator3d): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CartesianTransformationOperator3d): void;
  Share(ent: Handle_StepGeom_CartesianTransformationOperator3d, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWRectangularCompositeSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_RectangularCompositeSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_RectangularCompositeSurface): void;
  Share(ent: Handle_StepGeom_RectangularCompositeSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSurfaceOfLinearExtrusion {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SurfaceOfLinearExtrusion): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SurfaceOfLinearExtrusion): void;
  Share(ent: Handle_StepGeom_SurfaceOfLinearExtrusion, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWReparametrisedCompositeCurveSegment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_ReparametrisedCompositeCurveSegment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_ReparametrisedCompositeCurveSegment): void;
  Share(ent: Handle_StepGeom_ReparametrisedCompositeCurveSegment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCompositeCurveSegment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CompositeCurveSegment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CompositeCurveSegment): void;
  Share(ent: Handle_StepGeom_CompositeCurveSegment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBSplineCurveWithKnots {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BSplineCurveWithKnots): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BSplineCurveWithKnots): void;
  Share(ent: Handle_StepGeom_BSplineCurveWithKnots, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_BSplineCurveWithKnots, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWVector {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Vector): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Vector): void;
  Share(ent: Handle_StepGeom_Vector, iter: Interface_EntityIterator): void;
  Check(ent: Handle_StepGeom_Vector, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  delete(): void;
}

export declare class RWStepGeom_RWAxis2Placement2d {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Axis2Placement2d): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Axis2Placement2d): void;
  Share(ent: Handle_StepGeom_Axis2Placement2d, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWUniformSurfaceAndRationalBSplineSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface): void;
  Share(ent: Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSphericalSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SphericalSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SphericalSurface): void;
  Share(ent: Handle_StepGeom_SphericalSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCompositeCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_CompositeCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_CompositeCurve): void;
  Share(ent: Handle_StepGeom_CompositeCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Curve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Curve): void;
  delete(): void;
}

export declare class RWStepGeom_RWPcurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Pcurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Pcurve): void;
  Share(ent: Handle_StepGeom_Pcurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWPlacement {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Placement): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Placement): void;
  Share(ent: Handle_StepGeom_Placement, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWLine {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Line): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Line): void;
  Share(ent: Handle_StepGeom_Line, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWGeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx): void;
  Share(ent: Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWPolyline {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_Polyline): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_Polyline): void;
  Share(ent: Handle_StepGeom_Polyline, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWSweptSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_SweptSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_SweptSurface): void;
  Share(ent: Handle_StepGeom_SweptSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWGeometricRepresentationContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_GeometricRepresentationContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_GeometricRepresentationContext): void;
  delete(): void;
}

export declare class RWStepGeom_RWTrimmedCurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_TrimmedCurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_TrimmedCurve): void;
  Share(ent: Handle_StepGeom_TrimmedCurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWDegeneratePcurve {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_DegeneratePcurve): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_DegeneratePcurve): void;
  Share(ent: Handle_StepGeom_DegeneratePcurve, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBSplineSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BSplineSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BSplineSurface): void;
  Share(ent: Handle_StepGeom_BSplineSurface, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepGeom_RWBoundedSurface {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepGeom_BoundedSurface): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepGeom_BoundedSurface): void;
  delete(): void;
}

export declare class AppBlend_Approx {
  IsDone(): Standard_Boolean;
  SurfShape(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, NbUPoles: Graphic3d_ZLayerId, NbVPoles: Graphic3d_ZLayerId, NbUKnots: Graphic3d_ZLayerId, NbVKnots: Graphic3d_ZLayerId): void;
  Surface(TPoles: TColgp_Array2OfPnt, TWeights: TColStd_Array2OfReal, TUKnots: TColStd_Array1OfReal, TVKnots: TColStd_Array1OfReal, TUMults: TColStd_Array1OfInteger, TVMults: TColStd_Array1OfInteger): void;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  SurfPoles(): TColgp_Array2OfPnt;
  SurfWeights(): TColStd_Array2OfReal;
  SurfUKnots(): TColStd_Array1OfReal;
  SurfVKnots(): TColStd_Array1OfReal;
  SurfUMults(): TColStd_Array1OfInteger;
  SurfVMults(): TColStd_Array1OfInteger;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curves2dShape(Degree: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId): void;
  Curve2d(Index: Graphic3d_ZLayerId, TPoles: TColgp_Array1OfPnt2d, TKnots: TColStd_Array1OfReal, TMults: TColStd_Array1OfInteger): void;
  Curves2dDegree(): Graphic3d_ZLayerId;
  Curve2dPoles(Index: Graphic3d_ZLayerId): TColgp_Array1OfPnt2d;
  Curves2dKnots(): TColStd_Array1OfReal;
  Curves2dMults(): TColStd_Array1OfInteger;
  TolReached(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  TolCurveOnSurf(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_HLRTopoBRep_OutLiner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: HLRTopoBRep_OutLiner): void;
  get(): HLRTopoBRep_OutLiner;
  delete(): void;
}

  export declare class Handle_HLRTopoBRep_OutLiner_1 extends Handle_HLRTopoBRep_OutLiner {
    constructor();
  }

  export declare class Handle_HLRTopoBRep_OutLiner_2 extends Handle_HLRTopoBRep_OutLiner {
    constructor(thePtr: HLRTopoBRep_OutLiner);
  }

  export declare class Handle_HLRTopoBRep_OutLiner_3 extends Handle_HLRTopoBRep_OutLiner {
    constructor(theHandle: Handle_HLRTopoBRep_OutLiner);
  }

  export declare class Handle_HLRTopoBRep_OutLiner_4 extends Handle_HLRTopoBRep_OutLiner {
    constructor(theHandle: Handle_HLRTopoBRep_OutLiner);
  }

export declare class HLRTopoBRep_OutLiner extends Standard_Transient {
  OriginalShape_1(OriS: TopoDS_Shape): void;
  OriginalShape_2(): TopoDS_Shape;
  OutLinedShape_1(OutS: TopoDS_Shape): void;
  OutLinedShape_2(): TopoDS_Shape;
  DataStructure(): HLRTopoBRep_Data;
  Fill(P: HLRAlgo_Projector, MST: BRepTopAdaptor_MapOfShapeTool, nbIso: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class HLRTopoBRep_OutLiner_1 extends HLRTopoBRep_OutLiner {
    constructor();
  }

  export declare class HLRTopoBRep_OutLiner_2 extends HLRTopoBRep_OutLiner {
    constructor(OriSh: TopoDS_Shape);
  }

  export declare class HLRTopoBRep_OutLiner_3 extends HLRTopoBRep_OutLiner {
    constructor(OriS: TopoDS_Shape, OutS: TopoDS_Shape);
  }

export declare class HLRTopoBRep_ListOfVData extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: HLRTopoBRep_ListOfVData): HLRTopoBRep_ListOfVData;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): HLRTopoBRep_VData;
  First_2(): HLRTopoBRep_VData;
  Last_1(): HLRTopoBRep_VData;
  Last_2(): HLRTopoBRep_VData;
  Append_1(theItem: HLRTopoBRep_VData): HLRTopoBRep_VData;
  Append_3(theOther: HLRTopoBRep_ListOfVData): void;
  Prepend_1(theItem: HLRTopoBRep_VData): HLRTopoBRep_VData;
  Prepend_2(theOther: HLRTopoBRep_ListOfVData): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class HLRTopoBRep_ListOfVData_1 extends HLRTopoBRep_ListOfVData {
    constructor();
  }

  export declare class HLRTopoBRep_ListOfVData_2 extends HLRTopoBRep_ListOfVData {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRTopoBRep_ListOfVData_3 extends HLRTopoBRep_ListOfVData {
    constructor(theOther: HLRTopoBRep_ListOfVData);
  }

export declare class HLRTopoBRep_DSFiller {
  constructor();
  static Insert(S: TopoDS_Shape, FO: Contap_Contour, DS: HLRTopoBRep_Data, MST: BRepTopAdaptor_MapOfShapeTool, nbIso: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class HLRTopoBRep_FaceIsoLiner {
  constructor();
  static Perform(FI: Graphic3d_ZLayerId, F: TopoDS_Face, DS: HLRTopoBRep_Data, nbIsos: Graphic3d_ZLayerId): void;
  static MakeVertex(E: TopoDS_Edge, P: gp_Pnt, Par: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, DS: HLRTopoBRep_Data): TopoDS_Vertex;
  static MakeIsoLine(F: TopoDS_Face, Iso: Handle_Geom2d_Line, V1: TopoDS_Vertex, V2: TopoDS_Vertex, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, DS: HLRTopoBRep_Data): void;
  delete(): void;
}

export declare class HLRTopoBRep_FaceData {
  constructor()
  FaceIntL(): TopTools_ListOfShape;
  FaceOutL(): TopTools_ListOfShape;
  FaceIsoL(): TopTools_ListOfShape;
  AddIntL(): TopTools_ListOfShape;
  AddOutL(): TopTools_ListOfShape;
  AddIsoL(): TopTools_ListOfShape;
  delete(): void;
}

export declare class HLRTopoBRep_Data {
  constructor()
  Clear(): void;
  Clean(): void;
  EdgeHasSplE(E: TopoDS_Edge): Standard_Boolean;
  FaceHasIntL(F: TopoDS_Face): Standard_Boolean;
  FaceHasOutL(F: TopoDS_Face): Standard_Boolean;
  FaceHasIsoL(F: TopoDS_Face): Standard_Boolean;
  IsSplEEdgeEdge(E1: TopoDS_Edge, E2: TopoDS_Edge): Standard_Boolean;
  IsIntLFaceEdge(F: TopoDS_Face, E: TopoDS_Edge): Standard_Boolean;
  IsOutLFaceEdge(F: TopoDS_Face, E: TopoDS_Edge): Standard_Boolean;
  IsIsoLFaceEdge(F: TopoDS_Face, E: TopoDS_Edge): Standard_Boolean;
  NewSOldS(New: TopoDS_Shape): TopoDS_Shape;
  EdgeSplE(E: TopoDS_Edge): TopTools_ListOfShape;
  FaceIntL(F: TopoDS_Face): TopTools_ListOfShape;
  FaceOutL(F: TopoDS_Face): TopTools_ListOfShape;
  FaceIsoL(F: TopoDS_Face): TopTools_ListOfShape;
  IsOutV(V: TopoDS_Vertex): Standard_Boolean;
  IsIntV(V: TopoDS_Vertex): Standard_Boolean;
  AddOldS(NewS: TopoDS_Shape, OldS: TopoDS_Shape): void;
  AddSplE(E: TopoDS_Edge): TopTools_ListOfShape;
  AddIntL(F: TopoDS_Face): TopTools_ListOfShape;
  AddOutL(F: TopoDS_Face): TopTools_ListOfShape;
  AddIsoL(F: TopoDS_Face): TopTools_ListOfShape;
  AddOutV(V: TopoDS_Vertex): void;
  AddIntV(V: TopoDS_Vertex): void;
  InitEdge(): void;
  MoreEdge(): Standard_Boolean;
  NextEdge(): void;
  Edge(): TopoDS_Edge;
  InitVertex(E: TopoDS_Edge): void;
  MoreVertex(): Standard_Boolean;
  NextVertex(): void;
  Vertex(): TopoDS_Vertex;
  Parameter(): Quantity_AbsorbedDose;
  InsertBefore(V: TopoDS_Vertex, P: Quantity_AbsorbedDose): void;
  Append(V: TopoDS_Vertex, P: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class HLRTopoBRep_MapOfShapeListOfVData extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: HLRTopoBRep_MapOfShapeListOfVData): void;
  Assign(theOther: HLRTopoBRep_MapOfShapeListOfVData): HLRTopoBRep_MapOfShapeListOfVData;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: HLRTopoBRep_ListOfVData): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: HLRTopoBRep_ListOfVData): HLRTopoBRep_ListOfVData;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): HLRTopoBRep_ListOfVData;
  ChangeSeek(theKey: TopoDS_Shape): HLRTopoBRep_ListOfVData;
  ChangeFind(theKey: TopoDS_Shape): HLRTopoBRep_ListOfVData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class HLRTopoBRep_MapOfShapeListOfVData_1 extends HLRTopoBRep_MapOfShapeListOfVData {
    constructor();
  }

  export declare class HLRTopoBRep_MapOfShapeListOfVData_2 extends HLRTopoBRep_MapOfShapeListOfVData {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRTopoBRep_MapOfShapeListOfVData_3 extends HLRTopoBRep_MapOfShapeListOfVData {
    constructor(theOther: HLRTopoBRep_MapOfShapeListOfVData);
  }

export declare class HLRTopoBRep_VData {
  Parameter(): Quantity_AbsorbedDose;
  Vertex(): TopoDS_Shape;
  delete(): void;
}

  export declare class HLRTopoBRep_VData_1 extends HLRTopoBRep_VData {
    constructor();
  }

  export declare class HLRTopoBRep_VData_2 extends HLRTopoBRep_VData {
    constructor(P: Quantity_AbsorbedDose, V: TopoDS_Shape);
  }

export declare class HLRTopoBRep_DataMapOfShapeFaceData extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: HLRTopoBRep_DataMapOfShapeFaceData): void;
  Assign(theOther: HLRTopoBRep_DataMapOfShapeFaceData): HLRTopoBRep_DataMapOfShapeFaceData;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: HLRTopoBRep_FaceData): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: HLRTopoBRep_FaceData): HLRTopoBRep_FaceData;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): HLRTopoBRep_FaceData;
  ChangeSeek(theKey: TopoDS_Shape): HLRTopoBRep_FaceData;
  ChangeFind(theKey: TopoDS_Shape): HLRTopoBRep_FaceData;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class HLRTopoBRep_DataMapOfShapeFaceData_1 extends HLRTopoBRep_DataMapOfShapeFaceData {
    constructor();
  }

  export declare class HLRTopoBRep_DataMapOfShapeFaceData_2 extends HLRTopoBRep_DataMapOfShapeFaceData {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class HLRTopoBRep_DataMapOfShapeFaceData_3 extends HLRTopoBRep_DataMapOfShapeFaceData {
    constructor(theOther: HLRTopoBRep_DataMapOfShapeFaceData);
  }

export declare class Handle_FEmTool_ProfileMatrix {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_ProfileMatrix): void;
  get(): FEmTool_ProfileMatrix;
  delete(): void;
}

  export declare class Handle_FEmTool_ProfileMatrix_1 extends Handle_FEmTool_ProfileMatrix {
    constructor();
  }

  export declare class Handle_FEmTool_ProfileMatrix_2 extends Handle_FEmTool_ProfileMatrix {
    constructor(thePtr: FEmTool_ProfileMatrix);
  }

  export declare class Handle_FEmTool_ProfileMatrix_3 extends Handle_FEmTool_ProfileMatrix {
    constructor(theHandle: Handle_FEmTool_ProfileMatrix);
  }

  export declare class Handle_FEmTool_ProfileMatrix_4 extends Handle_FEmTool_ProfileMatrix {
    constructor(theHandle: Handle_FEmTool_ProfileMatrix);
  }

export declare class FEmTool_ProfileMatrix extends FEmTool_SparseMatrix {
  constructor(FirstIndexes: TColStd_Array1OfInteger)
  Init(Value: Quantity_AbsorbedDose): void;
  ChangeValue(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Decompose(): Standard_Boolean;
  Solve_1(B: math_Vector, X: math_Vector): void;
  Prepare(): Standard_Boolean;
  Solve_2(B: math_Vector, Init: math_Vector, X: math_Vector, Residual: math_Vector, Tolerance: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId): void;
  Multiplied(X: math_Vector, MX: math_Vector): void;
  RowNumber(): Graphic3d_ZLayerId;
  ColNumber(): Graphic3d_ZLayerId;
  IsInProfile(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId): Standard_Boolean;
  OutM(): void;
  OutS(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_FEmTool_SparseMatrix {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_SparseMatrix): void;
  get(): FEmTool_SparseMatrix;
  delete(): void;
}

  export declare class Handle_FEmTool_SparseMatrix_1 extends Handle_FEmTool_SparseMatrix {
    constructor();
  }

  export declare class Handle_FEmTool_SparseMatrix_2 extends Handle_FEmTool_SparseMatrix {
    constructor(thePtr: FEmTool_SparseMatrix);
  }

  export declare class Handle_FEmTool_SparseMatrix_3 extends Handle_FEmTool_SparseMatrix {
    constructor(theHandle: Handle_FEmTool_SparseMatrix);
  }

  export declare class Handle_FEmTool_SparseMatrix_4 extends Handle_FEmTool_SparseMatrix {
    constructor(theHandle: Handle_FEmTool_SparseMatrix);
  }

export declare class FEmTool_SparseMatrix extends Standard_Transient {
  Init(Value: Quantity_AbsorbedDose): void;
  ChangeValue(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Decompose(): Standard_Boolean;
  Solve_1(B: math_Vector, X: math_Vector): void;
  Prepare(): Standard_Boolean;
  Solve_2(B: math_Vector, Init: math_Vector, X: math_Vector, Residual: math_Vector, Tolerance: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId): void;
  Multiplied(X: math_Vector, MX: math_Vector): void;
  RowNumber(): Graphic3d_ZLayerId;
  ColNumber(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class FEmTool_SeqOfLinConstr extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: FEmTool_SeqOfLinConstr): FEmTool_SeqOfLinConstr;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: FEmTool_ListOfVectors): void;
  Append_2(theSeq: FEmTool_SeqOfLinConstr): void;
  Prepend_1(theItem: FEmTool_ListOfVectors): void;
  Prepend_2(theSeq: FEmTool_SeqOfLinConstr): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: FEmTool_ListOfVectors): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: FEmTool_SeqOfLinConstr): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: FEmTool_SeqOfLinConstr): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: FEmTool_ListOfVectors): void;
  Split(theIndex: Standard_Integer, theSeq: FEmTool_SeqOfLinConstr): void;
  First(): FEmTool_ListOfVectors;
  ChangeFirst(): FEmTool_ListOfVectors;
  Last(): FEmTool_ListOfVectors;
  ChangeLast(): FEmTool_ListOfVectors;
  Value(theIndex: Standard_Integer): FEmTool_ListOfVectors;
  ChangeValue(theIndex: Standard_Integer): FEmTool_ListOfVectors;
  SetValue(theIndex: Standard_Integer, theItem: FEmTool_ListOfVectors): void;
  delete(): void;
}

  export declare class FEmTool_SeqOfLinConstr_1 extends FEmTool_SeqOfLinConstr {
    constructor();
  }

  export declare class FEmTool_SeqOfLinConstr_2 extends FEmTool_SeqOfLinConstr {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class FEmTool_SeqOfLinConstr_3 extends FEmTool_SeqOfLinConstr {
    constructor(theOther: FEmTool_SeqOfLinConstr);
  }

export declare class FEmTool_Assembly {
  constructor(Dependence: TColStd_Array2OfInteger, Table: Handle_FEmTool_HAssemblyTable)
  NullifyMatrix(): void;
  AddMatrix(Element: Graphic3d_ZLayerId, Dimension1: Graphic3d_ZLayerId, Dimension2: Graphic3d_ZLayerId, Mat: math_Matrix): void;
  NullifyVector(): void;
  AddVector(Element: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, Vec: math_Vector): void;
  ResetConstraint(): void;
  NullifyConstraint(): void;
  AddConstraint(IndexofConstraint: Graphic3d_ZLayerId, Element: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, LinearForm: math_Vector, Value: Quantity_AbsorbedDose): void;
  Solve(): Standard_Boolean;
  Solution(Solution: math_Vector): void;
  NbGlobVar(): Graphic3d_ZLayerId;
  GetAssemblyTable(AssTable: Handle_FEmTool_HAssemblyTable): void;
  delete(): void;
}

export declare class FEmTool_LinearTension extends FEmTool_ElementaryCriterion {
  constructor(WorkDegree: Graphic3d_ZLayerId, ConstraintOrder: GeomAbs_Shape)
  DependenceTable(): Handle_TColStd_HArray2OfInteger;
  Value(): Quantity_AbsorbedDose;
  Hessian(Dimension1: Graphic3d_ZLayerId, Dimension2: Graphic3d_ZLayerId, H: math_Matrix): void;
  Gradient(Dimension: Graphic3d_ZLayerId, G: math_Vector): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_FEmTool_LinearTension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_LinearTension): void;
  get(): FEmTool_LinearTension;
  delete(): void;
}

  export declare class Handle_FEmTool_LinearTension_1 extends Handle_FEmTool_LinearTension {
    constructor();
  }

  export declare class Handle_FEmTool_LinearTension_2 extends Handle_FEmTool_LinearTension {
    constructor(thePtr: FEmTool_LinearTension);
  }

  export declare class Handle_FEmTool_LinearTension_3 extends Handle_FEmTool_LinearTension {
    constructor(theHandle: Handle_FEmTool_LinearTension);
  }

  export declare class Handle_FEmTool_LinearTension_4 extends Handle_FEmTool_LinearTension {
    constructor(theHandle: Handle_FEmTool_LinearTension);
  }

export declare class Handle_FEmTool_HAssemblyTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_HAssemblyTable): void;
  get(): FEmTool_HAssemblyTable;
  delete(): void;
}

  export declare class Handle_FEmTool_HAssemblyTable_1 extends Handle_FEmTool_HAssemblyTable {
    constructor();
  }

  export declare class Handle_FEmTool_HAssemblyTable_2 extends Handle_FEmTool_HAssemblyTable {
    constructor(thePtr: FEmTool_HAssemblyTable);
  }

  export declare class Handle_FEmTool_HAssemblyTable_3 extends Handle_FEmTool_HAssemblyTable {
    constructor(theHandle: Handle_FEmTool_HAssemblyTable);
  }

  export declare class Handle_FEmTool_HAssemblyTable_4 extends Handle_FEmTool_HAssemblyTable {
    constructor(theHandle: Handle_FEmTool_HAssemblyTable);
  }

export declare class Handle_FEmTool_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_Curve): void;
  get(): FEmTool_Curve;
  delete(): void;
}

  export declare class Handle_FEmTool_Curve_1 extends Handle_FEmTool_Curve {
    constructor();
  }

  export declare class Handle_FEmTool_Curve_2 extends Handle_FEmTool_Curve {
    constructor(thePtr: FEmTool_Curve);
  }

  export declare class Handle_FEmTool_Curve_3 extends Handle_FEmTool_Curve {
    constructor(theHandle: Handle_FEmTool_Curve);
  }

  export declare class Handle_FEmTool_Curve_4 extends Handle_FEmTool_Curve {
    constructor(theHandle: Handle_FEmTool_Curve);
  }

export declare class FEmTool_Curve extends Standard_Transient {
  constructor(Dimension: Graphic3d_ZLayerId, NbElements: Graphic3d_ZLayerId, TheBase: Handle_PLib_Base, Tolerance: Quantity_AbsorbedDose)
  Knots(): TColStd_Array1OfReal;
  SetElement(IndexOfElement: Graphic3d_ZLayerId, Coeffs: TColStd_Array2OfReal): void;
  D0(U: Quantity_AbsorbedDose, Pnt: TColStd_Array1OfReal): void;
  D1(U: Quantity_AbsorbedDose, Vec: TColStd_Array1OfReal): void;
  D2(U: Quantity_AbsorbedDose, Vec: TColStd_Array1OfReal): void;
  Length(FirstU: Quantity_AbsorbedDose, LastU: Quantity_AbsorbedDose, Length: Quantity_AbsorbedDose): void;
  GetElement(IndexOfElement: Graphic3d_ZLayerId, Coeffs: TColStd_Array2OfReal): void;
  GetPolynom(Coeffs: TColStd_Array1OfReal): void;
  NbElements(): Graphic3d_ZLayerId;
  Dimension(): Graphic3d_ZLayerId;
  Base(): Handle_PLib_Base;
  Degree(IndexOfElement: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetDegree(IndexOfElement: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  ReduceDegree(IndexOfElement: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, NewDegree: Graphic3d_ZLayerId, MaxError: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_FEmTool_ElementaryCriterion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_ElementaryCriterion): void;
  get(): FEmTool_ElementaryCriterion;
  delete(): void;
}

  export declare class Handle_FEmTool_ElementaryCriterion_1 extends Handle_FEmTool_ElementaryCriterion {
    constructor();
  }

  export declare class Handle_FEmTool_ElementaryCriterion_2 extends Handle_FEmTool_ElementaryCriterion {
    constructor(thePtr: FEmTool_ElementaryCriterion);
  }

  export declare class Handle_FEmTool_ElementaryCriterion_3 extends Handle_FEmTool_ElementaryCriterion {
    constructor(theHandle: Handle_FEmTool_ElementaryCriterion);
  }

  export declare class Handle_FEmTool_ElementaryCriterion_4 extends Handle_FEmTool_ElementaryCriterion {
    constructor(theHandle: Handle_FEmTool_ElementaryCriterion);
  }

export declare class FEmTool_ElementaryCriterion extends Standard_Transient {
  Set_1(Coeff: Handle_TColStd_HArray2OfReal): void;
  Set_2(FirstKnot: Quantity_AbsorbedDose, LastKnot: Quantity_AbsorbedDose): void;
  DependenceTable(): Handle_TColStd_HArray2OfInteger;
  Value(): Quantity_AbsorbedDose;
  Hessian(Dim1: Graphic3d_ZLayerId, Dim2: Graphic3d_ZLayerId, H: math_Matrix): void;
  Gradient(Dim: Graphic3d_ZLayerId, G: math_Vector): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class FEmTool_ElementsOfRefMatrix extends math_FunctionSet {
  constructor(TheBase: Handle_PLib_Base, DerOrder: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class Handle_FEmTool_LinearJerk {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_LinearJerk): void;
  get(): FEmTool_LinearJerk;
  delete(): void;
}

  export declare class Handle_FEmTool_LinearJerk_1 extends Handle_FEmTool_LinearJerk {
    constructor();
  }

  export declare class Handle_FEmTool_LinearJerk_2 extends Handle_FEmTool_LinearJerk {
    constructor(thePtr: FEmTool_LinearJerk);
  }

  export declare class Handle_FEmTool_LinearJerk_3 extends Handle_FEmTool_LinearJerk {
    constructor(theHandle: Handle_FEmTool_LinearJerk);
  }

  export declare class Handle_FEmTool_LinearJerk_4 extends Handle_FEmTool_LinearJerk {
    constructor(theHandle: Handle_FEmTool_LinearJerk);
  }

export declare class FEmTool_LinearJerk extends FEmTool_ElementaryCriterion {
  constructor(WorkDegree: Graphic3d_ZLayerId, ConstraintOrder: GeomAbs_Shape)
  DependenceTable(): Handle_TColStd_HArray2OfInteger;
  Value(): Quantity_AbsorbedDose;
  Hessian(Dimension1: Graphic3d_ZLayerId, Dimension2: Graphic3d_ZLayerId, H: math_Matrix): void;
  Gradient(Dimension: Graphic3d_ZLayerId, G: math_Vector): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_FEmTool_LinearFlexion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FEmTool_LinearFlexion): void;
  get(): FEmTool_LinearFlexion;
  delete(): void;
}

  export declare class Handle_FEmTool_LinearFlexion_1 extends Handle_FEmTool_LinearFlexion {
    constructor();
  }

  export declare class Handle_FEmTool_LinearFlexion_2 extends Handle_FEmTool_LinearFlexion {
    constructor(thePtr: FEmTool_LinearFlexion);
  }

  export declare class Handle_FEmTool_LinearFlexion_3 extends Handle_FEmTool_LinearFlexion {
    constructor(theHandle: Handle_FEmTool_LinearFlexion);
  }

  export declare class Handle_FEmTool_LinearFlexion_4 extends Handle_FEmTool_LinearFlexion {
    constructor(theHandle: Handle_FEmTool_LinearFlexion);
  }

export declare class FEmTool_LinearFlexion extends FEmTool_ElementaryCriterion {
  constructor(WorkDegree: Graphic3d_ZLayerId, ConstraintOrder: GeomAbs_Shape)
  DependenceTable(): Handle_TColStd_HArray2OfInteger;
  Value(): Quantity_AbsorbedDose;
  Hessian(Dimension1: Graphic3d_ZLayerId, Dimension2: Graphic3d_ZLayerId, H: math_Matrix): void;
  Gradient(Dimension: Graphic3d_ZLayerId, G: math_Vector): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_ToolOrderedGroupWithoutBackP {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_OrderedGroupWithoutBackP, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_OrderedGroupWithoutBackP, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_OrderedGroupWithoutBackP, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_OrderedGroupWithoutBackP): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_OrderedGroupWithoutBackP): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_OrderedGroupWithoutBackP, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_OrderedGroupWithoutBackP, entto: Handle_IGESBasic_OrderedGroupWithoutBackP, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_OrderedGroupWithoutBackP, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_ExternalReferenceFile extends IGESData_IGESEntity {
  constructor()
  Init(aNameArray: Handle_Interface_HArray1OfHAsciiString): void;
  NbListEntries(): Graphic3d_ZLayerId;
  Name(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_ExternalReferenceFile {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ExternalReferenceFile): void;
  get(): IGESBasic_ExternalReferenceFile;
  delete(): void;
}

  export declare class Handle_IGESBasic_ExternalReferenceFile_1 extends Handle_IGESBasic_ExternalReferenceFile {
    constructor();
  }

  export declare class Handle_IGESBasic_ExternalReferenceFile_2 extends Handle_IGESBasic_ExternalReferenceFile {
    constructor(thePtr: IGESBasic_ExternalReferenceFile);
  }

  export declare class Handle_IGESBasic_ExternalReferenceFile_3 extends Handle_IGESBasic_ExternalReferenceFile {
    constructor(theHandle: Handle_IGESBasic_ExternalReferenceFile);
  }

  export declare class Handle_IGESBasic_ExternalReferenceFile_4 extends Handle_IGESBasic_ExternalReferenceFile {
    constructor(theHandle: Handle_IGESBasic_ExternalReferenceFile);
  }

export declare class IGESBasic_ToolExternalRefName {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_ExternalRefName, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_ExternalRefName, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_ExternalRefName, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_ExternalRefName): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_ExternalRefName, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_ExternalRefName, entto: Handle_IGESBasic_ExternalRefName, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_ExternalRefName, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESBasic_HArray1OfHArray1OfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray1OfHArray1OfReal): void;
  get(): IGESBasic_HArray1OfHArray1OfReal;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray1OfHArray1OfReal_1 extends Handle_IGESBasic_HArray1OfHArray1OfReal {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfReal_2 extends Handle_IGESBasic_HArray1OfHArray1OfReal {
    constructor(thePtr: IGESBasic_HArray1OfHArray1OfReal);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfReal_3 extends Handle_IGESBasic_HArray1OfHArray1OfReal {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfReal);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfReal_4 extends Handle_IGESBasic_HArray1OfHArray1OfReal {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfReal);
  }

export declare class IGESBasic_HArray1OfHArray1OfReal extends Standard_Transient {
  constructor(low: Graphic3d_ZLayerId, up: Graphic3d_ZLayerId)
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_TColStd_HArray1OfReal): void;
  Value(num: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_ExternalRefFileName extends IGESData_IGESEntity {
  constructor()
  Init(aFileIdent: Handle_TCollection_HAsciiString, anExtName: Handle_TCollection_HAsciiString): void;
  SetForEntity(mode: Standard_Boolean): void;
  FileId(): Handle_TCollection_HAsciiString;
  ReferenceName(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_ExternalRefFileName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ExternalRefFileName): void;
  get(): IGESBasic_ExternalRefFileName;
  delete(): void;
}

  export declare class Handle_IGESBasic_ExternalRefFileName_1 extends Handle_IGESBasic_ExternalRefFileName {
    constructor();
  }

  export declare class Handle_IGESBasic_ExternalRefFileName_2 extends Handle_IGESBasic_ExternalRefFileName {
    constructor(thePtr: IGESBasic_ExternalRefFileName);
  }

  export declare class Handle_IGESBasic_ExternalRefFileName_3 extends Handle_IGESBasic_ExternalRefFileName {
    constructor(theHandle: Handle_IGESBasic_ExternalRefFileName);
  }

  export declare class Handle_IGESBasic_ExternalRefFileName_4 extends Handle_IGESBasic_ExternalRefFileName {
    constructor(theHandle: Handle_IGESBasic_ExternalRefFileName);
  }

export declare class Handle_IGESBasic_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ReadWriteModule): void;
  get(): IGESBasic_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESBasic_ReadWriteModule_1 extends Handle_IGESBasic_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESBasic_ReadWriteModule_2 extends Handle_IGESBasic_ReadWriteModule {
    constructor(thePtr: IGESBasic_ReadWriteModule);
  }

  export declare class Handle_IGESBasic_ReadWriteModule_3 extends Handle_IGESBasic_ReadWriteModule {
    constructor(theHandle: Handle_IGESBasic_ReadWriteModule);
  }

  export declare class Handle_IGESBasic_ReadWriteModule_4 extends Handle_IGESBasic_ReadWriteModule {
    constructor(theHandle: Handle_IGESBasic_ReadWriteModule);
  }

export declare class IGESBasic_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_ToolExternalReferenceFile {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_ExternalReferenceFile, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_ExternalReferenceFile, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_ExternalReferenceFile, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_ExternalReferenceFile): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_ExternalReferenceFile, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_ExternalReferenceFile, entto: Handle_IGESBasic_ExternalReferenceFile, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_ExternalReferenceFile, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_HArray1OfHArray1OfInteger extends Standard_Transient {
  constructor(low: Graphic3d_ZLayerId, up: Graphic3d_ZLayerId)
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_TColStd_HArray1OfInteger): void;
  Value(num: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfInteger;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_HArray1OfHArray1OfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray1OfHArray1OfInteger): void;
  get(): IGESBasic_HArray1OfHArray1OfInteger;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray1OfHArray1OfInteger_1 extends Handle_IGESBasic_HArray1OfHArray1OfInteger {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfInteger_2 extends Handle_IGESBasic_HArray1OfHArray1OfInteger {
    constructor(thePtr: IGESBasic_HArray1OfHArray1OfInteger);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfInteger_3 extends Handle_IGESBasic_HArray1OfHArray1OfInteger {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfInteger);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfInteger_4 extends Handle_IGESBasic_HArray1OfHArray1OfInteger {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfInteger);
  }

export declare class IGESBasic_ToolExternalRefLibName {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_ExternalRefLibName, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_ExternalRefLibName, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_ExternalRefLibName, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_ExternalRefLibName): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_ExternalRefLibName, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_ExternalRefLibName, entto: Handle_IGESBasic_ExternalRefLibName, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_ExternalRefLibName, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESBasic_HArray1OfHArray1OfIGESEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray1OfHArray1OfIGESEntity): void;
  get(): IGESBasic_HArray1OfHArray1OfIGESEntity;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_1 extends Handle_IGESBasic_HArray1OfHArray1OfIGESEntity {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_2 extends Handle_IGESBasic_HArray1OfHArray1OfIGESEntity {
    constructor(thePtr: IGESBasic_HArray1OfHArray1OfIGESEntity);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_3 extends Handle_IGESBasic_HArray1OfHArray1OfIGESEntity {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfIGESEntity);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_4 extends Handle_IGESBasic_HArray1OfHArray1OfIGESEntity {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfIGESEntity);
  }

export declare class IGESBasic_HArray1OfHArray1OfIGESEntity extends Standard_Transient {
  constructor(low: Graphic3d_ZLayerId, up: Graphic3d_ZLayerId)
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_IGESData_HArray1OfIGESEntity): void;
  Value(num: Graphic3d_ZLayerId): Handle_IGESData_HArray1OfIGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_ExternalRefFileIndex extends IGESData_IGESEntity {
  constructor()
  Init(aNameArray: Handle_Interface_HArray1OfHAsciiString, allEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  NbEntries(): Graphic3d_ZLayerId;
  Name(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Entity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_ExternalRefFileIndex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ExternalRefFileIndex): void;
  get(): IGESBasic_ExternalRefFileIndex;
  delete(): void;
}

  export declare class Handle_IGESBasic_ExternalRefFileIndex_1 extends Handle_IGESBasic_ExternalRefFileIndex {
    constructor();
  }

  export declare class Handle_IGESBasic_ExternalRefFileIndex_2 extends Handle_IGESBasic_ExternalRefFileIndex {
    constructor(thePtr: IGESBasic_ExternalRefFileIndex);
  }

  export declare class Handle_IGESBasic_ExternalRefFileIndex_3 extends Handle_IGESBasic_ExternalRefFileIndex {
    constructor(theHandle: Handle_IGESBasic_ExternalRefFileIndex);
  }

  export declare class Handle_IGESBasic_ExternalRefFileIndex_4 extends Handle_IGESBasic_ExternalRefFileIndex {
    constructor(theHandle: Handle_IGESBasic_ExternalRefFileIndex);
  }

export declare class IGESBasic_ExternalRefName extends IGESData_IGESEntity {
  constructor()
  Init(anExtName: Handle_TCollection_HAsciiString): void;
  ReferenceName(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_ExternalRefName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ExternalRefName): void;
  get(): IGESBasic_ExternalRefName;
  delete(): void;
}

  export declare class Handle_IGESBasic_ExternalRefName_1 extends Handle_IGESBasic_ExternalRefName {
    constructor();
  }

  export declare class Handle_IGESBasic_ExternalRefName_2 extends Handle_IGESBasic_ExternalRefName {
    constructor(thePtr: IGESBasic_ExternalRefName);
  }

  export declare class Handle_IGESBasic_ExternalRefName_3 extends Handle_IGESBasic_ExternalRefName {
    constructor(theHandle: Handle_IGESBasic_ExternalRefName);
  }

  export declare class Handle_IGESBasic_ExternalRefName_4 extends Handle_IGESBasic_ExternalRefName {
    constructor(theHandle: Handle_IGESBasic_ExternalRefName);
  }

export declare class IGESBasic_ToolOrderedGroup {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_OrderedGroup, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_OrderedGroup, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_OrderedGroup, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_OrderedGroup): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_OrderedGroup): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_OrderedGroup, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_OrderedGroup, entto: Handle_IGESBasic_OrderedGroup, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_OrderedGroup, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_ToolExternalRefFileName {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_ExternalRefFileName, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_ExternalRefFileName, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_ExternalRefFileName, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_ExternalRefFileName): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_ExternalRefFileName, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_ExternalRefFileName, entto: Handle_IGESBasic_ExternalRefFileName, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_ExternalRefFileName, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_ToolExternalRefFileIndex {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_ExternalRefFileIndex, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_ExternalRefFileIndex, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_ExternalRefFileIndex, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_ExternalRefFileIndex): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_ExternalRefFileIndex, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_ExternalRefFileIndex, entto: Handle_IGESBasic_ExternalRefFileIndex, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_ExternalRefFileIndex, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_ExternalRefLibName extends IGESData_IGESEntity {
  constructor()
  Init(aLibName: Handle_TCollection_HAsciiString, anExtName: Handle_TCollection_HAsciiString): void;
  LibraryName(): Handle_TCollection_HAsciiString;
  ReferenceName(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_ExternalRefLibName {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ExternalRefLibName): void;
  get(): IGESBasic_ExternalRefLibName;
  delete(): void;
}

  export declare class Handle_IGESBasic_ExternalRefLibName_1 extends Handle_IGESBasic_ExternalRefLibName {
    constructor();
  }

  export declare class Handle_IGESBasic_ExternalRefLibName_2 extends Handle_IGESBasic_ExternalRefLibName {
    constructor(thePtr: IGESBasic_ExternalRefLibName);
  }

  export declare class Handle_IGESBasic_ExternalRefLibName_3 extends Handle_IGESBasic_ExternalRefLibName {
    constructor(theHandle: Handle_IGESBasic_ExternalRefLibName);
  }

  export declare class Handle_IGESBasic_ExternalRefLibName_4 extends Handle_IGESBasic_ExternalRefLibName {
    constructor(theHandle: Handle_IGESBasic_ExternalRefLibName);
  }

export declare class Handle_IGESBasic_HArray1OfHArray1OfXYZ {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray1OfHArray1OfXYZ): void;
  get(): IGESBasic_HArray1OfHArray1OfXYZ;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXYZ_1 extends Handle_IGESBasic_HArray1OfHArray1OfXYZ {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXYZ_2 extends Handle_IGESBasic_HArray1OfHArray1OfXYZ {
    constructor(thePtr: IGESBasic_HArray1OfHArray1OfXYZ);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXYZ_3 extends Handle_IGESBasic_HArray1OfHArray1OfXYZ {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfXYZ);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXYZ_4 extends Handle_IGESBasic_HArray1OfHArray1OfXYZ {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfXYZ);
  }

export declare class IGESBasic_HArray1OfHArray1OfXYZ extends Standard_Transient {
  constructor(low: Graphic3d_ZLayerId, up: Graphic3d_ZLayerId)
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_TColgp_HArray1OfXYZ): void;
  Value(num: Graphic3d_ZLayerId): Handle_TColgp_HArray1OfXYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_SingularSubfigure extends IGESData_IGESEntity {
  constructor()
  Init(aSubfigureDef: Handle_IGESBasic_SubfigureDef, aTranslation: gp_XYZ, hasScale: Standard_Boolean, aScale: Quantity_AbsorbedDose): void;
  Subfigure(): Handle_IGESBasic_SubfigureDef;
  Translation(): gp_XYZ;
  ScaleFactor(): Quantity_AbsorbedDose;
  HasScaleFactor(): Standard_Boolean;
  TransformedTranslation(): gp_XYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_SingularSubfigure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_SingularSubfigure): void;
  get(): IGESBasic_SingularSubfigure;
  delete(): void;
}

  export declare class Handle_IGESBasic_SingularSubfigure_1 extends Handle_IGESBasic_SingularSubfigure {
    constructor();
  }

  export declare class Handle_IGESBasic_SingularSubfigure_2 extends Handle_IGESBasic_SingularSubfigure {
    constructor(thePtr: IGESBasic_SingularSubfigure);
  }

  export declare class Handle_IGESBasic_SingularSubfigure_3 extends Handle_IGESBasic_SingularSubfigure {
    constructor(theHandle: Handle_IGESBasic_SingularSubfigure);
  }

  export declare class Handle_IGESBasic_SingularSubfigure_4 extends Handle_IGESBasic_SingularSubfigure {
    constructor(theHandle: Handle_IGESBasic_SingularSubfigure);
  }

export declare class IGESBasic_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_SpecificModule): void;
  get(): IGESBasic_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESBasic_SpecificModule_1 extends Handle_IGESBasic_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESBasic_SpecificModule_2 extends Handle_IGESBasic_SpecificModule {
    constructor(thePtr: IGESBasic_SpecificModule);
  }

  export declare class Handle_IGESBasic_SpecificModule_3 extends Handle_IGESBasic_SpecificModule {
    constructor(theHandle: Handle_IGESBasic_SpecificModule);
  }

  export declare class Handle_IGESBasic_SpecificModule_4 extends Handle_IGESBasic_SpecificModule {
    constructor(theHandle: Handle_IGESBasic_SpecificModule);
  }

export declare class IGESBasic_ToolExternalRefFile {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_ExternalRefFile, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_ExternalRefFile, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_ExternalRefFile, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_ExternalRefFile): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_ExternalRefFile, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_ExternalRefFile, entto: Handle_IGESBasic_ExternalRefFile, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_ExternalRefFile, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_GroupWithoutBackP extends IGESBasic_Group {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_GroupWithoutBackP {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_GroupWithoutBackP): void;
  get(): IGESBasic_GroupWithoutBackP;
  delete(): void;
}

  export declare class Handle_IGESBasic_GroupWithoutBackP_1 extends Handle_IGESBasic_GroupWithoutBackP {
    constructor();
  }

  export declare class Handle_IGESBasic_GroupWithoutBackP_2 extends Handle_IGESBasic_GroupWithoutBackP {
    constructor(thePtr: IGESBasic_GroupWithoutBackP);
  }

  export declare class Handle_IGESBasic_GroupWithoutBackP_3 extends Handle_IGESBasic_GroupWithoutBackP {
    constructor(theHandle: Handle_IGESBasic_GroupWithoutBackP);
  }

  export declare class Handle_IGESBasic_GroupWithoutBackP_4 extends Handle_IGESBasic_GroupWithoutBackP {
    constructor(theHandle: Handle_IGESBasic_GroupWithoutBackP);
  }

export declare class IGESBasic_OrderedGroup extends IGESBasic_Group {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_OrderedGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_OrderedGroup): void;
  get(): IGESBasic_OrderedGroup;
  delete(): void;
}

  export declare class Handle_IGESBasic_OrderedGroup_1 extends Handle_IGESBasic_OrderedGroup {
    constructor();
  }

  export declare class Handle_IGESBasic_OrderedGroup_2 extends Handle_IGESBasic_OrderedGroup {
    constructor(thePtr: IGESBasic_OrderedGroup);
  }

  export declare class Handle_IGESBasic_OrderedGroup_3 extends Handle_IGESBasic_OrderedGroup {
    constructor(theHandle: Handle_IGESBasic_OrderedGroup);
  }

  export declare class Handle_IGESBasic_OrderedGroup_4 extends Handle_IGESBasic_OrderedGroup {
    constructor(theHandle: Handle_IGESBasic_OrderedGroup);
  }

export declare class Handle_IGESBasic_SubfigureDef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_SubfigureDef): void;
  get(): IGESBasic_SubfigureDef;
  delete(): void;
}

  export declare class Handle_IGESBasic_SubfigureDef_1 extends Handle_IGESBasic_SubfigureDef {
    constructor();
  }

  export declare class Handle_IGESBasic_SubfigureDef_2 extends Handle_IGESBasic_SubfigureDef {
    constructor(thePtr: IGESBasic_SubfigureDef);
  }

  export declare class Handle_IGESBasic_SubfigureDef_3 extends Handle_IGESBasic_SubfigureDef {
    constructor(theHandle: Handle_IGESBasic_SubfigureDef);
  }

  export declare class Handle_IGESBasic_SubfigureDef_4 extends Handle_IGESBasic_SubfigureDef {
    constructor(theHandle: Handle_IGESBasic_SubfigureDef);
  }

export declare class IGESBasic_SubfigureDef extends IGESData_IGESEntity {
  constructor()
  Init(aDepth: Graphic3d_ZLayerId, aName: Handle_TCollection_HAsciiString, allAssocEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  Depth(): Graphic3d_ZLayerId;
  Name(): Handle_TCollection_HAsciiString;
  NbEntities(): Graphic3d_ZLayerId;
  AssociatedEntity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  Value(Index: Graphic3d_ZLayerId): Handle_Standard_Transient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_Group extends IGESData_IGESEntity {
  Init(allEntities: Handle_IGESData_HArray1OfIGESEntity): void;
  SetOrdered(mode: Standard_Boolean): void;
  SetWithoutBackP(mode: Standard_Boolean): void;
  IsOrdered(): Standard_Boolean;
  IsWithoutBackP(): Standard_Boolean;
  SetUser(type: Graphic3d_ZLayerId, form: Graphic3d_ZLayerId): void;
  SetNb(nb: Graphic3d_ZLayerId): void;
  NbEntities(): Graphic3d_ZLayerId;
  Entity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  Value(Index: Graphic3d_ZLayerId): Handle_Standard_Transient;
  SetValue(Index: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IGESBasic_Group_1 extends IGESBasic_Group {
    constructor();
  }

  export declare class IGESBasic_Group_2 extends IGESBasic_Group {
    constructor(nb: Graphic3d_ZLayerId);
  }

export declare class Handle_IGESBasic_Group {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_Group): void;
  get(): IGESBasic_Group;
  delete(): void;
}

  export declare class Handle_IGESBasic_Group_1 extends Handle_IGESBasic_Group {
    constructor();
  }

  export declare class Handle_IGESBasic_Group_2 extends Handle_IGESBasic_Group {
    constructor(thePtr: IGESBasic_Group);
  }

  export declare class Handle_IGESBasic_Group_3 extends Handle_IGESBasic_Group {
    constructor(theHandle: Handle_IGESBasic_Group);
  }

  export declare class Handle_IGESBasic_Group_4 extends Handle_IGESBasic_Group {
    constructor(theHandle: Handle_IGESBasic_Group);
  }

export declare class IGESBasic_ToolGroupWithoutBackP {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_GroupWithoutBackP, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_GroupWithoutBackP, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_GroupWithoutBackP, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_GroupWithoutBackP): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_GroupWithoutBackP): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_GroupWithoutBackP, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_GroupWithoutBackP, entto: Handle_IGESBasic_GroupWithoutBackP, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_GroupWithoutBackP, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESBasic_HArray1OfLineFontEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray1OfLineFontEntity): void;
  get(): IGESBasic_HArray1OfLineFontEntity;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray1OfLineFontEntity_1 extends Handle_IGESBasic_HArray1OfLineFontEntity {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray1OfLineFontEntity_2 extends Handle_IGESBasic_HArray1OfLineFontEntity {
    constructor(thePtr: IGESBasic_HArray1OfLineFontEntity);
  }

  export declare class Handle_IGESBasic_HArray1OfLineFontEntity_3 extends Handle_IGESBasic_HArray1OfLineFontEntity {
    constructor(theHandle: Handle_IGESBasic_HArray1OfLineFontEntity);
  }

  export declare class Handle_IGESBasic_HArray1OfLineFontEntity_4 extends Handle_IGESBasic_HArray1OfLineFontEntity {
    constructor(theHandle: Handle_IGESBasic_HArray1OfLineFontEntity);
  }

export declare class IGESBasic_ToolName {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_Name, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_Name, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_Name, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_Name): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_Name): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_Name, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_Name, entto: Handle_IGESBasic_Name, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_Name, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_Hierarchy extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aLineFont: Graphic3d_ZLayerId, aView: Graphic3d_ZLayerId, anEntityLevel: Graphic3d_ZLayerId, aBlankStatus: Graphic3d_ZLayerId, aLineWt: Graphic3d_ZLayerId, aColorNum: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  NewLineFont(): Graphic3d_ZLayerId;
  NewView(): Graphic3d_ZLayerId;
  NewEntityLevel(): Graphic3d_ZLayerId;
  NewBlankStatus(): Graphic3d_ZLayerId;
  NewLineWeight(): Graphic3d_ZLayerId;
  NewColorNum(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_Hierarchy {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_Hierarchy): void;
  get(): IGESBasic_Hierarchy;
  delete(): void;
}

  export declare class Handle_IGESBasic_Hierarchy_1 extends Handle_IGESBasic_Hierarchy {
    constructor();
  }

  export declare class Handle_IGESBasic_Hierarchy_2 extends Handle_IGESBasic_Hierarchy {
    constructor(thePtr: IGESBasic_Hierarchy);
  }

  export declare class Handle_IGESBasic_Hierarchy_3 extends Handle_IGESBasic_Hierarchy {
    constructor(theHandle: Handle_IGESBasic_Hierarchy);
  }

  export declare class Handle_IGESBasic_Hierarchy_4 extends Handle_IGESBasic_Hierarchy {
    constructor(theHandle: Handle_IGESBasic_Hierarchy);
  }

export declare class IGESBasic_SingleParent extends IGESData_SingleParentEntity {
  constructor()
  Init(nbParentEntities: Graphic3d_ZLayerId, aParentEntity: Handle_IGESData_IGESEntity, allChildren: Handle_IGESData_HArray1OfIGESEntity): void;
  NbParentEntities(): Graphic3d_ZLayerId;
  SingleParent(): Handle_IGESData_IGESEntity;
  NbChildren(): Graphic3d_ZLayerId;
  Child(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_SingleParent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_SingleParent): void;
  get(): IGESBasic_SingleParent;
  delete(): void;
}

  export declare class Handle_IGESBasic_SingleParent_1 extends Handle_IGESBasic_SingleParent {
    constructor();
  }

  export declare class Handle_IGESBasic_SingleParent_2 extends Handle_IGESBasic_SingleParent {
    constructor(thePtr: IGESBasic_SingleParent);
  }

  export declare class Handle_IGESBasic_SingleParent_3 extends Handle_IGESBasic_SingleParent {
    constructor(theHandle: Handle_IGESBasic_SingleParent);
  }

  export declare class Handle_IGESBasic_SingleParent_4 extends Handle_IGESBasic_SingleParent {
    constructor(theHandle: Handle_IGESBasic_SingleParent);
  }

export declare class IGESBasic_ToolSingleParent {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_SingleParent, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_SingleParent, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_SingleParent, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_SingleParent): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_SingleParent): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_SingleParent, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_SingleParent, entto: Handle_IGESBasic_SingleParent, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_SingleParent, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESBasic_HArray2OfHArray1OfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray2OfHArray1OfReal): void;
  get(): IGESBasic_HArray2OfHArray1OfReal;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray2OfHArray1OfReal_1 extends Handle_IGESBasic_HArray2OfHArray1OfReal {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray2OfHArray1OfReal_2 extends Handle_IGESBasic_HArray2OfHArray1OfReal {
    constructor(thePtr: IGESBasic_HArray2OfHArray1OfReal);
  }

  export declare class Handle_IGESBasic_HArray2OfHArray1OfReal_3 extends Handle_IGESBasic_HArray2OfHArray1OfReal {
    constructor(theHandle: Handle_IGESBasic_HArray2OfHArray1OfReal);
  }

  export declare class Handle_IGESBasic_HArray2OfHArray1OfReal_4 extends Handle_IGESBasic_HArray2OfHArray1OfReal {
    constructor(theHandle: Handle_IGESBasic_HArray2OfHArray1OfReal);
  }

export declare class IGESBasic_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_GeneralModule): void;
  get(): IGESBasic_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESBasic_GeneralModule_1 extends Handle_IGESBasic_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESBasic_GeneralModule_2 extends Handle_IGESBasic_GeneralModule {
    constructor(thePtr: IGESBasic_GeneralModule);
  }

  export declare class Handle_IGESBasic_GeneralModule_3 extends Handle_IGESBasic_GeneralModule {
    constructor(theHandle: Handle_IGESBasic_GeneralModule);
  }

  export declare class Handle_IGESBasic_GeneralModule_4 extends Handle_IGESBasic_GeneralModule {
    constructor(theHandle: Handle_IGESBasic_GeneralModule);
  }

export declare class IGESBasic_ToolGroup {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_Group, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_Group, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_Group, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_Group): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_Group): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_Group, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_Group, entto: Handle_IGESBasic_Group, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_Group, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESBasic_AssocGroupType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_AssocGroupType): void;
  get(): IGESBasic_AssocGroupType;
  delete(): void;
}

  export declare class Handle_IGESBasic_AssocGroupType_1 extends Handle_IGESBasic_AssocGroupType {
    constructor();
  }

  export declare class Handle_IGESBasic_AssocGroupType_2 extends Handle_IGESBasic_AssocGroupType {
    constructor(thePtr: IGESBasic_AssocGroupType);
  }

  export declare class Handle_IGESBasic_AssocGroupType_3 extends Handle_IGESBasic_AssocGroupType {
    constructor(theHandle: Handle_IGESBasic_AssocGroupType);
  }

  export declare class Handle_IGESBasic_AssocGroupType_4 extends Handle_IGESBasic_AssocGroupType {
    constructor(theHandle: Handle_IGESBasic_AssocGroupType);
  }

export declare class IGESBasic_AssocGroupType extends IGESData_IGESEntity {
  constructor()
  Init(nbDataFields: Graphic3d_ZLayerId, aType: Graphic3d_ZLayerId, aName: Handle_TCollection_HAsciiString): void;
  NbData(): Graphic3d_ZLayerId;
  AssocType(): Graphic3d_ZLayerId;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_Name {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_Name): void;
  get(): IGESBasic_Name;
  delete(): void;
}

  export declare class Handle_IGESBasic_Name_1 extends Handle_IGESBasic_Name {
    constructor();
  }

  export declare class Handle_IGESBasic_Name_2 extends Handle_IGESBasic_Name {
    constructor(thePtr: IGESBasic_Name);
  }

  export declare class Handle_IGESBasic_Name_3 extends Handle_IGESBasic_Name {
    constructor(theHandle: Handle_IGESBasic_Name);
  }

  export declare class Handle_IGESBasic_Name_4 extends Handle_IGESBasic_Name {
    constructor(theHandle: Handle_IGESBasic_Name);
  }

export declare class IGESBasic_Name extends IGESData_NameEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aName: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  Value(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_HArray1OfHArray1OfXY extends Standard_Transient {
  constructor(low: Graphic3d_ZLayerId, up: Graphic3d_ZLayerId)
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  SetValue(num: Graphic3d_ZLayerId, val: Handle_TColgp_HArray1OfXY): void;
  Value(num: Graphic3d_ZLayerId): Handle_TColgp_HArray1OfXY;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_HArray1OfHArray1OfXY {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_HArray1OfHArray1OfXY): void;
  get(): IGESBasic_HArray1OfHArray1OfXY;
  delete(): void;
}

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXY_1 extends Handle_IGESBasic_HArray1OfHArray1OfXY {
    constructor();
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXY_2 extends Handle_IGESBasic_HArray1OfHArray1OfXY {
    constructor(thePtr: IGESBasic_HArray1OfHArray1OfXY);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXY_3 extends Handle_IGESBasic_HArray1OfHArray1OfXY {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfXY);
  }

  export declare class Handle_IGESBasic_HArray1OfHArray1OfXY_4 extends Handle_IGESBasic_HArray1OfHArray1OfXY {
    constructor(theHandle: Handle_IGESBasic_HArray1OfHArray1OfXY);
  }

export declare class Handle_IGESBasic_ExternalRefFile {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_ExternalRefFile): void;
  get(): IGESBasic_ExternalRefFile;
  delete(): void;
}

  export declare class Handle_IGESBasic_ExternalRefFile_1 extends Handle_IGESBasic_ExternalRefFile {
    constructor();
  }

  export declare class Handle_IGESBasic_ExternalRefFile_2 extends Handle_IGESBasic_ExternalRefFile {
    constructor(thePtr: IGESBasic_ExternalRefFile);
  }

  export declare class Handle_IGESBasic_ExternalRefFile_3 extends Handle_IGESBasic_ExternalRefFile {
    constructor(theHandle: Handle_IGESBasic_ExternalRefFile);
  }

  export declare class Handle_IGESBasic_ExternalRefFile_4 extends Handle_IGESBasic_ExternalRefFile {
    constructor(theHandle: Handle_IGESBasic_ExternalRefFile);
  }

export declare class IGESBasic_ExternalRefFile extends IGESData_IGESEntity {
  constructor()
  Init(aFileIdent: Handle_TCollection_HAsciiString): void;
  FileId(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESBasic_ToolSingularSubfigure {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_SingularSubfigure, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_SingularSubfigure, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_SingularSubfigure, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_SingularSubfigure): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_SingularSubfigure, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_SingularSubfigure, entto: Handle_IGESBasic_SingularSubfigure, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_SingularSubfigure, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_ToolAssocGroupType {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_AssocGroupType, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_AssocGroupType, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_AssocGroupType, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_AssocGroupType): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_AssocGroupType): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_AssocGroupType, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_AssocGroupType, entto: Handle_IGESBasic_AssocGroupType, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_AssocGroupType, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_ToolHierarchy {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_Hierarchy, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_Hierarchy, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_Hierarchy, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESBasic_Hierarchy): Standard_Boolean;
  DirChecker(ent: Handle_IGESBasic_Hierarchy): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_Hierarchy, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_Hierarchy, entto: Handle_IGESBasic_Hierarchy, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_Hierarchy, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESBasic_Protocol;
  delete(): void;
}

export declare class IGESBasic_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_Protocol): void;
  get(): IGESBasic_Protocol;
  delete(): void;
}

  export declare class Handle_IGESBasic_Protocol_1 extends Handle_IGESBasic_Protocol {
    constructor();
  }

  export declare class Handle_IGESBasic_Protocol_2 extends Handle_IGESBasic_Protocol {
    constructor(thePtr: IGESBasic_Protocol);
  }

  export declare class Handle_IGESBasic_Protocol_3 extends Handle_IGESBasic_Protocol {
    constructor(theHandle: Handle_IGESBasic_Protocol);
  }

  export declare class Handle_IGESBasic_Protocol_4 extends Handle_IGESBasic_Protocol {
    constructor(theHandle: Handle_IGESBasic_Protocol);
  }

export declare class IGESBasic_ToolSubfigureDef {
  constructor()
  ReadOwnParams(ent: Handle_IGESBasic_SubfigureDef, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESBasic_SubfigureDef, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESBasic_SubfigureDef, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESBasic_SubfigureDef): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESBasic_SubfigureDef, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESBasic_SubfigureDef, entto: Handle_IGESBasic_SubfigureDef, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESBasic_SubfigureDef, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESBasic_OrderedGroupWithoutBackP extends IGESBasic_Group {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESBasic_OrderedGroupWithoutBackP {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESBasic_OrderedGroupWithoutBackP): void;
  get(): IGESBasic_OrderedGroupWithoutBackP;
  delete(): void;
}

  export declare class Handle_IGESBasic_OrderedGroupWithoutBackP_1 extends Handle_IGESBasic_OrderedGroupWithoutBackP {
    constructor();
  }

  export declare class Handle_IGESBasic_OrderedGroupWithoutBackP_2 extends Handle_IGESBasic_OrderedGroupWithoutBackP {
    constructor(thePtr: IGESBasic_OrderedGroupWithoutBackP);
  }

  export declare class Handle_IGESBasic_OrderedGroupWithoutBackP_3 extends Handle_IGESBasic_OrderedGroupWithoutBackP {
    constructor(theHandle: Handle_IGESBasic_OrderedGroupWithoutBackP);
  }

  export declare class Handle_IGESBasic_OrderedGroupWithoutBackP_4 extends Handle_IGESBasic_OrderedGroupWithoutBackP {
    constructor(theHandle: Handle_IGESBasic_OrderedGroupWithoutBackP);
  }

export declare class Handle_StepBasic_PlaneAngleUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PlaneAngleUnit): void;
  get(): StepBasic_PlaneAngleUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_PlaneAngleUnit_1 extends Handle_StepBasic_PlaneAngleUnit {
    constructor();
  }

  export declare class Handle_StepBasic_PlaneAngleUnit_2 extends Handle_StepBasic_PlaneAngleUnit {
    constructor(thePtr: StepBasic_PlaneAngleUnit);
  }

  export declare class Handle_StepBasic_PlaneAngleUnit_3 extends Handle_StepBasic_PlaneAngleUnit {
    constructor(theHandle: Handle_StepBasic_PlaneAngleUnit);
  }

  export declare class Handle_StepBasic_PlaneAngleUnit_4 extends Handle_StepBasic_PlaneAngleUnit {
    constructor(theHandle: Handle_StepBasic_PlaneAngleUnit);
  }

export declare class StepBasic_PlaneAngleUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepBasic_Source = {
  StepBasic_sMade: {};
  StepBasic_sBought: {};
  StepBasic_sNotKnown: {};
}

export declare class Handle_StepBasic_ContractType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ContractType): void;
  get(): StepBasic_ContractType;
  delete(): void;
}

  export declare class Handle_StepBasic_ContractType_1 extends Handle_StepBasic_ContractType {
    constructor();
  }

  export declare class Handle_StepBasic_ContractType_2 extends Handle_StepBasic_ContractType {
    constructor(thePtr: StepBasic_ContractType);
  }

  export declare class Handle_StepBasic_ContractType_3 extends Handle_StepBasic_ContractType {
    constructor(theHandle: Handle_StepBasic_ContractType);
  }

  export declare class Handle_StepBasic_ContractType_4 extends Handle_StepBasic_ContractType {
    constructor(theHandle: Handle_StepBasic_ContractType);
  }

export declare class StepBasic_ContractType extends Standard_Transient {
  constructor()
  Init(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ExternallyDefinedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ExternallyDefinedItem): void;
  get(): StepBasic_ExternallyDefinedItem;
  delete(): void;
}

  export declare class Handle_StepBasic_ExternallyDefinedItem_1 extends Handle_StepBasic_ExternallyDefinedItem {
    constructor();
  }

  export declare class Handle_StepBasic_ExternallyDefinedItem_2 extends Handle_StepBasic_ExternallyDefinedItem {
    constructor(thePtr: StepBasic_ExternallyDefinedItem);
  }

  export declare class Handle_StepBasic_ExternallyDefinedItem_3 extends Handle_StepBasic_ExternallyDefinedItem {
    constructor(theHandle: Handle_StepBasic_ExternallyDefinedItem);
  }

  export declare class Handle_StepBasic_ExternallyDefinedItem_4 extends Handle_StepBasic_ExternallyDefinedItem {
    constructor(theHandle: Handle_StepBasic_ExternallyDefinedItem);
  }

export declare class StepBasic_ExternallyDefinedItem extends Standard_Transient {
  constructor()
  Init(aItemId: StepBasic_SourceItem, aSource: Handle_StepBasic_ExternalSource): void;
  ItemId(): StepBasic_SourceItem;
  SetItemId(ItemId: StepBasic_SourceItem): void;
  Source(): Handle_StepBasic_ExternalSource;
  SetSource(Source: Handle_StepBasic_ExternalSource): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ExternalIdentificationAssignment extends StepBasic_IdentificationAssignment {
  constructor()
  Init(aIdentificationAssignment_AssignedId: Handle_TCollection_HAsciiString, aIdentificationAssignment_Role: Handle_StepBasic_IdentificationRole, aSource: Handle_StepBasic_ExternalSource): void;
  Source(): Handle_StepBasic_ExternalSource;
  SetSource(Source: Handle_StepBasic_ExternalSource): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ExternalIdentificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ExternalIdentificationAssignment): void;
  get(): StepBasic_ExternalIdentificationAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_ExternalIdentificationAssignment_1 extends Handle_StepBasic_ExternalIdentificationAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_ExternalIdentificationAssignment_2 extends Handle_StepBasic_ExternalIdentificationAssignment {
    constructor(thePtr: StepBasic_ExternalIdentificationAssignment);
  }

  export declare class Handle_StepBasic_ExternalIdentificationAssignment_3 extends Handle_StepBasic_ExternalIdentificationAssignment {
    constructor(theHandle: Handle_StepBasic_ExternalIdentificationAssignment);
  }

  export declare class Handle_StepBasic_ExternalIdentificationAssignment_4 extends Handle_StepBasic_ExternalIdentificationAssignment {
    constructor(theHandle: Handle_StepBasic_ExternalIdentificationAssignment);
  }

export declare class StepBasic_SecurityClassificationAssignment extends Standard_Transient {
  constructor();
  Init(aAssignedSecurityClassification: Handle_StepBasic_SecurityClassification): void;
  SetAssignedSecurityClassification(aAssignedSecurityClassification: Handle_StepBasic_SecurityClassification): void;
  AssignedSecurityClassification(): Handle_StepBasic_SecurityClassification;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SecurityClassificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SecurityClassificationAssignment): void;
  get(): StepBasic_SecurityClassificationAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_SecurityClassificationAssignment_1 extends Handle_StepBasic_SecurityClassificationAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_SecurityClassificationAssignment_2 extends Handle_StepBasic_SecurityClassificationAssignment {
    constructor(thePtr: StepBasic_SecurityClassificationAssignment);
  }

  export declare class Handle_StepBasic_SecurityClassificationAssignment_3 extends Handle_StepBasic_SecurityClassificationAssignment {
    constructor(theHandle: Handle_StepBasic_SecurityClassificationAssignment);
  }

  export declare class Handle_StepBasic_SecurityClassificationAssignment_4 extends Handle_StepBasic_SecurityClassificationAssignment {
    constructor(theHandle: Handle_StepBasic_SecurityClassificationAssignment);
  }

export declare class Handle_StepBasic_OrganizationalAddress {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_OrganizationalAddress): void;
  get(): StepBasic_OrganizationalAddress;
  delete(): void;
}

  export declare class Handle_StepBasic_OrganizationalAddress_1 extends Handle_StepBasic_OrganizationalAddress {
    constructor();
  }

  export declare class Handle_StepBasic_OrganizationalAddress_2 extends Handle_StepBasic_OrganizationalAddress {
    constructor(thePtr: StepBasic_OrganizationalAddress);
  }

  export declare class Handle_StepBasic_OrganizationalAddress_3 extends Handle_StepBasic_OrganizationalAddress {
    constructor(theHandle: Handle_StepBasic_OrganizationalAddress);
  }

  export declare class Handle_StepBasic_OrganizationalAddress_4 extends Handle_StepBasic_OrganizationalAddress {
    constructor(theHandle: Handle_StepBasic_OrganizationalAddress);
  }

export declare class StepBasic_OrganizationalAddress extends StepBasic_Address {
  constructor()
  Init(hasAinternalLocation: Standard_Boolean, aInternalLocation: Handle_TCollection_HAsciiString, hasAstreetNumber: Standard_Boolean, aStreetNumber: Handle_TCollection_HAsciiString, hasAstreet: Standard_Boolean, aStreet: Handle_TCollection_HAsciiString, hasApostalBox: Standard_Boolean, aPostalBox: Handle_TCollection_HAsciiString, hasAtown: Standard_Boolean, aTown: Handle_TCollection_HAsciiString, hasAregion: Standard_Boolean, aRegion: Handle_TCollection_HAsciiString, hasApostalCode: Standard_Boolean, aPostalCode: Handle_TCollection_HAsciiString, hasAcountry: Standard_Boolean, aCountry: Handle_TCollection_HAsciiString, hasAfacsimileNumber: Standard_Boolean, aFacsimileNumber: Handle_TCollection_HAsciiString, hasAtelephoneNumber: Standard_Boolean, aTelephoneNumber: Handle_TCollection_HAsciiString, hasAelectronicMailAddress: Standard_Boolean, aElectronicMailAddress: Handle_TCollection_HAsciiString, hasAtelexNumber: Standard_Boolean, aTelexNumber: Handle_TCollection_HAsciiString, aOrganizations: Handle_StepBasic_HArray1OfOrganization, aDescription: Handle_TCollection_HAsciiString): void;
  SetOrganizations(aOrganizations: Handle_StepBasic_HArray1OfOrganization): void;
  Organizations(): Handle_StepBasic_HArray1OfOrganization;
  OrganizationsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_Organization;
  NbOrganizations(): Graphic3d_ZLayerId;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ProductDefinition extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aFormation: Handle_StepBasic_ProductDefinitionFormation, aFrameOfReference: Handle_StepBasic_ProductDefinitionContext): void;
  SetId(aId: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetFormation(aFormation: Handle_StepBasic_ProductDefinitionFormation): void;
  Formation(): Handle_StepBasic_ProductDefinitionFormation;
  SetFrameOfReference(aFrameOfReference: Handle_StepBasic_ProductDefinitionContext): void;
  FrameOfReference(): Handle_StepBasic_ProductDefinitionContext;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinition): void;
  get(): StepBasic_ProductDefinition;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinition_1 extends Handle_StepBasic_ProductDefinition {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinition_2 extends Handle_StepBasic_ProductDefinition {
    constructor(thePtr: StepBasic_ProductDefinition);
  }

  export declare class Handle_StepBasic_ProductDefinition_3 extends Handle_StepBasic_ProductDefinition {
    constructor(theHandle: Handle_StepBasic_ProductDefinition);
  }

  export declare class Handle_StepBasic_ProductDefinition_4 extends Handle_StepBasic_ProductDefinition {
    constructor(theHandle: Handle_StepBasic_ProductDefinition);
  }

export declare class Handle_StepBasic_PersonAndOrganization {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PersonAndOrganization): void;
  get(): StepBasic_PersonAndOrganization;
  delete(): void;
}

  export declare class Handle_StepBasic_PersonAndOrganization_1 extends Handle_StepBasic_PersonAndOrganization {
    constructor();
  }

  export declare class Handle_StepBasic_PersonAndOrganization_2 extends Handle_StepBasic_PersonAndOrganization {
    constructor(thePtr: StepBasic_PersonAndOrganization);
  }

  export declare class Handle_StepBasic_PersonAndOrganization_3 extends Handle_StepBasic_PersonAndOrganization {
    constructor(theHandle: Handle_StepBasic_PersonAndOrganization);
  }

  export declare class Handle_StepBasic_PersonAndOrganization_4 extends Handle_StepBasic_PersonAndOrganization {
    constructor(theHandle: Handle_StepBasic_PersonAndOrganization);
  }

export declare class StepBasic_PersonAndOrganization extends Standard_Transient {
  constructor()
  Init(aThePerson: Handle_StepBasic_Person, aTheOrganization: Handle_StepBasic_Organization): void;
  SetThePerson(aThePerson: Handle_StepBasic_Person): void;
  ThePerson(): Handle_StepBasic_Person;
  SetTheOrganization(aTheOrganization: Handle_StepBasic_Organization): void;
  TheOrganization(): Handle_StepBasic_Organization;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_HArray1OfPerson {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfPerson): void;
  get(): StepBasic_HArray1OfPerson;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfPerson_1 extends Handle_StepBasic_HArray1OfPerson {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfPerson_2 extends Handle_StepBasic_HArray1OfPerson {
    constructor(thePtr: StepBasic_HArray1OfPerson);
  }

  export declare class Handle_StepBasic_HArray1OfPerson_3 extends Handle_StepBasic_HArray1OfPerson {
    constructor(theHandle: Handle_StepBasic_HArray1OfPerson);
  }

  export declare class Handle_StepBasic_HArray1OfPerson_4 extends Handle_StepBasic_HArray1OfPerson {
    constructor(theHandle: Handle_StepBasic_HArray1OfPerson);
  }

export declare class StepBasic_SecurityClassification extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPurpose: Handle_TCollection_HAsciiString, aSecurityLevel: Handle_StepBasic_SecurityClassificationLevel): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetPurpose(aPurpose: Handle_TCollection_HAsciiString): void;
  Purpose(): Handle_TCollection_HAsciiString;
  SetSecurityLevel(aSecurityLevel: Handle_StepBasic_SecurityClassificationLevel): void;
  SecurityLevel(): Handle_StepBasic_SecurityClassificationLevel;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SecurityClassification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SecurityClassification): void;
  get(): StepBasic_SecurityClassification;
  delete(): void;
}

  export declare class Handle_StepBasic_SecurityClassification_1 extends Handle_StepBasic_SecurityClassification {
    constructor();
  }

  export declare class Handle_StepBasic_SecurityClassification_2 extends Handle_StepBasic_SecurityClassification {
    constructor(thePtr: StepBasic_SecurityClassification);
  }

  export declare class Handle_StepBasic_SecurityClassification_3 extends Handle_StepBasic_SecurityClassification {
    constructor(theHandle: Handle_StepBasic_SecurityClassification);
  }

  export declare class Handle_StepBasic_SecurityClassification_4 extends Handle_StepBasic_SecurityClassification {
    constructor(theHandle: Handle_StepBasic_SecurityClassification);
  }

export declare class Handle_StepBasic_MechanicalContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_MechanicalContext): void;
  get(): StepBasic_MechanicalContext;
  delete(): void;
}

  export declare class Handle_StepBasic_MechanicalContext_1 extends Handle_StepBasic_MechanicalContext {
    constructor();
  }

  export declare class Handle_StepBasic_MechanicalContext_2 extends Handle_StepBasic_MechanicalContext {
    constructor(thePtr: StepBasic_MechanicalContext);
  }

  export declare class Handle_StepBasic_MechanicalContext_3 extends Handle_StepBasic_MechanicalContext {
    constructor(theHandle: Handle_StepBasic_MechanicalContext);
  }

  export declare class Handle_StepBasic_MechanicalContext_4 extends Handle_StepBasic_MechanicalContext {
    constructor(theHandle: Handle_StepBasic_MechanicalContext);
  }

export declare class StepBasic_MechanicalContext extends StepBasic_ProductContext {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_PlaneAngleMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_PlaneAngleMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PlaneAngleMeasureWithUnit): void;
  get(): StepBasic_PlaneAngleMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_PlaneAngleMeasureWithUnit_1 extends Handle_StepBasic_PlaneAngleMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_PlaneAngleMeasureWithUnit_2 extends Handle_StepBasic_PlaneAngleMeasureWithUnit {
    constructor(thePtr: StepBasic_PlaneAngleMeasureWithUnit);
  }

  export declare class Handle_StepBasic_PlaneAngleMeasureWithUnit_3 extends Handle_StepBasic_PlaneAngleMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_PlaneAngleMeasureWithUnit);
  }

  export declare class Handle_StepBasic_PlaneAngleMeasureWithUnit_4 extends Handle_StepBasic_PlaneAngleMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_PlaneAngleMeasureWithUnit);
  }

export declare type StepBasic_SiPrefix = {
  StepBasic_spExa: {};
  StepBasic_spPeta: {};
  StepBasic_spTera: {};
  StepBasic_spGiga: {};
  StepBasic_spMega: {};
  StepBasic_spKilo: {};
  StepBasic_spHecto: {};
  StepBasic_spDeca: {};
  StepBasic_spDeci: {};
  StepBasic_spCenti: {};
  StepBasic_spMilli: {};
  StepBasic_spMicro: {};
  StepBasic_spNano: {};
  StepBasic_spPico: {};
  StepBasic_spFemto: {};
  StepBasic_spAtto: {};
}

export declare class StepBasic_ProductDefinitionFormationRelationship extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aRelatingProductDefinitionFormation: Handle_StepBasic_ProductDefinitionFormation, aRelatedProductDefinitionFormation: Handle_StepBasic_ProductDefinitionFormation): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  RelatingProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  SetRelatingProductDefinitionFormation(RelatingProductDefinitionFormation: Handle_StepBasic_ProductDefinitionFormation): void;
  RelatedProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  SetRelatedProductDefinitionFormation(RelatedProductDefinitionFormation: Handle_StepBasic_ProductDefinitionFormation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionFormationRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionFormationRelationship): void;
  get(): StepBasic_ProductDefinitionFormationRelationship;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionFormationRelationship_1 extends Handle_StepBasic_ProductDefinitionFormationRelationship {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionFormationRelationship_2 extends Handle_StepBasic_ProductDefinitionFormationRelationship {
    constructor(thePtr: StepBasic_ProductDefinitionFormationRelationship);
  }

  export declare class Handle_StepBasic_ProductDefinitionFormationRelationship_3 extends Handle_StepBasic_ProductDefinitionFormationRelationship {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionFormationRelationship);
  }

  export declare class Handle_StepBasic_ProductDefinitionFormationRelationship_4 extends Handle_StepBasic_ProductDefinitionFormationRelationship {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionFormationRelationship);
  }

export declare class StepBasic_ProductCategory extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasAdescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  UnSetDescription(): void;
  Description(): Handle_TCollection_HAsciiString;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductCategory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductCategory): void;
  get(): StepBasic_ProductCategory;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductCategory_1 extends Handle_StepBasic_ProductCategory {
    constructor();
  }

  export declare class Handle_StepBasic_ProductCategory_2 extends Handle_StepBasic_ProductCategory {
    constructor(thePtr: StepBasic_ProductCategory);
  }

  export declare class Handle_StepBasic_ProductCategory_3 extends Handle_StepBasic_ProductCategory {
    constructor(theHandle: Handle_StepBasic_ProductCategory);
  }

  export declare class Handle_StepBasic_ProductCategory_4 extends Handle_StepBasic_ProductCategory {
    constructor(theHandle: Handle_StepBasic_ProductCategory);
  }

export declare class Handle_StepBasic_MassMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_MassMeasureWithUnit): void;
  get(): StepBasic_MassMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_MassMeasureWithUnit_1 extends Handle_StepBasic_MassMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_MassMeasureWithUnit_2 extends Handle_StepBasic_MassMeasureWithUnit {
    constructor(thePtr: StepBasic_MassMeasureWithUnit);
  }

  export declare class Handle_StepBasic_MassMeasureWithUnit_3 extends Handle_StepBasic_MassMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_MassMeasureWithUnit);
  }

  export declare class Handle_StepBasic_MassMeasureWithUnit_4 extends Handle_StepBasic_MassMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_MassMeasureWithUnit);
  }

export declare class StepBasic_MassMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndTimeUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndTimeUnit): void;
  get(): StepBasic_ConversionBasedUnitAndTimeUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndTimeUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndTimeUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndTimeUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndTimeUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndTimeUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndTimeUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndTimeUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndTimeUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndTimeUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndTimeUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndTimeUnit);
  }

export declare class StepBasic_ConversionBasedUnitAndTimeUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetTimeUnit(aTimeUnit: Handle_StepBasic_TimeUnit): void;
  TimeUnit(): Handle_StepBasic_TimeUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_CalendarDate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_CalendarDate): void;
  get(): StepBasic_CalendarDate;
  delete(): void;
}

  export declare class Handle_StepBasic_CalendarDate_1 extends Handle_StepBasic_CalendarDate {
    constructor();
  }

  export declare class Handle_StepBasic_CalendarDate_2 extends Handle_StepBasic_CalendarDate {
    constructor(thePtr: StepBasic_CalendarDate);
  }

  export declare class Handle_StepBasic_CalendarDate_3 extends Handle_StepBasic_CalendarDate {
    constructor(theHandle: Handle_StepBasic_CalendarDate);
  }

  export declare class Handle_StepBasic_CalendarDate_4 extends Handle_StepBasic_CalendarDate {
    constructor(theHandle: Handle_StepBasic_CalendarDate);
  }

export declare class StepBasic_CalendarDate extends StepBasic_Date {
  constructor()
  Init(aYearComponent: Graphic3d_ZLayerId, aDayComponent: Graphic3d_ZLayerId, aMonthComponent: Graphic3d_ZLayerId): void;
  SetDayComponent(aDayComponent: Graphic3d_ZLayerId): void;
  DayComponent(): Graphic3d_ZLayerId;
  SetMonthComponent(aMonthComponent: Graphic3d_ZLayerId): void;
  MonthComponent(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_NameAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedName: Handle_TCollection_HAsciiString): void;
  AssignedName(): Handle_TCollection_HAsciiString;
  SetAssignedName(AssignedName: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_NameAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_NameAssignment): void;
  get(): StepBasic_NameAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_NameAssignment_1 extends Handle_StepBasic_NameAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_NameAssignment_2 extends Handle_StepBasic_NameAssignment {
    constructor(thePtr: StepBasic_NameAssignment);
  }

  export declare class Handle_StepBasic_NameAssignment_3 extends Handle_StepBasic_NameAssignment {
    constructor(theHandle: Handle_StepBasic_NameAssignment);
  }

  export declare class Handle_StepBasic_NameAssignment_4 extends Handle_StepBasic_NameAssignment {
    constructor(theHandle: Handle_StepBasic_NameAssignment);
  }

export declare class Handle_StepBasic_TimeMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_TimeMeasureWithUnit): void;
  get(): StepBasic_TimeMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_TimeMeasureWithUnit_1 extends Handle_StepBasic_TimeMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_TimeMeasureWithUnit_2 extends Handle_StepBasic_TimeMeasureWithUnit {
    constructor(thePtr: StepBasic_TimeMeasureWithUnit);
  }

  export declare class Handle_StepBasic_TimeMeasureWithUnit_3 extends Handle_StepBasic_TimeMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_TimeMeasureWithUnit);
  }

  export declare class Handle_StepBasic_TimeMeasureWithUnit_4 extends Handle_StepBasic_TimeMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_TimeMeasureWithUnit);
  }

export declare class StepBasic_TimeMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductContext): void;
  get(): StepBasic_ProductContext;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductContext_1 extends Handle_StepBasic_ProductContext {
    constructor();
  }

  export declare class Handle_StepBasic_ProductContext_2 extends Handle_StepBasic_ProductContext {
    constructor(thePtr: StepBasic_ProductContext);
  }

  export declare class Handle_StepBasic_ProductContext_3 extends Handle_StepBasic_ProductContext {
    constructor(theHandle: Handle_StepBasic_ProductContext);
  }

  export declare class Handle_StepBasic_ProductContext_4 extends Handle_StepBasic_ProductContext {
    constructor(theHandle: Handle_StepBasic_ProductContext);
  }

export declare class StepBasic_ProductContext extends StepBasic_ApplicationContextElement {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aFrameOfReference: Handle_StepBasic_ApplicationContext, aDisciplineType: Handle_TCollection_HAsciiString): void;
  SetDisciplineType(aDisciplineType: Handle_TCollection_HAsciiString): void;
  DisciplineType(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_AreaUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_AreaUnit): void;
  get(): StepBasic_AreaUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_AreaUnit_1 extends Handle_StepBasic_AreaUnit {
    constructor();
  }

  export declare class Handle_StepBasic_AreaUnit_2 extends Handle_StepBasic_AreaUnit {
    constructor(thePtr: StepBasic_AreaUnit);
  }

  export declare class Handle_StepBasic_AreaUnit_3 extends Handle_StepBasic_AreaUnit {
    constructor(theHandle: Handle_StepBasic_AreaUnit);
  }

  export declare class Handle_StepBasic_AreaUnit_4 extends Handle_StepBasic_AreaUnit {
    constructor(theHandle: Handle_StepBasic_AreaUnit);
  }

export declare class StepBasic_AreaUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionFormation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionFormation): void;
  get(): StepBasic_ProductDefinitionFormation;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionFormation_1 extends Handle_StepBasic_ProductDefinitionFormation {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionFormation_2 extends Handle_StepBasic_ProductDefinitionFormation {
    constructor(thePtr: StepBasic_ProductDefinitionFormation);
  }

  export declare class Handle_StepBasic_ProductDefinitionFormation_3 extends Handle_StepBasic_ProductDefinitionFormation {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionFormation);
  }

  export declare class Handle_StepBasic_ProductDefinitionFormation_4 extends Handle_StepBasic_ProductDefinitionFormation {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionFormation);
  }

export declare class StepBasic_ProductDefinitionFormation extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aOfProduct: Handle_StepBasic_Product): void;
  SetId(aId: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetOfProduct(aOfProduct: Handle_StepBasic_Product): void;
  OfProduct(): Handle_StepBasic_Product;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_VersionedActionRequest {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_VersionedActionRequest): void;
  get(): StepBasic_VersionedActionRequest;
  delete(): void;
}

  export declare class Handle_StepBasic_VersionedActionRequest_1 extends Handle_StepBasic_VersionedActionRequest {
    constructor();
  }

  export declare class Handle_StepBasic_VersionedActionRequest_2 extends Handle_StepBasic_VersionedActionRequest {
    constructor(thePtr: StepBasic_VersionedActionRequest);
  }

  export declare class Handle_StepBasic_VersionedActionRequest_3 extends Handle_StepBasic_VersionedActionRequest {
    constructor(theHandle: Handle_StepBasic_VersionedActionRequest);
  }

  export declare class Handle_StepBasic_VersionedActionRequest_4 extends Handle_StepBasic_VersionedActionRequest {
    constructor(theHandle: Handle_StepBasic_VersionedActionRequest);
  }

export declare class StepBasic_VersionedActionRequest extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aVersion: Handle_TCollection_HAsciiString, aPurpose: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Version(): Handle_TCollection_HAsciiString;
  SetVersion(Version: Handle_TCollection_HAsciiString): void;
  Purpose(): Handle_TCollection_HAsciiString;
  SetPurpose(Purpose: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_GroupAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_GroupAssignment): void;
  get(): StepBasic_GroupAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_GroupAssignment_1 extends Handle_StepBasic_GroupAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_GroupAssignment_2 extends Handle_StepBasic_GroupAssignment {
    constructor(thePtr: StepBasic_GroupAssignment);
  }

  export declare class Handle_StepBasic_GroupAssignment_3 extends Handle_StepBasic_GroupAssignment {
    constructor(theHandle: Handle_StepBasic_GroupAssignment);
  }

  export declare class Handle_StepBasic_GroupAssignment_4 extends Handle_StepBasic_GroupAssignment {
    constructor(theHandle: Handle_StepBasic_GroupAssignment);
  }

export declare class StepBasic_GroupAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedGroup: Handle_StepBasic_Group): void;
  AssignedGroup(): Handle_StepBasic_Group;
  SetAssignedGroup(AssignedGroup: Handle_StepBasic_Group): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_Approval extends Standard_Transient {
  constructor()
  Init(aStatus: Handle_StepBasic_ApprovalStatus, aLevel: Handle_TCollection_HAsciiString): void;
  SetStatus(aStatus: Handle_StepBasic_ApprovalStatus): void;
  Status(): Handle_StepBasic_ApprovalStatus;
  SetLevel(aLevel: Handle_TCollection_HAsciiString): void;
  Level(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Approval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Approval): void;
  get(): StepBasic_Approval;
  delete(): void;
}

  export declare class Handle_StepBasic_Approval_1 extends Handle_StepBasic_Approval {
    constructor();
  }

  export declare class Handle_StepBasic_Approval_2 extends Handle_StepBasic_Approval {
    constructor(thePtr: StepBasic_Approval);
  }

  export declare class Handle_StepBasic_Approval_3 extends Handle_StepBasic_Approval {
    constructor(theHandle: Handle_StepBasic_Approval);
  }

  export declare class Handle_StepBasic_Approval_4 extends Handle_StepBasic_Approval {
    constructor(theHandle: Handle_StepBasic_Approval);
  }

export declare class Handle_StepBasic_SiUnitAndLengthUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndLengthUnit): void;
  get(): StepBasic_SiUnitAndLengthUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndLengthUnit_1 extends Handle_StepBasic_SiUnitAndLengthUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndLengthUnit_2 extends Handle_StepBasic_SiUnitAndLengthUnit {
    constructor(thePtr: StepBasic_SiUnitAndLengthUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndLengthUnit_3 extends Handle_StepBasic_SiUnitAndLengthUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndLengthUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndLengthUnit_4 extends Handle_StepBasic_SiUnitAndLengthUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndLengthUnit);
  }

export declare class StepBasic_SiUnitAndLengthUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetLengthUnit(aLengthUnit: Handle_StepBasic_LengthUnit): void;
  LengthUnit(): Handle_StepBasic_LengthUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_CoordinatedUniversalTimeOffset {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_CoordinatedUniversalTimeOffset): void;
  get(): StepBasic_CoordinatedUniversalTimeOffset;
  delete(): void;
}

  export declare class Handle_StepBasic_CoordinatedUniversalTimeOffset_1 extends Handle_StepBasic_CoordinatedUniversalTimeOffset {
    constructor();
  }

  export declare class Handle_StepBasic_CoordinatedUniversalTimeOffset_2 extends Handle_StepBasic_CoordinatedUniversalTimeOffset {
    constructor(thePtr: StepBasic_CoordinatedUniversalTimeOffset);
  }

  export declare class Handle_StepBasic_CoordinatedUniversalTimeOffset_3 extends Handle_StepBasic_CoordinatedUniversalTimeOffset {
    constructor(theHandle: Handle_StepBasic_CoordinatedUniversalTimeOffset);
  }

  export declare class Handle_StepBasic_CoordinatedUniversalTimeOffset_4 extends Handle_StepBasic_CoordinatedUniversalTimeOffset {
    constructor(theHandle: Handle_StepBasic_CoordinatedUniversalTimeOffset);
  }

export declare class StepBasic_CoordinatedUniversalTimeOffset extends Standard_Transient {
  constructor()
  Init(aHourOffset: Graphic3d_ZLayerId, hasAminuteOffset: Standard_Boolean, aMinuteOffset: Graphic3d_ZLayerId, aSense: StepBasic_AheadOrBehind): void;
  SetHourOffset(aHourOffset: Graphic3d_ZLayerId): void;
  HourOffset(): Graphic3d_ZLayerId;
  SetMinuteOffset(aMinuteOffset: Graphic3d_ZLayerId): void;
  UnSetMinuteOffset(): void;
  MinuteOffset(): Graphic3d_ZLayerId;
  HasMinuteOffset(): Standard_Boolean;
  SetSense(aSense: StepBasic_AheadOrBehind): void;
  Sense(): StepBasic_AheadOrBehind;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ExternalSource extends Standard_Transient {
  constructor()
  Init(aSourceId: StepBasic_SourceItem): void;
  SourceId(): StepBasic_SourceItem;
  SetSourceId(SourceId: StepBasic_SourceItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ExternalSource {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ExternalSource): void;
  get(): StepBasic_ExternalSource;
  delete(): void;
}

  export declare class Handle_StepBasic_ExternalSource_1 extends Handle_StepBasic_ExternalSource {
    constructor();
  }

  export declare class Handle_StepBasic_ExternalSource_2 extends Handle_StepBasic_ExternalSource {
    constructor(thePtr: StepBasic_ExternalSource);
  }

  export declare class Handle_StepBasic_ExternalSource_3 extends Handle_StepBasic_ExternalSource {
    constructor(theHandle: Handle_StepBasic_ExternalSource);
  }

  export declare class Handle_StepBasic_ExternalSource_4 extends Handle_StepBasic_ExternalSource {
    constructor(theHandle: Handle_StepBasic_ExternalSource);
  }

export declare class StepBasic_DerivedUnit extends Standard_Transient {
  constructor()
  Init(elements: Handle_StepBasic_HArray1OfDerivedUnitElement): void;
  SetElements(elements: Handle_StepBasic_HArray1OfDerivedUnitElement): void;
  Elements(): Handle_StepBasic_HArray1OfDerivedUnitElement;
  NbElements(): Graphic3d_ZLayerId;
  ElementsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_DerivedUnitElement;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DerivedUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DerivedUnit): void;
  get(): StepBasic_DerivedUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_DerivedUnit_1 extends Handle_StepBasic_DerivedUnit {
    constructor();
  }

  export declare class Handle_StepBasic_DerivedUnit_2 extends Handle_StepBasic_DerivedUnit {
    constructor(thePtr: StepBasic_DerivedUnit);
  }

  export declare class Handle_StepBasic_DerivedUnit_3 extends Handle_StepBasic_DerivedUnit {
    constructor(theHandle: Handle_StepBasic_DerivedUnit);
  }

  export declare class Handle_StepBasic_DerivedUnit_4 extends Handle_StepBasic_DerivedUnit {
    constructor(theHandle: Handle_StepBasic_DerivedUnit);
  }

export declare type StepBasic_AheadOrBehind = {
  StepBasic_aobAhead: {};
  StepBasic_aobExact: {};
  StepBasic_aobBehind: {};
}

export declare class StepBasic_DocumentFile extends StepBasic_Document {
  constructor()
  Init(aDocument_Id: Handle_TCollection_HAsciiString, aDocument_Name: Handle_TCollection_HAsciiString, hasDocument_Description: Standard_Boolean, aDocument_Description: Handle_TCollection_HAsciiString, aDocument_Kind: Handle_StepBasic_DocumentType, aCharacterizedObject_Name: Handle_TCollection_HAsciiString, hasCharacterizedObject_Description: Standard_Boolean, aCharacterizedObject_Description: Handle_TCollection_HAsciiString): void;
  CharacterizedObject(): Handle_StepBasic_CharacterizedObject;
  SetCharacterizedObject(CharacterizedObject: Handle_StepBasic_CharacterizedObject): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentFile {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentFile): void;
  get(): StepBasic_DocumentFile;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentFile_1 extends Handle_StepBasic_DocumentFile {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentFile_2 extends Handle_StepBasic_DocumentFile {
    constructor(thePtr: StepBasic_DocumentFile);
  }

  export declare class Handle_StepBasic_DocumentFile_3 extends Handle_StepBasic_DocumentFile {
    constructor(theHandle: Handle_StepBasic_DocumentFile);
  }

  export declare class Handle_StepBasic_DocumentFile_4 extends Handle_StepBasic_DocumentFile {
    constructor(theHandle: Handle_StepBasic_DocumentFile);
  }

export declare class Handle_StepBasic_ApprovalStatus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApprovalStatus): void;
  get(): StepBasic_ApprovalStatus;
  delete(): void;
}

  export declare class Handle_StepBasic_ApprovalStatus_1 extends Handle_StepBasic_ApprovalStatus {
    constructor();
  }

  export declare class Handle_StepBasic_ApprovalStatus_2 extends Handle_StepBasic_ApprovalStatus {
    constructor(thePtr: StepBasic_ApprovalStatus);
  }

  export declare class Handle_StepBasic_ApprovalStatus_3 extends Handle_StepBasic_ApprovalStatus {
    constructor(theHandle: Handle_StepBasic_ApprovalStatus);
  }

  export declare class Handle_StepBasic_ApprovalStatus_4 extends Handle_StepBasic_ApprovalStatus {
    constructor(theHandle: Handle_StepBasic_ApprovalStatus);
  }

export declare class StepBasic_ApprovalStatus extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_DocumentUsageConstraint extends Standard_Transient {
  constructor()
  Init(aSource: Handle_StepBasic_Document, ase: Handle_TCollection_HAsciiString, asev: Handle_TCollection_HAsciiString): void;
  Source(): Handle_StepBasic_Document;
  SetSource(aSource: Handle_StepBasic_Document): void;
  SubjectElement(): Handle_TCollection_HAsciiString;
  SetSubjectElement(ase: Handle_TCollection_HAsciiString): void;
  SubjectElementValue(): Handle_TCollection_HAsciiString;
  SetSubjectElementValue(asev: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentUsageConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentUsageConstraint): void;
  get(): StepBasic_DocumentUsageConstraint;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentUsageConstraint_1 extends Handle_StepBasic_DocumentUsageConstraint {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentUsageConstraint_2 extends Handle_StepBasic_DocumentUsageConstraint {
    constructor(thePtr: StepBasic_DocumentUsageConstraint);
  }

  export declare class Handle_StepBasic_DocumentUsageConstraint_3 extends Handle_StepBasic_DocumentUsageConstraint {
    constructor(theHandle: Handle_StepBasic_DocumentUsageConstraint);
  }

  export declare class Handle_StepBasic_DocumentUsageConstraint_4 extends Handle_StepBasic_DocumentUsageConstraint {
    constructor(theHandle: Handle_StepBasic_DocumentUsageConstraint);
  }

export declare class Handle_StepBasic_IdentificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_IdentificationAssignment): void;
  get(): StepBasic_IdentificationAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_IdentificationAssignment_1 extends Handle_StepBasic_IdentificationAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_IdentificationAssignment_2 extends Handle_StepBasic_IdentificationAssignment {
    constructor(thePtr: StepBasic_IdentificationAssignment);
  }

  export declare class Handle_StepBasic_IdentificationAssignment_3 extends Handle_StepBasic_IdentificationAssignment {
    constructor(theHandle: Handle_StepBasic_IdentificationAssignment);
  }

  export declare class Handle_StepBasic_IdentificationAssignment_4 extends Handle_StepBasic_IdentificationAssignment {
    constructor(theHandle: Handle_StepBasic_IdentificationAssignment);
  }

export declare class StepBasic_IdentificationAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedId: Handle_TCollection_HAsciiString, aRole: Handle_StepBasic_IdentificationRole): void;
  AssignedId(): Handle_TCollection_HAsciiString;
  SetAssignedId(AssignedId: Handle_TCollection_HAsciiString): void;
  Role(): Handle_StepBasic_IdentificationRole;
  SetRole(Role: Handle_StepBasic_IdentificationRole): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndRatioUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndRatioUnit): void;
  get(): StepBasic_ConversionBasedUnitAndRatioUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndRatioUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndRatioUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndRatioUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndRatioUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndRatioUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndRatioUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndRatioUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndRatioUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndRatioUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndRatioUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndRatioUnit);
  }

export declare class StepBasic_ConversionBasedUnitAndRatioUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetRatioUnit(aRatioUnit: Handle_StepBasic_RatioUnit): void;
  RatioUnit(): Handle_StepBasic_RatioUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionRelationship): void;
  get(): StepBasic_ProductDefinitionRelationship;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionRelationship_1 extends Handle_StepBasic_ProductDefinitionRelationship {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionRelationship_2 extends Handle_StepBasic_ProductDefinitionRelationship {
    constructor(thePtr: StepBasic_ProductDefinitionRelationship);
  }

  export declare class Handle_StepBasic_ProductDefinitionRelationship_3 extends Handle_StepBasic_ProductDefinitionRelationship {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionRelationship);
  }

  export declare class Handle_StepBasic_ProductDefinitionRelationship_4 extends Handle_StepBasic_ProductDefinitionRelationship {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionRelationship);
  }

export declare class StepBasic_ProductDefinitionRelationship extends Standard_Transient {
  constructor()
  Init_1(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aRelatingProductDefinition: Handle_StepBasic_ProductDefinition, aRelatedProductDefinition: Handle_StepBasic_ProductDefinition): void;
  Init_2(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aRelatingProductDefinition: StepBasic_ProductDefinitionOrReference, aRelatedProductDefinition: StepBasic_ProductDefinitionOrReference): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  RelatingProductDefinition(): Handle_StepBasic_ProductDefinition;
  RelatingProductDefinitionAP242(): StepBasic_ProductDefinitionOrReference;
  SetRelatingProductDefinition_1(RelatingProductDefinition: Handle_StepBasic_ProductDefinition): void;
  SetRelatingProductDefinition_2(RelatingProductDefinition: StepBasic_ProductDefinitionOrReference): void;
  RelatedProductDefinition(): Handle_StepBasic_ProductDefinition;
  RelatedProductDefinitionAP242(): StepBasic_ProductDefinitionOrReference;
  SetRelatedProductDefinition_1(RelatedProductDefinition: Handle_StepBasic_ProductDefinition): void;
  SetRelatedProductDefinition_2(RelatedProductDefinition: StepBasic_ProductDefinitionOrReference): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_HArray1OfProduct {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfProduct): void;
  get(): StepBasic_HArray1OfProduct;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfProduct_1 extends Handle_StepBasic_HArray1OfProduct {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfProduct_2 extends Handle_StepBasic_HArray1OfProduct {
    constructor(thePtr: StepBasic_HArray1OfProduct);
  }

  export declare class Handle_StepBasic_HArray1OfProduct_3 extends Handle_StepBasic_HArray1OfProduct {
    constructor(theHandle: Handle_StepBasic_HArray1OfProduct);
  }

  export declare class Handle_StepBasic_HArray1OfProduct_4 extends Handle_StepBasic_HArray1OfProduct {
    constructor(theHandle: Handle_StepBasic_HArray1OfProduct);
  }

export declare class Handle_StepBasic_Certification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Certification): void;
  get(): StepBasic_Certification;
  delete(): void;
}

  export declare class Handle_StepBasic_Certification_1 extends Handle_StepBasic_Certification {
    constructor();
  }

  export declare class Handle_StepBasic_Certification_2 extends Handle_StepBasic_Certification {
    constructor(thePtr: StepBasic_Certification);
  }

  export declare class Handle_StepBasic_Certification_3 extends Handle_StepBasic_Certification {
    constructor(theHandle: Handle_StepBasic_Certification);
  }

  export declare class Handle_StepBasic_Certification_4 extends Handle_StepBasic_Certification {
    constructor(theHandle: Handle_StepBasic_Certification);
  }

export declare class StepBasic_Certification extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPurpose: Handle_TCollection_HAsciiString, aKind: Handle_StepBasic_CertificationType): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Purpose(): Handle_TCollection_HAsciiString;
  SetPurpose(Purpose: Handle_TCollection_HAsciiString): void;
  Kind(): Handle_StepBasic_CertificationType;
  SetKind(Kind: Handle_StepBasic_CertificationType): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_DimensionalExponents extends Standard_Transient {
  constructor()
  Init(aLengthExponent: Quantity_AbsorbedDose, aMassExponent: Quantity_AbsorbedDose, aTimeExponent: Quantity_AbsorbedDose, aElectricCurrentExponent: Quantity_AbsorbedDose, aThermodynamicTemperatureExponent: Quantity_AbsorbedDose, aAmountOfSubstanceExponent: Quantity_AbsorbedDose, aLuminousIntensityExponent: Quantity_AbsorbedDose): void;
  SetLengthExponent(aLengthExponent: Quantity_AbsorbedDose): void;
  LengthExponent(): Quantity_AbsorbedDose;
  SetMassExponent(aMassExponent: Quantity_AbsorbedDose): void;
  MassExponent(): Quantity_AbsorbedDose;
  SetTimeExponent(aTimeExponent: Quantity_AbsorbedDose): void;
  TimeExponent(): Quantity_AbsorbedDose;
  SetElectricCurrentExponent(aElectricCurrentExponent: Quantity_AbsorbedDose): void;
  ElectricCurrentExponent(): Quantity_AbsorbedDose;
  SetThermodynamicTemperatureExponent(aThermodynamicTemperatureExponent: Quantity_AbsorbedDose): void;
  ThermodynamicTemperatureExponent(): Quantity_AbsorbedDose;
  SetAmountOfSubstanceExponent(aAmountOfSubstanceExponent: Quantity_AbsorbedDose): void;
  AmountOfSubstanceExponent(): Quantity_AbsorbedDose;
  SetLuminousIntensityExponent(aLuminousIntensityExponent: Quantity_AbsorbedDose): void;
  LuminousIntensityExponent(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DimensionalExponents {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DimensionalExponents): void;
  get(): StepBasic_DimensionalExponents;
  delete(): void;
}

  export declare class Handle_StepBasic_DimensionalExponents_1 extends Handle_StepBasic_DimensionalExponents {
    constructor();
  }

  export declare class Handle_StepBasic_DimensionalExponents_2 extends Handle_StepBasic_DimensionalExponents {
    constructor(thePtr: StepBasic_DimensionalExponents);
  }

  export declare class Handle_StepBasic_DimensionalExponents_3 extends Handle_StepBasic_DimensionalExponents {
    constructor(theHandle: Handle_StepBasic_DimensionalExponents);
  }

  export declare class Handle_StepBasic_DimensionalExponents_4 extends Handle_StepBasic_DimensionalExponents {
    constructor(theHandle: Handle_StepBasic_DimensionalExponents);
  }

export declare class StepBasic_Document extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aKind: Handle_StepBasic_DocumentType): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  Kind(): Handle_StepBasic_DocumentType;
  SetKind(Kind: Handle_StepBasic_DocumentType): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Document {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Document): void;
  get(): StepBasic_Document;
  delete(): void;
}

  export declare class Handle_StepBasic_Document_1 extends Handle_StepBasic_Document {
    constructor();
  }

  export declare class Handle_StepBasic_Document_2 extends Handle_StepBasic_Document {
    constructor(thePtr: StepBasic_Document);
  }

  export declare class Handle_StepBasic_Document_3 extends Handle_StepBasic_Document {
    constructor(theHandle: Handle_StepBasic_Document);
  }

  export declare class Handle_StepBasic_Document_4 extends Handle_StepBasic_Document {
    constructor(theHandle: Handle_StepBasic_Document);
  }

export declare class StepBasic_OrganizationAssignment extends Standard_Transient {
  constructor();
  Init(aAssignedOrganization: Handle_StepBasic_Organization, aRole: Handle_StepBasic_OrganizationRole): void;
  SetAssignedOrganization(aAssignedOrganization: Handle_StepBasic_Organization): void;
  AssignedOrganization(): Handle_StepBasic_Organization;
  SetRole(aRole: Handle_StepBasic_OrganizationRole): void;
  Role(): Handle_StepBasic_OrganizationRole;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_OrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_OrganizationAssignment): void;
  get(): StepBasic_OrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_OrganizationAssignment_1 extends Handle_StepBasic_OrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_OrganizationAssignment_2 extends Handle_StepBasic_OrganizationAssignment {
    constructor(thePtr: StepBasic_OrganizationAssignment);
  }

  export declare class Handle_StepBasic_OrganizationAssignment_3 extends Handle_StepBasic_OrganizationAssignment {
    constructor(theHandle: Handle_StepBasic_OrganizationAssignment);
  }

  export declare class Handle_StepBasic_OrganizationAssignment_4 extends Handle_StepBasic_OrganizationAssignment {
    constructor(theHandle: Handle_StepBasic_OrganizationAssignment);
  }

export declare class Handle_StepBasic_SizeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SizeMember): void;
  get(): StepBasic_SizeMember;
  delete(): void;
}

  export declare class Handle_StepBasic_SizeMember_1 extends Handle_StepBasic_SizeMember {
    constructor();
  }

  export declare class Handle_StepBasic_SizeMember_2 extends Handle_StepBasic_SizeMember {
    constructor(thePtr: StepBasic_SizeMember);
  }

  export declare class Handle_StepBasic_SizeMember_3 extends Handle_StepBasic_SizeMember {
    constructor(theHandle: Handle_StepBasic_SizeMember);
  }

  export declare class Handle_StepBasic_SizeMember_4 extends Handle_StepBasic_SizeMember {
    constructor(theHandle: Handle_StepBasic_SizeMember);
  }

export declare class StepBasic_SizeMember extends StepData_SelectReal {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_PersonAndOrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PersonAndOrganizationAssignment): void;
  get(): StepBasic_PersonAndOrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_PersonAndOrganizationAssignment_1 extends Handle_StepBasic_PersonAndOrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_PersonAndOrganizationAssignment_2 extends Handle_StepBasic_PersonAndOrganizationAssignment {
    constructor(thePtr: StepBasic_PersonAndOrganizationAssignment);
  }

  export declare class Handle_StepBasic_PersonAndOrganizationAssignment_3 extends Handle_StepBasic_PersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepBasic_PersonAndOrganizationAssignment);
  }

  export declare class Handle_StepBasic_PersonAndOrganizationAssignment_4 extends Handle_StepBasic_PersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepBasic_PersonAndOrganizationAssignment);
  }

export declare class StepBasic_PersonAndOrganizationAssignment extends Standard_Transient {
  constructor();
  Init(aAssignedPersonAndOrganization: Handle_StepBasic_PersonAndOrganization, aRole: Handle_StepBasic_PersonAndOrganizationRole): void;
  SetAssignedPersonAndOrganization(aAssignedPersonAndOrganization: Handle_StepBasic_PersonAndOrganization): void;
  AssignedPersonAndOrganization(): Handle_StepBasic_PersonAndOrganization;
  SetRole(aRole: Handle_StepBasic_PersonAndOrganizationRole): void;
  Role(): Handle_StepBasic_PersonAndOrganizationRole;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_HArray1OfApproval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfApproval): void;
  get(): StepBasic_HArray1OfApproval;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfApproval_1 extends Handle_StepBasic_HArray1OfApproval {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfApproval_2 extends Handle_StepBasic_HArray1OfApproval {
    constructor(thePtr: StepBasic_HArray1OfApproval);
  }

  export declare class Handle_StepBasic_HArray1OfApproval_3 extends Handle_StepBasic_HArray1OfApproval {
    constructor(theHandle: Handle_StepBasic_HArray1OfApproval);
  }

  export declare class Handle_StepBasic_HArray1OfApproval_4 extends Handle_StepBasic_HArray1OfApproval {
    constructor(theHandle: Handle_StepBasic_HArray1OfApproval);
  }

export declare class StepBasic_ApplicationContextElement extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aFrameOfReference: Handle_StepBasic_ApplicationContext): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetFrameOfReference(aFrameOfReference: Handle_StepBasic_ApplicationContext): void;
  FrameOfReference(): Handle_StepBasic_ApplicationContext;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ApplicationContextElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApplicationContextElement): void;
  get(): StepBasic_ApplicationContextElement;
  delete(): void;
}

  export declare class Handle_StepBasic_ApplicationContextElement_1 extends Handle_StepBasic_ApplicationContextElement {
    constructor();
  }

  export declare class Handle_StepBasic_ApplicationContextElement_2 extends Handle_StepBasic_ApplicationContextElement {
    constructor(thePtr: StepBasic_ApplicationContextElement);
  }

  export declare class Handle_StepBasic_ApplicationContextElement_3 extends Handle_StepBasic_ApplicationContextElement {
    constructor(theHandle: Handle_StepBasic_ApplicationContextElement);
  }

  export declare class Handle_StepBasic_ApplicationContextElement_4 extends Handle_StepBasic_ApplicationContextElement {
    constructor(theHandle: Handle_StepBasic_ApplicationContextElement);
  }

export declare class Handle_StepBasic_HArray1OfDerivedUnitElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfDerivedUnitElement): void;
  get(): StepBasic_HArray1OfDerivedUnitElement;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfDerivedUnitElement_1 extends Handle_StepBasic_HArray1OfDerivedUnitElement {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfDerivedUnitElement_2 extends Handle_StepBasic_HArray1OfDerivedUnitElement {
    constructor(thePtr: StepBasic_HArray1OfDerivedUnitElement);
  }

  export declare class Handle_StepBasic_HArray1OfDerivedUnitElement_3 extends Handle_StepBasic_HArray1OfDerivedUnitElement {
    constructor(theHandle: Handle_StepBasic_HArray1OfDerivedUnitElement);
  }

  export declare class Handle_StepBasic_HArray1OfDerivedUnitElement_4 extends Handle_StepBasic_HArray1OfDerivedUnitElement {
    constructor(theHandle: Handle_StepBasic_HArray1OfDerivedUnitElement);
  }

export declare class Handle_StepBasic_CertificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_CertificationAssignment): void;
  get(): StepBasic_CertificationAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_CertificationAssignment_1 extends Handle_StepBasic_CertificationAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_CertificationAssignment_2 extends Handle_StepBasic_CertificationAssignment {
    constructor(thePtr: StepBasic_CertificationAssignment);
  }

  export declare class Handle_StepBasic_CertificationAssignment_3 extends Handle_StepBasic_CertificationAssignment {
    constructor(theHandle: Handle_StepBasic_CertificationAssignment);
  }

  export declare class Handle_StepBasic_CertificationAssignment_4 extends Handle_StepBasic_CertificationAssignment {
    constructor(theHandle: Handle_StepBasic_CertificationAssignment);
  }

export declare class StepBasic_CertificationAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedCertification: Handle_StepBasic_Certification): void;
  AssignedCertification(): Handle_StepBasic_Certification;
  SetAssignedCertification(AssignedCertification: Handle_StepBasic_Certification): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_HArray1OfProductContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfProductContext): void;
  get(): StepBasic_HArray1OfProductContext;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfProductContext_1 extends Handle_StepBasic_HArray1OfProductContext {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfProductContext_2 extends Handle_StepBasic_HArray1OfProductContext {
    constructor(thePtr: StepBasic_HArray1OfProductContext);
  }

  export declare class Handle_StepBasic_HArray1OfProductContext_3 extends Handle_StepBasic_HArray1OfProductContext {
    constructor(theHandle: Handle_StepBasic_HArray1OfProductContext);
  }

  export declare class Handle_StepBasic_HArray1OfProductContext_4 extends Handle_StepBasic_HArray1OfProductContext {
    constructor(theHandle: Handle_StepBasic_HArray1OfProductContext);
  }

export declare class Handle_StepBasic_CharacterizedObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_CharacterizedObject): void;
  get(): StepBasic_CharacterizedObject;
  delete(): void;
}

  export declare class Handle_StepBasic_CharacterizedObject_1 extends Handle_StepBasic_CharacterizedObject {
    constructor();
  }

  export declare class Handle_StepBasic_CharacterizedObject_2 extends Handle_StepBasic_CharacterizedObject {
    constructor(thePtr: StepBasic_CharacterizedObject);
  }

  export declare class Handle_StepBasic_CharacterizedObject_3 extends Handle_StepBasic_CharacterizedObject {
    constructor(theHandle: Handle_StepBasic_CharacterizedObject);
  }

  export declare class Handle_StepBasic_CharacterizedObject_4 extends Handle_StepBasic_CharacterizedObject {
    constructor(theHandle: Handle_StepBasic_CharacterizedObject);
  }

export declare class StepBasic_CharacterizedObject extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_GeneralProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_GeneralProperty): void;
  get(): StepBasic_GeneralProperty;
  delete(): void;
}

  export declare class Handle_StepBasic_GeneralProperty_1 extends Handle_StepBasic_GeneralProperty {
    constructor();
  }

  export declare class Handle_StepBasic_GeneralProperty_2 extends Handle_StepBasic_GeneralProperty {
    constructor(thePtr: StepBasic_GeneralProperty);
  }

  export declare class Handle_StepBasic_GeneralProperty_3 extends Handle_StepBasic_GeneralProperty {
    constructor(theHandle: Handle_StepBasic_GeneralProperty);
  }

  export declare class Handle_StepBasic_GeneralProperty_4 extends Handle_StepBasic_GeneralProperty {
    constructor(theHandle: Handle_StepBasic_GeneralProperty);
  }

export declare class StepBasic_GeneralProperty extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_Organization extends Standard_Transient {
  constructor()
  Init(hasAid: Standard_Boolean, aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString): void;
  SetId(aId: Handle_TCollection_HAsciiString): void;
  UnSetId(): void;
  Id(): Handle_TCollection_HAsciiString;
  HasId(): Standard_Boolean;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Organization {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Organization): void;
  get(): StepBasic_Organization;
  delete(): void;
}

  export declare class Handle_StepBasic_Organization_1 extends Handle_StepBasic_Organization {
    constructor();
  }

  export declare class Handle_StepBasic_Organization_2 extends Handle_StepBasic_Organization {
    constructor(thePtr: StepBasic_Organization);
  }

  export declare class Handle_StepBasic_Organization_3 extends Handle_StepBasic_Organization {
    constructor(theHandle: Handle_StepBasic_Organization);
  }

  export declare class Handle_StepBasic_Organization_4 extends Handle_StepBasic_Organization {
    constructor(theHandle: Handle_StepBasic_Organization);
  }

export declare class StepBasic_EffectivityAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedEffectivity: Handle_StepBasic_Effectivity): void;
  AssignedEffectivity(): Handle_StepBasic_Effectivity;
  SetAssignedEffectivity(AssignedEffectivity: Handle_StepBasic_Effectivity): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_EffectivityAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_EffectivityAssignment): void;
  get(): StepBasic_EffectivityAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_EffectivityAssignment_1 extends Handle_StepBasic_EffectivityAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_EffectivityAssignment_2 extends Handle_StepBasic_EffectivityAssignment {
    constructor(thePtr: StepBasic_EffectivityAssignment);
  }

  export declare class Handle_StepBasic_EffectivityAssignment_3 extends Handle_StepBasic_EffectivityAssignment {
    constructor(theHandle: Handle_StepBasic_EffectivityAssignment);
  }

  export declare class Handle_StepBasic_EffectivityAssignment_4 extends Handle_StepBasic_EffectivityAssignment {
    constructor(theHandle: Handle_StepBasic_EffectivityAssignment);
  }

export declare class StepBasic_SiUnitAndRatioUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetRatioUnit(aRatioUnit: Handle_StepBasic_RatioUnit): void;
  RatioUnit(): Handle_StepBasic_RatioUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndRatioUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndRatioUnit): void;
  get(): StepBasic_SiUnitAndRatioUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndRatioUnit_1 extends Handle_StepBasic_SiUnitAndRatioUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndRatioUnit_2 extends Handle_StepBasic_SiUnitAndRatioUnit {
    constructor(thePtr: StepBasic_SiUnitAndRatioUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndRatioUnit_3 extends Handle_StepBasic_SiUnitAndRatioUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndRatioUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndRatioUnit_4 extends Handle_StepBasic_SiUnitAndRatioUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndRatioUnit);
  }

export declare class StepBasic_PersonAndOrganizationRole extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_PersonAndOrganizationRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PersonAndOrganizationRole): void;
  get(): StepBasic_PersonAndOrganizationRole;
  delete(): void;
}

  export declare class Handle_StepBasic_PersonAndOrganizationRole_1 extends Handle_StepBasic_PersonAndOrganizationRole {
    constructor();
  }

  export declare class Handle_StepBasic_PersonAndOrganizationRole_2 extends Handle_StepBasic_PersonAndOrganizationRole {
    constructor(thePtr: StepBasic_PersonAndOrganizationRole);
  }

  export declare class Handle_StepBasic_PersonAndOrganizationRole_3 extends Handle_StepBasic_PersonAndOrganizationRole {
    constructor(theHandle: Handle_StepBasic_PersonAndOrganizationRole);
  }

  export declare class Handle_StepBasic_PersonAndOrganizationRole_4 extends Handle_StepBasic_PersonAndOrganizationRole {
    constructor(theHandle: Handle_StepBasic_PersonAndOrganizationRole);
  }

export declare class Handle_StepBasic_RatioMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_RatioMeasureWithUnit): void;
  get(): StepBasic_RatioMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_RatioMeasureWithUnit_1 extends Handle_StepBasic_RatioMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_RatioMeasureWithUnit_2 extends Handle_StepBasic_RatioMeasureWithUnit {
    constructor(thePtr: StepBasic_RatioMeasureWithUnit);
  }

  export declare class Handle_StepBasic_RatioMeasureWithUnit_3 extends Handle_StepBasic_RatioMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_RatioMeasureWithUnit);
  }

  export declare class Handle_StepBasic_RatioMeasureWithUnit_4 extends Handle_StepBasic_RatioMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_RatioMeasureWithUnit);
  }

export declare class StepBasic_RatioMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ProductDefinitionReference extends Standard_Transient {
  constructor()
  Init_1(theSource: Handle_StepBasic_ExternalSource, theProductId: Handle_TCollection_HAsciiString, theProductDefinitionFormationId: Handle_TCollection_HAsciiString, theProductDefinitionId: Handle_TCollection_HAsciiString, theIdOwningOrganizationName: Handle_TCollection_HAsciiString): void;
  Init_2(theSource: Handle_StepBasic_ExternalSource, theProductId: Handle_TCollection_HAsciiString, theProductDefinitionFormationId: Handle_TCollection_HAsciiString, theProductDefinitionId: Handle_TCollection_HAsciiString): void;
  Source(): Handle_StepBasic_ExternalSource;
  SetSource(theSource: Handle_StepBasic_ExternalSource): void;
  ProductId(): Handle_TCollection_HAsciiString;
  SetProductId(theProductId: Handle_TCollection_HAsciiString): void;
  ProductDefinitionFormationId(): Handle_TCollection_HAsciiString;
  SetProductDefinitionFormationId(theProductDefinitionFormationId: Handle_TCollection_HAsciiString): void;
  ProductDefinitionId(): Handle_TCollection_HAsciiString;
  SetProductDefinitionId(theProductDefinitionId: Handle_TCollection_HAsciiString): void;
  IdOwningOrganizationName(): Handle_TCollection_HAsciiString;
  SetIdOwningOrganizationName(theIdOwningOrganizationName: Handle_TCollection_HAsciiString): void;
  HasIdOwningOrganizationName(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionReference): void;
  get(): StepBasic_ProductDefinitionReference;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionReference_1 extends Handle_StepBasic_ProductDefinitionReference {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionReference_2 extends Handle_StepBasic_ProductDefinitionReference {
    constructor(thePtr: StepBasic_ProductDefinitionReference);
  }

  export declare class Handle_StepBasic_ProductDefinitionReference_3 extends Handle_StepBasic_ProductDefinitionReference {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionReference);
  }

  export declare class Handle_StepBasic_ProductDefinitionReference_4 extends Handle_StepBasic_ProductDefinitionReference {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionReference);
  }

export declare class Handle_StepBasic_ApprovalRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApprovalRole): void;
  get(): StepBasic_ApprovalRole;
  delete(): void;
}

  export declare class Handle_StepBasic_ApprovalRole_1 extends Handle_StepBasic_ApprovalRole {
    constructor();
  }

  export declare class Handle_StepBasic_ApprovalRole_2 extends Handle_StepBasic_ApprovalRole {
    constructor(thePtr: StepBasic_ApprovalRole);
  }

  export declare class Handle_StepBasic_ApprovalRole_3 extends Handle_StepBasic_ApprovalRole {
    constructor(theHandle: Handle_StepBasic_ApprovalRole);
  }

  export declare class Handle_StepBasic_ApprovalRole_4 extends Handle_StepBasic_ApprovalRole {
    constructor(theHandle: Handle_StepBasic_ApprovalRole);
  }

export declare class StepBasic_ApprovalRole extends Standard_Transient {
  constructor()
  Init(aRole: Handle_TCollection_HAsciiString): void;
  SetRole(aRole: Handle_TCollection_HAsciiString): void;
  Role(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DateAndTime {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DateAndTime): void;
  get(): StepBasic_DateAndTime;
  delete(): void;
}

  export declare class Handle_StepBasic_DateAndTime_1 extends Handle_StepBasic_DateAndTime {
    constructor();
  }

  export declare class Handle_StepBasic_DateAndTime_2 extends Handle_StepBasic_DateAndTime {
    constructor(thePtr: StepBasic_DateAndTime);
  }

  export declare class Handle_StepBasic_DateAndTime_3 extends Handle_StepBasic_DateAndTime {
    constructor(theHandle: Handle_StepBasic_DateAndTime);
  }

  export declare class Handle_StepBasic_DateAndTime_4 extends Handle_StepBasic_DateAndTime {
    constructor(theHandle: Handle_StepBasic_DateAndTime);
  }

export declare class StepBasic_DateAndTime extends Standard_Transient {
  constructor()
  Init(aDateComponent: Handle_StepBasic_Date, aTimeComponent: Handle_StepBasic_LocalTime): void;
  SetDateComponent(aDateComponent: Handle_StepBasic_Date): void;
  DateComponent(): Handle_StepBasic_Date;
  SetTimeComponent(aTimeComponent: Handle_StepBasic_LocalTime): void;
  TimeComponent(): Handle_StepBasic_LocalTime;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DigitalDocument {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DigitalDocument): void;
  get(): StepBasic_DigitalDocument;
  delete(): void;
}

  export declare class Handle_StepBasic_DigitalDocument_1 extends Handle_StepBasic_DigitalDocument {
    constructor();
  }

  export declare class Handle_StepBasic_DigitalDocument_2 extends Handle_StepBasic_DigitalDocument {
    constructor(thePtr: StepBasic_DigitalDocument);
  }

  export declare class Handle_StepBasic_DigitalDocument_3 extends Handle_StepBasic_DigitalDocument {
    constructor(theHandle: Handle_StepBasic_DigitalDocument);
  }

  export declare class Handle_StepBasic_DigitalDocument_4 extends Handle_StepBasic_DigitalDocument {
    constructor(theHandle: Handle_StepBasic_DigitalDocument);
  }

export declare class StepBasic_DigitalDocument extends StepBasic_Document {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ThermodynamicTemperatureUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ThermodynamicTemperatureUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ThermodynamicTemperatureUnit): void;
  get(): StepBasic_ThermodynamicTemperatureUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ThermodynamicTemperatureUnit_1 extends Handle_StepBasic_ThermodynamicTemperatureUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ThermodynamicTemperatureUnit_2 extends Handle_StepBasic_ThermodynamicTemperatureUnit {
    constructor(thePtr: StepBasic_ThermodynamicTemperatureUnit);
  }

  export declare class Handle_StepBasic_ThermodynamicTemperatureUnit_3 extends Handle_StepBasic_ThermodynamicTemperatureUnit {
    constructor(theHandle: Handle_StepBasic_ThermodynamicTemperatureUnit);
  }

  export declare class Handle_StepBasic_ThermodynamicTemperatureUnit_4 extends Handle_StepBasic_ThermodynamicTemperatureUnit {
    constructor(theHandle: Handle_StepBasic_ThermodynamicTemperatureUnit);
  }

export declare class Handle_StepBasic_ActionAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ActionAssignment): void;
  get(): StepBasic_ActionAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_ActionAssignment_1 extends Handle_StepBasic_ActionAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_ActionAssignment_2 extends Handle_StepBasic_ActionAssignment {
    constructor(thePtr: StepBasic_ActionAssignment);
  }

  export declare class Handle_StepBasic_ActionAssignment_3 extends Handle_StepBasic_ActionAssignment {
    constructor(theHandle: Handle_StepBasic_ActionAssignment);
  }

  export declare class Handle_StepBasic_ActionAssignment_4 extends Handle_StepBasic_ActionAssignment {
    constructor(theHandle: Handle_StepBasic_ActionAssignment);
  }

export declare class StepBasic_ActionAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedAction: Handle_StepBasic_Action): void;
  AssignedAction(): Handle_StepBasic_Action;
  SetAssignedAction(AssignedAction: Handle_StepBasic_Action): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_HArray1OfDocument {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfDocument): void;
  get(): StepBasic_HArray1OfDocument;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfDocument_1 extends Handle_StepBasic_HArray1OfDocument {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfDocument_2 extends Handle_StepBasic_HArray1OfDocument {
    constructor(thePtr: StepBasic_HArray1OfDocument);
  }

  export declare class Handle_StepBasic_HArray1OfDocument_3 extends Handle_StepBasic_HArray1OfDocument {
    constructor(theHandle: Handle_StepBasic_HArray1OfDocument);
  }

  export declare class Handle_StepBasic_HArray1OfDocument_4 extends Handle_StepBasic_HArray1OfDocument {
    constructor(theHandle: Handle_StepBasic_HArray1OfDocument);
  }

export declare class StepBasic_DesignContext extends StepBasic_ProductDefinitionContext {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DesignContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DesignContext): void;
  get(): StepBasic_DesignContext;
  delete(): void;
}

  export declare class Handle_StepBasic_DesignContext_1 extends Handle_StepBasic_DesignContext {
    constructor();
  }

  export declare class Handle_StepBasic_DesignContext_2 extends Handle_StepBasic_DesignContext {
    constructor(thePtr: StepBasic_DesignContext);
  }

  export declare class Handle_StepBasic_DesignContext_3 extends Handle_StepBasic_DesignContext {
    constructor(theHandle: Handle_StepBasic_DesignContext);
  }

  export declare class Handle_StepBasic_DesignContext_4 extends Handle_StepBasic_DesignContext {
    constructor(theHandle: Handle_StepBasic_DesignContext);
  }

export declare class Handle_StepBasic_SecurityClassificationLevel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SecurityClassificationLevel): void;
  get(): StepBasic_SecurityClassificationLevel;
  delete(): void;
}

  export declare class Handle_StepBasic_SecurityClassificationLevel_1 extends Handle_StepBasic_SecurityClassificationLevel {
    constructor();
  }

  export declare class Handle_StepBasic_SecurityClassificationLevel_2 extends Handle_StepBasic_SecurityClassificationLevel {
    constructor(thePtr: StepBasic_SecurityClassificationLevel);
  }

  export declare class Handle_StepBasic_SecurityClassificationLevel_3 extends Handle_StepBasic_SecurityClassificationLevel {
    constructor(theHandle: Handle_StepBasic_SecurityClassificationLevel);
  }

  export declare class Handle_StepBasic_SecurityClassificationLevel_4 extends Handle_StepBasic_SecurityClassificationLevel {
    constructor(theHandle: Handle_StepBasic_SecurityClassificationLevel);
  }

export declare class StepBasic_SecurityClassificationLevel extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentType): void;
  get(): StepBasic_DocumentType;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentType_1 extends Handle_StepBasic_DocumentType {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentType_2 extends Handle_StepBasic_DocumentType {
    constructor(thePtr: StepBasic_DocumentType);
  }

  export declare class Handle_StepBasic_DocumentType_3 extends Handle_StepBasic_DocumentType {
    constructor(theHandle: Handle_StepBasic_DocumentType);
  }

  export declare class Handle_StepBasic_DocumentType_4 extends Handle_StepBasic_DocumentType {
    constructor(theHandle: Handle_StepBasic_DocumentType);
  }

export declare class StepBasic_DocumentType extends Standard_Transient {
  constructor()
  Init(apdt: Handle_TCollection_HAsciiString): void;
  ProductDataType(): Handle_TCollection_HAsciiString;
  SetProductDataType(apdt: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionReferenceWithLocalRepresentation): void;
  get(): StepBasic_ProductDefinitionReferenceWithLocalRepresentation;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_1 extends Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_2 extends Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation {
    constructor(thePtr: StepBasic_ProductDefinitionReferenceWithLocalRepresentation);
  }

  export declare class Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_3 extends Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation);
  }

  export declare class Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_4 extends Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation);
  }

export declare class StepBasic_ProductDefinitionReferenceWithLocalRepresentation extends StepBasic_ProductDefinition {
  constructor()
  Init(theSource: Handle_StepBasic_ExternalSource, theId: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theFormation: Handle_StepBasic_ProductDefinitionFormation, theFrameOfReference: Handle_StepBasic_ProductDefinitionContext): void;
  Source(): Handle_StepBasic_ExternalSource;
  SetSource(theSource: Handle_StepBasic_ExternalSource): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_WeekOfYearAndDayDate extends StepBasic_Date {
  constructor()
  Init(aYearComponent: Graphic3d_ZLayerId, aWeekComponent: Graphic3d_ZLayerId, hasAdayComponent: Standard_Boolean, aDayComponent: Graphic3d_ZLayerId): void;
  SetWeekComponent(aWeekComponent: Graphic3d_ZLayerId): void;
  WeekComponent(): Graphic3d_ZLayerId;
  SetDayComponent(aDayComponent: Graphic3d_ZLayerId): void;
  UnSetDayComponent(): void;
  DayComponent(): Graphic3d_ZLayerId;
  HasDayComponent(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_WeekOfYearAndDayDate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_WeekOfYearAndDayDate): void;
  get(): StepBasic_WeekOfYearAndDayDate;
  delete(): void;
}

  export declare class Handle_StepBasic_WeekOfYearAndDayDate_1 extends Handle_StepBasic_WeekOfYearAndDayDate {
    constructor();
  }

  export declare class Handle_StepBasic_WeekOfYearAndDayDate_2 extends Handle_StepBasic_WeekOfYearAndDayDate {
    constructor(thePtr: StepBasic_WeekOfYearAndDayDate);
  }

  export declare class Handle_StepBasic_WeekOfYearAndDayDate_3 extends Handle_StepBasic_WeekOfYearAndDayDate {
    constructor(theHandle: Handle_StepBasic_WeekOfYearAndDayDate);
  }

  export declare class Handle_StepBasic_WeekOfYearAndDayDate_4 extends Handle_StepBasic_WeekOfYearAndDayDate {
    constructor(theHandle: Handle_StepBasic_WeekOfYearAndDayDate);
  }

export declare class StepBasic_ActionRequestSolution extends Standard_Transient {
  constructor()
  Init(aMethod: Handle_StepBasic_ActionMethod, aRequest: Handle_StepBasic_VersionedActionRequest): void;
  Method(): Handle_StepBasic_ActionMethod;
  SetMethod(Method: Handle_StepBasic_ActionMethod): void;
  Request(): Handle_StepBasic_VersionedActionRequest;
  SetRequest(Request: Handle_StepBasic_VersionedActionRequest): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ActionRequestSolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ActionRequestSolution): void;
  get(): StepBasic_ActionRequestSolution;
  delete(): void;
}

  export declare class Handle_StepBasic_ActionRequestSolution_1 extends Handle_StepBasic_ActionRequestSolution {
    constructor();
  }

  export declare class Handle_StepBasic_ActionRequestSolution_2 extends Handle_StepBasic_ActionRequestSolution {
    constructor(thePtr: StepBasic_ActionRequestSolution);
  }

  export declare class Handle_StepBasic_ActionRequestSolution_3 extends Handle_StepBasic_ActionRequestSolution {
    constructor(theHandle: Handle_StepBasic_ActionRequestSolution);
  }

  export declare class Handle_StepBasic_ActionRequestSolution_4 extends Handle_StepBasic_ActionRequestSolution {
    constructor(theHandle: Handle_StepBasic_ActionRequestSolution);
  }

export declare class Handle_StepBasic_Person {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Person): void;
  get(): StepBasic_Person;
  delete(): void;
}

  export declare class Handle_StepBasic_Person_1 extends Handle_StepBasic_Person {
    constructor();
  }

  export declare class Handle_StepBasic_Person_2 extends Handle_StepBasic_Person {
    constructor(thePtr: StepBasic_Person);
  }

  export declare class Handle_StepBasic_Person_3 extends Handle_StepBasic_Person {
    constructor(theHandle: Handle_StepBasic_Person);
  }

  export declare class Handle_StepBasic_Person_4 extends Handle_StepBasic_Person {
    constructor(theHandle: Handle_StepBasic_Person);
  }

export declare class StepBasic_Person extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, hasAlastName: Standard_Boolean, aLastName: Handle_TCollection_HAsciiString, hasAfirstName: Standard_Boolean, aFirstName: Handle_TCollection_HAsciiString, hasAmiddleNames: Standard_Boolean, aMiddleNames: Handle_Interface_HArray1OfHAsciiString, hasAprefixTitles: Standard_Boolean, aPrefixTitles: Handle_Interface_HArray1OfHAsciiString, hasAsuffixTitles: Standard_Boolean, aSuffixTitles: Handle_Interface_HArray1OfHAsciiString): void;
  SetId(aId: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetLastName(aLastName: Handle_TCollection_HAsciiString): void;
  UnSetLastName(): void;
  LastName(): Handle_TCollection_HAsciiString;
  HasLastName(): Standard_Boolean;
  SetFirstName(aFirstName: Handle_TCollection_HAsciiString): void;
  UnSetFirstName(): void;
  FirstName(): Handle_TCollection_HAsciiString;
  HasFirstName(): Standard_Boolean;
  SetMiddleNames(aMiddleNames: Handle_Interface_HArray1OfHAsciiString): void;
  UnSetMiddleNames(): void;
  MiddleNames(): Handle_Interface_HArray1OfHAsciiString;
  HasMiddleNames(): Standard_Boolean;
  MiddleNamesValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbMiddleNames(): Graphic3d_ZLayerId;
  SetPrefixTitles(aPrefixTitles: Handle_Interface_HArray1OfHAsciiString): void;
  UnSetPrefixTitles(): void;
  PrefixTitles(): Handle_Interface_HArray1OfHAsciiString;
  HasPrefixTitles(): Standard_Boolean;
  PrefixTitlesValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbPrefixTitles(): Graphic3d_ZLayerId;
  SetSuffixTitles(aSuffixTitles: Handle_Interface_HArray1OfHAsciiString): void;
  UnSetSuffixTitles(): void;
  SuffixTitles(): Handle_Interface_HArray1OfHAsciiString;
  HasSuffixTitles(): Standard_Boolean;
  SuffixTitlesValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbSuffixTitles(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfUncertaintyMeasureWithUnit): void;
  get(): StepBasic_HArray1OfUncertaintyMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_1 extends Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_2 extends Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit {
    constructor(thePtr: StepBasic_HArray1OfUncertaintyMeasureWithUnit);
  }

  export declare class Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_3 extends Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit);
  }

  export declare class Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_4 extends Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit);
  }

export declare class Handle_StepBasic_IdentificationRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_IdentificationRole): void;
  get(): StepBasic_IdentificationRole;
  delete(): void;
}

  export declare class Handle_StepBasic_IdentificationRole_1 extends Handle_StepBasic_IdentificationRole {
    constructor();
  }

  export declare class Handle_StepBasic_IdentificationRole_2 extends Handle_StepBasic_IdentificationRole {
    constructor(thePtr: StepBasic_IdentificationRole);
  }

  export declare class Handle_StepBasic_IdentificationRole_3 extends Handle_StepBasic_IdentificationRole {
    constructor(theHandle: Handle_StepBasic_IdentificationRole);
  }

  export declare class Handle_StepBasic_IdentificationRole_4 extends Handle_StepBasic_IdentificationRole {
    constructor(theHandle: Handle_StepBasic_IdentificationRole);
  }

export declare class StepBasic_IdentificationRole extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ProductCategoryRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aCategory: Handle_StepBasic_ProductCategory, aSubCategory: Handle_StepBasic_ProductCategory): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  Category(): Handle_StepBasic_ProductCategory;
  SetCategory(Category: Handle_StepBasic_ProductCategory): void;
  SubCategory(): Handle_StepBasic_ProductCategory;
  SetSubCategory(SubCategory: Handle_StepBasic_ProductCategory): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductCategoryRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductCategoryRelationship): void;
  get(): StepBasic_ProductCategoryRelationship;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductCategoryRelationship_1 extends Handle_StepBasic_ProductCategoryRelationship {
    constructor();
  }

  export declare class Handle_StepBasic_ProductCategoryRelationship_2 extends Handle_StepBasic_ProductCategoryRelationship {
    constructor(thePtr: StepBasic_ProductCategoryRelationship);
  }

  export declare class Handle_StepBasic_ProductCategoryRelationship_3 extends Handle_StepBasic_ProductCategoryRelationship {
    constructor(theHandle: Handle_StepBasic_ProductCategoryRelationship);
  }

  export declare class Handle_StepBasic_ProductCategoryRelationship_4 extends Handle_StepBasic_ProductCategoryRelationship {
    constructor(theHandle: Handle_StepBasic_ProductCategoryRelationship);
  }

export declare class Handle_StepBasic_ConversionBasedUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnit): void;
  get(): StepBasic_ConversionBasedUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnit_1 extends Handle_StepBasic_ConversionBasedUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnit_2 extends Handle_StepBasic_ConversionBasedUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnit_3 extends Handle_StepBasic_ConversionBasedUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnit_4 extends Handle_StepBasic_ConversionBasedUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnit);
  }

export declare class StepBasic_ConversionBasedUnit extends StepBasic_NamedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetConversionFactor(aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  ConversionFactor(): Handle_StepBasic_MeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ApprovalAssignment extends Standard_Transient {
  constructor();
  Init(aAssignedApproval: Handle_StepBasic_Approval): void;
  SetAssignedApproval(aAssignedApproval: Handle_StepBasic_Approval): void;
  AssignedApproval(): Handle_StepBasic_Approval;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ApprovalAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApprovalAssignment): void;
  get(): StepBasic_ApprovalAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_ApprovalAssignment_1 extends Handle_StepBasic_ApprovalAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_ApprovalAssignment_2 extends Handle_StepBasic_ApprovalAssignment {
    constructor(thePtr: StepBasic_ApprovalAssignment);
  }

  export declare class Handle_StepBasic_ApprovalAssignment_3 extends Handle_StepBasic_ApprovalAssignment {
    constructor(theHandle: Handle_StepBasic_ApprovalAssignment);
  }

  export declare class Handle_StepBasic_ApprovalAssignment_4 extends Handle_StepBasic_ApprovalAssignment {
    constructor(theHandle: Handle_StepBasic_ApprovalAssignment);
  }

export declare class Handle_StepBasic_HArray1OfNamedUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfNamedUnit): void;
  get(): StepBasic_HArray1OfNamedUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfNamedUnit_1 extends Handle_StepBasic_HArray1OfNamedUnit {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfNamedUnit_2 extends Handle_StepBasic_HArray1OfNamedUnit {
    constructor(thePtr: StepBasic_HArray1OfNamedUnit);
  }

  export declare class Handle_StepBasic_HArray1OfNamedUnit_3 extends Handle_StepBasic_HArray1OfNamedUnit {
    constructor(theHandle: Handle_StepBasic_HArray1OfNamedUnit);
  }

  export declare class Handle_StepBasic_HArray1OfNamedUnit_4 extends Handle_StepBasic_HArray1OfNamedUnit {
    constructor(theHandle: Handle_StepBasic_HArray1OfNamedUnit);
  }

export declare class Handle_StepBasic_HArray1OfProductDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfProductDefinition): void;
  get(): StepBasic_HArray1OfProductDefinition;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfProductDefinition_1 extends Handle_StepBasic_HArray1OfProductDefinition {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfProductDefinition_2 extends Handle_StepBasic_HArray1OfProductDefinition {
    constructor(thePtr: StepBasic_HArray1OfProductDefinition);
  }

  export declare class Handle_StepBasic_HArray1OfProductDefinition_3 extends Handle_StepBasic_HArray1OfProductDefinition {
    constructor(theHandle: Handle_StepBasic_HArray1OfProductDefinition);
  }

  export declare class Handle_StepBasic_HArray1OfProductDefinition_4 extends Handle_StepBasic_HArray1OfProductDefinition {
    constructor(theHandle: Handle_StepBasic_HArray1OfProductDefinition);
  }

export declare class Handle_StepBasic_ProductType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductType): void;
  get(): StepBasic_ProductType;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductType_1 extends Handle_StepBasic_ProductType {
    constructor();
  }

  export declare class Handle_StepBasic_ProductType_2 extends Handle_StepBasic_ProductType {
    constructor(thePtr: StepBasic_ProductType);
  }

  export declare class Handle_StepBasic_ProductType_3 extends Handle_StepBasic_ProductType {
    constructor(theHandle: Handle_StepBasic_ProductType);
  }

  export declare class Handle_StepBasic_ProductType_4 extends Handle_StepBasic_ProductType {
    constructor(theHandle: Handle_StepBasic_ProductType);
  }

export declare class StepBasic_ProductType extends StepBasic_ProductRelatedProductCategory {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_SiUnit extends StepBasic_NamedUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetPrefix(aPrefix: StepBasic_SiPrefix): void;
  UnSetPrefix(): void;
  Prefix(): StepBasic_SiPrefix;
  HasPrefix(): Standard_Boolean;
  SetName(aName: StepBasic_SiUnitName): void;
  Name(): StepBasic_SiUnitName;
  SetDimensions(aDimensions: Handle_StepBasic_DimensionalExponents): void;
  Dimensions(): Handle_StepBasic_DimensionalExponents;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnit): void;
  get(): StepBasic_SiUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnit_1 extends Handle_StepBasic_SiUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnit_2 extends Handle_StepBasic_SiUnit {
    constructor(thePtr: StepBasic_SiUnit);
  }

  export declare class Handle_StepBasic_SiUnit_3 extends Handle_StepBasic_SiUnit {
    constructor(theHandle: Handle_StepBasic_SiUnit);
  }

  export declare class Handle_StepBasic_SiUnit_4 extends Handle_StepBasic_SiUnit {
    constructor(theHandle: Handle_StepBasic_SiUnit);
  }

export declare class StepBasic_SiUnitAndSolidAngleUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetSolidAngleUnit(aSolidAngleUnit: Handle_StepBasic_SolidAngleUnit): void;
  SolidAngleUnit(): Handle_StepBasic_SolidAngleUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndSolidAngleUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndSolidAngleUnit): void;
  get(): StepBasic_SiUnitAndSolidAngleUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndSolidAngleUnit_1 extends Handle_StepBasic_SiUnitAndSolidAngleUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndSolidAngleUnit_2 extends Handle_StepBasic_SiUnitAndSolidAngleUnit {
    constructor(thePtr: StepBasic_SiUnitAndSolidAngleUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndSolidAngleUnit_3 extends Handle_StepBasic_SiUnitAndSolidAngleUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndSolidAngleUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndSolidAngleUnit_4 extends Handle_StepBasic_SiUnitAndSolidAngleUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndSolidAngleUnit);
  }

export declare class StepBasic_Date extends Standard_Transient {
  constructor()
  Init(aYearComponent: Graphic3d_ZLayerId): void;
  SetYearComponent(aYearComponent: Graphic3d_ZLayerId): void;
  YearComponent(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Date {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Date): void;
  get(): StepBasic_Date;
  delete(): void;
}

  export declare class Handle_StepBasic_Date_1 extends Handle_StepBasic_Date {
    constructor();
  }

  export declare class Handle_StepBasic_Date_2 extends Handle_StepBasic_Date {
    constructor(thePtr: StepBasic_Date);
  }

  export declare class Handle_StepBasic_Date_3 extends Handle_StepBasic_Date {
    constructor(theHandle: Handle_StepBasic_Date);
  }

  export declare class Handle_StepBasic_Date_4 extends Handle_StepBasic_Date {
    constructor(theHandle: Handle_StepBasic_Date);
  }

export declare class StepBasic_ConversionBasedUnitAndMassUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetMassUnit(aMassUnit: Handle_StepBasic_MassUnit): void;
  MassUnit(): Handle_StepBasic_MassUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndMassUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndMassUnit): void;
  get(): StepBasic_ConversionBasedUnitAndMassUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndMassUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndMassUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndMassUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndMassUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndMassUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndMassUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndMassUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndMassUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndMassUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndMassUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndMassUnit);
  }

export declare type StepBasic_SiUnitName = {
  StepBasic_sunMetre: {};
  StepBasic_sunGram: {};
  StepBasic_sunSecond: {};
  StepBasic_sunAmpere: {};
  StepBasic_sunKelvin: {};
  StepBasic_sunMole: {};
  StepBasic_sunCandela: {};
  StepBasic_sunRadian: {};
  StepBasic_sunSteradian: {};
  StepBasic_sunHertz: {};
  StepBasic_sunNewton: {};
  StepBasic_sunPascal: {};
  StepBasic_sunJoule: {};
  StepBasic_sunWatt: {};
  StepBasic_sunCoulomb: {};
  StepBasic_sunVolt: {};
  StepBasic_sunFarad: {};
  StepBasic_sunOhm: {};
  StepBasic_sunSiemens: {};
  StepBasic_sunWeber: {};
  StepBasic_sunTesla: {};
  StepBasic_sunHenry: {};
  StepBasic_sunDegreeCelsius: {};
  StepBasic_sunLumen: {};
  StepBasic_sunLux: {};
  StepBasic_sunBecquerel: {};
  StepBasic_sunGray: {};
  StepBasic_sunSievert: {};
}

export declare class StepBasic_SolidAngleMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SolidAngleMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SolidAngleMeasureWithUnit): void;
  get(): StepBasic_SolidAngleMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SolidAngleMeasureWithUnit_1 extends Handle_StepBasic_SolidAngleMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SolidAngleMeasureWithUnit_2 extends Handle_StepBasic_SolidAngleMeasureWithUnit {
    constructor(thePtr: StepBasic_SolidAngleMeasureWithUnit);
  }

  export declare class Handle_StepBasic_SolidAngleMeasureWithUnit_3 extends Handle_StepBasic_SolidAngleMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_SolidAngleMeasureWithUnit);
  }

  export declare class Handle_StepBasic_SolidAngleMeasureWithUnit_4 extends Handle_StepBasic_SolidAngleMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_SolidAngleMeasureWithUnit);
  }

export declare class Handle_StepBasic_OrdinalDate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_OrdinalDate): void;
  get(): StepBasic_OrdinalDate;
  delete(): void;
}

  export declare class Handle_StepBasic_OrdinalDate_1 extends Handle_StepBasic_OrdinalDate {
    constructor();
  }

  export declare class Handle_StepBasic_OrdinalDate_2 extends Handle_StepBasic_OrdinalDate {
    constructor(thePtr: StepBasic_OrdinalDate);
  }

  export declare class Handle_StepBasic_OrdinalDate_3 extends Handle_StepBasic_OrdinalDate {
    constructor(theHandle: Handle_StepBasic_OrdinalDate);
  }

  export declare class Handle_StepBasic_OrdinalDate_4 extends Handle_StepBasic_OrdinalDate {
    constructor(theHandle: Handle_StepBasic_OrdinalDate);
  }

export declare class StepBasic_OrdinalDate extends StepBasic_Date {
  constructor()
  Init(aYearComponent: Graphic3d_ZLayerId, aDayComponent: Graphic3d_ZLayerId): void;
  SetDayComponent(aDayComponent: Graphic3d_ZLayerId): void;
  DayComponent(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndTimeUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndTimeUnit): void;
  get(): StepBasic_SiUnitAndTimeUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndTimeUnit_1 extends Handle_StepBasic_SiUnitAndTimeUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndTimeUnit_2 extends Handle_StepBasic_SiUnitAndTimeUnit {
    constructor(thePtr: StepBasic_SiUnitAndTimeUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndTimeUnit_3 extends Handle_StepBasic_SiUnitAndTimeUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndTimeUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndTimeUnit_4 extends Handle_StepBasic_SiUnitAndTimeUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndTimeUnit);
  }

export declare class StepBasic_SiUnitAndTimeUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetTimeUnit(aTimeUnit: Handle_StepBasic_TimeUnit): void;
  TimeUnit(): Handle_StepBasic_TimeUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_MassUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_MassUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_MassUnit): void;
  get(): StepBasic_MassUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_MassUnit_1 extends Handle_StepBasic_MassUnit {
    constructor();
  }

  export declare class Handle_StepBasic_MassUnit_2 extends Handle_StepBasic_MassUnit {
    constructor(thePtr: StepBasic_MassUnit);
  }

  export declare class Handle_StepBasic_MassUnit_3 extends Handle_StepBasic_MassUnit {
    constructor(theHandle: Handle_StepBasic_MassUnit);
  }

  export declare class Handle_StepBasic_MassUnit_4 extends Handle_StepBasic_MassUnit {
    constructor(theHandle: Handle_StepBasic_MassUnit);
  }

export declare class Handle_StepBasic_DateAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DateAssignment): void;
  get(): StepBasic_DateAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_DateAssignment_1 extends Handle_StepBasic_DateAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_DateAssignment_2 extends Handle_StepBasic_DateAssignment {
    constructor(thePtr: StepBasic_DateAssignment);
  }

  export declare class Handle_StepBasic_DateAssignment_3 extends Handle_StepBasic_DateAssignment {
    constructor(theHandle: Handle_StepBasic_DateAssignment);
  }

  export declare class Handle_StepBasic_DateAssignment_4 extends Handle_StepBasic_DateAssignment {
    constructor(theHandle: Handle_StepBasic_DateAssignment);
  }

export declare class StepBasic_DateAssignment extends Standard_Transient {
  constructor();
  Init(aAssignedDate: Handle_StepBasic_Date, aRole: Handle_StepBasic_DateRole): void;
  SetAssignedDate(aAssignedDate: Handle_StepBasic_Date): void;
  AssignedDate(): Handle_StepBasic_Date;
  SetRole(aRole: Handle_StepBasic_DateRole): void;
  Role(): Handle_StepBasic_DateRole;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductConceptContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductConceptContext): void;
  get(): StepBasic_ProductConceptContext;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductConceptContext_1 extends Handle_StepBasic_ProductConceptContext {
    constructor();
  }

  export declare class Handle_StepBasic_ProductConceptContext_2 extends Handle_StepBasic_ProductConceptContext {
    constructor(thePtr: StepBasic_ProductConceptContext);
  }

  export declare class Handle_StepBasic_ProductConceptContext_3 extends Handle_StepBasic_ProductConceptContext {
    constructor(theHandle: Handle_StepBasic_ProductConceptContext);
  }

  export declare class Handle_StepBasic_ProductConceptContext_4 extends Handle_StepBasic_ProductConceptContext {
    constructor(theHandle: Handle_StepBasic_ProductConceptContext);
  }

export declare class StepBasic_ProductConceptContext extends StepBasic_ApplicationContextElement {
  constructor()
  Init(aApplicationContextElement_Name: Handle_TCollection_HAsciiString, aApplicationContextElement_FrameOfReference: Handle_StepBasic_ApplicationContext, aMarketSegmentType: Handle_TCollection_HAsciiString): void;
  MarketSegmentType(): Handle_TCollection_HAsciiString;
  SetMarketSegmentType(MarketSegmentType: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ApprovalRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aRelatingApproval: Handle_StepBasic_Approval, aRelatedApproval: Handle_StepBasic_Approval): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetRelatingApproval(aRelatingApproval: Handle_StepBasic_Approval): void;
  RelatingApproval(): Handle_StepBasic_Approval;
  SetRelatedApproval(aRelatedApproval: Handle_StepBasic_Approval): void;
  RelatedApproval(): Handle_StepBasic_Approval;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ApprovalRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApprovalRelationship): void;
  get(): StepBasic_ApprovalRelationship;
  delete(): void;
}

  export declare class Handle_StepBasic_ApprovalRelationship_1 extends Handle_StepBasic_ApprovalRelationship {
    constructor();
  }

  export declare class Handle_StepBasic_ApprovalRelationship_2 extends Handle_StepBasic_ApprovalRelationship {
    constructor(thePtr: StepBasic_ApprovalRelationship);
  }

  export declare class Handle_StepBasic_ApprovalRelationship_3 extends Handle_StepBasic_ApprovalRelationship {
    constructor(theHandle: Handle_StepBasic_ApprovalRelationship);
  }

  export declare class Handle_StepBasic_ApprovalRelationship_4 extends Handle_StepBasic_ApprovalRelationship {
    constructor(theHandle: Handle_StepBasic_ApprovalRelationship);
  }

export declare class Handle_StepBasic_ConversionBasedUnitAndLengthUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndLengthUnit): void;
  get(): StepBasic_ConversionBasedUnitAndLengthUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndLengthUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndLengthUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndLengthUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndLengthUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndLengthUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndLengthUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndLengthUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndLengthUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndLengthUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndLengthUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndLengthUnit);
  }

export declare class StepBasic_ConversionBasedUnitAndLengthUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetLengthUnit(aLengthUnit: Handle_StepBasic_LengthUnit): void;
  LengthUnit(): Handle_StepBasic_LengthUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ObjectRole extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ObjectRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ObjectRole): void;
  get(): StepBasic_ObjectRole;
  delete(): void;
}

  export declare class Handle_StepBasic_ObjectRole_1 extends Handle_StepBasic_ObjectRole {
    constructor();
  }

  export declare class Handle_StepBasic_ObjectRole_2 extends Handle_StepBasic_ObjectRole {
    constructor(thePtr: StepBasic_ObjectRole);
  }

  export declare class Handle_StepBasic_ObjectRole_3 extends Handle_StepBasic_ObjectRole {
    constructor(theHandle: Handle_StepBasic_ObjectRole);
  }

  export declare class Handle_StepBasic_ObjectRole_4 extends Handle_StepBasic_ObjectRole {
    constructor(theHandle: Handle_StepBasic_ObjectRole);
  }

export declare class StepBasic_PersonOrganizationSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Person(): Handle_StepBasic_Person;
  Organization(): Handle_StepBasic_Organization;
  PersonAndOrganization(): Handle_StepBasic_PersonAndOrganization;
  delete(): void;
}

export declare class StepBasic_DocumentProductEquivalence extends StepBasic_DocumentProductAssociation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentProductEquivalence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentProductEquivalence): void;
  get(): StepBasic_DocumentProductEquivalence;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentProductEquivalence_1 extends Handle_StepBasic_DocumentProductEquivalence {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentProductEquivalence_2 extends Handle_StepBasic_DocumentProductEquivalence {
    constructor(thePtr: StepBasic_DocumentProductEquivalence);
  }

  export declare class Handle_StepBasic_DocumentProductEquivalence_3 extends Handle_StepBasic_DocumentProductEquivalence {
    constructor(theHandle: Handle_StepBasic_DocumentProductEquivalence);
  }

  export declare class Handle_StepBasic_DocumentProductEquivalence_4 extends Handle_StepBasic_DocumentProductEquivalence {
    constructor(theHandle: Handle_StepBasic_DocumentProductEquivalence);
  }

export declare class Handle_StepBasic_ApprovalDateTime {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApprovalDateTime): void;
  get(): StepBasic_ApprovalDateTime;
  delete(): void;
}

  export declare class Handle_StepBasic_ApprovalDateTime_1 extends Handle_StepBasic_ApprovalDateTime {
    constructor();
  }

  export declare class Handle_StepBasic_ApprovalDateTime_2 extends Handle_StepBasic_ApprovalDateTime {
    constructor(thePtr: StepBasic_ApprovalDateTime);
  }

  export declare class Handle_StepBasic_ApprovalDateTime_3 extends Handle_StepBasic_ApprovalDateTime {
    constructor(theHandle: Handle_StepBasic_ApprovalDateTime);
  }

  export declare class Handle_StepBasic_ApprovalDateTime_4 extends Handle_StepBasic_ApprovalDateTime {
    constructor(theHandle: Handle_StepBasic_ApprovalDateTime);
  }

export declare class StepBasic_ApprovalDateTime extends Standard_Transient {
  constructor()
  Init(aDateTime: StepBasic_DateTimeSelect, aDatedApproval: Handle_StepBasic_Approval): void;
  SetDateTime(aDateTime: StepBasic_DateTimeSelect): void;
  DateTime(): StepBasic_DateTimeSelect;
  SetDatedApproval(aDatedApproval: Handle_StepBasic_Approval): void;
  DatedApproval(): Handle_StepBasic_Approval;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentRelationship): void;
  get(): StepBasic_DocumentRelationship;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentRelationship_1 extends Handle_StepBasic_DocumentRelationship {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentRelationship_2 extends Handle_StepBasic_DocumentRelationship {
    constructor(thePtr: StepBasic_DocumentRelationship);
  }

  export declare class Handle_StepBasic_DocumentRelationship_3 extends Handle_StepBasic_DocumentRelationship {
    constructor(theHandle: Handle_StepBasic_DocumentRelationship);
  }

  export declare class Handle_StepBasic_DocumentRelationship_4 extends Handle_StepBasic_DocumentRelationship {
    constructor(theHandle: Handle_StepBasic_DocumentRelationship);
  }

export declare class StepBasic_DocumentRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aRelating: Handle_StepBasic_Document, aRelated: Handle_StepBasic_Document): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  RelatingDocument(): Handle_StepBasic_Document;
  SetRelatingDocument(aRelating: Handle_StepBasic_Document): void;
  RelatedDocument(): Handle_StepBasic_Document;
  SetRelatedDocument(aRelated: Handle_StepBasic_Document): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ConversionBasedUnitAndAreaUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  SetAreaUnit(anAreaUnit: Handle_StepBasic_AreaUnit): void;
  AreaUnit(): Handle_StepBasic_AreaUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndAreaUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndAreaUnit): void;
  get(): StepBasic_ConversionBasedUnitAndAreaUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndAreaUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndAreaUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndAreaUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndAreaUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndAreaUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndAreaUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndAreaUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndAreaUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndAreaUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndAreaUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndAreaUnit);
  }

export declare class Handle_StepBasic_HArray1OfOrganization {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_HArray1OfOrganization): void;
  get(): StepBasic_HArray1OfOrganization;
  delete(): void;
}

  export declare class Handle_StepBasic_HArray1OfOrganization_1 extends Handle_StepBasic_HArray1OfOrganization {
    constructor();
  }

  export declare class Handle_StepBasic_HArray1OfOrganization_2 extends Handle_StepBasic_HArray1OfOrganization {
    constructor(thePtr: StepBasic_HArray1OfOrganization);
  }

  export declare class Handle_StepBasic_HArray1OfOrganization_3 extends Handle_StepBasic_HArray1OfOrganization {
    constructor(theHandle: Handle_StepBasic_HArray1OfOrganization);
  }

  export declare class Handle_StepBasic_HArray1OfOrganization_4 extends Handle_StepBasic_HArray1OfOrganization {
    constructor(theHandle: Handle_StepBasic_HArray1OfOrganization);
  }

export declare class StepBasic_ProductRelatedProductCategory extends StepBasic_ProductCategory {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasAdescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aProducts: Handle_StepBasic_HArray1OfProduct): void;
  SetProducts(aProducts: Handle_StepBasic_HArray1OfProduct): void;
  Products(): Handle_StepBasic_HArray1OfProduct;
  ProductsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_Product;
  NbProducts(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductRelatedProductCategory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductRelatedProductCategory): void;
  get(): StepBasic_ProductRelatedProductCategory;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductRelatedProductCategory_1 extends Handle_StepBasic_ProductRelatedProductCategory {
    constructor();
  }

  export declare class Handle_StepBasic_ProductRelatedProductCategory_2 extends Handle_StepBasic_ProductRelatedProductCategory {
    constructor(thePtr: StepBasic_ProductRelatedProductCategory);
  }

  export declare class Handle_StepBasic_ProductRelatedProductCategory_3 extends Handle_StepBasic_ProductRelatedProductCategory {
    constructor(theHandle: Handle_StepBasic_ProductRelatedProductCategory);
  }

  export declare class Handle_StepBasic_ProductRelatedProductCategory_4 extends Handle_StepBasic_ProductRelatedProductCategory {
    constructor(theHandle: Handle_StepBasic_ProductRelatedProductCategory);
  }

export declare class StepBasic_Action extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aChosenMethod: Handle_StepBasic_ActionMethod): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  ChosenMethod(): Handle_StepBasic_ActionMethod;
  SetChosenMethod(ChosenMethod: Handle_StepBasic_ActionMethod): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Action {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Action): void;
  get(): StepBasic_Action;
  delete(): void;
}

  export declare class Handle_StepBasic_Action_1 extends Handle_StepBasic_Action {
    constructor();
  }

  export declare class Handle_StepBasic_Action_2 extends Handle_StepBasic_Action {
    constructor(thePtr: StepBasic_Action);
  }

  export declare class Handle_StepBasic_Action_3 extends Handle_StepBasic_Action {
    constructor(theHandle: Handle_StepBasic_Action);
  }

  export declare class Handle_StepBasic_Action_4 extends Handle_StepBasic_Action {
    constructor(theHandle: Handle_StepBasic_Action);
  }

export declare class Handle_StepBasic_Group {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Group): void;
  get(): StepBasic_Group;
  delete(): void;
}

  export declare class Handle_StepBasic_Group_1 extends Handle_StepBasic_Group {
    constructor();
  }

  export declare class Handle_StepBasic_Group_2 extends Handle_StepBasic_Group {
    constructor(thePtr: StepBasic_Group);
  }

  export declare class Handle_StepBasic_Group_3 extends Handle_StepBasic_Group {
    constructor(theHandle: Handle_StepBasic_Group);
  }

  export declare class Handle_StepBasic_Group_4 extends Handle_StepBasic_Group {
    constructor(theHandle: Handle_StepBasic_Group);
  }

export declare class StepBasic_Group extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_LengthMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_LengthMeasureWithUnit): void;
  get(): StepBasic_LengthMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_LengthMeasureWithUnit_1 extends Handle_StepBasic_LengthMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_LengthMeasureWithUnit_2 extends Handle_StepBasic_LengthMeasureWithUnit {
    constructor(thePtr: StepBasic_LengthMeasureWithUnit);
  }

  export declare class Handle_StepBasic_LengthMeasureWithUnit_3 extends Handle_StepBasic_LengthMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_LengthMeasureWithUnit);
  }

  export declare class Handle_StepBasic_LengthMeasureWithUnit_4 extends Handle_StepBasic_LengthMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_LengthMeasureWithUnit);
  }

export declare class StepBasic_LengthMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_SizeSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  SetRealValue(aReal: Quantity_AbsorbedDose): void;
  RealValue(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionEffectivity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionEffectivity): void;
  get(): StepBasic_ProductDefinitionEffectivity;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionEffectivity_1 extends Handle_StepBasic_ProductDefinitionEffectivity {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionEffectivity_2 extends Handle_StepBasic_ProductDefinitionEffectivity {
    constructor(thePtr: StepBasic_ProductDefinitionEffectivity);
  }

  export declare class Handle_StepBasic_ProductDefinitionEffectivity_3 extends Handle_StepBasic_ProductDefinitionEffectivity {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionEffectivity);
  }

  export declare class Handle_StepBasic_ProductDefinitionEffectivity_4 extends Handle_StepBasic_ProductDefinitionEffectivity {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionEffectivity);
  }

export declare class StepBasic_ProductDefinitionEffectivity extends StepBasic_Effectivity {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aUsage: Handle_StepBasic_ProductDefinitionRelationship): void;
  Usage(): Handle_StepBasic_ProductDefinitionRelationship;
  SetUsage(aUsage: Handle_StepBasic_ProductDefinitionRelationship): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Address {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Address): void;
  get(): StepBasic_Address;
  delete(): void;
}

  export declare class Handle_StepBasic_Address_1 extends Handle_StepBasic_Address {
    constructor();
  }

  export declare class Handle_StepBasic_Address_2 extends Handle_StepBasic_Address {
    constructor(thePtr: StepBasic_Address);
  }

  export declare class Handle_StepBasic_Address_3 extends Handle_StepBasic_Address {
    constructor(theHandle: Handle_StepBasic_Address);
  }

  export declare class Handle_StepBasic_Address_4 extends Handle_StepBasic_Address {
    constructor(theHandle: Handle_StepBasic_Address);
  }

export declare class StepBasic_Address extends Standard_Transient {
  constructor()
  Init(hasAinternalLocation: Standard_Boolean, aInternalLocation: Handle_TCollection_HAsciiString, hasAstreetNumber: Standard_Boolean, aStreetNumber: Handle_TCollection_HAsciiString, hasAstreet: Standard_Boolean, aStreet: Handle_TCollection_HAsciiString, hasApostalBox: Standard_Boolean, aPostalBox: Handle_TCollection_HAsciiString, hasAtown: Standard_Boolean, aTown: Handle_TCollection_HAsciiString, hasAregion: Standard_Boolean, aRegion: Handle_TCollection_HAsciiString, hasApostalCode: Standard_Boolean, aPostalCode: Handle_TCollection_HAsciiString, hasAcountry: Standard_Boolean, aCountry: Handle_TCollection_HAsciiString, hasAfacsimileNumber: Standard_Boolean, aFacsimileNumber: Handle_TCollection_HAsciiString, hasAtelephoneNumber: Standard_Boolean, aTelephoneNumber: Handle_TCollection_HAsciiString, hasAelectronicMailAddress: Standard_Boolean, aElectronicMailAddress: Handle_TCollection_HAsciiString, hasAtelexNumber: Standard_Boolean, aTelexNumber: Handle_TCollection_HAsciiString): void;
  SetInternalLocation(aInternalLocation: Handle_TCollection_HAsciiString): void;
  UnSetInternalLocation(): void;
  InternalLocation(): Handle_TCollection_HAsciiString;
  HasInternalLocation(): Standard_Boolean;
  SetStreetNumber(aStreetNumber: Handle_TCollection_HAsciiString): void;
  UnSetStreetNumber(): void;
  StreetNumber(): Handle_TCollection_HAsciiString;
  HasStreetNumber(): Standard_Boolean;
  SetStreet(aStreet: Handle_TCollection_HAsciiString): void;
  UnSetStreet(): void;
  Street(): Handle_TCollection_HAsciiString;
  HasStreet(): Standard_Boolean;
  SetPostalBox(aPostalBox: Handle_TCollection_HAsciiString): void;
  UnSetPostalBox(): void;
  PostalBox(): Handle_TCollection_HAsciiString;
  HasPostalBox(): Standard_Boolean;
  SetTown(aTown: Handle_TCollection_HAsciiString): void;
  UnSetTown(): void;
  Town(): Handle_TCollection_HAsciiString;
  HasTown(): Standard_Boolean;
  SetRegion(aRegion: Handle_TCollection_HAsciiString): void;
  UnSetRegion(): void;
  Region(): Handle_TCollection_HAsciiString;
  HasRegion(): Standard_Boolean;
  SetPostalCode(aPostalCode: Handle_TCollection_HAsciiString): void;
  UnSetPostalCode(): void;
  PostalCode(): Handle_TCollection_HAsciiString;
  HasPostalCode(): Standard_Boolean;
  SetCountry(aCountry: Handle_TCollection_HAsciiString): void;
  UnSetCountry(): void;
  Country(): Handle_TCollection_HAsciiString;
  HasCountry(): Standard_Boolean;
  SetFacsimileNumber(aFacsimileNumber: Handle_TCollection_HAsciiString): void;
  UnSetFacsimileNumber(): void;
  FacsimileNumber(): Handle_TCollection_HAsciiString;
  HasFacsimileNumber(): Standard_Boolean;
  SetTelephoneNumber(aTelephoneNumber: Handle_TCollection_HAsciiString): void;
  UnSetTelephoneNumber(): void;
  TelephoneNumber(): Handle_TCollection_HAsciiString;
  HasTelephoneNumber(): Standard_Boolean;
  SetElectronicMailAddress(aElectronicMailAddress: Handle_TCollection_HAsciiString): void;
  UnSetElectronicMailAddress(): void;
  ElectronicMailAddress(): Handle_TCollection_HAsciiString;
  HasElectronicMailAddress(): Standard_Boolean;
  SetTelexNumber(aTelexNumber: Handle_TCollection_HAsciiString): void;
  UnSetTelexNumber(): void;
  TelexNumber(): Handle_TCollection_HAsciiString;
  HasTelexNumber(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentReference): void;
  get(): StepBasic_DocumentReference;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentReference_1 extends Handle_StepBasic_DocumentReference {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentReference_2 extends Handle_StepBasic_DocumentReference {
    constructor(thePtr: StepBasic_DocumentReference);
  }

  export declare class Handle_StepBasic_DocumentReference_3 extends Handle_StepBasic_DocumentReference {
    constructor(theHandle: Handle_StepBasic_DocumentReference);
  }

  export declare class Handle_StepBasic_DocumentReference_4 extends Handle_StepBasic_DocumentReference {
    constructor(theHandle: Handle_StepBasic_DocumentReference);
  }

export declare class StepBasic_DocumentReference extends Standard_Transient {
  constructor();
  Init0(aAssignedDocument: Handle_StepBasic_Document, aSource: Handle_TCollection_HAsciiString): void;
  AssignedDocument(): Handle_StepBasic_Document;
  SetAssignedDocument(aAssignedDocument: Handle_StepBasic_Document): void;
  Source(): Handle_TCollection_HAsciiString;
  SetSource(aSource: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_PersonalAddress extends StepBasic_Address {
  constructor()
  Init(hasAinternalLocation: Standard_Boolean, aInternalLocation: Handle_TCollection_HAsciiString, hasAstreetNumber: Standard_Boolean, aStreetNumber: Handle_TCollection_HAsciiString, hasAstreet: Standard_Boolean, aStreet: Handle_TCollection_HAsciiString, hasApostalBox: Standard_Boolean, aPostalBox: Handle_TCollection_HAsciiString, hasAtown: Standard_Boolean, aTown: Handle_TCollection_HAsciiString, hasAregion: Standard_Boolean, aRegion: Handle_TCollection_HAsciiString, hasApostalCode: Standard_Boolean, aPostalCode: Handle_TCollection_HAsciiString, hasAcountry: Standard_Boolean, aCountry: Handle_TCollection_HAsciiString, hasAfacsimileNumber: Standard_Boolean, aFacsimileNumber: Handle_TCollection_HAsciiString, hasAtelephoneNumber: Standard_Boolean, aTelephoneNumber: Handle_TCollection_HAsciiString, hasAelectronicMailAddress: Standard_Boolean, aElectronicMailAddress: Handle_TCollection_HAsciiString, hasAtelexNumber: Standard_Boolean, aTelexNumber: Handle_TCollection_HAsciiString, aPeople: Handle_StepBasic_HArray1OfPerson, aDescription: Handle_TCollection_HAsciiString): void;
  SetPeople(aPeople: Handle_StepBasic_HArray1OfPerson): void;
  People(): Handle_StepBasic_HArray1OfPerson;
  PeopleValue(num: Graphic3d_ZLayerId): Handle_StepBasic_Person;
  NbPeople(): Graphic3d_ZLayerId;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_PersonalAddress {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PersonalAddress): void;
  get(): StepBasic_PersonalAddress;
  delete(): void;
}

  export declare class Handle_StepBasic_PersonalAddress_1 extends Handle_StepBasic_PersonalAddress {
    constructor();
  }

  export declare class Handle_StepBasic_PersonalAddress_2 extends Handle_StepBasic_PersonalAddress {
    constructor(thePtr: StepBasic_PersonalAddress);
  }

  export declare class Handle_StepBasic_PersonalAddress_3 extends Handle_StepBasic_PersonalAddress {
    constructor(theHandle: Handle_StepBasic_PersonalAddress);
  }

  export declare class Handle_StepBasic_PersonalAddress_4 extends Handle_StepBasic_PersonalAddress {
    constructor(theHandle: Handle_StepBasic_PersonalAddress);
  }

export declare class StepBasic_SiUnitAndThermodynamicTemperatureUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetThermodynamicTemperatureUnit(aThermodynamicTemperatureUnit: Handle_StepBasic_ThermodynamicTemperatureUnit): void;
  ThermodynamicTemperatureUnit(): Handle_StepBasic_ThermodynamicTemperatureUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndThermodynamicTemperatureUnit): void;
  get(): StepBasic_SiUnitAndThermodynamicTemperatureUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_1 extends Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_2 extends Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit {
    constructor(thePtr: StepBasic_SiUnitAndThermodynamicTemperatureUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_3 extends Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_4 extends Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit);
  }

export declare class StepBasic_OrganizationRole extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_OrganizationRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_OrganizationRole): void;
  get(): StepBasic_OrganizationRole;
  delete(): void;
}

  export declare class Handle_StepBasic_OrganizationRole_1 extends Handle_StepBasic_OrganizationRole {
    constructor();
  }

  export declare class Handle_StepBasic_OrganizationRole_2 extends Handle_StepBasic_OrganizationRole {
    constructor(thePtr: StepBasic_OrganizationRole);
  }

  export declare class Handle_StepBasic_OrganizationRole_3 extends Handle_StepBasic_OrganizationRole {
    constructor(theHandle: Handle_StepBasic_OrganizationRole);
  }

  export declare class Handle_StepBasic_OrganizationRole_4 extends Handle_StepBasic_OrganizationRole {
    constructor(theHandle: Handle_StepBasic_OrganizationRole);
  }

export declare class StepBasic_ProductDefinitionContext extends StepBasic_ApplicationContextElement {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aFrameOfReference: Handle_StepBasic_ApplicationContext, aLifeCycleStage: Handle_TCollection_HAsciiString): void;
  SetLifeCycleStage(aLifeCycleStage: Handle_TCollection_HAsciiString): void;
  LifeCycleStage(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionContext): void;
  get(): StepBasic_ProductDefinitionContext;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionContext_1 extends Handle_StepBasic_ProductDefinitionContext {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionContext_2 extends Handle_StepBasic_ProductDefinitionContext {
    constructor(thePtr: StepBasic_ProductDefinitionContext);
  }

  export declare class Handle_StepBasic_ProductDefinitionContext_3 extends Handle_StepBasic_ProductDefinitionContext {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionContext);
  }

  export declare class Handle_StepBasic_ProductDefinitionContext_4 extends Handle_StepBasic_ProductDefinitionContext {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionContext);
  }

export declare class StepBasic_VolumeUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_VolumeUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_VolumeUnit): void;
  get(): StepBasic_VolumeUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_VolumeUnit_1 extends Handle_StepBasic_VolumeUnit {
    constructor();
  }

  export declare class Handle_StepBasic_VolumeUnit_2 extends Handle_StepBasic_VolumeUnit {
    constructor(thePtr: StepBasic_VolumeUnit);
  }

  export declare class Handle_StepBasic_VolumeUnit_3 extends Handle_StepBasic_VolumeUnit {
    constructor(theHandle: Handle_StepBasic_VolumeUnit);
  }

  export declare class Handle_StepBasic_VolumeUnit_4 extends Handle_StepBasic_VolumeUnit {
    constructor(theHandle: Handle_StepBasic_VolumeUnit);
  }

export declare class Handle_StepBasic_DocumentRepresentationType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentRepresentationType): void;
  get(): StepBasic_DocumentRepresentationType;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentRepresentationType_1 extends Handle_StepBasic_DocumentRepresentationType {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentRepresentationType_2 extends Handle_StepBasic_DocumentRepresentationType {
    constructor(thePtr: StepBasic_DocumentRepresentationType);
  }

  export declare class Handle_StepBasic_DocumentRepresentationType_3 extends Handle_StepBasic_DocumentRepresentationType {
    constructor(theHandle: Handle_StepBasic_DocumentRepresentationType);
  }

  export declare class Handle_StepBasic_DocumentRepresentationType_4 extends Handle_StepBasic_DocumentRepresentationType {
    constructor(theHandle: Handle_StepBasic_DocumentRepresentationType);
  }

export declare class StepBasic_DocumentRepresentationType extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aRepresentedDocument: Handle_StepBasic_Document): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  RepresentedDocument(): Handle_StepBasic_Document;
  SetRepresentedDocument(RepresentedDocument: Handle_StepBasic_Document): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_LocalTime {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_LocalTime): void;
  get(): StepBasic_LocalTime;
  delete(): void;
}

  export declare class Handle_StepBasic_LocalTime_1 extends Handle_StepBasic_LocalTime {
    constructor();
  }

  export declare class Handle_StepBasic_LocalTime_2 extends Handle_StepBasic_LocalTime {
    constructor(thePtr: StepBasic_LocalTime);
  }

  export declare class Handle_StepBasic_LocalTime_3 extends Handle_StepBasic_LocalTime {
    constructor(theHandle: Handle_StepBasic_LocalTime);
  }

  export declare class Handle_StepBasic_LocalTime_4 extends Handle_StepBasic_LocalTime {
    constructor(theHandle: Handle_StepBasic_LocalTime);
  }

export declare class StepBasic_LocalTime extends Standard_Transient {
  constructor()
  Init(aHourComponent: Graphic3d_ZLayerId, hasAminuteComponent: Standard_Boolean, aMinuteComponent: Graphic3d_ZLayerId, hasAsecondComponent: Standard_Boolean, aSecondComponent: Quantity_AbsorbedDose, aZone: Handle_StepBasic_CoordinatedUniversalTimeOffset): void;
  SetHourComponent(aHourComponent: Graphic3d_ZLayerId): void;
  HourComponent(): Graphic3d_ZLayerId;
  SetMinuteComponent(aMinuteComponent: Graphic3d_ZLayerId): void;
  UnSetMinuteComponent(): void;
  MinuteComponent(): Graphic3d_ZLayerId;
  HasMinuteComponent(): Standard_Boolean;
  SetSecondComponent(aSecondComponent: Quantity_AbsorbedDose): void;
  UnSetSecondComponent(): void;
  SecondComponent(): Quantity_AbsorbedDose;
  HasSecondComponent(): Standard_Boolean;
  SetZone(aZone: Handle_StepBasic_CoordinatedUniversalTimeOffset): void;
  Zone(): Handle_StepBasic_CoordinatedUniversalTimeOffset;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_DateTimeRole extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DateTimeRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DateTimeRole): void;
  get(): StepBasic_DateTimeRole;
  delete(): void;
}

  export declare class Handle_StepBasic_DateTimeRole_1 extends Handle_StepBasic_DateTimeRole {
    constructor();
  }

  export declare class Handle_StepBasic_DateTimeRole_2 extends Handle_StepBasic_DateTimeRole {
    constructor(thePtr: StepBasic_DateTimeRole);
  }

  export declare class Handle_StepBasic_DateTimeRole_3 extends Handle_StepBasic_DateTimeRole {
    constructor(theHandle: Handle_StepBasic_DateTimeRole);
  }

  export declare class Handle_StepBasic_DateTimeRole_4 extends Handle_StepBasic_DateTimeRole {
    constructor(theHandle: Handle_StepBasic_DateTimeRole);
  }

export declare class StepBasic_DateTimeSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Date(): Handle_StepBasic_Date;
  LocalTime(): Handle_StepBasic_LocalTime;
  DateAndTime(): Handle_StepBasic_DateAndTime;
  delete(): void;
}

export declare class StepBasic_NamedUnit extends Standard_Transient {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents): void;
  SetDimensions(aDimensions: Handle_StepBasic_DimensionalExponents): void;
  Dimensions(): Handle_StepBasic_DimensionalExponents;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_NamedUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_NamedUnit): void;
  get(): StepBasic_NamedUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_NamedUnit_1 extends Handle_StepBasic_NamedUnit {
    constructor();
  }

  export declare class Handle_StepBasic_NamedUnit_2 extends Handle_StepBasic_NamedUnit {
    constructor(thePtr: StepBasic_NamedUnit);
  }

  export declare class Handle_StepBasic_NamedUnit_3 extends Handle_StepBasic_NamedUnit {
    constructor(theHandle: Handle_StepBasic_NamedUnit);
  }

  export declare class Handle_StepBasic_NamedUnit_4 extends Handle_StepBasic_NamedUnit {
    constructor(theHandle: Handle_StepBasic_NamedUnit);
  }

export declare class StepBasic_ProductDefinitionOrReference extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionReference(): Handle_StepBasic_ProductDefinitionReference;
  ProductDefinitionReferenceWithLocalRepresentation(): Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation;
  delete(): void;
}

export declare class StepBasic_ConversionBasedUnitAndPlaneAngleUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetPlaneAngleUnit(aPlaneAngleUnit: Handle_StepBasic_PlaneAngleUnit): void;
  PlaneAngleUnit(): Handle_StepBasic_PlaneAngleUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndPlaneAngleUnit): void;
  get(): StepBasic_ConversionBasedUnitAndPlaneAngleUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndPlaneAngleUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit);
  }

export declare class StepBasic_ProductOrFormationOrDefinition extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Product(): Handle_StepBasic_Product;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  delete(): void;
}

export declare class StepBasic_MeasureWithUnit extends Standard_Transient {
  constructor()
  Init(aValueComponent: Handle_StepBasic_MeasureValueMember, aUnitComponent: StepBasic_Unit): void;
  SetValueComponent(aValueComponent: Quantity_AbsorbedDose): void;
  ValueComponent(): Quantity_AbsorbedDose;
  ValueComponentMember(): Handle_StepBasic_MeasureValueMember;
  SetValueComponentMember(val: Handle_StepBasic_MeasureValueMember): void;
  SetUnitComponent(aUnitComponent: StepBasic_Unit): void;
  UnitComponent(): StepBasic_Unit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_MeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_MeasureWithUnit): void;
  get(): StepBasic_MeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_MeasureWithUnit_1 extends Handle_StepBasic_MeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_MeasureWithUnit_2 extends Handle_StepBasic_MeasureWithUnit {
    constructor(thePtr: StepBasic_MeasureWithUnit);
  }

  export declare class Handle_StepBasic_MeasureWithUnit_3 extends Handle_StepBasic_MeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_MeasureWithUnit);
  }

  export declare class Handle_StepBasic_MeasureWithUnit_4 extends Handle_StepBasic_MeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_MeasureWithUnit);
  }

export declare class Handle_StepBasic_RoleAssociation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_RoleAssociation): void;
  get(): StepBasic_RoleAssociation;
  delete(): void;
}

  export declare class Handle_StepBasic_RoleAssociation_1 extends Handle_StepBasic_RoleAssociation {
    constructor();
  }

  export declare class Handle_StepBasic_RoleAssociation_2 extends Handle_StepBasic_RoleAssociation {
    constructor(thePtr: StepBasic_RoleAssociation);
  }

  export declare class Handle_StepBasic_RoleAssociation_3 extends Handle_StepBasic_RoleAssociation {
    constructor(theHandle: Handle_StepBasic_RoleAssociation);
  }

  export declare class Handle_StepBasic_RoleAssociation_4 extends Handle_StepBasic_RoleAssociation {
    constructor(theHandle: Handle_StepBasic_RoleAssociation);
  }

export declare class StepBasic_RoleAssociation extends Standard_Transient {
  constructor()
  Init(aRole: Handle_StepBasic_ObjectRole, aItemWithRole: StepBasic_RoleSelect): void;
  Role(): Handle_StepBasic_ObjectRole;
  SetRole(Role: Handle_StepBasic_ObjectRole): void;
  ItemWithRole(): StepBasic_RoleSelect;
  SetItemWithRole(ItemWithRole: StepBasic_RoleSelect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_DateAndTimeAssignment extends Standard_Transient {
  constructor();
  Init(aAssignedDateAndTime: Handle_StepBasic_DateAndTime, aRole: Handle_StepBasic_DateTimeRole): void;
  SetAssignedDateAndTime(aAssignedDateAndTime: Handle_StepBasic_DateAndTime): void;
  AssignedDateAndTime(): Handle_StepBasic_DateAndTime;
  SetRole(aRole: Handle_StepBasic_DateTimeRole): void;
  Role(): Handle_StepBasic_DateTimeRole;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DateAndTimeAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DateAndTimeAssignment): void;
  get(): StepBasic_DateAndTimeAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_DateAndTimeAssignment_1 extends Handle_StepBasic_DateAndTimeAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_DateAndTimeAssignment_2 extends Handle_StepBasic_DateAndTimeAssignment {
    constructor(thePtr: StepBasic_DateAndTimeAssignment);
  }

  export declare class Handle_StepBasic_DateAndTimeAssignment_3 extends Handle_StepBasic_DateAndTimeAssignment {
    constructor(theHandle: Handle_StepBasic_DateAndTimeAssignment);
  }

  export declare class Handle_StepBasic_DateAndTimeAssignment_4 extends Handle_StepBasic_DateAndTimeAssignment {
    constructor(theHandle: Handle_StepBasic_DateAndTimeAssignment);
  }

export declare class StepBasic_Unit extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NamedUnit(): Handle_StepBasic_NamedUnit;
  DerivedUnit(): Handle_StepBasic_DerivedUnit;
  delete(): void;
}

export declare class Handle_StepBasic_ActionRequestAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ActionRequestAssignment): void;
  get(): StepBasic_ActionRequestAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_ActionRequestAssignment_1 extends Handle_StepBasic_ActionRequestAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_ActionRequestAssignment_2 extends Handle_StepBasic_ActionRequestAssignment {
    constructor(thePtr: StepBasic_ActionRequestAssignment);
  }

  export declare class Handle_StepBasic_ActionRequestAssignment_3 extends Handle_StepBasic_ActionRequestAssignment {
    constructor(theHandle: Handle_StepBasic_ActionRequestAssignment);
  }

  export declare class Handle_StepBasic_ActionRequestAssignment_4 extends Handle_StepBasic_ActionRequestAssignment {
    constructor(theHandle: Handle_StepBasic_ActionRequestAssignment);
  }

export declare class StepBasic_ActionRequestAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedActionRequest: Handle_StepBasic_VersionedActionRequest): void;
  AssignedActionRequest(): Handle_StepBasic_VersionedActionRequest;
  SetAssignedActionRequest(AssignedActionRequest: Handle_StepBasic_VersionedActionRequest): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndPlaneAngleUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndPlaneAngleUnit): void;
  get(): StepBasic_SiUnitAndPlaneAngleUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndPlaneAngleUnit_1 extends Handle_StepBasic_SiUnitAndPlaneAngleUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndPlaneAngleUnit_2 extends Handle_StepBasic_SiUnitAndPlaneAngleUnit {
    constructor(thePtr: StepBasic_SiUnitAndPlaneAngleUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndPlaneAngleUnit_3 extends Handle_StepBasic_SiUnitAndPlaneAngleUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndPlaneAngleUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndPlaneAngleUnit_4 extends Handle_StepBasic_SiUnitAndPlaneAngleUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndPlaneAngleUnit);
  }

export declare class StepBasic_SiUnitAndPlaneAngleUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetPlaneAngleUnit(aPlaneAngleUnit: Handle_StepBasic_PlaneAngleUnit): void;
  PlaneAngleUnit(): Handle_StepBasic_PlaneAngleUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndMassUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndMassUnit): void;
  get(): StepBasic_SiUnitAndMassUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndMassUnit_1 extends Handle_StepBasic_SiUnitAndMassUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndMassUnit_2 extends Handle_StepBasic_SiUnitAndMassUnit {
    constructor(thePtr: StepBasic_SiUnitAndMassUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndMassUnit_3 extends Handle_StepBasic_SiUnitAndMassUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndMassUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndMassUnit_4 extends Handle_StepBasic_SiUnitAndMassUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndMassUnit);
  }

export declare class StepBasic_SiUnitAndMassUnit extends StepBasic_SiUnit {
  constructor()
  Init(hasAprefix: Standard_Boolean, aPrefix: StepBasic_SiPrefix, aName: StepBasic_SiUnitName): void;
  SetMassUnit(aMassUnit: Handle_StepBasic_MassUnit): void;
  MassUnit(): Handle_StepBasic_MassUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ApplicationProtocolDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApplicationProtocolDefinition): void;
  get(): StepBasic_ApplicationProtocolDefinition;
  delete(): void;
}

  export declare class Handle_StepBasic_ApplicationProtocolDefinition_1 extends Handle_StepBasic_ApplicationProtocolDefinition {
    constructor();
  }

  export declare class Handle_StepBasic_ApplicationProtocolDefinition_2 extends Handle_StepBasic_ApplicationProtocolDefinition {
    constructor(thePtr: StepBasic_ApplicationProtocolDefinition);
  }

  export declare class Handle_StepBasic_ApplicationProtocolDefinition_3 extends Handle_StepBasic_ApplicationProtocolDefinition {
    constructor(theHandle: Handle_StepBasic_ApplicationProtocolDefinition);
  }

  export declare class Handle_StepBasic_ApplicationProtocolDefinition_4 extends Handle_StepBasic_ApplicationProtocolDefinition {
    constructor(theHandle: Handle_StepBasic_ApplicationProtocolDefinition);
  }

export declare class StepBasic_ApplicationProtocolDefinition extends Standard_Transient {
  constructor()
  Init(aStatus: Handle_TCollection_HAsciiString, aApplicationInterpretedModelSchemaName: Handle_TCollection_HAsciiString, aApplicationProtocolYear: Graphic3d_ZLayerId, aApplication: Handle_StepBasic_ApplicationContext): void;
  SetStatus(aStatus: Handle_TCollection_HAsciiString): void;
  Status(): Handle_TCollection_HAsciiString;
  SetApplicationInterpretedModelSchemaName(aApplicationInterpretedModelSchemaName: Handle_TCollection_HAsciiString): void;
  ApplicationInterpretedModelSchemaName(): Handle_TCollection_HAsciiString;
  SetApplicationProtocolYear(aApplicationProtocolYear: Graphic3d_ZLayerId): void;
  ApplicationProtocolYear(): Graphic3d_ZLayerId;
  SetApplication(aApplication: Handle_StepBasic_ApplicationContext): void;
  Application(): Handle_StepBasic_ApplicationContext;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_LengthUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_LengthUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_LengthUnit): void;
  get(): StepBasic_LengthUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_LengthUnit_1 extends Handle_StepBasic_LengthUnit {
    constructor();
  }

  export declare class Handle_StepBasic_LengthUnit_2 extends Handle_StepBasic_LengthUnit {
    constructor(thePtr: StepBasic_LengthUnit);
  }

  export declare class Handle_StepBasic_LengthUnit_3 extends Handle_StepBasic_LengthUnit {
    constructor(theHandle: Handle_StepBasic_LengthUnit);
  }

  export declare class Handle_StepBasic_LengthUnit_4 extends Handle_StepBasic_LengthUnit {
    constructor(theHandle: Handle_StepBasic_LengthUnit);
  }

export declare class StepBasic_ActionMethod extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aConsequence: Handle_TCollection_HAsciiString, aPurpose: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  Consequence(): Handle_TCollection_HAsciiString;
  SetConsequence(Consequence: Handle_TCollection_HAsciiString): void;
  Purpose(): Handle_TCollection_HAsciiString;
  SetPurpose(Purpose: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ActionMethod {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ActionMethod): void;
  get(): StepBasic_ActionMethod;
  delete(): void;
}

  export declare class Handle_StepBasic_ActionMethod_1 extends Handle_StepBasic_ActionMethod {
    constructor();
  }

  export declare class Handle_StepBasic_ActionMethod_2 extends Handle_StepBasic_ActionMethod {
    constructor(thePtr: StepBasic_ActionMethod);
  }

  export declare class Handle_StepBasic_ActionMethod_3 extends Handle_StepBasic_ActionMethod {
    constructor(theHandle: Handle_StepBasic_ActionMethod);
  }

  export declare class Handle_StepBasic_ActionMethod_4 extends Handle_StepBasic_ActionMethod {
    constructor(theHandle: Handle_StepBasic_ActionMethod);
  }

export declare class StepBasic_RatioUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_RatioUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_RatioUnit): void;
  get(): StepBasic_RatioUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_RatioUnit_1 extends Handle_StepBasic_RatioUnit {
    constructor();
  }

  export declare class Handle_StepBasic_RatioUnit_2 extends Handle_StepBasic_RatioUnit {
    constructor(thePtr: StepBasic_RatioUnit);
  }

  export declare class Handle_StepBasic_RatioUnit_3 extends Handle_StepBasic_RatioUnit {
    constructor(theHandle: Handle_StepBasic_RatioUnit);
  }

  export declare class Handle_StepBasic_RatioUnit_4 extends Handle_StepBasic_RatioUnit {
    constructor(theHandle: Handle_StepBasic_RatioUnit);
  }

export declare class StepBasic_DateRole extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DateRole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DateRole): void;
  get(): StepBasic_DateRole;
  delete(): void;
}

  export declare class Handle_StepBasic_DateRole_1 extends Handle_StepBasic_DateRole {
    constructor();
  }

  export declare class Handle_StepBasic_DateRole_2 extends Handle_StepBasic_DateRole {
    constructor(thePtr: StepBasic_DateRole);
  }

  export declare class Handle_StepBasic_DateRole_3 extends Handle_StepBasic_DateRole {
    constructor(theHandle: Handle_StepBasic_DateRole);
  }

  export declare class Handle_StepBasic_DateRole_4 extends Handle_StepBasic_DateRole {
    constructor(theHandle: Handle_StepBasic_DateRole);
  }

export declare class Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionFormationWithSpecifiedSource): void;
  get(): StepBasic_ProductDefinitionFormationWithSpecifiedSource;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_1 extends Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_2 extends Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource {
    constructor(thePtr: StepBasic_ProductDefinitionFormationWithSpecifiedSource);
  }

  export declare class Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_3 extends Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource);
  }

  export declare class Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_4 extends Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource);
  }

export declare class StepBasic_ProductDefinitionFormationWithSpecifiedSource extends StepBasic_ProductDefinitionFormation {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aOfProduct: Handle_StepBasic_Product, aMakeOrBuy: StepBasic_Source): void;
  SetMakeOrBuy(aMakeOrBuy: StepBasic_Source): void;
  MakeOrBuy(): StepBasic_Source;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_SiUnitAndVolumeUnit extends StepBasic_SiUnit {
  constructor()
  SetVolumeUnit(aVolumeUnit: Handle_StepBasic_VolumeUnit): void;
  VolumeUnit(): Handle_StepBasic_VolumeUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndVolumeUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndVolumeUnit): void;
  get(): StepBasic_SiUnitAndVolumeUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndVolumeUnit_1 extends Handle_StepBasic_SiUnitAndVolumeUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndVolumeUnit_2 extends Handle_StepBasic_SiUnitAndVolumeUnit {
    constructor(thePtr: StepBasic_SiUnitAndVolumeUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndVolumeUnit_3 extends Handle_StepBasic_SiUnitAndVolumeUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndVolumeUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndVolumeUnit_4 extends Handle_StepBasic_SiUnitAndVolumeUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndVolumeUnit);
  }

export declare class Handle_StepBasic_UncertaintyMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_UncertaintyMeasureWithUnit): void;
  get(): StepBasic_UncertaintyMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_UncertaintyMeasureWithUnit_1 extends Handle_StepBasic_UncertaintyMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepBasic_UncertaintyMeasureWithUnit_2 extends Handle_StepBasic_UncertaintyMeasureWithUnit {
    constructor(thePtr: StepBasic_UncertaintyMeasureWithUnit);
  }

  export declare class Handle_StepBasic_UncertaintyMeasureWithUnit_3 extends Handle_StepBasic_UncertaintyMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_UncertaintyMeasureWithUnit);
  }

  export declare class Handle_StepBasic_UncertaintyMeasureWithUnit_4 extends Handle_StepBasic_UncertaintyMeasureWithUnit {
    constructor(theHandle: Handle_StepBasic_UncertaintyMeasureWithUnit);
  }

export declare class StepBasic_UncertaintyMeasureWithUnit extends StepBasic_MeasureWithUnit {
  constructor()
  Init(aValueComponent: Handle_StepBasic_MeasureValueMember, aUnitComponent: StepBasic_Unit, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_MeasureValueMember extends StepData_SelectReal {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_MeasureValueMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_MeasureValueMember): void;
  get(): StepBasic_MeasureValueMember;
  delete(): void;
}

  export declare class Handle_StepBasic_MeasureValueMember_1 extends Handle_StepBasic_MeasureValueMember {
    constructor();
  }

  export declare class Handle_StepBasic_MeasureValueMember_2 extends Handle_StepBasic_MeasureValueMember {
    constructor(thePtr: StepBasic_MeasureValueMember);
  }

  export declare class Handle_StepBasic_MeasureValueMember_3 extends Handle_StepBasic_MeasureValueMember {
    constructor(theHandle: Handle_StepBasic_MeasureValueMember);
  }

  export declare class Handle_StepBasic_MeasureValueMember_4 extends Handle_StepBasic_MeasureValueMember {
    constructor(theHandle: Handle_StepBasic_MeasureValueMember);
  }

export declare class StepBasic_Contract extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPurpose: Handle_TCollection_HAsciiString, aKind: Handle_StepBasic_ContractType): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Purpose(): Handle_TCollection_HAsciiString;
  SetPurpose(Purpose: Handle_TCollection_HAsciiString): void;
  Kind(): Handle_StepBasic_ContractType;
  SetKind(Kind: Handle_StepBasic_ContractType): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Contract {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Contract): void;
  get(): StepBasic_Contract;
  delete(): void;
}

  export declare class Handle_StepBasic_Contract_1 extends Handle_StepBasic_Contract {
    constructor();
  }

  export declare class Handle_StepBasic_Contract_2 extends Handle_StepBasic_Contract {
    constructor(thePtr: StepBasic_Contract);
  }

  export declare class Handle_StepBasic_Contract_3 extends Handle_StepBasic_Contract {
    constructor(theHandle: Handle_StepBasic_Contract);
  }

  export declare class Handle_StepBasic_Contract_4 extends Handle_StepBasic_Contract {
    constructor(theHandle: Handle_StepBasic_Contract);
  }

export declare class StepBasic_SourceItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  Identifier(): Handle_TCollection_HAsciiString;
  delete(): void;
}

export declare class StepBasic_SiUnitAndAreaUnit extends StepBasic_SiUnit {
  constructor()
  SetAreaUnit(anAreaUnit: Handle_StepBasic_AreaUnit): void;
  AreaUnit(): Handle_StepBasic_AreaUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SiUnitAndAreaUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SiUnitAndAreaUnit): void;
  get(): StepBasic_SiUnitAndAreaUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SiUnitAndAreaUnit_1 extends Handle_StepBasic_SiUnitAndAreaUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SiUnitAndAreaUnit_2 extends Handle_StepBasic_SiUnitAndAreaUnit {
    constructor(thePtr: StepBasic_SiUnitAndAreaUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndAreaUnit_3 extends Handle_StepBasic_SiUnitAndAreaUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndAreaUnit);
  }

  export declare class Handle_StepBasic_SiUnitAndAreaUnit_4 extends Handle_StepBasic_SiUnitAndAreaUnit {
    constructor(theHandle: Handle_StepBasic_SiUnitAndAreaUnit);
  }

export declare class StepBasic_Product extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aFrameOfReference: Handle_StepBasic_HArray1OfProductContext): void;
  SetId(aId: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetFrameOfReference(aFrameOfReference: Handle_StepBasic_HArray1OfProductContext): void;
  FrameOfReference(): Handle_StepBasic_HArray1OfProductContext;
  FrameOfReferenceValue(num: Graphic3d_ZLayerId): Handle_StepBasic_ProductContext;
  NbFrameOfReference(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Product {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Product): void;
  get(): StepBasic_Product;
  delete(): void;
}

  export declare class Handle_StepBasic_Product_1 extends Handle_StepBasic_Product {
    constructor();
  }

  export declare class Handle_StepBasic_Product_2 extends Handle_StepBasic_Product {
    constructor(thePtr: StepBasic_Product);
  }

  export declare class Handle_StepBasic_Product_3 extends Handle_StepBasic_Product {
    constructor(theHandle: Handle_StepBasic_Product);
  }

  export declare class Handle_StepBasic_Product_4 extends Handle_StepBasic_Product {
    constructor(theHandle: Handle_StepBasic_Product);
  }

export declare class Handle_StepBasic_DerivedUnitElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DerivedUnitElement): void;
  get(): StepBasic_DerivedUnitElement;
  delete(): void;
}

  export declare class Handle_StepBasic_DerivedUnitElement_1 extends Handle_StepBasic_DerivedUnitElement {
    constructor();
  }

  export declare class Handle_StepBasic_DerivedUnitElement_2 extends Handle_StepBasic_DerivedUnitElement {
    constructor(thePtr: StepBasic_DerivedUnitElement);
  }

  export declare class Handle_StepBasic_DerivedUnitElement_3 extends Handle_StepBasic_DerivedUnitElement {
    constructor(theHandle: Handle_StepBasic_DerivedUnitElement);
  }

  export declare class Handle_StepBasic_DerivedUnitElement_4 extends Handle_StepBasic_DerivedUnitElement {
    constructor(theHandle: Handle_StepBasic_DerivedUnitElement);
  }

export declare class StepBasic_DerivedUnitElement extends Standard_Transient {
  constructor()
  Init(aUnit: Handle_StepBasic_NamedUnit, aExponent: Quantity_AbsorbedDose): void;
  SetUnit(aUnit: Handle_StepBasic_NamedUnit): void;
  Unit(): Handle_StepBasic_NamedUnit;
  SetExponent(aExponent: Quantity_AbsorbedDose): void;
  Exponent(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_Effectivity extends Standard_Transient {
  constructor()
  Init(aid: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(aid: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_Effectivity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_Effectivity): void;
  get(): StepBasic_Effectivity;
  delete(): void;
}

  export declare class Handle_StepBasic_Effectivity_1 extends Handle_StepBasic_Effectivity {
    constructor();
  }

  export declare class Handle_StepBasic_Effectivity_2 extends Handle_StepBasic_Effectivity {
    constructor(thePtr: StepBasic_Effectivity);
  }

  export declare class Handle_StepBasic_Effectivity_3 extends Handle_StepBasic_Effectivity {
    constructor(theHandle: Handle_StepBasic_Effectivity);
  }

  export declare class Handle_StepBasic_Effectivity_4 extends Handle_StepBasic_Effectivity {
    constructor(theHandle: Handle_StepBasic_Effectivity);
  }

export declare class StepBasic_DocumentProductAssociation extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aRelatingDocument: Handle_StepBasic_Document, aRelatedProduct: StepBasic_ProductOrFormationOrDefinition): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  RelatingDocument(): Handle_StepBasic_Document;
  SetRelatingDocument(RelatingDocument: Handle_StepBasic_Document): void;
  RelatedProduct(): StepBasic_ProductOrFormationOrDefinition;
  SetRelatedProduct(RelatedProduct: StepBasic_ProductOrFormationOrDefinition): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_DocumentProductAssociation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_DocumentProductAssociation): void;
  get(): StepBasic_DocumentProductAssociation;
  delete(): void;
}

  export declare class Handle_StepBasic_DocumentProductAssociation_1 extends Handle_StepBasic_DocumentProductAssociation {
    constructor();
  }

  export declare class Handle_StepBasic_DocumentProductAssociation_2 extends Handle_StepBasic_DocumentProductAssociation {
    constructor(thePtr: StepBasic_DocumentProductAssociation);
  }

  export declare class Handle_StepBasic_DocumentProductAssociation_3 extends Handle_StepBasic_DocumentProductAssociation {
    constructor(theHandle: Handle_StepBasic_DocumentProductAssociation);
  }

  export declare class Handle_StepBasic_DocumentProductAssociation_4 extends Handle_StepBasic_DocumentProductAssociation {
    constructor(theHandle: Handle_StepBasic_DocumentProductAssociation);
  }

export declare class Handle_StepBasic_ApplicationContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApplicationContext): void;
  get(): StepBasic_ApplicationContext;
  delete(): void;
}

  export declare class Handle_StepBasic_ApplicationContext_1 extends Handle_StepBasic_ApplicationContext {
    constructor();
  }

  export declare class Handle_StepBasic_ApplicationContext_2 extends Handle_StepBasic_ApplicationContext {
    constructor(thePtr: StepBasic_ApplicationContext);
  }

  export declare class Handle_StepBasic_ApplicationContext_3 extends Handle_StepBasic_ApplicationContext {
    constructor(theHandle: Handle_StepBasic_ApplicationContext);
  }

  export declare class Handle_StepBasic_ApplicationContext_4 extends Handle_StepBasic_ApplicationContext {
    constructor(theHandle: Handle_StepBasic_ApplicationContext);
  }

export declare class StepBasic_ApplicationContext extends Standard_Transient {
  constructor()
  Init(aApplication: Handle_TCollection_HAsciiString): void;
  SetApplication(aApplication: Handle_TCollection_HAsciiString): void;
  Application(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_GroupRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aRelatingGroup: Handle_StepBasic_Group, aRelatedGroup: Handle_StepBasic_Group): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  RelatingGroup(): Handle_StepBasic_Group;
  SetRelatingGroup(RelatingGroup: Handle_StepBasic_Group): void;
  RelatedGroup(): Handle_StepBasic_Group;
  SetRelatedGroup(RelatedGroup: Handle_StepBasic_Group): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_GroupRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_GroupRelationship): void;
  get(): StepBasic_GroupRelationship;
  delete(): void;
}

  export declare class Handle_StepBasic_GroupRelationship_1 extends Handle_StepBasic_GroupRelationship {
    constructor();
  }

  export declare class Handle_StepBasic_GroupRelationship_2 extends Handle_StepBasic_GroupRelationship {
    constructor(thePtr: StepBasic_GroupRelationship);
  }

  export declare class Handle_StepBasic_GroupRelationship_3 extends Handle_StepBasic_GroupRelationship {
    constructor(theHandle: Handle_StepBasic_GroupRelationship);
  }

  export declare class Handle_StepBasic_GroupRelationship_4 extends Handle_StepBasic_GroupRelationship {
    constructor(theHandle: Handle_StepBasic_GroupRelationship);
  }

export declare class StepBasic_RoleSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ActionAssignment(): Handle_StepBasic_ActionAssignment;
  ActionRequestAssignment(): Handle_StepBasic_ActionRequestAssignment;
  ApprovalAssignment(): Handle_StepBasic_ApprovalAssignment;
  ApprovalDateTime(): Handle_StepBasic_ApprovalDateTime;
  CertificationAssignment(): Handle_StepBasic_CertificationAssignment;
  ContractAssignment(): Handle_StepBasic_ContractAssignment;
  DocumentReference(): Handle_StepBasic_DocumentReference;
  EffectivityAssignment(): Handle_StepBasic_EffectivityAssignment;
  GroupAssignment(): Handle_StepBasic_GroupAssignment;
  NameAssignment(): Handle_StepBasic_NameAssignment;
  SecurityClassificationAssignment(): Handle_StepBasic_SecurityClassificationAssignment;
  delete(): void;
}

export declare class Handle_StepBasic_EulerAngles {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_EulerAngles): void;
  get(): StepBasic_EulerAngles;
  delete(): void;
}

  export declare class Handle_StepBasic_EulerAngles_1 extends Handle_StepBasic_EulerAngles {
    constructor();
  }

  export declare class Handle_StepBasic_EulerAngles_2 extends Handle_StepBasic_EulerAngles {
    constructor(thePtr: StepBasic_EulerAngles);
  }

  export declare class Handle_StepBasic_EulerAngles_3 extends Handle_StepBasic_EulerAngles {
    constructor(theHandle: Handle_StepBasic_EulerAngles);
  }

  export declare class Handle_StepBasic_EulerAngles_4 extends Handle_StepBasic_EulerAngles {
    constructor(theHandle: Handle_StepBasic_EulerAngles);
  }

export declare class StepBasic_EulerAngles extends Standard_Transient {
  constructor()
  Init(aAngles: Handle_TColStd_HArray1OfReal): void;
  Angles(): Handle_TColStd_HArray1OfReal;
  SetAngles(Angles: Handle_TColStd_HArray1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_PhysicallyModeledProductDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_PhysicallyModeledProductDefinition): void;
  get(): StepBasic_PhysicallyModeledProductDefinition;
  delete(): void;
}

  export declare class Handle_StepBasic_PhysicallyModeledProductDefinition_1 extends Handle_StepBasic_PhysicallyModeledProductDefinition {
    constructor();
  }

  export declare class Handle_StepBasic_PhysicallyModeledProductDefinition_2 extends Handle_StepBasic_PhysicallyModeledProductDefinition {
    constructor(thePtr: StepBasic_PhysicallyModeledProductDefinition);
  }

  export declare class Handle_StepBasic_PhysicallyModeledProductDefinition_3 extends Handle_StepBasic_PhysicallyModeledProductDefinition {
    constructor(theHandle: Handle_StepBasic_PhysicallyModeledProductDefinition);
  }

  export declare class Handle_StepBasic_PhysicallyModeledProductDefinition_4 extends Handle_StepBasic_PhysicallyModeledProductDefinition {
    constructor(theHandle: Handle_StepBasic_PhysicallyModeledProductDefinition);
  }

export declare class StepBasic_PhysicallyModeledProductDefinition extends StepBasic_ProductDefinition {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndSolidAngleUnit): void;
  get(): StepBasic_ConversionBasedUnitAndSolidAngleUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndSolidAngleUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit);
  }

export declare class StepBasic_ConversionBasedUnitAndSolidAngleUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  Init(aDimensions: Handle_StepBasic_DimensionalExponents, aName: Handle_TCollection_HAsciiString, aConversionFactor: Handle_StepBasic_MeasureWithUnit): void;
  SetSolidAngleUnit(aSolidAngleUnit: Handle_StepBasic_SolidAngleUnit): void;
  SolidAngleUnit(): Handle_StepBasic_SolidAngleUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ConversionBasedUnitAndVolumeUnit extends StepBasic_ConversionBasedUnit {
  constructor()
  SetVolumeUnit(aVolumeUnit: Handle_StepBasic_VolumeUnit): void;
  VolumeUnit(): Handle_StepBasic_VolumeUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ConversionBasedUnitAndVolumeUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ConversionBasedUnitAndVolumeUnit): void;
  get(): StepBasic_ConversionBasedUnitAndVolumeUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_1 extends Handle_StepBasic_ConversionBasedUnitAndVolumeUnit {
    constructor();
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_2 extends Handle_StepBasic_ConversionBasedUnitAndVolumeUnit {
    constructor(thePtr: StepBasic_ConversionBasedUnitAndVolumeUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_3 extends Handle_StepBasic_ConversionBasedUnitAndVolumeUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndVolumeUnit);
  }

  export declare class Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_4 extends Handle_StepBasic_ConversionBasedUnitAndVolumeUnit {
    constructor(theHandle: Handle_StepBasic_ConversionBasedUnitAndVolumeUnit);
  }

export declare class Handle_StepBasic_TimeUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_TimeUnit): void;
  get(): StepBasic_TimeUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_TimeUnit_1 extends Handle_StepBasic_TimeUnit {
    constructor();
  }

  export declare class Handle_StepBasic_TimeUnit_2 extends Handle_StepBasic_TimeUnit {
    constructor(thePtr: StepBasic_TimeUnit);
  }

  export declare class Handle_StepBasic_TimeUnit_3 extends Handle_StepBasic_TimeUnit {
    constructor(theHandle: Handle_StepBasic_TimeUnit);
  }

  export declare class Handle_StepBasic_TimeUnit_4 extends Handle_StepBasic_TimeUnit {
    constructor(theHandle: Handle_StepBasic_TimeUnit);
  }

export declare class StepBasic_TimeUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ProductDefinitionWithAssociatedDocuments extends StepBasic_ProductDefinition {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aFormation: Handle_StepBasic_ProductDefinitionFormation, aFrame: Handle_StepBasic_ProductDefinitionContext, aDocIds: Handle_StepBasic_HArray1OfDocument): void;
  DocIds(): Handle_StepBasic_HArray1OfDocument;
  SetDocIds(DocIds: Handle_StepBasic_HArray1OfDocument): void;
  NbDocIds(): Graphic3d_ZLayerId;
  DocIdsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_Document;
  SetDocIdsValue(num: Graphic3d_ZLayerId, adoc: Handle_StepBasic_Document): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ProductDefinitionWithAssociatedDocuments {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ProductDefinitionWithAssociatedDocuments): void;
  get(): StepBasic_ProductDefinitionWithAssociatedDocuments;
  delete(): void;
}

  export declare class Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_1 extends Handle_StepBasic_ProductDefinitionWithAssociatedDocuments {
    constructor();
  }

  export declare class Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_2 extends Handle_StepBasic_ProductDefinitionWithAssociatedDocuments {
    constructor(thePtr: StepBasic_ProductDefinitionWithAssociatedDocuments);
  }

  export declare class Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_3 extends Handle_StepBasic_ProductDefinitionWithAssociatedDocuments {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionWithAssociatedDocuments);
  }

  export declare class Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_4 extends Handle_StepBasic_ProductDefinitionWithAssociatedDocuments {
    constructor(theHandle: Handle_StepBasic_ProductDefinitionWithAssociatedDocuments);
  }

export declare class Handle_StepBasic_ContractAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ContractAssignment): void;
  get(): StepBasic_ContractAssignment;
  delete(): void;
}

  export declare class Handle_StepBasic_ContractAssignment_1 extends Handle_StepBasic_ContractAssignment {
    constructor();
  }

  export declare class Handle_StepBasic_ContractAssignment_2 extends Handle_StepBasic_ContractAssignment {
    constructor(thePtr: StepBasic_ContractAssignment);
  }

  export declare class Handle_StepBasic_ContractAssignment_3 extends Handle_StepBasic_ContractAssignment {
    constructor(theHandle: Handle_StepBasic_ContractAssignment);
  }

  export declare class Handle_StepBasic_ContractAssignment_4 extends Handle_StepBasic_ContractAssignment {
    constructor(theHandle: Handle_StepBasic_ContractAssignment);
  }

export declare class StepBasic_ContractAssignment extends Standard_Transient {
  constructor()
  Init(aAssignedContract: Handle_StepBasic_Contract): void;
  AssignedContract(): Handle_StepBasic_Contract;
  SetAssignedContract(AssignedContract: Handle_StepBasic_Contract): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_CertificationType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_CertificationType): void;
  get(): StepBasic_CertificationType;
  delete(): void;
}

  export declare class Handle_StepBasic_CertificationType_1 extends Handle_StepBasic_CertificationType {
    constructor();
  }

  export declare class Handle_StepBasic_CertificationType_2 extends Handle_StepBasic_CertificationType {
    constructor(thePtr: StepBasic_CertificationType);
  }

  export declare class Handle_StepBasic_CertificationType_3 extends Handle_StepBasic_CertificationType {
    constructor(theHandle: Handle_StepBasic_CertificationType);
  }

  export declare class Handle_StepBasic_CertificationType_4 extends Handle_StepBasic_CertificationType {
    constructor(theHandle: Handle_StepBasic_CertificationType);
  }

export declare class StepBasic_CertificationType extends Standard_Transient {
  constructor()
  Init(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepBasic_ApprovalPersonOrganization extends Standard_Transient {
  constructor()
  Init(aPersonOrganization: StepBasic_PersonOrganizationSelect, aAuthorizedApproval: Handle_StepBasic_Approval, aRole: Handle_StepBasic_ApprovalRole): void;
  SetPersonOrganization(aPersonOrganization: StepBasic_PersonOrganizationSelect): void;
  PersonOrganization(): StepBasic_PersonOrganizationSelect;
  SetAuthorizedApproval(aAuthorizedApproval: Handle_StepBasic_Approval): void;
  AuthorizedApproval(): Handle_StepBasic_Approval;
  SetRole(aRole: Handle_StepBasic_ApprovalRole): void;
  Role(): Handle_StepBasic_ApprovalRole;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_ApprovalPersonOrganization {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_ApprovalPersonOrganization): void;
  get(): StepBasic_ApprovalPersonOrganization;
  delete(): void;
}

  export declare class Handle_StepBasic_ApprovalPersonOrganization_1 extends Handle_StepBasic_ApprovalPersonOrganization {
    constructor();
  }

  export declare class Handle_StepBasic_ApprovalPersonOrganization_2 extends Handle_StepBasic_ApprovalPersonOrganization {
    constructor(thePtr: StepBasic_ApprovalPersonOrganization);
  }

  export declare class Handle_StepBasic_ApprovalPersonOrganization_3 extends Handle_StepBasic_ApprovalPersonOrganization {
    constructor(theHandle: Handle_StepBasic_ApprovalPersonOrganization);
  }

  export declare class Handle_StepBasic_ApprovalPersonOrganization_4 extends Handle_StepBasic_ApprovalPersonOrganization {
    constructor(theHandle: Handle_StepBasic_ApprovalPersonOrganization);
  }

export declare class StepBasic_SolidAngleUnit extends StepBasic_NamedUnit {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepBasic_SolidAngleUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepBasic_SolidAngleUnit): void;
  get(): StepBasic_SolidAngleUnit;
  delete(): void;
}

  export declare class Handle_StepBasic_SolidAngleUnit_1 extends Handle_StepBasic_SolidAngleUnit {
    constructor();
  }

  export declare class Handle_StepBasic_SolidAngleUnit_2 extends Handle_StepBasic_SolidAngleUnit {
    constructor(thePtr: StepBasic_SolidAngleUnit);
  }

  export declare class Handle_StepBasic_SolidAngleUnit_3 extends Handle_StepBasic_SolidAngleUnit {
    constructor(theHandle: Handle_StepBasic_SolidAngleUnit);
  }

  export declare class Handle_StepBasic_SolidAngleUnit_4 extends Handle_StepBasic_SolidAngleUnit {
    constructor(theHandle: Handle_StepBasic_SolidAngleUnit);
  }

export declare class Geom2dEvaluator_OffsetCurve extends Geom2dEvaluator_Curve {
  SetOffsetValue(theOffset: Quantity_AbsorbedDose): void;
  D0(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d): void;
  D1(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d, theD1: gp_Vec2d): void;
  D2(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d, theD1: gp_Vec2d, theD2: gp_Vec2d): void;
  D3(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d, theD1: gp_Vec2d, theD2: gp_Vec2d, theD3: gp_Vec2d): void;
  DN(theU: Quantity_AbsorbedDose, theDeriv: Graphic3d_ZLayerId): gp_Vec2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2dEvaluator_OffsetCurve_1 extends Geom2dEvaluator_OffsetCurve {
    constructor(theBase: Handle_Geom2d_Curve, theOffset: Quantity_AbsorbedDose);
  }

  export declare class Geom2dEvaluator_OffsetCurve_2 extends Geom2dEvaluator_OffsetCurve {
    constructor(theBase: Handle_Geom2dAdaptor_HCurve, theOffset: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom2dEvaluator_OffsetCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2dEvaluator_OffsetCurve): void;
  get(): Geom2dEvaluator_OffsetCurve;
  delete(): void;
}

  export declare class Handle_Geom2dEvaluator_OffsetCurve_1 extends Handle_Geom2dEvaluator_OffsetCurve {
    constructor();
  }

  export declare class Handle_Geom2dEvaluator_OffsetCurve_2 extends Handle_Geom2dEvaluator_OffsetCurve {
    constructor(thePtr: Geom2dEvaluator_OffsetCurve);
  }

  export declare class Handle_Geom2dEvaluator_OffsetCurve_3 extends Handle_Geom2dEvaluator_OffsetCurve {
    constructor(theHandle: Handle_Geom2dEvaluator_OffsetCurve);
  }

  export declare class Handle_Geom2dEvaluator_OffsetCurve_4 extends Handle_Geom2dEvaluator_OffsetCurve {
    constructor(theHandle: Handle_Geom2dEvaluator_OffsetCurve);
  }

export declare class Handle_Geom2dEvaluator_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2dEvaluator_Curve): void;
  get(): Geom2dEvaluator_Curve;
  delete(): void;
}

  export declare class Handle_Geom2dEvaluator_Curve_1 extends Handle_Geom2dEvaluator_Curve {
    constructor();
  }

  export declare class Handle_Geom2dEvaluator_Curve_2 extends Handle_Geom2dEvaluator_Curve {
    constructor(thePtr: Geom2dEvaluator_Curve);
  }

  export declare class Handle_Geom2dEvaluator_Curve_3 extends Handle_Geom2dEvaluator_Curve {
    constructor(theHandle: Handle_Geom2dEvaluator_Curve);
  }

  export declare class Handle_Geom2dEvaluator_Curve_4 extends Handle_Geom2dEvaluator_Curve {
    constructor(theHandle: Handle_Geom2dEvaluator_Curve);
  }

export declare class Geom2dEvaluator_Curve extends Standard_Transient {
  D0(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d): void;
  D1(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d, theD1: gp_Vec2d): void;
  D2(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d, theD1: gp_Vec2d, theD2: gp_Vec2d): void;
  D3(theU: Quantity_AbsorbedDose, theValue: gp_Pnt2d, theD1: gp_Vec2d, theD2: gp_Vec2d, theD3: gp_Vec2d): void;
  DN(theU: Quantity_AbsorbedDose, theDerU: Graphic3d_ZLayerId): gp_Vec2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMFunction {
  constructor();
  static AddDrivers(theDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class BinMFunction_FunctionDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMFunction_FunctionDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMFunction_FunctionDriver): void;
  get(): BinMFunction_FunctionDriver;
  delete(): void;
}

  export declare class Handle_BinMFunction_FunctionDriver_1 extends Handle_BinMFunction_FunctionDriver {
    constructor();
  }

  export declare class Handle_BinMFunction_FunctionDriver_2 extends Handle_BinMFunction_FunctionDriver {
    constructor(thePtr: BinMFunction_FunctionDriver);
  }

  export declare class Handle_BinMFunction_FunctionDriver_3 extends Handle_BinMFunction_FunctionDriver {
    constructor(theHandle: Handle_BinMFunction_FunctionDriver);
  }

  export declare class Handle_BinMFunction_FunctionDriver_4 extends Handle_BinMFunction_FunctionDriver {
    constructor(theHandle: Handle_BinMFunction_FunctionDriver);
  }

export declare class Handle_BinMFunction_GraphNodeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMFunction_GraphNodeDriver): void;
  get(): BinMFunction_GraphNodeDriver;
  delete(): void;
}

  export declare class Handle_BinMFunction_GraphNodeDriver_1 extends Handle_BinMFunction_GraphNodeDriver {
    constructor();
  }

  export declare class Handle_BinMFunction_GraphNodeDriver_2 extends Handle_BinMFunction_GraphNodeDriver {
    constructor(thePtr: BinMFunction_GraphNodeDriver);
  }

  export declare class Handle_BinMFunction_GraphNodeDriver_3 extends Handle_BinMFunction_GraphNodeDriver {
    constructor(theHandle: Handle_BinMFunction_GraphNodeDriver);
  }

  export declare class Handle_BinMFunction_GraphNodeDriver_4 extends Handle_BinMFunction_GraphNodeDriver {
    constructor(theHandle: Handle_BinMFunction_GraphNodeDriver);
  }

export declare class BinMFunction_GraphNodeDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinMFunction_ScopeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMFunction_ScopeDriver): void;
  get(): BinMFunction_ScopeDriver;
  delete(): void;
}

  export declare class Handle_BinMFunction_ScopeDriver_1 extends Handle_BinMFunction_ScopeDriver {
    constructor();
  }

  export declare class Handle_BinMFunction_ScopeDriver_2 extends Handle_BinMFunction_ScopeDriver {
    constructor(thePtr: BinMFunction_ScopeDriver);
  }

  export declare class Handle_BinMFunction_ScopeDriver_3 extends Handle_BinMFunction_ScopeDriver {
    constructor(theHandle: Handle_BinMFunction_ScopeDriver);
  }

  export declare class Handle_BinMFunction_ScopeDriver_4 extends Handle_BinMFunction_ScopeDriver {
    constructor(theHandle: Handle_BinMFunction_ScopeDriver);
  }

export declare class BinMFunction_ScopeDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepPrimAPI_MakeHalfSpace extends BRepBuilderAPI_MakeShape {
  Solid(): TopoDS_Solid;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeHalfSpace_1 extends BRepPrimAPI_MakeHalfSpace {
    constructor(Face: TopoDS_Face, RefPnt: gp_Pnt);
  }

  export declare class BRepPrimAPI_MakeHalfSpace_2 extends BRepPrimAPI_MakeHalfSpace {
    constructor(Shell: TopoDS_Shell, RefPnt: gp_Pnt);
  }

export declare class BRepPrimAPI_MakeOneAxis extends BRepBuilderAPI_MakeShape {
  OneAxis(): Standard_Address;
  Build(): void;
  Face(): TopoDS_Face;
  Shell(): TopoDS_Shell;
  Solid(): TopoDS_Solid;
  delete(): void;
}

export declare class BRepPrimAPI_MakeWedge extends BRepBuilderAPI_MakeShape {
  Wedge(): BRepPrim_Wedge;
  Build(): void;
  Shell(): TopoDS_Shell;
  Solid(): TopoDS_Solid;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeWedge_1 extends BRepPrimAPI_MakeWedge {
    constructor(dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose, ltx: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeWedge_2 extends BRepPrimAPI_MakeWedge {
    constructor(Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose, ltx: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeWedge_3 extends BRepPrimAPI_MakeWedge {
    constructor(dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose, xmin: Quantity_AbsorbedDose, zmin: Quantity_AbsorbedDose, xmax: Quantity_AbsorbedDose, zmax: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeWedge_4 extends BRepPrimAPI_MakeWedge {
    constructor(Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose, xmin: Quantity_AbsorbedDose, zmin: Quantity_AbsorbedDose, xmax: Quantity_AbsorbedDose, zmax: Quantity_AbsorbedDose);
  }

export declare class BRepPrimAPI_MakeCylinder extends BRepPrimAPI_MakeOneAxis {
  OneAxis(): Standard_Address;
  Cylinder(): BRepPrim_Cylinder;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeCylinder_1 extends BRepPrimAPI_MakeCylinder {
    constructor(R: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeCylinder_2 extends BRepPrimAPI_MakeCylinder {
    constructor(R: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeCylinder_3 extends BRepPrimAPI_MakeCylinder {
    constructor(Axes: gp_Ax2, R: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeCylinder_4 extends BRepPrimAPI_MakeCylinder {
    constructor(Axes: gp_Ax2, R: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose);
  }

export declare class BRepPrimAPI_MakeRevol extends BRepPrimAPI_MakeSweep {
  Revol(): BRepSweep_Revol;
  Build(): void;
  FirstShape_1(): TopoDS_Shape;
  LastShape_1(): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  FirstShape_2(theShape: TopoDS_Shape): TopoDS_Shape;
  LastShape_2(theShape: TopoDS_Shape): TopoDS_Shape;
  HasDegenerated(): Standard_Boolean;
  Degenerated(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeRevol_1 extends BRepPrimAPI_MakeRevol {
    constructor(S: TopoDS_Shape, A: gp_Ax1, D: Quantity_AbsorbedDose, Copy: Standard_Boolean);
  }

  export declare class BRepPrimAPI_MakeRevol_2 extends BRepPrimAPI_MakeRevol {
    constructor(S: TopoDS_Shape, A: gp_Ax1, Copy: Standard_Boolean);
  }

export declare class BRepPrimAPI_MakeCone extends BRepPrimAPI_MakeOneAxis {
  OneAxis(): Standard_Address;
  Cone(): BRepPrim_Cone;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeCone_1 extends BRepPrimAPI_MakeCone {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeCone_2 extends BRepPrimAPI_MakeCone {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeCone_3 extends BRepPrimAPI_MakeCone {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeCone_4 extends BRepPrimAPI_MakeCone {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, H: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

export declare class BRepPrimAPI_MakeTorus extends BRepPrimAPI_MakeOneAxis {
  OneAxis(): Standard_Address;
  Torus(): BRepPrim_Torus;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeTorus_1 extends BRepPrimAPI_MakeTorus {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_2 extends BRepPrimAPI_MakeTorus {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_3 extends BRepPrimAPI_MakeTorus {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_4 extends BRepPrimAPI_MakeTorus {
    constructor(R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_5 extends BRepPrimAPI_MakeTorus {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_6 extends BRepPrimAPI_MakeTorus {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_7 extends BRepPrimAPI_MakeTorus {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeTorus_8 extends BRepPrimAPI_MakeTorus {
    constructor(Axes: gp_Ax2, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

export declare class BRepPrimAPI_MakeBox extends BRepBuilderAPI_MakeShape {
  Init_1(theDX: Quantity_AbsorbedDose, theDY: Quantity_AbsorbedDose, theDZ: Quantity_AbsorbedDose): void;
  Init_2(thePnt: gp_Pnt, theDX: Quantity_AbsorbedDose, theDY: Quantity_AbsorbedDose, theDZ: Quantity_AbsorbedDose): void;
  Init_3(thePnt1: gp_Pnt, thePnt2: gp_Pnt): void;
  Init_4(theAxes: gp_Ax2, theDX: Quantity_AbsorbedDose, theDY: Quantity_AbsorbedDose, theDZ: Quantity_AbsorbedDose): void;
  Wedge(): BRepPrim_Wedge;
  Build(): void;
  Shell(): TopoDS_Shell;
  Solid(): TopoDS_Solid;
  BottomFace(): TopoDS_Face;
  BackFace(): TopoDS_Face;
  FrontFace(): TopoDS_Face;
  LeftFace(): TopoDS_Face;
  RightFace(): TopoDS_Face;
  TopFace(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeBox_1 extends BRepPrimAPI_MakeBox {
    constructor();
  }

  export declare class BRepPrimAPI_MakeBox_2 extends BRepPrimAPI_MakeBox {
    constructor(dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeBox_3 extends BRepPrimAPI_MakeBox {
    constructor(P: gp_Pnt, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeBox_4 extends BRepPrimAPI_MakeBox {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class BRepPrimAPI_MakeBox_5 extends BRepPrimAPI_MakeBox {
    constructor(Axes: gp_Ax2, dx: Quantity_AbsorbedDose, dy: Quantity_AbsorbedDose, dz: Quantity_AbsorbedDose);
  }

export declare class BRepPrimAPI_MakePrism extends BRepPrimAPI_MakeSweep {
  Prism(): BRepSweep_Prism;
  Build(): void;
  FirstShape_1(): TopoDS_Shape;
  LastShape_1(): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  FirstShape_2(theShape: TopoDS_Shape): TopoDS_Shape;
  LastShape_2(theShape: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepPrimAPI_MakePrism_1 extends BRepPrimAPI_MakePrism {
    constructor(S: TopoDS_Shape, V: gp_Vec, Copy: Standard_Boolean, Canonize: Standard_Boolean);
  }

  export declare class BRepPrimAPI_MakePrism_2 extends BRepPrimAPI_MakePrism {
    constructor(S: TopoDS_Shape, D: gp_Dir, Inf: Standard_Boolean, Copy: Standard_Boolean, Canonize: Standard_Boolean);
  }

export declare class BRepPrimAPI_MakeSweep extends BRepBuilderAPI_MakeShape {
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  delete(): void;
}

export declare class BRepPrimAPI_MakeSphere extends BRepPrimAPI_MakeOneAxis {
  OneAxis(): Standard_Address;
  Sphere(): BRepPrim_Sphere;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeSphere_1 extends BRepPrimAPI_MakeSphere {
    constructor(R: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_2 extends BRepPrimAPI_MakeSphere {
    constructor(R: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_3 extends BRepPrimAPI_MakeSphere {
    constructor(R: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_4 extends BRepPrimAPI_MakeSphere {
    constructor(R: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose, angle3: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_5 extends BRepPrimAPI_MakeSphere {
    constructor(Center: gp_Pnt, R: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_6 extends BRepPrimAPI_MakeSphere {
    constructor(Center: gp_Pnt, R: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_7 extends BRepPrimAPI_MakeSphere {
    constructor(Center: gp_Pnt, R: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_8 extends BRepPrimAPI_MakeSphere {
    constructor(Center: gp_Pnt, R: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose, angle3: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_9 extends BRepPrimAPI_MakeSphere {
    constructor(Axis: gp_Ax2, R: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_10 extends BRepPrimAPI_MakeSphere {
    constructor(Axis: gp_Ax2, R: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_11 extends BRepPrimAPI_MakeSphere {
    constructor(Axis: gp_Ax2, R: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeSphere_12 extends BRepPrimAPI_MakeSphere {
    constructor(Axis: gp_Ax2, R: Quantity_AbsorbedDose, angle1: Quantity_AbsorbedDose, angle2: Quantity_AbsorbedDose, angle3: Quantity_AbsorbedDose);
  }

export declare class BRepPrimAPI_MakeRevolution extends BRepPrimAPI_MakeOneAxis {
  OneAxis(): Standard_Address;
  Revolution(): BRepPrim_Revolution;
  delete(): void;
}

  export declare class BRepPrimAPI_MakeRevolution_1 extends BRepPrimAPI_MakeRevolution {
    constructor(Meridian: Handle_Geom_Curve);
  }

  export declare class BRepPrimAPI_MakeRevolution_2 extends BRepPrimAPI_MakeRevolution {
    constructor(Meridian: Handle_Geom_Curve, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeRevolution_3 extends BRepPrimAPI_MakeRevolution {
    constructor(Meridian: Handle_Geom_Curve, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeRevolution_4 extends BRepPrimAPI_MakeRevolution {
    constructor(Meridian: Handle_Geom_Curve, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeRevolution_5 extends BRepPrimAPI_MakeRevolution {
    constructor(Axes: gp_Ax2, Meridian: Handle_Geom_Curve);
  }

  export declare class BRepPrimAPI_MakeRevolution_6 extends BRepPrimAPI_MakeRevolution {
    constructor(Axes: gp_Ax2, Meridian: Handle_Geom_Curve, angle: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeRevolution_7 extends BRepPrimAPI_MakeRevolution {
    constructor(Axes: gp_Ax2, Meridian: Handle_Geom_Curve, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose);
  }

  export declare class BRepPrimAPI_MakeRevolution_8 extends BRepPrimAPI_MakeRevolution {
    constructor(Axes: gp_Ax2, Meridian: Handle_Geom_Curve, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose, angle: Quantity_AbsorbedDose);
  }

export declare class CDM_ReferenceIterator {
  constructor(aDocument: Handle_CDM_Document)
  More(): Standard_Boolean;
  Next(): void;
  Document(): Handle_CDM_Document;
  ReferenceIdentifier(): Graphic3d_ZLayerId;
  DocumentVersion(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_CDM_Reference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDM_Reference): void;
  get(): CDM_Reference;
  delete(): void;
}

  export declare class Handle_CDM_Reference_1 extends Handle_CDM_Reference {
    constructor();
  }

  export declare class Handle_CDM_Reference_2 extends Handle_CDM_Reference {
    constructor(thePtr: CDM_Reference);
  }

  export declare class Handle_CDM_Reference_3 extends Handle_CDM_Reference {
    constructor(theHandle: Handle_CDM_Reference);
  }

  export declare class Handle_CDM_Reference_4 extends Handle_CDM_Reference {
    constructor(theHandle: Handle_CDM_Reference);
  }

export declare class CDM_Reference extends Standard_Transient {
  FromDocument(): Handle_CDM_Document;
  ToDocument(): Handle_CDM_Document;
  ReferenceIdentifier(): Graphic3d_ZLayerId;
  DocumentVersion(): Graphic3d_ZLayerId;
  IsReadOnly(): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_CDM_MetaData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDM_MetaData): void;
  get(): CDM_MetaData;
  delete(): void;
}

  export declare class Handle_CDM_MetaData_1 extends Handle_CDM_MetaData {
    constructor();
  }

  export declare class Handle_CDM_MetaData_2 extends Handle_CDM_MetaData {
    constructor(thePtr: CDM_MetaData);
  }

  export declare class Handle_CDM_MetaData_3 extends Handle_CDM_MetaData {
    constructor(theHandle: Handle_CDM_MetaData);
  }

  export declare class Handle_CDM_MetaData_4 extends Handle_CDM_MetaData {
    constructor(theHandle: Handle_CDM_MetaData);
  }

export declare class CDM_MetaData extends Standard_Transient {
  static LookUp_1(theLookUpTable: CDM_MetaDataLookUpTable, aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aPath: TCollection_ExtendedString, aFileName: TCollection_ExtendedString, ReadOnly: Standard_Boolean): Handle_CDM_MetaData;
  static LookUp_2(theLookUpTable: CDM_MetaDataLookUpTable, aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aPath: TCollection_ExtendedString, aVersion: TCollection_ExtendedString, aFileName: TCollection_ExtendedString, ReadOnly: Standard_Boolean): Handle_CDM_MetaData;
  IsRetrieved(): Standard_Boolean;
  Document(): Handle_CDM_Document;
  Folder(): TCollection_ExtendedString;
  Name(): TCollection_ExtendedString;
  Version(): TCollection_ExtendedString;
  HasVersion(): Standard_Boolean;
  FileName(): TCollection_ExtendedString;
  Path(): TCollection_ExtendedString;
  UnsetDocument(): void;
  IsReadOnly(): Standard_Boolean;
  SetIsReadOnly(): void;
  UnsetIsReadOnly(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class CDM_Document extends Standard_Transient {
  Update_1(aToDocument: Handle_CDM_Document, aReferenceIdentifier: Graphic3d_ZLayerId, aModifContext: Standard_Address): void;
  Update_2(ErrorString: TCollection_ExtendedString): Standard_Boolean;
  StorageFormat(): TCollection_ExtendedString;
  Extensions(Extensions: TColStd_SequenceOfExtendedString): void;
  GetAlternativeDocument(aFormat: TCollection_ExtendedString, anAlternativeDocument: Handle_CDM_Document): Standard_Boolean;
  CreateReference_1(anOtherDocument: Handle_CDM_Document): Graphic3d_ZLayerId;
  RemoveReference(aReferenceIdentifier: Graphic3d_ZLayerId): void;
  RemoveAllReferences(): void;
  Document(aReferenceIdentifier: Graphic3d_ZLayerId): Handle_CDM_Document;
  IsInSession(aReferenceIdentifier: Graphic3d_ZLayerId): Standard_Boolean;
  IsStored_1(aReferenceIdentifier: Graphic3d_ZLayerId): Standard_Boolean;
  Name(aReferenceIdentifier: Graphic3d_ZLayerId): TCollection_ExtendedString;
  UpdateFromDocuments(aModifContext: Standard_Address): void;
  ToReferencesNumber(): Graphic3d_ZLayerId;
  FromReferencesNumber(): Graphic3d_ZLayerId;
  ShallowReferences(aDocument: Handle_CDM_Document): Standard_Boolean;
  DeepReferences(aDocument: Handle_CDM_Document): Standard_Boolean;
  CopyReference(aFromDocument: Handle_CDM_Document, aReferenceIdentifier: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsReadOnly_1(): Standard_Boolean;
  IsReadOnly_2(aReferenceIdentifier: Graphic3d_ZLayerId): Standard_Boolean;
  SetIsReadOnly(): void;
  UnsetIsReadOnly(): void;
  Modify(): void;
  Modifications(): Graphic3d_ZLayerId;
  UnModify(): void;
  IsUpToDate(aReferenceIdentifier: Graphic3d_ZLayerId): Standard_Boolean;
  SetIsUpToDate(aReferenceIdentifier: Graphic3d_ZLayerId): void;
  SetComment(aComment: TCollection_ExtendedString): void;
  AddComment(aComment: TCollection_ExtendedString): void;
  SetComments(aComments: TColStd_SequenceOfExtendedString): void;
  Comments(aComments: TColStd_SequenceOfExtendedString): void;
  Comment(): Standard_ExtString;
  IsStored_2(): Standard_Boolean;
  StorageVersion(): Graphic3d_ZLayerId;
  SetMetaData(aMetaData: Handle_CDM_MetaData): void;
  UnsetIsStored(): void;
  MetaData(): Handle_CDM_MetaData;
  Folder(): TCollection_ExtendedString;
  SetRequestedFolder(aFolder: TCollection_ExtendedString): void;
  RequestedFolder(): TCollection_ExtendedString;
  HasRequestedFolder(): Standard_Boolean;
  SetRequestedName(aName: TCollection_ExtendedString): void;
  RequestedName(): TCollection_ExtendedString;
  SetRequestedPreviousVersion(aPreviousVersion: TCollection_ExtendedString): void;
  UnsetRequestedPreviousVersion(): void;
  HasRequestedPreviousVersion(): Standard_Boolean;
  RequestedPreviousVersion(): TCollection_ExtendedString;
  SetRequestedComment(aComment: TCollection_ExtendedString): void;
  RequestedComment(): TCollection_ExtendedString;
  LoadResources(): void;
  FindFileExtension(): Standard_Boolean;
  FileExtension(): TCollection_ExtendedString;
  FindDescription(): Standard_Boolean;
  Description(): TCollection_ExtendedString;
  IsModified(): Standard_Boolean;
  IsOpened_1(): Standard_Boolean;
  Open(anApplication: Handle_CDM_Application): void;
  CanClose(): CDM_CanCloseStatus;
  Close(): void;
  Application(): Handle_CDM_Application;
  CanCloseReference(aDocument: Handle_CDM_Document, aReferenceIdentifier: Graphic3d_ZLayerId): Standard_Boolean;
  CloseReference(aDocument: Handle_CDM_Document, aReferenceIdentifier: Graphic3d_ZLayerId): void;
  IsOpened_2(aReferenceIdentifier: Graphic3d_ZLayerId): Standard_Boolean;
  CreateReference_2(aMetaData: Handle_CDM_MetaData, aReferenceIdentifier: Graphic3d_ZLayerId, anApplication: Handle_CDM_Application, aToDocumentVersion: Graphic3d_ZLayerId, UseStorageConfiguration: Standard_Boolean): void;
  CreateReference_3(aMetaData: Handle_CDM_MetaData, anApplication: Handle_CDM_Application, aDocumentVersion: Graphic3d_ZLayerId, UseStorageConfiguration: Standard_Boolean): Graphic3d_ZLayerId;
  ReferenceCounter(): Graphic3d_ZLayerId;
  Update_3(): void;
  Reference(aReferenceIdentifier: Graphic3d_ZLayerId): Handle_CDM_Reference;
  SetModifications(Modifications: Graphic3d_ZLayerId): void;
  SetReferenceCounter(aReferenceCounter: Graphic3d_ZLayerId): void;
  StorageFormatVersion(): Graphic3d_ZLayerId;
  ChangeStorageFormatVersion(theVersion: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_CDM_Document {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDM_Document): void;
  get(): CDM_Document;
  delete(): void;
}

  export declare class Handle_CDM_Document_1 extends Handle_CDM_Document {
    constructor();
  }

  export declare class Handle_CDM_Document_2 extends Handle_CDM_Document {
    constructor(thePtr: CDM_Document);
  }

  export declare class Handle_CDM_Document_3 extends Handle_CDM_Document {
    constructor(theHandle: Handle_CDM_Document);
  }

  export declare class Handle_CDM_Document_4 extends Handle_CDM_Document {
    constructor(theHandle: Handle_CDM_Document);
  }

export declare type CDM_CanCloseStatus = {
  CDM_CCS_OK: {};
  CDM_CCS_NotOpen: {};
  CDM_CCS_UnstoredReferenced: {};
  CDM_CCS_ModifiedReferenced: {};
  CDM_CCS_ReferenceRejection: {};
}

export declare class Handle_CDM_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDM_Application): void;
  get(): CDM_Application;
  delete(): void;
}

  export declare class Handle_CDM_Application_1 extends Handle_CDM_Application {
    constructor();
  }

  export declare class Handle_CDM_Application_2 extends Handle_CDM_Application {
    constructor(thePtr: CDM_Application);
  }

  export declare class Handle_CDM_Application_3 extends Handle_CDM_Application {
    constructor(theHandle: Handle_CDM_Application);
  }

  export declare class Handle_CDM_Application_4 extends Handle_CDM_Application {
    constructor(theHandle: Handle_CDM_Application);
  }

export declare class CDM_Application extends Standard_Transient {
  Resources(): Handle_Resource_Manager;
  MessageDriver(): Handle_Message_Messenger;
  BeginOfUpdate(aDocument: Handle_CDM_Document): void;
  EndOfUpdate(aDocument: Handle_CDM_Document, theStatus: Standard_Boolean, ErrorString: TCollection_ExtendedString): void;
  Write(aString: Standard_ExtString): void;
  Name(): TCollection_ExtendedString;
  Version(): XCAFDoc_PartId;
  MetaDataLookUpTable(): CDM_MetaDataLookUpTable;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_FlowLineSpec extends IGESData_IGESEntity {
  constructor()
  Init(allProperties: Handle_Interface_HArray1OfHAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  FlowLineName(): Handle_TCollection_HAsciiString;
  Modifier(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_FlowLineSpec {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_FlowLineSpec): void;
  get(): IGESAppli_FlowLineSpec;
  delete(): void;
}

  export declare class Handle_IGESAppli_FlowLineSpec_1 extends Handle_IGESAppli_FlowLineSpec {
    constructor();
  }

  export declare class Handle_IGESAppli_FlowLineSpec_2 extends Handle_IGESAppli_FlowLineSpec {
    constructor(thePtr: IGESAppli_FlowLineSpec);
  }

  export declare class Handle_IGESAppli_FlowLineSpec_3 extends Handle_IGESAppli_FlowLineSpec {
    constructor(theHandle: Handle_IGESAppli_FlowLineSpec);
  }

  export declare class Handle_IGESAppli_FlowLineSpec_4 extends Handle_IGESAppli_FlowLineSpec {
    constructor(theHandle: Handle_IGESAppli_FlowLineSpec);
  }

export declare class Handle_IGESAppli_PWBArtworkStackup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_PWBArtworkStackup): void;
  get(): IGESAppli_PWBArtworkStackup;
  delete(): void;
}

  export declare class Handle_IGESAppli_PWBArtworkStackup_1 extends Handle_IGESAppli_PWBArtworkStackup {
    constructor();
  }

  export declare class Handle_IGESAppli_PWBArtworkStackup_2 extends Handle_IGESAppli_PWBArtworkStackup {
    constructor(thePtr: IGESAppli_PWBArtworkStackup);
  }

  export declare class Handle_IGESAppli_PWBArtworkStackup_3 extends Handle_IGESAppli_PWBArtworkStackup {
    constructor(theHandle: Handle_IGESAppli_PWBArtworkStackup);
  }

  export declare class Handle_IGESAppli_PWBArtworkStackup_4 extends Handle_IGESAppli_PWBArtworkStackup {
    constructor(theHandle: Handle_IGESAppli_PWBArtworkStackup);
  }

export declare class IGESAppli_PWBArtworkStackup extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, anArtIdent: Handle_TCollection_HAsciiString, allLevelNums: Handle_TColStd_HArray1OfInteger): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  Identification(): Handle_TCollection_HAsciiString;
  NbLevelNumbers(): Graphic3d_ZLayerId;
  LevelNumber(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_ToolFlowLineSpec {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_FlowLineSpec, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_FlowLineSpec, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_FlowLineSpec, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_FlowLineSpec): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_FlowLineSpec, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_FlowLineSpec, entto: Handle_IGESAppli_FlowLineSpec, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_FlowLineSpec, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_PipingFlow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_PipingFlow): void;
  get(): IGESAppli_PipingFlow;
  delete(): void;
}

  export declare class Handle_IGESAppli_PipingFlow_1 extends Handle_IGESAppli_PipingFlow {
    constructor();
  }

  export declare class Handle_IGESAppli_PipingFlow_2 extends Handle_IGESAppli_PipingFlow {
    constructor(thePtr: IGESAppli_PipingFlow);
  }

  export declare class Handle_IGESAppli_PipingFlow_3 extends Handle_IGESAppli_PipingFlow {
    constructor(theHandle: Handle_IGESAppli_PipingFlow);
  }

  export declare class Handle_IGESAppli_PipingFlow_4 extends Handle_IGESAppli_PipingFlow {
    constructor(theHandle: Handle_IGESAppli_PipingFlow);
  }

export declare class IGESAppli_PipingFlow extends IGESData_IGESEntity {
  constructor()
  Init(nbContextFlags: Graphic3d_ZLayerId, aFlowType: Graphic3d_ZLayerId, allFlowAssocs: Handle_IGESData_HArray1OfIGESEntity, allConnectPoints: Handle_IGESDraw_HArray1OfConnectPoint, allJoins: Handle_IGESData_HArray1OfIGESEntity, allFlowNames: Handle_Interface_HArray1OfHAsciiString, allTextDisps: Handle_IGESGraph_HArray1OfTextDisplayTemplate, allContFlowAssocs: Handle_IGESData_HArray1OfIGESEntity): void;
  OwnCorrect(): Standard_Boolean;
  NbContextFlags(): Graphic3d_ZLayerId;
  NbFlowAssociativities(): Graphic3d_ZLayerId;
  NbConnectPoints(): Graphic3d_ZLayerId;
  NbJoins(): Graphic3d_ZLayerId;
  NbFlowNames(): Graphic3d_ZLayerId;
  NbTextDisplayTemplates(): Graphic3d_ZLayerId;
  NbContFlowAssociativities(): Graphic3d_ZLayerId;
  TypeOfFlow(): Graphic3d_ZLayerId;
  FlowAssociativity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  ConnectPoint(Index: Graphic3d_ZLayerId): Handle_IGESDraw_ConnectPoint;
  Join(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  FlowName(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  TextDisplayTemplate(Index: Graphic3d_ZLayerId): Handle_IGESGraph_TextDisplayTemplate;
  ContFlowAssociativity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_NodalConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_NodalConstraint): void;
  get(): IGESAppli_NodalConstraint;
  delete(): void;
}

  export declare class Handle_IGESAppli_NodalConstraint_1 extends Handle_IGESAppli_NodalConstraint {
    constructor();
  }

  export declare class Handle_IGESAppli_NodalConstraint_2 extends Handle_IGESAppli_NodalConstraint {
    constructor(thePtr: IGESAppli_NodalConstraint);
  }

  export declare class Handle_IGESAppli_NodalConstraint_3 extends Handle_IGESAppli_NodalConstraint {
    constructor(theHandle: Handle_IGESAppli_NodalConstraint);
  }

  export declare class Handle_IGESAppli_NodalConstraint_4 extends Handle_IGESAppli_NodalConstraint {
    constructor(theHandle: Handle_IGESAppli_NodalConstraint);
  }

export declare class IGESAppli_NodalConstraint extends IGESData_IGESEntity {
  constructor()
  Init(aType: Graphic3d_ZLayerId, aNode: Handle_IGESAppli_Node, allTabData: Handle_IGESDefs_HArray1OfTabularData): void;
  NbCases(): Graphic3d_ZLayerId;
  Type(): Graphic3d_ZLayerId;
  NodeEntity(): Handle_IGESAppli_Node;
  TabularData(Index: Graphic3d_ZLayerId): Handle_IGESDefs_TabularData;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_ToolDrilledHole {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_DrilledHole, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_DrilledHole, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_DrilledHole, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_DrilledHole): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_DrilledHole): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_DrilledHole, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_DrilledHole, entto: Handle_IGESAppli_DrilledHole, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_DrilledHole, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolNodalDisplAndRot {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_NodalDisplAndRot, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_NodalDisplAndRot, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_NodalDisplAndRot, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_NodalDisplAndRot): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_NodalDisplAndRot, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_NodalDisplAndRot, entto: Handle_IGESAppli_NodalDisplAndRot, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_NodalDisplAndRot, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_DrilledHole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_DrilledHole): void;
  get(): IGESAppli_DrilledHole;
  delete(): void;
}

  export declare class Handle_IGESAppli_DrilledHole_1 extends Handle_IGESAppli_DrilledHole {
    constructor();
  }

  export declare class Handle_IGESAppli_DrilledHole_2 extends Handle_IGESAppli_DrilledHole {
    constructor(thePtr: IGESAppli_DrilledHole);
  }

  export declare class Handle_IGESAppli_DrilledHole_3 extends Handle_IGESAppli_DrilledHole {
    constructor(theHandle: Handle_IGESAppli_DrilledHole);
  }

  export declare class Handle_IGESAppli_DrilledHole_4 extends Handle_IGESAppli_DrilledHole {
    constructor(theHandle: Handle_IGESAppli_DrilledHole);
  }

export declare class IGESAppli_DrilledHole extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aSize: Quantity_AbsorbedDose, anotherSize: Quantity_AbsorbedDose, aPlating: Graphic3d_ZLayerId, aLayer: Graphic3d_ZLayerId, anotherLayer: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  DrillDiaSize(): Quantity_AbsorbedDose;
  FinishDiaSize(): Quantity_AbsorbedDose;
  IsPlating(): Standard_Boolean;
  NbLowerLayer(): Graphic3d_ZLayerId;
  NbHigherLayer(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_PartNumber extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aGenName: Handle_TCollection_HAsciiString, aMilName: Handle_TCollection_HAsciiString, aVendName: Handle_TCollection_HAsciiString, anIntName: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  GenericNumber(): Handle_TCollection_HAsciiString;
  MilitaryNumber(): Handle_TCollection_HAsciiString;
  VendorNumber(): Handle_TCollection_HAsciiString;
  InternalNumber(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_PartNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_PartNumber): void;
  get(): IGESAppli_PartNumber;
  delete(): void;
}

  export declare class Handle_IGESAppli_PartNumber_1 extends Handle_IGESAppli_PartNumber {
    constructor();
  }

  export declare class Handle_IGESAppli_PartNumber_2 extends Handle_IGESAppli_PartNumber {
    constructor(thePtr: IGESAppli_PartNumber);
  }

  export declare class Handle_IGESAppli_PartNumber_3 extends Handle_IGESAppli_PartNumber {
    constructor(theHandle: Handle_IGESAppli_PartNumber);
  }

  export declare class Handle_IGESAppli_PartNumber_4 extends Handle_IGESAppli_PartNumber {
    constructor(theHandle: Handle_IGESAppli_PartNumber);
  }

export declare class Handle_IGESAppli_HArray1OfNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_HArray1OfNode): void;
  get(): IGESAppli_HArray1OfNode;
  delete(): void;
}

  export declare class Handle_IGESAppli_HArray1OfNode_1 extends Handle_IGESAppli_HArray1OfNode {
    constructor();
  }

  export declare class Handle_IGESAppli_HArray1OfNode_2 extends Handle_IGESAppli_HArray1OfNode {
    constructor(thePtr: IGESAppli_HArray1OfNode);
  }

  export declare class Handle_IGESAppli_HArray1OfNode_3 extends Handle_IGESAppli_HArray1OfNode {
    constructor(theHandle: Handle_IGESAppli_HArray1OfNode);
  }

  export declare class Handle_IGESAppli_HArray1OfNode_4 extends Handle_IGESAppli_HArray1OfNode {
    constructor(theHandle: Handle_IGESAppli_HArray1OfNode);
  }

export declare class IGESAppli_ToolNodalResults {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_NodalResults, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_NodalResults, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_NodalResults, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_NodalResults): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_NodalResults, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_NodalResults, entto: Handle_IGESAppli_NodalResults, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_NodalResults, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_Flow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_Flow): void;
  get(): IGESAppli_Flow;
  delete(): void;
}

  export declare class Handle_IGESAppli_Flow_1 extends Handle_IGESAppli_Flow {
    constructor();
  }

  export declare class Handle_IGESAppli_Flow_2 extends Handle_IGESAppli_Flow {
    constructor(thePtr: IGESAppli_Flow);
  }

  export declare class Handle_IGESAppli_Flow_3 extends Handle_IGESAppli_Flow {
    constructor(theHandle: Handle_IGESAppli_Flow);
  }

  export declare class Handle_IGESAppli_Flow_4 extends Handle_IGESAppli_Flow {
    constructor(theHandle: Handle_IGESAppli_Flow);
  }

export declare class IGESAppli_Flow extends IGESData_IGESEntity {
  constructor()
  Init(nbContextFlags: Graphic3d_ZLayerId, aFlowType: Graphic3d_ZLayerId, aFuncFlag: Graphic3d_ZLayerId, allFlowAssocs: Handle_IGESData_HArray1OfIGESEntity, allConnectPoints: Handle_IGESDraw_HArray1OfConnectPoint, allJoins: Handle_IGESData_HArray1OfIGESEntity, allFlowNames: Handle_Interface_HArray1OfHAsciiString, allTextDisps: Handle_IGESGraph_HArray1OfTextDisplayTemplate, allContFlowAssocs: Handle_IGESData_HArray1OfIGESEntity): void;
  OwnCorrect(): Standard_Boolean;
  NbContextFlags(): Graphic3d_ZLayerId;
  NbFlowAssociativities(): Graphic3d_ZLayerId;
  NbConnectPoints(): Graphic3d_ZLayerId;
  NbJoins(): Graphic3d_ZLayerId;
  NbFlowNames(): Graphic3d_ZLayerId;
  NbTextDisplayTemplates(): Graphic3d_ZLayerId;
  NbContFlowAssociativities(): Graphic3d_ZLayerId;
  TypeOfFlow(): Graphic3d_ZLayerId;
  FunctionFlag(): Graphic3d_ZLayerId;
  FlowAssociativity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  ConnectPoint(Index: Graphic3d_ZLayerId): Handle_IGESDraw_ConnectPoint;
  Join(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  FlowName(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  TextDisplayTemplate(Index: Graphic3d_ZLayerId): Handle_IGESGraph_TextDisplayTemplate;
  ContFlowAssociativity(Index: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_RegionRestriction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_RegionRestriction): void;
  get(): IGESAppli_RegionRestriction;
  delete(): void;
}

  export declare class Handle_IGESAppli_RegionRestriction_1 extends Handle_IGESAppli_RegionRestriction {
    constructor();
  }

  export declare class Handle_IGESAppli_RegionRestriction_2 extends Handle_IGESAppli_RegionRestriction {
    constructor(thePtr: IGESAppli_RegionRestriction);
  }

  export declare class Handle_IGESAppli_RegionRestriction_3 extends Handle_IGESAppli_RegionRestriction {
    constructor(theHandle: Handle_IGESAppli_RegionRestriction);
  }

  export declare class Handle_IGESAppli_RegionRestriction_4 extends Handle_IGESAppli_RegionRestriction {
    constructor(theHandle: Handle_IGESAppli_RegionRestriction);
  }

export declare class IGESAppli_RegionRestriction extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aViasRest: Graphic3d_ZLayerId, aCompoRest: Graphic3d_ZLayerId, aCktRest: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  ElectricalViasRestriction(): Graphic3d_ZLayerId;
  ElectricalComponentRestriction(): Graphic3d_ZLayerId;
  ElectricalCktRestriction(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_ToolPartNumber {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_PartNumber, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_PartNumber, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_PartNumber, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_PartNumber): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_PartNumber): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_PartNumber, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_PartNumber, entto: Handle_IGESAppli_PartNumber, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_PartNumber, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_LevelFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_LevelFunction): void;
  get(): IGESAppli_LevelFunction;
  delete(): void;
}

  export declare class Handle_IGESAppli_LevelFunction_1 extends Handle_IGESAppli_LevelFunction {
    constructor();
  }

  export declare class Handle_IGESAppli_LevelFunction_2 extends Handle_IGESAppli_LevelFunction {
    constructor(thePtr: IGESAppli_LevelFunction);
  }

  export declare class Handle_IGESAppli_LevelFunction_3 extends Handle_IGESAppli_LevelFunction {
    constructor(theHandle: Handle_IGESAppli_LevelFunction);
  }

  export declare class Handle_IGESAppli_LevelFunction_4 extends Handle_IGESAppli_LevelFunction {
    constructor(theHandle: Handle_IGESAppli_LevelFunction);
  }

export declare class IGESAppli_LevelFunction extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aCode: Graphic3d_ZLayerId, aFuncDescrip: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  FuncDescriptionCode(): Graphic3d_ZLayerId;
  FuncDescription(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_PinNumber extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aValue: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  PinNumberVal(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_PinNumber {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_PinNumber): void;
  get(): IGESAppli_PinNumber;
  delete(): void;
}

  export declare class Handle_IGESAppli_PinNumber_1 extends Handle_IGESAppli_PinNumber {
    constructor();
  }

  export declare class Handle_IGESAppli_PinNumber_2 extends Handle_IGESAppli_PinNumber {
    constructor(thePtr: IGESAppli_PinNumber);
  }

  export declare class Handle_IGESAppli_PinNumber_3 extends Handle_IGESAppli_PinNumber {
    constructor(theHandle: Handle_IGESAppli_PinNumber);
  }

  export declare class Handle_IGESAppli_PinNumber_4 extends Handle_IGESAppli_PinNumber {
    constructor(theHandle: Handle_IGESAppli_PinNumber);
  }

export declare class Handle_IGESAppli_NodalResults {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_NodalResults): void;
  get(): IGESAppli_NodalResults;
  delete(): void;
}

  export declare class Handle_IGESAppli_NodalResults_1 extends Handle_IGESAppli_NodalResults {
    constructor();
  }

  export declare class Handle_IGESAppli_NodalResults_2 extends Handle_IGESAppli_NodalResults {
    constructor(thePtr: IGESAppli_NodalResults);
  }

  export declare class Handle_IGESAppli_NodalResults_3 extends Handle_IGESAppli_NodalResults {
    constructor(theHandle: Handle_IGESAppli_NodalResults);
  }

  export declare class Handle_IGESAppli_NodalResults_4 extends Handle_IGESAppli_NodalResults {
    constructor(theHandle: Handle_IGESAppli_NodalResults);
  }

export declare class IGESAppli_NodalResults extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aNumber: Graphic3d_ZLayerId, aTime: Quantity_AbsorbedDose, allNodeIdentifiers: Handle_TColStd_HArray1OfInteger, allNodes: Handle_IGESAppli_HArray1OfNode, allData: Handle_TColStd_HArray2OfReal): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  Note(): Handle_IGESDimen_GeneralNote;
  SubCaseNumber(): Graphic3d_ZLayerId;
  Time(): Quantity_AbsorbedDose;
  NbData(): Graphic3d_ZLayerId;
  NbNodes(): Graphic3d_ZLayerId;
  NodeIdentifier(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Node(Index: Graphic3d_ZLayerId): Handle_IGESAppli_Node;
  Data(NodeNum: Graphic3d_ZLayerId, DataNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_ReadWriteModule): void;
  get(): IGESAppli_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESAppli_ReadWriteModule_1 extends Handle_IGESAppli_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESAppli_ReadWriteModule_2 extends Handle_IGESAppli_ReadWriteModule {
    constructor(thePtr: IGESAppli_ReadWriteModule);
  }

  export declare class Handle_IGESAppli_ReadWriteModule_3 extends Handle_IGESAppli_ReadWriteModule {
    constructor(theHandle: Handle_IGESAppli_ReadWriteModule);
  }

  export declare class Handle_IGESAppli_ReadWriteModule_4 extends Handle_IGESAppli_ReadWriteModule {
    constructor(theHandle: Handle_IGESAppli_ReadWriteModule);
  }

export declare class IGESAppli_ReadWriteModule extends IGESData_ReadWriteModule {
  constructor()
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_LevelToPWBLayerMap extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, allExchLevels: Handle_TColStd_HArray1OfInteger, allNativeLevels: Handle_Interface_HArray1OfHAsciiString, allPhysLevels: Handle_TColStd_HArray1OfInteger, allExchIdents: Handle_Interface_HArray1OfHAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  NbLevelToLayerDefs(): Graphic3d_ZLayerId;
  ExchangeFileLevelNumber(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NativeLevel(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  PhysicalLayerNumber(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ExchangeFileLevelIdent(Index: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_LevelToPWBLayerMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_LevelToPWBLayerMap): void;
  get(): IGESAppli_LevelToPWBLayerMap;
  delete(): void;
}

  export declare class Handle_IGESAppli_LevelToPWBLayerMap_1 extends Handle_IGESAppli_LevelToPWBLayerMap {
    constructor();
  }

  export declare class Handle_IGESAppli_LevelToPWBLayerMap_2 extends Handle_IGESAppli_LevelToPWBLayerMap {
    constructor(thePtr: IGESAppli_LevelToPWBLayerMap);
  }

  export declare class Handle_IGESAppli_LevelToPWBLayerMap_3 extends Handle_IGESAppli_LevelToPWBLayerMap {
    constructor(theHandle: Handle_IGESAppli_LevelToPWBLayerMap);
  }

  export declare class Handle_IGESAppli_LevelToPWBLayerMap_4 extends Handle_IGESAppli_LevelToPWBLayerMap {
    constructor(theHandle: Handle_IGESAppli_LevelToPWBLayerMap);
  }

export declare class IGESAppli_GeneralModule extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  CategoryNumber(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_GeneralModule): void;
  get(): IGESAppli_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESAppli_GeneralModule_1 extends Handle_IGESAppli_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESAppli_GeneralModule_2 extends Handle_IGESAppli_GeneralModule {
    constructor(thePtr: IGESAppli_GeneralModule);
  }

  export declare class Handle_IGESAppli_GeneralModule_3 extends Handle_IGESAppli_GeneralModule {
    constructor(theHandle: Handle_IGESAppli_GeneralModule);
  }

  export declare class Handle_IGESAppli_GeneralModule_4 extends Handle_IGESAppli_GeneralModule {
    constructor(theHandle: Handle_IGESAppli_GeneralModule);
  }

export declare class IGESAppli_ToolPWBDrilledHole {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_PWBDrilledHole, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_PWBDrilledHole, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_PWBDrilledHole, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_PWBDrilledHole): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_PWBDrilledHole): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_PWBDrilledHole, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_PWBDrilledHole, entto: Handle_IGESAppli_PWBDrilledHole, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_PWBDrilledHole, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolFiniteElement {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_FiniteElement, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_FiniteElement, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_FiniteElement, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_FiniteElement): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_FiniteElement, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_FiniteElement, entto: Handle_IGESAppli_FiniteElement, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_FiniteElement, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolNode {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_Node, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_Node, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_Node, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_Node): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_Node, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_Node, entto: Handle_IGESAppli_Node, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_Node, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_HArray1OfFlow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_HArray1OfFlow): void;
  get(): IGESAppli_HArray1OfFlow;
  delete(): void;
}

  export declare class Handle_IGESAppli_HArray1OfFlow_1 extends Handle_IGESAppli_HArray1OfFlow {
    constructor();
  }

  export declare class Handle_IGESAppli_HArray1OfFlow_2 extends Handle_IGESAppli_HArray1OfFlow {
    constructor(thePtr: IGESAppli_HArray1OfFlow);
  }

  export declare class Handle_IGESAppli_HArray1OfFlow_3 extends Handle_IGESAppli_HArray1OfFlow {
    constructor(theHandle: Handle_IGESAppli_HArray1OfFlow);
  }

  export declare class Handle_IGESAppli_HArray1OfFlow_4 extends Handle_IGESAppli_HArray1OfFlow {
    constructor(theHandle: Handle_IGESAppli_HArray1OfFlow);
  }

export declare class IGESAppli_ToolReferenceDesignator {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_ReferenceDesignator, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_ReferenceDesignator, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_ReferenceDesignator, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_ReferenceDesignator): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_ReferenceDesignator): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_ReferenceDesignator, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_ReferenceDesignator, entto: Handle_IGESAppli_ReferenceDesignator, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_ReferenceDesignator, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolElementResults {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_ElementResults, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_ElementResults, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_ElementResults, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_ElementResults): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_ElementResults, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_ElementResults, entto: Handle_IGESAppli_ElementResults, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_ElementResults, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_ElementResults {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_ElementResults): void;
  get(): IGESAppli_ElementResults;
  delete(): void;
}

  export declare class Handle_IGESAppli_ElementResults_1 extends Handle_IGESAppli_ElementResults {
    constructor();
  }

  export declare class Handle_IGESAppli_ElementResults_2 extends Handle_IGESAppli_ElementResults {
    constructor(thePtr: IGESAppli_ElementResults);
  }

  export declare class Handle_IGESAppli_ElementResults_3 extends Handle_IGESAppli_ElementResults {
    constructor(theHandle: Handle_IGESAppli_ElementResults);
  }

  export declare class Handle_IGESAppli_ElementResults_4 extends Handle_IGESAppli_ElementResults {
    constructor(theHandle: Handle_IGESAppli_ElementResults);
  }

export declare class IGESAppli_ElementResults extends IGESData_IGESEntity {
  constructor()
  Init(aNote: Handle_IGESDimen_GeneralNote, aSubCase: Graphic3d_ZLayerId, aTime: Quantity_AbsorbedDose, nbResults: Graphic3d_ZLayerId, aResRepFlag: Graphic3d_ZLayerId, allElementIdents: Handle_TColStd_HArray1OfInteger, allFiniteElems: Handle_IGESAppli_HArray1OfFiniteElement, allTopTypes: Handle_TColStd_HArray1OfInteger, nbLayers: Handle_TColStd_HArray1OfInteger, allDataLayerFlags: Handle_TColStd_HArray1OfInteger, allnbResDataLocs: Handle_TColStd_HArray1OfInteger, allResDataLocs: Handle_IGESBasic_HArray1OfHArray1OfInteger, allResults: Handle_IGESBasic_HArray1OfHArray1OfReal): void;
  SetFormNumber(form: Graphic3d_ZLayerId): void;
  Note(): Handle_IGESDimen_GeneralNote;
  SubCaseNumber(): Graphic3d_ZLayerId;
  Time(): Quantity_AbsorbedDose;
  NbResultValues(): Graphic3d_ZLayerId;
  ResultReportFlag(): Graphic3d_ZLayerId;
  NbElements(): Graphic3d_ZLayerId;
  ElementIdentifier(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Element(Index: Graphic3d_ZLayerId): Handle_IGESAppli_FiniteElement;
  ElementTopologyType(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbLayers(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  DataLayerFlag(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbResultDataLocs(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ResultDataLoc(NElem: Graphic3d_ZLayerId, NLoc: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbResults(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ResultData_1(NElem: Graphic3d_ZLayerId, num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ResultRank(NElem: Graphic3d_ZLayerId, NVal: Graphic3d_ZLayerId, NLay: Graphic3d_ZLayerId, NLoc: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ResultData_2(NElem: Graphic3d_ZLayerId, NVal: Graphic3d_ZLayerId, NLay: Graphic3d_ZLayerId, NLoc: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ResultList(NElem: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESAppli_ToolLevelFunction {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_LevelFunction, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_LevelFunction, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_LevelFunction, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_LevelFunction): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_LevelFunction): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_LevelFunction, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_LevelFunction, entto: Handle_IGESAppli_LevelFunction, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_LevelFunction, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolLevelToPWBLayerMap {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_LevelToPWBLayerMap, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_LevelToPWBLayerMap, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_LevelToPWBLayerMap, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_LevelToPWBLayerMap): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_LevelToPWBLayerMap, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_LevelToPWBLayerMap, entto: Handle_IGESAppli_LevelToPWBLayerMap, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_LevelToPWBLayerMap, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESAppli_Protocol;
  delete(): void;
}

export declare class IGESAppli_NodalDisplAndRot extends IGESData_IGESEntity {
  constructor()
  Init(allNotes: Handle_IGESDimen_HArray1OfGeneralNote, allIdentifiers: Handle_TColStd_HArray1OfInteger, allNodes: Handle_IGESAppli_HArray1OfNode, allRotParams: Handle_IGESBasic_HArray1OfHArray1OfXYZ, allTransParams: Handle_IGESBasic_HArray1OfHArray1OfXYZ): void;
  NbCases(): Graphic3d_ZLayerId;
  NbNodes(): Graphic3d_ZLayerId;
  Note(Index: Graphic3d_ZLayerId): Handle_IGESDimen_GeneralNote;
  NodeIdentifier(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Node(Index: Graphic3d_ZLayerId): Handle_IGESAppli_Node;
  TranslationParameter(NodeNum: Graphic3d_ZLayerId, CaseNum: Graphic3d_ZLayerId): gp_XYZ;
  RotationalParameter(NodeNum: Graphic3d_ZLayerId, CaseNum: Graphic3d_ZLayerId): gp_XYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_NodalDisplAndRot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_NodalDisplAndRot): void;
  get(): IGESAppli_NodalDisplAndRot;
  delete(): void;
}

  export declare class Handle_IGESAppli_NodalDisplAndRot_1 extends Handle_IGESAppli_NodalDisplAndRot {
    constructor();
  }

  export declare class Handle_IGESAppli_NodalDisplAndRot_2 extends Handle_IGESAppli_NodalDisplAndRot {
    constructor(thePtr: IGESAppli_NodalDisplAndRot);
  }

  export declare class Handle_IGESAppli_NodalDisplAndRot_3 extends Handle_IGESAppli_NodalDisplAndRot {
    constructor(theHandle: Handle_IGESAppli_NodalDisplAndRot);
  }

  export declare class Handle_IGESAppli_NodalDisplAndRot_4 extends Handle_IGESAppli_NodalDisplAndRot {
    constructor(theHandle: Handle_IGESAppli_NodalDisplAndRot);
  }

export declare class IGESAppli_ToolPinNumber {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_PinNumber, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_PinNumber, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_PinNumber, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_PinNumber): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_PinNumber): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_PinNumber, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_PinNumber, entto: Handle_IGESAppli_PinNumber, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_PinNumber, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolPipingFlow {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_PipingFlow, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_PipingFlow, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_PipingFlow, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_PipingFlow): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_PipingFlow): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_PipingFlow, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_PipingFlow, entto: Handle_IGESAppli_PipingFlow, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_PipingFlow, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ReferenceDesignator extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aText: Handle_TCollection_HAsciiString): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  RefDesignatorText(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_ReferenceDesignator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_ReferenceDesignator): void;
  get(): IGESAppli_ReferenceDesignator;
  delete(): void;
}

  export declare class Handle_IGESAppli_ReferenceDesignator_1 extends Handle_IGESAppli_ReferenceDesignator {
    constructor();
  }

  export declare class Handle_IGESAppli_ReferenceDesignator_2 extends Handle_IGESAppli_ReferenceDesignator {
    constructor(thePtr: IGESAppli_ReferenceDesignator);
  }

  export declare class Handle_IGESAppli_ReferenceDesignator_3 extends Handle_IGESAppli_ReferenceDesignator {
    constructor(theHandle: Handle_IGESAppli_ReferenceDesignator);
  }

  export declare class Handle_IGESAppli_ReferenceDesignator_4 extends Handle_IGESAppli_ReferenceDesignator {
    constructor(theHandle: Handle_IGESAppli_ReferenceDesignator);
  }

export declare class IGESAppli_ToolPWBArtworkStackup {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_PWBArtworkStackup, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_PWBArtworkStackup, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_PWBArtworkStackup, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_PWBArtworkStackup): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_PWBArtworkStackup, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_PWBArtworkStackup, entto: Handle_IGESAppli_PWBArtworkStackup, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_PWBArtworkStackup, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_IGESAppli_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_SpecificModule): void;
  get(): IGESAppli_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESAppli_SpecificModule_1 extends Handle_IGESAppli_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESAppli_SpecificModule_2 extends Handle_IGESAppli_SpecificModule {
    constructor(thePtr: IGESAppli_SpecificModule);
  }

  export declare class Handle_IGESAppli_SpecificModule_3 extends Handle_IGESAppli_SpecificModule {
    constructor(theHandle: Handle_IGESAppli_SpecificModule);
  }

  export declare class Handle_IGESAppli_SpecificModule_4 extends Handle_IGESAppli_SpecificModule {
    constructor(theHandle: Handle_IGESAppli_SpecificModule);
  }

export declare class IGESAppli_SpecificModule extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_FiniteElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_FiniteElement): void;
  get(): IGESAppli_FiniteElement;
  delete(): void;
}

  export declare class Handle_IGESAppli_FiniteElement_1 extends Handle_IGESAppli_FiniteElement {
    constructor();
  }

  export declare class Handle_IGESAppli_FiniteElement_2 extends Handle_IGESAppli_FiniteElement {
    constructor(thePtr: IGESAppli_FiniteElement);
  }

  export declare class Handle_IGESAppli_FiniteElement_3 extends Handle_IGESAppli_FiniteElement {
    constructor(theHandle: Handle_IGESAppli_FiniteElement);
  }

  export declare class Handle_IGESAppli_FiniteElement_4 extends Handle_IGESAppli_FiniteElement {
    constructor(theHandle: Handle_IGESAppli_FiniteElement);
  }

export declare class IGESAppli_FiniteElement extends IGESData_IGESEntity {
  constructor()
  Init(aType: Graphic3d_ZLayerId, allNodes: Handle_IGESAppli_HArray1OfNode, aName: Handle_TCollection_HAsciiString): void;
  Topology(): Graphic3d_ZLayerId;
  NbNodes(): Graphic3d_ZLayerId;
  Node(Index: Graphic3d_ZLayerId): Handle_IGESAppli_Node;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_Protocol): void;
  get(): IGESAppli_Protocol;
  delete(): void;
}

  export declare class Handle_IGESAppli_Protocol_1 extends Handle_IGESAppli_Protocol {
    constructor();
  }

  export declare class Handle_IGESAppli_Protocol_2 extends Handle_IGESAppli_Protocol {
    constructor(thePtr: IGESAppli_Protocol);
  }

  export declare class Handle_IGESAppli_Protocol_3 extends Handle_IGESAppli_Protocol {
    constructor(theHandle: Handle_IGESAppli_Protocol);
  }

  export declare class Handle_IGESAppli_Protocol_4 extends Handle_IGESAppli_Protocol {
    constructor(theHandle: Handle_IGESAppli_Protocol);
  }

export declare class IGESAppli_Protocol extends IGESData_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_HArray1OfFiniteElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_HArray1OfFiniteElement): void;
  get(): IGESAppli_HArray1OfFiniteElement;
  delete(): void;
}

  export declare class Handle_IGESAppli_HArray1OfFiniteElement_1 extends Handle_IGESAppli_HArray1OfFiniteElement {
    constructor();
  }

  export declare class Handle_IGESAppli_HArray1OfFiniteElement_2 extends Handle_IGESAppli_HArray1OfFiniteElement {
    constructor(thePtr: IGESAppli_HArray1OfFiniteElement);
  }

  export declare class Handle_IGESAppli_HArray1OfFiniteElement_3 extends Handle_IGESAppli_HArray1OfFiniteElement {
    constructor(theHandle: Handle_IGESAppli_HArray1OfFiniteElement);
  }

  export declare class Handle_IGESAppli_HArray1OfFiniteElement_4 extends Handle_IGESAppli_HArray1OfFiniteElement {
    constructor(theHandle: Handle_IGESAppli_HArray1OfFiniteElement);
  }

export declare class IGESAppli_ToolRegionRestriction {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_RegionRestriction, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_RegionRestriction, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_RegionRestriction, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_RegionRestriction): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_RegionRestriction): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_RegionRestriction, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_RegionRestriction, entto: Handle_IGESAppli_RegionRestriction, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_RegionRestriction, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolFlow {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_Flow, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_Flow, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_Flow, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_Flow): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_Flow): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_Flow, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_Flow, entto: Handle_IGESAppli_Flow, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_Flow, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_Node extends IGESData_IGESEntity {
  constructor()
  Init(aCoord: gp_XYZ, aCoordSystem: Handle_IGESGeom_TransformationMatrix): void;
  Coord(): gp_Pnt;
  System(): Handle_IGESData_TransfEntity;
  SystemType(): Graphic3d_ZLayerId;
  TransformedNodalCoord(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_Node {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_Node): void;
  get(): IGESAppli_Node;
  delete(): void;
}

  export declare class Handle_IGESAppli_Node_1 extends Handle_IGESAppli_Node {
    constructor();
  }

  export declare class Handle_IGESAppli_Node_2 extends Handle_IGESAppli_Node {
    constructor(thePtr: IGESAppli_Node);
  }

  export declare class Handle_IGESAppli_Node_3 extends Handle_IGESAppli_Node {
    constructor(theHandle: Handle_IGESAppli_Node);
  }

  export declare class Handle_IGESAppli_Node_4 extends Handle_IGESAppli_Node {
    constructor(theHandle: Handle_IGESAppli_Node);
  }

export declare class IGESAppli_ToolLineWidening {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_LineWidening, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_LineWidening, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_LineWidening, iter: Interface_EntityIterator): void;
  OwnCorrect(ent: Handle_IGESAppli_LineWidening): Standard_Boolean;
  DirChecker(ent: Handle_IGESAppli_LineWidening): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_LineWidening, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_LineWidening, entto: Handle_IGESAppli_LineWidening, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_LineWidening, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_ToolNodalConstraint {
  constructor()
  ReadOwnParams(ent: Handle_IGESAppli_NodalConstraint, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(ent: Handle_IGESAppli_NodalConstraint, IW: IGESData_IGESWriter): void;
  OwnShared(ent: Handle_IGESAppli_NodalConstraint, iter: Interface_EntityIterator): void;
  DirChecker(ent: Handle_IGESAppli_NodalConstraint): IGESData_DirChecker;
  OwnCheck(ent: Handle_IGESAppli_NodalConstraint, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  OwnCopy(entfrom: Handle_IGESAppli_NodalConstraint, entto: Handle_IGESAppli_NodalConstraint, TC: Interface_CopyTool): void;
  OwnDump(ent: Handle_IGESAppli_NodalConstraint, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESAppli_PWBDrilledHole extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aDrillDia: Quantity_AbsorbedDose, aFinishDia: Quantity_AbsorbedDose, aCode: Graphic3d_ZLayerId): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  DrillDiameterSize(): Quantity_AbsorbedDose;
  FinishDiameterSize(): Quantity_AbsorbedDose;
  FunctionCode(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_PWBDrilledHole {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_PWBDrilledHole): void;
  get(): IGESAppli_PWBDrilledHole;
  delete(): void;
}

  export declare class Handle_IGESAppli_PWBDrilledHole_1 extends Handle_IGESAppli_PWBDrilledHole {
    constructor();
  }

  export declare class Handle_IGESAppli_PWBDrilledHole_2 extends Handle_IGESAppli_PWBDrilledHole {
    constructor(thePtr: IGESAppli_PWBDrilledHole);
  }

  export declare class Handle_IGESAppli_PWBDrilledHole_3 extends Handle_IGESAppli_PWBDrilledHole {
    constructor(theHandle: Handle_IGESAppli_PWBDrilledHole);
  }

  export declare class Handle_IGESAppli_PWBDrilledHole_4 extends Handle_IGESAppli_PWBDrilledHole {
    constructor(theHandle: Handle_IGESAppli_PWBDrilledHole);
  }

export declare class IGESAppli_LineWidening extends IGESData_IGESEntity {
  constructor()
  Init(nbPropVal: Graphic3d_ZLayerId, aWidth: Quantity_AbsorbedDose, aCornering: Graphic3d_ZLayerId, aExtnFlag: Graphic3d_ZLayerId, aJustifFlag: Graphic3d_ZLayerId, aExtnVal: Quantity_AbsorbedDose): void;
  NbPropertyValues(): Graphic3d_ZLayerId;
  WidthOfMetalization(): Quantity_AbsorbedDose;
  CorneringCode(): Graphic3d_ZLayerId;
  ExtensionFlag(): Graphic3d_ZLayerId;
  JustificationFlag(): Graphic3d_ZLayerId;
  ExtensionValue(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESAppli_LineWidening {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESAppli_LineWidening): void;
  get(): IGESAppli_LineWidening;
  delete(): void;
}

  export declare class Handle_IGESAppli_LineWidening_1 extends Handle_IGESAppli_LineWidening {
    constructor();
  }

  export declare class Handle_IGESAppli_LineWidening_2 extends Handle_IGESAppli_LineWidening {
    constructor(thePtr: IGESAppli_LineWidening);
  }

  export declare class Handle_IGESAppli_LineWidening_3 extends Handle_IGESAppli_LineWidening {
    constructor(theHandle: Handle_IGESAppli_LineWidening);
  }

  export declare class Handle_IGESAppli_LineWidening_4 extends Handle_IGESAppli_LineWidening {
    constructor(theHandle: Handle_IGESAppli_LineWidening);
  }

export declare class TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo): void;
  Assign(theOther: TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo): TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopOpeBRepBuild_VertexInfo): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopOpeBRepBuild_VertexInfo): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopOpeBRepBuild_VertexInfo;
  ChangeFromIndex(theIndex: Standard_Integer): TopOpeBRepBuild_VertexInfo;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopOpeBRepBuild_VertexInfo;
  Seek(theKey1: TopoDS_Shape): TopOpeBRepBuild_VertexInfo;
  ChangeSeek(theKey1: TopoDS_Shape): TopOpeBRepBuild_VertexInfo;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_1 extends TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo {
    constructor();
  }

  export declare class TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_2 extends TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_3 extends TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo {
    constructor(theOther: TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo);
  }

export declare class TopOpeBRepBuild_HBuilder extends Standard_Transient {
  constructor(BT: TopOpeBRepDS_BuildTool)
  BuildTool(): TopOpeBRepDS_BuildTool;
  Perform_1(HDS: Handle_TopOpeBRepDS_HDataStructure): void;
  Perform_2(HDS: Handle_TopOpeBRepDS_HDataStructure, S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  Clear(): void;
  DataStructure(): Handle_TopOpeBRepDS_HDataStructure;
  ChangeBuildTool(): TopOpeBRepDS_BuildTool;
  MergeShapes(S1: TopoDS_Shape, TB1: TopAbs_State, S2: TopoDS_Shape, TB2: TopAbs_State): void;
  MergeSolids(S1: TopoDS_Shape, TB1: TopAbs_State, S2: TopoDS_Shape, TB2: TopAbs_State): void;
  MergeSolid(S: TopoDS_Shape, TB: TopAbs_State): void;
  IsSplit(S: TopoDS_Shape, ToBuild: TopAbs_State): Standard_Boolean;
  Splits(S: TopoDS_Shape, ToBuild: TopAbs_State): TopTools_ListOfShape;
  IsMerged(S: TopoDS_Shape, ToBuild: TopAbs_State): Standard_Boolean;
  Merged(S: TopoDS_Shape, ToBuild: TopAbs_State): TopTools_ListOfShape;
  NewVertex(I: Graphic3d_ZLayerId): TopoDS_Shape;
  NewEdges(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  ChangeNewEdges(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  NewFaces(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  Section(): TopTools_ListOfShape;
  InitExtendedSectionDS(k: Graphic3d_ZLayerId): void;
  InitSection(k: Graphic3d_ZLayerId): void;
  MoreSection(): Standard_Boolean;
  NextSection(): void;
  CurrentSection(): TopoDS_Shape;
  GetDSEdgeFromSectEdge(E: TopoDS_Shape, rank: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetDSFaceFromDSEdge(indexEdg: Graphic3d_ZLayerId, rank: Graphic3d_ZLayerId): TColStd_ListOfInteger;
  GetDSCurveFromSectEdge(SectEdge: TopoDS_Shape): Graphic3d_ZLayerId;
  GetDSFaceFromDSCurve(indexCur: Graphic3d_ZLayerId, rank: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetDSPointFromNewVertex(NewVert: TopoDS_Shape): Graphic3d_ZLayerId;
  EdgeCurveAncestors(E: TopoDS_Shape, F1: TopoDS_Shape, F2: TopoDS_Shape, IC: Graphic3d_ZLayerId): Standard_Boolean;
  EdgeSectionAncestors(E: TopoDS_Shape, LF1: TopTools_ListOfShape, LF2: TopTools_ListOfShape, LE1: TopTools_ListOfShape, LE2: TopTools_ListOfShape): Standard_Boolean;
  IsKPart(): Graphic3d_ZLayerId;
  MergeKPart(TB1: TopAbs_State, TB2: TopAbs_State): void;
  ChangeBuilder(): TopOpeBRepBuild_Builder;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopOpeBRepBuild_HBuilder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepBuild_HBuilder): void;
  get(): TopOpeBRepBuild_HBuilder;
  delete(): void;
}

  export declare class Handle_TopOpeBRepBuild_HBuilder_1 extends Handle_TopOpeBRepBuild_HBuilder {
    constructor();
  }

  export declare class Handle_TopOpeBRepBuild_HBuilder_2 extends Handle_TopOpeBRepBuild_HBuilder {
    constructor(thePtr: TopOpeBRepBuild_HBuilder);
  }

  export declare class Handle_TopOpeBRepBuild_HBuilder_3 extends Handle_TopOpeBRepBuild_HBuilder {
    constructor(theHandle: Handle_TopOpeBRepBuild_HBuilder);
  }

  export declare class Handle_TopOpeBRepBuild_HBuilder_4 extends Handle_TopOpeBRepBuild_HBuilder {
    constructor(theHandle: Handle_TopOpeBRepBuild_HBuilder);
  }

export declare class TopOpeBRepBuild_WireEdgeSet extends TopOpeBRepBuild_ShapeSet {
  constructor(F: TopoDS_Shape, Addr: Standard_Address)
  Face(): TopoDS_Face;
  AddShape(S: TopoDS_Shape): void;
  AddStartElement(S: TopoDS_Shape): void;
  AddElement(S: TopoDS_Shape): void;
  InitNeighbours(E: TopoDS_Shape): void;
  FindNeighbours(): void;
  MakeNeighboursList(E: TopoDS_Shape, V: TopoDS_Shape): TopTools_ListOfShape;
  static IsUVISO(E: TopoDS_Edge, F: TopoDS_Face, uiso: Standard_Boolean, viso: Standard_Boolean): void;
  DumpSS(): void;
  SName_1(S: TopoDS_Shape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SName_2(S: TopTools_ListOfShape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SNameori_1(S: TopoDS_Shape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SNameori_2(S: TopTools_ListOfShape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  delete(): void;
}

export declare class TopOpeBRepBuild_Area3dBuilder extends TopOpeBRepBuild_AreaBuilder {
  InitAreaBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_Area3dBuilder_1 extends TopOpeBRepBuild_Area3dBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_Area3dBuilder_2 extends TopOpeBRepBuild_Area3dBuilder {
    constructor(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_Area1dBuilder extends TopOpeBRepBuild_AreaBuilder {
  InitAreaBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  ADD_Loop_TO_LISTOFLoop(L: Handle_TopOpeBRepBuild_Loop, LOL: TopOpeBRepBuild_ListOfLoop, s: Standard_Address): void;
  REM_Loop_FROM_LISTOFLoop(ITLOL: TopOpeBRepBuild_ListIteratorOfListOfLoop, LOL: TopOpeBRepBuild_ListOfLoop, s: Standard_Address): void;
  ADD_LISTOFLoop_TO_LISTOFLoop(LOL1: TopOpeBRepBuild_ListOfLoop, LOL2: TopOpeBRepBuild_ListOfLoop, s: Standard_Address, s1: Standard_Address, s2: Standard_Address): void;
  static DumpList(L: TopOpeBRepBuild_ListOfLoop): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_Area1dBuilder_1 extends TopOpeBRepBuild_Area1dBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_Area1dBuilder_2 extends TopOpeBRepBuild_Area1dBuilder {
    constructor(LS: TopOpeBRepBuild_PaveSet, LC: TopOpeBRepBuild_PaveClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_BlockIterator {
  Initialize(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Graphic3d_ZLayerId;
  Extent(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepBuild_BlockIterator_1 extends TopOpeBRepBuild_BlockIterator {
    constructor();
  }

  export declare class TopOpeBRepBuild_BlockIterator_2 extends TopOpeBRepBuild_BlockIterator {
    constructor(Lower: Graphic3d_ZLayerId, Upper: Graphic3d_ZLayerId);
  }

export declare class TopOpeBRepBuild_LoopClassifier {
  Compare(L1: Handle_TopOpeBRepBuild_Loop, L2: Handle_TopOpeBRepBuild_Loop): TopAbs_State;
  delete(): void;
}

export declare class TopOpeBRepBuild_BlockBuilder {
  MakeBlock(SS: TopOpeBRepBuild_ShapeSet): void;
  InitBlock(): void;
  MoreBlock(): Standard_Boolean;
  NextBlock(): void;
  BlockIterator(): TopOpeBRepBuild_BlockIterator;
  Element_1(BI: TopOpeBRepBuild_BlockIterator): TopoDS_Shape;
  Element_2(I: Graphic3d_ZLayerId): TopoDS_Shape;
  Element_3(S: TopoDS_Shape): Graphic3d_ZLayerId;
  ElementIsValid_1(BI: TopOpeBRepBuild_BlockIterator): Standard_Boolean;
  ElementIsValid_2(I: Graphic3d_ZLayerId): Standard_Boolean;
  AddElement(S: TopoDS_Shape): Graphic3d_ZLayerId;
  SetValid_1(BI: TopOpeBRepBuild_BlockIterator, isvalid: Standard_Boolean): void;
  SetValid_2(I: Graphic3d_ZLayerId, isvalid: Standard_Boolean): void;
  CurrentBlockIsRegular(): Standard_Boolean;
  delete(): void;
}

  export declare class TopOpeBRepBuild_BlockBuilder_1 extends TopOpeBRepBuild_BlockBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_BlockBuilder_2 extends TopOpeBRepBuild_BlockBuilder {
    constructor(SS: TopOpeBRepBuild_ShapeSet);
  }

export declare class TopOpeBRepBuild_VertexInfo {
  constructor()
  SetVertex(aV: TopoDS_Vertex): void;
  Vertex(): TopoDS_Vertex;
  SetSmart(aFlag: Standard_Boolean): void;
  Smart(): Standard_Boolean;
  NbCases(): Graphic3d_ZLayerId;
  FoundOut(): Graphic3d_ZLayerId;
  AddIn(anE: TopoDS_Edge): void;
  AddOut(anE: TopoDS_Edge): void;
  SetCurrentIn(anE: TopoDS_Edge): void;
  EdgesIn(): TopTools_IndexedMapOfOrientedShape;
  EdgesOut(): TopTools_IndexedMapOfOrientedShape;
  ChangeEdgesOut(): TopTools_IndexedMapOfOrientedShape;
  Dump(): void;
  CurrentOut(): TopoDS_Edge;
  AppendPassed(anE: TopoDS_Edge): void;
  RemovePassed(): void;
  ListPassed(): TopTools_ListOfShape;
  Prepare(aL: TopTools_ListOfShape): void;
  delete(): void;
}

export declare class TopOpeBRepBuild_GTopo {
  Reset(): void;
  Set(II: Standard_Boolean, IN: Standard_Boolean, IO: Standard_Boolean, NI: Standard_Boolean, NN: Standard_Boolean, NO: Standard_Boolean, OI: Standard_Boolean, ON: Standard_Boolean, OO: Standard_Boolean): void;
  Type(t1: TopAbs_ShapeEnum, t2: TopAbs_ShapeEnum): void;
  ChangeType(t1: TopAbs_ShapeEnum, t2: TopAbs_ShapeEnum): void;
  Config1(): TopOpeBRepDS_Config;
  Config2(): TopOpeBRepDS_Config;
  ChangeConfig(C1: TopOpeBRepDS_Config, C2: TopOpeBRepDS_Config): void;
  Value_1(s1: TopAbs_State, s2: TopAbs_State): Standard_Boolean;
  Value_2(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): Standard_Boolean;
  Value_3(II: Graphic3d_ZLayerId): Standard_Boolean;
  ChangeValue_1(i1: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId, b: Standard_Boolean): void;
  ChangeValue_2(s1: TopAbs_State, s2: TopAbs_State, b: Standard_Boolean): void;
  GIndex(S: TopAbs_State): Graphic3d_ZLayerId;
  GState(I: Graphic3d_ZLayerId): TopAbs_State;
  Index(II: Graphic3d_ZLayerId, i1: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId): void;
  DumpVal(OS: Standard_OStream, s1: TopAbs_State, s2: TopAbs_State): void;
  DumpType(OS: Standard_OStream): void;
  static DumpSSB(OS: Standard_OStream, s1: TopAbs_State, s2: TopAbs_State, b: Standard_Boolean): void;
  Dump(OS: Standard_OStream, s: Standard_Address): void;
  StatesON(s1: TopAbs_State, s2: TopAbs_State): void;
  IsToReverse1(): Standard_Boolean;
  IsToReverse2(): Standard_Boolean;
  SetReverse(rev: Standard_Boolean): void;
  Reverse(): Standard_Boolean;
  CopyPermuted(): TopOpeBRepBuild_GTopo;
  delete(): void;
}

  export declare class TopOpeBRepBuild_GTopo_1 extends TopOpeBRepBuild_GTopo {
    constructor();
  }

  export declare class TopOpeBRepBuild_GTopo_2 extends TopOpeBRepBuild_GTopo {
    constructor(II: Standard_Boolean, IN: Standard_Boolean, IO: Standard_Boolean, NI: Standard_Boolean, NN: Standard_Boolean, NO: Standard_Boolean, OI: Standard_Boolean, ON: Standard_Boolean, OO: Standard_Boolean, t1: TopAbs_ShapeEnum, t2: TopAbs_ShapeEnum, C1: TopOpeBRepDS_Config, C2: TopOpeBRepDS_Config);
  }

export declare class TopOpeBRepBuild_ShellToSolid {
  constructor()
  Init(): void;
  AddShell(Sh: TopoDS_Shell): void;
  MakeSolids(So: TopoDS_Solid, LSo: TopTools_ListOfShape): void;
  delete(): void;
}

export declare class TopOpeBRepBuild_WireEdgeClassifier extends TopOpeBRepBuild_CompositeClassifier {
  constructor(F: TopoDS_Shape, BB: TopOpeBRepBuild_BlockBuilder)
  Compare(L1: Handle_TopOpeBRepBuild_Loop, L2: Handle_TopOpeBRepBuild_Loop): TopAbs_State;
  LoopToShape(L: Handle_TopOpeBRepBuild_Loop): TopoDS_Shape;
  CompareShapes(B1: TopoDS_Shape, B2: TopoDS_Shape): TopAbs_State;
  CompareElementToShape(E: TopoDS_Shape, B: TopoDS_Shape): TopAbs_State;
  ResetShape(B: TopoDS_Shape): void;
  ResetElement(E: TopoDS_Shape): void;
  CompareElement(E: TopoDS_Shape): Standard_Boolean;
  State(): TopAbs_State;
  delete(): void;
}

export declare class TopOpeBRepBuild_FaceBuilder {
  InitFaceBuilder(ES: TopOpeBRepBuild_WireEdgeSet, F: TopoDS_Shape, ForceClass: Standard_Boolean): void;
  DetectUnclosedWire(mapVVsameG: TopTools_IndexedDataMapOfShapeShape, mapVon1Edge: TopTools_IndexedDataMapOfShapeShape): void;
  CorrectGclosedWire(mapVVref: TopTools_IndexedDataMapOfShapeShape, mapVon1Edge: TopTools_IndexedDataMapOfShapeShape): void;
  DetectPseudoInternalEdge(mapE: TopTools_IndexedMapOfShape): void;
  Face(): TopoDS_Shape;
  InitFace(): Graphic3d_ZLayerId;
  MoreFace(): Standard_Boolean;
  NextFace(): void;
  InitWire(): Graphic3d_ZLayerId;
  MoreWire(): Standard_Boolean;
  NextWire(): void;
  IsOldWire(): Standard_Boolean;
  OldWire(): TopoDS_Shape;
  FindNextValidElement(): void;
  InitEdge(): Graphic3d_ZLayerId;
  MoreEdge(): Standard_Boolean;
  NextEdge(): void;
  Edge(): TopoDS_Shape;
  EdgeConnexity(E: TopoDS_Shape): Graphic3d_ZLayerId;
  AddEdgeWire(E: TopoDS_Shape, W: TopoDS_Shape): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TopOpeBRepBuild_FaceBuilder_1 extends TopOpeBRepBuild_FaceBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_FaceBuilder_2 extends TopOpeBRepBuild_FaceBuilder {
    constructor(ES: TopOpeBRepBuild_WireEdgeSet, F: TopoDS_Shape, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_GTool {
  constructor();
  static GFusUnsh(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GFusSame(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GFusDiff(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GCutUnsh(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GCutSame(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GCutDiff(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GComUnsh(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GComSame(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static GComDiff(s1: TopAbs_ShapeEnum, s2: TopAbs_ShapeEnum): TopOpeBRepBuild_GTopo;
  static Dump(OS: Standard_OStream): void;
  delete(): void;
}

export declare class TopOpeBRepBuild_BuilderON {
  Perform(PB: TopOpeBRepBuild_PBuilder, F: TopoDS_Shape, PG: TopOpeBRepBuild_PGTopo, PLSclass: TopOpeBRepTool_Plos, PWES: TopOpeBRepBuild_PWireEdgeSet): void;
  GFillONCheckI(I: Handle_TopOpeBRepDS_Interference): Standard_Boolean;
  GFillONPartsWES1(I: Handle_TopOpeBRepDS_Interference): void;
  GFillONPartsWES2(I: Handle_TopOpeBRepDS_Interference, EspON: TopoDS_Shape): void;
  Perform2d(PB: TopOpeBRepBuild_PBuilder, F: TopoDS_Shape, PG: TopOpeBRepBuild_PGTopo, PLSclass: TopOpeBRepTool_Plos, PWES: TopOpeBRepBuild_PWireEdgeSet): void;
  GFillONParts2dWES2(I: Handle_TopOpeBRepDS_Interference, EspON: TopoDS_Shape): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_BuilderON_1 extends TopOpeBRepBuild_BuilderON {
    constructor();
  }

  export declare class TopOpeBRepBuild_BuilderON_2 extends TopOpeBRepBuild_BuilderON {
    constructor(PB: TopOpeBRepBuild_PBuilder, F: TopoDS_Shape, PG: TopOpeBRepBuild_PGTopo, PLSclass: TopOpeBRepTool_Plos, PWES: TopOpeBRepBuild_PWireEdgeSet);
  }

export declare class TopOpeBRepBuild_Tools2d {
  constructor();
  static MakeMapOfShapeVertexInfo(aWire: TopoDS_Wire, aMap: TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo): void;
  static DumpMapOfShapeVertexInfo(aMap: TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo): void;
  static Path(aWire: TopoDS_Wire, aResList: TopTools_ListOfShape): void;
  delete(): void;
}

export declare class TopOpeBRepBuild_FaceAreaBuilder extends TopOpeBRepBuild_Area2dBuilder {
  InitFaceAreaBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_FaceAreaBuilder_1 extends TopOpeBRepBuild_FaceAreaBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_FaceAreaBuilder_2 extends TopOpeBRepBuild_FaceAreaBuilder {
    constructor(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_CorrectFace2d {
  Face(): TopoDS_Face;
  Perform(): void;
  IsDone(): Standard_Boolean;
  ErrorStatus(): Graphic3d_ZLayerId;
  CorrectedFace(): TopoDS_Face;
  SetMapOfTrans2dInfo(aMap: TopTools_IndexedDataMapOfShapeShape): void;
  MapOfTrans2dInfo(): TopTools_IndexedDataMapOfShapeShape;
  static GetP2dFL(aFace: TopoDS_Face, anEdge: TopoDS_Edge, P2dF: gp_Pnt2d, P2dL: gp_Pnt2d): void;
  static CheckList(aFace: TopoDS_Face, aHeadList: TopTools_ListOfShape): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_CorrectFace2d_1 extends TopOpeBRepBuild_CorrectFace2d {
    constructor();
  }

  export declare class TopOpeBRepBuild_CorrectFace2d_2 extends TopOpeBRepBuild_CorrectFace2d {
    constructor(aFace: TopoDS_Face, anAvoidMap: TopTools_IndexedMapOfOrientedShape, aMap: TopTools_IndexedDataMapOfShapeShape);
  }

export declare class TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape): void;
  Assign(theOther: TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape): TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopOpeBRepBuild_ListOfShapeListOfShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopOpeBRepBuild_ListOfShapeListOfShape): TopOpeBRepBuild_ListOfShapeListOfShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopOpeBRepBuild_ListOfShapeListOfShape;
  ChangeSeek(theKey: TopoDS_Shape): TopOpeBRepBuild_ListOfShapeListOfShape;
  ChangeFind(theKey: TopoDS_Shape): TopOpeBRepBuild_ListOfShapeListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_1 extends TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape {
    constructor();
  }

  export declare class TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_2 extends TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_3 extends TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape {
    constructor(theOther: TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape);
  }

export declare class TopOpeBRepBuild_EdgeBuilder extends TopOpeBRepBuild_Area1dBuilder {
  InitEdgeBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  InitEdge(): void;
  MoreEdge(): Standard_Boolean;
  NextEdge(): void;
  InitVertex(): void;
  MoreVertex(): Standard_Boolean;
  NextVertex(): void;
  Vertex(): TopoDS_Shape;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class TopOpeBRepBuild_EdgeBuilder_1 extends TopOpeBRepBuild_EdgeBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_EdgeBuilder_2 extends TopOpeBRepBuild_EdgeBuilder {
    constructor(LS: TopOpeBRepBuild_PaveSet, LC: TopOpeBRepBuild_PaveClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_ShellFaceClassifier extends TopOpeBRepBuild_CompositeClassifier {
  constructor(BB: TopOpeBRepBuild_BlockBuilder)
  Clear(): void;
  CompareShapes(B1: TopoDS_Shape, B2: TopoDS_Shape): TopAbs_State;
  CompareElementToShape(F: TopoDS_Shape, S: TopoDS_Shape): TopAbs_State;
  ResetShape(S: TopoDS_Shape): void;
  ResetElement(F: TopoDS_Shape): void;
  CompareElement(F: TopoDS_Shape): Standard_Boolean;
  State(): TopAbs_State;
  delete(): void;
}

export declare class TopOpeBRepBuild_CompositeClassifier extends TopOpeBRepBuild_LoopClassifier {
  Compare(L1: Handle_TopOpeBRepBuild_Loop, L2: Handle_TopOpeBRepBuild_Loop): TopAbs_State;
  CompareShapes(B1: TopoDS_Shape, B2: TopoDS_Shape): TopAbs_State;
  CompareElementToShape(E: TopoDS_Shape, B: TopoDS_Shape): TopAbs_State;
  ResetShape(B: TopoDS_Shape): void;
  ResetElement(E: TopoDS_Shape): void;
  CompareElement(E: TopoDS_Shape): Standard_Boolean;
  State(): TopAbs_State;
  delete(): void;
}

export declare class TopOpeBRepBuild_ListOfShapeListOfShape extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopOpeBRepBuild_ListOfShapeListOfShape): TopOpeBRepBuild_ListOfShapeListOfShape;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopOpeBRepBuild_ShapeListOfShape;
  First_2(): TopOpeBRepBuild_ShapeListOfShape;
  Last_1(): TopOpeBRepBuild_ShapeListOfShape;
  Last_2(): TopOpeBRepBuild_ShapeListOfShape;
  Append_1(theItem: TopOpeBRepBuild_ShapeListOfShape): TopOpeBRepBuild_ShapeListOfShape;
  Append_3(theOther: TopOpeBRepBuild_ListOfShapeListOfShape): void;
  Prepend_1(theItem: TopOpeBRepBuild_ShapeListOfShape): TopOpeBRepBuild_ShapeListOfShape;
  Prepend_2(theOther: TopOpeBRepBuild_ListOfShapeListOfShape): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_ListOfShapeListOfShape_1 extends TopOpeBRepBuild_ListOfShapeListOfShape {
    constructor();
  }

  export declare class TopOpeBRepBuild_ListOfShapeListOfShape_2 extends TopOpeBRepBuild_ListOfShapeListOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepBuild_ListOfShapeListOfShape_3 extends TopOpeBRepBuild_ListOfShapeListOfShape {
    constructor(theOther: TopOpeBRepBuild_ListOfShapeListOfShape);
  }

export declare class TopOpeBRepBuild_Tools {
  constructor();
  static FindState(aVertex: TopoDS_Shape, aState: TopAbs_State, aShapeEnum: TopAbs_ShapeEnum, aMapVertexEdges: TopTools_IndexedDataMapOfShapeListOfShape, aMapProcessedVertices: TopTools_MapOfShape, aMapVs: TopOpeBRepDS_DataMapOfShapeState): void;
  static PropagateState(aSplEdgesState: TopOpeBRepDS_DataMapOfShapeState, anEdgesToRestMap: TopTools_IndexedMapOfShape, aShapeEnum1: TopAbs_ShapeEnum, aShapeEnum2: TopAbs_ShapeEnum, aShapeClassifier: TopOpeBRepTool_ShapeClassifier, aMapOfShapeWithState: TopOpeBRepDS_IndexedDataMapOfShapeWithState, anUnkStateShapes: TopTools_MapOfShape): void;
  static FindStateThroughVertex(aShape: TopoDS_Shape, aShapeClassifier: TopOpeBRepTool_ShapeClassifier, aMapOfShapeWithState: TopOpeBRepDS_IndexedDataMapOfShapeWithState, anAvoidSubshMap: TopTools_MapOfShape): TopAbs_State;
  static PropagateStateForWires(aFacesToRestMap: TopTools_IndexedMapOfShape, aMapOfShapeWithState: TopOpeBRepDS_IndexedDataMapOfShapeWithState): void;
  static SpreadStateToChild(aShape: TopoDS_Shape, aState: TopAbs_State, aMapOfShapeWithState: TopOpeBRepDS_IndexedDataMapOfShapeWithState): void;
  static FindState1(anEdge: TopoDS_Shape, aState: TopAbs_State, aMapEdgesFaces: TopTools_IndexedDataMapOfShapeListOfShape, aMapProcessedVertices: TopTools_MapOfShape, aMapVs: TopOpeBRepDS_DataMapOfShapeState): void;
  static FindState2(anEdge: TopoDS_Shape, aState: TopAbs_State, aMapEdgesFaces: TopTools_IndexedDataMapOfShapeListOfShape, aMapProcessedEdges: TopTools_MapOfShape, aMapVs: TopOpeBRepDS_DataMapOfShapeState): void;
  static GetAdjacentFace(aFaceObj: TopoDS_Shape, anEObj: TopoDS_Shape, anEdgeFaceMap: TopTools_IndexedDataMapOfShapeListOfShape, anAdjFaceObj: TopoDS_Shape): Standard_Boolean;
  static GetNormalToFaceOnEdge(aFObj: TopoDS_Face, anEdgeObj: TopoDS_Edge, aDirNormal: gp_Vec): void;
  static GetNormalInNearestPoint(aFace: TopoDS_Face, anEdge: TopoDS_Edge, aNormal: gp_Vec): void;
  static GetTangentToEdgeEdge(aFObj: TopoDS_Face, anEdgeObj: TopoDS_Edge, aOriEObj: TopoDS_Edge, aTangent: gp_Vec): Standard_Boolean;
  static GetTangentToEdge(anEdgeObj: TopoDS_Edge, aTangent: gp_Vec): Standard_Boolean;
  static UpdatePCurves(aWire: TopoDS_Wire, fromFace: TopoDS_Face, toFace: TopoDS_Face): void;
  static UpdateEdgeOnPeriodicalFace(aEdgeToUpdate: TopoDS_Edge, OldFace: TopoDS_Face, NewFace: TopoDS_Face): void;
  static UpdateEdgeOnFace(aEdgeToUpdate: TopoDS_Edge, OldFace: TopoDS_Face, NewFace: TopoDS_Face): void;
  static IsDegEdgesTheSame(anE1: TopoDS_Shape, anE2: TopoDS_Shape): Standard_Boolean;
  static NormalizeFace(oldFace: TopoDS_Shape, corrFace: TopoDS_Shape): void;
  static CorrectFace2d(oldFace: TopoDS_Shape, corrFace: TopoDS_Shape, aSourceShapes: TopTools_IndexedMapOfOrientedShape, aMapOfCorrect2dEdges: TopTools_IndexedDataMapOfShapeShape): void;
  static CorrectTolerances(aS: TopoDS_Shape, aTolMax: Quantity_AbsorbedDose): void;
  static CorrectCurveOnSurface(aS: TopoDS_Shape, aTolMax: Quantity_AbsorbedDose): void;
  static CorrectPointOnCurve(aS: TopoDS_Shape, aTolMax: Quantity_AbsorbedDose): void;
  static CheckFaceClosed2d(theFace: TopoDS_Face): Standard_Boolean;
  delete(): void;
}

export declare class TopOpeBRepBuild_LoopSet {
  constructor()
  ChangeListOfLoop(): TopOpeBRepBuild_ListOfLoop;
  InitLoop(): void;
  MoreLoop(): Standard_Boolean;
  NextLoop(): void;
  Loop(): Handle_TopOpeBRepBuild_Loop;
  delete(): void;
}

export declare class TopOpeBRepBuild_SolidAreaBuilder extends TopOpeBRepBuild_Area3dBuilder {
  InitSolidAreaBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_SolidAreaBuilder_1 extends TopOpeBRepBuild_SolidAreaBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_SolidAreaBuilder_2 extends TopOpeBRepBuild_SolidAreaBuilder {
    constructor(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_GIter {
  Init_1(): void;
  Init_2(G: TopOpeBRepBuild_GTopo): void;
  More(): Standard_Boolean;
  Next(): void;
  Current(s1: TopAbs_State, s2: TopAbs_State): void;
  Dump(OS: Standard_OStream): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_GIter_1 extends TopOpeBRepBuild_GIter {
    constructor();
  }

  export declare class TopOpeBRepBuild_GIter_2 extends TopOpeBRepBuild_GIter {
    constructor(G: TopOpeBRepBuild_GTopo);
  }

export declare class TopOpeBRepBuild_FuseFace {
  Init(LIF: TopTools_ListOfShape, LRF: TopTools_ListOfShape, CXM: Graphic3d_ZLayerId): void;
  PerformFace(): void;
  PerformEdge(): void;
  ClearEdge(): void;
  ClearVertex(): void;
  IsDone(): Standard_Boolean;
  IsModified(): Standard_Boolean;
  LFuseFace(): TopTools_ListOfShape;
  LInternEdge(): TopTools_ListOfShape;
  LExternEdge(): TopTools_ListOfShape;
  LModifEdge(): TopTools_ListOfShape;
  LInternVertex(): TopTools_ListOfShape;
  LExternVertex(): TopTools_ListOfShape;
  LModifVertex(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class TopOpeBRepBuild_FuseFace_1 extends TopOpeBRepBuild_FuseFace {
    constructor();
  }

  export declare class TopOpeBRepBuild_FuseFace_2 extends TopOpeBRepBuild_FuseFace {
    constructor(LIF: TopTools_ListOfShape, LRF: TopTools_ListOfShape, CXM: Graphic3d_ZLayerId);
  }

export declare type TopOpeBRepBuild_LoopEnum = {
  TopOpeBRepBuild_ANYLOOP: {};
  TopOpeBRepBuild_BOUNDARY: {};
  TopOpeBRepBuild_BLOCK: {};
}

export declare class TopOpeBRepBuild_WireToFace {
  constructor()
  Init(): void;
  AddWire(W: TopoDS_Wire): void;
  MakeFaces(F: TopoDS_Face, LF: TopTools_ListOfShape): void;
  delete(): void;
}

export declare class Handle_TopOpeBRepBuild_Loop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepBuild_Loop): void;
  get(): TopOpeBRepBuild_Loop;
  delete(): void;
}

  export declare class Handle_TopOpeBRepBuild_Loop_1 extends Handle_TopOpeBRepBuild_Loop {
    constructor();
  }

  export declare class Handle_TopOpeBRepBuild_Loop_2 extends Handle_TopOpeBRepBuild_Loop {
    constructor(thePtr: TopOpeBRepBuild_Loop);
  }

  export declare class Handle_TopOpeBRepBuild_Loop_3 extends Handle_TopOpeBRepBuild_Loop {
    constructor(theHandle: Handle_TopOpeBRepBuild_Loop);
  }

  export declare class Handle_TopOpeBRepBuild_Loop_4 extends Handle_TopOpeBRepBuild_Loop {
    constructor(theHandle: Handle_TopOpeBRepBuild_Loop);
  }

export declare class TopOpeBRepBuild_Loop extends Standard_Transient {
  IsShape(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  BlockIterator(): TopOpeBRepBuild_BlockIterator;
  Dump(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopOpeBRepBuild_Loop_1 extends TopOpeBRepBuild_Loop {
    constructor(S: TopoDS_Shape);
  }

  export declare class TopOpeBRepBuild_Loop_2 extends TopOpeBRepBuild_Loop {
    constructor(BI: TopOpeBRepBuild_BlockIterator);
  }

export declare class TopOpeBRepBuild_AreaBuilder {
  InitAreaBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  InitArea(): Graphic3d_ZLayerId;
  MoreArea(): Standard_Boolean;
  NextArea(): void;
  InitLoop(): Graphic3d_ZLayerId;
  MoreLoop(): Standard_Boolean;
  NextLoop(): void;
  Loop(): Handle_TopOpeBRepBuild_Loop;
  ADD_Loop_TO_LISTOFLoop(L: Handle_TopOpeBRepBuild_Loop, LOL: TopOpeBRepBuild_ListOfLoop, s: Standard_Address): void;
  REM_Loop_FROM_LISTOFLoop(ITLOL: TopOpeBRepBuild_ListIteratorOfListOfLoop, LOL: TopOpeBRepBuild_ListOfLoop, s: Standard_Address): void;
  ADD_LISTOFLoop_TO_LISTOFLoop(LOL1: TopOpeBRepBuild_ListOfLoop, LOL2: TopOpeBRepBuild_ListOfLoop, s: Standard_Address, s1: Standard_Address, s2: Standard_Address): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_AreaBuilder_1 extends TopOpeBRepBuild_AreaBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_AreaBuilder_2 extends TopOpeBRepBuild_AreaBuilder {
    constructor(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_Area2dBuilder extends TopOpeBRepBuild_AreaBuilder {
  InitAreaBuilder(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_Area2dBuilder_1 extends TopOpeBRepBuild_Area2dBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_Area2dBuilder_2 extends TopOpeBRepBuild_Area2dBuilder {
    constructor(LS: TopOpeBRepBuild_LoopSet, LC: TopOpeBRepBuild_LoopClassifier, ForceClass: Standard_Boolean);
  }

export declare class TopOpeBRepBuild_ShapeListOfShape {
  List(): TopTools_ListOfShape;
  ChangeList(): TopTools_ListOfShape;
  Shape(): TopoDS_Shape;
  ChangeShape(): TopoDS_Shape;
  delete(): void;
}

  export declare class TopOpeBRepBuild_ShapeListOfShape_1 extends TopOpeBRepBuild_ShapeListOfShape {
    constructor();
  }

  export declare class TopOpeBRepBuild_ShapeListOfShape_2 extends TopOpeBRepBuild_ShapeListOfShape {
    constructor(S: TopoDS_Shape);
  }

  export declare class TopOpeBRepBuild_ShapeListOfShape_3 extends TopOpeBRepBuild_ShapeListOfShape {
    constructor(S: TopoDS_Shape, L: TopTools_ListOfShape);
  }

export declare class TopOpeBRepBuild_ListOfListOfLoop extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopOpeBRepBuild_ListOfListOfLoop): TopOpeBRepBuild_ListOfListOfLoop;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopOpeBRepBuild_ListOfLoop;
  First_2(): TopOpeBRepBuild_ListOfLoop;
  Last_1(): TopOpeBRepBuild_ListOfLoop;
  Last_2(): TopOpeBRepBuild_ListOfLoop;
  Append_1(theItem: TopOpeBRepBuild_ListOfLoop): TopOpeBRepBuild_ListOfLoop;
  Append_3(theOther: TopOpeBRepBuild_ListOfListOfLoop): void;
  Prepend_1(theItem: TopOpeBRepBuild_ListOfLoop): TopOpeBRepBuild_ListOfLoop;
  Prepend_2(theOther: TopOpeBRepBuild_ListOfListOfLoop): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopOpeBRepBuild_ListOfListOfLoop_1 extends TopOpeBRepBuild_ListOfListOfLoop {
    constructor();
  }

  export declare class TopOpeBRepBuild_ListOfListOfLoop_2 extends TopOpeBRepBuild_ListOfListOfLoop {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopOpeBRepBuild_ListOfListOfLoop_3 extends TopOpeBRepBuild_ListOfListOfLoop {
    constructor(theOther: TopOpeBRepBuild_ListOfListOfLoop);
  }

export declare class TopOpeBRepBuild_ShapeSet {
  constructor(SubShapeType: TopAbs_ShapeEnum, checkshape: Standard_Boolean)
  AddShape(S: TopoDS_Shape): void;
  AddStartElement(S: TopoDS_Shape): void;
  AddElement(S: TopoDS_Shape): void;
  StartElements(): TopTools_ListOfShape;
  InitShapes(): void;
  MoreShapes(): Standard_Boolean;
  NextShape(): void;
  Shape(): TopoDS_Shape;
  InitStartElements(): void;
  MoreStartElements(): Standard_Boolean;
  NextStartElement(): void;
  StartElement(): TopoDS_Shape;
  InitNeighbours(S: TopoDS_Shape): void;
  MoreNeighbours(): Standard_Boolean;
  NextNeighbour(): void;
  Neighbour(): TopoDS_Shape;
  ChangeStartShapes(): TopTools_ListOfShape;
  FindNeighbours(): void;
  MakeNeighboursList(E: TopoDS_Shape, V: TopoDS_Shape): TopTools_ListOfShape;
  MaxNumberSubShape(Shape: TopoDS_Shape): Graphic3d_ZLayerId;
  CheckShape_1(checkshape: Standard_Boolean): void;
  CheckShape_2(): Standard_Boolean;
  CheckShape_3(S: TopoDS_Shape, checkgeom: Standard_Boolean): Standard_Boolean;
  DumpName(OS: Standard_OStream, str: XCAFDoc_PartId): void;
  DumpCheck(OS: Standard_OStream, str: XCAFDoc_PartId, S: TopoDS_Shape, chk: Standard_Boolean): void;
  DumpSS(): void;
  DumpBB(): void;
  DEBName_1(N: XCAFDoc_PartId): void;
  DEBName_2(): XCAFDoc_PartId;
  DEBNumber_1(I: Graphic3d_ZLayerId): void;
  DEBNumber_2(): Graphic3d_ZLayerId;
  SName_1(S: TopoDS_Shape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SNameori_1(S: TopoDS_Shape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SName_2(S: TopTools_ListOfShape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SNameori_2(S: TopTools_ListOfShape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  delete(): void;
}

export declare class TopOpeBRepBuild_SolidBuilder {
  InitSolidBuilder(FS: TopOpeBRepBuild_ShellFaceSet, ForceClass: Standard_Boolean): void;
  InitSolid(): Graphic3d_ZLayerId;
  MoreSolid(): Standard_Boolean;
  NextSolid(): void;
  InitShell(): Graphic3d_ZLayerId;
  MoreShell(): Standard_Boolean;
  NextShell(): void;
  IsOldShell(): Standard_Boolean;
  OldShell(): TopoDS_Shape;
  InitFace(): Graphic3d_ZLayerId;
  MoreFace(): Standard_Boolean;
  NextFace(): void;
  Face(): TopoDS_Shape;
  delete(): void;
}

  export declare class TopOpeBRepBuild_SolidBuilder_1 extends TopOpeBRepBuild_SolidBuilder {
    constructor();
  }

  export declare class TopOpeBRepBuild_SolidBuilder_2 extends TopOpeBRepBuild_SolidBuilder {
    constructor(FS: TopOpeBRepBuild_ShellFaceSet, ForceClass: Standard_Boolean);
  }

export declare class Handle_TopOpeBRepBuild_Pave {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopOpeBRepBuild_Pave): void;
  get(): TopOpeBRepBuild_Pave;
  delete(): void;
}

  export declare class Handle_TopOpeBRepBuild_Pave_1 extends Handle_TopOpeBRepBuild_Pave {
    constructor();
  }

  export declare class Handle_TopOpeBRepBuild_Pave_2 extends Handle_TopOpeBRepBuild_Pave {
    constructor(thePtr: TopOpeBRepBuild_Pave);
  }

  export declare class Handle_TopOpeBRepBuild_Pave_3 extends Handle_TopOpeBRepBuild_Pave {
    constructor(theHandle: Handle_TopOpeBRepBuild_Pave);
  }

  export declare class Handle_TopOpeBRepBuild_Pave_4 extends Handle_TopOpeBRepBuild_Pave {
    constructor(theHandle: Handle_TopOpeBRepBuild_Pave);
  }

export declare class TopOpeBRepBuild_Pave extends TopOpeBRepBuild_Loop {
  constructor(V: TopoDS_Shape, P: Quantity_AbsorbedDose, bound: Standard_Boolean)
  HasSameDomain_1(b: Standard_Boolean): void;
  SameDomain_1(VSD: TopoDS_Shape): void;
  HasSameDomain_2(): Standard_Boolean;
  SameDomain_2(): TopoDS_Shape;
  Vertex(): TopoDS_Shape;
  ChangeVertex(): TopoDS_Shape;
  Parameter_1(): Quantity_AbsorbedDose;
  Parameter_2(Par: Quantity_AbsorbedDose): void;
  InterferenceType(): TopOpeBRepDS_Kind;
  IsShape(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  Dump(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TopOpeBRepBuild_ShellFaceSet extends TopOpeBRepBuild_ShapeSet {
  Solid(): TopoDS_Solid;
  AddShape(S: TopoDS_Shape): void;
  AddStartElement(S: TopoDS_Shape): void;
  AddElement(S: TopoDS_Shape): void;
  DumpSS(): void;
  SName_1(S: TopoDS_Shape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SName_2(S: TopTools_ListOfShape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SNameori_1(S: TopoDS_Shape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  SNameori_2(S: TopTools_ListOfShape, sb: XCAFDoc_PartId, sa: XCAFDoc_PartId): XCAFDoc_PartId;
  delete(): void;
}

  export declare class TopOpeBRepBuild_ShellFaceSet_1 extends TopOpeBRepBuild_ShellFaceSet {
    constructor();
  }

  export declare class TopOpeBRepBuild_ShellFaceSet_2 extends TopOpeBRepBuild_ShellFaceSet {
    constructor(S: TopoDS_Shape, Addr: Standard_Address);
  }

export declare class TopOpeBRepBuild_PaveClassifier extends TopOpeBRepBuild_LoopClassifier {
  constructor(E: TopoDS_Shape)
  Compare(L1: Handle_TopOpeBRepBuild_Loop, L2: Handle_TopOpeBRepBuild_Loop): TopAbs_State;
  SetFirstParameter(P: Quantity_AbsorbedDose): void;
  ClosedVertices(B: Standard_Boolean): void;
  static AdjustCase(p1: Quantity_AbsorbedDose, o: TopAbs_Orientation, first: Quantity_AbsorbedDose, period: Quantity_AbsorbedDose, tol: Quantity_AbsorbedDose, cas: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class TopOpeBRepBuild_PaveSet extends TopOpeBRepBuild_LoopSet {
  constructor(E: TopoDS_Shape)
  RemovePV(B: Standard_Boolean): void;
  Append(PV: Handle_TopOpeBRepBuild_Pave): void;
  InitLoop(): void;
  MoreLoop(): Standard_Boolean;
  NextLoop(): void;
  Loop(): Handle_TopOpeBRepBuild_Loop;
  Edge(): TopoDS_Edge;
  HasEqualParameters(): Standard_Boolean;
  EqualParameters(): Quantity_AbsorbedDose;
  ClosedVertices(): Standard_Boolean;
  static SortPave(Lin: TopOpeBRepBuild_ListOfPave, Lout: TopOpeBRepBuild_ListOfPave): void;
  delete(): void;
}

export declare class XmlMXCAFDoc_VisMaterialDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_VisMaterialDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_VisMaterialDriver): void;
  get(): XmlMXCAFDoc_VisMaterialDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_VisMaterialDriver_1 extends Handle_XmlMXCAFDoc_VisMaterialDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_VisMaterialDriver_2 extends Handle_XmlMXCAFDoc_VisMaterialDriver {
    constructor(thePtr: XmlMXCAFDoc_VisMaterialDriver);
  }

  export declare class Handle_XmlMXCAFDoc_VisMaterialDriver_3 extends Handle_XmlMXCAFDoc_VisMaterialDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_VisMaterialDriver);
  }

  export declare class Handle_XmlMXCAFDoc_VisMaterialDriver_4 extends Handle_XmlMXCAFDoc_VisMaterialDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_VisMaterialDriver);
  }

export declare class XmlMXCAFDoc {
  constructor();
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, anMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_AssemblyItemRefDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_AssemblyItemRefDriver): void;
  get(): XmlMXCAFDoc_AssemblyItemRefDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_AssemblyItemRefDriver_1 extends Handle_XmlMXCAFDoc_AssemblyItemRefDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_AssemblyItemRefDriver_2 extends Handle_XmlMXCAFDoc_AssemblyItemRefDriver {
    constructor(thePtr: XmlMXCAFDoc_AssemblyItemRefDriver);
  }

  export declare class Handle_XmlMXCAFDoc_AssemblyItemRefDriver_3 extends Handle_XmlMXCAFDoc_AssemblyItemRefDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_AssemblyItemRefDriver);
  }

  export declare class Handle_XmlMXCAFDoc_AssemblyItemRefDriver_4 extends Handle_XmlMXCAFDoc_AssemblyItemRefDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_AssemblyItemRefDriver);
  }

export declare class XmlMXCAFDoc_AssemblyItemRefDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_VisMaterialToolDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_VisMaterialToolDriver): void;
  get(): XmlMXCAFDoc_VisMaterialToolDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_VisMaterialToolDriver_1 extends Handle_XmlMXCAFDoc_VisMaterialToolDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_VisMaterialToolDriver_2 extends Handle_XmlMXCAFDoc_VisMaterialToolDriver {
    constructor(thePtr: XmlMXCAFDoc_VisMaterialToolDriver);
  }

  export declare class Handle_XmlMXCAFDoc_VisMaterialToolDriver_3 extends Handle_XmlMXCAFDoc_VisMaterialToolDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_VisMaterialToolDriver);
  }

  export declare class Handle_XmlMXCAFDoc_VisMaterialToolDriver_4 extends Handle_XmlMXCAFDoc_VisMaterialToolDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_VisMaterialToolDriver);
  }

export declare class XmlMXCAFDoc_VisMaterialToolDriver extends XmlMDF_ADriver {
  constructor(theMsgDriver: Handle_Message_Messenger)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  delete(): void;
}

export declare class XmlMXCAFDoc_DatumDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_DatumDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_DatumDriver): void;
  get(): XmlMXCAFDoc_DatumDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_DatumDriver_1 extends Handle_XmlMXCAFDoc_DatumDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_DatumDriver_2 extends Handle_XmlMXCAFDoc_DatumDriver {
    constructor(thePtr: XmlMXCAFDoc_DatumDriver);
  }

  export declare class Handle_XmlMXCAFDoc_DatumDriver_3 extends Handle_XmlMXCAFDoc_DatumDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_DatumDriver);
  }

  export declare class Handle_XmlMXCAFDoc_DatumDriver_4 extends Handle_XmlMXCAFDoc_DatumDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_DatumDriver);
  }

export declare class XmlMXCAFDoc_NoteBinDataDriver extends XmlMXCAFDoc_NoteDriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_NoteBinDataDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_NoteBinDataDriver): void;
  get(): XmlMXCAFDoc_NoteBinDataDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_NoteBinDataDriver_1 extends Handle_XmlMXCAFDoc_NoteBinDataDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_NoteBinDataDriver_2 extends Handle_XmlMXCAFDoc_NoteBinDataDriver {
    constructor(thePtr: XmlMXCAFDoc_NoteBinDataDriver);
  }

  export declare class Handle_XmlMXCAFDoc_NoteBinDataDriver_3 extends Handle_XmlMXCAFDoc_NoteBinDataDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_NoteBinDataDriver);
  }

  export declare class Handle_XmlMXCAFDoc_NoteBinDataDriver_4 extends Handle_XmlMXCAFDoc_NoteBinDataDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_NoteBinDataDriver);
  }

export declare class XmlMXCAFDoc_NoteCommentDriver extends XmlMXCAFDoc_NoteDriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_NoteCommentDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_NoteCommentDriver): void;
  get(): XmlMXCAFDoc_NoteCommentDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_NoteCommentDriver_1 extends Handle_XmlMXCAFDoc_NoteCommentDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_NoteCommentDriver_2 extends Handle_XmlMXCAFDoc_NoteCommentDriver {
    constructor(thePtr: XmlMXCAFDoc_NoteCommentDriver);
  }

  export declare class Handle_XmlMXCAFDoc_NoteCommentDriver_3 extends Handle_XmlMXCAFDoc_NoteCommentDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_NoteCommentDriver);
  }

  export declare class Handle_XmlMXCAFDoc_NoteCommentDriver_4 extends Handle_XmlMXCAFDoc_NoteCommentDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_NoteCommentDriver);
  }

export declare class Handle_XmlMXCAFDoc_GraphNodeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_GraphNodeDriver): void;
  get(): XmlMXCAFDoc_GraphNodeDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_GraphNodeDriver_1 extends Handle_XmlMXCAFDoc_GraphNodeDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_GraphNodeDriver_2 extends Handle_XmlMXCAFDoc_GraphNodeDriver {
    constructor(thePtr: XmlMXCAFDoc_GraphNodeDriver);
  }

  export declare class Handle_XmlMXCAFDoc_GraphNodeDriver_3 extends Handle_XmlMXCAFDoc_GraphNodeDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_GraphNodeDriver);
  }

  export declare class Handle_XmlMXCAFDoc_GraphNodeDriver_4 extends Handle_XmlMXCAFDoc_GraphNodeDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_GraphNodeDriver);
  }

export declare class XmlMXCAFDoc_GraphNodeDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMXCAFDoc_NoteDriver extends XmlMDF_ADriver {
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_NoteDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_NoteDriver): void;
  get(): XmlMXCAFDoc_NoteDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_NoteDriver_1 extends Handle_XmlMXCAFDoc_NoteDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_NoteDriver_2 extends Handle_XmlMXCAFDoc_NoteDriver {
    constructor(thePtr: XmlMXCAFDoc_NoteDriver);
  }

  export declare class Handle_XmlMXCAFDoc_NoteDriver_3 extends Handle_XmlMXCAFDoc_NoteDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_NoteDriver);
  }

  export declare class Handle_XmlMXCAFDoc_NoteDriver_4 extends Handle_XmlMXCAFDoc_NoteDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_NoteDriver);
  }

export declare class XmlMXCAFDoc_MaterialDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_MaterialDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_MaterialDriver): void;
  get(): XmlMXCAFDoc_MaterialDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_MaterialDriver_1 extends Handle_XmlMXCAFDoc_MaterialDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_MaterialDriver_2 extends Handle_XmlMXCAFDoc_MaterialDriver {
    constructor(thePtr: XmlMXCAFDoc_MaterialDriver);
  }

  export declare class Handle_XmlMXCAFDoc_MaterialDriver_3 extends Handle_XmlMXCAFDoc_MaterialDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_MaterialDriver);
  }

  export declare class Handle_XmlMXCAFDoc_MaterialDriver_4 extends Handle_XmlMXCAFDoc_MaterialDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_MaterialDriver);
  }

export declare class XmlMXCAFDoc_ColorDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_ColorDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_ColorDriver): void;
  get(): XmlMXCAFDoc_ColorDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_ColorDriver_1 extends Handle_XmlMXCAFDoc_ColorDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_ColorDriver_2 extends Handle_XmlMXCAFDoc_ColorDriver {
    constructor(thePtr: XmlMXCAFDoc_ColorDriver);
  }

  export declare class Handle_XmlMXCAFDoc_ColorDriver_3 extends Handle_XmlMXCAFDoc_ColorDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_ColorDriver);
  }

  export declare class Handle_XmlMXCAFDoc_ColorDriver_4 extends Handle_XmlMXCAFDoc_ColorDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_ColorDriver);
  }

export declare class XmlMXCAFDoc_LocationDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  Translate_1(theLoc: TopLoc_Location, theParent: XmlObjMgt_Element, theMap: XmlObjMgt_SRelocationTable): void;
  Translate_2(theParent: XmlObjMgt_Element, theLoc: TopLoc_Location, theMap: XmlObjMgt_RRelocationTable): Standard_Boolean;
  SetSharedLocations(theLocations: TopTools_LocationSetPtr): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_LocationDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_LocationDriver): void;
  get(): XmlMXCAFDoc_LocationDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_LocationDriver_1 extends Handle_XmlMXCAFDoc_LocationDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_LocationDriver_2 extends Handle_XmlMXCAFDoc_LocationDriver {
    constructor(thePtr: XmlMXCAFDoc_LocationDriver);
  }

  export declare class Handle_XmlMXCAFDoc_LocationDriver_3 extends Handle_XmlMXCAFDoc_LocationDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_LocationDriver);
  }

  export declare class Handle_XmlMXCAFDoc_LocationDriver_4 extends Handle_XmlMXCAFDoc_LocationDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_LocationDriver);
  }

export declare class Handle_XmlMXCAFDoc_CentroidDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_CentroidDriver): void;
  get(): XmlMXCAFDoc_CentroidDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_CentroidDriver_1 extends Handle_XmlMXCAFDoc_CentroidDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_CentroidDriver_2 extends Handle_XmlMXCAFDoc_CentroidDriver {
    constructor(thePtr: XmlMXCAFDoc_CentroidDriver);
  }

  export declare class Handle_XmlMXCAFDoc_CentroidDriver_3 extends Handle_XmlMXCAFDoc_CentroidDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_CentroidDriver);
  }

  export declare class Handle_XmlMXCAFDoc_CentroidDriver_4 extends Handle_XmlMXCAFDoc_CentroidDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_CentroidDriver);
  }

export declare class XmlMXCAFDoc_CentroidDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMXCAFDoc_DimTolDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMXCAFDoc_DimTolDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMXCAFDoc_DimTolDriver): void;
  get(): XmlMXCAFDoc_DimTolDriver;
  delete(): void;
}

  export declare class Handle_XmlMXCAFDoc_DimTolDriver_1 extends Handle_XmlMXCAFDoc_DimTolDriver {
    constructor();
  }

  export declare class Handle_XmlMXCAFDoc_DimTolDriver_2 extends Handle_XmlMXCAFDoc_DimTolDriver {
    constructor(thePtr: XmlMXCAFDoc_DimTolDriver);
  }

  export declare class Handle_XmlMXCAFDoc_DimTolDriver_3 extends Handle_XmlMXCAFDoc_DimTolDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_DimTolDriver);
  }

  export declare class Handle_XmlMXCAFDoc_DimTolDriver_4 extends Handle_XmlMXCAFDoc_DimTolDriver {
    constructor(theHandle: Handle_XmlMXCAFDoc_DimTolDriver);
  }

export declare class NLPlate_HPG3Constraint extends NLPlate_HPG2Constraint {
  constructor(UV: gp_XY, D1T: Plate_D1, D2T: Plate_D2, D3T: Plate_D3)
  ActiveOrder(): Graphic3d_ZLayerId;
  G3Target(): Plate_D3;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NLPlate_HPG3Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG3Constraint): void;
  get(): NLPlate_HPG3Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG3Constraint_1 extends Handle_NLPlate_HPG3Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG3Constraint_2 extends Handle_NLPlate_HPG3Constraint {
    constructor(thePtr: NLPlate_HPG3Constraint);
  }

  export declare class Handle_NLPlate_HPG3Constraint_3 extends Handle_NLPlate_HPG3Constraint {
    constructor(theHandle: Handle_NLPlate_HPG3Constraint);
  }

  export declare class Handle_NLPlate_HPG3Constraint_4 extends Handle_NLPlate_HPG3Constraint {
    constructor(theHandle: Handle_NLPlate_HPG3Constraint);
  }

export declare class Handle_NLPlate_HPG2Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG2Constraint): void;
  get(): NLPlate_HPG2Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG2Constraint_1 extends Handle_NLPlate_HPG2Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG2Constraint_2 extends Handle_NLPlate_HPG2Constraint {
    constructor(thePtr: NLPlate_HPG2Constraint);
  }

  export declare class Handle_NLPlate_HPG2Constraint_3 extends Handle_NLPlate_HPG2Constraint {
    constructor(theHandle: Handle_NLPlate_HPG2Constraint);
  }

  export declare class Handle_NLPlate_HPG2Constraint_4 extends Handle_NLPlate_HPG2Constraint {
    constructor(theHandle: Handle_NLPlate_HPG2Constraint);
  }

export declare class NLPlate_HPG2Constraint extends NLPlate_HPG1Constraint {
  constructor(UV: gp_XY, D1T: Plate_D1, D2T: Plate_D2)
  ActiveOrder(): Graphic3d_ZLayerId;
  G2Target(): Plate_D2;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class NLPlate_HPG1Constraint extends NLPlate_HGPPConstraint {
  constructor(UV: gp_XY, D1T: Plate_D1)
  SetIncrementalLoadAllowed(ILA: Standard_Boolean): void;
  SetOrientation(Orient: Graphic3d_ZLayerId): void;
  IncrementalLoadAllowed(): Standard_Boolean;
  ActiveOrder(): Graphic3d_ZLayerId;
  IsG0(): Standard_Boolean;
  Orientation(): Graphic3d_ZLayerId;
  G1Target(): Plate_D1;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NLPlate_HPG1Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG1Constraint): void;
  get(): NLPlate_HPG1Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG1Constraint_1 extends Handle_NLPlate_HPG1Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG1Constraint_2 extends Handle_NLPlate_HPG1Constraint {
    constructor(thePtr: NLPlate_HPG1Constraint);
  }

  export declare class Handle_NLPlate_HPG1Constraint_3 extends Handle_NLPlate_HPG1Constraint {
    constructor(theHandle: Handle_NLPlate_HPG1Constraint);
  }

  export declare class Handle_NLPlate_HPG1Constraint_4 extends Handle_NLPlate_HPG1Constraint {
    constructor(theHandle: Handle_NLPlate_HPG1Constraint);
  }

export declare class Handle_NLPlate_HGPPConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HGPPConstraint): void;
  get(): NLPlate_HGPPConstraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HGPPConstraint_1 extends Handle_NLPlate_HGPPConstraint {
    constructor();
  }

  export declare class Handle_NLPlate_HGPPConstraint_2 extends Handle_NLPlate_HGPPConstraint {
    constructor(thePtr: NLPlate_HGPPConstraint);
  }

  export declare class Handle_NLPlate_HGPPConstraint_3 extends Handle_NLPlate_HGPPConstraint {
    constructor(theHandle: Handle_NLPlate_HGPPConstraint);
  }

  export declare class Handle_NLPlate_HGPPConstraint_4 extends Handle_NLPlate_HGPPConstraint {
    constructor(theHandle: Handle_NLPlate_HGPPConstraint);
  }

export declare class NLPlate_HGPPConstraint extends Standard_Transient {
  SetUVFreeSliding(UVFree: Standard_Boolean): void;
  SetIncrementalLoadAllowed(ILA: Standard_Boolean): void;
  SetActiveOrder(ActiveOrder: Graphic3d_ZLayerId): void;
  SetUV(UV: gp_XY): void;
  SetOrientation(Orient: Graphic3d_ZLayerId): void;
  SetG0Criterion(TolDist: Quantity_AbsorbedDose): void;
  SetG1Criterion(TolAng: Quantity_AbsorbedDose): void;
  SetG2Criterion(TolCurv: Quantity_AbsorbedDose): void;
  SetG3Criterion(TolG3: Quantity_AbsorbedDose): void;
  UVFreeSliding(): Standard_Boolean;
  IncrementalLoadAllowed(): Standard_Boolean;
  ActiveOrder(): Graphic3d_ZLayerId;
  UV(): gp_XY;
  Orientation(): Graphic3d_ZLayerId;
  IsG0(): Standard_Boolean;
  G0Target(): gp_XYZ;
  G1Target(): Plate_D1;
  G2Target(): Plate_D2;
  G3Target(): Plate_D3;
  G0Criterion(): Quantity_AbsorbedDose;
  G1Criterion(): Quantity_AbsorbedDose;
  G2Criterion(): Quantity_AbsorbedDose;
  G3Criterion(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NLPlate_HPG0G1Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG0G1Constraint): void;
  get(): NLPlate_HPG0G1Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG0G1Constraint_1 extends Handle_NLPlate_HPG0G1Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG0G1Constraint_2 extends Handle_NLPlate_HPG0G1Constraint {
    constructor(thePtr: NLPlate_HPG0G1Constraint);
  }

  export declare class Handle_NLPlate_HPG0G1Constraint_3 extends Handle_NLPlate_HPG0G1Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0G1Constraint);
  }

  export declare class Handle_NLPlate_HPG0G1Constraint_4 extends Handle_NLPlate_HPG0G1Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0G1Constraint);
  }

export declare class NLPlate_HPG0G1Constraint extends NLPlate_HPG0Constraint {
  constructor(UV: gp_XY, Value: gp_XYZ, D1T: Plate_D1)
  SetOrientation(Orient: Graphic3d_ZLayerId): void;
  ActiveOrder(): Graphic3d_ZLayerId;
  Orientation(): Graphic3d_ZLayerId;
  G1Target(): Plate_D1;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class NLPlate_HPG0Constraint extends NLPlate_HGPPConstraint {
  constructor(UV: gp_XY, Value: gp_XYZ)
  SetUVFreeSliding(UVFree: Standard_Boolean): void;
  SetIncrementalLoadAllowed(ILA: Standard_Boolean): void;
  UVFreeSliding(): Standard_Boolean;
  IncrementalLoadAllowed(): Standard_Boolean;
  ActiveOrder(): Graphic3d_ZLayerId;
  IsG0(): Standard_Boolean;
  G0Target(): gp_XYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NLPlate_HPG0Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG0Constraint): void;
  get(): NLPlate_HPG0Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG0Constraint_1 extends Handle_NLPlate_HPG0Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG0Constraint_2 extends Handle_NLPlate_HPG0Constraint {
    constructor(thePtr: NLPlate_HPG0Constraint);
  }

  export declare class Handle_NLPlate_HPG0Constraint_3 extends Handle_NLPlate_HPG0Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0Constraint);
  }

  export declare class Handle_NLPlate_HPG0Constraint_4 extends Handle_NLPlate_HPG0Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0Constraint);
  }

export declare class NLPlate_HPG0G3Constraint extends NLPlate_HPG0G2Constraint {
  constructor(UV: gp_XY, Value: gp_XYZ, D1T: Plate_D1, D2T: Plate_D2, D3T: Plate_D3)
  ActiveOrder(): Graphic3d_ZLayerId;
  G3Target(): Plate_D3;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NLPlate_HPG0G3Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG0G3Constraint): void;
  get(): NLPlate_HPG0G3Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG0G3Constraint_1 extends Handle_NLPlate_HPG0G3Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG0G3Constraint_2 extends Handle_NLPlate_HPG0G3Constraint {
    constructor(thePtr: NLPlate_HPG0G3Constraint);
  }

  export declare class Handle_NLPlate_HPG0G3Constraint_3 extends Handle_NLPlate_HPG0G3Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0G3Constraint);
  }

  export declare class Handle_NLPlate_HPG0G3Constraint_4 extends Handle_NLPlate_HPG0G3Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0G3Constraint);
  }

export declare class NLPlate_NLPlate {
  constructor(InitialSurface: Handle_Geom_Surface)
  Load(GConst: Handle_NLPlate_HGPPConstraint): void;
  Solve(ord: Graphic3d_ZLayerId, InitialConsraintOrder: Graphic3d_ZLayerId): void;
  Solve2(ord: Graphic3d_ZLayerId, InitialConsraintOrder: Graphic3d_ZLayerId): void;
  IncrementalSolve(ord: Graphic3d_ZLayerId, InitialConsraintOrder: Graphic3d_ZLayerId, NbIncrements: Graphic3d_ZLayerId, UVSliding: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  destroy(): void;
  Init(): void;
  Evaluate(point2d: gp_XY): gp_XYZ;
  EvaluateDerivative(point2d: gp_XY, iu: Graphic3d_ZLayerId, iv: Graphic3d_ZLayerId): gp_XYZ;
  Continuity(): Graphic3d_ZLayerId;
  ConstraintsSliding(NbIterations: Graphic3d_ZLayerId): void;
  MaxActiveConstraintOrder(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class NLPlate_HPG0G2Constraint extends NLPlate_HPG0G1Constraint {
  constructor(UV: gp_XY, Value: gp_XYZ, D1T: Plate_D1, D2T: Plate_D2)
  ActiveOrder(): Graphic3d_ZLayerId;
  G2Target(): Plate_D2;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_NLPlate_HPG0G2Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: NLPlate_HPG0G2Constraint): void;
  get(): NLPlate_HPG0G2Constraint;
  delete(): void;
}

  export declare class Handle_NLPlate_HPG0G2Constraint_1 extends Handle_NLPlate_HPG0G2Constraint {
    constructor();
  }

  export declare class Handle_NLPlate_HPG0G2Constraint_2 extends Handle_NLPlate_HPG0G2Constraint {
    constructor(thePtr: NLPlate_HPG0G2Constraint);
  }

  export declare class Handle_NLPlate_HPG0G2Constraint_3 extends Handle_NLPlate_HPG0G2Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0G2Constraint);
  }

  export declare class Handle_NLPlate_HPG0G2Constraint_4 extends Handle_NLPlate_HPG0G2Constraint {
    constructor(theHandle: Handle_NLPlate_HPG0G2Constraint);
  }

export declare class NLPlate_StackOfPlate extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: NLPlate_StackOfPlate): NLPlate_StackOfPlate;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Plate_Plate;
  First_2(): Plate_Plate;
  Last_1(): Plate_Plate;
  Last_2(): Plate_Plate;
  Append_1(theItem: Plate_Plate): Plate_Plate;
  Append_3(theOther: NLPlate_StackOfPlate): void;
  Prepend_1(theItem: Plate_Plate): Plate_Plate;
  Prepend_2(theOther: NLPlate_StackOfPlate): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class NLPlate_StackOfPlate_1 extends NLPlate_StackOfPlate {
    constructor();
  }

  export declare class NLPlate_StackOfPlate_2 extends NLPlate_StackOfPlate {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class NLPlate_StackOfPlate_3 extends NLPlate_StackOfPlate {
    constructor(theOther: NLPlate_StackOfPlate);
  }

export declare class TNaming_SameShapeIterator {
  constructor(aShape: TopoDS_Shape, access: TDF_Label)
  More(): Standard_Boolean;
  Next(): void;
  Label(): TDF_Label;
  delete(): void;
}

export declare class TNaming_ShapesSet {
  Clear(): void;
  Add_1(S: TopoDS_Shape): Standard_Boolean;
  Contains(S: TopoDS_Shape): Standard_Boolean;
  Remove_1(S: TopoDS_Shape): Standard_Boolean;
  Add_2(Shapes: TNaming_ShapesSet): void;
  Filter(Shapes: TNaming_ShapesSet): void;
  Remove_2(Shapes: TNaming_ShapesSet): void;
  IsEmpty(): Standard_Boolean;
  NbShapes(): Graphic3d_ZLayerId;
  ChangeMap(): TopTools_MapOfShape;
  Map(): TopTools_MapOfShape;
  delete(): void;
}

  export declare class TNaming_ShapesSet_1 extends TNaming_ShapesSet {
    constructor();
  }

  export declare class TNaming_ShapesSet_2 extends TNaming_ShapesSet {
    constructor(S: TopoDS_Shape, Type: TopAbs_ShapeEnum);
  }

export declare class TNaming {
  constructor();
  static Substitute(labelsource: TDF_Label, labelcible: TDF_Label, mapOldNew: TopTools_DataMapOfShapeShape): void;
  static Update(label: TDF_Label, mapOldNew: TopTools_DataMapOfShapeShape): void;
  static Displace(label: TDF_Label, aLocation: TopLoc_Location, WithOld: Standard_Boolean): void;
  static ChangeShapes(label: TDF_Label, M: TopTools_DataMapOfShapeShape): void;
  static Transform(label: TDF_Label, aTransformation: gp_Trsf): void;
  static Replicate_1(NS: Handle_TNaming_NamedShape, T: gp_Trsf, L: TDF_Label): void;
  static Replicate_2(SH: TopoDS_Shape, T: gp_Trsf, L: TDF_Label): void;
  static MakeShape(MS: TopTools_MapOfShape): TopoDS_Shape;
  static FindUniqueContext(S: TopoDS_Shape, Context: TopoDS_Shape): TopoDS_Shape;
  static FindUniqueContextSet(S: TopoDS_Shape, Context: TopoDS_Shape, Arr: Handle_TopTools_HArray1OfShape): TopoDS_Shape;
  static SubstituteSShape(accesslabel: TDF_Label, From: TopoDS_Shape, To: TopoDS_Shape): Standard_Boolean;
  static OuterWire(theFace: TopoDS_Face, theWire: TopoDS_Wire): Standard_Boolean;
  static OuterShell(theSolid: TopoDS_Solid, theShell: TopoDS_Shell): Standard_Boolean;
  static IDList(anIDList: TDF_IDList): void;
  delete(): void;
}

export declare class TNaming_Naming extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Insert(under: TDF_Label): Handle_TNaming_Naming;
  static Name(where: TDF_Label, Selection: TopoDS_Shape, Context: TopoDS_Shape, Geometry: Standard_Boolean, KeepOrientation: Standard_Boolean, BNproblem: Standard_Boolean): Handle_TNaming_NamedShape;
  IsDefined(): Standard_Boolean;
  GetName(): TNaming_Name;
  ChangeName(): TNaming_Name;
  Regenerate(scope: TDF_LabelMap): Standard_Boolean;
  Solve(scope: TDF_LabelMap): Standard_Boolean;
  ID(): Standard_GUID;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(With: Handle_TDF_Attribute): void;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(aDataSet: Handle_TDF_DataSet): void;
  ExtendedDump(anOS: Standard_OStream, aFilter: TDF_IDFilter, aMap: TDF_AttributeIndexedMap): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TNaming_Naming {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TNaming_Naming): void;
  get(): TNaming_Naming;
  delete(): void;
}

  export declare class Handle_TNaming_Naming_1 extends Handle_TNaming_Naming {
    constructor();
  }

  export declare class Handle_TNaming_Naming_2 extends Handle_TNaming_Naming {
    constructor(thePtr: TNaming_Naming);
  }

  export declare class Handle_TNaming_Naming_3 extends Handle_TNaming_Naming {
    constructor(theHandle: Handle_TNaming_Naming);
  }

  export declare class Handle_TNaming_Naming_4 extends Handle_TNaming_Naming {
    constructor(theHandle: Handle_TNaming_Naming);
  }

export declare class TNaming_Builder {
  constructor(aLabel: TDF_Label)
  Generated_1(newShape: TopoDS_Shape): void;
  Generated_2(oldShape: TopoDS_Shape, newShape: TopoDS_Shape): void;
  Delete(oldShape: TopoDS_Shape): void;
  Modify(oldShape: TopoDS_Shape, newShape: TopoDS_Shape): void;
  Select(aShape: TopoDS_Shape, inShape: TopoDS_Shape): void;
  NamedShape(): Handle_TNaming_NamedShape;
  delete(): void;
}

export declare class TNaming_IteratorOnShapesSet {
  Init(S: TNaming_ShapesSet): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): TopoDS_Shape;
  delete(): void;
}

  export declare class TNaming_IteratorOnShapesSet_1 extends TNaming_IteratorOnShapesSet {
    constructor();
  }

  export declare class TNaming_IteratorOnShapesSet_2 extends TNaming_IteratorOnShapesSet {
    constructor(S: TNaming_ShapesSet);
  }

export declare class TNaming_DataMapOfShapePtrRefShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TNaming_DataMapOfShapePtrRefShape): void;
  Assign(theOther: TNaming_DataMapOfShapePtrRefShape): TNaming_DataMapOfShapePtrRefShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TNaming_PtrRefShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TNaming_PtrRefShape): TNaming_PtrRefShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TNaming_PtrRefShape;
  ChangeSeek(theKey: TopoDS_Shape): TNaming_PtrRefShape;
  ChangeFind(theKey: TopoDS_Shape): TNaming_PtrRefShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TNaming_DataMapOfShapePtrRefShape_1 extends TNaming_DataMapOfShapePtrRefShape {
    constructor();
  }

  export declare class TNaming_DataMapOfShapePtrRefShape_2 extends TNaming_DataMapOfShapePtrRefShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TNaming_DataMapOfShapePtrRefShape_3 extends TNaming_DataMapOfShapePtrRefShape {
    constructor(theOther: TNaming_DataMapOfShapePtrRefShape);
  }

export declare class TNaming_DeltaOnRemoval extends TDF_DeltaOnRemoval {
  constructor(NS: Handle_TNaming_NamedShape)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TNaming_DeltaOnRemoval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TNaming_DeltaOnRemoval): void;
  get(): TNaming_DeltaOnRemoval;
  delete(): void;
}

  export declare class Handle_TNaming_DeltaOnRemoval_1 extends Handle_TNaming_DeltaOnRemoval {
    constructor();
  }

  export declare class Handle_TNaming_DeltaOnRemoval_2 extends Handle_TNaming_DeltaOnRemoval {
    constructor(thePtr: TNaming_DeltaOnRemoval);
  }

  export declare class Handle_TNaming_DeltaOnRemoval_3 extends Handle_TNaming_DeltaOnRemoval {
    constructor(theHandle: Handle_TNaming_DeltaOnRemoval);
  }

  export declare class Handle_TNaming_DeltaOnRemoval_4 extends Handle_TNaming_DeltaOnRemoval {
    constructor(theHandle: Handle_TNaming_DeltaOnRemoval);
  }

export declare class TNaming_Scope {
  WithValid_1(): Standard_Boolean;
  WithValid_2(mode: Standard_Boolean): void;
  ClearValid(): void;
  Valid(L: TDF_Label): void;
  ValidChildren(L: TDF_Label, withroot: Standard_Boolean): void;
  Unvalid(L: TDF_Label): void;
  UnvalidChildren(L: TDF_Label, withroot: Standard_Boolean): void;
  IsValid(L: TDF_Label): Standard_Boolean;
  GetValid(): TDF_LabelMap;
  ChangeValid(): TDF_LabelMap;
  CurrentShape(NS: Handle_TNaming_NamedShape): TopoDS_Shape;
  delete(): void;
}

  export declare class TNaming_Scope_1 extends TNaming_Scope {
    constructor();
  }

  export declare class TNaming_Scope_2 extends TNaming_Scope {
    constructor(WithValid: Standard_Boolean);
  }

  export declare class TNaming_Scope_3 extends TNaming_Scope {
    constructor(valid: TDF_LabelMap);
  }

export declare class TNaming_Iterator {
  More(): Standard_Boolean;
  Next(): void;
  OldShape(): TopoDS_Shape;
  NewShape(): TopoDS_Shape;
  IsModification(): Standard_Boolean;
  Evolution(): TNaming_Evolution;
  delete(): void;
}

  export declare class TNaming_Iterator_1 extends TNaming_Iterator {
    constructor(anAtt: Handle_TNaming_NamedShape);
  }

  export declare class TNaming_Iterator_2 extends TNaming_Iterator {
    constructor(aLabel: TDF_Label);
  }

  export declare class TNaming_Iterator_3 extends TNaming_Iterator {
    constructor(aLabel: TDF_Label, aTrans: Graphic3d_ZLayerId);
  }

export declare class TNaming_ListOfMapOfShape extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TNaming_ListOfMapOfShape): TNaming_ListOfMapOfShape;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopTools_MapOfShape;
  First_2(): TopTools_MapOfShape;
  Last_1(): TopTools_MapOfShape;
  Last_2(): TopTools_MapOfShape;
  Append_1(theItem: TopTools_MapOfShape): TopTools_MapOfShape;
  Append_3(theOther: TNaming_ListOfMapOfShape): void;
  Prepend_1(theItem: TopTools_MapOfShape): TopTools_MapOfShape;
  Prepend_2(theOther: TNaming_ListOfMapOfShape): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TNaming_ListOfMapOfShape_1 extends TNaming_ListOfMapOfShape {
    constructor();
  }

  export declare class TNaming_ListOfMapOfShape_2 extends TNaming_ListOfMapOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TNaming_ListOfMapOfShape_3 extends TNaming_ListOfMapOfShape {
    constructor(theOther: TNaming_ListOfMapOfShape);
  }

export declare class TNaming_Localizer {
  constructor()
  Init(US: Handle_TNaming_UsedShapes, CurTrans: Graphic3d_ZLayerId): void;
  SubShapes(S: TopoDS_Shape, Type: TopAbs_ShapeEnum): TopTools_MapOfShape;
  Ancestors(S: TopoDS_Shape, Type: TopAbs_ShapeEnum): TopTools_IndexedDataMapOfShapeListOfShape;
  FindFeaturesInAncestors(S: TopoDS_Shape, In: TopoDS_Shape, AncInFeatures: TopTools_MapOfShape): void;
  GoBack(S: TopoDS_Shape, Lab: TDF_Label, Evol: TNaming_Evolution, OldS: TopTools_ListOfShape, OldLab: TNaming_ListOfNamedShape): void;
  Backward(NS: Handle_TNaming_NamedShape, S: TopoDS_Shape, Primitives: TNaming_MapOfNamedShape, ValidShapes: TopTools_MapOfShape): void;
  FindNeighbourg(Cont: TopoDS_Shape, S: TopoDS_Shape, Neighbourg: TopTools_MapOfShape): void;
  static IsNew(S: TopoDS_Shape, NS: Handle_TNaming_NamedShape): Standard_Boolean;
  static FindGenerator(NS: Handle_TNaming_NamedShape, S: TopoDS_Shape, theListOfGenerators: TopTools_ListOfShape): void;
  static FindShapeContext(NS: Handle_TNaming_NamedShape, theS: TopoDS_Shape, theSC: TopoDS_Shape): void;
  delete(): void;
}

export declare class TNaming_DataMapOfShapeShapesSet extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TNaming_DataMapOfShapeShapesSet): void;
  Assign(theOther: TNaming_DataMapOfShapeShapesSet): TNaming_DataMapOfShapeShapesSet;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TNaming_ShapesSet): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TNaming_ShapesSet): TNaming_ShapesSet;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TNaming_ShapesSet;
  ChangeSeek(theKey: TopoDS_Shape): TNaming_ShapesSet;
  ChangeFind(theKey: TopoDS_Shape): TNaming_ShapesSet;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TNaming_DataMapOfShapeShapesSet_1 extends TNaming_DataMapOfShapeShapesSet {
    constructor();
  }

  export declare class TNaming_DataMapOfShapeShapesSet_2 extends TNaming_DataMapOfShapeShapesSet {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TNaming_DataMapOfShapeShapesSet_3 extends TNaming_DataMapOfShapeShapesSet {
    constructor(theOther: TNaming_DataMapOfShapeShapesSet);
  }

export declare class TNaming_Selector {
  constructor(aLabel: TDF_Label)
  static IsIdentified(access: TDF_Label, selection: TopoDS_Shape, NS: Handle_TNaming_NamedShape, Geometry: Standard_Boolean): Standard_Boolean;
  Select_1(Selection: TopoDS_Shape, Context: TopoDS_Shape, Geometry: Standard_Boolean, KeepOrientatation: Standard_Boolean): Standard_Boolean;
  Select_2(Selection: TopoDS_Shape, Geometry: Standard_Boolean, KeepOrientatation: Standard_Boolean): Standard_Boolean;
  Solve(Valid: TDF_LabelMap): Standard_Boolean;
  Arguments(args: TDF_AttributeMap): void;
  NamedShape(): Handle_TNaming_NamedShape;
  delete(): void;
}

export declare class TNaming_NewShapeIterator {
  More(): Standard_Boolean;
  Next(): void;
  Label(): TDF_Label;
  NamedShape(): Handle_TNaming_NamedShape;
  Shape(): TopoDS_Shape;
  IsModification(): Standard_Boolean;
  delete(): void;
}

  export declare class TNaming_NewShapeIterator_1 extends TNaming_NewShapeIterator {
    constructor(aShape: TopoDS_Shape, Transaction: Graphic3d_ZLayerId, access: TDF_Label);
  }

  export declare class TNaming_NewShapeIterator_2 extends TNaming_NewShapeIterator {
    constructor(aShape: TopoDS_Shape, access: TDF_Label);
  }

  export declare class TNaming_NewShapeIterator_3 extends TNaming_NewShapeIterator {
    constructor(anIterator: TNaming_NewShapeIterator);
  }

  export declare class TNaming_NewShapeIterator_4 extends TNaming_NewShapeIterator {
    constructor(anIterator: TNaming_Iterator);
  }

export declare class TNaming_TranslateTool extends Standard_Transient {
  constructor();
  Add(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  MakeVertex(S: TopoDS_Shape): void;
  MakeEdge(S: TopoDS_Shape): void;
  MakeWire(S: TopoDS_Shape): void;
  MakeFace(S: TopoDS_Shape): void;
  MakeShell(S: TopoDS_Shape): void;
  MakeSolid(S: TopoDS_Shape): void;
  MakeCompSolid(S: TopoDS_Shape): void;
  MakeCompound(S: TopoDS_Shape): void;
  UpdateVertex(S1: TopoDS_Shape, S2: TopoDS_Shape, M: TColStd_IndexedDataMapOfTransientTransient): void;
  UpdateEdge(S1: TopoDS_Shape, S2: TopoDS_Shape, M: TColStd_IndexedDataMapOfTransientTransient): void;
  UpdateFace(S1: TopoDS_Shape, S2: TopoDS_Shape, M: TColStd_IndexedDataMapOfTransientTransient): void;
  UpdateShape(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TNaming_TranslateTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TNaming_TranslateTool): void;
  get(): TNaming_TranslateTool;
  delete(): void;
}

  export declare class Handle_TNaming_TranslateTool_1 extends Handle_TNaming_TranslateTool {
    constructor();
  }

  export declare class Handle_TNaming_TranslateTool_2 extends Handle_TNaming_TranslateTool {
    constructor(thePtr: TNaming_TranslateTool);
  }

  export declare class Handle_TNaming_TranslateTool_3 extends Handle_TNaming_TranslateTool {
    constructor(theHandle: Handle_TNaming_TranslateTool);
  }

  export declare class Handle_TNaming_TranslateTool_4 extends Handle_TNaming_TranslateTool {
    constructor(theHandle: Handle_TNaming_TranslateTool);
  }

export declare class TNaming_CopyShape {
  constructor();
  static CopyTool(aShape: TopoDS_Shape, aMap: TColStd_IndexedDataMapOfTransientTransient, aResult: TopoDS_Shape): void;
  static Translate_1(aShape: TopoDS_Shape, aMap: TColStd_IndexedDataMapOfTransientTransient, aResult: TopoDS_Shape, TrTool: Handle_TNaming_TranslateTool): void;
  static Translate_2(L: TopLoc_Location, aMap: TColStd_IndexedDataMapOfTransientTransient): TopLoc_Location;
  delete(): void;
}

export declare class TNaming_UsedShapes extends TDF_Attribute {
  Destroy(): void;
  Map(): TNaming_DataMapOfShapePtrRefShape;
  ID(): Standard_GUID;
  static GetID(): Standard_GUID;
  BackupCopy(): Handle_TDF_Attribute;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  BeforeRemoval(): void;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  DeltaOnAddition(): Handle_TDF_DeltaOnAddition;
  DeltaOnRemoval(): Handle_TDF_DeltaOnRemoval;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocTationable: Handle_TDF_RelocationTable): void;
  References(aDataSet: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TNaming_UsedShapes {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TNaming_UsedShapes): void;
  get(): TNaming_UsedShapes;
  delete(): void;
}

  export declare class Handle_TNaming_UsedShapes_1 extends Handle_TNaming_UsedShapes {
    constructor();
  }

  export declare class Handle_TNaming_UsedShapes_2 extends Handle_TNaming_UsedShapes {
    constructor(thePtr: TNaming_UsedShapes);
  }

  export declare class Handle_TNaming_UsedShapes_3 extends Handle_TNaming_UsedShapes {
    constructor(theHandle: Handle_TNaming_UsedShapes);
  }

  export declare class Handle_TNaming_UsedShapes_4 extends Handle_TNaming_UsedShapes {
    constructor(theHandle: Handle_TNaming_UsedShapes);
  }

export declare class TNaming_OldShapeIterator {
  More(): Standard_Boolean;
  Next(): void;
  Label(): TDF_Label;
  NamedShape(): Handle_TNaming_NamedShape;
  Shape(): TopoDS_Shape;
  IsModification(): Standard_Boolean;
  delete(): void;
}

  export declare class TNaming_OldShapeIterator_1 extends TNaming_OldShapeIterator {
    constructor(aShape: TopoDS_Shape, Transaction: Graphic3d_ZLayerId, access: TDF_Label);
  }

  export declare class TNaming_OldShapeIterator_2 extends TNaming_OldShapeIterator {
    constructor(aShape: TopoDS_Shape, access: TDF_Label);
  }

  export declare class TNaming_OldShapeIterator_3 extends TNaming_OldShapeIterator {
    constructor(anIterator: TNaming_OldShapeIterator);
  }

  export declare class TNaming_OldShapeIterator_4 extends TNaming_OldShapeIterator {
    constructor(anIterator: TNaming_Iterator);
  }

export declare class TNaming_Translator {
  constructor()
  Add(aShape: TopoDS_Shape): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  Copied_1(aShape: TopoDS_Shape): TopoDS_Shape;
  Copied_2(): TopTools_DataMapOfShapeShape;
  DumpMap(isWrite: Standard_Boolean): void;
  delete(): void;
}

export declare class TNaming_Identifier {
  IsDone(): Standard_Boolean;
  Type(): TNaming_NameType;
  IsFeature(): Standard_Boolean;
  Feature(): Handle_TNaming_NamedShape;
  InitArgs(): void;
  MoreArgs(): Standard_Boolean;
  NextArg(): void;
  ArgIsFeature(): Standard_Boolean;
  FeatureArg(): Handle_TNaming_NamedShape;
  ShapeArg(): TopoDS_Shape;
  ShapeContext(): TopoDS_Shape;
  NamedShapeOfGeneration(): Handle_TNaming_NamedShape;
  AncestorIdentification(Localizer: TNaming_Localizer, Context: TopoDS_Shape): void;
  PrimitiveIdentification(Localizer: TNaming_Localizer, NS: Handle_TNaming_NamedShape): void;
  GeneratedIdentification(Localizer: TNaming_Localizer, NS: Handle_TNaming_NamedShape): void;
  Identification(Localizer: TNaming_Localizer, NS: Handle_TNaming_NamedShape): void;
  delete(): void;
}

  export declare class TNaming_Identifier_1 extends TNaming_Identifier {
    constructor(Lab: TDF_Label, S: TopoDS_Shape, Context: TopoDS_Shape, Geom: Standard_Boolean);
  }

  export declare class TNaming_Identifier_2 extends TNaming_Identifier {
    constructor(Lab: TDF_Label, S: TopoDS_Shape, ContextNS: Handle_TNaming_NamedShape, Geom: Standard_Boolean);
  }

export declare class TNaming_RefShape {
  Shape_1(S: TopoDS_Shape): void;
  FirstUse_1(aPtr: TNaming_PtrNode): void;
  FirstUse_2(): TNaming_PtrNode;
  Shape_2(): TopoDS_Shape;
  Label(): TDF_Label;
  NamedShape(): Handle_TNaming_NamedShape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class TNaming_RefShape_1 extends TNaming_RefShape {
    constructor();
  }

  export declare class TNaming_RefShape_2 extends TNaming_RefShape {
    constructor(S: TopoDS_Shape);
  }

export declare class TNaming_ListOfIndexedDataMapOfShapeListOfShape extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TNaming_ListOfIndexedDataMapOfShapeListOfShape): TNaming_ListOfIndexedDataMapOfShapeListOfShape;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopTools_IndexedDataMapOfShapeListOfShape;
  First_2(): TopTools_IndexedDataMapOfShapeListOfShape;
  Last_1(): TopTools_IndexedDataMapOfShapeListOfShape;
  Last_2(): TopTools_IndexedDataMapOfShapeListOfShape;
  Append_1(theItem: TopTools_IndexedDataMapOfShapeListOfShape): TopTools_IndexedDataMapOfShapeListOfShape;
  Append_3(theOther: TNaming_ListOfIndexedDataMapOfShapeListOfShape): void;
  Prepend_1(theItem: TopTools_IndexedDataMapOfShapeListOfShape): TopTools_IndexedDataMapOfShapeListOfShape;
  Prepend_2(theOther: TNaming_ListOfIndexedDataMapOfShapeListOfShape): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TNaming_ListOfIndexedDataMapOfShapeListOfShape_1 extends TNaming_ListOfIndexedDataMapOfShapeListOfShape {
    constructor();
  }

  export declare class TNaming_ListOfIndexedDataMapOfShapeListOfShape_2 extends TNaming_ListOfIndexedDataMapOfShapeListOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TNaming_ListOfIndexedDataMapOfShapeListOfShape_3 extends TNaming_ListOfIndexedDataMapOfShapeListOfShape {
    constructor(theOther: TNaming_ListOfIndexedDataMapOfShapeListOfShape);
  }

export declare class TNaming_Tool {
  constructor();
  static CurrentShape_1(NS: Handle_TNaming_NamedShape): TopoDS_Shape;
  static CurrentShape_2(NS: Handle_TNaming_NamedShape, Updated: TDF_LabelMap): TopoDS_Shape;
  static CurrentNamedShape_1(NS: Handle_TNaming_NamedShape, Updated: TDF_LabelMap): Handle_TNaming_NamedShape;
  static CurrentNamedShape_2(NS: Handle_TNaming_NamedShape): Handle_TNaming_NamedShape;
  static NamedShape(aShape: TopoDS_Shape, anAcces: TDF_Label): Handle_TNaming_NamedShape;
  static GetShape(NS: Handle_TNaming_NamedShape): TopoDS_Shape;
  static OriginalShape(NS: Handle_TNaming_NamedShape): TopoDS_Shape;
  static GeneratedShape(S: TopoDS_Shape, Generation: Handle_TNaming_NamedShape): TopoDS_Shape;
  static Collect(NS: Handle_TNaming_NamedShape, Labels: TNaming_MapOfNamedShape, OnlyModif: Standard_Boolean): void;
  static HasLabel_1(access: TDF_Label, aShape: TopoDS_Shape): Standard_Boolean;
  static Label_1(access: TDF_Label, aShape: TopoDS_Shape, TransDef: Graphic3d_ZLayerId): TDF_Label;
  static InitialShape(aShape: TopoDS_Shape, anAcces: TDF_Label, Labels: TDF_LabelList): TopoDS_Shape;
  static ValidUntil_1(access: TDF_Label, S: TopoDS_Shape): Graphic3d_ZLayerId;
  static FindShape(Valid: TDF_LabelMap, Forbiden: TDF_LabelMap, Arg: Handle_TNaming_NamedShape, S: TopoDS_Shape): void;
  delete(): void;
}

export declare class TNaming_NamingTool {
  constructor();
  static CurrentShape(Valid: TDF_LabelMap, Forbiden: TDF_LabelMap, NS: Handle_TNaming_NamedShape, MS: TopTools_IndexedMapOfShape): void;
  static CurrentShapeFromShape(Valid: TDF_LabelMap, Forbiden: TDF_LabelMap, Acces: TDF_Label, S: TopoDS_Shape, MS: TopTools_IndexedMapOfShape): void;
  static BuildDescendants(NS: Handle_TNaming_NamedShape, Labels: TDF_LabelMap): void;
  delete(): void;
}

export declare class TNaming_Name {
  constructor()
  Type_1(aType: TNaming_NameType): void;
  ShapeType_1(aType: TopAbs_ShapeEnum): void;
  Shape_1(theShape: TopoDS_Shape): void;
  Append(arg: Handle_TNaming_NamedShape): void;
  StopNamedShape_1(arg: Handle_TNaming_NamedShape): void;
  Index_1(I: Graphic3d_ZLayerId): void;
  ContextLabel_1(theLab: TDF_Label): void;
  Orientation_1(theOrientation: TopAbs_Orientation): void;
  Type_2(): TNaming_NameType;
  ShapeType_2(): TopAbs_ShapeEnum;
  Shape_2(): TopoDS_Shape;
  Arguments(): TNaming_ListOfNamedShape;
  StopNamedShape_2(): Handle_TNaming_NamedShape;
  Index_2(): Graphic3d_ZLayerId;
  ContextLabel_2(): TDF_Label;
  Orientation_2(): TopAbs_Orientation;
  Solve(aLab: TDF_Label, Valid: TDF_LabelMap): Standard_Boolean;
  Paste(into: TNaming_Name, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type TNaming_NameType = {
  TNaming_UNKNOWN: {};
  TNaming_IDENTITY: {};
  TNaming_MODIFUNTIL: {};
  TNaming_GENERATION: {};
  TNaming_INTERSECTION: {};
  TNaming_UNION: {};
  TNaming_SUBSTRACTION: {};
  TNaming_CONSTSHAPE: {};
  TNaming_FILTERBYNEIGHBOURGS: {};
  TNaming_ORIENTATION: {};
  TNaming_WIREIN: {};
  TNaming_SHELLIN: {};
}

export declare type TNaming_Evolution = {
  TNaming_PRIMITIVE: {};
  TNaming_GENERATED: {};
  TNaming_MODIFY: {};
  TNaming_DELETE: {};
  TNaming_REPLACE: {};
  TNaming_SELECTED: {};
}

export declare class Handle_TNaming_NamedShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TNaming_NamedShape): void;
  get(): TNaming_NamedShape;
  delete(): void;
}

  export declare class Handle_TNaming_NamedShape_1 extends Handle_TNaming_NamedShape {
    constructor();
  }

  export declare class Handle_TNaming_NamedShape_2 extends Handle_TNaming_NamedShape {
    constructor(thePtr: TNaming_NamedShape);
  }

  export declare class Handle_TNaming_NamedShape_3 extends Handle_TNaming_NamedShape {
    constructor(theHandle: Handle_TNaming_NamedShape);
  }

  export declare class Handle_TNaming_NamedShape_4 extends Handle_TNaming_NamedShape {
    constructor(theHandle: Handle_TNaming_NamedShape);
  }

export declare class TNaming_NamedShape extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  IsEmpty(): Standard_Boolean;
  Get(): TopoDS_Shape;
  Evolution(): TNaming_Evolution;
  Version(): Graphic3d_ZLayerId;
  SetVersion(version: Graphic3d_ZLayerId): void;
  Clear(): void;
  ID(): Standard_GUID;
  BackupCopy(): Handle_TDF_Attribute;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  DeltaOnModification_1(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DeltaOnModification_2(aDelta: Handle_TDF_DeltaOnModification): void;
  DeltaOnRemoval(): Handle_TDF_DeltaOnRemoval;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocTationable: Handle_TDF_RelocationTable): void;
  References(aDataSet: Handle_TDF_DataSet): void;
  BeforeRemoval(): void;
  BeforeUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TNaming_DeltaOnModification extends TDF_DeltaOnModification {
  constructor(NS: Handle_TNaming_NamedShape)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TNaming_DeltaOnModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TNaming_DeltaOnModification): void;
  get(): TNaming_DeltaOnModification;
  delete(): void;
}

  export declare class Handle_TNaming_DeltaOnModification_1 extends Handle_TNaming_DeltaOnModification {
    constructor();
  }

  export declare class Handle_TNaming_DeltaOnModification_2 extends Handle_TNaming_DeltaOnModification {
    constructor(thePtr: TNaming_DeltaOnModification);
  }

  export declare class Handle_TNaming_DeltaOnModification_3 extends Handle_TNaming_DeltaOnModification {
    constructor(theHandle: Handle_TNaming_DeltaOnModification);
  }

  export declare class Handle_TNaming_DeltaOnModification_4 extends Handle_TNaming_DeltaOnModification {
    constructor(theHandle: Handle_TNaming_DeltaOnModification);
  }

export declare class Handle_ShapeAnalysis_FreeBoundData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAnalysis_FreeBoundData): void;
  get(): ShapeAnalysis_FreeBoundData;
  delete(): void;
}

  export declare class Handle_ShapeAnalysis_FreeBoundData_1 extends Handle_ShapeAnalysis_FreeBoundData {
    constructor();
  }

  export declare class Handle_ShapeAnalysis_FreeBoundData_2 extends Handle_ShapeAnalysis_FreeBoundData {
    constructor(thePtr: ShapeAnalysis_FreeBoundData);
  }

  export declare class Handle_ShapeAnalysis_FreeBoundData_3 extends Handle_ShapeAnalysis_FreeBoundData {
    constructor(theHandle: Handle_ShapeAnalysis_FreeBoundData);
  }

  export declare class Handle_ShapeAnalysis_FreeBoundData_4 extends Handle_ShapeAnalysis_FreeBoundData {
    constructor(theHandle: Handle_ShapeAnalysis_FreeBoundData);
  }

export declare class ShapeAnalysis_FreeBoundData extends Standard_Transient {
  Clear(): void;
  SetFreeBound(freebound: TopoDS_Wire): void;
  SetArea(area: Quantity_AbsorbedDose): void;
  SetPerimeter(perimeter: Quantity_AbsorbedDose): void;
  SetRatio(ratio: Quantity_AbsorbedDose): void;
  SetWidth(width: Quantity_AbsorbedDose): void;
  AddNotch(notch: TopoDS_Wire, width: Quantity_AbsorbedDose): void;
  FreeBound(): TopoDS_Wire;
  Area(): Quantity_AbsorbedDose;
  Perimeter(): Quantity_AbsorbedDose;
  Ratio(): Quantity_AbsorbedDose;
  Width(): Quantity_AbsorbedDose;
  NbNotches(): Graphic3d_ZLayerId;
  Notches(): Handle_TopTools_HSequenceOfShape;
  Notch(index: Graphic3d_ZLayerId): TopoDS_Wire;
  NotchWidth_1(index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NotchWidth_2(notch: TopoDS_Wire): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeAnalysis_FreeBoundData_1 extends ShapeAnalysis_FreeBoundData {
    constructor();
  }

  export declare class ShapeAnalysis_FreeBoundData_2 extends ShapeAnalysis_FreeBoundData {
    constructor(freebound: TopoDS_Wire);
  }

export declare class Handle_ShapeAnalysis_HSequenceOfFreeBounds {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAnalysis_HSequenceOfFreeBounds): void;
  get(): ShapeAnalysis_HSequenceOfFreeBounds;
  delete(): void;
}

  export declare class Handle_ShapeAnalysis_HSequenceOfFreeBounds_1 extends Handle_ShapeAnalysis_HSequenceOfFreeBounds {
    constructor();
  }

  export declare class Handle_ShapeAnalysis_HSequenceOfFreeBounds_2 extends Handle_ShapeAnalysis_HSequenceOfFreeBounds {
    constructor(thePtr: ShapeAnalysis_HSequenceOfFreeBounds);
  }

  export declare class Handle_ShapeAnalysis_HSequenceOfFreeBounds_3 extends Handle_ShapeAnalysis_HSequenceOfFreeBounds {
    constructor(theHandle: Handle_ShapeAnalysis_HSequenceOfFreeBounds);
  }

  export declare class Handle_ShapeAnalysis_HSequenceOfFreeBounds_4 extends Handle_ShapeAnalysis_HSequenceOfFreeBounds {
    constructor(theHandle: Handle_ShapeAnalysis_HSequenceOfFreeBounds);
  }

export declare class Handle_ShapeAnalysis_TransferParameters {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAnalysis_TransferParameters): void;
  get(): ShapeAnalysis_TransferParameters;
  delete(): void;
}

  export declare class Handle_ShapeAnalysis_TransferParameters_1 extends Handle_ShapeAnalysis_TransferParameters {
    constructor();
  }

  export declare class Handle_ShapeAnalysis_TransferParameters_2 extends Handle_ShapeAnalysis_TransferParameters {
    constructor(thePtr: ShapeAnalysis_TransferParameters);
  }

  export declare class Handle_ShapeAnalysis_TransferParameters_3 extends Handle_ShapeAnalysis_TransferParameters {
    constructor(theHandle: Handle_ShapeAnalysis_TransferParameters);
  }

  export declare class Handle_ShapeAnalysis_TransferParameters_4 extends Handle_ShapeAnalysis_TransferParameters {
    constructor(theHandle: Handle_ShapeAnalysis_TransferParameters);
  }

export declare class ShapeAnalysis_TransferParameters extends Standard_Transient {
  Init(E: TopoDS_Edge, F: TopoDS_Face): void;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  Perform_1(Params: Handle_TColStd_HSequenceOfReal, To2d: Standard_Boolean): Handle_TColStd_HSequenceOfReal;
  Perform_2(Param: Quantity_AbsorbedDose, To2d: Standard_Boolean): Quantity_AbsorbedDose;
  TransferRange(newEdge: TopoDS_Edge, prevPar: Quantity_AbsorbedDose, currPar: Quantity_AbsorbedDose, To2d: Standard_Boolean): void;
  IsSameRange(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeAnalysis_TransferParameters_1 extends ShapeAnalysis_TransferParameters {
    constructor();
  }

  export declare class ShapeAnalysis_TransferParameters_2 extends ShapeAnalysis_TransferParameters {
    constructor(E: TopoDS_Edge, F: TopoDS_Face);
  }

export declare class ShapeAnalysis_ShapeTolerance {
  constructor()
  Tolerance(shape: TopoDS_Shape, mode: Graphic3d_ZLayerId, type: TopAbs_ShapeEnum): Quantity_AbsorbedDose;
  OverTolerance(shape: TopoDS_Shape, value: Quantity_AbsorbedDose, type: TopAbs_ShapeEnum): Handle_TopTools_HSequenceOfShape;
  InTolerance(shape: TopoDS_Shape, valmin: Quantity_AbsorbedDose, valmax: Quantity_AbsorbedDose, type: TopAbs_ShapeEnum): Handle_TopTools_HSequenceOfShape;
  InitTolerance(): void;
  AddTolerance(shape: TopoDS_Shape, type: TopAbs_ShapeEnum): void;
  GlobalTolerance(mode: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class ShapeAnalysis_WireOrder {
  SetMode(mode3d: Standard_Boolean, tol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  Clear(): void;
  Add_1(start3d: gp_XYZ, end3d: gp_XYZ): void;
  Add_2(start2d: gp_XY, end2d: gp_XY): void;
  NbEdges(): Graphic3d_ZLayerId;
  KeepLoopsMode(): Standard_Boolean;
  Perform(closed: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Status(): Graphic3d_ZLayerId;
  Ordered(n: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  XYZ(num: Graphic3d_ZLayerId, start3d: gp_XYZ, end3d: gp_XYZ): void;
  XY(num: Graphic3d_ZLayerId, start2d: gp_XY, end2d: gp_XY): void;
  Gap(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetChains(gap: Quantity_AbsorbedDose): void;
  NbChains(): Graphic3d_ZLayerId;
  Chain(num: Graphic3d_ZLayerId, n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): void;
  SetCouples(gap: Quantity_AbsorbedDose): void;
  NbCouples(): Graphic3d_ZLayerId;
  Couple(num: Graphic3d_ZLayerId, n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class ShapeAnalysis_WireOrder_1 extends ShapeAnalysis_WireOrder {
    constructor();
  }

  export declare class ShapeAnalysis_WireOrder_2 extends ShapeAnalysis_WireOrder {
    constructor(mode3d: Standard_Boolean, tol: Quantity_AbsorbedDose);
  }

export declare class ShapeAnalysis_Shell {
  constructor()
  Clear(): void;
  LoadShells(shape: TopoDS_Shape): void;
  CheckOrientedShells(shape: TopoDS_Shape, alsofree: Standard_Boolean, checkinternaledges: Standard_Boolean): Standard_Boolean;
  IsLoaded(shape: TopoDS_Shape): Standard_Boolean;
  NbLoaded(): Graphic3d_ZLayerId;
  Loaded(num: Graphic3d_ZLayerId): TopoDS_Shape;
  HasBadEdges(): Standard_Boolean;
  BadEdges(): TopoDS_Compound;
  HasFreeEdges(): Standard_Boolean;
  FreeEdges(): TopoDS_Compound;
  HasConnectedEdges(): Standard_Boolean;
  delete(): void;
}

export declare class ShapeAnalysis_Wire extends Standard_Transient {
  Init_1(wire: TopoDS_Wire, face: TopoDS_Face, precision: Quantity_AbsorbedDose): void;
  Init_2(sbwd: Handle_ShapeExtend_WireData, face: TopoDS_Face, precision: Quantity_AbsorbedDose): void;
  Load_1(wire: TopoDS_Wire): void;
  Load_2(sbwd: Handle_ShapeExtend_WireData): void;
  SetFace(face: TopoDS_Face): void;
  SetSurface_1(surface: Handle_Geom_Surface): void;
  SetSurface_2(surface: Handle_Geom_Surface, location: TopLoc_Location): void;
  SetPrecision(precision: Quantity_AbsorbedDose): void;
  ClearStatuses(): void;
  IsLoaded(): Standard_Boolean;
  IsReady(): Standard_Boolean;
  Precision(): Quantity_AbsorbedDose;
  WireData(): Handle_ShapeExtend_WireData;
  NbEdges(): Graphic3d_ZLayerId;
  Face(): TopoDS_Face;
  Surface(): Handle_ShapeAnalysis_Surface;
  Perform(): Standard_Boolean;
  CheckOrder_1(isClosed: Standard_Boolean, mode3d: Standard_Boolean): Standard_Boolean;
  CheckConnected_1(prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSmall_1(precsmall: Quantity_AbsorbedDose): Standard_Boolean;
  CheckEdgeCurves(): Standard_Boolean;
  CheckDegenerated_1(): Standard_Boolean;
  CheckClosed(prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSelfIntersection(): Standard_Boolean;
  CheckLacking_1(): Standard_Boolean;
  CheckGaps3d(): Standard_Boolean;
  CheckGaps2d(): Standard_Boolean;
  CheckCurveGaps(): Standard_Boolean;
  CheckOrder_2(sawo: ShapeAnalysis_WireOrder, isClosed: Standard_Boolean, mode3d: Standard_Boolean): Standard_Boolean;
  CheckConnected_2(num: Graphic3d_ZLayerId, prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSmall_2(num: Graphic3d_ZLayerId, precsmall: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSeam_1(num: Graphic3d_ZLayerId, C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve, cf: Quantity_AbsorbedDose, cl: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSeam_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckDegenerated_2(num: Graphic3d_ZLayerId, dgnr1: gp_Pnt2d, dgnr2: gp_Pnt2d): Standard_Boolean;
  CheckDegenerated_3(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckGap3d(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckGap2d(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckCurveGap(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckSelfIntersectingEdge_1(num: Graphic3d_ZLayerId, points2d: IntRes2d_SequenceOfIntersectionPoint, points3d: TColgp_SequenceOfPnt): Standard_Boolean;
  CheckSelfIntersectingEdge_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckIntersectingEdges_1(num: Graphic3d_ZLayerId, points2d: IntRes2d_SequenceOfIntersectionPoint, points3d: TColgp_SequenceOfPnt, errors: TColStd_SequenceOfReal): Standard_Boolean;
  CheckIntersectingEdges_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  CheckIntersectingEdges_3(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId, points2d: IntRes2d_SequenceOfIntersectionPoint, points3d: TColgp_SequenceOfPnt, errors: TColStd_SequenceOfReal): Standard_Boolean;
  CheckIntersectingEdges_4(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Standard_Boolean;
  CheckLacking_2(num: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose, p2d1: gp_Pnt2d, p2d2: gp_Pnt2d): Standard_Boolean;
  CheckLacking_3(num: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  CheckOuterBound(APIMake: Standard_Boolean): Standard_Boolean;
  CheckNotchedEdges(num: Graphic3d_ZLayerId, shortNum: Graphic3d_ZLayerId, param: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSmallArea(theWire: TopoDS_Wire): Standard_Boolean;
  CheckShapeConnect_1(shape: TopoDS_Shape, prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckShapeConnect_2(tailhead: Quantity_AbsorbedDose, tailtail: Quantity_AbsorbedDose, headtail: Quantity_AbsorbedDose, headhead: Quantity_AbsorbedDose, shape: TopoDS_Shape, prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckLoop(aMapLoopVertices: TopTools_IndexedMapOfShape, aMapVertexEdges: TopTools_DataMapOfShapeListOfShape, aMapSmallEdges: TopTools_MapOfShape, aMapSeemEdges: TopTools_MapOfShape): Standard_Boolean;
  CheckTail(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, theMaxSine: Quantity_AbsorbedDose, theMaxWidth: Quantity_AbsorbedDose, theMaxTolerance: Quantity_AbsorbedDose, theEdge11: TopoDS_Edge, theEdge12: TopoDS_Edge, theEdge21: TopoDS_Edge, theEdge22: TopoDS_Edge): Standard_Boolean;
  StatusOrder(Status: ShapeExtend_Status): Standard_Boolean;
  StatusConnected(Status: ShapeExtend_Status): Standard_Boolean;
  StatusEdgeCurves(Status: ShapeExtend_Status): Standard_Boolean;
  StatusDegenerated(Status: ShapeExtend_Status): Standard_Boolean;
  StatusClosed(Status: ShapeExtend_Status): Standard_Boolean;
  StatusSmall(Status: ShapeExtend_Status): Standard_Boolean;
  StatusSelfIntersection(Status: ShapeExtend_Status): Standard_Boolean;
  StatusLacking(Status: ShapeExtend_Status): Standard_Boolean;
  StatusGaps3d(Status: ShapeExtend_Status): Standard_Boolean;
  StatusGaps2d(Status: ShapeExtend_Status): Standard_Boolean;
  StatusCurveGaps(Status: ShapeExtend_Status): Standard_Boolean;
  StatusLoop(Status: ShapeExtend_Status): Standard_Boolean;
  LastCheckStatus(Status: ShapeExtend_Status): Standard_Boolean;
  MinDistance3d(): Quantity_AbsorbedDose;
  MinDistance2d(): Quantity_AbsorbedDose;
  MaxDistance3d(): Quantity_AbsorbedDose;
  MaxDistance2d(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeAnalysis_Wire_1 extends ShapeAnalysis_Wire {
    constructor();
  }

  export declare class ShapeAnalysis_Wire_2 extends ShapeAnalysis_Wire {
    constructor(wire: TopoDS_Wire, face: TopoDS_Face, precision: Quantity_AbsorbedDose);
  }

  export declare class ShapeAnalysis_Wire_3 extends ShapeAnalysis_Wire {
    constructor(sbwd: Handle_ShapeExtend_WireData, face: TopoDS_Face, precision: Quantity_AbsorbedDose);
  }

export declare class Handle_ShapeAnalysis_Wire {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAnalysis_Wire): void;
  get(): ShapeAnalysis_Wire;
  delete(): void;
}

  export declare class Handle_ShapeAnalysis_Wire_1 extends Handle_ShapeAnalysis_Wire {
    constructor();
  }

  export declare class Handle_ShapeAnalysis_Wire_2 extends Handle_ShapeAnalysis_Wire {
    constructor(thePtr: ShapeAnalysis_Wire);
  }

  export declare class Handle_ShapeAnalysis_Wire_3 extends Handle_ShapeAnalysis_Wire {
    constructor(theHandle: Handle_ShapeAnalysis_Wire);
  }

  export declare class Handle_ShapeAnalysis_Wire_4 extends Handle_ShapeAnalysis_Wire {
    constructor(theHandle: Handle_ShapeAnalysis_Wire);
  }

export declare class ShapeAnalysis {
  constructor();
  static OuterWire(face: TopoDS_Face): TopoDS_Wire;
  static TotCross2D(sewd: Handle_ShapeExtend_WireData, aFace: TopoDS_Face): Quantity_AbsorbedDose;
  static ContourArea(theWire: TopoDS_Wire): Quantity_AbsorbedDose;
  static IsOuterBound(face: TopoDS_Face): Standard_Boolean;
  static AdjustByPeriod(Val: Quantity_AbsorbedDose, ToVal: Quantity_AbsorbedDose, Period: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static AdjustToPeriod(Val: Quantity_AbsorbedDose, ValMin: Quantity_AbsorbedDose, ValMax: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static FindBounds(shape: TopoDS_Shape, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  static GetFaceUVBounds(F: TopoDS_Face, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class ShapeAnalysis_TransferParametersProj extends ShapeAnalysis_TransferParameters {
  Init(E: TopoDS_Edge, F: TopoDS_Face): void;
  Perform_1(Papams: Handle_TColStd_HSequenceOfReal, To2d: Standard_Boolean): Handle_TColStd_HSequenceOfReal;
  Perform_2(Param: Quantity_AbsorbedDose, To2d: Standard_Boolean): Quantity_AbsorbedDose;
  ForceProjection(): Standard_Boolean;
  TransferRange(newEdge: TopoDS_Edge, prevPar: Quantity_AbsorbedDose, currPar: Quantity_AbsorbedDose, Is2d: Standard_Boolean): void;
  IsSameRange(): Standard_Boolean;
  static CopyNMVertex_1(theVert: TopoDS_Vertex, toedge: TopoDS_Edge, fromedge: TopoDS_Edge): TopoDS_Vertex;
  static CopyNMVertex_2(theVert: TopoDS_Vertex, toFace: TopoDS_Face, fromFace: TopoDS_Face): TopoDS_Vertex;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeAnalysis_TransferParametersProj_1 extends ShapeAnalysis_TransferParametersProj {
    constructor();
  }

  export declare class ShapeAnalysis_TransferParametersProj_2 extends ShapeAnalysis_TransferParametersProj {
    constructor(E: TopoDS_Edge, F: TopoDS_Face);
  }

export declare class Handle_ShapeAnalysis_TransferParametersProj {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAnalysis_TransferParametersProj): void;
  get(): ShapeAnalysis_TransferParametersProj;
  delete(): void;
}

  export declare class Handle_ShapeAnalysis_TransferParametersProj_1 extends Handle_ShapeAnalysis_TransferParametersProj {
    constructor();
  }

  export declare class Handle_ShapeAnalysis_TransferParametersProj_2 extends Handle_ShapeAnalysis_TransferParametersProj {
    constructor(thePtr: ShapeAnalysis_TransferParametersProj);
  }

  export declare class Handle_ShapeAnalysis_TransferParametersProj_3 extends Handle_ShapeAnalysis_TransferParametersProj {
    constructor(theHandle: Handle_ShapeAnalysis_TransferParametersProj);
  }

  export declare class Handle_ShapeAnalysis_TransferParametersProj_4 extends Handle_ShapeAnalysis_TransferParametersProj {
    constructor(theHandle: Handle_ShapeAnalysis_TransferParametersProj);
  }

export declare class ShapeAnalysis_Curve {
  constructor();
  Project_1(C3D: Handle_Geom_Curve, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, proj: gp_Pnt, param: Quantity_AbsorbedDose, AdjustToEnds: Standard_Boolean): Quantity_AbsorbedDose;
  Project_2(C3D: Adaptor3d_Curve, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, proj: gp_Pnt, param: Quantity_AbsorbedDose, AdjustToEnds: Standard_Boolean): Quantity_AbsorbedDose;
  Project_3(C3D: Handle_Geom_Curve, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, proj: gp_Pnt, param: Quantity_AbsorbedDose, cf: Quantity_AbsorbedDose, cl: Quantity_AbsorbedDose, AdjustToEnds: Standard_Boolean): Quantity_AbsorbedDose;
  ProjectAct(C3D: Adaptor3d_Curve, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, proj: gp_Pnt, param: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  NextProject_1(paramPrev: Quantity_AbsorbedDose, C3D: Handle_Geom_Curve, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, proj: gp_Pnt, param: Quantity_AbsorbedDose, cf: Quantity_AbsorbedDose, cl: Quantity_AbsorbedDose, AdjustToEnds: Standard_Boolean): Quantity_AbsorbedDose;
  NextProject_2(paramPrev: Quantity_AbsorbedDose, C3D: Adaptor3d_Curve, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, proj: gp_Pnt, param: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  ValidateRange(Crv: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FillBndBox(C2d: Handle_Geom2d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, NPoints: Graphic3d_ZLayerId, Exact: Standard_Boolean, Box: Bnd_Box2d): void;
  SelectForwardSeam(C1: Handle_Geom2d_Curve, C2: Handle_Geom2d_Curve): Graphic3d_ZLayerId;
  static IsPlanar_1(pnts: TColgp_Array1OfPnt, Normal: gp_XYZ, preci: Quantity_AbsorbedDose): Standard_Boolean;
  static IsPlanar_2(curve: Handle_Geom_Curve, Normal: gp_XYZ, preci: Quantity_AbsorbedDose): Standard_Boolean;
  static GetSamplePoints_1(curve: Handle_Geom2d_Curve, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose, seq: TColgp_SequenceOfPnt2d): Standard_Boolean;
  static GetSamplePoints_2(curve: Handle_Geom_Curve, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose, seq: TColgp_SequenceOfPnt): Standard_Boolean;
  static IsClosed(curve: Handle_Geom_Curve, preci: Quantity_AbsorbedDose): Standard_Boolean;
  static IsPeriodic_1(curve: Handle_Geom_Curve): Standard_Boolean;
  static IsPeriodic_2(curve: Handle_Geom2d_Curve): Standard_Boolean;
  delete(): void;
}

export declare class ShapeAnalysis_ShapeContents {
  constructor()
  Clear(): void;
  ClearFlags(): void;
  Perform(shape: TopoDS_Shape): void;
  ModifyBigSplineMode(): Standard_Boolean;
  ModifyIndirectMode(): Standard_Boolean;
  ModifyOffestSurfaceMode(): Standard_Boolean;
  ModifyTrimmed3dMode(): Standard_Boolean;
  ModifyOffsetCurveMode(): Standard_Boolean;
  ModifyTrimmed2dMode(): Standard_Boolean;
  NbSolids(): Graphic3d_ZLayerId;
  NbShells(): Graphic3d_ZLayerId;
  NbFaces(): Graphic3d_ZLayerId;
  NbWires(): Graphic3d_ZLayerId;
  NbEdges(): Graphic3d_ZLayerId;
  NbVertices(): Graphic3d_ZLayerId;
  NbSolidsWithVoids(): Graphic3d_ZLayerId;
  NbBigSplines(): Graphic3d_ZLayerId;
  NbC0Surfaces(): Graphic3d_ZLayerId;
  NbC0Curves(): Graphic3d_ZLayerId;
  NbOffsetSurf(): Graphic3d_ZLayerId;
  NbIndirectSurf(): Graphic3d_ZLayerId;
  NbOffsetCurves(): Graphic3d_ZLayerId;
  NbTrimmedCurve2d(): Graphic3d_ZLayerId;
  NbTrimmedCurve3d(): Graphic3d_ZLayerId;
  NbBSplibeSurf(): Graphic3d_ZLayerId;
  NbBezierSurf(): Graphic3d_ZLayerId;
  NbTrimSurf(): Graphic3d_ZLayerId;
  NbWireWitnSeam(): Graphic3d_ZLayerId;
  NbWireWithSevSeams(): Graphic3d_ZLayerId;
  NbFaceWithSevWires(): Graphic3d_ZLayerId;
  NbNoPCurve(): Graphic3d_ZLayerId;
  NbFreeFaces(): Graphic3d_ZLayerId;
  NbFreeWires(): Graphic3d_ZLayerId;
  NbFreeEdges(): Graphic3d_ZLayerId;
  NbSharedSolids(): Graphic3d_ZLayerId;
  NbSharedShells(): Graphic3d_ZLayerId;
  NbSharedFaces(): Graphic3d_ZLayerId;
  NbSharedWires(): Graphic3d_ZLayerId;
  NbSharedFreeWires(): Graphic3d_ZLayerId;
  NbSharedFreeEdges(): Graphic3d_ZLayerId;
  NbSharedEdges(): Graphic3d_ZLayerId;
  NbSharedVertices(): Graphic3d_ZLayerId;
  BigSplineSec(): Handle_TopTools_HSequenceOfShape;
  IndirectSec(): Handle_TopTools_HSequenceOfShape;
  OffsetSurfaceSec(): Handle_TopTools_HSequenceOfShape;
  Trimmed3dSec(): Handle_TopTools_HSequenceOfShape;
  OffsetCurveSec(): Handle_TopTools_HSequenceOfShape;
  Trimmed2dSec(): Handle_TopTools_HSequenceOfShape;
  delete(): void;
}

export declare class ShapeAnalysis_CheckSmallFace {
  constructor()
  IsSpotFace(F: TopoDS_Face, spot: gp_Pnt, spotol: Quantity_AbsorbedDose, tol: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  CheckSpotFace(F: TopoDS_Face, tol: Quantity_AbsorbedDose): Standard_Boolean;
  IsStripSupport(F: TopoDS_Face, tol: Quantity_AbsorbedDose): Standard_Boolean;
  CheckStripEdges(E1: TopoDS_Edge, E2: TopoDS_Edge, tol: Quantity_AbsorbedDose, dmax: Quantity_AbsorbedDose): Standard_Boolean;
  FindStripEdges(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, tol: Quantity_AbsorbedDose, dmax: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSingleStrip(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, tol: Quantity_AbsorbedDose): Standard_Boolean;
  CheckStripFace(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, tol: Quantity_AbsorbedDose): Standard_Boolean;
  CheckSplittingVertices(F: TopoDS_Face, MapEdges: TopTools_DataMapOfShapeListOfShape, MapParam: ShapeAnalysis_DataMapOfShapeListOfReal, theAllVert: TopoDS_Compound): Graphic3d_ZLayerId;
  CheckPin(F: TopoDS_Face, whatrow: Graphic3d_ZLayerId, sence: Graphic3d_ZLayerId): Standard_Boolean;
  CheckTwisted(F: TopoDS_Face, paramu: Quantity_AbsorbedDose, paramv: Quantity_AbsorbedDose): Standard_Boolean;
  CheckPinFace(F: TopoDS_Face, mapEdges: TopTools_DataMapOfShapeShape, toler: Quantity_AbsorbedDose): Standard_Boolean;
  CheckPinEdges(theFirstEdge: TopoDS_Edge, theSecondEdge: TopoDS_Edge, coef1: Quantity_AbsorbedDose, coef2: Quantity_AbsorbedDose, toler: Quantity_AbsorbedDose): Standard_Boolean;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  SetTolerance(tol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  StatusSpot(status: ShapeExtend_Status): Standard_Boolean;
  StatusStrip(status: ShapeExtend_Status): Standard_Boolean;
  StatusPin(status: ShapeExtend_Status): Standard_Boolean;
  StatusTwisted(status: ShapeExtend_Status): Standard_Boolean;
  StatusSplitVert(status: ShapeExtend_Status): Standard_Boolean;
  StatusPinFace(status: ShapeExtend_Status): Standard_Boolean;
  StatusPinEdges(status: ShapeExtend_Status): Standard_Boolean;
  delete(): void;
}

export declare class ShapeAnalysis_BoxBndTreeSelector {
  constructor(theSeq: Handle_TopTools_HArray1OfShape, theShared: Standard_Boolean)
  DefineBoxes(theFBox: Bnd_Box, theLBox: Bnd_Box): void;
  DefineVertexes(theVf: TopoDS_Vertex, theVl: TopoDS_Vertex): void;
  DefinePnt(theFPnt: gp_Pnt, theLPnt: gp_Pnt): void;
  GetNb(): Graphic3d_ZLayerId;
  SetNb(theNb: Graphic3d_ZLayerId): void;
  LoadList(elem: Graphic3d_ZLayerId): void;
  SetStop(): void;
  SetTolerance(theTol: Quantity_AbsorbedDose): void;
  ContWire(nbWire: Graphic3d_ZLayerId): Standard_Boolean;
  LastCheckStatus(theStatus: ShapeExtend_Status): Standard_Boolean;
  Reject(theBnd: Bnd_Box): Standard_Boolean;
  Accept(a0: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class ShapeAnalysis_Geom {
  constructor();
  static NearestPlane(Pnts: TColgp_Array1OfPnt, aPln: gp_Pln, Dmax: Quantity_AbsorbedDose): Standard_Boolean;
  static PositionTrsf(coefs: Handle_TColStd_HArray2OfReal, trsf: gp_Trsf, unit: Quantity_AbsorbedDose, prec: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class ShapeAnalysis_FreeBoundsProperties {
  Init_1(shape: TopoDS_Shape, tolerance: Quantity_AbsorbedDose, splitclosed: Standard_Boolean, splitopen: Standard_Boolean): void;
  Init_2(shape: TopoDS_Shape, splitclosed: Standard_Boolean, splitopen: Standard_Boolean): void;
  Perform(): Standard_Boolean;
  IsLoaded(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  Tolerance(): Quantity_AbsorbedDose;
  NbFreeBounds(): Graphic3d_ZLayerId;
  NbClosedFreeBounds(): Graphic3d_ZLayerId;
  NbOpenFreeBounds(): Graphic3d_ZLayerId;
  ClosedFreeBounds(): Handle_ShapeAnalysis_HSequenceOfFreeBounds;
  OpenFreeBounds(): Handle_ShapeAnalysis_HSequenceOfFreeBounds;
  ClosedFreeBound(index: Graphic3d_ZLayerId): Handle_ShapeAnalysis_FreeBoundData;
  OpenFreeBound(index: Graphic3d_ZLayerId): Handle_ShapeAnalysis_FreeBoundData;
  DispatchBounds(): Standard_Boolean;
  CheckContours(prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckNotches_1(prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckNotches_2(fbData: Handle_ShapeAnalysis_FreeBoundData, prec: Quantity_AbsorbedDose): Standard_Boolean;
  CheckNotches_3(freebound: TopoDS_Wire, num: Graphic3d_ZLayerId, notch: TopoDS_Wire, distMax: Quantity_AbsorbedDose, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FillProperties(fbData: Handle_ShapeAnalysis_FreeBoundData, prec: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class ShapeAnalysis_FreeBoundsProperties_1 extends ShapeAnalysis_FreeBoundsProperties {
    constructor();
  }

  export declare class ShapeAnalysis_FreeBoundsProperties_2 extends ShapeAnalysis_FreeBoundsProperties {
    constructor(shape: TopoDS_Shape, tolerance: Quantity_AbsorbedDose, splitclosed: Standard_Boolean, splitopen: Standard_Boolean);
  }

  export declare class ShapeAnalysis_FreeBoundsProperties_3 extends ShapeAnalysis_FreeBoundsProperties {
    constructor(shape: TopoDS_Shape, splitclosed: Standard_Boolean, splitopen: Standard_Boolean);
  }

export declare class Handle_ShapeAnalysis_Surface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAnalysis_Surface): void;
  get(): ShapeAnalysis_Surface;
  delete(): void;
}

  export declare class Handle_ShapeAnalysis_Surface_1 extends Handle_ShapeAnalysis_Surface {
    constructor();
  }

  export declare class Handle_ShapeAnalysis_Surface_2 extends Handle_ShapeAnalysis_Surface {
    constructor(thePtr: ShapeAnalysis_Surface);
  }

  export declare class Handle_ShapeAnalysis_Surface_3 extends Handle_ShapeAnalysis_Surface {
    constructor(theHandle: Handle_ShapeAnalysis_Surface);
  }

  export declare class Handle_ShapeAnalysis_Surface_4 extends Handle_ShapeAnalysis_Surface {
    constructor(theHandle: Handle_ShapeAnalysis_Surface);
  }

export declare class ShapeAnalysis_Surface extends Standard_Transient {
  constructor(S: Handle_Geom_Surface)
  Init_1(S: Handle_Geom_Surface): void;
  Init_2(other: Handle_ShapeAnalysis_Surface): void;
  SetDomain(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Surface(): Handle_Geom_Surface;
  Adaptor3d(): Handle_GeomAdaptor_HSurface;
  TrueAdaptor3d(): Handle_GeomAdaptor_HSurface;
  Gap(): Quantity_AbsorbedDose;
  Value_1(u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): gp_Pnt;
  Value_2(p2d: gp_Pnt2d): gp_Pnt;
  HasSingularities(preci: Quantity_AbsorbedDose): Standard_Boolean;
  NbSingularities(preci: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Singularity(num: Graphic3d_ZLayerId, preci: Quantity_AbsorbedDose, P3d: gp_Pnt, firstP2d: gp_Pnt2d, lastP2d: gp_Pnt2d, firstpar: Quantity_AbsorbedDose, lastpar: Quantity_AbsorbedDose, uisodeg: Standard_Boolean): Standard_Boolean;
  IsDegenerated_1(P3d: gp_Pnt, preci: Quantity_AbsorbedDose): Standard_Boolean;
  DegeneratedValues(P3d: gp_Pnt, preci: Quantity_AbsorbedDose, firstP2d: gp_Pnt2d, lastP2d: gp_Pnt2d, firstpar: Quantity_AbsorbedDose, lastpar: Quantity_AbsorbedDose, forward: Standard_Boolean): Standard_Boolean;
  ProjectDegenerated_1(P3d: gp_Pnt, preci: Quantity_AbsorbedDose, neighbour: gp_Pnt2d, result: gp_Pnt2d): Standard_Boolean;
  ProjectDegenerated_2(nbrPnt: Graphic3d_ZLayerId, points: TColgp_SequenceOfPnt, pnt2d: TColgp_SequenceOfPnt2d, preci: Quantity_AbsorbedDose, direct: Standard_Boolean): Standard_Boolean;
  IsDegenerated_2(p2d1: gp_Pnt2d, p2d2: gp_Pnt2d, tol: Quantity_AbsorbedDose, ratio: Quantity_AbsorbedDose): Standard_Boolean;
  Bounds(ufirst: Quantity_AbsorbedDose, ulast: Quantity_AbsorbedDose, vfirst: Quantity_AbsorbedDose, vlast: Quantity_AbsorbedDose): void;
  ComputeBoundIsos(): void;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  IsUClosed(preci: Quantity_AbsorbedDose): Standard_Boolean;
  IsVClosed(preci: Quantity_AbsorbedDose): Standard_Boolean;
  ValueOfUV(P3D: gp_Pnt, preci: Quantity_AbsorbedDose): gp_Pnt2d;
  NextValueOfUV(p2dPrev: gp_Pnt2d, P3D: gp_Pnt, preci: Quantity_AbsorbedDose, maxpreci: Quantity_AbsorbedDose): gp_Pnt2d;
  UVFromIso(P3D: gp_Pnt, preci: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  UCloseVal(): Quantity_AbsorbedDose;
  VCloseVal(): Quantity_AbsorbedDose;
  GetBoxUF(): Bnd_Box;
  GetBoxUL(): Bnd_Box;
  GetBoxVF(): Bnd_Box;
  GetBoxVL(): Bnd_Box;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeAnalysis_Edge {
  constructor()
  HasCurve3d(edge: TopoDS_Edge): Standard_Boolean;
  Curve3d(edge: TopoDS_Edge, C3d: Handle_Geom_Curve, cf: Quantity_AbsorbedDose, cl: Quantity_AbsorbedDose, orient: Standard_Boolean): Standard_Boolean;
  IsClosed3d(edge: TopoDS_Edge): Standard_Boolean;
  HasPCurve_1(edge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  HasPCurve_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location): Standard_Boolean;
  PCurve_1(edge: TopoDS_Edge, face: TopoDS_Face, C2d: Handle_Geom2d_Curve, cf: Quantity_AbsorbedDose, cl: Quantity_AbsorbedDose, orient: Standard_Boolean): Standard_Boolean;
  PCurve_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location, C2d: Handle_Geom2d_Curve, cf: Quantity_AbsorbedDose, cl: Quantity_AbsorbedDose, orient: Standard_Boolean): Standard_Boolean;
  BoundUV_1(edge: TopoDS_Edge, face: TopoDS_Face, first: gp_Pnt2d, last: gp_Pnt2d): Standard_Boolean;
  BoundUV_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location, first: gp_Pnt2d, last: gp_Pnt2d): Standard_Boolean;
  IsSeam_1(edge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  IsSeam_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location): Standard_Boolean;
  FirstVertex(edge: TopoDS_Edge): TopoDS_Vertex;
  LastVertex(edge: TopoDS_Edge): TopoDS_Vertex;
  GetEndTangent2d_1(edge: TopoDS_Edge, face: TopoDS_Face, atEnd: Standard_Boolean, pos: gp_Pnt2d, tang: gp_Vec2d, dparam: Quantity_AbsorbedDose): Standard_Boolean;
  GetEndTangent2d_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location, atEnd: Standard_Boolean, pos: gp_Pnt2d, tang: gp_Vec2d, dparam: Quantity_AbsorbedDose): Standard_Boolean;
  CheckVerticesWithCurve3d(edge: TopoDS_Edge, preci: Quantity_AbsorbedDose, vtx: Graphic3d_ZLayerId): Standard_Boolean;
  CheckVerticesWithPCurve_1(edge: TopoDS_Edge, face: TopoDS_Face, preci: Quantity_AbsorbedDose, vtx: Graphic3d_ZLayerId): Standard_Boolean;
  CheckVerticesWithPCurve_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location, preci: Quantity_AbsorbedDose, vtx: Graphic3d_ZLayerId): Standard_Boolean;
  CheckVertexTolerance_1(edge: TopoDS_Edge, face: TopoDS_Face, toler1: Quantity_AbsorbedDose, toler2: Quantity_AbsorbedDose): Standard_Boolean;
  CheckVertexTolerance_2(edge: TopoDS_Edge, toler1: Quantity_AbsorbedDose, toler2: Quantity_AbsorbedDose): Standard_Boolean;
  CheckCurve3dWithPCurve_1(edge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  CheckCurve3dWithPCurve_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location): Standard_Boolean;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  CheckSameParameter_1(edge: TopoDS_Edge, maxdev: Quantity_AbsorbedDose, NbControl: Graphic3d_ZLayerId): Standard_Boolean;
  CheckSameParameter_2(theEdge: TopoDS_Edge, theFace: TopoDS_Face, theMaxdev: Quantity_AbsorbedDose, theNbControl: Graphic3d_ZLayerId): Standard_Boolean;
  CheckPCurveRange(theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, thePC: Handle_Geom2d_Curve): Standard_Boolean;
  static ComputeDeviation(CRef: Adaptor3d_Curve, Other: Adaptor3d_Curve, SameParameter: Standard_Boolean, dev: Quantity_AbsorbedDose, NCONTROL: Graphic3d_ZLayerId): Standard_Boolean;
  CheckOverlapping(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, theTolOverlap: Quantity_AbsorbedDose, theDomainDist: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class ShapeAnalysis_DataMapOfShapeListOfReal extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: ShapeAnalysis_DataMapOfShapeListOfReal): void;
  Assign(theOther: ShapeAnalysis_DataMapOfShapeListOfReal): ShapeAnalysis_DataMapOfShapeListOfReal;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TColStd_ListOfReal): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TColStd_ListOfReal): TColStd_ListOfReal;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TColStd_ListOfReal;
  ChangeSeek(theKey: TopoDS_Shape): TColStd_ListOfReal;
  ChangeFind(theKey: TopoDS_Shape): TColStd_ListOfReal;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class ShapeAnalysis_DataMapOfShapeListOfReal_1 extends ShapeAnalysis_DataMapOfShapeListOfReal {
    constructor();
  }

  export declare class ShapeAnalysis_DataMapOfShapeListOfReal_2 extends ShapeAnalysis_DataMapOfShapeListOfReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class ShapeAnalysis_DataMapOfShapeListOfReal_3 extends ShapeAnalysis_DataMapOfShapeListOfReal {
    constructor(theOther: ShapeAnalysis_DataMapOfShapeListOfReal);
  }

export declare class ShapeAnalysis_WireVertex {
  constructor()
  Init_1(wire: TopoDS_Wire, preci: Quantity_AbsorbedDose): void;
  Init_2(swbd: Handle_ShapeExtend_WireData, preci: Quantity_AbsorbedDose): void;
  Load_1(wire: TopoDS_Wire): void;
  Load_2(sbwd: Handle_ShapeExtend_WireData): void;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  Analyze(): void;
  SetSameVertex(num: Graphic3d_ZLayerId): void;
  SetSameCoords(num: Graphic3d_ZLayerId): void;
  SetClose(num: Graphic3d_ZLayerId): void;
  SetEnd(num: Graphic3d_ZLayerId, pos: gp_XYZ, ufol: Quantity_AbsorbedDose): void;
  SetStart(num: Graphic3d_ZLayerId, pos: gp_XYZ, upre: Quantity_AbsorbedDose): void;
  SetInters(num: Graphic3d_ZLayerId, pos: gp_XYZ, upre: Quantity_AbsorbedDose, ufol: Quantity_AbsorbedDose): void;
  SetDisjoined(num: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  Precision(): Quantity_AbsorbedDose;
  NbEdges(): Graphic3d_ZLayerId;
  WireData(): Handle_ShapeExtend_WireData;
  Status(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Position(num: Graphic3d_ZLayerId): gp_XYZ;
  UPrevious(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  UFollowing(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Data(num: Graphic3d_ZLayerId, pos: gp_XYZ, upre: Quantity_AbsorbedDose, ufol: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  NextStatus(stat: Graphic3d_ZLayerId, num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NextCriter(crit: Graphic3d_ZLayerId, num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class ShapeAnalysis_FreeBounds {
  GetClosedWires(): TopoDS_Compound;
  GetOpenWires(): TopoDS_Compound;
  static ConnectEdgesToWires(edges: Handle_TopTools_HSequenceOfShape, toler: Quantity_AbsorbedDose, shared: Standard_Boolean, wires: Handle_TopTools_HSequenceOfShape): void;
  static ConnectWiresToWires_1(iwires: Handle_TopTools_HSequenceOfShape, toler: Quantity_AbsorbedDose, shared: Standard_Boolean, owires: Handle_TopTools_HSequenceOfShape): void;
  static ConnectWiresToWires_2(iwires: Handle_TopTools_HSequenceOfShape, toler: Quantity_AbsorbedDose, shared: Standard_Boolean, owires: Handle_TopTools_HSequenceOfShape, vertices: TopTools_DataMapOfShapeShape): void;
  static SplitWires_1(wires: Handle_TopTools_HSequenceOfShape, toler: Quantity_AbsorbedDose, shared: Standard_Boolean, closed: Handle_TopTools_HSequenceOfShape, open: Handle_TopTools_HSequenceOfShape): void;
  static DispatchWires(wires: Handle_TopTools_HSequenceOfShape, closed: TopoDS_Compound, open: TopoDS_Compound): void;
  delete(): void;
}

  export declare class ShapeAnalysis_FreeBounds_1 extends ShapeAnalysis_FreeBounds {
    constructor();
  }

  export declare class ShapeAnalysis_FreeBounds_2 extends ShapeAnalysis_FreeBounds {
    constructor(shape: TopoDS_Shape, toler: Quantity_AbsorbedDose, splitclosed: Standard_Boolean, splitopen: Standard_Boolean);
  }

  export declare class ShapeAnalysis_FreeBounds_3 extends ShapeAnalysis_FreeBounds {
    constructor(shape: TopoDS_Shape, splitclosed: Standard_Boolean, splitopen: Standard_Boolean, checkinternaledges: Standard_Boolean);
  }

export declare class Handle_StepAP214_HArray1OfExternalIdentificationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfExternalIdentificationItem): void;
  get(): StepAP214_HArray1OfExternalIdentificationItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfExternalIdentificationItem_1 extends Handle_StepAP214_HArray1OfExternalIdentificationItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfExternalIdentificationItem_2 extends Handle_StepAP214_HArray1OfExternalIdentificationItem {
    constructor(thePtr: StepAP214_HArray1OfExternalIdentificationItem);
  }

  export declare class Handle_StepAP214_HArray1OfExternalIdentificationItem_3 extends Handle_StepAP214_HArray1OfExternalIdentificationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfExternalIdentificationItem);
  }

  export declare class Handle_StepAP214_HArray1OfExternalIdentificationItem_4 extends Handle_StepAP214_HArray1OfExternalIdentificationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfExternalIdentificationItem);
  }

export declare class Handle_StepAP214_AppliedSecurityClassificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedSecurityClassificationAssignment): void;
  get(): StepAP214_AppliedSecurityClassificationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedSecurityClassificationAssignment_1 extends Handle_StepAP214_AppliedSecurityClassificationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedSecurityClassificationAssignment_2 extends Handle_StepAP214_AppliedSecurityClassificationAssignment {
    constructor(thePtr: StepAP214_AppliedSecurityClassificationAssignment);
  }

  export declare class Handle_StepAP214_AppliedSecurityClassificationAssignment_3 extends Handle_StepAP214_AppliedSecurityClassificationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedSecurityClassificationAssignment);
  }

  export declare class Handle_StepAP214_AppliedSecurityClassificationAssignment_4 extends Handle_StepAP214_AppliedSecurityClassificationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedSecurityClassificationAssignment);
  }

export declare class StepAP214_AppliedSecurityClassificationAssignment extends StepBasic_SecurityClassificationAssignment {
  constructor()
  Init(aAssignedSecurityClassification: Handle_StepBasic_SecurityClassification, aItems: Handle_StepAP214_HArray1OfSecurityClassificationItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfSecurityClassificationItem): void;
  Items(): Handle_StepAP214_HArray1OfSecurityClassificationItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_SecurityClassificationItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_AutoDesignDatedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ApprovalPersonOrganization(): Handle_StepBasic_ApprovalPersonOrganization;
  AutoDesignDateAndPersonAssignment(): Handle_StepAP214_AutoDesignDateAndPersonAssignment;
  ProductDefinitionEffectivity(): Handle_StepBasic_ProductDefinitionEffectivity;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignPresentedItemSelect): void;
  get(): StepAP214_HArray1OfAutoDesignPresentedItemSelect;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_1 extends Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_2 extends Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignPresentedItemSelect);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_3 extends Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_4 extends Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect);
  }

export declare class Handle_StepAP214_HArray1OfAutoDesignDatedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignDatedItem): void;
  get(): StepAP214_HArray1OfAutoDesignDatedItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignDatedItem_1 extends Handle_StepAP214_HArray1OfAutoDesignDatedItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDatedItem_2 extends Handle_StepAP214_HArray1OfAutoDesignDatedItem {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignDatedItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDatedItem_3 extends Handle_StepAP214_HArray1OfAutoDesignDatedItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignDatedItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDatedItem_4 extends Handle_StepAP214_HArray1OfAutoDesignDatedItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignDatedItem);
  }

export declare class Handle_StepAP214_HArray1OfPersonAndOrganizationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfPersonAndOrganizationItem): void;
  get(): StepAP214_HArray1OfPersonAndOrganizationItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfPersonAndOrganizationItem_1 extends Handle_StepAP214_HArray1OfPersonAndOrganizationItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfPersonAndOrganizationItem_2 extends Handle_StepAP214_HArray1OfPersonAndOrganizationItem {
    constructor(thePtr: StepAP214_HArray1OfPersonAndOrganizationItem);
  }

  export declare class Handle_StepAP214_HArray1OfPersonAndOrganizationItem_3 extends Handle_StepAP214_HArray1OfPersonAndOrganizationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfPersonAndOrganizationItem);
  }

  export declare class Handle_StepAP214_HArray1OfPersonAndOrganizationItem_4 extends Handle_StepAP214_HArray1OfPersonAndOrganizationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfPersonAndOrganizationItem);
  }

export declare class StepAP214_Array1OfDocumentReferenceItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_DocumentReferenceItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfDocumentReferenceItem): StepAP214_Array1OfDocumentReferenceItem;
  Move(theOther: StepAP214_Array1OfDocumentReferenceItem): StepAP214_Array1OfDocumentReferenceItem;
  First(): StepAP214_DocumentReferenceItem;
  ChangeFirst(): StepAP214_DocumentReferenceItem;
  Last(): StepAP214_DocumentReferenceItem;
  ChangeLast(): StepAP214_DocumentReferenceItem;
  Value(theIndex: Standard_Integer): StepAP214_DocumentReferenceItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_DocumentReferenceItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_DocumentReferenceItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfDocumentReferenceItem_1 extends StepAP214_Array1OfDocumentReferenceItem {
    constructor();
  }

  export declare class StepAP214_Array1OfDocumentReferenceItem_2 extends StepAP214_Array1OfDocumentReferenceItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfDocumentReferenceItem_3 extends StepAP214_Array1OfDocumentReferenceItem {
    constructor(theOther: StepAP214_Array1OfDocumentReferenceItem);
  }

  export declare class StepAP214_Array1OfDocumentReferenceItem_4 extends StepAP214_Array1OfDocumentReferenceItem {
    constructor(theOther: StepAP214_Array1OfDocumentReferenceItem);
  }

  export declare class StepAP214_Array1OfDocumentReferenceItem_5 extends StepAP214_Array1OfDocumentReferenceItem {
    constructor(theBegin: StepAP214_DocumentReferenceItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_AppliedDateAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedDateAssignment): void;
  get(): StepAP214_AppliedDateAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedDateAssignment_1 extends Handle_StepAP214_AppliedDateAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedDateAssignment_2 extends Handle_StepAP214_AppliedDateAssignment {
    constructor(thePtr: StepAP214_AppliedDateAssignment);
  }

  export declare class Handle_StepAP214_AppliedDateAssignment_3 extends Handle_StepAP214_AppliedDateAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedDateAssignment);
  }

  export declare class Handle_StepAP214_AppliedDateAssignment_4 extends Handle_StepAP214_AppliedDateAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedDateAssignment);
  }

export declare class StepAP214_AppliedDateAssignment extends StepBasic_DateAssignment {
  constructor()
  Init(aAssignedDate: Handle_StepBasic_Date, aRole: Handle_StepBasic_DateRole, aItems: Handle_StepAP214_HArray1OfDateItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfDateItem): void;
  Items(): Handle_StepAP214_HArray1OfDateItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_DateItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_AutoDesignGroupedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AdvancedBrepShapeRepresentation(): Handle_StepShape_AdvancedBrepShapeRepresentation;
  CsgShapeRepresentation(): Handle_StepShape_CsgShapeRepresentation;
  FacetedBrepShapeRepresentation(): Handle_StepShape_FacetedBrepShapeRepresentation;
  GeometricallyBoundedSurfaceShapeRepresentation(): Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation;
  GeometricallyBoundedWireframeShapeRepresentation(): Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation;
  ManifoldSurfaceShapeRepresentation(): Handle_StepShape_ManifoldSurfaceShapeRepresentation;
  Representation(): Handle_StepRepr_Representation;
  RepresentationItem(): Handle_StepRepr_RepresentationItem;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeRepresentation(): Handle_StepShape_ShapeRepresentation;
  TemplateInstance(): Handle_StepVisual_TemplateInstance;
  delete(): void;
}

export declare class StepAP214_Array1OfOrganizationItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_OrganizationItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfOrganizationItem): StepAP214_Array1OfOrganizationItem;
  Move(theOther: StepAP214_Array1OfOrganizationItem): StepAP214_Array1OfOrganizationItem;
  First(): StepAP214_OrganizationItem;
  ChangeFirst(): StepAP214_OrganizationItem;
  Last(): StepAP214_OrganizationItem;
  ChangeLast(): StepAP214_OrganizationItem;
  Value(theIndex: Standard_Integer): StepAP214_OrganizationItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_OrganizationItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_OrganizationItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfOrganizationItem_1 extends StepAP214_Array1OfOrganizationItem {
    constructor();
  }

  export declare class StepAP214_Array1OfOrganizationItem_2 extends StepAP214_Array1OfOrganizationItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfOrganizationItem_3 extends StepAP214_Array1OfOrganizationItem {
    constructor(theOther: StepAP214_Array1OfOrganizationItem);
  }

  export declare class StepAP214_Array1OfOrganizationItem_4 extends StepAP214_Array1OfOrganizationItem {
    constructor(theOther: StepAP214_Array1OfOrganizationItem);
  }

  export declare class StepAP214_Array1OfOrganizationItem_5 extends StepAP214_Array1OfOrganizationItem {
    constructor(theBegin: StepAP214_OrganizationItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignDateAndTimeItem): void;
  get(): StepAP214_HArray1OfAutoDesignDateAndTimeItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_1 extends Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_2 extends Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignDateAndTimeItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_3 extends Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_4 extends Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem);
  }

export declare class StepAP214_Array1OfExternalIdentificationItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_ExternalIdentificationItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfExternalIdentificationItem): StepAP214_Array1OfExternalIdentificationItem;
  Move(theOther: StepAP214_Array1OfExternalIdentificationItem): StepAP214_Array1OfExternalIdentificationItem;
  First(): StepAP214_ExternalIdentificationItem;
  ChangeFirst(): StepAP214_ExternalIdentificationItem;
  Last(): StepAP214_ExternalIdentificationItem;
  ChangeLast(): StepAP214_ExternalIdentificationItem;
  Value(theIndex: Standard_Integer): StepAP214_ExternalIdentificationItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_ExternalIdentificationItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_ExternalIdentificationItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfExternalIdentificationItem_1 extends StepAP214_Array1OfExternalIdentificationItem {
    constructor();
  }

  export declare class StepAP214_Array1OfExternalIdentificationItem_2 extends StepAP214_Array1OfExternalIdentificationItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfExternalIdentificationItem_3 extends StepAP214_Array1OfExternalIdentificationItem {
    constructor(theOther: StepAP214_Array1OfExternalIdentificationItem);
  }

  export declare class StepAP214_Array1OfExternalIdentificationItem_4 extends StepAP214_Array1OfExternalIdentificationItem {
    constructor(theOther: StepAP214_Array1OfExternalIdentificationItem);
  }

  export declare class StepAP214_Array1OfExternalIdentificationItem_5 extends StepAP214_Array1OfExternalIdentificationItem {
    constructor(theBegin: StepAP214_ExternalIdentificationItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_Array1OfAutoDesignDateAndPersonItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignDateAndPersonItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignDateAndPersonItem): StepAP214_Array1OfAutoDesignDateAndPersonItem;
  Move(theOther: StepAP214_Array1OfAutoDesignDateAndPersonItem): StepAP214_Array1OfAutoDesignDateAndPersonItem;
  First(): StepAP214_AutoDesignDateAndPersonItem;
  ChangeFirst(): StepAP214_AutoDesignDateAndPersonItem;
  Last(): StepAP214_AutoDesignDateAndPersonItem;
  ChangeLast(): StepAP214_AutoDesignDateAndPersonItem;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignDateAndPersonItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignDateAndPersonItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignDateAndPersonItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignDateAndPersonItem_1 extends StepAP214_Array1OfAutoDesignDateAndPersonItem {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndPersonItem_2 extends StepAP214_Array1OfAutoDesignDateAndPersonItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndPersonItem_3 extends StepAP214_Array1OfAutoDesignDateAndPersonItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignDateAndPersonItem);
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndPersonItem_4 extends StepAP214_Array1OfAutoDesignDateAndPersonItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignDateAndPersonItem);
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndPersonItem_5 extends StepAP214_Array1OfAutoDesignDateAndPersonItem {
    constructor(theBegin: StepAP214_AutoDesignDateAndPersonItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_RepItemGroup extends StepBasic_Group {
  constructor()
  Init(aGroup_Name: Handle_TCollection_HAsciiString, hasGroup_Description: Standard_Boolean, aGroup_Description: Handle_TCollection_HAsciiString, aRepresentationItem_Name: Handle_TCollection_HAsciiString): void;
  RepresentationItem(): Handle_StepRepr_RepresentationItem;
  SetRepresentationItem(RepresentationItem: Handle_StepRepr_RepresentationItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_RepItemGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_RepItemGroup): void;
  get(): StepAP214_RepItemGroup;
  delete(): void;
}

  export declare class Handle_StepAP214_RepItemGroup_1 extends Handle_StepAP214_RepItemGroup {
    constructor();
  }

  export declare class Handle_StepAP214_RepItemGroup_2 extends Handle_StepAP214_RepItemGroup {
    constructor(thePtr: StepAP214_RepItemGroup);
  }

  export declare class Handle_StepAP214_RepItemGroup_3 extends Handle_StepAP214_RepItemGroup {
    constructor(theHandle: Handle_StepAP214_RepItemGroup);
  }

  export declare class Handle_StepAP214_RepItemGroup_4 extends Handle_StepAP214_RepItemGroup {
    constructor(theHandle: Handle_StepAP214_RepItemGroup);
  }

export declare class StepAP214_AppliedPersonAndOrganizationAssignment extends StepBasic_PersonAndOrganizationAssignment {
  constructor()
  Init(aAssignedPersonAndOrganization: Handle_StepBasic_PersonAndOrganization, aRole: Handle_StepBasic_PersonAndOrganizationRole, aItems: Handle_StepAP214_HArray1OfPersonAndOrganizationItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfPersonAndOrganizationItem): void;
  Items(): Handle_StepAP214_HArray1OfPersonAndOrganizationItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_PersonAndOrganizationItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AppliedPersonAndOrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedPersonAndOrganizationAssignment): void;
  get(): StepAP214_AppliedPersonAndOrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedPersonAndOrganizationAssignment_1 extends Handle_StepAP214_AppliedPersonAndOrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedPersonAndOrganizationAssignment_2 extends Handle_StepAP214_AppliedPersonAndOrganizationAssignment {
    constructor(thePtr: StepAP214_AppliedPersonAndOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AppliedPersonAndOrganizationAssignment_3 extends Handle_StepAP214_AppliedPersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedPersonAndOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AppliedPersonAndOrganizationAssignment_4 extends Handle_StepAP214_AppliedPersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedPersonAndOrganizationAssignment);
  }

export declare class StepAP214_AppliedPresentedItem extends StepVisual_PresentedItem {
  constructor()
  Init(aItems: Handle_StepAP214_HArray1OfPresentedItemSelect): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfPresentedItemSelect): void;
  Items(): Handle_StepAP214_HArray1OfPresentedItemSelect;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_PresentedItemSelect;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AppliedPresentedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedPresentedItem): void;
  get(): StepAP214_AppliedPresentedItem;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedPresentedItem_1 extends Handle_StepAP214_AppliedPresentedItem {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedPresentedItem_2 extends Handle_StepAP214_AppliedPresentedItem {
    constructor(thePtr: StepAP214_AppliedPresentedItem);
  }

  export declare class Handle_StepAP214_AppliedPresentedItem_3 extends Handle_StepAP214_AppliedPresentedItem {
    constructor(theHandle: Handle_StepAP214_AppliedPresentedItem);
  }

  export declare class Handle_StepAP214_AppliedPresentedItem_4 extends Handle_StepAP214_AppliedPresentedItem {
    constructor(theHandle: Handle_StepAP214_AppliedPresentedItem);
  }

export declare class Handle_StepAP214_AppliedApprovalAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedApprovalAssignment): void;
  get(): StepAP214_AppliedApprovalAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedApprovalAssignment_1 extends Handle_StepAP214_AppliedApprovalAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedApprovalAssignment_2 extends Handle_StepAP214_AppliedApprovalAssignment {
    constructor(thePtr: StepAP214_AppliedApprovalAssignment);
  }

  export declare class Handle_StepAP214_AppliedApprovalAssignment_3 extends Handle_StepAP214_AppliedApprovalAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedApprovalAssignment);
  }

  export declare class Handle_StepAP214_AppliedApprovalAssignment_4 extends Handle_StepAP214_AppliedApprovalAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedApprovalAssignment);
  }

export declare class StepAP214_AppliedApprovalAssignment extends StepBasic_ApprovalAssignment {
  constructor()
  Init(aAssignedApproval: Handle_StepBasic_Approval, aItems: Handle_StepAP214_HArray1OfApprovalItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfApprovalItem): void;
  Items(): Handle_StepAP214_HArray1OfApprovalItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_ApprovalItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_Protocol): void;
  get(): StepAP214_Protocol;
  delete(): void;
}

  export declare class Handle_StepAP214_Protocol_1 extends Handle_StepAP214_Protocol {
    constructor();
  }

  export declare class Handle_StepAP214_Protocol_2 extends Handle_StepAP214_Protocol {
    constructor(thePtr: StepAP214_Protocol);
  }

  export declare class Handle_StepAP214_Protocol_3 extends Handle_StepAP214_Protocol {
    constructor(theHandle: Handle_StepAP214_Protocol);
  }

  export declare class Handle_StepAP214_Protocol_4 extends Handle_StepAP214_Protocol {
    constructor(theHandle: Handle_StepAP214_Protocol);
  }

export declare class StepAP214_Protocol extends StepData_Protocol {
  constructor()
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  SchemaName(): Standard_CString;
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AppliedDocumentReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedDocumentReference): void;
  get(): StepAP214_AppliedDocumentReference;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedDocumentReference_1 extends Handle_StepAP214_AppliedDocumentReference {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedDocumentReference_2 extends Handle_StepAP214_AppliedDocumentReference {
    constructor(thePtr: StepAP214_AppliedDocumentReference);
  }

  export declare class Handle_StepAP214_AppliedDocumentReference_3 extends Handle_StepAP214_AppliedDocumentReference {
    constructor(theHandle: Handle_StepAP214_AppliedDocumentReference);
  }

  export declare class Handle_StepAP214_AppliedDocumentReference_4 extends Handle_StepAP214_AppliedDocumentReference {
    constructor(theHandle: Handle_StepAP214_AppliedDocumentReference);
  }

export declare class StepAP214_AppliedDocumentReference extends StepBasic_DocumentReference {
  constructor()
  Init(aAssignedDocument: Handle_StepBasic_Document, aSource: Handle_TCollection_HAsciiString, aItems: Handle_StepAP214_HArray1OfDocumentReferenceItem): void;
  Items(): Handle_StepAP214_HArray1OfDocumentReferenceItem;
  SetItems(aItems: Handle_StepAP214_HArray1OfDocumentReferenceItem): void;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_DocumentReferenceItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_ExternallyDefinedGeneralProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_ExternallyDefinedGeneralProperty): void;
  get(): StepAP214_ExternallyDefinedGeneralProperty;
  delete(): void;
}

  export declare class Handle_StepAP214_ExternallyDefinedGeneralProperty_1 extends Handle_StepAP214_ExternallyDefinedGeneralProperty {
    constructor();
  }

  export declare class Handle_StepAP214_ExternallyDefinedGeneralProperty_2 extends Handle_StepAP214_ExternallyDefinedGeneralProperty {
    constructor(thePtr: StepAP214_ExternallyDefinedGeneralProperty);
  }

  export declare class Handle_StepAP214_ExternallyDefinedGeneralProperty_3 extends Handle_StepAP214_ExternallyDefinedGeneralProperty {
    constructor(theHandle: Handle_StepAP214_ExternallyDefinedGeneralProperty);
  }

  export declare class Handle_StepAP214_ExternallyDefinedGeneralProperty_4 extends Handle_StepAP214_ExternallyDefinedGeneralProperty {
    constructor(theHandle: Handle_StepAP214_ExternallyDefinedGeneralProperty);
  }

export declare class StepAP214_ExternallyDefinedGeneralProperty extends StepBasic_GeneralProperty {
  constructor()
  Init(aGeneralProperty_Id: Handle_TCollection_HAsciiString, aGeneralProperty_Name: Handle_TCollection_HAsciiString, hasGeneralProperty_Description: Standard_Boolean, aGeneralProperty_Description: Handle_TCollection_HAsciiString, aExternallyDefinedItem_ItemId: StepBasic_SourceItem, aExternallyDefinedItem_Source: Handle_StepBasic_ExternalSource): void;
  ExternallyDefinedItem(): Handle_StepBasic_ExternallyDefinedItem;
  SetExternallyDefinedItem(ExternallyDefinedItem: Handle_StepBasic_ExternallyDefinedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_Array1OfPersonAndOrganizationItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_PersonAndOrganizationItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfPersonAndOrganizationItem): StepAP214_Array1OfPersonAndOrganizationItem;
  Move(theOther: StepAP214_Array1OfPersonAndOrganizationItem): StepAP214_Array1OfPersonAndOrganizationItem;
  First(): StepAP214_PersonAndOrganizationItem;
  ChangeFirst(): StepAP214_PersonAndOrganizationItem;
  Last(): StepAP214_PersonAndOrganizationItem;
  ChangeLast(): StepAP214_PersonAndOrganizationItem;
  Value(theIndex: Standard_Integer): StepAP214_PersonAndOrganizationItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_PersonAndOrganizationItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_PersonAndOrganizationItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfPersonAndOrganizationItem_1 extends StepAP214_Array1OfPersonAndOrganizationItem {
    constructor();
  }

  export declare class StepAP214_Array1OfPersonAndOrganizationItem_2 extends StepAP214_Array1OfPersonAndOrganizationItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfPersonAndOrganizationItem_3 extends StepAP214_Array1OfPersonAndOrganizationItem {
    constructor(theOther: StepAP214_Array1OfPersonAndOrganizationItem);
  }

  export declare class StepAP214_Array1OfPersonAndOrganizationItem_4 extends StepAP214_Array1OfPersonAndOrganizationItem {
    constructor(theOther: StepAP214_Array1OfPersonAndOrganizationItem);
  }

  export declare class StepAP214_Array1OfPersonAndOrganizationItem_5 extends StepAP214_Array1OfPersonAndOrganizationItem {
    constructor(theBegin: StepAP214_PersonAndOrganizationItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_AutoDesignDateAndPersonAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignDateAndPersonAssignment): void;
  get(): StepAP214_AutoDesignDateAndPersonAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignDateAndPersonAssignment_1 extends Handle_StepAP214_AutoDesignDateAndPersonAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignDateAndPersonAssignment_2 extends Handle_StepAP214_AutoDesignDateAndPersonAssignment {
    constructor(thePtr: StepAP214_AutoDesignDateAndPersonAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignDateAndPersonAssignment_3 extends Handle_StepAP214_AutoDesignDateAndPersonAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignDateAndPersonAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignDateAndPersonAssignment_4 extends Handle_StepAP214_AutoDesignDateAndPersonAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignDateAndPersonAssignment);
  }

export declare class StepAP214_AutoDesignDateAndPersonAssignment extends StepBasic_PersonAndOrganizationAssignment {
  constructor()
  Init(aAssignedPersonAndOrganization: Handle_StepBasic_PersonAndOrganization, aRole: Handle_StepBasic_PersonAndOrganizationRole, aItems: Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignDateAndPersonItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_OrganizationItem extends StepAP214_ApprovalItem {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AppliedOrganizationAssignment(): Handle_StepAP214_AppliedOrganizationAssignment;
  Approval(): Handle_StepBasic_Approval;
  AppliedSecurityClassificationAssignment(): Handle_StepAP214_AppliedSecurityClassificationAssignment;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfApprovalItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfApprovalItem): void;
  get(): StepAP214_HArray1OfApprovalItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfApprovalItem_1 extends Handle_StepAP214_HArray1OfApprovalItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfApprovalItem_2 extends Handle_StepAP214_HArray1OfApprovalItem {
    constructor(thePtr: StepAP214_HArray1OfApprovalItem);
  }

  export declare class Handle_StepAP214_HArray1OfApprovalItem_3 extends Handle_StepAP214_HArray1OfApprovalItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfApprovalItem);
  }

  export declare class Handle_StepAP214_HArray1OfApprovalItem_4 extends Handle_StepAP214_HArray1OfApprovalItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfApprovalItem);
  }

export declare class StepAP214_Array1OfDateItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_DateItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfDateItem): StepAP214_Array1OfDateItem;
  Move(theOther: StepAP214_Array1OfDateItem): StepAP214_Array1OfDateItem;
  First(): StepAP214_DateItem;
  ChangeFirst(): StepAP214_DateItem;
  Last(): StepAP214_DateItem;
  ChangeLast(): StepAP214_DateItem;
  Value(theIndex: Standard_Integer): StepAP214_DateItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_DateItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_DateItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfDateItem_1 extends StepAP214_Array1OfDateItem {
    constructor();
  }

  export declare class StepAP214_Array1OfDateItem_2 extends StepAP214_Array1OfDateItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfDateItem_3 extends StepAP214_Array1OfDateItem {
    constructor(theOther: StepAP214_Array1OfDateItem);
  }

  export declare class StepAP214_Array1OfDateItem_4 extends StepAP214_Array1OfDateItem {
    constructor(theOther: StepAP214_Array1OfDateItem);
  }

  export declare class StepAP214_Array1OfDateItem_5 extends StepAP214_Array1OfDateItem {
    constructor(theBegin: StepAP214_DateItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_AutoDesignDateAndPersonItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AutoDesignOrganizationAssignment(): Handle_StepAP214_AutoDesignOrganizationAssignment;
  Product(): Handle_StepBasic_Product;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  Representation(): Handle_StepRepr_Representation;
  AutoDesignDocumentReference(): Handle_StepAP214_AutoDesignDocumentReference;
  ExternallyDefinedRepresentation(): Handle_StepRepr_ExternallyDefinedRepresentation;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  ProductDefinitionWithAssociatedDocuments(): Handle_StepBasic_ProductDefinitionWithAssociatedDocuments;
  delete(): void;
}

export declare class StepAP214_Array1OfAutoDesignGroupedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignGroupedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignGroupedItem): StepAP214_Array1OfAutoDesignGroupedItem;
  Move(theOther: StepAP214_Array1OfAutoDesignGroupedItem): StepAP214_Array1OfAutoDesignGroupedItem;
  First(): StepAP214_AutoDesignGroupedItem;
  ChangeFirst(): StepAP214_AutoDesignGroupedItem;
  Last(): StepAP214_AutoDesignGroupedItem;
  ChangeLast(): StepAP214_AutoDesignGroupedItem;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignGroupedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignGroupedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignGroupedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignGroupedItem_1 extends StepAP214_Array1OfAutoDesignGroupedItem {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignGroupedItem_2 extends StepAP214_Array1OfAutoDesignGroupedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignGroupedItem_3 extends StepAP214_Array1OfAutoDesignGroupedItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignGroupedItem);
  }

  export declare class StepAP214_Array1OfAutoDesignGroupedItem_4 extends StepAP214_Array1OfAutoDesignGroupedItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignGroupedItem);
  }

  export declare class StepAP214_Array1OfAutoDesignGroupedItem_5 extends StepAP214_Array1OfAutoDesignGroupedItem {
    constructor(theBegin: StepAP214_AutoDesignGroupedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_DocumentReferenceItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Approval(): Handle_StepBasic_Approval;
  DescriptiveRepresentationItem(): Handle_StepRepr_DescriptiveRepresentationItem;
  MaterialDesignation(): Handle_StepRepr_MaterialDesignation;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  PropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  Representation(): Handle_StepRepr_Representation;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  AppliedExternalIdentificationAssignment(): Handle_StepAP214_AppliedExternalIdentificationAssignment;
  AssemblyComponentUsage(): Handle_StepRepr_AssemblyComponentUsage;
  CharacterizedObject(): Handle_StepBasic_CharacterizedObject;
  DimensionalSize(): Handle_StepShape_DimensionalSize;
  ExternallyDefinedItem(): Handle_StepBasic_ExternallyDefinedItem;
  Group(): Handle_StepBasic_Group;
  GroupRelationship(): Handle_StepBasic_GroupRelationship;
  MeasureRepresentationItem(): Handle_StepRepr_MeasureRepresentationItem;
  ProductCategory(): Handle_StepBasic_ProductCategory;
  ProductDefinitionContext(): Handle_StepBasic_ProductDefinitionContext;
  RepresentationItem(): Handle_StepRepr_RepresentationItem;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfSecurityClassificationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfSecurityClassificationItem): void;
  get(): StepAP214_HArray1OfSecurityClassificationItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfSecurityClassificationItem_1 extends Handle_StepAP214_HArray1OfSecurityClassificationItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfSecurityClassificationItem_2 extends Handle_StepAP214_HArray1OfSecurityClassificationItem {
    constructor(thePtr: StepAP214_HArray1OfSecurityClassificationItem);
  }

  export declare class Handle_StepAP214_HArray1OfSecurityClassificationItem_3 extends Handle_StepAP214_HArray1OfSecurityClassificationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfSecurityClassificationItem);
  }

  export declare class Handle_StepAP214_HArray1OfSecurityClassificationItem_4 extends Handle_StepAP214_HArray1OfSecurityClassificationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfSecurityClassificationItem);
  }

export declare class StepAP214_Array1OfAutoDesignDateAndTimeItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignDateAndTimeItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignDateAndTimeItem): StepAP214_Array1OfAutoDesignDateAndTimeItem;
  Move(theOther: StepAP214_Array1OfAutoDesignDateAndTimeItem): StepAP214_Array1OfAutoDesignDateAndTimeItem;
  First(): StepAP214_AutoDesignDateAndTimeItem;
  ChangeFirst(): StepAP214_AutoDesignDateAndTimeItem;
  Last(): StepAP214_AutoDesignDateAndTimeItem;
  ChangeLast(): StepAP214_AutoDesignDateAndTimeItem;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignDateAndTimeItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignDateAndTimeItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignDateAndTimeItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignDateAndTimeItem_1 extends StepAP214_Array1OfAutoDesignDateAndTimeItem {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndTimeItem_2 extends StepAP214_Array1OfAutoDesignDateAndTimeItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndTimeItem_3 extends StepAP214_Array1OfAutoDesignDateAndTimeItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignDateAndTimeItem);
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndTimeItem_4 extends StepAP214_Array1OfAutoDesignDateAndTimeItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignDateAndTimeItem);
  }

  export declare class StepAP214_Array1OfAutoDesignDateAndTimeItem_5 extends StepAP214_Array1OfAutoDesignDateAndTimeItem {
    constructor(theBegin: StepAP214_AutoDesignDateAndTimeItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  get(): StepAP214_HArray1OfAutoDesignGeneralOrgItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_1 extends Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_2 extends Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignGeneralOrgItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_3 extends Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_4 extends Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem);
  }

export declare class Handle_StepAP214_HArray1OfDocumentReferenceItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfDocumentReferenceItem): void;
  get(): StepAP214_HArray1OfDocumentReferenceItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfDocumentReferenceItem_1 extends Handle_StepAP214_HArray1OfDocumentReferenceItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfDocumentReferenceItem_2 extends Handle_StepAP214_HArray1OfDocumentReferenceItem {
    constructor(thePtr: StepAP214_HArray1OfDocumentReferenceItem);
  }

  export declare class Handle_StepAP214_HArray1OfDocumentReferenceItem_3 extends Handle_StepAP214_HArray1OfDocumentReferenceItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfDocumentReferenceItem);
  }

  export declare class Handle_StepAP214_HArray1OfDocumentReferenceItem_4 extends Handle_StepAP214_HArray1OfDocumentReferenceItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfDocumentReferenceItem);
  }

export declare class Handle_StepAP214_AppliedOrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedOrganizationAssignment): void;
  get(): StepAP214_AppliedOrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedOrganizationAssignment_1 extends Handle_StepAP214_AppliedOrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedOrganizationAssignment_2 extends Handle_StepAP214_AppliedOrganizationAssignment {
    constructor(thePtr: StepAP214_AppliedOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AppliedOrganizationAssignment_3 extends Handle_StepAP214_AppliedOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AppliedOrganizationAssignment_4 extends Handle_StepAP214_AppliedOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedOrganizationAssignment);
  }

export declare class StepAP214_AppliedOrganizationAssignment extends StepBasic_OrganizationAssignment {
  constructor()
  Init(aAssignedOrganization: Handle_StepBasic_Organization, aRole: Handle_StepBasic_OrganizationRole, aItems: Handle_StepAP214_HArray1OfOrganizationItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfOrganizationItem): void;
  Items(): Handle_StepAP214_HArray1OfOrganizationItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_OrganizationItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_AppliedGroupAssignment extends StepBasic_GroupAssignment {
  constructor()
  Init(aGroupAssignment_AssignedGroup: Handle_StepBasic_Group, aItems: Handle_StepAP214_HArray1OfGroupItem): void;
  Items(): Handle_StepAP214_HArray1OfGroupItem;
  SetItems(Items: Handle_StepAP214_HArray1OfGroupItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AppliedGroupAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedGroupAssignment): void;
  get(): StepAP214_AppliedGroupAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedGroupAssignment_1 extends Handle_StepAP214_AppliedGroupAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedGroupAssignment_2 extends Handle_StepAP214_AppliedGroupAssignment {
    constructor(thePtr: StepAP214_AppliedGroupAssignment);
  }

  export declare class Handle_StepAP214_AppliedGroupAssignment_3 extends Handle_StepAP214_AppliedGroupAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedGroupAssignment);
  }

  export declare class Handle_StepAP214_AppliedGroupAssignment_4 extends Handle_StepAP214_AppliedGroupAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedGroupAssignment);
  }

export declare class Handle_StepAP214_AutoDesignApprovalAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignApprovalAssignment): void;
  get(): StepAP214_AutoDesignApprovalAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignApprovalAssignment_1 extends Handle_StepAP214_AutoDesignApprovalAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignApprovalAssignment_2 extends Handle_StepAP214_AutoDesignApprovalAssignment {
    constructor(thePtr: StepAP214_AutoDesignApprovalAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignApprovalAssignment_3 extends Handle_StepAP214_AutoDesignApprovalAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignApprovalAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignApprovalAssignment_4 extends Handle_StepAP214_AutoDesignApprovalAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignApprovalAssignment);
  }

export declare class StepAP214_AutoDesignApprovalAssignment extends StepBasic_ApprovalAssignment {
  constructor()
  Init(aAssignedApproval: Handle_StepBasic_Approval, aItems: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignGeneralOrgItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfOrganizationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfOrganizationItem): void;
  get(): StepAP214_HArray1OfOrganizationItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfOrganizationItem_1 extends Handle_StepAP214_HArray1OfOrganizationItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfOrganizationItem_2 extends Handle_StepAP214_HArray1OfOrganizationItem {
    constructor(thePtr: StepAP214_HArray1OfOrganizationItem);
  }

  export declare class Handle_StepAP214_HArray1OfOrganizationItem_3 extends Handle_StepAP214_HArray1OfOrganizationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfOrganizationItem);
  }

  export declare class Handle_StepAP214_HArray1OfOrganizationItem_4 extends Handle_StepAP214_HArray1OfOrganizationItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfOrganizationItem);
  }

export declare class Handle_StepAP214_HArray1OfAutoDesignReferencingItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignReferencingItem): void;
  get(): StepAP214_HArray1OfAutoDesignReferencingItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignReferencingItem_1 extends Handle_StepAP214_HArray1OfAutoDesignReferencingItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignReferencingItem_2 extends Handle_StepAP214_HArray1OfAutoDesignReferencingItem {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignReferencingItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignReferencingItem_3 extends Handle_StepAP214_HArray1OfAutoDesignReferencingItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignReferencingItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignReferencingItem_4 extends Handle_StepAP214_HArray1OfAutoDesignReferencingItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignReferencingItem);
  }

export declare class StepAP214 {
  constructor();
  static Protocol(): Handle_StepAP214_Protocol;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignNominalDateAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignNominalDateAssignment): void;
  get(): StepAP214_AutoDesignNominalDateAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignNominalDateAssignment_1 extends Handle_StepAP214_AutoDesignNominalDateAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignNominalDateAssignment_2 extends Handle_StepAP214_AutoDesignNominalDateAssignment {
    constructor(thePtr: StepAP214_AutoDesignNominalDateAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignNominalDateAssignment_3 extends Handle_StepAP214_AutoDesignNominalDateAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignNominalDateAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignNominalDateAssignment_4 extends Handle_StepAP214_AutoDesignNominalDateAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignNominalDateAssignment);
  }

export declare class StepAP214_AutoDesignNominalDateAssignment extends StepBasic_DateAssignment {
  constructor()
  Init(aAssignedDate: Handle_StepBasic_Date, aRole: Handle_StepBasic_DateRole, aItems: Handle_StepAP214_HArray1OfAutoDesignDatedItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignDatedItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignDatedItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignDatedItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignDateAndPersonItem): void;
  get(): StepAP214_HArray1OfAutoDesignDateAndPersonItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_1 extends Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_2 extends Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignDateAndPersonItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_3 extends Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_4 extends Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem);
  }

export declare class Handle_StepAP214_AutoDesignDocumentReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignDocumentReference): void;
  get(): StepAP214_AutoDesignDocumentReference;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignDocumentReference_1 extends Handle_StepAP214_AutoDesignDocumentReference {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignDocumentReference_2 extends Handle_StepAP214_AutoDesignDocumentReference {
    constructor(thePtr: StepAP214_AutoDesignDocumentReference);
  }

  export declare class Handle_StepAP214_AutoDesignDocumentReference_3 extends Handle_StepAP214_AutoDesignDocumentReference {
    constructor(theHandle: Handle_StepAP214_AutoDesignDocumentReference);
  }

  export declare class Handle_StepAP214_AutoDesignDocumentReference_4 extends Handle_StepAP214_AutoDesignDocumentReference {
    constructor(theHandle: Handle_StepAP214_AutoDesignDocumentReference);
  }

export declare class StepAP214_AutoDesignDocumentReference extends StepBasic_DocumentReference {
  constructor()
  Init(aAssignedDocument: Handle_StepBasic_Document, aSource: Handle_TCollection_HAsciiString, aItems: Handle_StepAP214_HArray1OfAutoDesignReferencingItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignReferencingItem;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignReferencingItem): void;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignReferencingItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfAutoDesignGroupedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfAutoDesignGroupedItem): void;
  get(): StepAP214_HArray1OfAutoDesignGroupedItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfAutoDesignGroupedItem_1 extends Handle_StepAP214_HArray1OfAutoDesignGroupedItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignGroupedItem_2 extends Handle_StepAP214_HArray1OfAutoDesignGroupedItem {
    constructor(thePtr: StepAP214_HArray1OfAutoDesignGroupedItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignGroupedItem_3 extends Handle_StepAP214_HArray1OfAutoDesignGroupedItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignGroupedItem);
  }

  export declare class Handle_StepAP214_HArray1OfAutoDesignGroupedItem_4 extends Handle_StepAP214_HArray1OfAutoDesignGroupedItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfAutoDesignGroupedItem);
  }

export declare class StepAP214_Array1OfAutoDesignPresentedItemSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignPresentedItemSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignPresentedItemSelect): StepAP214_Array1OfAutoDesignPresentedItemSelect;
  Move(theOther: StepAP214_Array1OfAutoDesignPresentedItemSelect): StepAP214_Array1OfAutoDesignPresentedItemSelect;
  First(): StepAP214_AutoDesignPresentedItemSelect;
  ChangeFirst(): StepAP214_AutoDesignPresentedItemSelect;
  Last(): StepAP214_AutoDesignPresentedItemSelect;
  ChangeLast(): StepAP214_AutoDesignPresentedItemSelect;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignPresentedItemSelect;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignPresentedItemSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignPresentedItemSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignPresentedItemSelect_1 extends StepAP214_Array1OfAutoDesignPresentedItemSelect {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignPresentedItemSelect_2 extends StepAP214_Array1OfAutoDesignPresentedItemSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignPresentedItemSelect_3 extends StepAP214_Array1OfAutoDesignPresentedItemSelect {
    constructor(theOther: StepAP214_Array1OfAutoDesignPresentedItemSelect);
  }

  export declare class StepAP214_Array1OfAutoDesignPresentedItemSelect_4 extends StepAP214_Array1OfAutoDesignPresentedItemSelect {
    constructor(theOther: StepAP214_Array1OfAutoDesignPresentedItemSelect);
  }

  export declare class StepAP214_Array1OfAutoDesignPresentedItemSelect_5 extends StepAP214_Array1OfAutoDesignPresentedItemSelect {
    constructor(theBegin: StepAP214_AutoDesignPresentedItemSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_Array1OfAutoDesignReferencingItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignReferencingItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignReferencingItem): StepAP214_Array1OfAutoDesignReferencingItem;
  Move(theOther: StepAP214_Array1OfAutoDesignReferencingItem): StepAP214_Array1OfAutoDesignReferencingItem;
  First(): StepAP214_AutoDesignReferencingItem;
  ChangeFirst(): StepAP214_AutoDesignReferencingItem;
  Last(): StepAP214_AutoDesignReferencingItem;
  ChangeLast(): StepAP214_AutoDesignReferencingItem;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignReferencingItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignReferencingItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignReferencingItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignReferencingItem_1 extends StepAP214_Array1OfAutoDesignReferencingItem {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignReferencingItem_2 extends StepAP214_Array1OfAutoDesignReferencingItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignReferencingItem_3 extends StepAP214_Array1OfAutoDesignReferencingItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignReferencingItem);
  }

  export declare class StepAP214_Array1OfAutoDesignReferencingItem_4 extends StepAP214_Array1OfAutoDesignReferencingItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignReferencingItem);
  }

  export declare class StepAP214_Array1OfAutoDesignReferencingItem_5 extends StepAP214_Array1OfAutoDesignReferencingItem {
    constructor(theBegin: StepAP214_AutoDesignReferencingItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_Array1OfAutoDesignGeneralOrgItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignGeneralOrgItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignGeneralOrgItem): StepAP214_Array1OfAutoDesignGeneralOrgItem;
  Move(theOther: StepAP214_Array1OfAutoDesignGeneralOrgItem): StepAP214_Array1OfAutoDesignGeneralOrgItem;
  First(): StepAP214_AutoDesignGeneralOrgItem;
  ChangeFirst(): StepAP214_AutoDesignGeneralOrgItem;
  Last(): StepAP214_AutoDesignGeneralOrgItem;
  ChangeLast(): StepAP214_AutoDesignGeneralOrgItem;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignGeneralOrgItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignGeneralOrgItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignGeneralOrgItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignGeneralOrgItem_1 extends StepAP214_Array1OfAutoDesignGeneralOrgItem {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignGeneralOrgItem_2 extends StepAP214_Array1OfAutoDesignGeneralOrgItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignGeneralOrgItem_3 extends StepAP214_Array1OfAutoDesignGeneralOrgItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignGeneralOrgItem);
  }

  export declare class StepAP214_Array1OfAutoDesignGeneralOrgItem_4 extends StepAP214_Array1OfAutoDesignGeneralOrgItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignGeneralOrgItem);
  }

  export declare class StepAP214_Array1OfAutoDesignGeneralOrgItem_5 extends StepAP214_Array1OfAutoDesignGeneralOrgItem {
    constructor(theBegin: StepAP214_AutoDesignGeneralOrgItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_AutoDesignOrganizationItem extends StepAP214_AutoDesignGeneralOrgItem {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Document(): Handle_StepBasic_Document;
  PhysicallyModeledProductDefinition(): Handle_StepBasic_PhysicallyModeledProductDefinition;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignGroupAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignGroupAssignment): void;
  get(): StepAP214_AutoDesignGroupAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignGroupAssignment_1 extends Handle_StepAP214_AutoDesignGroupAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignGroupAssignment_2 extends Handle_StepAP214_AutoDesignGroupAssignment {
    constructor(thePtr: StepAP214_AutoDesignGroupAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignGroupAssignment_3 extends Handle_StepAP214_AutoDesignGroupAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignGroupAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignGroupAssignment_4 extends Handle_StepAP214_AutoDesignGroupAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignGroupAssignment);
  }

export declare class StepAP214_AutoDesignGroupAssignment extends StepBasic_GroupAssignment {
  constructor()
  Init(aAssignedGroup: Handle_StepBasic_Group, aItems: Handle_StepAP214_HArray1OfAutoDesignGroupedItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignGroupedItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignGroupedItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignGroupedItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_PersonAndOrganizationItem extends StepAP214_ApprovalItem {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AppliedOrganizationAssignment(): Handle_StepAP214_AppliedOrganizationAssignment;
  AppliedSecurityClassificationAssignment(): Handle_StepAP214_AppliedSecurityClassificationAssignment;
  Approval(): Handle_StepBasic_Approval;
  delete(): void;
}

export declare class StepAP214_AutoDesignDateAndTimeItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ApprovalPersonOrganization(): Handle_StepBasic_ApprovalPersonOrganization;
  AutoDesignDateAndPersonAssignment(): Handle_StepAP214_AutoDesignDateAndPersonAssignment;
  ProductDefinitionEffectivity(): Handle_StepBasic_ProductDefinitionEffectivity;
  delete(): void;
}

export declare class StepAP214_AutoDesignOrganizationAssignment extends StepBasic_OrganizationAssignment {
  constructor()
  Init(aAssignedOrganization: Handle_StepBasic_Organization, aRole: Handle_StepBasic_OrganizationRole, aItems: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignGeneralOrgItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignOrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignOrganizationAssignment): void;
  get(): StepAP214_AutoDesignOrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignOrganizationAssignment_1 extends Handle_StepAP214_AutoDesignOrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignOrganizationAssignment_2 extends Handle_StepAP214_AutoDesignOrganizationAssignment {
    constructor(thePtr: StepAP214_AutoDesignOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignOrganizationAssignment_3 extends Handle_StepAP214_AutoDesignOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignOrganizationAssignment_4 extends Handle_StepAP214_AutoDesignOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignOrganizationAssignment);
  }

export declare class StepAP214_GroupItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  GeometricRepresentationItem(): Handle_StepGeom_GeometricRepresentationItem;
  GroupRelationship(): Handle_StepBasic_GroupRelationship;
  MappedItem(): Handle_StepRepr_MappedItem;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  PropertyDefinitionRepresentation(): Handle_StepRepr_PropertyDefinitionRepresentation;
  Representation(): Handle_StepRepr_Representation;
  RepresentationItem(): Handle_StepRepr_RepresentationItem;
  RepresentationRelationshipWithTransformation(): Handle_StepRepr_RepresentationRelationshipWithTransformation;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  ShapeRepresentationRelationship(): Handle_StepRepr_ShapeRepresentationRelationship;
  StyledItem(): Handle_StepVisual_StyledItem;
  TopologicalRepresentationItem(): Handle_StepShape_TopologicalRepresentationItem;
  delete(): void;
}

export declare class StepAP214_ExternalIdentificationItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DocumentFile(): Handle_StepBasic_DocumentFile;
  ExternallyDefinedClass(): Handle_StepAP214_ExternallyDefinedClass;
  ExternallyDefinedGeneralProperty(): Handle_StepAP214_ExternallyDefinedGeneralProperty;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  AppliedOrganizationAssignment(): Handle_StepAP214_AppliedOrganizationAssignment;
  AppliedPersonAndOrganizationAssignment(): Handle_StepAP214_AppliedPersonAndOrganizationAssignment;
  Approval(): Handle_StepBasic_Approval;
  ApprovalStatus(): Handle_StepBasic_ApprovalStatus;
  ExternalSource(): Handle_StepBasic_ExternalSource;
  OrganizationalAddress(): Handle_StepBasic_OrganizationalAddress;
  SecurityClassification(): Handle_StepBasic_SecurityClassification;
  TrimmedCurve(): Handle_StepGeom_TrimmedCurve;
  VersionedActionRequest(): Handle_StepBasic_VersionedActionRequest;
  DateAndTimeAssignment(): Handle_StepBasic_DateAndTimeAssignment;
  DateAssignment(): Handle_StepBasic_DateAssignment;
  delete(): void;
}

export declare class StepAP214_Array1OfDateAndTimeItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_DateAndTimeItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfDateAndTimeItem): StepAP214_Array1OfDateAndTimeItem;
  Move(theOther: StepAP214_Array1OfDateAndTimeItem): StepAP214_Array1OfDateAndTimeItem;
  First(): StepAP214_DateAndTimeItem;
  ChangeFirst(): StepAP214_DateAndTimeItem;
  Last(): StepAP214_DateAndTimeItem;
  ChangeLast(): StepAP214_DateAndTimeItem;
  Value(theIndex: Standard_Integer): StepAP214_DateAndTimeItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_DateAndTimeItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_DateAndTimeItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfDateAndTimeItem_1 extends StepAP214_Array1OfDateAndTimeItem {
    constructor();
  }

  export declare class StepAP214_Array1OfDateAndTimeItem_2 extends StepAP214_Array1OfDateAndTimeItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfDateAndTimeItem_3 extends StepAP214_Array1OfDateAndTimeItem {
    constructor(theOther: StepAP214_Array1OfDateAndTimeItem);
  }

  export declare class StepAP214_Array1OfDateAndTimeItem_4 extends StepAP214_Array1OfDateAndTimeItem {
    constructor(theOther: StepAP214_Array1OfDateAndTimeItem);
  }

  export declare class StepAP214_Array1OfDateAndTimeItem_5 extends StepAP214_Array1OfDateAndTimeItem {
    constructor(theBegin: StepAP214_DateAndTimeItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_ExternallyDefinedClass {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_ExternallyDefinedClass): void;
  get(): StepAP214_ExternallyDefinedClass;
  delete(): void;
}

  export declare class Handle_StepAP214_ExternallyDefinedClass_1 extends Handle_StepAP214_ExternallyDefinedClass {
    constructor();
  }

  export declare class Handle_StepAP214_ExternallyDefinedClass_2 extends Handle_StepAP214_ExternallyDefinedClass {
    constructor(thePtr: StepAP214_ExternallyDefinedClass);
  }

  export declare class Handle_StepAP214_ExternallyDefinedClass_3 extends Handle_StepAP214_ExternallyDefinedClass {
    constructor(theHandle: Handle_StepAP214_ExternallyDefinedClass);
  }

  export declare class Handle_StepAP214_ExternallyDefinedClass_4 extends Handle_StepAP214_ExternallyDefinedClass {
    constructor(theHandle: Handle_StepAP214_ExternallyDefinedClass);
  }

export declare class StepAP214_ExternallyDefinedClass extends StepAP214_Class {
  constructor()
  Init(aGroup_Name: Handle_TCollection_HAsciiString, hasGroup_Description: Standard_Boolean, aGroup_Description: Handle_TCollection_HAsciiString, aExternallyDefinedItem_ItemId: StepBasic_SourceItem, aExternallyDefinedItem_Source: Handle_StepBasic_ExternalSource): void;
  ExternallyDefinedItem(): Handle_StepBasic_ExternallyDefinedItem;
  SetExternallyDefinedItem(ExternallyDefinedItem: Handle_StepBasic_ExternallyDefinedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_AutoDesignPersonAndOrganizationAssignment extends StepBasic_PersonAndOrganizationAssignment {
  constructor()
  Init(aAssignedPersonAndOrganization: Handle_StepBasic_PersonAndOrganization, aRole: Handle_StepBasic_PersonAndOrganizationRole, aItems: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignGeneralOrgItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignPersonAndOrganizationAssignment): void;
  get(): StepAP214_AutoDesignPersonAndOrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_1 extends Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_2 extends Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment {
    constructor(thePtr: StepAP214_AutoDesignPersonAndOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_3 extends Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_4 extends Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment);
  }

export declare class Handle_StepAP214_AutoDesignPresentedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignPresentedItem): void;
  get(): StepAP214_AutoDesignPresentedItem;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignPresentedItem_1 extends Handle_StepAP214_AutoDesignPresentedItem {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignPresentedItem_2 extends Handle_StepAP214_AutoDesignPresentedItem {
    constructor(thePtr: StepAP214_AutoDesignPresentedItem);
  }

  export declare class Handle_StepAP214_AutoDesignPresentedItem_3 extends Handle_StepAP214_AutoDesignPresentedItem {
    constructor(theHandle: Handle_StepAP214_AutoDesignPresentedItem);
  }

  export declare class Handle_StepAP214_AutoDesignPresentedItem_4 extends Handle_StepAP214_AutoDesignPresentedItem {
    constructor(theHandle: Handle_StepAP214_AutoDesignPresentedItem);
  }

export declare class StepAP214_AutoDesignPresentedItem extends StepVisual_PresentedItem {
  constructor()
  Init(aItems: Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignPresentedItemSelect;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_Class extends StepBasic_Group {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_Class {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_Class): void;
  get(): StepAP214_Class;
  delete(): void;
}

  export declare class Handle_StepAP214_Class_1 extends Handle_StepAP214_Class {
    constructor();
  }

  export declare class Handle_StepAP214_Class_2 extends Handle_StepAP214_Class {
    constructor(thePtr: StepAP214_Class);
  }

  export declare class Handle_StepAP214_Class_3 extends Handle_StepAP214_Class {
    constructor(theHandle: Handle_StepAP214_Class);
  }

  export declare class Handle_StepAP214_Class_4 extends Handle_StepAP214_Class {
    constructor(theHandle: Handle_StepAP214_Class);
  }

export declare class Handle_StepAP214_HArray1OfPresentedItemSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfPresentedItemSelect): void;
  get(): StepAP214_HArray1OfPresentedItemSelect;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfPresentedItemSelect_1 extends Handle_StepAP214_HArray1OfPresentedItemSelect {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfPresentedItemSelect_2 extends Handle_StepAP214_HArray1OfPresentedItemSelect {
    constructor(thePtr: StepAP214_HArray1OfPresentedItemSelect);
  }

  export declare class Handle_StepAP214_HArray1OfPresentedItemSelect_3 extends Handle_StepAP214_HArray1OfPresentedItemSelect {
    constructor(theHandle: Handle_StepAP214_HArray1OfPresentedItemSelect);
  }

  export declare class Handle_StepAP214_HArray1OfPresentedItemSelect_4 extends Handle_StepAP214_HArray1OfPresentedItemSelect {
    constructor(theHandle: Handle_StepAP214_HArray1OfPresentedItemSelect);
  }

export declare class StepAP214_AutoDesignPresentedItemSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionShape(): Handle_StepRepr_ProductDefinitionShape;
  RepresentationRelationship(): Handle_StepRepr_RepresentationRelationship;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  DocumentRelationship(): Handle_StepBasic_DocumentRelationship;
  delete(): void;
}

export declare class StepAP214_AutoDesignReferencingItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Approval(): Handle_StepBasic_Approval;
  DocumentRelationship(): Handle_StepBasic_DocumentRelationship;
  ExternallyDefinedRepresentation(): Handle_StepRepr_ExternallyDefinedRepresentation;
  MappedItem(): Handle_StepRepr_MappedItem;
  MaterialDesignation(): Handle_StepRepr_MaterialDesignation;
  PresentationArea(): Handle_StepVisual_PresentationArea;
  PresentationView(): Handle_StepVisual_PresentationView;
  ProductCategory(): Handle_StepBasic_ProductCategory;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  PropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  Representation(): Handle_StepRepr_Representation;
  RepresentationRelationship(): Handle_StepRepr_RepresentationRelationship;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  delete(): void;
}

export declare class StepAP214_Array1OfPresentedItemSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_PresentedItemSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfPresentedItemSelect): StepAP214_Array1OfPresentedItemSelect;
  Move(theOther: StepAP214_Array1OfPresentedItemSelect): StepAP214_Array1OfPresentedItemSelect;
  First(): StepAP214_PresentedItemSelect;
  ChangeFirst(): StepAP214_PresentedItemSelect;
  Last(): StepAP214_PresentedItemSelect;
  ChangeLast(): StepAP214_PresentedItemSelect;
  Value(theIndex: Standard_Integer): StepAP214_PresentedItemSelect;
  ChangeValue(theIndex: Standard_Integer): StepAP214_PresentedItemSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_PresentedItemSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfPresentedItemSelect_1 extends StepAP214_Array1OfPresentedItemSelect {
    constructor();
  }

  export declare class StepAP214_Array1OfPresentedItemSelect_2 extends StepAP214_Array1OfPresentedItemSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfPresentedItemSelect_3 extends StepAP214_Array1OfPresentedItemSelect {
    constructor(theOther: StepAP214_Array1OfPresentedItemSelect);
  }

  export declare class StepAP214_Array1OfPresentedItemSelect_4 extends StepAP214_Array1OfPresentedItemSelect {
    constructor(theOther: StepAP214_Array1OfPresentedItemSelect);
  }

  export declare class StepAP214_Array1OfPresentedItemSelect_5 extends StepAP214_Array1OfPresentedItemSelect {
    constructor(theBegin: StepAP214_PresentedItemSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignNominalDateAndTimeAssignment): void;
  get(): StepAP214_AutoDesignNominalDateAndTimeAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_1 extends Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_2 extends Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment {
    constructor(thePtr: StepAP214_AutoDesignNominalDateAndTimeAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_3 extends Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_4 extends Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment);
  }

export declare class StepAP214_AutoDesignNominalDateAndTimeAssignment extends StepBasic_DateAndTimeAssignment {
  constructor()
  Init(aAssignedDateAndTime: Handle_StepBasic_DateAndTime, aRole: Handle_StepBasic_DateTimeRole, aItems: Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignDateAndTimeItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignSecurityClassificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignSecurityClassificationAssignment): void;
  get(): StepAP214_AutoDesignSecurityClassificationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignSecurityClassificationAssignment_1 extends Handle_StepAP214_AutoDesignSecurityClassificationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignSecurityClassificationAssignment_2 extends Handle_StepAP214_AutoDesignSecurityClassificationAssignment {
    constructor(thePtr: StepAP214_AutoDesignSecurityClassificationAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignSecurityClassificationAssignment_3 extends Handle_StepAP214_AutoDesignSecurityClassificationAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignSecurityClassificationAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignSecurityClassificationAssignment_4 extends Handle_StepAP214_AutoDesignSecurityClassificationAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignSecurityClassificationAssignment);
  }

export declare class StepAP214_AutoDesignSecurityClassificationAssignment extends StepBasic_SecurityClassificationAssignment {
  constructor()
  Init(aAssignedSecurityClassification: Handle_StepBasic_SecurityClassification, aItems: Handle_StepBasic_HArray1OfApproval): void;
  SetItems(aItems: Handle_StepBasic_HArray1OfApproval): void;
  Items(): Handle_StepBasic_HArray1OfApproval;
  ItemsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_Approval;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignActualDateAndTimeAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignActualDateAndTimeAssignment): void;
  get(): StepAP214_AutoDesignActualDateAndTimeAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_1 extends Handle_StepAP214_AutoDesignActualDateAndTimeAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_2 extends Handle_StepAP214_AutoDesignActualDateAndTimeAssignment {
    constructor(thePtr: StepAP214_AutoDesignActualDateAndTimeAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_3 extends Handle_StepAP214_AutoDesignActualDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignActualDateAndTimeAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_4 extends Handle_StepAP214_AutoDesignActualDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignActualDateAndTimeAssignment);
  }

export declare class StepAP214_AutoDesignActualDateAndTimeAssignment extends StepBasic_DateAndTimeAssignment {
  constructor()
  Init(aAssignedDateAndTime: Handle_StepBasic_DateAndTime, aRole: Handle_StepBasic_DateTimeRole, aItems: Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignDateAndTimeItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AutoDesignActualDateAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AutoDesignActualDateAssignment): void;
  get(): StepAP214_AutoDesignActualDateAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AutoDesignActualDateAssignment_1 extends Handle_StepAP214_AutoDesignActualDateAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AutoDesignActualDateAssignment_2 extends Handle_StepAP214_AutoDesignActualDateAssignment {
    constructor(thePtr: StepAP214_AutoDesignActualDateAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignActualDateAssignment_3 extends Handle_StepAP214_AutoDesignActualDateAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignActualDateAssignment);
  }

  export declare class Handle_StepAP214_AutoDesignActualDateAssignment_4 extends Handle_StepAP214_AutoDesignActualDateAssignment {
    constructor(theHandle: Handle_StepAP214_AutoDesignActualDateAssignment);
  }

export declare class StepAP214_AutoDesignActualDateAssignment extends StepBasic_DateAssignment {
  constructor()
  Init(aAssignedDate: Handle_StepBasic_Date, aRole: Handle_StepBasic_DateRole, aItems: Handle_StepAP214_HArray1OfAutoDesignDatedItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfAutoDesignDatedItem): void;
  Items(): Handle_StepAP214_HArray1OfAutoDesignDatedItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_AutoDesignDatedItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP214_AutoDesignGeneralOrgItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Product(): Handle_StepBasic_Product;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  ProductDefinitionWithAssociatedDocuments(): Handle_StepBasic_ProductDefinitionWithAssociatedDocuments;
  Representation(): Handle_StepRepr_Representation;
  ExternallyDefinedRepresentation(): Handle_StepRepr_ExternallyDefinedRepresentation;
  AutoDesignDocumentReference(): Handle_StepAP214_AutoDesignDocumentReference;
  delete(): void;
}

export declare class Handle_StepAP214_HArray1OfGroupItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfGroupItem): void;
  get(): StepAP214_HArray1OfGroupItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfGroupItem_1 extends Handle_StepAP214_HArray1OfGroupItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfGroupItem_2 extends Handle_StepAP214_HArray1OfGroupItem {
    constructor(thePtr: StepAP214_HArray1OfGroupItem);
  }

  export declare class Handle_StepAP214_HArray1OfGroupItem_3 extends Handle_StepAP214_HArray1OfGroupItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfGroupItem);
  }

  export declare class Handle_StepAP214_HArray1OfGroupItem_4 extends Handle_StepAP214_HArray1OfGroupItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfGroupItem);
  }

export declare class StepAP214_Array1OfSecurityClassificationItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_SecurityClassificationItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfSecurityClassificationItem): StepAP214_Array1OfSecurityClassificationItem;
  Move(theOther: StepAP214_Array1OfSecurityClassificationItem): StepAP214_Array1OfSecurityClassificationItem;
  First(): StepAP214_SecurityClassificationItem;
  ChangeFirst(): StepAP214_SecurityClassificationItem;
  Last(): StepAP214_SecurityClassificationItem;
  ChangeLast(): StepAP214_SecurityClassificationItem;
  Value(theIndex: Standard_Integer): StepAP214_SecurityClassificationItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_SecurityClassificationItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_SecurityClassificationItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfSecurityClassificationItem_1 extends StepAP214_Array1OfSecurityClassificationItem {
    constructor();
  }

  export declare class StepAP214_Array1OfSecurityClassificationItem_2 extends StepAP214_Array1OfSecurityClassificationItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfSecurityClassificationItem_3 extends StepAP214_Array1OfSecurityClassificationItem {
    constructor(theOther: StepAP214_Array1OfSecurityClassificationItem);
  }

  export declare class StepAP214_Array1OfSecurityClassificationItem_4 extends StepAP214_Array1OfSecurityClassificationItem {
    constructor(theOther: StepAP214_Array1OfSecurityClassificationItem);
  }

  export declare class StepAP214_Array1OfSecurityClassificationItem_5 extends StepAP214_Array1OfSecurityClassificationItem {
    constructor(theBegin: StepAP214_SecurityClassificationItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_AppliedExternalIdentificationAssignment extends StepBasic_ExternalIdentificationAssignment {
  constructor()
  Init(aIdentificationAssignment_AssignedId: Handle_TCollection_HAsciiString, aIdentificationAssignment_Role: Handle_StepBasic_IdentificationRole, aExternalIdentificationAssignment_Source: Handle_StepBasic_ExternalSource, aItems: Handle_StepAP214_HArray1OfExternalIdentificationItem): void;
  Items(): Handle_StepAP214_HArray1OfExternalIdentificationItem;
  SetItems(Items: Handle_StepAP214_HArray1OfExternalIdentificationItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP214_AppliedExternalIdentificationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedExternalIdentificationAssignment): void;
  get(): StepAP214_AppliedExternalIdentificationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedExternalIdentificationAssignment_1 extends Handle_StepAP214_AppliedExternalIdentificationAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedExternalIdentificationAssignment_2 extends Handle_StepAP214_AppliedExternalIdentificationAssignment {
    constructor(thePtr: StepAP214_AppliedExternalIdentificationAssignment);
  }

  export declare class Handle_StepAP214_AppliedExternalIdentificationAssignment_3 extends Handle_StepAP214_AppliedExternalIdentificationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedExternalIdentificationAssignment);
  }

  export declare class Handle_StepAP214_AppliedExternalIdentificationAssignment_4 extends Handle_StepAP214_AppliedExternalIdentificationAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedExternalIdentificationAssignment);
  }

export declare class StepAP214_ApprovalItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AssemblyComponentUsageSubstitute(): Handle_StepRepr_AssemblyComponentUsageSubstitute;
  DocumentFile(): Handle_StepBasic_DocumentFile;
  MaterialDesignation(): Handle_StepRepr_MaterialDesignation;
  MechanicalDesignGeometricPresentationRepresentation(): Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation;
  PresentationArea(): Handle_StepVisual_PresentationArea;
  Product(): Handle_StepBasic_Product;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  PropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  ShapeRepresentation(): Handle_StepShape_ShapeRepresentation;
  SecurityClassification(): Handle_StepBasic_SecurityClassification;
  ConfigurationItem(): Handle_StepRepr_ConfigurationItem;
  Date(): Handle_StepBasic_Date;
  Document(): Handle_StepBasic_Document;
  Effectivity(): Handle_StepBasic_Effectivity;
  Group(): Handle_StepBasic_Group;
  GroupRelationship(): Handle_StepBasic_GroupRelationship;
  ProductDefinitionFormationRelationship(): Handle_StepBasic_ProductDefinitionFormationRelationship;
  Representation(): Handle_StepRepr_Representation;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  delete(): void;
}

export declare class StepAP214_PresentedItemSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  delete(): void;
}

export declare class StepAP214_Array1OfAutoDesignDatedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_AutoDesignDatedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfAutoDesignDatedItem): StepAP214_Array1OfAutoDesignDatedItem;
  Move(theOther: StepAP214_Array1OfAutoDesignDatedItem): StepAP214_Array1OfAutoDesignDatedItem;
  First(): StepAP214_AutoDesignDatedItem;
  ChangeFirst(): StepAP214_AutoDesignDatedItem;
  Last(): StepAP214_AutoDesignDatedItem;
  ChangeLast(): StepAP214_AutoDesignDatedItem;
  Value(theIndex: Standard_Integer): StepAP214_AutoDesignDatedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_AutoDesignDatedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_AutoDesignDatedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfAutoDesignDatedItem_1 extends StepAP214_Array1OfAutoDesignDatedItem {
    constructor();
  }

  export declare class StepAP214_Array1OfAutoDesignDatedItem_2 extends StepAP214_Array1OfAutoDesignDatedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfAutoDesignDatedItem_3 extends StepAP214_Array1OfAutoDesignDatedItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignDatedItem);
  }

  export declare class StepAP214_Array1OfAutoDesignDatedItem_4 extends StepAP214_Array1OfAutoDesignDatedItem {
    constructor(theOther: StepAP214_Array1OfAutoDesignDatedItem);
  }

  export declare class StepAP214_Array1OfAutoDesignDatedItem_5 extends StepAP214_Array1OfAutoDesignDatedItem {
    constructor(theBegin: StepAP214_AutoDesignDatedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP214_Array1OfGroupItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_GroupItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfGroupItem): StepAP214_Array1OfGroupItem;
  Move(theOther: StepAP214_Array1OfGroupItem): StepAP214_Array1OfGroupItem;
  First(): StepAP214_GroupItem;
  ChangeFirst(): StepAP214_GroupItem;
  Last(): StepAP214_GroupItem;
  ChangeLast(): StepAP214_GroupItem;
  Value(theIndex: Standard_Integer): StepAP214_GroupItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_GroupItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_GroupItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfGroupItem_1 extends StepAP214_Array1OfGroupItem {
    constructor();
  }

  export declare class StepAP214_Array1OfGroupItem_2 extends StepAP214_Array1OfGroupItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfGroupItem_3 extends StepAP214_Array1OfGroupItem {
    constructor(theOther: StepAP214_Array1OfGroupItem);
  }

  export declare class StepAP214_Array1OfGroupItem_4 extends StepAP214_Array1OfGroupItem {
    constructor(theOther: StepAP214_Array1OfGroupItem);
  }

  export declare class StepAP214_Array1OfGroupItem_5 extends StepAP214_Array1OfGroupItem {
    constructor(theBegin: StepAP214_GroupItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_HArray1OfDateItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfDateItem): void;
  get(): StepAP214_HArray1OfDateItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfDateItem_1 extends Handle_StepAP214_HArray1OfDateItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfDateItem_2 extends Handle_StepAP214_HArray1OfDateItem {
    constructor(thePtr: StepAP214_HArray1OfDateItem);
  }

  export declare class Handle_StepAP214_HArray1OfDateItem_3 extends Handle_StepAP214_HArray1OfDateItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfDateItem);
  }

  export declare class Handle_StepAP214_HArray1OfDateItem_4 extends Handle_StepAP214_HArray1OfDateItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfDateItem);
  }

export declare class StepAP214_DateAndTimeItem extends StepAP214_ApprovalItem {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ApprovalPersonOrganization(): Handle_StepBasic_ApprovalPersonOrganization;
  AppliedPersonAndOrganizationAssignment(): Handle_StepAP214_AppliedPersonAndOrganizationAssignment;
  AppliedOrganizationAssignment(): Handle_StepAP214_AppliedOrganizationAssignment;
  delete(): void;
}

export declare class StepAP214_DateItem extends StepAP214_ApprovalItem {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ApprovalPersonOrganization(): Handle_StepBasic_ApprovalPersonOrganization;
  AppliedPersonAndOrganizationAssignment(): Handle_StepAP214_AppliedPersonAndOrganizationAssignment;
  AppliedOrganizationAssignment(): Handle_StepAP214_AppliedOrganizationAssignment;
  AppliedSecurityClassificationAssignment(): Handle_StepAP214_AppliedSecurityClassificationAssignment;
  delete(): void;
}

export declare class StepAP214_Array1OfApprovalItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP214_ApprovalItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP214_Array1OfApprovalItem): StepAP214_Array1OfApprovalItem;
  Move(theOther: StepAP214_Array1OfApprovalItem): StepAP214_Array1OfApprovalItem;
  First(): StepAP214_ApprovalItem;
  ChangeFirst(): StepAP214_ApprovalItem;
  Last(): StepAP214_ApprovalItem;
  ChangeLast(): StepAP214_ApprovalItem;
  Value(theIndex: Standard_Integer): StepAP214_ApprovalItem;
  ChangeValue(theIndex: Standard_Integer): StepAP214_ApprovalItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP214_ApprovalItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP214_Array1OfApprovalItem_1 extends StepAP214_Array1OfApprovalItem {
    constructor();
  }

  export declare class StepAP214_Array1OfApprovalItem_2 extends StepAP214_Array1OfApprovalItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP214_Array1OfApprovalItem_3 extends StepAP214_Array1OfApprovalItem {
    constructor(theOther: StepAP214_Array1OfApprovalItem);
  }

  export declare class StepAP214_Array1OfApprovalItem_4 extends StepAP214_Array1OfApprovalItem {
    constructor(theOther: StepAP214_Array1OfApprovalItem);
  }

  export declare class StepAP214_Array1OfApprovalItem_5 extends StepAP214_Array1OfApprovalItem {
    constructor(theBegin: StepAP214_ApprovalItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP214_HArray1OfDateAndTimeItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_HArray1OfDateAndTimeItem): void;
  get(): StepAP214_HArray1OfDateAndTimeItem;
  delete(): void;
}

  export declare class Handle_StepAP214_HArray1OfDateAndTimeItem_1 extends Handle_StepAP214_HArray1OfDateAndTimeItem {
    constructor();
  }

  export declare class Handle_StepAP214_HArray1OfDateAndTimeItem_2 extends Handle_StepAP214_HArray1OfDateAndTimeItem {
    constructor(thePtr: StepAP214_HArray1OfDateAndTimeItem);
  }

  export declare class Handle_StepAP214_HArray1OfDateAndTimeItem_3 extends Handle_StepAP214_HArray1OfDateAndTimeItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfDateAndTimeItem);
  }

  export declare class Handle_StepAP214_HArray1OfDateAndTimeItem_4 extends Handle_StepAP214_HArray1OfDateAndTimeItem {
    constructor(theHandle: Handle_StepAP214_HArray1OfDateAndTimeItem);
  }

export declare class StepAP214_SecurityClassificationItem extends StepAP214_ApprovalItem {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Action(): Handle_StepBasic_Action;
  AssemblyComponentUsage(): Handle_StepRepr_AssemblyComponentUsage;
  ConfigurationDesign(): Handle_StepRepr_ConfigurationDesign;
  ConfigurationEffectivity(): Handle_StepRepr_ConfigurationEffectivity;
  DraughtingModel(): Handle_StepVisual_DraughtingModel;
  GeneralProperty(): Handle_StepBasic_GeneralProperty;
  MakeFromUsageOption(): Handle_StepRepr_MakeFromUsageOption;
  ProductConcept(): Handle_StepRepr_ProductConcept;
  ProductDefinitionUsage(): Handle_StepRepr_ProductDefinitionUsage;
  VersionedActionRequest(): Handle_StepBasic_VersionedActionRequest;
  delete(): void;
}

export declare class Handle_StepAP214_AppliedDateAndTimeAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP214_AppliedDateAndTimeAssignment): void;
  get(): StepAP214_AppliedDateAndTimeAssignment;
  delete(): void;
}

  export declare class Handle_StepAP214_AppliedDateAndTimeAssignment_1 extends Handle_StepAP214_AppliedDateAndTimeAssignment {
    constructor();
  }

  export declare class Handle_StepAP214_AppliedDateAndTimeAssignment_2 extends Handle_StepAP214_AppliedDateAndTimeAssignment {
    constructor(thePtr: StepAP214_AppliedDateAndTimeAssignment);
  }

  export declare class Handle_StepAP214_AppliedDateAndTimeAssignment_3 extends Handle_StepAP214_AppliedDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedDateAndTimeAssignment);
  }

  export declare class Handle_StepAP214_AppliedDateAndTimeAssignment_4 extends Handle_StepAP214_AppliedDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP214_AppliedDateAndTimeAssignment);
  }

export declare class StepAP214_AppliedDateAndTimeAssignment extends StepBasic_DateAndTimeAssignment {
  constructor()
  Init(aAssignedDateAndTime: Handle_StepBasic_DateAndTime, aRole: Handle_StepBasic_DateTimeRole, aItems: Handle_StepAP214_HArray1OfDateAndTimeItem): void;
  SetItems(aItems: Handle_StepAP214_HArray1OfDateAndTimeItem): void;
  Items(): Handle_StepAP214_HArray1OfDateAndTimeItem;
  ItemsValue(num: Graphic3d_ZLayerId): StepAP214_DateAndTimeItem;
  NbItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class LProp3d_CLProps {
  SetParameter(U: Quantity_AbsorbedDose): void;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  Value(): gp_Pnt;
  D1(): gp_Vec;
  D2(): gp_Vec;
  D3(): gp_Vec;
  IsTangentDefined(): Standard_Boolean;
  Tangent(D: gp_Dir): void;
  Curvature(): Quantity_AbsorbedDose;
  Normal(N: gp_Dir): void;
  CentreOfCurvature(P: gp_Pnt): void;
  delete(): void;
}

  export declare class LProp3d_CLProps_1 extends LProp3d_CLProps {
    constructor(C: Handle_Adaptor3d_HCurve, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class LProp3d_CLProps_2 extends LProp3d_CLProps {
    constructor(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class LProp3d_CLProps_3 extends LProp3d_CLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class LProp3d_SLProps {
  SetSurface(S: Handle_Adaptor3d_HSurface): void;
  SetParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  D1U(): gp_Vec;
  D1V(): gp_Vec;
  D2U(): gp_Vec;
  D2V(): gp_Vec;
  DUV(): gp_Vec;
  IsTangentUDefined(): Standard_Boolean;
  TangentU(D: gp_Dir): void;
  IsTangentVDefined(): Standard_Boolean;
  TangentV(D: gp_Dir): void;
  IsNormalDefined(): Standard_Boolean;
  Normal(): gp_Dir;
  IsCurvatureDefined(): Standard_Boolean;
  IsUmbilic(): Standard_Boolean;
  MaxCurvature(): Quantity_AbsorbedDose;
  MinCurvature(): Quantity_AbsorbedDose;
  CurvatureDirections(MaxD: gp_Dir, MinD: gp_Dir): void;
  MeanCurvature(): Quantity_AbsorbedDose;
  GaussianCurvature(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class LProp3d_SLProps_1 extends LProp3d_SLProps {
    constructor(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class LProp3d_SLProps_2 extends LProp3d_SLProps {
    constructor(S: Handle_Adaptor3d_HSurface, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class LProp3d_SLProps_3 extends LProp3d_SLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class LProp3d_SurfaceTool {
  constructor();
  static Value(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  static D2(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, DUV: gp_Vec): void;
  static DN(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, IU: Graphic3d_ZLayerId, IV: Graphic3d_ZLayerId): gp_Vec;
  static Continuity(S: Handle_Adaptor3d_HSurface): Graphic3d_ZLayerId;
  static Bounds(S: Handle_Adaptor3d_HSurface, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class LProp3d_CurveTool {
  constructor();
  static Value(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static D2(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: Handle_Adaptor3d_HCurve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static Continuity(C: Handle_Adaptor3d_HCurve): Graphic3d_ZLayerId;
  static FirstParameter(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Adaptor3d_HCurve): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GccAna_Circ2d3Tan {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position, Qualif3: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency3(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame3(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class GccAna_Circ2d3Tan_1 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, Qualified3: GccEnt_QualifiedCirc, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_2 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, Qualified3: GccEnt_QualifiedLin, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_3 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, Qualified3: GccEnt_QualifiedLin, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_4 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, Qualified3: GccEnt_QualifiedLin, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_5 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, Point3: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_6 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, Point3: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_7 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, Point3: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_8 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Point2: gp_Pnt2d, Point3: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_9 extends GccAna_Circ2d3Tan {
    constructor(Qualified1: GccEnt_QualifiedLin, Point2: gp_Pnt2d, Point3: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d3Tan_10 extends GccAna_Circ2d3Tan {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d, Point3: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GccAna_Lin2dTanPer {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, Pnt: gp_Pnt2d): void;
  Intersection2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

  export declare class GccAna_Lin2dTanPer_1 extends GccAna_Lin2dTanPer {
    constructor(ThePnt: gp_Pnt2d, TheLin: gp_Lin2d);
  }

  export declare class GccAna_Lin2dTanPer_2 extends GccAna_Lin2dTanPer {
    constructor(ThePnt: gp_Pnt2d, TheCircle: gp_Circ2d);
  }

  export declare class GccAna_Lin2dTanPer_3 extends GccAna_Lin2dTanPer {
    constructor(Qualified1: GccEnt_QualifiedCirc, TheLin: gp_Lin2d);
  }

  export declare class GccAna_Lin2dTanPer_4 extends GccAna_Lin2dTanPer {
    constructor(Qualified1: GccEnt_QualifiedCirc, TheCircle: gp_Circ2d);
  }

export declare class GccAna_Circ2dBisec {
  constructor(Circ1: gp_Circ2d, Circ2: gp_Circ2d)
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): Handle_GccInt_Bisec;
  delete(): void;
}

export declare class GccAna_Circ2dTanOnRad {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(Index: Graphic3d_ZLayerId, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class GccAna_Circ2dTanOnRad_1 extends GccAna_Circ2dTanOnRad {
    constructor(Qualified1: GccEnt_QualifiedCirc, OnLine: gp_Lin2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2dTanOnRad_2 extends GccAna_Circ2dTanOnRad {
    constructor(Qualified1: GccEnt_QualifiedLin, OnLine: gp_Lin2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2dTanOnRad_3 extends GccAna_Circ2dTanOnRad {
    constructor(Point1: gp_Pnt2d, OnLine: gp_Lin2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2dTanOnRad_4 extends GccAna_Circ2dTanOnRad {
    constructor(Qualified1: GccEnt_QualifiedCirc, OnCirc: gp_Circ2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2dTanOnRad_5 extends GccAna_Circ2dTanOnRad {
    constructor(Qualified1: GccEnt_QualifiedLin, OnCirc: gp_Circ2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2dTanOnRad_6 extends GccAna_Circ2dTanOnRad {
    constructor(Point1: gp_Pnt2d, OnCirc: gp_Circ2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GccAna_NoSolution extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_GccAna_NoSolution;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GccAna_NoSolution_1 extends GccAna_NoSolution {
    constructor();
  }

  export declare class GccAna_NoSolution_2 extends GccAna_NoSolution {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_GccAna_NoSolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccAna_NoSolution): void;
  get(): GccAna_NoSolution;
  delete(): void;
}

  export declare class Handle_GccAna_NoSolution_1 extends Handle_GccAna_NoSolution {
    constructor();
  }

  export declare class Handle_GccAna_NoSolution_2 extends Handle_GccAna_NoSolution {
    constructor(thePtr: GccAna_NoSolution);
  }

  export declare class Handle_GccAna_NoSolution_3 extends Handle_GccAna_NoSolution {
    constructor(theHandle: Handle_GccAna_NoSolution);
  }

  export declare class Handle_GccAna_NoSolution_4 extends Handle_GccAna_NoSolution {
    constructor(theHandle: Handle_GccAna_NoSolution);
  }

export declare class GccAna_Lin2dTanObl {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Intersection2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

  export declare class GccAna_Lin2dTanObl_1 extends GccAna_Lin2dTanObl {
    constructor(ThePoint: gp_Pnt2d, TheLine: gp_Lin2d, TheAngle: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Lin2dTanObl_2 extends GccAna_Lin2dTanObl {
    constructor(Qualified1: GccEnt_QualifiedCirc, TheLine: gp_Lin2d, TheAngle: Quantity_AbsorbedDose);
  }

export declare class GccAna_Lin2dTanPar {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, Pnt: gp_Pnt2d): void;
  delete(): void;
}

  export declare class GccAna_Lin2dTanPar_1 extends GccAna_Lin2dTanPar {
    constructor(ThePoint: gp_Pnt2d, Lin1: gp_Lin2d);
  }

  export declare class GccAna_Lin2dTanPar_2 extends GccAna_Lin2dTanPar {
    constructor(Qualified1: GccEnt_QualifiedCirc, Lin1: gp_Lin2d);
  }

export declare class GccAna_Circ2d2TanRad {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class GccAna_Circ2d2TanRad_1 extends GccAna_Circ2d2TanRad {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanRad_2 extends GccAna_Circ2d2TanRad {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanRad_3 extends GccAna_Circ2d2TanRad {
    constructor(Qualified1: GccEnt_QualifiedCirc, Point2: gp_Pnt2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanRad_4 extends GccAna_Circ2d2TanRad {
    constructor(Qualified1: GccEnt_QualifiedLin, Point2: gp_Pnt2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanRad_5 extends GccAna_Circ2d2TanRad {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanRad_6 extends GccAna_Circ2d2TanRad {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GccAna_Lin2dBisec {
  constructor(Lin1: gp_Lin2d, Lin2: gp_Lin2d)
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  Intersection1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Intersection2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

export declare class GccAna_CircLin2dBisec {
  constructor(Circle: gp_Circ2d, Line: gp_Lin2d)
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): Handle_GccInt_Bisec;
  delete(): void;
}

export declare class GccAna_Circ2d2TanOn {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(Index: Graphic3d_ZLayerId, ParArg: Quantity_AbsorbedDose, PntArg: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class GccAna_Circ2d2TanOn_1 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, OnLine: gp_Lin2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_2 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, OnLine: gp_Lin2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_3 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, OnLine: gp_Lin2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_4 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedCirc, Point2: gp_Pnt2d, OnLine: gp_Lin2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_5 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedLin, Point2: gp_Pnt2d, OnLine: gp_Lin2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_6 extends GccAna_Circ2d2TanOn {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d, OnLine: gp_Lin2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_7 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, OnCirc: gp_Circ2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_8 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, OnCirc: gp_Circ2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_9 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedCirc, Point2: gp_Pnt2d, OnCirc: gp_Circ2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_10 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, OnCirc: gp_Circ2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_11 extends GccAna_Circ2d2TanOn {
    constructor(Qualified1: GccEnt_QualifiedLin, Point2: gp_Pnt2d, OnCirc: gp_Circ2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2d2TanOn_12 extends GccAna_Circ2d2TanOn {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d, OnCirc: gp_Circ2d, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GccAna_LinPnt2dBisec {
  constructor(Line1: gp_Lin2d, Point2: gp_Pnt2d)
  IsDone(): Standard_Boolean;
  ThisSolution(): Handle_GccInt_Bisec;
  delete(): void;
}

export declare class GccAna_Circ2dTanCen {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class GccAna_Circ2dTanCen_1 extends GccAna_Circ2dTanCen {
    constructor(Qualified1: GccEnt_QualifiedCirc, Pcenter: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Circ2dTanCen_2 extends GccAna_Circ2dTanCen {
    constructor(Linetan: gp_Lin2d, Pcenter: gp_Pnt2d);
  }

  export declare class GccAna_Circ2dTanCen_3 extends GccAna_Circ2dTanCen {
    constructor(Point1: gp_Pnt2d, Pcenter: gp_Pnt2d);
  }

export declare class GccAna_Pnt2dBisec {
  constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d)
  IsDone(): Standard_Boolean;
  HasSolution(): Standard_Boolean;
  ThisSolution(): gp_Lin2d;
  delete(): void;
}

export declare class GccAna_CircPnt2dBisec {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): Handle_GccInt_Bisec;
  delete(): void;
}

  export declare class GccAna_CircPnt2dBisec_1 extends GccAna_CircPnt2dBisec {
    constructor(Circle1: gp_Circ2d, Point2: gp_Pnt2d);
  }

  export declare class GccAna_CircPnt2dBisec_2 extends GccAna_CircPnt2dBisec {
    constructor(Circle1: gp_Circ2d, Point2: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

export declare class GccAna_Lin2d2Tan {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

  export declare class GccAna_Lin2d2Tan_1 extends GccAna_Lin2d2Tan {
    constructor(ThePoint1: gp_Pnt2d, ThePoint2: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Lin2d2Tan_2 extends GccAna_Lin2d2Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, ThePoint: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class GccAna_Lin2d2Tan_3 extends GccAna_Lin2d2Tan {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, Tolerance: Quantity_AbsorbedDose);
  }

export declare type StdPrs_Volume = {
  StdPrs_Volume_Autodetection: {};
  StdPrs_Volume_Closed: {};
  StdPrs_Volume_Opened: {};
}

export declare class StdPrs_WFRestrictedFace extends Prs3d_Root {
  constructor();
  static Add_1(thePresentation: any, theFace: Handle_BRepAdaptor_HSurface, theDrawUIso: Standard_Boolean, theDrawVIso: Standard_Boolean, theNbUIso: Graphic3d_ZLayerId, theNbVIso: Graphic3d_ZLayerId, theDrawer: Handle_Prs3d_Drawer, theCurves: Prs3d_NListOfSequenceOfPnt): void;
  static Add_2(thePresentation: any, theFace: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer): void;
  static Match_1(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theDistance: Quantity_AbsorbedDose, theFace: Handle_BRepAdaptor_HSurface, theDrawUIso: Standard_Boolean, theDrawVIso: Standard_Boolean, theDeflection: Quantity_AbsorbedDose, theNbUIso: Graphic3d_ZLayerId, theNbVIso: Graphic3d_ZLayerId, theDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Match_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theDistance: Quantity_AbsorbedDose, theFace: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static MatchUIso(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theDistance: Quantity_AbsorbedDose, theFace: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static MatchVIso(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theDistance: Quantity_AbsorbedDose, theFace: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static AddUIso(thePresentation: any, theFace: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer): void;
  static AddVIso(thePresentation: any, theFace: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare class Handle_StdPrs_BRepFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdPrs_BRepFont): void;
  get(): StdPrs_BRepFont;
  delete(): void;
}

  export declare class Handle_StdPrs_BRepFont_1 extends Handle_StdPrs_BRepFont {
    constructor();
  }

  export declare class Handle_StdPrs_BRepFont_2 extends Handle_StdPrs_BRepFont {
    constructor(thePtr: StdPrs_BRepFont);
  }

  export declare class Handle_StdPrs_BRepFont_3 extends Handle_StdPrs_BRepFont {
    constructor(theHandle: Handle_StdPrs_BRepFont);
  }

  export declare class Handle_StdPrs_BRepFont_4 extends Handle_StdPrs_BRepFont {
    constructor(theHandle: Handle_StdPrs_BRepFont);
  }

export declare class StdPrs_BRepFont extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static FindAndCreate(theFontName: XCAFDoc_PartId, theFontAspect: Font_FontAspect, theSize: Quantity_AbsorbedDose, theStrictLevel: Font_StrictLevel): Handle_StdPrs_BRepFont;
  Release(): void;
  Init_1(theFontPath: NCollection_String, theSize: Quantity_AbsorbedDose, theFaceId: Graphic3d_ZLayerId): Standard_Boolean;
  FindAndInit(theFontName: XCAFDoc_PartId, theFontAspect: Font_FontAspect, theSize: Quantity_AbsorbedDose, theStrictLevel: Font_StrictLevel): Standard_Boolean;
  FTFont(): Handle_Font_FTFont;
  RenderGlyph(theChar: Standard_Utf32Char): TopoDS_Shape;
  SetCompositeCurveMode(theToConcatenate: Standard_Boolean): void;
  SetWidthScaling(theScaleFactor: Standard_ShortReal): void;
  Ascender(): Quantity_AbsorbedDose;
  Descender(): Quantity_AbsorbedDose;
  LineSpacing(): Quantity_AbsorbedDose;
  PointSize(): Quantity_AbsorbedDose;
  AdvanceX_1(theUCharNext: Standard_Utf32Char): Quantity_AbsorbedDose;
  AdvanceX_2(theUChar: Standard_Utf32Char, theUCharNext: Standard_Utf32Char): Quantity_AbsorbedDose;
  AdvanceY_1(theUCharNext: Standard_Utf32Char): Quantity_AbsorbedDose;
  AdvanceY_2(theUChar: Standard_Utf32Char, theUCharNext: Standard_Utf32Char): Quantity_AbsorbedDose;
  Scale(): Quantity_AbsorbedDose;
  Init_2(theFontName: NCollection_String, theFontAspect: Font_FontAspect, theSize: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class StdPrs_BRepFont_1 extends StdPrs_BRepFont {
    constructor();
  }

  export declare class StdPrs_BRepFont_2 extends StdPrs_BRepFont {
    constructor(theFontPath: NCollection_String, theSize: Quantity_AbsorbedDose, theFaceId: Graphic3d_ZLayerId);
  }

  export declare class StdPrs_BRepFont_3 extends StdPrs_BRepFont {
    constructor(theFontName: NCollection_String, theFontAspect: Font_FontAspect, theSize: Quantity_AbsorbedDose, theStrictLevel: Font_StrictLevel);
  }

export declare class StdPrs_ShadedShape extends Prs3d_Root {
  constructor();
  static Add_1(thePresentation: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theVolume: StdPrs_Volume): void;
  static Add_2(thePresentation: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theHasTexels: Standard_Boolean, theUVOrigin: gp_Pnt2d, theUVRepeat: gp_Pnt2d, theUVScale: gp_Pnt2d, theVolume: StdPrs_Volume): void;
  static ExploreSolids(theShape: TopoDS_Shape, theBuilder: BRep_Builder, theClosed: TopoDS_Compound, theOpened: TopoDS_Compound, theIgnore1DSubShape: Standard_Boolean): void;
  static AddWireframeForFreeElements(thePrs: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): void;
  static AddWireframeForFacesWithoutTriangles(thePrs: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): void;
  static FillTriangles_1(theShape: TopoDS_Shape): Handle_Graphic3d_ArrayOfTriangles;
  static FillTriangles_2(theShape: TopoDS_Shape, theHasTexels: Standard_Boolean, theUVOrigin: gp_Pnt2d, theUVRepeat: gp_Pnt2d, theUVScale: gp_Pnt2d): Handle_Graphic3d_ArrayOfTriangles;
  static FillFaceBoundaries(theShape: TopoDS_Shape, theUpperContinuity: GeomAbs_Shape): Handle_Graphic3d_ArrayOfSegments;
  delete(): void;
}

export declare class StdPrs_BRepTextBuilder {
  constructor();
  Perform_1(theFont: Font_BRepFont, theFormatter: Handle_Font_TextFormatter, thePenLoc: gp_Ax3): TopoDS_Shape;
  Perform_2(theFont: Font_BRepFont, theString: NCollection_String, thePenLoc: gp_Ax3, theHAlign: Graphic3d_HorizontalTextAlignment, theVAlign: Graphic3d_VerticalTextAlignment): TopoDS_Shape;
  delete(): void;
}

export declare class StdPrs_HLRShape extends StdPrs_HLRShapeI {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ComputeHLR(thePrs: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theProjector: Handle_Graphic3d_Camera): void;
  delete(): void;
}

export declare class StdPrs_WFDeflectionRestrictedFace extends Prs3d_Root {
  constructor();
  static Add_1(aPresentation: any, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer): void;
  static AddUIso(aPresentation: any, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer): void;
  static AddVIso(aPresentation: any, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer): void;
  static Add_2(aPresentation: any, aFace: Handle_BRepAdaptor_HSurface, DrawUIso: Standard_Boolean, DrawVIso: Standard_Boolean, Deflection: Quantity_AbsorbedDose, NBUiso: Graphic3d_ZLayerId, NBViso: Graphic3d_ZLayerId, aDrawer: Handle_Prs3d_Drawer, Curves: Prs3d_NListOfSequenceOfPnt): void;
  static Match_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static MatchUIso(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static MatchVIso(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Match_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_Prs3d_Drawer, DrawUIso: Standard_Boolean, DrawVIso: Standard_Boolean, aDeflection: Quantity_AbsorbedDose, NBUiso: Graphic3d_ZLayerId, NBViso: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class StdPrs_WFSurface extends Prs3d_Root {
  constructor();
  static Add(aPresentation: any, aSurface: Handle_Adaptor3d_HSurface, aDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare class StdPrs_ToolRFace {
  IsOriented(): Standard_Boolean;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Adaptor2d_Curve2d;
  Edge(): TopoDS_Edge;
  Orientation(): TopAbs_Orientation;
  IsInvalidGeometry(): Standard_Boolean;
  delete(): void;
}

  export declare class StdPrs_ToolRFace_1 extends StdPrs_ToolRFace {
    constructor();
  }

  export declare class StdPrs_ToolRFace_2 extends StdPrs_ToolRFace {
    constructor(aSurface: Handle_BRepAdaptor_HSurface);
  }

export declare class StdPrs_ToolTriangulatedShape {
  constructor();
  static IsTriangulated(theShape: TopoDS_Shape): Standard_Boolean;
  static IsClosed(theShape: TopoDS_Shape): Standard_Boolean;
  static ComputeNormals_1(theFace: TopoDS_Face, theTris: Handle_Poly_Triangulation): void;
  static ComputeNormals_2(theFace: TopoDS_Face, theTris: Handle_Poly_Triangulation, thePolyConnect: Poly_Connect): void;
  static Normal(theFace: TopoDS_Face, thePolyConnect: Poly_Connect, theNormals: TColgp_Array1OfDir): void;
  static GetDeflection(theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): Quantity_AbsorbedDose;
  static IsTessellated(theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Tessellate(theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static ClearOnOwnDeflectionChange(theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theToResetCoeff: Standard_Boolean): void;
  delete(): void;
}

export declare class StdPrs_ShadedSurface extends Prs3d_Root {
  constructor();
  static Add(aPresentation: any, aSurface: Adaptor3d_Surface, aDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare class StdPrs_ToolVertex {
  constructor();
  static Coord(aPoint: TopoDS_Vertex, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StdPrs_HLRToolShape {
  constructor(TheShape: TopoDS_Shape, TheProjector: HLRAlgo_Projector)
  NbEdges(): Graphic3d_ZLayerId;
  InitVisible(EdgeNumber: Graphic3d_ZLayerId): void;
  MoreVisible(): Standard_Boolean;
  NextVisible(): void;
  Visible(TheEdge: BRepAdaptor_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  InitHidden(EdgeNumber: Graphic3d_ZLayerId): void;
  MoreHidden(): Standard_Boolean;
  NextHidden(): void;
  Hidden(TheEdge: BRepAdaptor_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StdPrs_WFShape extends Prs3d_Root {
  constructor();
  static Add(thePresentation: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theIsParallel: Standard_Boolean): void;
  static AddEdgesOnTriangulation_1(theShape: TopoDS_Shape, theToExcludeGeometric: Standard_Boolean): Handle_Graphic3d_ArrayOfPrimitives;
  static AddEdgesOnTriangulation_2(theSegments: TColgp_SequenceOfPnt, theShape: TopoDS_Shape, theToExcludeGeometric: Standard_Boolean): void;
  static AddAllEdges(theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): Handle_Graphic3d_ArrayOfPrimitives;
  static AddVertexes(theShape: TopoDS_Shape, theVertexMode: Prs3d_VertexDrawMode): Handle_Graphic3d_ArrayOfPoints;
  delete(): void;
}

export declare class StdPrs_Plane extends Prs3d_Root {
  constructor();
  static Add(aPresentation: any, aPlane: Adaptor3d_Surface, aDrawer: Handle_Prs3d_Drawer): void;
  static Match(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aPlane: Adaptor3d_Surface, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  delete(): void;
}

export declare class StdPrs_DeflectionCurve extends Prs3d_Root {
  constructor();
  static Add_1(aPresentation: any, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer, drawCurve: Standard_Boolean): void;
  static Add_2(aPresentation: any, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDrawer: Handle_Prs3d_Drawer, drawCurve: Standard_Boolean): void;
  static Add_3(aPresentation: any, aCurve: Adaptor3d_Curve, aDeflection: Quantity_AbsorbedDose, aLimit: Quantity_AbsorbedDose, anAngle: Quantity_AbsorbedDose, drawCurve: Standard_Boolean): void;
  static Add_4(aPresentation: any, aCurve: Adaptor3d_Curve, aDeflection: Quantity_AbsorbedDose, aDrawer: Handle_Prs3d_Drawer, Points: TColgp_SequenceOfPnt, drawCurve: Standard_Boolean): void;
  static Add_5(aPresentation: any, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDeflection: Quantity_AbsorbedDose, Points: TColgp_SequenceOfPnt, anAngle: Quantity_AbsorbedDose, drawCurve: Standard_Boolean): void;
  static Match_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Match_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Match_3(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theDistance: Quantity_AbsorbedDose, theCurve: Adaptor3d_Curve, theDeflection: Quantity_AbsorbedDose, theLimit: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose): Standard_Boolean;
  static Match_4(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theDistance: Quantity_AbsorbedDose, theCurve: Adaptor3d_Curve, theU1: Quantity_AbsorbedDose, theU2: Quantity_AbsorbedDose, theDeflection: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class StdPrs_WFPoleSurface extends Prs3d_Root {
  constructor();
  static Add(aPresentation: any, aSurface: Adaptor3d_Surface, aDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare class StdPrs_PoleCurve extends Prs3d_Root {
  constructor();
  static Add(aPresentation: any, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer): void;
  static Match(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Pick(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class StdPrs_HLRPolyShape extends StdPrs_HLRShapeI {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ComputeHLR(thePrs: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theProjector: Handle_Graphic3d_Camera): void;
  delete(): void;
}

export declare class StdPrs_Curve extends Prs3d_Root {
  constructor();
  static Add_1(aPresentation: any, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer, drawCurve: Standard_Boolean): void;
  static Add_2(aPresentation: any, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDrawer: Handle_Prs3d_Drawer, drawCurve: Standard_Boolean): void;
  static Add_3(aPresentation: any, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer, Points: TColgp_SequenceOfPnt, drawCurve: Standard_Boolean): void;
  static Add_4(aPresentation: any, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Points: TColgp_SequenceOfPnt, aNbPoints: Graphic3d_ZLayerId, drawCurve: Standard_Boolean): void;
  static Match_1(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Match_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, aDeflection: Quantity_AbsorbedDose, aLimit: Quantity_AbsorbedDose, aNbPoints: Graphic3d_ZLayerId): Standard_Boolean;
  static Match_3(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDrawer: Handle_Prs3d_Drawer): Standard_Boolean;
  static Match_4(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDeflection: Quantity_AbsorbedDose, aNbPoints: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class StdPrs_Isolines extends Prs3d_Root {
  constructor();
  static Add_1(thePresentation: any, theFace: TopoDS_Face, theDrawer: Handle_Prs3d_Drawer, theDeflection: Quantity_AbsorbedDose): void;
  static Add_2(theFace: TopoDS_Face, theDrawer: Handle_Prs3d_Drawer, theDeflection: Quantity_AbsorbedDose, theUPolylines: Prs3d_NListOfSequenceOfPnt, theVPolylines: Prs3d_NListOfSequenceOfPnt): void;
  static AddOnTriangulation_1(thePresentation: any, theFace: TopoDS_Face, theDrawer: Handle_Prs3d_Drawer): void;
  static AddOnTriangulation_2(theFace: TopoDS_Face, theDrawer: Handle_Prs3d_Drawer, theUPolylines: Prs3d_NListOfSequenceOfPnt, theVPolylines: Prs3d_NListOfSequenceOfPnt): void;
  static AddOnTriangulation_3(thePresentation: any, theTriangulation: Handle_Poly_Triangulation, theSurface: Handle_Geom_Surface, theLocation: TopLoc_Location, theDrawer: Handle_Prs3d_Drawer, theUIsoParams: TColStd_SequenceOfReal, theVIsoParams: TColStd_SequenceOfReal): void;
  static AddOnSurface_1(thePresentation: any, theFace: TopoDS_Face, theDrawer: Handle_Prs3d_Drawer, theDeflection: Quantity_AbsorbedDose): void;
  static AddOnSurface_2(theFace: TopoDS_Face, theDrawer: Handle_Prs3d_Drawer, theDeflection: Quantity_AbsorbedDose, theUPolylines: Prs3d_NListOfSequenceOfPnt, theVPolylines: Prs3d_NListOfSequenceOfPnt): void;
  static AddOnSurface_3(thePresentation: any, theSurface: Handle_BRepAdaptor_HSurface, theDrawer: Handle_Prs3d_Drawer, theDeflection: Quantity_AbsorbedDose, theUIsoParams: TColStd_SequenceOfReal, theVIsoParams: TColStd_SequenceOfReal): void;
  static UVIsoParameters(theFace: TopoDS_Face, theNbIsoU: Graphic3d_ZLayerId, theNbIsoV: Graphic3d_ZLayerId, theUVLimit: Quantity_AbsorbedDose, theUIsoParams: TColStd_SequenceOfReal, theVIsoParams: TColStd_SequenceOfReal, theUmin: Quantity_AbsorbedDose, theUmax: Quantity_AbsorbedDose, theVmin: Quantity_AbsorbedDose, theVmax: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StdPrs_ToolPoint {
  constructor();
  static Coord(aPoint: Handle_Geom_Point, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StdPrs_HLRShapeI extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ComputeHLR(thePrs: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer, theProjector: Handle_Graphic3d_Camera): void;
  delete(): void;
}

export declare class StdPrs_WFDeflectionSurface extends Prs3d_Root {
  constructor();
  static Add(aPresentation: any, aSurface: Handle_Adaptor3d_HSurface, aDrawer: Handle_Prs3d_Drawer): void;
  delete(): void;
}

export declare class StdPrs_ShapeTool {
  constructor(theShape: TopoDS_Shape, theAllVertices: Standard_Boolean)
  InitFace(): void;
  MoreFace(): Standard_Boolean;
  NextFace(): void;
  GetFace(): TopoDS_Face;
  FaceBound(): Bnd_Box;
  IsPlanarFace_1(): Standard_Boolean;
  InitCurve(): void;
  MoreCurve(): Standard_Boolean;
  NextCurve(): void;
  GetCurve(): TopoDS_Edge;
  CurveBound(): Bnd_Box;
  Neighbours(): Graphic3d_ZLayerId;
  FacesOfEdge(): Handle_TopTools_HSequenceOfShape;
  InitVertex(): void;
  MoreVertex(): Standard_Boolean;
  NextVertex(): void;
  GetVertex(): TopoDS_Vertex;
  HasSurface(): Standard_Boolean;
  CurrentTriangulation(l: TopLoc_Location): Handle_Poly_Triangulation;
  HasCurve(): Standard_Boolean;
  PolygonOnTriangulation(Indices: Handle_Poly_PolygonOnTriangulation, T: Handle_Poly_Triangulation, l: TopLoc_Location): void;
  Polygon3D(l: TopLoc_Location): Handle_Poly_Polygon3D;
  static IsPlanarFace_2(theFace: TopoDS_Face): Standard_Boolean;
  delete(): void;
}

export declare class ShapeUpgrade {
  constructor();
  static C0BSplineToSequenceOfC1BSplineCurve_1(BS: Handle_Geom_BSplineCurve, seqBS: Handle_TColGeom_HSequenceOfBoundedCurve): Standard_Boolean;
  static C0BSplineToSequenceOfC1BSplineCurve_2(BS: Handle_Geom2d_BSplineCurve, seqBS: Handle_TColGeom2d_HSequenceOfBoundedCurve): Standard_Boolean;
  delete(): void;
}

export declare class ShapeUpgrade_ShapeDivideAngle extends ShapeUpgrade_ShapeDivide {
  InitTool(MaxAngle: Quantity_AbsorbedDose): void;
  SetMaxAngle(MaxAngle: Quantity_AbsorbedDose): void;
  MaxAngle(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class ShapeUpgrade_ShapeDivideAngle_1 extends ShapeUpgrade_ShapeDivideAngle {
    constructor(MaxAngle: Quantity_AbsorbedDose);
  }

  export declare class ShapeUpgrade_ShapeDivideAngle_2 extends ShapeUpgrade_ShapeDivideAngle {
    constructor(MaxAngle: Quantity_AbsorbedDose, S: TopoDS_Shape);
  }

export declare class ShapeUpgrade_SplitSurfaceArea extends ShapeUpgrade_SplitSurface {
  constructor()
  NbParts(): Graphic3d_ZLayerId;
  Compute(Segment: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitSurfaceArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitSurfaceArea): void;
  get(): ShapeUpgrade_SplitSurfaceArea;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitSurfaceArea_1 extends Handle_ShapeUpgrade_SplitSurfaceArea {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceArea_2 extends Handle_ShapeUpgrade_SplitSurfaceArea {
    constructor(thePtr: ShapeUpgrade_SplitSurfaceArea);
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceArea_3 extends Handle_ShapeUpgrade_SplitSurfaceArea {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurfaceArea);
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceArea_4 extends Handle_ShapeUpgrade_SplitSurfaceArea {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurfaceArea);
  }

export declare class Handle_ShapeUpgrade_ConvertCurve3dToBezier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_ConvertCurve3dToBezier): void;
  get(): ShapeUpgrade_ConvertCurve3dToBezier;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_ConvertCurve3dToBezier_1 extends Handle_ShapeUpgrade_ConvertCurve3dToBezier {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_ConvertCurve3dToBezier_2 extends Handle_ShapeUpgrade_ConvertCurve3dToBezier {
    constructor(thePtr: ShapeUpgrade_ConvertCurve3dToBezier);
  }

  export declare class Handle_ShapeUpgrade_ConvertCurve3dToBezier_3 extends Handle_ShapeUpgrade_ConvertCurve3dToBezier {
    constructor(theHandle: Handle_ShapeUpgrade_ConvertCurve3dToBezier);
  }

  export declare class Handle_ShapeUpgrade_ConvertCurve3dToBezier_4 extends Handle_ShapeUpgrade_ConvertCurve3dToBezier {
    constructor(theHandle: Handle_ShapeUpgrade_ConvertCurve3dToBezier);
  }

export declare class ShapeUpgrade_ConvertCurve3dToBezier extends ShapeUpgrade_SplitCurve3d {
  constructor()
  SetLineMode(mode: Standard_Boolean): void;
  GetLineMode(): Standard_Boolean;
  SetCircleMode(mode: Standard_Boolean): void;
  GetCircleMode(): Standard_Boolean;
  SetConicMode(mode: Standard_Boolean): void;
  GetConicMode(): Standard_Boolean;
  Compute(): void;
  Build(Segment: Standard_Boolean): void;
  SplitParams(): Handle_TColStd_HSequenceOfReal;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeUpgrade_WireDivide extends ShapeUpgrade_Tool {
  constructor()
  Init_1(W: TopoDS_Wire, F: TopoDS_Face): void;
  Init_2(W: TopoDS_Wire, S: Handle_Geom_Surface): void;
  Load_1(W: TopoDS_Wire): void;
  Load_2(E: TopoDS_Edge): void;
  SetFace(F: TopoDS_Face): void;
  SetSurface_1(S: Handle_Geom_Surface): void;
  SetSurface_2(S: Handle_Geom_Surface, L: TopLoc_Location): void;
  Perform(): void;
  Wire(): TopoDS_Wire;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  SetSplitCurve3dTool(splitCurve3dTool: Handle_ShapeUpgrade_SplitCurve3d): void;
  SetSplitCurve2dTool(splitCurve2dTool: Handle_ShapeUpgrade_SplitCurve2d): void;
  SetTransferParamTool(TransferParam: Handle_ShapeAnalysis_TransferParameters): void;
  SetEdgeDivideTool(edgeDivideTool: Handle_ShapeUpgrade_EdgeDivide): void;
  GetEdgeDivideTool(): Handle_ShapeUpgrade_EdgeDivide;
  GetTransferParamTool(): Handle_ShapeAnalysis_TransferParameters;
  SetEdgeMode(EdgeMode: Graphic3d_ZLayerId): void;
  SetFixSmallCurveTool(FixSmallCurvesTool: Handle_ShapeUpgrade_FixSmallCurves): void;
  GetFixSmallCurveTool(): Handle_ShapeUpgrade_FixSmallCurves;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_WireDivide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_WireDivide): void;
  get(): ShapeUpgrade_WireDivide;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_WireDivide_1 extends Handle_ShapeUpgrade_WireDivide {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_WireDivide_2 extends Handle_ShapeUpgrade_WireDivide {
    constructor(thePtr: ShapeUpgrade_WireDivide);
  }

  export declare class Handle_ShapeUpgrade_WireDivide_3 extends Handle_ShapeUpgrade_WireDivide {
    constructor(theHandle: Handle_ShapeUpgrade_WireDivide);
  }

  export declare class Handle_ShapeUpgrade_WireDivide_4 extends Handle_ShapeUpgrade_WireDivide {
    constructor(theHandle: Handle_ShapeUpgrade_WireDivide);
  }

export declare class ShapeUpgrade_SplitSurface extends Standard_Transient {
  constructor()
  Init_1(S: Handle_Geom_Surface): void;
  Init_2(S: Handle_Geom_Surface, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose): void;
  SetUSplitValues(UValues: Handle_TColStd_HSequenceOfReal): void;
  SetVSplitValues(VValues: Handle_TColStd_HSequenceOfReal): void;
  Build(Segment: Standard_Boolean): void;
  Compute(Segment: Standard_Boolean): void;
  Perform(Segment: Standard_Boolean): void;
  USplitValues(): Handle_TColStd_HSequenceOfReal;
  VSplitValues(): Handle_TColStd_HSequenceOfReal;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  ResSurfaces(): Handle_ShapeExtend_CompositeSurface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitSurface): void;
  get(): ShapeUpgrade_SplitSurface;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitSurface_1 extends Handle_ShapeUpgrade_SplitSurface {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitSurface_2 extends Handle_ShapeUpgrade_SplitSurface {
    constructor(thePtr: ShapeUpgrade_SplitSurface);
  }

  export declare class Handle_ShapeUpgrade_SplitSurface_3 extends Handle_ShapeUpgrade_SplitSurface {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurface);
  }

  export declare class Handle_ShapeUpgrade_SplitSurface_4 extends Handle_ShapeUpgrade_SplitSurface {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurface);
  }

export declare class ShapeUpgrade_SplitSurfaceContinuity extends ShapeUpgrade_SplitSurface {
  constructor()
  SetCriterion(Criterion: GeomAbs_Shape): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  Compute(Segment: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitSurfaceContinuity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitSurfaceContinuity): void;
  get(): ShapeUpgrade_SplitSurfaceContinuity;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitSurfaceContinuity_1 extends Handle_ShapeUpgrade_SplitSurfaceContinuity {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceContinuity_2 extends Handle_ShapeUpgrade_SplitSurfaceContinuity {
    constructor(thePtr: ShapeUpgrade_SplitSurfaceContinuity);
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceContinuity_3 extends Handle_ShapeUpgrade_SplitSurfaceContinuity {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurfaceContinuity);
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceContinuity_4 extends Handle_ShapeUpgrade_SplitSurfaceContinuity {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurfaceContinuity);
  }

export declare class SubSequenceOfEdges {
  constructor();
  delete(): void;
}

export declare class Handle_ShapeUpgrade_UnifySameDomain {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_UnifySameDomain): void;
  get(): ShapeUpgrade_UnifySameDomain;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_UnifySameDomain_1 extends Handle_ShapeUpgrade_UnifySameDomain {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_UnifySameDomain_2 extends Handle_ShapeUpgrade_UnifySameDomain {
    constructor(thePtr: ShapeUpgrade_UnifySameDomain);
  }

  export declare class Handle_ShapeUpgrade_UnifySameDomain_3 extends Handle_ShapeUpgrade_UnifySameDomain {
    constructor(theHandle: Handle_ShapeUpgrade_UnifySameDomain);
  }

  export declare class Handle_ShapeUpgrade_UnifySameDomain_4 extends Handle_ShapeUpgrade_UnifySameDomain {
    constructor(theHandle: Handle_ShapeUpgrade_UnifySameDomain);
  }

export declare class ShapeUpgrade_UnifySameDomain extends Standard_Transient {
  Initialize(aShape: TopoDS_Shape, UnifyEdges: Standard_Boolean, UnifyFaces: Standard_Boolean, ConcatBSplines: Standard_Boolean): void;
  AllowInternalEdges(theValue: Standard_Boolean): void;
  KeepShape(theShape: TopoDS_Shape): void;
  KeepShapes(theShapes: TopTools_MapOfShape): void;
  SetSafeInputMode(theValue: Standard_Boolean): void;
  SetLinearTolerance(theValue: Quantity_AbsorbedDose): void;
  SetAngularTolerance(theValue: Quantity_AbsorbedDose): void;
  Build(): void;
  Shape(): TopoDS_Shape;
  History_1(): Handle_BRepTools_History;
  History_2(): Handle_BRepTools_History;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeUpgrade_UnifySameDomain_1 extends ShapeUpgrade_UnifySameDomain {
    constructor();
  }

  export declare class ShapeUpgrade_UnifySameDomain_2 extends ShapeUpgrade_UnifySameDomain {
    constructor(aShape: TopoDS_Shape, UnifyEdges: Standard_Boolean, UnifyFaces: Standard_Boolean, ConcatBSplines: Standard_Boolean);
  }

export declare class ShapeUpgrade_EdgeDivide extends ShapeUpgrade_Tool {
  constructor()
  Clear(): void;
  SetFace(F: TopoDS_Face): void;
  Compute(E: TopoDS_Edge): Standard_Boolean;
  HasCurve2d(): Standard_Boolean;
  HasCurve3d(): Standard_Boolean;
  Knots2d(): Handle_TColStd_HSequenceOfReal;
  Knots3d(): Handle_TColStd_HSequenceOfReal;
  SetSplitCurve2dTool(splitCurve2dTool: Handle_ShapeUpgrade_SplitCurve2d): void;
  SetSplitCurve3dTool(splitCurve3dTool: Handle_ShapeUpgrade_SplitCurve3d): void;
  GetSplitCurve2dTool(): Handle_ShapeUpgrade_SplitCurve2d;
  GetSplitCurve3dTool(): Handle_ShapeUpgrade_SplitCurve3d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_EdgeDivide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_EdgeDivide): void;
  get(): ShapeUpgrade_EdgeDivide;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_EdgeDivide_1 extends Handle_ShapeUpgrade_EdgeDivide {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_EdgeDivide_2 extends Handle_ShapeUpgrade_EdgeDivide {
    constructor(thePtr: ShapeUpgrade_EdgeDivide);
  }

  export declare class Handle_ShapeUpgrade_EdgeDivide_3 extends Handle_ShapeUpgrade_EdgeDivide {
    constructor(theHandle: Handle_ShapeUpgrade_EdgeDivide);
  }

  export declare class Handle_ShapeUpgrade_EdgeDivide_4 extends Handle_ShapeUpgrade_EdgeDivide {
    constructor(theHandle: Handle_ShapeUpgrade_EdgeDivide);
  }

export declare class Handle_ShapeUpgrade_FixSmallBezierCurves {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_FixSmallBezierCurves): void;
  get(): ShapeUpgrade_FixSmallBezierCurves;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_FixSmallBezierCurves_1 extends Handle_ShapeUpgrade_FixSmallBezierCurves {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_FixSmallBezierCurves_2 extends Handle_ShapeUpgrade_FixSmallBezierCurves {
    constructor(thePtr: ShapeUpgrade_FixSmallBezierCurves);
  }

  export declare class Handle_ShapeUpgrade_FixSmallBezierCurves_3 extends Handle_ShapeUpgrade_FixSmallBezierCurves {
    constructor(theHandle: Handle_ShapeUpgrade_FixSmallBezierCurves);
  }

  export declare class Handle_ShapeUpgrade_FixSmallBezierCurves_4 extends Handle_ShapeUpgrade_FixSmallBezierCurves {
    constructor(theHandle: Handle_ShapeUpgrade_FixSmallBezierCurves);
  }

export declare class ShapeUpgrade_FixSmallBezierCurves extends ShapeUpgrade_FixSmallCurves {
  constructor()
  Approx(Curve3d: Handle_Geom_Curve, Curve2d: Handle_Geom2d_Curve, Curve2dR: Handle_Geom2d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitCurve3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitCurve3d): void;
  get(): ShapeUpgrade_SplitCurve3d;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitCurve3d_1 extends Handle_ShapeUpgrade_SplitCurve3d {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitCurve3d_2 extends Handle_ShapeUpgrade_SplitCurve3d {
    constructor(thePtr: ShapeUpgrade_SplitCurve3d);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve3d_3 extends Handle_ShapeUpgrade_SplitCurve3d {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve3d);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve3d_4 extends Handle_ShapeUpgrade_SplitCurve3d {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve3d);
  }

export declare class ShapeUpgrade_SplitCurve3d extends ShapeUpgrade_SplitCurve {
  constructor()
  Init_1(C: Handle_Geom_Curve): void;
  Init_2(C: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Build(Segment: Standard_Boolean): void;
  GetCurves(): Handle_TColGeom_HArray1OfCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_RemoveLocations {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_RemoveLocations): void;
  get(): ShapeUpgrade_RemoveLocations;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_RemoveLocations_1 extends Handle_ShapeUpgrade_RemoveLocations {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_RemoveLocations_2 extends Handle_ShapeUpgrade_RemoveLocations {
    constructor(thePtr: ShapeUpgrade_RemoveLocations);
  }

  export declare class Handle_ShapeUpgrade_RemoveLocations_3 extends Handle_ShapeUpgrade_RemoveLocations {
    constructor(theHandle: Handle_ShapeUpgrade_RemoveLocations);
  }

  export declare class Handle_ShapeUpgrade_RemoveLocations_4 extends Handle_ShapeUpgrade_RemoveLocations {
    constructor(theHandle: Handle_ShapeUpgrade_RemoveLocations);
  }

export declare class ShapeUpgrade_RemoveLocations extends Standard_Transient {
  constructor()
  Remove(theShape: TopoDS_Shape): Standard_Boolean;
  GetResult(): TopoDS_Shape;
  SetRemoveLevel(theLevel: TopAbs_ShapeEnum): void;
  RemoveLevel(): TopAbs_ShapeEnum;
  ModifiedShape(theInitShape: TopoDS_Shape): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_FaceDivide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_FaceDivide): void;
  get(): ShapeUpgrade_FaceDivide;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_FaceDivide_1 extends Handle_ShapeUpgrade_FaceDivide {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_FaceDivide_2 extends Handle_ShapeUpgrade_FaceDivide {
    constructor(thePtr: ShapeUpgrade_FaceDivide);
  }

  export declare class Handle_ShapeUpgrade_FaceDivide_3 extends Handle_ShapeUpgrade_FaceDivide {
    constructor(theHandle: Handle_ShapeUpgrade_FaceDivide);
  }

  export declare class Handle_ShapeUpgrade_FaceDivide_4 extends Handle_ShapeUpgrade_FaceDivide {
    constructor(theHandle: Handle_ShapeUpgrade_FaceDivide);
  }

export declare class ShapeUpgrade_FaceDivide extends ShapeUpgrade_Tool {
  Init(F: TopoDS_Face): void;
  SetSurfaceSegmentMode(Segment: Standard_Boolean): void;
  Perform(): Standard_Boolean;
  SplitSurface(): Standard_Boolean;
  SplitCurves(): Standard_Boolean;
  Result(): TopoDS_Shape;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  SetSplitSurfaceTool(splitSurfaceTool: Handle_ShapeUpgrade_SplitSurface): void;
  SetWireDivideTool(wireDivideTool: Handle_ShapeUpgrade_WireDivide): void;
  GetSplitSurfaceTool(): Handle_ShapeUpgrade_SplitSurface;
  GetWireDivideTool(): Handle_ShapeUpgrade_WireDivide;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeUpgrade_FaceDivide_1 extends ShapeUpgrade_FaceDivide {
    constructor();
  }

  export declare class ShapeUpgrade_FaceDivide_2 extends ShapeUpgrade_FaceDivide {
    constructor(F: TopoDS_Face);
  }

export declare class ShapeUpgrade_ShapeDivide {
  Init(S: TopoDS_Shape): void;
  SetPrecision(Prec: Quantity_AbsorbedDose): void;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  SetSurfaceSegmentMode(Segment: Standard_Boolean): void;
  Perform(newContext: Standard_Boolean): Standard_Boolean;
  Result(): TopoDS_Shape;
  GetContext(): Handle_ShapeBuild_ReShape;
  SetContext(context: Handle_ShapeBuild_ReShape): void;
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  MsgRegistrator(): Handle_ShapeExtend_BasicMsgRegistrator;
  SendMsg(shape: TopoDS_Shape, message: Message_Msg, gravity: Message_Gravity): void;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  SetSplitFaceTool(splitFaceTool: Handle_ShapeUpgrade_FaceDivide): void;
  SetEdgeMode(aEdgeMode: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class ShapeUpgrade_ShapeDivide_1 extends ShapeUpgrade_ShapeDivide {
    constructor();
  }

  export declare class ShapeUpgrade_ShapeDivide_2 extends ShapeUpgrade_ShapeDivide {
    constructor(S: TopoDS_Shape);
  }

export declare class ShapeUpgrade_SplitCurve2d extends ShapeUpgrade_SplitCurve {
  constructor()
  Init_1(C: Handle_Geom2d_Curve): void;
  Init_2(C: Handle_Geom2d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Build(Segment: Standard_Boolean): void;
  GetCurves(): Handle_TColGeom2d_HArray1OfCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitCurve2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitCurve2d): void;
  get(): ShapeUpgrade_SplitCurve2d;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitCurve2d_1 extends Handle_ShapeUpgrade_SplitCurve2d {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitCurve2d_2 extends Handle_ShapeUpgrade_SplitCurve2d {
    constructor(thePtr: ShapeUpgrade_SplitCurve2d);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve2d_3 extends Handle_ShapeUpgrade_SplitCurve2d {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve2d);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve2d_4 extends Handle_ShapeUpgrade_SplitCurve2d {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve2d);
  }

export declare class ShapeUpgrade_ShapeDivideClosed extends ShapeUpgrade_ShapeDivide {
  constructor(S: TopoDS_Shape)
  SetNbSplitPoints(num: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitSurfaceAngle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitSurfaceAngle): void;
  get(): ShapeUpgrade_SplitSurfaceAngle;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitSurfaceAngle_1 extends Handle_ShapeUpgrade_SplitSurfaceAngle {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceAngle_2 extends Handle_ShapeUpgrade_SplitSurfaceAngle {
    constructor(thePtr: ShapeUpgrade_SplitSurfaceAngle);
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceAngle_3 extends Handle_ShapeUpgrade_SplitSurfaceAngle {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurfaceAngle);
  }

  export declare class Handle_ShapeUpgrade_SplitSurfaceAngle_4 extends Handle_ShapeUpgrade_SplitSurfaceAngle {
    constructor(theHandle: Handle_ShapeUpgrade_SplitSurfaceAngle);
  }

export declare class ShapeUpgrade_SplitSurfaceAngle extends ShapeUpgrade_SplitSurface {
  constructor(MaxAngle: Quantity_AbsorbedDose)
  SetMaxAngle(MaxAngle: Quantity_AbsorbedDose): void;
  MaxAngle(): Quantity_AbsorbedDose;
  Compute(Segment: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeUpgrade_FixSmallCurves extends ShapeUpgrade_Tool {
  constructor()
  Init(theEdge: TopoDS_Edge, theFace: TopoDS_Face): void;
  Approx(Curve3d: Handle_Geom_Curve, Curve2d: Handle_Geom2d_Curve, Curve2dR: Handle_Geom2d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  SetSplitCurve3dTool(splitCurve3dTool: Handle_ShapeUpgrade_SplitCurve3d): void;
  SetSplitCurve2dTool(splitCurve2dTool: Handle_ShapeUpgrade_SplitCurve2d): void;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_FixSmallCurves {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_FixSmallCurves): void;
  get(): ShapeUpgrade_FixSmallCurves;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_FixSmallCurves_1 extends Handle_ShapeUpgrade_FixSmallCurves {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_FixSmallCurves_2 extends Handle_ShapeUpgrade_FixSmallCurves {
    constructor(thePtr: ShapeUpgrade_FixSmallCurves);
  }

  export declare class Handle_ShapeUpgrade_FixSmallCurves_3 extends Handle_ShapeUpgrade_FixSmallCurves {
    constructor(theHandle: Handle_ShapeUpgrade_FixSmallCurves);
  }

  export declare class Handle_ShapeUpgrade_FixSmallCurves_4 extends Handle_ShapeUpgrade_FixSmallCurves {
    constructor(theHandle: Handle_ShapeUpgrade_FixSmallCurves);
  }

export declare class Handle_ShapeUpgrade_ConvertCurve2dToBezier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_ConvertCurve2dToBezier): void;
  get(): ShapeUpgrade_ConvertCurve2dToBezier;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_ConvertCurve2dToBezier_1 extends Handle_ShapeUpgrade_ConvertCurve2dToBezier {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_ConvertCurve2dToBezier_2 extends Handle_ShapeUpgrade_ConvertCurve2dToBezier {
    constructor(thePtr: ShapeUpgrade_ConvertCurve2dToBezier);
  }

  export declare class Handle_ShapeUpgrade_ConvertCurve2dToBezier_3 extends Handle_ShapeUpgrade_ConvertCurve2dToBezier {
    constructor(theHandle: Handle_ShapeUpgrade_ConvertCurve2dToBezier);
  }

  export declare class Handle_ShapeUpgrade_ConvertCurve2dToBezier_4 extends Handle_ShapeUpgrade_ConvertCurve2dToBezier {
    constructor(theHandle: Handle_ShapeUpgrade_ConvertCurve2dToBezier);
  }

export declare class ShapeUpgrade_ConvertCurve2dToBezier extends ShapeUpgrade_SplitCurve2d {
  constructor()
  Compute(): void;
  Build(Segment: Standard_Boolean): void;
  SplitParams(): Handle_TColStd_HSequenceOfReal;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeUpgrade_Tool extends Standard_Transient {
  constructor()
  Set(tool: Handle_ShapeUpgrade_Tool): void;
  SetContext(context: Handle_ShapeBuild_ReShape): void;
  Context(): Handle_ShapeBuild_ReShape;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  Precision(): Quantity_AbsorbedDose;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  MinTolerance(): Quantity_AbsorbedDose;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  MaxTolerance(): Quantity_AbsorbedDose;
  LimitTolerance(toler: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_Tool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_Tool): void;
  get(): ShapeUpgrade_Tool;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_Tool_1 extends Handle_ShapeUpgrade_Tool {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_Tool_2 extends Handle_ShapeUpgrade_Tool {
    constructor(thePtr: ShapeUpgrade_Tool);
  }

  export declare class Handle_ShapeUpgrade_Tool_3 extends Handle_ShapeUpgrade_Tool {
    constructor(theHandle: Handle_ShapeUpgrade_Tool);
  }

  export declare class Handle_ShapeUpgrade_Tool_4 extends Handle_ShapeUpgrade_Tool {
    constructor(theHandle: Handle_ShapeUpgrade_Tool);
  }

export declare class ShapeUpgrade_FaceDivideArea extends ShapeUpgrade_FaceDivide {
  Perform(): Standard_Boolean;
  MaxArea(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeUpgrade_FaceDivideArea_1 extends ShapeUpgrade_FaceDivideArea {
    constructor();
  }

  export declare class ShapeUpgrade_FaceDivideArea_2 extends ShapeUpgrade_FaceDivideArea {
    constructor(F: TopoDS_Face);
  }

export declare class Handle_ShapeUpgrade_FaceDivideArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_FaceDivideArea): void;
  get(): ShapeUpgrade_FaceDivideArea;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_FaceDivideArea_1 extends Handle_ShapeUpgrade_FaceDivideArea {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_FaceDivideArea_2 extends Handle_ShapeUpgrade_FaceDivideArea {
    constructor(thePtr: ShapeUpgrade_FaceDivideArea);
  }

  export declare class Handle_ShapeUpgrade_FaceDivideArea_3 extends Handle_ShapeUpgrade_FaceDivideArea {
    constructor(theHandle: Handle_ShapeUpgrade_FaceDivideArea);
  }

  export declare class Handle_ShapeUpgrade_FaceDivideArea_4 extends Handle_ShapeUpgrade_FaceDivideArea {
    constructor(theHandle: Handle_ShapeUpgrade_FaceDivideArea);
  }

export declare class ShapeUpgrade_RemoveInternalWires extends ShapeUpgrade_Tool {
  Init(theShape: TopoDS_Shape): void;
  Perform_1(): Standard_Boolean;
  Perform_2(theSeqShapes: TopTools_SequenceOfShape): Standard_Boolean;
  GetResult(): TopoDS_Shape;
  MinArea(): Quantity_AbsorbedDose;
  RemoveFaceMode(): Standard_Boolean;
  RemovedFaces(): TopTools_SequenceOfShape;
  RemovedWires(): TopTools_SequenceOfShape;
  Status(theStatus: ShapeExtend_Status): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeUpgrade_RemoveInternalWires_1 extends ShapeUpgrade_RemoveInternalWires {
    constructor();
  }

  export declare class ShapeUpgrade_RemoveInternalWires_2 extends ShapeUpgrade_RemoveInternalWires {
    constructor(theShape: TopoDS_Shape);
  }

export declare class Handle_ShapeUpgrade_RemoveInternalWires {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_RemoveInternalWires): void;
  get(): ShapeUpgrade_RemoveInternalWires;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_RemoveInternalWires_1 extends Handle_ShapeUpgrade_RemoveInternalWires {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_RemoveInternalWires_2 extends Handle_ShapeUpgrade_RemoveInternalWires {
    constructor(thePtr: ShapeUpgrade_RemoveInternalWires);
  }

  export declare class Handle_ShapeUpgrade_RemoveInternalWires_3 extends Handle_ShapeUpgrade_RemoveInternalWires {
    constructor(theHandle: Handle_ShapeUpgrade_RemoveInternalWires);
  }

  export declare class Handle_ShapeUpgrade_RemoveInternalWires_4 extends Handle_ShapeUpgrade_RemoveInternalWires {
    constructor(theHandle: Handle_ShapeUpgrade_RemoveInternalWires);
  }

export declare class ShapeUpgrade_ShapeConvertToBezier extends ShapeUpgrade_ShapeDivide {
  Set2dConversion(mode: Standard_Boolean): void;
  Get2dConversion(): Standard_Boolean;
  Set3dConversion(mode: Standard_Boolean): void;
  Get3dConversion(): Standard_Boolean;
  SetSurfaceConversion(mode: Standard_Boolean): void;
  GetSurfaceConversion(): Standard_Boolean;
  Set3dLineConversion(mode: Standard_Boolean): void;
  Get3dLineConversion(): Standard_Boolean;
  Set3dCircleConversion(mode: Standard_Boolean): void;
  Get3dCircleConversion(): Standard_Boolean;
  Set3dConicConversion(mode: Standard_Boolean): void;
  Get3dConicConversion(): Standard_Boolean;
  SetPlaneMode(mode: Standard_Boolean): void;
  GetPlaneMode(): Standard_Boolean;
  SetRevolutionMode(mode: Standard_Boolean): void;
  GetRevolutionMode(): Standard_Boolean;
  SetExtrusionMode(mode: Standard_Boolean): void;
  GetExtrusionMode(): Standard_Boolean;
  SetBSplineMode(mode: Standard_Boolean): void;
  GetBSplineMode(): Standard_Boolean;
  Perform(newContext: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

  export declare class ShapeUpgrade_ShapeConvertToBezier_1 extends ShapeUpgrade_ShapeConvertToBezier {
    constructor();
  }

  export declare class ShapeUpgrade_ShapeConvertToBezier_2 extends ShapeUpgrade_ShapeConvertToBezier {
    constructor(S: TopoDS_Shape);
  }

export declare class ShapeUpgrade_ShapeDivideArea extends ShapeUpgrade_ShapeDivide {
  MaxArea(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class ShapeUpgrade_ShapeDivideArea_1 extends ShapeUpgrade_ShapeDivideArea {
    constructor();
  }

  export declare class ShapeUpgrade_ShapeDivideArea_2 extends ShapeUpgrade_ShapeDivideArea {
    constructor(S: TopoDS_Shape);
  }

export declare class ShapeUpgrade_ShellSewing {
  constructor()
  ApplySewing(shape: TopoDS_Shape, tol: Quantity_AbsorbedDose): TopoDS_Shape;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_ClosedEdgeDivide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_ClosedEdgeDivide): void;
  get(): ShapeUpgrade_ClosedEdgeDivide;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_ClosedEdgeDivide_1 extends Handle_ShapeUpgrade_ClosedEdgeDivide {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_ClosedEdgeDivide_2 extends Handle_ShapeUpgrade_ClosedEdgeDivide {
    constructor(thePtr: ShapeUpgrade_ClosedEdgeDivide);
  }

  export declare class Handle_ShapeUpgrade_ClosedEdgeDivide_3 extends Handle_ShapeUpgrade_ClosedEdgeDivide {
    constructor(theHandle: Handle_ShapeUpgrade_ClosedEdgeDivide);
  }

  export declare class Handle_ShapeUpgrade_ClosedEdgeDivide_4 extends Handle_ShapeUpgrade_ClosedEdgeDivide {
    constructor(theHandle: Handle_ShapeUpgrade_ClosedEdgeDivide);
  }

export declare class ShapeUpgrade_ClosedEdgeDivide extends ShapeUpgrade_EdgeDivide {
  constructor()
  Compute(anEdge: TopoDS_Edge): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeUpgrade_SplitCurve3dContinuity extends ShapeUpgrade_SplitCurve3d {
  constructor()
  SetCriterion(Criterion: GeomAbs_Shape): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  Compute(): void;
  GetCurve(): Handle_Geom_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitCurve3dContinuity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitCurve3dContinuity): void;
  get(): ShapeUpgrade_SplitCurve3dContinuity;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitCurve3dContinuity_1 extends Handle_ShapeUpgrade_SplitCurve3dContinuity {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitCurve3dContinuity_2 extends Handle_ShapeUpgrade_SplitCurve3dContinuity {
    constructor(thePtr: ShapeUpgrade_SplitCurve3dContinuity);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve3dContinuity_3 extends Handle_ShapeUpgrade_SplitCurve3dContinuity {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve3dContinuity);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve3dContinuity_4 extends Handle_ShapeUpgrade_SplitCurve3dContinuity {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve3dContinuity);
  }

export declare class Handle_ShapeUpgrade_ClosedFaceDivide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_ClosedFaceDivide): void;
  get(): ShapeUpgrade_ClosedFaceDivide;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_ClosedFaceDivide_1 extends Handle_ShapeUpgrade_ClosedFaceDivide {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_ClosedFaceDivide_2 extends Handle_ShapeUpgrade_ClosedFaceDivide {
    constructor(thePtr: ShapeUpgrade_ClosedFaceDivide);
  }

  export declare class Handle_ShapeUpgrade_ClosedFaceDivide_3 extends Handle_ShapeUpgrade_ClosedFaceDivide {
    constructor(theHandle: Handle_ShapeUpgrade_ClosedFaceDivide);
  }

  export declare class Handle_ShapeUpgrade_ClosedFaceDivide_4 extends Handle_ShapeUpgrade_ClosedFaceDivide {
    constructor(theHandle: Handle_ShapeUpgrade_ClosedFaceDivide);
  }

export declare class ShapeUpgrade_ClosedFaceDivide extends ShapeUpgrade_FaceDivide {
  SplitSurface(): Standard_Boolean;
  SetNbSplitPoints(num: Graphic3d_ZLayerId): void;
  GetNbSplitPoints(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeUpgrade_ClosedFaceDivide_1 extends ShapeUpgrade_ClosedFaceDivide {
    constructor();
  }

  export declare class ShapeUpgrade_ClosedFaceDivide_2 extends ShapeUpgrade_ClosedFaceDivide {
    constructor(F: TopoDS_Face);
  }

export declare class ShapeUpgrade_ConvertSurfaceToBezierBasis extends ShapeUpgrade_SplitSurface {
  constructor()
  Build(Segment: Standard_Boolean): void;
  Compute(Segment: Standard_Boolean): void;
  Segments(): Handle_ShapeExtend_CompositeSurface;
  SetPlaneMode(mode: Standard_Boolean): void;
  GetPlaneMode(): Standard_Boolean;
  SetRevolutionMode(mode: Standard_Boolean): void;
  GetRevolutionMode(): Standard_Boolean;
  SetExtrusionMode(mode: Standard_Boolean): void;
  GetExtrusionMode(): Standard_Boolean;
  SetBSplineMode(mode: Standard_Boolean): void;
  GetBSplineMode(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_ConvertSurfaceToBezierBasis): void;
  get(): ShapeUpgrade_ConvertSurfaceToBezierBasis;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_1 extends Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_2 extends Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis {
    constructor(thePtr: ShapeUpgrade_ConvertSurfaceToBezierBasis);
  }

  export declare class Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_3 extends Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis {
    constructor(theHandle: Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis);
  }

  export declare class Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_4 extends Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis {
    constructor(theHandle: Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis);
  }

export declare class Handle_ShapeUpgrade_SplitCurve2dContinuity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitCurve2dContinuity): void;
  get(): ShapeUpgrade_SplitCurve2dContinuity;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitCurve2dContinuity_1 extends Handle_ShapeUpgrade_SplitCurve2dContinuity {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitCurve2dContinuity_2 extends Handle_ShapeUpgrade_SplitCurve2dContinuity {
    constructor(thePtr: ShapeUpgrade_SplitCurve2dContinuity);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve2dContinuity_3 extends Handle_ShapeUpgrade_SplitCurve2dContinuity {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve2dContinuity);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve2dContinuity_4 extends Handle_ShapeUpgrade_SplitCurve2dContinuity {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve2dContinuity);
  }

export declare class ShapeUpgrade_SplitCurve2dContinuity extends ShapeUpgrade_SplitCurve2d {
  constructor()
  SetCriterion(Criterion: GeomAbs_Shape): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  Compute(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeUpgrade_ShapeDivideContinuity extends ShapeUpgrade_ShapeDivide {
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  SetTolerance2d(Tol: Quantity_AbsorbedDose): void;
  SetBoundaryCriterion(Criterion: GeomAbs_Shape): void;
  SetPCurveCriterion(Criterion: GeomAbs_Shape): void;
  SetSurfaceCriterion(Criterion: GeomAbs_Shape): void;
  delete(): void;
}

  export declare class ShapeUpgrade_ShapeDivideContinuity_1 extends ShapeUpgrade_ShapeDivideContinuity {
    constructor();
  }

  export declare class ShapeUpgrade_ShapeDivideContinuity_2 extends ShapeUpgrade_ShapeDivideContinuity {
    constructor(S: TopoDS_Shape);
  }

export declare class ShapeUpgrade_ShapeDivideClosedEdges extends ShapeUpgrade_ShapeDivide {
  constructor(S: TopoDS_Shape)
  SetNbSplitPoints(num: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class ShapeUpgrade_SplitCurve extends Standard_Transient {
  constructor()
  Init(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  SetSplitValues(SplitValues: Handle_TColStd_HSequenceOfReal): void;
  Build(Segment: Standard_Boolean): void;
  SplitValues(): Handle_TColStd_HSequenceOfReal;
  Compute(): void;
  Perform(Segment: Standard_Boolean): void;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeUpgrade_SplitCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeUpgrade_SplitCurve): void;
  get(): ShapeUpgrade_SplitCurve;
  delete(): void;
}

  export declare class Handle_ShapeUpgrade_SplitCurve_1 extends Handle_ShapeUpgrade_SplitCurve {
    constructor();
  }

  export declare class Handle_ShapeUpgrade_SplitCurve_2 extends Handle_ShapeUpgrade_SplitCurve {
    constructor(thePtr: ShapeUpgrade_SplitCurve);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve_3 extends Handle_ShapeUpgrade_SplitCurve {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve);
  }

  export declare class Handle_ShapeUpgrade_SplitCurve_4 extends Handle_ShapeUpgrade_SplitCurve {
    constructor(theHandle: Handle_ShapeUpgrade_SplitCurve);
  }

export declare class BRepTools_MapOfVertexPnt2d extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepTools_MapOfVertexPnt2d): void;
  Assign(theOther: BRepTools_MapOfVertexPnt2d): BRepTools_MapOfVertexPnt2d;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TColgp_SequenceOfPnt2d): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TColgp_SequenceOfPnt2d): TColgp_SequenceOfPnt2d;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TColgp_SequenceOfPnt2d;
  ChangeSeek(theKey: TopoDS_Shape): TColgp_SequenceOfPnt2d;
  ChangeFind(theKey: TopoDS_Shape): TColgp_SequenceOfPnt2d;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepTools_MapOfVertexPnt2d_1 extends BRepTools_MapOfVertexPnt2d {
    constructor();
  }

  export declare class BRepTools_MapOfVertexPnt2d_2 extends BRepTools_MapOfVertexPnt2d {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepTools_MapOfVertexPnt2d_3 extends BRepTools_MapOfVertexPnt2d {
    constructor(theOther: BRepTools_MapOfVertexPnt2d);
  }

export declare class Handle_BRepTools_TrsfModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTools_TrsfModification): void;
  get(): BRepTools_TrsfModification;
  delete(): void;
}

  export declare class Handle_BRepTools_TrsfModification_1 extends Handle_BRepTools_TrsfModification {
    constructor();
  }

  export declare class Handle_BRepTools_TrsfModification_2 extends Handle_BRepTools_TrsfModification {
    constructor(thePtr: BRepTools_TrsfModification);
  }

  export declare class Handle_BRepTools_TrsfModification_3 extends Handle_BRepTools_TrsfModification {
    constructor(theHandle: Handle_BRepTools_TrsfModification);
  }

  export declare class Handle_BRepTools_TrsfModification_4 extends Handle_BRepTools_TrsfModification {
    constructor(theHandle: Handle_BRepTools_TrsfModification);
  }

export declare class BRepTools_TrsfModification extends BRepTools_Modification {
  constructor(T: gp_Trsf)
  Trsf(): gp_Trsf;
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepTools_ShapeSet extends TopTools_ShapeSet {
  Clear(): void;
  AddGeometry(S: TopoDS_Shape): void;
  DumpGeometry_1(OS: Standard_OStream): void;
  WriteGeometry_1(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  ReadGeometry_1(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  DumpGeometry_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  WriteGeometry_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  ReadGeometry_2(T: TopAbs_ShapeEnum, IS: Standard_IStream, S: TopoDS_Shape): void;
  AddShapes(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  Check(T: TopAbs_ShapeEnum, S: TopoDS_Shape): void;
  ReadPolygon3D(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  WritePolygon3D(OS: Standard_OStream, Compact: Standard_Boolean, theProgress: Message_ProgressRange): void;
  DumpPolygon3D(OS: Standard_OStream): void;
  ReadTriangulation(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  WriteTriangulation(OS: Standard_OStream, Compact: Standard_Boolean, theProgress: Message_ProgressRange): void;
  DumpTriangulation(OS: Standard_OStream): void;
  ReadPolygonOnTriangulation(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  WritePolygonOnTriangulation(OS: Standard_OStream, Compact: Standard_Boolean, theProgress: Message_ProgressRange): void;
  DumpPolygonOnTriangulation(OS: Standard_OStream): void;
  delete(): void;
}

  export declare class BRepTools_ShapeSet_1 extends BRepTools_ShapeSet {
    constructor(isWithTriangles: Standard_Boolean);
  }

  export declare class BRepTools_ShapeSet_2 extends BRepTools_ShapeSet {
    constructor(B: BRep_Builder, isWithTriangles: Standard_Boolean);
  }

export declare class BRepTools_ReShape extends Standard_Transient {
  constructor()
  Clear(): void;
  Remove(shape: TopoDS_Shape): void;
  Replace(shape: TopoDS_Shape, newshape: TopoDS_Shape): void;
  IsRecorded(shape: TopoDS_Shape): Standard_Boolean;
  Value(shape: TopoDS_Shape): TopoDS_Shape;
  Status(shape: TopoDS_Shape, newsh: TopoDS_Shape, last: Standard_Boolean): Graphic3d_ZLayerId;
  Apply(shape: TopoDS_Shape, until: TopAbs_ShapeEnum): TopoDS_Shape;
  ModeConsiderLocation(): Standard_Boolean;
  CopyVertex_1(theV: TopoDS_Vertex, theTol: Quantity_AbsorbedDose): TopoDS_Vertex;
  CopyVertex_2(theV: TopoDS_Vertex, theNewPos: gp_Pnt, aTol: Quantity_AbsorbedDose): TopoDS_Vertex;
  IsNewShape(theShape: TopoDS_Shape): Standard_Boolean;
  History(): Handle_BRepTools_History;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepTools_ReShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTools_ReShape): void;
  get(): BRepTools_ReShape;
  delete(): void;
}

  export declare class Handle_BRepTools_ReShape_1 extends Handle_BRepTools_ReShape {
    constructor();
  }

  export declare class Handle_BRepTools_ReShape_2 extends Handle_BRepTools_ReShape {
    constructor(thePtr: BRepTools_ReShape);
  }

  export declare class Handle_BRepTools_ReShape_3 extends Handle_BRepTools_ReShape {
    constructor(theHandle: Handle_BRepTools_ReShape);
  }

  export declare class Handle_BRepTools_ReShape_4 extends Handle_BRepTools_ReShape {
    constructor(theHandle: Handle_BRepTools_ReShape);
  }

export declare class BRepTools_GTrsfModification extends BRepTools_Modification {
  constructor(T: gp_GTrsf)
  GTrsf(): gp_GTrsf;
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepTools_GTrsfModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTools_GTrsfModification): void;
  get(): BRepTools_GTrsfModification;
  delete(): void;
}

  export declare class Handle_BRepTools_GTrsfModification_1 extends Handle_BRepTools_GTrsfModification {
    constructor();
  }

  export declare class Handle_BRepTools_GTrsfModification_2 extends Handle_BRepTools_GTrsfModification {
    constructor(thePtr: BRepTools_GTrsfModification);
  }

  export declare class Handle_BRepTools_GTrsfModification_3 extends Handle_BRepTools_GTrsfModification {
    constructor(theHandle: Handle_BRepTools_GTrsfModification);
  }

  export declare class Handle_BRepTools_GTrsfModification_4 extends Handle_BRepTools_GTrsfModification {
    constructor(theHandle: Handle_BRepTools_GTrsfModification);
  }

export declare class BRepTools_Modification extends Standard_Transient {
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewTriangulation(F: TopoDS_Face, T: Handle_Poly_Triangulation): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPolygon(E: TopoDS_Edge, P: Handle_Poly_Polygon3D): Standard_Boolean;
  NewPolygonOnTriangulation(E: TopoDS_Edge, F: TopoDS_Face, P: Handle_Poly_PolygonOnTriangulation): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepTools_Modification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTools_Modification): void;
  get(): BRepTools_Modification;
  delete(): void;
}

  export declare class Handle_BRepTools_Modification_1 extends Handle_BRepTools_Modification {
    constructor();
  }

  export declare class Handle_BRepTools_Modification_2 extends Handle_BRepTools_Modification {
    constructor(thePtr: BRepTools_Modification);
  }

  export declare class Handle_BRepTools_Modification_3 extends Handle_BRepTools_Modification {
    constructor(theHandle: Handle_BRepTools_Modification);
  }

  export declare class Handle_BRepTools_Modification_4 extends Handle_BRepTools_Modification {
    constructor(theHandle: Handle_BRepTools_Modification);
  }

export declare class BRepTools {
  constructor();
  static UVBounds_1(F: TopoDS_Face, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose): void;
  static UVBounds_2(F: TopoDS_Face, W: TopoDS_Wire, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose): void;
  static UVBounds_3(F: TopoDS_Face, E: TopoDS_Edge, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose): void;
  static AddUVBounds_1(F: TopoDS_Face, B: Bnd_Box2d): void;
  static AddUVBounds_2(F: TopoDS_Face, W: TopoDS_Wire, B: Bnd_Box2d): void;
  static AddUVBounds_3(F: TopoDS_Face, E: TopoDS_Edge, B: Bnd_Box2d): void;
  static Update_1(V: TopoDS_Vertex): void;
  static Update_2(E: TopoDS_Edge): void;
  static Update_3(W: TopoDS_Wire): void;
  static Update_4(F: TopoDS_Face): void;
  static Update_5(S: TopoDS_Shell): void;
  static Update_6(S: TopoDS_Solid): void;
  static Update_7(C: TopoDS_CompSolid): void;
  static Update_8(C: TopoDS_Compound): void;
  static Update_9(S: TopoDS_Shape): void;
  static UpdateFaceUVPoints(theF: TopoDS_Face): void;
  static Clean(S: TopoDS_Shape): void;
  static CleanGeometry(theShape: TopoDS_Shape): void;
  static RemoveUnusedPCurves(S: TopoDS_Shape): void;
  static Triangulation(theShape: TopoDS_Shape, theLinDefl: Quantity_AbsorbedDose, theToCheckFreeEdges: Standard_Boolean): Standard_Boolean;
  static Compare_1(V1: TopoDS_Vertex, V2: TopoDS_Vertex): Standard_Boolean;
  static Compare_2(E1: TopoDS_Edge, E2: TopoDS_Edge): Standard_Boolean;
  static OuterWire(F: TopoDS_Face): TopoDS_Wire;
  static Map3DEdges(S: TopoDS_Shape, M: TopTools_IndexedMapOfShape): void;
  static IsReallyClosed(E: TopoDS_Edge, F: TopoDS_Face): Standard_Boolean;
  static DetectClosedness(theFace: TopoDS_Face, theUclosed: Standard_Boolean, theVclosed: Standard_Boolean): void;
  static Dump(Sh: TopoDS_Shape, S: Standard_OStream): void;
  static Write_1(Sh: TopoDS_Shape, S: Standard_OStream, theProgress: Message_ProgressRange): void;
  static Read_1(Sh: TopoDS_Shape, S: Standard_IStream, B: BRep_Builder, theProgress: Message_ProgressRange): void;
  static Write_2(Sh: TopoDS_Shape, File: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  static Read_2(Sh: TopoDS_Shape, File: Standard_CString, B: BRep_Builder, theProgress: Message_ProgressRange): Standard_Boolean;
  static EvalAndUpdateTol(theE: TopoDS_Edge, theC3d: Handle_Geom_Curve, theC2d: Handle_Geom2d_Curve, theS: Handle_Geom_Surface, theF: Quantity_AbsorbedDose, theL: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static OriEdgeInFace(theEdge: TopoDS_Edge, theFace: TopoDS_Face): TopAbs_Orientation;
  static RemoveInternals(theS: TopoDS_Shape, theForce: Standard_Boolean): void;
  delete(): void;
}

export declare class BRepTools_WireExplorer {
  Init_1(W: TopoDS_Wire): void;
  Init_2(W: TopoDS_Wire, F: TopoDS_Face): void;
  Init_3(W: TopoDS_Wire, F: TopoDS_Face, UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose): void;
  More(): Standard_Boolean;
  Next(): void;
  Current(): TopoDS_Edge;
  Orientation(): TopAbs_Orientation;
  CurrentVertex(): TopoDS_Vertex;
  Clear(): void;
  delete(): void;
}

  export declare class BRepTools_WireExplorer_1 extends BRepTools_WireExplorer {
    constructor();
  }

  export declare class BRepTools_WireExplorer_2 extends BRepTools_WireExplorer {
    constructor(W: TopoDS_Wire);
  }

  export declare class BRepTools_WireExplorer_3 extends BRepTools_WireExplorer {
    constructor(W: TopoDS_Wire, F: TopoDS_Face);
  }

export declare class Handle_BRepTools_History {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTools_History): void;
  get(): BRepTools_History;
  delete(): void;
}

  export declare class Handle_BRepTools_History_1 extends Handle_BRepTools_History {
    constructor();
  }

  export declare class Handle_BRepTools_History_2 extends Handle_BRepTools_History {
    constructor(thePtr: BRepTools_History);
  }

  export declare class Handle_BRepTools_History_3 extends Handle_BRepTools_History {
    constructor(theHandle: Handle_BRepTools_History);
  }

  export declare class Handle_BRepTools_History_4 extends Handle_BRepTools_History {
    constructor(theHandle: Handle_BRepTools_History);
  }

export declare class BRepTools_History extends Standard_Transient {
  constructor()
  static IsSupportedType(theShape: TopoDS_Shape): Standard_Boolean;
  AddGenerated(theInitial: TopoDS_Shape, theGenerated: TopoDS_Shape): void;
  AddModified(theInitial: TopoDS_Shape, theModified: TopoDS_Shape): void;
  Remove(theRemoved: TopoDS_Shape): void;
  ReplaceGenerated(theInitial: TopoDS_Shape, theGenerated: TopoDS_Shape): void;
  ReplaceModified(theInitial: TopoDS_Shape, theModified: TopoDS_Shape): void;
  Clear(): void;
  Generated(theInitial: TopoDS_Shape): TopTools_ListOfShape;
  Modified(theInitial: TopoDS_Shape): TopTools_ListOfShape;
  IsRemoved(theInitial: TopoDS_Shape): Standard_Boolean;
  HasGenerated(): Standard_Boolean;
  HasModified(): Standard_Boolean;
  HasRemoved(): Standard_Boolean;
  Merge_1(theHistory23: Handle_BRepTools_History): void;
  Merge_2(theHistory23: BRepTools_History): void;
  Dump(theS: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepTools_Quilt {
  constructor()
  Bind_1(Eold: TopoDS_Edge, Enew: TopoDS_Edge): void;
  Bind_2(Vold: TopoDS_Vertex, Vnew: TopoDS_Vertex): void;
  Add(S: TopoDS_Shape): void;
  IsCopied(S: TopoDS_Shape): Standard_Boolean;
  Copy(S: TopoDS_Shape): TopoDS_Shape;
  Shells(): TopoDS_Shape;
  delete(): void;
}

export declare class BRepTools_Substitution {
  constructor()
  Clear(): void;
  Substitute(OldShape: TopoDS_Shape, NewShapes: TopTools_ListOfShape): void;
  Build(S: TopoDS_Shape): void;
  IsCopied(S: TopoDS_Shape): Standard_Boolean;
  Copy(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

export declare class BRepTools_Modifier {
  Init(S: TopoDS_Shape): void;
  Perform(M: Handle_BRepTools_Modification, theProgress: Message_ProgressRange): void;
  IsDone(): Standard_Boolean;
  IsMutableInput(): Standard_Boolean;
  SetMutableInput(theMutableInput: Standard_Boolean): void;
  ModifiedShape(S: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepTools_Modifier_1 extends BRepTools_Modifier {
    constructor(theMutableInput: Standard_Boolean);
  }

  export declare class BRepTools_Modifier_2 extends BRepTools_Modifier {
    constructor(S: TopoDS_Shape);
  }

  export declare class BRepTools_Modifier_3 extends BRepTools_Modifier {
    constructor(S: TopoDS_Shape, M: Handle_BRepTools_Modification);
  }

export declare class BRepTools_NurbsConvertModification extends BRepTools_Modification {
  constructor()
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  GetUpdatedEdges(): TopTools_ListOfShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepTools_NurbsConvertModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTools_NurbsConvertModification): void;
  get(): BRepTools_NurbsConvertModification;
  delete(): void;
}

  export declare class Handle_BRepTools_NurbsConvertModification_1 extends Handle_BRepTools_NurbsConvertModification {
    constructor();
  }

  export declare class Handle_BRepTools_NurbsConvertModification_2 extends Handle_BRepTools_NurbsConvertModification {
    constructor(thePtr: BRepTools_NurbsConvertModification);
  }

  export declare class Handle_BRepTools_NurbsConvertModification_3 extends Handle_BRepTools_NurbsConvertModification {
    constructor(theHandle: Handle_BRepTools_NurbsConvertModification);
  }

  export declare class Handle_BRepTools_NurbsConvertModification_4 extends Handle_BRepTools_NurbsConvertModification {
    constructor(theHandle: Handle_BRepTools_NurbsConvertModification);
  }

export declare class Handle_Geom_BezierCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_BezierCurve): void;
  get(): Geom_BezierCurve;
  delete(): void;
}

  export declare class Handle_Geom_BezierCurve_1 extends Handle_Geom_BezierCurve {
    constructor();
  }

  export declare class Handle_Geom_BezierCurve_2 extends Handle_Geom_BezierCurve {
    constructor(thePtr: Geom_BezierCurve);
  }

  export declare class Handle_Geom_BezierCurve_3 extends Handle_Geom_BezierCurve {
    constructor(theHandle: Handle_Geom_BezierCurve);
  }

  export declare class Handle_Geom_BezierCurve_4 extends Handle_Geom_BezierCurve {
    constructor(theHandle: Handle_Geom_BezierCurve);
  }

export declare class Geom_BezierCurve extends Geom_BoundedCurve {
  Increase(Degree: Graphic3d_ZLayerId): void;
  InsertPoleAfter_1(Index: Graphic3d_ZLayerId, P: gp_Pnt): void;
  InsertPoleAfter_2(Index: Graphic3d_ZLayerId, P: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  InsertPoleBefore_1(Index: Graphic3d_ZLayerId, P: gp_Pnt): void;
  InsertPoleBefore_2(Index: Graphic3d_ZLayerId, P: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  RemovePole(Index: Graphic3d_ZLayerId): void;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  SetPole_1(Index: Graphic3d_ZLayerId, P: gp_Pnt): void;
  SetPole_2(Index: Graphic3d_ZLayerId, P: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  SetWeight(Index: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  IsClosed(): Standard_Boolean;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  IsRational(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Degree(): Graphic3d_ZLayerId;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  StartPoint(): gp_Pnt;
  EndPoint(): gp_Pnt;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  NbPoles(): Graphic3d_ZLayerId;
  Pole(Index: Graphic3d_ZLayerId): gp_Pnt;
  Poles_1(P: TColgp_Array1OfPnt): void;
  Poles_2(): TColgp_Array1OfPnt;
  Weight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights_1(W: TColStd_Array1OfReal): void;
  Weights_2(): TColStd_Array1OfReal;
  Transform(T: gp_Trsf): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  Resolution(Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_BezierCurve_1 extends Geom_BezierCurve {
    constructor(CurvePoles: TColgp_Array1OfPnt);
  }

  export declare class Geom_BezierCurve_2 extends Geom_BezierCurve {
    constructor(CurvePoles: TColgp_Array1OfPnt, PoleWeights: TColStd_Array1OfReal);
  }

export declare class Geom_BoundedSurface extends Geom_Surface {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_BoundedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_BoundedSurface): void;
  get(): Geom_BoundedSurface;
  delete(): void;
}

  export declare class Handle_Geom_BoundedSurface_1 extends Handle_Geom_BoundedSurface {
    constructor();
  }

  export declare class Handle_Geom_BoundedSurface_2 extends Handle_Geom_BoundedSurface {
    constructor(thePtr: Geom_BoundedSurface);
  }

  export declare class Handle_Geom_BoundedSurface_3 extends Handle_Geom_BoundedSurface {
    constructor(theHandle: Handle_Geom_BoundedSurface);
  }

  export declare class Handle_Geom_BoundedSurface_4 extends Handle_Geom_BoundedSurface {
    constructor(theHandle: Handle_Geom_BoundedSurface);
  }

export declare class Geom_SweptSurface extends Geom_Surface {
  Continuity(): GeomAbs_Shape;
  Direction(): gp_Dir;
  BasisCurve(): Handle_Geom_Curve;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_SweptSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_SweptSurface): void;
  get(): Geom_SweptSurface;
  delete(): void;
}

  export declare class Handle_Geom_SweptSurface_1 extends Handle_Geom_SweptSurface {
    constructor();
  }

  export declare class Handle_Geom_SweptSurface_2 extends Handle_Geom_SweptSurface {
    constructor(thePtr: Geom_SweptSurface);
  }

  export declare class Handle_Geom_SweptSurface_3 extends Handle_Geom_SweptSurface {
    constructor(theHandle: Handle_Geom_SweptSurface);
  }

  export declare class Handle_Geom_SweptSurface_4 extends Handle_Geom_SweptSurface {
    constructor(theHandle: Handle_Geom_SweptSurface);
  }

export declare class Handle_Geom_Plane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Plane): void;
  get(): Geom_Plane;
  delete(): void;
}

  export declare class Handle_Geom_Plane_1 extends Handle_Geom_Plane {
    constructor();
  }

  export declare class Handle_Geom_Plane_2 extends Handle_Geom_Plane {
    constructor(thePtr: Geom_Plane);
  }

  export declare class Handle_Geom_Plane_3 extends Handle_Geom_Plane {
    constructor(theHandle: Handle_Geom_Plane);
  }

  export declare class Handle_Geom_Plane_4 extends Handle_Geom_Plane {
    constructor(theHandle: Handle_Geom_Plane);
  }

export declare class Geom_Plane extends Geom_ElementarySurface {
  SetPln(Pl: gp_Pln): void;
  Pln(): gp_Pln;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Coefficients(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Plane_1 extends Geom_Plane {
    constructor(A3: gp_Ax3);
  }

  export declare class Geom_Plane_2 extends Geom_Plane {
    constructor(Pl: gp_Pln);
  }

  export declare class Geom_Plane_3 extends Geom_Plane {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

  export declare class Geom_Plane_4 extends Geom_Plane {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom_Geometry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Geometry): void;
  get(): Geom_Geometry;
  delete(): void;
}

  export declare class Handle_Geom_Geometry_1 extends Handle_Geom_Geometry {
    constructor();
  }

  export declare class Handle_Geom_Geometry_2 extends Handle_Geom_Geometry {
    constructor(thePtr: Geom_Geometry);
  }

  export declare class Handle_Geom_Geometry_3 extends Handle_Geom_Geometry {
    constructor(theHandle: Handle_Geom_Geometry);
  }

  export declare class Handle_Geom_Geometry_4 extends Handle_Geom_Geometry {
    constructor(theHandle: Handle_Geom_Geometry);
  }

export declare class Geom_Geometry extends Standard_Transient {
  Mirror_1(P: gp_Pnt): void;
  Mirror_2(A1: gp_Ax1): void;
  Mirror_3(A2: gp_Ax2): void;
  Rotate(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): void;
  Scale(P: gp_Pnt, S: Quantity_AbsorbedDose): void;
  Translate_1(V: gp_Vec): void;
  Translate_2(P1: gp_Pnt, P2: gp_Pnt): void;
  Transform(T: gp_Trsf): void;
  Mirrored_1(P: gp_Pnt): Handle_Geom_Geometry;
  Mirrored_2(A1: gp_Ax1): Handle_Geom_Geometry;
  Mirrored_3(A2: gp_Ax2): Handle_Geom_Geometry;
  Rotated(A1: gp_Ax1, Ang: Quantity_AbsorbedDose): Handle_Geom_Geometry;
  Scaled(P: gp_Pnt, S: Quantity_AbsorbedDose): Handle_Geom_Geometry;
  Transformed(T: gp_Trsf): Handle_Geom_Geometry;
  Translated_1(V: gp_Vec): Handle_Geom_Geometry;
  Translated_2(P1: gp_Pnt, P2: gp_Pnt): Handle_Geom_Geometry;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_BSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_BSplineSurface): void;
  get(): Geom_BSplineSurface;
  delete(): void;
}

  export declare class Handle_Geom_BSplineSurface_1 extends Handle_Geom_BSplineSurface {
    constructor();
  }

  export declare class Handle_Geom_BSplineSurface_2 extends Handle_Geom_BSplineSurface {
    constructor(thePtr: Geom_BSplineSurface);
  }

  export declare class Handle_Geom_BSplineSurface_3 extends Handle_Geom_BSplineSurface {
    constructor(theHandle: Handle_Geom_BSplineSurface);
  }

  export declare class Handle_Geom_BSplineSurface_4 extends Handle_Geom_BSplineSurface {
    constructor(theHandle: Handle_Geom_BSplineSurface);
  }

export declare class Geom_BSplineSurface extends Geom_BoundedSurface {
  ExchangeUV(): void;
  SetUPeriodic(): void;
  SetVPeriodic(): void;
  PeriodicNormalization(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  SetUOrigin(Index: Graphic3d_ZLayerId): void;
  SetVOrigin(Index: Graphic3d_ZLayerId): void;
  SetUNotPeriodic(): void;
  SetVNotPeriodic(): void;
  UReverse(): void;
  VReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IncreaseDegree(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId): void;
  InsertUKnots(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  InsertVKnots(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  RemoveUKnot(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  RemoveVKnot(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  IncreaseUMultiplicity_1(UIndex: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncreaseUMultiplicity_2(FromI1: Graphic3d_ZLayerId, ToI2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncrementUMultiplicity(FromI1: Graphic3d_ZLayerId, ToI2: Graphic3d_ZLayerId, Step: Graphic3d_ZLayerId): void;
  IncreaseVMultiplicity_1(VIndex: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncreaseVMultiplicity_2(FromI1: Graphic3d_ZLayerId, ToI2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncrementVMultiplicity(FromI1: Graphic3d_ZLayerId, ToI2: Graphic3d_ZLayerId, Step: Graphic3d_ZLayerId): void;
  InsertUKnot(U: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  InsertVKnot(V: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, theUTolerance: Quantity_AbsorbedDose, theVTolerance: Quantity_AbsorbedDose): void;
  CheckAndSegment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, theUTolerance: Quantity_AbsorbedDose, theVTolerance: Quantity_AbsorbedDose): void;
  SetUKnot_1(UIndex: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose): void;
  SetUKnots(UK: TColStd_Array1OfReal): void;
  SetUKnot_2(UIndex: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId): void;
  SetVKnot_1(VIndex: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose): void;
  SetVKnots(VK: TColStd_Array1OfReal): void;
  SetVKnot_2(VIndex: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId): void;
  LocateU(U: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, WithKnotRepetition: Standard_Boolean): void;
  LocateV(V: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, WithKnotRepetition: Standard_Boolean): void;
  SetPole_1(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, P: gp_Pnt): void;
  SetPole_2(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, P: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  SetPoleCol_1(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  SetPoleCol_2(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  SetPoleRow_1(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  SetPoleRow_2(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  SetWeight(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  SetWeightCol(VIndex: Graphic3d_ZLayerId, CPoleWeights: TColStd_Array1OfReal): void;
  SetWeightRow(UIndex: Graphic3d_ZLayerId, CPoleWeights: TColStd_Array1OfReal): void;
  MovePoint(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, UIndex1: Graphic3d_ZLayerId, UIndex2: Graphic3d_ZLayerId, VIndex1: Graphic3d_ZLayerId, VIndex2: Graphic3d_ZLayerId, UFirstIndex: Graphic3d_ZLayerId, ULastIndex: Graphic3d_ZLayerId, VFirstIndex: Graphic3d_ZLayerId, VLastIndex: Graphic3d_ZLayerId): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsURational(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Continuity(): GeomAbs_Shape;
  FirstUKnotIndex(): Graphic3d_ZLayerId;
  FirstVKnotIndex(): Graphic3d_ZLayerId;
  LastUKnotIndex(): Graphic3d_ZLayerId;
  LastVKnotIndex(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  Pole(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): gp_Pnt;
  Poles_1(P: TColgp_Array2OfPnt): void;
  Poles_2(): TColgp_Array2OfPnt;
  UDegree(): Graphic3d_ZLayerId;
  UKnot(UIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  UKnotDistribution(): GeomAbs_BSplKnotDistribution;
  UKnots_1(Ku: TColStd_Array1OfReal): void;
  UKnots_2(): TColStd_Array1OfReal;
  UKnotSequence_1(Ku: TColStd_Array1OfReal): void;
  UKnotSequence_2(): TColStd_Array1OfReal;
  UMultiplicity(UIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  UMultiplicities_1(Mu: TColStd_Array1OfInteger): void;
  UMultiplicities_2(): TColStd_Array1OfInteger;
  VDegree(): Graphic3d_ZLayerId;
  VKnot(VIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  VKnotDistribution(): GeomAbs_BSplKnotDistribution;
  VKnots_1(Kv: TColStd_Array1OfReal): void;
  VKnots_2(): TColStd_Array1OfReal;
  VKnotSequence_1(Kv: TColStd_Array1OfReal): void;
  VKnotSequence_2(): TColStd_Array1OfReal;
  VMultiplicity(VIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  VMultiplicities_1(Mv: TColStd_Array1OfInteger): void;
  VMultiplicities_2(): TColStd_Array1OfInteger;
  Weight(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights_1(W: TColStd_Array2OfReal): void;
  Weights_2(): TColStd_Array2OfReal;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  LocalD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId, P: gp_Pnt): void;
  LocalD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  LocalD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  LocalD3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  LocalDN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  LocalValue(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, FromUK1: Graphic3d_ZLayerId, ToUK2: Graphic3d_ZLayerId, FromVK1: Graphic3d_ZLayerId, ToVK2: Graphic3d_ZLayerId): gp_Pnt;
  UIso_1(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso_1(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  UIso_2(U: Quantity_AbsorbedDose, CheckRational: Standard_Boolean): Handle_Geom_Curve;
  VIso_2(V: Quantity_AbsorbedDose, CheckRational: Standard_Boolean): Handle_Geom_Curve;
  Transform(T: gp_Trsf): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  Resolution(Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose, VTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_BSplineSurface_1 extends Geom_BSplineSurface {
    constructor(Poles: TColgp_Array2OfPnt, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UPeriodic: Standard_Boolean, VPeriodic: Standard_Boolean);
  }

  export declare class Geom_BSplineSurface_2 extends Geom_BSplineSurface {
    constructor(Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UPeriodic: Standard_Boolean, VPeriodic: Standard_Boolean);
  }

export declare class Handle_Geom_UndefinedValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_UndefinedValue): void;
  get(): Geom_UndefinedValue;
  delete(): void;
}

  export declare class Handle_Geom_UndefinedValue_1 extends Handle_Geom_UndefinedValue {
    constructor();
  }

  export declare class Handle_Geom_UndefinedValue_2 extends Handle_Geom_UndefinedValue {
    constructor(thePtr: Geom_UndefinedValue);
  }

  export declare class Handle_Geom_UndefinedValue_3 extends Handle_Geom_UndefinedValue {
    constructor(theHandle: Handle_Geom_UndefinedValue);
  }

  export declare class Handle_Geom_UndefinedValue_4 extends Handle_Geom_UndefinedValue {
    constructor(theHandle: Handle_Geom_UndefinedValue);
  }

export declare class Geom_UndefinedValue extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Geom_UndefinedValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_UndefinedValue_1 extends Geom_UndefinedValue {
    constructor();
  }

  export declare class Geom_UndefinedValue_2 extends Geom_UndefinedValue {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Geom_AxisPlacement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_AxisPlacement): void;
  get(): Geom_AxisPlacement;
  delete(): void;
}

  export declare class Handle_Geom_AxisPlacement_1 extends Handle_Geom_AxisPlacement {
    constructor();
  }

  export declare class Handle_Geom_AxisPlacement_2 extends Handle_Geom_AxisPlacement {
    constructor(thePtr: Geom_AxisPlacement);
  }

  export declare class Handle_Geom_AxisPlacement_3 extends Handle_Geom_AxisPlacement {
    constructor(theHandle: Handle_Geom_AxisPlacement);
  }

  export declare class Handle_Geom_AxisPlacement_4 extends Handle_Geom_AxisPlacement {
    constructor(theHandle: Handle_Geom_AxisPlacement);
  }

export declare class Geom_AxisPlacement extends Geom_Geometry {
  SetAxis(A1: gp_Ax1): void;
  SetDirection(V: gp_Dir): void;
  SetLocation(P: gp_Pnt): void;
  Angle(Other: Handle_Geom_AxisPlacement): Quantity_AbsorbedDose;
  Axis(): gp_Ax1;
  Direction(): gp_Dir;
  Location(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_BSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_BSplineCurve): void;
  get(): Geom_BSplineCurve;
  delete(): void;
}

  export declare class Handle_Geom_BSplineCurve_1 extends Handle_Geom_BSplineCurve {
    constructor();
  }

  export declare class Handle_Geom_BSplineCurve_2 extends Handle_Geom_BSplineCurve {
    constructor(thePtr: Geom_BSplineCurve);
  }

  export declare class Handle_Geom_BSplineCurve_3 extends Handle_Geom_BSplineCurve {
    constructor(theHandle: Handle_Geom_BSplineCurve);
  }

  export declare class Handle_Geom_BSplineCurve_4 extends Handle_Geom_BSplineCurve {
    constructor(theHandle: Handle_Geom_BSplineCurve);
  }

export declare class Geom_BSplineCurve extends Geom_BoundedCurve {
  IncreaseDegree(Degree: Graphic3d_ZLayerId): void;
  IncreaseMultiplicity_1(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncreaseMultiplicity_2(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncrementMultiplicity(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  InsertKnot(U: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  InsertKnots(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  RemoveKnot(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, theTolerance: Quantity_AbsorbedDose): void;
  SetKnot_1(Index: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose): void;
  SetKnots(K: TColStd_Array1OfReal): void;
  SetKnot_2(Index: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId): void;
  PeriodicNormalization(U: Quantity_AbsorbedDose): void;
  SetPeriodic(): void;
  SetOrigin_1(Index: Graphic3d_ZLayerId): void;
  SetOrigin_2(U: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  SetNotPeriodic(): void;
  SetPole_1(Index: Graphic3d_ZLayerId, P: gp_Pnt): void;
  SetPole_2(Index: Graphic3d_ZLayerId, P: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  SetWeight(Index: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  MovePoint(U: Quantity_AbsorbedDose, P: gp_Pnt, Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId, FirstModifiedPole: Graphic3d_ZLayerId, LastModifiedPole: Graphic3d_ZLayerId): void;
  MovePointAndTangent(U: Quantity_AbsorbedDose, P: gp_Pnt, Tangent: gp_Vec, Tolerance: Quantity_AbsorbedDose, StartingCondition: Graphic3d_ZLayerId, EndingCondition: Graphic3d_ZLayerId, ErrorStatus: Graphic3d_ZLayerId): void;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsG1(theTf: Quantity_AbsorbedDose, theTl: Quantity_AbsorbedDose, theAngTol: Quantity_AbsorbedDose): Standard_Boolean;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  IsRational(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Degree(): Graphic3d_ZLayerId;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  LocalValue(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId): gp_Pnt;
  LocalD0(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt): void;
  LocalD1(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt, V1: gp_Vec): void;
  LocalD2(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  LocalD3(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  LocalDN(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, N: Graphic3d_ZLayerId): gp_Vec;
  EndPoint(): gp_Pnt;
  FirstUKnotIndex(): Graphic3d_ZLayerId;
  FirstParameter(): Quantity_AbsorbedDose;
  Knot(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Knots_1(K: TColStd_Array1OfReal): void;
  Knots_2(): TColStd_Array1OfReal;
  KnotSequence_1(K: TColStd_Array1OfReal): void;
  KnotSequence_2(): TColStd_Array1OfReal;
  KnotDistribution(): GeomAbs_BSplKnotDistribution;
  LastUKnotIndex(): Graphic3d_ZLayerId;
  LastParameter(): Quantity_AbsorbedDose;
  LocateU(U: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, WithKnotRepetition: Standard_Boolean): void;
  Multiplicity(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Multiplicities_1(M: TColStd_Array1OfInteger): void;
  Multiplicities_2(): TColStd_Array1OfInteger;
  NbKnots(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Pole(Index: Graphic3d_ZLayerId): gp_Pnt;
  Poles_1(P: TColgp_Array1OfPnt): void;
  Poles_2(): TColgp_Array1OfPnt;
  StartPoint(): gp_Pnt;
  Weight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights_1(W: TColStd_Array1OfReal): void;
  Weights_2(): TColStd_Array1OfReal;
  Transform(T: gp_Trsf): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  Resolution(Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom_Geometry;
  IsEqual(theOther: Handle_Geom_BSplineCurve, thePreci: Quantity_AbsorbedDose): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_BSplineCurve_1 extends Geom_BSplineCurve {
    constructor(Poles: TColgp_Array1OfPnt, Knots: TColStd_Array1OfReal, Multiplicities: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean);
  }

  export declare class Geom_BSplineCurve_2 extends Geom_BSplineCurve {
    constructor(Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Multiplicities: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, CheckRational: Standard_Boolean);
  }

export declare class Handle_Geom_TrimmedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_TrimmedCurve): void;
  get(): Geom_TrimmedCurve;
  delete(): void;
}

  export declare class Handle_Geom_TrimmedCurve_1 extends Handle_Geom_TrimmedCurve {
    constructor();
  }

  export declare class Handle_Geom_TrimmedCurve_2 extends Handle_Geom_TrimmedCurve {
    constructor(thePtr: Geom_TrimmedCurve);
  }

  export declare class Handle_Geom_TrimmedCurve_3 extends Handle_Geom_TrimmedCurve {
    constructor(theHandle: Handle_Geom_TrimmedCurve);
  }

  export declare class Handle_Geom_TrimmedCurve_4 extends Handle_Geom_TrimmedCurve {
    constructor(theHandle: Handle_Geom_TrimmedCurve);
  }

export declare class Geom_TrimmedCurve extends Geom_BoundedCurve {
  constructor(C: Handle_Geom_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Sense: Standard_Boolean, theAdjustPeriodic: Standard_Boolean)
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  SetTrim(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Sense: Standard_Boolean, theAdjustPeriodic: Standard_Boolean): void;
  BasisCurve(): Handle_Geom_Curve;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  EndPoint(): gp_Pnt;
  FirstParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  StartPoint(): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf): Quantity_AbsorbedDose;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_Direction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Direction): void;
  get(): Geom_Direction;
  delete(): void;
}

  export declare class Handle_Geom_Direction_1 extends Handle_Geom_Direction {
    constructor();
  }

  export declare class Handle_Geom_Direction_2 extends Handle_Geom_Direction {
    constructor(thePtr: Geom_Direction);
  }

  export declare class Handle_Geom_Direction_3 extends Handle_Geom_Direction {
    constructor(theHandle: Handle_Geom_Direction);
  }

  export declare class Handle_Geom_Direction_4 extends Handle_Geom_Direction {
    constructor(theHandle: Handle_Geom_Direction);
  }

export declare class Geom_Direction extends Geom_Vector {
  SetCoord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetDir(V: gp_Dir): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  Dir(): gp_Dir;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  Cross(Other: Handle_Geom_Vector): void;
  CrossCross(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): void;
  Crossed(Other: Handle_Geom_Vector): Handle_Geom_Vector;
  CrossCrossed(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): Handle_Geom_Vector;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Direction_1 extends Geom_Direction {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose);
  }

  export declare class Geom_Direction_2 extends Geom_Direction {
    constructor(V: gp_Dir);
  }

export declare class Geom_ConicalSurface extends Geom_ElementarySurface {
  SetCone(C: gp_Cone): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  SetSemiAngle(Ang: Quantity_AbsorbedDose): void;
  Cone(): gp_Cone;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Apex(): gp_Pnt;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Coefficients(A1: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, B1: Quantity_AbsorbedDose, B2: Quantity_AbsorbedDose, B3: Quantity_AbsorbedDose, C1: Quantity_AbsorbedDose, C2: Quantity_AbsorbedDose, C3: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  RefRadius(): Quantity_AbsorbedDose;
  SemiAngle(): Quantity_AbsorbedDose;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_ConicalSurface_1 extends Geom_ConicalSurface {
    constructor(A3: gp_Ax3, Ang: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose);
  }

  export declare class Geom_ConicalSurface_2 extends Geom_ConicalSurface {
    constructor(C: gp_Cone);
  }

export declare class Handle_Geom_ConicalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_ConicalSurface): void;
  get(): Geom_ConicalSurface;
  delete(): void;
}

  export declare class Handle_Geom_ConicalSurface_1 extends Handle_Geom_ConicalSurface {
    constructor();
  }

  export declare class Handle_Geom_ConicalSurface_2 extends Handle_Geom_ConicalSurface {
    constructor(thePtr: Geom_ConicalSurface);
  }

  export declare class Handle_Geom_ConicalSurface_3 extends Handle_Geom_ConicalSurface {
    constructor(theHandle: Handle_Geom_ConicalSurface);
  }

  export declare class Handle_Geom_ConicalSurface_4 extends Handle_Geom_ConicalSurface {
    constructor(theHandle: Handle_Geom_ConicalSurface);
  }

export declare class Handle_Geom_SurfaceOfLinearExtrusion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_SurfaceOfLinearExtrusion): void;
  get(): Geom_SurfaceOfLinearExtrusion;
  delete(): void;
}

  export declare class Handle_Geom_SurfaceOfLinearExtrusion_1 extends Handle_Geom_SurfaceOfLinearExtrusion {
    constructor();
  }

  export declare class Handle_Geom_SurfaceOfLinearExtrusion_2 extends Handle_Geom_SurfaceOfLinearExtrusion {
    constructor(thePtr: Geom_SurfaceOfLinearExtrusion);
  }

  export declare class Handle_Geom_SurfaceOfLinearExtrusion_3 extends Handle_Geom_SurfaceOfLinearExtrusion {
    constructor(theHandle: Handle_Geom_SurfaceOfLinearExtrusion);
  }

  export declare class Handle_Geom_SurfaceOfLinearExtrusion_4 extends Handle_Geom_SurfaceOfLinearExtrusion {
    constructor(theHandle: Handle_Geom_SurfaceOfLinearExtrusion);
  }

export declare class Geom_SurfaceOfLinearExtrusion extends Geom_SweptSurface {
  constructor(C: Handle_Geom_Curve, V: gp_Dir)
  SetDirection(V: gp_Dir): void;
  SetBasisCurve(C: Handle_Geom_Curve): void;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_Conic {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Conic): void;
  get(): Geom_Conic;
  delete(): void;
}

  export declare class Handle_Geom_Conic_1 extends Handle_Geom_Conic {
    constructor();
  }

  export declare class Handle_Geom_Conic_2 extends Handle_Geom_Conic {
    constructor(thePtr: Geom_Conic);
  }

  export declare class Handle_Geom_Conic_3 extends Handle_Geom_Conic {
    constructor(theHandle: Handle_Geom_Conic);
  }

  export declare class Handle_Geom_Conic_4 extends Handle_Geom_Conic {
    constructor(theHandle: Handle_Geom_Conic);
  }

export declare class Geom_Conic extends Geom_Curve {
  SetAxis(theA1: gp_Ax1): void;
  SetLocation(theP: gp_Pnt): void;
  SetPosition(theA2: gp_Ax2): void;
  Axis(): gp_Ax1;
  Location(): gp_Pnt;
  Position(): gp_Ax2;
  Eccentricity(): Quantity_AbsorbedDose;
  XAxis(): gp_Ax1;
  YAxis(): gp_Ax1;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Geom_OffsetCurve extends Geom_Curve {
  constructor(C: Handle_Geom_Curve, Offset: Quantity_AbsorbedDose, V: gp_Dir, isNotCheckC0: Standard_Boolean)
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  SetBasisCurve(C: Handle_Geom_Curve, isNotCheckC0: Standard_Boolean): void;
  SetDirection(V: gp_Dir): void;
  SetOffsetValue(D: Quantity_AbsorbedDose): void;
  BasisCurve(): Handle_Geom_Curve;
  Continuity(): GeomAbs_Shape;
  Direction(): gp_Dir;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Offset(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Transform(T: gp_Trsf): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf): Quantity_AbsorbedDose;
  Copy(): Handle_Geom_Geometry;
  GetBasisCurveContinuity(): GeomAbs_Shape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_OffsetCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_OffsetCurve): void;
  get(): Geom_OffsetCurve;
  delete(): void;
}

  export declare class Handle_Geom_OffsetCurve_1 extends Handle_Geom_OffsetCurve {
    constructor();
  }

  export declare class Handle_Geom_OffsetCurve_2 extends Handle_Geom_OffsetCurve {
    constructor(thePtr: Geom_OffsetCurve);
  }

  export declare class Handle_Geom_OffsetCurve_3 extends Handle_Geom_OffsetCurve {
    constructor(theHandle: Handle_Geom_OffsetCurve);
  }

  export declare class Handle_Geom_OffsetCurve_4 extends Handle_Geom_OffsetCurve {
    constructor(theHandle: Handle_Geom_OffsetCurve);
  }

export declare class Handle_Geom_VectorWithMagnitude {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_VectorWithMagnitude): void;
  get(): Geom_VectorWithMagnitude;
  delete(): void;
}

  export declare class Handle_Geom_VectorWithMagnitude_1 extends Handle_Geom_VectorWithMagnitude {
    constructor();
  }

  export declare class Handle_Geom_VectorWithMagnitude_2 extends Handle_Geom_VectorWithMagnitude {
    constructor(thePtr: Geom_VectorWithMagnitude);
  }

  export declare class Handle_Geom_VectorWithMagnitude_3 extends Handle_Geom_VectorWithMagnitude {
    constructor(theHandle: Handle_Geom_VectorWithMagnitude);
  }

  export declare class Handle_Geom_VectorWithMagnitude_4 extends Handle_Geom_VectorWithMagnitude {
    constructor(theHandle: Handle_Geom_VectorWithMagnitude);
  }

export declare class Geom_VectorWithMagnitude extends Geom_Vector {
  SetCoord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetVec(V: gp_Vec): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  Add(Other: Handle_Geom_Vector): void;
  Added(Other: Handle_Geom_Vector): Handle_Geom_VectorWithMagnitude;
  Cross(Other: Handle_Geom_Vector): void;
  Crossed(Other: Handle_Geom_Vector): Handle_Geom_Vector;
  CrossCross(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): void;
  CrossCrossed(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): Handle_Geom_Vector;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): Handle_Geom_VectorWithMagnitude;
  Multiplied(Scalar: Quantity_AbsorbedDose): Handle_Geom_VectorWithMagnitude;
  Multiply(Scalar: Quantity_AbsorbedDose): void;
  Normalize(): void;
  Normalized(): Handle_Geom_VectorWithMagnitude;
  Subtract(Other: Handle_Geom_Vector): void;
  Subtracted(Other: Handle_Geom_Vector): Handle_Geom_VectorWithMagnitude;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_VectorWithMagnitude_1 extends Geom_VectorWithMagnitude {
    constructor(V: gp_Vec);
  }

  export declare class Geom_VectorWithMagnitude_2 extends Geom_VectorWithMagnitude {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose);
  }

  export declare class Geom_VectorWithMagnitude_3 extends Geom_VectorWithMagnitude {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

export declare class Geom_Circle extends Geom_Conic {
  SetCirc(C: gp_Circ): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  Circ(): gp_Circ;
  Radius(): Quantity_AbsorbedDose;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Eccentricity(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Circle_1 extends Geom_Circle {
    constructor(C: gp_Circ);
  }

  export declare class Geom_Circle_2 extends Geom_Circle {
    constructor(A2: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom_Circle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Circle): void;
  get(): Geom_Circle;
  delete(): void;
}

  export declare class Handle_Geom_Circle_1 extends Handle_Geom_Circle {
    constructor();
  }

  export declare class Handle_Geom_Circle_2 extends Handle_Geom_Circle {
    constructor(thePtr: Geom_Circle);
  }

  export declare class Handle_Geom_Circle_3 extends Handle_Geom_Circle {
    constructor(theHandle: Handle_Geom_Circle);
  }

  export declare class Handle_Geom_Circle_4 extends Handle_Geom_Circle {
    constructor(theHandle: Handle_Geom_Circle);
  }

export declare class Handle_Geom_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Line): void;
  get(): Geom_Line;
  delete(): void;
}

  export declare class Handle_Geom_Line_1 extends Handle_Geom_Line {
    constructor();
  }

  export declare class Handle_Geom_Line_2 extends Handle_Geom_Line {
    constructor(thePtr: Geom_Line);
  }

  export declare class Handle_Geom_Line_3 extends Handle_Geom_Line {
    constructor(theHandle: Handle_Geom_Line);
  }

  export declare class Handle_Geom_Line_4 extends Handle_Geom_Line {
    constructor(theHandle: Handle_Geom_Line);
  }

export declare class Geom_Line extends Geom_Curve {
  SetLin(L: gp_Lin): void;
  SetDirection(V: gp_Dir): void;
  SetLocation(P: gp_Pnt): void;
  SetPosition(A1: gp_Ax1): void;
  Lin(): gp_Lin;
  Position(): gp_Ax1;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf): Quantity_AbsorbedDose;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Line_1 extends Geom_Line {
    constructor(A1: gp_Ax1);
  }

  export declare class Geom_Line_2 extends Geom_Line {
    constructor(L: gp_Lin);
  }

  export declare class Geom_Line_3 extends Geom_Line {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

export declare class Geom_Transformation extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetMirror_1(thePnt: gp_Pnt): void;
  SetMirror_2(theA1: gp_Ax1): void;
  SetMirror_3(theA2: gp_Ax2): void;
  SetRotation(theA1: gp_Ax1, theAng: Quantity_AbsorbedDose): void;
  SetScale(thePnt: gp_Pnt, theScale: Quantity_AbsorbedDose): void;
  SetTransformation_1(theFromSystem1: gp_Ax3, theToSystem2: gp_Ax3): void;
  SetTransformation_2(theToSystem: gp_Ax3): void;
  SetTranslation_1(theVec: gp_Vec): void;
  SetTranslation_2(P1: gp_Pnt, P2: gp_Pnt): void;
  SetTrsf(theTrsf: gp_Trsf): void;
  IsNegative(): Standard_Boolean;
  Form(): gp_TrsfForm;
  ScaleFactor(): Quantity_AbsorbedDose;
  Trsf(): gp_Trsf;
  Value(theRow: Graphic3d_ZLayerId, theCol: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Invert(): void;
  Inverted(): Handle_Geom_Transformation;
  Multiplied(Other: Handle_Geom_Transformation): Handle_Geom_Transformation;
  Multiply(theOther: Handle_Geom_Transformation): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): Handle_Geom_Transformation;
  PreMultiply(Other: Handle_Geom_Transformation): void;
  Transforms(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom_Transformation;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Geom_Transformation_1 extends Geom_Transformation {
    constructor();
  }

  export declare class Geom_Transformation_2 extends Geom_Transformation {
    constructor(T: gp_Trsf);
  }

export declare class Handle_Geom_Transformation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Transformation): void;
  get(): Geom_Transformation;
  delete(): void;
}

  export declare class Handle_Geom_Transformation_1 extends Handle_Geom_Transformation {
    constructor();
  }

  export declare class Handle_Geom_Transformation_2 extends Handle_Geom_Transformation {
    constructor(thePtr: Geom_Transformation);
  }

  export declare class Handle_Geom_Transformation_3 extends Handle_Geom_Transformation {
    constructor(theHandle: Handle_Geom_Transformation);
  }

  export declare class Handle_Geom_Transformation_4 extends Handle_Geom_Transformation {
    constructor(theHandle: Handle_Geom_Transformation);
  }

export declare class Geom_SphericalSurface extends Geom_ElementarySurface {
  SetRadius(R: Quantity_AbsorbedDose): void;
  SetSphere(S: gp_Sphere): void;
  Sphere(): gp_Sphere;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Area(): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Coefficients(A1: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, B1: Quantity_AbsorbedDose, B2: Quantity_AbsorbedDose, B3: Quantity_AbsorbedDose, C1: Quantity_AbsorbedDose, C2: Quantity_AbsorbedDose, C3: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  Volume(): Quantity_AbsorbedDose;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_SphericalSurface_1 extends Geom_SphericalSurface {
    constructor(A3: gp_Ax3, Radius: Quantity_AbsorbedDose);
  }

  export declare class Geom_SphericalSurface_2 extends Geom_SphericalSurface {
    constructor(S: gp_Sphere);
  }

export declare class Handle_Geom_SphericalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_SphericalSurface): void;
  get(): Geom_SphericalSurface;
  delete(): void;
}

  export declare class Handle_Geom_SphericalSurface_1 extends Handle_Geom_SphericalSurface {
    constructor();
  }

  export declare class Handle_Geom_SphericalSurface_2 extends Handle_Geom_SphericalSurface {
    constructor(thePtr: Geom_SphericalSurface);
  }

  export declare class Handle_Geom_SphericalSurface_3 extends Handle_Geom_SphericalSurface {
    constructor(theHandle: Handle_Geom_SphericalSurface);
  }

  export declare class Handle_Geom_SphericalSurface_4 extends Handle_Geom_SphericalSurface {
    constructor(theHandle: Handle_Geom_SphericalSurface);
  }

export declare class Geom_UndefinedDerivative extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Geom_UndefinedDerivative;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_UndefinedDerivative_1 extends Geom_UndefinedDerivative {
    constructor();
  }

  export declare class Geom_UndefinedDerivative_2 extends Geom_UndefinedDerivative {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Geom_UndefinedDerivative {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_UndefinedDerivative): void;
  get(): Geom_UndefinedDerivative;
  delete(): void;
}

  export declare class Handle_Geom_UndefinedDerivative_1 extends Handle_Geom_UndefinedDerivative {
    constructor();
  }

  export declare class Handle_Geom_UndefinedDerivative_2 extends Handle_Geom_UndefinedDerivative {
    constructor(thePtr: Geom_UndefinedDerivative);
  }

  export declare class Handle_Geom_UndefinedDerivative_3 extends Handle_Geom_UndefinedDerivative {
    constructor(theHandle: Handle_Geom_UndefinedDerivative);
  }

  export declare class Handle_Geom_UndefinedDerivative_4 extends Handle_Geom_UndefinedDerivative {
    constructor(theHandle: Handle_Geom_UndefinedDerivative);
  }

export declare class Handle_Geom_Axis2Placement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Axis2Placement): void;
  get(): Geom_Axis2Placement;
  delete(): void;
}

  export declare class Handle_Geom_Axis2Placement_1 extends Handle_Geom_Axis2Placement {
    constructor();
  }

  export declare class Handle_Geom_Axis2Placement_2 extends Handle_Geom_Axis2Placement {
    constructor(thePtr: Geom_Axis2Placement);
  }

  export declare class Handle_Geom_Axis2Placement_3 extends Handle_Geom_Axis2Placement {
    constructor(theHandle: Handle_Geom_Axis2Placement);
  }

  export declare class Handle_Geom_Axis2Placement_4 extends Handle_Geom_Axis2Placement {
    constructor(theHandle: Handle_Geom_Axis2Placement);
  }

export declare class Geom_Axis2Placement extends Geom_AxisPlacement {
  SetAx2(A2: gp_Ax2): void;
  SetDirection(V: gp_Dir): void;
  SetXDirection(Vx: gp_Dir): void;
  SetYDirection(Vy: gp_Dir): void;
  Ax2(): gp_Ax2;
  XDirection(): gp_Dir;
  YDirection(): gp_Dir;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Axis2Placement_1 extends Geom_Axis2Placement {
    constructor(A2: gp_Ax2);
  }

  export declare class Geom_Axis2Placement_2 extends Geom_Axis2Placement {
    constructor(P: gp_Pnt, N: gp_Dir, Vx: gp_Dir);
  }

export declare class Handle_Geom_CartesianPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_CartesianPoint): void;
  get(): Geom_CartesianPoint;
  delete(): void;
}

  export declare class Handle_Geom_CartesianPoint_1 extends Handle_Geom_CartesianPoint {
    constructor();
  }

  export declare class Handle_Geom_CartesianPoint_2 extends Handle_Geom_CartesianPoint {
    constructor(thePtr: Geom_CartesianPoint);
  }

  export declare class Handle_Geom_CartesianPoint_3 extends Handle_Geom_CartesianPoint {
    constructor(theHandle: Handle_Geom_CartesianPoint);
  }

  export declare class Handle_Geom_CartesianPoint_4 extends Handle_Geom_CartesianPoint {
    constructor(theHandle: Handle_Geom_CartesianPoint);
  }

export declare class Geom_CartesianPoint extends Geom_Point {
  SetCoord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetPnt(P: gp_Pnt): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  SetZ(Z: Quantity_AbsorbedDose): void;
  Coord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Pnt(): gp_Pnt;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_CartesianPoint_1 extends Geom_CartesianPoint {
    constructor(P: gp_Pnt);
  }

  export declare class Geom_CartesianPoint_2 extends Geom_CartesianPoint {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom_OsculatingSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_OsculatingSurface): void;
  get(): Geom_OsculatingSurface;
  delete(): void;
}

  export declare class Handle_Geom_OsculatingSurface_1 extends Handle_Geom_OsculatingSurface {
    constructor();
  }

  export declare class Handle_Geom_OsculatingSurface_2 extends Handle_Geom_OsculatingSurface {
    constructor(thePtr: Geom_OsculatingSurface);
  }

  export declare class Handle_Geom_OsculatingSurface_3 extends Handle_Geom_OsculatingSurface {
    constructor(theHandle: Handle_Geom_OsculatingSurface);
  }

  export declare class Handle_Geom_OsculatingSurface_4 extends Handle_Geom_OsculatingSurface {
    constructor(theHandle: Handle_Geom_OsculatingSurface);
  }

export declare class Geom_OsculatingSurface extends Standard_Transient {
  Init(BS: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose): void;
  BasisSurface(): Handle_Geom_Surface;
  Tolerance(): Quantity_AbsorbedDose;
  UOscSurf(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, t: Standard_Boolean, L: Handle_Geom_BSplineSurface): Standard_Boolean;
  VOscSurf(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, t: Standard_Boolean, L: Handle_Geom_BSplineSurface): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_OsculatingSurface_1 extends Geom_OsculatingSurface {
    constructor();
  }

  export declare class Geom_OsculatingSurface_2 extends Geom_OsculatingSurface {
    constructor(BS: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom_Vector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Vector): void;
  get(): Geom_Vector;
  delete(): void;
}

  export declare class Handle_Geom_Vector_1 extends Handle_Geom_Vector {
    constructor();
  }

  export declare class Handle_Geom_Vector_2 extends Handle_Geom_Vector {
    constructor(thePtr: Geom_Vector);
  }

  export declare class Handle_Geom_Vector_3 extends Handle_Geom_Vector {
    constructor(theHandle: Handle_Geom_Vector);
  }

  export declare class Handle_Geom_Vector_4 extends Handle_Geom_Vector {
    constructor(theHandle: Handle_Geom_Vector);
  }

export declare class Geom_Vector extends Geom_Geometry {
  Reverse(): void;
  Reversed(): Handle_Geom_Vector;
  Angle(Other: Handle_Geom_Vector): Quantity_AbsorbedDose;
  AngleWithRef(Other: Handle_Geom_Vector, VRef: Handle_Geom_Vector): Quantity_AbsorbedDose;
  Coord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  Cross(Other: Handle_Geom_Vector): void;
  Crossed(Other: Handle_Geom_Vector): Handle_Geom_Vector;
  CrossCross(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): void;
  CrossCrossed(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): Handle_Geom_Vector;
  Dot(Other: Handle_Geom_Vector): Quantity_AbsorbedDose;
  DotCross(V1: Handle_Geom_Vector, V2: Handle_Geom_Vector): Quantity_AbsorbedDose;
  Vec(): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_Ellipse {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Ellipse): void;
  get(): Geom_Ellipse;
  delete(): void;
}

  export declare class Handle_Geom_Ellipse_1 extends Handle_Geom_Ellipse {
    constructor();
  }

  export declare class Handle_Geom_Ellipse_2 extends Handle_Geom_Ellipse {
    constructor(thePtr: Geom_Ellipse);
  }

  export declare class Handle_Geom_Ellipse_3 extends Handle_Geom_Ellipse {
    constructor(theHandle: Handle_Geom_Ellipse);
  }

  export declare class Handle_Geom_Ellipse_4 extends Handle_Geom_Ellipse {
    constructor(theHandle: Handle_Geom_Ellipse);
  }

export declare class Geom_Ellipse extends Geom_Conic {
  SetElips(E: gp_Elips): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  Elips(): gp_Elips;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Directrix1(): gp_Ax1;
  Directrix2(): gp_Ax1;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt;
  Focus2(): gp_Pnt;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Ellipse_1 extends Geom_Ellipse {
    constructor(E: gp_Elips);
  }

  export declare class Geom_Ellipse_2 extends Geom_Ellipse {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom_Parabola {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Parabola): void;
  get(): Geom_Parabola;
  delete(): void;
}

  export declare class Handle_Geom_Parabola_1 extends Handle_Geom_Parabola {
    constructor();
  }

  export declare class Handle_Geom_Parabola_2 extends Handle_Geom_Parabola {
    constructor(thePtr: Geom_Parabola);
  }

  export declare class Handle_Geom_Parabola_3 extends Handle_Geom_Parabola {
    constructor(theHandle: Handle_Geom_Parabola);
  }

  export declare class Handle_Geom_Parabola_4 extends Handle_Geom_Parabola {
    constructor(theHandle: Handle_Geom_Parabola);
  }

export declare class Geom_Parabola extends Geom_Conic {
  SetFocal(Focal: Quantity_AbsorbedDose): void;
  SetParab(Prb: gp_Parab): void;
  Parab(): gp_Parab;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Directrix(): gp_Ax1;
  Eccentricity(): Quantity_AbsorbedDose;
  Focus(): gp_Pnt;
  Focal(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf): Quantity_AbsorbedDose;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Parabola_1 extends Geom_Parabola {
    constructor(Prb: gp_Parab);
  }

  export declare class Geom_Parabola_2 extends Geom_Parabola {
    constructor(A2: gp_Ax2, Focal: Quantity_AbsorbedDose);
  }

  export declare class Geom_Parabola_3 extends Geom_Parabola {
    constructor(D: gp_Ax1, F: gp_Pnt);
  }

export declare class Handle_Geom_BezierSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_BezierSurface): void;
  get(): Geom_BezierSurface;
  delete(): void;
}

  export declare class Handle_Geom_BezierSurface_1 extends Handle_Geom_BezierSurface {
    constructor();
  }

  export declare class Handle_Geom_BezierSurface_2 extends Handle_Geom_BezierSurface {
    constructor(thePtr: Geom_BezierSurface);
  }

  export declare class Handle_Geom_BezierSurface_3 extends Handle_Geom_BezierSurface {
    constructor(theHandle: Handle_Geom_BezierSurface);
  }

  export declare class Handle_Geom_BezierSurface_4 extends Handle_Geom_BezierSurface {
    constructor(theHandle: Handle_Geom_BezierSurface);
  }

export declare class Geom_BezierSurface extends Geom_BoundedSurface {
  ExchangeUV(): void;
  Increase(UDeg: Graphic3d_ZLayerId, VDeg: Graphic3d_ZLayerId): void;
  InsertPoleColAfter_1(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  InsertPoleColAfter_2(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  InsertPoleColBefore_1(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  InsertPoleColBefore_2(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  InsertPoleRowAfter_1(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  InsertPoleRowAfter_2(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  InsertPoleRowBefore_1(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  InsertPoleRowBefore_2(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  RemovePoleCol(VIndex: Graphic3d_ZLayerId): void;
  RemovePoleRow(UIndex: Graphic3d_ZLayerId): void;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  SetPole_1(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, P: gp_Pnt): void;
  SetPole_2(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, P: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  SetPoleCol_1(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  SetPoleCol_2(VIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  SetPoleRow_1(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt): void;
  SetPoleRow_2(UIndex: Graphic3d_ZLayerId, CPoles: TColgp_Array1OfPnt, CPoleWeights: TColStd_Array1OfReal): void;
  SetWeight(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  SetWeightCol(VIndex: Graphic3d_ZLayerId, CPoleWeights: TColStd_Array1OfReal): void;
  SetWeightRow(UIndex: Graphic3d_ZLayerId, CPoleWeights: TColStd_Array1OfReal): void;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Continuity(): GeomAbs_Shape;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  NbUPoles(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  Pole(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): gp_Pnt;
  Poles_1(P: TColgp_Array2OfPnt): void;
  Poles_2(): TColgp_Array2OfPnt;
  UDegree(): Graphic3d_ZLayerId;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VDegree(): Graphic3d_ZLayerId;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  Weight(UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights_1(W: TColStd_Array2OfReal): void;
  Weights_2(): TColStd_Array2OfReal;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Transform(T: gp_Trsf): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  Resolution(Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose, VTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_BezierSurface_1 extends Geom_BezierSurface {
    constructor(SurfacePoles: TColgp_Array2OfPnt);
  }

  export declare class Geom_BezierSurface_2 extends Geom_BezierSurface {
    constructor(SurfacePoles: TColgp_Array2OfPnt, PoleWeights: TColStd_Array2OfReal);
  }

export declare class Handle_Geom_Point {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Point): void;
  get(): Geom_Point;
  delete(): void;
}

  export declare class Handle_Geom_Point_1 extends Handle_Geom_Point {
    constructor();
  }

  export declare class Handle_Geom_Point_2 extends Handle_Geom_Point {
    constructor(thePtr: Geom_Point);
  }

  export declare class Handle_Geom_Point_3 extends Handle_Geom_Point {
    constructor(theHandle: Handle_Geom_Point);
  }

  export declare class Handle_Geom_Point_4 extends Handle_Geom_Point {
    constructor(theHandle: Handle_Geom_Point);
  }

export declare class Geom_Point extends Geom_Geometry {
  Coord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Pnt(): gp_Pnt;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  Distance(Other: Handle_Geom_Point): Quantity_AbsorbedDose;
  SquareDistance(Other: Handle_Geom_Point): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Geom_BoundedCurve extends Geom_Curve {
  EndPoint(): gp_Pnt;
  StartPoint(): gp_Pnt;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_BoundedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_BoundedCurve): void;
  get(): Geom_BoundedCurve;
  delete(): void;
}

  export declare class Handle_Geom_BoundedCurve_1 extends Handle_Geom_BoundedCurve {
    constructor();
  }

  export declare class Handle_Geom_BoundedCurve_2 extends Handle_Geom_BoundedCurve {
    constructor(thePtr: Geom_BoundedCurve);
  }

  export declare class Handle_Geom_BoundedCurve_3 extends Handle_Geom_BoundedCurve {
    constructor(theHandle: Handle_Geom_BoundedCurve);
  }

  export declare class Handle_Geom_BoundedCurve_4 extends Handle_Geom_BoundedCurve {
    constructor(theHandle: Handle_Geom_BoundedCurve);
  }

export declare class Handle_Geom_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Curve): void;
  get(): Geom_Curve;
  delete(): void;
}

  export declare class Handle_Geom_Curve_1 extends Handle_Geom_Curve {
    constructor();
  }

  export declare class Handle_Geom_Curve_2 extends Handle_Geom_Curve {
    constructor(thePtr: Geom_Curve);
  }

  export declare class Handle_Geom_Curve_3 extends Handle_Geom_Curve {
    constructor(theHandle: Handle_Geom_Curve);
  }

  export declare class Handle_Geom_Curve_4 extends Handle_Geom_Curve {
    constructor(theHandle: Handle_Geom_Curve);
  }

export declare class Geom_Curve extends Geom_Geometry {
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf): Quantity_AbsorbedDose;
  Reversed(): Handle_Geom_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Geom_RectangularTrimmedSurface extends Geom_BoundedSurface {
  SetTrim_1(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, USense: Standard_Boolean, VSense: Standard_Boolean): void;
  SetTrim_2(Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, UTrim: Standard_Boolean, Sense: Standard_Boolean): void;
  BasisSurface(): Handle_Geom_Surface;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Continuity(): GeomAbs_Shape;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_RectangularTrimmedSurface_1 extends Geom_RectangularTrimmedSurface {
    constructor(S: Handle_Geom_Surface, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, USense: Standard_Boolean, VSense: Standard_Boolean);
  }

  export declare class Geom_RectangularTrimmedSurface_2 extends Geom_RectangularTrimmedSurface {
    constructor(S: Handle_Geom_Surface, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, UTrim: Standard_Boolean, Sense: Standard_Boolean);
  }

export declare class Handle_Geom_RectangularTrimmedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_RectangularTrimmedSurface): void;
  get(): Geom_RectangularTrimmedSurface;
  delete(): void;
}

  export declare class Handle_Geom_RectangularTrimmedSurface_1 extends Handle_Geom_RectangularTrimmedSurface {
    constructor();
  }

  export declare class Handle_Geom_RectangularTrimmedSurface_2 extends Handle_Geom_RectangularTrimmedSurface {
    constructor(thePtr: Geom_RectangularTrimmedSurface);
  }

  export declare class Handle_Geom_RectangularTrimmedSurface_3 extends Handle_Geom_RectangularTrimmedSurface {
    constructor(theHandle: Handle_Geom_RectangularTrimmedSurface);
  }

  export declare class Handle_Geom_RectangularTrimmedSurface_4 extends Handle_Geom_RectangularTrimmedSurface {
    constructor(theHandle: Handle_Geom_RectangularTrimmedSurface);
  }

export declare class Geom_Surface extends Geom_Geometry {
  UReverse(): void;
  UReversed(): Handle_Geom_Surface;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversed(): Handle_Geom_Surface;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  Continuity(): GeomAbs_Shape;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_Surface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Surface): void;
  get(): Geom_Surface;
  delete(): void;
}

  export declare class Handle_Geom_Surface_1 extends Handle_Geom_Surface {
    constructor();
  }

  export declare class Handle_Geom_Surface_2 extends Handle_Geom_Surface {
    constructor(thePtr: Geom_Surface);
  }

  export declare class Handle_Geom_Surface_3 extends Handle_Geom_Surface {
    constructor(theHandle: Handle_Geom_Surface);
  }

  export declare class Handle_Geom_Surface_4 extends Handle_Geom_Surface {
    constructor(theHandle: Handle_Geom_Surface);
  }

export declare class Handle_Geom_Hyperbola {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Hyperbola): void;
  get(): Geom_Hyperbola;
  delete(): void;
}

  export declare class Handle_Geom_Hyperbola_1 extends Handle_Geom_Hyperbola {
    constructor();
  }

  export declare class Handle_Geom_Hyperbola_2 extends Handle_Geom_Hyperbola {
    constructor(thePtr: Geom_Hyperbola);
  }

  export declare class Handle_Geom_Hyperbola_3 extends Handle_Geom_Hyperbola {
    constructor(theHandle: Handle_Geom_Hyperbola);
  }

  export declare class Handle_Geom_Hyperbola_4 extends Handle_Geom_Hyperbola {
    constructor(theHandle: Handle_Geom_Hyperbola);
  }

export declare class Geom_Hyperbola extends Geom_Conic {
  SetHypr(H: gp_Hypr): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  Hypr(): gp_Hypr;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Asymptote1(): gp_Ax1;
  Asymptote2(): gp_Ax1;
  ConjugateBranch1(): gp_Hypr;
  ConjugateBranch2(): gp_Hypr;
  Directrix1(): gp_Ax1;
  Directrix2(): gp_Ax1;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt;
  Focus2(): gp_Pnt;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  OtherBranch(): gp_Hypr;
  Parameter(): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Hyperbola_1 extends Geom_Hyperbola {
    constructor(H: gp_Hypr);
  }

  export declare class Geom_Hyperbola_2 extends Geom_Hyperbola {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom_HSequenceOfBSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_HSequenceOfBSplineSurface): void;
  get(): Geom_HSequenceOfBSplineSurface;
  delete(): void;
}

  export declare class Handle_Geom_HSequenceOfBSplineSurface_1 extends Handle_Geom_HSequenceOfBSplineSurface {
    constructor();
  }

  export declare class Handle_Geom_HSequenceOfBSplineSurface_2 extends Handle_Geom_HSequenceOfBSplineSurface {
    constructor(thePtr: Geom_HSequenceOfBSplineSurface);
  }

  export declare class Handle_Geom_HSequenceOfBSplineSurface_3 extends Handle_Geom_HSequenceOfBSplineSurface {
    constructor(theHandle: Handle_Geom_HSequenceOfBSplineSurface);
  }

  export declare class Handle_Geom_HSequenceOfBSplineSurface_4 extends Handle_Geom_HSequenceOfBSplineSurface {
    constructor(theHandle: Handle_Geom_HSequenceOfBSplineSurface);
  }

export declare class Geom_ToroidalSurface extends Geom_ElementarySurface {
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  SetTorus(T: gp_Torus): void;
  Torus(): gp_Torus;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Area(): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Coefficients(Coef: TColStd_Array1OfReal): void;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  Volume(): Quantity_AbsorbedDose;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_ToroidalSurface_1 extends Geom_ToroidalSurface {
    constructor(A3: gp_Ax3, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class Geom_ToroidalSurface_2 extends Geom_ToroidalSurface {
    constructor(T: gp_Torus);
  }

export declare class Handle_Geom_ToroidalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_ToroidalSurface): void;
  get(): Geom_ToroidalSurface;
  delete(): void;
}

  export declare class Handle_Geom_ToroidalSurface_1 extends Handle_Geom_ToroidalSurface {
    constructor();
  }

  export declare class Handle_Geom_ToroidalSurface_2 extends Handle_Geom_ToroidalSurface {
    constructor(thePtr: Geom_ToroidalSurface);
  }

  export declare class Handle_Geom_ToroidalSurface_3 extends Handle_Geom_ToroidalSurface {
    constructor(theHandle: Handle_Geom_ToroidalSurface);
  }

  export declare class Handle_Geom_ToroidalSurface_4 extends Handle_Geom_ToroidalSurface {
    constructor(theHandle: Handle_Geom_ToroidalSurface);
  }

export declare class Geom_Axis1Placement extends Geom_AxisPlacement {
  Ax1(): gp_Ax1;
  Reverse(): void;
  Reversed(): Handle_Geom_Axis1Placement;
  SetDirection(V: gp_Dir): void;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_Axis1Placement_1 extends Geom_Axis1Placement {
    constructor(A1: gp_Ax1);
  }

  export declare class Geom_Axis1Placement_2 extends Geom_Axis1Placement {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

export declare class Handle_Geom_Axis1Placement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_Axis1Placement): void;
  get(): Geom_Axis1Placement;
  delete(): void;
}

  export declare class Handle_Geom_Axis1Placement_1 extends Handle_Geom_Axis1Placement {
    constructor();
  }

  export declare class Handle_Geom_Axis1Placement_2 extends Handle_Geom_Axis1Placement {
    constructor(thePtr: Geom_Axis1Placement);
  }

  export declare class Handle_Geom_Axis1Placement_3 extends Handle_Geom_Axis1Placement {
    constructor(theHandle: Handle_Geom_Axis1Placement);
  }

  export declare class Handle_Geom_Axis1Placement_4 extends Handle_Geom_Axis1Placement {
    constructor(theHandle: Handle_Geom_Axis1Placement);
  }

export declare class Geom_CylindricalSurface extends Geom_ElementarySurface {
  SetCylinder(C: gp_Cylinder): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  Cylinder(): gp_Cylinder;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Coefficients(A1: Quantity_AbsorbedDose, A2: Quantity_AbsorbedDose, A3: Quantity_AbsorbedDose, B1: Quantity_AbsorbedDose, B2: Quantity_AbsorbedDose, B3: Quantity_AbsorbedDose, C1: Quantity_AbsorbedDose, C2: Quantity_AbsorbedDose, C3: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom_CylindricalSurface_1 extends Geom_CylindricalSurface {
    constructor(A3: gp_Ax3, Radius: Quantity_AbsorbedDose);
  }

  export declare class Geom_CylindricalSurface_2 extends Geom_CylindricalSurface {
    constructor(C: gp_Cylinder);
  }

export declare class Handle_Geom_CylindricalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_CylindricalSurface): void;
  get(): Geom_CylindricalSurface;
  delete(): void;
}

  export declare class Handle_Geom_CylindricalSurface_1 extends Handle_Geom_CylindricalSurface {
    constructor();
  }

  export declare class Handle_Geom_CylindricalSurface_2 extends Handle_Geom_CylindricalSurface {
    constructor(thePtr: Geom_CylindricalSurface);
  }

  export declare class Handle_Geom_CylindricalSurface_3 extends Handle_Geom_CylindricalSurface {
    constructor(theHandle: Handle_Geom_CylindricalSurface);
  }

  export declare class Handle_Geom_CylindricalSurface_4 extends Handle_Geom_CylindricalSurface {
    constructor(theHandle: Handle_Geom_CylindricalSurface);
  }

export declare class Geom_OffsetSurface extends Geom_Surface {
  constructor(S: Handle_Geom_Surface, Offset: Quantity_AbsorbedDose, isNotCheckC0: Standard_Boolean)
  SetBasisSurface(S: Handle_Geom_Surface, isNotCheckC0: Standard_Boolean): void;
  SetOffsetValue(D: Quantity_AbsorbedDose): void;
  Offset(): Quantity_AbsorbedDose;
  BasisSurface(): Handle_Geom_Surface;
  OsculatingSurface(): Handle_Geom_OsculatingSurface;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Continuity(): GeomAbs_Shape;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Copy(): Handle_Geom_Geometry;
  Surface(): Handle_Geom_Surface;
  UOsculatingSurface(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, IsOpposite: Standard_Boolean, UOsculSurf: Handle_Geom_BSplineSurface): Standard_Boolean;
  VOsculatingSurface(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, IsOpposite: Standard_Boolean, VOsculSurf: Handle_Geom_BSplineSurface): Standard_Boolean;
  GetBasisSurfContinuity(): GeomAbs_Shape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_OffsetSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_OffsetSurface): void;
  get(): Geom_OffsetSurface;
  delete(): void;
}

  export declare class Handle_Geom_OffsetSurface_1 extends Handle_Geom_OffsetSurface {
    constructor();
  }

  export declare class Handle_Geom_OffsetSurface_2 extends Handle_Geom_OffsetSurface {
    constructor(thePtr: Geom_OffsetSurface);
  }

  export declare class Handle_Geom_OffsetSurface_3 extends Handle_Geom_OffsetSurface {
    constructor(theHandle: Handle_Geom_OffsetSurface);
  }

  export declare class Handle_Geom_OffsetSurface_4 extends Handle_Geom_OffsetSurface {
    constructor(theHandle: Handle_Geom_OffsetSurface);
  }

export declare class Handle_Geom_SurfaceOfRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_SurfaceOfRevolution): void;
  get(): Geom_SurfaceOfRevolution;
  delete(): void;
}

  export declare class Handle_Geom_SurfaceOfRevolution_1 extends Handle_Geom_SurfaceOfRevolution {
    constructor();
  }

  export declare class Handle_Geom_SurfaceOfRevolution_2 extends Handle_Geom_SurfaceOfRevolution {
    constructor(thePtr: Geom_SurfaceOfRevolution);
  }

  export declare class Handle_Geom_SurfaceOfRevolution_3 extends Handle_Geom_SurfaceOfRevolution {
    constructor(theHandle: Handle_Geom_SurfaceOfRevolution);
  }

  export declare class Handle_Geom_SurfaceOfRevolution_4 extends Handle_Geom_SurfaceOfRevolution {
    constructor(theHandle: Handle_Geom_SurfaceOfRevolution);
  }

export declare class Geom_SurfaceOfRevolution extends Geom_SweptSurface {
  constructor(C: Handle_Geom_Curve, A1: gp_Ax1)
  SetAxis(A1: gp_Ax1): void;
  SetDirection(V: gp_Dir): void;
  SetBasisCurve(C: Handle_Geom_Curve): void;
  SetLocation(P: gp_Pnt): void;
  Axis(): gp_Ax1;
  Location(): gp_Pnt;
  ReferencePlane(): gp_Ax2;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Geom_ElementarySurface extends Geom_Surface {
  SetAxis(theA1: gp_Ax1): void;
  SetLocation(theLoc: gp_Pnt): void;
  SetPosition(theAx3: gp_Ax3): void;
  Axis(): gp_Ax1;
  Location(): gp_Pnt;
  Position(): gp_Ax3;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom_ElementarySurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom_ElementarySurface): void;
  get(): Geom_ElementarySurface;
  delete(): void;
}

  export declare class Handle_Geom_ElementarySurface_1 extends Handle_Geom_ElementarySurface {
    constructor();
  }

  export declare class Handle_Geom_ElementarySurface_2 extends Handle_Geom_ElementarySurface {
    constructor(thePtr: Geom_ElementarySurface);
  }

  export declare class Handle_Geom_ElementarySurface_3 extends Handle_Geom_ElementarySurface {
    constructor(theHandle: Handle_Geom_ElementarySurface);
  }

  export declare class Handle_Geom_ElementarySurface_4 extends Handle_Geom_ElementarySurface {
    constructor(theHandle: Handle_Geom_ElementarySurface);
  }

export declare class ExprIntrp_Analysis {
  constructor()
  SetMaster(agen: Handle_ExprIntrp_Generator): void;
  Push(exp: Handle_Expr_GeneralExpression): void;
  PushRelation(rel: Handle_Expr_GeneralRelation): void;
  PushName(name: XCAFDoc_PartId): void;
  PushValue(degree: Graphic3d_ZLayerId): void;
  PushFunction(func: Handle_Expr_GeneralFunction): void;
  Pop(): Handle_Expr_GeneralExpression;
  PopRelation(): Handle_Expr_GeneralRelation;
  PopName(): XCAFDoc_PartId;
  PopValue(): Graphic3d_ZLayerId;
  PopFunction(): Handle_Expr_GeneralFunction;
  IsExpStackEmpty(): Standard_Boolean;
  IsRelStackEmpty(): Standard_Boolean;
  ResetAll(): void;
  Use_1(func: Handle_Expr_NamedFunction): void;
  Use_2(named: Handle_Expr_NamedExpression): void;
  GetNamed(name: XCAFDoc_PartId): Handle_Expr_NamedExpression;
  GetFunction(name: XCAFDoc_PartId): Handle_Expr_NamedFunction;
  delete(): void;
}

export declare class Handle_ExprIntrp_GenExp {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ExprIntrp_GenExp): void;
  get(): ExprIntrp_GenExp;
  delete(): void;
}

  export declare class Handle_ExprIntrp_GenExp_1 extends Handle_ExprIntrp_GenExp {
    constructor();
  }

  export declare class Handle_ExprIntrp_GenExp_2 extends Handle_ExprIntrp_GenExp {
    constructor(thePtr: ExprIntrp_GenExp);
  }

  export declare class Handle_ExprIntrp_GenExp_3 extends Handle_ExprIntrp_GenExp {
    constructor(theHandle: Handle_ExprIntrp_GenExp);
  }

  export declare class Handle_ExprIntrp_GenExp_4 extends Handle_ExprIntrp_GenExp {
    constructor(theHandle: Handle_ExprIntrp_GenExp);
  }

export declare class ExprIntrp_GenExp extends ExprIntrp_Generator {
  static Create(): Handle_ExprIntrp_GenExp;
  Process(str: XCAFDoc_PartId): void;
  IsDone(): Standard_Boolean;
  Expression(): Handle_Expr_GeneralExpression;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ExprIntrp {
  constructor();
  delete(): void;
}

export declare class ExprIntrp_SyntaxError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_ExprIntrp_SyntaxError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ExprIntrp_SyntaxError_1 extends ExprIntrp_SyntaxError {
    constructor();
  }

  export declare class ExprIntrp_SyntaxError_2 extends ExprIntrp_SyntaxError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_ExprIntrp_SyntaxError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ExprIntrp_SyntaxError): void;
  get(): ExprIntrp_SyntaxError;
  delete(): void;
}

  export declare class Handle_ExprIntrp_SyntaxError_1 extends Handle_ExprIntrp_SyntaxError {
    constructor();
  }

  export declare class Handle_ExprIntrp_SyntaxError_2 extends Handle_ExprIntrp_SyntaxError {
    constructor(thePtr: ExprIntrp_SyntaxError);
  }

  export declare class Handle_ExprIntrp_SyntaxError_3 extends Handle_ExprIntrp_SyntaxError {
    constructor(theHandle: Handle_ExprIntrp_SyntaxError);
  }

  export declare class Handle_ExprIntrp_SyntaxError_4 extends Handle_ExprIntrp_SyntaxError {
    constructor(theHandle: Handle_ExprIntrp_SyntaxError);
  }

export declare class ExprIntrp_GenRel extends ExprIntrp_Generator {
  static Create(): Handle_ExprIntrp_GenRel;
  Process(str: XCAFDoc_PartId): void;
  IsDone(): Standard_Boolean;
  Relation(): Handle_Expr_GeneralRelation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ExprIntrp_GenRel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ExprIntrp_GenRel): void;
  get(): ExprIntrp_GenRel;
  delete(): void;
}

  export declare class Handle_ExprIntrp_GenRel_1 extends Handle_ExprIntrp_GenRel {
    constructor();
  }

  export declare class Handle_ExprIntrp_GenRel_2 extends Handle_ExprIntrp_GenRel {
    constructor(thePtr: ExprIntrp_GenRel);
  }

  export declare class Handle_ExprIntrp_GenRel_3 extends Handle_ExprIntrp_GenRel {
    constructor(theHandle: Handle_ExprIntrp_GenRel);
  }

  export declare class Handle_ExprIntrp_GenRel_4 extends Handle_ExprIntrp_GenRel {
    constructor(theHandle: Handle_ExprIntrp_GenRel);
  }

export declare class Handle_ExprIntrp_GenFct {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ExprIntrp_GenFct): void;
  get(): ExprIntrp_GenFct;
  delete(): void;
}

  export declare class Handle_ExprIntrp_GenFct_1 extends Handle_ExprIntrp_GenFct {
    constructor();
  }

  export declare class Handle_ExprIntrp_GenFct_2 extends Handle_ExprIntrp_GenFct {
    constructor(thePtr: ExprIntrp_GenFct);
  }

  export declare class Handle_ExprIntrp_GenFct_3 extends Handle_ExprIntrp_GenFct {
    constructor(theHandle: Handle_ExprIntrp_GenFct);
  }

  export declare class Handle_ExprIntrp_GenFct_4 extends Handle_ExprIntrp_GenFct {
    constructor(theHandle: Handle_ExprIntrp_GenFct);
  }

export declare class ExprIntrp_GenFct extends ExprIntrp_Generator {
  static Create(): Handle_ExprIntrp_GenFct;
  Process(str: XCAFDoc_PartId): void;
  IsDone(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ExprIntrp_Generator extends Standard_Transient {
  Use_1(func: Handle_Expr_NamedFunction): void;
  Use_2(named: Handle_Expr_NamedExpression): void;
  GetNamed_1(): ExprIntrp_SequenceOfNamedExpression;
  GetFunctions(): ExprIntrp_SequenceOfNamedFunction;
  GetNamed_2(name: XCAFDoc_PartId): Handle_Expr_NamedExpression;
  GetFunction(name: XCAFDoc_PartId): Handle_Expr_NamedFunction;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ExprIntrp_Generator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ExprIntrp_Generator): void;
  get(): ExprIntrp_Generator;
  delete(): void;
}

  export declare class Handle_ExprIntrp_Generator_1 extends Handle_ExprIntrp_Generator {
    constructor();
  }

  export declare class Handle_ExprIntrp_Generator_2 extends Handle_ExprIntrp_Generator {
    constructor(thePtr: ExprIntrp_Generator);
  }

  export declare class Handle_ExprIntrp_Generator_3 extends Handle_ExprIntrp_Generator {
    constructor(theHandle: Handle_ExprIntrp_Generator);
  }

  export declare class Handle_ExprIntrp_Generator_4 extends Handle_ExprIntrp_Generator {
    constructor(theHandle: Handle_ExprIntrp_Generator);
  }

export declare class Handle_STEPControl_Controller {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPControl_Controller): void;
  get(): STEPControl_Controller;
  delete(): void;
}

  export declare class Handle_STEPControl_Controller_1 extends Handle_STEPControl_Controller {
    constructor();
  }

  export declare class Handle_STEPControl_Controller_2 extends Handle_STEPControl_Controller {
    constructor(thePtr: STEPControl_Controller);
  }

  export declare class Handle_STEPControl_Controller_3 extends Handle_STEPControl_Controller {
    constructor(theHandle: Handle_STEPControl_Controller);
  }

  export declare class Handle_STEPControl_Controller_4 extends Handle_STEPControl_Controller {
    constructor(theHandle: Handle_STEPControl_Controller);
  }

export declare class STEPControl_Controller extends XSControl_Controller {
  constructor()
  NewModel(): Handle_Interface_InterfaceModel;
  Customise(WS: Handle_XSControl_WorkSession): void;
  TransferWriteShape(shape: TopoDS_Shape, FP: Handle_Transfer_FinderProcess, model: Handle_Interface_InterfaceModel, modetrans: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  static Init(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPControl_ActorRead {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPControl_ActorRead): void;
  get(): STEPControl_ActorRead;
  delete(): void;
}

  export declare class Handle_STEPControl_ActorRead_1 extends Handle_STEPControl_ActorRead {
    constructor();
  }

  export declare class Handle_STEPControl_ActorRead_2 extends Handle_STEPControl_ActorRead {
    constructor(thePtr: STEPControl_ActorRead);
  }

  export declare class Handle_STEPControl_ActorRead_3 extends Handle_STEPControl_ActorRead {
    constructor(theHandle: Handle_STEPControl_ActorRead);
  }

  export declare class Handle_STEPControl_ActorRead_4 extends Handle_STEPControl_ActorRead {
    constructor(theHandle: Handle_STEPControl_ActorRead);
  }

export declare class STEPControl_ActorRead extends Transfer_ActorOfTransientProcess {
  constructor()
  Recognize(start: Handle_Standard_Transient): Standard_Boolean;
  Transfer(start: Handle_Standard_Transient, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransferShape(start: Handle_Standard_Transient, TP: Handle_Transfer_TransientProcess, isManifold: Standard_Boolean, theUseTrsf: Standard_Boolean, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  PrepareUnits(rep: Handle_StepRepr_Representation, TP: Handle_Transfer_TransientProcess): void;
  ResetUnits(): void;
  ComputeTransformation(Origin: Handle_StepGeom_Axis2Placement3d, Target: Handle_StepGeom_Axis2Placement3d, OrigContext: Handle_StepRepr_Representation, TargContext: Handle_StepRepr_Representation, TP: Handle_Transfer_TransientProcess, Trsf: gp_Trsf): Standard_Boolean;
  ComputeSRRWT(SRR: Handle_StepRepr_RepresentationRelationship, TP: Handle_Transfer_TransientProcess, Trsf: gp_Trsf): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class STEPControl_Writer {
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  UnsetTolerance(): void;
  SetWS(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean): void;
  WS(): Handle_XSControl_WorkSession;
  Model(newone: Standard_Boolean): Handle_StepData_StepModel;
  Transfer(sh: TopoDS_Shape, mode: STEPControl_StepModelType, compgraph: Standard_Boolean, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  Write(filename: Standard_CString): IFSelect_ReturnStatus;
  PrintStatsTransfer(what: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class STEPControl_Writer_1 extends STEPControl_Writer {
    constructor();
  }

  export declare class STEPControl_Writer_2 extends STEPControl_Writer {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class Handle_STEPControl_ActorWrite {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPControl_ActorWrite): void;
  get(): STEPControl_ActorWrite;
  delete(): void;
}

  export declare class Handle_STEPControl_ActorWrite_1 extends Handle_STEPControl_ActorWrite {
    constructor();
  }

  export declare class Handle_STEPControl_ActorWrite_2 extends Handle_STEPControl_ActorWrite {
    constructor(thePtr: STEPControl_ActorWrite);
  }

  export declare class Handle_STEPControl_ActorWrite_3 extends Handle_STEPControl_ActorWrite {
    constructor(theHandle: Handle_STEPControl_ActorWrite);
  }

  export declare class Handle_STEPControl_ActorWrite_4 extends Handle_STEPControl_ActorWrite {
    constructor(theHandle: Handle_STEPControl_ActorWrite);
  }

export declare class STEPControl_ActorWrite extends Transfer_ActorOfFinderProcess {
  constructor()
  Recognize(start: Handle_Transfer_Finder): Standard_Boolean;
  Transfer(start: Handle_Transfer_Finder, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransferSubShape(start: Handle_Transfer_Finder, SDR: Handle_StepShape_ShapeDefinitionRepresentation, AX1: Handle_StepGeom_Axis2Placement3d, FP: Handle_Transfer_FinderProcess, shapeGroup: Handle_TopTools_HSequenceOfShape, isManifold: Standard_Boolean, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransferShape(start: Handle_Transfer_Finder, SDR: Handle_StepShape_ShapeDefinitionRepresentation, FP: Handle_Transfer_FinderProcess, shapeGroup: Handle_TopTools_HSequenceOfShape, isManifold: Standard_Boolean, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransferCompound(start: Handle_Transfer_Finder, SDR: Handle_StepShape_ShapeDefinitionRepresentation, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  SetMode(M: STEPControl_StepModelType): void;
  Mode(): STEPControl_StepModelType;
  SetGroupMode(mode: Graphic3d_ZLayerId): void;
  GroupMode(): Graphic3d_ZLayerId;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  IsAssembly(S: TopoDS_Shape): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class STEPControl_Reader extends XSControl_Reader {
  StepModel(): Handle_StepData_StepModel;
  TransferRoot(num: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): Standard_Boolean;
  NbRootsForTransfer(): Graphic3d_ZLayerId;
  FileUnits(theUnitLengthNames: TColStd_SequenceOfAsciiString, theUnitAngleNames: TColStd_SequenceOfAsciiString, theUnitSolidAngleNames: TColStd_SequenceOfAsciiString): void;
  delete(): void;
}

  export declare class STEPControl_Reader_1 extends STEPControl_Reader {
    constructor();
  }

  export declare class STEPControl_Reader_2 extends STEPControl_Reader {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare type STEPControl_StepModelType = {
  STEPControl_AsIs: {};
  STEPControl_ManifoldSolidBrep: {};
  STEPControl_BrepWithVoids: {};
  STEPControl_FacetedBrep: {};
  STEPControl_FacetedBrepAndBrepWithVoids: {};
  STEPControl_ShellBasedSurfaceModel: {};
  STEPControl_GeometricCurveSet: {};
  STEPControl_Hybrid: {};
}

export declare class Handle_BRepTopAdaptor_HVertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTopAdaptor_HVertex): void;
  get(): BRepTopAdaptor_HVertex;
  delete(): void;
}

  export declare class Handle_BRepTopAdaptor_HVertex_1 extends Handle_BRepTopAdaptor_HVertex {
    constructor();
  }

  export declare class Handle_BRepTopAdaptor_HVertex_2 extends Handle_BRepTopAdaptor_HVertex {
    constructor(thePtr: BRepTopAdaptor_HVertex);
  }

  export declare class Handle_BRepTopAdaptor_HVertex_3 extends Handle_BRepTopAdaptor_HVertex {
    constructor(theHandle: Handle_BRepTopAdaptor_HVertex);
  }

  export declare class Handle_BRepTopAdaptor_HVertex_4 extends Handle_BRepTopAdaptor_HVertex {
    constructor(theHandle: Handle_BRepTopAdaptor_HVertex);
  }

export declare class BRepTopAdaptor_HVertex extends Adaptor3d_HVertex {
  constructor(Vtx: TopoDS_Vertex, Curve: Handle_BRepAdaptor_HCurve2d)
  Vertex(): TopoDS_Vertex;
  ChangeVertex(): TopoDS_Vertex;
  Value(): gp_Pnt2d;
  Parameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  Resolution(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  Orientation(): TopAbs_Orientation;
  IsSame(Other: Handle_Adaptor3d_HVertex): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepTopAdaptor_Tool {
  Init_1(F: TopoDS_Face, Tol2d: Quantity_AbsorbedDose): void;
  Init_2(Surface: Handle_Adaptor3d_HSurface, Tol2d: Quantity_AbsorbedDose): void;
  GetTopolTool(): Handle_BRepTopAdaptor_TopolTool;
  SetTopolTool(TT: Handle_BRepTopAdaptor_TopolTool): void;
  GetSurface(): Handle_Adaptor3d_HSurface;
  Destroy(): void;
  delete(): void;
}

  export declare class BRepTopAdaptor_Tool_1 extends BRepTopAdaptor_Tool {
    constructor();
  }

  export declare class BRepTopAdaptor_Tool_2 extends BRepTopAdaptor_Tool {
    constructor(F: TopoDS_Face, Tol2d: Quantity_AbsorbedDose);
  }

  export declare class BRepTopAdaptor_Tool_3 extends BRepTopAdaptor_Tool {
    constructor(Surface: Handle_Adaptor3d_HSurface, Tol2d: Quantity_AbsorbedDose);
  }

export declare class BRepTopAdaptor_MapOfShapeTool extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepTopAdaptor_MapOfShapeTool): void;
  Assign(theOther: BRepTopAdaptor_MapOfShapeTool): BRepTopAdaptor_MapOfShapeTool;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: BRepTopAdaptor_Tool): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: BRepTopAdaptor_Tool): BRepTopAdaptor_Tool;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): BRepTopAdaptor_Tool;
  ChangeSeek(theKey: TopoDS_Shape): BRepTopAdaptor_Tool;
  ChangeFind(theKey: TopoDS_Shape): BRepTopAdaptor_Tool;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepTopAdaptor_MapOfShapeTool_1 extends BRepTopAdaptor_MapOfShapeTool {
    constructor();
  }

  export declare class BRepTopAdaptor_MapOfShapeTool_2 extends BRepTopAdaptor_MapOfShapeTool {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepTopAdaptor_MapOfShapeTool_3 extends BRepTopAdaptor_MapOfShapeTool {
    constructor(theOther: BRepTopAdaptor_MapOfShapeTool);
  }

export declare class BRepTopAdaptor_FClass2d {
  constructor(F: TopoDS_Face, Tol: Quantity_AbsorbedDose)
  PerformInfinitePoint(): TopAbs_State;
  Perform(Puv: gp_Pnt2d, RecadreOnPeriodic: Standard_Boolean): TopAbs_State;
  Destroy(): void;
  Copy(Other: BRepTopAdaptor_FClass2d): BRepTopAdaptor_FClass2d;
  TestOnRestriction(Puv: gp_Pnt2d, Tol: Quantity_AbsorbedDose, RecadreOnPeriodic: Standard_Boolean): TopAbs_State;
  delete(): void;
}

export declare class BRepTopAdaptor_TopolTool extends Adaptor3d_TopolTool {
  Initialize_1(): void;
  Initialize_2(S: Handle_Adaptor3d_HSurface): void;
  Initialize_3(Curve: Handle_Adaptor2d_HCurve2d): void;
  Init(): void;
  More(): Standard_Boolean;
  Value(): Handle_Adaptor2d_HCurve2d;
  Next(): void;
  Edge(): Standard_Address;
  InitVertexIterator(): void;
  MoreVertex(): Standard_Boolean;
  Vertex(): Handle_Adaptor3d_HVertex;
  NextVertex(): void;
  Classify(P2d: gp_Pnt2d, Tol: Quantity_AbsorbedDose, RecadreOnPeriodic: Standard_Boolean): TopAbs_State;
  IsThePointOn(P2d: gp_Pnt2d, Tol: Quantity_AbsorbedDose, RecadreOnPeriodic: Standard_Boolean): Standard_Boolean;
  Orientation_1(C: Handle_Adaptor2d_HCurve2d): TopAbs_Orientation;
  Orientation_2(C: Handle_Adaptor3d_HVertex): TopAbs_Orientation;
  Destroy(): void;
  Has3d(): Standard_Boolean;
  Tol3d_1(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  Tol3d_2(V: Handle_Adaptor3d_HVertex): Quantity_AbsorbedDose;
  Pnt(V: Handle_Adaptor3d_HVertex): gp_Pnt;
  ComputeSamplePoints(): void;
  NbSamplesU(): Graphic3d_ZLayerId;
  NbSamplesV(): Graphic3d_ZLayerId;
  NbSamples(): Graphic3d_ZLayerId;
  SamplePoint(Index: Graphic3d_ZLayerId, P2d: gp_Pnt2d, P3d: gp_Pnt): void;
  DomainIsInfinite(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepTopAdaptor_TopolTool_1 extends BRepTopAdaptor_TopolTool {
    constructor();
  }

  export declare class BRepTopAdaptor_TopolTool_2 extends BRepTopAdaptor_TopolTool {
    constructor(Surface: Handle_Adaptor3d_HSurface);
  }

export declare class Handle_BRepTopAdaptor_TopolTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepTopAdaptor_TopolTool): void;
  get(): BRepTopAdaptor_TopolTool;
  delete(): void;
}

  export declare class Handle_BRepTopAdaptor_TopolTool_1 extends Handle_BRepTopAdaptor_TopolTool {
    constructor();
  }

  export declare class Handle_BRepTopAdaptor_TopolTool_2 extends Handle_BRepTopAdaptor_TopolTool {
    constructor(thePtr: BRepTopAdaptor_TopolTool);
  }

  export declare class Handle_BRepTopAdaptor_TopolTool_3 extends Handle_BRepTopAdaptor_TopolTool {
    constructor(theHandle: Handle_BRepTopAdaptor_TopolTool);
  }

  export declare class Handle_BRepTopAdaptor_TopolTool_4 extends Handle_BRepTopAdaptor_TopolTool {
    constructor(theHandle: Handle_BRepTopAdaptor_TopolTool);
  }

export declare class BRepApprox_TheMultiLineToolOfApprox {
  constructor();
  static FirstPoint(ML: BRepApprox_TheMultiLineOfApprox): Graphic3d_ZLayerId;
  static LastPoint(ML: BRepApprox_TheMultiLineOfApprox): Graphic3d_ZLayerId;
  static NbP2d(ML: BRepApprox_TheMultiLineOfApprox): Graphic3d_ZLayerId;
  static NbP3d(ML: BRepApprox_TheMultiLineOfApprox): Graphic3d_ZLayerId;
  static Value_1(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt): void;
  static Value_2(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabPt2d: TColgp_Array1OfPnt2d): void;
  static Value_3(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt, tabPt2d: TColgp_Array1OfPnt2d): void;
  static Tangency_1(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  static Tangency_2(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Tangency_3(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Curvature_1(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  static Curvature_2(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Curvature_3(ML: BRepApprox_TheMultiLineOfApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static MakeMLBetween(ML: BRepApprox_TheMultiLineOfApprox, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, NbPMin: Graphic3d_ZLayerId): BRepApprox_TheMultiLineOfApprox;
  static MakeMLOneMorePoint(ML: BRepApprox_TheMultiLineOfApprox, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, indbad: Graphic3d_ZLayerId, OtherLine: BRepApprox_TheMultiLineOfApprox): Standard_Boolean;
  static WhatStatus(ML: BRepApprox_TheMultiLineOfApprox, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): Approx_Status;
  static Dump(ML: BRepApprox_TheMultiLineOfApprox): void;
  delete(): void;
}

export declare class BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox {
  Perform_1(Param: TColStd_Array1OfReal, Rsnld: math_FunctionSetRoot): IntImp_ConstIsoparametric;
  Perform_2(Param: TColStd_Array1OfReal, Rsnld: math_FunctionSetRoot, ChoixIso: IntImp_ConstIsoparametric): IntImp_ConstIsoparametric;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Point(): IntSurf_PntOn2S;
  IsTangent(): Standard_Boolean;
  Direction(): gp_Dir;
  DirectionOnS1(): gp_Dir2d;
  DirectionOnS2(): gp_Dir2d;
  Function(): BRepApprox_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfApprox;
  ChangePoint(): IntSurf_PntOn2S;
  delete(): void;
}

  export declare class BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox_1 extends BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox {
    constructor(Param: TColStd_Array1OfReal, S1: BRepAdaptor_Surface, S2: BRepAdaptor_Surface, TolTangency: Quantity_AbsorbedDose);
  }

  export declare class BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox_2 extends BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox {
    constructor(S1: BRepAdaptor_Surface, S2: BRepAdaptor_Surface, TolTangency: Quantity_AbsorbedDose);
  }

export declare class BRepApprox_BSpParFunctionOfMyBSplGradientOfTheComputeLineOfApprox extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NbPol: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiBSpCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  Index(): math_IntegerVector;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  SetFirstLambda(l1: Quantity_AbsorbedDose): void;
  SetLastLambda(l2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BRepApprox_ThePrmPrmSvSurfacesOfApprox extends ApproxInt_SvSurfaces {
  constructor(Surf1: BRepAdaptor_Surface, Surf2: BRepAdaptor_Surface)
  Compute(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Pt: gp_Pnt, Tg: gp_Vec, Tguv1: gp_Vec2d, Tguv2: gp_Vec2d): Standard_Boolean;
  Pnt(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, P: gp_Pnt): void;
  SeekPoint(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Point: IntSurf_PntOn2S): Standard_Boolean;
  Tangency(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec): Standard_Boolean;
  TangencyOnSurf1(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  TangencyOnSurf2(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  delete(): void;
}

export declare class BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_1 extends BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_2 extends BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_3 extends BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_4 extends BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class BRepApprox_MyBSplGradientOfTheComputeLineOfApprox {
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiBSpCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepApprox_MyBSplGradientOfTheComputeLineOfApprox_1 extends BRepApprox_MyBSplGradientOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_MyBSplGradientOfTheComputeLineOfApprox_2 extends BRepApprox_MyBSplGradientOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, lambda1: Quantity_AbsorbedDose, lambda2: Quantity_AbsorbedDose);
  }

export declare class BRepApprox_BSpGradient_BFGSOfMyBSplGradientOfTheComputeLineOfApprox extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class BRepApprox_SurfaceTool {
  constructor();
  static FirstUParameter(S: BRepAdaptor_Surface): Quantity_AbsorbedDose;
  static FirstVParameter(S: BRepAdaptor_Surface): Quantity_AbsorbedDose;
  static LastUParameter(S: BRepAdaptor_Surface): Quantity_AbsorbedDose;
  static LastVParameter(S: BRepAdaptor_Surface): Quantity_AbsorbedDose;
  static NbUIntervals(S: BRepAdaptor_Surface, Sh: GeomAbs_Shape): Graphic3d_ZLayerId;
  static NbVIntervals(S: BRepAdaptor_Surface, Sh: GeomAbs_Shape): Graphic3d_ZLayerId;
  static UIntervals(S: BRepAdaptor_Surface, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static VIntervals(S: BRepAdaptor_Surface, T: TColStd_Array1OfReal, Sh: GeomAbs_Shape): void;
  static UTrim(S: BRepAdaptor_Surface, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  static VTrim(S: BRepAdaptor_Surface, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  static IsUClosed(S: BRepAdaptor_Surface): Standard_Boolean;
  static IsVClosed(S: BRepAdaptor_Surface): Standard_Boolean;
  static IsUPeriodic(S: BRepAdaptor_Surface): Standard_Boolean;
  static UPeriod(S: BRepAdaptor_Surface): Quantity_AbsorbedDose;
  static IsVPeriodic(S: BRepAdaptor_Surface): Standard_Boolean;
  static VPeriod(S: BRepAdaptor_Surface): Quantity_AbsorbedDose;
  static Value(S: BRepAdaptor_Surface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): gp_Pnt;
  static D0(S: BRepAdaptor_Surface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(S: BRepAdaptor_Surface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1u: gp_Vec, D1v: gp_Vec): void;
  static D2(S: BRepAdaptor_Surface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  static D3(S: BRepAdaptor_Surface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  static DN(S: BRepAdaptor_Surface, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  static UResolution(S: BRepAdaptor_Surface, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static VResolution(S: BRepAdaptor_Surface, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(S: BRepAdaptor_Surface): GeomAbs_SurfaceType;
  static Plane(S: BRepAdaptor_Surface): gp_Pln;
  static Cylinder(S: BRepAdaptor_Surface): gp_Cylinder;
  static Cone(S: BRepAdaptor_Surface): gp_Cone;
  static Torus(S: BRepAdaptor_Surface): gp_Torus;
  static Sphere(S: BRepAdaptor_Surface): gp_Sphere;
  static Bezier(S: BRepAdaptor_Surface): Handle_Geom_BezierSurface;
  static BSpline(S: BRepAdaptor_Surface): Handle_Geom_BSplineSurface;
  static AxeOfRevolution(S: BRepAdaptor_Surface): gp_Ax1;
  static Direction(S: BRepAdaptor_Surface): gp_Dir;
  static BasisCurve(S: BRepAdaptor_Surface): Handle_Adaptor3d_HCurve;
  static NbSamplesU_1(S: BRepAdaptor_Surface): Graphic3d_ZLayerId;
  static NbSamplesV_1(S: BRepAdaptor_Surface): Graphic3d_ZLayerId;
  static NbSamplesU_2(S: BRepAdaptor_Surface, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplesV_2(S: BRepAdaptor_Surface, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BRepApprox_ApproxLine extends Standard_Transient {
  NbPnts(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepApprox_ApproxLine_1 extends BRepApprox_ApproxLine {
    constructor(CurveXYZ: Handle_Geom_BSplineCurve, CurveUV1: Handle_Geom2d_BSplineCurve, CurveUV2: Handle_Geom2d_BSplineCurve);
  }

  export declare class BRepApprox_ApproxLine_2 extends BRepApprox_ApproxLine {
    constructor(lin: Handle_IntSurf_LineOn2S, theTang: Standard_Boolean);
  }

export declare class Handle_BRepApprox_ApproxLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepApprox_ApproxLine): void;
  get(): BRepApprox_ApproxLine;
  delete(): void;
}

  export declare class Handle_BRepApprox_ApproxLine_1 extends Handle_BRepApprox_ApproxLine {
    constructor();
  }

  export declare class Handle_BRepApprox_ApproxLine_2 extends Handle_BRepApprox_ApproxLine {
    constructor(thePtr: BRepApprox_ApproxLine);
  }

  export declare class Handle_BRepApprox_ApproxLine_3 extends Handle_BRepApprox_ApproxLine {
    constructor(theHandle: Handle_BRepApprox_ApproxLine);
  }

  export declare class Handle_BRepApprox_ApproxLine_4 extends Handle_BRepApprox_ApproxLine {
    constructor(theHandle: Handle_BRepApprox_ApproxLine);
  }

export declare class BRepApprox_MyGradientbisOfTheComputeLineOfApprox {
  constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepApprox_ParFunctionOfMyGradientbisOfTheComputeLineOfApprox extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class BRepApprox_MyGradientOfTheComputeLineBezierOfApprox {
  constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepApprox_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfApprox extends math_FunctionSetWithDerivatives {
  constructor(S1: BRepAdaptor_Surface, S2: BRepAdaptor_Surface)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  ComputeParameters(ChoixIso: IntImp_ConstIsoparametric, Param: TColStd_Array1OfReal, UVap: math_Vector, BornInf: math_Vector, BornSup: math_Vector, Tolerance: math_Vector): void;
  Root(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(UVap: math_Vector, Param: TColStd_Array1OfReal, BestChoix: IntImp_ConstIsoparametric): Standard_Boolean;
  Direction(): gp_Dir;
  DirectionOnS1(): gp_Dir2d;
  DirectionOnS2(): gp_Dir2d;
  AuxillarSurface1(): BRepAdaptor_Surface;
  AuxillarSurface2(): BRepAdaptor_Surface;
  delete(): void;
}

export declare class BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox extends math_FunctionSetWithDerivatives {
  Set_1(PS: BRepAdaptor_Surface): void;
  SetImplicitSurface(IS: IntSurf_Quadric): void;
  Set_2(Tolerance: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Tolerance(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(): Standard_Boolean;
  Direction3d(): gp_Vec;
  Direction2d(): gp_Dir2d;
  PSurface(): BRepAdaptor_Surface;
  ISurface(): IntSurf_Quadric;
  delete(): void;
}

  export declare class BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_1 extends BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox {
    constructor();
  }

  export declare class BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_2 extends BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox {
    constructor(PS: BRepAdaptor_Surface, IS: IntSurf_Quadric);
  }

  export declare class BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_3 extends BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox {
    constructor(IS: IntSurf_Quadric);
  }

export declare class BRepApprox_TheComputeLineOfApprox {
  Interpol(Line: BRepApprox_TheMultiLineOfApprox): void;
  Init(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean): void;
  Perform(Line: BRepApprox_TheMultiLineOfApprox): void;
  SetParameters(ThePar: math_Vector): void;
  SetKnots(Knots: TColStd_Array1OfReal): void;
  SetKnotsAndMultiplicities(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetContinuity(C: Graphic3d_ZLayerId): void;
  SetConstraints(firstC: AppParCurves_Constraint, lastC: AppParCurves_Constraint): void;
  SetPeriodic(thePeriodic: Standard_Boolean): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  Value(): AppParCurves_MultiBSpCurve;
  ChangeValue(): AppParCurves_MultiBSpCurve;
  Parameters_1(): TColStd_Array1OfReal;
  delete(): void;
}

  export declare class BRepApprox_TheComputeLineOfApprox_1 extends BRepApprox_TheComputeLineOfApprox {
    constructor(Line: BRepApprox_TheMultiLineOfApprox, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

  export declare class BRepApprox_TheComputeLineOfApprox_2 extends BRepApprox_TheComputeLineOfApprox {
    constructor(Line: BRepApprox_TheMultiLineOfApprox, Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class BRepApprox_TheComputeLineOfApprox_3 extends BRepApprox_TheComputeLineOfApprox {
    constructor(Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class BRepApprox_TheComputeLineOfApprox_4 extends BRepApprox_TheComputeLineOfApprox {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

export declare class BRepApprox_TheImpPrmSvSurfacesOfApprox extends ApproxInt_SvSurfaces {
  Compute(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Pt: gp_Pnt, Tg: gp_Vec, Tguv1: gp_Vec2d, Tguv2: gp_Vec2d): Standard_Boolean;
  Pnt(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, P: gp_Pnt): void;
  SeekPoint(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Point: IntSurf_PntOn2S): Standard_Boolean;
  Tangency(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec): Standard_Boolean;
  TangencyOnSurf1(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  TangencyOnSurf2(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  FillInitialVectorOfSolution(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, binfu: Quantity_AbsorbedDose, bsupu: Quantity_AbsorbedDose, binfv: Quantity_AbsorbedDose, bsupv: Quantity_AbsorbedDose, X: math_Vector, TranslationU: Quantity_AbsorbedDose, TranslationV: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class BRepApprox_TheImpPrmSvSurfacesOfApprox_1 extends BRepApprox_TheImpPrmSvSurfacesOfApprox {
    constructor(Surf1: BRepAdaptor_Surface, Surf2: IntSurf_Quadric);
  }

  export declare class BRepApprox_TheImpPrmSvSurfacesOfApprox_2 extends BRepApprox_TheImpPrmSvSurfacesOfApprox {
    constructor(Surf1: IntSurf_Quadric, Surf2: BRepAdaptor_Surface);
  }

export declare class BRepApprox_ParFunctionOfMyGradientOfTheComputeLineBezierOfApprox extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class BRepApprox_TheMultiLineOfApprox {
  FirstPoint(): Graphic3d_ZLayerId;
  LastPoint(): Graphic3d_ZLayerId;
  NbP2d(): Graphic3d_ZLayerId;
  NbP3d(): Graphic3d_ZLayerId;
  WhatStatus(): Approx_Status;
  Value_1(MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt): void;
  Value_2(MPointIndex: Graphic3d_ZLayerId, tabPt2d: TColgp_Array1OfPnt2d): void;
  Value_3(MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt, tabPt2d: TColgp_Array1OfPnt2d): void;
  Tangency_1(MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  Tangency_2(MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  Tangency_3(MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  MakeMLBetween(Low: Graphic3d_ZLayerId, High: Graphic3d_ZLayerId, NbPointsToInsert: Graphic3d_ZLayerId): BRepApprox_TheMultiLineOfApprox;
  MakeMLOneMorePoint(Low: Graphic3d_ZLayerId, High: Graphic3d_ZLayerId, indbad: Graphic3d_ZLayerId, OtherLine: BRepApprox_TheMultiLineOfApprox): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

  export declare class BRepApprox_TheMultiLineOfApprox_1 extends BRepApprox_TheMultiLineOfApprox {
    constructor();
  }

  export declare class BRepApprox_TheMultiLineOfApprox_2 extends BRepApprox_TheMultiLineOfApprox {
    constructor(line: Handle_BRepApprox_ApproxLine, PtrSvSurfaces: Standard_Address, NbP3d: Graphic3d_ZLayerId, NbP2d: Graphic3d_ZLayerId, ApproxU1V1: Standard_Boolean, ApproxU2V2: Standard_Boolean, xo: Quantity_AbsorbedDose, yo: Quantity_AbsorbedDose, zo: Quantity_AbsorbedDose, u1o: Quantity_AbsorbedDose, v1o: Quantity_AbsorbedDose, u2o: Quantity_AbsorbedDose, v2o: Quantity_AbsorbedDose, P2DOnFirst: Standard_Boolean, IndMin: Graphic3d_ZLayerId, IndMax: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_TheMultiLineOfApprox_3 extends BRepApprox_TheMultiLineOfApprox {
    constructor(line: Handle_BRepApprox_ApproxLine, NbP3d: Graphic3d_ZLayerId, NbP2d: Graphic3d_ZLayerId, ApproxU1V1: Standard_Boolean, ApproxU2V2: Standard_Boolean, xo: Quantity_AbsorbedDose, yo: Quantity_AbsorbedDose, zo: Quantity_AbsorbedDose, u1o: Quantity_AbsorbedDose, v1o: Quantity_AbsorbedDose, u2o: Quantity_AbsorbedDose, v2o: Quantity_AbsorbedDose, P2DOnFirst: Standard_Boolean, IndMin: Graphic3d_ZLayerId, IndMax: Graphic3d_ZLayerId);
  }

export declare class BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_1 extends BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_2 extends BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_3 extends BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_4 extends BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class BRepApprox_Gradient_BFGSOfMyGradientbisOfTheComputeLineOfApprox extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_1 extends BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_2 extends BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_3 extends BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_4 extends BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox {
    constructor(SSP: BRepApprox_TheMultiLineOfApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class BRepApprox_Gradient_BFGSOfMyGradientOfTheComputeLineBezierOfApprox extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class BRepApprox_TheComputeLineBezierOfApprox {
  Init(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean): void;
  Perform(Line: BRepApprox_TheMultiLineOfApprox): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetConstraints(firstC: AppParCurves_Constraint, lastC: AppParCurves_Constraint): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(Index: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  ChangeValue(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  SplineValue(): AppParCurves_MultiBSpCurve;
  Parametrization(): Approx_ParametrizationType;
  Parameters_1(Index: Graphic3d_ZLayerId): TColStd_Array1OfReal;
  delete(): void;
}

  export declare class BRepApprox_TheComputeLineBezierOfApprox_1 extends BRepApprox_TheComputeLineBezierOfApprox {
    constructor(Line: BRepApprox_TheMultiLineOfApprox, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

  export declare class BRepApprox_TheComputeLineBezierOfApprox_2 extends BRepApprox_TheComputeLineBezierOfApprox {
    constructor(Line: BRepApprox_TheMultiLineOfApprox, Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class BRepApprox_TheComputeLineBezierOfApprox_3 extends BRepApprox_TheComputeLineBezierOfApprox {
    constructor(Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class BRepApprox_TheComputeLineBezierOfApprox_4 extends BRepApprox_TheComputeLineBezierOfApprox {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

export declare class IntStart_SITopolTool extends Standard_Transient {
  Classify(P: gp_Pnt2d, Tol: Quantity_AbsorbedDose): TopAbs_State;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IntStart_SITopolTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntStart_SITopolTool): void;
  get(): IntStart_SITopolTool;
  delete(): void;
}

  export declare class Handle_IntStart_SITopolTool_1 extends Handle_IntStart_SITopolTool {
    constructor();
  }

  export declare class Handle_IntStart_SITopolTool_2 extends Handle_IntStart_SITopolTool {
    constructor(thePtr: IntStart_SITopolTool);
  }

  export declare class Handle_IntStart_SITopolTool_3 extends Handle_IntStart_SITopolTool {
    constructor(theHandle: Handle_IntStart_SITopolTool);
  }

  export declare class Handle_IntStart_SITopolTool_4 extends Handle_IntStart_SITopolTool {
    constructor(theHandle: Handle_IntStart_SITopolTool);
  }

export declare class Intf_InterferencePolygon2d extends Intf_Interference {
  Perform_1(Obje1: Intf_Polygon2d, Obje2: Intf_Polygon2d): void;
  Perform_2(Obje: Intf_Polygon2d): void;
  Pnt2dValue(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  delete(): void;
}

  export declare class Intf_InterferencePolygon2d_1 extends Intf_InterferencePolygon2d {
    constructor();
  }

  export declare class Intf_InterferencePolygon2d_2 extends Intf_InterferencePolygon2d {
    constructor(Obje1: Intf_Polygon2d, Obje2: Intf_Polygon2d);
  }

  export declare class Intf_InterferencePolygon2d_3 extends Intf_InterferencePolygon2d {
    constructor(Obje: Intf_Polygon2d);
  }

export declare type Intf_PIType = {
  Intf_EXTERNAL: {};
  Intf_FACE: {};
  Intf_EDGE: {};
  Intf_VERTEX: {};
}

export declare class Intf_Array1OfLin {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Lin): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Intf_Array1OfLin): Intf_Array1OfLin;
  Move(theOther: Intf_Array1OfLin): Intf_Array1OfLin;
  First(): gp_Lin;
  ChangeFirst(): gp_Lin;
  Last(): gp_Lin;
  ChangeLast(): gp_Lin;
  Value(theIndex: Standard_Integer): gp_Lin;
  ChangeValue(theIndex: Standard_Integer): gp_Lin;
  SetValue(theIndex: Standard_Integer, theItem: gp_Lin): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Intf_Array1OfLin_1 extends Intf_Array1OfLin {
    constructor();
  }

  export declare class Intf_Array1OfLin_2 extends Intf_Array1OfLin {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Intf_Array1OfLin_3 extends Intf_Array1OfLin {
    constructor(theOther: Intf_Array1OfLin);
  }

  export declare class Intf_Array1OfLin_4 extends Intf_Array1OfLin {
    constructor(theOther: Intf_Array1OfLin);
  }

  export declare class Intf_Array1OfLin_5 extends Intf_Array1OfLin {
    constructor(theBegin: gp_Lin, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Intf_SectionLine {
  NumberOfPoints(): Graphic3d_ZLayerId;
  GetPoint(Index: Graphic3d_ZLayerId): Intf_SectionPoint;
  IsClosed(): Standard_Boolean;
  Contains(ThePI: Intf_SectionPoint): Standard_Boolean;
  IsEnd(ThePI: Intf_SectionPoint): Graphic3d_ZLayerId;
  IsEqual(Other: Intf_SectionLine): Standard_Boolean;
  Append_1(Pi: Intf_SectionPoint): void;
  Append_2(LS: Intf_SectionLine): void;
  Prepend_1(Pi: Intf_SectionPoint): void;
  Prepend_2(LS: Intf_SectionLine): void;
  Reverse(): void;
  Close(): void;
  Dump(Indent: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Intf_SectionLine_1 extends Intf_SectionLine {
    constructor();
  }

  export declare class Intf_SectionLine_2 extends Intf_SectionLine {
    constructor(Other: Intf_SectionLine);
  }

export declare class Intf_Interference {
  NbSectionPoints(): Graphic3d_ZLayerId;
  PntValue(Index: Graphic3d_ZLayerId): Intf_SectionPoint;
  NbSectionLines(): Graphic3d_ZLayerId;
  LineValue(Index: Graphic3d_ZLayerId): Intf_SectionLine;
  NbTangentZones(): Graphic3d_ZLayerId;
  ZoneValue(Index: Graphic3d_ZLayerId): Intf_TangentZone;
  GetTolerance(): Quantity_AbsorbedDose;
  Contains(ThePnt: Intf_SectionPoint): Standard_Boolean;
  Insert_1(TheZone: Intf_TangentZone): Standard_Boolean;
  Insert_2(pdeb: Intf_SectionPoint, pfin: Intf_SectionPoint): void;
  Dump(): void;
  delete(): void;
}

export declare class Intf_Tool {
  constructor()
  Lin2dBox(theLin2d: gp_Lin2d, bounding: Bnd_Box2d, boxLin: Bnd_Box2d): void;
  Hypr2dBox(theHypr2d: gp_Hypr2d, bounding: Bnd_Box2d, boxHypr: Bnd_Box2d): void;
  Parab2dBox(theParab2d: gp_Parab2d, bounding: Bnd_Box2d, boxHypr: Bnd_Box2d): void;
  LinBox(theLin: gp_Lin, bounding: Bnd_Box, boxLin: Bnd_Box): void;
  HyprBox(theHypr: gp_Hypr, bounding: Bnd_Box, boxHypr: Bnd_Box): void;
  ParabBox(theParab: gp_Parab, bounding: Bnd_Box, boxHypr: Bnd_Box): void;
  NbSegments(): Graphic3d_ZLayerId;
  BeginParam(SegmentNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  EndParam(SegmentNum: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Intf_SeqOfSectionPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Intf_SeqOfSectionPoint): Intf_SeqOfSectionPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Intf_SectionPoint): void;
  Append_2(theSeq: Intf_SeqOfSectionPoint): void;
  Prepend_1(theItem: Intf_SectionPoint): void;
  Prepend_2(theSeq: Intf_SeqOfSectionPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Intf_SectionPoint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Intf_SeqOfSectionPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Intf_SeqOfSectionPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Intf_SectionPoint): void;
  Split(theIndex: Standard_Integer, theSeq: Intf_SeqOfSectionPoint): void;
  First(): Intf_SectionPoint;
  ChangeFirst(): Intf_SectionPoint;
  Last(): Intf_SectionPoint;
  ChangeLast(): Intf_SectionPoint;
  Value(theIndex: Standard_Integer): Intf_SectionPoint;
  ChangeValue(theIndex: Standard_Integer): Intf_SectionPoint;
  SetValue(theIndex: Standard_Integer, theItem: Intf_SectionPoint): void;
  delete(): void;
}

  export declare class Intf_SeqOfSectionPoint_1 extends Intf_SeqOfSectionPoint {
    constructor();
  }

  export declare class Intf_SeqOfSectionPoint_2 extends Intf_SeqOfSectionPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Intf_SeqOfSectionPoint_3 extends Intf_SeqOfSectionPoint {
    constructor(theOther: Intf_SeqOfSectionPoint);
  }

export declare class Intf_SeqOfTangentZone extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Intf_SeqOfTangentZone): Intf_SeqOfTangentZone;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Intf_TangentZone): void;
  Append_2(theSeq: Intf_SeqOfTangentZone): void;
  Prepend_1(theItem: Intf_TangentZone): void;
  Prepend_2(theSeq: Intf_SeqOfTangentZone): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Intf_TangentZone): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Intf_SeqOfTangentZone): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Intf_SeqOfTangentZone): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Intf_TangentZone): void;
  Split(theIndex: Standard_Integer, theSeq: Intf_SeqOfTangentZone): void;
  First(): Intf_TangentZone;
  ChangeFirst(): Intf_TangentZone;
  Last(): Intf_TangentZone;
  ChangeLast(): Intf_TangentZone;
  Value(theIndex: Standard_Integer): Intf_TangentZone;
  ChangeValue(theIndex: Standard_Integer): Intf_TangentZone;
  SetValue(theIndex: Standard_Integer, theItem: Intf_TangentZone): void;
  delete(): void;
}

  export declare class Intf_SeqOfTangentZone_1 extends Intf_SeqOfTangentZone {
    constructor();
  }

  export declare class Intf_SeqOfTangentZone_2 extends Intf_SeqOfTangentZone {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Intf_SeqOfTangentZone_3 extends Intf_SeqOfTangentZone {
    constructor(theOther: Intf_SeqOfTangentZone);
  }

export declare class Intf_TangentZone {
  constructor()
  NumberOfPoints(): Graphic3d_ZLayerId;
  GetPoint(Index: Graphic3d_ZLayerId): Intf_SectionPoint;
  IsEqual(Other: Intf_TangentZone): Standard_Boolean;
  Contains(ThePI: Intf_SectionPoint): Standard_Boolean;
  ParamOnFirst(paraMin: Quantity_AbsorbedDose, paraMax: Quantity_AbsorbedDose): void;
  ParamOnSecond(paraMin: Quantity_AbsorbedDose, paraMax: Quantity_AbsorbedDose): void;
  InfoFirst(segMin: Graphic3d_ZLayerId, paraMin: Quantity_AbsorbedDose, segMax: Graphic3d_ZLayerId, paraMax: Quantity_AbsorbedDose): void;
  InfoSecond(segMin: Graphic3d_ZLayerId, paraMin: Quantity_AbsorbedDose, segMax: Graphic3d_ZLayerId, paraMax: Quantity_AbsorbedDose): void;
  RangeContains(ThePI: Intf_SectionPoint): Standard_Boolean;
  HasCommonRange(Other: Intf_TangentZone): Standard_Boolean;
  Append_1(Pi: Intf_SectionPoint): void;
  Append_2(Tzi: Intf_TangentZone): void;
  Insert(Pi: Intf_SectionPoint): Standard_Boolean;
  PolygonInsert(Pi: Intf_SectionPoint): void;
  InsertBefore(Index: Graphic3d_ZLayerId, Pi: Intf_SectionPoint): void;
  InsertAfter(Index: Graphic3d_ZLayerId, Pi: Intf_SectionPoint): void;
  Dump(Indent: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Intf_SeqOfSectionLine extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Intf_SeqOfSectionLine): Intf_SeqOfSectionLine;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Intf_SectionLine): void;
  Append_2(theSeq: Intf_SeqOfSectionLine): void;
  Prepend_1(theItem: Intf_SectionLine): void;
  Prepend_2(theSeq: Intf_SeqOfSectionLine): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Intf_SectionLine): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Intf_SeqOfSectionLine): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Intf_SeqOfSectionLine): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Intf_SectionLine): void;
  Split(theIndex: Standard_Integer, theSeq: Intf_SeqOfSectionLine): void;
  First(): Intf_SectionLine;
  ChangeFirst(): Intf_SectionLine;
  Last(): Intf_SectionLine;
  ChangeLast(): Intf_SectionLine;
  Value(theIndex: Standard_Integer): Intf_SectionLine;
  ChangeValue(theIndex: Standard_Integer): Intf_SectionLine;
  SetValue(theIndex: Standard_Integer, theItem: Intf_SectionLine): void;
  delete(): void;
}

  export declare class Intf_SeqOfSectionLine_1 extends Intf_SeqOfSectionLine {
    constructor();
  }

  export declare class Intf_SeqOfSectionLine_2 extends Intf_SeqOfSectionLine {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Intf_SeqOfSectionLine_3 extends Intf_SeqOfSectionLine {
    constructor(theOther: Intf_SeqOfSectionLine);
  }

export declare class Intf_SectionPoint {
  Pnt(): gp_Pnt;
  ParamOnFirst(): Quantity_AbsorbedDose;
  ParamOnSecond(): Quantity_AbsorbedDose;
  TypeOnFirst(): Intf_PIType;
  TypeOnSecond(): Intf_PIType;
  InfoFirst_1(Dim: Intf_PIType, Add1: Graphic3d_ZLayerId, Add2: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  InfoFirst_2(Dim: Intf_PIType, Addr: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  InfoSecond_1(Dim: Intf_PIType, Add1: Graphic3d_ZLayerId, Add2: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  InfoSecond_2(Dim: Intf_PIType, Addr: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  Incidence(): Quantity_AbsorbedDose;
  IsEqual(Other: Intf_SectionPoint): Standard_Boolean;
  IsOnSameEdge(Other: Intf_SectionPoint): Standard_Boolean;
  Merge(Other: Intf_SectionPoint): void;
  Dump(Indent: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Intf_SectionPoint_1 extends Intf_SectionPoint {
    constructor();
  }

  export declare class Intf_SectionPoint_2 extends Intf_SectionPoint {
    constructor(Where: gp_Pnt, DimeO: Intf_PIType, AddrO1: Graphic3d_ZLayerId, AddrO2: Graphic3d_ZLayerId, ParamO: Quantity_AbsorbedDose, DimeT: Intf_PIType, AddrT1: Graphic3d_ZLayerId, AddrT2: Graphic3d_ZLayerId, ParamT: Quantity_AbsorbedDose, Incid: Quantity_AbsorbedDose);
  }

  export declare class Intf_SectionPoint_3 extends Intf_SectionPoint {
    constructor(Where: gp_Pnt2d, DimeO: Intf_PIType, AddrO1: Graphic3d_ZLayerId, ParamO: Quantity_AbsorbedDose, DimeT: Intf_PIType, AddrT1: Graphic3d_ZLayerId, ParamT: Quantity_AbsorbedDose, Incid: Quantity_AbsorbedDose);
  }

export declare class Intf {
  constructor();
  static PlaneEquation(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, NormalVector: gp_XYZ, PolarDistance: Quantity_AbsorbedDose): void;
  static Contain(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, ThePnt: gp_Pnt): Standard_Boolean;
  delete(): void;
}

export declare class Intf_Polygon2d {
  Bounding(): Bnd_Box2d;
  Closed(): Standard_Boolean;
  DeflectionOverEstimation(): Quantity_AbsorbedDose;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(theIndex: Graphic3d_ZLayerId, theBegin: gp_Pnt2d, theEnd: gp_Pnt2d): void;
  delete(): void;
}

export declare class Handle_APIHeaderSection_EditHeader {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: APIHeaderSection_EditHeader): void;
  get(): APIHeaderSection_EditHeader;
  delete(): void;
}

  export declare class Handle_APIHeaderSection_EditHeader_1 extends Handle_APIHeaderSection_EditHeader {
    constructor();
  }

  export declare class Handle_APIHeaderSection_EditHeader_2 extends Handle_APIHeaderSection_EditHeader {
    constructor(thePtr: APIHeaderSection_EditHeader);
  }

  export declare class Handle_APIHeaderSection_EditHeader_3 extends Handle_APIHeaderSection_EditHeader {
    constructor(theHandle: Handle_APIHeaderSection_EditHeader);
  }

  export declare class Handle_APIHeaderSection_EditHeader_4 extends Handle_APIHeaderSection_EditHeader {
    constructor(theHandle: Handle_APIHeaderSection_EditHeader);
  }

export declare class APIHeaderSection_EditHeader extends IFSelect_Editor {
  constructor()
  Label(): XCAFDoc_PartId;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class APIHeaderSection_MakeHeader {
  Init(nameval: Standard_CString): void;
  IsDone(): Standard_Boolean;
  Apply(model: Handle_StepData_StepModel): void;
  NewModel(protocol: Handle_Interface_Protocol): Handle_StepData_StepModel;
  HasFn(): Standard_Boolean;
  FnValue(): Handle_HeaderSection_FileName;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetTimeStamp(aTimeStamp: Handle_TCollection_HAsciiString): void;
  TimeStamp(): Handle_TCollection_HAsciiString;
  SetAuthor(aAuthor: Handle_Interface_HArray1OfHAsciiString): void;
  SetAuthorValue(num: Graphic3d_ZLayerId, aAuthor: Handle_TCollection_HAsciiString): void;
  Author(): Handle_Interface_HArray1OfHAsciiString;
  AuthorValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbAuthor(): Graphic3d_ZLayerId;
  SetOrganization(aOrganization: Handle_Interface_HArray1OfHAsciiString): void;
  SetOrganizationValue(num: Graphic3d_ZLayerId, aOrganization: Handle_TCollection_HAsciiString): void;
  Organization(): Handle_Interface_HArray1OfHAsciiString;
  OrganizationValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbOrganization(): Graphic3d_ZLayerId;
  SetPreprocessorVersion(aPreprocessorVersion: Handle_TCollection_HAsciiString): void;
  PreprocessorVersion(): Handle_TCollection_HAsciiString;
  SetOriginatingSystem(aOriginatingSystem: Handle_TCollection_HAsciiString): void;
  OriginatingSystem(): Handle_TCollection_HAsciiString;
  SetAuthorisation(aAuthorisation: Handle_TCollection_HAsciiString): void;
  Authorisation(): Handle_TCollection_HAsciiString;
  HasFs(): Standard_Boolean;
  FsValue(): Handle_HeaderSection_FileSchema;
  SetSchemaIdentifiers(aSchemaIdentifiers: Handle_Interface_HArray1OfHAsciiString): void;
  SetSchemaIdentifiersValue(num: Graphic3d_ZLayerId, aSchemaIdentifier: Handle_TCollection_HAsciiString): void;
  SchemaIdentifiers(): Handle_Interface_HArray1OfHAsciiString;
  SchemaIdentifiersValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbSchemaIdentifiers(): Graphic3d_ZLayerId;
  AddSchemaIdentifier(aSchemaIdentifier: Handle_TCollection_HAsciiString): void;
  HasFd(): Standard_Boolean;
  FdValue(): Handle_HeaderSection_FileDescription;
  SetDescription(aDescription: Handle_Interface_HArray1OfHAsciiString): void;
  SetDescriptionValue(num: Graphic3d_ZLayerId, aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_Interface_HArray1OfHAsciiString;
  DescriptionValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NbDescription(): Graphic3d_ZLayerId;
  SetImplementationLevel(aImplementationLevel: Handle_TCollection_HAsciiString): void;
  ImplementationLevel(): Handle_TCollection_HAsciiString;
  delete(): void;
}

  export declare class APIHeaderSection_MakeHeader_1 extends APIHeaderSection_MakeHeader {
    constructor(shapetype: Graphic3d_ZLayerId);
  }

  export declare class APIHeaderSection_MakeHeader_2 extends APIHeaderSection_MakeHeader {
    constructor(model: Handle_StepData_StepModel);
  }

export declare class BRepIntCurveSurface_Inter {
  constructor()
  Init_1(theShape: TopoDS_Shape, theCurve: GeomAdaptor_Curve, theTol: Quantity_AbsorbedDose): void;
  Init_2(theShape: TopoDS_Shape, theLine: gp_Lin, theTol: Quantity_AbsorbedDose): void;
  Load(theShape: TopoDS_Shape, theTol: Quantity_AbsorbedDose): void;
  Init_3(theCurve: GeomAdaptor_Curve): void;
  More(): Standard_Boolean;
  Next(): void;
  Point(): IntCurveSurface_IntersectionPoint;
  Pnt(): gp_Pnt;
  U(): Quantity_AbsorbedDose;
  V(): Quantity_AbsorbedDose;
  W(): Quantity_AbsorbedDose;
  State(): TopAbs_State;
  Transition(): IntCurveSurface_TransitionOnCurve;
  Face(): TopoDS_Face;
  delete(): void;
}

export declare class GProp_PGProps extends GProp_GProps {
  AddPoint_1(P: gp_Pnt): void;
  AddPoint_2(P: gp_Pnt, Density: Quantity_AbsorbedDose): void;
  static Barycentre_1(Pnts: TColgp_Array1OfPnt): gp_Pnt;
  static Barycentre_2(Pnts: TColgp_Array2OfPnt): gp_Pnt;
  static Barycentre_3(Pnts: TColgp_Array1OfPnt, Density: TColStd_Array1OfReal, Mass: Quantity_AbsorbedDose, G: gp_Pnt): void;
  static Barycentre_4(Pnts: TColgp_Array2OfPnt, Density: TColStd_Array2OfReal, Mass: Quantity_AbsorbedDose, G: gp_Pnt): void;
  delete(): void;
}

  export declare class GProp_PGProps_1 extends GProp_PGProps {
    constructor();
  }

  export declare class GProp_PGProps_2 extends GProp_PGProps {
    constructor(Pnts: TColgp_Array1OfPnt);
  }

  export declare class GProp_PGProps_3 extends GProp_PGProps {
    constructor(Pnts: TColgp_Array2OfPnt);
  }

  export declare class GProp_PGProps_4 extends GProp_PGProps {
    constructor(Pnts: TColgp_Array1OfPnt, Density: TColStd_Array1OfReal);
  }

  export declare class GProp_PGProps_5 extends GProp_PGProps {
    constructor(Pnts: TColgp_Array2OfPnt, Density: TColStd_Array2OfReal);
  }

export declare type GProp_EquaType = {
  GProp_Plane: {};
  GProp_Line: {};
  GProp_Point: {};
  GProp_Space: {};
  GProp_None: {};
}

export declare type GProp_ValueType = {
  GProp_Mass: {};
  GProp_CenterMassX: {};
  GProp_CenterMassY: {};
  GProp_CenterMassZ: {};
  GProp_InertiaXX: {};
  GProp_InertiaYY: {};
  GProp_InertiaZZ: {};
  GProp_InertiaXY: {};
  GProp_InertiaXZ: {};
  GProp_InertiaYZ: {};
  GProp_Unknown: {};
}

export declare class GProp {
  constructor();
  static HOperator(G: gp_Pnt, Q: gp_Pnt, Mass: Quantity_AbsorbedDose, Operator: gp_Mat): void;
  delete(): void;
}

export declare class GProp_GProps {
  Add(Item: GProp_GProps, Density: Quantity_AbsorbedDose): void;
  Mass(): Quantity_AbsorbedDose;
  CentreOfMass(): gp_Pnt;
  MatrixOfInertia(): gp_Mat;
  StaticMoments(Ix: Quantity_AbsorbedDose, Iy: Quantity_AbsorbedDose, Iz: Quantity_AbsorbedDose): void;
  MomentOfInertia(A: gp_Ax1): Quantity_AbsorbedDose;
  PrincipalProperties(): GProp_PrincipalProps;
  RadiusOfGyration(A: gp_Ax1): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GProp_GProps_1 extends GProp_GProps {
    constructor();
  }

  export declare class GProp_GProps_2 extends GProp_GProps {
    constructor(SystemLocation: gp_Pnt);
  }

export declare class GProp_CelGProps extends GProp_GProps {
  SetLocation(CLocation: gp_Pnt): void;
  Perform_1(C: gp_Circ, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  Perform_2(C: gp_Lin, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class GProp_CelGProps_1 extends GProp_CelGProps {
    constructor();
  }

  export declare class GProp_CelGProps_2 extends GProp_CelGProps {
    constructor(C: gp_Circ, CLocation: gp_Pnt);
  }

  export declare class GProp_CelGProps_3 extends GProp_CelGProps {
    constructor(C: gp_Circ, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, CLocation: gp_Pnt);
  }

  export declare class GProp_CelGProps_4 extends GProp_CelGProps {
    constructor(C: gp_Lin, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, CLocation: gp_Pnt);
  }

export declare class GProp_VelGProps extends GProp_GProps {
  SetLocation(VLocation: gp_Pnt): void;
  Perform_1(S: gp_Cylinder, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose): void;
  Perform_2(S: gp_Cone, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose): void;
  Perform_3(S: gp_Sphere, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose): void;
  Perform_4(S: gp_Torus, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class GProp_VelGProps_1 extends GProp_VelGProps {
    constructor();
  }

  export declare class GProp_VelGProps_2 extends GProp_VelGProps {
    constructor(S: gp_Cylinder, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, VLocation: gp_Pnt);
  }

  export declare class GProp_VelGProps_3 extends GProp_VelGProps {
    constructor(S: gp_Cone, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, VLocation: gp_Pnt);
  }

  export declare class GProp_VelGProps_4 extends GProp_VelGProps {
    constructor(S: gp_Sphere, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, VLocation: gp_Pnt);
  }

  export declare class GProp_VelGProps_5 extends GProp_VelGProps {
    constructor(S: gp_Torus, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, VLocation: gp_Pnt);
  }

export declare class Handle_GProp_UndefinedAxis {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GProp_UndefinedAxis): void;
  get(): GProp_UndefinedAxis;
  delete(): void;
}

  export declare class Handle_GProp_UndefinedAxis_1 extends Handle_GProp_UndefinedAxis {
    constructor();
  }

  export declare class Handle_GProp_UndefinedAxis_2 extends Handle_GProp_UndefinedAxis {
    constructor(thePtr: GProp_UndefinedAxis);
  }

  export declare class Handle_GProp_UndefinedAxis_3 extends Handle_GProp_UndefinedAxis {
    constructor(theHandle: Handle_GProp_UndefinedAxis);
  }

  export declare class Handle_GProp_UndefinedAxis_4 extends Handle_GProp_UndefinedAxis {
    constructor(theHandle: Handle_GProp_UndefinedAxis);
  }

export declare class GProp_UndefinedAxis extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_GProp_UndefinedAxis;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GProp_UndefinedAxis_1 extends GProp_UndefinedAxis {
    constructor();
  }

  export declare class GProp_UndefinedAxis_2 extends GProp_UndefinedAxis {
    constructor(theMessage: Standard_CString);
  }

export declare class GProp_PEquation {
  constructor(Pnts: TColgp_Array1OfPnt, Tol: Quantity_AbsorbedDose)
  IsPlanar(): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  IsPoint(): Standard_Boolean;
  IsSpace(): Standard_Boolean;
  Plane(): gp_Pln;
  Line(): gp_Lin;
  Point(): gp_Pnt;
  Box(P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  delete(): void;
}

export declare class GProp_SelGProps extends GProp_GProps {
  SetLocation(SLocation: gp_Pnt): void;
  Perform_1(S: gp_Cylinder, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose): void;
  Perform_2(S: gp_Cone, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose): void;
  Perform_3(S: gp_Sphere, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose): void;
  Perform_4(S: gp_Torus, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class GProp_SelGProps_1 extends GProp_SelGProps {
    constructor();
  }

  export declare class GProp_SelGProps_2 extends GProp_SelGProps {
    constructor(S: gp_Cylinder, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, SLocation: gp_Pnt);
  }

  export declare class GProp_SelGProps_3 extends GProp_SelGProps {
    constructor(S: gp_Cone, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Z1: Quantity_AbsorbedDose, Z2: Quantity_AbsorbedDose, SLocation: gp_Pnt);
  }

  export declare class GProp_SelGProps_4 extends GProp_SelGProps {
    constructor(S: gp_Sphere, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, SLocation: gp_Pnt);
  }

  export declare class GProp_SelGProps_5 extends GProp_SelGProps {
    constructor(S: gp_Torus, Teta1: Quantity_AbsorbedDose, Teta2: Quantity_AbsorbedDose, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, SLocation: gp_Pnt);
  }

export declare class GProp_PrincipalProps {
  constructor()
  HasSymmetryAxis_1(): Standard_Boolean;
  HasSymmetryAxis_2(aTol: Quantity_AbsorbedDose): Standard_Boolean;
  HasSymmetryPoint_1(): Standard_Boolean;
  HasSymmetryPoint_2(aTol: Quantity_AbsorbedDose): Standard_Boolean;
  Moments(Ixx: Quantity_AbsorbedDose, Iyy: Quantity_AbsorbedDose, Izz: Quantity_AbsorbedDose): void;
  FirstAxisOfInertia(): gp_Vec;
  SecondAxisOfInertia(): gp_Vec;
  ThirdAxisOfInertia(): gp_Vec;
  RadiusOfGyration(Rxx: Quantity_AbsorbedDose, Ryy: Quantity_AbsorbedDose, Rzz: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GCE2d_MakeSegment extends GCE2d_Root {
  Value(): Handle_Geom2d_TrimmedCurve;
  delete(): void;
}

  export declare class GCE2d_MakeSegment_1 extends GCE2d_MakeSegment {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

  export declare class GCE2d_MakeSegment_2 extends GCE2d_MakeSegment {
    constructor(P1: gp_Pnt2d, V: gp_Dir2d, P2: gp_Pnt2d);
  }

  export declare class GCE2d_MakeSegment_3 extends GCE2d_MakeSegment {
    constructor(Line: gp_Lin2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeSegment_4 extends GCE2d_MakeSegment {
    constructor(Line: gp_Lin2d, Point: gp_Pnt2d, Ulast: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeSegment_5 extends GCE2d_MakeSegment {
    constructor(Line: gp_Lin2d, P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

export declare class GCE2d_MakeEllipse extends GCE2d_Root {
  Value(): Handle_Geom2d_Ellipse;
  delete(): void;
}

  export declare class GCE2d_MakeEllipse_1 extends GCE2d_MakeEllipse {
    constructor(E: gp_Elips2d);
  }

  export declare class GCE2d_MakeEllipse_2 extends GCE2d_MakeEllipse {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeEllipse_3 extends GCE2d_MakeEllipse {
    constructor(Axis: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeEllipse_4 extends GCE2d_MakeEllipse {
    constructor(S1: gp_Pnt2d, S2: gp_Pnt2d, Center: gp_Pnt2d);
  }

export declare class GCE2d_MakeHyperbola extends GCE2d_Root {
  Value(): Handle_Geom2d_Hyperbola;
  delete(): void;
}

  export declare class GCE2d_MakeHyperbola_1 extends GCE2d_MakeHyperbola {
    constructor(H: gp_Hypr2d);
  }

  export declare class GCE2d_MakeHyperbola_2 extends GCE2d_MakeHyperbola {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeHyperbola_3 extends GCE2d_MakeHyperbola {
    constructor(Axis: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeHyperbola_4 extends GCE2d_MakeHyperbola {
    constructor(S1: gp_Pnt2d, S2: gp_Pnt2d, Center: gp_Pnt2d);
  }

export declare class GCE2d_MakeLine extends GCE2d_Root {
  Value(): Handle_Geom2d_Line;
  delete(): void;
}

  export declare class GCE2d_MakeLine_1 extends GCE2d_MakeLine {
    constructor(A: gp_Ax2d);
  }

  export declare class GCE2d_MakeLine_2 extends GCE2d_MakeLine {
    constructor(L: gp_Lin2d);
  }

  export declare class GCE2d_MakeLine_3 extends GCE2d_MakeLine {
    constructor(P: gp_Pnt2d, V: gp_Dir2d);
  }

  export declare class GCE2d_MakeLine_4 extends GCE2d_MakeLine {
    constructor(Lin: gp_Lin2d, Point: gp_Pnt2d);
  }

  export declare class GCE2d_MakeLine_5 extends GCE2d_MakeLine {
    constructor(Lin: gp_Lin2d, Dist: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeLine_6 extends GCE2d_MakeLine {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

export declare class GCE2d_MakeArcOfCircle extends GCE2d_Root {
  Value(): Handle_Geom2d_TrimmedCurve;
  delete(): void;
}

  export declare class GCE2d_MakeArcOfCircle_1 extends GCE2d_MakeArcOfCircle {
    constructor(Circ: gp_Circ2d, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfCircle_2 extends GCE2d_MakeArcOfCircle {
    constructor(Circ: gp_Circ2d, P: gp_Pnt2d, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfCircle_3 extends GCE2d_MakeArcOfCircle {
    constructor(Circ: gp_Circ2d, P1: gp_Pnt2d, P2: gp_Pnt2d, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfCircle_4 extends GCE2d_MakeArcOfCircle {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d, P3: gp_Pnt2d);
  }

  export declare class GCE2d_MakeArcOfCircle_5 extends GCE2d_MakeArcOfCircle {
    constructor(P1: gp_Pnt2d, V: gp_Vec2d, P2: gp_Pnt2d);
  }

export declare class GCE2d_MakeRotation {
  constructor(Point: gp_Pnt2d, Angle: Quantity_AbsorbedDose)
  Value(): Handle_Geom2d_Transformation;
  delete(): void;
}

export declare class GCE2d_MakeParabola extends GCE2d_Root {
  Value(): Handle_Geom2d_Parabola;
  delete(): void;
}

  export declare class GCE2d_MakeParabola_1 extends GCE2d_MakeParabola {
    constructor(Prb: gp_Parab2d);
  }

  export declare class GCE2d_MakeParabola_2 extends GCE2d_MakeParabola {
    constructor(Axis: gp_Ax22d, Focal: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeParabola_3 extends GCE2d_MakeParabola {
    constructor(MirrorAxis: gp_Ax2d, Focal: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeParabola_4 extends GCE2d_MakeParabola {
    constructor(D: gp_Ax2d, F: gp_Pnt2d, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeParabola_5 extends GCE2d_MakeParabola {
    constructor(S1: gp_Pnt2d, O: gp_Pnt2d);
  }

export declare class GCE2d_MakeTranslation {
  Value(): Handle_Geom2d_Transformation;
  delete(): void;
}

  export declare class GCE2d_MakeTranslation_1 extends GCE2d_MakeTranslation {
    constructor(Vect: gp_Vec2d);
  }

  export declare class GCE2d_MakeTranslation_2 extends GCE2d_MakeTranslation {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d);
  }

export declare class GCE2d_MakeArcOfHyperbola extends GCE2d_Root {
  Value(): Handle_Geom2d_TrimmedCurve;
  delete(): void;
}

  export declare class GCE2d_MakeArcOfHyperbola_1 extends GCE2d_MakeArcOfHyperbola {
    constructor(Hypr: gp_Hypr2d, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfHyperbola_2 extends GCE2d_MakeArcOfHyperbola {
    constructor(Hypr: gp_Hypr2d, P: gp_Pnt2d, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfHyperbola_3 extends GCE2d_MakeArcOfHyperbola {
    constructor(Hypr: gp_Hypr2d, P1: gp_Pnt2d, P2: gp_Pnt2d, Sense: Standard_Boolean);
  }

export declare class GCE2d_MakeCircle extends GCE2d_Root {
  Value(): Handle_Geom2d_Circle;
  delete(): void;
}

  export declare class GCE2d_MakeCircle_1 extends GCE2d_MakeCircle {
    constructor(C: gp_Circ2d);
  }

  export declare class GCE2d_MakeCircle_2 extends GCE2d_MakeCircle {
    constructor(A: gp_Ax2d, Radius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeCircle_3 extends GCE2d_MakeCircle {
    constructor(A: gp_Ax22d, Radius: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeCircle_4 extends GCE2d_MakeCircle {
    constructor(Circ: gp_Circ2d, Dist: Quantity_AbsorbedDose);
  }

  export declare class GCE2d_MakeCircle_5 extends GCE2d_MakeCircle {
    constructor(Circ: gp_Circ2d, Point: gp_Pnt2d);
  }

  export declare class GCE2d_MakeCircle_6 extends GCE2d_MakeCircle {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d, P3: gp_Pnt2d);
  }

  export declare class GCE2d_MakeCircle_7 extends GCE2d_MakeCircle {
    constructor(P: gp_Pnt2d, Radius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeCircle_8 extends GCE2d_MakeCircle {
    constructor(Center: gp_Pnt2d, Point: gp_Pnt2d, Sense: Standard_Boolean);
  }

export declare class GCE2d_MakeArcOfParabola extends GCE2d_Root {
  Value(): Handle_Geom2d_TrimmedCurve;
  delete(): void;
}

  export declare class GCE2d_MakeArcOfParabola_1 extends GCE2d_MakeArcOfParabola {
    constructor(Parab: gp_Parab2d, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfParabola_2 extends GCE2d_MakeArcOfParabola {
    constructor(Parab: gp_Parab2d, P: gp_Pnt2d, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfParabola_3 extends GCE2d_MakeArcOfParabola {
    constructor(Parab: gp_Parab2d, P1: gp_Pnt2d, P2: gp_Pnt2d, Sense: Standard_Boolean);
  }

export declare class GCE2d_MakeArcOfEllipse extends GCE2d_Root {
  Value(): Handle_Geom2d_TrimmedCurve;
  delete(): void;
}

  export declare class GCE2d_MakeArcOfEllipse_1 extends GCE2d_MakeArcOfEllipse {
    constructor(Elips: gp_Elips2d, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfEllipse_2 extends GCE2d_MakeArcOfEllipse {
    constructor(Elips: gp_Elips2d, P: gp_Pnt2d, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GCE2d_MakeArcOfEllipse_3 extends GCE2d_MakeArcOfEllipse {
    constructor(Elips: gp_Elips2d, P1: gp_Pnt2d, P2: gp_Pnt2d, Sense: Standard_Boolean);
  }

export declare class GCE2d_MakeScale {
  constructor(Point: gp_Pnt2d, Scale: Quantity_AbsorbedDose)
  Value(): Handle_Geom2d_Transformation;
  delete(): void;
}

export declare class GCE2d_MakeMirror {
  Value(): Handle_Geom2d_Transformation;
  delete(): void;
}

  export declare class GCE2d_MakeMirror_1 extends GCE2d_MakeMirror {
    constructor(Point: gp_Pnt2d);
  }

  export declare class GCE2d_MakeMirror_2 extends GCE2d_MakeMirror {
    constructor(Axis: gp_Ax2d);
  }

  export declare class GCE2d_MakeMirror_3 extends GCE2d_MakeMirror {
    constructor(Line: gp_Lin2d);
  }

  export declare class GCE2d_MakeMirror_4 extends GCE2d_MakeMirror {
    constructor(Point: gp_Pnt2d, Direc: gp_Dir2d);
  }

export declare class GCE2d_Root {
  constructor();
  IsDone(): Standard_Boolean;
  Status(): gce_ErrorType;
  delete(): void;
}

export declare class StepToTopoDS {
  constructor();
  static DecodeBuilderError(Error: StepToTopoDS_BuilderError): Handle_TCollection_HAsciiString;
  static DecodeShellError(Error: StepToTopoDS_TranslateShellError): Handle_TCollection_HAsciiString;
  static DecodeFaceError(Error: StepToTopoDS_TranslateFaceError): Handle_TCollection_HAsciiString;
  static DecodeEdgeError(Error: StepToTopoDS_TranslateEdgeError): Handle_TCollection_HAsciiString;
  static DecodeVertexError(Error: StepToTopoDS_TranslateVertexError): Handle_TCollection_HAsciiString;
  static DecodeVertexLoopError(Error: StepToTopoDS_TranslateVertexLoopError): Handle_TCollection_HAsciiString;
  static DecodePolyLoopError(Error: StepToTopoDS_TranslatePolyLoopError): Handle_TCollection_HAsciiString;
  static DecodeGeometricToolError(Error: StepToTopoDS_GeometricToolError): Standard_CString;
  delete(): void;
}

export declare class StepToTopoDS_PointPair {
  constructor(P1: Handle_StepGeom_CartesianPoint, P2: Handle_StepGeom_CartesianPoint)
  delete(): void;
}

export declare type StepToTopoDS_TranslateFaceError = {
  StepToTopoDS_TranslateFaceDone: {};
  StepToTopoDS_TranslateFaceOther: {};
}

export declare class StepToTopoDS_CartesianPointHasher {
  constructor();
  static HashCode(theCartesianPoint: Handle_StepGeom_CartesianPoint, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(K1: Handle_StepGeom_CartesianPoint, K2: Handle_StepGeom_CartesianPoint): Standard_Boolean;
  delete(): void;
}

export declare class StepToTopoDS_PointEdgeMap extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: StepToTopoDS_PointEdgeMap): void;
  Assign(theOther: StepToTopoDS_PointEdgeMap): StepToTopoDS_PointEdgeMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: StepToTopoDS_PointPair, theItem: TopoDS_Edge): Standard_Boolean;
  Bound(theKey: StepToTopoDS_PointPair, theItem: TopoDS_Edge): TopoDS_Edge;
  IsBound(theKey: StepToTopoDS_PointPair): Standard_Boolean;
  UnBind(theKey: StepToTopoDS_PointPair): Standard_Boolean;
  Seek(theKey: StepToTopoDS_PointPair): TopoDS_Edge;
  ChangeSeek(theKey: StepToTopoDS_PointPair): TopoDS_Edge;
  ChangeFind(theKey: StepToTopoDS_PointPair): TopoDS_Edge;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class StepToTopoDS_PointEdgeMap_1 extends StepToTopoDS_PointEdgeMap {
    constructor();
  }

  export declare class StepToTopoDS_PointEdgeMap_2 extends StepToTopoDS_PointEdgeMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class StepToTopoDS_PointEdgeMap_3 extends StepToTopoDS_PointEdgeMap {
    constructor(theOther: StepToTopoDS_PointEdgeMap);
  }

export declare class StepToTopoDS_TranslateEdge extends StepToTopoDS_Root {
  Init(E: Handle_StepShape_Edge, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool): void;
  MakeFromCurve3D(C3D: Handle_StepGeom_Curve, EC: Handle_StepShape_EdgeCurve, Vend: Handle_StepShape_Vertex, preci: Quantity_AbsorbedDose, E: TopoDS_Edge, V1: TopoDS_Vertex, V2: TopoDS_Vertex, T: StepToTopoDS_Tool): void;
  MakePCurve(PCU: Handle_StepGeom_Pcurve, ConvSurf: Handle_Geom_Surface): Handle_Geom2d_Curve;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslateEdgeError;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateEdge_1 extends StepToTopoDS_TranslateEdge {
    constructor();
  }

  export declare class StepToTopoDS_TranslateEdge_2 extends StepToTopoDS_TranslateEdge {
    constructor(E: Handle_StepShape_Edge, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool);
  }

export declare class StepToTopoDS_TranslateFace extends StepToTopoDS_Root {
  Init(FS: Handle_StepShape_FaceSurface, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslateFaceError;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateFace_1 extends StepToTopoDS_TranslateFace {
    constructor();
  }

  export declare class StepToTopoDS_TranslateFace_2 extends StepToTopoDS_TranslateFace {
    constructor(FS: Handle_StepShape_FaceSurface, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool);
  }

export declare type StepToTopoDS_TranslateShellError = {
  StepToTopoDS_TranslateShellDone: {};
  StepToTopoDS_TranslateShellOther: {};
}

export declare class StepToTopoDS_DataMapOfRINames extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: StepToTopoDS_DataMapOfRINames): void;
  Assign(theOther: StepToTopoDS_DataMapOfRINames): StepToTopoDS_DataMapOfRINames;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_AsciiString, theItem: TopoDS_Shape): Standard_Boolean;
  Bound(theKey: TCollection_AsciiString, theItem: TopoDS_Shape): TopoDS_Shape;
  IsBound(theKey: TCollection_AsciiString): Standard_Boolean;
  UnBind(theKey: TCollection_AsciiString): Standard_Boolean;
  Seek(theKey: TCollection_AsciiString): TopoDS_Shape;
  ChangeSeek(theKey: TCollection_AsciiString): TopoDS_Shape;
  ChangeFind(theKey: TCollection_AsciiString): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class StepToTopoDS_DataMapOfRINames_1 extends StepToTopoDS_DataMapOfRINames {
    constructor();
  }

  export declare class StepToTopoDS_DataMapOfRINames_2 extends StepToTopoDS_DataMapOfRINames {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class StepToTopoDS_DataMapOfRINames_3 extends StepToTopoDS_DataMapOfRINames {
    constructor(theOther: StepToTopoDS_DataMapOfRINames);
  }

export declare type StepToTopoDS_TranslateVertexError = {
  StepToTopoDS_TranslateVertexDone: {};
  StepToTopoDS_TranslateVertexOther: {};
}

export declare class StepToTopoDS_MakeTransformed extends StepToTopoDS_Root {
  constructor()
  Compute_1(Origin: Handle_StepGeom_Axis2Placement3d, Target: Handle_StepGeom_Axis2Placement3d): Standard_Boolean;
  Compute_2(Operator: Handle_StepGeom_CartesianTransformationOperator3d): Standard_Boolean;
  Transformation(): gp_Trsf;
  Transform(shape: TopoDS_Shape): Standard_Boolean;
  TranslateMappedItem(mapit: Handle_StepRepr_MappedItem, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): TopoDS_Shape;
  delete(): void;
}

export declare class StepToTopoDS_TranslateShell extends StepToTopoDS_Root {
  constructor()
  Init(CFS: Handle_StepShape_ConnectedFaceSet, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool, theProgress: Message_ProgressRange): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslateShellError;
  delete(): void;
}

export declare class StepToTopoDS_PointPairHasher {
  constructor();
  static HashCode(thePointPair: StepToTopoDS_PointPair, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(K1: StepToTopoDS_PointPair, K2: StepToTopoDS_PointPair): Standard_Boolean;
  delete(): void;
}

export declare class StepToTopoDS_TranslateCompositeCurve extends StepToTopoDS_Root {
  Init_1(CC: Handle_StepGeom_CompositeCurve, TP: Handle_Transfer_TransientProcess): Standard_Boolean;
  Init_2(CC: Handle_StepGeom_CompositeCurve, TP: Handle_Transfer_TransientProcess, S: Handle_StepGeom_Surface, Surf: Handle_Geom_Surface): Standard_Boolean;
  Value(): TopoDS_Wire;
  IsInfiniteSegment(): Standard_Boolean;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateCompositeCurve_1 extends StepToTopoDS_TranslateCompositeCurve {
    constructor();
  }

  export declare class StepToTopoDS_TranslateCompositeCurve_2 extends StepToTopoDS_TranslateCompositeCurve {
    constructor(CC: Handle_StepGeom_CompositeCurve, TP: Handle_Transfer_TransientProcess);
  }

  export declare class StepToTopoDS_TranslateCompositeCurve_3 extends StepToTopoDS_TranslateCompositeCurve {
    constructor(CC: Handle_StepGeom_CompositeCurve, TP: Handle_Transfer_TransientProcess, S: Handle_StepGeom_Surface, Surf: Handle_Geom_Surface);
  }

export declare type StepToTopoDS_TranslateEdgeError = {
  StepToTopoDS_TranslateEdgeDone: {};
  StepToTopoDS_TranslateEdgeOther: {};
}

export declare class StepToTopoDS_GeometricTool {
  constructor();
  static PCurve(SC: Handle_StepGeom_SurfaceCurve, S: Handle_StepGeom_Surface, PC: Handle_StepGeom_Pcurve, last: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsSeamCurve(SC: Handle_StepGeom_SurfaceCurve, S: Handle_StepGeom_Surface, E: Handle_StepShape_Edge, EL: Handle_StepShape_EdgeLoop): Standard_Boolean;
  static IsLikeSeam(SC: Handle_StepGeom_SurfaceCurve, S: Handle_StepGeom_Surface, E: Handle_StepShape_Edge, EL: Handle_StepShape_EdgeLoop): Standard_Boolean;
  static UpdateParam3d(C: Handle_Geom_Curve, w1: Quantity_AbsorbedDose, w2: Quantity_AbsorbedDose, preci: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare type StepToTopoDS_TranslateEdgeLoopError = {
  StepToTopoDS_TranslateEdgeLoopDone: {};
  StepToTopoDS_TranslateEdgeLoopOther: {};
}

export declare class StepToTopoDS_TranslatePolyLoop extends StepToTopoDS_Root {
  Init(PL: Handle_StepShape_PolyLoop, T: StepToTopoDS_Tool, S: Handle_Geom_Surface, F: TopoDS_Face): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslatePolyLoopError;
  delete(): void;
}

  export declare class StepToTopoDS_TranslatePolyLoop_1 extends StepToTopoDS_TranslatePolyLoop {
    constructor();
  }

  export declare class StepToTopoDS_TranslatePolyLoop_2 extends StepToTopoDS_TranslatePolyLoop {
    constructor(PL: Handle_StepShape_PolyLoop, T: StepToTopoDS_Tool, S: Handle_Geom_Surface, F: TopoDS_Face);
  }

export declare class StepToTopoDS_TranslateCurveBoundedSurface extends StepToTopoDS_Root {
  Init(CBS: Handle_StepGeom_CurveBoundedSurface, TP: Handle_Transfer_TransientProcess): Standard_Boolean;
  Value(): TopoDS_Face;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateCurveBoundedSurface_1 extends StepToTopoDS_TranslateCurveBoundedSurface {
    constructor();
  }

  export declare class StepToTopoDS_TranslateCurveBoundedSurface_2 extends StepToTopoDS_TranslateCurveBoundedSurface {
    constructor(CBS: Handle_StepGeom_CurveBoundedSurface, TP: Handle_Transfer_TransientProcess);
  }

export declare type StepToTopoDS_BuilderError = {
  StepToTopoDS_BuilderDone: {};
  StepToTopoDS_BuilderOther: {};
}

export declare class StepToTopoDS_TranslateEdgeLoop extends StepToTopoDS_Root {
  Init(FB: Handle_StepShape_FaceBound, F: TopoDS_Face, S: Handle_Geom_Surface, SS: Handle_StepGeom_Surface, ss: Standard_Boolean, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslateEdgeLoopError;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateEdgeLoop_1 extends StepToTopoDS_TranslateEdgeLoop {
    constructor();
  }

  export declare class StepToTopoDS_TranslateEdgeLoop_2 extends StepToTopoDS_TranslateEdgeLoop {
    constructor(FB: Handle_StepShape_FaceBound, F: TopoDS_Face, S: Handle_Geom_Surface, SS: Handle_StepGeom_Surface, ss: Standard_Boolean, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool);
  }

export declare type StepToTopoDS_GeometricToolError = {
  StepToTopoDS_GeometricToolDone: {};
  StepToTopoDS_GeometricToolIsDegenerated: {};
  StepToTopoDS_GeometricToolHasNoPCurve: {};
  StepToTopoDS_GeometricToolWrong3dParameters: {};
  StepToTopoDS_GeometricToolNoProjectiOnCurve: {};
  StepToTopoDS_GeometricToolOther: {};
}

export declare type StepToTopoDS_TranslatePolyLoopError = {
  StepToTopoDS_TranslatePolyLoopDone: {};
  StepToTopoDS_TranslatePolyLoopOther: {};
}

export declare class StepToTopoDS_TranslateVertex extends StepToTopoDS_Root {
  Init(V: Handle_StepShape_Vertex, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslateVertexError;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateVertex_1 extends StepToTopoDS_TranslateVertex {
    constructor();
  }

  export declare class StepToTopoDS_TranslateVertex_2 extends StepToTopoDS_TranslateVertex {
    constructor(V: Handle_StepShape_Vertex, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool);
  }

export declare class StepToTopoDS_Root {
  IsDone(): Standard_Boolean;
  Precision(): Quantity_AbsorbedDose;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  MaxTol(): Quantity_AbsorbedDose;
  SetMaxTol(maxpreci: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StepToTopoDS_Tool {
  Init(Map: StepToTopoDS_DataMapOfTRI, TP: Handle_Transfer_TransientProcess): void;
  IsBound(TRI: Handle_StepShape_TopologicalRepresentationItem): Standard_Boolean;
  Bind(TRI: Handle_StepShape_TopologicalRepresentationItem, S: TopoDS_Shape): void;
  Find(TRI: Handle_StepShape_TopologicalRepresentationItem): TopoDS_Shape;
  ClearEdgeMap(): void;
  IsEdgeBound(PP: StepToTopoDS_PointPair): Standard_Boolean;
  BindEdge(PP: StepToTopoDS_PointPair, E: TopoDS_Edge): void;
  FindEdge(PP: StepToTopoDS_PointPair): TopoDS_Edge;
  ClearVertexMap(): void;
  IsVertexBound(PG: Handle_StepGeom_CartesianPoint): Standard_Boolean;
  BindVertex(P: Handle_StepGeom_CartesianPoint, V: TopoDS_Vertex): void;
  FindVertex(P: Handle_StepGeom_CartesianPoint): TopoDS_Vertex;
  ComputePCurve_1(B: Standard_Boolean): void;
  ComputePCurve_2(): Standard_Boolean;
  TransientProcess(): Handle_Transfer_TransientProcess;
  AddContinuity_1(GeomSurf: Handle_Geom_Surface): void;
  AddContinuity_2(GeomCurve: Handle_Geom_Curve): void;
  AddContinuity_3(GeomCur2d: Handle_Geom2d_Curve): void;
  C0Surf(): Graphic3d_ZLayerId;
  C1Surf(): Graphic3d_ZLayerId;
  C2Surf(): Graphic3d_ZLayerId;
  C0Cur2(): Graphic3d_ZLayerId;
  C1Cur2(): Graphic3d_ZLayerId;
  C2Cur2(): Graphic3d_ZLayerId;
  C0Cur3(): Graphic3d_ZLayerId;
  C1Cur3(): Graphic3d_ZLayerId;
  C2Cur3(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class StepToTopoDS_Tool_1 extends StepToTopoDS_Tool {
    constructor();
  }

  export declare class StepToTopoDS_Tool_2 extends StepToTopoDS_Tool {
    constructor(Map: StepToTopoDS_DataMapOfTRI, TP: Handle_Transfer_TransientProcess);
  }

export declare class StepToTopoDS_TranslateVertexLoop extends StepToTopoDS_Root {
  Init(VL: Handle_StepShape_VertexLoop, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_TranslateVertexLoopError;
  delete(): void;
}

  export declare class StepToTopoDS_TranslateVertexLoop_1 extends StepToTopoDS_TranslateVertexLoop {
    constructor();
  }

  export declare class StepToTopoDS_TranslateVertexLoop_2 extends StepToTopoDS_TranslateVertexLoop {
    constructor(VL: Handle_StepShape_VertexLoop, T: StepToTopoDS_Tool, NMTool: StepToTopoDS_NMTool);
  }

export declare class StepToTopoDS_NMTool {
  Init(MapOfRI: StepToTopoDS_DataMapOfRI, MapOfRINames: StepToTopoDS_DataMapOfRINames): void;
  SetActive(isActive: Standard_Boolean): void;
  IsActive(): Standard_Boolean;
  CleanUp(): void;
  IsBound_1(RI: Handle_StepRepr_RepresentationItem): Standard_Boolean;
  IsBound_2(RIName: XCAFDoc_PartId): Standard_Boolean;
  Bind_1(RI: Handle_StepRepr_RepresentationItem, S: TopoDS_Shape): void;
  Bind_2(RIName: XCAFDoc_PartId, S: TopoDS_Shape): void;
  Find_1(RI: Handle_StepRepr_RepresentationItem): TopoDS_Shape;
  Find_2(RIName: XCAFDoc_PartId): TopoDS_Shape;
  RegisterNMEdge(Edge: TopoDS_Shape): void;
  IsSuspectedAsClosing(BaseShell: TopoDS_Shape, SuspectedShell: TopoDS_Shape): Standard_Boolean;
  IsPureNMShell(Shell: TopoDS_Shape): Standard_Boolean;
  SetIDEASCase(IDEASCase: Standard_Boolean): void;
  IsIDEASCase(): Standard_Boolean;
  delete(): void;
}

  export declare class StepToTopoDS_NMTool_1 extends StepToTopoDS_NMTool {
    constructor();
  }

  export declare class StepToTopoDS_NMTool_2 extends StepToTopoDS_NMTool {
    constructor(MapOfRI: StepToTopoDS_DataMapOfRI, MapOfRINames: StepToTopoDS_DataMapOfRINames);
  }

export declare class StepToTopoDS_Builder extends StepToTopoDS_Root {
  constructor()
  Init_1(S: Handle_StepShape_ManifoldSolidBrep, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): void;
  Init_2(S: Handle_StepShape_BrepWithVoids, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): void;
  Init_3(S: Handle_StepShape_FacetedBrep, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): void;
  Init_4(S: Handle_StepShape_FacetedBrepAndBrepWithVoids, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): void;
  Init_5(S: Handle_StepShape_ShellBasedSurfaceModel, TP: Handle_Transfer_TransientProcess, NMTool: StepToTopoDS_NMTool, theProgress: Message_ProgressRange): void;
  Init_6(S: Handle_StepShape_EdgeBasedWireframeModel, TP: Handle_Transfer_TransientProcess): void;
  Init_7(S: Handle_StepShape_FaceBasedSurfaceModel, TP: Handle_Transfer_TransientProcess): void;
  Init_8(S: Handle_StepShape_GeometricSet, TP: Handle_Transfer_TransientProcess, RA: Handle_Transfer_ActorOfTransientProcess, isManifold: Standard_Boolean, theProgress: Message_ProgressRange): void;
  Value(): TopoDS_Shape;
  Error(): StepToTopoDS_BuilderError;
  delete(): void;
}

export declare type StepToTopoDS_TranslateVertexLoopError = {
  StepToTopoDS_TranslateVertexLoopDone: {};
  StepToTopoDS_TranslateVertexLoopOther: {};
}

export declare class Handle_BinMDocStd_XLinkDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinMDocStd_XLinkDriver): void;
  get(): BinMDocStd_XLinkDriver;
  delete(): void;
}

  export declare class Handle_BinMDocStd_XLinkDriver_1 extends Handle_BinMDocStd_XLinkDriver {
    constructor();
  }

  export declare class Handle_BinMDocStd_XLinkDriver_2 extends Handle_BinMDocStd_XLinkDriver {
    constructor(thePtr: BinMDocStd_XLinkDriver);
  }

  export declare class Handle_BinMDocStd_XLinkDriver_3 extends Handle_BinMDocStd_XLinkDriver {
    constructor(theHandle: Handle_BinMDocStd_XLinkDriver);
  }

  export declare class Handle_BinMDocStd_XLinkDriver_4 extends Handle_BinMDocStd_XLinkDriver {
    constructor(theHandle: Handle_BinMDocStd_XLinkDriver);
  }

export declare class BinMDocStd_XLinkDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinMDocStd {
  constructor();
  static AddDrivers(theDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class ProjLib_PrjResolve {
  constructor(C: Adaptor3d_Curve, S: Adaptor3d_Surface, Fix: Graphic3d_ZLayerId)
  Perform(t: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Tol: gp_Pnt2d, Inf: gp_Pnt2d, Sup: gp_Pnt2d, FTol: Quantity_AbsorbedDose, StrictInside: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Solution(): gp_Pnt2d;
  delete(): void;
}

export declare class ProjLib_ComputeApproxOnPolarSurface {
  SetDegree(theDegMin: Graphic3d_ZLayerId, theDegMax: Graphic3d_ZLayerId): void;
  SetMaxSegments(theMaxSegments: Graphic3d_ZLayerId): void;
  SetBndPnt(theBndPnt: AppParCurves_Constraint): void;
  SetMaxDist(theMaxDist: Quantity_AbsorbedDose): void;
  SetTolerance(theTolerance: Quantity_AbsorbedDose): void;
  Perform_1(C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface): void;
  Perform_2(InitCurve2d: Handle_Adaptor2d_HCurve2d, C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface): Handle_Geom2d_BSplineCurve;
  BuildInitialCurve2d(Curve: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface): Handle_Adaptor2d_HCurve2d;
  ProjectUsingInitialCurve2d(Curve: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface, InitCurve2d: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BSplineCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  Curve2d(): Handle_Geom2d_Curve;
  IsDone(): Standard_Boolean;
  Tolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class ProjLib_ComputeApproxOnPolarSurface_1 extends ProjLib_ComputeApproxOnPolarSurface {
    constructor();
  }

  export declare class ProjLib_ComputeApproxOnPolarSurface_2 extends ProjLib_ComputeApproxOnPolarSurface {
    constructor(C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

  export declare class ProjLib_ComputeApproxOnPolarSurface_3 extends ProjLib_ComputeApproxOnPolarSurface {
    constructor(InitCurve2d: Handle_Adaptor2d_HCurve2d, C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

  export declare class ProjLib_ComputeApproxOnPolarSurface_4 extends ProjLib_ComputeApproxOnPolarSurface {
    constructor(InitCurve2d: Handle_Adaptor2d_HCurve2d, InitCurve2dBis: Handle_Adaptor2d_HCurve2d, C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

export declare class Handle_ProjLib_HProjectedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ProjLib_HProjectedCurve): void;
  get(): ProjLib_HProjectedCurve;
  delete(): void;
}

  export declare class Handle_ProjLib_HProjectedCurve_1 extends Handle_ProjLib_HProjectedCurve {
    constructor();
  }

  export declare class Handle_ProjLib_HProjectedCurve_2 extends Handle_ProjLib_HProjectedCurve {
    constructor(thePtr: ProjLib_HProjectedCurve);
  }

  export declare class Handle_ProjLib_HProjectedCurve_3 extends Handle_ProjLib_HProjectedCurve {
    constructor(theHandle: Handle_ProjLib_HProjectedCurve);
  }

  export declare class Handle_ProjLib_HProjectedCurve_4 extends Handle_ProjLib_HProjectedCurve {
    constructor(theHandle: Handle_ProjLib_HProjectedCurve);
  }

export declare class ProjLib_HProjectedCurve extends Adaptor2d_HCurve2d {
  Set(C: ProjLib_ProjectedCurve): void;
  Curve2d(): Adaptor2d_Curve2d;
  ChangeCurve2d(): ProjLib_ProjectedCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ProjLib_HProjectedCurve_1 extends ProjLib_HProjectedCurve {
    constructor();
  }

  export declare class ProjLib_HProjectedCurve_2 extends ProjLib_HProjectedCurve {
    constructor(C: ProjLib_ProjectedCurve);
  }

export declare class ProjLib_Cone extends ProjLib_Projector {
  Init(Co: gp_Cone): void;
  Project_1(L: gp_Lin): void;
  Project_2(C: gp_Circ): void;
  Project_3(E: gp_Elips): void;
  Project_4(P: gp_Parab): void;
  Project_5(H: gp_Hypr): void;
  delete(): void;
}

  export declare class ProjLib_Cone_1 extends ProjLib_Cone {
    constructor();
  }

  export declare class ProjLib_Cone_2 extends ProjLib_Cone {
    constructor(Co: gp_Cone);
  }

  export declare class ProjLib_Cone_3 extends ProjLib_Cone {
    constructor(Co: gp_Cone, L: gp_Lin);
  }

  export declare class ProjLib_Cone_4 extends ProjLib_Cone {
    constructor(Co: gp_Cone, C: gp_Circ);
  }

export declare class Handle_ProjLib_HCompProjectedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ProjLib_HCompProjectedCurve): void;
  get(): ProjLib_HCompProjectedCurve;
  delete(): void;
}

  export declare class Handle_ProjLib_HCompProjectedCurve_1 extends Handle_ProjLib_HCompProjectedCurve {
    constructor();
  }

  export declare class Handle_ProjLib_HCompProjectedCurve_2 extends Handle_ProjLib_HCompProjectedCurve {
    constructor(thePtr: ProjLib_HCompProjectedCurve);
  }

  export declare class Handle_ProjLib_HCompProjectedCurve_3 extends Handle_ProjLib_HCompProjectedCurve {
    constructor(theHandle: Handle_ProjLib_HCompProjectedCurve);
  }

  export declare class Handle_ProjLib_HCompProjectedCurve_4 extends Handle_ProjLib_HCompProjectedCurve {
    constructor(theHandle: Handle_ProjLib_HCompProjectedCurve);
  }

export declare class ProjLib_HCompProjectedCurve extends Adaptor2d_HCurve2d {
  Set(C: ProjLib_CompProjectedCurve): void;
  Curve2d(): Adaptor2d_Curve2d;
  ChangeCurve2d(): ProjLib_CompProjectedCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ProjLib_HCompProjectedCurve_1 extends ProjLib_HCompProjectedCurve {
    constructor();
  }

  export declare class ProjLib_HCompProjectedCurve_2 extends ProjLib_HCompProjectedCurve {
    constructor(C: ProjLib_CompProjectedCurve);
  }

export declare class ProjLib_Torus extends ProjLib_Projector {
  Init(To: gp_Torus): void;
  Project_1(L: gp_Lin): void;
  Project_2(C: gp_Circ): void;
  Project_3(E: gp_Elips): void;
  Project_4(P: gp_Parab): void;
  Project_5(H: gp_Hypr): void;
  delete(): void;
}

  export declare class ProjLib_Torus_1 extends ProjLib_Torus {
    constructor();
  }

  export declare class ProjLib_Torus_2 extends ProjLib_Torus {
    constructor(To: gp_Torus);
  }

  export declare class ProjLib_Torus_3 extends ProjLib_Torus {
    constructor(To: gp_Torus, C: gp_Circ);
  }

export declare class ProjLib_CompProjectedCurve extends Adaptor2d_Curve2d {
  Init(): void;
  Load_1(S: Handle_Adaptor3d_HSurface): void;
  Load_2(C: Handle_Adaptor3d_HCurve): void;
  GetSurface(): Handle_Adaptor3d_HSurface;
  GetCurve(): Handle_Adaptor3d_HCurve;
  GetTolerance(TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  NbCurves(): Graphic3d_ZLayerId;
  Bounds(Index: Graphic3d_ZLayerId, Udeb: Quantity_AbsorbedDose, Ufin: Quantity_AbsorbedDose): void;
  IsSinglePnt(Index: Graphic3d_ZLayerId, P: gp_Pnt2d): Standard_Boolean;
  IsUIso(Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose): Standard_Boolean;
  IsVIso(Index: Graphic3d_ZLayerId, V: Quantity_AbsorbedDose): Standard_Boolean;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Trim(FirstParam: Quantity_AbsorbedDose, LastParam: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  MaxDistance(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  GetSequence(): Handle_ProjLib_HSequenceOfHSequenceOfPnt;
  GetType(): GeomAbs_CurveType;
  delete(): void;
}

  export declare class ProjLib_CompProjectedCurve_1 extends ProjLib_CompProjectedCurve {
    constructor();
  }

  export declare class ProjLib_CompProjectedCurve_2 extends ProjLib_CompProjectedCurve {
    constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

  export declare class ProjLib_CompProjectedCurve_3 extends ProjLib_CompProjectedCurve {
    constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose, MaxDist: Quantity_AbsorbedDose);
  }

export declare class ProjLib_PrjFunc extends math_FunctionSetWithDerivatives {
  constructor(C: Adaptor3d_CurvePtr, FixVal: Quantity_AbsorbedDose, S: Adaptor3d_SurfacePtr, Fix: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Solution(): gp_Pnt2d;
  delete(): void;
}

export declare class ProjLib {
  constructor();
  static Project_1(Pl: gp_Pln, P: gp_Pnt): gp_Pnt2d;
  static Project_2(Pl: gp_Pln, L: gp_Lin): gp_Lin2d;
  static Project_3(Pl: gp_Pln, C: gp_Circ): gp_Circ2d;
  static Project_4(Pl: gp_Pln, E: gp_Elips): gp_Elips2d;
  static Project_5(Pl: gp_Pln, P: gp_Parab): gp_Parab2d;
  static Project_6(Pl: gp_Pln, H: gp_Hypr): gp_Hypr2d;
  static Project_7(Cy: gp_Cylinder, P: gp_Pnt): gp_Pnt2d;
  static Project_8(Cy: gp_Cylinder, L: gp_Lin): gp_Lin2d;
  static Project_9(Cy: gp_Cylinder, Ci: gp_Circ): gp_Lin2d;
  static Project_10(Co: gp_Cone, P: gp_Pnt): gp_Pnt2d;
  static Project_11(Co: gp_Cone, L: gp_Lin): gp_Lin2d;
  static Project_12(Co: gp_Cone, Ci: gp_Circ): gp_Lin2d;
  static Project_13(Sp: gp_Sphere, P: gp_Pnt): gp_Pnt2d;
  static Project_14(Sp: gp_Sphere, Ci: gp_Circ): gp_Lin2d;
  static Project_15(To: gp_Torus, P: gp_Pnt): gp_Pnt2d;
  static Project_16(To: gp_Torus, Ci: gp_Circ): gp_Lin2d;
  static MakePCurveOfType(PC: ProjLib_ProjectedCurve, aC: Handle_Geom2d_Curve): void;
  static IsAnaSurf(theAS: Handle_Adaptor3d_HSurface): Standard_Boolean;
  delete(): void;
}

export declare class ProjLib_Sphere extends ProjLib_Projector {
  Init(Sp: gp_Sphere): void;
  Project_1(L: gp_Lin): void;
  Project_2(C: gp_Circ): void;
  Project_3(E: gp_Elips): void;
  Project_4(P: gp_Parab): void;
  Project_5(H: gp_Hypr): void;
  SetInBounds(U: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class ProjLib_Sphere_1 extends ProjLib_Sphere {
    constructor();
  }

  export declare class ProjLib_Sphere_2 extends ProjLib_Sphere {
    constructor(Sp: gp_Sphere);
  }

  export declare class ProjLib_Sphere_3 extends ProjLib_Sphere {
    constructor(Sp: gp_Sphere, C: gp_Circ);
  }

export declare class ProjLib_Projector {
  constructor()
  IsDone(): Standard_Boolean;
  Done(): void;
  GetType(): GeomAbs_CurveType;
  SetBSpline(C: Handle_Geom2d_BSplineCurve): void;
  SetBezier(C: Handle_Geom2d_BezierCurve): void;
  SetType(Type: GeomAbs_CurveType): void;
  IsPeriodic(): Standard_Boolean;
  SetPeriodic(): void;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  Project_1(L: gp_Lin): void;
  Project_2(C: gp_Circ): void;
  Project_3(E: gp_Elips): void;
  Project_4(P: gp_Parab): void;
  Project_5(H: gp_Hypr): void;
  UFrame(CFirst: Quantity_AbsorbedDose, CLast: Quantity_AbsorbedDose, UFirst: Quantity_AbsorbedDose, Period: Quantity_AbsorbedDose): void;
  VFrame(CFirst: Quantity_AbsorbedDose, CLast: Quantity_AbsorbedDose, VFirst: Quantity_AbsorbedDose, Period: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class ProjLib_Cylinder extends ProjLib_Projector {
  Init(Cyl: gp_Cylinder): void;
  Project_1(L: gp_Lin): void;
  Project_2(C: gp_Circ): void;
  Project_3(E: gp_Elips): void;
  Project_4(P: gp_Parab): void;
  Project_5(H: gp_Hypr): void;
  delete(): void;
}

  export declare class ProjLib_Cylinder_1 extends ProjLib_Cylinder {
    constructor();
  }

  export declare class ProjLib_Cylinder_2 extends ProjLib_Cylinder {
    constructor(Cyl: gp_Cylinder);
  }

  export declare class ProjLib_Cylinder_3 extends ProjLib_Cylinder {
    constructor(Cyl: gp_Cylinder, L: gp_Lin);
  }

  export declare class ProjLib_Cylinder_4 extends ProjLib_Cylinder {
    constructor(Cyl: gp_Cylinder, C: gp_Circ);
  }

  export declare class ProjLib_Cylinder_5 extends ProjLib_Cylinder {
    constructor(Cyl: gp_Cylinder, E: gp_Elips);
  }

export declare class ProjLib_ComputeApprox {
  Perform(C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface): void;
  SetTolerance(theTolerance: Quantity_AbsorbedDose): void;
  SetDegree(theDegMin: Graphic3d_ZLayerId, theDegMax: Graphic3d_ZLayerId): void;
  SetMaxSegments(theMaxSegments: Graphic3d_ZLayerId): void;
  SetBndPnt(theBndPnt: AppParCurves_Constraint): void;
  BSpline(): Handle_Geom2d_BSplineCurve;
  Bezier(): Handle_Geom2d_BezierCurve;
  Tolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class ProjLib_ComputeApprox_1 extends ProjLib_ComputeApprox {
    constructor();
  }

  export declare class ProjLib_ComputeApprox_2 extends ProjLib_ComputeApprox {
    constructor(C: Handle_Adaptor3d_HCurve, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

export declare class ProjLib_ProjectOnPlane extends Adaptor3d_Curve {
  Load(C: Handle_Adaptor3d_HCurve, Tolerance: Quantity_AbsorbedDose, KeepParametrization: Standard_Boolean): void;
  GetPlane(): gp_Ax3;
  GetDirection(): gp_Dir;
  GetCurve(): Handle_Adaptor3d_HCurve;
  GetResult(): Handle_GeomAdaptor_HCurve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

  export declare class ProjLib_ProjectOnPlane_1 extends ProjLib_ProjectOnPlane {
    constructor();
  }

  export declare class ProjLib_ProjectOnPlane_2 extends ProjLib_ProjectOnPlane {
    constructor(Pl: gp_Ax3);
  }

  export declare class ProjLib_ProjectOnPlane_3 extends ProjLib_ProjectOnPlane {
    constructor(Pl: gp_Ax3, D: gp_Dir);
  }

export declare class ProjLib_ProjectedCurve extends Adaptor2d_Curve2d {
  Load_1(Tolerance: Quantity_AbsorbedDose): void;
  Load_2(S: Handle_Adaptor3d_HSurface): void;
  Perform(C: Handle_Adaptor3d_HCurve): void;
  SetDegree(theDegMin: Graphic3d_ZLayerId, theDegMax: Graphic3d_ZLayerId): void;
  SetMaxSegments(theMaxSegments: Graphic3d_ZLayerId): void;
  SetBndPnt(theBndPnt: AppParCurves_Constraint): void;
  SetMaxDist(theMaxDist: Quantity_AbsorbedDose): void;
  GetSurface(): Handle_Adaptor3d_HSurface;
  GetCurve(): Handle_Adaptor3d_HCurve;
  GetTolerance(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

  export declare class ProjLib_ProjectedCurve_1 extends ProjLib_ProjectedCurve {
    constructor();
  }

  export declare class ProjLib_ProjectedCurve_2 extends ProjLib_ProjectedCurve {
    constructor(S: Handle_Adaptor3d_HSurface);
  }

  export declare class ProjLib_ProjectedCurve_3 extends ProjLib_ProjectedCurve {
    constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve);
  }

  export declare class ProjLib_ProjectedCurve_4 extends ProjLib_ProjectedCurve {
    constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve, Tol: Quantity_AbsorbedDose);
  }

export declare class ProjLib_Plane extends ProjLib_Projector {
  Init(Pl: gp_Pln): void;
  Project_1(L: gp_Lin): void;
  Project_2(C: gp_Circ): void;
  Project_3(E: gp_Elips): void;
  Project_4(P: gp_Parab): void;
  Project_5(H: gp_Hypr): void;
  delete(): void;
}

  export declare class ProjLib_Plane_1 extends ProjLib_Plane {
    constructor();
  }

  export declare class ProjLib_Plane_2 extends ProjLib_Plane {
    constructor(Pl: gp_Pln);
  }

  export declare class ProjLib_Plane_3 extends ProjLib_Plane {
    constructor(Pl: gp_Pln, L: gp_Lin);
  }

  export declare class ProjLib_Plane_4 extends ProjLib_Plane {
    constructor(Pl: gp_Pln, C: gp_Circ);
  }

  export declare class ProjLib_Plane_5 extends ProjLib_Plane {
    constructor(Pl: gp_Pln, E: gp_Elips);
  }

  export declare class ProjLib_Plane_6 extends ProjLib_Plane {
    constructor(Pl: gp_Pln, P: gp_Parab);
  }

  export declare class ProjLib_Plane_7 extends ProjLib_Plane {
    constructor(Pl: gp_Pln, H: gp_Hypr);
  }

export declare class Handle_ProjLib_HSequenceOfHSequenceOfPnt {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ProjLib_HSequenceOfHSequenceOfPnt): void;
  get(): ProjLib_HSequenceOfHSequenceOfPnt;
  delete(): void;
}

  export declare class Handle_ProjLib_HSequenceOfHSequenceOfPnt_1 extends Handle_ProjLib_HSequenceOfHSequenceOfPnt {
    constructor();
  }

  export declare class Handle_ProjLib_HSequenceOfHSequenceOfPnt_2 extends Handle_ProjLib_HSequenceOfHSequenceOfPnt {
    constructor(thePtr: ProjLib_HSequenceOfHSequenceOfPnt);
  }

  export declare class Handle_ProjLib_HSequenceOfHSequenceOfPnt_3 extends Handle_ProjLib_HSequenceOfHSequenceOfPnt {
    constructor(theHandle: Handle_ProjLib_HSequenceOfHSequenceOfPnt);
  }

  export declare class Handle_ProjLib_HSequenceOfHSequenceOfPnt_4 extends Handle_ProjLib_HSequenceOfHSequenceOfPnt {
    constructor(theHandle: Handle_ProjLib_HSequenceOfHSequenceOfPnt);
  }

export declare class OSD_SharedLibrary {
  SetName(aName: Standard_CString): void;
  Name(): Standard_CString;
  DlOpen(Mode: OSD_LoadMode): Standard_Boolean;
  DlSymb(Name: Standard_CString): OSD_Function;
  DlClose(): void;
  DlError(): Standard_CString;
  Destroy(): void;
  delete(): void;
}

  export declare class OSD_SharedLibrary_1 extends OSD_SharedLibrary {
    constructor();
  }

  export declare class OSD_SharedLibrary_2 extends OSD_SharedLibrary {
    constructor(aFilename: Standard_CString);
  }

export declare class OSD_Exception_INVALID_DISPOSITION extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_INVALID_DISPOSITION;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_INVALID_DISPOSITION_1 extends OSD_Exception_INVALID_DISPOSITION {
    constructor();
  }

  export declare class OSD_Exception_INVALID_DISPOSITION_2 extends OSD_Exception_INVALID_DISPOSITION {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_INVALID_DISPOSITION {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_INVALID_DISPOSITION): void;
  get(): OSD_Exception_INVALID_DISPOSITION;
  delete(): void;
}

  export declare class Handle_OSD_Exception_INVALID_DISPOSITION_1 extends Handle_OSD_Exception_INVALID_DISPOSITION {
    constructor();
  }

  export declare class Handle_OSD_Exception_INVALID_DISPOSITION_2 extends Handle_OSD_Exception_INVALID_DISPOSITION {
    constructor(thePtr: OSD_Exception_INVALID_DISPOSITION);
  }

  export declare class Handle_OSD_Exception_INVALID_DISPOSITION_3 extends Handle_OSD_Exception_INVALID_DISPOSITION {
    constructor(theHandle: Handle_OSD_Exception_INVALID_DISPOSITION);
  }

  export declare class Handle_OSD_Exception_INVALID_DISPOSITION_4 extends Handle_OSD_Exception_INVALID_DISPOSITION {
    constructor(theHandle: Handle_OSD_Exception_INVALID_DISPOSITION);
  }

export declare type OSD_WhoAmI = {
  OSD_WDirectory: {};
  OSD_WDirectoryIterator: {};
  OSD_WEnvironment: {};
  OSD_WFile: {};
  OSD_WFileNode: {};
  OSD_WFileIterator: {};
  OSD_WPath: {};
  OSD_WProcess: {};
  OSD_WProtection: {};
  OSD_WHost: {};
  OSD_WDisk: {};
  OSD_WChronometer: {};
  OSD_WTimer: {};
  OSD_WPackage: {};
  OSD_WEnvironmentIterator: {};
}

export declare class OSD_SIGBUS extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGBUS;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGBUS_1 extends OSD_SIGBUS {
    constructor();
  }

  export declare class OSD_SIGBUS_2 extends OSD_SIGBUS {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGBUS {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGBUS): void;
  get(): OSD_SIGBUS;
  delete(): void;
}

  export declare class Handle_OSD_SIGBUS_1 extends Handle_OSD_SIGBUS {
    constructor();
  }

  export declare class Handle_OSD_SIGBUS_2 extends Handle_OSD_SIGBUS {
    constructor(thePtr: OSD_SIGBUS);
  }

  export declare class Handle_OSD_SIGBUS_3 extends Handle_OSD_SIGBUS {
    constructor(theHandle: Handle_OSD_SIGBUS);
  }

  export declare class Handle_OSD_SIGBUS_4 extends Handle_OSD_SIGBUS {
    constructor(theHandle: Handle_OSD_SIGBUS);
  }

export declare class OSD_Process {
  constructor()
  static ExecutablePath(): XCAFDoc_PartId;
  static ExecutableFolder(): XCAFDoc_PartId;
  TerminalType(Name: XCAFDoc_PartId): void;
  SystemDate(): Quantity_Date;
  UserName(): XCAFDoc_PartId;
  IsSuperUser(): Standard_Boolean;
  ProcessId(): Graphic3d_ZLayerId;
  CurrentDirectory(): OSD_Path;
  SetCurrentDirectory(where: OSD_Path): void;
  Failed(): Standard_Boolean;
  Reset(): void;
  Perror(): void;
  Error(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class OSD_Thread {
  Assign(other: OSD_Thread): void;
  SetPriority(thePriority: Graphic3d_ZLayerId): void;
  SetFunction(func: OSD_ThreadFunction): void;
  Run(data: Standard_Address, WNTStackSize: Graphic3d_ZLayerId): Standard_Boolean;
  Detach(): void;
  GetId(): Standard_ThreadId;
  static Current(): Standard_ThreadId;
  delete(): void;
}

  export declare class OSD_Thread_1 extends OSD_Thread {
    constructor();
  }

  export declare class OSD_Thread_2 extends OSD_Thread {
    constructor(func: OSD_ThreadFunction);
  }

  export declare class OSD_Thread_3 extends OSD_Thread {
    constructor(other: OSD_Thread);
  }

export declare class OSD_SIGSEGV extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGSEGV;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGSEGV_1 extends OSD_SIGSEGV {
    constructor();
  }

  export declare class OSD_SIGSEGV_2 extends OSD_SIGSEGV {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGSEGV {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGSEGV): void;
  get(): OSD_SIGSEGV;
  delete(): void;
}

  export declare class Handle_OSD_SIGSEGV_1 extends Handle_OSD_SIGSEGV {
    constructor();
  }

  export declare class Handle_OSD_SIGSEGV_2 extends Handle_OSD_SIGSEGV {
    constructor(thePtr: OSD_SIGSEGV);
  }

  export declare class Handle_OSD_SIGSEGV_3 extends Handle_OSD_SIGSEGV {
    constructor(theHandle: Handle_OSD_SIGSEGV);
  }

  export declare class Handle_OSD_SIGSEGV_4 extends Handle_OSD_SIGSEGV {
    constructor(theHandle: Handle_OSD_SIGSEGV);
  }

export declare class Handle_OSD_Signal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Signal): void;
  get(): OSD_Signal;
  delete(): void;
}

  export declare class Handle_OSD_Signal_1 extends Handle_OSD_Signal {
    constructor();
  }

  export declare class Handle_OSD_Signal_2 extends Handle_OSD_Signal {
    constructor(thePtr: OSD_Signal);
  }

  export declare class Handle_OSD_Signal_3 extends Handle_OSD_Signal {
    constructor(theHandle: Handle_OSD_Signal);
  }

  export declare class Handle_OSD_Signal_4 extends Handle_OSD_Signal {
    constructor(theHandle: Handle_OSD_Signal);
  }

export declare class OSD_Signal extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Signal;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Signal_1 extends OSD_Signal {
    constructor();
  }

  export declare class OSD_Signal_2 extends OSD_Signal {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_PRIV_INSTRUCTION {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_PRIV_INSTRUCTION): void;
  get(): OSD_Exception_PRIV_INSTRUCTION;
  delete(): void;
}

  export declare class Handle_OSD_Exception_PRIV_INSTRUCTION_1 extends Handle_OSD_Exception_PRIV_INSTRUCTION {
    constructor();
  }

  export declare class Handle_OSD_Exception_PRIV_INSTRUCTION_2 extends Handle_OSD_Exception_PRIV_INSTRUCTION {
    constructor(thePtr: OSD_Exception_PRIV_INSTRUCTION);
  }

  export declare class Handle_OSD_Exception_PRIV_INSTRUCTION_3 extends Handle_OSD_Exception_PRIV_INSTRUCTION {
    constructor(theHandle: Handle_OSD_Exception_PRIV_INSTRUCTION);
  }

  export declare class Handle_OSD_Exception_PRIV_INSTRUCTION_4 extends Handle_OSD_Exception_PRIV_INSTRUCTION {
    constructor(theHandle: Handle_OSD_Exception_PRIV_INSTRUCTION);
  }

export declare class OSD_Exception_PRIV_INSTRUCTION extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_PRIV_INSTRUCTION;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_PRIV_INSTRUCTION_1 extends OSD_Exception_PRIV_INSTRUCTION {
    constructor();
  }

  export declare class OSD_Exception_PRIV_INSTRUCTION_2 extends OSD_Exception_PRIV_INSTRUCTION {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_Disk {
  Name(): OSD_Path;
  SetName(Name: OSD_Path): void;
  DiskSize(): Graphic3d_ZLayerId;
  DiskFree(): Graphic3d_ZLayerId;
  Failed(): Standard_Boolean;
  Reset(): void;
  Perror(): void;
  Error(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class OSD_Disk_1 extends OSD_Disk {
    constructor();
  }

  export declare class OSD_Disk_2 extends OSD_Disk {
    constructor(Name: OSD_Path);
  }

  export declare class OSD_Disk_3 extends OSD_Disk {
    constructor(PathName: Standard_CString);
  }

export declare class OSD_SIGINT extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGINT;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGINT_1 extends OSD_SIGINT {
    constructor();
  }

  export declare class OSD_SIGINT_2 extends OSD_SIGINT {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGINT {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGINT): void;
  get(): OSD_SIGINT;
  delete(): void;
}

  export declare class Handle_OSD_SIGINT_1 extends Handle_OSD_SIGINT {
    constructor();
  }

  export declare class Handle_OSD_SIGINT_2 extends Handle_OSD_SIGINT {
    constructor(thePtr: OSD_SIGINT);
  }

  export declare class Handle_OSD_SIGINT_3 extends Handle_OSD_SIGINT {
    constructor(theHandle: Handle_OSD_SIGINT);
  }

  export declare class Handle_OSD_SIGINT_4 extends Handle_OSD_SIGINT {
    constructor(theHandle: Handle_OSD_SIGINT);
  }

export declare type OSD_OpenMode = {
  OSD_ReadOnly: {};
  OSD_WriteOnly: {};
  OSD_ReadWrite: {};
}

export declare class OSD_Exception_STATUS_NO_MEMORY extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_STATUS_NO_MEMORY;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_STATUS_NO_MEMORY_1 extends OSD_Exception_STATUS_NO_MEMORY {
    constructor();
  }

  export declare class OSD_Exception_STATUS_NO_MEMORY_2 extends OSD_Exception_STATUS_NO_MEMORY {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_STATUS_NO_MEMORY {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_STATUS_NO_MEMORY): void;
  get(): OSD_Exception_STATUS_NO_MEMORY;
  delete(): void;
}

  export declare class Handle_OSD_Exception_STATUS_NO_MEMORY_1 extends Handle_OSD_Exception_STATUS_NO_MEMORY {
    constructor();
  }

  export declare class Handle_OSD_Exception_STATUS_NO_MEMORY_2 extends Handle_OSD_Exception_STATUS_NO_MEMORY {
    constructor(thePtr: OSD_Exception_STATUS_NO_MEMORY);
  }

  export declare class Handle_OSD_Exception_STATUS_NO_MEMORY_3 extends Handle_OSD_Exception_STATUS_NO_MEMORY {
    constructor(theHandle: Handle_OSD_Exception_STATUS_NO_MEMORY);
  }

  export declare class Handle_OSD_Exception_STATUS_NO_MEMORY_4 extends Handle_OSD_Exception_STATUS_NO_MEMORY {
    constructor(theHandle: Handle_OSD_Exception_STATUS_NO_MEMORY);
  }

export declare class Handle_OSD_Exception_FLT_UNDERFLOW {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_UNDERFLOW): void;
  get(): OSD_Exception_FLT_UNDERFLOW;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_UNDERFLOW_1 extends Handle_OSD_Exception_FLT_UNDERFLOW {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_UNDERFLOW_2 extends Handle_OSD_Exception_FLT_UNDERFLOW {
    constructor(thePtr: OSD_Exception_FLT_UNDERFLOW);
  }

  export declare class Handle_OSD_Exception_FLT_UNDERFLOW_3 extends Handle_OSD_Exception_FLT_UNDERFLOW {
    constructor(theHandle: Handle_OSD_Exception_FLT_UNDERFLOW);
  }

  export declare class Handle_OSD_Exception_FLT_UNDERFLOW_4 extends Handle_OSD_Exception_FLT_UNDERFLOW {
    constructor(theHandle: Handle_OSD_Exception_FLT_UNDERFLOW);
  }

export declare class OSD_Exception_FLT_UNDERFLOW extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_UNDERFLOW;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_UNDERFLOW_1 extends OSD_Exception_FLT_UNDERFLOW {
    constructor();
  }

  export declare class OSD_Exception_FLT_UNDERFLOW_2 extends OSD_Exception_FLT_UNDERFLOW {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_Exception_INT_OVERFLOW extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_INT_OVERFLOW;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_INT_OVERFLOW_1 extends OSD_Exception_INT_OVERFLOW {
    constructor();
  }

  export declare class OSD_Exception_INT_OVERFLOW_2 extends OSD_Exception_INT_OVERFLOW {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_INT_OVERFLOW {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_INT_OVERFLOW): void;
  get(): OSD_Exception_INT_OVERFLOW;
  delete(): void;
}

  export declare class Handle_OSD_Exception_INT_OVERFLOW_1 extends Handle_OSD_Exception_INT_OVERFLOW {
    constructor();
  }

  export declare class Handle_OSD_Exception_INT_OVERFLOW_2 extends Handle_OSD_Exception_INT_OVERFLOW {
    constructor(thePtr: OSD_Exception_INT_OVERFLOW);
  }

  export declare class Handle_OSD_Exception_INT_OVERFLOW_3 extends Handle_OSD_Exception_INT_OVERFLOW {
    constructor(theHandle: Handle_OSD_Exception_INT_OVERFLOW);
  }

  export declare class Handle_OSD_Exception_INT_OVERFLOW_4 extends Handle_OSD_Exception_INT_OVERFLOW {
    constructor(theHandle: Handle_OSD_Exception_INT_OVERFLOW);
  }

export declare class OSD {
  constructor();
  static SetSignal_1(theSignalMode: OSD_SignalMode, theFloatingSignal: Standard_Boolean): void;
  static SetSignal_2(theFloatingSignal: Standard_Boolean): void;
  static SetThreadLocalSignal(theSignalMode: OSD_SignalMode, theFloatingSignal: Standard_Boolean): void;
  static SetFloatingSignal(theFloatingSignal: Standard_Boolean): void;
  static SignalMode(): OSD_SignalMode;
  static ToCatchFloatingSignals(): Standard_Boolean;
  static SecSleep(theSeconds: Graphic3d_ZLayerId): void;
  static MilliSecSleep(theMilliseconds: Graphic3d_ZLayerId): void;
  static CStringToReal(aString: Standard_CString, aReal: Quantity_AbsorbedDose): Standard_Boolean;
  static ControlBreak(): void;
  delete(): void;
}

export declare class OSD_Exception_IN_PAGE_ERROR extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_IN_PAGE_ERROR;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_IN_PAGE_ERROR_1 extends OSD_Exception_IN_PAGE_ERROR {
    constructor();
  }

  export declare class OSD_Exception_IN_PAGE_ERROR_2 extends OSD_Exception_IN_PAGE_ERROR {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_IN_PAGE_ERROR {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_IN_PAGE_ERROR): void;
  get(): OSD_Exception_IN_PAGE_ERROR;
  delete(): void;
}

  export declare class Handle_OSD_Exception_IN_PAGE_ERROR_1 extends Handle_OSD_Exception_IN_PAGE_ERROR {
    constructor();
  }

  export declare class Handle_OSD_Exception_IN_PAGE_ERROR_2 extends Handle_OSD_Exception_IN_PAGE_ERROR {
    constructor(thePtr: OSD_Exception_IN_PAGE_ERROR);
  }

  export declare class Handle_OSD_Exception_IN_PAGE_ERROR_3 extends Handle_OSD_Exception_IN_PAGE_ERROR {
    constructor(theHandle: Handle_OSD_Exception_IN_PAGE_ERROR);
  }

  export declare class Handle_OSD_Exception_IN_PAGE_ERROR_4 extends Handle_OSD_Exception_IN_PAGE_ERROR {
    constructor(theHandle: Handle_OSD_Exception_IN_PAGE_ERROR);
  }

export declare type OSD_OEMType = {
  OSD_Unavailable: {};
  OSD_SUN: {};
  OSD_DEC: {};
  OSD_SGI: {};
  OSD_NEC: {};
  OSD_MAC: {};
  OSD_PC: {};
  OSD_HP: {};
  OSD_IBM: {};
  OSD_VAX: {};
  OSD_LIN: {};
  OSD_AIX: {};
}

export declare class OSD_MemInfo {
  constructor(theImmediateUpdate: Standard_Boolean)
  IsActive(theCounter: any): Standard_Boolean;
  SetActive_1(theActive: Standard_Boolean): void;
  SetActive_2(theCounter: any, theActive: Standard_Boolean): void;
  Clear(): void;
  Update(): void;
  ToString(): XCAFDoc_PartId;
  Value(theCounter: any): Standard_ThreadId;
  ValueMiB(theCounter: any): Standard_ThreadId;
  ValuePreciseMiB(theCounter: any): Quantity_AbsorbedDose;
  static PrintInfo(): XCAFDoc_PartId;
  delete(): void;
}

export declare type OSD_SysType = {
  OSD_Unknown: {};
  OSD_Default: {};
  OSD_UnixBSD: {};
  OSD_UnixSystemV: {};
  OSD_VMS: {};
  OSD_OS2: {};
  OSD_OSF: {};
  OSD_MacOs: {};
  OSD_Taligent: {};
  OSD_WindowsNT: {};
  OSD_LinuxREDHAT: {};
  OSD_Aix: {};
}

export declare class OSD_Exception_ILLEGAL_INSTRUCTION extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_ILLEGAL_INSTRUCTION;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_ILLEGAL_INSTRUCTION_1 extends OSD_Exception_ILLEGAL_INSTRUCTION {
    constructor();
  }

  export declare class OSD_Exception_ILLEGAL_INSTRUCTION_2 extends OSD_Exception_ILLEGAL_INSTRUCTION {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_ILLEGAL_INSTRUCTION {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_ILLEGAL_INSTRUCTION): void;
  get(): OSD_Exception_ILLEGAL_INSTRUCTION;
  delete(): void;
}

  export declare class Handle_OSD_Exception_ILLEGAL_INSTRUCTION_1 extends Handle_OSD_Exception_ILLEGAL_INSTRUCTION {
    constructor();
  }

  export declare class Handle_OSD_Exception_ILLEGAL_INSTRUCTION_2 extends Handle_OSD_Exception_ILLEGAL_INSTRUCTION {
    constructor(thePtr: OSD_Exception_ILLEGAL_INSTRUCTION);
  }

  export declare class Handle_OSD_Exception_ILLEGAL_INSTRUCTION_3 extends Handle_OSD_Exception_ILLEGAL_INSTRUCTION {
    constructor(theHandle: Handle_OSD_Exception_ILLEGAL_INSTRUCTION);
  }

  export declare class Handle_OSD_Exception_ILLEGAL_INSTRUCTION_4 extends Handle_OSD_Exception_ILLEGAL_INSTRUCTION {
    constructor(theHandle: Handle_OSD_Exception_ILLEGAL_INSTRUCTION);
  }

export declare class OSD_ThreadPool extends Standard_Transient {
  constructor(theNbThreads: Standard_Integer)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static DefaultPool(theNbThreads: Standard_Integer): any;
  HasThreads(): Standard_Boolean;
  LowerThreadIndex(): Standard_Integer;
  UpperThreadIndex(): Standard_Integer;
  NbThreads(): Standard_Integer;
  NbDefaultThreadsToLaunch(): Standard_Integer;
  SetNbDefaultThreadsToLaunch(theNbThreads: Standard_Integer): void;
  IsInUse(): Standard_Boolean;
  Init(theNbThreads: Standard_Integer): void;
  delete(): void;
}

export declare class OSD_FileIterator {
  Destroy(): void;
  Initialize(where: OSD_Path, Mask: XCAFDoc_PartId): void;
  More(): Standard_Boolean;
  Next(): void;
  Values(): OSD_File;
  Failed(): Standard_Boolean;
  Reset(): void;
  Perror(): void;
  Error(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class OSD_FileIterator_1 extends OSD_FileIterator {
    constructor();
  }

  export declare class OSD_FileIterator_2 extends OSD_FileIterator {
    constructor(where: OSD_Path, Mask: XCAFDoc_PartId);
  }

export declare class OSD_SIGILL extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGILL;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGILL_1 extends OSD_SIGILL {
    constructor();
  }

  export declare class OSD_SIGILL_2 extends OSD_SIGILL {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGILL {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGILL): void;
  get(): OSD_SIGILL;
  delete(): void;
}

  export declare class Handle_OSD_SIGILL_1 extends Handle_OSD_SIGILL {
    constructor();
  }

  export declare class Handle_OSD_SIGILL_2 extends Handle_OSD_SIGILL {
    constructor(thePtr: OSD_SIGILL);
  }

  export declare class Handle_OSD_SIGILL_3 extends Handle_OSD_SIGILL {
    constructor(theHandle: Handle_OSD_SIGILL);
  }

  export declare class Handle_OSD_SIGILL_4 extends Handle_OSD_SIGILL {
    constructor(theHandle: Handle_OSD_SIGILL);
  }

export declare class OSD_SIGHUP extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGHUP;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGHUP_1 extends OSD_SIGHUP {
    constructor();
  }

  export declare class OSD_SIGHUP_2 extends OSD_SIGHUP {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGHUP {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGHUP): void;
  get(): OSD_SIGHUP;
  delete(): void;
}

  export declare class Handle_OSD_SIGHUP_1 extends Handle_OSD_SIGHUP {
    constructor();
  }

  export declare class Handle_OSD_SIGHUP_2 extends Handle_OSD_SIGHUP {
    constructor(thePtr: OSD_SIGHUP);
  }

  export declare class Handle_OSD_SIGHUP_3 extends Handle_OSD_SIGHUP {
    constructor(theHandle: Handle_OSD_SIGHUP);
  }

  export declare class Handle_OSD_SIGHUP_4 extends Handle_OSD_SIGHUP {
    constructor(theHandle: Handle_OSD_SIGHUP);
  }

export declare class OSD_Exception_FLT_INVALID_OPERATION extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_INVALID_OPERATION;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_INVALID_OPERATION_1 extends OSD_Exception_FLT_INVALID_OPERATION {
    constructor();
  }

  export declare class OSD_Exception_FLT_INVALID_OPERATION_2 extends OSD_Exception_FLT_INVALID_OPERATION {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_FLT_INVALID_OPERATION {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_INVALID_OPERATION): void;
  get(): OSD_Exception_FLT_INVALID_OPERATION;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_INVALID_OPERATION_1 extends Handle_OSD_Exception_FLT_INVALID_OPERATION {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_INVALID_OPERATION_2 extends Handle_OSD_Exception_FLT_INVALID_OPERATION {
    constructor(thePtr: OSD_Exception_FLT_INVALID_OPERATION);
  }

  export declare class Handle_OSD_Exception_FLT_INVALID_OPERATION_3 extends Handle_OSD_Exception_FLT_INVALID_OPERATION {
    constructor(theHandle: Handle_OSD_Exception_FLT_INVALID_OPERATION);
  }

  export declare class Handle_OSD_Exception_FLT_INVALID_OPERATION_4 extends Handle_OSD_Exception_FLT_INVALID_OPERATION {
    constructor(theHandle: Handle_OSD_Exception_FLT_INVALID_OPERATION);
  }

export declare class OSD_Directory extends OSD_FileNode {
  static BuildTemporary(): OSD_Directory;
  Build(Protect: OSD_Protection): void;
  delete(): void;
}

  export declare class OSD_Directory_1 extends OSD_Directory {
    constructor();
  }

  export declare class OSD_Directory_2 extends OSD_Directory {
    constructor(theName: OSD_Path);
  }

export declare class OSD_Error {
  constructor()
  Perror(): void;
  SetValue(Errcode: Graphic3d_ZLayerId, From: Graphic3d_ZLayerId, Message: XCAFDoc_PartId): void;
  Error(): Graphic3d_ZLayerId;
  Failed(): Standard_Boolean;
  Reset(): void;
  delete(): void;
}

export declare class OSD_Host {
  constructor()
  SystemVersion(): XCAFDoc_PartId;
  SystemId(): OSD_SysType;
  HostName(): XCAFDoc_PartId;
  AvailableMemory(): Graphic3d_ZLayerId;
  InternetAddress(): XCAFDoc_PartId;
  MachineType(): OSD_OEMType;
  Failed(): Standard_Boolean;
  Reset(): void;
  Perror(): void;
  Error(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare type OSD_LockType = {
  OSD_NoLock: {};
  OSD_ReadLock: {};
  OSD_WriteLock: {};
  OSD_ExclusiveLock: {};
}

export declare class OSD_Exception_FLT_DENORMAL_OPERAND extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_DENORMAL_OPERAND;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_DENORMAL_OPERAND_1 extends OSD_Exception_FLT_DENORMAL_OPERAND {
    constructor();
  }

  export declare class OSD_Exception_FLT_DENORMAL_OPERAND_2 extends OSD_Exception_FLT_DENORMAL_OPERAND {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_FLT_DENORMAL_OPERAND {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_DENORMAL_OPERAND): void;
  get(): OSD_Exception_FLT_DENORMAL_OPERAND;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_DENORMAL_OPERAND_1 extends Handle_OSD_Exception_FLT_DENORMAL_OPERAND {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_DENORMAL_OPERAND_2 extends Handle_OSD_Exception_FLT_DENORMAL_OPERAND {
    constructor(thePtr: OSD_Exception_FLT_DENORMAL_OPERAND);
  }

  export declare class Handle_OSD_Exception_FLT_DENORMAL_OPERAND_3 extends Handle_OSD_Exception_FLT_DENORMAL_OPERAND {
    constructor(theHandle: Handle_OSD_Exception_FLT_DENORMAL_OPERAND);
  }

  export declare class Handle_OSD_Exception_FLT_DENORMAL_OPERAND_4 extends Handle_OSD_Exception_FLT_DENORMAL_OPERAND {
    constructor(theHandle: Handle_OSD_Exception_FLT_DENORMAL_OPERAND);
  }

export declare class OSD_Environment {
  SetValue(Value: XCAFDoc_PartId): void;
  Value(): XCAFDoc_PartId;
  SetName(name: XCAFDoc_PartId): void;
  Name(): XCAFDoc_PartId;
  Build(): void;
  Remove(): void;
  Failed(): Standard_Boolean;
  Reset(): void;
  Perror(): void;
  Error(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class OSD_Environment_1 extends OSD_Environment {
    constructor();
  }

  export declare class OSD_Environment_2 extends OSD_Environment {
    constructor(Name: XCAFDoc_PartId);
  }

  export declare class OSD_Environment_3 extends OSD_Environment {
    constructor(Name: XCAFDoc_PartId, Value: XCAFDoc_PartId);
  }

export declare class Handle_OSD_SIGSYS {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGSYS): void;
  get(): OSD_SIGSYS;
  delete(): void;
}

  export declare class Handle_OSD_SIGSYS_1 extends Handle_OSD_SIGSYS {
    constructor();
  }

  export declare class Handle_OSD_SIGSYS_2 extends Handle_OSD_SIGSYS {
    constructor(thePtr: OSD_SIGSYS);
  }

  export declare class Handle_OSD_SIGSYS_3 extends Handle_OSD_SIGSYS {
    constructor(theHandle: Handle_OSD_SIGSYS);
  }

  export declare class Handle_OSD_SIGSYS_4 extends Handle_OSD_SIGSYS {
    constructor(theHandle: Handle_OSD_SIGSYS);
  }

export declare class OSD_SIGSYS extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGSYS;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGSYS_1 extends OSD_SIGSYS {
    constructor();
  }

  export declare class OSD_SIGSYS_2 extends OSD_SIGSYS {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_ARRAY_BOUNDS_EXCEEDED): void;
  get(): OSD_Exception_ARRAY_BOUNDS_EXCEEDED;
  delete(): void;
}

  export declare class Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_1 extends Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
    constructor();
  }

  export declare class Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_2 extends Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
    constructor(thePtr: OSD_Exception_ARRAY_BOUNDS_EXCEEDED);
  }

  export declare class Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_3 extends Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
    constructor(theHandle: Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED);
  }

  export declare class Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_4 extends Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
    constructor(theHandle: Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED);
  }

export declare class OSD_Exception_ARRAY_BOUNDS_EXCEEDED extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_ARRAY_BOUNDS_EXCEEDED_1 extends OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
    constructor();
  }

  export declare class OSD_Exception_ARRAY_BOUNDS_EXCEEDED_2 extends OSD_Exception_ARRAY_BOUNDS_EXCEEDED {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_Protection {
  Values(System: OSD_SingleProtection, User: OSD_SingleProtection, Group: OSD_SingleProtection, World: OSD_SingleProtection): void;
  SetValues(System: OSD_SingleProtection, User: OSD_SingleProtection, Group: OSD_SingleProtection, World: OSD_SingleProtection): void;
  SetSystem(priv: OSD_SingleProtection): void;
  SetUser(priv: OSD_SingleProtection): void;
  SetGroup(priv: OSD_SingleProtection): void;
  SetWorld(priv: OSD_SingleProtection): void;
  System(): OSD_SingleProtection;
  User(): OSD_SingleProtection;
  Group(): OSD_SingleProtection;
  World(): OSD_SingleProtection;
  Add(aProt: OSD_SingleProtection, aRight: OSD_SingleProtection): void;
  Sub(aProt: OSD_SingleProtection, aRight: OSD_SingleProtection): void;
  delete(): void;
}

  export declare class OSD_Protection_1 extends OSD_Protection {
    constructor();
  }

  export declare class OSD_Protection_2 extends OSD_Protection {
    constructor(System: OSD_SingleProtection, User: OSD_SingleProtection, Group: OSD_SingleProtection, World: OSD_SingleProtection);
  }

export declare class Handle_OSD_Exception {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception): void;
  get(): OSD_Exception;
  delete(): void;
}

  export declare class Handle_OSD_Exception_1 extends Handle_OSD_Exception {
    constructor();
  }

  export declare class Handle_OSD_Exception_2 extends Handle_OSD_Exception {
    constructor(thePtr: OSD_Exception);
  }

  export declare class Handle_OSD_Exception_3 extends Handle_OSD_Exception {
    constructor(theHandle: Handle_OSD_Exception);
  }

  export declare class Handle_OSD_Exception_4 extends Handle_OSD_Exception {
    constructor(theHandle: Handle_OSD_Exception);
  }

export declare class OSD_Exception extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_1 extends OSD_Exception {
    constructor();
  }

  export declare class OSD_Exception_2 extends OSD_Exception {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_Exception_CTRL_BREAK extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_CTRL_BREAK;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_CTRL_BREAK_1 extends OSD_Exception_CTRL_BREAK {
    constructor();
  }

  export declare class OSD_Exception_CTRL_BREAK_2 extends OSD_Exception_CTRL_BREAK {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_CTRL_BREAK {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_CTRL_BREAK): void;
  get(): OSD_Exception_CTRL_BREAK;
  delete(): void;
}

  export declare class Handle_OSD_Exception_CTRL_BREAK_1 extends Handle_OSD_Exception_CTRL_BREAK {
    constructor();
  }

  export declare class Handle_OSD_Exception_CTRL_BREAK_2 extends Handle_OSD_Exception_CTRL_BREAK {
    constructor(thePtr: OSD_Exception_CTRL_BREAK);
  }

  export declare class Handle_OSD_Exception_CTRL_BREAK_3 extends Handle_OSD_Exception_CTRL_BREAK {
    constructor(theHandle: Handle_OSD_Exception_CTRL_BREAK);
  }

  export declare class Handle_OSD_Exception_CTRL_BREAK_4 extends Handle_OSD_Exception_CTRL_BREAK {
    constructor(theHandle: Handle_OSD_Exception_CTRL_BREAK);
  }

export declare class OSD_Chronometer {
  constructor(theThisThreadOnly: Standard_Boolean)
  IsStarted(): Standard_Boolean;
  Reset(): void;
  Restart(): void;
  Stop(): void;
  Start(): void;
  Show_1(): void;
  Show_2(theOStream: Standard_OStream): void;
  UserTimeCPU(): Quantity_AbsorbedDose;
  SystemTimeCPU(): Quantity_AbsorbedDose;
  Show_3(theUserSeconds: Quantity_AbsorbedDose): void;
  Show_4(theUserSec: Quantity_AbsorbedDose, theSystemSec: Quantity_AbsorbedDose): void;
  static GetProcessCPU(UserSeconds: Quantity_AbsorbedDose, SystemSeconds: Quantity_AbsorbedDose): void;
  static GetThreadCPU(UserSeconds: Quantity_AbsorbedDose, SystemSeconds: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_OSD_Exception_INT_DIVIDE_BY_ZERO {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_INT_DIVIDE_BY_ZERO): void;
  get(): OSD_Exception_INT_DIVIDE_BY_ZERO;
  delete(): void;
}

  export declare class Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_1 extends Handle_OSD_Exception_INT_DIVIDE_BY_ZERO {
    constructor();
  }

  export declare class Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_2 extends Handle_OSD_Exception_INT_DIVIDE_BY_ZERO {
    constructor(thePtr: OSD_Exception_INT_DIVIDE_BY_ZERO);
  }

  export declare class Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_3 extends Handle_OSD_Exception_INT_DIVIDE_BY_ZERO {
    constructor(theHandle: Handle_OSD_Exception_INT_DIVIDE_BY_ZERO);
  }

  export declare class Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_4 extends Handle_OSD_Exception_INT_DIVIDE_BY_ZERO {
    constructor(theHandle: Handle_OSD_Exception_INT_DIVIDE_BY_ZERO);
  }

export declare class OSD_Exception_INT_DIVIDE_BY_ZERO extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_INT_DIVIDE_BY_ZERO;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_INT_DIVIDE_BY_ZERO_1 extends OSD_Exception_INT_DIVIDE_BY_ZERO {
    constructor();
  }

  export declare class OSD_Exception_INT_DIVIDE_BY_ZERO_2 extends OSD_Exception_INT_DIVIDE_BY_ZERO {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_MAllocHook {
  constructor();
  static SetCallback(theCB: any): void;
  static GetCallback(): any;
  static GetLogFileHandler(): any;
  static GetCollectBySize(): any;
  delete(): void;
}

export declare class Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_DIVIDE_BY_ZERO): void;
  get(): OSD_Exception_FLT_DIVIDE_BY_ZERO;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_1 extends Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_2 extends Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO {
    constructor(thePtr: OSD_Exception_FLT_DIVIDE_BY_ZERO);
  }

  export declare class Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_3 extends Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO {
    constructor(theHandle: Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO);
  }

  export declare class Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_4 extends Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO {
    constructor(theHandle: Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO);
  }

export declare class OSD_Exception_FLT_DIVIDE_BY_ZERO extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_DIVIDE_BY_ZERO_1 extends OSD_Exception_FLT_DIVIDE_BY_ZERO {
    constructor();
  }

  export declare class OSD_Exception_FLT_DIVIDE_BY_ZERO_2 extends OSD_Exception_FLT_DIVIDE_BY_ZERO {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_Timer extends OSD_Chronometer {
  constructor(theThisThreadOnly: Standard_Boolean)
  Reset_1(theTimeElapsedSec: Quantity_AbsorbedDose): void;
  Reset_2(): void;
  Restart(): void;
  Show_1(): void;
  Show_2(os: Standard_OStream): void;
  Show_3(theSeconds: Quantity_AbsorbedDose, theMinutes: Graphic3d_ZLayerId, theHours: Graphic3d_ZLayerId, theCPUtime: Quantity_AbsorbedDose): void;
  Stop(): void;
  Start(): void;
  ElapsedTime(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class OSD_DirectoryIterator {
  Destroy(): void;
  Initialize(where: OSD_Path, Mask: XCAFDoc_PartId): void;
  More(): Standard_Boolean;
  Next(): void;
  Values(): OSD_Directory;
  Failed(): Standard_Boolean;
  Reset(): void;
  Perror(): void;
  Error(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class OSD_DirectoryIterator_1 extends OSD_DirectoryIterator {
    constructor();
  }

  export declare class OSD_DirectoryIterator_2 extends OSD_DirectoryIterator {
    constructor(where: OSD_Path, Mask: XCAFDoc_PartId);
  }

export declare type OSD_KindFile = {
  OSD_FILE: {};
  OSD_DIRECTORY: {};
  OSD_LINK: {};
  OSD_SOCKET: {};
  OSD_UNKNOWN: {};
}

export declare class OSD_SIGKILL extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGKILL;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGKILL_1 extends OSD_SIGKILL {
    constructor();
  }

  export declare class OSD_SIGKILL_2 extends OSD_SIGKILL {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGKILL {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGKILL): void;
  get(): OSD_SIGKILL;
  delete(): void;
}

  export declare class Handle_OSD_SIGKILL_1 extends Handle_OSD_SIGKILL {
    constructor();
  }

  export declare class Handle_OSD_SIGKILL_2 extends Handle_OSD_SIGKILL {
    constructor(thePtr: OSD_SIGKILL);
  }

  export declare class Handle_OSD_SIGKILL_3 extends Handle_OSD_SIGKILL {
    constructor(theHandle: Handle_OSD_SIGKILL);
  }

  export declare class Handle_OSD_SIGKILL_4 extends Handle_OSD_SIGKILL {
    constructor(theHandle: Handle_OSD_SIGKILL);
  }

export declare class OSD_PerfMeter {
  Init(theMeter: Standard_Character): void;
  Start(): void;
  Stop(): void;
  Tick(): void;
  Flush(): void;
  delete(): void;
}

  export declare class OSD_PerfMeter_1 extends OSD_PerfMeter {
    constructor();
  }

  export declare class OSD_PerfMeter_2 extends OSD_PerfMeter {
    constructor(theMeter: Standard_Character, theToAutoStart: Standard_Boolean);
  }

export declare class Handle_OSD_Exception_FLT_OVERFLOW {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_OVERFLOW): void;
  get(): OSD_Exception_FLT_OVERFLOW;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_OVERFLOW_1 extends Handle_OSD_Exception_FLT_OVERFLOW {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_OVERFLOW_2 extends Handle_OSD_Exception_FLT_OVERFLOW {
    constructor(thePtr: OSD_Exception_FLT_OVERFLOW);
  }

  export declare class Handle_OSD_Exception_FLT_OVERFLOW_3 extends Handle_OSD_Exception_FLT_OVERFLOW {
    constructor(theHandle: Handle_OSD_Exception_FLT_OVERFLOW);
  }

  export declare class Handle_OSD_Exception_FLT_OVERFLOW_4 extends Handle_OSD_Exception_FLT_OVERFLOW {
    constructor(theHandle: Handle_OSD_Exception_FLT_OVERFLOW);
  }

export declare class OSD_Exception_FLT_OVERFLOW extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_OVERFLOW;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_OVERFLOW_1 extends OSD_Exception_FLT_OVERFLOW {
    constructor();
  }

  export declare class OSD_Exception_FLT_OVERFLOW_2 extends OSD_Exception_FLT_OVERFLOW {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_NONCONTINUABLE_EXCEPTION): void;
  get(): OSD_Exception_NONCONTINUABLE_EXCEPTION;
  delete(): void;
}

  export declare class Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_1 extends Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION {
    constructor();
  }

  export declare class Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_2 extends Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION {
    constructor(thePtr: OSD_Exception_NONCONTINUABLE_EXCEPTION);
  }

  export declare class Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_3 extends Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION {
    constructor(theHandle: Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION);
  }

  export declare class Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_4 extends Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION {
    constructor(theHandle: Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION);
  }

export declare class OSD_Exception_NONCONTINUABLE_EXCEPTION extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_NONCONTINUABLE_EXCEPTION_1 extends OSD_Exception_NONCONTINUABLE_EXCEPTION {
    constructor();
  }

  export declare class OSD_Exception_NONCONTINUABLE_EXCEPTION_2 extends OSD_Exception_NONCONTINUABLE_EXCEPTION {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_Exception_FLT_INEXACT_RESULT extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_INEXACT_RESULT;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_INEXACT_RESULT_1 extends OSD_Exception_FLT_INEXACT_RESULT {
    constructor();
  }

  export declare class OSD_Exception_FLT_INEXACT_RESULT_2 extends OSD_Exception_FLT_INEXACT_RESULT {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_FLT_INEXACT_RESULT {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_INEXACT_RESULT): void;
  get(): OSD_Exception_FLT_INEXACT_RESULT;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_INEXACT_RESULT_1 extends Handle_OSD_Exception_FLT_INEXACT_RESULT {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_INEXACT_RESULT_2 extends Handle_OSD_Exception_FLT_INEXACT_RESULT {
    constructor(thePtr: OSD_Exception_FLT_INEXACT_RESULT);
  }

  export declare class Handle_OSD_Exception_FLT_INEXACT_RESULT_3 extends Handle_OSD_Exception_FLT_INEXACT_RESULT {
    constructor(theHandle: Handle_OSD_Exception_FLT_INEXACT_RESULT);
  }

  export declare class Handle_OSD_Exception_FLT_INEXACT_RESULT_4 extends Handle_OSD_Exception_FLT_INEXACT_RESULT {
    constructor(theHandle: Handle_OSD_Exception_FLT_INEXACT_RESULT);
  }

export declare type OSD_FromWhere = {
  OSD_FromBeginning: {};
  OSD_FromHere: {};
  OSD_FromEnd: {};
}

export declare type OSD_LoadMode = {
  OSD_RTLD_LAZY: {};
  OSD_RTLD_NOW: {};
}

export declare class OSD_OSDError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_OSDError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_OSDError_1 extends OSD_OSDError {
    constructor();
  }

  export declare class OSD_OSDError_2 extends OSD_OSDError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_OSDError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_OSDError): void;
  get(): OSD_OSDError;
  delete(): void;
}

  export declare class Handle_OSD_OSDError_1 extends Handle_OSD_OSDError {
    constructor();
  }

  export declare class Handle_OSD_OSDError_2 extends Handle_OSD_OSDError {
    constructor(thePtr: OSD_OSDError);
  }

  export declare class Handle_OSD_OSDError_3 extends Handle_OSD_OSDError {
    constructor(theHandle: Handle_OSD_OSDError);
  }

  export declare class Handle_OSD_OSDError_4 extends Handle_OSD_OSDError {
    constructor(theHandle: Handle_OSD_OSDError);
  }

export declare type OSD_SignalMode = {
  OSD_SignalMode_AsIs: {};
  OSD_SignalMode_Set: {};
  OSD_SignalMode_SetUnhandled: {};
  OSD_SignalMode_Unset: {};
}

export declare class Handle_OSD_Exception_STACK_OVERFLOW {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_STACK_OVERFLOW): void;
  get(): OSD_Exception_STACK_OVERFLOW;
  delete(): void;
}

  export declare class Handle_OSD_Exception_STACK_OVERFLOW_1 extends Handle_OSD_Exception_STACK_OVERFLOW {
    constructor();
  }

  export declare class Handle_OSD_Exception_STACK_OVERFLOW_2 extends Handle_OSD_Exception_STACK_OVERFLOW {
    constructor(thePtr: OSD_Exception_STACK_OVERFLOW);
  }

  export declare class Handle_OSD_Exception_STACK_OVERFLOW_3 extends Handle_OSD_Exception_STACK_OVERFLOW {
    constructor(theHandle: Handle_OSD_Exception_STACK_OVERFLOW);
  }

  export declare class Handle_OSD_Exception_STACK_OVERFLOW_4 extends Handle_OSD_Exception_STACK_OVERFLOW {
    constructor(theHandle: Handle_OSD_Exception_STACK_OVERFLOW);
  }

export declare class OSD_Exception_STACK_OVERFLOW extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_STACK_OVERFLOW;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_STACK_OVERFLOW_1 extends OSD_Exception_STACK_OVERFLOW {
    constructor();
  }

  export declare class OSD_Exception_STACK_OVERFLOW_2 extends OSD_Exception_STACK_OVERFLOW {
    constructor(theMessage: Standard_CString);
  }

export declare class OSD_SIGQUIT extends OSD_Signal {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_SIGQUIT;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_SIGQUIT_1 extends OSD_SIGQUIT {
    constructor();
  }

  export declare class OSD_SIGQUIT_2 extends OSD_SIGQUIT {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_SIGQUIT {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_SIGQUIT): void;
  get(): OSD_SIGQUIT;
  delete(): void;
}

  export declare class Handle_OSD_SIGQUIT_1 extends Handle_OSD_SIGQUIT {
    constructor();
  }

  export declare class Handle_OSD_SIGQUIT_2 extends Handle_OSD_SIGQUIT {
    constructor(thePtr: OSD_SIGQUIT);
  }

  export declare class Handle_OSD_SIGQUIT_3 extends Handle_OSD_SIGQUIT {
    constructor(theHandle: Handle_OSD_SIGQUIT);
  }

  export declare class Handle_OSD_SIGQUIT_4 extends Handle_OSD_SIGQUIT {
    constructor(theHandle: Handle_OSD_SIGQUIT);
  }

export declare class OSD_Parallel {
  constructor();
  static ToUseOcctThreads(): Standard_Boolean;
  static SetUseOcctThreads(theToUseOcct: Standard_Boolean): void;
  static NbLogicalProcessors(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_OSD_Exception_FLT_STACK_CHECK {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_FLT_STACK_CHECK): void;
  get(): OSD_Exception_FLT_STACK_CHECK;
  delete(): void;
}

  export declare class Handle_OSD_Exception_FLT_STACK_CHECK_1 extends Handle_OSD_Exception_FLT_STACK_CHECK {
    constructor();
  }

  export declare class Handle_OSD_Exception_FLT_STACK_CHECK_2 extends Handle_OSD_Exception_FLT_STACK_CHECK {
    constructor(thePtr: OSD_Exception_FLT_STACK_CHECK);
  }

  export declare class Handle_OSD_Exception_FLT_STACK_CHECK_3 extends Handle_OSD_Exception_FLT_STACK_CHECK {
    constructor(theHandle: Handle_OSD_Exception_FLT_STACK_CHECK);
  }

  export declare class Handle_OSD_Exception_FLT_STACK_CHECK_4 extends Handle_OSD_Exception_FLT_STACK_CHECK {
    constructor(theHandle: Handle_OSD_Exception_FLT_STACK_CHECK);
  }

export declare class OSD_Exception_FLT_STACK_CHECK extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_FLT_STACK_CHECK;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_FLT_STACK_CHECK_1 extends OSD_Exception_FLT_STACK_CHECK {
    constructor();
  }

  export declare class OSD_Exception_FLT_STACK_CHECK_2 extends OSD_Exception_FLT_STACK_CHECK {
    constructor(theMessage: Standard_CString);
  }

export declare type OSD_SingleProtection = {
  OSD_None: {};
  OSD_R: {};
  OSD_W: {};
  OSD_RW: {};
  OSD_X: {};
  OSD_RX: {};
  OSD_WX: {};
  OSD_RWX: {};
  OSD_D: {};
  OSD_RD: {};
  OSD_WD: {};
  OSD_RWD: {};
  OSD_XD: {};
  OSD_RXD: {};
  OSD_WXD: {};
  OSD_RWXD: {};
}

export declare class OSD_Exception_ACCESS_VIOLATION extends OSD_Exception {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_OSD_Exception_ACCESS_VIOLATION;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class OSD_Exception_ACCESS_VIOLATION_1 extends OSD_Exception_ACCESS_VIOLATION {
    constructor();
  }

  export declare class OSD_Exception_ACCESS_VIOLATION_2 extends OSD_Exception_ACCESS_VIOLATION {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_OSD_Exception_ACCESS_VIOLATION {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: OSD_Exception_ACCESS_VIOLATION): void;
  get(): OSD_Exception_ACCESS_VIOLATION;
  delete(): void;
}

  export declare class Handle_OSD_Exception_ACCESS_VIOLATION_1 extends Handle_OSD_Exception_ACCESS_VIOLATION {
    constructor();
  }

  export declare class Handle_OSD_Exception_ACCESS_VIOLATION_2 extends Handle_OSD_Exception_ACCESS_VIOLATION {
    constructor(thePtr: OSD_Exception_ACCESS_VIOLATION);
  }

  export declare class Handle_OSD_Exception_ACCESS_VIOLATION_3 extends Handle_OSD_Exception_ACCESS_VIOLATION {
    constructor(theHandle: Handle_OSD_Exception_ACCESS_VIOLATION);
  }

  export declare class Handle_OSD_Exception_ACCESS_VIOLATION_4 extends Handle_OSD_Exception_ACCESS_VIOLATION {
    constructor(theHandle: Handle_OSD_Exception_ACCESS_VIOLATION);
  }

export declare class Plate_SequenceOfLinearXYZConstraint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Plate_SequenceOfLinearXYZConstraint): Plate_SequenceOfLinearXYZConstraint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Plate_LinearXYZConstraint): void;
  Append_2(theSeq: Plate_SequenceOfLinearXYZConstraint): void;
  Prepend_1(theItem: Plate_LinearXYZConstraint): void;
  Prepend_2(theSeq: Plate_SequenceOfLinearXYZConstraint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Plate_LinearXYZConstraint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Plate_SequenceOfLinearXYZConstraint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Plate_SequenceOfLinearXYZConstraint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Plate_LinearXYZConstraint): void;
  Split(theIndex: Standard_Integer, theSeq: Plate_SequenceOfLinearXYZConstraint): void;
  First(): Plate_LinearXYZConstraint;
  ChangeFirst(): Plate_LinearXYZConstraint;
  Last(): Plate_LinearXYZConstraint;
  ChangeLast(): Plate_LinearXYZConstraint;
  Value(theIndex: Standard_Integer): Plate_LinearXYZConstraint;
  ChangeValue(theIndex: Standard_Integer): Plate_LinearXYZConstraint;
  SetValue(theIndex: Standard_Integer, theItem: Plate_LinearXYZConstraint): void;
  delete(): void;
}

  export declare class Plate_SequenceOfLinearXYZConstraint_1 extends Plate_SequenceOfLinearXYZConstraint {
    constructor();
  }

  export declare class Plate_SequenceOfLinearXYZConstraint_2 extends Plate_SequenceOfLinearXYZConstraint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Plate_SequenceOfLinearXYZConstraint_3 extends Plate_SequenceOfLinearXYZConstraint {
    constructor(theOther: Plate_SequenceOfLinearXYZConstraint);
  }

export declare class Plate_FreeGtoCConstraint {
  nb_PPC(): Graphic3d_ZLayerId;
  GetPPC(Index: Graphic3d_ZLayerId): Plate_PinpointConstraint;
  nb_LSC(): Graphic3d_ZLayerId;
  LSC(Index: Graphic3d_ZLayerId): Plate_LinearScalarConstraint;
  delete(): void;
}

  export declare class Plate_FreeGtoCConstraint_1 extends Plate_FreeGtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, IncrementalLoad: Quantity_AbsorbedDose, orientation: Graphic3d_ZLayerId);
  }

  export declare class Plate_FreeGtoCConstraint_2 extends Plate_FreeGtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, D2S: Plate_D2, D2T: Plate_D2, IncrementalLoad: Quantity_AbsorbedDose, orientation: Graphic3d_ZLayerId);
  }

  export declare class Plate_FreeGtoCConstraint_3 extends Plate_FreeGtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, D2S: Plate_D2, D2T: Plate_D2, D3S: Plate_D3, D3T: Plate_D3, IncrementalLoad: Quantity_AbsorbedDose, orientation: Graphic3d_ZLayerId);
  }

export declare class Plate_LinearXYZConstraint {
  GetPPC(): Plate_Array1OfPinpointConstraint;
  Coeff(): TColStd_Array2OfReal;
  SetPPC(Index: Graphic3d_ZLayerId, Value: Plate_PinpointConstraint): void;
  SetCoeff(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Plate_LinearXYZConstraint_1 extends Plate_LinearXYZConstraint {
    constructor();
  }

  export declare class Plate_LinearXYZConstraint_2 extends Plate_LinearXYZConstraint {
    constructor(thePPC: Plate_Array1OfPinpointConstraint, theCoeff: TColStd_Array1OfReal);
  }

  export declare class Plate_LinearXYZConstraint_3 extends Plate_LinearXYZConstraint {
    constructor(thePPC: Plate_Array1OfPinpointConstraint, theCoeff: TColStd_Array2OfReal);
  }

  export declare class Plate_LinearXYZConstraint_4 extends Plate_LinearXYZConstraint {
    constructor(ColLen: Graphic3d_ZLayerId, RowLen: Graphic3d_ZLayerId);
  }

export declare class Plate_D3 {
  delete(): void;
}

  export declare class Plate_D3_1 extends Plate_D3 {
    constructor(duuu: gp_XYZ, duuv: gp_XYZ, duvv: gp_XYZ, dvvv: gp_XYZ);
  }

  export declare class Plate_D3_2 extends Plate_D3 {
    constructor(ref: Plate_D3);
  }

export declare class Plate_Plate {
  Copy(Ref: Plate_Plate): Plate_Plate;
  Load_1(PConst: Plate_PinpointConstraint): void;
  Load_2(LXYZConst: Plate_LinearXYZConstraint): void;
  Load_3(LScalarConst: Plate_LinearScalarConstraint): void;
  Load_4(GTConst: Plate_GlobalTranslationConstraint): void;
  Load_5(LConst: Plate_LineConstraint): void;
  Load_6(PConst: Plate_PlaneConstraint): void;
  Load_7(SCConst: Plate_SampledCurveConstraint): void;
  Load_8(GtoCConst: Plate_GtoCConstraint): void;
  Load_9(FGtoCConst: Plate_FreeGtoCConstraint): void;
  SolveTI(ord: Graphic3d_ZLayerId, anisotropie: Quantity_AbsorbedDose, theProgress: Message_ProgressRange): void;
  IsDone(): Standard_Boolean;
  destroy(): void;
  Init(): void;
  Evaluate(point2d: gp_XY): gp_XYZ;
  EvaluateDerivative(point2d: gp_XY, iu: Graphic3d_ZLayerId, iv: Graphic3d_ZLayerId): gp_XYZ;
  CoefPol(Coefs: Handle_TColgp_HArray2OfXYZ): void;
  SetPolynomialPartOnly(PPOnly: Standard_Boolean): void;
  Continuity(): Graphic3d_ZLayerId;
  UVBox(UMin: Quantity_AbsorbedDose, UMax: Quantity_AbsorbedDose, VMin: Quantity_AbsorbedDose, VMax: Quantity_AbsorbedDose): void;
  UVConstraints(Seq: TColgp_SequenceOfXY): void;
  delete(): void;
}

  export declare class Plate_Plate_1 extends Plate_Plate {
    constructor();
  }

  export declare class Plate_Plate_2 extends Plate_Plate {
    constructor(Ref: Plate_Plate);
  }

export declare class Plate_D1 {
  DU(): gp_XYZ;
  DV(): gp_XYZ;
  delete(): void;
}

  export declare class Plate_D1_1 extends Plate_D1 {
    constructor(du: gp_XYZ, dv: gp_XYZ);
  }

  export declare class Plate_D1_2 extends Plate_D1 {
    constructor(ref: Plate_D1);
  }

export declare class Plate_D2 {
  delete(): void;
}

  export declare class Plate_D2_1 extends Plate_D2 {
    constructor(duu: gp_XYZ, duv: gp_XYZ, dvv: gp_XYZ);
  }

  export declare class Plate_D2_2 extends Plate_D2 {
    constructor(ref: Plate_D2);
  }

export declare class Plate_Array1OfPinpointConstraint {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Plate_PinpointConstraint): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Plate_Array1OfPinpointConstraint): Plate_Array1OfPinpointConstraint;
  Move(theOther: Plate_Array1OfPinpointConstraint): Plate_Array1OfPinpointConstraint;
  First(): Plate_PinpointConstraint;
  ChangeFirst(): Plate_PinpointConstraint;
  Last(): Plate_PinpointConstraint;
  ChangeLast(): Plate_PinpointConstraint;
  Value(theIndex: Standard_Integer): Plate_PinpointConstraint;
  ChangeValue(theIndex: Standard_Integer): Plate_PinpointConstraint;
  SetValue(theIndex: Standard_Integer, theItem: Plate_PinpointConstraint): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Plate_Array1OfPinpointConstraint_1 extends Plate_Array1OfPinpointConstraint {
    constructor();
  }

  export declare class Plate_Array1OfPinpointConstraint_2 extends Plate_Array1OfPinpointConstraint {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Plate_Array1OfPinpointConstraint_3 extends Plate_Array1OfPinpointConstraint {
    constructor(theOther: Plate_Array1OfPinpointConstraint);
  }

  export declare class Plate_Array1OfPinpointConstraint_4 extends Plate_Array1OfPinpointConstraint {
    constructor(theOther: Plate_Array1OfPinpointConstraint);
  }

  export declare class Plate_Array1OfPinpointConstraint_5 extends Plate_Array1OfPinpointConstraint {
    constructor(theBegin: Plate_PinpointConstraint, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Plate_LinearScalarConstraint {
  GetPPC(): Plate_Array1OfPinpointConstraint;
  Coeff(): TColgp_Array2OfXYZ;
  SetPPC(Index: Graphic3d_ZLayerId, Value: Plate_PinpointConstraint): void;
  SetCoeff(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Value: gp_XYZ): void;
  delete(): void;
}

  export declare class Plate_LinearScalarConstraint_1 extends Plate_LinearScalarConstraint {
    constructor();
  }

  export declare class Plate_LinearScalarConstraint_2 extends Plate_LinearScalarConstraint {
    constructor(thePPC1: Plate_PinpointConstraint, theCoeff: gp_XYZ);
  }

  export declare class Plate_LinearScalarConstraint_3 extends Plate_LinearScalarConstraint {
    constructor(thePPC: Plate_Array1OfPinpointConstraint, theCoeff: TColgp_Array1OfXYZ);
  }

  export declare class Plate_LinearScalarConstraint_4 extends Plate_LinearScalarConstraint {
    constructor(thePPC: Plate_Array1OfPinpointConstraint, theCoeff: TColgp_Array2OfXYZ);
  }

  export declare class Plate_LinearScalarConstraint_5 extends Plate_LinearScalarConstraint {
    constructor(ColLen: Graphic3d_ZLayerId, RowLen: Graphic3d_ZLayerId);
  }

export declare class Plate_SequenceOfLinearScalarConstraint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Plate_SequenceOfLinearScalarConstraint): Plate_SequenceOfLinearScalarConstraint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Plate_LinearScalarConstraint): void;
  Append_2(theSeq: Plate_SequenceOfLinearScalarConstraint): void;
  Prepend_1(theItem: Plate_LinearScalarConstraint): void;
  Prepend_2(theSeq: Plate_SequenceOfLinearScalarConstraint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Plate_LinearScalarConstraint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Plate_SequenceOfLinearScalarConstraint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Plate_SequenceOfLinearScalarConstraint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Plate_LinearScalarConstraint): void;
  Split(theIndex: Standard_Integer, theSeq: Plate_SequenceOfLinearScalarConstraint): void;
  First(): Plate_LinearScalarConstraint;
  ChangeFirst(): Plate_LinearScalarConstraint;
  Last(): Plate_LinearScalarConstraint;
  ChangeLast(): Plate_LinearScalarConstraint;
  Value(theIndex: Standard_Integer): Plate_LinearScalarConstraint;
  ChangeValue(theIndex: Standard_Integer): Plate_LinearScalarConstraint;
  SetValue(theIndex: Standard_Integer, theItem: Plate_LinearScalarConstraint): void;
  delete(): void;
}

  export declare class Plate_SequenceOfLinearScalarConstraint_1 extends Plate_SequenceOfLinearScalarConstraint {
    constructor();
  }

  export declare class Plate_SequenceOfLinearScalarConstraint_2 extends Plate_SequenceOfLinearScalarConstraint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Plate_SequenceOfLinearScalarConstraint_3 extends Plate_SequenceOfLinearScalarConstraint {
    constructor(theOther: Plate_SequenceOfLinearScalarConstraint);
  }

export declare class Plate_SampledCurveConstraint {
  constructor(SOPPC: Plate_SequenceOfPinpointConstraint, n: Graphic3d_ZLayerId)
  LXYZC(): Plate_LinearXYZConstraint;
  delete(): void;
}

export declare class Plate_PinpointConstraint {
  Pnt2d(): gp_XY;
  Idu(): Graphic3d_ZLayerId;
  Idv(): Graphic3d_ZLayerId;
  Value(): gp_XYZ;
  delete(): void;
}

  export declare class Plate_PinpointConstraint_1 extends Plate_PinpointConstraint {
    constructor();
  }

  export declare class Plate_PinpointConstraint_2 extends Plate_PinpointConstraint {
    constructor(point2d: gp_XY, ImposedValue: gp_XYZ, iu: Graphic3d_ZLayerId, iv: Graphic3d_ZLayerId);
  }

export declare class Plate_GlobalTranslationConstraint {
  constructor(SOfXY: TColgp_SequenceOfXY)
  LXYZC(): Plate_LinearXYZConstraint;
  delete(): void;
}

export declare class Plate_PlaneConstraint {
  constructor(point2d: gp_XY, pln: gp_Pln, iu: Graphic3d_ZLayerId, iv: Graphic3d_ZLayerId)
  LSC(): Plate_LinearScalarConstraint;
  delete(): void;
}

export declare class Plate_SequenceOfPinpointConstraint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Plate_SequenceOfPinpointConstraint): Plate_SequenceOfPinpointConstraint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Plate_PinpointConstraint): void;
  Append_2(theSeq: Plate_SequenceOfPinpointConstraint): void;
  Prepend_1(theItem: Plate_PinpointConstraint): void;
  Prepend_2(theSeq: Plate_SequenceOfPinpointConstraint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Plate_PinpointConstraint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Plate_SequenceOfPinpointConstraint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Plate_SequenceOfPinpointConstraint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Plate_PinpointConstraint): void;
  Split(theIndex: Standard_Integer, theSeq: Plate_SequenceOfPinpointConstraint): void;
  First(): Plate_PinpointConstraint;
  ChangeFirst(): Plate_PinpointConstraint;
  Last(): Plate_PinpointConstraint;
  ChangeLast(): Plate_PinpointConstraint;
  Value(theIndex: Standard_Integer): Plate_PinpointConstraint;
  ChangeValue(theIndex: Standard_Integer): Plate_PinpointConstraint;
  SetValue(theIndex: Standard_Integer, theItem: Plate_PinpointConstraint): void;
  delete(): void;
}

  export declare class Plate_SequenceOfPinpointConstraint_1 extends Plate_SequenceOfPinpointConstraint {
    constructor();
  }

  export declare class Plate_SequenceOfPinpointConstraint_2 extends Plate_SequenceOfPinpointConstraint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Plate_SequenceOfPinpointConstraint_3 extends Plate_SequenceOfPinpointConstraint {
    constructor(theOther: Plate_SequenceOfPinpointConstraint);
  }

export declare class Handle_Plate_HArray1OfPinpointConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Plate_HArray1OfPinpointConstraint): void;
  get(): Plate_HArray1OfPinpointConstraint;
  delete(): void;
}

  export declare class Handle_Plate_HArray1OfPinpointConstraint_1 extends Handle_Plate_HArray1OfPinpointConstraint {
    constructor();
  }

  export declare class Handle_Plate_HArray1OfPinpointConstraint_2 extends Handle_Plate_HArray1OfPinpointConstraint {
    constructor(thePtr: Plate_HArray1OfPinpointConstraint);
  }

  export declare class Handle_Plate_HArray1OfPinpointConstraint_3 extends Handle_Plate_HArray1OfPinpointConstraint {
    constructor(theHandle: Handle_Plate_HArray1OfPinpointConstraint);
  }

  export declare class Handle_Plate_HArray1OfPinpointConstraint_4 extends Handle_Plate_HArray1OfPinpointConstraint {
    constructor(theHandle: Handle_Plate_HArray1OfPinpointConstraint);
  }

export declare class Plate_GtoCConstraint {
  nb_PPC(): Graphic3d_ZLayerId;
  GetPPC(Index: Graphic3d_ZLayerId): Plate_PinpointConstraint;
  D1SurfInit(): Plate_D1;
  delete(): void;
}

  export declare class Plate_GtoCConstraint_1 extends Plate_GtoCConstraint {
    constructor(ref: Plate_GtoCConstraint);
  }

  export declare class Plate_GtoCConstraint_2 extends Plate_GtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1);
  }

  export declare class Plate_GtoCConstraint_3 extends Plate_GtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, nP: gp_XYZ);
  }

  export declare class Plate_GtoCConstraint_4 extends Plate_GtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, D2S: Plate_D2, D2T: Plate_D2);
  }

  export declare class Plate_GtoCConstraint_5 extends Plate_GtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, D2S: Plate_D2, D2T: Plate_D2, nP: gp_XYZ);
  }

  export declare class Plate_GtoCConstraint_6 extends Plate_GtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, D2S: Plate_D2, D2T: Plate_D2, D3S: Plate_D3, D3T: Plate_D3);
  }

  export declare class Plate_GtoCConstraint_7 extends Plate_GtoCConstraint {
    constructor(point2d: gp_XY, D1S: Plate_D1, D1T: Plate_D1, D2S: Plate_D2, D2T: Plate_D2, D3S: Plate_D3, D3T: Plate_D3, nP: gp_XYZ);
  }

export declare class Plate_LineConstraint {
  constructor(point2d: gp_XY, lin: gp_Lin, iu: Graphic3d_ZLayerId, iv: Graphic3d_ZLayerId)
  LSC(): Plate_LinearScalarConstraint;
  delete(): void;
}

export declare class StdLDrivers {
  constructor();
  static Factory(aGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static BindTypes(theMap: StdObjMgt_MapOfInstantiators): void;
  delete(): void;
}

export declare class StdLDrivers_DocumentRetrievalDriver extends PCDM_RetrievalDriver {
  constructor();
  CreateDocument(): Handle_CDM_Document;
  Read_1(theFileName: TCollection_ExtendedString, theNewDocument: Handle_CDM_Document, theApplication: Handle_CDM_Application, theRange: Message_ProgressRange): void;
  Read_2(theIStream: Standard_IStream, theStorageData: Handle_Storage_Data, theDoc: Handle_CDM_Document, theApplication: Handle_CDM_Application, theRange: Message_ProgressRange): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class LocalAnalysis_CurveContinuity {
  constructor(Curv1: Handle_Geom_Curve, u1: Quantity_AbsorbedDose, Curv2: Handle_Geom_Curve, u2: Quantity_AbsorbedDose, Order: GeomAbs_Shape, EpsNul: Quantity_AbsorbedDose, EpsC0: Quantity_AbsorbedDose, EpsC1: Quantity_AbsorbedDose, EpsC2: Quantity_AbsorbedDose, EpsG1: Quantity_AbsorbedDose, EpsG2: Quantity_AbsorbedDose, Percent: Quantity_AbsorbedDose, Maxlen: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  StatusError(): LocalAnalysis_StatusErrorType;
  ContinuityStatus(): GeomAbs_Shape;
  C0Value(): Quantity_AbsorbedDose;
  C1Angle(): Quantity_AbsorbedDose;
  C1Ratio(): Quantity_AbsorbedDose;
  C2Angle(): Quantity_AbsorbedDose;
  C2Ratio(): Quantity_AbsorbedDose;
  G1Angle(): Quantity_AbsorbedDose;
  G2Angle(): Quantity_AbsorbedDose;
  G2CurvatureVariation(): Quantity_AbsorbedDose;
  IsC0(): Standard_Boolean;
  IsC1(): Standard_Boolean;
  IsC2(): Standard_Boolean;
  IsG1(): Standard_Boolean;
  IsG2(): Standard_Boolean;
  delete(): void;
}

export declare type LocalAnalysis_StatusErrorType = {
  LocalAnalysis_NullFirstDerivative: {};
  LocalAnalysis_NullSecondDerivative: {};
  LocalAnalysis_TangentNotDefined: {};
  LocalAnalysis_NormalNotDefined: {};
  LocalAnalysis_CurvatureNotDefined: {};
}

export declare class LocalAnalysis {
  constructor();
  static Dump_1(surfconti: LocalAnalysis_SurfaceContinuity, o: Standard_OStream): void;
  static Dump_2(curvconti: LocalAnalysis_CurveContinuity, o: Standard_OStream): void;
  delete(): void;
}

export declare class LocalAnalysis_SurfaceContinuity {
  ComputeAnalysis(Surf1: GeomLProp_SLProps, Surf2: GeomLProp_SLProps, Order: GeomAbs_Shape): void;
  IsDone(): Standard_Boolean;
  ContinuityStatus(): GeomAbs_Shape;
  StatusError(): LocalAnalysis_StatusErrorType;
  C0Value(): Quantity_AbsorbedDose;
  C1UAngle(): Quantity_AbsorbedDose;
  C1URatio(): Quantity_AbsorbedDose;
  C1VAngle(): Quantity_AbsorbedDose;
  C1VRatio(): Quantity_AbsorbedDose;
  C2UAngle(): Quantity_AbsorbedDose;
  C2URatio(): Quantity_AbsorbedDose;
  C2VAngle(): Quantity_AbsorbedDose;
  C2VRatio(): Quantity_AbsorbedDose;
  G1Angle(): Quantity_AbsorbedDose;
  G2CurvatureGap(): Quantity_AbsorbedDose;
  IsC0(): Standard_Boolean;
  IsC1(): Standard_Boolean;
  IsC2(): Standard_Boolean;
  IsG1(): Standard_Boolean;
  IsG2(): Standard_Boolean;
  delete(): void;
}

  export declare class LocalAnalysis_SurfaceContinuity_1 extends LocalAnalysis_SurfaceContinuity {
    constructor(Surf1: Handle_Geom_Surface, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, Surf2: Handle_Geom_Surface, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Order: GeomAbs_Shape, EpsNul: Quantity_AbsorbedDose, EpsC0: Quantity_AbsorbedDose, EpsC1: Quantity_AbsorbedDose, EpsC2: Quantity_AbsorbedDose, EpsG1: Quantity_AbsorbedDose, Percent: Quantity_AbsorbedDose, Maxlen: Quantity_AbsorbedDose);
  }

  export declare class LocalAnalysis_SurfaceContinuity_2 extends LocalAnalysis_SurfaceContinuity {
    constructor(curv1: Handle_Geom2d_Curve, curv2: Handle_Geom2d_Curve, U: Quantity_AbsorbedDose, Surf1: Handle_Geom_Surface, Surf2: Handle_Geom_Surface, Order: GeomAbs_Shape, EpsNul: Quantity_AbsorbedDose, EpsC0: Quantity_AbsorbedDose, EpsC1: Quantity_AbsorbedDose, EpsC2: Quantity_AbsorbedDose, EpsG1: Quantity_AbsorbedDose, Percent: Quantity_AbsorbedDose, Maxlen: Quantity_AbsorbedDose);
  }

  export declare class LocalAnalysis_SurfaceContinuity_3 extends LocalAnalysis_SurfaceContinuity {
    constructor(EpsNul: Quantity_AbsorbedDose, EpsC0: Quantity_AbsorbedDose, EpsC1: Quantity_AbsorbedDose, EpsC2: Quantity_AbsorbedDose, EpsG1: Quantity_AbsorbedDose, Percent: Quantity_AbsorbedDose, Maxlen: Quantity_AbsorbedDose);
  }

export declare type CDF_SubComponentStatus = {
  CDF_SCS_Consistent: {};
  CDF_SCS_Unconsistent: {};
  CDF_SCS_Stored: {};
  CDF_SCS_Modified: {};
}

export declare class CDF_Directory extends Standard_Transient {
  constructor()
  Add(aDocument: Handle_CDM_Document): void;
  Remove(aDocument: Handle_CDM_Document): void;
  Contains(aDocument: Handle_CDM_Document): Standard_Boolean;
  Last(): Handle_CDM_Document;
  Length(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_CDF_Directory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_Directory): void;
  get(): CDF_Directory;
  delete(): void;
}

  export declare class Handle_CDF_Directory_1 extends Handle_CDF_Directory {
    constructor();
  }

  export declare class Handle_CDF_Directory_2 extends Handle_CDF_Directory {
    constructor(thePtr: CDF_Directory);
  }

  export declare class Handle_CDF_Directory_3 extends Handle_CDF_Directory {
    constructor(theHandle: Handle_CDF_Directory);
  }

  export declare class Handle_CDF_Directory_4 extends Handle_CDF_Directory {
    constructor(theHandle: Handle_CDF_Directory);
  }

export declare class Handle_CDF_MetaDataDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_MetaDataDriver): void;
  get(): CDF_MetaDataDriver;
  delete(): void;
}

  export declare class Handle_CDF_MetaDataDriver_1 extends Handle_CDF_MetaDataDriver {
    constructor();
  }

  export declare class Handle_CDF_MetaDataDriver_2 extends Handle_CDF_MetaDataDriver {
    constructor(thePtr: CDF_MetaDataDriver);
  }

  export declare class Handle_CDF_MetaDataDriver_3 extends Handle_CDF_MetaDataDriver {
    constructor(theHandle: Handle_CDF_MetaDataDriver);
  }

  export declare class Handle_CDF_MetaDataDriver_4 extends Handle_CDF_MetaDataDriver {
    constructor(theHandle: Handle_CDF_MetaDataDriver);
  }

export declare class CDF_MetaDataDriver extends Standard_Transient {
  HasVersionCapability(): Standard_Boolean;
  CreateDependsOn(aFirstData: Handle_CDM_MetaData, aSecondData: Handle_CDM_MetaData): void;
  CreateReference(aFrom: Handle_CDM_MetaData, aTo: Handle_CDM_MetaData, aReferenceIdentifier: Graphic3d_ZLayerId, aToDocumentVersion: Graphic3d_ZLayerId): void;
  HasVersion(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString): Standard_Boolean;
  BuildFileName(aDocument: Handle_CDM_Document): TCollection_ExtendedString;
  SetName(aDocument: Handle_CDM_Document, aName: TCollection_ExtendedString): TCollection_ExtendedString;
  Find_1(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString): Standard_Boolean;
  HasReadPermission(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString): Standard_Boolean;
  MetaData_1(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString): Handle_CDM_MetaData;
  LastVersion(aMetaData: Handle_CDM_MetaData): Handle_CDM_MetaData;
  CreateMetaData(aDocument: Handle_CDM_Document, aFileName: TCollection_ExtendedString): Handle_CDM_MetaData;
  FindFolder(aFolder: TCollection_ExtendedString): Standard_Boolean;
  DefaultFolder(): TCollection_ExtendedString;
  ReferenceIterator(theMessageDriver: Handle_Message_Messenger): Handle_PCDM_ReferenceIterator;
  Find_2(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString): Standard_Boolean;
  MetaData_2(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString): Handle_CDM_MetaData;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class CDF_Store {
  constructor(aDocument: Handle_CDM_Document)
  Folder(): Handle_TCollection_HExtendedString;
  Name(): Handle_TCollection_HExtendedString;
  IsStored(): Standard_Boolean;
  IsModified(): Standard_Boolean;
  CurrentIsConsistent(): Standard_Boolean;
  IsConsistent(): Standard_Boolean;
  HasAPreviousVersion(): Standard_Boolean;
  PreviousVersion(): Handle_TCollection_HExtendedString;
  IsMainDocument(): Standard_Boolean;
  SetFolder_1(aFolder: TCollection_ExtendedString): Standard_Boolean;
  SetName_1(aName: Standard_ExtString): CDF_StoreSetNameStatus;
  SetComment(aComment: Standard_ExtString): void;
  Comment(): Handle_TCollection_HExtendedString;
  RecheckName(): CDF_StoreSetNameStatus;
  SetPreviousVersion(aPreviousVersion: Standard_ExtString): Standard_Boolean;
  Realize(theRange: Message_ProgressRange): void;
  Path(): Standard_ExtString;
  MetaDataPath(): Handle_TCollection_HExtendedString;
  Description(): Handle_TCollection_HExtendedString;
  SetCurrent(aPresentation: Standard_ExtString): void;
  SetMain(): void;
  StoreStatus(): PCDM_StoreStatus;
  AssociatedStatusText(): Standard_ExtString;
  SetName_2(aName: TCollection_ExtendedString): CDF_StoreSetNameStatus;
  SetFolder_2(aFolder: Standard_ExtString): Standard_Boolean;
  delete(): void;
}

export declare type CDF_StoreSetNameStatus = {
  CDF_SSNS_OK: {};
  CDF_SSNS_ReplacingAnExistentDocument: {};
  CDF_SSNS_OpenDocument: {};
}

export declare type CDF_TryStoreStatus = {
  CDF_TS_OK: {};
  CDF_TS_NoCurrentDocument: {};
  CDF_TS_NoDriver: {};
  CDF_TS_NoSubComponentDriver: {};
}

export declare class Handle_CDF_StoreList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_StoreList): void;
  get(): CDF_StoreList;
  delete(): void;
}

  export declare class Handle_CDF_StoreList_1 extends Handle_CDF_StoreList {
    constructor();
  }

  export declare class Handle_CDF_StoreList_2 extends Handle_CDF_StoreList {
    constructor(thePtr: CDF_StoreList);
  }

  export declare class Handle_CDF_StoreList_3 extends Handle_CDF_StoreList {
    constructor(theHandle: Handle_CDF_StoreList);
  }

  export declare class Handle_CDF_StoreList_4 extends Handle_CDF_StoreList {
    constructor(theHandle: Handle_CDF_StoreList);
  }

export declare class CDF_StoreList extends Standard_Transient {
  constructor(aDocument: Handle_CDM_Document)
  IsConsistent(): Standard_Boolean;
  Store(aMetaData: Handle_CDM_MetaData, aStatusAssociatedText: TCollection_ExtendedString, theRange: Message_ProgressRange): PCDM_StoreStatus;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_CDM_Document;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class CDF_Application extends CDM_Application {
  static Load(aGUID: Standard_GUID): Handle_CDF_Application;
  Open(aDocument: Handle_CDM_Document): void;
  CanClose(aDocument: Handle_CDM_Document): CDM_CanCloseStatus;
  Close(aDocument: Handle_CDM_Document): void;
  Retrieve_1(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, UseStorageConfiguration: Standard_Boolean, theRange: Message_ProgressRange): Handle_CDM_Document;
  Retrieve_2(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString, UseStorageConfiguration: Standard_Boolean, theRange: Message_ProgressRange): Handle_CDM_Document;
  CanRetrieve_1(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString): PCDM_ReaderStatus;
  CanRetrieve_2(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString): PCDM_ReaderStatus;
  GetRetrieveStatus(): PCDM_ReaderStatus;
  Read(theIStream: Standard_IStream, theRange: Message_ProgressRange): Handle_CDM_Document;
  ReaderFromFormat(aFormat: TCollection_ExtendedString): Handle_PCDM_Reader;
  WriterFromFormat(aFormat: TCollection_ExtendedString): Handle_PCDM_StorageDriver;
  Format(aFileName: TCollection_ExtendedString, theFormat: TCollection_ExtendedString): Standard_Boolean;
  DefaultFolder(): Standard_ExtString;
  SetDefaultFolder(aFolder: Standard_ExtString): Standard_Boolean;
  MetaDataDriver(): Handle_CDF_MetaDataDriver;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_CDF_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_Application): void;
  get(): CDF_Application;
  delete(): void;
}

  export declare class Handle_CDF_Application_1 extends Handle_CDF_Application {
    constructor();
  }

  export declare class Handle_CDF_Application_2 extends Handle_CDF_Application {
    constructor(thePtr: CDF_Application);
  }

  export declare class Handle_CDF_Application_3 extends Handle_CDF_Application {
    constructor(theHandle: Handle_CDF_Application);
  }

  export declare class Handle_CDF_Application_4 extends Handle_CDF_Application {
    constructor(theHandle: Handle_CDF_Application);
  }

export declare class Handle_CDF_FWOSDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_FWOSDriver): void;
  get(): CDF_FWOSDriver;
  delete(): void;
}

  export declare class Handle_CDF_FWOSDriver_1 extends Handle_CDF_FWOSDriver {
    constructor();
  }

  export declare class Handle_CDF_FWOSDriver_2 extends Handle_CDF_FWOSDriver {
    constructor(thePtr: CDF_FWOSDriver);
  }

  export declare class Handle_CDF_FWOSDriver_3 extends Handle_CDF_FWOSDriver {
    constructor(theHandle: Handle_CDF_FWOSDriver);
  }

  export declare class Handle_CDF_FWOSDriver_4 extends Handle_CDF_FWOSDriver {
    constructor(theHandle: Handle_CDF_FWOSDriver);
  }

export declare class CDF_FWOSDriver extends CDF_MetaDataDriver {
  constructor(theLookUpTable: CDM_MetaDataLookUpTable)
  Find(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString): Standard_Boolean;
  HasReadPermission(aFolder: TCollection_ExtendedString, aName: TCollection_ExtendedString, aVersion: TCollection_ExtendedString): Standard_Boolean;
  FindFolder(aFolder: TCollection_ExtendedString): Standard_Boolean;
  DefaultFolder(): TCollection_ExtendedString;
  BuildFileName(aDocument: Handle_CDM_Document): TCollection_ExtendedString;
  SetName(aDocument: Handle_CDM_Document, aName: TCollection_ExtendedString): TCollection_ExtendedString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type CDF_TypeOfActivation = {
  CDF_TOA_New: {};
  CDF_TOA_Modified: {};
  CDF_TOA_Unchanged: {};
}

export declare class CDF_MetaDataDriverFactory extends Standard_Transient {
  Build(): Handle_CDF_MetaDataDriver;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_CDF_MetaDataDriverFactory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_MetaDataDriverFactory): void;
  get(): CDF_MetaDataDriverFactory;
  delete(): void;
}

  export declare class Handle_CDF_MetaDataDriverFactory_1 extends Handle_CDF_MetaDataDriverFactory {
    constructor();
  }

  export declare class Handle_CDF_MetaDataDriverFactory_2 extends Handle_CDF_MetaDataDriverFactory {
    constructor(thePtr: CDF_MetaDataDriverFactory);
  }

  export declare class Handle_CDF_MetaDataDriverFactory_3 extends Handle_CDF_MetaDataDriverFactory {
    constructor(theHandle: Handle_CDF_MetaDataDriverFactory);
  }

  export declare class Handle_CDF_MetaDataDriverFactory_4 extends Handle_CDF_MetaDataDriverFactory {
    constructor(theHandle: Handle_CDF_MetaDataDriverFactory);
  }

export declare class CDF_MetaDataDriverError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_CDF_MetaDataDriverError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class CDF_MetaDataDriverError_1 extends CDF_MetaDataDriverError {
    constructor();
  }

  export declare class CDF_MetaDataDriverError_2 extends CDF_MetaDataDriverError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_CDF_MetaDataDriverError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: CDF_MetaDataDriverError): void;
  get(): CDF_MetaDataDriverError;
  delete(): void;
}

  export declare class Handle_CDF_MetaDataDriverError_1 extends Handle_CDF_MetaDataDriverError {
    constructor();
  }

  export declare class Handle_CDF_MetaDataDriverError_2 extends Handle_CDF_MetaDataDriverError {
    constructor(thePtr: CDF_MetaDataDriverError);
  }

  export declare class Handle_CDF_MetaDataDriverError_3 extends Handle_CDF_MetaDataDriverError {
    constructor(theHandle: Handle_CDF_MetaDataDriverError);
  }

  export declare class Handle_CDF_MetaDataDriverError_4 extends Handle_CDF_MetaDataDriverError {
    constructor(theHandle: Handle_CDF_MetaDataDriverError);
  }

export declare class XCAFView_Object extends Standard_Transient {
  SetName(theName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetType(theType: XCAFView_ProjectionType): void;
  Type(): XCAFView_ProjectionType;
  SetProjectionPoint(thePoint: gp_Pnt): void;
  ProjectionPoint(): gp_Pnt;
  SetViewDirection(theDirection: gp_Dir): void;
  ViewDirection(): gp_Dir;
  SetUpDirection(theDirection: gp_Dir): void;
  UpDirection(): gp_Dir;
  SetZoomFactor(theZoomFactor: Quantity_AbsorbedDose): void;
  ZoomFactor(): Quantity_AbsorbedDose;
  SetWindowHorizontalSize(theSize: Quantity_AbsorbedDose): void;
  WindowHorizontalSize(): Quantity_AbsorbedDose;
  SetWindowVerticalSize(theSize: Quantity_AbsorbedDose): void;
  WindowVerticalSize(): Quantity_AbsorbedDose;
  SetClippingExpression(theExpression: Handle_TCollection_HAsciiString): void;
  ClippingExpression(): Handle_TCollection_HAsciiString;
  UnsetFrontPlaneClipping(): void;
  HasFrontPlaneClipping(): Standard_Boolean;
  SetFrontPlaneDistance(theDistance: Quantity_AbsorbedDose): void;
  FrontPlaneDistance(): Quantity_AbsorbedDose;
  UnsetBackPlaneClipping(): void;
  HasBackPlaneClipping(): Standard_Boolean;
  SetBackPlaneDistance(theDistance: Quantity_AbsorbedDose): void;
  BackPlaneDistance(): Quantity_AbsorbedDose;
  SetViewVolumeSidesClipping(theViewVolumeSidesClipping: Standard_Boolean): void;
  HasViewVolumeSidesClipping(): Standard_Boolean;
  CreateGDTPoints(theLenght: Graphic3d_ZLayerId): void;
  HasGDTPoints(): Standard_Boolean;
  NbGDTPoints(): Graphic3d_ZLayerId;
  SetGDTPoint(theIndex: Graphic3d_ZLayerId, thePoint: gp_Pnt): void;
  GDTPoint(theIndex: Graphic3d_ZLayerId): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XCAFView_Object_1 extends XCAFView_Object {
    constructor();
  }

  export declare class XCAFView_Object_2 extends XCAFView_Object {
    constructor(theObj: Handle_XCAFView_Object);
  }

export declare class Handle_XCAFView_Object {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFView_Object): void;
  get(): XCAFView_Object;
  delete(): void;
}

  export declare class Handle_XCAFView_Object_1 extends Handle_XCAFView_Object {
    constructor();
  }

  export declare class Handle_XCAFView_Object_2 extends Handle_XCAFView_Object {
    constructor(thePtr: XCAFView_Object);
  }

  export declare class Handle_XCAFView_Object_3 extends Handle_XCAFView_Object {
    constructor(theHandle: Handle_XCAFView_Object);
  }

  export declare class Handle_XCAFView_Object_4 extends Handle_XCAFView_Object {
    constructor(theHandle: Handle_XCAFView_Object);
  }

export declare type XCAFView_ProjectionType = {
  XCAFView_ProjectionType_NoCamera: {};
  XCAFView_ProjectionType_Parallel: {};
  XCAFView_ProjectionType_Central: {};
}

export declare class GeomToStep_MakeToroidalSurface extends GeomToStep_Root {
  constructor(TorSurf: Handle_Geom_ToroidalSurface)
  Value(): Handle_StepGeom_ToroidalSurface;
  delete(): void;
}

export declare class GeomToStep_MakeConic extends GeomToStep_Root {
  Value(): Handle_StepGeom_Conic;
  delete(): void;
}

  export declare class GeomToStep_MakeConic_1 extends GeomToStep_MakeConic {
    constructor(C: Handle_Geom_Conic);
  }

  export declare class GeomToStep_MakeConic_2 extends GeomToStep_MakeConic {
    constructor(C: Handle_Geom2d_Conic);
  }

export declare class GeomToStep_MakeParabola extends GeomToStep_Root {
  Value(): Handle_StepGeom_Parabola;
  delete(): void;
}

  export declare class GeomToStep_MakeParabola_1 extends GeomToStep_MakeParabola {
    constructor(C: Handle_Geom2d_Parabola);
  }

  export declare class GeomToStep_MakeParabola_2 extends GeomToStep_MakeParabola {
    constructor(C: Handle_Geom_Parabola);
  }

export declare class GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve extends GeomToStep_Root {
  Value(): Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve;
  delete(): void;
}

  export declare class GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve_1 extends GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve {
    constructor(Bsplin: Handle_Geom_BSplineCurve);
  }

  export declare class GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve_2 extends GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve {
    constructor(Bsplin: Handle_Geom2d_BSplineCurve);
  }

export declare class GeomToStep_MakeEllipse extends GeomToStep_Root {
  Value(): Handle_StepGeom_Ellipse;
  delete(): void;
}

  export declare class GeomToStep_MakeEllipse_1 extends GeomToStep_MakeEllipse {
    constructor(C: gp_Elips);
  }

  export declare class GeomToStep_MakeEllipse_2 extends GeomToStep_MakeEllipse {
    constructor(C: Handle_Geom_Ellipse);
  }

  export declare class GeomToStep_MakeEllipse_3 extends GeomToStep_MakeEllipse {
    constructor(C: Handle_Geom2d_Ellipse);
  }

export declare class GeomToStep_MakeSphericalSurface extends GeomToStep_Root {
  constructor(CSurf: Handle_Geom_SphericalSurface)
  Value(): Handle_StepGeom_SphericalSurface;
  delete(): void;
}

export declare class GeomToStep_MakeSurfaceOfLinearExtrusion extends GeomToStep_Root {
  constructor(CSurf: Handle_Geom_SurfaceOfLinearExtrusion)
  Value(): Handle_StepGeom_SurfaceOfLinearExtrusion;
  delete(): void;
}

export declare class GeomToStep_MakeSurface extends GeomToStep_Root {
  constructor(C: Handle_Geom_Surface)
  Value(): Handle_StepGeom_Surface;
  delete(): void;
}

export declare class GeomToStep_MakeSurfaceOfRevolution extends GeomToStep_Root {
  constructor(RevSurf: Handle_Geom_SurfaceOfRevolution)
  Value(): Handle_StepGeom_SurfaceOfRevolution;
  delete(): void;
}

export declare class GeomToStep_MakeCircle extends GeomToStep_Root {
  Value(): Handle_StepGeom_Circle;
  delete(): void;
}

  export declare class GeomToStep_MakeCircle_1 extends GeomToStep_MakeCircle {
    constructor(C: gp_Circ);
  }

  export declare class GeomToStep_MakeCircle_2 extends GeomToStep_MakeCircle {
    constructor(C: Handle_Geom_Circle);
  }

  export declare class GeomToStep_MakeCircle_3 extends GeomToStep_MakeCircle {
    constructor(C: Handle_Geom2d_Circle);
  }

export declare class GeomToStep_MakeAxis2Placement2d extends GeomToStep_Root {
  Value(): Handle_StepGeom_Axis2Placement2d;
  delete(): void;
}

  export declare class GeomToStep_MakeAxis2Placement2d_1 extends GeomToStep_MakeAxis2Placement2d {
    constructor(A: gp_Ax2);
  }

  export declare class GeomToStep_MakeAxis2Placement2d_2 extends GeomToStep_MakeAxis2Placement2d {
    constructor(A: gp_Ax22d);
  }

export declare class GeomToStep_MakePolyline extends GeomToStep_Root {
  Value(): Handle_StepGeom_Polyline;
  delete(): void;
}

  export declare class GeomToStep_MakePolyline_1 extends GeomToStep_MakePolyline {
    constructor(P: TColgp_Array1OfPnt);
  }

  export declare class GeomToStep_MakePolyline_2 extends GeomToStep_MakePolyline {
    constructor(P: TColgp_Array1OfPnt2d);
  }

export declare class GeomToStep_MakeConicalSurface extends GeomToStep_Root {
  constructor(CSurf: Handle_Geom_ConicalSurface)
  Value(): Handle_StepGeom_ConicalSurface;
  delete(): void;
}

export declare class GeomToStep_MakeRectangularTrimmedSurface extends GeomToStep_Root {
  constructor(RTSurf: Handle_Geom_RectangularTrimmedSurface)
  Value(): Handle_StepGeom_RectangularTrimmedSurface;
  delete(): void;
}

export declare class GeomToStep_MakeLine extends GeomToStep_Root {
  Value(): Handle_StepGeom_Line;
  delete(): void;
}

  export declare class GeomToStep_MakeLine_1 extends GeomToStep_MakeLine {
    constructor(L: gp_Lin);
  }

  export declare class GeomToStep_MakeLine_2 extends GeomToStep_MakeLine {
    constructor(L: gp_Lin2d);
  }

  export declare class GeomToStep_MakeLine_3 extends GeomToStep_MakeLine {
    constructor(C: Handle_Geom_Line);
  }

  export declare class GeomToStep_MakeLine_4 extends GeomToStep_MakeLine {
    constructor(C: Handle_Geom2d_Line);
  }

export declare class GeomToStep_MakeCurve extends GeomToStep_Root {
  Value(): Handle_StepGeom_Curve;
  delete(): void;
}

  export declare class GeomToStep_MakeCurve_1 extends GeomToStep_MakeCurve {
    constructor(C: Handle_Geom_Curve);
  }

  export declare class GeomToStep_MakeCurve_2 extends GeomToStep_MakeCurve {
    constructor(C: Handle_Geom2d_Curve);
  }

export declare class GeomToStep_MakeCartesianPoint extends GeomToStep_Root {
  Value(): Handle_StepGeom_CartesianPoint;
  delete(): void;
}

  export declare class GeomToStep_MakeCartesianPoint_1 extends GeomToStep_MakeCartesianPoint {
    constructor(P: gp_Pnt);
  }

  export declare class GeomToStep_MakeCartesianPoint_2 extends GeomToStep_MakeCartesianPoint {
    constructor(P: gp_Pnt2d);
  }

  export declare class GeomToStep_MakeCartesianPoint_3 extends GeomToStep_MakeCartesianPoint {
    constructor(P: Handle_Geom_CartesianPoint);
  }

  export declare class GeomToStep_MakeCartesianPoint_4 extends GeomToStep_MakeCartesianPoint {
    constructor(P: Handle_Geom2d_CartesianPoint);
  }

export declare class GeomToStep_MakeBoundedSurface extends GeomToStep_Root {
  constructor(C: Handle_Geom_BoundedSurface)
  Value(): Handle_StepGeom_BoundedSurface;
  delete(): void;
}

export declare class GeomToStep_MakeBSplineSurfaceWithKnotsAndRationalBSplineSurface extends GeomToStep_Root {
  constructor(Bsplin: Handle_Geom_BSplineSurface)
  Value(): Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface;
  delete(): void;
}

export declare class GeomToStep_MakePlane extends GeomToStep_Root {
  Value(): Handle_StepGeom_Plane;
  delete(): void;
}

  export declare class GeomToStep_MakePlane_1 extends GeomToStep_MakePlane {
    constructor(P: gp_Pln);
  }

  export declare class GeomToStep_MakePlane_2 extends GeomToStep_MakePlane {
    constructor(P: Handle_Geom_Plane);
  }

export declare class GeomToStep_MakeAxis1Placement extends GeomToStep_Root {
  Value(): Handle_StepGeom_Axis1Placement;
  delete(): void;
}

  export declare class GeomToStep_MakeAxis1Placement_1 extends GeomToStep_MakeAxis1Placement {
    constructor(A: gp_Ax1);
  }

  export declare class GeomToStep_MakeAxis1Placement_2 extends GeomToStep_MakeAxis1Placement {
    constructor(A: gp_Ax2d);
  }

  export declare class GeomToStep_MakeAxis1Placement_3 extends GeomToStep_MakeAxis1Placement {
    constructor(A: Handle_Geom_Axis1Placement);
  }

  export declare class GeomToStep_MakeAxis1Placement_4 extends GeomToStep_MakeAxis1Placement {
    constructor(A: Handle_Geom2d_AxisPlacement);
  }

export declare class GeomToStep_MakeBoundedCurve extends GeomToStep_Root {
  Value(): Handle_StepGeom_BoundedCurve;
  delete(): void;
}

  export declare class GeomToStep_MakeBoundedCurve_1 extends GeomToStep_MakeBoundedCurve {
    constructor(C: Handle_Geom_BoundedCurve);
  }

  export declare class GeomToStep_MakeBoundedCurve_2 extends GeomToStep_MakeBoundedCurve {
    constructor(C: Handle_Geom2d_BoundedCurve);
  }

export declare class GeomToStep_MakeBSplineSurfaceWithKnots extends GeomToStep_Root {
  constructor(Bsplin: Handle_Geom_BSplineSurface)
  Value(): Handle_StepGeom_BSplineSurfaceWithKnots;
  delete(): void;
}

export declare class GeomToStep_MakeHyperbola extends GeomToStep_Root {
  Value(): Handle_StepGeom_Hyperbola;
  delete(): void;
}

  export declare class GeomToStep_MakeHyperbola_1 extends GeomToStep_MakeHyperbola {
    constructor(C: Handle_Geom2d_Hyperbola);
  }

  export declare class GeomToStep_MakeHyperbola_2 extends GeomToStep_MakeHyperbola {
    constructor(C: Handle_Geom_Hyperbola);
  }

export declare class GeomToStep_MakeVector extends GeomToStep_Root {
  Value(): Handle_StepGeom_Vector;
  delete(): void;
}

  export declare class GeomToStep_MakeVector_1 extends GeomToStep_MakeVector {
    constructor(V: gp_Vec);
  }

  export declare class GeomToStep_MakeVector_2 extends GeomToStep_MakeVector {
    constructor(V: gp_Vec2d);
  }

  export declare class GeomToStep_MakeVector_3 extends GeomToStep_MakeVector {
    constructor(V: Handle_Geom_Vector);
  }

  export declare class GeomToStep_MakeVector_4 extends GeomToStep_MakeVector {
    constructor(V: Handle_Geom2d_Vector);
  }

export declare class GeomToStep_MakeSweptSurface extends GeomToStep_Root {
  constructor(S: Handle_Geom_SweptSurface)
  Value(): Handle_StepGeom_SweptSurface;
  delete(): void;
}

export declare class GeomToStep_Root {
  constructor();
  IsDone(): Standard_Boolean;
  delete(): void;
}

export declare class GeomToStep_MakeCylindricalSurface extends GeomToStep_Root {
  constructor(CSurf: Handle_Geom_CylindricalSurface)
  Value(): Handle_StepGeom_CylindricalSurface;
  delete(): void;
}

export declare class GeomToStep_MakeBSplineCurveWithKnots extends GeomToStep_Root {
  Value(): Handle_StepGeom_BSplineCurveWithKnots;
  delete(): void;
}

  export declare class GeomToStep_MakeBSplineCurveWithKnots_1 extends GeomToStep_MakeBSplineCurveWithKnots {
    constructor(Bsplin: Handle_Geom_BSplineCurve);
  }

  export declare class GeomToStep_MakeBSplineCurveWithKnots_2 extends GeomToStep_MakeBSplineCurveWithKnots {
    constructor(Bsplin: Handle_Geom2d_BSplineCurve);
  }

export declare class GeomToStep_MakeAxis2Placement3d extends GeomToStep_Root {
  Value(): Handle_StepGeom_Axis2Placement3d;
  delete(): void;
}

  export declare class GeomToStep_MakeAxis2Placement3d_1 extends GeomToStep_MakeAxis2Placement3d {
    constructor();
  }

  export declare class GeomToStep_MakeAxis2Placement3d_2 extends GeomToStep_MakeAxis2Placement3d {
    constructor(A: gp_Ax2);
  }

  export declare class GeomToStep_MakeAxis2Placement3d_3 extends GeomToStep_MakeAxis2Placement3d {
    constructor(A: gp_Ax3);
  }

  export declare class GeomToStep_MakeAxis2Placement3d_4 extends GeomToStep_MakeAxis2Placement3d {
    constructor(T: gp_Trsf);
  }

  export declare class GeomToStep_MakeAxis2Placement3d_5 extends GeomToStep_MakeAxis2Placement3d {
    constructor(A: Handle_Geom_Axis2Placement);
  }

export declare class GeomToStep_MakeElementarySurface extends GeomToStep_Root {
  constructor(S: Handle_Geom_ElementarySurface)
  Value(): Handle_StepGeom_ElementarySurface;
  delete(): void;
}

export declare class GeomToStep_MakeDirection extends GeomToStep_Root {
  Value(): Handle_StepGeom_Direction;
  delete(): void;
}

  export declare class GeomToStep_MakeDirection_1 extends GeomToStep_MakeDirection {
    constructor(D: gp_Dir);
  }

  export declare class GeomToStep_MakeDirection_2 extends GeomToStep_MakeDirection {
    constructor(D: gp_Dir2d);
  }

  export declare class GeomToStep_MakeDirection_3 extends GeomToStep_MakeDirection {
    constructor(D: Handle_Geom_Direction);
  }

  export declare class GeomToStep_MakeDirection_4 extends GeomToStep_MakeDirection {
    constructor(D: Handle_Geom2d_Direction);
  }

export declare class Geom2dAdaptor_Curve extends Adaptor2d_Curve2d {
  Reset(): void;
  Load_1(C: Handle_Geom2d_Curve): void;
  Load_2(C: Handle_Geom2d_Curve, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose): void;
  Curve(): Handle_Geom2d_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor2d_HCurve2d;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Resolution(Ruv: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Ellipse(): gp_Elips2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  NbSamples(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom2d_BezierCurve;
  BSpline(): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

  export declare class Geom2dAdaptor_Curve_1 extends Geom2dAdaptor_Curve {
    constructor();
  }

  export declare class Geom2dAdaptor_Curve_2 extends Geom2dAdaptor_Curve {
    constructor(C: Handle_Geom2d_Curve);
  }

  export declare class Geom2dAdaptor_Curve_3 extends Geom2dAdaptor_Curve {
    constructor(C: Handle_Geom2d_Curve, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose);
  }

export declare class Geom2dAdaptor {
  constructor();
  static MakeCurve(HC: Adaptor2d_Curve2d): Handle_Geom2d_Curve;
  delete(): void;
}

export declare class Geom2dAdaptor_GHCurve extends Adaptor2d_HCurve2d {
  Set(C: Geom2dAdaptor_Curve): void;
  Curve2d(): Adaptor2d_Curve2d;
  ChangeCurve2d(): Geom2dAdaptor_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2dAdaptor_GHCurve_1 extends Geom2dAdaptor_GHCurve {
    constructor();
  }

  export declare class Geom2dAdaptor_GHCurve_2 extends Geom2dAdaptor_GHCurve {
    constructor(C: Geom2dAdaptor_Curve);
  }

export declare class Handle_Geom2dAdaptor_GHCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2dAdaptor_GHCurve): void;
  get(): Geom2dAdaptor_GHCurve;
  delete(): void;
}

  export declare class Handle_Geom2dAdaptor_GHCurve_1 extends Handle_Geom2dAdaptor_GHCurve {
    constructor();
  }

  export declare class Handle_Geom2dAdaptor_GHCurve_2 extends Handle_Geom2dAdaptor_GHCurve {
    constructor(thePtr: Geom2dAdaptor_GHCurve);
  }

  export declare class Handle_Geom2dAdaptor_GHCurve_3 extends Handle_Geom2dAdaptor_GHCurve {
    constructor(theHandle: Handle_Geom2dAdaptor_GHCurve);
  }

  export declare class Handle_Geom2dAdaptor_GHCurve_4 extends Handle_Geom2dAdaptor_GHCurve {
    constructor(theHandle: Handle_Geom2dAdaptor_GHCurve);
  }

export declare class Geom2dAdaptor_HCurve extends Geom2dAdaptor_GHCurve {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2dAdaptor_HCurve_1 extends Geom2dAdaptor_HCurve {
    constructor();
  }

  export declare class Geom2dAdaptor_HCurve_2 extends Geom2dAdaptor_HCurve {
    constructor(AS: Geom2dAdaptor_Curve);
  }

  export declare class Geom2dAdaptor_HCurve_3 extends Geom2dAdaptor_HCurve {
    constructor(S: Handle_Geom2d_Curve);
  }

  export declare class Geom2dAdaptor_HCurve_4 extends Geom2dAdaptor_HCurve {
    constructor(S: Handle_Geom2d_Curve, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom2dAdaptor_HCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2dAdaptor_HCurve): void;
  get(): Geom2dAdaptor_HCurve;
  delete(): void;
}

  export declare class Handle_Geom2dAdaptor_HCurve_1 extends Handle_Geom2dAdaptor_HCurve {
    constructor();
  }

  export declare class Handle_Geom2dAdaptor_HCurve_2 extends Handle_Geom2dAdaptor_HCurve {
    constructor(thePtr: Geom2dAdaptor_HCurve);
  }

  export declare class Handle_Geom2dAdaptor_HCurve_3 extends Handle_Geom2dAdaptor_HCurve {
    constructor(theHandle: Handle_Geom2dAdaptor_HCurve);
  }

  export declare class Handle_Geom2dAdaptor_HCurve_4 extends Handle_Geom2dAdaptor_HCurve {
    constructor(theHandle: Handle_Geom2dAdaptor_HCurve);
  }

export declare class Contap_Line {
  constructor()
  SetLineOn2S(L: Handle_IntSurf_LineOn2S): void;
  Clear(): void;
  LineOn2S(): Handle_IntSurf_LineOn2S;
  ResetSeqOfVertex(): void;
  Add_1(P: IntSurf_PntOn2S): void;
  SetValue_1(L: gp_Lin): void;
  SetValue_2(C: gp_Circ): void;
  SetValue_3(A: Handle_Adaptor2d_HCurve2d): void;
  Add_2(P: Contap_Point): void;
  NbVertex(): Graphic3d_ZLayerId;
  Vertex(Index: Graphic3d_ZLayerId): Contap_Point;
  TypeContour(): Contap_IType;
  NbPnts(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Arc(): Handle_Adaptor2d_HCurve2d;
  SetTransitionOnS(T: IntSurf_TypeTrans): void;
  TransitionOnS(): IntSurf_TypeTrans;
  delete(): void;
}

export declare class Contap_Point {
  SetValue(Pt: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  SetParameter(Para: Quantity_AbsorbedDose): void;
  SetVertex(V: Handle_Adaptor3d_HVertex): void;
  SetArc(A: Handle_Adaptor2d_HCurve2d, Param: Quantity_AbsorbedDose, TLine: IntSurf_Transition, TArc: IntSurf_Transition): void;
  SetMultiple(): void;
  SetInternal(): void;
  Value(): gp_Pnt;
  ParameterOnLine(): Quantity_AbsorbedDose;
  Parameters(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose): void;
  IsOnArc(): Standard_Boolean;
  Arc(): Handle_Adaptor2d_HCurve2d;
  ParameterOnArc(): Quantity_AbsorbedDose;
  TransitionOnLine(): IntSurf_Transition;
  TransitionOnArc(): IntSurf_Transition;
  IsVertex(): Standard_Boolean;
  Vertex(): Handle_Adaptor3d_HVertex;
  IsMultiple(): Standard_Boolean;
  IsInternal(): Standard_Boolean;
  delete(): void;
}

  export declare class Contap_Point_1 extends Contap_Point {
    constructor();
  }

  export declare class Contap_Point_2 extends Contap_Point {
    constructor(Pt: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose);
  }

export declare type Contap_TFunction = {
  Contap_ContourStd: {};
  Contap_ContourPrs: {};
  Contap_DraftStd: {};
  Contap_DraftPrs: {};
}

export declare class Contap_ContAna {
  constructor()
  Perform_1(S: gp_Sphere, D: gp_Dir): void;
  Perform_2(S: gp_Sphere, D: gp_Dir, Ang: Quantity_AbsorbedDose): void;
  Perform_3(S: gp_Sphere, Eye: gp_Pnt): void;
  Perform_4(C: gp_Cylinder, D: gp_Dir): void;
  Perform_5(C: gp_Cylinder, D: gp_Dir, Ang: Quantity_AbsorbedDose): void;
  Perform_6(C: gp_Cylinder, Eye: gp_Pnt): void;
  Perform_7(C: gp_Cone, D: gp_Dir): void;
  Perform_8(C: gp_Cone, D: gp_Dir, Ang: Quantity_AbsorbedDose): void;
  Perform_9(C: gp_Cone, Eye: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  NbContours(): Graphic3d_ZLayerId;
  TypeContour(): GeomAbs_CurveType;
  Circle(): gp_Circ;
  Line(Index: Graphic3d_ZLayerId): gp_Lin;
  delete(): void;
}

export declare class Contap_TheIWalking {
  constructor(Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Step: Quantity_AbsorbedDose, theToFillHoles: Standard_Boolean)
  SetTolerance(Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Step: Quantity_AbsorbedDose): void;
  Perform_1(Pnts1: IntSurf_SequenceOfPathPoint, Pnts2: IntSurf_SequenceOfInteriorPoint, Func: Contap_SurfFunction, S: Handle_Adaptor3d_HSurface, Reversed: Standard_Boolean): void;
  Perform_2(Pnts1: IntSurf_SequenceOfPathPoint, Func: Contap_SurfFunction, S: Handle_Adaptor3d_HSurface, Reversed: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  NbLines(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): Handle_Contap_TheIWLineOfTheIWalking;
  NbSinglePnts(): Graphic3d_ZLayerId;
  SinglePnt(Index: Graphic3d_ZLayerId): IntSurf_PathPoint;
  delete(): void;
}

export declare class Contap_ThePathPointOfTheSearch {
  SetValue_1(P: gp_Pnt, Tol: Quantity_AbsorbedDose, V: Handle_Adaptor3d_HVertex, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose): void;
  SetValue_2(P: gp_Pnt, Tol: Quantity_AbsorbedDose, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  Tolerance(): Quantity_AbsorbedDose;
  IsNew(): Standard_Boolean;
  Vertex(): Handle_Adaptor3d_HVertex;
  Arc(): Handle_Adaptor2d_HCurve2d;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Contap_ThePathPointOfTheSearch_1 extends Contap_ThePathPointOfTheSearch {
    constructor();
  }

  export declare class Contap_ThePathPointOfTheSearch_2 extends Contap_ThePathPointOfTheSearch {
    constructor(P: gp_Pnt, Tol: Quantity_AbsorbedDose, V: Handle_Adaptor3d_HVertex, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose);
  }

  export declare class Contap_ThePathPointOfTheSearch_3 extends Contap_ThePathPointOfTheSearch {
    constructor(P: gp_Pnt, Tol: Quantity_AbsorbedDose, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose);
  }

export declare class Contap_ArcFunction extends math_FunctionWithDerivative {
  constructor()
  Set_1(S: Handle_Adaptor3d_HSurface): void;
  Set_2(Direction: gp_Dir): void;
  Set_3(Direction: gp_Dir, Angle: Quantity_AbsorbedDose): void;
  Set_4(Eye: gp_Pnt): void;
  Set_5(Eye: gp_Pnt, Angle: Quantity_AbsorbedDose): void;
  Set_6(A: Handle_Adaptor2d_HCurve2d): void;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  NbSamples(): Graphic3d_ZLayerId;
  GetStateNumber(): Graphic3d_ZLayerId;
  Valpoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  Quadric(): IntSurf_Quadric;
  Surface(): Handle_Adaptor3d_HSurface;
  LastComputedPoint(): gp_Pnt;
  delete(): void;
}

export declare class Contap_TheSequenceOfPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Contap_TheSequenceOfPoint): Contap_TheSequenceOfPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Contap_Point): void;
  Append_2(theSeq: Contap_TheSequenceOfPoint): void;
  Prepend_1(theItem: Contap_Point): void;
  Prepend_2(theSeq: Contap_TheSequenceOfPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Contap_Point): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Contap_TheSequenceOfPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Contap_TheSequenceOfPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Contap_Point): void;
  Split(theIndex: Standard_Integer, theSeq: Contap_TheSequenceOfPoint): void;
  First(): Contap_Point;
  ChangeFirst(): Contap_Point;
  Last(): Contap_Point;
  ChangeLast(): Contap_Point;
  Value(theIndex: Standard_Integer): Contap_Point;
  ChangeValue(theIndex: Standard_Integer): Contap_Point;
  SetValue(theIndex: Standard_Integer, theItem: Contap_Point): void;
  delete(): void;
}

  export declare class Contap_TheSequenceOfPoint_1 extends Contap_TheSequenceOfPoint {
    constructor();
  }

  export declare class Contap_TheSequenceOfPoint_2 extends Contap_TheSequenceOfPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Contap_TheSequenceOfPoint_3 extends Contap_TheSequenceOfPoint {
    constructor(theOther: Contap_TheSequenceOfPoint);
  }

export declare class Handle_Contap_TheHSequenceOfPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Contap_TheHSequenceOfPoint): void;
  get(): Contap_TheHSequenceOfPoint;
  delete(): void;
}

  export declare class Handle_Contap_TheHSequenceOfPoint_1 extends Handle_Contap_TheHSequenceOfPoint {
    constructor();
  }

  export declare class Handle_Contap_TheHSequenceOfPoint_2 extends Handle_Contap_TheHSequenceOfPoint {
    constructor(thePtr: Contap_TheHSequenceOfPoint);
  }

  export declare class Handle_Contap_TheHSequenceOfPoint_3 extends Handle_Contap_TheHSequenceOfPoint {
    constructor(theHandle: Handle_Contap_TheHSequenceOfPoint);
  }

  export declare class Handle_Contap_TheHSequenceOfPoint_4 extends Handle_Contap_TheHSequenceOfPoint {
    constructor(theHandle: Handle_Contap_TheHSequenceOfPoint);
  }

export declare class Contap_TheSequenceOfLine extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Contap_TheSequenceOfLine): Contap_TheSequenceOfLine;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Contap_Line): void;
  Append_2(theSeq: Contap_TheSequenceOfLine): void;
  Prepend_1(theItem: Contap_Line): void;
  Prepend_2(theSeq: Contap_TheSequenceOfLine): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Contap_Line): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Contap_TheSequenceOfLine): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Contap_TheSequenceOfLine): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Contap_Line): void;
  Split(theIndex: Standard_Integer, theSeq: Contap_TheSequenceOfLine): void;
  First(): Contap_Line;
  ChangeFirst(): Contap_Line;
  Last(): Contap_Line;
  ChangeLast(): Contap_Line;
  Value(theIndex: Standard_Integer): Contap_Line;
  ChangeValue(theIndex: Standard_Integer): Contap_Line;
  SetValue(theIndex: Standard_Integer, theItem: Contap_Line): void;
  delete(): void;
}

  export declare class Contap_TheSequenceOfLine_1 extends Contap_TheSequenceOfLine {
    constructor();
  }

  export declare class Contap_TheSequenceOfLine_2 extends Contap_TheSequenceOfLine {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Contap_TheSequenceOfLine_3 extends Contap_TheSequenceOfLine {
    constructor(theOther: Contap_TheSequenceOfLine);
  }

export declare class Contap_TheSearch {
  constructor()
  Perform(F: Contap_ArcFunction, Domain: Handle_Adaptor3d_TopolTool, TolBoundary: Quantity_AbsorbedDose, TolTangency: Quantity_AbsorbedDose, RecheckOnRegularity: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  AllArcSolution(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): Contap_ThePathPointOfTheSearch;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(Index: Graphic3d_ZLayerId): Contap_TheSegmentOfTheSearch;
  delete(): void;
}

export declare class Contap_SequenceOfPathPointOfTheSearch extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Contap_SequenceOfPathPointOfTheSearch): Contap_SequenceOfPathPointOfTheSearch;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Contap_ThePathPointOfTheSearch): void;
  Append_2(theSeq: Contap_SequenceOfPathPointOfTheSearch): void;
  Prepend_1(theItem: Contap_ThePathPointOfTheSearch): void;
  Prepend_2(theSeq: Contap_SequenceOfPathPointOfTheSearch): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Contap_ThePathPointOfTheSearch): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Contap_SequenceOfPathPointOfTheSearch): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Contap_SequenceOfPathPointOfTheSearch): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Contap_ThePathPointOfTheSearch): void;
  Split(theIndex: Standard_Integer, theSeq: Contap_SequenceOfPathPointOfTheSearch): void;
  First(): Contap_ThePathPointOfTheSearch;
  ChangeFirst(): Contap_ThePathPointOfTheSearch;
  Last(): Contap_ThePathPointOfTheSearch;
  ChangeLast(): Contap_ThePathPointOfTheSearch;
  Value(theIndex: Standard_Integer): Contap_ThePathPointOfTheSearch;
  ChangeValue(theIndex: Standard_Integer): Contap_ThePathPointOfTheSearch;
  SetValue(theIndex: Standard_Integer, theItem: Contap_ThePathPointOfTheSearch): void;
  delete(): void;
}

  export declare class Contap_SequenceOfPathPointOfTheSearch_1 extends Contap_SequenceOfPathPointOfTheSearch {
    constructor();
  }

  export declare class Contap_SequenceOfPathPointOfTheSearch_2 extends Contap_SequenceOfPathPointOfTheSearch {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Contap_SequenceOfPathPointOfTheSearch_3 extends Contap_SequenceOfPathPointOfTheSearch {
    constructor(theOther: Contap_SequenceOfPathPointOfTheSearch);
  }

export declare class Contap_SurfProps {
  constructor();
  static Normale(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, N: gp_Vec): void;
  static DerivAndNorm(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, d1u: gp_Vec, d1v: gp_Vec, N: gp_Vec): void;
  static NormAndDn(S: Handle_Adaptor3d_HSurface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, N: gp_Vec, Dnu: gp_Vec, Dnv: gp_Vec): void;
  delete(): void;
}

export declare class Contap_TheSearchInside {
  Perform_1(F: Contap_SurfFunction, Surf: Handle_Adaptor3d_HSurface, T: Handle_Adaptor3d_TopolTool, Epsilon: Quantity_AbsorbedDose): void;
  Perform_2(F: Contap_SurfFunction, Surf: Handle_Adaptor3d_HSurface, UStart: Quantity_AbsorbedDose, VStart: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): IntSurf_InteriorPoint;
  delete(): void;
}

  export declare class Contap_TheSearchInside_1 extends Contap_TheSearchInside {
    constructor();
  }

  export declare class Contap_TheSearchInside_2 extends Contap_TheSearchInside {
    constructor(F: Contap_SurfFunction, Surf: Handle_Adaptor3d_HSurface, T: Handle_Adaptor3d_TopolTool, Epsilon: Quantity_AbsorbedDose);
  }

export declare class Contap_SequenceOfSegmentOfTheSearch extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Contap_SequenceOfSegmentOfTheSearch): Contap_SequenceOfSegmentOfTheSearch;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Contap_TheSegmentOfTheSearch): void;
  Append_2(theSeq: Contap_SequenceOfSegmentOfTheSearch): void;
  Prepend_1(theItem: Contap_TheSegmentOfTheSearch): void;
  Prepend_2(theSeq: Contap_SequenceOfSegmentOfTheSearch): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Contap_TheSegmentOfTheSearch): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Contap_SequenceOfSegmentOfTheSearch): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Contap_SequenceOfSegmentOfTheSearch): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Contap_TheSegmentOfTheSearch): void;
  Split(theIndex: Standard_Integer, theSeq: Contap_SequenceOfSegmentOfTheSearch): void;
  First(): Contap_TheSegmentOfTheSearch;
  ChangeFirst(): Contap_TheSegmentOfTheSearch;
  Last(): Contap_TheSegmentOfTheSearch;
  ChangeLast(): Contap_TheSegmentOfTheSearch;
  Value(theIndex: Standard_Integer): Contap_TheSegmentOfTheSearch;
  ChangeValue(theIndex: Standard_Integer): Contap_TheSegmentOfTheSearch;
  SetValue(theIndex: Standard_Integer, theItem: Contap_TheSegmentOfTheSearch): void;
  delete(): void;
}

  export declare class Contap_SequenceOfSegmentOfTheSearch_1 extends Contap_SequenceOfSegmentOfTheSearch {
    constructor();
  }

  export declare class Contap_SequenceOfSegmentOfTheSearch_2 extends Contap_SequenceOfSegmentOfTheSearch {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Contap_SequenceOfSegmentOfTheSearch_3 extends Contap_SequenceOfSegmentOfTheSearch {
    constructor(theOther: Contap_SequenceOfSegmentOfTheSearch);
  }

export declare class Contap_HContTool {
  constructor();
  static NbSamplesU(S: Handle_Adaptor3d_HSurface, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplesV(S: Handle_Adaptor3d_HSurface, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplePoints(S: Handle_Adaptor3d_HSurface): Graphic3d_ZLayerId;
  static SamplePoint(S: Handle_Adaptor3d_HSurface, Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static HasBeenSeen(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static NbSamplesOnArc(A: Handle_Adaptor2d_HCurve2d): Graphic3d_ZLayerId;
  static Bounds(C: Handle_Adaptor2d_HCurve2d, Ufirst: Quantity_AbsorbedDose, Ulast: Quantity_AbsorbedDose): void;
  static Project(C: Handle_Adaptor2d_HCurve2d, P: gp_Pnt2d, Paramproj: Quantity_AbsorbedDose, Ptproj: gp_Pnt2d): Standard_Boolean;
  static Tolerance(V: Handle_Adaptor3d_HVertex, C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Parameter(V: Handle_Adaptor3d_HVertex, C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static NbPoints(C: Handle_Adaptor2d_HCurve2d): Graphic3d_ZLayerId;
  static Value(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, Pt: gp_Pnt, Tol: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): void;
  static IsVertex(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId): Standard_Boolean;
  static Vertex(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, V: Handle_Adaptor3d_HVertex): void;
  static NbSegments(C: Handle_Adaptor2d_HCurve2d): Graphic3d_ZLayerId;
  static HasFirstPoint(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, IndFirst: Graphic3d_ZLayerId): Standard_Boolean;
  static HasLastPoint(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, IndLast: Graphic3d_ZLayerId): Standard_Boolean;
  static IsAllSolution(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  delete(): void;
}

export declare type Contap_IType = {
  Contap_Lin: {};
  Contap_Circle: {};
  Contap_Walking: {};
  Contap_Restriction: {};
}

export declare class Contap_SurfFunction extends math_FunctionSetWithDerivatives {
  constructor()
  Set_1(S: Handle_Adaptor3d_HSurface): void;
  Set_2(Eye: gp_Pnt): void;
  Set_3(Dir: gp_Dir): void;
  Set_4(Dir: gp_Dir, Angle: Quantity_AbsorbedDose): void;
  Set_5(Eye: gp_Pnt, Angle: Quantity_AbsorbedDose): void;
  Set_6(Tolerance: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Tolerance(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(): Standard_Boolean;
  Direction3d(): gp_Vec;
  Direction2d(): gp_Dir2d;
  FunctionType(): Contap_TFunction;
  Eye(): gp_Pnt;
  Direction(): gp_Dir;
  Angle(): Quantity_AbsorbedDose;
  Surface(): Handle_Adaptor3d_HSurface;
  PSurface(): Handle_Adaptor3d_HSurface;
  delete(): void;
}

export declare class Contap_TheSegmentOfTheSearch {
  constructor()
  SetValue(A: Handle_Adaptor2d_HCurve2d): void;
  SetLimitPoint(V: Contap_ThePathPointOfTheSearch, First: Standard_Boolean): void;
  Curve(): Handle_Adaptor2d_HCurve2d;
  HasFirstPoint(): Standard_Boolean;
  FirstPoint(): Contap_ThePathPointOfTheSearch;
  HasLastPoint(): Standard_Boolean;
  LastPoint(): Contap_ThePathPointOfTheSearch;
  delete(): void;
}

export declare class Handle_Contap_TheIWLineOfTheIWalking {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Contap_TheIWLineOfTheIWalking): void;
  get(): Contap_TheIWLineOfTheIWalking;
  delete(): void;
}

  export declare class Handle_Contap_TheIWLineOfTheIWalking_1 extends Handle_Contap_TheIWLineOfTheIWalking {
    constructor();
  }

  export declare class Handle_Contap_TheIWLineOfTheIWalking_2 extends Handle_Contap_TheIWLineOfTheIWalking {
    constructor(thePtr: Contap_TheIWLineOfTheIWalking);
  }

  export declare class Handle_Contap_TheIWLineOfTheIWalking_3 extends Handle_Contap_TheIWLineOfTheIWalking {
    constructor(theHandle: Handle_Contap_TheIWLineOfTheIWalking);
  }

  export declare class Handle_Contap_TheIWLineOfTheIWalking_4 extends Handle_Contap_TheIWLineOfTheIWalking {
    constructor(theHandle: Handle_Contap_TheIWLineOfTheIWalking);
  }

export declare class Contap_TheIWLineOfTheIWalking extends Standard_Transient {
  constructor(theAllocator: IntSurf_Allocator)
  Reverse(): void;
  Cut(Index: Graphic3d_ZLayerId): void;
  AddPoint(P: IntSurf_PntOn2S): void;
  AddStatusFirst_1(Closed: Standard_Boolean, HasFirst: Standard_Boolean): void;
  AddStatusFirst_2(Closed: Standard_Boolean, HasLast: Standard_Boolean, Index: Graphic3d_ZLayerId, P: IntSurf_PathPoint): void;
  AddStatusFirstLast(Closed: Standard_Boolean, HasFirst: Standard_Boolean, HasLast: Standard_Boolean): void;
  AddStatusLast_1(HasLast: Standard_Boolean): void;
  AddStatusLast_2(HasLast: Standard_Boolean, Index: Graphic3d_ZLayerId, P: IntSurf_PathPoint): void;
  AddIndexPassing(Index: Graphic3d_ZLayerId): void;
  SetTangentVector(V: gp_Vec, Index: Graphic3d_ZLayerId): void;
  SetTangencyAtBegining(IsTangent: Standard_Boolean): void;
  SetTangencyAtEnd(IsTangent: Standard_Boolean): void;
  NbPoints(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  Line(): Handle_IntSurf_LineOn2S;
  IsClosed(): Standard_Boolean;
  HasFirstPoint(): Standard_Boolean;
  HasLastPoint(): Standard_Boolean;
  FirstPoint(): IntSurf_PathPoint;
  FirstPointIndex(): Graphic3d_ZLayerId;
  LastPoint(): IntSurf_PathPoint;
  LastPointIndex(): Graphic3d_ZLayerId;
  NbPassingPoint(): Graphic3d_ZLayerId;
  PassingPoint(Index: Graphic3d_ZLayerId, IndexLine: Graphic3d_ZLayerId, IndexPnts: Graphic3d_ZLayerId): void;
  TangentVector(Index: Graphic3d_ZLayerId): gp_Vec;
  IsTangentAtBegining(): Standard_Boolean;
  IsTangentAtEnd(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Contap_HCurve2dTool {
  constructor();
  static FirstParameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Continuity(C: Handle_Adaptor2d_HCurve2d): GeomAbs_Shape;
  static NbIntervals(C: Handle_Adaptor2d_HCurve2d, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Handle_Adaptor2d_HCurve2d, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static IsClosed(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static IsPeriodic(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static Period(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Value(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose): gp_Pnt2d;
  static D0(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D2(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static DN(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static Resolution(C: Handle_Adaptor2d_HCurve2d, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Handle_Adaptor2d_HCurve2d): GeomAbs_CurveType;
  static Line(C: Handle_Adaptor2d_HCurve2d): gp_Lin2d;
  static Circle(C: Handle_Adaptor2d_HCurve2d): gp_Circ2d;
  static Ellipse(C: Handle_Adaptor2d_HCurve2d): gp_Elips2d;
  static Hyperbola(C: Handle_Adaptor2d_HCurve2d): gp_Hypr2d;
  static Parabola(C: Handle_Adaptor2d_HCurve2d): gp_Parab2d;
  static Bezier(C: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BezierCurve;
  static BSpline(C: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BSplineCurve;
  static NbSamples(C: Handle_Adaptor2d_HCurve2d, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Contap_Contour {
  Perform_1(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool): void;
  Perform_2(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, Direction: gp_Vec): void;
  Perform_3(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, Direction: gp_Vec, Angle: Quantity_AbsorbedDose): void;
  Perform_4(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, Eye: gp_Pnt): void;
  Init_1(Direction: gp_Vec): void;
  Init_2(Direction: gp_Vec, Angle: Quantity_AbsorbedDose): void;
  Init_3(Eye: gp_Pnt): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Contap_Line;
  SurfaceFunction(): Contap_SurfFunction;
  delete(): void;
}

  export declare class Contap_Contour_1 extends Contap_Contour {
    constructor();
  }

  export declare class Contap_Contour_2 extends Contap_Contour {
    constructor(Direction: gp_Vec);
  }

  export declare class Contap_Contour_3 extends Contap_Contour {
    constructor(Direction: gp_Vec, Angle: Quantity_AbsorbedDose);
  }

  export declare class Contap_Contour_4 extends Contap_Contour {
    constructor(Eye: gp_Pnt);
  }

  export declare class Contap_Contour_5 extends Contap_Contour {
    constructor(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, Direction: gp_Vec);
  }

  export declare class Contap_Contour_6 extends Contap_Contour {
    constructor(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, Direction: gp_Vec, Angle: Quantity_AbsorbedDose);
  }

  export declare class Contap_Contour_7 extends Contap_Contour {
    constructor(Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, Eye: gp_Pnt);
  }

export declare class IGESControl_Reader extends XSControl_Reader {
  SetReadVisible(ReadRoot: Standard_Boolean): void;
  GetReadVisible(): Standard_Boolean;
  IGESModel(): Handle_IGESData_IGESModel;
  NbRootsForTransfer(): Graphic3d_ZLayerId;
  PrintTransferInfo(failwarn: IFSelect_PrintFail, mode: IFSelect_PrintCount): void;
  delete(): void;
}

  export declare class IGESControl_Reader_1 extends IGESControl_Reader {
    constructor();
  }

  export declare class IGESControl_Reader_2 extends IGESControl_Reader {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class Handle_IGESControl_ToolContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESControl_ToolContainer): void;
  get(): IGESControl_ToolContainer;
  delete(): void;
}

  export declare class Handle_IGESControl_ToolContainer_1 extends Handle_IGESControl_ToolContainer {
    constructor();
  }

  export declare class Handle_IGESControl_ToolContainer_2 extends Handle_IGESControl_ToolContainer {
    constructor(thePtr: IGESControl_ToolContainer);
  }

  export declare class Handle_IGESControl_ToolContainer_3 extends Handle_IGESControl_ToolContainer {
    constructor(theHandle: Handle_IGESControl_ToolContainer);
  }

  export declare class Handle_IGESControl_ToolContainer_4 extends Handle_IGESControl_ToolContainer {
    constructor(theHandle: Handle_IGESControl_ToolContainer);
  }

export declare class IGESControl_ToolContainer extends IGESToBRep_ToolContainer {
  constructor()
  IGESBoundary(): Handle_IGESToBRep_IGESBoundary;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESControl_AlgoContainer extends IGESToBRep_AlgoContainer {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESControl_AlgoContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESControl_AlgoContainer): void;
  get(): IGESControl_AlgoContainer;
  delete(): void;
}

  export declare class Handle_IGESControl_AlgoContainer_1 extends Handle_IGESControl_AlgoContainer {
    constructor();
  }

  export declare class Handle_IGESControl_AlgoContainer_2 extends Handle_IGESControl_AlgoContainer {
    constructor(thePtr: IGESControl_AlgoContainer);
  }

  export declare class Handle_IGESControl_AlgoContainer_3 extends Handle_IGESControl_AlgoContainer {
    constructor(theHandle: Handle_IGESControl_AlgoContainer);
  }

  export declare class Handle_IGESControl_AlgoContainer_4 extends Handle_IGESControl_AlgoContainer {
    constructor(theHandle: Handle_IGESControl_AlgoContainer);
  }

export declare class Handle_IGESControl_IGESBoundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESControl_IGESBoundary): void;
  get(): IGESControl_IGESBoundary;
  delete(): void;
}

  export declare class Handle_IGESControl_IGESBoundary_1 extends Handle_IGESControl_IGESBoundary {
    constructor();
  }

  export declare class Handle_IGESControl_IGESBoundary_2 extends Handle_IGESControl_IGESBoundary {
    constructor(thePtr: IGESControl_IGESBoundary);
  }

  export declare class Handle_IGESControl_IGESBoundary_3 extends Handle_IGESControl_IGESBoundary {
    constructor(theHandle: Handle_IGESControl_IGESBoundary);
  }

  export declare class Handle_IGESControl_IGESBoundary_4 extends Handle_IGESControl_IGESBoundary {
    constructor(theHandle: Handle_IGESControl_IGESBoundary);
  }

export declare class IGESControl_IGESBoundary extends IGESToBRep_IGESBoundary {
  Check(result: Standard_Boolean, checkclosure: Standard_Boolean, okCurve3d: Standard_Boolean, okCurve2d: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IGESControl_IGESBoundary_1 extends IGESControl_IGESBoundary {
    constructor();
  }

  export declare class IGESControl_IGESBoundary_2 extends IGESControl_IGESBoundary {
    constructor(CS: IGESToBRep_CurveAndSurface);
  }

export declare class IGESControl_Writer {
  Model(): Handle_IGESData_IGESModel;
  TransferProcess(): Handle_Transfer_FinderProcess;
  SetTransferProcess(TP: Handle_Transfer_FinderProcess): void;
  AddShape(sh: TopoDS_Shape, theProgress: Message_ProgressRange): Standard_Boolean;
  AddGeom(geom: Handle_Standard_Transient): Standard_Boolean;
  AddEntity(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  ComputeModel(): void;
  Write_1(S: Standard_OStream, fnes: Standard_Boolean): Standard_Boolean;
  Write_2(file: Standard_CString, fnes: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

  export declare class IGESControl_Writer_1 extends IGESControl_Writer {
    constructor();
  }

  export declare class IGESControl_Writer_2 extends IGESControl_Writer {
    constructor(unit: Standard_CString, modecr: Graphic3d_ZLayerId);
  }

  export declare class IGESControl_Writer_3 extends IGESControl_Writer {
    constructor(model: Handle_IGESData_IGESModel, modecr: Graphic3d_ZLayerId);
  }

export declare class IGESControl_ActorWrite extends Transfer_ActorOfFinderProcess {
  constructor()
  Recognize(start: Handle_Transfer_Finder): Standard_Boolean;
  Transfer(start: Handle_Transfer_Finder, FP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESControl_ActorWrite {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESControl_ActorWrite): void;
  get(): IGESControl_ActorWrite;
  delete(): void;
}

  export declare class Handle_IGESControl_ActorWrite_1 extends Handle_IGESControl_ActorWrite {
    constructor();
  }

  export declare class Handle_IGESControl_ActorWrite_2 extends Handle_IGESControl_ActorWrite {
    constructor(thePtr: IGESControl_ActorWrite);
  }

  export declare class Handle_IGESControl_ActorWrite_3 extends Handle_IGESControl_ActorWrite {
    constructor(theHandle: Handle_IGESControl_ActorWrite);
  }

  export declare class Handle_IGESControl_ActorWrite_4 extends Handle_IGESControl_ActorWrite {
    constructor(theHandle: Handle_IGESControl_ActorWrite);
  }

export declare class IGESControl_Controller extends XSControl_Controller {
  constructor(modefnes: Standard_Boolean)
  NewModel(): Handle_Interface_InterfaceModel;
  ActorRead(model: Handle_Interface_InterfaceModel): Handle_Transfer_ActorOfTransientProcess;
  TransferWriteShape(shape: TopoDS_Shape, FP: Handle_Transfer_FinderProcess, model: Handle_Interface_InterfaceModel, modetrans: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  static Init(): Standard_Boolean;
  Customise(WS: Handle_XSControl_WorkSession): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESControl_Controller {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESControl_Controller): void;
  get(): IGESControl_Controller;
  delete(): void;
}

  export declare class Handle_IGESControl_Controller_1 extends Handle_IGESControl_Controller {
    constructor();
  }

  export declare class Handle_IGESControl_Controller_2 extends Handle_IGESControl_Controller {
    constructor(thePtr: IGESControl_Controller);
  }

  export declare class Handle_IGESControl_Controller_3 extends Handle_IGESControl_Controller {
    constructor(theHandle: Handle_IGESControl_Controller);
  }

  export declare class Handle_IGESControl_Controller_4 extends Handle_IGESControl_Controller {
    constructor(theHandle: Handle_IGESControl_Controller);
  }

export declare class XSControl {
  constructor();
  static Session(pilot: Handle_IFSelect_SessionPilot): Handle_XSControl_WorkSession;
  static Vars(pilot: Handle_IFSelect_SessionPilot): Handle_XSControl_Vars;
  delete(): void;
}

export declare class XSControl_SignTransferStatus extends IFSelect_Signature {
  SetReader(TR: Handle_XSControl_TransferReader): void;
  SetMap(TP: Handle_Transfer_TransientProcess): void;
  Map(): Handle_Transfer_TransientProcess;
  Reader(): Handle_XSControl_TransferReader;
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XSControl_SignTransferStatus_1 extends XSControl_SignTransferStatus {
    constructor();
  }

  export declare class XSControl_SignTransferStatus_2 extends XSControl_SignTransferStatus {
    constructor(TR: Handle_XSControl_TransferReader);
  }

export declare class Handle_XSControl_SignTransferStatus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_SignTransferStatus): void;
  get(): XSControl_SignTransferStatus;
  delete(): void;
}

  export declare class Handle_XSControl_SignTransferStatus_1 extends Handle_XSControl_SignTransferStatus {
    constructor();
  }

  export declare class Handle_XSControl_SignTransferStatus_2 extends Handle_XSControl_SignTransferStatus {
    constructor(thePtr: XSControl_SignTransferStatus);
  }

  export declare class Handle_XSControl_SignTransferStatus_3 extends Handle_XSControl_SignTransferStatus {
    constructor(theHandle: Handle_XSControl_SignTransferStatus);
  }

  export declare class Handle_XSControl_SignTransferStatus_4 extends Handle_XSControl_SignTransferStatus {
    constructor(theHandle: Handle_XSControl_SignTransferStatus);
  }

export declare class XSControl_Functions {
  constructor();
  static Init(): void;
  delete(): void;
}

export declare class XSControl_TransferWriter extends Standard_Transient {
  constructor()
  FinderProcess(): Handle_Transfer_FinderProcess;
  SetFinderProcess(theFP: Handle_Transfer_FinderProcess): void;
  Controller(): Handle_XSControl_Controller;
  SetController(theCtl: Handle_XSControl_Controller): void;
  Clear(theMode: Graphic3d_ZLayerId): void;
  TransferMode(): Graphic3d_ZLayerId;
  SetTransferMode(theMode: Graphic3d_ZLayerId): void;
  PrintStats(theWhat: Graphic3d_ZLayerId, theMode: Graphic3d_ZLayerId): void;
  RecognizeTransient(theObj: Handle_Standard_Transient): Standard_Boolean;
  TransferWriteTransient(theModel: Handle_Interface_InterfaceModel, theObj: Handle_Standard_Transient, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  RecognizeShape(theShape: TopoDS_Shape): Standard_Boolean;
  TransferWriteShape(theModel: Handle_Interface_InterfaceModel, theShape: TopoDS_Shape, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  CheckList(): Interface_CheckIterator;
  ResultCheckList(theModel: Handle_Interface_InterfaceModel): Interface_CheckIterator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XSControl_TransferWriter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_TransferWriter): void;
  get(): XSControl_TransferWriter;
  delete(): void;
}

  export declare class Handle_XSControl_TransferWriter_1 extends Handle_XSControl_TransferWriter {
    constructor();
  }

  export declare class Handle_XSControl_TransferWriter_2 extends Handle_XSControl_TransferWriter {
    constructor(thePtr: XSControl_TransferWriter);
  }

  export declare class Handle_XSControl_TransferWriter_3 extends Handle_XSControl_TransferWriter {
    constructor(theHandle: Handle_XSControl_TransferWriter);
  }

  export declare class Handle_XSControl_TransferWriter_4 extends Handle_XSControl_TransferWriter {
    constructor(theHandle: Handle_XSControl_TransferWriter);
  }

export declare class XSControl_SelectForTransfer extends IFSelect_SelectExtract {
  SetReader(TR: Handle_XSControl_TransferReader): void;
  SetActor(act: Handle_Transfer_ActorOfTransientProcess): void;
  Actor(): Handle_Transfer_ActorOfTransientProcess;
  Reader(): Handle_XSControl_TransferReader;
  Sort(rank: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  ExtractLabel(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XSControl_SelectForTransfer_1 extends XSControl_SelectForTransfer {
    constructor();
  }

  export declare class XSControl_SelectForTransfer_2 extends XSControl_SelectForTransfer {
    constructor(TR: Handle_XSControl_TransferReader);
  }

export declare class Handle_XSControl_SelectForTransfer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_SelectForTransfer): void;
  get(): XSControl_SelectForTransfer;
  delete(): void;
}

  export declare class Handle_XSControl_SelectForTransfer_1 extends Handle_XSControl_SelectForTransfer {
    constructor();
  }

  export declare class Handle_XSControl_SelectForTransfer_2 extends Handle_XSControl_SelectForTransfer {
    constructor(thePtr: XSControl_SelectForTransfer);
  }

  export declare class Handle_XSControl_SelectForTransfer_3 extends Handle_XSControl_SelectForTransfer {
    constructor(theHandle: Handle_XSControl_SelectForTransfer);
  }

  export declare class Handle_XSControl_SelectForTransfer_4 extends Handle_XSControl_SelectForTransfer {
    constructor(theHandle: Handle_XSControl_SelectForTransfer);
  }

export declare class Handle_XSControl_ConnectedShapes {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_ConnectedShapes): void;
  get(): XSControl_ConnectedShapes;
  delete(): void;
}

  export declare class Handle_XSControl_ConnectedShapes_1 extends Handle_XSControl_ConnectedShapes {
    constructor();
  }

  export declare class Handle_XSControl_ConnectedShapes_2 extends Handle_XSControl_ConnectedShapes {
    constructor(thePtr: XSControl_ConnectedShapes);
  }

  export declare class Handle_XSControl_ConnectedShapes_3 extends Handle_XSControl_ConnectedShapes {
    constructor(theHandle: Handle_XSControl_ConnectedShapes);
  }

  export declare class Handle_XSControl_ConnectedShapes_4 extends Handle_XSControl_ConnectedShapes {
    constructor(theHandle: Handle_XSControl_ConnectedShapes);
  }

export declare class XSControl_ConnectedShapes extends IFSelect_SelectExplore {
  SetReader(TR: Handle_XSControl_TransferReader): void;
  Explore(level: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, G: Interface_Graph, explored: Interface_EntityIterator): Standard_Boolean;
  ExploreLabel(): XCAFDoc_PartId;
  static AdjacentEntities(ashape: TopoDS_Shape, TP: Handle_Transfer_TransientProcess, type: TopAbs_ShapeEnum): Handle_TColStd_HSequenceOfTransient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class XSControl_ConnectedShapes_1 extends XSControl_ConnectedShapes {
    constructor();
  }

  export declare class XSControl_ConnectedShapes_2 extends XSControl_ConnectedShapes {
    constructor(TR: Handle_XSControl_TransferReader);
  }

export declare class XSControl_FuncShape {
  constructor();
  static Init(): void;
  static MoreShapes(session: Handle_XSControl_WorkSession, list: Handle_TopTools_HSequenceOfShape, name: Standard_CString): Graphic3d_ZLayerId;
  static FileAndVar(session: Handle_XSControl_WorkSession, file: Standard_CString, var_: Standard_CString, def: Standard_CString, resfile: XCAFDoc_PartId, resvar: XCAFDoc_PartId): Standard_Boolean;
  delete(): void;
}

export declare class XSControl_Utils {
  constructor()
  TraceLine(line: Standard_CString): void;
  TraceLines(lines: Handle_Standard_Transient): void;
  IsKind(item: Handle_Standard_Transient, what: Handle_Standard_Type): Standard_Boolean;
  TypeName(item: Handle_Standard_Transient, nopk: Standard_Boolean): Standard_CString;
  TraValue(list: Handle_Standard_Transient, num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  NewSeqTra(): Handle_TColStd_HSequenceOfTransient;
  AppendTra(seqval: Handle_TColStd_HSequenceOfTransient, traval: Handle_Standard_Transient): void;
  DateString(yy: Graphic3d_ZLayerId, mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId): Standard_CString;
  DateValues(text: Standard_CString, yy: Graphic3d_ZLayerId, mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId): void;
  ToCString_1(strval: Handle_TCollection_HAsciiString): Standard_CString;
  ToCString_2(strval: XCAFDoc_PartId): Standard_CString;
  ToHString_1(strcon: Standard_CString): Handle_TCollection_HAsciiString;
  ToAString(strcon: Standard_CString): XCAFDoc_PartId;
  ToEString_1(strval: Handle_TCollection_HExtendedString): Standard_ExtString;
  ToEString_2(strval: TCollection_ExtendedString): Standard_ExtString;
  ToHString_2(strcon: Standard_ExtString): Handle_TCollection_HExtendedString;
  ToXString(strcon: Standard_ExtString): TCollection_ExtendedString;
  AsciiToExtended(str: Standard_CString): Standard_ExtString;
  IsAscii(str: Standard_ExtString): Standard_Boolean;
  ExtendedToAscii(str: Standard_ExtString): Standard_CString;
  CStrValue(list: Handle_Standard_Transient, num: Graphic3d_ZLayerId): Standard_CString;
  EStrValue(list: Handle_Standard_Transient, num: Graphic3d_ZLayerId): Standard_ExtString;
  NewSeqCStr(): Handle_TColStd_HSequenceOfHAsciiString;
  AppendCStr(seqval: Handle_TColStd_HSequenceOfHAsciiString, strval: Standard_CString): void;
  NewSeqEStr(): Handle_TColStd_HSequenceOfHExtendedString;
  AppendEStr(seqval: Handle_TColStd_HSequenceOfHExtendedString, strval: Standard_ExtString): void;
  CompoundFromSeq(seqval: Handle_TopTools_HSequenceOfShape): TopoDS_Shape;
  ShapeType(shape: TopoDS_Shape, compound: Standard_Boolean): TopAbs_ShapeEnum;
  SortedCompound(shape: TopoDS_Shape, type: TopAbs_ShapeEnum, explore: Standard_Boolean, compound: Standard_Boolean): TopoDS_Shape;
  ShapeValue(seqv: Handle_TopTools_HSequenceOfShape, num: Graphic3d_ZLayerId): TopoDS_Shape;
  NewSeqShape(): Handle_TopTools_HSequenceOfShape;
  AppendShape(seqv: Handle_TopTools_HSequenceOfShape, shape: TopoDS_Shape): void;
  ShapeBinder(shape: TopoDS_Shape, hs: Standard_Boolean): Handle_Standard_Transient;
  BinderShape(tr: Handle_Standard_Transient): TopoDS_Shape;
  SeqLength(list: Handle_Standard_Transient): Graphic3d_ZLayerId;
  SeqToArr(seq: Handle_Standard_Transient, first: Graphic3d_ZLayerId): Handle_Standard_Transient;
  ArrToSeq(arr: Handle_Standard_Transient): Handle_Standard_Transient;
  SeqIntValue(list: Handle_TColStd_HSequenceOfInteger, num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_XSControl_WorkSession {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_WorkSession): void;
  get(): XSControl_WorkSession;
  delete(): void;
}

  export declare class Handle_XSControl_WorkSession_1 extends Handle_XSControl_WorkSession {
    constructor();
  }

  export declare class Handle_XSControl_WorkSession_2 extends Handle_XSControl_WorkSession {
    constructor(thePtr: XSControl_WorkSession);
  }

  export declare class Handle_XSControl_WorkSession_3 extends Handle_XSControl_WorkSession {
    constructor(theHandle: Handle_XSControl_WorkSession);
  }

  export declare class Handle_XSControl_WorkSession_4 extends Handle_XSControl_WorkSession {
    constructor(theHandle: Handle_XSControl_WorkSession);
  }

export declare class XSControl_WorkSession extends IFSelect_WorkSession {
  constructor()
  ClearData(theMode: Graphic3d_ZLayerId): void;
  SelectNorm(theNormName: Standard_CString): Standard_Boolean;
  SetController(theCtl: Handle_XSControl_Controller): void;
  SelectedNorm(theRsc: Standard_Boolean): Standard_CString;
  NormAdaptor(): Handle_XSControl_Controller;
  Context(): any;
  SetAllContext(theContext: any): void;
  ClearContext(): void;
  PrintTransferStatus(theNum: Graphic3d_ZLayerId, theWri: Standard_Boolean, theS: Standard_OStream): Standard_Boolean;
  InitTransferReader(theMode: Graphic3d_ZLayerId): void;
  SetTransferReader(theTR: Handle_XSControl_TransferReader): void;
  TransferReader(): Handle_XSControl_TransferReader;
  MapReader(): Handle_Transfer_TransientProcess;
  SetMapReader(theTP: Handle_Transfer_TransientProcess): Standard_Boolean;
  Result(theEnt: Handle_Standard_Transient, theMode: Graphic3d_ZLayerId): Handle_Standard_Transient;
  TransferReadOne(theEnts: Handle_Standard_Transient, theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  TransferReadRoots(theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  NewModel(): Handle_Interface_InterfaceModel;
  TransferWriter(): Handle_XSControl_TransferWriter;
  SetMapWriter(theFP: Handle_Transfer_FinderProcess): Standard_Boolean;
  TransferWriteShape(theShape: TopoDS_Shape, theCompGraph: Standard_Boolean, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  TransferWriteCheckList(): Interface_CheckIterator;
  Vars(): Handle_XSControl_Vars;
  SetVars(theVars: Handle_XSControl_Vars): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XSControl_Vars {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_Vars): void;
  get(): XSControl_Vars;
  delete(): void;
}

  export declare class Handle_XSControl_Vars_1 extends Handle_XSControl_Vars {
    constructor();
  }

  export declare class Handle_XSControl_Vars_2 extends Handle_XSControl_Vars {
    constructor(thePtr: XSControl_Vars);
  }

  export declare class Handle_XSControl_Vars_3 extends Handle_XSControl_Vars {
    constructor(theHandle: Handle_XSControl_Vars);
  }

  export declare class Handle_XSControl_Vars_4 extends Handle_XSControl_Vars {
    constructor(theHandle: Handle_XSControl_Vars);
  }

export declare class XSControl_Vars extends Standard_Transient {
  constructor()
  delete(): void;
}

export declare class Handle_XSControl_Controller {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_Controller): void;
  get(): XSControl_Controller;
  delete(): void;
}

  export declare class Handle_XSControl_Controller_1 extends Handle_XSControl_Controller {
    constructor();
  }

  export declare class Handle_XSControl_Controller_2 extends Handle_XSControl_Controller {
    constructor(thePtr: XSControl_Controller);
  }

  export declare class Handle_XSControl_Controller_3 extends Handle_XSControl_Controller {
    constructor(theHandle: Handle_XSControl_Controller);
  }

  export declare class Handle_XSControl_Controller_4 extends Handle_XSControl_Controller {
    constructor(theHandle: Handle_XSControl_Controller);
  }

export declare class XSControl_Controller extends Standard_Transient {
  SetNames(theLongName: Standard_CString, theShortName: Standard_CString): void;
  AutoRecord(): void;
  Record(name: Standard_CString): void;
  static Recorded(name: Standard_CString): Handle_XSControl_Controller;
  Name(rsc: Standard_Boolean): Standard_CString;
  Protocol(): Handle_Interface_Protocol;
  WorkLibrary(): Handle_IFSelect_WorkLibrary;
  NewModel(): Handle_Interface_InterfaceModel;
  ActorRead(model: Handle_Interface_InterfaceModel): Handle_Transfer_ActorOfTransientProcess;
  ActorWrite(): Handle_Transfer_ActorOfFinderProcess;
  SetModeWrite(modemin: Graphic3d_ZLayerId, modemax: Graphic3d_ZLayerId, shape: Standard_Boolean): void;
  SetModeWriteHelp(modetrans: Graphic3d_ZLayerId, help: Standard_CString, shape: Standard_Boolean): void;
  ModeWriteBounds(modemin: Graphic3d_ZLayerId, modemax: Graphic3d_ZLayerId, shape: Standard_Boolean): Standard_Boolean;
  IsModeWrite(modetrans: Graphic3d_ZLayerId, shape: Standard_Boolean): Standard_Boolean;
  ModeWriteHelp(modetrans: Graphic3d_ZLayerId, shape: Standard_Boolean): Standard_CString;
  RecognizeWriteTransient(obj: Handle_Standard_Transient, modetrans: Graphic3d_ZLayerId): Standard_Boolean;
  TransferWriteTransient(obj: Handle_Standard_Transient, FP: Handle_Transfer_FinderProcess, model: Handle_Interface_InterfaceModel, modetrans: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  RecognizeWriteShape(shape: TopoDS_Shape, modetrans: Graphic3d_ZLayerId): Standard_Boolean;
  TransferWriteShape(shape: TopoDS_Shape, FP: Handle_Transfer_FinderProcess, model: Handle_Interface_InterfaceModel, modetrans: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  AddSessionItem(theItem: Handle_Standard_Transient, theName: Standard_CString, toApply: Standard_Boolean): void;
  SessionItem(theName: Standard_CString): Handle_Standard_Transient;
  Customise(WS: Handle_XSControl_WorkSession): void;
  AdaptorSession(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XSControl_Reader {
  SetNorm(norm: Standard_CString): Standard_Boolean;
  SetWS(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean): void;
  WS(): Handle_XSControl_WorkSession;
  ReadFile(filename: Standard_CString): IFSelect_ReturnStatus;
  ReadStream(theName: Standard_CString, theIStream: Standard_IStream): IFSelect_ReturnStatus;
  Model(): Handle_Interface_InterfaceModel;
  GiveList_1(first: Standard_CString, second: Standard_CString): Handle_TColStd_HSequenceOfTransient;
  GiveList_2(first: Standard_CString, ent: Handle_Standard_Transient): Handle_TColStd_HSequenceOfTransient;
  NbRootsForTransfer(): Graphic3d_ZLayerId;
  RootForTransfer(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  TransferOneRoot(num: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): Standard_Boolean;
  TransferOne(num: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): Standard_Boolean;
  TransferEntity(start: Handle_Standard_Transient, theProgress: Message_ProgressRange): Standard_Boolean;
  TransferList(list: Handle_TColStd_HSequenceOfTransient, theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  TransferRoots(theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  ClearShapes(): void;
  NbShapes(): Graphic3d_ZLayerId;
  Shape(num: Graphic3d_ZLayerId): TopoDS_Shape;
  OneShape(): TopoDS_Shape;
  PrintCheckLoad_1(failsonly: Standard_Boolean, mode: IFSelect_PrintCount): void;
  PrintCheckLoad_2(theStream: Standard_OStream, failsonly: Standard_Boolean, mode: IFSelect_PrintCount): void;
  PrintCheckTransfer_1(failsonly: Standard_Boolean, mode: IFSelect_PrintCount): void;
  PrintCheckTransfer_2(theStream: Standard_OStream, failsonly: Standard_Boolean, mode: IFSelect_PrintCount): void;
  PrintStatsTransfer_1(what: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  PrintStatsTransfer_2(theStream: Standard_OStream, what: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  GetStatsTransfer(list: Handle_TColStd_HSequenceOfTransient, nbMapped: Graphic3d_ZLayerId, nbWithResult: Graphic3d_ZLayerId, nbWithFail: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class XSControl_Reader_1 extends XSControl_Reader {
    constructor();
  }

  export declare class XSControl_Reader_2 extends XSControl_Reader {
    constructor(norm: Standard_CString);
  }

  export declare class XSControl_Reader_3 extends XSControl_Reader {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class XSControl_TransferReader extends Standard_Transient {
  constructor()
  SetController(theControl: Handle_XSControl_Controller): void;
  SetActor(theActor: Handle_Transfer_ActorOfTransientProcess): void;
  Actor(): Handle_Transfer_ActorOfTransientProcess;
  SetModel(theModel: Handle_Interface_InterfaceModel): void;
  SetGraph(theGraph: Handle_Interface_HGraph): void;
  Model(): Handle_Interface_InterfaceModel;
  SetContext(theName: Standard_CString, theCtx: Handle_Standard_Transient): void;
  GetContext(theName: Standard_CString, theType: Handle_Standard_Type, theCtx: Handle_Standard_Transient): Standard_Boolean;
  Context(): any;
  SetFileName(theName: Standard_CString): void;
  FileName(): Standard_CString;
  Clear(theMode: Graphic3d_ZLayerId): void;
  TransientProcess(): Handle_Transfer_TransientProcess;
  SetTransientProcess(theTP: Handle_Transfer_TransientProcess): void;
  RecordResult(theEnt: Handle_Standard_Transient): Standard_Boolean;
  IsRecorded(theEnt: Handle_Standard_Transient): Standard_Boolean;
  HasResult(theEnt: Handle_Standard_Transient): Standard_Boolean;
  RecordedList(): Handle_TColStd_HSequenceOfTransient;
  Skip(theEnt: Handle_Standard_Transient): Standard_Boolean;
  IsSkipped(theEnt: Handle_Standard_Transient): Standard_Boolean;
  IsMarked(theEnt: Handle_Standard_Transient): Standard_Boolean;
  FinalResult(theEnt: Handle_Standard_Transient): Handle_Transfer_ResultFromModel;
  FinalEntityLabel(theEnt: Handle_Standard_Transient): Standard_CString;
  FinalEntityNumber(theEnt: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ResultFromNumber(theNum: Graphic3d_ZLayerId): Handle_Transfer_ResultFromModel;
  TransientResult(theEnt: Handle_Standard_Transient): Handle_Standard_Transient;
  ShapeResult(theEnt: Handle_Standard_Transient): TopoDS_Shape;
  ClearResult(theEnt: Handle_Standard_Transient, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  EntityFromResult(theRes: Handle_Standard_Transient, theMode: Graphic3d_ZLayerId): Handle_Standard_Transient;
  EntityFromShapeResult(theRes: TopoDS_Shape, theMode: Graphic3d_ZLayerId): Handle_Standard_Transient;
  EntitiesFromShapeList(theRes: Handle_TopTools_HSequenceOfShape, theMode: Graphic3d_ZLayerId): Handle_TColStd_HSequenceOfTransient;
  CheckList(theEnt: Handle_Standard_Transient, theLevel: Graphic3d_ZLayerId): Interface_CheckIterator;
  HasChecks(theEnt: Handle_Standard_Transient, FailsOnly: Standard_Boolean): Standard_Boolean;
  CheckedList(theEnt: Handle_Standard_Transient, WithCheck: Interface_CheckStatus, theResult: Standard_Boolean): Handle_TColStd_HSequenceOfTransient;
  BeginTransfer(): Standard_Boolean;
  Recognize(theEnt: Handle_Standard_Transient): Standard_Boolean;
  TransferOne(theEnt: Handle_Standard_Transient, theRec: Standard_Boolean, theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  TransferList(theList: Handle_TColStd_HSequenceOfTransient, theRec: Standard_Boolean, theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  TransferRoots(theGraph: Interface_Graph, theProgress: Message_ProgressRange): Graphic3d_ZLayerId;
  TransferClear(theEnt: Handle_Standard_Transient, theLevel: Graphic3d_ZLayerId): void;
  PrintStats(theStream: Standard_OStream, theWhat: Graphic3d_ZLayerId, theMode: Graphic3d_ZLayerId): void;
  LastCheckList(): Interface_CheckIterator;
  LastTransferList(theRoots: Standard_Boolean): Handle_TColStd_HSequenceOfTransient;
  ShapeResultList(theRec: Standard_Boolean): Handle_TopTools_HSequenceOfShape;
  static PrintStatsProcess(theTP: Handle_Transfer_TransientProcess, theWhat: Graphic3d_ZLayerId, theMode: Graphic3d_ZLayerId): void;
  static PrintStatsOnList(theTP: Handle_Transfer_TransientProcess, theList: Handle_TColStd_HSequenceOfTransient, theWhat: Graphic3d_ZLayerId, theMode: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XSControl_TransferReader {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XSControl_TransferReader): void;
  get(): XSControl_TransferReader;
  delete(): void;
}

  export declare class Handle_XSControl_TransferReader_1 extends Handle_XSControl_TransferReader {
    constructor();
  }

  export declare class Handle_XSControl_TransferReader_2 extends Handle_XSControl_TransferReader {
    constructor(thePtr: XSControl_TransferReader);
  }

  export declare class Handle_XSControl_TransferReader_3 extends Handle_XSControl_TransferReader {
    constructor(theHandle: Handle_XSControl_TransferReader);
  }

  export declare class Handle_XSControl_TransferReader_4 extends Handle_XSControl_TransferReader {
    constructor(theHandle: Handle_XSControl_TransferReader);
  }

export declare class XSControl_Writer {
  SetNorm(norm: Standard_CString): Standard_Boolean;
  SetWS(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean): void;
  WS(): Handle_XSControl_WorkSession;
  Model(newone: Standard_Boolean): Handle_Interface_InterfaceModel;
  TransferShape(sh: TopoDS_Shape, mode: Graphic3d_ZLayerId, theProgress: Message_ProgressRange): IFSelect_ReturnStatus;
  WriteFile(filename: Standard_CString): IFSelect_ReturnStatus;
  PrintStatsTransfer(what: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class XSControl_Writer_1 extends XSControl_Writer {
    constructor();
  }

  export declare class XSControl_Writer_2 extends XSControl_Writer {
    constructor(norm: Standard_CString);
  }

  export declare class XSControl_Writer_3 extends XSControl_Writer {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class StepVisual_CameraModelD3MultiClippingUnionSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Plane(): Handle_StepGeom_Plane;
  CameraModelD3MultiClippingIntersection(): Handle_StepVisual_CameraModelD3MultiClippingIntersection;
  delete(): void;
}

export declare class Handle_StepVisual_ContextDependentOverRidingStyledItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ContextDependentOverRidingStyledItem): void;
  get(): StepVisual_ContextDependentOverRidingStyledItem;
  delete(): void;
}

  export declare class Handle_StepVisual_ContextDependentOverRidingStyledItem_1 extends Handle_StepVisual_ContextDependentOverRidingStyledItem {
    constructor();
  }

  export declare class Handle_StepVisual_ContextDependentOverRidingStyledItem_2 extends Handle_StepVisual_ContextDependentOverRidingStyledItem {
    constructor(thePtr: StepVisual_ContextDependentOverRidingStyledItem);
  }

  export declare class Handle_StepVisual_ContextDependentOverRidingStyledItem_3 extends Handle_StepVisual_ContextDependentOverRidingStyledItem {
    constructor(theHandle: Handle_StepVisual_ContextDependentOverRidingStyledItem);
  }

  export declare class Handle_StepVisual_ContextDependentOverRidingStyledItem_4 extends Handle_StepVisual_ContextDependentOverRidingStyledItem {
    constructor(theHandle: Handle_StepVisual_ContextDependentOverRidingStyledItem);
  }

export declare class StepVisual_ContextDependentOverRidingStyledItem extends StepVisual_OverRidingStyledItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aStyles: Handle_StepVisual_HArray1OfPresentationStyleAssignment, aItem: Handle_Standard_Transient, aOverRiddenStyle: Handle_StepVisual_StyledItem, aStyleContext: Handle_StepVisual_HArray1OfStyleContextSelect): void;
  SetStyleContext(aStyleContext: Handle_StepVisual_HArray1OfStyleContextSelect): void;
  StyleContext(): Handle_StepVisual_HArray1OfStyleContextSelect;
  StyleContextValue(num: Graphic3d_ZLayerId): StepVisual_StyleContextSelect;
  NbStyleContext(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_PresentationRepresentationSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PresentationRepresentation(): Handle_StepVisual_PresentationRepresentation;
  PresentationSet(): Handle_StepVisual_PresentationSet;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfStyleContextSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfStyleContextSelect): void;
  get(): StepVisual_HArray1OfStyleContextSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfStyleContextSelect_1 extends Handle_StepVisual_HArray1OfStyleContextSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfStyleContextSelect_2 extends Handle_StepVisual_HArray1OfStyleContextSelect {
    constructor(thePtr: StepVisual_HArray1OfStyleContextSelect);
  }

  export declare class Handle_StepVisual_HArray1OfStyleContextSelect_3 extends Handle_StepVisual_HArray1OfStyleContextSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfStyleContextSelect);
  }

  export declare class Handle_StepVisual_HArray1OfStyleContextSelect_4 extends Handle_StepVisual_HArray1OfStyleContextSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfStyleContextSelect);
  }

export declare class Handle_StepVisual_AnnotationTextOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationTextOccurrence): void;
  get(): StepVisual_AnnotationTextOccurrence;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationTextOccurrence_1 extends Handle_StepVisual_AnnotationTextOccurrence {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationTextOccurrence_2 extends Handle_StepVisual_AnnotationTextOccurrence {
    constructor(thePtr: StepVisual_AnnotationTextOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationTextOccurrence_3 extends Handle_StepVisual_AnnotationTextOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationTextOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationTextOccurrence_4 extends Handle_StepVisual_AnnotationTextOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationTextOccurrence);
  }

export declare class StepVisual_AnnotationTextOccurrence extends StepVisual_AnnotationOccurrence {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect): void;
  get(): StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_1 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_2 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect {
    constructor(thePtr: StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect);
  }

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_3 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect);
  }

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_4 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect);
  }

export declare class StepVisual_AreaInSet extends Standard_Transient {
  constructor()
  Init(aArea: Handle_StepVisual_PresentationArea, aInSet: Handle_StepVisual_PresentationSet): void;
  SetArea(aArea: Handle_StepVisual_PresentationArea): void;
  Area(): Handle_StepVisual_PresentationArea;
  SetInSet(aInSet: Handle_StepVisual_PresentationSet): void;
  InSet(): Handle_StepVisual_PresentationSet;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_AreaInSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AreaInSet): void;
  get(): StepVisual_AreaInSet;
  delete(): void;
}

  export declare class Handle_StepVisual_AreaInSet_1 extends Handle_StepVisual_AreaInSet {
    constructor();
  }

  export declare class Handle_StepVisual_AreaInSet_2 extends Handle_StepVisual_AreaInSet {
    constructor(thePtr: StepVisual_AreaInSet);
  }

  export declare class Handle_StepVisual_AreaInSet_3 extends Handle_StepVisual_AreaInSet {
    constructor(theHandle: Handle_StepVisual_AreaInSet);
  }

  export declare class Handle_StepVisual_AreaInSet_4 extends Handle_StepVisual_AreaInSet {
    constructor(theHandle: Handle_StepVisual_AreaInSet);
  }

export declare class StepVisual_CurveStyleFontSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CurveStyleFont(): Handle_StepVisual_CurveStyleFont;
  PreDefinedCurveFont(): Handle_StepVisual_PreDefinedCurveFont;
  ExternallyDefinedCurveFont(): Handle_StepVisual_ExternallyDefinedCurveFont;
  delete(): void;
}

export declare class Handle_StepVisual_CameraModelD3MultiClipping {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraModelD3MultiClipping): void;
  get(): StepVisual_CameraModelD3MultiClipping;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraModelD3MultiClipping_1 extends Handle_StepVisual_CameraModelD3MultiClipping {
    constructor();
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClipping_2 extends Handle_StepVisual_CameraModelD3MultiClipping {
    constructor(thePtr: StepVisual_CameraModelD3MultiClipping);
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClipping_3 extends Handle_StepVisual_CameraModelD3MultiClipping {
    constructor(theHandle: Handle_StepVisual_CameraModelD3MultiClipping);
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClipping_4 extends Handle_StepVisual_CameraModelD3MultiClipping {
    constructor(theHandle: Handle_StepVisual_CameraModelD3MultiClipping);
  }

export declare class StepVisual_CameraModelD3MultiClipping extends StepVisual_CameraModelD3 {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theViewReferenceSystem: Handle_StepGeom_Axis2Placement3d, thePerspectiveOfVolume: Handle_StepVisual_ViewVolume, theShapeClipping: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect): void;
  SetShapeClipping(theShapeClipping: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect): void;
  ShapeClipping(): Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Array1OfDraughtingCalloutElement {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_DraughtingCalloutElement): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfDraughtingCalloutElement): StepVisual_Array1OfDraughtingCalloutElement;
  Move(theOther: StepVisual_Array1OfDraughtingCalloutElement): StepVisual_Array1OfDraughtingCalloutElement;
  First(): StepVisual_DraughtingCalloutElement;
  ChangeFirst(): StepVisual_DraughtingCalloutElement;
  Last(): StepVisual_DraughtingCalloutElement;
  ChangeLast(): StepVisual_DraughtingCalloutElement;
  Value(theIndex: Standard_Integer): StepVisual_DraughtingCalloutElement;
  ChangeValue(theIndex: Standard_Integer): StepVisual_DraughtingCalloutElement;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_DraughtingCalloutElement): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfDraughtingCalloutElement_1 extends StepVisual_Array1OfDraughtingCalloutElement {
    constructor();
  }

  export declare class StepVisual_Array1OfDraughtingCalloutElement_2 extends StepVisual_Array1OfDraughtingCalloutElement {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfDraughtingCalloutElement_3 extends StepVisual_Array1OfDraughtingCalloutElement {
    constructor(theOther: StepVisual_Array1OfDraughtingCalloutElement);
  }

  export declare class StepVisual_Array1OfDraughtingCalloutElement_4 extends StepVisual_Array1OfDraughtingCalloutElement {
    constructor(theOther: StepVisual_Array1OfDraughtingCalloutElement);
  }

  export declare class StepVisual_Array1OfDraughtingCalloutElement_5 extends StepVisual_Array1OfDraughtingCalloutElement {
    constructor(theBegin: StepVisual_DraughtingCalloutElement, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_Array1OfFillStyleSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_FillStyleSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfFillStyleSelect): StepVisual_Array1OfFillStyleSelect;
  Move(theOther: StepVisual_Array1OfFillStyleSelect): StepVisual_Array1OfFillStyleSelect;
  First(): StepVisual_FillStyleSelect;
  ChangeFirst(): StepVisual_FillStyleSelect;
  Last(): StepVisual_FillStyleSelect;
  ChangeLast(): StepVisual_FillStyleSelect;
  Value(theIndex: Standard_Integer): StepVisual_FillStyleSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_FillStyleSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_FillStyleSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfFillStyleSelect_1 extends StepVisual_Array1OfFillStyleSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfFillStyleSelect_2 extends StepVisual_Array1OfFillStyleSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfFillStyleSelect_3 extends StepVisual_Array1OfFillStyleSelect {
    constructor(theOther: StepVisual_Array1OfFillStyleSelect);
  }

  export declare class StepVisual_Array1OfFillStyleSelect_4 extends StepVisual_Array1OfFillStyleSelect {
    constructor(theOther: StepVisual_Array1OfFillStyleSelect);
  }

  export declare class StepVisual_Array1OfFillStyleSelect_5 extends StepVisual_Array1OfFillStyleSelect {
    constructor(theBegin: StepVisual_FillStyleSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_Array1OfSurfaceStyleElementSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_SurfaceStyleElementSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfSurfaceStyleElementSelect): StepVisual_Array1OfSurfaceStyleElementSelect;
  Move(theOther: StepVisual_Array1OfSurfaceStyleElementSelect): StepVisual_Array1OfSurfaceStyleElementSelect;
  First(): StepVisual_SurfaceStyleElementSelect;
  ChangeFirst(): StepVisual_SurfaceStyleElementSelect;
  Last(): StepVisual_SurfaceStyleElementSelect;
  ChangeLast(): StepVisual_SurfaceStyleElementSelect;
  Value(theIndex: Standard_Integer): StepVisual_SurfaceStyleElementSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_SurfaceStyleElementSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_SurfaceStyleElementSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfSurfaceStyleElementSelect_1 extends StepVisual_Array1OfSurfaceStyleElementSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfSurfaceStyleElementSelect_2 extends StepVisual_Array1OfSurfaceStyleElementSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfSurfaceStyleElementSelect_3 extends StepVisual_Array1OfSurfaceStyleElementSelect {
    constructor(theOther: StepVisual_Array1OfSurfaceStyleElementSelect);
  }

  export declare class StepVisual_Array1OfSurfaceStyleElementSelect_4 extends StepVisual_Array1OfSurfaceStyleElementSelect {
    constructor(theOther: StepVisual_Array1OfSurfaceStyleElementSelect);
  }

  export declare class StepVisual_Array1OfSurfaceStyleElementSelect_5 extends StepVisual_Array1OfSurfaceStyleElementSelect {
    constructor(theBegin: StepVisual_SurfaceStyleElementSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_ColourSpecification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ColourSpecification): void;
  get(): StepVisual_ColourSpecification;
  delete(): void;
}

  export declare class Handle_StepVisual_ColourSpecification_1 extends Handle_StepVisual_ColourSpecification {
    constructor();
  }

  export declare class Handle_StepVisual_ColourSpecification_2 extends Handle_StepVisual_ColourSpecification {
    constructor(thePtr: StepVisual_ColourSpecification);
  }

  export declare class Handle_StepVisual_ColourSpecification_3 extends Handle_StepVisual_ColourSpecification {
    constructor(theHandle: Handle_StepVisual_ColourSpecification);
  }

  export declare class Handle_StepVisual_ColourSpecification_4 extends Handle_StepVisual_ColourSpecification {
    constructor(theHandle: Handle_StepVisual_ColourSpecification);
  }

export declare class StepVisual_ColourSpecification extends StepVisual_Colour {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect): void;
  get(): StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_1 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_2 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(thePtr: StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect);
  }

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_3 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect);
  }

  export declare class Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_4 extends Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect);
  }

export declare class StepVisual_BoxCharacteristicSelect {
  constructor()
  TypeOfContent(): Graphic3d_ZLayerId;
  SetTypeOfContent(aType: Graphic3d_ZLayerId): void;
  RealValue(): Quantity_AbsorbedDose;
  SetRealValue(aValue: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class StepVisual_PresentationStyleByContext extends StepVisual_PresentationStyleAssignment {
  constructor()
  Init(aStyles: Handle_StepVisual_HArray1OfPresentationStyleSelect, aStyleContext: StepVisual_StyleContextSelect): void;
  SetStyleContext(aStyleContext: StepVisual_StyleContextSelect): void;
  StyleContext(): StepVisual_StyleContextSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentationStyleByContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationStyleByContext): void;
  get(): StepVisual_PresentationStyleByContext;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationStyleByContext_1 extends Handle_StepVisual_PresentationStyleByContext {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationStyleByContext_2 extends Handle_StepVisual_PresentationStyleByContext {
    constructor(thePtr: StepVisual_PresentationStyleByContext);
  }

  export declare class Handle_StepVisual_PresentationStyleByContext_3 extends Handle_StepVisual_PresentationStyleByContext {
    constructor(theHandle: Handle_StepVisual_PresentationStyleByContext);
  }

  export declare class Handle_StepVisual_PresentationStyleByContext_4 extends Handle_StepVisual_PresentationStyleByContext {
    constructor(theHandle: Handle_StepVisual_PresentationStyleByContext);
  }

export declare class StepVisual_NullStyleMember extends StepData_SelectInt {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(a0: Standard_CString): Standard_Boolean;
  Kind(): Graphic3d_ZLayerId;
  EnumText(): Standard_CString;
  SetEnumText(theValue: Graphic3d_ZLayerId, theText: Standard_CString): void;
  SetValue(theValue: StepVisual_NullStyle): void;
  Value(): StepVisual_NullStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_NullStyleMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_NullStyleMember): void;
  get(): StepVisual_NullStyleMember;
  delete(): void;
}

  export declare class Handle_StepVisual_NullStyleMember_1 extends Handle_StepVisual_NullStyleMember {
    constructor();
  }

  export declare class Handle_StepVisual_NullStyleMember_2 extends Handle_StepVisual_NullStyleMember {
    constructor(thePtr: StepVisual_NullStyleMember);
  }

  export declare class Handle_StepVisual_NullStyleMember_3 extends Handle_StepVisual_NullStyleMember {
    constructor(theHandle: Handle_StepVisual_NullStyleMember);
  }

  export declare class Handle_StepVisual_NullStyleMember_4 extends Handle_StepVisual_NullStyleMember {
    constructor(theHandle: Handle_StepVisual_NullStyleMember);
  }

export declare class StepVisual_PresentationSize extends Standard_Transient {
  constructor()
  Init(aUnit: StepVisual_PresentationSizeAssignmentSelect, aSize: Handle_StepVisual_PlanarBox): void;
  SetUnit(aUnit: StepVisual_PresentationSizeAssignmentSelect): void;
  Unit(): StepVisual_PresentationSizeAssignmentSelect;
  SetSize(aSize: Handle_StepVisual_PlanarBox): void;
  Size(): Handle_StepVisual_PlanarBox;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentationSize {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationSize): void;
  get(): StepVisual_PresentationSize;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationSize_1 extends Handle_StepVisual_PresentationSize {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationSize_2 extends Handle_StepVisual_PresentationSize {
    constructor(thePtr: StepVisual_PresentationSize);
  }

  export declare class Handle_StepVisual_PresentationSize_3 extends Handle_StepVisual_PresentationSize {
    constructor(theHandle: Handle_StepVisual_PresentationSize);
  }

  export declare class Handle_StepVisual_PresentationSize_4 extends Handle_StepVisual_PresentationSize {
    constructor(theHandle: Handle_StepVisual_PresentationSize);
  }

export declare class StepVisual_SurfaceStyleElementSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  SurfaceStyleFillArea(): Handle_StepVisual_SurfaceStyleFillArea;
  SurfaceStyleBoundary(): Handle_StepVisual_SurfaceStyleBoundary;
  SurfaceStyleParameterLine(): Handle_StepVisual_SurfaceStyleParameterLine;
  SurfaceStyleRendering(): Handle_StepVisual_SurfaceStyleRendering;
  delete(): void;
}

export declare class StepVisual_PresentationSizeAssignmentSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PresentationView(): Handle_StepVisual_PresentationView;
  PresentationArea(): Handle_StepVisual_PresentationArea;
  AreaInSet(): Handle_StepVisual_AreaInSet;
  delete(): void;
}

export declare class StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel extends StepVisual_DraughtingModel {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel): void;
  get(): StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel;
  delete(): void;
}

  export declare class Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_1 extends Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel {
    constructor();
  }

  export declare class Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_2 extends Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel {
    constructor(thePtr: StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel);
  }

  export declare class Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_3 extends Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel {
    constructor(theHandle: Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel);
  }

  export declare class Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_4 extends Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel {
    constructor(theHandle: Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel);
  }

export declare class Handle_StepVisual_PresentationRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationRepresentation): void;
  get(): StepVisual_PresentationRepresentation;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationRepresentation_1 extends Handle_StepVisual_PresentationRepresentation {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationRepresentation_2 extends Handle_StepVisual_PresentationRepresentation {
    constructor(thePtr: StepVisual_PresentationRepresentation);
  }

  export declare class Handle_StepVisual_PresentationRepresentation_3 extends Handle_StepVisual_PresentationRepresentation {
    constructor(theHandle: Handle_StepVisual_PresentationRepresentation);
  }

  export declare class Handle_StepVisual_PresentationRepresentation_4 extends Handle_StepVisual_PresentationRepresentation {
    constructor(theHandle: Handle_StepVisual_PresentationRepresentation);
  }

export declare class StepVisual_PresentationRepresentation extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfLayeredItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfLayeredItem): void;
  get(): StepVisual_HArray1OfLayeredItem;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfLayeredItem_1 extends Handle_StepVisual_HArray1OfLayeredItem {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfLayeredItem_2 extends Handle_StepVisual_HArray1OfLayeredItem {
    constructor(thePtr: StepVisual_HArray1OfLayeredItem);
  }

  export declare class Handle_StepVisual_HArray1OfLayeredItem_3 extends Handle_StepVisual_HArray1OfLayeredItem {
    constructor(theHandle: Handle_StepVisual_HArray1OfLayeredItem);
  }

  export declare class Handle_StepVisual_HArray1OfLayeredItem_4 extends Handle_StepVisual_HArray1OfLayeredItem {
    constructor(theHandle: Handle_StepVisual_HArray1OfLayeredItem);
  }

export declare class StepVisual_StyleContextSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Representation(): Handle_StepRepr_Representation;
  RepresentationItem(): Handle_StepRepr_RepresentationItem;
  PresentationSet(): Handle_StepVisual_PresentationSet;
  delete(): void;
}

export declare class StepVisual_AnnotationCurveOccurrenceAndGeomReprItem extends StepVisual_AnnotationCurveOccurrence {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationCurveOccurrenceAndGeomReprItem): void;
  get(): StepVisual_AnnotationCurveOccurrenceAndGeomReprItem;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_1 extends Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_2 extends Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem {
    constructor(thePtr: StepVisual_AnnotationCurveOccurrenceAndGeomReprItem);
  }

  export declare class Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_3 extends Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem {
    constructor(theHandle: Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem);
  }

  export declare class Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_4 extends Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem {
    constructor(theHandle: Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem);
  }

export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_MechanicalDesignGeometricPresentationArea): void;
  get(): StepVisual_MechanicalDesignGeometricPresentationArea;
  delete(): void;
}

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationArea_1 extends Handle_StepVisual_MechanicalDesignGeometricPresentationArea {
    constructor();
  }

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationArea_2 extends Handle_StepVisual_MechanicalDesignGeometricPresentationArea {
    constructor(thePtr: StepVisual_MechanicalDesignGeometricPresentationArea);
  }

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationArea_3 extends Handle_StepVisual_MechanicalDesignGeometricPresentationArea {
    constructor(theHandle: Handle_StepVisual_MechanicalDesignGeometricPresentationArea);
  }

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationArea_4 extends Handle_StepVisual_MechanicalDesignGeometricPresentationArea {
    constructor(theHandle: Handle_StepVisual_MechanicalDesignGeometricPresentationArea);
  }

export declare class StepVisual_MechanicalDesignGeometricPresentationArea extends StepVisual_PresentationArea {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_MarkerSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  CaseMem(sm: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  MarkerMember(): Handle_StepVisual_MarkerMember;
  delete(): void;
}

export declare class StepVisual_TextStyleWithBoxCharacteristics extends StepVisual_TextStyle {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCharacterAppearance: Handle_StepVisual_TextStyleForDefinedFont, aCharacteristics: Handle_StepVisual_HArray1OfBoxCharacteristicSelect): void;
  SetCharacteristics(aCharacteristics: Handle_StepVisual_HArray1OfBoxCharacteristicSelect): void;
  Characteristics(): Handle_StepVisual_HArray1OfBoxCharacteristicSelect;
  CharacteristicsValue(num: Graphic3d_ZLayerId): StepVisual_BoxCharacteristicSelect;
  NbCharacteristics(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_TextStyleWithBoxCharacteristics {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TextStyleWithBoxCharacteristics): void;
  get(): StepVisual_TextStyleWithBoxCharacteristics;
  delete(): void;
}

  export declare class Handle_StepVisual_TextStyleWithBoxCharacteristics_1 extends Handle_StepVisual_TextStyleWithBoxCharacteristics {
    constructor();
  }

  export declare class Handle_StepVisual_TextStyleWithBoxCharacteristics_2 extends Handle_StepVisual_TextStyleWithBoxCharacteristics {
    constructor(thePtr: StepVisual_TextStyleWithBoxCharacteristics);
  }

  export declare class Handle_StepVisual_TextStyleWithBoxCharacteristics_3 extends Handle_StepVisual_TextStyleWithBoxCharacteristics {
    constructor(theHandle: Handle_StepVisual_TextStyleWithBoxCharacteristics);
  }

  export declare class Handle_StepVisual_TextStyleWithBoxCharacteristics_4 extends Handle_StepVisual_TextStyleWithBoxCharacteristics {
    constructor(theHandle: Handle_StepVisual_TextStyleWithBoxCharacteristics);
  }

export declare class StepVisual_Array1OfPresentationStyleSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_PresentationStyleSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfPresentationStyleSelect): StepVisual_Array1OfPresentationStyleSelect;
  Move(theOther: StepVisual_Array1OfPresentationStyleSelect): StepVisual_Array1OfPresentationStyleSelect;
  First(): StepVisual_PresentationStyleSelect;
  ChangeFirst(): StepVisual_PresentationStyleSelect;
  Last(): StepVisual_PresentationStyleSelect;
  ChangeLast(): StepVisual_PresentationStyleSelect;
  Value(theIndex: Standard_Integer): StepVisual_PresentationStyleSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_PresentationStyleSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_PresentationStyleSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfPresentationStyleSelect_1 extends StepVisual_Array1OfPresentationStyleSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfPresentationStyleSelect_2 extends StepVisual_Array1OfPresentationStyleSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfPresentationStyleSelect_3 extends StepVisual_Array1OfPresentationStyleSelect {
    constructor(theOther: StepVisual_Array1OfPresentationStyleSelect);
  }

  export declare class StepVisual_Array1OfPresentationStyleSelect_4 extends StepVisual_Array1OfPresentationStyleSelect {
    constructor(theOther: StepVisual_Array1OfPresentationStyleSelect);
  }

  export declare class StepVisual_Array1OfPresentationStyleSelect_5 extends StepVisual_Array1OfPresentationStyleSelect {
    constructor(theBegin: StepVisual_PresentationStyleSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_Array1OfLayeredItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_LayeredItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfLayeredItem): StepVisual_Array1OfLayeredItem;
  Move(theOther: StepVisual_Array1OfLayeredItem): StepVisual_Array1OfLayeredItem;
  First(): StepVisual_LayeredItem;
  ChangeFirst(): StepVisual_LayeredItem;
  Last(): StepVisual_LayeredItem;
  ChangeLast(): StepVisual_LayeredItem;
  Value(theIndex: Standard_Integer): StepVisual_LayeredItem;
  ChangeValue(theIndex: Standard_Integer): StepVisual_LayeredItem;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_LayeredItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfLayeredItem_1 extends StepVisual_Array1OfLayeredItem {
    constructor();
  }

  export declare class StepVisual_Array1OfLayeredItem_2 extends StepVisual_Array1OfLayeredItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfLayeredItem_3 extends StepVisual_Array1OfLayeredItem {
    constructor(theOther: StepVisual_Array1OfLayeredItem);
  }

  export declare class StepVisual_Array1OfLayeredItem_4 extends StepVisual_Array1OfLayeredItem {
    constructor(theOther: StepVisual_Array1OfLayeredItem);
  }

  export declare class StepVisual_Array1OfLayeredItem_5 extends StepVisual_Array1OfLayeredItem {
    constructor(theBegin: StepVisual_LayeredItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_PresentationSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationSet): void;
  get(): StepVisual_PresentationSet;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationSet_1 extends Handle_StepVisual_PresentationSet {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationSet_2 extends Handle_StepVisual_PresentationSet {
    constructor(thePtr: StepVisual_PresentationSet);
  }

  export declare class Handle_StepVisual_PresentationSet_3 extends Handle_StepVisual_PresentationSet {
    constructor(theHandle: Handle_StepVisual_PresentationSet);
  }

  export declare class Handle_StepVisual_PresentationSet_4 extends Handle_StepVisual_PresentationSet {
    constructor(theHandle: Handle_StepVisual_PresentationSet);
  }

export declare class StepVisual_PresentationSet extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_OverRidingStyledItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_OverRidingStyledItem): void;
  get(): StepVisual_OverRidingStyledItem;
  delete(): void;
}

  export declare class Handle_StepVisual_OverRidingStyledItem_1 extends Handle_StepVisual_OverRidingStyledItem {
    constructor();
  }

  export declare class Handle_StepVisual_OverRidingStyledItem_2 extends Handle_StepVisual_OverRidingStyledItem {
    constructor(thePtr: StepVisual_OverRidingStyledItem);
  }

  export declare class Handle_StepVisual_OverRidingStyledItem_3 extends Handle_StepVisual_OverRidingStyledItem {
    constructor(theHandle: Handle_StepVisual_OverRidingStyledItem);
  }

  export declare class Handle_StepVisual_OverRidingStyledItem_4 extends Handle_StepVisual_OverRidingStyledItem {
    constructor(theHandle: Handle_StepVisual_OverRidingStyledItem);
  }

export declare class StepVisual_OverRidingStyledItem extends StepVisual_StyledItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aStyles: Handle_StepVisual_HArray1OfPresentationStyleAssignment, aItem: Handle_Standard_Transient, aOverRiddenStyle: Handle_StepVisual_StyledItem): void;
  SetOverRiddenStyle(aOverRiddenStyle: Handle_StepVisual_StyledItem): void;
  OverRiddenStyle(): Handle_StepVisual_StyledItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Array1OfTextOrCharacter {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_TextOrCharacter): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfTextOrCharacter): StepVisual_Array1OfTextOrCharacter;
  Move(theOther: StepVisual_Array1OfTextOrCharacter): StepVisual_Array1OfTextOrCharacter;
  First(): StepVisual_TextOrCharacter;
  ChangeFirst(): StepVisual_TextOrCharacter;
  Last(): StepVisual_TextOrCharacter;
  ChangeLast(): StepVisual_TextOrCharacter;
  Value(theIndex: Standard_Integer): StepVisual_TextOrCharacter;
  ChangeValue(theIndex: Standard_Integer): StepVisual_TextOrCharacter;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_TextOrCharacter): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfTextOrCharacter_1 extends StepVisual_Array1OfTextOrCharacter {
    constructor();
  }

  export declare class StepVisual_Array1OfTextOrCharacter_2 extends StepVisual_Array1OfTextOrCharacter {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfTextOrCharacter_3 extends StepVisual_Array1OfTextOrCharacter {
    constructor(theOther: StepVisual_Array1OfTextOrCharacter);
  }

  export declare class StepVisual_Array1OfTextOrCharacter_4 extends StepVisual_Array1OfTextOrCharacter {
    constructor(theOther: StepVisual_Array1OfTextOrCharacter);
  }

  export declare class StepVisual_Array1OfTextOrCharacter_5 extends StepVisual_Array1OfTextOrCharacter {
    constructor(theBegin: StepVisual_TextOrCharacter, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_HArray1OfRenderingPropertiesSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfRenderingPropertiesSelect): void;
  get(): StepVisual_HArray1OfRenderingPropertiesSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfRenderingPropertiesSelect_1 extends Handle_StepVisual_HArray1OfRenderingPropertiesSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfRenderingPropertiesSelect_2 extends Handle_StepVisual_HArray1OfRenderingPropertiesSelect {
    constructor(thePtr: StepVisual_HArray1OfRenderingPropertiesSelect);
  }

  export declare class Handle_StepVisual_HArray1OfRenderingPropertiesSelect_3 extends Handle_StepVisual_HArray1OfRenderingPropertiesSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfRenderingPropertiesSelect);
  }

  export declare class Handle_StepVisual_HArray1OfRenderingPropertiesSelect_4 extends Handle_StepVisual_HArray1OfRenderingPropertiesSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfRenderingPropertiesSelect);
  }

export declare class StepVisual_CameraModelD3MultiClippingUnion extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theShapeClipping: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect): void;
  SetShapeClipping(theShapeClipping: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect): void;
  ShapeClipping(): Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CameraModelD3MultiClippingUnion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraModelD3MultiClippingUnion): void;
  get(): StepVisual_CameraModelD3MultiClippingUnion;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraModelD3MultiClippingUnion_1 extends Handle_StepVisual_CameraModelD3MultiClippingUnion {
    constructor();
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClippingUnion_2 extends Handle_StepVisual_CameraModelD3MultiClippingUnion {
    constructor(thePtr: StepVisual_CameraModelD3MultiClippingUnion);
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClippingUnion_3 extends Handle_StepVisual_CameraModelD3MultiClippingUnion {
    constructor(theHandle: Handle_StepVisual_CameraModelD3MultiClippingUnion);
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClippingUnion_4 extends Handle_StepVisual_CameraModelD3MultiClippingUnion {
    constructor(theHandle: Handle_StepVisual_CameraModelD3MultiClippingUnion);
  }

export declare class StepVisual_Array1OfStyleContextSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_StyleContextSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfStyleContextSelect): StepVisual_Array1OfStyleContextSelect;
  Move(theOther: StepVisual_Array1OfStyleContextSelect): StepVisual_Array1OfStyleContextSelect;
  First(): StepVisual_StyleContextSelect;
  ChangeFirst(): StepVisual_StyleContextSelect;
  Last(): StepVisual_StyleContextSelect;
  ChangeLast(): StepVisual_StyleContextSelect;
  Value(theIndex: Standard_Integer): StepVisual_StyleContextSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_StyleContextSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_StyleContextSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfStyleContextSelect_1 extends StepVisual_Array1OfStyleContextSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfStyleContextSelect_2 extends StepVisual_Array1OfStyleContextSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfStyleContextSelect_3 extends StepVisual_Array1OfStyleContextSelect {
    constructor(theOther: StepVisual_Array1OfStyleContextSelect);
  }

  export declare class StepVisual_Array1OfStyleContextSelect_4 extends StepVisual_Array1OfStyleContextSelect {
    constructor(theOther: StepVisual_Array1OfStyleContextSelect);
  }

  export declare class StepVisual_Array1OfStyleContextSelect_5 extends StepVisual_Array1OfStyleContextSelect {
    constructor(theBegin: StepVisual_StyleContextSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_TessellatedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TessellatedItem): void;
  get(): StepVisual_TessellatedItem;
  delete(): void;
}

  export declare class Handle_StepVisual_TessellatedItem_1 extends Handle_StepVisual_TessellatedItem {
    constructor();
  }

  export declare class Handle_StepVisual_TessellatedItem_2 extends Handle_StepVisual_TessellatedItem {
    constructor(thePtr: StepVisual_TessellatedItem);
  }

  export declare class Handle_StepVisual_TessellatedItem_3 extends Handle_StepVisual_TessellatedItem {
    constructor(theHandle: Handle_StepVisual_TessellatedItem);
  }

  export declare class Handle_StepVisual_TessellatedItem_4 extends Handle_StepVisual_TessellatedItem {
    constructor(theHandle: Handle_StepVisual_TessellatedItem);
  }

export declare class StepVisual_TessellatedItem extends StepGeom_GeometricRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepVisual_SurfaceSide = {
  StepVisual_ssNegative: {};
  StepVisual_ssPositive: {};
  StepVisual_ssBoth: {};
}

export declare class StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_CameraModelD3MultiClippingInterectionSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect): StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect;
  Move(theOther: StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect): StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect;
  First(): StepVisual_CameraModelD3MultiClippingInterectionSelect;
  ChangeFirst(): StepVisual_CameraModelD3MultiClippingInterectionSelect;
  Last(): StepVisual_CameraModelD3MultiClippingInterectionSelect;
  ChangeLast(): StepVisual_CameraModelD3MultiClippingInterectionSelect;
  Value(theIndex: Standard_Integer): StepVisual_CameraModelD3MultiClippingInterectionSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_CameraModelD3MultiClippingInterectionSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_CameraModelD3MultiClippingInterectionSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_1 extends StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_2 extends StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_3 extends StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(theOther: StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect);
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_4 extends StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(theOther: StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect);
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_5 extends StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect {
    constructor(theBegin: StepVisual_CameraModelD3MultiClippingInterectionSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_PlanarBox {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PlanarBox): void;
  get(): StepVisual_PlanarBox;
  delete(): void;
}

  export declare class Handle_StepVisual_PlanarBox_1 extends Handle_StepVisual_PlanarBox {
    constructor();
  }

  export declare class Handle_StepVisual_PlanarBox_2 extends Handle_StepVisual_PlanarBox {
    constructor(thePtr: StepVisual_PlanarBox);
  }

  export declare class Handle_StepVisual_PlanarBox_3 extends Handle_StepVisual_PlanarBox {
    constructor(theHandle: Handle_StepVisual_PlanarBox);
  }

  export declare class Handle_StepVisual_PlanarBox_4 extends Handle_StepVisual_PlanarBox {
    constructor(theHandle: Handle_StepVisual_PlanarBox);
  }

export declare class StepVisual_PlanarBox extends StepVisual_PlanarExtent {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSizeInX: Quantity_AbsorbedDose, aSizeInY: Quantity_AbsorbedDose, aPlacement: StepGeom_Axis2Placement): void;
  SetPlacement(aPlacement: StepGeom_Axis2Placement): void;
  Placement(): StepGeom_Axis2Placement;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_CameraModel extends StepGeom_GeometricRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CameraModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraModel): void;
  get(): StepVisual_CameraModel;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraModel_1 extends Handle_StepVisual_CameraModel {
    constructor();
  }

  export declare class Handle_StepVisual_CameraModel_2 extends Handle_StepVisual_CameraModel {
    constructor(thePtr: StepVisual_CameraModel);
  }

  export declare class Handle_StepVisual_CameraModel_3 extends Handle_StepVisual_CameraModel {
    constructor(theHandle: Handle_StepVisual_CameraModel);
  }

  export declare class Handle_StepVisual_CameraModel_4 extends Handle_StepVisual_CameraModel {
    constructor(theHandle: Handle_StepVisual_CameraModel);
  }

export declare class StepVisual_DraughtingPreDefinedColour extends StepVisual_PreDefinedColour {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_DraughtingPreDefinedColour {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_DraughtingPreDefinedColour): void;
  get(): StepVisual_DraughtingPreDefinedColour;
  delete(): void;
}

  export declare class Handle_StepVisual_DraughtingPreDefinedColour_1 extends Handle_StepVisual_DraughtingPreDefinedColour {
    constructor();
  }

  export declare class Handle_StepVisual_DraughtingPreDefinedColour_2 extends Handle_StepVisual_DraughtingPreDefinedColour {
    constructor(thePtr: StepVisual_DraughtingPreDefinedColour);
  }

  export declare class Handle_StepVisual_DraughtingPreDefinedColour_3 extends Handle_StepVisual_DraughtingPreDefinedColour {
    constructor(theHandle: Handle_StepVisual_DraughtingPreDefinedColour);
  }

  export declare class Handle_StepVisual_DraughtingPreDefinedColour_4 extends Handle_StepVisual_DraughtingPreDefinedColour {
    constructor(theHandle: Handle_StepVisual_DraughtingPreDefinedColour);
  }

export declare class StepVisual_CameraModelD3MultiClippingInterectionSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Plane(): Handle_StepGeom_Plane;
  CameraModelD3MultiClippingUnion(): Handle_StepVisual_CameraModelD3MultiClippingUnion;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfCurveStyleFontPattern {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfCurveStyleFontPattern): void;
  get(): StepVisual_HArray1OfCurveStyleFontPattern;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfCurveStyleFontPattern_1 extends Handle_StepVisual_HArray1OfCurveStyleFontPattern {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfCurveStyleFontPattern_2 extends Handle_StepVisual_HArray1OfCurveStyleFontPattern {
    constructor(thePtr: StepVisual_HArray1OfCurveStyleFontPattern);
  }

  export declare class Handle_StepVisual_HArray1OfCurveStyleFontPattern_3 extends Handle_StepVisual_HArray1OfCurveStyleFontPattern {
    constructor(theHandle: Handle_StepVisual_HArray1OfCurveStyleFontPattern);
  }

  export declare class Handle_StepVisual_HArray1OfCurveStyleFontPattern_4 extends Handle_StepVisual_HArray1OfCurveStyleFontPattern {
    constructor(theHandle: Handle_StepVisual_HArray1OfCurveStyleFontPattern);
  }

export declare class Handle_StepVisual_PresentationStyleAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationStyleAssignment): void;
  get(): StepVisual_PresentationStyleAssignment;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationStyleAssignment_1 extends Handle_StepVisual_PresentationStyleAssignment {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationStyleAssignment_2 extends Handle_StepVisual_PresentationStyleAssignment {
    constructor(thePtr: StepVisual_PresentationStyleAssignment);
  }

  export declare class Handle_StepVisual_PresentationStyleAssignment_3 extends Handle_StepVisual_PresentationStyleAssignment {
    constructor(theHandle: Handle_StepVisual_PresentationStyleAssignment);
  }

  export declare class Handle_StepVisual_PresentationStyleAssignment_4 extends Handle_StepVisual_PresentationStyleAssignment {
    constructor(theHandle: Handle_StepVisual_PresentationStyleAssignment);
  }

export declare class StepVisual_PresentationStyleAssignment extends Standard_Transient {
  constructor()
  Init(aStyles: Handle_StepVisual_HArray1OfPresentationStyleSelect): void;
  SetStyles(aStyles: Handle_StepVisual_HArray1OfPresentationStyleSelect): void;
  Styles(): Handle_StepVisual_HArray1OfPresentationStyleSelect;
  StylesValue(num: Graphic3d_ZLayerId): StepVisual_PresentationStyleSelect;
  NbStyles(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Array1OfDirectionCountSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_DirectionCountSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfDirectionCountSelect): StepVisual_Array1OfDirectionCountSelect;
  Move(theOther: StepVisual_Array1OfDirectionCountSelect): StepVisual_Array1OfDirectionCountSelect;
  First(): StepVisual_DirectionCountSelect;
  ChangeFirst(): StepVisual_DirectionCountSelect;
  Last(): StepVisual_DirectionCountSelect;
  ChangeLast(): StepVisual_DirectionCountSelect;
  Value(theIndex: Standard_Integer): StepVisual_DirectionCountSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_DirectionCountSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_DirectionCountSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfDirectionCountSelect_1 extends StepVisual_Array1OfDirectionCountSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfDirectionCountSelect_2 extends StepVisual_Array1OfDirectionCountSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfDirectionCountSelect_3 extends StepVisual_Array1OfDirectionCountSelect {
    constructor(theOther: StepVisual_Array1OfDirectionCountSelect);
  }

  export declare class StepVisual_Array1OfDirectionCountSelect_4 extends StepVisual_Array1OfDirectionCountSelect {
    constructor(theOther: StepVisual_Array1OfDirectionCountSelect);
  }

  export declare class StepVisual_Array1OfDirectionCountSelect_5 extends StepVisual_Array1OfDirectionCountSelect {
    constructor(theBegin: StepVisual_DirectionCountSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_Invisibility extends Standard_Transient {
  constructor()
  Init(aInvisibleItems: Handle_StepVisual_HArray1OfInvisibleItem): void;
  SetInvisibleItems(aInvisibleItems: Handle_StepVisual_HArray1OfInvisibleItem): void;
  InvisibleItems(): Handle_StepVisual_HArray1OfInvisibleItem;
  InvisibleItemsValue(num: Graphic3d_ZLayerId): StepVisual_InvisibleItem;
  NbInvisibleItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_Invisibility {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_Invisibility): void;
  get(): StepVisual_Invisibility;
  delete(): void;
}

  export declare class Handle_StepVisual_Invisibility_1 extends Handle_StepVisual_Invisibility {
    constructor();
  }

  export declare class Handle_StepVisual_Invisibility_2 extends Handle_StepVisual_Invisibility {
    constructor(thePtr: StepVisual_Invisibility);
  }

  export declare class Handle_StepVisual_Invisibility_3 extends Handle_StepVisual_Invisibility {
    constructor(theHandle: Handle_StepVisual_Invisibility);
  }

  export declare class Handle_StepVisual_Invisibility_4 extends Handle_StepVisual_Invisibility {
    constructor(theHandle: Handle_StepVisual_Invisibility);
  }

export declare class StepVisual_PresentationLayerAssignment extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aAssignedItems: Handle_StepVisual_HArray1OfLayeredItem): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetAssignedItems(aAssignedItems: Handle_StepVisual_HArray1OfLayeredItem): void;
  AssignedItems(): Handle_StepVisual_HArray1OfLayeredItem;
  AssignedItemsValue(num: Graphic3d_ZLayerId): StepVisual_LayeredItem;
  NbAssignedItems(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentationLayerAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationLayerAssignment): void;
  get(): StepVisual_PresentationLayerAssignment;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationLayerAssignment_1 extends Handle_StepVisual_PresentationLayerAssignment {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationLayerAssignment_2 extends Handle_StepVisual_PresentationLayerAssignment {
    constructor(thePtr: StepVisual_PresentationLayerAssignment);
  }

  export declare class Handle_StepVisual_PresentationLayerAssignment_3 extends Handle_StepVisual_PresentationLayerAssignment {
    constructor(theHandle: Handle_StepVisual_PresentationLayerAssignment);
  }

  export declare class Handle_StepVisual_PresentationLayerAssignment_4 extends Handle_StepVisual_PresentationLayerAssignment {
    constructor(theHandle: Handle_StepVisual_PresentationLayerAssignment);
  }

export declare class Handle_StepVisual_ExternallyDefinedCurveFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ExternallyDefinedCurveFont): void;
  get(): StepVisual_ExternallyDefinedCurveFont;
  delete(): void;
}

  export declare class Handle_StepVisual_ExternallyDefinedCurveFont_1 extends Handle_StepVisual_ExternallyDefinedCurveFont {
    constructor();
  }

  export declare class Handle_StepVisual_ExternallyDefinedCurveFont_2 extends Handle_StepVisual_ExternallyDefinedCurveFont {
    constructor(thePtr: StepVisual_ExternallyDefinedCurveFont);
  }

  export declare class Handle_StepVisual_ExternallyDefinedCurveFont_3 extends Handle_StepVisual_ExternallyDefinedCurveFont {
    constructor(theHandle: Handle_StepVisual_ExternallyDefinedCurveFont);
  }

  export declare class Handle_StepVisual_ExternallyDefinedCurveFont_4 extends Handle_StepVisual_ExternallyDefinedCurveFont {
    constructor(theHandle: Handle_StepVisual_ExternallyDefinedCurveFont);
  }

export declare class StepVisual_ExternallyDefinedCurveFont extends StepBasic_ExternallyDefinedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_ColourRgb {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ColourRgb): void;
  get(): StepVisual_ColourRgb;
  delete(): void;
}

  export declare class Handle_StepVisual_ColourRgb_1 extends Handle_StepVisual_ColourRgb {
    constructor();
  }

  export declare class Handle_StepVisual_ColourRgb_2 extends Handle_StepVisual_ColourRgb {
    constructor(thePtr: StepVisual_ColourRgb);
  }

  export declare class Handle_StepVisual_ColourRgb_3 extends Handle_StepVisual_ColourRgb {
    constructor(theHandle: Handle_StepVisual_ColourRgb);
  }

  export declare class Handle_StepVisual_ColourRgb_4 extends Handle_StepVisual_ColourRgb {
    constructor(theHandle: Handle_StepVisual_ColourRgb);
  }

export declare class StepVisual_ColourRgb extends StepVisual_ColourSpecification {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aRed: Quantity_AbsorbedDose, aGreen: Quantity_AbsorbedDose, aBlue: Quantity_AbsorbedDose): void;
  SetRed(aRed: Quantity_AbsorbedDose): void;
  Red(): Quantity_AbsorbedDose;
  SetGreen(aGreen: Quantity_AbsorbedDose): void;
  Green(): Quantity_AbsorbedDose;
  SetBlue(aBlue: Quantity_AbsorbedDose): void;
  Blue(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_SurfaceStyleReflectanceAmbient extends Standard_Transient {
  constructor()
  Init(theAmbientReflectance: Quantity_AbsorbedDose): void;
  AmbientReflectance(): Quantity_AbsorbedDose;
  SetAmbientReflectance(theAmbientReflectance: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleReflectanceAmbient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleReflectanceAmbient): void;
  get(): StepVisual_SurfaceStyleReflectanceAmbient;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleReflectanceAmbient_1 extends Handle_StepVisual_SurfaceStyleReflectanceAmbient {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleReflectanceAmbient_2 extends Handle_StepVisual_SurfaceStyleReflectanceAmbient {
    constructor(thePtr: StepVisual_SurfaceStyleReflectanceAmbient);
  }

  export declare class Handle_StepVisual_SurfaceStyleReflectanceAmbient_3 extends Handle_StepVisual_SurfaceStyleReflectanceAmbient {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleReflectanceAmbient);
  }

  export declare class Handle_StepVisual_SurfaceStyleReflectanceAmbient_4 extends Handle_StepVisual_SurfaceStyleReflectanceAmbient {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleReflectanceAmbient);
  }

export declare class Handle_StepVisual_AnnotationFillAreaOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationFillAreaOccurrence): void;
  get(): StepVisual_AnnotationFillAreaOccurrence;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationFillAreaOccurrence_1 extends Handle_StepVisual_AnnotationFillAreaOccurrence {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationFillAreaOccurrence_2 extends Handle_StepVisual_AnnotationFillAreaOccurrence {
    constructor(thePtr: StepVisual_AnnotationFillAreaOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationFillAreaOccurrence_3 extends Handle_StepVisual_AnnotationFillAreaOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationFillAreaOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationFillAreaOccurrence_4 extends Handle_StepVisual_AnnotationFillAreaOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationFillAreaOccurrence);
  }

export declare class StepVisual_AnnotationFillAreaOccurrence extends StepVisual_AnnotationOccurrence {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theStyles: Handle_StepVisual_HArray1OfPresentationStyleAssignment, theItem: Handle_Standard_Transient, theFillStyleTarget: Handle_StepGeom_GeometricRepresentationItem): void;
  FillStyleTarget(): Handle_StepGeom_GeometricRepresentationItem;
  SetFillStyleTarget(theTarget: Handle_StepGeom_GeometricRepresentationItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfPresentationStyleSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfPresentationStyleSelect): void;
  get(): StepVisual_HArray1OfPresentationStyleSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfPresentationStyleSelect_1 extends Handle_StepVisual_HArray1OfPresentationStyleSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfPresentationStyleSelect_2 extends Handle_StepVisual_HArray1OfPresentationStyleSelect {
    constructor(thePtr: StepVisual_HArray1OfPresentationStyleSelect);
  }

  export declare class Handle_StepVisual_HArray1OfPresentationStyleSelect_3 extends Handle_StepVisual_HArray1OfPresentationStyleSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfPresentationStyleSelect);
  }

  export declare class Handle_StepVisual_HArray1OfPresentationStyleSelect_4 extends Handle_StepVisual_HArray1OfPresentationStyleSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfPresentationStyleSelect);
  }

export declare type StepVisual_MarkerType = {
  StepVisual_mtDot: {};
  StepVisual_mtX: {};
  StepVisual_mtPlus: {};
  StepVisual_mtAsterisk: {};
  StepVisual_mtRing: {};
  StepVisual_mtSquare: {};
  StepVisual_mtTriangle: {};
}

export declare type StepVisual_ShadingSurfaceMethod = {
  StepVisual_ssmConstantShading: {};
  StepVisual_ssmColourShading: {};
  StepVisual_ssmDotShading: {};
  StepVisual_ssmNormalShading: {};
}

export declare class StepVisual_PointStyle extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aMarker: StepVisual_MarkerSelect, aMarkerSize: StepBasic_SizeSelect, aMarkerColour: Handle_StepVisual_Colour): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetMarker(aMarker: StepVisual_MarkerSelect): void;
  Marker(): StepVisual_MarkerSelect;
  SetMarkerSize(aMarkerSize: StepBasic_SizeSelect): void;
  MarkerSize(): StepBasic_SizeSelect;
  SetMarkerColour(aMarkerColour: Handle_StepVisual_Colour): void;
  MarkerColour(): Handle_StepVisual_Colour;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PointStyle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PointStyle): void;
  get(): StepVisual_PointStyle;
  delete(): void;
}

  export declare class Handle_StepVisual_PointStyle_1 extends Handle_StepVisual_PointStyle {
    constructor();
  }

  export declare class Handle_StepVisual_PointStyle_2 extends Handle_StepVisual_PointStyle {
    constructor(thePtr: StepVisual_PointStyle);
  }

  export declare class Handle_StepVisual_PointStyle_3 extends Handle_StepVisual_PointStyle {
    constructor(theHandle: Handle_StepVisual_PointStyle);
  }

  export declare class Handle_StepVisual_PointStyle_4 extends Handle_StepVisual_PointStyle {
    constructor(theHandle: Handle_StepVisual_PointStyle);
  }

export declare class Handle_StepVisual_CurveStyleFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CurveStyleFont): void;
  get(): StepVisual_CurveStyleFont;
  delete(): void;
}

  export declare class Handle_StepVisual_CurveStyleFont_1 extends Handle_StepVisual_CurveStyleFont {
    constructor();
  }

  export declare class Handle_StepVisual_CurveStyleFont_2 extends Handle_StepVisual_CurveStyleFont {
    constructor(thePtr: StepVisual_CurveStyleFont);
  }

  export declare class Handle_StepVisual_CurveStyleFont_3 extends Handle_StepVisual_CurveStyleFont {
    constructor(theHandle: Handle_StepVisual_CurveStyleFont);
  }

  export declare class Handle_StepVisual_CurveStyleFont_4 extends Handle_StepVisual_CurveStyleFont {
    constructor(theHandle: Handle_StepVisual_CurveStyleFont);
  }

export declare class StepVisual_CurveStyleFont extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPatternList: Handle_StepVisual_HArray1OfCurveStyleFontPattern): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetPatternList(aPatternList: Handle_StepVisual_HArray1OfCurveStyleFontPattern): void;
  PatternList(): Handle_StepVisual_HArray1OfCurveStyleFontPattern;
  PatternListValue(num: Graphic3d_ZLayerId): Handle_StepVisual_CurveStyleFontPattern;
  NbPatternList(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_CameraImage extends StepRepr_MappedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CameraImage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraImage): void;
  get(): StepVisual_CameraImage;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraImage_1 extends Handle_StepVisual_CameraImage {
    constructor();
  }

  export declare class Handle_StepVisual_CameraImage_2 extends Handle_StepVisual_CameraImage {
    constructor(thePtr: StepVisual_CameraImage);
  }

  export declare class Handle_StepVisual_CameraImage_3 extends Handle_StepVisual_CameraImage {
    constructor(theHandle: Handle_StepVisual_CameraImage);
  }

  export declare class Handle_StepVisual_CameraImage_4 extends Handle_StepVisual_CameraImage {
    constructor(theHandle: Handle_StepVisual_CameraImage);
  }

export declare type StepVisual_TextPath = {
  StepVisual_tpUp: {};
  StepVisual_tpRight: {};
  StepVisual_tpDown: {};
  StepVisual_tpLeft: {};
}

export declare class StepVisual_AnnotationText extends StepRepr_MappedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_AnnotationText {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationText): void;
  get(): StepVisual_AnnotationText;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationText_1 extends Handle_StepVisual_AnnotationText {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationText_2 extends Handle_StepVisual_AnnotationText {
    constructor(thePtr: StepVisual_AnnotationText);
  }

  export declare class Handle_StepVisual_AnnotationText_3 extends Handle_StepVisual_AnnotationText {
    constructor(theHandle: Handle_StepVisual_AnnotationText);
  }

  export declare class Handle_StepVisual_AnnotationText_4 extends Handle_StepVisual_AnnotationText {
    constructor(theHandle: Handle_StepVisual_AnnotationText);
  }

export declare class Handle_StepVisual_CameraModelD2 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraModelD2): void;
  get(): StepVisual_CameraModelD2;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraModelD2_1 extends Handle_StepVisual_CameraModelD2 {
    constructor();
  }

  export declare class Handle_StepVisual_CameraModelD2_2 extends Handle_StepVisual_CameraModelD2 {
    constructor(thePtr: StepVisual_CameraModelD2);
  }

  export declare class Handle_StepVisual_CameraModelD2_3 extends Handle_StepVisual_CameraModelD2 {
    constructor(theHandle: Handle_StepVisual_CameraModelD2);
  }

  export declare class Handle_StepVisual_CameraModelD2_4 extends Handle_StepVisual_CameraModelD2 {
    constructor(theHandle: Handle_StepVisual_CameraModelD2);
  }

export declare class StepVisual_CameraModelD2 extends StepVisual_CameraModel {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aViewWindow: Handle_StepVisual_PlanarBox, aViewWindowClipping: Standard_Boolean): void;
  SetViewWindow(aViewWindow: Handle_StepVisual_PlanarBox): void;
  ViewWindow(): Handle_StepVisual_PlanarBox;
  SetViewWindowClipping(aViewWindowClipping: Standard_Boolean): void;
  ViewWindowClipping(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_PreDefinedTextFont extends StepVisual_PreDefinedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PreDefinedTextFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PreDefinedTextFont): void;
  get(): StepVisual_PreDefinedTextFont;
  delete(): void;
}

  export declare class Handle_StepVisual_PreDefinedTextFont_1 extends Handle_StepVisual_PreDefinedTextFont {
    constructor();
  }

  export declare class Handle_StepVisual_PreDefinedTextFont_2 extends Handle_StepVisual_PreDefinedTextFont {
    constructor(thePtr: StepVisual_PreDefinedTextFont);
  }

  export declare class Handle_StepVisual_PreDefinedTextFont_3 extends Handle_StepVisual_PreDefinedTextFont {
    constructor(theHandle: Handle_StepVisual_PreDefinedTextFont);
  }

  export declare class Handle_StepVisual_PreDefinedTextFont_4 extends Handle_StepVisual_PreDefinedTextFont {
    constructor(theHandle: Handle_StepVisual_PreDefinedTextFont);
  }

export declare class StepVisual_SurfaceStyleSilhouette extends Standard_Transient {
  constructor()
  Init(aStyleOfSilhouette: Handle_StepVisual_CurveStyle): void;
  SetStyleOfSilhouette(aStyleOfSilhouette: Handle_StepVisual_CurveStyle): void;
  StyleOfSilhouette(): Handle_StepVisual_CurveStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleSilhouette {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleSilhouette): void;
  get(): StepVisual_SurfaceStyleSilhouette;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleSilhouette_1 extends Handle_StepVisual_SurfaceStyleSilhouette {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleSilhouette_2 extends Handle_StepVisual_SurfaceStyleSilhouette {
    constructor(thePtr: StepVisual_SurfaceStyleSilhouette);
  }

  export declare class Handle_StepVisual_SurfaceStyleSilhouette_3 extends Handle_StepVisual_SurfaceStyleSilhouette {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleSilhouette);
  }

  export declare class Handle_StepVisual_SurfaceStyleSilhouette_4 extends Handle_StepVisual_SurfaceStyleSilhouette {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleSilhouette);
  }

export declare class Handle_StepVisual_DraughtingModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_DraughtingModel): void;
  get(): StepVisual_DraughtingModel;
  delete(): void;
}

  export declare class Handle_StepVisual_DraughtingModel_1 extends Handle_StepVisual_DraughtingModel {
    constructor();
  }

  export declare class Handle_StepVisual_DraughtingModel_2 extends Handle_StepVisual_DraughtingModel {
    constructor(thePtr: StepVisual_DraughtingModel);
  }

  export declare class Handle_StepVisual_DraughtingModel_3 extends Handle_StepVisual_DraughtingModel {
    constructor(theHandle: Handle_StepVisual_DraughtingModel);
  }

  export declare class Handle_StepVisual_DraughtingModel_4 extends Handle_StepVisual_DraughtingModel {
    constructor(theHandle: Handle_StepVisual_DraughtingModel);
  }

export declare class StepVisual_DraughtingModel extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_FillAreaStyle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_FillAreaStyle): void;
  get(): StepVisual_FillAreaStyle;
  delete(): void;
}

  export declare class Handle_StepVisual_FillAreaStyle_1 extends Handle_StepVisual_FillAreaStyle {
    constructor();
  }

  export declare class Handle_StepVisual_FillAreaStyle_2 extends Handle_StepVisual_FillAreaStyle {
    constructor(thePtr: StepVisual_FillAreaStyle);
  }

  export declare class Handle_StepVisual_FillAreaStyle_3 extends Handle_StepVisual_FillAreaStyle {
    constructor(theHandle: Handle_StepVisual_FillAreaStyle);
  }

  export declare class Handle_StepVisual_FillAreaStyle_4 extends Handle_StepVisual_FillAreaStyle {
    constructor(theHandle: Handle_StepVisual_FillAreaStyle);
  }

export declare class StepVisual_FillAreaStyle extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aFillStyles: Handle_StepVisual_HArray1OfFillStyleSelect): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetFillStyles(aFillStyles: Handle_StepVisual_HArray1OfFillStyleSelect): void;
  FillStyles(): Handle_StepVisual_HArray1OfFillStyleSelect;
  FillStylesValue(num: Graphic3d_ZLayerId): StepVisual_FillStyleSelect;
  NbFillStyles(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_InvisibleItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  StyledItem(): Handle_StepVisual_StyledItem;
  PresentationLayerAssignment(): Handle_StepVisual_PresentationLayerAssignment;
  PresentationRepresentation(): Handle_StepVisual_PresentationRepresentation;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfSurfaceStyleElementSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfSurfaceStyleElementSelect): void;
  get(): StepVisual_HArray1OfSurfaceStyleElementSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_1 extends Handle_StepVisual_HArray1OfSurfaceStyleElementSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_2 extends Handle_StepVisual_HArray1OfSurfaceStyleElementSelect {
    constructor(thePtr: StepVisual_HArray1OfSurfaceStyleElementSelect);
  }

  export declare class Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_3 extends Handle_StepVisual_HArray1OfSurfaceStyleElementSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfSurfaceStyleElementSelect);
  }

  export declare class Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_4 extends Handle_StepVisual_HArray1OfSurfaceStyleElementSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfSurfaceStyleElementSelect);
  }

export declare class StepVisual_SurfaceStyleBoundary extends Standard_Transient {
  constructor()
  Init(aStyleOfBoundary: Handle_StepVisual_CurveStyle): void;
  SetStyleOfBoundary(aStyleOfBoundary: Handle_StepVisual_CurveStyle): void;
  StyleOfBoundary(): Handle_StepVisual_CurveStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleBoundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleBoundary): void;
  get(): StepVisual_SurfaceStyleBoundary;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleBoundary_1 extends Handle_StepVisual_SurfaceStyleBoundary {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleBoundary_2 extends Handle_StepVisual_SurfaceStyleBoundary {
    constructor(thePtr: StepVisual_SurfaceStyleBoundary);
  }

  export declare class Handle_StepVisual_SurfaceStyleBoundary_3 extends Handle_StepVisual_SurfaceStyleBoundary {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleBoundary);
  }

  export declare class Handle_StepVisual_SurfaceStyleBoundary_4 extends Handle_StepVisual_SurfaceStyleBoundary {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleBoundary);
  }

export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_MechanicalDesignGeometricPresentationRepresentation): void;
  get(): StepVisual_MechanicalDesignGeometricPresentationRepresentation;
  delete(): void;
}

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_1 extends Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation {
    constructor();
  }

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_2 extends Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation {
    constructor(thePtr: StepVisual_MechanicalDesignGeometricPresentationRepresentation);
  }

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_3 extends Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation {
    constructor(theHandle: Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation);
  }

  export declare class Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_4 extends Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation {
    constructor(theHandle: Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation);
  }

export declare class StepVisual_MechanicalDesignGeometricPresentationRepresentation extends StepVisual_PresentationRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_TextStyle extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCharacterAppearance: Handle_StepVisual_TextStyleForDefinedFont): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetCharacterAppearance(aCharacterAppearance: Handle_StepVisual_TextStyleForDefinedFont): void;
  CharacterAppearance(): Handle_StepVisual_TextStyleForDefinedFont;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_TextStyle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TextStyle): void;
  get(): StepVisual_TextStyle;
  delete(): void;
}

  export declare class Handle_StepVisual_TextStyle_1 extends Handle_StepVisual_TextStyle {
    constructor();
  }

  export declare class Handle_StepVisual_TextStyle_2 extends Handle_StepVisual_TextStyle {
    constructor(thePtr: StepVisual_TextStyle);
  }

  export declare class Handle_StepVisual_TextStyle_3 extends Handle_StepVisual_TextStyle {
    constructor(theHandle: Handle_StepVisual_TextStyle);
  }

  export declare class Handle_StepVisual_TextStyle_4 extends Handle_StepVisual_TextStyle {
    constructor(theHandle: Handle_StepVisual_TextStyle);
  }

export declare class StepVisual_AnnotationOccurrence extends StepVisual_StyledItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_AnnotationOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationOccurrence): void;
  get(): StepVisual_AnnotationOccurrence;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationOccurrence_1 extends Handle_StepVisual_AnnotationOccurrence {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationOccurrence_2 extends Handle_StepVisual_AnnotationOccurrence {
    constructor(thePtr: StepVisual_AnnotationOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationOccurrence_3 extends Handle_StepVisual_AnnotationOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationOccurrence_4 extends Handle_StepVisual_AnnotationOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationOccurrence);
  }

export declare class Handle_StepVisual_TextStyleForDefinedFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TextStyleForDefinedFont): void;
  get(): StepVisual_TextStyleForDefinedFont;
  delete(): void;
}

  export declare class Handle_StepVisual_TextStyleForDefinedFont_1 extends Handle_StepVisual_TextStyleForDefinedFont {
    constructor();
  }

  export declare class Handle_StepVisual_TextStyleForDefinedFont_2 extends Handle_StepVisual_TextStyleForDefinedFont {
    constructor(thePtr: StepVisual_TextStyleForDefinedFont);
  }

  export declare class Handle_StepVisual_TextStyleForDefinedFont_3 extends Handle_StepVisual_TextStyleForDefinedFont {
    constructor(theHandle: Handle_StepVisual_TextStyleForDefinedFont);
  }

  export declare class Handle_StepVisual_TextStyleForDefinedFont_4 extends Handle_StepVisual_TextStyleForDefinedFont {
    constructor(theHandle: Handle_StepVisual_TextStyleForDefinedFont);
  }

export declare class StepVisual_TextStyleForDefinedFont extends Standard_Transient {
  constructor()
  Init(aTextColour: Handle_StepVisual_Colour): void;
  SetTextColour(aTextColour: Handle_StepVisual_Colour): void;
  TextColour(): Handle_StepVisual_Colour;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Array1OfInvisibleItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_InvisibleItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfInvisibleItem): StepVisual_Array1OfInvisibleItem;
  Move(theOther: StepVisual_Array1OfInvisibleItem): StepVisual_Array1OfInvisibleItem;
  First(): StepVisual_InvisibleItem;
  ChangeFirst(): StepVisual_InvisibleItem;
  Last(): StepVisual_InvisibleItem;
  ChangeLast(): StepVisual_InvisibleItem;
  Value(theIndex: Standard_Integer): StepVisual_InvisibleItem;
  ChangeValue(theIndex: Standard_Integer): StepVisual_InvisibleItem;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_InvisibleItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfInvisibleItem_1 extends StepVisual_Array1OfInvisibleItem {
    constructor();
  }

  export declare class StepVisual_Array1OfInvisibleItem_2 extends StepVisual_Array1OfInvisibleItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfInvisibleItem_3 extends StepVisual_Array1OfInvisibleItem {
    constructor(theOther: StepVisual_Array1OfInvisibleItem);
  }

  export declare class StepVisual_Array1OfInvisibleItem_4 extends StepVisual_Array1OfInvisibleItem {
    constructor(theOther: StepVisual_Array1OfInvisibleItem);
  }

  export declare class StepVisual_Array1OfInvisibleItem_5 extends StepVisual_Array1OfInvisibleItem {
    constructor(theBegin: StepVisual_InvisibleItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_ViewVolume extends Standard_Transient {
  constructor()
  Init(aProjectionType: StepVisual_CentralOrParallel, aProjectionPoint: Handle_StepGeom_CartesianPoint, aViewPlaneDistance: Quantity_AbsorbedDose, aFrontPlaneDistance: Quantity_AbsorbedDose, aFrontPlaneClipping: Standard_Boolean, aBackPlaneDistance: Quantity_AbsorbedDose, aBackPlaneClipping: Standard_Boolean, aViewVolumeSidesClipping: Standard_Boolean, aViewWindow: Handle_StepVisual_PlanarBox): void;
  SetProjectionType(aProjectionType: StepVisual_CentralOrParallel): void;
  ProjectionType(): StepVisual_CentralOrParallel;
  SetProjectionPoint(aProjectionPoint: Handle_StepGeom_CartesianPoint): void;
  ProjectionPoint(): Handle_StepGeom_CartesianPoint;
  SetViewPlaneDistance(aViewPlaneDistance: Quantity_AbsorbedDose): void;
  ViewPlaneDistance(): Quantity_AbsorbedDose;
  SetFrontPlaneDistance(aFrontPlaneDistance: Quantity_AbsorbedDose): void;
  FrontPlaneDistance(): Quantity_AbsorbedDose;
  SetFrontPlaneClipping(aFrontPlaneClipping: Standard_Boolean): void;
  FrontPlaneClipping(): Standard_Boolean;
  SetBackPlaneDistance(aBackPlaneDistance: Quantity_AbsorbedDose): void;
  BackPlaneDistance(): Quantity_AbsorbedDose;
  SetBackPlaneClipping(aBackPlaneClipping: Standard_Boolean): void;
  BackPlaneClipping(): Standard_Boolean;
  SetViewVolumeSidesClipping(aViewVolumeSidesClipping: Standard_Boolean): void;
  ViewVolumeSidesClipping(): Standard_Boolean;
  SetViewWindow(aViewWindow: Handle_StepVisual_PlanarBox): void;
  ViewWindow(): Handle_StepVisual_PlanarBox;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_ViewVolume {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ViewVolume): void;
  get(): StepVisual_ViewVolume;
  delete(): void;
}

  export declare class Handle_StepVisual_ViewVolume_1 extends Handle_StepVisual_ViewVolume {
    constructor();
  }

  export declare class Handle_StepVisual_ViewVolume_2 extends Handle_StepVisual_ViewVolume {
    constructor(thePtr: StepVisual_ViewVolume);
  }

  export declare class Handle_StepVisual_ViewVolume_3 extends Handle_StepVisual_ViewVolume {
    constructor(theHandle: Handle_StepVisual_ViewVolume);
  }

  export declare class Handle_StepVisual_ViewVolume_4 extends Handle_StepVisual_ViewVolume {
    constructor(theHandle: Handle_StepVisual_ViewVolume);
  }

export declare class Handle_StepVisual_SurfaceStyleRendering {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleRendering): void;
  get(): StepVisual_SurfaceStyleRendering;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleRendering_1 extends Handle_StepVisual_SurfaceStyleRendering {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleRendering_2 extends Handle_StepVisual_SurfaceStyleRendering {
    constructor(thePtr: StepVisual_SurfaceStyleRendering);
  }

  export declare class Handle_StepVisual_SurfaceStyleRendering_3 extends Handle_StepVisual_SurfaceStyleRendering {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleRendering);
  }

  export declare class Handle_StepVisual_SurfaceStyleRendering_4 extends Handle_StepVisual_SurfaceStyleRendering {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleRendering);
  }

export declare class StepVisual_SurfaceStyleRendering extends Standard_Transient {
  constructor()
  Init(theRenderingMethod: StepVisual_ShadingSurfaceMethod, theSurfaceColour: Handle_StepVisual_Colour): void;
  RenderingMethod(): StepVisual_ShadingSurfaceMethod;
  SetRenderingMethod(theRenderingMethod: StepVisual_ShadingSurfaceMethod): void;
  SurfaceColour(): Handle_StepVisual_Colour;
  SetSurfaceColour(theSurfaceColour: Handle_StepVisual_Colour): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Array1OfBoxCharacteristicSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_BoxCharacteristicSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfBoxCharacteristicSelect): StepVisual_Array1OfBoxCharacteristicSelect;
  Move(theOther: StepVisual_Array1OfBoxCharacteristicSelect): StepVisual_Array1OfBoxCharacteristicSelect;
  First(): StepVisual_BoxCharacteristicSelect;
  ChangeFirst(): StepVisual_BoxCharacteristicSelect;
  Last(): StepVisual_BoxCharacteristicSelect;
  ChangeLast(): StepVisual_BoxCharacteristicSelect;
  Value(theIndex: Standard_Integer): StepVisual_BoxCharacteristicSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_BoxCharacteristicSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_BoxCharacteristicSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfBoxCharacteristicSelect_1 extends StepVisual_Array1OfBoxCharacteristicSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfBoxCharacteristicSelect_2 extends StepVisual_Array1OfBoxCharacteristicSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfBoxCharacteristicSelect_3 extends StepVisual_Array1OfBoxCharacteristicSelect {
    constructor(theOther: StepVisual_Array1OfBoxCharacteristicSelect);
  }

  export declare class StepVisual_Array1OfBoxCharacteristicSelect_4 extends StepVisual_Array1OfBoxCharacteristicSelect {
    constructor(theOther: StepVisual_Array1OfBoxCharacteristicSelect);
  }

  export declare class StepVisual_Array1OfBoxCharacteristicSelect_5 extends StepVisual_Array1OfBoxCharacteristicSelect {
    constructor(theBegin: StepVisual_BoxCharacteristicSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_CurveStyleFontPattern extends Standard_Transient {
  constructor()
  Init(aVisibleSegmentLength: Quantity_AbsorbedDose, aInvisibleSegmentLength: Quantity_AbsorbedDose): void;
  SetVisibleSegmentLength(aVisibleSegmentLength: Quantity_AbsorbedDose): void;
  VisibleSegmentLength(): Quantity_AbsorbedDose;
  SetInvisibleSegmentLength(aInvisibleSegmentLength: Quantity_AbsorbedDose): void;
  InvisibleSegmentLength(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CurveStyleFontPattern {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CurveStyleFontPattern): void;
  get(): StepVisual_CurveStyleFontPattern;
  delete(): void;
}

  export declare class Handle_StepVisual_CurveStyleFontPattern_1 extends Handle_StepVisual_CurveStyleFontPattern {
    constructor();
  }

  export declare class Handle_StepVisual_CurveStyleFontPattern_2 extends Handle_StepVisual_CurveStyleFontPattern {
    constructor(thePtr: StepVisual_CurveStyleFontPattern);
  }

  export declare class Handle_StepVisual_CurveStyleFontPattern_3 extends Handle_StepVisual_CurveStyleFontPattern {
    constructor(theHandle: Handle_StepVisual_CurveStyleFontPattern);
  }

  export declare class Handle_StepVisual_CurveStyleFontPattern_4 extends Handle_StepVisual_CurveStyleFontPattern {
    constructor(theHandle: Handle_StepVisual_CurveStyleFontPattern);
  }

export declare type StepVisual_CentralOrParallel = {
  StepVisual_copCentral: {};
  StepVisual_copParallel: {};
}

export declare class Handle_StepVisual_SurfaceStyleParameterLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleParameterLine): void;
  get(): StepVisual_SurfaceStyleParameterLine;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleParameterLine_1 extends Handle_StepVisual_SurfaceStyleParameterLine {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleParameterLine_2 extends Handle_StepVisual_SurfaceStyleParameterLine {
    constructor(thePtr: StepVisual_SurfaceStyleParameterLine);
  }

  export declare class Handle_StepVisual_SurfaceStyleParameterLine_3 extends Handle_StepVisual_SurfaceStyleParameterLine {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleParameterLine);
  }

  export declare class Handle_StepVisual_SurfaceStyleParameterLine_4 extends Handle_StepVisual_SurfaceStyleParameterLine {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleParameterLine);
  }

export declare class StepVisual_SurfaceStyleParameterLine extends Standard_Transient {
  constructor()
  Init(aStyleOfParameterLines: Handle_StepVisual_CurveStyle, aDirectionCounts: Handle_StepVisual_HArray1OfDirectionCountSelect): void;
  SetStyleOfParameterLines(aStyleOfParameterLines: Handle_StepVisual_CurveStyle): void;
  StyleOfParameterLines(): Handle_StepVisual_CurveStyle;
  SetDirectionCounts(aDirectionCounts: Handle_StepVisual_HArray1OfDirectionCountSelect): void;
  DirectionCounts(): Handle_StepVisual_HArray1OfDirectionCountSelect;
  DirectionCountsValue(num: Graphic3d_ZLayerId): StepVisual_DirectionCountSelect;
  NbDirectionCounts(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentationView {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationView): void;
  get(): StepVisual_PresentationView;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationView_1 extends Handle_StepVisual_PresentationView {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationView_2 extends Handle_StepVisual_PresentationView {
    constructor(thePtr: StepVisual_PresentationView);
  }

  export declare class Handle_StepVisual_PresentationView_3 extends Handle_StepVisual_PresentationView {
    constructor(theHandle: Handle_StepVisual_PresentationView);
  }

  export declare class Handle_StepVisual_PresentationView_4 extends Handle_StepVisual_PresentationView {
    constructor(theHandle: Handle_StepVisual_PresentationView);
  }

export declare class StepVisual_PresentationView extends StepVisual_PresentationRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CameraModelD3MultiClippingIntersection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraModelD3MultiClippingIntersection): void;
  get(): StepVisual_CameraModelD3MultiClippingIntersection;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraModelD3MultiClippingIntersection_1 extends Handle_StepVisual_CameraModelD3MultiClippingIntersection {
    constructor();
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClippingIntersection_2 extends Handle_StepVisual_CameraModelD3MultiClippingIntersection {
    constructor(thePtr: StepVisual_CameraModelD3MultiClippingIntersection);
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClippingIntersection_3 extends Handle_StepVisual_CameraModelD3MultiClippingIntersection {
    constructor(theHandle: Handle_StepVisual_CameraModelD3MultiClippingIntersection);
  }

  export declare class Handle_StepVisual_CameraModelD3MultiClippingIntersection_4 extends Handle_StepVisual_CameraModelD3MultiClippingIntersection {
    constructor(theHandle: Handle_StepVisual_CameraModelD3MultiClippingIntersection);
  }

export declare class StepVisual_CameraModelD3MultiClippingIntersection extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theShapeClipping: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect): void;
  SetShapeClipping(theShapeClipping: Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect): void;
  ShapeClipping(): Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Template extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_Template {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_Template): void;
  get(): StepVisual_Template;
  delete(): void;
}

  export declare class Handle_StepVisual_Template_1 extends Handle_StepVisual_Template {
    constructor();
  }

  export declare class Handle_StepVisual_Template_2 extends Handle_StepVisual_Template {
    constructor(thePtr: StepVisual_Template);
  }

  export declare class Handle_StepVisual_Template_3 extends Handle_StepVisual_Template {
    constructor(theHandle: Handle_StepVisual_Template);
  }

  export declare class Handle_StepVisual_Template_4 extends Handle_StepVisual_Template {
    constructor(theHandle: Handle_StepVisual_Template);
  }

export declare class StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_CameraModelD3MultiClippingUnionSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect): StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect;
  Move(theOther: StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect): StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect;
  First(): StepVisual_CameraModelD3MultiClippingUnionSelect;
  ChangeFirst(): StepVisual_CameraModelD3MultiClippingUnionSelect;
  Last(): StepVisual_CameraModelD3MultiClippingUnionSelect;
  ChangeLast(): StepVisual_CameraModelD3MultiClippingUnionSelect;
  Value(theIndex: Standard_Integer): StepVisual_CameraModelD3MultiClippingUnionSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_CameraModelD3MultiClippingUnionSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_CameraModelD3MultiClippingUnionSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_1 extends StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_2 extends StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_3 extends StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect {
    constructor(theOther: StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect);
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_4 extends StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect {
    constructor(theOther: StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect);
  }

  export declare class StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_5 extends StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect {
    constructor(theBegin: StepVisual_CameraModelD3MultiClippingUnionSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepVisual_ContextDependentInvisibility extends StepVisual_Invisibility {
  constructor()
  Init(aInvisibleItems: Handle_StepVisual_HArray1OfInvisibleItem, aPresentationContext: StepVisual_InvisibilityContext): void;
  SetPresentationContext(aPresentationContext: StepVisual_InvisibilityContext): void;
  PresentationContext(): StepVisual_InvisibilityContext;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_ContextDependentInvisibility {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ContextDependentInvisibility): void;
  get(): StepVisual_ContextDependentInvisibility;
  delete(): void;
}

  export declare class Handle_StepVisual_ContextDependentInvisibility_1 extends Handle_StepVisual_ContextDependentInvisibility {
    constructor();
  }

  export declare class Handle_StepVisual_ContextDependentInvisibility_2 extends Handle_StepVisual_ContextDependentInvisibility {
    constructor(thePtr: StepVisual_ContextDependentInvisibility);
  }

  export declare class Handle_StepVisual_ContextDependentInvisibility_3 extends Handle_StepVisual_ContextDependentInvisibility {
    constructor(theHandle: Handle_StepVisual_ContextDependentInvisibility);
  }

  export declare class Handle_StepVisual_ContextDependentInvisibility_4 extends Handle_StepVisual_ContextDependentInvisibility {
    constructor(theHandle: Handle_StepVisual_ContextDependentInvisibility);
  }

export declare class Handle_StepVisual_CameraImage2dWithScale {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraImage2dWithScale): void;
  get(): StepVisual_CameraImage2dWithScale;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraImage2dWithScale_1 extends Handle_StepVisual_CameraImage2dWithScale {
    constructor();
  }

  export declare class Handle_StepVisual_CameraImage2dWithScale_2 extends Handle_StepVisual_CameraImage2dWithScale {
    constructor(thePtr: StepVisual_CameraImage2dWithScale);
  }

  export declare class Handle_StepVisual_CameraImage2dWithScale_3 extends Handle_StepVisual_CameraImage2dWithScale {
    constructor(theHandle: Handle_StepVisual_CameraImage2dWithScale);
  }

  export declare class Handle_StepVisual_CameraImage2dWithScale_4 extends Handle_StepVisual_CameraImage2dWithScale {
    constructor(theHandle: Handle_StepVisual_CameraImage2dWithScale);
  }

export declare class StepVisual_CameraImage2dWithScale extends StepVisual_CameraImage {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CameraUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraUsage): void;
  get(): StepVisual_CameraUsage;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraUsage_1 extends Handle_StepVisual_CameraUsage {
    constructor();
  }

  export declare class Handle_StepVisual_CameraUsage_2 extends Handle_StepVisual_CameraUsage {
    constructor(thePtr: StepVisual_CameraUsage);
  }

  export declare class Handle_StepVisual_CameraUsage_3 extends Handle_StepVisual_CameraUsage {
    constructor(theHandle: Handle_StepVisual_CameraUsage);
  }

  export declare class Handle_StepVisual_CameraUsage_4 extends Handle_StepVisual_CameraUsage {
    constructor(theHandle: Handle_StepVisual_CameraUsage);
  }

export declare class StepVisual_CameraUsage extends StepRepr_RepresentationMap {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_Array1OfAnnotationPlaneElement {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_AnnotationPlaneElement): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfAnnotationPlaneElement): StepVisual_Array1OfAnnotationPlaneElement;
  Move(theOther: StepVisual_Array1OfAnnotationPlaneElement): StepVisual_Array1OfAnnotationPlaneElement;
  First(): StepVisual_AnnotationPlaneElement;
  ChangeFirst(): StepVisual_AnnotationPlaneElement;
  Last(): StepVisual_AnnotationPlaneElement;
  ChangeLast(): StepVisual_AnnotationPlaneElement;
  Value(theIndex: Standard_Integer): StepVisual_AnnotationPlaneElement;
  ChangeValue(theIndex: Standard_Integer): StepVisual_AnnotationPlaneElement;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_AnnotationPlaneElement): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfAnnotationPlaneElement_1 extends StepVisual_Array1OfAnnotationPlaneElement {
    constructor();
  }

  export declare class StepVisual_Array1OfAnnotationPlaneElement_2 extends StepVisual_Array1OfAnnotationPlaneElement {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfAnnotationPlaneElement_3 extends StepVisual_Array1OfAnnotationPlaneElement {
    constructor(theOther: StepVisual_Array1OfAnnotationPlaneElement);
  }

  export declare class StepVisual_Array1OfAnnotationPlaneElement_4 extends StepVisual_Array1OfAnnotationPlaneElement {
    constructor(theOther: StepVisual_Array1OfAnnotationPlaneElement);
  }

  export declare class StepVisual_Array1OfAnnotationPlaneElement_5 extends StepVisual_Array1OfAnnotationPlaneElement {
    constructor(theBegin: StepVisual_AnnotationPlaneElement, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_CurveStyle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CurveStyle): void;
  get(): StepVisual_CurveStyle;
  delete(): void;
}

  export declare class Handle_StepVisual_CurveStyle_1 extends Handle_StepVisual_CurveStyle {
    constructor();
  }

  export declare class Handle_StepVisual_CurveStyle_2 extends Handle_StepVisual_CurveStyle {
    constructor(thePtr: StepVisual_CurveStyle);
  }

  export declare class Handle_StepVisual_CurveStyle_3 extends Handle_StepVisual_CurveStyle {
    constructor(theHandle: Handle_StepVisual_CurveStyle);
  }

  export declare class Handle_StepVisual_CurveStyle_4 extends Handle_StepVisual_CurveStyle {
    constructor(theHandle: Handle_StepVisual_CurveStyle);
  }

export declare class StepVisual_CurveStyle extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCurveFont: StepVisual_CurveStyleFontSelect, aCurveWidth: StepBasic_SizeSelect, aCurveColour: Handle_StepVisual_Colour): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetCurveFont(aCurveFont: StepVisual_CurveStyleFontSelect): void;
  CurveFont(): StepVisual_CurveStyleFontSelect;
  SetCurveWidth(aCurveWidth: StepBasic_SizeSelect): void;
  CurveWidth(): StepBasic_SizeSelect;
  SetCurveColour(aCurveColour: Handle_StepVisual_Colour): void;
  CurveColour(): Handle_StepVisual_Colour;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_CompositeTextWithExtent extends StepVisual_CompositeText {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCollectedText: Handle_StepVisual_HArray1OfTextOrCharacter, aExtent: Handle_StepVisual_PlanarExtent): void;
  SetExtent(aExtent: Handle_StepVisual_PlanarExtent): void;
  Extent(): Handle_StepVisual_PlanarExtent;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CompositeTextWithExtent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CompositeTextWithExtent): void;
  get(): StepVisual_CompositeTextWithExtent;
  delete(): void;
}

  export declare class Handle_StepVisual_CompositeTextWithExtent_1 extends Handle_StepVisual_CompositeTextWithExtent {
    constructor();
  }

  export declare class Handle_StepVisual_CompositeTextWithExtent_2 extends Handle_StepVisual_CompositeTextWithExtent {
    constructor(thePtr: StepVisual_CompositeTextWithExtent);
  }

  export declare class Handle_StepVisual_CompositeTextWithExtent_3 extends Handle_StepVisual_CompositeTextWithExtent {
    constructor(theHandle: Handle_StepVisual_CompositeTextWithExtent);
  }

  export declare class Handle_StepVisual_CompositeTextWithExtent_4 extends Handle_StepVisual_CompositeTextWithExtent {
    constructor(theHandle: Handle_StepVisual_CompositeTextWithExtent);
  }

export declare class StepVisual_AnnotationPlaneElement extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  DraughtingCallout(): Handle_StepVisual_DraughtingCallout;
  StyledItem(): Handle_StepVisual_StyledItem;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfTextOrCharacter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfTextOrCharacter): void;
  get(): StepVisual_HArray1OfTextOrCharacter;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfTextOrCharacter_1 extends Handle_StepVisual_HArray1OfTextOrCharacter {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfTextOrCharacter_2 extends Handle_StepVisual_HArray1OfTextOrCharacter {
    constructor(thePtr: StepVisual_HArray1OfTextOrCharacter);
  }

  export declare class Handle_StepVisual_HArray1OfTextOrCharacter_3 extends Handle_StepVisual_HArray1OfTextOrCharacter {
    constructor(theHandle: Handle_StepVisual_HArray1OfTextOrCharacter);
  }

  export declare class Handle_StepVisual_HArray1OfTextOrCharacter_4 extends Handle_StepVisual_HArray1OfTextOrCharacter {
    constructor(theHandle: Handle_StepVisual_HArray1OfTextOrCharacter);
  }

export declare class Handle_StepVisual_HArray1OfBoxCharacteristicSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfBoxCharacteristicSelect): void;
  get(): StepVisual_HArray1OfBoxCharacteristicSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfBoxCharacteristicSelect_1 extends Handle_StepVisual_HArray1OfBoxCharacteristicSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfBoxCharacteristicSelect_2 extends Handle_StepVisual_HArray1OfBoxCharacteristicSelect {
    constructor(thePtr: StepVisual_HArray1OfBoxCharacteristicSelect);
  }

  export declare class Handle_StepVisual_HArray1OfBoxCharacteristicSelect_3 extends Handle_StepVisual_HArray1OfBoxCharacteristicSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfBoxCharacteristicSelect);
  }

  export declare class Handle_StepVisual_HArray1OfBoxCharacteristicSelect_4 extends Handle_StepVisual_HArray1OfBoxCharacteristicSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfBoxCharacteristicSelect);
  }

export declare class Handle_StepVisual_HArray1OfDraughtingCalloutElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfDraughtingCalloutElement): void;
  get(): StepVisual_HArray1OfDraughtingCalloutElement;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfDraughtingCalloutElement_1 extends Handle_StepVisual_HArray1OfDraughtingCalloutElement {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfDraughtingCalloutElement_2 extends Handle_StepVisual_HArray1OfDraughtingCalloutElement {
    constructor(thePtr: StepVisual_HArray1OfDraughtingCalloutElement);
  }

  export declare class Handle_StepVisual_HArray1OfDraughtingCalloutElement_3 extends Handle_StepVisual_HArray1OfDraughtingCalloutElement {
    constructor(theHandle: Handle_StepVisual_HArray1OfDraughtingCalloutElement);
  }

  export declare class Handle_StepVisual_HArray1OfDraughtingCalloutElement_4 extends Handle_StepVisual_HArray1OfDraughtingCalloutElement {
    constructor(theHandle: Handle_StepVisual_HArray1OfDraughtingCalloutElement);
  }

export declare class Handle_StepVisual_TessellatedAnnotationOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TessellatedAnnotationOccurrence): void;
  get(): StepVisual_TessellatedAnnotationOccurrence;
  delete(): void;
}

  export declare class Handle_StepVisual_TessellatedAnnotationOccurrence_1 extends Handle_StepVisual_TessellatedAnnotationOccurrence {
    constructor();
  }

  export declare class Handle_StepVisual_TessellatedAnnotationOccurrence_2 extends Handle_StepVisual_TessellatedAnnotationOccurrence {
    constructor(thePtr: StepVisual_TessellatedAnnotationOccurrence);
  }

  export declare class Handle_StepVisual_TessellatedAnnotationOccurrence_3 extends Handle_StepVisual_TessellatedAnnotationOccurrence {
    constructor(theHandle: Handle_StepVisual_TessellatedAnnotationOccurrence);
  }

  export declare class Handle_StepVisual_TessellatedAnnotationOccurrence_4 extends Handle_StepVisual_TessellatedAnnotationOccurrence {
    constructor(theHandle: Handle_StepVisual_TessellatedAnnotationOccurrence);
  }

export declare class StepVisual_TessellatedAnnotationOccurrence extends StepVisual_StyledItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_AnnotationPlane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationPlane): void;
  get(): StepVisual_AnnotationPlane;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationPlane_1 extends Handle_StepVisual_AnnotationPlane {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationPlane_2 extends Handle_StepVisual_AnnotationPlane {
    constructor(thePtr: StepVisual_AnnotationPlane);
  }

  export declare class Handle_StepVisual_AnnotationPlane_3 extends Handle_StepVisual_AnnotationPlane {
    constructor(theHandle: Handle_StepVisual_AnnotationPlane);
  }

  export declare class Handle_StepVisual_AnnotationPlane_4 extends Handle_StepVisual_AnnotationPlane {
    constructor(theHandle: Handle_StepVisual_AnnotationPlane);
  }

export declare class StepVisual_AnnotationPlane extends StepVisual_AnnotationOccurrence {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theStyles: Handle_StepVisual_HArray1OfPresentationStyleAssignment, theItem: Handle_Standard_Transient, theElements: Handle_StepVisual_HArray1OfAnnotationPlaneElement): void;
  Elements(): Handle_StepVisual_HArray1OfAnnotationPlaneElement;
  SetElements(theElements: Handle_StepVisual_HArray1OfAnnotationPlaneElement): void;
  NbElements(): Graphic3d_ZLayerId;
  ElementsValue(theNum: Graphic3d_ZLayerId): StepVisual_AnnotationPlaneElement;
  SetElementsValue(theNum: Graphic3d_ZLayerId, theItem: StepVisual_AnnotationPlaneElement): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleRenderingWithProperties {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleRenderingWithProperties): void;
  get(): StepVisual_SurfaceStyleRenderingWithProperties;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleRenderingWithProperties_1 extends Handle_StepVisual_SurfaceStyleRenderingWithProperties {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleRenderingWithProperties_2 extends Handle_StepVisual_SurfaceStyleRenderingWithProperties {
    constructor(thePtr: StepVisual_SurfaceStyleRenderingWithProperties);
  }

  export declare class Handle_StepVisual_SurfaceStyleRenderingWithProperties_3 extends Handle_StepVisual_SurfaceStyleRenderingWithProperties {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleRenderingWithProperties);
  }

  export declare class Handle_StepVisual_SurfaceStyleRenderingWithProperties_4 extends Handle_StepVisual_SurfaceStyleRenderingWithProperties {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleRenderingWithProperties);
  }

export declare class StepVisual_SurfaceStyleRenderingWithProperties extends StepVisual_SurfaceStyleRendering {
  constructor()
  Init(theSurfaceStyleRendering_RenderingMethod: StepVisual_ShadingSurfaceMethod, theSurfaceStyleRendering_SurfaceColour: Handle_StepVisual_Colour, theProperties: Handle_StepVisual_HArray1OfRenderingPropertiesSelect): void;
  Properties(): Handle_StepVisual_HArray1OfRenderingPropertiesSelect;
  SetProperties(theProperties: Handle_StepVisual_HArray1OfRenderingPropertiesSelect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_PresentationStyleSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PointStyle(): Handle_StepVisual_PointStyle;
  CurveStyle(): Handle_StepVisual_CurveStyle;
  NullStyle(): Handle_StepVisual_NullStyleMember;
  SurfaceStyleUsage(): Handle_StepVisual_SurfaceStyleUsage;
  delete(): void;
}

export declare class StepVisual_StyledItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aStyles: Handle_StepVisual_HArray1OfPresentationStyleAssignment, aItem: Handle_Standard_Transient): void;
  SetStyles(aStyles: Handle_StepVisual_HArray1OfPresentationStyleAssignment): void;
  Styles(): Handle_StepVisual_HArray1OfPresentationStyleAssignment;
  StylesValue(num: Graphic3d_ZLayerId): Handle_StepVisual_PresentationStyleAssignment;
  NbStyles(): Graphic3d_ZLayerId;
  SetItem_1(aItem: Handle_StepRepr_RepresentationItem): void;
  Item(): Handle_StepRepr_RepresentationItem;
  SetItem_2(aItem: StepVisual_StyledItemTarget): void;
  ItemAP242(): StepVisual_StyledItemTarget;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_StyledItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_StyledItem): void;
  get(): StepVisual_StyledItem;
  delete(): void;
}

  export declare class Handle_StepVisual_StyledItem_1 extends Handle_StepVisual_StyledItem {
    constructor();
  }

  export declare class Handle_StepVisual_StyledItem_2 extends Handle_StepVisual_StyledItem {
    constructor(thePtr: StepVisual_StyledItem);
  }

  export declare class Handle_StepVisual_StyledItem_3 extends Handle_StepVisual_StyledItem {
    constructor(theHandle: Handle_StepVisual_StyledItem);
  }

  export declare class Handle_StepVisual_StyledItem_4 extends Handle_StepVisual_StyledItem {
    constructor(theHandle: Handle_StepVisual_StyledItem);
  }

export declare class StepVisual_AnnotationCurveOccurrence extends StepVisual_AnnotationOccurrence {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_AnnotationCurveOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationCurveOccurrence): void;
  get(): StepVisual_AnnotationCurveOccurrence;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationCurveOccurrence_1 extends Handle_StepVisual_AnnotationCurveOccurrence {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationCurveOccurrence_2 extends Handle_StepVisual_AnnotationCurveOccurrence {
    constructor(thePtr: StepVisual_AnnotationCurveOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationCurveOccurrence_3 extends Handle_StepVisual_AnnotationCurveOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationCurveOccurrence);
  }

  export declare class Handle_StepVisual_AnnotationCurveOccurrence_4 extends Handle_StepVisual_AnnotationCurveOccurrence {
    constructor(theHandle: Handle_StepVisual_AnnotationCurveOccurrence);
  }

export declare class Handle_StepVisual_HArray1OfInvisibleItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfInvisibleItem): void;
  get(): StepVisual_HArray1OfInvisibleItem;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfInvisibleItem_1 extends Handle_StepVisual_HArray1OfInvisibleItem {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfInvisibleItem_2 extends Handle_StepVisual_HArray1OfInvisibleItem {
    constructor(thePtr: StepVisual_HArray1OfInvisibleItem);
  }

  export declare class Handle_StepVisual_HArray1OfInvisibleItem_3 extends Handle_StepVisual_HArray1OfInvisibleItem {
    constructor(theHandle: Handle_StepVisual_HArray1OfInvisibleItem);
  }

  export declare class Handle_StepVisual_HArray1OfInvisibleItem_4 extends Handle_StepVisual_HArray1OfInvisibleItem {
    constructor(theHandle: Handle_StepVisual_HArray1OfInvisibleItem);
  }

export declare class StepVisual_CompositeText extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCollectedText: Handle_StepVisual_HArray1OfTextOrCharacter): void;
  SetCollectedText(aCollectedText: Handle_StepVisual_HArray1OfTextOrCharacter): void;
  CollectedText(): Handle_StepVisual_HArray1OfTextOrCharacter;
  CollectedTextValue(num: Graphic3d_ZLayerId): StepVisual_TextOrCharacter;
  NbCollectedText(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CompositeText {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CompositeText): void;
  get(): StepVisual_CompositeText;
  delete(): void;
}

  export declare class Handle_StepVisual_CompositeText_1 extends Handle_StepVisual_CompositeText {
    constructor();
  }

  export declare class Handle_StepVisual_CompositeText_2 extends Handle_StepVisual_CompositeText {
    constructor(thePtr: StepVisual_CompositeText);
  }

  export declare class Handle_StepVisual_CompositeText_3 extends Handle_StepVisual_CompositeText {
    constructor(theHandle: Handle_StepVisual_CompositeText);
  }

  export declare class Handle_StepVisual_CompositeText_4 extends Handle_StepVisual_CompositeText {
    constructor(theHandle: Handle_StepVisual_CompositeText);
  }

export declare class StepVisual_PresentedItem extends Standard_Transient {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentedItem): void;
  get(): StepVisual_PresentedItem;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentedItem_1 extends Handle_StepVisual_PresentedItem {
    constructor();
  }

  export declare class Handle_StepVisual_PresentedItem_2 extends Handle_StepVisual_PresentedItem {
    constructor(thePtr: StepVisual_PresentedItem);
  }

  export declare class Handle_StepVisual_PresentedItem_3 extends Handle_StepVisual_PresentedItem {
    constructor(theHandle: Handle_StepVisual_PresentedItem);
  }

  export declare class Handle_StepVisual_PresentedItem_4 extends Handle_StepVisual_PresentedItem {
    constructor(theHandle: Handle_StepVisual_PresentedItem);
  }

export declare class StepVisual_AreaOrView extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PresentationArea(): Handle_StepVisual_PresentationArea;
  PresentationView(): Handle_StepVisual_PresentationView;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfFillStyleSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfFillStyleSelect): void;
  get(): StepVisual_HArray1OfFillStyleSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfFillStyleSelect_1 extends Handle_StepVisual_HArray1OfFillStyleSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfFillStyleSelect_2 extends Handle_StepVisual_HArray1OfFillStyleSelect {
    constructor(thePtr: StepVisual_HArray1OfFillStyleSelect);
  }

  export declare class Handle_StepVisual_HArray1OfFillStyleSelect_3 extends Handle_StepVisual_HArray1OfFillStyleSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfFillStyleSelect);
  }

  export declare class Handle_StepVisual_HArray1OfFillStyleSelect_4 extends Handle_StepVisual_HArray1OfFillStyleSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfFillStyleSelect);
  }

export declare class StepVisual_RenderingPropertiesSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  SurfaceStyleReflectanceAmbient(): Handle_StepVisual_SurfaceStyleReflectanceAmbient;
  SurfaceStyleTransparent(): Handle_StepVisual_SurfaceStyleTransparent;
  delete(): void;
}

export declare class StepVisual_CameraImage3dWithScale extends StepVisual_CameraImage {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CameraImage3dWithScale {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraImage3dWithScale): void;
  get(): StepVisual_CameraImage3dWithScale;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraImage3dWithScale_1 extends Handle_StepVisual_CameraImage3dWithScale {
    constructor();
  }

  export declare class Handle_StepVisual_CameraImage3dWithScale_2 extends Handle_StepVisual_CameraImage3dWithScale {
    constructor(thePtr: StepVisual_CameraImage3dWithScale);
  }

  export declare class Handle_StepVisual_CameraImage3dWithScale_3 extends Handle_StepVisual_CameraImage3dWithScale {
    constructor(theHandle: Handle_StepVisual_CameraImage3dWithScale);
  }

  export declare class Handle_StepVisual_CameraImage3dWithScale_4 extends Handle_StepVisual_CameraImage3dWithScale {
    constructor(theHandle: Handle_StepVisual_CameraImage3dWithScale);
  }

export declare class Handle_StepVisual_FillAreaStyleColour {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_FillAreaStyleColour): void;
  get(): StepVisual_FillAreaStyleColour;
  delete(): void;
}

  export declare class Handle_StepVisual_FillAreaStyleColour_1 extends Handle_StepVisual_FillAreaStyleColour {
    constructor();
  }

  export declare class Handle_StepVisual_FillAreaStyleColour_2 extends Handle_StepVisual_FillAreaStyleColour {
    constructor(thePtr: StepVisual_FillAreaStyleColour);
  }

  export declare class Handle_StepVisual_FillAreaStyleColour_3 extends Handle_StepVisual_FillAreaStyleColour {
    constructor(theHandle: Handle_StepVisual_FillAreaStyleColour);
  }

  export declare class Handle_StepVisual_FillAreaStyleColour_4 extends Handle_StepVisual_FillAreaStyleColour {
    constructor(theHandle: Handle_StepVisual_FillAreaStyleColour);
  }

export declare class StepVisual_FillAreaStyleColour extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aFillColour: Handle_StepVisual_Colour): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetFillColour(aFillColour: Handle_StepVisual_Colour): void;
  FillColour(): Handle_StepVisual_Colour;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfDirectionCountSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfDirectionCountSelect): void;
  get(): StepVisual_HArray1OfDirectionCountSelect;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfDirectionCountSelect_1 extends Handle_StepVisual_HArray1OfDirectionCountSelect {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfDirectionCountSelect_2 extends Handle_StepVisual_HArray1OfDirectionCountSelect {
    constructor(thePtr: StepVisual_HArray1OfDirectionCountSelect);
  }

  export declare class Handle_StepVisual_HArray1OfDirectionCountSelect_3 extends Handle_StepVisual_HArray1OfDirectionCountSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfDirectionCountSelect);
  }

  export declare class Handle_StepVisual_HArray1OfDirectionCountSelect_4 extends Handle_StepVisual_HArray1OfDirectionCountSelect {
    constructor(theHandle: Handle_StepVisual_HArray1OfDirectionCountSelect);
  }

export declare class StepVisual_SurfaceStyleTransparent extends Standard_Transient {
  constructor()
  Init(theTransparency: Quantity_AbsorbedDose): void;
  Transparency(): Quantity_AbsorbedDose;
  SetTransparency(theTransparency: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleTransparent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleTransparent): void;
  get(): StepVisual_SurfaceStyleTransparent;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleTransparent_1 extends Handle_StepVisual_SurfaceStyleTransparent {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleTransparent_2 extends Handle_StepVisual_SurfaceStyleTransparent {
    constructor(thePtr: StepVisual_SurfaceStyleTransparent);
  }

  export declare class Handle_StepVisual_SurfaceStyleTransparent_3 extends Handle_StepVisual_SurfaceStyleTransparent {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleTransparent);
  }

  export declare class Handle_StepVisual_SurfaceStyleTransparent_4 extends Handle_StepVisual_SurfaceStyleTransparent {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleTransparent);
  }

export declare class StepVisual_DraughtingCallout extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theContents: Handle_StepVisual_HArray1OfDraughtingCalloutElement): void;
  Contents(): Handle_StepVisual_HArray1OfDraughtingCalloutElement;
  SetContents(theContents: Handle_StepVisual_HArray1OfDraughtingCalloutElement): void;
  NbContents(): Graphic3d_ZLayerId;
  ContentsValue(theNum: Graphic3d_ZLayerId): StepVisual_DraughtingCalloutElement;
  SetContentsValue(theNum: Graphic3d_ZLayerId, theItem: StepVisual_DraughtingCalloutElement): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_DraughtingCallout {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_DraughtingCallout): void;
  get(): StepVisual_DraughtingCallout;
  delete(): void;
}

  export declare class Handle_StepVisual_DraughtingCallout_1 extends Handle_StepVisual_DraughtingCallout {
    constructor();
  }

  export declare class Handle_StepVisual_DraughtingCallout_2 extends Handle_StepVisual_DraughtingCallout {
    constructor(thePtr: StepVisual_DraughtingCallout);
  }

  export declare class Handle_StepVisual_DraughtingCallout_3 extends Handle_StepVisual_DraughtingCallout {
    constructor(theHandle: Handle_StepVisual_DraughtingCallout);
  }

  export declare class Handle_StepVisual_DraughtingCallout_4 extends Handle_StepVisual_DraughtingCallout {
    constructor(theHandle: Handle_StepVisual_DraughtingCallout);
  }

export declare class StepVisual_DraughtingCalloutElement extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AnnotationCurveOccurrence(): Handle_StepVisual_AnnotationCurveOccurrence;
  AnnotationTextOccurrence(): Handle_StepVisual_AnnotationTextOccurrence;
  TessellatedAnnotationOccurrence(): Handle_StepVisual_TessellatedAnnotationOccurrence;
  AnnotationFillAreaOccurrence(): Handle_StepVisual_AnnotationFillAreaOccurrence;
  delete(): void;
}

export declare class Handle_StepVisual_Colour {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_Colour): void;
  get(): StepVisual_Colour;
  delete(): void;
}

  export declare class Handle_StepVisual_Colour_1 extends Handle_StepVisual_Colour {
    constructor();
  }

  export declare class Handle_StepVisual_Colour_2 extends Handle_StepVisual_Colour {
    constructor(thePtr: StepVisual_Colour);
  }

  export declare class Handle_StepVisual_Colour_3 extends Handle_StepVisual_Colour {
    constructor(theHandle: Handle_StepVisual_Colour);
  }

  export declare class Handle_StepVisual_Colour_4 extends Handle_StepVisual_Colour {
    constructor(theHandle: Handle_StepVisual_Colour);
  }

export declare class StepVisual_Colour extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceSideStyle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceSideStyle): void;
  get(): StepVisual_SurfaceSideStyle;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceSideStyle_1 extends Handle_StepVisual_SurfaceSideStyle {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceSideStyle_2 extends Handle_StepVisual_SurfaceSideStyle {
    constructor(thePtr: StepVisual_SurfaceSideStyle);
  }

  export declare class Handle_StepVisual_SurfaceSideStyle_3 extends Handle_StepVisual_SurfaceSideStyle {
    constructor(theHandle: Handle_StepVisual_SurfaceSideStyle);
  }

  export declare class Handle_StepVisual_SurfaceSideStyle_4 extends Handle_StepVisual_SurfaceSideStyle {
    constructor(theHandle: Handle_StepVisual_SurfaceSideStyle);
  }

export declare class StepVisual_SurfaceSideStyle extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aStyles: Handle_StepVisual_HArray1OfSurfaceStyleElementSelect): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetStyles(aStyles: Handle_StepVisual_HArray1OfSurfaceStyleElementSelect): void;
  Styles(): Handle_StepVisual_HArray1OfSurfaceStyleElementSelect;
  StylesValue(num: Graphic3d_ZLayerId): StepVisual_SurfaceStyleElementSelect;
  NbStyles(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfPresentationStyleAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfPresentationStyleAssignment): void;
  get(): StepVisual_HArray1OfPresentationStyleAssignment;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfPresentationStyleAssignment_1 extends Handle_StepVisual_HArray1OfPresentationStyleAssignment {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfPresentationStyleAssignment_2 extends Handle_StepVisual_HArray1OfPresentationStyleAssignment {
    constructor(thePtr: StepVisual_HArray1OfPresentationStyleAssignment);
  }

  export declare class Handle_StepVisual_HArray1OfPresentationStyleAssignment_3 extends Handle_StepVisual_HArray1OfPresentationStyleAssignment {
    constructor(theHandle: Handle_StepVisual_HArray1OfPresentationStyleAssignment);
  }

  export declare class Handle_StepVisual_HArray1OfPresentationStyleAssignment_4 extends Handle_StepVisual_HArray1OfPresentationStyleAssignment {
    constructor(theHandle: Handle_StepVisual_HArray1OfPresentationStyleAssignment);
  }

export declare class Handle_StepVisual_PreDefinedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PreDefinedItem): void;
  get(): StepVisual_PreDefinedItem;
  delete(): void;
}

  export declare class Handle_StepVisual_PreDefinedItem_1 extends Handle_StepVisual_PreDefinedItem {
    constructor();
  }

  export declare class Handle_StepVisual_PreDefinedItem_2 extends Handle_StepVisual_PreDefinedItem {
    constructor(thePtr: StepVisual_PreDefinedItem);
  }

  export declare class Handle_StepVisual_PreDefinedItem_3 extends Handle_StepVisual_PreDefinedItem {
    constructor(theHandle: Handle_StepVisual_PreDefinedItem);
  }

  export declare class Handle_StepVisual_PreDefinedItem_4 extends Handle_StepVisual_PreDefinedItem {
    constructor(theHandle: Handle_StepVisual_PreDefinedItem);
  }

export declare class StepVisual_PreDefinedItem extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_TextOrCharacter extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AnnotationText(): Handle_StepVisual_AnnotationText;
  CompositeText(): Handle_StepVisual_CompositeText;
  TextLiteral(): Handle_StepVisual_TextLiteral;
  delete(): void;
}

export declare class StepVisual_PreDefinedColour extends StepVisual_Colour {
  constructor()
  SetPreDefinedItem(item: Handle_StepVisual_PreDefinedItem): void;
  GetPreDefinedItem(): Handle_StepVisual_PreDefinedItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PreDefinedColour {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PreDefinedColour): void;
  get(): StepVisual_PreDefinedColour;
  delete(): void;
}

  export declare class Handle_StepVisual_PreDefinedColour_1 extends Handle_StepVisual_PreDefinedColour {
    constructor();
  }

  export declare class Handle_StepVisual_PreDefinedColour_2 extends Handle_StepVisual_PreDefinedColour {
    constructor(thePtr: StepVisual_PreDefinedColour);
  }

  export declare class Handle_StepVisual_PreDefinedColour_3 extends Handle_StepVisual_PreDefinedColour {
    constructor(theHandle: Handle_StepVisual_PreDefinedColour);
  }

  export declare class Handle_StepVisual_PreDefinedColour_4 extends Handle_StepVisual_PreDefinedColour {
    constructor(theHandle: Handle_StepVisual_PreDefinedColour);
  }

export declare class Handle_StepVisual_AnnotationFillArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_AnnotationFillArea): void;
  get(): StepVisual_AnnotationFillArea;
  delete(): void;
}

  export declare class Handle_StepVisual_AnnotationFillArea_1 extends Handle_StepVisual_AnnotationFillArea {
    constructor();
  }

  export declare class Handle_StepVisual_AnnotationFillArea_2 extends Handle_StepVisual_AnnotationFillArea {
    constructor(thePtr: StepVisual_AnnotationFillArea);
  }

  export declare class Handle_StepVisual_AnnotationFillArea_3 extends Handle_StepVisual_AnnotationFillArea {
    constructor(theHandle: Handle_StepVisual_AnnotationFillArea);
  }

  export declare class Handle_StepVisual_AnnotationFillArea_4 extends Handle_StepVisual_AnnotationFillArea {
    constructor(theHandle: Handle_StepVisual_AnnotationFillArea);
  }

export declare class StepVisual_AnnotationFillArea extends StepShape_GeometricCurveSet {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_CoordinatesList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CoordinatesList): void;
  get(): StepVisual_CoordinatesList;
  delete(): void;
}

  export declare class Handle_StepVisual_CoordinatesList_1 extends Handle_StepVisual_CoordinatesList {
    constructor();
  }

  export declare class Handle_StepVisual_CoordinatesList_2 extends Handle_StepVisual_CoordinatesList {
    constructor(thePtr: StepVisual_CoordinatesList);
  }

  export declare class Handle_StepVisual_CoordinatesList_3 extends Handle_StepVisual_CoordinatesList {
    constructor(theHandle: Handle_StepVisual_CoordinatesList);
  }

  export declare class Handle_StepVisual_CoordinatesList_4 extends Handle_StepVisual_CoordinatesList {
    constructor(theHandle: Handle_StepVisual_CoordinatesList);
  }

export declare class StepVisual_CoordinatesList extends StepVisual_TessellatedItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, thePoints: Handle_TColgp_HArray1OfXYZ): void;
  Points(): Handle_TColgp_HArray1OfXYZ;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_FillStyleSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  FillAreaStyleColour(): Handle_StepVisual_FillAreaStyleColour;
  delete(): void;
}

export declare class Handle_StepVisual_TessellatedGeometricSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TessellatedGeometricSet): void;
  get(): StepVisual_TessellatedGeometricSet;
  delete(): void;
}

  export declare class Handle_StepVisual_TessellatedGeometricSet_1 extends Handle_StepVisual_TessellatedGeometricSet {
    constructor();
  }

  export declare class Handle_StepVisual_TessellatedGeometricSet_2 extends Handle_StepVisual_TessellatedGeometricSet {
    constructor(thePtr: StepVisual_TessellatedGeometricSet);
  }

  export declare class Handle_StepVisual_TessellatedGeometricSet_3 extends Handle_StepVisual_TessellatedGeometricSet {
    constructor(theHandle: Handle_StepVisual_TessellatedGeometricSet);
  }

  export declare class Handle_StepVisual_TessellatedGeometricSet_4 extends Handle_StepVisual_TessellatedGeometricSet {
    constructor(theHandle: Handle_StepVisual_TessellatedGeometricSet);
  }

export declare class StepVisual_TessellatedGeometricSet extends StepVisual_TessellatedItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theItems: NCollection_Handle<StepVisual_Array1OfTessellatedItem>): void;
  Items(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_BackgroundColour extends StepVisual_Colour {
  constructor()
  Init(aPresentation: StepVisual_AreaOrView): void;
  SetPresentation(aPresentation: StepVisual_AreaOrView): void;
  Presentation(): StepVisual_AreaOrView;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_BackgroundColour {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_BackgroundColour): void;
  get(): StepVisual_BackgroundColour;
  delete(): void;
}

  export declare class Handle_StepVisual_BackgroundColour_1 extends Handle_StepVisual_BackgroundColour {
    constructor();
  }

  export declare class Handle_StepVisual_BackgroundColour_2 extends Handle_StepVisual_BackgroundColour {
    constructor(thePtr: StepVisual_BackgroundColour);
  }

  export declare class Handle_StepVisual_BackgroundColour_3 extends Handle_StepVisual_BackgroundColour {
    constructor(theHandle: Handle_StepVisual_BackgroundColour);
  }

  export declare class Handle_StepVisual_BackgroundColour_4 extends Handle_StepVisual_BackgroundColour {
    constructor(theHandle: Handle_StepVisual_BackgroundColour);
  }

export declare class StepVisual_Array1OfRenderingPropertiesSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepVisual_RenderingPropertiesSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepVisual_Array1OfRenderingPropertiesSelect): StepVisual_Array1OfRenderingPropertiesSelect;
  Move(theOther: StepVisual_Array1OfRenderingPropertiesSelect): StepVisual_Array1OfRenderingPropertiesSelect;
  First(): StepVisual_RenderingPropertiesSelect;
  ChangeFirst(): StepVisual_RenderingPropertiesSelect;
  Last(): StepVisual_RenderingPropertiesSelect;
  ChangeLast(): StepVisual_RenderingPropertiesSelect;
  Value(theIndex: Standard_Integer): StepVisual_RenderingPropertiesSelect;
  ChangeValue(theIndex: Standard_Integer): StepVisual_RenderingPropertiesSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepVisual_RenderingPropertiesSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepVisual_Array1OfRenderingPropertiesSelect_1 extends StepVisual_Array1OfRenderingPropertiesSelect {
    constructor();
  }

  export declare class StepVisual_Array1OfRenderingPropertiesSelect_2 extends StepVisual_Array1OfRenderingPropertiesSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepVisual_Array1OfRenderingPropertiesSelect_3 extends StepVisual_Array1OfRenderingPropertiesSelect {
    constructor(theOther: StepVisual_Array1OfRenderingPropertiesSelect);
  }

  export declare class StepVisual_Array1OfRenderingPropertiesSelect_4 extends StepVisual_Array1OfRenderingPropertiesSelect {
    constructor(theOther: StepVisual_Array1OfRenderingPropertiesSelect);
  }

  export declare class StepVisual_Array1OfRenderingPropertiesSelect_5 extends StepVisual_Array1OfRenderingPropertiesSelect {
    constructor(theBegin: StepVisual_RenderingPropertiesSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepVisual_PreDefinedCurveFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PreDefinedCurveFont): void;
  get(): StepVisual_PreDefinedCurveFont;
  delete(): void;
}

  export declare class Handle_StepVisual_PreDefinedCurveFont_1 extends Handle_StepVisual_PreDefinedCurveFont {
    constructor();
  }

  export declare class Handle_StepVisual_PreDefinedCurveFont_2 extends Handle_StepVisual_PreDefinedCurveFont {
    constructor(thePtr: StepVisual_PreDefinedCurveFont);
  }

  export declare class Handle_StepVisual_PreDefinedCurveFont_3 extends Handle_StepVisual_PreDefinedCurveFont {
    constructor(theHandle: Handle_StepVisual_PreDefinedCurveFont);
  }

  export declare class Handle_StepVisual_PreDefinedCurveFont_4 extends Handle_StepVisual_PreDefinedCurveFont {
    constructor(theHandle: Handle_StepVisual_PreDefinedCurveFont);
  }

export declare class StepVisual_PreDefinedCurveFont extends StepVisual_PreDefinedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_TessellatedCurveSet extends StepVisual_TessellatedItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theCoordList: Handle_StepVisual_CoordinatesList, theCurves: NCollection_Handle<StepVisual_VectorOfHSequenceOfInteger>): void;
  CoordList(): Handle_StepVisual_CoordinatesList;
  Curves(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_TessellatedCurveSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TessellatedCurveSet): void;
  get(): StepVisual_TessellatedCurveSet;
  delete(): void;
}

  export declare class Handle_StepVisual_TessellatedCurveSet_1 extends Handle_StepVisual_TessellatedCurveSet {
    constructor();
  }

  export declare class Handle_StepVisual_TessellatedCurveSet_2 extends Handle_StepVisual_TessellatedCurveSet {
    constructor(thePtr: StepVisual_TessellatedCurveSet);
  }

  export declare class Handle_StepVisual_TessellatedCurveSet_3 extends Handle_StepVisual_TessellatedCurveSet {
    constructor(theHandle: Handle_StepVisual_TessellatedCurveSet);
  }

  export declare class Handle_StepVisual_TessellatedCurveSet_4 extends Handle_StepVisual_TessellatedCurveSet {
    constructor(theHandle: Handle_StepVisual_TessellatedCurveSet);
  }

export declare class Handle_StepVisual_SurfaceStyleControlGrid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleControlGrid): void;
  get(): StepVisual_SurfaceStyleControlGrid;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleControlGrid_1 extends Handle_StepVisual_SurfaceStyleControlGrid {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleControlGrid_2 extends Handle_StepVisual_SurfaceStyleControlGrid {
    constructor(thePtr: StepVisual_SurfaceStyleControlGrid);
  }

  export declare class Handle_StepVisual_SurfaceStyleControlGrid_3 extends Handle_StepVisual_SurfaceStyleControlGrid {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleControlGrid);
  }

  export declare class Handle_StepVisual_SurfaceStyleControlGrid_4 extends Handle_StepVisual_SurfaceStyleControlGrid {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleControlGrid);
  }

export declare class StepVisual_SurfaceStyleControlGrid extends Standard_Transient {
  constructor()
  Init(aStyleOfControlGrid: Handle_StepVisual_CurveStyle): void;
  SetStyleOfControlGrid(aStyleOfControlGrid: Handle_StepVisual_CurveStyle): void;
  StyleOfControlGrid(): Handle_StepVisual_CurveStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_DirectionCountSelect {
  constructor()
  SetTypeOfContent(aTypeOfContent: Graphic3d_ZLayerId): void;
  TypeOfContent(): Graphic3d_ZLayerId;
  UDirectionCount(): Graphic3d_ZLayerId;
  SetUDirectionCount(aUDirectionCount: Graphic3d_ZLayerId): void;
  VDirectionCount(): Graphic3d_ZLayerId;
  SetVDirectionCount(aUDirectionCount: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_StepVisual_CameraModelD3 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_CameraModelD3): void;
  get(): StepVisual_CameraModelD3;
  delete(): void;
}

  export declare class Handle_StepVisual_CameraModelD3_1 extends Handle_StepVisual_CameraModelD3 {
    constructor();
  }

  export declare class Handle_StepVisual_CameraModelD3_2 extends Handle_StepVisual_CameraModelD3 {
    constructor(thePtr: StepVisual_CameraModelD3);
  }

  export declare class Handle_StepVisual_CameraModelD3_3 extends Handle_StepVisual_CameraModelD3 {
    constructor(theHandle: Handle_StepVisual_CameraModelD3);
  }

  export declare class Handle_StepVisual_CameraModelD3_4 extends Handle_StepVisual_CameraModelD3 {
    constructor(theHandle: Handle_StepVisual_CameraModelD3);
  }

export declare class StepVisual_CameraModelD3 extends StepVisual_CameraModel {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aViewReferenceSystem: Handle_StepGeom_Axis2Placement3d, aPerspectiveOfVolume: Handle_StepVisual_ViewVolume): void;
  SetViewReferenceSystem(aViewReferenceSystem: Handle_StepGeom_Axis2Placement3d): void;
  ViewReferenceSystem(): Handle_StepGeom_Axis2Placement3d;
  SetPerspectiveOfVolume(aPerspectiveOfVolume: Handle_StepVisual_ViewVolume): void;
  PerspectiveOfVolume(): Handle_StepVisual_ViewVolume;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_HArray1OfAnnotationPlaneElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_HArray1OfAnnotationPlaneElement): void;
  get(): StepVisual_HArray1OfAnnotationPlaneElement;
  delete(): void;
}

  export declare class Handle_StepVisual_HArray1OfAnnotationPlaneElement_1 extends Handle_StepVisual_HArray1OfAnnotationPlaneElement {
    constructor();
  }

  export declare class Handle_StepVisual_HArray1OfAnnotationPlaneElement_2 extends Handle_StepVisual_HArray1OfAnnotationPlaneElement {
    constructor(thePtr: StepVisual_HArray1OfAnnotationPlaneElement);
  }

  export declare class Handle_StepVisual_HArray1OfAnnotationPlaneElement_3 extends Handle_StepVisual_HArray1OfAnnotationPlaneElement {
    constructor(theHandle: Handle_StepVisual_HArray1OfAnnotationPlaneElement);
  }

  export declare class Handle_StepVisual_HArray1OfAnnotationPlaneElement_4 extends Handle_StepVisual_HArray1OfAnnotationPlaneElement {
    constructor(theHandle: Handle_StepVisual_HArray1OfAnnotationPlaneElement);
  }

export declare class StepVisual_ExternallyDefinedTextFont extends StepBasic_ExternallyDefinedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_ExternallyDefinedTextFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_ExternallyDefinedTextFont): void;
  get(): StepVisual_ExternallyDefinedTextFont;
  delete(): void;
}

  export declare class Handle_StepVisual_ExternallyDefinedTextFont_1 extends Handle_StepVisual_ExternallyDefinedTextFont {
    constructor();
  }

  export declare class Handle_StepVisual_ExternallyDefinedTextFont_2 extends Handle_StepVisual_ExternallyDefinedTextFont {
    constructor(thePtr: StepVisual_ExternallyDefinedTextFont);
  }

  export declare class Handle_StepVisual_ExternallyDefinedTextFont_3 extends Handle_StepVisual_ExternallyDefinedTextFont {
    constructor(theHandle: Handle_StepVisual_ExternallyDefinedTextFont);
  }

  export declare class Handle_StepVisual_ExternallyDefinedTextFont_4 extends Handle_StepVisual_ExternallyDefinedTextFont {
    constructor(theHandle: Handle_StepVisual_ExternallyDefinedTextFont);
  }

export declare class Handle_StepVisual_PresentedItemRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentedItemRepresentation): void;
  get(): StepVisual_PresentedItemRepresentation;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentedItemRepresentation_1 extends Handle_StepVisual_PresentedItemRepresentation {
    constructor();
  }

  export declare class Handle_StepVisual_PresentedItemRepresentation_2 extends Handle_StepVisual_PresentedItemRepresentation {
    constructor(thePtr: StepVisual_PresentedItemRepresentation);
  }

  export declare class Handle_StepVisual_PresentedItemRepresentation_3 extends Handle_StepVisual_PresentedItemRepresentation {
    constructor(theHandle: Handle_StepVisual_PresentedItemRepresentation);
  }

  export declare class Handle_StepVisual_PresentedItemRepresentation_4 extends Handle_StepVisual_PresentedItemRepresentation {
    constructor(theHandle: Handle_StepVisual_PresentedItemRepresentation);
  }

export declare class StepVisual_PresentedItemRepresentation extends Standard_Transient {
  constructor()
  Init(aPresentation: StepVisual_PresentationRepresentationSelect, aItem: Handle_StepVisual_PresentedItem): void;
  SetPresentation(aPresentation: StepVisual_PresentationRepresentationSelect): void;
  Presentation(): StepVisual_PresentationRepresentationSelect;
  SetItem(aItem: Handle_StepVisual_PresentedItem): void;
  Item(): Handle_StepVisual_PresentedItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_LayeredItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PresentationRepresentation(): Handle_StepVisual_PresentationRepresentation;
  RepresentationItem(): Handle_StepRepr_RepresentationItem;
  delete(): void;
}

export declare class StepVisual_MarkerMember extends StepData_SelectInt {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  EnumText(): Standard_CString;
  SetEnumText(val: Graphic3d_ZLayerId, text: Standard_CString): void;
  SetValue(val: StepVisual_MarkerType): void;
  Value(): StepVisual_MarkerType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_MarkerMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_MarkerMember): void;
  get(): StepVisual_MarkerMember;
  delete(): void;
}

  export declare class Handle_StepVisual_MarkerMember_1 extends Handle_StepVisual_MarkerMember {
    constructor();
  }

  export declare class Handle_StepVisual_MarkerMember_2 extends Handle_StepVisual_MarkerMember {
    constructor(thePtr: StepVisual_MarkerMember);
  }

  export declare class Handle_StepVisual_MarkerMember_3 extends Handle_StepVisual_MarkerMember {
    constructor(theHandle: Handle_StepVisual_MarkerMember);
  }

  export declare class Handle_StepVisual_MarkerMember_4 extends Handle_StepVisual_MarkerMember {
    constructor(theHandle: Handle_StepVisual_MarkerMember);
  }

export declare class StepVisual_FontSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PreDefinedTextFont(): Handle_StepVisual_PreDefinedTextFont;
  ExternallyDefinedTextFont(): Handle_StepVisual_ExternallyDefinedTextFont;
  delete(): void;
}

export declare class StepVisual_PresentationLayerUsage extends Standard_Transient {
  constructor()
  Init(aAssignment: Handle_StepVisual_PresentationLayerAssignment, aPresentation: Handle_StepVisual_PresentationRepresentation): void;
  SetAssignment(aAssignment: Handle_StepVisual_PresentationLayerAssignment): void;
  Assignment(): Handle_StepVisual_PresentationLayerAssignment;
  SetPresentation(aPresentation: Handle_StepVisual_PresentationRepresentation): void;
  Presentation(): Handle_StepVisual_PresentationRepresentation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentationLayerUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationLayerUsage): void;
  get(): StepVisual_PresentationLayerUsage;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationLayerUsage_1 extends Handle_StepVisual_PresentationLayerUsage {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationLayerUsage_2 extends Handle_StepVisual_PresentationLayerUsage {
    constructor(thePtr: StepVisual_PresentationLayerUsage);
  }

  export declare class Handle_StepVisual_PresentationLayerUsage_3 extends Handle_StepVisual_PresentationLayerUsage {
    constructor(theHandle: Handle_StepVisual_PresentationLayerUsage);
  }

  export declare class Handle_StepVisual_PresentationLayerUsage_4 extends Handle_StepVisual_PresentationLayerUsage {
    constructor(theHandle: Handle_StepVisual_PresentationLayerUsage);
  }

export declare class StepVisual_PresentationArea extends StepVisual_PresentationRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_PresentationArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PresentationArea): void;
  get(): StepVisual_PresentationArea;
  delete(): void;
}

  export declare class Handle_StepVisual_PresentationArea_1 extends Handle_StepVisual_PresentationArea {
    constructor();
  }

  export declare class Handle_StepVisual_PresentationArea_2 extends Handle_StepVisual_PresentationArea {
    constructor(thePtr: StepVisual_PresentationArea);
  }

  export declare class Handle_StepVisual_PresentationArea_3 extends Handle_StepVisual_PresentationArea {
    constructor(theHandle: Handle_StepVisual_PresentationArea);
  }

  export declare class Handle_StepVisual_PresentationArea_4 extends Handle_StepVisual_PresentationArea {
    constructor(theHandle: Handle_StepVisual_PresentationArea);
  }

export declare class StepVisual_TextLiteral extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aLiteral: Handle_TCollection_HAsciiString, aPlacement: StepGeom_Axis2Placement, aAlignment: Handle_TCollection_HAsciiString, aPath: StepVisual_TextPath, aFont: StepVisual_FontSelect): void;
  SetLiteral(aLiteral: Handle_TCollection_HAsciiString): void;
  Literal(): Handle_TCollection_HAsciiString;
  SetPlacement(aPlacement: StepGeom_Axis2Placement): void;
  Placement(): StepGeom_Axis2Placement;
  SetAlignment(aAlignment: Handle_TCollection_HAsciiString): void;
  Alignment(): Handle_TCollection_HAsciiString;
  SetPath(aPath: StepVisual_TextPath): void;
  Path(): StepVisual_TextPath;
  SetFont(aFont: StepVisual_FontSelect): void;
  Font(): StepVisual_FontSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_TextLiteral {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TextLiteral): void;
  get(): StepVisual_TextLiteral;
  delete(): void;
}

  export declare class Handle_StepVisual_TextLiteral_1 extends Handle_StepVisual_TextLiteral {
    constructor();
  }

  export declare class Handle_StepVisual_TextLiteral_2 extends Handle_StepVisual_TextLiteral {
    constructor(thePtr: StepVisual_TextLiteral);
  }

  export declare class Handle_StepVisual_TextLiteral_3 extends Handle_StepVisual_TextLiteral {
    constructor(theHandle: Handle_StepVisual_TextLiteral);
  }

  export declare class Handle_StepVisual_TextLiteral_4 extends Handle_StepVisual_TextLiteral {
    constructor(theHandle: Handle_StepVisual_TextLiteral);
  }

export declare class StepVisual_StyledItemTarget extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  GeometricRepresentationItem(): Handle_StepGeom_GeometricRepresentationItem;
  MappedItem(): Handle_StepRepr_MappedItem;
  Representation(): Handle_StepRepr_Representation;
  TopologicalRepresentationItem(): Handle_StepShape_TopologicalRepresentationItem;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleFillArea {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleFillArea): void;
  get(): StepVisual_SurfaceStyleFillArea;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleFillArea_1 extends Handle_StepVisual_SurfaceStyleFillArea {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleFillArea_2 extends Handle_StepVisual_SurfaceStyleFillArea {
    constructor(thePtr: StepVisual_SurfaceStyleFillArea);
  }

  export declare class Handle_StepVisual_SurfaceStyleFillArea_3 extends Handle_StepVisual_SurfaceStyleFillArea {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleFillArea);
  }

  export declare class Handle_StepVisual_SurfaceStyleFillArea_4 extends Handle_StepVisual_SurfaceStyleFillArea {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleFillArea);
  }

export declare class StepVisual_SurfaceStyleFillArea extends Standard_Transient {
  constructor()
  Init(aFillArea: Handle_StepVisual_FillAreaStyle): void;
  SetFillArea(aFillArea: Handle_StepVisual_FillAreaStyle): void;
  FillArea(): Handle_StepVisual_FillAreaStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_TemplateInstance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_TemplateInstance): void;
  get(): StepVisual_TemplateInstance;
  delete(): void;
}

  export declare class Handle_StepVisual_TemplateInstance_1 extends Handle_StepVisual_TemplateInstance {
    constructor();
  }

  export declare class Handle_StepVisual_TemplateInstance_2 extends Handle_StepVisual_TemplateInstance {
    constructor(thePtr: StepVisual_TemplateInstance);
  }

  export declare class Handle_StepVisual_TemplateInstance_3 extends Handle_StepVisual_TemplateInstance {
    constructor(theHandle: Handle_StepVisual_TemplateInstance);
  }

  export declare class Handle_StepVisual_TemplateInstance_4 extends Handle_StepVisual_TemplateInstance {
    constructor(theHandle: Handle_StepVisual_TemplateInstance);
  }

export declare class StepVisual_TemplateInstance extends StepRepr_MappedItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_SurfaceStyleUsage extends Standard_Transient {
  constructor()
  Init(aSide: StepVisual_SurfaceSide, aStyle: Handle_StepVisual_SurfaceSideStyle): void;
  SetSide(aSide: StepVisual_SurfaceSide): void;
  Side(): StepVisual_SurfaceSide;
  SetStyle(aStyle: Handle_StepVisual_SurfaceSideStyle): void;
  Style(): Handle_StepVisual_SurfaceSideStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleUsage): void;
  get(): StepVisual_SurfaceStyleUsage;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleUsage_1 extends Handle_StepVisual_SurfaceStyleUsage {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleUsage_2 extends Handle_StepVisual_SurfaceStyleUsage {
    constructor(thePtr: StepVisual_SurfaceStyleUsage);
  }

  export declare class Handle_StepVisual_SurfaceStyleUsage_3 extends Handle_StepVisual_SurfaceStyleUsage {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleUsage);
  }

  export declare class Handle_StepVisual_SurfaceStyleUsage_4 extends Handle_StepVisual_SurfaceStyleUsage {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleUsage);
  }

export declare class Handle_StepVisual_DraughtingAnnotationOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_DraughtingAnnotationOccurrence): void;
  get(): StepVisual_DraughtingAnnotationOccurrence;
  delete(): void;
}

  export declare class Handle_StepVisual_DraughtingAnnotationOccurrence_1 extends Handle_StepVisual_DraughtingAnnotationOccurrence {
    constructor();
  }

  export declare class Handle_StepVisual_DraughtingAnnotationOccurrence_2 extends Handle_StepVisual_DraughtingAnnotationOccurrence {
    constructor(thePtr: StepVisual_DraughtingAnnotationOccurrence);
  }

  export declare class Handle_StepVisual_DraughtingAnnotationOccurrence_3 extends Handle_StepVisual_DraughtingAnnotationOccurrence {
    constructor(theHandle: Handle_StepVisual_DraughtingAnnotationOccurrence);
  }

  export declare class Handle_StepVisual_DraughtingAnnotationOccurrence_4 extends Handle_StepVisual_DraughtingAnnotationOccurrence {
    constructor(theHandle: Handle_StepVisual_DraughtingAnnotationOccurrence);
  }

export declare class StepVisual_DraughtingAnnotationOccurrence extends StepVisual_AnnotationOccurrence {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepVisual_NullStyle = {
  StepVisual_Null: {};
}

export declare class Handle_StepVisual_DraughtingPreDefinedCurveFont {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_DraughtingPreDefinedCurveFont): void;
  get(): StepVisual_DraughtingPreDefinedCurveFont;
  delete(): void;
}

  export declare class Handle_StepVisual_DraughtingPreDefinedCurveFont_1 extends Handle_StepVisual_DraughtingPreDefinedCurveFont {
    constructor();
  }

  export declare class Handle_StepVisual_DraughtingPreDefinedCurveFont_2 extends Handle_StepVisual_DraughtingPreDefinedCurveFont {
    constructor(thePtr: StepVisual_DraughtingPreDefinedCurveFont);
  }

  export declare class Handle_StepVisual_DraughtingPreDefinedCurveFont_3 extends Handle_StepVisual_DraughtingPreDefinedCurveFont {
    constructor(theHandle: Handle_StepVisual_DraughtingPreDefinedCurveFont);
  }

  export declare class Handle_StepVisual_DraughtingPreDefinedCurveFont_4 extends Handle_StepVisual_DraughtingPreDefinedCurveFont {
    constructor(theHandle: Handle_StepVisual_DraughtingPreDefinedCurveFont);
  }

export declare class StepVisual_DraughtingPreDefinedCurveFont extends StepVisual_PreDefinedCurveFont {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_SurfaceStyleSegmentationCurve extends Standard_Transient {
  constructor()
  Init(aStyleOfSegmentationCurve: Handle_StepVisual_CurveStyle): void;
  SetStyleOfSegmentationCurve(aStyleOfSegmentationCurve: Handle_StepVisual_CurveStyle): void;
  StyleOfSegmentationCurve(): Handle_StepVisual_CurveStyle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepVisual_SurfaceStyleSegmentationCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_SurfaceStyleSegmentationCurve): void;
  get(): StepVisual_SurfaceStyleSegmentationCurve;
  delete(): void;
}

  export declare class Handle_StepVisual_SurfaceStyleSegmentationCurve_1 extends Handle_StepVisual_SurfaceStyleSegmentationCurve {
    constructor();
  }

  export declare class Handle_StepVisual_SurfaceStyleSegmentationCurve_2 extends Handle_StepVisual_SurfaceStyleSegmentationCurve {
    constructor(thePtr: StepVisual_SurfaceStyleSegmentationCurve);
  }

  export declare class Handle_StepVisual_SurfaceStyleSegmentationCurve_3 extends Handle_StepVisual_SurfaceStyleSegmentationCurve {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleSegmentationCurve);
  }

  export declare class Handle_StepVisual_SurfaceStyleSegmentationCurve_4 extends Handle_StepVisual_SurfaceStyleSegmentationCurve {
    constructor(theHandle: Handle_StepVisual_SurfaceStyleSegmentationCurve);
  }

export declare class Handle_StepVisual_PlanarExtent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepVisual_PlanarExtent): void;
  get(): StepVisual_PlanarExtent;
  delete(): void;
}

  export declare class Handle_StepVisual_PlanarExtent_1 extends Handle_StepVisual_PlanarExtent {
    constructor();
  }

  export declare class Handle_StepVisual_PlanarExtent_2 extends Handle_StepVisual_PlanarExtent {
    constructor(thePtr: StepVisual_PlanarExtent);
  }

  export declare class Handle_StepVisual_PlanarExtent_3 extends Handle_StepVisual_PlanarExtent {
    constructor(theHandle: Handle_StepVisual_PlanarExtent);
  }

  export declare class Handle_StepVisual_PlanarExtent_4 extends Handle_StepVisual_PlanarExtent {
    constructor(theHandle: Handle_StepVisual_PlanarExtent);
  }

export declare class StepVisual_PlanarExtent extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSizeInX: Quantity_AbsorbedDose, aSizeInY: Quantity_AbsorbedDose): void;
  SetSizeInX(aSizeInX: Quantity_AbsorbedDose): void;
  SizeInX(): Quantity_AbsorbedDose;
  SetSizeInY(aSizeInY: Quantity_AbsorbedDose): void;
  SizeInY(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepVisual_InvisibilityContext extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  PresentationRepresentation(): Handle_StepVisual_PresentationRepresentation;
  PresentationSet(): Handle_StepVisual_PresentationSet;
  DraughtingModel(): Handle_StepVisual_DraughtingModel;
  delete(): void;
}

export declare class Standard_LicenseNotFound extends Standard_LicenseError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_LicenseNotFound;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_LicenseNotFound_1 extends Standard_LicenseNotFound {
    constructor();
  }

  export declare class Standard_LicenseNotFound_2 extends Standard_LicenseNotFound {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_LicenseNotFound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_LicenseNotFound): void;
  get(): Standard_LicenseNotFound;
  delete(): void;
}

  export declare class Handle_Standard_LicenseNotFound_1 extends Handle_Standard_LicenseNotFound {
    constructor();
  }

  export declare class Handle_Standard_LicenseNotFound_2 extends Handle_Standard_LicenseNotFound {
    constructor(thePtr: Standard_LicenseNotFound);
  }

  export declare class Handle_Standard_LicenseNotFound_3 extends Handle_Standard_LicenseNotFound {
    constructor(theHandle: Handle_Standard_LicenseNotFound);
  }

  export declare class Handle_Standard_LicenseNotFound_4 extends Handle_Standard_LicenseNotFound {
    constructor(theHandle: Handle_Standard_LicenseNotFound);
  }

export declare class Standard {
  constructor();
  static Allocate(aSize: Standard_ThreadId): Standard_Address;
  static Free_1(thePtr: Standard_Address): void;
  static Reallocate(aStorage: Standard_Address, aNewSize: Standard_ThreadId): Standard_Address;
  static AllocateAligned(theSize: Standard_ThreadId, theAlign: Standard_ThreadId): Standard_Address;
  static FreeAligned_1(thePtrAligned: Standard_Address): void;
  static Purge(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_Standard_Overflow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_Overflow): void;
  get(): Standard_Overflow;
  delete(): void;
}

  export declare class Handle_Standard_Overflow_1 extends Handle_Standard_Overflow {
    constructor();
  }

  export declare class Handle_Standard_Overflow_2 extends Handle_Standard_Overflow {
    constructor(thePtr: Standard_Overflow);
  }

  export declare class Handle_Standard_Overflow_3 extends Handle_Standard_Overflow {
    constructor(theHandle: Handle_Standard_Overflow);
  }

  export declare class Handle_Standard_Overflow_4 extends Handle_Standard_Overflow {
    constructor(theHandle: Handle_Standard_Overflow);
  }

export declare class Standard_Overflow extends Standard_NumericError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_Overflow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_Overflow_1 extends Standard_Overflow {
    constructor();
  }

  export declare class Standard_Overflow_2 extends Standard_Overflow {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_NullObject extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NullObject;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NullObject_1 extends Standard_NullObject {
    constructor();
  }

  export declare class Standard_NullObject_2 extends Standard_NullObject {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_NullObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NullObject): void;
  get(): Standard_NullObject;
  delete(): void;
}

  export declare class Handle_Standard_NullObject_1 extends Handle_Standard_NullObject {
    constructor();
  }

  export declare class Handle_Standard_NullObject_2 extends Handle_Standard_NullObject {
    constructor(thePtr: Standard_NullObject);
  }

  export declare class Handle_Standard_NullObject_3 extends Handle_Standard_NullObject {
    constructor(theHandle: Handle_Standard_NullObject);
  }

  export declare class Handle_Standard_NullObject_4 extends Handle_Standard_NullObject {
    constructor(theHandle: Handle_Standard_NullObject);
  }

export declare class Standard_NullValue extends Standard_RangeError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NullValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NullValue_1 extends Standard_NullValue {
    constructor();
  }

  export declare class Standard_NullValue_2 extends Standard_NullValue {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_NullValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NullValue): void;
  get(): Standard_NullValue;
  delete(): void;
}

  export declare class Handle_Standard_NullValue_1 extends Handle_Standard_NullValue {
    constructor();
  }

  export declare class Handle_Standard_NullValue_2 extends Handle_Standard_NullValue {
    constructor(thePtr: Standard_NullValue);
  }

  export declare class Handle_Standard_NullValue_3 extends Handle_Standard_NullValue {
    constructor(theHandle: Handle_Standard_NullValue);
  }

  export declare class Handle_Standard_NullValue_4 extends Handle_Standard_NullValue {
    constructor(theHandle: Handle_Standard_NullValue);
  }

export declare class Standard_Type extends Standard_Transient {
  SystemName(): Standard_CString;
  Name(): Standard_CString;
  Size(): Standard_ThreadId;
  Parent(): Handle_Standard_Type;
  SubType_1(theOther: Handle_Standard_Type): Standard_Boolean;
  SubType_2(theOther: Standard_CString): Standard_Boolean;
  Print(theStream: Standard_OStream): void;
  static Register(theSystemName: Standard_Character, theName: Standard_Character, theSize: Standard_ThreadId, theParent: Handle_Standard_Type): Standard_Type;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Standard_Type {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_Type): void;
  get(): Standard_Type;
  delete(): void;
}

  export declare class Handle_Standard_Type_1 extends Handle_Standard_Type {
    constructor();
  }

  export declare class Handle_Standard_Type_2 extends Handle_Standard_Type {
    constructor(thePtr: Standard_Type);
  }

  export declare class Handle_Standard_Type_3 extends Handle_Standard_Type {
    constructor(theHandle: Handle_Standard_Type);
  }

  export declare class Handle_Standard_Type_4 extends Handle_Standard_Type {
    constructor(theHandle: Handle_Standard_Type);
  }

export declare class Handle_Standard_DomainError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_DomainError): void;
  get(): Standard_DomainError;
  delete(): void;
}

  export declare class Handle_Standard_DomainError_1 extends Handle_Standard_DomainError {
    constructor();
  }

  export declare class Handle_Standard_DomainError_2 extends Handle_Standard_DomainError {
    constructor(thePtr: Standard_DomainError);
  }

  export declare class Handle_Standard_DomainError_3 extends Handle_Standard_DomainError {
    constructor(theHandle: Handle_Standard_DomainError);
  }

  export declare class Handle_Standard_DomainError_4 extends Handle_Standard_DomainError {
    constructor(theHandle: Handle_Standard_DomainError);
  }

export declare class Standard_DomainError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_DomainError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_DomainError_1 extends Standard_DomainError {
    constructor();
  }

  export declare class Standard_DomainError_2 extends Standard_DomainError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_ConstructionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_ConstructionError): void;
  get(): Standard_ConstructionError;
  delete(): void;
}

  export declare class Handle_Standard_ConstructionError_1 extends Handle_Standard_ConstructionError {
    constructor();
  }

  export declare class Handle_Standard_ConstructionError_2 extends Handle_Standard_ConstructionError {
    constructor(thePtr: Standard_ConstructionError);
  }

  export declare class Handle_Standard_ConstructionError_3 extends Handle_Standard_ConstructionError {
    constructor(theHandle: Handle_Standard_ConstructionError);
  }

  export declare class Handle_Standard_ConstructionError_4 extends Handle_Standard_ConstructionError {
    constructor(theHandle: Handle_Standard_ConstructionError);
  }

export declare class Standard_ConstructionError extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_ConstructionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_ConstructionError_1 extends Standard_ConstructionError {
    constructor();
  }

  export declare class Standard_ConstructionError_2 extends Standard_ConstructionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_TypeMismatch extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_TypeMismatch;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_TypeMismatch_1 extends Standard_TypeMismatch {
    constructor();
  }

  export declare class Standard_TypeMismatch_2 extends Standard_TypeMismatch {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_TypeMismatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_TypeMismatch): void;
  get(): Standard_TypeMismatch;
  delete(): void;
}

  export declare class Handle_Standard_TypeMismatch_1 extends Handle_Standard_TypeMismatch {
    constructor();
  }

  export declare class Handle_Standard_TypeMismatch_2 extends Handle_Standard_TypeMismatch {
    constructor(thePtr: Standard_TypeMismatch);
  }

  export declare class Handle_Standard_TypeMismatch_3 extends Handle_Standard_TypeMismatch {
    constructor(theHandle: Handle_Standard_TypeMismatch);
  }

  export declare class Handle_Standard_TypeMismatch_4 extends Handle_Standard_TypeMismatch {
    constructor(theHandle: Handle_Standard_TypeMismatch);
  }

export declare class Standard_RangeError extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_RangeError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_RangeError_1 extends Standard_RangeError {
    constructor();
  }

  export declare class Standard_RangeError_2 extends Standard_RangeError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_RangeError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_RangeError): void;
  get(): Standard_RangeError;
  delete(): void;
}

  export declare class Handle_Standard_RangeError_1 extends Handle_Standard_RangeError {
    constructor();
  }

  export declare class Handle_Standard_RangeError_2 extends Handle_Standard_RangeError {
    constructor(thePtr: Standard_RangeError);
  }

  export declare class Handle_Standard_RangeError_3 extends Handle_Standard_RangeError {
    constructor(theHandle: Handle_Standard_RangeError);
  }

  export declare class Handle_Standard_RangeError_4 extends Handle_Standard_RangeError {
    constructor(theHandle: Handle_Standard_RangeError);
  }

export declare class Handle_Standard_DivideByZero {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_DivideByZero): void;
  get(): Standard_DivideByZero;
  delete(): void;
}

  export declare class Handle_Standard_DivideByZero_1 extends Handle_Standard_DivideByZero {
    constructor();
  }

  export declare class Handle_Standard_DivideByZero_2 extends Handle_Standard_DivideByZero {
    constructor(thePtr: Standard_DivideByZero);
  }

  export declare class Handle_Standard_DivideByZero_3 extends Handle_Standard_DivideByZero {
    constructor(theHandle: Handle_Standard_DivideByZero);
  }

  export declare class Handle_Standard_DivideByZero_4 extends Handle_Standard_DivideByZero {
    constructor(theHandle: Handle_Standard_DivideByZero);
  }

export declare class Standard_DivideByZero extends Standard_NumericError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_DivideByZero;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_DivideByZero_1 extends Standard_DivideByZero {
    constructor();
  }

  export declare class Standard_DivideByZero_2 extends Standard_DivideByZero {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_NegativeValue extends Standard_RangeError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NegativeValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NegativeValue_1 extends Standard_NegativeValue {
    constructor();
  }

  export declare class Standard_NegativeValue_2 extends Standard_NegativeValue {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_NegativeValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NegativeValue): void;
  get(): Standard_NegativeValue;
  delete(): void;
}

  export declare class Handle_Standard_NegativeValue_1 extends Handle_Standard_NegativeValue {
    constructor();
  }

  export declare class Handle_Standard_NegativeValue_2 extends Handle_Standard_NegativeValue {
    constructor(thePtr: Standard_NegativeValue);
  }

  export declare class Handle_Standard_NegativeValue_3 extends Handle_Standard_NegativeValue {
    constructor(theHandle: Handle_Standard_NegativeValue);
  }

  export declare class Handle_Standard_NegativeValue_4 extends Handle_Standard_NegativeValue {
    constructor(theHandle: Handle_Standard_NegativeValue);
  }

export declare class Handle_Standard_TooManyUsers {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_TooManyUsers): void;
  get(): Standard_TooManyUsers;
  delete(): void;
}

  export declare class Handle_Standard_TooManyUsers_1 extends Handle_Standard_TooManyUsers {
    constructor();
  }

  export declare class Handle_Standard_TooManyUsers_2 extends Handle_Standard_TooManyUsers {
    constructor(thePtr: Standard_TooManyUsers);
  }

  export declare class Handle_Standard_TooManyUsers_3 extends Handle_Standard_TooManyUsers {
    constructor(theHandle: Handle_Standard_TooManyUsers);
  }

  export declare class Handle_Standard_TooManyUsers_4 extends Handle_Standard_TooManyUsers {
    constructor(theHandle: Handle_Standard_TooManyUsers);
  }

export declare class Standard_TooManyUsers extends Standard_LicenseError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_TooManyUsers;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_TooManyUsers_1 extends Standard_TooManyUsers {
    constructor();
  }

  export declare class Standard_TooManyUsers_2 extends Standard_TooManyUsers {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_ArrayStreamBuffer {
  constructor(theBegin: Standard_Character, theSize: Standard_Size)
  Init(theBegin: Standard_Character, theSize: Standard_Size): void;
  xsgetn(thePtr: Standard_Character, theCount: any): any;
  delete(): void;
}

export declare class Standard_OutOfMemory extends Standard_ProgramError {
  constructor(theMessage: Standard_CString)
  GetMessageString(): Standard_CString;
  SetMessageString(aMessage: Standard_CString): void;
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_OutOfMemory;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Standard_OutOfMemory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_OutOfMemory): void;
  get(): Standard_OutOfMemory;
  delete(): void;
}

  export declare class Handle_Standard_OutOfMemory_1 extends Handle_Standard_OutOfMemory {
    constructor();
  }

  export declare class Handle_Standard_OutOfMemory_2 extends Handle_Standard_OutOfMemory {
    constructor(thePtr: Standard_OutOfMemory);
  }

  export declare class Handle_Standard_OutOfMemory_3 extends Handle_Standard_OutOfMemory {
    constructor(theHandle: Handle_Standard_OutOfMemory);
  }

  export declare class Handle_Standard_OutOfMemory_4 extends Handle_Standard_OutOfMemory {
    constructor(theHandle: Handle_Standard_OutOfMemory);
  }

export declare class Handle_Standard_DimensionError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_DimensionError): void;
  get(): Standard_DimensionError;
  delete(): void;
}

  export declare class Handle_Standard_DimensionError_1 extends Handle_Standard_DimensionError {
    constructor();
  }

  export declare class Handle_Standard_DimensionError_2 extends Handle_Standard_DimensionError {
    constructor(thePtr: Standard_DimensionError);
  }

  export declare class Handle_Standard_DimensionError_3 extends Handle_Standard_DimensionError {
    constructor(theHandle: Handle_Standard_DimensionError);
  }

  export declare class Handle_Standard_DimensionError_4 extends Handle_Standard_DimensionError {
    constructor(theHandle: Handle_Standard_DimensionError);
  }

export declare class Standard_DimensionError extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_DimensionError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_DimensionError_1 extends Standard_DimensionError {
    constructor();
  }

  export declare class Standard_DimensionError_2 extends Standard_DimensionError {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_DumpValue {
  delete(): void;
}

  export declare class Standard_DumpValue_1 extends Standard_DumpValue {
    constructor();
  }

  export declare class Standard_DumpValue_2 extends Standard_DumpValue {
    constructor(theValue: XCAFDoc_PartId, theStartPos: Graphic3d_ZLayerId);
  }

export declare type Standard_JsonKey = {
  Standard_JsonKey_None: {};
  Standard_JsonKey_OpenChild: {};
  Standard_JsonKey_CloseChild: {};
  Standard_JsonKey_OpenContainer: {};
  Standard_JsonKey_CloseContainer: {};
  Standard_JsonKey_Quote: {};
  Standard_JsonKey_SeparatorKeyToValue: {};
  Standard_JsonKey_SeparatorValueToValue: {};
}

export declare class Standard_Persistent extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  TypeNum(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Standard_Mutex {
  constructor()
  Lock(): void;
  TryLock(): Standard_Boolean;
  Unlock(): void;
  delete(): void;
}

export declare class Standard_Transient {
  Delete(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsInstance_1(theType: Handle_Standard_Type): Standard_Boolean;
  IsInstance_2(theTypeName: Standard_CString): Standard_Boolean;
  IsKind_1(theType: Handle_Standard_Type): Standard_Boolean;
  IsKind_2(theTypeName: Standard_CString): Standard_Boolean;
  This(): MMgt_TShared;
  GetRefCount(): Graphic3d_ZLayerId;
  IncrementRefCounter(): void;
  DecrementRefCounter(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Standard_Transient_1 extends Standard_Transient {
    constructor();
  }

  export declare class Standard_Transient_2 extends Standard_Transient {
    constructor(a: MMgt_TShared);
  }

export declare class Handle_Standard_Transient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_Transient): void;
  get(): Standard_Transient;
  delete(): void;
}

  export declare class Handle_Standard_Transient_1 extends Handle_Standard_Transient {
    constructor();
  }

  export declare class Handle_Standard_Transient_2 extends Handle_Standard_Transient {
    constructor(thePtr: Standard_Transient);
  }

  export declare class Handle_Standard_Transient_3 extends Handle_Standard_Transient {
    constructor(theHandle: Handle_Standard_Transient);
  }

  export declare class Handle_Standard_Transient_4 extends Handle_Standard_Transient {
    constructor(theHandle: Handle_Standard_Transient);
  }

export declare class Standard_GUID {
  ToUUID(): Standard_UUID;
  ToCString(aStrGuid: Standard_PCharacter): void;
  ToExtString(aStrGuid: Standard_PExtCharacter): void;
  IsSame(uid: Standard_GUID): Standard_Boolean;
  IsNotSame(uid: Standard_GUID): Standard_Boolean;
  Assign_1(uid: Standard_GUID): void;
  Assign_2(uid: Standard_UUID): void;
  ShallowDump(aStream: Standard_OStream): void;
  static CheckGUIDFormat(aGuid: Standard_CString): Standard_Boolean;
  Hash(Upper: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static HashCode(theGUID: Standard_GUID, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(string1: Standard_GUID, string2: Standard_GUID): Standard_Boolean;
  delete(): void;
}

  export declare class Standard_GUID_1 extends Standard_GUID {
    constructor();
  }

  export declare class Standard_GUID_2 extends Standard_GUID {
    constructor(aGuid: Standard_CString);
  }

  export declare class Standard_GUID_3 extends Standard_GUID {
    constructor(aGuid: Standard_ExtString);
  }

  export declare class Standard_GUID_4 extends Standard_GUID {
    constructor(a32b: Graphic3d_ZLayerId, a16b1: Standard_ExtCharacter, a16b2: Standard_ExtCharacter, a16b3: Standard_ExtCharacter, a8b1: Standard_Byte, a8b2: Standard_Byte, a8b3: Standard_Byte, a8b4: Standard_Byte, a8b5: Standard_Byte, a8b6: Standard_Byte);
  }

  export declare class Standard_GUID_5 extends Standard_GUID {
    constructor(aGuid: Standard_UUID);
  }

  export declare class Standard_GUID_6 extends Standard_GUID {
    constructor(aGuid: Standard_GUID);
  }

export declare class Standard_AbortiveTransaction extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_AbortiveTransaction;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_AbortiveTransaction_1 extends Standard_AbortiveTransaction {
    constructor();
  }

  export declare class Standard_AbortiveTransaction_2 extends Standard_AbortiveTransaction {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_AbortiveTransaction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_AbortiveTransaction): void;
  get(): Standard_AbortiveTransaction;
  delete(): void;
}

  export declare class Handle_Standard_AbortiveTransaction_1 extends Handle_Standard_AbortiveTransaction {
    constructor();
  }

  export declare class Handle_Standard_AbortiveTransaction_2 extends Handle_Standard_AbortiveTransaction {
    constructor(thePtr: Standard_AbortiveTransaction);
  }

  export declare class Handle_Standard_AbortiveTransaction_3 extends Handle_Standard_AbortiveTransaction {
    constructor(theHandle: Handle_Standard_AbortiveTransaction);
  }

  export declare class Handle_Standard_AbortiveTransaction_4 extends Handle_Standard_AbortiveTransaction {
    constructor(theHandle: Handle_Standard_AbortiveTransaction);
  }

export declare class Handle_Standard_Failure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_Failure): void;
  get(): Standard_Failure;
  delete(): void;
}

  export declare class Handle_Standard_Failure_1 extends Handle_Standard_Failure {
    constructor();
  }

  export declare class Handle_Standard_Failure_2 extends Handle_Standard_Failure {
    constructor(thePtr: Standard_Failure);
  }

  export declare class Handle_Standard_Failure_3 extends Handle_Standard_Failure {
    constructor(theHandle: Handle_Standard_Failure);
  }

  export declare class Handle_Standard_Failure_4 extends Handle_Standard_Failure {
    constructor(theHandle: Handle_Standard_Failure);
  }

export declare class Standard_Failure extends Standard_Transient {
  Print(theStream: Standard_OStream): void;
  GetMessageString(): Standard_CString;
  SetMessageString(aMessage: Standard_CString): void;
  Reraise_1(): void;
  Reraise_2(aMessage: Standard_CString): void;
  Reraise_3(aReason: Standard_SStream): void;
  static Raise_1(aMessage: Standard_CString): void;
  static Raise_2(aReason: Standard_SStream): void;
  static NewInstance(aMessage: Standard_CString): Handle_Standard_Failure;
  Jump(): void;
  static Caught(): Handle_Standard_Failure;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_Failure_1 extends Standard_Failure {
    constructor();
  }

  export declare class Standard_Failure_2 extends Standard_Failure {
    constructor(f: Standard_Failure);
  }

  export declare class Standard_Failure_3 extends Standard_Failure {
    constructor(aString: Standard_CString);
  }

export declare class Standard_ReadBuffer {
  constructor(theDataLen: int64_t, theChunkLen: Standard_Size, theIsPartialPayload: Standard_Boolean)
  Init(theDataLen: int64_t, theChunkLen: Standard_Size, theIsPartialPayload: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  delete(): void;
}

export declare class Standard_NumericError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NumericError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NumericError_1 extends Standard_NumericError {
    constructor();
  }

  export declare class Standard_NumericError_2 extends Standard_NumericError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_NumericError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NumericError): void;
  get(): Standard_NumericError;
  delete(): void;
}

  export declare class Handle_Standard_NumericError_1 extends Handle_Standard_NumericError {
    constructor();
  }

  export declare class Handle_Standard_NumericError_2 extends Handle_Standard_NumericError {
    constructor(thePtr: Standard_NumericError);
  }

  export declare class Handle_Standard_NumericError_3 extends Handle_Standard_NumericError {
    constructor(theHandle: Handle_Standard_NumericError);
  }

  export declare class Handle_Standard_NumericError_4 extends Handle_Standard_NumericError {
    constructor(theHandle: Handle_Standard_NumericError);
  }

export declare class Handle_Standard_LicenseError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_LicenseError): void;
  get(): Standard_LicenseError;
  delete(): void;
}

  export declare class Handle_Standard_LicenseError_1 extends Handle_Standard_LicenseError {
    constructor();
  }

  export declare class Handle_Standard_LicenseError_2 extends Handle_Standard_LicenseError {
    constructor(thePtr: Standard_LicenseError);
  }

  export declare class Handle_Standard_LicenseError_3 extends Handle_Standard_LicenseError {
    constructor(theHandle: Handle_Standard_LicenseError);
  }

  export declare class Handle_Standard_LicenseError_4 extends Handle_Standard_LicenseError {
    constructor(theHandle: Handle_Standard_LicenseError);
  }

export declare class Standard_LicenseError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_LicenseError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_LicenseError_1 extends Standard_LicenseError {
    constructor();
  }

  export declare class Standard_LicenseError_2 extends Standard_LicenseError {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_ReadLineBuffer {
  constructor(theMaxBufferSizeBytes: Standard_Size)
  Clear(): void;
  IsMultilineMode(): Standard_Boolean;
  ToPutGapInMultiline(): Standard_Boolean;
  SetMultilineMode(theMultilineMode: Standard_Boolean, theToPutGap: Standard_Boolean): void;
  delete(): void;
}

export declare class Standard_CLocaleSentry {
  constructor()
  static GetCLocale(): any;
  delete(): void;
}

export declare class Standard_OutOfRange extends Standard_RangeError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_OutOfRange;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_OutOfRange_1 extends Standard_OutOfRange {
    constructor();
  }

  export declare class Standard_OutOfRange_2 extends Standard_OutOfRange {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_OutOfRange {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_OutOfRange): void;
  get(): Standard_OutOfRange;
  delete(): void;
}

  export declare class Handle_Standard_OutOfRange_1 extends Handle_Standard_OutOfRange {
    constructor();
  }

  export declare class Handle_Standard_OutOfRange_2 extends Handle_Standard_OutOfRange {
    constructor(thePtr: Standard_OutOfRange);
  }

  export declare class Handle_Standard_OutOfRange_3 extends Handle_Standard_OutOfRange {
    constructor(theHandle: Handle_Standard_OutOfRange);
  }

  export declare class Handle_Standard_OutOfRange_4 extends Handle_Standard_OutOfRange {
    constructor(theHandle: Handle_Standard_OutOfRange);
  }

export declare class Standard_MMgrRaw extends Standard_MMgrRoot {
  constructor(aClear: Standard_Boolean)
  Allocate(aSize: Standard_ThreadId): Standard_Address;
  Reallocate(thePtr: Standard_Address, theSize: Standard_ThreadId): Standard_Address;
  Free(thePtr: Standard_Address): void;
  delete(): void;
}

export declare class Standard_Condition {
  constructor(theIsSet: Standard_Boolean)
  Set(): void;
  Reset(): void;
  Wait_1(): void;
  Wait_2(theTimeMilliseconds: Standard_Integer): Standard_Boolean;
  Check(): Standard_Boolean;
  CheckReset(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Standard_NoSuchObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NoSuchObject): void;
  get(): Standard_NoSuchObject;
  delete(): void;
}

  export declare class Handle_Standard_NoSuchObject_1 extends Handle_Standard_NoSuchObject {
    constructor();
  }

  export declare class Handle_Standard_NoSuchObject_2 extends Handle_Standard_NoSuchObject {
    constructor(thePtr: Standard_NoSuchObject);
  }

  export declare class Handle_Standard_NoSuchObject_3 extends Handle_Standard_NoSuchObject {
    constructor(theHandle: Handle_Standard_NoSuchObject);
  }

  export declare class Handle_Standard_NoSuchObject_4 extends Handle_Standard_NoSuchObject {
    constructor(theHandle: Handle_Standard_NoSuchObject);
  }

export declare class Standard_NoSuchObject extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NoSuchObject;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NoSuchObject_1 extends Standard_NoSuchObject {
    constructor();
  }

  export declare class Standard_NoSuchObject_2 extends Standard_NoSuchObject {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_MultiplyDefined {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_MultiplyDefined): void;
  get(): Standard_MultiplyDefined;
  delete(): void;
}

  export declare class Handle_Standard_MultiplyDefined_1 extends Handle_Standard_MultiplyDefined {
    constructor();
  }

  export declare class Handle_Standard_MultiplyDefined_2 extends Handle_Standard_MultiplyDefined {
    constructor(thePtr: Standard_MultiplyDefined);
  }

  export declare class Handle_Standard_MultiplyDefined_3 extends Handle_Standard_MultiplyDefined {
    constructor(theHandle: Handle_Standard_MultiplyDefined);
  }

  export declare class Handle_Standard_MultiplyDefined_4 extends Handle_Standard_MultiplyDefined {
    constructor(theHandle: Handle_Standard_MultiplyDefined);
  }

export declare class Standard_MultiplyDefined extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_MultiplyDefined;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_MultiplyDefined_1 extends Standard_MultiplyDefined {
    constructor();
  }

  export declare class Standard_MultiplyDefined_2 extends Standard_MultiplyDefined {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_Underflow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_Underflow): void;
  get(): Standard_Underflow;
  delete(): void;
}

  export declare class Handle_Standard_Underflow_1 extends Handle_Standard_Underflow {
    constructor();
  }

  export declare class Handle_Standard_Underflow_2 extends Handle_Standard_Underflow {
    constructor(thePtr: Standard_Underflow);
  }

  export declare class Handle_Standard_Underflow_3 extends Handle_Standard_Underflow {
    constructor(theHandle: Handle_Standard_Underflow);
  }

  export declare class Handle_Standard_Underflow_4 extends Handle_Standard_Underflow {
    constructor(theHandle: Handle_Standard_Underflow);
  }

export declare class Standard_Underflow extends Standard_NumericError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_Underflow;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_Underflow_1 extends Standard_Underflow {
    constructor();
  }

  export declare class Standard_Underflow_2 extends Standard_Underflow {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_NoMoreObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NoMoreObject): void;
  get(): Standard_NoMoreObject;
  delete(): void;
}

  export declare class Handle_Standard_NoMoreObject_1 extends Handle_Standard_NoMoreObject {
    constructor();
  }

  export declare class Handle_Standard_NoMoreObject_2 extends Handle_Standard_NoMoreObject {
    constructor(thePtr: Standard_NoMoreObject);
  }

  export declare class Handle_Standard_NoMoreObject_3 extends Handle_Standard_NoMoreObject {
    constructor(theHandle: Handle_Standard_NoMoreObject);
  }

  export declare class Handle_Standard_NoMoreObject_4 extends Handle_Standard_NoMoreObject {
    constructor(theHandle: Handle_Standard_NoMoreObject);
  }

export declare class Standard_NoMoreObject extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NoMoreObject;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NoMoreObject_1 extends Standard_NoMoreObject {
    constructor();
  }

  export declare class Standard_NoMoreObject_2 extends Standard_NoMoreObject {
    constructor(theMessage: Standard_CString);
  }

export declare type Standard_HandlerStatus = {
  Standard_HandlerVoid: {};
  Standard_HandlerJumped: {};
  Standard_HandlerProcessed: {};
}

export declare class Handle_Standard_ProgramError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_ProgramError): void;
  get(): Standard_ProgramError;
  delete(): void;
}

  export declare class Handle_Standard_ProgramError_1 extends Handle_Standard_ProgramError {
    constructor();
  }

  export declare class Handle_Standard_ProgramError_2 extends Handle_Standard_ProgramError {
    constructor(thePtr: Standard_ProgramError);
  }

  export declare class Handle_Standard_ProgramError_3 extends Handle_Standard_ProgramError {
    constructor(theHandle: Handle_Standard_ProgramError);
  }

  export declare class Handle_Standard_ProgramError_4 extends Handle_Standard_ProgramError {
    constructor(theHandle: Handle_Standard_ProgramError);
  }

export declare class Standard_ProgramError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_ProgramError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_ProgramError_1 extends Standard_ProgramError {
    constructor();
  }

  export declare class Standard_ProgramError_2 extends Standard_ProgramError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_NotImplemented {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_NotImplemented): void;
  get(): Standard_NotImplemented;
  delete(): void;
}

  export declare class Handle_Standard_NotImplemented_1 extends Handle_Standard_NotImplemented {
    constructor();
  }

  export declare class Handle_Standard_NotImplemented_2 extends Handle_Standard_NotImplemented {
    constructor(thePtr: Standard_NotImplemented);
  }

  export declare class Handle_Standard_NotImplemented_3 extends Handle_Standard_NotImplemented {
    constructor(theHandle: Handle_Standard_NotImplemented);
  }

  export declare class Handle_Standard_NotImplemented_4 extends Handle_Standard_NotImplemented {
    constructor(theHandle: Handle_Standard_NotImplemented);
  }

export declare class Standard_NotImplemented extends Standard_ProgramError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_NotImplemented;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_NotImplemented_1 extends Standard_NotImplemented {
    constructor();
  }

  export declare class Standard_NotImplemented_2 extends Standard_NotImplemented {
    constructor(theMessage: Standard_CString);
  }

export declare class Standard_MMgrOpt extends Standard_MMgrRoot {
  constructor(aClear: Standard_Boolean, aMMap: Standard_Boolean, aCellSize: Standard_ThreadId, aNbPages: Graphic3d_ZLayerId, aThreshold: Standard_ThreadId)
  Allocate(aSize: Standard_ThreadId): Standard_Address;
  Reallocate(thePtr: Standard_Address, theSize: Standard_ThreadId): Standard_Address;
  Free(thePtr: Standard_Address): void;
  Purge(isDestroyed: Standard_Boolean): Graphic3d_ZLayerId;
  static SetCallBackFunction(pFunc: any): void;
  delete(): void;
}

export declare class Standard_ImmutableObject extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_ImmutableObject;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_ImmutableObject_1 extends Standard_ImmutableObject {
    constructor();
  }

  export declare class Standard_ImmutableObject_2 extends Standard_ImmutableObject {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_ImmutableObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_ImmutableObject): void;
  get(): Standard_ImmutableObject;
  delete(): void;
}

  export declare class Handle_Standard_ImmutableObject_1 extends Handle_Standard_ImmutableObject {
    constructor();
  }

  export declare class Handle_Standard_ImmutableObject_2 extends Handle_Standard_ImmutableObject {
    constructor(thePtr: Standard_ImmutableObject);
  }

  export declare class Handle_Standard_ImmutableObject_3 extends Handle_Standard_ImmutableObject {
    constructor(theHandle: Handle_Standard_ImmutableObject);
  }

  export declare class Handle_Standard_ImmutableObject_4 extends Handle_Standard_ImmutableObject {
    constructor(theHandle: Handle_Standard_ImmutableObject);
  }

export declare class Standard_MMgrRoot {
  Allocate(theSize: Standard_ThreadId): Standard_Address;
  Reallocate(thePtr: Standard_Address, theSize: Standard_ThreadId): Standard_Address;
  Free(thePtr: Standard_Address): void;
  Purge(isDestroyed: Standard_Boolean): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Standard_DimensionMismatch extends Standard_DimensionError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Standard_DimensionMismatch;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Standard_DimensionMismatch_1 extends Standard_DimensionMismatch {
    constructor();
  }

  export declare class Standard_DimensionMismatch_2 extends Standard_DimensionMismatch {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Standard_DimensionMismatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Standard_DimensionMismatch): void;
  get(): Standard_DimensionMismatch;
  delete(): void;
}

  export declare class Handle_Standard_DimensionMismatch_1 extends Handle_Standard_DimensionMismatch {
    constructor();
  }

  export declare class Handle_Standard_DimensionMismatch_2 extends Handle_Standard_DimensionMismatch {
    constructor(thePtr: Standard_DimensionMismatch);
  }

  export declare class Handle_Standard_DimensionMismatch_3 extends Handle_Standard_DimensionMismatch {
    constructor(theHandle: Handle_Standard_DimensionMismatch);
  }

  export declare class Handle_Standard_DimensionMismatch_4 extends Handle_Standard_DimensionMismatch {
    constructor(theHandle: Handle_Standard_DimensionMismatch);
  }

export declare class Standard_MMgrTBBalloc extends Standard_MMgrRoot {
  constructor(aClear: Standard_Boolean)
  Allocate(aSize: Standard_ThreadId): Standard_Address;
  Reallocate(thePtr: Standard_Address, theSize: Standard_ThreadId): Standard_Address;
  Free(thePtr: Standard_Address): void;
  delete(): void;
}

export declare class RWStepRepr_RWConstructiveGeometryRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ConstructiveGeometryRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ConstructiveGeometryRepresentation): void;
  Share(ent: Handle_StepRepr_ConstructiveGeometryRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWCentreOfSymmetry {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CentreOfSymmetry): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CentreOfSymmetry): void;
  Share(ent: Handle_StepRepr_CentreOfSymmetry, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWPropertyDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_PropertyDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_PropertyDefinition): void;
  Share(ent: Handle_StepRepr_PropertyDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWCompGroupShAspAndCompShAspAndDatumFeatAndShAsp {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp): void;
  Share(ent: Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWDescriptiveRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_DescriptiveRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_DescriptiveRepresentationItem): void;
  delete(): void;
}

export declare class RWStepRepr_RWItemDefinedTransformation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ItemDefinedTransformation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ItemDefinedTransformation): void;
  Share(ent: Handle_StepRepr_ItemDefinedTransformation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWIntegerRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_IntegerRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_IntegerRepresentationItem): void;
  delete(): void;
}

export declare class RWStepRepr_RWGlobalUncertaintyAssignedContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_GlobalUncertaintyAssignedContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_GlobalUncertaintyAssignedContext): void;
  Share(ent: Handle_StepRepr_GlobalUncertaintyAssignedContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWBetweenShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_BetweenShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_BetweenShapeAspect): void;
  Share(ent: Handle_StepRepr_BetweenShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWMeasureRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_MeasureRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_MeasureRepresentationItem): void;
  Share(ent: Handle_StepRepr_MeasureRepresentationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWMappedItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_MappedItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_MappedItem): void;
  Share(ent: Handle_StepRepr_MappedItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWCompositeShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CompositeShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CompositeShapeAspect): void;
  Share(ent: Handle_StepRepr_CompositeShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWReprItemAndPlaneAngleMeasureWithUnitAndQRI {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI): void;
  delete(): void;
}

export declare class RWStepRepr_RWProductConcept {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ProductConcept): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ProductConcept): void;
  Share(ent: Handle_StepRepr_ProductConcept, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWDerivedShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_DerivedShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_DerivedShapeAspect): void;
  Share(ent: Handle_StepRepr_DerivedShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWParametricRepresentationContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ParametricRepresentationContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ParametricRepresentationContext): void;
  delete(): void;
}

export declare class RWStepRepr_RWDefinitionalRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_DefinitionalRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_DefinitionalRepresentation): void;
  Share(ent: Handle_StepRepr_DefinitionalRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWCharacterizedRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CharacterizedRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CharacterizedRepresentation): void;
  Share(ent: Handle_StepRepr_CharacterizedRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWRepresentationRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_RepresentationRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_RepresentationRelationship): void;
  Share(ent: Handle_StepRepr_RepresentationRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWTangent {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_Tangent): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_Tangent): void;
  Share(ent: Handle_StepRepr_Tangent, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWMaterialDesignation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_MaterialDesignation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_MaterialDesignation): void;
  Share(ent: Handle_StepRepr_MaterialDesignation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ShapeAspect): void;
  Share(ent: Handle_StepRepr_ShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWAssemblyComponentUsageSubstitute {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_AssemblyComponentUsageSubstitute): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_AssemblyComponentUsageSubstitute): void;
  Share(ent: Handle_StepRepr_AssemblyComponentUsageSubstitute, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_Representation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_Representation): void;
  Share(ent: Handle_StepRepr_Representation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWReprItemAndPlaneAngleMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit): void;
  delete(): void;
}

export declare class RWStepRepr_RWShapeAspectDerivingRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ShapeAspectDerivingRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ShapeAspectDerivingRelationship): void;
  Share(ent: Handle_StepRepr_ShapeAspectDerivingRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWContinuosShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ContinuosShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ContinuosShapeAspect): void;
  Share(ent: Handle_StepRepr_ContinuosShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWShapeAspectTransition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ShapeAspectTransition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ShapeAspectTransition): void;
  Share(ent: Handle_StepRepr_ShapeAspectTransition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWValueRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ValueRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ValueRepresentationItem): void;
  delete(): void;
}

export declare class RWStepRepr_RWFunctionallyDefinedTransformation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_FunctionallyDefinedTransformation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_FunctionallyDefinedTransformation): void;
  delete(): void;
}

export declare class RWStepRepr_RWRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_RepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_RepresentationItem): void;
  delete(): void;
}

export declare class RWStepRepr_RWRepresentationContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_RepresentationContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_RepresentationContext): void;
  delete(): void;
}

export declare class RWStepRepr_RWParallelOffset {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ParallelOffset): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ParallelOffset): void;
  Share(ent: Handle_StepRepr_ParallelOffset, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWMaterialPropertyRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_MaterialPropertyRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_MaterialPropertyRepresentation): void;
  Share(ent: Handle_StepRepr_MaterialPropertyRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWStructuralResponseProperty {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_StructuralResponseProperty): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_StructuralResponseProperty): void;
  Share(ent: Handle_StepRepr_StructuralResponseProperty, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWReprItemAndLengthMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ReprItemAndLengthMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ReprItemAndLengthMeasureWithUnit): void;
  delete(): void;
}

export declare class RWStepRepr_RWCompositeGroupShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CompositeGroupShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CompositeGroupShapeAspect): void;
  Share(ent: Handle_StepRepr_CompositeGroupShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWShapeRepresentationRelationshipWithTransformation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation): void;
  Share(ent: Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWShapeAspectRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ShapeAspectRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ShapeAspectRelationship): void;
  Share(ent: Handle_StepRepr_ShapeAspectRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWConfigurationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ConfigurationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ConfigurationItem): void;
  Share(ent: Handle_StepRepr_ConfigurationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWFeatureForDatumTargetRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_FeatureForDatumTargetRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_FeatureForDatumTargetRelationship): void;
  Share(ent: Handle_StepRepr_FeatureForDatumTargetRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWRepresentationRelationshipWithTransformation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_RepresentationRelationshipWithTransformation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_RepresentationRelationshipWithTransformation): void;
  Share(ent: Handle_StepRepr_RepresentationRelationshipWithTransformation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWStructuralResponsePropertyDefinitionRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation): void;
  Share(ent: Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWConfigurationEffectivity {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ConfigurationEffectivity): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ConfigurationEffectivity): void;
  Share(ent: Handle_StepRepr_ConfigurationEffectivity, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWApex {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_Apex): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_Apex): void;
  Share(ent: Handle_StepRepr_Apex, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWProductDefinitionShape {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ProductDefinitionShape): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ProductDefinitionShape): void;
  Share(ent: Handle_StepRepr_ProductDefinitionShape, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWReprItemAndLengthMeasureWithUnitAndQRI {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI): void;
  delete(): void;
}

export declare class RWStepRepr_RWCompoundRepresentationItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CompoundRepresentationItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CompoundRepresentationItem): void;
  Share(ent: Handle_StepRepr_CompoundRepresentationItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWAllAroundShapeAspect {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_AllAroundShapeAspect): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_AllAroundShapeAspect): void;
  Share(ent: Handle_StepRepr_AllAroundShapeAspect, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWConfigurationDesign {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ConfigurationDesign): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ConfigurationDesign): void;
  Share(ent: Handle_StepRepr_ConfigurationDesign, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWAssemblyComponentUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_AssemblyComponentUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_AssemblyComponentUsage): void;
  Share(ent: Handle_StepRepr_AssemblyComponentUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWPropertyDefinitionRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_PropertyDefinitionRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_PropertyDefinitionRelationship): void;
  Share(ent: Handle_StepRepr_PropertyDefinitionRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWMaterialProperty {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_MaterialProperty): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_MaterialProperty): void;
  Share(ent: Handle_StepRepr_MaterialProperty, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWQuantifiedAssemblyComponentUsage {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_QuantifiedAssemblyComponentUsage): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_QuantifiedAssemblyComponentUsage): void;
  Share(ent: Handle_StepRepr_QuantifiedAssemblyComponentUsage, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWGeometricAlignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_GeometricAlignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_GeometricAlignment): void;
  Share(ent: Handle_StepRepr_GeometricAlignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWCompShAspAndDatumFeatAndShAsp {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_CompShAspAndDatumFeatAndShAsp): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_CompShAspAndDatumFeatAndShAsp): void;
  Share(ent: Handle_StepRepr_CompShAspAndDatumFeatAndShAsp, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWConstructiveGeometryRepresentationRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_ConstructiveGeometryRepresentationRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_ConstructiveGeometryRepresentationRelationship): void;
  Share(ent: Handle_StepRepr_ConstructiveGeometryRepresentationRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWDataEnvironment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_DataEnvironment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_DataEnvironment): void;
  Share(ent: Handle_StepRepr_DataEnvironment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWGlobalUnitAssignedContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_GlobalUnitAssignedContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_GlobalUnitAssignedContext): void;
  Share(ent: Handle_StepRepr_GlobalUnitAssignedContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWRepresentationMap {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_RepresentationMap): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_RepresentationMap): void;
  Share(ent: Handle_StepRepr_RepresentationMap, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWExtension {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_Extension): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_Extension): void;
  Share(ent: Handle_StepRepr_Extension, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWSpecifiedHigherUsageOccurrence {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_SpecifiedHigherUsageOccurrence): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_SpecifiedHigherUsageOccurrence): void;
  Share(ent: Handle_StepRepr_SpecifiedHigherUsageOccurrence, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWPerpendicularTo {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_PerpendicularTo): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_PerpendicularTo): void;
  Share(ent: Handle_StepRepr_PerpendicularTo, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWPropertyDefinitionRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_PropertyDefinitionRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_PropertyDefinitionRepresentation): void;
  Share(ent: Handle_StepRepr_PropertyDefinitionRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepRepr_RWMakeFromUsageOption {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepRepr_MakeFromUsageOption): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepRepr_MakeFromUsageOption): void;
  Share(ent: Handle_StepRepr_MakeFromUsageOption, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class Handle_BRepCheck_Shell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Shell): void;
  get(): BRepCheck_Shell;
  delete(): void;
}

  export declare class Handle_BRepCheck_Shell_1 extends Handle_BRepCheck_Shell {
    constructor();
  }

  export declare class Handle_BRepCheck_Shell_2 extends Handle_BRepCheck_Shell {
    constructor(thePtr: BRepCheck_Shell);
  }

  export declare class Handle_BRepCheck_Shell_3 extends Handle_BRepCheck_Shell {
    constructor(theHandle: Handle_BRepCheck_Shell);
  }

  export declare class Handle_BRepCheck_Shell_4 extends Handle_BRepCheck_Shell {
    constructor(theHandle: Handle_BRepCheck_Shell);
  }

export declare class BRepCheck_Shell extends BRepCheck_Result {
  constructor(S: TopoDS_Shell)
  InContext(ContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  Closed(Update: Standard_Boolean): BRepCheck_Status;
  Orientation(Update: Standard_Boolean): BRepCheck_Status;
  SetUnorientable(): void;
  IsUnorientable(): Standard_Boolean;
  NbConnectedSet(theSets: TopTools_ListOfShape): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepCheck_Result {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Result): void;
  get(): BRepCheck_Result;
  delete(): void;
}

  export declare class Handle_BRepCheck_Result_1 extends Handle_BRepCheck_Result {
    constructor();
  }

  export declare class Handle_BRepCheck_Result_2 extends Handle_BRepCheck_Result {
    constructor(thePtr: BRepCheck_Result);
  }

  export declare class Handle_BRepCheck_Result_3 extends Handle_BRepCheck_Result {
    constructor(theHandle: Handle_BRepCheck_Result);
  }

  export declare class Handle_BRepCheck_Result_4 extends Handle_BRepCheck_Result {
    constructor(theHandle: Handle_BRepCheck_Result);
  }

export declare class BRepCheck_Result extends Standard_Transient {
  Init(S: TopoDS_Shape): void;
  InContext(ContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  SetFailStatus(S: TopoDS_Shape): void;
  Status(): BRepCheck_ListOfStatus;
  IsMinimum(): Standard_Boolean;
  IsBlind(): Standard_Boolean;
  StatusOnShape_1(S: TopoDS_Shape): BRepCheck_ListOfStatus;
  InitContextIterator(): void;
  MoreShapeInContext(): Standard_Boolean;
  ContextualShape(): TopoDS_Shape;
  StatusOnShape_2(): BRepCheck_ListOfStatus;
  NextShapeInContext(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepCheck_Edge extends BRepCheck_Result {
  constructor(E: TopoDS_Edge)
  InContext(ContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  GeometricControls_1(): Standard_Boolean;
  GeometricControls_2(B: Standard_Boolean): void;
  Tolerance(): Quantity_AbsorbedDose;
  SetStatus(theStatus: BRepCheck_Status): void;
  CheckPolygonOnTriangulation(theEdge: TopoDS_Edge): BRepCheck_Status;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepCheck_Edge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Edge): void;
  get(): BRepCheck_Edge;
  delete(): void;
}

  export declare class Handle_BRepCheck_Edge_1 extends Handle_BRepCheck_Edge {
    constructor();
  }

  export declare class Handle_BRepCheck_Edge_2 extends Handle_BRepCheck_Edge {
    constructor(thePtr: BRepCheck_Edge);
  }

  export declare class Handle_BRepCheck_Edge_3 extends Handle_BRepCheck_Edge {
    constructor(theHandle: Handle_BRepCheck_Edge);
  }

  export declare class Handle_BRepCheck_Edge_4 extends Handle_BRepCheck_Edge {
    constructor(theHandle: Handle_BRepCheck_Edge);
  }

export declare class BRepCheck_Analyzer {
  constructor(S: TopoDS_Shape, GeomControls: Standard_Boolean)
  Init(S: TopoDS_Shape, GeomControls: Standard_Boolean): void;
  IsValid_1(S: TopoDS_Shape): Standard_Boolean;
  IsValid_2(): Standard_Boolean;
  Result(SubS: TopoDS_Shape): Handle_BRepCheck_Result;
  delete(): void;
}

export declare class Handle_BRepCheck_Wire {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Wire): void;
  get(): BRepCheck_Wire;
  delete(): void;
}

  export declare class Handle_BRepCheck_Wire_1 extends Handle_BRepCheck_Wire {
    constructor();
  }

  export declare class Handle_BRepCheck_Wire_2 extends Handle_BRepCheck_Wire {
    constructor(thePtr: BRepCheck_Wire);
  }

  export declare class Handle_BRepCheck_Wire_3 extends Handle_BRepCheck_Wire {
    constructor(theHandle: Handle_BRepCheck_Wire);
  }

  export declare class Handle_BRepCheck_Wire_4 extends Handle_BRepCheck_Wire {
    constructor(theHandle: Handle_BRepCheck_Wire);
  }

export declare class BRepCheck_Wire extends BRepCheck_Result {
  constructor(W: TopoDS_Wire)
  InContext(ContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  Closed(Update: Standard_Boolean): BRepCheck_Status;
  Closed2d(F: TopoDS_Face, Update: Standard_Boolean): BRepCheck_Status;
  Orientation(F: TopoDS_Face, Update: Standard_Boolean): BRepCheck_Status;
  SelfIntersect(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, Update: Standard_Boolean): BRepCheck_Status;
  GeometricControls_1(): Standard_Boolean;
  GeometricControls_2(B: Standard_Boolean): void;
  SetStatus(theStatus: BRepCheck_Status): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepCheck_Solid extends BRepCheck_Result {
  constructor(theS: TopoDS_Solid)
  InContext(theContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepCheck_Solid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Solid): void;
  get(): BRepCheck_Solid;
  delete(): void;
}

  export declare class Handle_BRepCheck_Solid_1 extends Handle_BRepCheck_Solid {
    constructor();
  }

  export declare class Handle_BRepCheck_Solid_2 extends Handle_BRepCheck_Solid {
    constructor(thePtr: BRepCheck_Solid);
  }

  export declare class Handle_BRepCheck_Solid_3 extends Handle_BRepCheck_Solid {
    constructor(theHandle: Handle_BRepCheck_Solid);
  }

  export declare class Handle_BRepCheck_Solid_4 extends Handle_BRepCheck_Solid {
    constructor(theHandle: Handle_BRepCheck_Solid);
  }

export declare class Handle_BRepCheck_Face {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Face): void;
  get(): BRepCheck_Face;
  delete(): void;
}

  export declare class Handle_BRepCheck_Face_1 extends Handle_BRepCheck_Face {
    constructor();
  }

  export declare class Handle_BRepCheck_Face_2 extends Handle_BRepCheck_Face {
    constructor(thePtr: BRepCheck_Face);
  }

  export declare class Handle_BRepCheck_Face_3 extends Handle_BRepCheck_Face {
    constructor(theHandle: Handle_BRepCheck_Face);
  }

  export declare class Handle_BRepCheck_Face_4 extends Handle_BRepCheck_Face {
    constructor(theHandle: Handle_BRepCheck_Face);
  }

export declare class BRepCheck_Face extends BRepCheck_Result {
  constructor(F: TopoDS_Face)
  InContext(ContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  IntersectWires(Update: Standard_Boolean): BRepCheck_Status;
  ClassifyWires(Update: Standard_Boolean): BRepCheck_Status;
  OrientationOfWires(Update: Standard_Boolean): BRepCheck_Status;
  SetUnorientable(): void;
  SetStatus(theStatus: BRepCheck_Status): void;
  IsUnorientable(): Standard_Boolean;
  GeometricControls_1(): Standard_Boolean;
  GeometricControls_2(B: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type BRepCheck_Status = {
  BRepCheck_NoError: {};
  BRepCheck_InvalidPointOnCurve: {};
  BRepCheck_InvalidPointOnCurveOnSurface: {};
  BRepCheck_InvalidPointOnSurface: {};
  BRepCheck_No3DCurve: {};
  BRepCheck_Multiple3DCurve: {};
  BRepCheck_Invalid3DCurve: {};
  BRepCheck_NoCurveOnSurface: {};
  BRepCheck_InvalidCurveOnSurface: {};
  BRepCheck_InvalidCurveOnClosedSurface: {};
  BRepCheck_InvalidSameRangeFlag: {};
  BRepCheck_InvalidSameParameterFlag: {};
  BRepCheck_InvalidDegeneratedFlag: {};
  BRepCheck_FreeEdge: {};
  BRepCheck_InvalidMultiConnexity: {};
  BRepCheck_InvalidRange: {};
  BRepCheck_EmptyWire: {};
  BRepCheck_RedundantEdge: {};
  BRepCheck_SelfIntersectingWire: {};
  BRepCheck_NoSurface: {};
  BRepCheck_InvalidWire: {};
  BRepCheck_RedundantWire: {};
  BRepCheck_IntersectingWires: {};
  BRepCheck_InvalidImbricationOfWires: {};
  BRepCheck_EmptyShell: {};
  BRepCheck_RedundantFace: {};
  BRepCheck_InvalidImbricationOfShells: {};
  BRepCheck_UnorientableShape: {};
  BRepCheck_NotClosed: {};
  BRepCheck_NotConnected: {};
  BRepCheck_SubshapeNotInShape: {};
  BRepCheck_BadOrientation: {};
  BRepCheck_BadOrientationOfSubshape: {};
  BRepCheck_InvalidPolygonOnTriangulation: {};
  BRepCheck_InvalidToleranceValue: {};
  BRepCheck_EnclosedRegion: {};
  BRepCheck_CheckFail: {};
}

export declare class BRepCheck_DataMapOfShapeListOfStatus extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepCheck_DataMapOfShapeListOfStatus): void;
  Assign(theOther: BRepCheck_DataMapOfShapeListOfStatus): BRepCheck_DataMapOfShapeListOfStatus;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: BRepCheck_ListOfStatus): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: BRepCheck_ListOfStatus): BRepCheck_ListOfStatus;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): BRepCheck_ListOfStatus;
  ChangeSeek(theKey: TopoDS_Shape): BRepCheck_ListOfStatus;
  ChangeFind(theKey: TopoDS_Shape): BRepCheck_ListOfStatus;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepCheck_DataMapOfShapeListOfStatus_1 extends BRepCheck_DataMapOfShapeListOfStatus {
    constructor();
  }

  export declare class BRepCheck_DataMapOfShapeListOfStatus_2 extends BRepCheck_DataMapOfShapeListOfStatus {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepCheck_DataMapOfShapeListOfStatus_3 extends BRepCheck_DataMapOfShapeListOfStatus {
    constructor(theOther: BRepCheck_DataMapOfShapeListOfStatus);
  }

export declare class Handle_BRepCheck_Vertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepCheck_Vertex): void;
  get(): BRepCheck_Vertex;
  delete(): void;
}

  export declare class Handle_BRepCheck_Vertex_1 extends Handle_BRepCheck_Vertex {
    constructor();
  }

  export declare class Handle_BRepCheck_Vertex_2 extends Handle_BRepCheck_Vertex {
    constructor(thePtr: BRepCheck_Vertex);
  }

  export declare class Handle_BRepCheck_Vertex_3 extends Handle_BRepCheck_Vertex {
    constructor(theHandle: Handle_BRepCheck_Vertex);
  }

  export declare class Handle_BRepCheck_Vertex_4 extends Handle_BRepCheck_Vertex {
    constructor(theHandle: Handle_BRepCheck_Vertex);
  }

export declare class BRepCheck_Vertex extends BRepCheck_Result {
  constructor(V: TopoDS_Vertex)
  InContext(ContextShape: TopoDS_Shape): void;
  Minimum(): void;
  Blind(): void;
  Tolerance(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepCheck {
  constructor();
  static Add(List: BRepCheck_ListOfStatus, Stat: BRepCheck_Status): void;
  static Print(Stat: BRepCheck_Status, OS: Standard_OStream): void;
  static SelfIntersection(W: TopoDS_Wire, F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge): Standard_Boolean;
  static PrecCurve(aAC3D: Adaptor3d_Curve): Quantity_AbsorbedDose;
  static PrecSurface(aAHSurf: Handle_Adaptor3d_HSurface): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepCheck_ListOfStatus extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BRepCheck_ListOfStatus): BRepCheck_ListOfStatus;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BRepCheck_Status;
  First_2(): BRepCheck_Status;
  Last_1(): BRepCheck_Status;
  Last_2(): BRepCheck_Status;
  Append_1(theItem: BRepCheck_Status): BRepCheck_Status;
  Append_3(theOther: BRepCheck_ListOfStatus): void;
  Prepend_1(theItem: BRepCheck_Status): BRepCheck_Status;
  Prepend_2(theOther: BRepCheck_ListOfStatus): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BRepCheck_ListOfStatus_1 extends BRepCheck_ListOfStatus {
    constructor();
  }

  export declare class BRepCheck_ListOfStatus_2 extends BRepCheck_ListOfStatus {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepCheck_ListOfStatus_3 extends BRepCheck_ListOfStatus {
    constructor(theOther: BRepCheck_ListOfStatus);
  }

export declare class BRepBndLib {
  constructor();
  static Add(S: TopoDS_Shape, B: Bnd_Box, useTriangulation: Standard_Boolean): void;
  static AddClose(S: TopoDS_Shape, B: Bnd_Box): void;
  static AddOptimal(S: TopoDS_Shape, B: Bnd_Box, useTriangulation: Standard_Boolean, useShapeTolerance: Standard_Boolean): void;
  static AddOBB(theS: TopoDS_Shape, theOBB: Bnd_OBB, theIsTriangulationUsed: Standard_Boolean, theIsOptimal: Standard_Boolean, theIsShapeToleranceUsed: Standard_Boolean): void;
  delete(): void;
}

export declare class Interface_Protocol extends Standard_Transient {
  static Active(): Handle_Interface_Protocol;
  static SetActive(aprotocol: Handle_Interface_Protocol): void;
  static ClearActive(): void;
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  CaseNumber(obj: Handle_Standard_Transient): Graphic3d_ZLayerId;
  IsDynamicType(obj: Handle_Standard_Transient): Standard_Boolean;
  NbTypes(obj: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Type(obj: Handle_Standard_Transient, nt: Graphic3d_ZLayerId): Handle_Standard_Type;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  GlobalCheck(G: Interface_Graph, ach: Handle_Interface_Check): Standard_Boolean;
  NewModel(): Handle_Interface_InterfaceModel;
  IsSuitableModel(model: Handle_Interface_InterfaceModel): Standard_Boolean;
  UnknownEntity(): Handle_Standard_Transient;
  IsUnknownEntity(ent: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_Protocol): void;
  get(): Interface_Protocol;
  delete(): void;
}

  export declare class Handle_Interface_Protocol_1 extends Handle_Interface_Protocol {
    constructor();
  }

  export declare class Handle_Interface_Protocol_2 extends Handle_Interface_Protocol {
    constructor(thePtr: Interface_Protocol);
  }

  export declare class Handle_Interface_Protocol_3 extends Handle_Interface_Protocol {
    constructor(theHandle: Handle_Interface_Protocol);
  }

  export declare class Handle_Interface_Protocol_4 extends Handle_Interface_Protocol {
    constructor(theHandle: Handle_Interface_Protocol);
  }

export declare class Handle_Interface_HGraph {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_HGraph): void;
  get(): Interface_HGraph;
  delete(): void;
}

  export declare class Handle_Interface_HGraph_1 extends Handle_Interface_HGraph {
    constructor();
  }

  export declare class Handle_Interface_HGraph_2 extends Handle_Interface_HGraph {
    constructor(thePtr: Interface_HGraph);
  }

  export declare class Handle_Interface_HGraph_3 extends Handle_Interface_HGraph {
    constructor(theHandle: Handle_Interface_HGraph);
  }

  export declare class Handle_Interface_HGraph_4 extends Handle_Interface_HGraph {
    constructor(theHandle: Handle_Interface_HGraph);
  }

export declare type Interface_DataState = {
  Interface_StateOK: {};
  Interface_LoadWarning: {};
  Interface_LoadFail: {};
  Interface_DataWarning: {};
  Interface_DataFail: {};
  Interface_StateUnloaded: {};
  Interface_StateUnknown: {};
}

export declare class Interface_NodeOfReaderLib extends Standard_Transient {
  constructor()
  AddNode(anode: Handle_Interface_GlobalNodeOfReaderLib): void;
  Module(): Handle_Interface_ReaderModule;
  Protocol(): Handle_Interface_Protocol;
  Next(): Handle_Interface_NodeOfReaderLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_NodeOfReaderLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_NodeOfReaderLib): void;
  get(): Interface_NodeOfReaderLib;
  delete(): void;
}

  export declare class Handle_Interface_NodeOfReaderLib_1 extends Handle_Interface_NodeOfReaderLib {
    constructor();
  }

  export declare class Handle_Interface_NodeOfReaderLib_2 extends Handle_Interface_NodeOfReaderLib {
    constructor(thePtr: Interface_NodeOfReaderLib);
  }

  export declare class Handle_Interface_NodeOfReaderLib_3 extends Handle_Interface_NodeOfReaderLib {
    constructor(theHandle: Handle_Interface_NodeOfReaderLib);
  }

  export declare class Handle_Interface_NodeOfReaderLib_4 extends Handle_Interface_NodeOfReaderLib {
    constructor(theHandle: Handle_Interface_NodeOfReaderLib);
  }

export declare class Interface_EntityIterator {
  AddList(list: Handle_TColStd_HSequenceOfTransient): void;
  AddItem(anentity: Handle_Standard_Transient): void;
  GetOneItem(anentity: Handle_Standard_Transient): void;
  SelectType(atype: Handle_Standard_Type, keep: Standard_Boolean): void;
  NbEntities(): Graphic3d_ZLayerId;
  NbTyped(type: Handle_Standard_Type): Graphic3d_ZLayerId;
  Typed(type: Handle_Standard_Type): Interface_EntityIterator;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Standard_Transient;
  Content(): Handle_TColStd_HSequenceOfTransient;
  Destroy(): void;
  delete(): void;
}

  export declare class Interface_EntityIterator_1 extends Interface_EntityIterator {
    constructor();
  }

  export declare class Interface_EntityIterator_2 extends Interface_EntityIterator {
    constructor(list: Handle_TColStd_HSequenceOfTransient);
  }

export declare class Interface_CopyTool {
  Model(): Handle_Interface_InterfaceModel;
  SetControl(othermap: Handle_Interface_CopyControl): void;
  Control(): Handle_Interface_CopyControl;
  Clear(): void;
  Copy(entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient, mapped: Standard_Boolean, errstat: Standard_Boolean): Standard_Boolean;
  Transferred(ent: Handle_Standard_Transient): Handle_Standard_Transient;
  Bind(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): void;
  Search(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): Standard_Boolean;
  ClearLastFlags(): void;
  LastCopiedAfter(numfrom: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, res: Handle_Standard_Transient): Graphic3d_ZLayerId;
  TransferEntity(ent: Handle_Standard_Transient): void;
  RenewImpliedRefs(): void;
  FillModel(bmodel: Handle_Interface_InterfaceModel): void;
  CompleteResult(withreports: Standard_Boolean): Interface_EntityIterator;
  RootResult(withreports: Standard_Boolean): Interface_EntityIterator;
  delete(): void;
}

  export declare class Interface_CopyTool_1 extends Interface_CopyTool {
    constructor(amodel: Handle_Interface_InterfaceModel, lib: Interface_GeneralLib);
  }

  export declare class Interface_CopyTool_2 extends Interface_CopyTool {
    constructor(amodel: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol);
  }

  export declare class Interface_CopyTool_3 extends Interface_CopyTool {
    constructor(amodel: Handle_Interface_InterfaceModel);
  }

export declare class Interface_EntityList {
  constructor()
  Clear(): void;
  Append(ent: Handle_Standard_Transient): void;
  Add(ent: Handle_Standard_Transient): void;
  Remove_1(ent: Handle_Standard_Transient): void;
  Remove_2(num: Graphic3d_ZLayerId): void;
  IsEmpty(): Standard_Boolean;
  NbEntities(): Graphic3d_ZLayerId;
  Value(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  SetValue(num: Graphic3d_ZLayerId, ent: Handle_Standard_Transient): void;
  FillIterator(iter: Interface_EntityIterator): void;
  NbTypedEntities(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  TypedEntity(atype: Handle_Standard_Type, num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  delete(): void;
}

export declare class Interface_CheckIterator {
  SetName(name: Standard_CString): void;
  Name(): Standard_CString;
  SetModel(model: Handle_Interface_InterfaceModel): void;
  Model(): Handle_Interface_InterfaceModel;
  Clear(): void;
  Merge(other: Interface_CheckIterator): void;
  Add(ach: Handle_Interface_Check, num: Graphic3d_ZLayerId): void;
  Check_1(num: Graphic3d_ZLayerId): Handle_Interface_Check;
  Check_2(ent: Handle_Standard_Transient): Handle_Interface_Check;
  CCheck_1(num: Graphic3d_ZLayerId): Handle_Interface_Check;
  CCheck_2(ent: Handle_Standard_Transient): Handle_Interface_Check;
  IsEmpty(failsonly: Standard_Boolean): Standard_Boolean;
  Status(): Interface_CheckStatus;
  Complies(status: Interface_CheckStatus): Standard_Boolean;
  Extract_1(status: Interface_CheckStatus): Interface_CheckIterator;
  Extract_2(mess: Standard_CString, incl: Graphic3d_ZLayerId, status: Interface_CheckStatus): Interface_CheckIterator;
  Remove(mess: Standard_CString, incl: Graphic3d_ZLayerId, status: Interface_CheckStatus): Standard_Boolean;
  Checkeds(failsonly: Standard_Boolean, global: Standard_Boolean): Handle_TColStd_HSequenceOfTransient;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Interface_Check;
  Number(): Graphic3d_ZLayerId;
  Print_1(S: Standard_OStream, failsonly: Standard_Boolean, final: Graphic3d_ZLayerId): void;
  Print_2(S: Standard_OStream, model: Handle_Interface_InterfaceModel, failsonly: Standard_Boolean, final: Graphic3d_ZLayerId): void;
  Destroy(): void;
  delete(): void;
}

  export declare class Interface_CheckIterator_1 extends Interface_CheckIterator {
    constructor();
  }

  export declare class Interface_CheckIterator_2 extends Interface_CheckIterator {
    constructor(name: Standard_CString);
  }

export declare class Handle_Interface_GlobalNodeOfGeneralLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_GlobalNodeOfGeneralLib): void;
  get(): Interface_GlobalNodeOfGeneralLib;
  delete(): void;
}

  export declare class Handle_Interface_GlobalNodeOfGeneralLib_1 extends Handle_Interface_GlobalNodeOfGeneralLib {
    constructor();
  }

  export declare class Handle_Interface_GlobalNodeOfGeneralLib_2 extends Handle_Interface_GlobalNodeOfGeneralLib {
    constructor(thePtr: Interface_GlobalNodeOfGeneralLib);
  }

  export declare class Handle_Interface_GlobalNodeOfGeneralLib_3 extends Handle_Interface_GlobalNodeOfGeneralLib {
    constructor(theHandle: Handle_Interface_GlobalNodeOfGeneralLib);
  }

  export declare class Handle_Interface_GlobalNodeOfGeneralLib_4 extends Handle_Interface_GlobalNodeOfGeneralLib {
    constructor(theHandle: Handle_Interface_GlobalNodeOfGeneralLib);
  }

export declare class Interface_GlobalNodeOfGeneralLib extends Standard_Transient {
  constructor()
  Add(amodule: Handle_Interface_GeneralModule, aprotocol: Handle_Interface_Protocol): void;
  Module(): Handle_Interface_GeneralModule;
  Protocol(): Handle_Interface_Protocol;
  Next(): Handle_Interface_GlobalNodeOfGeneralLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Interface_MapAsciiStringHasher {
  constructor();
  static HashCode(theAsciiString: XCAFDoc_PartId, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(K1: XCAFDoc_PartId, K2: XCAFDoc_PartId): Standard_Boolean;
  delete(): void;
}

export declare class Interface_Category {
  SetProtocol(theProtocol: Handle_Interface_Protocol): void;
  CatNum(theEnt: Handle_Standard_Transient, theShares: Interface_ShareTool): Graphic3d_ZLayerId;
  ClearNums(): void;
  Compute(theModel: Handle_Interface_InterfaceModel, theShares: Interface_ShareTool): void;
  Num(theNumEnt: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static AddCategory(theName: Standard_CString): Graphic3d_ZLayerId;
  static NbCategories(): Graphic3d_ZLayerId;
  static Name(theNum: Graphic3d_ZLayerId): Standard_CString;
  static Number(theName: Standard_CString): Graphic3d_ZLayerId;
  static Init(): void;
  delete(): void;
}

  export declare class Interface_Category_1 extends Interface_Category {
    constructor();
  }

  export declare class Interface_Category_2 extends Interface_Category {
    constructor(theProtocol: Handle_Interface_Protocol);
  }

  export declare class Interface_Category_3 extends Interface_Category {
    constructor(theGTool: Handle_Interface_GTool);
  }

export declare class Interface_ShareTool {
  Model(): Handle_Interface_InterfaceModel;
  Graph(): Interface_Graph;
  RootEntities(): Interface_EntityIterator;
  IsShared(ent: Handle_Standard_Transient): Standard_Boolean;
  Shareds(ent: Handle_Standard_Transient): Interface_EntityIterator;
  Sharings(ent: Handle_Standard_Transient): Interface_EntityIterator;
  NbTypedSharings(ent: Handle_Standard_Transient, atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  TypedSharing(ent: Handle_Standard_Transient, atype: Handle_Standard_Type): Handle_Standard_Transient;
  All(ent: Handle_Standard_Transient, rootlast: Standard_Boolean): Interface_EntityIterator;
  Print(iter: Interface_EntityIterator, S: Standard_OStream): void;
  delete(): void;
}

  export declare class Interface_ShareTool_1 extends Interface_ShareTool {
    constructor(amodel: Handle_Interface_InterfaceModel, lib: Interface_GeneralLib);
  }

  export declare class Interface_ShareTool_2 extends Interface_ShareTool {
    constructor(amodel: Handle_Interface_InterfaceModel, gtool: Handle_Interface_GTool);
  }

  export declare class Interface_ShareTool_3 extends Interface_ShareTool {
    constructor(amodel: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol);
  }

  export declare class Interface_ShareTool_4 extends Interface_ShareTool {
    constructor(amodel: Handle_Interface_InterfaceModel);
  }

  export declare class Interface_ShareTool_5 extends Interface_ShareTool {
    constructor(agraph: Interface_Graph);
  }

  export declare class Interface_ShareTool_6 extends Interface_ShareTool {
    constructor(ahgraph: Handle_Interface_HGraph);
  }

export declare class Handle_Interface_InterfaceError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_InterfaceError): void;
  get(): Interface_InterfaceError;
  delete(): void;
}

  export declare class Handle_Interface_InterfaceError_1 extends Handle_Interface_InterfaceError {
    constructor();
  }

  export declare class Handle_Interface_InterfaceError_2 extends Handle_Interface_InterfaceError {
    constructor(thePtr: Interface_InterfaceError);
  }

  export declare class Handle_Interface_InterfaceError_3 extends Handle_Interface_InterfaceError {
    constructor(theHandle: Handle_Interface_InterfaceError);
  }

  export declare class Handle_Interface_InterfaceError_4 extends Handle_Interface_InterfaceError {
    constructor(theHandle: Handle_Interface_InterfaceError);
  }

export declare class Interface_InterfaceError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Interface_InterfaceError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_InterfaceError_1 extends Interface_InterfaceError {
    constructor();
  }

  export declare class Interface_InterfaceError_2 extends Interface_InterfaceError {
    constructor(theMessage: Standard_CString);
  }

export declare class Interface_FileReaderTool {
  SetData(reader: Handle_Interface_FileReaderData, protocol: Handle_Interface_Protocol): void;
  Protocol(): Handle_Interface_Protocol;
  Data(): Handle_Interface_FileReaderData;
  SetModel(amodel: Handle_Interface_InterfaceModel): void;
  Model(): Handle_Interface_InterfaceModel;
  SetMessenger(messenger: Handle_Message_Messenger): void;
  Messenger(): Handle_Message_Messenger;
  SetTraceLevel(tracelev: Graphic3d_ZLayerId): void;
  TraceLevel(): Graphic3d_ZLayerId;
  SetErrorHandle(err: Standard_Boolean): void;
  ErrorHandle(): Standard_Boolean;
  SetEntities(): void;
  Recognize(num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): Standard_Boolean;
  RecognizeByLib(num: Graphic3d_ZLayerId, glib: Interface_GeneralLib, rlib: Interface_ReaderLib, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): Standard_Boolean;
  UnknownEntity(): Handle_Standard_Transient;
  NewModel(): Handle_Interface_InterfaceModel;
  LoadModel(amodel: Handle_Interface_InterfaceModel): void;
  LoadedEntity(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  BeginRead(amodel: Handle_Interface_InterfaceModel): void;
  AnalyseRecord(num: Graphic3d_ZLayerId, anent: Handle_Standard_Transient, acheck: Handle_Interface_Check): Standard_Boolean;
  EndRead(amodel: Handle_Interface_InterfaceModel): void;
  Clear(): void;
  delete(): void;
}

export declare class Handle_Interface_ReportEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_ReportEntity): void;
  get(): Interface_ReportEntity;
  delete(): void;
}

  export declare class Handle_Interface_ReportEntity_1 extends Handle_Interface_ReportEntity {
    constructor();
  }

  export declare class Handle_Interface_ReportEntity_2 extends Handle_Interface_ReportEntity {
    constructor(thePtr: Interface_ReportEntity);
  }

  export declare class Handle_Interface_ReportEntity_3 extends Handle_Interface_ReportEntity {
    constructor(theHandle: Handle_Interface_ReportEntity);
  }

  export declare class Handle_Interface_ReportEntity_4 extends Handle_Interface_ReportEntity {
    constructor(theHandle: Handle_Interface_ReportEntity);
  }

export declare class Interface_ReportEntity extends Standard_Transient {
  SetContent(content: Handle_Standard_Transient): void;
  Check(): Handle_Interface_Check;
  CCheck(): Handle_Interface_Check;
  Concerned(): Handle_Standard_Transient;
  HasContent(): Standard_Boolean;
  HasNewContent(): Standard_Boolean;
  Content(): Handle_Standard_Transient;
  IsError(): Standard_Boolean;
  IsUnknown(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_ReportEntity_1 extends Interface_ReportEntity {
    constructor(unknown: Handle_Standard_Transient);
  }

  export declare class Interface_ReportEntity_2 extends Interface_ReportEntity {
    constructor(acheck: Handle_Interface_Check, concerned: Handle_Standard_Transient);
  }

export declare class Interface_BitMap {
  Initialize_1(nbitems: Graphic3d_ZLayerId, resflags: Graphic3d_ZLayerId): void;
  Initialize_2(other: Interface_BitMap, copied: Standard_Boolean): void;
  Reservate(moreflags: Graphic3d_ZLayerId): void;
  SetLength(nbitems: Graphic3d_ZLayerId): void;
  AddFlag(name: Standard_CString): Graphic3d_ZLayerId;
  AddSomeFlags(more: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  RemoveFlag(num: Graphic3d_ZLayerId): Standard_Boolean;
  SetFlagName(num: Graphic3d_ZLayerId, name: Standard_CString): Standard_Boolean;
  NbFlags(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  FlagName(num: Graphic3d_ZLayerId): Standard_CString;
  FlagNumber(name: Standard_CString): Graphic3d_ZLayerId;
  Value(item: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId): Standard_Boolean;
  SetValue(item: Graphic3d_ZLayerId, val: Standard_Boolean, flag: Graphic3d_ZLayerId): void;
  SetTrue(item: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId): void;
  SetFalse(item: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId): void;
  CTrue(item: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId): Standard_Boolean;
  CFalse(item: Graphic3d_ZLayerId, flag: Graphic3d_ZLayerId): Standard_Boolean;
  Init(val: Standard_Boolean, flag: Graphic3d_ZLayerId): void;
  Clear(): void;
  delete(): void;
}

  export declare class Interface_BitMap_1 extends Interface_BitMap {
    constructor();
  }

  export declare class Interface_BitMap_2 extends Interface_BitMap {
    constructor(nbitems: Graphic3d_ZLayerId, resflags: Graphic3d_ZLayerId);
  }

  export declare class Interface_BitMap_3 extends Interface_BitMap {
    constructor(other: Interface_BitMap, copied: Standard_Boolean);
  }

export declare class Interface_UndefinedContent extends Standard_Transient {
  constructor()
  NbParams(): Graphic3d_ZLayerId;
  NbLiterals(): Graphic3d_ZLayerId;
  ParamData(num: Graphic3d_ZLayerId, ptype: Interface_ParamType, ent: Handle_Standard_Transient, val: Handle_TCollection_HAsciiString): Standard_Boolean;
  ParamType(num: Graphic3d_ZLayerId): Interface_ParamType;
  IsParamEntity(num: Graphic3d_ZLayerId): Standard_Boolean;
  ParamEntity(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  ParamValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Reservate(nb: Graphic3d_ZLayerId, nblit: Graphic3d_ZLayerId): void;
  AddLiteral(ptype: Interface_ParamType, val: Handle_TCollection_HAsciiString): void;
  AddEntity(ptype: Interface_ParamType, ent: Handle_Standard_Transient): void;
  RemoveParam(num: Graphic3d_ZLayerId): void;
  SetLiteral(num: Graphic3d_ZLayerId, ptype: Interface_ParamType, val: Handle_TCollection_HAsciiString): void;
  SetEntity_1(num: Graphic3d_ZLayerId, ptype: Interface_ParamType, ent: Handle_Standard_Transient): void;
  SetEntity_2(num: Graphic3d_ZLayerId, ent: Handle_Standard_Transient): void;
  EntityList(): Interface_EntityList;
  GetFromAnother(other: Handle_Interface_UndefinedContent, TC: Interface_CopyTool): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_UndefinedContent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_UndefinedContent): void;
  get(): Interface_UndefinedContent;
  delete(): void;
}

  export declare class Handle_Interface_UndefinedContent_1 extends Handle_Interface_UndefinedContent {
    constructor();
  }

  export declare class Handle_Interface_UndefinedContent_2 extends Handle_Interface_UndefinedContent {
    constructor(thePtr: Interface_UndefinedContent);
  }

  export declare class Handle_Interface_UndefinedContent_3 extends Handle_Interface_UndefinedContent {
    constructor(theHandle: Handle_Interface_UndefinedContent);
  }

  export declare class Handle_Interface_UndefinedContent_4 extends Handle_Interface_UndefinedContent {
    constructor(theHandle: Handle_Interface_UndefinedContent);
  }

export declare class Interface_ParamList extends Standard_Transient {
  constructor(theIncrement: Graphic3d_ZLayerId)
  Length(): Graphic3d_ZLayerId;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  SetValue(Index: Graphic3d_ZLayerId, Value: Interface_FileParameter): void;
  Value(Index: Graphic3d_ZLayerId): Interface_FileParameter;
  ChangeValue(Index: Graphic3d_ZLayerId): Interface_FileParameter;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_ParamList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_ParamList): void;
  get(): Interface_ParamList;
  delete(): void;
}

  export declare class Handle_Interface_ParamList_1 extends Handle_Interface_ParamList {
    constructor();
  }

  export declare class Handle_Interface_ParamList_2 extends Handle_Interface_ParamList {
    constructor(thePtr: Interface_ParamList);
  }

  export declare class Handle_Interface_ParamList_3 extends Handle_Interface_ParamList {
    constructor(theHandle: Handle_Interface_ParamList);
  }

  export declare class Handle_Interface_ParamList_4 extends Handle_Interface_ParamList {
    constructor(theHandle: Handle_Interface_ParamList);
  }

export declare class Handle_Interface_Check {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_Check): void;
  get(): Interface_Check;
  delete(): void;
}

  export declare class Handle_Interface_Check_1 extends Handle_Interface_Check {
    constructor();
  }

  export declare class Handle_Interface_Check_2 extends Handle_Interface_Check {
    constructor(thePtr: Interface_Check);
  }

  export declare class Handle_Interface_Check_3 extends Handle_Interface_Check {
    constructor(theHandle: Handle_Interface_Check);
  }

  export declare class Handle_Interface_Check_4 extends Handle_Interface_Check {
    constructor(theHandle: Handle_Interface_Check);
  }

export declare class Interface_Check extends Standard_Transient {
  SendFail(amsg: Message_Msg): void;
  AddFail_1(amess: Handle_TCollection_HAsciiString): void;
  AddFail_2(amess: Handle_TCollection_HAsciiString, orig: Handle_TCollection_HAsciiString): void;
  AddFail_3(amess: Standard_CString, orig: Standard_CString): void;
  AddFail_4(amsg: Message_Msg): void;
  HasFailed(): Standard_Boolean;
  NbFails(): Graphic3d_ZLayerId;
  Fail(num: Graphic3d_ZLayerId, final: Standard_Boolean): Handle_TCollection_HAsciiString;
  CFail(num: Graphic3d_ZLayerId, final: Standard_Boolean): Standard_CString;
  Fails(final: Standard_Boolean): Handle_TColStd_HSequenceOfHAsciiString;
  SendWarning(amsg: Message_Msg): void;
  AddWarning_1(amess: Handle_TCollection_HAsciiString): void;
  AddWarning_2(amess: Handle_TCollection_HAsciiString, orig: Handle_TCollection_HAsciiString): void;
  AddWarning_3(amess: Standard_CString, orig: Standard_CString): void;
  AddWarning_4(amsg: Message_Msg): void;
  HasWarnings(): Standard_Boolean;
  NbWarnings(): Graphic3d_ZLayerId;
  Warning(num: Graphic3d_ZLayerId, final: Standard_Boolean): Handle_TCollection_HAsciiString;
  CWarning(num: Graphic3d_ZLayerId, final: Standard_Boolean): Standard_CString;
  Warnings(final: Standard_Boolean): Handle_TColStd_HSequenceOfHAsciiString;
  SendMsg(amsg: Message_Msg): void;
  NbInfoMsgs(): Graphic3d_ZLayerId;
  InfoMsg(num: Graphic3d_ZLayerId, final: Standard_Boolean): Handle_TCollection_HAsciiString;
  CInfoMsg(num: Graphic3d_ZLayerId, final: Standard_Boolean): Standard_CString;
  InfoMsgs(final: Standard_Boolean): Handle_TColStd_HSequenceOfHAsciiString;
  Status(): Interface_CheckStatus;
  Complies_1(status: Interface_CheckStatus): Standard_Boolean;
  Complies_2(mess: Handle_TCollection_HAsciiString, incl: Graphic3d_ZLayerId, status: Interface_CheckStatus): Standard_Boolean;
  HasEntity(): Standard_Boolean;
  Entity(): Handle_Standard_Transient;
  Clear(): void;
  ClearFails(): void;
  ClearWarnings(): void;
  ClearInfoMsgs(): void;
  Remove(mess: Handle_TCollection_HAsciiString, incl: Graphic3d_ZLayerId, status: Interface_CheckStatus): Standard_Boolean;
  Mend(pref: Standard_CString, num: Graphic3d_ZLayerId): Standard_Boolean;
  SetEntity(anentity: Handle_Standard_Transient): void;
  GetEntity(anentity: Handle_Standard_Transient): void;
  GetMessages(other: Handle_Interface_Check): void;
  GetAsWarning(other: Handle_Interface_Check, failsonly: Standard_Boolean): void;
  Print(S: Standard_OStream, level: Graphic3d_ZLayerId, final: Graphic3d_ZLayerId): void;
  Trace(level: Graphic3d_ZLayerId, final: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_Check_1 extends Interface_Check {
    constructor();
  }

  export declare class Interface_Check_2 extends Interface_Check {
    constructor(anentity: Handle_Standard_Transient);
  }

export declare class Interface_FloatWriter {
  constructor(chars: Graphic3d_ZLayerId)
  SetFormat(form: Standard_CString, reset: Standard_Boolean): void;
  SetFormatForRange(form: Standard_CString, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose): void;
  SetZeroSuppress(mode: Standard_Boolean): void;
  SetDefaults(chars: Graphic3d_ZLayerId): void;
  Options(zerosup: Standard_Boolean, range: Standard_Boolean, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose): void;
  MainFormat(): Standard_CString;
  FormatForRange(): Standard_CString;
  Write(val: Quantity_AbsorbedDose, text: Standard_CString): Graphic3d_ZLayerId;
  static Convert(val: Quantity_AbsorbedDose, text: Standard_CString, zerosup: Standard_Boolean, Range1: Quantity_AbsorbedDose, Range2: Quantity_AbsorbedDose, mainform: Standard_CString, rangeform: Standard_CString): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Interface_CheckFailure extends Interface_InterfaceError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Interface_CheckFailure;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_CheckFailure_1 extends Interface_CheckFailure {
    constructor();
  }

  export declare class Interface_CheckFailure_2 extends Interface_CheckFailure {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Interface_CheckFailure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_CheckFailure): void;
  get(): Interface_CheckFailure;
  delete(): void;
}

  export declare class Handle_Interface_CheckFailure_1 extends Handle_Interface_CheckFailure {
    constructor();
  }

  export declare class Handle_Interface_CheckFailure_2 extends Handle_Interface_CheckFailure {
    constructor(thePtr: Interface_CheckFailure);
  }

  export declare class Handle_Interface_CheckFailure_3 extends Handle_Interface_CheckFailure {
    constructor(theHandle: Handle_Interface_CheckFailure);
  }

  export declare class Handle_Interface_CheckFailure_4 extends Handle_Interface_CheckFailure {
    constructor(theHandle: Handle_Interface_CheckFailure);
  }

export declare class Interface_Array1OfFileParameter {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Interface_FileParameter): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Interface_Array1OfFileParameter): Interface_Array1OfFileParameter;
  Move(theOther: Interface_Array1OfFileParameter): Interface_Array1OfFileParameter;
  First(): Interface_FileParameter;
  ChangeFirst(): Interface_FileParameter;
  Last(): Interface_FileParameter;
  ChangeLast(): Interface_FileParameter;
  Value(theIndex: Standard_Integer): Interface_FileParameter;
  ChangeValue(theIndex: Standard_Integer): Interface_FileParameter;
  SetValue(theIndex: Standard_Integer, theItem: Interface_FileParameter): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Interface_Array1OfFileParameter_1 extends Interface_Array1OfFileParameter {
    constructor();
  }

  export declare class Interface_Array1OfFileParameter_2 extends Interface_Array1OfFileParameter {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Interface_Array1OfFileParameter_3 extends Interface_Array1OfFileParameter {
    constructor(theOther: Interface_Array1OfFileParameter);
  }

  export declare class Interface_Array1OfFileParameter_4 extends Interface_Array1OfFileParameter {
    constructor(theOther: Interface_Array1OfFileParameter);
  }

  export declare class Interface_Array1OfFileParameter_5 extends Interface_Array1OfFileParameter {
    constructor(theBegin: Interface_FileParameter, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_Interface_SignLabel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_SignLabel): void;
  get(): Interface_SignLabel;
  delete(): void;
}

  export declare class Handle_Interface_SignLabel_1 extends Handle_Interface_SignLabel {
    constructor();
  }

  export declare class Handle_Interface_SignLabel_2 extends Handle_Interface_SignLabel {
    constructor(thePtr: Interface_SignLabel);
  }

  export declare class Handle_Interface_SignLabel_3 extends Handle_Interface_SignLabel {
    constructor(theHandle: Handle_Interface_SignLabel);
  }

  export declare class Handle_Interface_SignLabel_4 extends Handle_Interface_SignLabel {
    constructor(theHandle: Handle_Interface_SignLabel);
  }

export declare class Interface_SignLabel extends MoniTool_SignText {
  constructor()
  Name(): Standard_CString;
  Text(ent: Handle_Standard_Transient, context: Handle_Standard_Transient): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_InterfaceMismatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_InterfaceMismatch): void;
  get(): Interface_InterfaceMismatch;
  delete(): void;
}

  export declare class Handle_Interface_InterfaceMismatch_1 extends Handle_Interface_InterfaceMismatch {
    constructor();
  }

  export declare class Handle_Interface_InterfaceMismatch_2 extends Handle_Interface_InterfaceMismatch {
    constructor(thePtr: Interface_InterfaceMismatch);
  }

  export declare class Handle_Interface_InterfaceMismatch_3 extends Handle_Interface_InterfaceMismatch {
    constructor(theHandle: Handle_Interface_InterfaceMismatch);
  }

  export declare class Handle_Interface_InterfaceMismatch_4 extends Handle_Interface_InterfaceMismatch {
    constructor(theHandle: Handle_Interface_InterfaceMismatch);
  }

export declare class Interface_InterfaceMismatch extends Interface_InterfaceError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Interface_InterfaceMismatch;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_InterfaceMismatch_1 extends Interface_InterfaceMismatch {
    constructor();
  }

  export declare class Interface_InterfaceMismatch_2 extends Interface_InterfaceMismatch {
    constructor(theMessage: Standard_CString);
  }

export declare class Interface_CopyControl extends Standard_Transient {
  Clear(): void;
  Bind(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): void;
  Search(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_CopyControl {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_CopyControl): void;
  get(): Interface_CopyControl;
  delete(): void;
}

  export declare class Handle_Interface_CopyControl_1 extends Handle_Interface_CopyControl {
    constructor();
  }

  export declare class Handle_Interface_CopyControl_2 extends Handle_Interface_CopyControl {
    constructor(thePtr: Interface_CopyControl);
  }

  export declare class Handle_Interface_CopyControl_3 extends Handle_Interface_CopyControl {
    constructor(theHandle: Handle_Interface_CopyControl);
  }

  export declare class Handle_Interface_CopyControl_4 extends Handle_Interface_CopyControl {
    constructor(theHandle: Handle_Interface_CopyControl);
  }

export declare class Interface_MSG {
  Destroy(): void;
  Value(): Standard_CString;
  static Read_1(S: Standard_IStream): Graphic3d_ZLayerId;
  static Read_2(file: Standard_CString): Graphic3d_ZLayerId;
  static Write(S: Standard_OStream, rootkey: Standard_CString): Graphic3d_ZLayerId;
  static IsKey(mess: Standard_CString): Standard_Boolean;
  static Translated(key: Standard_CString): Standard_CString;
  static Record(key: Standard_CString, item: Standard_CString): void;
  static SetTrace(toprint: Standard_Boolean, torecord: Standard_Boolean): void;
  static SetMode(running: Standard_Boolean, raising: Standard_Boolean): void;
  static PrintTrace(S: Standard_OStream): void;
  static Intervalled(val: Quantity_AbsorbedDose, order: Graphic3d_ZLayerId, upper: Standard_Boolean): Quantity_AbsorbedDose;
  static TDate(text: Standard_CString, yy: Graphic3d_ZLayerId, mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId, format: Standard_CString): void;
  static NDate(text: Standard_CString, yy: Graphic3d_ZLayerId, mm: Graphic3d_ZLayerId, dd: Graphic3d_ZLayerId, hh: Graphic3d_ZLayerId, mn: Graphic3d_ZLayerId, ss: Graphic3d_ZLayerId): Standard_Boolean;
  static CDate(text1: Standard_CString, text2: Standard_CString): Graphic3d_ZLayerId;
  static Blanks_1(val: Graphic3d_ZLayerId, max: Graphic3d_ZLayerId): Standard_CString;
  static Blanks_2(val: Standard_CString, max: Graphic3d_ZLayerId): Standard_CString;
  static Blanks_3(count: Graphic3d_ZLayerId): Standard_CString;
  static Print(S: Standard_OStream, val: Standard_CString, max: Graphic3d_ZLayerId, just: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Interface_MSG_1 extends Interface_MSG {
    constructor(key: Standard_CString);
  }

  export declare class Interface_MSG_2 extends Interface_MSG {
    constructor(key: Standard_CString, i1: Graphic3d_ZLayerId);
  }

  export declare class Interface_MSG_3 extends Interface_MSG {
    constructor(key: Standard_CString, i1: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId);
  }

  export declare class Interface_MSG_4 extends Interface_MSG {
    constructor(key: Standard_CString, r1: Quantity_AbsorbedDose, intervals: Graphic3d_ZLayerId);
  }

  export declare class Interface_MSG_5 extends Interface_MSG {
    constructor(key: Standard_CString, str: Standard_CString);
  }

  export declare class Interface_MSG_6 extends Interface_MSG {
    constructor(key: Standard_CString, ival: Graphic3d_ZLayerId, str: Standard_CString);
  }

export declare type Interface_ParamType = {
  Interface_ParamMisc: {};
  Interface_ParamInteger: {};
  Interface_ParamReal: {};
  Interface_ParamIdent: {};
  Interface_ParamVoid: {};
  Interface_ParamText: {};
  Interface_ParamEnum: {};
  Interface_ParamLogical: {};
  Interface_ParamSub: {};
  Interface_ParamHexa: {};
  Interface_ParamBinary: {};
}

export declare class Handle_Interface_InterfaceModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_InterfaceModel): void;
  get(): Interface_InterfaceModel;
  delete(): void;
}

  export declare class Handle_Interface_InterfaceModel_1 extends Handle_Interface_InterfaceModel {
    constructor();
  }

  export declare class Handle_Interface_InterfaceModel_2 extends Handle_Interface_InterfaceModel {
    constructor(thePtr: Interface_InterfaceModel);
  }

  export declare class Handle_Interface_InterfaceModel_3 extends Handle_Interface_InterfaceModel {
    constructor(theHandle: Handle_Interface_InterfaceModel);
  }

  export declare class Handle_Interface_InterfaceModel_4 extends Handle_Interface_InterfaceModel {
    constructor(theHandle: Handle_Interface_InterfaceModel);
  }

export declare class Interface_InterfaceModel extends Standard_Transient {
  Destroy(): void;
  SetProtocol(proto: Handle_Interface_Protocol): void;
  Protocol(): Handle_Interface_Protocol;
  SetGTool(gtool: Handle_Interface_GTool): void;
  GTool(): Handle_Interface_GTool;
  DispatchStatus(): Standard_Boolean;
  Clear(): void;
  ClearEntities(): void;
  ClearLabels(): void;
  ClearHeader(): void;
  NbEntities(): Graphic3d_ZLayerId;
  Contains(anentity: Handle_Standard_Transient): Standard_Boolean;
  Number(anentity: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Value(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  NbTypes(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Type(ent: Handle_Standard_Transient, num: Graphic3d_ZLayerId): Handle_Standard_Type;
  TypeName(ent: Handle_Standard_Transient, complete: Standard_Boolean): Standard_CString;
  static ClassName(typnam: Standard_CString): Standard_CString;
  EntityState(num: Graphic3d_ZLayerId): Interface_DataState;
  IsReportEntity(num: Graphic3d_ZLayerId, semantic: Standard_Boolean): Standard_Boolean;
  ReportEntity(num: Graphic3d_ZLayerId, semantic: Standard_Boolean): Handle_Interface_ReportEntity;
  IsErrorEntity(num: Graphic3d_ZLayerId): Standard_Boolean;
  IsRedefinedContent(num: Graphic3d_ZLayerId): Standard_Boolean;
  ClearReportEntity(num: Graphic3d_ZLayerId): Standard_Boolean;
  SetReportEntity(num: Graphic3d_ZLayerId, rep: Handle_Interface_ReportEntity): Standard_Boolean;
  AddReportEntity(rep: Handle_Interface_ReportEntity, semantic: Standard_Boolean): Standard_Boolean;
  IsUnknownEntity(num: Graphic3d_ZLayerId): Standard_Boolean;
  FillSemanticChecks(checks: Interface_CheckIterator, clear: Standard_Boolean): void;
  HasSemanticChecks(): Standard_Boolean;
  Check(num: Graphic3d_ZLayerId, syntactic: Standard_Boolean): Handle_Interface_Check;
  Reservate(nbent: Graphic3d_ZLayerId): void;
  AddEntity(anentity: Handle_Standard_Transient): void;
  AddWithRefs_1(anent: Handle_Standard_Transient, proto: Handle_Interface_Protocol, level: Graphic3d_ZLayerId, listall: Standard_Boolean): void;
  AddWithRefs_2(anent: Handle_Standard_Transient, level: Graphic3d_ZLayerId, listall: Standard_Boolean): void;
  AddWithRefs_3(anent: Handle_Standard_Transient, lib: Interface_GeneralLib, level: Graphic3d_ZLayerId, listall: Standard_Boolean): void;
  ReplaceEntity(nument: Graphic3d_ZLayerId, anent: Handle_Standard_Transient): void;
  ReverseOrders(after: Graphic3d_ZLayerId): void;
  ChangeOrder(oldnum: Graphic3d_ZLayerId, newnum: Graphic3d_ZLayerId, count: Graphic3d_ZLayerId): void;
  GetFromTransfer(aniter: Interface_EntityIterator): void;
  GetFromAnother(other: Handle_Interface_InterfaceModel): void;
  NewEmptyModel(): Handle_Interface_InterfaceModel;
  SetCategoryNumber(num: Graphic3d_ZLayerId, val: Graphic3d_ZLayerId): Standard_Boolean;
  CategoryNumber(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  FillIterator(iter: Interface_EntityIterator): void;
  Entities(): Interface_EntityIterator;
  Reports(semantic: Standard_Boolean): Interface_EntityIterator;
  Redefineds(): Interface_EntityIterator;
  GlobalCheck(syntactic: Standard_Boolean): Handle_Interface_Check;
  SetGlobalCheck(ach: Handle_Interface_Check): void;
  VerifyCheck(ach: Handle_Interface_Check): void;
  DumpHeader(S: Standard_OStream, level: Graphic3d_ZLayerId): void;
  Print(ent: Handle_Standard_Transient, s: Standard_OStream, mode: Graphic3d_ZLayerId): void;
  PrintLabel(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  PrintToLog(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  StringLabel(ent: Handle_Standard_Transient): Handle_TCollection_HAsciiString;
  NextNumberForLabel(label: Standard_CString, lastnum: Graphic3d_ZLayerId, exact: Standard_Boolean): Graphic3d_ZLayerId;
  static HasTemplate(name: Standard_CString): Standard_Boolean;
  static Template(name: Standard_CString): Handle_Interface_InterfaceModel;
  static SetTemplate(name: Standard_CString, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static ListTemplates(): Handle_TColStd_HSequenceOfHAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_CopyMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_CopyMap): void;
  get(): Interface_CopyMap;
  delete(): void;
}

  export declare class Handle_Interface_CopyMap_1 extends Handle_Interface_CopyMap {
    constructor();
  }

  export declare class Handle_Interface_CopyMap_2 extends Handle_Interface_CopyMap {
    constructor(thePtr: Interface_CopyMap);
  }

  export declare class Handle_Interface_CopyMap_3 extends Handle_Interface_CopyMap {
    constructor(theHandle: Handle_Interface_CopyMap);
  }

  export declare class Handle_Interface_CopyMap_4 extends Handle_Interface_CopyMap {
    constructor(theHandle: Handle_Interface_CopyMap);
  }

export declare class Interface_CopyMap extends Interface_CopyControl {
  constructor(amodel: Handle_Interface_InterfaceModel)
  Clear(): void;
  Model(): Handle_Interface_InterfaceModel;
  Bind(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): void;
  Search(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_HArray1OfHAsciiString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_HArray1OfHAsciiString): void;
  get(): Interface_HArray1OfHAsciiString;
  delete(): void;
}

  export declare class Handle_Interface_HArray1OfHAsciiString_1 extends Handle_Interface_HArray1OfHAsciiString {
    constructor();
  }

  export declare class Handle_Interface_HArray1OfHAsciiString_2 extends Handle_Interface_HArray1OfHAsciiString {
    constructor(thePtr: Interface_HArray1OfHAsciiString);
  }

  export declare class Handle_Interface_HArray1OfHAsciiString_3 extends Handle_Interface_HArray1OfHAsciiString {
    constructor(theHandle: Handle_Interface_HArray1OfHAsciiString);
  }

  export declare class Handle_Interface_HArray1OfHAsciiString_4 extends Handle_Interface_HArray1OfHAsciiString {
    constructor(theHandle: Handle_Interface_HArray1OfHAsciiString);
  }

export declare class Interface_GraphContent extends Interface_EntityIterator {
  GetFromGraph_1(agraph: Interface_Graph): void;
  GetFromGraph_2(agraph: Interface_Graph, stat: Graphic3d_ZLayerId): void;
  Result(): Interface_EntityIterator;
  Begin(): void;
  Evaluate(): void;
  delete(): void;
}

  export declare class Interface_GraphContent_1 extends Interface_GraphContent {
    constructor();
  }

  export declare class Interface_GraphContent_2 extends Interface_GraphContent {
    constructor(agraph: Interface_Graph);
  }

  export declare class Interface_GraphContent_3 extends Interface_GraphContent {
    constructor(agraph: Interface_Graph, stat: Graphic3d_ZLayerId);
  }

  export declare class Interface_GraphContent_4 extends Interface_GraphContent {
    constructor(agraph: Interface_Graph, ent: Handle_Standard_Transient);
  }

export declare class Interface_GeneralLib {
  static SetGlobal(amodule: Handle_Interface_GeneralModule, aprotocol: Handle_Interface_Protocol): void;
  AddProtocol(aprotocol: Handle_Standard_Transient): void;
  Clear(): void;
  SetComplete(): void;
  Select(obj: Handle_Standard_Transient, module: Handle_Interface_GeneralModule, CN: Graphic3d_ZLayerId): Standard_Boolean;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Module(): Handle_Interface_GeneralModule;
  Protocol(): Handle_Interface_Protocol;
  delete(): void;
}

  export declare class Interface_GeneralLib_1 extends Interface_GeneralLib {
    constructor(aprotocol: Handle_Interface_Protocol);
  }

  export declare class Interface_GeneralLib_2 extends Interface_GeneralLib {
    constructor();
  }

export declare class Interface_CheckTool {
  FillCheck(ent: Handle_Standard_Transient, sh: Interface_ShareTool, ach: Handle_Interface_Check): void;
  Print_1(ach: Handle_Interface_Check, S: Standard_OStream): void;
  Print_2(list: Interface_CheckIterator, S: Standard_OStream): void;
  Check(num: Graphic3d_ZLayerId): Handle_Interface_Check;
  CheckSuccess(reset: Standard_Boolean): void;
  CompleteCheckList(): Interface_CheckIterator;
  CheckList(): Interface_CheckIterator;
  AnalyseCheckList(): Interface_CheckIterator;
  VerifyCheckList(): Interface_CheckIterator;
  WarningCheckList(): Interface_CheckIterator;
  UnknownEntities(): Interface_EntityIterator;
  delete(): void;
}

  export declare class Interface_CheckTool_1 extends Interface_CheckTool {
    constructor(model: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol);
  }

  export declare class Interface_CheckTool_2 extends Interface_CheckTool {
    constructor(model: Handle_Interface_InterfaceModel);
  }

  export declare class Interface_CheckTool_3 extends Interface_CheckTool {
    constructor(graph: Interface_Graph);
  }

  export declare class Interface_CheckTool_4 extends Interface_CheckTool {
    constructor(hgraph: Handle_Interface_HGraph);
  }

export declare class Handle_Interface_FileReaderData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_FileReaderData): void;
  get(): Interface_FileReaderData;
  delete(): void;
}

  export declare class Handle_Interface_FileReaderData_1 extends Handle_Interface_FileReaderData {
    constructor();
  }

  export declare class Handle_Interface_FileReaderData_2 extends Handle_Interface_FileReaderData {
    constructor(thePtr: Interface_FileReaderData);
  }

  export declare class Handle_Interface_FileReaderData_3 extends Handle_Interface_FileReaderData {
    constructor(theHandle: Handle_Interface_FileReaderData);
  }

  export declare class Handle_Interface_FileReaderData_4 extends Handle_Interface_FileReaderData {
    constructor(theHandle: Handle_Interface_FileReaderData);
  }

export declare class Interface_IntVal extends Standard_Transient {
  constructor()
  Value(): Graphic3d_ZLayerId;
  CValue(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_IntVal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_IntVal): void;
  get(): Interface_IntVal;
  delete(): void;
}

  export declare class Handle_Interface_IntVal_1 extends Handle_Interface_IntVal {
    constructor();
  }

  export declare class Handle_Interface_IntVal_2 extends Handle_Interface_IntVal {
    constructor(thePtr: Interface_IntVal);
  }

  export declare class Handle_Interface_IntVal_3 extends Handle_Interface_IntVal {
    constructor(theHandle: Handle_Interface_IntVal);
  }

  export declare class Handle_Interface_IntVal_4 extends Handle_Interface_IntVal {
    constructor(theHandle: Handle_Interface_IntVal);
  }

export declare class Handle_Interface_NodeOfGeneralLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_NodeOfGeneralLib): void;
  get(): Interface_NodeOfGeneralLib;
  delete(): void;
}

  export declare class Handle_Interface_NodeOfGeneralLib_1 extends Handle_Interface_NodeOfGeneralLib {
    constructor();
  }

  export declare class Handle_Interface_NodeOfGeneralLib_2 extends Handle_Interface_NodeOfGeneralLib {
    constructor(thePtr: Interface_NodeOfGeneralLib);
  }

  export declare class Handle_Interface_NodeOfGeneralLib_3 extends Handle_Interface_NodeOfGeneralLib {
    constructor(theHandle: Handle_Interface_NodeOfGeneralLib);
  }

  export declare class Handle_Interface_NodeOfGeneralLib_4 extends Handle_Interface_NodeOfGeneralLib {
    constructor(theHandle: Handle_Interface_NodeOfGeneralLib);
  }

export declare class Interface_NodeOfGeneralLib extends Standard_Transient {
  constructor()
  AddNode(anode: Handle_Interface_GlobalNodeOfGeneralLib): void;
  Module(): Handle_Interface_GeneralModule;
  Protocol(): Handle_Interface_Protocol;
  Next(): Handle_Interface_NodeOfGeneralLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Interface_FileParameter {
  constructor()
  Init_1(val: XCAFDoc_PartId, typ: Interface_ParamType): void;
  Init_2(val: Standard_CString, typ: Interface_ParamType): void;
  CValue(): Standard_CString;
  ParamType(): Interface_ParamType;
  SetEntityNumber(num: Graphic3d_ZLayerId): void;
  EntityNumber(): Graphic3d_ZLayerId;
  Clear(): void;
  Destroy(): void;
  delete(): void;
}

export declare class Interface_STAT {
  Internals(tit: Handle_TCollection_HAsciiString, total: Quantity_AbsorbedDose, phn: Handle_TColStd_HSequenceOfAsciiString, phw: Handle_TColStd_HSequenceOfReal, phdeb: Handle_TColStd_HSequenceOfInteger, phfin: Handle_TColStd_HSequenceOfInteger, stw: Handle_TColStd_HSequenceOfReal): void;
  AddPhase(weight: Quantity_AbsorbedDose, name: Standard_CString): void;
  AddStep(weight: Quantity_AbsorbedDose): void;
  Step(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Start(items: Graphic3d_ZLayerId, cycles: Graphic3d_ZLayerId): void;
  static StartCount(items: Graphic3d_ZLayerId, title: Standard_CString): void;
  static NextPhase(items: Graphic3d_ZLayerId, cycles: Graphic3d_ZLayerId): void;
  static SetPhase(items: Graphic3d_ZLayerId, cycles: Graphic3d_ZLayerId): void;
  static NextCycle(items: Graphic3d_ZLayerId): void;
  static NextStep(): void;
  static NextItem(nbitems: Graphic3d_ZLayerId): void;
  static End(): void;
  static Where(phase: Standard_Boolean): Standard_CString;
  static Percent(phase: Standard_Boolean): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Interface_STAT_1 extends Interface_STAT {
    constructor(title: Standard_CString);
  }

  export declare class Interface_STAT_2 extends Interface_STAT {
    constructor(other: Interface_STAT);
  }

export declare class Interface_LineBuffer {
  constructor(size: Graphic3d_ZLayerId)
  SetMax(max: Graphic3d_ZLayerId): void;
  SetInitial(initial: Graphic3d_ZLayerId): void;
  SetKeep(): void;
  CanGet(more: Graphic3d_ZLayerId): Standard_Boolean;
  Content(): Standard_CString;
  Length(): Graphic3d_ZLayerId;
  Clear(): void;
  FreezeInitial(): void;
  Move_1(str: XCAFDoc_PartId): void;
  Move_2(str: Handle_TCollection_HAsciiString): void;
  Moved(): Handle_TCollection_HAsciiString;
  Add_1(text: Standard_CString): void;
  Add_2(text: Standard_CString, lntext: Graphic3d_ZLayerId): void;
  Add_3(text: XCAFDoc_PartId): void;
  Add_4(text: Standard_Character): void;
  delete(): void;
}

export declare class Handle_Interface_SignType {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_SignType): void;
  get(): Interface_SignType;
  delete(): void;
}

  export declare class Handle_Interface_SignType_1 extends Handle_Interface_SignType {
    constructor();
  }

  export declare class Handle_Interface_SignType_2 extends Handle_Interface_SignType {
    constructor(thePtr: Interface_SignType);
  }

  export declare class Handle_Interface_SignType_3 extends Handle_Interface_SignType {
    constructor(theHandle: Handle_Interface_SignType);
  }

  export declare class Handle_Interface_SignType_4 extends Handle_Interface_SignType {
    constructor(theHandle: Handle_Interface_SignType);
  }

export declare class Interface_SignType extends MoniTool_SignText {
  Text(ent: Handle_Standard_Transient, context: Handle_Standard_Transient): XCAFDoc_PartId;
  Value(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  static ClassName(typnam: Standard_CString): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Interface_ShareFlags {
  Model(): Handle_Interface_InterfaceModel;
  IsShared(ent: Handle_Standard_Transient): Standard_Boolean;
  RootEntities(): Interface_EntityIterator;
  NbRoots(): Graphic3d_ZLayerId;
  Root(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  delete(): void;
}

  export declare class Interface_ShareFlags_1 extends Interface_ShareFlags {
    constructor(amodel: Handle_Interface_InterfaceModel, lib: Interface_GeneralLib);
  }

  export declare class Interface_ShareFlags_2 extends Interface_ShareFlags {
    constructor(amodel: Handle_Interface_InterfaceModel, gtool: Handle_Interface_GTool);
  }

  export declare class Interface_ShareFlags_3 extends Interface_ShareFlags {
    constructor(amodel: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol);
  }

  export declare class Interface_ShareFlags_4 extends Interface_ShareFlags {
    constructor(amodel: Handle_Interface_InterfaceModel);
  }

  export declare class Interface_ShareFlags_5 extends Interface_ShareFlags {
    constructor(agraph: Interface_Graph);
  }

export declare class Interface_IndexedMapOfAsciiString extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Interface_IndexedMapOfAsciiString): void;
  Assign(theOther: Interface_IndexedMapOfAsciiString): Interface_IndexedMapOfAsciiString;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: TCollection_AsciiString): Standard_Integer;
  Contains(theKey1: TCollection_AsciiString): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TCollection_AsciiString): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TCollection_AsciiString): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): TCollection_AsciiString;
  FindIndex(theKey1: TCollection_AsciiString): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Interface_IndexedMapOfAsciiString_1 extends Interface_IndexedMapOfAsciiString {
    constructor();
  }

  export declare class Interface_IndexedMapOfAsciiString_2 extends Interface_IndexedMapOfAsciiString {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Interface_IndexedMapOfAsciiString_3 extends Interface_IndexedMapOfAsciiString {
    constructor(theOther: Interface_IndexedMapOfAsciiString);
  }

export declare class Interface_ReaderModule extends Standard_Transient {
  CaseNum(data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Read(casenum: Graphic3d_ZLayerId, data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): void;
  NewRead(casenum: Graphic3d_ZLayerId, data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_ReaderModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_ReaderModule): void;
  get(): Interface_ReaderModule;
  delete(): void;
}

  export declare class Handle_Interface_ReaderModule_1 extends Handle_Interface_ReaderModule {
    constructor();
  }

  export declare class Handle_Interface_ReaderModule_2 extends Handle_Interface_ReaderModule {
    constructor(thePtr: Interface_ReaderModule);
  }

  export declare class Handle_Interface_ReaderModule_3 extends Handle_Interface_ReaderModule {
    constructor(theHandle: Handle_Interface_ReaderModule);
  }

  export declare class Handle_Interface_ReaderModule_4 extends Handle_Interface_ReaderModule {
    constructor(theHandle: Handle_Interface_ReaderModule);
  }

export declare type Interface_CheckStatus = {
  Interface_CheckOK: {};
  Interface_CheckWarning: {};
  Interface_CheckFail: {};
  Interface_CheckAny: {};
  Interface_CheckMessage: {};
  Interface_CheckNoFail: {};
}

export declare class Interface_EntityCluster extends Standard_Transient {
  Append(ent: Handle_Standard_Transient): void;
  Remove_1(ent: Handle_Standard_Transient): Standard_Boolean;
  Remove_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  NbEntities(): Graphic3d_ZLayerId;
  Value(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  SetValue(num: Graphic3d_ZLayerId, ent: Handle_Standard_Transient): void;
  FillIterator(iter: Interface_EntityIterator): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_EntityCluster_1 extends Interface_EntityCluster {
    constructor();
  }

  export declare class Interface_EntityCluster_2 extends Interface_EntityCluster {
    constructor(ent: Handle_Standard_Transient);
  }

  export declare class Interface_EntityCluster_3 extends Interface_EntityCluster {
    constructor(ec: Handle_Interface_EntityCluster);
  }

  export declare class Interface_EntityCluster_4 extends Interface_EntityCluster {
    constructor(ant: Handle_Standard_Transient, ec: Handle_Interface_EntityCluster);
  }

export declare class Handle_Interface_EntityCluster {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_EntityCluster): void;
  get(): Interface_EntityCluster;
  delete(): void;
}

  export declare class Handle_Interface_EntityCluster_1 extends Handle_Interface_EntityCluster {
    constructor();
  }

  export declare class Handle_Interface_EntityCluster_2 extends Handle_Interface_EntityCluster {
    constructor(thePtr: Interface_EntityCluster);
  }

  export declare class Handle_Interface_EntityCluster_3 extends Handle_Interface_EntityCluster {
    constructor(theHandle: Handle_Interface_EntityCluster);
  }

  export declare class Handle_Interface_EntityCluster_4 extends Handle_Interface_EntityCluster {
    constructor(theHandle: Handle_Interface_EntityCluster);
  }

export declare class Handle_Interface_HSequenceOfCheck {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_HSequenceOfCheck): void;
  get(): Interface_HSequenceOfCheck;
  delete(): void;
}

  export declare class Handle_Interface_HSequenceOfCheck_1 extends Handle_Interface_HSequenceOfCheck {
    constructor();
  }

  export declare class Handle_Interface_HSequenceOfCheck_2 extends Handle_Interface_HSequenceOfCheck {
    constructor(thePtr: Interface_HSequenceOfCheck);
  }

  export declare class Handle_Interface_HSequenceOfCheck_3 extends Handle_Interface_HSequenceOfCheck {
    constructor(theHandle: Handle_Interface_HSequenceOfCheck);
  }

  export declare class Handle_Interface_HSequenceOfCheck_4 extends Handle_Interface_HSequenceOfCheck {
    constructor(theHandle: Handle_Interface_HSequenceOfCheck);
  }

export declare class Interface_IntList {
  Initialize(nbe: Graphic3d_ZLayerId): void;
  Internals(nbrefs: Graphic3d_ZLayerId, ents: Handle_TColStd_HArray1OfInteger, refs: Handle_TColStd_HArray1OfInteger): void;
  NbEntities(): Graphic3d_ZLayerId;
  SetNbEntities(nbe: Graphic3d_ZLayerId): void;
  SetNumber(number: Graphic3d_ZLayerId): void;
  Number(): Graphic3d_ZLayerId;
  List(number: Graphic3d_ZLayerId, copied: Standard_Boolean): Interface_IntList;
  SetRedefined(mode: Standard_Boolean): void;
  Reservate(count: Graphic3d_ZLayerId): void;
  Add(ref: Graphic3d_ZLayerId): void;
  Length(): Graphic3d_ZLayerId;
  IsRedefined(num: Graphic3d_ZLayerId): Standard_Boolean;
  Value(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Remove(num: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  AdjustSize(margin: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Interface_IntList_1 extends Interface_IntList {
    constructor();
  }

  export declare class Interface_IntList_2 extends Interface_IntList {
    constructor(nbe: Graphic3d_ZLayerId);
  }

  export declare class Interface_IntList_3 extends Interface_IntList {
    constructor(other: Interface_IntList, copied: Standard_Boolean);
  }

export declare class Interface_Static extends Interface_TypedValue {
  PrintStatic(S: Standard_OStream): void;
  Family(): Standard_CString;
  SetWild(wildcard: Handle_Interface_Static): void;
  Wild(): Handle_Interface_Static;
  SetUptodate(): void;
  UpdatedStatus(): Standard_Boolean;
  static Init_1(family: Standard_CString, name: Standard_CString, type: Interface_ParamType, init: Standard_CString): Standard_Boolean;
  static Init_2(family: Standard_CString, name: Standard_CString, type: Standard_Character, init: Standard_CString): Standard_Boolean;
  static Static(name: Standard_CString): Handle_Interface_Static;
  static IsPresent(name: Standard_CString): Standard_Boolean;
  static CDef(name: Standard_CString, part: Standard_CString): Standard_CString;
  static IDef(name: Standard_CString, part: Standard_CString): Graphic3d_ZLayerId;
  static IsSet(name: Standard_CString, proper: Standard_Boolean): Standard_Boolean;
  static CVal(name: Standard_CString): Standard_CString;
  static IVal(name: Standard_CString): Graphic3d_ZLayerId;
  static RVal(name: Standard_CString): Quantity_AbsorbedDose;
  static SetCVal(name: Standard_CString, val: Standard_CString): Standard_Boolean;
  static SetIVal(name: Standard_CString, val: Graphic3d_ZLayerId): Standard_Boolean;
  static SetRVal(name: Standard_CString, val: Quantity_AbsorbedDose): Standard_Boolean;
  static Update(name: Standard_CString): Standard_Boolean;
  static IsUpdated(name: Standard_CString): Standard_Boolean;
  static Items(mode: Graphic3d_ZLayerId, criter: Standard_CString): Handle_TColStd_HSequenceOfHAsciiString;
  static Standards(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_Static_1 extends Interface_Static {
    constructor(family: Standard_CString, name: Standard_CString, type: Interface_ParamType, init: Standard_CString);
  }

  export declare class Interface_Static_2 extends Interface_Static {
    constructor(family: Standard_CString, name: Standard_CString, other: Handle_Interface_Static);
  }

export declare class Handle_Interface_Static {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_Static): void;
  get(): Interface_Static;
  delete(): void;
}

  export declare class Handle_Interface_Static_1 extends Handle_Interface_Static {
    constructor();
  }

  export declare class Handle_Interface_Static_2 extends Handle_Interface_Static {
    constructor(thePtr: Interface_Static);
  }

  export declare class Handle_Interface_Static_3 extends Handle_Interface_Static {
    constructor(theHandle: Handle_Interface_Static);
  }

  export declare class Handle_Interface_Static_4 extends Handle_Interface_Static {
    constructor(theHandle: Handle_Interface_Static);
  }

export declare class Handle_Interface_GlobalNodeOfReaderLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_GlobalNodeOfReaderLib): void;
  get(): Interface_GlobalNodeOfReaderLib;
  delete(): void;
}

  export declare class Handle_Interface_GlobalNodeOfReaderLib_1 extends Handle_Interface_GlobalNodeOfReaderLib {
    constructor();
  }

  export declare class Handle_Interface_GlobalNodeOfReaderLib_2 extends Handle_Interface_GlobalNodeOfReaderLib {
    constructor(thePtr: Interface_GlobalNodeOfReaderLib);
  }

  export declare class Handle_Interface_GlobalNodeOfReaderLib_3 extends Handle_Interface_GlobalNodeOfReaderLib {
    constructor(theHandle: Handle_Interface_GlobalNodeOfReaderLib);
  }

  export declare class Handle_Interface_GlobalNodeOfReaderLib_4 extends Handle_Interface_GlobalNodeOfReaderLib {
    constructor(theHandle: Handle_Interface_GlobalNodeOfReaderLib);
  }

export declare class Interface_GlobalNodeOfReaderLib extends Standard_Transient {
  constructor()
  Add(amodule: Handle_Interface_ReaderModule, aprotocol: Handle_Interface_Protocol): void;
  Module(): Handle_Interface_ReaderModule;
  Protocol(): Handle_Interface_Protocol;
  Next(): Handle_Interface_GlobalNodeOfReaderLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Interface_GTool extends Standard_Transient {
  SetSignType(sign: Handle_Interface_SignType): void;
  SignType(): Handle_Interface_SignType;
  SignValue(ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_CString;
  SignName(): Standard_CString;
  SetProtocol(proto: Handle_Interface_Protocol, enforce: Standard_Boolean): void;
  Protocol(): Handle_Interface_Protocol;
  Lib(): Interface_GeneralLib;
  Reservate(nb: Graphic3d_ZLayerId, enforce: Standard_Boolean): void;
  ClearEntities(): void;
  Select(ent: Handle_Standard_Transient, gmod: Handle_Interface_GeneralModule, CN: Graphic3d_ZLayerId, enforce: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Interface_GTool_1 extends Interface_GTool {
    constructor();
  }

  export declare class Interface_GTool_2 extends Interface_GTool {
    constructor(proto: Handle_Interface_Protocol, nbent: Graphic3d_ZLayerId);
  }

export declare class Handle_Interface_GTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_GTool): void;
  get(): Interface_GTool;
  delete(): void;
}

  export declare class Handle_Interface_GTool_1 extends Handle_Interface_GTool {
    constructor();
  }

  export declare class Handle_Interface_GTool_2 extends Handle_Interface_GTool {
    constructor(thePtr: Interface_GTool);
  }

  export declare class Handle_Interface_GTool_3 extends Handle_Interface_GTool {
    constructor(theHandle: Handle_Interface_GTool);
  }

  export declare class Handle_Interface_GTool_4 extends Handle_Interface_GTool {
    constructor(theHandle: Handle_Interface_GTool);
  }

export declare class Interface_ParamSet extends Standard_Transient {
  constructor(nres: Graphic3d_ZLayerId, nst: Graphic3d_ZLayerId)
  Append_1(val: Standard_CString, lnval: Graphic3d_ZLayerId, typ: Interface_ParamType, nument: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Append_2(FP: Interface_FileParameter): Graphic3d_ZLayerId;
  NbParams(): Graphic3d_ZLayerId;
  Param(num: Graphic3d_ZLayerId): Interface_FileParameter;
  ChangeParam(num: Graphic3d_ZLayerId): Interface_FileParameter;
  SetParam(num: Graphic3d_ZLayerId, FP: Interface_FileParameter): void;
  Params(num: Graphic3d_ZLayerId, nb: Graphic3d_ZLayerId): Handle_Interface_ParamList;
  Destroy(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_ParamSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_ParamSet): void;
  get(): Interface_ParamSet;
  delete(): void;
}

  export declare class Handle_Interface_ParamSet_1 extends Handle_Interface_ParamSet {
    constructor();
  }

  export declare class Handle_Interface_ParamSet_2 extends Handle_Interface_ParamSet {
    constructor(thePtr: Interface_ParamSet);
  }

  export declare class Handle_Interface_ParamSet_3 extends Handle_Interface_ParamSet {
    constructor(theHandle: Handle_Interface_ParamSet);
  }

  export declare class Handle_Interface_ParamSet_4 extends Handle_Interface_ParamSet {
    constructor(theHandle: Handle_Interface_ParamSet);
  }

export declare class Handle_Interface_TypedValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_TypedValue): void;
  get(): Interface_TypedValue;
  delete(): void;
}

  export declare class Handle_Interface_TypedValue_1 extends Handle_Interface_TypedValue {
    constructor();
  }

  export declare class Handle_Interface_TypedValue_2 extends Handle_Interface_TypedValue {
    constructor(thePtr: Interface_TypedValue);
  }

  export declare class Handle_Interface_TypedValue_3 extends Handle_Interface_TypedValue {
    constructor(theHandle: Handle_Interface_TypedValue);
  }

  export declare class Handle_Interface_TypedValue_4 extends Handle_Interface_TypedValue {
    constructor(theHandle: Handle_Interface_TypedValue);
  }

export declare class Interface_TypedValue extends MoniTool_TypedValue {
  constructor(name: Standard_CString, type: Interface_ParamType, init: Standard_CString)
  Type(): Interface_ParamType;
  static ParamTypeToValueType(typ: Interface_ParamType): MoniTool_ValueType;
  static ValueTypeToParamType(typ: MoniTool_ValueType): Interface_ParamType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Interface_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Interface_GeneralModule): void;
  get(): Interface_GeneralModule;
  delete(): void;
}

  export declare class Handle_Interface_GeneralModule_1 extends Handle_Interface_GeneralModule {
    constructor();
  }

  export declare class Handle_Interface_GeneralModule_2 extends Handle_Interface_GeneralModule {
    constructor(thePtr: Interface_GeneralModule);
  }

  export declare class Handle_Interface_GeneralModule_3 extends Handle_Interface_GeneralModule {
    constructor(theHandle: Handle_Interface_GeneralModule);
  }

  export declare class Handle_Interface_GeneralModule_4 extends Handle_Interface_GeneralModule {
    constructor(theHandle: Handle_Interface_GeneralModule);
  }

export declare class Interface_ReaderLib {
  static SetGlobal(amodule: Handle_Interface_ReaderModule, aprotocol: Handle_Interface_Protocol): void;
  AddProtocol(aprotocol: Handle_Standard_Transient): void;
  Clear(): void;
  SetComplete(): void;
  Select(obj: Handle_Standard_Transient, module: Handle_Interface_ReaderModule, CN: Graphic3d_ZLayerId): Standard_Boolean;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Module(): Handle_Interface_ReaderModule;
  Protocol(): Handle_Interface_Protocol;
  delete(): void;
}

  export declare class Interface_ReaderLib_1 extends Interface_ReaderLib {
    constructor(aprotocol: Handle_Interface_Protocol);
  }

  export declare class Interface_ReaderLib_2 extends Interface_ReaderLib {
    constructor();
  }

export declare class V3d_Viewer extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IfMoreViews(): Standard_Boolean;
  CreateView(): Handle_V3d_View;
  SetViewOn_1(): void;
  SetViewOn_2(theView: Handle_V3d_View): void;
  SetViewOff_1(): void;
  SetViewOff_2(theView: Handle_V3d_View): void;
  Update(): void;
  Redraw(): void;
  RedrawImmediate(): void;
  Invalidate(): void;
  Remove(): void;
  Driver(): Handle_Graphic3d_GraphicDriver;
  StructureManager(): Handle_Graphic3d_StructureManager;
  DefaultRenderingParams(): Graphic3d_RenderingParams;
  SetDefaultRenderingParams(theParams: Graphic3d_RenderingParams): void;
  SetDefaultBackgroundColor_1(theColor: Quantity_Color): void;
  GetGradientBackground(): Aspect_GradientBackground;
  SetDefaultBgGradientColors(theColor1: Quantity_Color, theColor2: Quantity_Color, theFillStyle: Aspect_GradientFillMethod): void;
  DefaultViewSize(): Quantity_AbsorbedDose;
  SetDefaultViewSize(theSize: Quantity_AbsorbedDose): void;
  DefaultViewProj(): V3d_TypeOfOrientation;
  SetDefaultViewProj(theOrientation: V3d_TypeOfOrientation): void;
  DefaultVisualization(): V3d_TypeOfVisualization;
  SetDefaultVisualization(theType: V3d_TypeOfVisualization): void;
  DefaultShadingModel(): V3d_TypeOfShadingModel;
  SetDefaultShadingModel(theType: V3d_TypeOfShadingModel): void;
  DefaultTypeOfView(): V3d_TypeOfView;
  SetDefaultTypeOfView(theType: V3d_TypeOfView): void;
  DefaultBackgroundColor_1(): Quantity_Color;
  DefaultBgGradientColors(theColor1: Quantity_Color, theColor2: Quantity_Color): void;
  GetAllZLayers(theLayerSeq: TColStd_SequenceOfInteger): void;
  AddZLayer(theLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings): Standard_Boolean;
  InsertLayerBefore(theNewLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings, theLayerAfter: Graphic3d_ZLayerId): Standard_Boolean;
  InsertLayerAfter(theNewLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings, theLayerBefore: Graphic3d_ZLayerId): Standard_Boolean;
  RemoveZLayer(theLayerId: Graphic3d_ZLayerId): Standard_Boolean;
  ZLayerSettings(theLayerId: Graphic3d_ZLayerId): Graphic3d_ZLayerSettings;
  SetZLayerSettings(theLayerId: Graphic3d_ZLayerId, theSettings: Graphic3d_ZLayerSettings): void;
  ActiveViews(): V3d_ListOfView;
  ActiveViewIterator(): V3d_ListOfViewIterator;
  LastActiveView(): Standard_Boolean;
  DefinedViews(): V3d_ListOfView;
  DefinedViewIterator(): V3d_ListOfViewIterator;
  SetDefaultLights(): void;
  SetLightOn_1(theLight: any): void;
  SetLightOn_2(): void;
  SetLightOff_1(theLight: any): void;
  SetLightOff_2(): void;
  AddLight(theLight: any): void;
  DelLight(theLight: any): void;
  UpdateLights(): void;
  IsGlobalLight(TheLight: any): Standard_Boolean;
  ActiveLights(): V3d_ListOfLight;
  ActiveLightIterator(): V3d_ListOfLightIterator;
  DefinedLights(): V3d_ListOfLight;
  DefinedLightIterator(): V3d_ListOfLightIterator;
  Erase(): void;
  UnHighlight(): void;
  ComputedMode(): Standard_Boolean;
  SetComputedMode(theMode: Standard_Boolean): void;
  DefaultComputedMode(): Standard_Boolean;
  SetDefaultComputedMode(theMode: Standard_Boolean): void;
  PrivilegedPlane(): gp_Ax3;
  SetPrivilegedPlane(thePlane: gp_Ax3): void;
  DisplayPrivilegedPlane(theOnOff: Standard_Boolean, theSize: Quantity_AbsorbedDose): void;
  ActivateGrid(aGridType: Aspect_GridType, aGridDrawMode: Aspect_GridDrawMode): void;
  DeactivateGrid(): void;
  SetGridEcho_1(showGrid: Standard_Boolean): void;
  SetGridEcho_2(aMarker: Handle_Graphic3d_AspectMarker3d): void;
  GridEcho(): Standard_Boolean;
  IsActive(): Standard_Boolean;
  Grid(): Handle_Aspect_Grid;
  GridType(): Aspect_GridType;
  GridDrawMode(): Aspect_GridDrawMode;
  RectangularGridValues(XOrigin: Quantity_AbsorbedDose, YOrigin: Quantity_AbsorbedDose, XStep: Quantity_AbsorbedDose, YStep: Quantity_AbsorbedDose, RotationAngle: Quantity_AbsorbedDose): void;
  SetRectangularGridValues(XOrigin: Quantity_AbsorbedDose, YOrigin: Quantity_AbsorbedDose, XStep: Quantity_AbsorbedDose, YStep: Quantity_AbsorbedDose, RotationAngle: Quantity_AbsorbedDose): void;
  CircularGridValues(XOrigin: Quantity_AbsorbedDose, YOrigin: Quantity_AbsorbedDose, RadiusStep: Quantity_AbsorbedDose, DivisionNumber: Graphic3d_ZLayerId, RotationAngle: Quantity_AbsorbedDose): void;
  SetCircularGridValues(XOrigin: Quantity_AbsorbedDose, YOrigin: Quantity_AbsorbedDose, RadiusStep: Quantity_AbsorbedDose, DivisionNumber: Graphic3d_ZLayerId, RotationAngle: Quantity_AbsorbedDose): void;
  CircularGridGraphicValues(Radius: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  SetCircularGridGraphicValues(Radius: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  RectangularGridGraphicValues(XSize: Quantity_AbsorbedDose, YSize: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  SetRectangularGridGraphicValues(XSize: Quantity_AbsorbedDose, YSize: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  ShowGridEcho(theView: Handle_V3d_View, thePoint: Graphic3d_Vertex): void;
  HideGridEcho(theView: Handle_V3d_View): void;
  SetDefaultBackgroundColor_2(theType: Quantity_TypeOfColor, theV1: Quantity_AbsorbedDose, theV2: Quantity_AbsorbedDose, theV3: Quantity_AbsorbedDose): void;
  DefaultBackgroundColor_2(theType: Quantity_TypeOfColor, theV1: Quantity_AbsorbedDose, theV2: Quantity_AbsorbedDose, theV3: Quantity_AbsorbedDose): void;
  InitActiveViews(): void;
  MoreActiveViews(): Standard_Boolean;
  NextActiveViews(): void;
  ActiveView(): Handle_V3d_View;
  InitDefinedViews(): void;
  MoreDefinedViews(): Standard_Boolean;
  NextDefinedViews(): void;
  DefinedView(): Handle_V3d_View;
  InitActiveLights(): void;
  MoreActiveLights(): Standard_Boolean;
  NextActiveLights(): void;
  ActiveLight(): any;
  InitDefinedLights(): void;
  MoreDefinedLights(): Standard_Boolean;
  NextDefinedLights(): void;
  DefinedLight(): any;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class V3d_Viewer_1 extends V3d_Viewer {
    constructor(theDriver: Handle_Graphic3d_GraphicDriver);
  }

  export declare class V3d_Viewer_2 extends V3d_Viewer {
    constructor(theDriver: Handle_Graphic3d_GraphicDriver, theName: Standard_ExtString, theDomain: Standard_CString, theViewSize: Quantity_AbsorbedDose, theViewProj: V3d_TypeOfOrientation, theViewBackground: Quantity_Color, theVisualization: V3d_TypeOfVisualization, theShadingModel: V3d_TypeOfShadingModel, theComputedMode: Standard_Boolean, theDefaultComputedMode: Standard_Boolean);
  }

export declare class Handle_V3d_Viewer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_Viewer): void;
  get(): V3d_Viewer;
  delete(): void;
}

  export declare class Handle_V3d_Viewer_1 extends Handle_V3d_Viewer {
    constructor();
  }

  export declare class Handle_V3d_Viewer_2 extends Handle_V3d_Viewer {
    constructor(thePtr: V3d_Viewer);
  }

  export declare class Handle_V3d_Viewer_3 extends Handle_V3d_Viewer {
    constructor(theHandle: Handle_V3d_Viewer);
  }

  export declare class Handle_V3d_Viewer_4 extends Handle_V3d_Viewer {
    constructor(theHandle: Handle_V3d_Viewer);
  }

export declare class V3d {
  constructor();
  static GetProjAxis(theOrientation: V3d_TypeOfOrientation): gp_Dir;
  static ArrowOfRadius(garrow: Handle_Graphic3d_Group, X0: Quantity_AbsorbedDose, Y0: Quantity_AbsorbedDose, Z0: Quantity_AbsorbedDose, DX: Quantity_AbsorbedDose, DY: Quantity_AbsorbedDose, DZ: Quantity_AbsorbedDose, Alpha: Quantity_AbsorbedDose, Lng: Quantity_AbsorbedDose): void;
  static CircleInPlane(gcircle: Handle_Graphic3d_Group, X0: Quantity_AbsorbedDose, Y0: Quantity_AbsorbedDose, Z0: Quantity_AbsorbedDose, VX: Quantity_AbsorbedDose, VY: Quantity_AbsorbedDose, VZ: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose): void;
  static SwitchViewsinWindow(aPreviousView: Handle_V3d_View, aNextView: Handle_V3d_View): void;
  static TypeOfOrientationToString(theType: V3d_TypeOfOrientation): Standard_CString;
  static TypeOfOrientationFromString_1(theTypeString: Standard_CString): V3d_TypeOfOrientation;
  static TypeOfOrientationFromString_2(theTypeString: Standard_CString, theType: V3d_TypeOfOrientation): Standard_Boolean;
  delete(): void;
}

export declare class V3d_BadValue extends Standard_OutOfRange {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_V3d_BadValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class V3d_BadValue_1 extends V3d_BadValue {
    constructor();
  }

  export declare class V3d_BadValue_2 extends V3d_BadValue {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_V3d_BadValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_BadValue): void;
  get(): V3d_BadValue;
  delete(): void;
}

  export declare class Handle_V3d_BadValue_1 extends Handle_V3d_BadValue {
    constructor();
  }

  export declare class Handle_V3d_BadValue_2 extends Handle_V3d_BadValue {
    constructor(thePtr: V3d_BadValue);
  }

  export declare class Handle_V3d_BadValue_3 extends Handle_V3d_BadValue {
    constructor(theHandle: Handle_V3d_BadValue);
  }

  export declare class Handle_V3d_BadValue_4 extends Handle_V3d_BadValue {
    constructor(theHandle: Handle_V3d_BadValue);
  }

export declare class Handle_V3d_PositionLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_PositionLight): void;
  get(): V3d_PositionLight;
  delete(): void;
}

  export declare class Handle_V3d_PositionLight_1 extends Handle_V3d_PositionLight {
    constructor();
  }

  export declare class Handle_V3d_PositionLight_2 extends Handle_V3d_PositionLight {
    constructor(thePtr: V3d_PositionLight);
  }

  export declare class Handle_V3d_PositionLight_3 extends Handle_V3d_PositionLight {
    constructor(theHandle: Handle_V3d_PositionLight);
  }

  export declare class Handle_V3d_PositionLight_4 extends Handle_V3d_PositionLight {
    constructor(theHandle: Handle_V3d_PositionLight);
  }

export declare class V3d_PositionLight extends Graphic3d_CLight {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class V3d_ImageDumpOptions {
  constructor()
  delete(): void;
}

export declare class V3d_Plane extends Standard_Transient {
  constructor(theA: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose, theC: Quantity_AbsorbedDose, theD: Quantity_AbsorbedDose)
  SetPlane(theA: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose, theC: Quantity_AbsorbedDose, theD: Quantity_AbsorbedDose): void;
  Display(theView: Handle_V3d_View, theColor: Quantity_Color): void;
  Erase(): void;
  Plane(theA: Quantity_AbsorbedDose, theB: Quantity_AbsorbedDose, theC: Quantity_AbsorbedDose, theD: Quantity_AbsorbedDose): void;
  IsDisplayed(): Standard_Boolean;
  ClipPlane(): Handle_Graphic3d_ClipPlane;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_V3d_Plane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_Plane): void;
  get(): V3d_Plane;
  delete(): void;
}

  export declare class Handle_V3d_Plane_1 extends Handle_V3d_Plane {
    constructor();
  }

  export declare class Handle_V3d_Plane_2 extends Handle_V3d_Plane {
    constructor(thePtr: V3d_Plane);
  }

  export declare class Handle_V3d_Plane_3 extends Handle_V3d_Plane {
    constructor(theHandle: Handle_V3d_Plane);
  }

  export declare class Handle_V3d_Plane_4 extends Handle_V3d_Plane {
    constructor(theHandle: Handle_V3d_Plane);
  }

export declare type V3d_TypeOfAxe = {
  V3d_X: {};
  V3d_Y: {};
  V3d_Z: {};
}

export declare type V3d_StereoDumpOptions = {
  V3d_SDO_MONO: {};
  V3d_SDO_LEFT_EYE: {};
  V3d_SDO_RIGHT_EYE: {};
  V3d_SDO_BLENDED: {};
}

export declare type V3d_TypeOfPickLight = {
  V3d_POSITIONLIGHT: {};
  V3d_SPACELIGHT: {};
  V3d_RADIUSTEXTLIGHT: {};
  V3d_ExtRADIUSLIGHT: {};
  V3d_IntRADIUSLIGHT: {};
  V3d_NOTHING: {};
}

export declare type V3d_TypeOfVisualization = {
  V3d_WIREFRAME: {};
  V3d_ZBUFFER: {};
}

export declare class Handle_V3d_SpotLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_SpotLight): void;
  get(): V3d_SpotLight;
  delete(): void;
}

  export declare class Handle_V3d_SpotLight_1 extends Handle_V3d_SpotLight {
    constructor();
  }

  export declare class Handle_V3d_SpotLight_2 extends Handle_V3d_SpotLight {
    constructor(thePtr: V3d_SpotLight);
  }

  export declare class Handle_V3d_SpotLight_3 extends Handle_V3d_SpotLight {
    constructor(theHandle: Handle_V3d_SpotLight);
  }

  export declare class Handle_V3d_SpotLight_4 extends Handle_V3d_SpotLight {
    constructor(theHandle: Handle_V3d_SpotLight);
  }

export declare class V3d_SpotLight extends V3d_PositionLight {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetDirection_1(theOrientation: V3d_TypeOfOrientation): void;
  SetDirection_2(theDir: gp_Dir): void;
  SetDirection_3(theVx: Quantity_AbsorbedDose, theVy: Quantity_AbsorbedDose, theVz: Quantity_AbsorbedDose): void;
  Position_1(): gp_Pnt;
  Position_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  SetPosition_1(thePosition: gp_Pnt): void;
  SetPosition_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class V3d_SpotLight_1 extends V3d_SpotLight {
    constructor(thePos: gp_Pnt, theDirection: V3d_TypeOfOrientation, theColor: Quantity_Color);
  }

  export declare class V3d_SpotLight_2 extends V3d_SpotLight {
    constructor(thePos: gp_Pnt, theDirection: gp_Dir, theColor: Quantity_Color);
  }

export declare class V3d_RectangularGrid extends Aspect_RectangularGrid {
  constructor(aViewer: V3d_ViewerPointer, aColor: Quantity_Color, aTenthColor: Quantity_Color)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColors(aColor: Quantity_Color, aTenthColor: Quantity_Color): void;
  Display(): void;
  Erase(): void;
  IsDisplayed(): Standard_Boolean;
  GraphicValues(XSize: Quantity_AbsorbedDose, YSize: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  SetGraphicValues(XSize: Quantity_AbsorbedDose, YSize: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_V3d_RectangularGrid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_RectangularGrid): void;
  get(): V3d_RectangularGrid;
  delete(): void;
}

  export declare class Handle_V3d_RectangularGrid_1 extends Handle_V3d_RectangularGrid {
    constructor();
  }

  export declare class Handle_V3d_RectangularGrid_2 extends Handle_V3d_RectangularGrid {
    constructor(thePtr: V3d_RectangularGrid);
  }

  export declare class Handle_V3d_RectangularGrid_3 extends Handle_V3d_RectangularGrid {
    constructor(theHandle: Handle_V3d_RectangularGrid);
  }

  export declare class Handle_V3d_RectangularGrid_4 extends Handle_V3d_RectangularGrid {
    constructor(theHandle: Handle_V3d_RectangularGrid);
  }

export declare type V3d_TypeOfPickCamera = {
  V3d_POSITIONCAMERA: {};
  V3d_SPACECAMERA: {};
  V3d_RADIUSTEXTCAMERA: {};
  V3d_ExtRADIUSCAMERA: {};
  V3d_IntRADIUSCAMERA: {};
  V3d_NOTHINGCAMERA: {};
}

export declare class V3d_PositionalLight extends V3d_PositionLight {
  constructor(thePos: gp_Pnt, theColor: Quantity_Color)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_V3d_PositionalLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_PositionalLight): void;
  get(): V3d_PositionalLight;
  delete(): void;
}

  export declare class Handle_V3d_PositionalLight_1 extends Handle_V3d_PositionalLight {
    constructor();
  }

  export declare class Handle_V3d_PositionalLight_2 extends Handle_V3d_PositionalLight {
    constructor(thePtr: V3d_PositionalLight);
  }

  export declare class Handle_V3d_PositionalLight_3 extends Handle_V3d_PositionalLight {
    constructor(theHandle: Handle_V3d_PositionalLight);
  }

  export declare class Handle_V3d_PositionalLight_4 extends Handle_V3d_PositionalLight {
    constructor(theHandle: Handle_V3d_PositionalLight);
  }

export declare class Handle_V3d_UnMapped {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_UnMapped): void;
  get(): V3d_UnMapped;
  delete(): void;
}

  export declare class Handle_V3d_UnMapped_1 extends Handle_V3d_UnMapped {
    constructor();
  }

  export declare class Handle_V3d_UnMapped_2 extends Handle_V3d_UnMapped {
    constructor(thePtr: V3d_UnMapped);
  }

  export declare class Handle_V3d_UnMapped_3 extends Handle_V3d_UnMapped {
    constructor(theHandle: Handle_V3d_UnMapped);
  }

  export declare class Handle_V3d_UnMapped_4 extends Handle_V3d_UnMapped {
    constructor(theHandle: Handle_V3d_UnMapped);
  }

export declare class V3d_UnMapped extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_V3d_UnMapped;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class V3d_UnMapped_1 extends V3d_UnMapped {
    constructor();
  }

  export declare class V3d_UnMapped_2 extends V3d_UnMapped {
    constructor(theMessage: Standard_CString);
  }

export declare class V3d_AmbientLight extends Graphic3d_CLight {
  constructor(theColor: Quantity_Color)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_V3d_AmbientLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_AmbientLight): void;
  get(): V3d_AmbientLight;
  delete(): void;
}

  export declare class Handle_V3d_AmbientLight_1 extends Handle_V3d_AmbientLight {
    constructor();
  }

  export declare class Handle_V3d_AmbientLight_2 extends Handle_V3d_AmbientLight {
    constructor(thePtr: V3d_AmbientLight);
  }

  export declare class Handle_V3d_AmbientLight_3 extends Handle_V3d_AmbientLight {
    constructor(theHandle: Handle_V3d_AmbientLight);
  }

  export declare class Handle_V3d_AmbientLight_4 extends Handle_V3d_AmbientLight {
    constructor(theHandle: Handle_V3d_AmbientLight);
  }

export declare class Handle_V3d_View {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_View): void;
  get(): V3d_View;
  delete(): void;
}

  export declare class Handle_V3d_View_1 extends Handle_V3d_View {
    constructor();
  }

  export declare class Handle_V3d_View_2 extends Handle_V3d_View {
    constructor(thePtr: V3d_View);
  }

  export declare class Handle_V3d_View_3 extends Handle_V3d_View {
    constructor(theHandle: Handle_V3d_View);
  }

  export declare class Handle_V3d_View_4 extends Handle_V3d_View {
    constructor(theHandle: Handle_V3d_View);
  }

export declare class V3d_View extends Standard_Transient {
  SetWindow(theWindow: Handle_Aspect_Window, theContext: Aspect_RenderingContext): void;
  SetMagnify(theWindow: Handle_Aspect_Window, thePreviousView: Handle_V3d_View, theX1: Graphic3d_ZLayerId, theY1: Graphic3d_ZLayerId, theX2: Graphic3d_ZLayerId, theY2: Graphic3d_ZLayerId): void;
  Remove(): void;
  Update(): void;
  Redraw(): void;
  RedrawImmediate(): void;
  Invalidate(): void;
  IsInvalidated(): Standard_Boolean;
  IsInvalidatedImmediate(): Standard_Boolean;
  InvalidateImmediate(): void;
  MustBeResized(): void;
  DoMapping(): void;
  IsEmpty(): Standard_Boolean;
  UpdateLights(): void;
  SetAutoZFitMode(theIsOn: Standard_Boolean, theScaleFactor: Quantity_AbsorbedDose): void;
  AutoZFitMode(): Standard_Boolean;
  AutoZFitScaleFactor(): Quantity_AbsorbedDose;
  AutoZFit(): void;
  ZFitAll(theScaleFactor: Quantity_AbsorbedDose): void;
  SetBackgroundColor_1(theType: Quantity_TypeOfColor, theV1: Quantity_AbsorbedDose, theV2: Quantity_AbsorbedDose, theV3: Quantity_AbsorbedDose): void;
  SetBackgroundColor_2(theColor: Quantity_Color): void;
  SetBgGradientColors(theColor1: Quantity_Color, theColor2: Quantity_Color, theFillStyle: Aspect_GradientFillMethod, theToUpdate: Standard_Boolean): void;
  SetBgGradientStyle(theMethod: Aspect_GradientFillMethod, theToUpdate: Standard_Boolean): void;
  SetBackgroundImage_1(theFileName: Standard_CString, theFillStyle: Aspect_FillMethod, theToUpdate: Standard_Boolean): void;
  SetBackgroundImage_2(theTexture: Handle_Graphic3d_Texture2D, theFillStyle: Aspect_FillMethod, theToUpdate: Standard_Boolean): void;
  SetBgImageStyle(theFillStyle: Aspect_FillMethod, theToUpdate: Standard_Boolean): void;
  SetBackgroundCubeMap(theCubeMap: Handle_Graphic3d_CubeMap, theToUpdatePBREnv: Standard_Boolean, theToUpdate: Standard_Boolean): void;
  GeneratePBREnvironment(theToUpdate: Standard_Boolean): void;
  ClearPBREnvironment(theToUpdate: Standard_Boolean): void;
  SetAxis(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Vx: Quantity_AbsorbedDose, Vy: Quantity_AbsorbedDose, Vz: Quantity_AbsorbedDose): void;
  SetShadingModel(theShadingModel: V3d_TypeOfShadingModel): void;
  SetTextureEnv(theTexture: Handle_Graphic3d_TextureEnv): void;
  SetVisualization(theType: V3d_TypeOfVisualization): void;
  SetLightOn_1(theLight: any): void;
  SetLightOn_2(): void;
  SetLightOff_1(theLight: any): void;
  SetLightOff_2(): void;
  IsActiveLight(theLight: any): Standard_Boolean;
  SetImmediateUpdate(theImmediateUpdate: Standard_Boolean): Standard_Boolean;
  ZBufferTriedronSetup(theXColor: Quantity_Color, theYColor: Quantity_Color, theZColor: Quantity_Color, theSizeRatio: Quantity_AbsorbedDose, theAxisDiametr: Quantity_AbsorbedDose, theNbFacettes: Graphic3d_ZLayerId): void;
  TriedronDisplay(thePosition: Aspect_TypeOfTriedronPosition, theColor: Quantity_Color, theScale: Quantity_AbsorbedDose, theMode: V3d_TypeOfVisualization): void;
  TriedronErase(): void;
  GetGraduatedTrihedron(): Graphic3d_GraduatedTrihedron;
  GraduatedTrihedronDisplay(theTrihedronData: Graphic3d_GraduatedTrihedron): void;
  GraduatedTrihedronErase(): void;
  SetFront(): void;
  Rotate_1(Ax: Quantity_AbsorbedDose, Ay: Quantity_AbsorbedDose, Az: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Rotate_2(Ax: Quantity_AbsorbedDose, Ay: Quantity_AbsorbedDose, Az: Quantity_AbsorbedDose, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Rotate_3(Axe: V3d_TypeOfAxe, Angle: Quantity_AbsorbedDose, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Rotate_4(Axe: V3d_TypeOfAxe, Angle: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Rotate_5(Angle: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Move_1(Dx: Quantity_AbsorbedDose, Dy: Quantity_AbsorbedDose, Dz: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Move_2(Axe: V3d_TypeOfAxe, Length: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Move_3(Length: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Translate_1(Dx: Quantity_AbsorbedDose, Dy: Quantity_AbsorbedDose, Dz: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Translate_2(Axe: V3d_TypeOfAxe, Length: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Translate_3(Length: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Place(theXp: Graphic3d_ZLayerId, theYp: Graphic3d_ZLayerId, theZoomFactor: Quantity_AbsorbedDose): void;
  Turn_1(Ax: Quantity_AbsorbedDose, Ay: Quantity_AbsorbedDose, Az: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Turn_2(Axe: V3d_TypeOfAxe, Angle: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  Turn_3(Angle: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  SetTwist(Angle: Quantity_AbsorbedDose): void;
  SetEye(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetDepth(Depth: Quantity_AbsorbedDose): void;
  SetProj_1(Vx: Quantity_AbsorbedDose, Vy: Quantity_AbsorbedDose, Vz: Quantity_AbsorbedDose): void;
  SetProj_2(theOrientation: V3d_TypeOfOrientation, theIsYup: Standard_Boolean): void;
  SetAt(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetUp_1(Vx: Quantity_AbsorbedDose, Vy: Quantity_AbsorbedDose, Vz: Quantity_AbsorbedDose): void;
  SetUp_2(Orientation: V3d_TypeOfOrientation): void;
  SetViewOrientationDefault(): void;
  ResetViewOrientation(): void;
  Panning(theDXv: Quantity_AbsorbedDose, theDYv: Quantity_AbsorbedDose, theZoomFactor: Quantity_AbsorbedDose, theToStart: Standard_Boolean): void;
  SetCenter(theXp: Graphic3d_ZLayerId, theYp: Graphic3d_ZLayerId): void;
  SetSize(theSize: Quantity_AbsorbedDose): void;
  SetZSize(SetZSize: Quantity_AbsorbedDose): void;
  SetZoom(Coef: Quantity_AbsorbedDose, Start: Standard_Boolean): void;
  SetScale(Coef: Quantity_AbsorbedDose): void;
  SetAxialScale(Sx: Quantity_AbsorbedDose, Sy: Quantity_AbsorbedDose, Sz: Quantity_AbsorbedDose): void;
  FitAll_1(theMargin: Quantity_AbsorbedDose, theToUpdate: Standard_Boolean): void;
  FitAll_2(theBox: Bnd_Box, theMargin: Quantity_AbsorbedDose, theToUpdate: Standard_Boolean): void;
  DepthFitAll(Aspect: Quantity_AbsorbedDose, Margin: Quantity_AbsorbedDose): void;
  FitAll_3(theMinXv: Quantity_AbsorbedDose, theMinYv: Quantity_AbsorbedDose, theMaxXv: Quantity_AbsorbedDose, theMaxYv: Quantity_AbsorbedDose): void;
  WindowFit(theMinXp: Graphic3d_ZLayerId, theMinYp: Graphic3d_ZLayerId, theMaxXp: Graphic3d_ZLayerId, theMaxYp: Graphic3d_ZLayerId): void;
  SetViewMappingDefault(): void;
  ResetViewMapping(): void;
  Reset(theToUpdate: Standard_Boolean): void;
  Convert_1(Vp: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Convert_2(Xp: Graphic3d_ZLayerId, Yp: Graphic3d_ZLayerId, Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose): void;
  Convert_3(Vv: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Convert_4(Xv: Quantity_AbsorbedDose, Yv: Quantity_AbsorbedDose, Xp: Graphic3d_ZLayerId, Yp: Graphic3d_ZLayerId): void;
  Convert_5(Xp: Graphic3d_ZLayerId, Yp: Graphic3d_ZLayerId, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  ConvertWithProj(Xp: Graphic3d_ZLayerId, Yp: Graphic3d_ZLayerId, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Vx: Quantity_AbsorbedDose, Vy: Quantity_AbsorbedDose, Vz: Quantity_AbsorbedDose): void;
  ConvertToGrid_1(Xp: Graphic3d_ZLayerId, Yp: Graphic3d_ZLayerId, Xg: Quantity_AbsorbedDose, Yg: Quantity_AbsorbedDose, Zg: Quantity_AbsorbedDose): void;
  ConvertToGrid_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Xg: Quantity_AbsorbedDose, Yg: Quantity_AbsorbedDose, Zg: Quantity_AbsorbedDose): void;
  Convert_6(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Xp: Graphic3d_ZLayerId, Yp: Graphic3d_ZLayerId): void;
  Project_1(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theXp: Quantity_AbsorbedDose, theYp: Quantity_AbsorbedDose): void;
  Project_2(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose, theZ: Quantity_AbsorbedDose, theXp: Quantity_AbsorbedDose, theYp: Quantity_AbsorbedDose, theZp: Quantity_AbsorbedDose): void;
  BackgroundColor_1(Type: Quantity_TypeOfColor, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, V3: Quantity_AbsorbedDose): void;
  BackgroundColor_2(): Quantity_Color;
  GradientBackgroundColors(theColor1: Quantity_Color, theColor2: Quantity_Color): void;
  GradientBackground(): Aspect_GradientBackground;
  Scale_1(): Quantity_AbsorbedDose;
  AxialScale_1(Sx: Quantity_AbsorbedDose, Sy: Quantity_AbsorbedDose, Sz: Quantity_AbsorbedDose): void;
  Size(Width: Quantity_AbsorbedDose, Height: Quantity_AbsorbedDose): void;
  ZSize(): Quantity_AbsorbedDose;
  Eye(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  FocalReferencePoint(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  ProjReferenceAxe(Xpix: Graphic3d_ZLayerId, Ypix: Graphic3d_ZLayerId, XP: Quantity_AbsorbedDose, YP: Quantity_AbsorbedDose, ZP: Quantity_AbsorbedDose, VX: Quantity_AbsorbedDose, VY: Quantity_AbsorbedDose, VZ: Quantity_AbsorbedDose): void;
  Depth(): Quantity_AbsorbedDose;
  Proj(Vx: Quantity_AbsorbedDose, Vy: Quantity_AbsorbedDose, Vz: Quantity_AbsorbedDose): void;
  At(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  Up(Vx: Quantity_AbsorbedDose, Vy: Quantity_AbsorbedDose, Vz: Quantity_AbsorbedDose): void;
  Twist(): Quantity_AbsorbedDose;
  ShadingModel(): V3d_TypeOfShadingModel;
  TextureEnv(): Handle_Graphic3d_TextureEnv;
  Visualization(): V3d_TypeOfVisualization;
  ActiveLights(): V3d_ListOfLight;
  ActiveLightIterator(): V3d_ListOfLightIterator;
  LightLimit(): Graphic3d_ZLayerId;
  Viewer(): Handle_V3d_Viewer;
  IfWindow(): Standard_Boolean;
  Window(): Handle_Aspect_Window;
  Type(): V3d_TypeOfView;
  Pan(theDXp: Graphic3d_ZLayerId, theDYp: Graphic3d_ZLayerId, theZoomFactor: Quantity_AbsorbedDose, theToStart: Standard_Boolean): void;
  Zoom(theXp1: Graphic3d_ZLayerId, theYp1: Graphic3d_ZLayerId, theXp2: Graphic3d_ZLayerId, theYp2: Graphic3d_ZLayerId): void;
  StartZoomAtPoint(theXp: Graphic3d_ZLayerId, theYp: Graphic3d_ZLayerId): void;
  ZoomAtPoint(theMouseStartX: Graphic3d_ZLayerId, theMouseStartY: Graphic3d_ZLayerId, theMouseEndX: Graphic3d_ZLayerId, theMouseEndY: Graphic3d_ZLayerId): void;
  AxialScale_2(Dx: Graphic3d_ZLayerId, Dy: Graphic3d_ZLayerId, Axis: V3d_TypeOfAxe): void;
  StartRotation(X: Graphic3d_ZLayerId, Y: Graphic3d_ZLayerId, zRotationThreshold: Quantity_AbsorbedDose): void;
  Rotation(X: Graphic3d_ZLayerId, Y: Graphic3d_ZLayerId): void;
  SetFocale(Focale: Quantity_AbsorbedDose): void;
  Focale(): Quantity_AbsorbedDose;
  View(): Handle_Graphic3d_CView;
  SetComputedMode(theMode: Standard_Boolean): void;
  ComputedMode(): Standard_Boolean;
  WindowFitAll(Xmin: Graphic3d_ZLayerId, Ymin: Graphic3d_ZLayerId, Xmax: Graphic3d_ZLayerId, Ymax: Graphic3d_ZLayerId): void;
  FitMinMax(theCamera: Handle_Graphic3d_Camera, theBox: Bnd_Box, theMargin: Quantity_AbsorbedDose, theResolution: Quantity_AbsorbedDose, theToEnlargeIfLine: Standard_Boolean): Standard_Boolean;
  SetGrid(aPlane: gp_Ax3, aGrid: Handle_Aspect_Grid): void;
  SetGridActivity(aFlag: Standard_Boolean): void;
  Dump(theFile: Standard_CString, theBufferType: Graphic3d_BufferType): Standard_Boolean;
  ToPixMap_1(theImage: Image_PixMap, theParams: V3d_ImageDumpOptions): Standard_Boolean;
  ToPixMap_2(theImage: Image_PixMap, theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId, theBufferType: Graphic3d_BufferType, theToAdjustAspect: Standard_Boolean, theStereoOptions: V3d_StereoDumpOptions): Standard_Boolean;
  SetBackFacingModel(theModel: V3d_TypeOfBackfacingModel): void;
  BackFacingModel(): V3d_TypeOfBackfacingModel;
  AddClipPlane(thePlane: Handle_Graphic3d_ClipPlane): void;
  RemoveClipPlane(thePlane: Handle_Graphic3d_ClipPlane): void;
  SetClipPlanes_1(thePlanes: Handle_Graphic3d_SequenceOfHClipPlane): void;
  SetClipPlanes_2(thePlanes: Graphic3d_SequenceOfHClipPlane): void;
  ClipPlanes(): Handle_Graphic3d_SequenceOfHClipPlane;
  PlaneLimit(): Graphic3d_ZLayerId;
  SetCamera(theCamera: Handle_Graphic3d_Camera): void;
  Camera(): Handle_Graphic3d_Camera;
  DefaultCamera(): Handle_Graphic3d_Camera;
  RenderingParams(): Graphic3d_RenderingParams;
  ChangeRenderingParams(): Graphic3d_RenderingParams;
  IsCullingEnabled(): Standard_Boolean;
  SetFrustumCulling(theMode: Standard_Boolean): void;
  DiagnosticInformation(theDict: TColStd_IndexedDataMapOfStringString, theFlags: Graphic3d_DiagnosticInfo): void;
  StatisticInformation_1(): XCAFDoc_PartId;
  StatisticInformation_2(theDict: TColStd_IndexedDataMapOfStringString): void;
  GravityPoint(): gp_Pnt;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IfMoreLights(): Standard_Boolean;
  InitActiveLights(): void;
  MoreActiveLights(): Standard_Boolean;
  NextActiveLights(): void;
  ActiveLight(): any;
  delete(): void;
}

  export declare class V3d_View_1 extends V3d_View {
    constructor(theViewer: Handle_V3d_Viewer, theType: V3d_TypeOfView);
  }

  export declare class V3d_View_2 extends V3d_View {
    constructor(theViewer: Handle_V3d_Viewer, theView: Handle_V3d_View);
  }

export declare type V3d_TypeOfOrientation = {
  V3d_Xpos: {};
  V3d_Ypos: {};
  V3d_Zpos: {};
  V3d_Xneg: {};
  V3d_Yneg: {};
  V3d_Zneg: {};
  V3d_XposYpos: {};
  V3d_XposZpos: {};
  V3d_YposZpos: {};
  V3d_XnegYneg: {};
  V3d_XnegYpos: {};
  V3d_XnegZneg: {};
  V3d_XnegZpos: {};
  V3d_YnegZneg: {};
  V3d_YnegZpos: {};
  V3d_XposYneg: {};
  V3d_XposZneg: {};
  V3d_YposZneg: {};
  V3d_XposYposZpos: {};
  V3d_XposYnegZpos: {};
  V3d_XposYposZneg: {};
  V3d_XnegYposZpos: {};
  V3d_XposYnegZneg: {};
  V3d_XnegYposZneg: {};
  V3d_XnegYnegZpos: {};
  V3d_XnegYnegZneg: {};
  V3d_TypeOfOrientation_Zup_AxoLeft: {};
  V3d_TypeOfOrientation_Zup_AxoRight: {};
  V3d_TypeOfOrientation_Zup_Front: {};
  V3d_TypeOfOrientation_Zup_Back: {};
  V3d_TypeOfOrientation_Zup_Top: {};
  V3d_TypeOfOrientation_Zup_Bottom: {};
  V3d_TypeOfOrientation_Zup_Left: {};
  V3d_TypeOfOrientation_Zup_Right: {};
  V3d_TypeOfOrientation_Yup_AxoLeft: {};
  V3d_TypeOfOrientation_Yup_AxoRight: {};
  V3d_TypeOfOrientation_Yup_Front: {};
  V3d_TypeOfOrientation_Yup_Back: {};
  V3d_TypeOfOrientation_Yup_Top: {};
  V3d_TypeOfOrientation_Yup_Bottom: {};
  V3d_TypeOfOrientation_Yup_Left: {};
  V3d_TypeOfOrientation_Yup_Right: {};
}

export declare type V3d_TypeOfRepresentation = {
  V3d_SIMPLE: {};
  V3d_COMPLETE: {};
  V3d_PARTIAL: {};
  V3d_SAMELAST: {};
}

export declare class Handle_V3d_DirectionalLight {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_DirectionalLight): void;
  get(): V3d_DirectionalLight;
  delete(): void;
}

  export declare class Handle_V3d_DirectionalLight_1 extends Handle_V3d_DirectionalLight {
    constructor();
  }

  export declare class Handle_V3d_DirectionalLight_2 extends Handle_V3d_DirectionalLight {
    constructor(thePtr: V3d_DirectionalLight);
  }

  export declare class Handle_V3d_DirectionalLight_3 extends Handle_V3d_DirectionalLight {
    constructor(theHandle: Handle_V3d_DirectionalLight);
  }

  export declare class Handle_V3d_DirectionalLight_4 extends Handle_V3d_DirectionalLight {
    constructor(theHandle: Handle_V3d_DirectionalLight);
  }

export declare class V3d_DirectionalLight extends V3d_PositionLight {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetDirection_1(theDirection: V3d_TypeOfOrientation): void;
  SetDirection_2(theDir: gp_Dir): void;
  SetDirection_3(theVx: Quantity_AbsorbedDose, theVy: Quantity_AbsorbedDose, theVz: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class V3d_DirectionalLight_1 extends V3d_DirectionalLight {
    constructor(theDirection: V3d_TypeOfOrientation, theColor: Quantity_Color, theIsHeadlight: Standard_Boolean);
  }

  export declare class V3d_DirectionalLight_2 extends V3d_DirectionalLight {
    constructor(theDirection: gp_Dir, theColor: Quantity_Color, theIsHeadlight: Standard_Boolean);
  }

export declare type V3d_TypeOfView = {
  V3d_ORTHOGRAPHIC: {};
  V3d_PERSPECTIVE: {};
}

export declare class Handle_V3d_CircularGrid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_CircularGrid): void;
  get(): V3d_CircularGrid;
  delete(): void;
}

  export declare class Handle_V3d_CircularGrid_1 extends Handle_V3d_CircularGrid {
    constructor();
  }

  export declare class Handle_V3d_CircularGrid_2 extends Handle_V3d_CircularGrid {
    constructor(thePtr: V3d_CircularGrid);
  }

  export declare class Handle_V3d_CircularGrid_3 extends Handle_V3d_CircularGrid {
    constructor(theHandle: Handle_V3d_CircularGrid);
  }

  export declare class Handle_V3d_CircularGrid_4 extends Handle_V3d_CircularGrid {
    constructor(theHandle: Handle_V3d_CircularGrid);
  }

export declare class V3d_CircularGrid extends Aspect_CircularGrid {
  constructor(aViewer: V3d_ViewerPointer, aColor: Quantity_Color, aTenthColor: Quantity_Color)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColors(aColor: Quantity_Color, aTenthColor: Quantity_Color): void;
  Display(): void;
  Erase(): void;
  IsDisplayed(): Standard_Boolean;
  GraphicValues(Radius: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  SetGraphicValues(Radius: Quantity_AbsorbedDose, OffSet: Quantity_AbsorbedDose): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class V3d_Trihedron extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetWireframe(theAsWireframe: Standard_Boolean): void;
  SetPosition(thePosition: Aspect_TypeOfTriedronPosition): void;
  SetScale(theScale: Quantity_AbsorbedDose): void;
  SetSizeRatio(theRatio: Quantity_AbsorbedDose): void;
  SetArrowDiameter(theDiam: Quantity_AbsorbedDose): void;
  SetNbFacets(theNbFacets: Graphic3d_ZLayerId): void;
  SetLabelsColor(theColor: Quantity_Color): void;
  SetArrowsColor(theXColor: Quantity_Color, theYColor: Quantity_Color, theZColor: Quantity_Color): void;
  Display(theView: V3d_View): void;
  Erase(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_V3d_Trihedron {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: V3d_Trihedron): void;
  get(): V3d_Trihedron;
  delete(): void;
}

  export declare class Handle_V3d_Trihedron_1 extends Handle_V3d_Trihedron {
    constructor();
  }

  export declare class Handle_V3d_Trihedron_2 extends Handle_V3d_Trihedron {
    constructor(thePtr: V3d_Trihedron);
  }

  export declare class Handle_V3d_Trihedron_3 extends Handle_V3d_Trihedron {
    constructor(theHandle: Handle_V3d_Trihedron);
  }

  export declare class Handle_V3d_Trihedron_4 extends Handle_V3d_Trihedron {
    constructor(theHandle: Handle_V3d_Trihedron);
  }

export declare type V3d_TypeOfBackfacingModel = {
  V3d_TOBM_AUTOMATIC: {};
  V3d_TOBM_ALWAYS_DISPLAYED: {};
  V3d_TOBM_NEVER_DISPLAYED: {};
}

export declare class AppCont_Function {
  GetNumberOfPoints(theNbPnt: Graphic3d_ZLayerId, theNbPnt2d: Graphic3d_ZLayerId): void;
  GetNbOf3dPoints(): Graphic3d_ZLayerId;
  GetNbOf2dPoints(): Graphic3d_ZLayerId;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Value(theU: Quantity_AbsorbedDose, thePnt2d: TColgp_Array1OfPnt2d, thePnt: TColgp_Array1OfPnt): Standard_Boolean;
  D1(theU: Quantity_AbsorbedDose, theVec2d: TColgp_Array1OfVec2d, theVec: TColgp_Array1OfVec): Standard_Boolean;
  PeriodInformation(a0: Graphic3d_ZLayerId, IsPeriodic: Standard_Boolean, thePeriod: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class AppCont_LeastSquare {
  constructor(SSP: AppCont_Function, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Deg: Graphic3d_ZLayerId, NbPoints: Graphic3d_ZLayerId)
  Value(): AppParCurves_MultiCurve;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  delete(): void;
}

export declare class PeriodicityInfo {
  constructor();
  delete(): void;
}

export declare class StdPersistent_PPrsStd {
  constructor();
  delete(): void;
}

export declare class StdPersistent_DataXtd {
  constructor();
  delete(): void;
}

export declare class StdPersistent {
  constructor();
  static BindTypes(theMap: StdObjMgt_MapOfInstantiators): void;
  delete(): void;
}

export declare class StdPersistent_Naming {
  constructor();
  delete(): void;
}

export declare class StdPersistent_DataXtd_Constraint {
  constructor();
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(theChildren: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TDataXtd_Constraint): void;
  delete(): void;
}

export declare class Handle_StdPersistent_HArray1OfShape1 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdPersistent_HArray1OfShape1): void;
  get(): StdPersistent_HArray1OfShape1;
  delete(): void;
}

  export declare class Handle_StdPersistent_HArray1OfShape1_1 extends Handle_StdPersistent_HArray1OfShape1 {
    constructor();
  }

  export declare class Handle_StdPersistent_HArray1OfShape1_2 extends Handle_StdPersistent_HArray1OfShape1 {
    constructor(thePtr: StdPersistent_HArray1OfShape1);
  }

  export declare class Handle_StdPersistent_HArray1OfShape1_3 extends Handle_StdPersistent_HArray1OfShape1 {
    constructor(theHandle: Handle_StdPersistent_HArray1OfShape1);
  }

  export declare class Handle_StdPersistent_HArray1OfShape1_4 extends Handle_StdPersistent_HArray1OfShape1 {
    constructor(theHandle: Handle_StdPersistent_HArray1OfShape1);
  }

export declare class StdPersistent_HArray1 {
  constructor();
  delete(): void;
}

export declare class StdPersistent_TopoDS {
  constructor();
  delete(): void;
}

export declare class StdPersistent_DataXtd_PatternStd {
  constructor();
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(theChildren: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TDataXtd_PatternStd): void;
  delete(): void;
}

export declare class ChFi2d {
  constructor();
  delete(): void;
}

export declare class ChFi2d_ChamferAPI {
  Init_1(theWire: TopoDS_Wire): void;
  Init_2(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge): void;
  Perform(): Standard_Boolean;
  Result(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, theLength1: Quantity_AbsorbedDose, theLength2: Quantity_AbsorbedDose): TopoDS_Edge;
  delete(): void;
}

  export declare class ChFi2d_ChamferAPI_1 extends ChFi2d_ChamferAPI {
    constructor();
  }

  export declare class ChFi2d_ChamferAPI_2 extends ChFi2d_ChamferAPI {
    constructor(theWire: TopoDS_Wire);
  }

  export declare class ChFi2d_ChamferAPI_3 extends ChFi2d_ChamferAPI {
    constructor(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge);
  }

export declare class ChFi2d_Builder {
  Init_1(F: TopoDS_Face): void;
  Init_2(RefFace: TopoDS_Face, ModFace: TopoDS_Face): void;
  AddFillet(V: TopoDS_Vertex, Radius: Quantity_AbsorbedDose): TopoDS_Edge;
  ModifyFillet(Fillet: TopoDS_Edge, Radius: Quantity_AbsorbedDose): TopoDS_Edge;
  RemoveFillet(Fillet: TopoDS_Edge): TopoDS_Vertex;
  AddChamfer_1(E1: TopoDS_Edge, E2: TopoDS_Edge, D1: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): TopoDS_Edge;
  AddChamfer_2(E: TopoDS_Edge, V: TopoDS_Vertex, D: Quantity_AbsorbedDose, Ang: Quantity_AbsorbedDose): TopoDS_Edge;
  ModifyChamfer_1(Chamfer: TopoDS_Edge, E1: TopoDS_Edge, E2: TopoDS_Edge, D1: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): TopoDS_Edge;
  ModifyChamfer_2(Chamfer: TopoDS_Edge, E: TopoDS_Edge, D: Quantity_AbsorbedDose, Ang: Quantity_AbsorbedDose): TopoDS_Edge;
  RemoveChamfer(Chamfer: TopoDS_Edge): TopoDS_Vertex;
  Result(): TopoDS_Face;
  IsModified(E: TopoDS_Edge): Standard_Boolean;
  FilletEdges(): TopTools_SequenceOfShape;
  NbFillet(): Graphic3d_ZLayerId;
  ChamferEdges(): TopTools_SequenceOfShape;
  NbChamfer(): Graphic3d_ZLayerId;
  HasDescendant(E: TopoDS_Edge): Standard_Boolean;
  DescendantEdge(E: TopoDS_Edge): TopoDS_Edge;
  BasisEdge(E: TopoDS_Edge): TopoDS_Edge;
  Status(): ChFi2d_ConstructionError;
  delete(): void;
}

  export declare class ChFi2d_Builder_1 extends ChFi2d_Builder {
    constructor();
  }

  export declare class ChFi2d_Builder_2 extends ChFi2d_Builder {
    constructor(F: TopoDS_Face);
  }

export declare type ChFi2d_ConstructionError = {
  ChFi2d_NotPlanar: {};
  ChFi2d_NoFace: {};
  ChFi2d_InitialisationError: {};
  ChFi2d_ParametersError: {};
  ChFi2d_Ready: {};
  ChFi2d_IsDone: {};
  ChFi2d_ComputationError: {};
  ChFi2d_ConnexionError: {};
  ChFi2d_TangencyError: {};
  ChFi2d_FirstEdgeDegenerated: {};
  ChFi2d_LastEdgeDegenerated: {};
  ChFi2d_BothEdgesDegenerated: {};
  ChFi2d_NotAuthorized: {};
}

export declare class ChFi2d_AnaFilletAlgo {
  Init_1(theWire: TopoDS_Wire, thePlane: gp_Pln): void;
  Init_2(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, thePlane: gp_Pln): void;
  Perform(radius: Quantity_AbsorbedDose): Standard_Boolean;
  Result(e1: TopoDS_Edge, e2: TopoDS_Edge): TopoDS_Edge;
  delete(): void;
}

  export declare class ChFi2d_AnaFilletAlgo_1 extends ChFi2d_AnaFilletAlgo {
    constructor();
  }

  export declare class ChFi2d_AnaFilletAlgo_2 extends ChFi2d_AnaFilletAlgo {
    constructor(theWire: TopoDS_Wire, thePlane: gp_Pln);
  }

  export declare class ChFi2d_AnaFilletAlgo_3 extends ChFi2d_AnaFilletAlgo {
    constructor(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, thePlane: gp_Pln);
  }

export declare class FilletPoint {
  constructor(theParam: Quantity_AbsorbedDose)
  setParam(theParam: Quantity_AbsorbedDose): void;
  getParam(): Quantity_AbsorbedDose;
  getNBValues(): Graphic3d_ZLayerId;
  getValue(theIndex: Standard_Integer): Quantity_AbsorbedDose;
  getDiff(theIndex: Standard_Integer): Quantity_AbsorbedDose;
  isValid(theIndex: Standard_Integer): Standard_Boolean;
  getNear(theIndex: Standard_Integer): Standard_Integer;
  setParam2(theParam2: Quantity_AbsorbedDose): void;
  getParam2(): Quantity_AbsorbedDose;
  setCenter(thePoint: gp_Pnt2d): void;
  getCenter(): gp_Pnt2d;
  appendValue(theValue: Quantity_AbsorbedDose, theValid: Standard_Boolean): void;
  calculateDiff(a0: FilletPoint): Standard_Boolean;
  FilterPoints(a0: FilletPoint): void;
  Copy(): FilletPoint;
  hasSolution(theRadius: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  LowerValue(): Quantity_AbsorbedDose;
  remove(theIndex: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class ChFi2d_FilletAlgo {
  Init_1(theWire: TopoDS_Wire, thePlane: gp_Pln): void;
  Init_2(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, thePlane: gp_Pln): void;
  Perform(theRadius: Quantity_AbsorbedDose): Standard_Boolean;
  NbResults(thePoint: gp_Pnt): Graphic3d_ZLayerId;
  Result(thePoint: gp_Pnt, theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, iSolution: Graphic3d_ZLayerId): TopoDS_Edge;
  delete(): void;
}

  export declare class ChFi2d_FilletAlgo_1 extends ChFi2d_FilletAlgo {
    constructor();
  }

  export declare class ChFi2d_FilletAlgo_2 extends ChFi2d_FilletAlgo {
    constructor(theWire: TopoDS_Wire, thePlane: gp_Pln);
  }

  export declare class ChFi2d_FilletAlgo_3 extends ChFi2d_FilletAlgo {
    constructor(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, thePlane: gp_Pln);
  }

export declare class ChFi2d_FilletAPI {
  Init_1(theWire: TopoDS_Wire, thePlane: gp_Pln): void;
  Init_2(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, thePlane: gp_Pln): void;
  Perform(theRadius: Quantity_AbsorbedDose): Standard_Boolean;
  NbResults(thePoint: gp_Pnt): Graphic3d_ZLayerId;
  Result(thePoint: gp_Pnt, theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, iSolution: Graphic3d_ZLayerId): TopoDS_Edge;
  delete(): void;
}

  export declare class ChFi2d_FilletAPI_1 extends ChFi2d_FilletAPI {
    constructor();
  }

  export declare class ChFi2d_FilletAPI_2 extends ChFi2d_FilletAPI {
    constructor(theWire: TopoDS_Wire, thePlane: gp_Pln);
  }

  export declare class ChFi2d_FilletAPI_3 extends ChFi2d_FilletAPI {
    constructor(theEdge1: TopoDS_Edge, theEdge2: TopoDS_Edge, thePlane: gp_Pln);
  }

export declare class Handle_VrmlConverter_Drawer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlConverter_Drawer): void;
  get(): VrmlConverter_Drawer;
  delete(): void;
}

  export declare class Handle_VrmlConverter_Drawer_1 extends Handle_VrmlConverter_Drawer {
    constructor();
  }

  export declare class Handle_VrmlConverter_Drawer_2 extends Handle_VrmlConverter_Drawer {
    constructor(thePtr: VrmlConverter_Drawer);
  }

  export declare class Handle_VrmlConverter_Drawer_3 extends Handle_VrmlConverter_Drawer {
    constructor(theHandle: Handle_VrmlConverter_Drawer);
  }

  export declare class Handle_VrmlConverter_Drawer_4 extends Handle_VrmlConverter_Drawer {
    constructor(theHandle: Handle_VrmlConverter_Drawer);
  }

export declare class VrmlConverter_Drawer extends Standard_Transient {
  constructor()
  SetTypeOfDeflection(aTypeOfDeflection: Aspect_TypeOfDeflection): void;
  TypeOfDeflection(): Aspect_TypeOfDeflection;
  SetMaximalChordialDeviation(aChordialDeviation: Quantity_AbsorbedDose): void;
  MaximalChordialDeviation(): Quantity_AbsorbedDose;
  SetDeviationCoefficient(aCoefficient: Quantity_AbsorbedDose): void;
  DeviationCoefficient(): Quantity_AbsorbedDose;
  SetDiscretisation(d: Graphic3d_ZLayerId): void;
  Discretisation(): Graphic3d_ZLayerId;
  SetMaximalParameterValue(Value: Quantity_AbsorbedDose): void;
  MaximalParameterValue(): Quantity_AbsorbedDose;
  SetIsoOnPlane(OnOff: Standard_Boolean): void;
  IsoOnPlane(): Standard_Boolean;
  UIsoAspect(): Handle_VrmlConverter_IsoAspect;
  SetUIsoAspect(anAspect: Handle_VrmlConverter_IsoAspect): void;
  VIsoAspect(): Handle_VrmlConverter_IsoAspect;
  SetVIsoAspect(anAspect: Handle_VrmlConverter_IsoAspect): void;
  FreeBoundaryAspect(): Handle_VrmlConverter_LineAspect;
  SetFreeBoundaryAspect(anAspect: Handle_VrmlConverter_LineAspect): void;
  SetFreeBoundaryDraw(OnOff: Standard_Boolean): void;
  FreeBoundaryDraw(): Standard_Boolean;
  WireAspect(): Handle_VrmlConverter_LineAspect;
  SetWireAspect(anAspect: Handle_VrmlConverter_LineAspect): void;
  SetWireDraw(OnOff: Standard_Boolean): void;
  WireDraw(): Standard_Boolean;
  UnFreeBoundaryAspect(): Handle_VrmlConverter_LineAspect;
  SetUnFreeBoundaryAspect(anAspect: Handle_VrmlConverter_LineAspect): void;
  SetUnFreeBoundaryDraw(OnOff: Standard_Boolean): void;
  UnFreeBoundaryDraw(): Standard_Boolean;
  LineAspect(): Handle_VrmlConverter_LineAspect;
  SetLineAspect(anAspect: Handle_VrmlConverter_LineAspect): void;
  PointAspect(): Handle_VrmlConverter_PointAspect;
  SetPointAspect(anAspect: Handle_VrmlConverter_PointAspect): void;
  ShadingAspect(): Handle_VrmlConverter_ShadingAspect;
  SetShadingAspect(anAspect: Handle_VrmlConverter_ShadingAspect): void;
  DrawHiddenLine(): Standard_Boolean;
  EnableDrawHiddenLine(): void;
  DisableDrawHiddenLine(): void;
  HiddenLineAspect(): Handle_VrmlConverter_LineAspect;
  SetHiddenLineAspect(anAspect: Handle_VrmlConverter_LineAspect): void;
  SeenLineAspect(): Handle_VrmlConverter_LineAspect;
  SetSeenLineAspect(anAspect: Handle_VrmlConverter_LineAspect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class VrmlConverter_ShadedShape {
  constructor();
  static Add(anOStream: Standard_OStream, aShape: TopoDS_Shape, aDrawer: Handle_VrmlConverter_Drawer): void;
  static ComputeNormal(aFace: TopoDS_Face, pc: Poly_Connect, Nor: TColgp_Array1OfDir): void;
  delete(): void;
}

export declare class VrmlConverter_Curve {
  constructor();
  static Add_1(aCurve: Adaptor3d_Curve, aDrawer: Handle_VrmlConverter_Drawer, anOStream: Standard_OStream): void;
  static Add_2(aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDrawer: Handle_VrmlConverter_Drawer, anOStream: Standard_OStream): void;
  static Add_3(aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, anOStream: Standard_OStream, aNbPoints: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_VrmlConverter_PointAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlConverter_PointAspect): void;
  get(): VrmlConverter_PointAspect;
  delete(): void;
}

  export declare class Handle_VrmlConverter_PointAspect_1 extends Handle_VrmlConverter_PointAspect {
    constructor();
  }

  export declare class Handle_VrmlConverter_PointAspect_2 extends Handle_VrmlConverter_PointAspect {
    constructor(thePtr: VrmlConverter_PointAspect);
  }

  export declare class Handle_VrmlConverter_PointAspect_3 extends Handle_VrmlConverter_PointAspect {
    constructor(theHandle: Handle_VrmlConverter_PointAspect);
  }

  export declare class Handle_VrmlConverter_PointAspect_4 extends Handle_VrmlConverter_PointAspect {
    constructor(theHandle: Handle_VrmlConverter_PointAspect);
  }

export declare class VrmlConverter_PointAspect extends Standard_Transient {
  SetMaterial(aMaterial: Handle_Vrml_Material): void;
  Material(): Handle_Vrml_Material;
  SetHasMaterial(OnOff: Standard_Boolean): void;
  HasMaterial(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlConverter_PointAspect_1 extends VrmlConverter_PointAspect {
    constructor();
  }

  export declare class VrmlConverter_PointAspect_2 extends VrmlConverter_PointAspect {
    constructor(aMaterial: Handle_Vrml_Material, OnOff: Standard_Boolean);
  }

export declare type VrmlConverter_TypeOfLight = {
  VrmlConverter_NoLight: {};
  VrmlConverter_DirectionLight: {};
  VrmlConverter_PointLight: {};
  VrmlConverter_SpotLight: {};
}

export declare type VrmlConverter_TypeOfCamera = {
  VrmlConverter_NoCamera: {};
  VrmlConverter_PerspectiveCamera: {};
  VrmlConverter_OrthographicCamera: {};
}

export declare class VrmlConverter_IsoAspect extends VrmlConverter_LineAspect {
  SetNumber(aNumber: Graphic3d_ZLayerId): void;
  Number(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlConverter_IsoAspect_1 extends VrmlConverter_IsoAspect {
    constructor();
  }

  export declare class VrmlConverter_IsoAspect_2 extends VrmlConverter_IsoAspect {
    constructor(aMaterial: Handle_Vrml_Material, OnOff: Standard_Boolean, aNumber: Graphic3d_ZLayerId);
  }

export declare class Handle_VrmlConverter_IsoAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlConverter_IsoAspect): void;
  get(): VrmlConverter_IsoAspect;
  delete(): void;
}

  export declare class Handle_VrmlConverter_IsoAspect_1 extends Handle_VrmlConverter_IsoAspect {
    constructor();
  }

  export declare class Handle_VrmlConverter_IsoAspect_2 extends Handle_VrmlConverter_IsoAspect {
    constructor(thePtr: VrmlConverter_IsoAspect);
  }

  export declare class Handle_VrmlConverter_IsoAspect_3 extends Handle_VrmlConverter_IsoAspect {
    constructor(theHandle: Handle_VrmlConverter_IsoAspect);
  }

  export declare class Handle_VrmlConverter_IsoAspect_4 extends Handle_VrmlConverter_IsoAspect {
    constructor(theHandle: Handle_VrmlConverter_IsoAspect);
  }

export declare class VrmlConverter_HLRShape {
  constructor();
  static Add(anOStream: Standard_OStream, aShape: TopoDS_Shape, aDrawer: Handle_VrmlConverter_Drawer, aProjector: Handle_VrmlConverter_Projector): void;
  delete(): void;
}

export declare class VrmlConverter_WFRestrictedFace {
  constructor();
  static Add_1(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_VrmlConverter_Drawer): void;
  static AddUIso(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_VrmlConverter_Drawer): void;
  static AddVIso(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_VrmlConverter_Drawer): void;
  static Add_2(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, DrawUIso: Standard_Boolean, DrawVIso: Standard_Boolean, NBUiso: Graphic3d_ZLayerId, NBViso: Graphic3d_ZLayerId, aDrawer: Handle_VrmlConverter_Drawer): void;
  delete(): void;
}

export declare class Handle_VrmlConverter_Projector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlConverter_Projector): void;
  get(): VrmlConverter_Projector;
  delete(): void;
}

  export declare class Handle_VrmlConverter_Projector_1 extends Handle_VrmlConverter_Projector {
    constructor();
  }

  export declare class Handle_VrmlConverter_Projector_2 extends Handle_VrmlConverter_Projector {
    constructor(thePtr: VrmlConverter_Projector);
  }

  export declare class Handle_VrmlConverter_Projector_3 extends Handle_VrmlConverter_Projector {
    constructor(theHandle: Handle_VrmlConverter_Projector);
  }

  export declare class Handle_VrmlConverter_Projector_4 extends Handle_VrmlConverter_Projector {
    constructor(theHandle: Handle_VrmlConverter_Projector);
  }

export declare class VrmlConverter_Projector extends Standard_Transient {
  constructor(Shapes: TopTools_Array1OfShape, Focus: Quantity_AbsorbedDose, DX: Quantity_AbsorbedDose, DY: Quantity_AbsorbedDose, DZ: Quantity_AbsorbedDose, XUp: Quantity_AbsorbedDose, YUp: Quantity_AbsorbedDose, ZUp: Quantity_AbsorbedDose, Camera: VrmlConverter_TypeOfCamera, Light: VrmlConverter_TypeOfLight)
  SetCamera(aCamera: VrmlConverter_TypeOfCamera): void;
  Camera(): VrmlConverter_TypeOfCamera;
  SetLight(aLight: VrmlConverter_TypeOfLight): void;
  Light(): VrmlConverter_TypeOfLight;
  Add(anOStream: Standard_OStream): void;
  Projector(): HLRAlgo_Projector;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class VrmlConverter_WFDeflectionShape {
  constructor();
  static Add(anOStream: Standard_OStream, aShape: TopoDS_Shape, aDrawer: Handle_VrmlConverter_Drawer): void;
  delete(): void;
}

export declare class VrmlConverter_WFShape {
  constructor();
  static Add(anOStream: Standard_OStream, aShape: TopoDS_Shape, aDrawer: Handle_VrmlConverter_Drawer): void;
  delete(): void;
}

export declare class VrmlConverter_DeflectionCurve {
  constructor();
  static Add_1(anOStream: Standard_OStream, aCurve: Adaptor3d_Curve, aDrawer: Handle_VrmlConverter_Drawer): void;
  static Add_2(anOStream: Standard_OStream, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDrawer: Handle_VrmlConverter_Drawer): void;
  static Add_3(anOStream: Standard_OStream, aCurve: Adaptor3d_Curve, aDeflection: Quantity_AbsorbedDose, aLimit: Quantity_AbsorbedDose): void;
  static Add_4(anOStream: Standard_OStream, aCurve: Adaptor3d_Curve, aDeflection: Quantity_AbsorbedDose, aDrawer: Handle_VrmlConverter_Drawer): void;
  static Add_5(anOStream: Standard_OStream, aCurve: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, aDeflection: Quantity_AbsorbedDose): void;
  static Add_6(anOStream: Standard_OStream, aCurve: Adaptor3d_Curve, aParams: Handle_TColStd_HArray1OfReal, aNbNodes: Graphic3d_ZLayerId, aDrawer: Handle_VrmlConverter_Drawer): void;
  delete(): void;
}

export declare class VrmlConverter_LineAspect extends Standard_Transient {
  SetMaterial(aMaterial: Handle_Vrml_Material): void;
  Material(): Handle_Vrml_Material;
  SetHasMaterial(OnOff: Standard_Boolean): void;
  HasMaterial(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class VrmlConverter_LineAspect_1 extends VrmlConverter_LineAspect {
    constructor();
  }

  export declare class VrmlConverter_LineAspect_2 extends VrmlConverter_LineAspect {
    constructor(aMaterial: Handle_Vrml_Material, OnOff: Standard_Boolean);
  }

export declare class Handle_VrmlConverter_LineAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlConverter_LineAspect): void;
  get(): VrmlConverter_LineAspect;
  delete(): void;
}

  export declare class Handle_VrmlConverter_LineAspect_1 extends Handle_VrmlConverter_LineAspect {
    constructor();
  }

  export declare class Handle_VrmlConverter_LineAspect_2 extends Handle_VrmlConverter_LineAspect {
    constructor(thePtr: VrmlConverter_LineAspect);
  }

  export declare class Handle_VrmlConverter_LineAspect_3 extends Handle_VrmlConverter_LineAspect {
    constructor(theHandle: Handle_VrmlConverter_LineAspect);
  }

  export declare class Handle_VrmlConverter_LineAspect_4 extends Handle_VrmlConverter_LineAspect {
    constructor(theHandle: Handle_VrmlConverter_LineAspect);
  }

export declare class VrmlConverter_WFDeflectionRestrictedFace {
  constructor();
  static Add_1(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_VrmlConverter_Drawer): void;
  static AddUIso(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_VrmlConverter_Drawer): void;
  static AddVIso(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, aDrawer: Handle_VrmlConverter_Drawer): void;
  static Add_2(anOStream: Standard_OStream, aFace: Handle_BRepAdaptor_HSurface, DrawUIso: Standard_Boolean, DrawVIso: Standard_Boolean, Deflection: Quantity_AbsorbedDose, NBUiso: Graphic3d_ZLayerId, NBViso: Graphic3d_ZLayerId, aDrawer: Handle_VrmlConverter_Drawer): void;
  delete(): void;
}

export declare class VrmlConverter_ShadingAspect extends Standard_Transient {
  constructor()
  SetFrontMaterial(aMaterial: Handle_Vrml_Material): void;
  FrontMaterial(): Handle_Vrml_Material;
  SetShapeHints(aShapeHints: Vrml_ShapeHints): void;
  ShapeHints(): Vrml_ShapeHints;
  SetHasNormals(OnOff: Standard_Boolean): void;
  HasNormals(): Standard_Boolean;
  SetHasMaterial(OnOff: Standard_Boolean): void;
  HasMaterial(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_VrmlConverter_ShadingAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: VrmlConverter_ShadingAspect): void;
  get(): VrmlConverter_ShadingAspect;
  delete(): void;
}

  export declare class Handle_VrmlConverter_ShadingAspect_1 extends Handle_VrmlConverter_ShadingAspect {
    constructor();
  }

  export declare class Handle_VrmlConverter_ShadingAspect_2 extends Handle_VrmlConverter_ShadingAspect {
    constructor(thePtr: VrmlConverter_ShadingAspect);
  }

  export declare class Handle_VrmlConverter_ShadingAspect_3 extends Handle_VrmlConverter_ShadingAspect {
    constructor(theHandle: Handle_VrmlConverter_ShadingAspect);
  }

  export declare class Handle_VrmlConverter_ShadingAspect_4 extends Handle_VrmlConverter_ShadingAspect {
    constructor(theHandle: Handle_VrmlConverter_ShadingAspect);
  }

export declare class GeomTools_SurfaceSet {
  constructor()
  Clear(): void;
  Add(S: Handle_Geom_Surface): Graphic3d_ZLayerId;
  Surface(I: Graphic3d_ZLayerId): Handle_Geom_Surface;
  Index(S: Handle_Geom_Surface): Graphic3d_ZLayerId;
  Dump(OS: Standard_OStream): void;
  Write(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  Read(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  static PrintSurface(S: Handle_Geom_Surface, OS: Standard_OStream, compact: Standard_Boolean): void;
  static ReadSurface(IS: Standard_IStream): Handle_Geom_Surface;
  delete(): void;
}

export declare class Handle_GeomTools_UndefinedTypeHandler {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomTools_UndefinedTypeHandler): void;
  get(): GeomTools_UndefinedTypeHandler;
  delete(): void;
}

  export declare class Handle_GeomTools_UndefinedTypeHandler_1 extends Handle_GeomTools_UndefinedTypeHandler {
    constructor();
  }

  export declare class Handle_GeomTools_UndefinedTypeHandler_2 extends Handle_GeomTools_UndefinedTypeHandler {
    constructor(thePtr: GeomTools_UndefinedTypeHandler);
  }

  export declare class Handle_GeomTools_UndefinedTypeHandler_3 extends Handle_GeomTools_UndefinedTypeHandler {
    constructor(theHandle: Handle_GeomTools_UndefinedTypeHandler);
  }

  export declare class Handle_GeomTools_UndefinedTypeHandler_4 extends Handle_GeomTools_UndefinedTypeHandler {
    constructor(theHandle: Handle_GeomTools_UndefinedTypeHandler);
  }

export declare class GeomTools_CurveSet {
  constructor()
  Clear(): void;
  Add(C: Handle_Geom_Curve): Graphic3d_ZLayerId;
  Curve(I: Graphic3d_ZLayerId): Handle_Geom_Curve;
  Index(C: Handle_Geom_Curve): Graphic3d_ZLayerId;
  Dump(OS: Standard_OStream): void;
  Write(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  Read(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  static PrintCurve(C: Handle_Geom_Curve, OS: Standard_OStream, compact: Standard_Boolean): void;
  static ReadCurve(IS: Standard_IStream): Handle_Geom_Curve;
  delete(): void;
}

export declare class GeomTools {
  constructor();
  static Dump_1(S: Handle_Geom_Surface, OS: Standard_OStream): void;
  static Write_1(S: Handle_Geom_Surface, OS: Standard_OStream): void;
  static Read_1(S: Handle_Geom_Surface, IS: Standard_IStream): void;
  static Dump_2(C: Handle_Geom_Curve, OS: Standard_OStream): void;
  static Write_2(C: Handle_Geom_Curve, OS: Standard_OStream): void;
  static Read_2(C: Handle_Geom_Curve, IS: Standard_IStream): void;
  static Dump_3(C: Handle_Geom2d_Curve, OS: Standard_OStream): void;
  static Write_3(C: Handle_Geom2d_Curve, OS: Standard_OStream): void;
  static Read_3(C: Handle_Geom2d_Curve, IS: Standard_IStream): void;
  static SetUndefinedTypeHandler(aHandler: Handle_GeomTools_UndefinedTypeHandler): void;
  static GetUndefinedTypeHandler(): Handle_GeomTools_UndefinedTypeHandler;
  static GetReal(IS: Standard_IStream, theValue: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomTools_Curve2dSet {
  constructor()
  Clear(): void;
  Add(C: Handle_Geom2d_Curve): Graphic3d_ZLayerId;
  Curve2d(I: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  Index(C: Handle_Geom2d_Curve): Graphic3d_ZLayerId;
  Dump(OS: Standard_OStream): void;
  Write(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  Read(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  static PrintCurve2d(C: Handle_Geom2d_Curve, OS: Standard_OStream, compact: Standard_Boolean): void;
  static ReadCurve2d(IS: Standard_IStream): Handle_Geom2d_Curve;
  delete(): void;
}

export declare class Handle_MAT_TListNodeOfListOfEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_TListNodeOfListOfEdge): void;
  get(): MAT_TListNodeOfListOfEdge;
  delete(): void;
}

  export declare class Handle_MAT_TListNodeOfListOfEdge_1 extends Handle_MAT_TListNodeOfListOfEdge {
    constructor();
  }

  export declare class Handle_MAT_TListNodeOfListOfEdge_2 extends Handle_MAT_TListNodeOfListOfEdge {
    constructor(thePtr: MAT_TListNodeOfListOfEdge);
  }

  export declare class Handle_MAT_TListNodeOfListOfEdge_3 extends Handle_MAT_TListNodeOfListOfEdge {
    constructor(theHandle: Handle_MAT_TListNodeOfListOfEdge);
  }

  export declare class Handle_MAT_TListNodeOfListOfEdge_4 extends Handle_MAT_TListNodeOfListOfEdge {
    constructor(theHandle: Handle_MAT_TListNodeOfListOfEdge);
  }

export declare class MAT_TListNodeOfListOfEdge extends Standard_Transient {
  GetItem(): Handle_MAT_Edge;
  Next_1(): Handle_MAT_TListNodeOfListOfEdge;
  Previous_1(): Handle_MAT_TListNodeOfListOfEdge;
  SetItem(anitem: Handle_MAT_Edge): void;
  Next_2(atlistnode: Handle_MAT_TListNodeOfListOfEdge): void;
  Previous_2(atlistnode: Handle_MAT_TListNodeOfListOfEdge): void;
  Dummy(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class MAT_TListNodeOfListOfEdge_1 extends MAT_TListNodeOfListOfEdge {
    constructor();
  }

  export declare class MAT_TListNodeOfListOfEdge_2 extends MAT_TListNodeOfListOfEdge {
    constructor(anitem: Handle_MAT_Edge);
  }

export declare class Handle_MAT_Graph {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_Graph): void;
  get(): MAT_Graph;
  delete(): void;
}

  export declare class Handle_MAT_Graph_1 extends Handle_MAT_Graph {
    constructor();
  }

  export declare class Handle_MAT_Graph_2 extends Handle_MAT_Graph {
    constructor(thePtr: MAT_Graph);
  }

  export declare class Handle_MAT_Graph_3 extends Handle_MAT_Graph {
    constructor(theHandle: Handle_MAT_Graph);
  }

  export declare class Handle_MAT_Graph_4 extends Handle_MAT_Graph {
    constructor(theHandle: Handle_MAT_Graph);
  }

export declare class MAT_Graph extends Standard_Transient {
  constructor()
  Perform(SemiInfinite: Standard_Boolean, TheRoots: Handle_MAT_ListOfBisector, NbBasicElts: Graphic3d_ZLayerId, NbArcs: Graphic3d_ZLayerId): void;
  Arc(Index: Graphic3d_ZLayerId): Handle_MAT_Arc;
  BasicElt(Index: Graphic3d_ZLayerId): Handle_MAT_BasicElt;
  Node(Index: Graphic3d_ZLayerId): Handle_MAT_Node;
  NumberOfArcs(): Graphic3d_ZLayerId;
  NumberOfNodes(): Graphic3d_ZLayerId;
  NumberOfBasicElts(): Graphic3d_ZLayerId;
  NumberOfInfiniteNodes(): Graphic3d_ZLayerId;
  FusionOfBasicElts(IndexElt1: Graphic3d_ZLayerId, IndexElt2: Graphic3d_ZLayerId, MergeArc1: Standard_Boolean, GeomIndexArc1: Graphic3d_ZLayerId, GeomIndexArc2: Graphic3d_ZLayerId, MergeArc2: Standard_Boolean, GeomIndexArc3: Graphic3d_ZLayerId, GeomIndexArc4: Graphic3d_ZLayerId): void;
  CompactArcs(): void;
  CompactNodes(): void;
  ChangeBasicElts(NewMap: MAT_DataMapOfIntegerBasicElt): void;
  ChangeBasicElt(Index: Graphic3d_ZLayerId): Handle_MAT_BasicElt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class MAT_ListOfEdge extends Standard_Transient {
  constructor()
  First(): void;
  Last(): void;
  Init(aniten: Handle_MAT_Edge): void;
  Next(): void;
  Previous(): void;
  More(): Standard_Boolean;
  Current_1(): Handle_MAT_Edge;
  Current_2(anitem: Handle_MAT_Edge): void;
  FirstItem(): Handle_MAT_Edge;
  LastItem(): Handle_MAT_Edge;
  PreviousItem(): Handle_MAT_Edge;
  NextItem(): Handle_MAT_Edge;
  Number(): Graphic3d_ZLayerId;
  Index(): Graphic3d_ZLayerId;
  Brackets(anindex: Graphic3d_ZLayerId): Handle_MAT_Edge;
  Unlink(): void;
  LinkBefore(anitem: Handle_MAT_Edge): void;
  LinkAfter(anitem: Handle_MAT_Edge): void;
  FrontAdd(anitem: Handle_MAT_Edge): void;
  BackAdd(anitem: Handle_MAT_Edge): void;
  Permute(): void;
  Loop(): void;
  IsEmpty(): Standard_Boolean;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MAT_ListOfEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_ListOfEdge): void;
  get(): MAT_ListOfEdge;
  delete(): void;
}

  export declare class Handle_MAT_ListOfEdge_1 extends Handle_MAT_ListOfEdge {
    constructor();
  }

  export declare class Handle_MAT_ListOfEdge_2 extends Handle_MAT_ListOfEdge {
    constructor(thePtr: MAT_ListOfEdge);
  }

  export declare class Handle_MAT_ListOfEdge_3 extends Handle_MAT_ListOfEdge {
    constructor(theHandle: Handle_MAT_ListOfEdge);
  }

  export declare class Handle_MAT_ListOfEdge_4 extends Handle_MAT_ListOfEdge {
    constructor(theHandle: Handle_MAT_ListOfEdge);
  }

export declare class Handle_MAT_Bisector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_Bisector): void;
  get(): MAT_Bisector;
  delete(): void;
}

  export declare class Handle_MAT_Bisector_1 extends Handle_MAT_Bisector {
    constructor();
  }

  export declare class Handle_MAT_Bisector_2 extends Handle_MAT_Bisector {
    constructor(thePtr: MAT_Bisector);
  }

  export declare class Handle_MAT_Bisector_3 extends Handle_MAT_Bisector {
    constructor(theHandle: Handle_MAT_Bisector);
  }

  export declare class Handle_MAT_Bisector_4 extends Handle_MAT_Bisector {
    constructor(theHandle: Handle_MAT_Bisector);
  }

export declare class MAT_Bisector extends Standard_Transient {
  constructor()
  AddBisector(abisector: Handle_MAT_Bisector): void;
  List(): Handle_MAT_ListOfBisector;
  FirstBisector(): Handle_MAT_Bisector;
  LastBisector(): Handle_MAT_Bisector;
  BisectorNumber_1(anumber: Graphic3d_ZLayerId): void;
  IndexNumber_1(anumber: Graphic3d_ZLayerId): void;
  FirstEdge_1(anedge: Handle_MAT_Edge): void;
  SecondEdge_1(anedge: Handle_MAT_Edge): void;
  IssuePoint_1(apoint: Graphic3d_ZLayerId): void;
  EndPoint_1(apoint: Graphic3d_ZLayerId): void;
  DistIssuePoint_1(areal: Quantity_AbsorbedDose): void;
  FirstVector_1(avector: Graphic3d_ZLayerId): void;
  SecondVector_1(avector: Graphic3d_ZLayerId): void;
  Sense_1(asense: Quantity_AbsorbedDose): void;
  FirstParameter_1(aparameter: Quantity_AbsorbedDose): void;
  SecondParameter_1(aparameter: Quantity_AbsorbedDose): void;
  BisectorNumber_2(): Graphic3d_ZLayerId;
  IndexNumber_2(): Graphic3d_ZLayerId;
  FirstEdge_2(): Handle_MAT_Edge;
  SecondEdge_2(): Handle_MAT_Edge;
  IssuePoint_2(): Graphic3d_ZLayerId;
  EndPoint_2(): Graphic3d_ZLayerId;
  DistIssuePoint_2(): Quantity_AbsorbedDose;
  FirstVector_2(): Graphic3d_ZLayerId;
  SecondVector_2(): Graphic3d_ZLayerId;
  Sense_2(): Quantity_AbsorbedDose;
  FirstParameter_2(): Quantity_AbsorbedDose;
  SecondParameter_2(): Quantity_AbsorbedDose;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MAT_TListNodeOfListOfBisector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_TListNodeOfListOfBisector): void;
  get(): MAT_TListNodeOfListOfBisector;
  delete(): void;
}

  export declare class Handle_MAT_TListNodeOfListOfBisector_1 extends Handle_MAT_TListNodeOfListOfBisector {
    constructor();
  }

  export declare class Handle_MAT_TListNodeOfListOfBisector_2 extends Handle_MAT_TListNodeOfListOfBisector {
    constructor(thePtr: MAT_TListNodeOfListOfBisector);
  }

  export declare class Handle_MAT_TListNodeOfListOfBisector_3 extends Handle_MAT_TListNodeOfListOfBisector {
    constructor(theHandle: Handle_MAT_TListNodeOfListOfBisector);
  }

  export declare class Handle_MAT_TListNodeOfListOfBisector_4 extends Handle_MAT_TListNodeOfListOfBisector {
    constructor(theHandle: Handle_MAT_TListNodeOfListOfBisector);
  }

export declare class MAT_TListNodeOfListOfBisector extends Standard_Transient {
  GetItem(): Handle_MAT_Bisector;
  Next_1(): Handle_MAT_TListNodeOfListOfBisector;
  Previous_1(): Handle_MAT_TListNodeOfListOfBisector;
  SetItem(anitem: Handle_MAT_Bisector): void;
  Next_2(atlistnode: Handle_MAT_TListNodeOfListOfBisector): void;
  Previous_2(atlistnode: Handle_MAT_TListNodeOfListOfBisector): void;
  Dummy(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class MAT_TListNodeOfListOfBisector_1 extends MAT_TListNodeOfListOfBisector {
    constructor();
  }

  export declare class MAT_TListNodeOfListOfBisector_2 extends MAT_TListNodeOfListOfBisector {
    constructor(anitem: Handle_MAT_Bisector);
  }

export declare class Handle_MAT_Node {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_Node): void;
  get(): MAT_Node;
  delete(): void;
}

  export declare class Handle_MAT_Node_1 extends Handle_MAT_Node {
    constructor();
  }

  export declare class Handle_MAT_Node_2 extends Handle_MAT_Node {
    constructor(thePtr: MAT_Node);
  }

  export declare class Handle_MAT_Node_3 extends Handle_MAT_Node {
    constructor(theHandle: Handle_MAT_Node);
  }

  export declare class Handle_MAT_Node_4 extends Handle_MAT_Node {
    constructor(theHandle: Handle_MAT_Node);
  }

export declare class MAT_Node extends Standard_Transient {
  constructor(GeomIndex: Graphic3d_ZLayerId, LinkedArc: Handle_MAT_Arc, Distance: Quantity_AbsorbedDose)
  GeomIndex(): Graphic3d_ZLayerId;
  Index(): Graphic3d_ZLayerId;
  LinkedArcs(S: MAT_SequenceOfArc): void;
  NearElts(S: MAT_SequenceOfBasicElt): void;
  Distance(): Quantity_AbsorbedDose;
  PendingNode(): Standard_Boolean;
  OnBasicElt(): Standard_Boolean;
  Infinite(): Standard_Boolean;
  SetIndex(anIndex: Graphic3d_ZLayerId): void;
  SetLinkedArc(anArc: Handle_MAT_Arc): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class MAT_Zone extends Standard_Transient {
  Perform(aBasicElt: Handle_MAT_BasicElt): void;
  NumberOfArcs(): Graphic3d_ZLayerId;
  ArcOnFrontier(Index: Graphic3d_ZLayerId): Handle_MAT_Arc;
  NoEmptyZone(): Standard_Boolean;
  Limited(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class MAT_Zone_1 extends MAT_Zone {
    constructor();
  }

  export declare class MAT_Zone_2 extends MAT_Zone {
    constructor(aBasicElt: Handle_MAT_BasicElt);
  }

export declare class Handle_MAT_Zone {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_Zone): void;
  get(): MAT_Zone;
  delete(): void;
}

  export declare class Handle_MAT_Zone_1 extends Handle_MAT_Zone {
    constructor();
  }

  export declare class Handle_MAT_Zone_2 extends Handle_MAT_Zone {
    constructor(thePtr: MAT_Zone);
  }

  export declare class Handle_MAT_Zone_3 extends Handle_MAT_Zone {
    constructor(theHandle: Handle_MAT_Zone);
  }

  export declare class Handle_MAT_Zone_4 extends Handle_MAT_Zone {
    constructor(theHandle: Handle_MAT_Zone);
  }

export declare class MAT_ListOfBisector extends Standard_Transient {
  constructor()
  First(): void;
  Last(): void;
  Init(aniten: Handle_MAT_Bisector): void;
  Next(): void;
  Previous(): void;
  More(): Standard_Boolean;
  Current_1(): Handle_MAT_Bisector;
  Current_2(anitem: Handle_MAT_Bisector): void;
  FirstItem(): Handle_MAT_Bisector;
  LastItem(): Handle_MAT_Bisector;
  PreviousItem(): Handle_MAT_Bisector;
  NextItem(): Handle_MAT_Bisector;
  Number(): Graphic3d_ZLayerId;
  Index(): Graphic3d_ZLayerId;
  Brackets(anindex: Graphic3d_ZLayerId): Handle_MAT_Bisector;
  Unlink(): void;
  LinkBefore(anitem: Handle_MAT_Bisector): void;
  LinkAfter(anitem: Handle_MAT_Bisector): void;
  FrontAdd(anitem: Handle_MAT_Bisector): void;
  BackAdd(anitem: Handle_MAT_Bisector): void;
  Permute(): void;
  Loop(): void;
  IsEmpty(): Standard_Boolean;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MAT_ListOfBisector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_ListOfBisector): void;
  get(): MAT_ListOfBisector;
  delete(): void;
}

  export declare class Handle_MAT_ListOfBisector_1 extends Handle_MAT_ListOfBisector {
    constructor();
  }

  export declare class Handle_MAT_ListOfBisector_2 extends Handle_MAT_ListOfBisector {
    constructor(thePtr: MAT_ListOfBisector);
  }

  export declare class Handle_MAT_ListOfBisector_3 extends Handle_MAT_ListOfBisector {
    constructor(theHandle: Handle_MAT_ListOfBisector);
  }

  export declare class Handle_MAT_ListOfBisector_4 extends Handle_MAT_ListOfBisector {
    constructor(theHandle: Handle_MAT_ListOfBisector);
  }

export declare type MAT_Side = {
  MAT_Left: {};
  MAT_Right: {};
}

export declare class MAT_BasicElt extends Standard_Transient {
  constructor(anInteger: Graphic3d_ZLayerId)
  StartArc(): Handle_MAT_Arc;
  EndArc(): Handle_MAT_Arc;
  Index(): Graphic3d_ZLayerId;
  GeomIndex(): Graphic3d_ZLayerId;
  SetStartArc(anArc: Handle_MAT_Arc): void;
  SetEndArc(anArc: Handle_MAT_Arc): void;
  SetIndex(anInteger: Graphic3d_ZLayerId): void;
  SetGeomIndex(anInteger: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MAT_BasicElt {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_BasicElt): void;
  get(): MAT_BasicElt;
  delete(): void;
}

  export declare class Handle_MAT_BasicElt_1 extends Handle_MAT_BasicElt {
    constructor();
  }

  export declare class Handle_MAT_BasicElt_2 extends Handle_MAT_BasicElt {
    constructor(thePtr: MAT_BasicElt);
  }

  export declare class Handle_MAT_BasicElt_3 extends Handle_MAT_BasicElt {
    constructor(theHandle: Handle_MAT_BasicElt);
  }

  export declare class Handle_MAT_BasicElt_4 extends Handle_MAT_BasicElt {
    constructor(theHandle: Handle_MAT_BasicElt);
  }

export declare class Handle_MAT_Edge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_Edge): void;
  get(): MAT_Edge;
  delete(): void;
}

  export declare class Handle_MAT_Edge_1 extends Handle_MAT_Edge {
    constructor();
  }

  export declare class Handle_MAT_Edge_2 extends Handle_MAT_Edge {
    constructor(thePtr: MAT_Edge);
  }

  export declare class Handle_MAT_Edge_3 extends Handle_MAT_Edge {
    constructor(theHandle: Handle_MAT_Edge);
  }

  export declare class Handle_MAT_Edge_4 extends Handle_MAT_Edge {
    constructor(theHandle: Handle_MAT_Edge);
  }

export declare class MAT_Edge extends Standard_Transient {
  constructor()
  EdgeNumber_1(anumber: Graphic3d_ZLayerId): void;
  FirstBisector_1(abisector: Handle_MAT_Bisector): void;
  SecondBisector_1(abisector: Handle_MAT_Bisector): void;
  Distance_1(adistance: Quantity_AbsorbedDose): void;
  IntersectionPoint_1(apoint: Graphic3d_ZLayerId): void;
  EdgeNumber_2(): Graphic3d_ZLayerId;
  FirstBisector_2(): Handle_MAT_Bisector;
  SecondBisector_2(): Handle_MAT_Bisector;
  Distance_2(): Quantity_AbsorbedDose;
  IntersectionPoint_2(): Graphic3d_ZLayerId;
  Dump(ashift: Graphic3d_ZLayerId, alevel: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class MAT_Arc extends Standard_Transient {
  constructor(ArcIndex: Graphic3d_ZLayerId, GeomIndex: Graphic3d_ZLayerId, FirstElement: Handle_MAT_BasicElt, SecondElement: Handle_MAT_BasicElt)
  Index(): Graphic3d_ZLayerId;
  GeomIndex(): Graphic3d_ZLayerId;
  FirstElement(): Handle_MAT_BasicElt;
  SecondElement(): Handle_MAT_BasicElt;
  FirstNode(): Handle_MAT_Node;
  SecondNode(): Handle_MAT_Node;
  TheOtherNode(aNode: Handle_MAT_Node): Handle_MAT_Node;
  HasNeighbour(aNode: Handle_MAT_Node, aSide: MAT_Side): Standard_Boolean;
  Neighbour(aNode: Handle_MAT_Node, aSide: MAT_Side): Handle_MAT_Arc;
  SetIndex(anInteger: Graphic3d_ZLayerId): void;
  SetGeomIndex(anInteger: Graphic3d_ZLayerId): void;
  SetFirstElement(aBasicElt: Handle_MAT_BasicElt): void;
  SetSecondElement(aBasicElt: Handle_MAT_BasicElt): void;
  SetFirstNode(aNode: Handle_MAT_Node): void;
  SetSecondNode(aNode: Handle_MAT_Node): void;
  SetFirstArc(aSide: MAT_Side, anArc: Handle_MAT_Arc): void;
  SetSecondArc(aSide: MAT_Side, anArc: Handle_MAT_Arc): void;
  SetNeighbour(aSide: MAT_Side, aNode: Handle_MAT_Node, anArc: Handle_MAT_Arc): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MAT_Arc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MAT_Arc): void;
  get(): MAT_Arc;
  delete(): void;
}

  export declare class Handle_MAT_Arc_1 extends Handle_MAT_Arc {
    constructor();
  }

  export declare class Handle_MAT_Arc_2 extends Handle_MAT_Arc {
    constructor(thePtr: MAT_Arc);
  }

  export declare class Handle_MAT_Arc_3 extends Handle_MAT_Arc {
    constructor(theHandle: Handle_MAT_Arc);
  }

  export declare class Handle_MAT_Arc_4 extends Handle_MAT_Arc {
    constructor(theHandle: Handle_MAT_Arc);
  }

export declare class StdLPersistent_NamedData {
  constructor();
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(a0: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TDataStd_NamedData): void;
  delete(): void;
}

export declare class StdLPersistent_Void {
  constructor();
  delete(): void;
}

export declare class StdLPersistent_Data extends StdObjMgt_Persistent {
  constructor()
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(theChildren: any): void;
  PName(): Standard_CString;
  Import(): Handle_TDF_Data;
  delete(): void;
}

export declare class StdLPersistent {
  constructor();
  static BindTypes(theMap: StdObjMgt_MapOfInstantiators): void;
  delete(): void;
}

export declare class StdLPersistent_Document extends StdObjMgt_Persistent {
  constructor();
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(a0: any): void;
  PName(): Standard_CString;
  ImportDocument(theDocument: Handle_TDocStd_Document): void;
  delete(): void;
}

export declare class StdLPersistent_Value {
  constructor();
  delete(): void;
}

export declare class StdLPersistent_HString {
  constructor();
  delete(): void;
}

export declare class StdLPersistent_Dependency {
  constructor();
  delete(): void;
}

export declare class StdLPersistent_Real {
  constructor()
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(a0: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TDataStd_Real): void;
  delete(): void;
}

export declare class StdLPersistent_XLink {
  constructor();
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(theChildren: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TDocStd_XLink): void;
  delete(): void;
}

export declare class StdLPersistent_Variable {
  constructor()
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(theChildren: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TDataStd_Variable): void;
  delete(): void;
}

export declare class StdLPersistent_Collection {
  constructor();
  delete(): void;
}

export declare class StdLPersistent_HArray1 {
  constructor();
  delete(): void;
}

export declare class Handle_StdLPersistent_HArray1OfPersistent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdLPersistent_HArray1OfPersistent): void;
  get(): StdLPersistent_HArray1OfPersistent;
  delete(): void;
}

  export declare class Handle_StdLPersistent_HArray1OfPersistent_1 extends Handle_StdLPersistent_HArray1OfPersistent {
    constructor();
  }

  export declare class Handle_StdLPersistent_HArray1OfPersistent_2 extends Handle_StdLPersistent_HArray1OfPersistent {
    constructor(thePtr: StdLPersistent_HArray1OfPersistent);
  }

  export declare class Handle_StdLPersistent_HArray1OfPersistent_3 extends Handle_StdLPersistent_HArray1OfPersistent {
    constructor(theHandle: Handle_StdLPersistent_HArray1OfPersistent);
  }

  export declare class Handle_StdLPersistent_HArray1OfPersistent_4 extends Handle_StdLPersistent_HArray1OfPersistent {
    constructor(theHandle: Handle_StdLPersistent_HArray1OfPersistent);
  }

export declare class StdLPersistent_Function {
  constructor()
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(a0: any): void;
  PName(): Standard_CString;
  Import(theAttribute: Handle_TFunction_Function): void;
  delete(): void;
}

export declare class Handle_StdLPersistent_HArray2OfPersistent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdLPersistent_HArray2OfPersistent): void;
  get(): StdLPersistent_HArray2OfPersistent;
  delete(): void;
}

  export declare class Handle_StdLPersistent_HArray2OfPersistent_1 extends Handle_StdLPersistent_HArray2OfPersistent {
    constructor();
  }

  export declare class Handle_StdLPersistent_HArray2OfPersistent_2 extends Handle_StdLPersistent_HArray2OfPersistent {
    constructor(thePtr: StdLPersistent_HArray2OfPersistent);
  }

  export declare class Handle_StdLPersistent_HArray2OfPersistent_3 extends Handle_StdLPersistent_HArray2OfPersistent {
    constructor(theHandle: Handle_StdLPersistent_HArray2OfPersistent);
  }

  export declare class Handle_StdLPersistent_HArray2OfPersistent_4 extends Handle_StdLPersistent_HArray2OfPersistent {
    constructor(theHandle: Handle_StdLPersistent_HArray2OfPersistent);
  }

export declare class StdLPersistent_HArray2 {
  constructor();
  delete(): void;
}

export declare class StdLPersistent_TreeNode {
  constructor();
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(a0: any): void;
  PName(): Standard_CString;
  CreateAttribute(): Handle_TDF_Attribute;
  ImportAttribute(): void;
  delete(): void;
}

export declare class Handle_GeomEvaluator_Surface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomEvaluator_Surface): void;
  get(): GeomEvaluator_Surface;
  delete(): void;
}

  export declare class Handle_GeomEvaluator_Surface_1 extends Handle_GeomEvaluator_Surface {
    constructor();
  }

  export declare class Handle_GeomEvaluator_Surface_2 extends Handle_GeomEvaluator_Surface {
    constructor(thePtr: GeomEvaluator_Surface);
  }

  export declare class Handle_GeomEvaluator_Surface_3 extends Handle_GeomEvaluator_Surface {
    constructor(theHandle: Handle_GeomEvaluator_Surface);
  }

  export declare class Handle_GeomEvaluator_Surface_4 extends Handle_GeomEvaluator_Surface {
    constructor(theHandle: Handle_GeomEvaluator_Surface);
  }

export declare class GeomEvaluator_Surface extends Standard_Transient {
  D0(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec): void;
  D3(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec, theD3U: gp_Vec, theD3V: gp_Vec, theD3UUV: gp_Vec, theD3UVV: gp_Vec): void;
  DN(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theDerU: Graphic3d_ZLayerId, theDerV: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomEvaluator_Curve extends Standard_Transient {
  D0(theU: Quantity_AbsorbedDose, theValue: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1: gp_Vec, theD2: gp_Vec): void;
  D3(theU: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1: gp_Vec, theD2: gp_Vec, theD3: gp_Vec): void;
  DN(theU: Quantity_AbsorbedDose, theDerU: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomEvaluator_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomEvaluator_Curve): void;
  get(): GeomEvaluator_Curve;
  delete(): void;
}

  export declare class Handle_GeomEvaluator_Curve_1 extends Handle_GeomEvaluator_Curve {
    constructor();
  }

  export declare class Handle_GeomEvaluator_Curve_2 extends Handle_GeomEvaluator_Curve {
    constructor(thePtr: GeomEvaluator_Curve);
  }

  export declare class Handle_GeomEvaluator_Curve_3 extends Handle_GeomEvaluator_Curve {
    constructor(theHandle: Handle_GeomEvaluator_Curve);
  }

  export declare class Handle_GeomEvaluator_Curve_4 extends Handle_GeomEvaluator_Curve {
    constructor(theHandle: Handle_GeomEvaluator_Curve);
  }

export declare class GeomEvaluator_SurfaceOfExtrusion extends GeomEvaluator_Surface {
  SetDirection(theDirection: gp_Dir): void;
  D0(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec): void;
  D3(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec, theD3U: gp_Vec, theD3V: gp_Vec, theD3UUV: gp_Vec, theD3UVV: gp_Vec): void;
  DN(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theDerU: Graphic3d_ZLayerId, theDerV: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomEvaluator_SurfaceOfExtrusion_1 extends GeomEvaluator_SurfaceOfExtrusion {
    constructor(theBase: Handle_Geom_Curve, theExtrusionDir: gp_Dir);
  }

  export declare class GeomEvaluator_SurfaceOfExtrusion_2 extends GeomEvaluator_SurfaceOfExtrusion {
    constructor(theBase: Handle_Adaptor3d_HCurve, theExtrusionDir: gp_Dir);
  }

export declare class Handle_GeomEvaluator_SurfaceOfExtrusion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomEvaluator_SurfaceOfExtrusion): void;
  get(): GeomEvaluator_SurfaceOfExtrusion;
  delete(): void;
}

  export declare class Handle_GeomEvaluator_SurfaceOfExtrusion_1 extends Handle_GeomEvaluator_SurfaceOfExtrusion {
    constructor();
  }

  export declare class Handle_GeomEvaluator_SurfaceOfExtrusion_2 extends Handle_GeomEvaluator_SurfaceOfExtrusion {
    constructor(thePtr: GeomEvaluator_SurfaceOfExtrusion);
  }

  export declare class Handle_GeomEvaluator_SurfaceOfExtrusion_3 extends Handle_GeomEvaluator_SurfaceOfExtrusion {
    constructor(theHandle: Handle_GeomEvaluator_SurfaceOfExtrusion);
  }

  export declare class Handle_GeomEvaluator_SurfaceOfExtrusion_4 extends Handle_GeomEvaluator_SurfaceOfExtrusion {
    constructor(theHandle: Handle_GeomEvaluator_SurfaceOfExtrusion);
  }

export declare class Handle_GeomEvaluator_OffsetCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomEvaluator_OffsetCurve): void;
  get(): GeomEvaluator_OffsetCurve;
  delete(): void;
}

  export declare class Handle_GeomEvaluator_OffsetCurve_1 extends Handle_GeomEvaluator_OffsetCurve {
    constructor();
  }

  export declare class Handle_GeomEvaluator_OffsetCurve_2 extends Handle_GeomEvaluator_OffsetCurve {
    constructor(thePtr: GeomEvaluator_OffsetCurve);
  }

  export declare class Handle_GeomEvaluator_OffsetCurve_3 extends Handle_GeomEvaluator_OffsetCurve {
    constructor(theHandle: Handle_GeomEvaluator_OffsetCurve);
  }

  export declare class Handle_GeomEvaluator_OffsetCurve_4 extends Handle_GeomEvaluator_OffsetCurve {
    constructor(theHandle: Handle_GeomEvaluator_OffsetCurve);
  }

export declare class GeomEvaluator_OffsetCurve extends GeomEvaluator_Curve {
  SetOffsetValue(theOffset: Quantity_AbsorbedDose): void;
  SetOffsetDirection(theDirection: gp_Dir): void;
  D0(theU: Quantity_AbsorbedDose, theValue: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1: gp_Vec, theD2: gp_Vec): void;
  D3(theU: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1: gp_Vec, theD2: gp_Vec, theD3: gp_Vec): void;
  DN(theU: Quantity_AbsorbedDose, theDeriv: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomEvaluator_OffsetCurve_1 extends GeomEvaluator_OffsetCurve {
    constructor(theBase: Handle_Geom_Curve, theOffset: Quantity_AbsorbedDose, theDirection: gp_Dir);
  }

  export declare class GeomEvaluator_OffsetCurve_2 extends GeomEvaluator_OffsetCurve {
    constructor(theBase: Handle_GeomAdaptor_HCurve, theOffset: Quantity_AbsorbedDose, theDirection: gp_Dir);
  }

export declare class GeomEvaluator_SurfaceOfRevolution extends GeomEvaluator_Surface {
  SetDirection(theDirection: gp_Dir): void;
  SetLocation(theLocation: gp_Pnt): void;
  SetAxis(theAxis: gp_Ax1): void;
  D0(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec): void;
  D3(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec, theD3U: gp_Vec, theD3V: gp_Vec, theD3UUV: gp_Vec, theD3UVV: gp_Vec): void;
  DN(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theDerU: Graphic3d_ZLayerId, theDerV: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomEvaluator_SurfaceOfRevolution_1 extends GeomEvaluator_SurfaceOfRevolution {
    constructor(theBase: Handle_Geom_Curve, theRevolDir: gp_Dir, theRevolLoc: gp_Pnt);
  }

  export declare class GeomEvaluator_SurfaceOfRevolution_2 extends GeomEvaluator_SurfaceOfRevolution {
    constructor(theBase: Handle_Adaptor3d_HCurve, theRevolDir: gp_Dir, theRevolLoc: gp_Pnt);
  }

export declare class Handle_GeomEvaluator_SurfaceOfRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomEvaluator_SurfaceOfRevolution): void;
  get(): GeomEvaluator_SurfaceOfRevolution;
  delete(): void;
}

  export declare class Handle_GeomEvaluator_SurfaceOfRevolution_1 extends Handle_GeomEvaluator_SurfaceOfRevolution {
    constructor();
  }

  export declare class Handle_GeomEvaluator_SurfaceOfRevolution_2 extends Handle_GeomEvaluator_SurfaceOfRevolution {
    constructor(thePtr: GeomEvaluator_SurfaceOfRevolution);
  }

  export declare class Handle_GeomEvaluator_SurfaceOfRevolution_3 extends Handle_GeomEvaluator_SurfaceOfRevolution {
    constructor(theHandle: Handle_GeomEvaluator_SurfaceOfRevolution);
  }

  export declare class Handle_GeomEvaluator_SurfaceOfRevolution_4 extends Handle_GeomEvaluator_SurfaceOfRevolution {
    constructor(theHandle: Handle_GeomEvaluator_SurfaceOfRevolution);
  }

export declare class GeomEvaluator_OffsetSurface extends GeomEvaluator_Surface {
  SetOffsetValue(theOffset: Quantity_AbsorbedDose): void;
  D0(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec): void;
  D3(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theValue: gp_Pnt, theD1U: gp_Vec, theD1V: gp_Vec, theD2U: gp_Vec, theD2V: gp_Vec, theD2UV: gp_Vec, theD3U: gp_Vec, theD3V: gp_Vec, theD3UUV: gp_Vec, theD3UVV: gp_Vec): void;
  DN(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theDerU: Graphic3d_ZLayerId, theDerV: Graphic3d_ZLayerId): gp_Vec;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomEvaluator_OffsetSurface_1 extends GeomEvaluator_OffsetSurface {
    constructor(theBase: Handle_Geom_Surface, theOffset: Quantity_AbsorbedDose, theOscSurf: Handle_Geom_OsculatingSurface);
  }

  export declare class GeomEvaluator_OffsetSurface_2 extends GeomEvaluator_OffsetSurface {
    constructor(theBase: Handle_GeomAdaptor_HSurface, theOffset: Quantity_AbsorbedDose, theOscSurf: Handle_Geom_OsculatingSurface);
  }

export declare class Handle_GeomEvaluator_OffsetSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomEvaluator_OffsetSurface): void;
  get(): GeomEvaluator_OffsetSurface;
  delete(): void;
}

  export declare class Handle_GeomEvaluator_OffsetSurface_1 extends Handle_GeomEvaluator_OffsetSurface {
    constructor();
  }

  export declare class Handle_GeomEvaluator_OffsetSurface_2 extends Handle_GeomEvaluator_OffsetSurface {
    constructor(thePtr: GeomEvaluator_OffsetSurface);
  }

  export declare class Handle_GeomEvaluator_OffsetSurface_3 extends Handle_GeomEvaluator_OffsetSurface {
    constructor(theHandle: Handle_GeomEvaluator_OffsetSurface);
  }

  export declare class Handle_GeomEvaluator_OffsetSurface_4 extends Handle_GeomEvaluator_OffsetSurface {
    constructor(theHandle: Handle_GeomEvaluator_OffsetSurface);
  }

export declare class Handle_ShapeBuild_ReShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeBuild_ReShape): void;
  get(): ShapeBuild_ReShape;
  delete(): void;
}

  export declare class Handle_ShapeBuild_ReShape_1 extends Handle_ShapeBuild_ReShape {
    constructor();
  }

  export declare class Handle_ShapeBuild_ReShape_2 extends Handle_ShapeBuild_ReShape {
    constructor(thePtr: ShapeBuild_ReShape);
  }

  export declare class Handle_ShapeBuild_ReShape_3 extends Handle_ShapeBuild_ReShape {
    constructor(theHandle: Handle_ShapeBuild_ReShape);
  }

  export declare class Handle_ShapeBuild_ReShape_4 extends Handle_ShapeBuild_ReShape {
    constructor(theHandle: Handle_ShapeBuild_ReShape);
  }

export declare class ShapeBuild_ReShape extends BRepTools_ReShape {
  constructor()
  Apply_1(shape: TopoDS_Shape, until: TopAbs_ShapeEnum, buildmode: Graphic3d_ZLayerId): TopoDS_Shape;
  Apply_2(shape: TopoDS_Shape, until: TopAbs_ShapeEnum): TopoDS_Shape;
  Status_1(shape: TopoDS_Shape, newsh: TopoDS_Shape, last: Standard_Boolean): Graphic3d_ZLayerId;
  Status_2(status: ShapeExtend_Status): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeBuild_Edge {
  constructor();
  CopyReplaceVertices(edge: TopoDS_Edge, V1: TopoDS_Vertex, V2: TopoDS_Vertex): TopoDS_Edge;
  CopyRanges(toedge: TopoDS_Edge, fromedge: TopoDS_Edge, alpha: Quantity_AbsorbedDose, beta: Quantity_AbsorbedDose): void;
  SetRange3d(edge: TopoDS_Edge, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose): void;
  CopyPCurves(toedge: TopoDS_Edge, fromedge: TopoDS_Edge): void;
  Copy(edge: TopoDS_Edge, sharepcurves: Standard_Boolean): TopoDS_Edge;
  RemovePCurve_1(edge: TopoDS_Edge, face: TopoDS_Face): void;
  RemovePCurve_2(edge: TopoDS_Edge, surf: Handle_Geom_Surface): void;
  RemovePCurve_3(edge: TopoDS_Edge, surf: Handle_Geom_Surface, loc: TopLoc_Location): void;
  ReplacePCurve(edge: TopoDS_Edge, pcurve: Handle_Geom2d_Curve, face: TopoDS_Face): void;
  ReassignPCurve(edge: TopoDS_Edge, old: TopoDS_Face, sub: TopoDS_Face): Standard_Boolean;
  TransformPCurve(pcurve: Handle_Geom2d_Curve, trans: gp_Trsf2d, uFact: Quantity_AbsorbedDose, aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  RemoveCurve3d(edge: TopoDS_Edge): void;
  BuildCurve3d(edge: TopoDS_Edge): Standard_Boolean;
  MakeEdge_1(edge: TopoDS_Edge, curve: Handle_Geom_Curve, L: TopLoc_Location): void;
  MakeEdge_2(edge: TopoDS_Edge, curve: Handle_Geom_Curve, L: TopLoc_Location, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  MakeEdge_3(edge: TopoDS_Edge, pcurve: Handle_Geom2d_Curve, face: TopoDS_Face): void;
  MakeEdge_4(edge: TopoDS_Edge, pcurve: Handle_Geom2d_Curve, face: TopoDS_Face, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  MakeEdge_5(edge: TopoDS_Edge, pcurve: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location): void;
  MakeEdge_6(edge: TopoDS_Edge, pcurve: Handle_Geom2d_Curve, S: Handle_Geom_Surface, L: TopLoc_Location, p1: Quantity_AbsorbedDose, p2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class ShapeBuild {
  constructor();
  static PlaneXOY(): Handle_Geom_Plane;
  delete(): void;
}

export declare class ShapeBuild_Vertex {
  constructor();
  CombineVertex_1(V1: TopoDS_Vertex, V2: TopoDS_Vertex, tolFactor: Quantity_AbsorbedDose): TopoDS_Vertex;
  CombineVertex_2(pnt1: gp_Pnt, pnt2: gp_Pnt, tol1: Quantity_AbsorbedDose, tol2: Quantity_AbsorbedDose, tolFactor: Quantity_AbsorbedDose): TopoDS_Vertex;
  delete(): void;
}

export declare class RWObj_Material {
  constructor()
  delete(): void;
}

export declare class RWObj_SubMesh {
  constructor();
  delete(): void;
}

export declare class RWObj_MtlReader {
  constructor(theMaterials: NCollection_DataMap<TCollection_AsciiString, RWObj_Material>)
  Read(theFolder: XCAFDoc_PartId, theFile: XCAFDoc_PartId): Standard_Boolean;
  delete(): void;
}

export declare class RWObj {
  constructor();
  static ReadFile(theFile: Standard_CString, aProgress: Message_ProgressRange): Handle_Poly_Triangulation;
  delete(): void;
}

export declare class RWObj_CafReader extends RWMesh_CafReader {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsSinglePrecision(): Standard_Boolean;
  SetSinglePrecision(theIsSinglePrecision: Standard_Boolean): void;
  delete(): void;
}

export declare type RWObj_SubMeshReason = {
  RWObj_SubMeshReason_NewObject: {};
  RWObj_SubMeshReason_NewGroup: {};
  RWObj_SubMeshReason_NewMaterial: {};
  RWObj_SubMeshReason_NewSmoothGroup: {};
}

export declare class RWObj_IShapeReceiver {
  BindNamedShape(theShape: TopoDS_Shape, theName: XCAFDoc_PartId, theMaterial: RWObj_Material, theIsRootShape: Standard_Boolean): void;
  delete(): void;
}

export declare class RWObj_TriangulationReader extends RWObj_Reader {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetCreateShapes(theToCreateShapes: Standard_Boolean): void;
  SetShapeReceiver(theReceiver: RWObj_IShapeReceiver): void;
  GetTriangulation(): Handle_Poly_Triangulation;
  ResultShape(): TopoDS_Shape;
  delete(): void;
}

export declare class RWObj_Reader extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Read(theFile: XCAFDoc_PartId, theProgress: Message_ProgressRange): Standard_Boolean;
  Probe(theFile: XCAFDoc_PartId, theProgress: Message_ProgressRange): Standard_Boolean;
  FileComments(): XCAFDoc_PartId;
  ExternalFiles(): any;
  NbProbeNodes(): Graphic3d_ZLayerId;
  NbProbeElems(): Graphic3d_ZLayerId;
  MemoryLimit(): Standard_ThreadId;
  SetMemoryLimit(theMemLimit: Standard_ThreadId): void;
  Transformation(): RWMesh_CoordinateSystemConverter;
  SetTransformation(theCSConverter: RWMesh_CoordinateSystemConverter): void;
  IsSinglePrecision(): Standard_Boolean;
  SetSinglePrecision(theIsSinglePrecision: Standard_Boolean): void;
  delete(): void;
}

export declare class Geom2dGcc_CurveTool {
  constructor();
  static FirstParameter(C: Geom2dAdaptor_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: Geom2dAdaptor_Curve): Quantity_AbsorbedDose;
  static EpsX(C: Geom2dAdaptor_Curve, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static NbSamples(C: Geom2dAdaptor_Curve): Graphic3d_ZLayerId;
  static Value(C: Geom2dAdaptor_Curve, X: Quantity_AbsorbedDose): gp_Pnt2d;
  static D1(C: Geom2dAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d): void;
  static D2(C: Geom2dAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d, N: gp_Vec2d): void;
  static D3(C: Geom2dAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d, N: gp_Vec2d, dN: gp_Vec2d): void;
  delete(): void;
}

export declare class Geom2dGcc_Circ2d2TanRad {
  Results_1(Circ: GccAna_Circ2d2TanRad): void;
  Results_2(Circ: Geom2dGcc_Circ2d2TanRadGeo): void;
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d2TanRad_1 extends Geom2dGcc_Circ2d2TanRad {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Qualified2: Geom2dGcc_QualifiedCurve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanRad_2 extends Geom2dGcc_Circ2d2TanRad {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Point: Handle_Geom2d_Point, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanRad_3 extends Geom2dGcc_Circ2d2TanRad {
    constructor(Point1: Handle_Geom2d_Point, Point2: Handle_Geom2d_Point, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Lin2dTanOblIter {
  constructor(Qualified1: Geom2dGcc_QCurve, TheLin: gp_Lin2d, Param1: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ThisSolution(): gp_Lin2d;
  WhichQualifier(Qualif1: GccEnt_Position): void;
  Tangency1(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Intersection2(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsParallel2(): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dGcc_Circ2d3TanIter {
  IsDone(): Standard_Boolean;
  ThisSolution(): gp_Circ2d;
  WhichQualifier(Qualif1: GccEnt_Position, Qualif2: GccEnt_Position, Qualif3: GccEnt_Position): void;
  Tangency1(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency3(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(): Standard_Boolean;
  IsTheSame2(): Standard_Boolean;
  IsTheSame3(): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d3TanIter_1 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, Qualified3: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_2 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, Qualified3: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_3 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, Qualified3: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_4 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, Point3: gp_Pnt2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_5 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, Qualified3: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_6 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: Geom2dGcc_QCurve, Qualified3: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_7 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: Geom2dGcc_QCurve, Point3: gp_Pnt2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_8 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Point1: gp_Pnt2d, Point2: gp_Pnt2d, Param1: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_9 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, Point2: gp_Pnt2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3TanIter_10 extends Geom2dGcc_Circ2d3TanIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, Qualified3: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare type Geom2dGcc_Type3 = {
  Geom2dGcc_CuCu: {};
  Geom2dGcc_CiCu: {};
}

export declare class Geom2dGcc_Circ2d2TanRadGeo {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d2TanRadGeo_1 extends Geom2dGcc_Circ2d2TanRadGeo {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanRadGeo_2 extends Geom2dGcc_Circ2d2TanRadGeo {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: Geom2dGcc_QCurve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanRadGeo_3 extends Geom2dGcc_Circ2d2TanRadGeo {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanRadGeo_4 extends Geom2dGcc_Circ2d2TanRadGeo {
    constructor(Qualified1: Geom2dGcc_QCurve, Point2: gp_Pnt2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_QCurve {
  constructor(Curve: Geom2dAdaptor_Curve, Qualifier: GccEnt_Position)
  Qualified(): Geom2dAdaptor_Curve;
  Qualifier(): GccEnt_Position;
  IsUnqualified(): Standard_Boolean;
  IsEnclosing(): Standard_Boolean;
  IsEnclosed(): Standard_Boolean;
  IsOutside(): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dGcc_Circ2d3Tan {
  Results(Circ: GccAna_Circ2d3Tan, Rank1: Graphic3d_ZLayerId, Rank2: Graphic3d_ZLayerId, Rank3: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position, Qualif3: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency3(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame3(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d3Tan_1 extends Geom2dGcc_Circ2d3Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Qualified2: Geom2dGcc_QualifiedCurve, Qualified3: Geom2dGcc_QualifiedCurve, Tolerance: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3Tan_2 extends Geom2dGcc_Circ2d3Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Qualified2: Geom2dGcc_QualifiedCurve, Point: Handle_Geom2d_Point, Tolerance: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3Tan_3 extends Geom2dGcc_Circ2d3Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Point1: Handle_Geom2d_Point, Point2: Handle_Geom2d_Point, Tolerance: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d3Tan_4 extends Geom2dGcc_Circ2d3Tan {
    constructor(Point1: Handle_Geom2d_Point, Point2: Handle_Geom2d_Point, Point3: Handle_Geom2d_Point, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Circ2dTanOnRadGeo {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(Index: Graphic3d_ZLayerId, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2dTanOnRadGeo_1 extends Geom2dGcc_Circ2dTanOnRadGeo {
    constructor(Qualified1: Geom2dGcc_QCurve, OnLine: gp_Lin2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2dTanOnRadGeo_2 extends Geom2dGcc_Circ2dTanOnRadGeo {
    constructor(Qualified1: Geom2dGcc_QCurve, OnCirc: gp_Circ2d, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2dTanOnRadGeo_3 extends Geom2dGcc_Circ2dTanOnRadGeo {
    constructor(Qualified1: GccEnt_QualifiedCirc, OnCurv: Geom2dAdaptor_Curve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2dTanOnRadGeo_4 extends Geom2dGcc_Circ2dTanOnRadGeo {
    constructor(Qualified1: GccEnt_QualifiedLin, OnCurv: Geom2dAdaptor_Curve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2dTanOnRadGeo_5 extends Geom2dGcc_Circ2dTanOnRadGeo {
    constructor(Qualified1: Geom2dGcc_QCurve, OnCurv: Geom2dAdaptor_Curve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2dTanOnRadGeo_6 extends Geom2dGcc_Circ2dTanOnRadGeo {
    constructor(Point1: gp_Pnt2d, OnCurv: Geom2dAdaptor_Curve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare type Geom2dGcc_Type2 = {
  Geom2dGcc_CuCuOnCu: {};
  Geom2dGcc_CiCuOnCu: {};
  Geom2dGcc_LiCuOnCu: {};
  Geom2dGcc_CuPtOnCu: {};
  Geom2dGcc_CuCuOnLi: {};
  Geom2dGcc_CiCuOnLi: {};
  Geom2dGcc_LiCuOnLi: {};
  Geom2dGcc_CuPtOnLi: {};
  Geom2dGcc_CuCuOnCi: {};
  Geom2dGcc_CiCuOnCi: {};
  Geom2dGcc_LiCuOnCi: {};
  Geom2dGcc_CuPtOnCi: {};
}

export declare class Geom2dGcc_Circ2d2TanOnGeo {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(Index: Graphic3d_ZLayerId, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d2TanOnGeo_1 extends Geom2dGcc_Circ2d2TanOnGeo {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedCirc, OnCurv: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnGeo_2 extends Geom2dGcc_Circ2d2TanOnGeo {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: GccEnt_QualifiedLin, OnCurv: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnGeo_3 extends Geom2dGcc_Circ2d2TanOnGeo {
    constructor(Qualified1: GccEnt_QualifiedCirc, Point2: gp_Pnt2d, OnCurv: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnGeo_4 extends Geom2dGcc_Circ2d2TanOnGeo {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: GccEnt_QualifiedLin, OnCurv: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnGeo_5 extends Geom2dGcc_Circ2d2TanOnGeo {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: gp_Pnt2d, OnCurv: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnGeo_6 extends Geom2dGcc_Circ2d2TanOnGeo {
    constructor(Point1: gp_Pnt2d, Point2: gp_Pnt2d, OnCurv: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Circ2dTanOnRad {
  Results_1(Circ: GccAna_Circ2dTanOnRad): void;
  Results_2(Circ: Geom2dGcc_Circ2dTanOnRadGeo): void;
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(Index: Graphic3d_ZLayerId, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2dTanOnRad_1 extends Geom2dGcc_Circ2dTanOnRad {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, OnCurv: Geom2dAdaptor_Curve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2dTanOnRad_2 extends Geom2dGcc_Circ2dTanOnRad {
    constructor(Point1: Handle_Geom2d_Point, OnCurv: Geom2dAdaptor_Curve, Radius: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Lin2d2Tan {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

  export declare class Geom2dGcc_Lin2d2Tan_1 extends Geom2dGcc_Lin2d2Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Qualified2: Geom2dGcc_QualifiedCurve, Tolang: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Lin2d2Tan_2 extends Geom2dGcc_Lin2d2Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, ThePoint: gp_Pnt2d, Tolang: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Lin2d2Tan_3 extends Geom2dGcc_Lin2d2Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Qualified2: Geom2dGcc_QualifiedCurve, Tolang: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Lin2d2Tan_4 extends Geom2dGcc_Lin2d2Tan {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, ThePoint: gp_Pnt2d, Tolang: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_IsParallel extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Geom2dGcc_IsParallel;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2dGcc_IsParallel_1 extends Geom2dGcc_IsParallel {
    constructor();
  }

  export declare class Geom2dGcc_IsParallel_2 extends Geom2dGcc_IsParallel {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Geom2dGcc_IsParallel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2dGcc_IsParallel): void;
  get(): Geom2dGcc_IsParallel;
  delete(): void;
}

  export declare class Handle_Geom2dGcc_IsParallel_1 extends Handle_Geom2dGcc_IsParallel {
    constructor();
  }

  export declare class Handle_Geom2dGcc_IsParallel_2 extends Handle_Geom2dGcc_IsParallel {
    constructor(thePtr: Geom2dGcc_IsParallel);
  }

  export declare class Handle_Geom2dGcc_IsParallel_3 extends Handle_Geom2dGcc_IsParallel {
    constructor(theHandle: Handle_Geom2dGcc_IsParallel);
  }

  export declare class Handle_Geom2dGcc_IsParallel_4 extends Handle_Geom2dGcc_IsParallel {
    constructor(theHandle: Handle_Geom2dGcc_IsParallel);
  }

export declare class Geom2dGcc_FunctionTanObl extends math_FunctionWithDerivative {
  constructor(Curve: Geom2dAdaptor_Curve, Dir: gp_Dir2d)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, Deriv: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, Deriv: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dGcc_FunctionTanCirCu extends math_FunctionWithDerivative {
  constructor(Circ: gp_Circ2d, Curv: Geom2dAdaptor_Curve)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, Deriv: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, Deriv: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dGcc_Lin2dTanObl {
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Lin2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Intersection2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

  export declare class Geom2dGcc_Lin2dTanObl_1 extends Geom2dGcc_Lin2dTanObl {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, TheLin: gp_Lin2d, TolAng: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Lin2dTanObl_2 extends Geom2dGcc_Lin2dTanObl {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, TheLin: gp_Lin2d, TolAng: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Circ2d2TanOnIter {
  IsDone(): Standard_Boolean;
  ThisSolution(): gp_Circ2d;
  WhichQualifier(Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(): Standard_Boolean;
  IsTheSame2(): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d2TanOnIter_1 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, OnLine: gp_Lin2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_2 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: Geom2dGcc_QCurve, OnLine: gp_Lin2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_3 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, OnLine: gp_Lin2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_4 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Point2: gp_Pnt2d, OnLine: gp_Lin2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_5 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, OnCirc: gp_Circ2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_6 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: Geom2dGcc_QCurve, OnCirc: gp_Circ2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_7 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, OnCirc: gp_Circ2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Param3: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_8 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Point2: gp_Pnt2d, OnCirc: gp_Circ2d, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_9 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, OnCurv: Geom2dAdaptor_Curve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, ParamOn: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_10 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: GccEnt_QualifiedLin, Qualified2: Geom2dGcc_QCurve, OnCurve: Geom2dAdaptor_Curve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, ParamOn: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_11 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Point2: gp_Pnt2d, OnCurve: Geom2dAdaptor_Curve, Param1: Quantity_AbsorbedDose, ParamOn: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOnIter_12 extends Geom2dGcc_Circ2d2TanOnIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, OnCurve: Geom2dAdaptor_Curve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, ParamOn: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Circ2d2TanOn {
  Results_1(Circ: GccAna_Circ2d2TanOn): void;
  Results_2(Circ: Geom2dGcc_Circ2d2TanOnGeo): void;
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  CenterOn3(Index: Graphic3d_ZLayerId, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  IsTheSame2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_Circ2d2TanOn_1 extends Geom2dGcc_Circ2d2TanOn {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Qualified2: Geom2dGcc_QualifiedCurve, OnCurve: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, ParamOn: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOn_2 extends Geom2dGcc_Circ2d2TanOn {
    constructor(Qualified1: Geom2dGcc_QualifiedCurve, Point: Handle_Geom2d_Point, OnCurve: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose, Param1: Quantity_AbsorbedDose, ParamOn: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Circ2d2TanOn_3 extends Geom2dGcc_Circ2d2TanOn {
    constructor(Point1: Handle_Geom2d_Point, Point2: Handle_Geom2d_Point, OnCurve: Geom2dAdaptor_Curve, Tolerance: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Circ2dTanCen {
  constructor(Qualified1: Geom2dGcc_QualifiedCurve, Pcenter: Handle_Geom2d_Point, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  IsTheSame1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare type Geom2dGcc_Type1 = {
  Geom2dGcc_CuCuCu: {};
  Geom2dGcc_CiCuCu: {};
  Geom2dGcc_CiCiCu: {};
  Geom2dGcc_CiLiCu: {};
  Geom2dGcc_LiLiCu: {};
  Geom2dGcc_LiCuCu: {};
}

export declare class Geom2dGcc_FunctionTanCuCuOnCu extends math_FunctionSetWithDerivatives {
  InitDerivative(X: math_Vector, Point1: gp_Pnt2d, Point2: gp_Pnt2d, Point3: gp_Pnt2d, Tan1: gp_Vec2d, Tan2: gp_Vec2d, Tan3: gp_Vec2d, D21: gp_Vec2d, D22: gp_Vec2d, D23: gp_Vec2d): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_1 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: Geom2dAdaptor_Curve, C2: Geom2dAdaptor_Curve, OnCi: gp_Circ2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_2 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: gp_Circ2d, C2: Geom2dAdaptor_Curve, OnCi: gp_Circ2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_3 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(L1: gp_Lin2d, C2: Geom2dAdaptor_Curve, OnCi: gp_Circ2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_4 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: Geom2dAdaptor_Curve, P2: gp_Pnt2d, OnCi: gp_Circ2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_5 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: Geom2dAdaptor_Curve, C2: Geom2dAdaptor_Curve, OnLi: gp_Lin2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_6 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: gp_Circ2d, C2: Geom2dAdaptor_Curve, OnLi: gp_Lin2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_7 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(L1: gp_Lin2d, C2: Geom2dAdaptor_Curve, OnLi: gp_Lin2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_8 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: Geom2dAdaptor_Curve, P2: gp_Pnt2d, OnLi: gp_Lin2d, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_9 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: Geom2dAdaptor_Curve, C2: Geom2dAdaptor_Curve, OnCu: Geom2dAdaptor_Curve, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_10 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: gp_Circ2d, C2: Geom2dAdaptor_Curve, OnCu: Geom2dAdaptor_Curve, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_11 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(L1: gp_Lin2d, C2: Geom2dAdaptor_Curve, OnCu: Geom2dAdaptor_Curve, Rad: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_FunctionTanCuCuOnCu_12 extends Geom2dGcc_FunctionTanCuCuOnCu {
    constructor(C1: Geom2dAdaptor_Curve, P1: gp_Pnt2d, OnCu: Geom2dAdaptor_Curve, Rad: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_FunctionTanCuCu extends math_FunctionSetWithDerivatives {
  InitDerivative(X: math_Vector, Point1: gp_Pnt2d, Point2: gp_Pnt2d, Tan1: gp_Vec2d, Tan2: gp_Vec2d, D21: gp_Vec2d, D22: gp_Vec2d): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, Deriv: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, Deriv: math_Matrix): Standard_Boolean;
  delete(): void;
}

  export declare class Geom2dGcc_FunctionTanCuCu_1 extends Geom2dGcc_FunctionTanCuCu {
    constructor(Curv1: Geom2dAdaptor_Curve, Curv2: Geom2dAdaptor_Curve);
  }

  export declare class Geom2dGcc_FunctionTanCuCu_2 extends Geom2dGcc_FunctionTanCuCu {
    constructor(Circ1: gp_Circ2d, Curv2: Geom2dAdaptor_Curve);
  }

export declare class Geom2dGcc_Lin2d2TanIter {
  IsDone(): Standard_Boolean;
  ThisSolution(): gp_Lin2d;
  WhichQualifier(Qualif1: GccEnt_Position, Qualif2: GccEnt_Position): void;
  Tangency1(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  Tangency2(ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

  export declare class Geom2dGcc_Lin2d2TanIter_1 extends Geom2dGcc_Lin2d2TanIter {
    constructor(Qualified1: Geom2dGcc_QCurve, ThePoint: gp_Pnt2d, Param1: Quantity_AbsorbedDose, Tolang: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Lin2d2TanIter_2 extends Geom2dGcc_Lin2d2TanIter {
    constructor(Qualified1: GccEnt_QualifiedCirc, Qualified2: Geom2dGcc_QCurve, Param2: Quantity_AbsorbedDose, Tolang: Quantity_AbsorbedDose);
  }

  export declare class Geom2dGcc_Lin2d2TanIter_3 extends Geom2dGcc_Lin2d2TanIter {
    constructor(Qualified1: Geom2dGcc_QCurve, Qualified2: Geom2dGcc_QCurve, Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose, Tolang: Quantity_AbsorbedDose);
  }

export declare class Geom2dGcc_Circ2dTanCenGeo {
  constructor(Qualified1: Geom2dGcc_QCurve, Pcenter: gp_Pnt2d, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  ThisSolution(Index: Graphic3d_ZLayerId): gp_Circ2d;
  WhichQualifier(Index: Graphic3d_ZLayerId, Qualif1: GccEnt_Position): void;
  Tangency1(Index: Graphic3d_ZLayerId, ParSol: Quantity_AbsorbedDose, ParArg: Quantity_AbsorbedDose, PntSol: gp_Pnt2d): void;
  delete(): void;
}

export declare class Geom2dGcc_FunctionTanCuPnt extends math_FunctionWithDerivative {
  constructor(C: Geom2dAdaptor_Curve, Point: gp_Pnt2d)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, Deriv: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, Deriv: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dGcc {
  constructor();
  static Unqualified(Obj: Geom2dAdaptor_Curve): Geom2dGcc_QualifiedCurve;
  static Enclosing(Obj: Geom2dAdaptor_Curve): Geom2dGcc_QualifiedCurve;
  static Enclosed(Obj: Geom2dAdaptor_Curve): Geom2dGcc_QualifiedCurve;
  static Outside(Obj: Geom2dAdaptor_Curve): Geom2dGcc_QualifiedCurve;
  delete(): void;
}

export declare class Geom2dGcc_QualifiedCurve {
  constructor(Curve: Geom2dAdaptor_Curve, Qualifier: GccEnt_Position)
  Qualified(): Geom2dAdaptor_Curve;
  Qualifier(): GccEnt_Position;
  IsUnqualified(): Standard_Boolean;
  IsEnclosing(): Standard_Boolean;
  IsEnclosed(): Standard_Boolean;
  IsOutside(): Standard_Boolean;
  delete(): void;
}

export declare class XmlLDrivers_DocumentRetrievalDriver extends PCDM_RetrievalDriver {
  constructor()
  CreateDocument(): Handle_CDM_Document;
  Read_1(theFileName: TCollection_ExtendedString, theNewDocument: Handle_CDM_Document, theApplication: Handle_CDM_Application, theRange: Message_ProgressRange): void;
  Read_2(theIStream: Standard_IStream, theStorageData: Handle_Storage_Data, theDoc: Handle_CDM_Document, theApplication: Handle_CDM_Application, theRange: Message_ProgressRange): void;
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlLDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlLDrivers_DocumentRetrievalDriver): void;
  get(): XmlLDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_XmlLDrivers_DocumentRetrievalDriver_1 extends Handle_XmlLDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_XmlLDrivers_DocumentRetrievalDriver_2 extends Handle_XmlLDrivers_DocumentRetrievalDriver {
    constructor(thePtr: XmlLDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlLDrivers_DocumentRetrievalDriver_3 extends Handle_XmlLDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlLDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlLDrivers_DocumentRetrievalDriver_4 extends Handle_XmlLDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlLDrivers_DocumentRetrievalDriver);
  }

export declare class XmlLDrivers_DocumentStorageDriver extends PCDM_StorageDriver {
  constructor(theCopyright: TCollection_ExtendedString)
  Write_1(theDocument: Handle_CDM_Document, theFileName: TCollection_ExtendedString, theRange: Message_ProgressRange): void;
  Write_2(theDocument: Handle_CDM_Document, theOStream: Standard_OStream, theRange: Message_ProgressRange): void;
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlLDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlLDrivers_DocumentStorageDriver): void;
  get(): XmlLDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_XmlLDrivers_DocumentStorageDriver_1 extends Handle_XmlLDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_XmlLDrivers_DocumentStorageDriver_2 extends Handle_XmlLDrivers_DocumentStorageDriver {
    constructor(thePtr: XmlLDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlLDrivers_DocumentStorageDriver_3 extends Handle_XmlLDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlLDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlLDrivers_DocumentStorageDriver_4 extends Handle_XmlLDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlLDrivers_DocumentStorageDriver);
  }

export declare class XmlLDrivers {
  constructor();
  static Factory(theGUID: Standard_GUID): Handle_Standard_Transient;
  static CreationDate(): XCAFDoc_PartId;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static StorageVersion(): Standard_Integer;
  delete(): void;
}

export declare class XmlLDrivers_NamespaceDef {
  Prefix(): XCAFDoc_PartId;
  URI(): XCAFDoc_PartId;
  delete(): void;
}

  export declare class XmlLDrivers_NamespaceDef_1 extends XmlLDrivers_NamespaceDef {
    constructor();
  }

  export declare class XmlLDrivers_NamespaceDef_2 extends XmlLDrivers_NamespaceDef {
    constructor(thePrefix: XCAFDoc_PartId, theURI: XCAFDoc_PartId);
  }

export declare class XmlLDrivers_SequenceOfNamespaceDef extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: XmlLDrivers_SequenceOfNamespaceDef): XmlLDrivers_SequenceOfNamespaceDef;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: XmlLDrivers_NamespaceDef): void;
  Append_2(theSeq: XmlLDrivers_SequenceOfNamespaceDef): void;
  Prepend_1(theItem: XmlLDrivers_NamespaceDef): void;
  Prepend_2(theSeq: XmlLDrivers_SequenceOfNamespaceDef): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: XmlLDrivers_NamespaceDef): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: XmlLDrivers_SequenceOfNamespaceDef): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: XmlLDrivers_SequenceOfNamespaceDef): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: XmlLDrivers_NamespaceDef): void;
  Split(theIndex: Standard_Integer, theSeq: XmlLDrivers_SequenceOfNamespaceDef): void;
  First(): XmlLDrivers_NamespaceDef;
  ChangeFirst(): XmlLDrivers_NamespaceDef;
  Last(): XmlLDrivers_NamespaceDef;
  ChangeLast(): XmlLDrivers_NamespaceDef;
  Value(theIndex: Standard_Integer): XmlLDrivers_NamespaceDef;
  ChangeValue(theIndex: Standard_Integer): XmlLDrivers_NamespaceDef;
  SetValue(theIndex: Standard_Integer, theItem: XmlLDrivers_NamespaceDef): void;
  delete(): void;
}

  export declare class XmlLDrivers_SequenceOfNamespaceDef_1 extends XmlLDrivers_SequenceOfNamespaceDef {
    constructor();
  }

  export declare class XmlLDrivers_SequenceOfNamespaceDef_2 extends XmlLDrivers_SequenceOfNamespaceDef {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class XmlLDrivers_SequenceOfNamespaceDef_3 extends XmlLDrivers_SequenceOfNamespaceDef {
    constructor(theOther: XmlLDrivers_SequenceOfNamespaceDef);
  }

export declare class BVH_TreeBaseTransient extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BVH_BinaryTree {
  constructor();
  delete(): void;
}

export declare class BVH_QuadTree {
  constructor();
  delete(): void;
}

export declare class BVH_Properties extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BVH_BuildThread extends Standard_Transient {
  constructor(theBuildTool: BVH_BuildTool, theBuildQueue: BVH_BuildQueue)
  Run(): void;
  Wait(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BVH_BuildTool {
  Perform(theNode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_BVH_BuildThread {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BVH_BuildThread): void;
  get(): BVH_BuildThread;
  delete(): void;
}

  export declare class Handle_BVH_BuildThread_1 extends Handle_BVH_BuildThread {
    constructor();
  }

  export declare class Handle_BVH_BuildThread_2 extends Handle_BVH_BuildThread {
    constructor(thePtr: BVH_BuildThread);
  }

  export declare class Handle_BVH_BuildThread_3 extends Handle_BVH_BuildThread {
    constructor(theHandle: Handle_BVH_BuildThread);
  }

  export declare class Handle_BVH_BuildThread_4 extends Handle_BVH_BuildThread {
    constructor(theHandle: Handle_BVH_BuildThread);
  }

export declare class BVH_ObjectTransient extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Properties(): any;
  SetProperties(theProperties: any): void;
  IsDirty(): Standard_Boolean;
  MarkDirty(): void;
  delete(): void;
}

export declare class BVH_BuilderTransient extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  MaxTreeDepth(): Graphic3d_ZLayerId;
  LeafNodeSize(): Graphic3d_ZLayerId;
  IsParallel(): Standard_Boolean;
  SetParallel(isParallel: Standard_Boolean): void;
  delete(): void;
}

export declare class BVH_BuildQueue {
  constructor()
  Size(): Graphic3d_ZLayerId;
  Enqueue(theNode: Graphic3d_ZLayerId): void;
  Fetch(wasBusy: Standard_Boolean): Graphic3d_ZLayerId;
  HasBusyThreads(): Standard_Boolean;
  delete(): void;
}

export declare class GccEnt_QualifiedLin {
  constructor(Qualified: gp_Lin2d, Qualifier: GccEnt_Position)
  Qualified(): gp_Lin2d;
  Qualifier(): GccEnt_Position;
  IsUnqualified(): Standard_Boolean;
  IsEnclosed(): Standard_Boolean;
  IsOutside(): Standard_Boolean;
  delete(): void;
}

export declare type GccEnt_Position = {
  GccEnt_unqualified: {};
  GccEnt_enclosing: {};
  GccEnt_enclosed: {};
  GccEnt_outside: {};
  GccEnt_noqualifier: {};
}

export declare class GccEnt_BadQualifier extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_GccEnt_BadQualifier;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GccEnt_BadQualifier_1 extends GccEnt_BadQualifier {
    constructor();
  }

  export declare class GccEnt_BadQualifier_2 extends GccEnt_BadQualifier {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_GccEnt_BadQualifier {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccEnt_BadQualifier): void;
  get(): GccEnt_BadQualifier;
  delete(): void;
}

  export declare class Handle_GccEnt_BadQualifier_1 extends Handle_GccEnt_BadQualifier {
    constructor();
  }

  export declare class Handle_GccEnt_BadQualifier_2 extends Handle_GccEnt_BadQualifier {
    constructor(thePtr: GccEnt_BadQualifier);
  }

  export declare class Handle_GccEnt_BadQualifier_3 extends Handle_GccEnt_BadQualifier {
    constructor(theHandle: Handle_GccEnt_BadQualifier);
  }

  export declare class Handle_GccEnt_BadQualifier_4 extends Handle_GccEnt_BadQualifier {
    constructor(theHandle: Handle_GccEnt_BadQualifier);
  }

export declare class GccEnt {
  constructor();
  static PositionToString(thePosition: GccEnt_Position): Standard_CString;
  static PositionFromString_1(thePositionString: Standard_CString): GccEnt_Position;
  static PositionFromString_2(thePositionString: Standard_CString, thePosition: GccEnt_Position): Standard_Boolean;
  static Unqualified_1(Obj: gp_Lin2d): GccEnt_QualifiedLin;
  static Unqualified_2(Obj: gp_Circ2d): GccEnt_QualifiedCirc;
  static Enclosing(Obj: gp_Circ2d): GccEnt_QualifiedCirc;
  static Enclosed_1(Obj: gp_Lin2d): GccEnt_QualifiedLin;
  static Enclosed_2(Obj: gp_Circ2d): GccEnt_QualifiedCirc;
  static Outside_1(Obj: gp_Lin2d): GccEnt_QualifiedLin;
  static Outside_2(Obj: gp_Circ2d): GccEnt_QualifiedCirc;
  delete(): void;
}

export declare class GccEnt_Array1OfPosition {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: GccEnt_Position): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: GccEnt_Array1OfPosition): GccEnt_Array1OfPosition;
  Move(theOther: GccEnt_Array1OfPosition): GccEnt_Array1OfPosition;
  First(): GccEnt_Position;
  ChangeFirst(): GccEnt_Position;
  Last(): GccEnt_Position;
  ChangeLast(): GccEnt_Position;
  Value(theIndex: Standard_Integer): GccEnt_Position;
  ChangeValue(theIndex: Standard_Integer): GccEnt_Position;
  SetValue(theIndex: Standard_Integer, theItem: GccEnt_Position): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class GccEnt_Array1OfPosition_1 extends GccEnt_Array1OfPosition {
    constructor();
  }

  export declare class GccEnt_Array1OfPosition_2 extends GccEnt_Array1OfPosition {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class GccEnt_Array1OfPosition_3 extends GccEnt_Array1OfPosition {
    constructor(theOther: GccEnt_Array1OfPosition);
  }

  export declare class GccEnt_Array1OfPosition_4 extends GccEnt_Array1OfPosition {
    constructor(theOther: GccEnt_Array1OfPosition);
  }

  export declare class GccEnt_Array1OfPosition_5 extends GccEnt_Array1OfPosition {
    constructor(theBegin: GccEnt_Position, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class GccEnt_QualifiedCirc {
  constructor(Qualified: gp_Circ2d, Qualifier: GccEnt_Position)
  Qualified(): gp_Circ2d;
  Qualifier(): GccEnt_Position;
  IsUnqualified(): Standard_Boolean;
  IsEnclosing(): Standard_Boolean;
  IsEnclosed(): Standard_Boolean;
  IsOutside(): Standard_Boolean;
  delete(): void;
}

export declare class BRepAlgoAPI_Section extends BRepAlgoAPI_BooleanOperation {
  Init1_1(S1: TopoDS_Shape): void;
  Init1_2(Pl: gp_Pln): void;
  Init1_3(Sf: Handle_Geom_Surface): void;
  Init2_1(S2: TopoDS_Shape): void;
  Init2_2(Pl: gp_Pln): void;
  Init2_3(Sf: Handle_Geom_Surface): void;
  Approximation(B: Standard_Boolean): void;
  ComputePCurveOn1(B: Standard_Boolean): void;
  ComputePCurveOn2(B: Standard_Boolean): void;
  Build(): void;
  HasAncestorFaceOn1(E: TopoDS_Shape, F: TopoDS_Shape): Standard_Boolean;
  HasAncestorFaceOn2(E: TopoDS_Shape, F: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepAlgoAPI_Section_1 extends BRepAlgoAPI_Section {
    constructor();
  }

  export declare class BRepAlgoAPI_Section_2 extends BRepAlgoAPI_Section {
    constructor(PF: BOPAlgo_PaveFiller);
  }

  export declare class BRepAlgoAPI_Section_3 extends BRepAlgoAPI_Section {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgoAPI_Section_4 extends BRepAlgoAPI_Section {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, aDSF: BOPAlgo_PaveFiller, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgoAPI_Section_5 extends BRepAlgoAPI_Section {
    constructor(S1: TopoDS_Shape, Pl: gp_Pln, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgoAPI_Section_6 extends BRepAlgoAPI_Section {
    constructor(S1: TopoDS_Shape, Sf: Handle_Geom_Surface, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgoAPI_Section_7 extends BRepAlgoAPI_Section {
    constructor(Sf: Handle_Geom_Surface, S2: TopoDS_Shape, PerformNow: Standard_Boolean);
  }

  export declare class BRepAlgoAPI_Section_8 extends BRepAlgoAPI_Section {
    constructor(Sf1: Handle_Geom_Surface, Sf2: Handle_Geom_Surface, PerformNow: Standard_Boolean);
  }

export declare class BRepAlgoAPI_BuilderAlgo extends BRepAlgoAPI_Algo {
  SetArguments(theLS: TopTools_ListOfShape): void;
  Arguments(): TopTools_ListOfShape;
  SetNonDestructive(theFlag: Standard_Boolean): void;
  NonDestructive(): Standard_Boolean;
  SetGlue(theGlue: BOPAlgo_GlueEnum): void;
  Glue(): BOPAlgo_GlueEnum;
  SetCheckInverted(theCheck: Standard_Boolean): void;
  CheckInverted(): Standard_Boolean;
  Build(): void;
  SimplifyResult(theUnifyEdges: Standard_Boolean, theUnifyFaces: Standard_Boolean, theAngularTol: Quantity_AbsorbedDose): void;
  Modified(theS: TopoDS_Shape): TopTools_ListOfShape;
  Generated(theS: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(aS: TopoDS_Shape): Standard_Boolean;
  HasModified(): Standard_Boolean;
  HasGenerated(): Standard_Boolean;
  HasDeleted(): Standard_Boolean;
  SetToFillHistory(theHistFlag: Standard_Boolean): void;
  HasHistory(): Standard_Boolean;
  SectionEdges(): TopTools_ListOfShape;
  DSFiller(): BOPAlgo_PPaveFiller;
  Builder(): BOPAlgo_PBuilder;
  History(): Handle_BRepTools_History;
  delete(): void;
}

  export declare class BRepAlgoAPI_BuilderAlgo_1 extends BRepAlgoAPI_BuilderAlgo {
    constructor();
  }

  export declare class BRepAlgoAPI_BuilderAlgo_2 extends BRepAlgoAPI_BuilderAlgo {
    constructor(thePF: BOPAlgo_PaveFiller);
  }

export declare class BRepAlgoAPI_Defeaturing extends BRepAlgoAPI_Algo {
  constructor()
  SetShape(theShape: TopoDS_Shape): void;
  InputShape(): TopoDS_Shape;
  AddFaceToRemove(theFace: TopoDS_Shape): void;
  AddFacesToRemove(theFaces: TopTools_ListOfShape): void;
  FacesToRemove(): TopTools_ListOfShape;
  Build(): void;
  SetToFillHistory(theFlag: Standard_Boolean): void;
  HasHistory(): Standard_Boolean;
  Modified(theS: TopoDS_Shape): TopTools_ListOfShape;
  Generated(theS: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(theS: TopoDS_Shape): Standard_Boolean;
  HasModified(): Standard_Boolean;
  HasGenerated(): Standard_Boolean;
  HasDeleted(): Standard_Boolean;
  History(): Handle_BRepTools_History;
  delete(): void;
}

export declare class BRepAlgoAPI_BooleanOperation extends BRepAlgoAPI_BuilderAlgo {
  Shape1(): TopoDS_Shape;
  Shape2(): TopoDS_Shape;
  SetTools(theLS: TopTools_ListOfShape): void;
  Tools(): TopTools_ListOfShape;
  SetOperation(theBOP: BOPAlgo_Operation): void;
  Operation(): BOPAlgo_Operation;
  Build(): void;
  delete(): void;
}

  export declare class BRepAlgoAPI_BooleanOperation_1 extends BRepAlgoAPI_BooleanOperation {
    constructor();
  }

  export declare class BRepAlgoAPI_BooleanOperation_2 extends BRepAlgoAPI_BooleanOperation {
    constructor(thePF: BOPAlgo_PaveFiller);
  }

export declare class BRepAlgoAPI_Common extends BRepAlgoAPI_BooleanOperation {
  delete(): void;
}

  export declare class BRepAlgoAPI_Common_1 extends BRepAlgoAPI_Common {
    constructor();
  }

  export declare class BRepAlgoAPI_Common_2 extends BRepAlgoAPI_Common {
    constructor(PF: BOPAlgo_PaveFiller);
  }

  export declare class BRepAlgoAPI_Common_3 extends BRepAlgoAPI_Common {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape);
  }

  export declare class BRepAlgoAPI_Common_4 extends BRepAlgoAPI_Common {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, PF: BOPAlgo_PaveFiller);
  }

export declare class BRepAlgoAPI_Fuse extends BRepAlgoAPI_BooleanOperation {
  delete(): void;
}

  export declare class BRepAlgoAPI_Fuse_1 extends BRepAlgoAPI_Fuse {
    constructor();
  }

  export declare class BRepAlgoAPI_Fuse_2 extends BRepAlgoAPI_Fuse {
    constructor(PF: BOPAlgo_PaveFiller);
  }

  export declare class BRepAlgoAPI_Fuse_3 extends BRepAlgoAPI_Fuse {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape);
  }

  export declare class BRepAlgoAPI_Fuse_4 extends BRepAlgoAPI_Fuse {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, aDSF: BOPAlgo_PaveFiller);
  }

export declare class BRepAlgoAPI_Algo extends BRepBuilderAPI_MakeShape {
  Shape(): TopoDS_Shape;
  Clear(): void;
  SetRunParallel(theFlag: Standard_Boolean): void;
  RunParallel(): Standard_Boolean;
  SetFuzzyValue(theFuzz: Quantity_AbsorbedDose): void;
  FuzzyValue(): Quantity_AbsorbedDose;
  HasErrors(): Standard_Boolean;
  HasWarnings(): Standard_Boolean;
  HasError(theType: Handle_Standard_Type): Standard_Boolean;
  HasWarning(theType: Handle_Standard_Type): Standard_Boolean;
  DumpErrors(theOS: Standard_OStream): void;
  DumpWarnings(theOS: Standard_OStream): void;
  ClearWarnings(): void;
  GetReport(): Handle_Message_Report;
  SetProgressIndicator(theProgress: Message_ProgressScope): void;
  SetUseOBB(theUseOBB: Standard_Boolean): void;
  delete(): void;
}

export declare class BRepAlgoAPI_Cut extends BRepAlgoAPI_BooleanOperation {
  delete(): void;
}

  export declare class BRepAlgoAPI_Cut_1 extends BRepAlgoAPI_Cut {
    constructor();
  }

  export declare class BRepAlgoAPI_Cut_2 extends BRepAlgoAPI_Cut {
    constructor(PF: BOPAlgo_PaveFiller);
  }

  export declare class BRepAlgoAPI_Cut_3 extends BRepAlgoAPI_Cut {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape);
  }

  export declare class BRepAlgoAPI_Cut_4 extends BRepAlgoAPI_Cut {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, aDSF: BOPAlgo_PaveFiller, bFWD: Standard_Boolean);
  }

export declare class BRepAlgoAPI_Splitter extends BRepAlgoAPI_BuilderAlgo {
  SetTools(theLS: TopTools_ListOfShape): void;
  Tools(): TopTools_ListOfShape;
  Build(): void;
  delete(): void;
}

  export declare class BRepAlgoAPI_Splitter_1 extends BRepAlgoAPI_Splitter {
    constructor();
  }

  export declare class BRepAlgoAPI_Splitter_2 extends BRepAlgoAPI_Splitter {
    constructor(thePF: BOPAlgo_PaveFiller);
  }

export declare class BRepAlgoAPI_Check extends BOPAlgo_Options {
  SetData_1(theS: TopoDS_Shape, bTestSE: Standard_Boolean, bTestSI: Standard_Boolean): void;
  SetData_2(theS1: TopoDS_Shape, theS2: TopoDS_Shape, theOp: BOPAlgo_Operation, bTestSE: Standard_Boolean, bTestSI: Standard_Boolean): void;
  Perform(): void;
  IsValid(): Standard_Boolean;
  Result(): BOPAlgo_ListOfCheckResult;
  delete(): void;
}

  export declare class BRepAlgoAPI_Check_1 extends BRepAlgoAPI_Check {
    constructor();
  }

  export declare class BRepAlgoAPI_Check_2 extends BRepAlgoAPI_Check {
    constructor(theS: TopoDS_Shape, bTestSE: Standard_Boolean, bTestSI: Standard_Boolean);
  }

  export declare class BRepAlgoAPI_Check_3 extends BRepAlgoAPI_Check {
    constructor(theS1: TopoDS_Shape, theS2: TopoDS_Shape, theOp: BOPAlgo_Operation, bTestSE: Standard_Boolean, bTestSI: Standard_Boolean);
  }

export declare class RWHeaderSection_RWFileSchema {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_HeaderSection_FileSchema): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_HeaderSection_FileSchema): void;
  delete(): void;
}

export declare class RWHeaderSection_RWFileDescription {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_HeaderSection_FileDescription): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_HeaderSection_FileDescription): void;
  delete(): void;
}

export declare class Handle_RWHeaderSection_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: RWHeaderSection_GeneralModule): void;
  get(): RWHeaderSection_GeneralModule;
  delete(): void;
}

  export declare class Handle_RWHeaderSection_GeneralModule_1 extends Handle_RWHeaderSection_GeneralModule {
    constructor();
  }

  export declare class Handle_RWHeaderSection_GeneralModule_2 extends Handle_RWHeaderSection_GeneralModule {
    constructor(thePtr: RWHeaderSection_GeneralModule);
  }

  export declare class Handle_RWHeaderSection_GeneralModule_3 extends Handle_RWHeaderSection_GeneralModule {
    constructor(theHandle: Handle_RWHeaderSection_GeneralModule);
  }

  export declare class Handle_RWHeaderSection_GeneralModule_4 extends Handle_RWHeaderSection_GeneralModule {
    constructor(theHandle: Handle_RWHeaderSection_GeneralModule);
  }

export declare class RWHeaderSection_ReadWriteModule extends StepData_ReadWriteModule {
  constructor()
  CaseStep_1(atype: XCAFDoc_PartId): Graphic3d_ZLayerId;
  CaseStep_2(types: TColStd_SequenceOfAsciiString): Graphic3d_ZLayerId;
  IsComplex(CN: Graphic3d_ZLayerId): Standard_Boolean;
  StepType(CN: Graphic3d_ZLayerId): XCAFDoc_PartId;
  ReadStep(CN: Graphic3d_ZLayerId, data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): void;
  WriteStep(CN: Graphic3d_ZLayerId, SW: StepData_StepWriter, ent: Handle_Standard_Transient): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_RWHeaderSection_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: RWHeaderSection_ReadWriteModule): void;
  get(): RWHeaderSection_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_RWHeaderSection_ReadWriteModule_1 extends Handle_RWHeaderSection_ReadWriteModule {
    constructor();
  }

  export declare class Handle_RWHeaderSection_ReadWriteModule_2 extends Handle_RWHeaderSection_ReadWriteModule {
    constructor(thePtr: RWHeaderSection_ReadWriteModule);
  }

  export declare class Handle_RWHeaderSection_ReadWriteModule_3 extends Handle_RWHeaderSection_ReadWriteModule {
    constructor(theHandle: Handle_RWHeaderSection_ReadWriteModule);
  }

  export declare class Handle_RWHeaderSection_ReadWriteModule_4 extends Handle_RWHeaderSection_ReadWriteModule {
    constructor(theHandle: Handle_RWHeaderSection_ReadWriteModule);
  }

export declare class RWHeaderSection {
  constructor();
  static Init(): void;
  delete(): void;
}

export declare class RWHeaderSection_RWFileName {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_HeaderSection_FileName): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_HeaderSection_FileName): void;
  delete(): void;
}

export declare class Handle_MoniTool_TypedValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_TypedValue): void;
  get(): MoniTool_TypedValue;
  delete(): void;
}

  export declare class Handle_MoniTool_TypedValue_1 extends Handle_MoniTool_TypedValue {
    constructor();
  }

  export declare class Handle_MoniTool_TypedValue_2 extends Handle_MoniTool_TypedValue {
    constructor(thePtr: MoniTool_TypedValue);
  }

  export declare class Handle_MoniTool_TypedValue_3 extends Handle_MoniTool_TypedValue {
    constructor(theHandle: Handle_MoniTool_TypedValue);
  }

  export declare class Handle_MoniTool_TypedValue_4 extends Handle_MoniTool_TypedValue {
    constructor(theHandle: Handle_MoniTool_TypedValue);
  }

export declare class MoniTool_TypedValue extends Standard_Transient {
  Name(): Standard_CString;
  ValueType(): MoniTool_ValueType;
  Definition(): XCAFDoc_PartId;
  SetDefinition(deftext: Standard_CString): void;
  Print(S: Standard_OStream): void;
  PrintValue(S: Standard_OStream): void;
  AddDef(initext: Standard_CString): Standard_Boolean;
  SetLabel(label: Standard_CString): void;
  Label(): Standard_CString;
  SetMaxLength(max: Graphic3d_ZLayerId): void;
  MaxLength(): Graphic3d_ZLayerId;
  SetIntegerLimit(max: Standard_Boolean, val: Graphic3d_ZLayerId): void;
  IntegerLimit(max: Standard_Boolean, val: Graphic3d_ZLayerId): Standard_Boolean;
  SetRealLimit(max: Standard_Boolean, val: Quantity_AbsorbedDose): void;
  RealLimit(max: Standard_Boolean, val: Quantity_AbsorbedDose): Standard_Boolean;
  SetUnitDef(def: Standard_CString): void;
  UnitDef(): Standard_CString;
  StartEnum(start: Graphic3d_ZLayerId, match: Standard_Boolean): void;
  AddEnum(v1: Standard_CString, v2: Standard_CString, v3: Standard_CString, v4: Standard_CString, v5: Standard_CString, v6: Standard_CString, v7: Standard_CString, v8: Standard_CString, v9: Standard_CString, v10: Standard_CString): void;
  AddEnumValue(val: Standard_CString, num: Graphic3d_ZLayerId): void;
  EnumDef(startcase: Graphic3d_ZLayerId, endcase: Graphic3d_ZLayerId, match: Standard_Boolean): Standard_Boolean;
  EnumVal(num: Graphic3d_ZLayerId): Standard_CString;
  EnumCase(val: Standard_CString): Graphic3d_ZLayerId;
  SetObjectType(typ: Handle_Standard_Type): void;
  ObjectType(): Handle_Standard_Type;
  SetInterpret(func: MoniTool_ValueInterpret): void;
  HasInterpret(): Standard_Boolean;
  SetSatisfies(func: MoniTool_ValueSatisfies, name: Standard_CString): void;
  SatisfiesName(): Standard_CString;
  IsSetValue(): Standard_Boolean;
  CStringValue(): Standard_CString;
  HStringValue(): Handle_TCollection_HAsciiString;
  Interpret(hval: Handle_TCollection_HAsciiString, native: Standard_Boolean): Handle_TCollection_HAsciiString;
  Satisfies(hval: Handle_TCollection_HAsciiString): Standard_Boolean;
  ClearValue(): void;
  SetCStringValue(val: Standard_CString): Standard_Boolean;
  SetHStringValue(hval: Handle_TCollection_HAsciiString): Standard_Boolean;
  IntegerValue(): Graphic3d_ZLayerId;
  SetIntegerValue(ival: Graphic3d_ZLayerId): Standard_Boolean;
  RealValue(): Quantity_AbsorbedDose;
  SetRealValue(rval: Quantity_AbsorbedDose): Standard_Boolean;
  ObjectValue(): Handle_Standard_Transient;
  GetObjectValue(val: Handle_Standard_Transient): void;
  SetObjectValue(obj: Handle_Standard_Transient): Standard_Boolean;
  ObjectTypeName(): Standard_CString;
  static AddLib(tv: Handle_MoniTool_TypedValue, def: Standard_CString): Standard_Boolean;
  static Lib(def: Standard_CString): Handle_MoniTool_TypedValue;
  static FromLib(def: Standard_CString): Handle_MoniTool_TypedValue;
  static LibList(): Handle_TColStd_HSequenceOfAsciiString;
  static StaticValue(name: Standard_CString): Handle_MoniTool_TypedValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class MoniTool_TypedValue_1 extends MoniTool_TypedValue {
    constructor(name: Standard_CString, type: MoniTool_ValueType, init: Standard_CString);
  }

  export declare class MoniTool_TypedValue_2 extends MoniTool_TypedValue {
    constructor(other: Handle_MoniTool_TypedValue);
  }

export declare class MoniTool_DataInfo {
  constructor();
  static Type(ent: Handle_Standard_Transient): Handle_Standard_Type;
  static TypeName(ent: Handle_Standard_Transient): Standard_CString;
  delete(): void;
}

export declare class MoniTool_ElemHasher {
  constructor();
  static HashCode(theElement: Handle_MoniTool_Element, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(K1: Handle_MoniTool_Element, K2: Handle_MoniTool_Element): Standard_Boolean;
  delete(): void;
}

export declare class MoniTool_TransientElem extends MoniTool_Element {
  constructor(akey: Handle_Standard_Transient)
  Value(): Handle_Standard_Transient;
  Equates(other: Handle_MoniTool_Element): Standard_Boolean;
  ValueType(): Handle_Standard_Type;
  ValueTypeName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MoniTool_TransientElem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_TransientElem): void;
  get(): MoniTool_TransientElem;
  delete(): void;
}

  export declare class Handle_MoniTool_TransientElem_1 extends Handle_MoniTool_TransientElem {
    constructor();
  }

  export declare class Handle_MoniTool_TransientElem_2 extends Handle_MoniTool_TransientElem {
    constructor(thePtr: MoniTool_TransientElem);
  }

  export declare class Handle_MoniTool_TransientElem_3 extends Handle_MoniTool_TransientElem {
    constructor(theHandle: Handle_MoniTool_TransientElem);
  }

  export declare class Handle_MoniTool_TransientElem_4 extends Handle_MoniTool_TransientElem {
    constructor(theHandle: Handle_MoniTool_TransientElem);
  }

export declare class MoniTool_MTHasher {
  constructor();
  static HashCode(theString: Standard_CString, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(Str1: Standard_CString, Str2: Standard_CString): Standard_Boolean;
  delete(): void;
}

export declare class MoniTool_AttrList {
  SetAttribute(name: Standard_CString, val: Handle_Standard_Transient): void;
  RemoveAttribute(name: Standard_CString): Standard_Boolean;
  GetAttribute(name: Standard_CString, type: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  Attribute(name: Standard_CString): Handle_Standard_Transient;
  AttributeType(name: Standard_CString): MoniTool_ValueType;
  SetIntegerAttribute(name: Standard_CString, val: Graphic3d_ZLayerId): void;
  GetIntegerAttribute(name: Standard_CString, val: Graphic3d_ZLayerId): Standard_Boolean;
  IntegerAttribute(name: Standard_CString): Graphic3d_ZLayerId;
  SetRealAttribute(name: Standard_CString, val: Quantity_AbsorbedDose): void;
  GetRealAttribute(name: Standard_CString, val: Quantity_AbsorbedDose): Standard_Boolean;
  RealAttribute(name: Standard_CString): Quantity_AbsorbedDose;
  SetStringAttribute(name: Standard_CString, val: Standard_CString): void;
  StringAttribute(name: Standard_CString): Standard_CString;
  AttrList(): any;
  SameAttributes(other: MoniTool_AttrList): void;
  GetAttributes(other: MoniTool_AttrList, fromname: Standard_CString, copied: Standard_Boolean): void;
  delete(): void;
}

  export declare class MoniTool_AttrList_1 extends MoniTool_AttrList {
    constructor();
  }

  export declare class MoniTool_AttrList_2 extends MoniTool_AttrList {
    constructor(other: MoniTool_AttrList);
  }

export declare type MoniTool_ValueType = {
  MoniTool_ValueMisc: {};
  MoniTool_ValueInteger: {};
  MoniTool_ValueReal: {};
  MoniTool_ValueIdent: {};
  MoniTool_ValueVoid: {};
  MoniTool_ValueText: {};
  MoniTool_ValueEnum: {};
  MoniTool_ValueLogical: {};
  MoniTool_ValueSub: {};
  MoniTool_ValueHexa: {};
  MoniTool_ValueBinary: {};
}

export declare class MoniTool_TimerSentry {
  Timer(): Handle_MoniTool_Timer;
  Stop(): void;
  delete(): void;
}

  export declare class MoniTool_TimerSentry_1 extends MoniTool_TimerSentry {
    constructor(cname: Standard_CString);
  }

  export declare class MoniTool_TimerSentry_2 extends MoniTool_TimerSentry {
    constructor(timer: Handle_MoniTool_Timer);
  }

export declare class MoniTool_IntVal extends Standard_Transient {
  constructor(val: Graphic3d_ZLayerId)
  Value(): Graphic3d_ZLayerId;
  CValue(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MoniTool_IntVal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_IntVal): void;
  get(): MoniTool_IntVal;
  delete(): void;
}

  export declare class Handle_MoniTool_IntVal_1 extends Handle_MoniTool_IntVal {
    constructor();
  }

  export declare class Handle_MoniTool_IntVal_2 extends Handle_MoniTool_IntVal {
    constructor(thePtr: MoniTool_IntVal);
  }

  export declare class Handle_MoniTool_IntVal_3 extends Handle_MoniTool_IntVal {
    constructor(theHandle: Handle_MoniTool_IntVal);
  }

  export declare class Handle_MoniTool_IntVal_4 extends Handle_MoniTool_IntVal {
    constructor(theHandle: Handle_MoniTool_IntVal);
  }

export declare class MoniTool_Stat {
  static Current(): MoniTool_Stat;
  Open(nb: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  OpenMore(id: Graphic3d_ZLayerId, nb: Graphic3d_ZLayerId): void;
  Add(nb: Graphic3d_ZLayerId): void;
  AddSub(nb: Graphic3d_ZLayerId): void;
  AddEnd(): void;
  Close(id: Graphic3d_ZLayerId): void;
  Level(): Graphic3d_ZLayerId;
  Percent(fromlev: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class MoniTool_Stat_1 extends MoniTool_Stat {
    constructor(title: Standard_CString);
  }

  export declare class MoniTool_Stat_2 extends MoniTool_Stat {
    constructor(other: MoniTool_Stat);
  }

export declare class Handle_MoniTool_Element {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_Element): void;
  get(): MoniTool_Element;
  delete(): void;
}

  export declare class Handle_MoniTool_Element_1 extends Handle_MoniTool_Element {
    constructor();
  }

  export declare class Handle_MoniTool_Element_2 extends Handle_MoniTool_Element {
    constructor(thePtr: MoniTool_Element);
  }

  export declare class Handle_MoniTool_Element_3 extends Handle_MoniTool_Element {
    constructor(theHandle: Handle_MoniTool_Element);
  }

  export declare class Handle_MoniTool_Element_4 extends Handle_MoniTool_Element {
    constructor(theHandle: Handle_MoniTool_Element);
  }

export declare class MoniTool_Element extends Standard_Transient {
  GetHashCode(): Graphic3d_ZLayerId;
  Equates(other: Handle_MoniTool_Element): Standard_Boolean;
  ValueType(): Handle_Standard_Type;
  ValueTypeName(): Standard_CString;
  ListAttr(): MoniTool_AttrList;
  ChangeAttr(): MoniTool_AttrList;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class MoniTool_RealVal extends Standard_Transient {
  constructor(val: Quantity_AbsorbedDose)
  Value(): Quantity_AbsorbedDose;
  CValue(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MoniTool_RealVal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_RealVal): void;
  get(): MoniTool_RealVal;
  delete(): void;
}

  export declare class Handle_MoniTool_RealVal_1 extends Handle_MoniTool_RealVal {
    constructor();
  }

  export declare class Handle_MoniTool_RealVal_2 extends Handle_MoniTool_RealVal {
    constructor(thePtr: MoniTool_RealVal);
  }

  export declare class Handle_MoniTool_RealVal_3 extends Handle_MoniTool_RealVal {
    constructor(theHandle: Handle_MoniTool_RealVal);
  }

  export declare class Handle_MoniTool_RealVal_4 extends Handle_MoniTool_RealVal {
    constructor(theHandle: Handle_MoniTool_RealVal);
  }

export declare class Handle_MoniTool_HSequenceOfElement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_HSequenceOfElement): void;
  get(): MoniTool_HSequenceOfElement;
  delete(): void;
}

  export declare class Handle_MoniTool_HSequenceOfElement_1 extends Handle_MoniTool_HSequenceOfElement {
    constructor();
  }

  export declare class Handle_MoniTool_HSequenceOfElement_2 extends Handle_MoniTool_HSequenceOfElement {
    constructor(thePtr: MoniTool_HSequenceOfElement);
  }

  export declare class Handle_MoniTool_HSequenceOfElement_3 extends Handle_MoniTool_HSequenceOfElement {
    constructor(theHandle: Handle_MoniTool_HSequenceOfElement);
  }

  export declare class Handle_MoniTool_HSequenceOfElement_4 extends Handle_MoniTool_HSequenceOfElement {
    constructor(theHandle: Handle_MoniTool_HSequenceOfElement);
  }

export declare class Handle_MoniTool_Timer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_Timer): void;
  get(): MoniTool_Timer;
  delete(): void;
}

  export declare class Handle_MoniTool_Timer_1 extends Handle_MoniTool_Timer {
    constructor();
  }

  export declare class Handle_MoniTool_Timer_2 extends Handle_MoniTool_Timer {
    constructor(thePtr: MoniTool_Timer);
  }

  export declare class Handle_MoniTool_Timer_3 extends Handle_MoniTool_Timer {
    constructor(theHandle: Handle_MoniTool_Timer);
  }

  export declare class Handle_MoniTool_Timer_4 extends Handle_MoniTool_Timer {
    constructor(theHandle: Handle_MoniTool_Timer);
  }

export declare class MoniTool_Timer extends Standard_Transient {
  constructor()
  Timer_1(): OSD_Timer;
  Timer_2(): OSD_Timer;
  Start_1(): void;
  Stop_1(): void;
  Reset(): void;
  Count(): Graphic3d_ZLayerId;
  IsRunning(): Graphic3d_ZLayerId;
  CPU(): Quantity_AbsorbedDose;
  Amend(): Quantity_AbsorbedDose;
  Dump(ostr: Standard_OStream): void;
  static Timer_3(name: Standard_CString): Handle_MoniTool_Timer;
  static Start_2(name: Standard_CString): void;
  static Stop_2(name: Standard_CString): void;
  static Dictionary(): MoniTool_DataMapOfTimer;
  static ClearTimers(): void;
  static DumpTimers(ostr: Standard_OStream): void;
  static ComputeAmendments(): void;
  static GetAmendments(Access: Quantity_AbsorbedDose, Internal: Quantity_AbsorbedDose, External: Quantity_AbsorbedDose, Error10: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MoniTool_SignText {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_SignText): void;
  get(): MoniTool_SignText;
  delete(): void;
}

  export declare class Handle_MoniTool_SignText_1 extends Handle_MoniTool_SignText {
    constructor();
  }

  export declare class Handle_MoniTool_SignText_2 extends Handle_MoniTool_SignText {
    constructor(thePtr: MoniTool_SignText);
  }

  export declare class Handle_MoniTool_SignText_3 extends Handle_MoniTool_SignText {
    constructor(theHandle: Handle_MoniTool_SignText);
  }

  export declare class Handle_MoniTool_SignText_4 extends Handle_MoniTool_SignText {
    constructor(theHandle: Handle_MoniTool_SignText);
  }

export declare class MoniTool_SignText extends Standard_Transient {
  Name(): Standard_CString;
  TextAlone(ent: Handle_Standard_Transient): XCAFDoc_PartId;
  Text(ent: Handle_Standard_Transient, context: Handle_Standard_Transient): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MoniTool_SignShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_SignShape): void;
  get(): MoniTool_SignShape;
  delete(): void;
}

  export declare class Handle_MoniTool_SignShape_1 extends Handle_MoniTool_SignShape {
    constructor();
  }

  export declare class Handle_MoniTool_SignShape_2 extends Handle_MoniTool_SignShape {
    constructor(thePtr: MoniTool_SignShape);
  }

  export declare class Handle_MoniTool_SignShape_3 extends Handle_MoniTool_SignShape {
    constructor(theHandle: Handle_MoniTool_SignShape);
  }

  export declare class Handle_MoniTool_SignShape_4 extends Handle_MoniTool_SignShape {
    constructor(theHandle: Handle_MoniTool_SignShape);
  }

export declare class MoniTool_SignShape extends MoniTool_SignText {
  constructor()
  Name(): Standard_CString;
  Text(ent: Handle_Standard_Transient, context: Handle_Standard_Transient): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class MoniTool_CaseData extends Standard_Transient {
  constructor(caseid: Standard_CString, name: Standard_CString)
  SetCaseId(caseid: Standard_CString): void;
  SetName(name: Standard_CString): void;
  CaseId(): Standard_CString;
  Name_1(): Standard_CString;
  IsCheck(): Standard_Boolean;
  IsWarning(): Standard_Boolean;
  IsFail(): Standard_Boolean;
  ResetCheck(): void;
  SetWarning(): void;
  SetFail(): void;
  SetChange(): void;
  SetReplace(num: Graphic3d_ZLayerId): void;
  AddData(val: Handle_Standard_Transient, kind: Graphic3d_ZLayerId, name: Standard_CString): void;
  AddRaised(theException: Handle_Standard_Failure, name: Standard_CString): void;
  AddShape(sh: TopoDS_Shape, name: Standard_CString): void;
  AddXYZ(aXYZ: gp_XYZ, name: Standard_CString): void;
  AddXY(aXY: gp_XY, name: Standard_CString): void;
  AddReal(val: Quantity_AbsorbedDose, name: Standard_CString): void;
  AddReals(v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, name: Standard_CString): void;
  AddCPU(lastCPU: Quantity_AbsorbedDose, curCPU: Quantity_AbsorbedDose, name: Standard_CString): void;
  GetCPU(): Quantity_AbsorbedDose;
  LargeCPU(maxCPU: Quantity_AbsorbedDose, lastCPU: Quantity_AbsorbedDose, curCPU: Quantity_AbsorbedDose): Standard_Boolean;
  AddGeom(geom: Handle_Standard_Transient, name: Standard_CString): void;
  AddEntity(ent: Handle_Standard_Transient, name: Standard_CString): void;
  AddText(text: Standard_CString, name: Standard_CString): void;
  AddInteger(val: Graphic3d_ZLayerId, name: Standard_CString): void;
  AddAny(val: Handle_Standard_Transient, name: Standard_CString): void;
  RemoveData(num: Graphic3d_ZLayerId): void;
  NbData(): Graphic3d_ZLayerId;
  Data(nd: Graphic3d_ZLayerId): Handle_Standard_Transient;
  GetData(nd: Graphic3d_ZLayerId, type: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  Kind(nd: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Name_2(nd: Graphic3d_ZLayerId): XCAFDoc_PartId;
  NameNum(name: Standard_CString): Graphic3d_ZLayerId;
  Shape(nd: Graphic3d_ZLayerId): TopoDS_Shape;
  XYZ(nd: Graphic3d_ZLayerId, val: gp_XYZ): Standard_Boolean;
  XY(nd: Graphic3d_ZLayerId, val: gp_XY): Standard_Boolean;
  Reals(nd: Graphic3d_ZLayerId, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Standard_Boolean;
  Real(nd: Graphic3d_ZLayerId, val: Quantity_AbsorbedDose): Standard_Boolean;
  Integer(nd: Graphic3d_ZLayerId, val: Graphic3d_ZLayerId): Standard_Boolean;
  Msg(): Message_Msg;
  static SetDefWarning(acode: Standard_CString): void;
  static SetDefFail(acode: Standard_CString): void;
  static DefCheck(acode: Standard_CString): Graphic3d_ZLayerId;
  static SetDefMsg(casecode: Standard_CString, mesdef: Standard_CString): void;
  static DefMsg(casecode: Standard_CString): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_MoniTool_CaseData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: MoniTool_CaseData): void;
  get(): MoniTool_CaseData;
  delete(): void;
}

  export declare class Handle_MoniTool_CaseData_1 extends Handle_MoniTool_CaseData {
    constructor();
  }

  export declare class Handle_MoniTool_CaseData_2 extends Handle_MoniTool_CaseData {
    constructor(thePtr: MoniTool_CaseData);
  }

  export declare class Handle_MoniTool_CaseData_3 extends Handle_MoniTool_CaseData {
    constructor(theHandle: Handle_MoniTool_CaseData);
  }

  export declare class Handle_MoniTool_CaseData_4 extends Handle_MoniTool_CaseData {
    constructor(theHandle: Handle_MoniTool_CaseData);
  }

export declare class Handle_Media_Timer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Media_Timer): void;
  get(): Media_Timer;
  delete(): void;
}

  export declare class Handle_Media_Timer_1 extends Handle_Media_Timer {
    constructor();
  }

  export declare class Handle_Media_Timer_2 extends Handle_Media_Timer {
    constructor(thePtr: Media_Timer);
  }

  export declare class Handle_Media_Timer_3 extends Handle_Media_Timer {
    constructor(theHandle: Handle_Media_Timer);
  }

  export declare class Handle_Media_Timer_4 extends Handle_Media_Timer {
    constructor(theHandle: Handle_Media_Timer);
  }

export declare class IFGraph_AllShared extends Interface_GraphContent {
  GetFromEntity(ent: Handle_Standard_Transient): void;
  GetFromIter(iter: Interface_EntityIterator): void;
  ResetData(): void;
  Evaluate(): void;
  delete(): void;
}

  export declare class IFGraph_AllShared_1 extends IFGraph_AllShared {
    constructor(agraph: Interface_Graph);
  }

  export declare class IFGraph_AllShared_2 extends IFGraph_AllShared {
    constructor(agraph: Interface_Graph, ent: Handle_Standard_Transient);
  }

export declare class IFGraph_SubPartsIterator {
  GetParts(other: IFGraph_SubPartsIterator): void;
  Model(): Handle_Interface_InterfaceModel;
  AddPart(): void;
  NbParts(): Graphic3d_ZLayerId;
  PartNum(): Graphic3d_ZLayerId;
  SetLoad(): void;
  SetPartNum(num: Graphic3d_ZLayerId): void;
  GetFromEntity(ent: Handle_Standard_Transient, shared: Standard_Boolean): void;
  GetFromIter(iter: Interface_EntityIterator): void;
  Reset(): void;
  Evaluate(): void;
  Loaded(): Interface_GraphContent;
  LoadedGraph(): Interface_Graph;
  IsLoaded(ent: Handle_Standard_Transient): Standard_Boolean;
  IsInPart(ent: Handle_Standard_Transient): Standard_Boolean;
  EntityPartNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  IsSingle(): Standard_Boolean;
  FirstEntity(): Handle_Standard_Transient;
  Entities(): Interface_EntityIterator;
  delete(): void;
}

  export declare class IFGraph_SubPartsIterator_1 extends IFGraph_SubPartsIterator {
    constructor(agraph: Interface_Graph, whole: Standard_Boolean);
  }

  export declare class IFGraph_SubPartsIterator_2 extends IFGraph_SubPartsIterator {
    constructor(other: IFGraph_SubPartsIterator);
  }

export declare class IFGraph_SCRoots extends IFGraph_StrongComponants {
  Evaluate(): void;
  delete(): void;
}

  export declare class IFGraph_SCRoots_1 extends IFGraph_SCRoots {
    constructor(agraph: Interface_Graph, whole: Standard_Boolean);
  }

  export declare class IFGraph_SCRoots_2 extends IFGraph_SCRoots {
    constructor(subparts: IFGraph_StrongComponants);
  }

export declare class IFGraph_Cumulate extends Interface_GraphContent {
  constructor(agraph: Interface_Graph)
  GetFromEntity(ent: Handle_Standard_Transient): void;
  GetFromIter(iter: Interface_EntityIterator): void;
  ResetData(): void;
  Evaluate(): void;
  Overlapped(): Interface_EntityIterator;
  Forgotten(): Interface_EntityIterator;
  PerCount(count: Graphic3d_ZLayerId): Interface_EntityIterator;
  NbTimes(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  HighestNbTimes(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IFGraph_StrongComponants extends IFGraph_SubPartsIterator {
  constructor(agraph: Interface_Graph, whole: Standard_Boolean)
  Evaluate(): void;
  delete(): void;
}

export declare class IFGraph_ExternalSources extends Interface_GraphContent {
  constructor(agraph: Interface_Graph)
  GetFromEntity(ent: Handle_Standard_Transient): void;
  GetFromIter(iter: Interface_EntityIterator): void;
  ResetData(): void;
  Evaluate(): void;
  IsEmpty(): Standard_Boolean;
  delete(): void;
}

export declare class IFGraph_Compare extends Interface_GraphContent {
  constructor(agraph: Interface_Graph)
  GetFromEntity(ent: Handle_Standard_Transient, first: Standard_Boolean): void;
  GetFromIter(iter: Interface_EntityIterator, first: Standard_Boolean): void;
  Merge(): void;
  RemoveSecond(): void;
  KeepCommon(): void;
  ResetData(): void;
  Evaluate(): void;
  Common(): Interface_EntityIterator;
  FirstOnly(): Interface_EntityIterator;
  SecondOnly(): Interface_EntityIterator;
  delete(): void;
}

export declare class IFGraph_Articulations extends Interface_GraphContent {
  constructor(agraph: Interface_Graph, whole: Standard_Boolean)
  GetFromEntity(ent: Handle_Standard_Transient): void;
  GetFromIter(iter: Interface_EntityIterator): void;
  ResetData(): void;
  Evaluate(): void;
  delete(): void;
}

export declare class IFGraph_ConnectedComponants extends IFGraph_SubPartsIterator {
  constructor(agraph: Interface_Graph, whole: Standard_Boolean)
  Evaluate(): void;
  delete(): void;
}

export declare class IFGraph_AllConnected extends Interface_GraphContent {
  GetFromEntity(ent: Handle_Standard_Transient): void;
  ResetData(): void;
  Evaluate(): void;
  delete(): void;
}

  export declare class IFGraph_AllConnected_1 extends IFGraph_AllConnected {
    constructor(agraph: Interface_Graph);
  }

  export declare class IFGraph_AllConnected_2 extends IFGraph_AllConnected {
    constructor(agraph: Interface_Graph, ent: Handle_Standard_Transient);
  }

export declare class IFGraph_Cycles extends IFGraph_SubPartsIterator {
  Evaluate(): void;
  delete(): void;
}

  export declare class IFGraph_Cycles_1 extends IFGraph_Cycles {
    constructor(agraph: Interface_Graph, whole: Standard_Boolean);
  }

  export declare class IFGraph_Cycles_2 extends IFGraph_Cycles {
    constructor(subparts: IFGraph_StrongComponants);
  }

export declare class GeomFill_Line extends Standard_Transient {
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomFill_Line_1 extends GeomFill_Line {
    constructor();
  }

  export declare class GeomFill_Line_2 extends GeomFill_Line {
    constructor(NbPoints: Graphic3d_ZLayerId);
  }

export declare class Handle_GeomFill_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_Line): void;
  get(): GeomFill_Line;
  delete(): void;
}

  export declare class Handle_GeomFill_Line_1 extends Handle_GeomFill_Line {
    constructor();
  }

  export declare class Handle_GeomFill_Line_2 extends Handle_GeomFill_Line {
    constructor(thePtr: GeomFill_Line);
  }

  export declare class Handle_GeomFill_Line_3 extends Handle_GeomFill_Line {
    constructor(theHandle: Handle_GeomFill_Line);
  }

  export declare class Handle_GeomFill_Line_4 extends Handle_GeomFill_Line {
    constructor(theHandle: Handle_GeomFill_Line);
  }

export declare class GeomFill_TrihedronLaw extends Standard_Transient {
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  Copy(): Handle_GeomFill_TrihedronLaw;
  ErrorStatus(): GeomFill_PipeError;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_TrihedronLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_TrihedronLaw): void;
  get(): GeomFill_TrihedronLaw;
  delete(): void;
}

  export declare class Handle_GeomFill_TrihedronLaw_1 extends Handle_GeomFill_TrihedronLaw {
    constructor();
  }

  export declare class Handle_GeomFill_TrihedronLaw_2 extends Handle_GeomFill_TrihedronLaw {
    constructor(thePtr: GeomFill_TrihedronLaw);
  }

  export declare class Handle_GeomFill_TrihedronLaw_3 extends Handle_GeomFill_TrihedronLaw {
    constructor(theHandle: Handle_GeomFill_TrihedronLaw);
  }

  export declare class Handle_GeomFill_TrihedronLaw_4 extends Handle_GeomFill_TrihedronLaw {
    constructor(theHandle: Handle_GeomFill_TrihedronLaw);
  }

export declare class GeomFill_QuasiAngularConvertor {
  constructor()
  Initialized(): Standard_Boolean;
  Init(): void;
  Section_1(FirstPnt: gp_Pnt, Center: gp_Pnt, Dir: gp_Vec, Angle: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal): void;
  Section_2(FirstPnt: gp_Pnt, DFirstPnt: gp_Vec, Center: gp_Pnt, DCenter: gp_Vec, Dir: gp_Vec, DDir: gp_Vec, Angle: Quantity_AbsorbedDose, DAngle: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Weights: TColStd_Array1OfReal, DWeights: TColStd_Array1OfReal): void;
  Section_3(FirstPnt: gp_Pnt, DFirstPnt: gp_Vec, D2FirstPnt: gp_Vec, Center: gp_Pnt, DCenter: gp_Vec, D2Center: gp_Vec, Dir: gp_Vec, DDir: gp_Vec, D2Dir: gp_Vec, Angle: Quantity_AbsorbedDose, DAngle: Quantity_AbsorbedDose, D2Angle: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Weights: TColStd_Array1OfReal, DWeights: TColStd_Array1OfReal, D2Weights: TColStd_Array1OfReal): void;
  delete(): void;
}

export declare class GeomFill_AppSurf extends AppBlend_Approx {
  Init(Degmin: Graphic3d_ZLayerId, Degmax: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIt: Graphic3d_ZLayerId, KnownParameters: Standard_Boolean): void;
  SetParType(ParType: Approx_ParametrizationType): void;
  SetContinuity(C: GeomAbs_Shape): void;
  SetCriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  ParType(): Approx_ParametrizationType;
  Continuity(): GeomAbs_Shape;
  CriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  Perform_1(Lin: Handle_GeomFill_Line, SecGen: GeomFill_SectionGenerator, SpApprox: Standard_Boolean): void;
  PerformSmoothing(Lin: Handle_GeomFill_Line, SecGen: GeomFill_SectionGenerator): void;
  Perform_2(Lin: Handle_GeomFill_Line, SecGen: GeomFill_SectionGenerator, NbMaxP: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  SurfShape(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, NbUPoles: Graphic3d_ZLayerId, NbVPoles: Graphic3d_ZLayerId, NbUKnots: Graphic3d_ZLayerId, NbVKnots: Graphic3d_ZLayerId): void;
  Surface(TPoles: TColgp_Array2OfPnt, TWeights: TColStd_Array2OfReal, TUKnots: TColStd_Array1OfReal, TVKnots: TColStd_Array1OfReal, TUMults: TColStd_Array1OfInteger, TVMults: TColStd_Array1OfInteger): void;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  SurfPoles(): TColgp_Array2OfPnt;
  SurfWeights(): TColStd_Array2OfReal;
  SurfUKnots(): TColStd_Array1OfReal;
  SurfVKnots(): TColStd_Array1OfReal;
  SurfUMults(): TColStd_Array1OfInteger;
  SurfVMults(): TColStd_Array1OfInteger;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curves2dShape(Degree: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId): void;
  Curve2d(Index: Graphic3d_ZLayerId, TPoles: TColgp_Array1OfPnt2d, TKnots: TColStd_Array1OfReal, TMults: TColStd_Array1OfInteger): void;
  Curves2dDegree(): Graphic3d_ZLayerId;
  Curve2dPoles(Index: Graphic3d_ZLayerId): TColgp_Array1OfPnt2d;
  Curves2dKnots(): TColStd_Array1OfReal;
  Curves2dMults(): TColStd_Array1OfInteger;
  TolReached(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  TolCurveOnSurf(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomFill_AppSurf_1 extends GeomFill_AppSurf {
    constructor();
  }

  export declare class GeomFill_AppSurf_2 extends GeomFill_AppSurf {
    constructor(Degmin: Graphic3d_ZLayerId, Degmax: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIt: Graphic3d_ZLayerId, KnownParameters: Standard_Boolean);
  }

export declare class Handle_GeomFill_CoonsAlgPatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_CoonsAlgPatch): void;
  get(): GeomFill_CoonsAlgPatch;
  delete(): void;
}

  export declare class Handle_GeomFill_CoonsAlgPatch_1 extends Handle_GeomFill_CoonsAlgPatch {
    constructor();
  }

  export declare class Handle_GeomFill_CoonsAlgPatch_2 extends Handle_GeomFill_CoonsAlgPatch {
    constructor(thePtr: GeomFill_CoonsAlgPatch);
  }

  export declare class Handle_GeomFill_CoonsAlgPatch_3 extends Handle_GeomFill_CoonsAlgPatch {
    constructor(theHandle: Handle_GeomFill_CoonsAlgPatch);
  }

  export declare class Handle_GeomFill_CoonsAlgPatch_4 extends Handle_GeomFill_CoonsAlgPatch {
    constructor(theHandle: Handle_GeomFill_CoonsAlgPatch);
  }

export declare class GeomFill_CoonsAlgPatch extends Standard_Transient {
  constructor(B1: Handle_GeomFill_Boundary, B2: Handle_GeomFill_Boundary, B3: Handle_GeomFill_Boundary, B4: Handle_GeomFill_Boundary)
  Func_1(f1: Handle_Law_Function, f2: Handle_Law_Function): void;
  SetFunc(f1: Handle_Law_Function, f2: Handle_Law_Function): void;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  D1U(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Vec;
  D1V(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Vec;
  DUV(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Vec;
  Corner(I: Graphic3d_ZLayerId): gp_Pnt;
  Bound(I: Graphic3d_ZLayerId): Handle_GeomFill_Boundary;
  Func_2(I: Graphic3d_ZLayerId): Handle_Law_Function;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_PolynomialConvertor {
  constructor()
  Initialized(): Standard_Boolean;
  Init(): void;
  Section_1(FirstPnt: gp_Pnt, Center: gp_Pnt, Dir: gp_Vec, Angle: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt): void;
  Section_2(FirstPnt: gp_Pnt, DFirstPnt: gp_Vec, Center: gp_Pnt, DCenter: gp_Vec, Dir: gp_Vec, DDir: gp_Vec, Angle: Quantity_AbsorbedDose, DAngle: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec): void;
  Section_3(FirstPnt: gp_Pnt, DFirstPnt: gp_Vec, D2FirstPnt: gp_Vec, Center: gp_Pnt, DCenter: gp_Vec, D2Center: gp_Vec, Dir: gp_Vec, DDir: gp_Vec, D2Dir: gp_Vec, Angle: Quantity_AbsorbedDose, DAngle: Quantity_AbsorbedDose, D2Angle: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec): void;
  delete(): void;
}

export declare class Handle_GeomFill_HSequenceOfAx2 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_HSequenceOfAx2): void;
  get(): GeomFill_HSequenceOfAx2;
  delete(): void;
}

  export declare class Handle_GeomFill_HSequenceOfAx2_1 extends Handle_GeomFill_HSequenceOfAx2 {
    constructor();
  }

  export declare class Handle_GeomFill_HSequenceOfAx2_2 extends Handle_GeomFill_HSequenceOfAx2 {
    constructor(thePtr: GeomFill_HSequenceOfAx2);
  }

  export declare class Handle_GeomFill_HSequenceOfAx2_3 extends Handle_GeomFill_HSequenceOfAx2 {
    constructor(theHandle: Handle_GeomFill_HSequenceOfAx2);
  }

  export declare class Handle_GeomFill_HSequenceOfAx2_4 extends Handle_GeomFill_HSequenceOfAx2 {
    constructor(theHandle: Handle_GeomFill_HSequenceOfAx2);
  }

export declare class GeomFill_SimpleBound extends GeomFill_Boundary {
  constructor(Curve: Handle_Adaptor3d_HCurve, Tol3d: Quantity_AbsorbedDose, Tolang: Quantity_AbsorbedDose)
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  Reparametrize(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasDF: Standard_Boolean, HasDL: Standard_Boolean, DF: Quantity_AbsorbedDose, DL: Quantity_AbsorbedDose, Rev: Standard_Boolean): void;
  Bounds(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  IsDegenerated(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_SimpleBound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_SimpleBound): void;
  get(): GeomFill_SimpleBound;
  delete(): void;
}

  export declare class Handle_GeomFill_SimpleBound_1 extends Handle_GeomFill_SimpleBound {
    constructor();
  }

  export declare class Handle_GeomFill_SimpleBound_2 extends Handle_GeomFill_SimpleBound {
    constructor(thePtr: GeomFill_SimpleBound);
  }

  export declare class Handle_GeomFill_SimpleBound_3 extends Handle_GeomFill_SimpleBound {
    constructor(theHandle: Handle_GeomFill_SimpleBound);
  }

  export declare class Handle_GeomFill_SimpleBound_4 extends Handle_GeomFill_SimpleBound {
    constructor(theHandle: Handle_GeomFill_SimpleBound);
  }

export declare class Handle_GeomFill_DiscreteTrihedron {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_DiscreteTrihedron): void;
  get(): GeomFill_DiscreteTrihedron;
  delete(): void;
}

  export declare class Handle_GeomFill_DiscreteTrihedron_1 extends Handle_GeomFill_DiscreteTrihedron {
    constructor();
  }

  export declare class Handle_GeomFill_DiscreteTrihedron_2 extends Handle_GeomFill_DiscreteTrihedron {
    constructor(thePtr: GeomFill_DiscreteTrihedron);
  }

  export declare class Handle_GeomFill_DiscreteTrihedron_3 extends Handle_GeomFill_DiscreteTrihedron {
    constructor(theHandle: Handle_GeomFill_DiscreteTrihedron);
  }

  export declare class Handle_GeomFill_DiscreteTrihedron_4 extends Handle_GeomFill_DiscreteTrihedron {
    constructor(theHandle: Handle_GeomFill_DiscreteTrihedron);
  }

export declare class GeomFill_DiscreteTrihedron extends GeomFill_TrihedronLaw {
  constructor()
  Copy(): Handle_GeomFill_TrihedronLaw;
  Init(): void;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_LocationLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_LocationLaw): void;
  get(): GeomFill_LocationLaw;
  delete(): void;
}

  export declare class Handle_GeomFill_LocationLaw_1 extends Handle_GeomFill_LocationLaw {
    constructor();
  }

  export declare class Handle_GeomFill_LocationLaw_2 extends Handle_GeomFill_LocationLaw {
    constructor(thePtr: GeomFill_LocationLaw);
  }

  export declare class Handle_GeomFill_LocationLaw_3 extends Handle_GeomFill_LocationLaw {
    constructor(theHandle: Handle_GeomFill_LocationLaw);
  }

  export declare class Handle_GeomFill_LocationLaw_4 extends Handle_GeomFill_LocationLaw {
    constructor(theHandle: Handle_GeomFill_LocationLaw);
  }

export declare class GeomFill_LocationLaw extends Standard_Transient {
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  GetCurve(): Handle_Adaptor3d_HCurve;
  SetTrsf(Transfo: gp_Mat): void;
  Copy(): Handle_GeomFill_LocationLaw;
  D0_1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec): Standard_Boolean;
  D0_2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, D2M: gp_Mat, D2V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  Nb2dCurves(): Graphic3d_ZLayerId;
  HasFirstRestriction(): Standard_Boolean;
  HasLastRestriction(): Standard_Boolean;
  TraceNumber(): Graphic3d_ZLayerId;
  ErrorStatus(): GeomFill_PipeError;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Resolution(Index: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  GetMaximalNorm(): Quantity_AbsorbedDose;
  GetAverageLaw(AM: gp_Mat, AV: gp_Vec): void;
  IsTranslation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  IsRotation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  Rotation(Center: gp_Pnt): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_BoundWithSurf extends GeomFill_Boundary {
  constructor(CurveOnSurf: Adaptor3d_CurveOnSurface, Tol3d: Quantity_AbsorbedDose, Tolang: Quantity_AbsorbedDose)
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  HasNormals(): Standard_Boolean;
  Norm(U: Quantity_AbsorbedDose): gp_Vec;
  D1Norm(U: Quantity_AbsorbedDose, N: gp_Vec, DN: gp_Vec): void;
  Reparametrize(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasDF: Standard_Boolean, HasDL: Standard_Boolean, DF: Quantity_AbsorbedDose, DL: Quantity_AbsorbedDose, Rev: Standard_Boolean): void;
  Bounds(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  IsDegenerated(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_BoundWithSurf {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_BoundWithSurf): void;
  get(): GeomFill_BoundWithSurf;
  delete(): void;
}

  export declare class Handle_GeomFill_BoundWithSurf_1 extends Handle_GeomFill_BoundWithSurf {
    constructor();
  }

  export declare class Handle_GeomFill_BoundWithSurf_2 extends Handle_GeomFill_BoundWithSurf {
    constructor(thePtr: GeomFill_BoundWithSurf);
  }

  export declare class Handle_GeomFill_BoundWithSurf_3 extends Handle_GeomFill_BoundWithSurf {
    constructor(theHandle: Handle_GeomFill_BoundWithSurf);
  }

  export declare class Handle_GeomFill_BoundWithSurf_4 extends Handle_GeomFill_BoundWithSurf {
    constructor(theHandle: Handle_GeomFill_BoundWithSurf);
  }

export declare class GeomFill_DraftTrihedron extends GeomFill_TrihedronLaw {
  constructor(BiNormal: gp_Vec, Angle: Quantity_AbsorbedDose)
  SetAngle(Angle: Quantity_AbsorbedDose): void;
  Copy(): Handle_GeomFill_TrihedronLaw;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_DraftTrihedron {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_DraftTrihedron): void;
  get(): GeomFill_DraftTrihedron;
  delete(): void;
}

  export declare class Handle_GeomFill_DraftTrihedron_1 extends Handle_GeomFill_DraftTrihedron {
    constructor();
  }

  export declare class Handle_GeomFill_DraftTrihedron_2 extends Handle_GeomFill_DraftTrihedron {
    constructor(thePtr: GeomFill_DraftTrihedron);
  }

  export declare class Handle_GeomFill_DraftTrihedron_3 extends Handle_GeomFill_DraftTrihedron {
    constructor(theHandle: Handle_GeomFill_DraftTrihedron);
  }

  export declare class Handle_GeomFill_DraftTrihedron_4 extends Handle_GeomFill_DraftTrihedron {
    constructor(theHandle: Handle_GeomFill_DraftTrihedron);
  }

export declare type GeomFill_Trihedron = {
  GeomFill_IsCorrectedFrenet: {};
  GeomFill_IsFixed: {};
  GeomFill_IsFrenet: {};
  GeomFill_IsConstantNormal: {};
  GeomFill_IsDarboux: {};
  GeomFill_IsGuideAC: {};
  GeomFill_IsGuidePlan: {};
  GeomFill_IsGuideACWithContact: {};
  GeomFill_IsGuidePlanWithContact: {};
  GeomFill_IsDiscreteTrihedron: {};
}

export declare class GeomFill_PlanFunc extends math_FunctionWithDerivative {
  constructor(P: gp_Pnt, V: gp_Vec, C: Handle_Adaptor3d_HCurve)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  D2(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D1: Quantity_AbsorbedDose, D2: Quantity_AbsorbedDose): void;
  DEDT(X: Quantity_AbsorbedDose, DP: gp_Vec, DV: gp_Vec, DF: Quantity_AbsorbedDose): void;
  D2E(X: Quantity_AbsorbedDose, DP: gp_Vec, D2P: gp_Vec, DV: gp_Vec, D2V: gp_Vec, DFDT: Quantity_AbsorbedDose, D2FDT2: Quantity_AbsorbedDose, D2FDTDX: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomFill_FunctionGuide extends math_FunctionSetWithDerivatives {
  constructor(S: Handle_GeomFill_SectionLaw, Guide: Handle_Adaptor3d_HCurve, ParamOnLaw: Quantity_AbsorbedDose)
  SetParam(Param: Quantity_AbsorbedDose, Centre: gp_Pnt, Dir: gp_XYZ, XDir: gp_XYZ): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  DerivT(X: math_Vector, DCentre: gp_XYZ, DDir: gp_XYZ, DFDT: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class GeomFill_Generator extends GeomFill_Profiler {
  constructor()
  Perform(PTol: Quantity_AbsorbedDose): void;
  Surface(): Handle_Geom_Surface;
  delete(): void;
}

export declare class GeomFill_Boundary extends Standard_Transient {
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  HasNormals(): Standard_Boolean;
  Norm(U: Quantity_AbsorbedDose): gp_Vec;
  D1Norm(U: Quantity_AbsorbedDose, N: gp_Vec, DN: gp_Vec): void;
  Reparametrize(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasDF: Standard_Boolean, HasDL: Standard_Boolean, DF: Quantity_AbsorbedDose, DL: Quantity_AbsorbedDose, Rev: Standard_Boolean): void;
  Points(PFirst: gp_Pnt, PLast: gp_Pnt): void;
  Bounds(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  IsDegenerated(): Standard_Boolean;
  Tol3d_1(): Quantity_AbsorbedDose;
  Tol3d_2(Tol: Quantity_AbsorbedDose): void;
  Tolang_1(): Quantity_AbsorbedDose;
  Tolang_2(Tol: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_Boundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_Boundary): void;
  get(): GeomFill_Boundary;
  delete(): void;
}

  export declare class Handle_GeomFill_Boundary_1 extends Handle_GeomFill_Boundary {
    constructor();
  }

  export declare class Handle_GeomFill_Boundary_2 extends Handle_GeomFill_Boundary {
    constructor(thePtr: GeomFill_Boundary);
  }

  export declare class Handle_GeomFill_Boundary_3 extends Handle_GeomFill_Boundary {
    constructor(theHandle: Handle_GeomFill_Boundary);
  }

  export declare class Handle_GeomFill_Boundary_4 extends Handle_GeomFill_Boundary {
    constructor(theHandle: Handle_GeomFill_Boundary);
  }

export declare class Handle_GeomFill_NSections {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_NSections): void;
  get(): GeomFill_NSections;
  delete(): void;
}

  export declare class Handle_GeomFill_NSections_1 extends Handle_GeomFill_NSections {
    constructor();
  }

  export declare class Handle_GeomFill_NSections_2 extends Handle_GeomFill_NSections {
    constructor(thePtr: GeomFill_NSections);
  }

  export declare class Handle_GeomFill_NSections_3 extends Handle_GeomFill_NSections {
    constructor(theHandle: Handle_GeomFill_NSections);
  }

  export declare class Handle_GeomFill_NSections_4 extends Handle_GeomFill_NSections {
    constructor(theHandle: Handle_GeomFill_NSections);
  }

export declare class GeomFill_Coons extends GeomFill_Filling {
  Init_1(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt): void;
  Init_2(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal, W3: TColStd_Array1OfReal, W4: TColStd_Array1OfReal): void;
  delete(): void;
}

  export declare class GeomFill_Coons_1 extends GeomFill_Coons {
    constructor();
  }

  export declare class GeomFill_Coons_2 extends GeomFill_Coons {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt);
  }

  export declare class GeomFill_Coons_3 extends GeomFill_Coons {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal, W3: TColStd_Array1OfReal, W4: TColStd_Array1OfReal);
  }

export declare class Handle_GeomFill_TgtOnCoons {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_TgtOnCoons): void;
  get(): GeomFill_TgtOnCoons;
  delete(): void;
}

  export declare class Handle_GeomFill_TgtOnCoons_1 extends Handle_GeomFill_TgtOnCoons {
    constructor();
  }

  export declare class Handle_GeomFill_TgtOnCoons_2 extends Handle_GeomFill_TgtOnCoons {
    constructor(thePtr: GeomFill_TgtOnCoons);
  }

  export declare class Handle_GeomFill_TgtOnCoons_3 extends Handle_GeomFill_TgtOnCoons {
    constructor(theHandle: Handle_GeomFill_TgtOnCoons);
  }

  export declare class Handle_GeomFill_TgtOnCoons_4 extends Handle_GeomFill_TgtOnCoons {
    constructor(theHandle: Handle_GeomFill_TgtOnCoons);
  }

export declare class GeomFill_TgtOnCoons extends GeomFill_TgtField {
  constructor(K: Handle_GeomFill_CoonsAlgPatch, I: Graphic3d_ZLayerId)
  Value(W: Quantity_AbsorbedDose): gp_Vec;
  D1_1(W: Quantity_AbsorbedDose): gp_Vec;
  D1_2(W: Quantity_AbsorbedDose, T: gp_Vec, DT: gp_Vec): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_AppSweep extends AppBlend_Approx {
  Init(Degmin: Graphic3d_ZLayerId, Degmax: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIt: Graphic3d_ZLayerId, KnownParameters: Standard_Boolean): void;
  SetParType(ParType: Approx_ParametrizationType): void;
  SetContinuity(C: GeomAbs_Shape): void;
  SetCriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  ParType(): Approx_ParametrizationType;
  Continuity(): GeomAbs_Shape;
  CriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  Perform_1(Lin: Handle_GeomFill_Line, SecGen: GeomFill_SweepSectionGenerator, SpApprox: Standard_Boolean): void;
  PerformSmoothing(Lin: Handle_GeomFill_Line, SecGen: GeomFill_SweepSectionGenerator): void;
  Perform_2(Lin: Handle_GeomFill_Line, SecGen: GeomFill_SweepSectionGenerator, NbMaxP: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  SurfShape(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, NbUPoles: Graphic3d_ZLayerId, NbVPoles: Graphic3d_ZLayerId, NbUKnots: Graphic3d_ZLayerId, NbVKnots: Graphic3d_ZLayerId): void;
  Surface(TPoles: TColgp_Array2OfPnt, TWeights: TColStd_Array2OfReal, TUKnots: TColStd_Array1OfReal, TVKnots: TColStd_Array1OfReal, TUMults: TColStd_Array1OfInteger, TVMults: TColStd_Array1OfInteger): void;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  SurfPoles(): TColgp_Array2OfPnt;
  SurfWeights(): TColStd_Array2OfReal;
  SurfUKnots(): TColStd_Array1OfReal;
  SurfVKnots(): TColStd_Array1OfReal;
  SurfUMults(): TColStd_Array1OfInteger;
  SurfVMults(): TColStd_Array1OfInteger;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curves2dShape(Degree: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId): void;
  Curve2d(Index: Graphic3d_ZLayerId, TPoles: TColgp_Array1OfPnt2d, TKnots: TColStd_Array1OfReal, TMults: TColStd_Array1OfInteger): void;
  Curves2dDegree(): Graphic3d_ZLayerId;
  Curve2dPoles(Index: Graphic3d_ZLayerId): TColgp_Array1OfPnt2d;
  Curves2dKnots(): TColStd_Array1OfReal;
  Curves2dMults(): TColStd_Array1OfInteger;
  TolReached(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  TolCurveOnSurf(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomFill_AppSweep_1 extends GeomFill_AppSweep {
    constructor();
  }

  export declare class GeomFill_AppSweep_2 extends GeomFill_AppSweep {
    constructor(Degmin: Graphic3d_ZLayerId, Degmax: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIt: Graphic3d_ZLayerId, KnownParameters: Standard_Boolean);
  }

export declare class GeomFill_BSplineCurves {
  Init_1(C1: Handle_Geom_BSplineCurve, C2: Handle_Geom_BSplineCurve, C3: Handle_Geom_BSplineCurve, C4: Handle_Geom_BSplineCurve, Type: GeomFill_FillingStyle): void;
  Init_2(C1: Handle_Geom_BSplineCurve, C2: Handle_Geom_BSplineCurve, C3: Handle_Geom_BSplineCurve, Type: GeomFill_FillingStyle): void;
  Init_3(C1: Handle_Geom_BSplineCurve, C2: Handle_Geom_BSplineCurve, Type: GeomFill_FillingStyle): void;
  Surface(): Handle_Geom_BSplineSurface;
  delete(): void;
}

  export declare class GeomFill_BSplineCurves_1 extends GeomFill_BSplineCurves {
    constructor();
  }

  export declare class GeomFill_BSplineCurves_2 extends GeomFill_BSplineCurves {
    constructor(C1: Handle_Geom_BSplineCurve, C2: Handle_Geom_BSplineCurve, C3: Handle_Geom_BSplineCurve, C4: Handle_Geom_BSplineCurve, Type: GeomFill_FillingStyle);
  }

  export declare class GeomFill_BSplineCurves_3 extends GeomFill_BSplineCurves {
    constructor(C1: Handle_Geom_BSplineCurve, C2: Handle_Geom_BSplineCurve, C3: Handle_Geom_BSplineCurve, Type: GeomFill_FillingStyle);
  }

  export declare class GeomFill_BSplineCurves_4 extends GeomFill_BSplineCurves {
    constructor(C1: Handle_Geom_BSplineCurve, C2: Handle_Geom_BSplineCurve, Type: GeomFill_FillingStyle);
  }

export declare class GeomFill {
  constructor();
  static Surface(Curve1: Handle_Geom_Curve, Curve2: Handle_Geom_Curve): Handle_Geom_Surface;
  static GetCircle_1(TConv: Convert_ParameterisationType, ns1: gp_Vec, ns2: gp_Vec, nplan: gp_Vec, pt1: gp_Pnt, pt2: gp_Pnt, Rayon: Quantity_AbsorbedDose, Center: gp_Pnt, Poles: TColgp_Array1OfPnt, Weigths: TColStd_Array1OfReal): void;
  static GetCircle_2(TConv: Convert_ParameterisationType, ns1: gp_Vec, ns2: gp_Vec, dn1w: gp_Vec, dn2w: gp_Vec, nplan: gp_Vec, dnplan: gp_Vec, pts1: gp_Pnt, pts2: gp_Pnt, tang1: gp_Vec, tang2: gp_Vec, Rayon: Quantity_AbsorbedDose, DRayon: Quantity_AbsorbedDose, Center: gp_Pnt, DCenter: gp_Vec, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  static GetCircle_3(TConv: Convert_ParameterisationType, ns1: gp_Vec, ns2: gp_Vec, dn1w: gp_Vec, dn2w: gp_Vec, d2n1w: gp_Vec, d2n2w: gp_Vec, nplan: gp_Vec, dnplan: gp_Vec, d2nplan: gp_Vec, pts1: gp_Pnt, pts2: gp_Pnt, tang1: gp_Vec, tang2: gp_Vec, Dtang1: gp_Vec, Dtang2: gp_Vec, Rayon: Quantity_AbsorbedDose, DRayon: Quantity_AbsorbedDose, D2Rayon: Quantity_AbsorbedDose, Center: gp_Pnt, DCenter: gp_Vec, D2Center: gp_Vec, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  static GetShape(MaxAng: Quantity_AbsorbedDose, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, TypeConv: Convert_ParameterisationType): void;
  static Knots(TypeConv: Convert_ParameterisationType, TKnots: TColStd_Array1OfReal): void;
  static Mults(TypeConv: Convert_ParameterisationType, TMults: TColStd_Array1OfInteger): void;
  static GetMinimalWeights(TConv: Convert_ParameterisationType, AngleMin: Quantity_AbsorbedDose, AngleMax: Quantity_AbsorbedDose, Weigths: TColStd_Array1OfReal): void;
  static GetTolerance(TConv: Convert_ParameterisationType, AngleMin: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose, AngularTol: Quantity_AbsorbedDose, SpatialTol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GeomFill_LocFunction {
  constructor(Law: Handle_GeomFill_LocationLaw)
  D0(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): Standard_Boolean;
  DN(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Order: Graphic3d_ZLayerId, Result: Quantity_AbsorbedDose, Ier: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class GeomFill_Profiler {
  constructor()
  AddCurve(Curve: Handle_Geom_Curve): void;
  Perform(PTol: Quantity_AbsorbedDose): void;
  Degree(): Graphic3d_ZLayerId;
  IsPeriodic(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  Poles(Index: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt): void;
  Weights(Index: Graphic3d_ZLayerId, Weights: TColStd_Array1OfReal): void;
  NbKnots(): Graphic3d_ZLayerId;
  KnotsAndMults(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger): void;
  Curve(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  delete(): void;
}

export declare class Handle_GeomFill_LocationGuide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_LocationGuide): void;
  get(): GeomFill_LocationGuide;
  delete(): void;
}

  export declare class Handle_GeomFill_LocationGuide_1 extends Handle_GeomFill_LocationGuide {
    constructor();
  }

  export declare class Handle_GeomFill_LocationGuide_2 extends Handle_GeomFill_LocationGuide {
    constructor(thePtr: GeomFill_LocationGuide);
  }

  export declare class Handle_GeomFill_LocationGuide_3 extends Handle_GeomFill_LocationGuide {
    constructor(theHandle: Handle_GeomFill_LocationGuide);
  }

  export declare class Handle_GeomFill_LocationGuide_4 extends Handle_GeomFill_LocationGuide {
    constructor(theHandle: Handle_GeomFill_LocationGuide);
  }

export declare class GeomFill_LocationGuide extends GeomFill_LocationLaw {
  constructor(Triedre: Handle_GeomFill_TrihedronWithGuide)
  Set(Section: Handle_GeomFill_SectionLaw, rotat: Standard_Boolean, SFirst: Quantity_AbsorbedDose, SLast: Quantity_AbsorbedDose, PrecAngle: Quantity_AbsorbedDose, LastAngle: Quantity_AbsorbedDose): void;
  EraseRotation(): void;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  GetCurve(): Handle_Adaptor3d_HCurve;
  SetTrsf(Transfo: gp_Mat): void;
  Copy(): Handle_GeomFill_LocationLaw;
  D0_1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec): Standard_Boolean;
  D0_2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, D2M: gp_Mat, D2V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  HasFirstRestriction(): Standard_Boolean;
  HasLastRestriction(): Standard_Boolean;
  TraceNumber(): Graphic3d_ZLayerId;
  ErrorStatus(): GeomFill_PipeError;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  Resolution(Index: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  GetMaximalNorm(): Quantity_AbsorbedDose;
  GetAverageLaw(AM: gp_Mat, AV: gp_Vec): void;
  IsTranslation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  IsRotation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  Rotation(Center: gp_Pnt): void;
  Section(): Handle_Geom_Curve;
  Guide(): Handle_Adaptor3d_HCurve;
  SetOrigine(Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose): void;
  ComputeAutomaticLaw(ParAndRad: Handle_TColgp_HArray1OfPnt2d): GeomFill_PipeError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_ConstrainedFilling {
  constructor(MaxDeg: Graphic3d_ZLayerId, MaxSeg: Graphic3d_ZLayerId)
  Init_1(B1: Handle_GeomFill_Boundary, B2: Handle_GeomFill_Boundary, B3: Handle_GeomFill_Boundary, NoCheck: Standard_Boolean): void;
  Init_2(B1: Handle_GeomFill_Boundary, B2: Handle_GeomFill_Boundary, B3: Handle_GeomFill_Boundary, B4: Handle_GeomFill_Boundary, NoCheck: Standard_Boolean): void;
  SetDomain(l: Quantity_AbsorbedDose, B: Handle_GeomFill_BoundWithSurf): void;
  ReBuild(): void;
  Boundary(I: Graphic3d_ZLayerId): Handle_GeomFill_Boundary;
  Surface(): Handle_Geom_BSplineSurface;
  Eval(W: Quantity_AbsorbedDose, Ord: Graphic3d_ZLayerId, Result: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  CheckCoonsAlgPatch(I: Graphic3d_ZLayerId): void;
  CheckTgteField(I: Graphic3d_ZLayerId): void;
  CheckApprox(I: Graphic3d_ZLayerId): void;
  CheckResult(I: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_GeomFill_EvolvedSection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_EvolvedSection): void;
  get(): GeomFill_EvolvedSection;
  delete(): void;
}

  export declare class Handle_GeomFill_EvolvedSection_1 extends Handle_GeomFill_EvolvedSection {
    constructor();
  }

  export declare class Handle_GeomFill_EvolvedSection_2 extends Handle_GeomFill_EvolvedSection {
    constructor(thePtr: GeomFill_EvolvedSection);
  }

  export declare class Handle_GeomFill_EvolvedSection_3 extends Handle_GeomFill_EvolvedSection {
    constructor(theHandle: Handle_GeomFill_EvolvedSection);
  }

  export declare class Handle_GeomFill_EvolvedSection_4 extends Handle_GeomFill_EvolvedSection {
    constructor(theHandle: Handle_GeomFill_EvolvedSection);
  }

export declare class GeomFill_EvolvedSection extends GeomFill_SectionLaw {
  constructor(C: Handle_Geom_Curve, L: Handle_Law_Function)
  D0(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  BSplineSurface(): Handle_Geom_BSplineSurface;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  IsConstant(Error: Quantity_AbsorbedDose): Standard_Boolean;
  ConstantSection(): Handle_Geom_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_Frenet extends GeomFill_TrihedronLaw {
  constructor()
  Copy(): Handle_GeomFill_TrihedronLaw;
  Init(): void;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_Frenet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_Frenet): void;
  get(): GeomFill_Frenet;
  delete(): void;
}

  export declare class Handle_GeomFill_Frenet_1 extends Handle_GeomFill_Frenet {
    constructor();
  }

  export declare class Handle_GeomFill_Frenet_2 extends Handle_GeomFill_Frenet {
    constructor(thePtr: GeomFill_Frenet);
  }

  export declare class Handle_GeomFill_Frenet_3 extends Handle_GeomFill_Frenet {
    constructor(theHandle: Handle_GeomFill_Frenet);
  }

  export declare class Handle_GeomFill_Frenet_4 extends Handle_GeomFill_Frenet {
    constructor(theHandle: Handle_GeomFill_Frenet);
  }

export declare class GeomFill_ConstantBiNormal extends GeomFill_TrihedronLaw {
  constructor(BiNormal: gp_Dir)
  Copy(): Handle_GeomFill_TrihedronLaw;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_ConstantBiNormal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_ConstantBiNormal): void;
  get(): GeomFill_ConstantBiNormal;
  delete(): void;
}

  export declare class Handle_GeomFill_ConstantBiNormal_1 extends Handle_GeomFill_ConstantBiNormal {
    constructor();
  }

  export declare class Handle_GeomFill_ConstantBiNormal_2 extends Handle_GeomFill_ConstantBiNormal {
    constructor(thePtr: GeomFill_ConstantBiNormal);
  }

  export declare class Handle_GeomFill_ConstantBiNormal_3 extends Handle_GeomFill_ConstantBiNormal {
    constructor(theHandle: Handle_GeomFill_ConstantBiNormal);
  }

  export declare class Handle_GeomFill_ConstantBiNormal_4 extends Handle_GeomFill_ConstantBiNormal {
    constructor(theHandle: Handle_GeomFill_ConstantBiNormal);
  }

export declare class GeomFill_BezierCurves {
  Init_1(C1: Handle_Geom_BezierCurve, C2: Handle_Geom_BezierCurve, C3: Handle_Geom_BezierCurve, C4: Handle_Geom_BezierCurve, Type: GeomFill_FillingStyle): void;
  Init_2(C1: Handle_Geom_BezierCurve, C2: Handle_Geom_BezierCurve, C3: Handle_Geom_BezierCurve, Type: GeomFill_FillingStyle): void;
  Init_3(C1: Handle_Geom_BezierCurve, C2: Handle_Geom_BezierCurve, Type: GeomFill_FillingStyle): void;
  Surface(): Handle_Geom_BezierSurface;
  delete(): void;
}

  export declare class GeomFill_BezierCurves_1 extends GeomFill_BezierCurves {
    constructor();
  }

  export declare class GeomFill_BezierCurves_2 extends GeomFill_BezierCurves {
    constructor(C1: Handle_Geom_BezierCurve, C2: Handle_Geom_BezierCurve, C3: Handle_Geom_BezierCurve, C4: Handle_Geom_BezierCurve, Type: GeomFill_FillingStyle);
  }

  export declare class GeomFill_BezierCurves_3 extends GeomFill_BezierCurves {
    constructor(C1: Handle_Geom_BezierCurve, C2: Handle_Geom_BezierCurve, C3: Handle_Geom_BezierCurve, Type: GeomFill_FillingStyle);
  }

  export declare class GeomFill_BezierCurves_4 extends GeomFill_BezierCurves {
    constructor(C1: Handle_Geom_BezierCurve, C2: Handle_Geom_BezierCurve, Type: GeomFill_FillingStyle);
  }

export declare class Handle_GeomFill_SectionLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_SectionLaw): void;
  get(): GeomFill_SectionLaw;
  delete(): void;
}

  export declare class Handle_GeomFill_SectionLaw_1 extends Handle_GeomFill_SectionLaw {
    constructor();
  }

  export declare class Handle_GeomFill_SectionLaw_2 extends Handle_GeomFill_SectionLaw {
    constructor(thePtr: GeomFill_SectionLaw);
  }

  export declare class Handle_GeomFill_SectionLaw_3 extends Handle_GeomFill_SectionLaw {
    constructor(theHandle: Handle_GeomFill_SectionLaw);
  }

  export declare class Handle_GeomFill_SectionLaw_4 extends Handle_GeomFill_SectionLaw {
    constructor(theHandle: Handle_GeomFill_SectionLaw);
  }

export declare class GeomFill_SectionLaw extends Standard_Transient {
  D0(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  BSplineSurface(): Handle_Geom_BSplineSurface;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  IsConstant(Error: Quantity_AbsorbedDose): Standard_Boolean;
  ConstantSection(): Handle_Geom_Curve;
  IsConicalLaw(Error: Quantity_AbsorbedDose): Standard_Boolean;
  CirclSection(Param: Quantity_AbsorbedDose): Handle_Geom_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_HArray1OfLocationLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_HArray1OfLocationLaw): void;
  get(): GeomFill_HArray1OfLocationLaw;
  delete(): void;
}

  export declare class Handle_GeomFill_HArray1OfLocationLaw_1 extends Handle_GeomFill_HArray1OfLocationLaw {
    constructor();
  }

  export declare class Handle_GeomFill_HArray1OfLocationLaw_2 extends Handle_GeomFill_HArray1OfLocationLaw {
    constructor(thePtr: GeomFill_HArray1OfLocationLaw);
  }

  export declare class Handle_GeomFill_HArray1OfLocationLaw_3 extends Handle_GeomFill_HArray1OfLocationLaw {
    constructor(theHandle: Handle_GeomFill_HArray1OfLocationLaw);
  }

  export declare class Handle_GeomFill_HArray1OfLocationLaw_4 extends Handle_GeomFill_HArray1OfLocationLaw {
    constructor(theHandle: Handle_GeomFill_HArray1OfLocationLaw);
  }

export declare class GeomFill_Pipe {
  Init_1(Path: Handle_Geom_Curve, Radius: Quantity_AbsorbedDose): void;
  Init_2(Path: Handle_Geom_Curve, FirstSect: Handle_Geom_Curve, Option: GeomFill_Trihedron): void;
  Init_3(Path: Handle_Geom2d_Curve, Support: Handle_Geom_Surface, FirstSect: Handle_Geom_Curve): void;
  Init_4(Path: Handle_Geom_Curve, FirstSect: Handle_Geom_Curve, Dir: gp_Dir): void;
  Init_5(Path: Handle_Geom_Curve, FirstSect: Handle_Geom_Curve, LastSect: Handle_Geom_Curve): void;
  Init_6(Path: Handle_Geom_Curve, NSections: TColGeom_SequenceOfCurve): void;
  Init_7(Path: Handle_Adaptor3d_HCurve, Curve1: Handle_Adaptor3d_HCurve, Curve2: Handle_Adaptor3d_HCurve, Radius: Quantity_AbsorbedDose): void;
  Init_8(Path: Handle_Geom_Curve, Guide: Handle_Adaptor3d_HCurve, FirstSect: Handle_Geom_Curve, ByACR: Standard_Boolean, rotat: Standard_Boolean): void;
  Perform_1(WithParameters: Standard_Boolean, myPolynomial: Standard_Boolean): void;
  Perform_2(Tol: Quantity_AbsorbedDose, Polynomial: Standard_Boolean, Conti: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, NbMaxSegment: Graphic3d_ZLayerId): void;
  Surface(): Handle_Geom_Surface;
  ExchangeUV(): Standard_Boolean;
  GenerateParticularCase_1(B: Standard_Boolean): void;
  GenerateParticularCase_2(): Standard_Boolean;
  ErrorOnSurf(): Quantity_AbsorbedDose;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class GeomFill_Pipe_1 extends GeomFill_Pipe {
    constructor();
  }

  export declare class GeomFill_Pipe_2 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, Radius: Quantity_AbsorbedDose);
  }

  export declare class GeomFill_Pipe_3 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, FirstSect: Handle_Geom_Curve, Option: GeomFill_Trihedron);
  }

  export declare class GeomFill_Pipe_4 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom2d_Curve, Support: Handle_Geom_Surface, FirstSect: Handle_Geom_Curve);
  }

  export declare class GeomFill_Pipe_5 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, FirstSect: Handle_Geom_Curve, Dir: gp_Dir);
  }

  export declare class GeomFill_Pipe_6 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, FirstSect: Handle_Geom_Curve, LastSect: Handle_Geom_Curve);
  }

  export declare class GeomFill_Pipe_7 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, NSections: TColGeom_SequenceOfCurve);
  }

  export declare class GeomFill_Pipe_8 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, Curve1: Handle_Geom_Curve, Curve2: Handle_Geom_Curve, Radius: Quantity_AbsorbedDose);
  }

  export declare class GeomFill_Pipe_9 extends GeomFill_Pipe {
    constructor(Path: Handle_Adaptor3d_HCurve, Curve1: Handle_Adaptor3d_HCurve, Curve2: Handle_Adaptor3d_HCurve, Radius: Quantity_AbsorbedDose);
  }

  export declare class GeomFill_Pipe_10 extends GeomFill_Pipe {
    constructor(Path: Handle_Geom_Curve, Guide: Handle_Adaptor3d_HCurve, FirstSect: Handle_Geom_Curve, ByACR: Standard_Boolean, rotat: Standard_Boolean);
  }

export declare class GeomFill_Sweep {
  constructor(Location: Handle_GeomFill_LocationLaw, WithKpart: Standard_Boolean)
  SetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, SectionFirst: Quantity_AbsorbedDose, SectionLast: Quantity_AbsorbedDose): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, BoundTol: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, TolAngular: Quantity_AbsorbedDose): void;
  SetForceApproxC1(ForceApproxC1: Standard_Boolean): void;
  ExchangeUV(): Standard_Boolean;
  UReversed(): Standard_Boolean;
  VReversed(): Standard_Boolean;
  Build(Section: Handle_GeomFill_SectionLaw, Methode: GeomFill_ApproxStyle, Continuity: GeomAbs_Shape, Degmax: Graphic3d_ZLayerId, Segmax: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  ErrorOnSurface(): Quantity_AbsorbedDose;
  ErrorOnRestriction(IsFirst: Standard_Boolean, UError: Quantity_AbsorbedDose, VError: Quantity_AbsorbedDose): void;
  ErrorOnTrace(IndexOfTrace: Graphic3d_ZLayerId, UError: Quantity_AbsorbedDose, VError: Quantity_AbsorbedDose): void;
  Surface(): Handle_Geom_Surface;
  Restriction(IsFirst: Standard_Boolean): Handle_Geom2d_Curve;
  NumberOfTrace(): Graphic3d_ZLayerId;
  Trace(IndexOfTrace: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  delete(): void;
}

export declare class GeomFill_SweepFunction extends Approx_SweepFunction {
  constructor(Section: Handle_GeomFill_SectionLaw, Location: Handle_GeomFill_LocationLaw, FirstParameter: Quantity_AbsorbedDose, FirstParameterOnS: Quantity_AbsorbedDose, RatioParameterOnS: Quantity_AbsorbedDose)
  D0(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Nb2dCurves(): Graphic3d_ZLayerId;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Resolution(Index: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_SweepFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_SweepFunction): void;
  get(): GeomFill_SweepFunction;
  delete(): void;
}

  export declare class Handle_GeomFill_SweepFunction_1 extends Handle_GeomFill_SweepFunction {
    constructor();
  }

  export declare class Handle_GeomFill_SweepFunction_2 extends Handle_GeomFill_SweepFunction {
    constructor(thePtr: GeomFill_SweepFunction);
  }

  export declare class Handle_GeomFill_SweepFunction_3 extends Handle_GeomFill_SweepFunction {
    constructor(theHandle: Handle_GeomFill_SweepFunction);
  }

  export declare class Handle_GeomFill_SweepFunction_4 extends Handle_GeomFill_SweepFunction {
    constructor(theHandle: Handle_GeomFill_SweepFunction);
  }

export declare class GeomFill_TgtField extends Standard_Transient {
  IsScalable(): Standard_Boolean;
  Scale(Func: Handle_Law_BSpline): void;
  Value(W: Quantity_AbsorbedDose): gp_Vec;
  D1_1(W: Quantity_AbsorbedDose): gp_Vec;
  D1_2(W: Quantity_AbsorbedDose, V: gp_Vec, DV: gp_Vec): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_TgtField {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_TgtField): void;
  get(): GeomFill_TgtField;
  delete(): void;
}

  export declare class Handle_GeomFill_TgtField_1 extends Handle_GeomFill_TgtField {
    constructor();
  }

  export declare class Handle_GeomFill_TgtField_2 extends Handle_GeomFill_TgtField {
    constructor(thePtr: GeomFill_TgtField);
  }

  export declare class Handle_GeomFill_TgtField_3 extends Handle_GeomFill_TgtField {
    constructor(theHandle: Handle_GeomFill_TgtField);
  }

  export declare class Handle_GeomFill_TgtField_4 extends Handle_GeomFill_TgtField {
    constructor(theHandle: Handle_GeomFill_TgtField);
  }

export declare class Handle_GeomFill_HArray1OfSectionLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_HArray1OfSectionLaw): void;
  get(): GeomFill_HArray1OfSectionLaw;
  delete(): void;
}

  export declare class Handle_GeomFill_HArray1OfSectionLaw_1 extends Handle_GeomFill_HArray1OfSectionLaw {
    constructor();
  }

  export declare class Handle_GeomFill_HArray1OfSectionLaw_2 extends Handle_GeomFill_HArray1OfSectionLaw {
    constructor(thePtr: GeomFill_HArray1OfSectionLaw);
  }

  export declare class Handle_GeomFill_HArray1OfSectionLaw_3 extends Handle_GeomFill_HArray1OfSectionLaw {
    constructor(theHandle: Handle_GeomFill_HArray1OfSectionLaw);
  }

  export declare class Handle_GeomFill_HArray1OfSectionLaw_4 extends Handle_GeomFill_HArray1OfSectionLaw {
    constructor(theHandle: Handle_GeomFill_HArray1OfSectionLaw);
  }

export declare class GeomFill_Stretch extends GeomFill_Filling {
  Init_1(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt): void;
  Init_2(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal, W3: TColStd_Array1OfReal, W4: TColStd_Array1OfReal): void;
  delete(): void;
}

  export declare class GeomFill_Stretch_1 extends GeomFill_Stretch {
    constructor();
  }

  export declare class GeomFill_Stretch_2 extends GeomFill_Stretch {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt);
  }

  export declare class GeomFill_Stretch_3 extends GeomFill_Stretch {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal, W3: TColStd_Array1OfReal, W4: TColStd_Array1OfReal);
  }

export declare class GeomFill_GuideTrihedronAC extends GeomFill_TrihedronWithGuide {
  constructor(guide: Handle_Adaptor3d_HCurve)
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  Copy(): Handle_GeomFill_TrihedronLaw;
  Guide(): Handle_Adaptor3d_HCurve;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  Origine(OrACR1: Quantity_AbsorbedDose, OrACR2: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_GuideTrihedronAC {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_GuideTrihedronAC): void;
  get(): GeomFill_GuideTrihedronAC;
  delete(): void;
}

  export declare class Handle_GeomFill_GuideTrihedronAC_1 extends Handle_GeomFill_GuideTrihedronAC {
    constructor();
  }

  export declare class Handle_GeomFill_GuideTrihedronAC_2 extends Handle_GeomFill_GuideTrihedronAC {
    constructor(thePtr: GeomFill_GuideTrihedronAC);
  }

  export declare class Handle_GeomFill_GuideTrihedronAC_3 extends Handle_GeomFill_GuideTrihedronAC {
    constructor(theHandle: Handle_GeomFill_GuideTrihedronAC);
  }

  export declare class Handle_GeomFill_GuideTrihedronAC_4 extends Handle_GeomFill_GuideTrihedronAC {
    constructor(theHandle: Handle_GeomFill_GuideTrihedronAC);
  }

export declare class GeomFill_SequenceOfTrsf extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: GeomFill_SequenceOfTrsf): GeomFill_SequenceOfTrsf;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Trsf): void;
  Append_2(theSeq: GeomFill_SequenceOfTrsf): void;
  Prepend_1(theItem: gp_Trsf): void;
  Prepend_2(theSeq: GeomFill_SequenceOfTrsf): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Trsf): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: GeomFill_SequenceOfTrsf): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: GeomFill_SequenceOfTrsf): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Trsf): void;
  Split(theIndex: Standard_Integer, theSeq: GeomFill_SequenceOfTrsf): void;
  First(): gp_Trsf;
  ChangeFirst(): gp_Trsf;
  Last(): gp_Trsf;
  ChangeLast(): gp_Trsf;
  Value(theIndex: Standard_Integer): gp_Trsf;
  ChangeValue(theIndex: Standard_Integer): gp_Trsf;
  SetValue(theIndex: Standard_Integer, theItem: gp_Trsf): void;
  delete(): void;
}

  export declare class GeomFill_SequenceOfTrsf_1 extends GeomFill_SequenceOfTrsf {
    constructor();
  }

  export declare class GeomFill_SequenceOfTrsf_2 extends GeomFill_SequenceOfTrsf {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class GeomFill_SequenceOfTrsf_3 extends GeomFill_SequenceOfTrsf {
    constructor(theOther: GeomFill_SequenceOfTrsf);
  }

export declare class Handle_GeomFill_UniformSection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_UniformSection): void;
  get(): GeomFill_UniformSection;
  delete(): void;
}

  export declare class Handle_GeomFill_UniformSection_1 extends Handle_GeomFill_UniformSection {
    constructor();
  }

  export declare class Handle_GeomFill_UniformSection_2 extends Handle_GeomFill_UniformSection {
    constructor(thePtr: GeomFill_UniformSection);
  }

  export declare class Handle_GeomFill_UniformSection_3 extends Handle_GeomFill_UniformSection {
    constructor(theHandle: Handle_GeomFill_UniformSection);
  }

  export declare class Handle_GeomFill_UniformSection_4 extends Handle_GeomFill_UniformSection {
    constructor(theHandle: Handle_GeomFill_UniformSection);
  }

export declare class GeomFill_UniformSection extends GeomFill_SectionLaw {
  constructor(C: Handle_Geom_Curve, FirstParameter: Quantity_AbsorbedDose, LastParameter: Quantity_AbsorbedDose)
  D0(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  BSplineSurface(): Handle_Geom_BSplineSurface;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  IsConstant(Error: Quantity_AbsorbedDose): Standard_Boolean;
  ConstantSection(): Handle_Geom_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_CurveAndTrihedron {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_CurveAndTrihedron): void;
  get(): GeomFill_CurveAndTrihedron;
  delete(): void;
}

  export declare class Handle_GeomFill_CurveAndTrihedron_1 extends Handle_GeomFill_CurveAndTrihedron {
    constructor();
  }

  export declare class Handle_GeomFill_CurveAndTrihedron_2 extends Handle_GeomFill_CurveAndTrihedron {
    constructor(thePtr: GeomFill_CurveAndTrihedron);
  }

  export declare class Handle_GeomFill_CurveAndTrihedron_3 extends Handle_GeomFill_CurveAndTrihedron {
    constructor(theHandle: Handle_GeomFill_CurveAndTrihedron);
  }

  export declare class Handle_GeomFill_CurveAndTrihedron_4 extends Handle_GeomFill_CurveAndTrihedron {
    constructor(theHandle: Handle_GeomFill_CurveAndTrihedron);
  }

export declare class GeomFill_CurveAndTrihedron extends GeomFill_LocationLaw {
  constructor(Trihedron: Handle_GeomFill_TrihedronLaw)
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  GetCurve(): Handle_Adaptor3d_HCurve;
  SetTrsf(Transfo: gp_Mat): void;
  Copy(): Handle_GeomFill_LocationLaw;
  D0_1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec): Standard_Boolean;
  D0_2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, D2M: gp_Mat, D2V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetMaximalNorm(): Quantity_AbsorbedDose;
  GetAverageLaw(AM: gp_Mat, AV: gp_Vec): void;
  IsTranslation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  IsRotation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  Rotation(Center: gp_Pnt): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_CornerState {
  constructor()
  Gap_1(): Quantity_AbsorbedDose;
  Gap_2(G: Quantity_AbsorbedDose): void;
  TgtAng_1(): Quantity_AbsorbedDose;
  TgtAng_2(Ang: Quantity_AbsorbedDose): void;
  HasConstraint(): Standard_Boolean;
  Constraint(): void;
  NorAng_1(): Quantity_AbsorbedDose;
  NorAng_2(Ang: Quantity_AbsorbedDose): void;
  IsToKill(Scal: Quantity_AbsorbedDose): Standard_Boolean;
  DoKill(Scal: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomFill_SnglrFunc extends Adaptor3d_Curve {
  constructor(HC: Handle_Adaptor3d_HCurve)
  SetRatio(Ratio: Quantity_AbsorbedDose): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  delete(): void;
}

export declare class Handle_GeomFill_DegeneratedBound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_DegeneratedBound): void;
  get(): GeomFill_DegeneratedBound;
  delete(): void;
}

  export declare class Handle_GeomFill_DegeneratedBound_1 extends Handle_GeomFill_DegeneratedBound {
    constructor();
  }

  export declare class Handle_GeomFill_DegeneratedBound_2 extends Handle_GeomFill_DegeneratedBound {
    constructor(thePtr: GeomFill_DegeneratedBound);
  }

  export declare class Handle_GeomFill_DegeneratedBound_3 extends Handle_GeomFill_DegeneratedBound {
    constructor(theHandle: Handle_GeomFill_DegeneratedBound);
  }

  export declare class Handle_GeomFill_DegeneratedBound_4 extends Handle_GeomFill_DegeneratedBound {
    constructor(theHandle: Handle_GeomFill_DegeneratedBound);
  }

export declare class GeomFill_DegeneratedBound extends GeomFill_Boundary {
  constructor(Point: gp_Pnt, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, Tolang: Quantity_AbsorbedDose)
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  Reparametrize(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, HasDF: Standard_Boolean, HasDL: Standard_Boolean, DF: Quantity_AbsorbedDose, DL: Quantity_AbsorbedDose, Rev: Standard_Boolean): void;
  Bounds(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  IsDegenerated(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_SectionGenerator extends GeomFill_Profiler {
  constructor()
  SetParam(Params: Handle_TColStd_HArray1OfReal): void;
  GetShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, NbPoles2d: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  Section_1(P: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  Section_2(P: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): void;
  Parameter(P: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GeomFill_Filling {
  constructor()
  NbUPoles(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  Poles(Poles: TColgp_Array2OfPnt): void;
  isRational(): Standard_Boolean;
  Weights(Weights: TColStd_Array2OfReal): void;
  delete(): void;
}

export declare class Handle_GeomFill_Fixed {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_Fixed): void;
  get(): GeomFill_Fixed;
  delete(): void;
}

  export declare class Handle_GeomFill_Fixed_1 extends Handle_GeomFill_Fixed {
    constructor();
  }

  export declare class Handle_GeomFill_Fixed_2 extends Handle_GeomFill_Fixed {
    constructor(thePtr: GeomFill_Fixed);
  }

  export declare class Handle_GeomFill_Fixed_3 extends Handle_GeomFill_Fixed {
    constructor(theHandle: Handle_GeomFill_Fixed);
  }

  export declare class Handle_GeomFill_Fixed_4 extends Handle_GeomFill_Fixed {
    constructor(theHandle: Handle_GeomFill_Fixed);
  }

export declare class GeomFill_Fixed extends GeomFill_TrihedronLaw {
  constructor(Tangent: gp_Vec, Normal: gp_Vec)
  Copy(): Handle_GeomFill_TrihedronLaw;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_SequenceOfAx2 extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: GeomFill_SequenceOfAx2): GeomFill_SequenceOfAx2;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Ax2): void;
  Append_2(theSeq: GeomFill_SequenceOfAx2): void;
  Prepend_1(theItem: gp_Ax2): void;
  Prepend_2(theSeq: GeomFill_SequenceOfAx2): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Ax2): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: GeomFill_SequenceOfAx2): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: GeomFill_SequenceOfAx2): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Ax2): void;
  Split(theIndex: Standard_Integer, theSeq: GeomFill_SequenceOfAx2): void;
  First(): gp_Ax2;
  ChangeFirst(): gp_Ax2;
  Last(): gp_Ax2;
  ChangeLast(): gp_Ax2;
  Value(theIndex: Standard_Integer): gp_Ax2;
  ChangeValue(theIndex: Standard_Integer): gp_Ax2;
  SetValue(theIndex: Standard_Integer, theItem: gp_Ax2): void;
  delete(): void;
}

  export declare class GeomFill_SequenceOfAx2_1 extends GeomFill_SequenceOfAx2 {
    constructor();
  }

  export declare class GeomFill_SequenceOfAx2_2 extends GeomFill_SequenceOfAx2 {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class GeomFill_SequenceOfAx2_3 extends GeomFill_SequenceOfAx2 {
    constructor(theOther: GeomFill_SequenceOfAx2);
  }

export declare class GeomFill_SectionPlacement {
  constructor(L: Handle_GeomFill_LocationLaw, Section: Handle_Geom_Geometry)
  SetLocation(L: Handle_GeomFill_LocationLaw): void;
  Perform_1(Tol: Quantity_AbsorbedDose): void;
  Perform_2(Path: Handle_Adaptor3d_HCurve, Tol: Quantity_AbsorbedDose): void;
  Perform_3(ParamOnPath: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  ParameterOnPath(): Quantity_AbsorbedDose;
  ParameterOnSection(): Quantity_AbsorbedDose;
  Distance(): Quantity_AbsorbedDose;
  Angle(): Quantity_AbsorbedDose;
  Transformation(WithTranslation: Standard_Boolean, WithCorrection: Standard_Boolean): gp_Trsf;
  Section(WithTranslation: Standard_Boolean): Handle_Geom_Curve;
  ModifiedSection(WithTranslation: Standard_Boolean): Handle_Geom_Curve;
  delete(): void;
}

export declare class Handle_GeomFill_LocationDraft {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_LocationDraft): void;
  get(): GeomFill_LocationDraft;
  delete(): void;
}

  export declare class Handle_GeomFill_LocationDraft_1 extends Handle_GeomFill_LocationDraft {
    constructor();
  }

  export declare class Handle_GeomFill_LocationDraft_2 extends Handle_GeomFill_LocationDraft {
    constructor(thePtr: GeomFill_LocationDraft);
  }

  export declare class Handle_GeomFill_LocationDraft_3 extends Handle_GeomFill_LocationDraft {
    constructor(theHandle: Handle_GeomFill_LocationDraft);
  }

  export declare class Handle_GeomFill_LocationDraft_4 extends Handle_GeomFill_LocationDraft {
    constructor(theHandle: Handle_GeomFill_LocationDraft);
  }

export declare class GeomFill_LocationDraft extends GeomFill_LocationLaw {
  constructor(Direction: gp_Dir, Angle: Quantity_AbsorbedDose)
  SetStopSurf(Surf: Handle_Adaptor3d_HSurface): void;
  SetAngle(Angle: Quantity_AbsorbedDose): void;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  GetCurve(): Handle_Adaptor3d_HCurve;
  SetTrsf(Transfo: gp_Mat): void;
  Copy(): Handle_GeomFill_LocationLaw;
  D0_1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec): Standard_Boolean;
  D0_2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, M: gp_Mat, V: gp_Vec, DM: gp_Mat, DV: gp_Vec, D2M: gp_Mat, D2V: gp_Vec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d): Standard_Boolean;
  HasFirstRestriction(): Standard_Boolean;
  HasLastRestriction(): Standard_Boolean;
  TraceNumber(): Graphic3d_ZLayerId;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetDomain(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Resolution(Index: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  GetMaximalNorm(): Quantity_AbsorbedDose;
  GetAverageLaw(AM: gp_Mat, AV: gp_Vec): void;
  IsTranslation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  IsRotation(Error: Quantity_AbsorbedDose): Standard_Boolean;
  Rotation(Center: gp_Pnt): void;
  IsIntersec(): Standard_Boolean;
  Direction(): gp_Dir;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_CircularBlendFunc extends Approx_SweepFunction {
  constructor(Path: Handle_Adaptor3d_HCurve, Curve1: Handle_Adaptor3d_HCurve, Curve2: Handle_Adaptor3d_HCurve, Radius: Quantity_AbsorbedDose, Polynomial: Standard_Boolean)
  D0(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Nb2dCurves(): Graphic3d_ZLayerId;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_CircularBlendFunc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_CircularBlendFunc): void;
  get(): GeomFill_CircularBlendFunc;
  delete(): void;
}

  export declare class Handle_GeomFill_CircularBlendFunc_1 extends Handle_GeomFill_CircularBlendFunc {
    constructor();
  }

  export declare class Handle_GeomFill_CircularBlendFunc_2 extends Handle_GeomFill_CircularBlendFunc {
    constructor(thePtr: GeomFill_CircularBlendFunc);
  }

  export declare class Handle_GeomFill_CircularBlendFunc_3 extends Handle_GeomFill_CircularBlendFunc {
    constructor(theHandle: Handle_GeomFill_CircularBlendFunc);
  }

  export declare class Handle_GeomFill_CircularBlendFunc_4 extends Handle_GeomFill_CircularBlendFunc {
    constructor(theHandle: Handle_GeomFill_CircularBlendFunc);
  }

export declare type GeomFill_FillingStyle = {
  GeomFill_StretchStyle: {};
  GeomFill_CoonsStyle: {};
  GeomFill_CurvedStyle: {};
}

export declare class GeomFill_CorrectedFrenet extends GeomFill_TrihedronLaw {
  Copy(): Handle_GeomFill_TrihedronLaw;
  SetCurve(C: Handle_Adaptor3d_HCurve): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  EvaluateBestMode(): GeomFill_Trihedron;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomFill_CorrectedFrenet_1 extends GeomFill_CorrectedFrenet {
    constructor();
  }

  export declare class GeomFill_CorrectedFrenet_2 extends GeomFill_CorrectedFrenet {
    constructor(ForEvaluation: Standard_Boolean);
  }

export declare class Handle_GeomFill_CorrectedFrenet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_CorrectedFrenet): void;
  get(): GeomFill_CorrectedFrenet;
  delete(): void;
}

  export declare class Handle_GeomFill_CorrectedFrenet_1 extends Handle_GeomFill_CorrectedFrenet {
    constructor();
  }

  export declare class Handle_GeomFill_CorrectedFrenet_2 extends Handle_GeomFill_CorrectedFrenet {
    constructor(thePtr: GeomFill_CorrectedFrenet);
  }

  export declare class Handle_GeomFill_CorrectedFrenet_3 extends Handle_GeomFill_CorrectedFrenet {
    constructor(theHandle: Handle_GeomFill_CorrectedFrenet);
  }

  export declare class Handle_GeomFill_CorrectedFrenet_4 extends Handle_GeomFill_CorrectedFrenet {
    constructor(theHandle: Handle_GeomFill_CorrectedFrenet);
  }

export declare class GeomFill_GuideTrihedronPlan extends GeomFill_TrihedronWithGuide {
  constructor(theGuide: Handle_Adaptor3d_HCurve)
  SetCurve(thePath: Handle_Adaptor3d_HCurve): void;
  Copy(): Handle_GeomFill_TrihedronLaw;
  ErrorStatus(): GeomFill_PipeError;
  Guide(): Handle_Adaptor3d_HCurve;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  Origine(OrACR1: Quantity_AbsorbedDose, OrACR2: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_GuideTrihedronPlan {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_GuideTrihedronPlan): void;
  get(): GeomFill_GuideTrihedronPlan;
  delete(): void;
}

  export declare class Handle_GeomFill_GuideTrihedronPlan_1 extends Handle_GeomFill_GuideTrihedronPlan {
    constructor();
  }

  export declare class Handle_GeomFill_GuideTrihedronPlan_2 extends Handle_GeomFill_GuideTrihedronPlan {
    constructor(thePtr: GeomFill_GuideTrihedronPlan);
  }

  export declare class Handle_GeomFill_GuideTrihedronPlan_3 extends Handle_GeomFill_GuideTrihedronPlan {
    constructor(theHandle: Handle_GeomFill_GuideTrihedronPlan);
  }

  export declare class Handle_GeomFill_GuideTrihedronPlan_4 extends Handle_GeomFill_GuideTrihedronPlan {
    constructor(theHandle: Handle_GeomFill_GuideTrihedronPlan);
  }

export declare class GeomFill_Curved extends GeomFill_Filling {
  Init_1(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt): void;
  Init_2(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal, W3: TColStd_Array1OfReal, W4: TColStd_Array1OfReal): void;
  Init_3(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt): void;
  Init_4(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal): void;
  delete(): void;
}

  export declare class GeomFill_Curved_1 extends GeomFill_Curved {
    constructor();
  }

  export declare class GeomFill_Curved_2 extends GeomFill_Curved {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt);
  }

  export declare class GeomFill_Curved_3 extends GeomFill_Curved {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, P3: TColgp_Array1OfPnt, P4: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal, W3: TColStd_Array1OfReal, W4: TColStd_Array1OfReal);
  }

  export declare class GeomFill_Curved_4 extends GeomFill_Curved {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt);
  }

  export declare class GeomFill_Curved_5 extends GeomFill_Curved {
    constructor(P1: TColgp_Array1OfPnt, P2: TColgp_Array1OfPnt, W1: TColStd_Array1OfReal, W2: TColStd_Array1OfReal);
  }

export declare class GeomFill_FunctionDraft extends math_FunctionSetWithDerivatives {
  constructor(S: Handle_Adaptor3d_HSurface, C: Handle_Adaptor3d_HCurve)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  DerivT(C: Handle_Adaptor3d_HCurve, Param: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, dN: gp_Vec, teta: Quantity_AbsorbedDose, F: math_Vector): Standard_Boolean;
  Deriv2T(C: Handle_Adaptor3d_HCurve, Param: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, d2N: gp_Vec, teta: Quantity_AbsorbedDose, F: math_Vector): Standard_Boolean;
  DerivTX(dN: gp_Vec, teta: Quantity_AbsorbedDose, D: math_Matrix): Standard_Boolean;
  Deriv2X(X: math_Vector, T: GeomFill_Tensor): Standard_Boolean;
  delete(): void;
}

export declare class GeomFill_Tensor {
  constructor(NbRow: Graphic3d_ZLayerId, NbCol: Graphic3d_ZLayerId, NbMat: Graphic3d_ZLayerId)
  Init(InitialValue: Quantity_AbsorbedDose): void;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Mat: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ChangeValue(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId, Mat: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Multiply(Right: math_Vector, Product: math_Matrix): void;
  delete(): void;
}

export declare class Handle_GeomFill_TrihedronWithGuide {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_TrihedronWithGuide): void;
  get(): GeomFill_TrihedronWithGuide;
  delete(): void;
}

  export declare class Handle_GeomFill_TrihedronWithGuide_1 extends Handle_GeomFill_TrihedronWithGuide {
    constructor();
  }

  export declare class Handle_GeomFill_TrihedronWithGuide_2 extends Handle_GeomFill_TrihedronWithGuide {
    constructor(thePtr: GeomFill_TrihedronWithGuide);
  }

  export declare class Handle_GeomFill_TrihedronWithGuide_3 extends Handle_GeomFill_TrihedronWithGuide {
    constructor(theHandle: Handle_GeomFill_TrihedronWithGuide);
  }

  export declare class Handle_GeomFill_TrihedronWithGuide_4 extends Handle_GeomFill_TrihedronWithGuide {
    constructor(theHandle: Handle_GeomFill_TrihedronWithGuide);
  }

export declare class GeomFill_TrihedronWithGuide extends GeomFill_TrihedronLaw {
  Guide(): Handle_Adaptor3d_HCurve;
  Origine(Param1: Quantity_AbsorbedDose, Param2: Quantity_AbsorbedDose): void;
  CurrentPointOnGuide(): gp_Pnt;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomFill_Darboux extends GeomFill_TrihedronLaw {
  constructor()
  Copy(): Handle_GeomFill_TrihedronLaw;
  D0(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, Normal: gp_Vec, BiNormal: gp_Vec): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, Tangent: gp_Vec, DTangent: gp_Vec, D2Tangent: gp_Vec, Normal: gp_Vec, DNormal: gp_Vec, D2Normal: gp_Vec, BiNormal: gp_Vec, DBiNormal: gp_Vec, D2BiNormal: gp_Vec): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  GetAverageLaw(ATangent: gp_Vec, ANormal: gp_Vec, ABiNormal: gp_Vec): void;
  IsConstant(): Standard_Boolean;
  IsOnlyBy3dCurve(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomFill_Darboux {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomFill_Darboux): void;
  get(): GeomFill_Darboux;
  delete(): void;
}

  export declare class Handle_GeomFill_Darboux_1 extends Handle_GeomFill_Darboux {
    constructor();
  }

  export declare class Handle_GeomFill_Darboux_2 extends Handle_GeomFill_Darboux {
    constructor(thePtr: GeomFill_Darboux);
  }

  export declare class Handle_GeomFill_Darboux_3 extends Handle_GeomFill_Darboux {
    constructor(theHandle: Handle_GeomFill_Darboux);
  }

  export declare class Handle_GeomFill_Darboux_4 extends Handle_GeomFill_Darboux {
    constructor(theHandle: Handle_GeomFill_Darboux);
  }

export declare type GeomFill_ApproxStyle = {
  GeomFill_Section: {};
  GeomFill_Location: {};
}

export declare type GeomFill_PipeError = {
  GeomFill_PipeOk: {};
  GeomFill_PipeNotOk: {};
  GeomFill_PlaneNotIntersectGuide: {};
  GeomFill_ImpossibleContact: {};
}

export declare class IntPatch_ImpPrmIntersection {
  SetStartPoint(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Perform(Surf1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, Surf2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, Pas: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  NbPnts(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntPatch_Point;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Handle_IntPatch_Line;
  delete(): void;
}

  export declare class IntPatch_ImpPrmIntersection_1 extends IntPatch_ImpPrmIntersection {
    constructor();
  }

  export declare class IntPatch_ImpPrmIntersection_2 extends IntPatch_ImpPrmIntersection {
    constructor(Surf1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, Surf2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose, Pas: Quantity_AbsorbedDose);
  }

export declare class IntPatch_TheSearchInside {
  Perform_1(F: IntPatch_TheSurfFunction, Surf: Handle_Adaptor3d_HSurface, T: Handle_Adaptor3d_TopolTool, Epsilon: Quantity_AbsorbedDose): void;
  Perform_2(F: IntPatch_TheSurfFunction, Surf: Handle_Adaptor3d_HSurface, UStart: Quantity_AbsorbedDose, VStart: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): IntSurf_InteriorPoint;
  delete(): void;
}

  export declare class IntPatch_TheSearchInside_1 extends IntPatch_TheSearchInside {
    constructor();
  }

  export declare class IntPatch_TheSearchInside_2 extends IntPatch_TheSearchInside {
    constructor(F: IntPatch_TheSurfFunction, Surf: Handle_Adaptor3d_HSurface, T: Handle_Adaptor3d_TopolTool, Epsilon: Quantity_AbsorbedDose);
  }

export declare class IntPatch_InterferencePolyhedron extends Intf_Interference {
  Perform_1(Obje1: IntPatch_Polyhedron, Obje2: IntPatch_Polyhedron): void;
  Perform_2(Obje: IntPatch_Polyhedron): void;
  delete(): void;
}

  export declare class IntPatch_InterferencePolyhedron_1 extends IntPatch_InterferencePolyhedron {
    constructor();
  }

  export declare class IntPatch_InterferencePolyhedron_2 extends IntPatch_InterferencePolyhedron {
    constructor(Obje1: IntPatch_Polyhedron, Obje2: IntPatch_Polyhedron);
  }

  export declare class IntPatch_InterferencePolyhedron_3 extends IntPatch_InterferencePolyhedron {
    constructor(Obje: IntPatch_Polyhedron);
  }

export declare class IntPatch_LineConstructor {
  constructor(mode: Graphic3d_ZLayerId)
  Perform(SL: IntPatch_SequenceOfLine, L: Handle_IntPatch_Line, S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, Tol: Quantity_AbsorbedDose): void;
  NbLines(): Graphic3d_ZLayerId;
  Line(index: Graphic3d_ZLayerId): Handle_IntPatch_Line;
  delete(): void;
}

export declare class IntPatch_ALine extends IntPatch_Line {
  AddVertex(Pnt: IntPatch_Point): void;
  Replace(Index: Graphic3d_ZLayerId, Pnt: IntPatch_Point): void;
  SetFirstPoint(IndFirst: Graphic3d_ZLayerId): void;
  SetLastPoint(IndLast: Graphic3d_ZLayerId): void;
  FirstParameter(IsIncluded: Standard_Boolean): Quantity_AbsorbedDose;
  LastParameter(IsIncluded: Standard_Boolean): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, Du: gp_Vec): Standard_Boolean;
  FindParameter(P: gp_Pnt, theParams: TColStd_ListOfReal): void;
  HasFirstPoint(): Standard_Boolean;
  HasLastPoint(): Standard_Boolean;
  FirstPoint(): IntPatch_Point;
  LastPoint(): IntPatch_Point;
  NbVertex(): Graphic3d_ZLayerId;
  Vertex(Index: Graphic3d_ZLayerId): IntPatch_Point;
  ChangeVertex(theIndex: Graphic3d_ZLayerId): IntPatch_Point;
  ComputeVertexParameters(Tol: Quantity_AbsorbedDose): void;
  Curve(): IntAna_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IntPatch_ALine_1 extends IntPatch_ALine {
    constructor(C: IntAna_Curve, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_ALine_2 extends IntPatch_ALine {
    constructor(C: IntAna_Curve, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_ALine_3 extends IntPatch_ALine {
    constructor(C: IntAna_Curve, Tang: Standard_Boolean);
  }

export declare class Handle_IntPatch_ALine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_ALine): void;
  get(): IntPatch_ALine;
  delete(): void;
}

  export declare class Handle_IntPatch_ALine_1 extends Handle_IntPatch_ALine {
    constructor();
  }

  export declare class Handle_IntPatch_ALine_2 extends Handle_IntPatch_ALine {
    constructor(thePtr: IntPatch_ALine);
  }

  export declare class Handle_IntPatch_ALine_3 extends Handle_IntPatch_ALine {
    constructor(theHandle: Handle_IntPatch_ALine);
  }

  export declare class Handle_IntPatch_ALine_4 extends Handle_IntPatch_ALine {
    constructor(theHandle: Handle_IntPatch_ALine);
  }

export declare class IntPatch_SequenceOfSegmentOfTheSOnBounds extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntPatch_SequenceOfSegmentOfTheSOnBounds): IntPatch_SequenceOfSegmentOfTheSOnBounds;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntPatch_TheSegmentOfTheSOnBounds): void;
  Append_2(theSeq: IntPatch_SequenceOfSegmentOfTheSOnBounds): void;
  Prepend_1(theItem: IntPatch_TheSegmentOfTheSOnBounds): void;
  Prepend_2(theSeq: IntPatch_SequenceOfSegmentOfTheSOnBounds): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntPatch_TheSegmentOfTheSOnBounds): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfSegmentOfTheSOnBounds): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfSegmentOfTheSOnBounds): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntPatch_TheSegmentOfTheSOnBounds): void;
  Split(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfSegmentOfTheSOnBounds): void;
  First(): IntPatch_TheSegmentOfTheSOnBounds;
  ChangeFirst(): IntPatch_TheSegmentOfTheSOnBounds;
  Last(): IntPatch_TheSegmentOfTheSOnBounds;
  ChangeLast(): IntPatch_TheSegmentOfTheSOnBounds;
  Value(theIndex: Standard_Integer): IntPatch_TheSegmentOfTheSOnBounds;
  ChangeValue(theIndex: Standard_Integer): IntPatch_TheSegmentOfTheSOnBounds;
  SetValue(theIndex: Standard_Integer, theItem: IntPatch_TheSegmentOfTheSOnBounds): void;
  delete(): void;
}

  export declare class IntPatch_SequenceOfSegmentOfTheSOnBounds_1 extends IntPatch_SequenceOfSegmentOfTheSOnBounds {
    constructor();
  }

  export declare class IntPatch_SequenceOfSegmentOfTheSOnBounds_2 extends IntPatch_SequenceOfSegmentOfTheSOnBounds {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntPatch_SequenceOfSegmentOfTheSOnBounds_3 extends IntPatch_SequenceOfSegmentOfTheSOnBounds {
    constructor(theOther: IntPatch_SequenceOfSegmentOfTheSOnBounds);
  }

export declare class IntPatch_HInterTool {
  constructor()
  static SingularOnUMin(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static SingularOnUMax(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static SingularOnVMin(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static SingularOnVMax(S: Handle_Adaptor3d_HSurface): Standard_Boolean;
  static NbSamplesU(S: Handle_Adaptor3d_HSurface, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static NbSamplesV(S: Handle_Adaptor3d_HSurface, v1: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  NbSamplePoints(S: Handle_Adaptor3d_HSurface): Graphic3d_ZLayerId;
  SamplePoint(S: Handle_Adaptor3d_HSurface, Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static HasBeenSeen(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static NbSamplesOnArc(A: Handle_Adaptor2d_HCurve2d): Graphic3d_ZLayerId;
  static Bounds(C: Handle_Adaptor2d_HCurve2d, Ufirst: Quantity_AbsorbedDose, Ulast: Quantity_AbsorbedDose): void;
  static Project(C: Handle_Adaptor2d_HCurve2d, P: gp_Pnt2d, Paramproj: Quantity_AbsorbedDose, Ptproj: gp_Pnt2d): Standard_Boolean;
  static Tolerance(V: Handle_Adaptor3d_HVertex, C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Parameter(V: Handle_Adaptor3d_HVertex, C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static NbPoints(C: Handle_Adaptor2d_HCurve2d): Graphic3d_ZLayerId;
  static Value(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, Pt: gp_Pnt, Tol: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose): void;
  static IsVertex(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId): Standard_Boolean;
  static Vertex(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, V: Handle_Adaptor3d_HVertex): void;
  static NbSegments(C: Handle_Adaptor2d_HCurve2d): Graphic3d_ZLayerId;
  static HasFirstPoint(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, IndFirst: Graphic3d_ZLayerId): Standard_Boolean;
  static HasLastPoint(C: Handle_Adaptor2d_HCurve2d, Index: Graphic3d_ZLayerId, IndLast: Graphic3d_ZLayerId): Standard_Boolean;
  static IsAllSolution(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  delete(): void;
}

export declare class IntPatch_ImpImpIntersection {
  Perform(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, theIsReqToKeepRLine: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  GetStatus(): any;
  IsEmpty(): Standard_Boolean;
  TangentFaces(): Standard_Boolean;
  OppositeFaces(): Standard_Boolean;
  NbPnts(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntPatch_Point;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Handle_IntPatch_Line;
  delete(): void;
}

  export declare class IntPatch_ImpImpIntersection_1 extends IntPatch_ImpImpIntersection {
    constructor();
  }

  export declare class IntPatch_ImpImpIntersection_2 extends IntPatch_ImpImpIntersection {
    constructor(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, theIsReqToKeepRLine: Standard_Boolean);
  }

export declare class IntPatch_PolyhedronTool {
  constructor();
  static Bounding(thePolyh: IntPatch_Polyhedron): Bnd_Box;
  static ComponentsBounding(thePolyh: IntPatch_Polyhedron): Handle_Bnd_HArray1OfBox;
  static DeflectionOverEstimation(thePolyh: IntPatch_Polyhedron): Quantity_AbsorbedDose;
  static NbTriangles(thePolyh: IntPatch_Polyhedron): Graphic3d_ZLayerId;
  static Triangle(thePolyh: IntPatch_Polyhedron, Index: Graphic3d_ZLayerId, P1: Graphic3d_ZLayerId, P2: Graphic3d_ZLayerId, P3: Graphic3d_ZLayerId): void;
  static Point(thePolyh: IntPatch_Polyhedron, Index: Graphic3d_ZLayerId): gp_Pnt;
  static TriConnex(thePolyh: IntPatch_Polyhedron, Triang: Graphic3d_ZLayerId, Pivot: Graphic3d_ZLayerId, Pedge: Graphic3d_ZLayerId, TriCon: Graphic3d_ZLayerId, OtherP: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IntPatch_PolyArc extends IntPatch_Polygo {
  constructor(A: Handle_Adaptor2d_HCurve2d, NbSample: Graphic3d_ZLayerId, Pfirst: Quantity_AbsorbedDose, Plast: Quantity_AbsorbedDose, BoxOtherPolygon: Bnd_Box2d)
  Closed(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  Parameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetOffset(OffsetX: Quantity_AbsorbedDose, OffsetY: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class IntPatch_ThePathPointOfTheSOnBounds {
  SetValue_1(P: gp_Pnt, Tol: Quantity_AbsorbedDose, V: Handle_Adaptor3d_HVertex, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose): void;
  SetValue_2(P: gp_Pnt, Tol: Quantity_AbsorbedDose, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  Tolerance(): Quantity_AbsorbedDose;
  IsNew(): Standard_Boolean;
  Vertex(): Handle_Adaptor3d_HVertex;
  Arc(): Handle_Adaptor2d_HCurve2d;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class IntPatch_ThePathPointOfTheSOnBounds_1 extends IntPatch_ThePathPointOfTheSOnBounds {
    constructor();
  }

  export declare class IntPatch_ThePathPointOfTheSOnBounds_2 extends IntPatch_ThePathPointOfTheSOnBounds {
    constructor(P: gp_Pnt, Tol: Quantity_AbsorbedDose, V: Handle_Adaptor3d_HVertex, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose);
  }

  export declare class IntPatch_ThePathPointOfTheSOnBounds_3 extends IntPatch_ThePathPointOfTheSOnBounds {
    constructor(P: gp_Pnt, Tol: Quantity_AbsorbedDose, A: Handle_Adaptor2d_HCurve2d, Parameter: Quantity_AbsorbedDose);
  }

export declare class IntPatch_Point {
  constructor()
  SetValue_1(Pt: gp_Pnt, Tol: Quantity_AbsorbedDose, Tangent: Standard_Boolean): void;
  SetValue_2(Pt: gp_Pnt): void;
  SetValue_3(thePOn2S: IntSurf_PntOn2S): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  SetParameters(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  SetParameter(Para: Quantity_AbsorbedDose): void;
  SetVertex(OnFirst: Standard_Boolean, V: Handle_Adaptor3d_HVertex): void;
  SetArc(OnFirst: Standard_Boolean, A: Handle_Adaptor2d_HCurve2d, Param: Quantity_AbsorbedDose, TLine: IntSurf_Transition, TArc: IntSurf_Transition): void;
  SetMultiple(IsMult: Standard_Boolean): void;
  Value(): gp_Pnt;
  ParameterOnLine(): Quantity_AbsorbedDose;
  Tolerance(): Quantity_AbsorbedDose;
  IsTangencyPoint(): Standard_Boolean;
  ParametersOnS1(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose): void;
  ParametersOnS2(U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsMultiple(): Standard_Boolean;
  IsOnDomS1(): Standard_Boolean;
  IsVertexOnS1(): Standard_Boolean;
  VertexOnS1(): Handle_Adaptor3d_HVertex;
  ArcOnS1(): Handle_Adaptor2d_HCurve2d;
  TransitionLineArc1(): IntSurf_Transition;
  TransitionOnS1(): IntSurf_Transition;
  ParameterOnArc1(): Quantity_AbsorbedDose;
  IsOnDomS2(): Standard_Boolean;
  IsVertexOnS2(): Standard_Boolean;
  VertexOnS2(): Handle_Adaptor3d_HVertex;
  ArcOnS2(): Handle_Adaptor2d_HCurve2d;
  TransitionLineArc2(): IntSurf_Transition;
  TransitionOnS2(): IntSurf_Transition;
  ParameterOnArc2(): Quantity_AbsorbedDose;
  PntOn2S(): IntSurf_PntOn2S;
  Parameters(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  ReverseTransition(): void;
  Dump(): void;
  delete(): void;
}

export declare class Handle_IntPatch_GLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_GLine): void;
  get(): IntPatch_GLine;
  delete(): void;
}

  export declare class Handle_IntPatch_GLine_1 extends Handle_IntPatch_GLine {
    constructor();
  }

  export declare class Handle_IntPatch_GLine_2 extends Handle_IntPatch_GLine {
    constructor(thePtr: IntPatch_GLine);
  }

  export declare class Handle_IntPatch_GLine_3 extends Handle_IntPatch_GLine {
    constructor(theHandle: Handle_IntPatch_GLine);
  }

  export declare class Handle_IntPatch_GLine_4 extends Handle_IntPatch_GLine {
    constructor(theHandle: Handle_IntPatch_GLine);
  }

export declare class IntPatch_GLine extends IntPatch_Line {
  AddVertex(Pnt: IntPatch_Point): void;
  Replace(Index: Graphic3d_ZLayerId, Pnt: IntPatch_Point): void;
  SetFirstPoint(IndFirst: Graphic3d_ZLayerId): void;
  SetLastPoint(IndLast: Graphic3d_ZLayerId): void;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Parabola(): gp_Parab;
  Hyperbola(): gp_Hypr;
  HasFirstPoint(): Standard_Boolean;
  HasLastPoint(): Standard_Boolean;
  FirstPoint(): IntPatch_Point;
  LastPoint(): IntPatch_Point;
  NbVertex(): Graphic3d_ZLayerId;
  Vertex(Index: Graphic3d_ZLayerId): IntPatch_Point;
  ComputeVertexParameters(Tol: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IntPatch_GLine_1 extends IntPatch_GLine {
    constructor(L: gp_Lin, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_GLine_2 extends IntPatch_GLine {
    constructor(L: gp_Lin, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_GLine_3 extends IntPatch_GLine {
    constructor(L: gp_Lin, Tang: Standard_Boolean);
  }

  export declare class IntPatch_GLine_4 extends IntPatch_GLine {
    constructor(C: gp_Circ, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_GLine_5 extends IntPatch_GLine {
    constructor(C: gp_Circ, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_GLine_6 extends IntPatch_GLine {
    constructor(C: gp_Circ, Tang: Standard_Boolean);
  }

  export declare class IntPatch_GLine_7 extends IntPatch_GLine {
    constructor(E: gp_Elips, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_GLine_8 extends IntPatch_GLine {
    constructor(E: gp_Elips, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_GLine_9 extends IntPatch_GLine {
    constructor(E: gp_Elips, Tang: Standard_Boolean);
  }

  export declare class IntPatch_GLine_10 extends IntPatch_GLine {
    constructor(P: gp_Parab, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_GLine_11 extends IntPatch_GLine {
    constructor(P: gp_Parab, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_GLine_12 extends IntPatch_GLine {
    constructor(P: gp_Parab, Tang: Standard_Boolean);
  }

  export declare class IntPatch_GLine_13 extends IntPatch_GLine {
    constructor(H: gp_Hypr, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_GLine_14 extends IntPatch_GLine {
    constructor(H: gp_Hypr, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_GLine_15 extends IntPatch_GLine {
    constructor(H: gp_Hypr, Tang: Standard_Boolean);
  }

export declare class IntPatch_PrmPrmIntersection {
  constructor()
  Perform_1(Caro1: Handle_Adaptor3d_HSurface, Polyhedron1: IntPatch_Polyhedron, Domain1: Handle_Adaptor3d_TopolTool, Caro2: Handle_Adaptor3d_HSurface, Polyhedron2: IntPatch_Polyhedron, Domain2: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose): void;
  Perform_2(Caro1: Handle_Adaptor3d_HSurface, Polyhedron1: IntPatch_Polyhedron, Domain1: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose): void;
  Perform_3(Caro1: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, Caro2: Handle_Adaptor3d_HSurface, Domain2: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose, ClearFlag: Standard_Boolean): void;
  Perform_4(Caro1: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, Caro2: Handle_Adaptor3d_HSurface, Domain2: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose, ListOfPnts: IntSurf_ListOfPntOn2S): void;
  Perform_5(Caro1: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, Caro2: Handle_Adaptor3d_HSurface, Domain2: Handle_Adaptor3d_TopolTool, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose): void;
  Perform_6(Caro1: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose): void;
  Perform_7(Caro1: Handle_Adaptor3d_HSurface, Domain1: Handle_Adaptor3d_TopolTool, Caro2: Handle_Adaptor3d_HSurface, Polyhedron2: IntPatch_Polyhedron, Domain2: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose): void;
  Perform_8(Caro1: Handle_Adaptor3d_HSurface, Polyhedron1: IntPatch_Polyhedron, Domain1: Handle_Adaptor3d_TopolTool, Caro2: Handle_Adaptor3d_HSurface, Domain2: Handle_Adaptor3d_TopolTool, TolTangency: Quantity_AbsorbedDose, Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Increment: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Handle_IntPatch_Line;
  NewLine(Caro1: Handle_Adaptor3d_HSurface, Caro2: Handle_Adaptor3d_HSurface, IndexLine: Graphic3d_ZLayerId, LowPoint: Graphic3d_ZLayerId, HighPoint: Graphic3d_ZLayerId, NbPoints: Graphic3d_ZLayerId): Handle_IntPatch_Line;
  GrilleInteger(ix: Graphic3d_ZLayerId, iy: Graphic3d_ZLayerId, iz: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IntegerGrille(t: Graphic3d_ZLayerId, ix: Graphic3d_ZLayerId, iy: Graphic3d_ZLayerId, iz: Graphic3d_ZLayerId): void;
  DansGrille(t: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbPointsGrille(): Graphic3d_ZLayerId;
  RemplitLin(x1: Graphic3d_ZLayerId, y1: Graphic3d_ZLayerId, z1: Graphic3d_ZLayerId, x2: Graphic3d_ZLayerId, y2: Graphic3d_ZLayerId, z2: Graphic3d_ZLayerId, Map: IntPatch_PrmPrmIntersection_T3Bits): void;
  RemplitTri(x1: Graphic3d_ZLayerId, y1: Graphic3d_ZLayerId, z1: Graphic3d_ZLayerId, x2: Graphic3d_ZLayerId, y2: Graphic3d_ZLayerId, z2: Graphic3d_ZLayerId, x3: Graphic3d_ZLayerId, y3: Graphic3d_ZLayerId, z3: Graphic3d_ZLayerId, Map: IntPatch_PrmPrmIntersection_T3Bits): void;
  Remplit(a: Graphic3d_ZLayerId, b: Graphic3d_ZLayerId, c: Graphic3d_ZLayerId, Map: IntPatch_PrmPrmIntersection_T3Bits): void;
  CodeReject(x1: Quantity_AbsorbedDose, y1: Quantity_AbsorbedDose, z1: Quantity_AbsorbedDose, x2: Quantity_AbsorbedDose, y2: Quantity_AbsorbedDose, z2: Quantity_AbsorbedDose, x3: Quantity_AbsorbedDose, y3: Quantity_AbsorbedDose, z3: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  PointDepart(LineOn2S: Handle_IntSurf_LineOn2S, S1: Handle_Adaptor3d_HSurface, SU1: Graphic3d_ZLayerId, SV1: Graphic3d_ZLayerId, S2: Handle_Adaptor3d_HSurface, SU2: Graphic3d_ZLayerId, SV2: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IntPatch_RstInt {
  constructor();
  static PutVertexOnLine(L: Handle_IntPatch_Line, Surf: Handle_Adaptor3d_HSurface, Domain: Handle_Adaptor3d_TopolTool, OtherSurf: Handle_Adaptor3d_HSurface, OnFirst: Standard_Boolean, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare type IntPatch_SpecPntType = {
  IntPatch_SPntNone: {};
  IntPatch_SPntSeamU: {};
  IntPatch_SPntSeamV: {};
  IntPatch_SPntSeamUV: {};
  IntPatch_SPntPoleSeamU: {};
  IntPatch_SPntPole: {};
}

export declare class IntPatch_TheIWalking {
  constructor(Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Step: Quantity_AbsorbedDose, theToFillHoles: Standard_Boolean)
  SetTolerance(Epsilon: Quantity_AbsorbedDose, Deflection: Quantity_AbsorbedDose, Step: Quantity_AbsorbedDose): void;
  Perform_1(Pnts1: IntSurf_SequenceOfPathPoint, Pnts2: IntSurf_SequenceOfInteriorPoint, Func: IntPatch_TheSurfFunction, S: Handle_Adaptor3d_HSurface, Reversed: Standard_Boolean): void;
  Perform_2(Pnts1: IntSurf_SequenceOfPathPoint, Func: IntPatch_TheSurfFunction, S: Handle_Adaptor3d_HSurface, Reversed: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  NbLines(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): Handle_IntPatch_TheIWLineOfTheIWalking;
  NbSinglePnts(): Graphic3d_ZLayerId;
  SinglePnt(Index: Graphic3d_ZLayerId): IntSurf_PathPoint;
  delete(): void;
}

export declare class IntPatch_SpecialPoints {
  constructor();
  static AddCrossUVIsoPoint(theQSurf: Handle_Adaptor3d_HSurface, thePSurf: Handle_Adaptor3d_HSurface, theRefPt: IntSurf_PntOn2S, theTol3d: Quantity_AbsorbedDose, theAddedPoint: IntSurf_PntOn2S, theIsReversed: Standard_Boolean): Standard_Boolean;
  static AddPointOnUorVIso(theQSurf: Handle_Adaptor3d_HSurface, thePSurf: Handle_Adaptor3d_HSurface, theRefPt: IntSurf_PntOn2S, theIsU: Standard_Boolean, theIsoParameter: Quantity_AbsorbedDose, theToler: math_Vector, theInitPoint: math_Vector, theInfBound: math_Vector, theSupBound: math_Vector, theAddedPoint: IntSurf_PntOn2S, theIsReversed: Standard_Boolean): Standard_Boolean;
  static AddSingularPole(theQSurf: Handle_Adaptor3d_HSurface, thePSurf: Handle_Adaptor3d_HSurface, thePtIso: IntSurf_PntOn2S, theVertex: IntPatch_Point, theAddedPoint: IntSurf_PntOn2S, theIsReversed: Standard_Boolean, theIsReqRefCheck: Standard_Boolean): Standard_Boolean;
  static ContinueAfterSpecialPoint(theQSurf: Handle_Adaptor3d_HSurface, thePSurf: Handle_Adaptor3d_HSurface, theRefPt: IntSurf_PntOn2S, theSPType: IntPatch_SpecPntType, theTol2D: Quantity_AbsorbedDose, theNewPoint: IntSurf_PntOn2S, theIsReversed: Standard_Boolean): Standard_Boolean;
  static AdjustPointAndVertex(theRefPoint: IntSurf_PntOn2S, theArrPeriods: Standard_Real [4], theNewPoint: IntSurf_PntOn2S, theVertex: IntPatch_Point): void;
  delete(): void;
}

export declare class IntPatch_TheSOnBounds {
  constructor()
  Perform(F: IntPatch_ArcFunction, Domain: Handle_Adaptor3d_TopolTool, TolBoundary: Quantity_AbsorbedDose, TolTangency: Quantity_AbsorbedDose, RecheckOnRegularity: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  AllArcSolution(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntPatch_ThePathPointOfTheSOnBounds;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(Index: Graphic3d_ZLayerId): IntPatch_TheSegmentOfTheSOnBounds;
  delete(): void;
}

export declare class IntPatch_TheIWLineOfTheIWalking extends Standard_Transient {
  constructor(theAllocator: IntSurf_Allocator)
  Reverse(): void;
  Cut(Index: Graphic3d_ZLayerId): void;
  AddPoint(P: IntSurf_PntOn2S): void;
  AddStatusFirst_1(Closed: Standard_Boolean, HasFirst: Standard_Boolean): void;
  AddStatusFirst_2(Closed: Standard_Boolean, HasLast: Standard_Boolean, Index: Graphic3d_ZLayerId, P: IntSurf_PathPoint): void;
  AddStatusFirstLast(Closed: Standard_Boolean, HasFirst: Standard_Boolean, HasLast: Standard_Boolean): void;
  AddStatusLast_1(HasLast: Standard_Boolean): void;
  AddStatusLast_2(HasLast: Standard_Boolean, Index: Graphic3d_ZLayerId, P: IntSurf_PathPoint): void;
  AddIndexPassing(Index: Graphic3d_ZLayerId): void;
  SetTangentVector(V: gp_Vec, Index: Graphic3d_ZLayerId): void;
  SetTangencyAtBegining(IsTangent: Standard_Boolean): void;
  SetTangencyAtEnd(IsTangent: Standard_Boolean): void;
  NbPoints(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  Line(): Handle_IntSurf_LineOn2S;
  IsClosed(): Standard_Boolean;
  HasFirstPoint(): Standard_Boolean;
  HasLastPoint(): Standard_Boolean;
  FirstPoint(): IntSurf_PathPoint;
  FirstPointIndex(): Graphic3d_ZLayerId;
  LastPoint(): IntSurf_PathPoint;
  LastPointIndex(): Graphic3d_ZLayerId;
  NbPassingPoint(): Graphic3d_ZLayerId;
  PassingPoint(Index: Graphic3d_ZLayerId, IndexLine: Graphic3d_ZLayerId, IndexPnts: Graphic3d_ZLayerId): void;
  TangentVector(Index: Graphic3d_ZLayerId): gp_Vec;
  IsTangentAtBegining(): Standard_Boolean;
  IsTangentAtEnd(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IntPatch_TheIWLineOfTheIWalking {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_TheIWLineOfTheIWalking): void;
  get(): IntPatch_TheIWLineOfTheIWalking;
  delete(): void;
}

  export declare class Handle_IntPatch_TheIWLineOfTheIWalking_1 extends Handle_IntPatch_TheIWLineOfTheIWalking {
    constructor();
  }

  export declare class Handle_IntPatch_TheIWLineOfTheIWalking_2 extends Handle_IntPatch_TheIWLineOfTheIWalking {
    constructor(thePtr: IntPatch_TheIWLineOfTheIWalking);
  }

  export declare class Handle_IntPatch_TheIWLineOfTheIWalking_3 extends Handle_IntPatch_TheIWLineOfTheIWalking {
    constructor(theHandle: Handle_IntPatch_TheIWLineOfTheIWalking);
  }

  export declare class Handle_IntPatch_TheIWLineOfTheIWalking_4 extends Handle_IntPatch_TheIWLineOfTheIWalking {
    constructor(theHandle: Handle_IntPatch_TheIWLineOfTheIWalking);
  }

export declare class IntPatch_PolyLine extends IntPatch_Polygo {
  SetWLine(OnFirst: Standard_Boolean, Line: Handle_IntPatch_WLine): void;
  SetRLine(OnFirst: Standard_Boolean, Line: Handle_IntPatch_RLine): void;
  ResetError(): void;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  delete(): void;
}

  export declare class IntPatch_PolyLine_1 extends IntPatch_PolyLine {
    constructor();
  }

  export declare class IntPatch_PolyLine_2 extends IntPatch_PolyLine {
    constructor(InitDefle: Quantity_AbsorbedDose);
  }

export declare class IntPatch_CSFunction extends math_FunctionSetWithDerivatives {
  constructor(S1: Handle_Adaptor3d_HSurface, C: Handle_Adaptor2d_HCurve2d, S2: Handle_Adaptor3d_HSurface)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Point(): gp_Pnt;
  Root(): Quantity_AbsorbedDose;
  AuxillarSurface(): Handle_Adaptor3d_HSurface;
  AuxillarCurve(): Handle_Adaptor2d_HCurve2d;
  delete(): void;
}

export declare class IntPatch_SequenceOfPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntPatch_SequenceOfPoint): IntPatch_SequenceOfPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntPatch_Point): void;
  Append_2(theSeq: IntPatch_SequenceOfPoint): void;
  Prepend_1(theItem: IntPatch_Point): void;
  Prepend_2(theSeq: IntPatch_SequenceOfPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntPatch_Point): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntPatch_Point): void;
  Split(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfPoint): void;
  First(): IntPatch_Point;
  ChangeFirst(): IntPatch_Point;
  Last(): IntPatch_Point;
  ChangeLast(): IntPatch_Point;
  Value(theIndex: Standard_Integer): IntPatch_Point;
  ChangeValue(theIndex: Standard_Integer): IntPatch_Point;
  SetValue(theIndex: Standard_Integer, theItem: IntPatch_Point): void;
  delete(): void;
}

  export declare class IntPatch_SequenceOfPoint_1 extends IntPatch_SequenceOfPoint {
    constructor();
  }

  export declare class IntPatch_SequenceOfPoint_2 extends IntPatch_SequenceOfPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntPatch_SequenceOfPoint_3 extends IntPatch_SequenceOfPoint {
    constructor(theOther: IntPatch_SequenceOfPoint);
  }

export declare class Handle_IntPatch_RLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_RLine): void;
  get(): IntPatch_RLine;
  delete(): void;
}

  export declare class Handle_IntPatch_RLine_1 extends Handle_IntPatch_RLine {
    constructor();
  }

  export declare class Handle_IntPatch_RLine_2 extends Handle_IntPatch_RLine {
    constructor(thePtr: IntPatch_RLine);
  }

  export declare class Handle_IntPatch_RLine_3 extends Handle_IntPatch_RLine {
    constructor(theHandle: Handle_IntPatch_RLine);
  }

  export declare class Handle_IntPatch_RLine_4 extends Handle_IntPatch_RLine {
    constructor(theHandle: Handle_IntPatch_RLine);
  }

export declare class IntPatch_CurvIntSurf {
  Perform(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, Rsnld: math_FunctionSetRoot, u0: Quantity_AbsorbedDose, v0: Quantity_AbsorbedDose, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, w0: Quantity_AbsorbedDose, w1: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Point(): gp_Pnt;
  ParameterOnCurve(): Quantity_AbsorbedDose;
  ParameterOnSurface(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Function(): IntPatch_CSFunction;
  delete(): void;
}

  export declare class IntPatch_CurvIntSurf_1 extends IntPatch_CurvIntSurf {
    constructor(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, W: Quantity_AbsorbedDose, F: IntPatch_CSFunction, TolTangency: Quantity_AbsorbedDose, MarginCoef: Quantity_AbsorbedDose);
  }

  export declare class IntPatch_CurvIntSurf_2 extends IntPatch_CurvIntSurf {
    constructor(F: IntPatch_CSFunction, TolTangency: Quantity_AbsorbedDose);
  }

export declare class IntPatch_TheSurfFunction extends math_FunctionSetWithDerivatives {
  Set_1(PS: Handle_Adaptor3d_HSurface): void;
  SetImplicitSurface(IS: IntSurf_Quadric): void;
  Set_2(Tolerance: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Tolerance(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(): Standard_Boolean;
  Direction3d(): gp_Vec;
  Direction2d(): gp_Dir2d;
  PSurface(): Handle_Adaptor3d_HSurface;
  ISurface(): IntSurf_Quadric;
  delete(): void;
}

  export declare class IntPatch_TheSurfFunction_1 extends IntPatch_TheSurfFunction {
    constructor();
  }

  export declare class IntPatch_TheSurfFunction_2 extends IntPatch_TheSurfFunction {
    constructor(PS: Handle_Adaptor3d_HSurface, IS: IntSurf_Quadric);
  }

  export declare class IntPatch_TheSurfFunction_3 extends IntPatch_TheSurfFunction {
    constructor(IS: IntSurf_Quadric);
  }

export declare class IntPatch_ALineToWLine {
  constructor(theS1: Handle_Adaptor3d_HSurface, theS2: Handle_Adaptor3d_HSurface, theNbPoints: Graphic3d_ZLayerId)
  SetTolOpenDomain(aT: Quantity_AbsorbedDose): void;
  TolOpenDomain(): Quantity_AbsorbedDose;
  SetTolTransition(aT: Quantity_AbsorbedDose): void;
  TolTransition(): Quantity_AbsorbedDose;
  SetTol3D(aT: Quantity_AbsorbedDose): void;
  Tol3D(): Quantity_AbsorbedDose;
  MakeWLine_1(aline: Handle_IntPatch_ALine, theLines: IntPatch_SequenceOfLine): void;
  MakeWLine_2(aline: Handle_IntPatch_ALine, paraminf: Quantity_AbsorbedDose, paramsup: Quantity_AbsorbedDose, theLines: IntPatch_SequenceOfLine): void;
  delete(): void;
}

export declare class IntPatch_WLine extends IntPatch_PointLine {
  AddVertex(Pnt: IntPatch_Point, theIsPrepend: Standard_Boolean): void;
  SetPoint(Index: Graphic3d_ZLayerId, Pnt: IntPatch_Point): void;
  Replace(Index: Graphic3d_ZLayerId, Pnt: IntPatch_Point): void;
  SetFirstPoint(IndFirst: Graphic3d_ZLayerId): void;
  SetLastPoint(IndLast: Graphic3d_ZLayerId): void;
  NbPnts(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  HasFirstPoint(): Standard_Boolean;
  HasLastPoint(): Standard_Boolean;
  FirstPoint_1(): IntPatch_Point;
  LastPoint_1(): IntPatch_Point;
  FirstPoint_2(Indfirst: Graphic3d_ZLayerId): IntPatch_Point;
  LastPoint_2(Indlast: Graphic3d_ZLayerId): IntPatch_Point;
  NbVertex(): Graphic3d_ZLayerId;
  Vertex(Index: Graphic3d_ZLayerId): IntPatch_Point;
  ChangeVertex(Index: Graphic3d_ZLayerId): IntPatch_Point;
  ComputeVertexParameters(Tol: Quantity_AbsorbedDose): void;
  Curve(): Handle_IntSurf_LineOn2S;
  IsOutSurf1Box(theP: gp_Pnt2d): Standard_Boolean;
  IsOutSurf2Box(theP: gp_Pnt2d): Standard_Boolean;
  IsOutBox(theP: gp_Pnt): Standard_Boolean;
  SetPeriod(pu1: Quantity_AbsorbedDose, pv1: Quantity_AbsorbedDose, pu2: Quantity_AbsorbedDose, pv2: Quantity_AbsorbedDose): void;
  U1Period(): Quantity_AbsorbedDose;
  V1Period(): Quantity_AbsorbedDose;
  U2Period(): Quantity_AbsorbedDose;
  V2Period(): Quantity_AbsorbedDose;
  SetArcOnS1(A: Handle_Adaptor2d_HCurve2d): void;
  HasArcOnS1(): Standard_Boolean;
  GetArcOnS1(): Handle_Adaptor2d_HCurve2d;
  SetArcOnS2(A: Handle_Adaptor2d_HCurve2d): void;
  HasArcOnS2(): Standard_Boolean;
  GetArcOnS2(): Handle_Adaptor2d_HCurve2d;
  ClearVertexes(): void;
  RemoveVertex(theIndex: Graphic3d_ZLayerId): void;
  InsertVertexBefore(theIndex: Graphic3d_ZLayerId, thePnt: IntPatch_Point): void;
  Dump(theMode: Graphic3d_ZLayerId): void;
  EnablePurging(theIsEnabled: Standard_Boolean): void;
  IsPurgingAllowed(): Standard_Boolean;
  GetCreatingWay(): any;
  SetCreatingWayInfo(theAlgo: any): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IntPatch_WLine_1 extends IntPatch_WLine {
    constructor(Line: Handle_IntSurf_LineOn2S, Tang: Standard_Boolean, Trans1: IntSurf_TypeTrans, Trans2: IntSurf_TypeTrans);
  }

  export declare class IntPatch_WLine_2 extends IntPatch_WLine {
    constructor(Line: Handle_IntSurf_LineOn2S, Tang: Standard_Boolean, Situ1: IntSurf_Situation, Situ2: IntSurf_Situation);
  }

  export declare class IntPatch_WLine_3 extends IntPatch_WLine {
    constructor(Line: Handle_IntSurf_LineOn2S, Tang: Standard_Boolean);
  }

export declare class Handle_IntPatch_WLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_WLine): void;
  get(): IntPatch_WLine;
  delete(): void;
}

  export declare class Handle_IntPatch_WLine_1 extends Handle_IntPatch_WLine {
    constructor();
  }

  export declare class Handle_IntPatch_WLine_2 extends Handle_IntPatch_WLine {
    constructor(thePtr: IntPatch_WLine);
  }

  export declare class Handle_IntPatch_WLine_3 extends Handle_IntPatch_WLine {
    constructor(theHandle: Handle_IntPatch_WLine);
  }

  export declare class Handle_IntPatch_WLine_4 extends Handle_IntPatch_WLine {
    constructor(theHandle: Handle_IntPatch_WLine);
  }

export declare class IntPatch_Intersection {
  SetTolerances(TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, UVMaxStep: Quantity_AbsorbedDose, Fleche: Quantity_AbsorbedDose): void;
  Perform_1(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, isGeomInt: Standard_Boolean, theIsReqToKeepRLine: Standard_Boolean, theIsReqToPostWLProc: Standard_Boolean): void;
  Perform_2(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose, LOfPnts: IntSurf_ListOfPntOn2S, isGeomInt: Standard_Boolean, theIsReqToKeepRLine: Standard_Boolean, theIsReqToPostWLProc: Standard_Boolean): void;
  Perform_3(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose): void;
  Perform_4(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  TangentFaces(): Standard_Boolean;
  OppositeFaces(): Standard_Boolean;
  NbPnts(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntPatch_Point;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Handle_IntPatch_Line;
  SequenceOfLine(): IntPatch_SequenceOfLine;
  Dump(Mode: Graphic3d_ZLayerId, S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool): void;
  delete(): void;
}

  export declare class IntPatch_Intersection_1 extends IntPatch_Intersection {
    constructor();
  }

  export declare class IntPatch_Intersection_2 extends IntPatch_Intersection {
    constructor(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, S2: Handle_Adaptor3d_HSurface, D2: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose);
  }

  export declare class IntPatch_Intersection_3 extends IntPatch_Intersection {
    constructor(S1: Handle_Adaptor3d_HSurface, D1: Handle_Adaptor3d_TopolTool, TolArc: Quantity_AbsorbedDose, TolTang: Quantity_AbsorbedDose);
  }

export declare class IntPatch_PrmPrmIntersection_T3Bits {
  constructor(size: Graphic3d_ZLayerId)
  Destroy(): void;
  Add(t: Graphic3d_ZLayerId): void;
  Val(t: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Raz(t: Graphic3d_ZLayerId): void;
  ResetAnd(): void;
  And(Oth: IntPatch_PrmPrmIntersection_T3Bits, indiceprecedent: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IntPatch_TheSegmentOfTheSOnBounds {
  constructor()
  SetValue(A: Handle_Adaptor2d_HCurve2d): void;
  SetLimitPoint(V: IntPatch_ThePathPointOfTheSOnBounds, First: Standard_Boolean): void;
  Curve(): Handle_Adaptor2d_HCurve2d;
  HasFirstPoint(): Standard_Boolean;
  FirstPoint(): IntPatch_ThePathPointOfTheSOnBounds;
  HasLastPoint(): Standard_Boolean;
  LastPoint(): IntPatch_ThePathPointOfTheSOnBounds;
  delete(): void;
}

export declare class IntPatch_SequenceOfPathPointOfTheSOnBounds extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntPatch_SequenceOfPathPointOfTheSOnBounds): IntPatch_SequenceOfPathPointOfTheSOnBounds;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntPatch_ThePathPointOfTheSOnBounds): void;
  Append_2(theSeq: IntPatch_SequenceOfPathPointOfTheSOnBounds): void;
  Prepend_1(theItem: IntPatch_ThePathPointOfTheSOnBounds): void;
  Prepend_2(theSeq: IntPatch_SequenceOfPathPointOfTheSOnBounds): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntPatch_ThePathPointOfTheSOnBounds): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfPathPointOfTheSOnBounds): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfPathPointOfTheSOnBounds): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntPatch_ThePathPointOfTheSOnBounds): void;
  Split(theIndex: Standard_Integer, theSeq: IntPatch_SequenceOfPathPointOfTheSOnBounds): void;
  First(): IntPatch_ThePathPointOfTheSOnBounds;
  ChangeFirst(): IntPatch_ThePathPointOfTheSOnBounds;
  Last(): IntPatch_ThePathPointOfTheSOnBounds;
  ChangeLast(): IntPatch_ThePathPointOfTheSOnBounds;
  Value(theIndex: Standard_Integer): IntPatch_ThePathPointOfTheSOnBounds;
  ChangeValue(theIndex: Standard_Integer): IntPatch_ThePathPointOfTheSOnBounds;
  SetValue(theIndex: Standard_Integer, theItem: IntPatch_ThePathPointOfTheSOnBounds): void;
  delete(): void;
}

  export declare class IntPatch_SequenceOfPathPointOfTheSOnBounds_1 extends IntPatch_SequenceOfPathPointOfTheSOnBounds {
    constructor();
  }

  export declare class IntPatch_SequenceOfPathPointOfTheSOnBounds_2 extends IntPatch_SequenceOfPathPointOfTheSOnBounds {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntPatch_SequenceOfPathPointOfTheSOnBounds_3 extends IntPatch_SequenceOfPathPointOfTheSOnBounds {
    constructor(theOther: IntPatch_SequenceOfPathPointOfTheSOnBounds);
  }

export declare type IntPatch_IType = {
  IntPatch_Lin: {};
  IntPatch_Circle: {};
  IntPatch_Ellipse: {};
  IntPatch_Parabola: {};
  IntPatch_Hyperbola: {};
  IntPatch_Analytic: {};
  IntPatch_Walking: {};
  IntPatch_Restriction: {};
}

export declare class IntPatch_ArcFunction extends math_FunctionWithDerivative {
  constructor()
  SetQuadric(Q: IntSurf_Quadric): void;
  Set_1(A: Handle_Adaptor2d_HCurve2d): void;
  Set_2(S: Handle_Adaptor3d_HSurface): void;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  NbSamples(): Graphic3d_ZLayerId;
  GetStateNumber(): Graphic3d_ZLayerId;
  Valpoint(Index: Graphic3d_ZLayerId): gp_Pnt;
  Quadric(): IntSurf_Quadric;
  Arc(): Handle_Adaptor2d_HCurve2d;
  Surface(): Handle_Adaptor3d_HSurface;
  LastComputedPoint(): gp_Pnt;
  delete(): void;
}

export declare class IntPatch_Line extends Standard_Transient {
  SetValue(Uiso1: Standard_Boolean, Viso1: Standard_Boolean, Uiso2: Standard_Boolean, Viso2: Standard_Boolean): void;
  ArcType(): IntPatch_IType;
  IsTangent(): Standard_Boolean;
  TransitionOnS1(): IntSurf_TypeTrans;
  TransitionOnS2(): IntSurf_TypeTrans;
  SituationS1(): IntSurf_Situation;
  SituationS2(): IntSurf_Situation;
  IsUIsoOnS1(): Standard_Boolean;
  IsVIsoOnS1(): Standard_Boolean;
  IsUIsoOnS2(): Standard_Boolean;
  IsVIsoOnS2(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IntPatch_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_Line): void;
  get(): IntPatch_Line;
  delete(): void;
}

  export declare class Handle_IntPatch_Line_1 extends Handle_IntPatch_Line {
    constructor();
  }

  export declare class Handle_IntPatch_Line_2 extends Handle_IntPatch_Line {
    constructor(thePtr: IntPatch_Line);
  }

  export declare class Handle_IntPatch_Line_3 extends Handle_IntPatch_Line {
    constructor(theHandle: Handle_IntPatch_Line);
  }

  export declare class Handle_IntPatch_Line_4 extends Handle_IntPatch_Line {
    constructor(theHandle: Handle_IntPatch_Line);
  }

export declare class IntPatch_HCurve2dTool {
  constructor();
  static FirstParameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static LastParameter(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Continuity(C: Handle_Adaptor2d_HCurve2d): GeomAbs_Shape;
  static NbIntervals(C: Handle_Adaptor2d_HCurve2d, S: GeomAbs_Shape): Graphic3d_ZLayerId;
  static Intervals(C: Handle_Adaptor2d_HCurve2d, T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  static IsClosed(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static IsPeriodic(C: Handle_Adaptor2d_HCurve2d): Standard_Boolean;
  static Period(C: Handle_Adaptor2d_HCurve2d): Quantity_AbsorbedDose;
  static Value(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose): gp_Pnt2d;
  static D0(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D2(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static DN(C: Handle_Adaptor2d_HCurve2d, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static Resolution(C: Handle_Adaptor2d_HCurve2d, R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetType(C: Handle_Adaptor2d_HCurve2d): GeomAbs_CurveType;
  static Line(C: Handle_Adaptor2d_HCurve2d): gp_Lin2d;
  static Circle(C: Handle_Adaptor2d_HCurve2d): gp_Circ2d;
  static Ellipse(C: Handle_Adaptor2d_HCurve2d): gp_Elips2d;
  static Hyperbola(C: Handle_Adaptor2d_HCurve2d): gp_Hypr2d;
  static Parabola(C: Handle_Adaptor2d_HCurve2d): gp_Parab2d;
  static Bezier(C: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BezierCurve;
  static BSpline(C: Handle_Adaptor2d_HCurve2d): Handle_Geom2d_BSplineCurve;
  static NbSamples(C: Handle_Adaptor2d_HCurve2d, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IntPatch_WLineTool {
  constructor();
  static ComputePurgedWLine(theWLine: Handle_IntPatch_WLine, theS1: Handle_Adaptor3d_HSurface, theS2: Handle_Adaptor3d_HSurface, theDom1: Handle_Adaptor3d_TopolTool, theDom2: Handle_Adaptor3d_TopolTool): Handle_IntPatch_WLine;
  static JoinWLines(theSlin: IntPatch_SequenceOfLine, theSPnt: IntPatch_SequenceOfPoint, theS1: Handle_Adaptor3d_HSurface, theS2: Handle_Adaptor3d_HSurface, theTol3D: Quantity_AbsorbedDose): void;
  static ExtendTwoWLines(theSlin: IntPatch_SequenceOfLine, theS1: Handle_Adaptor3d_HSurface, theS2: Handle_Adaptor3d_HSurface, theToler3D: Quantity_AbsorbedDose, theArrPeriods: Quantity_AbsorbedDose, theBoxS1: Bnd_Box2d, theBoxS2: Bnd_Box2d, theListOfCriticalPoints: QANCollection_ListOfPnt): void;
  delete(): void;
}

export declare class IntPatch_Polygo extends Intf_Polygon2d {
  Error(): Quantity_AbsorbedDose;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  DeflectionOverEstimation(): Quantity_AbsorbedDose;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(theIndex: Graphic3d_ZLayerId, theBegin: gp_Pnt2d, theEnd: gp_Pnt2d): void;
  Dump(): void;
  delete(): void;
}

export declare class IntPatch_PointLine extends IntPatch_Line {
  AddVertex(Pnt: IntPatch_Point, theIsPrepend: Standard_Boolean): void;
  NbPnts(): Graphic3d_ZLayerId;
  NbVertex(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  Vertex(Index: Graphic3d_ZLayerId): IntPatch_Point;
  ChangeVertex(Index: Graphic3d_ZLayerId): IntPatch_Point;
  ClearVertexes(): void;
  RemoveVertex(theIndex: Graphic3d_ZLayerId): void;
  Curve(): Handle_IntSurf_LineOn2S;
  IsOutSurf1Box(P1: gp_Pnt2d): Standard_Boolean;
  IsOutSurf2Box(P2: gp_Pnt2d): Standard_Boolean;
  IsOutBox(P: gp_Pnt): Standard_Boolean;
  static CurvatureRadiusOfIntersLine(theS1: Handle_Adaptor3d_HSurface, theS2: Handle_Adaptor3d_HSurface, theUVPoint: IntSurf_PntOn2S): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IntPatch_PointLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntPatch_PointLine): void;
  get(): IntPatch_PointLine;
  delete(): void;
}

  export declare class Handle_IntPatch_PointLine_1 extends Handle_IntPatch_PointLine {
    constructor();
  }

  export declare class Handle_IntPatch_PointLine_2 extends Handle_IntPatch_PointLine {
    constructor(thePtr: IntPatch_PointLine);
  }

  export declare class Handle_IntPatch_PointLine_3 extends Handle_IntPatch_PointLine {
    constructor(theHandle: Handle_IntPatch_PointLine);
  }

  export declare class Handle_IntPatch_PointLine_4 extends Handle_IntPatch_PointLine {
    constructor(theHandle: Handle_IntPatch_PointLine);
  }

export declare class Handle_GccInt_BElips {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_BElips): void;
  get(): GccInt_BElips;
  delete(): void;
}

  export declare class Handle_GccInt_BElips_1 extends Handle_GccInt_BElips {
    constructor();
  }

  export declare class Handle_GccInt_BElips_2 extends Handle_GccInt_BElips {
    constructor(thePtr: GccInt_BElips);
  }

  export declare class Handle_GccInt_BElips_3 extends Handle_GccInt_BElips {
    constructor(theHandle: Handle_GccInt_BElips);
  }

  export declare class Handle_GccInt_BElips_4 extends Handle_GccInt_BElips {
    constructor(theHandle: Handle_GccInt_BElips);
  }

export declare class GccInt_BElips extends GccInt_Bisec {
  constructor(Ellipse: gp_Elips2d)
  Ellipse(): gp_Elips2d;
  ArcType(): GccInt_IType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GccInt_BPoint extends GccInt_Bisec {
  constructor(Point: gp_Pnt2d)
  Point(): gp_Pnt2d;
  ArcType(): GccInt_IType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GccInt_BPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_BPoint): void;
  get(): GccInt_BPoint;
  delete(): void;
}

  export declare class Handle_GccInt_BPoint_1 extends Handle_GccInt_BPoint {
    constructor();
  }

  export declare class Handle_GccInt_BPoint_2 extends Handle_GccInt_BPoint {
    constructor(thePtr: GccInt_BPoint);
  }

  export declare class Handle_GccInt_BPoint_3 extends Handle_GccInt_BPoint {
    constructor(theHandle: Handle_GccInt_BPoint);
  }

  export declare class Handle_GccInt_BPoint_4 extends Handle_GccInt_BPoint {
    constructor(theHandle: Handle_GccInt_BPoint);
  }

export declare class GccInt_BParab extends GccInt_Bisec {
  constructor(Parab: gp_Parab2d)
  Parabola(): gp_Parab2d;
  ArcType(): GccInt_IType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GccInt_BParab {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_BParab): void;
  get(): GccInt_BParab;
  delete(): void;
}

  export declare class Handle_GccInt_BParab_1 extends Handle_GccInt_BParab {
    constructor();
  }

  export declare class Handle_GccInt_BParab_2 extends Handle_GccInt_BParab {
    constructor(thePtr: GccInt_BParab);
  }

  export declare class Handle_GccInt_BParab_3 extends Handle_GccInt_BParab {
    constructor(theHandle: Handle_GccInt_BParab);
  }

  export declare class Handle_GccInt_BParab_4 extends Handle_GccInt_BParab {
    constructor(theHandle: Handle_GccInt_BParab);
  }

export declare class GccInt_Bisec extends Standard_Transient {
  ArcType(): GccInt_IType;
  Point(): gp_Pnt2d;
  Line(): gp_Lin2d;
  Circle(): gp_Circ2d;
  Hyperbola(): gp_Hypr2d;
  Parabola(): gp_Parab2d;
  Ellipse(): gp_Elips2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GccInt_Bisec {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_Bisec): void;
  get(): GccInt_Bisec;
  delete(): void;
}

  export declare class Handle_GccInt_Bisec_1 extends Handle_GccInt_Bisec {
    constructor();
  }

  export declare class Handle_GccInt_Bisec_2 extends Handle_GccInt_Bisec {
    constructor(thePtr: GccInt_Bisec);
  }

  export declare class Handle_GccInt_Bisec_3 extends Handle_GccInt_Bisec {
    constructor(theHandle: Handle_GccInt_Bisec);
  }

  export declare class Handle_GccInt_Bisec_4 extends Handle_GccInt_Bisec {
    constructor(theHandle: Handle_GccInt_Bisec);
  }

export declare class Handle_GccInt_BHyper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_BHyper): void;
  get(): GccInt_BHyper;
  delete(): void;
}

  export declare class Handle_GccInt_BHyper_1 extends Handle_GccInt_BHyper {
    constructor();
  }

  export declare class Handle_GccInt_BHyper_2 extends Handle_GccInt_BHyper {
    constructor(thePtr: GccInt_BHyper);
  }

  export declare class Handle_GccInt_BHyper_3 extends Handle_GccInt_BHyper {
    constructor(theHandle: Handle_GccInt_BHyper);
  }

  export declare class Handle_GccInt_BHyper_4 extends Handle_GccInt_BHyper {
    constructor(theHandle: Handle_GccInt_BHyper);
  }

export declare class GccInt_BHyper extends GccInt_Bisec {
  constructor(Hyper: gp_Hypr2d)
  Hyperbola(): gp_Hypr2d;
  ArcType(): GccInt_IType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GccInt_BLine extends GccInt_Bisec {
  constructor(Line: gp_Lin2d)
  Line(): gp_Lin2d;
  ArcType(): GccInt_IType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GccInt_BLine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_BLine): void;
  get(): GccInt_BLine;
  delete(): void;
}

  export declare class Handle_GccInt_BLine_1 extends Handle_GccInt_BLine {
    constructor();
  }

  export declare class Handle_GccInt_BLine_2 extends Handle_GccInt_BLine {
    constructor(thePtr: GccInt_BLine);
  }

  export declare class Handle_GccInt_BLine_3 extends Handle_GccInt_BLine {
    constructor(theHandle: Handle_GccInt_BLine);
  }

  export declare class Handle_GccInt_BLine_4 extends Handle_GccInt_BLine {
    constructor(theHandle: Handle_GccInt_BLine);
  }

export declare type GccInt_IType = {
  GccInt_Lin: {};
  GccInt_Cir: {};
  GccInt_Ell: {};
  GccInt_Par: {};
  GccInt_Hpr: {};
  GccInt_Pnt: {};
}

export declare class GccInt_BCirc extends GccInt_Bisec {
  constructor(Circ: gp_Circ2d)
  Circle(): gp_Circ2d;
  ArcType(): GccInt_IType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GccInt_BCirc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GccInt_BCirc): void;
  get(): GccInt_BCirc;
  delete(): void;
}

  export declare class Handle_GccInt_BCirc_1 extends Handle_GccInt_BCirc {
    constructor();
  }

  export declare class Handle_GccInt_BCirc_2 extends Handle_GccInt_BCirc {
    constructor(thePtr: GccInt_BCirc);
  }

  export declare class Handle_GccInt_BCirc_3 extends Handle_GccInt_BCirc {
    constructor(theHandle: Handle_GccInt_BCirc);
  }

  export declare class Handle_GccInt_BCirc_4 extends Handle_GccInt_BCirc {
    constructor(theHandle: Handle_GccInt_BCirc);
  }

export declare class Handle_StdFail_UndefinedValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdFail_UndefinedValue): void;
  get(): StdFail_UndefinedValue;
  delete(): void;
}

  export declare class Handle_StdFail_UndefinedValue_1 extends Handle_StdFail_UndefinedValue {
    constructor();
  }

  export declare class Handle_StdFail_UndefinedValue_2 extends Handle_StdFail_UndefinedValue {
    constructor(thePtr: StdFail_UndefinedValue);
  }

  export declare class Handle_StdFail_UndefinedValue_3 extends Handle_StdFail_UndefinedValue {
    constructor(theHandle: Handle_StdFail_UndefinedValue);
  }

  export declare class Handle_StdFail_UndefinedValue_4 extends Handle_StdFail_UndefinedValue {
    constructor(theHandle: Handle_StdFail_UndefinedValue);
  }

export declare class StdFail_UndefinedValue extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_StdFail_UndefinedValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class StdFail_UndefinedValue_1 extends StdFail_UndefinedValue {
    constructor();
  }

  export declare class StdFail_UndefinedValue_2 extends StdFail_UndefinedValue {
    constructor(theMessage: Standard_CString);
  }

export declare class StdFail_Undefined extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_StdFail_Undefined;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class StdFail_Undefined_1 extends StdFail_Undefined {
    constructor();
  }

  export declare class StdFail_Undefined_2 extends StdFail_Undefined {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_StdFail_Undefined {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdFail_Undefined): void;
  get(): StdFail_Undefined;
  delete(): void;
}

  export declare class Handle_StdFail_Undefined_1 extends Handle_StdFail_Undefined {
    constructor();
  }

  export declare class Handle_StdFail_Undefined_2 extends Handle_StdFail_Undefined {
    constructor(thePtr: StdFail_Undefined);
  }

  export declare class Handle_StdFail_Undefined_3 extends Handle_StdFail_Undefined {
    constructor(theHandle: Handle_StdFail_Undefined);
  }

  export declare class Handle_StdFail_Undefined_4 extends Handle_StdFail_Undefined {
    constructor(theHandle: Handle_StdFail_Undefined);
  }

export declare class Handle_StdFail_InfiniteSolutions {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdFail_InfiniteSolutions): void;
  get(): StdFail_InfiniteSolutions;
  delete(): void;
}

  export declare class Handle_StdFail_InfiniteSolutions_1 extends Handle_StdFail_InfiniteSolutions {
    constructor();
  }

  export declare class Handle_StdFail_InfiniteSolutions_2 extends Handle_StdFail_InfiniteSolutions {
    constructor(thePtr: StdFail_InfiniteSolutions);
  }

  export declare class Handle_StdFail_InfiniteSolutions_3 extends Handle_StdFail_InfiniteSolutions {
    constructor(theHandle: Handle_StdFail_InfiniteSolutions);
  }

  export declare class Handle_StdFail_InfiniteSolutions_4 extends Handle_StdFail_InfiniteSolutions {
    constructor(theHandle: Handle_StdFail_InfiniteSolutions);
  }

export declare class StdFail_InfiniteSolutions extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_StdFail_InfiniteSolutions;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class StdFail_InfiniteSolutions_1 extends StdFail_InfiniteSolutions {
    constructor();
  }

  export declare class StdFail_InfiniteSolutions_2 extends StdFail_InfiniteSolutions {
    constructor(theMessage: Standard_CString);
  }

export declare class StdFail_NotDone extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_StdFail_NotDone;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class StdFail_NotDone_1 extends StdFail_NotDone {
    constructor();
  }

  export declare class StdFail_NotDone_2 extends StdFail_NotDone {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_StdFail_NotDone {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdFail_NotDone): void;
  get(): StdFail_NotDone;
  delete(): void;
}

  export declare class Handle_StdFail_NotDone_1 extends Handle_StdFail_NotDone {
    constructor();
  }

  export declare class Handle_StdFail_NotDone_2 extends Handle_StdFail_NotDone {
    constructor(thePtr: StdFail_NotDone);
  }

  export declare class Handle_StdFail_NotDone_3 extends Handle_StdFail_NotDone {
    constructor(theHandle: Handle_StdFail_NotDone);
  }

  export declare class Handle_StdFail_NotDone_4 extends Handle_StdFail_NotDone {
    constructor(theHandle: Handle_StdFail_NotDone);
  }

export declare class Handle_StdFail_UndefinedDerivative {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StdFail_UndefinedDerivative): void;
  get(): StdFail_UndefinedDerivative;
  delete(): void;
}

  export declare class Handle_StdFail_UndefinedDerivative_1 extends Handle_StdFail_UndefinedDerivative {
    constructor();
  }

  export declare class Handle_StdFail_UndefinedDerivative_2 extends Handle_StdFail_UndefinedDerivative {
    constructor(thePtr: StdFail_UndefinedDerivative);
  }

  export declare class Handle_StdFail_UndefinedDerivative_3 extends Handle_StdFail_UndefinedDerivative {
    constructor(theHandle: Handle_StdFail_UndefinedDerivative);
  }

  export declare class Handle_StdFail_UndefinedDerivative_4 extends Handle_StdFail_UndefinedDerivative {
    constructor(theHandle: Handle_StdFail_UndefinedDerivative);
  }

export declare class StdFail_UndefinedDerivative extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_StdFail_UndefinedDerivative;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class StdFail_UndefinedDerivative_1 extends StdFail_UndefinedDerivative {
    constructor();
  }

  export declare class StdFail_UndefinedDerivative_2 extends StdFail_UndefinedDerivative {
    constructor(theMessage: Standard_CString);
  }

export declare type Transfer_StatusExec = {
  Transfer_StatusInitial: {};
  Transfer_StatusRun: {};
  Transfer_StatusDone: {};
  Transfer_StatusError: {};
  Transfer_StatusLoop: {};
}

export declare class Transfer_ResultFromModel extends Standard_Transient {
  constructor()
  SetModel(model: Handle_Interface_InterfaceModel): void;
  SetFileName(filename: Standard_CString): void;
  Model(): Handle_Interface_InterfaceModel;
  FileName(): Standard_CString;
  Fill(TP: Handle_Transfer_TransientProcess, ent: Handle_Standard_Transient): Standard_Boolean;
  Strip(mode: Graphic3d_ZLayerId): void;
  FillBack(TP: Handle_Transfer_TransientProcess): void;
  HasResult(): Standard_Boolean;
  MainResult(): Handle_Transfer_ResultFromTransient;
  SetMainResult(amain: Handle_Transfer_ResultFromTransient): void;
  MainLabel(): Standard_CString;
  MainNumber(): Graphic3d_ZLayerId;
  ResultFromKey(start: Handle_Standard_Transient): Handle_Transfer_ResultFromTransient;
  Results(level: Graphic3d_ZLayerId): Handle_TColStd_HSequenceOfTransient;
  TransferredList(level: Graphic3d_ZLayerId): Handle_TColStd_HSequenceOfTransient;
  CheckedList(check: Interface_CheckStatus, result: Standard_Boolean): Handle_TColStd_HSequenceOfTransient;
  CheckList(erronly: Standard_Boolean, level: Graphic3d_ZLayerId): Interface_CheckIterator;
  CheckStatus(): Interface_CheckStatus;
  ComputeCheckStatus(enforce: Standard_Boolean): Interface_CheckStatus;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_ResultFromModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ResultFromModel): void;
  get(): Transfer_ResultFromModel;
  delete(): void;
}

  export declare class Handle_Transfer_ResultFromModel_1 extends Handle_Transfer_ResultFromModel {
    constructor();
  }

  export declare class Handle_Transfer_ResultFromModel_2 extends Handle_Transfer_ResultFromModel {
    constructor(thePtr: Transfer_ResultFromModel);
  }

  export declare class Handle_Transfer_ResultFromModel_3 extends Handle_Transfer_ResultFromModel {
    constructor(theHandle: Handle_Transfer_ResultFromModel);
  }

  export declare class Handle_Transfer_ResultFromModel_4 extends Handle_Transfer_ResultFromModel {
    constructor(theHandle: Handle_Transfer_ResultFromModel);
  }

export declare class Handle_Transfer_Binder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_Binder): void;
  get(): Transfer_Binder;
  delete(): void;
}

  export declare class Handle_Transfer_Binder_1 extends Handle_Transfer_Binder {
    constructor();
  }

  export declare class Handle_Transfer_Binder_2 extends Handle_Transfer_Binder {
    constructor(thePtr: Transfer_Binder);
  }

  export declare class Handle_Transfer_Binder_3 extends Handle_Transfer_Binder {
    constructor(theHandle: Handle_Transfer_Binder);
  }

  export declare class Handle_Transfer_Binder_4 extends Handle_Transfer_Binder {
    constructor(theHandle: Handle_Transfer_Binder);
  }

export declare class Transfer_Binder extends Standard_Transient {
  Merge(other: Handle_Transfer_Binder): void;
  IsMultiple(): Standard_Boolean;
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  AddResult(next: Handle_Transfer_Binder): void;
  NextResult(): Handle_Transfer_Binder;
  HasResult(): Standard_Boolean;
  SetAlreadyUsed(): void;
  Status(): Transfer_StatusResult;
  StatusExec(): Transfer_StatusExec;
  SetStatusExec(stat: Transfer_StatusExec): void;
  AddFail(mess: Standard_CString, orig: Standard_CString): void;
  AddWarning(mess: Standard_CString, orig: Standard_CString): void;
  Check(): Handle_Interface_Check;
  CCheck(): Handle_Interface_Check;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type Transfer_UndefMode = {
  Transfer_UndefIgnore: {};
  Transfer_UndefFailure: {};
  Transfer_UndefContent: {};
  Transfer_UndefUser: {};
}

export declare class Transfer_FindHasher {
  constructor();
  static HashCode(theFinder: Handle_Transfer_Finder, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(K1: Handle_Transfer_Finder, K2: Handle_Transfer_Finder): Standard_Boolean;
  delete(): void;
}

export declare class Transfer_DataInfo {
  constructor();
  static Type(ent: Handle_Standard_Transient): Handle_Standard_Type;
  static TypeName(ent: Handle_Standard_Transient): Standard_CString;
  delete(): void;
}

export declare class Handle_Transfer_FinderProcess {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_FinderProcess): void;
  get(): Transfer_FinderProcess;
  delete(): void;
}

  export declare class Handle_Transfer_FinderProcess_1 extends Handle_Transfer_FinderProcess {
    constructor();
  }

  export declare class Handle_Transfer_FinderProcess_2 extends Handle_Transfer_FinderProcess {
    constructor(thePtr: Transfer_FinderProcess);
  }

  export declare class Handle_Transfer_FinderProcess_3 extends Handle_Transfer_FinderProcess {
    constructor(theHandle: Handle_Transfer_FinderProcess);
  }

  export declare class Handle_Transfer_FinderProcess_4 extends Handle_Transfer_FinderProcess {
    constructor(theHandle: Handle_Transfer_FinderProcess);
  }

export declare class Transfer_FinderProcess extends Transfer_ProcessForFinder {
  constructor(nb: Graphic3d_ZLayerId)
  SetModel(model: Handle_Interface_InterfaceModel): void;
  Model(): Handle_Interface_InterfaceModel;
  NextMappedWithAttribute(name: Standard_CString, num0: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  TransientMapper(obj: Handle_Standard_Transient): Handle_Transfer_TransientMapper;
  PrintTrace(start: Handle_Transfer_Finder, S: Standard_OStream): void;
  PrintStats(mode: Graphic3d_ZLayerId, S: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_IteratorOfProcessForFinder extends Transfer_TransferIterator {
  constructor(withstarts: Standard_Boolean)
  Add_1(binder: Handle_Transfer_Binder): void;
  Add_2(binder: Handle_Transfer_Binder, start: Handle_Transfer_Finder): void;
  Filter(list: Handle_Transfer_HSequenceOfFinder, keep: Standard_Boolean): void;
  HasStarting(): Standard_Boolean;
  Starting(): Handle_Transfer_Finder;
  delete(): void;
}

export declare class Handle_Transfer_ActorDispatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ActorDispatch): void;
  get(): Transfer_ActorDispatch;
  delete(): void;
}

  export declare class Handle_Transfer_ActorDispatch_1 extends Handle_Transfer_ActorDispatch {
    constructor();
  }

  export declare class Handle_Transfer_ActorDispatch_2 extends Handle_Transfer_ActorDispatch {
    constructor(thePtr: Transfer_ActorDispatch);
  }

  export declare class Handle_Transfer_ActorDispatch_3 extends Handle_Transfer_ActorDispatch {
    constructor(theHandle: Handle_Transfer_ActorDispatch);
  }

  export declare class Handle_Transfer_ActorDispatch_4 extends Handle_Transfer_ActorDispatch {
    constructor(theHandle: Handle_Transfer_ActorDispatch);
  }

export declare class Transfer_ActorDispatch extends Transfer_ActorOfTransientProcess {
  AddActor(actor: Handle_Transfer_ActorOfTransientProcess): void;
  TransferDispatch(): Transfer_TransferDispatch;
  Transfer(start: Handle_Standard_Transient, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Transfer_ActorDispatch_1 extends Transfer_ActorDispatch {
    constructor(amodel: Handle_Interface_InterfaceModel, lib: Interface_GeneralLib);
  }

  export declare class Transfer_ActorDispatch_2 extends Transfer_ActorDispatch {
    constructor(amodel: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol);
  }

  export declare class Transfer_ActorDispatch_3 extends Transfer_ActorDispatch {
    constructor(amodel: Handle_Interface_InterfaceModel);
  }

export declare type Transfer_StatusResult = {
  Transfer_StatusVoid: {};
  Transfer_StatusDefined: {};
  Transfer_StatusUsed: {};
}

export declare class Handle_Transfer_TransferDeadLoop {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_TransferDeadLoop): void;
  get(): Transfer_TransferDeadLoop;
  delete(): void;
}

  export declare class Handle_Transfer_TransferDeadLoop_1 extends Handle_Transfer_TransferDeadLoop {
    constructor();
  }

  export declare class Handle_Transfer_TransferDeadLoop_2 extends Handle_Transfer_TransferDeadLoop {
    constructor(thePtr: Transfer_TransferDeadLoop);
  }

  export declare class Handle_Transfer_TransferDeadLoop_3 extends Handle_Transfer_TransferDeadLoop {
    constructor(theHandle: Handle_Transfer_TransferDeadLoop);
  }

  export declare class Handle_Transfer_TransferDeadLoop_4 extends Handle_Transfer_TransferDeadLoop {
    constructor(theHandle: Handle_Transfer_TransferDeadLoop);
  }

export declare class Transfer_TransferDeadLoop extends Transfer_TransferFailure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Transfer_TransferDeadLoop;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Transfer_TransferDeadLoop_1 extends Transfer_TransferDeadLoop {
    constructor();
  }

  export declare class Transfer_TransferDeadLoop_2 extends Transfer_TransferDeadLoop {
    constructor(theMessage: Standard_CString);
  }

export declare class Transfer_ProcessForFinder extends Standard_Transient {
  Clear(): void;
  Clean(): void;
  Resize(nb: Graphic3d_ZLayerId): void;
  SetActor(actor: Handle_Transfer_ActorOfProcessForFinder): void;
  Actor(): Handle_Transfer_ActorOfProcessForFinder;
  Find(start: Handle_Transfer_Finder): Handle_Transfer_Binder;
  IsBound(start: Handle_Transfer_Finder): Standard_Boolean;
  IsAlreadyUsed(start: Handle_Transfer_Finder): Standard_Boolean;
  Bind(start: Handle_Transfer_Finder, binder: Handle_Transfer_Binder): void;
  Rebind(start: Handle_Transfer_Finder, binder: Handle_Transfer_Binder): void;
  Unbind(start: Handle_Transfer_Finder): Standard_Boolean;
  FindElseBind(start: Handle_Transfer_Finder): Handle_Transfer_Binder;
  SetMessenger(messenger: Handle_Message_Messenger): void;
  Messenger(): Handle_Message_Messenger;
  SetTraceLevel(tracelev: Graphic3d_ZLayerId): void;
  TraceLevel(): Graphic3d_ZLayerId;
  SendFail(start: Handle_Transfer_Finder, amsg: Message_Msg): void;
  SendWarning(start: Handle_Transfer_Finder, amsg: Message_Msg): void;
  SendMsg(start: Handle_Transfer_Finder, amsg: Message_Msg): void;
  AddFail_1(start: Handle_Transfer_Finder, mess: Standard_CString, orig: Standard_CString): void;
  AddError(start: Handle_Transfer_Finder, mess: Standard_CString, orig: Standard_CString): void;
  AddFail_2(start: Handle_Transfer_Finder, amsg: Message_Msg): void;
  AddWarning_1(start: Handle_Transfer_Finder, mess: Standard_CString, orig: Standard_CString): void;
  AddWarning_2(start: Handle_Transfer_Finder, amsg: Message_Msg): void;
  Mend(start: Handle_Transfer_Finder, pref: Standard_CString): void;
  Check(start: Handle_Transfer_Finder): Handle_Interface_Check;
  BindTransient(start: Handle_Transfer_Finder, res: Handle_Standard_Transient): void;
  FindTransient(start: Handle_Transfer_Finder): Handle_Standard_Transient;
  BindMultiple(start: Handle_Transfer_Finder): void;
  AddMultiple(start: Handle_Transfer_Finder, res: Handle_Standard_Transient): void;
  FindTypedTransient_1(start: Handle_Transfer_Finder, atype: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  GetTypedTransient_1(binder: Handle_Transfer_Binder, atype: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  NbMapped(): Graphic3d_ZLayerId;
  Mapped(num: Graphic3d_ZLayerId): Handle_Transfer_Finder;
  MapIndex(start: Handle_Transfer_Finder): Graphic3d_ZLayerId;
  MapItem(num: Graphic3d_ZLayerId): Handle_Transfer_Binder;
  SetRoot(start: Handle_Transfer_Finder): void;
  SetRootManagement(stat: Standard_Boolean): void;
  NbRoots(): Graphic3d_ZLayerId;
  Root(num: Graphic3d_ZLayerId): Handle_Transfer_Finder;
  RootItem(num: Graphic3d_ZLayerId): Handle_Transfer_Binder;
  RootIndex(start: Handle_Transfer_Finder): Graphic3d_ZLayerId;
  NestingLevel(): Graphic3d_ZLayerId;
  ResetNestingLevel(): void;
  Recognize(start: Handle_Transfer_Finder): Standard_Boolean;
  Transferring(start: Handle_Transfer_Finder, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  Transfer(start: Handle_Transfer_Finder, theProgress: Message_ProgressRange): Standard_Boolean;
  SetErrorHandle(err: Standard_Boolean): void;
  ErrorHandle(): Standard_Boolean;
  StartTrace(binder: Handle_Transfer_Binder, start: Handle_Transfer_Finder, level: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  PrintTrace(start: Handle_Transfer_Finder, S: Standard_OStream): void;
  IsLooping(alevel: Graphic3d_ZLayerId): Standard_Boolean;
  RootResult(withstart: Standard_Boolean): Transfer_IteratorOfProcessForFinder;
  CompleteResult(withstart: Standard_Boolean): Transfer_IteratorOfProcessForFinder;
  AbnormalResult(): Transfer_IteratorOfProcessForFinder;
  CheckList(erronly: Standard_Boolean): Interface_CheckIterator;
  ResultOne(start: Handle_Transfer_Finder, level: Graphic3d_ZLayerId, withstart: Standard_Boolean): Transfer_IteratorOfProcessForFinder;
  CheckListOne(start: Handle_Transfer_Finder, level: Graphic3d_ZLayerId, erronly: Standard_Boolean): Interface_CheckIterator;
  IsCheckListEmpty(start: Handle_Transfer_Finder, level: Graphic3d_ZLayerId, erronly: Standard_Boolean): Standard_Boolean;
  RemoveResult(start: Handle_Transfer_Finder, level: Graphic3d_ZLayerId, compute: Standard_Boolean): void;
  CheckNum(start: Handle_Transfer_Finder): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Transfer_ProcessForFinder_1 extends Transfer_ProcessForFinder {
    constructor(nb: Graphic3d_ZLayerId);
  }

  export declare class Transfer_ProcessForFinder_2 extends Transfer_ProcessForFinder {
    constructor(printer: Handle_Message_Messenger, nb: Graphic3d_ZLayerId);
  }

export declare class Handle_Transfer_ProcessForFinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ProcessForFinder): void;
  get(): Transfer_ProcessForFinder;
  delete(): void;
}

  export declare class Handle_Transfer_ProcessForFinder_1 extends Handle_Transfer_ProcessForFinder {
    constructor();
  }

  export declare class Handle_Transfer_ProcessForFinder_2 extends Handle_Transfer_ProcessForFinder {
    constructor(thePtr: Transfer_ProcessForFinder);
  }

  export declare class Handle_Transfer_ProcessForFinder_3 extends Handle_Transfer_ProcessForFinder {
    constructor(theHandle: Handle_Transfer_ProcessForFinder);
  }

  export declare class Handle_Transfer_ProcessForFinder_4 extends Handle_Transfer_ProcessForFinder {
    constructor(theHandle: Handle_Transfer_ProcessForFinder);
  }

export declare class Handle_Transfer_TransientProcess {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_TransientProcess): void;
  get(): Transfer_TransientProcess;
  delete(): void;
}

  export declare class Handle_Transfer_TransientProcess_1 extends Handle_Transfer_TransientProcess {
    constructor();
  }

  export declare class Handle_Transfer_TransientProcess_2 extends Handle_Transfer_TransientProcess {
    constructor(thePtr: Transfer_TransientProcess);
  }

  export declare class Handle_Transfer_TransientProcess_3 extends Handle_Transfer_TransientProcess {
    constructor(theHandle: Handle_Transfer_TransientProcess);
  }

  export declare class Handle_Transfer_TransientProcess_4 extends Handle_Transfer_TransientProcess {
    constructor(theHandle: Handle_Transfer_TransientProcess);
  }

export declare class Transfer_TransientProcess extends Transfer_ProcessForTransient {
  constructor(nb: Graphic3d_ZLayerId)
  SetModel(model: Handle_Interface_InterfaceModel): void;
  Model(): Handle_Interface_InterfaceModel;
  SetGraph(HG: Handle_Interface_HGraph): void;
  HasGraph(): Standard_Boolean;
  HGraph(): Handle_Interface_HGraph;
  Graph(): Interface_Graph;
  SetContext(name: Standard_CString, ctx: Handle_Standard_Transient): void;
  GetContext(name: Standard_CString, type: Handle_Standard_Type, ctx: Handle_Standard_Transient): Standard_Boolean;
  Context(): any;
  PrintTrace(start: Handle_Standard_Transient, S: Standard_OStream): void;
  CheckNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  TypedSharings(start: Handle_Standard_Transient, type: Handle_Standard_Type): Interface_EntityIterator;
  IsDataLoaded(ent: Handle_Standard_Transient): Standard_Boolean;
  IsDataFail(ent: Handle_Standard_Transient): Standard_Boolean;
  PrintStats(mode: Graphic3d_ZLayerId, S: Standard_OStream): void;
  RootsForTransfer(): Handle_TColStd_HSequenceOfTransient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_ActorOfFinderProcess extends Transfer_ActorOfProcessForFinder {
  constructor()
  ModeTrans(): Graphic3d_ZLayerId;
  Transferring(start: Handle_Transfer_Finder, TP: Handle_Transfer_ProcessForFinder, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  Transfer(start: Handle_Transfer_Finder, TP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransferTransient(start: Handle_Standard_Transient, TP: Handle_Transfer_FinderProcess, theProgress: Message_ProgressRange): Handle_Standard_Transient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_ActorOfFinderProcess {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ActorOfFinderProcess): void;
  get(): Transfer_ActorOfFinderProcess;
  delete(): void;
}

  export declare class Handle_Transfer_ActorOfFinderProcess_1 extends Handle_Transfer_ActorOfFinderProcess {
    constructor();
  }

  export declare class Handle_Transfer_ActorOfFinderProcess_2 extends Handle_Transfer_ActorOfFinderProcess {
    constructor(thePtr: Transfer_ActorOfFinderProcess);
  }

  export declare class Handle_Transfer_ActorOfFinderProcess_3 extends Handle_Transfer_ActorOfFinderProcess {
    constructor(theHandle: Handle_Transfer_ActorOfFinderProcess);
  }

  export declare class Handle_Transfer_ActorOfFinderProcess_4 extends Handle_Transfer_ActorOfFinderProcess {
    constructor(theHandle: Handle_Transfer_ActorOfFinderProcess);
  }

export declare class Handle_Transfer_MapContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_MapContainer): void;
  get(): Transfer_MapContainer;
  delete(): void;
}

  export declare class Handle_Transfer_MapContainer_1 extends Handle_Transfer_MapContainer {
    constructor();
  }

  export declare class Handle_Transfer_MapContainer_2 extends Handle_Transfer_MapContainer {
    constructor(thePtr: Transfer_MapContainer);
  }

  export declare class Handle_Transfer_MapContainer_3 extends Handle_Transfer_MapContainer {
    constructor(theHandle: Handle_Transfer_MapContainer);
  }

  export declare class Handle_Transfer_MapContainer_4 extends Handle_Transfer_MapContainer {
    constructor(theHandle: Handle_Transfer_MapContainer);
  }

export declare class Transfer_MapContainer extends Standard_Transient {
  constructor()
  SetMapObjects(theMapObjects: TColStd_DataMapOfTransientTransient): void;
  GetMapObjects(): TColStd_DataMapOfTransientTransient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_TransferInput {
  constructor()
  Entities(list: Transfer_TransferIterator): Interface_EntityIterator;
  FillModel_1(proc: Handle_Transfer_TransientProcess, amodel: Handle_Interface_InterfaceModel): void;
  FillModel_2(proc: Handle_Transfer_TransientProcess, amodel: Handle_Interface_InterfaceModel, proto: Handle_Interface_Protocol, roots: Standard_Boolean): void;
  FillModel_3(proc: Handle_Transfer_FinderProcess, amodel: Handle_Interface_InterfaceModel): void;
  FillModel_4(proc: Handle_Transfer_FinderProcess, amodel: Handle_Interface_InterfaceModel, proto: Handle_Interface_Protocol, roots: Standard_Boolean): void;
  delete(): void;
}

export declare class Handle_Transfer_HSequenceOfBinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_HSequenceOfBinder): void;
  get(): Transfer_HSequenceOfBinder;
  delete(): void;
}

  export declare class Handle_Transfer_HSequenceOfBinder_1 extends Handle_Transfer_HSequenceOfBinder {
    constructor();
  }

  export declare class Handle_Transfer_HSequenceOfBinder_2 extends Handle_Transfer_HSequenceOfBinder {
    constructor(thePtr: Transfer_HSequenceOfBinder);
  }

  export declare class Handle_Transfer_HSequenceOfBinder_3 extends Handle_Transfer_HSequenceOfBinder {
    constructor(theHandle: Handle_Transfer_HSequenceOfBinder);
  }

  export declare class Handle_Transfer_HSequenceOfBinder_4 extends Handle_Transfer_HSequenceOfBinder {
    constructor(theHandle: Handle_Transfer_HSequenceOfBinder);
  }

export declare class Handle_Transfer_HSequenceOfFinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_HSequenceOfFinder): void;
  get(): Transfer_HSequenceOfFinder;
  delete(): void;
}

  export declare class Handle_Transfer_HSequenceOfFinder_1 extends Handle_Transfer_HSequenceOfFinder {
    constructor();
  }

  export declare class Handle_Transfer_HSequenceOfFinder_2 extends Handle_Transfer_HSequenceOfFinder {
    constructor(thePtr: Transfer_HSequenceOfFinder);
  }

  export declare class Handle_Transfer_HSequenceOfFinder_3 extends Handle_Transfer_HSequenceOfFinder {
    constructor(theHandle: Handle_Transfer_HSequenceOfFinder);
  }

  export declare class Handle_Transfer_HSequenceOfFinder_4 extends Handle_Transfer_HSequenceOfFinder {
    constructor(theHandle: Handle_Transfer_HSequenceOfFinder);
  }

export declare class Handle_Transfer_ActorOfProcessForFinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ActorOfProcessForFinder): void;
  get(): Transfer_ActorOfProcessForFinder;
  delete(): void;
}

  export declare class Handle_Transfer_ActorOfProcessForFinder_1 extends Handle_Transfer_ActorOfProcessForFinder {
    constructor();
  }

  export declare class Handle_Transfer_ActorOfProcessForFinder_2 extends Handle_Transfer_ActorOfProcessForFinder {
    constructor(thePtr: Transfer_ActorOfProcessForFinder);
  }

  export declare class Handle_Transfer_ActorOfProcessForFinder_3 extends Handle_Transfer_ActorOfProcessForFinder {
    constructor(theHandle: Handle_Transfer_ActorOfProcessForFinder);
  }

  export declare class Handle_Transfer_ActorOfProcessForFinder_4 extends Handle_Transfer_ActorOfProcessForFinder {
    constructor(theHandle: Handle_Transfer_ActorOfProcessForFinder);
  }

export declare class Transfer_ActorOfProcessForFinder extends Standard_Transient {
  constructor()
  Recognize(start: Handle_Transfer_Finder): Standard_Boolean;
  Transferring(start: Handle_Transfer_Finder, TP: Handle_Transfer_ProcessForFinder, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransientResult(res: Handle_Standard_Transient): Handle_Transfer_SimpleBinderOfTransient;
  NullResult(): Handle_Transfer_Binder;
  SetLast(mode: Standard_Boolean): void;
  IsLast(): Standard_Boolean;
  SetNext(next: Handle_Transfer_ActorOfProcessForFinder): void;
  Next(): Handle_Transfer_ActorOfProcessForFinder;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_IteratorOfProcessForTransient extends Transfer_TransferIterator {
  constructor(withstarts: Standard_Boolean)
  Add_1(binder: Handle_Transfer_Binder): void;
  Add_2(binder: Handle_Transfer_Binder, start: Handle_Standard_Transient): void;
  Filter(list: Handle_TColStd_HSequenceOfTransient, keep: Standard_Boolean): void;
  HasStarting(): Standard_Boolean;
  Starting(): Handle_Standard_Transient;
  delete(): void;
}

export declare class Transfer_TransferIterator {
  constructor()
  AddItem(atr: Handle_Transfer_Binder): void;
  SelectBinder(atype: Handle_Standard_Type, keep: Standard_Boolean): void;
  SelectResult(atype: Handle_Standard_Type, keep: Standard_Boolean): void;
  SelectUnique(keep: Standard_Boolean): void;
  SelectItem(num: Graphic3d_ZLayerId, keep: Standard_Boolean): void;
  Number(): Graphic3d_ZLayerId;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Transfer_Binder;
  HasResult(): Standard_Boolean;
  HasUniqueResult(): Standard_Boolean;
  ResultType(): Handle_Standard_Type;
  HasTransientResult(): Standard_Boolean;
  TransientResult(): Handle_Standard_Transient;
  Status(): Transfer_StatusExec;
  HasFails(): Standard_Boolean;
  HasWarnings(): Standard_Boolean;
  Check(): Handle_Interface_Check;
  delete(): void;
}

export declare class Handle_Transfer_TransientMapper {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_TransientMapper): void;
  get(): Transfer_TransientMapper;
  delete(): void;
}

  export declare class Handle_Transfer_TransientMapper_1 extends Handle_Transfer_TransientMapper {
    constructor();
  }

  export declare class Handle_Transfer_TransientMapper_2 extends Handle_Transfer_TransientMapper {
    constructor(thePtr: Transfer_TransientMapper);
  }

  export declare class Handle_Transfer_TransientMapper_3 extends Handle_Transfer_TransientMapper {
    constructor(theHandle: Handle_Transfer_TransientMapper);
  }

  export declare class Handle_Transfer_TransientMapper_4 extends Handle_Transfer_TransientMapper {
    constructor(theHandle: Handle_Transfer_TransientMapper);
  }

export declare class Transfer_TransientMapper extends Transfer_Finder {
  constructor(akey: Handle_Standard_Transient)
  Value(): Handle_Standard_Transient;
  Equates(other: Handle_Transfer_Finder): Standard_Boolean;
  ValueType(): Handle_Standard_Type;
  ValueTypeName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_BinderOfTransientInteger extends Transfer_SimpleBinderOfTransient {
  constructor()
  SetInteger(value: Graphic3d_ZLayerId): void;
  Integer(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_BinderOfTransientInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_BinderOfTransientInteger): void;
  get(): Transfer_BinderOfTransientInteger;
  delete(): void;
}

  export declare class Handle_Transfer_BinderOfTransientInteger_1 extends Handle_Transfer_BinderOfTransientInteger {
    constructor();
  }

  export declare class Handle_Transfer_BinderOfTransientInteger_2 extends Handle_Transfer_BinderOfTransientInteger {
    constructor(thePtr: Transfer_BinderOfTransientInteger);
  }

  export declare class Handle_Transfer_BinderOfTransientInteger_3 extends Handle_Transfer_BinderOfTransientInteger {
    constructor(theHandle: Handle_Transfer_BinderOfTransientInteger);
  }

  export declare class Handle_Transfer_BinderOfTransientInteger_4 extends Handle_Transfer_BinderOfTransientInteger {
    constructor(theHandle: Handle_Transfer_BinderOfTransientInteger);
  }

export declare class Handle_Transfer_TransientListBinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_TransientListBinder): void;
  get(): Transfer_TransientListBinder;
  delete(): void;
}

  export declare class Handle_Transfer_TransientListBinder_1 extends Handle_Transfer_TransientListBinder {
    constructor();
  }

  export declare class Handle_Transfer_TransientListBinder_2 extends Handle_Transfer_TransientListBinder {
    constructor(thePtr: Transfer_TransientListBinder);
  }

  export declare class Handle_Transfer_TransientListBinder_3 extends Handle_Transfer_TransientListBinder {
    constructor(theHandle: Handle_Transfer_TransientListBinder);
  }

  export declare class Handle_Transfer_TransientListBinder_4 extends Handle_Transfer_TransientListBinder {
    constructor(theHandle: Handle_Transfer_TransientListBinder);
  }

export declare class Transfer_TransientListBinder extends Transfer_Binder {
  IsMultiple(): Standard_Boolean;
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  AddResult(res: Handle_Standard_Transient): void;
  Result(): Handle_TColStd_HSequenceOfTransient;
  SetResult(num: Graphic3d_ZLayerId, res: Handle_Standard_Transient): void;
  NbTransients(): Graphic3d_ZLayerId;
  Transient(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Transfer_TransientListBinder_1 extends Transfer_TransientListBinder {
    constructor();
  }

  export declare class Transfer_TransientListBinder_2 extends Transfer_TransientListBinder {
    constructor(list: Handle_TColStd_HSequenceOfTransient);
  }

export declare class Transfer_TransferOutput {
  Model(): Handle_Interface_InterfaceModel;
  TransientProcess(): Handle_Transfer_TransientProcess;
  Transfer(obj: Handle_Standard_Transient, theProgress: Message_ProgressRange): void;
  TransferRoots_1(protocol: Handle_Interface_Protocol, theProgress: Message_ProgressRange): void;
  TransferRoots_2(G: Interface_Graph, theProgress: Message_ProgressRange): void;
  TransferRoots_3(theProgress: Message_ProgressRange): void;
  ListForStatus(normal: Standard_Boolean, roots: Standard_Boolean): Interface_EntityIterator;
  ModelForStatus(protocol: Handle_Interface_Protocol, normal: Standard_Boolean, roots: Standard_Boolean): Handle_Interface_InterfaceModel;
  delete(): void;
}

  export declare class Transfer_TransferOutput_1 extends Transfer_TransferOutput {
    constructor(actor: Handle_Transfer_ActorOfTransientProcess, amodel: Handle_Interface_InterfaceModel);
  }

  export declare class Transfer_TransferOutput_2 extends Transfer_TransferOutput {
    constructor(proc: Handle_Transfer_TransientProcess, amodel: Handle_Interface_InterfaceModel);
  }

export declare class Transfer_ActorOfTransientProcess extends Transfer_ActorOfProcessForTransient {
  constructor()
  Transferring(start: Handle_Standard_Transient, TP: Handle_Transfer_ProcessForTransient, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  Transfer(start: Handle_Standard_Transient, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransferTransient(start: Handle_Standard_Transient, TP: Handle_Transfer_TransientProcess, theProgress: Message_ProgressRange): Handle_Standard_Transient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_ActorOfTransientProcess {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ActorOfTransientProcess): void;
  get(): Transfer_ActorOfTransientProcess;
  delete(): void;
}

  export declare class Handle_Transfer_ActorOfTransientProcess_1 extends Handle_Transfer_ActorOfTransientProcess {
    constructor();
  }

  export declare class Handle_Transfer_ActorOfTransientProcess_2 extends Handle_Transfer_ActorOfTransientProcess {
    constructor(thePtr: Transfer_ActorOfTransientProcess);
  }

  export declare class Handle_Transfer_ActorOfTransientProcess_3 extends Handle_Transfer_ActorOfTransientProcess {
    constructor(theHandle: Handle_Transfer_ActorOfTransientProcess);
  }

  export declare class Handle_Transfer_ActorOfTransientProcess_4 extends Handle_Transfer_ActorOfTransientProcess {
    constructor(theHandle: Handle_Transfer_ActorOfTransientProcess);
  }

export declare class Transfer_TransferFailure extends Interface_InterfaceError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Transfer_TransferFailure;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Transfer_TransferFailure_1 extends Transfer_TransferFailure {
    constructor();
  }

  export declare class Transfer_TransferFailure_2 extends Transfer_TransferFailure {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Transfer_TransferFailure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_TransferFailure): void;
  get(): Transfer_TransferFailure;
  delete(): void;
}

  export declare class Handle_Transfer_TransferFailure_1 extends Handle_Transfer_TransferFailure {
    constructor();
  }

  export declare class Handle_Transfer_TransferFailure_2 extends Handle_Transfer_TransferFailure {
    constructor(thePtr: Transfer_TransferFailure);
  }

  export declare class Handle_Transfer_TransferFailure_3 extends Handle_Transfer_TransferFailure {
    constructor(theHandle: Handle_Transfer_TransferFailure);
  }

  export declare class Handle_Transfer_TransferFailure_4 extends Handle_Transfer_TransferFailure {
    constructor(theHandle: Handle_Transfer_TransferFailure);
  }

export declare class Handle_Transfer_DispatchControl {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_DispatchControl): void;
  get(): Transfer_DispatchControl;
  delete(): void;
}

  export declare class Handle_Transfer_DispatchControl_1 extends Handle_Transfer_DispatchControl {
    constructor();
  }

  export declare class Handle_Transfer_DispatchControl_2 extends Handle_Transfer_DispatchControl {
    constructor(thePtr: Transfer_DispatchControl);
  }

  export declare class Handle_Transfer_DispatchControl_3 extends Handle_Transfer_DispatchControl {
    constructor(theHandle: Handle_Transfer_DispatchControl);
  }

  export declare class Handle_Transfer_DispatchControl_4 extends Handle_Transfer_DispatchControl {
    constructor(theHandle: Handle_Transfer_DispatchControl);
  }

export declare class Transfer_DispatchControl extends Interface_CopyControl {
  constructor(model: Handle_Interface_InterfaceModel, TP: Handle_Transfer_TransientProcess)
  TransientProcess(): Handle_Transfer_TransientProcess;
  StartingModel(): Handle_Interface_InterfaceModel;
  Clear(): void;
  Bind(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): void;
  Search(ent: Handle_Standard_Transient, res: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_ProcessForTransient extends Standard_Transient {
  Clear(): void;
  Clean(): void;
  Resize(nb: Graphic3d_ZLayerId): void;
  SetActor(actor: Handle_Transfer_ActorOfProcessForTransient): void;
  Actor(): Handle_Transfer_ActorOfProcessForTransient;
  Find(start: Handle_Standard_Transient): Handle_Transfer_Binder;
  IsBound(start: Handle_Standard_Transient): Standard_Boolean;
  IsAlreadyUsed(start: Handle_Standard_Transient): Standard_Boolean;
  Bind(start: Handle_Standard_Transient, binder: Handle_Transfer_Binder): void;
  Rebind(start: Handle_Standard_Transient, binder: Handle_Transfer_Binder): void;
  Unbind(start: Handle_Standard_Transient): Standard_Boolean;
  FindElseBind(start: Handle_Standard_Transient): Handle_Transfer_Binder;
  SetMessenger(messenger: Handle_Message_Messenger): void;
  Messenger(): Handle_Message_Messenger;
  SetTraceLevel(tracelev: Graphic3d_ZLayerId): void;
  TraceLevel(): Graphic3d_ZLayerId;
  SendFail(start: Handle_Standard_Transient, amsg: Message_Msg): void;
  SendWarning(start: Handle_Standard_Transient, amsg: Message_Msg): void;
  SendMsg(start: Handle_Standard_Transient, amsg: Message_Msg): void;
  AddFail_1(start: Handle_Standard_Transient, mess: Standard_CString, orig: Standard_CString): void;
  AddError(start: Handle_Standard_Transient, mess: Standard_CString, orig: Standard_CString): void;
  AddFail_2(start: Handle_Standard_Transient, amsg: Message_Msg): void;
  AddWarning_1(start: Handle_Standard_Transient, mess: Standard_CString, orig: Standard_CString): void;
  AddWarning_2(start: Handle_Standard_Transient, amsg: Message_Msg): void;
  Mend(start: Handle_Standard_Transient, pref: Standard_CString): void;
  Check(start: Handle_Standard_Transient): Handle_Interface_Check;
  BindTransient(start: Handle_Standard_Transient, res: Handle_Standard_Transient): void;
  FindTransient(start: Handle_Standard_Transient): Handle_Standard_Transient;
  BindMultiple(start: Handle_Standard_Transient): void;
  AddMultiple(start: Handle_Standard_Transient, res: Handle_Standard_Transient): void;
  FindTypedTransient(start: Handle_Standard_Transient, atype: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  GetTypedTransient(binder: Handle_Transfer_Binder, atype: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  NbMapped(): Graphic3d_ZLayerId;
  Mapped(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  MapIndex(start: Handle_Standard_Transient): Graphic3d_ZLayerId;
  MapItem(num: Graphic3d_ZLayerId): Handle_Transfer_Binder;
  SetRoot(start: Handle_Standard_Transient): void;
  SetRootManagement(stat: Standard_Boolean): void;
  NbRoots(): Graphic3d_ZLayerId;
  Root(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  RootItem(num: Graphic3d_ZLayerId): Handle_Transfer_Binder;
  RootIndex(start: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NestingLevel(): Graphic3d_ZLayerId;
  ResetNestingLevel(): void;
  Recognize(start: Handle_Standard_Transient): Standard_Boolean;
  Transferring(start: Handle_Standard_Transient, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  Transfer(start: Handle_Standard_Transient, theProgress: Message_ProgressRange): Standard_Boolean;
  SetErrorHandle(err: Standard_Boolean): void;
  ErrorHandle(): Standard_Boolean;
  StartTrace(binder: Handle_Transfer_Binder, start: Handle_Standard_Transient, level: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): void;
  PrintTrace(start: Handle_Standard_Transient, S: Standard_OStream): void;
  IsLooping(alevel: Graphic3d_ZLayerId): Standard_Boolean;
  RootResult(withstart: Standard_Boolean): Transfer_IteratorOfProcessForTransient;
  CompleteResult(withstart: Standard_Boolean): Transfer_IteratorOfProcessForTransient;
  AbnormalResult(): Transfer_IteratorOfProcessForTransient;
  CheckList(erronly: Standard_Boolean): Interface_CheckIterator;
  ResultOne(start: Handle_Standard_Transient, level: Graphic3d_ZLayerId, withstart: Standard_Boolean): Transfer_IteratorOfProcessForTransient;
  CheckListOne(start: Handle_Standard_Transient, level: Graphic3d_ZLayerId, erronly: Standard_Boolean): Interface_CheckIterator;
  IsCheckListEmpty(start: Handle_Standard_Transient, level: Graphic3d_ZLayerId, erronly: Standard_Boolean): Standard_Boolean;
  RemoveResult(start: Handle_Standard_Transient, level: Graphic3d_ZLayerId, compute: Standard_Boolean): void;
  CheckNum(start: Handle_Standard_Transient): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Transfer_ProcessForTransient_1 extends Transfer_ProcessForTransient {
    constructor(nb: Graphic3d_ZLayerId);
  }

  export declare class Transfer_ProcessForTransient_2 extends Transfer_ProcessForTransient {
    constructor(printer: Handle_Message_Messenger, nb: Graphic3d_ZLayerId);
  }

export declare class Handle_Transfer_ProcessForTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ProcessForTransient): void;
  get(): Transfer_ProcessForTransient;
  delete(): void;
}

  export declare class Handle_Transfer_ProcessForTransient_1 extends Handle_Transfer_ProcessForTransient {
    constructor();
  }

  export declare class Handle_Transfer_ProcessForTransient_2 extends Handle_Transfer_ProcessForTransient {
    constructor(thePtr: Transfer_ProcessForTransient);
  }

  export declare class Handle_Transfer_ProcessForTransient_3 extends Handle_Transfer_ProcessForTransient {
    constructor(theHandle: Handle_Transfer_ProcessForTransient);
  }

  export declare class Handle_Transfer_ProcessForTransient_4 extends Handle_Transfer_ProcessForTransient {
    constructor(theHandle: Handle_Transfer_ProcessForTransient);
  }

export declare class Handle_Transfer_SimpleBinderOfTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_SimpleBinderOfTransient): void;
  get(): Transfer_SimpleBinderOfTransient;
  delete(): void;
}

  export declare class Handle_Transfer_SimpleBinderOfTransient_1 extends Handle_Transfer_SimpleBinderOfTransient {
    constructor();
  }

  export declare class Handle_Transfer_SimpleBinderOfTransient_2 extends Handle_Transfer_SimpleBinderOfTransient {
    constructor(thePtr: Transfer_SimpleBinderOfTransient);
  }

  export declare class Handle_Transfer_SimpleBinderOfTransient_3 extends Handle_Transfer_SimpleBinderOfTransient {
    constructor(theHandle: Handle_Transfer_SimpleBinderOfTransient);
  }

  export declare class Handle_Transfer_SimpleBinderOfTransient_4 extends Handle_Transfer_SimpleBinderOfTransient {
    constructor(theHandle: Handle_Transfer_SimpleBinderOfTransient);
  }

export declare class Transfer_SimpleBinderOfTransient extends Transfer_Binder {
  constructor()
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  SetResult(res: Handle_Standard_Transient): void;
  Result(): Handle_Standard_Transient;
  static GetTypedResult(bnd: Handle_Transfer_Binder, atype: Handle_Standard_Type, res: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_Finder extends Standard_Transient {
  GetHashCode(): Graphic3d_ZLayerId;
  Equates(other: Handle_Transfer_Finder): Standard_Boolean;
  ValueType(): Handle_Standard_Type;
  ValueTypeName(): Standard_CString;
  SetAttribute(name: Standard_CString, val: Handle_Standard_Transient): void;
  RemoveAttribute(name: Standard_CString): Standard_Boolean;
  GetAttribute(name: Standard_CString, type: Handle_Standard_Type, val: Handle_Standard_Transient): Standard_Boolean;
  Attribute(name: Standard_CString): Handle_Standard_Transient;
  AttributeType(name: Standard_CString): Interface_ParamType;
  SetIntegerAttribute(name: Standard_CString, val: Graphic3d_ZLayerId): void;
  GetIntegerAttribute(name: Standard_CString, val: Graphic3d_ZLayerId): Standard_Boolean;
  IntegerAttribute(name: Standard_CString): Graphic3d_ZLayerId;
  SetRealAttribute(name: Standard_CString, val: Quantity_AbsorbedDose): void;
  GetRealAttribute(name: Standard_CString, val: Quantity_AbsorbedDose): Standard_Boolean;
  RealAttribute(name: Standard_CString): Quantity_AbsorbedDose;
  SetStringAttribute(name: Standard_CString, val: Standard_CString): void;
  StringAttribute(name: Standard_CString): Standard_CString;
  AttrList(): any;
  SameAttributes(other: Handle_Transfer_Finder): void;
  GetAttributes(other: Handle_Transfer_Finder, fromname: Standard_CString, copied: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_Finder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_Finder): void;
  get(): Transfer_Finder;
  delete(): void;
}

  export declare class Handle_Transfer_Finder_1 extends Handle_Transfer_Finder {
    constructor();
  }

  export declare class Handle_Transfer_Finder_2 extends Handle_Transfer_Finder {
    constructor(thePtr: Transfer_Finder);
  }

  export declare class Handle_Transfer_Finder_3 extends Handle_Transfer_Finder {
    constructor(theHandle: Handle_Transfer_Finder);
  }

  export declare class Handle_Transfer_Finder_4 extends Handle_Transfer_Finder {
    constructor(theHandle: Handle_Transfer_Finder);
  }

export declare class Transfer_ActorOfProcessForTransient extends Standard_Transient {
  constructor()
  Recognize(start: Handle_Standard_Transient): Standard_Boolean;
  Transferring(start: Handle_Standard_Transient, TP: Handle_Transfer_ProcessForTransient, theProgress: Message_ProgressRange): Handle_Transfer_Binder;
  TransientResult(res: Handle_Standard_Transient): Handle_Transfer_SimpleBinderOfTransient;
  NullResult(): Handle_Transfer_Binder;
  SetLast(mode: Standard_Boolean): void;
  IsLast(): Standard_Boolean;
  SetNext(next: Handle_Transfer_ActorOfProcessForTransient): void;
  Next(): Handle_Transfer_ActorOfProcessForTransient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_ActorOfProcessForTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ActorOfProcessForTransient): void;
  get(): Transfer_ActorOfProcessForTransient;
  delete(): void;
}

  export declare class Handle_Transfer_ActorOfProcessForTransient_1 extends Handle_Transfer_ActorOfProcessForTransient {
    constructor();
  }

  export declare class Handle_Transfer_ActorOfProcessForTransient_2 extends Handle_Transfer_ActorOfProcessForTransient {
    constructor(thePtr: Transfer_ActorOfProcessForTransient);
  }

  export declare class Handle_Transfer_ActorOfProcessForTransient_3 extends Handle_Transfer_ActorOfProcessForTransient {
    constructor(theHandle: Handle_Transfer_ActorOfProcessForTransient);
  }

  export declare class Handle_Transfer_ActorOfProcessForTransient_4 extends Handle_Transfer_ActorOfProcessForTransient {
    constructor(theHandle: Handle_Transfer_ActorOfProcessForTransient);
  }

export declare class Handle_Transfer_MultipleBinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_MultipleBinder): void;
  get(): Transfer_MultipleBinder;
  delete(): void;
}

  export declare class Handle_Transfer_MultipleBinder_1 extends Handle_Transfer_MultipleBinder {
    constructor();
  }

  export declare class Handle_Transfer_MultipleBinder_2 extends Handle_Transfer_MultipleBinder {
    constructor(thePtr: Transfer_MultipleBinder);
  }

  export declare class Handle_Transfer_MultipleBinder_3 extends Handle_Transfer_MultipleBinder {
    constructor(theHandle: Handle_Transfer_MultipleBinder);
  }

  export declare class Handle_Transfer_MultipleBinder_4 extends Handle_Transfer_MultipleBinder {
    constructor(theHandle: Handle_Transfer_MultipleBinder);
  }

export declare class Transfer_MultipleBinder extends Transfer_Binder {
  constructor()
  IsMultiple(): Standard_Boolean;
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  AddResult(res: Handle_Standard_Transient): void;
  NbResults(): Graphic3d_ZLayerId;
  ResultValue(num: Graphic3d_ZLayerId): Handle_Standard_Transient;
  MultipleResult(): Handle_TColStd_HSequenceOfTransient;
  SetMultipleResult(mulres: Handle_TColStd_HSequenceOfTransient): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Transfer_VoidBinder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_VoidBinder): void;
  get(): Transfer_VoidBinder;
  delete(): void;
}

  export declare class Handle_Transfer_VoidBinder_1 extends Handle_Transfer_VoidBinder {
    constructor();
  }

  export declare class Handle_Transfer_VoidBinder_2 extends Handle_Transfer_VoidBinder {
    constructor(thePtr: Transfer_VoidBinder);
  }

  export declare class Handle_Transfer_VoidBinder_3 extends Handle_Transfer_VoidBinder {
    constructor(theHandle: Handle_Transfer_VoidBinder);
  }

  export declare class Handle_Transfer_VoidBinder_4 extends Handle_Transfer_VoidBinder {
    constructor(theHandle: Handle_Transfer_VoidBinder);
  }

export declare class Transfer_VoidBinder extends Transfer_Binder {
  constructor()
  ResultType(): Handle_Standard_Type;
  ResultTypeName(): Standard_CString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Transfer_TransferDispatch extends Interface_CopyTool {
  TransientProcess(): Handle_Transfer_TransientProcess;
  Copy(entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient, mapped: Standard_Boolean, errstat: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

  export declare class Transfer_TransferDispatch_1 extends Transfer_TransferDispatch {
    constructor(amodel: Handle_Interface_InterfaceModel, lib: Interface_GeneralLib);
  }

  export declare class Transfer_TransferDispatch_2 extends Transfer_TransferDispatch {
    constructor(amodel: Handle_Interface_InterfaceModel, protocol: Handle_Interface_Protocol);
  }

  export declare class Transfer_TransferDispatch_3 extends Transfer_TransferDispatch {
    constructor(amodel: Handle_Interface_InterfaceModel);
  }

export declare class Handle_Transfer_ResultFromTransient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Transfer_ResultFromTransient): void;
  get(): Transfer_ResultFromTransient;
  delete(): void;
}

  export declare class Handle_Transfer_ResultFromTransient_1 extends Handle_Transfer_ResultFromTransient {
    constructor();
  }

  export declare class Handle_Transfer_ResultFromTransient_2 extends Handle_Transfer_ResultFromTransient {
    constructor(thePtr: Transfer_ResultFromTransient);
  }

  export declare class Handle_Transfer_ResultFromTransient_3 extends Handle_Transfer_ResultFromTransient {
    constructor(theHandle: Handle_Transfer_ResultFromTransient);
  }

  export declare class Handle_Transfer_ResultFromTransient_4 extends Handle_Transfer_ResultFromTransient {
    constructor(theHandle: Handle_Transfer_ResultFromTransient);
  }

export declare class Transfer_ResultFromTransient extends Standard_Transient {
  constructor()
  SetStart(start: Handle_Standard_Transient): void;
  SetBinder(binder: Handle_Transfer_Binder): void;
  Start(): Handle_Standard_Transient;
  Binder(): Handle_Transfer_Binder;
  HasResult(): Standard_Boolean;
  Check(): Handle_Interface_Check;
  CheckStatus(): Interface_CheckStatus;
  ClearSubs(): void;
  AddSubResult(sub: Handle_Transfer_ResultFromTransient): void;
  NbSubResults(): Graphic3d_ZLayerId;
  SubResult(num: Graphic3d_ZLayerId): Handle_Transfer_ResultFromTransient;
  ResultFromKey(key: Handle_Standard_Transient): Handle_Transfer_ResultFromTransient;
  FillMap(map: BinObjMgt_SRelocationTable): void;
  Fill(TP: Handle_Transfer_TransientProcess): void;
  Strip(): void;
  FillBack(TP: Handle_Transfer_TransientProcess): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepExtrema_TriangleSet extends BVH_PrimitiveSet3d {
  Size(): Graphic3d_ZLayerId;
  Box_1(theIndex: Graphic3d_ZLayerId): Graphic3d_BndBox3d;
  Center(theIndex: Graphic3d_ZLayerId, theAxis: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Swap(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  Clear(): void;
  Init(theFaces: BRepExtrema_ShapeList): Standard_Boolean;
  GetVertices(theIndex: Graphic3d_ZLayerId, theVertex1: BVH_Vec3d, theVertex2: BVH_Vec3d, theVertex3: BVH_Vec3d): void;
  GetFaceID(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepExtrema_TriangleSet_1 extends BRepExtrema_TriangleSet {
    constructor();
  }

  export declare class BRepExtrema_TriangleSet_2 extends BRepExtrema_TriangleSet {
    constructor(theFaces: BRepExtrema_ShapeList);
  }

export declare class BRepExtrema_ShapeList extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BRepExtrema_ShapeList, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: TopoDS_Face): TopoDS_Face;
  Appended(): TopoDS_Face;
  Value(theIndex: Standard_Integer): TopoDS_Face;
  First(): TopoDS_Face;
  ChangeFirst(): TopoDS_Face;
  Last(): TopoDS_Face;
  ChangeLast(): TopoDS_Face;
  ChangeValue(theIndex: Standard_Integer): TopoDS_Face;
  SetValue(theIndex: Standard_Integer, theValue: TopoDS_Face): TopoDS_Face;
  delete(): void;
}

  export declare class BRepExtrema_ShapeList_1 extends BRepExtrema_ShapeList {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepExtrema_ShapeList_2 extends BRepExtrema_ShapeList {
    constructor(theOther: BRepExtrema_ShapeList);
  }

export declare class Handle_BRepExtrema_TriangleSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepExtrema_TriangleSet): void;
  get(): BRepExtrema_TriangleSet;
  delete(): void;
}

  export declare class Handle_BRepExtrema_TriangleSet_1 extends Handle_BRepExtrema_TriangleSet {
    constructor();
  }

  export declare class Handle_BRepExtrema_TriangleSet_2 extends Handle_BRepExtrema_TriangleSet {
    constructor(thePtr: BRepExtrema_TriangleSet);
  }

  export declare class Handle_BRepExtrema_TriangleSet_3 extends Handle_BRepExtrema_TriangleSet {
    constructor(theHandle: Handle_BRepExtrema_TriangleSet);
  }

  export declare class Handle_BRepExtrema_TriangleSet_4 extends Handle_BRepExtrema_TriangleSet {
    constructor(theHandle: Handle_BRepExtrema_TriangleSet);
  }

export declare class BRepExtrema_ExtPF {
  Initialize(TheFace: TopoDS_Face, TheFlag: Extrema_ExtFlag, TheAlgo: Extrema_ExtAlgo): void;
  Perform(TheVertex: TopoDS_Vertex, TheFace: TopoDS_Face): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Parameter(N: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Point(N: Graphic3d_ZLayerId): gp_Pnt;
  SetFlag(F: Extrema_ExtFlag): void;
  SetAlgo(A: Extrema_ExtAlgo): void;
  delete(): void;
}

  export declare class BRepExtrema_ExtPF_1 extends BRepExtrema_ExtPF {
    constructor();
  }

  export declare class BRepExtrema_ExtPF_2 extends BRepExtrema_ExtPF {
    constructor(TheVertex: TopoDS_Vertex, TheFace: TopoDS_Face, TheFlag: Extrema_ExtFlag, TheAlgo: Extrema_ExtAlgo);
  }

export declare class BRepExtrema_ExtPC {
  Initialize(E: TopoDS_Edge): void;
  Perform(V: TopoDS_Vertex): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Parameter(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Point(N: Graphic3d_ZLayerId): gp_Pnt;
  TrimmedSquareDistances(dist1: Quantity_AbsorbedDose, dist2: Quantity_AbsorbedDose, pnt1: gp_Pnt, pnt2: gp_Pnt): void;
  delete(): void;
}

  export declare class BRepExtrema_ExtPC_1 extends BRepExtrema_ExtPC {
    constructor();
  }

  export declare class BRepExtrema_ExtPC_2 extends BRepExtrema_ExtPC {
    constructor(V: TopoDS_Vertex, E: TopoDS_Edge);
  }

export declare class BRepExtrema_SelfIntersection extends BRepExtrema_ElementFilter {
  Tolerance(): Quantity_AbsorbedDose;
  SetTolerance(theTolerance: Quantity_AbsorbedDose): void;
  LoadShape(theShape: TopoDS_Shape): Standard_Boolean;
  Perform(): void;
  IsDone(): Standard_Boolean;
  OverlapElements(): BRepExtrema_MapOfIntegerPackedMapOfInteger;
  GetSubShape(theID: Graphic3d_ZLayerId): TopoDS_Face;
  ElementSet(): Handle_BRepExtrema_TriangleSet;
  delete(): void;
}

  export declare class BRepExtrema_SelfIntersection_1 extends BRepExtrema_SelfIntersection {
    constructor(theTolerance: Quantity_AbsorbedDose);
  }

  export declare class BRepExtrema_SelfIntersection_2 extends BRepExtrema_SelfIntersection {
    constructor(theShape: TopoDS_Shape, theTolerance: Quantity_AbsorbedDose);
  }

export declare type BRepExtrema_SupportType = {
  BRepExtrema_IsVertex: {};
  BRepExtrema_IsOnEdge: {};
  BRepExtrema_IsInFace: {};
}

export declare class BRepExtrema_Poly {
  constructor();
  static Distance(S1: TopoDS_Shape, S2: TopoDS_Shape, P1: gp_Pnt, P2: gp_Pnt, dist: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepExtrema_SolutionElem {
  Dist(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  SupportKind(): BRepExtrema_SupportType;
  Vertex(): TopoDS_Vertex;
  Edge(): TopoDS_Edge;
  Face(): TopoDS_Face;
  EdgeParameter(theParam: Quantity_AbsorbedDose): void;
  FaceParameter(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class BRepExtrema_SolutionElem_1 extends BRepExtrema_SolutionElem {
    constructor();
  }

  export declare class BRepExtrema_SolutionElem_2 extends BRepExtrema_SolutionElem {
    constructor(theDist: Quantity_AbsorbedDose, thePoint: gp_Pnt, theSolType: BRepExtrema_SupportType, theVertex: TopoDS_Vertex);
  }

  export declare class BRepExtrema_SolutionElem_3 extends BRepExtrema_SolutionElem {
    constructor(theDist: Quantity_AbsorbedDose, thePoint: gp_Pnt, theSolType: BRepExtrema_SupportType, theEdge: TopoDS_Edge, theParam: Quantity_AbsorbedDose);
  }

  export declare class BRepExtrema_SolutionElem_4 extends BRepExtrema_SolutionElem {
    constructor(theDist: Quantity_AbsorbedDose, thePoint: gp_Pnt, theSolType: BRepExtrema_SupportType, theFace: TopoDS_Face, theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose);
  }

export declare class BRepExtrema_SeqOfSolution extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepExtrema_SeqOfSolution): BRepExtrema_SeqOfSolution;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: BRepExtrema_SolutionElem): void;
  Append_2(theSeq: BRepExtrema_SeqOfSolution): void;
  Prepend_1(theItem: BRepExtrema_SolutionElem): void;
  Prepend_2(theSeq: BRepExtrema_SeqOfSolution): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: BRepExtrema_SolutionElem): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepExtrema_SeqOfSolution): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepExtrema_SeqOfSolution): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: BRepExtrema_SolutionElem): void;
  Split(theIndex: Standard_Integer, theSeq: BRepExtrema_SeqOfSolution): void;
  First(): BRepExtrema_SolutionElem;
  ChangeFirst(): BRepExtrema_SolutionElem;
  Last(): BRepExtrema_SolutionElem;
  ChangeLast(): BRepExtrema_SolutionElem;
  Value(theIndex: Standard_Integer): BRepExtrema_SolutionElem;
  ChangeValue(theIndex: Standard_Integer): BRepExtrema_SolutionElem;
  SetValue(theIndex: Standard_Integer, theItem: BRepExtrema_SolutionElem): void;
  delete(): void;
}

  export declare class BRepExtrema_SeqOfSolution_1 extends BRepExtrema_SeqOfSolution {
    constructor();
  }

  export declare class BRepExtrema_SeqOfSolution_2 extends BRepExtrema_SeqOfSolution {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepExtrema_SeqOfSolution_3 extends BRepExtrema_SeqOfSolution {
    constructor(theOther: BRepExtrema_SeqOfSolution);
  }

export declare class BRepExtrema_OverlapTool {
  LoadTriangleSets(theSet1: Handle_BRepExtrema_TriangleSet, theSet2: Handle_BRepExtrema_TriangleSet): void;
  Perform(theTolerance: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  MarkDirty(): void;
  OverlapSubShapes1(): BRepExtrema_MapOfIntegerPackedMapOfInteger;
  OverlapSubShapes2(): BRepExtrema_MapOfIntegerPackedMapOfInteger;
  SetElementFilter(theFilter: BRepExtrema_ElementFilter): void;
  RejectNode(theCornerMin1: BVH_Vec3d, theCornerMax1: BVH_Vec3d, theCornerMin2: BVH_Vec3d, theCornerMax2: BVH_Vec3d, a4: Quantity_AbsorbedDose): Standard_Boolean;
  Accept(theLeaf1: Graphic3d_ZLayerId, theLeaf2: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class BRepExtrema_OverlapTool_1 extends BRepExtrema_OverlapTool {
    constructor();
  }

  export declare class BRepExtrema_OverlapTool_2 extends BRepExtrema_OverlapTool {
    constructor(theSet1: Handle_BRepExtrema_TriangleSet, theSet2: Handle_BRepExtrema_TriangleSet);
  }

export declare class Handle_BRepExtrema_UnCompatibleShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepExtrema_UnCompatibleShape): void;
  get(): BRepExtrema_UnCompatibleShape;
  delete(): void;
}

  export declare class Handle_BRepExtrema_UnCompatibleShape_1 extends Handle_BRepExtrema_UnCompatibleShape {
    constructor();
  }

  export declare class Handle_BRepExtrema_UnCompatibleShape_2 extends Handle_BRepExtrema_UnCompatibleShape {
    constructor(thePtr: BRepExtrema_UnCompatibleShape);
  }

  export declare class Handle_BRepExtrema_UnCompatibleShape_3 extends Handle_BRepExtrema_UnCompatibleShape {
    constructor(theHandle: Handle_BRepExtrema_UnCompatibleShape);
  }

  export declare class Handle_BRepExtrema_UnCompatibleShape_4 extends Handle_BRepExtrema_UnCompatibleShape {
    constructor(theHandle: Handle_BRepExtrema_UnCompatibleShape);
  }

export declare class BRepExtrema_UnCompatibleShape extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_BRepExtrema_UnCompatibleShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepExtrema_UnCompatibleShape_1 extends BRepExtrema_UnCompatibleShape {
    constructor();
  }

  export declare class BRepExtrema_UnCompatibleShape_2 extends BRepExtrema_UnCompatibleShape {
    constructor(theMessage: Standard_CString);
  }

export declare class BRepExtrema_ExtCF {
  Initialize(E: TopoDS_Edge, F: TopoDS_Face): void;
  Perform(E: TopoDS_Edge, F: TopoDS_Face): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsParallel(): Standard_Boolean;
  ParameterOnEdge(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ParameterOnFace(N: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  PointOnEdge(N: Graphic3d_ZLayerId): gp_Pnt;
  PointOnFace(N: Graphic3d_ZLayerId): gp_Pnt;
  delete(): void;
}

  export declare class BRepExtrema_ExtCF_1 extends BRepExtrema_ExtCF {
    constructor();
  }

  export declare class BRepExtrema_ExtCF_2 extends BRepExtrema_ExtCF {
    constructor(E: TopoDS_Edge, F: TopoDS_Face);
  }

export declare class BRepExtrema_ShapeProximity {
  Tolerance(): Quantity_AbsorbedDose;
  SetTolerance(theTolerance: Quantity_AbsorbedDose): void;
  LoadShape1(theShape1: TopoDS_Shape): Standard_Boolean;
  LoadShape2(theShape2: TopoDS_Shape): Standard_Boolean;
  Perform(): void;
  IsDone(): Standard_Boolean;
  OverlapSubShapes1(): BRepExtrema_MapOfIntegerPackedMapOfInteger;
  OverlapSubShapes2(): BRepExtrema_MapOfIntegerPackedMapOfInteger;
  GetSubShape1(theID: Graphic3d_ZLayerId): TopoDS_Face;
  GetSubShape2(theID: Graphic3d_ZLayerId): TopoDS_Face;
  ElementSet1(): Handle_BRepExtrema_TriangleSet;
  ElementSet2(): Handle_BRepExtrema_TriangleSet;
  delete(): void;
}

  export declare class BRepExtrema_ShapeProximity_1 extends BRepExtrema_ShapeProximity {
    constructor(theTolerance: Quantity_AbsorbedDose);
  }

  export declare class BRepExtrema_ShapeProximity_2 extends BRepExtrema_ShapeProximity {
    constructor(theShape1: TopoDS_Shape, theShape2: TopoDS_Shape, theTolerance: Quantity_AbsorbedDose);
  }

export declare class BRepExtrema_ExtCC {
  Initialize(E2: TopoDS_Edge): void;
  Perform(E1: TopoDS_Edge): void;
  IsDone(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  IsParallel(): Standard_Boolean;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ParameterOnE1(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  PointOnE1(N: Graphic3d_ZLayerId): gp_Pnt;
  ParameterOnE2(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  PointOnE2(N: Graphic3d_ZLayerId): gp_Pnt;
  TrimmedSquareDistances(dist11: Quantity_AbsorbedDose, distP12: Quantity_AbsorbedDose, distP21: Quantity_AbsorbedDose, distP22: Quantity_AbsorbedDose, P11: gp_Pnt, P12: gp_Pnt, P21: gp_Pnt, P22: gp_Pnt): void;
  delete(): void;
}

  export declare class BRepExtrema_ExtCC_1 extends BRepExtrema_ExtCC {
    constructor();
  }

  export declare class BRepExtrema_ExtCC_2 extends BRepExtrema_ExtCC {
    constructor(E1: TopoDS_Edge, E2: TopoDS_Edge);
  }

export declare class BRepExtrema_DistanceSS {
  IsDone(): Standard_Boolean;
  DistValue(): Quantity_AbsorbedDose;
  Seq1Value(): BRepExtrema_SeqOfSolution;
  Seq2Value(): BRepExtrema_SeqOfSolution;
  SetFlag(F: Extrema_ExtFlag): void;
  SetAlgo(A: Extrema_ExtAlgo): void;
  delete(): void;
}

  export declare class BRepExtrema_DistanceSS_1 extends BRepExtrema_DistanceSS {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, B1: Bnd_Box, B2: Bnd_Box, DstRef: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

  export declare class BRepExtrema_DistanceSS_2 extends BRepExtrema_DistanceSS {
    constructor(S1: TopoDS_Shape, S2: TopoDS_Shape, B1: Bnd_Box, B2: Bnd_Box, DstRef: Quantity_AbsorbedDose, aDeflection: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

export declare class BRepExtrema_ElementFilter {
  constructor();
  PreCheckElements(a0: Graphic3d_ZLayerId, a1: Graphic3d_ZLayerId): any;
  delete(): void;
}

export declare class BRepExtrema_DistShapeShape {
  SetDeflection(theDeflection: Quantity_AbsorbedDose): void;
  LoadS1(Shape1: TopoDS_Shape): void;
  LoadS2(Shape1: TopoDS_Shape): void;
  Perform(): Standard_Boolean;
  IsDone(): Standard_Boolean;
  NbSolution(): Graphic3d_ZLayerId;
  Value(): Quantity_AbsorbedDose;
  InnerSolution(): Standard_Boolean;
  PointOnShape1(N: Graphic3d_ZLayerId): gp_Pnt;
  PointOnShape2(N: Graphic3d_ZLayerId): gp_Pnt;
  SupportTypeShape1(N: Graphic3d_ZLayerId): BRepExtrema_SupportType;
  SupportTypeShape2(N: Graphic3d_ZLayerId): BRepExtrema_SupportType;
  SupportOnShape1(N: Graphic3d_ZLayerId): TopoDS_Shape;
  SupportOnShape2(N: Graphic3d_ZLayerId): TopoDS_Shape;
  ParOnEdgeS1(N: Graphic3d_ZLayerId, t: Quantity_AbsorbedDose): void;
  ParOnEdgeS2(N: Graphic3d_ZLayerId, t: Quantity_AbsorbedDose): void;
  ParOnFaceS1(N: Graphic3d_ZLayerId, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): void;
  ParOnFaceS2(N: Graphic3d_ZLayerId, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose): void;
  Dump(o: Standard_OStream): void;
  SetFlag(F: Extrema_ExtFlag): void;
  SetAlgo(A: Extrema_ExtAlgo): void;
  delete(): void;
}

  export declare class BRepExtrema_DistShapeShape_1 extends BRepExtrema_DistShapeShape {
    constructor();
  }

  export declare class BRepExtrema_DistShapeShape_2 extends BRepExtrema_DistShapeShape {
    constructor(Shape1: TopoDS_Shape, Shape2: TopoDS_Shape, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

  export declare class BRepExtrema_DistShapeShape_3 extends BRepExtrema_DistShapeShape {
    constructor(Shape1: TopoDS_Shape, Shape2: TopoDS_Shape, theDeflection: Quantity_AbsorbedDose, F: Extrema_ExtFlag, A: Extrema_ExtAlgo);
  }

export declare class BRepExtrema_ExtFF {
  Initialize(F2: TopoDS_Face): void;
  Perform(F1: TopoDS_Face, F2: TopoDS_Face): void;
  IsDone(): Standard_Boolean;
  IsParallel(): Standard_Boolean;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  ParameterOnFace1(N: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  ParameterOnFace2(N: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  PointOnFace1(N: Graphic3d_ZLayerId): gp_Pnt;
  PointOnFace2(N: Graphic3d_ZLayerId): gp_Pnt;
  delete(): void;
}

  export declare class BRepExtrema_ExtFF_1 extends BRepExtrema_ExtFF {
    constructor();
  }

  export declare class BRepExtrema_ExtFF_2 extends BRepExtrema_ExtFF {
    constructor(F1: TopoDS_Face, F2: TopoDS_Face);
  }

export declare class TopTools_DataMapOfOrientedShapeInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfOrientedShapeInteger): void;
  Assign(theOther: TopTools_DataMapOfOrientedShapeInteger): TopTools_DataMapOfOrientedShapeInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Standard_Integer;
  ChangeSeek(theKey: TopoDS_Shape): Standard_Integer;
  ChangeFind(theKey: TopoDS_Shape): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfOrientedShapeInteger_1 extends TopTools_DataMapOfOrientedShapeInteger {
    constructor();
  }

  export declare class TopTools_DataMapOfOrientedShapeInteger_2 extends TopTools_DataMapOfOrientedShapeInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfOrientedShapeInteger_3 extends TopTools_DataMapOfOrientedShapeInteger {
    constructor(theOther: TopTools_DataMapOfOrientedShapeInteger);
  }

export declare class TopTools_IndexedMapOfShape extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_IndexedMapOfShape): void;
  Assign(theOther: TopTools_IndexedMapOfShape): TopTools_IndexedMapOfShape;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_IndexedMapOfShape_1 extends TopTools_IndexedMapOfShape {
    constructor();
  }

  export declare class TopTools_IndexedMapOfShape_2 extends TopTools_IndexedMapOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_IndexedMapOfShape_3 extends TopTools_IndexedMapOfShape {
    constructor(theOther: TopTools_IndexedMapOfShape);
  }

export declare class TopTools_DataMapOfShapeBox extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeBox): void;
  Assign(theOther: TopTools_DataMapOfShapeBox): TopTools_DataMapOfShapeBox;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Bnd_Box): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Bnd_Box): Bnd_Box;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Bnd_Box;
  ChangeSeek(theKey: TopoDS_Shape): Bnd_Box;
  ChangeFind(theKey: TopoDS_Shape): Bnd_Box;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeBox_1 extends TopTools_DataMapOfShapeBox {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeBox_2 extends TopTools_DataMapOfShapeBox {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeBox_3 extends TopTools_DataMapOfShapeBox {
    constructor(theOther: TopTools_DataMapOfShapeBox);
  }

export declare class TopTools_Array2OfShape {
  Init(theValue: TopoDS_Shape): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TopTools_Array2OfShape): TopTools_Array2OfShape;
  Move(theOther: TopTools_Array2OfShape): TopTools_Array2OfShape;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): TopoDS_Shape;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): TopoDS_Shape;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: TopoDS_Shape): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopTools_Array2OfShape_1 extends TopTools_Array2OfShape {
    constructor();
  }

  export declare class TopTools_Array2OfShape_2 extends TopTools_Array2OfShape {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TopTools_Array2OfShape_3 extends TopTools_Array2OfShape {
    constructor(theOther: TopTools_Array2OfShape);
  }

  export declare class TopTools_Array2OfShape_4 extends TopTools_Array2OfShape {
    constructor(theOther: TopTools_Array2OfShape);
  }

  export declare class TopTools_Array2OfShape_5 extends TopTools_Array2OfShape {
    constructor(theBegin: TopoDS_Shape, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TopTools_HArray1OfShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopTools_HArray1OfShape): void;
  get(): TopTools_HArray1OfShape;
  delete(): void;
}

  export declare class Handle_TopTools_HArray1OfShape_1 extends Handle_TopTools_HArray1OfShape {
    constructor();
  }

  export declare class Handle_TopTools_HArray1OfShape_2 extends Handle_TopTools_HArray1OfShape {
    constructor(thePtr: TopTools_HArray1OfShape);
  }

  export declare class Handle_TopTools_HArray1OfShape_3 extends Handle_TopTools_HArray1OfShape {
    constructor(theHandle: Handle_TopTools_HArray1OfShape);
  }

  export declare class Handle_TopTools_HArray1OfShape_4 extends Handle_TopTools_HArray1OfShape {
    constructor(theHandle: Handle_TopTools_HArray1OfShape);
  }

export declare class Handle_TopTools_HSequenceOfShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopTools_HSequenceOfShape): void;
  get(): TopTools_HSequenceOfShape;
  delete(): void;
}

  export declare class Handle_TopTools_HSequenceOfShape_1 extends Handle_TopTools_HSequenceOfShape {
    constructor();
  }

  export declare class Handle_TopTools_HSequenceOfShape_2 extends Handle_TopTools_HSequenceOfShape {
    constructor(thePtr: TopTools_HSequenceOfShape);
  }

  export declare class Handle_TopTools_HSequenceOfShape_3 extends Handle_TopTools_HSequenceOfShape {
    constructor(theHandle: Handle_TopTools_HSequenceOfShape);
  }

  export declare class Handle_TopTools_HSequenceOfShape_4 extends Handle_TopTools_HSequenceOfShape {
    constructor(theHandle: Handle_TopTools_HSequenceOfShape);
  }

export declare class TopTools_ShapeSet {
  constructor()
  SetFormatNb(theFormatNb: Graphic3d_ZLayerId): void;
  FormatNb(): Graphic3d_ZLayerId;
  Clear(): void;
  Add(S: TopoDS_Shape): Graphic3d_ZLayerId;
  Shape(I: Graphic3d_ZLayerId): TopoDS_Shape;
  Index(S: TopoDS_Shape): Graphic3d_ZLayerId;
  Locations(): TopTools_LocationSet;
  ChangeLocations(): TopTools_LocationSet;
  DumpExtent_2(S: XCAFDoc_PartId): void;
  Dump_1(OS: Standard_OStream): void;
  Write_1(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  Read_1(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  Dump_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  Write_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  Read_2(S: TopoDS_Shape, IS: Standard_IStream): void;
  AddGeometry(S: TopoDS_Shape): void;
  DumpGeometry_1(OS: Standard_OStream): void;
  WriteGeometry_1(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  ReadGeometry_1(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  DumpGeometry_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  WriteGeometry_2(S: TopoDS_Shape, OS: Standard_OStream): void;
  ReadGeometry_2(T: TopAbs_ShapeEnum, IS: Standard_IStream, S: TopoDS_Shape): void;
  AddShapes(S1: TopoDS_Shape, S2: TopoDS_Shape): void;
  Check(T: TopAbs_ShapeEnum, S: TopoDS_Shape): void;
  NbShapes(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TopTools_IndexedDataMapOfShapeShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_IndexedDataMapOfShapeShape): void;
  Assign(theOther: TopTools_IndexedDataMapOfShapeShape): TopTools_IndexedDataMapOfShapeShape;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopoDS_Shape): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopoDS_Shape): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopoDS_Shape;
  ChangeFromIndex(theIndex: Standard_Integer): TopoDS_Shape;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopoDS_Shape;
  Seek(theKey1: TopoDS_Shape): TopoDS_Shape;
  ChangeSeek(theKey1: TopoDS_Shape): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_IndexedDataMapOfShapeShape_1 extends TopTools_IndexedDataMapOfShapeShape {
    constructor();
  }

  export declare class TopTools_IndexedDataMapOfShapeShape_2 extends TopTools_IndexedDataMapOfShapeShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_IndexedDataMapOfShapeShape_3 extends TopTools_IndexedDataMapOfShapeShape {
    constructor(theOther: TopTools_IndexedDataMapOfShapeShape);
  }

export declare class TopTools_OrientedShapeMapHasher {
  constructor();
  static HashCode(theShape: TopoDS_Shape, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(S1: TopoDS_Shape, S2: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

export declare class TopTools_MutexForShapeProvider {
  constructor()
  CreateMutexesForSubShapes(theShape: TopoDS_Shape, theType: TopAbs_ShapeEnum): void;
  CreateMutexForShape(theShape: TopoDS_Shape): void;
  GetMutex(theShape: TopoDS_Shape): Standard_Mutex;
  RemoveAllMutexes(): void;
  delete(): void;
}

export declare class TopTools_Array1OfListOfShape {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TopTools_ListOfShape): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TopTools_Array1OfListOfShape): TopTools_Array1OfListOfShape;
  Move(theOther: TopTools_Array1OfListOfShape): TopTools_Array1OfListOfShape;
  First(): TopTools_ListOfShape;
  ChangeFirst(): TopTools_ListOfShape;
  Last(): TopTools_ListOfShape;
  ChangeLast(): TopTools_ListOfShape;
  Value(theIndex: Standard_Integer): TopTools_ListOfShape;
  ChangeValue(theIndex: Standard_Integer): TopTools_ListOfShape;
  SetValue(theIndex: Standard_Integer, theItem: TopTools_ListOfShape): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopTools_Array1OfListOfShape_1 extends TopTools_Array1OfListOfShape {
    constructor();
  }

  export declare class TopTools_Array1OfListOfShape_2 extends TopTools_Array1OfListOfShape {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TopTools_Array1OfListOfShape_3 extends TopTools_Array1OfListOfShape {
    constructor(theOther: TopTools_Array1OfListOfShape);
  }

  export declare class TopTools_Array1OfListOfShape_4 extends TopTools_Array1OfListOfShape {
    constructor(theOther: TopTools_Array1OfListOfShape);
  }

  export declare class TopTools_Array1OfListOfShape_5 extends TopTools_Array1OfListOfShape {
    constructor(theBegin: TopTools_ListOfShape, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TopTools_ShapeMapHasher {
  constructor();
  static HashCode(theShape: TopoDS_Shape, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(S1: TopoDS_Shape, S2: TopoDS_Shape): Standard_Boolean;
  delete(): void;
}

export declare class TopTools_DataMapOfShapeReal extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeReal): void;
  Assign(theOther: TopTools_DataMapOfShapeReal): TopTools_DataMapOfShapeReal;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Standard_Real): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Standard_Real): Standard_Real;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Standard_Real;
  ChangeSeek(theKey: TopoDS_Shape): Standard_Real;
  ChangeFind(theKey: TopoDS_Shape): Standard_Real;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeReal_1 extends TopTools_DataMapOfShapeReal {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeReal_2 extends TopTools_DataMapOfShapeReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeReal_3 extends TopTools_DataMapOfShapeReal {
    constructor(theOther: TopTools_DataMapOfShapeReal);
  }

export declare class TopTools_IndexedMapOfOrientedShape extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_IndexedMapOfOrientedShape): void;
  Assign(theOther: TopTools_IndexedMapOfOrientedShape): TopTools_IndexedMapOfOrientedShape;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_IndexedMapOfOrientedShape_1 extends TopTools_IndexedMapOfOrientedShape {
    constructor();
  }

  export declare class TopTools_IndexedMapOfOrientedShape_2 extends TopTools_IndexedMapOfOrientedShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_IndexedMapOfOrientedShape_3 extends TopTools_IndexedMapOfOrientedShape {
    constructor(theOther: TopTools_IndexedMapOfOrientedShape);
  }

export declare class TopTools_DataMapOfShapeListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeListOfShape): void;
  Assign(theOther: TopTools_DataMapOfShapeListOfShape): TopTools_DataMapOfShapeListOfShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopTools_ListOfShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopTools_ListOfShape): TopTools_ListOfShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopTools_ListOfShape;
  ChangeSeek(theKey: TopoDS_Shape): TopTools_ListOfShape;
  ChangeFind(theKey: TopoDS_Shape): TopTools_ListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeListOfShape_1 extends TopTools_DataMapOfShapeListOfShape {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeListOfShape_2 extends TopTools_DataMapOfShapeListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeListOfShape_3 extends TopTools_DataMapOfShapeListOfShape {
    constructor(theOther: TopTools_DataMapOfShapeListOfShape);
  }

export declare class Handle_TopTools_HArray1OfListOfShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopTools_HArray1OfListOfShape): void;
  get(): TopTools_HArray1OfListOfShape;
  delete(): void;
}

  export declare class Handle_TopTools_HArray1OfListOfShape_1 extends Handle_TopTools_HArray1OfListOfShape {
    constructor();
  }

  export declare class Handle_TopTools_HArray1OfListOfShape_2 extends Handle_TopTools_HArray1OfListOfShape {
    constructor(thePtr: TopTools_HArray1OfListOfShape);
  }

  export declare class Handle_TopTools_HArray1OfListOfShape_3 extends Handle_TopTools_HArray1OfListOfShape {
    constructor(theHandle: Handle_TopTools_HArray1OfListOfShape);
  }

  export declare class Handle_TopTools_HArray1OfListOfShape_4 extends Handle_TopTools_HArray1OfListOfShape {
    constructor(theHandle: Handle_TopTools_HArray1OfListOfShape);
  }

export declare class TopTools_Array1OfShape {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TopoDS_Shape): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TopTools_Array1OfShape): TopTools_Array1OfShape;
  Move(theOther: TopTools_Array1OfShape): TopTools_Array1OfShape;
  First(): TopoDS_Shape;
  ChangeFirst(): TopoDS_Shape;
  Last(): TopoDS_Shape;
  ChangeLast(): TopoDS_Shape;
  Value(theIndex: Standard_Integer): TopoDS_Shape;
  ChangeValue(theIndex: Standard_Integer): TopoDS_Shape;
  SetValue(theIndex: Standard_Integer, theItem: TopoDS_Shape): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopTools_Array1OfShape_1 extends TopTools_Array1OfShape {
    constructor();
  }

  export declare class TopTools_Array1OfShape_2 extends TopTools_Array1OfShape {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TopTools_Array1OfShape_3 extends TopTools_Array1OfShape {
    constructor(theOther: TopTools_Array1OfShape);
  }

  export declare class TopTools_Array1OfShape_4 extends TopTools_Array1OfShape {
    constructor(theOther: TopTools_Array1OfShape);
  }

  export declare class TopTools_Array1OfShape_5 extends TopTools_Array1OfShape {
    constructor(theBegin: TopoDS_Shape, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TopTools_HArray2OfShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopTools_HArray2OfShape): void;
  get(): TopTools_HArray2OfShape;
  delete(): void;
}

  export declare class Handle_TopTools_HArray2OfShape_1 extends Handle_TopTools_HArray2OfShape {
    constructor();
  }

  export declare class Handle_TopTools_HArray2OfShape_2 extends Handle_TopTools_HArray2OfShape {
    constructor(thePtr: TopTools_HArray2OfShape);
  }

  export declare class Handle_TopTools_HArray2OfShape_3 extends Handle_TopTools_HArray2OfShape {
    constructor(theHandle: Handle_TopTools_HArray2OfShape);
  }

  export declare class Handle_TopTools_HArray2OfShape_4 extends Handle_TopTools_HArray2OfShape {
    constructor(theHandle: Handle_TopTools_HArray2OfShape);
  }

export declare class TopTools {
  constructor();
  static Dump(Sh: TopoDS_Shape, S: Standard_OStream): void;
  static Dummy(I: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopTools_MapOfShape extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_MapOfShape): void;
  Assign(theOther: TopTools_MapOfShape): TopTools_MapOfShape;
  ReSize(N: Standard_Integer): void;
  Add(K: TopoDS_Shape): Standard_Boolean;
  Added(K: TopoDS_Shape): TopoDS_Shape;
  Contains_1(K: TopoDS_Shape): Standard_Boolean;
  Remove(K: TopoDS_Shape): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: TopTools_MapOfShape): Standard_Boolean;
  Contains_2(theOther: TopTools_MapOfShape): Standard_Boolean;
  Union(theLeft: TopTools_MapOfShape, theRight: TopTools_MapOfShape): void;
  Unite(theOther: TopTools_MapOfShape): Standard_Boolean;
  HasIntersection(theMap: TopTools_MapOfShape): Standard_Boolean;
  Intersection(theLeft: TopTools_MapOfShape, theRight: TopTools_MapOfShape): void;
  Intersect(theOther: TopTools_MapOfShape): Standard_Boolean;
  Subtraction(theLeft: TopTools_MapOfShape, theRight: TopTools_MapOfShape): void;
  Subtract(theOther: TopTools_MapOfShape): Standard_Boolean;
  Difference(theLeft: TopTools_MapOfShape, theRight: TopTools_MapOfShape): void;
  Differ(theOther: TopTools_MapOfShape): Standard_Boolean;
  delete(): void;
}

  export declare class TopTools_MapOfShape_1 extends TopTools_MapOfShape {
    constructor();
  }

  export declare class TopTools_MapOfShape_2 extends TopTools_MapOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_MapOfShape_3 extends TopTools_MapOfShape {
    constructor(theOther: TopTools_MapOfShape);
  }

export declare class TopTools_MapOfOrientedShape extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_MapOfOrientedShape): void;
  Assign(theOther: TopTools_MapOfOrientedShape): TopTools_MapOfOrientedShape;
  ReSize(N: Standard_Integer): void;
  Add(K: TopoDS_Shape): Standard_Boolean;
  Added(K: TopoDS_Shape): TopoDS_Shape;
  Contains_1(K: TopoDS_Shape): Standard_Boolean;
  Remove(K: TopoDS_Shape): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: TopTools_MapOfOrientedShape): Standard_Boolean;
  Contains_2(theOther: TopTools_MapOfOrientedShape): Standard_Boolean;
  Union(theLeft: TopTools_MapOfOrientedShape, theRight: TopTools_MapOfOrientedShape): void;
  Unite(theOther: TopTools_MapOfOrientedShape): Standard_Boolean;
  HasIntersection(theMap: TopTools_MapOfOrientedShape): Standard_Boolean;
  Intersection(theLeft: TopTools_MapOfOrientedShape, theRight: TopTools_MapOfOrientedShape): void;
  Intersect(theOther: TopTools_MapOfOrientedShape): Standard_Boolean;
  Subtraction(theLeft: TopTools_MapOfOrientedShape, theRight: TopTools_MapOfOrientedShape): void;
  Subtract(theOther: TopTools_MapOfOrientedShape): Standard_Boolean;
  Difference(theLeft: TopTools_MapOfOrientedShape, theRight: TopTools_MapOfOrientedShape): void;
  Differ(theOther: TopTools_MapOfOrientedShape): Standard_Boolean;
  delete(): void;
}

  export declare class TopTools_MapOfOrientedShape_1 extends TopTools_MapOfOrientedShape {
    constructor();
  }

  export declare class TopTools_MapOfOrientedShape_2 extends TopTools_MapOfOrientedShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_MapOfOrientedShape_3 extends TopTools_MapOfOrientedShape {
    constructor(theOther: TopTools_MapOfOrientedShape);
  }

export declare class TopTools_DataMapOfShapeShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeShape): void;
  Assign(theOther: TopTools_DataMapOfShapeShape): TopTools_DataMapOfShapeShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopoDS_Shape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopoDS_Shape): TopoDS_Shape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopoDS_Shape;
  ChangeSeek(theKey: TopoDS_Shape): TopoDS_Shape;
  ChangeFind(theKey: TopoDS_Shape): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeShape_1 extends TopTools_DataMapOfShapeShape {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeShape_2 extends TopTools_DataMapOfShapeShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeShape_3 extends TopTools_DataMapOfShapeShape {
    constructor(theOther: TopTools_DataMapOfShapeShape);
  }

export declare class TopTools_DataMapOfShapeSequenceOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeSequenceOfShape): void;
  Assign(theOther: TopTools_DataMapOfShapeSequenceOfShape): TopTools_DataMapOfShapeSequenceOfShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopTools_SequenceOfShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopTools_SequenceOfShape): TopTools_SequenceOfShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopTools_SequenceOfShape;
  ChangeSeek(theKey: TopoDS_Shape): TopTools_SequenceOfShape;
  ChangeFind(theKey: TopoDS_Shape): TopTools_SequenceOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeSequenceOfShape_1 extends TopTools_DataMapOfShapeSequenceOfShape {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeSequenceOfShape_2 extends TopTools_DataMapOfShapeSequenceOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeSequenceOfShape_3 extends TopTools_DataMapOfShapeSequenceOfShape {
    constructor(theOther: TopTools_DataMapOfShapeSequenceOfShape);
  }

export declare class TopTools_ListOfShape extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopTools_ListOfShape): TopTools_ListOfShape;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopoDS_Shape;
  First_2(): TopoDS_Shape;
  Last_1(): TopoDS_Shape;
  Last_2(): TopoDS_Shape;
  Append_1(theItem: TopoDS_Shape): TopoDS_Shape;
  Append_3(theOther: TopTools_ListOfShape): void;
  Prepend_1(theItem: TopoDS_Shape): TopoDS_Shape;
  Prepend_2(theOther: TopTools_ListOfShape): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopTools_ListOfShape_1 extends TopTools_ListOfShape {
    constructor();
  }

  export declare class TopTools_ListOfShape_2 extends TopTools_ListOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_ListOfShape_3 extends TopTools_ListOfShape {
    constructor(theOther: TopTools_ListOfShape);
  }

export declare class TopTools_SequenceOfShape extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TopTools_SequenceOfShape): TopTools_SequenceOfShape;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TopoDS_Shape): void;
  Append_2(theSeq: TopTools_SequenceOfShape): void;
  Prepend_1(theItem: TopoDS_Shape): void;
  Prepend_2(theSeq: TopTools_SequenceOfShape): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TopoDS_Shape): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TopTools_SequenceOfShape): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TopTools_SequenceOfShape): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TopoDS_Shape): void;
  Split(theIndex: Standard_Integer, theSeq: TopTools_SequenceOfShape): void;
  First(): TopoDS_Shape;
  ChangeFirst(): TopoDS_Shape;
  Last(): TopoDS_Shape;
  ChangeLast(): TopoDS_Shape;
  Value(theIndex: Standard_Integer): TopoDS_Shape;
  ChangeValue(theIndex: Standard_Integer): TopoDS_Shape;
  SetValue(theIndex: Standard_Integer, theItem: TopoDS_Shape): void;
  delete(): void;
}

  export declare class TopTools_SequenceOfShape_1 extends TopTools_SequenceOfShape {
    constructor();
  }

  export declare class TopTools_SequenceOfShape_2 extends TopTools_SequenceOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_SequenceOfShape_3 extends TopTools_SequenceOfShape {
    constructor(theOther: TopTools_SequenceOfShape);
  }

export declare class TopTools_DataMapOfShapeListOfInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeListOfInteger): void;
  Assign(theOther: TopTools_DataMapOfShapeListOfInteger): TopTools_DataMapOfShapeListOfInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TColStd_ListOfInteger): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TColStd_ListOfInteger): TColStd_ListOfInteger;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TColStd_ListOfInteger;
  ChangeSeek(theKey: TopoDS_Shape): TColStd_ListOfInteger;
  ChangeFind(theKey: TopoDS_Shape): TColStd_ListOfInteger;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeListOfInteger_1 extends TopTools_DataMapOfShapeListOfInteger {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeListOfInteger_2 extends TopTools_DataMapOfShapeListOfInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeListOfInteger_3 extends TopTools_DataMapOfShapeListOfInteger {
    constructor(theOther: TopTools_DataMapOfShapeListOfInteger);
  }

export declare class TopTools_DataMapOfOrientedShapeShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfOrientedShapeShape): void;
  Assign(theOther: TopTools_DataMapOfOrientedShapeShape): TopTools_DataMapOfOrientedShapeShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopoDS_Shape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopoDS_Shape): TopoDS_Shape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopoDS_Shape;
  ChangeSeek(theKey: TopoDS_Shape): TopoDS_Shape;
  ChangeFind(theKey: TopoDS_Shape): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfOrientedShapeShape_1 extends TopTools_DataMapOfOrientedShapeShape {
    constructor();
  }

  export declare class TopTools_DataMapOfOrientedShapeShape_2 extends TopTools_DataMapOfOrientedShapeShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfOrientedShapeShape_3 extends TopTools_DataMapOfOrientedShapeShape {
    constructor(theOther: TopTools_DataMapOfOrientedShapeShape);
  }

export declare class TopTools_IndexedDataMapOfShapeListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_IndexedDataMapOfShapeListOfShape): void;
  Assign(theOther: TopTools_IndexedDataMapOfShapeListOfShape): TopTools_IndexedDataMapOfShapeListOfShape;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopTools_ListOfShape): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopTools_ListOfShape): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopTools_ListOfShape;
  ChangeFromIndex(theIndex: Standard_Integer): TopTools_ListOfShape;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopTools_ListOfShape;
  Seek(theKey1: TopoDS_Shape): TopTools_ListOfShape;
  ChangeSeek(theKey1: TopoDS_Shape): TopTools_ListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_IndexedDataMapOfShapeListOfShape_1 extends TopTools_IndexedDataMapOfShapeListOfShape {
    constructor();
  }

  export declare class TopTools_IndexedDataMapOfShapeListOfShape_2 extends TopTools_IndexedDataMapOfShapeListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_IndexedDataMapOfShapeListOfShape_3 extends TopTools_IndexedDataMapOfShapeListOfShape {
    constructor(theOther: TopTools_IndexedDataMapOfShapeListOfShape);
  }

export declare class TopTools_DataMapOfIntegerListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopTools_ListOfShape, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopTools_ListOfShape, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopTools_ListOfShape): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopTools_ListOfShape): TopTools_ListOfShape;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopTools_ListOfShape;
  ChangeSeek(theKey: Standard_Integer): TopTools_ListOfShape;
  ChangeFind(theKey: Standard_Integer): TopTools_ListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfIntegerListOfShape_1 extends TopTools_DataMapOfIntegerListOfShape {
    constructor();
  }

  export declare class TopTools_DataMapOfIntegerListOfShape_2 extends TopTools_DataMapOfIntegerListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfIntegerListOfShape_3 extends TopTools_DataMapOfIntegerListOfShape {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopTools_ListOfShape, TColStd_MapIntegerHasher>);
  }

export declare class TopTools_ListOfListOfShape extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TopTools_ListOfListOfShape): TopTools_ListOfListOfShape;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TopTools_ListOfShape;
  First_2(): TopTools_ListOfShape;
  Last_1(): TopTools_ListOfShape;
  Last_2(): TopTools_ListOfShape;
  Append_1(theItem: TopTools_ListOfShape): TopTools_ListOfShape;
  Append_3(theOther: TopTools_ListOfListOfShape): void;
  Prepend_1(theItem: TopTools_ListOfShape): TopTools_ListOfShape;
  Prepend_2(theOther: TopTools_ListOfListOfShape): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TopTools_ListOfListOfShape_1 extends TopTools_ListOfListOfShape {
    constructor();
  }

  export declare class TopTools_ListOfListOfShape_2 extends TopTools_ListOfListOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_ListOfListOfShape_3 extends TopTools_ListOfListOfShape {
    constructor(theOther: TopTools_ListOfListOfShape);
  }

export declare class TopTools_LocationSet {
  constructor()
  Clear(): void;
  Add(L: TopLoc_Location): Graphic3d_ZLayerId;
  Location(I: Graphic3d_ZLayerId): TopLoc_Location;
  Index(L: TopLoc_Location): Graphic3d_ZLayerId;
  Dump(OS: Standard_OStream): void;
  Write(OS: Standard_OStream, theProgress: Message_ProgressRange): void;
  Read(IS: Standard_IStream, theProgress: Message_ProgressRange): void;
  delete(): void;
}

export declare class TopTools_DataMapOfShapeInteger extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_DataMapOfShapeInteger): void;
  Assign(theOther: TopTools_DataMapOfShapeInteger): TopTools_DataMapOfShapeInteger;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Standard_Integer;
  ChangeSeek(theKey: TopoDS_Shape): Standard_Integer;
  ChangeFind(theKey: TopoDS_Shape): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfShapeInteger_1 extends TopTools_DataMapOfShapeInteger {
    constructor();
  }

  export declare class TopTools_DataMapOfShapeInteger_2 extends TopTools_DataMapOfShapeInteger {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfShapeInteger_3 extends TopTools_DataMapOfShapeInteger {
    constructor(theOther: TopTools_DataMapOfShapeInteger);
  }

export declare class TopTools_DataMapOfIntegerShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, TopoDS_Shape, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, TopoDS_Shape, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: TopoDS_Shape): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: TopoDS_Shape): TopoDS_Shape;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): TopoDS_Shape;
  ChangeSeek(theKey: Standard_Integer): TopoDS_Shape;
  ChangeFind(theKey: Standard_Integer): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_DataMapOfIntegerShape_1 extends TopTools_DataMapOfIntegerShape {
    constructor();
  }

  export declare class TopTools_DataMapOfIntegerShape_2 extends TopTools_DataMapOfIntegerShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_DataMapOfIntegerShape_3 extends TopTools_DataMapOfIntegerShape {
    constructor(theOther: NCollection_DataMap<Standard_Integer, TopoDS_Shape, TColStd_MapIntegerHasher>);
  }

export declare class TopTools_IndexedDataMapOfShapeAddress extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_IndexedDataMapOfShapeAddress): void;
  Assign(theOther: TopTools_IndexedDataMapOfShapeAddress): TopTools_IndexedDataMapOfShapeAddress;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: Standard_Address): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: Standard_Address): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): Standard_Address;
  ChangeFromIndex(theIndex: Standard_Integer): Standard_Address;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): Standard_Address;
  Seek(theKey1: TopoDS_Shape): Standard_Address;
  ChangeSeek(theKey1: TopoDS_Shape): Standard_Address;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_IndexedDataMapOfShapeAddress_1 extends TopTools_IndexedDataMapOfShapeAddress {
    constructor();
  }

  export declare class TopTools_IndexedDataMapOfShapeAddress_2 extends TopTools_IndexedDataMapOfShapeAddress {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_IndexedDataMapOfShapeAddress_3 extends TopTools_IndexedDataMapOfShapeAddress {
    constructor(theOther: TopTools_IndexedDataMapOfShapeAddress);
  }

export declare class TopTools_IndexedDataMapOfShapeReal extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TopTools_IndexedDataMapOfShapeReal): void;
  Assign(theOther: TopTools_IndexedDataMapOfShapeReal): TopTools_IndexedDataMapOfShapeReal;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: Standard_Real): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: Standard_Real): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): Standard_Real;
  ChangeFromIndex(theIndex: Standard_Integer): Standard_Real;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): Standard_Real;
  Seek(theKey1: TopoDS_Shape): Standard_Real;
  ChangeSeek(theKey1: TopoDS_Shape): Standard_Real;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopTools_IndexedDataMapOfShapeReal_1 extends TopTools_IndexedDataMapOfShapeReal {
    constructor();
  }

  export declare class TopTools_IndexedDataMapOfShapeReal_2 extends TopTools_IndexedDataMapOfShapeReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopTools_IndexedDataMapOfShapeReal_3 extends TopTools_IndexedDataMapOfShapeReal {
    constructor(theOther: TopTools_IndexedDataMapOfShapeReal);
  }

export declare class RWStepAP214_RWAutoDesignDocumentReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignDocumentReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignDocumentReference): void;
  Share(ent: Handle_StepAP214_AutoDesignDocumentReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignActualDateAndTimeAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignActualDateAndTimeAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignActualDateAndTimeAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignActualDateAndTimeAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignActualDateAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignActualDateAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignActualDateAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignActualDateAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignPersonAndOrganizationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class Handle_RWStepAP214_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: RWStepAP214_GeneralModule): void;
  get(): RWStepAP214_GeneralModule;
  delete(): void;
}

  export declare class Handle_RWStepAP214_GeneralModule_1 extends Handle_RWStepAP214_GeneralModule {
    constructor();
  }

  export declare class Handle_RWStepAP214_GeneralModule_2 extends Handle_RWStepAP214_GeneralModule {
    constructor(thePtr: RWStepAP214_GeneralModule);
  }

  export declare class Handle_RWStepAP214_GeneralModule_3 extends Handle_RWStepAP214_GeneralModule {
    constructor(theHandle: Handle_RWStepAP214_GeneralModule);
  }

  export declare class Handle_RWStepAP214_GeneralModule_4 extends Handle_RWStepAP214_GeneralModule {
    constructor(theHandle: Handle_RWStepAP214_GeneralModule);
  }

export declare class RWStepAP214_RWAppliedDateAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedDateAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedDateAssignment): void;
  Share(ent: Handle_StepAP214_AppliedDateAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignDateAndPersonAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignDateAndPersonAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignDateAndPersonAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignDateAndPersonAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWClass {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_Class): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_Class): void;
  Share(ent: Handle_StepAP214_Class, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignSecurityClassificationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignSecurityClassificationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignSecurityClassificationAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignSecurityClassificationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignOrganizationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignOrganizationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignOrganizationAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignOrganizationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignPresentedItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignPresentedItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignPresentedItem): void;
  Share(ent: Handle_StepAP214_AutoDesignPresentedItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWRepItemGroup {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_RepItemGroup): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_RepItemGroup): void;
  Share(ent: Handle_StepAP214_RepItemGroup, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignNominalDateAndTimeAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedGroupAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedGroupAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedGroupAssignment): void;
  Share(ent: Handle_StepAP214_AppliedGroupAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedPersonAndOrganizationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedPersonAndOrganizationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedPersonAndOrganizationAssignment): void;
  Share(ent: Handle_StepAP214_AppliedPersonAndOrganizationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignNominalDateAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignNominalDateAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignNominalDateAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignNominalDateAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedDocumentReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedDocumentReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedDocumentReference): void;
  Share(ent: Handle_StepAP214_AppliedDocumentReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWExternallyDefinedClass {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_ExternallyDefinedClass): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_ExternallyDefinedClass): void;
  Share(ent: Handle_StepAP214_ExternallyDefinedClass, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWExternallyDefinedGeneralProperty {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_ExternallyDefinedGeneralProperty): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_ExternallyDefinedGeneralProperty): void;
  Share(ent: Handle_StepAP214_ExternallyDefinedGeneralProperty, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignGroupAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignGroupAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignGroupAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignGroupAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAutoDesignApprovalAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AutoDesignApprovalAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AutoDesignApprovalAssignment): void;
  Share(ent: Handle_StepAP214_AutoDesignApprovalAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214 {
  constructor();
  static Init(): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedExternalIdentificationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedExternalIdentificationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedExternalIdentificationAssignment): void;
  Share(ent: Handle_StepAP214_AppliedExternalIdentificationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedApprovalAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedApprovalAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedApprovalAssignment): void;
  Share(ent: Handle_StepAP214_AppliedApprovalAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedDateAndTimeAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedDateAndTimeAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedDateAndTimeAssignment): void;
  Share(ent: Handle_StepAP214_AppliedDateAndTimeAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedSecurityClassificationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedSecurityClassificationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedSecurityClassificationAssignment): void;
  Share(ent: Handle_StepAP214_AppliedSecurityClassificationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedOrganizationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedOrganizationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedOrganizationAssignment): void;
  Share(ent: Handle_StepAP214_AppliedOrganizationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class Handle_RWStepAP214_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: RWStepAP214_ReadWriteModule): void;
  get(): RWStepAP214_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_RWStepAP214_ReadWriteModule_1 extends Handle_RWStepAP214_ReadWriteModule {
    constructor();
  }

  export declare class Handle_RWStepAP214_ReadWriteModule_2 extends Handle_RWStepAP214_ReadWriteModule {
    constructor(thePtr: RWStepAP214_ReadWriteModule);
  }

  export declare class Handle_RWStepAP214_ReadWriteModule_3 extends Handle_RWStepAP214_ReadWriteModule {
    constructor(theHandle: Handle_RWStepAP214_ReadWriteModule);
  }

  export declare class Handle_RWStepAP214_ReadWriteModule_4 extends Handle_RWStepAP214_ReadWriteModule {
    constructor(theHandle: Handle_RWStepAP214_ReadWriteModule);
  }

export declare class RWStepAP214_ReadWriteModule extends StepData_ReadWriteModule {
  constructor()
  CaseStep_1(atype: XCAFDoc_PartId): Graphic3d_ZLayerId;
  CaseStep_2(types: TColStd_SequenceOfAsciiString): Graphic3d_ZLayerId;
  IsComplex(CN: Graphic3d_ZLayerId): Standard_Boolean;
  StepType(CN: Graphic3d_ZLayerId): XCAFDoc_PartId;
  ComplexType(CN: Graphic3d_ZLayerId, types: TColStd_SequenceOfAsciiString): Standard_Boolean;
  ReadStep(CN: Graphic3d_ZLayerId, data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): void;
  WriteStep(CN: Graphic3d_ZLayerId, SW: StepData_StepWriter, ent: Handle_Standard_Transient): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class RWStepAP214_RWAppliedPresentedItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP214_AppliedPresentedItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP214_AppliedPresentedItem): void;
  Share(ent: Handle_StepAP214_AppliedPresentedItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class BRepFill_Evolved {
  Perform_1(Spine: TopoDS_Wire, Profile: TopoDS_Wire, AxeProf: gp_Ax3, Join: GeomAbs_JoinType, Solid: Standard_Boolean): void;
  Perform_2(Spine: TopoDS_Face, Profile: TopoDS_Wire, AxeProf: gp_Ax3, Join: GeomAbs_JoinType, Solid: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  GeneratedShapes(SpineShape: TopoDS_Shape, ProfShape: TopoDS_Shape): TopTools_ListOfShape;
  JoinType(): GeomAbs_JoinType;
  Top(): TopoDS_Shape;
  Bottom(): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepFill_Evolved_1 extends BRepFill_Evolved {
    constructor();
  }

  export declare class BRepFill_Evolved_2 extends BRepFill_Evolved {
    constructor(Spine: TopoDS_Wire, Profile: TopoDS_Wire, AxeProf: gp_Ax3, Join: GeomAbs_JoinType, Solid: Standard_Boolean);
  }

  export declare class BRepFill_Evolved_3 extends BRepFill_Evolved {
    constructor(Spine: TopoDS_Face, Profile: TopoDS_Wire, AxeProf: gp_Ax3, Join: GeomAbs_JoinType, Solid: Standard_Boolean);
  }

export declare class BRepFill_CompatibleWires {
  Init(Sections: TopTools_SequenceOfShape): void;
  SetPercent(percent: Quantity_AbsorbedDose): void;
  Perform(WithRotation: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Shape(): TopTools_SequenceOfShape;
  GeneratedShapes(SubSection: TopoDS_Edge): TopTools_ListOfShape;
  Generated(): TopTools_DataMapOfShapeListOfShape;
  IsDegeneratedFirstSection(): Standard_Boolean;
  IsDegeneratedLastSection(): Standard_Boolean;
  delete(): void;
}

  export declare class BRepFill_CompatibleWires_1 extends BRepFill_CompatibleWires {
    constructor();
  }

  export declare class BRepFill_CompatibleWires_2 extends BRepFill_CompatibleWires {
    constructor(Sections: TopTools_SequenceOfShape);
  }

export declare class BRepFill_Draft {
  constructor(Shape: TopoDS_Shape, Dir: gp_Dir, Angle: Quantity_AbsorbedDose)
  SetOptions(Style: BRepFill_TransitionStyle, AngleMin: Quantity_AbsorbedDose, AngleMax: Quantity_AbsorbedDose): void;
  SetDraft(IsInternal: Standard_Boolean): void;
  Perform_1(LengthMax: Quantity_AbsorbedDose): void;
  Perform_2(Surface: Handle_Geom_Surface, KeepInsideSurface: Standard_Boolean): void;
  Perform_3(StopShape: TopoDS_Shape, KeepOutSide: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  Shell(): TopoDS_Shell;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  Shape(): TopoDS_Shape;
  delete(): void;
}

export declare class BRepFill_IndexedDataMapOfOrientedShapeListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepFill_IndexedDataMapOfOrientedShapeListOfShape): void;
  Assign(theOther: BRepFill_IndexedDataMapOfOrientedShapeListOfShape): BRepFill_IndexedDataMapOfOrientedShapeListOfShape;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: TopTools_ListOfShape): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: TopTools_ListOfShape): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): TopTools_ListOfShape;
  ChangeFromIndex(theIndex: Standard_Integer): TopTools_ListOfShape;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): TopTools_ListOfShape;
  Seek(theKey1: TopoDS_Shape): TopTools_ListOfShape;
  ChangeSeek(theKey1: TopoDS_Shape): TopTools_ListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepFill_IndexedDataMapOfOrientedShapeListOfShape_1 extends BRepFill_IndexedDataMapOfOrientedShapeListOfShape {
    constructor();
  }

  export declare class BRepFill_IndexedDataMapOfOrientedShapeListOfShape_2 extends BRepFill_IndexedDataMapOfOrientedShapeListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_IndexedDataMapOfOrientedShapeListOfShape_3 extends BRepFill_IndexedDataMapOfOrientedShapeListOfShape {
    constructor(theOther: BRepFill_IndexedDataMapOfOrientedShapeListOfShape);
  }

export declare class BRepFill_Filling {
  constructor(Degree: Graphic3d_ZLayerId, NbPtsOnCur: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Anisotropie: Standard_Boolean, Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose, MaxDeg: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId)
  SetConstrParam(Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose): void;
  SetResolParam(Degree: Graphic3d_ZLayerId, NbPtsOnCur: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Anisotropie: Standard_Boolean): void;
  SetApproxParam(MaxDeg: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId): void;
  LoadInitSurface(aFace: TopoDS_Face): void;
  Add_1(anEdge: TopoDS_Edge, Order: GeomAbs_Shape, IsBound: Standard_Boolean): Graphic3d_ZLayerId;
  Add_2(anEdge: TopoDS_Edge, Support: TopoDS_Face, Order: GeomAbs_Shape, IsBound: Standard_Boolean): Graphic3d_ZLayerId;
  Add_3(Support: TopoDS_Face, Order: GeomAbs_Shape): Graphic3d_ZLayerId;
  Add_4(Point: gp_Pnt): Graphic3d_ZLayerId;
  Add_5(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Support: TopoDS_Face, Order: GeomAbs_Shape): Graphic3d_ZLayerId;
  Build(): void;
  IsDone(): Standard_Boolean;
  Face(): TopoDS_Face;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  G0Error_1(): Quantity_AbsorbedDose;
  G1Error_1(): Quantity_AbsorbedDose;
  G2Error_1(): Quantity_AbsorbedDose;
  G0Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  G1Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  G2Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepFill_EdgeFaceAndOrder {
  delete(): void;
}

  export declare class BRepFill_EdgeFaceAndOrder_1 extends BRepFill_EdgeFaceAndOrder {
    constructor();
  }

  export declare class BRepFill_EdgeFaceAndOrder_2 extends BRepFill_EdgeFaceAndOrder {
    constructor(anEdge: TopoDS_Edge, aFace: TopoDS_Face, anOrder: GeomAbs_Shape);
  }

export declare class BRepFill_ListOfOffsetWire extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BRepFill_ListOfOffsetWire): BRepFill_ListOfOffsetWire;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BRepFill_OffsetWire;
  First_2(): BRepFill_OffsetWire;
  Last_1(): BRepFill_OffsetWire;
  Last_2(): BRepFill_OffsetWire;
  Append_1(theItem: BRepFill_OffsetWire): BRepFill_OffsetWire;
  Append_3(theOther: BRepFill_ListOfOffsetWire): void;
  Prepend_1(theItem: BRepFill_OffsetWire): BRepFill_OffsetWire;
  Prepend_2(theOther: BRepFill_ListOfOffsetWire): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BRepFill_ListOfOffsetWire_1 extends BRepFill_ListOfOffsetWire {
    constructor();
  }

  export declare class BRepFill_ListOfOffsetWire_2 extends BRepFill_ListOfOffsetWire {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_ListOfOffsetWire_3 extends BRepFill_ListOfOffsetWire {
    constructor(theOther: BRepFill_ListOfOffsetWire);
  }

export declare class Handle_BRepFill_SectionLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_SectionLaw): void;
  get(): BRepFill_SectionLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_SectionLaw_1 extends Handle_BRepFill_SectionLaw {
    constructor();
  }

  export declare class Handle_BRepFill_SectionLaw_2 extends Handle_BRepFill_SectionLaw {
    constructor(thePtr: BRepFill_SectionLaw);
  }

  export declare class Handle_BRepFill_SectionLaw_3 extends Handle_BRepFill_SectionLaw {
    constructor(theHandle: Handle_BRepFill_SectionLaw);
  }

  export declare class Handle_BRepFill_SectionLaw_4 extends Handle_BRepFill_SectionLaw {
    constructor(theHandle: Handle_BRepFill_SectionLaw);
  }

export declare class BRepFill_SectionLaw extends Standard_Transient {
  NbLaw(): Graphic3d_ZLayerId;
  Law(Index: Graphic3d_ZLayerId): Handle_GeomFill_SectionLaw;
  IndexOfEdge(anEdge: TopoDS_Shape): Graphic3d_ZLayerId;
  IsConstant(): Standard_Boolean;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsDone(): Standard_Boolean;
  IsVertex(): Standard_Boolean;
  ConcatenedLaw(): Handle_GeomFill_SectionLaw;
  Continuity(Index: Graphic3d_ZLayerId, TolAngular: Quantity_AbsorbedDose): GeomAbs_Shape;
  VertexTol(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Vertex(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): TopoDS_Vertex;
  D0(U: Quantity_AbsorbedDose, S: TopoDS_Shape): void;
  Init(W: TopoDS_Wire): void;
  CurrentEdge(): TopoDS_Edge;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepFill_ShapeLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_ShapeLaw): void;
  get(): BRepFill_ShapeLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_ShapeLaw_1 extends Handle_BRepFill_ShapeLaw {
    constructor();
  }

  export declare class Handle_BRepFill_ShapeLaw_2 extends Handle_BRepFill_ShapeLaw {
    constructor(thePtr: BRepFill_ShapeLaw);
  }

  export declare class Handle_BRepFill_ShapeLaw_3 extends Handle_BRepFill_ShapeLaw {
    constructor(theHandle: Handle_BRepFill_ShapeLaw);
  }

  export declare class Handle_BRepFill_ShapeLaw_4 extends Handle_BRepFill_ShapeLaw {
    constructor(theHandle: Handle_BRepFill_ShapeLaw);
  }

export declare class BRepFill_ShapeLaw extends BRepFill_SectionLaw {
  IsVertex(): Standard_Boolean;
  IsConstant(): Standard_Boolean;
  ConcatenedLaw(): Handle_GeomFill_SectionLaw;
  Continuity(Index: Graphic3d_ZLayerId, TolAngular: Quantity_AbsorbedDose): GeomAbs_Shape;
  VertexTol(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Vertex(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): TopoDS_Vertex;
  D0(Param: Quantity_AbsorbedDose, S: TopoDS_Shape): void;
  Edge(Index: Graphic3d_ZLayerId): TopoDS_Edge;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepFill_ShapeLaw_1 extends BRepFill_ShapeLaw {
    constructor(V: TopoDS_Vertex, Build: Standard_Boolean);
  }

  export declare class BRepFill_ShapeLaw_2 extends BRepFill_ShapeLaw {
    constructor(W: TopoDS_Wire, Build: Standard_Boolean);
  }

  export declare class BRepFill_ShapeLaw_3 extends BRepFill_ShapeLaw {
    constructor(W: TopoDS_Wire, L: Handle_Law_Function, Build: Standard_Boolean);
  }

export declare class BRepFill_DataMapOfShapeDataMapOfShapeListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepFill_DataMapOfShapeDataMapOfShapeListOfShape): void;
  Assign(theOther: BRepFill_DataMapOfShapeDataMapOfShapeListOfShape): BRepFill_DataMapOfShapeDataMapOfShapeListOfShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopTools_DataMapOfShapeListOfShape): TopTools_DataMapOfShapeListOfShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopTools_DataMapOfShapeListOfShape;
  ChangeSeek(theKey: TopoDS_Shape): TopTools_DataMapOfShapeListOfShape;
  ChangeFind(theKey: TopoDS_Shape): TopTools_DataMapOfShapeListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_1 extends BRepFill_DataMapOfShapeDataMapOfShapeListOfShape {
    constructor();
  }

  export declare class BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_2 extends BRepFill_DataMapOfShapeDataMapOfShapeListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_3 extends BRepFill_DataMapOfShapeDataMapOfShapeListOfShape {
    constructor(theOther: BRepFill_DataMapOfShapeDataMapOfShapeListOfShape);
  }

export declare class BRepFill_DataMapOfShapeSequenceOfPnt extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepFill_DataMapOfShapeSequenceOfPnt): void;
  Assign(theOther: BRepFill_DataMapOfShapeSequenceOfPnt): BRepFill_DataMapOfShapeSequenceOfPnt;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TColgp_SequenceOfPnt): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TColgp_SequenceOfPnt): TColgp_SequenceOfPnt;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TColgp_SequenceOfPnt;
  ChangeSeek(theKey: TopoDS_Shape): TColgp_SequenceOfPnt;
  ChangeFind(theKey: TopoDS_Shape): TColgp_SequenceOfPnt;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepFill_DataMapOfShapeSequenceOfPnt_1 extends BRepFill_DataMapOfShapeSequenceOfPnt {
    constructor();
  }

  export declare class BRepFill_DataMapOfShapeSequenceOfPnt_2 extends BRepFill_DataMapOfShapeSequenceOfPnt {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_DataMapOfShapeSequenceOfPnt_3 extends BRepFill_DataMapOfShapeSequenceOfPnt {
    constructor(theOther: BRepFill_DataMapOfShapeSequenceOfPnt);
  }

export declare class Handle_BRepFill_ACRLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_ACRLaw): void;
  get(): BRepFill_ACRLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_ACRLaw_1 extends Handle_BRepFill_ACRLaw {
    constructor();
  }

  export declare class Handle_BRepFill_ACRLaw_2 extends Handle_BRepFill_ACRLaw {
    constructor(thePtr: BRepFill_ACRLaw);
  }

  export declare class Handle_BRepFill_ACRLaw_3 extends Handle_BRepFill_ACRLaw {
    constructor(theHandle: Handle_BRepFill_ACRLaw);
  }

  export declare class Handle_BRepFill_ACRLaw_4 extends Handle_BRepFill_ACRLaw {
    constructor(theHandle: Handle_BRepFill_ACRLaw);
  }

export declare class BRepFill_ACRLaw extends BRepFill_LocationLaw {
  constructor(Path: TopoDS_Wire, Law: Handle_GeomFill_LocationGuide)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepFill_Pipe {
  Perform(Spine: TopoDS_Wire, Profile: TopoDS_Shape, GeneratePartCase: Standard_Boolean): void;
  Spine(): TopoDS_Shape;
  Profile(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  ErrorOnSurface(): Quantity_AbsorbedDose;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Generated(S: TopoDS_Shape, L: TopTools_ListOfShape): void;
  Face(ESpine: TopoDS_Edge, EProfile: TopoDS_Edge): TopoDS_Face;
  Edge(ESpine: TopoDS_Edge, VProfile: TopoDS_Vertex): TopoDS_Edge;
  Section(VSpine: TopoDS_Vertex): TopoDS_Shape;
  PipeLine(Point: gp_Pnt): TopoDS_Wire;
  delete(): void;
}

  export declare class BRepFill_Pipe_1 extends BRepFill_Pipe {
    constructor();
  }

  export declare class BRepFill_Pipe_2 extends BRepFill_Pipe {
    constructor(Spine: TopoDS_Wire, Profile: TopoDS_Shape, aMode: GeomFill_Trihedron, ForceApproxC1: Standard_Boolean, GeneratePartCase: Standard_Boolean);
  }

export declare class BRepFill_SectionPlacement {
  Transformation(): gp_Trsf;
  AbscissaOnPath(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepFill_SectionPlacement_1 extends BRepFill_SectionPlacement {
    constructor(Law: Handle_BRepFill_LocationLaw, Section: TopoDS_Shape, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean);
  }

  export declare class BRepFill_SectionPlacement_2 extends BRepFill_SectionPlacement {
    constructor(Law: Handle_BRepFill_LocationLaw, Section: TopoDS_Shape, Vertex: TopoDS_Shape, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean);
  }

export declare class BRepFill_ComputeCLine {
  Perform(Line: BRepFill_MultiLine): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetConstraints(FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint): void;
  SetMaxSegments(theMaxSegments: Graphic3d_ZLayerId): void;
  SetInvOrder(theInvOrder: Standard_Boolean): void;
  SetHangChecking(theHangChecking: Standard_Boolean): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(Index: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  Parameters(Index: Graphic3d_ZLayerId, firstp: Quantity_AbsorbedDose, lastp: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class BRepFill_ComputeCLine_1 extends BRepFill_ComputeCLine {
    constructor(Line: BRepFill_MultiLine, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, cutting: Standard_Boolean, FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint);
  }

  export declare class BRepFill_ComputeCLine_2 extends BRepFill_ComputeCLine {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, cutting: Standard_Boolean, FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint);
  }

export declare class BRepFill_AdvancedEvolved {
  constructor()
  Perform(theSpine: TopoDS_Wire, theProfile: TopoDS_Wire, theTolerance: Quantity_AbsorbedDose, theSolidReq: Standard_Boolean): void;
  IsDone(theErrorCode: Aspect_VKeyFlags): Standard_Boolean;
  Shape(): TopoDS_Shape;
  SetTemporaryDirectory(thePath: Standard_CString): void;
  SetParallelMode(theVal: Standard_Boolean): void;
  delete(): void;
}

export declare class BRepFill_TrimShellCorner {
  constructor(theFaces: Handle_TopTools_HArray2OfShape, theTransition: BRepFill_TransitionStyle, theAxeOfBisPlane: gp_Ax2)
  AddBounds(Bounds: Handle_TopTools_HArray2OfShape): void;
  AddUEdges(theUEdges: Handle_TopTools_HArray2OfShape): void;
  AddVEdges(theVEdges: Handle_TopTools_HArray2OfShape, theIndex: Graphic3d_ZLayerId): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  HasSection(): Standard_Boolean;
  Modified(S: TopoDS_Shape, theModified: TopTools_ListOfShape): void;
  delete(): void;
}

export declare class BRepFill_CurveConstraint extends GeomPlate_CurveConstraint {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepFill_CurveConstraint_1 extends BRepFill_CurveConstraint {
    constructor(Boundary: Handle_Adaptor3d_HCurveOnSurface, Order: Graphic3d_ZLayerId, NPt: Graphic3d_ZLayerId, TolDist: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose);
  }

  export declare class BRepFill_CurveConstraint_2 extends BRepFill_CurveConstraint {
    constructor(Boundary: Handle_Adaptor3d_HCurve, Tang: Graphic3d_ZLayerId, NPt: Graphic3d_ZLayerId, TolDist: Quantity_AbsorbedDose);
  }

export declare class Handle_BRepFill_CurveConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_CurveConstraint): void;
  get(): BRepFill_CurveConstraint;
  delete(): void;
}

  export declare class Handle_BRepFill_CurveConstraint_1 extends Handle_BRepFill_CurveConstraint {
    constructor();
  }

  export declare class Handle_BRepFill_CurveConstraint_2 extends Handle_BRepFill_CurveConstraint {
    constructor(thePtr: BRepFill_CurveConstraint);
  }

  export declare class Handle_BRepFill_CurveConstraint_3 extends Handle_BRepFill_CurveConstraint {
    constructor(theHandle: Handle_BRepFill_CurveConstraint);
  }

  export declare class Handle_BRepFill_CurveConstraint_4 extends Handle_BRepFill_CurveConstraint {
    constructor(theHandle: Handle_BRepFill_CurveConstraint);
  }

export declare class BRepFill_SequenceOfSection extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepFill_SequenceOfSection): BRepFill_SequenceOfSection;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: BRepFill_Section): void;
  Append_2(theSeq: BRepFill_SequenceOfSection): void;
  Prepend_1(theItem: BRepFill_Section): void;
  Prepend_2(theSeq: BRepFill_SequenceOfSection): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: BRepFill_Section): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfSection): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfSection): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: BRepFill_Section): void;
  Split(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfSection): void;
  First(): BRepFill_Section;
  ChangeFirst(): BRepFill_Section;
  Last(): BRepFill_Section;
  ChangeLast(): BRepFill_Section;
  Value(theIndex: Standard_Integer): BRepFill_Section;
  ChangeValue(theIndex: Standard_Integer): BRepFill_Section;
  SetValue(theIndex: Standard_Integer, theItem: BRepFill_Section): void;
  delete(): void;
}

  export declare class BRepFill_SequenceOfSection_1 extends BRepFill_SequenceOfSection {
    constructor();
  }

  export declare class BRepFill_SequenceOfSection_2 extends BRepFill_SequenceOfSection {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_SequenceOfSection_3 extends BRepFill_SequenceOfSection {
    constructor(theOther: BRepFill_SequenceOfSection);
  }

export declare class BRepFill_Edge3DLaw extends BRepFill_LocationLaw {
  constructor(Path: TopoDS_Wire, Law: Handle_GeomFill_LocationLaw)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepFill_Edge3DLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_Edge3DLaw): void;
  get(): BRepFill_Edge3DLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_Edge3DLaw_1 extends Handle_BRepFill_Edge3DLaw {
    constructor();
  }

  export declare class Handle_BRepFill_Edge3DLaw_2 extends Handle_BRepFill_Edge3DLaw {
    constructor(thePtr: BRepFill_Edge3DLaw);
  }

  export declare class Handle_BRepFill_Edge3DLaw_3 extends Handle_BRepFill_Edge3DLaw {
    constructor(theHandle: Handle_BRepFill_Edge3DLaw);
  }

  export declare class Handle_BRepFill_Edge3DLaw_4 extends Handle_BRepFill_Edge3DLaw {
    constructor(theHandle: Handle_BRepFill_Edge3DLaw);
  }

export declare class BRepFill {
  constructor();
  static Face(Edge1: TopoDS_Edge, Edge2: TopoDS_Edge): TopoDS_Face;
  static Shell(Wire1: TopoDS_Wire, Wire2: TopoDS_Wire): TopoDS_Shell;
  static Axe(Spine: TopoDS_Shape, Profile: TopoDS_Wire, AxeProf: gp_Ax3, ProfOnSpine: Standard_Boolean, Tol: Quantity_AbsorbedDose): void;
  static ComputeACR(wire: TopoDS_Wire, ACR: TColStd_Array1OfReal): void;
  static InsertACR(wire: TopoDS_Wire, ACRcuts: TColStd_Array1OfReal, prec: Quantity_AbsorbedDose): TopoDS_Wire;
  delete(): void;
}

export declare class BRepFill_FaceAndOrder {
  delete(): void;
}

  export declare class BRepFill_FaceAndOrder_1 extends BRepFill_FaceAndOrder {
    constructor();
  }

  export declare class BRepFill_FaceAndOrder_2 extends BRepFill_FaceAndOrder {
    constructor(aFace: TopoDS_Face, anOrder: GeomAbs_Shape);
  }

export declare class BRepFill_Sweep {
  constructor(Section: Handle_BRepFill_SectionLaw, Location: Handle_BRepFill_LocationLaw, WithKPart: Standard_Boolean)
  SetBounds(FirstShape: TopoDS_Wire, LastShape: TopoDS_Wire): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, BoundTol: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, TolAngular: Quantity_AbsorbedDose): void;
  SetAngularControl(AngleMin: Quantity_AbsorbedDose, AngleMax: Quantity_AbsorbedDose): void;
  SetForceApproxC1(ForceApproxC1: Standard_Boolean): void;
  Build(ReversedEdges: TopTools_MapOfShape, Tapes: BRepFill_DataMapOfShapeHArray2OfShape, Rails: BRepFill_DataMapOfShapeHArray2OfShape, Transition: BRepFill_TransitionStyle, Continuity: GeomAbs_Shape, Approx: GeomFill_ApproxStyle, Degmax: Graphic3d_ZLayerId, Segmax: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  ErrorOnSurface(): Quantity_AbsorbedDose;
  SubShape(): Handle_TopTools_HArray2OfShape;
  InterFaces(): Handle_TopTools_HArray2OfShape;
  Sections(): Handle_TopTools_HArray2OfShape;
  Tape(Index: Graphic3d_ZLayerId): TopoDS_Shape;
  delete(): void;
}

export declare class BRepFill_Generator {
  constructor()
  AddWire(Wire: TopoDS_Wire): void;
  Perform(): void;
  Shell(): TopoDS_Shell;
  Generated(): TopTools_DataMapOfShapeListOfShape;
  GeneratedShapes(SSection: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

export declare class BRepFill_SequenceOfEdgeFaceAndOrder extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepFill_SequenceOfEdgeFaceAndOrder): BRepFill_SequenceOfEdgeFaceAndOrder;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: BRepFill_EdgeFaceAndOrder): void;
  Append_2(theSeq: BRepFill_SequenceOfEdgeFaceAndOrder): void;
  Prepend_1(theItem: BRepFill_EdgeFaceAndOrder): void;
  Prepend_2(theSeq: BRepFill_SequenceOfEdgeFaceAndOrder): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: BRepFill_EdgeFaceAndOrder): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfEdgeFaceAndOrder): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfEdgeFaceAndOrder): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: BRepFill_EdgeFaceAndOrder): void;
  Split(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfEdgeFaceAndOrder): void;
  First(): BRepFill_EdgeFaceAndOrder;
  ChangeFirst(): BRepFill_EdgeFaceAndOrder;
  Last(): BRepFill_EdgeFaceAndOrder;
  ChangeLast(): BRepFill_EdgeFaceAndOrder;
  Value(theIndex: Standard_Integer): BRepFill_EdgeFaceAndOrder;
  ChangeValue(theIndex: Standard_Integer): BRepFill_EdgeFaceAndOrder;
  SetValue(theIndex: Standard_Integer, theItem: BRepFill_EdgeFaceAndOrder): void;
  delete(): void;
}

  export declare class BRepFill_SequenceOfEdgeFaceAndOrder_1 extends BRepFill_SequenceOfEdgeFaceAndOrder {
    constructor();
  }

  export declare class BRepFill_SequenceOfEdgeFaceAndOrder_2 extends BRepFill_SequenceOfEdgeFaceAndOrder {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_SequenceOfEdgeFaceAndOrder_3 extends BRepFill_SequenceOfEdgeFaceAndOrder {
    constructor(theOther: BRepFill_SequenceOfEdgeFaceAndOrder);
  }

export declare class Handle_BRepFill_PipeShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_PipeShell): void;
  get(): BRepFill_PipeShell;
  delete(): void;
}

  export declare class Handle_BRepFill_PipeShell_1 extends Handle_BRepFill_PipeShell {
    constructor();
  }

  export declare class Handle_BRepFill_PipeShell_2 extends Handle_BRepFill_PipeShell {
    constructor(thePtr: BRepFill_PipeShell);
  }

  export declare class Handle_BRepFill_PipeShell_3 extends Handle_BRepFill_PipeShell {
    constructor(theHandle: Handle_BRepFill_PipeShell);
  }

  export declare class Handle_BRepFill_PipeShell_4 extends Handle_BRepFill_PipeShell {
    constructor(theHandle: Handle_BRepFill_PipeShell);
  }

export declare class BRepFill_PipeShell extends Standard_Transient {
  constructor(Spine: TopoDS_Wire)
  Set_1(Frenet: Standard_Boolean): void;
  SetDiscrete(): void;
  Set_2(Axe: gp_Ax2): void;
  Set_3(BiNormal: gp_Dir): void;
  Set_4(SpineSupport: TopoDS_Shape): Standard_Boolean;
  Set_5(AuxiliarySpine: TopoDS_Wire, CurvilinearEquivalence: Standard_Boolean, KeepContact: BRepFill_TypeOfContact): void;
  SetMaxDegree(NewMaxDegree: Graphic3d_ZLayerId): void;
  SetMaxSegments(NewMaxSegments: Graphic3d_ZLayerId): void;
  SetForceApproxC1(ForceApproxC1: Standard_Boolean): void;
  Add_1(Profile: TopoDS_Shape, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  Add_2(Profile: TopoDS_Shape, Location: TopoDS_Vertex, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  SetLaw_1(Profile: TopoDS_Shape, L: Handle_Law_Function, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  SetLaw_2(Profile: TopoDS_Shape, L: Handle_Law_Function, Location: TopoDS_Vertex, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  DeleteProfile(Profile: TopoDS_Shape): void;
  IsReady(): Standard_Boolean;
  GetStatus(): GeomFill_PipeError;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, BoundTol: Quantity_AbsorbedDose, TolAngular: Quantity_AbsorbedDose): void;
  SetTransition(Mode: BRepFill_TransitionStyle, Angmin: Quantity_AbsorbedDose, Angmax: Quantity_AbsorbedDose): void;
  Simulate(NumberOfSection: Graphic3d_ZLayerId, Sections: TopTools_ListOfShape): void;
  Build(): Standard_Boolean;
  MakeSolid(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  ErrorOnSurface(): Quantity_AbsorbedDose;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Profiles(theProfiles: TopTools_ListOfShape): void;
  Spine(): TopoDS_Wire;
  Generated(S: TopoDS_Shape, L: TopTools_ListOfShape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepFill_TrimSurfaceTool {
  constructor(Bis: Handle_Geom2d_Curve, Face1: TopoDS_Face, Face2: TopoDS_Face, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Inv1: Standard_Boolean, Inv2: Standard_Boolean)
  IntersectWith(EdgeOnF1: TopoDS_Edge, EdgeOnF2: TopoDS_Edge, Points: TColgp_SequenceOfPnt): void;
  IsOnFace(Point: gp_Pnt2d): Standard_Boolean;
  ProjOn(Point: gp_Pnt2d, Edge: TopoDS_Edge): Quantity_AbsorbedDose;
  Project(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Curve: Handle_Geom_Curve, PCurve1: Handle_Geom2d_Curve, PCurve2: Handle_Geom2d_Curve, myCont: GeomAbs_Shape): void;
  delete(): void;
}

export declare class BRepFill_ApproxSeewing {
  Perform(ML: BRepFill_MultiLine): void;
  IsDone(): Standard_Boolean;
  Curve(): Handle_Geom_Curve;
  CurveOnF1(): Handle_Geom2d_Curve;
  CurveOnF2(): Handle_Geom2d_Curve;
  delete(): void;
}

  export declare class BRepFill_ApproxSeewing_1 extends BRepFill_ApproxSeewing {
    constructor();
  }

  export declare class BRepFill_ApproxSeewing_2 extends BRepFill_ApproxSeewing {
    constructor(ML: BRepFill_MultiLine);
  }

export declare class BRepFill_MultiLine extends AppCont_Function {
  IsParticularCase(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Curves(Curve: Handle_Geom_Curve, PCurve1: Handle_Geom2d_Curve, PCurve2: Handle_Geom2d_Curve): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Value_1(U: Quantity_AbsorbedDose): gp_Pnt;
  ValueOnF1(U: Quantity_AbsorbedDose): gp_Pnt2d;
  ValueOnF2(U: Quantity_AbsorbedDose): gp_Pnt2d;
  Value3dOnF1OnF2(U: Quantity_AbsorbedDose, P3d: gp_Pnt, PF1: gp_Pnt2d, PF2: gp_Pnt2d): void;
  Value_2(theU: Quantity_AbsorbedDose, thePnt2d: TColgp_Array1OfPnt2d, thePnt: TColgp_Array1OfPnt): Standard_Boolean;
  D1(theU: Quantity_AbsorbedDose, theVec2d: TColgp_Array1OfVec2d, theVec: TColgp_Array1OfVec): Standard_Boolean;
  delete(): void;
}

  export declare class BRepFill_MultiLine_1 extends BRepFill_MultiLine {
    constructor();
  }

  export declare class BRepFill_MultiLine_2 extends BRepFill_MultiLine {
    constructor(Face1: TopoDS_Face, Face2: TopoDS_Face, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Inv1: Standard_Boolean, Inv2: Standard_Boolean, Bissec: Handle_Geom2d_Curve);
  }

export declare class BRepFill_OffsetWire {
  Init(Spine: TopoDS_Face, Join: GeomAbs_JoinType, IsOpenResult: Standard_Boolean): void;
  Perform(Offset: Quantity_AbsorbedDose, Alt: Quantity_AbsorbedDose): void;
  PerformWithBiLo(WSP: TopoDS_Face, Offset: Quantity_AbsorbedDose, Locus: BRepMAT2d_BisectingLocus, Link: BRepMAT2d_LinkTopoBilo, Join: GeomAbs_JoinType, Alt: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Spine(): TopoDS_Face;
  Shape(): TopoDS_Shape;
  GeneratedShapes(SpineShape: TopoDS_Shape): TopTools_ListOfShape;
  JoinType(): GeomAbs_JoinType;
  delete(): void;
}

  export declare class BRepFill_OffsetWire_1 extends BRepFill_OffsetWire {
    constructor();
  }

  export declare class BRepFill_OffsetWire_2 extends BRepFill_OffsetWire {
    constructor(Spine: TopoDS_Face, Join: GeomAbs_JoinType, IsOpenResult: Standard_Boolean);
  }

export declare class BRepFill_EdgeOnSurfLaw extends BRepFill_LocationLaw {
  constructor(Path: TopoDS_Wire, Surf: TopoDS_Shape)
  HasResult(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepFill_EdgeOnSurfLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_EdgeOnSurfLaw): void;
  get(): BRepFill_EdgeOnSurfLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_EdgeOnSurfLaw_1 extends Handle_BRepFill_EdgeOnSurfLaw {
    constructor();
  }

  export declare class Handle_BRepFill_EdgeOnSurfLaw_2 extends Handle_BRepFill_EdgeOnSurfLaw {
    constructor(thePtr: BRepFill_EdgeOnSurfLaw);
  }

  export declare class Handle_BRepFill_EdgeOnSurfLaw_3 extends Handle_BRepFill_EdgeOnSurfLaw {
    constructor(theHandle: Handle_BRepFill_EdgeOnSurfLaw);
  }

  export declare class Handle_BRepFill_EdgeOnSurfLaw_4 extends Handle_BRepFill_EdgeOnSurfLaw {
    constructor(theHandle: Handle_BRepFill_EdgeOnSurfLaw);
  }

export declare class BRepFill_TrimEdgeTool {
  IntersectWith(Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, InitShape1: TopoDS_Shape, InitShape2: TopoDS_Shape, End1: TopoDS_Vertex, End2: TopoDS_Vertex, theJoinType: GeomAbs_JoinType, IsOpenResult: Standard_Boolean, Params: TColgp_SequenceOfPnt): void;
  AddOrConfuse(Start: Standard_Boolean, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Params: TColgp_SequenceOfPnt): void;
  IsInside(P: gp_Pnt2d): Standard_Boolean;
  delete(): void;
}

  export declare class BRepFill_TrimEdgeTool_1 extends BRepFill_TrimEdgeTool {
    constructor();
  }

  export declare class BRepFill_TrimEdgeTool_2 extends BRepFill_TrimEdgeTool {
    constructor(Bisec: Bisector_Bisec, S1: Handle_Geom2d_Geometry, S2: Handle_Geom2d_Geometry, Offset: Quantity_AbsorbedDose);
  }

export declare type BRepFill_TypeOfContact = {
  BRepFill_NoContact: {};
  BRepFill_Contact: {};
  BRepFill_ContactOnBorder: {};
}

export declare class BRepFill_DataMapOfOrientedShapeListOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepFill_DataMapOfOrientedShapeListOfShape): void;
  Assign(theOther: BRepFill_DataMapOfOrientedShapeListOfShape): BRepFill_DataMapOfOrientedShapeListOfShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopTools_ListOfShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopTools_ListOfShape): TopTools_ListOfShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopTools_ListOfShape;
  ChangeSeek(theKey: TopoDS_Shape): TopTools_ListOfShape;
  ChangeFind(theKey: TopoDS_Shape): TopTools_ListOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepFill_DataMapOfOrientedShapeListOfShape_1 extends BRepFill_DataMapOfOrientedShapeListOfShape {
    constructor();
  }

  export declare class BRepFill_DataMapOfOrientedShapeListOfShape_2 extends BRepFill_DataMapOfOrientedShapeListOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_DataMapOfOrientedShapeListOfShape_3 extends BRepFill_DataMapOfOrientedShapeListOfShape {
    constructor(theOther: BRepFill_DataMapOfOrientedShapeListOfShape);
  }

export declare class BRepFill_SequenceOfFaceAndOrder extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepFill_SequenceOfFaceAndOrder): BRepFill_SequenceOfFaceAndOrder;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: BRepFill_FaceAndOrder): void;
  Append_2(theSeq: BRepFill_SequenceOfFaceAndOrder): void;
  Prepend_1(theItem: BRepFill_FaceAndOrder): void;
  Prepend_2(theSeq: BRepFill_SequenceOfFaceAndOrder): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: BRepFill_FaceAndOrder): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfFaceAndOrder): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfFaceAndOrder): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: BRepFill_FaceAndOrder): void;
  Split(theIndex: Standard_Integer, theSeq: BRepFill_SequenceOfFaceAndOrder): void;
  First(): BRepFill_FaceAndOrder;
  ChangeFirst(): BRepFill_FaceAndOrder;
  Last(): BRepFill_FaceAndOrder;
  ChangeLast(): BRepFill_FaceAndOrder;
  Value(theIndex: Standard_Integer): BRepFill_FaceAndOrder;
  ChangeValue(theIndex: Standard_Integer): BRepFill_FaceAndOrder;
  SetValue(theIndex: Standard_Integer, theItem: BRepFill_FaceAndOrder): void;
  delete(): void;
}

  export declare class BRepFill_SequenceOfFaceAndOrder_1 extends BRepFill_SequenceOfFaceAndOrder {
    constructor();
  }

  export declare class BRepFill_SequenceOfFaceAndOrder_2 extends BRepFill_SequenceOfFaceAndOrder {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_SequenceOfFaceAndOrder_3 extends BRepFill_SequenceOfFaceAndOrder {
    constructor(theOther: BRepFill_SequenceOfFaceAndOrder);
  }

export declare class BRepFill_DataMapOfShapeSequenceOfReal extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepFill_DataMapOfShapeSequenceOfReal): void;
  Assign(theOther: BRepFill_DataMapOfShapeSequenceOfReal): BRepFill_DataMapOfShapeSequenceOfReal;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TColStd_SequenceOfReal): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TColStd_SequenceOfReal): TColStd_SequenceOfReal;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TColStd_SequenceOfReal;
  ChangeSeek(theKey: TopoDS_Shape): TColStd_SequenceOfReal;
  ChangeFind(theKey: TopoDS_Shape): TColStd_SequenceOfReal;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepFill_DataMapOfShapeSequenceOfReal_1 extends BRepFill_DataMapOfShapeSequenceOfReal {
    constructor();
  }

  export declare class BRepFill_DataMapOfShapeSequenceOfReal_2 extends BRepFill_DataMapOfShapeSequenceOfReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepFill_DataMapOfShapeSequenceOfReal_3 extends BRepFill_DataMapOfShapeSequenceOfReal {
    constructor(theOther: BRepFill_DataMapOfShapeSequenceOfReal);
  }

export declare class BRepFill_OffsetAncestors {
  Perform(Paral: BRepFill_OffsetWire): void;
  IsDone(): Standard_Boolean;
  HasAncestor(S1: TopoDS_Edge): Standard_Boolean;
  Ancestor(S1: TopoDS_Edge): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepFill_OffsetAncestors_1 extends BRepFill_OffsetAncestors {
    constructor();
  }

  export declare class BRepFill_OffsetAncestors_2 extends BRepFill_OffsetAncestors {
    constructor(Paral: BRepFill_OffsetWire);
  }

export declare class Handle_BRepFill_DraftLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_DraftLaw): void;
  get(): BRepFill_DraftLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_DraftLaw_1 extends Handle_BRepFill_DraftLaw {
    constructor();
  }

  export declare class Handle_BRepFill_DraftLaw_2 extends Handle_BRepFill_DraftLaw {
    constructor(thePtr: BRepFill_DraftLaw);
  }

  export declare class Handle_BRepFill_DraftLaw_3 extends Handle_BRepFill_DraftLaw {
    constructor(theHandle: Handle_BRepFill_DraftLaw);
  }

  export declare class Handle_BRepFill_DraftLaw_4 extends Handle_BRepFill_DraftLaw {
    constructor(theHandle: Handle_BRepFill_DraftLaw);
  }

export declare class BRepFill_DraftLaw extends BRepFill_Edge3DLaw {
  constructor(Path: TopoDS_Wire, Law: Handle_GeomFill_LocationDraft)
  CleanLaw(TolAngular: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BRepFill_LocationLaw {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_LocationLaw): void;
  get(): BRepFill_LocationLaw;
  delete(): void;
}

  export declare class Handle_BRepFill_LocationLaw_1 extends Handle_BRepFill_LocationLaw {
    constructor();
  }

  export declare class Handle_BRepFill_LocationLaw_2 extends Handle_BRepFill_LocationLaw {
    constructor(thePtr: BRepFill_LocationLaw);
  }

  export declare class Handle_BRepFill_LocationLaw_3 extends Handle_BRepFill_LocationLaw {
    constructor(theHandle: Handle_BRepFill_LocationLaw);
  }

  export declare class Handle_BRepFill_LocationLaw_4 extends Handle_BRepFill_LocationLaw {
    constructor(theHandle: Handle_BRepFill_LocationLaw);
  }

export declare class BRepFill_LocationLaw extends Standard_Transient {
  constructor();
  GetStatus(): GeomFill_PipeError;
  TransformInG0Law(): void;
  TransformInCompatibleLaw(AngularTolerance: Quantity_AbsorbedDose): void;
  DeleteTransform(): void;
  NbHoles(Tol: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Holes(Interval: TColStd_Array1OfInteger): void;
  NbLaw(): Graphic3d_ZLayerId;
  Law(Index: Graphic3d_ZLayerId): Handle_GeomFill_LocationLaw;
  Wire(): TopoDS_Wire;
  Edge(Index: Graphic3d_ZLayerId): TopoDS_Edge;
  Vertex(Index: Graphic3d_ZLayerId): TopoDS_Vertex;
  PerformVertex(Index: Graphic3d_ZLayerId, InputVertex: TopoDS_Vertex, TolMin: Quantity_AbsorbedDose, OutputVertex: TopoDS_Vertex, Location: Graphic3d_ZLayerId): void;
  CurvilinearBounds(Index: Graphic3d_ZLayerId, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  IsClosed(): Standard_Boolean;
  IsG1(Index: Graphic3d_ZLayerId, SpatialTolerance: Quantity_AbsorbedDose, AngularTolerance: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  D0(Abscissa: Quantity_AbsorbedDose, Section: TopoDS_Shape): void;
  Parameter(Abscissa: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): void;
  Abscissa(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepFill_Section {
  Set(IsLaw: Standard_Boolean): void;
  OriginalShape(): TopoDS_Shape;
  Wire(): TopoDS_Wire;
  Vertex(): TopoDS_Vertex;
  ModifiedShape(theShape: TopoDS_Shape): TopoDS_Shape;
  IsLaw(): Standard_Boolean;
  IsPunctual(): Standard_Boolean;
  WithContact(): Standard_Boolean;
  WithCorrection(): Standard_Boolean;
  delete(): void;
}

  export declare class BRepFill_Section_1 extends BRepFill_Section {
    constructor();
  }

  export declare class BRepFill_Section_2 extends BRepFill_Section {
    constructor(Profile: TopoDS_Shape, V: TopoDS_Vertex, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean);
  }

export declare type BRepFill_TransitionStyle = {
  BRepFill_Modified: {};
  BRepFill_Right: {};
  BRepFill_Round: {};
}

export declare class Handle_BRepFill_NSections {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepFill_NSections): void;
  get(): BRepFill_NSections;
  delete(): void;
}

  export declare class Handle_BRepFill_NSections_1 extends Handle_BRepFill_NSections {
    constructor();
  }

  export declare class Handle_BRepFill_NSections_2 extends Handle_BRepFill_NSections {
    constructor(thePtr: BRepFill_NSections);
  }

  export declare class Handle_BRepFill_NSections_3 extends Handle_BRepFill_NSections {
    constructor(theHandle: Handle_BRepFill_NSections);
  }

  export declare class Handle_BRepFill_NSections_4 extends Handle_BRepFill_NSections {
    constructor(theHandle: Handle_BRepFill_NSections);
  }

export declare class BRepFill_NSections extends BRepFill_SectionLaw {
  IsVertex(): Standard_Boolean;
  IsConstant(): Standard_Boolean;
  ConcatenedLaw(): Handle_GeomFill_SectionLaw;
  Continuity(Index: Graphic3d_ZLayerId, TolAngular: Quantity_AbsorbedDose): GeomAbs_Shape;
  VertexTol(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Vertex(Index: Graphic3d_ZLayerId, Param: Quantity_AbsorbedDose): TopoDS_Vertex;
  D0(Param: Quantity_AbsorbedDose, S: TopoDS_Shape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepFill_NSections_1 extends BRepFill_NSections {
    constructor(S: TopTools_SequenceOfShape, Build: Standard_Boolean);
  }

  export declare class BRepFill_NSections_2 extends BRepFill_NSections {
    constructor(S: TopTools_SequenceOfShape, Trsfs: GeomFill_SequenceOfTrsf, P: TColStd_SequenceOfReal, VF: Quantity_AbsorbedDose, VL: Quantity_AbsorbedDose, Build: Standard_Boolean);
  }

export declare class Bnd_SeqOfBox extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: Bnd_SeqOfBox): Bnd_SeqOfBox;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: Bnd_Box): void;
  Append_2(theSeq: Bnd_SeqOfBox): void;
  Prepend_1(theItem: Bnd_Box): void;
  Prepend_2(theSeq: Bnd_SeqOfBox): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: Bnd_Box): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: Bnd_SeqOfBox): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: Bnd_SeqOfBox): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: Bnd_Box): void;
  Split(theIndex: Standard_Integer, theSeq: Bnd_SeqOfBox): void;
  First(): Bnd_Box;
  ChangeFirst(): Bnd_Box;
  Last(): Bnd_Box;
  ChangeLast(): Bnd_Box;
  Value(theIndex: Standard_Integer): Bnd_Box;
  ChangeValue(theIndex: Standard_Integer): Bnd_Box;
  SetValue(theIndex: Standard_Integer, theItem: Bnd_Box): void;
  delete(): void;
}

  export declare class Bnd_SeqOfBox_1 extends Bnd_SeqOfBox {
    constructor();
  }

  export declare class Bnd_SeqOfBox_2 extends Bnd_SeqOfBox {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Bnd_SeqOfBox_3 extends Bnd_SeqOfBox {
    constructor(theOther: Bnd_SeqOfBox);
  }

export declare class Handle_Bnd_HArray1OfBox2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bnd_HArray1OfBox2d): void;
  get(): Bnd_HArray1OfBox2d;
  delete(): void;
}

  export declare class Handle_Bnd_HArray1OfBox2d_1 extends Handle_Bnd_HArray1OfBox2d {
    constructor();
  }

  export declare class Handle_Bnd_HArray1OfBox2d_2 extends Handle_Bnd_HArray1OfBox2d {
    constructor(thePtr: Bnd_HArray1OfBox2d);
  }

  export declare class Handle_Bnd_HArray1OfBox2d_3 extends Handle_Bnd_HArray1OfBox2d {
    constructor(theHandle: Handle_Bnd_HArray1OfBox2d);
  }

  export declare class Handle_Bnd_HArray1OfBox2d_4 extends Handle_Bnd_HArray1OfBox2d {
    constructor(theHandle: Handle_Bnd_HArray1OfBox2d);
  }

export declare class Bnd_B2f {
  IsVoid(): Standard_Boolean;
  Clear(): void;
  Add_1(thePnt: gp_XY): void;
  Add_2(thePnt: gp_Pnt2d): void;
  Add_3(theBox: Bnd_B2f): void;
  CornerMin(): gp_XY;
  CornerMax(): gp_XY;
  SquareExtent(): Quantity_AbsorbedDose;
  Enlarge(theDiff: Quantity_AbsorbedDose): void;
  Limit(theOtherBox: Bnd_B2f): Standard_Boolean;
  Transformed(theTrsf: gp_Trsf2d): Bnd_B2f;
  IsOut_1(thePnt: gp_XY): Standard_Boolean;
  IsOut_2(theCenter: gp_XY, theRadius: Quantity_AbsorbedDose, isCircleHollow: Standard_Boolean): Standard_Boolean;
  IsOut_3(theOtherBox: Bnd_B2f): Standard_Boolean;
  IsOut_4(theOtherBox: Bnd_B2f, theTrsf: gp_Trsf2d): Standard_Boolean;
  IsOut_5(theLine: gp_Ax2d): Standard_Boolean;
  IsOut_6(theP0: gp_XY, theP1: gp_XY): Standard_Boolean;
  IsIn_1(theBox: Bnd_B2f): Standard_Boolean;
  IsIn_2(theBox: Bnd_B2f, theTrsf: gp_Trsf2d): Standard_Boolean;
  SetCenter(theCenter: gp_XY): void;
  SetHSize(theHSize: gp_XY): void;
  delete(): void;
}

  export declare class Bnd_B2f_1 extends Bnd_B2f {
    constructor();
  }

  export declare class Bnd_B2f_2 extends Bnd_B2f {
    constructor(theCenter: gp_XY, theHSize: gp_XY);
  }

export declare class Bnd_Array1OfSphere {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Bnd_Sphere): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Bnd_Array1OfSphere): Bnd_Array1OfSphere;
  Move(theOther: Bnd_Array1OfSphere): Bnd_Array1OfSphere;
  First(): Bnd_Sphere;
  ChangeFirst(): Bnd_Sphere;
  Last(): Bnd_Sphere;
  ChangeLast(): Bnd_Sphere;
  Value(theIndex: Standard_Integer): Bnd_Sphere;
  ChangeValue(theIndex: Standard_Integer): Bnd_Sphere;
  SetValue(theIndex: Standard_Integer, theItem: Bnd_Sphere): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Bnd_Array1OfSphere_1 extends Bnd_Array1OfSphere {
    constructor();
  }

  export declare class Bnd_Array1OfSphere_2 extends Bnd_Array1OfSphere {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Bnd_Array1OfSphere_3 extends Bnd_Array1OfSphere {
    constructor(theOther: Bnd_Array1OfSphere);
  }

  export declare class Bnd_Array1OfSphere_4 extends Bnd_Array1OfSphere {
    constructor(theOther: Bnd_Array1OfSphere);
  }

  export declare class Bnd_Array1OfSphere_5 extends Bnd_Array1OfSphere {
    constructor(theBegin: Bnd_Sphere, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Bnd_Range {
  Common(theOther: Bnd_Range): void;
  Union(theOther: Bnd_Range): Standard_Boolean;
  Split(theVal: Quantity_AbsorbedDose, theList: NCollection_List<Bnd_Range>, thePeriod: Quantity_AbsorbedDose): void;
  IsIntersected(theVal: Quantity_AbsorbedDose, thePeriod: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Add_1(theParameter: Quantity_AbsorbedDose): void;
  Add_2(theRange: Bnd_Range): void;
  GetMin(thePar: Quantity_AbsorbedDose): Standard_Boolean;
  GetMax(thePar: Quantity_AbsorbedDose): Standard_Boolean;
  GetBounds(theFirstPar: Quantity_AbsorbedDose, theLastPar: Quantity_AbsorbedDose): Standard_Boolean;
  GetIntermediatePoint(theLambda: Quantity_AbsorbedDose, theParameter: Quantity_AbsorbedDose): Standard_Boolean;
  Delta(): Quantity_AbsorbedDose;
  IsVoid(): Standard_Boolean;
  SetVoid(): void;
  Enlarge(theDelta: Quantity_AbsorbedDose): void;
  Shifted(theVal: Quantity_AbsorbedDose): Bnd_Range;
  Shift(theVal: Quantity_AbsorbedDose): void;
  TrimFrom(theValLower: Quantity_AbsorbedDose): void;
  TrimTo(theValUpper: Quantity_AbsorbedDose): void;
  IsOut_1(theValue: Quantity_AbsorbedDose): Standard_Boolean;
  IsOut_2(theRange: Bnd_Range): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Bnd_Range_1 extends Bnd_Range {
    constructor();
  }

  export declare class Bnd_Range_2 extends Bnd_Range {
    constructor(theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose);
  }

export declare class Bnd_B3d {
  IsVoid(): Standard_Boolean;
  Clear(): void;
  Add_1(thePnt: gp_XYZ): void;
  Add_2(thePnt: gp_Pnt): void;
  Add_3(theBox: Bnd_B3d): void;
  CornerMin(): gp_XYZ;
  CornerMax(): gp_XYZ;
  SquareExtent(): Quantity_AbsorbedDose;
  Enlarge(theDiff: Quantity_AbsorbedDose): void;
  Limit(theOtherBox: Bnd_B3d): Standard_Boolean;
  Transformed(theTrsf: gp_Trsf): Bnd_B3d;
  IsOut_1(thePnt: gp_XYZ): Standard_Boolean;
  IsOut_2(theCenter: gp_XYZ, theRadius: Quantity_AbsorbedDose, isSphereHollow: Standard_Boolean): Standard_Boolean;
  IsOut_3(theOtherBox: Bnd_B3d): Standard_Boolean;
  IsOut_4(theOtherBox: Bnd_B3d, theTrsf: gp_Trsf): Standard_Boolean;
  IsOut_5(theLine: gp_Ax1, isRay: Standard_Boolean, theOverthickness: Quantity_AbsorbedDose): Standard_Boolean;
  IsOut_6(thePlane: gp_Ax3): Standard_Boolean;
  IsIn_1(theBox: Bnd_B3d): Standard_Boolean;
  IsIn_2(theBox: Bnd_B3d, theTrsf: gp_Trsf): Standard_Boolean;
  SetCenter(theCenter: gp_XYZ): void;
  SetHSize(theHSize: gp_XYZ): void;
  delete(): void;
}

  export declare class Bnd_B3d_1 extends Bnd_B3d {
    constructor();
  }

  export declare class Bnd_B3d_2 extends Bnd_B3d {
    constructor(theCenter: gp_XYZ, theHSize: gp_XYZ);
  }

export declare class Bnd_Tools {
  constructor();
  static Bnd2BVH_1(theBox: Bnd_Box2d): any;
  static Bnd2BVH_2(theBox: Bnd_Box): Graphic3d_BndBox3d;
  delete(): void;
}

export declare class Bnd_BoundSortBox {
  constructor()
  Initialize_1(CompleteBox: Bnd_Box, SetOfBox: Handle_Bnd_HArray1OfBox): void;
  Initialize_2(SetOfBox: Handle_Bnd_HArray1OfBox): void;
  Initialize_3(CompleteBox: Bnd_Box, nbComponents: Graphic3d_ZLayerId): void;
  Add(theBox: Bnd_Box, boxIndex: Graphic3d_ZLayerId): void;
  Compare_1(theBox: Bnd_Box): TColStd_ListOfInteger;
  Compare_2(P: gp_Pln): TColStd_ListOfInteger;
  Dump(): void;
  Destroy(): void;
  delete(): void;
}

export declare class Handle_Bnd_HArray1OfSphere {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bnd_HArray1OfSphere): void;
  get(): Bnd_HArray1OfSphere;
  delete(): void;
}

  export declare class Handle_Bnd_HArray1OfSphere_1 extends Handle_Bnd_HArray1OfSphere {
    constructor();
  }

  export declare class Handle_Bnd_HArray1OfSphere_2 extends Handle_Bnd_HArray1OfSphere {
    constructor(thePtr: Bnd_HArray1OfSphere);
  }

  export declare class Handle_Bnd_HArray1OfSphere_3 extends Handle_Bnd_HArray1OfSphere {
    constructor(theHandle: Handle_Bnd_HArray1OfSphere);
  }

  export declare class Handle_Bnd_HArray1OfSphere_4 extends Handle_Bnd_HArray1OfSphere {
    constructor(theHandle: Handle_Bnd_HArray1OfSphere);
  }

export declare class Bnd_OBB {
  ReBuild(theListOfPoints: TColgp_Array1OfPnt, theListOfTolerances: TColStd_Array1OfReal, theIsOptimal: Standard_Boolean): void;
  SetCenter(theCenter: gp_Pnt): void;
  SetXComponent(theXDirection: gp_Dir, theHXSize: Quantity_AbsorbedDose): void;
  SetYComponent(theYDirection: gp_Dir, theHYSize: Quantity_AbsorbedDose): void;
  SetZComponent(theZDirection: gp_Dir, theHZSize: Quantity_AbsorbedDose): void;
  Position(): gp_Ax3;
  Center(): gp_XYZ;
  XDirection(): gp_XYZ;
  YDirection(): gp_XYZ;
  ZDirection(): gp_XYZ;
  XHSize(): Quantity_AbsorbedDose;
  YHSize(): Quantity_AbsorbedDose;
  ZHSize(): Quantity_AbsorbedDose;
  IsVoid(): Standard_Boolean;
  SetVoid(): void;
  SetAABox(theFlag: Standard_Boolean): void;
  IsAABox(): Standard_Boolean;
  Enlarge(theGapAdd: Quantity_AbsorbedDose): void;
  GetVertex(theP: gp_Pnt [8]): Standard_Boolean;
  SquareExtent(): Quantity_AbsorbedDose;
  IsOut_1(theOther: Bnd_OBB): Standard_Boolean;
  IsOut_2(theP: gp_Pnt): Standard_Boolean;
  IsCompletelyInside(theOther: Bnd_OBB): Standard_Boolean;
  Add_1(theOther: Bnd_OBB): void;
  Add_2(theP: gp_Pnt): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Bnd_OBB_1 extends Bnd_OBB {
    constructor();
  }

  export declare class Bnd_OBB_2 extends Bnd_OBB {
    constructor(theCenter: gp_Pnt, theXDirection: gp_Dir, theYDirection: gp_Dir, theZDirection: gp_Dir, theHXSize: Quantity_AbsorbedDose, theHYSize: Quantity_AbsorbedDose, theHZSize: Quantity_AbsorbedDose);
  }

  export declare class Bnd_OBB_3 extends Bnd_OBB {
    constructor(theBox: Bnd_Box);
  }

export declare class Bnd_Box2d {
  constructor()
  SetWhole(): void;
  SetVoid(): void;
  Set_1(thePnt: gp_Pnt2d): void;
  Set_2(thePnt: gp_Pnt2d, theDir: gp_Dir2d): void;
  Update_1(aXmin: Quantity_AbsorbedDose, aYmin: Quantity_AbsorbedDose, aXmax: Quantity_AbsorbedDose, aYmax: Quantity_AbsorbedDose): void;
  Update_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  GetGap(): Quantity_AbsorbedDose;
  SetGap(Tol: Quantity_AbsorbedDose): void;
  Enlarge(theTol: Quantity_AbsorbedDose): void;
  Get(aXmin: Quantity_AbsorbedDose, aYmin: Quantity_AbsorbedDose, aXmax: Quantity_AbsorbedDose, aYmax: Quantity_AbsorbedDose): void;
  OpenXmin(): void;
  OpenXmax(): void;
  OpenYmin(): void;
  OpenYmax(): void;
  IsOpenXmin(): Standard_Boolean;
  IsOpenXmax(): Standard_Boolean;
  IsOpenYmin(): Standard_Boolean;
  IsOpenYmax(): Standard_Boolean;
  IsWhole(): Standard_Boolean;
  IsVoid(): Standard_Boolean;
  Transformed(T: gp_Trsf2d): Bnd_Box2d;
  Add_1(Other: Bnd_Box2d): void;
  Add_2(thePnt: gp_Pnt2d): void;
  Add_3(thePnt: gp_Pnt2d, theDir: gp_Dir2d): void;
  Add_4(D: gp_Dir2d): void;
  IsOut_1(P: gp_Pnt2d): Standard_Boolean;
  IsOut_2(Other: Bnd_Box2d): Standard_Boolean;
  IsOut_3(theOther: Bnd_Box2d, theTrsf: gp_Trsf2d): Standard_Boolean;
  IsOut_4(T1: gp_Trsf2d, Other: Bnd_Box2d, T2: gp_Trsf2d): Standard_Boolean;
  Dump(): void;
  SquareExtent(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Bnd_B2d {
  IsVoid(): Standard_Boolean;
  Clear(): void;
  Add_1(thePnt: gp_XY): void;
  Add_2(thePnt: gp_Pnt2d): void;
  Add_3(theBox: Bnd_B2d): void;
  CornerMin(): gp_XY;
  CornerMax(): gp_XY;
  SquareExtent(): Quantity_AbsorbedDose;
  Enlarge(theDiff: Quantity_AbsorbedDose): void;
  Limit(theOtherBox: Bnd_B2d): Standard_Boolean;
  Transformed(theTrsf: gp_Trsf2d): Bnd_B2d;
  IsOut_1(thePnt: gp_XY): Standard_Boolean;
  IsOut_2(theCenter: gp_XY, theRadius: Quantity_AbsorbedDose, isCircleHollow: Standard_Boolean): Standard_Boolean;
  IsOut_3(theOtherBox: Bnd_B2d): Standard_Boolean;
  IsOut_4(theOtherBox: Bnd_B2d, theTrsf: gp_Trsf2d): Standard_Boolean;
  IsOut_5(theLine: gp_Ax2d): Standard_Boolean;
  IsOut_6(theP0: gp_XY, theP1: gp_XY): Standard_Boolean;
  IsIn_1(theBox: Bnd_B2d): Standard_Boolean;
  IsIn_2(theBox: Bnd_B2d, theTrsf: gp_Trsf2d): Standard_Boolean;
  SetCenter(theCenter: gp_XY): void;
  SetHSize(theHSize: gp_XY): void;
  delete(): void;
}

  export declare class Bnd_B2d_1 extends Bnd_B2d {
    constructor();
  }

  export declare class Bnd_B2d_2 extends Bnd_B2d {
    constructor(theCenter: gp_XY, theHSize: gp_XY);
  }

export declare class Bnd_Box {
  SetWhole(): void;
  SetVoid(): void;
  Set_1(P: gp_Pnt): void;
  Set_2(P: gp_Pnt, D: gp_Dir): void;
  Update_1(aXmin: Quantity_AbsorbedDose, aYmin: Quantity_AbsorbedDose, aZmin: Quantity_AbsorbedDose, aXmax: Quantity_AbsorbedDose, aYmax: Quantity_AbsorbedDose, aZmax: Quantity_AbsorbedDose): void;
  Update_2(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  GetGap(): Quantity_AbsorbedDose;
  SetGap(Tol: Quantity_AbsorbedDose): void;
  Enlarge(Tol: Quantity_AbsorbedDose): void;
  Get(theXmin: Quantity_AbsorbedDose, theYmin: Quantity_AbsorbedDose, theZmin: Quantity_AbsorbedDose, theXmax: Quantity_AbsorbedDose, theYmax: Quantity_AbsorbedDose, theZmax: Quantity_AbsorbedDose): void;
  CornerMin(): gp_Pnt;
  CornerMax(): gp_Pnt;
  OpenXmin(): void;
  OpenXmax(): void;
  OpenYmin(): void;
  OpenYmax(): void;
  OpenZmin(): void;
  OpenZmax(): void;
  IsOpen(): Standard_Boolean;
  IsOpenXmin(): Standard_Boolean;
  IsOpenXmax(): Standard_Boolean;
  IsOpenYmin(): Standard_Boolean;
  IsOpenYmax(): Standard_Boolean;
  IsOpenZmin(): Standard_Boolean;
  IsOpenZmax(): Standard_Boolean;
  IsWhole(): Standard_Boolean;
  IsVoid(): Standard_Boolean;
  IsXThin(tol: Quantity_AbsorbedDose): Standard_Boolean;
  IsYThin(tol: Quantity_AbsorbedDose): Standard_Boolean;
  IsZThin(tol: Quantity_AbsorbedDose): Standard_Boolean;
  IsThin(tol: Quantity_AbsorbedDose): Standard_Boolean;
  Transformed(T: gp_Trsf): Bnd_Box;
  Add_1(Other: Bnd_Box): void;
  Add_2(P: gp_Pnt): void;
  Add_3(P: gp_Pnt, D: gp_Dir): void;
  Add_4(D: gp_Dir): void;
  IsOut_1(P: gp_Pnt): Standard_Boolean;
  IsOut_2(L: gp_Lin): Standard_Boolean;
  IsOut_3(P: gp_Pln): Standard_Boolean;
  IsOut_4(Other: Bnd_Box): Standard_Boolean;
  IsOut_5(Other: Bnd_Box, T: gp_Trsf): Standard_Boolean;
  IsOut_6(T1: gp_Trsf, Other: Bnd_Box, T2: gp_Trsf): Standard_Boolean;
  IsOut_7(P1: gp_Pnt, P2: gp_Pnt, D: gp_Dir): Standard_Boolean;
  Distance(Other: Bnd_Box): Quantity_AbsorbedDose;
  Dump(): void;
  SquareExtent(): Quantity_AbsorbedDose;
  FinitePart(): Bnd_Box;
  HasFinitePart(): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  InitFromJson(theSStream: Standard_SStream, theStreamPos: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

  export declare class Bnd_Box_1 extends Bnd_Box {
    constructor();
  }

  export declare class Bnd_Box_2 extends Bnd_Box {
    constructor(theMin: gp_Pnt, theMax: gp_Pnt);
  }

export declare class Bnd_Sphere {
  U(): Graphic3d_ZLayerId;
  V(): Graphic3d_ZLayerId;
  IsValid(): Standard_Boolean;
  SetValid(isValid: Standard_Boolean): void;
  Center(): gp_XYZ;
  Radius(): Quantity_AbsorbedDose;
  Distances(theXYZ: gp_XYZ, theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose): void;
  SquareDistances(theXYZ: gp_XYZ, theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose): void;
  Project(theNode: gp_XYZ, theProjNode: gp_XYZ, theDist: Quantity_AbsorbedDose, theInside: Standard_Boolean): Standard_Boolean;
  Distance(theNode: gp_XYZ): Quantity_AbsorbedDose;
  SquareDistance(theNode: gp_XYZ): Quantity_AbsorbedDose;
  Add(theOther: Bnd_Sphere): void;
  IsOut_1(theOther: Bnd_Sphere): Standard_Boolean;
  IsOut_2(thePnt: gp_XYZ, theMaxDist: Quantity_AbsorbedDose): Standard_Boolean;
  SquareExtent(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Bnd_Sphere_1 extends Bnd_Sphere {
    constructor();
  }

  export declare class Bnd_Sphere_2 extends Bnd_Sphere {
    constructor(theCntr: gp_XYZ, theRad: Quantity_AbsorbedDose, theU: Graphic3d_ZLayerId, theV: Graphic3d_ZLayerId);
  }

export declare class Bnd_B3f {
  IsVoid(): Standard_Boolean;
  Clear(): void;
  Add_1(thePnt: gp_XYZ): void;
  Add_2(thePnt: gp_Pnt): void;
  Add_3(theBox: Bnd_B3f): void;
  CornerMin(): gp_XYZ;
  CornerMax(): gp_XYZ;
  SquareExtent(): Quantity_AbsorbedDose;
  Enlarge(theDiff: Quantity_AbsorbedDose): void;
  Limit(theOtherBox: Bnd_B3f): Standard_Boolean;
  Transformed(theTrsf: gp_Trsf): Bnd_B3f;
  IsOut_1(thePnt: gp_XYZ): Standard_Boolean;
  IsOut_2(theCenter: gp_XYZ, theRadius: Quantity_AbsorbedDose, isSphereHollow: Standard_Boolean): Standard_Boolean;
  IsOut_3(theOtherBox: Bnd_B3f): Standard_Boolean;
  IsOut_4(theOtherBox: Bnd_B3f, theTrsf: gp_Trsf): Standard_Boolean;
  IsOut_5(theLine: gp_Ax1, isRay: Standard_Boolean, theOverthickness: Quantity_AbsorbedDose): Standard_Boolean;
  IsOut_6(thePlane: gp_Ax3): Standard_Boolean;
  IsIn_1(theBox: Bnd_B3f): Standard_Boolean;
  IsIn_2(theBox: Bnd_B3f, theTrsf: gp_Trsf): Standard_Boolean;
  SetCenter(theCenter: gp_XYZ): void;
  SetHSize(theHSize: gp_XYZ): void;
  delete(): void;
}

  export declare class Bnd_B3f_1 extends Bnd_B3f {
    constructor();
  }

  export declare class Bnd_B3f_2 extends Bnd_B3f {
    constructor(theCenter: gp_XYZ, theHSize: gp_XYZ);
  }

export declare class Bnd_Array1OfBox2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Bnd_Box2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Bnd_Array1OfBox2d): Bnd_Array1OfBox2d;
  Move(theOther: Bnd_Array1OfBox2d): Bnd_Array1OfBox2d;
  First(): Bnd_Box2d;
  ChangeFirst(): Bnd_Box2d;
  Last(): Bnd_Box2d;
  ChangeLast(): Bnd_Box2d;
  Value(theIndex: Standard_Integer): Bnd_Box2d;
  ChangeValue(theIndex: Standard_Integer): Bnd_Box2d;
  SetValue(theIndex: Standard_Integer, theItem: Bnd_Box2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Bnd_Array1OfBox2d_1 extends Bnd_Array1OfBox2d {
    constructor();
  }

  export declare class Bnd_Array1OfBox2d_2 extends Bnd_Array1OfBox2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Bnd_Array1OfBox2d_3 extends Bnd_Array1OfBox2d {
    constructor(theOther: Bnd_Array1OfBox2d);
  }

  export declare class Bnd_Array1OfBox2d_4 extends Bnd_Array1OfBox2d {
    constructor(theOther: Bnd_Array1OfBox2d);
  }

  export declare class Bnd_Array1OfBox2d_5 extends Bnd_Array1OfBox2d {
    constructor(theBegin: Bnd_Box2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Bnd_BoundSortBox2d {
  constructor()
  Initialize_1(CompleteBox: Bnd_Box2d, SetOfBox: Handle_Bnd_HArray1OfBox2d): void;
  Initialize_2(SetOfBox: Handle_Bnd_HArray1OfBox2d): void;
  Initialize_3(CompleteBox: Bnd_Box2d, nbComponents: Graphic3d_ZLayerId): void;
  Add(theBox: Bnd_Box2d, boxIndex: Graphic3d_ZLayerId): void;
  Compare(theBox: Bnd_Box2d): TColStd_ListOfInteger;
  Dump(): void;
  delete(): void;
}

export declare class Bnd_Array1OfBox {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Bnd_Box): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Bnd_Array1OfBox): Bnd_Array1OfBox;
  Move(theOther: Bnd_Array1OfBox): Bnd_Array1OfBox;
  First(): Bnd_Box;
  ChangeFirst(): Bnd_Box;
  Last(): Bnd_Box;
  ChangeLast(): Bnd_Box;
  Value(theIndex: Standard_Integer): Bnd_Box;
  ChangeValue(theIndex: Standard_Integer): Bnd_Box;
  SetValue(theIndex: Standard_Integer, theItem: Bnd_Box): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Bnd_Array1OfBox_1 extends Bnd_Array1OfBox {
    constructor();
  }

  export declare class Bnd_Array1OfBox_2 extends Bnd_Array1OfBox {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Bnd_Array1OfBox_3 extends Bnd_Array1OfBox {
    constructor(theOther: Bnd_Array1OfBox);
  }

  export declare class Bnd_Array1OfBox_4 extends Bnd_Array1OfBox {
    constructor(theOther: Bnd_Array1OfBox);
  }

  export declare class Bnd_Array1OfBox_5 extends Bnd_Array1OfBox {
    constructor(theBegin: Bnd_Box, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_Bnd_HArray1OfBox {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Bnd_HArray1OfBox): void;
  get(): Bnd_HArray1OfBox;
  delete(): void;
}

  export declare class Handle_Bnd_HArray1OfBox_1 extends Handle_Bnd_HArray1OfBox {
    constructor();
  }

  export declare class Handle_Bnd_HArray1OfBox_2 extends Handle_Bnd_HArray1OfBox {
    constructor(thePtr: Bnd_HArray1OfBox);
  }

  export declare class Handle_Bnd_HArray1OfBox_3 extends Handle_Bnd_HArray1OfBox {
    constructor(theHandle: Handle_Bnd_HArray1OfBox);
  }

  export declare class Handle_Bnd_HArray1OfBox_4 extends Handle_Bnd_HArray1OfBox {
    constructor(theHandle: Handle_Bnd_HArray1OfBox);
  }

export declare class BRepClass_Intersector extends Geom2dInt_IntConicCurveOfGInter {
  constructor()
  Perform(L: gp_Lin2d, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, E: BRepClass_Edge): void;
  LocalGeometry(E: BRepClass_Edge, U: Quantity_AbsorbedDose, T: gp_Dir2d, N: gp_Dir2d, C: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class BRepClass_FClass2dOfFClassifier {
  constructor()
  Reset(L: gp_Lin2d, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Compare(E: BRepClass_Edge, Or: TopAbs_Orientation): void;
  Parameter(): Quantity_AbsorbedDose;
  Intersector(): BRepClass_Intersector;
  ClosestIntersection(): Graphic3d_ZLayerId;
  State(): TopAbs_State;
  IsHeadOrEnd(): Standard_Boolean;
  delete(): void;
}

export declare class BRepClass_Edge {
  Edge_1(): TopoDS_Edge;
  Edge_2(): TopoDS_Edge;
  Face_1(): TopoDS_Face;
  Face_2(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepClass_Edge_1 extends BRepClass_Edge {
    constructor();
  }

  export declare class BRepClass_Edge_2 extends BRepClass_Edge {
    constructor(E: TopoDS_Edge, F: TopoDS_Face);
  }

export declare class BRepClass_FacePassiveClassifier {
  constructor()
  Reset(L: gp_Lin2d, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Compare(E: BRepClass_Edge, Or: TopAbs_Orientation): void;
  Parameter(): Quantity_AbsorbedDose;
  Intersector(): BRepClass_Intersector;
  ClosestIntersection(): Graphic3d_ZLayerId;
  State(): TopAbs_State;
  IsHeadOrEnd(): Standard_Boolean;
  delete(): void;
}

export declare class BRepClass_FClassifier {
  Perform(F: BRepClass_FaceExplorer, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose): void;
  State(): TopAbs_State;
  Rejected(): Standard_Boolean;
  NoWires(): Standard_Boolean;
  Edge(): BRepClass_Edge;
  EdgeParameter(): Quantity_AbsorbedDose;
  Position(): IntRes2d_Position;
  delete(): void;
}

  export declare class BRepClass_FClassifier_1 extends BRepClass_FClassifier {
    constructor();
  }

  export declare class BRepClass_FClassifier_2 extends BRepClass_FClassifier {
    constructor(F: BRepClass_FaceExplorer, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose);
  }

export declare class BRepClass_FaceExplorer {
  constructor(F: TopoDS_Face)
  CheckPoint(thePoint: gp_Pnt2d): Standard_Boolean;
  Reject(P: gp_Pnt2d): Standard_Boolean;
  Segment(P: gp_Pnt2d, L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  OtherSegment(P: gp_Pnt2d, L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  InitWires(): void;
  MoreWires(): Standard_Boolean;
  NextWire(): void;
  RejectWire(L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  InitEdges(): void;
  MoreEdges(): Standard_Boolean;
  NextEdge(): void;
  RejectEdge(L: gp_Lin2d, Par: Quantity_AbsorbedDose): Standard_Boolean;
  CurrentEdge(E: BRepClass_Edge, Or: TopAbs_Orientation): void;
  delete(): void;
}

export declare class BRepClass_FaceClassifier extends BRepClass_FClassifier {
  Perform_1(F: TopoDS_Face, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose): void;
  Perform_2(F: TopoDS_Face, P: gp_Pnt, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class BRepClass_FaceClassifier_1 extends BRepClass_FaceClassifier {
    constructor();
  }

  export declare class BRepClass_FaceClassifier_2 extends BRepClass_FaceClassifier {
    constructor(F: BRepClass_FaceExplorer, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose);
  }

  export declare class BRepClass_FaceClassifier_3 extends BRepClass_FaceClassifier {
    constructor(F: TopoDS_Face, P: gp_Pnt2d, Tol: Quantity_AbsorbedDose);
  }

  export declare class BRepClass_FaceClassifier_4 extends BRepClass_FaceClassifier {
    constructor(F: TopoDS_Face, P: gp_Pnt, Tol: Quantity_AbsorbedDose);
  }

export declare class ChFiKPart_ComputeData {
  constructor();
  static Compute(DStr: TopOpeBRepDS_DataStructure, Data: Handle_ChFiDS_SurfData, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, Or1: TopAbs_Orientation, Or2: TopAbs_Orientation, Sp: Handle_ChFiDS_Spine, Iedge: Graphic3d_ZLayerId): Standard_Boolean;
  static ComputeCorner_1(DStr: TopOpeBRepDS_DataStructure, Data: Handle_ChFiDS_SurfData, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, OrFace1: TopAbs_Orientation, OrFace2: TopAbs_Orientation, Or1: TopAbs_Orientation, Or2: TopAbs_Orientation, minRad: Quantity_AbsorbedDose, majRad: Quantity_AbsorbedDose, P1S1: gp_Pnt2d, P2S1: gp_Pnt2d, P1S2: gp_Pnt2d, P2S2: gp_Pnt2d): Standard_Boolean;
  static ComputeCorner_2(DStr: TopOpeBRepDS_DataStructure, Data: Handle_ChFiDS_SurfData, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, OrFace1: TopAbs_Orientation, OrFace2: TopAbs_Orientation, Or1: TopAbs_Orientation, Or2: TopAbs_Orientation, Rad: Quantity_AbsorbedDose, PS1: gp_Pnt2d, P1S2: gp_Pnt2d, P2S2: gp_Pnt2d): Standard_Boolean;
  static ComputeCorner_3(DStr: TopOpeBRepDS_DataStructure, Data: Handle_ChFiDS_SurfData, S: Handle_Adaptor3d_HSurface, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, OfS: TopAbs_Orientation, OS: TopAbs_Orientation, OS1: TopAbs_Orientation, OS2: TopAbs_Orientation, Radius: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class GeomAdaptor_SurfaceOfLinearExtrusion extends GeomAdaptor_Surface {
  Load_1(C: Handle_Adaptor3d_HCurve): void;
  Load_2(V: gp_Dir): void;
  FirstUParameter(): Quantity_AbsorbedDose;
  LastUParameter(): Quantity_AbsorbedDose;
  FirstVParameter(): Quantity_AbsorbedDose;
  LastVParameter(): Quantity_AbsorbedDose;
  UContinuity(): GeomAbs_Shape;
  VContinuity(): GeomAbs_Shape;
  NbUIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  NbVIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  UIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  VIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  UTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  VTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  UResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Sphere(): gp_Sphere;
  Torus(): gp_Torus;
  UDegree(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bezier(): Handle_Geom_BezierSurface;
  BSpline(): Handle_Geom_BSplineSurface;
  AxeOfRevolution(): gp_Ax1;
  Direction(): gp_Dir;
  BasisCurve(): Handle_Adaptor3d_HCurve;
  delete(): void;
}

  export declare class GeomAdaptor_SurfaceOfLinearExtrusion_1 extends GeomAdaptor_SurfaceOfLinearExtrusion {
    constructor();
  }

  export declare class GeomAdaptor_SurfaceOfLinearExtrusion_2 extends GeomAdaptor_SurfaceOfLinearExtrusion {
    constructor(C: Handle_Adaptor3d_HCurve);
  }

  export declare class GeomAdaptor_SurfaceOfLinearExtrusion_3 extends GeomAdaptor_SurfaceOfLinearExtrusion {
    constructor(C: Handle_Adaptor3d_HCurve, V: gp_Dir);
  }

export declare class Handle_GeomAdaptor_GHSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomAdaptor_GHSurface): void;
  get(): GeomAdaptor_GHSurface;
  delete(): void;
}

  export declare class Handle_GeomAdaptor_GHSurface_1 extends Handle_GeomAdaptor_GHSurface {
    constructor();
  }

  export declare class Handle_GeomAdaptor_GHSurface_2 extends Handle_GeomAdaptor_GHSurface {
    constructor(thePtr: GeomAdaptor_GHSurface);
  }

  export declare class Handle_GeomAdaptor_GHSurface_3 extends Handle_GeomAdaptor_GHSurface {
    constructor(theHandle: Handle_GeomAdaptor_GHSurface);
  }

  export declare class Handle_GeomAdaptor_GHSurface_4 extends Handle_GeomAdaptor_GHSurface {
    constructor(theHandle: Handle_GeomAdaptor_GHSurface);
  }

export declare class GeomAdaptor_GHSurface extends Adaptor3d_HSurface {
  Set(S: GeomAdaptor_Surface): void;
  Surface(): Adaptor3d_Surface;
  ChangeSurface(): GeomAdaptor_Surface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomAdaptor_GHSurface_1 extends GeomAdaptor_GHSurface {
    constructor();
  }

  export declare class GeomAdaptor_GHSurface_2 extends GeomAdaptor_GHSurface {
    constructor(S: GeomAdaptor_Surface);
  }

export declare class GeomAdaptor_HSurfaceOfLinearExtrusion extends Adaptor3d_HSurface {
  Set(S: GeomAdaptor_SurfaceOfLinearExtrusion): void;
  Surface(): Adaptor3d_Surface;
  ChangeSurface(): GeomAdaptor_SurfaceOfLinearExtrusion;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomAdaptor_HSurfaceOfLinearExtrusion_1 extends GeomAdaptor_HSurfaceOfLinearExtrusion {
    constructor();
  }

  export declare class GeomAdaptor_HSurfaceOfLinearExtrusion_2 extends GeomAdaptor_HSurfaceOfLinearExtrusion {
    constructor(S: GeomAdaptor_SurfaceOfLinearExtrusion);
  }

export declare class Handle_GeomAdaptor_HSurfaceOfLinearExtrusion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomAdaptor_HSurfaceOfLinearExtrusion): void;
  get(): GeomAdaptor_HSurfaceOfLinearExtrusion;
  delete(): void;
}

  export declare class Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_1 extends Handle_GeomAdaptor_HSurfaceOfLinearExtrusion {
    constructor();
  }

  export declare class Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_2 extends Handle_GeomAdaptor_HSurfaceOfLinearExtrusion {
    constructor(thePtr: GeomAdaptor_HSurfaceOfLinearExtrusion);
  }

  export declare class Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_3 extends Handle_GeomAdaptor_HSurfaceOfLinearExtrusion {
    constructor(theHandle: Handle_GeomAdaptor_HSurfaceOfLinearExtrusion);
  }

  export declare class Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_4 extends Handle_GeomAdaptor_HSurfaceOfLinearExtrusion {
    constructor(theHandle: Handle_GeomAdaptor_HSurfaceOfLinearExtrusion);
  }

export declare class GeomAdaptor_Surface extends Adaptor3d_Surface {
  Load_1(S: Handle_Geom_Surface): void;
  Load_2(S: Handle_Geom_Surface, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  Surface(): Handle_Geom_Surface;
  FirstUParameter(): Quantity_AbsorbedDose;
  LastUParameter(): Quantity_AbsorbedDose;
  FirstVParameter(): Quantity_AbsorbedDose;
  LastVParameter(): Quantity_AbsorbedDose;
  UContinuity(): GeomAbs_Shape;
  VContinuity(): GeomAbs_Shape;
  NbUIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  NbVIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  UIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  VIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  UTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  VTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  UResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Sphere(): gp_Sphere;
  Torus(): gp_Torus;
  UDegree(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bezier(): Handle_Geom_BezierSurface;
  BSpline(): Handle_Geom_BSplineSurface;
  AxeOfRevolution(): gp_Ax1;
  Direction(): gp_Dir;
  BasisCurve(): Handle_Adaptor3d_HCurve;
  BasisSurface(): Handle_Adaptor3d_HSurface;
  OffsetValue(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomAdaptor_Surface_1 extends GeomAdaptor_Surface {
    constructor();
  }

  export declare class GeomAdaptor_Surface_2 extends GeomAdaptor_Surface {
    constructor(S: Handle_Geom_Surface);
  }

  export declare class GeomAdaptor_Surface_3 extends GeomAdaptor_Surface {
    constructor(S: Handle_Geom_Surface, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

export declare class Handle_GeomAdaptor_HSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomAdaptor_HSurface): void;
  get(): GeomAdaptor_HSurface;
  delete(): void;
}

  export declare class Handle_GeomAdaptor_HSurface_1 extends Handle_GeomAdaptor_HSurface {
    constructor();
  }

  export declare class Handle_GeomAdaptor_HSurface_2 extends Handle_GeomAdaptor_HSurface {
    constructor(thePtr: GeomAdaptor_HSurface);
  }

  export declare class Handle_GeomAdaptor_HSurface_3 extends Handle_GeomAdaptor_HSurface {
    constructor(theHandle: Handle_GeomAdaptor_HSurface);
  }

  export declare class Handle_GeomAdaptor_HSurface_4 extends Handle_GeomAdaptor_HSurface {
    constructor(theHandle: Handle_GeomAdaptor_HSurface);
  }

export declare class GeomAdaptor_HSurface extends GeomAdaptor_GHSurface {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomAdaptor_HSurface_1 extends GeomAdaptor_HSurface {
    constructor();
  }

  export declare class GeomAdaptor_HSurface_2 extends GeomAdaptor_HSurface {
    constructor(AS: GeomAdaptor_Surface);
  }

  export declare class GeomAdaptor_HSurface_3 extends GeomAdaptor_HSurface {
    constructor(S: Handle_Geom_Surface);
  }

  export declare class GeomAdaptor_HSurface_4 extends GeomAdaptor_HSurface {
    constructor(S: Handle_Geom_Surface, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose);
  }

export declare class GeomAdaptor {
  constructor();
  static MakeCurve(C: Adaptor3d_Curve): Handle_Geom_Curve;
  static MakeSurface(theS: Adaptor3d_Surface, theTrimFlag: Standard_Boolean): Handle_Geom_Surface;
  delete(): void;
}

export declare class GeomAdaptor_SurfaceOfRevolution extends GeomAdaptor_Surface {
  Load_1(C: Handle_Adaptor3d_HCurve): void;
  Load_2(V: gp_Ax1): void;
  AxeOfRevolution(): gp_Ax1;
  FirstUParameter(): Quantity_AbsorbedDose;
  LastUParameter(): Quantity_AbsorbedDose;
  FirstVParameter(): Quantity_AbsorbedDose;
  LastVParameter(): Quantity_AbsorbedDose;
  UContinuity(): GeomAbs_Shape;
  VContinuity(): GeomAbs_Shape;
  NbUIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  NbVIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  UIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  VIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  UTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  VTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  UResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Sphere(): gp_Sphere;
  Torus(): gp_Torus;
  VDegree(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bezier(): Handle_Geom_BezierSurface;
  BSpline(): Handle_Geom_BSplineSurface;
  Axis(): gp_Ax3;
  BasisCurve(): Handle_Adaptor3d_HCurve;
  delete(): void;
}

  export declare class GeomAdaptor_SurfaceOfRevolution_1 extends GeomAdaptor_SurfaceOfRevolution {
    constructor();
  }

  export declare class GeomAdaptor_SurfaceOfRevolution_2 extends GeomAdaptor_SurfaceOfRevolution {
    constructor(C: Handle_Adaptor3d_HCurve);
  }

  export declare class GeomAdaptor_SurfaceOfRevolution_3 extends GeomAdaptor_SurfaceOfRevolution {
    constructor(C: Handle_Adaptor3d_HCurve, V: gp_Ax1);
  }

export declare class GeomAdaptor_HSurfaceOfRevolution extends Adaptor3d_HSurface {
  Set(S: GeomAdaptor_SurfaceOfRevolution): void;
  Surface(): Adaptor3d_Surface;
  ChangeSurface(): GeomAdaptor_SurfaceOfRevolution;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomAdaptor_HSurfaceOfRevolution_1 extends GeomAdaptor_HSurfaceOfRevolution {
    constructor();
  }

  export declare class GeomAdaptor_HSurfaceOfRevolution_2 extends GeomAdaptor_HSurfaceOfRevolution {
    constructor(S: GeomAdaptor_SurfaceOfRevolution);
  }

export declare class Handle_GeomAdaptor_HSurfaceOfRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomAdaptor_HSurfaceOfRevolution): void;
  get(): GeomAdaptor_HSurfaceOfRevolution;
  delete(): void;
}

  export declare class Handle_GeomAdaptor_HSurfaceOfRevolution_1 extends Handle_GeomAdaptor_HSurfaceOfRevolution {
    constructor();
  }

  export declare class Handle_GeomAdaptor_HSurfaceOfRevolution_2 extends Handle_GeomAdaptor_HSurfaceOfRevolution {
    constructor(thePtr: GeomAdaptor_HSurfaceOfRevolution);
  }

  export declare class Handle_GeomAdaptor_HSurfaceOfRevolution_3 extends Handle_GeomAdaptor_HSurfaceOfRevolution {
    constructor(theHandle: Handle_GeomAdaptor_HSurfaceOfRevolution);
  }

  export declare class Handle_GeomAdaptor_HSurfaceOfRevolution_4 extends Handle_GeomAdaptor_HSurfaceOfRevolution {
    constructor(theHandle: Handle_GeomAdaptor_HSurfaceOfRevolution);
  }

export declare class Handle_GeomAdaptor_HCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomAdaptor_HCurve): void;
  get(): GeomAdaptor_HCurve;
  delete(): void;
}

  export declare class Handle_GeomAdaptor_HCurve_1 extends Handle_GeomAdaptor_HCurve {
    constructor();
  }

  export declare class Handle_GeomAdaptor_HCurve_2 extends Handle_GeomAdaptor_HCurve {
    constructor(thePtr: GeomAdaptor_HCurve);
  }

  export declare class Handle_GeomAdaptor_HCurve_3 extends Handle_GeomAdaptor_HCurve {
    constructor(theHandle: Handle_GeomAdaptor_HCurve);
  }

  export declare class Handle_GeomAdaptor_HCurve_4 extends Handle_GeomAdaptor_HCurve {
    constructor(theHandle: Handle_GeomAdaptor_HCurve);
  }

export declare class GeomAdaptor_HCurve extends GeomAdaptor_GHCurve {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomAdaptor_HCurve_1 extends GeomAdaptor_HCurve {
    constructor();
  }

  export declare class GeomAdaptor_HCurve_2 extends GeomAdaptor_HCurve {
    constructor(AS: GeomAdaptor_Curve);
  }

  export declare class GeomAdaptor_HCurve_3 extends GeomAdaptor_HCurve {
    constructor(S: Handle_Geom_Curve);
  }

  export declare class GeomAdaptor_HCurve_4 extends GeomAdaptor_HCurve {
    constructor(S: Handle_Geom_Curve, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose);
  }

export declare class GeomAdaptor_GHCurve extends Adaptor3d_HCurve {
  Set(C: GeomAdaptor_Curve): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): GeomAdaptor_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomAdaptor_GHCurve_1 extends GeomAdaptor_GHCurve {
    constructor();
  }

  export declare class GeomAdaptor_GHCurve_2 extends GeomAdaptor_GHCurve {
    constructor(C: GeomAdaptor_Curve);
  }

export declare class Handle_GeomAdaptor_GHCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomAdaptor_GHCurve): void;
  get(): GeomAdaptor_GHCurve;
  delete(): void;
}

  export declare class Handle_GeomAdaptor_GHCurve_1 extends Handle_GeomAdaptor_GHCurve {
    constructor();
  }

  export declare class Handle_GeomAdaptor_GHCurve_2 extends Handle_GeomAdaptor_GHCurve {
    constructor(thePtr: GeomAdaptor_GHCurve);
  }

  export declare class Handle_GeomAdaptor_GHCurve_3 extends Handle_GeomAdaptor_GHCurve {
    constructor(theHandle: Handle_GeomAdaptor_GHCurve);
  }

  export declare class Handle_GeomAdaptor_GHCurve_4 extends Handle_GeomAdaptor_GHCurve {
    constructor(theHandle: Handle_GeomAdaptor_GHCurve);
  }

export declare class GeomAdaptor_Curve extends Adaptor3d_Curve {
  Reset(): void;
  Load_1(C: Handle_Geom_Curve): void;
  Load_2(C: Handle_Geom_Curve, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose): void;
  Curve(): Handle_Geom_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  OffsetCurve(): Handle_Geom_OffsetCurve;
  delete(): void;
}

  export declare class GeomAdaptor_Curve_1 extends GeomAdaptor_Curve {
    constructor();
  }

  export declare class GeomAdaptor_Curve_2 extends GeomAdaptor_Curve {
    constructor(C: Handle_Geom_Curve);
  }

  export declare class GeomAdaptor_Curve_3 extends GeomAdaptor_Curve {
    constructor(C: Handle_Geom_Curve, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose);
  }

export declare class GC_MakeTrimmedCylinder extends GC_Root {
  Value(): Handle_Geom_RectangularTrimmedSurface;
  delete(): void;
}

  export declare class GC_MakeTrimmedCylinder_1 extends GC_MakeTrimmedCylinder {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class GC_MakeTrimmedCylinder_2 extends GC_MakeTrimmedCylinder {
    constructor(Circ: gp_Circ, Height: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeTrimmedCylinder_3 extends GC_MakeTrimmedCylinder {
    constructor(A1: gp_Ax1, Radius: Quantity_AbsorbedDose, Height: Quantity_AbsorbedDose);
  }

export declare class GC_MakeSegment extends GC_Root {
  Value(): Handle_Geom_TrimmedCurve;
  delete(): void;
}

  export declare class GC_MakeSegment_1 extends GC_MakeSegment {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

  export declare class GC_MakeSegment_2 extends GC_MakeSegment {
    constructor(Line: gp_Lin, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeSegment_3 extends GC_MakeSegment {
    constructor(Line: gp_Lin, Point: gp_Pnt, Ulast: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeSegment_4 extends GC_MakeSegment {
    constructor(Line: gp_Lin, P1: gp_Pnt, P2: gp_Pnt);
  }

export declare class GC_MakeArcOfHyperbola extends GC_Root {
  Value(): Handle_Geom_TrimmedCurve;
  delete(): void;
}

  export declare class GC_MakeArcOfHyperbola_1 extends GC_MakeArcOfHyperbola {
    constructor(Hypr: gp_Hypr, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfHyperbola_2 extends GC_MakeArcOfHyperbola {
    constructor(Hypr: gp_Hypr, P: gp_Pnt, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfHyperbola_3 extends GC_MakeArcOfHyperbola {
    constructor(Hypr: gp_Hypr, P1: gp_Pnt, P2: gp_Pnt, Sense: Standard_Boolean);
  }

export declare class GC_MakeTrimmedCone extends GC_Root {
  Value(): Handle_Geom_RectangularTrimmedSurface;
  delete(): void;
}

  export declare class GC_MakeTrimmedCone_1 extends GC_MakeTrimmedCone {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, P4: gp_Pnt);
  }

  export declare class GC_MakeTrimmedCone_2 extends GC_MakeTrimmedCone {
    constructor(P1: gp_Pnt, P2: gp_Pnt, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose);
  }

export declare class GC_MakeCylindricalSurface extends GC_Root {
  Value(): Handle_Geom_CylindricalSurface;
  delete(): void;
}

  export declare class GC_MakeCylindricalSurface_1 extends GC_MakeCylindricalSurface {
    constructor(A2: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCylindricalSurface_2 extends GC_MakeCylindricalSurface {
    constructor(C: gp_Cylinder);
  }

  export declare class GC_MakeCylindricalSurface_3 extends GC_MakeCylindricalSurface {
    constructor(Cyl: gp_Cylinder, Point: gp_Pnt);
  }

  export declare class GC_MakeCylindricalSurface_4 extends GC_MakeCylindricalSurface {
    constructor(Cyl: gp_Cylinder, Dist: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCylindricalSurface_5 extends GC_MakeCylindricalSurface {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class GC_MakeCylindricalSurface_6 extends GC_MakeCylindricalSurface {
    constructor(Axis: gp_Ax1, Radius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCylindricalSurface_7 extends GC_MakeCylindricalSurface {
    constructor(Circ: gp_Circ);
  }

export declare class GC_MakeLine extends GC_Root {
  Value(): Handle_Geom_Line;
  delete(): void;
}

  export declare class GC_MakeLine_1 extends GC_MakeLine {
    constructor(A1: gp_Ax1);
  }

  export declare class GC_MakeLine_2 extends GC_MakeLine {
    constructor(L: gp_Lin);
  }

  export declare class GC_MakeLine_3 extends GC_MakeLine {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

  export declare class GC_MakeLine_4 extends GC_MakeLine {
    constructor(Lin: gp_Lin, Point: gp_Pnt);
  }

  export declare class GC_MakeLine_5 extends GC_MakeLine {
    constructor(P1: gp_Pnt, P2: gp_Pnt);
  }

export declare class GC_MakeCircle extends GC_Root {
  Value(): Handle_Geom_Circle;
  delete(): void;
}

  export declare class GC_MakeCircle_1 extends GC_MakeCircle {
    constructor(C: gp_Circ);
  }

  export declare class GC_MakeCircle_2 extends GC_MakeCircle {
    constructor(A2: gp_Ax2, Radius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCircle_3 extends GC_MakeCircle {
    constructor(Circ: gp_Circ, Dist: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCircle_4 extends GC_MakeCircle {
    constructor(Circ: gp_Circ, Point: gp_Pnt);
  }

  export declare class GC_MakeCircle_5 extends GC_MakeCircle {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class GC_MakeCircle_6 extends GC_MakeCircle {
    constructor(Center: gp_Pnt, Norm: gp_Dir, Radius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCircle_7 extends GC_MakeCircle {
    constructor(Center: gp_Pnt, PtAxis: gp_Pnt, Radius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeCircle_8 extends GC_MakeCircle {
    constructor(Axis: gp_Ax1, Radius: Quantity_AbsorbedDose);
  }

export declare class GC_MakeTranslation {
  Value(): Handle_Geom_Transformation;
  delete(): void;
}

  export declare class GC_MakeTranslation_1 extends GC_MakeTranslation {
    constructor(Vect: gp_Vec);
  }

  export declare class GC_MakeTranslation_2 extends GC_MakeTranslation {
    constructor(Point1: gp_Pnt, Point2: gp_Pnt);
  }

export declare class GC_MakeArcOfEllipse extends GC_Root {
  Value(): Handle_Geom_TrimmedCurve;
  delete(): void;
}

  export declare class GC_MakeArcOfEllipse_1 extends GC_MakeArcOfEllipse {
    constructor(Elips: gp_Elips, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfEllipse_2 extends GC_MakeArcOfEllipse {
    constructor(Elips: gp_Elips, P: gp_Pnt, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfEllipse_3 extends GC_MakeArcOfEllipse {
    constructor(Elips: gp_Elips, P1: gp_Pnt, P2: gp_Pnt, Sense: Standard_Boolean);
  }

export declare class GC_MakeArcOfCircle extends GC_Root {
  Value(): Handle_Geom_TrimmedCurve;
  delete(): void;
}

  export declare class GC_MakeArcOfCircle_1 extends GC_MakeArcOfCircle {
    constructor(Circ: gp_Circ, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfCircle_2 extends GC_MakeArcOfCircle {
    constructor(Circ: gp_Circ, P: gp_Pnt, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfCircle_3 extends GC_MakeArcOfCircle {
    constructor(Circ: gp_Circ, P1: gp_Pnt, P2: gp_Pnt, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfCircle_4 extends GC_MakeArcOfCircle {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class GC_MakeArcOfCircle_5 extends GC_MakeArcOfCircle {
    constructor(P1: gp_Pnt, V: gp_Vec, P2: gp_Pnt);
  }

export declare class GC_MakeConicalSurface extends GC_Root {
  Value(): Handle_Geom_ConicalSurface;
  delete(): void;
}

  export declare class GC_MakeConicalSurface_1 extends GC_MakeConicalSurface {
    constructor(A2: gp_Ax2, Ang: Quantity_AbsorbedDose, Radius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeConicalSurface_2 extends GC_MakeConicalSurface {
    constructor(C: gp_Cone);
  }

  export declare class GC_MakeConicalSurface_3 extends GC_MakeConicalSurface {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt, P4: gp_Pnt);
  }

  export declare class GC_MakeConicalSurface_4 extends GC_MakeConicalSurface {
    constructor(P1: gp_Pnt, P2: gp_Pnt, R1: Quantity_AbsorbedDose, R2: Quantity_AbsorbedDose);
  }

export declare class GC_MakeMirror {
  Value(): Handle_Geom_Transformation;
  delete(): void;
}

  export declare class GC_MakeMirror_1 extends GC_MakeMirror {
    constructor(Point: gp_Pnt);
  }

  export declare class GC_MakeMirror_2 extends GC_MakeMirror {
    constructor(Axis: gp_Ax1);
  }

  export declare class GC_MakeMirror_3 extends GC_MakeMirror {
    constructor(Line: gp_Lin);
  }

  export declare class GC_MakeMirror_4 extends GC_MakeMirror {
    constructor(Point: gp_Pnt, Direc: gp_Dir);
  }

  export declare class GC_MakeMirror_5 extends GC_MakeMirror {
    constructor(Plane: gp_Pln);
  }

  export declare class GC_MakeMirror_6 extends GC_MakeMirror {
    constructor(Plane: gp_Ax2);
  }

export declare class GC_MakeScale {
  constructor(Point: gp_Pnt, Scale: Quantity_AbsorbedDose)
  Value(): Handle_Geom_Transformation;
  delete(): void;
}

export declare class GC_MakeRotation {
  Value(): Handle_Geom_Transformation;
  delete(): void;
}

  export declare class GC_MakeRotation_1 extends GC_MakeRotation {
    constructor(Line: gp_Lin, Angle: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeRotation_2 extends GC_MakeRotation {
    constructor(Axis: gp_Ax1, Angle: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeRotation_3 extends GC_MakeRotation {
    constructor(Point: gp_Pnt, Direc: gp_Dir, Angle: Quantity_AbsorbedDose);
  }

export declare class GC_MakeHyperbola extends GC_Root {
  Value(): Handle_Geom_Hyperbola;
  delete(): void;
}

  export declare class GC_MakeHyperbola_1 extends GC_MakeHyperbola {
    constructor(H: gp_Hypr);
  }

  export declare class GC_MakeHyperbola_2 extends GC_MakeHyperbola {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeHyperbola_3 extends GC_MakeHyperbola {
    constructor(S1: gp_Pnt, S2: gp_Pnt, Center: gp_Pnt);
  }

export declare class GC_MakePlane extends GC_Root {
  Value(): Handle_Geom_Plane;
  delete(): void;
}

  export declare class GC_MakePlane_1 extends GC_MakePlane {
    constructor(Pl: gp_Pln);
  }

  export declare class GC_MakePlane_2 extends GC_MakePlane {
    constructor(P: gp_Pnt, V: gp_Dir);
  }

  export declare class GC_MakePlane_3 extends GC_MakePlane {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose);
  }

  export declare class GC_MakePlane_4 extends GC_MakePlane {
    constructor(Pln: gp_Pln, Point: gp_Pnt);
  }

  export declare class GC_MakePlane_5 extends GC_MakePlane {
    constructor(Pln: gp_Pln, Dist: Quantity_AbsorbedDose);
  }

  export declare class GC_MakePlane_6 extends GC_MakePlane {
    constructor(P1: gp_Pnt, P2: gp_Pnt, P3: gp_Pnt);
  }

  export declare class GC_MakePlane_7 extends GC_MakePlane {
    constructor(Axis: gp_Ax1);
  }

export declare class GC_Root {
  constructor();
  IsDone(): Standard_Boolean;
  Status(): gce_ErrorType;
  delete(): void;
}

export declare class GC_MakeEllipse extends GC_Root {
  Value(): Handle_Geom_Ellipse;
  delete(): void;
}

  export declare class GC_MakeEllipse_1 extends GC_MakeEllipse {
    constructor(E: gp_Elips);
  }

  export declare class GC_MakeEllipse_2 extends GC_MakeEllipse {
    constructor(A2: gp_Ax2, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

  export declare class GC_MakeEllipse_3 extends GC_MakeEllipse {
    constructor(S1: gp_Pnt, S2: gp_Pnt, Center: gp_Pnt);
  }

export declare class GC_MakeArcOfParabola extends GC_Root {
  Value(): Handle_Geom_TrimmedCurve;
  delete(): void;
}

  export declare class GC_MakeArcOfParabola_1 extends GC_MakeArcOfParabola {
    constructor(Parab: gp_Parab, Alpha1: Quantity_AbsorbedDose, Alpha2: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfParabola_2 extends GC_MakeArcOfParabola {
    constructor(Parab: gp_Parab, P: gp_Pnt, Alpha: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class GC_MakeArcOfParabola_3 extends GC_MakeArcOfParabola {
    constructor(Parab: gp_Parab, P1: gp_Pnt, P2: gp_Pnt, Sense: Standard_Boolean);
  }

export declare class TopLoc_Location {
  IsIdentity(): Standard_Boolean;
  Identity(): void;
  FirstDatum(): Handle_TopLoc_Datum3D;
  FirstPower(): Graphic3d_ZLayerId;
  NextLocation(): TopLoc_Location;
  Transformation(): gp_Trsf;
  Inverted(): TopLoc_Location;
  Multiplied(Other: TopLoc_Location): TopLoc_Location;
  Divided(Other: TopLoc_Location): TopLoc_Location;
  Predivided(Other: TopLoc_Location): TopLoc_Location;
  Powered(pwr: Graphic3d_ZLayerId): TopLoc_Location;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsEqual(Other: TopLoc_Location): Standard_Boolean;
  IsDifferent(Other: TopLoc_Location): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  ShallowDump(S: Standard_OStream): void;
  delete(): void;
}

  export declare class TopLoc_Location_1 extends TopLoc_Location {
    constructor();
  }

  export declare class TopLoc_Location_2 extends TopLoc_Location {
    constructor(T: gp_Trsf);
  }

  export declare class TopLoc_Location_3 extends TopLoc_Location {
    constructor(D: Handle_TopLoc_Datum3D);
  }

export declare class TopLoc_MapLocationHasher {
  constructor();
  static HashCode(theKey: TopLoc_Location, theUpperBound: Standard_Integer): Standard_Integer;
  static IsEqual(theKey1: TopLoc_Location, theKey2: TopLoc_Location): Standard_Boolean;
  delete(): void;
}

export declare class Handle_TopLoc_Datum3D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopLoc_Datum3D): void;
  get(): TopLoc_Datum3D;
  delete(): void;
}

  export declare class Handle_TopLoc_Datum3D_1 extends Handle_TopLoc_Datum3D {
    constructor();
  }

  export declare class Handle_TopLoc_Datum3D_2 extends Handle_TopLoc_Datum3D {
    constructor(thePtr: TopLoc_Datum3D);
  }

  export declare class Handle_TopLoc_Datum3D_3 extends Handle_TopLoc_Datum3D {
    constructor(theHandle: Handle_TopLoc_Datum3D);
  }

  export declare class Handle_TopLoc_Datum3D_4 extends Handle_TopLoc_Datum3D {
    constructor(theHandle: Handle_TopLoc_Datum3D);
  }

export declare class TopLoc_Datum3D extends Standard_Transient {
  Transformation(): gp_Trsf;
  Trsf(): gp_Trsf;
  Form(): gp_TrsfForm;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  ShallowDump(S: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopLoc_Datum3D_1 extends TopLoc_Datum3D {
    constructor();
  }

  export declare class TopLoc_Datum3D_2 extends TopLoc_Datum3D {
    constructor(T: gp_Trsf);
  }

export declare class TopLoc_IndexedMapOfLocation extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_IndexedMap<TopLoc_Location, TopLoc_MapLocationHasher>): void;
  Assign(theOther: NCollection_IndexedMap<TopLoc_Location, TopLoc_MapLocationHasher>): any;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: TopLoc_Location): Standard_Integer;
  Contains(theKey1: TopLoc_Location): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopLoc_Location): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopLoc_Location): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): TopLoc_Location;
  FindIndex(theKey1: TopLoc_Location): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TopLoc_IndexedMapOfLocation_1 extends TopLoc_IndexedMapOfLocation {
    constructor();
  }

  export declare class TopLoc_IndexedMapOfLocation_2 extends TopLoc_IndexedMapOfLocation {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopLoc_IndexedMapOfLocation_3 extends TopLoc_IndexedMapOfLocation {
    constructor(theOther: NCollection_IndexedMap<TopLoc_Location, TopLoc_MapLocationHasher>);
  }

export declare class TopLoc_ItemLocation {
  constructor(D: Handle_TopLoc_Datum3D, P: Graphic3d_ZLayerId)
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopLoc_SListNodeOfItemLocation extends Standard_Transient {
  constructor(I: TopLoc_ItemLocation, aTail: TopLoc_SListOfItemLocation)
  Tail(): TopLoc_SListOfItemLocation;
  Value(): TopLoc_ItemLocation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopLoc_SListNodeOfItemLocation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopLoc_SListNodeOfItemLocation): void;
  get(): TopLoc_SListNodeOfItemLocation;
  delete(): void;
}

  export declare class Handle_TopLoc_SListNodeOfItemLocation_1 extends Handle_TopLoc_SListNodeOfItemLocation {
    constructor();
  }

  export declare class Handle_TopLoc_SListNodeOfItemLocation_2 extends Handle_TopLoc_SListNodeOfItemLocation {
    constructor(thePtr: TopLoc_SListNodeOfItemLocation);
  }

  export declare class Handle_TopLoc_SListNodeOfItemLocation_3 extends Handle_TopLoc_SListNodeOfItemLocation {
    constructor(theHandle: Handle_TopLoc_SListNodeOfItemLocation);
  }

  export declare class Handle_TopLoc_SListNodeOfItemLocation_4 extends Handle_TopLoc_SListNodeOfItemLocation {
    constructor(theHandle: Handle_TopLoc_SListNodeOfItemLocation);
  }

export declare class TopLoc_SListOfItemLocation {
  Assign(Other: TopLoc_SListOfItemLocation): TopLoc_SListOfItemLocation;
  IsEmpty(): Standard_Boolean;
  Clear(): void;
  Value(): TopLoc_ItemLocation;
  Tail(): TopLoc_SListOfItemLocation;
  Construct(anItem: TopLoc_ItemLocation): void;
  ToTail(): void;
  More(): Standard_Boolean;
  Next(): void;
  delete(): void;
}

  export declare class TopLoc_SListOfItemLocation_1 extends TopLoc_SListOfItemLocation {
    constructor();
  }

  export declare class TopLoc_SListOfItemLocation_2 extends TopLoc_SListOfItemLocation {
    constructor(anItem: TopLoc_ItemLocation, aTail: TopLoc_SListOfItemLocation);
  }

  export declare class TopLoc_SListOfItemLocation_3 extends TopLoc_SListOfItemLocation {
    constructor(Other: TopLoc_SListOfItemLocation);
  }

  export declare class TopLoc_SListOfItemLocation_4 extends TopLoc_SListOfItemLocation {
    constructor(theOther: TopLoc_SListOfItemLocation);
  }

export declare class TopLoc_MapOfLocation extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): void;
  Assign(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): any;
  ReSize(N: Standard_Integer): void;
  Add(K: TopLoc_Location): Standard_Boolean;
  Added(K: TopLoc_Location): TopLoc_Location;
  Contains_1(K: TopLoc_Location): Standard_Boolean;
  Remove(K: TopLoc_Location): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  Contains_2(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  Union(theLeft: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>, theRight: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): void;
  Unite(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  HasIntersection(theMap: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  Intersection(theLeft: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>, theRight: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): void;
  Intersect(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  Subtraction(theLeft: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>, theRight: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): void;
  Subtract(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  Difference(theLeft: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>, theRight: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): void;
  Differ(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>): Standard_Boolean;
  delete(): void;
}

  export declare class TopLoc_MapOfLocation_1 extends TopLoc_MapOfLocation {
    constructor();
  }

  export declare class TopLoc_MapOfLocation_2 extends TopLoc_MapOfLocation {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TopLoc_MapOfLocation_3 extends TopLoc_MapOfLocation {
    constructor(theOther: NCollection_Map<TopLoc_Location, TopLoc_MapLocationHasher>);
  }

export declare class FSD_Base64Decoder {
  constructor();
  static Decode(theStr: Standard_Byte, theLen: Standard_ThreadId): Handle_NCollection_Buffer;
  delete(): void;
}

export declare class Handle_FSD_File {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FSD_File): void;
  get(): FSD_File;
  delete(): void;
}

  export declare class Handle_FSD_File_1 extends Handle_FSD_File {
    constructor();
  }

  export declare class Handle_FSD_File_2 extends Handle_FSD_File {
    constructor(thePtr: FSD_File);
  }

  export declare class Handle_FSD_File_3 extends Handle_FSD_File {
    constructor(theHandle: Handle_FSD_File);
  }

  export declare class Handle_FSD_File_4 extends Handle_FSD_File {
    constructor(theHandle: Handle_FSD_File);
  }

export declare class Handle_FSD_CmpFile {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FSD_CmpFile): void;
  get(): FSD_CmpFile;
  delete(): void;
}

  export declare class Handle_FSD_CmpFile_1 extends Handle_FSD_CmpFile {
    constructor();
  }

  export declare class Handle_FSD_CmpFile_2 extends Handle_FSD_CmpFile {
    constructor(thePtr: FSD_CmpFile);
  }

  export declare class Handle_FSD_CmpFile_3 extends Handle_FSD_CmpFile {
    constructor(theHandle: Handle_FSD_CmpFile);
  }

  export declare class Handle_FSD_CmpFile_4 extends Handle_FSD_CmpFile {
    constructor(theHandle: Handle_FSD_CmpFile);
  }

export declare class FSD_CmpFile extends FSD_File {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Open(aName: XCAFDoc_PartId, aMode: Storage_OpenMode): Storage_Error;
  static IsGoodFileType(aName: XCAFDoc_PartId): Storage_Error;
  BeginWriteInfoSection(): Storage_Error;
  BeginReadInfoSection(): Storage_Error;
  WritePersistentObjectHeader(aRef: Graphic3d_ZLayerId, aType: Graphic3d_ZLayerId): void;
  BeginWritePersistentObjectData(): void;
  BeginWriteObjectData(): void;
  EndWriteObjectData(): void;
  EndWritePersistentObjectData(): void;
  ReadPersistentObjectHeader(aRef: Graphic3d_ZLayerId, aType: Graphic3d_ZLayerId): void;
  BeginReadPersistentObjectData(): void;
  BeginReadObjectData(): void;
  EndReadObjectData(): void;
  EndReadPersistentObjectData(): void;
  Destroy(): void;
  static MagicNumber(): Standard_CString;
  delete(): void;
}

export declare class Handle_FSD_BinaryFile {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: FSD_BinaryFile): void;
  get(): FSD_BinaryFile;
  delete(): void;
}

  export declare class Handle_FSD_BinaryFile_1 extends Handle_FSD_BinaryFile {
    constructor();
  }

  export declare class Handle_FSD_BinaryFile_2 extends Handle_FSD_BinaryFile {
    constructor(thePtr: FSD_BinaryFile);
  }

  export declare class Handle_FSD_BinaryFile_3 extends Handle_FSD_BinaryFile {
    constructor(theHandle: Handle_FSD_BinaryFile);
  }

  export declare class Handle_FSD_BinaryFile_4 extends Handle_FSD_BinaryFile {
    constructor(theHandle: Handle_FSD_BinaryFile);
  }

export declare class FSD_FileHeader {
  constructor();
  delete(): void;
}

export declare type TCollection_Side = {
  TCollection_Left: {};
  TCollection_Right: {};
}

export declare class TCollection_ExtendedString {
  AssignCat_1(other: TCollection_ExtendedString): void;
  AssignCat_2(theChar: Standard_Utf16Char): void;
  Cat(other: TCollection_ExtendedString): TCollection_ExtendedString;
  ChangeAll(aChar: Standard_ExtCharacter, NewChar: Standard_ExtCharacter): void;
  Clear(): void;
  Copy(fromwhere: TCollection_ExtendedString): void;
  Swap(theOther: TCollection_ExtendedString): void;
  Insert_1(where: Graphic3d_ZLayerId, what: Standard_ExtCharacter): void;
  Insert_2(where: Graphic3d_ZLayerId, what: TCollection_ExtendedString): void;
  IsEmpty(): Standard_Boolean;
  IsEqual_1(other: Standard_ExtString): Standard_Boolean;
  IsEqual_2(other: TCollection_ExtendedString): Standard_Boolean;
  IsDifferent_1(other: Standard_ExtString): Standard_Boolean;
  IsDifferent_2(other: TCollection_ExtendedString): Standard_Boolean;
  IsLess_1(other: Standard_ExtString): Standard_Boolean;
  IsLess_2(other: TCollection_ExtendedString): Standard_Boolean;
  IsGreater_1(other: Standard_ExtString): Standard_Boolean;
  IsGreater_2(other: TCollection_ExtendedString): Standard_Boolean;
  StartsWith(theStartString: TCollection_ExtendedString): Standard_Boolean;
  EndsWith(theEndString: TCollection_ExtendedString): Standard_Boolean;
  IsAscii(): Standard_Boolean;
  Length(): Graphic3d_ZLayerId;
  Print(astream: Standard_OStream): void;
  RemoveAll(what: Standard_ExtCharacter): void;
  Remove(where: Graphic3d_ZLayerId, ahowmany: Graphic3d_ZLayerId): void;
  Search(what: TCollection_ExtendedString): Graphic3d_ZLayerId;
  SearchFromEnd(what: TCollection_ExtendedString): Graphic3d_ZLayerId;
  SetValue_1(where: Graphic3d_ZLayerId, what: Standard_ExtCharacter): void;
  SetValue_2(where: Graphic3d_ZLayerId, what: TCollection_ExtendedString): void;
  Split(where: Graphic3d_ZLayerId): TCollection_ExtendedString;
  Token(separators: Standard_ExtString, whichone: Graphic3d_ZLayerId): TCollection_ExtendedString;
  ToExtString(): Standard_ExtString;
  Trunc(ahowmany: Graphic3d_ZLayerId): void;
  Value(where: Graphic3d_ZLayerId): Standard_ExtCharacter;
  static HashCode(theString: TCollection_ExtendedString, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual_3(theString1: TCollection_ExtendedString, theString2: TCollection_ExtendedString): Standard_Boolean;
  LengthOfCString(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class TCollection_ExtendedString_1 extends TCollection_ExtendedString {
    constructor();
  }

  export declare class TCollection_ExtendedString_2 extends TCollection_ExtendedString {
    constructor(astring: Standard_CString, isMultiByte: Standard_Boolean);
  }

  export declare class TCollection_ExtendedString_3 extends TCollection_ExtendedString {
    constructor(astring: Standard_ExtString);
  }

  export declare class TCollection_ExtendedString_4 extends TCollection_ExtendedString {
    constructor(theStringUtf: Standard_WideChar);
  }

  export declare class TCollection_ExtendedString_5 extends TCollection_ExtendedString {
    constructor(aChar: Standard_Character);
  }

  export declare class TCollection_ExtendedString_6 extends TCollection_ExtendedString {
    constructor(aChar: Standard_ExtCharacter);
  }

  export declare class TCollection_ExtendedString_7 extends TCollection_ExtendedString {
    constructor(length: Graphic3d_ZLayerId, filler: Standard_ExtCharacter);
  }

  export declare class TCollection_ExtendedString_8 extends TCollection_ExtendedString {
    constructor(value: Graphic3d_ZLayerId);
  }

  export declare class TCollection_ExtendedString_9 extends TCollection_ExtendedString {
    constructor(value: Quantity_AbsorbedDose);
  }

  export declare class TCollection_ExtendedString_10 extends TCollection_ExtendedString {
    constructor(astring: TCollection_ExtendedString);
  }

  export declare class TCollection_ExtendedString_11 extends TCollection_ExtendedString {
    constructor(theOther: TCollection_ExtendedString);
  }

  export declare class TCollection_ExtendedString_12 extends TCollection_ExtendedString {
    constructor(astring: XCAFDoc_PartId, isMultiByte: Standard_Boolean);
  }

export declare class Handle_TCollection_MapNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TCollection_MapNode): void;
  get(): TCollection_MapNode;
  delete(): void;
}

  export declare class Handle_TCollection_MapNode_1 extends Handle_TCollection_MapNode {
    constructor();
  }

  export declare class Handle_TCollection_MapNode_2 extends Handle_TCollection_MapNode {
    constructor(thePtr: TCollection_MapNode);
  }

  export declare class Handle_TCollection_MapNode_3 extends Handle_TCollection_MapNode {
    constructor(theHandle: Handle_TCollection_MapNode);
  }

  export declare class Handle_TCollection_MapNode_4 extends Handle_TCollection_MapNode {
    constructor(theHandle: Handle_TCollection_MapNode);
  }

export declare class TCollection_MapNode extends Standard_Transient {
  constructor(n: TCollection_MapNodePtr)
  Next(): TCollection_MapNodePtr;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TCollection_BaseSequence {
  IsEmpty(): Standard_Boolean;
  Length(): Graphic3d_ZLayerId;
  Reverse(): void;
  Exchange(I: Graphic3d_ZLayerId, J: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TCollection {
  constructor();
  static NextPrimeForMap(I: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class TCollection_SeqNode extends Standard_Transient {
  constructor(n: TCollection_SeqNodePtr, p: TCollection_SeqNodePtr)
  Next(): TCollection_SeqNodePtr;
  Previous(): TCollection_SeqNodePtr;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TCollection_SeqNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TCollection_SeqNode): void;
  get(): TCollection_SeqNode;
  delete(): void;
}

  export declare class Handle_TCollection_SeqNode_1 extends Handle_TCollection_SeqNode {
    constructor();
  }

  export declare class Handle_TCollection_SeqNode_2 extends Handle_TCollection_SeqNode {
    constructor(thePtr: TCollection_SeqNode);
  }

  export declare class Handle_TCollection_SeqNode_3 extends Handle_TCollection_SeqNode {
    constructor(theHandle: Handle_TCollection_SeqNode);
  }

  export declare class Handle_TCollection_SeqNode_4 extends Handle_TCollection_SeqNode {
    constructor(theHandle: Handle_TCollection_SeqNode);
  }

export declare class TCollection_BasicMapIterator {
  Reset(): void;
  More(): Standard_Boolean;
  Next(): void;
  delete(): void;
}

export declare class TCollection_BasicMap {
  NbBuckets(): Graphic3d_ZLayerId;
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Statistics(S: Standard_OStream): void;
  delete(): void;
}

export declare class Handle_TCollection_HAsciiString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TCollection_HAsciiString): void;
  get(): TCollection_HAsciiString;
  delete(): void;
}

  export declare class Handle_TCollection_HAsciiString_1 extends Handle_TCollection_HAsciiString {
    constructor();
  }

  export declare class Handle_TCollection_HAsciiString_2 extends Handle_TCollection_HAsciiString {
    constructor(thePtr: TCollection_HAsciiString);
  }

  export declare class Handle_TCollection_HAsciiString_3 extends Handle_TCollection_HAsciiString {
    constructor(theHandle: Handle_TCollection_HAsciiString);
  }

  export declare class Handle_TCollection_HAsciiString_4 extends Handle_TCollection_HAsciiString {
    constructor(theHandle: Handle_TCollection_HAsciiString);
  }

export declare class TCollection_HAsciiString extends Standard_Transient {
  AssignCat_1(other: Standard_CString): void;
  AssignCat_2(other: Handle_TCollection_HAsciiString): void;
  Capitalize(): void;
  Cat_1(other: Standard_CString): Handle_TCollection_HAsciiString;
  Cat_2(other: Handle_TCollection_HAsciiString): Handle_TCollection_HAsciiString;
  Center(Width: Graphic3d_ZLayerId, Filler: Standard_Character): void;
  ChangeAll(aChar: Standard_Character, NewChar: Standard_Character, CaseSensitive: Standard_Boolean): void;
  Clear(): void;
  FirstLocationInSet(Set: Handle_TCollection_HAsciiString, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  FirstLocationNotInSet(Set: Handle_TCollection_HAsciiString, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Insert_1(where: Graphic3d_ZLayerId, what: Standard_Character): void;
  Insert_2(where: Graphic3d_ZLayerId, what: Standard_CString): void;
  Insert_3(where: Graphic3d_ZLayerId, what: Handle_TCollection_HAsciiString): void;
  InsertAfter(Index: Graphic3d_ZLayerId, other: Handle_TCollection_HAsciiString): void;
  InsertBefore(Index: Graphic3d_ZLayerId, other: Handle_TCollection_HAsciiString): void;
  IsEmpty(): Standard_Boolean;
  IsLess(other: Handle_TCollection_HAsciiString): Standard_Boolean;
  IsGreater(other: Handle_TCollection_HAsciiString): Standard_Boolean;
  IntegerValue(): Graphic3d_ZLayerId;
  IsIntegerValue(): Standard_Boolean;
  IsRealValue(): Standard_Boolean;
  IsAscii(): Standard_Boolean;
  IsDifferent(S: Handle_TCollection_HAsciiString): Standard_Boolean;
  IsSameString_1(S: Handle_TCollection_HAsciiString): Standard_Boolean;
  IsSameString_2(S: Handle_TCollection_HAsciiString, CaseSensitive: Standard_Boolean): Standard_Boolean;
  LeftAdjust(): void;
  LeftJustify(Width: Graphic3d_ZLayerId, Filler: Standard_Character): void;
  Length(): Graphic3d_ZLayerId;
  Location_1(other: Handle_TCollection_HAsciiString, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Location_2(N: Graphic3d_ZLayerId, C: Standard_Character, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  LowerCase(): void;
  Prepend(other: Handle_TCollection_HAsciiString): void;
  Print(astream: Standard_OStream): void;
  RealValue(): Quantity_AbsorbedDose;
  RemoveAll_1(C: Standard_Character, CaseSensitive: Standard_Boolean): void;
  RemoveAll_2(what: Standard_Character): void;
  Remove(where: Graphic3d_ZLayerId, ahowmany: Graphic3d_ZLayerId): void;
  RightAdjust(): void;
  RightJustify(Width: Graphic3d_ZLayerId, Filler: Standard_Character): void;
  Search_1(what: Standard_CString): Graphic3d_ZLayerId;
  Search_2(what: Handle_TCollection_HAsciiString): Graphic3d_ZLayerId;
  SearchFromEnd_1(what: Standard_CString): Graphic3d_ZLayerId;
  SearchFromEnd_2(what: Handle_TCollection_HAsciiString): Graphic3d_ZLayerId;
  SetValue_1(where: Graphic3d_ZLayerId, what: Standard_Character): void;
  SetValue_2(where: Graphic3d_ZLayerId, what: Standard_CString): void;
  SetValue_3(where: Graphic3d_ZLayerId, what: Handle_TCollection_HAsciiString): void;
  Split(where: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  SubString(FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  ToCString(): Standard_CString;
  Token(separators: Standard_CString, whichone: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Trunc(ahowmany: Graphic3d_ZLayerId): void;
  UpperCase(): void;
  UsefullLength(): Graphic3d_ZLayerId;
  Value(where: Graphic3d_ZLayerId): Standard_Character;
  String(): XCAFDoc_PartId;
  IsSameState(other: Handle_TCollection_HAsciiString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TCollection_HAsciiString_1 extends TCollection_HAsciiString {
    constructor();
  }

  export declare class TCollection_HAsciiString_2 extends TCollection_HAsciiString {
    constructor(message: Standard_CString);
  }

  export declare class TCollection_HAsciiString_3 extends TCollection_HAsciiString {
    constructor(aChar: Standard_Character);
  }

  export declare class TCollection_HAsciiString_4 extends TCollection_HAsciiString {
    constructor(length: Graphic3d_ZLayerId, filler: Standard_Character);
  }

  export declare class TCollection_HAsciiString_5 extends TCollection_HAsciiString {
    constructor(value: Graphic3d_ZLayerId);
  }

  export declare class TCollection_HAsciiString_6 extends TCollection_HAsciiString {
    constructor(value: Quantity_AbsorbedDose);
  }

  export declare class TCollection_HAsciiString_7 extends TCollection_HAsciiString {
    constructor(aString: XCAFDoc_PartId);
  }

  export declare class TCollection_HAsciiString_8 extends TCollection_HAsciiString {
    constructor(aString: Handle_TCollection_HAsciiString);
  }

  export declare class TCollection_HAsciiString_9 extends TCollection_HAsciiString {
    constructor(aString: Handle_TCollection_HExtendedString, replaceNonAscii: Standard_Character);
  }

export declare class TCollection_AsciiString {
  AssignCat_1(other: Standard_Character): void;
  AssignCat_2(other: Graphic3d_ZLayerId): void;
  AssignCat_3(other: Quantity_AbsorbedDose): void;
  AssignCat_4(other: Standard_CString): void;
  AssignCat_5(other: XCAFDoc_PartId): void;
  Capitalize(): void;
  Cat_1(other: Standard_Character): XCAFDoc_PartId;
  Cat_2(other: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Cat_3(other: Quantity_AbsorbedDose): XCAFDoc_PartId;
  Cat_4(other: Standard_CString): XCAFDoc_PartId;
  Cat_5(other: XCAFDoc_PartId): XCAFDoc_PartId;
  Center(Width: Graphic3d_ZLayerId, Filler: Standard_Character): void;
  ChangeAll(aChar: Standard_Character, NewChar: Standard_Character, CaseSensitive: Standard_Boolean): void;
  Clear(): void;
  Copy_1(fromwhere: Standard_CString): void;
  Copy_2(fromwhere: XCAFDoc_PartId): void;
  Swap(theOther: XCAFDoc_PartId): void;
  FirstLocationInSet(Set: XCAFDoc_PartId, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  FirstLocationNotInSet(Set: XCAFDoc_PartId, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Insert_1(where: Graphic3d_ZLayerId, what: Standard_Character): void;
  Insert_2(where: Graphic3d_ZLayerId, what: Standard_CString): void;
  Insert_3(where: Graphic3d_ZLayerId, what: XCAFDoc_PartId): void;
  InsertAfter(Index: Graphic3d_ZLayerId, other: XCAFDoc_PartId): void;
  InsertBefore(Index: Graphic3d_ZLayerId, other: XCAFDoc_PartId): void;
  IsEmpty(): Standard_Boolean;
  IsEqual_1(other: Standard_CString): Standard_Boolean;
  IsEqual_2(other: XCAFDoc_PartId): Standard_Boolean;
  IsDifferent_1(other: Standard_CString): Standard_Boolean;
  IsDifferent_2(other: XCAFDoc_PartId): Standard_Boolean;
  IsLess_1(other: Standard_CString): Standard_Boolean;
  IsLess_2(other: XCAFDoc_PartId): Standard_Boolean;
  IsGreater_1(other: Standard_CString): Standard_Boolean;
  IsGreater_2(other: XCAFDoc_PartId): Standard_Boolean;
  StartsWith(theStartString: XCAFDoc_PartId): Standard_Boolean;
  EndsWith(theEndString: XCAFDoc_PartId): Standard_Boolean;
  IntegerValue(): Graphic3d_ZLayerId;
  IsIntegerValue(): Standard_Boolean;
  IsRealValue(): Standard_Boolean;
  IsAscii(): Standard_Boolean;
  LeftAdjust(): void;
  LeftJustify(Width: Graphic3d_ZLayerId, Filler: Standard_Character): void;
  Length(): Graphic3d_ZLayerId;
  Location_1(other: XCAFDoc_PartId, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Location_2(N: Graphic3d_ZLayerId, C: Standard_Character, FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  LowerCase(): void;
  Prepend(other: XCAFDoc_PartId): void;
  Print(astream: Standard_OStream): void;
  Read(astream: Standard_IStream): void;
  RealValue(): Quantity_AbsorbedDose;
  RemoveAll_1(C: Standard_Character, CaseSensitive: Standard_Boolean): void;
  RemoveAll_2(what: Standard_Character): void;
  Remove(where: Graphic3d_ZLayerId, ahowmany: Graphic3d_ZLayerId): void;
  RightAdjust(): void;
  RightJustify(Width: Graphic3d_ZLayerId, Filler: Standard_Character): void;
  Search_1(what: Standard_CString): Graphic3d_ZLayerId;
  Search_2(what: XCAFDoc_PartId): Graphic3d_ZLayerId;
  SearchFromEnd_1(what: Standard_CString): Graphic3d_ZLayerId;
  SearchFromEnd_2(what: XCAFDoc_PartId): Graphic3d_ZLayerId;
  SetValue_1(where: Graphic3d_ZLayerId, what: Standard_Character): void;
  SetValue_2(where: Graphic3d_ZLayerId, what: Standard_CString): void;
  SetValue_3(where: Graphic3d_ZLayerId, what: XCAFDoc_PartId): void;
  Split_1(where: Graphic3d_ZLayerId): XCAFDoc_PartId;
  SubString_1(FromIndex: Graphic3d_ZLayerId, ToIndex: Graphic3d_ZLayerId): XCAFDoc_PartId;
  ToCString(): Standard_CString;
  Token_1(separators: Standard_CString, whichone: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Trunc(ahowmany: Graphic3d_ZLayerId): void;
  UpperCase(): void;
  UsefullLength(): Graphic3d_ZLayerId;
  Value(where: Graphic3d_ZLayerId): Standard_Character;
  static HashCode(theAsciiString: XCAFDoc_PartId, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual_3(string1: XCAFDoc_PartId, string2: XCAFDoc_PartId): Standard_Boolean;
  static IsEqual_4(string1: XCAFDoc_PartId, string2: Standard_CString): Standard_Boolean;
  static IsSameString(theString1: XCAFDoc_PartId, theString2: XCAFDoc_PartId, theIsCaseSensitive: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

  export declare class TCollection_AsciiString_1 extends TCollection_AsciiString {
    constructor();
  }

  export declare class TCollection_AsciiString_2 extends TCollection_AsciiString {
    constructor(message: Standard_CString);
  }

  export declare class TCollection_AsciiString_3 extends TCollection_AsciiString {
    constructor(message: Standard_CString, aLen: Graphic3d_ZLayerId);
  }

  export declare class TCollection_AsciiString_4 extends TCollection_AsciiString {
    constructor(aChar: Standard_Character);
  }

  export declare class TCollection_AsciiString_5 extends TCollection_AsciiString {
    constructor(length: Graphic3d_ZLayerId, filler: Standard_Character);
  }

  export declare class TCollection_AsciiString_6 extends TCollection_AsciiString {
    constructor(value: Graphic3d_ZLayerId);
  }

  export declare class TCollection_AsciiString_7 extends TCollection_AsciiString {
    constructor(value: Quantity_AbsorbedDose);
  }

  export declare class TCollection_AsciiString_8 extends TCollection_AsciiString {
    constructor(astring: XCAFDoc_PartId);
  }

  export declare class TCollection_AsciiString_9 extends TCollection_AsciiString {
    constructor(theOther: XCAFDoc_PartId);
  }

  export declare class TCollection_AsciiString_10 extends TCollection_AsciiString {
    constructor(astring: XCAFDoc_PartId, message: Standard_Character);
  }

  export declare class TCollection_AsciiString_11 extends TCollection_AsciiString {
    constructor(astring: XCAFDoc_PartId, message: Standard_CString);
  }

  export declare class TCollection_AsciiString_12 extends TCollection_AsciiString {
    constructor(astring: XCAFDoc_PartId, message: XCAFDoc_PartId);
  }

  export declare class TCollection_AsciiString_13 extends TCollection_AsciiString {
    constructor(astring: TCollection_ExtendedString, replaceNonAscii: Standard_Character);
  }

  export declare class TCollection_AsciiString_14 extends TCollection_AsciiString {
    constructor(theStringUtf: Standard_WideChar);
  }

export declare class TCollection_HExtendedString extends Standard_Transient {
  AssignCat(other: Handle_TCollection_HExtendedString): void;
  Cat(other: Handle_TCollection_HExtendedString): Handle_TCollection_HExtendedString;
  ChangeAll(aChar: Standard_ExtCharacter, NewChar: Standard_ExtCharacter): void;
  Clear(): void;
  IsEmpty(): Standard_Boolean;
  Insert_1(where: Graphic3d_ZLayerId, what: Standard_ExtCharacter): void;
  Insert_2(where: Graphic3d_ZLayerId, what: Handle_TCollection_HExtendedString): void;
  IsLess(other: Handle_TCollection_HExtendedString): Standard_Boolean;
  IsGreater(other: Handle_TCollection_HExtendedString): Standard_Boolean;
  IsAscii(): Standard_Boolean;
  Length(): Graphic3d_ZLayerId;
  Remove(where: Graphic3d_ZLayerId, ahowmany: Graphic3d_ZLayerId): void;
  RemoveAll(what: Standard_ExtCharacter): void;
  SetValue_1(where: Graphic3d_ZLayerId, what: Standard_ExtCharacter): void;
  SetValue_2(where: Graphic3d_ZLayerId, what: Handle_TCollection_HExtendedString): void;
  Split(where: Graphic3d_ZLayerId): Handle_TCollection_HExtendedString;
  Search(what: Handle_TCollection_HExtendedString): Graphic3d_ZLayerId;
  SearchFromEnd(what: Handle_TCollection_HExtendedString): Graphic3d_ZLayerId;
  ToExtString(): Standard_ExtString;
  Token(separators: Standard_ExtString, whichone: Graphic3d_ZLayerId): Handle_TCollection_HExtendedString;
  Trunc(ahowmany: Graphic3d_ZLayerId): void;
  Value(where: Graphic3d_ZLayerId): Standard_ExtCharacter;
  String(): TCollection_ExtendedString;
  Print(astream: Standard_OStream): void;
  IsSameState(other: Handle_TCollection_HExtendedString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TCollection_HExtendedString_1 extends TCollection_HExtendedString {
    constructor();
  }

  export declare class TCollection_HExtendedString_2 extends TCollection_HExtendedString {
    constructor(message: Standard_CString);
  }

  export declare class TCollection_HExtendedString_3 extends TCollection_HExtendedString {
    constructor(message: Standard_ExtString);
  }

  export declare class TCollection_HExtendedString_4 extends TCollection_HExtendedString {
    constructor(aChar: Standard_ExtCharacter);
  }

  export declare class TCollection_HExtendedString_5 extends TCollection_HExtendedString {
    constructor(length: Graphic3d_ZLayerId, filler: Standard_ExtCharacter);
  }

  export declare class TCollection_HExtendedString_6 extends TCollection_HExtendedString {
    constructor(aString: TCollection_ExtendedString);
  }

  export declare class TCollection_HExtendedString_7 extends TCollection_HExtendedString {
    constructor(aString: Handle_TCollection_HAsciiString);
  }

  export declare class TCollection_HExtendedString_8 extends TCollection_HExtendedString {
    constructor(aString: Handle_TCollection_HExtendedString);
  }

export declare class Handle_TCollection_HExtendedString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TCollection_HExtendedString): void;
  get(): TCollection_HExtendedString;
  delete(): void;
}

  export declare class Handle_TCollection_HExtendedString_1 extends Handle_TCollection_HExtendedString {
    constructor();
  }

  export declare class Handle_TCollection_HExtendedString_2 extends Handle_TCollection_HExtendedString {
    constructor(thePtr: TCollection_HExtendedString);
  }

  export declare class Handle_TCollection_HExtendedString_3 extends Handle_TCollection_HExtendedString {
    constructor(theHandle: Handle_TCollection_HExtendedString);
  }

  export declare class Handle_TCollection_HExtendedString_4 extends Handle_TCollection_HExtendedString {
    constructor(theHandle: Handle_TCollection_HExtendedString);
  }

export declare class BRepOffset_DataMapOfShapeOffset extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepOffset_DataMapOfShapeOffset): void;
  Assign(theOther: BRepOffset_DataMapOfShapeOffset): BRepOffset_DataMapOfShapeOffset;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: BRepOffset_Offset): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: BRepOffset_Offset): BRepOffset_Offset;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): BRepOffset_Offset;
  ChangeSeek(theKey: TopoDS_Shape): BRepOffset_Offset;
  ChangeFind(theKey: TopoDS_Shape): BRepOffset_Offset;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepOffset_DataMapOfShapeOffset_1 extends BRepOffset_DataMapOfShapeOffset {
    constructor();
  }

  export declare class BRepOffset_DataMapOfShapeOffset_2 extends BRepOffset_DataMapOfShapeOffset {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepOffset_DataMapOfShapeOffset_3 extends BRepOffset_DataMapOfShapeOffset {
    constructor(theOther: BRepOffset_DataMapOfShapeOffset);
  }

export declare class BRepOffset_Inter2d {
  constructor();
  static Compute(AsDes: Handle_BRepAlgo_AsDes, F: TopoDS_Face, NewEdges: TopTools_IndexedMapOfShape, Tol: Quantity_AbsorbedDose, theEdgeIntEdges: TopTools_DataMapOfShapeListOfShape, theDMVV: TopTools_IndexedDataMapOfShapeListOfShape): void;
  static ConnexIntByInt(FI: TopoDS_Face, OFI: BRepOffset_Offset, MES: TopTools_DataMapOfShapeShape, Build: TopTools_DataMapOfShapeShape, theAsDes: Handle_BRepAlgo_AsDes, AsDes2d: Handle_BRepAlgo_AsDes, Offset: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Analyse: BRepOffset_Analyse, FacesWithVerts: TopTools_IndexedMapOfShape, theImageVV: BRepAlgo_Image, theEdgeIntEdges: TopTools_DataMapOfShapeListOfShape, theDMVV: TopTools_IndexedDataMapOfShapeListOfShape): Standard_Boolean;
  static ConnexIntByIntInVert(FI: TopoDS_Face, OFI: BRepOffset_Offset, MES: TopTools_DataMapOfShapeShape, Build: TopTools_DataMapOfShapeShape, AsDes: Handle_BRepAlgo_AsDes, AsDes2d: Handle_BRepAlgo_AsDes, Tol: Quantity_AbsorbedDose, Analyse: BRepOffset_Analyse, theDMVV: TopTools_IndexedDataMapOfShapeListOfShape): void;
  static FuseVertices(theDMVV: TopTools_IndexedDataMapOfShapeListOfShape, theAsDes: Handle_BRepAlgo_AsDes, theImageVV: BRepAlgo_Image): Standard_Boolean;
  static ExtentEdge(E: TopoDS_Edge, NE: TopoDS_Edge, theOffset: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class BRepOffset_ListOfInterval extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BRepOffset_ListOfInterval): BRepOffset_ListOfInterval;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BRepOffset_Interval;
  First_2(): BRepOffset_Interval;
  Last_1(): BRepOffset_Interval;
  Last_2(): BRepOffset_Interval;
  Append_1(theItem: BRepOffset_Interval): BRepOffset_Interval;
  Append_3(theOther: BRepOffset_ListOfInterval): void;
  Prepend_1(theItem: BRepOffset_Interval): BRepOffset_Interval;
  Prepend_2(theOther: BRepOffset_ListOfInterval): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BRepOffset_ListOfInterval_1 extends BRepOffset_ListOfInterval {
    constructor();
  }

  export declare class BRepOffset_ListOfInterval_2 extends BRepOffset_ListOfInterval {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepOffset_ListOfInterval_3 extends BRepOffset_ListOfInterval {
    constructor(theOther: BRepOffset_ListOfInterval);
  }

export declare type BRepOffset_Error = {
  BRepOffset_NoError: {};
  BRepOffset_UnknownError: {};
  BRepOffset_BadNormalsOnGeometry: {};
  BRepOffset_C0Geometry: {};
  BRepOffset_NullOffset: {};
  BRepOffset_NotConnectedShell: {};
  BRepOffset_CannotTrimEdges: {};
  BRepOffset_CannotFuseVertices: {};
  BRepOffset_CannotExtentEdge: {};
}

export declare class BRepOffset_DataMapOfShapeMapOfShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepOffset_DataMapOfShapeMapOfShape): void;
  Assign(theOther: BRepOffset_DataMapOfShapeMapOfShape): BRepOffset_DataMapOfShapeMapOfShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TopTools_MapOfShape): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TopTools_MapOfShape): TopTools_MapOfShape;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TopTools_MapOfShape;
  ChangeSeek(theKey: TopoDS_Shape): TopTools_MapOfShape;
  ChangeFind(theKey: TopoDS_Shape): TopTools_MapOfShape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepOffset_DataMapOfShapeMapOfShape_1 extends BRepOffset_DataMapOfShapeMapOfShape {
    constructor();
  }

  export declare class BRepOffset_DataMapOfShapeMapOfShape_2 extends BRepOffset_DataMapOfShapeMapOfShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepOffset_DataMapOfShapeMapOfShape_3 extends BRepOffset_DataMapOfShapeMapOfShape {
    constructor(theOther: BRepOffset_DataMapOfShapeMapOfShape);
  }

export declare class BRepOffset_Analyse {
  Perform(theS: TopoDS_Shape, theAngle: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Type(theE: TopoDS_Edge): BRepOffset_ListOfInterval;
  Edges_1(theV: TopoDS_Vertex, theType: ChFiDS_TypeOfConcavity, theL: TopTools_ListOfShape): void;
  Edges_2(theF: TopoDS_Face, theType: ChFiDS_TypeOfConcavity, theL: TopTools_ListOfShape): void;
  TangentEdges(theEdge: TopoDS_Edge, theVertex: TopoDS_Vertex, theEdges: TopTools_ListOfShape): void;
  HasAncestor(theS: TopoDS_Shape): Standard_Boolean;
  Ancestors(theS: TopoDS_Shape): TopTools_ListOfShape;
  Explode_1(theL: TopTools_ListOfShape, theType: ChFiDS_TypeOfConcavity): void;
  Explode_2(theL: TopTools_ListOfShape, theType1: ChFiDS_TypeOfConcavity, theType2: ChFiDS_TypeOfConcavity): void;
  AddFaces_1(theFace: TopoDS_Face, theCo: TopoDS_Compound, theMap: TopTools_MapOfShape, theType: ChFiDS_TypeOfConcavity): void;
  AddFaces_2(theFace: TopoDS_Face, theCo: TopoDS_Compound, theMap: TopTools_MapOfShape, theType1: ChFiDS_TypeOfConcavity, theType2: ChFiDS_TypeOfConcavity): void;
  SetOffsetValue(theOffset: Quantity_AbsorbedDose): void;
  SetFaceOffsetMap(theMap: TopTools_DataMapOfShapeReal): void;
  NewFaces(): TopTools_ListOfShape;
  Generated(theS: TopoDS_Shape): TopoDS_Shape;
  HasGenerated(theS: TopoDS_Shape): Standard_Boolean;
  EdgeReplacement(theFace: TopoDS_Face, theEdge: TopoDS_Edge): TopoDS_Edge;
  Descendants(theS: TopoDS_Shape, theUpdate: Standard_Boolean): TopTools_ListOfShape;
  Clear(): void;
  delete(): void;
}

  export declare class BRepOffset_Analyse_1 extends BRepOffset_Analyse {
    constructor();
  }

  export declare class BRepOffset_Analyse_2 extends BRepOffset_Analyse {
    constructor(theS: TopoDS_Shape, theAngle: Quantity_AbsorbedDose);
  }

export declare class BRepOffset_DataMapOfShapeListOfInterval extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BRepOffset_DataMapOfShapeListOfInterval): void;
  Assign(theOther: BRepOffset_DataMapOfShapeListOfInterval): BRepOffset_DataMapOfShapeListOfInterval;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: BRepOffset_ListOfInterval): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: BRepOffset_ListOfInterval): BRepOffset_ListOfInterval;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): BRepOffset_ListOfInterval;
  ChangeSeek(theKey: TopoDS_Shape): BRepOffset_ListOfInterval;
  ChangeFind(theKey: TopoDS_Shape): BRepOffset_ListOfInterval;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BRepOffset_DataMapOfShapeListOfInterval_1 extends BRepOffset_DataMapOfShapeListOfInterval {
    constructor();
  }

  export declare class BRepOffset_DataMapOfShapeListOfInterval_2 extends BRepOffset_DataMapOfShapeListOfInterval {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepOffset_DataMapOfShapeListOfInterval_3 extends BRepOffset_DataMapOfShapeListOfInterval {
    constructor(theOther: BRepOffset_DataMapOfShapeListOfInterval);
  }

export declare type BRepOffset_Mode = {
  BRepOffset_Skin: {};
  BRepOffset_Pipe: {};
  BRepOffset_RectoVerso: {};
}

export declare type BRepOffset_Status = {
  BRepOffset_Good: {};
  BRepOffset_Reversed: {};
  BRepOffset_Degenerated: {};
  BRepOffset_Unknown: {};
}

export declare class BRepOffset_Inter3d {
  constructor(AsDes: Handle_BRepAlgo_AsDes, Side: TopAbs_State, Tol: Quantity_AbsorbedDose)
  CompletInt(SetOfFaces: TopTools_ListOfShape, InitOffsetFace: BRepAlgo_Image): void;
  FaceInter(F1: TopoDS_Face, F2: TopoDS_Face, InitOffsetFace: BRepAlgo_Image): void;
  ConnexIntByArc(SetOfFaces: TopTools_ListOfShape, ShapeInit: TopoDS_Shape, Analyse: BRepOffset_Analyse, InitOffsetFace: BRepAlgo_Image): void;
  ConnexIntByInt(SI: TopoDS_Shape, MapSF: BRepOffset_DataMapOfShapeOffset, A: BRepOffset_Analyse, MES: TopTools_DataMapOfShapeShape, Build: TopTools_DataMapOfShapeShape, Failed: TopTools_ListOfShape, bIsPlanar: Standard_Boolean): void;
  ContextIntByInt(ContextFaces: TopTools_IndexedMapOfShape, ExtentContext: Standard_Boolean, MapSF: BRepOffset_DataMapOfShapeOffset, A: BRepOffset_Analyse, MES: TopTools_DataMapOfShapeShape, Build: TopTools_DataMapOfShapeShape, Failed: TopTools_ListOfShape, bIsPlanar: Standard_Boolean): void;
  ContextIntByArc(ContextFaces: TopTools_IndexedMapOfShape, ExtentContext: Standard_Boolean, Analyse: BRepOffset_Analyse, InitOffsetFace: BRepAlgo_Image, InitOffsetEdge: BRepAlgo_Image): void;
  AddCommonEdges(SetOfFaces: TopTools_ListOfShape): void;
  SetDone(F1: TopoDS_Face, F2: TopoDS_Face): void;
  IsDone(F1: TopoDS_Face, F2: TopoDS_Face): Standard_Boolean;
  TouchedFaces(): TopTools_IndexedMapOfShape;
  AsDes(): Handle_BRepAlgo_AsDes;
  NewEdges(): TopTools_IndexedMapOfShape;
  delete(): void;
}

export declare class BRepOffset_Offset {
  Init_1(Face: TopoDS_Face, Offset: Quantity_AbsorbedDose, OffsetOutside: Standard_Boolean, JoinType: GeomAbs_JoinType): void;
  Init_2(Face: TopoDS_Face, Offset: Quantity_AbsorbedDose, Created: TopTools_DataMapOfShapeShape, OffsetOutside: Standard_Boolean, JoinType: GeomAbs_JoinType): void;
  Init_3(Path: TopoDS_Edge, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Offset: Quantity_AbsorbedDose, Polynomial: Standard_Boolean, Tol: Quantity_AbsorbedDose, Conti: GeomAbs_Shape): void;
  Init_4(Path: TopoDS_Edge, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Offset: Quantity_AbsorbedDose, FirstEdge: TopoDS_Edge, LastEdge: TopoDS_Edge, Polynomial: Standard_Boolean, Tol: Quantity_AbsorbedDose, Conti: GeomAbs_Shape): void;
  Init_5(Vertex: TopoDS_Vertex, LEdge: TopTools_ListOfShape, Offset: Quantity_AbsorbedDose, Polynomial: Standard_Boolean, Tol: Quantity_AbsorbedDose, Conti: GeomAbs_Shape): void;
  Init_6(Edge: TopoDS_Edge, Offset: Quantity_AbsorbedDose): void;
  InitialShape(): TopoDS_Shape;
  Face(): TopoDS_Face;
  Generated(Shape: TopoDS_Shape): TopoDS_Shape;
  Status(): BRepOffset_Status;
  delete(): void;
}

  export declare class BRepOffset_Offset_1 extends BRepOffset_Offset {
    constructor();
  }

  export declare class BRepOffset_Offset_2 extends BRepOffset_Offset {
    constructor(Face: TopoDS_Face, Offset: Quantity_AbsorbedDose, OffsetOutside: Standard_Boolean, JoinType: GeomAbs_JoinType);
  }

  export declare class BRepOffset_Offset_3 extends BRepOffset_Offset {
    constructor(Face: TopoDS_Face, Offset: Quantity_AbsorbedDose, Created: TopTools_DataMapOfShapeShape, OffsetOutside: Standard_Boolean, JoinType: GeomAbs_JoinType);
  }

  export declare class BRepOffset_Offset_4 extends BRepOffset_Offset {
    constructor(Path: TopoDS_Edge, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Offset: Quantity_AbsorbedDose, Polynomial: Standard_Boolean, Tol: Quantity_AbsorbedDose, Conti: GeomAbs_Shape);
  }

  export declare class BRepOffset_Offset_5 extends BRepOffset_Offset {
    constructor(Path: TopoDS_Edge, Edge1: TopoDS_Edge, Edge2: TopoDS_Edge, Offset: Quantity_AbsorbedDose, FirstEdge: TopoDS_Edge, LastEdge: TopoDS_Edge, Polynomial: Standard_Boolean, Tol: Quantity_AbsorbedDose, Conti: GeomAbs_Shape);
  }

  export declare class BRepOffset_Offset_6 extends BRepOffset_Offset {
    constructor(Vertex: TopoDS_Vertex, LEdge: TopTools_ListOfShape, Offset: Quantity_AbsorbedDose, Polynomial: Standard_Boolean, Tol: Quantity_AbsorbedDose, Conti: GeomAbs_Shape);
  }

export declare class BRepOffset_Interval {
  First_1(U: Quantity_AbsorbedDose): void;
  Last_1(U: Quantity_AbsorbedDose): void;
  Type_1(T: ChFiDS_TypeOfConcavity): void;
  First_2(): Quantity_AbsorbedDose;
  Last_2(): Quantity_AbsorbedDose;
  Type_2(): ChFiDS_TypeOfConcavity;
  delete(): void;
}

  export declare class BRepOffset_Interval_1 extends BRepOffset_Interval {
    constructor();
  }

  export declare class BRepOffset_Interval_2 extends BRepOffset_Interval {
    constructor(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Type: ChFiDS_TypeOfConcavity);
  }

export declare class BRepOffset {
  constructor();
  static Surface(Surface: Handle_Geom_Surface, Offset: Quantity_AbsorbedDose, theStatus: BRepOffset_Status, allowC0: Standard_Boolean): Handle_Geom_Surface;
  static CollapseSingularities(theSurface: Handle_Geom_Surface, theFace: TopoDS_Face, thePrecision: Quantity_AbsorbedDose): Handle_Geom_Surface;
  delete(): void;
}

export declare class BRepOffset_MakeLoops {
  constructor()
  Build(LF: TopTools_ListOfShape, AsDes: Handle_BRepAlgo_AsDes, Image: BRepAlgo_Image, theImageVV: BRepAlgo_Image): void;
  BuildOnContext(LContext: TopTools_ListOfShape, Analyse: BRepOffset_Analyse, AsDes: Handle_BRepAlgo_AsDes, Image: BRepAlgo_Image, InSide: Standard_Boolean): void;
  BuildFaces(LF: TopTools_ListOfShape, AsDes: Handle_BRepAlgo_AsDes, Image: BRepAlgo_Image): void;
  delete(): void;
}

export declare class BRepOffset_SimpleOffset extends BRepTools_Modification {
  constructor(theInputShape: TopoDS_Shape, theOffsetValue: Quantity_AbsorbedDose, theTolerance: Quantity_AbsorbedDose)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewSurface(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  delete(): void;
}

export declare class Handle_BRepOffset_SimpleOffset {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepOffset_SimpleOffset): void;
  get(): BRepOffset_SimpleOffset;
  delete(): void;
}

  export declare class Handle_BRepOffset_SimpleOffset_1 extends Handle_BRepOffset_SimpleOffset {
    constructor();
  }

  export declare class Handle_BRepOffset_SimpleOffset_2 extends Handle_BRepOffset_SimpleOffset {
    constructor(thePtr: BRepOffset_SimpleOffset);
  }

  export declare class Handle_BRepOffset_SimpleOffset_3 extends Handle_BRepOffset_SimpleOffset {
    constructor(theHandle: Handle_BRepOffset_SimpleOffset);
  }

  export declare class Handle_BRepOffset_SimpleOffset_4 extends Handle_BRepOffset_SimpleOffset {
    constructor(theHandle: Handle_BRepOffset_SimpleOffset);
  }

export declare class BRepOffset_MakeSimpleOffset {
  Initialize(theInputShape: TopoDS_Shape, theOffsetValue: Quantity_AbsorbedDose): void;
  Perform(): void;
  GetErrorMessage(): XCAFDoc_PartId;
  GetError(): BRepOffsetSimple_Status;
  GetBuildSolidFlag(): Standard_Boolean;
  SetBuildSolidFlag(theBuildFlag: Standard_Boolean): void;
  GetOffsetValue(): Quantity_AbsorbedDose;
  SetOffsetValue(theOffsetValue: Quantity_AbsorbedDose): void;
  GetTolerance(): Quantity_AbsorbedDose;
  SetTolerance(theValue: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  GetResultShape(): TopoDS_Shape;
  GetSafeOffset(theExpectedToler: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Generated(theShape: TopoDS_Shape): TopoDS_Shape;
  Modified(theShape: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepOffset_MakeSimpleOffset_1 extends BRepOffset_MakeSimpleOffset {
    constructor();
  }

  export declare class BRepOffset_MakeSimpleOffset_2 extends BRepOffset_MakeSimpleOffset {
    constructor(theInputShape: TopoDS_Shape, theOffsetValue: Quantity_AbsorbedDose);
  }

export declare type BRepOffsetSimple_Status = {
  BRepOffsetSimple_OK: {};
  BRepOffsetSimple_NullInputShape: {};
  BRepOffsetSimple_ErrorOffsetComputation: {};
  BRepOffsetSimple_ErrorWallFaceComputation: {};
  BRepOffsetSimple_ErrorInvalidNbShells: {};
  BRepOffsetSimple_ErrorNonClosedShell: {};
}

export declare class BRepOffset_Tool {
  constructor();
  static EdgeVertices(E: TopoDS_Edge, V1: TopoDS_Vertex, V2: TopoDS_Vertex): void;
  static OrientSection(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, O1: TopAbs_Orientation, O2: TopAbs_Orientation): void;
  static FindCommonShapes_1(theF1: TopoDS_Face, theF2: TopoDS_Face, theLE: TopTools_ListOfShape, theLV: TopTools_ListOfShape): Standard_Boolean;
  static FindCommonShapes_2(theS1: TopoDS_Shape, theS2: TopoDS_Shape, theType: TopAbs_ShapeEnum, theLSC: TopTools_ListOfShape): Standard_Boolean;
  static Inter3D(F1: TopoDS_Face, F2: TopoDS_Face, LInt1: TopTools_ListOfShape, LInt2: TopTools_ListOfShape, Side: TopAbs_State, RefEdge: TopoDS_Edge, RefFace1: TopoDS_Face, RefFace2: TopoDS_Face): void;
  static TryProject(F1: TopoDS_Face, F2: TopoDS_Face, Edges: TopTools_ListOfShape, LInt1: TopTools_ListOfShape, LInt2: TopTools_ListOfShape, Side: TopAbs_State, TolConf: Quantity_AbsorbedDose): Standard_Boolean;
  static PipeInter(F1: TopoDS_Face, F2: TopoDS_Face, LInt1: TopTools_ListOfShape, LInt2: TopTools_ListOfShape, Side: TopAbs_State): void;
  static Inter2d(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, LV: TopTools_ListOfShape, Tol: Quantity_AbsorbedDose): void;
  static InterOrExtent(F1: TopoDS_Face, F2: TopoDS_Face, LInt1: TopTools_ListOfShape, LInt2: TopTools_ListOfShape, Side: TopAbs_State): void;
  static CheckBounds(F: TopoDS_Face, Analyse: BRepOffset_Analyse, enlargeU: Standard_Boolean, enlargeVfirst: Standard_Boolean, enlargeVlast: Standard_Boolean): void;
  static EnLargeFace(F: TopoDS_Face, NF: TopoDS_Face, ChangeGeom: Standard_Boolean, UpDatePCurve: Standard_Boolean, enlargeU: Standard_Boolean, enlargeVfirst: Standard_Boolean, enlargeVlast: Standard_Boolean, theExtensionMode: Graphic3d_ZLayerId, theLenBeforeUfirst: Quantity_AbsorbedDose, theLenAfterUlast: Quantity_AbsorbedDose, theLenBeforeVfirst: Quantity_AbsorbedDose, theLenAfterVlast: Quantity_AbsorbedDose): Standard_Boolean;
  static ExtentFace(F: TopoDS_Face, ConstShapes: TopTools_DataMapOfShapeShape, ToBuild: TopTools_DataMapOfShapeShape, Side: TopAbs_State, TolConf: Quantity_AbsorbedDose, NF: TopoDS_Face): void;
  static BuildNeighbour(W: TopoDS_Wire, F: TopoDS_Face, NOnV1: TopTools_DataMapOfShapeShape, NOnV2: TopTools_DataMapOfShapeShape): void;
  static MapVertexEdges(S: TopoDS_Shape, MVE: TopTools_DataMapOfShapeListOfShape): void;
  static Deboucle3D(S: TopoDS_Shape, Boundary: TopTools_MapOfShape): TopoDS_Shape;
  static CorrectOrientation(SI: TopoDS_Shape, NewEdges: TopTools_IndexedMapOfShape, AsDes: Handle_BRepAlgo_AsDes, InitOffset: BRepAlgo_Image, Offset: Quantity_AbsorbedDose): void;
  static Gabarit(aCurve: Handle_Geom_Curve): Quantity_AbsorbedDose;
  static CheckPlanesNormals(theFace1: TopoDS_Face, theFace2: TopoDS_Face, theTolAng: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Handle_StepElement_HArray1OfVolumeElementPurpose {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfVolumeElementPurpose): void;
  get(): StepElement_HArray1OfVolumeElementPurpose;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfVolumeElementPurpose_1 extends Handle_StepElement_HArray1OfVolumeElementPurpose {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfVolumeElementPurpose_2 extends Handle_StepElement_HArray1OfVolumeElementPurpose {
    constructor(thePtr: StepElement_HArray1OfVolumeElementPurpose);
  }

  export declare class Handle_StepElement_HArray1OfVolumeElementPurpose_3 extends Handle_StepElement_HArray1OfVolumeElementPurpose {
    constructor(theHandle: Handle_StepElement_HArray1OfVolumeElementPurpose);
  }

  export declare class Handle_StepElement_HArray1OfVolumeElementPurpose_4 extends Handle_StepElement_HArray1OfVolumeElementPurpose {
    constructor(theHandle: Handle_StepElement_HArray1OfVolumeElementPurpose);
  }

export declare class StepElement_ElementAspect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetElementVolume(aVal: StepElement_ElementVolume): void;
  ElementVolume(): StepElement_ElementVolume;
  SetVolume3dFace(aVal: Graphic3d_ZLayerId): void;
  Volume3dFace(): Graphic3d_ZLayerId;
  SetVolume2dFace(aVal: Graphic3d_ZLayerId): void;
  Volume2dFace(): Graphic3d_ZLayerId;
  SetVolume3dEdge(aVal: Graphic3d_ZLayerId): void;
  Volume3dEdge(): Graphic3d_ZLayerId;
  SetVolume2dEdge(aVal: Graphic3d_ZLayerId): void;
  Volume2dEdge(): Graphic3d_ZLayerId;
  SetSurface3dFace(aVal: Graphic3d_ZLayerId): void;
  Surface3dFace(): Graphic3d_ZLayerId;
  SetSurface2dFace(aVal: Graphic3d_ZLayerId): void;
  Surface2dFace(): Graphic3d_ZLayerId;
  SetSurface3dEdge(aVal: Graphic3d_ZLayerId): void;
  Surface3dEdge(): Graphic3d_ZLayerId;
  SetSurface2dEdge(aVal: Graphic3d_ZLayerId): void;
  Surface2dEdge(): Graphic3d_ZLayerId;
  SetCurveEdge(aVal: StepElement_CurveEdge): void;
  CurveEdge(): StepElement_CurveEdge;
  delete(): void;
}

export declare class Handle_StepElement_Surface3dElementDescriptor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_Surface3dElementDescriptor): void;
  get(): StepElement_Surface3dElementDescriptor;
  delete(): void;
}

  export declare class Handle_StepElement_Surface3dElementDescriptor_1 extends Handle_StepElement_Surface3dElementDescriptor {
    constructor();
  }

  export declare class Handle_StepElement_Surface3dElementDescriptor_2 extends Handle_StepElement_Surface3dElementDescriptor {
    constructor(thePtr: StepElement_Surface3dElementDescriptor);
  }

  export declare class Handle_StepElement_Surface3dElementDescriptor_3 extends Handle_StepElement_Surface3dElementDescriptor {
    constructor(theHandle: Handle_StepElement_Surface3dElementDescriptor);
  }

  export declare class Handle_StepElement_Surface3dElementDescriptor_4 extends Handle_StepElement_Surface3dElementDescriptor {
    constructor(theHandle: Handle_StepElement_Surface3dElementDescriptor);
  }

export declare class StepElement_Surface3dElementDescriptor extends StepElement_ElementDescriptor {
  constructor()
  Init(aElementDescriptor_TopologyOrder: StepElement_ElementOrder, aElementDescriptor_Description: Handle_TCollection_HAsciiString, aPurpose: Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember, aShape: StepElement_Element2dShape): void;
  Purpose(): Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember;
  SetPurpose(Purpose: Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember): void;
  Shape(): StepElement_Element2dShape;
  SetShape(Shape: StepElement_Element2dShape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepElement_EnumeratedCurveElementFreedom = {
  StepElement_XTranslation: {};
  StepElement_YTranslation: {};
  StepElement_ZTranslation: {};
  StepElement_XRotation: {};
  StepElement_YRotation: {};
  StepElement_ZRotation: {};
  StepElement_Warp: {};
  StepElement_None: {};
}

export declare class StepElement_CurveElementPurposeMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_CurveElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_CurveElementPurposeMember): void;
  get(): StepElement_CurveElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_CurveElementPurposeMember_1 extends Handle_StepElement_CurveElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_CurveElementPurposeMember_2 extends Handle_StepElement_CurveElementPurposeMember {
    constructor(thePtr: StepElement_CurveElementPurposeMember);
  }

  export declare class Handle_StepElement_CurveElementPurposeMember_3 extends Handle_StepElement_CurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_CurveElementPurposeMember);
  }

  export declare class Handle_StepElement_CurveElementPurposeMember_4 extends Handle_StepElement_CurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_CurveElementPurposeMember);
  }

export declare class StepElement_Array1OfVolumeElementPurpose {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepElement_VolumeElementPurpose): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepElement_Array1OfVolumeElementPurpose): StepElement_Array1OfVolumeElementPurpose;
  Move(theOther: StepElement_Array1OfVolumeElementPurpose): StepElement_Array1OfVolumeElementPurpose;
  First(): StepElement_VolumeElementPurpose;
  ChangeFirst(): StepElement_VolumeElementPurpose;
  Last(): StepElement_VolumeElementPurpose;
  ChangeLast(): StepElement_VolumeElementPurpose;
  Value(theIndex: Standard_Integer): StepElement_VolumeElementPurpose;
  ChangeValue(theIndex: Standard_Integer): StepElement_VolumeElementPurpose;
  SetValue(theIndex: Standard_Integer, theItem: StepElement_VolumeElementPurpose): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepElement_Array1OfVolumeElementPurpose_1 extends StepElement_Array1OfVolumeElementPurpose {
    constructor();
  }

  export declare class StepElement_Array1OfVolumeElementPurpose_2 extends StepElement_Array1OfVolumeElementPurpose {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepElement_Array1OfVolumeElementPurpose_3 extends StepElement_Array1OfVolumeElementPurpose {
    constructor(theOther: StepElement_Array1OfVolumeElementPurpose);
  }

  export declare class StepElement_Array1OfVolumeElementPurpose_4 extends StepElement_Array1OfVolumeElementPurpose {
    constructor(theOther: StepElement_Array1OfVolumeElementPurpose);
  }

  export declare class StepElement_Array1OfVolumeElementPurpose_5 extends StepElement_Array1OfVolumeElementPurpose {
    constructor(theBegin: StepElement_VolumeElementPurpose, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepElement_SurfaceSectionFieldConstant extends StepElement_SurfaceSectionField {
  constructor()
  Init(aDefinition: Handle_StepElement_SurfaceSection): void;
  Definition(): Handle_StepElement_SurfaceSection;
  SetDefinition(Definition: Handle_StepElement_SurfaceSection): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_SurfaceSectionFieldConstant {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_SurfaceSectionFieldConstant): void;
  get(): StepElement_SurfaceSectionFieldConstant;
  delete(): void;
}

  export declare class Handle_StepElement_SurfaceSectionFieldConstant_1 extends Handle_StepElement_SurfaceSectionFieldConstant {
    constructor();
  }

  export declare class Handle_StepElement_SurfaceSectionFieldConstant_2 extends Handle_StepElement_SurfaceSectionFieldConstant {
    constructor(thePtr: StepElement_SurfaceSectionFieldConstant);
  }

  export declare class Handle_StepElement_SurfaceSectionFieldConstant_3 extends Handle_StepElement_SurfaceSectionFieldConstant {
    constructor(theHandle: Handle_StepElement_SurfaceSectionFieldConstant);
  }

  export declare class Handle_StepElement_SurfaceSectionFieldConstant_4 extends Handle_StepElement_SurfaceSectionFieldConstant {
    constructor(theHandle: Handle_StepElement_SurfaceSectionFieldConstant);
  }

export declare class Handle_StepElement_SurfaceElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_SurfaceElementPurposeMember): void;
  get(): StepElement_SurfaceElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_SurfaceElementPurposeMember_1 extends Handle_StepElement_SurfaceElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_SurfaceElementPurposeMember_2 extends Handle_StepElement_SurfaceElementPurposeMember {
    constructor(thePtr: StepElement_SurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_SurfaceElementPurposeMember_3 extends Handle_StepElement_SurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_SurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_SurfaceElementPurposeMember_4 extends Handle_StepElement_SurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_SurfaceElementPurposeMember);
  }

export declare class StepElement_SurfaceElementPurposeMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_HArray2OfCurveElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray2OfCurveElementPurposeMember): void;
  get(): StepElement_HArray2OfCurveElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HArray2OfCurveElementPurposeMember_1 extends Handle_StepElement_HArray2OfCurveElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HArray2OfCurveElementPurposeMember_2 extends Handle_StepElement_HArray2OfCurveElementPurposeMember {
    constructor(thePtr: StepElement_HArray2OfCurveElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray2OfCurveElementPurposeMember_3 extends Handle_StepElement_HArray2OfCurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray2OfCurveElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray2OfCurveElementPurposeMember_4 extends Handle_StepElement_HArray2OfCurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray2OfCurveElementPurposeMember);
  }

export declare type StepElement_ElementOrder = {
  StepElement_Linear: {};
  StepElement_Quadratic: {};
  StepElement_Cubic: {};
}

export declare class StepElement_VolumeElementPurpose extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetEnumeratedVolumeElementPurpose(aVal: StepElement_EnumeratedVolumeElementPurpose): void;
  EnumeratedVolumeElementPurpose(): StepElement_EnumeratedVolumeElementPurpose;
  SetApplicationDefinedElementPurpose(aVal: Handle_TCollection_HAsciiString): void;
  ApplicationDefinedElementPurpose(): Handle_TCollection_HAsciiString;
  delete(): void;
}

export declare class Handle_StepElement_HArray2OfSurfaceElementPurpose {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray2OfSurfaceElementPurpose): void;
  get(): StepElement_HArray2OfSurfaceElementPurpose;
  delete(): void;
}

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurpose_1 extends Handle_StepElement_HArray2OfSurfaceElementPurpose {
    constructor();
  }

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurpose_2 extends Handle_StepElement_HArray2OfSurfaceElementPurpose {
    constructor(thePtr: StepElement_HArray2OfSurfaceElementPurpose);
  }

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurpose_3 extends Handle_StepElement_HArray2OfSurfaceElementPurpose {
    constructor(theHandle: Handle_StepElement_HArray2OfSurfaceElementPurpose);
  }

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurpose_4 extends Handle_StepElement_HArray2OfSurfaceElementPurpose {
    constructor(theHandle: Handle_StepElement_HArray2OfSurfaceElementPurpose);
  }

export declare type StepElement_CurveEdge = {
  StepElement_ElementEdge: {};
}

export declare type StepElement_Element2dShape = {
  StepElement_Quadrilateral: {};
  StepElement_Triangle: {};
}

export declare class StepElement_Array2OfSurfaceElementPurpose {
  Init(theValue: StepElement_SurfaceElementPurpose): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: StepElement_Array2OfSurfaceElementPurpose): StepElement_Array2OfSurfaceElementPurpose;
  Move(theOther: StepElement_Array2OfSurfaceElementPurpose): StepElement_Array2OfSurfaceElementPurpose;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): StepElement_SurfaceElementPurpose;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): StepElement_SurfaceElementPurpose;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: StepElement_SurfaceElementPurpose): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepElement_Array2OfSurfaceElementPurpose_1 extends StepElement_Array2OfSurfaceElementPurpose {
    constructor();
  }

  export declare class StepElement_Array2OfSurfaceElementPurpose_2 extends StepElement_Array2OfSurfaceElementPurpose {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class StepElement_Array2OfSurfaceElementPurpose_3 extends StepElement_Array2OfSurfaceElementPurpose {
    constructor(theOther: StepElement_Array2OfSurfaceElementPurpose);
  }

  export declare class StepElement_Array2OfSurfaceElementPurpose_4 extends StepElement_Array2OfSurfaceElementPurpose {
    constructor(theOther: StepElement_Array2OfSurfaceElementPurpose);
  }

  export declare class StepElement_Array2OfSurfaceElementPurpose_5 extends StepElement_Array2OfSurfaceElementPurpose {
    constructor(theBegin: StepElement_SurfaceElementPurpose, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare type StepElement_EnumeratedSurfaceElementPurpose = {
  StepElement_MembraneDirect: {};
  StepElement_MembraneShear: {};
  StepElement_BendingDirect: {};
  StepElement_BendingTorsion: {};
  StepElement_NormalToPlaneShear: {};
}

export declare class Handle_StepElement_HSequenceOfElementMaterial {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HSequenceOfElementMaterial): void;
  get(): StepElement_HSequenceOfElementMaterial;
  delete(): void;
}

  export declare class Handle_StepElement_HSequenceOfElementMaterial_1 extends Handle_StepElement_HSequenceOfElementMaterial {
    constructor();
  }

  export declare class Handle_StepElement_HSequenceOfElementMaterial_2 extends Handle_StepElement_HSequenceOfElementMaterial {
    constructor(thePtr: StepElement_HSequenceOfElementMaterial);
  }

  export declare class Handle_StepElement_HSequenceOfElementMaterial_3 extends Handle_StepElement_HSequenceOfElementMaterial {
    constructor(theHandle: Handle_StepElement_HSequenceOfElementMaterial);
  }

  export declare class Handle_StepElement_HSequenceOfElementMaterial_4 extends Handle_StepElement_HSequenceOfElementMaterial {
    constructor(theHandle: Handle_StepElement_HSequenceOfElementMaterial);
  }

export declare class Handle_StepElement_HArray1OfCurveElementSectionDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfCurveElementSectionDefinition): void;
  get(): StepElement_HArray1OfCurveElementSectionDefinition;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfCurveElementSectionDefinition_1 extends Handle_StepElement_HArray1OfCurveElementSectionDefinition {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfCurveElementSectionDefinition_2 extends Handle_StepElement_HArray1OfCurveElementSectionDefinition {
    constructor(thePtr: StepElement_HArray1OfCurveElementSectionDefinition);
  }

  export declare class Handle_StepElement_HArray1OfCurveElementSectionDefinition_3 extends Handle_StepElement_HArray1OfCurveElementSectionDefinition {
    constructor(theHandle: Handle_StepElement_HArray1OfCurveElementSectionDefinition);
  }

  export declare class Handle_StepElement_HArray1OfCurveElementSectionDefinition_4 extends Handle_StepElement_HArray1OfCurveElementSectionDefinition {
    constructor(theHandle: Handle_StepElement_HArray1OfCurveElementSectionDefinition);
  }

export declare class Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfMeasureOrUnspecifiedValue): void;
  get(): StepElement_HArray1OfMeasureOrUnspecifiedValue;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_1 extends Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_2 extends Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue {
    constructor(thePtr: StepElement_HArray1OfMeasureOrUnspecifiedValue);
  }

  export declare class Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_3 extends Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue {
    constructor(theHandle: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue);
  }

  export declare class Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_4 extends Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue {
    constructor(theHandle: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue);
  }

export declare class StepElement_ElementAspectMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_ElementAspectMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_ElementAspectMember): void;
  get(): StepElement_ElementAspectMember;
  delete(): void;
}

  export declare class Handle_StepElement_ElementAspectMember_1 extends Handle_StepElement_ElementAspectMember {
    constructor();
  }

  export declare class Handle_StepElement_ElementAspectMember_2 extends Handle_StepElement_ElementAspectMember {
    constructor(thePtr: StepElement_ElementAspectMember);
  }

  export declare class Handle_StepElement_ElementAspectMember_3 extends Handle_StepElement_ElementAspectMember {
    constructor(theHandle: Handle_StepElement_ElementAspectMember);
  }

  export declare class Handle_StepElement_ElementAspectMember_4 extends Handle_StepElement_ElementAspectMember {
    constructor(theHandle: Handle_StepElement_ElementAspectMember);
  }

export declare class Handle_StepElement_HArray1OfVolumeElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfVolumeElementPurposeMember): void;
  get(): StepElement_HArray1OfVolumeElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfVolumeElementPurposeMember_1 extends Handle_StepElement_HArray1OfVolumeElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfVolumeElementPurposeMember_2 extends Handle_StepElement_HArray1OfVolumeElementPurposeMember {
    constructor(thePtr: StepElement_HArray1OfVolumeElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray1OfVolumeElementPurposeMember_3 extends Handle_StepElement_HArray1OfVolumeElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray1OfVolumeElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray1OfVolumeElementPurposeMember_4 extends Handle_StepElement_HArray1OfVolumeElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray1OfVolumeElementPurposeMember);
  }

export declare class StepElement_Array1OfMeasureOrUnspecifiedValue {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepElement_MeasureOrUnspecifiedValue): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepElement_Array1OfMeasureOrUnspecifiedValue): StepElement_Array1OfMeasureOrUnspecifiedValue;
  Move(theOther: StepElement_Array1OfMeasureOrUnspecifiedValue): StepElement_Array1OfMeasureOrUnspecifiedValue;
  First(): StepElement_MeasureOrUnspecifiedValue;
  ChangeFirst(): StepElement_MeasureOrUnspecifiedValue;
  Last(): StepElement_MeasureOrUnspecifiedValue;
  ChangeLast(): StepElement_MeasureOrUnspecifiedValue;
  Value(theIndex: Standard_Integer): StepElement_MeasureOrUnspecifiedValue;
  ChangeValue(theIndex: Standard_Integer): StepElement_MeasureOrUnspecifiedValue;
  SetValue(theIndex: Standard_Integer, theItem: StepElement_MeasureOrUnspecifiedValue): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepElement_Array1OfMeasureOrUnspecifiedValue_1 extends StepElement_Array1OfMeasureOrUnspecifiedValue {
    constructor();
  }

  export declare class StepElement_Array1OfMeasureOrUnspecifiedValue_2 extends StepElement_Array1OfMeasureOrUnspecifiedValue {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepElement_Array1OfMeasureOrUnspecifiedValue_3 extends StepElement_Array1OfMeasureOrUnspecifiedValue {
    constructor(theOther: StepElement_Array1OfMeasureOrUnspecifiedValue);
  }

  export declare class StepElement_Array1OfMeasureOrUnspecifiedValue_4 extends StepElement_Array1OfMeasureOrUnspecifiedValue {
    constructor(theOther: StepElement_Array1OfMeasureOrUnspecifiedValue);
  }

  export declare class StepElement_Array1OfMeasureOrUnspecifiedValue_5 extends StepElement_Array1OfMeasureOrUnspecifiedValue {
    constructor(theBegin: StepElement_MeasureOrUnspecifiedValue, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepElement_CurveElementEndReleasePacket {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_CurveElementEndReleasePacket): void;
  get(): StepElement_CurveElementEndReleasePacket;
  delete(): void;
}

  export declare class Handle_StepElement_CurveElementEndReleasePacket_1 extends Handle_StepElement_CurveElementEndReleasePacket {
    constructor();
  }

  export declare class Handle_StepElement_CurveElementEndReleasePacket_2 extends Handle_StepElement_CurveElementEndReleasePacket {
    constructor(thePtr: StepElement_CurveElementEndReleasePacket);
  }

  export declare class Handle_StepElement_CurveElementEndReleasePacket_3 extends Handle_StepElement_CurveElementEndReleasePacket {
    constructor(theHandle: Handle_StepElement_CurveElementEndReleasePacket);
  }

  export declare class Handle_StepElement_CurveElementEndReleasePacket_4 extends Handle_StepElement_CurveElementEndReleasePacket {
    constructor(theHandle: Handle_StepElement_CurveElementEndReleasePacket);
  }

export declare class StepElement_CurveElementEndReleasePacket extends Standard_Transient {
  constructor()
  Init(aReleaseFreedom: StepElement_CurveElementFreedom, aReleaseStiffness: Quantity_AbsorbedDose): void;
  ReleaseFreedom(): StepElement_CurveElementFreedom;
  SetReleaseFreedom(ReleaseFreedom: StepElement_CurveElementFreedom): void;
  ReleaseStiffness(): Quantity_AbsorbedDose;
  SetReleaseStiffness(ReleaseStiffness: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_MeasureOrUnspecifiedValueMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_MeasureOrUnspecifiedValueMember): void;
  get(): StepElement_MeasureOrUnspecifiedValueMember;
  delete(): void;
}

  export declare class Handle_StepElement_MeasureOrUnspecifiedValueMember_1 extends Handle_StepElement_MeasureOrUnspecifiedValueMember {
    constructor();
  }

  export declare class Handle_StepElement_MeasureOrUnspecifiedValueMember_2 extends Handle_StepElement_MeasureOrUnspecifiedValueMember {
    constructor(thePtr: StepElement_MeasureOrUnspecifiedValueMember);
  }

  export declare class Handle_StepElement_MeasureOrUnspecifiedValueMember_3 extends Handle_StepElement_MeasureOrUnspecifiedValueMember {
    constructor(theHandle: Handle_StepElement_MeasureOrUnspecifiedValueMember);
  }

  export declare class Handle_StepElement_MeasureOrUnspecifiedValueMember_4 extends Handle_StepElement_MeasureOrUnspecifiedValueMember {
    constructor(theHandle: Handle_StepElement_MeasureOrUnspecifiedValueMember);
  }

export declare class StepElement_MeasureOrUnspecifiedValueMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepElement_Curve3dElementDescriptor extends StepElement_ElementDescriptor {
  constructor()
  Init(aElementDescriptor_TopologyOrder: StepElement_ElementOrder, aElementDescriptor_Description: Handle_TCollection_HAsciiString, aPurpose: Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember): void;
  Purpose(): Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember;
  SetPurpose(Purpose: Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_Curve3dElementDescriptor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_Curve3dElementDescriptor): void;
  get(): StepElement_Curve3dElementDescriptor;
  delete(): void;
}

  export declare class Handle_StepElement_Curve3dElementDescriptor_1 extends Handle_StepElement_Curve3dElementDescriptor {
    constructor();
  }

  export declare class Handle_StepElement_Curve3dElementDescriptor_2 extends Handle_StepElement_Curve3dElementDescriptor {
    constructor(thePtr: StepElement_Curve3dElementDescriptor);
  }

  export declare class Handle_StepElement_Curve3dElementDescriptor_3 extends Handle_StepElement_Curve3dElementDescriptor {
    constructor(theHandle: Handle_StepElement_Curve3dElementDescriptor);
  }

  export declare class Handle_StepElement_Curve3dElementDescriptor_4 extends Handle_StepElement_Curve3dElementDescriptor {
    constructor(theHandle: Handle_StepElement_Curve3dElementDescriptor);
  }

export declare class StepElement_UniformSurfaceSection extends StepElement_SurfaceSection {
  constructor()
  Init(aSurfaceSection_Offset: StepElement_MeasureOrUnspecifiedValue, aSurfaceSection_NonStructuralMass: StepElement_MeasureOrUnspecifiedValue, aSurfaceSection_NonStructuralMassOffset: StepElement_MeasureOrUnspecifiedValue, aThickness: Quantity_AbsorbedDose, aBendingThickness: StepElement_MeasureOrUnspecifiedValue, aShearThickness: StepElement_MeasureOrUnspecifiedValue): void;
  Thickness(): Quantity_AbsorbedDose;
  SetThickness(Thickness: Quantity_AbsorbedDose): void;
  BendingThickness(): StepElement_MeasureOrUnspecifiedValue;
  SetBendingThickness(BendingThickness: StepElement_MeasureOrUnspecifiedValue): void;
  ShearThickness(): StepElement_MeasureOrUnspecifiedValue;
  SetShearThickness(ShearThickness: StepElement_MeasureOrUnspecifiedValue): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_UniformSurfaceSection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_UniformSurfaceSection): void;
  get(): StepElement_UniformSurfaceSection;
  delete(): void;
}

  export declare class Handle_StepElement_UniformSurfaceSection_1 extends Handle_StepElement_UniformSurfaceSection {
    constructor();
  }

  export declare class Handle_StepElement_UniformSurfaceSection_2 extends Handle_StepElement_UniformSurfaceSection {
    constructor(thePtr: StepElement_UniformSurfaceSection);
  }

  export declare class Handle_StepElement_UniformSurfaceSection_3 extends Handle_StepElement_UniformSurfaceSection {
    constructor(theHandle: Handle_StepElement_UniformSurfaceSection);
  }

  export declare class Handle_StepElement_UniformSurfaceSection_4 extends Handle_StepElement_UniformSurfaceSection {
    constructor(theHandle: Handle_StepElement_UniformSurfaceSection);
  }

export declare class Handle_StepElement_HArray1OfSurfaceSection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfSurfaceSection): void;
  get(): StepElement_HArray1OfSurfaceSection;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfSurfaceSection_1 extends Handle_StepElement_HArray1OfSurfaceSection {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfSurfaceSection_2 extends Handle_StepElement_HArray1OfSurfaceSection {
    constructor(thePtr: StepElement_HArray1OfSurfaceSection);
  }

  export declare class Handle_StepElement_HArray1OfSurfaceSection_3 extends Handle_StepElement_HArray1OfSurfaceSection {
    constructor(theHandle: Handle_StepElement_HArray1OfSurfaceSection);
  }

  export declare class Handle_StepElement_HArray1OfSurfaceSection_4 extends Handle_StepElement_HArray1OfSurfaceSection {
    constructor(theHandle: Handle_StepElement_HArray1OfSurfaceSection);
  }

export declare class Handle_StepElement_Volume3dElementDescriptor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_Volume3dElementDescriptor): void;
  get(): StepElement_Volume3dElementDescriptor;
  delete(): void;
}

  export declare class Handle_StepElement_Volume3dElementDescriptor_1 extends Handle_StepElement_Volume3dElementDescriptor {
    constructor();
  }

  export declare class Handle_StepElement_Volume3dElementDescriptor_2 extends Handle_StepElement_Volume3dElementDescriptor {
    constructor(thePtr: StepElement_Volume3dElementDescriptor);
  }

  export declare class Handle_StepElement_Volume3dElementDescriptor_3 extends Handle_StepElement_Volume3dElementDescriptor {
    constructor(theHandle: Handle_StepElement_Volume3dElementDescriptor);
  }

  export declare class Handle_StepElement_Volume3dElementDescriptor_4 extends Handle_StepElement_Volume3dElementDescriptor {
    constructor(theHandle: Handle_StepElement_Volume3dElementDescriptor);
  }

export declare class StepElement_Volume3dElementDescriptor extends StepElement_ElementDescriptor {
  constructor()
  Init(aElementDescriptor_TopologyOrder: StepElement_ElementOrder, aElementDescriptor_Description: Handle_TCollection_HAsciiString, aPurpose: Handle_StepElement_HArray1OfVolumeElementPurposeMember, aShape: StepElement_Volume3dElementShape): void;
  Purpose(): Handle_StepElement_HArray1OfVolumeElementPurposeMember;
  SetPurpose(Purpose: Handle_StepElement_HArray1OfVolumeElementPurposeMember): void;
  Shape(): StepElement_Volume3dElementShape;
  SetShape(Shape: StepElement_Volume3dElementShape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepElement_AnalysisItemWithinRepresentation extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aItem: Handle_StepRepr_RepresentationItem, aRep: Handle_StepRepr_Representation): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  Item(): Handle_StepRepr_RepresentationItem;
  SetItem(Item: Handle_StepRepr_RepresentationItem): void;
  Rep(): Handle_StepRepr_Representation;
  SetRep(Rep: Handle_StepRepr_Representation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_AnalysisItemWithinRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_AnalysisItemWithinRepresentation): void;
  get(): StepElement_AnalysisItemWithinRepresentation;
  delete(): void;
}

  export declare class Handle_StepElement_AnalysisItemWithinRepresentation_1 extends Handle_StepElement_AnalysisItemWithinRepresentation {
    constructor();
  }

  export declare class Handle_StepElement_AnalysisItemWithinRepresentation_2 extends Handle_StepElement_AnalysisItemWithinRepresentation {
    constructor(thePtr: StepElement_AnalysisItemWithinRepresentation);
  }

  export declare class Handle_StepElement_AnalysisItemWithinRepresentation_3 extends Handle_StepElement_AnalysisItemWithinRepresentation {
    constructor(theHandle: Handle_StepElement_AnalysisItemWithinRepresentation);
  }

  export declare class Handle_StepElement_AnalysisItemWithinRepresentation_4 extends Handle_StepElement_AnalysisItemWithinRepresentation {
    constructor(theHandle: Handle_StepElement_AnalysisItemWithinRepresentation);
  }

export declare class Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfHSequenceOfCurveElementPurposeMember): void;
  get(): StepElement_HArray1OfHSequenceOfCurveElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_1 extends Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_2 extends Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember {
    constructor(thePtr: StepElement_HArray1OfHSequenceOfCurveElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_3 extends Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_4 extends Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember);
  }

export declare class Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember): void;
  get(): StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_1 extends Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_2 extends Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember {
    constructor(thePtr: StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_3 extends Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_4 extends Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember);
  }

export declare type StepElement_ElementVolume = {
  StepElement_Volume: {};
}

export declare class StepElement_MeasureOrUnspecifiedValue extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetContextDependentMeasure(aVal: Quantity_AbsorbedDose): void;
  ContextDependentMeasure(): Quantity_AbsorbedDose;
  SetUnspecifiedValue(aVal: StepElement_UnspecifiedValue): void;
  UnspecifiedValue(): StepElement_UnspecifiedValue;
  delete(): void;
}

export declare class StepElement_CurveElementPurpose extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetEnumeratedCurveElementPurpose(aVal: StepElement_EnumeratedCurveElementPurpose): void;
  EnumeratedCurveElementPurpose(): StepElement_EnumeratedCurveElementPurpose;
  SetApplicationDefinedElementPurpose(aVal: Handle_TCollection_HAsciiString): void;
  ApplicationDefinedElementPurpose(): Handle_TCollection_HAsciiString;
  delete(): void;
}

export declare type StepElement_Volume3dElementShape = {
  StepElement_Hexahedron: {};
  StepElement_Wedge: {};
  StepElement_Tetrahedron: {};
  StepElement_Pyramid: {};
}

export declare class Handle_StepElement_HArray1OfCurveElementEndReleasePacket {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray1OfCurveElementEndReleasePacket): void;
  get(): StepElement_HArray1OfCurveElementEndReleasePacket;
  delete(): void;
}

  export declare class Handle_StepElement_HArray1OfCurveElementEndReleasePacket_1 extends Handle_StepElement_HArray1OfCurveElementEndReleasePacket {
    constructor();
  }

  export declare class Handle_StepElement_HArray1OfCurveElementEndReleasePacket_2 extends Handle_StepElement_HArray1OfCurveElementEndReleasePacket {
    constructor(thePtr: StepElement_HArray1OfCurveElementEndReleasePacket);
  }

  export declare class Handle_StepElement_HArray1OfCurveElementEndReleasePacket_3 extends Handle_StepElement_HArray1OfCurveElementEndReleasePacket {
    constructor(theHandle: Handle_StepElement_HArray1OfCurveElementEndReleasePacket);
  }

  export declare class Handle_StepElement_HArray1OfCurveElementEndReleasePacket_4 extends Handle_StepElement_HArray1OfCurveElementEndReleasePacket {
    constructor(theHandle: Handle_StepElement_HArray1OfCurveElementEndReleasePacket);
  }

export declare class StepElement_CurveElementFreedom extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetEnumeratedCurveElementFreedom(aVal: StepElement_EnumeratedCurveElementFreedom): void;
  EnumeratedCurveElementFreedom(): StepElement_EnumeratedCurveElementFreedom;
  SetApplicationDefinedDegreeOfFreedom(aVal: Handle_TCollection_HAsciiString): void;
  ApplicationDefinedDegreeOfFreedom(): Handle_TCollection_HAsciiString;
  delete(): void;
}

export declare class StepElement_ElementMaterial extends Standard_Transient {
  constructor()
  Init(aMaterialId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aProperties: Handle_StepRepr_HArray1OfMaterialPropertyRepresentation): void;
  MaterialId(): Handle_TCollection_HAsciiString;
  SetMaterialId(MaterialId: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  Properties(): Handle_StepRepr_HArray1OfMaterialPropertyRepresentation;
  SetProperties(Properties: Handle_StepRepr_HArray1OfMaterialPropertyRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_ElementMaterial {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_ElementMaterial): void;
  get(): StepElement_ElementMaterial;
  delete(): void;
}

  export declare class Handle_StepElement_ElementMaterial_1 extends Handle_StepElement_ElementMaterial {
    constructor();
  }

  export declare class Handle_StepElement_ElementMaterial_2 extends Handle_StepElement_ElementMaterial {
    constructor(thePtr: StepElement_ElementMaterial);
  }

  export declare class Handle_StepElement_ElementMaterial_3 extends Handle_StepElement_ElementMaterial {
    constructor(theHandle: Handle_StepElement_ElementMaterial);
  }

  export declare class Handle_StepElement_ElementMaterial_4 extends Handle_StepElement_ElementMaterial {
    constructor(theHandle: Handle_StepElement_ElementMaterial);
  }

export declare class StepElement_SurfaceElementPurpose extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetEnumeratedSurfaceElementPurpose(aVal: StepElement_EnumeratedSurfaceElementPurpose): void;
  EnumeratedSurfaceElementPurpose(): StepElement_EnumeratedSurfaceElementPurpose;
  SetApplicationDefinedElementPurpose(aVal: Handle_TCollection_HAsciiString): void;
  ApplicationDefinedElementPurpose(): Handle_TCollection_HAsciiString;
  delete(): void;
}

export declare class StepElement_SurfaceElementProperty extends Standard_Transient {
  constructor()
  Init(aPropertyId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aSection: Handle_StepElement_SurfaceSectionField): void;
  PropertyId(): Handle_TCollection_HAsciiString;
  SetPropertyId(PropertyId: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  Section(): Handle_StepElement_SurfaceSectionField;
  SetSection(Section: Handle_StepElement_SurfaceSectionField): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_SurfaceElementProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_SurfaceElementProperty): void;
  get(): StepElement_SurfaceElementProperty;
  delete(): void;
}

  export declare class Handle_StepElement_SurfaceElementProperty_1 extends Handle_StepElement_SurfaceElementProperty {
    constructor();
  }

  export declare class Handle_StepElement_SurfaceElementProperty_2 extends Handle_StepElement_SurfaceElementProperty {
    constructor(thePtr: StepElement_SurfaceElementProperty);
  }

  export declare class Handle_StepElement_SurfaceElementProperty_3 extends Handle_StepElement_SurfaceElementProperty {
    constructor(theHandle: Handle_StepElement_SurfaceElementProperty);
  }

  export declare class Handle_StepElement_SurfaceElementProperty_4 extends Handle_StepElement_SurfaceElementProperty {
    constructor(theHandle: Handle_StepElement_SurfaceElementProperty);
  }

export declare class Handle_StepElement_HSequenceOfSurfaceElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HSequenceOfSurfaceElementPurposeMember): void;
  get(): StepElement_HSequenceOfSurfaceElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_1 extends Handle_StepElement_HSequenceOfSurfaceElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_2 extends Handle_StepElement_HSequenceOfSurfaceElementPurposeMember {
    constructor(thePtr: StepElement_HSequenceOfSurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_3 extends Handle_StepElement_HSequenceOfSurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HSequenceOfSurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_4 extends Handle_StepElement_HSequenceOfSurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HSequenceOfSurfaceElementPurposeMember);
  }

export declare type StepElement_EnumeratedVolumeElementPurpose = {
  StepElement_StressDisplacement: {};
}

export declare class Handle_StepElement_VolumeElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_VolumeElementPurposeMember): void;
  get(): StepElement_VolumeElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_VolumeElementPurposeMember_1 extends Handle_StepElement_VolumeElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_VolumeElementPurposeMember_2 extends Handle_StepElement_VolumeElementPurposeMember {
    constructor(thePtr: StepElement_VolumeElementPurposeMember);
  }

  export declare class Handle_StepElement_VolumeElementPurposeMember_3 extends Handle_StepElement_VolumeElementPurposeMember {
    constructor(theHandle: Handle_StepElement_VolumeElementPurposeMember);
  }

  export declare class Handle_StepElement_VolumeElementPurposeMember_4 extends Handle_StepElement_VolumeElementPurposeMember {
    constructor(theHandle: Handle_StepElement_VolumeElementPurposeMember);
  }

export declare class StepElement_VolumeElementPurposeMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepElement_SurfaceSectionFieldVarying extends StepElement_SurfaceSectionField {
  constructor()
  Init(aDefinitions: Handle_StepElement_HArray1OfSurfaceSection, aAdditionalNodeValues: Standard_Boolean): void;
  Definitions(): Handle_StepElement_HArray1OfSurfaceSection;
  SetDefinitions(Definitions: Handle_StepElement_HArray1OfSurfaceSection): void;
  AdditionalNodeValues(): Standard_Boolean;
  SetAdditionalNodeValues(AdditionalNodeValues: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_SurfaceSectionFieldVarying {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_SurfaceSectionFieldVarying): void;
  get(): StepElement_SurfaceSectionFieldVarying;
  delete(): void;
}

  export declare class Handle_StepElement_SurfaceSectionFieldVarying_1 extends Handle_StepElement_SurfaceSectionFieldVarying {
    constructor();
  }

  export declare class Handle_StepElement_SurfaceSectionFieldVarying_2 extends Handle_StepElement_SurfaceSectionFieldVarying {
    constructor(thePtr: StepElement_SurfaceSectionFieldVarying);
  }

  export declare class Handle_StepElement_SurfaceSectionFieldVarying_3 extends Handle_StepElement_SurfaceSectionFieldVarying {
    constructor(theHandle: Handle_StepElement_SurfaceSectionFieldVarying);
  }

  export declare class Handle_StepElement_SurfaceSectionFieldVarying_4 extends Handle_StepElement_SurfaceSectionFieldVarying {
    constructor(theHandle: Handle_StepElement_SurfaceSectionFieldVarying);
  }

export declare class Handle_StepElement_HArray2OfSurfaceElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HArray2OfSurfaceElementPurposeMember): void;
  get(): StepElement_HArray2OfSurfaceElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurposeMember_1 extends Handle_StepElement_HArray2OfSurfaceElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurposeMember_2 extends Handle_StepElement_HArray2OfSurfaceElementPurposeMember {
    constructor(thePtr: StepElement_HArray2OfSurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurposeMember_3 extends Handle_StepElement_HArray2OfSurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray2OfSurfaceElementPurposeMember);
  }

  export declare class Handle_StepElement_HArray2OfSurfaceElementPurposeMember_4 extends Handle_StepElement_HArray2OfSurfaceElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HArray2OfSurfaceElementPurposeMember);
  }

export declare class Handle_StepElement_HSequenceOfCurveElementPurposeMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HSequenceOfCurveElementPurposeMember): void;
  get(): StepElement_HSequenceOfCurveElementPurposeMember;
  delete(): void;
}

  export declare class Handle_StepElement_HSequenceOfCurveElementPurposeMember_1 extends Handle_StepElement_HSequenceOfCurveElementPurposeMember {
    constructor();
  }

  export declare class Handle_StepElement_HSequenceOfCurveElementPurposeMember_2 extends Handle_StepElement_HSequenceOfCurveElementPurposeMember {
    constructor(thePtr: StepElement_HSequenceOfCurveElementPurposeMember);
  }

  export declare class Handle_StepElement_HSequenceOfCurveElementPurposeMember_3 extends Handle_StepElement_HSequenceOfCurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HSequenceOfCurveElementPurposeMember);
  }

  export declare class Handle_StepElement_HSequenceOfCurveElementPurposeMember_4 extends Handle_StepElement_HSequenceOfCurveElementPurposeMember {
    constructor(theHandle: Handle_StepElement_HSequenceOfCurveElementPurposeMember);
  }

export declare class Handle_StepElement_CurveElementFreedomMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_CurveElementFreedomMember): void;
  get(): StepElement_CurveElementFreedomMember;
  delete(): void;
}

  export declare class Handle_StepElement_CurveElementFreedomMember_1 extends Handle_StepElement_CurveElementFreedomMember {
    constructor();
  }

  export declare class Handle_StepElement_CurveElementFreedomMember_2 extends Handle_StepElement_CurveElementFreedomMember {
    constructor(thePtr: StepElement_CurveElementFreedomMember);
  }

  export declare class Handle_StepElement_CurveElementFreedomMember_3 extends Handle_StepElement_CurveElementFreedomMember {
    constructor(theHandle: Handle_StepElement_CurveElementFreedomMember);
  }

  export declare class Handle_StepElement_CurveElementFreedomMember_4 extends Handle_StepElement_CurveElementFreedomMember {
    constructor(theHandle: Handle_StepElement_CurveElementFreedomMember);
  }

export declare class StepElement_CurveElementFreedomMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_ElementDescriptor {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_ElementDescriptor): void;
  get(): StepElement_ElementDescriptor;
  delete(): void;
}

  export declare class Handle_StepElement_ElementDescriptor_1 extends Handle_StepElement_ElementDescriptor {
    constructor();
  }

  export declare class Handle_StepElement_ElementDescriptor_2 extends Handle_StepElement_ElementDescriptor {
    constructor(thePtr: StepElement_ElementDescriptor);
  }

  export declare class Handle_StepElement_ElementDescriptor_3 extends Handle_StepElement_ElementDescriptor {
    constructor(theHandle: Handle_StepElement_ElementDescriptor);
  }

  export declare class Handle_StepElement_ElementDescriptor_4 extends Handle_StepElement_ElementDescriptor {
    constructor(theHandle: Handle_StepElement_ElementDescriptor);
  }

export declare class StepElement_ElementDescriptor extends Standard_Transient {
  constructor()
  Init(aTopologyOrder: StepElement_ElementOrder, aDescription: Handle_TCollection_HAsciiString): void;
  TopologyOrder(): StepElement_ElementOrder;
  SetTopologyOrder(TopologyOrder: StepElement_ElementOrder): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepElement_SurfaceSection extends Standard_Transient {
  constructor()
  Init(aOffset: StepElement_MeasureOrUnspecifiedValue, aNonStructuralMass: StepElement_MeasureOrUnspecifiedValue, aNonStructuralMassOffset: StepElement_MeasureOrUnspecifiedValue): void;
  Offset(): StepElement_MeasureOrUnspecifiedValue;
  SetOffset(Offset: StepElement_MeasureOrUnspecifiedValue): void;
  NonStructuralMass(): StepElement_MeasureOrUnspecifiedValue;
  SetNonStructuralMass(NonStructuralMass: StepElement_MeasureOrUnspecifiedValue): void;
  NonStructuralMassOffset(): StepElement_MeasureOrUnspecifiedValue;
  SetNonStructuralMassOffset(NonStructuralMassOffset: StepElement_MeasureOrUnspecifiedValue): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_SurfaceSection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_SurfaceSection): void;
  get(): StepElement_SurfaceSection;
  delete(): void;
}

  export declare class Handle_StepElement_SurfaceSection_1 extends Handle_StepElement_SurfaceSection {
    constructor();
  }

  export declare class Handle_StepElement_SurfaceSection_2 extends Handle_StepElement_SurfaceSection {
    constructor(thePtr: StepElement_SurfaceSection);
  }

  export declare class Handle_StepElement_SurfaceSection_3 extends Handle_StepElement_SurfaceSection {
    constructor(theHandle: Handle_StepElement_SurfaceSection);
  }

  export declare class Handle_StepElement_SurfaceSection_4 extends Handle_StepElement_SurfaceSection {
    constructor(theHandle: Handle_StepElement_SurfaceSection);
  }

export declare class Handle_StepElement_HSequenceOfCurveElementSectionDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_HSequenceOfCurveElementSectionDefinition): void;
  get(): StepElement_HSequenceOfCurveElementSectionDefinition;
  delete(): void;
}

  export declare class Handle_StepElement_HSequenceOfCurveElementSectionDefinition_1 extends Handle_StepElement_HSequenceOfCurveElementSectionDefinition {
    constructor();
  }

  export declare class Handle_StepElement_HSequenceOfCurveElementSectionDefinition_2 extends Handle_StepElement_HSequenceOfCurveElementSectionDefinition {
    constructor(thePtr: StepElement_HSequenceOfCurveElementSectionDefinition);
  }

  export declare class Handle_StepElement_HSequenceOfCurveElementSectionDefinition_3 extends Handle_StepElement_HSequenceOfCurveElementSectionDefinition {
    constructor(theHandle: Handle_StepElement_HSequenceOfCurveElementSectionDefinition);
  }

  export declare class Handle_StepElement_HSequenceOfCurveElementSectionDefinition_4 extends Handle_StepElement_HSequenceOfCurveElementSectionDefinition {
    constructor(theHandle: Handle_StepElement_HSequenceOfCurveElementSectionDefinition);
  }

export declare type StepElement_EnumeratedCurveElementPurpose = {
  StepElement_Axial: {};
  StepElement_YYBending: {};
  StepElement_ZZBending: {};
  StepElement_Torsion: {};
  StepElement_XYShear: {};
  StepElement_XZShear: {};
  StepElement_Warping: {};
}

export declare class Handle_StepElement_SurfaceSectionField {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_SurfaceSectionField): void;
  get(): StepElement_SurfaceSectionField;
  delete(): void;
}

  export declare class Handle_StepElement_SurfaceSectionField_1 extends Handle_StepElement_SurfaceSectionField {
    constructor();
  }

  export declare class Handle_StepElement_SurfaceSectionField_2 extends Handle_StepElement_SurfaceSectionField {
    constructor(thePtr: StepElement_SurfaceSectionField);
  }

  export declare class Handle_StepElement_SurfaceSectionField_3 extends Handle_StepElement_SurfaceSectionField {
    constructor(theHandle: Handle_StepElement_SurfaceSectionField);
  }

  export declare class Handle_StepElement_SurfaceSectionField_4 extends Handle_StepElement_SurfaceSectionField {
    constructor(theHandle: Handle_StepElement_SurfaceSectionField);
  }

export declare class StepElement_SurfaceSectionField extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepElement_UnspecifiedValue = {
  StepElement_Unspecified: {};
}

export declare class Handle_StepElement_CurveElementSectionDerivedDefinitions {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_CurveElementSectionDerivedDefinitions): void;
  get(): StepElement_CurveElementSectionDerivedDefinitions;
  delete(): void;
}

  export declare class Handle_StepElement_CurveElementSectionDerivedDefinitions_1 extends Handle_StepElement_CurveElementSectionDerivedDefinitions {
    constructor();
  }

  export declare class Handle_StepElement_CurveElementSectionDerivedDefinitions_2 extends Handle_StepElement_CurveElementSectionDerivedDefinitions {
    constructor(thePtr: StepElement_CurveElementSectionDerivedDefinitions);
  }

  export declare class Handle_StepElement_CurveElementSectionDerivedDefinitions_3 extends Handle_StepElement_CurveElementSectionDerivedDefinitions {
    constructor(theHandle: Handle_StepElement_CurveElementSectionDerivedDefinitions);
  }

  export declare class Handle_StepElement_CurveElementSectionDerivedDefinitions_4 extends Handle_StepElement_CurveElementSectionDerivedDefinitions {
    constructor(theHandle: Handle_StepElement_CurveElementSectionDerivedDefinitions);
  }

export declare class StepElement_CurveElementSectionDerivedDefinitions extends StepElement_CurveElementSectionDefinition {
  constructor()
  Init(aCurveElementSectionDefinition_Description: Handle_TCollection_HAsciiString, aCurveElementSectionDefinition_SectionAngle: Quantity_AbsorbedDose, aCrossSectionalArea: Quantity_AbsorbedDose, aShearArea: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue, aSecondMomentOfArea: Handle_TColStd_HArray1OfReal, aTorsionalConstant: Quantity_AbsorbedDose, aWarpingConstant: StepElement_MeasureOrUnspecifiedValue, aLocationOfCentroid: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue, aLocationOfShearCentre: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue, aLocationOfNonStructuralMass: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue, aNonStructuralMass: StepElement_MeasureOrUnspecifiedValue, aPolarMoment: StepElement_MeasureOrUnspecifiedValue): void;
  CrossSectionalArea(): Quantity_AbsorbedDose;
  SetCrossSectionalArea(CrossSectionalArea: Quantity_AbsorbedDose): void;
  ShearArea(): Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue;
  SetShearArea(ShearArea: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue): void;
  SecondMomentOfArea(): Handle_TColStd_HArray1OfReal;
  SetSecondMomentOfArea(SecondMomentOfArea: Handle_TColStd_HArray1OfReal): void;
  TorsionalConstant(): Quantity_AbsorbedDose;
  SetTorsionalConstant(TorsionalConstant: Quantity_AbsorbedDose): void;
  WarpingConstant(): StepElement_MeasureOrUnspecifiedValue;
  SetWarpingConstant(WarpingConstant: StepElement_MeasureOrUnspecifiedValue): void;
  LocationOfCentroid(): Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue;
  SetLocationOfCentroid(LocationOfCentroid: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue): void;
  LocationOfShearCentre(): Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue;
  SetLocationOfShearCentre(LocationOfShearCentre: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue): void;
  LocationOfNonStructuralMass(): Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue;
  SetLocationOfNonStructuralMass(LocationOfNonStructuralMass: Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue): void;
  NonStructuralMass(): StepElement_MeasureOrUnspecifiedValue;
  SetNonStructuralMass(NonStructuralMass: StepElement_MeasureOrUnspecifiedValue): void;
  PolarMoment(): StepElement_MeasureOrUnspecifiedValue;
  SetPolarMoment(PolarMoment: StepElement_MeasureOrUnspecifiedValue): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepElement_CurveElementSectionDefinition extends Standard_Transient {
  constructor()
  Init(aDescription: Handle_TCollection_HAsciiString, aSectionAngle: Quantity_AbsorbedDose): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  SectionAngle(): Quantity_AbsorbedDose;
  SetSectionAngle(SectionAngle: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepElement_CurveElementSectionDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepElement_CurveElementSectionDefinition): void;
  get(): StepElement_CurveElementSectionDefinition;
  delete(): void;
}

  export declare class Handle_StepElement_CurveElementSectionDefinition_1 extends Handle_StepElement_CurveElementSectionDefinition {
    constructor();
  }

  export declare class Handle_StepElement_CurveElementSectionDefinition_2 extends Handle_StepElement_CurveElementSectionDefinition {
    constructor(thePtr: StepElement_CurveElementSectionDefinition);
  }

  export declare class Handle_StepElement_CurveElementSectionDefinition_3 extends Handle_StepElement_CurveElementSectionDefinition {
    constructor(theHandle: Handle_StepElement_CurveElementSectionDefinition);
  }

  export declare class Handle_StepElement_CurveElementSectionDefinition_4 extends Handle_StepElement_CurveElementSectionDefinition {
    constructor(theHandle: Handle_StepElement_CurveElementSectionDefinition);
  }

export declare class TColgp_SequenceOfVec extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfVec): TColgp_SequenceOfVec;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Vec): void;
  Append_2(theSeq: TColgp_SequenceOfVec): void;
  Prepend_1(theItem: gp_Vec): void;
  Prepend_2(theSeq: TColgp_SequenceOfVec): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Vec): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfVec): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfVec): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Vec): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfVec): void;
  First(): gp_Vec;
  ChangeFirst(): gp_Vec;
  Last(): gp_Vec;
  ChangeLast(): gp_Vec;
  Value(theIndex: Standard_Integer): gp_Vec;
  ChangeValue(theIndex: Standard_Integer): gp_Vec;
  SetValue(theIndex: Standard_Integer, theItem: gp_Vec): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfVec_1 extends TColgp_SequenceOfVec {
    constructor();
  }

  export declare class TColgp_SequenceOfVec_2 extends TColgp_SequenceOfVec {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfVec_3 extends TColgp_SequenceOfVec {
    constructor(theOther: TColgp_SequenceOfVec);
  }

export declare class TColgp_Array2OfXY {
  Init(theValue: gp_XY): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfXY): TColgp_Array2OfXY;
  Move(theOther: TColgp_Array2OfXY): TColgp_Array2OfXY;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_XY;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_XY;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_XY): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfXY_1 extends TColgp_Array2OfXY {
    constructor();
  }

  export declare class TColgp_Array2OfXY_2 extends TColgp_Array2OfXY {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfXY_3 extends TColgp_Array2OfXY {
    constructor(theOther: TColgp_Array2OfXY);
  }

  export declare class TColgp_Array2OfXY_4 extends TColgp_Array2OfXY {
    constructor(theOther: TColgp_Array2OfXY);
  }

  export declare class TColgp_Array2OfXY_5 extends TColgp_Array2OfXY {
    constructor(theBegin: gp_XY, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColgp_Array1OfDir2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Dir2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfDir2d): TColgp_Array1OfDir2d;
  Move(theOther: TColgp_Array1OfDir2d): TColgp_Array1OfDir2d;
  First(): gp_Dir2d;
  ChangeFirst(): gp_Dir2d;
  Last(): gp_Dir2d;
  ChangeLast(): gp_Dir2d;
  Value(theIndex: Standard_Integer): gp_Dir2d;
  ChangeValue(theIndex: Standard_Integer): gp_Dir2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Dir2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfDir2d_1 extends TColgp_Array1OfDir2d {
    constructor();
  }

  export declare class TColgp_Array1OfDir2d_2 extends TColgp_Array1OfDir2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfDir2d_3 extends TColgp_Array1OfDir2d {
    constructor(theOther: TColgp_Array1OfDir2d);
  }

  export declare class TColgp_Array1OfDir2d_4 extends TColgp_Array1OfDir2d {
    constructor(theOther: TColgp_Array1OfDir2d);
  }

  export declare class TColgp_Array1OfDir2d_5 extends TColgp_Array1OfDir2d {
    constructor(theBegin: gp_Dir2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray2OfVec2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfVec2d): void;
  get(): TColgp_HArray2OfVec2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfVec2d_1 extends Handle_TColgp_HArray2OfVec2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfVec2d_2 extends Handle_TColgp_HArray2OfVec2d {
    constructor(thePtr: TColgp_HArray2OfVec2d);
  }

  export declare class Handle_TColgp_HArray2OfVec2d_3 extends Handle_TColgp_HArray2OfVec2d {
    constructor(theHandle: Handle_TColgp_HArray2OfVec2d);
  }

  export declare class Handle_TColgp_HArray2OfVec2d_4 extends Handle_TColgp_HArray2OfVec2d {
    constructor(theHandle: Handle_TColgp_HArray2OfVec2d);
  }

export declare class Handle_TColgp_HSequenceOfXYZ {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfXYZ): void;
  get(): TColgp_HSequenceOfXYZ;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfXYZ_1 extends Handle_TColgp_HSequenceOfXYZ {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfXYZ_2 extends Handle_TColgp_HSequenceOfXYZ {
    constructor(thePtr: TColgp_HSequenceOfXYZ);
  }

  export declare class Handle_TColgp_HSequenceOfXYZ_3 extends Handle_TColgp_HSequenceOfXYZ {
    constructor(theHandle: Handle_TColgp_HSequenceOfXYZ);
  }

  export declare class Handle_TColgp_HSequenceOfXYZ_4 extends Handle_TColgp_HSequenceOfXYZ {
    constructor(theHandle: Handle_TColgp_HSequenceOfXYZ);
  }

export declare class TColgp_Array1OfXY {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_XY): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfXY): TColgp_Array1OfXY;
  Move(theOther: TColgp_Array1OfXY): TColgp_Array1OfXY;
  First(): gp_XY;
  ChangeFirst(): gp_XY;
  Last(): gp_XY;
  ChangeLast(): gp_XY;
  Value(theIndex: Standard_Integer): gp_XY;
  ChangeValue(theIndex: Standard_Integer): gp_XY;
  SetValue(theIndex: Standard_Integer, theItem: gp_XY): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfXY_1 extends TColgp_Array1OfXY {
    constructor();
  }

  export declare class TColgp_Array1OfXY_2 extends TColgp_Array1OfXY {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfXY_3 extends TColgp_Array1OfXY {
    constructor(theOther: TColgp_Array1OfXY);
  }

  export declare class TColgp_Array1OfXY_4 extends TColgp_Array1OfXY {
    constructor(theOther: TColgp_Array1OfXY);
  }

  export declare class TColgp_Array1OfXY_5 extends TColgp_Array1OfXY {
    constructor(theBegin: gp_XY, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray1OfLin2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfLin2d): void;
  get(): TColgp_HArray1OfLin2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfLin2d_1 extends Handle_TColgp_HArray1OfLin2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfLin2d_2 extends Handle_TColgp_HArray1OfLin2d {
    constructor(thePtr: TColgp_HArray1OfLin2d);
  }

  export declare class Handle_TColgp_HArray1OfLin2d_3 extends Handle_TColgp_HArray1OfLin2d {
    constructor(theHandle: Handle_TColgp_HArray1OfLin2d);
  }

  export declare class Handle_TColgp_HArray1OfLin2d_4 extends Handle_TColgp_HArray1OfLin2d {
    constructor(theHandle: Handle_TColgp_HArray1OfLin2d);
  }

export declare class TColgp_Array1OfVec2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Vec2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfVec2d): TColgp_Array1OfVec2d;
  Move(theOther: TColgp_Array1OfVec2d): TColgp_Array1OfVec2d;
  First(): gp_Vec2d;
  ChangeFirst(): gp_Vec2d;
  Last(): gp_Vec2d;
  ChangeLast(): gp_Vec2d;
  Value(theIndex: Standard_Integer): gp_Vec2d;
  ChangeValue(theIndex: Standard_Integer): gp_Vec2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Vec2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfVec2d_1 extends TColgp_Array1OfVec2d {
    constructor();
  }

  export declare class TColgp_Array1OfVec2d_2 extends TColgp_Array1OfVec2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfVec2d_3 extends TColgp_Array1OfVec2d {
    constructor(theOther: TColgp_Array1OfVec2d);
  }

  export declare class TColgp_Array1OfVec2d_4 extends TColgp_Array1OfVec2d {
    constructor(theOther: TColgp_Array1OfVec2d);
  }

  export declare class TColgp_Array1OfVec2d_5 extends TColgp_Array1OfVec2d {
    constructor(theBegin: gp_Vec2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColgp_SequenceOfXYZ extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfXYZ): TColgp_SequenceOfXYZ;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_XYZ): void;
  Append_2(theSeq: TColgp_SequenceOfXYZ): void;
  Prepend_1(theItem: gp_XYZ): void;
  Prepend_2(theSeq: TColgp_SequenceOfXYZ): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_XYZ): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfXYZ): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfXYZ): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_XYZ): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfXYZ): void;
  First(): gp_XYZ;
  ChangeFirst(): gp_XYZ;
  Last(): gp_XYZ;
  ChangeLast(): gp_XYZ;
  Value(theIndex: Standard_Integer): gp_XYZ;
  ChangeValue(theIndex: Standard_Integer): gp_XYZ;
  SetValue(theIndex: Standard_Integer, theItem: gp_XYZ): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfXYZ_1 extends TColgp_SequenceOfXYZ {
    constructor();
  }

  export declare class TColgp_SequenceOfXYZ_2 extends TColgp_SequenceOfXYZ {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfXYZ_3 extends TColgp_SequenceOfXYZ {
    constructor(theOther: TColgp_SequenceOfXYZ);
  }

export declare class TColgp_SequenceOfAx1 extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfAx1): TColgp_SequenceOfAx1;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Ax1): void;
  Append_2(theSeq: TColgp_SequenceOfAx1): void;
  Prepend_1(theItem: gp_Ax1): void;
  Prepend_2(theSeq: TColgp_SequenceOfAx1): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Ax1): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfAx1): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfAx1): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Ax1): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfAx1): void;
  First(): gp_Ax1;
  ChangeFirst(): gp_Ax1;
  Last(): gp_Ax1;
  ChangeLast(): gp_Ax1;
  Value(theIndex: Standard_Integer): gp_Ax1;
  ChangeValue(theIndex: Standard_Integer): gp_Ax1;
  SetValue(theIndex: Standard_Integer, theItem: gp_Ax1): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfAx1_1 extends TColgp_SequenceOfAx1 {
    constructor();
  }

  export declare class TColgp_SequenceOfAx1_2 extends TColgp_SequenceOfAx1 {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfAx1_3 extends TColgp_SequenceOfAx1 {
    constructor(theOther: TColgp_SequenceOfAx1);
  }

export declare class TColgp_Array2OfPnt2d {
  Init(theValue: gp_Pnt2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfPnt2d): TColgp_Array2OfPnt2d;
  Move(theOther: TColgp_Array2OfPnt2d): TColgp_Array2OfPnt2d;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Pnt2d;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Pnt2d;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Pnt2d): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfPnt2d_1 extends TColgp_Array2OfPnt2d {
    constructor();
  }

  export declare class TColgp_Array2OfPnt2d_2 extends TColgp_Array2OfPnt2d {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfPnt2d_3 extends TColgp_Array2OfPnt2d {
    constructor(theOther: TColgp_Array2OfPnt2d);
  }

  export declare class TColgp_Array2OfPnt2d_4 extends TColgp_Array2OfPnt2d {
    constructor(theOther: TColgp_Array2OfPnt2d);
  }

  export declare class TColgp_Array2OfPnt2d_5 extends TColgp_Array2OfPnt2d {
    constructor(theBegin: gp_Pnt2d, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray1OfPnt2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfPnt2d): void;
  get(): TColgp_HArray1OfPnt2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfPnt2d_1 extends Handle_TColgp_HArray1OfPnt2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfPnt2d_2 extends Handle_TColgp_HArray1OfPnt2d {
    constructor(thePtr: TColgp_HArray1OfPnt2d);
  }

  export declare class Handle_TColgp_HArray1OfPnt2d_3 extends Handle_TColgp_HArray1OfPnt2d {
    constructor(theHandle: Handle_TColgp_HArray1OfPnt2d);
  }

  export declare class Handle_TColgp_HArray1OfPnt2d_4 extends Handle_TColgp_HArray1OfPnt2d {
    constructor(theHandle: Handle_TColgp_HArray1OfPnt2d);
  }

export declare class Handle_TColgp_HArray1OfVec2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfVec2d): void;
  get(): TColgp_HArray1OfVec2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfVec2d_1 extends Handle_TColgp_HArray1OfVec2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfVec2d_2 extends Handle_TColgp_HArray1OfVec2d {
    constructor(thePtr: TColgp_HArray1OfVec2d);
  }

  export declare class Handle_TColgp_HArray1OfVec2d_3 extends Handle_TColgp_HArray1OfVec2d {
    constructor(theHandle: Handle_TColgp_HArray1OfVec2d);
  }

  export declare class Handle_TColgp_HArray1OfVec2d_4 extends Handle_TColgp_HArray1OfVec2d {
    constructor(theHandle: Handle_TColgp_HArray1OfVec2d);
  }

export declare class Handle_TColgp_HArray2OfXY {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfXY): void;
  get(): TColgp_HArray2OfXY;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfXY_1 extends Handle_TColgp_HArray2OfXY {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfXY_2 extends Handle_TColgp_HArray2OfXY {
    constructor(thePtr: TColgp_HArray2OfXY);
  }

  export declare class Handle_TColgp_HArray2OfXY_3 extends Handle_TColgp_HArray2OfXY {
    constructor(theHandle: Handle_TColgp_HArray2OfXY);
  }

  export declare class Handle_TColgp_HArray2OfXY_4 extends Handle_TColgp_HArray2OfXY {
    constructor(theHandle: Handle_TColgp_HArray2OfXY);
  }

export declare class TColgp_SequenceOfDir2d extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfDir2d): TColgp_SequenceOfDir2d;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Dir2d): void;
  Append_2(theSeq: TColgp_SequenceOfDir2d): void;
  Prepend_1(theItem: gp_Dir2d): void;
  Prepend_2(theSeq: TColgp_SequenceOfDir2d): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Dir2d): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfDir2d): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfDir2d): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Dir2d): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfDir2d): void;
  First(): gp_Dir2d;
  ChangeFirst(): gp_Dir2d;
  Last(): gp_Dir2d;
  ChangeLast(): gp_Dir2d;
  Value(theIndex: Standard_Integer): gp_Dir2d;
  ChangeValue(theIndex: Standard_Integer): gp_Dir2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Dir2d): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfDir2d_1 extends TColgp_SequenceOfDir2d {
    constructor();
  }

  export declare class TColgp_SequenceOfDir2d_2 extends TColgp_SequenceOfDir2d {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfDir2d_3 extends TColgp_SequenceOfDir2d {
    constructor(theOther: TColgp_SequenceOfDir2d);
  }

export declare class Handle_TColgp_HArray1OfPnt {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfPnt): void;
  get(): TColgp_HArray1OfPnt;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfPnt_1 extends Handle_TColgp_HArray1OfPnt {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfPnt_2 extends Handle_TColgp_HArray1OfPnt {
    constructor(thePtr: TColgp_HArray1OfPnt);
  }

  export declare class Handle_TColgp_HArray1OfPnt_3 extends Handle_TColgp_HArray1OfPnt {
    constructor(theHandle: Handle_TColgp_HArray1OfPnt);
  }

  export declare class Handle_TColgp_HArray1OfPnt_4 extends Handle_TColgp_HArray1OfPnt {
    constructor(theHandle: Handle_TColgp_HArray1OfPnt);
  }

export declare class Handle_TColgp_HArray2OfVec {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfVec): void;
  get(): TColgp_HArray2OfVec;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfVec_1 extends Handle_TColgp_HArray2OfVec {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfVec_2 extends Handle_TColgp_HArray2OfVec {
    constructor(thePtr: TColgp_HArray2OfVec);
  }

  export declare class Handle_TColgp_HArray2OfVec_3 extends Handle_TColgp_HArray2OfVec {
    constructor(theHandle: Handle_TColgp_HArray2OfVec);
  }

  export declare class Handle_TColgp_HArray2OfVec_4 extends Handle_TColgp_HArray2OfVec {
    constructor(theHandle: Handle_TColgp_HArray2OfVec);
  }

export declare class TColgp_SequenceOfVec2d extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfVec2d): TColgp_SequenceOfVec2d;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Vec2d): void;
  Append_2(theSeq: TColgp_SequenceOfVec2d): void;
  Prepend_1(theItem: gp_Vec2d): void;
  Prepend_2(theSeq: TColgp_SequenceOfVec2d): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Vec2d): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfVec2d): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfVec2d): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Vec2d): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfVec2d): void;
  First(): gp_Vec2d;
  ChangeFirst(): gp_Vec2d;
  Last(): gp_Vec2d;
  ChangeLast(): gp_Vec2d;
  Value(theIndex: Standard_Integer): gp_Vec2d;
  ChangeValue(theIndex: Standard_Integer): gp_Vec2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Vec2d): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfVec2d_1 extends TColgp_SequenceOfVec2d {
    constructor();
  }

  export declare class TColgp_SequenceOfVec2d_2 extends TColgp_SequenceOfVec2d {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfVec2d_3 extends TColgp_SequenceOfVec2d {
    constructor(theOther: TColgp_SequenceOfVec2d);
  }

export declare class Handle_TColgp_HSequenceOfVec2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfVec2d): void;
  get(): TColgp_HSequenceOfVec2d;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfVec2d_1 extends Handle_TColgp_HSequenceOfVec2d {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfVec2d_2 extends Handle_TColgp_HSequenceOfVec2d {
    constructor(thePtr: TColgp_HSequenceOfVec2d);
  }

  export declare class Handle_TColgp_HSequenceOfVec2d_3 extends Handle_TColgp_HSequenceOfVec2d {
    constructor(theHandle: Handle_TColgp_HSequenceOfVec2d);
  }

  export declare class Handle_TColgp_HSequenceOfVec2d_4 extends Handle_TColgp_HSequenceOfVec2d {
    constructor(theHandle: Handle_TColgp_HSequenceOfVec2d);
  }

export declare class TColgp_SequenceOfDir extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfDir): TColgp_SequenceOfDir;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Dir): void;
  Append_2(theSeq: TColgp_SequenceOfDir): void;
  Prepend_1(theItem: gp_Dir): void;
  Prepend_2(theSeq: TColgp_SequenceOfDir): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Dir): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfDir): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfDir): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Dir): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfDir): void;
  First(): gp_Dir;
  ChangeFirst(): gp_Dir;
  Last(): gp_Dir;
  ChangeLast(): gp_Dir;
  Value(theIndex: Standard_Integer): gp_Dir;
  ChangeValue(theIndex: Standard_Integer): gp_Dir;
  SetValue(theIndex: Standard_Integer, theItem: gp_Dir): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfDir_1 extends TColgp_SequenceOfDir {
    constructor();
  }

  export declare class TColgp_SequenceOfDir_2 extends TColgp_SequenceOfDir {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfDir_3 extends TColgp_SequenceOfDir {
    constructor(theOther: TColgp_SequenceOfDir);
  }

export declare class TColgp_Array1OfPnt {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Pnt): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfPnt): TColgp_Array1OfPnt;
  Move(theOther: TColgp_Array1OfPnt): TColgp_Array1OfPnt;
  First(): gp_Pnt;
  ChangeFirst(): gp_Pnt;
  Last(): gp_Pnt;
  ChangeLast(): gp_Pnt;
  Value(theIndex: Standard_Integer): gp_Pnt;
  ChangeValue(theIndex: Standard_Integer): gp_Pnt;
  SetValue(theIndex: Standard_Integer, theItem: gp_Pnt): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfPnt_1 extends TColgp_Array1OfPnt {
    constructor();
  }

  export declare class TColgp_Array1OfPnt_2 extends TColgp_Array1OfPnt {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfPnt_3 extends TColgp_Array1OfPnt {
    constructor(theOther: TColgp_Array1OfPnt);
  }

  export declare class TColgp_Array1OfPnt_4 extends TColgp_Array1OfPnt {
    constructor(theOther: TColgp_Array1OfPnt);
  }

  export declare class TColgp_Array1OfPnt_5 extends TColgp_Array1OfPnt {
    constructor(theBegin: gp_Pnt, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray1OfXY {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfXY): void;
  get(): TColgp_HArray1OfXY;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfXY_1 extends Handle_TColgp_HArray1OfXY {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfXY_2 extends Handle_TColgp_HArray1OfXY {
    constructor(thePtr: TColgp_HArray1OfXY);
  }

  export declare class Handle_TColgp_HArray1OfXY_3 extends Handle_TColgp_HArray1OfXY {
    constructor(theHandle: Handle_TColgp_HArray1OfXY);
  }

  export declare class Handle_TColgp_HArray1OfXY_4 extends Handle_TColgp_HArray1OfXY {
    constructor(theHandle: Handle_TColgp_HArray1OfXY);
  }

export declare class Handle_TColgp_HSequenceOfDir2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfDir2d): void;
  get(): TColgp_HSequenceOfDir2d;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfDir2d_1 extends Handle_TColgp_HSequenceOfDir2d {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfDir2d_2 extends Handle_TColgp_HSequenceOfDir2d {
    constructor(thePtr: TColgp_HSequenceOfDir2d);
  }

  export declare class Handle_TColgp_HSequenceOfDir2d_3 extends Handle_TColgp_HSequenceOfDir2d {
    constructor(theHandle: Handle_TColgp_HSequenceOfDir2d);
  }

  export declare class Handle_TColgp_HSequenceOfDir2d_4 extends Handle_TColgp_HSequenceOfDir2d {
    constructor(theHandle: Handle_TColgp_HSequenceOfDir2d);
  }

export declare class TColgp_Array1OfXYZ {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_XYZ): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfXYZ): TColgp_Array1OfXYZ;
  Move(theOther: TColgp_Array1OfXYZ): TColgp_Array1OfXYZ;
  First(): gp_XYZ;
  ChangeFirst(): gp_XYZ;
  Last(): gp_XYZ;
  ChangeLast(): gp_XYZ;
  Value(theIndex: Standard_Integer): gp_XYZ;
  ChangeValue(theIndex: Standard_Integer): gp_XYZ;
  SetValue(theIndex: Standard_Integer, theItem: gp_XYZ): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfXYZ_1 extends TColgp_Array1OfXYZ {
    constructor();
  }

  export declare class TColgp_Array1OfXYZ_2 extends TColgp_Array1OfXYZ {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfXYZ_3 extends TColgp_Array1OfXYZ {
    constructor(theOther: TColgp_Array1OfXYZ);
  }

  export declare class TColgp_Array1OfXYZ_4 extends TColgp_Array1OfXYZ {
    constructor(theOther: TColgp_Array1OfXYZ);
  }

  export declare class TColgp_Array1OfXYZ_5 extends TColgp_Array1OfXYZ {
    constructor(theBegin: gp_XYZ, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColgp_Array2OfLin2d {
  Init(theValue: gp_Lin2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfLin2d): TColgp_Array2OfLin2d;
  Move(theOther: TColgp_Array2OfLin2d): TColgp_Array2OfLin2d;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Lin2d;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Lin2d;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Lin2d): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfLin2d_1 extends TColgp_Array2OfLin2d {
    constructor();
  }

  export declare class TColgp_Array2OfLin2d_2 extends TColgp_Array2OfLin2d {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfLin2d_3 extends TColgp_Array2OfLin2d {
    constructor(theOther: TColgp_Array2OfLin2d);
  }

  export declare class TColgp_Array2OfLin2d_4 extends TColgp_Array2OfLin2d {
    constructor(theOther: TColgp_Array2OfLin2d);
  }

  export declare class TColgp_Array2OfLin2d_5 extends TColgp_Array2OfLin2d {
    constructor(theBegin: gp_Lin2d, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray1OfDir2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfDir2d): void;
  get(): TColgp_HArray1OfDir2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfDir2d_1 extends Handle_TColgp_HArray1OfDir2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfDir2d_2 extends Handle_TColgp_HArray1OfDir2d {
    constructor(thePtr: TColgp_HArray1OfDir2d);
  }

  export declare class Handle_TColgp_HArray1OfDir2d_3 extends Handle_TColgp_HArray1OfDir2d {
    constructor(theHandle: Handle_TColgp_HArray1OfDir2d);
  }

  export declare class Handle_TColgp_HArray1OfDir2d_4 extends Handle_TColgp_HArray1OfDir2d {
    constructor(theHandle: Handle_TColgp_HArray1OfDir2d);
  }

export declare class TColgp_Array1OfPnt2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Pnt2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfPnt2d): TColgp_Array1OfPnt2d;
  Move(theOther: TColgp_Array1OfPnt2d): TColgp_Array1OfPnt2d;
  First(): gp_Pnt2d;
  ChangeFirst(): gp_Pnt2d;
  Last(): gp_Pnt2d;
  ChangeLast(): gp_Pnt2d;
  Value(theIndex: Standard_Integer): gp_Pnt2d;
  ChangeValue(theIndex: Standard_Integer): gp_Pnt2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Pnt2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfPnt2d_1 extends TColgp_Array1OfPnt2d {
    constructor();
  }

  export declare class TColgp_Array1OfPnt2d_2 extends TColgp_Array1OfPnt2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfPnt2d_3 extends TColgp_Array1OfPnt2d {
    constructor(theOther: TColgp_Array1OfPnt2d);
  }

  export declare class TColgp_Array1OfPnt2d_4 extends TColgp_Array1OfPnt2d {
    constructor(theOther: TColgp_Array1OfPnt2d);
  }

  export declare class TColgp_Array1OfPnt2d_5 extends TColgp_Array1OfPnt2d {
    constructor(theBegin: gp_Pnt2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColgp_Array1OfCirc2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Circ2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfCirc2d): TColgp_Array1OfCirc2d;
  Move(theOther: TColgp_Array1OfCirc2d): TColgp_Array1OfCirc2d;
  First(): gp_Circ2d;
  ChangeFirst(): gp_Circ2d;
  Last(): gp_Circ2d;
  ChangeLast(): gp_Circ2d;
  Value(theIndex: Standard_Integer): gp_Circ2d;
  ChangeValue(theIndex: Standard_Integer): gp_Circ2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Circ2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfCirc2d_1 extends TColgp_Array1OfCirc2d {
    constructor();
  }

  export declare class TColgp_Array1OfCirc2d_2 extends TColgp_Array1OfCirc2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfCirc2d_3 extends TColgp_Array1OfCirc2d {
    constructor(theOther: TColgp_Array1OfCirc2d);
  }

  export declare class TColgp_Array1OfCirc2d_4 extends TColgp_Array1OfCirc2d {
    constructor(theOther: TColgp_Array1OfCirc2d);
  }

  export declare class TColgp_Array1OfCirc2d_5 extends TColgp_Array1OfCirc2d {
    constructor(theBegin: gp_Circ2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColgp_Array1OfDir {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Dir): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfDir): TColgp_Array1OfDir;
  Move(theOther: TColgp_Array1OfDir): TColgp_Array1OfDir;
  First(): gp_Dir;
  ChangeFirst(): gp_Dir;
  Last(): gp_Dir;
  ChangeLast(): gp_Dir;
  Value(theIndex: Standard_Integer): gp_Dir;
  ChangeValue(theIndex: Standard_Integer): gp_Dir;
  SetValue(theIndex: Standard_Integer, theItem: gp_Dir): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfDir_1 extends TColgp_Array1OfDir {
    constructor();
  }

  export declare class TColgp_Array1OfDir_2 extends TColgp_Array1OfDir {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfDir_3 extends TColgp_Array1OfDir {
    constructor(theOther: TColgp_Array1OfDir);
  }

  export declare class TColgp_Array1OfDir_4 extends TColgp_Array1OfDir {
    constructor(theOther: TColgp_Array1OfDir);
  }

  export declare class TColgp_Array1OfDir_5 extends TColgp_Array1OfDir {
    constructor(theBegin: gp_Dir, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TColgp_Array2OfCirc2d {
  Init(theValue: gp_Circ2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfCirc2d): TColgp_Array2OfCirc2d;
  Move(theOther: TColgp_Array2OfCirc2d): TColgp_Array2OfCirc2d;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Circ2d;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Circ2d;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Circ2d): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfCirc2d_1 extends TColgp_Array2OfCirc2d {
    constructor();
  }

  export declare class TColgp_Array2OfCirc2d_2 extends TColgp_Array2OfCirc2d {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfCirc2d_3 extends TColgp_Array2OfCirc2d {
    constructor(theOther: TColgp_Array2OfCirc2d);
  }

  export declare class TColgp_Array2OfCirc2d_4 extends TColgp_Array2OfCirc2d {
    constructor(theOther: TColgp_Array2OfCirc2d);
  }

  export declare class TColgp_Array2OfCirc2d_5 extends TColgp_Array2OfCirc2d {
    constructor(theBegin: gp_Circ2d, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColgp_Array2OfDir {
  Init(theValue: gp_Dir): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfDir): TColgp_Array2OfDir;
  Move(theOther: TColgp_Array2OfDir): TColgp_Array2OfDir;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Dir;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Dir;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Dir): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfDir_1 extends TColgp_Array2OfDir {
    constructor();
  }

  export declare class TColgp_Array2OfDir_2 extends TColgp_Array2OfDir {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfDir_3 extends TColgp_Array2OfDir {
    constructor(theOther: TColgp_Array2OfDir);
  }

  export declare class TColgp_Array2OfDir_4 extends TColgp_Array2OfDir {
    constructor(theOther: TColgp_Array2OfDir);
  }

  export declare class TColgp_Array2OfDir_5 extends TColgp_Array2OfDir {
    constructor(theBegin: gp_Dir, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColgp_Array1OfVec {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Vec): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfVec): TColgp_Array1OfVec;
  Move(theOther: TColgp_Array1OfVec): TColgp_Array1OfVec;
  First(): gp_Vec;
  ChangeFirst(): gp_Vec;
  Last(): gp_Vec;
  ChangeLast(): gp_Vec;
  Value(theIndex: Standard_Integer): gp_Vec;
  ChangeValue(theIndex: Standard_Integer): gp_Vec;
  SetValue(theIndex: Standard_Integer, theItem: gp_Vec): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfVec_1 extends TColgp_Array1OfVec {
    constructor();
  }

  export declare class TColgp_Array1OfVec_2 extends TColgp_Array1OfVec {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfVec_3 extends TColgp_Array1OfVec {
    constructor(theOther: TColgp_Array1OfVec);
  }

  export declare class TColgp_Array1OfVec_4 extends TColgp_Array1OfVec {
    constructor(theOther: TColgp_Array1OfVec);
  }

  export declare class TColgp_Array1OfVec_5 extends TColgp_Array1OfVec {
    constructor(theBegin: gp_Vec, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray2OfPnt2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfPnt2d): void;
  get(): TColgp_HArray2OfPnt2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfPnt2d_1 extends Handle_TColgp_HArray2OfPnt2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfPnt2d_2 extends Handle_TColgp_HArray2OfPnt2d {
    constructor(thePtr: TColgp_HArray2OfPnt2d);
  }

  export declare class Handle_TColgp_HArray2OfPnt2d_3 extends Handle_TColgp_HArray2OfPnt2d {
    constructor(theHandle: Handle_TColgp_HArray2OfPnt2d);
  }

  export declare class Handle_TColgp_HArray2OfPnt2d_4 extends Handle_TColgp_HArray2OfPnt2d {
    constructor(theHandle: Handle_TColgp_HArray2OfPnt2d);
  }

export declare class Handle_TColgp_HArray1OfVec {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfVec): void;
  get(): TColgp_HArray1OfVec;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfVec_1 extends Handle_TColgp_HArray1OfVec {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfVec_2 extends Handle_TColgp_HArray1OfVec {
    constructor(thePtr: TColgp_HArray1OfVec);
  }

  export declare class Handle_TColgp_HArray1OfVec_3 extends Handle_TColgp_HArray1OfVec {
    constructor(theHandle: Handle_TColgp_HArray1OfVec);
  }

  export declare class Handle_TColgp_HArray1OfVec_4 extends Handle_TColgp_HArray1OfVec {
    constructor(theHandle: Handle_TColgp_HArray1OfVec);
  }

export declare class Handle_TColgp_HSequenceOfDir {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfDir): void;
  get(): TColgp_HSequenceOfDir;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfDir_1 extends Handle_TColgp_HSequenceOfDir {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfDir_2 extends Handle_TColgp_HSequenceOfDir {
    constructor(thePtr: TColgp_HSequenceOfDir);
  }

  export declare class Handle_TColgp_HSequenceOfDir_3 extends Handle_TColgp_HSequenceOfDir {
    constructor(theHandle: Handle_TColgp_HSequenceOfDir);
  }

  export declare class Handle_TColgp_HSequenceOfDir_4 extends Handle_TColgp_HSequenceOfDir {
    constructor(theHandle: Handle_TColgp_HSequenceOfDir);
  }

export declare class Handle_TColgp_HArray2OfLin2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfLin2d): void;
  get(): TColgp_HArray2OfLin2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfLin2d_1 extends Handle_TColgp_HArray2OfLin2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfLin2d_2 extends Handle_TColgp_HArray2OfLin2d {
    constructor(thePtr: TColgp_HArray2OfLin2d);
  }

  export declare class Handle_TColgp_HArray2OfLin2d_3 extends Handle_TColgp_HArray2OfLin2d {
    constructor(theHandle: Handle_TColgp_HArray2OfLin2d);
  }

  export declare class Handle_TColgp_HArray2OfLin2d_4 extends Handle_TColgp_HArray2OfLin2d {
    constructor(theHandle: Handle_TColgp_HArray2OfLin2d);
  }

export declare class Handle_TColgp_HSequenceOfPnt2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfPnt2d): void;
  get(): TColgp_HSequenceOfPnt2d;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfPnt2d_1 extends Handle_TColgp_HSequenceOfPnt2d {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfPnt2d_2 extends Handle_TColgp_HSequenceOfPnt2d {
    constructor(thePtr: TColgp_HSequenceOfPnt2d);
  }

  export declare class Handle_TColgp_HSequenceOfPnt2d_3 extends Handle_TColgp_HSequenceOfPnt2d {
    constructor(theHandle: Handle_TColgp_HSequenceOfPnt2d);
  }

  export declare class Handle_TColgp_HSequenceOfPnt2d_4 extends Handle_TColgp_HSequenceOfPnt2d {
    constructor(theHandle: Handle_TColgp_HSequenceOfPnt2d);
  }

export declare class Handle_TColgp_HSequenceOfXY {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfXY): void;
  get(): TColgp_HSequenceOfXY;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfXY_1 extends Handle_TColgp_HSequenceOfXY {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfXY_2 extends Handle_TColgp_HSequenceOfXY {
    constructor(thePtr: TColgp_HSequenceOfXY);
  }

  export declare class Handle_TColgp_HSequenceOfXY_3 extends Handle_TColgp_HSequenceOfXY {
    constructor(theHandle: Handle_TColgp_HSequenceOfXY);
  }

  export declare class Handle_TColgp_HSequenceOfXY_4 extends Handle_TColgp_HSequenceOfXY {
    constructor(theHandle: Handle_TColgp_HSequenceOfXY);
  }

export declare class TColgp_Array2OfXYZ {
  Init(theValue: gp_XYZ): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfXYZ): TColgp_Array2OfXYZ;
  Move(theOther: TColgp_Array2OfXYZ): TColgp_Array2OfXYZ;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_XYZ;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_XYZ;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_XYZ): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfXYZ_1 extends TColgp_Array2OfXYZ {
    constructor();
  }

  export declare class TColgp_Array2OfXYZ_2 extends TColgp_Array2OfXYZ {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfXYZ_3 extends TColgp_Array2OfXYZ {
    constructor(theOther: TColgp_Array2OfXYZ);
  }

  export declare class TColgp_Array2OfXYZ_4 extends TColgp_Array2OfXYZ {
    constructor(theOther: TColgp_Array2OfXYZ);
  }

  export declare class TColgp_Array2OfXYZ_5 extends TColgp_Array2OfXYZ {
    constructor(theBegin: gp_XYZ, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray2OfPnt {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfPnt): void;
  get(): TColgp_HArray2OfPnt;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfPnt_1 extends Handle_TColgp_HArray2OfPnt {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfPnt_2 extends Handle_TColgp_HArray2OfPnt {
    constructor(thePtr: TColgp_HArray2OfPnt);
  }

  export declare class Handle_TColgp_HArray2OfPnt_3 extends Handle_TColgp_HArray2OfPnt {
    constructor(theHandle: Handle_TColgp_HArray2OfPnt);
  }

  export declare class Handle_TColgp_HArray2OfPnt_4 extends Handle_TColgp_HArray2OfPnt {
    constructor(theHandle: Handle_TColgp_HArray2OfPnt);
  }

export declare class TColgp_SequenceOfPnt extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfPnt): TColgp_SequenceOfPnt;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Pnt): void;
  Append_2(theSeq: TColgp_SequenceOfPnt): void;
  Prepend_1(theItem: gp_Pnt): void;
  Prepend_2(theSeq: TColgp_SequenceOfPnt): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Pnt): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfPnt): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfPnt): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Pnt): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfPnt): void;
  First(): gp_Pnt;
  ChangeFirst(): gp_Pnt;
  Last(): gp_Pnt;
  ChangeLast(): gp_Pnt;
  Value(theIndex: Standard_Integer): gp_Pnt;
  ChangeValue(theIndex: Standard_Integer): gp_Pnt;
  SetValue(theIndex: Standard_Integer, theItem: gp_Pnt): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfPnt_1 extends TColgp_SequenceOfPnt {
    constructor();
  }

  export declare class TColgp_SequenceOfPnt_2 extends TColgp_SequenceOfPnt {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfPnt_3 extends TColgp_SequenceOfPnt {
    constructor(theOther: TColgp_SequenceOfPnt);
  }

export declare class Handle_TColgp_HSequenceOfPnt {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfPnt): void;
  get(): TColgp_HSequenceOfPnt;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfPnt_1 extends Handle_TColgp_HSequenceOfPnt {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfPnt_2 extends Handle_TColgp_HSequenceOfPnt {
    constructor(thePtr: TColgp_HSequenceOfPnt);
  }

  export declare class Handle_TColgp_HSequenceOfPnt_3 extends Handle_TColgp_HSequenceOfPnt {
    constructor(theHandle: Handle_TColgp_HSequenceOfPnt);
  }

  export declare class Handle_TColgp_HSequenceOfPnt_4 extends Handle_TColgp_HSequenceOfPnt {
    constructor(theHandle: Handle_TColgp_HSequenceOfPnt);
  }

export declare class Handle_TColgp_HArray1OfDir {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfDir): void;
  get(): TColgp_HArray1OfDir;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfDir_1 extends Handle_TColgp_HArray1OfDir {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfDir_2 extends Handle_TColgp_HArray1OfDir {
    constructor(thePtr: TColgp_HArray1OfDir);
  }

  export declare class Handle_TColgp_HArray1OfDir_3 extends Handle_TColgp_HArray1OfDir {
    constructor(theHandle: Handle_TColgp_HArray1OfDir);
  }

  export declare class Handle_TColgp_HArray1OfDir_4 extends Handle_TColgp_HArray1OfDir {
    constructor(theHandle: Handle_TColgp_HArray1OfDir);
  }

export declare class TColgp_Array2OfDir2d {
  Init(theValue: gp_Dir2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfDir2d): TColgp_Array2OfDir2d;
  Move(theOther: TColgp_Array2OfDir2d): TColgp_Array2OfDir2d;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Dir2d;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Dir2d;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Dir2d): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfDir2d_1 extends TColgp_Array2OfDir2d {
    constructor();
  }

  export declare class TColgp_Array2OfDir2d_2 extends TColgp_Array2OfDir2d {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfDir2d_3 extends TColgp_Array2OfDir2d {
    constructor(theOther: TColgp_Array2OfDir2d);
  }

  export declare class TColgp_Array2OfDir2d_4 extends TColgp_Array2OfDir2d {
    constructor(theOther: TColgp_Array2OfDir2d);
  }

  export declare class TColgp_Array2OfDir2d_5 extends TColgp_Array2OfDir2d {
    constructor(theBegin: gp_Dir2d, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColgp_Array2OfVec {
  Init(theValue: gp_Vec): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfVec): TColgp_Array2OfVec;
  Move(theOther: TColgp_Array2OfVec): TColgp_Array2OfVec;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Vec;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Vec;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Vec): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfVec_1 extends TColgp_Array2OfVec {
    constructor();
  }

  export declare class TColgp_Array2OfVec_2 extends TColgp_Array2OfVec {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfVec_3 extends TColgp_Array2OfVec {
    constructor(theOther: TColgp_Array2OfVec);
  }

  export declare class TColgp_Array2OfVec_4 extends TColgp_Array2OfVec {
    constructor(theOther: TColgp_Array2OfVec);
  }

  export declare class TColgp_Array2OfVec_5 extends TColgp_Array2OfVec {
    constructor(theBegin: gp_Vec, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColgp_Array2OfVec2d {
  Init(theValue: gp_Vec2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfVec2d): TColgp_Array2OfVec2d;
  Move(theOther: TColgp_Array2OfVec2d): TColgp_Array2OfVec2d;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Vec2d;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Vec2d;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Vec2d): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfVec2d_1 extends TColgp_Array2OfVec2d {
    constructor();
  }

  export declare class TColgp_Array2OfVec2d_2 extends TColgp_Array2OfVec2d {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfVec2d_3 extends TColgp_Array2OfVec2d {
    constructor(theOther: TColgp_Array2OfVec2d);
  }

  export declare class TColgp_Array2OfVec2d_4 extends TColgp_Array2OfVec2d {
    constructor(theOther: TColgp_Array2OfVec2d);
  }

  export declare class TColgp_Array2OfVec2d_5 extends TColgp_Array2OfVec2d {
    constructor(theBegin: gp_Vec2d, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HArray1OfXYZ {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfXYZ): void;
  get(): TColgp_HArray1OfXYZ;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfXYZ_1 extends Handle_TColgp_HArray1OfXYZ {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfXYZ_2 extends Handle_TColgp_HArray1OfXYZ {
    constructor(thePtr: TColgp_HArray1OfXYZ);
  }

  export declare class Handle_TColgp_HArray1OfXYZ_3 extends Handle_TColgp_HArray1OfXYZ {
    constructor(theHandle: Handle_TColgp_HArray1OfXYZ);
  }

  export declare class Handle_TColgp_HArray1OfXYZ_4 extends Handle_TColgp_HArray1OfXYZ {
    constructor(theHandle: Handle_TColgp_HArray1OfXYZ);
  }

export declare class Handle_TColgp_HArray2OfCirc2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfCirc2d): void;
  get(): TColgp_HArray2OfCirc2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfCirc2d_1 extends Handle_TColgp_HArray2OfCirc2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfCirc2d_2 extends Handle_TColgp_HArray2OfCirc2d {
    constructor(thePtr: TColgp_HArray2OfCirc2d);
  }

  export declare class Handle_TColgp_HArray2OfCirc2d_3 extends Handle_TColgp_HArray2OfCirc2d {
    constructor(theHandle: Handle_TColgp_HArray2OfCirc2d);
  }

  export declare class Handle_TColgp_HArray2OfCirc2d_4 extends Handle_TColgp_HArray2OfCirc2d {
    constructor(theHandle: Handle_TColgp_HArray2OfCirc2d);
  }

export declare class TColgp_Array2OfPnt {
  Init(theValue: gp_Pnt): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TColgp_Array2OfPnt): TColgp_Array2OfPnt;
  Move(theOther: TColgp_Array2OfPnt): TColgp_Array2OfPnt;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): gp_Pnt;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): gp_Pnt;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: gp_Pnt): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array2OfPnt_1 extends TColgp_Array2OfPnt {
    constructor();
  }

  export declare class TColgp_Array2OfPnt_2 extends TColgp_Array2OfPnt {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TColgp_Array2OfPnt_3 extends TColgp_Array2OfPnt {
    constructor(theOther: TColgp_Array2OfPnt);
  }

  export declare class TColgp_Array2OfPnt_4 extends TColgp_Array2OfPnt {
    constructor(theOther: TColgp_Array2OfPnt);
  }

  export declare class TColgp_Array2OfPnt_5 extends TColgp_Array2OfPnt {
    constructor(theBegin: gp_Pnt, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TColgp_SequenceOfPnt2d extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfPnt2d): TColgp_SequenceOfPnt2d;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_Pnt2d): void;
  Append_2(theSeq: TColgp_SequenceOfPnt2d): void;
  Prepend_1(theItem: gp_Pnt2d): void;
  Prepend_2(theSeq: TColgp_SequenceOfPnt2d): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_Pnt2d): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfPnt2d): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfPnt2d): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_Pnt2d): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfPnt2d): void;
  First(): gp_Pnt2d;
  ChangeFirst(): gp_Pnt2d;
  Last(): gp_Pnt2d;
  ChangeLast(): gp_Pnt2d;
  Value(theIndex: Standard_Integer): gp_Pnt2d;
  ChangeValue(theIndex: Standard_Integer): gp_Pnt2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Pnt2d): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfPnt2d_1 extends TColgp_SequenceOfPnt2d {
    constructor();
  }

  export declare class TColgp_SequenceOfPnt2d_2 extends TColgp_SequenceOfPnt2d {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfPnt2d_3 extends TColgp_SequenceOfPnt2d {
    constructor(theOther: TColgp_SequenceOfPnt2d);
  }

export declare class Handle_TColgp_HArray2OfDir {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfDir): void;
  get(): TColgp_HArray2OfDir;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfDir_1 extends Handle_TColgp_HArray2OfDir {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfDir_2 extends Handle_TColgp_HArray2OfDir {
    constructor(thePtr: TColgp_HArray2OfDir);
  }

  export declare class Handle_TColgp_HArray2OfDir_3 extends Handle_TColgp_HArray2OfDir {
    constructor(theHandle: Handle_TColgp_HArray2OfDir);
  }

  export declare class Handle_TColgp_HArray2OfDir_4 extends Handle_TColgp_HArray2OfDir {
    constructor(theHandle: Handle_TColgp_HArray2OfDir);
  }

export declare class Handle_TColgp_HArray1OfCirc2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray1OfCirc2d): void;
  get(): TColgp_HArray1OfCirc2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray1OfCirc2d_1 extends Handle_TColgp_HArray1OfCirc2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray1OfCirc2d_2 extends Handle_TColgp_HArray1OfCirc2d {
    constructor(thePtr: TColgp_HArray1OfCirc2d);
  }

  export declare class Handle_TColgp_HArray1OfCirc2d_3 extends Handle_TColgp_HArray1OfCirc2d {
    constructor(theHandle: Handle_TColgp_HArray1OfCirc2d);
  }

  export declare class Handle_TColgp_HArray1OfCirc2d_4 extends Handle_TColgp_HArray1OfCirc2d {
    constructor(theHandle: Handle_TColgp_HArray1OfCirc2d);
  }

export declare class Handle_TColgp_HArray2OfDir2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfDir2d): void;
  get(): TColgp_HArray2OfDir2d;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfDir2d_1 extends Handle_TColgp_HArray2OfDir2d {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfDir2d_2 extends Handle_TColgp_HArray2OfDir2d {
    constructor(thePtr: TColgp_HArray2OfDir2d);
  }

  export declare class Handle_TColgp_HArray2OfDir2d_3 extends Handle_TColgp_HArray2OfDir2d {
    constructor(theHandle: Handle_TColgp_HArray2OfDir2d);
  }

  export declare class Handle_TColgp_HArray2OfDir2d_4 extends Handle_TColgp_HArray2OfDir2d {
    constructor(theHandle: Handle_TColgp_HArray2OfDir2d);
  }

export declare class TColgp_SequenceOfXY extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TColgp_SequenceOfXY): TColgp_SequenceOfXY;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: gp_XY): void;
  Append_2(theSeq: TColgp_SequenceOfXY): void;
  Prepend_1(theItem: gp_XY): void;
  Prepend_2(theSeq: TColgp_SequenceOfXY): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: gp_XY): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfXY): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfXY): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: gp_XY): void;
  Split(theIndex: Standard_Integer, theSeq: TColgp_SequenceOfXY): void;
  First(): gp_XY;
  ChangeFirst(): gp_XY;
  Last(): gp_XY;
  ChangeLast(): gp_XY;
  Value(theIndex: Standard_Integer): gp_XY;
  ChangeValue(theIndex: Standard_Integer): gp_XY;
  SetValue(theIndex: Standard_Integer, theItem: gp_XY): void;
  delete(): void;
}

  export declare class TColgp_SequenceOfXY_1 extends TColgp_SequenceOfXY {
    constructor();
  }

  export declare class TColgp_SequenceOfXY_2 extends TColgp_SequenceOfXY {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TColgp_SequenceOfXY_3 extends TColgp_SequenceOfXY {
    constructor(theOther: TColgp_SequenceOfXY);
  }

export declare class TColgp_Array1OfLin2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Lin2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TColgp_Array1OfLin2d): TColgp_Array1OfLin2d;
  Move(theOther: TColgp_Array1OfLin2d): TColgp_Array1OfLin2d;
  First(): gp_Lin2d;
  ChangeFirst(): gp_Lin2d;
  Last(): gp_Lin2d;
  ChangeLast(): gp_Lin2d;
  Value(theIndex: Standard_Integer): gp_Lin2d;
  ChangeValue(theIndex: Standard_Integer): gp_Lin2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_Lin2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TColgp_Array1OfLin2d_1 extends TColgp_Array1OfLin2d {
    constructor();
  }

  export declare class TColgp_Array1OfLin2d_2 extends TColgp_Array1OfLin2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TColgp_Array1OfLin2d_3 extends TColgp_Array1OfLin2d {
    constructor(theOther: TColgp_Array1OfLin2d);
  }

  export declare class TColgp_Array1OfLin2d_4 extends TColgp_Array1OfLin2d {
    constructor(theOther: TColgp_Array1OfLin2d);
  }

  export declare class TColgp_Array1OfLin2d_5 extends TColgp_Array1OfLin2d {
    constructor(theBegin: gp_Lin2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_TColgp_HSequenceOfVec {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HSequenceOfVec): void;
  get(): TColgp_HSequenceOfVec;
  delete(): void;
}

  export declare class Handle_TColgp_HSequenceOfVec_1 extends Handle_TColgp_HSequenceOfVec {
    constructor();
  }

  export declare class Handle_TColgp_HSequenceOfVec_2 extends Handle_TColgp_HSequenceOfVec {
    constructor(thePtr: TColgp_HSequenceOfVec);
  }

  export declare class Handle_TColgp_HSequenceOfVec_3 extends Handle_TColgp_HSequenceOfVec {
    constructor(theHandle: Handle_TColgp_HSequenceOfVec);
  }

  export declare class Handle_TColgp_HSequenceOfVec_4 extends Handle_TColgp_HSequenceOfVec {
    constructor(theHandle: Handle_TColgp_HSequenceOfVec);
  }

export declare class Handle_TColgp_HArray2OfXYZ {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColgp_HArray2OfXYZ): void;
  get(): TColgp_HArray2OfXYZ;
  delete(): void;
}

  export declare class Handle_TColgp_HArray2OfXYZ_1 extends Handle_TColgp_HArray2OfXYZ {
    constructor();
  }

  export declare class Handle_TColgp_HArray2OfXYZ_2 extends Handle_TColgp_HArray2OfXYZ {
    constructor(thePtr: TColgp_HArray2OfXYZ);
  }

  export declare class Handle_TColgp_HArray2OfXYZ_3 extends Handle_TColgp_HArray2OfXYZ {
    constructor(theHandle: Handle_TColgp_HArray2OfXYZ);
  }

  export declare class Handle_TColgp_HArray2OfXYZ_4 extends Handle_TColgp_HArray2OfXYZ {
    constructor(theHandle: Handle_TColgp_HArray2OfXYZ);
  }

export declare class FairCurve_BattenLaw extends math_Function {
  constructor(Heigth: Quantity_AbsorbedDose, Slope: Quantity_AbsorbedDose, Sliding: Quantity_AbsorbedDose)
  SetSliding(Sliding: Quantity_AbsorbedDose): void;
  SetHeigth(Heigth: Quantity_AbsorbedDose): void;
  SetSlope(Slope: Quantity_AbsorbedDose): void;
  Value(T: Quantity_AbsorbedDose, THeigth: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class FairCurve_EnergyOfBatten extends FairCurve_Energy {
  constructor(BSplOrder: Graphic3d_ZLayerId, FlatKnots: Handle_TColStd_HArray1OfReal, Poles: Handle_TColgp_HArray1OfPnt2d, ContrOrder1: Graphic3d_ZLayerId, ContrOrder2: Graphic3d_ZLayerId, Law: FairCurve_BattenLaw, LengthSliding: Quantity_AbsorbedDose, FreeSliding: Standard_Boolean, Angle1: Quantity_AbsorbedDose, Angle2: Quantity_AbsorbedDose)
  LengthSliding(): Quantity_AbsorbedDose;
  Status(): FairCurve_AnalysisCode;
  Variable(X: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare type FairCurve_AnalysisCode = {
  FairCurve_OK: {};
  FairCurve_NotConverged: {};
  FairCurve_InfiniteSliding: {};
  FairCurve_NullHeight: {};
}

export declare class FairCurve_EnergyOfMVC extends FairCurve_Energy {
  constructor(BSplOrder: Graphic3d_ZLayerId, FlatKnots: Handle_TColStd_HArray1OfReal, Poles: Handle_TColgp_HArray1OfPnt2d, ContrOrder1: Graphic3d_ZLayerId, ContrOrder2: Graphic3d_ZLayerId, Law: FairCurve_BattenLaw, PhysicalRatio: Quantity_AbsorbedDose, LengthSliding: Quantity_AbsorbedDose, FreeSliding: Standard_Boolean, Angle1: Quantity_AbsorbedDose, Angle2: Quantity_AbsorbedDose, Curvature1: Quantity_AbsorbedDose, Curvature2: Quantity_AbsorbedDose)
  LengthSliding(): Quantity_AbsorbedDose;
  Status(): FairCurve_AnalysisCode;
  Variable(X: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class FairCurve_Newton extends math_NewtonMinimum {
  constructor(theFunction: math_MultipleVarFunctionWithHessian, theSpatialTolerance: Quantity_AbsorbedDose, theCriteriumTolerance: Quantity_AbsorbedDose, theNbIterations: Graphic3d_ZLayerId, theConvexity: Quantity_AbsorbedDose, theWithSingularity: Standard_Boolean)
  IsConverged(): Standard_Boolean;
  delete(): void;
}

export declare class FairCurve_DistributionOfTension extends FairCurve_DistributionOfEnergy {
  constructor(BSplOrder: Graphic3d_ZLayerId, FlatKnots: Handle_TColStd_HArray1OfReal, Poles: Handle_TColgp_HArray1OfPnt2d, DerivativeOrder: Graphic3d_ZLayerId, LengthSliding: Quantity_AbsorbedDose, Law: FairCurve_BattenLaw, NbValAux: Graphic3d_ZLayerId, Uniform: Standard_Boolean)
  SetLengthSliding(LengthSliding: Quantity_AbsorbedDose): void;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class FairCurve_DistributionOfSagging extends FairCurve_DistributionOfEnergy {
  constructor(BSplOrder: Graphic3d_ZLayerId, FlatKnots: Handle_TColStd_HArray1OfReal, Poles: Handle_TColgp_HArray1OfPnt2d, DerivativeOrder: Graphic3d_ZLayerId, Law: FairCurve_BattenLaw, NbValAux: Graphic3d_ZLayerId)
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class FairCurve_DistributionOfEnergy extends math_FunctionSet {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  SetDerivativeOrder(DerivativeOrder: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class FairCurve_MinimalVariation extends FairCurve_Batten {
  constructor(P1: gp_Pnt2d, P2: gp_Pnt2d, Heigth: Quantity_AbsorbedDose, Slope: Quantity_AbsorbedDose, PhysicalRatio: Quantity_AbsorbedDose)
  SetCurvature1(Curvature: Quantity_AbsorbedDose): void;
  SetCurvature2(Curvature: Quantity_AbsorbedDose): void;
  SetPhysicalRatio(Ratio: Quantity_AbsorbedDose): void;
  Compute_1(ACode: FairCurve_AnalysisCode, NbIterations: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  GetCurvature1(): Quantity_AbsorbedDose;
  GetCurvature2(): Quantity_AbsorbedDose;
  GetPhysicalRatio(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class FairCurve_DistributionOfJerk extends FairCurve_DistributionOfEnergy {
  constructor(BSplOrder: Graphic3d_ZLayerId, FlatKnots: Handle_TColStd_HArray1OfReal, Poles: Handle_TColgp_HArray1OfPnt2d, DerivativeOrder: Graphic3d_ZLayerId, Law: FairCurve_BattenLaw, NbValAux: Graphic3d_ZLayerId)
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class FairCurve_Energy extends math_MultipleVarFunctionWithHessian {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, E: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values_1(X: math_Vector, E: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  Values_2(X: math_Vector, E: Quantity_AbsorbedDose, G: math_Vector, H: math_Matrix): Standard_Boolean;
  Variable(X: math_Vector): Standard_Boolean;
  Poles(): Handle_TColgp_HArray1OfPnt2d;
  delete(): void;
}

export declare class FairCurve_Batten {
  constructor(P1: gp_Pnt2d, P2: gp_Pnt2d, Height: Quantity_AbsorbedDose, Slope: Quantity_AbsorbedDose)
  SetFreeSliding(FreeSliding: Standard_Boolean): void;
  SetConstraintOrder1(ConstraintOrder: Graphic3d_ZLayerId): void;
  SetConstraintOrder2(ConstraintOrder: Graphic3d_ZLayerId): void;
  SetP1(P1: gp_Pnt2d): void;
  SetP2(P2: gp_Pnt2d): void;
  SetAngle1(Angle1: Quantity_AbsorbedDose): void;
  SetAngle2(Angle2: Quantity_AbsorbedDose): void;
  SetHeight(Height: Quantity_AbsorbedDose): void;
  SetSlope(Slope: Quantity_AbsorbedDose): void;
  SetSlidingFactor(SlidingFactor: Quantity_AbsorbedDose): void;
  Compute_1(Code: FairCurve_AnalysisCode, NbIterations: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  SlidingOfReference_1(): Quantity_AbsorbedDose;
  GetFreeSliding(): Standard_Boolean;
  GetConstraintOrder1(): Graphic3d_ZLayerId;
  GetConstraintOrder2(): Graphic3d_ZLayerId;
  GetP1(): gp_Pnt2d;
  GetP2(): gp_Pnt2d;
  GetAngle1(): Quantity_AbsorbedDose;
  GetAngle2(): Quantity_AbsorbedDose;
  GetHeight(): Quantity_AbsorbedDose;
  GetSlope(): Quantity_AbsorbedDose;
  GetSlidingFactor(): Quantity_AbsorbedDose;
  Curve(): Handle_Geom2d_BSplineCurve;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class AIS_PointCloudOwner extends SelectMgr_EntityOwner {
  constructor(theOrigin: Handle_AIS_PointCloud)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SelectedPoints(): Handle_TColStd_HPackedMapOfInteger;
  DetectedPoints(): Handle_TColStd_HPackedMapOfInteger;
  IsForcedHilight(): Standard_Boolean;
  HilightWithColor(thePrsMgr: any, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId): void;
  Unhilight(thePrsMgr: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  Clear(thePrsMgr: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_AIS_PointCloud {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_PointCloud): void;
  get(): AIS_PointCloud;
  delete(): void;
}

  export declare class Handle_AIS_PointCloud_1 extends Handle_AIS_PointCloud {
    constructor();
  }

  export declare class Handle_AIS_PointCloud_2 extends Handle_AIS_PointCloud {
    constructor(thePtr: AIS_PointCloud);
  }

  export declare class Handle_AIS_PointCloud_3 extends Handle_AIS_PointCloud {
    constructor(theHandle: Handle_AIS_PointCloud);
  }

  export declare class Handle_AIS_PointCloud_4 extends Handle_AIS_PointCloud {
    constructor(theHandle: Handle_AIS_PointCloud);
  }

export declare class AIS_PointCloud extends AIS_InteractiveObject {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetPoints_1(thePoints: Handle_Graphic3d_ArrayOfPoints): void;
  SetPoints_2(theCoords: Handle_TColgp_HArray1OfPnt, theColors: Handle_Quantity_HArray1OfColor, theNormals: Handle_TColgp_HArray1OfDir): void;
  GetPoints(): Handle_Graphic3d_ArrayOfPoints;
  GetBoundingBox(): Bnd_Box;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  SetMaterial(theMat: Graphic3d_MaterialAspect): void;
  UnsetMaterial(): void;
  delete(): void;
}

export declare class Handle_AIS_Triangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Triangulation): void;
  get(): AIS_Triangulation;
  delete(): void;
}

  export declare class Handle_AIS_Triangulation_1 extends Handle_AIS_Triangulation {
    constructor();
  }

  export declare class Handle_AIS_Triangulation_2 extends Handle_AIS_Triangulation {
    constructor(thePtr: AIS_Triangulation);
  }

  export declare class Handle_AIS_Triangulation_3 extends Handle_AIS_Triangulation {
    constructor(theHandle: Handle_AIS_Triangulation);
  }

  export declare class Handle_AIS_Triangulation_4 extends Handle_AIS_Triangulation {
    constructor(theHandle: Handle_AIS_Triangulation);
  }

export declare class AIS_Triangulation extends AIS_InteractiveObject {
  constructor(aTriangulation: Handle_Poly_Triangulation)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColors(aColor: Handle_TColStd_HArray1OfInteger): void;
  GetColors(): Handle_TColStd_HArray1OfInteger;
  HasVertexColors(): Standard_Boolean;
  SetTriangulation(aTriangulation: Handle_Poly_Triangulation): void;
  GetTriangulation(): Handle_Poly_Triangulation;
  SetTransparency(aValue: Quantity_AbsorbedDose): void;
  UnsetTransparency(): void;
  delete(): void;
}

export declare class Handle_AIS_Shape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Shape): void;
  get(): AIS_Shape;
  delete(): void;
}

  export declare class Handle_AIS_Shape_1 extends Handle_AIS_Shape {
    constructor();
  }

  export declare class Handle_AIS_Shape_2 extends Handle_AIS_Shape {
    constructor(thePtr: AIS_Shape);
  }

  export declare class Handle_AIS_Shape_3 extends Handle_AIS_Shape {
    constructor(theHandle: Handle_AIS_Shape);
  }

  export declare class Handle_AIS_Shape_4 extends Handle_AIS_Shape {
    constructor(theHandle: Handle_AIS_Shape);
  }

export declare class AIS_Shape extends AIS_InteractiveObject {
  constructor(shap: TopoDS_Shape)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  AcceptShapeDecomposition(): Standard_Boolean;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Shape(): TopoDS_Shape;
  SetShape(theShape: TopoDS_Shape): void;
  Set(theShape: TopoDS_Shape): void;
  SetOwnDeviationCoefficient_1(): Standard_Boolean;
  SetOwnDeviationAngle_1(): Standard_Boolean;
  SetOwnDeviationCoefficient_2(aCoefficient: Quantity_AbsorbedDose): void;
  SetAngleAndDeviation(anAngle: Quantity_AbsorbedDose): void;
  UserAngle(): Quantity_AbsorbedDose;
  SetOwnDeviationAngle_2(anAngle: Quantity_AbsorbedDose): void;
  OwnDeviationCoefficient(aCoefficient: Quantity_AbsorbedDose, aPreviousCoefficient: Quantity_AbsorbedDose): Standard_Boolean;
  OwnDeviationAngle(anAngle: Quantity_AbsorbedDose, aPreviousAngle: Quantity_AbsorbedDose): Standard_Boolean;
  SetTypeOfHLR(theTypeOfHLR: Prs3d_TypeOfHLR): void;
  TypeOfHLR(): Prs3d_TypeOfHLR;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  SetWidth(aValue: Quantity_AbsorbedDose): void;
  UnsetWidth(): void;
  SetMaterial(aName: Graphic3d_MaterialAspect): void;
  UnsetMaterial(): void;
  SetTransparency(aValue: Quantity_AbsorbedDose): void;
  UnsetTransparency(): void;
  BoundingBox_1(): Bnd_Box;
  BoundingBox_2(theBndBox: Bnd_Box): void;
  Color(aColor: Quantity_Color): void;
  Material(): Graphic3d_NameOfMaterial;
  Transparency(): Quantity_AbsorbedDose;
  static SelectionType(theSelMode: Graphic3d_ZLayerId): TopAbs_ShapeEnum;
  static SelectionMode(theShapeType: TopAbs_ShapeEnum): Graphic3d_ZLayerId;
  TextureRepeatUV(): gp_Pnt2d;
  SetTextureRepeatUV(theRepeatUV: gp_Pnt2d): void;
  TextureOriginUV(): gp_Pnt2d;
  SetTextureOriginUV(theOriginUV: gp_Pnt2d): void;
  TextureScaleUV(): gp_Pnt2d;
  SetTextureScaleUV(theScaleUV: gp_Pnt2d): void;
  static computeHlrPresentation(theProjector: Handle_Graphic3d_Camera, thePrs: any, theShape: TopoDS_Shape, theDrawer: Handle_Prs3d_Drawer): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_AIS_BadEdgeFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_BadEdgeFilter): void;
  get(): AIS_BadEdgeFilter;
  delete(): void;
}

  export declare class Handle_AIS_BadEdgeFilter_1 extends Handle_AIS_BadEdgeFilter {
    constructor();
  }

  export declare class Handle_AIS_BadEdgeFilter_2 extends Handle_AIS_BadEdgeFilter {
    constructor(thePtr: AIS_BadEdgeFilter);
  }

  export declare class Handle_AIS_BadEdgeFilter_3 extends Handle_AIS_BadEdgeFilter {
    constructor(theHandle: Handle_AIS_BadEdgeFilter);
  }

  export declare class Handle_AIS_BadEdgeFilter_4 extends Handle_AIS_BadEdgeFilter {
    constructor(theHandle: Handle_AIS_BadEdgeFilter);
  }

export declare class AIS_BadEdgeFilter extends SelectMgr_Filter {
  constructor()
  ActsOn(aType: TopAbs_ShapeEnum): Standard_Boolean;
  IsOk(EO: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  SetContour(Index: Graphic3d_ZLayerId): void;
  AddEdge(anEdge: TopoDS_Edge, Index: Graphic3d_ZLayerId): void;
  RemoveEdges(Index: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_AIS_AttributeFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_AttributeFilter): void;
  get(): AIS_AttributeFilter;
  delete(): void;
}

  export declare class Handle_AIS_AttributeFilter_1 extends Handle_AIS_AttributeFilter {
    constructor();
  }

  export declare class Handle_AIS_AttributeFilter_2 extends Handle_AIS_AttributeFilter {
    constructor(thePtr: AIS_AttributeFilter);
  }

  export declare class Handle_AIS_AttributeFilter_3 extends Handle_AIS_AttributeFilter {
    constructor(theHandle: Handle_AIS_AttributeFilter);
  }

  export declare class Handle_AIS_AttributeFilter_4 extends Handle_AIS_AttributeFilter {
    constructor(theHandle: Handle_AIS_AttributeFilter);
  }

export declare class AIS_AttributeFilter extends SelectMgr_Filter {
  HasColor(): Standard_Boolean;
  HasWidth(): Standard_Boolean;
  SetColor(aCol: Quantity_NameOfColor): void;
  SetWidth(aWidth: Quantity_AbsorbedDose): void;
  UnsetColor(): void;
  UnsetWidth(): void;
  IsOk(anObj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class AIS_AttributeFilter_1 extends AIS_AttributeFilter {
    constructor();
  }

  export declare class AIS_AttributeFilter_2 extends AIS_AttributeFilter {
    constructor(aCol: Quantity_NameOfColor);
  }

  export declare class AIS_AttributeFilter_3 extends AIS_AttributeFilter {
    constructor(aWidth: Quantity_AbsorbedDose);
  }

export declare class Handle_AIS_Plane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Plane): void;
  get(): AIS_Plane;
  delete(): void;
}

  export declare class Handle_AIS_Plane_1 extends Handle_AIS_Plane {
    constructor();
  }

  export declare class Handle_AIS_Plane_2 extends Handle_AIS_Plane {
    constructor(thePtr: AIS_Plane);
  }

  export declare class Handle_AIS_Plane_3 extends Handle_AIS_Plane {
    constructor(theHandle: Handle_AIS_Plane);
  }

  export declare class Handle_AIS_Plane_4 extends Handle_AIS_Plane {
    constructor(theHandle: Handle_AIS_Plane);
  }

export declare class AIS_Plane extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetSize_1(aValue: Quantity_AbsorbedDose): void;
  SetSize_2(Xval: Quantity_AbsorbedDose, YVal: Quantity_AbsorbedDose): void;
  UnsetSize(): void;
  Size(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): Standard_Boolean;
  HasOwnSize(): Standard_Boolean;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  Component(): Handle_Geom_Plane;
  SetComponent(aComponent: Handle_Geom_Plane): void;
  PlaneAttributes(aComponent: Handle_Geom_Plane, aCenter: gp_Pnt, aPmin: gp_Pnt, aPmax: gp_Pnt): Standard_Boolean;
  SetPlaneAttributes(aComponent: Handle_Geom_Plane, aCenter: gp_Pnt, aPmin: gp_Pnt, aPmax: gp_Pnt): void;
  Center(): gp_Pnt;
  SetCenter(theCenter: gp_Pnt): void;
  SetAxis2Placement(aComponent: Handle_Geom_Axis2Placement, aPlaneType: AIS_TypeOfPlane): void;
  Axis2Placement(): Handle_Geom_Axis2Placement;
  TypeOfPlane(): AIS_TypeOfPlane;
  IsXYZPlane(): Standard_Boolean;
  CurrentMode(): Standard_Boolean;
  SetCurrentMode(theCurrentMode: Standard_Boolean): void;
  AcceptDisplayMode(aMode: Graphic3d_ZLayerId): Standard_Boolean;
  SetContext(aCtx: Handle_AIS_InteractiveContext): void;
  TypeOfSensitivity(): Select3D_TypeOfSensitivity;
  SetTypeOfSensitivity(theTypeOfSensitivity: Select3D_TypeOfSensitivity): void;
  ComputeSelection(theSelection: Handle_SelectMgr_Selection, theMode: Graphic3d_ZLayerId): void;
  SetColor(aColor: Quantity_Color): void;
  UnsetColor(): void;
  delete(): void;
}

  export declare class AIS_Plane_1 extends AIS_Plane {
    constructor(aComponent: Handle_Geom_Plane, aCurrentMode: Standard_Boolean);
  }

  export declare class AIS_Plane_2 extends AIS_Plane {
    constructor(aComponent: Handle_Geom_Plane, aCenter: gp_Pnt, aCurrentMode: Standard_Boolean);
  }

  export declare class AIS_Plane_3 extends AIS_Plane {
    constructor(aComponent: Handle_Geom_Plane, aCenter: gp_Pnt, aPmin: gp_Pnt, aPmax: gp_Pnt, aCurrentMode: Standard_Boolean);
  }

  export declare class AIS_Plane_4 extends AIS_Plane {
    constructor(aComponent: Handle_Geom_Axis2Placement, aPlaneType: AIS_TypeOfPlane, aCurrentMode: Standard_Boolean);
  }

export declare type AIS_TypeOfAxis = {
  AIS_TOAX_Unknown: {};
  AIS_TOAX_XAxis: {};
  AIS_TOAX_YAxis: {};
  AIS_TOAX_ZAxis: {};
}

export declare class AIS_Line extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  Line(): Handle_Geom_Line;
  Points(thePStart: Handle_Geom_Point, thePEnd: Handle_Geom_Point): void;
  SetLine(theLine: Handle_Geom_Line): void;
  SetPoints(thePStart: Handle_Geom_Point, thePEnd: Handle_Geom_Point): void;
  SetColor(aColor: Quantity_Color): void;
  SetWidth(aValue: Quantity_AbsorbedDose): void;
  UnsetColor(): void;
  UnsetWidth(): void;
  delete(): void;
}

  export declare class AIS_Line_1 extends AIS_Line {
    constructor(aLine: Handle_Geom_Line);
  }

  export declare class AIS_Line_2 extends AIS_Line {
    constructor(aStartPoint: Handle_Geom_Point, aEndPoint: Handle_Geom_Point);
  }

export declare class Handle_AIS_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Line): void;
  get(): AIS_Line;
  delete(): void;
}

  export declare class Handle_AIS_Line_1 extends Handle_AIS_Line {
    constructor();
  }

  export declare class Handle_AIS_Line_2 extends Handle_AIS_Line {
    constructor(thePtr: AIS_Line);
  }

  export declare class Handle_AIS_Line_3 extends Handle_AIS_Line {
    constructor(theHandle: Handle_AIS_Line);
  }

  export declare class Handle_AIS_Line_4 extends Handle_AIS_Line {
    constructor(theHandle: Handle_AIS_Line);
  }

export declare class Handle_AIS_ManipulatorOwner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ManipulatorOwner): void;
  get(): AIS_ManipulatorOwner;
  delete(): void;
}

  export declare class Handle_AIS_ManipulatorOwner_1 extends Handle_AIS_ManipulatorOwner {
    constructor();
  }

  export declare class Handle_AIS_ManipulatorOwner_2 extends Handle_AIS_ManipulatorOwner {
    constructor(thePtr: AIS_ManipulatorOwner);
  }

  export declare class Handle_AIS_ManipulatorOwner_3 extends Handle_AIS_ManipulatorOwner {
    constructor(theHandle: Handle_AIS_ManipulatorOwner);
  }

  export declare class Handle_AIS_ManipulatorOwner_4 extends Handle_AIS_ManipulatorOwner {
    constructor(theHandle: Handle_AIS_ManipulatorOwner);
  }

export declare class AIS_ManipulatorOwner extends SelectMgr_EntityOwner {
  constructor(theSelObject: Handle_SelectMgr_SelectableObject, theIndex: Graphic3d_ZLayerId, theMode: AIS_ManipulatorMode, thePriority: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  HilightWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId): void;
  IsHilighted(thePM: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Unhilight(thePM: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  Mode(): AIS_ManipulatorMode;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_AIS_ConnectedInteractive {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ConnectedInteractive): void;
  get(): AIS_ConnectedInteractive;
  delete(): void;
}

  export declare class Handle_AIS_ConnectedInteractive_1 extends Handle_AIS_ConnectedInteractive {
    constructor();
  }

  export declare class Handle_AIS_ConnectedInteractive_2 extends Handle_AIS_ConnectedInteractive {
    constructor(thePtr: AIS_ConnectedInteractive);
  }

  export declare class Handle_AIS_ConnectedInteractive_3 extends Handle_AIS_ConnectedInteractive {
    constructor(theHandle: Handle_AIS_ConnectedInteractive);
  }

  export declare class Handle_AIS_ConnectedInteractive_4 extends Handle_AIS_ConnectedInteractive {
    constructor(theHandle: Handle_AIS_ConnectedInteractive);
  }

export declare class AIS_ConnectedInteractive extends AIS_InteractiveObject {
  constructor(aTypeOfPresentation3d: PrsMgr_TypeOfPresentation3d)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Type(): AIS_KindOfInteractive;
  Signature(): Graphic3d_ZLayerId;
  Connect_1(theAnotherObj: Handle_AIS_InteractiveObject): void;
  Connect_2(theAnotherObj: Handle_AIS_InteractiveObject, theLocation: gp_Trsf): void;
  Connect_3(theAnotherObj: Handle_AIS_InteractiveObject, theLocation: Handle_TopLoc_Datum3D): void;
  HasConnection(): Standard_Boolean;
  ConnectedTo(): Handle_AIS_InteractiveObject;
  Disconnect(): void;
  AcceptShapeDecomposition(): Standard_Boolean;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class Handle_AIS_Selection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Selection): void;
  get(): AIS_Selection;
  delete(): void;
}

  export declare class Handle_AIS_Selection_1 extends Handle_AIS_Selection {
    constructor();
  }

  export declare class Handle_AIS_Selection_2 extends Handle_AIS_Selection {
    constructor(thePtr: AIS_Selection);
  }

  export declare class Handle_AIS_Selection_3 extends Handle_AIS_Selection {
    constructor(theHandle: Handle_AIS_Selection);
  }

  export declare class Handle_AIS_Selection_4 extends Handle_AIS_Selection {
    constructor(theHandle: Handle_AIS_Selection);
  }

export declare class AIS_Selection extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Clear(): void;
  Select(theObject: Handle_SelectMgr_EntityOwner): AIS_SelectStatus;
  AddSelect(theObject: Handle_SelectMgr_EntityOwner): AIS_SelectStatus;
  ClearAndSelect(theObject: Handle_SelectMgr_EntityOwner): void;
  IsSelected(theObject: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  Objects(): AIS_NListOfEntityOwner;
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  Init(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_SelectMgr_EntityOwner;
  delete(): void;
}

export declare class AIS_InteractiveContext extends Standard_Transient {
  constructor(MainViewer: Handle_V3d_Viewer)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  DisplayStatus(anIobj: Handle_AIS_InteractiveObject): AIS_DisplayStatus;
  Status(anObj: Handle_AIS_InteractiveObject, astatus: TCollection_ExtendedString): void;
  IsDisplayed_1(anIobj: Handle_AIS_InteractiveObject): Standard_Boolean;
  IsDisplayed_2(aniobj: Handle_AIS_InteractiveObject, aMode: Graphic3d_ZLayerId): Standard_Boolean;
  SetAutoActivateSelection(theIsAuto: Standard_Boolean): void;
  GetAutoActivateSelection(): Standard_Boolean;
  Display_1(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  Display_2(theIObj: Handle_AIS_InteractiveObject, theDispMode: Graphic3d_ZLayerId, theSelectionMode: Graphic3d_ZLayerId, theToUpdateViewer: Standard_Boolean, theDispStatus: AIS_DisplayStatus): void;
  Load_1(theObj: Handle_AIS_InteractiveObject, theSelectionMode: Graphic3d_ZLayerId): void;
  Display_3(theIObj: Handle_AIS_InteractiveObject, theDispMode: Graphic3d_ZLayerId, theSelectionMode: Graphic3d_ZLayerId, theToUpdateViewer: Standard_Boolean, theToAllowDecomposition: Standard_Boolean, theDispStatus: AIS_DisplayStatus): void;
  Load_2(theObj: Handle_AIS_InteractiveObject, theSelectionMode: Graphic3d_ZLayerId, a2: Standard_Boolean): void;
  Erase(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  EraseAll(theToUpdateViewer: Standard_Boolean): void;
  DisplayAll(theToUpdateViewer: Standard_Boolean): void;
  EraseSelected(theToUpdateViewer: Standard_Boolean): void;
  DisplaySelected(theToUpdateViewer: Standard_Boolean): void;
  ClearPrs(theIObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId, theToUpdateViewer: Standard_Boolean): void;
  Remove(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  RemoveAll(theToUpdateViewer: Standard_Boolean): void;
  Redisplay_1(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean, theAllModes: Standard_Boolean): void;
  Redisplay_2(theTypeOfObject: AIS_KindOfInteractive, theSignature: Graphic3d_ZLayerId, theToUpdateViewer: Standard_Boolean): void;
  RecomputePrsOnly(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean, theAllModes: Standard_Boolean): void;
  RecomputeSelectionOnly(anIObj: Handle_AIS_InteractiveObject): void;
  Update(theIObj: Handle_AIS_InteractiveObject, theUpdateViewer: Standard_Boolean): void;
  HighlightStyle_1(theStyleType: Prs3d_TypeOfHighlight): Handle_Prs3d_Drawer;
  SetHighlightStyle_1(theStyleType: Prs3d_TypeOfHighlight, theStyle: Handle_Prs3d_Drawer): void;
  HighlightStyle_2(): Handle_Prs3d_Drawer;
  SetHighlightStyle_2(theStyle: Handle_Prs3d_Drawer): void;
  SelectionStyle(): Handle_Prs3d_Drawer;
  SetSelectionStyle(theStyle: Handle_Prs3d_Drawer): void;
  HighlightStyle_3(theObj: Handle_AIS_InteractiveObject, theStyle: Handle_Prs3d_Drawer): Standard_Boolean;
  HighlightStyle_4(theOwner: Handle_SelectMgr_EntityOwner, theStyle: Handle_Prs3d_Drawer): Standard_Boolean;
  IsHilighted_1(theObj: Handle_AIS_InteractiveObject): Standard_Boolean;
  IsHilighted_2(theOwner: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  Hilight(theObj: Handle_AIS_InteractiveObject, theIsToUpdateViewer: Standard_Boolean): void;
  HilightWithColor(theObj: Handle_AIS_InteractiveObject, theStyle: Handle_Prs3d_Drawer, theToUpdateViewer: Standard_Boolean): void;
  Unhilight(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  DisplayPriority(theIObj: Handle_AIS_InteractiveObject): Graphic3d_ZLayerId;
  SetDisplayPriority(theIObj: Handle_AIS_InteractiveObject, thePriority: Graphic3d_ZLayerId): void;
  GetZLayer(theIObj: Handle_AIS_InteractiveObject): Graphic3d_ZLayerId;
  SetZLayer(theIObj: Handle_AIS_InteractiveObject, theLayerId: Graphic3d_ZLayerId): void;
  SetViewAffinity(theIObj: Handle_AIS_InteractiveObject, theView: Handle_V3d_View, theIsVisible: Standard_Boolean): void;
  DisplayMode(): Graphic3d_ZLayerId;
  SetDisplayMode_1(theMode: Graphic3d_ZLayerId, theToUpdateViewer: Standard_Boolean): void;
  SetDisplayMode_2(theIObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId, theToUpdateViewer: Standard_Boolean): void;
  UnsetDisplayMode(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SetLocation(theObject: Handle_AIS_InteractiveObject, theLocation: TopLoc_Location): void;
  ResetLocation(theObject: Handle_AIS_InteractiveObject): void;
  HasLocation(theObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  Location(theObject: Handle_AIS_InteractiveObject): TopLoc_Location;
  SetTransformPersistence_1(theObject: Handle_AIS_InteractiveObject, theTrsfPers: Handle_Graphic3d_TransformPers): void;
  SetTransformPersistence_2(theObj: Handle_AIS_InteractiveObject, theFlag: Graphic3d_TransModeFlags, thePoint: gp_Pnt): void;
  SetPixelTolerance(thePrecision: Graphic3d_ZLayerId): void;
  PixelTolerance(): Graphic3d_ZLayerId;
  SetSelectionSensitivity(theObject: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId, theNewSensitivity: Graphic3d_ZLayerId): void;
  LastActiveView(): Handle_V3d_View;
  MoveTo(theXPix: Graphic3d_ZLayerId, theYPix: Graphic3d_ZLayerId, theView: Handle_V3d_View, theToRedrawOnUpdate: Standard_Boolean): AIS_StatusOfDetection;
  ClearDetected(theToRedrawImmediate: Standard_Boolean): Standard_Boolean;
  HasDetected(): Standard_Boolean;
  DetectedOwner(): Handle_SelectMgr_EntityOwner;
  DetectedInteractive(): Handle_AIS_InteractiveObject;
  HasDetectedShape(): Standard_Boolean;
  DetectedShape(): TopoDS_Shape;
  HasNextDetected(): Standard_Boolean;
  HilightNextDetected(theView: Handle_V3d_View, theToRedrawImmediate: Standard_Boolean): Graphic3d_ZLayerId;
  HilightPreviousDetected(theView: Handle_V3d_View, theToRedrawImmediate: Standard_Boolean): Graphic3d_ZLayerId;
  InitDetected(): void;
  MoreDetected(): Standard_Boolean;
  NextDetected(): void;
  DetectedCurrentOwner(): Handle_SelectMgr_EntityOwner;
  SetSelectedAspect(theAspect: Handle_Prs3d_BasicAspect, theToUpdateViewer: Standard_Boolean): void;
  AddSelect_1(theObject: Handle_SelectMgr_EntityOwner): AIS_StatusOfPick;
  AddSelect_2(theObject: Handle_AIS_InteractiveObject): AIS_StatusOfPick;
  Select_1(theXPMin: Graphic3d_ZLayerId, theYPMin: Graphic3d_ZLayerId, theXPMax: Graphic3d_ZLayerId, theYPMax: Graphic3d_ZLayerId, theView: Handle_V3d_View, theToUpdateViewer: Standard_Boolean): AIS_StatusOfPick;
  Select_2(thePolyline: TColgp_Array1OfPnt2d, theView: Handle_V3d_View, theToUpdateViewer: Standard_Boolean): AIS_StatusOfPick;
  Select_3(theToUpdateViewer: Standard_Boolean): AIS_StatusOfPick;
  ShiftSelect_1(theToUpdateViewer: Standard_Boolean): AIS_StatusOfPick;
  ShiftSelect_2(thePolyline: TColgp_Array1OfPnt2d, theView: Handle_V3d_View, theToUpdateViewer: Standard_Boolean): AIS_StatusOfPick;
  ShiftSelect_3(theXPMin: Graphic3d_ZLayerId, theYPMin: Graphic3d_ZLayerId, theXPMax: Graphic3d_ZLayerId, theYPMax: Graphic3d_ZLayerId, theView: Handle_V3d_View, theToUpdateViewer: Standard_Boolean): AIS_StatusOfPick;
  BoundingBoxOfSelection(): Bnd_Box;
  FitSelected_1(theView: Handle_V3d_View, theMargin: Quantity_AbsorbedDose, theToUpdate: Standard_Boolean): void;
  FitSelected_2(theView: Handle_V3d_View): void;
  ToHilightSelected(): Standard_Boolean;
  SetToHilightSelected(toHilight: Standard_Boolean): void;
  AutomaticHilight(): Standard_Boolean;
  SetAutomaticHilight(theStatus: Standard_Boolean): void;
  SetSelected_1(theOwners: Handle_SelectMgr_EntityOwner, theToUpdateViewer: Standard_Boolean): void;
  SetSelected_2(theObject: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  AddOrRemoveSelected_1(theObject: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SetSelectedState(theOwner: Handle_SelectMgr_EntityOwner, theIsSelected: Standard_Boolean): Standard_Boolean;
  HilightSelected(theToUpdateViewer: Standard_Boolean): void;
  UnhilightSelected(theToUpdateViewer: Standard_Boolean): void;
  UpdateSelected(theToUpdateViewer: Standard_Boolean): void;
  ClearSelected(theToUpdateViewer: Standard_Boolean): void;
  AddOrRemoveSelected_2(theOwner: Handle_SelectMgr_EntityOwner, theToUpdateViewer: Standard_Boolean): void;
  IsSelected_1(theOwner: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  IsSelected_2(theObj: Handle_AIS_InteractiveObject): Standard_Boolean;
  FirstSelectedObject(): Handle_AIS_InteractiveObject;
  NbSelected(): Graphic3d_ZLayerId;
  InitSelected(): void;
  MoreSelected(): Standard_Boolean;
  NextSelected(): void;
  SelectedOwner(): Handle_SelectMgr_EntityOwner;
  SelectedInteractive(): Handle_AIS_InteractiveObject;
  HasSelectedShape(): Standard_Boolean;
  SelectedShape(): TopoDS_Shape;
  HasApplicative(): Standard_Boolean;
  Applicative(): Handle_Standard_Transient;
  BeginImmediateDraw(): Standard_Boolean;
  ImmediateAdd(theObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  EndImmediateDraw_1(theView: Handle_V3d_View): Standard_Boolean;
  EndImmediateDraw_2(): Standard_Boolean;
  IsImmediateModeOn(): Standard_Boolean;
  RedrawImmediate(theViewer: Handle_V3d_Viewer): void;
  SetSelectionModeActive(theObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId, theToActivate: Standard_Boolean, theConcurrency: AIS_SelectionModesConcurrency, theIsForce: Standard_Boolean): void;
  Activate_1(theObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId, theIsForce: Standard_Boolean): void;
  Activate_2(theMode: Graphic3d_ZLayerId, theIsForce: Standard_Boolean): void;
  Deactivate_1(theObj: Handle_AIS_InteractiveObject): void;
  Deactivate_2(theObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId): void;
  Deactivate_3(theMode: Graphic3d_ZLayerId): void;
  Deactivate_4(): void;
  ActivatedModes(anIobj: Handle_AIS_InteractiveObject, theList: TColStd_ListOfInteger): void;
  EntityOwners(theOwners: any, theIObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId): void;
  FilterType(): SelectMgr_FilterType;
  SetFilterType(theFilterType: SelectMgr_FilterType): void;
  Filters(): SelectMgr_ListOfFilter;
  AddFilter(theFilter: Handle_SelectMgr_Filter): void;
  RemoveFilter(theFilter: Handle_SelectMgr_Filter): void;
  RemoveFilters(): void;
  PickingStrategy(): SelectMgr_PickingStrategy;
  SetPickingStrategy(theStrategy: SelectMgr_PickingStrategy): void;
  DefaultDrawer(): Handle_Prs3d_Drawer;
  CurrentViewer(): Handle_V3d_Viewer;
  SelectionManager(): Handle_SelectMgr_SelectionManager;
  MainPrsMgr(): any;
  MainSelector(): any;
  UpdateCurrentViewer(): void;
  DisplayedObjects_1(aListOfIO: AIS_ListOfInteractive): void;
  DisplayedObjects_2(theWhichKind: AIS_KindOfInteractive, theWhichSignature: Graphic3d_ZLayerId, theListOfIO: AIS_ListOfInteractive): void;
  ErasedObjects_1(theListOfIO: AIS_ListOfInteractive): void;
  ErasedObjects_2(theWhichKind: AIS_KindOfInteractive, theWhichSignature: Graphic3d_ZLayerId, theListOfIO: AIS_ListOfInteractive): void;
  ObjectsByDisplayStatus_1(theStatus: AIS_DisplayStatus, theListOfIO: AIS_ListOfInteractive): void;
  ObjectsByDisplayStatus_2(WhichKind: AIS_KindOfInteractive, WhichSignature: Graphic3d_ZLayerId, theStatus: AIS_DisplayStatus, theListOfIO: AIS_ListOfInteractive): void;
  ObjectsInside(aListOfIO: AIS_ListOfInteractive, WhichKind: AIS_KindOfInteractive, WhichSignature: Graphic3d_ZLayerId): void;
  RebuildSelectionStructs(): void;
  Disconnect(theAssembly: Handle_AIS_InteractiveObject, theObjToDisconnect: Handle_AIS_InteractiveObject): void;
  ObjectsForView(theListOfIO: AIS_ListOfInteractive, theView: Handle_V3d_View, theIsVisibleInView: Standard_Boolean, theStatus: AIS_DisplayStatus): void;
  PurgeDisplay(): Graphic3d_ZLayerId;
  GravityPoint(theView: Handle_V3d_View): gp_Pnt;
  DisplayActiveSensitive_1(aView: Handle_V3d_View): void;
  ClearActiveSensitive(aView: Handle_V3d_View): void;
  DisplayActiveSensitive_2(anObject: Handle_AIS_InteractiveObject, aView: Handle_V3d_View): void;
  SetLocalAttributes(theIObj: Handle_AIS_InteractiveObject, theDrawer: Handle_Prs3d_Drawer, theToUpdateViewer: Standard_Boolean): void;
  UnsetLocalAttributes(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SetCurrentFacingModel(aniobj: Handle_AIS_InteractiveObject, aModel: Aspect_TypeOfFacingModel): void;
  HasColor(aniobj: Handle_AIS_InteractiveObject): Standard_Boolean;
  Color(aniobj: Handle_AIS_InteractiveObject, acolor: Quantity_Color): void;
  SetColor(theIObj: Handle_AIS_InteractiveObject, theColor: Quantity_Color, theToUpdateViewer: Standard_Boolean): void;
  UnsetColor(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  Width(aniobj: Handle_AIS_InteractiveObject): Quantity_AbsorbedDose;
  SetWidth(theIObj: Handle_AIS_InteractiveObject, theValue: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  UnsetWidth(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SetMaterial(theIObj: Handle_AIS_InteractiveObject, theMaterial: Graphic3d_MaterialAspect, theToUpdateViewer: Standard_Boolean): void;
  UnsetMaterial(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SetTransparency(theIObj: Handle_AIS_InteractiveObject, theValue: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  UnsetTransparency(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SetPolygonOffsets(theIObj: Handle_AIS_InteractiveObject, theMode: Graphic3d_ZLayerId, theFactor: Standard_ShortReal, theUnits: Standard_ShortReal, theToUpdateViewer: Standard_Boolean): void;
  HasPolygonOffsets(anObj: Handle_AIS_InteractiveObject): Standard_Boolean;
  PolygonOffsets(anObj: Handle_AIS_InteractiveObject, aMode: Graphic3d_ZLayerId, aFactor: Standard_ShortReal, aUnits: Standard_ShortReal): void;
  SetTrihedronSize(theSize: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  TrihedronSize(): Quantity_AbsorbedDose;
  SetPlaneSize_1(theSizeX: Quantity_AbsorbedDose, theSizeY: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  SetPlaneSize_2(theSize: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  PlaneSize(XSize: Quantity_AbsorbedDose, YSize: Quantity_AbsorbedDose): Standard_Boolean;
  SetDeviationCoefficient_1(theIObj: Handle_AIS_InteractiveObject, theCoefficient: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  SetDeviationAngle_1(theIObj: Handle_AIS_InteractiveObject, theAngle: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  SetAngleAndDeviation(theIObj: Handle_AIS_InteractiveObject, theAngle: Quantity_AbsorbedDose, theToUpdateViewer: Standard_Boolean): void;
  SetDeviationCoefficient_2(theCoefficient: Quantity_AbsorbedDose): void;
  DeviationCoefficient(): Quantity_AbsorbedDose;
  SetDeviationAngle_2(anAngle: Quantity_AbsorbedDose): void;
  DeviationAngle(): Quantity_AbsorbedDose;
  HiddenLineAspect(): Handle_Prs3d_LineAspect;
  SetHiddenLineAspect(anAspect: Handle_Prs3d_LineAspect): void;
  DrawHiddenLine(): Standard_Boolean;
  EnableDrawHiddenLine(): void;
  DisableDrawHiddenLine(): void;
  SetIsoNumber(NbIsos: Graphic3d_ZLayerId, WhichIsos: AIS_TypeOfIso): void;
  IsoNumber(WhichIsos: AIS_TypeOfIso): Graphic3d_ZLayerId;
  IsoOnPlane_1(SwitchOn: Standard_Boolean): void;
  IsoOnPlane_2(): Standard_Boolean;
  IsoOnTriangulation_1(theIsEnabled: Standard_Boolean, theObject: Handle_AIS_InteractiveObject): void;
  IsoOnTriangulation_2(theToSwitchOn: Standard_Boolean): void;
  IsoOnTriangulation_3(): Standard_Boolean;
  SetCurrentObject(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  AddOrRemoveCurrentObject(theObj: Handle_AIS_InteractiveObject, theIsToUpdateViewer: Standard_Boolean): void;
  UpdateCurrent(): void;
  IsCurrent(theObject: Handle_AIS_InteractiveObject): Standard_Boolean;
  InitCurrent(): void;
  MoreCurrent(): Standard_Boolean;
  NextCurrent(): void;
  Current(): Handle_AIS_InteractiveObject;
  NbCurrents(): Graphic3d_ZLayerId;
  HilightCurrents(theToUpdateViewer: Standard_Boolean): void;
  UnhilightCurrents(theToUpdateViewer: Standard_Boolean): void;
  ClearCurrents(theToUpdateViewer: Standard_Boolean): void;
  DetectedCurrentShape(): TopoDS_Shape;
  DetectedCurrentObject(): Handle_AIS_InteractiveObject;
  SubIntensityColor(): Quantity_Color;
  SetSubIntensityColor(theColor: Quantity_Color): void;
  SubIntensityOn(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  SubIntensityOff(theIObj: Handle_AIS_InteractiveObject, theToUpdateViewer: Standard_Boolean): void;
  Selection(): Handle_AIS_Selection;
  SetSelection(theSelection: Handle_AIS_Selection): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_AIS_InteractiveContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_InteractiveContext): void;
  get(): AIS_InteractiveContext;
  delete(): void;
}

  export declare class Handle_AIS_InteractiveContext_1 extends Handle_AIS_InteractiveContext {
    constructor();
  }

  export declare class Handle_AIS_InteractiveContext_2 extends Handle_AIS_InteractiveContext {
    constructor(thePtr: AIS_InteractiveContext);
  }

  export declare class Handle_AIS_InteractiveContext_3 extends Handle_AIS_InteractiveContext {
    constructor(theHandle: Handle_AIS_InteractiveContext);
  }

  export declare class Handle_AIS_InteractiveContext_4 extends Handle_AIS_InteractiveContext {
    constructor(theHandle: Handle_AIS_InteractiveContext);
  }

export declare type AIS_StatusOfPick = {
  AIS_SOP_Error: {};
  AIS_SOP_NothingSelected: {};
  AIS_SOP_Removed: {};
  AIS_SOP_OneSelected: {};
  AIS_SOP_SeveralSelected: {};
}

export declare class AIS_ViewCubeOwner extends SelectMgr_EntityOwner {
  constructor(theObject: any, theOrient: V3d_TypeOfOrientation, thePriority: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsForcedHilight(): Standard_Boolean;
  MainOrientation(): V3d_TypeOfOrientation;
  HandleMouseClick(thePoint: OpenGl_Vec2i, theButton: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsDoubleClick: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

export declare class AIS_ViewCube extends AIS_InteractiveObject {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static IsBoxSide(theOrient: V3d_TypeOfOrientation): Standard_Boolean;
  static IsBoxEdge(theOrient: V3d_TypeOfOrientation): Standard_Boolean;
  static IsBoxCorner(theOrient: V3d_TypeOfOrientation): Standard_Boolean;
  ViewAnimation(): Handle_AIS_AnimationCamera;
  SetViewAnimation(theAnimation: Handle_AIS_AnimationCamera): void;
  ToAutoStartAnimation(): Standard_Boolean;
  SetAutoStartAnimation(theToEnable: Standard_Boolean): void;
  IsFixedAnimationLoop(): Standard_Boolean;
  SetFixedAnimationLoop(theToEnable: Standard_Boolean): void;
  ResetStyles(): void;
  Size(): Quantity_AbsorbedDose;
  SetSize(theValue: Quantity_AbsorbedDose, theToAdaptAnother: Standard_Boolean): void;
  BoxFacetExtension(): Quantity_AbsorbedDose;
  SetBoxFacetExtension(theValue: Quantity_AbsorbedDose): void;
  AxesPadding(): Quantity_AbsorbedDose;
  SetAxesPadding(theValue: Quantity_AbsorbedDose): void;
  BoxEdgeGap(): Quantity_AbsorbedDose;
  SetBoxEdgeGap(theValue: Quantity_AbsorbedDose): void;
  BoxEdgeMinSize(): Quantity_AbsorbedDose;
  SetBoxEdgeMinSize(theValue: Quantity_AbsorbedDose): void;
  BoxCornerMinSize(): Quantity_AbsorbedDose;
  SetBoxCornerMinSize(theValue: Quantity_AbsorbedDose): void;
  RoundRadius(): Quantity_AbsorbedDose;
  SetRoundRadius(theValue: Quantity_AbsorbedDose): void;
  AxesRadius(): Quantity_AbsorbedDose;
  SetAxesRadius(theRadius: Quantity_AbsorbedDose): void;
  AxesConeRadius(): Quantity_AbsorbedDose;
  SetAxesConeRadius(theRadius: Quantity_AbsorbedDose): void;
  AxesSphereRadius(): Quantity_AbsorbedDose;
  SetAxesSphereRadius(theRadius: Quantity_AbsorbedDose): void;
  ToDrawAxes(): Standard_Boolean;
  SetDrawAxes(theValue: Standard_Boolean): void;
  ToDrawEdges(): Standard_Boolean;
  SetDrawEdges(theValue: Standard_Boolean): void;
  ToDrawVertices(): Standard_Boolean;
  SetDrawVertices(theValue: Standard_Boolean): void;
  IsYup(): Standard_Boolean;
  SetYup(theIsYup: Standard_Boolean, theToUpdateLabels: Standard_Boolean): void;
  BoxSideStyle(): Handle_Prs3d_ShadingAspect;
  BoxEdgeStyle(): Handle_Prs3d_ShadingAspect;
  BoxCornerStyle(): Handle_Prs3d_ShadingAspect;
  BoxColor(): Quantity_Color;
  SetBoxColor(theColor: Quantity_Color): void;
  BoxTransparency(): Quantity_AbsorbedDose;
  SetBoxTransparency(theValue: Quantity_AbsorbedDose): void;
  InnerColor(): Quantity_Color;
  SetInnerColor(theColor: Quantity_Color): void;
  BoxSideLabel(theSide: V3d_TypeOfOrientation): XCAFDoc_PartId;
  SetBoxSideLabel(theSide: V3d_TypeOfOrientation, theLabel: XCAFDoc_PartId): void;
  TextColor(): Quantity_Color;
  SetTextColor(theColor: Quantity_Color): void;
  Font(): XCAFDoc_PartId;
  SetFont(theFont: XCAFDoc_PartId): void;
  FontHeight(): Quantity_AbsorbedDose;
  SetFontHeight(theValue: Quantity_AbsorbedDose): void;
  AxisLabel(theAxis: Prs3d_DatumParts): XCAFDoc_PartId;
  SetAxesLabels(theX: XCAFDoc_PartId, theY: XCAFDoc_PartId, theZ: XCAFDoc_PartId): void;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  SetTransparency(theValue: Quantity_AbsorbedDose): void;
  UnsetTransparency(): void;
  SetMaterial(theMat: Graphic3d_MaterialAspect): void;
  UnsetMaterial(): void;
  Duration(): Quantity_AbsorbedDose;
  SetDuration(theValue: Quantity_AbsorbedDose): void;
  ToResetCameraUp(): Standard_Boolean;
  SetResetCamera(theToReset: Standard_Boolean): void;
  ToFitSelected(): Standard_Boolean;
  SetFitSelected(theToFitSelected: Standard_Boolean): void;
  HasAnimation(): Standard_Boolean;
  StartAnimation(theOwner: any): void;
  UpdateAnimation(theToUpdate: Standard_Boolean): Standard_Boolean;
  HandleClick(theOwner: any): void;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  GlobalSelOwner(): Handle_SelectMgr_EntityOwner;
  Compute(thePrsMgr: any, thePrs: any, theMode: Graphic3d_ZLayerId): void;
  ComputeSelection(theSelection: Handle_SelectMgr_Selection, theMode: Graphic3d_ZLayerId): void;
  IsAutoHilight(): Standard_Boolean;
  ClearSelected(): void;
  HilightOwnerWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theOwner: Handle_SelectMgr_EntityOwner): void;
  HilightSelected(thePM: any, theSeq: SelectMgr_SequenceOfOwner): void;
  UnsetAttributes(): void;
  UnsetHilightAttributes(): void;
  delete(): void;
}

export declare type AIS_TrihedronSelectionMode = {
  AIS_TrihedronSelectionMode_EntireObject: {};
  AIS_TrihedronSelectionMode_Origin: {};
  AIS_TrihedronSelectionMode_Axes: {};
  AIS_TrihedronSelectionMode_MainPlanes: {};
}

export declare type AIS_DisplayStatus = {
  AIS_DS_Displayed: {};
  AIS_DS_Erased: {};
  AIS_DS_None: {};
}

export declare type AIS_TypeOfPlane = {
  AIS_TOPL_Unknown: {};
  AIS_TOPL_XYPlane: {};
  AIS_TOPL_XZPlane: {};
  AIS_TOPL_YZPlane: {};
}

export declare class AIS_DataMapofIntegerListOfinteractive extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, AIS_ListOfInteractive, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, AIS_ListOfInteractive, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: AIS_ListOfInteractive): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: AIS_ListOfInteractive): AIS_ListOfInteractive;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): AIS_ListOfInteractive;
  ChangeSeek(theKey: Standard_Integer): AIS_ListOfInteractive;
  ChangeFind(theKey: Standard_Integer): AIS_ListOfInteractive;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class AIS_DataMapofIntegerListOfinteractive_1 extends AIS_DataMapofIntegerListOfinteractive {
    constructor();
  }

  export declare class AIS_DataMapofIntegerListOfinteractive_2 extends AIS_DataMapofIntegerListOfinteractive {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class AIS_DataMapofIntegerListOfinteractive_3 extends AIS_DataMapofIntegerListOfinteractive {
    constructor(theOther: NCollection_DataMap<Standard_Integer, AIS_ListOfInteractive, TColStd_MapIntegerHasher>);
  }

export declare class AIS_Axis extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Component(): Handle_Geom_Line;
  SetComponent(aComponent: Handle_Geom_Line): void;
  Axis2Placement(): Handle_Geom_Axis2Placement;
  SetAxis2Placement(aComponent: Handle_Geom_Axis2Placement, anAxisType: AIS_TypeOfAxis): void;
  SetAxis1Placement(anAxis: Handle_Geom_Axis1Placement): void;
  TypeOfAxis(): AIS_TypeOfAxis;
  SetTypeOfAxis(theTypeAxis: AIS_TypeOfAxis): void;
  IsXYZAxis(): Standard_Boolean;
  AcceptDisplayMode(aMode: Graphic3d_ZLayerId): Standard_Boolean;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  SetColor(aColor: Quantity_Color): void;
  SetWidth(aValue: Quantity_AbsorbedDose): void;
  UnsetColor(): void;
  UnsetWidth(): void;
  delete(): void;
}

  export declare class AIS_Axis_1 extends AIS_Axis {
    constructor(aComponent: Handle_Geom_Line);
  }

  export declare class AIS_Axis_2 extends AIS_Axis {
    constructor(aComponent: Handle_Geom_Axis2Placement, anAxisType: AIS_TypeOfAxis);
  }

  export declare class AIS_Axis_3 extends AIS_Axis {
    constructor(anAxis: Handle_Geom_Axis1Placement);
  }

export declare class Handle_AIS_Axis {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Axis): void;
  get(): AIS_Axis;
  delete(): void;
}

  export declare class Handle_AIS_Axis_1 extends Handle_AIS_Axis {
    constructor();
  }

  export declare class Handle_AIS_Axis_2 extends Handle_AIS_Axis {
    constructor(thePtr: AIS_Axis);
  }

  export declare class Handle_AIS_Axis_3 extends Handle_AIS_Axis {
    constructor(theHandle: Handle_AIS_Axis);
  }

  export declare class Handle_AIS_Axis_4 extends Handle_AIS_Axis {
    constructor(theHandle: Handle_AIS_Axis);
  }

export declare type AIS_SelectStatus = {
  AIS_SS_Added: {};
  AIS_SS_Removed: {};
  AIS_SS_NotDone: {};
}

export declare class Handle_AIS_ColorScale {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ColorScale): void;
  get(): AIS_ColorScale;
  delete(): void;
}

  export declare class Handle_AIS_ColorScale_1 extends Handle_AIS_ColorScale {
    constructor();
  }

  export declare class Handle_AIS_ColorScale_2 extends Handle_AIS_ColorScale {
    constructor(thePtr: AIS_ColorScale);
  }

  export declare class Handle_AIS_ColorScale_3 extends Handle_AIS_ColorScale {
    constructor(theHandle: Handle_AIS_ColorScale);
  }

  export declare class Handle_AIS_ColorScale_4 extends Handle_AIS_ColorScale {
    constructor(theHandle: Handle_AIS_ColorScale);
  }

export declare class AIS_ColorScale extends AIS_InteractiveObject {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static FindColor_1(theValue: Quantity_AbsorbedDose, theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose, theColorsCount: Graphic3d_ZLayerId, theColorHlsMin: OpenGl_Vec3d, theColorHlsMax: OpenGl_Vec3d, theColor: Quantity_Color): Standard_Boolean;
  static FindColor_2(theValue: Quantity_AbsorbedDose, theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose, theColorsCount: Graphic3d_ZLayerId, theColor: Quantity_Color): Standard_Boolean;
  static hueToValidRange(theHue: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FindColor_3(theValue: Quantity_AbsorbedDose, theColor: Quantity_Color): Standard_Boolean;
  GetMin(): Quantity_AbsorbedDose;
  SetMin(theMin: Quantity_AbsorbedDose): void;
  GetMax(): Quantity_AbsorbedDose;
  SetMax(theMax: Quantity_AbsorbedDose): void;
  GetRange(theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose): void;
  SetRange(theMin: Quantity_AbsorbedDose, theMax: Quantity_AbsorbedDose): void;
  HueMin(): Quantity_AbsorbedDose;
  HueMax(): Quantity_AbsorbedDose;
  HueRange(theMinAngle: Quantity_AbsorbedDose, theMaxAngle: Quantity_AbsorbedDose): void;
  SetHueRange(theMinAngle: Quantity_AbsorbedDose, theMaxAngle: Quantity_AbsorbedDose): void;
  ColorRange(theMinColor: Quantity_Color, theMaxColor: Quantity_Color): void;
  SetColorRange(theMinColor: Quantity_Color, theMaxColor: Quantity_Color): void;
  GetLabelType(): Aspect_TypeOfColorScaleData;
  SetLabelType(theType: Aspect_TypeOfColorScaleData): void;
  GetColorType(): Aspect_TypeOfColorScaleData;
  SetColorType(theType: Aspect_TypeOfColorScaleData): void;
  GetNumberOfIntervals(): Graphic3d_ZLayerId;
  SetNumberOfIntervals(theNum: Graphic3d_ZLayerId): void;
  GetTitle(): TCollection_ExtendedString;
  SetTitle(theTitle: TCollection_ExtendedString): void;
  GetFormat(): XCAFDoc_PartId;
  Format(): XCAFDoc_PartId;
  SetFormat(theFormat: XCAFDoc_PartId): void;
  GetLabel(theIndex: Graphic3d_ZLayerId): TCollection_ExtendedString;
  GetIntervalColor(theIndex: Graphic3d_ZLayerId): Quantity_Color;
  SetIntervalColor(theColor: Quantity_Color, theIndex: Graphic3d_ZLayerId): void;
  GetLabels(theLabels: TColStd_SequenceOfExtendedString): void;
  Labels(): TColStd_SequenceOfExtendedString;
  SetLabels(theSeq: TColStd_SequenceOfExtendedString): void;
  GetColors_1(theColors: Aspect_SequenceOfColor): void;
  GetColors_2(): Aspect_SequenceOfColor;
  SetColors(theSeq: Aspect_SequenceOfColor): void;
  SetUniformColors(theLightness: Quantity_AbsorbedDose, theHueFrom: Quantity_AbsorbedDose, theHueTo: Quantity_AbsorbedDose): void;
  static MakeUniformColors(theNbColors: Graphic3d_ZLayerId, theLightness: Quantity_AbsorbedDose, theHueFrom: Quantity_AbsorbedDose, theHueTo: Quantity_AbsorbedDose): Aspect_SequenceOfColor;
  GetLabelPosition(): Aspect_TypeOfColorScalePosition;
  SetLabelPosition(thePos: Aspect_TypeOfColorScalePosition): void;
  GetTitlePosition(): Aspect_TypeOfColorScalePosition;
  SetTitlePosition(thePos: Aspect_TypeOfColorScalePosition): void;
  IsReversed(): Standard_Boolean;
  SetReversed(theReverse: Standard_Boolean): void;
  IsSmoothTransition(): Standard_Boolean;
  SetSmoothTransition(theIsSmooth: Standard_Boolean): void;
  IsLabelAtBorder(): Standard_Boolean;
  SetLabelAtBorder(theOn: Standard_Boolean): void;
  IsLogarithmic(): Standard_Boolean;
  SetLogarithmic(isLogarithmic: Standard_Boolean): void;
  SetLabel(theLabel: TCollection_ExtendedString, theIndex: Graphic3d_ZLayerId): void;
  GetSize(theBreadth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  SetSize(theBreadth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  GetBreadth(): Graphic3d_ZLayerId;
  SetBreadth(theBreadth: Graphic3d_ZLayerId): void;
  GetHeight(): Graphic3d_ZLayerId;
  SetHeight(theHeight: Graphic3d_ZLayerId): void;
  GetPosition(theX: Quantity_AbsorbedDose, theY: Quantity_AbsorbedDose): void;
  SetPosition(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId): void;
  GetXPosition(): Graphic3d_ZLayerId;
  SetXPosition(theX: Graphic3d_ZLayerId): void;
  GetYPosition(): Graphic3d_ZLayerId;
  SetYPosition(theY: Graphic3d_ZLayerId): void;
  GetTextHeight(): Graphic3d_ZLayerId;
  SetTextHeight(theHeight: Graphic3d_ZLayerId): void;
  TextWidth(theText: TCollection_ExtendedString): Graphic3d_ZLayerId;
  TextHeight(theText: TCollection_ExtendedString): Graphic3d_ZLayerId;
  TextSize(theText: TCollection_ExtendedString, theHeight: Graphic3d_ZLayerId, theWidth: Graphic3d_ZLayerId, theAscent: Graphic3d_ZLayerId, theDescent: Graphic3d_ZLayerId): void;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Compute(thePresentationManager: any, thePresentation: any, theMode: Graphic3d_ZLayerId): void;
  ComputeSelection(a0: Handle_SelectMgr_Selection, a1: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_AIS_GlobalStatus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_GlobalStatus): void;
  get(): AIS_GlobalStatus;
  delete(): void;
}

  export declare class Handle_AIS_GlobalStatus_1 extends Handle_AIS_GlobalStatus {
    constructor();
  }

  export declare class Handle_AIS_GlobalStatus_2 extends Handle_AIS_GlobalStatus {
    constructor(thePtr: AIS_GlobalStatus);
  }

  export declare class Handle_AIS_GlobalStatus_3 extends Handle_AIS_GlobalStatus {
    constructor(theHandle: Handle_AIS_GlobalStatus);
  }

  export declare class Handle_AIS_GlobalStatus_4 extends Handle_AIS_GlobalStatus {
    constructor(theHandle: Handle_AIS_GlobalStatus);
  }

export declare class AIS_GlobalStatus extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetGraphicStatus(theStatus: AIS_DisplayStatus): void;
  AddSelectionMode(theMode: Graphic3d_ZLayerId): void;
  SetDisplayMode(theMode: Graphic3d_ZLayerId): void;
  DisplayMode(): Graphic3d_ZLayerId;
  SetLayerIndex(theIndex: Graphic3d_ZLayerId): void;
  SetHilightStatus(theStatus: Standard_Boolean): void;
  SetHilightStyle(theStyle: Handle_Prs3d_Drawer): void;
  HilightStyle(): Handle_Prs3d_Drawer;
  IsSubIntensityOn(): Standard_Boolean;
  SubIntensityOn(): void;
  SubIntensityOff(): void;
  RemoveSelectionMode(aMode: Graphic3d_ZLayerId): void;
  ClearSelectionModes(): void;
  GraphicStatus(): AIS_DisplayStatus;
  SelectionModes(): TColStd_ListOfInteger;
  IsHilighted(): Standard_Boolean;
  IsSModeIn(aMode: Graphic3d_ZLayerId): Standard_Boolean;
  GetLayerIndex(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class AIS_GlobalStatus_1 extends AIS_GlobalStatus {
    constructor();
  }

  export declare class AIS_GlobalStatus_2 extends AIS_GlobalStatus {
    constructor(aStat: AIS_DisplayStatus, aDispMode: Graphic3d_ZLayerId, aSelMode: Graphic3d_ZLayerId, ishilighted: Standard_Boolean, aLayerIndex: Graphic3d_ZLayerId);
  }

export declare class AIS_WalkDelta {
  constructor()
  IsJumping(): Standard_Boolean;
  SetJumping(theIsJumping: Standard_Boolean): void;
  IsCrouching(): Standard_Boolean;
  SetCrouching(theIsCrouching: Standard_Boolean): void;
  IsRunning(): Standard_Boolean;
  SetRunning(theIsRunning: Standard_Boolean): void;
  IsEmpty(): Standard_Boolean;
  ToMove(): Standard_Boolean;
  ToRotate(): Standard_Boolean;
  delete(): void;
}

export declare type AIS_WalkTranslation = {
  AIS_WalkTranslation_Forward: {};
  AIS_WalkTranslation_Side: {};
  AIS_WalkTranslation_Up: {};
}

export declare type AIS_WalkRotation = {
  AIS_WalkRotation_Yaw: {};
  AIS_WalkRotation_Pitch: {};
  AIS_WalkRotation_Roll: {};
}

export declare class AIS_WalkPart {
  constructor()
  IsEmpty(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_AIS_C0RegularityFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_C0RegularityFilter): void;
  get(): AIS_C0RegularityFilter;
  delete(): void;
}

  export declare class Handle_AIS_C0RegularityFilter_1 extends Handle_AIS_C0RegularityFilter {
    constructor();
  }

  export declare class Handle_AIS_C0RegularityFilter_2 extends Handle_AIS_C0RegularityFilter {
    constructor(thePtr: AIS_C0RegularityFilter);
  }

  export declare class Handle_AIS_C0RegularityFilter_3 extends Handle_AIS_C0RegularityFilter {
    constructor(theHandle: Handle_AIS_C0RegularityFilter);
  }

  export declare class Handle_AIS_C0RegularityFilter_4 extends Handle_AIS_C0RegularityFilter {
    constructor(theHandle: Handle_AIS_C0RegularityFilter);
  }

export declare class AIS_C0RegularityFilter extends SelectMgr_Filter {
  constructor(aShape: TopoDS_Shape)
  ActsOn(aType: TopAbs_ShapeEnum): Standard_Boolean;
  IsOk(EO: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class AIS_TrihedronOwner extends SelectMgr_EntityOwner {
  constructor(theSelObject: Handle_SelectMgr_SelectableObject, theDatumPart: Prs3d_DatumParts, thePriority: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  DatumPart(): Prs3d_DatumParts;
  HilightWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theMode: Graphic3d_ZLayerId): void;
  IsHilighted(thePM: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Unhilight(thePM: Handle_PrsMgr_PresentationManager, theMode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_AIS_TrihedronOwner {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_TrihedronOwner): void;
  get(): AIS_TrihedronOwner;
  delete(): void;
}

  export declare class Handle_AIS_TrihedronOwner_1 extends Handle_AIS_TrihedronOwner {
    constructor();
  }

  export declare class Handle_AIS_TrihedronOwner_2 extends Handle_AIS_TrihedronOwner {
    constructor(thePtr: AIS_TrihedronOwner);
  }

  export declare class Handle_AIS_TrihedronOwner_3 extends Handle_AIS_TrihedronOwner {
    constructor(theHandle: Handle_AIS_TrihedronOwner);
  }

  export declare class Handle_AIS_TrihedronOwner_4 extends Handle_AIS_TrihedronOwner {
    constructor(theHandle: Handle_AIS_TrihedronOwner);
  }

export declare type AIS_ConnectStatus = {
  AIS_CS_None: {};
  AIS_CS_Connection: {};
  AIS_CS_Transform: {};
  AIS_CS_Both: {};
}

export declare class AIS_RubberBand extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetRectangle(theMinX: Graphic3d_ZLayerId, theMinY: Graphic3d_ZLayerId, theMaxX: Graphic3d_ZLayerId, theMaxY: Graphic3d_ZLayerId): void;
  AddPoint(thePoint: OpenGl_Vec2i): void;
  RemoveLastPoint(): void;
  Points(): any;
  ClearPoints(): void;
  LineColor(): Quantity_Color;
  SetLineColor(theColor: Quantity_Color): void;
  FillColor(): Quantity_Color;
  SetFillColor(theColor: Quantity_Color): void;
  SetLineWidth(theWidth: Quantity_AbsorbedDose): void;
  LineWidth(): Quantity_AbsorbedDose;
  SetLineType(theType: Aspect_TypeOfLine): void;
  LineType(): Aspect_TypeOfLine;
  SetFillTransparency(theValue: Quantity_AbsorbedDose): void;
  FillTransparency(): Quantity_AbsorbedDose;
  SetFilling_1(theIsFilling: Standard_Boolean): void;
  SetFilling_2(theColor: Quantity_Color, theTransparency: Quantity_AbsorbedDose): void;
  IsFilling(): Standard_Boolean;
  IsPolygonClosed(): Standard_Boolean;
  SetPolygonClosed(theIsPolygonClosed: Standard_Boolean): void;
  delete(): void;
}

  export declare class AIS_RubberBand_1 extends AIS_RubberBand {
    constructor();
  }

  export declare class AIS_RubberBand_2 extends AIS_RubberBand {
    constructor(theLineColor: Quantity_Color, theType: Aspect_TypeOfLine, theLineWidth: Quantity_AbsorbedDose, theIsPolygonClosed: Standard_Boolean);
  }

  export declare class AIS_RubberBand_3 extends AIS_RubberBand {
    constructor(theLineColor: Quantity_Color, theType: Aspect_TypeOfLine, theFillColor: Quantity_Color, theTransparency: Quantity_AbsorbedDose, theLineWidth: Quantity_AbsorbedDose, theIsPolygonClosed: Standard_Boolean);
  }

export declare class Handle_AIS_RubberBand {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_RubberBand): void;
  get(): AIS_RubberBand;
  delete(): void;
}

  export declare class Handle_AIS_RubberBand_1 extends Handle_AIS_RubberBand {
    constructor();
  }

  export declare class Handle_AIS_RubberBand_2 extends Handle_AIS_RubberBand {
    constructor(thePtr: AIS_RubberBand);
  }

  export declare class Handle_AIS_RubberBand_3 extends Handle_AIS_RubberBand {
    constructor(theHandle: Handle_AIS_RubberBand);
  }

  export declare class Handle_AIS_RubberBand_4 extends Handle_AIS_RubberBand {
    constructor(theHandle: Handle_AIS_RubberBand);
  }

export declare type AIS_TypeOfIso = {
  AIS_TOI_IsoU: {};
  AIS_TOI_IsoV: {};
  AIS_TOI_Both: {};
}

export declare class Handle_AIS_Animation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Animation): void;
  get(): AIS_Animation;
  delete(): void;
}

  export declare class Handle_AIS_Animation_1 extends Handle_AIS_Animation {
    constructor();
  }

  export declare class Handle_AIS_Animation_2 extends Handle_AIS_Animation {
    constructor(thePtr: AIS_Animation);
  }

  export declare class Handle_AIS_Animation_3 extends Handle_AIS_Animation {
    constructor(theHandle: Handle_AIS_Animation);
  }

  export declare class Handle_AIS_Animation_4 extends Handle_AIS_Animation {
    constructor(theHandle: Handle_AIS_Animation);
  }

export declare class AIS_AnimationProgress {
  constructor()
  delete(): void;
}

export declare class AIS_Animation extends Standard_Transient {
  constructor(theAnimationName: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Name(): XCAFDoc_PartId;
  StartPts(): Quantity_AbsorbedDose;
  SetStartPts(thePtsStart: Quantity_AbsorbedDose): void;
  Duration(): Quantity_AbsorbedDose;
  UpdateTotalDuration(): void;
  HasOwnDuration(): Standard_Boolean;
  OwnDuration(): Quantity_AbsorbedDose;
  SetOwnDuration(theDuration: Quantity_AbsorbedDose): void;
  Add(theAnimation: Handle_AIS_Animation): void;
  Clear(): void;
  Find(theAnimationName: XCAFDoc_PartId): Handle_AIS_Animation;
  Remove(theAnimation: Handle_AIS_Animation): Standard_Boolean;
  Replace(theAnimationOld: Handle_AIS_Animation, theAnimationNew: Handle_AIS_Animation): Standard_Boolean;
  CopyFrom(theOther: Handle_AIS_Animation): void;
  Children(): any;
  StartTimer(theStartPts: Quantity_AbsorbedDose, thePlaySpeed: Quantity_AbsorbedDose, theToUpdate: Standard_Boolean, theToStopTimer: Standard_Boolean): void;
  UpdateTimer(): Quantity_AbsorbedDose;
  ElapsedTime(): Quantity_AbsorbedDose;
  Start(theToUpdate: Standard_Boolean): void;
  Pause(): void;
  Stop(): void;
  IsStopped(): Standard_Boolean;
  Update(thePts: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare type AIS_StatusOfDetection = {
  AIS_SOD_Error: {};
  AIS_SOD_Nothing: {};
  AIS_SOD_AllBad: {};
  AIS_SOD_Selected: {};
  AIS_SOD_OnlyOneDetected: {};
  AIS_SOD_OnlyOneGood: {};
  AIS_SOD_SeveralGood: {};
}

export declare class AIS_MultipleConnectedInteractive extends AIS_InteractiveObject {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Connect_1(theAnotherObj: Handle_AIS_InteractiveObject, theLocation: Handle_TopLoc_Datum3D, theTrsfPers: Handle_Graphic3d_TransformPers): Handle_AIS_InteractiveObject;
  Type(): AIS_KindOfInteractive;
  Signature(): Graphic3d_ZLayerId;
  HasConnection(): Standard_Boolean;
  Disconnect(theInteractive: Handle_AIS_InteractiveObject): void;
  DisconnectAll(): void;
  AcceptShapeDecomposition(): Standard_Boolean;
  GetAssemblyOwner(): Handle_SelectMgr_EntityOwner;
  GlobalSelOwner(): Handle_SelectMgr_EntityOwner;
  SetContext(theCtx: Handle_AIS_InteractiveContext): void;
  Connect_2(theAnotherObj: Handle_AIS_InteractiveObject): Handle_AIS_InteractiveObject;
  Connect_3(theAnotherObj: Handle_AIS_InteractiveObject, theLocation: gp_Trsf): Handle_AIS_InteractiveObject;
  Connect_4(theAnotherObj: Handle_AIS_InteractiveObject, theLocation: gp_Trsf, theTrsfPers: Handle_Graphic3d_TransformPers): Handle_AIS_InteractiveObject;
  Connect_5(theInteractive: Handle_AIS_InteractiveObject, theLocation: gp_Trsf, theTrsfPersFlag: Graphic3d_TransModeFlags, theTrsfPersPoint: gp_Pnt): Handle_AIS_InteractiveObject;
  delete(): void;
}

export declare class Handle_AIS_MultipleConnectedInteractive {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_MultipleConnectedInteractive): void;
  get(): AIS_MultipleConnectedInteractive;
  delete(): void;
}

  export declare class Handle_AIS_MultipleConnectedInteractive_1 extends Handle_AIS_MultipleConnectedInteractive {
    constructor();
  }

  export declare class Handle_AIS_MultipleConnectedInteractive_2 extends Handle_AIS_MultipleConnectedInteractive {
    constructor(thePtr: AIS_MultipleConnectedInteractive);
  }

  export declare class Handle_AIS_MultipleConnectedInteractive_3 extends Handle_AIS_MultipleConnectedInteractive {
    constructor(theHandle: Handle_AIS_MultipleConnectedInteractive);
  }

  export declare class Handle_AIS_MultipleConnectedInteractive_4 extends Handle_AIS_MultipleConnectedInteractive {
    constructor(theHandle: Handle_AIS_MultipleConnectedInteractive);
  }

export declare class Handle_AIS_AnimationObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_AnimationObject): void;
  get(): AIS_AnimationObject;
  delete(): void;
}

  export declare class Handle_AIS_AnimationObject_1 extends Handle_AIS_AnimationObject {
    constructor();
  }

  export declare class Handle_AIS_AnimationObject_2 extends Handle_AIS_AnimationObject {
    constructor(thePtr: AIS_AnimationObject);
  }

  export declare class Handle_AIS_AnimationObject_3 extends Handle_AIS_AnimationObject {
    constructor(theHandle: Handle_AIS_AnimationObject);
  }

  export declare class Handle_AIS_AnimationObject_4 extends Handle_AIS_AnimationObject {
    constructor(theHandle: Handle_AIS_AnimationObject);
  }

export declare class AIS_AnimationObject extends AIS_Animation {
  constructor(theAnimationName: XCAFDoc_PartId, theContext: Handle_AIS_InteractiveContext, theObject: Handle_AIS_InteractiveObject, theTrsfStart: gp_Trsf, theTrsfEnd: gp_Trsf)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_AIS_InteractiveObject {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_InteractiveObject): void;
  get(): AIS_InteractiveObject;
  delete(): void;
}

  export declare class Handle_AIS_InteractiveObject_1 extends Handle_AIS_InteractiveObject {
    constructor();
  }

  export declare class Handle_AIS_InteractiveObject_2 extends Handle_AIS_InteractiveObject {
    constructor(thePtr: AIS_InteractiveObject);
  }

  export declare class Handle_AIS_InteractiveObject_3 extends Handle_AIS_InteractiveObject {
    constructor(theHandle: Handle_AIS_InteractiveObject);
  }

  export declare class Handle_AIS_InteractiveObject_4 extends Handle_AIS_InteractiveObject {
    constructor(theHandle: Handle_AIS_InteractiveObject);
  }

export declare class AIS_InteractiveObject extends SelectMgr_SelectableObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Type(): AIS_KindOfInteractive;
  Signature(): Graphic3d_ZLayerId;
  Redisplay(AllModes: Standard_Boolean): void;
  HasInteractiveContext(): Standard_Boolean;
  InteractiveContext(): AIS_InteractiveContext;
  SetContext(aCtx: Handle_AIS_InteractiveContext): void;
  HasOwner(): Standard_Boolean;
  GetOwner(): Handle_Standard_Transient;
  SetOwner(theApplicativeEntity: Handle_Standard_Transient): void;
  ClearOwner(): void;
  ProcessDragging(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theOwner: Handle_SelectMgr_EntityOwner, theDragFrom: OpenGl_Vec2i, theDragTo: OpenGl_Vec2i, theAction: AIS_DragAction): Standard_Boolean;
  GetContext(): Handle_AIS_InteractiveContext;
  HasPresentation(): Standard_Boolean;
  Presentation(): any;
  SetAspect(anAspect: Handle_Prs3d_BasicAspect): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class AIS_Trihedron extends AIS_InteractiveObject {
  constructor(theComponent: Handle_Geom_Axis2Placement)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetDatumDisplayMode(theMode: Prs3d_DatumMode): void;
  DatumDisplayMode(): Prs3d_DatumMode;
  Component(): Handle_Geom_Axis2Placement;
  SetComponent(theComponent: Handle_Geom_Axis2Placement): void;
  HasOwnSize(): Standard_Boolean;
  SetSize(theValue: Quantity_AbsorbedDose): void;
  UnsetSize(): void;
  Size(): Quantity_AbsorbedDose;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  SetColor(theColor: Quantity_Color): void;
  SetTextColor(theColor: Quantity_Color): void;
  HasTextColor(): Standard_Boolean;
  TextColor(): Quantity_Color;
  SetArrowColor(theColor: Quantity_Color): void;
  HasArrowColor(): Standard_Boolean;
  ArrowColor(): Quantity_Color;
  UnsetColor(): void;
  SetDatumPartColor(thePart: Prs3d_DatumParts, theColor: Quantity_Color): void;
  DatumPartColor(thePart: Prs3d_DatumParts): Quantity_Color;
  SetOriginColor(theColor: Quantity_Color): void;
  SetXAxisColor(theColor: Quantity_Color): void;
  SetYAxisColor(theColor: Quantity_Color): void;
  SetAxisColor(theColor: Quantity_Color): void;
  ToDrawArrows(): Standard_Boolean;
  SetDrawArrows(theToDraw: Standard_Boolean): void;
  SetSelectionPriority(thePart: Prs3d_DatumParts, thePriority: Graphic3d_ZLayerId): void;
  SelectionPriority(thePart: Prs3d_DatumParts): Graphic3d_ZLayerId;
  SetLabel(thePart: Prs3d_DatumParts, thePriority: TCollection_ExtendedString): void;
  Label(thePart: Prs3d_DatumParts): TCollection_ExtendedString;
  ClearSelected(): void;
  HilightSelected(thePM: any, theOwners: SelectMgr_SequenceOfOwner): void;
  HilightOwnerWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theOwner: Handle_SelectMgr_EntityOwner): void;
  delete(): void;
}

export declare class Handle_AIS_Trihedron {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Trihedron): void;
  get(): AIS_Trihedron;
  delete(): void;
}

  export declare class Handle_AIS_Trihedron_1 extends Handle_AIS_Trihedron {
    constructor();
  }

  export declare class Handle_AIS_Trihedron_2 extends Handle_AIS_Trihedron {
    constructor(thePtr: AIS_Trihedron);
  }

  export declare class Handle_AIS_Trihedron_3 extends Handle_AIS_Trihedron {
    constructor(theHandle: Handle_AIS_Trihedron);
  }

  export declare class Handle_AIS_Trihedron_4 extends Handle_AIS_Trihedron {
    constructor(theHandle: Handle_AIS_Trihedron);
  }

export declare class Handle_AIS_TypeFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_TypeFilter): void;
  get(): AIS_TypeFilter;
  delete(): void;
}

  export declare class Handle_AIS_TypeFilter_1 extends Handle_AIS_TypeFilter {
    constructor();
  }

  export declare class Handle_AIS_TypeFilter_2 extends Handle_AIS_TypeFilter {
    constructor(thePtr: AIS_TypeFilter);
  }

  export declare class Handle_AIS_TypeFilter_3 extends Handle_AIS_TypeFilter {
    constructor(theHandle: Handle_AIS_TypeFilter);
  }

  export declare class Handle_AIS_TypeFilter_4 extends Handle_AIS_TypeFilter {
    constructor(theHandle: Handle_AIS_TypeFilter);
  }

export declare class AIS_TypeFilter extends SelectMgr_Filter {
  constructor(aGivenKind: AIS_KindOfInteractive)
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class AIS_ViewController {
  constructor()
  InputBuffer(theType: AIS_ViewInputBufferType): AIS_ViewInputBuffer;
  ChangeInputBuffer(theType: AIS_ViewInputBufferType): AIS_ViewInputBuffer;
  ViewAnimation(): Handle_AIS_AnimationCamera;
  SetViewAnimation(theAnimation: Handle_AIS_AnimationCamera): void;
  AbortViewAnimation(): void;
  RotationMode(): AIS_RotationMode;
  SetRotationMode(theMode: AIS_RotationMode): void;
  NavigationMode(): AIS_NavigationMode;
  SetNavigationMode(theMode: AIS_NavigationMode): void;
  MouseAcceleration(): Standard_ShortReal;
  SetMouseAcceleration(theRatio: Standard_ShortReal): void;
  OrbitAcceleration(): Standard_ShortReal;
  SetOrbitAcceleration(theRatio: Standard_ShortReal): void;
  ToShowPanAnchorPoint(): Standard_Boolean;
  SetShowPanAnchorPoint(theToShow: Standard_Boolean): void;
  ToShowRotateCenter(): Standard_Boolean;
  SetShowRotateCenter(theToShow: Standard_Boolean): void;
  ToLockOrbitZUp(): Standard_Boolean;
  SetLockOrbitZUp(theToForceUp: Standard_Boolean): void;
  ToAllowTouchZRotation(): Standard_Boolean;
  SetAllowTouchZRotation(theToEnable: Standard_Boolean): void;
  ToAllowRotation(): Standard_Boolean;
  SetAllowRotation(theToEnable: Standard_Boolean): void;
  ToAllowPanning(): Standard_Boolean;
  SetAllowPanning(theToEnable: Standard_Boolean): void;
  ToAllowZooming(): Standard_Boolean;
  SetAllowZooming(theToEnable: Standard_Boolean): void;
  ToAllowZFocus(): Standard_Boolean;
  SetAllowZFocus(theToEnable: Standard_Boolean): void;
  ToAllowHighlight(): Standard_Boolean;
  SetAllowHighlight(theToEnable: Standard_Boolean): void;
  ToAllowDragging(): Standard_Boolean;
  SetAllowDragging(theToEnable: Standard_Boolean): void;
  ToStickToRayOnZoom(): Standard_Boolean;
  SetStickToRayOnZoom(theToEnable: Standard_Boolean): void;
  ToStickToRayOnRotation(): Standard_Boolean;
  SetStickToRayOnRotation(theToEnable: Standard_Boolean): void;
  ToInvertPitch(): Standard_Boolean;
  SetInvertPitch(theToInvert: Standard_Boolean): void;
  WalkSpeedAbsolute(): Standard_ShortReal;
  SetWalkSpeedAbsolute(theSpeed: Standard_ShortReal): void;
  WalkSpeedRelative(): Standard_ShortReal;
  SetWalkSpeedRelative(theFactor: Standard_ShortReal): void;
  ThrustSpeed(): Standard_ShortReal;
  SetThrustSpeed(theSpeed: Standard_ShortReal): void;
  HasPreviousMoveTo(): Standard_Boolean;
  PreviousMoveTo(): OpenGl_Vec2i;
  ResetPreviousMoveTo(): void;
  ToDisplayXRAuxDevices(): Standard_Boolean;
  SetDisplayXRAuxDevices(theToDisplay: Standard_Boolean): void;
  ToDisplayXRHands(): Standard_Boolean;
  SetDisplayXRHands(theToDisplay: Standard_Boolean): void;
  KeyDown(theKey: Aspect_VKey, theTime: Standard_Real, thePressure: Standard_Real): void;
  KeyUp(theKey: Aspect_VKey, theTime: Standard_Real): void;
  KeyFromAxis(theNegative: Aspect_VKey, thePositive: Aspect_VKey, theTime: Standard_Real, thePressure: Standard_Real): void;
  FetchNavigationKeys(theCrouchRatio: Quantity_AbsorbedDose, theRunRatio: Quantity_AbsorbedDose): AIS_WalkDelta;
  MouseGestureMap(): AIS_MouseGestureMap;
  ChangeMouseGestureMap(): AIS_MouseGestureMap;
  MouseDoubleClickInterval(): Standard_Real;
  SetMouseDoubleClickInterval(theSeconds: Standard_Real): void;
  SelectInViewer_1(thePnt: OpenGl_Vec2i, theIsXOR: Standard_Boolean): void;
  SelectInViewer_2(thePnts: NCollection_Sequence<Graphic3d_Vec2i>, theIsXOR: Standard_Boolean): void;
  UpdateRubberBand(thePntFrom: OpenGl_Vec2i, thePntTo: OpenGl_Vec2i, theIsXOR: Standard_Boolean): void;
  UpdatePolySelection(thePnt: OpenGl_Vec2i, theToAppend: Standard_Boolean): void;
  UpdateZoom(theDelta: Aspect_ScrollDelta): Standard_Boolean;
  UpdateZRotation(theAngle: Standard_Real): Standard_Boolean;
  UpdateMouseScroll(theDelta: Aspect_ScrollDelta): Standard_Boolean;
  UpdateMouseButtons(thePoint: OpenGl_Vec2i, theButtons: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsEmulated: Standard_Boolean): Standard_Boolean;
  UpdateMousePosition(thePoint: OpenGl_Vec2i, theButtons: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsEmulated: Standard_Boolean): Standard_Boolean;
  PressMouseButton(thePoint: OpenGl_Vec2i, theButton: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsEmulated: Standard_Boolean): Standard_Boolean;
  ReleaseMouseButton(thePoint: OpenGl_Vec2i, theButton: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsEmulated: Standard_Boolean): Standard_Boolean;
  UpdateMouseClick(thePoint: OpenGl_Vec2i, theButton: Aspect_VKeyMouse, theModifiers: Aspect_VKeyFlags, theIsDoubleClick: Standard_Boolean): Standard_Boolean;
  PressedMouseButtons(): Aspect_VKeyMouse;
  LastMouseFlags(): Aspect_VKeyFlags;
  LastMousePosition(): OpenGl_Vec2i;
  TouchToleranceScale(): Standard_ShortReal;
  SetTouchToleranceScale(theTolerance: Standard_ShortReal): void;
  HasTouchPoints(): Standard_Boolean;
  AddTouchPoint(theId: Standard_ThreadId, thePnt: OpenGl_Vec2d, theClearBefore: Standard_Boolean): void;
  RemoveTouchPoint(theId: Standard_ThreadId, theClearSelectPnts: Standard_Boolean): Standard_Boolean;
  UpdateTouchPoint(theId: Standard_ThreadId, thePnt: OpenGl_Vec2d): void;
  Get3dMouseTranslationScale(): Standard_ShortReal;
  Set3dMouseTranslationScale(theScale: Standard_ShortReal): void;
  Get3dMouseRotationScale(): Standard_ShortReal;
  Set3dMouseRotationScale(theScale: Standard_ShortReal): void;
  To3dMousePreciseInput(): Standard_Boolean;
  Set3dMousePreciseInput(theIsQuadric: Standard_Boolean): void;
  Get3dMouseIsNoRotate(): any;
  Change3dMouseIsNoRotate(): any;
  Get3dMouseToReverse(): any;
  Change3dMouseToReverse(): any;
  Update3dMouse(theEvent: WNT_HIDSpaceMouse): Standard_Boolean;
  update3dMouseTranslation(theEvent: WNT_HIDSpaceMouse): Standard_Boolean;
  update3dMouseRotation(theEvent: WNT_HIDSpaceMouse): Standard_Boolean;
  update3dMouseKeys(theEvent: WNT_HIDSpaceMouse): Standard_Boolean;
  EventTime(): Standard_Real;
  ResetViewInput(): void;
  UpdateViewOrientation(theOrientation: V3d_TypeOfOrientation, theToFitAll: Standard_Boolean): void;
  FlushViewEvents(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theToHandle: Standard_Boolean): void;
  HandleViewEvents(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  OnSelectionChanged(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  OnObjectDragged(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theAction: AIS_DragAction): void;
  PickPoint(thePnt: gp_Pnt, theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theCursor: OpenGl_Vec2i, theToStickToPickRay: Standard_Boolean): Standard_Boolean;
  GravityPoint(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): gp_Pnt;
  FitAllAuto(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleViewOrientationKeys(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleNavigationKeys(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): AIS_WalkDelta;
  handleCameraActions(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theWalk: AIS_WalkDelta): void;
  handleMoveTo(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  toAskNextFrame(): Standard_Boolean;
  setAskNextFrame(theToDraw: Standard_Boolean): void;
  hasPanningAnchorPoint(): Standard_Boolean;
  panningAnchorPoint(): gp_Pnt;
  setPanningAnchorPoint(thePnt: gp_Pnt): void;
  handlePanning(theView: Handle_V3d_View): void;
  handleZRotate(theView: Handle_V3d_View): void;
  MinZoomDistance(): Standard_Real;
  SetMinZoomDistance(theDist: Standard_Real): void;
  handleZoom(theView: Handle_V3d_View, theParams: Aspect_ScrollDelta, thePnt: gp_Pnt): void;
  handleZFocusScroll(theView: Handle_V3d_View, theParams: Aspect_ScrollDelta): void;
  handleOrbitRotation(theView: Handle_V3d_View, thePnt: gp_Pnt, theToLockZUp: Standard_Boolean): void;
  handleViewRotation(theView: Handle_V3d_View, theYawExtra: Standard_Real, thePitchExtra: Standard_Real, theRoll: Standard_Real, theToRestartOnIncrement: Standard_Boolean): void;
  handleViewRedraw(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleXRInput(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theWalk: AIS_WalkDelta): void;
  handleXRTurnPad(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleXRTeleport(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleXRPicking(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleXRHighlight(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleXRPresentations(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View): void;
  handleXRMoveTo(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, thePose: gp_Trsf, theToHighlight: Standard_Boolean): Graphic3d_ZLayerId;
  delete(): void;
}

export declare type AIS_DragAction = {
  AIS_DragAction_Start: {};
  AIS_DragAction_Update: {};
  AIS_DragAction_Stop: {};
  AIS_DragAction_Abort: {};
}

export declare class AIS_ColoredDrawer extends Prs3d_Drawer {
  constructor(theLink: Handle_Prs3d_Drawer)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsHidden(): Standard_Boolean;
  SetHidden(theToHide: Standard_Boolean): void;
  HasOwnMaterial(): Standard_Boolean;
  UnsetOwnMaterial(): void;
  SetOwnMaterial(): void;
  HasOwnColor(): Standard_Boolean;
  UnsetOwnColor(): void;
  SetOwnColor(a0: Quantity_Color): void;
  HasOwnTransparency(): Standard_Boolean;
  UnsetOwnTransparency(): void;
  SetOwnTransparency(a0: Quantity_AbsorbedDose): void;
  HasOwnWidth(): Standard_Boolean;
  UnsetOwnWidth(): void;
  SetOwnWidth(a0: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_AIS_ColoredDrawer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ColoredDrawer): void;
  get(): AIS_ColoredDrawer;
  delete(): void;
}

  export declare class Handle_AIS_ColoredDrawer_1 extends Handle_AIS_ColoredDrawer {
    constructor();
  }

  export declare class Handle_AIS_ColoredDrawer_2 extends Handle_AIS_ColoredDrawer {
    constructor(thePtr: AIS_ColoredDrawer);
  }

  export declare class Handle_AIS_ColoredDrawer_3 extends Handle_AIS_ColoredDrawer {
    constructor(theHandle: Handle_AIS_ColoredDrawer);
  }

  export declare class Handle_AIS_ColoredDrawer_4 extends Handle_AIS_ColoredDrawer {
    constructor(theHandle: Handle_AIS_ColoredDrawer);
  }

export declare class AIS_XRTrackedDevice extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Role(): Aspect_XRTrackedDeviceRole;
  SetRole(theRole: Aspect_XRTrackedDeviceRole): void;
  LaserColor(): Quantity_Color;
  SetLaserColor(theColor: Quantity_Color): void;
  LaserLength(): Standard_ShortReal;
  SetLaserLength(theLength: Standard_ShortReal): void;
  UnitFactor(): Standard_ShortReal;
  SetUnitFactor(theFactor: Standard_ShortReal): void;
  delete(): void;
}

  export declare class AIS_XRTrackedDevice_1 extends AIS_XRTrackedDevice {
    constructor(theTris: Handle_Graphic3d_ArrayOfTriangles, theTexture: any);
  }

  export declare class AIS_XRTrackedDevice_2 extends AIS_XRTrackedDevice {
    constructor();
  }

export declare class Handle_AIS_Point {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Point): void;
  get(): AIS_Point;
  delete(): void;
}

  export declare class Handle_AIS_Point_1 extends Handle_AIS_Point {
    constructor();
  }

  export declare class Handle_AIS_Point_2 extends Handle_AIS_Point {
    constructor(thePtr: AIS_Point);
  }

  export declare class Handle_AIS_Point_3 extends Handle_AIS_Point {
    constructor(theHandle: Handle_AIS_Point);
  }

  export declare class Handle_AIS_Point_4 extends Handle_AIS_Point {
    constructor(theHandle: Handle_AIS_Point);
  }

export declare class AIS_Point extends AIS_InteractiveObject {
  constructor(aComponent: Handle_Geom_Point)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  Component(): Handle_Geom_Point;
  SetComponent(aComponent: Handle_Geom_Point): void;
  AcceptDisplayMode(aMode: Graphic3d_ZLayerId): Standard_Boolean;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  SetMarker(aType: Aspect_TypeOfMarker): void;
  UnsetMarker(): void;
  HasMarker(): Standard_Boolean;
  Vertex(): TopoDS_Vertex;
  delete(): void;
}

export declare type AIS_ManipulatorMode = {
  AIS_MM_None: {};
  AIS_MM_Translation: {};
  AIS_MM_Rotation: {};
  AIS_MM_Scaling: {};
  AIS_MM_TranslationPlane: {};
}

export declare class AIS_MediaPlayer extends AIS_InteractiveObject {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetCallback(theCallbackFunction: any, theCallbackUserPtr: C_f): void;
  OpenInput(thePath: XCAFDoc_PartId, theToWait: Standard_Boolean): void;
  PresentFrame(theLeftCorner: OpenGl_Vec2i, theMaxSize: OpenGl_Vec2i): Standard_Boolean;
  PlayerContext(): any;
  PlayPause(): void;
  SetClosePlayer(): void;
  Duration(): Standard_Real;
  delete(): void;
}

export declare class AIS_Manipulator extends AIS_InteractiveObject {
  SetPart_1(theAxisIndex: Graphic3d_ZLayerId, theMode: AIS_ManipulatorMode, theIsEnabled: Standard_Boolean): void;
  SetPart_2(theMode: AIS_ManipulatorMode, theIsEnabled: Standard_Boolean): void;
  Attach_1(theObject: Handle_AIS_InteractiveObject, theOptions: any): void;
  Attach_2(theObject: Handle_AIS_ManipulatorObjectSequence, theOptions: any): void;
  EnableMode(theMode: AIS_ManipulatorMode): void;
  SetModeActivationOnDetection(theToEnable: Standard_Boolean): void;
  IsModeActivationOnDetection(): Standard_Boolean;
  ProcessDragging(theCtx: Handle_AIS_InteractiveContext, theView: Handle_V3d_View, theOwner: Handle_SelectMgr_EntityOwner, theDragFrom: OpenGl_Vec2i, theDragTo: OpenGl_Vec2i, theAction: AIS_DragAction): Standard_Boolean;
  StartTransform(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId, theView: Handle_V3d_View): void;
  Transform_1(aTrsf: gp_Trsf): void;
  StopTransform(theToApply: Standard_Boolean): void;
  Transform_2(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId, theView: Handle_V3d_View): gp_Trsf;
  ObjectTransformation(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId, theView: Handle_V3d_View, theTrsf: gp_Trsf): Standard_Boolean;
  DeactivateCurrentMode(): void;
  Detach(): void;
  Objects(): Handle_AIS_ManipulatorObjectSequence;
  Object_1(): Handle_AIS_InteractiveObject;
  Object_2(theIndex: Graphic3d_ZLayerId): Handle_AIS_InteractiveObject;
  IsAttached(): Standard_Boolean;
  HasActiveMode(): Standard_Boolean;
  HasActiveTransformation(): Standard_Boolean;
  StartTransformation_1(): gp_Trsf;
  StartTransformation_2(theIndex: Graphic3d_ZLayerId): gp_Trsf;
  SetZoomPersistence(theToEnable: Standard_Boolean): void;
  ZoomPersistence(): Standard_Boolean;
  SetTransformPersistence(theTrsfPers: Handle_Graphic3d_TransformPers): void;
  ActiveMode(): AIS_ManipulatorMode;
  ActiveAxisIndex(): Graphic3d_ZLayerId;
  Position(): gp_Ax2;
  SetPosition(thePosition: gp_Ax2): void;
  Size(): Standard_ShortReal;
  SetSize(theSideLength: Standard_ShortReal): void;
  SetGap(theValue: Standard_ShortReal): void;
  SetTransformBehavior(theSettings: any): void;
  ChangeTransformBehavior(): any;
  TransformBehavior(): any;
  Compute(thePrsMgr: any, thePrs: any, theMode: Graphic3d_ZLayerId): void;
  ComputeSelection(theSelection: Handle_SelectMgr_Selection, theMode: Graphic3d_ZLayerId): void;
  IsAutoHilight(): Standard_Boolean;
  ClearSelected(): void;
  HilightSelected(thePM: any, theSeq: SelectMgr_SequenceOfOwner): void;
  HilightOwnerWithColor(thePM: any, theStyle: Handle_Prs3d_Drawer, theOwner: Handle_SelectMgr_EntityOwner): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class AIS_Manipulator_1 extends AIS_Manipulator {
    constructor();
  }

  export declare class AIS_Manipulator_2 extends AIS_Manipulator {
    constructor(thePosition: gp_Ax2);
  }

export declare class Handle_AIS_ManipulatorObjectSequence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ManipulatorObjectSequence): void;
  get(): AIS_ManipulatorObjectSequence;
  delete(): void;
}

  export declare class Handle_AIS_ManipulatorObjectSequence_1 extends Handle_AIS_ManipulatorObjectSequence {
    constructor();
  }

  export declare class Handle_AIS_ManipulatorObjectSequence_2 extends Handle_AIS_ManipulatorObjectSequence {
    constructor(thePtr: AIS_ManipulatorObjectSequence);
  }

  export declare class Handle_AIS_ManipulatorObjectSequence_3 extends Handle_AIS_ManipulatorObjectSequence {
    constructor(theHandle: Handle_AIS_ManipulatorObjectSequence);
  }

  export declare class Handle_AIS_ManipulatorObjectSequence_4 extends Handle_AIS_ManipulatorObjectSequence {
    constructor(theHandle: Handle_AIS_ManipulatorObjectSequence);
  }

export declare class Handle_AIS_Manipulator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Manipulator): void;
  get(): AIS_Manipulator;
  delete(): void;
}

  export declare class Handle_AIS_Manipulator_1 extends Handle_AIS_Manipulator {
    constructor();
  }

  export declare class Handle_AIS_Manipulator_2 extends Handle_AIS_Manipulator {
    constructor(thePtr: AIS_Manipulator);
  }

  export declare class Handle_AIS_Manipulator_3 extends Handle_AIS_Manipulator {
    constructor(theHandle: Handle_AIS_Manipulator);
  }

  export declare class Handle_AIS_Manipulator_4 extends Handle_AIS_Manipulator {
    constructor(theHandle: Handle_AIS_Manipulator);
  }

export declare class AIS_CameraFrustum extends AIS_InteractiveObject {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetCameraFrustum(theCamera: Handle_Graphic3d_Camera): void;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  UnsetTransparency(): void;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

export declare class AIS {
  constructor();
  delete(): void;
}

export declare class AIS_GraphicTool {
  constructor();
  static GetLineColor_1(aDrawer: Handle_Prs3d_Drawer, TheTypeOfAttributes: AIS_TypeOfAttribute): Quantity_NameOfColor;
  static GetLineColor_2(aDrawer: Handle_Prs3d_Drawer, TheTypeOfAttributes: AIS_TypeOfAttribute, TheLineColor: Quantity_Color): void;
  static GetLineWidth(aDrawer: Handle_Prs3d_Drawer, TheTypeOfAttributes: AIS_TypeOfAttribute): Quantity_AbsorbedDose;
  static GetLineType(aDrawer: Handle_Prs3d_Drawer, TheTypeOfAttributes: AIS_TypeOfAttribute): Aspect_TypeOfLine;
  static GetLineAtt(aDrawer: Handle_Prs3d_Drawer, TheTypeOfAttributes: AIS_TypeOfAttribute, aCol: Quantity_NameOfColor, aWidth: Quantity_AbsorbedDose, aTyp: Aspect_TypeOfLine): void;
  static GetInteriorColor_1(aDrawer: Handle_Prs3d_Drawer): Quantity_NameOfColor;
  static GetInteriorColor_2(aDrawer: Handle_Prs3d_Drawer, aColor: Quantity_Color): void;
  static GetMaterial(aDrawer: Handle_Prs3d_Drawer): Graphic3d_MaterialAspect;
  delete(): void;
}

export declare class Handle_AIS_TextLabel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_TextLabel): void;
  get(): AIS_TextLabel;
  delete(): void;
}

  export declare class Handle_AIS_TextLabel_1 extends Handle_AIS_TextLabel {
    constructor();
  }

  export declare class Handle_AIS_TextLabel_2 extends Handle_AIS_TextLabel {
    constructor(thePtr: AIS_TextLabel);
  }

  export declare class Handle_AIS_TextLabel_3 extends Handle_AIS_TextLabel {
    constructor(theHandle: Handle_AIS_TextLabel);
  }

  export declare class Handle_AIS_TextLabel_4 extends Handle_AIS_TextLabel {
    constructor(theHandle: Handle_AIS_TextLabel);
  }

export declare class AIS_TextLabel extends AIS_InteractiveObject {
  constructor()
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  SetColor(theColor: Quantity_Color): void;
  SetTransparency(theValue: Quantity_AbsorbedDose): void;
  UnsetTransparency(): void;
  SetMaterial(a0: Graphic3d_MaterialAspect): void;
  SetText(theText: TCollection_ExtendedString): void;
  SetPosition(thePosition: gp_Pnt): void;
  SetHJustification(theHJust: Graphic3d_HorizontalTextAlignment): void;
  SetVJustification(theVJust: Graphic3d_VerticalTextAlignment): void;
  SetAngle(theAngle: Quantity_AbsorbedDose): void;
  SetZoomable(theIsZoomable: Standard_Boolean): void;
  SetHeight(theHeight: Quantity_AbsorbedDose): void;
  SetFontAspect(theFontAspect: Font_FontAspect): void;
  SetFont(theFont: Standard_CString): void;
  SetOrientation3D(theOrientation: gp_Ax2): void;
  UnsetOrientation3D(): void;
  Position(): gp_Pnt;
  Text(): TCollection_ExtendedString;
  FontName(): XCAFDoc_PartId;
  FontAspect(): Font_FontAspect;
  Orientation3D(): gp_Ax2;
  HasOrientation3D(): Standard_Boolean;
  SetFlipping(theIsFlipping: Standard_Boolean): void;
  HasFlipping(): Standard_Boolean;
  HasOwnAnchorPoint(): Standard_Boolean;
  SetOwnAnchorPoint(theOwnAnchorPoint: Standard_Boolean): void;
  SetDisplayType(theDisplayType: Aspect_TypeOfDisplayText): void;
  SetColorSubTitle(theColor: Quantity_Color): void;
  TextFormatter(): Handle_Font_TextFormatter;
  SetTextFormatter(theFormatter: Handle_Font_TextFormatter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type AIS_ClearMode = {
  AIS_CM_All: {};
  AIS_CM_Interactive: {};
  AIS_CM_Filters: {};
  AIS_CM_StandardModes: {};
  AIS_CM_TemporaryShapePrs: {};
}

export declare type AIS_DisplayMode = {
  AIS_WireFrame: {};
  AIS_Shaded: {};
}

export declare class AIS_ColoredShape extends AIS_Shape {
  CustomAspects(theShape: TopoDS_Shape): Handle_AIS_ColoredDrawer;
  ClearCustomAspects(): void;
  UnsetCustomAspects(theShape: TopoDS_Shape, theToUnregister: Standard_Boolean): void;
  SetCustomColor(theShape: TopoDS_Shape, theColor: Quantity_Color): void;
  SetCustomTransparency(theShape: TopoDS_Shape, theTransparency: Quantity_AbsorbedDose): void;
  SetCustomWidth(theShape: TopoDS_Shape, theLineWidth: Quantity_AbsorbedDose): void;
  CustomAspectsMap(): AIS_DataMapOfShapeDrawer;
  ChangeCustomAspectsMap(): AIS_DataMapOfShapeDrawer;
  SetColor(theColor: Quantity_Color): void;
  SetWidth(theLineWidth: Quantity_AbsorbedDose): void;
  SetTransparency(theValue: Quantity_AbsorbedDose): void;
  SetMaterial(theAspect: Graphic3d_MaterialAspect): void;
  UnsetTransparency(): void;
  UnsetWidth(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class AIS_ColoredShape_1 extends AIS_ColoredShape {
    constructor(theShape: TopoDS_Shape);
  }

  export declare class AIS_ColoredShape_2 extends AIS_ColoredShape {
    constructor(theShape: Handle_AIS_Shape);
  }

export declare class Handle_AIS_ColoredShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ColoredShape): void;
  get(): AIS_ColoredShape;
  delete(): void;
}

  export declare class Handle_AIS_ColoredShape_1 extends Handle_AIS_ColoredShape {
    constructor();
  }

  export declare class Handle_AIS_ColoredShape_2 extends Handle_AIS_ColoredShape {
    constructor(thePtr: AIS_ColoredShape);
  }

  export declare class Handle_AIS_ColoredShape_3 extends Handle_AIS_ColoredShape {
    constructor(theHandle: Handle_AIS_ColoredShape);
  }

  export declare class Handle_AIS_ColoredShape_4 extends Handle_AIS_ColoredShape {
    constructor(theHandle: Handle_AIS_ColoredShape);
  }

export declare class AIS_Circle extends AIS_InteractiveObject {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  Circle(): Handle_Geom_Circle;
  Parameters(theU1: Quantity_AbsorbedDose, theU2: Quantity_AbsorbedDose): void;
  SetCircle(theCircle: Handle_Geom_Circle): void;
  SetFirstParam(theU: Quantity_AbsorbedDose): void;
  SetLastParam(theU: Quantity_AbsorbedDose): void;
  SetColor(aColor: Quantity_Color): void;
  SetWidth(aValue: Quantity_AbsorbedDose): void;
  UnsetColor(): void;
  UnsetWidth(): void;
  IsFilledCircleSens(): Standard_Boolean;
  SetFilledCircleSens(theIsFilledCircleSens: Standard_Boolean): void;
  delete(): void;
}

  export declare class AIS_Circle_1 extends AIS_Circle {
    constructor(aCircle: Handle_Geom_Circle);
  }

  export declare class AIS_Circle_2 extends AIS_Circle {
    constructor(theCircle: Handle_Geom_Circle, theUStart: Quantity_AbsorbedDose, theUEnd: Quantity_AbsorbedDose, theIsFilledCircleSens: Standard_Boolean);
  }

export declare class Handle_AIS_Circle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_Circle): void;
  get(): AIS_Circle;
  delete(): void;
}

  export declare class Handle_AIS_Circle_1 extends Handle_AIS_Circle {
    constructor();
  }

  export declare class Handle_AIS_Circle_2 extends Handle_AIS_Circle {
    constructor(thePtr: AIS_Circle);
  }

  export declare class Handle_AIS_Circle_3 extends Handle_AIS_Circle {
    constructor(theHandle: Handle_AIS_Circle);
  }

  export declare class Handle_AIS_Circle_4 extends Handle_AIS_Circle {
    constructor(theHandle: Handle_AIS_Circle);
  }

export declare class Handle_AIS_AnimationCamera {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_AnimationCamera): void;
  get(): AIS_AnimationCamera;
  delete(): void;
}

  export declare class Handle_AIS_AnimationCamera_1 extends Handle_AIS_AnimationCamera {
    constructor();
  }

  export declare class Handle_AIS_AnimationCamera_2 extends Handle_AIS_AnimationCamera {
    constructor(thePtr: AIS_AnimationCamera);
  }

  export declare class Handle_AIS_AnimationCamera_3 extends Handle_AIS_AnimationCamera {
    constructor(theHandle: Handle_AIS_AnimationCamera);
  }

  export declare class Handle_AIS_AnimationCamera_4 extends Handle_AIS_AnimationCamera {
    constructor(theHandle: Handle_AIS_AnimationCamera);
  }

export declare class AIS_AnimationCamera extends AIS_Animation {
  constructor(theAnimationName: XCAFDoc_PartId, theView: Handle_V3d_View)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  View(): Handle_V3d_View;
  SetView(theView: Handle_V3d_View): void;
  CameraStart(): Handle_Graphic3d_Camera;
  SetCameraStart(theCameraStart: Handle_Graphic3d_Camera): void;
  CameraEnd(): Handle_Graphic3d_Camera;
  SetCameraEnd(theCameraEnd: Handle_Graphic3d_Camera): void;
  delete(): void;
}

export declare type AIS_NavigationMode = {
  AIS_NavigationMode_Orbit: {};
  AIS_NavigationMode_FirstPersonFlight: {};
  AIS_NavigationMode_FirstPersonWalk: {};
}

export declare class Handle_AIS_SignatureFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_SignatureFilter): void;
  get(): AIS_SignatureFilter;
  delete(): void;
}

  export declare class Handle_AIS_SignatureFilter_1 extends Handle_AIS_SignatureFilter {
    constructor();
  }

  export declare class Handle_AIS_SignatureFilter_2 extends Handle_AIS_SignatureFilter {
    constructor(thePtr: AIS_SignatureFilter);
  }

  export declare class Handle_AIS_SignatureFilter_3 extends Handle_AIS_SignatureFilter {
    constructor(theHandle: Handle_AIS_SignatureFilter);
  }

  export declare class Handle_AIS_SignatureFilter_4 extends Handle_AIS_SignatureFilter {
    constructor(theHandle: Handle_AIS_SignatureFilter);
  }

export declare class AIS_SignatureFilter extends AIS_TypeFilter {
  constructor(aGivenKind: AIS_KindOfInteractive, aGivenSignature: Graphic3d_ZLayerId)
  IsOk(anobj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class AIS_PlaneTrihedron extends AIS_InteractiveObject {
  constructor(aPlane: Handle_Geom_Plane)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Component(): Handle_Geom_Plane;
  SetComponent(aPlane: Handle_Geom_Plane): void;
  XAxis(): Handle_AIS_Line;
  YAxis(): Handle_AIS_Line;
  Position(): Handle_AIS_Point;
  SetLength(theLength: Quantity_AbsorbedDose): void;
  GetLength(): Quantity_AbsorbedDose;
  AcceptDisplayMode(aMode: Graphic3d_ZLayerId): Standard_Boolean;
  Signature(): Graphic3d_ZLayerId;
  Type(): AIS_KindOfInteractive;
  SetColor(theColor: Quantity_Color): void;
  SetXLabel(theLabel: XCAFDoc_PartId): void;
  SetYLabel(theLabel: XCAFDoc_PartId): void;
  delete(): void;
}

export declare class Handle_AIS_PlaneTrihedron {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_PlaneTrihedron): void;
  get(): AIS_PlaneTrihedron;
  delete(): void;
}

  export declare class Handle_AIS_PlaneTrihedron_1 extends Handle_AIS_PlaneTrihedron {
    constructor();
  }

  export declare class Handle_AIS_PlaneTrihedron_2 extends Handle_AIS_PlaneTrihedron {
    constructor(thePtr: AIS_PlaneTrihedron);
  }

  export declare class Handle_AIS_PlaneTrihedron_3 extends Handle_AIS_PlaneTrihedron {
    constructor(theHandle: Handle_AIS_PlaneTrihedron);
  }

  export declare class Handle_AIS_PlaneTrihedron_4 extends Handle_AIS_PlaneTrihedron {
    constructor(theHandle: Handle_AIS_PlaneTrihedron);
  }

export declare type AIS_RotationMode = {
  AIS_RotationMode_BndBoxActive: {};
  AIS_RotationMode_PickLast: {};
  AIS_RotationMode_PickCenter: {};
  AIS_RotationMode_CameraAt: {};
  AIS_RotationMode_BndBoxScene: {};
}

export declare class Handle_AIS_ExclusionFilter {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_ExclusionFilter): void;
  get(): AIS_ExclusionFilter;
  delete(): void;
}

  export declare class Handle_AIS_ExclusionFilter_1 extends Handle_AIS_ExclusionFilter {
    constructor();
  }

  export declare class Handle_AIS_ExclusionFilter_2 extends Handle_AIS_ExclusionFilter {
    constructor(thePtr: AIS_ExclusionFilter);
  }

  export declare class Handle_AIS_ExclusionFilter_3 extends Handle_AIS_ExclusionFilter {
    constructor(theHandle: Handle_AIS_ExclusionFilter);
  }

  export declare class Handle_AIS_ExclusionFilter_4 extends Handle_AIS_ExclusionFilter {
    constructor(theHandle: Handle_AIS_ExclusionFilter);
  }

export declare class AIS_ExclusionFilter extends SelectMgr_Filter {
  IsOk(anObj: Handle_SelectMgr_EntityOwner): Standard_Boolean;
  Add_1(TypeToExclude: AIS_KindOfInteractive): Standard_Boolean;
  Add_2(TypeToExclude: AIS_KindOfInteractive, SignatureInType: Graphic3d_ZLayerId): Standard_Boolean;
  Remove_1(TypeToExclude: AIS_KindOfInteractive): Standard_Boolean;
  Remove_2(TypeToExclude: AIS_KindOfInteractive, SignatureInType: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  IsExclusionFlagOn(): Standard_Boolean;
  SetExclusionFlag(Status: Standard_Boolean): void;
  IsStored(aType: AIS_KindOfInteractive): Standard_Boolean;
  ListOfStoredTypes(TheList: TColStd_ListOfInteger): void;
  ListOfSignature(aType: AIS_KindOfInteractive, TheStoredList: TColStd_ListOfInteger): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class AIS_ExclusionFilter_1 extends AIS_ExclusionFilter {
    constructor(ExclusionFlagOn: Standard_Boolean);
  }

  export declare class AIS_ExclusionFilter_2 extends AIS_ExclusionFilter {
    constructor(TypeToExclude: AIS_KindOfInteractive, ExclusionFlagOn: Standard_Boolean);
  }

  export declare class AIS_ExclusionFilter_3 extends AIS_ExclusionFilter {
    constructor(TypeToExclude: AIS_KindOfInteractive, SignatureInType: Graphic3d_ZLayerId, ExclusionFlagOn: Standard_Boolean);
  }

export declare type AIS_ViewSelectionTool = {
  AIS_ViewSelectionTool_Picking: {};
  AIS_ViewSelectionTool_RubberBand: {};
  AIS_ViewSelectionTool_Polygon: {};
  AIS_ViewSelectionTool_ZoomWindow: {};
}

export declare type AIS_ViewInputBufferType = {
  AIS_ViewInputBufferType_UI: {};
  AIS_ViewInputBufferType_GL: {};
}

export declare class AIS_ViewInputBuffer {
  constructor()
  Reset(): void;
  delete(): void;
}

export declare type AIS_MouseGesture = {
  AIS_MouseGesture_NONE: {};
  AIS_MouseGesture_SelectRectangle: {};
  AIS_MouseGesture_SelectLasso: {};
  AIS_MouseGesture_Zoom: {};
  AIS_MouseGesture_ZoomWindow: {};
  AIS_MouseGesture_Pan: {};
  AIS_MouseGesture_RotateOrbit: {};
  AIS_MouseGesture_RotateView: {};
}

export declare type AIS_SelectionModesConcurrency = {
  AIS_SelectionModesConcurrency_Single: {};
  AIS_SelectionModesConcurrency_GlobalOrLocal: {};
  AIS_SelectionModesConcurrency_Multiple: {};
}

export declare type AIS_TypeOfAttribute = {
  AIS_TOA_Line: {};
  AIS_TOA_Dimension: {};
  AIS_TOA_Wire: {};
  AIS_TOA_Plane: {};
  AIS_TOA_Vector: {};
  AIS_TOA_UIso: {};
  AIS_TOA_VIso: {};
  AIS_TOA_Free: {};
  AIS_TOA_UnFree: {};
  AIS_TOA_Section: {};
  AIS_TOA_Hidden: {};
  AIS_TOA_Seen: {};
  AIS_TOA_FaceBoundary: {};
  AIS_TOA_FirstAxis: {};
  AIS_TOA_SecondAxis: {};
  AIS_TOA_ThirdAxis: {};
}

export declare type AIS_KindOfInteractive = {
  AIS_KOI_None: {};
  AIS_KOI_Datum: {};
  AIS_KOI_Shape: {};
  AIS_KOI_Object: {};
  AIS_KOI_Relation: {};
  AIS_KOI_Dimension: {};
}

export declare class Handle_AIS_TexturedShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AIS_TexturedShape): void;
  get(): AIS_TexturedShape;
  delete(): void;
}

  export declare class Handle_AIS_TexturedShape_1 extends Handle_AIS_TexturedShape {
    constructor();
  }

  export declare class Handle_AIS_TexturedShape_2 extends Handle_AIS_TexturedShape {
    constructor(thePtr: AIS_TexturedShape);
  }

  export declare class Handle_AIS_TexturedShape_3 extends Handle_AIS_TexturedShape {
    constructor(theHandle: Handle_AIS_TexturedShape);
  }

  export declare class Handle_AIS_TexturedShape_4 extends Handle_AIS_TexturedShape {
    constructor(theHandle: Handle_AIS_TexturedShape);
  }

export declare class AIS_TexturedShape extends AIS_Shape {
  constructor(theShape: TopoDS_Shape)
  SetTextureFileName(theTextureFileName: XCAFDoc_PartId): void;
  SetTexturePixMap(theTexturePixMap: Handle_Image_PixMap): void;
  TextureMapState(): Standard_Boolean;
  SetTextureMapOn(): void;
  SetTextureMapOff(): void;
  TextureFile(): Standard_CString;
  TexturePixMap(): Handle_Image_PixMap;
  UpdateAttributes(): void;
  SetColor(theColor: Quantity_Color): void;
  UnsetColor(): void;
  SetMaterial(theAspect: Graphic3d_MaterialAspect): void;
  UnsetMaterial(): void;
  EnableTextureModulate(): void;
  DisableTextureModulate(): void;
  TextureRepeat(): Standard_Boolean;
  URepeat(): Quantity_AbsorbedDose;
  VRepeat(): Quantity_AbsorbedDose;
  SetTextureRepeat(theToRepeat: Standard_Boolean, theURepeat: Quantity_AbsorbedDose, theVRepeat: Quantity_AbsorbedDose): void;
  TextureOrigin(): Standard_Boolean;
  TextureUOrigin(): Quantity_AbsorbedDose;
  TextureVOrigin(): Quantity_AbsorbedDose;
  SetTextureOrigin(theToSetTextureOrigin: Standard_Boolean, theUOrigin: Quantity_AbsorbedDose, theVOrigin: Quantity_AbsorbedDose): void;
  TextureScale(): Standard_Boolean;
  TextureScaleU(): Quantity_AbsorbedDose;
  TextureScaleV(): Quantity_AbsorbedDose;
  SetTextureScale(theToSetTextureScale: Standard_Boolean, theScaleU: Quantity_AbsorbedDose, theScaleV: Quantity_AbsorbedDose): void;
  ShowTriangles_1(): Standard_Boolean;
  ShowTriangles_2(theToShowTriangles: Standard_Boolean): void;
  TextureModulate(): Standard_Boolean;
  AcceptDisplayMode(theMode: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinObjMgt_RRelocationTable extends TColStd_DataMapOfIntegerTransient {
  constructor();
  GetHeaderData(): Handle_Storage_HeaderData;
  SetHeaderData(theHeaderData: Handle_Storage_HeaderData): void;
  Clear(doReleaseMemory: Standard_Boolean): void;
  delete(): void;
}

export declare class BinObjMgt_Persistent {
  constructor()
  PutCharacter(theValue: Standard_Character): BinObjMgt_Persistent;
  PutByte(theValue: Standard_Byte): BinObjMgt_Persistent;
  PutExtCharacter(theValue: Standard_ExtCharacter): BinObjMgt_Persistent;
  PutInteger(theValue: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  PutBoolean(theValue: Standard_Boolean): BinObjMgt_Persistent;
  PutReal(theValue: Quantity_AbsorbedDose): BinObjMgt_Persistent;
  PutShortReal(theValue: Standard_ShortReal): BinObjMgt_Persistent;
  PutCString(theValue: Standard_CString): BinObjMgt_Persistent;
  PutAsciiString(theValue: XCAFDoc_PartId): BinObjMgt_Persistent;
  PutExtendedString(theValue: TCollection_ExtendedString): BinObjMgt_Persistent;
  PutLabel(theValue: TDF_Label): BinObjMgt_Persistent;
  PutGUID(theValue: Standard_GUID): BinObjMgt_Persistent;
  PutCharArray(theArray: BinObjMgt_PChar, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  PutByteArray(theArray: BinObjMgt_PByte, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  PutExtCharArray(theArray: BinObjMgt_PExtChar, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  PutIntArray(theArray: BinObjMgt_PInteger, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  PutRealArray(theArray: BinObjMgt_PReal, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  PutShortRealArray(theArray: BinObjMgt_PShortReal, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetCharacter(theValue: Standard_Character): BinObjMgt_Persistent;
  GetByte(theValue: Standard_Byte): BinObjMgt_Persistent;
  GetExtCharacter(theValue: Standard_ExtCharacter): BinObjMgt_Persistent;
  GetInteger(theValue: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetBoolean(theValue: Standard_Boolean): BinObjMgt_Persistent;
  GetReal(theValue: Quantity_AbsorbedDose): BinObjMgt_Persistent;
  GetShortReal(theValue: Standard_ShortReal): BinObjMgt_Persistent;
  GetAsciiString(theValue: XCAFDoc_PartId): BinObjMgt_Persistent;
  GetExtendedString(theValue: TCollection_ExtendedString): BinObjMgt_Persistent;
  GetLabel(theDS: Handle_TDF_Data, theValue: TDF_Label): BinObjMgt_Persistent;
  GetGUID(theValue: Standard_GUID): BinObjMgt_Persistent;
  GetCharArray(theArray: BinObjMgt_PChar, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetByteArray(theArray: BinObjMgt_PByte, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetExtCharArray(theArray: BinObjMgt_PExtChar, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetIntArray(theArray: BinObjMgt_PInteger, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetRealArray(theArray: BinObjMgt_PReal, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  GetShortRealArray(theArray: BinObjMgt_PShortReal, theLength: Graphic3d_ZLayerId): BinObjMgt_Persistent;
  Position(): Graphic3d_ZLayerId;
  SetPosition(thePos: Graphic3d_ZLayerId): Standard_Boolean;
  Truncate(): void;
  IsError(): Standard_Boolean;
  IsOK(): Standard_Boolean;
  Init(): void;
  SetId(theId: Graphic3d_ZLayerId): void;
  SetTypeId(theId: Graphic3d_ZLayerId): void;
  Id(): Graphic3d_ZLayerId;
  TypeId(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  Destroy(): void;
  delete(): void;
}

export declare class IMeshTools_MeshAlgo extends Standard_Transient {
  Perform(theDFace: any, theParameters: IMeshTools_Parameters, theRange: Message_ProgressRange): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshTools_ShapeExplorer extends IMeshData_Shape {
  constructor(theShape: TopoDS_Shape)
  Accept(theVisitor: any): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshTools_Context extends IMeshData_Shape {
  constructor()
  BuildModel(): Standard_Boolean;
  DiscretizeEdges(): Standard_Boolean;
  HealModel(): Standard_Boolean;
  PreProcessModel(): Standard_Boolean;
  DiscretizeFaces(theRange: Message_ProgressRange): Standard_Boolean;
  PostProcessModel(): Standard_Boolean;
  Clean(): void;
  GetModelBuilder(): any;
  SetModelBuilder(theBuilder: any): void;
  GetEdgeDiscret(): any;
  SetEdgeDiscret(theEdgeDiscret: any): void;
  GetModelHealer(): any;
  SetModelHealer(theModelHealer: any): void;
  GetPreProcessor(): any;
  SetPreProcessor(thePreProcessor: any): void;
  GetFaceDiscret(): any;
  SetFaceDiscret(theFaceDiscret: any): void;
  GetPostProcessor(): any;
  SetPostProcessor(thePostProcessor: any): void;
  GetParameters(): IMeshTools_Parameters;
  ChangeParameters(): IMeshTools_Parameters;
  GetModel(): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshTools_ModelAlgo extends Standard_Transient {
  Perform(theModel: any, theParameters: IMeshTools_Parameters, theRange: Message_ProgressRange): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshTools_ModelBuilder extends Message_Algorithm {
  Perform(theShape: TopoDS_Shape, theParameters: IMeshTools_Parameters): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshTools_CurveTessellator extends Standard_Transient {
  PointsNb(): Graphic3d_ZLayerId;
  Value(theIndex: Graphic3d_ZLayerId, thePoint: gp_Pnt, theParameter: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IMeshTools_MeshBuilder extends Message_Algorithm {
  SetContext(theContext: any): void;
  GetContext(): any;
  Perform(theRange: Message_ProgressRange): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class IMeshTools_MeshBuilder_1 extends IMeshTools_MeshBuilder {
    constructor();
  }

  export declare class IMeshTools_MeshBuilder_2 extends IMeshTools_MeshBuilder {
    constructor(theContext: any);
  }

export declare class IMeshTools_Parameters {
  constructor()
  static RelMinSize(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class IMeshTools_ShapeVisitor extends Standard_Transient {
  Visit_1(theFace: TopoDS_Face): void;
  Visit_2(theEdge: TopoDS_Edge): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type IMeshTools_MeshAlgoType = {
  IMeshTools_MeshAlgoType_DEFAULT: {};
  IMeshTools_MeshAlgoType_Watson: {};
  IMeshTools_MeshAlgoType_Delabella: {};
}

export declare class IMeshTools_MeshAlgoFactory extends Standard_Transient {
  GetAlgo(theSurfaceType: GeomAbs_SurfaceType, theParameters: IMeshTools_Parameters): any;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class CPnts_AbscissaPoint {
  static Length_1(C: Adaptor3d_Curve): Quantity_AbsorbedDose;
  static Length_2(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static Length_3(C: Adaptor3d_Curve, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_4(C: Adaptor2d_Curve2d, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_5(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_6(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_7(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Length_8(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Init_1(C: Adaptor3d_Curve): void;
  Init_2(C: Adaptor2d_Curve2d): void;
  Init_3(C: Adaptor3d_Curve, Tol: Quantity_AbsorbedDose): void;
  Init_4(C: Adaptor2d_Curve2d, Tol: Quantity_AbsorbedDose): void;
  Init_5(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  Init_6(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  Init_7(C: Adaptor3d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Init_8(C: Adaptor2d_Curve2d, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_1(Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose): void;
  Perform_2(Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose): void;
  AdvPerform(Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Parameter(): Quantity_AbsorbedDose;
  SetParameter(P: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class CPnts_AbscissaPoint_1 extends CPnts_AbscissaPoint {
    constructor();
  }

  export declare class CPnts_AbscissaPoint_2 extends CPnts_AbscissaPoint {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose);
  }

  export declare class CPnts_AbscissaPoint_3 extends CPnts_AbscissaPoint {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose);
  }

  export declare class CPnts_AbscissaPoint_4 extends CPnts_AbscissaPoint {
    constructor(C: Adaptor3d_Curve, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose);
  }

  export declare class CPnts_AbscissaPoint_5 extends CPnts_AbscissaPoint {
    constructor(C: Adaptor2d_Curve2d, Abscissa: Quantity_AbsorbedDose, U0: Quantity_AbsorbedDose, Ui: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose);
  }

export declare class CPnts_MyRootFunction extends math_FunctionWithDerivative {
  constructor()
  Init_1(F: CPnts_RealFunction, D: Standard_Address, Order: Graphic3d_ZLayerId): void;
  Init_2(X0: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose): void;
  Init_3(X0: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, Df: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, Df: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class CPnts_UniformDeflection {
  Initialize_1(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Initialize_2(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Initialize_3(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  Initialize_4(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean): void;
  IsAllDone(): Standard_Boolean;
  Next(): void;
  More(): Standard_Boolean;
  Value(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  delete(): void;
}

  export declare class CPnts_UniformDeflection_1 extends CPnts_UniformDeflection {
    constructor();
  }

  export declare class CPnts_UniformDeflection_2 extends CPnts_UniformDeflection {
    constructor(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

  export declare class CPnts_UniformDeflection_3 extends CPnts_UniformDeflection {
    constructor(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

  export declare class CPnts_UniformDeflection_4 extends CPnts_UniformDeflection {
    constructor(C: Adaptor3d_Curve, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

  export declare class CPnts_UniformDeflection_5 extends CPnts_UniformDeflection {
    constructor(C: Adaptor2d_Curve2d, Deflection: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Resolution: Quantity_AbsorbedDose, WithControl: Standard_Boolean);
  }

export declare class CPnts_MyGaussFunction extends math_Function {
  constructor()
  Init(F: CPnts_RealFunction, D: Standard_Address): void;
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class TopoDS_Solid extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class Handle_TopoDS_FrozenShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_FrozenShape): void;
  get(): TopoDS_FrozenShape;
  delete(): void;
}

  export declare class Handle_TopoDS_FrozenShape_1 extends Handle_TopoDS_FrozenShape {
    constructor();
  }

  export declare class Handle_TopoDS_FrozenShape_2 extends Handle_TopoDS_FrozenShape {
    constructor(thePtr: TopoDS_FrozenShape);
  }

  export declare class Handle_TopoDS_FrozenShape_3 extends Handle_TopoDS_FrozenShape {
    constructor(theHandle: Handle_TopoDS_FrozenShape);
  }

  export declare class Handle_TopoDS_FrozenShape_4 extends Handle_TopoDS_FrozenShape {
    constructor(theHandle: Handle_TopoDS_FrozenShape);
  }

export declare class TopoDS_FrozenShape extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_TopoDS_FrozenShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopoDS_FrozenShape_1 extends TopoDS_FrozenShape {
    constructor();
  }

  export declare class TopoDS_FrozenShape_2 extends TopoDS_FrozenShape {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_TopoDS_TVertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TVertex): void;
  get(): TopoDS_TVertex;
  delete(): void;
}

  export declare class Handle_TopoDS_TVertex_1 extends Handle_TopoDS_TVertex {
    constructor();
  }

  export declare class Handle_TopoDS_TVertex_2 extends Handle_TopoDS_TVertex {
    constructor(thePtr: TopoDS_TVertex);
  }

  export declare class Handle_TopoDS_TVertex_3 extends Handle_TopoDS_TVertex {
    constructor(theHandle: Handle_TopoDS_TVertex);
  }

  export declare class Handle_TopoDS_TVertex_4 extends Handle_TopoDS_TVertex {
    constructor(theHandle: Handle_TopoDS_TVertex);
  }

export declare class TopoDS_TVertex extends TopoDS_TShape {
  ShapeType(): TopAbs_ShapeEnum;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TopoDS_TCompSolid extends TopoDS_TShape {
  constructor()
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopoDS_TCompSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TCompSolid): void;
  get(): TopoDS_TCompSolid;
  delete(): void;
}

  export declare class Handle_TopoDS_TCompSolid_1 extends Handle_TopoDS_TCompSolid {
    constructor();
  }

  export declare class Handle_TopoDS_TCompSolid_2 extends Handle_TopoDS_TCompSolid {
    constructor(thePtr: TopoDS_TCompSolid);
  }

  export declare class Handle_TopoDS_TCompSolid_3 extends Handle_TopoDS_TCompSolid {
    constructor(theHandle: Handle_TopoDS_TCompSolid);
  }

  export declare class Handle_TopoDS_TCompSolid_4 extends Handle_TopoDS_TCompSolid {
    constructor(theHandle: Handle_TopoDS_TCompSolid);
  }

export declare class TopoDS_AlertAttribute extends Message_AttributeStream {
  constructor(theShape: TopoDS_Shape, theName: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetShape(): TopoDS_Shape;
  static Send(theMessenger: Handle_Message_Messenger, theShape: TopoDS_Shape): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopoDS_Shell extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class TopoDS_CompSolid extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class TopoDS_AlertWithShape extends Message_Alert {
  constructor(theShape: TopoDS_Shape)
  GetShape(): TopoDS_Shape;
  SetShape(theShape: TopoDS_Shape): void;
  SupportsMerge(): Standard_Boolean;
  Merge(theTarget: Handle_Message_Alert): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TopoDS_Shape {
  constructor()
  IsNull(): Standard_Boolean;
  Nullify(): void;
  Location_1(): TopLoc_Location;
  Location_2(theLoc: TopLoc_Location): void;
  Located(theLoc: TopLoc_Location): TopoDS_Shape;
  Orientation_1(): TopAbs_Orientation;
  Orientation_2(theOrient: TopAbs_Orientation): void;
  Oriented(theOrient: TopAbs_Orientation): TopoDS_Shape;
  TShape_1(): Handle_TopoDS_TShape;
  ShapeType(): TopAbs_ShapeEnum;
  Free_1(): Standard_Boolean;
  Free_2(theIsFree: Standard_Boolean): void;
  Locked_1(): Standard_Boolean;
  Locked_2(theIsLocked: Standard_Boolean): void;
  Modified_1(): Standard_Boolean;
  Modified_2(theIsModified: Standard_Boolean): void;
  Checked_1(): Standard_Boolean;
  Checked_2(theIsChecked: Standard_Boolean): void;
  Orientable_1(): Standard_Boolean;
  Orientable_2(theIsOrientable: Standard_Boolean): void;
  Closed_1(): Standard_Boolean;
  Closed_2(theIsClosed: Standard_Boolean): void;
  Infinite_1(): Standard_Boolean;
  Infinite_2(theIsInfinite: Standard_Boolean): void;
  Convex_1(): Standard_Boolean;
  Convex_2(theIsConvex: Standard_Boolean): void;
  Move(thePosition: TopLoc_Location): void;
  Moved(thePosition: TopLoc_Location): TopoDS_Shape;
  Reverse(): void;
  Reversed(): TopoDS_Shape;
  Complement(): void;
  Complemented(): TopoDS_Shape;
  Compose(theOrient: TopAbs_Orientation): void;
  Composed(theOrient: TopAbs_Orientation): TopoDS_Shape;
  NbChildren(): Graphic3d_ZLayerId;
  IsPartner(theOther: TopoDS_Shape): Standard_Boolean;
  IsSame(theOther: TopoDS_Shape): Standard_Boolean;
  IsEqual(theOther: TopoDS_Shape): Standard_Boolean;
  IsNotEqual(theOther: TopoDS_Shape): Standard_Boolean;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  EmptyCopy(): void;
  EmptyCopied(): TopoDS_Shape;
  TShape_2(theTShape: Handle_TopoDS_TShape): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_TopoDS_TShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TShell): void;
  get(): TopoDS_TShell;
  delete(): void;
}

  export declare class Handle_TopoDS_TShell_1 extends Handle_TopoDS_TShell {
    constructor();
  }

  export declare class Handle_TopoDS_TShell_2 extends Handle_TopoDS_TShell {
    constructor(thePtr: TopoDS_TShell);
  }

  export declare class Handle_TopoDS_TShell_3 extends Handle_TopoDS_TShell {
    constructor(theHandle: Handle_TopoDS_TShell);
  }

  export declare class Handle_TopoDS_TShell_4 extends Handle_TopoDS_TShell {
    constructor(theHandle: Handle_TopoDS_TShell);
  }

export declare class TopoDS_TShell extends TopoDS_TShape {
  constructor()
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopoDS_TFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TFace): void;
  get(): TopoDS_TFace;
  delete(): void;
}

  export declare class Handle_TopoDS_TFace_1 extends Handle_TopoDS_TFace {
    constructor();
  }

  export declare class Handle_TopoDS_TFace_2 extends Handle_TopoDS_TFace {
    constructor(thePtr: TopoDS_TFace);
  }

  export declare class Handle_TopoDS_TFace_3 extends Handle_TopoDS_TFace {
    constructor(theHandle: Handle_TopoDS_TFace);
  }

  export declare class Handle_TopoDS_TFace_4 extends Handle_TopoDS_TFace {
    constructor(theHandle: Handle_TopoDS_TFace);
  }

export declare class TopoDS_TFace extends TopoDS_TShape {
  constructor()
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TopoDS_LockedShape extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_TopoDS_LockedShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopoDS_LockedShape_1 extends TopoDS_LockedShape {
    constructor();
  }

  export declare class TopoDS_LockedShape_2 extends TopoDS_LockedShape {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_TopoDS_LockedShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_LockedShape): void;
  get(): TopoDS_LockedShape;
  delete(): void;
}

  export declare class Handle_TopoDS_LockedShape_1 extends Handle_TopoDS_LockedShape {
    constructor();
  }

  export declare class Handle_TopoDS_LockedShape_2 extends Handle_TopoDS_LockedShape {
    constructor(thePtr: TopoDS_LockedShape);
  }

  export declare class Handle_TopoDS_LockedShape_3 extends Handle_TopoDS_LockedShape {
    constructor(theHandle: Handle_TopoDS_LockedShape);
  }

  export declare class Handle_TopoDS_LockedShape_4 extends Handle_TopoDS_LockedShape {
    constructor(theHandle: Handle_TopoDS_LockedShape);
  }

export declare class TopoDS_TCompound extends TopoDS_TShape {
  constructor()
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopoDS_TCompound {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TCompound): void;
  get(): TopoDS_TCompound;
  delete(): void;
}

  export declare class Handle_TopoDS_TCompound_1 extends Handle_TopoDS_TCompound {
    constructor();
  }

  export declare class Handle_TopoDS_TCompound_2 extends Handle_TopoDS_TCompound {
    constructor(thePtr: TopoDS_TCompound);
  }

  export declare class Handle_TopoDS_TCompound_3 extends Handle_TopoDS_TCompound {
    constructor(theHandle: Handle_TopoDS_TCompound);
  }

  export declare class Handle_TopoDS_TCompound_4 extends Handle_TopoDS_TCompound {
    constructor(theHandle: Handle_TopoDS_TCompound);
  }

export declare class TopoDS_TShape extends Standard_Transient {
  Free_1(): Standard_Boolean;
  Free_2(theIsFree: Standard_Boolean): void;
  Locked_1(): Standard_Boolean;
  Locked_2(theIsLocked: Standard_Boolean): void;
  Modified_1(): Standard_Boolean;
  Modified_2(theIsModified: Standard_Boolean): void;
  Checked_1(): Standard_Boolean;
  Checked_2(theIsChecked: Standard_Boolean): void;
  Orientable_1(): Standard_Boolean;
  Orientable_2(theIsOrientable: Standard_Boolean): void;
  Closed_1(): Standard_Boolean;
  Closed_2(theIsClosed: Standard_Boolean): void;
  Infinite_1(): Standard_Boolean;
  Infinite_2(theIsInfinite: Standard_Boolean): void;
  Convex_1(): Standard_Boolean;
  Convex_2(theIsConvex: Standard_Boolean): void;
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  NbChildren(): Graphic3d_ZLayerId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopoDS_TShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TShape): void;
  get(): TopoDS_TShape;
  delete(): void;
}

  export declare class Handle_TopoDS_TShape_1 extends Handle_TopoDS_TShape {
    constructor();
  }

  export declare class Handle_TopoDS_TShape_2 extends Handle_TopoDS_TShape {
    constructor(thePtr: TopoDS_TShape);
  }

  export declare class Handle_TopoDS_TShape_3 extends Handle_TopoDS_TShape {
    constructor(theHandle: Handle_TopoDS_TShape);
  }

  export declare class Handle_TopoDS_TShape_4 extends Handle_TopoDS_TShape {
    constructor(theHandle: Handle_TopoDS_TShape);
  }

export declare class TopoDS_Face extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class TopoDS_TEdge extends TopoDS_TShape {
  ShapeType(): TopAbs_ShapeEnum;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopoDS_TEdge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TEdge): void;
  get(): TopoDS_TEdge;
  delete(): void;
}

  export declare class Handle_TopoDS_TEdge_1 extends Handle_TopoDS_TEdge {
    constructor();
  }

  export declare class Handle_TopoDS_TEdge_2 extends Handle_TopoDS_TEdge {
    constructor(thePtr: TopoDS_TEdge);
  }

  export declare class Handle_TopoDS_TEdge_3 extends Handle_TopoDS_TEdge {
    constructor(theHandle: Handle_TopoDS_TEdge);
  }

  export declare class Handle_TopoDS_TEdge_4 extends Handle_TopoDS_TEdge {
    constructor(theHandle: Handle_TopoDS_TEdge);
  }

export declare class TopoDS_Builder {
  constructor();
  MakeWire(W: TopoDS_Wire): void;
  MakeShell(S: TopoDS_Shell): void;
  MakeSolid(S: TopoDS_Solid): void;
  MakeCompSolid(C: TopoDS_CompSolid): void;
  MakeCompound(C: TopoDS_Compound): void;
  Add(S: TopoDS_Shape, C: TopoDS_Shape): void;
  Remove(S: TopoDS_Shape, C: TopoDS_Shape): void;
  delete(): void;
}

export declare class TopoDS_UnCompatibleShapes extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_TopoDS_UnCompatibleShapes;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopoDS_UnCompatibleShapes_1 extends TopoDS_UnCompatibleShapes {
    constructor();
  }

  export declare class TopoDS_UnCompatibleShapes_2 extends TopoDS_UnCompatibleShapes {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_TopoDS_UnCompatibleShapes {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_UnCompatibleShapes): void;
  get(): TopoDS_UnCompatibleShapes;
  delete(): void;
}

  export declare class Handle_TopoDS_UnCompatibleShapes_1 extends Handle_TopoDS_UnCompatibleShapes {
    constructor();
  }

  export declare class Handle_TopoDS_UnCompatibleShapes_2 extends Handle_TopoDS_UnCompatibleShapes {
    constructor(thePtr: TopoDS_UnCompatibleShapes);
  }

  export declare class Handle_TopoDS_UnCompatibleShapes_3 extends Handle_TopoDS_UnCompatibleShapes {
    constructor(theHandle: Handle_TopoDS_UnCompatibleShapes);
  }

  export declare class Handle_TopoDS_UnCompatibleShapes_4 extends Handle_TopoDS_UnCompatibleShapes {
    constructor(theHandle: Handle_TopoDS_UnCompatibleShapes);
  }

export declare class TopoDS_TSolid extends TopoDS_TShape {
  constructor()
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TopoDS_TSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TSolid): void;
  get(): TopoDS_TSolid;
  delete(): void;
}

  export declare class Handle_TopoDS_TSolid_1 extends Handle_TopoDS_TSolid {
    constructor();
  }

  export declare class Handle_TopoDS_TSolid_2 extends Handle_TopoDS_TSolid {
    constructor(thePtr: TopoDS_TSolid);
  }

  export declare class Handle_TopoDS_TSolid_3 extends Handle_TopoDS_TSolid {
    constructor(theHandle: Handle_TopoDS_TSolid);
  }

  export declare class Handle_TopoDS_TSolid_4 extends Handle_TopoDS_TSolid {
    constructor(theHandle: Handle_TopoDS_TSolid);
  }

export declare class TopoDS_Edge extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class TopoDS {
  constructor();
  static Vertex_1(S: TopoDS_Shape): TopoDS_Vertex;
  static Vertex_2(a0: TopoDS_Shape): TopoDS_Vertex;
  static Edge_1(S: TopoDS_Shape): TopoDS_Edge;
  static Edge_2(a0: TopoDS_Shape): TopoDS_Edge;
  static Wire_1(S: TopoDS_Shape): TopoDS_Wire;
  static Wire_2(a0: TopoDS_Shape): TopoDS_Wire;
  static Face_1(S: TopoDS_Shape): TopoDS_Face;
  static Face_2(a0: TopoDS_Shape): TopoDS_Face;
  static Shell_1(S: TopoDS_Shape): TopoDS_Shell;
  static Shell_2(a0: TopoDS_Shape): TopoDS_Shell;
  static Solid_1(S: TopoDS_Shape): TopoDS_Solid;
  static Solid_2(a0: TopoDS_Shape): TopoDS_Solid;
  static CompSolid_1(S: TopoDS_Shape): TopoDS_CompSolid;
  static CompSolid_2(a0: TopoDS_Shape): TopoDS_CompSolid;
  static Compound_1(S: TopoDS_Shape): TopoDS_Compound;
  static Compound_2(a0: TopoDS_Shape): TopoDS_Compound;
  delete(): void;
}

export declare class Handle_TopoDS_TWire {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_TWire): void;
  get(): TopoDS_TWire;
  delete(): void;
}

  export declare class Handle_TopoDS_TWire_1 extends Handle_TopoDS_TWire {
    constructor();
  }

  export declare class Handle_TopoDS_TWire_2 extends Handle_TopoDS_TWire {
    constructor(thePtr: TopoDS_TWire);
  }

  export declare class Handle_TopoDS_TWire_3 extends Handle_TopoDS_TWire {
    constructor(theHandle: Handle_TopoDS_TWire);
  }

  export declare class Handle_TopoDS_TWire_4 extends Handle_TopoDS_TWire {
    constructor(theHandle: Handle_TopoDS_TWire);
  }

export declare class TopoDS_TWire extends TopoDS_TShape {
  constructor()
  ShapeType(): TopAbs_ShapeEnum;
  EmptyCopy(): Handle_TopoDS_TShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TopoDS_Wire extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class Handle_TopoDS_HShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TopoDS_HShape): void;
  get(): TopoDS_HShape;
  delete(): void;
}

  export declare class Handle_TopoDS_HShape_1 extends Handle_TopoDS_HShape {
    constructor();
  }

  export declare class Handle_TopoDS_HShape_2 extends Handle_TopoDS_HShape {
    constructor(thePtr: TopoDS_HShape);
  }

  export declare class Handle_TopoDS_HShape_3 extends Handle_TopoDS_HShape {
    constructor(theHandle: Handle_TopoDS_HShape);
  }

  export declare class Handle_TopoDS_HShape_4 extends Handle_TopoDS_HShape {
    constructor(theHandle: Handle_TopoDS_HShape);
  }

export declare class TopoDS_HShape extends Standard_Transient {
  Shape_1(aShape: TopoDS_Shape): void;
  Shape_2(): TopoDS_Shape;
  ChangeShape(): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class TopoDS_HShape_1 extends TopoDS_HShape {
    constructor();
  }

  export declare class TopoDS_HShape_2 extends TopoDS_HShape {
    constructor(aShape: TopoDS_Shape);
  }

export declare class TopoDS_Vertex extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class TopoDS_Iterator {
  Initialize(S: TopoDS_Shape, cumOri: Standard_Boolean, cumLoc: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): TopoDS_Shape;
  delete(): void;
}

  export declare class TopoDS_Iterator_1 extends TopoDS_Iterator {
    constructor();
  }

  export declare class TopoDS_Iterator_2 extends TopoDS_Iterator {
    constructor(S: TopoDS_Shape, cumOri: Standard_Boolean, cumLoc: Standard_Boolean);
  }

export declare class TopoDS_Compound extends TopoDS_Shape {
  constructor()
  delete(): void;
}

export declare class GeomInt_ResConstraintOfMyGradientOfTheComputeLineBezierOfWLApprox {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, SCurv: AppParCurves_MultiCurve, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, Constraints: Handle_AppParCurves_HArray1OfConstraintCouple, Bern: math_Matrix, DerivativeBern: math_Matrix, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ConstraintMatrix(): math_Matrix;
  Duale(): math_Vector;
  ConstraintDerivative(SSP: GeomInt_TheMultiLineOfWLApprox, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, DA: math_Matrix): math_Matrix;
  InverseMatrix(): math_Matrix;
  delete(): void;
}

export declare class GeomInt {
  constructor();
  static AdjustPeriodic(thePar: Quantity_AbsorbedDose, theParMin: Quantity_AbsorbedDose, theParMax: Quantity_AbsorbedDose, thePeriod: Quantity_AbsorbedDose, theNewPar: Quantity_AbsorbedDose, theOffset: Quantity_AbsorbedDose, theEps: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class GeomInt_Gradient_BFGSOfMyGradientOfTheComputeLineBezierOfWLApprox extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class GeomInt_BSpParFunctionOfMyBSplGradientOfTheComputeLineOfWLApprox extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NbPol: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiBSpCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  Index(): math_IntegerVector;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  SetFirstLambda(l1: Quantity_AbsorbedDose): void;
  SetLastLambda(l2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomInt_MyGradientOfTheComputeLineBezierOfWLApprox {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GeomInt_WLApprox {
  constructor()
  SetParameters(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, DegMin: Graphic3d_ZLayerId, DegMax: Graphic3d_ZLayerId, NbIterMax: Graphic3d_ZLayerId, NbPntMax: Graphic3d_ZLayerId, ApproxWithTangency: Standard_Boolean, Parametrization: Approx_ParametrizationType): void;
  TolReached3d(): Quantity_AbsorbedDose;
  TolReached2d(): Quantity_AbsorbedDose;
  IsDone(): Standard_Boolean;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiBSpCurve;
  delete(): void;
}

export declare class GeomInt_IntSS {
  Perform_1(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose, Approx: Standard_Boolean, ApproxS1: Standard_Boolean, ApproxS2: Standard_Boolean): void;
  Perform_2(HS1: Handle_GeomAdaptor_HSurface, HS2: Handle_GeomAdaptor_HSurface, Tol: Quantity_AbsorbedDose, Approx: Standard_Boolean, ApproxS1: Standard_Boolean, ApproxS2: Standard_Boolean): void;
  Perform_3(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Approx: Standard_Boolean, ApproxS1: Standard_Boolean, ApproxS2: Standard_Boolean): void;
  Perform_4(HS1: Handle_GeomAdaptor_HSurface, HS2: Handle_GeomAdaptor_HSurface, Tol: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, Approx: Standard_Boolean, ApproxS1: Standard_Boolean, ApproxS2: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  TolReached3d(): Quantity_AbsorbedDose;
  TolReached2d(): Quantity_AbsorbedDose;
  NbLines(): Graphic3d_ZLayerId;
  Line(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  HasLineOnS1(Index: Graphic3d_ZLayerId): Standard_Boolean;
  LineOnS1(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  HasLineOnS2(Index: Graphic3d_ZLayerId): Standard_Boolean;
  LineOnS2(Index: Graphic3d_ZLayerId): Handle_Geom2d_Curve;
  NbBoundaries(): Graphic3d_ZLayerId;
  Boundary(Index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  NbPoints(): Graphic3d_ZLayerId;
  Point(Index: Graphic3d_ZLayerId): gp_Pnt;
  Pnt2d(Index: Graphic3d_ZLayerId, OnFirst: Standard_Boolean): gp_Pnt2d;
  static TreatRLine(theRL: Handle_IntPatch_RLine, theHS1: Handle_GeomAdaptor_HSurface, theHS2: Handle_GeomAdaptor_HSurface, theC3d: Handle_Geom_Curve, theC2d1: Handle_Geom2d_Curve, theC2d2: Handle_Geom2d_Curve, theTolReached: Quantity_AbsorbedDose): void;
  static BuildPCurves(f: Quantity_AbsorbedDose, l: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, S: Handle_Geom_Surface, C: Handle_Geom_Curve, C2d: Handle_Geom2d_Curve): void;
  static TrimILineOnSurfBoundaries(theC2d1: Handle_Geom2d_Curve, theC2d2: Handle_Geom2d_Curve, theBound1: Bnd_Box2d, theBound2: Bnd_Box2d, theArrayOfParameters: GeomInt_VectorOfReal): void;
  static MakeBSpline(WL: Handle_IntPatch_WLine, ideb: Graphic3d_ZLayerId, ifin: Graphic3d_ZLayerId): Handle_Geom_Curve;
  static MakeBSpline2d(theWLine: Handle_IntPatch_WLine, ideb: Graphic3d_ZLayerId, ifin: Graphic3d_ZLayerId, onFirst: Standard_Boolean): Handle_Geom2d_BSplineCurve;
  delete(): void;
}

  export declare class GeomInt_IntSS_1 extends GeomInt_IntSS {
    constructor();
  }

  export declare class GeomInt_IntSS_2 extends GeomInt_IntSS {
    constructor(S1: Handle_Geom_Surface, S2: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose, Approx: Standard_Boolean, ApproxS1: Standard_Boolean, ApproxS2: Standard_Boolean);
  }

export declare class GeomInt_SequenceOfParameterAndOrientation extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: GeomInt_SequenceOfParameterAndOrientation): GeomInt_SequenceOfParameterAndOrientation;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: GeomInt_ParameterAndOrientation): void;
  Append_2(theSeq: GeomInt_SequenceOfParameterAndOrientation): void;
  Prepend_1(theItem: GeomInt_ParameterAndOrientation): void;
  Prepend_2(theSeq: GeomInt_SequenceOfParameterAndOrientation): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: GeomInt_ParameterAndOrientation): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: GeomInt_SequenceOfParameterAndOrientation): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: GeomInt_SequenceOfParameterAndOrientation): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: GeomInt_ParameterAndOrientation): void;
  Split(theIndex: Standard_Integer, theSeq: GeomInt_SequenceOfParameterAndOrientation): void;
  First(): GeomInt_ParameterAndOrientation;
  ChangeFirst(): GeomInt_ParameterAndOrientation;
  Last(): GeomInt_ParameterAndOrientation;
  ChangeLast(): GeomInt_ParameterAndOrientation;
  Value(theIndex: Standard_Integer): GeomInt_ParameterAndOrientation;
  ChangeValue(theIndex: Standard_Integer): GeomInt_ParameterAndOrientation;
  SetValue(theIndex: Standard_Integer, theItem: GeomInt_ParameterAndOrientation): void;
  delete(): void;
}

  export declare class GeomInt_SequenceOfParameterAndOrientation_1 extends GeomInt_SequenceOfParameterAndOrientation {
    constructor();
  }

  export declare class GeomInt_SequenceOfParameterAndOrientation_2 extends GeomInt_SequenceOfParameterAndOrientation {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class GeomInt_SequenceOfParameterAndOrientation_3 extends GeomInt_SequenceOfParameterAndOrientation {
    constructor(theOther: GeomInt_SequenceOfParameterAndOrientation);
  }

export declare class GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_1 extends GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_2 extends GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_3 extends GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_4 extends GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class GeomInt_LineConstructor {
  constructor()
  Load(D1: Handle_Adaptor3d_TopolTool, D2: Handle_Adaptor3d_TopolTool, S1: Handle_GeomAdaptor_HSurface, S2: Handle_GeomAdaptor_HSurface): void;
  Perform(L: Handle_IntPatch_Line): void;
  IsDone(): Standard_Boolean;
  NbParts(): Graphic3d_ZLayerId;
  Part(I: Graphic3d_ZLayerId, WFirst: Quantity_AbsorbedDose, WLast: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class GeomInt_BSpGradient_BFGSOfMyBSplGradientOfTheComputeLineOfWLApprox extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class GeomInt_LineTool {
  constructor();
  static NbVertex(L: Handle_IntPatch_Line): Graphic3d_ZLayerId;
  static Vertex(L: Handle_IntPatch_Line, I: Graphic3d_ZLayerId): IntPatch_Point;
  static FirstParameter(L: Handle_IntPatch_Line): Quantity_AbsorbedDose;
  static LastParameter(L: Handle_IntPatch_Line): Quantity_AbsorbedDose;
  static DecompositionOfWLine(theWLine: Handle_IntPatch_WLine, theSurface1: Handle_GeomAdaptor_HSurface, theSurface2: Handle_GeomAdaptor_HSurface, aTolSum: Quantity_AbsorbedDose, theLConstructor: GeomInt_LineConstructor, theNewLines: IntPatch_SequenceOfLine): Standard_Boolean;
  delete(): void;
}

export declare class GeomInt_TheMultiLineOfWLApprox {
  FirstPoint(): Graphic3d_ZLayerId;
  LastPoint(): Graphic3d_ZLayerId;
  NbP2d(): Graphic3d_ZLayerId;
  NbP3d(): Graphic3d_ZLayerId;
  WhatStatus(): Approx_Status;
  Value_1(MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt): void;
  Value_2(MPointIndex: Graphic3d_ZLayerId, tabPt2d: TColgp_Array1OfPnt2d): void;
  Value_3(MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt, tabPt2d: TColgp_Array1OfPnt2d): void;
  Tangency_1(MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  Tangency_2(MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  Tangency_3(MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  MakeMLBetween(Low: Graphic3d_ZLayerId, High: Graphic3d_ZLayerId, NbPointsToInsert: Graphic3d_ZLayerId): GeomInt_TheMultiLineOfWLApprox;
  MakeMLOneMorePoint(Low: Graphic3d_ZLayerId, High: Graphic3d_ZLayerId, indbad: Graphic3d_ZLayerId, OtherLine: GeomInt_TheMultiLineOfWLApprox): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

  export declare class GeomInt_TheMultiLineOfWLApprox_1 extends GeomInt_TheMultiLineOfWLApprox {
    constructor();
  }

  export declare class GeomInt_TheMultiLineOfWLApprox_2 extends GeomInt_TheMultiLineOfWLApprox {
    constructor(line: Handle_IntPatch_WLine, PtrSvSurfaces: Standard_Address, NbP3d: Graphic3d_ZLayerId, NbP2d: Graphic3d_ZLayerId, ApproxU1V1: Standard_Boolean, ApproxU2V2: Standard_Boolean, xo: Quantity_AbsorbedDose, yo: Quantity_AbsorbedDose, zo: Quantity_AbsorbedDose, u1o: Quantity_AbsorbedDose, v1o: Quantity_AbsorbedDose, u2o: Quantity_AbsorbedDose, v2o: Quantity_AbsorbedDose, P2DOnFirst: Standard_Boolean, IndMin: Graphic3d_ZLayerId, IndMax: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_TheMultiLineOfWLApprox_3 extends GeomInt_TheMultiLineOfWLApprox {
    constructor(line: Handle_IntPatch_WLine, NbP3d: Graphic3d_ZLayerId, NbP2d: Graphic3d_ZLayerId, ApproxU1V1: Standard_Boolean, ApproxU2V2: Standard_Boolean, xo: Quantity_AbsorbedDose, yo: Quantity_AbsorbedDose, zo: Quantity_AbsorbedDose, u1o: Quantity_AbsorbedDose, v1o: Quantity_AbsorbedDose, u2o: Quantity_AbsorbedDose, v2o: Quantity_AbsorbedDose, P2DOnFirst: Standard_Boolean, IndMin: Graphic3d_ZLayerId, IndMax: Graphic3d_ZLayerId);
  }

export declare class GeomInt_ParFunctionOfMyGradientbisOfTheComputeLineOfWLApprox extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox {
  Perform_1(Param: TColStd_Array1OfReal, Rsnld: math_FunctionSetRoot): IntImp_ConstIsoparametric;
  Perform_2(Param: TColStd_Array1OfReal, Rsnld: math_FunctionSetRoot, ChoixIso: IntImp_ConstIsoparametric): IntImp_ConstIsoparametric;
  IsDone(): Standard_Boolean;
  IsEmpty(): Standard_Boolean;
  Point(): IntSurf_PntOn2S;
  IsTangent(): Standard_Boolean;
  Direction(): gp_Dir;
  DirectionOnS1(): gp_Dir2d;
  DirectionOnS2(): gp_Dir2d;
  Function(): GeomInt_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfWLApprox;
  ChangePoint(): IntSurf_PntOn2S;
  delete(): void;
}

  export declare class GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox_1 extends GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox {
    constructor(Param: TColStd_Array1OfReal, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, TolTangency: Quantity_AbsorbedDose);
  }

  export declare class GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox_2 extends GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox {
    constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, TolTangency: Quantity_AbsorbedDose);
  }

export declare class GeomInt_TheImpPrmSvSurfacesOfWLApprox extends ApproxInt_SvSurfaces {
  Compute(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Pt: gp_Pnt, Tg: gp_Vec, Tguv1: gp_Vec2d, Tguv2: gp_Vec2d): Standard_Boolean;
  Pnt(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, P: gp_Pnt): void;
  SeekPoint(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Point: IntSurf_PntOn2S): Standard_Boolean;
  Tangency(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec): Standard_Boolean;
  TangencyOnSurf1(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  TangencyOnSurf2(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  FillInitialVectorOfSolution(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, binfu: Quantity_AbsorbedDose, bsupu: Quantity_AbsorbedDose, binfv: Quantity_AbsorbedDose, bsupv: Quantity_AbsorbedDose, X: math_Vector, TranslationU: Quantity_AbsorbedDose, TranslationV: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class GeomInt_TheImpPrmSvSurfacesOfWLApprox_1 extends GeomInt_TheImpPrmSvSurfacesOfWLApprox {
    constructor(Surf1: Handle_Adaptor3d_HSurface, Surf2: IntSurf_Quadric);
  }

  export declare class GeomInt_TheImpPrmSvSurfacesOfWLApprox_2 extends GeomInt_TheImpPrmSvSurfacesOfWLApprox {
    constructor(Surf1: IntSurf_Quadric, Surf2: Handle_Adaptor3d_HSurface);
  }

export declare class GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_1 extends GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_2 extends GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_3 extends GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_4 extends GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox extends math_FunctionSetWithDerivatives {
  Set_1(PS: Handle_Adaptor3d_HSurface): void;
  SetImplicitSurface(IS: IntSurf_Quadric): void;
  Set_2(Tolerance: Quantity_AbsorbedDose): void;
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Tolerance(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(): Standard_Boolean;
  Direction3d(): gp_Vec;
  Direction2d(): gp_Dir2d;
  PSurface(): Handle_Adaptor3d_HSurface;
  ISurface(): IntSurf_Quadric;
  delete(): void;
}

  export declare class GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_1 extends GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox {
    constructor();
  }

  export declare class GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_2 extends GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox {
    constructor(PS: Handle_Adaptor3d_HSurface, IS: IntSurf_Quadric);
  }

  export declare class GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_3 extends GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox {
    constructor(IS: IntSurf_Quadric);
  }

export declare class GeomInt_TheComputeLineOfWLApprox {
  Interpol(Line: GeomInt_TheMultiLineOfWLApprox): void;
  Init(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean): void;
  Perform(Line: GeomInt_TheMultiLineOfWLApprox): void;
  SetParameters(ThePar: math_Vector): void;
  SetKnots(Knots: TColStd_Array1OfReal): void;
  SetKnotsAndMultiplicities(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetContinuity(C: Graphic3d_ZLayerId): void;
  SetConstraints(firstC: AppParCurves_Constraint, lastC: AppParCurves_Constraint): void;
  SetPeriodic(thePeriodic: Standard_Boolean): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  Value(): AppParCurves_MultiBSpCurve;
  ChangeValue(): AppParCurves_MultiBSpCurve;
  Parameters_1(): TColStd_Array1OfReal;
  delete(): void;
}

  export declare class GeomInt_TheComputeLineOfWLApprox_1 extends GeomInt_TheComputeLineOfWLApprox {
    constructor(Line: GeomInt_TheMultiLineOfWLApprox, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

  export declare class GeomInt_TheComputeLineOfWLApprox_2 extends GeomInt_TheComputeLineOfWLApprox {
    constructor(Line: GeomInt_TheMultiLineOfWLApprox, Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class GeomInt_TheComputeLineOfWLApprox_3 extends GeomInt_TheComputeLineOfWLApprox {
    constructor(Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class GeomInt_TheComputeLineOfWLApprox_4 extends GeomInt_TheComputeLineOfWLApprox {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

export declare class GeomInt_VectorOfReal extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: GeomInt_VectorOfReal, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: Standard_Real): Standard_Real;
  Appended(): Standard_Real;
  Value(theIndex: Standard_Integer): Standard_Real;
  First(): Standard_Real;
  ChangeFirst(): Standard_Real;
  Last(): Standard_Real;
  ChangeLast(): Standard_Real;
  ChangeValue(theIndex: Standard_Integer): Standard_Real;
  SetValue(theIndex: Standard_Integer, theValue: Standard_Real): Standard_Real;
  delete(): void;
}

  export declare class GeomInt_VectorOfReal_1 extends GeomInt_VectorOfReal {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class GeomInt_VectorOfReal_2 extends GeomInt_VectorOfReal {
    constructor(theOther: GeomInt_VectorOfReal);
  }

export declare class GeomInt_ParameterAndOrientation {
  SetOrientation1(Or: TopAbs_Orientation): void;
  SetOrientation2(Or: TopAbs_Orientation): void;
  Parameter(): Quantity_AbsorbedDose;
  Orientation1(): TopAbs_Orientation;
  Orientation2(): TopAbs_Orientation;
  delete(): void;
}

  export declare class GeomInt_ParameterAndOrientation_1 extends GeomInt_ParameterAndOrientation {
    constructor();
  }

  export declare class GeomInt_ParameterAndOrientation_2 extends GeomInt_ParameterAndOrientation {
    constructor(P: Quantity_AbsorbedDose, Or1: TopAbs_Orientation, Or2: TopAbs_Orientation);
  }

export declare class GeomInt_ThePrmPrmSvSurfacesOfWLApprox extends ApproxInt_SvSurfaces {
  constructor(Surf1: Handle_Adaptor3d_HSurface, Surf2: Handle_Adaptor3d_HSurface)
  Compute(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Pt: gp_Pnt, Tg: gp_Vec, Tguv1: gp_Vec2d, Tguv2: gp_Vec2d): Standard_Boolean;
  Pnt(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, P: gp_Pnt): void;
  SeekPoint(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Point: IntSurf_PntOn2S): Standard_Boolean;
  Tangency(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec): Standard_Boolean;
  TangencyOnSurf1(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  TangencyOnSurf2(u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, Tg: gp_Vec2d): Standard_Boolean;
  delete(): void;
}

export declare class GeomInt_TheComputeLineBezierOfWLApprox {
  Init(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean): void;
  Perform(Line: GeomInt_TheMultiLineOfWLApprox): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetConstraints(firstC: AppParCurves_Constraint, lastC: AppParCurves_Constraint): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(Index: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  ChangeValue(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  SplineValue(): AppParCurves_MultiBSpCurve;
  Parametrization(): Approx_ParametrizationType;
  Parameters_1(Index: Graphic3d_ZLayerId): TColStd_Array1OfReal;
  delete(): void;
}

  export declare class GeomInt_TheComputeLineBezierOfWLApprox_1 extends GeomInt_TheComputeLineBezierOfWLApprox {
    constructor(Line: GeomInt_TheMultiLineOfWLApprox, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

  export declare class GeomInt_TheComputeLineBezierOfWLApprox_2 extends GeomInt_TheComputeLineBezierOfWLApprox {
    constructor(Line: GeomInt_TheMultiLineOfWLApprox, Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class GeomInt_TheComputeLineBezierOfWLApprox_3 extends GeomInt_TheComputeLineBezierOfWLApprox {
    constructor(Parameters: math_Vector, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, Squares: Standard_Boolean);
  }

  export declare class GeomInt_TheComputeLineBezierOfWLApprox_4 extends GeomInt_TheComputeLineBezierOfWLApprox {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, cutting: Standard_Boolean, parametrization: Approx_ParametrizationType, Squares: Standard_Boolean);
  }

export declare class GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox {
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiBSpCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox_1 extends GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox_2 extends GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, lambda1: Quantity_AbsorbedDose, lambda2: Quantity_AbsorbedDose);
  }

export declare class GeomInt_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfWLApprox extends math_FunctionSetWithDerivatives {
  constructor(S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  ComputeParameters(ChoixIso: IntImp_ConstIsoparametric, Param: TColStd_Array1OfReal, UVap: math_Vector, BornInf: math_Vector, BornSup: math_Vector, Tolerance: math_Vector): void;
  Root(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  IsTangent(UVap: math_Vector, Param: TColStd_Array1OfReal, BestChoix: IntImp_ConstIsoparametric): Standard_Boolean;
  Direction(): gp_Dir;
  DirectionOnS1(): gp_Dir2d;
  DirectionOnS2(): gp_Dir2d;
  AuxillarSurface1(): Handle_Adaptor3d_HSurface;
  AuxillarSurface2(): Handle_Adaptor3d_HSurface;
  delete(): void;
}

export declare class GeomInt_ResConstraintOfMyGradientbisOfTheComputeLineOfWLApprox {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, SCurv: AppParCurves_MultiCurve, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, Constraints: Handle_AppParCurves_HArray1OfConstraintCouple, Bern: math_Matrix, DerivativeBern: math_Matrix, Tolerance: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  ConstraintMatrix(): math_Matrix;
  Duale(): math_Vector;
  ConstraintDerivative(SSP: GeomInt_TheMultiLineOfWLApprox, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, DA: math_Matrix): math_Matrix;
  InverseMatrix(): math_Matrix;
  delete(): void;
}

export declare class GeomInt_ParFunctionOfMyGradientOfTheComputeLineBezierOfWLApprox extends math_MultipleVarFunctionWithGradient {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId)
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  NewParameters(): math_Vector;
  CurveValue(): AppParCurves_MultiCurve;
  Error(IPoint: Graphic3d_ZLayerId, CurveIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  FirstConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, FirstPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  LastConstraint(TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, LastPoint: Graphic3d_ZLayerId): AppParCurves_Constraint;
  delete(): void;
}

export declare class GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox {
  Perform_1(Parameters: math_Vector): void;
  Perform_2(Parameters: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_3(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  Perform_4(Parameters: math_Vector, V1t: math_Vector, V2t: math_Vector, V1c: math_Vector, V2c: math_Vector, l1: Quantity_AbsorbedDose, l2: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  BezierValue(): AppParCurves_MultiCurve;
  BSplineValue(): AppParCurves_MultiBSpCurve;
  FunctionMatrix(): math_Matrix;
  DerivativeFunctionMatrix(): math_Matrix;
  ErrorGradient(Grad: math_Vector, F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  Distance(): math_Matrix;
  Error(F: Quantity_AbsorbedDose, MaxE3d: Quantity_AbsorbedDose, MaxE2d: Quantity_AbsorbedDose): void;
  FirstLambda(): Quantity_AbsorbedDose;
  LastLambda(): Quantity_AbsorbedDose;
  Points(): math_Matrix;
  Poles(): math_Matrix;
  KIndex(): math_IntegerVector;
  delete(): void;
}

  export declare class GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_1 extends GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_2 extends GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_3 extends GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, Parameters: math_Vector, NbPol: Graphic3d_ZLayerId);
  }

  export declare class GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_4 extends GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox {
    constructor(SSP: GeomInt_TheMultiLineOfWLApprox, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, FirstCons: AppParCurves_Constraint, LastCons: AppParCurves_Constraint, NbPol: Graphic3d_ZLayerId);
  }

export declare class GeomInt_MyGradientbisOfTheComputeLineOfWLApprox {
  constructor(SSP: GeomInt_TheMultiLineOfWLApprox, FirstPoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId, TheConstraints: Handle_AppParCurves_HArray1OfConstraintCouple, Parameters: math_Vector, Deg: Graphic3d_ZLayerId, Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Value(): AppParCurves_MultiCurve;
  Error(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  MaxError3d(): Quantity_AbsorbedDose;
  MaxError2d(): Quantity_AbsorbedDose;
  AverageError(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class GeomInt_TheMultiLineToolOfWLApprox {
  constructor();
  static FirstPoint(ML: GeomInt_TheMultiLineOfWLApprox): Graphic3d_ZLayerId;
  static LastPoint(ML: GeomInt_TheMultiLineOfWLApprox): Graphic3d_ZLayerId;
  static NbP2d(ML: GeomInt_TheMultiLineOfWLApprox): Graphic3d_ZLayerId;
  static NbP3d(ML: GeomInt_TheMultiLineOfWLApprox): Graphic3d_ZLayerId;
  static Value_1(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt): void;
  static Value_2(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabPt2d: TColgp_Array1OfPnt2d): void;
  static Value_3(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabPt: TColgp_Array1OfPnt, tabPt2d: TColgp_Array1OfPnt2d): void;
  static Tangency_1(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  static Tangency_2(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Tangency_3(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Curvature_1(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec): Standard_Boolean;
  static Curvature_2(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static Curvature_3(ML: GeomInt_TheMultiLineOfWLApprox, MPointIndex: Graphic3d_ZLayerId, tabV: TColgp_Array1OfVec, tabV2d: TColgp_Array1OfVec2d): Standard_Boolean;
  static MakeMLBetween(ML: GeomInt_TheMultiLineOfWLApprox, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, NbPMin: Graphic3d_ZLayerId): GeomInt_TheMultiLineOfWLApprox;
  static MakeMLOneMorePoint(ML: GeomInt_TheMultiLineOfWLApprox, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, indbad: Graphic3d_ZLayerId, OtherLine: GeomInt_TheMultiLineOfWLApprox): Standard_Boolean;
  static WhatStatus(ML: GeomInt_TheMultiLineOfWLApprox, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId): Approx_Status;
  static Dump(ML: GeomInt_TheMultiLineOfWLApprox): void;
  delete(): void;
}

export declare class GeomInt_Gradient_BFGSOfMyGradientbisOfTheComputeLineOfWLApprox extends math_BFGS {
  constructor(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, Eps: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId)
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  delete(): void;
}

export declare class LProp_SequenceOfCIType extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: LProp_SequenceOfCIType): LProp_SequenceOfCIType;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: LProp_CIType): void;
  Append_2(theSeq: LProp_SequenceOfCIType): void;
  Prepend_1(theItem: LProp_CIType): void;
  Prepend_2(theSeq: LProp_SequenceOfCIType): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: LProp_CIType): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: LProp_SequenceOfCIType): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: LProp_SequenceOfCIType): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: LProp_CIType): void;
  Split(theIndex: Standard_Integer, theSeq: LProp_SequenceOfCIType): void;
  First(): LProp_CIType;
  ChangeFirst(): LProp_CIType;
  Last(): LProp_CIType;
  ChangeLast(): LProp_CIType;
  Value(theIndex: Standard_Integer): LProp_CIType;
  ChangeValue(theIndex: Standard_Integer): LProp_CIType;
  SetValue(theIndex: Standard_Integer, theItem: LProp_CIType): void;
  delete(): void;
}

  export declare class LProp_SequenceOfCIType_1 extends LProp_SequenceOfCIType {
    constructor();
  }

  export declare class LProp_SequenceOfCIType_2 extends LProp_SequenceOfCIType {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class LProp_SequenceOfCIType_3 extends LProp_SequenceOfCIType {
    constructor(theOther: LProp_SequenceOfCIType);
  }

export declare class LProp_CurAndInf {
  constructor()
  AddInflection(Param: Quantity_AbsorbedDose): void;
  AddExtCur(Param: Quantity_AbsorbedDose, IsMin: Standard_Boolean): void;
  Clear(): void;
  IsEmpty(): Standard_Boolean;
  NbPoints(): Graphic3d_ZLayerId;
  Parameter(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Type(N: Graphic3d_ZLayerId): LProp_CIType;
  delete(): void;
}

export declare type LProp_CIType = {
  LProp_Inflection: {};
  LProp_MinCur: {};
  LProp_MaxCur: {};
}

export declare class LProp_NotDefined extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_LProp_NotDefined;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class LProp_NotDefined_1 extends LProp_NotDefined {
    constructor();
  }

  export declare class LProp_NotDefined_2 extends LProp_NotDefined {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_LProp_NotDefined {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: LProp_NotDefined): void;
  get(): LProp_NotDefined;
  delete(): void;
}

  export declare class Handle_LProp_NotDefined_1 extends Handle_LProp_NotDefined {
    constructor();
  }

  export declare class Handle_LProp_NotDefined_2 extends Handle_LProp_NotDefined {
    constructor(thePtr: LProp_NotDefined);
  }

  export declare class Handle_LProp_NotDefined_3 extends Handle_LProp_NotDefined {
    constructor(theHandle: Handle_LProp_NotDefined);
  }

  export declare class Handle_LProp_NotDefined_4 extends Handle_LProp_NotDefined {
    constructor(theHandle: Handle_LProp_NotDefined);
  }

export declare class Handle_LProp_BadContinuity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: LProp_BadContinuity): void;
  get(): LProp_BadContinuity;
  delete(): void;
}

  export declare class Handle_LProp_BadContinuity_1 extends Handle_LProp_BadContinuity {
    constructor();
  }

  export declare class Handle_LProp_BadContinuity_2 extends Handle_LProp_BadContinuity {
    constructor(thePtr: LProp_BadContinuity);
  }

  export declare class Handle_LProp_BadContinuity_3 extends Handle_LProp_BadContinuity {
    constructor(theHandle: Handle_LProp_BadContinuity);
  }

  export declare class Handle_LProp_BadContinuity_4 extends Handle_LProp_BadContinuity {
    constructor(theHandle: Handle_LProp_BadContinuity);
  }

export declare class LProp_BadContinuity extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_LProp_BadContinuity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class LProp_BadContinuity_1 extends LProp_BadContinuity {
    constructor();
  }

  export declare class LProp_BadContinuity_2 extends LProp_BadContinuity {
    constructor(theMessage: Standard_CString);
  }

export declare class LProp_AnalyticCurInf {
  constructor()
  Perform(T: GeomAbs_CurveType, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, Result: LProp_CurAndInf): void;
  delete(): void;
}

export declare type LProp_Status = {
  LProp_Undecided: {};
  LProp_Undefined: {};
  LProp_Defined: {};
  LProp_Computed: {};
}

export declare class BSplCLib {
  constructor();
  static Hunt(theArray: TColStd_Array1OfReal, theX: Quantity_AbsorbedDose, theXPos: Graphic3d_ZLayerId): void;
  static FirstUKnotIndex(Degree: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger): Graphic3d_ZLayerId;
  static LastUKnotIndex(Degree: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger): Graphic3d_ZLayerId;
  static FlatIndex(Degree: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger, Periodic: Standard_Boolean): Graphic3d_ZLayerId;
  static LocateParameter_1(Degree: Graphic3d_ZLayerId, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, U: Quantity_AbsorbedDose, IsPeriodic: Standard_Boolean, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, KnotIndex: Graphic3d_ZLayerId, NewU: Quantity_AbsorbedDose): void;
  static LocateParameter_2(Degree: Graphic3d_ZLayerId, Knots: TColStd_Array1OfReal, U: Quantity_AbsorbedDose, IsPeriodic: Standard_Boolean, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, KnotIndex: Graphic3d_ZLayerId, NewU: Quantity_AbsorbedDose): void;
  static LocateParameter_3(Degree: Graphic3d_ZLayerId, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, U: Quantity_AbsorbedDose, Periodic: Standard_Boolean, Index: Graphic3d_ZLayerId, NewU: Quantity_AbsorbedDose): void;
  static MaxKnotMult(Mults: TColStd_Array1OfInteger, K1: Graphic3d_ZLayerId, K2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static MinKnotMult(Mults: TColStd_Array1OfInteger, K1: Graphic3d_ZLayerId, K2: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static NbPoles(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Mults: TColStd_Array1OfInteger): Graphic3d_ZLayerId;
  static KnotSequenceLength(Mults: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean): Graphic3d_ZLayerId;
  static KnotSequence_1(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, KnotSeq: TColStd_Array1OfReal, Periodic: Standard_Boolean): void;
  static KnotSequence_2(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, KnotSeq: TColStd_Array1OfReal): void;
  static KnotsLength(KnotSeq: TColStd_Array1OfReal, Periodic: Standard_Boolean): Graphic3d_ZLayerId;
  static Knots(KnotSeq: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Periodic: Standard_Boolean): void;
  static KnotForm(Knots: TColStd_Array1OfReal, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId): BSplCLib_KnotDistribution;
  static MultForm(Mults: TColStd_Array1OfInteger, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId): BSplCLib_MultDistribution;
  static KnotAnalysis(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, CKnots: TColStd_Array1OfReal, CMults: TColStd_Array1OfInteger, KnotForm: GeomAbs_BSplKnotDistribution, MaxKnotMult: Graphic3d_ZLayerId): void;
  static Reparametrize(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Knots: TColStd_Array1OfReal): void;
  static Reverse_1(Knots: TColStd_Array1OfReal): void;
  static Reverse_2(Mults: TColStd_Array1OfInteger): void;
  static Reverse_3(Poles: TColgp_Array1OfPnt, Last: Graphic3d_ZLayerId): void;
  static Reverse_4(Poles: TColgp_Array1OfPnt2d, Last: Graphic3d_ZLayerId): void;
  static Reverse_5(Weights: TColStd_Array1OfReal, Last: Graphic3d_ZLayerId): void;
  static IsRational(Weights: TColStd_Array1OfReal, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, Epsilon: Quantity_AbsorbedDose): Standard_Boolean;
  static MaxDegree(): Graphic3d_ZLayerId;
  static Eval_1(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, Knots: Quantity_AbsorbedDose, Dimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose): void;
  static BoorScheme(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, Knots: Quantity_AbsorbedDose, Dimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Depth: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId): void;
  static AntiBoorScheme(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, Knots: Quantity_AbsorbedDose, Dimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Depth: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  static Derivative(Degree: Graphic3d_ZLayerId, Knots: Quantity_AbsorbedDose, Dimension: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId, Order: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose): void;
  static Bohm(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, N: Graphic3d_ZLayerId, Knots: Quantity_AbsorbedDose, Dimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose): void;
  static NoWeights(): TColStd_Array1OfReal;
  static NoMults(): TColStd_Array1OfInteger;
  static BuildKnots(Degree: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, LK: Quantity_AbsorbedDose): void;
  static PoleIndex(Degree: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Mults: TColStd_Array1OfInteger): Graphic3d_ZLayerId;
  static BuildEval_1(Degree: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Poles: TColStd_Array1OfReal, Weights: TColStd_Array1OfReal, LP: Quantity_AbsorbedDose): void;
  static BuildEval_2(Degree: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, LP: Quantity_AbsorbedDose): void;
  static BuildEval_3(Degree: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, LP: Quantity_AbsorbedDose): void;
  static BuildBoor(Index: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, Poles: TColStd_Array1OfReal, LP: Quantity_AbsorbedDose): void;
  static BoorIndex(Index: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId, Depth: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static GetPole(Index: Graphic3d_ZLayerId, Length: Graphic3d_ZLayerId, Depth: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, LocPoles: Quantity_AbsorbedDose, Position: Graphic3d_ZLayerId, Pole: TColStd_Array1OfReal): void;
  static PrepareInsertKnots(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, AddKnots: TColStd_Array1OfReal, AddMults: TColStd_Array1OfInteger, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Epsilon: Quantity_AbsorbedDose, Add: Standard_Boolean): Standard_Boolean;
  static InsertKnots_1(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Dimension: Graphic3d_ZLayerId, Poles: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, AddKnots: TColStd_Array1OfReal, AddMults: TColStd_Array1OfInteger, NewPoles: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Epsilon: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  static InsertKnots_2(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, AddKnots: TColStd_Array1OfReal, AddMults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Epsilon: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  static InsertKnots_3(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, AddKnots: TColStd_Array1OfReal, AddMults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Epsilon: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  static InsertKnot_1(UIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, UMult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal): void;
  static InsertKnot_2(UIndex: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, UMult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal): void;
  static RaiseMultiplicity_1(KnotIndex: Graphic3d_ZLayerId, Mult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal): void;
  static RaiseMultiplicity_2(KnotIndex: Graphic3d_ZLayerId, Mult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal): void;
  static RemoveKnot_1(Index: Graphic3d_ZLayerId, Mult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Dimension: Graphic3d_ZLayerId, Poles: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  static RemoveKnot_2(Index: Graphic3d_ZLayerId, Mult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  static RemoveKnot_3(Index: Graphic3d_ZLayerId, Mult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  static IncreaseDegreeCountKnots(Degree: Graphic3d_ZLayerId, NewDegree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Mults: TColStd_Array1OfInteger): Graphic3d_ZLayerId;
  static IncreaseDegree_1(Degree: Graphic3d_ZLayerId, NewDegree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Dimension: Graphic3d_ZLayerId, Poles: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger): void;
  static IncreaseDegree_2(Degree: Graphic3d_ZLayerId, NewDegree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger): void;
  static IncreaseDegree_3(Degree: Graphic3d_ZLayerId, NewDegree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger): void;
  static IncreaseDegree_4(NewDegree: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal): void;
  static IncreaseDegree_5(NewDegree: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal): void;
  static PrepareUnperiodize(Degree: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger, NbKnots: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId): void;
  static Unperiodize_1(Degree: Graphic3d_ZLayerId, Dimension: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger, Knots: TColStd_Array1OfReal, Poles: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, NewKnots: TColStd_Array1OfReal, NewPoles: TColStd_Array1OfReal): void;
  static Unperiodize_2(Degree: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger, Knots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, NewKnots: TColStd_Array1OfReal, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal): void;
  static Unperiodize_3(Degree: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger, Knots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, NewKnots: TColStd_Array1OfReal, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal): void;
  static PrepareTrimming(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, NbKnots: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId): void;
  static Trimming_1(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Dimension: Graphic3d_ZLayerId, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Poles: TColStd_Array1OfReal, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, NewPoles: TColStd_Array1OfReal): void;
  static Trimming_2(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt, NewWeights: TColStd_Array1OfReal): void;
  static Trimming_3(Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, NewPoles: TColgp_Array1OfPnt2d, NewWeights: TColStd_Array1OfReal): void;
  static D0_1(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColStd_Array1OfReal, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: Quantity_AbsorbedDose): void;
  static D0_2(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt): void;
  static D0_3(U: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt2d): void;
  static D0_4(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, P: gp_Pnt): void;
  static D0_5(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, P: gp_Pnt2d): void;
  static D1_1(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColStd_Array1OfReal, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static D1_2(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt, V: gp_Vec): void;
  static D1_3(U: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D1_4(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, P: gp_Pnt, V: gp_Vec): void;
  static D1_5(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, P: gp_Pnt2d, V: gp_Vec2d): void;
  static D2_1(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColStd_Array1OfReal, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  static D2_2(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D2_3(U: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D2_4(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D2_5(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  static D3_1(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColStd_Array1OfReal, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose, V3: Quantity_AbsorbedDose): void;
  static D3_2(U: Quantity_AbsorbedDose, Index: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static D3_3(U: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static D3_4(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static D3_5(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  static EvalBsplineBasis(DerivativeOrder: Graphic3d_ZLayerId, Order: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameter: Quantity_AbsorbedDose, FirstNonZeroBsplineIndex: Graphic3d_ZLayerId, BsplineBasis: math_Matrix, isPeriodic: Standard_Boolean): Graphic3d_ZLayerId;
  static BuildBSpMatrix(Parameters: TColStd_Array1OfReal, OrderArray: TColStd_Array1OfInteger, FlatKnots: TColStd_Array1OfReal, Degree: Graphic3d_ZLayerId, Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static FactorBandedMatrix(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, PivotIndexProblem: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static SolveBandedSystem_1(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, ArrayDimension: Graphic3d_ZLayerId, Array: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static SolveBandedSystem_2(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, Array: TColgp_Array1OfPnt2d): Graphic3d_ZLayerId;
  static SolveBandedSystem_3(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, Array: TColgp_Array1OfPnt): Graphic3d_ZLayerId;
  static SolveBandedSystem_4(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, HomogenousFlag: Standard_Boolean, ArrayDimension: Graphic3d_ZLayerId, Array: Quantity_AbsorbedDose, Weights: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static SolveBandedSystem_5(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, HomogenousFlag: Standard_Boolean, Array: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal): Graphic3d_ZLayerId;
  static SolveBandedSystem_6(Matrix: math_Matrix, UpperBandWidth: Graphic3d_ZLayerId, LowerBandWidth: Graphic3d_ZLayerId, HomogeneousFlag: Standard_Boolean, Array: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal): Graphic3d_ZLayerId;
  static MergeBSplineKnots(Tolerance: Quantity_AbsorbedDose, StartValue: Quantity_AbsorbedDose, EndValue: Quantity_AbsorbedDose, Degree1: Graphic3d_ZLayerId, Knots1: TColStd_Array1OfReal, Mults1: TColStd_Array1OfInteger, Degree2: Graphic3d_ZLayerId, Knots2: TColStd_Array1OfReal, Mults2: TColStd_Array1OfInteger, NumPoles: Graphic3d_ZLayerId, NewKnots: Handle_TColStd_HArray1OfReal, NewMults: Handle_TColStd_HArray1OfInteger): void;
  static FunctionReparameterise_1(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, PolesDimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: Quantity_AbsorbedDose, theStatus: Graphic3d_ZLayerId): void;
  static FunctionReparameterise_2(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, Poles: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: TColStd_Array1OfReal, theStatus: Graphic3d_ZLayerId): void;
  static FunctionReparameterise_3(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: TColgp_Array1OfPnt, theStatus: Graphic3d_ZLayerId): void;
  static FunctionReparameterise_4(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: TColgp_Array1OfPnt2d, theStatus: Graphic3d_ZLayerId): void;
  static FunctionMultiply_1(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, PolesDimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: Quantity_AbsorbedDose, theStatus: Graphic3d_ZLayerId): void;
  static FunctionMultiply_2(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, Poles: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: TColStd_Array1OfReal, theStatus: Graphic3d_ZLayerId): void;
  static FunctionMultiply_3(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: TColgp_Array1OfPnt2d, theStatus: Graphic3d_ZLayerId): void;
  static FunctionMultiply_4(Function: BSplCLib_EvaluatorFunction, BSplineDegree: Graphic3d_ZLayerId, BSplineFlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, FlatKnots: TColStd_Array1OfReal, NewDegree: Graphic3d_ZLayerId, NewPoles: TColgp_Array1OfPnt, theStatus: Graphic3d_ZLayerId): void;
  static Eval_2(U: Quantity_AbsorbedDose, PeriodicFlag: Standard_Boolean, DerivativeRequest: Graphic3d_ZLayerId, ExtrapMode: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, ArrayDimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Result: Quantity_AbsorbedDose): void;
  static Eval_3(U: Quantity_AbsorbedDose, PeriodicFlag: Standard_Boolean, DerivativeRequest: Graphic3d_ZLayerId, ExtrapMode: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, ArrayDimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Weights: Quantity_AbsorbedDose, PolesResult: Quantity_AbsorbedDose, WeightsResult: Quantity_AbsorbedDose): void;
  static Eval_4(U: Quantity_AbsorbedDose, PeriodicFlag: Standard_Boolean, HomogeneousFlag: Standard_Boolean, ExtrapMode: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Weight: Quantity_AbsorbedDose): void;
  static Eval_5(U: Quantity_AbsorbedDose, PeriodicFlag: Standard_Boolean, HomogeneousFlag: Standard_Boolean, ExtrapMode: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  static TangExtendToConstraint(FlatKnots: TColStd_Array1OfReal, C1Coefficient: Quantity_AbsorbedDose, NumPoles: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Dimension: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, ConstraintPoint: TColStd_Array1OfReal, Continuity: Graphic3d_ZLayerId, After: Standard_Boolean, NbPolesResult: Graphic3d_ZLayerId, NbKnotsRsult: Graphic3d_ZLayerId, KnotsResult: Quantity_AbsorbedDose, PolesResult: Quantity_AbsorbedDose): void;
  static CacheD0_1(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt): void;
  static CacheD0_2(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d): void;
  static CoefsD0_1(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt): void;
  static CoefsD0_2(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d): void;
  static CacheD1_1(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Vec: gp_Vec): void;
  static CacheD1_2(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Vec: gp_Vec2d): void;
  static CoefsD1_1(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Vec: gp_Vec): void;
  static CoefsD1_2(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Vec: gp_Vec2d): void;
  static CacheD2_1(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Vec1: gp_Vec, Vec2: gp_Vec): void;
  static CacheD2_2(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Vec1: gp_Vec2d, Vec2: gp_Vec2d): void;
  static CoefsD2_1(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Vec1: gp_Vec, Vec2: gp_Vec): void;
  static CoefsD2_2(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Vec1: gp_Vec2d, Vec2: gp_Vec2d): void;
  static CacheD3_1(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Vec1: gp_Vec, Vec2: gp_Vec, Vec3: gp_Vec): void;
  static CacheD3_2(U: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, CacheParameter: Quantity_AbsorbedDose, SpanLenght: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Vec1: gp_Vec2d, Vec2: gp_Vec2d, Vec3: gp_Vec2d): void;
  static CoefsD3_1(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, Point: gp_Pnt, Vec1: gp_Vec, Vec2: gp_Vec, Vec3: gp_Vec): void;
  static CoefsD3_2(U: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Point: gp_Pnt2d, Vec1: gp_Vec2d, Vec2: gp_Vec2d, Vec3: gp_Vec2d): void;
  static BuildCache_1(U: Quantity_AbsorbedDose, InverseOfSpanDomain: Quantity_AbsorbedDose, PeriodicFlag: Standard_Boolean, Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, CachePoles: TColgp_Array1OfPnt, CacheWeights: TColStd_Array1OfReal): void;
  static BuildCache_2(U: Quantity_AbsorbedDose, InverseOfSpanDomain: Quantity_AbsorbedDose, PeriodicFlag: Standard_Boolean, Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, CachePoles: TColgp_Array1OfPnt2d, CacheWeights: TColStd_Array1OfReal): void;
  static BuildCache_3(theParameter: Quantity_AbsorbedDose, theSpanDomain: Quantity_AbsorbedDose, thePeriodicFlag: Standard_Boolean, theDegree: Graphic3d_ZLayerId, theSpanIndex: Graphic3d_ZLayerId, theFlatKnots: TColStd_Array1OfReal, thePoles: TColgp_Array1OfPnt, theWeights: TColStd_Array1OfReal, theCacheArray: TColStd_Array2OfReal): void;
  static BuildCache_4(theParameter: Quantity_AbsorbedDose, theSpanDomain: Quantity_AbsorbedDose, thePeriodicFlag: Standard_Boolean, theDegree: Graphic3d_ZLayerId, theSpanIndex: Graphic3d_ZLayerId, theFlatKnots: TColStd_Array1OfReal, thePoles: TColgp_Array1OfPnt2d, theWeights: TColStd_Array1OfReal, theCacheArray: TColStd_Array2OfReal): void;
  static PolesCoefficients_1(Poles: TColgp_Array1OfPnt2d, CachePoles: TColgp_Array1OfPnt2d): void;
  static PolesCoefficients_2(Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, CachePoles: TColgp_Array1OfPnt2d, CacheWeights: TColStd_Array1OfReal): void;
  static PolesCoefficients_3(Poles: TColgp_Array1OfPnt, CachePoles: TColgp_Array1OfPnt): void;
  static PolesCoefficients_4(Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, CachePoles: TColgp_Array1OfPnt, CacheWeights: TColStd_Array1OfReal): void;
  static FlatBezierKnots(Degree: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static BuildSchoenbergPoints(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal): void;
  static Interpolate_1(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal, ContactOrderArray: TColStd_Array1OfInteger, Poles: TColgp_Array1OfPnt, InversionProblem: Graphic3d_ZLayerId): void;
  static Interpolate_2(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal, ContactOrderArray: TColStd_Array1OfInteger, Poles: TColgp_Array1OfPnt2d, InversionProblem: Graphic3d_ZLayerId): void;
  static Interpolate_3(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal, ContactOrderArray: TColStd_Array1OfInteger, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, InversionProblem: Graphic3d_ZLayerId): void;
  static Interpolate_4(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal, ContactOrderArray: TColStd_Array1OfInteger, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, InversionProblem: Graphic3d_ZLayerId): void;
  static Interpolate_5(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal, ContactOrderArray: TColStd_Array1OfInteger, ArrayDimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, InversionProblem: Graphic3d_ZLayerId): void;
  static Interpolate_6(Degree: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Parameters: TColStd_Array1OfReal, ContactOrderArray: TColStd_Array1OfInteger, ArrayDimension: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Weights: Quantity_AbsorbedDose, InversionProblem: Graphic3d_ZLayerId): void;
  static MovePoint_1(U: Quantity_AbsorbedDose, Displ: gp_Vec2d, Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, FirstIndex: Graphic3d_ZLayerId, LastIndex: Graphic3d_ZLayerId, NewPoles: TColgp_Array1OfPnt2d): void;
  static MovePoint_2(U: Quantity_AbsorbedDose, Displ: gp_Vec, Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, FirstIndex: Graphic3d_ZLayerId, LastIndex: Graphic3d_ZLayerId, NewPoles: TColgp_Array1OfPnt): void;
  static MovePointAndTangent_1(U: Quantity_AbsorbedDose, ArrayDimension: Graphic3d_ZLayerId, Delta: Quantity_AbsorbedDose, DeltaDerivative: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, StartingCondition: Graphic3d_ZLayerId, EndingCondition: Graphic3d_ZLayerId, Poles: Quantity_AbsorbedDose, Weights: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, NewPoles: Quantity_AbsorbedDose, ErrorStatus: Graphic3d_ZLayerId): void;
  static MovePointAndTangent_2(U: Quantity_AbsorbedDose, Delta: gp_Vec, DeltaDerivative: gp_Vec, Tolerance: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, StartingCondition: Graphic3d_ZLayerId, EndingCondition: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, NewPoles: TColgp_Array1OfPnt, ErrorStatus: Graphic3d_ZLayerId): void;
  static MovePointAndTangent_3(U: Quantity_AbsorbedDose, Delta: gp_Vec2d, DeltaDerivative: gp_Vec2d, Tolerance: Quantity_AbsorbedDose, Degree: Graphic3d_ZLayerId, StartingCondition: Graphic3d_ZLayerId, EndingCondition: Graphic3d_ZLayerId, Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, NewPoles: TColgp_Array1OfPnt2d, ErrorStatus: Graphic3d_ZLayerId): void;
  static Resolution_1(PolesArray: Quantity_AbsorbedDose, ArrayDimension: Graphic3d_ZLayerId, NumPoles: Graphic3d_ZLayerId, Weights: TColStd_Array1OfReal, FlatKnots: TColStd_Array1OfReal, Degree: Graphic3d_ZLayerId, Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  static Resolution_2(Poles: TColgp_Array1OfPnt, Weights: TColStd_Array1OfReal, NumPoles: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Degree: Graphic3d_ZLayerId, Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  static Resolution_3(Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, NumPoles: Graphic3d_ZLayerId, FlatKnots: TColStd_Array1OfReal, Degree: Graphic3d_ZLayerId, Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_BSplCLib_Cache {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BSplCLib_Cache): void;
  get(): BSplCLib_Cache;
  delete(): void;
}

  export declare class Handle_BSplCLib_Cache_1 extends Handle_BSplCLib_Cache {
    constructor();
  }

  export declare class Handle_BSplCLib_Cache_2 extends Handle_BSplCLib_Cache {
    constructor(thePtr: BSplCLib_Cache);
  }

  export declare class Handle_BSplCLib_Cache_3 extends Handle_BSplCLib_Cache {
    constructor(theHandle: Handle_BSplCLib_Cache);
  }

  export declare class Handle_BSplCLib_Cache_4 extends Handle_BSplCLib_Cache {
    constructor(theHandle: Handle_BSplCLib_Cache);
  }

export declare class BSplCLib_Cache extends Standard_Transient {
  IsCacheValid(theParameter: Quantity_AbsorbedDose): Standard_Boolean;
  BuildCache_1(theParameter: Quantity_AbsorbedDose, theFlatKnots: TColStd_Array1OfReal, thePoles2d: TColgp_Array1OfPnt2d, theWeights: TColStd_Array1OfReal): void;
  BuildCache_2(theParameter: Quantity_AbsorbedDose, theFlatKnots: TColStd_Array1OfReal, thePoles: TColgp_Array1OfPnt, theWeights: TColStd_Array1OfReal): void;
  D0_1(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt2d): void;
  D0_2(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt): void;
  D1_1(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt2d, theTangent: gp_Vec2d): void;
  D1_2(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt, theTangent: gp_Vec): void;
  D2_1(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt2d, theTangent: gp_Vec2d, theCurvature: gp_Vec2d): void;
  D2_2(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt, theTangent: gp_Vec, theCurvature: gp_Vec): void;
  D3_1(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt2d, theTangent: gp_Vec2d, theCurvature: gp_Vec2d, theTorsion: gp_Vec2d): void;
  D3_2(theParameter: Quantity_AbsorbedDose, thePoint: gp_Pnt, theTangent: gp_Vec, theCurvature: gp_Vec, theTorsion: gp_Vec): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BSplCLib_Cache_1 extends BSplCLib_Cache {
    constructor(theDegree: Graphic3d_ZLayerId, thePeriodic: Standard_Boolean, theFlatKnots: TColStd_Array1OfReal, thePoles2d: TColgp_Array1OfPnt2d, theWeights: TColStd_Array1OfReal);
  }

  export declare class BSplCLib_Cache_2 extends BSplCLib_Cache {
    constructor(theDegree: Graphic3d_ZLayerId, thePeriodic: Standard_Boolean, theFlatKnots: TColStd_Array1OfReal, thePoles: TColgp_Array1OfPnt, theWeights: TColStd_Array1OfReal);
  }

export declare class BSplCLib_EvaluatorFunction {
  Evaluate(theDerivativeRequest: Graphic3d_ZLayerId, theStartEnd: Quantity_AbsorbedDose, theParameter: Quantity_AbsorbedDose, theResult: Quantity_AbsorbedDose, theErrorCode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type BSplCLib_KnotDistribution = {
  BSplCLib_NonUniform: {};
  BSplCLib_Uniform: {};
}

export declare type BSplCLib_MultDistribution = {
  BSplCLib_NonConstant: {};
  BSplCLib_Constant: {};
  BSplCLib_QuasiConstant: {};
}

export declare class BSplCLib_CacheParams {
  constructor(theDegree: Graphic3d_ZLayerId, thePeriodic: Standard_Boolean, theFlatKnots: TColStd_Array1OfReal)
  PeriodicNormalization(theParameter: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IsCacheValid(theParameter: Quantity_AbsorbedDose): Standard_Boolean;
  LocateParameter(theParameter: Quantity_AbsorbedDose, theFlatKnots: TColStd_Array1OfReal): void;
  delete(): void;
}

export declare class Approx_FitAndDivide2d {
  Perform(Line: AppCont_Function): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetConstraints(FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint): void;
  SetMaxSegments(theMaxSegments: Graphic3d_ZLayerId): void;
  SetInvOrder(theInvOrder: Standard_Boolean): void;
  SetHangChecking(theHangChecking: Standard_Boolean): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(Index: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  Parameters(Index: Graphic3d_ZLayerId, firstp: Quantity_AbsorbedDose, lastp: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Approx_FitAndDivide2d_1 extends Approx_FitAndDivide2d {
    constructor(Line: AppCont_Function, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, cutting: Standard_Boolean, FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint);
  }

  export declare class Approx_FitAndDivide2d_2 extends Approx_FitAndDivide2d {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, cutting: Standard_Boolean, FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint);
  }

export declare class Approx_MCurvesToBSpCurve {
  constructor()
  Reset(): void;
  Append(MC: AppParCurves_MultiCurve): void;
  Perform_1(): void;
  Perform_2(TheSeq: AppParCurves_SequenceOfMultiCurve): void;
  Value(): AppParCurves_MultiBSpCurve;
  ChangeValue(): AppParCurves_MultiBSpCurve;
  delete(): void;
}

export declare class Approx_FitAndDivide {
  Perform(Line: AppCont_Function): void;
  SetDegrees(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId): void;
  SetTolerances(Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose): void;
  SetConstraints(FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint): void;
  SetMaxSegments(theMaxSegments: Graphic3d_ZLayerId): void;
  SetInvOrder(theInvOrder: Standard_Boolean): void;
  SetHangChecking(theHangChecking: Standard_Boolean): void;
  IsAllApproximated(): Standard_Boolean;
  IsToleranceReached(): Standard_Boolean;
  Error(Index: Graphic3d_ZLayerId, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): void;
  NbMultiCurves(): Graphic3d_ZLayerId;
  Value(Index: Graphic3d_ZLayerId): AppParCurves_MultiCurve;
  Parameters(Index: Graphic3d_ZLayerId, firstp: Quantity_AbsorbedDose, lastp: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Approx_FitAndDivide_1 extends Approx_FitAndDivide {
    constructor(Line: AppCont_Function, degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, cutting: Standard_Boolean, FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint);
  }

  export declare class Approx_FitAndDivide_2 extends Approx_FitAndDivide {
    constructor(degreemin: Graphic3d_ZLayerId, degreemax: Graphic3d_ZLayerId, Tolerance3d: Quantity_AbsorbedDose, Tolerance2d: Quantity_AbsorbedDose, cutting: Standard_Boolean, FirstC: AppParCurves_Constraint, LastC: AppParCurves_Constraint);
  }

export declare class Approx_CurveOnSurface {
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  Curve3d(): Handle_Geom_BSplineCurve;
  MaxError3d(): Quantity_AbsorbedDose;
  Curve2d(): Handle_Geom2d_BSplineCurve;
  MaxError2dU(): Quantity_AbsorbedDose;
  MaxError2dV(): Quantity_AbsorbedDose;
  Perform(theMaxSegments: Graphic3d_ZLayerId, theMaxDegree: Graphic3d_ZLayerId, theContinuity: GeomAbs_Shape, theOnly3d: Standard_Boolean, theOnly2d: Standard_Boolean): void;
  delete(): void;
}

  export declare class Approx_CurveOnSurface_1 extends Approx_CurveOnSurface {
    constructor(C2D: Handle_Adaptor2d_HCurve2d, Surf: Handle_Adaptor3d_HSurface, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId, Only3d: Standard_Boolean, Only2d: Standard_Boolean);
  }

  export declare class Approx_CurveOnSurface_2 extends Approx_CurveOnSurface {
    constructor(theC2D: Handle_Adaptor2d_HCurve2d, theSurf: Handle_Adaptor3d_HSurface, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theTol: Quantity_AbsorbedDose);
  }

export declare type Approx_Status = {
  Approx_PointsAdded: {};
  Approx_NoPointsAdded: {};
  Approx_NoApproximation: {};
}

export declare class Approx_SameParameter {
  IsDone(): Standard_Boolean;
  TolReached(): Quantity_AbsorbedDose;
  IsSameParameter(): Standard_Boolean;
  Curve2d(): Handle_Geom2d_Curve;
  delete(): void;
}

  export declare class Approx_SameParameter_1 extends Approx_SameParameter {
    constructor(C3D: Handle_Geom_Curve, C2D: Handle_Geom2d_Curve, S: Handle_Geom_Surface, Tol: Quantity_AbsorbedDose);
  }

  export declare class Approx_SameParameter_2 extends Approx_SameParameter {
    constructor(C3D: Handle_Adaptor3d_HCurve, C2D: Handle_Geom2d_Curve, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

  export declare class Approx_SameParameter_3 extends Approx_SameParameter {
    constructor(C3D: Handle_Adaptor3d_HCurve, C2D: Handle_Adaptor2d_HCurve2d, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

export declare type Approx_ParametrizationType = {
  Approx_ChordLength: {};
  Approx_Centripetal: {};
  Approx_IsoParametric: {};
}

export declare class Approx_CurvlinFunc extends Standard_Transient {
  SetTol(Tol: Quantity_AbsorbedDose): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Length_1(): void;
  Length_2(C: Adaptor3d_Curve, FirstU: Quantity_AbsorbedDose, LasrU: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetLength(): Quantity_AbsorbedDose;
  GetUParameter(C: Adaptor3d_Curve, S: Quantity_AbsorbedDose, NumberOfCurve: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  GetSParameter_1(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  EvalCase1(S: Quantity_AbsorbedDose, Order: Graphic3d_ZLayerId, Result: TColStd_Array1OfReal): Standard_Boolean;
  EvalCase2(S: Quantity_AbsorbedDose, Order: Graphic3d_ZLayerId, Result: TColStd_Array1OfReal): Standard_Boolean;
  EvalCase3(S: Quantity_AbsorbedDose, Order: Graphic3d_ZLayerId, Result: TColStd_Array1OfReal): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Approx_CurvlinFunc_1 extends Approx_CurvlinFunc {
    constructor(C: Handle_Adaptor3d_HCurve, Tol: Quantity_AbsorbedDose);
  }

  export declare class Approx_CurvlinFunc_2 extends Approx_CurvlinFunc {
    constructor(C2D: Handle_Adaptor2d_HCurve2d, S: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

  export declare class Approx_CurvlinFunc_3 extends Approx_CurvlinFunc {
    constructor(C2D1: Handle_Adaptor2d_HCurve2d, C2D2: Handle_Adaptor2d_HCurve2d, S1: Handle_Adaptor3d_HSurface, S2: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose);
  }

export declare class Handle_Approx_CurvlinFunc {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Approx_CurvlinFunc): void;
  get(): Approx_CurvlinFunc;
  delete(): void;
}

  export declare class Handle_Approx_CurvlinFunc_1 extends Handle_Approx_CurvlinFunc {
    constructor();
  }

  export declare class Handle_Approx_CurvlinFunc_2 extends Handle_Approx_CurvlinFunc {
    constructor(thePtr: Approx_CurvlinFunc);
  }

  export declare class Handle_Approx_CurvlinFunc_3 extends Handle_Approx_CurvlinFunc {
    constructor(theHandle: Handle_Approx_CurvlinFunc);
  }

  export declare class Handle_Approx_CurvlinFunc_4 extends Handle_Approx_CurvlinFunc {
    constructor(theHandle: Handle_Approx_CurvlinFunc);
  }

export declare class Approx_SweepFunction extends Standard_Transient {
  D0(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, Poles2d: TColgp_Array1OfPnt2d, Weigths: TColStd_Array1OfReal): Standard_Boolean;
  D1(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal): Standard_Boolean;
  D2(Param: Quantity_AbsorbedDose, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Poles: TColgp_Array1OfPnt, DPoles: TColgp_Array1OfVec, D2Poles: TColgp_Array1OfVec, Poles2d: TColgp_Array1OfPnt2d, DPoles2d: TColgp_Array1OfVec2d, D2Poles2d: TColgp_Array1OfVec2d, Weigths: TColStd_Array1OfReal, DWeigths: TColStd_Array1OfReal, D2Weigths: TColStd_Array1OfReal): Standard_Boolean;
  Nb2dCurves(): Graphic3d_ZLayerId;
  SectionShape(NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId): void;
  Knots(TKnots: TColStd_Array1OfReal): void;
  Mults(TMults: TColStd_Array1OfInteger): void;
  IsRational(): Standard_Boolean;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  SetInterval(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose): void;
  Resolution(Index: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  GetTolerance(BoundTol: Quantity_AbsorbedDose, SurfTol: Quantity_AbsorbedDose, AngleTol: Quantity_AbsorbedDose, Tol3d: TColStd_Array1OfReal): void;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose): void;
  BarycentreOfSurf(): gp_Pnt;
  MaximalSection(): Quantity_AbsorbedDose;
  GetMinimalWeight(Weigths: TColStd_Array1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Approx_SweepFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Approx_SweepFunction): void;
  get(): Approx_SweepFunction;
  delete(): void;
}

  export declare class Handle_Approx_SweepFunction_1 extends Handle_Approx_SweepFunction {
    constructor();
  }

  export declare class Handle_Approx_SweepFunction_2 extends Handle_Approx_SweepFunction {
    constructor(thePtr: Approx_SweepFunction);
  }

  export declare class Handle_Approx_SweepFunction_3 extends Handle_Approx_SweepFunction {
    constructor(theHandle: Handle_Approx_SweepFunction);
  }

  export declare class Handle_Approx_SweepFunction_4 extends Handle_Approx_SweepFunction {
    constructor(theHandle: Handle_Approx_SweepFunction);
  }

export declare class Handle_Approx_HArray1OfAdHSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Approx_HArray1OfAdHSurface): void;
  get(): Approx_HArray1OfAdHSurface;
  delete(): void;
}

  export declare class Handle_Approx_HArray1OfAdHSurface_1 extends Handle_Approx_HArray1OfAdHSurface {
    constructor();
  }

  export declare class Handle_Approx_HArray1OfAdHSurface_2 extends Handle_Approx_HArray1OfAdHSurface {
    constructor(thePtr: Approx_HArray1OfAdHSurface);
  }

  export declare class Handle_Approx_HArray1OfAdHSurface_3 extends Handle_Approx_HArray1OfAdHSurface {
    constructor(theHandle: Handle_Approx_HArray1OfAdHSurface);
  }

  export declare class Handle_Approx_HArray1OfAdHSurface_4 extends Handle_Approx_HArray1OfAdHSurface {
    constructor(theHandle: Handle_Approx_HArray1OfAdHSurface);
  }

export declare class Approx_Array1OfGTrsf2d {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_GTrsf2d): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Approx_Array1OfGTrsf2d): Approx_Array1OfGTrsf2d;
  Move(theOther: Approx_Array1OfGTrsf2d): Approx_Array1OfGTrsf2d;
  First(): gp_GTrsf2d;
  ChangeFirst(): gp_GTrsf2d;
  Last(): gp_GTrsf2d;
  ChangeLast(): gp_GTrsf2d;
  Value(theIndex: Standard_Integer): gp_GTrsf2d;
  ChangeValue(theIndex: Standard_Integer): gp_GTrsf2d;
  SetValue(theIndex: Standard_Integer, theItem: gp_GTrsf2d): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Approx_Array1OfGTrsf2d_1 extends Approx_Array1OfGTrsf2d {
    constructor();
  }

  export declare class Approx_Array1OfGTrsf2d_2 extends Approx_Array1OfGTrsf2d {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Approx_Array1OfGTrsf2d_3 extends Approx_Array1OfGTrsf2d {
    constructor(theOther: Approx_Array1OfGTrsf2d);
  }

  export declare class Approx_Array1OfGTrsf2d_4 extends Approx_Array1OfGTrsf2d {
    constructor(theOther: Approx_Array1OfGTrsf2d);
  }

  export declare class Approx_Array1OfGTrsf2d_5 extends Approx_Array1OfGTrsf2d {
    constructor(theBegin: gp_GTrsf2d, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Approx_CurvilinearParameter {
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  Curve3d(): Handle_Geom_BSplineCurve;
  MaxError3d(): Quantity_AbsorbedDose;
  Curve2d1(): Handle_Geom2d_BSplineCurve;
  MaxError2d1(): Quantity_AbsorbedDose;
  Curve2d2(): Handle_Geom2d_BSplineCurve;
  MaxError2d2(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class Approx_CurvilinearParameter_1 extends Approx_CurvilinearParameter {
    constructor(C3D: Handle_Adaptor3d_HCurve, Tol: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId);
  }

  export declare class Approx_CurvilinearParameter_2 extends Approx_CurvilinearParameter {
    constructor(C2D: Handle_Adaptor2d_HCurve2d, Surf: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId);
  }

  export declare class Approx_CurvilinearParameter_3 extends Approx_CurvilinearParameter {
    constructor(C2D1: Handle_Adaptor2d_HCurve2d, Surf1: Handle_Adaptor3d_HSurface, C2D2: Handle_Adaptor2d_HCurve2d, Surf2: Handle_Adaptor3d_HSurface, Tol: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId);
  }

export declare class Approx_Curve2d {
  constructor(C2D: Handle_Adaptor2d_HCurve2d, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  Curve(): Handle_Geom2d_BSplineCurve;
  MaxError2dU(): Quantity_AbsorbedDose;
  MaxError2dV(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Approx_Curve3d {
  constructor(Curve: Handle_Adaptor3d_HCurve, Tol3d: Quantity_AbsorbedDose, Order: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId)
  Curve(): Handle_Geom_BSplineCurve;
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  MaxError(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class Handle_Approx_HArray1OfGTrsf2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Approx_HArray1OfGTrsf2d): void;
  get(): Approx_HArray1OfGTrsf2d;
  delete(): void;
}

  export declare class Handle_Approx_HArray1OfGTrsf2d_1 extends Handle_Approx_HArray1OfGTrsf2d {
    constructor();
  }

  export declare class Handle_Approx_HArray1OfGTrsf2d_2 extends Handle_Approx_HArray1OfGTrsf2d {
    constructor(thePtr: Approx_HArray1OfGTrsf2d);
  }

  export declare class Handle_Approx_HArray1OfGTrsf2d_3 extends Handle_Approx_HArray1OfGTrsf2d {
    constructor(theHandle: Handle_Approx_HArray1OfGTrsf2d);
  }

  export declare class Handle_Approx_HArray1OfGTrsf2d_4 extends Handle_Approx_HArray1OfGTrsf2d {
    constructor(theHandle: Handle_Approx_HArray1OfGTrsf2d);
  }

export declare class Approx_SweepApproximation {
  constructor(Func: Handle_Approx_SweepFunction)
  Perform(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, BoundTol: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, TolAngular: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, Degmax: Graphic3d_ZLayerId, Segmax: Graphic3d_ZLayerId): void;
  Eval(Parameter: Quantity_AbsorbedDose, DerivativeRequest: Graphic3d_ZLayerId, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Result: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  IsDone(): Standard_Boolean;
  SurfShape(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, NbUPoles: Graphic3d_ZLayerId, NbVPoles: Graphic3d_ZLayerId, NbUKnots: Graphic3d_ZLayerId, NbVKnots: Graphic3d_ZLayerId): void;
  Surface(TPoles: TColgp_Array2OfPnt, TWeights: TColStd_Array2OfReal, TUKnots: TColStd_Array1OfReal, TVKnots: TColStd_Array1OfReal, TUMults: TColStd_Array1OfInteger, TVMults: TColStd_Array1OfInteger): void;
  UDegree(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  SurfPoles(): TColgp_Array2OfPnt;
  SurfWeights(): TColStd_Array2OfReal;
  SurfUKnots(): TColStd_Array1OfReal;
  SurfVKnots(): TColStd_Array1OfReal;
  SurfUMults(): TColStd_Array1OfInteger;
  SurfVMults(): TColStd_Array1OfInteger;
  MaxErrorOnSurf(): Quantity_AbsorbedDose;
  AverageErrorOnSurf(): Quantity_AbsorbedDose;
  NbCurves2d(): Graphic3d_ZLayerId;
  Curves2dShape(Degree: Graphic3d_ZLayerId, NbPoles: Graphic3d_ZLayerId, NbKnots: Graphic3d_ZLayerId): void;
  Curve2d(Index: Graphic3d_ZLayerId, TPoles: TColgp_Array1OfPnt2d, TKnots: TColStd_Array1OfReal, TMults: TColStd_Array1OfInteger): void;
  Curves2dDegree(): Graphic3d_ZLayerId;
  Curve2dPoles(Index: Graphic3d_ZLayerId): TColgp_Array1OfPnt2d;
  Curves2dKnots(): TColStd_Array1OfReal;
  Curves2dMults(): TColStd_Array1OfInteger;
  Max2dError(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Average2dError(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  TolCurveOnSurf(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare type IntImp_ConstIsoparametric = {
  IntImp_UIsoparametricOnCaro1: {};
  IntImp_VIsoparametricOnCaro1: {};
  IntImp_UIsoparametricOnCaro2: {};
  IntImp_VIsoparametricOnCaro2: {};
}

export declare class Handle_ShapeProcess_Context {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeProcess_Context): void;
  get(): ShapeProcess_Context;
  delete(): void;
}

  export declare class Handle_ShapeProcess_Context_1 extends Handle_ShapeProcess_Context {
    constructor();
  }

  export declare class Handle_ShapeProcess_Context_2 extends Handle_ShapeProcess_Context {
    constructor(thePtr: ShapeProcess_Context);
  }

  export declare class Handle_ShapeProcess_Context_3 extends Handle_ShapeProcess_Context {
    constructor(theHandle: Handle_ShapeProcess_Context);
  }

  export declare class Handle_ShapeProcess_Context_4 extends Handle_ShapeProcess_Context {
    constructor(theHandle: Handle_ShapeProcess_Context);
  }

export declare class ShapeProcess_Context extends Standard_Transient {
  Init(file: Standard_CString, scope: Standard_CString): Standard_Boolean;
  LoadResourceManager(file: Standard_CString): Handle_Resource_Manager;
  ResourceManager(): Handle_Resource_Manager;
  SetScope(scope: Standard_CString): void;
  UnSetScope(): void;
  IsParamSet(param: Standard_CString): Standard_Boolean;
  GetReal(param: Standard_CString, val: Quantity_AbsorbedDose): Standard_Boolean;
  GetInteger(param: Standard_CString, val: Graphic3d_ZLayerId): Standard_Boolean;
  GetBoolean(param: Standard_CString, val: Standard_Boolean): Standard_Boolean;
  GetString(param: Standard_CString, val: XCAFDoc_PartId): Standard_Boolean;
  RealVal(param: Standard_CString, def: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IntegerVal(param: Standard_CString, def: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  BooleanVal(param: Standard_CString, def: Standard_Boolean): Standard_Boolean;
  StringVal(param: Standard_CString, def: Standard_CString): Standard_CString;
  SetMessenger(messenger: Handle_Message_Messenger): void;
  Messenger(): Handle_Message_Messenger;
  SetTraceLevel(tracelev: Graphic3d_ZLayerId): void;
  TraceLevel(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeProcess_Context_1 extends ShapeProcess_Context {
    constructor();
  }

  export declare class ShapeProcess_Context_2 extends ShapeProcess_Context {
    constructor(file: Standard_CString, scope: Standard_CString);
  }

export declare class Handle_ShapeProcess_Operator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeProcess_Operator): void;
  get(): ShapeProcess_Operator;
  delete(): void;
}

  export declare class Handle_ShapeProcess_Operator_1 extends Handle_ShapeProcess_Operator {
    constructor();
  }

  export declare class Handle_ShapeProcess_Operator_2 extends Handle_ShapeProcess_Operator {
    constructor(thePtr: ShapeProcess_Operator);
  }

  export declare class Handle_ShapeProcess_Operator_3 extends Handle_ShapeProcess_Operator {
    constructor(theHandle: Handle_ShapeProcess_Operator);
  }

  export declare class Handle_ShapeProcess_Operator_4 extends Handle_ShapeProcess_Operator {
    constructor(theHandle: Handle_ShapeProcess_Operator);
  }

export declare class ShapeProcess_Operator extends Standard_Transient {
  Perform(context: Handle_ShapeProcess_Context, theProgress: Message_ProgressRange): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeProcess {
  constructor();
  static RegisterOperator(name: Standard_CString, op: Handle_ShapeProcess_Operator): Standard_Boolean;
  static FindOperator(name: Standard_CString, op: Handle_ShapeProcess_Operator): Standard_Boolean;
  static Perform(context: Handle_ShapeProcess_Context, seq: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  delete(): void;
}

export declare class ShapeProcess_UOperator extends ShapeProcess_Operator {
  constructor(func: ShapeProcess_OperFunc)
  Perform(context: Handle_ShapeProcess_Context, theProgress: Message_ProgressRange): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeProcess_UOperator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeProcess_UOperator): void;
  get(): ShapeProcess_UOperator;
  delete(): void;
}

  export declare class Handle_ShapeProcess_UOperator_1 extends Handle_ShapeProcess_UOperator {
    constructor();
  }

  export declare class Handle_ShapeProcess_UOperator_2 extends Handle_ShapeProcess_UOperator {
    constructor(thePtr: ShapeProcess_UOperator);
  }

  export declare class Handle_ShapeProcess_UOperator_3 extends Handle_ShapeProcess_UOperator {
    constructor(theHandle: Handle_ShapeProcess_UOperator);
  }

  export declare class Handle_ShapeProcess_UOperator_4 extends Handle_ShapeProcess_UOperator {
    constructor(theHandle: Handle_ShapeProcess_UOperator);
  }

export declare class Handle_ShapeProcess_ShapeContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeProcess_ShapeContext): void;
  get(): ShapeProcess_ShapeContext;
  delete(): void;
}

  export declare class Handle_ShapeProcess_ShapeContext_1 extends Handle_ShapeProcess_ShapeContext {
    constructor();
  }

  export declare class Handle_ShapeProcess_ShapeContext_2 extends Handle_ShapeProcess_ShapeContext {
    constructor(thePtr: ShapeProcess_ShapeContext);
  }

  export declare class Handle_ShapeProcess_ShapeContext_3 extends Handle_ShapeProcess_ShapeContext {
    constructor(theHandle: Handle_ShapeProcess_ShapeContext);
  }

  export declare class Handle_ShapeProcess_ShapeContext_4 extends Handle_ShapeProcess_ShapeContext {
    constructor(theHandle: Handle_ShapeProcess_ShapeContext);
  }

export declare class ShapeProcess_ShapeContext extends ShapeProcess_Context {
  Init(S: TopoDS_Shape): void;
  Shape(): TopoDS_Shape;
  Result(): TopoDS_Shape;
  Map(): TopTools_DataMapOfShapeShape;
  Messages_1(): Handle_ShapeExtend_MsgRegistrator;
  Messages_2(): Handle_ShapeExtend_MsgRegistrator;
  SetDetalisation(level: TopAbs_ShapeEnum): void;
  GetDetalisation(): TopAbs_ShapeEnum;
  SetResult(S: TopoDS_Shape): void;
  RecordModification_1(repl: TopTools_DataMapOfShapeShape, msg: Handle_ShapeExtend_MsgRegistrator): void;
  RecordModification_2(repl: Handle_ShapeBuild_ReShape, msg: Handle_ShapeExtend_MsgRegistrator): void;
  RecordModification_3(repl: Handle_ShapeBuild_ReShape): void;
  RecordModification_4(sh: TopoDS_Shape, repl: BRepTools_Modifier, msg: Handle_ShapeExtend_MsgRegistrator): void;
  AddMessage(S: TopoDS_Shape, msg: Message_Msg, gravity: Message_Gravity): void;
  GetContinuity(param: Standard_CString, val: GeomAbs_Shape): Standard_Boolean;
  ContinuityVal(param: Standard_CString, def: GeomAbs_Shape): GeomAbs_Shape;
  PrintStatistics(): void;
  SetNonManifold(theNonManifold: Standard_Boolean): void;
  IsNonManifold(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeProcess_ShapeContext_1 extends ShapeProcess_ShapeContext {
    constructor(file: Standard_CString, seq: Standard_CString);
  }

  export declare class ShapeProcess_ShapeContext_2 extends ShapeProcess_ShapeContext {
    constructor(S: TopoDS_Shape, file: Standard_CString, seq: Standard_CString);
  }

export declare class ShapeProcess_OperLibrary {
  constructor();
  static Init(): void;
  static ApplyModifier(S: TopoDS_Shape, context: Handle_ShapeProcess_ShapeContext, M: Handle_BRepTools_Modification, map: TopTools_DataMapOfShapeShape, msg: Handle_ShapeExtend_MsgRegistrator, theMutableInput: Standard_Boolean): TopoDS_Shape;
  delete(): void;
}

export declare class XmlDrivers {
  constructor();
  static Factory(theGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  delete(): void;
}

export declare class Handle_XmlDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlDrivers_DocumentStorageDriver): void;
  get(): XmlDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_XmlDrivers_DocumentStorageDriver_1 extends Handle_XmlDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_XmlDrivers_DocumentStorageDriver_2 extends Handle_XmlDrivers_DocumentStorageDriver {
    constructor(thePtr: XmlDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlDrivers_DocumentStorageDriver_3 extends Handle_XmlDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlDrivers_DocumentStorageDriver_4 extends Handle_XmlDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlDrivers_DocumentStorageDriver);
  }

export declare class XmlDrivers_DocumentStorageDriver extends XmlLDrivers_DocumentStorageDriver {
  constructor(theCopyright: TCollection_ExtendedString)
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  WriteShapeSection(thePDoc: XmlObjMgt_Element, theRange: Message_ProgressRange): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlDrivers_DocumentRetrievalDriver): void;
  get(): XmlDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_XmlDrivers_DocumentRetrievalDriver_1 extends Handle_XmlDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_XmlDrivers_DocumentRetrievalDriver_2 extends Handle_XmlDrivers_DocumentRetrievalDriver {
    constructor(thePtr: XmlDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlDrivers_DocumentRetrievalDriver_3 extends Handle_XmlDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlDrivers_DocumentRetrievalDriver_4 extends Handle_XmlDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlDrivers_DocumentRetrievalDriver);
  }

export declare class XmlDrivers_DocumentRetrievalDriver extends XmlLDrivers_DocumentRetrievalDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  ReadShapeSection(thePDoc: XmlObjMgt_Element, theMsgDriver: Handle_Message_Messenger, theRange: Message_ProgressRange): Handle_XmlMDF_ADriver;
  ShapeSetCleaning(theDriver: Handle_XmlMDF_ADriver): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP242_ItemIdentifiedRepresentationUsageDefinition extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AppliedApprovalAssignment(): Handle_StepAP214_AppliedApprovalAssignment;
  AppliedDateAndTimeAssignment(): Handle_StepAP214_AppliedDateAndTimeAssignment;
  AppliedDateAssignment(): Handle_StepAP214_AppliedDateAssignment;
  AppliedDocumentReference(): Handle_StepAP214_AppliedDocumentReference;
  AppliedExternalIdentificationAssignment(): Handle_StepAP214_AppliedExternalIdentificationAssignment;
  AppliedGroupAssignment(): Handle_StepAP214_AppliedGroupAssignment;
  AppliedOrganizationAssignment(): Handle_StepAP214_AppliedOrganizationAssignment;
  AppliedPersonAndOrganizationAssignment(): Handle_StepAP214_AppliedPersonAndOrganizationAssignment;
  AppliedSecurityClassificationAssignment(): Handle_StepAP214_AppliedSecurityClassificationAssignment;
  DimensionalSize(): Handle_StepShape_DimensionalSize;
  GeneralProperty(): Handle_StepBasic_GeneralProperty;
  GeometricTolerance(): Handle_StepDimTol_GeometricTolerance;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  PropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  PropertyDefinitionRelationship(): Handle_StepRepr_PropertyDefinitionRelationship;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  delete(): void;
}

export declare class Handle_StepAP242_DraughtingModelItemAssociation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP242_DraughtingModelItemAssociation): void;
  get(): StepAP242_DraughtingModelItemAssociation;
  delete(): void;
}

  export declare class Handle_StepAP242_DraughtingModelItemAssociation_1 extends Handle_StepAP242_DraughtingModelItemAssociation {
    constructor();
  }

  export declare class Handle_StepAP242_DraughtingModelItemAssociation_2 extends Handle_StepAP242_DraughtingModelItemAssociation {
    constructor(thePtr: StepAP242_DraughtingModelItemAssociation);
  }

  export declare class Handle_StepAP242_DraughtingModelItemAssociation_3 extends Handle_StepAP242_DraughtingModelItemAssociation {
    constructor(theHandle: Handle_StepAP242_DraughtingModelItemAssociation);
  }

  export declare class Handle_StepAP242_DraughtingModelItemAssociation_4 extends Handle_StepAP242_DraughtingModelItemAssociation {
    constructor(theHandle: Handle_StepAP242_DraughtingModelItemAssociation);
  }

export declare class StepAP242_DraughtingModelItemAssociation extends StepAP242_ItemIdentifiedRepresentationUsage {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP242_ItemIdentifiedRepresentationUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP242_ItemIdentifiedRepresentationUsage): void;
  get(): StepAP242_ItemIdentifiedRepresentationUsage;
  delete(): void;
}

  export declare class Handle_StepAP242_ItemIdentifiedRepresentationUsage_1 extends Handle_StepAP242_ItemIdentifiedRepresentationUsage {
    constructor();
  }

  export declare class Handle_StepAP242_ItemIdentifiedRepresentationUsage_2 extends Handle_StepAP242_ItemIdentifiedRepresentationUsage {
    constructor(thePtr: StepAP242_ItemIdentifiedRepresentationUsage);
  }

  export declare class Handle_StepAP242_ItemIdentifiedRepresentationUsage_3 extends Handle_StepAP242_ItemIdentifiedRepresentationUsage {
    constructor(theHandle: Handle_StepAP242_ItemIdentifiedRepresentationUsage);
  }

  export declare class Handle_StepAP242_ItemIdentifiedRepresentationUsage_4 extends Handle_StepAP242_ItemIdentifiedRepresentationUsage {
    constructor(theHandle: Handle_StepAP242_ItemIdentifiedRepresentationUsage);
  }

export declare class StepAP242_ItemIdentifiedRepresentationUsage extends Standard_Transient {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theDefinition: StepAP242_ItemIdentifiedRepresentationUsageDefinition, theUsedRepresentation: Handle_StepRepr_Representation, theIdentifiedItem: Handle_StepRepr_HArray1OfRepresentationItem): void;
  SetName(theName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(theDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDefinition(theDefinition: StepAP242_ItemIdentifiedRepresentationUsageDefinition): void;
  Definition(): StepAP242_ItemIdentifiedRepresentationUsageDefinition;
  SetUsedRepresentation(theUsedRepresentation: Handle_StepRepr_Representation): void;
  UsedRepresentation(): Handle_StepRepr_Representation;
  IdentifiedItem(): Handle_StepRepr_HArray1OfRepresentationItem;
  NbIdentifiedItem(): Graphic3d_ZLayerId;
  SetIdentifiedItem(theIdentifiedItem: Handle_StepRepr_HArray1OfRepresentationItem): void;
  IdentifiedItemValue(num: Graphic3d_ZLayerId): Handle_StepRepr_RepresentationItem;
  SetIdentifiedItemValue(num: Graphic3d_ZLayerId, theItem: Handle_StepRepr_RepresentationItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP242_IdAttributeSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Action(): Handle_StepBasic_Action;
  Address(): Handle_StepBasic_Address;
  ApplicationContext(): Handle_StepBasic_ApplicationContext;
  DimensionalSize(): Handle_StepShape_DimensionalSize;
  GeometricTolerance(): Handle_StepDimTol_GeometricTolerance;
  Group(): Handle_StepBasic_Group;
  ProductCategory(): Handle_StepBasic_ProductCategory;
  PropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  Representation(): Handle_StepRepr_Representation;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  delete(): void;
}

export declare class StepAP242_GeometricItemSpecificUsage extends StepAP242_ItemIdentifiedRepresentationUsage {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP242_GeometricItemSpecificUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP242_GeometricItemSpecificUsage): void;
  get(): StepAP242_GeometricItemSpecificUsage;
  delete(): void;
}

  export declare class Handle_StepAP242_GeometricItemSpecificUsage_1 extends Handle_StepAP242_GeometricItemSpecificUsage {
    constructor();
  }

  export declare class Handle_StepAP242_GeometricItemSpecificUsage_2 extends Handle_StepAP242_GeometricItemSpecificUsage {
    constructor(thePtr: StepAP242_GeometricItemSpecificUsage);
  }

  export declare class Handle_StepAP242_GeometricItemSpecificUsage_3 extends Handle_StepAP242_GeometricItemSpecificUsage {
    constructor(theHandle: Handle_StepAP242_GeometricItemSpecificUsage);
  }

  export declare class Handle_StepAP242_GeometricItemSpecificUsage_4 extends Handle_StepAP242_GeometricItemSpecificUsage {
    constructor(theHandle: Handle_StepAP242_GeometricItemSpecificUsage);
  }

export declare class Handle_StepAP242_IdAttribute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP242_IdAttribute): void;
  get(): StepAP242_IdAttribute;
  delete(): void;
}

  export declare class Handle_StepAP242_IdAttribute_1 extends Handle_StepAP242_IdAttribute {
    constructor();
  }

  export declare class Handle_StepAP242_IdAttribute_2 extends Handle_StepAP242_IdAttribute {
    constructor(thePtr: StepAP242_IdAttribute);
  }

  export declare class Handle_StepAP242_IdAttribute_3 extends Handle_StepAP242_IdAttribute {
    constructor(theHandle: Handle_StepAP242_IdAttribute);
  }

  export declare class Handle_StepAP242_IdAttribute_4 extends Handle_StepAP242_IdAttribute {
    constructor(theHandle: Handle_StepAP242_IdAttribute);
  }

export declare class StepAP242_IdAttribute extends Standard_Transient {
  constructor()
  Init(theAttributeValue: Handle_TCollection_HAsciiString, theIdentifiedItem: StepAP242_IdAttributeSelect): void;
  SetAttributeValue(theAttributeValue: Handle_TCollection_HAsciiString): void;
  AttributeValue(): Handle_TCollection_HAsciiString;
  SetIdentifiedItem(theIdentifiedItem: StepAP242_IdAttributeSelect): void;
  IdentifiedItem(): StepAP242_IdAttributeSelect;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Geom2dInt_GInter extends IntRes2d_Intersection {
  Perform_1(C1: Adaptor2d_Curve2d, D1: IntRes2d_Domain, C2: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(C1: Adaptor2d_Curve2d, D1: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(C1: Adaptor2d_Curve2d, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(C1: Adaptor2d_Curve2d, D1: IntRes2d_Domain, C2: Adaptor2d_Curve2d, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_6(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  ComputeDomain(C1: Adaptor2d_Curve2d, TolDomain: Quantity_AbsorbedDose): IntRes2d_Domain;
  SetMinNbSamples(theMinNbSamples: Graphic3d_ZLayerId): void;
  GetMinNbSamples(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Geom2dInt_GInter_1 extends Geom2dInt_GInter {
    constructor();
  }

  export declare class Geom2dInt_GInter_2 extends Geom2dInt_GInter {
    constructor(C: Adaptor2d_Curve2d, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_GInter_3 extends Geom2dInt_GInter {
    constructor(C: Adaptor2d_Curve2d, D: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_GInter_4 extends Geom2dInt_GInter {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_GInter_5 extends Geom2dInt_GInter {
    constructor(C1: Adaptor2d_Curve2d, D1: IntRes2d_Domain, C2: Adaptor2d_Curve2d, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_GInter_6 extends Geom2dInt_GInter {
    constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_GInter_7 extends Geom2dInt_GInter {
    constructor(C1: Adaptor2d_Curve2d, D1: IntRes2d_Domain, C2: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class Geom2dInt_ExactIntersectionPointOfTheIntPCurvePCurveOfGInter {
  constructor(C1: Adaptor2d_Curve2d, C2: Adaptor2d_Curve2d, Tol: Quantity_AbsorbedDose)
  Perform_1(Poly1: Geom2dInt_ThePolygon2dOfTheIntPCurvePCurveOfGInter, Poly2: Geom2dInt_ThePolygon2dOfTheIntPCurvePCurveOfGInter, NumSegOn1: Graphic3d_ZLayerId, NumSegOn2: Graphic3d_ZLayerId, ParamOnSeg1: Quantity_AbsorbedDose, ParamOnSeg2: Quantity_AbsorbedDose): void;
  Perform_2(Uo: Quantity_AbsorbedDose, Vo: Quantity_AbsorbedDose, UInf: Quantity_AbsorbedDose, VInf: Quantity_AbsorbedDose, USup: Quantity_AbsorbedDose, VSup: Quantity_AbsorbedDose): void;
  NbRoots(): Graphic3d_ZLayerId;
  Roots(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  AnErrorOccurred(): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dInt_MyImpParToolOfTheIntersectorOfTheIntConicCurveOfGInter extends math_FunctionWithDerivative {
  constructor(IT: IntCurve_IConicTool, PC: Adaptor2d_Curve2d)
  Value(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(Param: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(Param: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Geom2dInt_TheIntPCurvePCurveOfGInter extends IntRes2d_Intersection {
  constructor()
  Perform_1(Curve1: Adaptor2d_Curve2d, Domain1: IntRes2d_Domain, Curve2: Adaptor2d_Curve2d, Domain2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(Curve1: Adaptor2d_Curve2d, Domain1: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  SetMinNbSamples(theMinNbSamples: Graphic3d_ZLayerId): void;
  GetMinNbSamples(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Geom2dInt_IntConicCurveOfGInter extends IntRes2d_Intersection {
  Perform_1(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Geom2dInt_IntConicCurveOfGInter_1 extends Geom2dInt_IntConicCurveOfGInter {
    constructor();
  }

  export declare class Geom2dInt_IntConicCurveOfGInter_2 extends Geom2dInt_IntConicCurveOfGInter {
    constructor(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_IntConicCurveOfGInter_3 extends Geom2dInt_IntConicCurveOfGInter {
    constructor(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_IntConicCurveOfGInter_4 extends Geom2dInt_IntConicCurveOfGInter {
    constructor(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_IntConicCurveOfGInter_5 extends Geom2dInt_IntConicCurveOfGInter {
    constructor(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_IntConicCurveOfGInter_6 extends Geom2dInt_IntConicCurveOfGInter {
    constructor(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class Geom2dInt_TheProjPCurOfGInter {
  constructor();
  static FindParameter_1(C: Adaptor2d_Curve2d, Pnt: gp_Pnt2d, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static FindParameter_2(C: Adaptor2d_Curve2d, Pnt: gp_Pnt2d, LowParameter: Quantity_AbsorbedDose, HighParameter: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter {
  Initialize(C: Adaptor2d_Curve2d, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose): void;
  Perform(P: gp_Pnt2d, U0: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  SquareDistance(): Quantity_AbsorbedDose;
  IsMin(): Standard_Boolean;
  Point(): Extrema_POnCurv2d;
  delete(): void;
}

  export declare class Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_1 extends Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter {
    constructor();
  }

  export declare class Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_2 extends Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_3 extends Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, Umin: Quantity_AbsorbedDose, Usup: Quantity_AbsorbedDose, TolU: Quantity_AbsorbedDose);
  }

export declare class Geom2dInt_Geom2dCurveTool {
  constructor();
  static GetType(C: Adaptor2d_Curve2d): GeomAbs_CurveType;
  static Line(C: Adaptor2d_Curve2d): gp_Lin2d;
  static Circle(C: Adaptor2d_Curve2d): gp_Circ2d;
  static Ellipse(C: Adaptor2d_Curve2d): gp_Elips2d;
  static Parabola(C: Adaptor2d_Curve2d): gp_Parab2d;
  static Hyperbola(C: Adaptor2d_Curve2d): gp_Hypr2d;
  static EpsX_1(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static EpsX_2(C: Adaptor2d_Curve2d, Eps_XYZ: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static NbSamples_1(C: Adaptor2d_Curve2d): Graphic3d_ZLayerId;
  static NbSamples_2(C: Adaptor2d_Curve2d, U0: Quantity_AbsorbedDose, U1: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static FirstParameter(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static LastParameter(C: Adaptor2d_Curve2d): Quantity_AbsorbedDose;
  static Value(C: Adaptor2d_Curve2d, X: Quantity_AbsorbedDose): gp_Pnt2d;
  static D0(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  static D1(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d): void;
  static D2(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d, N: gp_Vec2d): void;
  static D3(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, P: gp_Pnt2d, T: gp_Vec2d, N: gp_Vec2d, V: gp_Vec2d): void;
  static DN(C: Adaptor2d_Curve2d, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  static NbIntervals(C: Adaptor2d_Curve2d): Graphic3d_ZLayerId;
  static Intervals(C: Adaptor2d_Curve2d, Tab: TColStd_Array1OfReal): void;
  static GetInterval(C: Adaptor2d_Curve2d, Index: Graphic3d_ZLayerId, Tab: TColStd_Array1OfReal, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  static Degree(C: Adaptor2d_Curve2d): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Geom2dInt_TheIntConicCurveOfGInter extends IntRes2d_Intersection {
  Perform_1(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_2(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_3(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_4(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Perform_5(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Geom2dInt_TheIntConicCurveOfGInter_1 extends Geom2dInt_TheIntConicCurveOfGInter {
    constructor();
  }

  export declare class Geom2dInt_TheIntConicCurveOfGInter_2 extends Geom2dInt_TheIntConicCurveOfGInter {
    constructor(L: gp_Lin2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_TheIntConicCurveOfGInter_3 extends Geom2dInt_TheIntConicCurveOfGInter {
    constructor(C: gp_Circ2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_TheIntConicCurveOfGInter_4 extends Geom2dInt_TheIntConicCurveOfGInter {
    constructor(E: gp_Elips2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_TheIntConicCurveOfGInter_5 extends Geom2dInt_TheIntConicCurveOfGInter {
    constructor(Prb: gp_Parab2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

  export declare class Geom2dInt_TheIntConicCurveOfGInter_6 extends Geom2dInt_TheIntConicCurveOfGInter {
    constructor(H: gp_Hypr2d, D1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, D2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class Geom2dInt_ThePolygon2dOfTheIntPCurvePCurveOfGInter extends Intf_Polygon2d {
  constructor(Curve: Adaptor2d_Curve2d, NbPnt: Graphic3d_ZLayerId, Domain: IntRes2d_Domain, Tol: Quantity_AbsorbedDose)
  ComputeWithBox(Curve: Adaptor2d_Curve2d, OtherBox: Bnd_Box2d): void;
  DeflectionOverEstimation(): Quantity_AbsorbedDose;
  SetDeflectionOverEstimation(x: Quantity_AbsorbedDose): void;
  Closed_1(clos: Standard_Boolean): void;
  Closed_2(): Standard_Boolean;
  NbSegments(): Graphic3d_ZLayerId;
  Segment(theIndex: Graphic3d_ZLayerId, theBegin: gp_Pnt2d, theEnd: gp_Pnt2d): void;
  InfParameter(): Quantity_AbsorbedDose;
  SupParameter(): Quantity_AbsorbedDose;
  AutoIntersectionIsPossible(): Standard_Boolean;
  ApproxParamOnCurve(Index: Graphic3d_ZLayerId, ParamOnLine: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  CalculRegion(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, x1: Quantity_AbsorbedDose, x2: Quantity_AbsorbedDose, y1: Quantity_AbsorbedDose, y2: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  Dump(): void;
  delete(): void;
}

export declare class Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter extends IntRes2d_Intersection {
  Perform(ITool: IntCurve_IConicTool, Dom1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, Dom2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  FindU(parameter: Quantity_AbsorbedDose, point: gp_Pnt2d, TheParCurev: Adaptor2d_Curve2d, IntCurve_IConicTool: IntCurve_IConicTool): Quantity_AbsorbedDose;
  FindV(parameter: Quantity_AbsorbedDose, point: gp_Pnt2d, IntCurve_IConicTool: IntCurve_IConicTool, ParCurve: Adaptor2d_Curve2d, TheParCurveDomain: IntRes2d_Domain, V0: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  And_Domaine_Objet1_Intersections(IntCurve_IConicTool: IntCurve_IConicTool, TheParCurve: Adaptor2d_Curve2d, TheImpCurveDomain: IntRes2d_Domain, TheParCurveDomain: IntRes2d_Domain, NbResultats: Graphic3d_ZLayerId, Inter2_And_Domain2: TColStd_Array1OfReal, Inter1: TColStd_Array1OfReal, Resultat1: TColStd_Array1OfReal, Resultat2: TColStd_Array1OfReal, EpsNul: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter_1 extends Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter {
    constructor();
  }

  export declare class Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter_2 extends Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter {
    constructor(ITool: IntCurve_IConicTool, Dom1: IntRes2d_Domain, PCurve: Adaptor2d_Curve2d, Dom2: IntRes2d_Domain, TolConf: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter extends math_FunctionWithDerivative {
  Initialize(C: Adaptor2d_Curve2d): void;
  SetPoint(P: gp_Pnt2d): void;
  Value(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(U: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  Values(U: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, DF: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  NbExt(): Graphic3d_ZLayerId;
  SquareDistance(N: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsMin(N: Graphic3d_ZLayerId): Standard_Boolean;
  Point(N: Graphic3d_ZLayerId): Extrema_POnCurv2d;
  SubIntervalInitialize(theUfirst: Quantity_AbsorbedDose, theUlast: Quantity_AbsorbedDose): void;
  SearchOfTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter_1 extends Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter {
    constructor();
  }

  export declare class Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter_2 extends Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter {
    constructor(P: gp_Pnt2d, C: Adaptor2d_Curve2d);
  }

export declare class Geom2dInt_TheCurveLocatorOfTheProjPCurOfGInter {
  constructor();
  delete(): void;
}

export declare class Geom2dInt_TheDistBetweenPCurvesOfTheIntPCurvePCurveOfGInter extends math_FunctionSetWithDerivatives {
  constructor(curve1: Adaptor2d_Curve2d, curve2: Adaptor2d_Curve2d)
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class STEPCAFControl_GDTProperty {
  constructor()
  static GetDimModifiers(theCRI: Handle_StepRepr_CompoundRepresentationItem, theModifiers: XCAFDimTolObjects_DimensionModifiersSequence): void;
  static GetDimClassOfTolerance(theLAF: Handle_StepShape_LimitsAndFits, theHolle: Standard_Boolean, theFV: XCAFDimTolObjects_DimensionFormVariance, theG: XCAFDimTolObjects_DimensionGrade): void;
  static GetDimType(theName: Handle_TCollection_HAsciiString, theType: XCAFDimTolObjects_DimensionType): Standard_Boolean;
  static GetDatumTargetType(theDescription: Handle_TCollection_HAsciiString, theType: XCAFDimTolObjects_DatumTargetType): Standard_Boolean;
  static GetDimQualifierType(theDescription: Handle_TCollection_HAsciiString, theType: XCAFDimTolObjects_DimensionQualifier): Standard_Boolean;
  static GetTolValueType_1(theDescription: Handle_TCollection_HAsciiString, theType: XCAFDimTolObjects_GeomToleranceTypeValue): Standard_Boolean;
  static GetTolValueType_2(theType: XCAFDimTolObjects_GeomToleranceTypeValue): Handle_TCollection_HAsciiString;
  static GetDimTypeName(theType: XCAFDimTolObjects_DimensionType): Handle_TCollection_HAsciiString;
  static GetDimQualifierName(theQualifier: XCAFDimTolObjects_DimensionQualifier): Handle_TCollection_HAsciiString;
  static GetDimModifierName(theModifier: XCAFDimTolObjects_DimensionModif): Handle_TCollection_HAsciiString;
  static GetLimitsAndFits(theHole: Standard_Boolean, theFormVariance: XCAFDimTolObjects_DimensionFormVariance, theGrade: XCAFDimTolObjects_DimensionGrade): Handle_StepShape_LimitsAndFits;
  static GetDatumTargetName(theDatumType: XCAFDimTolObjects_DatumTargetType): Handle_TCollection_HAsciiString;
  static IsDimensionalLocation(theType: XCAFDimTolObjects_DimensionType): Standard_Boolean;
  static IsDimensionalSize(theType: XCAFDimTolObjects_DimensionType): Standard_Boolean;
  static GetGeomToleranceType_1(theType: XCAFDimTolObjects_GeomToleranceType): StepDimTol_GeometricToleranceType;
  static GetGeomToleranceType_2(theType: StepDimTol_GeometricToleranceType): XCAFDimTolObjects_GeomToleranceType;
  static GetGeomTolerance(theType: XCAFDimTolObjects_GeomToleranceType): Handle_StepDimTol_GeometricTolerance;
  static GetGeomToleranceModifier(theModifier: XCAFDimTolObjects_GeomToleranceModif): StepDimTol_GeometricToleranceModifier;
  static GetDatumRefModifiers(theModifiers: XCAFDimTolObjects_DatumModifiersSequence, theModifWithVal: XCAFDimTolObjects_DatumModifWithValue, theValue: Quantity_AbsorbedDose, theUnit: StepBasic_Unit): Handle_StepDimTol_HArray1OfDatumReferenceModifier;
  static GetTessellation(theShape: TopoDS_Shape): Handle_StepVisual_TessellatedGeometricSet;
  delete(): void;
}

export declare class STEPCAFControl_ExternFile extends Standard_Transient {
  constructor()
  SetWS(WS: Handle_XSControl_WorkSession): void;
  GetWS(): Handle_XSControl_WorkSession;
  SetLoadStatus(stat: IFSelect_ReturnStatus): void;
  GetLoadStatus(): IFSelect_ReturnStatus;
  SetTransferStatus(isok: Standard_Boolean): void;
  GetTransferStatus(): Standard_Boolean;
  SetWriteStatus(stat: IFSelect_ReturnStatus): void;
  GetWriteStatus(): IFSelect_ReturnStatus;
  SetName(name: Handle_TCollection_HAsciiString): void;
  GetName(): Handle_TCollection_HAsciiString;
  SetLabel(L: TDF_Label): void;
  GetLabel(): TDF_Label;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPCAFControl_ExternFile {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPCAFControl_ExternFile): void;
  get(): STEPCAFControl_ExternFile;
  delete(): void;
}

  export declare class Handle_STEPCAFControl_ExternFile_1 extends Handle_STEPCAFControl_ExternFile {
    constructor();
  }

  export declare class Handle_STEPCAFControl_ExternFile_2 extends Handle_STEPCAFControl_ExternFile {
    constructor(thePtr: STEPCAFControl_ExternFile);
  }

  export declare class Handle_STEPCAFControl_ExternFile_3 extends Handle_STEPCAFControl_ExternFile {
    constructor(theHandle: Handle_STEPCAFControl_ExternFile);
  }

  export declare class Handle_STEPCAFControl_ExternFile_4 extends Handle_STEPCAFControl_ExternFile {
    constructor(theHandle: Handle_STEPCAFControl_ExternFile);
  }

export declare class Handle_STEPCAFControl_ActorWrite {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPCAFControl_ActorWrite): void;
  get(): STEPCAFControl_ActorWrite;
  delete(): void;
}

  export declare class Handle_STEPCAFControl_ActorWrite_1 extends Handle_STEPCAFControl_ActorWrite {
    constructor();
  }

  export declare class Handle_STEPCAFControl_ActorWrite_2 extends Handle_STEPCAFControl_ActorWrite {
    constructor(thePtr: STEPCAFControl_ActorWrite);
  }

  export declare class Handle_STEPCAFControl_ActorWrite_3 extends Handle_STEPCAFControl_ActorWrite {
    constructor(theHandle: Handle_STEPCAFControl_ActorWrite);
  }

  export declare class Handle_STEPCAFControl_ActorWrite_4 extends Handle_STEPCAFControl_ActorWrite {
    constructor(theHandle: Handle_STEPCAFControl_ActorWrite);
  }

export declare class STEPCAFControl_ActorWrite extends STEPControl_ActorWrite {
  constructor()
  IsAssembly(S: TopoDS_Shape): Standard_Boolean;
  SetStdMode(stdmode: Standard_Boolean): void;
  ClearMap(): void;
  RegisterAssembly(S: TopoDS_Shape): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class STEPCAFControl_Reader {
  Init(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean): void;
  ReadFile(filename: Standard_CString): IFSelect_ReturnStatus;
  NbRootsForTransfer(): Graphic3d_ZLayerId;
  TransferOneRoot(num: Graphic3d_ZLayerId, doc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  Transfer_1(doc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_1(filename: XCAFDoc_PartId, doc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_2(filename: Standard_CString, doc: Handle_TDocStd_Document, theProgress: Message_ProgressRange): Standard_Boolean;
  ExternFiles(): any;
  ExternFile(name: Standard_CString, ef: Handle_STEPCAFControl_ExternFile): Standard_Boolean;
  ChangeReader(): STEPControl_Reader;
  Reader(): STEPControl_Reader;
  static FindInstance(NAUO: Handle_StepRepr_NextAssemblyUsageOccurrence, STool: Handle_XCAFDoc_ShapeTool, Tool: STEPConstruct_Tool, ShapeLabelMap: XCAFDoc_DataMapOfShapeLabel): TDF_Label;
  SetColorMode(colormode: Standard_Boolean): void;
  GetColorMode(): Standard_Boolean;
  SetNameMode(namemode: Standard_Boolean): void;
  GetNameMode(): Standard_Boolean;
  SetLayerMode(layermode: Standard_Boolean): void;
  GetLayerMode(): Standard_Boolean;
  SetPropsMode(propsmode: Standard_Boolean): void;
  GetPropsMode(): Standard_Boolean;
  SetSHUOMode(shuomode: Standard_Boolean): void;
  GetSHUOMode(): Standard_Boolean;
  SetGDTMode(gdtmode: Standard_Boolean): void;
  GetGDTMode(): Standard_Boolean;
  SetMatMode(matmode: Standard_Boolean): void;
  GetMatMode(): Standard_Boolean;
  SetViewMode(viewmode: Standard_Boolean): void;
  GetViewMode(): Standard_Boolean;
  delete(): void;
}

  export declare class STEPCAFControl_Reader_1 extends STEPCAFControl_Reader {
    constructor();
  }

  export declare class STEPCAFControl_Reader_2 extends STEPCAFControl_Reader {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class STEPCAFControl_DataMapOfLabelShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: STEPCAFControl_DataMapOfLabelShape): void;
  Assign(theOther: STEPCAFControl_DataMapOfLabelShape): STEPCAFControl_DataMapOfLabelShape;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TDF_Label, theItem: TopoDS_Shape): Standard_Boolean;
  Bound(theKey: TDF_Label, theItem: TopoDS_Shape): TopoDS_Shape;
  IsBound(theKey: TDF_Label): Standard_Boolean;
  UnBind(theKey: TDF_Label): Standard_Boolean;
  Seek(theKey: TDF_Label): TopoDS_Shape;
  ChangeSeek(theKey: TDF_Label): TopoDS_Shape;
  ChangeFind(theKey: TDF_Label): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class STEPCAFControl_DataMapOfLabelShape_1 extends STEPCAFControl_DataMapOfLabelShape {
    constructor();
  }

  export declare class STEPCAFControl_DataMapOfLabelShape_2 extends STEPCAFControl_DataMapOfLabelShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class STEPCAFControl_DataMapOfLabelShape_3 extends STEPCAFControl_DataMapOfLabelShape {
    constructor(theOther: STEPCAFControl_DataMapOfLabelShape);
  }

export declare class Handle_STEPCAFControl_Controller {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPCAFControl_Controller): void;
  get(): STEPCAFControl_Controller;
  delete(): void;
}

  export declare class Handle_STEPCAFControl_Controller_1 extends Handle_STEPCAFControl_Controller {
    constructor();
  }

  export declare class Handle_STEPCAFControl_Controller_2 extends Handle_STEPCAFControl_Controller {
    constructor(thePtr: STEPCAFControl_Controller);
  }

  export declare class Handle_STEPCAFControl_Controller_3 extends Handle_STEPCAFControl_Controller {
    constructor(theHandle: Handle_STEPCAFControl_Controller);
  }

  export declare class Handle_STEPCAFControl_Controller_4 extends Handle_STEPCAFControl_Controller {
    constructor(theHandle: Handle_STEPCAFControl_Controller);
  }

export declare class STEPCAFControl_Controller extends STEPControl_Controller {
  constructor()
  static Init(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class STEPCAFControl_Writer {
  Init(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean): void;
  Write(filename: Standard_CString): IFSelect_ReturnStatus;
  Transfer_1(doc: Handle_TDocStd_Document, mode: STEPControl_StepModelType, multi: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  Transfer_2(L: TDF_Label, mode: STEPControl_StepModelType, multi: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_1(doc: Handle_TDocStd_Document, filename: XCAFDoc_PartId, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_2(doc: Handle_TDocStd_Document, filename: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  ExternFiles(): any;
  ExternFile_1(L: TDF_Label, ef: Handle_STEPCAFControl_ExternFile): Standard_Boolean;
  ExternFile_2(name: Standard_CString, ef: Handle_STEPCAFControl_ExternFile): Standard_Boolean;
  ChangeWriter(): STEPControl_Writer;
  Writer(): STEPControl_Writer;
  SetColorMode(colormode: Standard_Boolean): void;
  GetColorMode(): Standard_Boolean;
  SetNameMode(namemode: Standard_Boolean): void;
  GetNameMode(): Standard_Boolean;
  SetLayerMode(layermode: Standard_Boolean): void;
  GetLayerMode(): Standard_Boolean;
  SetPropsMode(propsmode: Standard_Boolean): void;
  GetPropsMode(): Standard_Boolean;
  SetSHUOMode(shuomode: Standard_Boolean): void;
  GetSHUOMode(): Standard_Boolean;
  SetDimTolMode(dimtolmode: Standard_Boolean): void;
  GetDimTolMode(): Standard_Boolean;
  SetMaterialMode(matmode: Standard_Boolean): void;
  GetMaterialMode(): Standard_Boolean;
  delete(): void;
}

  export declare class STEPCAFControl_Writer_1 extends STEPCAFControl_Writer {
    constructor();
  }

  export declare class STEPCAFControl_Writer_2 extends STEPCAFControl_Writer {
    constructor(WS: Handle_XSControl_WorkSession, scratch: Standard_Boolean);
  }

export declare class Handle_BSplSLib_Cache {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BSplSLib_Cache): void;
  get(): BSplSLib_Cache;
  delete(): void;
}

  export declare class Handle_BSplSLib_Cache_1 extends Handle_BSplSLib_Cache {
    constructor();
  }

  export declare class Handle_BSplSLib_Cache_2 extends Handle_BSplSLib_Cache {
    constructor(thePtr: BSplSLib_Cache);
  }

  export declare class Handle_BSplSLib_Cache_3 extends Handle_BSplSLib_Cache {
    constructor(theHandle: Handle_BSplSLib_Cache);
  }

  export declare class Handle_BSplSLib_Cache_4 extends Handle_BSplSLib_Cache {
    constructor(theHandle: Handle_BSplSLib_Cache);
  }

export declare class BSplSLib_Cache extends Standard_Transient {
  constructor(theDegreeU: Graphic3d_ZLayerId, thePeriodicU: Standard_Boolean, theFlatKnotsU: TColStd_Array1OfReal, theDegreeV: Graphic3d_ZLayerId, thePeriodicV: Standard_Boolean, theFlatKnotsV: TColStd_Array1OfReal, theWeights: TColStd_Array2OfReal)
  IsCacheValid(theParameterU: Quantity_AbsorbedDose, theParameterV: Quantity_AbsorbedDose): Standard_Boolean;
  BuildCache(theParameterU: Quantity_AbsorbedDose, theParameterV: Quantity_AbsorbedDose, theFlatKnotsU: TColStd_Array1OfReal, theFlatKnotsV: TColStd_Array1OfReal, thePoles: TColgp_Array2OfPnt, theWeights: TColStd_Array2OfReal): void;
  D0(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, thePoint: gp_Pnt): void;
  D1(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, thePoint: gp_Pnt, theTangentU: gp_Vec, theTangentV: gp_Vec): void;
  D2(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, thePoint: gp_Pnt, theTangentU: gp_Vec, theTangentV: gp_Vec, theCurvatureU: gp_Vec, theCurvatureV: gp_Vec, theCurvatureUV: gp_Vec): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BSplSLib {
  constructor();
  static RationalDerivative(UDeg: Graphic3d_ZLayerId, VDeg: Graphic3d_ZLayerId, N: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId, Ders: Quantity_AbsorbedDose, RDers: Quantity_AbsorbedDose, All: Standard_Boolean): void;
  static D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, P: gp_Pnt): void;
  static D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec): void;
  static D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec): void;
  static D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, P: gp_Pnt, Vu: gp_Vec, Vv: gp_Vec, Vuu: gp_Vec, Vvv: gp_Vec, Vuv: gp_Vec, Vuuu: gp_Vec, Vvvv: gp_Vec, Vuuv: gp_Vec, Vuvv: gp_Vec): void;
  static DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, Vn: gp_Vec): void;
  static Iso(Param: Quantity_AbsorbedDose, IsU: Standard_Boolean, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, CPoles: TColgp_Array1OfPnt, CWeights: TColStd_Array1OfReal): void;
  static Reverse_1(Poles: TColgp_Array2OfPnt, Last: Graphic3d_ZLayerId, UDirection: Standard_Boolean): void;
  static HomogeneousD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, W: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static HomogeneousD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, N: gp_Pnt, Nu: gp_Vec, Nv: gp_Vec, D: Quantity_AbsorbedDose, Du: Quantity_AbsorbedDose, Dv: Quantity_AbsorbedDose): void;
  static Reverse_2(Weights: TColStd_Array2OfReal, Last: Graphic3d_ZLayerId, UDirection: Standard_Boolean): void;
  static IsRational(Weights: TColStd_Array2OfReal, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, J1: Graphic3d_ZLayerId, J2: Graphic3d_ZLayerId, Epsilon: Quantity_AbsorbedDose): Standard_Boolean;
  static SetPoles_1(Poles: TColgp_Array2OfPnt, FP: TColStd_Array1OfReal, UDirection: Standard_Boolean): void;
  static SetPoles_2(Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, FP: TColStd_Array1OfReal, UDirection: Standard_Boolean): void;
  static GetPoles_1(FP: TColStd_Array1OfReal, Poles: TColgp_Array2OfPnt, UDirection: Standard_Boolean): void;
  static GetPoles_2(FP: TColStd_Array1OfReal, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UDirection: Standard_Boolean): void;
  static MovePoint(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Displ: gp_Vec, UIndex1: Graphic3d_ZLayerId, UIndex2: Graphic3d_ZLayerId, VIndex1: Graphic3d_ZLayerId, VIndex2: Graphic3d_ZLayerId, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, Rational: Standard_Boolean, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UFlatKnots: TColStd_Array1OfReal, VFlatKnots: TColStd_Array1OfReal, UFirstIndex: Graphic3d_ZLayerId, ULastIndex: Graphic3d_ZLayerId, VFirstIndex: Graphic3d_ZLayerId, VLastIndex: Graphic3d_ZLayerId, NewPoles: TColgp_Array2OfPnt): void;
  static InsertKnots(UDirection: Standard_Boolean, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, AddKnots: TColStd_Array1OfReal, AddMults: TColStd_Array1OfInteger, NewPoles: TColgp_Array2OfPnt, NewWeights: TColStd_Array2OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Epsilon: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  static RemoveKnot(UDirection: Standard_Boolean, Index: Graphic3d_ZLayerId, Mult: Graphic3d_ZLayerId, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array2OfPnt, NewWeights: TColStd_Array2OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  static IncreaseDegree(UDirection: Standard_Boolean, Degree: Graphic3d_ZLayerId, NewDegree: Graphic3d_ZLayerId, Periodic: Standard_Boolean, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, NewPoles: TColgp_Array2OfPnt, NewWeights: TColStd_Array2OfReal, NewKnots: TColStd_Array1OfReal, NewMults: TColStd_Array1OfInteger): void;
  static Unperiodize(UDirection: Standard_Boolean, Degree: Graphic3d_ZLayerId, Mults: TColStd_Array1OfInteger, Knots: TColStd_Array1OfReal, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, NewMults: TColStd_Array1OfInteger, NewKnots: TColStd_Array1OfReal, NewPoles: TColgp_Array2OfPnt, NewWeights: TColStd_Array2OfReal): void;
  static NoWeights(): TColStd_Array2OfReal;
  static BuildCache_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, USpanDomain: Quantity_AbsorbedDose, VSpanDomain: Quantity_AbsorbedDose, UPeriodicFlag: Standard_Boolean, VPeriodicFlag: Standard_Boolean, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UIndex: Graphic3d_ZLayerId, VIndex: Graphic3d_ZLayerId, UFlatKnots: TColStd_Array1OfReal, VFlatKnots: TColStd_Array1OfReal, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, CachePoles: TColgp_Array2OfPnt, CacheWeights: TColStd_Array2OfReal): void;
  static BuildCache_2(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose, theUSpanDomain: Quantity_AbsorbedDose, theVSpanDomain: Quantity_AbsorbedDose, theUPeriodic: Standard_Boolean, theVPeriodic: Standard_Boolean, theUDegree: Graphic3d_ZLayerId, theVDegree: Graphic3d_ZLayerId, theUIndex: Graphic3d_ZLayerId, theVIndex: Graphic3d_ZLayerId, theUFlatKnots: TColStd_Array1OfReal, theVFlatKnots: TColStd_Array1OfReal, thePoles: TColgp_Array2OfPnt, theWeights: TColStd_Array2OfReal, theCacheArray: TColStd_Array2OfReal): void;
  static CacheD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UCacheParameter: Quantity_AbsorbedDose, VCacheParameter: Quantity_AbsorbedDose, USpanLenght: Quantity_AbsorbedDose, VSpanLength: Quantity_AbsorbedDose, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Point: gp_Pnt): void;
  static CoefsD0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Point: gp_Pnt): void;
  static CacheD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UCacheParameter: Quantity_AbsorbedDose, VCacheParameter: Quantity_AbsorbedDose, USpanLenght: Quantity_AbsorbedDose, VSpanLength: Quantity_AbsorbedDose, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Point: gp_Pnt, VecU: gp_Vec, VecV: gp_Vec): void;
  static CoefsD1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Point: gp_Pnt, VecU: gp_Vec, VecV: gp_Vec): void;
  static CacheD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UCacheParameter: Quantity_AbsorbedDose, VCacheParameter: Quantity_AbsorbedDose, USpanLenght: Quantity_AbsorbedDose, VSpanLength: Quantity_AbsorbedDose, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Point: gp_Pnt, VecU: gp_Vec, VecV: gp_Vec, VecUU: gp_Vec, VecUV: gp_Vec, VecVV: gp_Vec): void;
  static CoefsD2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, Point: gp_Pnt, VecU: gp_Vec, VecV: gp_Vec, VecUU: gp_Vec, VecUV: gp_Vec, VecVV: gp_Vec): void;
  static PolesCoefficients_1(Poles: TColgp_Array2OfPnt, CachePoles: TColgp_Array2OfPnt): void;
  static PolesCoefficients_2(Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, CachePoles: TColgp_Array2OfPnt, CacheWeights: TColStd_Array2OfReal): void;
  static Resolution(Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UKnots: TColStd_Array1OfReal, VKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, URat: Standard_Boolean, VRat: Standard_Boolean, UPer: Standard_Boolean, VPer: Standard_Boolean, Tolerance3D: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose, VTolerance: Quantity_AbsorbedDose): void;
  static Interpolate_1(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UFlatKnots: TColStd_Array1OfReal, VFlatKnots: TColStd_Array1OfReal, UParameters: TColStd_Array1OfReal, VParameters: TColStd_Array1OfReal, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, InversionProblem: Graphic3d_ZLayerId): void;
  static Interpolate_2(UDegree: Graphic3d_ZLayerId, VDegree: Graphic3d_ZLayerId, UFlatKnots: TColStd_Array1OfReal, VFlatKnots: TColStd_Array1OfReal, UParameters: TColStd_Array1OfReal, VParameters: TColStd_Array1OfReal, Poles: TColgp_Array2OfPnt, InversionProblem: Graphic3d_ZLayerId): void;
  static FunctionMultiply(Function: BSplSLib_EvaluatorFunction, UBSplineDegree: Graphic3d_ZLayerId, VBSplineDegree: Graphic3d_ZLayerId, UBSplineKnots: TColStd_Array1OfReal, VBSplineKnots: TColStd_Array1OfReal, UMults: TColStd_Array1OfInteger, VMults: TColStd_Array1OfInteger, Poles: TColgp_Array2OfPnt, Weights: TColStd_Array2OfReal, UFlatKnots: TColStd_Array1OfReal, VFlatKnots: TColStd_Array1OfReal, UNewDegree: Graphic3d_ZLayerId, VNewDegree: Graphic3d_ZLayerId, NewNumerator: TColgp_Array2OfPnt, NewDenominator: TColStd_Array2OfReal, theStatus: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class BSplSLib_EvaluatorFunction {
  Evaluate(theDerivativeRequest: Graphic3d_ZLayerId, theUParameter: Quantity_AbsorbedDose, theVParameter: Quantity_AbsorbedDose, theResult: Quantity_AbsorbedDose, theErrorCode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TopTrans_Array2OfOrientation {
  Init(theValue: TopAbs_Orientation): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  NbRows(): Standard_Integer;
  NbColumns(): Standard_Integer;
  RowLength(): Standard_Integer;
  ColLength(): Standard_Integer;
  LowerRow(): Standard_Integer;
  UpperRow(): Standard_Integer;
  LowerCol(): Standard_Integer;
  UpperCol(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  Assign(theOther: TopTrans_Array2OfOrientation): TopTrans_Array2OfOrientation;
  Move(theOther: TopTrans_Array2OfOrientation): TopTrans_Array2OfOrientation;
  Value(theRow: Standard_Integer, theCol: Standard_Integer): TopAbs_Orientation;
  ChangeValue(theRow: Standard_Integer, theCol: Standard_Integer): TopAbs_Orientation;
  SetValue(theRow: Standard_Integer, theCol: Standard_Integer, theItem: TopAbs_Orientation): void;
  Resize(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TopTrans_Array2OfOrientation_1 extends TopTrans_Array2OfOrientation {
    constructor();
  }

  export declare class TopTrans_Array2OfOrientation_2 extends TopTrans_Array2OfOrientation {
    constructor(theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

  export declare class TopTrans_Array2OfOrientation_3 extends TopTrans_Array2OfOrientation {
    constructor(theOther: TopTrans_Array2OfOrientation);
  }

  export declare class TopTrans_Array2OfOrientation_4 extends TopTrans_Array2OfOrientation {
    constructor(theOther: TopTrans_Array2OfOrientation);
  }

  export declare class TopTrans_Array2OfOrientation_5 extends TopTrans_Array2OfOrientation {
    constructor(theBegin: TopAbs_Orientation, theRowLower: Standard_Integer, theRowUpper: Standard_Integer, theColLower: Standard_Integer, theColUpper: Standard_Integer);
  }

export declare class TopTrans_CurveTransition {
  constructor()
  Reset_1(Tgt: gp_Dir, Norm: gp_Dir, Curv: Quantity_AbsorbedDose): void;
  Reset_2(Tgt: gp_Dir): void;
  Compare_1(Tole: Quantity_AbsorbedDose, Tang: gp_Dir, Norm: gp_Dir, Curv: Quantity_AbsorbedDose, S: TopAbs_Orientation, Or: TopAbs_Orientation): void;
  StateBefore(): TopAbs_State;
  StateAfter(): TopAbs_State;
  delete(): void;
}

export declare class TopTrans_SurfaceTransition {
  constructor()
  Reset_1(Tgt: gp_Dir, Norm: gp_Dir, MaxD: gp_Dir, MinD: gp_Dir, MaxCurv: Quantity_AbsorbedDose, MinCurv: Quantity_AbsorbedDose): void;
  Reset_2(Tgt: gp_Dir, Norm: gp_Dir): void;
  Compare_1(Tole: Quantity_AbsorbedDose, Norm: gp_Dir, MaxD: gp_Dir, MinD: gp_Dir, MaxCurv: Quantity_AbsorbedDose, MinCurv: Quantity_AbsorbedDose, S: TopAbs_Orientation, O: TopAbs_Orientation): void;
  Compare_2(Tole: Quantity_AbsorbedDose, Norm: gp_Dir, S: TopAbs_Orientation, O: TopAbs_Orientation): void;
  StateBefore(): TopAbs_State;
  StateAfter(): TopAbs_State;
  static GetBefore(Tran: TopAbs_Orientation): TopAbs_State;
  static GetAfter(Tran: TopAbs_Orientation): TopAbs_State;
  delete(): void;
}

export declare class BRepLProp_SLProps {
  SetSurface(S: BRepAdaptor_Surface): void;
  SetParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  D1U(): gp_Vec;
  D1V(): gp_Vec;
  D2U(): gp_Vec;
  D2V(): gp_Vec;
  DUV(): gp_Vec;
  IsTangentUDefined(): Standard_Boolean;
  TangentU(D: gp_Dir): void;
  IsTangentVDefined(): Standard_Boolean;
  TangentV(D: gp_Dir): void;
  IsNormalDefined(): Standard_Boolean;
  Normal(): gp_Dir;
  IsCurvatureDefined(): Standard_Boolean;
  IsUmbilic(): Standard_Boolean;
  MaxCurvature(): Quantity_AbsorbedDose;
  MinCurvature(): Quantity_AbsorbedDose;
  CurvatureDirections(MaxD: gp_Dir, MinD: gp_Dir): void;
  MeanCurvature(): Quantity_AbsorbedDose;
  GaussianCurvature(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepLProp_SLProps_1 extends BRepLProp_SLProps {
    constructor(S: BRepAdaptor_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class BRepLProp_SLProps_2 extends BRepLProp_SLProps {
    constructor(S: BRepAdaptor_Surface, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class BRepLProp_SLProps_3 extends BRepLProp_SLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class BRepLProp_CurveTool {
  constructor();
  static Value(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  static D2(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  static D3(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  static Continuity(C: BRepAdaptor_Curve): Graphic3d_ZLayerId;
  static FirstParameter(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  static LastParameter(C: BRepAdaptor_Curve): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepLProp {
  constructor();
  static Continuity_1(C1: BRepAdaptor_Curve, C2: BRepAdaptor_Curve, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, tl: Quantity_AbsorbedDose, ta: Quantity_AbsorbedDose): GeomAbs_Shape;
  static Continuity_2(C1: BRepAdaptor_Curve, C2: BRepAdaptor_Curve, u1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose): GeomAbs_Shape;
  delete(): void;
}

export declare class BRepLProp_CLProps {
  SetParameter(U: Quantity_AbsorbedDose): void;
  SetCurve(C: BRepAdaptor_Curve): void;
  Value(): gp_Pnt;
  D1(): gp_Vec;
  D2(): gp_Vec;
  D3(): gp_Vec;
  IsTangentDefined(): Standard_Boolean;
  Tangent(D: gp_Dir): void;
  Curvature(): Quantity_AbsorbedDose;
  Normal(N: gp_Dir): void;
  CentreOfCurvature(P: gp_Pnt): void;
  delete(): void;
}

  export declare class BRepLProp_CLProps_1 extends BRepLProp_CLProps {
    constructor(C: BRepAdaptor_Curve, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class BRepLProp_CLProps_2 extends BRepLProp_CLProps {
    constructor(C: BRepAdaptor_Curve, U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

  export declare class BRepLProp_CLProps_3 extends BRepLProp_CLProps {
    constructor(N: Graphic3d_ZLayerId, Resolution: Quantity_AbsorbedDose);
  }

export declare class BRepLProp_SurfaceTool {
  constructor();
  static Value(S: BRepAdaptor_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  static D1(S: BRepAdaptor_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  static D2(S: BRepAdaptor_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, DUV: gp_Vec): void;
  static DN(S: BRepAdaptor_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, IU: Graphic3d_ZLayerId, IV: Graphic3d_ZLayerId): gp_Vec;
  static Continuity(S: BRepAdaptor_Surface): Graphic3d_ZLayerId;
  static Bounds(S: BRepAdaptor_Surface, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Resource_DataMapOfAsciiStringExtendedString extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Resource_DataMapOfAsciiStringExtendedString): void;
  Assign(theOther: Resource_DataMapOfAsciiStringExtendedString): Resource_DataMapOfAsciiStringExtendedString;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_AsciiString, theItem: TCollection_ExtendedString): Standard_Boolean;
  Bound(theKey: TCollection_AsciiString, theItem: TCollection_ExtendedString): TCollection_ExtendedString;
  IsBound(theKey: TCollection_AsciiString): Standard_Boolean;
  UnBind(theKey: TCollection_AsciiString): Standard_Boolean;
  Seek(theKey: TCollection_AsciiString): TCollection_ExtendedString;
  ChangeSeek(theKey: TCollection_AsciiString): TCollection_ExtendedString;
  ChangeFind(theKey: TCollection_AsciiString): TCollection_ExtendedString;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Resource_DataMapOfAsciiStringExtendedString_1 extends Resource_DataMapOfAsciiStringExtendedString {
    constructor();
  }

  export declare class Resource_DataMapOfAsciiStringExtendedString_2 extends Resource_DataMapOfAsciiStringExtendedString {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Resource_DataMapOfAsciiStringExtendedString_3 extends Resource_DataMapOfAsciiStringExtendedString {
    constructor(theOther: Resource_DataMapOfAsciiStringExtendedString);
  }

export declare class Handle_Resource_Manager {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Resource_Manager): void;
  get(): Resource_Manager;
  delete(): void;
}

  export declare class Handle_Resource_Manager_1 extends Handle_Resource_Manager {
    constructor();
  }

  export declare class Handle_Resource_Manager_2 extends Handle_Resource_Manager {
    constructor(thePtr: Resource_Manager);
  }

  export declare class Handle_Resource_Manager_3 extends Handle_Resource_Manager {
    constructor(theHandle: Handle_Resource_Manager);
  }

  export declare class Handle_Resource_Manager_4 extends Handle_Resource_Manager {
    constructor(theHandle: Handle_Resource_Manager);
  }

export declare class Resource_Manager extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Save(): Standard_Boolean;
  Find_1(aResource: Standard_CString): Standard_Boolean;
  Find_2(theResource: XCAFDoc_PartId, theValue: XCAFDoc_PartId): Standard_Boolean;
  Integer(aResourceName: Standard_CString): Graphic3d_ZLayerId;
  Real(aResourceName: Standard_CString): Quantity_AbsorbedDose;
  Value(aResourceName: Standard_CString): Standard_CString;
  ExtValue(aResourceName: Standard_CString): Standard_ExtString;
  SetResource_1(aResourceName: Standard_CString, aValue: Graphic3d_ZLayerId): void;
  SetResource_2(aResourceName: Standard_CString, aValue: Quantity_AbsorbedDose): void;
  SetResource_3(aResourceName: Standard_CString, aValue: Standard_CString): void;
  SetResource_4(aResourceName: Standard_CString, aValue: Standard_ExtString): void;
  static GetResourcePath(aPath: XCAFDoc_PartId, aName: Standard_CString, isUserDefaults: Standard_Boolean): void;
  delete(): void;
}

  export declare class Resource_Manager_1 extends Resource_Manager {
    constructor(aName: Standard_CString, Verbose: Standard_Boolean);
  }

  export declare class Resource_Manager_2 extends Resource_Manager {
    constructor(theName: XCAFDoc_PartId, theDefaultsDirectory: XCAFDoc_PartId, theUserDefaultsDirectory: XCAFDoc_PartId, theIsVerbose: Standard_Boolean);
  }

export declare type Resource_FormatType = {
  Resource_FormatType_SJIS: {};
  Resource_FormatType_EUC: {};
  Resource_FormatType_NoConversion: {};
  Resource_FormatType_GB: {};
  Resource_FormatType_UTF8: {};
  Resource_FormatType_SystemLocale: {};
  Resource_FormatType_CP1250: {};
  Resource_FormatType_CP1251: {};
  Resource_FormatType_CP1252: {};
  Resource_FormatType_CP1253: {};
  Resource_FormatType_CP1254: {};
  Resource_FormatType_CP1255: {};
  Resource_FormatType_CP1256: {};
  Resource_FormatType_CP1257: {};
  Resource_FormatType_CP1258: {};
  Resource_FormatType_iso8859_1: {};
  Resource_FormatType_iso8859_2: {};
  Resource_FormatType_iso8859_3: {};
  Resource_FormatType_iso8859_4: {};
  Resource_FormatType_iso8859_5: {};
  Resource_FormatType_iso8859_6: {};
  Resource_FormatType_iso8859_7: {};
  Resource_FormatType_iso8859_8: {};
  Resource_FormatType_iso8859_9: {};
  Resource_FormatType_GBK: {};
  Resource_FormatType_Big5: {};
  Resource_FormatType_ANSI: {};
  Resource_SJIS: {};
  Resource_EUC: {};
  Resource_ANSI: {};
  Resource_GB: {};
}

export declare class Resource_LexicalCompare {
  constructor()
  IsLower(Left: XCAFDoc_PartId, Right: XCAFDoc_PartId): Standard_Boolean;
  delete(): void;
}

export declare class Resource_DataMapOfAsciiStringAsciiString extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Resource_DataMapOfAsciiStringAsciiString): void;
  Assign(theOther: Resource_DataMapOfAsciiStringAsciiString): Resource_DataMapOfAsciiStringAsciiString;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_AsciiString, theItem: TCollection_AsciiString): Standard_Boolean;
  Bound(theKey: TCollection_AsciiString, theItem: TCollection_AsciiString): TCollection_AsciiString;
  IsBound(theKey: TCollection_AsciiString): Standard_Boolean;
  UnBind(theKey: TCollection_AsciiString): Standard_Boolean;
  Seek(theKey: TCollection_AsciiString): TCollection_AsciiString;
  ChangeSeek(theKey: TCollection_AsciiString): TCollection_AsciiString;
  ChangeFind(theKey: TCollection_AsciiString): TCollection_AsciiString;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Resource_DataMapOfAsciiStringAsciiString_1 extends Resource_DataMapOfAsciiStringAsciiString {
    constructor();
  }

  export declare class Resource_DataMapOfAsciiStringAsciiString_2 extends Resource_DataMapOfAsciiStringAsciiString {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Resource_DataMapOfAsciiStringAsciiString_3 extends Resource_DataMapOfAsciiStringAsciiString {
    constructor(theOther: Resource_DataMapOfAsciiStringAsciiString);
  }

export declare class Resource_NoSuchResource extends Standard_NoSuchObject {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Resource_NoSuchResource;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Resource_NoSuchResource_1 extends Resource_NoSuchResource {
    constructor();
  }

  export declare class Resource_NoSuchResource_2 extends Resource_NoSuchResource {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Resource_NoSuchResource {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Resource_NoSuchResource): void;
  get(): Resource_NoSuchResource;
  delete(): void;
}

  export declare class Handle_Resource_NoSuchResource_1 extends Handle_Resource_NoSuchResource {
    constructor();
  }

  export declare class Handle_Resource_NoSuchResource_2 extends Handle_Resource_NoSuchResource {
    constructor(thePtr: Resource_NoSuchResource);
  }

  export declare class Handle_Resource_NoSuchResource_3 extends Handle_Resource_NoSuchResource {
    constructor(theHandle: Handle_Resource_NoSuchResource);
  }

  export declare class Handle_Resource_NoSuchResource_4 extends Handle_Resource_NoSuchResource {
    constructor(theHandle: Handle_Resource_NoSuchResource);
  }

export declare class Resource_Unicode {
  constructor();
  delete(): void;
}

export declare class Handle_BinTObjDrivers_ReferenceDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_ReferenceDriver): void;
  get(): BinTObjDrivers_ReferenceDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_ReferenceDriver_1 extends Handle_BinTObjDrivers_ReferenceDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_ReferenceDriver_2 extends Handle_BinTObjDrivers_ReferenceDriver {
    constructor(thePtr: BinTObjDrivers_ReferenceDriver);
  }

  export declare class Handle_BinTObjDrivers_ReferenceDriver_3 extends Handle_BinTObjDrivers_ReferenceDriver {
    constructor(theHandle: Handle_BinTObjDrivers_ReferenceDriver);
  }

  export declare class Handle_BinTObjDrivers_ReferenceDriver_4 extends Handle_BinTObjDrivers_ReferenceDriver {
    constructor(theHandle: Handle_BinTObjDrivers_ReferenceDriver);
  }

export declare class BinTObjDrivers_ReferenceDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinTObjDrivers {
  constructor();
  static Factory(aGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AddDrivers(aDriverTable: Handle_BinMDF_ADriverTable, aMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class Handle_BinTObjDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_DocumentRetrievalDriver): void;
  get(): BinTObjDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_DocumentRetrievalDriver_1 extends Handle_BinTObjDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_DocumentRetrievalDriver_2 extends Handle_BinTObjDrivers_DocumentRetrievalDriver {
    constructor(thePtr: BinTObjDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinTObjDrivers_DocumentRetrievalDriver_3 extends Handle_BinTObjDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinTObjDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_BinTObjDrivers_DocumentRetrievalDriver_4 extends Handle_BinTObjDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_BinTObjDrivers_DocumentRetrievalDriver);
  }

export declare class BinTObjDrivers_DocumentRetrievalDriver extends BinLDrivers_DocumentRetrievalDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinTObjDrivers_ObjectDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_ObjectDriver): void;
  get(): BinTObjDrivers_ObjectDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_ObjectDriver_1 extends Handle_BinTObjDrivers_ObjectDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_ObjectDriver_2 extends Handle_BinTObjDrivers_ObjectDriver {
    constructor(thePtr: BinTObjDrivers_ObjectDriver);
  }

  export declare class Handle_BinTObjDrivers_ObjectDriver_3 extends Handle_BinTObjDrivers_ObjectDriver {
    constructor(theHandle: Handle_BinTObjDrivers_ObjectDriver);
  }

  export declare class Handle_BinTObjDrivers_ObjectDriver_4 extends Handle_BinTObjDrivers_ObjectDriver {
    constructor(theHandle: Handle_BinTObjDrivers_ObjectDriver);
  }

export declare class BinTObjDrivers_ObjectDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinTObjDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_DocumentStorageDriver): void;
  get(): BinTObjDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_DocumentStorageDriver_1 extends Handle_BinTObjDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_DocumentStorageDriver_2 extends Handle_BinTObjDrivers_DocumentStorageDriver {
    constructor(thePtr: BinTObjDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinTObjDrivers_DocumentStorageDriver_3 extends Handle_BinTObjDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinTObjDrivers_DocumentStorageDriver);
  }

  export declare class Handle_BinTObjDrivers_DocumentStorageDriver_4 extends Handle_BinTObjDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_BinTObjDrivers_DocumentStorageDriver);
  }

export declare class BinTObjDrivers_DocumentStorageDriver extends BinLDrivers_DocumentStorageDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_BinMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinTObjDrivers_ModelDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_ModelDriver): void;
  get(): BinTObjDrivers_ModelDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_ModelDriver_1 extends Handle_BinTObjDrivers_ModelDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_ModelDriver_2 extends Handle_BinTObjDrivers_ModelDriver {
    constructor(thePtr: BinTObjDrivers_ModelDriver);
  }

  export declare class Handle_BinTObjDrivers_ModelDriver_3 extends Handle_BinTObjDrivers_ModelDriver {
    constructor(theHandle: Handle_BinTObjDrivers_ModelDriver);
  }

  export declare class Handle_BinTObjDrivers_ModelDriver_4 extends Handle_BinTObjDrivers_ModelDriver {
    constructor(theHandle: Handle_BinTObjDrivers_ModelDriver);
  }

export declare class BinTObjDrivers_ModelDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: BinObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: BinObjMgt_Persistent, RelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinTObjDrivers_IntSparseArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_IntSparseArrayDriver): void;
  get(): BinTObjDrivers_IntSparseArrayDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_IntSparseArrayDriver_1 extends Handle_BinTObjDrivers_IntSparseArrayDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_IntSparseArrayDriver_2 extends Handle_BinTObjDrivers_IntSparseArrayDriver {
    constructor(thePtr: BinTObjDrivers_IntSparseArrayDriver);
  }

  export declare class Handle_BinTObjDrivers_IntSparseArrayDriver_3 extends Handle_BinTObjDrivers_IntSparseArrayDriver {
    constructor(theHandle: Handle_BinTObjDrivers_IntSparseArrayDriver);
  }

  export declare class Handle_BinTObjDrivers_IntSparseArrayDriver_4 extends Handle_BinTObjDrivers_IntSparseArrayDriver {
    constructor(theHandle: Handle_BinTObjDrivers_IntSparseArrayDriver);
  }

export declare class BinTObjDrivers_IntSparseArrayDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BinTObjDrivers_XYZDriver extends BinMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: BinObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: BinObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: BinObjMgt_Persistent, theRelocTable: BinObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_BinTObjDrivers_XYZDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BinTObjDrivers_XYZDriver): void;
  get(): BinTObjDrivers_XYZDriver;
  delete(): void;
}

  export declare class Handle_BinTObjDrivers_XYZDriver_1 extends Handle_BinTObjDrivers_XYZDriver {
    constructor();
  }

  export declare class Handle_BinTObjDrivers_XYZDriver_2 extends Handle_BinTObjDrivers_XYZDriver {
    constructor(thePtr: BinTObjDrivers_XYZDriver);
  }

  export declare class Handle_BinTObjDrivers_XYZDriver_3 extends Handle_BinTObjDrivers_XYZDriver {
    constructor(theHandle: Handle_BinTObjDrivers_XYZDriver);
  }

  export declare class Handle_BinTObjDrivers_XYZDriver_4 extends Handle_BinTObjDrivers_XYZDriver {
    constructor(theHandle: Handle_BinTObjDrivers_XYZDriver);
  }

export declare class StepRepr_ValueRange extends StepRepr_CompoundRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ValueRange {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ValueRange): void;
  get(): StepRepr_ValueRange;
  delete(): void;
}

  export declare class Handle_StepRepr_ValueRange_1 extends Handle_StepRepr_ValueRange {
    constructor();
  }

  export declare class Handle_StepRepr_ValueRange_2 extends Handle_StepRepr_ValueRange {
    constructor(thePtr: StepRepr_ValueRange);
  }

  export declare class Handle_StepRepr_ValueRange_3 extends Handle_StepRepr_ValueRange {
    constructor(theHandle: Handle_StepRepr_ValueRange);
  }

  export declare class Handle_StepRepr_ValueRange_4 extends Handle_StepRepr_ValueRange {
    constructor(theHandle: Handle_StepRepr_ValueRange);
  }

export declare class Handle_StepRepr_ConfigurationDesign {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ConfigurationDesign): void;
  get(): StepRepr_ConfigurationDesign;
  delete(): void;
}

  export declare class Handle_StepRepr_ConfigurationDesign_1 extends Handle_StepRepr_ConfigurationDesign {
    constructor();
  }

  export declare class Handle_StepRepr_ConfigurationDesign_2 extends Handle_StepRepr_ConfigurationDesign {
    constructor(thePtr: StepRepr_ConfigurationDesign);
  }

  export declare class Handle_StepRepr_ConfigurationDesign_3 extends Handle_StepRepr_ConfigurationDesign {
    constructor(theHandle: Handle_StepRepr_ConfigurationDesign);
  }

  export declare class Handle_StepRepr_ConfigurationDesign_4 extends Handle_StepRepr_ConfigurationDesign {
    constructor(theHandle: Handle_StepRepr_ConfigurationDesign);
  }

export declare class StepRepr_ConfigurationDesign extends Standard_Transient {
  constructor()
  Init(aConfiguration: Handle_StepRepr_ConfigurationItem, aDesign: StepRepr_ConfigurationDesignItem): void;
  Configuration(): Handle_StepRepr_ConfigurationItem;
  SetConfiguration(Configuration: Handle_StepRepr_ConfigurationItem): void;
  Design(): StepRepr_ConfigurationDesignItem;
  SetDesign(Design: StepRepr_ConfigurationDesignItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp extends StepRepr_CompShAspAndDatumFeatAndShAsp {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp): void;
  get(): StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp;
  delete(): void;
}

  export declare class Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_1 extends Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp {
    constructor();
  }

  export declare class Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_2 extends Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp {
    constructor(thePtr: StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp);
  }

  export declare class Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_3 extends Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp {
    constructor(theHandle: Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp);
  }

  export declare class Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_4 extends Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp {
    constructor(theHandle: Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp);
  }

export declare class StepRepr_ReprItemAndMeasureWithUnit extends StepRepr_RepresentationItem {
  constructor()
  Init(aMWU: Handle_StepBasic_MeasureWithUnit, aRI: Handle_StepRepr_RepresentationItem): void;
  GetMeasureRepresentationItem(): Handle_StepRepr_MeasureRepresentationItem;
  SetMeasureWithUnit(aMWU: Handle_StepBasic_MeasureWithUnit): void;
  GetMeasureWithUnit(): Handle_StepBasic_MeasureWithUnit;
  GetRepresentationItem(): Handle_StepRepr_RepresentationItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ReprItemAndMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ReprItemAndMeasureWithUnit): void;
  get(): StepRepr_ReprItemAndMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnit_1 extends Handle_StepRepr_ReprItemAndMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnit_2 extends Handle_StepRepr_ReprItemAndMeasureWithUnit {
    constructor(thePtr: StepRepr_ReprItemAndMeasureWithUnit);
  }

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnit_3 extends Handle_StepRepr_ReprItemAndMeasureWithUnit {
    constructor(theHandle: Handle_StepRepr_ReprItemAndMeasureWithUnit);
  }

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnit_4 extends Handle_StepRepr_ReprItemAndMeasureWithUnit {
    constructor(theHandle: Handle_StepRepr_ReprItemAndMeasureWithUnit);
  }

export declare class Handle_StepRepr_QuantifiedAssemblyComponentUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_QuantifiedAssemblyComponentUsage): void;
  get(): StepRepr_QuantifiedAssemblyComponentUsage;
  delete(): void;
}

  export declare class Handle_StepRepr_QuantifiedAssemblyComponentUsage_1 extends Handle_StepRepr_QuantifiedAssemblyComponentUsage {
    constructor();
  }

  export declare class Handle_StepRepr_QuantifiedAssemblyComponentUsage_2 extends Handle_StepRepr_QuantifiedAssemblyComponentUsage {
    constructor(thePtr: StepRepr_QuantifiedAssemblyComponentUsage);
  }

  export declare class Handle_StepRepr_QuantifiedAssemblyComponentUsage_3 extends Handle_StepRepr_QuantifiedAssemblyComponentUsage {
    constructor(theHandle: Handle_StepRepr_QuantifiedAssemblyComponentUsage);
  }

  export declare class Handle_StepRepr_QuantifiedAssemblyComponentUsage_4 extends Handle_StepRepr_QuantifiedAssemblyComponentUsage {
    constructor(theHandle: Handle_StepRepr_QuantifiedAssemblyComponentUsage);
  }

export declare class StepRepr_QuantifiedAssemblyComponentUsage extends StepRepr_AssemblyComponentUsage {
  constructor()
  Init_1(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: Handle_StepBasic_ProductDefinition, aProductDefinitionRelationship_RelatedProductDefinition: Handle_StepBasic_ProductDefinition, hasAssemblyComponentUsage_ReferenceDesignator: Standard_Boolean, aAssemblyComponentUsage_ReferenceDesignator: Handle_TCollection_HAsciiString, aQuantity: Handle_StepBasic_MeasureWithUnit): void;
  Init_2(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: StepBasic_ProductDefinitionOrReference, aProductDefinitionRelationship_RelatedProductDefinition: StepBasic_ProductDefinitionOrReference, hasAssemblyComponentUsage_ReferenceDesignator: Standard_Boolean, aAssemblyComponentUsage_ReferenceDesignator: Handle_TCollection_HAsciiString, aQuantity: Handle_StepBasic_MeasureWithUnit): void;
  Quantity(): Handle_StepBasic_MeasureWithUnit;
  SetQuantity(Quantity: Handle_StepBasic_MeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ParametricRepresentationContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ParametricRepresentationContext): void;
  get(): StepRepr_ParametricRepresentationContext;
  delete(): void;
}

  export declare class Handle_StepRepr_ParametricRepresentationContext_1 extends Handle_StepRepr_ParametricRepresentationContext {
    constructor();
  }

  export declare class Handle_StepRepr_ParametricRepresentationContext_2 extends Handle_StepRepr_ParametricRepresentationContext {
    constructor(thePtr: StepRepr_ParametricRepresentationContext);
  }

  export declare class Handle_StepRepr_ParametricRepresentationContext_3 extends Handle_StepRepr_ParametricRepresentationContext {
    constructor(theHandle: Handle_StepRepr_ParametricRepresentationContext);
  }

  export declare class Handle_StepRepr_ParametricRepresentationContext_4 extends Handle_StepRepr_ParametricRepresentationContext {
    constructor(theHandle: Handle_StepRepr_ParametricRepresentationContext);
  }

export declare class StepRepr_ParametricRepresentationContext extends StepRepr_RepresentationContext {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_NextAssemblyUsageOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_NextAssemblyUsageOccurrence): void;
  get(): StepRepr_NextAssemblyUsageOccurrence;
  delete(): void;
}

  export declare class Handle_StepRepr_NextAssemblyUsageOccurrence_1 extends Handle_StepRepr_NextAssemblyUsageOccurrence {
    constructor();
  }

  export declare class Handle_StepRepr_NextAssemblyUsageOccurrence_2 extends Handle_StepRepr_NextAssemblyUsageOccurrence {
    constructor(thePtr: StepRepr_NextAssemblyUsageOccurrence);
  }

  export declare class Handle_StepRepr_NextAssemblyUsageOccurrence_3 extends Handle_StepRepr_NextAssemblyUsageOccurrence {
    constructor(theHandle: Handle_StepRepr_NextAssemblyUsageOccurrence);
  }

  export declare class Handle_StepRepr_NextAssemblyUsageOccurrence_4 extends Handle_StepRepr_NextAssemblyUsageOccurrence {
    constructor(theHandle: Handle_StepRepr_NextAssemblyUsageOccurrence);
  }

export declare class StepRepr_NextAssemblyUsageOccurrence extends StepRepr_AssemblyComponentUsage {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_Tangent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_Tangent): void;
  get(): StepRepr_Tangent;
  delete(): void;
}

  export declare class Handle_StepRepr_Tangent_1 extends Handle_StepRepr_Tangent {
    constructor();
  }

  export declare class Handle_StepRepr_Tangent_2 extends Handle_StepRepr_Tangent {
    constructor(thePtr: StepRepr_Tangent);
  }

  export declare class Handle_StepRepr_Tangent_3 extends Handle_StepRepr_Tangent {
    constructor(theHandle: Handle_StepRepr_Tangent);
  }

  export declare class Handle_StepRepr_Tangent_4 extends Handle_StepRepr_Tangent {
    constructor(theHandle: Handle_StepRepr_Tangent);
  }

export declare class StepRepr_Tangent extends StepRepr_DerivedShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_StructuralResponseProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_StructuralResponseProperty): void;
  get(): StepRepr_StructuralResponseProperty;
  delete(): void;
}

  export declare class Handle_StepRepr_StructuralResponseProperty_1 extends Handle_StepRepr_StructuralResponseProperty {
    constructor();
  }

  export declare class Handle_StepRepr_StructuralResponseProperty_2 extends Handle_StepRepr_StructuralResponseProperty {
    constructor(thePtr: StepRepr_StructuralResponseProperty);
  }

  export declare class Handle_StepRepr_StructuralResponseProperty_3 extends Handle_StepRepr_StructuralResponseProperty {
    constructor(theHandle: Handle_StepRepr_StructuralResponseProperty);
  }

  export declare class Handle_StepRepr_StructuralResponseProperty_4 extends Handle_StepRepr_StructuralResponseProperty {
    constructor(theHandle: Handle_StepRepr_StructuralResponseProperty);
  }

export declare class StepRepr_StructuralResponseProperty extends StepRepr_PropertyDefinition {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_CompositeShapeAspect extends StepRepr_ShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_CompositeShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CompositeShapeAspect): void;
  get(): StepRepr_CompositeShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_CompositeShapeAspect_1 extends Handle_StepRepr_CompositeShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_CompositeShapeAspect_2 extends Handle_StepRepr_CompositeShapeAspect {
    constructor(thePtr: StepRepr_CompositeShapeAspect);
  }

  export declare class Handle_StepRepr_CompositeShapeAspect_3 extends Handle_StepRepr_CompositeShapeAspect {
    constructor(theHandle: Handle_StepRepr_CompositeShapeAspect);
  }

  export declare class Handle_StepRepr_CompositeShapeAspect_4 extends Handle_StepRepr_CompositeShapeAspect {
    constructor(theHandle: Handle_StepRepr_CompositeShapeAspect);
  }

export declare class Handle_StepRepr_PropertyDefinitionRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_PropertyDefinitionRepresentation): void;
  get(): StepRepr_PropertyDefinitionRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_PropertyDefinitionRepresentation_1 extends Handle_StepRepr_PropertyDefinitionRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_PropertyDefinitionRepresentation_2 extends Handle_StepRepr_PropertyDefinitionRepresentation {
    constructor(thePtr: StepRepr_PropertyDefinitionRepresentation);
  }

  export declare class Handle_StepRepr_PropertyDefinitionRepresentation_3 extends Handle_StepRepr_PropertyDefinitionRepresentation {
    constructor(theHandle: Handle_StepRepr_PropertyDefinitionRepresentation);
  }

  export declare class Handle_StepRepr_PropertyDefinitionRepresentation_4 extends Handle_StepRepr_PropertyDefinitionRepresentation {
    constructor(theHandle: Handle_StepRepr_PropertyDefinitionRepresentation);
  }

export declare class StepRepr_PropertyDefinitionRepresentation extends Standard_Transient {
  constructor()
  Init(aDefinition: StepRepr_RepresentedDefinition, aUsedRepresentation: Handle_StepRepr_Representation): void;
  Definition(): StepRepr_RepresentedDefinition;
  SetDefinition(Definition: StepRepr_RepresentedDefinition): void;
  UsedRepresentation(): Handle_StepRepr_Representation;
  SetUsedRepresentation(UsedRepresentation: Handle_StepRepr_Representation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_FeatureForDatumTargetRelationship extends StepRepr_ShapeAspectRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_FeatureForDatumTargetRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_FeatureForDatumTargetRelationship): void;
  get(): StepRepr_FeatureForDatumTargetRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_FeatureForDatumTargetRelationship_1 extends Handle_StepRepr_FeatureForDatumTargetRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_FeatureForDatumTargetRelationship_2 extends Handle_StepRepr_FeatureForDatumTargetRelationship {
    constructor(thePtr: StepRepr_FeatureForDatumTargetRelationship);
  }

  export declare class Handle_StepRepr_FeatureForDatumTargetRelationship_3 extends Handle_StepRepr_FeatureForDatumTargetRelationship {
    constructor(theHandle: Handle_StepRepr_FeatureForDatumTargetRelationship);
  }

  export declare class Handle_StepRepr_FeatureForDatumTargetRelationship_4 extends Handle_StepRepr_FeatureForDatumTargetRelationship {
    constructor(theHandle: Handle_StepRepr_FeatureForDatumTargetRelationship);
  }

export declare class Handle_StepRepr_HArray1OfMaterialPropertyRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_HArray1OfMaterialPropertyRepresentation): void;
  get(): StepRepr_HArray1OfMaterialPropertyRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_1 extends Handle_StepRepr_HArray1OfMaterialPropertyRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_2 extends Handle_StepRepr_HArray1OfMaterialPropertyRepresentation {
    constructor(thePtr: StepRepr_HArray1OfMaterialPropertyRepresentation);
  }

  export declare class Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_3 extends Handle_StepRepr_HArray1OfMaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepRepr_HArray1OfMaterialPropertyRepresentation);
  }

  export declare class Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_4 extends Handle_StepRepr_HArray1OfMaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepRepr_HArray1OfMaterialPropertyRepresentation);
  }

export declare class Handle_StepRepr_DataEnvironment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_DataEnvironment): void;
  get(): StepRepr_DataEnvironment;
  delete(): void;
}

  export declare class Handle_StepRepr_DataEnvironment_1 extends Handle_StepRepr_DataEnvironment {
    constructor();
  }

  export declare class Handle_StepRepr_DataEnvironment_2 extends Handle_StepRepr_DataEnvironment {
    constructor(thePtr: StepRepr_DataEnvironment);
  }

  export declare class Handle_StepRepr_DataEnvironment_3 extends Handle_StepRepr_DataEnvironment {
    constructor(theHandle: Handle_StepRepr_DataEnvironment);
  }

  export declare class Handle_StepRepr_DataEnvironment_4 extends Handle_StepRepr_DataEnvironment {
    constructor(theHandle: Handle_StepRepr_DataEnvironment);
  }

export declare class StepRepr_DataEnvironment extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aElements: Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  Elements(): Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation;
  SetElements(Elements: Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ParallelOffset {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ParallelOffset): void;
  get(): StepRepr_ParallelOffset;
  delete(): void;
}

  export declare class Handle_StepRepr_ParallelOffset_1 extends Handle_StepRepr_ParallelOffset {
    constructor();
  }

  export declare class Handle_StepRepr_ParallelOffset_2 extends Handle_StepRepr_ParallelOffset {
    constructor(thePtr: StepRepr_ParallelOffset);
  }

  export declare class Handle_StepRepr_ParallelOffset_3 extends Handle_StepRepr_ParallelOffset {
    constructor(theHandle: Handle_StepRepr_ParallelOffset);
  }

  export declare class Handle_StepRepr_ParallelOffset_4 extends Handle_StepRepr_ParallelOffset {
    constructor(theHandle: Handle_StepRepr_ParallelOffset);
  }

export declare class StepRepr_ParallelOffset extends StepRepr_DerivedShapeAspect {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theOfShape: Handle_StepRepr_ProductDefinitionShape, theProductDefinitional: StepData_Logical, theOffset: Handle_StepBasic_MeasureWithUnit): void;
  Offset(): Handle_StepBasic_MeasureWithUnit;
  SetOffset(theOffset: Handle_StepBasic_MeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_MappedItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aMappingSource: Handle_StepRepr_RepresentationMap, aMappingTarget: Handle_StepRepr_RepresentationItem): void;
  SetMappingSource(aMappingSource: Handle_StepRepr_RepresentationMap): void;
  MappingSource(): Handle_StepRepr_RepresentationMap;
  SetMappingTarget(aMappingTarget: Handle_StepRepr_RepresentationItem): void;
  MappingTarget(): Handle_StepRepr_RepresentationItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_MappedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_MappedItem): void;
  get(): StepRepr_MappedItem;
  delete(): void;
}

  export declare class Handle_StepRepr_MappedItem_1 extends Handle_StepRepr_MappedItem {
    constructor();
  }

  export declare class Handle_StepRepr_MappedItem_2 extends Handle_StepRepr_MappedItem {
    constructor(thePtr: StepRepr_MappedItem);
  }

  export declare class Handle_StepRepr_MappedItem_3 extends Handle_StepRepr_MappedItem {
    constructor(theHandle: Handle_StepRepr_MappedItem);
  }

  export declare class Handle_StepRepr_MappedItem_4 extends Handle_StepRepr_MappedItem {
    constructor(theHandle: Handle_StepRepr_MappedItem);
  }

export declare class StepRepr_ReprItemAndMeasureWithUnitAndQRI extends StepRepr_ReprItemAndMeasureWithUnit {
  constructor()
  Init(aMWU: Handle_StepBasic_MeasureWithUnit, aRI: Handle_StepRepr_RepresentationItem, aQRI: Handle_StepShape_QualifiedRepresentationItem): void;
  SetQualifiedRepresentationItem(aQRI: Handle_StepShape_QualifiedRepresentationItem): void;
  GetQualifiedRepresentationItem(): Handle_StepShape_QualifiedRepresentationItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ReprItemAndMeasureWithUnitAndQRI): void;
  get(): StepRepr_ReprItemAndMeasureWithUnitAndQRI;
  delete(): void;
}

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_1 extends Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI {
    constructor();
  }

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_2 extends Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI {
    constructor(thePtr: StepRepr_ReprItemAndMeasureWithUnitAndQRI);
  }

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_3 extends Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI {
    constructor(theHandle: Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI);
  }

  export declare class Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_4 extends Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI {
    constructor(theHandle: Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI);
  }

export declare class Handle_StepRepr_BetweenShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_BetweenShapeAspect): void;
  get(): StepRepr_BetweenShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_BetweenShapeAspect_1 extends Handle_StepRepr_BetweenShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_BetweenShapeAspect_2 extends Handle_StepRepr_BetweenShapeAspect {
    constructor(thePtr: StepRepr_BetweenShapeAspect);
  }

  export declare class Handle_StepRepr_BetweenShapeAspect_3 extends Handle_StepRepr_BetweenShapeAspect {
    constructor(theHandle: Handle_StepRepr_BetweenShapeAspect);
  }

  export declare class Handle_StepRepr_BetweenShapeAspect_4 extends Handle_StepRepr_BetweenShapeAspect {
    constructor(theHandle: Handle_StepRepr_BetweenShapeAspect);
  }

export declare class StepRepr_BetweenShapeAspect extends StepRepr_ContinuosShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_RepresentationRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_RepresentationRelationship): void;
  get(): StepRepr_RepresentationRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_RepresentationRelationship_1 extends Handle_StepRepr_RepresentationRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_RepresentationRelationship_2 extends Handle_StepRepr_RepresentationRelationship {
    constructor(thePtr: StepRepr_RepresentationRelationship);
  }

  export declare class Handle_StepRepr_RepresentationRelationship_3 extends Handle_StepRepr_RepresentationRelationship {
    constructor(theHandle: Handle_StepRepr_RepresentationRelationship);
  }

  export declare class Handle_StepRepr_RepresentationRelationship_4 extends Handle_StepRepr_RepresentationRelationship {
    constructor(theHandle: Handle_StepRepr_RepresentationRelationship);
  }

export declare class StepRepr_RepresentationRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aRep1: Handle_StepRepr_Representation, aRep2: Handle_StepRepr_Representation): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetRep1(aRep1: Handle_StepRepr_Representation): void;
  Rep1(): Handle_StepRepr_Representation;
  SetRep2(aRep2: Handle_StepRepr_Representation): void;
  Rep2(): Handle_StepRepr_Representation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_HSequenceOfMaterialPropertyRepresentation): void;
  get(): StepRepr_HSequenceOfMaterialPropertyRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_1 extends Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_2 extends Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation {
    constructor(thePtr: StepRepr_HSequenceOfMaterialPropertyRepresentation);
  }

  export declare class Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_3 extends Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation);
  }

  export declare class Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_4 extends Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation);
  }

export declare class Handle_StepRepr_PerpendicularTo {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_PerpendicularTo): void;
  get(): StepRepr_PerpendicularTo;
  delete(): void;
}

  export declare class Handle_StepRepr_PerpendicularTo_1 extends Handle_StepRepr_PerpendicularTo {
    constructor();
  }

  export declare class Handle_StepRepr_PerpendicularTo_2 extends Handle_StepRepr_PerpendicularTo {
    constructor(thePtr: StepRepr_PerpendicularTo);
  }

  export declare class Handle_StepRepr_PerpendicularTo_3 extends Handle_StepRepr_PerpendicularTo {
    constructor(theHandle: Handle_StepRepr_PerpendicularTo);
  }

  export declare class Handle_StepRepr_PerpendicularTo_4 extends Handle_StepRepr_PerpendicularTo {
    constructor(theHandle: Handle_StepRepr_PerpendicularTo);
  }

export declare class StepRepr_PerpendicularTo extends StepRepr_DerivedShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_RepresentationRelationshipWithTransformation extends StepRepr_ShapeRepresentationRelationship {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aRep1: Handle_StepRepr_Representation, aRep2: Handle_StepRepr_Representation, aTransf: StepRepr_Transformation): void;
  TransformationOperator(): StepRepr_Transformation;
  SetTransformationOperator(aTrans: StepRepr_Transformation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_RepresentationRelationshipWithTransformation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_RepresentationRelationshipWithTransformation): void;
  get(): StepRepr_RepresentationRelationshipWithTransformation;
  delete(): void;
}

  export declare class Handle_StepRepr_RepresentationRelationshipWithTransformation_1 extends Handle_StepRepr_RepresentationRelationshipWithTransformation {
    constructor();
  }

  export declare class Handle_StepRepr_RepresentationRelationshipWithTransformation_2 extends Handle_StepRepr_RepresentationRelationshipWithTransformation {
    constructor(thePtr: StepRepr_RepresentationRelationshipWithTransformation);
  }

  export declare class Handle_StepRepr_RepresentationRelationshipWithTransformation_3 extends Handle_StepRepr_RepresentationRelationshipWithTransformation {
    constructor(theHandle: Handle_StepRepr_RepresentationRelationshipWithTransformation);
  }

  export declare class Handle_StepRepr_RepresentationRelationshipWithTransformation_4 extends Handle_StepRepr_RepresentationRelationshipWithTransformation {
    constructor(theHandle: Handle_StepRepr_RepresentationRelationshipWithTransformation);
  }

export declare class StepRepr_PromissoryUsageOccurrence extends StepRepr_AssemblyComponentUsage {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_PromissoryUsageOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_PromissoryUsageOccurrence): void;
  get(): StepRepr_PromissoryUsageOccurrence;
  delete(): void;
}

  export declare class Handle_StepRepr_PromissoryUsageOccurrence_1 extends Handle_StepRepr_PromissoryUsageOccurrence {
    constructor();
  }

  export declare class Handle_StepRepr_PromissoryUsageOccurrence_2 extends Handle_StepRepr_PromissoryUsageOccurrence {
    constructor(thePtr: StepRepr_PromissoryUsageOccurrence);
  }

  export declare class Handle_StepRepr_PromissoryUsageOccurrence_3 extends Handle_StepRepr_PromissoryUsageOccurrence {
    constructor(theHandle: Handle_StepRepr_PromissoryUsageOccurrence);
  }

  export declare class Handle_StepRepr_PromissoryUsageOccurrence_4 extends Handle_StepRepr_PromissoryUsageOccurrence {
    constructor(theHandle: Handle_StepRepr_PromissoryUsageOccurrence);
  }

export declare class StepRepr_ProductDefinitionUsage extends StepBasic_ProductDefinitionRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ProductDefinitionUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ProductDefinitionUsage): void;
  get(): StepRepr_ProductDefinitionUsage;
  delete(): void;
}

  export declare class Handle_StepRepr_ProductDefinitionUsage_1 extends Handle_StepRepr_ProductDefinitionUsage {
    constructor();
  }

  export declare class Handle_StepRepr_ProductDefinitionUsage_2 extends Handle_StepRepr_ProductDefinitionUsage {
    constructor(thePtr: StepRepr_ProductDefinitionUsage);
  }

  export declare class Handle_StepRepr_ProductDefinitionUsage_3 extends Handle_StepRepr_ProductDefinitionUsage {
    constructor(theHandle: Handle_StepRepr_ProductDefinitionUsage);
  }

  export declare class Handle_StepRepr_ProductDefinitionUsage_4 extends Handle_StepRepr_ProductDefinitionUsage {
    constructor(theHandle: Handle_StepRepr_ProductDefinitionUsage);
  }

export declare class Handle_StepRepr_MaterialDesignation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_MaterialDesignation): void;
  get(): StepRepr_MaterialDesignation;
  delete(): void;
}

  export declare class Handle_StepRepr_MaterialDesignation_1 extends Handle_StepRepr_MaterialDesignation {
    constructor();
  }

  export declare class Handle_StepRepr_MaterialDesignation_2 extends Handle_StepRepr_MaterialDesignation {
    constructor(thePtr: StepRepr_MaterialDesignation);
  }

  export declare class Handle_StepRepr_MaterialDesignation_3 extends Handle_StepRepr_MaterialDesignation {
    constructor(theHandle: Handle_StepRepr_MaterialDesignation);
  }

  export declare class Handle_StepRepr_MaterialDesignation_4 extends Handle_StepRepr_MaterialDesignation {
    constructor(theHandle: Handle_StepRepr_MaterialDesignation);
  }

export declare class StepRepr_MaterialDesignation extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aOfDefinition: StepRepr_CharacterizedDefinition): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetOfDefinition(aOfDefinition: StepRepr_CharacterizedDefinition): void;
  OfDefinition(): StepRepr_CharacterizedDefinition;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_MaterialPropertyRepresentation extends StepRepr_PropertyDefinitionRepresentation {
  constructor()
  Init(aPropertyDefinitionRepresentation_Definition: StepRepr_RepresentedDefinition, aPropertyDefinitionRepresentation_UsedRepresentation: Handle_StepRepr_Representation, aDependentEnvironment: Handle_StepRepr_DataEnvironment): void;
  DependentEnvironment(): Handle_StepRepr_DataEnvironment;
  SetDependentEnvironment(DependentEnvironment: Handle_StepRepr_DataEnvironment): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_MaterialPropertyRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_MaterialPropertyRepresentation): void;
  get(): StepRepr_MaterialPropertyRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_MaterialPropertyRepresentation_1 extends Handle_StepRepr_MaterialPropertyRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_MaterialPropertyRepresentation_2 extends Handle_StepRepr_MaterialPropertyRepresentation {
    constructor(thePtr: StepRepr_MaterialPropertyRepresentation);
  }

  export declare class Handle_StepRepr_MaterialPropertyRepresentation_3 extends Handle_StepRepr_MaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepRepr_MaterialPropertyRepresentation);
  }

  export declare class Handle_StepRepr_MaterialPropertyRepresentation_4 extends Handle_StepRepr_MaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepRepr_MaterialPropertyRepresentation);
  }

export declare class Handle_StepRepr_HSequenceOfRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_HSequenceOfRepresentationItem): void;
  get(): StepRepr_HSequenceOfRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_HSequenceOfRepresentationItem_1 extends Handle_StepRepr_HSequenceOfRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_HSequenceOfRepresentationItem_2 extends Handle_StepRepr_HSequenceOfRepresentationItem {
    constructor(thePtr: StepRepr_HSequenceOfRepresentationItem);
  }

  export declare class Handle_StepRepr_HSequenceOfRepresentationItem_3 extends Handle_StepRepr_HSequenceOfRepresentationItem {
    constructor(theHandle: Handle_StepRepr_HSequenceOfRepresentationItem);
  }

  export declare class Handle_StepRepr_HSequenceOfRepresentationItem_4 extends Handle_StepRepr_HSequenceOfRepresentationItem {
    constructor(theHandle: Handle_StepRepr_HSequenceOfRepresentationItem);
  }

export declare class Handle_StepRepr_GlobalUnitAssignedContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_GlobalUnitAssignedContext): void;
  get(): StepRepr_GlobalUnitAssignedContext;
  delete(): void;
}

  export declare class Handle_StepRepr_GlobalUnitAssignedContext_1 extends Handle_StepRepr_GlobalUnitAssignedContext {
    constructor();
  }

  export declare class Handle_StepRepr_GlobalUnitAssignedContext_2 extends Handle_StepRepr_GlobalUnitAssignedContext {
    constructor(thePtr: StepRepr_GlobalUnitAssignedContext);
  }

  export declare class Handle_StepRepr_GlobalUnitAssignedContext_3 extends Handle_StepRepr_GlobalUnitAssignedContext {
    constructor(theHandle: Handle_StepRepr_GlobalUnitAssignedContext);
  }

  export declare class Handle_StepRepr_GlobalUnitAssignedContext_4 extends Handle_StepRepr_GlobalUnitAssignedContext {
    constructor(theHandle: Handle_StepRepr_GlobalUnitAssignedContext);
  }

export declare class StepRepr_GlobalUnitAssignedContext extends StepRepr_RepresentationContext {
  constructor()
  Init(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aUnits: Handle_StepBasic_HArray1OfNamedUnit): void;
  SetUnits(aUnits: Handle_StepBasic_HArray1OfNamedUnit): void;
  Units(): Handle_StepBasic_HArray1OfNamedUnit;
  UnitsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_NamedUnit;
  NbUnits(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_Extension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_Extension): void;
  get(): StepRepr_Extension;
  delete(): void;
}

  export declare class Handle_StepRepr_Extension_1 extends Handle_StepRepr_Extension {
    constructor();
  }

  export declare class Handle_StepRepr_Extension_2 extends Handle_StepRepr_Extension {
    constructor(thePtr: StepRepr_Extension);
  }

  export declare class Handle_StepRepr_Extension_3 extends Handle_StepRepr_Extension {
    constructor(theHandle: Handle_StepRepr_Extension);
  }

  export declare class Handle_StepRepr_Extension_4 extends Handle_StepRepr_Extension {
    constructor(theHandle: Handle_StepRepr_Extension);
  }

export declare class StepRepr_Extension extends StepRepr_DerivedShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_ReprItemAndLengthMeasureWithUnit extends StepRepr_ReprItemAndMeasureWithUnit {
  constructor()
  SetLengthMeasureWithUnit(aLMWU: Handle_StepBasic_LengthMeasureWithUnit): void;
  GetLengthMeasureWithUnit(): Handle_StepBasic_LengthMeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ReprItemAndLengthMeasureWithUnit): void;
  get(): StepRepr_ReprItemAndLengthMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_1 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_2 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnit {
    constructor(thePtr: StepRepr_ReprItemAndLengthMeasureWithUnit);
  }

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_3 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnit {
    constructor(theHandle: Handle_StepRepr_ReprItemAndLengthMeasureWithUnit);
  }

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_4 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnit {
    constructor(theHandle: Handle_StepRepr_ReprItemAndLengthMeasureWithUnit);
  }

export declare class Handle_StepRepr_PropertyDefinitionRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_PropertyDefinitionRelationship): void;
  get(): StepRepr_PropertyDefinitionRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_PropertyDefinitionRelationship_1 extends Handle_StepRepr_PropertyDefinitionRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_PropertyDefinitionRelationship_2 extends Handle_StepRepr_PropertyDefinitionRelationship {
    constructor(thePtr: StepRepr_PropertyDefinitionRelationship);
  }

  export declare class Handle_StepRepr_PropertyDefinitionRelationship_3 extends Handle_StepRepr_PropertyDefinitionRelationship {
    constructor(theHandle: Handle_StepRepr_PropertyDefinitionRelationship);
  }

  export declare class Handle_StepRepr_PropertyDefinitionRelationship_4 extends Handle_StepRepr_PropertyDefinitionRelationship {
    constructor(theHandle: Handle_StepRepr_PropertyDefinitionRelationship);
  }

export declare class StepRepr_PropertyDefinitionRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aRelatingPropertyDefinition: Handle_StepRepr_PropertyDefinition, aRelatedPropertyDefinition: Handle_StepRepr_PropertyDefinition): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  RelatingPropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  SetRelatingPropertyDefinition(RelatingPropertyDefinition: Handle_StepRepr_PropertyDefinition): void;
  RelatedPropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  SetRelatedPropertyDefinition(RelatedPropertyDefinition: Handle_StepRepr_PropertyDefinition): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_SpecifiedHigherUsageOccurrence extends StepRepr_AssemblyComponentUsage {
  constructor()
  Init_1(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: Handle_StepBasic_ProductDefinition, aProductDefinitionRelationship_RelatedProductDefinition: Handle_StepBasic_ProductDefinition, hasAssemblyComponentUsage_ReferenceDesignator: Standard_Boolean, aAssemblyComponentUsage_ReferenceDesignator: Handle_TCollection_HAsciiString, aUpperUsage: Handle_StepRepr_AssemblyComponentUsage, aNextUsage: Handle_StepRepr_NextAssemblyUsageOccurrence): void;
  Init_2(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: StepBasic_ProductDefinitionOrReference, aProductDefinitionRelationship_RelatedProductDefinition: StepBasic_ProductDefinitionOrReference, hasAssemblyComponentUsage_ReferenceDesignator: Standard_Boolean, aAssemblyComponentUsage_ReferenceDesignator: Handle_TCollection_HAsciiString, aUpperUsage: Handle_StepRepr_AssemblyComponentUsage, aNextUsage: Handle_StepRepr_NextAssemblyUsageOccurrence): void;
  UpperUsage(): Handle_StepRepr_AssemblyComponentUsage;
  SetUpperUsage(UpperUsage: Handle_StepRepr_AssemblyComponentUsage): void;
  NextUsage(): Handle_StepRepr_NextAssemblyUsageOccurrence;
  SetNextUsage(NextUsage: Handle_StepRepr_NextAssemblyUsageOccurrence): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_SpecifiedHigherUsageOccurrence {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_SpecifiedHigherUsageOccurrence): void;
  get(): StepRepr_SpecifiedHigherUsageOccurrence;
  delete(): void;
}

  export declare class Handle_StepRepr_SpecifiedHigherUsageOccurrence_1 extends Handle_StepRepr_SpecifiedHigherUsageOccurrence {
    constructor();
  }

  export declare class Handle_StepRepr_SpecifiedHigherUsageOccurrence_2 extends Handle_StepRepr_SpecifiedHigherUsageOccurrence {
    constructor(thePtr: StepRepr_SpecifiedHigherUsageOccurrence);
  }

  export declare class Handle_StepRepr_SpecifiedHigherUsageOccurrence_3 extends Handle_StepRepr_SpecifiedHigherUsageOccurrence {
    constructor(theHandle: Handle_StepRepr_SpecifiedHigherUsageOccurrence);
  }

  export declare class Handle_StepRepr_SpecifiedHigherUsageOccurrence_4 extends Handle_StepRepr_SpecifiedHigherUsageOccurrence {
    constructor(theHandle: Handle_StepRepr_SpecifiedHigherUsageOccurrence);
  }

export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI): void;
  get(): StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI;
  delete(): void;
}

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_1 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI {
    constructor();
  }

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_2 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI {
    constructor(thePtr: StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI);
  }

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_3 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI {
    constructor(theHandle: Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI);
  }

  export declare class Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_4 extends Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI {
    constructor(theHandle: Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI);
  }

export declare class StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI extends StepRepr_ReprItemAndMeasureWithUnitAndQRI {
  constructor()
  SetLengthMeasureWithUnit(aLMWU: Handle_StepBasic_LengthMeasureWithUnit): void;
  GetLengthMeasureWithUnit(): Handle_StepBasic_LengthMeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_HArray1OfPropertyDefinitionRepresentation): void;
  get(): StepRepr_HArray1OfPropertyDefinitionRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_1 extends Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_2 extends Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation {
    constructor(thePtr: StepRepr_HArray1OfPropertyDefinitionRepresentation);
  }

  export declare class Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_3 extends Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation {
    constructor(theHandle: Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation);
  }

  export declare class Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_4 extends Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation {
    constructor(theHandle: Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation);
  }

export declare class StepRepr_AssemblyComponentUsageSubstitute extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDef: Handle_TCollection_HAsciiString, aBase: Handle_StepRepr_AssemblyComponentUsage, aSubs: Handle_StepRepr_AssemblyComponentUsage): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Definition(): Handle_TCollection_HAsciiString;
  SetDefinition(aDef: Handle_TCollection_HAsciiString): void;
  Base(): Handle_StepRepr_AssemblyComponentUsage;
  SetBase(aBase: Handle_StepRepr_AssemblyComponentUsage): void;
  Substitute(): Handle_StepRepr_AssemblyComponentUsage;
  SetSubstitute(aSubstitute: Handle_StepRepr_AssemblyComponentUsage): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_AssemblyComponentUsageSubstitute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_AssemblyComponentUsageSubstitute): void;
  get(): StepRepr_AssemblyComponentUsageSubstitute;
  delete(): void;
}

  export declare class Handle_StepRepr_AssemblyComponentUsageSubstitute_1 extends Handle_StepRepr_AssemblyComponentUsageSubstitute {
    constructor();
  }

  export declare class Handle_StepRepr_AssemblyComponentUsageSubstitute_2 extends Handle_StepRepr_AssemblyComponentUsageSubstitute {
    constructor(thePtr: StepRepr_AssemblyComponentUsageSubstitute);
  }

  export declare class Handle_StepRepr_AssemblyComponentUsageSubstitute_3 extends Handle_StepRepr_AssemblyComponentUsageSubstitute {
    constructor(theHandle: Handle_StepRepr_AssemblyComponentUsageSubstitute);
  }

  export declare class Handle_StepRepr_AssemblyComponentUsageSubstitute_4 extends Handle_StepRepr_AssemblyComponentUsageSubstitute {
    constructor(theHandle: Handle_StepRepr_AssemblyComponentUsageSubstitute);
  }

export declare class StepRepr_CharacterizedDefinition extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CharacterizedObject(): Handle_StepBasic_CharacterizedObject;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionRelationship(): Handle_StepBasic_ProductDefinitionRelationship;
  ProductDefinitionShape(): Handle_StepRepr_ProductDefinitionShape;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  DocumentFile(): Handle_StepBasic_DocumentFile;
  delete(): void;
}

export declare class Handle_StepRepr_CharacterizedRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CharacterizedRepresentation): void;
  get(): StepRepr_CharacterizedRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_CharacterizedRepresentation_1 extends Handle_StepRepr_CharacterizedRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_CharacterizedRepresentation_2 extends Handle_StepRepr_CharacterizedRepresentation {
    constructor(thePtr: StepRepr_CharacterizedRepresentation);
  }

  export declare class Handle_StepRepr_CharacterizedRepresentation_3 extends Handle_StepRepr_CharacterizedRepresentation {
    constructor(theHandle: Handle_StepRepr_CharacterizedRepresentation);
  }

  export declare class Handle_StepRepr_CharacterizedRepresentation_4 extends Handle_StepRepr_CharacterizedRepresentation {
    constructor(theHandle: Handle_StepRepr_CharacterizedRepresentation);
  }

export declare class StepRepr_CharacterizedRepresentation extends StepRepr_Representation {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theItems: Handle_StepRepr_HArray1OfRepresentationItem, theContextOfItems: Handle_StepRepr_RepresentationContext): void;
  SetDescription(theDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_AssemblyComponentUsage {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_AssemblyComponentUsage): void;
  get(): StepRepr_AssemblyComponentUsage;
  delete(): void;
}

  export declare class Handle_StepRepr_AssemblyComponentUsage_1 extends Handle_StepRepr_AssemblyComponentUsage {
    constructor();
  }

  export declare class Handle_StepRepr_AssemblyComponentUsage_2 extends Handle_StepRepr_AssemblyComponentUsage {
    constructor(thePtr: StepRepr_AssemblyComponentUsage);
  }

  export declare class Handle_StepRepr_AssemblyComponentUsage_3 extends Handle_StepRepr_AssemblyComponentUsage {
    constructor(theHandle: Handle_StepRepr_AssemblyComponentUsage);
  }

  export declare class Handle_StepRepr_AssemblyComponentUsage_4 extends Handle_StepRepr_AssemblyComponentUsage {
    constructor(theHandle: Handle_StepRepr_AssemblyComponentUsage);
  }

export declare class StepRepr_AssemblyComponentUsage extends StepRepr_ProductDefinitionUsage {
  constructor()
  Init_1(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: Handle_StepBasic_ProductDefinition, aProductDefinitionRelationship_RelatedProductDefinition: Handle_StepBasic_ProductDefinition, hasReferenceDesignator: Standard_Boolean, aReferenceDesignator: Handle_TCollection_HAsciiString): void;
  Init_2(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: StepBasic_ProductDefinitionOrReference, aProductDefinitionRelationship_RelatedProductDefinition: StepBasic_ProductDefinitionOrReference, hasReferenceDesignator: Standard_Boolean, aReferenceDesignator: Handle_TCollection_HAsciiString): void;
  ReferenceDesignator(): Handle_TCollection_HAsciiString;
  SetReferenceDesignator(ReferenceDesignator: Handle_TCollection_HAsciiString): void;
  HasReferenceDesignator(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_DefinitionalRepresentation extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_DefinitionalRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_DefinitionalRepresentation): void;
  get(): StepRepr_DefinitionalRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_DefinitionalRepresentation_1 extends Handle_StepRepr_DefinitionalRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_DefinitionalRepresentation_2 extends Handle_StepRepr_DefinitionalRepresentation {
    constructor(thePtr: StepRepr_DefinitionalRepresentation);
  }

  export declare class Handle_StepRepr_DefinitionalRepresentation_3 extends Handle_StepRepr_DefinitionalRepresentation {
    constructor(theHandle: Handle_StepRepr_DefinitionalRepresentation);
  }

  export declare class Handle_StepRepr_DefinitionalRepresentation_4 extends Handle_StepRepr_DefinitionalRepresentation {
    constructor(theHandle: Handle_StepRepr_DefinitionalRepresentation);
  }

export declare class StepRepr_GeometricAlignment extends StepRepr_DerivedShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_GeometricAlignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_GeometricAlignment): void;
  get(): StepRepr_GeometricAlignment;
  delete(): void;
}

  export declare class Handle_StepRepr_GeometricAlignment_1 extends Handle_StepRepr_GeometricAlignment {
    constructor();
  }

  export declare class Handle_StepRepr_GeometricAlignment_2 extends Handle_StepRepr_GeometricAlignment {
    constructor(thePtr: StepRepr_GeometricAlignment);
  }

  export declare class Handle_StepRepr_GeometricAlignment_3 extends Handle_StepRepr_GeometricAlignment {
    constructor(theHandle: Handle_StepRepr_GeometricAlignment);
  }

  export declare class Handle_StepRepr_GeometricAlignment_4 extends Handle_StepRepr_GeometricAlignment {
    constructor(theHandle: Handle_StepRepr_GeometricAlignment);
  }

export declare class StepRepr_ConfigurationEffectivity extends StepBasic_ProductDefinitionEffectivity {
  constructor()
  Init(aEffectivity_Id: Handle_TCollection_HAsciiString, aProductDefinitionEffectivity_Usage: Handle_StepBasic_ProductDefinitionRelationship, aConfiguration: Handle_StepRepr_ConfigurationDesign): void;
  Configuration(): Handle_StepRepr_ConfigurationDesign;
  SetConfiguration(Configuration: Handle_StepRepr_ConfigurationDesign): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ConfigurationEffectivity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ConfigurationEffectivity): void;
  get(): StepRepr_ConfigurationEffectivity;
  delete(): void;
}

  export declare class Handle_StepRepr_ConfigurationEffectivity_1 extends Handle_StepRepr_ConfigurationEffectivity {
    constructor();
  }

  export declare class Handle_StepRepr_ConfigurationEffectivity_2 extends Handle_StepRepr_ConfigurationEffectivity {
    constructor(thePtr: StepRepr_ConfigurationEffectivity);
  }

  export declare class Handle_StepRepr_ConfigurationEffectivity_3 extends Handle_StepRepr_ConfigurationEffectivity {
    constructor(theHandle: Handle_StepRepr_ConfigurationEffectivity);
  }

  export declare class Handle_StepRepr_ConfigurationEffectivity_4 extends Handle_StepRepr_ConfigurationEffectivity {
    constructor(theHandle: Handle_StepRepr_ConfigurationEffectivity);
  }

export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ReprItemAndPlaneAngleMeasureWithUnit): void;
  get(): StepRepr_ReprItemAndPlaneAngleMeasureWithUnit;
  delete(): void;
}

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_1 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit {
    constructor();
  }

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_2 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit {
    constructor(thePtr: StepRepr_ReprItemAndPlaneAngleMeasureWithUnit);
  }

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_3 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit {
    constructor(theHandle: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit);
  }

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_4 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit {
    constructor(theHandle: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit);
  }

export declare class StepRepr_ReprItemAndPlaneAngleMeasureWithUnit extends StepRepr_ReprItemAndMeasureWithUnit {
  constructor()
  SetPlaneAngleMeasureWithUnit(aLMWU: Handle_StepBasic_PlaneAngleMeasureWithUnit): void;
  GetPlaneAngleMeasureWithUnit(): Handle_StepBasic_PlaneAngleMeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_MaterialProperty extends StepRepr_PropertyDefinition {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_MaterialProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_MaterialProperty): void;
  get(): StepRepr_MaterialProperty;
  delete(): void;
}

  export declare class Handle_StepRepr_MaterialProperty_1 extends Handle_StepRepr_MaterialProperty {
    constructor();
  }

  export declare class Handle_StepRepr_MaterialProperty_2 extends Handle_StepRepr_MaterialProperty {
    constructor(thePtr: StepRepr_MaterialProperty);
  }

  export declare class Handle_StepRepr_MaterialProperty_3 extends Handle_StepRepr_MaterialProperty {
    constructor(theHandle: Handle_StepRepr_MaterialProperty);
  }

  export declare class Handle_StepRepr_MaterialProperty_4 extends Handle_StepRepr_MaterialProperty {
    constructor(theHandle: Handle_StepRepr_MaterialProperty);
  }

export declare class Handle_StepRepr_CentreOfSymmetry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CentreOfSymmetry): void;
  get(): StepRepr_CentreOfSymmetry;
  delete(): void;
}

  export declare class Handle_StepRepr_CentreOfSymmetry_1 extends Handle_StepRepr_CentreOfSymmetry {
    constructor();
  }

  export declare class Handle_StepRepr_CentreOfSymmetry_2 extends Handle_StepRepr_CentreOfSymmetry {
    constructor(thePtr: StepRepr_CentreOfSymmetry);
  }

  export declare class Handle_StepRepr_CentreOfSymmetry_3 extends Handle_StepRepr_CentreOfSymmetry {
    constructor(theHandle: Handle_StepRepr_CentreOfSymmetry);
  }

  export declare class Handle_StepRepr_CentreOfSymmetry_4 extends Handle_StepRepr_CentreOfSymmetry {
    constructor(theHandle: Handle_StepRepr_CentreOfSymmetry);
  }

export declare class StepRepr_CentreOfSymmetry extends StepRepr_DerivedShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_ShapeDefinition extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionShape(): Handle_StepRepr_ProductDefinitionShape;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  delete(): void;
}

export declare class StepRepr_ExternallyDefinedRepresentation extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ExternallyDefinedRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ExternallyDefinedRepresentation): void;
  get(): StepRepr_ExternallyDefinedRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_ExternallyDefinedRepresentation_1 extends Handle_StepRepr_ExternallyDefinedRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_ExternallyDefinedRepresentation_2 extends Handle_StepRepr_ExternallyDefinedRepresentation {
    constructor(thePtr: StepRepr_ExternallyDefinedRepresentation);
  }

  export declare class Handle_StepRepr_ExternallyDefinedRepresentation_3 extends Handle_StepRepr_ExternallyDefinedRepresentation {
    constructor(theHandle: Handle_StepRepr_ExternallyDefinedRepresentation);
  }

  export declare class Handle_StepRepr_ExternallyDefinedRepresentation_4 extends Handle_StepRepr_ExternallyDefinedRepresentation {
    constructor(theHandle: Handle_StepRepr_ExternallyDefinedRepresentation);
  }

export declare class StepRepr_DescriptiveRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString): void;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_DescriptiveRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_DescriptiveRepresentationItem): void;
  get(): StepRepr_DescriptiveRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_DescriptiveRepresentationItem_1 extends Handle_StepRepr_DescriptiveRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_DescriptiveRepresentationItem_2 extends Handle_StepRepr_DescriptiveRepresentationItem {
    constructor(thePtr: StepRepr_DescriptiveRepresentationItem);
  }

  export declare class Handle_StepRepr_DescriptiveRepresentationItem_3 extends Handle_StepRepr_DescriptiveRepresentationItem {
    constructor(theHandle: Handle_StepRepr_DescriptiveRepresentationItem);
  }

  export declare class Handle_StepRepr_DescriptiveRepresentationItem_4 extends Handle_StepRepr_DescriptiveRepresentationItem {
    constructor(theHandle: Handle_StepRepr_DescriptiveRepresentationItem);
  }

export declare class Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_StructuralResponsePropertyDefinitionRepresentation): void;
  get(): StepRepr_StructuralResponsePropertyDefinitionRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_1 extends Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_2 extends Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation {
    constructor(thePtr: StepRepr_StructuralResponsePropertyDefinitionRepresentation);
  }

  export declare class Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_3 extends Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation {
    constructor(theHandle: Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation);
  }

  export declare class Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_4 extends Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation {
    constructor(theHandle: Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation);
  }

export declare class StepRepr_StructuralResponsePropertyDefinitionRepresentation extends StepRepr_PropertyDefinitionRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_ProductConcept extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aMarketContext: Handle_StepBasic_ProductConceptContext): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  MarketContext(): Handle_StepBasic_ProductConceptContext;
  SetMarketContext(MarketContext: Handle_StepBasic_ProductConceptContext): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ProductConcept {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ProductConcept): void;
  get(): StepRepr_ProductConcept;
  delete(): void;
}

  export declare class Handle_StepRepr_ProductConcept_1 extends Handle_StepRepr_ProductConcept {
    constructor();
  }

  export declare class Handle_StepRepr_ProductConcept_2 extends Handle_StepRepr_ProductConcept {
    constructor(thePtr: StepRepr_ProductConcept);
  }

  export declare class Handle_StepRepr_ProductConcept_3 extends Handle_StepRepr_ProductConcept {
    constructor(theHandle: Handle_StepRepr_ProductConcept);
  }

  export declare class Handle_StepRepr_ProductConcept_4 extends Handle_StepRepr_ProductConcept {
    constructor(theHandle: Handle_StepRepr_ProductConcept);
  }

export declare class StepRepr_RepresentedDefinition extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  GeneralProperty(): Handle_StepBasic_GeneralProperty;
  PropertyDefinition(): Handle_StepRepr_PropertyDefinition;
  PropertyDefinitionRelationship(): Handle_StepRepr_PropertyDefinitionRelationship;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  ShapeAspectRelationship(): Handle_StepRepr_ShapeAspectRelationship;
  delete(): void;
}

export declare class StepRepr_GlobalUncertaintyAssignedContext extends StepRepr_RepresentationContext {
  constructor()
  Init(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aUncertainty: Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit): void;
  SetUncertainty(aUncertainty: Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit): void;
  Uncertainty(): Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit;
  UncertaintyValue(num: Graphic3d_ZLayerId): Handle_StepBasic_UncertaintyMeasureWithUnit;
  NbUncertainty(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_GlobalUncertaintyAssignedContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_GlobalUncertaintyAssignedContext): void;
  get(): StepRepr_GlobalUncertaintyAssignedContext;
  delete(): void;
}

  export declare class Handle_StepRepr_GlobalUncertaintyAssignedContext_1 extends Handle_StepRepr_GlobalUncertaintyAssignedContext {
    constructor();
  }

  export declare class Handle_StepRepr_GlobalUncertaintyAssignedContext_2 extends Handle_StepRepr_GlobalUncertaintyAssignedContext {
    constructor(thePtr: StepRepr_GlobalUncertaintyAssignedContext);
  }

  export declare class Handle_StepRepr_GlobalUncertaintyAssignedContext_3 extends Handle_StepRepr_GlobalUncertaintyAssignedContext {
    constructor(theHandle: Handle_StepRepr_GlobalUncertaintyAssignedContext);
  }

  export declare class Handle_StepRepr_GlobalUncertaintyAssignedContext_4 extends Handle_StepRepr_GlobalUncertaintyAssignedContext {
    constructor(theHandle: Handle_StepRepr_GlobalUncertaintyAssignedContext);
  }

export declare class Handle_StepRepr_CompShAspAndDatumFeatAndShAsp {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CompShAspAndDatumFeatAndShAsp): void;
  get(): StepRepr_CompShAspAndDatumFeatAndShAsp;
  delete(): void;
}

  export declare class Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_1 extends Handle_StepRepr_CompShAspAndDatumFeatAndShAsp {
    constructor();
  }

  export declare class Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_2 extends Handle_StepRepr_CompShAspAndDatumFeatAndShAsp {
    constructor(thePtr: StepRepr_CompShAspAndDatumFeatAndShAsp);
  }

  export declare class Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_3 extends Handle_StepRepr_CompShAspAndDatumFeatAndShAsp {
    constructor(theHandle: Handle_StepRepr_CompShAspAndDatumFeatAndShAsp);
  }

  export declare class Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_4 extends Handle_StepRepr_CompShAspAndDatumFeatAndShAsp {
    constructor(theHandle: Handle_StepRepr_CompShAspAndDatumFeatAndShAsp);
  }

export declare class StepRepr_CompShAspAndDatumFeatAndShAsp extends StepRepr_ShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_ConstructiveGeometryRepresentationRelationship extends StepRepr_RepresentationRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ConstructiveGeometryRepresentationRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ConstructiveGeometryRepresentationRelationship): void;
  get(): StepRepr_ConstructiveGeometryRepresentationRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_1 extends Handle_StepRepr_ConstructiveGeometryRepresentationRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_2 extends Handle_StepRepr_ConstructiveGeometryRepresentationRelationship {
    constructor(thePtr: StepRepr_ConstructiveGeometryRepresentationRelationship);
  }

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_3 extends Handle_StepRepr_ConstructiveGeometryRepresentationRelationship {
    constructor(theHandle: Handle_StepRepr_ConstructiveGeometryRepresentationRelationship);
  }

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_4 extends Handle_StepRepr_ConstructiveGeometryRepresentationRelationship {
    constructor(theHandle: Handle_StepRepr_ConstructiveGeometryRepresentationRelationship);
  }

export declare class Handle_StepRepr_ProductDefinitionShape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ProductDefinitionShape): void;
  get(): StepRepr_ProductDefinitionShape;
  delete(): void;
}

  export declare class Handle_StepRepr_ProductDefinitionShape_1 extends Handle_StepRepr_ProductDefinitionShape {
    constructor();
  }

  export declare class Handle_StepRepr_ProductDefinitionShape_2 extends Handle_StepRepr_ProductDefinitionShape {
    constructor(thePtr: StepRepr_ProductDefinitionShape);
  }

  export declare class Handle_StepRepr_ProductDefinitionShape_3 extends Handle_StepRepr_ProductDefinitionShape {
    constructor(theHandle: Handle_StepRepr_ProductDefinitionShape);
  }

  export declare class Handle_StepRepr_ProductDefinitionShape_4 extends Handle_StepRepr_ProductDefinitionShape {
    constructor(theHandle: Handle_StepRepr_ProductDefinitionShape);
  }

export declare class StepRepr_ProductDefinitionShape extends StepRepr_PropertyDefinition {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ValueRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ValueRepresentationItem): void;
  get(): StepRepr_ValueRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_ValueRepresentationItem_1 extends Handle_StepRepr_ValueRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_ValueRepresentationItem_2 extends Handle_StepRepr_ValueRepresentationItem {
    constructor(thePtr: StepRepr_ValueRepresentationItem);
  }

  export declare class Handle_StepRepr_ValueRepresentationItem_3 extends Handle_StepRepr_ValueRepresentationItem {
    constructor(theHandle: Handle_StepRepr_ValueRepresentationItem);
  }

  export declare class Handle_StepRepr_ValueRepresentationItem_4 extends Handle_StepRepr_ValueRepresentationItem {
    constructor(theHandle: Handle_StepRepr_ValueRepresentationItem);
  }

export declare class StepRepr_ValueRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theValueComponentMember: Handle_StepBasic_MeasureValueMember): void;
  SetValueComponentMember(theValueComponentMember: Handle_StepBasic_MeasureValueMember): void;
  ValueComponentMember(): Handle_StepBasic_MeasureValueMember;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_Apex extends StepRepr_DerivedShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_Apex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_Apex): void;
  get(): StepRepr_Apex;
  delete(): void;
}

  export declare class Handle_StepRepr_Apex_1 extends Handle_StepRepr_Apex {
    constructor();
  }

  export declare class Handle_StepRepr_Apex_2 extends Handle_StepRepr_Apex {
    constructor(thePtr: StepRepr_Apex);
  }

  export declare class Handle_StepRepr_Apex_3 extends Handle_StepRepr_Apex {
    constructor(theHandle: Handle_StepRepr_Apex);
  }

  export declare class Handle_StepRepr_Apex_4 extends Handle_StepRepr_Apex {
    constructor(theHandle: Handle_StepRepr_Apex);
  }

export declare class Handle_StepRepr_FunctionallyDefinedTransformation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_FunctionallyDefinedTransformation): void;
  get(): StepRepr_FunctionallyDefinedTransformation;
  delete(): void;
}

  export declare class Handle_StepRepr_FunctionallyDefinedTransformation_1 extends Handle_StepRepr_FunctionallyDefinedTransformation {
    constructor();
  }

  export declare class Handle_StepRepr_FunctionallyDefinedTransformation_2 extends Handle_StepRepr_FunctionallyDefinedTransformation {
    constructor(thePtr: StepRepr_FunctionallyDefinedTransformation);
  }

  export declare class Handle_StepRepr_FunctionallyDefinedTransformation_3 extends Handle_StepRepr_FunctionallyDefinedTransformation {
    constructor(theHandle: Handle_StepRepr_FunctionallyDefinedTransformation);
  }

  export declare class Handle_StepRepr_FunctionallyDefinedTransformation_4 extends Handle_StepRepr_FunctionallyDefinedTransformation {
    constructor(theHandle: Handle_StepRepr_FunctionallyDefinedTransformation);
  }

export declare class StepRepr_FunctionallyDefinedTransformation extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_RepresentationMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_RepresentationMap): void;
  get(): StepRepr_RepresentationMap;
  delete(): void;
}

  export declare class Handle_StepRepr_RepresentationMap_1 extends Handle_StepRepr_RepresentationMap {
    constructor();
  }

  export declare class Handle_StepRepr_RepresentationMap_2 extends Handle_StepRepr_RepresentationMap {
    constructor(thePtr: StepRepr_RepresentationMap);
  }

  export declare class Handle_StepRepr_RepresentationMap_3 extends Handle_StepRepr_RepresentationMap {
    constructor(theHandle: Handle_StepRepr_RepresentationMap);
  }

  export declare class Handle_StepRepr_RepresentationMap_4 extends Handle_StepRepr_RepresentationMap {
    constructor(theHandle: Handle_StepRepr_RepresentationMap);
  }

export declare class StepRepr_RepresentationMap extends Standard_Transient {
  constructor()
  Init(aMappingOrigin: Handle_StepRepr_RepresentationItem, aMappedRepresentation: Handle_StepRepr_Representation): void;
  SetMappingOrigin(aMappingOrigin: Handle_StepRepr_RepresentationItem): void;
  MappingOrigin(): Handle_StepRepr_RepresentationItem;
  SetMappedRepresentation(aMappedRepresentation: Handle_StepRepr_Representation): void;
  MappedRepresentation(): Handle_StepRepr_Representation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_RepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_RepresentationItem): void;
  get(): StepRepr_RepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_RepresentationItem_1 extends Handle_StepRepr_RepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_RepresentationItem_2 extends Handle_StepRepr_RepresentationItem {
    constructor(thePtr: StepRepr_RepresentationItem);
  }

  export declare class Handle_StepRepr_RepresentationItem_3 extends Handle_StepRepr_RepresentationItem {
    constructor(theHandle: Handle_StepRepr_RepresentationItem);
  }

  export declare class Handle_StepRepr_RepresentationItem_4 extends Handle_StepRepr_RepresentationItem {
    constructor(theHandle: Handle_StepRepr_RepresentationItem);
  }

export declare class StepRepr_RepresentationItem extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_AllAroundShapeAspect extends StepRepr_ContinuosShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_AllAroundShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_AllAroundShapeAspect): void;
  get(): StepRepr_AllAroundShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_AllAroundShapeAspect_1 extends Handle_StepRepr_AllAroundShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_AllAroundShapeAspect_2 extends Handle_StepRepr_AllAroundShapeAspect {
    constructor(thePtr: StepRepr_AllAroundShapeAspect);
  }

  export declare class Handle_StepRepr_AllAroundShapeAspect_3 extends Handle_StepRepr_AllAroundShapeAspect {
    constructor(theHandle: Handle_StepRepr_AllAroundShapeAspect);
  }

  export declare class Handle_StepRepr_AllAroundShapeAspect_4 extends Handle_StepRepr_AllAroundShapeAspect {
    constructor(theHandle: Handle_StepRepr_AllAroundShapeAspect);
  }

export declare class Handle_StepRepr_ConstructiveGeometryRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ConstructiveGeometryRepresentation): void;
  get(): StepRepr_ConstructiveGeometryRepresentation;
  delete(): void;
}

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentation_1 extends Handle_StepRepr_ConstructiveGeometryRepresentation {
    constructor();
  }

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentation_2 extends Handle_StepRepr_ConstructiveGeometryRepresentation {
    constructor(thePtr: StepRepr_ConstructiveGeometryRepresentation);
  }

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentation_3 extends Handle_StepRepr_ConstructiveGeometryRepresentation {
    constructor(theHandle: Handle_StepRepr_ConstructiveGeometryRepresentation);
  }

  export declare class Handle_StepRepr_ConstructiveGeometryRepresentation_4 extends Handle_StepRepr_ConstructiveGeometryRepresentation {
    constructor(theHandle: Handle_StepRepr_ConstructiveGeometryRepresentation);
  }

export declare class StepRepr_ConstructiveGeometryRepresentation extends StepRepr_Representation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_Representation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_Representation): void;
  get(): StepRepr_Representation;
  delete(): void;
}

  export declare class Handle_StepRepr_Representation_1 extends Handle_StepRepr_Representation {
    constructor();
  }

  export declare class Handle_StepRepr_Representation_2 extends Handle_StepRepr_Representation {
    constructor(thePtr: StepRepr_Representation);
  }

  export declare class Handle_StepRepr_Representation_3 extends Handle_StepRepr_Representation {
    constructor(theHandle: Handle_StepRepr_Representation);
  }

  export declare class Handle_StepRepr_Representation_4 extends Handle_StepRepr_Representation {
    constructor(theHandle: Handle_StepRepr_Representation);
  }

export declare class StepRepr_Representation extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aItems: Handle_StepRepr_HArray1OfRepresentationItem, aContextOfItems: Handle_StepRepr_RepresentationContext): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetItems(aItems: Handle_StepRepr_HArray1OfRepresentationItem): void;
  Items(): Handle_StepRepr_HArray1OfRepresentationItem;
  ItemsValue(num: Graphic3d_ZLayerId): Handle_StepRepr_RepresentationItem;
  NbItems(): Graphic3d_ZLayerId;
  SetContextOfItems(aContextOfItems: Handle_StepRepr_RepresentationContext): void;
  ContextOfItems(): Handle_StepRepr_RepresentationContext;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_CompositeGroupShapeAspect extends StepRepr_CompositeShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_CompositeGroupShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CompositeGroupShapeAspect): void;
  get(): StepRepr_CompositeGroupShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_CompositeGroupShapeAspect_1 extends Handle_StepRepr_CompositeGroupShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_CompositeGroupShapeAspect_2 extends Handle_StepRepr_CompositeGroupShapeAspect {
    constructor(thePtr: StepRepr_CompositeGroupShapeAspect);
  }

  export declare class Handle_StepRepr_CompositeGroupShapeAspect_3 extends Handle_StepRepr_CompositeGroupShapeAspect {
    constructor(theHandle: Handle_StepRepr_CompositeGroupShapeAspect);
  }

  export declare class Handle_StepRepr_CompositeGroupShapeAspect_4 extends Handle_StepRepr_CompositeGroupShapeAspect {
    constructor(theHandle: Handle_StepRepr_CompositeGroupShapeAspect);
  }

export declare class StepRepr_ShapeRepresentationRelationshipWithTransformation extends StepRepr_RepresentationRelationshipWithTransformation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ShapeRepresentationRelationshipWithTransformation): void;
  get(): StepRepr_ShapeRepresentationRelationshipWithTransformation;
  delete(): void;
}

  export declare class Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_1 extends Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation {
    constructor();
  }

  export declare class Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_2 extends Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation {
    constructor(thePtr: StepRepr_ShapeRepresentationRelationshipWithTransformation);
  }

  export declare class Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_3 extends Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation {
    constructor(theHandle: Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation);
  }

  export declare class Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_4 extends Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation {
    constructor(theHandle: Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation);
  }

export declare class Handle_StepRepr_ShapeAspectTransition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ShapeAspectTransition): void;
  get(): StepRepr_ShapeAspectTransition;
  delete(): void;
}

  export declare class Handle_StepRepr_ShapeAspectTransition_1 extends Handle_StepRepr_ShapeAspectTransition {
    constructor();
  }

  export declare class Handle_StepRepr_ShapeAspectTransition_2 extends Handle_StepRepr_ShapeAspectTransition {
    constructor(thePtr: StepRepr_ShapeAspectTransition);
  }

  export declare class Handle_StepRepr_ShapeAspectTransition_3 extends Handle_StepRepr_ShapeAspectTransition {
    constructor(theHandle: Handle_StepRepr_ShapeAspectTransition);
  }

  export declare class Handle_StepRepr_ShapeAspectTransition_4 extends Handle_StepRepr_ShapeAspectTransition {
    constructor(theHandle: Handle_StepRepr_ShapeAspectTransition);
  }

export declare class StepRepr_ShapeAspectTransition extends StepRepr_ShapeAspectRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_IntegerRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(theName: Handle_TCollection_HAsciiString, theValue: Graphic3d_ZLayerId): void;
  SetValue(theValue: Graphic3d_ZLayerId): void;
  Value(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_IntegerRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_IntegerRepresentationItem): void;
  get(): StepRepr_IntegerRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_IntegerRepresentationItem_1 extends Handle_StepRepr_IntegerRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_IntegerRepresentationItem_2 extends Handle_StepRepr_IntegerRepresentationItem {
    constructor(thePtr: StepRepr_IntegerRepresentationItem);
  }

  export declare class Handle_StepRepr_IntegerRepresentationItem_3 extends Handle_StepRepr_IntegerRepresentationItem {
    constructor(theHandle: Handle_StepRepr_IntegerRepresentationItem);
  }

  export declare class Handle_StepRepr_IntegerRepresentationItem_4 extends Handle_StepRepr_IntegerRepresentationItem {
    constructor(theHandle: Handle_StepRepr_IntegerRepresentationItem);
  }

export declare class StepRepr_ConfigurationDesignItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  delete(): void;
}

export declare class StepRepr_DerivedShapeAspect extends StepRepr_ShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_DerivedShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_DerivedShapeAspect): void;
  get(): StepRepr_DerivedShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_DerivedShapeAspect_1 extends Handle_StepRepr_DerivedShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_DerivedShapeAspect_2 extends Handle_StepRepr_DerivedShapeAspect {
    constructor(thePtr: StepRepr_DerivedShapeAspect);
  }

  export declare class Handle_StepRepr_DerivedShapeAspect_3 extends Handle_StepRepr_DerivedShapeAspect {
    constructor(theHandle: Handle_StepRepr_DerivedShapeAspect);
  }

  export declare class Handle_StepRepr_DerivedShapeAspect_4 extends Handle_StepRepr_DerivedShapeAspect {
    constructor(theHandle: Handle_StepRepr_DerivedShapeAspect);
  }

export declare class Handle_StepRepr_CompoundRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_CompoundRepresentationItem): void;
  get(): StepRepr_CompoundRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_CompoundRepresentationItem_1 extends Handle_StepRepr_CompoundRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_CompoundRepresentationItem_2 extends Handle_StepRepr_CompoundRepresentationItem {
    constructor(thePtr: StepRepr_CompoundRepresentationItem);
  }

  export declare class Handle_StepRepr_CompoundRepresentationItem_3 extends Handle_StepRepr_CompoundRepresentationItem {
    constructor(theHandle: Handle_StepRepr_CompoundRepresentationItem);
  }

  export declare class Handle_StepRepr_CompoundRepresentationItem_4 extends Handle_StepRepr_CompoundRepresentationItem {
    constructor(theHandle: Handle_StepRepr_CompoundRepresentationItem);
  }

export declare class StepRepr_CompoundRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, item_element: Handle_StepRepr_HArray1OfRepresentationItem): void;
  ItemElement(): Handle_StepRepr_HArray1OfRepresentationItem;
  NbItemElement(): Graphic3d_ZLayerId;
  SetItemElement(item_element: Handle_StepRepr_HArray1OfRepresentationItem): void;
  ItemElementValue(num: Graphic3d_ZLayerId): Handle_StepRepr_RepresentationItem;
  SetItemElementValue(num: Graphic3d_ZLayerId, anelement: Handle_StepRepr_RepresentationItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_ItemDefinedTransformation extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aTransformItem1: Handle_StepRepr_RepresentationItem, aTransformItem2: Handle_StepRepr_RepresentationItem): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetTransformItem1(aItem: Handle_StepRepr_RepresentationItem): void;
  TransformItem1(): Handle_StepRepr_RepresentationItem;
  SetTransformItem2(aItem: Handle_StepRepr_RepresentationItem): void;
  TransformItem2(): Handle_StepRepr_RepresentationItem;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ItemDefinedTransformation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ItemDefinedTransformation): void;
  get(): StepRepr_ItemDefinedTransformation;
  delete(): void;
}

  export declare class Handle_StepRepr_ItemDefinedTransformation_1 extends Handle_StepRepr_ItemDefinedTransformation {
    constructor();
  }

  export declare class Handle_StepRepr_ItemDefinedTransformation_2 extends Handle_StepRepr_ItemDefinedTransformation {
    constructor(thePtr: StepRepr_ItemDefinedTransformation);
  }

  export declare class Handle_StepRepr_ItemDefinedTransformation_3 extends Handle_StepRepr_ItemDefinedTransformation {
    constructor(theHandle: Handle_StepRepr_ItemDefinedTransformation);
  }

  export declare class Handle_StepRepr_ItemDefinedTransformation_4 extends Handle_StepRepr_ItemDefinedTransformation {
    constructor(theHandle: Handle_StepRepr_ItemDefinedTransformation);
  }

export declare class StepRepr_ShapeAspectDerivingRelationship extends StepRepr_ShapeAspectRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ShapeAspectDerivingRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ShapeAspectDerivingRelationship): void;
  get(): StepRepr_ShapeAspectDerivingRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_ShapeAspectDerivingRelationship_1 extends Handle_StepRepr_ShapeAspectDerivingRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_ShapeAspectDerivingRelationship_2 extends Handle_StepRepr_ShapeAspectDerivingRelationship {
    constructor(thePtr: StepRepr_ShapeAspectDerivingRelationship);
  }

  export declare class Handle_StepRepr_ShapeAspectDerivingRelationship_3 extends Handle_StepRepr_ShapeAspectDerivingRelationship {
    constructor(theHandle: Handle_StepRepr_ShapeAspectDerivingRelationship);
  }

  export declare class Handle_StepRepr_ShapeAspectDerivingRelationship_4 extends Handle_StepRepr_ShapeAspectDerivingRelationship {
    constructor(theHandle: Handle_StepRepr_ShapeAspectDerivingRelationship);
  }

export declare class StepRepr_ShapeRepresentationRelationship extends StepRepr_RepresentationRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ShapeRepresentationRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ShapeRepresentationRelationship): void;
  get(): StepRepr_ShapeRepresentationRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_ShapeRepresentationRelationship_1 extends Handle_StepRepr_ShapeRepresentationRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_ShapeRepresentationRelationship_2 extends Handle_StepRepr_ShapeRepresentationRelationship {
    constructor(thePtr: StepRepr_ShapeRepresentationRelationship);
  }

  export declare class Handle_StepRepr_ShapeRepresentationRelationship_3 extends Handle_StepRepr_ShapeRepresentationRelationship {
    constructor(theHandle: Handle_StepRepr_ShapeRepresentationRelationship);
  }

  export declare class Handle_StepRepr_ShapeRepresentationRelationship_4 extends Handle_StepRepr_ShapeRepresentationRelationship {
    constructor(theHandle: Handle_StepRepr_ShapeRepresentationRelationship);
  }

export declare class StepRepr_ShapeAspect extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aOfShape: Handle_StepRepr_ProductDefinitionShape, aProductDefinitional: StepData_Logical): void;
  SetName(aName: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetDescription(aDescription: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetOfShape(aOfShape: Handle_StepRepr_ProductDefinitionShape): void;
  OfShape(): Handle_StepRepr_ProductDefinitionShape;
  SetProductDefinitional(aProductDefinitional: StepData_Logical): void;
  ProductDefinitional(): StepData_Logical;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ShapeAspect): void;
  get(): StepRepr_ShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_ShapeAspect_1 extends Handle_StepRepr_ShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_ShapeAspect_2 extends Handle_StepRepr_ShapeAspect {
    constructor(thePtr: StepRepr_ShapeAspect);
  }

  export declare class Handle_StepRepr_ShapeAspect_3 extends Handle_StepRepr_ShapeAspect {
    constructor(theHandle: Handle_StepRepr_ShapeAspect);
  }

  export declare class Handle_StepRepr_ShapeAspect_4 extends Handle_StepRepr_ShapeAspect {
    constructor(theHandle: Handle_StepRepr_ShapeAspect);
  }

export declare class Handle_StepRepr_ContinuosShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ContinuosShapeAspect): void;
  get(): StepRepr_ContinuosShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_ContinuosShapeAspect_1 extends Handle_StepRepr_ContinuosShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_ContinuosShapeAspect_2 extends Handle_StepRepr_ContinuosShapeAspect {
    constructor(thePtr: StepRepr_ContinuosShapeAspect);
  }

  export declare class Handle_StepRepr_ContinuosShapeAspect_3 extends Handle_StepRepr_ContinuosShapeAspect {
    constructor(theHandle: Handle_StepRepr_ContinuosShapeAspect);
  }

  export declare class Handle_StepRepr_ContinuosShapeAspect_4 extends Handle_StepRepr_ContinuosShapeAspect {
    constructor(theHandle: Handle_StepRepr_ContinuosShapeAspect);
  }

export declare class StepRepr_ContinuosShapeAspect extends StepRepr_CompositeShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_HArray1OfRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_HArray1OfRepresentationItem): void;
  get(): StepRepr_HArray1OfRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_HArray1OfRepresentationItem_1 extends Handle_StepRepr_HArray1OfRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_HArray1OfRepresentationItem_2 extends Handle_StepRepr_HArray1OfRepresentationItem {
    constructor(thePtr: StepRepr_HArray1OfRepresentationItem);
  }

  export declare class Handle_StepRepr_HArray1OfRepresentationItem_3 extends Handle_StepRepr_HArray1OfRepresentationItem {
    constructor(theHandle: Handle_StepRepr_HArray1OfRepresentationItem);
  }

  export declare class Handle_StepRepr_HArray1OfRepresentationItem_4 extends Handle_StepRepr_HArray1OfRepresentationItem {
    constructor(theHandle: Handle_StepRepr_HArray1OfRepresentationItem);
  }

export declare class StepRepr_RepresentationContext extends Standard_Transient {
  constructor()
  Init(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString): void;
  SetContextIdentifier(aContextIdentifier: Handle_TCollection_HAsciiString): void;
  ContextIdentifier(): Handle_TCollection_HAsciiString;
  SetContextType(aContextType: Handle_TCollection_HAsciiString): void;
  ContextType(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_RepresentationContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_RepresentationContext): void;
  get(): StepRepr_RepresentationContext;
  delete(): void;
}

  export declare class Handle_StepRepr_RepresentationContext_1 extends Handle_StepRepr_RepresentationContext {
    constructor();
  }

  export declare class Handle_StepRepr_RepresentationContext_2 extends Handle_StepRepr_RepresentationContext {
    constructor(thePtr: StepRepr_RepresentationContext);
  }

  export declare class Handle_StepRepr_RepresentationContext_3 extends Handle_StepRepr_RepresentationContext {
    constructor(theHandle: Handle_StepRepr_RepresentationContext);
  }

  export declare class Handle_StepRepr_RepresentationContext_4 extends Handle_StepRepr_RepresentationContext {
    constructor(theHandle: Handle_StepRepr_RepresentationContext);
  }

export declare class Handle_StepRepr_HArray1OfShapeAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_HArray1OfShapeAspect): void;
  get(): StepRepr_HArray1OfShapeAspect;
  delete(): void;
}

  export declare class Handle_StepRepr_HArray1OfShapeAspect_1 extends Handle_StepRepr_HArray1OfShapeAspect {
    constructor();
  }

  export declare class Handle_StepRepr_HArray1OfShapeAspect_2 extends Handle_StepRepr_HArray1OfShapeAspect {
    constructor(thePtr: StepRepr_HArray1OfShapeAspect);
  }

  export declare class Handle_StepRepr_HArray1OfShapeAspect_3 extends Handle_StepRepr_HArray1OfShapeAspect {
    constructor(theHandle: Handle_StepRepr_HArray1OfShapeAspect);
  }

  export declare class Handle_StepRepr_HArray1OfShapeAspect_4 extends Handle_StepRepr_HArray1OfShapeAspect {
    constructor(theHandle: Handle_StepRepr_HArray1OfShapeAspect);
  }

export declare class StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI extends StepRepr_ReprItemAndMeasureWithUnitAndQRI {
  constructor()
  SetPlaneAngleMeasureWithUnit(aLMWU: Handle_StepBasic_PlaneAngleMeasureWithUnit): void;
  GetPlaneAngleMeasureWithUnit(): Handle_StepBasic_PlaneAngleMeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI): void;
  get(): StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI;
  delete(): void;
}

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_1 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI {
    constructor();
  }

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_2 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI {
    constructor(thePtr: StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI);
  }

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_3 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI {
    constructor(theHandle: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI);
  }

  export declare class Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_4 extends Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI {
    constructor(theHandle: Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI);
  }

export declare class StepRepr_ShapeAspectRelationship extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aRelatingShapeAspect: Handle_StepRepr_ShapeAspect, aRelatedShapeAspect: Handle_StepRepr_ShapeAspect): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  RelatingShapeAspect(): Handle_StepRepr_ShapeAspect;
  SetRelatingShapeAspect(RelatingShapeAspect: Handle_StepRepr_ShapeAspect): void;
  RelatedShapeAspect(): Handle_StepRepr_ShapeAspect;
  SetRelatedShapeAspect(RelatedShapeAspect: Handle_StepRepr_ShapeAspect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ShapeAspectRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ShapeAspectRelationship): void;
  get(): StepRepr_ShapeAspectRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_ShapeAspectRelationship_1 extends Handle_StepRepr_ShapeAspectRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_ShapeAspectRelationship_2 extends Handle_StepRepr_ShapeAspectRelationship {
    constructor(thePtr: StepRepr_ShapeAspectRelationship);
  }

  export declare class Handle_StepRepr_ShapeAspectRelationship_3 extends Handle_StepRepr_ShapeAspectRelationship {
    constructor(theHandle: Handle_StepRepr_ShapeAspectRelationship);
  }

  export declare class Handle_StepRepr_ShapeAspectRelationship_4 extends Handle_StepRepr_ShapeAspectRelationship {
    constructor(theHandle: Handle_StepRepr_ShapeAspectRelationship);
  }

export declare class StepRepr_ConfigurationItem extends Standard_Transient {
  constructor()
  Init(aId: Handle_TCollection_HAsciiString, aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aItemConcept: Handle_StepRepr_ProductConcept, hasPurpose: Standard_Boolean, aPurpose: Handle_TCollection_HAsciiString): void;
  Id(): Handle_TCollection_HAsciiString;
  SetId(Id: Handle_TCollection_HAsciiString): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  ItemConcept(): Handle_StepRepr_ProductConcept;
  SetItemConcept(ItemConcept: Handle_StepRepr_ProductConcept): void;
  Purpose(): Handle_TCollection_HAsciiString;
  SetPurpose(Purpose: Handle_TCollection_HAsciiString): void;
  HasPurpose(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_ConfigurationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_ConfigurationItem): void;
  get(): StepRepr_ConfigurationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_ConfigurationItem_1 extends Handle_StepRepr_ConfigurationItem {
    constructor();
  }

  export declare class Handle_StepRepr_ConfigurationItem_2 extends Handle_StepRepr_ConfigurationItem {
    constructor(thePtr: StepRepr_ConfigurationItem);
  }

  export declare class Handle_StepRepr_ConfigurationItem_3 extends Handle_StepRepr_ConfigurationItem {
    constructor(theHandle: Handle_StepRepr_ConfigurationItem);
  }

  export declare class Handle_StepRepr_ConfigurationItem_4 extends Handle_StepRepr_ConfigurationItem {
    constructor(theHandle: Handle_StepRepr_ConfigurationItem);
  }

export declare class StepRepr_Transformation extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ItemDefinedTransformation(): Handle_StepRepr_ItemDefinedTransformation;
  FunctionallyDefinedTransformation(): Handle_StepRepr_FunctionallyDefinedTransformation;
  delete(): void;
}

export declare class StepRepr_PropertyDefinition extends Standard_Transient {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasDescription: Standard_Boolean, aDescription: Handle_TCollection_HAsciiString, aDefinition: StepRepr_CharacterizedDefinition): void;
  Name(): Handle_TCollection_HAsciiString;
  SetName(Name: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  HasDescription(): Standard_Boolean;
  Definition(): StepRepr_CharacterizedDefinition;
  SetDefinition(Definition: StepRepr_CharacterizedDefinition): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_PropertyDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_PropertyDefinition): void;
  get(): StepRepr_PropertyDefinition;
  delete(): void;
}

  export declare class Handle_StepRepr_PropertyDefinition_1 extends Handle_StepRepr_PropertyDefinition {
    constructor();
  }

  export declare class Handle_StepRepr_PropertyDefinition_2 extends Handle_StepRepr_PropertyDefinition {
    constructor(thePtr: StepRepr_PropertyDefinition);
  }

  export declare class Handle_StepRepr_PropertyDefinition_3 extends Handle_StepRepr_PropertyDefinition {
    constructor(theHandle: Handle_StepRepr_PropertyDefinition);
  }

  export declare class Handle_StepRepr_PropertyDefinition_4 extends Handle_StepRepr_PropertyDefinition {
    constructor(theHandle: Handle_StepRepr_PropertyDefinition);
  }

export declare class Handle_StepRepr_MakeFromUsageOption {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_MakeFromUsageOption): void;
  get(): StepRepr_MakeFromUsageOption;
  delete(): void;
}

  export declare class Handle_StepRepr_MakeFromUsageOption_1 extends Handle_StepRepr_MakeFromUsageOption {
    constructor();
  }

  export declare class Handle_StepRepr_MakeFromUsageOption_2 extends Handle_StepRepr_MakeFromUsageOption {
    constructor(thePtr: StepRepr_MakeFromUsageOption);
  }

  export declare class Handle_StepRepr_MakeFromUsageOption_3 extends Handle_StepRepr_MakeFromUsageOption {
    constructor(theHandle: Handle_StepRepr_MakeFromUsageOption);
  }

  export declare class Handle_StepRepr_MakeFromUsageOption_4 extends Handle_StepRepr_MakeFromUsageOption {
    constructor(theHandle: Handle_StepRepr_MakeFromUsageOption);
  }

export declare class StepRepr_MakeFromUsageOption extends StepRepr_ProductDefinitionUsage {
  constructor()
  Init_1(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: Handle_StepBasic_ProductDefinition, aProductDefinitionRelationship_RelatedProductDefinition: Handle_StepBasic_ProductDefinition, aRanking: Graphic3d_ZLayerId, aRankingRationale: Handle_TCollection_HAsciiString, aQuantity: Handle_StepBasic_MeasureWithUnit): void;
  Init_2(aProductDefinitionRelationship_Id: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_Name: Handle_TCollection_HAsciiString, hasProductDefinitionRelationship_Description: Standard_Boolean, aProductDefinitionRelationship_Description: Handle_TCollection_HAsciiString, aProductDefinitionRelationship_RelatingProductDefinition: StepBasic_ProductDefinitionOrReference, aProductDefinitionRelationship_RelatedProductDefinition: StepBasic_ProductDefinitionOrReference, aRanking: Graphic3d_ZLayerId, aRankingRationale: Handle_TCollection_HAsciiString, aQuantity: Handle_StepBasic_MeasureWithUnit): void;
  Ranking(): Graphic3d_ZLayerId;
  SetRanking(Ranking: Graphic3d_ZLayerId): void;
  RankingRationale(): Handle_TCollection_HAsciiString;
  SetRankingRationale(RankingRationale: Handle_TCollection_HAsciiString): void;
  Quantity(): Handle_StepBasic_MeasureWithUnit;
  SetQuantity(Quantity: Handle_StepBasic_MeasureWithUnit): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_SuppliedPartRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_SuppliedPartRelationship): void;
  get(): StepRepr_SuppliedPartRelationship;
  delete(): void;
}

  export declare class Handle_StepRepr_SuppliedPartRelationship_1 extends Handle_StepRepr_SuppliedPartRelationship {
    constructor();
  }

  export declare class Handle_StepRepr_SuppliedPartRelationship_2 extends Handle_StepRepr_SuppliedPartRelationship {
    constructor(thePtr: StepRepr_SuppliedPartRelationship);
  }

  export declare class Handle_StepRepr_SuppliedPartRelationship_3 extends Handle_StepRepr_SuppliedPartRelationship {
    constructor(theHandle: Handle_StepRepr_SuppliedPartRelationship);
  }

  export declare class Handle_StepRepr_SuppliedPartRelationship_4 extends Handle_StepRepr_SuppliedPartRelationship {
    constructor(theHandle: Handle_StepRepr_SuppliedPartRelationship);
  }

export declare class StepRepr_SuppliedPartRelationship extends StepBasic_ProductDefinitionRelationship {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepRepr_MeasureRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aValueComponent: Handle_StepBasic_MeasureValueMember, aUnitComponent: StepBasic_Unit): void;
  SetMeasure(Measure: Handle_StepBasic_MeasureWithUnit): void;
  Measure(): Handle_StepBasic_MeasureWithUnit;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepRepr_MeasureRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepRepr_MeasureRepresentationItem): void;
  get(): StepRepr_MeasureRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepRepr_MeasureRepresentationItem_1 extends Handle_StepRepr_MeasureRepresentationItem {
    constructor();
  }

  export declare class Handle_StepRepr_MeasureRepresentationItem_2 extends Handle_StepRepr_MeasureRepresentationItem {
    constructor(thePtr: StepRepr_MeasureRepresentationItem);
  }

  export declare class Handle_StepRepr_MeasureRepresentationItem_3 extends Handle_StepRepr_MeasureRepresentationItem {
    constructor(theHandle: Handle_StepRepr_MeasureRepresentationItem);
  }

  export declare class Handle_StepRepr_MeasureRepresentationItem_4 extends Handle_StepRepr_MeasureRepresentationItem {
    constructor(theHandle: Handle_StepRepr_MeasureRepresentationItem);
  }

export declare class StlAPI {
  constructor();
  static Write(theShape: TopoDS_Shape, theFile: Standard_CString, theAsciiMode: Standard_Boolean): Standard_Boolean;
  static Read(theShape: TopoDS_Shape, aFile: Standard_CString): Standard_Boolean;
  delete(): void;
}

export declare class StlAPI_Reader {
  constructor();
  Read(theShape: TopoDS_Shape, theFileName: Standard_CString): Standard_Boolean;
  delete(): void;
}

export declare class StlAPI_Writer {
  constructor()
  ASCIIMode(): Standard_Boolean;
  Write(theShape: TopoDS_Shape, theFileName: Standard_CString, theProgress: Message_ProgressRange): Standard_Boolean;
  delete(): void;
}

export declare class ShapeExtend_Explorer {
  constructor()
  CompoundFromSeq(seqval: Handle_TopTools_HSequenceOfShape): TopoDS_Shape;
  SeqFromCompound(comp: TopoDS_Shape, expcomp: Standard_Boolean): Handle_TopTools_HSequenceOfShape;
  ListFromSeq(seqval: Handle_TopTools_HSequenceOfShape, lisval: TopTools_ListOfShape, clear: Standard_Boolean): void;
  SeqFromList(lisval: TopTools_ListOfShape): Handle_TopTools_HSequenceOfShape;
  ShapeType(shape: TopoDS_Shape, compound: Standard_Boolean): TopAbs_ShapeEnum;
  SortedCompound(shape: TopoDS_Shape, type: TopAbs_ShapeEnum, explore: Standard_Boolean, compound: Standard_Boolean): TopoDS_Shape;
  DispatchList(list: Handle_TopTools_HSequenceOfShape, vertices: Handle_TopTools_HSequenceOfShape, edges: Handle_TopTools_HSequenceOfShape, wires: Handle_TopTools_HSequenceOfShape, faces: Handle_TopTools_HSequenceOfShape, shells: Handle_TopTools_HSequenceOfShape, solids: Handle_TopTools_HSequenceOfShape, compsols: Handle_TopTools_HSequenceOfShape, compounds: Handle_TopTools_HSequenceOfShape): void;
  delete(): void;
}

export declare class Handle_ShapeExtend_BasicMsgRegistrator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeExtend_BasicMsgRegistrator): void;
  get(): ShapeExtend_BasicMsgRegistrator;
  delete(): void;
}

  export declare class Handle_ShapeExtend_BasicMsgRegistrator_1 extends Handle_ShapeExtend_BasicMsgRegistrator {
    constructor();
  }

  export declare class Handle_ShapeExtend_BasicMsgRegistrator_2 extends Handle_ShapeExtend_BasicMsgRegistrator {
    constructor(thePtr: ShapeExtend_BasicMsgRegistrator);
  }

  export declare class Handle_ShapeExtend_BasicMsgRegistrator_3 extends Handle_ShapeExtend_BasicMsgRegistrator {
    constructor(theHandle: Handle_ShapeExtend_BasicMsgRegistrator);
  }

  export declare class Handle_ShapeExtend_BasicMsgRegistrator_4 extends Handle_ShapeExtend_BasicMsgRegistrator {
    constructor(theHandle: Handle_ShapeExtend_BasicMsgRegistrator);
  }

export declare class ShapeExtend_BasicMsgRegistrator extends Standard_Transient {
  constructor()
  Send_1(object: Handle_Standard_Transient, message: Message_Msg, gravity: Message_Gravity): void;
  Send_2(shape: TopoDS_Shape, message: Message_Msg, gravity: Message_Gravity): void;
  Send_3(message: Message_Msg, gravity: Message_Gravity): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeExtend_CompositeSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeExtend_CompositeSurface): void;
  get(): ShapeExtend_CompositeSurface;
  delete(): void;
}

  export declare class Handle_ShapeExtend_CompositeSurface_1 extends Handle_ShapeExtend_CompositeSurface {
    constructor();
  }

  export declare class Handle_ShapeExtend_CompositeSurface_2 extends Handle_ShapeExtend_CompositeSurface {
    constructor(thePtr: ShapeExtend_CompositeSurface);
  }

  export declare class Handle_ShapeExtend_CompositeSurface_3 extends Handle_ShapeExtend_CompositeSurface {
    constructor(theHandle: Handle_ShapeExtend_CompositeSurface);
  }

  export declare class Handle_ShapeExtend_CompositeSurface_4 extends Handle_ShapeExtend_CompositeSurface {
    constructor(theHandle: Handle_ShapeExtend_CompositeSurface);
  }

export declare class ShapeExtend_CompositeSurface extends Geom_Surface {
  Init_1(GridSurf: Handle_TColGeom_HArray2OfSurface, param: ShapeExtend_Parametrisation): Standard_Boolean;
  Init_2(GridSurf: Handle_TColGeom_HArray2OfSurface, UJoints: TColStd_Array1OfReal, VJoints: TColStd_Array1OfReal): Standard_Boolean;
  NbUPatches(): Graphic3d_ZLayerId;
  NbVPatches(): Graphic3d_ZLayerId;
  Patch_1(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId): Handle_Geom_Surface;
  Patches(): Handle_TColGeom_HArray2OfSurface;
  UJointValues(): Handle_TColStd_HArray1OfReal;
  VJointValues(): Handle_TColStd_HArray1OfReal;
  UJointValue(i: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  VJointValue(j: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  SetUJointValues(UJoints: TColStd_Array1OfReal): Standard_Boolean;
  SetVJointValues(VJoints: TColStd_Array1OfReal): Standard_Boolean;
  SetUFirstValue(UFirst: Quantity_AbsorbedDose): void;
  SetVFirstValue(VFirst: Quantity_AbsorbedDose): void;
  LocateUParameter(U: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  LocateVParameter(V: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  LocateUVPoint(pnt: gp_Pnt2d, i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId): void;
  Patch_2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): Handle_Geom_Surface;
  Patch_3(pnt: gp_Pnt2d): Handle_Geom_Surface;
  ULocalToGlobal(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, u: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VLocalToGlobal(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, v: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  LocalToGlobal(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, uv: gp_Pnt2d): gp_Pnt2d;
  UGlobalToLocal(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VGlobalToLocal(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GlobalToLocal(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, UV: gp_Pnt2d): gp_Pnt2d;
  GlobalToLocalTransformation(i: Graphic3d_ZLayerId, j: Graphic3d_ZLayerId, uFact: Quantity_AbsorbedDose, Trsf: gp_Trsf2d): Standard_Boolean;
  Transform(T: gp_Trsf): void;
  Copy(): Handle_Geom_Geometry;
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  IsVPeriodic(): Standard_Boolean;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  Continuity(): GeomAbs_Shape;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Value(pnt: gp_Pnt2d): gp_Pnt;
  ComputeJointValues(param: ShapeExtend_Parametrisation): void;
  CheckConnectivity(prec: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeExtend_CompositeSurface_1 extends ShapeExtend_CompositeSurface {
    constructor();
  }

  export declare class ShapeExtend_CompositeSurface_2 extends ShapeExtend_CompositeSurface {
    constructor(GridSurf: Handle_TColGeom_HArray2OfSurface, param: ShapeExtend_Parametrisation);
  }

  export declare class ShapeExtend_CompositeSurface_3 extends ShapeExtend_CompositeSurface {
    constructor(GridSurf: Handle_TColGeom_HArray2OfSurface, UJoints: TColStd_Array1OfReal, VJoints: TColStd_Array1OfReal);
  }

export declare class ShapeExtend_WireData extends Standard_Transient {
  Init_1(other: Handle_ShapeExtend_WireData): void;
  Init_2(wire: TopoDS_Wire, chained: Standard_Boolean, theManifoldMode: Standard_Boolean): Standard_Boolean;
  Clear(): void;
  ComputeSeams(enforce: Standard_Boolean): void;
  SetLast(num: Graphic3d_ZLayerId): void;
  SetDegeneratedLast(): void;
  Add_1(edge: TopoDS_Edge, atnum: Graphic3d_ZLayerId): void;
  Add_2(wire: TopoDS_Wire, atnum: Graphic3d_ZLayerId): void;
  Add_3(wire: Handle_ShapeExtend_WireData, atnum: Graphic3d_ZLayerId): void;
  Add_4(shape: TopoDS_Shape, atnum: Graphic3d_ZLayerId): void;
  AddOriented_1(edge: TopoDS_Edge, mode: Graphic3d_ZLayerId): void;
  AddOriented_2(wire: TopoDS_Wire, mode: Graphic3d_ZLayerId): void;
  AddOriented_3(shape: TopoDS_Shape, mode: Graphic3d_ZLayerId): void;
  Remove(num: Graphic3d_ZLayerId): void;
  Set(edge: TopoDS_Edge, num: Graphic3d_ZLayerId): void;
  Reverse_1(): void;
  Reverse_2(face: TopoDS_Face): void;
  NbEdges(): Graphic3d_ZLayerId;
  NbNonManifoldEdges(): Graphic3d_ZLayerId;
  NonmanifoldEdge(num: Graphic3d_ZLayerId): TopoDS_Edge;
  NonmanifoldEdges(): Handle_TopTools_HSequenceOfShape;
  ManifoldMode(): Standard_Boolean;
  Edge(num: Graphic3d_ZLayerId): TopoDS_Edge;
  Index(edge: TopoDS_Edge): Graphic3d_ZLayerId;
  IsSeam(num: Graphic3d_ZLayerId): Standard_Boolean;
  Wire(): TopoDS_Wire;
  WireAPIMake(): TopoDS_Wire;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeExtend_WireData_1 extends ShapeExtend_WireData {
    constructor();
  }

  export declare class ShapeExtend_WireData_2 extends ShapeExtend_WireData {
    constructor(wire: TopoDS_Wire, chained: Standard_Boolean, theManifoldMode: Standard_Boolean);
  }

export declare class Handle_ShapeExtend_WireData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeExtend_WireData): void;
  get(): ShapeExtend_WireData;
  delete(): void;
}

  export declare class Handle_ShapeExtend_WireData_1 extends Handle_ShapeExtend_WireData {
    constructor();
  }

  export declare class Handle_ShapeExtend_WireData_2 extends Handle_ShapeExtend_WireData {
    constructor(thePtr: ShapeExtend_WireData);
  }

  export declare class Handle_ShapeExtend_WireData_3 extends Handle_ShapeExtend_WireData {
    constructor(theHandle: Handle_ShapeExtend_WireData);
  }

  export declare class Handle_ShapeExtend_WireData_4 extends Handle_ShapeExtend_WireData {
    constructor(theHandle: Handle_ShapeExtend_WireData);
  }

export declare type ShapeExtend_Parametrisation = {
  ShapeExtend_Natural: {};
  ShapeExtend_Uniform: {};
  ShapeExtend_Unitary: {};
}

export declare class Handle_ShapeExtend_ComplexCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeExtend_ComplexCurve): void;
  get(): ShapeExtend_ComplexCurve;
  delete(): void;
}

  export declare class Handle_ShapeExtend_ComplexCurve_1 extends Handle_ShapeExtend_ComplexCurve {
    constructor();
  }

  export declare class Handle_ShapeExtend_ComplexCurve_2 extends Handle_ShapeExtend_ComplexCurve {
    constructor(thePtr: ShapeExtend_ComplexCurve);
  }

  export declare class Handle_ShapeExtend_ComplexCurve_3 extends Handle_ShapeExtend_ComplexCurve {
    constructor(theHandle: Handle_ShapeExtend_ComplexCurve);
  }

  export declare class Handle_ShapeExtend_ComplexCurve_4 extends Handle_ShapeExtend_ComplexCurve {
    constructor(theHandle: Handle_ShapeExtend_ComplexCurve);
  }

export declare class ShapeExtend_ComplexCurve extends Geom_Curve {
  NbCurves(): Graphic3d_ZLayerId;
  Curve(index: Graphic3d_ZLayerId): Handle_Geom_Curve;
  LocateParameter(U: Quantity_AbsorbedDose, UOut: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  LocalToGlobal(index: Graphic3d_ZLayerId, Ulocal: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Transform(T: gp_Trsf): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  GetScaleFactor(ind: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  CheckConnectivity(Preci: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type ShapeExtend_Status = {
  ShapeExtend_OK: {};
  ShapeExtend_DONE1: {};
  ShapeExtend_DONE2: {};
  ShapeExtend_DONE3: {};
  ShapeExtend_DONE4: {};
  ShapeExtend_DONE5: {};
  ShapeExtend_DONE6: {};
  ShapeExtend_DONE7: {};
  ShapeExtend_DONE8: {};
  ShapeExtend_DONE: {};
  ShapeExtend_FAIL1: {};
  ShapeExtend_FAIL2: {};
  ShapeExtend_FAIL3: {};
  ShapeExtend_FAIL4: {};
  ShapeExtend_FAIL5: {};
  ShapeExtend_FAIL6: {};
  ShapeExtend_FAIL7: {};
  ShapeExtend_FAIL8: {};
  ShapeExtend_FAIL: {};
}

export declare class ShapeExtend {
  constructor();
  static Init(): void;
  static EncodeStatus(status: ShapeExtend_Status): Graphic3d_ZLayerId;
  static DecodeStatus(flag: Graphic3d_ZLayerId, status: ShapeExtend_Status): Standard_Boolean;
  delete(): void;
}

export declare class Handle_ShapeExtend_MsgRegistrator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeExtend_MsgRegistrator): void;
  get(): ShapeExtend_MsgRegistrator;
  delete(): void;
}

  export declare class Handle_ShapeExtend_MsgRegistrator_1 extends Handle_ShapeExtend_MsgRegistrator {
    constructor();
  }

  export declare class Handle_ShapeExtend_MsgRegistrator_2 extends Handle_ShapeExtend_MsgRegistrator {
    constructor(thePtr: ShapeExtend_MsgRegistrator);
  }

  export declare class Handle_ShapeExtend_MsgRegistrator_3 extends Handle_ShapeExtend_MsgRegistrator {
    constructor(theHandle: Handle_ShapeExtend_MsgRegistrator);
  }

  export declare class Handle_ShapeExtend_MsgRegistrator_4 extends Handle_ShapeExtend_MsgRegistrator {
    constructor(theHandle: Handle_ShapeExtend_MsgRegistrator);
  }

export declare class ShapeExtend_MsgRegistrator extends ShapeExtend_BasicMsgRegistrator {
  constructor()
  Send_1(object: Handle_Standard_Transient, message: Message_Msg, gravity: Message_Gravity): void;
  Send_2(shape: TopoDS_Shape, message: Message_Msg, gravity: Message_Gravity): void;
  MapTransient(): ShapeExtend_DataMapOfTransientListOfMsg;
  MapShape(): ShapeExtend_DataMapOfShapeListOfMsg;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeExtend_DataMapOfShapeListOfMsg extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: ShapeExtend_DataMapOfShapeListOfMsg): void;
  Assign(theOther: ShapeExtend_DataMapOfShapeListOfMsg): ShapeExtend_DataMapOfShapeListOfMsg;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Message_ListOfMsg): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Message_ListOfMsg): Message_ListOfMsg;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Message_ListOfMsg;
  ChangeSeek(theKey: TopoDS_Shape): Message_ListOfMsg;
  ChangeFind(theKey: TopoDS_Shape): Message_ListOfMsg;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class ShapeExtend_DataMapOfShapeListOfMsg_1 extends ShapeExtend_DataMapOfShapeListOfMsg {
    constructor();
  }

  export declare class ShapeExtend_DataMapOfShapeListOfMsg_2 extends ShapeExtend_DataMapOfShapeListOfMsg {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class ShapeExtend_DataMapOfShapeListOfMsg_3 extends ShapeExtend_DataMapOfShapeListOfMsg {
    constructor(theOther: ShapeExtend_DataMapOfShapeListOfMsg);
  }

export declare class BOPDS_MapOfPave extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPDS_MapOfPave): void;
  Assign(theOther: BOPDS_MapOfPave): BOPDS_MapOfPave;
  ReSize(N: Standard_Integer): void;
  Add(K: BOPDS_Pave): Standard_Boolean;
  Added(K: BOPDS_Pave): BOPDS_Pave;
  Contains_1(K: BOPDS_Pave): Standard_Boolean;
  Remove(K: BOPDS_Pave): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: BOPDS_MapOfPave): Standard_Boolean;
  Contains_2(theOther: BOPDS_MapOfPave): Standard_Boolean;
  Union(theLeft: BOPDS_MapOfPave, theRight: BOPDS_MapOfPave): void;
  Unite(theOther: BOPDS_MapOfPave): Standard_Boolean;
  HasIntersection(theMap: BOPDS_MapOfPave): Standard_Boolean;
  Intersection(theLeft: BOPDS_MapOfPave, theRight: BOPDS_MapOfPave): void;
  Intersect(theOther: BOPDS_MapOfPave): Standard_Boolean;
  Subtraction(theLeft: BOPDS_MapOfPave, theRight: BOPDS_MapOfPave): void;
  Subtract(theOther: BOPDS_MapOfPave): Standard_Boolean;
  Difference(theLeft: BOPDS_MapOfPave, theRight: BOPDS_MapOfPave): void;
  Differ(theOther: BOPDS_MapOfPave): Standard_Boolean;
  delete(): void;
}

  export declare class BOPDS_MapOfPave_1 extends BOPDS_MapOfPave {
    constructor();
  }

  export declare class BOPDS_MapOfPave_2 extends BOPDS_MapOfPave {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_MapOfPave_3 extends BOPDS_MapOfPave {
    constructor(theOther: BOPDS_MapOfPave);
  }

export declare class BOPDS_PaveMapHasher {
  constructor();
  static HashCode(thePave: BOPDS_Pave, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(aPave1: BOPDS_Pave, aPave2: BOPDS_Pave): Standard_Boolean;
  delete(): void;
}

export declare class BOPDS_VectorOfInterfEF extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfEF, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfEF): BOPDS_InterfEF;
  Appended(): BOPDS_InterfEF;
  Value(theIndex: Standard_Integer): BOPDS_InterfEF;
  First(): BOPDS_InterfEF;
  ChangeFirst(): BOPDS_InterfEF;
  Last(): BOPDS_InterfEF;
  ChangeLast(): BOPDS_InterfEF;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfEF;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfEF): BOPDS_InterfEF;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfEF_1 extends BOPDS_VectorOfInterfEF {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfEF_2 extends BOPDS_VectorOfInterfEF {
    constructor(theOther: BOPDS_VectorOfInterfEF);
  }

export declare class BOPDS_VectorOfInterfFF extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfFF, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfFF): BOPDS_InterfFF;
  Appended(): BOPDS_InterfFF;
  Value(theIndex: Standard_Integer): BOPDS_InterfFF;
  First(): BOPDS_InterfFF;
  ChangeFirst(): BOPDS_InterfFF;
  Last(): BOPDS_InterfFF;
  ChangeLast(): BOPDS_InterfFF;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfFF;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfFF): BOPDS_InterfFF;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfFF_1 extends BOPDS_VectorOfInterfFF {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfFF_2 extends BOPDS_VectorOfInterfFF {
    constructor(theOther: BOPDS_VectorOfInterfFF);
  }

export declare class BOPDS_VectorOfInterfFZ extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfFZ, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfFZ): BOPDS_InterfFZ;
  Appended(): BOPDS_InterfFZ;
  Value(theIndex: Standard_Integer): BOPDS_InterfFZ;
  First(): BOPDS_InterfFZ;
  ChangeFirst(): BOPDS_InterfFZ;
  Last(): BOPDS_InterfFZ;
  ChangeLast(): BOPDS_InterfFZ;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfFZ;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfFZ): BOPDS_InterfFZ;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfFZ_1 extends BOPDS_VectorOfInterfFZ {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfFZ_2 extends BOPDS_VectorOfInterfFZ {
    constructor(theOther: BOPDS_VectorOfInterfFZ);
  }

export declare class BOPDS_Tools {
  constructor();
  static TypeToInteger_1(theT1: TopAbs_ShapeEnum, theT2: TopAbs_ShapeEnum): Graphic3d_ZLayerId;
  static TypeToInteger_2(theT: TopAbs_ShapeEnum): Graphic3d_ZLayerId;
  static HasBRep(theT: TopAbs_ShapeEnum): Standard_Boolean;
  static IsInterfering(theT: TopAbs_ShapeEnum): Standard_Boolean;
  delete(): void;
}

export declare class BOPDS_VectorOfInterfVF extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfVF, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfVF): BOPDS_InterfVF;
  Appended(): BOPDS_InterfVF;
  Value(theIndex: Standard_Integer): BOPDS_InterfVF;
  First(): BOPDS_InterfVF;
  ChangeFirst(): BOPDS_InterfVF;
  Last(): BOPDS_InterfVF;
  ChangeLast(): BOPDS_InterfVF;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfVF;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfVF): BOPDS_InterfVF;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfVF_1 extends BOPDS_VectorOfInterfVF {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfVF_2 extends BOPDS_VectorOfInterfVF {
    constructor(theOther: BOPDS_VectorOfInterfVF);
  }

export declare class BOPDS_VectorOfPair extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfPair, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_Pair): BOPDS_Pair;
  Appended(): BOPDS_Pair;
  Value(theIndex: Standard_Integer): BOPDS_Pair;
  First(): BOPDS_Pair;
  ChangeFirst(): BOPDS_Pair;
  Last(): BOPDS_Pair;
  ChangeLast(): BOPDS_Pair;
  ChangeValue(theIndex: Standard_Integer): BOPDS_Pair;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_Pair): BOPDS_Pair;
  delete(): void;
}

  export declare class BOPDS_VectorOfPair_1 extends BOPDS_VectorOfPair {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfPair_2 extends BOPDS_VectorOfPair {
    constructor(theOther: BOPDS_VectorOfPair);
  }

export declare class BOPDS_VectorOfListOfPaveBlock extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfListOfPaveBlock, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_ListOfPaveBlock): BOPDS_ListOfPaveBlock;
  Appended(): BOPDS_ListOfPaveBlock;
  Value(theIndex: Standard_Integer): BOPDS_ListOfPaveBlock;
  First(): BOPDS_ListOfPaveBlock;
  ChangeFirst(): BOPDS_ListOfPaveBlock;
  Last(): BOPDS_ListOfPaveBlock;
  ChangeLast(): BOPDS_ListOfPaveBlock;
  ChangeValue(theIndex: Standard_Integer): BOPDS_ListOfPaveBlock;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_ListOfPaveBlock): BOPDS_ListOfPaveBlock;
  delete(): void;
}

  export declare class BOPDS_VectorOfListOfPaveBlock_1 extends BOPDS_VectorOfListOfPaveBlock {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfListOfPaveBlock_2 extends BOPDS_VectorOfListOfPaveBlock {
    constructor(theOther: BOPDS_VectorOfListOfPaveBlock);
  }

export declare class BOPDS_SubIterator {
  SetDS(pDS: BOPDS_PDS): void;
  DS(): BOPDS_DS;
  SetSubSet1(theLI: TColStd_ListOfInteger): void;
  SubSet1(): TColStd_ListOfInteger;
  SetSubSet2(theLI: TColStd_ListOfInteger): void;
  SubSet2(): TColStd_ListOfInteger;
  Initialize(): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  Prepare(): void;
  ExpectedLength(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class BOPDS_SubIterator_1 extends BOPDS_SubIterator {
    constructor();
  }

  export declare class BOPDS_SubIterator_2 extends BOPDS_SubIterator {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_PairMapHasher {
  constructor();
  static HashCode(thePair: BOPDS_Pair, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(thePair1: BOPDS_Pair, thePair2: BOPDS_Pair): Standard_Boolean;
  delete(): void;
}

export declare class BOPDS_VectorOfPoint extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfPoint, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_Point): BOPDS_Point;
  Appended(): BOPDS_Point;
  Value(theIndex: Standard_Integer): BOPDS_Point;
  First(): BOPDS_Point;
  ChangeFirst(): BOPDS_Point;
  Last(): BOPDS_Point;
  ChangeLast(): BOPDS_Point;
  ChangeValue(theIndex: Standard_Integer): BOPDS_Point;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_Point): BOPDS_Point;
  delete(): void;
}

  export declare class BOPDS_VectorOfPoint_1 extends BOPDS_VectorOfPoint {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfPoint_2 extends BOPDS_VectorOfPoint {
    constructor(theOther: BOPDS_VectorOfPoint);
  }

export declare class BOPDS_VectorOfInterfZZ extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfZZ, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfZZ): BOPDS_InterfZZ;
  Appended(): BOPDS_InterfZZ;
  Value(theIndex: Standard_Integer): BOPDS_InterfZZ;
  First(): BOPDS_InterfZZ;
  ChangeFirst(): BOPDS_InterfZZ;
  Last(): BOPDS_InterfZZ;
  ChangeLast(): BOPDS_InterfZZ;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfZZ;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfZZ): BOPDS_InterfZZ;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfZZ_1 extends BOPDS_VectorOfInterfZZ {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfZZ_2 extends BOPDS_VectorOfInterfZZ {
    constructor(theOther: BOPDS_VectorOfInterfZZ);
  }

export declare class BOPDS_PaveBlock extends Standard_Transient {
  SetPave1(thePave: BOPDS_Pave): void;
  Pave1(): BOPDS_Pave;
  SetPave2(thePave: BOPDS_Pave): void;
  Pave2(): BOPDS_Pave;
  SetEdge(theEdge: Graphic3d_ZLayerId): void;
  Edge(): Graphic3d_ZLayerId;
  HasEdge_1(): Standard_Boolean;
  HasEdge_2(theEdge: Graphic3d_ZLayerId): Standard_Boolean;
  SetOriginalEdge(theEdge: Graphic3d_ZLayerId): void;
  OriginalEdge(): Graphic3d_ZLayerId;
  IsSplitEdge(): Standard_Boolean;
  Range(theT1: Quantity_AbsorbedDose, theT2: Quantity_AbsorbedDose): void;
  HasSameBounds(theOther: Handle_BOPDS_PaveBlock): Standard_Boolean;
  Indices(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  IsToUpdate(): Standard_Boolean;
  AppendExtPave(thePave: BOPDS_Pave): void;
  AppendExtPave1(thePave: BOPDS_Pave): void;
  RemoveExtPave(theVertNum: Graphic3d_ZLayerId): void;
  ExtPaves(): BOPDS_ListOfPave;
  ChangeExtPaves(): BOPDS_ListOfPave;
  Update(theLPB: BOPDS_ListOfPaveBlock, theFlag: Standard_Boolean): void;
  ContainsParameter(thePrm: Quantity_AbsorbedDose, theTol: Quantity_AbsorbedDose, theInd: Graphic3d_ZLayerId): Standard_Boolean;
  SetShrunkData(theTS1: Quantity_AbsorbedDose, theTS2: Quantity_AbsorbedDose, theBox: Bnd_Box, theIsSplittable: Standard_Boolean): void;
  ShrunkData(theTS1: Quantity_AbsorbedDose, theTS2: Quantity_AbsorbedDose, theBox: Bnd_Box, theIsSplittable: Standard_Boolean): void;
  HasShrunkData(): Standard_Boolean;
  Dump(): void;
  IsSplittable(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BOPDS_PaveBlock_1 extends BOPDS_PaveBlock {
    constructor();
  }

  export declare class BOPDS_PaveBlock_2 extends BOPDS_PaveBlock {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class Handle_BOPDS_PaveBlock {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BOPDS_PaveBlock): void;
  get(): BOPDS_PaveBlock;
  delete(): void;
}

  export declare class Handle_BOPDS_PaveBlock_1 extends Handle_BOPDS_PaveBlock {
    constructor();
  }

  export declare class Handle_BOPDS_PaveBlock_2 extends Handle_BOPDS_PaveBlock {
    constructor(thePtr: BOPDS_PaveBlock);
  }

  export declare class Handle_BOPDS_PaveBlock_3 extends Handle_BOPDS_PaveBlock {
    constructor(theHandle: Handle_BOPDS_PaveBlock);
  }

  export declare class Handle_BOPDS_PaveBlock_4 extends Handle_BOPDS_PaveBlock {
    constructor(theHandle: Handle_BOPDS_PaveBlock);
  }

export declare class BOPDS_VectorOfInterfVZ extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfVZ, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfVZ): BOPDS_InterfVZ;
  Appended(): BOPDS_InterfVZ;
  Value(theIndex: Standard_Integer): BOPDS_InterfVZ;
  First(): BOPDS_InterfVZ;
  ChangeFirst(): BOPDS_InterfVZ;
  Last(): BOPDS_InterfVZ;
  ChangeLast(): BOPDS_InterfVZ;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfVZ;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfVZ): BOPDS_InterfVZ;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfVZ_1 extends BOPDS_VectorOfInterfVZ {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfVZ_2 extends BOPDS_VectorOfInterfVZ {
    constructor(theOther: BOPDS_VectorOfInterfVZ);
  }

export declare class BOPDS_ListOfPave extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BOPDS_ListOfPave): BOPDS_ListOfPave;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BOPDS_Pave;
  First_2(): BOPDS_Pave;
  Last_1(): BOPDS_Pave;
  Last_2(): BOPDS_Pave;
  Append_1(theItem: BOPDS_Pave): BOPDS_Pave;
  Append_3(theOther: BOPDS_ListOfPave): void;
  Prepend_1(theItem: BOPDS_Pave): BOPDS_Pave;
  Prepend_2(theOther: BOPDS_ListOfPave): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BOPDS_ListOfPave_1 extends BOPDS_ListOfPave {
    constructor();
  }

  export declare class BOPDS_ListOfPave_2 extends BOPDS_ListOfPave {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_ListOfPave_3 extends BOPDS_ListOfPave {
    constructor(theOther: BOPDS_ListOfPave);
  }

export declare class BOPDS_DS {
  Clear(): void;
  Allocator(): Handle_NCollection_BaseAllocator;
  SetArguments(theLS: TopTools_ListOfShape): void;
  Arguments(): TopTools_ListOfShape;
  Init(theFuzz: Quantity_AbsorbedDose): void;
  NbShapes(): Graphic3d_ZLayerId;
  NbSourceShapes(): Graphic3d_ZLayerId;
  NbRanges(): Graphic3d_ZLayerId;
  Range(theIndex: Graphic3d_ZLayerId): BOPDS_IndexRange;
  Rank(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsNewShape(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  Append_1(theSI: BOPDS_ShapeInfo): Graphic3d_ZLayerId;
  Append_2(theS: TopoDS_Shape): Graphic3d_ZLayerId;
  ShapeInfo(theIndex: Graphic3d_ZLayerId): BOPDS_ShapeInfo;
  ChangeShapeInfo(theIndex: Graphic3d_ZLayerId): BOPDS_ShapeInfo;
  Shape(theIndex: Graphic3d_ZLayerId): TopoDS_Shape;
  Index(theS: TopoDS_Shape): Graphic3d_ZLayerId;
  PaveBlocksPool(): BOPDS_VectorOfListOfPaveBlock;
  ChangePaveBlocksPool(): BOPDS_VectorOfListOfPaveBlock;
  HasPaveBlocks(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  PaveBlocks(theIndex: Graphic3d_ZLayerId): BOPDS_ListOfPaveBlock;
  ChangePaveBlocks(theIndex: Graphic3d_ZLayerId): BOPDS_ListOfPaveBlock;
  UpdatePaveBlocks(): void;
  UpdatePaveBlock(thePB: Handle_BOPDS_PaveBlock): void;
  UpdateCommonBlock(theCB: Handle_BOPDS_CommonBlock, theFuzz: Quantity_AbsorbedDose): void;
  IsCommonBlock(thePB: Handle_BOPDS_PaveBlock): Standard_Boolean;
  CommonBlock(thePB: Handle_BOPDS_PaveBlock): Handle_BOPDS_CommonBlock;
  SetCommonBlock(thePB: Handle_BOPDS_PaveBlock, theCB: Handle_BOPDS_CommonBlock): void;
  RealPaveBlock(thePB: Handle_BOPDS_PaveBlock): Handle_BOPDS_PaveBlock;
  IsCommonBlockOnEdge(thePB: Handle_BOPDS_PaveBlock): Standard_Boolean;
  FaceInfoPool(): BOPDS_VectorOfFaceInfo;
  HasFaceInfo(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  FaceInfo(theIndex: Graphic3d_ZLayerId): BOPDS_FaceInfo;
  ChangeFaceInfo(theIndex: Graphic3d_ZLayerId): BOPDS_FaceInfo;
  UpdateFaceInfoIn_1(theIndex: Graphic3d_ZLayerId): void;
  UpdateFaceInfoIn_2(theFaces: TColStd_MapOfInteger): void;
  UpdateFaceInfoOn_1(theIndex: Graphic3d_ZLayerId): void;
  UpdateFaceInfoOn_2(theFaces: TColStd_MapOfInteger): void;
  FaceInfoOn(theIndex: Graphic3d_ZLayerId, theMPB: BOPDS_IndexedMapOfPaveBlock, theMVP: TColStd_MapOfInteger): void;
  FaceInfoIn(theIndex: Graphic3d_ZLayerId, theMPB: BOPDS_IndexedMapOfPaveBlock, theMVP: TColStd_MapOfInteger): void;
  AloneVertices(theF: Graphic3d_ZLayerId, theLI: TColStd_ListOfInteger): void;
  RefineFaceInfoOn(): void;
  RefineFaceInfoIn(): void;
  SubShapesOnIn(theNF1: Graphic3d_ZLayerId, theNF2: Graphic3d_ZLayerId, theMVOnIn: TColStd_MapOfInteger, theMVCommon: TColStd_MapOfInteger, thePBOnIn: BOPDS_IndexedMapOfPaveBlock, theCommonPB: BOPDS_MapOfPaveBlock): void;
  SharedEdges(theF1: Graphic3d_ZLayerId, theF2: Graphic3d_ZLayerId, theLI: TColStd_ListOfInteger, theAllocator: Handle_NCollection_BaseAllocator): void;
  ShapesSD(): TColStd_DataMapOfIntegerInteger;
  AddShapeSD(theIndex: Graphic3d_ZLayerId, theIndexSD: Graphic3d_ZLayerId): void;
  HasShapeSD(theIndex: Graphic3d_ZLayerId, theIndexSD: Graphic3d_ZLayerId): Standard_Boolean;
  InterfVV(): BOPDS_VectorOfInterfVV;
  InterfVE(): BOPDS_VectorOfInterfVE;
  InterfVF(): BOPDS_VectorOfInterfVF;
  InterfEE(): BOPDS_VectorOfInterfEE;
  InterfEF(): BOPDS_VectorOfInterfEF;
  InterfFF(): BOPDS_VectorOfInterfFF;
  InterfVZ(): BOPDS_VectorOfInterfVZ;
  InterfEZ(): BOPDS_VectorOfInterfEZ;
  InterfFZ(): BOPDS_VectorOfInterfFZ;
  InterfZZ(): BOPDS_VectorOfInterfZZ;
  static NbInterfTypes(): Graphic3d_ZLayerId;
  AddInterf(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId): Standard_Boolean;
  HasInterf_1(theI: Graphic3d_ZLayerId): Standard_Boolean;
  HasInterf_2(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId): Standard_Boolean;
  HasInterfShapeSubShapes(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId, theFlag: Standard_Boolean): Standard_Boolean;
  HasInterfSubShapes(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId): Standard_Boolean;
  Interferences(): BOPDS_MapOfPair;
  Dump(): void;
  IsSubShape(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId): Standard_Boolean;
  Paves(theIndex: Graphic3d_ZLayerId, theLP: BOPDS_ListOfPave): void;
  UpdatePaveBlocksWithSDVertices(): void;
  UpdatePaveBlockWithSDVertices(thePB: Handle_BOPDS_PaveBlock): void;
  UpdateCommonBlockWithSDVertices(theCB: Handle_BOPDS_CommonBlock): void;
  InitPaveBlocksForVertex(theNV: Graphic3d_ZLayerId): void;
  ReleasePaveBlocks(): void;
  IsValidShrunkData(thePB: Handle_BOPDS_PaveBlock): Standard_Boolean;
  BuildBndBoxSolid(theIndex: Graphic3d_ZLayerId, theBox: Bnd_Box, theCheckInverted: Standard_Boolean): void;
  delete(): void;
}

  export declare class BOPDS_DS_1 extends BOPDS_DS {
    constructor();
  }

  export declare class BOPDS_DS_2 extends BOPDS_DS {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks): void;
  Assign(theOther: BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks): BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Shape, theItem: BOPDS_CoupleOfPaveBlocks): Standard_Integer;
  Contains(theKey1: TopoDS_Shape): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Shape, theItem: BOPDS_CoupleOfPaveBlocks): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Shape): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Shape;
  FindFromIndex(theIndex: Standard_Integer): BOPDS_CoupleOfPaveBlocks;
  ChangeFromIndex(theIndex: Standard_Integer): BOPDS_CoupleOfPaveBlocks;
  FindIndex(theKey1: TopoDS_Shape): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Shape): BOPDS_CoupleOfPaveBlocks;
  Seek(theKey1: TopoDS_Shape): BOPDS_CoupleOfPaveBlocks;
  ChangeSeek(theKey1: TopoDS_Shape): BOPDS_CoupleOfPaveBlocks;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_1 extends BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks {
    constructor();
  }

  export declare class BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_2 extends BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_3 extends BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks {
    constructor(theOther: BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks);
  }

export declare class BOPDS_Pair {
  SetIndices(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  Indices(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  IsEqual(theOther: BOPDS_Pair): Standard_Boolean;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class BOPDS_Pair_1 extends BOPDS_Pair {
    constructor();
  }

  export declare class BOPDS_Pair_2 extends BOPDS_Pair {
    constructor(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId);
  }

export declare class BOPDS_VectorOfVectorOfPair extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfVectorOfPair, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_VectorOfPair): BOPDS_VectorOfPair;
  Appended(): BOPDS_VectorOfPair;
  Value(theIndex: Standard_Integer): BOPDS_VectorOfPair;
  First(): BOPDS_VectorOfPair;
  ChangeFirst(): BOPDS_VectorOfPair;
  Last(): BOPDS_VectorOfPair;
  ChangeLast(): BOPDS_VectorOfPair;
  ChangeValue(theIndex: Standard_Integer): BOPDS_VectorOfPair;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_VectorOfPair): BOPDS_VectorOfPair;
  delete(): void;
}

  export declare class BOPDS_VectorOfVectorOfPair_1 extends BOPDS_VectorOfVectorOfPair {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfVectorOfPair_2 extends BOPDS_VectorOfVectorOfPair {
    constructor(theOther: BOPDS_VectorOfVectorOfPair);
  }

export declare class BOPDS_CoupleOfPaveBlocks {
  SetIndex(theIndex: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  SetIndexInterf(theIndex: Graphic3d_ZLayerId): void;
  IndexInterf(): Graphic3d_ZLayerId;
  SetPaveBlocks(thePB1: Handle_BOPDS_PaveBlock, thePB2: Handle_BOPDS_PaveBlock): void;
  PaveBlocks(thePB1: Handle_BOPDS_PaveBlock, thePB2: Handle_BOPDS_PaveBlock): void;
  SetPaveBlock1(thePB: Handle_BOPDS_PaveBlock): void;
  PaveBlock1(): Handle_BOPDS_PaveBlock;
  SetPaveBlock2(thePB: Handle_BOPDS_PaveBlock): void;
  PaveBlock2(): Handle_BOPDS_PaveBlock;
  SetTolerance(theTol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BOPDS_CoupleOfPaveBlocks_1 extends BOPDS_CoupleOfPaveBlocks {
    constructor();
  }

  export declare class BOPDS_CoupleOfPaveBlocks_2 extends BOPDS_CoupleOfPaveBlocks {
    constructor(thePB1: Handle_BOPDS_PaveBlock, thePB2: Handle_BOPDS_PaveBlock);
  }

export declare class BOPDS_VectorOfInterfVE extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfVE, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfVE): BOPDS_InterfVE;
  Appended(): BOPDS_InterfVE;
  Value(theIndex: Standard_Integer): BOPDS_InterfVE;
  First(): BOPDS_InterfVE;
  ChangeFirst(): BOPDS_InterfVE;
  Last(): BOPDS_InterfVE;
  ChangeLast(): BOPDS_InterfVE;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfVE;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfVE): BOPDS_InterfVE;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfVE_1 extends BOPDS_VectorOfInterfVE {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfVE_2 extends BOPDS_VectorOfInterfVE {
    constructor(theOther: BOPDS_VectorOfInterfVE);
  }

export declare class BOPDS_Curve {
  SetCurve(theC: IntTools_Curve): void;
  Curve(): IntTools_Curve;
  SetBox(theBox: Bnd_Box): void;
  Box(): Bnd_Box;
  ChangeBox(): Bnd_Box;
  SetPaveBlocks(theLPB: BOPDS_ListOfPaveBlock): void;
  PaveBlocks(): BOPDS_ListOfPaveBlock;
  ChangePaveBlocks(): BOPDS_ListOfPaveBlock;
  InitPaveBlock1(): void;
  ChangePaveBlock1(): Handle_BOPDS_PaveBlock;
  TechnoVertices(): TColStd_ListOfInteger;
  ChangeTechnoVertices(): TColStd_ListOfInteger;
  HasEdge(): Standard_Boolean;
  SetTolerance(theTol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  TangentialTolerance(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BOPDS_Curve_1 extends BOPDS_Curve {
    constructor();
  }

  export declare class BOPDS_Curve_2 extends BOPDS_Curve {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_VectorOfFaceInfo extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfFaceInfo, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_FaceInfo): BOPDS_FaceInfo;
  Appended(): BOPDS_FaceInfo;
  Value(theIndex: Standard_Integer): BOPDS_FaceInfo;
  First(): BOPDS_FaceInfo;
  ChangeFirst(): BOPDS_FaceInfo;
  Last(): BOPDS_FaceInfo;
  ChangeLast(): BOPDS_FaceInfo;
  ChangeValue(theIndex: Standard_Integer): BOPDS_FaceInfo;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_FaceInfo): BOPDS_FaceInfo;
  delete(): void;
}

  export declare class BOPDS_VectorOfFaceInfo_1 extends BOPDS_VectorOfFaceInfo {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfFaceInfo_2 extends BOPDS_VectorOfFaceInfo {
    constructor(theOther: BOPDS_VectorOfFaceInfo);
  }

export declare class BOPDS_VectorOfInterfEE extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfEE, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfEE): BOPDS_InterfEE;
  Appended(): BOPDS_InterfEE;
  Value(theIndex: Standard_Integer): BOPDS_InterfEE;
  First(): BOPDS_InterfEE;
  ChangeFirst(): BOPDS_InterfEE;
  Last(): BOPDS_InterfEE;
  ChangeLast(): BOPDS_InterfEE;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfEE;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfEE): BOPDS_InterfEE;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfEE_1 extends BOPDS_VectorOfInterfEE {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfEE_2 extends BOPDS_VectorOfInterfEE {
    constructor(theOther: BOPDS_VectorOfInterfEE);
  }

export declare class BOPDS_Point {
  constructor()
  SetPnt(thePnt: gp_Pnt): void;
  Pnt(): gp_Pnt;
  SetPnt2D1(thePnt: gp_Pnt2d): void;
  Pnt2D1(): gp_Pnt2d;
  SetPnt2D2(thePnt: gp_Pnt2d): void;
  Pnt2D2(): gp_Pnt2d;
  SetIndex(theIndex: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BOPDS_VectorOfCurve extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfCurve, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_Curve): BOPDS_Curve;
  Appended(): BOPDS_Curve;
  Value(theIndex: Standard_Integer): BOPDS_Curve;
  First(): BOPDS_Curve;
  ChangeFirst(): BOPDS_Curve;
  Last(): BOPDS_Curve;
  ChangeLast(): BOPDS_Curve;
  ChangeValue(theIndex: Standard_Integer): BOPDS_Curve;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_Curve): BOPDS_Curve;
  delete(): void;
}

  export declare class BOPDS_VectorOfCurve_1 extends BOPDS_VectorOfCurve {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfCurve_2 extends BOPDS_VectorOfCurve {
    constructor(theOther: BOPDS_VectorOfCurve);
  }

export declare class BOPDS_VectorOfPave {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: BOPDS_Pave): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfPave): BOPDS_VectorOfPave;
  Move(theOther: BOPDS_VectorOfPave): BOPDS_VectorOfPave;
  First(): BOPDS_Pave;
  ChangeFirst(): BOPDS_Pave;
  Last(): BOPDS_Pave;
  ChangeLast(): BOPDS_Pave;
  Value(theIndex: Standard_Integer): BOPDS_Pave;
  ChangeValue(theIndex: Standard_Integer): BOPDS_Pave;
  SetValue(theIndex: Standard_Integer, theItem: BOPDS_Pave): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class BOPDS_VectorOfPave_1 extends BOPDS_VectorOfPave {
    constructor();
  }

  export declare class BOPDS_VectorOfPave_2 extends BOPDS_VectorOfPave {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class BOPDS_VectorOfPave_3 extends BOPDS_VectorOfPave {
    constructor(theOther: BOPDS_VectorOfPave);
  }

  export declare class BOPDS_VectorOfPave_4 extends BOPDS_VectorOfPave {
    constructor(theOther: BOPDS_VectorOfPave);
  }

  export declare class BOPDS_VectorOfPave_5 extends BOPDS_VectorOfPave {
    constructor(theBegin: BOPDS_Pave, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class BOPDS_FaceInfo {
  Clear(): void;
  SetIndex(theI: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  PaveBlocksIn(): BOPDS_IndexedMapOfPaveBlock;
  ChangePaveBlocksIn(): BOPDS_IndexedMapOfPaveBlock;
  VerticesIn(): TColStd_MapOfInteger;
  ChangeVerticesIn(): TColStd_MapOfInteger;
  PaveBlocksOn(): BOPDS_IndexedMapOfPaveBlock;
  ChangePaveBlocksOn(): BOPDS_IndexedMapOfPaveBlock;
  VerticesOn(): TColStd_MapOfInteger;
  ChangeVerticesOn(): TColStd_MapOfInteger;
  PaveBlocksSc(): BOPDS_IndexedMapOfPaveBlock;
  ChangePaveBlocksSc(): BOPDS_IndexedMapOfPaveBlock;
  VerticesSc(): TColStd_MapOfInteger;
  ChangeVerticesSc(): TColStd_MapOfInteger;
  delete(): void;
}

  export declare class BOPDS_FaceInfo_1 extends BOPDS_FaceInfo {
    constructor();
  }

  export declare class BOPDS_FaceInfo_2 extends BOPDS_FaceInfo {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_MapOfPair extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPDS_MapOfPair): void;
  Assign(theOther: BOPDS_MapOfPair): BOPDS_MapOfPair;
  ReSize(N: Standard_Integer): void;
  Add(K: BOPDS_Pair): Standard_Boolean;
  Added(K: BOPDS_Pair): BOPDS_Pair;
  Contains_1(K: BOPDS_Pair): Standard_Boolean;
  Remove(K: BOPDS_Pair): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: BOPDS_MapOfPair): Standard_Boolean;
  Contains_2(theOther: BOPDS_MapOfPair): Standard_Boolean;
  Union(theLeft: BOPDS_MapOfPair, theRight: BOPDS_MapOfPair): void;
  Unite(theOther: BOPDS_MapOfPair): Standard_Boolean;
  HasIntersection(theMap: BOPDS_MapOfPair): Standard_Boolean;
  Intersection(theLeft: BOPDS_MapOfPair, theRight: BOPDS_MapOfPair): void;
  Intersect(theOther: BOPDS_MapOfPair): Standard_Boolean;
  Subtraction(theLeft: BOPDS_MapOfPair, theRight: BOPDS_MapOfPair): void;
  Subtract(theOther: BOPDS_MapOfPair): Standard_Boolean;
  Difference(theLeft: BOPDS_MapOfPair, theRight: BOPDS_MapOfPair): void;
  Differ(theOther: BOPDS_MapOfPair): Standard_Boolean;
  delete(): void;
}

  export declare class BOPDS_MapOfPair_1 extends BOPDS_MapOfPair {
    constructor();
  }

  export declare class BOPDS_MapOfPair_2 extends BOPDS_MapOfPair {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_MapOfPair_3 extends BOPDS_MapOfPair {
    constructor(theOther: BOPDS_MapOfPair);
  }

export declare class BOPDS_VectorOfInterfEZ extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfEZ, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfEZ): BOPDS_InterfEZ;
  Appended(): BOPDS_InterfEZ;
  Value(theIndex: Standard_Integer): BOPDS_InterfEZ;
  First(): BOPDS_InterfEZ;
  ChangeFirst(): BOPDS_InterfEZ;
  Last(): BOPDS_InterfEZ;
  ChangeLast(): BOPDS_InterfEZ;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfEZ;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfEZ): BOPDS_InterfEZ;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfEZ_1 extends BOPDS_VectorOfInterfEZ {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfEZ_2 extends BOPDS_VectorOfInterfEZ {
    constructor(theOther: BOPDS_VectorOfInterfEZ);
  }

export declare class BOPDS_ShapeInfo {
  SetShape(theS: TopoDS_Shape): void;
  Shape(): TopoDS_Shape;
  SetShapeType(theType: TopAbs_ShapeEnum): void;
  ShapeType(): TopAbs_ShapeEnum;
  SetBox(theBox: Bnd_Box): void;
  Box(): Bnd_Box;
  ChangeBox(): Bnd_Box;
  SubShapes(): TColStd_ListOfInteger;
  ChangeSubShapes(): TColStd_ListOfInteger;
  HasSubShape(theI: Graphic3d_ZLayerId): Standard_Boolean;
  HasReference(): Standard_Boolean;
  SetReference(theI: Graphic3d_ZLayerId): void;
  Reference(): Graphic3d_ZLayerId;
  HasBRep(): Standard_Boolean;
  IsInterfering(): Standard_Boolean;
  HasFlag_1(): Standard_Boolean;
  HasFlag_2(theFlag: Graphic3d_ZLayerId): Standard_Boolean;
  SetFlag(theI: Graphic3d_ZLayerId): void;
  Flag(): Graphic3d_ZLayerId;
  Dump(): void;
  delete(): void;
}

  export declare class BOPDS_ShapeInfo_1 extends BOPDS_ShapeInfo {
    constructor();
  }

  export declare class BOPDS_ShapeInfo_2 extends BOPDS_ShapeInfo {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_Pave {
  constructor()
  SetIndex(theIndex: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  SetParameter(theParameter: Quantity_AbsorbedDose): void;
  Parameter(): Quantity_AbsorbedDose;
  Contents(theIndex: Graphic3d_ZLayerId, theParameter: Quantity_AbsorbedDose): void;
  IsLess(theOther: BOPDS_Pave): Standard_Boolean;
  IsEqual(theOther: BOPDS_Pave): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

export declare class BOPDS_CommonBlock extends Standard_Transient {
  AddPaveBlock(aPB: Handle_BOPDS_PaveBlock): void;
  SetPaveBlocks(aLPB: BOPDS_ListOfPaveBlock): void;
  AddFace(aF: Graphic3d_ZLayerId): void;
  SetFaces(aLF: TColStd_ListOfInteger): void;
  AppendFaces(aLF: TColStd_ListOfInteger): void;
  PaveBlocks(): BOPDS_ListOfPaveBlock;
  Faces(): TColStd_ListOfInteger;
  PaveBlock1(): Handle_BOPDS_PaveBlock;
  PaveBlockOnEdge(theIndex: Graphic3d_ZLayerId): Handle_BOPDS_PaveBlock;
  IsPaveBlockOnFace(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  IsPaveBlockOnEdge(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  Contains_1(thePB: Handle_BOPDS_PaveBlock): Standard_Boolean;
  Contains_2(theF: Graphic3d_ZLayerId): Standard_Boolean;
  SetEdge(theEdge: Graphic3d_ZLayerId): void;
  Edge(): Graphic3d_ZLayerId;
  Dump(): void;
  SetRealPaveBlock(thePB: Handle_BOPDS_PaveBlock): void;
  SetTolerance(theTol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BOPDS_CommonBlock_1 extends BOPDS_CommonBlock {
    constructor();
  }

  export declare class BOPDS_CommonBlock_2 extends BOPDS_CommonBlock {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class Handle_BOPDS_CommonBlock {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BOPDS_CommonBlock): void;
  get(): BOPDS_CommonBlock;
  delete(): void;
}

  export declare class Handle_BOPDS_CommonBlock_1 extends Handle_BOPDS_CommonBlock {
    constructor();
  }

  export declare class Handle_BOPDS_CommonBlock_2 extends Handle_BOPDS_CommonBlock {
    constructor(thePtr: BOPDS_CommonBlock);
  }

  export declare class Handle_BOPDS_CommonBlock_3 extends Handle_BOPDS_CommonBlock {
    constructor(theHandle: Handle_BOPDS_CommonBlock);
  }

  export declare class Handle_BOPDS_CommonBlock_4 extends Handle_BOPDS_CommonBlock {
    constructor(theHandle: Handle_BOPDS_CommonBlock);
  }

export declare class BOPDS_InterfVV extends BOPDS_Interf {
  delete(): void;
}

  export declare class BOPDS_InterfVV_1 extends BOPDS_InterfVV {
    constructor();
  }

  export declare class BOPDS_InterfVV_2 extends BOPDS_InterfVV {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfFZ extends BOPDS_Interf {
  delete(): void;
}

  export declare class BOPDS_InterfFZ_1 extends BOPDS_InterfFZ {
    constructor();
  }

  export declare class BOPDS_InterfFZ_2 extends BOPDS_InterfFZ {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfZZ extends BOPDS_Interf {
  delete(): void;
}

  export declare class BOPDS_InterfZZ_1 extends BOPDS_InterfZZ {
    constructor();
  }

  export declare class BOPDS_InterfZZ_2 extends BOPDS_InterfZZ {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfFF extends BOPDS_Interf {
  constructor()
  Init(theNbCurves: Graphic3d_ZLayerId, theNbPoints: Graphic3d_ZLayerId): void;
  SetTangentFaces(theFlag: Standard_Boolean): void;
  TangentFaces(): Standard_Boolean;
  Curves(): BOPDS_VectorOfCurve;
  ChangeCurves(): BOPDS_VectorOfCurve;
  Points(): BOPDS_VectorOfPoint;
  ChangePoints(): BOPDS_VectorOfPoint;
  delete(): void;
}

export declare class BOPDS_Interf {
  SetIndices(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  Indices(theIndex1: Graphic3d_ZLayerId, theIndex2: Graphic3d_ZLayerId): void;
  SetIndex1(theIndex: Graphic3d_ZLayerId): void;
  SetIndex2(theIndex: Graphic3d_ZLayerId): void;
  Index1(): Graphic3d_ZLayerId;
  Index2(): Graphic3d_ZLayerId;
  OppositeIndex(theI: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Contains(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  SetIndexNew(theIndex: Graphic3d_ZLayerId): void;
  IndexNew(): Graphic3d_ZLayerId;
  HasIndexNew_1(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  HasIndexNew_2(): Standard_Boolean;
  delete(): void;
}

export declare class BOPDS_InterfVE extends BOPDS_Interf {
  SetParameter(theT: Quantity_AbsorbedDose): void;
  Parameter(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BOPDS_InterfVE_1 extends BOPDS_InterfVE {
    constructor();
  }

  export declare class BOPDS_InterfVE_2 extends BOPDS_InterfVE {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfVF extends BOPDS_Interf {
  SetUV(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose): void;
  UV(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class BOPDS_InterfVF_1 extends BOPDS_InterfVF {
    constructor();
  }

  export declare class BOPDS_InterfVF_2 extends BOPDS_InterfVF {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfEE extends BOPDS_Interf {
  SetCommonPart(theCP: IntTools_CommonPrt): void;
  CommonPart(): IntTools_CommonPrt;
  delete(): void;
}

  export declare class BOPDS_InterfEE_1 extends BOPDS_InterfEE {
    constructor();
  }

  export declare class BOPDS_InterfEE_2 extends BOPDS_InterfEE {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfEF extends BOPDS_Interf {
  SetCommonPart(theCP: IntTools_CommonPrt): void;
  CommonPart(): IntTools_CommonPrt;
  delete(): void;
}

  export declare class BOPDS_InterfEF_1 extends BOPDS_InterfEF {
    constructor();
  }

  export declare class BOPDS_InterfEF_2 extends BOPDS_InterfEF {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfEZ extends BOPDS_Interf {
  delete(): void;
}

  export declare class BOPDS_InterfEZ_1 extends BOPDS_InterfEZ {
    constructor();
  }

  export declare class BOPDS_InterfEZ_2 extends BOPDS_InterfEZ {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_InterfVZ extends BOPDS_Interf {
  delete(): void;
}

  export declare class BOPDS_InterfVZ_1 extends BOPDS_InterfVZ {
    constructor();
  }

  export declare class BOPDS_InterfVZ_2 extends BOPDS_InterfVZ {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class BOPDS_VectorOfIndexRange extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfIndexRange, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_IndexRange): BOPDS_IndexRange;
  Appended(): BOPDS_IndexRange;
  Value(theIndex: Standard_Integer): BOPDS_IndexRange;
  First(): BOPDS_IndexRange;
  ChangeFirst(): BOPDS_IndexRange;
  Last(): BOPDS_IndexRange;
  ChangeLast(): BOPDS_IndexRange;
  ChangeValue(theIndex: Standard_Integer): BOPDS_IndexRange;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_IndexRange): BOPDS_IndexRange;
  delete(): void;
}

  export declare class BOPDS_VectorOfIndexRange_1 extends BOPDS_VectorOfIndexRange {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfIndexRange_2 extends BOPDS_VectorOfIndexRange {
    constructor(theOther: BOPDS_VectorOfIndexRange);
  }

export declare class BOPDS_VectorOfInterfVV extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfInterfVV, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_InterfVV): BOPDS_InterfVV;
  Appended(): BOPDS_InterfVV;
  Value(theIndex: Standard_Integer): BOPDS_InterfVV;
  First(): BOPDS_InterfVV;
  ChangeFirst(): BOPDS_InterfVV;
  Last(): BOPDS_InterfVV;
  ChangeLast(): BOPDS_InterfVV;
  ChangeValue(theIndex: Standard_Integer): BOPDS_InterfVV;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_InterfVV): BOPDS_InterfVV;
  delete(): void;
}

  export declare class BOPDS_VectorOfInterfVV_1 extends BOPDS_VectorOfInterfVV {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfInterfVV_2 extends BOPDS_VectorOfInterfVV {
    constructor(theOther: BOPDS_VectorOfInterfVV);
  }

export declare class BOPDS_VectorOfShapeInfo extends NCollection_BaseVector {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Length(): Standard_Integer;
  Size(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Assign(theOther: BOPDS_VectorOfShapeInfo, theOwnAllocator: Standard_Boolean): void;
  Append(theValue: BOPDS_ShapeInfo): BOPDS_ShapeInfo;
  Appended(): BOPDS_ShapeInfo;
  Value(theIndex: Standard_Integer): BOPDS_ShapeInfo;
  First(): BOPDS_ShapeInfo;
  ChangeFirst(): BOPDS_ShapeInfo;
  Last(): BOPDS_ShapeInfo;
  ChangeLast(): BOPDS_ShapeInfo;
  ChangeValue(theIndex: Standard_Integer): BOPDS_ShapeInfo;
  SetValue(theIndex: Standard_Integer, theValue: BOPDS_ShapeInfo): BOPDS_ShapeInfo;
  delete(): void;
}

  export declare class BOPDS_VectorOfShapeInfo_1 extends BOPDS_VectorOfShapeInfo {
    constructor(theIncrement: Standard_Integer, theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_VectorOfShapeInfo_2 extends BOPDS_VectorOfShapeInfo {
    constructor(theOther: BOPDS_VectorOfShapeInfo);
  }

export declare class BOPDS_IndexRange {
  constructor()
  SetFirst(theI1: Graphic3d_ZLayerId): void;
  SetLast(theI2: Graphic3d_ZLayerId): void;
  First(): Graphic3d_ZLayerId;
  Last(): Graphic3d_ZLayerId;
  SetIndices(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId): void;
  Indices(theI1: Graphic3d_ZLayerId, theI2: Graphic3d_ZLayerId): void;
  Contains(theIndex: Graphic3d_ZLayerId): Standard_Boolean;
  Dump(): void;
  delete(): void;
}

export declare class BOPDS_DataMapOfIntegerListOfPaveBlock extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: NCollection_DataMap<Standard_Integer, BOPDS_ListOfPaveBlock, TColStd_MapIntegerHasher>): void;
  Assign(theOther: NCollection_DataMap<Standard_Integer, BOPDS_ListOfPaveBlock, TColStd_MapIntegerHasher>): any;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: Standard_Integer, theItem: BOPDS_ListOfPaveBlock): Standard_Boolean;
  Bound(theKey: Standard_Integer, theItem: BOPDS_ListOfPaveBlock): BOPDS_ListOfPaveBlock;
  IsBound(theKey: Standard_Integer): Standard_Boolean;
  UnBind(theKey: Standard_Integer): Standard_Boolean;
  Seek(theKey: Standard_Integer): BOPDS_ListOfPaveBlock;
  ChangeSeek(theKey: Standard_Integer): BOPDS_ListOfPaveBlock;
  ChangeFind(theKey: Standard_Integer): BOPDS_ListOfPaveBlock;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BOPDS_DataMapOfIntegerListOfPaveBlock_1 extends BOPDS_DataMapOfIntegerListOfPaveBlock {
    constructor();
  }

  export declare class BOPDS_DataMapOfIntegerListOfPaveBlock_2 extends BOPDS_DataMapOfIntegerListOfPaveBlock {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_DataMapOfIntegerListOfPaveBlock_3 extends BOPDS_DataMapOfIntegerListOfPaveBlock {
    constructor(theOther: NCollection_DataMap<Standard_Integer, BOPDS_ListOfPaveBlock, TColStd_MapIntegerHasher>);
  }

export declare class BOPDS_DataMapOfShapeCoupleOfPaveBlocks extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPDS_DataMapOfShapeCoupleOfPaveBlocks): void;
  Assign(theOther: BOPDS_DataMapOfShapeCoupleOfPaveBlocks): BOPDS_DataMapOfShapeCoupleOfPaveBlocks;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: BOPDS_CoupleOfPaveBlocks): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: BOPDS_CoupleOfPaveBlocks): BOPDS_CoupleOfPaveBlocks;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): BOPDS_CoupleOfPaveBlocks;
  ChangeSeek(theKey: TopoDS_Shape): BOPDS_CoupleOfPaveBlocks;
  ChangeFind(theKey: TopoDS_Shape): BOPDS_CoupleOfPaveBlocks;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BOPDS_DataMapOfShapeCoupleOfPaveBlocks_1 extends BOPDS_DataMapOfShapeCoupleOfPaveBlocks {
    constructor();
  }

  export declare class BOPDS_DataMapOfShapeCoupleOfPaveBlocks_2 extends BOPDS_DataMapOfShapeCoupleOfPaveBlocks {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPDS_DataMapOfShapeCoupleOfPaveBlocks_3 extends BOPDS_DataMapOfShapeCoupleOfPaveBlocks {
    constructor(theOther: BOPDS_DataMapOfShapeCoupleOfPaveBlocks);
  }

export declare class Hermit {
  constructor();
  static Solution_1(BS: Handle_Geom_BSplineCurve, TolPoles: Quantity_AbsorbedDose, TolKnots: Quantity_AbsorbedDose): Handle_Geom2d_BSplineCurve;
  static Solution_2(BS: Handle_Geom2d_BSplineCurve, TolPoles: Quantity_AbsorbedDose, TolKnots: Quantity_AbsorbedDose): Handle_Geom2d_BSplineCurve;
  static Solutionbis(BS: Handle_Geom_BSplineCurve, Knotmin: Quantity_AbsorbedDose, Knotmax: Quantity_AbsorbedDose, TolPoles: Quantity_AbsorbedDose, TolKnots: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class ShapeAlgo_AlgoContainer extends Standard_Transient {
  constructor()
  SetToolContainer(TC: Handle_ShapeAlgo_ToolContainer): void;
  ToolContainer(): Handle_ShapeAlgo_ToolContainer;
  ConnectNextWire(saw: Handle_ShapeAnalysis_Wire, nextsewd: Handle_ShapeExtend_WireData, maxtol: Quantity_AbsorbedDose, distmin: Quantity_AbsorbedDose, revsewd: Standard_Boolean, revnextsewd: Standard_Boolean): Standard_Boolean;
  ApproxBSplineCurve_1(bspline: Handle_Geom_BSplineCurve, seq: TColGeom_SequenceOfCurve): void;
  ApproxBSplineCurve_2(bspline: Handle_Geom2d_BSplineCurve, seq: TColGeom2d_SequenceOfCurve): void;
  C0BSplineToSequenceOfC1BSplineCurve_1(BS: Handle_Geom_BSplineCurve, seqBS: Handle_TColGeom_HSequenceOfBoundedCurve): Standard_Boolean;
  C0BSplineToSequenceOfC1BSplineCurve_2(BS: Handle_Geom2d_BSplineCurve, seqBS: Handle_TColGeom2d_HSequenceOfBoundedCurve): Standard_Boolean;
  C0ShapeToC1Shape(shape: TopoDS_Shape, tol: Quantity_AbsorbedDose): TopoDS_Shape;
  ConvertSurfaceToBSpline(surf: Handle_Geom_Surface, UF: Quantity_AbsorbedDose, UL: Quantity_AbsorbedDose, VF: Quantity_AbsorbedDose, VL: Quantity_AbsorbedDose): Handle_Geom_BSplineSurface;
  HomoWires(wireIn1: TopoDS_Wire, wireIn2: TopoDS_Wire, wireOut1: TopoDS_Wire, wireOut2: TopoDS_Wire, byParam: Standard_Boolean): Standard_Boolean;
  OuterWire(face: TopoDS_Face): TopoDS_Wire;
  ConvertToPeriodic(surf: Handle_Geom_Surface): Handle_Geom_Surface;
  GetFaceUVBounds(F: TopoDS_Face, Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  ConvertCurveToBSpline(C3D: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId): Handle_Geom_BSplineCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeAlgo_AlgoContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAlgo_AlgoContainer): void;
  get(): ShapeAlgo_AlgoContainer;
  delete(): void;
}

  export declare class Handle_ShapeAlgo_AlgoContainer_1 extends Handle_ShapeAlgo_AlgoContainer {
    constructor();
  }

  export declare class Handle_ShapeAlgo_AlgoContainer_2 extends Handle_ShapeAlgo_AlgoContainer {
    constructor(thePtr: ShapeAlgo_AlgoContainer);
  }

  export declare class Handle_ShapeAlgo_AlgoContainer_3 extends Handle_ShapeAlgo_AlgoContainer {
    constructor(theHandle: Handle_ShapeAlgo_AlgoContainer);
  }

  export declare class Handle_ShapeAlgo_AlgoContainer_4 extends Handle_ShapeAlgo_AlgoContainer {
    constructor(theHandle: Handle_ShapeAlgo_AlgoContainer);
  }

export declare class ShapeAlgo {
  constructor();
  static Init(): void;
  static SetAlgoContainer(aContainer: Handle_ShapeAlgo_AlgoContainer): void;
  static AlgoContainer(): Handle_ShapeAlgo_AlgoContainer;
  delete(): void;
}

export declare class Handle_ShapeAlgo_ToolContainer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeAlgo_ToolContainer): void;
  get(): ShapeAlgo_ToolContainer;
  delete(): void;
}

  export declare class Handle_ShapeAlgo_ToolContainer_1 extends Handle_ShapeAlgo_ToolContainer {
    constructor();
  }

  export declare class Handle_ShapeAlgo_ToolContainer_2 extends Handle_ShapeAlgo_ToolContainer {
    constructor(thePtr: ShapeAlgo_ToolContainer);
  }

  export declare class Handle_ShapeAlgo_ToolContainer_3 extends Handle_ShapeAlgo_ToolContainer {
    constructor(theHandle: Handle_ShapeAlgo_ToolContainer);
  }

  export declare class Handle_ShapeAlgo_ToolContainer_4 extends Handle_ShapeAlgo_ToolContainer {
    constructor(theHandle: Handle_ShapeAlgo_ToolContainer);
  }

export declare class ShapeAlgo_ToolContainer extends Standard_Transient {
  constructor()
  FixShape(): Handle_ShapeFix_Shape;
  EdgeProjAux(): Handle_ShapeFix_EdgeProjAux;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TColGeom2d_HSequenceOfBoundedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom2d_HSequenceOfBoundedCurve): void;
  get(): TColGeom2d_HSequenceOfBoundedCurve;
  delete(): void;
}

  export declare class Handle_TColGeom2d_HSequenceOfBoundedCurve_1 extends Handle_TColGeom2d_HSequenceOfBoundedCurve {
    constructor();
  }

  export declare class Handle_TColGeom2d_HSequenceOfBoundedCurve_2 extends Handle_TColGeom2d_HSequenceOfBoundedCurve {
    constructor(thePtr: TColGeom2d_HSequenceOfBoundedCurve);
  }

  export declare class Handle_TColGeom2d_HSequenceOfBoundedCurve_3 extends Handle_TColGeom2d_HSequenceOfBoundedCurve {
    constructor(theHandle: Handle_TColGeom2d_HSequenceOfBoundedCurve);
  }

  export declare class Handle_TColGeom2d_HSequenceOfBoundedCurve_4 extends Handle_TColGeom2d_HSequenceOfBoundedCurve {
    constructor(theHandle: Handle_TColGeom2d_HSequenceOfBoundedCurve);
  }

export declare class Handle_TColGeom2d_HArray1OfCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom2d_HArray1OfCurve): void;
  get(): TColGeom2d_HArray1OfCurve;
  delete(): void;
}

  export declare class Handle_TColGeom2d_HArray1OfCurve_1 extends Handle_TColGeom2d_HArray1OfCurve {
    constructor();
  }

  export declare class Handle_TColGeom2d_HArray1OfCurve_2 extends Handle_TColGeom2d_HArray1OfCurve {
    constructor(thePtr: TColGeom2d_HArray1OfCurve);
  }

  export declare class Handle_TColGeom2d_HArray1OfCurve_3 extends Handle_TColGeom2d_HArray1OfCurve {
    constructor(theHandle: Handle_TColGeom2d_HArray1OfCurve);
  }

  export declare class Handle_TColGeom2d_HArray1OfCurve_4 extends Handle_TColGeom2d_HArray1OfCurve {
    constructor(theHandle: Handle_TColGeom2d_HArray1OfCurve);
  }

export declare class Handle_TColGeom2d_HArray1OfBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom2d_HArray1OfBSplineCurve): void;
  get(): TColGeom2d_HArray1OfBSplineCurve;
  delete(): void;
}

  export declare class Handle_TColGeom2d_HArray1OfBSplineCurve_1 extends Handle_TColGeom2d_HArray1OfBSplineCurve {
    constructor();
  }

  export declare class Handle_TColGeom2d_HArray1OfBSplineCurve_2 extends Handle_TColGeom2d_HArray1OfBSplineCurve {
    constructor(thePtr: TColGeom2d_HArray1OfBSplineCurve);
  }

  export declare class Handle_TColGeom2d_HArray1OfBSplineCurve_3 extends Handle_TColGeom2d_HArray1OfBSplineCurve {
    constructor(theHandle: Handle_TColGeom2d_HArray1OfBSplineCurve);
  }

  export declare class Handle_TColGeom2d_HArray1OfBSplineCurve_4 extends Handle_TColGeom2d_HArray1OfBSplineCurve {
    constructor(theHandle: Handle_TColGeom2d_HArray1OfBSplineCurve);
  }

export declare class Handle_TColGeom2d_HArray1OfBezierCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom2d_HArray1OfBezierCurve): void;
  get(): TColGeom2d_HArray1OfBezierCurve;
  delete(): void;
}

  export declare class Handle_TColGeom2d_HArray1OfBezierCurve_1 extends Handle_TColGeom2d_HArray1OfBezierCurve {
    constructor();
  }

  export declare class Handle_TColGeom2d_HArray1OfBezierCurve_2 extends Handle_TColGeom2d_HArray1OfBezierCurve {
    constructor(thePtr: TColGeom2d_HArray1OfBezierCurve);
  }

  export declare class Handle_TColGeom2d_HArray1OfBezierCurve_3 extends Handle_TColGeom2d_HArray1OfBezierCurve {
    constructor(theHandle: Handle_TColGeom2d_HArray1OfBezierCurve);
  }

  export declare class Handle_TColGeom2d_HArray1OfBezierCurve_4 extends Handle_TColGeom2d_HArray1OfBezierCurve {
    constructor(theHandle: Handle_TColGeom2d_HArray1OfBezierCurve);
  }

export declare class Handle_TColGeom2d_HSequenceOfCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TColGeom2d_HSequenceOfCurve): void;
  get(): TColGeom2d_HSequenceOfCurve;
  delete(): void;
}

  export declare class Handle_TColGeom2d_HSequenceOfCurve_1 extends Handle_TColGeom2d_HSequenceOfCurve {
    constructor();
  }

  export declare class Handle_TColGeom2d_HSequenceOfCurve_2 extends Handle_TColGeom2d_HSequenceOfCurve {
    constructor(thePtr: TColGeom2d_HSequenceOfCurve);
  }

  export declare class Handle_TColGeom2d_HSequenceOfCurve_3 extends Handle_TColGeom2d_HSequenceOfCurve {
    constructor(theHandle: Handle_TColGeom2d_HSequenceOfCurve);
  }

  export declare class Handle_TColGeom2d_HSequenceOfCurve_4 extends Handle_TColGeom2d_HSequenceOfCurve {
    constructor(theHandle: Handle_TColGeom2d_HSequenceOfCurve);
  }

export declare class GeomPlate_Array1OfSequenceOfReal {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TColStd_SequenceOfReal): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: GeomPlate_Array1OfSequenceOfReal): GeomPlate_Array1OfSequenceOfReal;
  Move(theOther: GeomPlate_Array1OfSequenceOfReal): GeomPlate_Array1OfSequenceOfReal;
  First(): TColStd_SequenceOfReal;
  ChangeFirst(): TColStd_SequenceOfReal;
  Last(): TColStd_SequenceOfReal;
  ChangeLast(): TColStd_SequenceOfReal;
  Value(theIndex: Standard_Integer): TColStd_SequenceOfReal;
  ChangeValue(theIndex: Standard_Integer): TColStd_SequenceOfReal;
  SetValue(theIndex: Standard_Integer, theItem: TColStd_SequenceOfReal): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class GeomPlate_Array1OfSequenceOfReal_1 extends GeomPlate_Array1OfSequenceOfReal {
    constructor();
  }

  export declare class GeomPlate_Array1OfSequenceOfReal_2 extends GeomPlate_Array1OfSequenceOfReal {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class GeomPlate_Array1OfSequenceOfReal_3 extends GeomPlate_Array1OfSequenceOfReal {
    constructor(theOther: GeomPlate_Array1OfSequenceOfReal);
  }

  export declare class GeomPlate_Array1OfSequenceOfReal_4 extends GeomPlate_Array1OfSequenceOfReal {
    constructor(theOther: GeomPlate_Array1OfSequenceOfReal);
  }

  export declare class GeomPlate_Array1OfSequenceOfReal_5 extends GeomPlate_Array1OfSequenceOfReal {
    constructor(theBegin: TColStd_SequenceOfReal, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class GeomPlate_SequenceOfAij extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: GeomPlate_SequenceOfAij): GeomPlate_SequenceOfAij;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: GeomPlate_Aij): void;
  Append_2(theSeq: GeomPlate_SequenceOfAij): void;
  Prepend_1(theItem: GeomPlate_Aij): void;
  Prepend_2(theSeq: GeomPlate_SequenceOfAij): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: GeomPlate_Aij): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: GeomPlate_SequenceOfAij): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: GeomPlate_SequenceOfAij): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: GeomPlate_Aij): void;
  Split(theIndex: Standard_Integer, theSeq: GeomPlate_SequenceOfAij): void;
  First(): GeomPlate_Aij;
  ChangeFirst(): GeomPlate_Aij;
  Last(): GeomPlate_Aij;
  ChangeLast(): GeomPlate_Aij;
  Value(theIndex: Standard_Integer): GeomPlate_Aij;
  ChangeValue(theIndex: Standard_Integer): GeomPlate_Aij;
  SetValue(theIndex: Standard_Integer, theItem: GeomPlate_Aij): void;
  delete(): void;
}

  export declare class GeomPlate_SequenceOfAij_1 extends GeomPlate_SequenceOfAij {
    constructor();
  }

  export declare class GeomPlate_SequenceOfAij_2 extends GeomPlate_SequenceOfAij {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class GeomPlate_SequenceOfAij_3 extends GeomPlate_SequenceOfAij {
    constructor(theOther: GeomPlate_SequenceOfAij);
  }

export declare class GeomPlate_PlateG1Criterion extends AdvApp2Var_Criterion {
  constructor(Data: TColgp_SequenceOfXY, G1Data: TColgp_SequenceOfXYZ, Maximum: Quantity_AbsorbedDose, Type: AdvApp2Var_CriterionType, Repart: AdvApp2Var_CriterionRepartition)
  Value(P: AdvApp2Var_Patch, C: AdvApp2Var_Context): void;
  IsSatisfied(P: AdvApp2Var_Patch): Standard_Boolean;
  delete(): void;
}

export declare class Handle_GeomPlate_PointConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_PointConstraint): void;
  get(): GeomPlate_PointConstraint;
  delete(): void;
}

  export declare class Handle_GeomPlate_PointConstraint_1 extends Handle_GeomPlate_PointConstraint {
    constructor();
  }

  export declare class Handle_GeomPlate_PointConstraint_2 extends Handle_GeomPlate_PointConstraint {
    constructor(thePtr: GeomPlate_PointConstraint);
  }

  export declare class Handle_GeomPlate_PointConstraint_3 extends Handle_GeomPlate_PointConstraint {
    constructor(theHandle: Handle_GeomPlate_PointConstraint);
  }

  export declare class Handle_GeomPlate_PointConstraint_4 extends Handle_GeomPlate_PointConstraint {
    constructor(theHandle: Handle_GeomPlate_PointConstraint);
  }

export declare class GeomPlate_PointConstraint extends Standard_Transient {
  SetOrder(Order: Graphic3d_ZLayerId): void;
  Order(): Graphic3d_ZLayerId;
  SetG0Criterion(TolDist: Quantity_AbsorbedDose): void;
  SetG1Criterion(TolAng: Quantity_AbsorbedDose): void;
  SetG2Criterion(TolCurv: Quantity_AbsorbedDose): void;
  G0Criterion(): Quantity_AbsorbedDose;
  G1Criterion(): Quantity_AbsorbedDose;
  G2Criterion(): Quantity_AbsorbedDose;
  D0(P: gp_Pnt): void;
  D1(P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D2(P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec, V4: gp_Vec, V5: gp_Vec): void;
  HasPnt2dOnSurf(): Standard_Boolean;
  SetPnt2dOnSurf(Pnt: gp_Pnt2d): void;
  Pnt2dOnSurf(): gp_Pnt2d;
  LPropSurf(): GeomLProp_SLProps;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomPlate_PointConstraint_1 extends GeomPlate_PointConstraint {
    constructor(Pt: gp_Pnt, Order: Graphic3d_ZLayerId, TolDist: Quantity_AbsorbedDose);
  }

  export declare class GeomPlate_PointConstraint_2 extends GeomPlate_PointConstraint {
    constructor(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Surf: Handle_Geom_Surface, Order: Graphic3d_ZLayerId, TolDist: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose);
  }

export declare class GeomPlate_PlateG0Criterion extends AdvApp2Var_Criterion {
  constructor(Data: TColgp_SequenceOfXY, G0Data: TColgp_SequenceOfXYZ, Maximum: Quantity_AbsorbedDose, Type: AdvApp2Var_CriterionType, Repart: AdvApp2Var_CriterionRepartition)
  Value(P: AdvApp2Var_Patch, C: AdvApp2Var_Context): void;
  IsSatisfied(P: AdvApp2Var_Patch): Standard_Boolean;
  delete(): void;
}

export declare class GeomPlate_BuildPlateSurface {
  Init(): void;
  LoadInitSurface(Surf: Handle_Geom_Surface): void;
  Add_1(Cont: Handle_GeomPlate_CurveConstraint): void;
  SetNbBounds(NbBounds: Graphic3d_ZLayerId): void;
  Add_2(Cont: Handle_GeomPlate_PointConstraint): void;
  Perform(theProgress: Message_ProgressRange): void;
  CurveConstraint(order: Graphic3d_ZLayerId): Handle_GeomPlate_CurveConstraint;
  PointConstraint(order: Graphic3d_ZLayerId): Handle_GeomPlate_PointConstraint;
  Disc2dContour(nbp: Graphic3d_ZLayerId, Seq2d: TColgp_SequenceOfXY): void;
  Disc3dContour(nbp: Graphic3d_ZLayerId, iordre: Graphic3d_ZLayerId, Seq3d: TColgp_SequenceOfXYZ): void;
  IsDone(): Standard_Boolean;
  Surface(): Handle_GeomPlate_Surface;
  SurfInit(): Handle_Geom_Surface;
  Sense(): Handle_TColStd_HArray1OfInteger;
  Curves2d(): Handle_TColGeom2d_HArray1OfCurve;
  Order(): Handle_TColStd_HArray1OfInteger;
  G0Error_1(): Quantity_AbsorbedDose;
  G1Error_1(): Quantity_AbsorbedDose;
  G2Error_1(): Quantity_AbsorbedDose;
  G0Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  G1Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  G2Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomPlate_BuildPlateSurface_1 extends GeomPlate_BuildPlateSurface {
    constructor(NPoints: Handle_TColStd_HArray1OfInteger, TabCurve: Handle_GeomPlate_HArray1OfHCurve, Tang: Handle_TColStd_HArray1OfInteger, Degree: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose, Anisotropie: Standard_Boolean);
  }

  export declare class GeomPlate_BuildPlateSurface_2 extends GeomPlate_BuildPlateSurface {
    constructor(Surf: Handle_Geom_Surface, Degree: Graphic3d_ZLayerId, NbPtsOnCur: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose, Anisotropie: Standard_Boolean);
  }

  export declare class GeomPlate_BuildPlateSurface_3 extends GeomPlate_BuildPlateSurface {
    constructor(Degree: Graphic3d_ZLayerId, NbPtsOnCur: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose, Anisotropie: Standard_Boolean);
  }

export declare class Handle_GeomPlate_HSequenceOfCurveConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_HSequenceOfCurveConstraint): void;
  get(): GeomPlate_HSequenceOfCurveConstraint;
  delete(): void;
}

  export declare class Handle_GeomPlate_HSequenceOfCurveConstraint_1 extends Handle_GeomPlate_HSequenceOfCurveConstraint {
    constructor();
  }

  export declare class Handle_GeomPlate_HSequenceOfCurveConstraint_2 extends Handle_GeomPlate_HSequenceOfCurveConstraint {
    constructor(thePtr: GeomPlate_HSequenceOfCurveConstraint);
  }

  export declare class Handle_GeomPlate_HSequenceOfCurveConstraint_3 extends Handle_GeomPlate_HSequenceOfCurveConstraint {
    constructor(theHandle: Handle_GeomPlate_HSequenceOfCurveConstraint);
  }

  export declare class Handle_GeomPlate_HSequenceOfCurveConstraint_4 extends Handle_GeomPlate_HSequenceOfCurveConstraint {
    constructor(theHandle: Handle_GeomPlate_HSequenceOfCurveConstraint);
  }

export declare class Handle_GeomPlate_HSequenceOfPointConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_HSequenceOfPointConstraint): void;
  get(): GeomPlate_HSequenceOfPointConstraint;
  delete(): void;
}

  export declare class Handle_GeomPlate_HSequenceOfPointConstraint_1 extends Handle_GeomPlate_HSequenceOfPointConstraint {
    constructor();
  }

  export declare class Handle_GeomPlate_HSequenceOfPointConstraint_2 extends Handle_GeomPlate_HSequenceOfPointConstraint {
    constructor(thePtr: GeomPlate_HSequenceOfPointConstraint);
  }

  export declare class Handle_GeomPlate_HSequenceOfPointConstraint_3 extends Handle_GeomPlate_HSequenceOfPointConstraint {
    constructor(theHandle: Handle_GeomPlate_HSequenceOfPointConstraint);
  }

  export declare class Handle_GeomPlate_HSequenceOfPointConstraint_4 extends Handle_GeomPlate_HSequenceOfPointConstraint {
    constructor(theHandle: Handle_GeomPlate_HSequenceOfPointConstraint);
  }

export declare class GeomPlate_BuildAveragePlane {
  Plane(): Handle_Geom_Plane;
  Line(): Handle_Geom_Line;
  IsPlane(): Standard_Boolean;
  IsLine(): Standard_Boolean;
  MinMaxBox(Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  static HalfSpace(NewNormals: TColgp_SequenceOfVec, Normals: TColgp_SequenceOfVec, Bset: GeomPlate_SequenceOfAij, LinTol: Quantity_AbsorbedDose, AngTol: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class GeomPlate_BuildAveragePlane_1 extends GeomPlate_BuildAveragePlane {
    constructor(Pts: Handle_TColgp_HArray1OfPnt, NbBoundPoints: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose, POption: Graphic3d_ZLayerId, NOption: Graphic3d_ZLayerId);
  }

  export declare class GeomPlate_BuildAveragePlane_2 extends GeomPlate_BuildAveragePlane {
    constructor(Normals: TColgp_SequenceOfVec, Pts: Handle_TColgp_HArray1OfPnt);
  }

export declare class GeomPlate_Aij {
  delete(): void;
}

  export declare class GeomPlate_Aij_1 extends GeomPlate_Aij {
    constructor();
  }

  export declare class GeomPlate_Aij_2 extends GeomPlate_Aij {
    constructor(anInd1: Graphic3d_ZLayerId, anInd2: Graphic3d_ZLayerId, aVec: gp_Vec);
  }

export declare class Handle_GeomPlate_HArray1OfHCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_HArray1OfHCurve): void;
  get(): GeomPlate_HArray1OfHCurve;
  delete(): void;
}

  export declare class Handle_GeomPlate_HArray1OfHCurve_1 extends Handle_GeomPlate_HArray1OfHCurve {
    constructor();
  }

  export declare class Handle_GeomPlate_HArray1OfHCurve_2 extends Handle_GeomPlate_HArray1OfHCurve {
    constructor(thePtr: GeomPlate_HArray1OfHCurve);
  }

  export declare class Handle_GeomPlate_HArray1OfHCurve_3 extends Handle_GeomPlate_HArray1OfHCurve {
    constructor(theHandle: Handle_GeomPlate_HArray1OfHCurve);
  }

  export declare class Handle_GeomPlate_HArray1OfHCurve_4 extends Handle_GeomPlate_HArray1OfHCurve {
    constructor(theHandle: Handle_GeomPlate_HArray1OfHCurve);
  }

export declare class Handle_GeomPlate_CurveConstraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_CurveConstraint): void;
  get(): GeomPlate_CurveConstraint;
  delete(): void;
}

  export declare class Handle_GeomPlate_CurveConstraint_1 extends Handle_GeomPlate_CurveConstraint {
    constructor();
  }

  export declare class Handle_GeomPlate_CurveConstraint_2 extends Handle_GeomPlate_CurveConstraint {
    constructor(thePtr: GeomPlate_CurveConstraint);
  }

  export declare class Handle_GeomPlate_CurveConstraint_3 extends Handle_GeomPlate_CurveConstraint {
    constructor(theHandle: Handle_GeomPlate_CurveConstraint);
  }

  export declare class Handle_GeomPlate_CurveConstraint_4 extends Handle_GeomPlate_CurveConstraint {
    constructor(theHandle: Handle_GeomPlate_CurveConstraint);
  }

export declare class GeomPlate_CurveConstraint extends Standard_Transient {
  SetOrder(Order: Graphic3d_ZLayerId): void;
  Order(): Graphic3d_ZLayerId;
  NbPoints(): Graphic3d_ZLayerId;
  SetNbPoints(NewNb: Graphic3d_ZLayerId): void;
  SetG0Criterion(G0Crit: Handle_Law_Function): void;
  SetG1Criterion(G1Crit: Handle_Law_Function): void;
  SetG2Criterion(G2Crit: Handle_Law_Function): void;
  G0Criterion(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  G1Criterion(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  G2Criterion(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Length(): Quantity_AbsorbedDose;
  LPropSurf(U: Quantity_AbsorbedDose): GeomLProp_SLProps;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec, V4: gp_Vec, V5: gp_Vec): void;
  Curve3d(): Handle_Adaptor3d_HCurve;
  SetCurve2dOnSurf(Curve2d: Handle_Geom2d_Curve): void;
  Curve2dOnSurf(): Handle_Geom2d_Curve;
  SetProjectedCurve(Curve2d: Handle_Adaptor2d_HCurve2d, TolU: Quantity_AbsorbedDose, TolV: Quantity_AbsorbedDose): void;
  ProjectedCurve(): Handle_Adaptor2d_HCurve2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class GeomPlate_CurveConstraint_1 extends GeomPlate_CurveConstraint {
    constructor();
  }

  export declare class GeomPlate_CurveConstraint_2 extends GeomPlate_CurveConstraint {
    constructor(Boundary: Handle_Adaptor3d_HCurve, Order: Graphic3d_ZLayerId, NPt: Graphic3d_ZLayerId, TolDist: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose);
  }

export declare class GeomPlate_Surface extends Geom_Surface {
  constructor(Surfinit: Handle_Geom_Surface, Surfinter: Plate_Plate)
  UReverse(): void;
  UReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VReverse(): void;
  VReversedParameter(V: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformParameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, T: gp_Trsf): void;
  ParametricTransformation(T: gp_Trsf): gp_GTrsf2d;
  Bounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  UIso(U: Quantity_AbsorbedDose): Handle_Geom_Curve;
  VIso(V: Quantity_AbsorbedDose): Handle_Geom_Curve;
  Continuity(): GeomAbs_Shape;
  IsCNu(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsCNv(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Copy(): Handle_Geom_Geometry;
  Transform(T: gp_Trsf): void;
  CallSurfinit(): Handle_Geom_Surface;
  SetBounds(Umin: Quantity_AbsorbedDose, Umax: Quantity_AbsorbedDose, Vmin: Quantity_AbsorbedDose, Vmax: Quantity_AbsorbedDose): void;
  RealBounds(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Constraints(Seq: TColgp_SequenceOfXY): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_GeomPlate_Surface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_Surface): void;
  get(): GeomPlate_Surface;
  delete(): void;
}

  export declare class Handle_GeomPlate_Surface_1 extends Handle_GeomPlate_Surface {
    constructor();
  }

  export declare class Handle_GeomPlate_Surface_2 extends Handle_GeomPlate_Surface {
    constructor(thePtr: GeomPlate_Surface);
  }

  export declare class Handle_GeomPlate_Surface_3 extends Handle_GeomPlate_Surface {
    constructor(theHandle: Handle_GeomPlate_Surface);
  }

  export declare class Handle_GeomPlate_Surface_4 extends Handle_GeomPlate_Surface {
    constructor(theHandle: Handle_GeomPlate_Surface);
  }

export declare class GeomPlate_MakeApprox {
  Surface(): Handle_Geom_BSplineSurface;
  ApproxError(): Quantity_AbsorbedDose;
  CriterionError(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class GeomPlate_MakeApprox_1 extends GeomPlate_MakeApprox {
    constructor(SurfPlate: Handle_GeomPlate_Surface, PlateCrit: AdvApp2Var_Criterion, Tol3d: Quantity_AbsorbedDose, Nbmax: Graphic3d_ZLayerId, dgmax: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, EnlargeCoeff: Quantity_AbsorbedDose);
  }

  export declare class GeomPlate_MakeApprox_2 extends GeomPlate_MakeApprox {
    constructor(SurfPlate: Handle_GeomPlate_Surface, Tol3d: Quantity_AbsorbedDose, Nbmax: Graphic3d_ZLayerId, dgmax: Graphic3d_ZLayerId, dmax: Quantity_AbsorbedDose, CritOrder: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, EnlargeCoeff: Quantity_AbsorbedDose);
  }

export declare class Handle_GeomPlate_HArray1OfSequenceOfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: GeomPlate_HArray1OfSequenceOfReal): void;
  get(): GeomPlate_HArray1OfSequenceOfReal;
  delete(): void;
}

  export declare class Handle_GeomPlate_HArray1OfSequenceOfReal_1 extends Handle_GeomPlate_HArray1OfSequenceOfReal {
    constructor();
  }

  export declare class Handle_GeomPlate_HArray1OfSequenceOfReal_2 extends Handle_GeomPlate_HArray1OfSequenceOfReal {
    constructor(thePtr: GeomPlate_HArray1OfSequenceOfReal);
  }

  export declare class Handle_GeomPlate_HArray1OfSequenceOfReal_3 extends Handle_GeomPlate_HArray1OfSequenceOfReal {
    constructor(theHandle: Handle_GeomPlate_HArray1OfSequenceOfReal);
  }

  export declare class Handle_GeomPlate_HArray1OfSequenceOfReal_4 extends Handle_GeomPlate_HArray1OfSequenceOfReal {
    constructor(theHandle: Handle_GeomPlate_HArray1OfSequenceOfReal);
  }

export declare class Handle_ShapeFix_SplitCommonVertex {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_SplitCommonVertex): void;
  get(): ShapeFix_SplitCommonVertex;
  delete(): void;
}

  export declare class Handle_ShapeFix_SplitCommonVertex_1 extends Handle_ShapeFix_SplitCommonVertex {
    constructor();
  }

  export declare class Handle_ShapeFix_SplitCommonVertex_2 extends Handle_ShapeFix_SplitCommonVertex {
    constructor(thePtr: ShapeFix_SplitCommonVertex);
  }

  export declare class Handle_ShapeFix_SplitCommonVertex_3 extends Handle_ShapeFix_SplitCommonVertex {
    constructor(theHandle: Handle_ShapeFix_SplitCommonVertex);
  }

  export declare class Handle_ShapeFix_SplitCommonVertex_4 extends Handle_ShapeFix_SplitCommonVertex {
    constructor(theHandle: Handle_ShapeFix_SplitCommonVertex);
  }

export declare class ShapeFix_SplitCommonVertex extends ShapeFix_Root {
  constructor()
  Init(S: TopoDS_Shape): void;
  Perform(): void;
  Shape(): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeFix_Face extends ShapeFix_Root {
  ClearModes(): void;
  Init_1(face: TopoDS_Face): void;
  Init_2(surf: Handle_Geom_Surface, preci: Quantity_AbsorbedDose, fwd: Standard_Boolean): void;
  Init_3(surf: Handle_ShapeAnalysis_Surface, preci: Quantity_AbsorbedDose, fwd: Standard_Boolean): void;
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  FixWireMode(): Graphic3d_ZLayerId;
  FixOrientationMode(): Graphic3d_ZLayerId;
  FixAddNaturalBoundMode(): Graphic3d_ZLayerId;
  FixMissingSeamMode(): Graphic3d_ZLayerId;
  FixSmallAreaWireMode(): Graphic3d_ZLayerId;
  RemoveSmallAreaFaceMode(): Graphic3d_ZLayerId;
  FixIntersectingWiresMode(): Graphic3d_ZLayerId;
  FixLoopWiresMode(): Graphic3d_ZLayerId;
  FixSplitFaceMode(): Graphic3d_ZLayerId;
  AutoCorrectPrecisionMode(): Graphic3d_ZLayerId;
  FixPeriodicDegeneratedMode(): Graphic3d_ZLayerId;
  Face(): TopoDS_Face;
  Result(): TopoDS_Shape;
  Add(wire: TopoDS_Wire): void;
  Perform(): Standard_Boolean;
  FixOrientation_1(): Standard_Boolean;
  FixOrientation_2(MapWires: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  FixAddNaturalBound(): Standard_Boolean;
  FixMissingSeam(): Standard_Boolean;
  FixSmallAreaWire(theIsRemoveSmallFace: Standard_Boolean): Standard_Boolean;
  FixLoopWire(aResWires: TopTools_SequenceOfShape): Standard_Boolean;
  FixIntersectingWires(): Standard_Boolean;
  FixWiresTwoCoincEdges(): Standard_Boolean;
  FixSplitFace(MapWires: TopTools_DataMapOfShapeListOfShape): Standard_Boolean;
  FixPeriodicDegenerated(): Standard_Boolean;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  FixWireTool(): Handle_ShapeFix_Wire;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_Face_1 extends ShapeFix_Face {
    constructor();
  }

  export declare class ShapeFix_Face_2 extends ShapeFix_Face {
    constructor(face: TopoDS_Face);
  }

export declare class Handle_ShapeFix_Face {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Face): void;
  get(): ShapeFix_Face;
  delete(): void;
}

  export declare class Handle_ShapeFix_Face_1 extends Handle_ShapeFix_Face {
    constructor();
  }

  export declare class Handle_ShapeFix_Face_2 extends Handle_ShapeFix_Face {
    constructor(thePtr: ShapeFix_Face);
  }

  export declare class Handle_ShapeFix_Face_3 extends Handle_ShapeFix_Face {
    constructor(theHandle: Handle_ShapeFix_Face);
  }

  export declare class Handle_ShapeFix_Face_4 extends Handle_ShapeFix_Face {
    constructor(theHandle: Handle_ShapeFix_Face);
  }

export declare class ShapeFix_Wireframe extends ShapeFix_Root {
  ClearStatuses(): void;
  Load(shape: TopoDS_Shape): void;
  FixWireGaps(): Standard_Boolean;
  FixSmallEdges(): Standard_Boolean;
  CheckSmallEdges(theSmallEdges: TopTools_MapOfShape, theEdgeToFaces: TopTools_DataMapOfShapeListOfShape, theFaceWithSmall: TopTools_DataMapOfShapeListOfShape, theMultyEdges: TopTools_MapOfShape): Standard_Boolean;
  MergeSmallEdges(theSmallEdges: TopTools_MapOfShape, theEdgeToFaces: TopTools_DataMapOfShapeListOfShape, theFaceWithSmall: TopTools_DataMapOfShapeListOfShape, theMultyEdges: TopTools_MapOfShape, theModeDrop: Standard_Boolean, theLimitAngle: Quantity_AbsorbedDose): Standard_Boolean;
  StatusWireGaps(status: ShapeExtend_Status): Standard_Boolean;
  StatusSmallEdges(status: ShapeExtend_Status): Standard_Boolean;
  Shape(): TopoDS_Shape;
  ModeDropSmallEdges(): Standard_Boolean;
  SetLimitAngle(theLimitAngle: Quantity_AbsorbedDose): void;
  LimitAngle(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_Wireframe_1 extends ShapeFix_Wireframe {
    constructor();
  }

  export declare class ShapeFix_Wireframe_2 extends ShapeFix_Wireframe {
    constructor(shape: TopoDS_Shape);
  }

export declare class Handle_ShapeFix_Wireframe {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Wireframe): void;
  get(): ShapeFix_Wireframe;
  delete(): void;
}

  export declare class Handle_ShapeFix_Wireframe_1 extends Handle_ShapeFix_Wireframe {
    constructor();
  }

  export declare class Handle_ShapeFix_Wireframe_2 extends Handle_ShapeFix_Wireframe {
    constructor(thePtr: ShapeFix_Wireframe);
  }

  export declare class Handle_ShapeFix_Wireframe_3 extends Handle_ShapeFix_Wireframe {
    constructor(theHandle: Handle_ShapeFix_Wireframe);
  }

  export declare class Handle_ShapeFix_Wireframe_4 extends Handle_ShapeFix_Wireframe {
    constructor(theHandle: Handle_ShapeFix_Wireframe);
  }

export declare class ShapeFix_DataMapOfShapeBox2d extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: ShapeFix_DataMapOfShapeBox2d): void;
  Assign(theOther: ShapeFix_DataMapOfShapeBox2d): ShapeFix_DataMapOfShapeBox2d;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: Bnd_Box2d): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: Bnd_Box2d): Bnd_Box2d;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): Bnd_Box2d;
  ChangeSeek(theKey: TopoDS_Shape): Bnd_Box2d;
  ChangeFind(theKey: TopoDS_Shape): Bnd_Box2d;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class ShapeFix_DataMapOfShapeBox2d_1 extends ShapeFix_DataMapOfShapeBox2d {
    constructor();
  }

  export declare class ShapeFix_DataMapOfShapeBox2d_2 extends ShapeFix_DataMapOfShapeBox2d {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class ShapeFix_DataMapOfShapeBox2d_3 extends ShapeFix_DataMapOfShapeBox2d {
    constructor(theOther: ShapeFix_DataMapOfShapeBox2d);
  }

export declare class ShapeFix_Wire extends ShapeFix_Root {
  ClearModes(): void;
  ClearStatuses(): void;
  Init_1(wire: TopoDS_Wire, face: TopoDS_Face, prec: Quantity_AbsorbedDose): void;
  Init_2(saw: Handle_ShapeAnalysis_Wire): void;
  Load_1(wire: TopoDS_Wire): void;
  Load_2(sbwd: Handle_ShapeExtend_WireData): void;
  SetFace(face: TopoDS_Face): void;
  SetSurface_1(surf: Handle_Geom_Surface): void;
  SetSurface_2(surf: Handle_Geom_Surface, loc: TopLoc_Location): void;
  SetPrecision(prec: Quantity_AbsorbedDose): void;
  SetMaxTailAngle(theMaxTailAngle: Quantity_AbsorbedDose): void;
  SetMaxTailWidth(theMaxTailWidth: Quantity_AbsorbedDose): void;
  IsLoaded(): Standard_Boolean;
  IsReady(): Standard_Boolean;
  NbEdges(): Graphic3d_ZLayerId;
  Wire(): TopoDS_Wire;
  WireAPIMake(): TopoDS_Wire;
  Analyzer(): Handle_ShapeAnalysis_Wire;
  WireData(): Handle_ShapeExtend_WireData;
  Face(): TopoDS_Face;
  ModifyTopologyMode(): Standard_Boolean;
  ModifyGeometryMode(): Standard_Boolean;
  ModifyRemoveLoopMode(): Graphic3d_ZLayerId;
  ClosedWireMode(): Standard_Boolean;
  PreferencePCurveMode(): Standard_Boolean;
  FixGapsByRangesMode(): Standard_Boolean;
  FixReorderMode(): Graphic3d_ZLayerId;
  FixSmallMode(): Graphic3d_ZLayerId;
  FixConnectedMode(): Graphic3d_ZLayerId;
  FixEdgeCurvesMode(): Graphic3d_ZLayerId;
  FixDegeneratedMode(): Graphic3d_ZLayerId;
  FixSelfIntersectionMode(): Graphic3d_ZLayerId;
  FixLackingMode(): Graphic3d_ZLayerId;
  FixGaps3dMode(): Graphic3d_ZLayerId;
  FixGaps2dMode(): Graphic3d_ZLayerId;
  FixReversed2dMode(): Graphic3d_ZLayerId;
  FixRemovePCurveMode(): Graphic3d_ZLayerId;
  FixAddPCurveMode(): Graphic3d_ZLayerId;
  FixRemoveCurve3dMode(): Graphic3d_ZLayerId;
  FixAddCurve3dMode(): Graphic3d_ZLayerId;
  FixSeamMode(): Graphic3d_ZLayerId;
  FixShiftedMode(): Graphic3d_ZLayerId;
  FixSameParameterMode(): Graphic3d_ZLayerId;
  FixVertexToleranceMode(): Graphic3d_ZLayerId;
  FixNotchedEdgesMode(): Graphic3d_ZLayerId;
  FixSelfIntersectingEdgeMode(): Graphic3d_ZLayerId;
  FixIntersectingEdgesMode(): Graphic3d_ZLayerId;
  FixNonAdjacentIntersectingEdgesMode(): Graphic3d_ZLayerId;
  FixTailMode(): Graphic3d_ZLayerId;
  Perform(): Standard_Boolean;
  FixReorder_1(): Standard_Boolean;
  FixSmall_1(lockvtx: Standard_Boolean, precsmall: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  FixConnected_1(prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixEdgeCurves(): Standard_Boolean;
  FixDegenerated_1(): Standard_Boolean;
  FixSelfIntersection(): Standard_Boolean;
  FixLacking_1(force: Standard_Boolean): Standard_Boolean;
  FixClosed(prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixGaps3d(): Standard_Boolean;
  FixGaps2d(): Standard_Boolean;
  FixReorder_2(wi: ShapeAnalysis_WireOrder): Standard_Boolean;
  FixSmall_2(num: Graphic3d_ZLayerId, lockvtx: Standard_Boolean, precsmall: Quantity_AbsorbedDose): Standard_Boolean;
  FixConnected_2(num: Graphic3d_ZLayerId, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixSeam(num: Graphic3d_ZLayerId): Standard_Boolean;
  FixShifted(): Standard_Boolean;
  FixDegenerated_2(num: Graphic3d_ZLayerId): Standard_Boolean;
  FixLacking_2(num: Graphic3d_ZLayerId, force: Standard_Boolean): Standard_Boolean;
  FixNotchedEdges(): Standard_Boolean;
  FixGap3d(num: Graphic3d_ZLayerId, convert: Standard_Boolean): Standard_Boolean;
  FixGap2d(num: Graphic3d_ZLayerId, convert: Standard_Boolean): Standard_Boolean;
  FixTails(): Standard_Boolean;
  StatusReorder(status: ShapeExtend_Status): Standard_Boolean;
  StatusSmall(status: ShapeExtend_Status): Standard_Boolean;
  StatusConnected(status: ShapeExtend_Status): Standard_Boolean;
  StatusEdgeCurves(status: ShapeExtend_Status): Standard_Boolean;
  StatusDegenerated(status: ShapeExtend_Status): Standard_Boolean;
  StatusSelfIntersection(status: ShapeExtend_Status): Standard_Boolean;
  StatusLacking(status: ShapeExtend_Status): Standard_Boolean;
  StatusClosed(status: ShapeExtend_Status): Standard_Boolean;
  StatusGaps3d(status: ShapeExtend_Status): Standard_Boolean;
  StatusGaps2d(status: ShapeExtend_Status): Standard_Boolean;
  StatusNotches(status: ShapeExtend_Status): Standard_Boolean;
  StatusRemovedSegment(): Standard_Boolean;
  StatusFixTails(status: ShapeExtend_Status): Standard_Boolean;
  LastFixStatus(status: ShapeExtend_Status): Standard_Boolean;
  FixEdgeTool(): Handle_ShapeFix_Edge;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_Wire_1 extends ShapeFix_Wire {
    constructor();
  }

  export declare class ShapeFix_Wire_2 extends ShapeFix_Wire {
    constructor(wire: TopoDS_Wire, face: TopoDS_Face, prec: Quantity_AbsorbedDose);
  }

export declare class Handle_ShapeFix_Wire {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Wire): void;
  get(): ShapeFix_Wire;
  delete(): void;
}

  export declare class Handle_ShapeFix_Wire_1 extends Handle_ShapeFix_Wire {
    constructor();
  }

  export declare class Handle_ShapeFix_Wire_2 extends Handle_ShapeFix_Wire {
    constructor(thePtr: ShapeFix_Wire);
  }

  export declare class Handle_ShapeFix_Wire_3 extends Handle_ShapeFix_Wire {
    constructor(theHandle: Handle_ShapeFix_Wire);
  }

  export declare class Handle_ShapeFix_Wire_4 extends Handle_ShapeFix_Wire {
    constructor(theHandle: Handle_ShapeFix_Wire);
  }

export declare class ShapeFix_FixSmallSolid extends ShapeFix_Root {
  constructor()
  SetFixMode(theMode: Graphic3d_ZLayerId): void;
  SetVolumeThreshold(theThreshold: Quantity_AbsorbedDose): void;
  SetWidthFactorThreshold(theThreshold: Quantity_AbsorbedDose): void;
  Remove(theShape: TopoDS_Shape, theContext: Handle_ShapeBuild_ReShape): TopoDS_Shape;
  Merge(theShape: TopoDS_Shape, theContext: Handle_ShapeBuild_ReShape): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeFix_FixSmallSolid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_FixSmallSolid): void;
  get(): ShapeFix_FixSmallSolid;
  delete(): void;
}

  export declare class Handle_ShapeFix_FixSmallSolid_1 extends Handle_ShapeFix_FixSmallSolid {
    constructor();
  }

  export declare class Handle_ShapeFix_FixSmallSolid_2 extends Handle_ShapeFix_FixSmallSolid {
    constructor(thePtr: ShapeFix_FixSmallSolid);
  }

  export declare class Handle_ShapeFix_FixSmallSolid_3 extends Handle_ShapeFix_FixSmallSolid {
    constructor(theHandle: Handle_ShapeFix_FixSmallSolid);
  }

  export declare class Handle_ShapeFix_FixSmallSolid_4 extends Handle_ShapeFix_FixSmallSolid {
    constructor(theHandle: Handle_ShapeFix_FixSmallSolid);
  }

export declare class ShapeFix_ShapeTolerance {
  constructor()
  LimitTolerance(shape: TopoDS_Shape, tmin: Quantity_AbsorbedDose, tmax: Quantity_AbsorbedDose, styp: TopAbs_ShapeEnum): Standard_Boolean;
  SetTolerance(shape: TopoDS_Shape, preci: Quantity_AbsorbedDose, styp: TopAbs_ShapeEnum): void;
  delete(): void;
}

export declare class ShapeFix_Solid extends ShapeFix_Root {
  Init(solid: TopoDS_Solid): void;
  Perform(theProgress: Message_ProgressRange): Standard_Boolean;
  SolidFromShell(shell: TopoDS_Shell): TopoDS_Solid;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  Solid(): TopoDS_Shape;
  FixShellTool(): Handle_ShapeFix_Shell;
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  FixShellMode(): Graphic3d_ZLayerId;
  FixShellOrientationMode(): Graphic3d_ZLayerId;
  CreateOpenSolidMode(): Standard_Boolean;
  Shape(): TopoDS_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_Solid_1 extends ShapeFix_Solid {
    constructor();
  }

  export declare class ShapeFix_Solid_2 extends ShapeFix_Solid {
    constructor(solid: TopoDS_Solid);
  }

export declare class Handle_ShapeFix_Solid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Solid): void;
  get(): ShapeFix_Solid;
  delete(): void;
}

  export declare class Handle_ShapeFix_Solid_1 extends Handle_ShapeFix_Solid {
    constructor();
  }

  export declare class Handle_ShapeFix_Solid_2 extends Handle_ShapeFix_Solid {
    constructor(thePtr: ShapeFix_Solid);
  }

  export declare class Handle_ShapeFix_Solid_3 extends Handle_ShapeFix_Solid {
    constructor(theHandle: Handle_ShapeFix_Solid);
  }

  export declare class Handle_ShapeFix_Solid_4 extends Handle_ShapeFix_Solid {
    constructor(theHandle: Handle_ShapeFix_Solid);
  }

export declare class ShapeFix_FaceConnect {
  constructor()
  Add(aFirst: TopoDS_Face, aSecond: TopoDS_Face): Standard_Boolean;
  Build(shell: TopoDS_Shell, sewtoler: Quantity_AbsorbedDose, fixtoler: Quantity_AbsorbedDose): TopoDS_Shell;
  Clear(): void;
  delete(): void;
}

export declare class ShapeFix_IntersectionTool {
  constructor(context: Handle_ShapeBuild_ReShape, preci: Quantity_AbsorbedDose, maxtol: Quantity_AbsorbedDose)
  Context(): Handle_ShapeBuild_ReShape;
  SplitEdge(edge: TopoDS_Edge, param: Quantity_AbsorbedDose, vert: TopoDS_Vertex, face: TopoDS_Face, newE1: TopoDS_Edge, newE2: TopoDS_Edge, preci: Quantity_AbsorbedDose): Standard_Boolean;
  CutEdge(edge: TopoDS_Edge, pend: Quantity_AbsorbedDose, cut: Quantity_AbsorbedDose, face: TopoDS_Face, iscutline: Standard_Boolean): Standard_Boolean;
  FixSelfIntersectWire(sewd: Handle_ShapeExtend_WireData, face: TopoDS_Face, NbSplit: Graphic3d_ZLayerId, NbCut: Graphic3d_ZLayerId, NbRemoved: Graphic3d_ZLayerId): Standard_Boolean;
  FixIntersectingWires(face: TopoDS_Face): Standard_Boolean;
  delete(): void;
}

export declare class ShapeFix_ComposeShell extends ShapeFix_Root {
  constructor()
  Init(Grid: Handle_ShapeExtend_CompositeSurface, L: TopLoc_Location, Face: TopoDS_Face, Prec: Quantity_AbsorbedDose): void;
  ClosedMode(): Standard_Boolean;
  Perform(): Standard_Boolean;
  SplitEdges(): void;
  Result(): TopoDS_Shape;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  DispatchWires(faces: TopTools_SequenceOfShape, wires: ShapeFix_SequenceOfWireSegment): void;
  SetTransferParamTool(TransferParam: Handle_ShapeAnalysis_TransferParameters): void;
  GetTransferParamTool(): Handle_ShapeAnalysis_TransferParameters;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeFix_ComposeShell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_ComposeShell): void;
  get(): ShapeFix_ComposeShell;
  delete(): void;
}

  export declare class Handle_ShapeFix_ComposeShell_1 extends Handle_ShapeFix_ComposeShell {
    constructor();
  }

  export declare class Handle_ShapeFix_ComposeShell_2 extends Handle_ShapeFix_ComposeShell {
    constructor(thePtr: ShapeFix_ComposeShell);
  }

  export declare class Handle_ShapeFix_ComposeShell_3 extends Handle_ShapeFix_ComposeShell {
    constructor(theHandle: Handle_ShapeFix_ComposeShell);
  }

  export declare class Handle_ShapeFix_ComposeShell_4 extends Handle_ShapeFix_ComposeShell {
    constructor(theHandle: Handle_ShapeFix_ComposeShell);
  }

export declare class ShapeFix_FixSmallFace extends ShapeFix_Root {
  constructor()
  Init(S: TopoDS_Shape): void;
  Perform(): void;
  FixSpotFace(): TopoDS_Shape;
  ReplaceVerticesInCaseOfSpot(F: TopoDS_Face, tol: Quantity_AbsorbedDose): Standard_Boolean;
  RemoveFacesInCaseOfSpot(F: TopoDS_Face): Standard_Boolean;
  FixStripFace(wasdone: Standard_Boolean): TopoDS_Shape;
  ReplaceInCaseOfStrip(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, tol: Quantity_AbsorbedDose): Standard_Boolean;
  RemoveFacesInCaseOfStrip(F: TopoDS_Face): Standard_Boolean;
  ComputeSharedEdgeForStripFace(F: TopoDS_Face, E1: TopoDS_Edge, E2: TopoDS_Edge, F1: TopoDS_Face, tol: Quantity_AbsorbedDose): TopoDS_Edge;
  FixSplitFace(S: TopoDS_Shape): TopoDS_Shape;
  SplitOneFace(F: TopoDS_Face, theSplittedFaces: TopoDS_Compound): Standard_Boolean;
  FixFace(F: TopoDS_Face): TopoDS_Face;
  FixShape(): TopoDS_Shape;
  Shape(): TopoDS_Shape;
  FixPinFace(F: TopoDS_Face): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeFix_FixSmallFace {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_FixSmallFace): void;
  get(): ShapeFix_FixSmallFace;
  delete(): void;
}

  export declare class Handle_ShapeFix_FixSmallFace_1 extends Handle_ShapeFix_FixSmallFace {
    constructor();
  }

  export declare class Handle_ShapeFix_FixSmallFace_2 extends Handle_ShapeFix_FixSmallFace {
    constructor(thePtr: ShapeFix_FixSmallFace);
  }

  export declare class Handle_ShapeFix_FixSmallFace_3 extends Handle_ShapeFix_FixSmallFace {
    constructor(theHandle: Handle_ShapeFix_FixSmallFace);
  }

  export declare class Handle_ShapeFix_FixSmallFace_4 extends Handle_ShapeFix_FixSmallFace {
    constructor(theHandle: Handle_ShapeFix_FixSmallFace);
  }

export declare class ShapeFix_SequenceOfWireSegment extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: ShapeFix_SequenceOfWireSegment): ShapeFix_SequenceOfWireSegment;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: ShapeFix_WireSegment): void;
  Append_2(theSeq: ShapeFix_SequenceOfWireSegment): void;
  Prepend_1(theItem: ShapeFix_WireSegment): void;
  Prepend_2(theSeq: ShapeFix_SequenceOfWireSegment): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: ShapeFix_WireSegment): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: ShapeFix_SequenceOfWireSegment): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: ShapeFix_SequenceOfWireSegment): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: ShapeFix_WireSegment): void;
  Split(theIndex: Standard_Integer, theSeq: ShapeFix_SequenceOfWireSegment): void;
  First(): ShapeFix_WireSegment;
  ChangeFirst(): ShapeFix_WireSegment;
  Last(): ShapeFix_WireSegment;
  ChangeLast(): ShapeFix_WireSegment;
  Value(theIndex: Standard_Integer): ShapeFix_WireSegment;
  ChangeValue(theIndex: Standard_Integer): ShapeFix_WireSegment;
  SetValue(theIndex: Standard_Integer, theItem: ShapeFix_WireSegment): void;
  delete(): void;
}

  export declare class ShapeFix_SequenceOfWireSegment_1 extends ShapeFix_SequenceOfWireSegment {
    constructor();
  }

  export declare class ShapeFix_SequenceOfWireSegment_2 extends ShapeFix_SequenceOfWireSegment {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class ShapeFix_SequenceOfWireSegment_3 extends ShapeFix_SequenceOfWireSegment {
    constructor(theOther: ShapeFix_SequenceOfWireSegment);
  }

export declare class ShapeFix_Edge extends Standard_Transient {
  constructor()
  Projector(): Handle_ShapeConstruct_ProjectCurveOnSurface;
  FixRemovePCurve_1(edge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  FixRemovePCurve_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location): Standard_Boolean;
  FixRemoveCurve3d(edge: TopoDS_Edge): Standard_Boolean;
  FixAddPCurve_1(edge: TopoDS_Edge, face: TopoDS_Face, isSeam: Standard_Boolean, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixAddPCurve_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location, isSeam: Standard_Boolean, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixAddPCurve_3(edge: TopoDS_Edge, face: TopoDS_Face, isSeam: Standard_Boolean, surfana: Handle_ShapeAnalysis_Surface, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixAddPCurve_4(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location, isSeam: Standard_Boolean, surfana: Handle_ShapeAnalysis_Surface, prec: Quantity_AbsorbedDose): Standard_Boolean;
  FixAddCurve3d(edge: TopoDS_Edge): Standard_Boolean;
  FixVertexTolerance_1(edge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  FixVertexTolerance_2(edge: TopoDS_Edge): Standard_Boolean;
  FixReversed2d_1(edge: TopoDS_Edge, face: TopoDS_Face): Standard_Boolean;
  FixReversed2d_2(edge: TopoDS_Edge, surface: Handle_Geom_Surface, location: TopLoc_Location): Standard_Boolean;
  FixSameParameter_1(edge: TopoDS_Edge, tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  FixSameParameter_2(edge: TopoDS_Edge, face: TopoDS_Face, tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  SetContext(context: Handle_ShapeBuild_ReShape): void;
  Context(): Handle_ShapeBuild_ReShape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ShapeFix_Edge {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Edge): void;
  get(): ShapeFix_Edge;
  delete(): void;
}

  export declare class Handle_ShapeFix_Edge_1 extends Handle_ShapeFix_Edge {
    constructor();
  }

  export declare class Handle_ShapeFix_Edge_2 extends Handle_ShapeFix_Edge {
    constructor(thePtr: ShapeFix_Edge);
  }

  export declare class Handle_ShapeFix_Edge_3 extends Handle_ShapeFix_Edge {
    constructor(theHandle: Handle_ShapeFix_Edge);
  }

  export declare class Handle_ShapeFix_Edge_4 extends Handle_ShapeFix_Edge {
    constructor(theHandle: Handle_ShapeFix_Edge);
  }

export declare class ShapeFix_FreeBounds {
  GetClosedWires(): TopoDS_Compound;
  GetOpenWires(): TopoDS_Compound;
  GetShape(): TopoDS_Shape;
  delete(): void;
}

  export declare class ShapeFix_FreeBounds_1 extends ShapeFix_FreeBounds {
    constructor();
  }

  export declare class ShapeFix_FreeBounds_2 extends ShapeFix_FreeBounds {
    constructor(shape: TopoDS_Shape, sewtoler: Quantity_AbsorbedDose, closetoler: Quantity_AbsorbedDose, splitclosed: Standard_Boolean, splitopen: Standard_Boolean);
  }

  export declare class ShapeFix_FreeBounds_3 extends ShapeFix_FreeBounds {
    constructor(shape: TopoDS_Shape, closetoler: Quantity_AbsorbedDose, splitclosed: Standard_Boolean, splitopen: Standard_Boolean);
  }

export declare class ShapeFix_WireVertex {
  constructor()
  Init_1(wire: TopoDS_Wire, preci: Quantity_AbsorbedDose): void;
  Init_2(sbwd: Handle_ShapeExtend_WireData, preci: Quantity_AbsorbedDose): void;
  Init_3(sawv: ShapeAnalysis_WireVertex): void;
  Analyzer(): ShapeAnalysis_WireVertex;
  WireData(): Handle_ShapeExtend_WireData;
  Wire(): TopoDS_Wire;
  FixSame(): Graphic3d_ZLayerId;
  Fix(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class ShapeFix_SplitTool {
  constructor()
  SplitEdge_1(edge: TopoDS_Edge, param: Quantity_AbsorbedDose, vert: TopoDS_Vertex, face: TopoDS_Face, newE1: TopoDS_Edge, newE2: TopoDS_Edge, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): Standard_Boolean;
  SplitEdge_2(edge: TopoDS_Edge, param1: Quantity_AbsorbedDose, param2: Quantity_AbsorbedDose, vert: TopoDS_Vertex, face: TopoDS_Face, newE1: TopoDS_Edge, newE2: TopoDS_Edge, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): Standard_Boolean;
  CutEdge(edge: TopoDS_Edge, pend: Quantity_AbsorbedDose, cut: Quantity_AbsorbedDose, face: TopoDS_Face, iscutline: Standard_Boolean): Standard_Boolean;
  SplitEdge_3(edge: TopoDS_Edge, fp: Quantity_AbsorbedDose, V1: TopoDS_Vertex, lp: Quantity_AbsorbedDose, V2: TopoDS_Vertex, face: TopoDS_Face, SeqE: TopTools_SequenceOfShape, aNum: Graphic3d_ZLayerId, context: Handle_ShapeBuild_ReShape, tol3d: Quantity_AbsorbedDose, tol2d: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Handle_ShapeFix_Root {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Root): void;
  get(): ShapeFix_Root;
  delete(): void;
}

  export declare class Handle_ShapeFix_Root_1 extends Handle_ShapeFix_Root {
    constructor();
  }

  export declare class Handle_ShapeFix_Root_2 extends Handle_ShapeFix_Root {
    constructor(thePtr: ShapeFix_Root);
  }

  export declare class Handle_ShapeFix_Root_3 extends Handle_ShapeFix_Root {
    constructor(theHandle: Handle_ShapeFix_Root);
  }

  export declare class Handle_ShapeFix_Root_4 extends Handle_ShapeFix_Root {
    constructor(theHandle: Handle_ShapeFix_Root);
  }

export declare class ShapeFix_Root extends Standard_Transient {
  constructor()
  Set(Root: Handle_ShapeFix_Root): void;
  SetContext(context: Handle_ShapeBuild_ReShape): void;
  Context(): Handle_ShapeBuild_ReShape;
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  MsgRegistrator(): Handle_ShapeExtend_BasicMsgRegistrator;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  Precision(): Quantity_AbsorbedDose;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  MinTolerance(): Quantity_AbsorbedDose;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  MaxTolerance(): Quantity_AbsorbedDose;
  LimitTolerance(toler: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  SendMsg_1(shape: TopoDS_Shape, message: Message_Msg, gravity: Message_Gravity): void;
  SendMsg_2(message: Message_Msg, gravity: Message_Gravity): void;
  SendWarning_1(shape: TopoDS_Shape, message: Message_Msg): void;
  SendWarning_2(message: Message_Msg): void;
  SendFail_1(shape: TopoDS_Shape, message: Message_Msg): void;
  SendFail_2(message: Message_Msg): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeFix_Shape extends ShapeFix_Root {
  Init(shape: TopoDS_Shape): void;
  Perform(theProgress: Message_ProgressRange): Standard_Boolean;
  Shape(): TopoDS_Shape;
  FixSolidTool(): Handle_ShapeFix_Solid;
  FixShellTool(): Handle_ShapeFix_Shell;
  FixFaceTool(): Handle_ShapeFix_Face;
  FixWireTool(): Handle_ShapeFix_Wire;
  FixEdgeTool(): Handle_ShapeFix_Edge;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  FixSolidMode(): Graphic3d_ZLayerId;
  FixFreeShellMode(): Graphic3d_ZLayerId;
  FixFreeFaceMode(): Graphic3d_ZLayerId;
  FixFreeWireMode(): Graphic3d_ZLayerId;
  FixSameParameterMode(): Graphic3d_ZLayerId;
  FixVertexPositionMode(): Graphic3d_ZLayerId;
  FixVertexTolMode(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_Shape_1 extends ShapeFix_Shape {
    constructor();
  }

  export declare class ShapeFix_Shape_2 extends ShapeFix_Shape {
    constructor(shape: TopoDS_Shape);
  }

export declare class Handle_ShapeFix_Shape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Shape): void;
  get(): ShapeFix_Shape;
  delete(): void;
}

  export declare class Handle_ShapeFix_Shape_1 extends Handle_ShapeFix_Shape {
    constructor();
  }

  export declare class Handle_ShapeFix_Shape_2 extends Handle_ShapeFix_Shape {
    constructor(thePtr: ShapeFix_Shape);
  }

  export declare class Handle_ShapeFix_Shape_3 extends Handle_ShapeFix_Shape {
    constructor(theHandle: Handle_ShapeFix_Shape);
  }

  export declare class Handle_ShapeFix_Shape_4 extends Handle_ShapeFix_Shape {
    constructor(theHandle: Handle_ShapeFix_Shape);
  }

export declare class ShapeFix_Shell extends ShapeFix_Root {
  Init(shell: TopoDS_Shell): void;
  Perform(theProgress: Message_ProgressRange): Standard_Boolean;
  FixFaceOrientation(shell: TopoDS_Shell, isAccountMultiConex: Standard_Boolean, NonManifold: Standard_Boolean): Standard_Boolean;
  Shell(): TopoDS_Shell;
  Shape(): TopoDS_Shape;
  NbShells(): Graphic3d_ZLayerId;
  ErrorFaces(): TopoDS_Compound;
  Status(status: ShapeExtend_Status): Standard_Boolean;
  FixFaceTool(): Handle_ShapeFix_Face;
  SetMsgRegistrator(msgreg: Handle_ShapeExtend_BasicMsgRegistrator): void;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  SetMinTolerance(mintol: Quantity_AbsorbedDose): void;
  SetMaxTolerance(maxtol: Quantity_AbsorbedDose): void;
  FixFaceMode(): Graphic3d_ZLayerId;
  FixOrientationMode(): Graphic3d_ZLayerId;
  SetNonManifoldFlag(isNonManifold: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_Shell_1 extends ShapeFix_Shell {
    constructor();
  }

  export declare class ShapeFix_Shell_2 extends ShapeFix_Shell {
    constructor(shape: TopoDS_Shell);
  }

export declare class Handle_ShapeFix_Shell {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_Shell): void;
  get(): ShapeFix_Shell;
  delete(): void;
}

  export declare class Handle_ShapeFix_Shell_1 extends Handle_ShapeFix_Shell {
    constructor();
  }

  export declare class Handle_ShapeFix_Shell_2 extends Handle_ShapeFix_Shell {
    constructor(thePtr: ShapeFix_Shell);
  }

  export declare class Handle_ShapeFix_Shell_3 extends Handle_ShapeFix_Shell {
    constructor(theHandle: Handle_ShapeFix_Shell);
  }

  export declare class Handle_ShapeFix_Shell_4 extends Handle_ShapeFix_Shell {
    constructor(theHandle: Handle_ShapeFix_Shell);
  }

export declare class ShapeFix {
  constructor();
  static SameParameter(shape: TopoDS_Shape, enforce: Standard_Boolean, preci: Quantity_AbsorbedDose, theProgress: Message_ProgressRange, theMsgReg: Handle_ShapeExtend_BasicMsgRegistrator): Standard_Boolean;
  static EncodeRegularity(shape: TopoDS_Shape, tolang: Quantity_AbsorbedDose): void;
  static RemoveSmallEdges(shape: TopoDS_Shape, Tolerance: Quantity_AbsorbedDose, context: Handle_ShapeBuild_ReShape): TopoDS_Shape;
  static FixVertexPosition(theshape: TopoDS_Shape, theTolerance: Quantity_AbsorbedDose, thecontext: Handle_ShapeBuild_ReShape): Standard_Boolean;
  static LeastEdgeSize(theshape: TopoDS_Shape): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class ShapeFix_EdgeConnect {
  constructor()
  Add_1(aFirst: TopoDS_Edge, aSecond: TopoDS_Edge): void;
  Add_2(aShape: TopoDS_Shape): void;
  Build(): void;
  Clear(): void;
  delete(): void;
}

export declare class ShapeFix_EdgeProjAux extends Standard_Transient {
  Init(F: TopoDS_Face, E: TopoDS_Edge): void;
  Compute(preci: Quantity_AbsorbedDose): void;
  IsFirstDone(): Standard_Boolean;
  IsLastDone(): Standard_Boolean;
  FirstParam(): Quantity_AbsorbedDose;
  LastParam(): Quantity_AbsorbedDose;
  IsIso(C: Handle_Geom2d_Curve): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ShapeFix_EdgeProjAux_1 extends ShapeFix_EdgeProjAux {
    constructor();
  }

  export declare class ShapeFix_EdgeProjAux_2 extends ShapeFix_EdgeProjAux {
    constructor(F: TopoDS_Face, E: TopoDS_Edge);
  }

export declare class Handle_ShapeFix_EdgeProjAux {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeFix_EdgeProjAux): void;
  get(): ShapeFix_EdgeProjAux;
  delete(): void;
}

  export declare class Handle_ShapeFix_EdgeProjAux_1 extends Handle_ShapeFix_EdgeProjAux {
    constructor();
  }

  export declare class Handle_ShapeFix_EdgeProjAux_2 extends Handle_ShapeFix_EdgeProjAux {
    constructor(thePtr: ShapeFix_EdgeProjAux);
  }

  export declare class Handle_ShapeFix_EdgeProjAux_3 extends Handle_ShapeFix_EdgeProjAux {
    constructor(theHandle: Handle_ShapeFix_EdgeProjAux);
  }

  export declare class Handle_ShapeFix_EdgeProjAux_4 extends Handle_ShapeFix_EdgeProjAux {
    constructor(theHandle: Handle_ShapeFix_EdgeProjAux);
  }

export declare class math_Gauss {
  constructor(A: math_Matrix, MinPivot: Quantity_AbsorbedDose, theProgress: Message_ProgressRange)
  IsDone(): Standard_Boolean;
  Solve_1(B: math_Vector, X: math_Vector): void;
  Solve_2(B: math_Vector): void;
  Determinant(): Quantity_AbsorbedDose;
  Invert(Inv: math_Matrix): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare type math_Status = {
  math_OK: {};
  math_TooManyIterations: {};
  math_FunctionError: {};
  math_DirectionSearchError: {};
  math_NotBracketed: {};
}

export declare class math_FunctionSetWithDerivatives extends math_FunctionSet {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  Derivatives(X: math_Vector, D: math_Matrix): Standard_Boolean;
  Values(X: math_Vector, F: math_Vector, D: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class math_BracketedRoot {
  constructor(F: math_Function, Bound1: Quantity_AbsorbedDose, Bound2: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, ZEPS: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Value(): Quantity_AbsorbedDose;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_Powell {
  constructor(theFunction: math_MultipleVarFunction, theTolerance: Quantity_AbsorbedDose, theNbIterations: Graphic3d_ZLayerId, theZEPS: Quantity_AbsorbedDose)
  Perform(theFunction: math_MultipleVarFunction, theStartingPoint: math_Vector, theStartingDirections: math_Matrix): void;
  IsSolutionReached(theFunction: math_MultipleVarFunction): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Location_1(): math_Vector;
  Location_2(Loc: math_Vector): void;
  Minimum(): Quantity_AbsorbedDose;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_ValueAndWeight {
  Value(): Quantity_AbsorbedDose;
  Weight(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class math_ValueAndWeight_1 extends math_ValueAndWeight {
    constructor();
  }

  export declare class math_ValueAndWeight_2 extends math_ValueAndWeight {
    constructor(theValue: Quantity_AbsorbedDose, theWeight: Quantity_AbsorbedDose);
  }

export declare class math_BullardGenerator {
  constructor(theSeed: Aspect_VKeyFlags)
  SetSeed(theSeed: Aspect_VKeyFlags): void;
  NextInt(): Aspect_VKeyFlags;
  NextReal(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class math_BracketMinimum {
  SetLimits(theLeft: Quantity_AbsorbedDose, theRight: Quantity_AbsorbedDose): void;
  SetFA(theValue: Quantity_AbsorbedDose): void;
  SetFB(theValue: Quantity_AbsorbedDose): void;
  Perform(F: math_Function): void;
  IsDone(): Standard_Boolean;
  Values(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose): void;
  FunctionValues(FA: Quantity_AbsorbedDose, FB: Quantity_AbsorbedDose, FC: Quantity_AbsorbedDose): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_BracketMinimum_1 extends math_BracketMinimum {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose);
  }

  export declare class math_BracketMinimum_2 extends math_BracketMinimum {
    constructor(F: math_Function, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose);
  }

  export declare class math_BracketMinimum_3 extends math_BracketMinimum {
    constructor(F: math_Function, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, FA: Quantity_AbsorbedDose);
  }

  export declare class math_BracketMinimum_4 extends math_BracketMinimum {
    constructor(F: math_Function, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, FA: Quantity_AbsorbedDose, FB: Quantity_AbsorbedDose);
  }

export declare class math_Uzawa {
  IsDone(): Standard_Boolean;
  Value(): math_Vector;
  InitialError(): math_Vector;
  Duale(V: math_Vector): void;
  Error(): math_Vector;
  NbIterations(): Graphic3d_ZLayerId;
  InverseCont(): math_Matrix;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_Uzawa_1 extends math_Uzawa {
    constructor(Cont: math_Matrix, Secont: math_Vector, StartingPoint: math_Vector, EpsLix: Quantity_AbsorbedDose, EpsLic: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class math_Uzawa_2 extends math_Uzawa {
    constructor(Cont: math_Matrix, Secont: math_Vector, StartingPoint: math_Vector, Nci: Graphic3d_ZLayerId, Nce: Graphic3d_ZLayerId, EpsLix: Quantity_AbsorbedDose, EpsLic: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

export declare class math_TrigonometricFunctionRoots {
  IsDone(): Standard_Boolean;
  InfiniteRoots(): Standard_Boolean;
  Value(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbSolutions(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_TrigonometricFunctionRoots_1 extends math_TrigonometricFunctionRoots {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, InfBound: Quantity_AbsorbedDose, SupBound: Quantity_AbsorbedDose);
  }

  export declare class math_TrigonometricFunctionRoots_2 extends math_TrigonometricFunctionRoots {
    constructor(D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, InfBound: Quantity_AbsorbedDose, SupBound: Quantity_AbsorbedDose);
  }

  export declare class math_TrigonometricFunctionRoots_3 extends math_TrigonometricFunctionRoots {
    constructor(C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose, InfBound: Quantity_AbsorbedDose, SupBound: Quantity_AbsorbedDose);
  }

export declare class math_FunctionWithDerivative extends math_Function {
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class math_ComputeKronrodPointsAndWeights {
  constructor(Number: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Points(): math_Vector;
  Weights(): math_Vector;
  delete(): void;
}

export declare class math_GaussSingleIntegration {
  IsDone(): Standard_Boolean;
  Value(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_GaussSingleIntegration_1 extends math_GaussSingleIntegration {
    constructor();
  }

  export declare class math_GaussSingleIntegration_2 extends math_GaussSingleIntegration {
    constructor(F: math_Function, Lower: Quantity_AbsorbedDose, Upper: Quantity_AbsorbedDose, Order: Graphic3d_ZLayerId);
  }

  export declare class math_GaussSingleIntegration_3 extends math_GaussSingleIntegration {
    constructor(F: math_Function, Lower: Quantity_AbsorbedDose, Upper: Quantity_AbsorbedDose, Order: Graphic3d_ZLayerId, Tol: Quantity_AbsorbedDose);
  }

export declare class PSO_Particle {
  constructor()
  delete(): void;
}

export declare class math_PSOParticlesPool {
  constructor(theParticlesCount: Graphic3d_ZLayerId, theDimensionCount: Graphic3d_ZLayerId)
  GetParticle(theIdx: Graphic3d_ZLayerId): PSO_Particle;
  GetBestParticle(): PSO_Particle;
  GetWorstParticle(): PSO_Particle;
  delete(): void;
}

export declare class math_FunctionSample {
  constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId)
  Bounds(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose): void;
  NbPoints(): Graphic3d_ZLayerId;
  GetParameter(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class math_Array1OfValueAndWeight {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: math_ValueAndWeight): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: math_Array1OfValueAndWeight): math_Array1OfValueAndWeight;
  Move(theOther: math_Array1OfValueAndWeight): math_Array1OfValueAndWeight;
  First(): math_ValueAndWeight;
  ChangeFirst(): math_ValueAndWeight;
  Last(): math_ValueAndWeight;
  ChangeLast(): math_ValueAndWeight;
  Value(theIndex: Standard_Integer): math_ValueAndWeight;
  ChangeValue(theIndex: Standard_Integer): math_ValueAndWeight;
  SetValue(theIndex: Standard_Integer, theItem: math_ValueAndWeight): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class math_Array1OfValueAndWeight_1 extends math_Array1OfValueAndWeight {
    constructor();
  }

  export declare class math_Array1OfValueAndWeight_2 extends math_Array1OfValueAndWeight {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class math_Array1OfValueAndWeight_3 extends math_Array1OfValueAndWeight {
    constructor(theOther: math_Array1OfValueAndWeight);
  }

  export declare class math_Array1OfValueAndWeight_4 extends math_Array1OfValueAndWeight {
    constructor(theOther: math_Array1OfValueAndWeight);
  }

  export declare class math_Array1OfValueAndWeight_5 extends math_Array1OfValueAndWeight {
    constructor(theBegin: math_ValueAndWeight, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class math_GaussMultipleIntegration {
  constructor(F: math_MultipleVarFunction, Lower: math_Vector, Upper: math_Vector, Order: math_IntegerVector)
  IsDone(): Standard_Boolean;
  Value(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math {
  constructor();
  static GaussPointsMax(): Graphic3d_ZLayerId;
  static GaussPoints(Index: Graphic3d_ZLayerId, Points: math_Vector): void;
  static GaussWeights(Index: Graphic3d_ZLayerId, Weights: math_Vector): void;
  static KronrodPointsMax(): Graphic3d_ZLayerId;
  static OrderedGaussPointsAndWeights(Index: Graphic3d_ZLayerId, Points: math_Vector, Weights: math_Vector): Standard_Boolean;
  static KronrodPointsAndWeights(Index: Graphic3d_ZLayerId, Points: math_Vector, Weights: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class math_FunctionSetRoot {
  SetTolerance(Tolerance: math_Vector): void;
  IsSolutionReached(F: math_FunctionSetWithDerivatives): Standard_Boolean;
  Perform_1(theFunction: math_FunctionSetWithDerivatives, theStartingPoint: math_Vector, theStopOnDivergent: Standard_Boolean): void;
  Perform_2(theFunction: math_FunctionSetWithDerivatives, theStartingPoint: math_Vector, theInfBound: math_Vector, theSupBound: math_Vector, theStopOnDivergent: Standard_Boolean): void;
  IsDone(): Standard_Boolean;
  NbIterations(): Graphic3d_ZLayerId;
  StateNumber(): Graphic3d_ZLayerId;
  Root_1(): math_Vector;
  Root_2(Root: math_Vector): void;
  Derivative_1(): math_Matrix;
  Derivative_2(Der: math_Matrix): void;
  FunctionSetErrors_1(): math_Vector;
  FunctionSetErrors_2(Err: math_Vector): void;
  Dump(o: Standard_OStream): void;
  IsDivergent(): Standard_Boolean;
  delete(): void;
}

  export declare class math_FunctionSetRoot_1 extends math_FunctionSetRoot {
    constructor(F: math_FunctionSetWithDerivatives, Tolerance: math_Vector, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class math_FunctionSetRoot_2 extends math_FunctionSetRoot {
    constructor(F: math_FunctionSetWithDerivatives, NbIterations: Graphic3d_ZLayerId);
  }

export declare class math_NotSquare extends Standard_DimensionError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_math_NotSquare;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class math_NotSquare_1 extends math_NotSquare {
    constructor();
  }

  export declare class math_NotSquare_2 extends math_NotSquare {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_math_NotSquare {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: math_NotSquare): void;
  get(): math_NotSquare;
  delete(): void;
}

  export declare class Handle_math_NotSquare_1 extends Handle_math_NotSquare {
    constructor();
  }

  export declare class Handle_math_NotSquare_2 extends Handle_math_NotSquare {
    constructor(thePtr: math_NotSquare);
  }

  export declare class Handle_math_NotSquare_3 extends Handle_math_NotSquare {
    constructor(theHandle: Handle_math_NotSquare);
  }

  export declare class Handle_math_NotSquare_4 extends Handle_math_NotSquare {
    constructor(theHandle: Handle_math_NotSquare);
  }

export declare class math_BissecNewton {
  constructor(theXTolerance: Quantity_AbsorbedDose)
  Perform(F: math_FunctionWithDerivative, Bound1: Quantity_AbsorbedDose, Bound2: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId): void;
  IsSolutionReached(theFunction: math_FunctionWithDerivative): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Derivative(): Quantity_AbsorbedDose;
  Value(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_BFGS {
  constructor(NbVariables: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, ZEPS: Quantity_AbsorbedDose)
  SetBoundary(theLeftBorder: math_Vector, theRightBorder: math_Vector): void;
  Perform(F: math_MultipleVarFunctionWithGradient, StartingPoint: math_Vector): void;
  IsSolutionReached(F: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Location_1(): math_Vector;
  Location_2(Loc: math_Vector): void;
  Minimum(): Quantity_AbsorbedDose;
  Gradient_1(): math_Vector;
  Gradient_2(Grad: math_Vector): void;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_FRPR {
  constructor(theFunction: math_MultipleVarFunctionWithGradient, theTolerance: Quantity_AbsorbedDose, theNbIterations: Graphic3d_ZLayerId, theZEPS: Quantity_AbsorbedDose)
  Perform(theFunction: math_MultipleVarFunctionWithGradient, theStartingPoint: math_Vector): void;
  IsSolutionReached(theFunction: math_MultipleVarFunctionWithGradient): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Location_1(): math_Vector;
  Location_2(Loc: math_Vector): void;
  Minimum(): Quantity_AbsorbedDose;
  Gradient_1(): math_Vector;
  Gradient_2(Grad: math_Vector): void;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_GlobOptMin {
  constructor(theFunc: math_MultipleVarFunction, theLowerBorder: math_Vector, theUpperBorder: math_Vector, theC: Quantity_AbsorbedDose, theDiscretizationTol: Quantity_AbsorbedDose, theSameTol: Quantity_AbsorbedDose)
  SetGlobalParams(theFunc: math_MultipleVarFunction, theLowerBorder: math_Vector, theUpperBorder: math_Vector, theC: Quantity_AbsorbedDose, theDiscretizationTol: Quantity_AbsorbedDose, theSameTol: Quantity_AbsorbedDose): void;
  SetLocalParams(theLocalA: math_Vector, theLocalB: math_Vector): void;
  SetTol(theDiscretizationTol: Quantity_AbsorbedDose, theSameTol: Quantity_AbsorbedDose): void;
  GetTol(theDiscretizationTol: Quantity_AbsorbedDose, theSameTol: Quantity_AbsorbedDose): void;
  Perform(isFindSingleSolution: Standard_Boolean): void;
  Points(theIndex: Graphic3d_ZLayerId, theSol: math_Vector): void;
  SetContinuity(theCont: Graphic3d_ZLayerId): void;
  GetContinuity(): Graphic3d_ZLayerId;
  SetFunctionalMinimalValue(theMinimalValue: Quantity_AbsorbedDose): void;
  GetFunctionalMinimalValue(): Quantity_AbsorbedDose;
  SetLipConstState(theFlag: Standard_Boolean): void;
  GetLipConstState(): Standard_Boolean;
  isDone(): Standard_Boolean;
  GetF(): Quantity_AbsorbedDose;
  NbExtrema(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class math_DirectPolynomialRoots {
  IsDone(): Standard_Boolean;
  InfiniteRoots(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  Value(Nieme: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_DirectPolynomialRoots_1 extends math_DirectPolynomialRoots {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose);
  }

  export declare class math_DirectPolynomialRoots_2 extends math_DirectPolynomialRoots {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose);
  }

  export declare class math_DirectPolynomialRoots_3 extends math_DirectPolynomialRoots {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose);
  }

  export declare class math_DirectPolynomialRoots_4 extends math_DirectPolynomialRoots {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose);
  }

export declare class math_Jacobi {
  constructor(A: math_Matrix)
  IsDone(): Standard_Boolean;
  Values(): math_Vector;
  Value(Num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Vectors(): math_Matrix;
  Vector(Num: Graphic3d_ZLayerId, V: math_Vector): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_BrentMinimum {
  Perform(F: math_Function, Ax: Quantity_AbsorbedDose, Bx: Quantity_AbsorbedDose, Cx: Quantity_AbsorbedDose): void;
  IsSolutionReached(theFunction: math_Function): Standard_Boolean;
  IsDone(): Standard_Boolean;
  Location(): Quantity_AbsorbedDose;
  Minimum(): Quantity_AbsorbedDose;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_BrentMinimum_1 extends math_BrentMinimum {
    constructor(TolX: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, ZEPS: Quantity_AbsorbedDose);
  }

  export declare class math_BrentMinimum_2 extends math_BrentMinimum {
    constructor(TolX: Quantity_AbsorbedDose, Fbx: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId, ZEPS: Quantity_AbsorbedDose);
  }

export declare class math_GaussSetIntegration {
  constructor(F: math_FunctionSet, Lower: math_Vector, Upper: math_Vector, Order: math_IntegerVector)
  IsDone(): Standard_Boolean;
  Value(): math_Vector;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_TrigonometricEquationFunction extends math_FunctionWithDerivative {
  constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, C: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose, E: Quantity_AbsorbedDose)
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  Derivative(X: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  Values(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose, D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class math_KronrodSingleIntegration {
  Perform_1(theFunction: math_Function, theLower: Quantity_AbsorbedDose, theUpper: Quantity_AbsorbedDose, theNbPnts: Graphic3d_ZLayerId): void;
  Perform_2(theFunction: math_Function, theLower: Quantity_AbsorbedDose, theUpper: Quantity_AbsorbedDose, theNbPnts: Graphic3d_ZLayerId, theTolerance: Quantity_AbsorbedDose, theMaxNbIter: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  Value(): Quantity_AbsorbedDose;
  ErrorReached(): Quantity_AbsorbedDose;
  AbsolutError(): Quantity_AbsorbedDose;
  OrderReached(): Graphic3d_ZLayerId;
  NbIterReached(): Graphic3d_ZLayerId;
  static GKRule(theFunction: math_Function, theLower: Quantity_AbsorbedDose, theUpper: Quantity_AbsorbedDose, theGaussP: math_Vector, theGaussW: math_Vector, theKronrodP: math_Vector, theKronrodW: math_Vector, theValue: Quantity_AbsorbedDose, theError: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

  export declare class math_KronrodSingleIntegration_1 extends math_KronrodSingleIntegration {
    constructor();
  }

  export declare class math_KronrodSingleIntegration_2 extends math_KronrodSingleIntegration {
    constructor(theFunction: math_Function, theLower: Quantity_AbsorbedDose, theUpper: Quantity_AbsorbedDose, theNbPnts: Graphic3d_ZLayerId);
  }

  export declare class math_KronrodSingleIntegration_3 extends math_KronrodSingleIntegration {
    constructor(theFunction: math_Function, theLower: Quantity_AbsorbedDose, theUpper: Quantity_AbsorbedDose, theNbPnts: Graphic3d_ZLayerId, theTolerance: Quantity_AbsorbedDose, theMaxNbIter: Graphic3d_ZLayerId);
  }

export declare class math_FunctionRoot {
  IsDone(): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Derivative(): Quantity_AbsorbedDose;
  Value(): Quantity_AbsorbedDose;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_FunctionRoot_1 extends math_FunctionRoot {
    constructor(F: math_FunctionWithDerivative, Guess: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class math_FunctionRoot_2 extends math_FunctionRoot {
    constructor(F: math_FunctionWithDerivative, Guess: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

export declare class math_SVD {
  constructor(A: math_Matrix)
  IsDone(): Standard_Boolean;
  Solve(B: math_Vector, X: math_Vector, Eps: Quantity_AbsorbedDose): void;
  PseudoInverse(Inv: math_Matrix, Eps: Quantity_AbsorbedDose): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_MultipleVarFunction {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class math_GaussLeastSquare {
  constructor(A: math_Matrix, MinPivot: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  Solve(B: math_Vector, X: math_Vector): void;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_FunctionAllRoots {
  constructor(F: math_FunctionWithDerivative, S: math_FunctionSample, EpsX: Quantity_AbsorbedDose, EpsF: Quantity_AbsorbedDose, EpsNul: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  NbIntervals(): Graphic3d_ZLayerId;
  GetInterval(Index: Graphic3d_ZLayerId, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose): void;
  GetIntervalState(Index: Graphic3d_ZLayerId, IFirst: Graphic3d_ZLayerId, ILast: Graphic3d_ZLayerId): void;
  NbPoints(): Graphic3d_ZLayerId;
  GetPoint(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  GetPointState(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_EigenValuesSearcher {
  constructor(Diagonal: TColStd_Array1OfReal, Subdiagonal: TColStd_Array1OfReal)
  IsDone(): Standard_Boolean;
  Dimension(): Graphic3d_ZLayerId;
  EigenValue(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  EigenVector(Index: Graphic3d_ZLayerId): math_Vector;
  delete(): void;
}

export declare class math_PSO {
  constructor(theFunc: math_MultipleVarFunction, theLowBorder: math_Vector, theUppBorder: math_Vector, theSteps: math_Vector, theNbParticles: Graphic3d_ZLayerId, theNbIter: Graphic3d_ZLayerId)
  Perform_1(theSteps: math_Vector, theValue: Quantity_AbsorbedDose, theOutPnt: math_Vector, theNbIter: Graphic3d_ZLayerId): void;
  Perform_2(theParticles: math_PSOParticlesPool, theNbParticles: Graphic3d_ZLayerId, theValue: Quantity_AbsorbedDose, theOutPnt: math_Vector, theNbIter: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class math_Function {
  Value(X: Quantity_AbsorbedDose, F: Quantity_AbsorbedDose): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class math_NewtonFunctionRoot {
  Perform(F: math_FunctionWithDerivative, Guess: Quantity_AbsorbedDose): void;
  IsDone(): Standard_Boolean;
  Root(): Quantity_AbsorbedDose;
  Derivative(): Quantity_AbsorbedDose;
  Value(): Quantity_AbsorbedDose;
  NbIterations(): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class math_NewtonFunctionRoot_1 extends math_NewtonFunctionRoot {
    constructor(F: math_FunctionWithDerivative, Guess: Quantity_AbsorbedDose, EpsX: Quantity_AbsorbedDose, EpsF: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class math_NewtonFunctionRoot_2 extends math_NewtonFunctionRoot {
    constructor(F: math_FunctionWithDerivative, Guess: Quantity_AbsorbedDose, EpsX: Quantity_AbsorbedDose, EpsF: Quantity_AbsorbedDose, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

  export declare class math_NewtonFunctionRoot_3 extends math_NewtonFunctionRoot {
    constructor(A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, EpsX: Quantity_AbsorbedDose, EpsF: Quantity_AbsorbedDose, NbIterations: Graphic3d_ZLayerId);
  }

export declare class math_FunctionRoots {
  constructor(F: math_FunctionWithDerivative, A: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, NbSample: Graphic3d_ZLayerId, EpsX: Quantity_AbsorbedDose, EpsF: Quantity_AbsorbedDose, EpsNull: Quantity_AbsorbedDose, K: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  IsAllNull(): Standard_Boolean;
  NbSolutions(): Graphic3d_ZLayerId;
  Value(Nieme: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  StateNumber(Nieme: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class math_MultipleVarFunctionWithHessian extends math_MultipleVarFunctionWithGradient {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values_1(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  Values_2(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector, H: math_Matrix): Standard_Boolean;
  delete(): void;
}

export declare class Handle_math_SingularMatrix {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: math_SingularMatrix): void;
  get(): math_SingularMatrix;
  delete(): void;
}

  export declare class Handle_math_SingularMatrix_1 extends Handle_math_SingularMatrix {
    constructor();
  }

  export declare class Handle_math_SingularMatrix_2 extends Handle_math_SingularMatrix {
    constructor(thePtr: math_SingularMatrix);
  }

  export declare class Handle_math_SingularMatrix_3 extends Handle_math_SingularMatrix {
    constructor(theHandle: Handle_math_SingularMatrix);
  }

  export declare class Handle_math_SingularMatrix_4 extends Handle_math_SingularMatrix {
    constructor(theHandle: Handle_math_SingularMatrix);
  }

export declare class math_SingularMatrix extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_math_SingularMatrix;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class math_SingularMatrix_1 extends math_SingularMatrix {
    constructor();
  }

  export declare class math_SingularMatrix_2 extends math_SingularMatrix {
    constructor(theMessage: Standard_CString);
  }

export declare class math_FunctionSet {
  NbVariables(): Graphic3d_ZLayerId;
  NbEquations(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: math_Vector): Standard_Boolean;
  GetStateNumber(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class math_MultipleVarFunctionWithGradient extends math_MultipleVarFunction {
  NbVariables(): Graphic3d_ZLayerId;
  Value(X: math_Vector, F: Quantity_AbsorbedDose): Standard_Boolean;
  Gradient(X: math_Vector, G: math_Vector): Standard_Boolean;
  Values(X: math_Vector, F: Quantity_AbsorbedDose, G: math_Vector): Standard_Boolean;
  delete(): void;
}

export declare class math_ComputeGaussPointsAndWeights {
  constructor(Number: Graphic3d_ZLayerId)
  IsDone(): Standard_Boolean;
  Points(): math_Vector;
  Weights(): math_Vector;
  delete(): void;
}

export declare class math_DoubleTab {
  Init(InitValue: Quantity_AbsorbedDose): void;
  Copy(Other: math_DoubleTab): void;
  SetLowerRow(LowerRow: Graphic3d_ZLayerId): void;
  SetLowerCol(LowerCol: Graphic3d_ZLayerId): void;
  Value(RowIndex: Graphic3d_ZLayerId, ColIndex: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Free(): void;
  delete(): void;
}

  export declare class math_DoubleTab_1 extends math_DoubleTab {
    constructor(LowerRow: Graphic3d_ZLayerId, UpperRow: Graphic3d_ZLayerId, LowerCol: Graphic3d_ZLayerId, UpperCol: Graphic3d_ZLayerId);
  }

  export declare class math_DoubleTab_2 extends math_DoubleTab {
    constructor(Tab: Standard_Address, LowerRow: Graphic3d_ZLayerId, UpperRow: Graphic3d_ZLayerId, LowerCol: Graphic3d_ZLayerId, UpperCol: Graphic3d_ZLayerId);
  }

  export declare class math_DoubleTab_3 extends math_DoubleTab {
    constructor(Other: math_DoubleTab);
  }

export declare class math_Crout {
  constructor(A: math_Matrix, MinPivot: Quantity_AbsorbedDose)
  IsDone(): Standard_Boolean;
  Solve(B: math_Vector, X: math_Vector): void;
  Inverse(): math_Matrix;
  Invert(Inv: math_Matrix): void;
  Determinant(): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class Image_SupportedFormats extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  IsSupported_1(theFormat: Image_Format): Standard_Boolean;
  Add_1(theFormat: Image_Format): void;
  HasCompressed(): Standard_Boolean;
  IsSupported_2(theFormat: Image_CompressedFormat): Standard_Boolean;
  Add_2(theFormat: Image_CompressedFormat): void;
  Clear(): void;
  delete(): void;
}

export declare class Handle_Image_AlienPixMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Image_AlienPixMap): void;
  get(): Image_AlienPixMap;
  delete(): void;
}

  export declare class Handle_Image_AlienPixMap_1 extends Handle_Image_AlienPixMap {
    constructor();
  }

  export declare class Handle_Image_AlienPixMap_2 extends Handle_Image_AlienPixMap {
    constructor(thePtr: Image_AlienPixMap);
  }

  export declare class Handle_Image_AlienPixMap_3 extends Handle_Image_AlienPixMap {
    constructor(theHandle: Handle_Image_AlienPixMap);
  }

  export declare class Handle_Image_AlienPixMap_4 extends Handle_Image_AlienPixMap {
    constructor(theHandle: Handle_Image_AlienPixMap);
  }

export declare class Image_AlienPixMap extends Image_PixMap {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static IsTopDownDefault(): Standard_Boolean;
  Load_1(theFileName: XCAFDoc_PartId): Standard_Boolean;
  Load_2(theStream: Standard_IStream, theFileName: XCAFDoc_PartId): Standard_Boolean;
  Load_3(theData: Standard_Byte, theLength: Standard_ThreadId, theFileName: XCAFDoc_PartId): Standard_Boolean;
  Save(theFileName: XCAFDoc_PartId): Standard_Boolean;
  InitTrash(thePixelFormat: Image_Format, theSizeX: Standard_ThreadId, theSizeY: Standard_ThreadId, theSizeRowBytes: Standard_ThreadId): Standard_Boolean;
  InitCopy(theCopy: Image_PixMap): Standard_Boolean;
  Clear(): void;
  AdjustGamma(theGammaCorr: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class Image_VideoRecorder extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Close(): void;
  Open(theFileName: Standard_Character, theParams: Image_VideoParams): Standard_Boolean;
  FrameCount(): int64_t;
  PushFrame(): Standard_Boolean;
  delete(): void;
}

export declare class Handle_Image_VideoRecorder {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Image_VideoRecorder): void;
  get(): Image_VideoRecorder;
  delete(): void;
}

  export declare class Handle_Image_VideoRecorder_1 extends Handle_Image_VideoRecorder {
    constructor();
  }

  export declare class Handle_Image_VideoRecorder_2 extends Handle_Image_VideoRecorder {
    constructor(thePtr: Image_VideoRecorder);
  }

  export declare class Handle_Image_VideoRecorder_3 extends Handle_Image_VideoRecorder {
    constructor(theHandle: Handle_Image_VideoRecorder);
  }

  export declare class Handle_Image_VideoRecorder_4 extends Handle_Image_VideoRecorder {
    constructor(theHandle: Handle_Image_VideoRecorder);
  }

export declare class Image_VideoParams {
  constructor()
  SetFramerate_1(theNumerator: Graphic3d_ZLayerId, theDenominator: Graphic3d_ZLayerId): void;
  SetFramerate_2(theValue: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Image_Format = {
  Image_Format_UNKNOWN: {};
  Image_Format_Gray: {};
  Image_Format_Alpha: {};
  Image_Format_RGB: {};
  Image_Format_BGR: {};
  Image_Format_RGB32: {};
  Image_Format_BGR32: {};
  Image_Format_RGBA: {};
  Image_Format_BGRA: {};
  Image_Format_GrayF: {};
  Image_Format_AlphaF: {};
  Image_Format_RGF: {};
  Image_Format_RGBF: {};
  Image_Format_BGRF: {};
  Image_Format_RGBAF: {};
  Image_Format_BGRAF: {};
}

export declare class Image_DDSParser {
  constructor();
  static Load_1(theSupported: any, theFile: XCAFDoc_PartId, theFaceIndex: Graphic3d_ZLayerId, theFileOffset: int64_t): any;
  static Load_2(theSupported: any, theBuffer: Handle_NCollection_Buffer, theFaceIndex: Graphic3d_ZLayerId): any;
  delete(): void;
}

export declare class Handle_Image_PixMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Image_PixMap): void;
  get(): Image_PixMap;
  delete(): void;
}

  export declare class Handle_Image_PixMap_1 extends Handle_Image_PixMap {
    constructor();
  }

  export declare class Handle_Image_PixMap_2 extends Handle_Image_PixMap {
    constructor(thePtr: Image_PixMap);
  }

  export declare class Handle_Image_PixMap_3 extends Handle_Image_PixMap {
    constructor(theHandle: Handle_Image_PixMap);
  }

  export declare class Handle_Image_PixMap_4 extends Handle_Image_PixMap {
    constructor(theHandle: Handle_Image_PixMap);
  }

export declare class Image_PixMap extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static IsBigEndianHost(): Standard_Boolean;
  static SwapRgbaBgra(theImage: Image_PixMap): Standard_Boolean;
  static ToBlackWhite(theImage: Image_PixMap): void;
  static DefaultAllocator(): Handle_NCollection_BaseAllocator;
  Format(): Image_Format;
  SetFormat(thePixelFormat: Image_Format): void;
  Width(): Standard_ThreadId;
  Height(): Standard_ThreadId;
  SizeX(): Standard_ThreadId;
  SizeY(): Standard_ThreadId;
  Ratio(): Quantity_AbsorbedDose;
  IsEmpty(): Standard_Boolean;
  PixelColor(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId, theToLinearize: Standard_Boolean): Quantity_ColorRGBA;
  SetPixelColor_1(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId, theColor: Quantity_Color, theToDeLinearize: Standard_Boolean): void;
  SetPixelColor_2(theX: Graphic3d_ZLayerId, theY: Graphic3d_ZLayerId, theColor: Quantity_ColorRGBA, theToDeLinearize: Standard_Boolean): void;
  InitWrapper(thePixelFormat: Image_Format, theDataPtr: Standard_Byte, theSizeX: Standard_ThreadId, theSizeY: Standard_ThreadId, theSizeRowBytes: Standard_ThreadId): Standard_Boolean;
  InitTrash(thePixelFormat: Image_Format, theSizeX: Standard_ThreadId, theSizeY: Standard_ThreadId, theSizeRowBytes: Standard_ThreadId): Standard_Boolean;
  InitCopy(theCopy: Image_PixMap): Standard_Boolean;
  InitZero(thePixelFormat: Image_Format, theSizeX: Standard_ThreadId, theSizeY: Standard_ThreadId, theSizeRowBytes: Standard_ThreadId, theValue: Standard_Byte): Standard_Boolean;
  Clear(): void;
  IsTopDown(): Standard_Boolean;
  SetTopDown(theIsTopDown: Standard_Boolean): void;
  TopDownInc(): Standard_ThreadId;
  Data(): Standard_Byte;
  ChangeData(): Standard_Byte;
  Row(theRow: Standard_ThreadId): Standard_Byte;
  ChangeRow(theRow: Standard_ThreadId): Standard_Byte;
  SizePixelBytes_1(): Standard_ThreadId;
  static SizePixelBytes_2(thePixelFormat: Image_Format): Standard_ThreadId;
  SizeRowBytes(): Standard_ThreadId;
  RowExtraBytes(): Standard_ThreadId;
  MaxRowAligmentBytes(): Standard_ThreadId;
  SizeBytes(): Standard_ThreadId;
  RawValue(theRow: Standard_ThreadId, theCol: Standard_ThreadId): Standard_Byte;
  ChangeRawValue(theRow: Standard_ThreadId, theCol: Standard_ThreadId): Standard_Byte;
  delete(): void;
}

export declare class Image_Texture extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  TextureId(): XCAFDoc_PartId;
  FilePath(): XCAFDoc_PartId;
  FileOffset(): int64_t;
  FileLength(): int64_t;
  DataBuffer(): Handle_NCollection_Buffer;
  ProbeImageFileFormat(): XCAFDoc_PartId;
  ReadCompressedImage(theSupported: any): any;
  ReadImage(theSupported: any): Handle_Image_PixMap;
  WriteImage(theFile: XCAFDoc_PartId): Standard_Boolean;
  static HashCode(theTexture: any, theUpper: Standard_Integer): Standard_Integer;
  static IsEqual(theTex1: any, theTex2: any): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Image_Texture_1 extends Image_Texture {
    constructor(theFileName: XCAFDoc_PartId);
  }

  export declare class Image_Texture_2 extends Image_Texture {
    constructor(theFileName: XCAFDoc_PartId, theOffset: int64_t, theLength: int64_t);
  }

  export declare class Image_Texture_3 extends Image_Texture {
    constructor(theBuffer: Handle_NCollection_Buffer, theId: XCAFDoc_PartId);
  }

export declare type Image_CompressedFormat = {
  Image_CompressedFormat_UNKNOWN: {};
  Image_CompressedFormat_RGB_S3TC_DXT1: {};
  Image_CompressedFormat_RGBA_S3TC_DXT1: {};
  Image_CompressedFormat_RGBA_S3TC_DXT3: {};
  Image_CompressedFormat_RGBA_S3TC_DXT5: {};
}

export declare class Image_PixMapData extends NCollection_Buffer {
  constructor()
  Init(theAlloc: Handle_NCollection_BaseAllocator, theSizeBPP: Standard_ThreadId, theSizeX: Standard_ThreadId, theSizeY: Standard_ThreadId, theSizeRowBytes: Standard_ThreadId, theDataPtr: Standard_Byte): Standard_Boolean;
  ZeroData(): void;
  Row(theRow: Standard_ThreadId): Standard_Byte;
  ChangeRow(theRow: Standard_ThreadId): Standard_Byte;
  Value(theRow: Standard_ThreadId, theCol: Standard_ThreadId): Standard_Byte;
  ChangeValue(theRow: Standard_ThreadId, theCol: Standard_ThreadId): Standard_Byte;
  MaxRowAligmentBytes(): Standard_ThreadId;
  SetTopDown(theIsTopDown: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Image_PixMapData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Image_PixMapData): void;
  get(): Image_PixMapData;
  delete(): void;
}

  export declare class Handle_Image_PixMapData_1 extends Handle_Image_PixMapData {
    constructor();
  }

  export declare class Handle_Image_PixMapData_2 extends Handle_Image_PixMapData {
    constructor(thePtr: Image_PixMapData);
  }

  export declare class Handle_Image_PixMapData_3 extends Handle_Image_PixMapData {
    constructor(theHandle: Handle_Image_PixMapData);
  }

  export declare class Handle_Image_PixMapData_4 extends Handle_Image_PixMapData {
    constructor(theHandle: Handle_Image_PixMapData);
  }

export declare class Image_ColorBGRF {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_ShortReal;
  g_1(): Standard_ShortReal;
  b_1(): Standard_ShortReal;
  r_2(): Standard_ShortReal;
  g_2(): Standard_ShortReal;
  b_2(): Standard_ShortReal;
  delete(): void;
}

export declare class Image_ColorRGF {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_ShortReal;
  g_1(): Standard_ShortReal;
  r_2(): Standard_ShortReal;
  g_2(): Standard_ShortReal;
  delete(): void;
}

export declare class Image_ColorBGR32 {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_Byte;
  g_1(): Standard_Byte;
  b_1(): Standard_Byte;
  a__1(): Standard_Byte;
  r_2(): Standard_Byte;
  g_2(): Standard_Byte;
  b_2(): Standard_Byte;
  a__2(): Standard_Byte;
  delete(): void;
}

export declare class Image_ColorBGR {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_Byte;
  g_1(): Standard_Byte;
  b_1(): Standard_Byte;
  r_2(): Standard_Byte;
  g_2(): Standard_Byte;
  b_2(): Standard_Byte;
  delete(): void;
}

export declare class Image_ColorRGBF {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_ShortReal;
  g_1(): Standard_ShortReal;
  b_1(): Standard_ShortReal;
  r_2(): Standard_ShortReal;
  g_2(): Standard_ShortReal;
  b_2(): Standard_ShortReal;
  delete(): void;
}

export declare class Image_ColorRGB {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_Byte;
  g_1(): Standard_Byte;
  b_1(): Standard_Byte;
  r_2(): Standard_Byte;
  g_2(): Standard_Byte;
  b_2(): Standard_Byte;
  delete(): void;
}

export declare class Image_ColorRGBA {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_Byte;
  g_1(): Standard_Byte;
  b_1(): Standard_Byte;
  a_1(): Standard_Byte;
  r_2(): Standard_Byte;
  g_2(): Standard_Byte;
  b_2(): Standard_Byte;
  a_2(): Standard_Byte;
  delete(): void;
}

export declare class Image_ColorRGB32 {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_Byte;
  g_1(): Standard_Byte;
  b_1(): Standard_Byte;
  a__1(): Standard_Byte;
  r_2(): Standard_Byte;
  g_2(): Standard_Byte;
  b_2(): Standard_Byte;
  a__2(): Standard_Byte;
  delete(): void;
}

export declare class Image_ColorBGRA {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_Byte;
  g_1(): Standard_Byte;
  b_1(): Standard_Byte;
  a_1(): Standard_Byte;
  r_2(): Standard_Byte;
  g_2(): Standard_Byte;
  b_2(): Standard_Byte;
  a_2(): Standard_Byte;
  delete(): void;
}

export declare class Image_ColorBGRAF {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_ShortReal;
  g_1(): Standard_ShortReal;
  b_1(): Standard_ShortReal;
  a_1(): Standard_ShortReal;
  r_2(): Standard_ShortReal;
  g_2(): Standard_ShortReal;
  b_2(): Standard_ShortReal;
  a_2(): Standard_ShortReal;
  delete(): void;
}

export declare class Image_ColorRGBAF {
  constructor();
  static Length(): Graphic3d_ZLayerId;
  r_1(): Standard_ShortReal;
  g_1(): Standard_ShortReal;
  b_1(): Standard_ShortReal;
  a_1(): Standard_ShortReal;
  r_2(): Standard_ShortReal;
  g_2(): Standard_ShortReal;
  b_2(): Standard_ShortReal;
  a_2(): Standard_ShortReal;
  delete(): void;
}

export declare class Image_CompressedPixMap extends Standard_Transient {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  BaseFormat(): Image_Format;
  SetBaseFormat(theFormat: Image_Format): void;
  CompressedFormat(): Image_CompressedFormat;
  SetCompressedFormat(theFormat: Image_CompressedFormat): void;
  FaceData(): Handle_NCollection_Buffer;
  SetFaceData(theBuffer: Handle_NCollection_Buffer): void;
  MipMaps(): TColStd_Array1OfInteger;
  ChangeMipMaps(): TColStd_Array1OfInteger;
  IsCompleteMipMapSet(): Standard_Boolean;
  SetCompleteMipMapSet(theIsComplete: Standard_Boolean): void;
  FaceBytes(): Standard_ThreadId;
  SetFaceBytes(theSize: Standard_ThreadId): void;
  SizeX(): Graphic3d_ZLayerId;
  SizeY(): Graphic3d_ZLayerId;
  SetSize(theSizeX: Graphic3d_ZLayerId, theSizeY: Graphic3d_ZLayerId): void;
  IsTopDown(): Standard_Boolean;
  NbFaces(): Graphic3d_ZLayerId;
  SetNbFaces(theSize: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Image_Diff {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Image_Diff): void;
  get(): Image_Diff;
  delete(): void;
}

  export declare class Handle_Image_Diff_1 extends Handle_Image_Diff {
    constructor();
  }

  export declare class Handle_Image_Diff_2 extends Handle_Image_Diff {
    constructor(thePtr: Image_Diff);
  }

  export declare class Handle_Image_Diff_3 extends Handle_Image_Diff {
    constructor(theHandle: Handle_Image_Diff);
  }

  export declare class Handle_Image_Diff_4 extends Handle_Image_Diff {
    constructor(theHandle: Handle_Image_Diff);
  }

export declare class Image_Diff extends Standard_Transient {
  constructor()
  Init_1(theImageRef: Handle_Image_PixMap, theImageNew: Handle_Image_PixMap, theToBlackWhite: Standard_Boolean): Standard_Boolean;
  Init_2(theImgPathRef: XCAFDoc_PartId, theImgPathNew: XCAFDoc_PartId, theToBlackWhite: Standard_Boolean): Standard_Boolean;
  SetColorTolerance(theTolerance: Quantity_AbsorbedDose): void;
  ColorTolerance(): Quantity_AbsorbedDose;
  SetBorderFilterOn(theToIgnore: Standard_Boolean): void;
  IsBorderFilterOn(): Standard_Boolean;
  Compare(): Graphic3d_ZLayerId;
  SaveDiffImage_1(theDiffImage: Image_PixMap): Standard_Boolean;
  SaveDiffImage_2(theDiffPath: XCAFDoc_PartId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class GeomProjLib {
  constructor();
  static Curve2d_1(C: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, S: Handle_Geom_Surface, UFirst: Quantity_AbsorbedDose, ULast: Quantity_AbsorbedDose, VFirst: Quantity_AbsorbedDose, VLast: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  static Curve2d_2(C: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, S: Handle_Geom_Surface, Tolerance: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  static Curve2d_3(C: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, S: Handle_Geom_Surface): Handle_Geom2d_Curve;
  static Curve2d_4(C: Handle_Geom_Curve, S: Handle_Geom_Surface): Handle_Geom2d_Curve;
  static Curve2d_5(C: Handle_Geom_Curve, S: Handle_Geom_Surface, UDeb: Quantity_AbsorbedDose, UFin: Quantity_AbsorbedDose, VDeb: Quantity_AbsorbedDose, VFin: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  static Curve2d_6(C: Handle_Geom_Curve, S: Handle_Geom_Surface, UDeb: Quantity_AbsorbedDose, UFin: Quantity_AbsorbedDose, VDeb: Quantity_AbsorbedDose, VFin: Quantity_AbsorbedDose, Tolerance: Quantity_AbsorbedDose): Handle_Geom2d_Curve;
  static Project(C: Handle_Geom_Curve, S: Handle_Geom_Surface): Handle_Geom_Curve;
  static ProjectOnPlane(Curve: Handle_Geom_Curve, Plane: Handle_Geom_Plane, Dir: gp_Dir, KeepParametrization: Standard_Boolean): Handle_Geom_Curve;
  delete(): void;
}

export declare class Handle_TDataStd_Tick {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Tick): void;
  get(): TDataStd_Tick;
  delete(): void;
}

  export declare class Handle_TDataStd_Tick_1 extends Handle_TDataStd_Tick {
    constructor();
  }

  export declare class Handle_TDataStd_Tick_2 extends Handle_TDataStd_Tick {
    constructor(thePtr: TDataStd_Tick);
  }

  export declare class Handle_TDataStd_Tick_3 extends Handle_TDataStd_Tick {
    constructor(theHandle: Handle_TDataStd_Tick);
  }

  export declare class Handle_TDataStd_Tick_4 extends Handle_TDataStd_Tick {
    constructor(theHandle: Handle_TDataStd_Tick);
  }

export declare class TDataStd_Tick extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set(label: TDF_Label): Handle_TDataStd_Tick;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class TDataStd_DataMapOfStringByte extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDataStd_DataMapOfStringByte): void;
  Assign(theOther: TDataStd_DataMapOfStringByte): TDataStd_DataMapOfStringByte;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_ExtendedString, theItem: Standard_Byte): Standard_Boolean;
  Bound(theKey: TCollection_ExtendedString, theItem: Standard_Byte): Standard_Byte;
  IsBound(theKey: TCollection_ExtendedString): Standard_Boolean;
  UnBind(theKey: TCollection_ExtendedString): Standard_Boolean;
  Seek(theKey: TCollection_ExtendedString): Standard_Byte;
  ChangeSeek(theKey: TCollection_ExtendedString): Standard_Byte;
  ChangeFind(theKey: TCollection_ExtendedString): Standard_Byte;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDataStd_DataMapOfStringByte_1 extends TDataStd_DataMapOfStringByte {
    constructor();
  }

  export declare class TDataStd_DataMapOfStringByte_2 extends TDataStd_DataMapOfStringByte {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDataStd_DataMapOfStringByte_3 extends TDataStd_DataMapOfStringByte {
    constructor(theOther: TDataStd_DataMapOfStringByte);
  }

export declare class Handle_TDataStd_UAttribute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_UAttribute): void;
  get(): TDataStd_UAttribute;
  delete(): void;
}

  export declare class Handle_TDataStd_UAttribute_1 extends Handle_TDataStd_UAttribute {
    constructor();
  }

  export declare class Handle_TDataStd_UAttribute_2 extends Handle_TDataStd_UAttribute {
    constructor(thePtr: TDataStd_UAttribute);
  }

  export declare class Handle_TDataStd_UAttribute_3 extends Handle_TDataStd_UAttribute {
    constructor(theHandle: Handle_TDataStd_UAttribute);
  }

  export declare class Handle_TDataStd_UAttribute_4 extends Handle_TDataStd_UAttribute {
    constructor(theHandle: Handle_TDataStd_UAttribute);
  }

export declare class TDataStd_UAttribute extends TDF_Attribute {
  constructor()
  static Set(label: TDF_Label, LocalID: Standard_GUID): Handle_TDataStd_UAttribute;
  SetID(LocalID: Standard_GUID): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(DS: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_DeltaOnModificationOfRealArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_DeltaOnModificationOfRealArray): void;
  get(): TDataStd_DeltaOnModificationOfRealArray;
  delete(): void;
}

  export declare class Handle_TDataStd_DeltaOnModificationOfRealArray_1 extends Handle_TDataStd_DeltaOnModificationOfRealArray {
    constructor();
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfRealArray_2 extends Handle_TDataStd_DeltaOnModificationOfRealArray {
    constructor(thePtr: TDataStd_DeltaOnModificationOfRealArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfRealArray_3 extends Handle_TDataStd_DeltaOnModificationOfRealArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfRealArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfRealArray_4 extends Handle_TDataStd_DeltaOnModificationOfRealArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfRealArray);
  }

export declare class TDataStd_DeltaOnModificationOfRealArray extends TDF_DeltaOnModification {
  constructor(Arr: Handle_TDataStd_RealArray)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_DeltaOnModificationOfExtStringArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_DeltaOnModificationOfExtStringArray): void;
  get(): TDataStd_DeltaOnModificationOfExtStringArray;
  delete(): void;
}

  export declare class Handle_TDataStd_DeltaOnModificationOfExtStringArray_1 extends Handle_TDataStd_DeltaOnModificationOfExtStringArray {
    constructor();
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfExtStringArray_2 extends Handle_TDataStd_DeltaOnModificationOfExtStringArray {
    constructor(thePtr: TDataStd_DeltaOnModificationOfExtStringArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfExtStringArray_3 extends Handle_TDataStd_DeltaOnModificationOfExtStringArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfExtStringArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfExtStringArray_4 extends Handle_TDataStd_DeltaOnModificationOfExtStringArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfExtStringArray);
  }

export declare class TDataStd_DeltaOnModificationOfExtStringArray extends TDF_DeltaOnModification {
  constructor(Arr: Handle_TDataStd_ExtStringArray)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_HDataMapOfStringHArray1OfReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HDataMapOfStringHArray1OfReal): void;
  get(): TDataStd_HDataMapOfStringHArray1OfReal;
  delete(): void;
}

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfReal_1 extends Handle_TDataStd_HDataMapOfStringHArray1OfReal {
    constructor();
  }

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfReal_2 extends Handle_TDataStd_HDataMapOfStringHArray1OfReal {
    constructor(thePtr: TDataStd_HDataMapOfStringHArray1OfReal);
  }

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfReal_3 extends Handle_TDataStd_HDataMapOfStringHArray1OfReal {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringHArray1OfReal);
  }

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfReal_4 extends Handle_TDataStd_HDataMapOfStringHArray1OfReal {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringHArray1OfReal);
  }

export declare class TDataStd_HDataMapOfStringHArray1OfReal extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Map(): TDataStd_DataMapOfStringHArray1OfReal;
  ChangeMap(): TDataStd_DataMapOfStringHArray1OfReal;
  delete(): void;
}

  export declare class TDataStd_HDataMapOfStringHArray1OfReal_1 extends TDataStd_HDataMapOfStringHArray1OfReal {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TDataStd_HDataMapOfStringHArray1OfReal_2 extends TDataStd_HDataMapOfStringHArray1OfReal {
    constructor(theOther: TDataStd_DataMapOfStringHArray1OfReal);
  }

export declare class TDataStd_HDataMapOfStringByte extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Map(): TDataStd_DataMapOfStringByte;
  ChangeMap(): TDataStd_DataMapOfStringByte;
  delete(): void;
}

  export declare class TDataStd_HDataMapOfStringByte_1 extends TDataStd_HDataMapOfStringByte {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TDataStd_HDataMapOfStringByte_2 extends TDataStd_HDataMapOfStringByte {
    constructor(theOther: TDataStd_DataMapOfStringByte);
  }

export declare class Handle_TDataStd_HDataMapOfStringByte {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HDataMapOfStringByte): void;
  get(): TDataStd_HDataMapOfStringByte;
  delete(): void;
}

  export declare class Handle_TDataStd_HDataMapOfStringByte_1 extends Handle_TDataStd_HDataMapOfStringByte {
    constructor();
  }

  export declare class Handle_TDataStd_HDataMapOfStringByte_2 extends Handle_TDataStd_HDataMapOfStringByte {
    constructor(thePtr: TDataStd_HDataMapOfStringByte);
  }

  export declare class Handle_TDataStd_HDataMapOfStringByte_3 extends Handle_TDataStd_HDataMapOfStringByte {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringByte);
  }

  export declare class Handle_TDataStd_HDataMapOfStringByte_4 extends Handle_TDataStd_HDataMapOfStringByte {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringByte);
  }

export declare class Handle_TDataStd_Integer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Integer): void;
  get(): TDataStd_Integer;
  delete(): void;
}

  export declare class Handle_TDataStd_Integer_1 extends Handle_TDataStd_Integer {
    constructor();
  }

  export declare class Handle_TDataStd_Integer_2 extends Handle_TDataStd_Integer {
    constructor(thePtr: TDataStd_Integer);
  }

  export declare class Handle_TDataStd_Integer_3 extends Handle_TDataStd_Integer {
    constructor(theHandle: Handle_TDataStd_Integer);
  }

  export declare class Handle_TDataStd_Integer_4 extends Handle_TDataStd_Integer {
    constructor(theHandle: Handle_TDataStd_Integer);
  }

export declare class TDataStd_Integer extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, value: Graphic3d_ZLayerId): Handle_TDataStd_Integer;
  static Set_2(label: TDF_Label, guid: Standard_GUID, value: Graphic3d_ZLayerId): Handle_TDataStd_Integer;
  Set_3(V: Graphic3d_ZLayerId): void;
  SetID_1(guid: Standard_GUID): void;
  SetID_2(): void;
  Get(): Graphic3d_ZLayerId;
  IsCaptured(): Standard_Boolean;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_IntegerList extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_IntegerList;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID): Handle_TDataStd_IntegerList;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  Prepend(value: Graphic3d_ZLayerId): void;
  Append(value: Graphic3d_ZLayerId): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  InsertBefore(value: Graphic3d_ZLayerId, before_value: Graphic3d_ZLayerId): Standard_Boolean;
  InsertBeforeByIndex(index: Graphic3d_ZLayerId, before_value: Graphic3d_ZLayerId): Standard_Boolean;
  InsertAfter(value: Graphic3d_ZLayerId, after_value: Graphic3d_ZLayerId): Standard_Boolean;
  InsertAfterByIndex(index: Graphic3d_ZLayerId, after_value: Graphic3d_ZLayerId): Standard_Boolean;
  Remove(value: Graphic3d_ZLayerId): Standard_Boolean;
  RemoveByIndex(index: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  First(): Graphic3d_ZLayerId;
  Last(): Graphic3d_ZLayerId;
  List(): TColStd_ListOfInteger;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_IntegerList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_IntegerList): void;
  get(): TDataStd_IntegerList;
  delete(): void;
}

  export declare class Handle_TDataStd_IntegerList_1 extends Handle_TDataStd_IntegerList {
    constructor();
  }

  export declare class Handle_TDataStd_IntegerList_2 extends Handle_TDataStd_IntegerList {
    constructor(thePtr: TDataStd_IntegerList);
  }

  export declare class Handle_TDataStd_IntegerList_3 extends Handle_TDataStd_IntegerList {
    constructor(theHandle: Handle_TDataStd_IntegerList);
  }

  export declare class Handle_TDataStd_IntegerList_4 extends Handle_TDataStd_IntegerList {
    constructor(theHandle: Handle_TDataStd_IntegerList);
  }

export declare class TDataStd_NoteBook extends TDataStd_GenericEmpty {
  constructor()
  static Find(current: TDF_Label, N: Handle_TDataStd_NoteBook): Standard_Boolean;
  static New(label: TDF_Label): Handle_TDataStd_NoteBook;
  static GetID(): Standard_GUID;
  Append_1(value: Quantity_AbsorbedDose, isExported: Standard_Boolean): Handle_TDataStd_Real;
  Append_2(value: Graphic3d_ZLayerId, isExported: Standard_Boolean): Handle_TDataStd_Integer;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataStd_NoteBook {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_NoteBook): void;
  get(): TDataStd_NoteBook;
  delete(): void;
}

  export declare class Handle_TDataStd_NoteBook_1 extends Handle_TDataStd_NoteBook {
    constructor();
  }

  export declare class Handle_TDataStd_NoteBook_2 extends Handle_TDataStd_NoteBook {
    constructor(thePtr: TDataStd_NoteBook);
  }

  export declare class Handle_TDataStd_NoteBook_3 extends Handle_TDataStd_NoteBook {
    constructor(theHandle: Handle_TDataStd_NoteBook);
  }

  export declare class Handle_TDataStd_NoteBook_4 extends Handle_TDataStd_NoteBook {
    constructor(theHandle: Handle_TDataStd_NoteBook);
  }

export declare class Handle_TDataStd_AsciiString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_AsciiString): void;
  get(): TDataStd_AsciiString;
  delete(): void;
}

  export declare class Handle_TDataStd_AsciiString_1 extends Handle_TDataStd_AsciiString {
    constructor();
  }

  export declare class Handle_TDataStd_AsciiString_2 extends Handle_TDataStd_AsciiString {
    constructor(thePtr: TDataStd_AsciiString);
  }

  export declare class Handle_TDataStd_AsciiString_3 extends Handle_TDataStd_AsciiString {
    constructor(theHandle: Handle_TDataStd_AsciiString);
  }

  export declare class Handle_TDataStd_AsciiString_4 extends Handle_TDataStd_AsciiString {
    constructor(theHandle: Handle_TDataStd_AsciiString);
  }

export declare class TDataStd_AsciiString extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, string: XCAFDoc_PartId): Handle_TDataStd_AsciiString;
  static Set_2(label: TDF_Label, guid: Standard_GUID, string: XCAFDoc_PartId): Handle_TDataStd_AsciiString;
  Set_3(S: XCAFDoc_PartId): void;
  SetID_1(guid: Standard_GUID): void;
  SetID_2(): void;
  Get(): XCAFDoc_PartId;
  IsEmpty(): Standard_Boolean;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_DataMapOfStringString extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDataStd_DataMapOfStringString): void;
  Assign(theOther: TDataStd_DataMapOfStringString): TDataStd_DataMapOfStringString;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_ExtendedString, theItem: TCollection_ExtendedString): Standard_Boolean;
  Bound(theKey: TCollection_ExtendedString, theItem: TCollection_ExtendedString): TCollection_ExtendedString;
  IsBound(theKey: TCollection_ExtendedString): Standard_Boolean;
  UnBind(theKey: TCollection_ExtendedString): Standard_Boolean;
  Seek(theKey: TCollection_ExtendedString): TCollection_ExtendedString;
  ChangeSeek(theKey: TCollection_ExtendedString): TCollection_ExtendedString;
  ChangeFind(theKey: TCollection_ExtendedString): TCollection_ExtendedString;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDataStd_DataMapOfStringString_1 extends TDataStd_DataMapOfStringString {
    constructor();
  }

  export declare class TDataStd_DataMapOfStringString_2 extends TDataStd_DataMapOfStringString {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDataStd_DataMapOfStringString_3 extends TDataStd_DataMapOfStringString {
    constructor(theOther: TDataStd_DataMapOfStringString);
  }

export declare class TDataStd_LabelArray1 {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: TDF_Label): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TDataStd_LabelArray1): TDataStd_LabelArray1;
  Move(theOther: TDataStd_LabelArray1): TDataStd_LabelArray1;
  First(): TDF_Label;
  ChangeFirst(): TDF_Label;
  Last(): TDF_Label;
  ChangeLast(): TDF_Label;
  Value(theIndex: Standard_Integer): TDF_Label;
  ChangeValue(theIndex: Standard_Integer): TDF_Label;
  SetValue(theIndex: Standard_Integer, theItem: TDF_Label): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TDataStd_LabelArray1_1 extends TDataStd_LabelArray1 {
    constructor();
  }

  export declare class TDataStd_LabelArray1_2 extends TDataStd_LabelArray1 {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TDataStd_LabelArray1_3 extends TDataStd_LabelArray1 {
    constructor(theOther: TDataStd_LabelArray1);
  }

  export declare class TDataStd_LabelArray1_4 extends TDataStd_LabelArray1 {
    constructor(theOther: TDataStd_LabelArray1);
  }

  export declare class TDataStd_LabelArray1_5 extends TDataStd_LabelArray1 {
    constructor(theBegin: TDF_Label, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TDataStd_ChildNodeIterator {
  Initialize(aTreeNode: Handle_TDataStd_TreeNode, allLevels: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  NextBrother(): void;
  Value(): Handle_TDataStd_TreeNode;
  delete(): void;
}

  export declare class TDataStd_ChildNodeIterator_1 extends TDataStd_ChildNodeIterator {
    constructor();
  }

  export declare class TDataStd_ChildNodeIterator_2 extends TDataStd_ChildNodeIterator {
    constructor(aTreeNode: Handle_TDataStd_TreeNode, allLevels: Standard_Boolean);
  }

export declare class Handle_TDataStd_Variable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Variable): void;
  get(): TDataStd_Variable;
  delete(): void;
}

  export declare class Handle_TDataStd_Variable_1 extends Handle_TDataStd_Variable {
    constructor();
  }

  export declare class Handle_TDataStd_Variable_2 extends Handle_TDataStd_Variable {
    constructor(thePtr: TDataStd_Variable);
  }

  export declare class Handle_TDataStd_Variable_3 extends Handle_TDataStd_Variable {
    constructor(theHandle: Handle_TDataStd_Variable);
  }

  export declare class Handle_TDataStd_Variable_4 extends Handle_TDataStd_Variable {
    constructor(theHandle: Handle_TDataStd_Variable);
  }

export declare class TDataStd_Variable extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_Variable;
  Name_1(string: TCollection_ExtendedString): void;
  Name_2(): TCollection_ExtendedString;
  Set_2(value: Quantity_AbsorbedDose): void;
  Set_3(value: Quantity_AbsorbedDose, dimension: TDataStd_RealEnum): void;
  IsValued(): Standard_Boolean;
  Get(): Quantity_AbsorbedDose;
  Real(): Handle_TDataStd_Real;
  IsAssigned(): Standard_Boolean;
  Assign(): Handle_TDataStd_Expression;
  Desassign(): void;
  Expression(): Handle_TDataStd_Expression;
  IsCaptured(): Standard_Boolean;
  IsConstant(): Standard_Boolean;
  Unit_1(unit: XCAFDoc_PartId): void;
  Unit_2(): XCAFDoc_PartId;
  Constant(status: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(DS: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_ExtStringList extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_ExtStringList;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID): Handle_TDataStd_ExtStringList;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  Prepend(value: TCollection_ExtendedString): void;
  Append(value: TCollection_ExtendedString): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  InsertBefore_1(value: TCollection_ExtendedString, before_value: TCollection_ExtendedString): Standard_Boolean;
  InsertBefore_2(index: Graphic3d_ZLayerId, before_value: TCollection_ExtendedString): Standard_Boolean;
  InsertAfter_1(value: TCollection_ExtendedString, after_value: TCollection_ExtendedString): Standard_Boolean;
  InsertAfter_2(index: Graphic3d_ZLayerId, after_value: TCollection_ExtendedString): Standard_Boolean;
  Remove_1(value: TCollection_ExtendedString): Standard_Boolean;
  Remove_2(index: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  First(): TCollection_ExtendedString;
  Last(): TCollection_ExtendedString;
  List(): TDataStd_ListOfExtendedString;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_ExtStringList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_ExtStringList): void;
  get(): TDataStd_ExtStringList;
  delete(): void;
}

  export declare class Handle_TDataStd_ExtStringList_1 extends Handle_TDataStd_ExtStringList {
    constructor();
  }

  export declare class Handle_TDataStd_ExtStringList_2 extends Handle_TDataStd_ExtStringList {
    constructor(thePtr: TDataStd_ExtStringList);
  }

  export declare class Handle_TDataStd_ExtStringList_3 extends Handle_TDataStd_ExtStringList {
    constructor(theHandle: Handle_TDataStd_ExtStringList);
  }

  export declare class Handle_TDataStd_ExtStringList_4 extends Handle_TDataStd_ExtStringList {
    constructor(theHandle: Handle_TDataStd_ExtStringList);
  }

export declare class TDataStd_ListOfByte extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TDataStd_ListOfByte): TDataStd_ListOfByte;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Standard_Byte;
  First_2(): Standard_Byte;
  Last_1(): Standard_Byte;
  Last_2(): Standard_Byte;
  Append_1(theItem: Standard_Byte): Standard_Byte;
  Append_3(theOther: TDataStd_ListOfByte): void;
  Prepend_1(theItem: Standard_Byte): Standard_Byte;
  Prepend_2(theOther: TDataStd_ListOfByte): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TDataStd_ListOfByte_1 extends TDataStd_ListOfByte {
    constructor();
  }

  export declare class TDataStd_ListOfByte_2 extends TDataStd_ListOfByte {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDataStd_ListOfByte_3 extends TDataStd_ListOfByte {
    constructor(theOther: TDataStd_ListOfByte);
  }

export declare class TDataStd_ReferenceArray extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): Handle_TDataStd_ReferenceArray;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): Handle_TDataStd_ReferenceArray;
  Init(lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): void;
  SetValue(index: Graphic3d_ZLayerId, value: TDF_Label): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  Value(Index: Graphic3d_ZLayerId): TDF_Label;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  InternalArray(): Handle_TDataStd_HLabelArray1;
  SetInternalArray(values: Handle_TDataStd_HLabelArray1, isCheckItems: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(DS: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_ReferenceArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_ReferenceArray): void;
  get(): TDataStd_ReferenceArray;
  delete(): void;
}

  export declare class Handle_TDataStd_ReferenceArray_1 extends Handle_TDataStd_ReferenceArray {
    constructor();
  }

  export declare class Handle_TDataStd_ReferenceArray_2 extends Handle_TDataStd_ReferenceArray {
    constructor(thePtr: TDataStd_ReferenceArray);
  }

  export declare class Handle_TDataStd_ReferenceArray_3 extends Handle_TDataStd_ReferenceArray {
    constructor(theHandle: Handle_TDataStd_ReferenceArray);
  }

  export declare class Handle_TDataStd_ReferenceArray_4 extends Handle_TDataStd_ReferenceArray {
    constructor(theHandle: Handle_TDataStd_ReferenceArray);
  }

export declare class Handle_TDataStd_TreeNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_TreeNode): void;
  get(): TDataStd_TreeNode;
  delete(): void;
}

  export declare class Handle_TDataStd_TreeNode_1 extends Handle_TDataStd_TreeNode {
    constructor();
  }

  export declare class Handle_TDataStd_TreeNode_2 extends Handle_TDataStd_TreeNode {
    constructor(thePtr: TDataStd_TreeNode);
  }

  export declare class Handle_TDataStd_TreeNode_3 extends Handle_TDataStd_TreeNode {
    constructor(theHandle: Handle_TDataStd_TreeNode);
  }

  export declare class Handle_TDataStd_TreeNode_4 extends Handle_TDataStd_TreeNode {
    constructor(theHandle: Handle_TDataStd_TreeNode);
  }

export declare class TDataStd_TreeNode extends TDF_Attribute {
  constructor()
  static Find(L: TDF_Label, T: Handle_TDataStd_TreeNode): Standard_Boolean;
  static Set_1(L: TDF_Label): Handle_TDataStd_TreeNode;
  static Set_2(L: TDF_Label, ExplicitTreeID: Standard_GUID): Handle_TDataStd_TreeNode;
  static GetDefaultTreeID(): Standard_GUID;
  Append(Child: Handle_TDataStd_TreeNode): Standard_Boolean;
  Prepend(Child: Handle_TDataStd_TreeNode): Standard_Boolean;
  InsertBefore(Node: Handle_TDataStd_TreeNode): Standard_Boolean;
  InsertAfter(Node: Handle_TDataStd_TreeNode): Standard_Boolean;
  Remove(): Standard_Boolean;
  Depth(): Graphic3d_ZLayerId;
  NbChildren(allLevels: Standard_Boolean): Graphic3d_ZLayerId;
  IsAscendant(of: Handle_TDataStd_TreeNode): Standard_Boolean;
  IsDescendant(of: Handle_TDataStd_TreeNode): Standard_Boolean;
  IsRoot(): Standard_Boolean;
  Root(): Handle_TDataStd_TreeNode;
  IsFather(of: Handle_TDataStd_TreeNode): Standard_Boolean;
  IsChild(of: Handle_TDataStd_TreeNode): Standard_Boolean;
  HasFather(): Standard_Boolean;
  Father(): Handle_TDataStd_TreeNode;
  HasNext(): Standard_Boolean;
  Next(): Handle_TDataStd_TreeNode;
  HasPrevious(): Standard_Boolean;
  Previous(): Handle_TDataStd_TreeNode;
  HasFirst(): Standard_Boolean;
  First(): Handle_TDataStd_TreeNode;
  HasLast(): Standard_Boolean;
  Last(): Handle_TDataStd_TreeNode;
  FindLast(): Handle_TDataStd_TreeNode;
  SetTreeID(explicitID: Standard_GUID): void;
  SetFather(F: Handle_TDataStd_TreeNode): void;
  SetNext(F: Handle_TDataStd_TreeNode): void;
  SetPrevious(F: Handle_TDataStd_TreeNode): void;
  SetFirst(F: Handle_TDataStd_TreeNode): void;
  SetLast(F: Handle_TDataStd_TreeNode): void;
  AfterAddition(): void;
  BeforeForget(): void;
  AfterResume(): void;
  BeforeUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  NewEmpty(): Handle_TDF_Attribute;
  References(aDataSet: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_IntegerArray extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_IntegerArray;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_IntegerArray;
  Init(lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): void;
  SetValue(Index: Graphic3d_ZLayerId, Value: Graphic3d_ZLayerId): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  Value(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  ChangeArray(newArray: Handle_TColStd_HArray1OfInteger, isCheckItems: Standard_Boolean): void;
  Array(): Handle_TColStd_HArray1OfInteger;
  GetDelta(): Standard_Boolean;
  SetDelta(isDelta: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DeltaOnModification(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_TDataStd_IntegerArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_IntegerArray): void;
  get(): TDataStd_IntegerArray;
  delete(): void;
}

  export declare class Handle_TDataStd_IntegerArray_1 extends Handle_TDataStd_IntegerArray {
    constructor();
  }

  export declare class Handle_TDataStd_IntegerArray_2 extends Handle_TDataStd_IntegerArray {
    constructor(thePtr: TDataStd_IntegerArray);
  }

  export declare class Handle_TDataStd_IntegerArray_3 extends Handle_TDataStd_IntegerArray {
    constructor(theHandle: Handle_TDataStd_IntegerArray);
  }

  export declare class Handle_TDataStd_IntegerArray_4 extends Handle_TDataStd_IntegerArray {
    constructor(theHandle: Handle_TDataStd_IntegerArray);
  }

export declare class TDataStd_ListOfExtendedString extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TDataStd_ListOfExtendedString): TDataStd_ListOfExtendedString;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TCollection_ExtendedString;
  First_2(): TCollection_ExtendedString;
  Last_1(): TCollection_ExtendedString;
  Last_2(): TCollection_ExtendedString;
  Append_1(theItem: TCollection_ExtendedString): TCollection_ExtendedString;
  Append_3(theOther: TDataStd_ListOfExtendedString): void;
  Prepend_1(theItem: TCollection_ExtendedString): TCollection_ExtendedString;
  Prepend_2(theOther: TDataStd_ListOfExtendedString): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TDataStd_ListOfExtendedString_1 extends TDataStd_ListOfExtendedString {
    constructor();
  }

  export declare class TDataStd_ListOfExtendedString_2 extends TDataStd_ListOfExtendedString {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDataStd_ListOfExtendedString_3 extends TDataStd_ListOfExtendedString {
    constructor(theOther: TDataStd_ListOfExtendedString);
  }

export declare class Handle_TDataStd_DeltaOnModificationOfByteArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_DeltaOnModificationOfByteArray): void;
  get(): TDataStd_DeltaOnModificationOfByteArray;
  delete(): void;
}

  export declare class Handle_TDataStd_DeltaOnModificationOfByteArray_1 extends Handle_TDataStd_DeltaOnModificationOfByteArray {
    constructor();
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfByteArray_2 extends Handle_TDataStd_DeltaOnModificationOfByteArray {
    constructor(thePtr: TDataStd_DeltaOnModificationOfByteArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfByteArray_3 extends Handle_TDataStd_DeltaOnModificationOfByteArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfByteArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfByteArray_4 extends Handle_TDataStd_DeltaOnModificationOfByteArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfByteArray);
  }

export declare class TDataStd_DeltaOnModificationOfByteArray extends TDF_DeltaOnModification {
  constructor(Arr: Handle_TDataStd_ByteArray)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_Relation extends TDataStd_Expression {
  constructor()
  static GetID(): Standard_GUID;
  static Set(label: TDF_Label): Handle_TDataStd_Relation;
  SetRelation(E: TCollection_ExtendedString): void;
  GetRelation(): TCollection_ExtendedString;
  ID(): Standard_GUID;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataStd_Relation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Relation): void;
  get(): TDataStd_Relation;
  delete(): void;
}

  export declare class Handle_TDataStd_Relation_1 extends Handle_TDataStd_Relation {
    constructor();
  }

  export declare class Handle_TDataStd_Relation_2 extends Handle_TDataStd_Relation {
    constructor(thePtr: TDataStd_Relation);
  }

  export declare class Handle_TDataStd_Relation_3 extends Handle_TDataStd_Relation {
    constructor(theHandle: Handle_TDataStd_Relation);
  }

  export declare class Handle_TDataStd_Relation_4 extends Handle_TDataStd_Relation {
    constructor(theHandle: Handle_TDataStd_Relation);
  }

export declare class TDataStd_GenericEmpty extends TDF_Attribute {
  Restore(a0: Handle_TDF_Attribute): void;
  Paste(a0: Handle_TDF_Attribute, a1: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_GenericEmpty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_GenericEmpty): void;
  get(): TDataStd_GenericEmpty;
  delete(): void;
}

  export declare class Handle_TDataStd_GenericEmpty_1 extends Handle_TDataStd_GenericEmpty {
    constructor();
  }

  export declare class Handle_TDataStd_GenericEmpty_2 extends Handle_TDataStd_GenericEmpty {
    constructor(thePtr: TDataStd_GenericEmpty);
  }

  export declare class Handle_TDataStd_GenericEmpty_3 extends Handle_TDataStd_GenericEmpty {
    constructor(theHandle: Handle_TDataStd_GenericEmpty);
  }

  export declare class Handle_TDataStd_GenericEmpty_4 extends Handle_TDataStd_GenericEmpty {
    constructor(theHandle: Handle_TDataStd_GenericEmpty);
  }

export declare class Handle_TDataStd_Current {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Current): void;
  get(): TDataStd_Current;
  delete(): void;
}

  export declare class Handle_TDataStd_Current_1 extends Handle_TDataStd_Current {
    constructor();
  }

  export declare class Handle_TDataStd_Current_2 extends Handle_TDataStd_Current {
    constructor(thePtr: TDataStd_Current);
  }

  export declare class Handle_TDataStd_Current_3 extends Handle_TDataStd_Current {
    constructor(theHandle: Handle_TDataStd_Current);
  }

  export declare class Handle_TDataStd_Current_4 extends Handle_TDataStd_Current {
    constructor(theHandle: Handle_TDataStd_Current);
  }

export declare class TDataStd_Current extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set(L: TDF_Label): void;
  static Get(acces: TDF_Label): TDF_Label;
  static Has(acces: TDF_Label): Standard_Boolean;
  SetLabel(current: TDF_Label): void;
  GetLabel(): TDF_Label;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_Name extends TDataStd_GenericExtString {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, string: TCollection_ExtendedString): Handle_TDataStd_Name;
  static Set_2(label: TDF_Label, guid: Standard_GUID, string: TCollection_ExtendedString): Handle_TDataStd_Name;
  Set_3(S: TCollection_ExtendedString): void;
  SetID_1(guid: Standard_GUID): void;
  SetID_2(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataStd_Name {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Name): void;
  get(): TDataStd_Name;
  delete(): void;
}

  export declare class Handle_TDataStd_Name_1 extends Handle_TDataStd_Name {
    constructor();
  }

  export declare class Handle_TDataStd_Name_2 extends Handle_TDataStd_Name {
    constructor(thePtr: TDataStd_Name);
  }

  export declare class Handle_TDataStd_Name_3 extends Handle_TDataStd_Name {
    constructor(theHandle: Handle_TDataStd_Name);
  }

  export declare class Handle_TDataStd_Name_4 extends Handle_TDataStd_Name {
    constructor(theHandle: Handle_TDataStd_Name);
  }

export declare class Handle_TDataStd_NamedData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_NamedData): void;
  get(): TDataStd_NamedData;
  delete(): void;
}

  export declare class Handle_TDataStd_NamedData_1 extends Handle_TDataStd_NamedData {
    constructor();
  }

  export declare class Handle_TDataStd_NamedData_2 extends Handle_TDataStd_NamedData {
    constructor(thePtr: TDataStd_NamedData);
  }

  export declare class Handle_TDataStd_NamedData_3 extends Handle_TDataStd_NamedData {
    constructor(theHandle: Handle_TDataStd_NamedData);
  }

  export declare class Handle_TDataStd_NamedData_4 extends Handle_TDataStd_NamedData {
    constructor(theHandle: Handle_TDataStd_NamedData);
  }

export declare class TDataStd_NamedData extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set(label: TDF_Label): Handle_TDataStd_NamedData;
  HasIntegers(): Standard_Boolean;
  HasInteger(theName: TCollection_ExtendedString): Standard_Boolean;
  GetInteger(theName: TCollection_ExtendedString): Graphic3d_ZLayerId;
  SetInteger(theName: TCollection_ExtendedString, theInteger: Graphic3d_ZLayerId): void;
  GetIntegersContainer(): CDM_NamesDirectory;
  ChangeIntegers(theIntegers: CDM_NamesDirectory): void;
  HasReals(): Standard_Boolean;
  HasReal(theName: TCollection_ExtendedString): Standard_Boolean;
  GetReal(theName: TCollection_ExtendedString): Quantity_AbsorbedDose;
  SetReal(theName: TCollection_ExtendedString, theReal: Quantity_AbsorbedDose): void;
  GetRealsContainer(): TDataStd_DataMapOfStringReal;
  ChangeReals(theReals: TDataStd_DataMapOfStringReal): void;
  HasStrings(): Standard_Boolean;
  HasString(theName: TCollection_ExtendedString): Standard_Boolean;
  GetString(theName: TCollection_ExtendedString): TCollection_ExtendedString;
  SetString(theName: TCollection_ExtendedString, theString: TCollection_ExtendedString): void;
  GetStringsContainer(): TDataStd_DataMapOfStringString;
  ChangeStrings(theStrings: TDataStd_DataMapOfStringString): void;
  HasBytes(): Standard_Boolean;
  HasByte(theName: TCollection_ExtendedString): Standard_Boolean;
  GetByte(theName: TCollection_ExtendedString): Standard_Byte;
  SetByte(theName: TCollection_ExtendedString, theByte: Standard_Byte): void;
  GetBytesContainer(): TDataStd_DataMapOfStringByte;
  ChangeBytes(theBytes: TDataStd_DataMapOfStringByte): void;
  HasArraysOfIntegers(): Standard_Boolean;
  HasArrayOfIntegers(theName: TCollection_ExtendedString): Standard_Boolean;
  GetArrayOfIntegers(theName: TCollection_ExtendedString): Handle_TColStd_HArray1OfInteger;
  SetArrayOfIntegers(theName: TCollection_ExtendedString, theArrayOfIntegers: Handle_TColStd_HArray1OfInteger): void;
  GetArraysOfIntegersContainer(): TDataStd_DataMapOfStringHArray1OfInteger;
  ChangeArraysOfIntegers(theArraysOfIntegers: TDataStd_DataMapOfStringHArray1OfInteger): void;
  HasArraysOfReals(): Standard_Boolean;
  HasArrayOfReals(theName: TCollection_ExtendedString): Standard_Boolean;
  GetArrayOfReals(theName: TCollection_ExtendedString): Handle_TColStd_HArray1OfReal;
  SetArrayOfReals(theName: TCollection_ExtendedString, theArrayOfReals: Handle_TColStd_HArray1OfReal): void;
  GetArraysOfRealsContainer(): TDataStd_DataMapOfStringHArray1OfReal;
  ChangeArraysOfReals(theArraysOfReals: TDataStd_DataMapOfStringHArray1OfReal): void;
  Clear(): void;
  HasDeferredData(): Standard_Boolean;
  LoadDeferredData(theToKeepDeferred: Standard_Boolean): Standard_Boolean;
  UnloadDeferredData(): Standard_Boolean;
  clear(): void;
  setInteger(theName: TCollection_ExtendedString, theInteger: Graphic3d_ZLayerId): void;
  setReal(theName: TCollection_ExtendedString, theReal: Quantity_AbsorbedDose): void;
  setString(theName: TCollection_ExtendedString, theString: TCollection_ExtendedString): void;
  setByte(theName: TCollection_ExtendedString, theByte: Standard_Byte): void;
  setArrayOfIntegers(theName: TCollection_ExtendedString, theArrayOfIntegers: Handle_TColStd_HArray1OfInteger): void;
  setArrayOfReals(theName: TCollection_ExtendedString, theArrayOfReals: Handle_TColStd_HArray1OfReal): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_Directory {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Directory): void;
  get(): TDataStd_Directory;
  delete(): void;
}

  export declare class Handle_TDataStd_Directory_1 extends Handle_TDataStd_Directory {
    constructor();
  }

  export declare class Handle_TDataStd_Directory_2 extends Handle_TDataStd_Directory {
    constructor(thePtr: TDataStd_Directory);
  }

  export declare class Handle_TDataStd_Directory_3 extends Handle_TDataStd_Directory {
    constructor(theHandle: Handle_TDataStd_Directory);
  }

  export declare class Handle_TDataStd_Directory_4 extends Handle_TDataStd_Directory {
    constructor(theHandle: Handle_TDataStd_Directory);
  }

export declare class TDataStd_Directory extends TDataStd_GenericEmpty {
  constructor()
  static Find(current: TDF_Label, D: Handle_TDataStd_Directory): Standard_Boolean;
  static New(label: TDF_Label): Handle_TDataStd_Directory;
  static AddDirectory(dir: Handle_TDataStd_Directory): Handle_TDataStd_Directory;
  static MakeObjectLabel(dir: Handle_TDataStd_Directory): TDF_Label;
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class TDataStd_Comment extends TDataStd_GenericExtString {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_Comment;
  static Set_2(label: TDF_Label, string: TCollection_ExtendedString): Handle_TDataStd_Comment;
  Set_3(S: TCollection_ExtendedString): void;
  SetID_1(guid: Standard_GUID): void;
  SetID_2(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataStd_Comment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Comment): void;
  get(): TDataStd_Comment;
  delete(): void;
}

  export declare class Handle_TDataStd_Comment_1 extends Handle_TDataStd_Comment {
    constructor();
  }

  export declare class Handle_TDataStd_Comment_2 extends Handle_TDataStd_Comment {
    constructor(thePtr: TDataStd_Comment);
  }

  export declare class Handle_TDataStd_Comment_3 extends Handle_TDataStd_Comment {
    constructor(theHandle: Handle_TDataStd_Comment);
  }

  export declare class Handle_TDataStd_Comment_4 extends Handle_TDataStd_Comment {
    constructor(theHandle: Handle_TDataStd_Comment);
  }

export declare class Handle_TDataStd_GenericExtString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_GenericExtString): void;
  get(): TDataStd_GenericExtString;
  delete(): void;
}

  export declare class Handle_TDataStd_GenericExtString_1 extends Handle_TDataStd_GenericExtString {
    constructor();
  }

  export declare class Handle_TDataStd_GenericExtString_2 extends Handle_TDataStd_GenericExtString {
    constructor(thePtr: TDataStd_GenericExtString);
  }

  export declare class Handle_TDataStd_GenericExtString_3 extends Handle_TDataStd_GenericExtString {
    constructor(theHandle: Handle_TDataStd_GenericExtString);
  }

  export declare class Handle_TDataStd_GenericExtString_4 extends Handle_TDataStd_GenericExtString {
    constructor(theHandle: Handle_TDataStd_GenericExtString);
  }

export declare class TDataStd_GenericExtString extends TDF_Attribute {
  Set(S: TCollection_ExtendedString): void;
  SetID(guid: Standard_GUID): void;
  Get(): TCollection_ExtendedString;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_ReferenceList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_ReferenceList): void;
  get(): TDataStd_ReferenceList;
  delete(): void;
}

  export declare class Handle_TDataStd_ReferenceList_1 extends Handle_TDataStd_ReferenceList {
    constructor();
  }

  export declare class Handle_TDataStd_ReferenceList_2 extends Handle_TDataStd_ReferenceList {
    constructor(thePtr: TDataStd_ReferenceList);
  }

  export declare class Handle_TDataStd_ReferenceList_3 extends Handle_TDataStd_ReferenceList {
    constructor(theHandle: Handle_TDataStd_ReferenceList);
  }

  export declare class Handle_TDataStd_ReferenceList_4 extends Handle_TDataStd_ReferenceList {
    constructor(theHandle: Handle_TDataStd_ReferenceList);
  }

export declare class TDataStd_ReferenceList extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_ReferenceList;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID): Handle_TDataStd_ReferenceList;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  Prepend(value: TDF_Label): void;
  Append(value: TDF_Label): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  InsertBefore_1(value: TDF_Label, before_value: TDF_Label): Standard_Boolean;
  InsertBefore_2(index: Graphic3d_ZLayerId, before_value: TDF_Label): Standard_Boolean;
  InsertAfter_1(value: TDF_Label, after_value: TDF_Label): Standard_Boolean;
  InsertAfter_2(index: Graphic3d_ZLayerId, after_value: TDF_Label): Standard_Boolean;
  Remove_1(value: TDF_Label): Standard_Boolean;
  Remove_2(index: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  First(): TDF_Label;
  Last(): TDF_Label;
  List(): TDF_LabelList;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(DS: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_HLabelArray1 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HLabelArray1): void;
  get(): TDataStd_HLabelArray1;
  delete(): void;
}

  export declare class Handle_TDataStd_HLabelArray1_1 extends Handle_TDataStd_HLabelArray1 {
    constructor();
  }

  export declare class Handle_TDataStd_HLabelArray1_2 extends Handle_TDataStd_HLabelArray1 {
    constructor(thePtr: TDataStd_HLabelArray1);
  }

  export declare class Handle_TDataStd_HLabelArray1_3 extends Handle_TDataStd_HLabelArray1 {
    constructor(theHandle: Handle_TDataStd_HLabelArray1);
  }

  export declare class Handle_TDataStd_HLabelArray1_4 extends Handle_TDataStd_HLabelArray1 {
    constructor(theHandle: Handle_TDataStd_HLabelArray1);
  }

export declare class TDataStd_HDataMapOfStringString extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Map(): TDataStd_DataMapOfStringString;
  ChangeMap(): TDataStd_DataMapOfStringString;
  delete(): void;
}

  export declare class TDataStd_HDataMapOfStringString_1 extends TDataStd_HDataMapOfStringString {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TDataStd_HDataMapOfStringString_2 extends TDataStd_HDataMapOfStringString {
    constructor(theOther: TDataStd_DataMapOfStringString);
  }

export declare class Handle_TDataStd_HDataMapOfStringString {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HDataMapOfStringString): void;
  get(): TDataStd_HDataMapOfStringString;
  delete(): void;
}

  export declare class Handle_TDataStd_HDataMapOfStringString_1 extends Handle_TDataStd_HDataMapOfStringString {
    constructor();
  }

  export declare class Handle_TDataStd_HDataMapOfStringString_2 extends Handle_TDataStd_HDataMapOfStringString {
    constructor(thePtr: TDataStd_HDataMapOfStringString);
  }

  export declare class Handle_TDataStd_HDataMapOfStringString_3 extends Handle_TDataStd_HDataMapOfStringString {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringString);
  }

  export declare class Handle_TDataStd_HDataMapOfStringString_4 extends Handle_TDataStd_HDataMapOfStringString {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringString);
  }

export declare class TDataStd_HDataMapOfStringHArray1OfInteger extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Map(): TDataStd_DataMapOfStringHArray1OfInteger;
  ChangeMap(): TDataStd_DataMapOfStringHArray1OfInteger;
  delete(): void;
}

  export declare class TDataStd_HDataMapOfStringHArray1OfInteger_1 extends TDataStd_HDataMapOfStringHArray1OfInteger {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TDataStd_HDataMapOfStringHArray1OfInteger_2 extends TDataStd_HDataMapOfStringHArray1OfInteger {
    constructor(theOther: TDataStd_DataMapOfStringHArray1OfInteger);
  }

export declare class Handle_TDataStd_HDataMapOfStringHArray1OfInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HDataMapOfStringHArray1OfInteger): void;
  get(): TDataStd_HDataMapOfStringHArray1OfInteger;
  delete(): void;
}

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfInteger_1 extends Handle_TDataStd_HDataMapOfStringHArray1OfInteger {
    constructor();
  }

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfInteger_2 extends Handle_TDataStd_HDataMapOfStringHArray1OfInteger {
    constructor(thePtr: TDataStd_HDataMapOfStringHArray1OfInteger);
  }

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfInteger_3 extends Handle_TDataStd_HDataMapOfStringHArray1OfInteger {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringHArray1OfInteger);
  }

  export declare class Handle_TDataStd_HDataMapOfStringHArray1OfInteger_4 extends Handle_TDataStd_HDataMapOfStringHArray1OfInteger {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringHArray1OfInteger);
  }

export declare class TDataStd {
  constructor();
  static IDList(anIDList: TDF_IDList): void;
  delete(): void;
}

export declare class Handle_TDataStd_HDataMapOfStringReal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HDataMapOfStringReal): void;
  get(): TDataStd_HDataMapOfStringReal;
  delete(): void;
}

  export declare class Handle_TDataStd_HDataMapOfStringReal_1 extends Handle_TDataStd_HDataMapOfStringReal {
    constructor();
  }

  export declare class Handle_TDataStd_HDataMapOfStringReal_2 extends Handle_TDataStd_HDataMapOfStringReal {
    constructor(thePtr: TDataStd_HDataMapOfStringReal);
  }

  export declare class Handle_TDataStd_HDataMapOfStringReal_3 extends Handle_TDataStd_HDataMapOfStringReal {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringReal);
  }

  export declare class Handle_TDataStd_HDataMapOfStringReal_4 extends Handle_TDataStd_HDataMapOfStringReal {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringReal);
  }

export declare class TDataStd_HDataMapOfStringReal extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Map(): TDataStd_DataMapOfStringReal;
  ChangeMap(): TDataStd_DataMapOfStringReal;
  delete(): void;
}

  export declare class TDataStd_HDataMapOfStringReal_1 extends TDataStd_HDataMapOfStringReal {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TDataStd_HDataMapOfStringReal_2 extends TDataStd_HDataMapOfStringReal {
    constructor(theOther: TDataStd_DataMapOfStringReal);
  }

export declare class TDataStd_ExtStringArray extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_ExtStringArray;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_ExtStringArray;
  Init(lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): void;
  SetValue(Index: Graphic3d_ZLayerId, Value: TCollection_ExtendedString): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  Value(Index: Graphic3d_ZLayerId): TCollection_ExtendedString;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  ChangeArray(newArray: Handle_TColStd_HArray1OfExtendedString, isCheckItems: Standard_Boolean): void;
  Array(): Handle_TColStd_HArray1OfExtendedString;
  GetDelta(): Standard_Boolean;
  SetDelta(isDelta: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DeltaOnModification(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_TDataStd_ExtStringArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_ExtStringArray): void;
  get(): TDataStd_ExtStringArray;
  delete(): void;
}

  export declare class Handle_TDataStd_ExtStringArray_1 extends Handle_TDataStd_ExtStringArray {
    constructor();
  }

  export declare class Handle_TDataStd_ExtStringArray_2 extends Handle_TDataStd_ExtStringArray {
    constructor(thePtr: TDataStd_ExtStringArray);
  }

  export declare class Handle_TDataStd_ExtStringArray_3 extends Handle_TDataStd_ExtStringArray {
    constructor(theHandle: Handle_TDataStd_ExtStringArray);
  }

  export declare class Handle_TDataStd_ExtStringArray_4 extends Handle_TDataStd_ExtStringArray {
    constructor(theHandle: Handle_TDataStd_ExtStringArray);
  }

export declare class TDataStd_DataMapOfStringReal extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDataStd_DataMapOfStringReal): void;
  Assign(theOther: TDataStd_DataMapOfStringReal): TDataStd_DataMapOfStringReal;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TCollection_ExtendedString, theItem: Standard_Real): Standard_Boolean;
  Bound(theKey: TCollection_ExtendedString, theItem: Standard_Real): Standard_Real;
  IsBound(theKey: TCollection_ExtendedString): Standard_Boolean;
  UnBind(theKey: TCollection_ExtendedString): Standard_Boolean;
  Seek(theKey: TCollection_ExtendedString): Standard_Real;
  ChangeSeek(theKey: TCollection_ExtendedString): Standard_Real;
  ChangeFind(theKey: TCollection_ExtendedString): Standard_Real;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDataStd_DataMapOfStringReal_1 extends TDataStd_DataMapOfStringReal {
    constructor();
  }

  export declare class TDataStd_DataMapOfStringReal_2 extends TDataStd_DataMapOfStringReal {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDataStd_DataMapOfStringReal_3 extends TDataStd_DataMapOfStringReal {
    constructor(theOther: TDataStd_DataMapOfStringReal);
  }

export declare class Handle_TDataStd_RealArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_RealArray): void;
  get(): TDataStd_RealArray;
  delete(): void;
}

  export declare class Handle_TDataStd_RealArray_1 extends Handle_TDataStd_RealArray {
    constructor();
  }

  export declare class Handle_TDataStd_RealArray_2 extends Handle_TDataStd_RealArray {
    constructor(thePtr: TDataStd_RealArray);
  }

  export declare class Handle_TDataStd_RealArray_3 extends Handle_TDataStd_RealArray {
    constructor(theHandle: Handle_TDataStd_RealArray);
  }

  export declare class Handle_TDataStd_RealArray_4 extends Handle_TDataStd_RealArray {
    constructor(theHandle: Handle_TDataStd_RealArray);
  }

export declare class TDataStd_RealArray extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_RealArray;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_RealArray;
  Init(lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  SetValue(Index: Graphic3d_ZLayerId, Value: Quantity_AbsorbedDose): void;
  Value(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  ChangeArray(newArray: Handle_TColStd_HArray1OfReal, isCheckItems: Standard_Boolean): void;
  Array(): Handle_TColStd_HArray1OfReal;
  GetDelta(): Standard_Boolean;
  SetDelta(isDelta: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DeltaOnModification(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class TDataStd_Expression extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set(label: TDF_Label): Handle_TDataStd_Expression;
  Name(): TCollection_ExtendedString;
  SetExpression(E: TCollection_ExtendedString): void;
  GetExpression(): TCollection_ExtendedString;
  GetVariables(): TDF_AttributeList;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_Expression {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Expression): void;
  get(): TDataStd_Expression;
  delete(): void;
}

  export declare class Handle_TDataStd_Expression_1 extends Handle_TDataStd_Expression {
    constructor();
  }

  export declare class Handle_TDataStd_Expression_2 extends Handle_TDataStd_Expression {
    constructor(thePtr: TDataStd_Expression);
  }

  export declare class Handle_TDataStd_Expression_3 extends Handle_TDataStd_Expression {
    constructor(theHandle: Handle_TDataStd_Expression);
  }

  export declare class Handle_TDataStd_Expression_4 extends Handle_TDataStd_Expression {
    constructor(theHandle: Handle_TDataStd_Expression);
  }

export declare class Handle_TDataStd_DeltaOnModificationOfIntPackedMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_DeltaOnModificationOfIntPackedMap): void;
  get(): TDataStd_DeltaOnModificationOfIntPackedMap;
  delete(): void;
}

  export declare class Handle_TDataStd_DeltaOnModificationOfIntPackedMap_1 extends Handle_TDataStd_DeltaOnModificationOfIntPackedMap {
    constructor();
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfIntPackedMap_2 extends Handle_TDataStd_DeltaOnModificationOfIntPackedMap {
    constructor(thePtr: TDataStd_DeltaOnModificationOfIntPackedMap);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfIntPackedMap_3 extends Handle_TDataStd_DeltaOnModificationOfIntPackedMap {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfIntPackedMap);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfIntPackedMap_4 extends Handle_TDataStd_DeltaOnModificationOfIntPackedMap {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfIntPackedMap);
  }

export declare class TDataStd_DeltaOnModificationOfIntPackedMap extends TDF_DeltaOnModification {
  constructor(Arr: Handle_TDataStd_IntPackedMap)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_BooleanArray extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): Handle_TDataStd_BooleanArray;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): Handle_TDataStd_BooleanArray;
  Init(lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): void;
  SetValue(index: Graphic3d_ZLayerId, value: Standard_Boolean): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  Value(Index: Graphic3d_ZLayerId): Standard_Boolean;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  InternalArray(): Handle_TColStd_HArray1OfByte;
  SetInternalArray(values: Handle_TColStd_HArray1OfByte): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_BooleanArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_BooleanArray): void;
  get(): TDataStd_BooleanArray;
  delete(): void;
}

  export declare class Handle_TDataStd_BooleanArray_1 extends Handle_TDataStd_BooleanArray {
    constructor();
  }

  export declare class Handle_TDataStd_BooleanArray_2 extends Handle_TDataStd_BooleanArray {
    constructor(thePtr: TDataStd_BooleanArray);
  }

  export declare class Handle_TDataStd_BooleanArray_3 extends Handle_TDataStd_BooleanArray {
    constructor(theHandle: Handle_TDataStd_BooleanArray);
  }

  export declare class Handle_TDataStd_BooleanArray_4 extends Handle_TDataStd_BooleanArray {
    constructor(theHandle: Handle_TDataStd_BooleanArray);
  }

export declare class TDataStd_IntPackedMap extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Set(label: TDF_Label, isDelta: Standard_Boolean): Handle_TDataStd_IntPackedMap;
  ChangeMap_1(theMap: Handle_TColStd_HPackedMapOfInteger): Standard_Boolean;
  ChangeMap_2(theMap: TColStd_PackedMapOfInteger): Standard_Boolean;
  GetMap(): TColStd_PackedMapOfInteger;
  GetHMap(): Handle_TColStd_HPackedMapOfInteger;
  Clear(): Standard_Boolean;
  Add(theKey: Graphic3d_ZLayerId): Standard_Boolean;
  Remove(theKey: Graphic3d_ZLayerId): Standard_Boolean;
  Contains(theKey: Graphic3d_ZLayerId): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  GetDelta(): Standard_Boolean;
  SetDelta(isDelta: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DeltaOnModification(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_TDataStd_IntPackedMap {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_IntPackedMap): void;
  get(): TDataStd_IntPackedMap;
  delete(): void;
}

  export declare class Handle_TDataStd_IntPackedMap_1 extends Handle_TDataStd_IntPackedMap {
    constructor();
  }

  export declare class Handle_TDataStd_IntPackedMap_2 extends Handle_TDataStd_IntPackedMap {
    constructor(thePtr: TDataStd_IntPackedMap);
  }

  export declare class Handle_TDataStd_IntPackedMap_3 extends Handle_TDataStd_IntPackedMap {
    constructor(theHandle: Handle_TDataStd_IntPackedMap);
  }

  export declare class Handle_TDataStd_IntPackedMap_4 extends Handle_TDataStd_IntPackedMap {
    constructor(theHandle: Handle_TDataStd_IntPackedMap);
  }

export declare class Handle_TDataStd_HDataMapOfStringInteger {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_HDataMapOfStringInteger): void;
  get(): TDataStd_HDataMapOfStringInteger;
  delete(): void;
}

  export declare class Handle_TDataStd_HDataMapOfStringInteger_1 extends Handle_TDataStd_HDataMapOfStringInteger {
    constructor();
  }

  export declare class Handle_TDataStd_HDataMapOfStringInteger_2 extends Handle_TDataStd_HDataMapOfStringInteger {
    constructor(thePtr: TDataStd_HDataMapOfStringInteger);
  }

  export declare class Handle_TDataStd_HDataMapOfStringInteger_3 extends Handle_TDataStd_HDataMapOfStringInteger {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringInteger);
  }

  export declare class Handle_TDataStd_HDataMapOfStringInteger_4 extends Handle_TDataStd_HDataMapOfStringInteger {
    constructor(theHandle: Handle_TDataStd_HDataMapOfStringInteger);
  }

export declare class TDataStd_HDataMapOfStringInteger extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Map(): CDM_NamesDirectory;
  ChangeMap(): CDM_NamesDirectory;
  delete(): void;
}

  export declare class TDataStd_HDataMapOfStringInteger_1 extends TDataStd_HDataMapOfStringInteger {
    constructor(NbBuckets: Graphic3d_ZLayerId);
  }

  export declare class TDataStd_HDataMapOfStringInteger_2 extends TDataStd_HDataMapOfStringInteger {
    constructor(theOther: CDM_NamesDirectory);
  }

export declare class Handle_TDataStd_ByteArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_ByteArray): void;
  get(): TDataStd_ByteArray;
  delete(): void;
}

  export declare class Handle_TDataStd_ByteArray_1 extends Handle_TDataStd_ByteArray {
    constructor();
  }

  export declare class Handle_TDataStd_ByteArray_2 extends Handle_TDataStd_ByteArray {
    constructor(thePtr: TDataStd_ByteArray);
  }

  export declare class Handle_TDataStd_ByteArray_3 extends Handle_TDataStd_ByteArray {
    constructor(theHandle: Handle_TDataStd_ByteArray);
  }

  export declare class Handle_TDataStd_ByteArray_4 extends Handle_TDataStd_ByteArray {
    constructor(theHandle: Handle_TDataStd_ByteArray);
  }

export declare class TDataStd_ByteArray extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_ByteArray;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID, lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId, isDelta: Standard_Boolean): Handle_TDataStd_ByteArray;
  Init(lower: Graphic3d_ZLayerId, upper: Graphic3d_ZLayerId): void;
  SetValue(index: Graphic3d_ZLayerId, value: Standard_Byte): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  Value(Index: Graphic3d_ZLayerId): Standard_Byte;
  Lower(): Graphic3d_ZLayerId;
  Upper(): Graphic3d_ZLayerId;
  Length(): Graphic3d_ZLayerId;
  InternalArray(): Handle_TColStd_HArray1OfByte;
  ChangeArray(newArray: Handle_TColStd_HArray1OfByte, isCheckItems: Standard_Boolean): void;
  GetDelta(): Standard_Boolean;
  SetDelta(isDelta: Standard_Boolean): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DeltaOnModification(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_TDataStd_BooleanList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_BooleanList): void;
  get(): TDataStd_BooleanList;
  delete(): void;
}

  export declare class Handle_TDataStd_BooleanList_1 extends Handle_TDataStd_BooleanList {
    constructor();
  }

  export declare class Handle_TDataStd_BooleanList_2 extends Handle_TDataStd_BooleanList {
    constructor(thePtr: TDataStd_BooleanList);
  }

  export declare class Handle_TDataStd_BooleanList_3 extends Handle_TDataStd_BooleanList {
    constructor(theHandle: Handle_TDataStd_BooleanList);
  }

  export declare class Handle_TDataStd_BooleanList_4 extends Handle_TDataStd_BooleanList {
    constructor(theHandle: Handle_TDataStd_BooleanList);
  }

export declare class TDataStd_BooleanList extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_BooleanList;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID): Handle_TDataStd_BooleanList;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  Prepend(value: Standard_Boolean): void;
  Append(value: Standard_Boolean): void;
  Clear(): void;
  First(): Standard_Boolean;
  Last(): Standard_Boolean;
  List(): TDataStd_ListOfByte;
  InsertBefore(index: Graphic3d_ZLayerId, before_value: Standard_Boolean): Standard_Boolean;
  InsertAfter(index: Graphic3d_ZLayerId, after_value: Standard_Boolean): Standard_Boolean;
  Remove(index: Graphic3d_ZLayerId): Standard_Boolean;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDataStd_RealList extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataStd_RealList;
  static Set_2(label: TDF_Label, theGuid: Standard_GUID): Handle_TDataStd_RealList;
  IsEmpty(): Standard_Boolean;
  Extent(): Graphic3d_ZLayerId;
  Prepend(value: Quantity_AbsorbedDose): void;
  Append(value: Quantity_AbsorbedDose): void;
  SetID_1(theGuid: Standard_GUID): void;
  SetID_2(): void;
  InsertBefore(value: Quantity_AbsorbedDose, before_value: Quantity_AbsorbedDose): Standard_Boolean;
  InsertBeforeByIndex(index: Graphic3d_ZLayerId, before_value: Quantity_AbsorbedDose): Standard_Boolean;
  InsertAfter(value: Quantity_AbsorbedDose, after_value: Quantity_AbsorbedDose): Standard_Boolean;
  InsertAfterByIndex(index: Graphic3d_ZLayerId, after_value: Quantity_AbsorbedDose): Standard_Boolean;
  Remove(value: Quantity_AbsorbedDose): Standard_Boolean;
  RemoveByIndex(index: Graphic3d_ZLayerId): Standard_Boolean;
  Clear(): void;
  First(): Quantity_AbsorbedDose;
  Last(): Quantity_AbsorbedDose;
  List(): TColStd_ListOfReal;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_RealList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_RealList): void;
  get(): TDataStd_RealList;
  delete(): void;
}

  export declare class Handle_TDataStd_RealList_1 extends Handle_TDataStd_RealList {
    constructor();
  }

  export declare class Handle_TDataStd_RealList_2 extends Handle_TDataStd_RealList {
    constructor(thePtr: TDataStd_RealList);
  }

  export declare class Handle_TDataStd_RealList_3 extends Handle_TDataStd_RealList {
    constructor(theHandle: Handle_TDataStd_RealList);
  }

  export declare class Handle_TDataStd_RealList_4 extends Handle_TDataStd_RealList {
    constructor(theHandle: Handle_TDataStd_RealList);
  }

export declare class TDataStd_DeltaOnModificationOfIntArray extends TDF_DeltaOnModification {
  constructor(Arr: Handle_TDataStd_IntegerArray)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataStd_DeltaOnModificationOfIntArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_DeltaOnModificationOfIntArray): void;
  get(): TDataStd_DeltaOnModificationOfIntArray;
  delete(): void;
}

  export declare class Handle_TDataStd_DeltaOnModificationOfIntArray_1 extends Handle_TDataStd_DeltaOnModificationOfIntArray {
    constructor();
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfIntArray_2 extends Handle_TDataStd_DeltaOnModificationOfIntArray {
    constructor(thePtr: TDataStd_DeltaOnModificationOfIntArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfIntArray_3 extends Handle_TDataStd_DeltaOnModificationOfIntArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfIntArray);
  }

  export declare class Handle_TDataStd_DeltaOnModificationOfIntArray_4 extends Handle_TDataStd_DeltaOnModificationOfIntArray {
    constructor(theHandle: Handle_TDataStd_DeltaOnModificationOfIntArray);
  }

export declare type TDataStd_RealEnum = {
  TDataStd_SCALAR: {};
  TDataStd_LENGTH: {};
  TDataStd_ANGULAR: {};
}

export declare class Handle_TDataStd_Real {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataStd_Real): void;
  get(): TDataStd_Real;
  delete(): void;
}

  export declare class Handle_TDataStd_Real_1 extends Handle_TDataStd_Real {
    constructor();
  }

  export declare class Handle_TDataStd_Real_2 extends Handle_TDataStd_Real {
    constructor(thePtr: TDataStd_Real);
  }

  export declare class Handle_TDataStd_Real_3 extends Handle_TDataStd_Real {
    constructor(theHandle: Handle_TDataStd_Real);
  }

  export declare class Handle_TDataStd_Real_4 extends Handle_TDataStd_Real {
    constructor(theHandle: Handle_TDataStd_Real);
  }

export declare class TDataStd_Real extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, value: Quantity_AbsorbedDose): Handle_TDataStd_Real;
  static Set_2(label: TDF_Label, guid: Standard_GUID, value: Quantity_AbsorbedDose): Handle_TDataStd_Real;
  SetDimension(DIM: TDataStd_RealEnum): void;
  GetDimension(): TDataStd_RealEnum;
  Set_3(V: Quantity_AbsorbedDose): void;
  SetID_1(guid: Standard_GUID): void;
  SetID_2(): void;
  Get(): Quantity_AbsorbedDose;
  IsCaptured(): Standard_Boolean;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_HArray1OfCertifiedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfCertifiedItem): void;
  get(): StepAP203_HArray1OfCertifiedItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfCertifiedItem_1 extends Handle_StepAP203_HArray1OfCertifiedItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfCertifiedItem_2 extends Handle_StepAP203_HArray1OfCertifiedItem {
    constructor(thePtr: StepAP203_HArray1OfCertifiedItem);
  }

  export declare class Handle_StepAP203_HArray1OfCertifiedItem_3 extends Handle_StepAP203_HArray1OfCertifiedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfCertifiedItem);
  }

  export declare class Handle_StepAP203_HArray1OfCertifiedItem_4 extends Handle_StepAP203_HArray1OfCertifiedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfCertifiedItem);
  }

export declare class Handle_StepAP203_ChangeRequest {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_ChangeRequest): void;
  get(): StepAP203_ChangeRequest;
  delete(): void;
}

  export declare class Handle_StepAP203_ChangeRequest_1 extends Handle_StepAP203_ChangeRequest {
    constructor();
  }

  export declare class Handle_StepAP203_ChangeRequest_2 extends Handle_StepAP203_ChangeRequest {
    constructor(thePtr: StepAP203_ChangeRequest);
  }

  export declare class Handle_StepAP203_ChangeRequest_3 extends Handle_StepAP203_ChangeRequest {
    constructor(theHandle: Handle_StepAP203_ChangeRequest);
  }

  export declare class Handle_StepAP203_ChangeRequest_4 extends Handle_StepAP203_ChangeRequest {
    constructor(theHandle: Handle_StepAP203_ChangeRequest);
  }

export declare class StepAP203_ChangeRequest extends StepBasic_ActionRequestAssignment {
  constructor()
  Init(aActionRequestAssignment_AssignedActionRequest: Handle_StepBasic_VersionedActionRequest, aItems: Handle_StepAP203_HArray1OfChangeRequestItem): void;
  Items(): Handle_StepAP203_HArray1OfChangeRequestItem;
  SetItems(Items: Handle_StepAP203_HArray1OfChangeRequestItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_CcDesignSecurityClassification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignSecurityClassification): void;
  get(): StepAP203_CcDesignSecurityClassification;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignSecurityClassification_1 extends Handle_StepAP203_CcDesignSecurityClassification {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignSecurityClassification_2 extends Handle_StepAP203_CcDesignSecurityClassification {
    constructor(thePtr: StepAP203_CcDesignSecurityClassification);
  }

  export declare class Handle_StepAP203_CcDesignSecurityClassification_3 extends Handle_StepAP203_CcDesignSecurityClassification {
    constructor(theHandle: Handle_StepAP203_CcDesignSecurityClassification);
  }

  export declare class Handle_StepAP203_CcDesignSecurityClassification_4 extends Handle_StepAP203_CcDesignSecurityClassification {
    constructor(theHandle: Handle_StepAP203_CcDesignSecurityClassification);
  }

export declare class StepAP203_CcDesignSecurityClassification extends StepBasic_SecurityClassificationAssignment {
  constructor()
  Init(aSecurityClassificationAssignment_AssignedSecurityClassification: Handle_StepBasic_SecurityClassification, aItems: Handle_StepAP203_HArray1OfClassifiedItem): void;
  Items(): Handle_StepAP203_HArray1OfClassifiedItem;
  SetItems(Items: Handle_StepAP203_HArray1OfClassifiedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_CcDesignSpecificationReference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignSpecificationReference): void;
  get(): StepAP203_CcDesignSpecificationReference;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignSpecificationReference_1 extends Handle_StepAP203_CcDesignSpecificationReference {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignSpecificationReference_2 extends Handle_StepAP203_CcDesignSpecificationReference {
    constructor(thePtr: StepAP203_CcDesignSpecificationReference);
  }

  export declare class Handle_StepAP203_CcDesignSpecificationReference_3 extends Handle_StepAP203_CcDesignSpecificationReference {
    constructor(theHandle: Handle_StepAP203_CcDesignSpecificationReference);
  }

  export declare class Handle_StepAP203_CcDesignSpecificationReference_4 extends Handle_StepAP203_CcDesignSpecificationReference {
    constructor(theHandle: Handle_StepAP203_CcDesignSpecificationReference);
  }

export declare class StepAP203_CcDesignSpecificationReference extends StepBasic_DocumentReference {
  constructor()
  Init(aDocumentReference_AssignedDocument: Handle_StepBasic_Document, aDocumentReference_Source: Handle_TCollection_HAsciiString, aItems: Handle_StepAP203_HArray1OfSpecifiedItem): void;
  Items(): Handle_StepAP203_HArray1OfSpecifiedItem;
  SetItems(Items: Handle_StepAP203_HArray1OfSpecifiedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP203_Array1OfWorkItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_WorkItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfWorkItem): StepAP203_Array1OfWorkItem;
  Move(theOther: StepAP203_Array1OfWorkItem): StepAP203_Array1OfWorkItem;
  First(): StepAP203_WorkItem;
  ChangeFirst(): StepAP203_WorkItem;
  Last(): StepAP203_WorkItem;
  ChangeLast(): StepAP203_WorkItem;
  Value(theIndex: Standard_Integer): StepAP203_WorkItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_WorkItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_WorkItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfWorkItem_1 extends StepAP203_Array1OfWorkItem {
    constructor();
  }

  export declare class StepAP203_Array1OfWorkItem_2 extends StepAP203_Array1OfWorkItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfWorkItem_3 extends StepAP203_Array1OfWorkItem {
    constructor(theOther: StepAP203_Array1OfWorkItem);
  }

  export declare class StepAP203_Array1OfWorkItem_4 extends StepAP203_Array1OfWorkItem {
    constructor(theOther: StepAP203_Array1OfWorkItem);
  }

  export declare class StepAP203_Array1OfWorkItem_5 extends StepAP203_Array1OfWorkItem {
    constructor(theBegin: StepAP203_WorkItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_Array1OfCertifiedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_CertifiedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfCertifiedItem): StepAP203_Array1OfCertifiedItem;
  Move(theOther: StepAP203_Array1OfCertifiedItem): StepAP203_Array1OfCertifiedItem;
  First(): StepAP203_CertifiedItem;
  ChangeFirst(): StepAP203_CertifiedItem;
  Last(): StepAP203_CertifiedItem;
  ChangeLast(): StepAP203_CertifiedItem;
  Value(theIndex: Standard_Integer): StepAP203_CertifiedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_CertifiedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_CertifiedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfCertifiedItem_1 extends StepAP203_Array1OfCertifiedItem {
    constructor();
  }

  export declare class StepAP203_Array1OfCertifiedItem_2 extends StepAP203_Array1OfCertifiedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfCertifiedItem_3 extends StepAP203_Array1OfCertifiedItem {
    constructor(theOther: StepAP203_Array1OfCertifiedItem);
  }

  export declare class StepAP203_Array1OfCertifiedItem_4 extends StepAP203_Array1OfCertifiedItem {
    constructor(theOther: StepAP203_Array1OfCertifiedItem);
  }

  export declare class StepAP203_Array1OfCertifiedItem_5 extends StepAP203_Array1OfCertifiedItem {
    constructor(theBegin: StepAP203_CertifiedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_StartWork extends StepBasic_ActionAssignment {
  constructor()
  Init(aActionAssignment_AssignedAction: Handle_StepBasic_Action, aItems: Handle_StepAP203_HArray1OfWorkItem): void;
  Items(): Handle_StepAP203_HArray1OfWorkItem;
  SetItems(Items: Handle_StepAP203_HArray1OfWorkItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_StartWork {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_StartWork): void;
  get(): StepAP203_StartWork;
  delete(): void;
}

  export declare class Handle_StepAP203_StartWork_1 extends Handle_StepAP203_StartWork {
    constructor();
  }

  export declare class Handle_StepAP203_StartWork_2 extends Handle_StepAP203_StartWork {
    constructor(thePtr: StepAP203_StartWork);
  }

  export declare class Handle_StepAP203_StartWork_3 extends Handle_StepAP203_StartWork {
    constructor(theHandle: Handle_StepAP203_StartWork);
  }

  export declare class Handle_StepAP203_StartWork_4 extends Handle_StepAP203_StartWork {
    constructor(theHandle: Handle_StepAP203_StartWork);
  }

export declare class Handle_StepAP203_CcDesignDateAndTimeAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignDateAndTimeAssignment): void;
  get(): StepAP203_CcDesignDateAndTimeAssignment;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignDateAndTimeAssignment_1 extends Handle_StepAP203_CcDesignDateAndTimeAssignment {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignDateAndTimeAssignment_2 extends Handle_StepAP203_CcDesignDateAndTimeAssignment {
    constructor(thePtr: StepAP203_CcDesignDateAndTimeAssignment);
  }

  export declare class Handle_StepAP203_CcDesignDateAndTimeAssignment_3 extends Handle_StepAP203_CcDesignDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP203_CcDesignDateAndTimeAssignment);
  }

  export declare class Handle_StepAP203_CcDesignDateAndTimeAssignment_4 extends Handle_StepAP203_CcDesignDateAndTimeAssignment {
    constructor(theHandle: Handle_StepAP203_CcDesignDateAndTimeAssignment);
  }

export declare class StepAP203_CcDesignDateAndTimeAssignment extends StepBasic_DateAndTimeAssignment {
  constructor()
  Init(aDateAndTimeAssignment_AssignedDateAndTime: Handle_StepBasic_DateAndTime, aDateAndTimeAssignment_Role: Handle_StepBasic_DateTimeRole, aItems: Handle_StepAP203_HArray1OfDateTimeItem): void;
  Items(): Handle_StepAP203_HArray1OfDateTimeItem;
  SetItems(Items: Handle_StepAP203_HArray1OfDateTimeItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP203_Array1OfStartRequestItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_StartRequestItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfStartRequestItem): StepAP203_Array1OfStartRequestItem;
  Move(theOther: StepAP203_Array1OfStartRequestItem): StepAP203_Array1OfStartRequestItem;
  First(): StepAP203_StartRequestItem;
  ChangeFirst(): StepAP203_StartRequestItem;
  Last(): StepAP203_StartRequestItem;
  ChangeLast(): StepAP203_StartRequestItem;
  Value(theIndex: Standard_Integer): StepAP203_StartRequestItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_StartRequestItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_StartRequestItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfStartRequestItem_1 extends StepAP203_Array1OfStartRequestItem {
    constructor();
  }

  export declare class StepAP203_Array1OfStartRequestItem_2 extends StepAP203_Array1OfStartRequestItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfStartRequestItem_3 extends StepAP203_Array1OfStartRequestItem {
    constructor(theOther: StepAP203_Array1OfStartRequestItem);
  }

  export declare class StepAP203_Array1OfStartRequestItem_4 extends StepAP203_Array1OfStartRequestItem {
    constructor(theOther: StepAP203_Array1OfStartRequestItem);
  }

  export declare class StepAP203_Array1OfStartRequestItem_5 extends StepAP203_Array1OfStartRequestItem {
    constructor(theBegin: StepAP203_StartRequestItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP203_HArray1OfChangeRequestItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfChangeRequestItem): void;
  get(): StepAP203_HArray1OfChangeRequestItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfChangeRequestItem_1 extends Handle_StepAP203_HArray1OfChangeRequestItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfChangeRequestItem_2 extends Handle_StepAP203_HArray1OfChangeRequestItem {
    constructor(thePtr: StepAP203_HArray1OfChangeRequestItem);
  }

  export declare class Handle_StepAP203_HArray1OfChangeRequestItem_3 extends Handle_StepAP203_HArray1OfChangeRequestItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfChangeRequestItem);
  }

  export declare class Handle_StepAP203_HArray1OfChangeRequestItem_4 extends Handle_StepAP203_HArray1OfChangeRequestItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfChangeRequestItem);
  }

export declare class StepAP203_DateTimeItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ChangeRequest(): Handle_StepAP203_ChangeRequest;
  StartRequest(): Handle_StepAP203_StartRequest;
  Change(): Handle_StepAP203_Change;
  StartWork(): Handle_StepAP203_StartWork;
  ApprovalPersonOrganization(): Handle_StepBasic_ApprovalPersonOrganization;
  Contract(): Handle_StepBasic_Contract;
  SecurityClassification(): Handle_StepBasic_SecurityClassification;
  Certification(): Handle_StepBasic_Certification;
  delete(): void;
}

export declare class Handle_StepAP203_StartRequest {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_StartRequest): void;
  get(): StepAP203_StartRequest;
  delete(): void;
}

  export declare class Handle_StepAP203_StartRequest_1 extends Handle_StepAP203_StartRequest {
    constructor();
  }

  export declare class Handle_StepAP203_StartRequest_2 extends Handle_StepAP203_StartRequest {
    constructor(thePtr: StepAP203_StartRequest);
  }

  export declare class Handle_StepAP203_StartRequest_3 extends Handle_StepAP203_StartRequest {
    constructor(theHandle: Handle_StepAP203_StartRequest);
  }

  export declare class Handle_StepAP203_StartRequest_4 extends Handle_StepAP203_StartRequest {
    constructor(theHandle: Handle_StepAP203_StartRequest);
  }

export declare class StepAP203_StartRequest extends StepBasic_ActionRequestAssignment {
  constructor()
  Init(aActionRequestAssignment_AssignedActionRequest: Handle_StepBasic_VersionedActionRequest, aItems: Handle_StepAP203_HArray1OfStartRequestItem): void;
  Items(): Handle_StepAP203_HArray1OfStartRequestItem;
  SetItems(Items: Handle_StepAP203_HArray1OfStartRequestItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP203_Array1OfClassifiedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_ClassifiedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfClassifiedItem): StepAP203_Array1OfClassifiedItem;
  Move(theOther: StepAP203_Array1OfClassifiedItem): StepAP203_Array1OfClassifiedItem;
  First(): StepAP203_ClassifiedItem;
  ChangeFirst(): StepAP203_ClassifiedItem;
  Last(): StepAP203_ClassifiedItem;
  ChangeLast(): StepAP203_ClassifiedItem;
  Value(theIndex: Standard_Integer): StepAP203_ClassifiedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_ClassifiedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_ClassifiedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfClassifiedItem_1 extends StepAP203_Array1OfClassifiedItem {
    constructor();
  }

  export declare class StepAP203_Array1OfClassifiedItem_2 extends StepAP203_Array1OfClassifiedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfClassifiedItem_3 extends StepAP203_Array1OfClassifiedItem {
    constructor(theOther: StepAP203_Array1OfClassifiedItem);
  }

  export declare class StepAP203_Array1OfClassifiedItem_4 extends StepAP203_Array1OfClassifiedItem {
    constructor(theOther: StepAP203_Array1OfClassifiedItem);
  }

  export declare class StepAP203_Array1OfClassifiedItem_5 extends StepAP203_Array1OfClassifiedItem {
    constructor(theBegin: StepAP203_ClassifiedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_CertifiedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  SuppliedPartRelationship(): Handle_StepRepr_SuppliedPartRelationship;
  delete(): void;
}

export declare class Handle_StepAP203_HArray1OfDateTimeItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfDateTimeItem): void;
  get(): StepAP203_HArray1OfDateTimeItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfDateTimeItem_1 extends Handle_StepAP203_HArray1OfDateTimeItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfDateTimeItem_2 extends Handle_StepAP203_HArray1OfDateTimeItem {
    constructor(thePtr: StepAP203_HArray1OfDateTimeItem);
  }

  export declare class Handle_StepAP203_HArray1OfDateTimeItem_3 extends Handle_StepAP203_HArray1OfDateTimeItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfDateTimeItem);
  }

  export declare class Handle_StepAP203_HArray1OfDateTimeItem_4 extends Handle_StepAP203_HArray1OfDateTimeItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfDateTimeItem);
  }

export declare class StepAP203_ClassifiedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  AssemblyComponentUsage(): Handle_StepRepr_AssemblyComponentUsage;
  delete(): void;
}

export declare class StepAP203_Array1OfContractedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_ContractedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfContractedItem): StepAP203_Array1OfContractedItem;
  Move(theOther: StepAP203_Array1OfContractedItem): StepAP203_Array1OfContractedItem;
  First(): StepAP203_ContractedItem;
  ChangeFirst(): StepAP203_ContractedItem;
  Last(): StepAP203_ContractedItem;
  ChangeLast(): StepAP203_ContractedItem;
  Value(theIndex: Standard_Integer): StepAP203_ContractedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_ContractedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_ContractedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfContractedItem_1 extends StepAP203_Array1OfContractedItem {
    constructor();
  }

  export declare class StepAP203_Array1OfContractedItem_2 extends StepAP203_Array1OfContractedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfContractedItem_3 extends StepAP203_Array1OfContractedItem {
    constructor(theOther: StepAP203_Array1OfContractedItem);
  }

  export declare class StepAP203_Array1OfContractedItem_4 extends StepAP203_Array1OfContractedItem {
    constructor(theOther: StepAP203_Array1OfContractedItem);
  }

  export declare class StepAP203_Array1OfContractedItem_5 extends StepAP203_Array1OfContractedItem {
    constructor(theBegin: StepAP203_ContractedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_PersonOrganizationItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Change(): Handle_StepAP203_Change;
  StartWork(): Handle_StepAP203_StartWork;
  ChangeRequest(): Handle_StepAP203_ChangeRequest;
  StartRequest(): Handle_StepAP203_StartRequest;
  ConfigurationItem(): Handle_StepRepr_ConfigurationItem;
  Product(): Handle_StepBasic_Product;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  Contract(): Handle_StepBasic_Contract;
  SecurityClassification(): Handle_StepBasic_SecurityClassification;
  delete(): void;
}

export declare class Handle_StepAP203_HArray1OfStartRequestItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfStartRequestItem): void;
  get(): StepAP203_HArray1OfStartRequestItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfStartRequestItem_1 extends Handle_StepAP203_HArray1OfStartRequestItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfStartRequestItem_2 extends Handle_StepAP203_HArray1OfStartRequestItem {
    constructor(thePtr: StepAP203_HArray1OfStartRequestItem);
  }

  export declare class Handle_StepAP203_HArray1OfStartRequestItem_3 extends Handle_StepAP203_HArray1OfStartRequestItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfStartRequestItem);
  }

  export declare class Handle_StepAP203_HArray1OfStartRequestItem_4 extends Handle_StepAP203_HArray1OfStartRequestItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfStartRequestItem);
  }

export declare class StepAP203_Array1OfChangeRequestItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_ChangeRequestItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfChangeRequestItem): StepAP203_Array1OfChangeRequestItem;
  Move(theOther: StepAP203_Array1OfChangeRequestItem): StepAP203_Array1OfChangeRequestItem;
  First(): StepAP203_ChangeRequestItem;
  ChangeFirst(): StepAP203_ChangeRequestItem;
  Last(): StepAP203_ChangeRequestItem;
  ChangeLast(): StepAP203_ChangeRequestItem;
  Value(theIndex: Standard_Integer): StepAP203_ChangeRequestItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_ChangeRequestItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_ChangeRequestItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfChangeRequestItem_1 extends StepAP203_Array1OfChangeRequestItem {
    constructor();
  }

  export declare class StepAP203_Array1OfChangeRequestItem_2 extends StepAP203_Array1OfChangeRequestItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfChangeRequestItem_3 extends StepAP203_Array1OfChangeRequestItem {
    constructor(theOther: StepAP203_Array1OfChangeRequestItem);
  }

  export declare class StepAP203_Array1OfChangeRequestItem_4 extends StepAP203_Array1OfChangeRequestItem {
    constructor(theOther: StepAP203_Array1OfChangeRequestItem);
  }

  export declare class StepAP203_Array1OfChangeRequestItem_5 extends StepAP203_Array1OfChangeRequestItem {
    constructor(theBegin: StepAP203_ChangeRequestItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_Change extends StepBasic_ActionAssignment {
  constructor()
  Init(aActionAssignment_AssignedAction: Handle_StepBasic_Action, aItems: Handle_StepAP203_HArray1OfWorkItem): void;
  Items(): Handle_StepAP203_HArray1OfWorkItem;
  SetItems(Items: Handle_StepAP203_HArray1OfWorkItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_Change {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_Change): void;
  get(): StepAP203_Change;
  delete(): void;
}

  export declare class Handle_StepAP203_Change_1 extends Handle_StepAP203_Change {
    constructor();
  }

  export declare class Handle_StepAP203_Change_2 extends Handle_StepAP203_Change {
    constructor(thePtr: StepAP203_Change);
  }

  export declare class Handle_StepAP203_Change_3 extends Handle_StepAP203_Change {
    constructor(theHandle: Handle_StepAP203_Change);
  }

  export declare class Handle_StepAP203_Change_4 extends Handle_StepAP203_Change {
    constructor(theHandle: Handle_StepAP203_Change);
  }

export declare class Handle_StepAP203_HArray1OfPersonOrganizationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfPersonOrganizationItem): void;
  get(): StepAP203_HArray1OfPersonOrganizationItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfPersonOrganizationItem_1 extends Handle_StepAP203_HArray1OfPersonOrganizationItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfPersonOrganizationItem_2 extends Handle_StepAP203_HArray1OfPersonOrganizationItem {
    constructor(thePtr: StepAP203_HArray1OfPersonOrganizationItem);
  }

  export declare class Handle_StepAP203_HArray1OfPersonOrganizationItem_3 extends Handle_StepAP203_HArray1OfPersonOrganizationItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfPersonOrganizationItem);
  }

  export declare class Handle_StepAP203_HArray1OfPersonOrganizationItem_4 extends Handle_StepAP203_HArray1OfPersonOrganizationItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfPersonOrganizationItem);
  }

export declare class StepAP203_SpecifiedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ShapeAspect(): Handle_StepRepr_ShapeAspect;
  delete(): void;
}

export declare class StepAP203_Array1OfSpecifiedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_SpecifiedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfSpecifiedItem): StepAP203_Array1OfSpecifiedItem;
  Move(theOther: StepAP203_Array1OfSpecifiedItem): StepAP203_Array1OfSpecifiedItem;
  First(): StepAP203_SpecifiedItem;
  ChangeFirst(): StepAP203_SpecifiedItem;
  Last(): StepAP203_SpecifiedItem;
  ChangeLast(): StepAP203_SpecifiedItem;
  Value(theIndex: Standard_Integer): StepAP203_SpecifiedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_SpecifiedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_SpecifiedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfSpecifiedItem_1 extends StepAP203_Array1OfSpecifiedItem {
    constructor();
  }

  export declare class StepAP203_Array1OfSpecifiedItem_2 extends StepAP203_Array1OfSpecifiedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfSpecifiedItem_3 extends StepAP203_Array1OfSpecifiedItem {
    constructor(theOther: StepAP203_Array1OfSpecifiedItem);
  }

  export declare class StepAP203_Array1OfSpecifiedItem_4 extends StepAP203_Array1OfSpecifiedItem {
    constructor(theOther: StepAP203_Array1OfSpecifiedItem);
  }

  export declare class StepAP203_Array1OfSpecifiedItem_5 extends StepAP203_Array1OfSpecifiedItem {
    constructor(theBegin: StepAP203_SpecifiedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP203_HArray1OfSpecifiedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfSpecifiedItem): void;
  get(): StepAP203_HArray1OfSpecifiedItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfSpecifiedItem_1 extends Handle_StepAP203_HArray1OfSpecifiedItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfSpecifiedItem_2 extends Handle_StepAP203_HArray1OfSpecifiedItem {
    constructor(thePtr: StepAP203_HArray1OfSpecifiedItem);
  }

  export declare class Handle_StepAP203_HArray1OfSpecifiedItem_3 extends Handle_StepAP203_HArray1OfSpecifiedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfSpecifiedItem);
  }

  export declare class Handle_StepAP203_HArray1OfSpecifiedItem_4 extends Handle_StepAP203_HArray1OfSpecifiedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfSpecifiedItem);
  }

export declare class Handle_StepAP203_HArray1OfContractedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfContractedItem): void;
  get(): StepAP203_HArray1OfContractedItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfContractedItem_1 extends Handle_StepAP203_HArray1OfContractedItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfContractedItem_2 extends Handle_StepAP203_HArray1OfContractedItem {
    constructor(thePtr: StepAP203_HArray1OfContractedItem);
  }

  export declare class Handle_StepAP203_HArray1OfContractedItem_3 extends Handle_StepAP203_HArray1OfContractedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfContractedItem);
  }

  export declare class Handle_StepAP203_HArray1OfContractedItem_4 extends Handle_StepAP203_HArray1OfContractedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfContractedItem);
  }

export declare class Handle_StepAP203_HArray1OfApprovedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfApprovedItem): void;
  get(): StepAP203_HArray1OfApprovedItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfApprovedItem_1 extends Handle_StepAP203_HArray1OfApprovedItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfApprovedItem_2 extends Handle_StepAP203_HArray1OfApprovedItem {
    constructor(thePtr: StepAP203_HArray1OfApprovedItem);
  }

  export declare class Handle_StepAP203_HArray1OfApprovedItem_3 extends Handle_StepAP203_HArray1OfApprovedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfApprovedItem);
  }

  export declare class Handle_StepAP203_HArray1OfApprovedItem_4 extends Handle_StepAP203_HArray1OfApprovedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfApprovedItem);
  }

export declare class StepAP203_ChangeRequestItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  delete(): void;
}

export declare class Handle_StepAP203_HArray1OfWorkItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfWorkItem): void;
  get(): StepAP203_HArray1OfWorkItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfWorkItem_1 extends Handle_StepAP203_HArray1OfWorkItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfWorkItem_2 extends Handle_StepAP203_HArray1OfWorkItem {
    constructor(thePtr: StepAP203_HArray1OfWorkItem);
  }

  export declare class Handle_StepAP203_HArray1OfWorkItem_3 extends Handle_StepAP203_HArray1OfWorkItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfWorkItem);
  }

  export declare class Handle_StepAP203_HArray1OfWorkItem_4 extends Handle_StepAP203_HArray1OfWorkItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfWorkItem);
  }

export declare class StepAP203_Array1OfDateTimeItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_DateTimeItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfDateTimeItem): StepAP203_Array1OfDateTimeItem;
  Move(theOther: StepAP203_Array1OfDateTimeItem): StepAP203_Array1OfDateTimeItem;
  First(): StepAP203_DateTimeItem;
  ChangeFirst(): StepAP203_DateTimeItem;
  Last(): StepAP203_DateTimeItem;
  ChangeLast(): StepAP203_DateTimeItem;
  Value(theIndex: Standard_Integer): StepAP203_DateTimeItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_DateTimeItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_DateTimeItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfDateTimeItem_1 extends StepAP203_Array1OfDateTimeItem {
    constructor();
  }

  export declare class StepAP203_Array1OfDateTimeItem_2 extends StepAP203_Array1OfDateTimeItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfDateTimeItem_3 extends StepAP203_Array1OfDateTimeItem {
    constructor(theOther: StepAP203_Array1OfDateTimeItem);
  }

  export declare class StepAP203_Array1OfDateTimeItem_4 extends StepAP203_Array1OfDateTimeItem {
    constructor(theOther: StepAP203_Array1OfDateTimeItem);
  }

  export declare class StepAP203_Array1OfDateTimeItem_5 extends StepAP203_Array1OfDateTimeItem {
    constructor(theBegin: StepAP203_DateTimeItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_StartRequestItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  delete(): void;
}

export declare class StepAP203_ContractedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  delete(): void;
}

export declare class Handle_StepAP203_CcDesignApproval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignApproval): void;
  get(): StepAP203_CcDesignApproval;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignApproval_1 extends Handle_StepAP203_CcDesignApproval {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignApproval_2 extends Handle_StepAP203_CcDesignApproval {
    constructor(thePtr: StepAP203_CcDesignApproval);
  }

  export declare class Handle_StepAP203_CcDesignApproval_3 extends Handle_StepAP203_CcDesignApproval {
    constructor(theHandle: Handle_StepAP203_CcDesignApproval);
  }

  export declare class Handle_StepAP203_CcDesignApproval_4 extends Handle_StepAP203_CcDesignApproval {
    constructor(theHandle: Handle_StepAP203_CcDesignApproval);
  }

export declare class StepAP203_CcDesignApproval extends StepBasic_ApprovalAssignment {
  constructor()
  Init(aApprovalAssignment_AssignedApproval: Handle_StepBasic_Approval, aItems: Handle_StepAP203_HArray1OfApprovedItem): void;
  Items(): Handle_StepAP203_HArray1OfApprovedItem;
  SetItems(Items: Handle_StepAP203_HArray1OfApprovedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepAP203_WorkItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  delete(): void;
}

export declare class StepAP203_Array1OfPersonOrganizationItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_PersonOrganizationItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfPersonOrganizationItem): StepAP203_Array1OfPersonOrganizationItem;
  Move(theOther: StepAP203_Array1OfPersonOrganizationItem): StepAP203_Array1OfPersonOrganizationItem;
  First(): StepAP203_PersonOrganizationItem;
  ChangeFirst(): StepAP203_PersonOrganizationItem;
  Last(): StepAP203_PersonOrganizationItem;
  ChangeLast(): StepAP203_PersonOrganizationItem;
  Value(theIndex: Standard_Integer): StepAP203_PersonOrganizationItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_PersonOrganizationItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_PersonOrganizationItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfPersonOrganizationItem_1 extends StepAP203_Array1OfPersonOrganizationItem {
    constructor();
  }

  export declare class StepAP203_Array1OfPersonOrganizationItem_2 extends StepAP203_Array1OfPersonOrganizationItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfPersonOrganizationItem_3 extends StepAP203_Array1OfPersonOrganizationItem {
    constructor(theOther: StepAP203_Array1OfPersonOrganizationItem);
  }

  export declare class StepAP203_Array1OfPersonOrganizationItem_4 extends StepAP203_Array1OfPersonOrganizationItem {
    constructor(theOther: StepAP203_Array1OfPersonOrganizationItem);
  }

  export declare class StepAP203_Array1OfPersonOrganizationItem_5 extends StepAP203_Array1OfPersonOrganizationItem {
    constructor(theBegin: StepAP203_PersonOrganizationItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepAP203_HArray1OfClassifiedItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_HArray1OfClassifiedItem): void;
  get(): StepAP203_HArray1OfClassifiedItem;
  delete(): void;
}

  export declare class Handle_StepAP203_HArray1OfClassifiedItem_1 extends Handle_StepAP203_HArray1OfClassifiedItem {
    constructor();
  }

  export declare class Handle_StepAP203_HArray1OfClassifiedItem_2 extends Handle_StepAP203_HArray1OfClassifiedItem {
    constructor(thePtr: StepAP203_HArray1OfClassifiedItem);
  }

  export declare class Handle_StepAP203_HArray1OfClassifiedItem_3 extends Handle_StepAP203_HArray1OfClassifiedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfClassifiedItem);
  }

  export declare class Handle_StepAP203_HArray1OfClassifiedItem_4 extends Handle_StepAP203_HArray1OfClassifiedItem {
    constructor(theHandle: Handle_StepAP203_HArray1OfClassifiedItem);
  }

export declare class StepAP203_Array1OfApprovedItem {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepAP203_ApprovedItem): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepAP203_Array1OfApprovedItem): StepAP203_Array1OfApprovedItem;
  Move(theOther: StepAP203_Array1OfApprovedItem): StepAP203_Array1OfApprovedItem;
  First(): StepAP203_ApprovedItem;
  ChangeFirst(): StepAP203_ApprovedItem;
  Last(): StepAP203_ApprovedItem;
  ChangeLast(): StepAP203_ApprovedItem;
  Value(theIndex: Standard_Integer): StepAP203_ApprovedItem;
  ChangeValue(theIndex: Standard_Integer): StepAP203_ApprovedItem;
  SetValue(theIndex: Standard_Integer, theItem: StepAP203_ApprovedItem): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepAP203_Array1OfApprovedItem_1 extends StepAP203_Array1OfApprovedItem {
    constructor();
  }

  export declare class StepAP203_Array1OfApprovedItem_2 extends StepAP203_Array1OfApprovedItem {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepAP203_Array1OfApprovedItem_3 extends StepAP203_Array1OfApprovedItem {
    constructor(theOther: StepAP203_Array1OfApprovedItem);
  }

  export declare class StepAP203_Array1OfApprovedItem_4 extends StepAP203_Array1OfApprovedItem {
    constructor(theOther: StepAP203_Array1OfApprovedItem);
  }

  export declare class StepAP203_Array1OfApprovedItem_5 extends StepAP203_Array1OfApprovedItem {
    constructor(theBegin: StepAP203_ApprovedItem, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepAP203_ApprovedItem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ProductDefinitionFormation(): Handle_StepBasic_ProductDefinitionFormation;
  ProductDefinition(): Handle_StepBasic_ProductDefinition;
  ConfigurationEffectivity(): Handle_StepRepr_ConfigurationEffectivity;
  ConfigurationItem(): Handle_StepRepr_ConfigurationItem;
  SecurityClassification(): Handle_StepBasic_SecurityClassification;
  ChangeRequest(): Handle_StepAP203_ChangeRequest;
  Change(): Handle_StepAP203_Change;
  StartRequest(): Handle_StepAP203_StartRequest;
  StartWork(): Handle_StepAP203_StartWork;
  Certification(): Handle_StepBasic_Certification;
  Contract(): Handle_StepBasic_Contract;
  delete(): void;
}

export declare class StepAP203_CcDesignCertification extends StepBasic_CertificationAssignment {
  constructor()
  Init(aCertificationAssignment_AssignedCertification: Handle_StepBasic_Certification, aItems: Handle_StepAP203_HArray1OfCertifiedItem): void;
  Items(): Handle_StepAP203_HArray1OfCertifiedItem;
  SetItems(Items: Handle_StepAP203_HArray1OfCertifiedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_CcDesignCertification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignCertification): void;
  get(): StepAP203_CcDesignCertification;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignCertification_1 extends Handle_StepAP203_CcDesignCertification {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignCertification_2 extends Handle_StepAP203_CcDesignCertification {
    constructor(thePtr: StepAP203_CcDesignCertification);
  }

  export declare class Handle_StepAP203_CcDesignCertification_3 extends Handle_StepAP203_CcDesignCertification {
    constructor(theHandle: Handle_StepAP203_CcDesignCertification);
  }

  export declare class Handle_StepAP203_CcDesignCertification_4 extends Handle_StepAP203_CcDesignCertification {
    constructor(theHandle: Handle_StepAP203_CcDesignCertification);
  }

export declare class StepAP203_CcDesignContract extends StepBasic_ContractAssignment {
  constructor()
  Init(aContractAssignment_AssignedContract: Handle_StepBasic_Contract, aItems: Handle_StepAP203_HArray1OfContractedItem): void;
  Items(): Handle_StepAP203_HArray1OfContractedItem;
  SetItems(Items: Handle_StepAP203_HArray1OfContractedItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepAP203_CcDesignContract {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignContract): void;
  get(): StepAP203_CcDesignContract;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignContract_1 extends Handle_StepAP203_CcDesignContract {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignContract_2 extends Handle_StepAP203_CcDesignContract {
    constructor(thePtr: StepAP203_CcDesignContract);
  }

  export declare class Handle_StepAP203_CcDesignContract_3 extends Handle_StepAP203_CcDesignContract {
    constructor(theHandle: Handle_StepAP203_CcDesignContract);
  }

  export declare class Handle_StepAP203_CcDesignContract_4 extends Handle_StepAP203_CcDesignContract {
    constructor(theHandle: Handle_StepAP203_CcDesignContract);
  }

export declare class Handle_StepAP203_CcDesignPersonAndOrganizationAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepAP203_CcDesignPersonAndOrganizationAssignment): void;
  get(): StepAP203_CcDesignPersonAndOrganizationAssignment;
  delete(): void;
}

  export declare class Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_1 extends Handle_StepAP203_CcDesignPersonAndOrganizationAssignment {
    constructor();
  }

  export declare class Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_2 extends Handle_StepAP203_CcDesignPersonAndOrganizationAssignment {
    constructor(thePtr: StepAP203_CcDesignPersonAndOrganizationAssignment);
  }

  export declare class Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_3 extends Handle_StepAP203_CcDesignPersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepAP203_CcDesignPersonAndOrganizationAssignment);
  }

  export declare class Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_4 extends Handle_StepAP203_CcDesignPersonAndOrganizationAssignment {
    constructor(theHandle: Handle_StepAP203_CcDesignPersonAndOrganizationAssignment);
  }

export declare class StepAP203_CcDesignPersonAndOrganizationAssignment extends StepBasic_PersonAndOrganizationAssignment {
  constructor()
  Init(aPersonAndOrganizationAssignment_AssignedPersonAndOrganization: Handle_StepBasic_PersonAndOrganization, aPersonAndOrganizationAssignment_Role: Handle_StepBasic_PersonAndOrganizationRole, aItems: Handle_StepAP203_HArray1OfPersonOrganizationItem): void;
  Items(): Handle_StepAP203_HArray1OfPersonOrganizationItem;
  SetItems(Items: Handle_StepAP203_HArray1OfPersonOrganizationItem): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BRepAdaptor_HCurve2d extends Adaptor2d_HCurve2d {
  Set(C: BRepAdaptor_Curve2d): void;
  Curve2d(): Adaptor2d_Curve2d;
  ChangeCurve2d(): BRepAdaptor_Curve2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepAdaptor_HCurve2d_1 extends BRepAdaptor_HCurve2d {
    constructor();
  }

  export declare class BRepAdaptor_HCurve2d_2 extends BRepAdaptor_HCurve2d {
    constructor(C: BRepAdaptor_Curve2d);
  }

export declare class Handle_BRepAdaptor_HCurve2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepAdaptor_HCurve2d): void;
  get(): BRepAdaptor_HCurve2d;
  delete(): void;
}

  export declare class Handle_BRepAdaptor_HCurve2d_1 extends Handle_BRepAdaptor_HCurve2d {
    constructor();
  }

  export declare class Handle_BRepAdaptor_HCurve2d_2 extends Handle_BRepAdaptor_HCurve2d {
    constructor(thePtr: BRepAdaptor_HCurve2d);
  }

  export declare class Handle_BRepAdaptor_HCurve2d_3 extends Handle_BRepAdaptor_HCurve2d {
    constructor(theHandle: Handle_BRepAdaptor_HCurve2d);
  }

  export declare class Handle_BRepAdaptor_HCurve2d_4 extends Handle_BRepAdaptor_HCurve2d {
    constructor(theHandle: Handle_BRepAdaptor_HCurve2d);
  }

export declare class BRepAdaptor_HCurve extends Adaptor3d_HCurve {
  Set(C: BRepAdaptor_Curve): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): BRepAdaptor_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepAdaptor_HCurve_1 extends BRepAdaptor_HCurve {
    constructor();
  }

  export declare class BRepAdaptor_HCurve_2 extends BRepAdaptor_HCurve {
    constructor(C: BRepAdaptor_Curve);
  }

export declare class Handle_BRepAdaptor_HCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepAdaptor_HCurve): void;
  get(): BRepAdaptor_HCurve;
  delete(): void;
}

  export declare class Handle_BRepAdaptor_HCurve_1 extends Handle_BRepAdaptor_HCurve {
    constructor();
  }

  export declare class Handle_BRepAdaptor_HCurve_2 extends Handle_BRepAdaptor_HCurve {
    constructor(thePtr: BRepAdaptor_HCurve);
  }

  export declare class Handle_BRepAdaptor_HCurve_3 extends Handle_BRepAdaptor_HCurve {
    constructor(theHandle: Handle_BRepAdaptor_HCurve);
  }

  export declare class Handle_BRepAdaptor_HCurve_4 extends Handle_BRepAdaptor_HCurve {
    constructor(theHandle: Handle_BRepAdaptor_HCurve);
  }

export declare class BRepAdaptor_Curve2d extends Geom2dAdaptor_Curve {
  Initialize(E: TopoDS_Edge, F: TopoDS_Face): void;
  Edge(): TopoDS_Edge;
  Face(): TopoDS_Face;
  delete(): void;
}

  export declare class BRepAdaptor_Curve2d_1 extends BRepAdaptor_Curve2d {
    constructor();
  }

  export declare class BRepAdaptor_Curve2d_2 extends BRepAdaptor_Curve2d {
    constructor(E: TopoDS_Edge, F: TopoDS_Face);
  }

export declare class BRepAdaptor_Curve extends Adaptor3d_Curve {
  Reset(): void;
  Initialize_1(E: TopoDS_Edge): void;
  Initialize_2(E: TopoDS_Edge, F: TopoDS_Face): void;
  Trsf(): gp_Trsf;
  Is3DCurve(): Standard_Boolean;
  IsCurveOnSurface(): Standard_Boolean;
  Curve(): GeomAdaptor_Curve;
  CurveOnSurface(): Adaptor3d_CurveOnSurface;
  Edge(): TopoDS_Edge;
  Tolerance(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  OffsetCurve(): Handle_Geom_OffsetCurve;
  delete(): void;
}

  export declare class BRepAdaptor_Curve_1 extends BRepAdaptor_Curve {
    constructor();
  }

  export declare class BRepAdaptor_Curve_2 extends BRepAdaptor_Curve {
    constructor(E: TopoDS_Edge);
  }

  export declare class BRepAdaptor_Curve_3 extends BRepAdaptor_Curve {
    constructor(E: TopoDS_Edge, F: TopoDS_Face);
  }

export declare class BRepAdaptor_Array1OfCurve {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: BRepAdaptor_Curve): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: BRepAdaptor_Array1OfCurve): BRepAdaptor_Array1OfCurve;
  Move(theOther: BRepAdaptor_Array1OfCurve): BRepAdaptor_Array1OfCurve;
  First(): BRepAdaptor_Curve;
  ChangeFirst(): BRepAdaptor_Curve;
  Last(): BRepAdaptor_Curve;
  ChangeLast(): BRepAdaptor_Curve;
  Value(theIndex: Standard_Integer): BRepAdaptor_Curve;
  ChangeValue(theIndex: Standard_Integer): BRepAdaptor_Curve;
  SetValue(theIndex: Standard_Integer, theItem: BRepAdaptor_Curve): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class BRepAdaptor_Array1OfCurve_1 extends BRepAdaptor_Array1OfCurve {
    constructor();
  }

  export declare class BRepAdaptor_Array1OfCurve_2 extends BRepAdaptor_Array1OfCurve {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class BRepAdaptor_Array1OfCurve_3 extends BRepAdaptor_Array1OfCurve {
    constructor(theOther: BRepAdaptor_Array1OfCurve);
  }

  export declare class BRepAdaptor_Array1OfCurve_4 extends BRepAdaptor_Array1OfCurve {
    constructor(theOther: BRepAdaptor_Array1OfCurve);
  }

  export declare class BRepAdaptor_Array1OfCurve_5 extends BRepAdaptor_Array1OfCurve {
    constructor(theBegin: BRepAdaptor_Curve, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_BRepAdaptor_HArray1OfCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepAdaptor_HArray1OfCurve): void;
  get(): BRepAdaptor_HArray1OfCurve;
  delete(): void;
}

  export declare class Handle_BRepAdaptor_HArray1OfCurve_1 extends Handle_BRepAdaptor_HArray1OfCurve {
    constructor();
  }

  export declare class Handle_BRepAdaptor_HArray1OfCurve_2 extends Handle_BRepAdaptor_HArray1OfCurve {
    constructor(thePtr: BRepAdaptor_HArray1OfCurve);
  }

  export declare class Handle_BRepAdaptor_HArray1OfCurve_3 extends Handle_BRepAdaptor_HArray1OfCurve {
    constructor(theHandle: Handle_BRepAdaptor_HArray1OfCurve);
  }

  export declare class Handle_BRepAdaptor_HArray1OfCurve_4 extends Handle_BRepAdaptor_HArray1OfCurve {
    constructor(theHandle: Handle_BRepAdaptor_HArray1OfCurve);
  }

export declare class BRepAdaptor_CompCurve extends Adaptor3d_Curve {
  Initialize_1(W: TopoDS_Wire, KnotByCurvilinearAbcissa: Standard_Boolean): void;
  Initialize_2(W: TopoDS_Wire, KnotByCurvilinearAbcissa: Standard_Boolean, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): void;
  Wire(): TopoDS_Wire;
  Edge(U: Quantity_AbsorbedDose, E: TopoDS_Edge, UonE: Quantity_AbsorbedDose): void;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt, V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Degree(): Graphic3d_ZLayerId;
  IsRational(): Standard_Boolean;
  NbPoles(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

  export declare class BRepAdaptor_CompCurve_1 extends BRepAdaptor_CompCurve {
    constructor();
  }

  export declare class BRepAdaptor_CompCurve_2 extends BRepAdaptor_CompCurve {
    constructor(W: TopoDS_Wire, KnotByCurvilinearAbcissa: Standard_Boolean);
  }

  export declare class BRepAdaptor_CompCurve_3 extends BRepAdaptor_CompCurve {
    constructor(W: TopoDS_Wire, KnotByCurvilinearAbcissa: Standard_Boolean, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose);
  }

export declare class BRepAdaptor_Surface extends Adaptor3d_Surface {
  Initialize(F: TopoDS_Face, Restriction: Standard_Boolean): void;
  Surface(): GeomAdaptor_Surface;
  ChangeSurface(): GeomAdaptor_Surface;
  Trsf(): gp_Trsf;
  Face(): TopoDS_Face;
  Tolerance(): Quantity_AbsorbedDose;
  FirstUParameter(): Quantity_AbsorbedDose;
  LastUParameter(): Quantity_AbsorbedDose;
  FirstVParameter(): Quantity_AbsorbedDose;
  LastVParameter(): Quantity_AbsorbedDose;
  UContinuity(): GeomAbs_Shape;
  VContinuity(): GeomAbs_Shape;
  NbUIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  NbVIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  UIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  VIntervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  UTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  VTrim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HSurface;
  IsUClosed(): Standard_Boolean;
  IsVClosed(): Standard_Boolean;
  IsUPeriodic(): Standard_Boolean;
  UPeriod(): Quantity_AbsorbedDose;
  IsVPeriodic(): Standard_Boolean;
  VPeriod(): Quantity_AbsorbedDose;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  D0(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  D2(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec): void;
  D3(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec, D2U: gp_Vec, D2V: gp_Vec, D2UV: gp_Vec, D3U: gp_Vec, D3V: gp_Vec, D3UUV: gp_Vec, D3UVV: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  UResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  VResolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Sphere(): gp_Sphere;
  Torus(): gp_Torus;
  UDegree(): Graphic3d_ZLayerId;
  NbUPoles(): Graphic3d_ZLayerId;
  VDegree(): Graphic3d_ZLayerId;
  NbVPoles(): Graphic3d_ZLayerId;
  NbUKnots(): Graphic3d_ZLayerId;
  NbVKnots(): Graphic3d_ZLayerId;
  IsURational(): Standard_Boolean;
  IsVRational(): Standard_Boolean;
  Bezier(): Handle_Geom_BezierSurface;
  BSpline(): Handle_Geom_BSplineSurface;
  AxeOfRevolution(): gp_Ax1;
  Direction(): gp_Dir;
  BasisCurve(): Handle_Adaptor3d_HCurve;
  BasisSurface(): Handle_Adaptor3d_HSurface;
  OffsetValue(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepAdaptor_Surface_1 extends BRepAdaptor_Surface {
    constructor();
  }

  export declare class BRepAdaptor_Surface_2 extends BRepAdaptor_Surface {
    constructor(F: TopoDS_Face, R: Standard_Boolean);
  }

export declare class Handle_BRepAdaptor_HSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepAdaptor_HSurface): void;
  get(): BRepAdaptor_HSurface;
  delete(): void;
}

  export declare class Handle_BRepAdaptor_HSurface_1 extends Handle_BRepAdaptor_HSurface {
    constructor();
  }

  export declare class Handle_BRepAdaptor_HSurface_2 extends Handle_BRepAdaptor_HSurface {
    constructor(thePtr: BRepAdaptor_HSurface);
  }

  export declare class Handle_BRepAdaptor_HSurface_3 extends Handle_BRepAdaptor_HSurface {
    constructor(theHandle: Handle_BRepAdaptor_HSurface);
  }

  export declare class Handle_BRepAdaptor_HSurface_4 extends Handle_BRepAdaptor_HSurface {
    constructor(theHandle: Handle_BRepAdaptor_HSurface);
  }

export declare class BRepAdaptor_HSurface extends Adaptor3d_HSurface {
  Set(S: BRepAdaptor_Surface): void;
  Surface(): Adaptor3d_Surface;
  ChangeSurface(): BRepAdaptor_Surface;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepAdaptor_HSurface_1 extends BRepAdaptor_HSurface {
    constructor();
  }

  export declare class BRepAdaptor_HSurface_2 extends BRepAdaptor_HSurface {
    constructor(S: BRepAdaptor_Surface);
  }

export declare class BRepAdaptor_HCompCurve extends Adaptor3d_HCurve {
  Set(C: BRepAdaptor_CompCurve): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): BRepAdaptor_CompCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class BRepAdaptor_HCompCurve_1 extends BRepAdaptor_HCompCurve {
    constructor();
  }

  export declare class BRepAdaptor_HCompCurve_2 extends BRepAdaptor_HCompCurve {
    constructor(C: BRepAdaptor_CompCurve);
  }

export declare class Handle_BRepAdaptor_HCompCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: BRepAdaptor_HCompCurve): void;
  get(): BRepAdaptor_HCompCurve;
  delete(): void;
}

  export declare class Handle_BRepAdaptor_HCompCurve_1 extends Handle_BRepAdaptor_HCompCurve {
    constructor();
  }

  export declare class Handle_BRepAdaptor_HCompCurve_2 extends Handle_BRepAdaptor_HCompCurve {
    constructor(thePtr: BRepAdaptor_HCompCurve);
  }

  export declare class Handle_BRepAdaptor_HCompCurve_3 extends Handle_BRepAdaptor_HCompCurve {
    constructor(theHandle: Handle_BRepAdaptor_HCompCurve);
  }

  export declare class Handle_BRepAdaptor_HCompCurve_4 extends Handle_BRepAdaptor_HCompCurve {
    constructor(theHandle: Handle_BRepAdaptor_HCompCurve);
  }

export declare class TDF_CopyTool {
  constructor();
  static Copy_1(aSourceDataSet: Handle_TDF_DataSet, aRelocationTable: Handle_TDF_RelocationTable): void;
  static Copy_2(aSourceDataSet: Handle_TDF_DataSet, aRelocationTable: Handle_TDF_RelocationTable, aPrivilegeFilter: TDF_IDFilter): void;
  static Copy_3(aSourceDataSet: Handle_TDF_DataSet, aRelocationTable: Handle_TDF_RelocationTable, aPrivilegeFilter: TDF_IDFilter, aRefFilter: TDF_IDFilter, setSelfContained: Standard_Boolean): void;
  delete(): void;
}

export declare class TDF_Delta extends Standard_Transient {
  constructor()
  IsEmpty(): Standard_Boolean;
  IsApplicable(aCurrentTime: Graphic3d_ZLayerId): Standard_Boolean;
  BeginTime(): Graphic3d_ZLayerId;
  EndTime(): Graphic3d_ZLayerId;
  Labels(aLabelList: TDF_LabelList): void;
  AttributeDeltas(): TDF_AttributeDeltaList;
  Name(): TCollection_ExtendedString;
  SetName(theName: TCollection_ExtendedString): void;
  Dump(OS: Standard_OStream): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_Delta {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_Delta): void;
  get(): TDF_Delta;
  delete(): void;
}

  export declare class Handle_TDF_Delta_1 extends Handle_TDF_Delta {
    constructor();
  }

  export declare class Handle_TDF_Delta_2 extends Handle_TDF_Delta {
    constructor(thePtr: TDF_Delta);
  }

  export declare class Handle_TDF_Delta_3 extends Handle_TDF_Delta {
    constructor(theHandle: Handle_TDF_Delta);
  }

  export declare class Handle_TDF_Delta_4 extends Handle_TDF_Delta {
    constructor(theHandle: Handle_TDF_Delta);
  }

export declare class TDF_DefaultDeltaOnRemoval extends TDF_DeltaOnRemoval {
  constructor(anAttribute: Handle_TDF_Attribute)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_DefaultDeltaOnRemoval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DefaultDeltaOnRemoval): void;
  get(): TDF_DefaultDeltaOnRemoval;
  delete(): void;
}

  export declare class Handle_TDF_DefaultDeltaOnRemoval_1 extends Handle_TDF_DefaultDeltaOnRemoval {
    constructor();
  }

  export declare class Handle_TDF_DefaultDeltaOnRemoval_2 extends Handle_TDF_DefaultDeltaOnRemoval {
    constructor(thePtr: TDF_DefaultDeltaOnRemoval);
  }

  export declare class Handle_TDF_DefaultDeltaOnRemoval_3 extends Handle_TDF_DefaultDeltaOnRemoval {
    constructor(theHandle: Handle_TDF_DefaultDeltaOnRemoval);
  }

  export declare class Handle_TDF_DefaultDeltaOnRemoval_4 extends Handle_TDF_DefaultDeltaOnRemoval {
    constructor(theHandle: Handle_TDF_DefaultDeltaOnRemoval);
  }

export declare class TDF_AttributeIterator {
  Initialize(aLabel: TDF_Label, withoutForgotten: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_TDF_Attribute;
  PtrValue(): TDF_Attribute;
  delete(): void;
}

  export declare class TDF_AttributeIterator_1 extends TDF_AttributeIterator {
    constructor();
  }

  export declare class TDF_AttributeIterator_2 extends TDF_AttributeIterator {
    constructor(aLabel: TDF_Label, withoutForgotten: Standard_Boolean);
  }

  export declare class TDF_AttributeIterator_3 extends TDF_AttributeIterator {
    constructor(aLabelNode: TDF_LabelNodePtr, withoutForgotten: Standard_Boolean);
  }

export declare class TDF_ClosureTool {
  constructor();
  static Closure_1(aDataSet: Handle_TDF_DataSet): void;
  static Closure_2(aDataSet: Handle_TDF_DataSet, aFilter: TDF_IDFilter, aMode: TDF_ClosureMode): void;
  static Closure_3(aLabel: TDF_Label, aLabMap: TDF_LabelMap, anAttMap: TDF_AttributeMap, aFilter: TDF_IDFilter, aMode: TDF_ClosureMode): void;
  delete(): void;
}

export declare class TDF_DeltaOnModification extends TDF_AttributeDelta {
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_DeltaOnModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DeltaOnModification): void;
  get(): TDF_DeltaOnModification;
  delete(): void;
}

  export declare class Handle_TDF_DeltaOnModification_1 extends Handle_TDF_DeltaOnModification {
    constructor();
  }

  export declare class Handle_TDF_DeltaOnModification_2 extends Handle_TDF_DeltaOnModification {
    constructor(thePtr: TDF_DeltaOnModification);
  }

  export declare class Handle_TDF_DeltaOnModification_3 extends Handle_TDF_DeltaOnModification {
    constructor(theHandle: Handle_TDF_DeltaOnModification);
  }

  export declare class Handle_TDF_DeltaOnModification_4 extends Handle_TDF_DeltaOnModification {
    constructor(theHandle: Handle_TDF_DeltaOnModification);
  }

export declare class TDF_Data extends Standard_Transient {
  constructor()
  Root(): TDF_Label;
  Transaction(): Graphic3d_ZLayerId;
  Time(): Graphic3d_ZLayerId;
  IsApplicable(aDelta: Handle_TDF_Delta): Standard_Boolean;
  Undo(aDelta: Handle_TDF_Delta, withDelta: Standard_Boolean): Handle_TDF_Delta;
  Destroy(): void;
  NotUndoMode(): Standard_Boolean;
  AllowModification(isAllowed: Standard_Boolean): void;
  IsModificationAllowed(): Standard_Boolean;
  LabelNodeAllocator(): TDF_HAllocator;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_Data {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_Data): void;
  get(): TDF_Data;
  delete(): void;
}

  export declare class Handle_TDF_Data_1 extends Handle_TDF_Data {
    constructor();
  }

  export declare class Handle_TDF_Data_2 extends Handle_TDF_Data {
    constructor(thePtr: TDF_Data);
  }

  export declare class Handle_TDF_Data_3 extends Handle_TDF_Data {
    constructor(theHandle: Handle_TDF_Data);
  }

  export declare class Handle_TDF_Data_4 extends Handle_TDF_Data {
    constructor(theHandle: Handle_TDF_Data);
  }

export declare class Handle_TDF_DeltaOnRemoval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DeltaOnRemoval): void;
  get(): TDF_DeltaOnRemoval;
  delete(): void;
}

  export declare class Handle_TDF_DeltaOnRemoval_1 extends Handle_TDF_DeltaOnRemoval {
    constructor();
  }

  export declare class Handle_TDF_DeltaOnRemoval_2 extends Handle_TDF_DeltaOnRemoval {
    constructor(thePtr: TDF_DeltaOnRemoval);
  }

  export declare class Handle_TDF_DeltaOnRemoval_3 extends Handle_TDF_DeltaOnRemoval {
    constructor(theHandle: Handle_TDF_DeltaOnRemoval);
  }

  export declare class Handle_TDF_DeltaOnRemoval_4 extends Handle_TDF_DeltaOnRemoval {
    constructor(theHandle: Handle_TDF_DeltaOnRemoval);
  }

export declare class TDF_DeltaOnRemoval extends TDF_AttributeDelta {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDF_ChildIDIterator {
  Initialize(aLabel: TDF_Label, anID: Standard_GUID, allLevels: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  NextBrother(): void;
  Value(): Handle_TDF_Attribute;
  delete(): void;
}

  export declare class TDF_ChildIDIterator_1 extends TDF_ChildIDIterator {
    constructor();
  }

  export declare class TDF_ChildIDIterator_2 extends TDF_ChildIDIterator {
    constructor(aLabel: TDF_Label, anID: Standard_GUID, allLevels: Standard_Boolean);
  }

export declare class TDF_GUIDProgIDMap extends NCollection_BaseMap {
  Exchange(theOther: TDF_GUIDProgIDMap): void;
  Assign(theOther: TDF_GUIDProgIDMap): TDF_GUIDProgIDMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey1: Standard_GUID, theKey2: TCollection_ExtendedString): void;
  AreBound(theKey1: Standard_GUID, theKey2: TCollection_ExtendedString): Standard_Boolean;
  IsBound1(theKey1: Standard_GUID): Standard_Boolean;
  IsBound2(theKey2: TCollection_ExtendedString): Standard_Boolean;
  UnBind1(theKey1: Standard_GUID): Standard_Boolean;
  UnBind2(theKey2: TCollection_ExtendedString): Standard_Boolean;
  Find1_1(theKey1: Standard_GUID): TCollection_ExtendedString;
  Find1_2(theKey1: Standard_GUID, theKey2: TCollection_ExtendedString): Standard_Boolean;
  Seek1(theKey1: Standard_GUID): TCollection_ExtendedString;
  Find2_1(theKey2: TCollection_ExtendedString): Standard_GUID;
  Find2_2(theKey2: TCollection_ExtendedString, theKey1: Standard_GUID): Standard_Boolean;
  Seek2(theKey2: TCollection_ExtendedString): Standard_GUID;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDF_GUIDProgIDMap_1 extends TDF_GUIDProgIDMap {
    constructor();
  }

  export declare class TDF_GUIDProgIDMap_2 extends TDF_GUIDProgIDMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_GUIDProgIDMap_3 extends TDF_GUIDProgIDMap {
    constructor(theOther: TDF_GUIDProgIDMap);
  }

export declare class Handle_TDF_DefaultDeltaOnModification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DefaultDeltaOnModification): void;
  get(): TDF_DefaultDeltaOnModification;
  delete(): void;
}

  export declare class Handle_TDF_DefaultDeltaOnModification_1 extends Handle_TDF_DefaultDeltaOnModification {
    constructor();
  }

  export declare class Handle_TDF_DefaultDeltaOnModification_2 extends Handle_TDF_DefaultDeltaOnModification {
    constructor(thePtr: TDF_DefaultDeltaOnModification);
  }

  export declare class Handle_TDF_DefaultDeltaOnModification_3 extends Handle_TDF_DefaultDeltaOnModification {
    constructor(theHandle: Handle_TDF_DefaultDeltaOnModification);
  }

  export declare class Handle_TDF_DefaultDeltaOnModification_4 extends Handle_TDF_DefaultDeltaOnModification {
    constructor(theHandle: Handle_TDF_DefaultDeltaOnModification);
  }

export declare class TDF_DefaultDeltaOnModification extends TDF_DeltaOnModification {
  constructor(anAttribute: Handle_TDF_Attribute)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDF_LabelIntegerMap extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDF_LabelIntegerMap): void;
  Assign(theOther: TDF_LabelIntegerMap): TDF_LabelIntegerMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TDF_Label, theItem: Standard_Integer): Standard_Boolean;
  Bound(theKey: TDF_Label, theItem: Standard_Integer): Standard_Integer;
  IsBound(theKey: TDF_Label): Standard_Boolean;
  UnBind(theKey: TDF_Label): Standard_Boolean;
  Seek(theKey: TDF_Label): Standard_Integer;
  ChangeSeek(theKey: TDF_Label): Standard_Integer;
  ChangeFind(theKey: TDF_Label): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDF_LabelIntegerMap_1 extends TDF_LabelIntegerMap {
    constructor();
  }

  export declare class TDF_LabelIntegerMap_2 extends TDF_LabelIntegerMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelIntegerMap_3 extends TDF_LabelIntegerMap {
    constructor(theOther: TDF_LabelIntegerMap);
  }

export declare class TDF_CopyLabel {
  Load(aSource: TDF_Label, aTarget: TDF_Label): void;
  UseFilter(aFilter: TDF_IDFilter): void;
  static ExternalReferences_1(Lab: TDF_Label, aExternals: TDF_AttributeMap, aFilter: TDF_IDFilter): Standard_Boolean;
  static ExternalReferences_2(aRefLab: TDF_Label, Lab: TDF_Label, aExternals: TDF_AttributeMap, aFilter: TDF_IDFilter, aDataSet: Handle_TDF_DataSet): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  RelocationTable(): Handle_TDF_RelocationTable;
  delete(): void;
}

  export declare class TDF_CopyLabel_1 extends TDF_CopyLabel {
    constructor();
  }

  export declare class TDF_CopyLabel_2 extends TDF_CopyLabel {
    constructor(aSource: TDF_Label, aTarget: TDF_Label);
  }

export declare class Handle_TDF_RelocationTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_RelocationTable): void;
  get(): TDF_RelocationTable;
  delete(): void;
}

  export declare class Handle_TDF_RelocationTable_1 extends Handle_TDF_RelocationTable {
    constructor();
  }

  export declare class Handle_TDF_RelocationTable_2 extends Handle_TDF_RelocationTable {
    constructor(thePtr: TDF_RelocationTable);
  }

  export declare class Handle_TDF_RelocationTable_3 extends Handle_TDF_RelocationTable {
    constructor(theHandle: Handle_TDF_RelocationTable);
  }

  export declare class Handle_TDF_RelocationTable_4 extends Handle_TDF_RelocationTable {
    constructor(theHandle: Handle_TDF_RelocationTable);
  }

export declare class TDF_RelocationTable extends Standard_Transient {
  constructor(selfRelocate: Standard_Boolean)
  SelfRelocate_1(selfRelocate: Standard_Boolean): void;
  SelfRelocate_2(): Standard_Boolean;
  AfterRelocate_1(afterRelocate: Standard_Boolean): void;
  AfterRelocate_2(): Standard_Boolean;
  SetRelocation_1(aSourceLabel: TDF_Label, aTargetLabel: TDF_Label): void;
  HasRelocation_1(aSourceLabel: TDF_Label, aTargetLabel: TDF_Label): Standard_Boolean;
  SetRelocation_2(aSourceAttribute: Handle_TDF_Attribute, aTargetAttribute: Handle_TDF_Attribute): void;
  HasRelocation_2(aSourceAttribute: Handle_TDF_Attribute, aTargetAttribute: Handle_TDF_Attribute): Standard_Boolean;
  SetTransientRelocation(aSourceTransient: Handle_Standard_Transient, aTargetTransient: Handle_Standard_Transient): void;
  HasTransientRelocation(aSourceTransient: Handle_Standard_Transient, aTargetTransient: Handle_Standard_Transient): Standard_Boolean;
  Clear(): void;
  TargetLabelMap(aLabelMap: TDF_LabelMap): void;
  TargetAttributeMap(anAttributeMap: TDF_AttributeMap): void;
  LabelTable(): TDF_LabelDataMap;
  AttributeTable(): TDF_AttributeDataMap;
  TransientTable(): TColStd_IndexedDataMapOfTransientTransient;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDF_DerivedAttribute {
  constructor();
  static Register(theNewAttributeFunction: any, theNameSpace: Standard_CString, theTypeName: Standard_CString): any;
  static Attribute(theType: Standard_CString): Handle_TDF_Attribute;
  static TypeName(theType: Standard_CString): XCAFDoc_PartId;
  static Attributes(theList: TDF_AttributeList): void;
  delete(): void;
}

export declare class TDF_ClosureMode {
  constructor(aMode: Standard_Boolean)
  Descendants_1(aStatus: Standard_Boolean): void;
  Descendants_2(): Standard_Boolean;
  References_1(aStatus: Standard_Boolean): void;
  References_2(): Standard_Boolean;
  delete(): void;
}

export declare class TDF_LabelSequence extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: TDF_LabelSequence): TDF_LabelSequence;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TDF_Label): void;
  Append_2(theSeq: TDF_LabelSequence): void;
  Prepend_1(theItem: TDF_Label): void;
  Prepend_2(theSeq: TDF_LabelSequence): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TDF_Label): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: TDF_LabelSequence): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: TDF_LabelSequence): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TDF_Label): void;
  Split(theIndex: Standard_Integer, theSeq: TDF_LabelSequence): void;
  First(): TDF_Label;
  ChangeFirst(): TDF_Label;
  Last(): TDF_Label;
  ChangeLast(): TDF_Label;
  Value(theIndex: Standard_Integer): TDF_Label;
  ChangeValue(theIndex: Standard_Integer): TDF_Label;
  SetValue(theIndex: Standard_Integer, theItem: TDF_Label): void;
  delete(): void;
}

  export declare class TDF_LabelSequence_1 extends TDF_LabelSequence {
    constructor();
  }

  export declare class TDF_LabelSequence_2 extends TDF_LabelSequence {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelSequence_3 extends TDF_LabelSequence {
    constructor(theOther: TDF_LabelSequence);
  }

export declare class TDF_LabelDataMap extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDF_LabelDataMap): void;
  Assign(theOther: TDF_LabelDataMap): TDF_LabelDataMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TDF_Label, theItem: TDF_Label): Standard_Boolean;
  Bound(theKey: TDF_Label, theItem: TDF_Label): TDF_Label;
  IsBound(theKey: TDF_Label): Standard_Boolean;
  UnBind(theKey: TDF_Label): Standard_Boolean;
  Seek(theKey: TDF_Label): TDF_Label;
  ChangeSeek(theKey: TDF_Label): TDF_Label;
  ChangeFind(theKey: TDF_Label): TDF_Label;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDF_LabelDataMap_1 extends TDF_LabelDataMap {
    constructor();
  }

  export declare class TDF_LabelDataMap_2 extends TDF_LabelDataMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelDataMap_3 extends TDF_LabelDataMap {
    constructor(theOther: TDF_LabelDataMap);
  }

export declare class TDF_LabelIndexedMap extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDF_LabelIndexedMap): void;
  Assign(theOther: TDF_LabelIndexedMap): TDF_LabelIndexedMap;
  ReSize(theExtent: Standard_Integer): void;
  Add(theKey1: TDF_Label): Standard_Integer;
  Contains(theKey1: TDF_Label): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TDF_Label): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TDF_Label): Standard_Boolean;
  FindKey(theIndex: Standard_Integer): TDF_Label;
  FindIndex(theKey1: TDF_Label): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDF_LabelIndexedMap_1 extends TDF_LabelIndexedMap {
    constructor();
  }

  export declare class TDF_LabelIndexedMap_2 extends TDF_LabelIndexedMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelIndexedMap_3 extends TDF_LabelIndexedMap {
    constructor(theOther: TDF_LabelIndexedMap);
  }

export declare class TDF_LabelDoubleMap extends NCollection_BaseMap {
  Exchange(theOther: TDF_LabelDoubleMap): void;
  Assign(theOther: TDF_LabelDoubleMap): TDF_LabelDoubleMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey1: TDF_Label, theKey2: TDF_Label): void;
  AreBound(theKey1: TDF_Label, theKey2: TDF_Label): Standard_Boolean;
  IsBound1(theKey1: TDF_Label): Standard_Boolean;
  IsBound2(theKey2: TDF_Label): Standard_Boolean;
  UnBind1(theKey1: TDF_Label): Standard_Boolean;
  UnBind2(theKey2: TDF_Label): Standard_Boolean;
  Find1_1(theKey1: TDF_Label): TDF_Label;
  Find1_2(theKey1: TDF_Label, theKey2: TDF_Label): Standard_Boolean;
  Seek1(theKey1: TDF_Label): TDF_Label;
  Find2_1(theKey2: TDF_Label): TDF_Label;
  Find2_2(theKey2: TDF_Label, theKey1: TDF_Label): Standard_Boolean;
  Seek2(theKey2: TDF_Label): TDF_Label;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class TDF_LabelDoubleMap_1 extends TDF_LabelDoubleMap {
    constructor();
  }

  export declare class TDF_LabelDoubleMap_2 extends TDF_LabelDoubleMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelDoubleMap_3 extends TDF_LabelDoubleMap {
    constructor(theOther: TDF_LabelDoubleMap);
  }

export declare class Handle_TDF_HAttributeArray1 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_HAttributeArray1): void;
  get(): TDF_HAttributeArray1;
  delete(): void;
}

  export declare class Handle_TDF_HAttributeArray1_1 extends Handle_TDF_HAttributeArray1 {
    constructor();
  }

  export declare class Handle_TDF_HAttributeArray1_2 extends Handle_TDF_HAttributeArray1 {
    constructor(thePtr: TDF_HAttributeArray1);
  }

  export declare class Handle_TDF_HAttributeArray1_3 extends Handle_TDF_HAttributeArray1 {
    constructor(theHandle: Handle_TDF_HAttributeArray1);
  }

  export declare class Handle_TDF_HAttributeArray1_4 extends Handle_TDF_HAttributeArray1 {
    constructor(theHandle: Handle_TDF_HAttributeArray1);
  }

export declare class TDF_LabelMapHasher {
  constructor();
  static HashCode(theLabel: TDF_Label, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(aLab1: TDF_Label, aLab2: TDF_Label): Standard_Boolean;
  delete(): void;
}

export declare class TDF_DeltaOnForget extends TDF_AttributeDelta {
  constructor(anAtt: Handle_TDF_Attribute)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_DeltaOnForget {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DeltaOnForget): void;
  get(): TDF_DeltaOnForget;
  delete(): void;
}

  export declare class Handle_TDF_DeltaOnForget_1 extends Handle_TDF_DeltaOnForget {
    constructor();
  }

  export declare class Handle_TDF_DeltaOnForget_2 extends Handle_TDF_DeltaOnForget {
    constructor(thePtr: TDF_DeltaOnForget);
  }

  export declare class Handle_TDF_DeltaOnForget_3 extends Handle_TDF_DeltaOnForget {
    constructor(theHandle: Handle_TDF_DeltaOnForget);
  }

  export declare class Handle_TDF_DeltaOnForget_4 extends Handle_TDF_DeltaOnForget {
    constructor(theHandle: Handle_TDF_DeltaOnForget);
  }

export declare class TDF_DeltaOnResume extends TDF_AttributeDelta {
  constructor(anAtt: Handle_TDF_Attribute)
  Apply(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_DeltaOnResume {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DeltaOnResume): void;
  get(): TDF_DeltaOnResume;
  delete(): void;
}

  export declare class Handle_TDF_DeltaOnResume_1 extends Handle_TDF_DeltaOnResume {
    constructor();
  }

  export declare class Handle_TDF_DeltaOnResume_2 extends Handle_TDF_DeltaOnResume {
    constructor(thePtr: TDF_DeltaOnResume);
  }

  export declare class Handle_TDF_DeltaOnResume_3 extends Handle_TDF_DeltaOnResume {
    constructor(theHandle: Handle_TDF_DeltaOnResume);
  }

  export declare class Handle_TDF_DeltaOnResume_4 extends Handle_TDF_DeltaOnResume {
    constructor(theHandle: Handle_TDF_DeltaOnResume);
  }

export declare class TDF_LabelMap extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDF_LabelMap): void;
  Assign(theOther: TDF_LabelMap): TDF_LabelMap;
  ReSize(N: Standard_Integer): void;
  Add(K: TDF_Label): Standard_Boolean;
  Added(K: TDF_Label): TDF_Label;
  Contains_1(K: TDF_Label): Standard_Boolean;
  Remove(K: TDF_Label): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: TDF_LabelMap): Standard_Boolean;
  Contains_2(theOther: TDF_LabelMap): Standard_Boolean;
  Union(theLeft: TDF_LabelMap, theRight: TDF_LabelMap): void;
  Unite(theOther: TDF_LabelMap): Standard_Boolean;
  HasIntersection(theMap: TDF_LabelMap): Standard_Boolean;
  Intersection(theLeft: TDF_LabelMap, theRight: TDF_LabelMap): void;
  Intersect(theOther: TDF_LabelMap): Standard_Boolean;
  Subtraction(theLeft: TDF_LabelMap, theRight: TDF_LabelMap): void;
  Subtract(theOther: TDF_LabelMap): Standard_Boolean;
  Difference(theLeft: TDF_LabelMap, theRight: TDF_LabelMap): void;
  Differ(theOther: TDF_LabelMap): Standard_Boolean;
  delete(): void;
}

  export declare class TDF_LabelMap_1 extends TDF_LabelMap {
    constructor();
  }

  export declare class TDF_LabelMap_2 extends TDF_LabelMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelMap_3 extends TDF_LabelMap {
    constructor(theOther: TDF_LabelMap);
  }

export declare class TDF_IDFilter {
  constructor(ignoreMode: Standard_Boolean)
  IgnoreAll_1(ignore: Standard_Boolean): void;
  IgnoreAll_2(): Standard_Boolean;
  Keep_1(anID: Standard_GUID): void;
  Keep_2(anIDList: TDF_IDList): void;
  Ignore_1(anID: Standard_GUID): void;
  Ignore_2(anIDList: TDF_IDList): void;
  IsKept_1(anID: Standard_GUID): Standard_Boolean;
  IsKept_2(anAtt: Handle_TDF_Attribute): Standard_Boolean;
  IsIgnored_1(anID: Standard_GUID): Standard_Boolean;
  IsIgnored_2(anAtt: Handle_TDF_Attribute): Standard_Boolean;
  IDList(anIDList: TDF_IDList): void;
  Copy(fromFilter: TDF_IDFilter): void;
  Dump(anOS: Standard_OStream): void;
  Assign(theFilter: TDF_IDFilter): void;
  delete(): void;
}

export declare class TDF_AttributeDelta extends Standard_Transient {
  Apply(): void;
  Label(): TDF_Label;
  Attribute(): Handle_TDF_Attribute;
  ID(): Standard_GUID;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_AttributeDelta {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_AttributeDelta): void;
  get(): TDF_AttributeDelta;
  delete(): void;
}

  export declare class Handle_TDF_AttributeDelta_1 extends Handle_TDF_AttributeDelta {
    constructor();
  }

  export declare class Handle_TDF_AttributeDelta_2 extends Handle_TDF_AttributeDelta {
    constructor(thePtr: TDF_AttributeDelta);
  }

  export declare class Handle_TDF_AttributeDelta_3 extends Handle_TDF_AttributeDelta {
    constructor(theHandle: Handle_TDF_AttributeDelta);
  }

  export declare class Handle_TDF_AttributeDelta_4 extends Handle_TDF_AttributeDelta {
    constructor(theHandle: Handle_TDF_AttributeDelta);
  }

export declare class TDF_LabelList extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TDF_LabelList): TDF_LabelList;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): TDF_Label;
  First_2(): TDF_Label;
  Last_1(): TDF_Label;
  Last_2(): TDF_Label;
  Append_1(theItem: TDF_Label): TDF_Label;
  Append_3(theOther: TDF_LabelList): void;
  Prepend_1(theItem: TDF_Label): TDF_Label;
  Prepend_2(theOther: TDF_LabelList): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TDF_LabelList_1 extends TDF_LabelList {
    constructor();
  }

  export declare class TDF_LabelList_2 extends TDF_LabelList {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_LabelList_3 extends TDF_LabelList {
    constructor(theOther: TDF_LabelList);
  }

export declare class TDF_Tool {
  constructor();
  static NbLabels(aLabel: TDF_Label): Graphic3d_ZLayerId;
  static NbAttributes_1(aLabel: TDF_Label): Graphic3d_ZLayerId;
  static NbAttributes_2(aLabel: TDF_Label, aFilter: TDF_IDFilter): Graphic3d_ZLayerId;
  static IsSelfContained_1(aLabel: TDF_Label): Standard_Boolean;
  static IsSelfContained_2(aLabel: TDF_Label, aFilter: TDF_IDFilter): Standard_Boolean;
  static OutReferers_1(theLabel: TDF_Label, theAtts: TDF_AttributeMap): void;
  static OutReferers_2(aLabel: TDF_Label, aFilterForReferers: TDF_IDFilter, aFilterForReferences: TDF_IDFilter, atts: TDF_AttributeMap): void;
  static OutReferences_1(aLabel: TDF_Label, atts: TDF_AttributeMap): void;
  static OutReferences_2(aLabel: TDF_Label, aFilterForReferers: TDF_IDFilter, aFilterForReferences: TDF_IDFilter, atts: TDF_AttributeMap): void;
  static RelocateLabel(aSourceLabel: TDF_Label, fromRoot: TDF_Label, toRoot: TDF_Label, aTargetLabel: TDF_Label, create: Standard_Boolean): void;
  static Entry(aLabel: TDF_Label, anEntry: XCAFDoc_PartId): void;
  static TagList_1(aLabel: TDF_Label, aTagList: TColStd_ListOfInteger): void;
  static TagList_2(anEntry: XCAFDoc_PartId, aTagList: TColStd_ListOfInteger): void;
  static Label_1(aDF: Handle_TDF_Data, anEntry: XCAFDoc_PartId, aLabel: TDF_Label, create: Standard_Boolean): void;
  static Label_2(aDF: Handle_TDF_Data, anEntry: Standard_CString, aLabel: TDF_Label, create: Standard_Boolean): void;
  static Label_3(aDF: Handle_TDF_Data, aTagList: TColStd_ListOfInteger, aLabel: TDF_Label, create: Standard_Boolean): void;
  static CountLabels(aLabelList: TDF_LabelList, aLabelMap: TDF_LabelIntegerMap): void;
  static DeductLabels(aLabelList: TDF_LabelList, aLabelMap: TDF_LabelIntegerMap): void;
  static DeepDump_1(anOS: Standard_OStream, aDF: Handle_TDF_Data): void;
  static ExtendedDeepDump_1(anOS: Standard_OStream, aDF: Handle_TDF_Data, aFilter: TDF_IDFilter): void;
  static DeepDump_2(anOS: Standard_OStream, aLabel: TDF_Label): void;
  static ExtendedDeepDump_2(anOS: Standard_OStream, aLabel: TDF_Label, aFilter: TDF_IDFilter): void;
  delete(): void;
}

export declare class TDF_IDMap extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: TDF_IDMap): void;
  Assign(theOther: TDF_IDMap): TDF_IDMap;
  ReSize(N: Standard_Integer): void;
  Add(K: Standard_GUID): Standard_Boolean;
  Added(K: Standard_GUID): Standard_GUID;
  Contains_1(K: Standard_GUID): Standard_Boolean;
  Remove(K: Standard_GUID): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: TDF_IDMap): Standard_Boolean;
  Contains_2(theOther: TDF_IDMap): Standard_Boolean;
  Union(theLeft: TDF_IDMap, theRight: TDF_IDMap): void;
  Unite(theOther: TDF_IDMap): Standard_Boolean;
  HasIntersection(theMap: TDF_IDMap): Standard_Boolean;
  Intersection(theLeft: TDF_IDMap, theRight: TDF_IDMap): void;
  Intersect(theOther: TDF_IDMap): Standard_Boolean;
  Subtraction(theLeft: TDF_IDMap, theRight: TDF_IDMap): void;
  Subtract(theOther: TDF_IDMap): Standard_Boolean;
  Difference(theLeft: TDF_IDMap, theRight: TDF_IDMap): void;
  Differ(theOther: TDF_IDMap): Standard_Boolean;
  delete(): void;
}

  export declare class TDF_IDMap_1 extends TDF_IDMap {
    constructor();
  }

  export declare class TDF_IDMap_2 extends TDF_IDMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_IDMap_3 extends TDF_IDMap {
    constructor(theOther: TDF_IDMap);
  }

export declare class TDF_Label {
  constructor()
  Nullify(): void;
  Data(): Handle_TDF_Data;
  Tag(): Graphic3d_ZLayerId;
  Father(): TDF_Label;
  IsNull(): Standard_Boolean;
  Imported(aStatus: Standard_Boolean): void;
  IsImported(): Standard_Boolean;
  IsEqual(aLabel: TDF_Label): Standard_Boolean;
  IsDifferent(aLabel: TDF_Label): Standard_Boolean;
  IsRoot(): Standard_Boolean;
  IsAttribute(anID: Standard_GUID): Standard_Boolean;
  AddAttribute(anAttribute: Handle_TDF_Attribute, append: Standard_Boolean): void;
  ForgetAttribute_1(anAttribute: Handle_TDF_Attribute): void;
  ForgetAttribute_2(aguid: Standard_GUID): Standard_Boolean;
  ForgetAllAttributes(clearChildren: Standard_Boolean): void;
  ResumeAttribute(anAttribute: Handle_TDF_Attribute): void;
  FindAttribute_1(anID: Standard_GUID, anAttribute: Handle_TDF_Attribute): Standard_Boolean;
  FindAttribute_3(anID: Standard_GUID, aTransaction: Graphic3d_ZLayerId, anAttribute: Handle_TDF_Attribute): Standard_Boolean;
  MayBeModified(): Standard_Boolean;
  AttributesModified(): Standard_Boolean;
  HasAttribute(): Standard_Boolean;
  NbAttributes(): Graphic3d_ZLayerId;
  Depth(): Graphic3d_ZLayerId;
  IsDescendant(aLabel: TDF_Label): Standard_Boolean;
  Root(): TDF_Label;
  HasChild(): Standard_Boolean;
  NbChildren(): Graphic3d_ZLayerId;
  FindChild(aTag: Graphic3d_ZLayerId, create: Standard_Boolean): TDF_Label;
  NewChild(): TDF_Label;
  Transaction(): Graphic3d_ZLayerId;
  HasLowerNode(otherLabel: TDF_Label): Standard_Boolean;
  HasGreaterNode(otherLabel: TDF_Label): Standard_Boolean;
  ExtendedDump(anOS: Standard_OStream, aFilter: TDF_IDFilter, aMap: TDF_AttributeIndexedMap): void;
  EntryDump(anOS: Standard_OStream): void;
  delete(): void;
}

export declare class TDF_ComparisonTool {
  constructor();
  static Compare_1(aSourceDataSet: Handle_TDF_DataSet, aTargetDataSet: Handle_TDF_DataSet, aFilter: TDF_IDFilter, aRelocationTable: Handle_TDF_RelocationTable): void;
  static SourceUnbound(aRefDataSet: Handle_TDF_DataSet, aRelocationTable: Handle_TDF_RelocationTable, aFilter: TDF_IDFilter, aDiffDataSet: Handle_TDF_DataSet, anOption: Graphic3d_ZLayerId): Standard_Boolean;
  static TargetUnbound(aRefDataSet: Handle_TDF_DataSet, aRelocationTable: Handle_TDF_RelocationTable, aFilter: TDF_IDFilter, aDiffDataSet: Handle_TDF_DataSet, anOption: Graphic3d_ZLayerId): Standard_Boolean;
  static Cut(aDataSet: Handle_TDF_DataSet): void;
  static IsSelfContained(aLabel: TDF_Label, aDataSet: Handle_TDF_DataSet): Standard_Boolean;
  delete(): void;
}

export declare class TDF_IDList extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: TDF_IDList): TDF_IDList;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): Standard_GUID;
  First_2(): Standard_GUID;
  Last_1(): Standard_GUID;
  Last_2(): Standard_GUID;
  Append_1(theItem: Standard_GUID): Standard_GUID;
  Append_3(theOther: TDF_IDList): void;
  Prepend_1(theItem: Standard_GUID): Standard_GUID;
  Prepend_2(theOther: TDF_IDList): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class TDF_IDList_1 extends TDF_IDList {
    constructor();
  }

  export declare class TDF_IDList_2 extends TDF_IDList {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class TDF_IDList_3 extends TDF_IDList {
    constructor(theOther: TDF_IDList);
  }

export declare class TDF_Attribute extends Standard_Transient {
  ID(): Standard_GUID;
  SetID_1(a0: Standard_GUID): void;
  SetID_2(): void;
  Label(): TDF_Label;
  Transaction(): Graphic3d_ZLayerId;
  UntilTransaction(): Graphic3d_ZLayerId;
  IsValid(): Standard_Boolean;
  IsNew(): Standard_Boolean;
  IsForgotten(): Standard_Boolean;
  IsAttribute(anID: Standard_GUID): Standard_Boolean;
  FindAttribute_1(anID: Standard_GUID, anAttribute: Handle_TDF_Attribute): Standard_Boolean;
  AddAttribute(other: Handle_TDF_Attribute): void;
  ForgetAttribute(aguid: Standard_GUID): Standard_Boolean;
  ForgetAllAttributes(clearChildren: Standard_Boolean): void;
  AfterAddition(): void;
  BeforeRemoval(): void;
  BeforeForget(): void;
  AfterResume(): void;
  AfterRetrieval(forceIt: Standard_Boolean): Standard_Boolean;
  BeforeUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  AfterUndo(anAttDelta: Handle_TDF_AttributeDelta, forceIt: Standard_Boolean): Standard_Boolean;
  BeforeCommitTransaction(): void;
  Backup_1(): void;
  IsBackuped(): Standard_Boolean;
  BackupCopy(): Handle_TDF_Attribute;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  DeltaOnAddition(): Handle_TDF_DeltaOnAddition;
  DeltaOnForget(): Handle_TDF_DeltaOnForget;
  DeltaOnResume(): Handle_TDF_DeltaOnResume;
  DeltaOnModification_1(anOldAttribute: Handle_TDF_Attribute): Handle_TDF_DeltaOnModification;
  DeltaOnModification_2(aDelta: Handle_TDF_DeltaOnModification): void;
  DeltaOnRemoval(): Handle_TDF_DeltaOnRemoval;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocationTable: Handle_TDF_RelocationTable): void;
  References(aDataSet: Handle_TDF_DataSet): void;
  ExtendedDump(anOS: Standard_OStream, aFilter: TDF_IDFilter, aMap: TDF_AttributeIndexedMap): void;
  Forget(aTransaction: Graphic3d_ZLayerId): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_Attribute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_Attribute): void;
  get(): TDF_Attribute;
  delete(): void;
}

  export declare class Handle_TDF_Attribute_1 extends Handle_TDF_Attribute {
    constructor();
  }

  export declare class Handle_TDF_Attribute_2 extends Handle_TDF_Attribute {
    constructor(thePtr: TDF_Attribute);
  }

  export declare class Handle_TDF_Attribute_3 extends Handle_TDF_Attribute {
    constructor(theHandle: Handle_TDF_Attribute);
  }

  export declare class Handle_TDF_Attribute_4 extends Handle_TDF_Attribute {
    constructor(theHandle: Handle_TDF_Attribute);
  }

export declare class TDF_ChildIterator {
  Initialize(aLabel: TDF_Label, allLevels: Standard_Boolean): void;
  More(): Standard_Boolean;
  Next(): void;
  NextBrother(): void;
  Value(): TDF_Label;
  delete(): void;
}

  export declare class TDF_ChildIterator_1 extends TDF_ChildIterator {
    constructor();
  }

  export declare class TDF_ChildIterator_2 extends TDF_ChildIterator {
    constructor(aLabel: TDF_Label, allLevels: Standard_Boolean);
  }

export declare class Handle_TDF_Reference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_Reference): void;
  get(): TDF_Reference;
  delete(): void;
}

  export declare class Handle_TDF_Reference_1 extends Handle_TDF_Reference {
    constructor();
  }

  export declare class Handle_TDF_Reference_2 extends Handle_TDF_Reference {
    constructor(thePtr: TDF_Reference);
  }

  export declare class Handle_TDF_Reference_3 extends Handle_TDF_Reference {
    constructor(theHandle: Handle_TDF_Reference);
  }

  export declare class Handle_TDF_Reference_4 extends Handle_TDF_Reference {
    constructor(theHandle: Handle_TDF_Reference);
  }

export declare class TDF_Reference extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(I: TDF_Label, Origin: TDF_Label): Handle_TDF_Reference;
  Set_2(Origin: TDF_Label): void;
  Get(): TDF_Label;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(DS: Handle_TDF_DataSet): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_TagSource {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_TagSource): void;
  get(): TDF_TagSource;
  delete(): void;
}

  export declare class Handle_TDF_TagSource_1 extends Handle_TDF_TagSource {
    constructor();
  }

  export declare class Handle_TDF_TagSource_2 extends Handle_TDF_TagSource {
    constructor(thePtr: TDF_TagSource);
  }

  export declare class Handle_TDF_TagSource_3 extends Handle_TDF_TagSource {
    constructor(theHandle: Handle_TDF_TagSource);
  }

  export declare class Handle_TDF_TagSource_4 extends Handle_TDF_TagSource {
    constructor(theHandle: Handle_TDF_TagSource);
  }

export declare class TDF_TagSource extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDF_TagSource;
  static NewChild_1(L: TDF_Label): TDF_Label;
  NewTag(): Graphic3d_ZLayerId;
  NewChild_2(): TDF_Label;
  Get(): Graphic3d_ZLayerId;
  Set_2(T: Graphic3d_ZLayerId): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDF_Transaction {
  Initialize(aDF: Handle_TDF_Data): void;
  Open(): Graphic3d_ZLayerId;
  Commit(withDelta: Standard_Boolean): Handle_TDF_Delta;
  Abort(): void;
  Data(): Handle_TDF_Data;
  Transaction(): Graphic3d_ZLayerId;
  Name(): XCAFDoc_PartId;
  IsOpen(): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class TDF_Transaction_1 extends TDF_Transaction {
    constructor(aName: XCAFDoc_PartId);
  }

  export declare class TDF_Transaction_2 extends TDF_Transaction {
    constructor(aDF: Handle_TDF_Data, aName: XCAFDoc_PartId);
  }

export declare class TDF {
  constructor();
  static LowestID(): Standard_GUID;
  static UppestID(): Standard_GUID;
  static AddLinkGUIDToProgID(ID: Standard_GUID, ProgID: TCollection_ExtendedString): void;
  static GUIDFromProgID(ProgID: TCollection_ExtendedString, ID: Standard_GUID): Standard_Boolean;
  static ProgIDFromGUID(ID: Standard_GUID, ProgID: TCollection_ExtendedString): Standard_Boolean;
  delete(): void;
}

export declare class Handle_TDF_DeltaOnAddition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DeltaOnAddition): void;
  get(): TDF_DeltaOnAddition;
  delete(): void;
}

  export declare class Handle_TDF_DeltaOnAddition_1 extends Handle_TDF_DeltaOnAddition {
    constructor();
  }

  export declare class Handle_TDF_DeltaOnAddition_2 extends Handle_TDF_DeltaOnAddition {
    constructor(thePtr: TDF_DeltaOnAddition);
  }

  export declare class Handle_TDF_DeltaOnAddition_3 extends Handle_TDF_DeltaOnAddition {
    constructor(theHandle: Handle_TDF_DeltaOnAddition);
  }

  export declare class Handle_TDF_DeltaOnAddition_4 extends Handle_TDF_DeltaOnAddition {
    constructor(theHandle: Handle_TDF_DeltaOnAddition);
  }

export declare class TDF_DeltaOnAddition extends TDF_AttributeDelta {
  constructor(anAtt: Handle_TDF_Attribute)
  Apply(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class TDF_DataSet extends Standard_Transient {
  constructor()
  Clear(): void;
  IsEmpty(): Standard_Boolean;
  AddLabel(aLabel: TDF_Label): void;
  ContainsLabel(aLabel: TDF_Label): Standard_Boolean;
  Labels(): TDF_LabelMap;
  AddAttribute(anAttribute: Handle_TDF_Attribute): void;
  ContainsAttribute(anAttribute: Handle_TDF_Attribute): Standard_Boolean;
  Attributes(): TDF_AttributeMap;
  AddRoot(aLabel: TDF_Label): void;
  Roots(): TDF_LabelList;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDF_DataSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDF_DataSet): void;
  get(): TDF_DataSet;
  delete(): void;
}

  export declare class Handle_TDF_DataSet_1 extends Handle_TDF_DataSet {
    constructor();
  }

  export declare class Handle_TDF_DataSet_2 extends Handle_TDF_DataSet {
    constructor(thePtr: TDF_DataSet);
  }

  export declare class Handle_TDF_DataSet_3 extends Handle_TDF_DataSet {
    constructor(theHandle: Handle_TDF_DataSet);
  }

  export declare class Handle_TDF_DataSet_4 extends Handle_TDF_DataSet {
    constructor(theHandle: Handle_TDF_DataSet);
  }

export declare class Poly_MakeLoops {
  Reset(theHelper: any, theAlloc: Handle_NCollection_BaseAllocator): void;
  AddLink(theLink: any): void;
  ReplaceLink(theLink: any, theNewLink: any): void;
  SetLinkOrientation(theLink: any, theOrient: any): any;
  FindLink(theLink: any): any;
  Perform(): Graphic3d_ZLayerId;
  GetNbLoops(): Graphic3d_ZLayerId;
  GetLoop(theIndex: Graphic3d_ZLayerId): any;
  GetNbHanging(): Graphic3d_ZLayerId;
  GetHangingLinks(theLinks: any): void;
  delete(): void;
}

export declare class Poly_MakeLoops3D extends Poly_MakeLoops {
  constructor(theHelper: any, theAlloc: Handle_NCollection_BaseAllocator)
  delete(): void;
}

export declare class Poly_MakeLoops2D extends Poly_MakeLoops {
  constructor(theLeftWay: Standard_Boolean, theHelper: any, theAlloc: Handle_NCollection_BaseAllocator)
  delete(): void;
}

export declare class Handle_Poly_PolygonOnTriangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Poly_PolygonOnTriangulation): void;
  get(): Poly_PolygonOnTriangulation;
  delete(): void;
}

  export declare class Handle_Poly_PolygonOnTriangulation_1 extends Handle_Poly_PolygonOnTriangulation {
    constructor();
  }

  export declare class Handle_Poly_PolygonOnTriangulation_2 extends Handle_Poly_PolygonOnTriangulation {
    constructor(thePtr: Poly_PolygonOnTriangulation);
  }

  export declare class Handle_Poly_PolygonOnTriangulation_3 extends Handle_Poly_PolygonOnTriangulation {
    constructor(theHandle: Handle_Poly_PolygonOnTriangulation);
  }

  export declare class Handle_Poly_PolygonOnTriangulation_4 extends Handle_Poly_PolygonOnTriangulation {
    constructor(theHandle: Handle_Poly_PolygonOnTriangulation);
  }

export declare class Poly_PolygonOnTriangulation extends Standard_Transient {
  Copy(): Handle_Poly_PolygonOnTriangulation;
  Deflection_1(): Quantity_AbsorbedDose;
  Deflection_2(theDefl: Quantity_AbsorbedDose): void;
  NbNodes(): Graphic3d_ZLayerId;
  Nodes(): TColStd_Array1OfInteger;
  ChangeNodes(): TColStd_Array1OfInteger;
  HasParameters(): Standard_Boolean;
  Parameters(): Handle_TColStd_HArray1OfReal;
  ChangeParameters(): TColStd_Array1OfReal;
  SetParameters(theParameters: Handle_TColStd_HArray1OfReal): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Poly_PolygonOnTriangulation_1 extends Poly_PolygonOnTriangulation {
    constructor(theNbNodes: Graphic3d_ZLayerId, theHasParams: Standard_Boolean);
  }

  export declare class Poly_PolygonOnTriangulation_2 extends Poly_PolygonOnTriangulation {
    constructor(Nodes: TColStd_Array1OfInteger);
  }

  export declare class Poly_PolygonOnTriangulation_3 extends Poly_PolygonOnTriangulation {
    constructor(Nodes: TColStd_Array1OfInteger, Parameters: TColStd_Array1OfReal);
  }

export declare class Poly_CoherentTriangle {
  Node(ind: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  IsEmpty(): Standard_Boolean;
  SetConnection_1(iConn: Graphic3d_ZLayerId, theTr: Poly_CoherentTriangle): Standard_Boolean;
  SetConnection_2(theTri: Poly_CoherentTriangle): Standard_Boolean;
  RemoveConnection_1(iConn: Graphic3d_ZLayerId): void;
  RemoveConnection_2(theTri: Poly_CoherentTriangle): Standard_Boolean;
  NConnections(): Graphic3d_ZLayerId;
  GetConnectedNode(iConn: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetConnectedTri(iConn: Graphic3d_ZLayerId): Poly_CoherentTriangle;
  GetLink(iLink: Graphic3d_ZLayerId): Poly_CoherentLink;
  FindConnection(a0: Poly_CoherentTriangle): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Poly_CoherentTriangle_1 extends Poly_CoherentTriangle {
    constructor();
  }

  export declare class Poly_CoherentTriangle_2 extends Poly_CoherentTriangle {
    constructor(iNode0: Graphic3d_ZLayerId, iNode1: Graphic3d_ZLayerId, iNode2: Graphic3d_ZLayerId);
  }

export declare class Poly {
  constructor();
  static Catenate(lstTri: Poly_ListOfTriangulation): Handle_Poly_Triangulation;
  static Write_1(T: Handle_Poly_Triangulation, OS: Standard_OStream, Compact: Standard_Boolean): void;
  static Write_2(P: Handle_Poly_Polygon3D, OS: Standard_OStream, Compact: Standard_Boolean): void;
  static Write_3(P: Handle_Poly_Polygon2D, OS: Standard_OStream, Compact: Standard_Boolean): void;
  static Dump_1(T: Handle_Poly_Triangulation, OS: Standard_OStream): void;
  static Dump_2(P: Handle_Poly_Polygon3D, OS: Standard_OStream): void;
  static Dump_3(P: Handle_Poly_Polygon2D, OS: Standard_OStream): void;
  static ReadTriangulation(IS: Standard_IStream): Handle_Poly_Triangulation;
  static ReadPolygon3D(IS: Standard_IStream): Handle_Poly_Polygon3D;
  static ReadPolygon2D(IS: Standard_IStream): Handle_Poly_Polygon2D;
  static ComputeNormals(Tri: Handle_Poly_Triangulation): void;
  static PointOnTriangle(P1: gp_XY, P2: gp_XY, P3: gp_XY, P: gp_XY, UV: gp_XY): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Poly_Polygon3D extends Standard_Transient {
  Copy(): Handle_Poly_Polygon3D;
  Deflection_1(): Quantity_AbsorbedDose;
  Deflection_2(theDefl: Quantity_AbsorbedDose): void;
  NbNodes(): Graphic3d_ZLayerId;
  Nodes(): TColgp_Array1OfPnt;
  ChangeNodes(): TColgp_Array1OfPnt;
  HasParameters(): Standard_Boolean;
  Parameters(): TColStd_Array1OfReal;
  ChangeParameters(): TColStd_Array1OfReal;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Poly_Polygon3D_1 extends Poly_Polygon3D {
    constructor(theNbNodes: Graphic3d_ZLayerId, theHasParams: Standard_Boolean);
  }

  export declare class Poly_Polygon3D_2 extends Poly_Polygon3D {
    constructor(Nodes: TColgp_Array1OfPnt);
  }

  export declare class Poly_Polygon3D_3 extends Poly_Polygon3D {
    constructor(Nodes: TColgp_Array1OfPnt, Parameters: TColStd_Array1OfReal);
  }

export declare class Handle_Poly_Polygon3D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Poly_Polygon3D): void;
  get(): Poly_Polygon3D;
  delete(): void;
}

  export declare class Handle_Poly_Polygon3D_1 extends Handle_Poly_Polygon3D {
    constructor();
  }

  export declare class Handle_Poly_Polygon3D_2 extends Handle_Poly_Polygon3D {
    constructor(thePtr: Poly_Polygon3D);
  }

  export declare class Handle_Poly_Polygon3D_3 extends Handle_Poly_Polygon3D {
    constructor(theHandle: Handle_Poly_Polygon3D);
  }

  export declare class Handle_Poly_Polygon3D_4 extends Handle_Poly_Polygon3D {
    constructor(theHandle: Handle_Poly_Polygon3D);
  }

export declare class Poly_CoherentLink {
  Node(ind: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  OppositeNode(ind: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetAttribute(): Standard_Address;
  SetAttribute(theAtt: Standard_Address): void;
  IsEmpty(): Standard_Boolean;
  Nullify(): void;
  delete(): void;
}

  export declare class Poly_CoherentLink_1 extends Poly_CoherentLink {
    constructor();
  }

  export declare class Poly_CoherentLink_2 extends Poly_CoherentLink {
    constructor(iNode0: Graphic3d_ZLayerId, iNode1: Graphic3d_ZLayerId);
  }

  export declare class Poly_CoherentLink_3 extends Poly_CoherentLink {
    constructor(theTri: Poly_CoherentTriangle, iSide: Graphic3d_ZLayerId);
  }

export declare class Poly_Polygon2D extends Standard_Transient {
  Deflection_1(): Quantity_AbsorbedDose;
  Deflection_2(theDefl: Quantity_AbsorbedDose): void;
  NbNodes(): Graphic3d_ZLayerId;
  Nodes(): TColgp_Array1OfPnt2d;
  ChangeNodes(): TColgp_Array1OfPnt2d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Poly_Polygon2D_1 extends Poly_Polygon2D {
    constructor(theNbNodes: Graphic3d_ZLayerId);
  }

  export declare class Poly_Polygon2D_2 extends Poly_Polygon2D {
    constructor(Nodes: TColgp_Array1OfPnt2d);
  }

export declare class Handle_Poly_Polygon2D {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Poly_Polygon2D): void;
  get(): Poly_Polygon2D;
  delete(): void;
}

  export declare class Handle_Poly_Polygon2D_1 extends Handle_Poly_Polygon2D {
    constructor();
  }

  export declare class Handle_Poly_Polygon2D_2 extends Handle_Poly_Polygon2D {
    constructor(thePtr: Poly_Polygon2D);
  }

  export declare class Handle_Poly_Polygon2D_3 extends Handle_Poly_Polygon2D {
    constructor(theHandle: Handle_Poly_Polygon2D);
  }

  export declare class Handle_Poly_Polygon2D_4 extends Handle_Poly_Polygon2D {
    constructor(theHandle: Handle_Poly_Polygon2D);
  }

export declare class Poly_Triangulation extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Copy(): Handle_Poly_Triangulation;
  Deflection_1(): Quantity_AbsorbedDose;
  Deflection_2(theDeflection: Quantity_AbsorbedDose): void;
  RemoveUVNodes(): void;
  NbNodes(): Graphic3d_ZLayerId;
  NbTriangles(): Graphic3d_ZLayerId;
  HasUVNodes(): Standard_Boolean;
  Nodes(): TColgp_Array1OfPnt;
  ChangeNodes(): TColgp_Array1OfPnt;
  Node(theIndex: Graphic3d_ZLayerId): gp_Pnt;
  ChangeNode(theIndex: Graphic3d_ZLayerId): gp_Pnt;
  UVNodes(): TColgp_Array1OfPnt2d;
  ChangeUVNodes(): TColgp_Array1OfPnt2d;
  UVNode(theIndex: Graphic3d_ZLayerId): gp_Pnt2d;
  ChangeUVNode(theIndex: Graphic3d_ZLayerId): gp_Pnt2d;
  Triangles(): Poly_Array1OfTriangle;
  ChangeTriangles(): Poly_Array1OfTriangle;
  Triangle(theIndex: Graphic3d_ZLayerId): Poly_Triangle;
  ChangeTriangle(theIndex: Graphic3d_ZLayerId): Poly_Triangle;
  SetNormals(theNormals: Handle_TShort_HArray1OfShortReal): void;
  Normals(): TShort_Array1OfShortReal;
  ChangeNormals(): TShort_Array1OfShortReal;
  HasNormals(): Standard_Boolean;
  Normal(theIndex: Graphic3d_ZLayerId): gp_Dir;
  SetNormal(theIndex: Graphic3d_ZLayerId, theNormal: gp_Dir): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Poly_Triangulation_1 extends Poly_Triangulation {
    constructor(nbNodes: Graphic3d_ZLayerId, nbTriangles: Graphic3d_ZLayerId, UVNodes: Standard_Boolean);
  }

  export declare class Poly_Triangulation_2 extends Poly_Triangulation {
    constructor(Nodes: TColgp_Array1OfPnt, Triangles: Poly_Array1OfTriangle);
  }

  export declare class Poly_Triangulation_3 extends Poly_Triangulation {
    constructor(Nodes: TColgp_Array1OfPnt, UVNodes: TColgp_Array1OfPnt2d, Triangles: Poly_Array1OfTriangle);
  }

  export declare class Poly_Triangulation_4 extends Poly_Triangulation {
    constructor(theTriangulation: Handle_Poly_Triangulation);
  }

export declare class Handle_Poly_Triangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Poly_Triangulation): void;
  get(): Poly_Triangulation;
  delete(): void;
}

  export declare class Handle_Poly_Triangulation_1 extends Handle_Poly_Triangulation {
    constructor();
  }

  export declare class Handle_Poly_Triangulation_2 extends Handle_Poly_Triangulation {
    constructor(thePtr: Poly_Triangulation);
  }

  export declare class Handle_Poly_Triangulation_3 extends Handle_Poly_Triangulation {
    constructor(theHandle: Handle_Poly_Triangulation);
  }

  export declare class Handle_Poly_Triangulation_4 extends Handle_Poly_Triangulation {
    constructor(theHandle: Handle_Poly_Triangulation);
  }

export declare class Poly_Triangle {
  Set_1(theN1: Graphic3d_ZLayerId, theN2: Graphic3d_ZLayerId, theN3: Graphic3d_ZLayerId): void;
  Set_2(theIndex: Graphic3d_ZLayerId, theNode: Graphic3d_ZLayerId): void;
  Get(theN1: Graphic3d_ZLayerId, theN2: Graphic3d_ZLayerId, theN3: Graphic3d_ZLayerId): void;
  Value(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ChangeValue(theIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Poly_Triangle_1 extends Poly_Triangle {
    constructor();
  }

  export declare class Poly_Triangle_2 extends Poly_Triangle {
    constructor(theN1: Graphic3d_ZLayerId, theN2: Graphic3d_ZLayerId, theN3: Graphic3d_ZLayerId);
  }

export declare class Poly_Connect {
  Load(theTriangulation: Handle_Poly_Triangulation): void;
  Triangulation(): Handle_Poly_Triangulation;
  Triangle(N: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Triangles(T: Graphic3d_ZLayerId, t1: Graphic3d_ZLayerId, t2: Graphic3d_ZLayerId, t3: Graphic3d_ZLayerId): void;
  Nodes(T: Graphic3d_ZLayerId, n1: Graphic3d_ZLayerId, n2: Graphic3d_ZLayerId, n3: Graphic3d_ZLayerId): void;
  Initialize(N: Graphic3d_ZLayerId): void;
  More(): Standard_Boolean;
  Next(): void;
  Value(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class Poly_Connect_1 extends Poly_Connect {
    constructor();
  }

  export declare class Poly_Connect_2 extends Poly_Connect {
    constructor(theTriangulation: Handle_Poly_Triangulation);
  }

export declare class Poly_Array1OfTriangle {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: Poly_Triangle): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: Poly_Array1OfTriangle): Poly_Array1OfTriangle;
  Move(theOther: Poly_Array1OfTriangle): Poly_Array1OfTriangle;
  First(): Poly_Triangle;
  ChangeFirst(): Poly_Triangle;
  Last(): Poly_Triangle;
  ChangeLast(): Poly_Triangle;
  Value(theIndex: Standard_Integer): Poly_Triangle;
  ChangeValue(theIndex: Standard_Integer): Poly_Triangle;
  SetValue(theIndex: Standard_Integer, theItem: Poly_Triangle): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class Poly_Array1OfTriangle_1 extends Poly_Array1OfTriangle {
    constructor();
  }

  export declare class Poly_Array1OfTriangle_2 extends Poly_Array1OfTriangle {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class Poly_Array1OfTriangle_3 extends Poly_Array1OfTriangle {
    constructor(theOther: Poly_Array1OfTriangle);
  }

  export declare class Poly_Array1OfTriangle_4 extends Poly_Array1OfTriangle {
    constructor(theOther: Poly_Array1OfTriangle);
  }

  export declare class Poly_Array1OfTriangle_5 extends Poly_Array1OfTriangle {
    constructor(theBegin: Poly_Triangle, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Poly_CoherentTriangulation extends Standard_Transient {
  GetTriangulation(): Handle_Poly_Triangulation;
  RemoveDegenerated(theTol: Quantity_AbsorbedDose, pLstRemovedNode: any): Standard_Boolean;
  GetFreeNodes(lstNodes: TColStd_ListOfInteger): Standard_Boolean;
  MaxNode(): Graphic3d_ZLayerId;
  MaxTriangle(): Graphic3d_ZLayerId;
  SetDeflection(theDefl: Quantity_AbsorbedDose): void;
  Deflection(): Quantity_AbsorbedDose;
  SetNode(thePnt: gp_XYZ, iN: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Node(i: Graphic3d_ZLayerId): Poly_CoherentNode;
  ChangeNode(i: Graphic3d_ZLayerId): Poly_CoherentNode;
  NNodes(): Graphic3d_ZLayerId;
  Triangle(i: Graphic3d_ZLayerId): Poly_CoherentTriangle;
  NTriangles(): Graphic3d_ZLayerId;
  NLinks(): Graphic3d_ZLayerId;
  RemoveTriangle(theTr: Poly_CoherentTriangle): Standard_Boolean;
  RemoveLink(theLink: Poly_CoherentLink): void;
  AddTriangle(iNode0: Graphic3d_ZLayerId, iNode1: Graphic3d_ZLayerId, iNode2: Graphic3d_ZLayerId): Poly_CoherentTriangle;
  ReplaceNodes(theTriangle: Poly_CoherentTriangle, iNode0: Graphic3d_ZLayerId, iNode1: Graphic3d_ZLayerId, iNode2: Graphic3d_ZLayerId): Standard_Boolean;
  AddLink(theTri: Poly_CoherentTriangle, theConn: Graphic3d_ZLayerId): Poly_CoherentLink;
  FindTriangle(theLink: Poly_CoherentLink, pTri: Poly_CoherentTriangle [2]): Standard_Boolean;
  ComputeLinks(): Graphic3d_ZLayerId;
  ClearLinks(): void;
  Allocator(): Handle_NCollection_BaseAllocator;
  Clone(theAlloc: Handle_NCollection_BaseAllocator): Handle_Poly_CoherentTriangulation;
  Dump(a0: Standard_OStream): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Poly_CoherentTriangulation_1 extends Poly_CoherentTriangulation {
    constructor(theAlloc: Handle_NCollection_BaseAllocator);
  }

  export declare class Poly_CoherentTriangulation_2 extends Poly_CoherentTriangulation {
    constructor(theTriangulation: Handle_Poly_Triangulation, theAlloc: Handle_NCollection_BaseAllocator);
  }

export declare class Handle_Poly_CoherentTriangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Poly_CoherentTriangulation): void;
  get(): Poly_CoherentTriangulation;
  delete(): void;
}

  export declare class Handle_Poly_CoherentTriangulation_1 extends Handle_Poly_CoherentTriangulation {
    constructor();
  }

  export declare class Handle_Poly_CoherentTriangulation_2 extends Handle_Poly_CoherentTriangulation {
    constructor(thePtr: Poly_CoherentTriangulation);
  }

  export declare class Handle_Poly_CoherentTriangulation_3 extends Handle_Poly_CoherentTriangulation {
    constructor(theHandle: Handle_Poly_CoherentTriangulation);
  }

  export declare class Handle_Poly_CoherentTriangulation_4 extends Handle_Poly_CoherentTriangulation {
    constructor(theHandle: Handle_Poly_CoherentTriangulation);
  }

export declare class Handle_Poly_HArray1OfTriangle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Poly_HArray1OfTriangle): void;
  get(): Poly_HArray1OfTriangle;
  delete(): void;
}

  export declare class Handle_Poly_HArray1OfTriangle_1 extends Handle_Poly_HArray1OfTriangle {
    constructor();
  }

  export declare class Handle_Poly_HArray1OfTriangle_2 extends Handle_Poly_HArray1OfTriangle {
    constructor(thePtr: Poly_HArray1OfTriangle);
  }

  export declare class Handle_Poly_HArray1OfTriangle_3 extends Handle_Poly_HArray1OfTriangle {
    constructor(theHandle: Handle_Poly_HArray1OfTriangle);
  }

  export declare class Handle_Poly_HArray1OfTriangle_4 extends Handle_Poly_HArray1OfTriangle {
    constructor(theHandle: Handle_Poly_HArray1OfTriangle);
  }

export declare class Poly_CoherentNode extends gp_XYZ {
  SetUV(theU: Quantity_AbsorbedDose, theV: Quantity_AbsorbedDose): void;
  GetU(): Quantity_AbsorbedDose;
  GetV(): Quantity_AbsorbedDose;
  SetNormal(theVector: gp_XYZ): void;
  HasNormal(): Standard_Boolean;
  GetNormal(): gp_XYZ;
  SetIndex(theIndex: Graphic3d_ZLayerId): void;
  GetIndex(): Graphic3d_ZLayerId;
  IsFreeNode(): Standard_Boolean;
  Clear(a0: Handle_NCollection_BaseAllocator): void;
  AddTriangle(theTri: Poly_CoherentTriangle, theA: Handle_NCollection_BaseAllocator): void;
  RemoveTriangle(theTri: Poly_CoherentTriangle, theA: Handle_NCollection_BaseAllocator): Standard_Boolean;
  TriangleIterator(): any;
  Dump(theStream: Standard_OStream): void;
  delete(): void;
}

  export declare class Poly_CoherentNode_1 extends Poly_CoherentNode {
    constructor();
  }

  export declare class Poly_CoherentNode_2 extends Poly_CoherentNode {
    constructor(thePnt: gp_XYZ);
  }

export declare type Storage_SolveMode = {
  Storage_AddSolve: {};
  Storage_WriteSolve: {};
  Storage_ReadSolve: {};
}

export declare class Storage_PType extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Storage_PType): void;
  Assign(theOther: Storage_PType): Storage_PType;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TCollection_AsciiString, theItem: Standard_Integer): Standard_Integer;
  Contains(theKey1: TCollection_AsciiString): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TCollection_AsciiString, theItem: Standard_Integer): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TCollection_AsciiString): void;
  FindKey(theIndex: Standard_Integer): TCollection_AsciiString;
  FindFromIndex(theIndex: Standard_Integer): Standard_Integer;
  ChangeFromIndex(theIndex: Standard_Integer): Standard_Integer;
  FindIndex(theKey1: TCollection_AsciiString): Standard_Integer;
  ChangeFromKey(theKey1: TCollection_AsciiString): Standard_Integer;
  Seek(theKey1: TCollection_AsciiString): Standard_Integer;
  ChangeSeek(theKey1: TCollection_AsciiString): Standard_Integer;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Storage_PType_1 extends Storage_PType {
    constructor();
  }

  export declare class Storage_PType_2 extends Storage_PType {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Storage_PType_3 extends Storage_PType {
    constructor(theOther: Storage_PType);
  }

export declare class Storage_StreamFormatError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamFormatError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamFormatError_1 extends Storage_StreamFormatError {
    constructor();
  }

  export declare class Storage_StreamFormatError_2 extends Storage_StreamFormatError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Storage_StreamFormatError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamFormatError): void;
  get(): Storage_StreamFormatError;
  delete(): void;
}

  export declare class Handle_Storage_StreamFormatError_1 extends Handle_Storage_StreamFormatError {
    constructor();
  }

  export declare class Handle_Storage_StreamFormatError_2 extends Handle_Storage_StreamFormatError {
    constructor(thePtr: Storage_StreamFormatError);
  }

  export declare class Handle_Storage_StreamFormatError_3 extends Handle_Storage_StreamFormatError {
    constructor(theHandle: Handle_Storage_StreamFormatError);
  }

  export declare class Handle_Storage_StreamFormatError_4 extends Handle_Storage_StreamFormatError {
    constructor(theHandle: Handle_Storage_StreamFormatError);
  }

export declare class Handle_Storage_StreamModeError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamModeError): void;
  get(): Storage_StreamModeError;
  delete(): void;
}

  export declare class Handle_Storage_StreamModeError_1 extends Handle_Storage_StreamModeError {
    constructor();
  }

  export declare class Handle_Storage_StreamModeError_2 extends Handle_Storage_StreamModeError {
    constructor(thePtr: Storage_StreamModeError);
  }

  export declare class Handle_Storage_StreamModeError_3 extends Handle_Storage_StreamModeError {
    constructor(theHandle: Handle_Storage_StreamModeError);
  }

  export declare class Handle_Storage_StreamModeError_4 extends Handle_Storage_StreamModeError {
    constructor(theHandle: Handle_Storage_StreamModeError);
  }

export declare class Storage_StreamModeError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamModeError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamModeError_1 extends Storage_StreamModeError {
    constructor();
  }

  export declare class Storage_StreamModeError_2 extends Storage_StreamModeError {
    constructor(theMessage: Standard_CString);
  }

export declare class Storage_StreamTypeMismatchError extends Storage_StreamReadError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamTypeMismatchError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamTypeMismatchError_1 extends Storage_StreamTypeMismatchError {
    constructor();
  }

  export declare class Storage_StreamTypeMismatchError_2 extends Storage_StreamTypeMismatchError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Storage_StreamTypeMismatchError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamTypeMismatchError): void;
  get(): Storage_StreamTypeMismatchError;
  delete(): void;
}

  export declare class Handle_Storage_StreamTypeMismatchError_1 extends Handle_Storage_StreamTypeMismatchError {
    constructor();
  }

  export declare class Handle_Storage_StreamTypeMismatchError_2 extends Handle_Storage_StreamTypeMismatchError {
    constructor(thePtr: Storage_StreamTypeMismatchError);
  }

  export declare class Handle_Storage_StreamTypeMismatchError_3 extends Handle_Storage_StreamTypeMismatchError {
    constructor(theHandle: Handle_Storage_StreamTypeMismatchError);
  }

  export declare class Handle_Storage_StreamTypeMismatchError_4 extends Handle_Storage_StreamTypeMismatchError {
    constructor(theHandle: Handle_Storage_StreamTypeMismatchError);
  }

export declare class Handle_Storage_HPArray {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_HPArray): void;
  get(): Storage_HPArray;
  delete(): void;
}

  export declare class Handle_Storage_HPArray_1 extends Handle_Storage_HPArray {
    constructor();
  }

  export declare class Handle_Storage_HPArray_2 extends Handle_Storage_HPArray {
    constructor(thePtr: Storage_HPArray);
  }

  export declare class Handle_Storage_HPArray_3 extends Handle_Storage_HPArray {
    constructor(theHandle: Handle_Storage_HPArray);
  }

  export declare class Handle_Storage_HPArray_4 extends Handle_Storage_HPArray {
    constructor(theHandle: Handle_Storage_HPArray);
  }

export declare class Handle_Storage_InternalData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_InternalData): void;
  get(): Storage_InternalData;
  delete(): void;
}

  export declare class Handle_Storage_InternalData_1 extends Handle_Storage_InternalData {
    constructor();
  }

  export declare class Handle_Storage_InternalData_2 extends Handle_Storage_InternalData {
    constructor(thePtr: Storage_InternalData);
  }

  export declare class Handle_Storage_InternalData_3 extends Handle_Storage_InternalData {
    constructor(theHandle: Handle_Storage_InternalData);
  }

  export declare class Handle_Storage_InternalData_4 extends Handle_Storage_InternalData {
    constructor(theHandle: Handle_Storage_InternalData);
  }

export declare class Storage_InternalData extends Standard_Transient {
  constructor()
  ReadArray(): Handle_Storage_HPArray;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Storage_StreamReadError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamReadError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamReadError_1 extends Storage_StreamReadError {
    constructor();
  }

  export declare class Storage_StreamReadError_2 extends Storage_StreamReadError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Storage_StreamReadError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamReadError): void;
  get(): Storage_StreamReadError;
  delete(): void;
}

  export declare class Handle_Storage_StreamReadError_1 extends Handle_Storage_StreamReadError {
    constructor();
  }

  export declare class Handle_Storage_StreamReadError_2 extends Handle_Storage_StreamReadError {
    constructor(thePtr: Storage_StreamReadError);
  }

  export declare class Handle_Storage_StreamReadError_3 extends Handle_Storage_StreamReadError {
    constructor(theHandle: Handle_Storage_StreamReadError);
  }

  export declare class Handle_Storage_StreamReadError_4 extends Handle_Storage_StreamReadError {
    constructor(theHandle: Handle_Storage_StreamReadError);
  }

export declare class Handle_Storage_StreamWriteError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamWriteError): void;
  get(): Storage_StreamWriteError;
  delete(): void;
}

  export declare class Handle_Storage_StreamWriteError_1 extends Handle_Storage_StreamWriteError {
    constructor();
  }

  export declare class Handle_Storage_StreamWriteError_2 extends Handle_Storage_StreamWriteError {
    constructor(thePtr: Storage_StreamWriteError);
  }

  export declare class Handle_Storage_StreamWriteError_3 extends Handle_Storage_StreamWriteError {
    constructor(theHandle: Handle_Storage_StreamWriteError);
  }

  export declare class Handle_Storage_StreamWriteError_4 extends Handle_Storage_StreamWriteError {
    constructor(theHandle: Handle_Storage_StreamWriteError);
  }

export declare class Storage_StreamWriteError extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamWriteError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamWriteError_1 extends Storage_StreamWriteError {
    constructor();
  }

  export declare class Storage_StreamWriteError_2 extends Storage_StreamWriteError {
    constructor(theMessage: Standard_CString);
  }

export declare class Storage_Root extends Standard_Transient {
  SetName(theName: XCAFDoc_PartId): void;
  Name(): XCAFDoc_PartId;
  SetObject(anObject: any): void;
  Object(): any;
  Type(): XCAFDoc_PartId;
  SetReference(aRef: Graphic3d_ZLayerId): void;
  Reference(): Graphic3d_ZLayerId;
  SetType(aType: XCAFDoc_PartId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_Root_1 extends Storage_Root {
    constructor();
  }

  export declare class Storage_Root_2 extends Storage_Root {
    constructor(theName: XCAFDoc_PartId, theObject: any);
  }

  export declare class Storage_Root_3 extends Storage_Root {
    constructor(theName: XCAFDoc_PartId, theRef: Graphic3d_ZLayerId, theType: XCAFDoc_PartId);
  }

export declare class Handle_Storage_Root {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_Root): void;
  get(): Storage_Root;
  delete(): void;
}

  export declare class Handle_Storage_Root_1 extends Handle_Storage_Root {
    constructor();
  }

  export declare class Handle_Storage_Root_2 extends Handle_Storage_Root {
    constructor(thePtr: Storage_Root);
  }

  export declare class Handle_Storage_Root_3 extends Handle_Storage_Root {
    constructor(theHandle: Handle_Storage_Root);
  }

  export declare class Handle_Storage_Root_4 extends Handle_Storage_Root {
    constructor(theHandle: Handle_Storage_Root);
  }

export declare class Storage_Data extends Standard_Transient {
  constructor()
  ErrorStatus(): Storage_Error;
  ClearErrorStatus(): void;
  ErrorStatusExtension(): XCAFDoc_PartId;
  CreationDate(): XCAFDoc_PartId;
  StorageVersion(): XCAFDoc_PartId;
  SchemaVersion(): XCAFDoc_PartId;
  SchemaName(): XCAFDoc_PartId;
  SetApplicationVersion(aVersion: XCAFDoc_PartId): void;
  ApplicationVersion(): XCAFDoc_PartId;
  SetApplicationName(aName: TCollection_ExtendedString): void;
  ApplicationName(): TCollection_ExtendedString;
  SetDataType(aType: TCollection_ExtendedString): void;
  DataType(): TCollection_ExtendedString;
  AddToUserInfo(anInfo: XCAFDoc_PartId): void;
  UserInfo(): TColStd_SequenceOfAsciiString;
  AddToComments(aComment: TCollection_ExtendedString): void;
  Comments(): TColStd_SequenceOfExtendedString;
  NumberOfObjects(): Graphic3d_ZLayerId;
  NumberOfRoots(): Graphic3d_ZLayerId;
  AddRoot_1(anObject: any): void;
  AddRoot_2(aName: XCAFDoc_PartId, anObject: any): void;
  RemoveRoot(aName: XCAFDoc_PartId): void;
  Roots(): Handle_Storage_HSeqOfRoot;
  Find(aName: XCAFDoc_PartId): Handle_Storage_Root;
  IsRoot(aName: XCAFDoc_PartId): Standard_Boolean;
  NumberOfTypes(): Graphic3d_ZLayerId;
  IsType(aName: XCAFDoc_PartId): Standard_Boolean;
  Types(): Handle_TColStd_HSequenceOfAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  HeaderData(): Handle_Storage_HeaderData;
  RootData(): Handle_Storage_RootData;
  TypeData(): Handle_Storage_TypeData;
  InternalData(): Handle_Storage_InternalData;
  Clear(): void;
  delete(): void;
}

export declare class Handle_Storage_Data {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_Data): void;
  get(): Storage_Data;
  delete(): void;
}

  export declare class Handle_Storage_Data_1 extends Handle_Storage_Data {
    constructor();
  }

  export declare class Handle_Storage_Data_2 extends Handle_Storage_Data {
    constructor(thePtr: Storage_Data);
  }

  export declare class Handle_Storage_Data_3 extends Handle_Storage_Data {
    constructor(theHandle: Handle_Storage_Data);
  }

  export declare class Handle_Storage_Data_4 extends Handle_Storage_Data {
    constructor(theHandle: Handle_Storage_Data);
  }

export declare class Storage_BucketIterator {
  constructor(a: Storage_BucketOfPersistent)
  Init(a0: Storage_BucketOfPersistent): void;
  Reset(): void;
  Value(): Standard_Persistent;
  More(): Standard_Boolean;
  Next(): void;
  delete(): void;
}

export declare class Storage_BucketOfPersistent {
  constructor(theBucketSize: Graphic3d_ZLayerId, theBucketNumber: Graphic3d_ZLayerId)
  Length(): Graphic3d_ZLayerId;
  Append(sp: any): void;
  Value(theIndex: Graphic3d_ZLayerId): Standard_Persistent;
  Clear(): void;
  delete(): void;
}

export declare class Storage_Bucket {
  Clear(): void;
  delete(): void;
}

  export declare class Storage_Bucket_1 extends Storage_Bucket {
    constructor();
  }

  export declare class Storage_Bucket_2 extends Storage_Bucket {
    constructor(theSpaceSize: Graphic3d_ZLayerId);
  }

export declare class Storage_HeaderData extends Standard_Transient {
  constructor()
  Read(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  CreationDate(): XCAFDoc_PartId;
  StorageVersion(): XCAFDoc_PartId;
  SchemaVersion(): XCAFDoc_PartId;
  SchemaName(): XCAFDoc_PartId;
  SetApplicationVersion(aVersion: XCAFDoc_PartId): void;
  ApplicationVersion(): XCAFDoc_PartId;
  SetApplicationName(aName: TCollection_ExtendedString): void;
  ApplicationName(): TCollection_ExtendedString;
  SetDataType(aType: TCollection_ExtendedString): void;
  DataType(): TCollection_ExtendedString;
  AddToUserInfo(theUserInfo: XCAFDoc_PartId): void;
  UserInfo(): TColStd_SequenceOfAsciiString;
  AddToComments(aComment: TCollection_ExtendedString): void;
  Comments(): TColStd_SequenceOfExtendedString;
  NumberOfObjects(): Graphic3d_ZLayerId;
  ErrorStatus(): Storage_Error;
  ErrorStatusExtension(): XCAFDoc_PartId;
  ClearErrorStatus(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetNumberOfObjects(anObjectNumber: Graphic3d_ZLayerId): void;
  SetStorageVersion(aVersion: XCAFDoc_PartId): void;
  SetCreationDate(aDate: XCAFDoc_PartId): void;
  SetSchemaVersion(aVersion: XCAFDoc_PartId): void;
  SetSchemaName(aName: XCAFDoc_PartId): void;
  delete(): void;
}

export declare class Handle_Storage_HeaderData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_HeaderData): void;
  get(): Storage_HeaderData;
  delete(): void;
}

  export declare class Handle_Storage_HeaderData_1 extends Handle_Storage_HeaderData {
    constructor();
  }

  export declare class Handle_Storage_HeaderData_2 extends Handle_Storage_HeaderData {
    constructor(thePtr: Storage_HeaderData);
  }

  export declare class Handle_Storage_HeaderData_3 extends Handle_Storage_HeaderData {
    constructor(theHandle: Handle_Storage_HeaderData);
  }

  export declare class Handle_Storage_HeaderData_4 extends Handle_Storage_HeaderData {
    constructor(theHandle: Handle_Storage_HeaderData);
  }

export declare class Handle_Storage_RootData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_RootData): void;
  get(): Storage_RootData;
  delete(): void;
}

  export declare class Handle_Storage_RootData_1 extends Handle_Storage_RootData {
    constructor();
  }

  export declare class Handle_Storage_RootData_2 extends Handle_Storage_RootData {
    constructor(thePtr: Storage_RootData);
  }

  export declare class Handle_Storage_RootData_3 extends Handle_Storage_RootData {
    constructor(theHandle: Handle_Storage_RootData);
  }

  export declare class Handle_Storage_RootData_4 extends Handle_Storage_RootData {
    constructor(theHandle: Handle_Storage_RootData);
  }

export declare class Storage_RootData extends Standard_Transient {
  constructor()
  Read(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  NumberOfRoots(): Graphic3d_ZLayerId;
  AddRoot(aRoot: Handle_Storage_Root): void;
  Roots(): Handle_Storage_HSeqOfRoot;
  Find(aName: XCAFDoc_PartId): Handle_Storage_Root;
  IsRoot(aName: XCAFDoc_PartId): Standard_Boolean;
  RemoveRoot(aName: XCAFDoc_PartId): void;
  ErrorStatus(): Storage_Error;
  ErrorStatusExtension(): XCAFDoc_PartId;
  ClearErrorStatus(): void;
  UpdateRoot(aName: XCAFDoc_PartId, aPers: any): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Storage {
  constructor();
  static Version(): XCAFDoc_PartId;
  delete(): void;
}

export declare type Storage_OpenMode = {
  Storage_VSNone: {};
  Storage_VSRead: {};
  Storage_VSWrite: {};
  Storage_VSReadWrite: {};
}

export declare class Storage_TypedCallBack extends Standard_Transient {
  SetType(aType: XCAFDoc_PartId): void;
  Type(): XCAFDoc_PartId;
  SetCallBack(aCallBack: Handle_Storage_CallBack): void;
  CallBack(): Handle_Storage_CallBack;
  SetIndex(anIndex: Graphic3d_ZLayerId): void;
  Index(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_TypedCallBack_1 extends Storage_TypedCallBack {
    constructor();
  }

  export declare class Storage_TypedCallBack_2 extends Storage_TypedCallBack {
    constructor(aTypeName: XCAFDoc_PartId, aCallBack: Handle_Storage_CallBack);
  }

export declare class Handle_Storage_TypedCallBack {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_TypedCallBack): void;
  get(): Storage_TypedCallBack;
  delete(): void;
}

  export declare class Handle_Storage_TypedCallBack_1 extends Handle_Storage_TypedCallBack {
    constructor();
  }

  export declare class Handle_Storage_TypedCallBack_2 extends Handle_Storage_TypedCallBack {
    constructor(thePtr: Storage_TypedCallBack);
  }

  export declare class Handle_Storage_TypedCallBack_3 extends Handle_Storage_TypedCallBack {
    constructor(theHandle: Handle_Storage_TypedCallBack);
  }

  export declare class Handle_Storage_TypedCallBack_4 extends Handle_Storage_TypedCallBack {
    constructor(theHandle: Handle_Storage_TypedCallBack);
  }

export declare type Storage_Error = {
  Storage_VSOk: {};
  Storage_VSOpenError: {};
  Storage_VSModeError: {};
  Storage_VSCloseError: {};
  Storage_VSAlreadyOpen: {};
  Storage_VSNotOpen: {};
  Storage_VSSectionNotFound: {};
  Storage_VSWriteError: {};
  Storage_VSFormatError: {};
  Storage_VSUnknownType: {};
  Storage_VSTypeMismatch: {};
  Storage_VSInternalError: {};
  Storage_VSExtCharParityError: {};
  Storage_VSWrongFileDriver: {};
}

export declare class Handle_Storage_HArrayOfCallBack {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_HArrayOfCallBack): void;
  get(): Storage_HArrayOfCallBack;
  delete(): void;
}

  export declare class Handle_Storage_HArrayOfCallBack_1 extends Handle_Storage_HArrayOfCallBack {
    constructor();
  }

  export declare class Handle_Storage_HArrayOfCallBack_2 extends Handle_Storage_HArrayOfCallBack {
    constructor(thePtr: Storage_HArrayOfCallBack);
  }

  export declare class Handle_Storage_HArrayOfCallBack_3 extends Handle_Storage_HArrayOfCallBack {
    constructor(theHandle: Handle_Storage_HArrayOfCallBack);
  }

  export declare class Handle_Storage_HArrayOfCallBack_4 extends Handle_Storage_HArrayOfCallBack {
    constructor(theHandle: Handle_Storage_HArrayOfCallBack);
  }

export declare class Storage_Schema extends Standard_Transient {
  constructor()
  SetVersion(aVersion: XCAFDoc_PartId): void;
  Version(): XCAFDoc_PartId;
  SetName(aSchemaName: XCAFDoc_PartId): void;
  Name(): XCAFDoc_PartId;
  Write(s: Handle_Storage_BaseDriver, aData: Handle_Storage_Data): void;
  static ICreationDate(): XCAFDoc_PartId;
  static CheckTypeMigration(theTypeName: XCAFDoc_PartId, theNewName: XCAFDoc_PartId): Standard_Boolean;
  AddReadUnknownTypeCallBack(aTypeName: XCAFDoc_PartId, aCallBack: Handle_Storage_CallBack): void;
  RemoveReadUnknownTypeCallBack(aTypeName: XCAFDoc_PartId): void;
  InstalledCallBackList(): Handle_TColStd_HSequenceOfAsciiString;
  ClearCallBackList(): void;
  UseDefaultCallBack(): void;
  DontUseDefaultCallBack(): void;
  IsUsingDefaultCallBack(): Standard_Boolean;
  SetDefaultCallBack(f: Handle_Storage_CallBack): void;
  ResetDefaultCallBack(): void;
  DefaultCallBack(): Handle_Storage_CallBack;
  WritePersistentObjectHeader(sp: any, theDriver: Handle_Storage_BaseDriver): void;
  WritePersistentReference(sp: any, theDriver: Handle_Storage_BaseDriver): void;
  AddPersistent(sp: any, tName: Standard_CString): Standard_Boolean;
  PersistentToAdd(sp: any): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Storage_Schema {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_Schema): void;
  get(): Storage_Schema;
  delete(): void;
}

  export declare class Handle_Storage_Schema_1 extends Handle_Storage_Schema {
    constructor();
  }

  export declare class Handle_Storage_Schema_2 extends Handle_Storage_Schema {
    constructor(thePtr: Storage_Schema);
  }

  export declare class Handle_Storage_Schema_3 extends Handle_Storage_Schema {
    constructor(theHandle: Handle_Storage_Schema);
  }

  export declare class Handle_Storage_Schema_4 extends Handle_Storage_Schema {
    constructor(theHandle: Handle_Storage_Schema);
  }

export declare class Storage_StreamUnknownTypeError extends Storage_StreamReadError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamUnknownTypeError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamUnknownTypeError_1 extends Storage_StreamUnknownTypeError {
    constructor();
  }

  export declare class Storage_StreamUnknownTypeError_2 extends Storage_StreamUnknownTypeError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Storage_StreamUnknownTypeError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamUnknownTypeError): void;
  get(): Storage_StreamUnknownTypeError;
  delete(): void;
}

  export declare class Handle_Storage_StreamUnknownTypeError_1 extends Handle_Storage_StreamUnknownTypeError {
    constructor();
  }

  export declare class Handle_Storage_StreamUnknownTypeError_2 extends Handle_Storage_StreamUnknownTypeError {
    constructor(thePtr: Storage_StreamUnknownTypeError);
  }

  export declare class Handle_Storage_StreamUnknownTypeError_3 extends Handle_Storage_StreamUnknownTypeError {
    constructor(theHandle: Handle_Storage_StreamUnknownTypeError);
  }

  export declare class Handle_Storage_StreamUnknownTypeError_4 extends Handle_Storage_StreamUnknownTypeError {
    constructor(theHandle: Handle_Storage_StreamUnknownTypeError);
  }

export declare class Handle_Storage_HArrayOfSchema {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_HArrayOfSchema): void;
  get(): Storage_HArrayOfSchema;
  delete(): void;
}

  export declare class Handle_Storage_HArrayOfSchema_1 extends Handle_Storage_HArrayOfSchema {
    constructor();
  }

  export declare class Handle_Storage_HArrayOfSchema_2 extends Handle_Storage_HArrayOfSchema {
    constructor(thePtr: Storage_HArrayOfSchema);
  }

  export declare class Handle_Storage_HArrayOfSchema_3 extends Handle_Storage_HArrayOfSchema {
    constructor(theHandle: Handle_Storage_HArrayOfSchema);
  }

  export declare class Handle_Storage_HArrayOfSchema_4 extends Handle_Storage_HArrayOfSchema {
    constructor(theHandle: Handle_Storage_HArrayOfSchema);
  }

export declare class Storage_TypeData extends Standard_Transient {
  constructor()
  Read(theDriver: Handle_Storage_BaseDriver): Standard_Boolean;
  NumberOfTypes(): Graphic3d_ZLayerId;
  AddType(aName: XCAFDoc_PartId, aTypeNum: Graphic3d_ZLayerId): void;
  Type_1(aTypeNum: Graphic3d_ZLayerId): XCAFDoc_PartId;
  Type_2(aTypeName: XCAFDoc_PartId): Graphic3d_ZLayerId;
  IsType(aName: XCAFDoc_PartId): Standard_Boolean;
  Types(): Handle_TColStd_HSequenceOfAsciiString;
  ErrorStatus(): Storage_Error;
  ErrorStatusExtension(): XCAFDoc_PartId;
  ClearErrorStatus(): void;
  Clear(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Storage_TypeData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_TypeData): void;
  get(): Storage_TypeData;
  delete(): void;
}

  export declare class Handle_Storage_TypeData_1 extends Handle_Storage_TypeData {
    constructor();
  }

  export declare class Handle_Storage_TypeData_2 extends Handle_Storage_TypeData {
    constructor(thePtr: Storage_TypeData);
  }

  export declare class Handle_Storage_TypeData_3 extends Handle_Storage_TypeData {
    constructor(theHandle: Handle_Storage_TypeData);
  }

  export declare class Handle_Storage_TypeData_4 extends Handle_Storage_TypeData {
    constructor(theHandle: Handle_Storage_TypeData);
  }

export declare class Handle_Storage_BaseDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_BaseDriver): void;
  get(): Storage_BaseDriver;
  delete(): void;
}

  export declare class Handle_Storage_BaseDriver_1 extends Handle_Storage_BaseDriver {
    constructor();
  }

  export declare class Handle_Storage_BaseDriver_2 extends Handle_Storage_BaseDriver {
    constructor(thePtr: Storage_BaseDriver);
  }

  export declare class Handle_Storage_BaseDriver_3 extends Handle_Storage_BaseDriver {
    constructor(theHandle: Handle_Storage_BaseDriver);
  }

  export declare class Handle_Storage_BaseDriver_4 extends Handle_Storage_BaseDriver {
    constructor(theHandle: Handle_Storage_BaseDriver);
  }

export declare class Storage_DefaultCallBack extends Storage_CallBack {
  constructor()
  New(): any;
  Add(thePers: any, theSchema: Handle_Storage_Schema): void;
  Write(thePers: any, theDriver: Handle_Storage_BaseDriver, theSchema: Handle_Storage_Schema): void;
  Read(thePers: any, theDriver: Handle_Storage_BaseDriver, theSchema: Handle_Storage_Schema): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Storage_DefaultCallBack {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_DefaultCallBack): void;
  get(): Storage_DefaultCallBack;
  delete(): void;
}

  export declare class Handle_Storage_DefaultCallBack_1 extends Handle_Storage_DefaultCallBack {
    constructor();
  }

  export declare class Handle_Storage_DefaultCallBack_2 extends Handle_Storage_DefaultCallBack {
    constructor(thePtr: Storage_DefaultCallBack);
  }

  export declare class Handle_Storage_DefaultCallBack_3 extends Handle_Storage_DefaultCallBack {
    constructor(theHandle: Handle_Storage_DefaultCallBack);
  }

  export declare class Handle_Storage_DefaultCallBack_4 extends Handle_Storage_DefaultCallBack {
    constructor(theHandle: Handle_Storage_DefaultCallBack);
  }

export declare class Storage_StreamExtCharParityError extends Storage_StreamReadError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Storage_StreamExtCharParityError;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Storage_StreamExtCharParityError_1 extends Storage_StreamExtCharParityError {
    constructor();
  }

  export declare class Storage_StreamExtCharParityError_2 extends Storage_StreamExtCharParityError {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Storage_StreamExtCharParityError {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_StreamExtCharParityError): void;
  get(): Storage_StreamExtCharParityError;
  delete(): void;
}

  export declare class Handle_Storage_StreamExtCharParityError_1 extends Handle_Storage_StreamExtCharParityError {
    constructor();
  }

  export declare class Handle_Storage_StreamExtCharParityError_2 extends Handle_Storage_StreamExtCharParityError {
    constructor(thePtr: Storage_StreamExtCharParityError);
  }

  export declare class Handle_Storage_StreamExtCharParityError_3 extends Handle_Storage_StreamExtCharParityError {
    constructor(theHandle: Handle_Storage_StreamExtCharParityError);
  }

  export declare class Handle_Storage_StreamExtCharParityError_4 extends Handle_Storage_StreamExtCharParityError {
    constructor(theHandle: Handle_Storage_StreamExtCharParityError);
  }

export declare class Handle_Storage_CallBack {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_CallBack): void;
  get(): Storage_CallBack;
  delete(): void;
}

  export declare class Handle_Storage_CallBack_1 extends Handle_Storage_CallBack {
    constructor();
  }

  export declare class Handle_Storage_CallBack_2 extends Handle_Storage_CallBack {
    constructor(thePtr: Storage_CallBack);
  }

  export declare class Handle_Storage_CallBack_3 extends Handle_Storage_CallBack {
    constructor(theHandle: Handle_Storage_CallBack);
  }

  export declare class Handle_Storage_CallBack_4 extends Handle_Storage_CallBack {
    constructor(theHandle: Handle_Storage_CallBack);
  }

export declare class Storage_CallBack extends Standard_Transient {
  New(): any;
  Add(aPers: any, aSchema: Handle_Storage_Schema): void;
  Write(aPers: any, aDriver: Handle_Storage_BaseDriver, aSchema: Handle_Storage_Schema): void;
  Read(aPers: any, aDriver: Handle_Storage_BaseDriver, aSchema: Handle_Storage_Schema): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Storage_HSeqOfRoot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Storage_HSeqOfRoot): void;
  get(): Storage_HSeqOfRoot;
  delete(): void;
}

  export declare class Handle_Storage_HSeqOfRoot_1 extends Handle_Storage_HSeqOfRoot {
    constructor();
  }

  export declare class Handle_Storage_HSeqOfRoot_2 extends Handle_Storage_HSeqOfRoot {
    constructor(thePtr: Storage_HSeqOfRoot);
  }

  export declare class Handle_Storage_HSeqOfRoot_3 extends Handle_Storage_HSeqOfRoot {
    constructor(theHandle: Handle_Storage_HSeqOfRoot);
  }

  export declare class Handle_Storage_HSeqOfRoot_4 extends Handle_Storage_HSeqOfRoot {
    constructor(theHandle: Handle_Storage_HSeqOfRoot);
  }

export declare class IntImpParGen {
  constructor();
  static DetermineTransition_1(Pos1: IntRes2d_Position, Tan1: gp_Vec2d, Norm1: gp_Vec2d, Trans1: IntRes2d_Transition, Pos2: IntRes2d_Position, Tan2: gp_Vec2d, Norm2: gp_Vec2d, Trans2: IntRes2d_Transition, Tol: Quantity_AbsorbedDose): void;
  static DetermineTransition_2(Pos1: IntRes2d_Position, Tan1: gp_Vec2d, Trans1: IntRes2d_Transition, Pos2: IntRes2d_Position, Tan2: gp_Vec2d, Trans2: IntRes2d_Transition, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  static DeterminePosition(Pos1: IntRes2d_Position, Dom1: IntRes2d_Domain, P1: gp_Pnt2d, Tol: Quantity_AbsorbedDose): void;
  static NormalizeOnDomain(Par1: Quantity_AbsorbedDose, Dom1: IntRes2d_Domain): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_XmlMDF_ReferenceDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDF_ReferenceDriver): void;
  get(): XmlMDF_ReferenceDriver;
  delete(): void;
}

  export declare class Handle_XmlMDF_ReferenceDriver_1 extends Handle_XmlMDF_ReferenceDriver {
    constructor();
  }

  export declare class Handle_XmlMDF_ReferenceDriver_2 extends Handle_XmlMDF_ReferenceDriver {
    constructor(thePtr: XmlMDF_ReferenceDriver);
  }

  export declare class Handle_XmlMDF_ReferenceDriver_3 extends Handle_XmlMDF_ReferenceDriver {
    constructor(theHandle: Handle_XmlMDF_ReferenceDriver);
  }

  export declare class Handle_XmlMDF_ReferenceDriver_4 extends Handle_XmlMDF_ReferenceDriver {
    constructor(theHandle: Handle_XmlMDF_ReferenceDriver);
  }

export declare class XmlMDF_ReferenceDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDF_TagSourceDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDF_TagSourceDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDF_TagSourceDriver): void;
  get(): XmlMDF_TagSourceDriver;
  delete(): void;
}

  export declare class Handle_XmlMDF_TagSourceDriver_1 extends Handle_XmlMDF_TagSourceDriver {
    constructor();
  }

  export declare class Handle_XmlMDF_TagSourceDriver_2 extends Handle_XmlMDF_TagSourceDriver {
    constructor(thePtr: XmlMDF_TagSourceDriver);
  }

  export declare class Handle_XmlMDF_TagSourceDriver_3 extends Handle_XmlMDF_TagSourceDriver {
    constructor(theHandle: Handle_XmlMDF_TagSourceDriver);
  }

  export declare class Handle_XmlMDF_TagSourceDriver_4 extends Handle_XmlMDF_TagSourceDriver {
    constructor(theHandle: Handle_XmlMDF_TagSourceDriver);
  }

export declare class XmlMDF_ADriver extends Standard_Transient {
  VersionNumber(): Graphic3d_ZLayerId;
  NewEmpty(): Handle_TDF_Attribute;
  SourceType(): Handle_Standard_Type;
  TypeName(): XCAFDoc_PartId;
  Namespace(): XCAFDoc_PartId;
  Paste_1(aSource: XmlObjMgt_Persistent, aTarget: Handle_TDF_Attribute, aRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(aSource: Handle_TDF_Attribute, aTarget: XmlObjMgt_Persistent, aRelocTable: XmlObjMgt_SRelocationTable): void;
  MessageDriver(): Handle_Message_Messenger;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMDF_ADriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDF_ADriver): void;
  get(): XmlMDF_ADriver;
  delete(): void;
}

  export declare class Handle_XmlMDF_ADriver_1 extends Handle_XmlMDF_ADriver {
    constructor();
  }

  export declare class Handle_XmlMDF_ADriver_2 extends Handle_XmlMDF_ADriver {
    constructor(thePtr: XmlMDF_ADriver);
  }

  export declare class Handle_XmlMDF_ADriver_3 extends Handle_XmlMDF_ADriver {
    constructor(theHandle: Handle_XmlMDF_ADriver);
  }

  export declare class Handle_XmlMDF_ADriver_4 extends Handle_XmlMDF_ADriver {
    constructor(theHandle: Handle_XmlMDF_ADriver);
  }

export declare class Handle_XmlMDF_ADriverTable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMDF_ADriverTable): void;
  get(): XmlMDF_ADriverTable;
  delete(): void;
}

  export declare class Handle_XmlMDF_ADriverTable_1 extends Handle_XmlMDF_ADriverTable {
    constructor();
  }

  export declare class Handle_XmlMDF_ADriverTable_2 extends Handle_XmlMDF_ADriverTable {
    constructor(thePtr: XmlMDF_ADriverTable);
  }

  export declare class Handle_XmlMDF_ADriverTable_3 extends Handle_XmlMDF_ADriverTable {
    constructor(theHandle: Handle_XmlMDF_ADriverTable);
  }

  export declare class Handle_XmlMDF_ADriverTable_4 extends Handle_XmlMDF_ADriverTable {
    constructor(theHandle: Handle_XmlMDF_ADriverTable);
  }

export declare class XmlMDF_ADriverTable extends Standard_Transient {
  constructor()
  AddDriver(anHDriver: Handle_XmlMDF_ADriver): void;
  AddDerivedDriver_1(theInstance: Handle_TDF_Attribute): void;
  AddDerivedDriver_2(theDerivedType: Standard_CString): Handle_Standard_Type;
  CreateDrvMap(theDriverMap: XmlMDF_MapOfDriver): void;
  GetDriver(theType: Handle_Standard_Type, theDriver: Handle_XmlMDF_ADriver): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMDF {
  constructor();
  static FromTo_1(aSource: Handle_TDF_Data, aTarget: XmlObjMgt_Element, aReloc: XmlObjMgt_SRelocationTable, aDrivers: Handle_XmlMDF_ADriverTable, theRange: Message_ProgressRange): void;
  static FromTo_2(aSource: XmlObjMgt_Element, aTarget: Handle_TDF_Data, aReloc: XmlObjMgt_RRelocationTable, aDrivers: Handle_XmlMDF_ADriverTable, theRange: Message_ProgressRange): Standard_Boolean;
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, theMessageDriver: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class XmlMDF_DerivedDriver extends XmlMDF_ADriver {
  constructor(theDerivative: Handle_TDF_Attribute, theBaseDriver: Handle_XmlMDF_ADriver)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  TypeName(): XCAFDoc_PartId;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  delete(): void;
}

export declare type RWMesh_CoordinateSystem = {
  RWMesh_CoordinateSystem_Undefined: {};
  RWMesh_CoordinateSystem_posYfwd_posZup: {};
  RWMesh_CoordinateSystem_negZfwd_posYup: {};
  RWMesh_CoordinateSystem_Blender: {};
  RWMesh_CoordinateSystem_glTF: {};
  RWMesh_CoordinateSystem_Zup: {};
  RWMesh_CoordinateSystem_Yup: {};
}

export declare class RWMesh_MaterialMap {
  DefaultStyle(): XCAFPrs_Style;
  SetDefaultStyle(theStyle: XCAFPrs_Style): void;
  FindMaterial(theStyle: XCAFPrs_Style): XCAFDoc_PartId;
  AddMaterial(theStyle: XCAFPrs_Style): XCAFDoc_PartId;
  CreateTextureFolder(): Standard_Boolean;
  CopyTexture(theResTexture: XCAFDoc_PartId, theTexture: any, theKey: XCAFDoc_PartId): Standard_Boolean;
  DefineMaterial(theStyle: XCAFPrs_Style, theKey: XCAFDoc_PartId, theName: XCAFDoc_PartId): void;
  IsFailed(): Standard_Boolean;
  delete(): void;
}

export declare class RWMesh_CoordinateSystemConverter {
  constructor()
  static StandardCoordinateSystem(theSys: RWMesh_CoordinateSystem): gp_Ax3;
  IsEmpty(): Standard_Boolean;
  InputLengthUnit(): Quantity_AbsorbedDose;
  SetInputLengthUnit(theInputScale: Quantity_AbsorbedDose): void;
  OutputLengthUnit(): Quantity_AbsorbedDose;
  SetOutputLengthUnit(theOutputScale: Quantity_AbsorbedDose): void;
  HasInputCoordinateSystem(): Standard_Boolean;
  InputCoordinateSystem(): gp_Ax3;
  SetInputCoordinateSystem_1(theSysFrom: gp_Ax3): void;
  SetInputCoordinateSystem_2(theSysFrom: RWMesh_CoordinateSystem): void;
  HasOutputCoordinateSystem(): Standard_Boolean;
  OutputCoordinateSystem(): gp_Ax3;
  SetOutputCoordinateSystem_1(theSysTo: gp_Ax3): void;
  SetOutputCoordinateSystem_2(theSysTo: RWMesh_CoordinateSystem): void;
  Init(theInputSystem: gp_Ax3, theInputLengthUnit: Quantity_AbsorbedDose, theOutputSystem: gp_Ax3, theOutputLengthUnit: Quantity_AbsorbedDose): void;
  TransformTransformation(theTrsf: gp_Trsf): void;
  TransformPosition(thePos: gp_XYZ): void;
  TransformNormal(theNorm: OpenGl_Vec3): void;
  delete(): void;
}

export declare class RWMesh_NodeAttributes {
  constructor();
  delete(): void;
}

export declare class RWMesh_NodeAttributeMap extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: RWMesh_NodeAttributeMap): void;
  Assign(theOther: RWMesh_NodeAttributeMap): RWMesh_NodeAttributeMap;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: RWMesh_NodeAttributes): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: RWMesh_NodeAttributes): RWMesh_NodeAttributes;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): RWMesh_NodeAttributes;
  ChangeSeek(theKey: TopoDS_Shape): RWMesh_NodeAttributes;
  ChangeFind(theKey: TopoDS_Shape): RWMesh_NodeAttributes;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class RWMesh_NodeAttributeMap_1 extends RWMesh_NodeAttributeMap {
    constructor();
  }

  export declare class RWMesh_NodeAttributeMap_2 extends RWMesh_NodeAttributeMap {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class RWMesh_NodeAttributeMap_3 extends RWMesh_NodeAttributeMap {
    constructor(theOther: RWMesh_NodeAttributeMap);
  }

export declare class RWMesh_FaceIterator {
  constructor(theLabel: TDF_Label, theLocation: TopLoc_Location, theToMapColors: Standard_Boolean, theStyle: XCAFPrs_Style)
  More(): Standard_Boolean;
  Next(): void;
  Face(): TopoDS_Face;
  Triangulation(): Handle_Poly_Triangulation;
  IsEmptyMesh(): Standard_Boolean;
  FaceStyle(): XCAFPrs_Style;
  HasFaceColor(): Standard_Boolean;
  FaceColor(): Quantity_ColorRGBA;
  NbTriangles(): Graphic3d_ZLayerId;
  ElemLower(): Graphic3d_ZLayerId;
  ElemUpper(): Graphic3d_ZLayerId;
  TriangleOriented(theElemIndex: Graphic3d_ZLayerId): Poly_Triangle;
  HasNormals(): Standard_Boolean;
  HasTexCoords(): Standard_Boolean;
  NormalTransformed(theNode: Graphic3d_ZLayerId): gp_Dir;
  NbNodes(): Graphic3d_ZLayerId;
  NodeLower(): Graphic3d_ZLayerId;
  NodeUpper(): Graphic3d_ZLayerId;
  NodeTransformed(theNode: Graphic3d_ZLayerId): gp_Pnt;
  NodeTexCoord(theNode: Graphic3d_ZLayerId): gp_Pnt2d;
  node(theNode: Graphic3d_ZLayerId): gp_Pnt;
  normal(theNode: Graphic3d_ZLayerId): gp_Dir;
  triangle(theElemIndex: Graphic3d_ZLayerId): Poly_Triangle;
  delete(): void;
}

export declare type RWMesh_CafReaderStatusEx = {
  RWMesh_CafReaderStatusEx_NONE: {};
  RWMesh_CafReaderStatusEx_Partial: {};
}

export declare class RWMesh_CafReader extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Document(): Handle_TDocStd_Document;
  SetDocument(theDoc: Handle_TDocStd_Document): void;
  RootPrefix(): XCAFDoc_PartId;
  SetRootPrefix(theRootPrefix: XCAFDoc_PartId): void;
  ToFillIncompleteDocument(): Standard_Boolean;
  SetFillIncompleteDocument(theToFillIncomplete: Standard_Boolean): void;
  MemoryLimitMiB(): Graphic3d_ZLayerId;
  SetMemoryLimitMiB(theLimitMiB: Graphic3d_ZLayerId): void;
  CoordinateSystemConverter(): RWMesh_CoordinateSystemConverter;
  SetCoordinateSystemConverter(theConverter: RWMesh_CoordinateSystemConverter): void;
  SystemLengthUnit(): Quantity_AbsorbedDose;
  SetSystemLengthUnit(theUnits: Quantity_AbsorbedDose): void;
  HasSystemCoordinateSystem(): Standard_Boolean;
  SystemCoordinateSystem(): gp_Ax3;
  SetSystemCoordinateSystem_1(theCS: gp_Ax3): void;
  SetSystemCoordinateSystem_2(theCS: RWMesh_CoordinateSystem): void;
  FileLengthUnit(): Quantity_AbsorbedDose;
  SetFileLengthUnit(theUnits: Quantity_AbsorbedDose): void;
  HasFileCoordinateSystem(): Standard_Boolean;
  FileCoordinateSystem(): gp_Ax3;
  SetFileCoordinateSystem_1(theCS: gp_Ax3): void;
  SetFileCoordinateSystem_2(theCS: RWMesh_CoordinateSystem): void;
  Perform(theFile: XCAFDoc_PartId, theProgress: Message_ProgressRange): Standard_Boolean;
  ExtraStatus(): Graphic3d_ZLayerId;
  SingleShape(): TopoDS_Shape;
  ExternalFiles(): any;
  Metadata(): TColStd_IndexedDataMapOfStringString;
  ProbeHeader(theFile: XCAFDoc_PartId, theProgress: Message_ProgressRange): Standard_Boolean;
  delete(): void;
}

export declare class IntSurf_Transition {
  SetValue_1(Tangent: Standard_Boolean, Type: IntSurf_TypeTrans): void;
  SetValue_2(Tangent: Standard_Boolean, Situ: IntSurf_Situation, Oppos: Standard_Boolean): void;
  SetValue_3(): void;
  TransitionType(): IntSurf_TypeTrans;
  IsTangent(): Standard_Boolean;
  Situation(): IntSurf_Situation;
  IsOpposite(): Standard_Boolean;
  delete(): void;
}

  export declare class IntSurf_Transition_1 extends IntSurf_Transition {
    constructor();
  }

  export declare class IntSurf_Transition_2 extends IntSurf_Transition {
    constructor(Tangent: Standard_Boolean, Type: IntSurf_TypeTrans);
  }

  export declare class IntSurf_Transition_3 extends IntSurf_Transition {
    constructor(Tangent: Standard_Boolean, Situ: IntSurf_Situation, Oppos: Standard_Boolean);
  }

export declare class IntSurf_PathPointTool {
  constructor();
  static Value3d(PStart: IntSurf_PathPoint): gp_Pnt;
  static Value2d(PStart: IntSurf_PathPoint, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static IsPassingPnt(PStart: IntSurf_PathPoint): Standard_Boolean;
  static IsTangent(PStart: IntSurf_PathPoint): Standard_Boolean;
  static Direction3d(PStart: IntSurf_PathPoint): gp_Vec;
  static Direction2d(PStart: IntSurf_PathPoint): gp_Dir2d;
  static Multiplicity(PStart: IntSurf_PathPoint): Graphic3d_ZLayerId;
  static Parameters(PStart: IntSurf_PathPoint, Mult: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class IntSurf_InteriorPoint {
  SetValue(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Direc: gp_Vec, Direc2d: gp_Vec2d): void;
  Value(): gp_Pnt;
  Parameters(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  UParameter(): Quantity_AbsorbedDose;
  VParameter(): Quantity_AbsorbedDose;
  Direction(): gp_Vec;
  Direction2d(): gp_Vec2d;
  delete(): void;
}

  export declare class IntSurf_InteriorPoint_1 extends IntSurf_InteriorPoint {
    constructor();
  }

  export declare class IntSurf_InteriorPoint_2 extends IntSurf_InteriorPoint {
    constructor(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Direc: gp_Vec, Direc2d: gp_Vec2d);
  }

export declare class IntSurf_ListOfPntOn2S extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: IntSurf_ListOfPntOn2S): IntSurf_ListOfPntOn2S;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): IntSurf_PntOn2S;
  First_2(): IntSurf_PntOn2S;
  Last_1(): IntSurf_PntOn2S;
  Last_2(): IntSurf_PntOn2S;
  Append_1(theItem: IntSurf_PntOn2S): IntSurf_PntOn2S;
  Append_3(theOther: IntSurf_ListOfPntOn2S): void;
  Prepend_1(theItem: IntSurf_PntOn2S): IntSurf_PntOn2S;
  Prepend_2(theOther: IntSurf_ListOfPntOn2S): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class IntSurf_ListOfPntOn2S_1 extends IntSurf_ListOfPntOn2S {
    constructor();
  }

  export declare class IntSurf_ListOfPntOn2S_2 extends IntSurf_ListOfPntOn2S {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntSurf_ListOfPntOn2S_3 extends IntSurf_ListOfPntOn2S {
    constructor(theOther: IntSurf_ListOfPntOn2S);
  }

export declare class IntSurf_SequenceOfPathPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntSurf_SequenceOfPathPoint): IntSurf_SequenceOfPathPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntSurf_PathPoint): void;
  Append_2(theSeq: IntSurf_SequenceOfPathPoint): void;
  Prepend_1(theItem: IntSurf_PathPoint): void;
  Prepend_2(theSeq: IntSurf_SequenceOfPathPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntSurf_PathPoint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfPathPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfPathPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntSurf_PathPoint): void;
  Split(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfPathPoint): void;
  First(): IntSurf_PathPoint;
  ChangeFirst(): IntSurf_PathPoint;
  Last(): IntSurf_PathPoint;
  ChangeLast(): IntSurf_PathPoint;
  Value(theIndex: Standard_Integer): IntSurf_PathPoint;
  ChangeValue(theIndex: Standard_Integer): IntSurf_PathPoint;
  SetValue(theIndex: Standard_Integer, theItem: IntSurf_PathPoint): void;
  delete(): void;
}

  export declare class IntSurf_SequenceOfPathPoint_1 extends IntSurf_SequenceOfPathPoint {
    constructor();
  }

  export declare class IntSurf_SequenceOfPathPoint_2 extends IntSurf_SequenceOfPathPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntSurf_SequenceOfPathPoint_3 extends IntSurf_SequenceOfPathPoint {
    constructor(theOther: IntSurf_SequenceOfPathPoint);
  }

export declare class IntSurf_Couple {
  First(): Graphic3d_ZLayerId;
  Second(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class IntSurf_Couple_1 extends IntSurf_Couple {
    constructor();
  }

  export declare class IntSurf_Couple_2 extends IntSurf_Couple {
    constructor(Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId);
  }

export declare class IntSurf {
  constructor();
  static MakeTransition(TgFirst: gp_Vec, TgSecond: gp_Vec, Normal: gp_Dir, TFirst: IntSurf_Transition, TSecond: IntSurf_Transition): void;
  static SetPeriod(theFirstSurf: Handle_Adaptor3d_HSurface, theSecondSurf: Handle_Adaptor3d_HSurface, theArrOfPeriod: Standard_Real [4]): void;
  delete(): void;
}

export declare type IntSurf_Situation = {
  IntSurf_Inside: {};
  IntSurf_Outside: {};
  IntSurf_Unknown: {};
}

export declare class IntSurf_LineOn2S extends Standard_Transient {
  constructor(theAllocator: IntSurf_Allocator)
  Add(P: IntSurf_PntOn2S): void;
  NbPoints(): Graphic3d_ZLayerId;
  Value_1(Index: Graphic3d_ZLayerId): IntSurf_PntOn2S;
  Reverse(): void;
  Split(Index: Graphic3d_ZLayerId): Handle_IntSurf_LineOn2S;
  Value_2(Index: Graphic3d_ZLayerId, P: IntSurf_PntOn2S): void;
  SetUV(Index: Graphic3d_ZLayerId, OnFirst: Standard_Boolean, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Clear(): void;
  InsertBefore(I: Graphic3d_ZLayerId, P: IntSurf_PntOn2S): void;
  RemovePoint(I: Graphic3d_ZLayerId): void;
  IsOutSurf1Box(theP: gp_Pnt2d): Standard_Boolean;
  IsOutSurf2Box(theP: gp_Pnt2d): Standard_Boolean;
  IsOutBox(theP: gp_Pnt): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IntSurf_LineOn2S {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IntSurf_LineOn2S): void;
  get(): IntSurf_LineOn2S;
  delete(): void;
}

  export declare class Handle_IntSurf_LineOn2S_1 extends Handle_IntSurf_LineOn2S {
    constructor();
  }

  export declare class Handle_IntSurf_LineOn2S_2 extends Handle_IntSurf_LineOn2S {
    constructor(thePtr: IntSurf_LineOn2S);
  }

  export declare class Handle_IntSurf_LineOn2S_3 extends Handle_IntSurf_LineOn2S {
    constructor(theHandle: Handle_IntSurf_LineOn2S);
  }

  export declare class Handle_IntSurf_LineOn2S_4 extends Handle_IntSurf_LineOn2S {
    constructor(theHandle: Handle_IntSurf_LineOn2S);
  }

export declare class IntSurf_PathPoint {
  SetValue(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  AddUV(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  SetDirections(V: gp_Vec, D: gp_Dir2d): void;
  SetTangency(Tang: Standard_Boolean): void;
  SetPassing(Pass: Standard_Boolean): void;
  Value(): gp_Pnt;
  Value2d(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  IsPassingPnt(): Standard_Boolean;
  IsTangent(): Standard_Boolean;
  Direction3d(): gp_Vec;
  Direction2d(): gp_Dir2d;
  Multiplicity(): Graphic3d_ZLayerId;
  Parameters(Index: Graphic3d_ZLayerId, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntSurf_PathPoint_1 extends IntSurf_PathPoint {
    constructor();
  }

  export declare class IntSurf_PathPoint_2 extends IntSurf_PathPoint {
    constructor(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose);
  }

export declare class IntSurf_SequenceOfCouple extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntSurf_SequenceOfCouple): IntSurf_SequenceOfCouple;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntSurf_Couple): void;
  Append_2(theSeq: IntSurf_SequenceOfCouple): void;
  Prepend_1(theItem: IntSurf_Couple): void;
  Prepend_2(theSeq: IntSurf_SequenceOfCouple): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntSurf_Couple): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfCouple): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfCouple): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntSurf_Couple): void;
  Split(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfCouple): void;
  First(): IntSurf_Couple;
  ChangeFirst(): IntSurf_Couple;
  Last(): IntSurf_Couple;
  ChangeLast(): IntSurf_Couple;
  Value(theIndex: Standard_Integer): IntSurf_Couple;
  ChangeValue(theIndex: Standard_Integer): IntSurf_Couple;
  SetValue(theIndex: Standard_Integer, theItem: IntSurf_Couple): void;
  delete(): void;
}

  export declare class IntSurf_SequenceOfCouple_1 extends IntSurf_SequenceOfCouple {
    constructor();
  }

  export declare class IntSurf_SequenceOfCouple_2 extends IntSurf_SequenceOfCouple {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntSurf_SequenceOfCouple_3 extends IntSurf_SequenceOfCouple {
    constructor(theOther: IntSurf_SequenceOfCouple);
  }

export declare class IntSurf_PntOn2S {
  constructor()
  SetValue_1(Pt: gp_Pnt): void;
  SetValue_2(Pt: gp_Pnt, OnFirst: Standard_Boolean, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  SetValue_3(Pt: gp_Pnt, U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  SetValue_4(OnFirst: Standard_Boolean, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  SetValue_5(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  Value(): gp_Pnt;
  ValueOnSurface(OnFirst: Standard_Boolean): gp_Pnt2d;
  ParametersOnS1(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose): void;
  ParametersOnS2(U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  ParametersOnSurface(OnFirst: Standard_Boolean, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Parameters(U1: Quantity_AbsorbedDose, V1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, V2: Quantity_AbsorbedDose): void;
  IsSame(theOtherPoint: IntSurf_PntOn2S, theTol3D: Quantity_AbsorbedDose, theTol2D: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class IntSurf_Quadric {
  SetValue_1(P: gp_Pln): void;
  SetValue_2(C: gp_Cylinder): void;
  SetValue_3(S: gp_Sphere): void;
  SetValue_4(C: gp_Cone): void;
  SetValue_5(T: gp_Torus): void;
  Distance(P: gp_Pnt): Quantity_AbsorbedDose;
  Gradient(P: gp_Pnt): gp_Vec;
  ValAndGrad(P: gp_Pnt, Dist: Quantity_AbsorbedDose, Grad: gp_Vec): void;
  TypeQuadric(): GeomAbs_SurfaceType;
  Plane(): gp_Pln;
  Sphere(): gp_Sphere;
  Cylinder(): gp_Cylinder;
  Cone(): gp_Cone;
  Torus(): gp_Torus;
  Value(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Pnt;
  D1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, P: gp_Pnt, D1U: gp_Vec, D1V: gp_Vec): void;
  DN(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Nu: Graphic3d_ZLayerId, Nv: Graphic3d_ZLayerId): gp_Vec;
  Normale_1(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): gp_Vec;
  Parameters(P: gp_Pnt, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  Normale_2(P: gp_Pnt): gp_Vec;
  delete(): void;
}

  export declare class IntSurf_Quadric_1 extends IntSurf_Quadric {
    constructor();
  }

  export declare class IntSurf_Quadric_2 extends IntSurf_Quadric {
    constructor(P: gp_Pln);
  }

  export declare class IntSurf_Quadric_3 extends IntSurf_Quadric {
    constructor(C: gp_Cylinder);
  }

  export declare class IntSurf_Quadric_4 extends IntSurf_Quadric {
    constructor(S: gp_Sphere);
  }

  export declare class IntSurf_Quadric_5 extends IntSurf_Quadric {
    constructor(C: gp_Cone);
  }

  export declare class IntSurf_Quadric_6 extends IntSurf_Quadric {
    constructor(T: gp_Torus);
  }

export declare type IntSurf_TypeTrans = {
  IntSurf_In: {};
  IntSurf_Out: {};
  IntSurf_Touch: {};
  IntSurf_Undecided: {};
}

export declare class IntSurf_InteriorPointTool {
  constructor();
  static Value3d(PStart: IntSurf_InteriorPoint): gp_Pnt;
  static Value2d(PStart: IntSurf_InteriorPoint, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose): void;
  static Direction3d(PStart: IntSurf_InteriorPoint): gp_Vec;
  static Direction2d(PStart: IntSurf_InteriorPoint): gp_Dir2d;
  delete(): void;
}

export declare class IntSurf_QuadricTool {
  constructor();
  static Value(Quad: IntSurf_Quadric, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static Gradient(Quad: IntSurf_Quadric, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, V: gp_Vec): void;
  static ValueAndGradient(Quad: IntSurf_Quadric, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, Val: Quantity_AbsorbedDose, Grad: gp_Vec): void;
  static Tolerance(Quad: IntSurf_Quadric): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class IntSurf_SequenceOfPntOn2S extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntSurf_SequenceOfPntOn2S): IntSurf_SequenceOfPntOn2S;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntSurf_PntOn2S): void;
  Append_2(theSeq: IntSurf_SequenceOfPntOn2S): void;
  Prepend_1(theItem: IntSurf_PntOn2S): void;
  Prepend_2(theSeq: IntSurf_SequenceOfPntOn2S): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntSurf_PntOn2S): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfPntOn2S): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfPntOn2S): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntSurf_PntOn2S): void;
  Split(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfPntOn2S): void;
  First(): IntSurf_PntOn2S;
  ChangeFirst(): IntSurf_PntOn2S;
  Last(): IntSurf_PntOn2S;
  ChangeLast(): IntSurf_PntOn2S;
  Value(theIndex: Standard_Integer): IntSurf_PntOn2S;
  ChangeValue(theIndex: Standard_Integer): IntSurf_PntOn2S;
  SetValue(theIndex: Standard_Integer, theItem: IntSurf_PntOn2S): void;
  delete(): void;
}

  export declare class IntSurf_SequenceOfPntOn2S_1 extends IntSurf_SequenceOfPntOn2S {
    constructor();
  }

  export declare class IntSurf_SequenceOfPntOn2S_2 extends IntSurf_SequenceOfPntOn2S {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntSurf_SequenceOfPntOn2S_3 extends IntSurf_SequenceOfPntOn2S {
    constructor(theOther: IntSurf_SequenceOfPntOn2S);
  }

export declare class IntSurf_SequenceOfInteriorPoint extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntSurf_SequenceOfInteriorPoint): IntSurf_SequenceOfInteriorPoint;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntSurf_InteriorPoint): void;
  Append_2(theSeq: IntSurf_SequenceOfInteriorPoint): void;
  Prepend_1(theItem: IntSurf_InteriorPoint): void;
  Prepend_2(theSeq: IntSurf_SequenceOfInteriorPoint): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntSurf_InteriorPoint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfInteriorPoint): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfInteriorPoint): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntSurf_InteriorPoint): void;
  Split(theIndex: Standard_Integer, theSeq: IntSurf_SequenceOfInteriorPoint): void;
  First(): IntSurf_InteriorPoint;
  ChangeFirst(): IntSurf_InteriorPoint;
  Last(): IntSurf_InteriorPoint;
  ChangeLast(): IntSurf_InteriorPoint;
  Value(theIndex: Standard_Integer): IntSurf_InteriorPoint;
  ChangeValue(theIndex: Standard_Integer): IntSurf_InteriorPoint;
  SetValue(theIndex: Standard_Integer, theItem: IntSurf_InteriorPoint): void;
  delete(): void;
}

  export declare class IntSurf_SequenceOfInteriorPoint_1 extends IntSurf_SequenceOfInteriorPoint {
    constructor();
  }

  export declare class IntSurf_SequenceOfInteriorPoint_2 extends IntSurf_SequenceOfInteriorPoint {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntSurf_SequenceOfInteriorPoint_3 extends IntSurf_SequenceOfInteriorPoint {
    constructor(theOther: IntSurf_SequenceOfInteriorPoint);
  }

export declare class XCAFDoc_Area extends TDataStd_Real {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  Set_1(vol: Quantity_AbsorbedDose): void;
  static Set_2(label: TDF_Label, area: Quantity_AbsorbedDose): Handle_XCAFDoc_Area;
  Get_1(): Quantity_AbsorbedDose;
  static Get_2(label: TDF_Label, area: Quantity_AbsorbedDose): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_Area {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Area): void;
  get(): XCAFDoc_Area;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Area_1 extends Handle_XCAFDoc_Area {
    constructor();
  }

  export declare class Handle_XCAFDoc_Area_2 extends Handle_XCAFDoc_Area {
    constructor(thePtr: XCAFDoc_Area);
  }

  export declare class Handle_XCAFDoc_Area_3 extends Handle_XCAFDoc_Area {
    constructor(theHandle: Handle_XCAFDoc_Area);
  }

  export declare class Handle_XCAFDoc_Area_4 extends Handle_XCAFDoc_Area {
    constructor(theHandle: Handle_XCAFDoc_Area);
  }

export declare class XCAFDoc_LayerTool extends TDataStd_GenericEmpty {
  constructor()
  static Set(L: TDF_Label): Handle_XCAFDoc_LayerTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  ShapeTool(): Handle_XCAFDoc_ShapeTool;
  IsLayer(lab: TDF_Label): Standard_Boolean;
  GetLayer(lab: TDF_Label, aLayer: TCollection_ExtendedString): Standard_Boolean;
  FindLayer_1(aLayer: TCollection_ExtendedString, lab: TDF_Label): Standard_Boolean;
  FindLayer_2(aLayer: TCollection_ExtendedString): TDF_Label;
  AddLayer(aLayer: TCollection_ExtendedString): TDF_Label;
  RemoveLayer(lab: TDF_Label): void;
  GetLayerLabels(Labels: TDF_LabelSequence): void;
  SetLayer_1(L: TDF_Label, LayerL: TDF_Label, shapeInOneLayer: Standard_Boolean): void;
  SetLayer_2(L: TDF_Label, aLayer: TCollection_ExtendedString, shapeInOneLayer: Standard_Boolean): void;
  UnSetLayers_1(L: TDF_Label): void;
  UnSetOneLayer_1(L: TDF_Label, aLayer: TCollection_ExtendedString): Standard_Boolean;
  UnSetOneLayer_2(L: TDF_Label, aLayerL: TDF_Label): Standard_Boolean;
  IsSet_1(L: TDF_Label, aLayer: TCollection_ExtendedString): Standard_Boolean;
  IsSet_2(L: TDF_Label, aLayerL: TDF_Label): Standard_Boolean;
  GetLayers_1(L: TDF_Label, aLayerS: Handle_TColStd_HSequenceOfExtendedString): Standard_Boolean;
  GetLayers_2(L: TDF_Label, aLayerLS: TDF_LabelSequence): Standard_Boolean;
  GetLayers_3(L: TDF_Label): Handle_TColStd_HSequenceOfExtendedString;
  GetShapesOfLayer(layerL: TDF_Label, ShLabels: TDF_LabelSequence): void;
  IsVisible(layerL: TDF_Label): Standard_Boolean;
  SetVisibility(layerL: TDF_Label, isvisible: Standard_Boolean): void;
  SetLayer_3(Sh: TopoDS_Shape, LayerL: TDF_Label, shapeInOneLayer: Standard_Boolean): Standard_Boolean;
  SetLayer_4(Sh: TopoDS_Shape, aLayer: TCollection_ExtendedString, shapeInOneLayer: Standard_Boolean): Standard_Boolean;
  UnSetLayers_2(Sh: TopoDS_Shape): Standard_Boolean;
  UnSetOneLayer_3(Sh: TopoDS_Shape, aLayer: TCollection_ExtendedString): Standard_Boolean;
  UnSetOneLayer_4(Sh: TopoDS_Shape, aLayerL: TDF_Label): Standard_Boolean;
  IsSet_3(Sh: TopoDS_Shape, aLayer: TCollection_ExtendedString): Standard_Boolean;
  IsSet_4(Sh: TopoDS_Shape, aLayerL: TDF_Label): Standard_Boolean;
  GetLayers_4(Sh: TopoDS_Shape, aLayerS: Handle_TColStd_HSequenceOfExtendedString): Standard_Boolean;
  GetLayers_5(Sh: TopoDS_Shape, aLayerLS: TDF_LabelSequence): Standard_Boolean;
  GetLayers_6(Sh: TopoDS_Shape): Handle_TColStd_HSequenceOfExtendedString;
  ID(): Standard_GUID;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_LayerTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_LayerTool): void;
  get(): XCAFDoc_LayerTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_LayerTool_1 extends Handle_XCAFDoc_LayerTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_LayerTool_2 extends Handle_XCAFDoc_LayerTool {
    constructor(thePtr: XCAFDoc_LayerTool);
  }

  export declare class Handle_XCAFDoc_LayerTool_3 extends Handle_XCAFDoc_LayerTool {
    constructor(theHandle: Handle_XCAFDoc_LayerTool);
  }

  export declare class Handle_XCAFDoc_LayerTool_4 extends Handle_XCAFDoc_LayerTool {
    constructor(theHandle: Handle_XCAFDoc_LayerTool);
  }

export declare class XCAFDoc_MaterialTool extends TDataStd_GenericEmpty {
  constructor()
  static Set(L: TDF_Label): Handle_XCAFDoc_MaterialTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  ShapeTool(): Handle_XCAFDoc_ShapeTool;
  IsMaterial(lab: TDF_Label): Standard_Boolean;
  GetMaterialLabels(Labels: TDF_LabelSequence): void;
  AddMaterial(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aDensity: Quantity_AbsorbedDose, aDensName: Handle_TCollection_HAsciiString, aDensValType: Handle_TCollection_HAsciiString): TDF_Label;
  SetMaterial_1(L: TDF_Label, MatL: TDF_Label): void;
  SetMaterial_2(L: TDF_Label, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aDensity: Quantity_AbsorbedDose, aDensName: Handle_TCollection_HAsciiString, aDensValType: Handle_TCollection_HAsciiString): void;
  GetMaterial(MatL: TDF_Label, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aDensity: Quantity_AbsorbedDose, aDensName: Handle_TCollection_HAsciiString, aDensValType: Handle_TCollection_HAsciiString): Standard_Boolean;
  static GetDensityForShape(ShapeL: TDF_Label): Quantity_AbsorbedDose;
  ID(): Standard_GUID;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_MaterialTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_MaterialTool): void;
  get(): XCAFDoc_MaterialTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_MaterialTool_1 extends Handle_XCAFDoc_MaterialTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_MaterialTool_2 extends Handle_XCAFDoc_MaterialTool {
    constructor(thePtr: XCAFDoc_MaterialTool);
  }

  export declare class Handle_XCAFDoc_MaterialTool_3 extends Handle_XCAFDoc_MaterialTool {
    constructor(theHandle: Handle_XCAFDoc_MaterialTool);
  }

  export declare class Handle_XCAFDoc_MaterialTool_4 extends Handle_XCAFDoc_MaterialTool {
    constructor(theHandle: Handle_XCAFDoc_MaterialTool);
  }

export declare class XCAFDoc_AssemblyItemRef extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Get(theLabel: TDF_Label): Handle_XCAFDoc_AssemblyItemRef;
  static Set_1(theLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId): Handle_XCAFDoc_AssemblyItemRef;
  static Set_2(theLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theGUID: Standard_GUID): Handle_XCAFDoc_AssemblyItemRef;
  static Set_3(theLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theShapeIndex: Graphic3d_ZLayerId): Handle_XCAFDoc_AssemblyItemRef;
  IsOrphan(): Standard_Boolean;
  HasExtraRef(): Standard_Boolean;
  IsGUID(): Standard_Boolean;
  IsSubshapeIndex(): Standard_Boolean;
  GetGUID(): Standard_GUID;
  GetSubshapeIndex(): Graphic3d_ZLayerId;
  GetItem(): XCAFDoc_AssemblyItemId;
  SetItem_1(theItemId: XCAFDoc_AssemblyItemId): void;
  SetItem_2(thePath: TColStd_ListOfAsciiString): void;
  SetItem_3(theString: XCAFDoc_PartId): void;
  SetGUID(theAttrGUID: Standard_GUID): void;
  SetSubshapeIndex(theShapeIndex: Graphic3d_ZLayerId): void;
  ClearExtraRef(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  ID(): Standard_GUID;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theAttrFrom: Handle_TDF_Attribute): void;
  Paste(theAttrInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  delete(): void;
}

export declare class Handle_XCAFDoc_AssemblyItemRef {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_AssemblyItemRef): void;
  get(): XCAFDoc_AssemblyItemRef;
  delete(): void;
}

  export declare class Handle_XCAFDoc_AssemblyItemRef_1 extends Handle_XCAFDoc_AssemblyItemRef {
    constructor();
  }

  export declare class Handle_XCAFDoc_AssemblyItemRef_2 extends Handle_XCAFDoc_AssemblyItemRef {
    constructor(thePtr: XCAFDoc_AssemblyItemRef);
  }

  export declare class Handle_XCAFDoc_AssemblyItemRef_3 extends Handle_XCAFDoc_AssemblyItemRef {
    constructor(theHandle: Handle_XCAFDoc_AssemblyItemRef);
  }

  export declare class Handle_XCAFDoc_AssemblyItemRef_4 extends Handle_XCAFDoc_AssemblyItemRef {
    constructor(theHandle: Handle_XCAFDoc_AssemblyItemRef);
  }

export declare class Handle_XCAFDoc_DocumentTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_DocumentTool): void;
  get(): XCAFDoc_DocumentTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_DocumentTool_1 extends Handle_XCAFDoc_DocumentTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_DocumentTool_2 extends Handle_XCAFDoc_DocumentTool {
    constructor(thePtr: XCAFDoc_DocumentTool);
  }

  export declare class Handle_XCAFDoc_DocumentTool_3 extends Handle_XCAFDoc_DocumentTool {
    constructor(theHandle: Handle_XCAFDoc_DocumentTool);
  }

  export declare class Handle_XCAFDoc_DocumentTool_4 extends Handle_XCAFDoc_DocumentTool {
    constructor(theHandle: Handle_XCAFDoc_DocumentTool);
  }

export declare class XCAFDoc_DocumentTool extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set(L: TDF_Label, IsAcces: Standard_Boolean): Handle_XCAFDoc_DocumentTool;
  static IsXCAFDocument(Doc: Handle_TDocStd_Document): Standard_Boolean;
  static DocLabel(acces: TDF_Label): TDF_Label;
  static ShapesLabel(acces: TDF_Label): TDF_Label;
  static ColorsLabel(acces: TDF_Label): TDF_Label;
  static LayersLabel(acces: TDF_Label): TDF_Label;
  static DGTsLabel(acces: TDF_Label): TDF_Label;
  static MaterialsLabel(acces: TDF_Label): TDF_Label;
  static ViewsLabel(acces: TDF_Label): TDF_Label;
  static ClippingPlanesLabel(acces: TDF_Label): TDF_Label;
  static NotesLabel(acces: TDF_Label): TDF_Label;
  static VisMaterialLabel(theLabel: TDF_Label): TDF_Label;
  static ShapeTool(acces: TDF_Label): Handle_XCAFDoc_ShapeTool;
  static ColorTool(acces: TDF_Label): Handle_XCAFDoc_ColorTool;
  static VisMaterialTool(theLabel: TDF_Label): Handle_XCAFDoc_VisMaterialTool;
  static LayerTool(acces: TDF_Label): Handle_XCAFDoc_LayerTool;
  static DimTolTool(acces: TDF_Label): Handle_XCAFDoc_DimTolTool;
  static MaterialTool(acces: TDF_Label): Handle_XCAFDoc_MaterialTool;
  static ViewTool(acces: TDF_Label): Handle_XCAFDoc_ViewTool;
  static ClippingPlaneTool(acces: TDF_Label): Handle_XCAFDoc_ClippingPlaneTool;
  static NotesTool(acces: TDF_Label): Handle_XCAFDoc_NotesTool;
  Init(): void;
  ID(): Standard_GUID;
  AfterRetrieval(forceIt: Standard_Boolean): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class XCAFDoc_ClippingPlaneTool extends TDataStd_GenericEmpty {
  constructor()
  static Set(theLabel: TDF_Label): Handle_XCAFDoc_ClippingPlaneTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  IsClippingPlane(theLabel: TDF_Label): Standard_Boolean;
  GetClippingPlane_1(theLabel: TDF_Label, thePlane: gp_Pln, theName: TCollection_ExtendedString, theCapping: Standard_Boolean): Standard_Boolean;
  GetClippingPlane_2(theLabel: TDF_Label, thePlane: gp_Pln, theName: Handle_TCollection_HAsciiString, theCapping: Standard_Boolean): Standard_Boolean;
  AddClippingPlane_1(thePlane: gp_Pln, theName: TCollection_ExtendedString, theCapping: Standard_Boolean): TDF_Label;
  AddClippingPlane_2(thePlane: gp_Pln, theName: Handle_TCollection_HAsciiString, theCapping: Standard_Boolean): TDF_Label;
  AddClippingPlane_3(thePlane: gp_Pln, theName: TCollection_ExtendedString): TDF_Label;
  AddClippingPlane_4(thePlane: gp_Pln, theName: Handle_TCollection_HAsciiString): TDF_Label;
  RemoveClippingPlane(theLabel: TDF_Label): Standard_Boolean;
  GetClippingPlanes(Labels: TDF_LabelSequence): void;
  UpdateClippingPlane(theLabelL: TDF_Label, thePlane: gp_Pln, theName: TCollection_ExtendedString): void;
  SetCapping(theClippingPlaneL: TDF_Label, theCapping: Standard_Boolean): void;
  GetCapping_1(theClippingPlaneL: TDF_Label): Standard_Boolean;
  GetCapping_2(theClippingPlaneL: TDF_Label, theCapping: Standard_Boolean): Standard_Boolean;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_ClippingPlaneTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_ClippingPlaneTool): void;
  get(): XCAFDoc_ClippingPlaneTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_ClippingPlaneTool_1 extends Handle_XCAFDoc_ClippingPlaneTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_ClippingPlaneTool_2 extends Handle_XCAFDoc_ClippingPlaneTool {
    constructor(thePtr: XCAFDoc_ClippingPlaneTool);
  }

  export declare class Handle_XCAFDoc_ClippingPlaneTool_3 extends Handle_XCAFDoc_ClippingPlaneTool {
    constructor(theHandle: Handle_XCAFDoc_ClippingPlaneTool);
  }

  export declare class Handle_XCAFDoc_ClippingPlaneTool_4 extends Handle_XCAFDoc_ClippingPlaneTool {
    constructor(theHandle: Handle_XCAFDoc_ClippingPlaneTool);
  }

export declare class XCAFDoc_VisMaterialCommon {
  constructor()
  IsEqual(theOther: XCAFDoc_VisMaterialCommon): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type XCAFDoc_ColorType = {
  XCAFDoc_ColorGen: {};
  XCAFDoc_ColorSurf: {};
  XCAFDoc_ColorCurv: {};
}

export declare class Handle_XCAFDoc_Datum {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Datum): void;
  get(): XCAFDoc_Datum;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Datum_1 extends Handle_XCAFDoc_Datum {
    constructor();
  }

  export declare class Handle_XCAFDoc_Datum_2 extends Handle_XCAFDoc_Datum {
    constructor(thePtr: XCAFDoc_Datum);
  }

  export declare class Handle_XCAFDoc_Datum_3 extends Handle_XCAFDoc_Datum {
    constructor(theHandle: Handle_XCAFDoc_Datum);
  }

  export declare class Handle_XCAFDoc_Datum_4 extends Handle_XCAFDoc_Datum {
    constructor(theHandle: Handle_XCAFDoc_Datum);
  }

export declare class XCAFDoc_Datum extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, anIdentification: Handle_TCollection_HAsciiString): Handle_XCAFDoc_Datum;
  static Set_2(theLabel: TDF_Label): Handle_XCAFDoc_Datum;
  Set_3(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, anIdentification: Handle_TCollection_HAsciiString): void;
  GetName(): Handle_TCollection_HAsciiString;
  GetDescription(): Handle_TCollection_HAsciiString;
  GetIdentification(): Handle_TCollection_HAsciiString;
  GetObject(): Handle_XCAFDimTolObjects_DatumObject;
  SetObject(theDatumObject: Handle_XCAFDimTolObjects_DatumObject): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XCAFDoc_Material extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aDensity: Quantity_AbsorbedDose, aDensName: Handle_TCollection_HAsciiString, aDensValType: Handle_TCollection_HAsciiString): Handle_XCAFDoc_Material;
  Set_2(aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aDensity: Quantity_AbsorbedDose, aDensName: Handle_TCollection_HAsciiString, aDensValType: Handle_TCollection_HAsciiString): void;
  GetName(): Handle_TCollection_HAsciiString;
  GetDescription(): Handle_TCollection_HAsciiString;
  GetDensity(): Quantity_AbsorbedDose;
  GetDensName(): Handle_TCollection_HAsciiString;
  GetDensValType(): Handle_TCollection_HAsciiString;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFDoc_Material {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Material): void;
  get(): XCAFDoc_Material;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Material_1 extends Handle_XCAFDoc_Material {
    constructor();
  }

  export declare class Handle_XCAFDoc_Material_2 extends Handle_XCAFDoc_Material {
    constructor(thePtr: XCAFDoc_Material);
  }

  export declare class Handle_XCAFDoc_Material_3 extends Handle_XCAFDoc_Material {
    constructor(theHandle: Handle_XCAFDoc_Material);
  }

  export declare class Handle_XCAFDoc_Material_4 extends Handle_XCAFDoc_Material {
    constructor(theHandle: Handle_XCAFDoc_Material);
  }

export declare class Handle_XCAFDoc_Note {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Note): void;
  get(): XCAFDoc_Note;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Note_1 extends Handle_XCAFDoc_Note {
    constructor();
  }

  export declare class Handle_XCAFDoc_Note_2 extends Handle_XCAFDoc_Note {
    constructor(thePtr: XCAFDoc_Note);
  }

  export declare class Handle_XCAFDoc_Note_3 extends Handle_XCAFDoc_Note {
    constructor(theHandle: Handle_XCAFDoc_Note);
  }

  export declare class Handle_XCAFDoc_Note_4 extends Handle_XCAFDoc_Note {
    constructor(theHandle: Handle_XCAFDoc_Note);
  }

export declare class XCAFDoc_Note extends TDF_Attribute {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static IsMine(theLabel: TDF_Label): Standard_Boolean;
  static Get(theLabel: TDF_Label): Handle_XCAFDoc_Note;
  Set(theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString): void;
  UserName(): TCollection_ExtendedString;
  TimeStamp(): TCollection_ExtendedString;
  IsOrphan(): Standard_Boolean;
  GetObject(): Handle_XCAFNoteObjects_NoteObject;
  SetObject(theObject: Handle_XCAFNoteObjects_NoteObject): void;
  Restore(theAttrFrom: Handle_TDF_Attribute): void;
  Paste(theAttrInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_XCAFDoc_GraphNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_GraphNode): void;
  get(): XCAFDoc_GraphNode;
  delete(): void;
}

  export declare class Handle_XCAFDoc_GraphNode_1 extends Handle_XCAFDoc_GraphNode {
    constructor();
  }

  export declare class Handle_XCAFDoc_GraphNode_2 extends Handle_XCAFDoc_GraphNode {
    constructor(thePtr: XCAFDoc_GraphNode);
  }

  export declare class Handle_XCAFDoc_GraphNode_3 extends Handle_XCAFDoc_GraphNode {
    constructor(theHandle: Handle_XCAFDoc_GraphNode);
  }

  export declare class Handle_XCAFDoc_GraphNode_4 extends Handle_XCAFDoc_GraphNode {
    constructor(theHandle: Handle_XCAFDoc_GraphNode);
  }

export declare class XCAFDoc_GraphNode extends TDF_Attribute {
  constructor()
  static Find(L: TDF_Label, G: Handle_XCAFDoc_GraphNode): Standard_Boolean;
  static Set_1(L: TDF_Label): Handle_XCAFDoc_GraphNode;
  static Set_2(L: TDF_Label, ExplicitGraphID: Standard_GUID): Handle_XCAFDoc_GraphNode;
  static GetDefaultGraphID(): Standard_GUID;
  SetGraphID(explicitID: Standard_GUID): void;
  SetFather(F: Handle_XCAFDoc_GraphNode): Graphic3d_ZLayerId;
  SetChild(Ch: Handle_XCAFDoc_GraphNode): Graphic3d_ZLayerId;
  UnSetFather_1(F: Handle_XCAFDoc_GraphNode): void;
  UnSetFather_2(Findex: Graphic3d_ZLayerId): void;
  UnSetChild_1(Ch: Handle_XCAFDoc_GraphNode): void;
  UnSetChild_2(Chindex: Graphic3d_ZLayerId): void;
  GetFather(Findex: Graphic3d_ZLayerId): Handle_XCAFDoc_GraphNode;
  GetChild(Chindex: Graphic3d_ZLayerId): Handle_XCAFDoc_GraphNode;
  FatherIndex(F: Handle_XCAFDoc_GraphNode): Graphic3d_ZLayerId;
  ChildIndex(Ch: Handle_XCAFDoc_GraphNode): Graphic3d_ZLayerId;
  IsFather(Ch: Handle_XCAFDoc_GraphNode): Standard_Boolean;
  IsChild(F: Handle_XCAFDoc_GraphNode): Standard_Boolean;
  NbFathers(): Graphic3d_ZLayerId;
  NbChildren(): Graphic3d_ZLayerId;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  NewEmpty(): Handle_TDF_Attribute;
  References(aDataSet: Handle_TDF_DataSet): void;
  BeforeForget(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFDoc_NotesTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_NotesTool): void;
  get(): XCAFDoc_NotesTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_NotesTool_1 extends Handle_XCAFDoc_NotesTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_NotesTool_2 extends Handle_XCAFDoc_NotesTool {
    constructor(thePtr: XCAFDoc_NotesTool);
  }

  export declare class Handle_XCAFDoc_NotesTool_3 extends Handle_XCAFDoc_NotesTool {
    constructor(theHandle: Handle_XCAFDoc_NotesTool);
  }

  export declare class Handle_XCAFDoc_NotesTool_4 extends Handle_XCAFDoc_NotesTool {
    constructor(theHandle: Handle_XCAFDoc_NotesTool);
  }

export declare class XCAFDoc_NotesTool extends TDataStd_GenericEmpty {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  static GetID(): Standard_GUID;
  static Set(theLabel: TDF_Label): Handle_XCAFDoc_NotesTool;
  GetNotesLabel(): TDF_Label;
  GetAnnotatedItemsLabel(): TDF_Label;
  NbNotes(): Graphic3d_ZLayerId;
  NbAnnotatedItems(): Graphic3d_ZLayerId;
  GetNotes_1(theNoteLabels: TDF_LabelSequence): void;
  GetAnnotatedItems(theLabels: TDF_LabelSequence): void;
  IsAnnotatedItem_1(theItemId: XCAFDoc_AssemblyItemId): Standard_Boolean;
  IsAnnotatedItem_2(theItemLabel: TDF_Label): Standard_Boolean;
  FindAnnotatedItem_1(theItemId: XCAFDoc_AssemblyItemId): TDF_Label;
  FindAnnotatedItem_2(theItemLabel: TDF_Label): TDF_Label;
  FindAnnotatedItemAttr_1(theItemId: XCAFDoc_AssemblyItemId, theGUID: Standard_GUID): TDF_Label;
  FindAnnotatedItemAttr_2(theItemLabel: TDF_Label, theGUID: Standard_GUID): TDF_Label;
  FindAnnotatedItemSubshape_1(theItemId: XCAFDoc_AssemblyItemId, theSubshapeIndex: Graphic3d_ZLayerId): TDF_Label;
  FindAnnotatedItemSubshape_2(theItemLabel: TDF_Label, theSubshapeIndex: Graphic3d_ZLayerId): TDF_Label;
  CreateComment(theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theComment: TCollection_ExtendedString): Handle_XCAFDoc_Note;
  CreateBalloon(theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theComment: TCollection_ExtendedString): Handle_XCAFDoc_Note;
  CreateBinData_1(theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theTitle: TCollection_ExtendedString, theMIMEtype: XCAFDoc_PartId, theFile: OSD_File): Handle_XCAFDoc_Note;
  CreateBinData_2(theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theTitle: TCollection_ExtendedString, theMIMEtype: XCAFDoc_PartId, theData: Handle_TColStd_HArray1OfByte): Handle_XCAFDoc_Note;
  GetNotes_2(theItemId: XCAFDoc_AssemblyItemId, theNoteLabels: TDF_LabelSequence): Graphic3d_ZLayerId;
  GetNotes_3(theItemLabel: TDF_Label, theNoteLabels: TDF_LabelSequence): Graphic3d_ZLayerId;
  GetAttrNotes_1(theItemId: XCAFDoc_AssemblyItemId, theGUID: Standard_GUID, theNoteLabels: TDF_LabelSequence): Graphic3d_ZLayerId;
  GetAttrNotes_2(theItemLabel: TDF_Label, theGUID: Standard_GUID, theNoteLabels: TDF_LabelSequence): Graphic3d_ZLayerId;
  GetSubshapeNotes(theItemId: XCAFDoc_AssemblyItemId, theSubshapeIndex: Graphic3d_ZLayerId, theNoteLabels: TDF_LabelSequence): Graphic3d_ZLayerId;
  AddNote_1(theNoteLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId): Handle_XCAFDoc_AssemblyItemRef;
  AddNote_2(theNoteLabel: TDF_Label, theItemLabel: TDF_Label): Handle_XCAFDoc_AssemblyItemRef;
  AddNoteToAttr_1(theNoteLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theGUID: Standard_GUID): Handle_XCAFDoc_AssemblyItemRef;
  AddNoteToAttr_2(theNoteLabel: TDF_Label, theItemLabel: TDF_Label, theGUID: Standard_GUID): Handle_XCAFDoc_AssemblyItemRef;
  AddNoteToSubshape_1(theNoteLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theSubshapeIndex: Graphic3d_ZLayerId): Handle_XCAFDoc_AssemblyItemRef;
  AddNoteToSubshape_2(theNoteLabel: TDF_Label, theItemLabel: TDF_Label, theSubshapeIndex: Graphic3d_ZLayerId): Handle_XCAFDoc_AssemblyItemRef;
  RemoveNote_1(theNoteLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveNote_2(theNoteLabel: TDF_Label, theItemLabel: TDF_Label, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveSubshapeNote_1(theNoteLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theSubshapeIndex: Graphic3d_ZLayerId, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveSubshapeNote_2(theNoteLabel: TDF_Label, theItemLabel: TDF_Label, theSubshapeIndex: Graphic3d_ZLayerId, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAttrNote_1(theNoteLabel: TDF_Label, theItemId: XCAFDoc_AssemblyItemId, theGUID: Standard_GUID, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAttrNote_2(theNoteLabel: TDF_Label, theItemLabel: TDF_Label, theGUID: Standard_GUID, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAllNotes_1(theItemId: XCAFDoc_AssemblyItemId, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAllNotes_2(theItemLabel: TDF_Label, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAllSubshapeNotes(theItemId: XCAFDoc_AssemblyItemId, theSubshapeIndex: Graphic3d_ZLayerId, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAllAttrNotes_1(theItemId: XCAFDoc_AssemblyItemId, theGUID: Standard_GUID, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  RemoveAllAttrNotes_2(theItemLabel: TDF_Label, theGUID: Standard_GUID, theDelIfOrphan: Standard_Boolean): Standard_Boolean;
  DeleteNote(theNoteLabel: TDF_Label): Standard_Boolean;
  DeleteNotes(theNoteLabels: TDF_LabelSequence): Graphic3d_ZLayerId;
  DeleteAllNotes(): Graphic3d_ZLayerId;
  NbOrphanNotes(): Graphic3d_ZLayerId;
  GetOrphanNotes(theNoteLabels: TDF_LabelSequence): void;
  DeleteOrphanNotes(): Graphic3d_ZLayerId;
  ID(): Standard_GUID;
  delete(): void;
}

export declare class XCAFDoc_VisMaterialPBR {
  constructor()
  IsEqual(theOther: XCAFDoc_VisMaterialPBR): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class XCAFDoc_AssemblyItemId {
  Init_1(thePath: TColStd_ListOfAsciiString): void;
  Init_2(theString: XCAFDoc_PartId): void;
  IsNull(): Standard_Boolean;
  Nullify(): void;
  IsChild(theOther: XCAFDoc_AssemblyItemId): Standard_Boolean;
  IsDirectChild(theOther: XCAFDoc_AssemblyItemId): Standard_Boolean;
  IsEqual(theOther: XCAFDoc_AssemblyItemId): Standard_Boolean;
  GetPath(): TColStd_ListOfAsciiString;
  ToString(): XCAFDoc_PartId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class XCAFDoc_AssemblyItemId_1 extends XCAFDoc_AssemblyItemId {
    constructor();
  }

  export declare class XCAFDoc_AssemblyItemId_2 extends XCAFDoc_AssemblyItemId {
    constructor(thePath: TColStd_ListOfAsciiString);
  }

  export declare class XCAFDoc_AssemblyItemId_3 extends XCAFDoc_AssemblyItemId {
    constructor(theString: XCAFDoc_PartId);
  }

export declare class XCAFDoc_Editor {
  constructor();
  static Expand_1(Doc: TDF_Label, Shape: TDF_Label, recursively: Standard_Boolean): Standard_Boolean;
  static Expand_2(Doc: TDF_Label, recursively: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

export declare class Handle_XCAFDoc_Color {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Color): void;
  get(): XCAFDoc_Color;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Color_1 extends Handle_XCAFDoc_Color {
    constructor();
  }

  export declare class Handle_XCAFDoc_Color_2 extends Handle_XCAFDoc_Color {
    constructor(thePtr: XCAFDoc_Color);
  }

  export declare class Handle_XCAFDoc_Color_3 extends Handle_XCAFDoc_Color {
    constructor(theHandle: Handle_XCAFDoc_Color);
  }

  export declare class Handle_XCAFDoc_Color_4 extends Handle_XCAFDoc_Color {
    constructor(theHandle: Handle_XCAFDoc_Color);
  }

export declare class XCAFDoc_Color extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, C: Quantity_Color): Handle_XCAFDoc_Color;
  static Set_2(label: TDF_Label, C: Quantity_ColorRGBA): Handle_XCAFDoc_Color;
  static Set_3(label: TDF_Label, C: Quantity_NameOfColor): Handle_XCAFDoc_Color;
  static Set_4(label: TDF_Label, R: Quantity_AbsorbedDose, G: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, alpha: Quantity_AbsorbedDose): Handle_XCAFDoc_Color;
  Set_5(C: Quantity_Color): void;
  Set_6(C: Quantity_ColorRGBA): void;
  Set_7(C: Quantity_NameOfColor): void;
  Set_8(R: Quantity_AbsorbedDose, G: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose, alpha: Quantity_AbsorbedDose): void;
  GetColor(): Quantity_Color;
  GetColorRGBA(): Quantity_ColorRGBA;
  GetNOC(): Quantity_NameOfColor;
  GetRGB(R: Quantity_AbsorbedDose, G: Quantity_AbsorbedDose, B: Quantity_AbsorbedDose): void;
  GetAlpha(): Standard_ShortReal;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFDoc_GeomTolerance {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_GeomTolerance): void;
  get(): XCAFDoc_GeomTolerance;
  delete(): void;
}

  export declare class Handle_XCAFDoc_GeomTolerance_1 extends Handle_XCAFDoc_GeomTolerance {
    constructor();
  }

  export declare class Handle_XCAFDoc_GeomTolerance_2 extends Handle_XCAFDoc_GeomTolerance {
    constructor(thePtr: XCAFDoc_GeomTolerance);
  }

  export declare class Handle_XCAFDoc_GeomTolerance_3 extends Handle_XCAFDoc_GeomTolerance {
    constructor(theHandle: Handle_XCAFDoc_GeomTolerance);
  }

  export declare class Handle_XCAFDoc_GeomTolerance_4 extends Handle_XCAFDoc_GeomTolerance {
    constructor(theHandle: Handle_XCAFDoc_GeomTolerance);
  }

export declare class Handle_XCAFDoc_VisMaterial {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_VisMaterial): void;
  get(): XCAFDoc_VisMaterial;
  delete(): void;
}

  export declare class Handle_XCAFDoc_VisMaterial_1 extends Handle_XCAFDoc_VisMaterial {
    constructor();
  }

  export declare class Handle_XCAFDoc_VisMaterial_2 extends Handle_XCAFDoc_VisMaterial {
    constructor(thePtr: XCAFDoc_VisMaterial);
  }

  export declare class Handle_XCAFDoc_VisMaterial_3 extends Handle_XCAFDoc_VisMaterial {
    constructor(theHandle: Handle_XCAFDoc_VisMaterial);
  }

  export declare class Handle_XCAFDoc_VisMaterial_4 extends Handle_XCAFDoc_VisMaterial {
    constructor(theHandle: Handle_XCAFDoc_VisMaterial);
  }

export declare class XCAFDoc_VisMaterial extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  IsEmpty(): Standard_Boolean;
  FillMaterialAspect(theAspect: Graphic3d_MaterialAspect): void;
  FillAspect(theAspect: Handle_Graphic3d_Aspects): void;
  HasPbrMaterial(): Standard_Boolean;
  PbrMaterial(): XCAFDoc_VisMaterialPBR;
  SetPbrMaterial(theMaterial: XCAFDoc_VisMaterialPBR): void;
  UnsetPbrMaterial(): void;
  HasCommonMaterial(): Standard_Boolean;
  CommonMaterial(): XCAFDoc_VisMaterialCommon;
  SetCommonMaterial(theMaterial: XCAFDoc_VisMaterialCommon): void;
  UnsetCommonMaterial(): void;
  BaseColor(): Quantity_ColorRGBA;
  AlphaMode(): Graphic3d_AlphaMode;
  AlphaCutOff(): Standard_ShortReal;
  SetAlphaMode(theMode: Graphic3d_AlphaMode, theCutOff: Standard_ShortReal): void;
  IsDoubleSided(): Standard_Boolean;
  SetDoubleSided(theIsDoubleSided: Standard_Boolean): void;
  RawName(): Handle_TCollection_HAsciiString;
  SetRawName(theName: Handle_TCollection_HAsciiString): void;
  IsEqual(theOther: Handle_XCAFDoc_VisMaterial): Standard_Boolean;
  ConvertToCommonMaterial(): XCAFDoc_VisMaterialCommon;
  ConvertToPbrMaterial(): XCAFDoc_VisMaterialPBR;
  ID(): Standard_GUID;
  Restore(theWith: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(theInto: Handle_TDF_Attribute, theRelTable: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_XCAFDoc_Volume {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Volume): void;
  get(): XCAFDoc_Volume;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Volume_1 extends Handle_XCAFDoc_Volume {
    constructor();
  }

  export declare class Handle_XCAFDoc_Volume_2 extends Handle_XCAFDoc_Volume {
    constructor(thePtr: XCAFDoc_Volume);
  }

  export declare class Handle_XCAFDoc_Volume_3 extends Handle_XCAFDoc_Volume {
    constructor(theHandle: Handle_XCAFDoc_Volume);
  }

  export declare class Handle_XCAFDoc_Volume_4 extends Handle_XCAFDoc_Volume {
    constructor(theHandle: Handle_XCAFDoc_Volume);
  }

export declare class XCAFDoc_Volume extends TDataStd_Real {
  constructor()
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  Set_1(vol: Quantity_AbsorbedDose): void;
  static Set_2(label: TDF_Label, vol: Quantity_AbsorbedDose): Handle_XCAFDoc_Volume;
  Get_1(): Quantity_AbsorbedDose;
  static Get_2(label: TDF_Label, vol: Quantity_AbsorbedDose): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_NoteComment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_NoteComment): void;
  get(): XCAFDoc_NoteComment;
  delete(): void;
}

  export declare class Handle_XCAFDoc_NoteComment_1 extends Handle_XCAFDoc_NoteComment {
    constructor();
  }

  export declare class Handle_XCAFDoc_NoteComment_2 extends Handle_XCAFDoc_NoteComment {
    constructor(thePtr: XCAFDoc_NoteComment);
  }

  export declare class Handle_XCAFDoc_NoteComment_3 extends Handle_XCAFDoc_NoteComment {
    constructor(theHandle: Handle_XCAFDoc_NoteComment);
  }

  export declare class Handle_XCAFDoc_NoteComment_4 extends Handle_XCAFDoc_NoteComment {
    constructor(theHandle: Handle_XCAFDoc_NoteComment);
  }

export declare class XCAFDoc_NoteComment extends XCAFDoc_Note {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Get(theLabel: TDF_Label): Handle_XCAFDoc_NoteComment;
  static Set_1(theLabel: TDF_Label, theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theComment: TCollection_ExtendedString): Handle_XCAFDoc_NoteComment;
  Set_2(theComment: TCollection_ExtendedString): void;
  Comment(): TCollection_ExtendedString;
  ID(): Standard_GUID;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theAttrFrom: Handle_TDF_Attribute): void;
  Paste(theAttrInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  delete(): void;
}

export declare class XCAFDoc_Dimension extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set(theLabel: TDF_Label): Handle_XCAFDoc_Dimension;
  ID(): Standard_GUID;
  SetObject(theDimensionObject: Handle_XCAFDimTolObjects_DimensionObject): void;
  GetObject(): Handle_XCAFDimTolObjects_DimensionObject;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_Dimension {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Dimension): void;
  get(): XCAFDoc_Dimension;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Dimension_1 extends Handle_XCAFDoc_Dimension {
    constructor();
  }

  export declare class Handle_XCAFDoc_Dimension_2 extends Handle_XCAFDoc_Dimension {
    constructor(thePtr: XCAFDoc_Dimension);
  }

  export declare class Handle_XCAFDoc_Dimension_3 extends Handle_XCAFDoc_Dimension {
    constructor(theHandle: Handle_XCAFDoc_Dimension);
  }

  export declare class Handle_XCAFDoc_Dimension_4 extends Handle_XCAFDoc_Dimension {
    constructor(theHandle: Handle_XCAFDoc_Dimension);
  }

export declare class Handle_XCAFDoc_ColorTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_ColorTool): void;
  get(): XCAFDoc_ColorTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_ColorTool_1 extends Handle_XCAFDoc_ColorTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_ColorTool_2 extends Handle_XCAFDoc_ColorTool {
    constructor(thePtr: XCAFDoc_ColorTool);
  }

  export declare class Handle_XCAFDoc_ColorTool_3 extends Handle_XCAFDoc_ColorTool {
    constructor(theHandle: Handle_XCAFDoc_ColorTool);
  }

  export declare class Handle_XCAFDoc_ColorTool_4 extends Handle_XCAFDoc_ColorTool {
    constructor(theHandle: Handle_XCAFDoc_ColorTool);
  }

export declare class XCAFDoc_ColorTool extends TDataStd_GenericEmpty {
  constructor()
  static AutoNaming(): Standard_Boolean;
  static SetAutoNaming(theIsAutoNaming: Standard_Boolean): void;
  static Set(L: TDF_Label): Handle_XCAFDoc_ColorTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  ShapeTool(): Handle_XCAFDoc_ShapeTool;
  IsColor(lab: TDF_Label): Standard_Boolean;
  GetColor_1(lab: TDF_Label, col: Quantity_Color): Standard_Boolean;
  GetColor_2(lab: TDF_Label, col: Quantity_ColorRGBA): Standard_Boolean;
  FindColor_1(col: Quantity_Color, lab: TDF_Label): Standard_Boolean;
  FindColor_2(col: Quantity_ColorRGBA, lab: TDF_Label): Standard_Boolean;
  FindColor_3(col: Quantity_Color): TDF_Label;
  FindColor_4(col: Quantity_ColorRGBA): TDF_Label;
  AddColor_1(col: Quantity_Color): TDF_Label;
  AddColor_2(col: Quantity_ColorRGBA): TDF_Label;
  RemoveColor(lab: TDF_Label): void;
  GetColors(Labels: TDF_LabelSequence): void;
  SetColor_1(L: TDF_Label, colorL: TDF_Label, type: XCAFDoc_ColorType): void;
  SetColor_2(L: TDF_Label, Color: Quantity_Color, type: XCAFDoc_ColorType): void;
  SetColor_3(L: TDF_Label, Color: Quantity_ColorRGBA, type: XCAFDoc_ColorType): void;
  UnSetColor_1(L: TDF_Label, type: XCAFDoc_ColorType): void;
  IsSet_1(L: TDF_Label, type: XCAFDoc_ColorType): Standard_Boolean;
  static GetColor_3(L: TDF_Label, type: XCAFDoc_ColorType, colorL: TDF_Label): Standard_Boolean;
  GetColor_4(L: TDF_Label, type: XCAFDoc_ColorType, color: Quantity_Color): Standard_Boolean;
  GetColor_5(L: TDF_Label, type: XCAFDoc_ColorType, color: Quantity_ColorRGBA): Standard_Boolean;
  SetColor_4(S: TopoDS_Shape, colorL: TDF_Label, type: XCAFDoc_ColorType): Standard_Boolean;
  SetColor_5(S: TopoDS_Shape, Color: Quantity_Color, type: XCAFDoc_ColorType): Standard_Boolean;
  SetColor_6(S: TopoDS_Shape, Color: Quantity_ColorRGBA, type: XCAFDoc_ColorType): Standard_Boolean;
  UnSetColor_2(S: TopoDS_Shape, type: XCAFDoc_ColorType): Standard_Boolean;
  IsSet_2(S: TopoDS_Shape, type: XCAFDoc_ColorType): Standard_Boolean;
  GetColor_6(S: TopoDS_Shape, type: XCAFDoc_ColorType, colorL: TDF_Label): Standard_Boolean;
  GetColor_7(S: TopoDS_Shape, type: XCAFDoc_ColorType, color: Quantity_Color): Standard_Boolean;
  GetColor_8(S: TopoDS_Shape, type: XCAFDoc_ColorType, color: Quantity_ColorRGBA): Standard_Boolean;
  IsVisible(L: TDF_Label): Standard_Boolean;
  SetVisibility(shapeLabel: TDF_Label, isvisible: Standard_Boolean): void;
  IsColorByLayer(L: TDF_Label): Standard_Boolean;
  SetColorByLayer(shapeLabel: TDF_Label, isColorByLayer: Standard_Boolean): void;
  SetInstanceColor_1(theShape: TopoDS_Shape, type: XCAFDoc_ColorType, color: Quantity_Color, isCreateSHUO: Standard_Boolean): Standard_Boolean;
  SetInstanceColor_2(theShape: TopoDS_Shape, type: XCAFDoc_ColorType, color: Quantity_ColorRGBA, isCreateSHUO: Standard_Boolean): Standard_Boolean;
  GetInstanceColor_1(theShape: TopoDS_Shape, type: XCAFDoc_ColorType, color: Quantity_Color): Standard_Boolean;
  GetInstanceColor_2(theShape: TopoDS_Shape, type: XCAFDoc_ColorType, color: Quantity_ColorRGBA): Standard_Boolean;
  IsInstanceVisible(theShape: TopoDS_Shape): Standard_Boolean;
  ReverseChainsOfTreeNodes(): Standard_Boolean;
  ID(): Standard_GUID;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_Centroid {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Centroid): void;
  get(): XCAFDoc_Centroid;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Centroid_1 extends Handle_XCAFDoc_Centroid {
    constructor();
  }

  export declare class Handle_XCAFDoc_Centroid_2 extends Handle_XCAFDoc_Centroid {
    constructor(thePtr: XCAFDoc_Centroid);
  }

  export declare class Handle_XCAFDoc_Centroid_3 extends Handle_XCAFDoc_Centroid {
    constructor(theHandle: Handle_XCAFDoc_Centroid);
  }

  export declare class Handle_XCAFDoc_Centroid_4 extends Handle_XCAFDoc_Centroid {
    constructor(theHandle: Handle_XCAFDoc_Centroid);
  }

export declare class XCAFDoc_Centroid extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, pnt: gp_Pnt): Handle_XCAFDoc_Centroid;
  Set_2(pnt: gp_Pnt): void;
  Get_1(): gp_Pnt;
  static Get_2(label: TDF_Label, pnt: gp_Pnt): Standard_Boolean;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFDoc_DimTolTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_DimTolTool): void;
  get(): XCAFDoc_DimTolTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_DimTolTool_1 extends Handle_XCAFDoc_DimTolTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_DimTolTool_2 extends Handle_XCAFDoc_DimTolTool {
    constructor(thePtr: XCAFDoc_DimTolTool);
  }

  export declare class Handle_XCAFDoc_DimTolTool_3 extends Handle_XCAFDoc_DimTolTool {
    constructor(theHandle: Handle_XCAFDoc_DimTolTool);
  }

  export declare class Handle_XCAFDoc_DimTolTool_4 extends Handle_XCAFDoc_DimTolTool {
    constructor(theHandle: Handle_XCAFDoc_DimTolTool);
  }

export declare class XCAFDoc_DimTolTool extends TDataStd_GenericEmpty {
  constructor()
  static Set(L: TDF_Label): Handle_XCAFDoc_DimTolTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  ShapeTool(): Handle_XCAFDoc_ShapeTool;
  IsDimension(theLab: TDF_Label): Standard_Boolean;
  GetDimensionLabels(theLabels: TDF_LabelSequence): void;
  SetDimension_1(theFirstLS: TDF_LabelSequence, theSecondLS: TDF_LabelSequence, theDimL: TDF_Label): void;
  SetDimension_2(theFirstL: TDF_Label, theSecondL: TDF_Label, theDimL: TDF_Label): void;
  SetDimension_3(theL: TDF_Label, theDimL: TDF_Label): void;
  GetRefDimensionLabels(theShapeL: TDF_Label, theDimensions: TDF_LabelSequence): Standard_Boolean;
  AddDimension(): TDF_Label;
  IsGeomTolerance(theLab: TDF_Label): Standard_Boolean;
  GetGeomToleranceLabels(theLabels: TDF_LabelSequence): void;
  SetGeomTolerance_1(theL: TDF_Label, theGeomTolL: TDF_Label): void;
  SetGeomTolerance_2(theL: TDF_LabelSequence, theGeomTolL: TDF_Label): void;
  GetRefGeomToleranceLabels(theShapeL: TDF_Label, theDimTols: TDF_LabelSequence): Standard_Boolean;
  AddGeomTolerance(): TDF_Label;
  IsDimTol(theLab: TDF_Label): Standard_Boolean;
  GetDimTolLabels(Labels: TDF_LabelSequence): void;
  FindDimTol_1(theKind: Graphic3d_ZLayerId, theVal: Handle_TColStd_HArray1OfReal, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, lab: TDF_Label): Standard_Boolean;
  FindDimTol_2(theKind: Graphic3d_ZLayerId, theVal: Handle_TColStd_HArray1OfReal, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString): TDF_Label;
  AddDimTol(theKind: Graphic3d_ZLayerId, theVal: Handle_TColStd_HArray1OfReal, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString): TDF_Label;
  SetDimTol_1(theL: TDF_Label, theDimTolL: TDF_Label): void;
  SetDimTol_2(theL: TDF_Label, theKind: Graphic3d_ZLayerId, theVal: Handle_TColStd_HArray1OfReal, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString): TDF_Label;
  GetRefShapeLabel(theL: TDF_Label, theShapeLFirst: TDF_LabelSequence, theShapeLSecond: TDF_LabelSequence): Standard_Boolean;
  GetDimTol(theDimTolL: TDF_Label, theKind: Graphic3d_ZLayerId, theVal: Handle_TColStd_HArray1OfReal, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString): Standard_Boolean;
  IsDatum(lab: TDF_Label): Standard_Boolean;
  GetDatumLabels(Labels: TDF_LabelSequence): void;
  FindDatum(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theIdentification: Handle_TCollection_HAsciiString, lab: TDF_Label): Standard_Boolean;
  AddDatum_1(theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theIdentification: Handle_TCollection_HAsciiString): TDF_Label;
  AddDatum_2(): TDF_Label;
  SetDatum_1(theShapeLabels: TDF_LabelSequence, theDatumL: TDF_Label): void;
  SetDatum_2(theL: TDF_Label, theTolerL: TDF_Label, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theIdentification: Handle_TCollection_HAsciiString): void;
  SetDatumToGeomTol(theDatumL: TDF_Label, theTolerL: TDF_Label): void;
  GetDatum(theDatumL: TDF_Label, theName: Handle_TCollection_HAsciiString, theDescription: Handle_TCollection_HAsciiString, theIdentification: Handle_TCollection_HAsciiString): Standard_Boolean;
  GetDatumOfTolerLabels(theDimTolL: TDF_Label, theDatums: TDF_LabelSequence): Standard_Boolean;
  GetDatumWithObjectOfTolerLabels(theDimTolL: TDF_Label, theDatums: TDF_LabelSequence): Standard_Boolean;
  GetTolerOfDatumLabels(theDatumL: TDF_Label, theTols: TDF_LabelSequence): Standard_Boolean;
  GetRefDatumLabel(theShapeL: TDF_Label, theDatum: TDF_LabelSequence): Standard_Boolean;
  IsLocked(theViewL: TDF_Label): Standard_Boolean;
  Lock(theViewL: TDF_Label): void;
  GetGDTPresentations(theGDTLabelToShape: NCollection_IndexedDataMap<TDF_Label, TopoDS_Shape, TDF_LabelMapHasher>): void;
  SetGDTPresentations(theGDTLabelToPrs: NCollection_IndexedDataMap<TDF_Label, TopoDS_Shape, TDF_LabelMapHasher>): void;
  Unlock(theViewL: TDF_Label): void;
  ID(): Standard_GUID;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class XCAFDoc_ShapeMapTool extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set(L: TDF_Label): Handle_XCAFDoc_ShapeMapTool;
  IsSubShape(sub: TopoDS_Shape): Standard_Boolean;
  SetShape(S: TopoDS_Shape): void;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  GetMap(): TopTools_IndexedMapOfShape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFDoc_ShapeMapTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_ShapeMapTool): void;
  get(): XCAFDoc_ShapeMapTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_ShapeMapTool_1 extends Handle_XCAFDoc_ShapeMapTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_ShapeMapTool_2 extends Handle_XCAFDoc_ShapeMapTool {
    constructor(thePtr: XCAFDoc_ShapeMapTool);
  }

  export declare class Handle_XCAFDoc_ShapeMapTool_3 extends Handle_XCAFDoc_ShapeMapTool {
    constructor(theHandle: Handle_XCAFDoc_ShapeMapTool);
  }

  export declare class Handle_XCAFDoc_ShapeMapTool_4 extends Handle_XCAFDoc_ShapeMapTool {
    constructor(theHandle: Handle_XCAFDoc_ShapeMapTool);
  }

export declare class XCAFDoc_DataMapOfShapeLabel extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: XCAFDoc_DataMapOfShapeLabel): void;
  Assign(theOther: XCAFDoc_DataMapOfShapeLabel): XCAFDoc_DataMapOfShapeLabel;
  ReSize(N: Standard_Integer): void;
  Bind(theKey: TopoDS_Shape, theItem: TDF_Label): Standard_Boolean;
  Bound(theKey: TopoDS_Shape, theItem: TDF_Label): TDF_Label;
  IsBound(theKey: TopoDS_Shape): Standard_Boolean;
  UnBind(theKey: TopoDS_Shape): Standard_Boolean;
  Seek(theKey: TopoDS_Shape): TDF_Label;
  ChangeSeek(theKey: TopoDS_Shape): TDF_Label;
  ChangeFind(theKey: TopoDS_Shape): TDF_Label;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class XCAFDoc_DataMapOfShapeLabel_1 extends XCAFDoc_DataMapOfShapeLabel {
    constructor();
  }

  export declare class XCAFDoc_DataMapOfShapeLabel_2 extends XCAFDoc_DataMapOfShapeLabel {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class XCAFDoc_DataMapOfShapeLabel_3 extends XCAFDoc_DataMapOfShapeLabel {
    constructor(theOther: XCAFDoc_DataMapOfShapeLabel);
  }

export declare class XCAFDoc_ShapeTool extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set(L: TDF_Label): Handle_XCAFDoc_ShapeTool;
  IsTopLevel(L: TDF_Label): Standard_Boolean;
  static IsFree(L: TDF_Label): Standard_Boolean;
  static IsShape(L: TDF_Label): Standard_Boolean;
  static IsSimpleShape(L: TDF_Label): Standard_Boolean;
  static IsReference(L: TDF_Label): Standard_Boolean;
  static IsAssembly(L: TDF_Label): Standard_Boolean;
  static IsComponent(L: TDF_Label): Standard_Boolean;
  static IsCompound(L: TDF_Label): Standard_Boolean;
  static IsSubShape_1(L: TDF_Label): Standard_Boolean;
  IsSubShape_2(shapeL: TDF_Label, sub: TopoDS_Shape): Standard_Boolean;
  SearchUsingMap(S: TopoDS_Shape, L: TDF_Label, findWithoutLoc: Standard_Boolean, findSubshape: Standard_Boolean): Standard_Boolean;
  Search(S: TopoDS_Shape, L: TDF_Label, findInstance: Standard_Boolean, findComponent: Standard_Boolean, findSubshape: Standard_Boolean): Standard_Boolean;
  FindShape_1(S: TopoDS_Shape, L: TDF_Label, findInstance: Standard_Boolean): Standard_Boolean;
  FindShape_2(S: TopoDS_Shape, findInstance: Standard_Boolean): TDF_Label;
  static GetShape_1(L: TDF_Label, S: TopoDS_Shape): Standard_Boolean;
  static GetShape_2(L: TDF_Label): TopoDS_Shape;
  NewShape(): TDF_Label;
  SetShape(L: TDF_Label, S: TopoDS_Shape): void;
  AddShape(S: TopoDS_Shape, makeAssembly: Standard_Boolean, makePrepare: Standard_Boolean): TDF_Label;
  RemoveShape(L: TDF_Label, removeCompletely: Standard_Boolean): Standard_Boolean;
  Init(): void;
  static SetAutoNaming(V: Standard_Boolean): void;
  static AutoNaming(): Standard_Boolean;
  ComputeShapes(L: TDF_Label): void;
  ComputeSimpleShapes(): void;
  GetShapes(Labels: TDF_LabelSequence): void;
  GetFreeShapes(FreeLabels: TDF_LabelSequence): void;
  static GetUsers(L: TDF_Label, Labels: TDF_LabelSequence, getsubchilds: Standard_Boolean): Graphic3d_ZLayerId;
  static GetLocation(L: TDF_Label): TopLoc_Location;
  static GetReferredShape(L: TDF_Label, Label: TDF_Label): Standard_Boolean;
  static NbComponents(L: TDF_Label, getsubchilds: Standard_Boolean): Graphic3d_ZLayerId;
  static GetComponents(L: TDF_Label, Labels: TDF_LabelSequence, getsubchilds: Standard_Boolean): Standard_Boolean;
  AddComponent_1(assembly: TDF_Label, comp: TDF_Label, Loc: TopLoc_Location): TDF_Label;
  AddComponent_2(assembly: TDF_Label, comp: TopoDS_Shape, expand: Standard_Boolean): TDF_Label;
  RemoveComponent(comp: TDF_Label): void;
  UpdateAssemblies(): void;
  FindSubShape(shapeL: TDF_Label, sub: TopoDS_Shape, L: TDF_Label): Standard_Boolean;
  AddSubShape_1(shapeL: TDF_Label, sub: TopoDS_Shape): TDF_Label;
  AddSubShape_2(shapeL: TDF_Label, sub: TopoDS_Shape, addedSubShapeL: TDF_Label): Standard_Boolean;
  FindMainShapeUsingMap(sub: TopoDS_Shape): TDF_Label;
  FindMainShape(sub: TopoDS_Shape): TDF_Label;
  static GetSubShapes(L: TDF_Label, Labels: TDF_LabelSequence): Standard_Boolean;
  BaseLabel(): TDF_Label;
  static DumpShape(theDumpLog: Standard_OStream, L: TDF_Label, level: Graphic3d_ZLayerId, deep: Standard_Boolean): void;
  ID(): Standard_GUID;
  static IsExternRef(L: TDF_Label): Standard_Boolean;
  SetExternRefs_1(SHAS: TColStd_SequenceOfHAsciiString): TDF_Label;
  SetExternRefs_2(L: TDF_Label, SHAS: TColStd_SequenceOfHAsciiString): void;
  static GetExternRefs(L: TDF_Label, SHAS: TColStd_SequenceOfHAsciiString): void;
  SetSHUO(Labels: TDF_LabelSequence, MainSHUOAttr: Handle_XCAFDoc_GraphNode): Standard_Boolean;
  static GetSHUO(SHUOLabel: TDF_Label, aSHUOAttr: Handle_XCAFDoc_GraphNode): Standard_Boolean;
  static GetAllComponentSHUO(CompLabel: TDF_Label, SHUOAttrs: TDF_AttributeSequence): Standard_Boolean;
  static GetSHUOUpperUsage(NextUsageL: TDF_Label, Labels: TDF_LabelSequence): Standard_Boolean;
  static GetSHUONextUsage(UpperUsageL: TDF_Label, Labels: TDF_LabelSequence): Standard_Boolean;
  RemoveSHUO(SHUOLabel: TDF_Label): Standard_Boolean;
  FindComponent(theShape: TopoDS_Shape, Labels: TDF_LabelSequence): Standard_Boolean;
  GetSHUOInstance(theSHUO: Handle_XCAFDoc_GraphNode): TopoDS_Shape;
  SetInstanceSHUO(theShape: TopoDS_Shape): Handle_XCAFDoc_GraphNode;
  GetAllSHUOInstances(theSHUO: Handle_XCAFDoc_GraphNode, theSHUOShapeSeq: TopTools_SequenceOfShape): Standard_Boolean;
  static FindSHUO(Labels: TDF_LabelSequence, theSHUOAttr: Handle_XCAFDoc_GraphNode): Standard_Boolean;
  Expand(Shape: TDF_Label): Standard_Boolean;
  GetNamedProperties_1(theLabel: TDF_Label, theToCreate: Standard_Boolean): Handle_TDataStd_NamedData;
  GetNamedProperties_2(theShape: TopoDS_Shape, theToCreate: Standard_Boolean): Handle_TDataStd_NamedData;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_ShapeTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_ShapeTool): void;
  get(): XCAFDoc_ShapeTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_ShapeTool_1 extends Handle_XCAFDoc_ShapeTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_ShapeTool_2 extends Handle_XCAFDoc_ShapeTool {
    constructor(thePtr: XCAFDoc_ShapeTool);
  }

  export declare class Handle_XCAFDoc_ShapeTool_3 extends Handle_XCAFDoc_ShapeTool {
    constructor(theHandle: Handle_XCAFDoc_ShapeTool);
  }

  export declare class Handle_XCAFDoc_ShapeTool_4 extends Handle_XCAFDoc_ShapeTool {
    constructor(theHandle: Handle_XCAFDoc_ShapeTool);
  }

export declare class Handle_XCAFDoc_VisMaterialTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_VisMaterialTool): void;
  get(): XCAFDoc_VisMaterialTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_VisMaterialTool_1 extends Handle_XCAFDoc_VisMaterialTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_VisMaterialTool_2 extends Handle_XCAFDoc_VisMaterialTool {
    constructor(thePtr: XCAFDoc_VisMaterialTool);
  }

  export declare class Handle_XCAFDoc_VisMaterialTool_3 extends Handle_XCAFDoc_VisMaterialTool {
    constructor(theHandle: Handle_XCAFDoc_VisMaterialTool);
  }

  export declare class Handle_XCAFDoc_VisMaterialTool_4 extends Handle_XCAFDoc_VisMaterialTool {
    constructor(theHandle: Handle_XCAFDoc_VisMaterialTool);
  }

export declare class XCAFDoc_VisMaterialTool extends TDF_Attribute {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static Set(L: TDF_Label): Handle_XCAFDoc_VisMaterialTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  ShapeTool(): Handle_XCAFDoc_ShapeTool;
  IsMaterial(theLabel: TDF_Label): Standard_Boolean;
  GetMaterial(theMatLabel: TDF_Label): Handle_XCAFDoc_VisMaterial;
  AddMaterial_1(theMat: Handle_XCAFDoc_VisMaterial, theName: XCAFDoc_PartId): TDF_Label;
  AddMaterial_2(theName: XCAFDoc_PartId): TDF_Label;
  RemoveMaterial(theLabel: TDF_Label): void;
  GetMaterials(Labels: TDF_LabelSequence): void;
  SetShapeMaterial_1(theShapeLabel: TDF_Label, theMaterialLabel: TDF_Label): void;
  UnSetShapeMaterial_1(theShapeLabel: TDF_Label): void;
  IsSetShapeMaterial_1(theLabel: TDF_Label): Standard_Boolean;
  static GetShapeMaterial_1(theShapeLabel: TDF_Label, theMaterialLabel: TDF_Label): Standard_Boolean;
  GetShapeMaterial_2(theShapeLabel: TDF_Label): Handle_XCAFDoc_VisMaterial;
  SetShapeMaterial_2(theShape: TopoDS_Shape, theMaterialLabel: TDF_Label): Standard_Boolean;
  UnSetShapeMaterial_2(theShape: TopoDS_Shape): Standard_Boolean;
  IsSetShapeMaterial_2(theShape: TopoDS_Shape): Standard_Boolean;
  GetShapeMaterial_3(theShape: TopoDS_Shape, theMaterialLabel: TDF_Label): Standard_Boolean;
  GetShapeMaterial_4(theShape: TopoDS_Shape): Handle_XCAFDoc_VisMaterial;
  ID(): Standard_GUID;
  Restore(a0: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(a0: Handle_TDF_Attribute, a1: Handle_TDF_RelocationTable): void;
  delete(): void;
}

export declare class Handle_XCAFDoc_NoteBalloon {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_NoteBalloon): void;
  get(): XCAFDoc_NoteBalloon;
  delete(): void;
}

  export declare class Handle_XCAFDoc_NoteBalloon_1 extends Handle_XCAFDoc_NoteBalloon {
    constructor();
  }

  export declare class Handle_XCAFDoc_NoteBalloon_2 extends Handle_XCAFDoc_NoteBalloon {
    constructor(thePtr: XCAFDoc_NoteBalloon);
  }

  export declare class Handle_XCAFDoc_NoteBalloon_3 extends Handle_XCAFDoc_NoteBalloon {
    constructor(theHandle: Handle_XCAFDoc_NoteBalloon);
  }

  export declare class Handle_XCAFDoc_NoteBalloon_4 extends Handle_XCAFDoc_NoteBalloon {
    constructor(theHandle: Handle_XCAFDoc_NoteBalloon);
  }

export declare class XCAFDoc_NoteBalloon extends XCAFDoc_NoteComment {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  static GetID(): Standard_GUID;
  static Get(theLabel: TDF_Label): Handle_XCAFDoc_NoteBalloon;
  static Set(theLabel: TDF_Label, theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theComment: TCollection_ExtendedString): Handle_XCAFDoc_NoteBalloon;
  ID(): Standard_GUID;
  delete(): void;
}

export declare class Handle_XCAFDoc_ViewTool {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_ViewTool): void;
  get(): XCAFDoc_ViewTool;
  delete(): void;
}

  export declare class Handle_XCAFDoc_ViewTool_1 extends Handle_XCAFDoc_ViewTool {
    constructor();
  }

  export declare class Handle_XCAFDoc_ViewTool_2 extends Handle_XCAFDoc_ViewTool {
    constructor(thePtr: XCAFDoc_ViewTool);
  }

  export declare class Handle_XCAFDoc_ViewTool_3 extends Handle_XCAFDoc_ViewTool {
    constructor(theHandle: Handle_XCAFDoc_ViewTool);
  }

  export declare class Handle_XCAFDoc_ViewTool_4 extends Handle_XCAFDoc_ViewTool {
    constructor(theHandle: Handle_XCAFDoc_ViewTool);
  }

export declare class XCAFDoc_ViewTool extends TDataStd_GenericEmpty {
  constructor()
  static Set(L: TDF_Label): Handle_XCAFDoc_ViewTool;
  static GetID(): Standard_GUID;
  BaseLabel(): TDF_Label;
  IsView(theLabel: TDF_Label): Standard_Boolean;
  GetViewLabels(theLabels: TDF_LabelSequence): void;
  SetView_1(theShapes: TDF_LabelSequence, theGDTs: TDF_LabelSequence, theClippingPlanes: TDF_LabelSequence, theNotes: TDF_LabelSequence, theAnnotations: TDF_LabelSequence, theViewL: TDF_Label): void;
  SetView_2(theShapes: TDF_LabelSequence, theGDTs: TDF_LabelSequence, theClippingPlanes: TDF_LabelSequence, theViewL: TDF_Label): void;
  SetView_3(theShapes: TDF_LabelSequence, theGDTs: TDF_LabelSequence, theViewL: TDF_Label): void;
  SetClippingPlanes(theClippingPlaneLabels: TDF_LabelSequence, theViewL: TDF_Label): void;
  RemoveView(theViewL: TDF_Label): void;
  GetViewLabelsForShape(theShapeL: TDF_Label, theViews: TDF_LabelSequence): Standard_Boolean;
  GetViewLabelsForGDT(theGDTL: TDF_Label, theViews: TDF_LabelSequence): Standard_Boolean;
  GetViewLabelsForClippingPlane(theClippingPlaneL: TDF_Label, theViews: TDF_LabelSequence): Standard_Boolean;
  GetViewLabelsForNote(theNoteL: TDF_Label, theViews: TDF_LabelSequence): Standard_Boolean;
  GetViewLabelsForAnnotation(theAnnotationL: TDF_Label, theViews: TDF_LabelSequence): Standard_Boolean;
  AddView(): TDF_Label;
  GetRefShapeLabel(theViewL: TDF_Label, theShapeLabels: TDF_LabelSequence): Standard_Boolean;
  GetRefGDTLabel(theViewL: TDF_Label, theGDTLabels: TDF_LabelSequence): Standard_Boolean;
  GetRefClippingPlaneLabel(theViewL: TDF_Label, theClippingPlaneLabels: TDF_LabelSequence): Standard_Boolean;
  GetRefNoteLabel(theViewL: TDF_Label, theNoteLabels: TDF_LabelSequence): Standard_Boolean;
  GetRefAnnotationLabel(theViewL: TDF_Label, theAnnotationLabels: TDF_LabelSequence): Standard_Boolean;
  IsLocked(theViewL: TDF_Label): Standard_Boolean;
  Lock(theViewL: TDF_Label): void;
  Unlock(theViewL: TDF_Label): void;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_View {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_View): void;
  get(): XCAFDoc_View;
  delete(): void;
}

  export declare class Handle_XCAFDoc_View_1 extends Handle_XCAFDoc_View {
    constructor();
  }

  export declare class Handle_XCAFDoc_View_2 extends Handle_XCAFDoc_View {
    constructor(thePtr: XCAFDoc_View);
  }

  export declare class Handle_XCAFDoc_View_3 extends Handle_XCAFDoc_View {
    constructor(theHandle: Handle_XCAFDoc_View);
  }

  export declare class Handle_XCAFDoc_View_4 extends Handle_XCAFDoc_View {
    constructor(theHandle: Handle_XCAFDoc_View);
  }

export declare class XCAFDoc_View extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set(theLabel: TDF_Label): Handle_XCAFDoc_View;
  ID(): Standard_GUID;
  SetObject(theViewObject: Handle_XCAFView_Object): void;
  GetObject(): Handle_XCAFView_Object;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_XCAFDoc_Location {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_Location): void;
  get(): XCAFDoc_Location;
  delete(): void;
}

  export declare class Handle_XCAFDoc_Location_1 extends Handle_XCAFDoc_Location {
    constructor();
  }

  export declare class Handle_XCAFDoc_Location_2 extends Handle_XCAFDoc_Location {
    constructor(thePtr: XCAFDoc_Location);
  }

  export declare class Handle_XCAFDoc_Location_3 extends Handle_XCAFDoc_Location {
    constructor(theHandle: Handle_XCAFDoc_Location);
  }

  export declare class Handle_XCAFDoc_Location_4 extends Handle_XCAFDoc_Location {
    constructor(theHandle: Handle_XCAFDoc_Location);
  }

export declare class XCAFDoc_Location extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, Loc: TopLoc_Location): Handle_XCAFDoc_Location;
  Set_2(Loc: TopLoc_Location): void;
  Get(): TopLoc_Location;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XCAFDoc_NoteBinData extends XCAFDoc_Note {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  static GetID(): Standard_GUID;
  static Get(theLabel: TDF_Label): Handle_XCAFDoc_NoteBinData;
  static Set_1(theLabel: TDF_Label, theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theTitle: TCollection_ExtendedString, theMIMEtype: XCAFDoc_PartId, theFile: OSD_File): Handle_XCAFDoc_NoteBinData;
  static Set_2(theLabel: TDF_Label, theUserName: TCollection_ExtendedString, theTimeStamp: TCollection_ExtendedString, theTitle: TCollection_ExtendedString, theMIMEtype: XCAFDoc_PartId, theData: Handle_TColStd_HArray1OfByte): Handle_XCAFDoc_NoteBinData;
  Set_3(theTitle: TCollection_ExtendedString, theMIMEtype: XCAFDoc_PartId, theFile: OSD_File): Standard_Boolean;
  Set_4(theTitle: TCollection_ExtendedString, theMIMEtype: XCAFDoc_PartId, theData: Handle_TColStd_HArray1OfByte): void;
  Title(): TCollection_ExtendedString;
  MIMEtype(): XCAFDoc_PartId;
  Size(): Graphic3d_ZLayerId;
  Data(): Handle_TColStd_HArray1OfByte;
  ID(): Standard_GUID;
  NewEmpty(): Handle_TDF_Attribute;
  Restore(theAttrFrom: Handle_TDF_Attribute): void;
  Paste(theAttrInto: Handle_TDF_Attribute, theRT: Handle_TDF_RelocationTable): void;
  delete(): void;
}

export declare class Handle_XCAFDoc_NoteBinData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_NoteBinData): void;
  get(): XCAFDoc_NoteBinData;
  delete(): void;
}

  export declare class Handle_XCAFDoc_NoteBinData_1 extends Handle_XCAFDoc_NoteBinData {
    constructor();
  }

  export declare class Handle_XCAFDoc_NoteBinData_2 extends Handle_XCAFDoc_NoteBinData {
    constructor(thePtr: XCAFDoc_NoteBinData);
  }

  export declare class Handle_XCAFDoc_NoteBinData_3 extends Handle_XCAFDoc_NoteBinData {
    constructor(theHandle: Handle_XCAFDoc_NoteBinData);
  }

  export declare class Handle_XCAFDoc_NoteBinData_4 extends Handle_XCAFDoc_NoteBinData {
    constructor(theHandle: Handle_XCAFDoc_NoteBinData);
  }

export declare class XCAFDoc_DimTol extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label, kind: Graphic3d_ZLayerId, aVal: Handle_TColStd_HArray1OfReal, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString): Handle_XCAFDoc_DimTol;
  Set_2(kind: Graphic3d_ZLayerId, aVal: Handle_TColStd_HArray1OfReal, aName: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString): void;
  GetKind(): Graphic3d_ZLayerId;
  GetVal(): Handle_TColStd_HArray1OfReal;
  GetName(): Handle_TCollection_HAsciiString;
  GetDescription(): Handle_TCollection_HAsciiString;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XCAFDoc_DimTol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XCAFDoc_DimTol): void;
  get(): XCAFDoc_DimTol;
  delete(): void;
}

  export declare class Handle_XCAFDoc_DimTol_1 extends Handle_XCAFDoc_DimTol {
    constructor();
  }

  export declare class Handle_XCAFDoc_DimTol_2 extends Handle_XCAFDoc_DimTol {
    constructor(thePtr: XCAFDoc_DimTol);
  }

  export declare class Handle_XCAFDoc_DimTol_3 extends Handle_XCAFDoc_DimTol {
    constructor(theHandle: Handle_XCAFDoc_DimTol);
  }

  export declare class Handle_XCAFDoc_DimTol_4 extends Handle_XCAFDoc_DimTol {
    constructor(theHandle: Handle_XCAFDoc_DimTol);
  }

export declare class XCAFDoc {
  constructor();
  static AssemblyGUID(): Standard_GUID;
  static ShapeRefGUID(): Standard_GUID;
  static ColorRefGUID(type: XCAFDoc_ColorType): Standard_GUID;
  static DimTolRefGUID(): Standard_GUID;
  static DimensionRefFirstGUID(): Standard_GUID;
  static DimensionRefSecondGUID(): Standard_GUID;
  static GeomToleranceRefGUID(): Standard_GUID;
  static DatumRefGUID(): Standard_GUID;
  static DatumTolRefGUID(): Standard_GUID;
  static LayerRefGUID(): Standard_GUID;
  static MaterialRefGUID(): Standard_GUID;
  static VisMaterialRefGUID(): Standard_GUID;
  static NoteRefGUID(): Standard_GUID;
  static InvisibleGUID(): Standard_GUID;
  static ColorByLayerGUID(): Standard_GUID;
  static ExternRefGUID(): Standard_GUID;
  static SHUORefGUID(): Standard_GUID;
  static ViewRefGUID(): Standard_GUID;
  static ViewRefShapeGUID(): Standard_GUID;
  static ViewRefGDTGUID(): Standard_GUID;
  static ViewRefPlaneGUID(): Standard_GUID;
  static ViewRefNoteGUID(): Standard_GUID;
  static ViewRefAnnotationGUID(): Standard_GUID;
  static LockGUID(): Standard_GUID;
  delete(): void;
}

export declare class Handle_STEPEdit_EditContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPEdit_EditContext): void;
  get(): STEPEdit_EditContext;
  delete(): void;
}

  export declare class Handle_STEPEdit_EditContext_1 extends Handle_STEPEdit_EditContext {
    constructor();
  }

  export declare class Handle_STEPEdit_EditContext_2 extends Handle_STEPEdit_EditContext {
    constructor(thePtr: STEPEdit_EditContext);
  }

  export declare class Handle_STEPEdit_EditContext_3 extends Handle_STEPEdit_EditContext {
    constructor(theHandle: Handle_STEPEdit_EditContext);
  }

  export declare class Handle_STEPEdit_EditContext_4 extends Handle_STEPEdit_EditContext {
    constructor(theHandle: Handle_STEPEdit_EditContext);
  }

export declare class STEPEdit_EditContext extends IFSelect_Editor {
  constructor()
  Label(): XCAFDoc_PartId;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class STEPEdit {
  constructor();
  static Protocol(): Handle_Interface_Protocol;
  static NewModel(): Handle_StepData_StepModel;
  static SignType(): Handle_IFSelect_Signature;
  static NewSelectSDR(): Handle_IFSelect_SelectSignature;
  static NewSelectPlacedItem(): Handle_IFSelect_SelectSignature;
  static NewSelectShapeRepr(): Handle_IFSelect_SelectSignature;
  delete(): void;
}

export declare class STEPEdit_EditSDR extends IFSelect_Editor {
  constructor()
  Label(): XCAFDoc_PartId;
  Recognize(form: Handle_IFSelect_EditForm): Standard_Boolean;
  StringValue(form: Handle_IFSelect_EditForm, num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  Apply(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  Load(form: Handle_IFSelect_EditForm, ent: Handle_Standard_Transient, model: Handle_Interface_InterfaceModel): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_STEPEdit_EditSDR {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: STEPEdit_EditSDR): void;
  get(): STEPEdit_EditSDR;
  delete(): void;
}

  export declare class Handle_STEPEdit_EditSDR_1 extends Handle_STEPEdit_EditSDR {
    constructor();
  }

  export declare class Handle_STEPEdit_EditSDR_2 extends Handle_STEPEdit_EditSDR {
    constructor(thePtr: STEPEdit_EditSDR);
  }

  export declare class Handle_STEPEdit_EditSDR_3 extends Handle_STEPEdit_EditSDR {
    constructor(theHandle: Handle_STEPEdit_EditSDR);
  }

  export declare class Handle_STEPEdit_EditSDR_4 extends Handle_STEPEdit_EditSDR {
    constructor(theHandle: Handle_STEPEdit_EditSDR);
  }

export declare class BRepToIGESBRep_Entity extends BRepToIGES_BREntity {
  constructor()
  Clear(): void;
  TransferVertexList(): void;
  IndexVertex(myvertex: TopoDS_Vertex): Graphic3d_ZLayerId;
  AddVertex(myvertex: TopoDS_Vertex): Graphic3d_ZLayerId;
  TransferEdgeList(): void;
  IndexEdge(myedge: TopoDS_Edge): Graphic3d_ZLayerId;
  AddEdge(myedge: TopoDS_Edge, mycurve3d: Handle_IGESData_IGESEntity): Graphic3d_ZLayerId;
  TransferShape(start: TopoDS_Shape, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferEdge_1(myedge: TopoDS_Edge): Handle_IGESData_IGESEntity;
  TransferEdge_2(myedge: TopoDS_Edge, myface: TopoDS_Face, length: Quantity_AbsorbedDose): Handle_IGESData_IGESEntity;
  TransferWire(mywire: TopoDS_Wire, myface: TopoDS_Face, length: Quantity_AbsorbedDose): Handle_IGESSolid_Loop;
  TransferFace(start: TopoDS_Face): Handle_IGESSolid_Face;
  TransferShell(start: TopoDS_Shell, theProgress: Message_ProgressRange): Handle_IGESSolid_Shell;
  TransferSolid(start: TopoDS_Solid, theProgress: Message_ProgressRange): Handle_IGESSolid_ManifoldSolid;
  TransferCompSolid(start: TopoDS_CompSolid, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  TransferCompound(start: TopoDS_Compound, theProgress: Message_ProgressRange): Handle_IGESData_IGESEntity;
  delete(): void;
}

export declare class AppStd_Application extends TDocStd_Application {
  constructor();
  ResourcesName(): Standard_CString;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_AppStd_Application {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: AppStd_Application): void;
  get(): AppStd_Application;
  delete(): void;
}

  export declare class Handle_AppStd_Application_1 extends Handle_AppStd_Application {
    constructor();
  }

  export declare class Handle_AppStd_Application_2 extends Handle_AppStd_Application {
    constructor(thePtr: AppStd_Application);
  }

  export declare class Handle_AppStd_Application_3 extends Handle_AppStd_Application {
    constructor(theHandle: Handle_AppStd_Application);
  }

  export declare class Handle_AppStd_Application_4 extends Handle_AppStd_Application {
    constructor(theHandle: Handle_AppStd_Application);
  }

export declare type Prs3d_TypeOfHLR = {
  Prs3d_TOH_NotSet: {};
  Prs3d_TOH_PolyAlgo: {};
  Prs3d_TOH_Algo: {};
}

export declare type Prs3d_DatumAxes = {
  Prs3d_DA_XAxis: {};
  Prs3d_DA_YAxis: {};
  Prs3d_DA_ZAxis: {};
  Prs3d_DA_XYAxis: {};
  Prs3d_DA_YZAxis: {};
  Prs3d_DA_XZAxis: {};
  Prs3d_DA_XYZAxis: {};
}

export declare class Handle_Prs3d_BasicAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_BasicAspect): void;
  get(): Prs3d_BasicAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_BasicAspect_1 extends Handle_Prs3d_BasicAspect {
    constructor();
  }

  export declare class Handle_Prs3d_BasicAspect_2 extends Handle_Prs3d_BasicAspect {
    constructor(thePtr: Prs3d_BasicAspect);
  }

  export declare class Handle_Prs3d_BasicAspect_3 extends Handle_Prs3d_BasicAspect {
    constructor(theHandle: Handle_Prs3d_BasicAspect);
  }

  export declare class Handle_Prs3d_BasicAspect_4 extends Handle_Prs3d_BasicAspect {
    constructor(theHandle: Handle_Prs3d_BasicAspect);
  }

export declare class Prs3d_BasicAspect extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Prs3d_Text {
  constructor();
  static Draw_1(theGroup: Handle_Graphic3d_Group, theAspect: Handle_Prs3d_TextAspect, theText: TCollection_ExtendedString, theAttachmentPoint: gp_Pnt): Handle_Graphic3d_Text;
  static Draw_2(theGroup: Handle_Graphic3d_Group, theAspect: Handle_Prs3d_TextAspect, theText: TCollection_ExtendedString, theOrientation: gp_Ax2, theHasOwnAnchor: Standard_Boolean): Handle_Graphic3d_Text;
  static Draw_3(thePrs: any, theDrawer: Handle_Prs3d_Drawer, theText: TCollection_ExtendedString, theAttachmentPoint: gp_Pnt): void;
  static Draw_4(thePrs: any, theAspect: Handle_Prs3d_TextAspect, theText: TCollection_ExtendedString, theOrientation: gp_Ax2, theHasOwnAnchor: Standard_Boolean): void;
  static Draw_5(thePrs: any, theAspect: Handle_Prs3d_TextAspect, theText: TCollection_ExtendedString, theAttachmentPoint: gp_Pnt): void;
  delete(): void;
}

export declare class Prs3d_Arrow {
  constructor();
  static DrawShaded(theAxis: gp_Ax1, theTubeRadius: Quantity_AbsorbedDose, theAxisLength: Quantity_AbsorbedDose, theConeRadius: Quantity_AbsorbedDose, theConeLength: Quantity_AbsorbedDose, theNbFacettes: Graphic3d_ZLayerId): Handle_Graphic3d_ArrayOfTriangles;
  static DrawSegments(theLocation: gp_Pnt, theDir: gp_Dir, theAngle: Quantity_AbsorbedDose, theLength: Quantity_AbsorbedDose, theNbSegments: Graphic3d_ZLayerId): Handle_Graphic3d_ArrayOfSegments;
  static Draw_1(theGroup: Handle_Graphic3d_Group, theLocation: gp_Pnt, theDirection: gp_Dir, theAngle: Quantity_AbsorbedDose, theLength: Quantity_AbsorbedDose): void;
  static Draw_2(thePrs: any, theLocation: gp_Pnt, theDirection: gp_Dir, theAngle: Quantity_AbsorbedDose, theLength: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Handle_Prs3d_PlaneAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_PlaneAspect): void;
  get(): Prs3d_PlaneAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_PlaneAspect_1 extends Handle_Prs3d_PlaneAspect {
    constructor();
  }

  export declare class Handle_Prs3d_PlaneAspect_2 extends Handle_Prs3d_PlaneAspect {
    constructor(thePtr: Prs3d_PlaneAspect);
  }

  export declare class Handle_Prs3d_PlaneAspect_3 extends Handle_Prs3d_PlaneAspect {
    constructor(theHandle: Handle_Prs3d_PlaneAspect);
  }

  export declare class Handle_Prs3d_PlaneAspect_4 extends Handle_Prs3d_PlaneAspect {
    constructor(theHandle: Handle_Prs3d_PlaneAspect);
  }

export declare class Prs3d_PlaneAspect extends Prs3d_BasicAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  EdgesAspect(): Handle_Prs3d_LineAspect;
  IsoAspect(): Handle_Prs3d_LineAspect;
  ArrowAspect(): Handle_Prs3d_LineAspect;
  SetArrowsLength(theLength: Quantity_AbsorbedDose): void;
  ArrowsLength(): Quantity_AbsorbedDose;
  SetArrowsSize(theSize: Quantity_AbsorbedDose): void;
  ArrowsSize(): Quantity_AbsorbedDose;
  SetArrowsAngle(theAngle: Quantity_AbsorbedDose): void;
  ArrowsAngle(): Quantity_AbsorbedDose;
  SetDisplayCenterArrow(theToDraw: Standard_Boolean): void;
  DisplayCenterArrow(): Standard_Boolean;
  SetDisplayEdgesArrows(theToDraw: Standard_Boolean): void;
  DisplayEdgesArrows(): Standard_Boolean;
  SetDisplayEdges(theToDraw: Standard_Boolean): void;
  DisplayEdges(): Standard_Boolean;
  SetDisplayIso(theToDraw: Standard_Boolean): void;
  DisplayIso(): Standard_Boolean;
  SetPlaneLength(theLX: Quantity_AbsorbedDose, theLY: Quantity_AbsorbedDose): void;
  PlaneXLength(): Quantity_AbsorbedDose;
  PlaneYLength(): Quantity_AbsorbedDose;
  SetIsoDistance(theL: Quantity_AbsorbedDose): void;
  IsoDistance(): Quantity_AbsorbedDose;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Prs3d_DimensionUnits {
  SetAngleUnits(theUnits: XCAFDoc_PartId): void;
  GetAngleUnits(): XCAFDoc_PartId;
  SetLengthUnits(theUnits: XCAFDoc_PartId): void;
  GetLengthUnits(): XCAFDoc_PartId;
  delete(): void;
}

  export declare class Prs3d_DimensionUnits_1 extends Prs3d_DimensionUnits {
    constructor();
  }

  export declare class Prs3d_DimensionUnits_2 extends Prs3d_DimensionUnits {
    constructor(theUnits: Prs3d_DimensionUnits);
  }

export declare class Prs3d_BndBox extends Prs3d_Root {
  constructor();
  static Add_1(thePresentation: any, theBndBox: Bnd_Box, theDrawer: Handle_Prs3d_Drawer): void;
  static Add_2(thePresentation: any, theBndBox: Bnd_OBB, theDrawer: Handle_Prs3d_Drawer): void;
  static FillSegments_1(theBox: Bnd_OBB): Handle_Graphic3d_ArrayOfSegments;
  static FillSegments_2(theBox: Bnd_Box): Handle_Graphic3d_ArrayOfSegments;
  static FillSegments_3(theSegments: Handle_Graphic3d_ArrayOfSegments, theBox: Bnd_OBB): void;
  static FillSegments_4(theSegments: Handle_Graphic3d_ArrayOfSegments, theBox: Bnd_Box): void;
  static fillSegments(theSegments: Handle_Graphic3d_ArrayOfSegments, theBox: gp_Pnt): void;
  delete(): void;
}

export declare type Prs3d_DatumParts = {
  Prs3d_DP_Origin: {};
  Prs3d_DP_XAxis: {};
  Prs3d_DP_YAxis: {};
  Prs3d_DP_ZAxis: {};
  Prs3d_DP_XArrow: {};
  Prs3d_DP_YArrow: {};
  Prs3d_DP_ZArrow: {};
  Prs3d_DP_XOYAxis: {};
  Prs3d_DP_YOZAxis: {};
  Prs3d_DP_XOZAxis: {};
  Prs3d_DP_None: {};
}

export declare class Prs3d_TextAspect extends Prs3d_BasicAspect {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColor(theColor: Quantity_Color): void;
  SetFont(theFont: Standard_CString): void;
  SetHeight(theHeight: Quantity_AbsorbedDose): void;
  SetAngle(theAngle: Quantity_AbsorbedDose): void;
  Height(): Quantity_AbsorbedDose;
  Angle(): Quantity_AbsorbedDose;
  SetHorizontalJustification(theJustification: Graphic3d_HorizontalTextAlignment): void;
  SetVerticalJustification(theJustification: Graphic3d_VerticalTextAlignment): void;
  SetOrientation(theOrientation: Graphic3d_TextPath): void;
  HorizontalJustification(): Graphic3d_HorizontalTextAlignment;
  VerticalJustification(): Graphic3d_VerticalTextAlignment;
  Orientation(): Graphic3d_TextPath;
  Aspect(): Handle_Graphic3d_AspectText3d;
  SetAspect(theAspect: Handle_Graphic3d_AspectText3d): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Prs3d_TextAspect_1 extends Prs3d_TextAspect {
    constructor();
  }

  export declare class Prs3d_TextAspect_2 extends Prs3d_TextAspect {
    constructor(theAspect: Handle_Graphic3d_AspectText3d);
  }

export declare class Handle_Prs3d_TextAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_TextAspect): void;
  get(): Prs3d_TextAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_TextAspect_1 extends Handle_Prs3d_TextAspect {
    constructor();
  }

  export declare class Handle_Prs3d_TextAspect_2 extends Handle_Prs3d_TextAspect {
    constructor(thePtr: Prs3d_TextAspect);
  }

  export declare class Handle_Prs3d_TextAspect_3 extends Handle_Prs3d_TextAspect {
    constructor(theHandle: Handle_Prs3d_TextAspect);
  }

  export declare class Handle_Prs3d_TextAspect_4 extends Handle_Prs3d_TextAspect {
    constructor(theHandle: Handle_Prs3d_TextAspect);
  }

export declare class Prs3d_ToolSector extends Prs3d_ToolQuadric {
  constructor(theRadius: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId)
  static Create(theRadius: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  delete(): void;
}

export declare class Prs3d_ToolTorus extends Prs3d_ToolQuadric {
  static Create_1(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  static Create_2(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  static Create_3(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theAngle1: Quantity_AbsorbedDose, theAngle2: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  static Create_4(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theAngle1: Quantity_AbsorbedDose, theAngle2: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  delete(): void;
}

  export declare class Prs3d_ToolTorus_1 extends Prs3d_ToolTorus {
    constructor(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId);
  }

  export declare class Prs3d_ToolTorus_2 extends Prs3d_ToolTorus {
    constructor(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId);
  }

  export declare class Prs3d_ToolTorus_3 extends Prs3d_ToolTorus {
    constructor(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theAngle1: Quantity_AbsorbedDose, theAngle2: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId);
  }

  export declare class Prs3d_ToolTorus_4 extends Prs3d_ToolTorus {
    constructor(theMajorRad: Quantity_AbsorbedDose, theMinorRad: Quantity_AbsorbedDose, theAngle1: Quantity_AbsorbedDose, theAngle2: Quantity_AbsorbedDose, theAngle: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId);
  }

export declare type Prs3d_DimensionArrowOrientation = {
  Prs3d_DAO_Internal: {};
  Prs3d_DAO_External: {};
  Prs3d_DAO_Fit: {};
}

export declare class Handle_Prs3d_LineAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_LineAspect): void;
  get(): Prs3d_LineAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_LineAspect_1 extends Handle_Prs3d_LineAspect {
    constructor();
  }

  export declare class Handle_Prs3d_LineAspect_2 extends Handle_Prs3d_LineAspect {
    constructor(thePtr: Prs3d_LineAspect);
  }

  export declare class Handle_Prs3d_LineAspect_3 extends Handle_Prs3d_LineAspect {
    constructor(theHandle: Handle_Prs3d_LineAspect);
  }

  export declare class Handle_Prs3d_LineAspect_4 extends Handle_Prs3d_LineAspect {
    constructor(theHandle: Handle_Prs3d_LineAspect);
  }

export declare class Prs3d_LineAspect extends Prs3d_BasicAspect {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColor(theColor: Quantity_Color): void;
  SetTypeOfLine(theType: Aspect_TypeOfLine): void;
  SetWidth(theWidth: Quantity_AbsorbedDose): void;
  Aspect(): Handle_Graphic3d_AspectLine3d;
  SetAspect(theAspect: Handle_Graphic3d_AspectLine3d): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Prs3d_LineAspect_1 extends Prs3d_LineAspect {
    constructor(theColor: Quantity_Color, theType: Aspect_TypeOfLine, theWidth: Quantity_AbsorbedDose);
  }

  export declare class Prs3d_LineAspect_2 extends Prs3d_LineAspect {
    constructor(theAspect: Handle_Graphic3d_AspectLine3d);
  }

export declare class Prs3d_ToolDisk extends Prs3d_ToolQuadric {
  constructor(theInnerRadius: Quantity_AbsorbedDose, theOuterRadius: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId)
  static Create(theInnerRadius: Quantity_AbsorbedDose, theOuterRadius: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  SetAngleRange(theStartAngle: Quantity_AbsorbedDose, theEndAngle: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class Prs3d_ShadingAspect extends Prs3d_BasicAspect {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColor(aColor: Quantity_Color, aModel: Aspect_TypeOfFacingModel): void;
  SetMaterial(aMaterial: Graphic3d_MaterialAspect, aModel: Aspect_TypeOfFacingModel): void;
  SetTransparency(aValue: Quantity_AbsorbedDose, aModel: Aspect_TypeOfFacingModel): void;
  Color(aModel: Aspect_TypeOfFacingModel): Quantity_Color;
  Material(aModel: Aspect_TypeOfFacingModel): Graphic3d_MaterialAspect;
  Transparency(aModel: Aspect_TypeOfFacingModel): Quantity_AbsorbedDose;
  Aspect(): Handle_Graphic3d_AspectFillArea3d;
  SetAspect(theAspect: Handle_Graphic3d_AspectFillArea3d): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Prs3d_ShadingAspect_1 extends Prs3d_ShadingAspect {
    constructor();
  }

  export declare class Prs3d_ShadingAspect_2 extends Prs3d_ShadingAspect {
    constructor(theAspect: Handle_Graphic3d_AspectFillArea3d);
  }

export declare class Handle_Prs3d_ShadingAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_ShadingAspect): void;
  get(): Prs3d_ShadingAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_ShadingAspect_1 extends Handle_Prs3d_ShadingAspect {
    constructor();
  }

  export declare class Handle_Prs3d_ShadingAspect_2 extends Handle_Prs3d_ShadingAspect {
    constructor(thePtr: Prs3d_ShadingAspect);
  }

  export declare class Handle_Prs3d_ShadingAspect_3 extends Handle_Prs3d_ShadingAspect {
    constructor(theHandle: Handle_Prs3d_ShadingAspect);
  }

  export declare class Handle_Prs3d_ShadingAspect_4 extends Handle_Prs3d_ShadingAspect {
    constructor(theHandle: Handle_Prs3d_ShadingAspect);
  }

export declare class Handle_Prs3d_PresentationShadow {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_PresentationShadow): void;
  get(): Prs3d_PresentationShadow;
  delete(): void;
}

  export declare class Handle_Prs3d_PresentationShadow_1 extends Handle_Prs3d_PresentationShadow {
    constructor();
  }

  export declare class Handle_Prs3d_PresentationShadow_2 extends Handle_Prs3d_PresentationShadow {
    constructor(thePtr: Prs3d_PresentationShadow);
  }

  export declare class Handle_Prs3d_PresentationShadow_3 extends Handle_Prs3d_PresentationShadow {
    constructor(theHandle: Handle_Prs3d_PresentationShadow);
  }

  export declare class Handle_Prs3d_PresentationShadow_4 extends Handle_Prs3d_PresentationShadow {
    constructor(theHandle: Handle_Prs3d_PresentationShadow);
  }

export declare class Prs3d_PresentationShadow extends Graphic3d_Structure {
  constructor(theViewer: Handle_Graphic3d_StructureManager, thePrs: Handle_Graphic3d_Structure)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ParentId(): Graphic3d_ZLayerId;
  ParentAffinity(): Handle_Graphic3d_ViewAffinity;
  CalculateBoundBox(): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare type Prs3d_TypeOfHighlight = {
  Prs3d_TypeOfHighlight_None: {};
  Prs3d_TypeOfHighlight_Selected: {};
  Prs3d_TypeOfHighlight_Dynamic: {};
  Prs3d_TypeOfHighlight_LocalSelected: {};
  Prs3d_TypeOfHighlight_LocalDynamic: {};
  Prs3d_TypeOfHighlight_SubIntensity: {};
  Prs3d_TypeOfHighlight_NB: {};
}

export declare class Handle_Prs3d_IsoAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_IsoAspect): void;
  get(): Prs3d_IsoAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_IsoAspect_1 extends Handle_Prs3d_IsoAspect {
    constructor();
  }

  export declare class Handle_Prs3d_IsoAspect_2 extends Handle_Prs3d_IsoAspect {
    constructor(thePtr: Prs3d_IsoAspect);
  }

  export declare class Handle_Prs3d_IsoAspect_3 extends Handle_Prs3d_IsoAspect {
    constructor(theHandle: Handle_Prs3d_IsoAspect);
  }

  export declare class Handle_Prs3d_IsoAspect_4 extends Handle_Prs3d_IsoAspect {
    constructor(theHandle: Handle_Prs3d_IsoAspect);
  }

export declare class Prs3d_IsoAspect extends Prs3d_LineAspect {
  constructor(theColor: Quantity_Color, theType: Aspect_TypeOfLine, theWidth: Quantity_AbsorbedDose, theNumber: Graphic3d_ZLayerId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetNumber(theNumber: Graphic3d_ZLayerId): void;
  Number(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare type Prs3d_VertexDrawMode = {
  Prs3d_VDM_Isolated: {};
  Prs3d_VDM_All: {};
  Prs3d_VDM_Inherited: {};
}

export declare class Prs3d_DatumAspect extends Prs3d_BasicAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  LineAspect(thePart: Prs3d_DatumParts): Handle_Prs3d_LineAspect;
  ShadingAspect(thePart: Prs3d_DatumParts): Handle_Prs3d_ShadingAspect;
  TextAspect(): Handle_Prs3d_TextAspect;
  SetTextAspect(theTextAspect: Handle_Prs3d_TextAspect): void;
  PointAspect(): Handle_Prs3d_PointAspect;
  SetPointAspect(theAspect: Handle_Prs3d_PointAspect): void;
  ArrowAspect(): Handle_Prs3d_ArrowAspect;
  SetArrowAspect(theAspect: Handle_Prs3d_ArrowAspect): void;
  FirstAxisAspect(): Handle_Prs3d_LineAspect;
  SecondAxisAspect(): Handle_Prs3d_LineAspect;
  ThirdAxisAspect(): Handle_Prs3d_LineAspect;
  SetDrawFirstAndSecondAxis(theToDraw: Standard_Boolean): void;
  DrawFirstAndSecondAxis(): Standard_Boolean;
  SetDrawThirdAxis(theToDraw: Standard_Boolean): void;
  DrawThirdAxis(): Standard_Boolean;
  DrawDatumPart(thePart: Prs3d_DatumParts): Standard_Boolean;
  SetDrawDatumAxes(theType: Prs3d_DatumAxes): void;
  DatumAxes(): Prs3d_DatumAxes;
  SetAttribute(theType: Prs3d_DatumAttribute, theValue: Quantity_AbsorbedDose): void;
  Attribute(theType: Prs3d_DatumAttribute): Quantity_AbsorbedDose;
  SetAxisLength(theL1: Quantity_AbsorbedDose, theL2: Quantity_AbsorbedDose, theL3: Quantity_AbsorbedDose): void;
  AxisLength(thePart: Prs3d_DatumParts): Quantity_AbsorbedDose;
  FirstAxisLength(): Quantity_AbsorbedDose;
  SecondAxisLength(): Quantity_AbsorbedDose;
  ThirdAxisLength(): Quantity_AbsorbedDose;
  ToDrawLabels(): Standard_Boolean;
  SetDrawLabels(theToDraw: Standard_Boolean): void;
  SetToDrawLabels(theToDraw: Standard_Boolean): void;
  ToDrawArrows(): Standard_Boolean;
  SetDrawArrows(theToDraw: Standard_Boolean): void;
  ArrowPartForAxis(thePart: Prs3d_DatumParts): Prs3d_DatumParts;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Prs3d_DatumAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_DatumAspect): void;
  get(): Prs3d_DatumAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_DatumAspect_1 extends Handle_Prs3d_DatumAspect {
    constructor();
  }

  export declare class Handle_Prs3d_DatumAspect_2 extends Handle_Prs3d_DatumAspect {
    constructor(thePtr: Prs3d_DatumAspect);
  }

  export declare class Handle_Prs3d_DatumAspect_3 extends Handle_Prs3d_DatumAspect {
    constructor(theHandle: Handle_Prs3d_DatumAspect);
  }

  export declare class Handle_Prs3d_DatumAspect_4 extends Handle_Prs3d_DatumAspect {
    constructor(theHandle: Handle_Prs3d_DatumAspect);
  }

export declare class Prs3d {
  constructor();
  static MatchSegment(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose, aDistance: Quantity_AbsorbedDose, p1: gp_Pnt, p2: gp_Pnt, dist: Quantity_AbsorbedDose): Standard_Boolean;
  static GetDeflection_1(theBndMin: OpenGl_Vec3d, theBndMax: OpenGl_Vec3d, theDeviationCoefficient: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static GetDeflection_2(theBndBox: Bnd_Box, theDeviationCoefficient: Quantity_AbsorbedDose, theMaximalChordialDeviation: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static PrimitivesFromPolylines(thePoints: Prs3d_NListOfSequenceOfPnt): Handle_Graphic3d_ArrayOfPrimitives;
  static AddPrimitivesGroup(thePrs: any, theAspect: Handle_Prs3d_LineAspect, thePolylines: Prs3d_NListOfSequenceOfPnt): void;
  static AddFreeEdges(theSegments: TColgp_SequenceOfPnt, thePolyTri: Handle_Poly_Triangulation, theLocation: gp_Trsf): void;
  delete(): void;
}

export declare type Prs3d_DatumAttribute = {
  Prs3d_DA_XAxisLength: {};
  Prs3d_DA_YAxisLength: {};
  Prs3d_DA_ZAxisLength: {};
  Prs3d_DP_ShadingTubeRadiusPercent: {};
  Prs3d_DP_ShadingConeRadiusPercent: {};
  Prs3d_DP_ShadingConeLengthPercent: {};
  Prs3d_DP_ShadingOriginRadiusPercent: {};
  Prs3d_DP_ShadingNumberOfFacettes: {};
}

export declare type Prs3d_TypeOfLinePicking = {
  Prs3d_TOLP_Point: {};
  Prs3d_TOLP_Segment: {};
}

export declare type Prs3d_DatumMode = {
  Prs3d_DM_WireFrame: {};
  Prs3d_DM_Shaded: {};
}

export declare type Prs3d_DimensionTextVerticalPosition = {
  Prs3d_DTVP_Above: {};
  Prs3d_DTVP_Below: {};
  Prs3d_DTVP_Center: {};
}

export declare class Prs3d_DimensionAspect extends Prs3d_BasicAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  LineAspect(): Handle_Prs3d_LineAspect;
  SetLineAspect(theAspect: Handle_Prs3d_LineAspect): void;
  TextAspect(): Handle_Prs3d_TextAspect;
  SetTextAspect(theAspect: Handle_Prs3d_TextAspect): void;
  IsText3d(): Standard_Boolean;
  MakeText3d(isText3d: Standard_Boolean): void;
  IsTextShaded(): Standard_Boolean;
  MakeTextShaded(theIsTextShaded: Standard_Boolean): void;
  IsArrows3d(): Standard_Boolean;
  MakeArrows3d(theIsArrows3d: Standard_Boolean): void;
  IsUnitsDisplayed(): Standard_Boolean;
  MakeUnitsDisplayed(theIsDisplayed: Standard_Boolean): void;
  SetArrowOrientation(theArrowOrient: Prs3d_DimensionArrowOrientation): void;
  ArrowOrientation(): Prs3d_DimensionArrowOrientation;
  SetTextVerticalPosition(thePosition: Prs3d_DimensionTextVerticalPosition): void;
  TextVerticalPosition(): Prs3d_DimensionTextVerticalPosition;
  SetTextHorizontalPosition(thePosition: Prs3d_DimensionTextHorizontalPosition): void;
  TextHorizontalPosition(): Prs3d_DimensionTextHorizontalPosition;
  ArrowAspect(): Handle_Prs3d_ArrowAspect;
  SetArrowAspect(theAspect: Handle_Prs3d_ArrowAspect): void;
  SetCommonColor(theColor: Quantity_Color): void;
  SetExtensionSize(theSize: Quantity_AbsorbedDose): void;
  ExtensionSize(): Quantity_AbsorbedDose;
  SetArrowTailSize(theSize: Quantity_AbsorbedDose): void;
  ArrowTailSize(): Quantity_AbsorbedDose;
  SetValueStringFormat(theFormat: XCAFDoc_PartId): void;
  ValueStringFormat(): XCAFDoc_PartId;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class Handle_Prs3d_DimensionAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_DimensionAspect): void;
  get(): Prs3d_DimensionAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_DimensionAspect_1 extends Handle_Prs3d_DimensionAspect {
    constructor();
  }

  export declare class Handle_Prs3d_DimensionAspect_2 extends Handle_Prs3d_DimensionAspect {
    constructor(thePtr: Prs3d_DimensionAspect);
  }

  export declare class Handle_Prs3d_DimensionAspect_3 extends Handle_Prs3d_DimensionAspect {
    constructor(theHandle: Handle_Prs3d_DimensionAspect);
  }

  export declare class Handle_Prs3d_DimensionAspect_4 extends Handle_Prs3d_DimensionAspect {
    constructor(theHandle: Handle_Prs3d_DimensionAspect);
  }

export declare class Handle_Prs3d_ArrowAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_ArrowAspect): void;
  get(): Prs3d_ArrowAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_ArrowAspect_1 extends Handle_Prs3d_ArrowAspect {
    constructor();
  }

  export declare class Handle_Prs3d_ArrowAspect_2 extends Handle_Prs3d_ArrowAspect {
    constructor(thePtr: Prs3d_ArrowAspect);
  }

  export declare class Handle_Prs3d_ArrowAspect_3 extends Handle_Prs3d_ArrowAspect {
    constructor(theHandle: Handle_Prs3d_ArrowAspect);
  }

  export declare class Handle_Prs3d_ArrowAspect_4 extends Handle_Prs3d_ArrowAspect {
    constructor(theHandle: Handle_Prs3d_ArrowAspect);
  }

export declare class Prs3d_ArrowAspect extends Prs3d_BasicAspect {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetAngle(anAngle: Quantity_AbsorbedDose): void;
  Angle(): Quantity_AbsorbedDose;
  SetLength(theLength: Quantity_AbsorbedDose): void;
  Length(): Quantity_AbsorbedDose;
  SetColor(theColor: Quantity_Color): void;
  Aspect(): Handle_Graphic3d_AspectLine3d;
  SetAspect(theAspect: Handle_Graphic3d_AspectLine3d): void;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Prs3d_ArrowAspect_1 extends Prs3d_ArrowAspect {
    constructor();
  }

  export declare class Prs3d_ArrowAspect_2 extends Prs3d_ArrowAspect {
    constructor(anAngle: Quantity_AbsorbedDose, aLength: Quantity_AbsorbedDose);
  }

  export declare class Prs3d_ArrowAspect_3 extends Prs3d_ArrowAspect {
    constructor(theAspect: Handle_Graphic3d_AspectLine3d);
  }

export declare class Prs3d_InvalidAngle extends Standard_RangeError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Prs3d_InvalidAngle;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Prs3d_InvalidAngle_1 extends Prs3d_InvalidAngle {
    constructor();
  }

  export declare class Prs3d_InvalidAngle_2 extends Prs3d_InvalidAngle {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Prs3d_InvalidAngle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_InvalidAngle): void;
  get(): Prs3d_InvalidAngle;
  delete(): void;
}

  export declare class Handle_Prs3d_InvalidAngle_1 extends Handle_Prs3d_InvalidAngle {
    constructor();
  }

  export declare class Handle_Prs3d_InvalidAngle_2 extends Handle_Prs3d_InvalidAngle {
    constructor(thePtr: Prs3d_InvalidAngle);
  }

  export declare class Handle_Prs3d_InvalidAngle_3 extends Handle_Prs3d_InvalidAngle {
    constructor(theHandle: Handle_Prs3d_InvalidAngle);
  }

  export declare class Handle_Prs3d_InvalidAngle_4 extends Handle_Prs3d_InvalidAngle {
    constructor(theHandle: Handle_Prs3d_InvalidAngle);
  }

export declare class Prs3d_ToolCylinder extends Prs3d_ToolQuadric {
  constructor(theBottomRad: Quantity_AbsorbedDose, theTopRad: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId)
  static Create(theBottomRad: Quantity_AbsorbedDose, theTopRad: Quantity_AbsorbedDose, theHeight: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  delete(): void;
}

export declare class Prs3d_Root {
  constructor();
  static CurrentGroup(thePrs3d: any): Handle_Graphic3d_Group;
  static NewGroup(thePrs3d: any): Handle_Graphic3d_Group;
  delete(): void;
}

export declare class Prs3d_ToolSphere extends Prs3d_ToolQuadric {
  constructor(theRadius: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId)
  static Create(theRadius: Quantity_AbsorbedDose, theNbSlices: Graphic3d_ZLayerId, theNbStacks: Graphic3d_ZLayerId, theTrsf: gp_Trsf): Handle_Graphic3d_ArrayOfTriangles;
  delete(): void;
}

export declare type Prs3d_DimensionTextHorizontalPosition = {
  Prs3d_DTHP_Left: {};
  Prs3d_DTHP_Right: {};
  Prs3d_DTHP_Center: {};
  Prs3d_DTHP_Fit: {};
}

export declare class Handle_Prs3d_Drawer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_Drawer): void;
  get(): Prs3d_Drawer;
  delete(): void;
}

  export declare class Handle_Prs3d_Drawer_1 extends Handle_Prs3d_Drawer {
    constructor();
  }

  export declare class Handle_Prs3d_Drawer_2 extends Handle_Prs3d_Drawer {
    constructor(thePtr: Prs3d_Drawer);
  }

  export declare class Handle_Prs3d_Drawer_3 extends Handle_Prs3d_Drawer {
    constructor(theHandle: Handle_Prs3d_Drawer);
  }

  export declare class Handle_Prs3d_Drawer_4 extends Handle_Prs3d_Drawer {
    constructor(theHandle: Handle_Prs3d_Drawer);
  }

export declare class Prs3d_Drawer extends Graphic3d_PresentationAttributes {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetTypeOfDeflection(theTypeOfDeflection: Aspect_TypeOfDeflection): void;
  TypeOfDeflection(): Aspect_TypeOfDeflection;
  HasOwnTypeOfDeflection(): Standard_Boolean;
  SetMaximalChordialDeviation(theChordialDeviation: Quantity_AbsorbedDose): void;
  MaximalChordialDeviation(): Quantity_AbsorbedDose;
  HasOwnMaximalChordialDeviation(): Standard_Boolean;
  SetTypeOfHLR(theTypeOfHLR: Prs3d_TypeOfHLR): void;
  TypeOfHLR(): Prs3d_TypeOfHLR;
  HasOwnTypeOfHLR(): Standard_Boolean;
  SetMaximalParameterValue(theValue: Quantity_AbsorbedDose): void;
  MaximalParameterValue(): Quantity_AbsorbedDose;
  HasOwnMaximalParameterValue(): Standard_Boolean;
  SetIsoOnPlane(theIsEnabled: Standard_Boolean): void;
  IsoOnPlane(): Standard_Boolean;
  HasOwnIsoOnPlane(): Standard_Boolean;
  IsoOnTriangulation(): Standard_Boolean;
  HasOwnIsoOnTriangulation(): Standard_Boolean;
  SetIsoOnTriangulation(theToEnable: Standard_Boolean): void;
  SetDiscretisation(theValue: Graphic3d_ZLayerId): void;
  Discretisation(): Graphic3d_ZLayerId;
  HasOwnDiscretisation(): Standard_Boolean;
  SetDeviationCoefficient_1(theCoefficient: Quantity_AbsorbedDose): void;
  DeviationCoefficient(): Quantity_AbsorbedDose;
  SetDeviationCoefficient_2(): void;
  HasOwnDeviationCoefficient(): Standard_Boolean;
  PreviousDeviationCoefficient(): Quantity_AbsorbedDose;
  UpdatePreviousDeviationCoefficient(): void;
  SetDeviationAngle_1(theAngle: Quantity_AbsorbedDose): void;
  DeviationAngle(): Quantity_AbsorbedDose;
  SetDeviationAngle_2(): void;
  HasOwnDeviationAngle(): Standard_Boolean;
  PreviousDeviationAngle(): Quantity_AbsorbedDose;
  UpdatePreviousDeviationAngle(): void;
  SetAutoTriangulation(theIsEnabled: Standard_Boolean): void;
  IsAutoTriangulation(): Standard_Boolean;
  HasOwnIsAutoTriangulation(): Standard_Boolean;
  UIsoAspect(): Handle_Prs3d_IsoAspect;
  SetUIsoAspect(theAspect: Handle_Prs3d_IsoAspect): void;
  HasOwnUIsoAspect(): Standard_Boolean;
  VIsoAspect(): Handle_Prs3d_IsoAspect;
  SetVIsoAspect(theAspect: Handle_Prs3d_IsoAspect): void;
  HasOwnVIsoAspect(): Standard_Boolean;
  WireAspect(): Handle_Prs3d_LineAspect;
  SetWireAspect(theAspect: Handle_Prs3d_LineAspect): void;
  HasOwnWireAspect(): Standard_Boolean;
  SetWireDraw(theIsEnabled: Standard_Boolean): void;
  WireDraw(): Standard_Boolean;
  HasOwnWireDraw(): Standard_Boolean;
  PointAspect(): Handle_Prs3d_PointAspect;
  SetPointAspect(theAspect: Handle_Prs3d_PointAspect): void;
  HasOwnPointAspect(): Standard_Boolean;
  SetupOwnPointAspect(theDefaults: Handle_Prs3d_Drawer): Standard_Boolean;
  LineAspect(): Handle_Prs3d_LineAspect;
  SetLineAspect(theAspect: Handle_Prs3d_LineAspect): void;
  HasOwnLineAspect(): Standard_Boolean;
  SetOwnLineAspects(theDefaults: Handle_Prs3d_Drawer): Standard_Boolean;
  SetOwnDatumAspects(theDefaults: Handle_Prs3d_Drawer): Standard_Boolean;
  TextAspect(): Handle_Prs3d_TextAspect;
  SetTextAspect(theAspect: Handle_Prs3d_TextAspect): void;
  HasOwnTextAspect(): Standard_Boolean;
  ShadingAspect(): Handle_Prs3d_ShadingAspect;
  SetShadingAspect(theAspect: Handle_Prs3d_ShadingAspect): void;
  HasOwnShadingAspect(): Standard_Boolean;
  SetupOwnShadingAspect(theDefaults: Handle_Prs3d_Drawer): Standard_Boolean;
  SeenLineAspect(): Handle_Prs3d_LineAspect;
  SetSeenLineAspect(theAspect: Handle_Prs3d_LineAspect): void;
  HasOwnSeenLineAspect(): Standard_Boolean;
  PlaneAspect(): Handle_Prs3d_PlaneAspect;
  SetPlaneAspect(theAspect: Handle_Prs3d_PlaneAspect): void;
  HasOwnPlaneAspect(): Standard_Boolean;
  ArrowAspect(): Handle_Prs3d_ArrowAspect;
  SetArrowAspect(theAspect: Handle_Prs3d_ArrowAspect): void;
  HasOwnArrowAspect(): Standard_Boolean;
  SetLineArrowDraw(theIsEnabled: Standard_Boolean): void;
  LineArrowDraw(): Standard_Boolean;
  HasOwnLineArrowDraw(): Standard_Boolean;
  HiddenLineAspect(): Handle_Prs3d_LineAspect;
  SetHiddenLineAspect(theAspect: Handle_Prs3d_LineAspect): void;
  HasOwnHiddenLineAspect(): Standard_Boolean;
  DrawHiddenLine(): Standard_Boolean;
  EnableDrawHiddenLine(): void;
  DisableDrawHiddenLine(): void;
  HasOwnDrawHiddenLine(): Standard_Boolean;
  VectorAspect(): Handle_Prs3d_LineAspect;
  SetVectorAspect(theAspect: Handle_Prs3d_LineAspect): void;
  HasOwnVectorAspect(): Standard_Boolean;
  SetVertexDrawMode(theMode: Prs3d_VertexDrawMode): void;
  VertexDrawMode(): Prs3d_VertexDrawMode;
  HasOwnVertexDrawMode(): Standard_Boolean;
  DatumAspect(): Handle_Prs3d_DatumAspect;
  SetDatumAspect(theAspect: Handle_Prs3d_DatumAspect): void;
  HasOwnDatumAspect(): Standard_Boolean;
  SectionAspect(): Handle_Prs3d_LineAspect;
  SetSectionAspect(theAspect: Handle_Prs3d_LineAspect): void;
  HasOwnSectionAspect(): Standard_Boolean;
  SetFreeBoundaryAspect(theAspect: Handle_Prs3d_LineAspect): void;
  FreeBoundaryAspect(): Handle_Prs3d_LineAspect;
  HasOwnFreeBoundaryAspect(): Standard_Boolean;
  SetFreeBoundaryDraw(theIsEnabled: Standard_Boolean): void;
  FreeBoundaryDraw(): Standard_Boolean;
  HasOwnFreeBoundaryDraw(): Standard_Boolean;
  SetUnFreeBoundaryAspect(theAspect: Handle_Prs3d_LineAspect): void;
  UnFreeBoundaryAspect(): Handle_Prs3d_LineAspect;
  HasOwnUnFreeBoundaryAspect(): Standard_Boolean;
  SetUnFreeBoundaryDraw(theIsEnabled: Standard_Boolean): void;
  UnFreeBoundaryDraw(): Standard_Boolean;
  HasOwnUnFreeBoundaryDraw(): Standard_Boolean;
  SetFaceBoundaryAspect(theAspect: Handle_Prs3d_LineAspect): void;
  FaceBoundaryAspect(): Handle_Prs3d_LineAspect;
  HasOwnFaceBoundaryAspect(): Standard_Boolean;
  SetupOwnFaceBoundaryAspect(theDefaults: Handle_Prs3d_Drawer): Standard_Boolean;
  SetFaceBoundaryDraw(theIsEnabled: Standard_Boolean): void;
  FaceBoundaryDraw(): Standard_Boolean;
  HasOwnFaceBoundaryDraw(): Standard_Boolean;
  HasOwnFaceBoundaryUpperContinuity(): Standard_Boolean;
  FaceBoundaryUpperContinuity(): GeomAbs_Shape;
  SetFaceBoundaryUpperContinuity(theMostAllowedEdgeClass: GeomAbs_Shape): void;
  UnsetFaceBoundaryUpperContinuity(): void;
  DimensionAspect(): Handle_Prs3d_DimensionAspect;
  SetDimensionAspect(theAspect: Handle_Prs3d_DimensionAspect): void;
  HasOwnDimensionAspect(): Standard_Boolean;
  SetDimLengthModelUnits(theUnits: XCAFDoc_PartId): void;
  SetDimAngleModelUnits(theUnits: XCAFDoc_PartId): void;
  DimLengthModelUnits(): XCAFDoc_PartId;
  DimAngleModelUnits(): XCAFDoc_PartId;
  HasOwnDimLengthModelUnits(): Standard_Boolean;
  HasOwnDimAngleModelUnits(): Standard_Boolean;
  SetDimLengthDisplayUnits(theUnits: XCAFDoc_PartId): void;
  SetDimAngleDisplayUnits(theUnits: XCAFDoc_PartId): void;
  DimLengthDisplayUnits(): XCAFDoc_PartId;
  DimAngleDisplayUnits(): XCAFDoc_PartId;
  HasOwnDimLengthDisplayUnits(): Standard_Boolean;
  HasOwnDimAngleDisplayUnits(): Standard_Boolean;
  Link_1(): Handle_Prs3d_Drawer;
  HasLink(): Standard_Boolean;
  Link_2(theDrawer: Handle_Prs3d_Drawer): void;
  SetLink(theDrawer: Handle_Prs3d_Drawer): void;
  ClearLocalAttributes(): void;
  SetShaderProgram(theProgram: Handle_Graphic3d_ShaderProgram, theAspect: Graphic3d_GroupAspect, theToOverrideDefaults: Standard_Boolean): Standard_Boolean;
  SetShadingModel(theModel: V3d_TypeOfShadingModel, theToOverrideDefaults: Standard_Boolean): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  SetHLRAngle_1(theAngle: Quantity_AbsorbedDose): void;
  HLRAngle(): Quantity_AbsorbedDose;
  SetHLRAngle_2(): void;
  HasOwnHLRDeviationAngle(): Standard_Boolean;
  PreviousHLRDeviationAngle(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_Prs3d_PointAspect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Prs3d_PointAspect): void;
  get(): Prs3d_PointAspect;
  delete(): void;
}

  export declare class Handle_Prs3d_PointAspect_1 extends Handle_Prs3d_PointAspect {
    constructor();
  }

  export declare class Handle_Prs3d_PointAspect_2 extends Handle_Prs3d_PointAspect {
    constructor(thePtr: Prs3d_PointAspect);
  }

  export declare class Handle_Prs3d_PointAspect_3 extends Handle_Prs3d_PointAspect {
    constructor(theHandle: Handle_Prs3d_PointAspect);
  }

  export declare class Handle_Prs3d_PointAspect_4 extends Handle_Prs3d_PointAspect {
    constructor(theHandle: Handle_Prs3d_PointAspect);
  }

export declare class Prs3d_PointAspect extends Prs3d_BasicAspect {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  SetColor(theColor: Quantity_Color): void;
  SetTypeOfMarker(theType: Aspect_TypeOfMarker): void;
  SetScale(theScale: Quantity_AbsorbedDose): void;
  Aspect(): Handle_Graphic3d_AspectMarker3d;
  SetAspect(theAspect: Handle_Graphic3d_AspectMarker3d): void;
  GetTextureSize(theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId): void;
  GetTexture(): Handle_Graphic3d_MarkerImage;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class Prs3d_PointAspect_1 extends Prs3d_PointAspect {
    constructor(theType: Aspect_TypeOfMarker, theColor: Quantity_Color, theScale: Quantity_AbsorbedDose);
  }

  export declare class Prs3d_PointAspect_2 extends Prs3d_PointAspect {
    constructor(theColor: Quantity_Color, theWidth: Graphic3d_ZLayerId, theHeight: Graphic3d_ZLayerId, theTexture: Handle_TColStd_HArray1OfByte);
  }

  export declare class Prs3d_PointAspect_3 extends Prs3d_PointAspect {
    constructor(theAspect: Handle_Graphic3d_AspectMarker3d);
  }

export declare class HLRAppli_ReflectLines {
  constructor(aShape: TopoDS_Shape)
  SetAxes(Nx: Quantity_AbsorbedDose, Ny: Quantity_AbsorbedDose, Nz: Quantity_AbsorbedDose, XAt: Quantity_AbsorbedDose, YAt: Quantity_AbsorbedDose, ZAt: Quantity_AbsorbedDose, XUp: Quantity_AbsorbedDose, YUp: Quantity_AbsorbedDose, ZUp: Quantity_AbsorbedDose): void;
  Perform(): void;
  GetResult(): TopoDS_Shape;
  GetCompoundOf3dEdges(type: HLRBRep_TypeOfResultingEdge, visible: Standard_Boolean, In3d: Standard_Boolean): TopoDS_Shape;
  delete(): void;
}

export declare class BRepOffsetAPI_MakeEvolved extends BRepBuilderAPI_MakeShape {
  Evolved(): BRepFill_Evolved;
  Build(): void;
  GeneratedShapes(SpineShape: TopoDS_Shape, ProfShape: TopoDS_Shape): TopTools_ListOfShape;
  Top(): TopoDS_Shape;
  Bottom(): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepOffsetAPI_MakeEvolved_1 extends BRepOffsetAPI_MakeEvolved {
    constructor();
  }

  export declare class BRepOffsetAPI_MakeEvolved_2 extends BRepOffsetAPI_MakeEvolved {
    constructor(theSpine: TopoDS_Shape, theProfile: TopoDS_Wire, theJoinType: GeomAbs_JoinType, theIsAxeProf: Standard_Boolean, theIsSolid: Standard_Boolean, theIsProfOnSpine: Standard_Boolean, theTol: Quantity_AbsorbedDose, theIsVolume: Standard_Boolean, theRunInParallel: Standard_Boolean);
  }

export declare class BRepOffsetAPI_MiddlePath extends BRepBuilderAPI_MakeShape {
  constructor(aShape: TopoDS_Shape, StartShape: TopoDS_Shape, EndShape: TopoDS_Shape)
  Build(): void;
  delete(): void;
}

export declare class BRepOffsetAPI_ThruSections extends BRepBuilderAPI_MakeShape {
  constructor(isSolid: Standard_Boolean, ruled: Standard_Boolean, pres3d: Quantity_AbsorbedDose)
  Init(isSolid: Standard_Boolean, ruled: Standard_Boolean, pres3d: Quantity_AbsorbedDose): void;
  AddWire(wire: TopoDS_Wire): void;
  AddVertex(aVertex: TopoDS_Vertex): void;
  CheckCompatibility(check: Standard_Boolean): void;
  SetSmoothing(UseSmoothing: Standard_Boolean): void;
  SetParType(ParType: Approx_ParametrizationType): void;
  SetContinuity(C: GeomAbs_Shape): void;
  SetCriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  SetMaxDegree(MaxDeg: Graphic3d_ZLayerId): void;
  ParType(): Approx_ParametrizationType;
  Continuity(): GeomAbs_Shape;
  MaxDegree(): Graphic3d_ZLayerId;
  UseSmoothing(): Standard_Boolean;
  CriteriumWeight(W1: Quantity_AbsorbedDose, W2: Quantity_AbsorbedDose, W3: Quantity_AbsorbedDose): void;
  Build(): void;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  GeneratedFace(Edge: TopoDS_Shape): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  Wires(): TopTools_ListOfShape;
  delete(): void;
}

export declare class BRepOffsetAPI_SequenceOfSequenceOfShape extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepOffsetAPI_SequenceOfSequenceOfShape): BRepOffsetAPI_SequenceOfSequenceOfShape;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TopTools_SequenceOfShape): void;
  Append_2(theSeq: BRepOffsetAPI_SequenceOfSequenceOfShape): void;
  Prepend_1(theItem: TopTools_SequenceOfShape): void;
  Prepend_2(theSeq: BRepOffsetAPI_SequenceOfSequenceOfShape): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TopTools_SequenceOfShape): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepOffsetAPI_SequenceOfSequenceOfShape): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepOffsetAPI_SequenceOfSequenceOfShape): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TopTools_SequenceOfShape): void;
  Split(theIndex: Standard_Integer, theSeq: BRepOffsetAPI_SequenceOfSequenceOfShape): void;
  First(): TopTools_SequenceOfShape;
  ChangeFirst(): TopTools_SequenceOfShape;
  Last(): TopTools_SequenceOfShape;
  ChangeLast(): TopTools_SequenceOfShape;
  Value(theIndex: Standard_Integer): TopTools_SequenceOfShape;
  ChangeValue(theIndex: Standard_Integer): TopTools_SequenceOfShape;
  SetValue(theIndex: Standard_Integer, theItem: TopTools_SequenceOfShape): void;
  delete(): void;
}

  export declare class BRepOffsetAPI_SequenceOfSequenceOfShape_1 extends BRepOffsetAPI_SequenceOfSequenceOfShape {
    constructor();
  }

  export declare class BRepOffsetAPI_SequenceOfSequenceOfShape_2 extends BRepOffsetAPI_SequenceOfSequenceOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepOffsetAPI_SequenceOfSequenceOfShape_3 extends BRepOffsetAPI_SequenceOfSequenceOfShape {
    constructor(theOther: BRepOffsetAPI_SequenceOfSequenceOfShape);
  }

export declare class BRepOffsetAPI_MakeThickSolid extends BRepOffsetAPI_MakeOffsetShape {
  MakeThickSolidBySimple(theS: TopoDS_Shape, theOffsetValue: Quantity_AbsorbedDose): void;
  MakeThickSolidByJoin(S: TopoDS_Shape, ClosingFaces: TopTools_ListOfShape, Offset: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Mode: BRepOffset_Mode, Intersection: Standard_Boolean, SelfInter: Standard_Boolean, Join: GeomAbs_JoinType, RemoveIntEdges: Standard_Boolean): void;
  Build(): void;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepOffsetAPI_MakeThickSolid_1 extends BRepOffsetAPI_MakeThickSolid {
    constructor();
  }

  export declare class BRepOffsetAPI_MakeThickSolid_2 extends BRepOffsetAPI_MakeThickSolid {
    constructor(S: TopoDS_Shape, ClosingFaces: TopTools_ListOfShape, Offset: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Mode: BRepOffset_Mode, Intersection: Standard_Boolean, SelfInter: Standard_Boolean, Join: GeomAbs_JoinType, RemoveIntEdges: Standard_Boolean);
  }

export declare class BRepOffsetAPI_SequenceOfSequenceOfReal extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: BRepOffsetAPI_SequenceOfSequenceOfReal): BRepOffsetAPI_SequenceOfSequenceOfReal;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: TColStd_SequenceOfReal): void;
  Append_2(theSeq: BRepOffsetAPI_SequenceOfSequenceOfReal): void;
  Prepend_1(theItem: TColStd_SequenceOfReal): void;
  Prepend_2(theSeq: BRepOffsetAPI_SequenceOfSequenceOfReal): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: TColStd_SequenceOfReal): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: BRepOffsetAPI_SequenceOfSequenceOfReal): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: BRepOffsetAPI_SequenceOfSequenceOfReal): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: TColStd_SequenceOfReal): void;
  Split(theIndex: Standard_Integer, theSeq: BRepOffsetAPI_SequenceOfSequenceOfReal): void;
  First(): TColStd_SequenceOfReal;
  ChangeFirst(): TColStd_SequenceOfReal;
  Last(): TColStd_SequenceOfReal;
  ChangeLast(): TColStd_SequenceOfReal;
  Value(theIndex: Standard_Integer): TColStd_SequenceOfReal;
  ChangeValue(theIndex: Standard_Integer): TColStd_SequenceOfReal;
  SetValue(theIndex: Standard_Integer, theItem: TColStd_SequenceOfReal): void;
  delete(): void;
}

  export declare class BRepOffsetAPI_SequenceOfSequenceOfReal_1 extends BRepOffsetAPI_SequenceOfSequenceOfReal {
    constructor();
  }

  export declare class BRepOffsetAPI_SequenceOfSequenceOfReal_2 extends BRepOffsetAPI_SequenceOfSequenceOfReal {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BRepOffsetAPI_SequenceOfSequenceOfReal_3 extends BRepOffsetAPI_SequenceOfSequenceOfReal {
    constructor(theOther: BRepOffsetAPI_SequenceOfSequenceOfReal);
  }

export declare class BRepOffsetAPI_MakeDraft extends BRepBuilderAPI_MakeShape {
  constructor(Shape: TopoDS_Shape, Dir: gp_Dir, Angle: Quantity_AbsorbedDose)
  SetOptions(Style: BRepBuilderAPI_TransitionMode, AngleMin: Quantity_AbsorbedDose, AngleMax: Quantity_AbsorbedDose): void;
  SetDraft(IsInternal: Standard_Boolean): void;
  Perform_1(LengthMax: Quantity_AbsorbedDose): void;
  Perform_2(Surface: Handle_Geom_Surface, KeepInsideSurface: Standard_Boolean): void;
  Perform_3(StopShape: TopoDS_Shape, KeepOutSide: Standard_Boolean): void;
  Shell(): TopoDS_Shell;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

export declare class BRepOffsetAPI_MakeFilling extends BRepBuilderAPI_MakeShape {
  constructor(Degree: Graphic3d_ZLayerId, NbPtsOnCur: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Anisotropie: Standard_Boolean, Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose, MaxDeg: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId)
  SetConstrParam(Tol2d: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, TolAng: Quantity_AbsorbedDose, TolCurv: Quantity_AbsorbedDose): void;
  SetResolParam(Degree: Graphic3d_ZLayerId, NbPtsOnCur: Graphic3d_ZLayerId, NbIter: Graphic3d_ZLayerId, Anisotropie: Standard_Boolean): void;
  SetApproxParam(MaxDeg: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId): void;
  LoadInitSurface(Surf: TopoDS_Face): void;
  Add_1(Constr: TopoDS_Edge, Order: GeomAbs_Shape, IsBound: Standard_Boolean): Graphic3d_ZLayerId;
  Add_2(Constr: TopoDS_Edge, Support: TopoDS_Face, Order: GeomAbs_Shape, IsBound: Standard_Boolean): Graphic3d_ZLayerId;
  Add_3(Support: TopoDS_Face, Order: GeomAbs_Shape): Graphic3d_ZLayerId;
  Add_4(Point: gp_Pnt): Graphic3d_ZLayerId;
  Add_5(U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, Support: TopoDS_Face, Order: GeomAbs_Shape): Graphic3d_ZLayerId;
  Build(): void;
  IsDone(): Standard_Boolean;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  G0Error_1(): Quantity_AbsorbedDose;
  G1Error_1(): Quantity_AbsorbedDose;
  G2Error_1(): Quantity_AbsorbedDose;
  G0Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  G1Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  G2Error_2(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class BRepOffsetAPI_DraftAngle extends BRepBuilderAPI_ModifyShape {
  Clear(): void;
  Init(S: TopoDS_Shape): void;
  Add(F: TopoDS_Face, Direction: gp_Dir, Angle: Quantity_AbsorbedDose, NeutralPlane: gp_Pln, Flag: Standard_Boolean): void;
  AddDone(): Standard_Boolean;
  Remove(F: TopoDS_Face): void;
  ProblematicShape(): TopoDS_Shape;
  Status(): Draft_ErrorStatus;
  ConnectedFaces(F: TopoDS_Face): TopTools_ListOfShape;
  ModifiedFaces(): TopTools_ListOfShape;
  Build(): void;
  CorrectWires(): void;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  ModifiedShape(S: TopoDS_Shape): TopoDS_Shape;
  delete(): void;
}

  export declare class BRepOffsetAPI_DraftAngle_1 extends BRepOffsetAPI_DraftAngle {
    constructor();
  }

  export declare class BRepOffsetAPI_DraftAngle_2 extends BRepOffsetAPI_DraftAngle {
    constructor(S: TopoDS_Shape);
  }

export declare class BRepOffsetAPI_NormalProjection extends BRepBuilderAPI_MakeShape {
  Init(S: TopoDS_Shape): void;
  Add(ToProj: TopoDS_Shape): void;
  SetParams(Tol3D: Quantity_AbsorbedDose, Tol2D: Quantity_AbsorbedDose, InternalContinuity: GeomAbs_Shape, MaxDegree: Graphic3d_ZLayerId, MaxSeg: Graphic3d_ZLayerId): void;
  SetMaxDistance(MaxDist: Quantity_AbsorbedDose): void;
  SetLimit(FaceBoundaries: Standard_Boolean): void;
  Compute3d(With3d: Standard_Boolean): void;
  Build(): void;
  IsDone(): Standard_Boolean;
  Projection(): TopoDS_Shape;
  Couple(E: TopoDS_Edge): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  Ancestor(E: TopoDS_Edge): TopoDS_Shape;
  BuildWire(Liste: TopTools_ListOfShape): Standard_Boolean;
  delete(): void;
}

  export declare class BRepOffsetAPI_NormalProjection_1 extends BRepOffsetAPI_NormalProjection {
    constructor();
  }

  export declare class BRepOffsetAPI_NormalProjection_2 extends BRepOffsetAPI_NormalProjection {
    constructor(S: TopoDS_Shape);
  }

export declare class BRepOffsetAPI_MakePipe extends BRepPrimAPI_MakeSweep {
  Pipe(): BRepFill_Pipe;
  Build(): void;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Generated_1(S: TopoDS_Shape): TopTools_ListOfShape;
  Generated_2(SSpine: TopoDS_Shape, SProfile: TopoDS_Shape): TopoDS_Shape;
  ErrorOnSurface(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class BRepOffsetAPI_MakePipe_1 extends BRepOffsetAPI_MakePipe {
    constructor(Spine: TopoDS_Wire, Profile: TopoDS_Shape);
  }

  export declare class BRepOffsetAPI_MakePipe_2 extends BRepOffsetAPI_MakePipe {
    constructor(Spine: TopoDS_Wire, Profile: TopoDS_Shape, aMode: GeomFill_Trihedron, ForceApproxC1: Standard_Boolean);
  }

export declare class BRepOffsetAPI_MakeOffset extends BRepBuilderAPI_MakeShape {
  Init_1(Spine: TopoDS_Face, Join: GeomAbs_JoinType, IsOpenResult: Standard_Boolean): void;
  Init_2(Join: GeomAbs_JoinType, IsOpenResult: Standard_Boolean): void;
  AddWire(Spine: TopoDS_Wire): void;
  Perform(Offset: Quantity_AbsorbedDose, Alt: Quantity_AbsorbedDose): void;
  Build(): void;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BRepOffsetAPI_MakeOffset_1 extends BRepOffsetAPI_MakeOffset {
    constructor();
  }

  export declare class BRepOffsetAPI_MakeOffset_2 extends BRepOffsetAPI_MakeOffset {
    constructor(Spine: TopoDS_Face, Join: GeomAbs_JoinType, IsOpenResult: Standard_Boolean);
  }

  export declare class BRepOffsetAPI_MakeOffset_3 extends BRepOffsetAPI_MakeOffset {
    constructor(Spine: TopoDS_Wire, Join: GeomAbs_JoinType, IsOpenResult: Standard_Boolean);
  }

export declare class BRepOffsetAPI_MakePipeShell extends BRepPrimAPI_MakeSweep {
  constructor(Spine: TopoDS_Wire)
  SetMode_1(IsFrenet: Standard_Boolean): void;
  SetDiscreteMode(): void;
  SetMode_2(Axe: gp_Ax2): void;
  SetMode_3(BiNormal: gp_Dir): void;
  SetMode_4(SpineSupport: TopoDS_Shape): Standard_Boolean;
  SetMode_5(AuxiliarySpine: TopoDS_Wire, CurvilinearEquivalence: Standard_Boolean, KeepContact: BRepFill_TypeOfContact): void;
  Add_1(Profile: TopoDS_Shape, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  Add_2(Profile: TopoDS_Shape, Location: TopoDS_Vertex, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  SetLaw_1(Profile: TopoDS_Shape, L: Handle_Law_Function, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  SetLaw_2(Profile: TopoDS_Shape, L: Handle_Law_Function, Location: TopoDS_Vertex, WithContact: Standard_Boolean, WithCorrection: Standard_Boolean): void;
  Delete(Profile: TopoDS_Shape): void;
  IsReady(): Standard_Boolean;
  GetStatus(): BRepBuilderAPI_PipeError;
  SetTolerance(Tol3d: Quantity_AbsorbedDose, BoundTol: Quantity_AbsorbedDose, TolAngular: Quantity_AbsorbedDose): void;
  SetMaxDegree(NewMaxDegree: Graphic3d_ZLayerId): void;
  SetMaxSegments(NewMaxSegments: Graphic3d_ZLayerId): void;
  SetForceApproxC1(ForceApproxC1: Standard_Boolean): void;
  SetTransitionMode(Mode: BRepBuilderAPI_TransitionMode): void;
  Simulate(NumberOfSection: Graphic3d_ZLayerId, Result: TopTools_ListOfShape): void;
  Build(): void;
  MakeSolid(): Standard_Boolean;
  FirstShape(): TopoDS_Shape;
  LastShape(): TopoDS_Shape;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  ErrorOnSurface(): Quantity_AbsorbedDose;
  Profiles(theProfiles: TopTools_ListOfShape): void;
  Spine(): TopoDS_Wire;
  delete(): void;
}

export declare class BRepOffsetAPI_MakeOffsetShape extends BRepBuilderAPI_MakeShape {
  PerformBySimple(theS: TopoDS_Shape, theOffsetValue: Quantity_AbsorbedDose): void;
  PerformByJoin(S: TopoDS_Shape, Offset: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Mode: BRepOffset_Mode, Intersection: Standard_Boolean, SelfInter: Standard_Boolean, Join: GeomAbs_JoinType, RemoveIntEdges: Standard_Boolean): void;
  MakeOffset(): BRepOffset_MakeOffset;
  Build(): void;
  Generated(S: TopoDS_Shape): TopTools_ListOfShape;
  Modified(S: TopoDS_Shape): TopTools_ListOfShape;
  IsDeleted(S: TopoDS_Shape): Standard_Boolean;
  GetJoinType(): GeomAbs_JoinType;
  delete(): void;
}

  export declare class BRepOffsetAPI_MakeOffsetShape_1 extends BRepOffsetAPI_MakeOffsetShape {
    constructor();
  }

  export declare class BRepOffsetAPI_MakeOffsetShape_2 extends BRepOffsetAPI_MakeOffsetShape {
    constructor(S: TopoDS_Shape, Offset: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose, Mode: BRepOffset_Mode, Intersection: Standard_Boolean, SelfInter: Standard_Boolean, Join: GeomAbs_JoinType, RemoveIntEdges: Standard_Boolean);
  }

export declare type RWGltf_GltfAccessorCompType = {
  RWGltf_GltfAccessorCompType_UNKNOWN: {};
  RWGltf_GltfAccessorCompType_Int8: {};
  RWGltf_GltfAccessorCompType_UInt8: {};
  RWGltf_GltfAccessorCompType_Int16: {};
  RWGltf_GltfAccessorCompType_UInt16: {};
  RWGltf_GltfAccessorCompType_UInt32: {};
  RWGltf_GltfAccessorCompType_Float32: {};
}

export declare class RWGltf_GltfSceneNodeMap {
  constructor()
  FindIndex(theNodeId: XCAFDoc_PartId): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class RWGltf_GltfMaterialMap extends RWMesh_MaterialMap {
  constructor(theFile: XCAFDoc_PartId, theDefSamplerId: Graphic3d_ZLayerId)
  AddImages(theWriter: RWGltf_GltfOStreamWriter, theStyle: XCAFPrs_Style, theIsStarted: Standard_Boolean): void;
  AddMaterial_1(theWriter: RWGltf_GltfOStreamWriter, theStyle: XCAFPrs_Style, theIsStarted: Standard_Boolean): void;
  AddTextures(theWriter: RWGltf_GltfOStreamWriter, theStyle: XCAFPrs_Style, theIsStarted: Standard_Boolean): void;
  NbImages(): Graphic3d_ZLayerId;
  NbTextures(): Graphic3d_ZLayerId;
  static baseColorTexture(theMat: Handle_XCAFDoc_VisMaterial): any;
  delete(): void;
}

export declare type RWGltf_GltfPrimitiveMode = {
  RWGltf_GltfPrimitiveMode_UNKNOWN: {};
  RWGltf_GltfPrimitiveMode_Points: {};
  RWGltf_GltfPrimitiveMode_Lines: {};
  RWGltf_GltfPrimitiveMode_LineLoop: {};
  RWGltf_GltfPrimitiveMode_LineStrip: {};
  RWGltf_GltfPrimitiveMode_Triangles: {};
  RWGltf_GltfPrimitiveMode_TriangleStrip: {};
  RWGltf_GltfPrimitiveMode_TriangleFan: {};
}

export declare class RWGltf_GltfAccessor {
  constructor()
  delete(): void;
}

export declare class RWGltf_CafWriter extends Standard_Transient {
  constructor(theFile: XCAFDoc_PartId, theIsBinary: Standard_Boolean)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  CoordinateSystemConverter(): RWMesh_CoordinateSystemConverter;
  ChangeCoordinateSystemConverter(): RWMesh_CoordinateSystemConverter;
  SetCoordinateSystemConverter(theConverter: RWMesh_CoordinateSystemConverter): void;
  IsBinary(): Standard_Boolean;
  TransformationFormat(): RWGltf_WriterTrsfFormat;
  SetTransformationFormat(theFormat: RWGltf_WriterTrsfFormat): void;
  IsForcedUVExport(): Standard_Boolean;
  SetForcedUVExport(theToForce: Standard_Boolean): void;
  DefaultStyle(): XCAFPrs_Style;
  SetDefaultStyle(theStyle: XCAFPrs_Style): void;
  Perform_1(theDocument: Handle_TDocStd_Document, theRootLabels: TDF_LabelSequence, theLabelFilter: TColStd_MapOfAsciiString, theFileInfo: TColStd_IndexedDataMapOfStringString, theProgress: Message_ProgressRange): Standard_Boolean;
  Perform_2(theDocument: Handle_TDocStd_Document, theFileInfo: TColStd_IndexedDataMapOfStringString, theProgress: Message_ProgressRange): Standard_Boolean;
  delete(): void;
}

export declare type RWGltf_GltfBufferViewTarget = {
  RWGltf_GltfBufferViewTarget_UNKNOWN: {};
  RWGltf_GltfBufferViewTarget_ARRAY_BUFFER: {};
  RWGltf_GltfBufferViewTarget_ELEMENT_ARRAY_BUFFER: {};
}

export declare type RWGltf_WriterTrsfFormat = {
  RWGltf_WriterTrsfFormat_Compact: {};
  RWGltf_WriterTrsfFormat_Mat4: {};
  RWGltf_WriterTrsfFormat_TRS: {};
}

export declare class RWGltf_CafReader extends RWMesh_CafReader {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ToParallel(): Standard_Boolean;
  SetParallel(theToParallel: Standard_Boolean): void;
  ToSkipEmptyNodes(): Standard_Boolean;
  SetSkipEmptyNodes(theToSkip: Standard_Boolean): void;
  ToUseMeshNameAsFallback(): Standard_Boolean;
  SetMeshNameAsFallback(theToFallback: Standard_Boolean): void;
  delete(): void;
}

export declare class RWGltf_GltfSharedIStream {
  constructor();
  delete(): void;
}

export declare class RWGltf_PrimitiveArrayReader extends Standard_Transient {
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  ErrorPrefix(): XCAFDoc_PartId;
  SetErrorPrefix(theErrPrefix: XCAFDoc_PartId): void;
  CoordinateSystemConverter(): RWMesh_CoordinateSystemConverter;
  SetCoordinateSystemConverter(theConverter: RWMesh_CoordinateSystemConverter): void;
  Load(theMesh: any): Handle_Poly_Triangulation;
  delete(): void;
}

export declare class RWGltf_MaterialCommon extends Standard_Transient {
  constructor()
  delete(): void;
}

export declare class RWGltf_MaterialMetallicRoughness extends Standard_Transient {
  constructor()
  delete(): void;
}

export declare class RWGltf_TriangulationReader extends RWGltf_PrimitiveArrayReader {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type RWGltf_GltfArrayType = {
  RWGltf_GltfArrayType_UNKNOWN: {};
  RWGltf_GltfArrayType_Indices: {};
  RWGltf_GltfArrayType_Position: {};
  RWGltf_GltfArrayType_Normal: {};
  RWGltf_GltfArrayType_Color: {};
  RWGltf_GltfArrayType_TCoord0: {};
  RWGltf_GltfArrayType_TCoord1: {};
  RWGltf_GltfArrayType_Joint: {};
  RWGltf_GltfArrayType_Weight: {};
}

export declare class RWGltf_GltfPrimArrayData {
  delete(): void;
}

  export declare class RWGltf_GltfPrimArrayData_1 extends RWGltf_GltfPrimArrayData {
    constructor();
  }

  export declare class RWGltf_GltfPrimArrayData_2 extends RWGltf_GltfPrimArrayData {
    constructor(theType: RWGltf_GltfArrayType);
  }

export declare class RWGltf_GltfFace {
  constructor();
  delete(): void;
}

export declare class RWGltf_GltfLatePrimitiveArray extends Poly_Triangulation {
  constructor(theId: XCAFDoc_PartId, theName: XCAFDoc_PartId)
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  Id(): XCAFDoc_PartId;
  Name(): XCAFDoc_PartId;
  SetName(theName: XCAFDoc_PartId): void;
  PrimitiveMode(): RWGltf_GltfPrimitiveMode;
  SetPrimitiveMode(theMode: RWGltf_GltfPrimitiveMode): void;
  HasStyle(): Standard_Boolean;
  BaseColor(): Quantity_ColorRGBA;
  MaterialPbr(): any;
  SetMaterialPbr(theMat: any): void;
  MaterialCommon(): any;
  SetMaterialCommon(theMat: any): void;
  Data(): any;
  AddPrimArrayData(theType: RWGltf_GltfArrayType): RWGltf_GltfPrimArrayData;
  BoundingBox(): Bnd_Box;
  SetBoundingBox(theBox: Bnd_Box): void;
  delete(): void;
}

export declare type RWGltf_GltfRootElement = {
  RWGltf_GltfRootElement_Asset: {};
  RWGltf_GltfRootElement_Scenes: {};
  RWGltf_GltfRootElement_Scene: {};
  RWGltf_GltfRootElement_Nodes: {};
  RWGltf_GltfRootElement_Meshes: {};
  RWGltf_GltfRootElement_Accessors: {};
  RWGltf_GltfRootElement_BufferViews: {};
  RWGltf_GltfRootElement_Buffers: {};
  RWGltf_GltfRootElement_NB_MANDATORY: {};
  RWGltf_GltfRootElement_Animations: {};
  RWGltf_GltfRootElement_Materials: {};
  RWGltf_GltfRootElement_Programs: {};
  RWGltf_GltfRootElement_Samplers: {};
  RWGltf_GltfRootElement_Shaders: {};
  RWGltf_GltfRootElement_Skins: {};
  RWGltf_GltfRootElement_Techniques: {};
  RWGltf_GltfRootElement_Textures: {};
  RWGltf_GltfRootElement_Images: {};
  RWGltf_GltfRootElement_ExtensionsUsed: {};
  RWGltf_GltfRootElement_ExtensionsRequired: {};
  RWGltf_GltfRootElement_NB: {};
}

export declare type RWGltf_GltfAlphaMode = {
  RWGltf_GltfAlphaMode_Opaque: {};
  RWGltf_GltfAlphaMode_Mask: {};
  RWGltf_GltfAlphaMode_Blend: {};
}

export declare class RWGltf_GltfOStreamWriter {
  constructor(theOStream: any)
  delete(): void;
}

export declare class RWGltf_GltfBufferView {
  constructor()
  delete(): void;
}

export declare type RWGltf_GltfAccessorLayout = {
  RWGltf_GltfAccessorLayout_UNKNOWN: {};
  RWGltf_GltfAccessorLayout_Scalar: {};
  RWGltf_GltfAccessorLayout_Vec2: {};
  RWGltf_GltfAccessorLayout_Vec3: {};
  RWGltf_GltfAccessorLayout_Vec4: {};
  RWGltf_GltfAccessorLayout_Mat2: {};
  RWGltf_GltfAccessorLayout_Mat3: {};
  RWGltf_GltfAccessorLayout_Mat4: {};
}

export declare class StepGeom_CompositeCurve extends StepGeom_BoundedCurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSegments: Handle_StepGeom_HArray1OfCompositeCurveSegment, aSelfIntersect: StepData_Logical): void;
  SetSegments(aSegments: Handle_StepGeom_HArray1OfCompositeCurveSegment): void;
  Segments(): Handle_StepGeom_HArray1OfCompositeCurveSegment;
  SegmentsValue(num: Graphic3d_ZLayerId): Handle_StepGeom_CompositeCurveSegment;
  NbSegments(): Graphic3d_ZLayerId;
  SetSelfIntersect(aSelfIntersect: StepData_Logical): void;
  SelfIntersect(): StepData_Logical;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CompositeCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CompositeCurve): void;
  get(): StepGeom_CompositeCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_CompositeCurve_1 extends Handle_StepGeom_CompositeCurve {
    constructor();
  }

  export declare class Handle_StepGeom_CompositeCurve_2 extends Handle_StepGeom_CompositeCurve {
    constructor(thePtr: StepGeom_CompositeCurve);
  }

  export declare class Handle_StepGeom_CompositeCurve_3 extends Handle_StepGeom_CompositeCurve {
    constructor(theHandle: Handle_StepGeom_CompositeCurve);
  }

  export declare class Handle_StepGeom_CompositeCurve_4 extends Handle_StepGeom_CompositeCurve {
    constructor(theHandle: Handle_StepGeom_CompositeCurve);
  }

export declare class StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface extends StepGeom_BSplineSurface {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aQuasiUniformSurface: Handle_StepGeom_QuasiUniformSurface, aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray2OfReal): void;
  SetQuasiUniformSurface(aQuasiUniformSurface: Handle_StepGeom_QuasiUniformSurface): void;
  QuasiUniformSurface(): Handle_StepGeom_QuasiUniformSurface;
  SetRationalBSplineSurface(aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  RationalBSplineSurface(): Handle_StepGeom_RationalBSplineSurface;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray2OfReal): void;
  WeightsData(): Handle_TColStd_HArray2OfReal;
  WeightsDataValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsDataI(): Graphic3d_ZLayerId;
  NbWeightsDataJ(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface): void;
  get(): StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_1 extends Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface {
    constructor();
  }

  export declare class Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_2 extends Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface {
    constructor(thePtr: StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_3 extends Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_4 extends Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface);
  }

export declare class Handle_StepGeom_Parabola {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Parabola): void;
  get(): StepGeom_Parabola;
  delete(): void;
}

  export declare class Handle_StepGeom_Parabola_1 extends Handle_StepGeom_Parabola {
    constructor();
  }

  export declare class Handle_StepGeom_Parabola_2 extends Handle_StepGeom_Parabola {
    constructor(thePtr: StepGeom_Parabola);
  }

  export declare class Handle_StepGeom_Parabola_3 extends Handle_StepGeom_Parabola {
    constructor(theHandle: Handle_StepGeom_Parabola);
  }

  export declare class Handle_StepGeom_Parabola_4 extends Handle_StepGeom_Parabola {
    constructor(theHandle: Handle_StepGeom_Parabola);
  }

export declare class StepGeom_Parabola extends StepGeom_Conic {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: StepGeom_Axis2Placement, aFocalDist: Quantity_AbsorbedDose): void;
  SetFocalDist(aFocalDist: Quantity_AbsorbedDose): void;
  FocalDist(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_RectangularTrimmedSurface extends StepGeom_BoundedSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aU1: Quantity_AbsorbedDose, aU2: Quantity_AbsorbedDose, aV1: Quantity_AbsorbedDose, aV2: Quantity_AbsorbedDose, aUsense: Standard_Boolean, aVsense: Standard_Boolean): void;
  SetBasisSurface(aBasisSurface: Handle_StepGeom_Surface): void;
  BasisSurface(): Handle_StepGeom_Surface;
  SetU1(aU1: Quantity_AbsorbedDose): void;
  U1(): Quantity_AbsorbedDose;
  SetU2(aU2: Quantity_AbsorbedDose): void;
  U2(): Quantity_AbsorbedDose;
  SetV1(aV1: Quantity_AbsorbedDose): void;
  V1(): Quantity_AbsorbedDose;
  SetV2(aV2: Quantity_AbsorbedDose): void;
  V2(): Quantity_AbsorbedDose;
  SetUsense(aUsense: Standard_Boolean): void;
  Usense(): Standard_Boolean;
  SetVsense(aVsense: Standard_Boolean): void;
  Vsense(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_RectangularTrimmedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_RectangularTrimmedSurface): void;
  get(): StepGeom_RectangularTrimmedSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_RectangularTrimmedSurface_1 extends Handle_StepGeom_RectangularTrimmedSurface {
    constructor();
  }

  export declare class Handle_StepGeom_RectangularTrimmedSurface_2 extends Handle_StepGeom_RectangularTrimmedSurface {
    constructor(thePtr: StepGeom_RectangularTrimmedSurface);
  }

  export declare class Handle_StepGeom_RectangularTrimmedSurface_3 extends Handle_StepGeom_RectangularTrimmedSurface {
    constructor(theHandle: Handle_StepGeom_RectangularTrimmedSurface);
  }

  export declare class Handle_StepGeom_RectangularTrimmedSurface_4 extends Handle_StepGeom_RectangularTrimmedSurface {
    constructor(theHandle: Handle_StepGeom_RectangularTrimmedSurface);
  }

export declare type StepGeom_TransitionCode = {
  StepGeom_tcDiscontinuous: {};
  StepGeom_tcContinuous: {};
  StepGeom_tcContSameGradient: {};
  StepGeom_tcContSameGradientSameCurvature: {};
}

export declare class Handle_StepGeom_ConicalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_ConicalSurface): void;
  get(): StepGeom_ConicalSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_ConicalSurface_1 extends Handle_StepGeom_ConicalSurface {
    constructor();
  }

  export declare class Handle_StepGeom_ConicalSurface_2 extends Handle_StepGeom_ConicalSurface {
    constructor(thePtr: StepGeom_ConicalSurface);
  }

  export declare class Handle_StepGeom_ConicalSurface_3 extends Handle_StepGeom_ConicalSurface {
    constructor(theHandle: Handle_StepGeom_ConicalSurface);
  }

  export declare class Handle_StepGeom_ConicalSurface_4 extends Handle_StepGeom_ConicalSurface {
    constructor(theHandle: Handle_StepGeom_ConicalSurface);
  }

export declare class StepGeom_ConicalSurface extends StepGeom_ElementarySurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aRadius: Quantity_AbsorbedDose, aSemiAngle: Quantity_AbsorbedDose): void;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  SetSemiAngle(aSemiAngle: Quantity_AbsorbedDose): void;
  SemiAngle(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Polyline {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Polyline): void;
  get(): StepGeom_Polyline;
  delete(): void;
}

  export declare class Handle_StepGeom_Polyline_1 extends Handle_StepGeom_Polyline {
    constructor();
  }

  export declare class Handle_StepGeom_Polyline_2 extends Handle_StepGeom_Polyline {
    constructor(thePtr: StepGeom_Polyline);
  }

  export declare class Handle_StepGeom_Polyline_3 extends Handle_StepGeom_Polyline {
    constructor(theHandle: Handle_StepGeom_Polyline);
  }

  export declare class Handle_StepGeom_Polyline_4 extends Handle_StepGeom_Polyline {
    constructor(theHandle: Handle_StepGeom_Polyline);
  }

export declare class StepGeom_Polyline extends StepGeom_BoundedCurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPoints: Handle_StepGeom_HArray1OfCartesianPoint): void;
  SetPoints(aPoints: Handle_StepGeom_HArray1OfCartesianPoint): void;
  Points(): Handle_StepGeom_HArray1OfCartesianPoint;
  PointsValue(num: Graphic3d_ZLayerId): Handle_StepGeom_CartesianPoint;
  NbPoints(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_CartesianTransformationOperator3d extends StepGeom_CartesianTransformationOperator {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasAaxis1: Standard_Boolean, aAxis1: Handle_StepGeom_Direction, hasAaxis2: Standard_Boolean, aAxis2: Handle_StepGeom_Direction, aLocalOrigin: Handle_StepGeom_CartesianPoint, hasAscale: Standard_Boolean, aScale: Quantity_AbsorbedDose, hasAaxis3: Standard_Boolean, aAxis3: Handle_StepGeom_Direction): void;
  SetAxis3(aAxis3: Handle_StepGeom_Direction): void;
  UnSetAxis3(): void;
  Axis3(): Handle_StepGeom_Direction;
  HasAxis3(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CartesianTransformationOperator3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CartesianTransformationOperator3d): void;
  get(): StepGeom_CartesianTransformationOperator3d;
  delete(): void;
}

  export declare class Handle_StepGeom_CartesianTransformationOperator3d_1 extends Handle_StepGeom_CartesianTransformationOperator3d {
    constructor();
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator3d_2 extends Handle_StepGeom_CartesianTransformationOperator3d {
    constructor(thePtr: StepGeom_CartesianTransformationOperator3d);
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator3d_3 extends Handle_StepGeom_CartesianTransformationOperator3d {
    constructor(theHandle: Handle_StepGeom_CartesianTransformationOperator3d);
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator3d_4 extends Handle_StepGeom_CartesianTransformationOperator3d {
    constructor(theHandle: Handle_StepGeom_CartesianTransformationOperator3d);
  }

export declare class Handle_StepGeom_SurfaceOfLinearExtrusion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SurfaceOfLinearExtrusion): void;
  get(): StepGeom_SurfaceOfLinearExtrusion;
  delete(): void;
}

  export declare class Handle_StepGeom_SurfaceOfLinearExtrusion_1 extends Handle_StepGeom_SurfaceOfLinearExtrusion {
    constructor();
  }

  export declare class Handle_StepGeom_SurfaceOfLinearExtrusion_2 extends Handle_StepGeom_SurfaceOfLinearExtrusion {
    constructor(thePtr: StepGeom_SurfaceOfLinearExtrusion);
  }

  export declare class Handle_StepGeom_SurfaceOfLinearExtrusion_3 extends Handle_StepGeom_SurfaceOfLinearExtrusion {
    constructor(theHandle: Handle_StepGeom_SurfaceOfLinearExtrusion);
  }

  export declare class Handle_StepGeom_SurfaceOfLinearExtrusion_4 extends Handle_StepGeom_SurfaceOfLinearExtrusion {
    constructor(theHandle: Handle_StepGeom_SurfaceOfLinearExtrusion);
  }

export declare class StepGeom_SurfaceOfLinearExtrusion extends StepGeom_SweptSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptCurve: Handle_StepGeom_Curve, aExtrusionAxis: Handle_StepGeom_Vector): void;
  SetExtrusionAxis(aExtrusionAxis: Handle_StepGeom_Vector): void;
  ExtrusionAxis(): Handle_StepGeom_Vector;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_BezierSurfaceAndRationalBSplineSurface extends StepGeom_BSplineSurface {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aBezierSurface: Handle_StepGeom_BezierSurface, aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray2OfReal): void;
  SetBezierSurface(aBezierSurface: Handle_StepGeom_BezierSurface): void;
  BezierSurface(): Handle_StepGeom_BezierSurface;
  SetRationalBSplineSurface(aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  RationalBSplineSurface(): Handle_StepGeom_RationalBSplineSurface;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray2OfReal): void;
  WeightsData(): Handle_TColStd_HArray2OfReal;
  WeightsDataValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsDataI(): Graphic3d_ZLayerId;
  NbWeightsDataJ(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BezierSurfaceAndRationalBSplineSurface): void;
  get(): StepGeom_BezierSurfaceAndRationalBSplineSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_1 extends Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface {
    constructor();
  }

  export declare class Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_2 extends Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface {
    constructor(thePtr: StepGeom_BezierSurfaceAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_3 extends Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_4 extends Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface);
  }

export declare type StepGeom_BSplineCurveForm = {
  StepGeom_bscfPolylineForm: {};
  StepGeom_bscfCircularArc: {};
  StepGeom_bscfEllipticArc: {};
  StepGeom_bscfParabolicArc: {};
  StepGeom_bscfHyperbolicArc: {};
  StepGeom_bscfUnspecified: {};
}

export declare class Handle_StepGeom_HArray1OfPcurveOrSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfPcurveOrSurface): void;
  get(): StepGeom_HArray1OfPcurveOrSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfPcurveOrSurface_1 extends Handle_StepGeom_HArray1OfPcurveOrSurface {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfPcurveOrSurface_2 extends Handle_StepGeom_HArray1OfPcurveOrSurface {
    constructor(thePtr: StepGeom_HArray1OfPcurveOrSurface);
  }

  export declare class Handle_StepGeom_HArray1OfPcurveOrSurface_3 extends Handle_StepGeom_HArray1OfPcurveOrSurface {
    constructor(theHandle: Handle_StepGeom_HArray1OfPcurveOrSurface);
  }

  export declare class Handle_StepGeom_HArray1OfPcurveOrSurface_4 extends Handle_StepGeom_HArray1OfPcurveOrSurface {
    constructor(theHandle: Handle_StepGeom_HArray1OfPcurveOrSurface);
  }

export declare class StepGeom_GeometricRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_GeometricRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_GeometricRepresentationItem): void;
  get(): StepGeom_GeometricRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepGeom_GeometricRepresentationItem_1 extends Handle_StepGeom_GeometricRepresentationItem {
    constructor();
  }

  export declare class Handle_StepGeom_GeometricRepresentationItem_2 extends Handle_StepGeom_GeometricRepresentationItem {
    constructor(thePtr: StepGeom_GeometricRepresentationItem);
  }

  export declare class Handle_StepGeom_GeometricRepresentationItem_3 extends Handle_StepGeom_GeometricRepresentationItem {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationItem);
  }

  export declare class Handle_StepGeom_GeometricRepresentationItem_4 extends Handle_StepGeom_GeometricRepresentationItem {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationItem);
  }

export declare class Handle_StepGeom_HArray1OfTrimmingSelect {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfTrimmingSelect): void;
  get(): StepGeom_HArray1OfTrimmingSelect;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfTrimmingSelect_1 extends Handle_StepGeom_HArray1OfTrimmingSelect {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfTrimmingSelect_2 extends Handle_StepGeom_HArray1OfTrimmingSelect {
    constructor(thePtr: StepGeom_HArray1OfTrimmingSelect);
  }

  export declare class Handle_StepGeom_HArray1OfTrimmingSelect_3 extends Handle_StepGeom_HArray1OfTrimmingSelect {
    constructor(theHandle: Handle_StepGeom_HArray1OfTrimmingSelect);
  }

  export declare class Handle_StepGeom_HArray1OfTrimmingSelect_4 extends Handle_StepGeom_HArray1OfTrimmingSelect {
    constructor(theHandle: Handle_StepGeom_HArray1OfTrimmingSelect);
  }

export declare class StepGeom_SurfaceCurveAndBoundedCurve extends StepGeom_SurfaceCurve {
  constructor()
  BoundedCurve(): Handle_StepGeom_BoundedCurve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_SurfaceCurveAndBoundedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SurfaceCurveAndBoundedCurve): void;
  get(): StepGeom_SurfaceCurveAndBoundedCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_SurfaceCurveAndBoundedCurve_1 extends Handle_StepGeom_SurfaceCurveAndBoundedCurve {
    constructor();
  }

  export declare class Handle_StepGeom_SurfaceCurveAndBoundedCurve_2 extends Handle_StepGeom_SurfaceCurveAndBoundedCurve {
    constructor(thePtr: StepGeom_SurfaceCurveAndBoundedCurve);
  }

  export declare class Handle_StepGeom_SurfaceCurveAndBoundedCurve_3 extends Handle_StepGeom_SurfaceCurveAndBoundedCurve {
    constructor(theHandle: Handle_StepGeom_SurfaceCurveAndBoundedCurve);
  }

  export declare class Handle_StepGeom_SurfaceCurveAndBoundedCurve_4 extends Handle_StepGeom_SurfaceCurveAndBoundedCurve {
    constructor(theHandle: Handle_StepGeom_SurfaceCurveAndBoundedCurve);
  }

export declare class StepGeom_Curve extends StepGeom_GeometricRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Curve): void;
  get(): StepGeom_Curve;
  delete(): void;
}

  export declare class Handle_StepGeom_Curve_1 extends Handle_StepGeom_Curve {
    constructor();
  }

  export declare class Handle_StepGeom_Curve_2 extends Handle_StepGeom_Curve {
    constructor(thePtr: StepGeom_Curve);
  }

  export declare class Handle_StepGeom_Curve_3 extends Handle_StepGeom_Curve {
    constructor(theHandle: Handle_StepGeom_Curve);
  }

  export declare class Handle_StepGeom_Curve_4 extends Handle_StepGeom_Curve {
    constructor(theHandle: Handle_StepGeom_Curve);
  }

export declare class StepGeom_ReparametrisedCompositeCurveSegment extends StepGeom_CompositeCurveSegment {
  constructor()
  Init(aTransition: StepGeom_TransitionCode, aSameSense: Standard_Boolean, aParentCurve: Handle_StepGeom_Curve, aParamLength: Quantity_AbsorbedDose): void;
  SetParamLength(aParamLength: Quantity_AbsorbedDose): void;
  ParamLength(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_ReparametrisedCompositeCurveSegment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_ReparametrisedCompositeCurveSegment): void;
  get(): StepGeom_ReparametrisedCompositeCurveSegment;
  delete(): void;
}

  export declare class Handle_StepGeom_ReparametrisedCompositeCurveSegment_1 extends Handle_StepGeom_ReparametrisedCompositeCurveSegment {
    constructor();
  }

  export declare class Handle_StepGeom_ReparametrisedCompositeCurveSegment_2 extends Handle_StepGeom_ReparametrisedCompositeCurveSegment {
    constructor(thePtr: StepGeom_ReparametrisedCompositeCurveSegment);
  }

  export declare class Handle_StepGeom_ReparametrisedCompositeCurveSegment_3 extends Handle_StepGeom_ReparametrisedCompositeCurveSegment {
    constructor(theHandle: Handle_StepGeom_ReparametrisedCompositeCurveSegment);
  }

  export declare class Handle_StepGeom_ReparametrisedCompositeCurveSegment_4 extends Handle_StepGeom_ReparametrisedCompositeCurveSegment {
    constructor(theHandle: Handle_StepGeom_ReparametrisedCompositeCurveSegment);
  }

export declare class Handle_StepGeom_HArray1OfCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfCurve): void;
  get(): StepGeom_HArray1OfCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfCurve_1 extends Handle_StepGeom_HArray1OfCurve {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfCurve_2 extends Handle_StepGeom_HArray1OfCurve {
    constructor(thePtr: StepGeom_HArray1OfCurve);
  }

  export declare class Handle_StepGeom_HArray1OfCurve_3 extends Handle_StepGeom_HArray1OfCurve {
    constructor(theHandle: Handle_StepGeom_HArray1OfCurve);
  }

  export declare class Handle_StepGeom_HArray1OfCurve_4 extends Handle_StepGeom_HArray1OfCurve {
    constructor(theHandle: Handle_StepGeom_HArray1OfCurve);
  }

export declare type StepGeom_BSplineSurfaceForm = {
  StepGeom_bssfPlaneSurf: {};
  StepGeom_bssfCylindricalSurf: {};
  StepGeom_bssfConicalSurf: {};
  StepGeom_bssfSphericalSurf: {};
  StepGeom_bssfToroidalSurf: {};
  StepGeom_bssfSurfOfRevolution: {};
  StepGeom_bssfRuledSurf: {};
  StepGeom_bssfGeneralisedCone: {};
  StepGeom_bssfQuadricSurf: {};
  StepGeom_bssfSurfOfLinearExtrusion: {};
  StepGeom_bssfUnspecified: {};
}

export declare class StepGeom_SurfaceReplica extends StepGeom_Surface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aParentSurface: Handle_StepGeom_Surface, aTransformation: Handle_StepGeom_CartesianTransformationOperator3d): void;
  SetParentSurface(aParentSurface: Handle_StepGeom_Surface): void;
  ParentSurface(): Handle_StepGeom_Surface;
  SetTransformation(aTransformation: Handle_StepGeom_CartesianTransformationOperator3d): void;
  Transformation(): Handle_StepGeom_CartesianTransformationOperator3d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_SurfaceReplica {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SurfaceReplica): void;
  get(): StepGeom_SurfaceReplica;
  delete(): void;
}

  export declare class Handle_StepGeom_SurfaceReplica_1 extends Handle_StepGeom_SurfaceReplica {
    constructor();
  }

  export declare class Handle_StepGeom_SurfaceReplica_2 extends Handle_StepGeom_SurfaceReplica {
    constructor(thePtr: StepGeom_SurfaceReplica);
  }

  export declare class Handle_StepGeom_SurfaceReplica_3 extends Handle_StepGeom_SurfaceReplica {
    constructor(theHandle: Handle_StepGeom_SurfaceReplica);
  }

  export declare class Handle_StepGeom_SurfaceReplica_4 extends Handle_StepGeom_SurfaceReplica {
    constructor(theHandle: Handle_StepGeom_SurfaceReplica);
  }

export declare type StepGeom_TrimmingPreference = {
  StepGeom_tpCartesian: {};
  StepGeom_tpParameter: {};
  StepGeom_tpUnspecified: {};
}

export declare class Handle_StepGeom_DegenerateToroidalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_DegenerateToroidalSurface): void;
  get(): StepGeom_DegenerateToroidalSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_DegenerateToroidalSurface_1 extends Handle_StepGeom_DegenerateToroidalSurface {
    constructor();
  }

  export declare class Handle_StepGeom_DegenerateToroidalSurface_2 extends Handle_StepGeom_DegenerateToroidalSurface {
    constructor(thePtr: StepGeom_DegenerateToroidalSurface);
  }

  export declare class Handle_StepGeom_DegenerateToroidalSurface_3 extends Handle_StepGeom_DegenerateToroidalSurface {
    constructor(theHandle: Handle_StepGeom_DegenerateToroidalSurface);
  }

  export declare class Handle_StepGeom_DegenerateToroidalSurface_4 extends Handle_StepGeom_DegenerateToroidalSurface {
    constructor(theHandle: Handle_StepGeom_DegenerateToroidalSurface);
  }

export declare class StepGeom_DegenerateToroidalSurface extends StepGeom_ToroidalSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aMajorRadius: Quantity_AbsorbedDose, aMinorRadius: Quantity_AbsorbedDose, aSelectOuter: Standard_Boolean): void;
  SetSelectOuter(aSelectOuter: Standard_Boolean): void;
  SelectOuter(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_UniformCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_UniformCurve): void;
  get(): StepGeom_UniformCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_UniformCurve_1 extends Handle_StepGeom_UniformCurve {
    constructor();
  }

  export declare class Handle_StepGeom_UniformCurve_2 extends Handle_StepGeom_UniformCurve {
    constructor(thePtr: StepGeom_UniformCurve);
  }

  export declare class Handle_StepGeom_UniformCurve_3 extends Handle_StepGeom_UniformCurve {
    constructor(theHandle: Handle_StepGeom_UniformCurve);
  }

  export declare class Handle_StepGeom_UniformCurve_4 extends Handle_StepGeom_UniformCurve {
    constructor(theHandle: Handle_StepGeom_UniformCurve);
  }

export declare class StepGeom_UniformCurve extends StepGeom_BSplineCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_Point extends StepGeom_GeometricRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Point {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Point): void;
  get(): StepGeom_Point;
  delete(): void;
}

  export declare class Handle_StepGeom_Point_1 extends Handle_StepGeom_Point {
    constructor();
  }

  export declare class Handle_StepGeom_Point_2 extends Handle_StepGeom_Point {
    constructor(thePtr: StepGeom_Point);
  }

  export declare class Handle_StepGeom_Point_3 extends Handle_StepGeom_Point {
    constructor(theHandle: Handle_StepGeom_Point);
  }

  export declare class Handle_StepGeom_Point_4 extends Handle_StepGeom_Point {
    constructor(theHandle: Handle_StepGeom_Point);
  }

export declare class StepGeom_GeometricRepresentationContextAndParametricRepresentationContext extends StepRepr_RepresentationContext {
  constructor()
  Init_1(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aGeometricRepresentationContext: Handle_StepGeom_GeometricRepresentationContext, aParametricRepresentationContext: Handle_StepRepr_ParametricRepresentationContext): void;
  Init_2(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aCoordinateSpaceDimension: Graphic3d_ZLayerId): void;
  SetGeometricRepresentationContext(aGeometricRepresentationContext: Handle_StepGeom_GeometricRepresentationContext): void;
  GeometricRepresentationContext(): Handle_StepGeom_GeometricRepresentationContext;
  SetParametricRepresentationContext(aParametricRepresentationContext: Handle_StepRepr_ParametricRepresentationContext): void;
  ParametricRepresentationContext(): Handle_StepRepr_ParametricRepresentationContext;
  SetCoordinateSpaceDimension(aCoordinateSpaceDimension: Graphic3d_ZLayerId): void;
  CoordinateSpaceDimension(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_GeometricRepresentationContextAndParametricRepresentationContext): void;
  get(): StepGeom_GeometricRepresentationContextAndParametricRepresentationContext;
  delete(): void;
}

  export declare class Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_1 extends Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext {
    constructor();
  }

  export declare class Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_2 extends Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext {
    constructor(thePtr: StepGeom_GeometricRepresentationContextAndParametricRepresentationContext);
  }

  export declare class Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_3 extends Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext);
  }

  export declare class Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_4 extends Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext);
  }

export declare class StepGeom_Axis1Placement extends StepGeom_Placement {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aLocation: Handle_StepGeom_CartesianPoint, hasAaxis: Standard_Boolean, aAxis: Handle_StepGeom_Direction): void;
  SetAxis(aAxis: Handle_StepGeom_Direction): void;
  UnSetAxis(): void;
  Axis(): Handle_StepGeom_Direction;
  HasAxis(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Axis1Placement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Axis1Placement): void;
  get(): StepGeom_Axis1Placement;
  delete(): void;
}

  export declare class Handle_StepGeom_Axis1Placement_1 extends Handle_StepGeom_Axis1Placement {
    constructor();
  }

  export declare class Handle_StepGeom_Axis1Placement_2 extends Handle_StepGeom_Axis1Placement {
    constructor(thePtr: StepGeom_Axis1Placement);
  }

  export declare class Handle_StepGeom_Axis1Placement_3 extends Handle_StepGeom_Axis1Placement {
    constructor(theHandle: Handle_StepGeom_Axis1Placement);
  }

  export declare class Handle_StepGeom_Axis1Placement_4 extends Handle_StepGeom_Axis1Placement {
    constructor(theHandle: Handle_StepGeom_Axis1Placement);
  }

export declare class StepGeom_Pcurve extends StepGeom_Curve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aReferenceToCurve: Handle_StepRepr_DefinitionalRepresentation): void;
  SetBasisSurface(aBasisSurface: Handle_StepGeom_Surface): void;
  BasisSurface(): Handle_StepGeom_Surface;
  SetReferenceToCurve(aReferenceToCurve: Handle_StepRepr_DefinitionalRepresentation): void;
  ReferenceToCurve(): Handle_StepRepr_DefinitionalRepresentation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Pcurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Pcurve): void;
  get(): StepGeom_Pcurve;
  delete(): void;
}

  export declare class Handle_StepGeom_Pcurve_1 extends Handle_StepGeom_Pcurve {
    constructor();
  }

  export declare class Handle_StepGeom_Pcurve_2 extends Handle_StepGeom_Pcurve {
    constructor(thePtr: StepGeom_Pcurve);
  }

  export declare class Handle_StepGeom_Pcurve_3 extends Handle_StepGeom_Pcurve {
    constructor(theHandle: Handle_StepGeom_Pcurve);
  }

  export declare class Handle_StepGeom_Pcurve_4 extends Handle_StepGeom_Pcurve {
    constructor(theHandle: Handle_StepGeom_Pcurve);
  }

export declare class StepGeom_VectorOrDirection extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Vector(): Handle_StepGeom_Vector;
  Direction(): Handle_StepGeom_Direction;
  delete(): void;
}

export declare class StepGeom_Line extends StepGeom_Curve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPnt: Handle_StepGeom_CartesianPoint, aDir: Handle_StepGeom_Vector): void;
  SetPnt(aPnt: Handle_StepGeom_CartesianPoint): void;
  Pnt(): Handle_StepGeom_CartesianPoint;
  SetDir(aDir: Handle_StepGeom_Vector): void;
  Dir(): Handle_StepGeom_Vector;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Line): void;
  get(): StepGeom_Line;
  delete(): void;
}

  export declare class Handle_StepGeom_Line_1 extends Handle_StepGeom_Line {
    constructor();
  }

  export declare class Handle_StepGeom_Line_2 extends Handle_StepGeom_Line {
    constructor(thePtr: StepGeom_Line);
  }

  export declare class Handle_StepGeom_Line_3 extends Handle_StepGeom_Line {
    constructor(theHandle: Handle_StepGeom_Line);
  }

  export declare class Handle_StepGeom_Line_4 extends Handle_StepGeom_Line {
    constructor(theHandle: Handle_StepGeom_Line);
  }

export declare class Handle_StepGeom_Plane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Plane): void;
  get(): StepGeom_Plane;
  delete(): void;
}

  export declare class Handle_StepGeom_Plane_1 extends Handle_StepGeom_Plane {
    constructor();
  }

  export declare class Handle_StepGeom_Plane_2 extends Handle_StepGeom_Plane {
    constructor(thePtr: StepGeom_Plane);
  }

  export declare class Handle_StepGeom_Plane_3 extends Handle_StepGeom_Plane {
    constructor(theHandle: Handle_StepGeom_Plane);
  }

  export declare class Handle_StepGeom_Plane_4 extends Handle_StepGeom_Plane {
    constructor(theHandle: Handle_StepGeom_Plane);
  }

export declare class StepGeom_Plane extends StepGeom_ElementarySurface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CurveBoundedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CurveBoundedSurface): void;
  get(): StepGeom_CurveBoundedSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_CurveBoundedSurface_1 extends Handle_StepGeom_CurveBoundedSurface {
    constructor();
  }

  export declare class Handle_StepGeom_CurveBoundedSurface_2 extends Handle_StepGeom_CurveBoundedSurface {
    constructor(thePtr: StepGeom_CurveBoundedSurface);
  }

  export declare class Handle_StepGeom_CurveBoundedSurface_3 extends Handle_StepGeom_CurveBoundedSurface {
    constructor(theHandle: Handle_StepGeom_CurveBoundedSurface);
  }

  export declare class Handle_StepGeom_CurveBoundedSurface_4 extends Handle_StepGeom_CurveBoundedSurface {
    constructor(theHandle: Handle_StepGeom_CurveBoundedSurface);
  }

export declare class StepGeom_CurveBoundedSurface extends StepGeom_BoundedSurface {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aBoundaries: Handle_StepGeom_HArray1OfSurfaceBoundary, aImplicitOuter: Standard_Boolean): void;
  BasisSurface(): Handle_StepGeom_Surface;
  SetBasisSurface(BasisSurface: Handle_StepGeom_Surface): void;
  Boundaries(): Handle_StepGeom_HArray1OfSurfaceBoundary;
  SetBoundaries(Boundaries: Handle_StepGeom_HArray1OfSurfaceBoundary): void;
  ImplicitOuter(): Standard_Boolean;
  SetImplicitOuter(ImplicitOuter: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_CylindricalSurface extends StepGeom_ElementarySurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aRadius: Quantity_AbsorbedDose): void;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CylindricalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CylindricalSurface): void;
  get(): StepGeom_CylindricalSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_CylindricalSurface_1 extends Handle_StepGeom_CylindricalSurface {
    constructor();
  }

  export declare class Handle_StepGeom_CylindricalSurface_2 extends Handle_StepGeom_CylindricalSurface {
    constructor(thePtr: StepGeom_CylindricalSurface);
  }

  export declare class Handle_StepGeom_CylindricalSurface_3 extends Handle_StepGeom_CylindricalSurface {
    constructor(theHandle: Handle_StepGeom_CylindricalSurface);
  }

  export declare class Handle_StepGeom_CylindricalSurface_4 extends Handle_StepGeom_CylindricalSurface {
    constructor(theHandle: Handle_StepGeom_CylindricalSurface);
  }

export declare class StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx extends StepRepr_RepresentationContext {
  constructor()
  Init_1(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aGeometricRepresentationCtx: Handle_StepGeom_GeometricRepresentationContext, aGlobalUnitAssignedCtx: Handle_StepRepr_GlobalUnitAssignedContext, aGlobalUncertaintyAssignedCtx: Handle_StepRepr_GlobalUncertaintyAssignedContext): void;
  Init_2(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aCoordinateSpaceDimension: Graphic3d_ZLayerId, aUnits: Handle_StepBasic_HArray1OfNamedUnit, anUncertainty: Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit): void;
  SetGeometricRepresentationContext(aGeometricRepresentationContext: Handle_StepGeom_GeometricRepresentationContext): void;
  GeometricRepresentationContext(): Handle_StepGeom_GeometricRepresentationContext;
  SetGlobalUnitAssignedContext(aGlobalUnitAssignedContext: Handle_StepRepr_GlobalUnitAssignedContext): void;
  GlobalUnitAssignedContext(): Handle_StepRepr_GlobalUnitAssignedContext;
  SetGlobalUncertaintyAssignedContext(aGlobalUncertaintyAssignedCtx: Handle_StepRepr_GlobalUncertaintyAssignedContext): void;
  GlobalUncertaintyAssignedContext(): Handle_StepRepr_GlobalUncertaintyAssignedContext;
  SetCoordinateSpaceDimension(aCoordinateSpaceDimension: Graphic3d_ZLayerId): void;
  CoordinateSpaceDimension(): Graphic3d_ZLayerId;
  SetUnits(aUnits: Handle_StepBasic_HArray1OfNamedUnit): void;
  Units(): Handle_StepBasic_HArray1OfNamedUnit;
  UnitsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_NamedUnit;
  NbUnits(): Graphic3d_ZLayerId;
  SetUncertainty(aUncertainty: Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit): void;
  Uncertainty(): Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit;
  UncertaintyValue(num: Graphic3d_ZLayerId): Handle_StepBasic_UncertaintyMeasureWithUnit;
  NbUncertainty(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx): void;
  get(): StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx;
  delete(): void;
}

  export declare class Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_1 extends Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx {
    constructor();
  }

  export declare class Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_2 extends Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx {
    constructor(thePtr: StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx);
  }

  export declare class Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_3 extends Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx {
    constructor(theHandle: Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx);
  }

  export declare class Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_4 extends Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx {
    constructor(theHandle: Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx);
  }

export declare class StepGeom_QuasiUniformSurface extends StepGeom_BSplineSurface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_QuasiUniformSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_QuasiUniformSurface): void;
  get(): StepGeom_QuasiUniformSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_QuasiUniformSurface_1 extends Handle_StepGeom_QuasiUniformSurface {
    constructor();
  }

  export declare class Handle_StepGeom_QuasiUniformSurface_2 extends Handle_StepGeom_QuasiUniformSurface {
    constructor(thePtr: StepGeom_QuasiUniformSurface);
  }

  export declare class Handle_StepGeom_QuasiUniformSurface_3 extends Handle_StepGeom_QuasiUniformSurface {
    constructor(theHandle: Handle_StepGeom_QuasiUniformSurface);
  }

  export declare class Handle_StepGeom_QuasiUniformSurface_4 extends Handle_StepGeom_QuasiUniformSurface {
    constructor(theHandle: Handle_StepGeom_QuasiUniformSurface);
  }

export declare class Handle_StepGeom_Vector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Vector): void;
  get(): StepGeom_Vector;
  delete(): void;
}

  export declare class Handle_StepGeom_Vector_1 extends Handle_StepGeom_Vector {
    constructor();
  }

  export declare class Handle_StepGeom_Vector_2 extends Handle_StepGeom_Vector {
    constructor(thePtr: StepGeom_Vector);
  }

  export declare class Handle_StepGeom_Vector_3 extends Handle_StepGeom_Vector {
    constructor(theHandle: Handle_StepGeom_Vector);
  }

  export declare class Handle_StepGeom_Vector_4 extends Handle_StepGeom_Vector {
    constructor(theHandle: Handle_StepGeom_Vector);
  }

export declare class StepGeom_Vector extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aOrientation: Handle_StepGeom_Direction, aMagnitude: Quantity_AbsorbedDose): void;
  SetOrientation(aOrientation: Handle_StepGeom_Direction): void;
  Orientation(): Handle_StepGeom_Direction;
  SetMagnitude(aMagnitude: Quantity_AbsorbedDose): void;
  Magnitude(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_QuasiUniformCurveAndRationalBSplineCurve extends StepGeom_BSplineCurve {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aQuasiUniformCurve: Handle_StepGeom_QuasiUniformCurve, aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray1OfReal): void;
  SetQuasiUniformCurve(aQuasiUniformCurve: Handle_StepGeom_QuasiUniformCurve): void;
  QuasiUniformCurve(): Handle_StepGeom_QuasiUniformCurve;
  SetRationalBSplineCurve(aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  RationalBSplineCurve(): Handle_StepGeom_RationalBSplineCurve;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray1OfReal): void;
  WeightsData(): Handle_TColStd_HArray1OfReal;
  WeightsDataValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsData(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_QuasiUniformCurveAndRationalBSplineCurve): void;
  get(): StepGeom_QuasiUniformCurveAndRationalBSplineCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_1 extends Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve {
    constructor();
  }

  export declare class Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_2 extends Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve {
    constructor(thePtr: StepGeom_QuasiUniformCurveAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_3 extends Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_4 extends Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve);
  }

export declare class Handle_StepGeom_SphericalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SphericalSurface): void;
  get(): StepGeom_SphericalSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_SphericalSurface_1 extends Handle_StepGeom_SphericalSurface {
    constructor();
  }

  export declare class Handle_StepGeom_SphericalSurface_2 extends Handle_StepGeom_SphericalSurface {
    constructor(thePtr: StepGeom_SphericalSurface);
  }

  export declare class Handle_StepGeom_SphericalSurface_3 extends Handle_StepGeom_SphericalSurface {
    constructor(theHandle: Handle_StepGeom_SphericalSurface);
  }

  export declare class Handle_StepGeom_SphericalSurface_4 extends Handle_StepGeom_SphericalSurface {
    constructor(theHandle: Handle_StepGeom_SphericalSurface);
  }

export declare class StepGeom_SphericalSurface extends StepGeom_ElementarySurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aRadius: Quantity_AbsorbedDose): void;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_Axis2Placement3d extends StepGeom_Placement {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aLocation: Handle_StepGeom_CartesianPoint, hasAaxis: Standard_Boolean, aAxis: Handle_StepGeom_Direction, hasArefDirection: Standard_Boolean, aRefDirection: Handle_StepGeom_Direction): void;
  SetAxis(aAxis: Handle_StepGeom_Direction): void;
  UnSetAxis(): void;
  Axis(): Handle_StepGeom_Direction;
  HasAxis(): Standard_Boolean;
  SetRefDirection(aRefDirection: Handle_StepGeom_Direction): void;
  UnSetRefDirection(): void;
  RefDirection(): Handle_StepGeom_Direction;
  HasRefDirection(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Axis2Placement3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Axis2Placement3d): void;
  get(): StepGeom_Axis2Placement3d;
  delete(): void;
}

  export declare class Handle_StepGeom_Axis2Placement3d_1 extends Handle_StepGeom_Axis2Placement3d {
    constructor();
  }

  export declare class Handle_StepGeom_Axis2Placement3d_2 extends Handle_StepGeom_Axis2Placement3d {
    constructor(thePtr: StepGeom_Axis2Placement3d);
  }

  export declare class Handle_StepGeom_Axis2Placement3d_3 extends Handle_StepGeom_Axis2Placement3d {
    constructor(theHandle: Handle_StepGeom_Axis2Placement3d);
  }

  export declare class Handle_StepGeom_Axis2Placement3d_4 extends Handle_StepGeom_Axis2Placement3d {
    constructor(theHandle: Handle_StepGeom_Axis2Placement3d);
  }

export declare class Handle_StepGeom_HArray2OfSurfacePatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray2OfSurfacePatch): void;
  get(): StepGeom_HArray2OfSurfacePatch;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray2OfSurfacePatch_1 extends Handle_StepGeom_HArray2OfSurfacePatch {
    constructor();
  }

  export declare class Handle_StepGeom_HArray2OfSurfacePatch_2 extends Handle_StepGeom_HArray2OfSurfacePatch {
    constructor(thePtr: StepGeom_HArray2OfSurfacePatch);
  }

  export declare class Handle_StepGeom_HArray2OfSurfacePatch_3 extends Handle_StepGeom_HArray2OfSurfacePatch {
    constructor(theHandle: Handle_StepGeom_HArray2OfSurfacePatch);
  }

  export declare class Handle_StepGeom_HArray2OfSurfacePatch_4 extends Handle_StepGeom_HArray2OfSurfacePatch {
    constructor(theHandle: Handle_StepGeom_HArray2OfSurfacePatch);
  }

export declare class Handle_StepGeom_BoundedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BoundedCurve): void;
  get(): StepGeom_BoundedCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_BoundedCurve_1 extends Handle_StepGeom_BoundedCurve {
    constructor();
  }

  export declare class Handle_StepGeom_BoundedCurve_2 extends Handle_StepGeom_BoundedCurve {
    constructor(thePtr: StepGeom_BoundedCurve);
  }

  export declare class Handle_StepGeom_BoundedCurve_3 extends Handle_StepGeom_BoundedCurve {
    constructor(theHandle: Handle_StepGeom_BoundedCurve);
  }

  export declare class Handle_StepGeom_BoundedCurve_4 extends Handle_StepGeom_BoundedCurve {
    constructor(theHandle: Handle_StepGeom_BoundedCurve);
  }

export declare class StepGeom_BoundedCurve extends StepGeom_Curve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_TrimmedCurve extends StepGeom_BoundedCurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisCurve: Handle_StepGeom_Curve, aTrim1: Handle_StepGeom_HArray1OfTrimmingSelect, aTrim2: Handle_StepGeom_HArray1OfTrimmingSelect, aSenseAgreement: Standard_Boolean, aMasterRepresentation: StepGeom_TrimmingPreference): void;
  SetBasisCurve(aBasisCurve: Handle_StepGeom_Curve): void;
  BasisCurve(): Handle_StepGeom_Curve;
  SetTrim1(aTrim1: Handle_StepGeom_HArray1OfTrimmingSelect): void;
  Trim1(): Handle_StepGeom_HArray1OfTrimmingSelect;
  Trim1Value(num: Graphic3d_ZLayerId): StepGeom_TrimmingSelect;
  NbTrim1(): Graphic3d_ZLayerId;
  SetTrim2(aTrim2: Handle_StepGeom_HArray1OfTrimmingSelect): void;
  Trim2(): Handle_StepGeom_HArray1OfTrimmingSelect;
  Trim2Value(num: Graphic3d_ZLayerId): StepGeom_TrimmingSelect;
  NbTrim2(): Graphic3d_ZLayerId;
  SetSenseAgreement(aSenseAgreement: Standard_Boolean): void;
  SenseAgreement(): Standard_Boolean;
  SetMasterRepresentation(aMasterRepresentation: StepGeom_TrimmingPreference): void;
  MasterRepresentation(): StepGeom_TrimmingPreference;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_TrimmedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_TrimmedCurve): void;
  get(): StepGeom_TrimmedCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_TrimmedCurve_1 extends Handle_StepGeom_TrimmedCurve {
    constructor();
  }

  export declare class Handle_StepGeom_TrimmedCurve_2 extends Handle_StepGeom_TrimmedCurve {
    constructor(thePtr: StepGeom_TrimmedCurve);
  }

  export declare class Handle_StepGeom_TrimmedCurve_3 extends Handle_StepGeom_TrimmedCurve {
    constructor(theHandle: Handle_StepGeom_TrimmedCurve);
  }

  export declare class Handle_StepGeom_TrimmedCurve_4 extends Handle_StepGeom_TrimmedCurve {
    constructor(theHandle: Handle_StepGeom_TrimmedCurve);
  }

export declare class Handle_StepGeom_SurfacePatch {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SurfacePatch): void;
  get(): StepGeom_SurfacePatch;
  delete(): void;
}

  export declare class Handle_StepGeom_SurfacePatch_1 extends Handle_StepGeom_SurfacePatch {
    constructor();
  }

  export declare class Handle_StepGeom_SurfacePatch_2 extends Handle_StepGeom_SurfacePatch {
    constructor(thePtr: StepGeom_SurfacePatch);
  }

  export declare class Handle_StepGeom_SurfacePatch_3 extends Handle_StepGeom_SurfacePatch {
    constructor(theHandle: Handle_StepGeom_SurfacePatch);
  }

  export declare class Handle_StepGeom_SurfacePatch_4 extends Handle_StepGeom_SurfacePatch {
    constructor(theHandle: Handle_StepGeom_SurfacePatch);
  }

export declare class StepGeom_SurfacePatch extends Standard_Transient {
  constructor()
  Init(aParentSurface: Handle_StepGeom_BoundedSurface, aUTransition: StepGeom_TransitionCode, aVTransition: StepGeom_TransitionCode, aUSense: Standard_Boolean, aVSense: Standard_Boolean): void;
  SetParentSurface(aParentSurface: Handle_StepGeom_BoundedSurface): void;
  ParentSurface(): Handle_StepGeom_BoundedSurface;
  SetUTransition(aUTransition: StepGeom_TransitionCode): void;
  UTransition(): StepGeom_TransitionCode;
  SetVTransition(aVTransition: StepGeom_TransitionCode): void;
  VTransition(): StepGeom_TransitionCode;
  SetUSense(aUSense: Standard_Boolean): void;
  USense(): Standard_Boolean;
  SetVSense(aVSense: Standard_Boolean): void;
  VSense(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_Ellipse extends StepGeom_Conic {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: StepGeom_Axis2Placement, aSemiAxis1: Quantity_AbsorbedDose, aSemiAxis2: Quantity_AbsorbedDose): void;
  SetSemiAxis1(aSemiAxis1: Quantity_AbsorbedDose): void;
  SemiAxis1(): Quantity_AbsorbedDose;
  SetSemiAxis2(aSemiAxis2: Quantity_AbsorbedDose): void;
  SemiAxis2(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Ellipse {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Ellipse): void;
  get(): StepGeom_Ellipse;
  delete(): void;
}

  export declare class Handle_StepGeom_Ellipse_1 extends Handle_StepGeom_Ellipse {
    constructor();
  }

  export declare class Handle_StepGeom_Ellipse_2 extends Handle_StepGeom_Ellipse {
    constructor(thePtr: StepGeom_Ellipse);
  }

  export declare class Handle_StepGeom_Ellipse_3 extends Handle_StepGeom_Ellipse {
    constructor(theHandle: Handle_StepGeom_Ellipse);
  }

  export declare class Handle_StepGeom_Ellipse_4 extends Handle_StepGeom_Ellipse {
    constructor(theHandle: Handle_StepGeom_Ellipse);
  }

export declare class StepGeom_BezierCurve extends StepGeom_BSplineCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BezierCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BezierCurve): void;
  get(): StepGeom_BezierCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_BezierCurve_1 extends Handle_StepGeom_BezierCurve {
    constructor();
  }

  export declare class Handle_StepGeom_BezierCurve_2 extends Handle_StepGeom_BezierCurve {
    constructor(thePtr: StepGeom_BezierCurve);
  }

  export declare class Handle_StepGeom_BezierCurve_3 extends Handle_StepGeom_BezierCurve {
    constructor(theHandle: Handle_StepGeom_BezierCurve);
  }

  export declare class Handle_StepGeom_BezierCurve_4 extends Handle_StepGeom_BezierCurve {
    constructor(theHandle: Handle_StepGeom_BezierCurve);
  }

export declare class Handle_StepGeom_CartesianPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CartesianPoint): void;
  get(): StepGeom_CartesianPoint;
  delete(): void;
}

  export declare class Handle_StepGeom_CartesianPoint_1 extends Handle_StepGeom_CartesianPoint {
    constructor();
  }

  export declare class Handle_StepGeom_CartesianPoint_2 extends Handle_StepGeom_CartesianPoint {
    constructor(thePtr: StepGeom_CartesianPoint);
  }

  export declare class Handle_StepGeom_CartesianPoint_3 extends Handle_StepGeom_CartesianPoint {
    constructor(theHandle: Handle_StepGeom_CartesianPoint);
  }

  export declare class Handle_StepGeom_CartesianPoint_4 extends Handle_StepGeom_CartesianPoint {
    constructor(theHandle: Handle_StepGeom_CartesianPoint);
  }

export declare class StepGeom_CartesianPoint extends StepGeom_Point {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCoordinates: Handle_TColStd_HArray1OfReal): void;
  Init2D(aName: Handle_TCollection_HAsciiString, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Init3D(aName: Handle_TCollection_HAsciiString, X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose, Z: Quantity_AbsorbedDose): void;
  SetCoordinates(aCoordinates: Handle_TColStd_HArray1OfReal): void;
  Coordinates(): Handle_TColStd_HArray1OfReal;
  CoordinatesValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbCoordinates(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_BSplineCurve extends StepGeom_BoundedCurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical): void;
  SetDegree(aDegree: Graphic3d_ZLayerId): void;
  Degree(): Graphic3d_ZLayerId;
  SetControlPointsList(aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint): void;
  ControlPointsList(): Handle_StepGeom_HArray1OfCartesianPoint;
  ControlPointsListValue(num: Graphic3d_ZLayerId): Handle_StepGeom_CartesianPoint;
  NbControlPointsList(): Graphic3d_ZLayerId;
  SetCurveForm(aCurveForm: StepGeom_BSplineCurveForm): void;
  CurveForm(): StepGeom_BSplineCurveForm;
  SetClosedCurve(aClosedCurve: StepData_Logical): void;
  ClosedCurve(): StepData_Logical;
  SetSelfIntersect(aSelfIntersect: StepData_Logical): void;
  SelfIntersect(): StepData_Logical;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BSplineCurve): void;
  get(): StepGeom_BSplineCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_BSplineCurve_1 extends Handle_StepGeom_BSplineCurve {
    constructor();
  }

  export declare class Handle_StepGeom_BSplineCurve_2 extends Handle_StepGeom_BSplineCurve {
    constructor(thePtr: StepGeom_BSplineCurve);
  }

  export declare class Handle_StepGeom_BSplineCurve_3 extends Handle_StepGeom_BSplineCurve {
    constructor(theHandle: Handle_StepGeom_BSplineCurve);
  }

  export declare class Handle_StepGeom_BSplineCurve_4 extends Handle_StepGeom_BSplineCurve {
    constructor(theHandle: Handle_StepGeom_BSplineCurve);
  }

export declare class StepGeom_Axis2Placement2d extends StepGeom_Placement {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aLocation: Handle_StepGeom_CartesianPoint, hasArefDirection: Standard_Boolean, aRefDirection: Handle_StepGeom_Direction): void;
  SetRefDirection(aRefDirection: Handle_StepGeom_Direction): void;
  UnSetRefDirection(): void;
  RefDirection(): Handle_StepGeom_Direction;
  HasRefDirection(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Axis2Placement2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Axis2Placement2d): void;
  get(): StepGeom_Axis2Placement2d;
  delete(): void;
}

  export declare class Handle_StepGeom_Axis2Placement2d_1 extends Handle_StepGeom_Axis2Placement2d {
    constructor();
  }

  export declare class Handle_StepGeom_Axis2Placement2d_2 extends Handle_StepGeom_Axis2Placement2d {
    constructor(thePtr: StepGeom_Axis2Placement2d);
  }

  export declare class Handle_StepGeom_Axis2Placement2d_3 extends Handle_StepGeom_Axis2Placement2d {
    constructor(theHandle: Handle_StepGeom_Axis2Placement2d);
  }

  export declare class Handle_StepGeom_Axis2Placement2d_4 extends Handle_StepGeom_Axis2Placement2d {
    constructor(theHandle: Handle_StepGeom_Axis2Placement2d);
  }

export declare class Handle_StepGeom_QuasiUniformCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_QuasiUniformCurve): void;
  get(): StepGeom_QuasiUniformCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_QuasiUniformCurve_1 extends Handle_StepGeom_QuasiUniformCurve {
    constructor();
  }

  export declare class Handle_StepGeom_QuasiUniformCurve_2 extends Handle_StepGeom_QuasiUniformCurve {
    constructor(thePtr: StepGeom_QuasiUniformCurve);
  }

  export declare class Handle_StepGeom_QuasiUniformCurve_3 extends Handle_StepGeom_QuasiUniformCurve {
    constructor(theHandle: Handle_StepGeom_QuasiUniformCurve);
  }

  export declare class Handle_StepGeom_QuasiUniformCurve_4 extends Handle_StepGeom_QuasiUniformCurve {
    constructor(theHandle: Handle_StepGeom_QuasiUniformCurve);
  }

export declare class StepGeom_QuasiUniformCurve extends StepGeom_BSplineCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_SurfaceOfRevolution {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SurfaceOfRevolution): void;
  get(): StepGeom_SurfaceOfRevolution;
  delete(): void;
}

  export declare class Handle_StepGeom_SurfaceOfRevolution_1 extends Handle_StepGeom_SurfaceOfRevolution {
    constructor();
  }

  export declare class Handle_StepGeom_SurfaceOfRevolution_2 extends Handle_StepGeom_SurfaceOfRevolution {
    constructor(thePtr: StepGeom_SurfaceOfRevolution);
  }

  export declare class Handle_StepGeom_SurfaceOfRevolution_3 extends Handle_StepGeom_SurfaceOfRevolution {
    constructor(theHandle: Handle_StepGeom_SurfaceOfRevolution);
  }

  export declare class Handle_StepGeom_SurfaceOfRevolution_4 extends Handle_StepGeom_SurfaceOfRevolution {
    constructor(theHandle: Handle_StepGeom_SurfaceOfRevolution);
  }

export declare class StepGeom_SurfaceOfRevolution extends StepGeom_SweptSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptCurve: Handle_StepGeom_Curve, aAxisPosition: Handle_StepGeom_Axis1Placement): void;
  SetAxisPosition(aAxisPosition: Handle_StepGeom_Axis1Placement): void;
  AxisPosition(): Handle_StepGeom_Axis1Placement;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_SweptSurface extends StepGeom_Surface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSweptCurve: Handle_StepGeom_Curve): void;
  SetSweptCurve(aSweptCurve: Handle_StepGeom_Curve): void;
  SweptCurve(): Handle_StepGeom_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_SweptSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SweptSurface): void;
  get(): StepGeom_SweptSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_SweptSurface_1 extends Handle_StepGeom_SweptSurface {
    constructor();
  }

  export declare class Handle_StepGeom_SweptSurface_2 extends Handle_StepGeom_SweptSurface {
    constructor(thePtr: StepGeom_SweptSurface);
  }

  export declare class Handle_StepGeom_SweptSurface_3 extends Handle_StepGeom_SweptSurface {
    constructor(theHandle: Handle_StepGeom_SweptSurface);
  }

  export declare class Handle_StepGeom_SweptSurface_4 extends Handle_StepGeom_SweptSurface {
    constructor(theHandle: Handle_StepGeom_SweptSurface);
  }

export declare class Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext): void;
  get(): StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext;
  delete(): void;
}

  export declare class Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_1 extends Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext {
    constructor();
  }

  export declare class Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_2 extends Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext {
    constructor(thePtr: StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext);
  }

  export declare class Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_3 extends Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext);
  }

  export declare class Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_4 extends Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext);
  }

export declare class StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext extends StepRepr_RepresentationContext {
  constructor()
  Init_1(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aGeometricRepresentationContext: Handle_StepGeom_GeometricRepresentationContext, aGlobalUnitAssignedContext: Handle_StepRepr_GlobalUnitAssignedContext): void;
  Init_2(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aCoordinateSpaceDimension: Graphic3d_ZLayerId, aUnits: Handle_StepBasic_HArray1OfNamedUnit): void;
  SetGeometricRepresentationContext(aGeometricRepresentationContext: Handle_StepGeom_GeometricRepresentationContext): void;
  GeometricRepresentationContext(): Handle_StepGeom_GeometricRepresentationContext;
  SetGlobalUnitAssignedContext(aGlobalUnitAssignedContext: Handle_StepRepr_GlobalUnitAssignedContext): void;
  GlobalUnitAssignedContext(): Handle_StepRepr_GlobalUnitAssignedContext;
  SetCoordinateSpaceDimension(aCoordinateSpaceDimension: Graphic3d_ZLayerId): void;
  CoordinateSpaceDimension(): Graphic3d_ZLayerId;
  SetUnits(aUnits: Handle_StepBasic_HArray1OfNamedUnit): void;
  Units(): Handle_StepBasic_HArray1OfNamedUnit;
  UnitsValue(num: Graphic3d_ZLayerId): Handle_StepBasic_NamedUnit;
  NbUnits(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_OrientedSurface extends StepGeom_Surface {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aOrientation: Standard_Boolean): void;
  Orientation(): Standard_Boolean;
  SetOrientation(Orientation: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_OrientedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_OrientedSurface): void;
  get(): StepGeom_OrientedSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_OrientedSurface_1 extends Handle_StepGeom_OrientedSurface {
    constructor();
  }

  export declare class Handle_StepGeom_OrientedSurface_2 extends Handle_StepGeom_OrientedSurface {
    constructor(thePtr: StepGeom_OrientedSurface);
  }

  export declare class Handle_StepGeom_OrientedSurface_3 extends Handle_StepGeom_OrientedSurface {
    constructor(theHandle: Handle_StepGeom_OrientedSurface);
  }

  export declare class Handle_StepGeom_OrientedSurface_4 extends Handle_StepGeom_OrientedSurface {
    constructor(theHandle: Handle_StepGeom_OrientedSurface);
  }

export declare class StepGeom_RationalBSplineSurface extends StepGeom_BSplineSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray2OfReal): void;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray2OfReal): void;
  WeightsData(): Handle_TColStd_HArray2OfReal;
  WeightsDataValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsDataI(): Graphic3d_ZLayerId;
  NbWeightsDataJ(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_RationalBSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_RationalBSplineSurface): void;
  get(): StepGeom_RationalBSplineSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_RationalBSplineSurface_1 extends Handle_StepGeom_RationalBSplineSurface {
    constructor();
  }

  export declare class Handle_StepGeom_RationalBSplineSurface_2 extends Handle_StepGeom_RationalBSplineSurface {
    constructor(thePtr: StepGeom_RationalBSplineSurface);
  }

  export declare class Handle_StepGeom_RationalBSplineSurface_3 extends Handle_StepGeom_RationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_RationalBSplineSurface);
  }

  export declare class Handle_StepGeom_RationalBSplineSurface_4 extends Handle_StepGeom_RationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_RationalBSplineSurface);
  }

export declare class StepGeom_Surface extends StepGeom_GeometricRepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Surface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Surface): void;
  get(): StepGeom_Surface;
  delete(): void;
}

  export declare class Handle_StepGeom_Surface_1 extends Handle_StepGeom_Surface {
    constructor();
  }

  export declare class Handle_StepGeom_Surface_2 extends Handle_StepGeom_Surface {
    constructor(thePtr: StepGeom_Surface);
  }

  export declare class Handle_StepGeom_Surface_3 extends Handle_StepGeom_Surface {
    constructor(theHandle: Handle_StepGeom_Surface);
  }

  export declare class Handle_StepGeom_Surface_4 extends Handle_StepGeom_Surface {
    constructor(theHandle: Handle_StepGeom_Surface);
  }

export declare class StepGeom_UniformSurface extends StepGeom_BSplineSurface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_UniformSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_UniformSurface): void;
  get(): StepGeom_UniformSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_UniformSurface_1 extends Handle_StepGeom_UniformSurface {
    constructor();
  }

  export declare class Handle_StepGeom_UniformSurface_2 extends Handle_StepGeom_UniformSurface {
    constructor(thePtr: StepGeom_UniformSurface);
  }

  export declare class Handle_StepGeom_UniformSurface_3 extends Handle_StepGeom_UniformSurface {
    constructor(theHandle: Handle_StepGeom_UniformSurface);
  }

  export declare class Handle_StepGeom_UniformSurface_4 extends Handle_StepGeom_UniformSurface {
    constructor(theHandle: Handle_StepGeom_UniformSurface);
  }

export declare type StepGeom_KnotType = {
  StepGeom_ktUniformKnots: {};
  StepGeom_ktUnspecified: {};
  StepGeom_ktQuasiUniformKnots: {};
  StepGeom_ktPiecewiseBezierKnots: {};
}

export declare class Handle_StepGeom_HArray1OfCartesianPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfCartesianPoint): void;
  get(): StepGeom_HArray1OfCartesianPoint;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfCartesianPoint_1 extends Handle_StepGeom_HArray1OfCartesianPoint {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfCartesianPoint_2 extends Handle_StepGeom_HArray1OfCartesianPoint {
    constructor(thePtr: StepGeom_HArray1OfCartesianPoint);
  }

  export declare class Handle_StepGeom_HArray1OfCartesianPoint_3 extends Handle_StepGeom_HArray1OfCartesianPoint {
    constructor(theHandle: Handle_StepGeom_HArray1OfCartesianPoint);
  }

  export declare class Handle_StepGeom_HArray1OfCartesianPoint_4 extends Handle_StepGeom_HArray1OfCartesianPoint {
    constructor(theHandle: Handle_StepGeom_HArray1OfCartesianPoint);
  }

export declare class StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve extends StepGeom_BSplineCurve {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aBSplineCurveWithKnots: Handle_StepGeom_BSplineCurveWithKnots, aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aKnotMultiplicities: Handle_TColStd_HArray1OfInteger, aKnots: Handle_TColStd_HArray1OfReal, aKnotSpec: StepGeom_KnotType, aWeightsData: Handle_TColStd_HArray1OfReal): void;
  SetBSplineCurveWithKnots(aBSplineCurveWithKnots: Handle_StepGeom_BSplineCurveWithKnots): void;
  BSplineCurveWithKnots(): Handle_StepGeom_BSplineCurveWithKnots;
  SetRationalBSplineCurve(aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  RationalBSplineCurve(): Handle_StepGeom_RationalBSplineCurve;
  SetKnotMultiplicities(aKnotMultiplicities: Handle_TColStd_HArray1OfInteger): void;
  KnotMultiplicities(): Handle_TColStd_HArray1OfInteger;
  KnotMultiplicitiesValue(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbKnotMultiplicities(): Graphic3d_ZLayerId;
  SetKnots(aKnots: Handle_TColStd_HArray1OfReal): void;
  Knots(): Handle_TColStd_HArray1OfReal;
  KnotsValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbKnots(): Graphic3d_ZLayerId;
  SetKnotSpec(aKnotSpec: StepGeom_KnotType): void;
  KnotSpec(): StepGeom_KnotType;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray1OfReal): void;
  WeightsData(): Handle_TColStd_HArray1OfReal;
  WeightsDataValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsData(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve): void;
  get(): StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_1 extends Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve {
    constructor();
  }

  export declare class Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_2 extends Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve {
    constructor(thePtr: StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_3 extends Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_4 extends Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve);
  }

export declare class StepGeom_Axis2Placement extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Axis2Placement2d(): Handle_StepGeom_Axis2Placement2d;
  Axis2Placement3d(): Handle_StepGeom_Axis2Placement3d;
  delete(): void;
}

export declare class Handle_StepGeom_HArray2OfCartesianPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray2OfCartesianPoint): void;
  get(): StepGeom_HArray2OfCartesianPoint;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray2OfCartesianPoint_1 extends Handle_StepGeom_HArray2OfCartesianPoint {
    constructor();
  }

  export declare class Handle_StepGeom_HArray2OfCartesianPoint_2 extends Handle_StepGeom_HArray2OfCartesianPoint {
    constructor(thePtr: StepGeom_HArray2OfCartesianPoint);
  }

  export declare class Handle_StepGeom_HArray2OfCartesianPoint_3 extends Handle_StepGeom_HArray2OfCartesianPoint {
    constructor(theHandle: Handle_StepGeom_HArray2OfCartesianPoint);
  }

  export declare class Handle_StepGeom_HArray2OfCartesianPoint_4 extends Handle_StepGeom_HArray2OfCartesianPoint {
    constructor(theHandle: Handle_StepGeom_HArray2OfCartesianPoint);
  }

export declare class Handle_StepGeom_BSplineCurveWithKnots {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BSplineCurveWithKnots): void;
  get(): StepGeom_BSplineCurveWithKnots;
  delete(): void;
}

  export declare class Handle_StepGeom_BSplineCurveWithKnots_1 extends Handle_StepGeom_BSplineCurveWithKnots {
    constructor();
  }

  export declare class Handle_StepGeom_BSplineCurveWithKnots_2 extends Handle_StepGeom_BSplineCurveWithKnots {
    constructor(thePtr: StepGeom_BSplineCurveWithKnots);
  }

  export declare class Handle_StepGeom_BSplineCurveWithKnots_3 extends Handle_StepGeom_BSplineCurveWithKnots {
    constructor(theHandle: Handle_StepGeom_BSplineCurveWithKnots);
  }

  export declare class Handle_StepGeom_BSplineCurveWithKnots_4 extends Handle_StepGeom_BSplineCurveWithKnots {
    constructor(theHandle: Handle_StepGeom_BSplineCurveWithKnots);
  }

export declare class StepGeom_BSplineCurveWithKnots extends StepGeom_BSplineCurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aKnotMultiplicities: Handle_TColStd_HArray1OfInteger, aKnots: Handle_TColStd_HArray1OfReal, aKnotSpec: StepGeom_KnotType): void;
  SetKnotMultiplicities(aKnotMultiplicities: Handle_TColStd_HArray1OfInteger): void;
  KnotMultiplicities(): Handle_TColStd_HArray1OfInteger;
  KnotMultiplicitiesValue(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbKnotMultiplicities(): Graphic3d_ZLayerId;
  SetKnots(aKnots: Handle_TColStd_HArray1OfReal): void;
  Knots(): Handle_TColStd_HArray1OfReal;
  KnotsValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbKnots(): Graphic3d_ZLayerId;
  SetKnotSpec(aKnotSpec: StepGeom_KnotType): void;
  KnotSpec(): StepGeom_KnotType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CompositeCurveSegment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CompositeCurveSegment): void;
  get(): StepGeom_CompositeCurveSegment;
  delete(): void;
}

  export declare class Handle_StepGeom_CompositeCurveSegment_1 extends Handle_StepGeom_CompositeCurveSegment {
    constructor();
  }

  export declare class Handle_StepGeom_CompositeCurveSegment_2 extends Handle_StepGeom_CompositeCurveSegment {
    constructor(thePtr: StepGeom_CompositeCurveSegment);
  }

  export declare class Handle_StepGeom_CompositeCurveSegment_3 extends Handle_StepGeom_CompositeCurveSegment {
    constructor(theHandle: Handle_StepGeom_CompositeCurveSegment);
  }

  export declare class Handle_StepGeom_CompositeCurveSegment_4 extends Handle_StepGeom_CompositeCurveSegment {
    constructor(theHandle: Handle_StepGeom_CompositeCurveSegment);
  }

export declare class StepGeom_CompositeCurveSegment extends Standard_Transient {
  constructor()
  Init(aTransition: StepGeom_TransitionCode, aSameSense: Standard_Boolean, aParentCurve: Handle_StepGeom_Curve): void;
  SetTransition(aTransition: StepGeom_TransitionCode): void;
  Transition(): StepGeom_TransitionCode;
  SetSameSense(aSameSense: Standard_Boolean): void;
  SameSense(): Standard_Boolean;
  SetParentCurve(aParentCurve: Handle_StepGeom_Curve): void;
  ParentCurve(): Handle_StepGeom_Curve;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_RationalBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_RationalBSplineCurve): void;
  get(): StepGeom_RationalBSplineCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_RationalBSplineCurve_1 extends Handle_StepGeom_RationalBSplineCurve {
    constructor();
  }

  export declare class Handle_StepGeom_RationalBSplineCurve_2 extends Handle_StepGeom_RationalBSplineCurve {
    constructor(thePtr: StepGeom_RationalBSplineCurve);
  }

  export declare class Handle_StepGeom_RationalBSplineCurve_3 extends Handle_StepGeom_RationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_RationalBSplineCurve);
  }

  export declare class Handle_StepGeom_RationalBSplineCurve_4 extends Handle_StepGeom_RationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_RationalBSplineCurve);
  }

export declare class StepGeom_RationalBSplineCurve extends StepGeom_BSplineCurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray1OfReal): void;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray1OfReal): void;
  WeightsData(): Handle_TColStd_HArray1OfReal;
  WeightsDataValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsData(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CartesianTransformationOperator2d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CartesianTransformationOperator2d): void;
  get(): StepGeom_CartesianTransformationOperator2d;
  delete(): void;
}

  export declare class Handle_StepGeom_CartesianTransformationOperator2d_1 extends Handle_StepGeom_CartesianTransformationOperator2d {
    constructor();
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator2d_2 extends Handle_StepGeom_CartesianTransformationOperator2d {
    constructor(thePtr: StepGeom_CartesianTransformationOperator2d);
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator2d_3 extends Handle_StepGeom_CartesianTransformationOperator2d {
    constructor(theHandle: Handle_StepGeom_CartesianTransformationOperator2d);
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator2d_4 extends Handle_StepGeom_CartesianTransformationOperator2d {
    constructor(theHandle: Handle_StepGeom_CartesianTransformationOperator2d);
  }

export declare class StepGeom_CartesianTransformationOperator2d extends StepGeom_CartesianTransformationOperator {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Hyperbola {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Hyperbola): void;
  get(): StepGeom_Hyperbola;
  delete(): void;
}

  export declare class Handle_StepGeom_Hyperbola_1 extends Handle_StepGeom_Hyperbola {
    constructor();
  }

  export declare class Handle_StepGeom_Hyperbola_2 extends Handle_StepGeom_Hyperbola {
    constructor(thePtr: StepGeom_Hyperbola);
  }

  export declare class Handle_StepGeom_Hyperbola_3 extends Handle_StepGeom_Hyperbola {
    constructor(theHandle: Handle_StepGeom_Hyperbola);
  }

  export declare class Handle_StepGeom_Hyperbola_4 extends Handle_StepGeom_Hyperbola {
    constructor(theHandle: Handle_StepGeom_Hyperbola);
  }

export declare class StepGeom_Hyperbola extends StepGeom_Conic {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: StepGeom_Axis2Placement, aSemiAxis: Quantity_AbsorbedDose, aSemiImagAxis: Quantity_AbsorbedDose): void;
  SetSemiAxis(aSemiAxis: Quantity_AbsorbedDose): void;
  SemiAxis(): Quantity_AbsorbedDose;
  SetSemiImagAxis(aSemiImagAxis: Quantity_AbsorbedDose): void;
  SemiImagAxis(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_HArray1OfBoundaryCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfBoundaryCurve): void;
  get(): StepGeom_HArray1OfBoundaryCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfBoundaryCurve_1 extends Handle_StepGeom_HArray1OfBoundaryCurve {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfBoundaryCurve_2 extends Handle_StepGeom_HArray1OfBoundaryCurve {
    constructor(thePtr: StepGeom_HArray1OfBoundaryCurve);
  }

  export declare class Handle_StepGeom_HArray1OfBoundaryCurve_3 extends Handle_StepGeom_HArray1OfBoundaryCurve {
    constructor(theHandle: Handle_StepGeom_HArray1OfBoundaryCurve);
  }

  export declare class Handle_StepGeom_HArray1OfBoundaryCurve_4 extends Handle_StepGeom_HArray1OfBoundaryCurve {
    constructor(theHandle: Handle_StepGeom_HArray1OfBoundaryCurve);
  }

export declare class StepGeom_Array1OfSurfaceBoundary {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepGeom_SurfaceBoundary): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepGeom_Array1OfSurfaceBoundary): StepGeom_Array1OfSurfaceBoundary;
  Move(theOther: StepGeom_Array1OfSurfaceBoundary): StepGeom_Array1OfSurfaceBoundary;
  First(): StepGeom_SurfaceBoundary;
  ChangeFirst(): StepGeom_SurfaceBoundary;
  Last(): StepGeom_SurfaceBoundary;
  ChangeLast(): StepGeom_SurfaceBoundary;
  Value(theIndex: Standard_Integer): StepGeom_SurfaceBoundary;
  ChangeValue(theIndex: Standard_Integer): StepGeom_SurfaceBoundary;
  SetValue(theIndex: Standard_Integer, theItem: StepGeom_SurfaceBoundary): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepGeom_Array1OfSurfaceBoundary_1 extends StepGeom_Array1OfSurfaceBoundary {
    constructor();
  }

  export declare class StepGeom_Array1OfSurfaceBoundary_2 extends StepGeom_Array1OfSurfaceBoundary {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepGeom_Array1OfSurfaceBoundary_3 extends StepGeom_Array1OfSurfaceBoundary {
    constructor(theOther: StepGeom_Array1OfSurfaceBoundary);
  }

  export declare class StepGeom_Array1OfSurfaceBoundary_4 extends StepGeom_Array1OfSurfaceBoundary {
    constructor(theOther: StepGeom_Array1OfSurfaceBoundary);
  }

  export declare class StepGeom_Array1OfSurfaceBoundary_5 extends StepGeom_Array1OfSurfaceBoundary {
    constructor(theBegin: StepGeom_SurfaceBoundary, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class StepGeom_TrimmingSelect extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  CartesianPoint(): Handle_StepGeom_CartesianPoint;
  SetParameterValue(aParameterValue: Quantity_AbsorbedDose): void;
  ParameterValue(): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class StepGeom_BezierSurface extends StepGeom_BSplineSurface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BezierSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BezierSurface): void;
  get(): StepGeom_BezierSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_BezierSurface_1 extends Handle_StepGeom_BezierSurface {
    constructor();
  }

  export declare class Handle_StepGeom_BezierSurface_2 extends Handle_StepGeom_BezierSurface {
    constructor(thePtr: StepGeom_BezierSurface);
  }

  export declare class Handle_StepGeom_BezierSurface_3 extends Handle_StepGeom_BezierSurface {
    constructor(theHandle: Handle_StepGeom_BezierSurface);
  }

  export declare class Handle_StepGeom_BezierSurface_4 extends Handle_StepGeom_BezierSurface {
    constructor(theHandle: Handle_StepGeom_BezierSurface);
  }

export declare class Handle_StepGeom_SurfaceCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SurfaceCurve): void;
  get(): StepGeom_SurfaceCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_SurfaceCurve_1 extends Handle_StepGeom_SurfaceCurve {
    constructor();
  }

  export declare class Handle_StepGeom_SurfaceCurve_2 extends Handle_StepGeom_SurfaceCurve {
    constructor(thePtr: StepGeom_SurfaceCurve);
  }

  export declare class Handle_StepGeom_SurfaceCurve_3 extends Handle_StepGeom_SurfaceCurve {
    constructor(theHandle: Handle_StepGeom_SurfaceCurve);
  }

  export declare class Handle_StepGeom_SurfaceCurve_4 extends Handle_StepGeom_SurfaceCurve {
    constructor(theHandle: Handle_StepGeom_SurfaceCurve);
  }

export declare class StepGeom_SurfaceCurve extends StepGeom_Curve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aCurve3d: Handle_StepGeom_Curve, aAssociatedGeometry: Handle_StepGeom_HArray1OfPcurveOrSurface, aMasterRepresentation: StepGeom_PreferredSurfaceCurveRepresentation): void;
  SetCurve3d(aCurve3d: Handle_StepGeom_Curve): void;
  Curve3d(): Handle_StepGeom_Curve;
  SetAssociatedGeometry(aAssociatedGeometry: Handle_StepGeom_HArray1OfPcurveOrSurface): void;
  AssociatedGeometry(): Handle_StepGeom_HArray1OfPcurveOrSurface;
  AssociatedGeometryValue(num: Graphic3d_ZLayerId): StepGeom_PcurveOrSurface;
  NbAssociatedGeometry(): Graphic3d_ZLayerId;
  SetMasterRepresentation(aMasterRepresentation: StepGeom_PreferredSurfaceCurveRepresentation): void;
  MasterRepresentation(): StepGeom_PreferredSurfaceCurveRepresentation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_GeometricRepresentationContext extends StepRepr_RepresentationContext {
  constructor()
  Init(aContextIdentifier: Handle_TCollection_HAsciiString, aContextType: Handle_TCollection_HAsciiString, aCoordinateSpaceDimension: Graphic3d_ZLayerId): void;
  SetCoordinateSpaceDimension(aCoordinateSpaceDimension: Graphic3d_ZLayerId): void;
  CoordinateSpaceDimension(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_GeometricRepresentationContext {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_GeometricRepresentationContext): void;
  get(): StepGeom_GeometricRepresentationContext;
  delete(): void;
}

  export declare class Handle_StepGeom_GeometricRepresentationContext_1 extends Handle_StepGeom_GeometricRepresentationContext {
    constructor();
  }

  export declare class Handle_StepGeom_GeometricRepresentationContext_2 extends Handle_StepGeom_GeometricRepresentationContext {
    constructor(thePtr: StepGeom_GeometricRepresentationContext);
  }

  export declare class Handle_StepGeom_GeometricRepresentationContext_3 extends Handle_StepGeom_GeometricRepresentationContext {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationContext);
  }

  export declare class Handle_StepGeom_GeometricRepresentationContext_4 extends Handle_StepGeom_GeometricRepresentationContext {
    constructor(theHandle: Handle_StepGeom_GeometricRepresentationContext);
  }

export declare class StepGeom_DegeneratePcurve extends StepGeom_Point {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aReferenceToCurve: Handle_StepRepr_DefinitionalRepresentation): void;
  SetBasisSurface(aBasisSurface: Handle_StepGeom_Surface): void;
  BasisSurface(): Handle_StepGeom_Surface;
  SetReferenceToCurve(aReferenceToCurve: Handle_StepRepr_DefinitionalRepresentation): void;
  ReferenceToCurve(): Handle_StepRepr_DefinitionalRepresentation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_DegeneratePcurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_DegeneratePcurve): void;
  get(): StepGeom_DegeneratePcurve;
  delete(): void;
}

  export declare class Handle_StepGeom_DegeneratePcurve_1 extends Handle_StepGeom_DegeneratePcurve {
    constructor();
  }

  export declare class Handle_StepGeom_DegeneratePcurve_2 extends Handle_StepGeom_DegeneratePcurve {
    constructor(thePtr: StepGeom_DegeneratePcurve);
  }

  export declare class Handle_StepGeom_DegeneratePcurve_3 extends Handle_StepGeom_DegeneratePcurve {
    constructor(theHandle: Handle_StepGeom_DegeneratePcurve);
  }

  export declare class Handle_StepGeom_DegeneratePcurve_4 extends Handle_StepGeom_DegeneratePcurve {
    constructor(theHandle: Handle_StepGeom_DegeneratePcurve);
  }

export declare type StepGeom_PreferredSurfaceCurveRepresentation = {
  StepGeom_pscrCurve3d: {};
  StepGeom_pscrPcurveS1: {};
  StepGeom_pscrPcurveS2: {};
}

export declare class StepGeom_EvaluatedDegeneratePcurve extends StepGeom_DegeneratePcurve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aReferenceToCurve: Handle_StepRepr_DefinitionalRepresentation, aEquivalentPoint: Handle_StepGeom_CartesianPoint): void;
  SetEquivalentPoint(aEquivalentPoint: Handle_StepGeom_CartesianPoint): void;
  EquivalentPoint(): Handle_StepGeom_CartesianPoint;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_EvaluatedDegeneratePcurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_EvaluatedDegeneratePcurve): void;
  get(): StepGeom_EvaluatedDegeneratePcurve;
  delete(): void;
}

  export declare class Handle_StepGeom_EvaluatedDegeneratePcurve_1 extends Handle_StepGeom_EvaluatedDegeneratePcurve {
    constructor();
  }

  export declare class Handle_StepGeom_EvaluatedDegeneratePcurve_2 extends Handle_StepGeom_EvaluatedDegeneratePcurve {
    constructor(thePtr: StepGeom_EvaluatedDegeneratePcurve);
  }

  export declare class Handle_StepGeom_EvaluatedDegeneratePcurve_3 extends Handle_StepGeom_EvaluatedDegeneratePcurve {
    constructor(theHandle: Handle_StepGeom_EvaluatedDegeneratePcurve);
  }

  export declare class Handle_StepGeom_EvaluatedDegeneratePcurve_4 extends Handle_StepGeom_EvaluatedDegeneratePcurve {
    constructor(theHandle: Handle_StepGeom_EvaluatedDegeneratePcurve);
  }

export declare class Handle_StepGeom_OffsetCurve3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_OffsetCurve3d): void;
  get(): StepGeom_OffsetCurve3d;
  delete(): void;
}

  export declare class Handle_StepGeom_OffsetCurve3d_1 extends Handle_StepGeom_OffsetCurve3d {
    constructor();
  }

  export declare class Handle_StepGeom_OffsetCurve3d_2 extends Handle_StepGeom_OffsetCurve3d {
    constructor(thePtr: StepGeom_OffsetCurve3d);
  }

  export declare class Handle_StepGeom_OffsetCurve3d_3 extends Handle_StepGeom_OffsetCurve3d {
    constructor(theHandle: Handle_StepGeom_OffsetCurve3d);
  }

  export declare class Handle_StepGeom_OffsetCurve3d_4 extends Handle_StepGeom_OffsetCurve3d {
    constructor(theHandle: Handle_StepGeom_OffsetCurve3d);
  }

export declare class StepGeom_OffsetCurve3d extends StepGeom_Curve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisCurve: Handle_StepGeom_Curve, aDistance: Quantity_AbsorbedDose, aSelfIntersect: StepData_Logical, aRefDirection: Handle_StepGeom_Direction): void;
  SetBasisCurve(aBasisCurve: Handle_StepGeom_Curve): void;
  BasisCurve(): Handle_StepGeom_Curve;
  SetDistance(aDistance: Quantity_AbsorbedDose): void;
  Distance(): Quantity_AbsorbedDose;
  SetSelfIntersect(aSelfIntersect: StepData_Logical): void;
  SelfIntersect(): StepData_Logical;
  SetRefDirection(aRefDirection: Handle_StepGeom_Direction): void;
  RefDirection(): Handle_StepGeom_Direction;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_IntersectionCurve extends StepGeom_SurfaceCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_IntersectionCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_IntersectionCurve): void;
  get(): StepGeom_IntersectionCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_IntersectionCurve_1 extends Handle_StepGeom_IntersectionCurve {
    constructor();
  }

  export declare class Handle_StepGeom_IntersectionCurve_2 extends Handle_StepGeom_IntersectionCurve {
    constructor(thePtr: StepGeom_IntersectionCurve);
  }

  export declare class Handle_StepGeom_IntersectionCurve_3 extends Handle_StepGeom_IntersectionCurve {
    constructor(theHandle: Handle_StepGeom_IntersectionCurve);
  }

  export declare class Handle_StepGeom_IntersectionCurve_4 extends Handle_StepGeom_IntersectionCurve {
    constructor(theHandle: Handle_StepGeom_IntersectionCurve);
  }

export declare class Handle_StepGeom_TrimmingMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_TrimmingMember): void;
  get(): StepGeom_TrimmingMember;
  delete(): void;
}

  export declare class Handle_StepGeom_TrimmingMember_1 extends Handle_StepGeom_TrimmingMember {
    constructor();
  }

  export declare class Handle_StepGeom_TrimmingMember_2 extends Handle_StepGeom_TrimmingMember {
    constructor(thePtr: StepGeom_TrimmingMember);
  }

  export declare class Handle_StepGeom_TrimmingMember_3 extends Handle_StepGeom_TrimmingMember {
    constructor(theHandle: Handle_StepGeom_TrimmingMember);
  }

  export declare class Handle_StepGeom_TrimmingMember_4 extends Handle_StepGeom_TrimmingMember {
    constructor(theHandle: Handle_StepGeom_TrimmingMember);
  }

export declare class StepGeom_TrimmingMember extends StepData_SelectReal {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Conic {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Conic): void;
  get(): StepGeom_Conic;
  delete(): void;
}

  export declare class Handle_StepGeom_Conic_1 extends Handle_StepGeom_Conic {
    constructor();
  }

  export declare class Handle_StepGeom_Conic_2 extends Handle_StepGeom_Conic {
    constructor(thePtr: StepGeom_Conic);
  }

  export declare class Handle_StepGeom_Conic_3 extends Handle_StepGeom_Conic {
    constructor(theHandle: Handle_StepGeom_Conic);
  }

  export declare class Handle_StepGeom_Conic_4 extends Handle_StepGeom_Conic {
    constructor(theHandle: Handle_StepGeom_Conic);
  }

export declare class StepGeom_Conic extends StepGeom_Curve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: StepGeom_Axis2Placement): void;
  SetPosition(aPosition: StepGeom_Axis2Placement): void;
  Position(): StepGeom_Axis2Placement;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_RectangularCompositeSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_RectangularCompositeSurface): void;
  get(): StepGeom_RectangularCompositeSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_RectangularCompositeSurface_1 extends Handle_StepGeom_RectangularCompositeSurface {
    constructor();
  }

  export declare class Handle_StepGeom_RectangularCompositeSurface_2 extends Handle_StepGeom_RectangularCompositeSurface {
    constructor(thePtr: StepGeom_RectangularCompositeSurface);
  }

  export declare class Handle_StepGeom_RectangularCompositeSurface_3 extends Handle_StepGeom_RectangularCompositeSurface {
    constructor(theHandle: Handle_StepGeom_RectangularCompositeSurface);
  }

  export declare class Handle_StepGeom_RectangularCompositeSurface_4 extends Handle_StepGeom_RectangularCompositeSurface {
    constructor(theHandle: Handle_StepGeom_RectangularCompositeSurface);
  }

export declare class StepGeom_RectangularCompositeSurface extends StepGeom_BoundedSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aSegments: Handle_StepGeom_HArray2OfSurfacePatch): void;
  SetSegments(aSegments: Handle_StepGeom_HArray2OfSurfacePatch): void;
  Segments(): Handle_StepGeom_HArray2OfSurfacePatch;
  SegmentsValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Handle_StepGeom_SurfacePatch;
  NbSegmentsI(): Graphic3d_ZLayerId;
  NbSegmentsJ(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_Array1OfPcurveOrSurface {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepGeom_PcurveOrSurface): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepGeom_Array1OfPcurveOrSurface): StepGeom_Array1OfPcurveOrSurface;
  Move(theOther: StepGeom_Array1OfPcurveOrSurface): StepGeom_Array1OfPcurveOrSurface;
  First(): StepGeom_PcurveOrSurface;
  ChangeFirst(): StepGeom_PcurveOrSurface;
  Last(): StepGeom_PcurveOrSurface;
  ChangeLast(): StepGeom_PcurveOrSurface;
  Value(theIndex: Standard_Integer): StepGeom_PcurveOrSurface;
  ChangeValue(theIndex: Standard_Integer): StepGeom_PcurveOrSurface;
  SetValue(theIndex: Standard_Integer, theItem: StepGeom_PcurveOrSurface): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepGeom_Array1OfPcurveOrSurface_1 extends StepGeom_Array1OfPcurveOrSurface {
    constructor();
  }

  export declare class StepGeom_Array1OfPcurveOrSurface_2 extends StepGeom_Array1OfPcurveOrSurface {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepGeom_Array1OfPcurveOrSurface_3 extends StepGeom_Array1OfPcurveOrSurface {
    constructor(theOther: StepGeom_Array1OfPcurveOrSurface);
  }

  export declare class StepGeom_Array1OfPcurveOrSurface_4 extends StepGeom_Array1OfPcurveOrSurface {
    constructor(theOther: StepGeom_Array1OfPcurveOrSurface);
  }

  export declare class StepGeom_Array1OfPcurveOrSurface_5 extends StepGeom_Array1OfPcurveOrSurface {
    constructor(theBegin: StepGeom_PcurveOrSurface, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_UniformSurfaceAndRationalBSplineSurface): void;
  get(): StepGeom_UniformSurfaceAndRationalBSplineSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_1 extends Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface {
    constructor();
  }

  export declare class Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_2 extends Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface {
    constructor(thePtr: StepGeom_UniformSurfaceAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_3 extends Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_4 extends Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface);
  }

export declare class StepGeom_UniformSurfaceAndRationalBSplineSurface extends StepGeom_BSplineSurface {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aUniformSurface: Handle_StepGeom_UniformSurface, aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray2OfReal): void;
  SetUniformSurface(aUniformSurface: Handle_StepGeom_UniformSurface): void;
  UniformSurface(): Handle_StepGeom_UniformSurface;
  SetRationalBSplineSurface(aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  RationalBSplineSurface(): Handle_StepGeom_RationalBSplineSurface;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray2OfReal): void;
  WeightsData(): Handle_TColStd_HArray2OfReal;
  WeightsDataValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsDataI(): Graphic3d_ZLayerId;
  NbWeightsDataJ(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_OuterBoundaryCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_OuterBoundaryCurve): void;
  get(): StepGeom_OuterBoundaryCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_OuterBoundaryCurve_1 extends Handle_StepGeom_OuterBoundaryCurve {
    constructor();
  }

  export declare class Handle_StepGeom_OuterBoundaryCurve_2 extends Handle_StepGeom_OuterBoundaryCurve {
    constructor(thePtr: StepGeom_OuterBoundaryCurve);
  }

  export declare class Handle_StepGeom_OuterBoundaryCurve_3 extends Handle_StepGeom_OuterBoundaryCurve {
    constructor(theHandle: Handle_StepGeom_OuterBoundaryCurve);
  }

  export declare class Handle_StepGeom_OuterBoundaryCurve_4 extends Handle_StepGeom_OuterBoundaryCurve {
    constructor(theHandle: Handle_StepGeom_OuterBoundaryCurve);
  }

export declare class StepGeom_OuterBoundaryCurve extends StepGeom_BoundaryCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_UniformCurveAndRationalBSplineCurve extends StepGeom_BSplineCurve {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aUniformCurve: Handle_StepGeom_UniformCurve, aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray1OfReal): void;
  SetUniformCurve(aUniformCurve: Handle_StepGeom_UniformCurve): void;
  UniformCurve(): Handle_StepGeom_UniformCurve;
  SetRationalBSplineCurve(aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  RationalBSplineCurve(): Handle_StepGeom_RationalBSplineCurve;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray1OfReal): void;
  WeightsData(): Handle_TColStd_HArray1OfReal;
  WeightsDataValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsData(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_UniformCurveAndRationalBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_UniformCurveAndRationalBSplineCurve): void;
  get(): StepGeom_UniformCurveAndRationalBSplineCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_UniformCurveAndRationalBSplineCurve_1 extends Handle_StepGeom_UniformCurveAndRationalBSplineCurve {
    constructor();
  }

  export declare class Handle_StepGeom_UniformCurveAndRationalBSplineCurve_2 extends Handle_StepGeom_UniformCurveAndRationalBSplineCurve {
    constructor(thePtr: StepGeom_UniformCurveAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_UniformCurveAndRationalBSplineCurve_3 extends Handle_StepGeom_UniformCurveAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_UniformCurveAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_UniformCurveAndRationalBSplineCurve_4 extends Handle_StepGeom_UniformCurveAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_UniformCurveAndRationalBSplineCurve);
  }

export declare class Handle_StepGeom_PointOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_PointOnSurface): void;
  get(): StepGeom_PointOnSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_PointOnSurface_1 extends Handle_StepGeom_PointOnSurface {
    constructor();
  }

  export declare class Handle_StepGeom_PointOnSurface_2 extends Handle_StepGeom_PointOnSurface {
    constructor(thePtr: StepGeom_PointOnSurface);
  }

  export declare class Handle_StepGeom_PointOnSurface_3 extends Handle_StepGeom_PointOnSurface {
    constructor(theHandle: Handle_StepGeom_PointOnSurface);
  }

  export declare class Handle_StepGeom_PointOnSurface_4 extends Handle_StepGeom_PointOnSurface {
    constructor(theHandle: Handle_StepGeom_PointOnSurface);
  }

export declare class StepGeom_PointOnSurface extends StepGeom_Point {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aPointParameterU: Quantity_AbsorbedDose, aPointParameterV: Quantity_AbsorbedDose): void;
  SetBasisSurface(aBasisSurface: Handle_StepGeom_Surface): void;
  BasisSurface(): Handle_StepGeom_Surface;
  SetPointParameterU(aPointParameterU: Quantity_AbsorbedDose): void;
  PointParameterU(): Quantity_AbsorbedDose;
  SetPointParameterV(aPointParameterV: Quantity_AbsorbedDose): void;
  PointParameterV(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_PcurveOrSurface extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Pcurve(): Handle_StepGeom_Pcurve;
  Surface(): Handle_StepGeom_Surface;
  delete(): void;
}

export declare class Handle_StepGeom_Placement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Placement): void;
  get(): StepGeom_Placement;
  delete(): void;
}

  export declare class Handle_StepGeom_Placement_1 extends Handle_StepGeom_Placement {
    constructor();
  }

  export declare class Handle_StepGeom_Placement_2 extends Handle_StepGeom_Placement {
    constructor(thePtr: StepGeom_Placement);
  }

  export declare class Handle_StepGeom_Placement_3 extends Handle_StepGeom_Placement {
    constructor(theHandle: Handle_StepGeom_Placement);
  }

  export declare class Handle_StepGeom_Placement_4 extends Handle_StepGeom_Placement {
    constructor(theHandle: Handle_StepGeom_Placement);
  }

export declare class StepGeom_Placement extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aLocation: Handle_StepGeom_CartesianPoint): void;
  SetLocation(aLocation: Handle_StepGeom_CartesianPoint): void;
  Location(): Handle_StepGeom_CartesianPoint;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_Circle extends StepGeom_Conic {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: StepGeom_Axis2Placement, aRadius: Quantity_AbsorbedDose): void;
  SetRadius(aRadius: Quantity_AbsorbedDose): void;
  Radius(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Circle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Circle): void;
  get(): StepGeom_Circle;
  delete(): void;
}

  export declare class Handle_StepGeom_Circle_1 extends Handle_StepGeom_Circle {
    constructor();
  }

  export declare class Handle_StepGeom_Circle_2 extends Handle_StepGeom_Circle {
    constructor(thePtr: StepGeom_Circle);
  }

  export declare class Handle_StepGeom_Circle_3 extends Handle_StepGeom_Circle {
    constructor(theHandle: Handle_StepGeom_Circle);
  }

  export declare class Handle_StepGeom_Circle_4 extends Handle_StepGeom_Circle {
    constructor(theHandle: Handle_StepGeom_Circle);
  }

export declare class StepGeom_BSplineSurface extends StepGeom_BoundedSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical): void;
  SetUDegree(aUDegree: Graphic3d_ZLayerId): void;
  UDegree(): Graphic3d_ZLayerId;
  SetVDegree(aVDegree: Graphic3d_ZLayerId): void;
  VDegree(): Graphic3d_ZLayerId;
  SetControlPointsList(aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint): void;
  ControlPointsList(): Handle_StepGeom_HArray2OfCartesianPoint;
  ControlPointsListValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Handle_StepGeom_CartesianPoint;
  NbControlPointsListI(): Graphic3d_ZLayerId;
  NbControlPointsListJ(): Graphic3d_ZLayerId;
  SetSurfaceForm(aSurfaceForm: StepGeom_BSplineSurfaceForm): void;
  SurfaceForm(): StepGeom_BSplineSurfaceForm;
  SetUClosed(aUClosed: StepData_Logical): void;
  UClosed(): StepData_Logical;
  SetVClosed(aVClosed: StepData_Logical): void;
  VClosed(): StepData_Logical;
  SetSelfIntersect(aSelfIntersect: StepData_Logical): void;
  SelfIntersect(): StepData_Logical;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BSplineSurface): void;
  get(): StepGeom_BSplineSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_BSplineSurface_1 extends Handle_StepGeom_BSplineSurface {
    constructor();
  }

  export declare class Handle_StepGeom_BSplineSurface_2 extends Handle_StepGeom_BSplineSurface {
    constructor(thePtr: StepGeom_BSplineSurface);
  }

  export declare class Handle_StepGeom_BSplineSurface_3 extends Handle_StepGeom_BSplineSurface {
    constructor(theHandle: Handle_StepGeom_BSplineSurface);
  }

  export declare class Handle_StepGeom_BSplineSurface_4 extends Handle_StepGeom_BSplineSurface {
    constructor(theHandle: Handle_StepGeom_BSplineSurface);
  }

export declare class StepGeom_BSplineSurfaceWithKnots extends StepGeom_BSplineSurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aUMultiplicities: Handle_TColStd_HArray1OfInteger, aVMultiplicities: Handle_TColStd_HArray1OfInteger, aUKnots: Handle_TColStd_HArray1OfReal, aVKnots: Handle_TColStd_HArray1OfReal, aKnotSpec: StepGeom_KnotType): void;
  SetUMultiplicities(aUMultiplicities: Handle_TColStd_HArray1OfInteger): void;
  UMultiplicities(): Handle_TColStd_HArray1OfInteger;
  UMultiplicitiesValue(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbUMultiplicities(): Graphic3d_ZLayerId;
  SetVMultiplicities(aVMultiplicities: Handle_TColStd_HArray1OfInteger): void;
  VMultiplicities(): Handle_TColStd_HArray1OfInteger;
  VMultiplicitiesValue(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbVMultiplicities(): Graphic3d_ZLayerId;
  SetUKnots(aUKnots: Handle_TColStd_HArray1OfReal): void;
  UKnots(): Handle_TColStd_HArray1OfReal;
  UKnotsValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbUKnots(): Graphic3d_ZLayerId;
  SetVKnots(aVKnots: Handle_TColStd_HArray1OfReal): void;
  VKnots(): Handle_TColStd_HArray1OfReal;
  VKnotsValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbVKnots(): Graphic3d_ZLayerId;
  SetKnotSpec(aKnotSpec: StepGeom_KnotType): void;
  KnotSpec(): StepGeom_KnotType;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BSplineSurfaceWithKnots {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BSplineSurfaceWithKnots): void;
  get(): StepGeom_BSplineSurfaceWithKnots;
  delete(): void;
}

  export declare class Handle_StepGeom_BSplineSurfaceWithKnots_1 extends Handle_StepGeom_BSplineSurfaceWithKnots {
    constructor();
  }

  export declare class Handle_StepGeom_BSplineSurfaceWithKnots_2 extends Handle_StepGeom_BSplineSurfaceWithKnots {
    constructor(thePtr: StepGeom_BSplineSurfaceWithKnots);
  }

  export declare class Handle_StepGeom_BSplineSurfaceWithKnots_3 extends Handle_StepGeom_BSplineSurfaceWithKnots {
    constructor(theHandle: Handle_StepGeom_BSplineSurfaceWithKnots);
  }

  export declare class Handle_StepGeom_BSplineSurfaceWithKnots_4 extends Handle_StepGeom_BSplineSurfaceWithKnots {
    constructor(theHandle: Handle_StepGeom_BSplineSurfaceWithKnots);
  }

export declare class StepGeom_CompositeCurveOnSurface extends StepGeom_CompositeCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CompositeCurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CompositeCurveOnSurface): void;
  get(): StepGeom_CompositeCurveOnSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_CompositeCurveOnSurface_1 extends Handle_StepGeom_CompositeCurveOnSurface {
    constructor();
  }

  export declare class Handle_StepGeom_CompositeCurveOnSurface_2 extends Handle_StepGeom_CompositeCurveOnSurface {
    constructor(thePtr: StepGeom_CompositeCurveOnSurface);
  }

  export declare class Handle_StepGeom_CompositeCurveOnSurface_3 extends Handle_StepGeom_CompositeCurveOnSurface {
    constructor(theHandle: Handle_StepGeom_CompositeCurveOnSurface);
  }

  export declare class Handle_StepGeom_CompositeCurveOnSurface_4 extends Handle_StepGeom_CompositeCurveOnSurface {
    constructor(theHandle: Handle_StepGeom_CompositeCurveOnSurface);
  }

export declare class StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface extends StepGeom_BSplineSurface {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aBSplineSurfaceWithKnots: Handle_StepGeom_BSplineSurfaceWithKnots, aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aUDegree: Graphic3d_ZLayerId, aVDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray2OfCartesianPoint, aSurfaceForm: StepGeom_BSplineSurfaceForm, aUClosed: StepData_Logical, aVClosed: StepData_Logical, aSelfIntersect: StepData_Logical, aUMultiplicities: Handle_TColStd_HArray1OfInteger, aVMultiplicities: Handle_TColStd_HArray1OfInteger, aUKnots: Handle_TColStd_HArray1OfReal, aVKnots: Handle_TColStd_HArray1OfReal, aKnotSpec: StepGeom_KnotType, aWeightsData: Handle_TColStd_HArray2OfReal): void;
  SetBSplineSurfaceWithKnots(aBSplineSurfaceWithKnots: Handle_StepGeom_BSplineSurfaceWithKnots): void;
  BSplineSurfaceWithKnots(): Handle_StepGeom_BSplineSurfaceWithKnots;
  SetRationalBSplineSurface(aRationalBSplineSurface: Handle_StepGeom_RationalBSplineSurface): void;
  RationalBSplineSurface(): Handle_StepGeom_RationalBSplineSurface;
  SetUMultiplicities(aUMultiplicities: Handle_TColStd_HArray1OfInteger): void;
  UMultiplicities(): Handle_TColStd_HArray1OfInteger;
  UMultiplicitiesValue(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbUMultiplicities(): Graphic3d_ZLayerId;
  SetVMultiplicities(aVMultiplicities: Handle_TColStd_HArray1OfInteger): void;
  VMultiplicities(): Handle_TColStd_HArray1OfInteger;
  VMultiplicitiesValue(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbVMultiplicities(): Graphic3d_ZLayerId;
  SetUKnots(aUKnots: Handle_TColStd_HArray1OfReal): void;
  UKnots(): Handle_TColStd_HArray1OfReal;
  UKnotsValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbUKnots(): Graphic3d_ZLayerId;
  SetVKnots(aVKnots: Handle_TColStd_HArray1OfReal): void;
  VKnots(): Handle_TColStd_HArray1OfReal;
  VKnotsValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbVKnots(): Graphic3d_ZLayerId;
  SetKnotSpec(aKnotSpec: StepGeom_KnotType): void;
  KnotSpec(): StepGeom_KnotType;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray2OfReal): void;
  WeightsData(): Handle_TColStd_HArray2OfReal;
  WeightsDataValue(num1: Graphic3d_ZLayerId, num2: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsDataI(): Graphic3d_ZLayerId;
  NbWeightsDataJ(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface): void;
  get(): StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_1 extends Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface {
    constructor();
  }

  export declare class Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_2 extends Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface {
    constructor(thePtr: StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_3 extends Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface);
  }

  export declare class Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_4 extends Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface {
    constructor(theHandle: Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface);
  }

export declare class Handle_StepGeom_HArray1OfSurfaceBoundary {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfSurfaceBoundary): void;
  get(): StepGeom_HArray1OfSurfaceBoundary;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfSurfaceBoundary_1 extends Handle_StepGeom_HArray1OfSurfaceBoundary {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfSurfaceBoundary_2 extends Handle_StepGeom_HArray1OfSurfaceBoundary {
    constructor(thePtr: StepGeom_HArray1OfSurfaceBoundary);
  }

  export declare class Handle_StepGeom_HArray1OfSurfaceBoundary_3 extends Handle_StepGeom_HArray1OfSurfaceBoundary {
    constructor(theHandle: Handle_StepGeom_HArray1OfSurfaceBoundary);
  }

  export declare class Handle_StepGeom_HArray1OfSurfaceBoundary_4 extends Handle_StepGeom_HArray1OfSurfaceBoundary {
    constructor(theHandle: Handle_StepGeom_HArray1OfSurfaceBoundary);
  }

export declare class StepGeom_SeamCurve extends StepGeom_SurfaceCurve {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_SeamCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_SeamCurve): void;
  get(): StepGeom_SeamCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_SeamCurve_1 extends Handle_StepGeom_SeamCurve {
    constructor();
  }

  export declare class Handle_StepGeom_SeamCurve_2 extends Handle_StepGeom_SeamCurve {
    constructor(thePtr: StepGeom_SeamCurve);
  }

  export declare class Handle_StepGeom_SeamCurve_3 extends Handle_StepGeom_SeamCurve {
    constructor(theHandle: Handle_StepGeom_SeamCurve);
  }

  export declare class Handle_StepGeom_SeamCurve_4 extends Handle_StepGeom_SeamCurve {
    constructor(theHandle: Handle_StepGeom_SeamCurve);
  }

export declare class StepGeom_CurveOnSurface extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  Pcurve(): Handle_StepGeom_Pcurve;
  SurfaceCurve(): Handle_StepGeom_SurfaceCurve;
  CompositeCurveOnSurface(): Handle_StepGeom_CompositeCurveOnSurface;
  delete(): void;
}

export declare class Handle_StepGeom_CurveReplica {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CurveReplica): void;
  get(): StepGeom_CurveReplica;
  delete(): void;
}

  export declare class Handle_StepGeom_CurveReplica_1 extends Handle_StepGeom_CurveReplica {
    constructor();
  }

  export declare class Handle_StepGeom_CurveReplica_2 extends Handle_StepGeom_CurveReplica {
    constructor(thePtr: StepGeom_CurveReplica);
  }

  export declare class Handle_StepGeom_CurveReplica_3 extends Handle_StepGeom_CurveReplica {
    constructor(theHandle: Handle_StepGeom_CurveReplica);
  }

  export declare class Handle_StepGeom_CurveReplica_4 extends Handle_StepGeom_CurveReplica {
    constructor(theHandle: Handle_StepGeom_CurveReplica);
  }

export declare class StepGeom_CurveReplica extends StepGeom_Curve {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aParentCurve: Handle_StepGeom_Curve, aTransformation: Handle_StepGeom_CartesianTransformationOperator): void;
  SetParentCurve(aParentCurve: Handle_StepGeom_Curve): void;
  ParentCurve(): Handle_StepGeom_Curve;
  SetTransformation(aTransformation: Handle_StepGeom_CartesianTransformationOperator): void;
  Transformation(): Handle_StepGeom_CartesianTransformationOperator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_ToroidalSurface extends StepGeom_ElementarySurface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d, aMajorRadius: Quantity_AbsorbedDose, aMinorRadius: Quantity_AbsorbedDose): void;
  SetMajorRadius(aMajorRadius: Quantity_AbsorbedDose): void;
  MajorRadius(): Quantity_AbsorbedDose;
  SetMinorRadius(aMinorRadius: Quantity_AbsorbedDose): void;
  MinorRadius(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_ToroidalSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_ToroidalSurface): void;
  get(): StepGeom_ToroidalSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_ToroidalSurface_1 extends Handle_StepGeom_ToroidalSurface {
    constructor();
  }

  export declare class Handle_StepGeom_ToroidalSurface_2 extends Handle_StepGeom_ToroidalSurface {
    constructor(thePtr: StepGeom_ToroidalSurface);
  }

  export declare class Handle_StepGeom_ToroidalSurface_3 extends Handle_StepGeom_ToroidalSurface {
    constructor(theHandle: Handle_StepGeom_ToroidalSurface);
  }

  export declare class Handle_StepGeom_ToroidalSurface_4 extends Handle_StepGeom_ToroidalSurface {
    constructor(theHandle: Handle_StepGeom_ToroidalSurface);
  }

export declare class Handle_StepGeom_ElementarySurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_ElementarySurface): void;
  get(): StepGeom_ElementarySurface;
  delete(): void;
}

  export declare class Handle_StepGeom_ElementarySurface_1 extends Handle_StepGeom_ElementarySurface {
    constructor();
  }

  export declare class Handle_StepGeom_ElementarySurface_2 extends Handle_StepGeom_ElementarySurface {
    constructor(thePtr: StepGeom_ElementarySurface);
  }

  export declare class Handle_StepGeom_ElementarySurface_3 extends Handle_StepGeom_ElementarySurface {
    constructor(theHandle: Handle_StepGeom_ElementarySurface);
  }

  export declare class Handle_StepGeom_ElementarySurface_4 extends Handle_StepGeom_ElementarySurface {
    constructor(theHandle: Handle_StepGeom_ElementarySurface);
  }

export declare class StepGeom_ElementarySurface extends StepGeom_Surface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aPosition: Handle_StepGeom_Axis2Placement3d): void;
  SetPosition(aPosition: Handle_StepGeom_Axis2Placement3d): void;
  Position(): Handle_StepGeom_Axis2Placement3d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BoundaryCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BoundaryCurve): void;
  get(): StepGeom_BoundaryCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_BoundaryCurve_1 extends Handle_StepGeom_BoundaryCurve {
    constructor();
  }

  export declare class Handle_StepGeom_BoundaryCurve_2 extends Handle_StepGeom_BoundaryCurve {
    constructor(thePtr: StepGeom_BoundaryCurve);
  }

  export declare class Handle_StepGeom_BoundaryCurve_3 extends Handle_StepGeom_BoundaryCurve {
    constructor(theHandle: Handle_StepGeom_BoundaryCurve);
  }

  export declare class Handle_StepGeom_BoundaryCurve_4 extends Handle_StepGeom_BoundaryCurve {
    constructor(theHandle: Handle_StepGeom_BoundaryCurve);
  }

export declare class StepGeom_BoundaryCurve extends StepGeom_CompositeCurveOnSurface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_BoundedSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BoundedSurface): void;
  get(): StepGeom_BoundedSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_BoundedSurface_1 extends Handle_StepGeom_BoundedSurface {
    constructor();
  }

  export declare class Handle_StepGeom_BoundedSurface_2 extends Handle_StepGeom_BoundedSurface {
    constructor(thePtr: StepGeom_BoundedSurface);
  }

  export declare class Handle_StepGeom_BoundedSurface_3 extends Handle_StepGeom_BoundedSurface {
    constructor(theHandle: Handle_StepGeom_BoundedSurface);
  }

  export declare class Handle_StepGeom_BoundedSurface_4 extends Handle_StepGeom_BoundedSurface {
    constructor(theHandle: Handle_StepGeom_BoundedSurface);
  }

export declare class StepGeom_BoundedSurface extends StepGeom_Surface {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_HArray1OfCompositeCurveSegment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_HArray1OfCompositeCurveSegment): void;
  get(): StepGeom_HArray1OfCompositeCurveSegment;
  delete(): void;
}

  export declare class Handle_StepGeom_HArray1OfCompositeCurveSegment_1 extends Handle_StepGeom_HArray1OfCompositeCurveSegment {
    constructor();
  }

  export declare class Handle_StepGeom_HArray1OfCompositeCurveSegment_2 extends Handle_StepGeom_HArray1OfCompositeCurveSegment {
    constructor(thePtr: StepGeom_HArray1OfCompositeCurveSegment);
  }

  export declare class Handle_StepGeom_HArray1OfCompositeCurveSegment_3 extends Handle_StepGeom_HArray1OfCompositeCurveSegment {
    constructor(theHandle: Handle_StepGeom_HArray1OfCompositeCurveSegment);
  }

  export declare class Handle_StepGeom_HArray1OfCompositeCurveSegment_4 extends Handle_StepGeom_HArray1OfCompositeCurveSegment {
    constructor(theHandle: Handle_StepGeom_HArray1OfCompositeCurveSegment);
  }

export declare class StepGeom_SurfaceBoundary extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  BoundaryCurve(): Handle_StepGeom_BoundaryCurve;
  DegeneratePcurve(): Handle_StepGeom_DegeneratePcurve;
  delete(): void;
}

export declare class StepGeom_Array1OfTrimmingSelect {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepGeom_TrimmingSelect): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepGeom_Array1OfTrimmingSelect): StepGeom_Array1OfTrimmingSelect;
  Move(theOther: StepGeom_Array1OfTrimmingSelect): StepGeom_Array1OfTrimmingSelect;
  First(): StepGeom_TrimmingSelect;
  ChangeFirst(): StepGeom_TrimmingSelect;
  Last(): StepGeom_TrimmingSelect;
  ChangeLast(): StepGeom_TrimmingSelect;
  Value(theIndex: Standard_Integer): StepGeom_TrimmingSelect;
  ChangeValue(theIndex: Standard_Integer): StepGeom_TrimmingSelect;
  SetValue(theIndex: Standard_Integer, theItem: StepGeom_TrimmingSelect): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepGeom_Array1OfTrimmingSelect_1 extends StepGeom_Array1OfTrimmingSelect {
    constructor();
  }

  export declare class StepGeom_Array1OfTrimmingSelect_2 extends StepGeom_Array1OfTrimmingSelect {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepGeom_Array1OfTrimmingSelect_3 extends StepGeom_Array1OfTrimmingSelect {
    constructor(theOther: StepGeom_Array1OfTrimmingSelect);
  }

  export declare class StepGeom_Array1OfTrimmingSelect_4 extends StepGeom_Array1OfTrimmingSelect {
    constructor(theOther: StepGeom_Array1OfTrimmingSelect);
  }

  export declare class StepGeom_Array1OfTrimmingSelect_5 extends StepGeom_Array1OfTrimmingSelect {
    constructor(theBegin: StepGeom_TrimmingSelect, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepGeom_BezierCurveAndRationalBSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_BezierCurveAndRationalBSplineCurve): void;
  get(): StepGeom_BezierCurveAndRationalBSplineCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_BezierCurveAndRationalBSplineCurve_1 extends Handle_StepGeom_BezierCurveAndRationalBSplineCurve {
    constructor();
  }

  export declare class Handle_StepGeom_BezierCurveAndRationalBSplineCurve_2 extends Handle_StepGeom_BezierCurveAndRationalBSplineCurve {
    constructor(thePtr: StepGeom_BezierCurveAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_BezierCurveAndRationalBSplineCurve_3 extends Handle_StepGeom_BezierCurveAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_BezierCurveAndRationalBSplineCurve);
  }

  export declare class Handle_StepGeom_BezierCurveAndRationalBSplineCurve_4 extends Handle_StepGeom_BezierCurveAndRationalBSplineCurve {
    constructor(theHandle: Handle_StepGeom_BezierCurveAndRationalBSplineCurve);
  }

export declare class StepGeom_BezierCurveAndRationalBSplineCurve extends StepGeom_BSplineCurve {
  constructor()
  Init_1(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aBezierCurve: Handle_StepGeom_BezierCurve, aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  Init_2(aName: Handle_TCollection_HAsciiString, aDegree: Graphic3d_ZLayerId, aControlPointsList: Handle_StepGeom_HArray1OfCartesianPoint, aCurveForm: StepGeom_BSplineCurveForm, aClosedCurve: StepData_Logical, aSelfIntersect: StepData_Logical, aWeightsData: Handle_TColStd_HArray1OfReal): void;
  SetBezierCurve(aBezierCurve: Handle_StepGeom_BezierCurve): void;
  BezierCurve(): Handle_StepGeom_BezierCurve;
  SetRationalBSplineCurve(aRationalBSplineCurve: Handle_StepGeom_RationalBSplineCurve): void;
  RationalBSplineCurve(): Handle_StepGeom_RationalBSplineCurve;
  SetWeightsData(aWeightsData: Handle_TColStd_HArray1OfReal): void;
  WeightsData(): Handle_TColStd_HArray1OfReal;
  WeightsDataValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbWeightsData(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_Direction extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aDirectionRatios: Handle_TColStd_HArray1OfReal): void;
  SetDirectionRatios(aDirectionRatios: Handle_TColStd_HArray1OfReal): void;
  DirectionRatios(): Handle_TColStd_HArray1OfReal;
  DirectionRatiosValue(num: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  NbDirectionRatios(): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_Direction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_Direction): void;
  get(): StepGeom_Direction;
  delete(): void;
}

  export declare class Handle_StepGeom_Direction_1 extends Handle_StepGeom_Direction {
    constructor();
  }

  export declare class Handle_StepGeom_Direction_2 extends Handle_StepGeom_Direction {
    constructor(thePtr: StepGeom_Direction);
  }

  export declare class Handle_StepGeom_Direction_3 extends Handle_StepGeom_Direction {
    constructor(theHandle: Handle_StepGeom_Direction);
  }

  export declare class Handle_StepGeom_Direction_4 extends Handle_StepGeom_Direction {
    constructor(theHandle: Handle_StepGeom_Direction);
  }

export declare class StepGeom_PointReplica extends StepGeom_Point {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aParentPt: Handle_StepGeom_Point, aTransformation: Handle_StepGeom_CartesianTransformationOperator): void;
  SetParentPt(aParentPt: Handle_StepGeom_Point): void;
  ParentPt(): Handle_StepGeom_Point;
  SetTransformation(aTransformation: Handle_StepGeom_CartesianTransformationOperator): void;
  Transformation(): Handle_StepGeom_CartesianTransformationOperator;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_PointReplica {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_PointReplica): void;
  get(): StepGeom_PointReplica;
  delete(): void;
}

  export declare class Handle_StepGeom_PointReplica_1 extends Handle_StepGeom_PointReplica {
    constructor();
  }

  export declare class Handle_StepGeom_PointReplica_2 extends Handle_StepGeom_PointReplica {
    constructor(thePtr: StepGeom_PointReplica);
  }

  export declare class Handle_StepGeom_PointReplica_3 extends Handle_StepGeom_PointReplica {
    constructor(theHandle: Handle_StepGeom_PointReplica);
  }

  export declare class Handle_StepGeom_PointReplica_4 extends Handle_StepGeom_PointReplica {
    constructor(theHandle: Handle_StepGeom_PointReplica);
  }

export declare class Handle_StepGeom_PointOnCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_PointOnCurve): void;
  get(): StepGeom_PointOnCurve;
  delete(): void;
}

  export declare class Handle_StepGeom_PointOnCurve_1 extends Handle_StepGeom_PointOnCurve {
    constructor();
  }

  export declare class Handle_StepGeom_PointOnCurve_2 extends Handle_StepGeom_PointOnCurve {
    constructor(thePtr: StepGeom_PointOnCurve);
  }

  export declare class Handle_StepGeom_PointOnCurve_3 extends Handle_StepGeom_PointOnCurve {
    constructor(theHandle: Handle_StepGeom_PointOnCurve);
  }

  export declare class Handle_StepGeom_PointOnCurve_4 extends Handle_StepGeom_PointOnCurve {
    constructor(theHandle: Handle_StepGeom_PointOnCurve);
  }

export declare class StepGeom_PointOnCurve extends StepGeom_Point {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisCurve: Handle_StepGeom_Curve, aPointParameter: Quantity_AbsorbedDose): void;
  SetBasisCurve(aBasisCurve: Handle_StepGeom_Curve): void;
  BasisCurve(): Handle_StepGeom_Curve;
  SetPointParameter(aPointParameter: Quantity_AbsorbedDose): void;
  PointParameter(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepGeom_CartesianTransformationOperator extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, hasAaxis1: Standard_Boolean, aAxis1: Handle_StepGeom_Direction, hasAaxis2: Standard_Boolean, aAxis2: Handle_StepGeom_Direction, aLocalOrigin: Handle_StepGeom_CartesianPoint, hasAscale: Standard_Boolean, aScale: Quantity_AbsorbedDose): void;
  SetAxis1(aAxis1: Handle_StepGeom_Direction): void;
  UnSetAxis1(): void;
  Axis1(): Handle_StepGeom_Direction;
  HasAxis1(): Standard_Boolean;
  SetAxis2(aAxis2: Handle_StepGeom_Direction): void;
  UnSetAxis2(): void;
  Axis2(): Handle_StepGeom_Direction;
  HasAxis2(): Standard_Boolean;
  SetLocalOrigin(aLocalOrigin: Handle_StepGeom_CartesianPoint): void;
  LocalOrigin(): Handle_StepGeom_CartesianPoint;
  SetScale(aScale: Quantity_AbsorbedDose): void;
  UnSetScale(): void;
  Scale(): Quantity_AbsorbedDose;
  HasScale(): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_CartesianTransformationOperator {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_CartesianTransformationOperator): void;
  get(): StepGeom_CartesianTransformationOperator;
  delete(): void;
}

  export declare class Handle_StepGeom_CartesianTransformationOperator_1 extends Handle_StepGeom_CartesianTransformationOperator {
    constructor();
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator_2 extends Handle_StepGeom_CartesianTransformationOperator {
    constructor(thePtr: StepGeom_CartesianTransformationOperator);
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator_3 extends Handle_StepGeom_CartesianTransformationOperator {
    constructor(theHandle: Handle_StepGeom_CartesianTransformationOperator);
  }

  export declare class Handle_StepGeom_CartesianTransformationOperator_4 extends Handle_StepGeom_CartesianTransformationOperator {
    constructor(theHandle: Handle_StepGeom_CartesianTransformationOperator);
  }

export declare class StepGeom_OffsetSurface extends StepGeom_Surface {
  constructor()
  Init(aName: Handle_TCollection_HAsciiString, aBasisSurface: Handle_StepGeom_Surface, aDistance: Quantity_AbsorbedDose, aSelfIntersect: StepData_Logical): void;
  SetBasisSurface(aBasisSurface: Handle_StepGeom_Surface): void;
  BasisSurface(): Handle_StepGeom_Surface;
  SetDistance(aDistance: Quantity_AbsorbedDose): void;
  Distance(): Quantity_AbsorbedDose;
  SetSelfIntersect(aSelfIntersect: StepData_Logical): void;
  SelfIntersect(): StepData_Logical;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepGeom_OffsetSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepGeom_OffsetSurface): void;
  get(): StepGeom_OffsetSurface;
  delete(): void;
}

  export declare class Handle_StepGeom_OffsetSurface_1 extends Handle_StepGeom_OffsetSurface {
    constructor();
  }

  export declare class Handle_StepGeom_OffsetSurface_2 extends Handle_StepGeom_OffsetSurface {
    constructor(thePtr: StepGeom_OffsetSurface);
  }

  export declare class Handle_StepGeom_OffsetSurface_3 extends Handle_StepGeom_OffsetSurface {
    constructor(theHandle: Handle_StepGeom_OffsetSurface);
  }

  export declare class Handle_StepGeom_OffsetSurface_4 extends Handle_StepGeom_OffsetSurface {
    constructor(theHandle: Handle_StepGeom_OffsetSurface);
  }

export declare class Draft_FaceInfo {
  RootFace_1(F: TopoDS_Face): void;
  NewGeometry(): Standard_Boolean;
  Add(F: TopoDS_Face): void;
  FirstFace(): TopoDS_Face;
  SecondFace(): TopoDS_Face;
  Geometry(): Handle_Geom_Surface;
  ChangeGeometry(): Handle_Geom_Surface;
  RootFace_2(): TopoDS_Face;
  ChangeCurve(): Handle_Geom_Curve;
  Curve(): Handle_Geom_Curve;
  delete(): void;
}

  export declare class Draft_FaceInfo_1 extends Draft_FaceInfo {
    constructor();
  }

  export declare class Draft_FaceInfo_2 extends Draft_FaceInfo {
    constructor(S: Handle_Geom_Surface, HasNewGeometry: Standard_Boolean);
  }

export declare class Draft_IndexedDataMapOfFaceFaceInfo extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Draft_IndexedDataMapOfFaceFaceInfo): void;
  Assign(theOther: Draft_IndexedDataMapOfFaceFaceInfo): Draft_IndexedDataMapOfFaceFaceInfo;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Face, theItem: Draft_FaceInfo): Standard_Integer;
  Contains(theKey1: TopoDS_Face): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Face, theItem: Draft_FaceInfo): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Face): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Face;
  FindFromIndex(theIndex: Standard_Integer): Draft_FaceInfo;
  ChangeFromIndex(theIndex: Standard_Integer): Draft_FaceInfo;
  FindIndex(theKey1: TopoDS_Face): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Face): Draft_FaceInfo;
  Seek(theKey1: TopoDS_Face): Draft_FaceInfo;
  ChangeSeek(theKey1: TopoDS_Face): Draft_FaceInfo;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Draft_IndexedDataMapOfFaceFaceInfo_1 extends Draft_IndexedDataMapOfFaceFaceInfo {
    constructor();
  }

  export declare class Draft_IndexedDataMapOfFaceFaceInfo_2 extends Draft_IndexedDataMapOfFaceFaceInfo {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Draft_IndexedDataMapOfFaceFaceInfo_3 extends Draft_IndexedDataMapOfFaceFaceInfo {
    constructor(theOther: Draft_IndexedDataMapOfFaceFaceInfo);
  }

export declare type Draft_ErrorStatus = {
  Draft_NoError: {};
  Draft_FaceRecomputation: {};
  Draft_EdgeRecomputation: {};
  Draft_VertexRecomputation: {};
}

export declare class Draft_IndexedDataMapOfEdgeEdgeInfo extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Draft_IndexedDataMapOfEdgeEdgeInfo): void;
  Assign(theOther: Draft_IndexedDataMapOfEdgeEdgeInfo): Draft_IndexedDataMapOfEdgeEdgeInfo;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Edge, theItem: Draft_EdgeInfo): Standard_Integer;
  Contains(theKey1: TopoDS_Edge): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Edge, theItem: Draft_EdgeInfo): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Edge): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Edge;
  FindFromIndex(theIndex: Standard_Integer): Draft_EdgeInfo;
  ChangeFromIndex(theIndex: Standard_Integer): Draft_EdgeInfo;
  FindIndex(theKey1: TopoDS_Edge): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Edge): Draft_EdgeInfo;
  Seek(theKey1: TopoDS_Edge): Draft_EdgeInfo;
  ChangeSeek(theKey1: TopoDS_Edge): Draft_EdgeInfo;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Draft_IndexedDataMapOfEdgeEdgeInfo_1 extends Draft_IndexedDataMapOfEdgeEdgeInfo {
    constructor();
  }

  export declare class Draft_IndexedDataMapOfEdgeEdgeInfo_2 extends Draft_IndexedDataMapOfEdgeEdgeInfo {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Draft_IndexedDataMapOfEdgeEdgeInfo_3 extends Draft_IndexedDataMapOfEdgeEdgeInfo {
    constructor(theOther: Draft_IndexedDataMapOfEdgeEdgeInfo);
  }

export declare class Draft_VertexInfo {
  constructor()
  Add(E: TopoDS_Edge): void;
  Geometry(): gp_Pnt;
  Parameter(E: TopoDS_Edge): Quantity_AbsorbedDose;
  InitEdgeIterator(): void;
  Edge(): TopoDS_Edge;
  NextEdge(): void;
  MoreEdge(): Standard_Boolean;
  ChangeGeometry(): gp_Pnt;
  ChangeParameter(E: TopoDS_Edge): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Draft_IndexedDataMapOfVertexVertexInfo extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: Draft_IndexedDataMapOfVertexVertexInfo): void;
  Assign(theOther: Draft_IndexedDataMapOfVertexVertexInfo): Draft_IndexedDataMapOfVertexVertexInfo;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Vertex, theItem: Draft_VertexInfo): Standard_Integer;
  Contains(theKey1: TopoDS_Vertex): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Vertex, theItem: Draft_VertexInfo): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Vertex): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Vertex;
  FindFromIndex(theIndex: Standard_Integer): Draft_VertexInfo;
  ChangeFromIndex(theIndex: Standard_Integer): Draft_VertexInfo;
  FindIndex(theKey1: TopoDS_Vertex): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Vertex): Draft_VertexInfo;
  Seek(theKey1: TopoDS_Vertex): Draft_VertexInfo;
  ChangeSeek(theKey1: TopoDS_Vertex): Draft_VertexInfo;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class Draft_IndexedDataMapOfVertexVertexInfo_1 extends Draft_IndexedDataMapOfVertexVertexInfo {
    constructor();
  }

  export declare class Draft_IndexedDataMapOfVertexVertexInfo_2 extends Draft_IndexedDataMapOfVertexVertexInfo {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class Draft_IndexedDataMapOfVertexVertexInfo_3 extends Draft_IndexedDataMapOfVertexVertexInfo {
    constructor(theOther: Draft_IndexedDataMapOfVertexVertexInfo);
  }

export declare class Draft_EdgeInfo {
  Add(F: TopoDS_Face): void;
  RootFace_1(F: TopoDS_Face): void;
  Tangent(P: gp_Pnt): void;
  IsTangent(P: gp_Pnt): Standard_Boolean;
  NewGeometry(): Standard_Boolean;
  SetNewGeometry(NewGeom: Standard_Boolean): void;
  Geometry(): Handle_Geom_Curve;
  FirstFace(): TopoDS_Face;
  SecondFace(): TopoDS_Face;
  FirstPC(): Handle_Geom2d_Curve;
  SecondPC(): Handle_Geom2d_Curve;
  ChangeGeometry(): Handle_Geom_Curve;
  ChangeFirstPC(): Handle_Geom2d_Curve;
  ChangeSecondPC(): Handle_Geom2d_Curve;
  RootFace_2(): TopoDS_Face;
  Tolerance_1(tol: Quantity_AbsorbedDose): void;
  Tolerance_2(): Quantity_AbsorbedDose;
  delete(): void;
}

  export declare class Draft_EdgeInfo_1 extends Draft_EdgeInfo {
    constructor();
  }

  export declare class Draft_EdgeInfo_2 extends Draft_EdgeInfo {
    constructor(HasNewGeometry: Standard_Boolean);
  }

export declare class Handle_Draft_Modification {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Draft_Modification): void;
  get(): Draft_Modification;
  delete(): void;
}

  export declare class Handle_Draft_Modification_1 extends Handle_Draft_Modification {
    constructor();
  }

  export declare class Handle_Draft_Modification_2 extends Handle_Draft_Modification {
    constructor(thePtr: Draft_Modification);
  }

  export declare class Handle_Draft_Modification_3 extends Handle_Draft_Modification {
    constructor(theHandle: Handle_Draft_Modification);
  }

  export declare class Handle_Draft_Modification_4 extends Handle_Draft_Modification {
    constructor(theHandle: Handle_Draft_Modification);
  }

export declare class Draft_Modification extends BRepTools_Modification {
  constructor(S: TopoDS_Shape)
  Clear(): void;
  Init(S: TopoDS_Shape): void;
  Add(F: TopoDS_Face, Direction: gp_Dir, Angle: Quantity_AbsorbedDose, NeutralPlane: gp_Pln, Flag: Standard_Boolean): Standard_Boolean;
  Remove(F: TopoDS_Face): void;
  Perform(): void;
  IsDone(): Standard_Boolean;
  Error(): Draft_ErrorStatus;
  ProblematicShape(): TopoDS_Shape;
  ConnectedFaces(F: TopoDS_Face): TopTools_ListOfShape;
  ModifiedFaces(): TopTools_ListOfShape;
  NewSurface_1(F: TopoDS_Face, S: Handle_Geom_Surface, L: TopLoc_Location, Tol: Quantity_AbsorbedDose, RevWires: Standard_Boolean, RevFace: Standard_Boolean): Standard_Boolean;
  NewCurve_1(E: TopoDS_Edge, C: Handle_Geom_Curve, L: TopLoc_Location, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewPoint(V: TopoDS_Vertex, P: gp_Pnt, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewCurve2d(E: TopoDS_Edge, F: TopoDS_Face, NewE: TopoDS_Edge, NewF: TopoDS_Face, C: Handle_Geom2d_Curve, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  NewParameter(V: TopoDS_Vertex, E: TopoDS_Edge, P: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Standard_Boolean;
  Continuity(E: TopoDS_Edge, F1: TopoDS_Face, F2: TopoDS_Face, NewE: TopoDS_Edge, NewF1: TopoDS_Face, NewF2: TopoDS_Face): GeomAbs_Shape;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Draft {
  constructor();
  static Angle(F: TopoDS_Face, Direction: gp_Dir): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class AdvApprox_Cutting {
  Value(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose, cuttingvalue: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class AdvApprox_SimpleApprox {
  constructor(TotalDimension: Graphic3d_ZLayerId, TotalNumSS: Graphic3d_ZLayerId, Continuity: GeomAbs_Shape, WorkDegree: Graphic3d_ZLayerId, NbGaussPoints: Graphic3d_ZLayerId, JacobiBase: Handle_PLib_JacobiPolynomial, Func: AdvApprox_EvaluatorFunction)
  Perform(LocalDimension: TColStd_Array1OfInteger, LocalTolerancesArray: TColStd_Array1OfReal, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, MaxDegree: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  Degree(): Graphic3d_ZLayerId;
  Coefficients(): Handle_TColStd_HArray1OfReal;
  FirstConstr(): Handle_TColStd_HArray2OfReal;
  LastConstr(): Handle_TColStd_HArray2OfReal;
  SomTab(): Handle_TColStd_HArray1OfReal;
  DifTab(): Handle_TColStd_HArray1OfReal;
  MaxError(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  AverageError(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

export declare class AdvApprox_DichoCutting extends AdvApprox_Cutting {
  constructor()
  Value(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose, cuttingvalue: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class AdvApprox_PrefCutting extends AdvApprox_Cutting {
  constructor(CutPnts: TColStd_Array1OfReal)
  Value(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose, cuttingvalue: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class AdvApprox_ApproxAFunction {
  static Approximation(TotalDimension: Graphic3d_ZLayerId, TotalNumSS: Graphic3d_ZLayerId, LocalDimension: TColStd_Array1OfInteger, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Evaluator: AdvApprox_EvaluatorFunction, CutTool: AdvApprox_Cutting, ContinuityOrder: Graphic3d_ZLayerId, NumMaxCoeffs: Graphic3d_ZLayerId, MaxSegments: Graphic3d_ZLayerId, TolerancesArray: TColStd_Array1OfReal, code_precis: Graphic3d_ZLayerId, NumCurves: Graphic3d_ZLayerId, NumCoeffPerCurveArray: TColStd_Array1OfInteger, LocalCoefficientArray: TColStd_Array1OfReal, IntervalsArray: TColStd_Array1OfReal, ErrorMaxArray: TColStd_Array1OfReal, AverageErrorArray: TColStd_Array1OfReal, ErrorCode: Graphic3d_ZLayerId): void;
  IsDone(): Standard_Boolean;
  HasResult(): Standard_Boolean;
  Poles1d_1(): Handle_TColStd_HArray2OfReal;
  Poles2d_1(): Handle_TColgp_HArray2OfPnt2d;
  Poles_1(): Handle_TColgp_HArray2OfPnt;
  NbPoles(): Graphic3d_ZLayerId;
  Poles1d_2(Index: Graphic3d_ZLayerId, P: TColStd_Array1OfReal): void;
  Poles2d_2(Index: Graphic3d_ZLayerId, P: TColgp_Array1OfPnt2d): void;
  Poles_2(Index: Graphic3d_ZLayerId, P: TColgp_Array1OfPnt): void;
  Degree(): Graphic3d_ZLayerId;
  NbKnots(): Graphic3d_ZLayerId;
  NumSubSpaces(Dimension: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Knots(): Handle_TColStd_HArray1OfReal;
  Multiplicities(): Handle_TColStd_HArray1OfInteger;
  MaxError_1(Dimension: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  AverageError_1(Dimension: Graphic3d_ZLayerId): Handle_TColStd_HArray1OfReal;
  MaxError_2(Dimension: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  AverageError_2(Dimension: Graphic3d_ZLayerId, Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Dump(o: Standard_OStream): void;
  delete(): void;
}

  export declare class AdvApprox_ApproxAFunction_1 extends AdvApprox_ApproxAFunction {
    constructor(Num1DSS: Graphic3d_ZLayerId, Num2DSS: Graphic3d_ZLayerId, Num3DSS: Graphic3d_ZLayerId, OneDTol: Handle_TColStd_HArray1OfReal, TwoDTol: Handle_TColStd_HArray1OfReal, ThreeDTol: Handle_TColStd_HArray1OfReal, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDeg: Graphic3d_ZLayerId, MaxSeg: Graphic3d_ZLayerId, Func: AdvApprox_EvaluatorFunction);
  }

  export declare class AdvApprox_ApproxAFunction_2 extends AdvApprox_ApproxAFunction {
    constructor(Num1DSS: Graphic3d_ZLayerId, Num2DSS: Graphic3d_ZLayerId, Num3DSS: Graphic3d_ZLayerId, OneDTol: Handle_TColStd_HArray1OfReal, TwoDTol: Handle_TColStd_HArray1OfReal, ThreeDTol: Handle_TColStd_HArray1OfReal, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxDeg: Graphic3d_ZLayerId, MaxSeg: Graphic3d_ZLayerId, Func: AdvApprox_EvaluatorFunction, CutTool: AdvApprox_Cutting);
  }

export declare class AdvApprox_EvaluatorFunction {
  Evaluate(Dimension: Graphic3d_ZLayerId, StartEnd: Standard_Real [2], Parameter: Quantity_AbsorbedDose, DerivativeRequest: Graphic3d_ZLayerId, Result: Quantity_AbsorbedDose, ErrorCode: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class AdvApprox_PrefAndRec extends AdvApprox_Cutting {
  constructor(RecomendedCut: TColStd_Array1OfReal, PrefferedCut: TColStd_Array1OfReal, Weight: Quantity_AbsorbedDose)
  Value(a: Quantity_AbsorbedDose, b: Quantity_AbsorbedDose, cuttingvalue: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare class StdObjMgt_ReadData {
  constructor(theDriver: Handle_Storage_BaseDriver, theNumberOfObjects: Graphic3d_ZLayerId)
  ReadPersistentObject(theRef: Graphic3d_ZLayerId): void;
  PersistentObject(theRef: Graphic3d_ZLayerId): any;
  ReadReference(): any;
  delete(): void;
}

export declare class StdObjMgt_Persistent extends Standard_Transient {
  Read(theReadData: StdObjMgt_ReadData): void;
  Write(theWriteData: StdObjMgt_WriteData): void;
  PChildren(a0: any): void;
  PName(): Standard_CString;
  ImportDocument(theDocument: Handle_TDocStd_Document): void;
  CreateAttribute(): Handle_TDF_Attribute;
  GetAttribute(): Handle_TDF_Attribute;
  ImportAttribute(): void;
  AsciiString(): Handle_TCollection_HAsciiString;
  ExtString(): Handle_TCollection_HExtendedString;
  Label(theDF: Handle_TDF_Data): TDF_Label;
  TypeNum_1(): Graphic3d_ZLayerId;
  TypeNum_2(theTypeNum: Graphic3d_ZLayerId): void;
  RefNum_1(): Graphic3d_ZLayerId;
  RefNum_2(theRefNum: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class StdObjMgt_MapOfInstantiators {
  constructor();
  delete(): void;
}

export declare class StdObjMgt_WriteData {
  constructor(theDriver: Handle_Storage_BaseDriver)
  WritePersistentObject(thePersistent: any): void;
  delete(): void;
}

export declare class StdObjMgt_SharedObject {
  constructor();
  delete(): void;
}

export declare class TopCnx_EdgeFaceTransition {
  constructor()
  Reset_1(Tgt: gp_Dir, Norm: gp_Dir, Curv: Quantity_AbsorbedDose): void;
  Reset_2(Tgt: gp_Dir): void;
  AddInterference(Tole: Quantity_AbsorbedDose, Tang: gp_Dir, Norm: gp_Dir, Curv: Quantity_AbsorbedDose, Or: TopAbs_Orientation, Tr: TopAbs_Orientation, BTr: TopAbs_Orientation): void;
  Transition(): TopAbs_Orientation;
  BoundaryTransition(): TopAbs_Orientation;
  delete(): void;
}

export declare class Handle_Expr_LogOfe {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_LogOfe): void;
  get(): Expr_LogOfe;
  delete(): void;
}

  export declare class Handle_Expr_LogOfe_1 extends Handle_Expr_LogOfe {
    constructor();
  }

  export declare class Handle_Expr_LogOfe_2 extends Handle_Expr_LogOfe {
    constructor(thePtr: Expr_LogOfe);
  }

  export declare class Handle_Expr_LogOfe_3 extends Handle_Expr_LogOfe {
    constructor(theHandle: Handle_Expr_LogOfe);
  }

  export declare class Handle_Expr_LogOfe_4 extends Handle_Expr_LogOfe {
    constructor(theHandle: Handle_Expr_LogOfe);
  }

export declare class Expr_LogOfe extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_GeneralFunction extends Standard_Transient {
  NbOfVariables(): Graphic3d_ZLayerId;
  Variable(index: Graphic3d_ZLayerId): Handle_Expr_NamedUnknown;
  Copy(): Handle_Expr_GeneralFunction;
  Derivative_1(var_: Handle_Expr_NamedUnknown): Handle_Expr_GeneralFunction;
  Derivative_2(var_: Handle_Expr_NamedUnknown, deg: Graphic3d_ZLayerId): Handle_Expr_GeneralFunction;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  IsIdentical(func: Handle_Expr_GeneralFunction): Standard_Boolean;
  IsLinearOnVariable(index: Graphic3d_ZLayerId): Standard_Boolean;
  GetStringName(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_GeneralFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_GeneralFunction): void;
  get(): Expr_GeneralFunction;
  delete(): void;
}

  export declare class Handle_Expr_GeneralFunction_1 extends Handle_Expr_GeneralFunction {
    constructor();
  }

  export declare class Handle_Expr_GeneralFunction_2 extends Handle_Expr_GeneralFunction {
    constructor(thePtr: Expr_GeneralFunction);
  }

  export declare class Handle_Expr_GeneralFunction_3 extends Handle_Expr_GeneralFunction {
    constructor(theHandle: Handle_Expr_GeneralFunction);
  }

  export declare class Handle_Expr_GeneralFunction_4 extends Handle_Expr_GeneralFunction {
    constructor(theHandle: Handle_Expr_GeneralFunction);
  }

export declare class Expr_NotEvaluable extends Expr_ExprFailure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Expr_NotEvaluable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_NotEvaluable_1 extends Expr_NotEvaluable {
    constructor();
  }

  export declare class Expr_NotEvaluable_2 extends Expr_NotEvaluable {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Expr_NotEvaluable {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NotEvaluable): void;
  get(): Expr_NotEvaluable;
  delete(): void;
}

  export declare class Handle_Expr_NotEvaluable_1 extends Handle_Expr_NotEvaluable {
    constructor();
  }

  export declare class Handle_Expr_NotEvaluable_2 extends Handle_Expr_NotEvaluable {
    constructor(thePtr: Expr_NotEvaluable);
  }

  export declare class Handle_Expr_NotEvaluable_3 extends Handle_Expr_NotEvaluable {
    constructor(theHandle: Handle_Expr_NotEvaluable);
  }

  export declare class Handle_Expr_NotEvaluable_4 extends Handle_Expr_NotEvaluable {
    constructor(theHandle: Handle_Expr_NotEvaluable);
  }

export declare class Expr_LessThan extends Expr_SingleRelation {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_LessThan {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_LessThan): void;
  get(): Expr_LessThan;
  delete(): void;
}

  export declare class Handle_Expr_LessThan_1 extends Handle_Expr_LessThan {
    constructor();
  }

  export declare class Handle_Expr_LessThan_2 extends Handle_Expr_LessThan {
    constructor(thePtr: Expr_LessThan);
  }

  export declare class Handle_Expr_LessThan_3 extends Handle_Expr_LessThan {
    constructor(theHandle: Handle_Expr_LessThan);
  }

  export declare class Handle_Expr_LessThan_4 extends Handle_Expr_LessThan {
    constructor(theHandle: Handle_Expr_LessThan);
  }

export declare class Handle_Expr_NotAssigned {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NotAssigned): void;
  get(): Expr_NotAssigned;
  delete(): void;
}

  export declare class Handle_Expr_NotAssigned_1 extends Handle_Expr_NotAssigned {
    constructor();
  }

  export declare class Handle_Expr_NotAssigned_2 extends Handle_Expr_NotAssigned {
    constructor(thePtr: Expr_NotAssigned);
  }

  export declare class Handle_Expr_NotAssigned_3 extends Handle_Expr_NotAssigned {
    constructor(theHandle: Handle_Expr_NotAssigned);
  }

  export declare class Handle_Expr_NotAssigned_4 extends Handle_Expr_NotAssigned {
    constructor(theHandle: Handle_Expr_NotAssigned);
  }

export declare class Expr_NotAssigned extends Expr_ExprFailure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Expr_NotAssigned;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_NotAssigned_1 extends Expr_NotAssigned {
    constructor();
  }

  export declare class Expr_NotAssigned_2 extends Expr_NotAssigned {
    constructor(theMessage: Standard_CString);
  }

export declare class Expr_Square extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Square {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Square): void;
  get(): Expr_Square;
  delete(): void;
}

  export declare class Handle_Expr_Square_1 extends Handle_Expr_Square {
    constructor();
  }

  export declare class Handle_Expr_Square_2 extends Handle_Expr_Square {
    constructor(thePtr: Expr_Square);
  }

  export declare class Handle_Expr_Square_3 extends Handle_Expr_Square {
    constructor(theHandle: Handle_Expr_Square);
  }

  export declare class Handle_Expr_Square_4 extends Handle_Expr_Square {
    constructor(theHandle: Handle_Expr_Square);
  }

export declare class Expr_Difference extends Expr_BinaryExpression {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  NDerivative(X: Handle_Expr_NamedUnknown, N: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Difference {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Difference): void;
  get(): Expr_Difference;
  delete(): void;
}

  export declare class Handle_Expr_Difference_1 extends Handle_Expr_Difference {
    constructor();
  }

  export declare class Handle_Expr_Difference_2 extends Handle_Expr_Difference {
    constructor(thePtr: Expr_Difference);
  }

  export declare class Handle_Expr_Difference_3 extends Handle_Expr_Difference {
    constructor(theHandle: Handle_Expr_Difference);
  }

  export declare class Handle_Expr_Difference_4 extends Handle_Expr_Difference {
    constructor(theHandle: Handle_Expr_Difference);
  }

export declare class Handle_Expr_Product {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Product): void;
  get(): Expr_Product;
  delete(): void;
}

  export declare class Handle_Expr_Product_1 extends Handle_Expr_Product {
    constructor();
  }

  export declare class Handle_Expr_Product_2 extends Handle_Expr_Product {
    constructor(thePtr: Expr_Product);
  }

  export declare class Handle_Expr_Product_3 extends Handle_Expr_Product {
    constructor(theHandle: Handle_Expr_Product);
  }

  export declare class Handle_Expr_Product_4 extends Handle_Expr_Product {
    constructor(theHandle: Handle_Expr_Product);
  }

export declare class Expr_Product extends Expr_PolyExpression {
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_Product_1 extends Expr_Product {
    constructor(exps: Expr_SequenceOfGeneralExpression);
  }

  export declare class Expr_Product_2 extends Expr_Product {
    constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression);
  }

export declare class Handle_Expr_BinaryExpression {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_BinaryExpression): void;
  get(): Expr_BinaryExpression;
  delete(): void;
}

  export declare class Handle_Expr_BinaryExpression_1 extends Handle_Expr_BinaryExpression {
    constructor();
  }

  export declare class Handle_Expr_BinaryExpression_2 extends Handle_Expr_BinaryExpression {
    constructor(thePtr: Expr_BinaryExpression);
  }

  export declare class Handle_Expr_BinaryExpression_3 extends Handle_Expr_BinaryExpression {
    constructor(theHandle: Handle_Expr_BinaryExpression);
  }

  export declare class Handle_Expr_BinaryExpression_4 extends Handle_Expr_BinaryExpression {
    constructor(theHandle: Handle_Expr_BinaryExpression);
  }

export declare class Expr_BinaryExpression extends Expr_GeneralExpression {
  FirstOperand(): Handle_Expr_GeneralExpression;
  SecondOperand(): Handle_Expr_GeneralExpression;
  SetFirstOperand(exp: Handle_Expr_GeneralExpression): void;
  SetSecondOperand(exp: Handle_Expr_GeneralExpression): void;
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Simplified(): Handle_Expr_GeneralExpression;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_GreaterThan extends Expr_SingleRelation {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_GreaterThan {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_GreaterThan): void;
  get(): Expr_GreaterThan;
  delete(): void;
}

  export declare class Handle_Expr_GreaterThan_1 extends Handle_Expr_GreaterThan {
    constructor();
  }

  export declare class Handle_Expr_GreaterThan_2 extends Handle_Expr_GreaterThan {
    constructor(thePtr: Expr_GreaterThan);
  }

  export declare class Handle_Expr_GreaterThan_3 extends Handle_Expr_GreaterThan {
    constructor(theHandle: Handle_Expr_GreaterThan);
  }

  export declare class Handle_Expr_GreaterThan_4 extends Handle_Expr_GreaterThan {
    constructor(theHandle: Handle_Expr_GreaterThan);
  }

export declare class Expr_UnknownIterator {
  constructor(exp: Handle_Expr_GeneralExpression)
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Expr_NamedUnknown;
  delete(): void;
}

export declare class Expr_InvalidFunction extends Expr_ExprFailure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Expr_InvalidFunction;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_InvalidFunction_1 extends Expr_InvalidFunction {
    constructor();
  }

  export declare class Expr_InvalidFunction_2 extends Expr_InvalidFunction {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Expr_InvalidFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_InvalidFunction): void;
  get(): Expr_InvalidFunction;
  delete(): void;
}

  export declare class Handle_Expr_InvalidFunction_1 extends Handle_Expr_InvalidFunction {
    constructor();
  }

  export declare class Handle_Expr_InvalidFunction_2 extends Handle_Expr_InvalidFunction {
    constructor(thePtr: Expr_InvalidFunction);
  }

  export declare class Handle_Expr_InvalidFunction_3 extends Handle_Expr_InvalidFunction {
    constructor(theHandle: Handle_Expr_InvalidFunction);
  }

  export declare class Handle_Expr_InvalidFunction_4 extends Handle_Expr_InvalidFunction {
    constructor(theHandle: Handle_Expr_InvalidFunction);
  }

export declare class Handle_Expr_GeneralRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_GeneralRelation): void;
  get(): Expr_GeneralRelation;
  delete(): void;
}

  export declare class Handle_Expr_GeneralRelation_1 extends Handle_Expr_GeneralRelation {
    constructor();
  }

  export declare class Handle_Expr_GeneralRelation_2 extends Handle_Expr_GeneralRelation {
    constructor(thePtr: Expr_GeneralRelation);
  }

  export declare class Handle_Expr_GeneralRelation_3 extends Handle_Expr_GeneralRelation {
    constructor(theHandle: Handle_Expr_GeneralRelation);
  }

  export declare class Handle_Expr_GeneralRelation_4 extends Handle_Expr_GeneralRelation {
    constructor(theHandle: Handle_Expr_GeneralRelation);
  }

export declare class Expr_GeneralRelation extends Standard_Transient {
  IsSatisfied(): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  NbOfSubRelations(): Graphic3d_ZLayerId;
  NbOfSingleRelations(): Graphic3d_ZLayerId;
  SubRelation(index: Graphic3d_ZLayerId): Handle_Expr_GeneralRelation;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Sign {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Sign): void;
  get(): Expr_Sign;
  delete(): void;
}

  export declare class Handle_Expr_Sign_1 extends Handle_Expr_Sign {
    constructor();
  }

  export declare class Handle_Expr_Sign_2 extends Handle_Expr_Sign {
    constructor(thePtr: Expr_Sign);
  }

  export declare class Handle_Expr_Sign_3 extends Handle_Expr_Sign {
    constructor(theHandle: Handle_Expr_Sign);
  }

  export declare class Handle_Expr_Sign_4 extends Handle_Expr_Sign {
    constructor(theHandle: Handle_Expr_Sign);
  }

export declare class Expr_Sign extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_SystemRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_SystemRelation): void;
  get(): Expr_SystemRelation;
  delete(): void;
}

  export declare class Handle_Expr_SystemRelation_1 extends Handle_Expr_SystemRelation {
    constructor();
  }

  export declare class Handle_Expr_SystemRelation_2 extends Handle_Expr_SystemRelation {
    constructor(thePtr: Expr_SystemRelation);
  }

  export declare class Handle_Expr_SystemRelation_3 extends Handle_Expr_SystemRelation {
    constructor(theHandle: Handle_Expr_SystemRelation);
  }

  export declare class Handle_Expr_SystemRelation_4 extends Handle_Expr_SystemRelation {
    constructor(theHandle: Handle_Expr_SystemRelation);
  }

export declare class Expr_SystemRelation extends Expr_GeneralRelation {
  constructor(relation: Handle_Expr_GeneralRelation)
  Add(relation: Handle_Expr_GeneralRelation): void;
  Remove(relation: Handle_Expr_GeneralRelation): void;
  IsLinear(): Standard_Boolean;
  NbOfSubRelations(): Graphic3d_ZLayerId;
  NbOfSingleRelations(): Graphic3d_ZLayerId;
  SubRelation(index: Graphic3d_ZLayerId): Handle_Expr_GeneralRelation;
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_ArgCosh extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_ArgCosh {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ArgCosh): void;
  get(): Expr_ArgCosh;
  delete(): void;
}

  export declare class Handle_Expr_ArgCosh_1 extends Handle_Expr_ArgCosh {
    constructor();
  }

  export declare class Handle_Expr_ArgCosh_2 extends Handle_Expr_ArgCosh {
    constructor(thePtr: Expr_ArgCosh);
  }

  export declare class Handle_Expr_ArgCosh_3 extends Handle_Expr_ArgCosh {
    constructor(theHandle: Handle_Expr_ArgCosh);
  }

  export declare class Handle_Expr_ArgCosh_4 extends Handle_Expr_ArgCosh {
    constructor(theHandle: Handle_Expr_ArgCosh);
  }

export declare class Expr_PolyFunction extends Expr_PolyExpression {
  constructor(func: Handle_Expr_GeneralFunction, exps: Expr_Array1OfGeneralExpression)
  Function(): Handle_Expr_GeneralFunction;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_PolyFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_PolyFunction): void;
  get(): Expr_PolyFunction;
  delete(): void;
}

  export declare class Handle_Expr_PolyFunction_1 extends Handle_Expr_PolyFunction {
    constructor();
  }

  export declare class Handle_Expr_PolyFunction_2 extends Handle_Expr_PolyFunction {
    constructor(thePtr: Expr_PolyFunction);
  }

  export declare class Handle_Expr_PolyFunction_3 extends Handle_Expr_PolyFunction {
    constructor(theHandle: Handle_Expr_PolyFunction);
  }

  export declare class Handle_Expr_PolyFunction_4 extends Handle_Expr_PolyFunction {
    constructor(theHandle: Handle_Expr_PolyFunction);
  }

export declare class Expr_Equal extends Expr_SingleRelation {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Equal {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Equal): void;
  get(): Expr_Equal;
  delete(): void;
}

  export declare class Handle_Expr_Equal_1 extends Handle_Expr_Equal {
    constructor();
  }

  export declare class Handle_Expr_Equal_2 extends Handle_Expr_Equal {
    constructor(thePtr: Expr_Equal);
  }

  export declare class Handle_Expr_Equal_3 extends Handle_Expr_Equal {
    constructor(theHandle: Handle_Expr_Equal);
  }

  export declare class Handle_Expr_Equal_4 extends Handle_Expr_Equal {
    constructor(theHandle: Handle_Expr_Equal);
  }

export declare class Handle_Expr_Sinh {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Sinh): void;
  get(): Expr_Sinh;
  delete(): void;
}

  export declare class Handle_Expr_Sinh_1 extends Handle_Expr_Sinh {
    constructor();
  }

  export declare class Handle_Expr_Sinh_2 extends Handle_Expr_Sinh {
    constructor(thePtr: Expr_Sinh);
  }

  export declare class Handle_Expr_Sinh_3 extends Handle_Expr_Sinh {
    constructor(theHandle: Handle_Expr_Sinh);
  }

  export declare class Handle_Expr_Sinh_4 extends Handle_Expr_Sinh {
    constructor(theHandle: Handle_Expr_Sinh);
  }

export declare class Expr_Sinh extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_PolyExpression extends Expr_GeneralExpression {
  NbOperands(): Graphic3d_ZLayerId;
  Operand(index: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  SetOperand(exp: Handle_Expr_GeneralExpression, index: Graphic3d_ZLayerId): void;
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Simplified(): Handle_Expr_GeneralExpression;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_PolyExpression {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_PolyExpression): void;
  get(): Expr_PolyExpression;
  delete(): void;
}

  export declare class Handle_Expr_PolyExpression_1 extends Handle_Expr_PolyExpression {
    constructor();
  }

  export declare class Handle_Expr_PolyExpression_2 extends Handle_Expr_PolyExpression {
    constructor(thePtr: Expr_PolyExpression);
  }

  export declare class Handle_Expr_PolyExpression_3 extends Handle_Expr_PolyExpression {
    constructor(theHandle: Handle_Expr_PolyExpression);
  }

  export declare class Handle_Expr_PolyExpression_4 extends Handle_Expr_PolyExpression {
    constructor(theHandle: Handle_Expr_PolyExpression);
  }

export declare class Expr_LessThanOrEqual extends Expr_SingleRelation {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_LessThanOrEqual {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_LessThanOrEqual): void;
  get(): Expr_LessThanOrEqual;
  delete(): void;
}

  export declare class Handle_Expr_LessThanOrEqual_1 extends Handle_Expr_LessThanOrEqual {
    constructor();
  }

  export declare class Handle_Expr_LessThanOrEqual_2 extends Handle_Expr_LessThanOrEqual {
    constructor(thePtr: Expr_LessThanOrEqual);
  }

  export declare class Handle_Expr_LessThanOrEqual_3 extends Handle_Expr_LessThanOrEqual {
    constructor(theHandle: Handle_Expr_LessThanOrEqual);
  }

  export declare class Handle_Expr_LessThanOrEqual_4 extends Handle_Expr_LessThanOrEqual {
    constructor(theHandle: Handle_Expr_LessThanOrEqual);
  }

export declare class Expr_FunctionDerivative extends Expr_GeneralFunction {
  constructor(func: Handle_Expr_GeneralFunction, withX: Handle_Expr_NamedUnknown, deg: Graphic3d_ZLayerId)
  NbOfVariables(): Graphic3d_ZLayerId;
  Variable(index: Graphic3d_ZLayerId): Handle_Expr_NamedUnknown;
  Evaluate(vars: Expr_Array1OfNamedUnknown, values: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  Copy(): Handle_Expr_GeneralFunction;
  Derivative_1(var_: Handle_Expr_NamedUnknown): Handle_Expr_GeneralFunction;
  Derivative_2(var_: Handle_Expr_NamedUnknown, deg: Graphic3d_ZLayerId): Handle_Expr_GeneralFunction;
  IsIdentical(func: Handle_Expr_GeneralFunction): Standard_Boolean;
  IsLinearOnVariable(index: Graphic3d_ZLayerId): Standard_Boolean;
  Function(): Handle_Expr_GeneralFunction;
  Degree(): Graphic3d_ZLayerId;
  DerivVariable(): Handle_Expr_NamedUnknown;
  GetStringName(): XCAFDoc_PartId;
  Expression(): Handle_Expr_GeneralExpression;
  UpdateExpression(): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_FunctionDerivative {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_FunctionDerivative): void;
  get(): Expr_FunctionDerivative;
  delete(): void;
}

  export declare class Handle_Expr_FunctionDerivative_1 extends Handle_Expr_FunctionDerivative {
    constructor();
  }

  export declare class Handle_Expr_FunctionDerivative_2 extends Handle_Expr_FunctionDerivative {
    constructor(thePtr: Expr_FunctionDerivative);
  }

  export declare class Handle_Expr_FunctionDerivative_3 extends Handle_Expr_FunctionDerivative {
    constructor(theHandle: Handle_Expr_FunctionDerivative);
  }

  export declare class Handle_Expr_FunctionDerivative_4 extends Handle_Expr_FunctionDerivative {
    constructor(theHandle: Handle_Expr_FunctionDerivative);
  }

export declare class Handle_Expr_UnaryMinus {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_UnaryMinus): void;
  get(): Expr_UnaryMinus;
  delete(): void;
}

  export declare class Handle_Expr_UnaryMinus_1 extends Handle_Expr_UnaryMinus {
    constructor();
  }

  export declare class Handle_Expr_UnaryMinus_2 extends Handle_Expr_UnaryMinus {
    constructor(thePtr: Expr_UnaryMinus);
  }

  export declare class Handle_Expr_UnaryMinus_3 extends Handle_Expr_UnaryMinus {
    constructor(theHandle: Handle_Expr_UnaryMinus);
  }

  export declare class Handle_Expr_UnaryMinus_4 extends Handle_Expr_UnaryMinus {
    constructor(theHandle: Handle_Expr_UnaryMinus);
  }

export declare class Expr_UnaryMinus extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  NDerivative(X: Handle_Expr_NamedUnknown, N: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_ArgSinh extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_ArgSinh {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ArgSinh): void;
  get(): Expr_ArgSinh;
  delete(): void;
}

  export declare class Handle_Expr_ArgSinh_1 extends Handle_Expr_ArgSinh {
    constructor();
  }

  export declare class Handle_Expr_ArgSinh_2 extends Handle_Expr_ArgSinh {
    constructor(thePtr: Expr_ArgSinh);
  }

  export declare class Handle_Expr_ArgSinh_3 extends Handle_Expr_ArgSinh {
    constructor(theHandle: Handle_Expr_ArgSinh);
  }

  export declare class Handle_Expr_ArgSinh_4 extends Handle_Expr_ArgSinh {
    constructor(theHandle: Handle_Expr_ArgSinh);
  }

export declare class Expr_NamedConstant extends Expr_NamedExpression {
  constructor(name: XCAFDoc_PartId, value: Quantity_AbsorbedDose)
  GetValue(): Quantity_AbsorbedDose;
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Simplified(): Handle_Expr_GeneralExpression;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  NDerivative(X: Handle_Expr_NamedUnknown, N: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_NamedConstant {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NamedConstant): void;
  get(): Expr_NamedConstant;
  delete(): void;
}

  export declare class Handle_Expr_NamedConstant_1 extends Handle_Expr_NamedConstant {
    constructor();
  }

  export declare class Handle_Expr_NamedConstant_2 extends Handle_Expr_NamedConstant {
    constructor(thePtr: Expr_NamedConstant);
  }

  export declare class Handle_Expr_NamedConstant_3 extends Handle_Expr_NamedConstant {
    constructor(theHandle: Handle_Expr_NamedConstant);
  }

  export declare class Handle_Expr_NamedConstant_4 extends Handle_Expr_NamedConstant {
    constructor(theHandle: Handle_Expr_NamedConstant);
  }

export declare class Expr_Absolute extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Absolute {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Absolute): void;
  get(): Expr_Absolute;
  delete(): void;
}

  export declare class Handle_Expr_Absolute_1 extends Handle_Expr_Absolute {
    constructor();
  }

  export declare class Handle_Expr_Absolute_2 extends Handle_Expr_Absolute {
    constructor(thePtr: Expr_Absolute);
  }

  export declare class Handle_Expr_Absolute_3 extends Handle_Expr_Absolute {
    constructor(theHandle: Handle_Expr_Absolute);
  }

  export declare class Handle_Expr_Absolute_4 extends Handle_Expr_Absolute {
    constructor(theHandle: Handle_Expr_Absolute);
  }

export declare class Expr_Tangent extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Tangent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Tangent): void;
  get(): Expr_Tangent;
  delete(): void;
}

  export declare class Handle_Expr_Tangent_1 extends Handle_Expr_Tangent {
    constructor();
  }

  export declare class Handle_Expr_Tangent_2 extends Handle_Expr_Tangent {
    constructor(thePtr: Expr_Tangent);
  }

  export declare class Handle_Expr_Tangent_3 extends Handle_Expr_Tangent {
    constructor(theHandle: Handle_Expr_Tangent);
  }

  export declare class Handle_Expr_Tangent_4 extends Handle_Expr_Tangent {
    constructor(theHandle: Handle_Expr_Tangent);
  }

export declare class Handle_Expr_ArgTanh {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ArgTanh): void;
  get(): Expr_ArgTanh;
  delete(): void;
}

  export declare class Handle_Expr_ArgTanh_1 extends Handle_Expr_ArgTanh {
    constructor();
  }

  export declare class Handle_Expr_ArgTanh_2 extends Handle_Expr_ArgTanh {
    constructor(thePtr: Expr_ArgTanh);
  }

  export declare class Handle_Expr_ArgTanh_3 extends Handle_Expr_ArgTanh {
    constructor(theHandle: Handle_Expr_ArgTanh);
  }

  export declare class Handle_Expr_ArgTanh_4 extends Handle_Expr_ArgTanh {
    constructor(theHandle: Handle_Expr_ArgTanh);
  }

export declare class Expr_ArgTanh extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_NumericValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NumericValue): void;
  get(): Expr_NumericValue;
  delete(): void;
}

  export declare class Handle_Expr_NumericValue_1 extends Handle_Expr_NumericValue {
    constructor();
  }

  export declare class Handle_Expr_NumericValue_2 extends Handle_Expr_NumericValue {
    constructor(thePtr: Expr_NumericValue);
  }

  export declare class Handle_Expr_NumericValue_3 extends Handle_Expr_NumericValue {
    constructor(theHandle: Handle_Expr_NumericValue);
  }

  export declare class Handle_Expr_NumericValue_4 extends Handle_Expr_NumericValue {
    constructor(theHandle: Handle_Expr_NumericValue);
  }

export declare class Expr_NumericValue extends Expr_GeneralExpression {
  constructor(val: Quantity_AbsorbedDose)
  GetValue(): Quantity_AbsorbedDose;
  SetValue(val: Quantity_AbsorbedDose): void;
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Simplified(): Handle_Expr_GeneralExpression;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  NDerivative(X: Handle_Expr_NamedUnknown, N: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_Division extends Expr_BinaryExpression {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Division {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Division): void;
  get(): Expr_Division;
  delete(): void;
}

  export declare class Handle_Expr_Division_1 extends Handle_Expr_Division {
    constructor();
  }

  export declare class Handle_Expr_Division_2 extends Handle_Expr_Division {
    constructor(thePtr: Expr_Division);
  }

  export declare class Handle_Expr_Division_3 extends Handle_Expr_Division {
    constructor(theHandle: Handle_Expr_Division);
  }

  export declare class Handle_Expr_Division_4 extends Handle_Expr_Division {
    constructor(theHandle: Handle_Expr_Division);
  }

export declare class Handle_Expr_Exponentiate {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Exponentiate): void;
  get(): Expr_Exponentiate;
  delete(): void;
}

  export declare class Handle_Expr_Exponentiate_1 extends Handle_Expr_Exponentiate {
    constructor();
  }

  export declare class Handle_Expr_Exponentiate_2 extends Handle_Expr_Exponentiate {
    constructor(thePtr: Expr_Exponentiate);
  }

  export declare class Handle_Expr_Exponentiate_3 extends Handle_Expr_Exponentiate {
    constructor(theHandle: Handle_Expr_Exponentiate);
  }

  export declare class Handle_Expr_Exponentiate_4 extends Handle_Expr_Exponentiate {
    constructor(theHandle: Handle_Expr_Exponentiate);
  }

export declare class Expr_Exponentiate extends Expr_BinaryExpression {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Tanh {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Tanh): void;
  get(): Expr_Tanh;
  delete(): void;
}

  export declare class Handle_Expr_Tanh_1 extends Handle_Expr_Tanh {
    constructor();
  }

  export declare class Handle_Expr_Tanh_2 extends Handle_Expr_Tanh {
    constructor(thePtr: Expr_Tanh);
  }

  export declare class Handle_Expr_Tanh_3 extends Handle_Expr_Tanh {
    constructor(theHandle: Handle_Expr_Tanh);
  }

  export declare class Handle_Expr_Tanh_4 extends Handle_Expr_Tanh {
    constructor(theHandle: Handle_Expr_Tanh);
  }

export declare class Expr_Tanh extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Sine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Sine): void;
  get(): Expr_Sine;
  delete(): void;
}

  export declare class Handle_Expr_Sine_1 extends Handle_Expr_Sine {
    constructor();
  }

  export declare class Handle_Expr_Sine_2 extends Handle_Expr_Sine {
    constructor(thePtr: Expr_Sine);
  }

  export declare class Handle_Expr_Sine_3 extends Handle_Expr_Sine {
    constructor(theHandle: Handle_Expr_Sine);
  }

  export declare class Handle_Expr_Sine_4 extends Handle_Expr_Sine {
    constructor(theHandle: Handle_Expr_Sine);
  }

export declare class Expr_Sine extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_RUIterator {
  constructor(rel: Handle_Expr_GeneralRelation)
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Expr_NamedUnknown;
  delete(): void;
}

export declare class Expr_UnaryFunction extends Expr_UnaryExpression {
  constructor(func: Handle_Expr_GeneralFunction, exp: Handle_Expr_GeneralExpression)
  Function(): Handle_Expr_GeneralFunction;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_UnaryFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_UnaryFunction): void;
  get(): Expr_UnaryFunction;
  delete(): void;
}

  export declare class Handle_Expr_UnaryFunction_1 extends Handle_Expr_UnaryFunction {
    constructor();
  }

  export declare class Handle_Expr_UnaryFunction_2 extends Handle_Expr_UnaryFunction {
    constructor(thePtr: Expr_UnaryFunction);
  }

  export declare class Handle_Expr_UnaryFunction_3 extends Handle_Expr_UnaryFunction {
    constructor(theHandle: Handle_Expr_UnaryFunction);
  }

  export declare class Handle_Expr_UnaryFunction_4 extends Handle_Expr_UnaryFunction {
    constructor(theHandle: Handle_Expr_UnaryFunction);
  }

export declare class Expr_InvalidAssignment extends Expr_ExprFailure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Expr_InvalidAssignment;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_InvalidAssignment_1 extends Expr_InvalidAssignment {
    constructor();
  }

  export declare class Expr_InvalidAssignment_2 extends Expr_InvalidAssignment {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Expr_InvalidAssignment {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_InvalidAssignment): void;
  get(): Expr_InvalidAssignment;
  delete(): void;
}

  export declare class Handle_Expr_InvalidAssignment_1 extends Handle_Expr_InvalidAssignment {
    constructor();
  }

  export declare class Handle_Expr_InvalidAssignment_2 extends Handle_Expr_InvalidAssignment {
    constructor(thePtr: Expr_InvalidAssignment);
  }

  export declare class Handle_Expr_InvalidAssignment_3 extends Handle_Expr_InvalidAssignment {
    constructor(theHandle: Handle_Expr_InvalidAssignment);
  }

  export declare class Handle_Expr_InvalidAssignment_4 extends Handle_Expr_InvalidAssignment {
    constructor(theHandle: Handle_Expr_InvalidAssignment);
  }

export declare class Expr_RelationIterator {
  constructor(rel: Handle_Expr_GeneralRelation)
  More(): Standard_Boolean;
  Next(): void;
  Value(): Handle_Expr_SingleRelation;
  delete(): void;
}

export declare class Handle_Expr_Cosh {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Cosh): void;
  get(): Expr_Cosh;
  delete(): void;
}

  export declare class Handle_Expr_Cosh_1 extends Handle_Expr_Cosh {
    constructor();
  }

  export declare class Handle_Expr_Cosh_2 extends Handle_Expr_Cosh {
    constructor(thePtr: Expr_Cosh);
  }

  export declare class Handle_Expr_Cosh_3 extends Handle_Expr_Cosh {
    constructor(theHandle: Handle_Expr_Cosh);
  }

  export declare class Handle_Expr_Cosh_4 extends Handle_Expr_Cosh {
    constructor(theHandle: Handle_Expr_Cosh);
  }

export declare class Expr_Cosh extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_SquareRoot extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_SquareRoot {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_SquareRoot): void;
  get(): Expr_SquareRoot;
  delete(): void;
}

  export declare class Handle_Expr_SquareRoot_1 extends Handle_Expr_SquareRoot {
    constructor();
  }

  export declare class Handle_Expr_SquareRoot_2 extends Handle_Expr_SquareRoot {
    constructor(thePtr: Expr_SquareRoot);
  }

  export declare class Handle_Expr_SquareRoot_3 extends Handle_Expr_SquareRoot {
    constructor(theHandle: Handle_Expr_SquareRoot);
  }

  export declare class Handle_Expr_SquareRoot_4 extends Handle_Expr_SquareRoot {
    constructor(theHandle: Handle_Expr_SquareRoot);
  }

export declare class Expr_GreaterThanOrEqual extends Expr_SingleRelation {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_GreaterThanOrEqual {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_GreaterThanOrEqual): void;
  get(): Expr_GreaterThanOrEqual;
  delete(): void;
}

  export declare class Handle_Expr_GreaterThanOrEqual_1 extends Handle_Expr_GreaterThanOrEqual {
    constructor();
  }

  export declare class Handle_Expr_GreaterThanOrEqual_2 extends Handle_Expr_GreaterThanOrEqual {
    constructor(thePtr: Expr_GreaterThanOrEqual);
  }

  export declare class Handle_Expr_GreaterThanOrEqual_3 extends Handle_Expr_GreaterThanOrEqual {
    constructor(theHandle: Handle_Expr_GreaterThanOrEqual);
  }

  export declare class Handle_Expr_GreaterThanOrEqual_4 extends Handle_Expr_GreaterThanOrEqual {
    constructor(theHandle: Handle_Expr_GreaterThanOrEqual);
  }

export declare class Handle_Expr_Cosine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Cosine): void;
  get(): Expr_Cosine;
  delete(): void;
}

  export declare class Handle_Expr_Cosine_1 extends Handle_Expr_Cosine {
    constructor();
  }

  export declare class Handle_Expr_Cosine_2 extends Handle_Expr_Cosine {
    constructor(thePtr: Expr_Cosine);
  }

  export declare class Handle_Expr_Cosine_3 extends Handle_Expr_Cosine {
    constructor(theHandle: Handle_Expr_Cosine);
  }

  export declare class Handle_Expr_Cosine_4 extends Handle_Expr_Cosine {
    constructor(theHandle: Handle_Expr_Cosine);
  }

export declare class Expr_Cosine extends Expr_UnaryExpression {
  constructor(Exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_NamedFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NamedFunction): void;
  get(): Expr_NamedFunction;
  delete(): void;
}

  export declare class Handle_Expr_NamedFunction_1 extends Handle_Expr_NamedFunction {
    constructor();
  }

  export declare class Handle_Expr_NamedFunction_2 extends Handle_Expr_NamedFunction {
    constructor(thePtr: Expr_NamedFunction);
  }

  export declare class Handle_Expr_NamedFunction_3 extends Handle_Expr_NamedFunction {
    constructor(theHandle: Handle_Expr_NamedFunction);
  }

  export declare class Handle_Expr_NamedFunction_4 extends Handle_Expr_NamedFunction {
    constructor(theHandle: Handle_Expr_NamedFunction);
  }

export declare class Expr_NamedFunction extends Expr_GeneralFunction {
  constructor(name: XCAFDoc_PartId, exp: Handle_Expr_GeneralExpression, vars: Expr_Array1OfNamedUnknown)
  SetName(newname: XCAFDoc_PartId): void;
  GetName(): XCAFDoc_PartId;
  NbOfVariables(): Graphic3d_ZLayerId;
  Variable(index: Graphic3d_ZLayerId): Handle_Expr_NamedUnknown;
  Evaluate(vars: Expr_Array1OfNamedUnknown, values: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  Copy(): Handle_Expr_GeneralFunction;
  Derivative_1(var_: Handle_Expr_NamedUnknown): Handle_Expr_GeneralFunction;
  Derivative_2(var_: Handle_Expr_NamedUnknown, deg: Graphic3d_ZLayerId): Handle_Expr_GeneralFunction;
  IsIdentical(func: Handle_Expr_GeneralFunction): Standard_Boolean;
  IsLinearOnVariable(index: Graphic3d_ZLayerId): Standard_Boolean;
  GetStringName(): XCAFDoc_PartId;
  Expression(): Handle_Expr_GeneralExpression;
  SetExpression(exp: Handle_Expr_GeneralExpression): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_Sum extends Expr_PolyExpression {
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  NDerivative(X: Handle_Expr_NamedUnknown, N: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_Sum_1 extends Expr_Sum {
    constructor(exps: Expr_SequenceOfGeneralExpression);
  }

  export declare class Expr_Sum_2 extends Expr_Sum {
    constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression);
  }

export declare class Handle_Expr_Sum {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Sum): void;
  get(): Expr_Sum;
  delete(): void;
}

  export declare class Handle_Expr_Sum_1 extends Handle_Expr_Sum {
    constructor();
  }

  export declare class Handle_Expr_Sum_2 extends Handle_Expr_Sum {
    constructor(thePtr: Expr_Sum);
  }

  export declare class Handle_Expr_Sum_3 extends Handle_Expr_Sum {
    constructor(theHandle: Handle_Expr_Sum);
  }

  export declare class Handle_Expr_Sum_4 extends Handle_Expr_Sum {
    constructor(theHandle: Handle_Expr_Sum);
  }

export declare class Handle_Expr_NamedUnknown {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NamedUnknown): void;
  get(): Expr_NamedUnknown;
  delete(): void;
}

  export declare class Handle_Expr_NamedUnknown_1 extends Handle_Expr_NamedUnknown {
    constructor();
  }

  export declare class Handle_Expr_NamedUnknown_2 extends Handle_Expr_NamedUnknown {
    constructor(thePtr: Expr_NamedUnknown);
  }

  export declare class Handle_Expr_NamedUnknown_3 extends Handle_Expr_NamedUnknown {
    constructor(theHandle: Handle_Expr_NamedUnknown);
  }

  export declare class Handle_Expr_NamedUnknown_4 extends Handle_Expr_NamedUnknown {
    constructor(theHandle: Handle_Expr_NamedUnknown);
  }

export declare class Expr_NamedUnknown extends Expr_NamedExpression {
  constructor(name: XCAFDoc_PartId)
  IsAssigned(): Standard_Boolean;
  AssignedExpression(): Handle_Expr_GeneralExpression;
  Assign(exp: Handle_Expr_GeneralExpression): void;
  Deassign(): void;
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Simplified(): Handle_Expr_GeneralExpression;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_LogOf10 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_LogOf10): void;
  get(): Expr_LogOf10;
  delete(): void;
}

  export declare class Handle_Expr_LogOf10_1 extends Handle_Expr_LogOf10 {
    constructor();
  }

  export declare class Handle_Expr_LogOf10_2 extends Handle_Expr_LogOf10 {
    constructor(thePtr: Expr_LogOf10);
  }

  export declare class Handle_Expr_LogOf10_3 extends Handle_Expr_LogOf10 {
    constructor(theHandle: Handle_Expr_LogOf10);
  }

  export declare class Handle_Expr_LogOf10_4 extends Handle_Expr_LogOf10 {
    constructor(theHandle: Handle_Expr_LogOf10);
  }

export declare class Expr_LogOf10 extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr {
  constructor();
  static CopyShare(exp: Handle_Expr_GeneralExpression): Handle_Expr_GeneralExpression;
  static NbOfFreeVariables_1(exp: Handle_Expr_GeneralExpression): Graphic3d_ZLayerId;
  static NbOfFreeVariables_2(exp: Handle_Expr_GeneralRelation): Graphic3d_ZLayerId;
  static Sign(val: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Expr_SingleRelation extends Expr_GeneralRelation {
  SetFirstMember(exp: Handle_Expr_GeneralExpression): void;
  SetSecondMember(exp: Handle_Expr_GeneralExpression): void;
  FirstMember(): Handle_Expr_GeneralExpression;
  SecondMember(): Handle_Expr_GeneralExpression;
  IsLinear(): Standard_Boolean;
  NbOfSubRelations(): Graphic3d_ZLayerId;
  NbOfSingleRelations(): Graphic3d_ZLayerId;
  SubRelation(index: Graphic3d_ZLayerId): Handle_Expr_GeneralRelation;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_SingleRelation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_SingleRelation): void;
  get(): Expr_SingleRelation;
  delete(): void;
}

  export declare class Handle_Expr_SingleRelation_1 extends Handle_Expr_SingleRelation {
    constructor();
  }

  export declare class Handle_Expr_SingleRelation_2 extends Handle_Expr_SingleRelation {
    constructor(thePtr: Expr_SingleRelation);
  }

  export declare class Handle_Expr_SingleRelation_3 extends Handle_Expr_SingleRelation {
    constructor(theHandle: Handle_Expr_SingleRelation);
  }

  export declare class Handle_Expr_SingleRelation_4 extends Handle_Expr_SingleRelation {
    constructor(theHandle: Handle_Expr_SingleRelation);
  }

export declare class Expr_BinaryFunction extends Expr_BinaryExpression {
  constructor(func: Handle_Expr_GeneralFunction, exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  Function(): Handle_Expr_GeneralFunction;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_BinaryFunction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_BinaryFunction): void;
  get(): Expr_BinaryFunction;
  delete(): void;
}

  export declare class Handle_Expr_BinaryFunction_1 extends Handle_Expr_BinaryFunction {
    constructor();
  }

  export declare class Handle_Expr_BinaryFunction_2 extends Handle_Expr_BinaryFunction {
    constructor(thePtr: Expr_BinaryFunction);
  }

  export declare class Handle_Expr_BinaryFunction_3 extends Handle_Expr_BinaryFunction {
    constructor(theHandle: Handle_Expr_BinaryFunction);
  }

  export declare class Handle_Expr_BinaryFunction_4 extends Handle_Expr_BinaryFunction {
    constructor(theHandle: Handle_Expr_BinaryFunction);
  }

export declare class Handle_Expr_Exponential {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Exponential): void;
  get(): Expr_Exponential;
  delete(): void;
}

  export declare class Handle_Expr_Exponential_1 extends Handle_Expr_Exponential {
    constructor();
  }

  export declare class Handle_Expr_Exponential_2 extends Handle_Expr_Exponential {
    constructor(thePtr: Expr_Exponential);
  }

  export declare class Handle_Expr_Exponential_3 extends Handle_Expr_Exponential {
    constructor(theHandle: Handle_Expr_Exponential);
  }

  export declare class Handle_Expr_Exponential_4 extends Handle_Expr_Exponential {
    constructor(theHandle: Handle_Expr_Exponential);
  }

export declare class Expr_Exponential extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_Different {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_Different): void;
  get(): Expr_Different;
  delete(): void;
}

  export declare class Handle_Expr_Different_1 extends Handle_Expr_Different {
    constructor();
  }

  export declare class Handle_Expr_Different_2 extends Handle_Expr_Different {
    constructor(thePtr: Expr_Different);
  }

  export declare class Handle_Expr_Different_3 extends Handle_Expr_Different {
    constructor(theHandle: Handle_Expr_Different);
  }

  export declare class Handle_Expr_Different_4 extends Handle_Expr_Different {
    constructor(theHandle: Handle_Expr_Different);
  }

export declare class Expr_Different extends Expr_SingleRelation {
  constructor(exp1: Handle_Expr_GeneralExpression, exp2: Handle_Expr_GeneralExpression)
  IsSatisfied(): Standard_Boolean;
  Simplified(): Handle_Expr_GeneralRelation;
  Simplify(): void;
  Copy(): Handle_Expr_GeneralRelation;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_ExprFailure extends Standard_Failure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Expr_ExprFailure;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_ExprFailure_1 extends Expr_ExprFailure {
    constructor();
  }

  export declare class Expr_ExprFailure_2 extends Expr_ExprFailure {
    constructor(theMessage: Standard_CString);
  }

export declare class Handle_Expr_ExprFailure {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ExprFailure): void;
  get(): Expr_ExprFailure;
  delete(): void;
}

  export declare class Handle_Expr_ExprFailure_1 extends Handle_Expr_ExprFailure {
    constructor();
  }

  export declare class Handle_Expr_ExprFailure_2 extends Handle_Expr_ExprFailure {
    constructor(thePtr: Expr_ExprFailure);
  }

  export declare class Handle_Expr_ExprFailure_3 extends Handle_Expr_ExprFailure {
    constructor(theHandle: Handle_Expr_ExprFailure);
  }

  export declare class Handle_Expr_ExprFailure_4 extends Handle_Expr_ExprFailure {
    constructor(theHandle: Handle_Expr_ExprFailure);
  }

export declare class Handle_Expr_ArcSine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ArcSine): void;
  get(): Expr_ArcSine;
  delete(): void;
}

  export declare class Handle_Expr_ArcSine_1 extends Handle_Expr_ArcSine {
    constructor();
  }

  export declare class Handle_Expr_ArcSine_2 extends Handle_Expr_ArcSine {
    constructor(thePtr: Expr_ArcSine);
  }

  export declare class Handle_Expr_ArcSine_3 extends Handle_Expr_ArcSine {
    constructor(theHandle: Handle_Expr_ArcSine);
  }

  export declare class Handle_Expr_ArcSine_4 extends Handle_Expr_ArcSine {
    constructor(theHandle: Handle_Expr_ArcSine);
  }

export declare class Expr_ArcSine extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Expr_GeneralExpression extends Standard_Transient {
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Simplified(): Handle_Expr_GeneralExpression;
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  IsShareable(): Standard_Boolean;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  NDerivative(X: Handle_Expr_NamedUnknown, N: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  EvaluateNumeric(): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_GeneralExpression {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_GeneralExpression): void;
  get(): Expr_GeneralExpression;
  delete(): void;
}

  export declare class Handle_Expr_GeneralExpression_1 extends Handle_Expr_GeneralExpression {
    constructor();
  }

  export declare class Handle_Expr_GeneralExpression_2 extends Handle_Expr_GeneralExpression {
    constructor(thePtr: Expr_GeneralExpression);
  }

  export declare class Handle_Expr_GeneralExpression_3 extends Handle_Expr_GeneralExpression {
    constructor(theHandle: Handle_Expr_GeneralExpression);
  }

  export declare class Handle_Expr_GeneralExpression_4 extends Handle_Expr_GeneralExpression {
    constructor(theHandle: Handle_Expr_GeneralExpression);
  }

export declare class Handle_Expr_ArcCosine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ArcCosine): void;
  get(): Expr_ArcCosine;
  delete(): void;
}

  export declare class Handle_Expr_ArcCosine_1 extends Handle_Expr_ArcCosine {
    constructor();
  }

  export declare class Handle_Expr_ArcCosine_2 extends Handle_Expr_ArcCosine {
    constructor(thePtr: Expr_ArcCosine);
  }

  export declare class Handle_Expr_ArcCosine_3 extends Handle_Expr_ArcCosine {
    constructor(theHandle: Handle_Expr_ArcCosine);
  }

  export declare class Handle_Expr_ArcCosine_4 extends Handle_Expr_ArcCosine {
    constructor(theHandle: Handle_Expr_ArcCosine);
  }

export declare class Expr_ArcCosine extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_InvalidOperand {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_InvalidOperand): void;
  get(): Expr_InvalidOperand;
  delete(): void;
}

  export declare class Handle_Expr_InvalidOperand_1 extends Handle_Expr_InvalidOperand {
    constructor();
  }

  export declare class Handle_Expr_InvalidOperand_2 extends Handle_Expr_InvalidOperand {
    constructor(thePtr: Expr_InvalidOperand);
  }

  export declare class Handle_Expr_InvalidOperand_3 extends Handle_Expr_InvalidOperand {
    constructor(theHandle: Handle_Expr_InvalidOperand);
  }

  export declare class Handle_Expr_InvalidOperand_4 extends Handle_Expr_InvalidOperand {
    constructor(theHandle: Handle_Expr_InvalidOperand);
  }

export declare class Expr_InvalidOperand extends Expr_ExprFailure {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Expr_InvalidOperand;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Expr_InvalidOperand_1 extends Expr_InvalidOperand {
    constructor();
  }

  export declare class Expr_InvalidOperand_2 extends Expr_InvalidOperand {
    constructor(theMessage: Standard_CString);
  }

export declare class Expr_NamedExpression extends Expr_GeneralExpression {
  GetName(): XCAFDoc_PartId;
  SetName(name: XCAFDoc_PartId): void;
  IsShareable(): Standard_Boolean;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_NamedExpression {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_NamedExpression): void;
  get(): Expr_NamedExpression;
  delete(): void;
}

  export declare class Handle_Expr_NamedExpression_1 extends Handle_Expr_NamedExpression {
    constructor();
  }

  export declare class Handle_Expr_NamedExpression_2 extends Handle_Expr_NamedExpression {
    constructor(thePtr: Expr_NamedExpression);
  }

  export declare class Handle_Expr_NamedExpression_3 extends Handle_Expr_NamedExpression {
    constructor(theHandle: Handle_Expr_NamedExpression);
  }

  export declare class Handle_Expr_NamedExpression_4 extends Handle_Expr_NamedExpression {
    constructor(theHandle: Handle_Expr_NamedExpression);
  }

export declare class Expr_ArcTangent extends Expr_UnaryExpression {
  constructor(exp: Handle_Expr_GeneralExpression)
  ShallowSimplified(): Handle_Expr_GeneralExpression;
  Copy(): Handle_Expr_GeneralExpression;
  IsIdentical(Other: Handle_Expr_GeneralExpression): Standard_Boolean;
  IsLinear(): Standard_Boolean;
  Derivative(X: Handle_Expr_NamedUnknown): Handle_Expr_GeneralExpression;
  Evaluate(vars: Expr_Array1OfNamedUnknown, vals: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  String(): XCAFDoc_PartId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_ArcTangent {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_ArcTangent): void;
  get(): Expr_ArcTangent;
  delete(): void;
}

  export declare class Handle_Expr_ArcTangent_1 extends Handle_Expr_ArcTangent {
    constructor();
  }

  export declare class Handle_Expr_ArcTangent_2 extends Handle_Expr_ArcTangent {
    constructor(thePtr: Expr_ArcTangent);
  }

  export declare class Handle_Expr_ArcTangent_3 extends Handle_Expr_ArcTangent {
    constructor(theHandle: Handle_Expr_ArcTangent);
  }

  export declare class Handle_Expr_ArcTangent_4 extends Handle_Expr_ArcTangent {
    constructor(theHandle: Handle_Expr_ArcTangent);
  }

export declare class Expr_UnaryExpression extends Expr_GeneralExpression {
  Operand(): Handle_Expr_GeneralExpression;
  SetOperand(exp: Handle_Expr_GeneralExpression): void;
  NbSubExpressions(): Graphic3d_ZLayerId;
  SubExpression(I: Graphic3d_ZLayerId): Handle_Expr_GeneralExpression;
  ContainsUnknowns(): Standard_Boolean;
  Contains(exp: Handle_Expr_GeneralExpression): Standard_Boolean;
  Replace(var_: Handle_Expr_NamedUnknown, with_: Handle_Expr_GeneralExpression): void;
  Simplified(): Handle_Expr_GeneralExpression;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Expr_UnaryExpression {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Expr_UnaryExpression): void;
  get(): Expr_UnaryExpression;
  delete(): void;
}

  export declare class Handle_Expr_UnaryExpression_1 extends Handle_Expr_UnaryExpression {
    constructor();
  }

  export declare class Handle_Expr_UnaryExpression_2 extends Handle_Expr_UnaryExpression {
    constructor(thePtr: Expr_UnaryExpression);
  }

  export declare class Handle_Expr_UnaryExpression_3 extends Handle_Expr_UnaryExpression {
    constructor(theHandle: Handle_Expr_UnaryExpression);
  }

  export declare class Handle_Expr_UnaryExpression_4 extends Handle_Expr_UnaryExpression {
    constructor(theHandle: Handle_Expr_UnaryExpression);
  }

export declare class XmlTObjDrivers_IntSparseArrayDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(theSource: XmlObjMgt_Persistent, theTarget: Handle_TDF_Attribute, theRelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(theSource: Handle_TDF_Attribute, theTarget: XmlObjMgt_Persistent, theRelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlTObjDrivers_IntSparseArrayDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_IntSparseArrayDriver): void;
  get(): XmlTObjDrivers_IntSparseArrayDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_IntSparseArrayDriver_1 extends Handle_XmlTObjDrivers_IntSparseArrayDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_IntSparseArrayDriver_2 extends Handle_XmlTObjDrivers_IntSparseArrayDriver {
    constructor(thePtr: XmlTObjDrivers_IntSparseArrayDriver);
  }

  export declare class Handle_XmlTObjDrivers_IntSparseArrayDriver_3 extends Handle_XmlTObjDrivers_IntSparseArrayDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_IntSparseArrayDriver);
  }

  export declare class Handle_XmlTObjDrivers_IntSparseArrayDriver_4 extends Handle_XmlTObjDrivers_IntSparseArrayDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_IntSparseArrayDriver);
  }

export declare class XmlTObjDrivers {
  constructor();
  static Factory(aGUID: Standard_GUID): Handle_Standard_Transient;
  static DefineFormat(theApp: Handle_TDocStd_Application): void;
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, anMsgDrv: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class XmlTObjDrivers_DocumentRetrievalDriver extends XmlLDrivers_DocumentRetrievalDriver {
  constructor()
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlTObjDrivers_DocumentRetrievalDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_DocumentRetrievalDriver): void;
  get(): XmlTObjDrivers_DocumentRetrievalDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_DocumentRetrievalDriver_1 extends Handle_XmlTObjDrivers_DocumentRetrievalDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_DocumentRetrievalDriver_2 extends Handle_XmlTObjDrivers_DocumentRetrievalDriver {
    constructor(thePtr: XmlTObjDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlTObjDrivers_DocumentRetrievalDriver_3 extends Handle_XmlTObjDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_DocumentRetrievalDriver);
  }

  export declare class Handle_XmlTObjDrivers_DocumentRetrievalDriver_4 extends Handle_XmlTObjDrivers_DocumentRetrievalDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_DocumentRetrievalDriver);
  }

export declare class XmlTObjDrivers_DocumentStorageDriver extends XmlLDrivers_DocumentStorageDriver {
  constructor(theCopyright: TCollection_ExtendedString)
  AttributeDrivers(theMsgDriver: Handle_Message_Messenger): Handle_XmlMDF_ADriverTable;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlTObjDrivers_DocumentStorageDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_DocumentStorageDriver): void;
  get(): XmlTObjDrivers_DocumentStorageDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_DocumentStorageDriver_1 extends Handle_XmlTObjDrivers_DocumentStorageDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_DocumentStorageDriver_2 extends Handle_XmlTObjDrivers_DocumentStorageDriver {
    constructor(thePtr: XmlTObjDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlTObjDrivers_DocumentStorageDriver_3 extends Handle_XmlTObjDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_DocumentStorageDriver);
  }

  export declare class Handle_XmlTObjDrivers_DocumentStorageDriver_4 extends Handle_XmlTObjDrivers_DocumentStorageDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_DocumentStorageDriver);
  }

export declare class Handle_XmlTObjDrivers_ModelDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_ModelDriver): void;
  get(): XmlTObjDrivers_ModelDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_ModelDriver_1 extends Handle_XmlTObjDrivers_ModelDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_ModelDriver_2 extends Handle_XmlTObjDrivers_ModelDriver {
    constructor(thePtr: XmlTObjDrivers_ModelDriver);
  }

  export declare class Handle_XmlTObjDrivers_ModelDriver_3 extends Handle_XmlTObjDrivers_ModelDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_ModelDriver);
  }

  export declare class Handle_XmlTObjDrivers_ModelDriver_4 extends Handle_XmlTObjDrivers_ModelDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_ModelDriver);
  }

export declare class XmlTObjDrivers_ModelDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlTObjDrivers_ObjectDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlTObjDrivers_ObjectDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_ObjectDriver): void;
  get(): XmlTObjDrivers_ObjectDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_ObjectDriver_1 extends Handle_XmlTObjDrivers_ObjectDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_ObjectDriver_2 extends Handle_XmlTObjDrivers_ObjectDriver {
    constructor(thePtr: XmlTObjDrivers_ObjectDriver);
  }

  export declare class Handle_XmlTObjDrivers_ObjectDriver_3 extends Handle_XmlTObjDrivers_ObjectDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_ObjectDriver);
  }

  export declare class Handle_XmlTObjDrivers_ObjectDriver_4 extends Handle_XmlTObjDrivers_ObjectDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_ObjectDriver);
  }

export declare class XmlTObjDrivers_XYZDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlTObjDrivers_XYZDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_XYZDriver): void;
  get(): XmlTObjDrivers_XYZDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_XYZDriver_1 extends Handle_XmlTObjDrivers_XYZDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_XYZDriver_2 extends Handle_XmlTObjDrivers_XYZDriver {
    constructor(thePtr: XmlTObjDrivers_XYZDriver);
  }

  export declare class Handle_XmlTObjDrivers_XYZDriver_3 extends Handle_XmlTObjDrivers_XYZDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_XYZDriver);
  }

  export declare class Handle_XmlTObjDrivers_XYZDriver_4 extends Handle_XmlTObjDrivers_XYZDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_XYZDriver);
  }

export declare class XmlTObjDrivers_ReferenceDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlTObjDrivers_ReferenceDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlTObjDrivers_ReferenceDriver): void;
  get(): XmlTObjDrivers_ReferenceDriver;
  delete(): void;
}

  export declare class Handle_XmlTObjDrivers_ReferenceDriver_1 extends Handle_XmlTObjDrivers_ReferenceDriver {
    constructor();
  }

  export declare class Handle_XmlTObjDrivers_ReferenceDriver_2 extends Handle_XmlTObjDrivers_ReferenceDriver {
    constructor(thePtr: XmlTObjDrivers_ReferenceDriver);
  }

  export declare class Handle_XmlTObjDrivers_ReferenceDriver_3 extends Handle_XmlTObjDrivers_ReferenceDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_ReferenceDriver);
  }

  export declare class Handle_XmlTObjDrivers_ReferenceDriver_4 extends Handle_XmlTObjDrivers_ReferenceDriver {
    constructor(theHandle: Handle_XmlTObjDrivers_ReferenceDriver);
  }

export declare class ShapeConstruct {
  constructor();
  static ConvertCurveToBSpline_1(C3D: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId): Handle_Geom_BSplineCurve;
  static ConvertCurveToBSpline_2(C2D: Handle_Geom2d_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol2d: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId): Handle_Geom2d_BSplineCurve;
  static ConvertSurfaceToBSpline(surf: Handle_Geom_Surface, UF: Quantity_AbsorbedDose, UL: Quantity_AbsorbedDose, VF: Quantity_AbsorbedDose, VL: Quantity_AbsorbedDose, Tol3d: Quantity_AbsorbedDose, Continuity: GeomAbs_Shape, MaxSegments: Graphic3d_ZLayerId, MaxDegree: Graphic3d_ZLayerId): Handle_Geom_BSplineSurface;
  static JoinPCurves(theEdges: Handle_TopTools_HSequenceOfShape, theFace: TopoDS_Face, theEdge: TopoDS_Edge): Standard_Boolean;
  static JoinCurves_1(c3d1: Handle_Geom_Curve, ac3d2: Handle_Geom_Curve, Orient1: TopAbs_Orientation, Orient2: TopAbs_Orientation, first1: Quantity_AbsorbedDose, last1: Quantity_AbsorbedDose, first2: Quantity_AbsorbedDose, last2: Quantity_AbsorbedDose, c3dOut: Handle_Geom_Curve, isRev1: Standard_Boolean, isRev2: Standard_Boolean): Standard_Boolean;
  static JoinCurves_2(c2d1: Handle_Geom2d_Curve, ac2d2: Handle_Geom2d_Curve, Orient1: TopAbs_Orientation, Orient2: TopAbs_Orientation, first1: Quantity_AbsorbedDose, last1: Quantity_AbsorbedDose, first2: Quantity_AbsorbedDose, last2: Quantity_AbsorbedDose, c2dOut: Handle_Geom2d_Curve, isRev1: Standard_Boolean, isRev2: Standard_Boolean, isError: Standard_Boolean): Standard_Boolean;
  delete(): void;
}

export declare class ShapeConstruct_Curve {
  constructor();
  AdjustCurve(C3D: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt, take1: Standard_Boolean, take2: Standard_Boolean): Standard_Boolean;
  AdjustCurveSegment(C3D: Handle_Geom_Curve, P1: gp_Pnt, P2: gp_Pnt, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): Standard_Boolean;
  AdjustCurve2d(C2D: Handle_Geom2d_Curve, P1: gp_Pnt2d, P2: gp_Pnt2d, take1: Standard_Boolean, take2: Standard_Boolean): Standard_Boolean;
  ConvertToBSpline_1(C: Handle_Geom_Curve, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose, prec: Quantity_AbsorbedDose): Handle_Geom_BSplineCurve;
  ConvertToBSpline_2(C: Handle_Geom2d_Curve, first: Quantity_AbsorbedDose, last: Quantity_AbsorbedDose, prec: Quantity_AbsorbedDose): Handle_Geom2d_BSplineCurve;
  static FixKnots_1(knots: Handle_TColStd_HArray1OfReal): Standard_Boolean;
  static FixKnots_2(knots: TColStd_Array1OfReal): Standard_Boolean;
  delete(): void;
}

export declare class Handle_ShapeConstruct_ProjectCurveOnSurface {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ShapeConstruct_ProjectCurveOnSurface): void;
  get(): ShapeConstruct_ProjectCurveOnSurface;
  delete(): void;
}

  export declare class Handle_ShapeConstruct_ProjectCurveOnSurface_1 extends Handle_ShapeConstruct_ProjectCurveOnSurface {
    constructor();
  }

  export declare class Handle_ShapeConstruct_ProjectCurveOnSurface_2 extends Handle_ShapeConstruct_ProjectCurveOnSurface {
    constructor(thePtr: ShapeConstruct_ProjectCurveOnSurface);
  }

  export declare class Handle_ShapeConstruct_ProjectCurveOnSurface_3 extends Handle_ShapeConstruct_ProjectCurveOnSurface {
    constructor(theHandle: Handle_ShapeConstruct_ProjectCurveOnSurface);
  }

  export declare class Handle_ShapeConstruct_ProjectCurveOnSurface_4 extends Handle_ShapeConstruct_ProjectCurveOnSurface {
    constructor(theHandle: Handle_ShapeConstruct_ProjectCurveOnSurface);
  }

export declare class ShapeConstruct_ProjectCurveOnSurface extends Standard_Transient {
  constructor()
  Init_1(surf: Handle_Geom_Surface, preci: Quantity_AbsorbedDose): void;
  Init_2(surf: Handle_ShapeAnalysis_Surface, preci: Quantity_AbsorbedDose): void;
  SetSurface_1(surf: Handle_Geom_Surface): void;
  SetSurface_2(surf: Handle_ShapeAnalysis_Surface): void;
  SetPrecision(preci: Quantity_AbsorbedDose): void;
  BuildCurveMode(): Standard_Boolean;
  AdjustOverDegenMode(): Graphic3d_ZLayerId;
  Status(theStatus: ShapeExtend_Status): Standard_Boolean;
  Perform(c3d: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, c2d: Handle_Geom2d_Curve, TolFirst: Quantity_AbsorbedDose, TolLast: Quantity_AbsorbedDose): Standard_Boolean;
  PerformByProjLib(c3d: Handle_Geom_Curve, First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, c2d: Handle_Geom2d_Curve, continuity: GeomAbs_Shape, maxdeg: Graphic3d_ZLayerId, nbinterval: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ShapeConstruct_MakeTriangulation extends BRepBuilderAPI_MakeShape {
  Build(): void;
  IsDone(): Standard_Boolean;
  delete(): void;
}

  export declare class ShapeConstruct_MakeTriangulation_1 extends ShapeConstruct_MakeTriangulation {
    constructor(pnts: TColgp_Array1OfPnt, prec: Quantity_AbsorbedDose);
  }

  export declare class ShapeConstruct_MakeTriangulation_2 extends ShapeConstruct_MakeTriangulation {
    constructor(wire: TopoDS_Wire, prec: Quantity_AbsorbedDose);
  }

export declare class RWStepBasic_RWSiUnitAndAreaUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndAreaUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndAreaUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWWeekOfYearAndDayDate {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_WeekOfYearAndDayDate): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_WeekOfYearAndDayDate): void;
  delete(): void;
}

export declare class RWStepBasic_RWGroupAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_GroupAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_GroupAssignment): void;
  Share(ent: Handle_StepBasic_GroupAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndVolumeUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndVolumeUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndVolumeUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndVolumeUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndLengthUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndLengthUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndLengthUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndLengthUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndLengthUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndLengthUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndLengthUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWCertification {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Certification): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Certification): void;
  Share(ent: Handle_StepBasic_Certification, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndMassUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndMassUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndMassUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionEffectivity {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionEffectivity): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionEffectivity): void;
  Share(ent: Handle_StepBasic_ProductDefinitionEffectivity, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWOrganization {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Organization): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Organization): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductCategory {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductCategory): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductCategory): void;
  delete(): void;
}

export declare class RWStepBasic_RWMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_MeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_MeasureWithUnit): void;
  Share(ent: Handle_StepBasic_MeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWPersonalAddress {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_PersonalAddress): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_PersonalAddress): void;
  Share(ent: Handle_StepBasic_PersonalAddress, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnit): void;
  DecodePrefix(aPrefix: StepBasic_SiPrefix, text: Standard_CString): Standard_Boolean;
  DecodeName(aName: StepBasic_SiUnitName, text: Standard_CString): Standard_Boolean;
  EncodePrefix(aPrefix: StepBasic_SiPrefix): XCAFDoc_PartId;
  EncodeName(aName: StepBasic_SiUnitName): XCAFDoc_PartId;
  delete(): void;
}

export declare class RWStepBasic_RWLengthUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_LengthUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_LengthUnit): void;
  Share(ent: Handle_StepBasic_LengthUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndRatioUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndRatioUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndRatioUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndRatioUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWActionMethod {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ActionMethod): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ActionMethod): void;
  Share(ent: Handle_StepBasic_ActionMethod, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndSolidAngleUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndSolidAngleUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndSolidAngleUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionReferenceWithLocalRepresentation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation): void;
  Share(ent: Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndPlaneAngleUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionFormationRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionFormationRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionFormationRelationship): void;
  Share(ent: Handle_StepBasic_ProductDefinitionFormationRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSecurityClassification {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SecurityClassification): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SecurityClassification): void;
  Share(ent: Handle_StepBasic_SecurityClassification, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWMassMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_MassMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_MassMeasureWithUnit): void;
  Share(ent: Handle_StepBasic_MassMeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWContractType {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ContractType): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ContractType): void;
  Share(ent: Handle_StepBasic_ContractType, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndSolidAngleUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWExternallyDefinedItem {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ExternallyDefinedItem): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ExternallyDefinedItem): void;
  Share(ent: Handle_StepBasic_ExternallyDefinedItem, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWCertificationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_CertificationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_CertificationAssignment): void;
  Share(ent: Handle_StepBasic_CertificationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWContract {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Contract): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Contract): void;
  Share(ent: Handle_StepBasic_Contract, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWGeneralProperty {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_GeneralProperty): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_GeneralProperty): void;
  Share(ent: Handle_StepBasic_GeneralProperty, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWActionAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ActionAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ActionAssignment): void;
  Share(ent: Handle_StepBasic_ActionAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDate {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Date): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Date): void;
  delete(): void;
}

export declare class RWStepBasic_RWGroup {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Group): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Group): void;
  Share(ent: Handle_StepBasic_Group, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApplicationProtocolDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApplicationProtocolDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApplicationProtocolDefinition): void;
  Share(ent: Handle_StepBasic_ApplicationProtocolDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWMassUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_MassUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_MassUnit): void;
  Share(ent: Handle_StepBasic_MassUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentUsageConstraint {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentUsageConstraint): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentUsageConstraint): void;
  Share(ent: Handle_StepBasic_DocumentUsageConstraint, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductConceptContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductConceptContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductConceptContext): void;
  Share(ent: Handle_StepBasic_ProductConceptContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWOrganizationRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_OrganizationRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_OrganizationRole): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndAreaUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndAreaUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndAreaUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndAreaUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWEffectivityAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_EffectivityAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_EffectivityAssignment): void;
  Share(ent: Handle_StepBasic_EffectivityAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductCategoryRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductCategoryRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductCategoryRelationship): void;
  Share(ent: Handle_StepBasic_ProductCategoryRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWNameAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_NameAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_NameAssignment): void;
  Share(ent: Handle_StepBasic_NameAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWPlaneAngleUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_PlaneAngleUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_PlaneAngleUnit): void;
  Share(ent: Handle_StepBasic_PlaneAngleUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentProductAssociation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentProductAssociation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentProductAssociation): void;
  Share(ent: Handle_StepBasic_DocumentProductAssociation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionFormationWithSpecifiedSource {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource): void;
  Share(ent: Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWGroupRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_GroupRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_GroupRelationship): void;
  Share(ent: Handle_StepBasic_GroupRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApprovalRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApprovalRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApprovalRelationship): void;
  Share(ent: Handle_StepBasic_ApprovalRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWLocalTime {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_LocalTime): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_LocalTime): void;
  Share(ent: Handle_StepBasic_LocalTime, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWActionRequestAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ActionRequestAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ActionRequestAssignment): void;
  Share(ent: Handle_StepBasic_ActionRequestAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSolidAngleMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SolidAngleMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SolidAngleMeasureWithUnit): void;
  Share(ent: Handle_StepBasic_SolidAngleMeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionFormation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionFormation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionFormation): void;
  Share(ent: Handle_StepBasic_ProductDefinitionFormation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentProductEquivalence {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentProductEquivalence): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentProductEquivalence): void;
  Share(ent: Handle_StepBasic_DocumentProductEquivalence, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionReference): void;
  Share(ent: Handle_StepBasic_ProductDefinitionReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndRatioUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndRatioUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndRatioUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWPerson {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Person): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Person): void;
  delete(): void;
}

export declare class RWStepBasic_RWDerivedUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DerivedUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DerivedUnit): void;
  Share(ent: Handle_StepBasic_DerivedUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndTimeUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndTimeUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndTimeUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndVolumeUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndVolumeUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndVolumeUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinition {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinition): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinition): void;
  Share(ent: Handle_StepBasic_ProductDefinition, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApplicationContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApplicationContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApplicationContext): void;
  delete(): void;
}

export declare class RWStepBasic_RWDerivedUnitElement {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DerivedUnitElement): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DerivedUnitElement): void;
  Share(ent: Handle_StepBasic_DerivedUnitElement, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApprovalStatus {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApprovalStatus): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApprovalStatus): void;
  delete(): void;
}

export declare class RWStepBasic_RWSecurityClassificationLevel {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SecurityClassificationLevel): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SecurityClassificationLevel): void;
  delete(): void;
}

export declare class RWStepBasic_RWUncertaintyMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_UncertaintyMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_UncertaintyMeasureWithUnit): void;
  Share(ent: Handle_StepBasic_UncertaintyMeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDateTimeRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DateTimeRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DateTimeRole): void;
  delete(): void;
}

export declare class RWStepBasic_RWEffectivity {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Effectivity): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Effectivity): void;
  Share(ent: Handle_StepBasic_Effectivity, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWPersonAndOrganization {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_PersonAndOrganization): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_PersonAndOrganization): void;
  Share(ent: Handle_StepBasic_PersonAndOrganization, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDateAndTime {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DateAndTime): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DateAndTime): void;
  Share(ent: Handle_StepBasic_DateAndTime, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndMassUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndMassUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndMassUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndMassUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSolidAngleUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SolidAngleUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SolidAngleUnit): void;
  Share(ent: Handle_StepBasic_SolidAngleUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWMechanicalContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_MechanicalContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_MechanicalContext): void;
  Share(ent: Handle_StepBasic_MechanicalContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApplicationContextElement {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApplicationContextElement): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApplicationContextElement): void;
  Share(ent: Handle_StepBasic_ApplicationContextElement, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndPlaneAngleUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndPlaneAngleUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndPlaneAngleUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWOrganizationalAddress {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_OrganizationalAddress): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_OrganizationalAddress): void;
  Share(ent: Handle_StepBasic_OrganizationalAddress, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWExternalSource {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ExternalSource): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ExternalSource): void;
  Share(ent: Handle_StepBasic_ExternalSource, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductRelatedProductCategory {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductRelatedProductCategory): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductRelatedProductCategory): void;
  Share(ent: Handle_StepBasic_ProductRelatedProductCategory, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocument {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Document): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Document): void;
  Share(ent: Handle_StepBasic_Document, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWAddress {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Address): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Address): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentType {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentType): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentType): void;
  Share(ent: Handle_StepBasic_DocumentType, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApprovalPersonOrganization {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApprovalPersonOrganization): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApprovalPersonOrganization): void;
  Share(ent: Handle_StepBasic_ApprovalPersonOrganization, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProduct {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Product): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Product): void;
  Share(ent: Handle_StepBasic_Product, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentFile {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentFile): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentFile): void;
  Share(ent: Handle_StepBasic_DocumentFile, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWPersonAndOrganizationRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_PersonAndOrganizationRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_PersonAndOrganizationRole): void;
  delete(): void;
}

export declare class RWStepBasic_RWApprovalDateTime {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApprovalDateTime): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApprovalDateTime): void;
  Share(ent: Handle_StepBasic_ApprovalDateTime, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentRepresentationType {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentRepresentationType): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentRepresentationType): void;
  Share(ent: Handle_StepBasic_DocumentRepresentationType, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDateRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DateRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DateRole): void;
  delete(): void;
}

export declare class RWStepBasic_RWDocumentRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DocumentRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DocumentRelationship): void;
  Share(ent: Handle_StepBasic_DocumentRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWContractAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ContractAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ContractAssignment): void;
  Share(ent: Handle_StepBasic_ContractAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWApproval {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Approval): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Approval): void;
  Share(ent: Handle_StepBasic_Approval, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWIdentificationRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_IdentificationRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_IdentificationRole): void;
  Share(ent: Handle_StepBasic_IdentificationRole, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWSiUnitAndThermodynamicTemperatureUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit): void;
  delete(): void;
}

export declare class RWStepBasic_RWOrdinalDate {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_OrdinalDate): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_OrdinalDate): void;
  delete(): void;
}

export declare class RWStepBasic_RWActionRequestSolution {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ActionRequestSolution): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ActionRequestSolution): void;
  Share(ent: Handle_StepBasic_ActionRequestSolution, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWRoleAssociation {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_RoleAssociation): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_RoleAssociation): void;
  Share(ent: Handle_StepBasic_RoleAssociation, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWDimensionalExponents {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_DimensionalExponents): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_DimensionalExponents): void;
  delete(): void;
}

export declare class RWStepBasic_RWApprovalRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ApprovalRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ApprovalRole): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductType {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductType): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductType): void;
  Share(ent: Handle_StepBasic_ProductType, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionRelationship {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionRelationship): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionRelationship): void;
  Share(ent: Handle_StepBasic_ProductDefinitionRelationship, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWThermodynamicTemperatureUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ThermodynamicTemperatureUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ThermodynamicTemperatureUnit): void;
  Share(ent: Handle_StepBasic_ThermodynamicTemperatureUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWCoordinatedUniversalTimeOffset {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_CoordinatedUniversalTimeOffset): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_CoordinatedUniversalTimeOffset): void;
  delete(): void;
}

export declare class RWStepBasic_RWExternalIdentificationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ExternalIdentificationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ExternalIdentificationAssignment): void;
  Share(ent: Handle_StepBasic_ExternalIdentificationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWAction {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_Action): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_Action): void;
  Share(ent: Handle_StepBasic_Action, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWLengthMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_LengthMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_LengthMeasureWithUnit): void;
  Share(ent: Handle_StepBasic_LengthMeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWCalendarDate {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_CalendarDate): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_CalendarDate): void;
  delete(): void;
}

export declare class RWStepBasic_RWIdentificationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_IdentificationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_IdentificationAssignment): void;
  Share(ent: Handle_StepBasic_IdentificationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWCharacterizedObject {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_CharacterizedObject): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_CharacterizedObject): void;
  Share(ent: Handle_StepBasic_CharacterizedObject, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWConversionBasedUnitAndTimeUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ConversionBasedUnitAndTimeUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ConversionBasedUnitAndTimeUnit): void;
  Share(ent: Handle_StepBasic_ConversionBasedUnitAndTimeUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWVersionedActionRequest {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_VersionedActionRequest): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_VersionedActionRequest): void;
  Share(ent: Handle_StepBasic_VersionedActionRequest, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWCertificationType {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_CertificationType): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_CertificationType): void;
  Share(ent: Handle_StepBasic_CertificationType, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWNamedUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_NamedUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_NamedUnit): void;
  Share(ent: Handle_StepBasic_NamedUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionWithAssociatedDocuments {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionWithAssociatedDocuments): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionWithAssociatedDocuments): void;
  Share(ent: Handle_StepBasic_ProductDefinitionWithAssociatedDocuments, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWPlaneAngleMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_PlaneAngleMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_PlaneAngleMeasureWithUnit): void;
  Share(ent: Handle_StepBasic_PlaneAngleMeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWRatioMeasureWithUnit {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_RatioMeasureWithUnit): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_RatioMeasureWithUnit): void;
  Share(ent: Handle_StepBasic_RatioMeasureWithUnit, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductContext): void;
  Share(ent: Handle_StepBasic_ProductContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWEulerAngles {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_EulerAngles): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_EulerAngles): void;
  Share(ent: Handle_StepBasic_EulerAngles, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWObjectRole {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ObjectRole): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ObjectRole): void;
  Share(ent: Handle_StepBasic_ObjectRole, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepBasic_RWProductDefinitionContext {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepBasic_ProductDefinitionContext): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepBasic_ProductDefinitionContext): void;
  Share(ent: Handle_StepBasic_ProductDefinitionContext, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class IntPolyh_Triangle {
  FirstPoint(): Graphic3d_ZLayerId;
  SecondPoint(): Graphic3d_ZLayerId;
  ThirdPoint(): Graphic3d_ZLayerId;
  FirstEdge(): Graphic3d_ZLayerId;
  FirstEdgeOrientation(): Graphic3d_ZLayerId;
  SecondEdge(): Graphic3d_ZLayerId;
  SecondEdgeOrientation(): Graphic3d_ZLayerId;
  ThirdEdge(): Graphic3d_ZLayerId;
  ThirdEdgeOrientation(): Graphic3d_ZLayerId;
  Deflection(): Quantity_AbsorbedDose;
  IsIntersectionPossible(): Standard_Boolean;
  HasIntersection(): Standard_Boolean;
  IsDegenerated(): Standard_Boolean;
  SetFirstPoint(thePoint: Graphic3d_ZLayerId): void;
  SetSecondPoint(thePoint: Graphic3d_ZLayerId): void;
  SetThirdPoint(thePoint: Graphic3d_ZLayerId): void;
  SetFirstEdge(theEdge: Graphic3d_ZLayerId, theEdgeOrientation: Graphic3d_ZLayerId): void;
  SetSecondEdge(theEdge: Graphic3d_ZLayerId, theEdgeOrientation: Graphic3d_ZLayerId): void;
  SetThirdEdge(theEdge: Graphic3d_ZLayerId, theEdgeOrientation: Graphic3d_ZLayerId): void;
  SetDeflection(theDeflection: Quantity_AbsorbedDose): void;
  SetIntersectionPossible(theIP: Standard_Boolean): void;
  SetIntersection(theInt: Standard_Boolean): void;
  SetDegenerated(theDegFlag: Standard_Boolean): void;
  GetEdgeNumber(theEdgeIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetEdge(theEdgeIndex: Graphic3d_ZLayerId, theEdgeNumber: Graphic3d_ZLayerId): void;
  GetEdgeOrientation(theEdgeIndex: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetEdgeOrientation(theEdgeIndex: Graphic3d_ZLayerId, theEdgeOrientation: Graphic3d_ZLayerId): void;
  ComputeDeflection(theSurface: Handle_Adaptor3d_HSurface, thePoints: IntPolyh_ArrayOfPoints): Quantity_AbsorbedDose;
  GetNextTriangle(theTriangle: Graphic3d_ZLayerId, theEdgeNum: Graphic3d_ZLayerId, TEdges: IntPolyh_ArrayOfEdges): Graphic3d_ZLayerId;
  MiddleRefinement(theTriangleNumber: Graphic3d_ZLayerId, theSurface: Handle_Adaptor3d_HSurface, TPoints: IntPolyh_ArrayOfPoints, TTriangles: IntPolyh_ArrayOfTriangles, TEdges: IntPolyh_ArrayOfEdges): void;
  MultipleMiddleRefinement(theRefineCriterion: Quantity_AbsorbedDose, theBox: Bnd_Box, theTriangleNumber: Graphic3d_ZLayerId, theSurface: Handle_Adaptor3d_HSurface, TPoints: IntPolyh_ArrayOfPoints, TTriangles: IntPolyh_ArrayOfTriangles, TEdges: IntPolyh_ArrayOfEdges): void;
  LinkEdges2Triangle(TEdges: IntPolyh_ArrayOfEdges, theEdge1: Graphic3d_ZLayerId, theEdge2: Graphic3d_ZLayerId, theEdge3: Graphic3d_ZLayerId): void;
  SetEdgeAndOrientation(theEdge: IntPolyh_Edge, theEdgeIndex: Graphic3d_ZLayerId): void;
  BoundingBox(thePoints: IntPolyh_ArrayOfPoints): Bnd_Box;
  Dump(v: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class IntPolyh_Triangle_1 extends IntPolyh_Triangle {
    constructor();
  }

  export declare class IntPolyh_Triangle_2 extends IntPolyh_Triangle {
    constructor(thePoint1: Graphic3d_ZLayerId, thePoint2: Graphic3d_ZLayerId, thePoint3: Graphic3d_ZLayerId);
  }

export declare class IntPolyh_SeqOfStartPoints extends NCollection_BaseSequence {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Reverse(): void;
  Exchange(I: Standard_Integer, J: Standard_Integer): void;
  static delNode(theNode: NCollection_SeqNode, theAl: Handle_NCollection_BaseAllocator): void;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  Assign(theOther: IntPolyh_SeqOfStartPoints): IntPolyh_SeqOfStartPoints;
  Remove_2(theIndex: Standard_Integer): void;
  Remove_3(theFromIndex: Standard_Integer, theToIndex: Standard_Integer): void;
  Append_1(theItem: IntPolyh_StartPoint): void;
  Append_2(theSeq: IntPolyh_SeqOfStartPoints): void;
  Prepend_1(theItem: IntPolyh_StartPoint): void;
  Prepend_2(theSeq: IntPolyh_SeqOfStartPoints): void;
  InsertBefore_1(theIndex: Standard_Integer, theItem: IntPolyh_StartPoint): void;
  InsertBefore_2(theIndex: Standard_Integer, theSeq: IntPolyh_SeqOfStartPoints): void;
  InsertAfter_2(theIndex: Standard_Integer, theSeq: IntPolyh_SeqOfStartPoints): void;
  InsertAfter_3(theIndex: Standard_Integer, theItem: IntPolyh_StartPoint): void;
  Split(theIndex: Standard_Integer, theSeq: IntPolyh_SeqOfStartPoints): void;
  First(): IntPolyh_StartPoint;
  ChangeFirst(): IntPolyh_StartPoint;
  Last(): IntPolyh_StartPoint;
  ChangeLast(): IntPolyh_StartPoint;
  Value(theIndex: Standard_Integer): IntPolyh_StartPoint;
  ChangeValue(theIndex: Standard_Integer): IntPolyh_StartPoint;
  SetValue(theIndex: Standard_Integer, theItem: IntPolyh_StartPoint): void;
  delete(): void;
}

  export declare class IntPolyh_SeqOfStartPoints_1 extends IntPolyh_SeqOfStartPoints {
    constructor();
  }

  export declare class IntPolyh_SeqOfStartPoints_2 extends IntPolyh_SeqOfStartPoints {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntPolyh_SeqOfStartPoints_3 extends IntPolyh_SeqOfStartPoints {
    constructor(theOther: IntPolyh_SeqOfStartPoints);
  }

export declare class IntPolyh_StartPoint {
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  U1(): Quantity_AbsorbedDose;
  V1(): Quantity_AbsorbedDose;
  U2(): Quantity_AbsorbedDose;
  V2(): Quantity_AbsorbedDose;
  T1(): Graphic3d_ZLayerId;
  E1(): Graphic3d_ZLayerId;
  Lambda1(): Quantity_AbsorbedDose;
  T2(): Graphic3d_ZLayerId;
  E2(): Graphic3d_ZLayerId;
  Lambda2(): Quantity_AbsorbedDose;
  GetAngle(): Quantity_AbsorbedDose;
  ChainList(): Graphic3d_ZLayerId;
  GetEdgePoints(Triangle: IntPolyh_Triangle, FirstEdgePoint: Graphic3d_ZLayerId, SecondEdgePoint: Graphic3d_ZLayerId, LastPoint: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetXYZ(XX: Quantity_AbsorbedDose, YY: Quantity_AbsorbedDose, ZZ: Quantity_AbsorbedDose): void;
  SetUV1(UU1: Quantity_AbsorbedDose, VV1: Quantity_AbsorbedDose): void;
  SetUV2(UU2: Quantity_AbsorbedDose, VV2: Quantity_AbsorbedDose): void;
  SetEdge1(IE1: Graphic3d_ZLayerId): void;
  SetLambda1(LAM1: Quantity_AbsorbedDose): void;
  SetEdge2(IE2: Graphic3d_ZLayerId): void;
  SetLambda2(LAM2: Quantity_AbsorbedDose): void;
  SetCoupleValue(IT1: Graphic3d_ZLayerId, IT2: Graphic3d_ZLayerId): void;
  SetAngle(ang: Quantity_AbsorbedDose): void;
  SetChainList(ChList: Graphic3d_ZLayerId): void;
  CheckSameSP(SP: IntPolyh_StartPoint): Graphic3d_ZLayerId;
  Dump_1(): void;
  Dump_2(i: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class IntPolyh_StartPoint_1 extends IntPolyh_StartPoint {
    constructor();
  }

  export declare class IntPolyh_StartPoint_2 extends IntPolyh_StartPoint {
    constructor(xx: Quantity_AbsorbedDose, yy: Quantity_AbsorbedDose, zz: Quantity_AbsorbedDose, uu1: Quantity_AbsorbedDose, vv1: Quantity_AbsorbedDose, uu2: Quantity_AbsorbedDose, vv2: Quantity_AbsorbedDose, T1: Graphic3d_ZLayerId, E1: Graphic3d_ZLayerId, LAM1: Quantity_AbsorbedDose, T2: Graphic3d_ZLayerId, E2: Graphic3d_ZLayerId, LAM2: Quantity_AbsorbedDose, List: Graphic3d_ZLayerId);
  }

export declare class IntPolyh_Edge {
  FirstPoint(): Graphic3d_ZLayerId;
  SecondPoint(): Graphic3d_ZLayerId;
  FirstTriangle(): Graphic3d_ZLayerId;
  SecondTriangle(): Graphic3d_ZLayerId;
  SetFirstPoint(thePoint: Graphic3d_ZLayerId): void;
  SetSecondPoint(thePoint: Graphic3d_ZLayerId): void;
  SetFirstTriangle(theTriangle: Graphic3d_ZLayerId): void;
  SetSecondTriangle(theTriangle: Graphic3d_ZLayerId): void;
  Dump(v: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class IntPolyh_Edge_1 extends IntPolyh_Edge {
    constructor();
  }

  export declare class IntPolyh_Edge_2 extends IntPolyh_Edge {
    constructor(thePoint1: Graphic3d_ZLayerId, thePoint2: Graphic3d_ZLayerId, theTriangle1: Graphic3d_ZLayerId, theTriangle2: Graphic3d_ZLayerId);
  }

export declare class IntPolyh_Couple {
  FirstValue(): Graphic3d_ZLayerId;
  SecondValue(): Graphic3d_ZLayerId;
  IsAnalyzed(): Standard_Boolean;
  Angle(): Quantity_AbsorbedDose;
  SetCoupleValue(theInd1: Graphic3d_ZLayerId, theInd2: Graphic3d_ZLayerId): void;
  SetAnalyzed(theAnalyzed: Standard_Boolean): void;
  SetAngle(theAngle: Quantity_AbsorbedDose): void;
  IsEqual(theOther: IntPolyh_Couple): Standard_Boolean;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Dump(v: Graphic3d_ZLayerId): void;
  delete(): void;
}

  export declare class IntPolyh_Couple_1 extends IntPolyh_Couple {
    constructor();
  }

  export declare class IntPolyh_Couple_2 extends IntPolyh_Couple {
    constructor(theTriangle1: Graphic3d_ZLayerId, theTriangle2: Graphic3d_ZLayerId, theAngle: Quantity_AbsorbedDose);
  }

export declare class IntPolyh_SectionLine {
  Init(nn: Graphic3d_ZLayerId): void;
  Value(nn: Graphic3d_ZLayerId): IntPolyh_StartPoint;
  ChangeValue(nn: Graphic3d_ZLayerId): IntPolyh_StartPoint;
  Copy(Other: IntPolyh_SectionLine): IntPolyh_SectionLine;
  GetN(): Graphic3d_ZLayerId;
  NbStartPoints(): Graphic3d_ZLayerId;
  IncrementNbStartPoints(): void;
  Destroy(): void;
  Dump(): void;
  Prepend(SP: IntPolyh_StartPoint): void;
  delete(): void;
}

  export declare class IntPolyh_SectionLine_1 extends IntPolyh_SectionLine {
    constructor();
  }

  export declare class IntPolyh_SectionLine_2 extends IntPolyh_SectionLine {
    constructor(nn: Graphic3d_ZLayerId);
  }

export declare class IntPolyh_Intersection {
  IsDone(): Standard_Boolean;
  NbSectionLines(): Graphic3d_ZLayerId;
  NbPointsInLine(IndexLine: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  NbTangentZones(): Graphic3d_ZLayerId;
  NbPointsInTangentZone(a0: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  GetLinePoint(IndexLine: Graphic3d_ZLayerId, IndexPoint: Graphic3d_ZLayerId, x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose, incidence: Quantity_AbsorbedDose): void;
  GetTangentZonePoint(IndexLine: Graphic3d_ZLayerId, IndexPoint: Graphic3d_ZLayerId, x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, u1: Quantity_AbsorbedDose, v1: Quantity_AbsorbedDose, u2: Quantity_AbsorbedDose, v2: Quantity_AbsorbedDose): void;
  delete(): void;
}

  export declare class IntPolyh_Intersection_1 extends IntPolyh_Intersection {
    constructor(theS1: Handle_Adaptor3d_HSurface, theS2: Handle_Adaptor3d_HSurface);
  }

  export declare class IntPolyh_Intersection_2 extends IntPolyh_Intersection {
    constructor(theS1: Handle_Adaptor3d_HSurface, theNbSU1: Graphic3d_ZLayerId, theNbSV1: Graphic3d_ZLayerId, theS2: Handle_Adaptor3d_HSurface, theNbSU2: Graphic3d_ZLayerId, theNbSV2: Graphic3d_ZLayerId);
  }

  export declare class IntPolyh_Intersection_3 extends IntPolyh_Intersection {
    constructor(theS1: Handle_Adaptor3d_HSurface, theUPars1: TColStd_Array1OfReal, theVPars1: TColStd_Array1OfReal, theS2: Handle_Adaptor3d_HSurface, theUPars2: TColStd_Array1OfReal, theVPars2: TColStd_Array1OfReal);
  }

export declare class IntPolyh_Tools {
  constructor();
  static IsEnlargePossible(theSurf: Handle_Adaptor3d_HSurface, theUEnlarge: Standard_Boolean, theVEnlarge: Standard_Boolean): void;
  static MakeSampling(theSurf: Handle_Adaptor3d_HSurface, theNbSU: Graphic3d_ZLayerId, theNbSV: Graphic3d_ZLayerId, theEnlargeZone: Standard_Boolean, theUPars: TColStd_Array1OfReal, theVPars: TColStd_Array1OfReal): void;
  static ComputeDeflection(theSurf: Handle_Adaptor3d_HSurface, theUPars: TColStd_Array1OfReal, theVPars: TColStd_Array1OfReal): Quantity_AbsorbedDose;
  static FillArrayOfPointNormal(theSurf: Handle_Adaptor3d_HSurface, theUPars: TColStd_Array1OfReal, theVPars: TColStd_Array1OfReal, thePoints: IntPolyh_ArrayOfPointNormal): void;
  delete(): void;
}

export declare class IntPolyh_PointNormal {
  constructor();
  delete(): void;
}

export declare class IntPolyh_Point {
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Z(): Quantity_AbsorbedDose;
  U(): Quantity_AbsorbedDose;
  V(): Quantity_AbsorbedDose;
  PartOfCommon(): Graphic3d_ZLayerId;
  Set(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose, II: Graphic3d_ZLayerId): void;
  SetX(x: Quantity_AbsorbedDose): void;
  SetY(y: Quantity_AbsorbedDose): void;
  SetZ(z: Quantity_AbsorbedDose): void;
  SetU(u: Quantity_AbsorbedDose): void;
  SetV(v: Quantity_AbsorbedDose): void;
  SetPartOfCommon(ii: Graphic3d_ZLayerId): void;
  Middle(MySurface: Handle_Adaptor3d_HSurface, P1: IntPolyh_Point, P2: IntPolyh_Point): void;
  Add(P1: IntPolyh_Point): IntPolyh_Point;
  Sub(P1: IntPolyh_Point): IntPolyh_Point;
  Divide(rr: Quantity_AbsorbedDose): IntPolyh_Point;
  Multiplication(rr: Quantity_AbsorbedDose): IntPolyh_Point;
  SquareModulus(): Quantity_AbsorbedDose;
  SquareDistance(P2: IntPolyh_Point): Quantity_AbsorbedDose;
  Dot(P2: IntPolyh_Point): Quantity_AbsorbedDose;
  Cross(P1: IntPolyh_Point, P2: IntPolyh_Point): void;
  Dump_1(): void;
  Dump_2(i: Graphic3d_ZLayerId): void;
  SetDegenerated(theFlag: Standard_Boolean): void;
  Degenerated(): Standard_Boolean;
  delete(): void;
}

  export declare class IntPolyh_Point_1 extends IntPolyh_Point {
    constructor();
  }

  export declare class IntPolyh_Point_2 extends IntPolyh_Point {
    constructor(x: Quantity_AbsorbedDose, y: Quantity_AbsorbedDose, z: Quantity_AbsorbedDose, u: Quantity_AbsorbedDose, v: Quantity_AbsorbedDose);
  }

export declare class IntPolyh_CoupleMapHasher {
  constructor();
  static HashCode(theCouple: IntPolyh_Couple, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(theCouple1: IntPolyh_Couple, theCouple2: IntPolyh_Couple): Standard_Boolean;
  delete(): void;
}

export declare class IntPolyh_ListOfCouples extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: IntPolyh_ListOfCouples): IntPolyh_ListOfCouples;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): IntPolyh_Couple;
  First_2(): IntPolyh_Couple;
  Last_1(): IntPolyh_Couple;
  Last_2(): IntPolyh_Couple;
  Append_1(theItem: IntPolyh_Couple): IntPolyh_Couple;
  Append_3(theOther: IntPolyh_ListOfCouples): void;
  Prepend_1(theItem: IntPolyh_Couple): IntPolyh_Couple;
  Prepend_2(theOther: IntPolyh_ListOfCouples): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class IntPolyh_ListOfCouples_1 extends IntPolyh_ListOfCouples {
    constructor();
  }

  export declare class IntPolyh_ListOfCouples_2 extends IntPolyh_ListOfCouples {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class IntPolyh_ListOfCouples_3 extends IntPolyh_ListOfCouples {
    constructor(theOther: IntPolyh_ListOfCouples);
  }

export declare class RWStepAP203_RWChangeRequest {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_ChangeRequest): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_ChangeRequest): void;
  Share(ent: Handle_StepAP203_ChangeRequest, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignApproval {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignApproval): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignApproval): void;
  Share(ent: Handle_StepAP203_CcDesignApproval, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignPersonAndOrganizationAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignPersonAndOrganizationAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignPersonAndOrganizationAssignment): void;
  Share(ent: Handle_StepAP203_CcDesignPersonAndOrganizationAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignContract {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignContract): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignContract): void;
  Share(ent: Handle_StepAP203_CcDesignContract, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWStartRequest {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_StartRequest): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_StartRequest): void;
  Share(ent: Handle_StepAP203_StartRequest, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignSecurityClassification {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignSecurityClassification): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignSecurityClassification): void;
  Share(ent: Handle_StepAP203_CcDesignSecurityClassification, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignCertification {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignCertification): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignCertification): void;
  Share(ent: Handle_StepAP203_CcDesignCertification, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWChange {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_Change): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_Change): void;
  Share(ent: Handle_StepAP203_Change, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWStartWork {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_StartWork): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_StartWork): void;
  Share(ent: Handle_StepAP203_StartWork, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignDateAndTimeAssignment {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignDateAndTimeAssignment): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignDateAndTimeAssignment): void;
  Share(ent: Handle_StepAP203_CcDesignDateAndTimeAssignment, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class RWStepAP203_RWCcDesignSpecificationReference {
  constructor()
  ReadStep(data: Handle_StepData_StepReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_StepAP203_CcDesignSpecificationReference): void;
  WriteStep(SW: StepData_StepWriter, ent: Handle_StepAP203_CcDesignSpecificationReference): void;
  Share(ent: Handle_StepAP203_CcDesignSpecificationReference, iter: Interface_EntityIterator): void;
  delete(): void;
}

export declare class TDataXtd_Constraint extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataXtd_Constraint;
  Set_2(type: TDataXtd_ConstraintEnum, G1: Handle_TNaming_NamedShape): void;
  Set_3(type: TDataXtd_ConstraintEnum, G1: Handle_TNaming_NamedShape, G2: Handle_TNaming_NamedShape): void;
  Set_4(type: TDataXtd_ConstraintEnum, G1: Handle_TNaming_NamedShape, G2: Handle_TNaming_NamedShape, G3: Handle_TNaming_NamedShape): void;
  Set_5(type: TDataXtd_ConstraintEnum, G1: Handle_TNaming_NamedShape, G2: Handle_TNaming_NamedShape, G3: Handle_TNaming_NamedShape, G4: Handle_TNaming_NamedShape): void;
  Verified_1(): Standard_Boolean;
  GetType(): TDataXtd_ConstraintEnum;
  IsPlanar(): Standard_Boolean;
  GetPlane(): Handle_TNaming_NamedShape;
  IsDimension(): Standard_Boolean;
  GetValue(): Handle_TDataStd_Real;
  NbGeometries(): Graphic3d_ZLayerId;
  GetGeometry(Index: Graphic3d_ZLayerId): Handle_TNaming_NamedShape;
  ClearGeometries(): void;
  SetType(CTR: TDataXtd_ConstraintEnum): void;
  SetPlane(plane: Handle_TNaming_NamedShape): void;
  SetValue(V: Handle_TDataStd_Real): void;
  SetGeometry(Index: Graphic3d_ZLayerId, G: Handle_TNaming_NamedShape): void;
  Verified_2(status: Standard_Boolean): void;
  Inverted_1(status: Standard_Boolean): void;
  Inverted_2(): Standard_Boolean;
  Reversed_1(status: Standard_Boolean): void;
  Reversed_2(): Standard_Boolean;
  static CollectChildConstraints(aLabel: TDF_Label, TheList: TDF_LabelList): void;
  ID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(DS: Handle_TDF_DataSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataXtd_Constraint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Constraint): void;
  get(): TDataXtd_Constraint;
  delete(): void;
}

  export declare class Handle_TDataXtd_Constraint_1 extends Handle_TDataXtd_Constraint {
    constructor();
  }

  export declare class Handle_TDataXtd_Constraint_2 extends Handle_TDataXtd_Constraint {
    constructor(thePtr: TDataXtd_Constraint);
  }

  export declare class Handle_TDataXtd_Constraint_3 extends Handle_TDataXtd_Constraint {
    constructor(theHandle: Handle_TDataXtd_Constraint);
  }

  export declare class Handle_TDataXtd_Constraint_4 extends Handle_TDataXtd_Constraint {
    constructor(theHandle: Handle_TDataXtd_Constraint);
  }

export declare class Handle_TDataXtd_HArray1OfTrsf {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_HArray1OfTrsf): void;
  get(): TDataXtd_HArray1OfTrsf;
  delete(): void;
}

  export declare class Handle_TDataXtd_HArray1OfTrsf_1 extends Handle_TDataXtd_HArray1OfTrsf {
    constructor();
  }

  export declare class Handle_TDataXtd_HArray1OfTrsf_2 extends Handle_TDataXtd_HArray1OfTrsf {
    constructor(thePtr: TDataXtd_HArray1OfTrsf);
  }

  export declare class Handle_TDataXtd_HArray1OfTrsf_3 extends Handle_TDataXtd_HArray1OfTrsf {
    constructor(theHandle: Handle_TDataXtd_HArray1OfTrsf);
  }

  export declare class Handle_TDataXtd_HArray1OfTrsf_4 extends Handle_TDataXtd_HArray1OfTrsf {
    constructor(theHandle: Handle_TDataXtd_HArray1OfTrsf);
  }

export declare class TDataXtd_Array1OfTrsf {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: gp_Trsf): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: TDataXtd_Array1OfTrsf): TDataXtd_Array1OfTrsf;
  Move(theOther: TDataXtd_Array1OfTrsf): TDataXtd_Array1OfTrsf;
  First(): gp_Trsf;
  ChangeFirst(): gp_Trsf;
  Last(): gp_Trsf;
  ChangeLast(): gp_Trsf;
  Value(theIndex: Standard_Integer): gp_Trsf;
  ChangeValue(theIndex: Standard_Integer): gp_Trsf;
  SetValue(theIndex: Standard_Integer, theItem: gp_Trsf): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class TDataXtd_Array1OfTrsf_1 extends TDataXtd_Array1OfTrsf {
    constructor();
  }

  export declare class TDataXtd_Array1OfTrsf_2 extends TDataXtd_Array1OfTrsf {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class TDataXtd_Array1OfTrsf_3 extends TDataXtd_Array1OfTrsf {
    constructor(theOther: TDataXtd_Array1OfTrsf);
  }

  export declare class TDataXtd_Array1OfTrsf_4 extends TDataXtd_Array1OfTrsf {
    constructor(theOther: TDataXtd_Array1OfTrsf);
  }

  export declare class TDataXtd_Array1OfTrsf_5 extends TDataXtd_Array1OfTrsf {
    constructor(theBegin: gp_Trsf, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class TDataXtd_Geometry extends TDF_Attribute {
  constructor()
  static Set(label: TDF_Label): Handle_TDataXtd_Geometry;
  static Type_1(L: TDF_Label): TDataXtd_GeometryEnum;
  static Type_2(S: Handle_TNaming_NamedShape): TDataXtd_GeometryEnum;
  static Point_1(L: TDF_Label, G: gp_Pnt): Standard_Boolean;
  static Point_2(S: Handle_TNaming_NamedShape, G: gp_Pnt): Standard_Boolean;
  static Axis_1(L: TDF_Label, G: gp_Ax1): Standard_Boolean;
  static Axis_2(S: Handle_TNaming_NamedShape, G: gp_Ax1): Standard_Boolean;
  static Line_1(L: TDF_Label, G: gp_Lin): Standard_Boolean;
  static Line_2(S: Handle_TNaming_NamedShape, G: gp_Lin): Standard_Boolean;
  static Circle_1(L: TDF_Label, G: gp_Circ): Standard_Boolean;
  static Circle_2(S: Handle_TNaming_NamedShape, G: gp_Circ): Standard_Boolean;
  static Ellipse_1(L: TDF_Label, G: gp_Elips): Standard_Boolean;
  static Ellipse_2(S: Handle_TNaming_NamedShape, G: gp_Elips): Standard_Boolean;
  static Plane_1(L: TDF_Label, G: gp_Pln): Standard_Boolean;
  static Plane_2(S: Handle_TNaming_NamedShape, G: gp_Pln): Standard_Boolean;
  static Cylinder_1(L: TDF_Label, G: gp_Cylinder): Standard_Boolean;
  static Cylinder_2(S: Handle_TNaming_NamedShape, G: gp_Cylinder): Standard_Boolean;
  static GetID(): Standard_GUID;
  SetType(T: TDataXtd_GeometryEnum): void;
  GetType(): TDataXtd_GeometryEnum;
  ID(): Standard_GUID;
  Restore(with_: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataXtd_Geometry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Geometry): void;
  get(): TDataXtd_Geometry;
  delete(): void;
}

  export declare class Handle_TDataXtd_Geometry_1 extends Handle_TDataXtd_Geometry {
    constructor();
  }

  export declare class Handle_TDataXtd_Geometry_2 extends Handle_TDataXtd_Geometry {
    constructor(thePtr: TDataXtd_Geometry);
  }

  export declare class Handle_TDataXtd_Geometry_3 extends Handle_TDataXtd_Geometry {
    constructor(theHandle: Handle_TDataXtd_Geometry);
  }

  export declare class Handle_TDataXtd_Geometry_4 extends Handle_TDataXtd_Geometry {
    constructor(theHandle: Handle_TDataXtd_Geometry);
  }

export declare class TDataXtd_Pattern extends TDF_Attribute {
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  PatternID(): Standard_GUID;
  NbTrsfs(): Graphic3d_ZLayerId;
  ComputeTrsfs(Trsfs: TDataXtd_Array1OfTrsf): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataXtd_Pattern {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Pattern): void;
  get(): TDataXtd_Pattern;
  delete(): void;
}

  export declare class Handle_TDataXtd_Pattern_1 extends Handle_TDataXtd_Pattern {
    constructor();
  }

  export declare class Handle_TDataXtd_Pattern_2 extends Handle_TDataXtd_Pattern {
    constructor(thePtr: TDataXtd_Pattern);
  }

  export declare class Handle_TDataXtd_Pattern_3 extends Handle_TDataXtd_Pattern {
    constructor(theHandle: Handle_TDataXtd_Pattern);
  }

  export declare class Handle_TDataXtd_Pattern_4 extends Handle_TDataXtd_Pattern {
    constructor(theHandle: Handle_TDataXtd_Pattern);
  }

export declare class TDataXtd {
  constructor();
  static IDList(anIDList: TDF_IDList): void;
  delete(): void;
}

export declare class TDataXtd_Presentation extends TDF_Attribute {
  constructor()
  static Set(theLabel: TDF_Label, theDriverId: Standard_GUID): Handle_TDataXtd_Presentation;
  static Unset(theLabel: TDF_Label): void;
  ID(): Standard_GUID;
  static GetID(): Standard_GUID;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocTationable: Handle_TDF_RelocationTable): void;
  BackupCopy(): Handle_TDF_Attribute;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  GetDriverGUID(): Standard_GUID;
  SetDriverGUID(theGUID: Standard_GUID): void;
  IsDisplayed(): Standard_Boolean;
  HasOwnMaterial(): Standard_Boolean;
  HasOwnTransparency(): Standard_Boolean;
  HasOwnColor(): Standard_Boolean;
  HasOwnWidth(): Standard_Boolean;
  HasOwnMode(): Standard_Boolean;
  HasOwnSelectionMode(): Standard_Boolean;
  SetDisplayed(theIsDisplayed: Standard_Boolean): void;
  SetMaterialIndex(theMaterialIndex: Graphic3d_ZLayerId): void;
  SetTransparency(theValue: Quantity_AbsorbedDose): void;
  SetColor(theColor: Quantity_NameOfColor): void;
  SetWidth(theWidth: Quantity_AbsorbedDose): void;
  SetMode(theMode: Graphic3d_ZLayerId): void;
  GetNbSelectionModes(): Graphic3d_ZLayerId;
  SetSelectionMode(theSelectionMode: Graphic3d_ZLayerId, theTransaction: Standard_Boolean): void;
  AddSelectionMode(theSelectionMode: Graphic3d_ZLayerId, theTransaction: Standard_Boolean): void;
  MaterialIndex(): Graphic3d_ZLayerId;
  Transparency(): Quantity_AbsorbedDose;
  Color(): Quantity_NameOfColor;
  Width(): Quantity_AbsorbedDose;
  Mode(): Graphic3d_ZLayerId;
  SelectionMode(index: Standard_Integer): Graphic3d_ZLayerId;
  UnsetMaterial(): void;
  UnsetTransparency(): void;
  UnsetColor(): void;
  UnsetWidth(): void;
  UnsetMode(): void;
  UnsetSelectionMode(): void;
  static getColorNameFromOldEnum(theOld: Graphic3d_ZLayerId): Quantity_NameOfColor;
  static getOldColorNameFromNewEnum(theNew: Quantity_NameOfColor): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class Handle_TDataXtd_Presentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Presentation): void;
  get(): TDataXtd_Presentation;
  delete(): void;
}

  export declare class Handle_TDataXtd_Presentation_1 extends Handle_TDataXtd_Presentation {
    constructor();
  }

  export declare class Handle_TDataXtd_Presentation_2 extends Handle_TDataXtd_Presentation {
    constructor(thePtr: TDataXtd_Presentation);
  }

  export declare class Handle_TDataXtd_Presentation_3 extends Handle_TDataXtd_Presentation {
    constructor(theHandle: Handle_TDataXtd_Presentation);
  }

  export declare class Handle_TDataXtd_Presentation_4 extends Handle_TDataXtd_Presentation {
    constructor(theHandle: Handle_TDataXtd_Presentation);
  }

export declare class TDataXtd_Triangulation extends TDF_Attribute {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(theLabel: TDF_Label): Handle_TDataXtd_Triangulation;
  static Set_2(theLabel: TDF_Label, theTriangulation: Handle_Poly_Triangulation): Handle_TDataXtd_Triangulation;
  Set_3(theTriangulation: Handle_Poly_Triangulation): void;
  Get(): Handle_Poly_Triangulation;
  Deflection_1(): Quantity_AbsorbedDose;
  Deflection_2(theDeflection: Quantity_AbsorbedDose): void;
  RemoveUVNodes(): void;
  NbNodes(): Graphic3d_ZLayerId;
  NbTriangles(): Graphic3d_ZLayerId;
  HasUVNodes(): Standard_Boolean;
  Node(theIndex: Graphic3d_ZLayerId): gp_Pnt;
  SetNode(theIndex: Graphic3d_ZLayerId, theNode: gp_Pnt): void;
  UVNode(theIndex: Graphic3d_ZLayerId): gp_Pnt2d;
  SetUVNode(theIndex: Graphic3d_ZLayerId, theUVNode: gp_Pnt2d): void;
  Triangle(theIndex: Graphic3d_ZLayerId): Poly_Triangle;
  SetTriangle(theIndex: Graphic3d_ZLayerId, theTriangle: Poly_Triangle): void;
  SetNormals(theNormals: Handle_TShort_HArray1OfShortReal): void;
  SetNormal(theIndex: Graphic3d_ZLayerId, theNormal: gp_Dir): void;
  HasNormals(): Standard_Boolean;
  Normal(theIndex: Graphic3d_ZLayerId): gp_Dir;
  ID(): Standard_GUID;
  Restore(theAttribute: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataXtd_Triangulation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Triangulation): void;
  get(): TDataXtd_Triangulation;
  delete(): void;
}

  export declare class Handle_TDataXtd_Triangulation_1 extends Handle_TDataXtd_Triangulation {
    constructor();
  }

  export declare class Handle_TDataXtd_Triangulation_2 extends Handle_TDataXtd_Triangulation {
    constructor(thePtr: TDataXtd_Triangulation);
  }

  export declare class Handle_TDataXtd_Triangulation_3 extends Handle_TDataXtd_Triangulation {
    constructor(theHandle: Handle_TDataXtd_Triangulation);
  }

  export declare class Handle_TDataXtd_Triangulation_4 extends Handle_TDataXtd_Triangulation {
    constructor(theHandle: Handle_TDataXtd_Triangulation);
  }

export declare class TDataXtd_Axis extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataXtd_Axis;
  static Set_2(label: TDF_Label, L: gp_Lin): Handle_TDataXtd_Axis;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataXtd_Axis {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Axis): void;
  get(): TDataXtd_Axis;
  delete(): void;
}

  export declare class Handle_TDataXtd_Axis_1 extends Handle_TDataXtd_Axis {
    constructor();
  }

  export declare class Handle_TDataXtd_Axis_2 extends Handle_TDataXtd_Axis {
    constructor(thePtr: TDataXtd_Axis);
  }

  export declare class Handle_TDataXtd_Axis_3 extends Handle_TDataXtd_Axis {
    constructor(theHandle: Handle_TDataXtd_Axis);
  }

  export declare class Handle_TDataXtd_Axis_4 extends Handle_TDataXtd_Axis {
    constructor(theHandle: Handle_TDataXtd_Axis);
  }

export declare class Handle_TDataXtd_Shape {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Shape): void;
  get(): TDataXtd_Shape;
  delete(): void;
}

  export declare class Handle_TDataXtd_Shape_1 extends Handle_TDataXtd_Shape {
    constructor();
  }

  export declare class Handle_TDataXtd_Shape_2 extends Handle_TDataXtd_Shape {
    constructor(thePtr: TDataXtd_Shape);
  }

  export declare class Handle_TDataXtd_Shape_3 extends Handle_TDataXtd_Shape {
    constructor(theHandle: Handle_TDataXtd_Shape);
  }

  export declare class Handle_TDataXtd_Shape_4 extends Handle_TDataXtd_Shape {
    constructor(theHandle: Handle_TDataXtd_Shape);
  }

export declare class TDataXtd_Shape extends TDataStd_GenericEmpty {
  constructor()
  static Find(current: TDF_Label, S: Handle_TDataXtd_Shape): Standard_Boolean;
  static New(label: TDF_Label): Handle_TDataXtd_Shape;
  static Set(label: TDF_Label, shape: TopoDS_Shape): Handle_TDataXtd_Shape;
  static Get(label: TDF_Label): TopoDS_Shape;
  static GetID(): Standard_GUID;
  ID(): Standard_GUID;
  References(DS: Handle_TDF_DataSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare type TDataXtd_GeometryEnum = {
  TDataXtd_ANY_GEOM: {};
  TDataXtd_POINT: {};
  TDataXtd_LINE: {};
  TDataXtd_CIRCLE: {};
  TDataXtd_ELLIPSE: {};
  TDataXtd_SPLINE: {};
  TDataXtd_PLANE: {};
  TDataXtd_CYLINDER: {};
}

export declare type TDataXtd_ConstraintEnum = {
  TDataXtd_RADIUS: {};
  TDataXtd_DIAMETER: {};
  TDataXtd_MINOR_RADIUS: {};
  TDataXtd_MAJOR_RADIUS: {};
  TDataXtd_TANGENT: {};
  TDataXtd_PARALLEL: {};
  TDataXtd_PERPENDICULAR: {};
  TDataXtd_CONCENTRIC: {};
  TDataXtd_COINCIDENT: {};
  TDataXtd_DISTANCE: {};
  TDataXtd_ANGLE: {};
  TDataXtd_EQUAL_RADIUS: {};
  TDataXtd_SYMMETRY: {};
  TDataXtd_MIDPOINT: {};
  TDataXtd_EQUAL_DISTANCE: {};
  TDataXtd_FIX: {};
  TDataXtd_RIGID: {};
  TDataXtd_FROM: {};
  TDataXtd_AXIS: {};
  TDataXtd_MATE: {};
  TDataXtd_ALIGN_FACES: {};
  TDataXtd_ALIGN_AXES: {};
  TDataXtd_AXES_ANGLE: {};
  TDataXtd_FACES_ANGLE: {};
  TDataXtd_ROUND: {};
  TDataXtd_OFFSET: {};
}

export declare class Handle_TDataXtd_Placement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Placement): void;
  get(): TDataXtd_Placement;
  delete(): void;
}

  export declare class Handle_TDataXtd_Placement_1 extends Handle_TDataXtd_Placement {
    constructor();
  }

  export declare class Handle_TDataXtd_Placement_2 extends Handle_TDataXtd_Placement {
    constructor(thePtr: TDataXtd_Placement);
  }

  export declare class Handle_TDataXtd_Placement_3 extends Handle_TDataXtd_Placement {
    constructor(theHandle: Handle_TDataXtd_Placement);
  }

  export declare class Handle_TDataXtd_Placement_4 extends Handle_TDataXtd_Placement {
    constructor(theHandle: Handle_TDataXtd_Placement);
  }

export declare class TDataXtd_Placement extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set(label: TDF_Label): Handle_TDataXtd_Placement;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class TDataXtd_Plane extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataXtd_Plane;
  static Set_2(label: TDF_Label, P: gp_Pln): Handle_TDataXtd_Plane;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataXtd_Plane {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Plane): void;
  get(): TDataXtd_Plane;
  delete(): void;
}

  export declare class Handle_TDataXtd_Plane_1 extends Handle_TDataXtd_Plane {
    constructor();
  }

  export declare class Handle_TDataXtd_Plane_2 extends Handle_TDataXtd_Plane {
    constructor(thePtr: TDataXtd_Plane);
  }

  export declare class Handle_TDataXtd_Plane_3 extends Handle_TDataXtd_Plane {
    constructor(theHandle: Handle_TDataXtd_Plane);
  }

  export declare class Handle_TDataXtd_Plane_4 extends Handle_TDataXtd_Plane {
    constructor(theHandle: Handle_TDataXtd_Plane);
  }

export declare class Handle_TDataXtd_PatternStd {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_PatternStd): void;
  get(): TDataXtd_PatternStd;
  delete(): void;
}

  export declare class Handle_TDataXtd_PatternStd_1 extends Handle_TDataXtd_PatternStd {
    constructor();
  }

  export declare class Handle_TDataXtd_PatternStd_2 extends Handle_TDataXtd_PatternStd {
    constructor(thePtr: TDataXtd_PatternStd);
  }

  export declare class Handle_TDataXtd_PatternStd_3 extends Handle_TDataXtd_PatternStd {
    constructor(theHandle: Handle_TDataXtd_PatternStd);
  }

  export declare class Handle_TDataXtd_PatternStd_4 extends Handle_TDataXtd_PatternStd {
    constructor(theHandle: Handle_TDataXtd_PatternStd);
  }

export declare class TDataXtd_PatternStd extends TDataXtd_Pattern {
  constructor()
  static GetPatternID(): Standard_GUID;
  static Set(label: TDF_Label): Handle_TDataXtd_PatternStd;
  Signature_1(signature: Graphic3d_ZLayerId): void;
  Axis1_1(Axis1: Handle_TNaming_NamedShape): void;
  Axis2_1(Axis2: Handle_TNaming_NamedShape): void;
  Axis1Reversed_1(Axis1Reversed: Standard_Boolean): void;
  Axis2Reversed_1(Axis2Reversed: Standard_Boolean): void;
  Value1_1(value: Handle_TDataStd_Real): void;
  Value2_1(value: Handle_TDataStd_Real): void;
  NbInstances1_1(NbInstances1: Handle_TDataStd_Integer): void;
  NbInstances2_1(NbInstances2: Handle_TDataStd_Integer): void;
  Mirror_1(plane: Handle_TNaming_NamedShape): void;
  Signature_2(): Graphic3d_ZLayerId;
  Axis1_2(): Handle_TNaming_NamedShape;
  Axis2_2(): Handle_TNaming_NamedShape;
  Axis1Reversed_2(): Standard_Boolean;
  Axis2Reversed_2(): Standard_Boolean;
  Value1_2(): Handle_TDataStd_Real;
  Value2_2(): Handle_TDataStd_Real;
  NbInstances1_2(): Handle_TDataStd_Integer;
  NbInstances2_2(): Handle_TDataStd_Integer;
  Mirror_2(): Handle_TNaming_NamedShape;
  NbTrsfs(): Graphic3d_ZLayerId;
  ComputeTrsfs(Trsfs: TDataXtd_Array1OfTrsf): void;
  PatternID(): Standard_GUID;
  Restore(With: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(Into: Handle_TDF_Attribute, RT: Handle_TDF_RelocationTable): void;
  References(aDataSet: Handle_TDF_DataSet): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_TDataXtd_Point {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Point): void;
  get(): TDataXtd_Point;
  delete(): void;
}

  export declare class Handle_TDataXtd_Point_1 extends Handle_TDataXtd_Point {
    constructor();
  }

  export declare class Handle_TDataXtd_Point_2 extends Handle_TDataXtd_Point {
    constructor(thePtr: TDataXtd_Point);
  }

  export declare class Handle_TDataXtd_Point_3 extends Handle_TDataXtd_Point {
    constructor(theHandle: Handle_TDataXtd_Point);
  }

  export declare class Handle_TDataXtd_Point_4 extends Handle_TDataXtd_Point {
    constructor(theHandle: Handle_TDataXtd_Point);
  }

export declare class TDataXtd_Point extends TDataStd_GenericEmpty {
  constructor()
  static GetID(): Standard_GUID;
  static Set_1(label: TDF_Label): Handle_TDataXtd_Point;
  static Set_2(label: TDF_Label, P: gp_Pnt): Handle_TDataXtd_Point;
  ID(): Standard_GUID;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  NewEmpty(): Handle_TDF_Attribute;
  delete(): void;
}

export declare class Handle_TDataXtd_Position {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: TDataXtd_Position): void;
  get(): TDataXtd_Position;
  delete(): void;
}

  export declare class Handle_TDataXtd_Position_1 extends Handle_TDataXtd_Position {
    constructor();
  }

  export declare class Handle_TDataXtd_Position_2 extends Handle_TDataXtd_Position {
    constructor(thePtr: TDataXtd_Position);
  }

  export declare class Handle_TDataXtd_Position_3 extends Handle_TDataXtd_Position {
    constructor(theHandle: Handle_TDataXtd_Position);
  }

  export declare class Handle_TDataXtd_Position_4 extends Handle_TDataXtd_Position {
    constructor(theHandle: Handle_TDataXtd_Position);
  }

export declare class TDataXtd_Position extends TDF_Attribute {
  constructor()
  static Set_1(aLabel: TDF_Label, aPos: gp_Pnt): void;
  static Set_2(aLabel: TDF_Label): Handle_TDataXtd_Position;
  static Get(aLabel: TDF_Label, aPos: gp_Pnt): Standard_Boolean;
  ID(): Standard_GUID;
  static GetID(): Standard_GUID;
  Restore(anAttribute: Handle_TDF_Attribute): void;
  NewEmpty(): Handle_TDF_Attribute;
  Paste(intoAttribute: Handle_TDF_Attribute, aRelocTationable: Handle_TDF_RelocationTable): void;
  GetPosition(): gp_Pnt;
  SetPosition(aPos: gp_Pnt): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class XmlMFunction_GraphNodeDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMFunction_GraphNodeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMFunction_GraphNodeDriver): void;
  get(): XmlMFunction_GraphNodeDriver;
  delete(): void;
}

  export declare class Handle_XmlMFunction_GraphNodeDriver_1 extends Handle_XmlMFunction_GraphNodeDriver {
    constructor();
  }

  export declare class Handle_XmlMFunction_GraphNodeDriver_2 extends Handle_XmlMFunction_GraphNodeDriver {
    constructor(thePtr: XmlMFunction_GraphNodeDriver);
  }

  export declare class Handle_XmlMFunction_GraphNodeDriver_3 extends Handle_XmlMFunction_GraphNodeDriver {
    constructor(theHandle: Handle_XmlMFunction_GraphNodeDriver);
  }

  export declare class Handle_XmlMFunction_GraphNodeDriver_4 extends Handle_XmlMFunction_GraphNodeDriver {
    constructor(theHandle: Handle_XmlMFunction_GraphNodeDriver);
  }

export declare class XmlMFunction {
  constructor();
  static AddDrivers(aDriverTable: Handle_XmlMDF_ADriverTable, theMessageDriver: Handle_Message_Messenger): void;
  delete(): void;
}

export declare class XmlMFunction_ScopeDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMFunction_ScopeDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMFunction_ScopeDriver): void;
  get(): XmlMFunction_ScopeDriver;
  delete(): void;
}

  export declare class Handle_XmlMFunction_ScopeDriver_1 extends Handle_XmlMFunction_ScopeDriver {
    constructor();
  }

  export declare class Handle_XmlMFunction_ScopeDriver_2 extends Handle_XmlMFunction_ScopeDriver {
    constructor(thePtr: XmlMFunction_ScopeDriver);
  }

  export declare class Handle_XmlMFunction_ScopeDriver_3 extends Handle_XmlMFunction_ScopeDriver {
    constructor(theHandle: Handle_XmlMFunction_ScopeDriver);
  }

  export declare class Handle_XmlMFunction_ScopeDriver_4 extends Handle_XmlMFunction_ScopeDriver {
    constructor(theHandle: Handle_XmlMFunction_ScopeDriver);
  }

export declare class XmlMFunction_FunctionDriver extends XmlMDF_ADriver {
  constructor(theMessageDriver: Handle_Message_Messenger)
  NewEmpty(): Handle_TDF_Attribute;
  Paste_1(Source: XmlObjMgt_Persistent, Target: Handle_TDF_Attribute, RelocTable: XmlObjMgt_RRelocationTable): Standard_Boolean;
  Paste_2(Source: Handle_TDF_Attribute, Target: XmlObjMgt_Persistent, RelocTable: XmlObjMgt_SRelocationTable): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_XmlMFunction_FunctionDriver {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: XmlMFunction_FunctionDriver): void;
  get(): XmlMFunction_FunctionDriver;
  delete(): void;
}

  export declare class Handle_XmlMFunction_FunctionDriver_1 extends Handle_XmlMFunction_FunctionDriver {
    constructor();
  }

  export declare class Handle_XmlMFunction_FunctionDriver_2 extends Handle_XmlMFunction_FunctionDriver {
    constructor(thePtr: XmlMFunction_FunctionDriver);
  }

  export declare class Handle_XmlMFunction_FunctionDriver_3 extends Handle_XmlMFunction_FunctionDriver {
    constructor(theHandle: Handle_XmlMFunction_FunctionDriver);
  }

  export declare class Handle_XmlMFunction_FunctionDriver_4 extends Handle_XmlMFunction_FunctionDriver {
    constructor(theHandle: Handle_XmlMFunction_FunctionDriver);
  }

export declare class IGESData_DefaultSpecific extends IGESData_SpecificModule {
  constructor()
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_DefaultSpecific {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_DefaultSpecific): void;
  get(): IGESData_DefaultSpecific;
  delete(): void;
}

  export declare class Handle_IGESData_DefaultSpecific_1 extends Handle_IGESData_DefaultSpecific {
    constructor();
  }

  export declare class Handle_IGESData_DefaultSpecific_2 extends Handle_IGESData_DefaultSpecific {
    constructor(thePtr: IGESData_DefaultSpecific);
  }

  export declare class Handle_IGESData_DefaultSpecific_3 extends Handle_IGESData_DefaultSpecific {
    constructor(theHandle: Handle_IGESData_DefaultSpecific);
  }

  export declare class Handle_IGESData_DefaultSpecific_4 extends Handle_IGESData_DefaultSpecific {
    constructor(theHandle: Handle_IGESData_DefaultSpecific);
  }

export declare class IGESData_IGESType {
  Type(): Graphic3d_ZLayerId;
  Form(): Graphic3d_ZLayerId;
  IsEqual(another: IGESData_IGESType): Standard_Boolean;
  Nullify(): void;
  delete(): void;
}

  export declare class IGESData_IGESType_1 extends IGESData_IGESType {
    constructor();
  }

  export declare class IGESData_IGESType_2 extends IGESData_IGESType {
    constructor(atype: Graphic3d_ZLayerId, aform: Graphic3d_ZLayerId);
  }

export declare class IGESData_GlobalNodeOfWriterLib extends Standard_Transient {
  constructor()
  Add(amodule: Handle_IGESData_ReadWriteModule, aprotocol: Handle_IGESData_Protocol): void;
  Module(): Handle_IGESData_ReadWriteModule;
  Protocol(): Handle_IGESData_Protocol;
  Next(): Handle_IGESData_GlobalNodeOfWriterLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_GlobalNodeOfWriterLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_GlobalNodeOfWriterLib): void;
  get(): IGESData_GlobalNodeOfWriterLib;
  delete(): void;
}

  export declare class Handle_IGESData_GlobalNodeOfWriterLib_1 extends Handle_IGESData_GlobalNodeOfWriterLib {
    constructor();
  }

  export declare class Handle_IGESData_GlobalNodeOfWriterLib_2 extends Handle_IGESData_GlobalNodeOfWriterLib {
    constructor(thePtr: IGESData_GlobalNodeOfWriterLib);
  }

  export declare class Handle_IGESData_GlobalNodeOfWriterLib_3 extends Handle_IGESData_GlobalNodeOfWriterLib {
    constructor(theHandle: Handle_IGESData_GlobalNodeOfWriterLib);
  }

  export declare class Handle_IGESData_GlobalNodeOfWriterLib_4 extends Handle_IGESData_GlobalNodeOfWriterLib {
    constructor(theHandle: Handle_IGESData_GlobalNodeOfWriterLib);
  }

export declare type IGESData_Status = {
  IGESData_EntityOK: {};
  IGESData_EntityError: {};
  IGESData_ReferenceError: {};
  IGESData_TypeError: {};
}

export declare type IGESData_ReadStage = {
  IGESData_ReadDir: {};
  IGESData_ReadOwn: {};
  IGESData_ReadAssocs: {};
  IGESData_ReadProps: {};
  IGESData_ReadEnd: {};
}

export declare class IGESData_NodeOfSpecificLib extends Standard_Transient {
  constructor()
  AddNode(anode: Handle_IGESData_GlobalNodeOfSpecificLib): void;
  Module(): Handle_IGESData_SpecificModule;
  Protocol(): Handle_IGESData_Protocol;
  Next(): Handle_IGESData_NodeOfSpecificLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_NodeOfSpecificLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_NodeOfSpecificLib): void;
  get(): IGESData_NodeOfSpecificLib;
  delete(): void;
}

  export declare class Handle_IGESData_NodeOfSpecificLib_1 extends Handle_IGESData_NodeOfSpecificLib {
    constructor();
  }

  export declare class Handle_IGESData_NodeOfSpecificLib_2 extends Handle_IGESData_NodeOfSpecificLib {
    constructor(thePtr: IGESData_NodeOfSpecificLib);
  }

  export declare class Handle_IGESData_NodeOfSpecificLib_3 extends Handle_IGESData_NodeOfSpecificLib {
    constructor(theHandle: Handle_IGESData_NodeOfSpecificLib);
  }

  export declare class Handle_IGESData_NodeOfSpecificLib_4 extends Handle_IGESData_NodeOfSpecificLib {
    constructor(theHandle: Handle_IGESData_NodeOfSpecificLib);
  }

export declare class IGESData_IGESReaderTool extends Interface_FileReaderTool {
  constructor(reader: Handle_IGESData_IGESReaderData, protocol: Handle_IGESData_Protocol)
  Prepare(reco: Handle_IGESData_FileRecognizer): void;
  Recognize(num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): Standard_Boolean;
  BeginRead(amodel: Handle_Interface_InterfaceModel): void;
  AnalyseRecord(num: Graphic3d_ZLayerId, anent: Handle_Standard_Transient, acheck: Handle_Interface_Check): Standard_Boolean;
  EndRead(amodel: Handle_Interface_InterfaceModel): void;
  ReadDir(ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, DP: IGESData_DirPart, ach: Handle_Interface_Check): void;
  ReadOwnParams(ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  ReadProps(ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  ReadAssocs(ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  delete(): void;
}

export declare class Handle_IGESData_SingleParentEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_SingleParentEntity): void;
  get(): IGESData_SingleParentEntity;
  delete(): void;
}

  export declare class Handle_IGESData_SingleParentEntity_1 extends Handle_IGESData_SingleParentEntity {
    constructor();
  }

  export declare class Handle_IGESData_SingleParentEntity_2 extends Handle_IGESData_SingleParentEntity {
    constructor(thePtr: IGESData_SingleParentEntity);
  }

  export declare class Handle_IGESData_SingleParentEntity_3 extends Handle_IGESData_SingleParentEntity {
    constructor(theHandle: Handle_IGESData_SingleParentEntity);
  }

  export declare class Handle_IGESData_SingleParentEntity_4 extends Handle_IGESData_SingleParentEntity {
    constructor(theHandle: Handle_IGESData_SingleParentEntity);
  }

export declare class IGESData_SingleParentEntity extends IGESData_IGESEntity {
  SingleParent(): Handle_IGESData_IGESEntity;
  NbChildren(): Graphic3d_ZLayerId;
  Child(num: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_LevelListEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_LevelListEntity): void;
  get(): IGESData_LevelListEntity;
  delete(): void;
}

  export declare class Handle_IGESData_LevelListEntity_1 extends Handle_IGESData_LevelListEntity {
    constructor();
  }

  export declare class Handle_IGESData_LevelListEntity_2 extends Handle_IGESData_LevelListEntity {
    constructor(thePtr: IGESData_LevelListEntity);
  }

  export declare class Handle_IGESData_LevelListEntity_3 extends Handle_IGESData_LevelListEntity {
    constructor(theHandle: Handle_IGESData_LevelListEntity);
  }

  export declare class Handle_IGESData_LevelListEntity_4 extends Handle_IGESData_LevelListEntity {
    constructor(theHandle: Handle_IGESData_LevelListEntity);
  }

export declare class IGESData_LevelListEntity extends IGESData_IGESEntity {
  NbLevelNumbers(): Graphic3d_ZLayerId;
  LevelNumber(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  HasLevelNumber(level: Graphic3d_ZLayerId): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_NameEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_NameEntity): void;
  get(): IGESData_NameEntity;
  delete(): void;
}

  export declare class Handle_IGESData_NameEntity_1 extends Handle_IGESData_NameEntity {
    constructor();
  }

  export declare class Handle_IGESData_NameEntity_2 extends Handle_IGESData_NameEntity {
    constructor(thePtr: IGESData_NameEntity);
  }

  export declare class Handle_IGESData_NameEntity_3 extends Handle_IGESData_NameEntity {
    constructor(theHandle: Handle_IGESData_NameEntity);
  }

  export declare class Handle_IGESData_NameEntity_4 extends Handle_IGESData_NameEntity {
    constructor(theHandle: Handle_IGESData_NameEntity);
  }

export declare class IGESData_NameEntity extends IGESData_IGESEntity {
  Value(): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_LineFontEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_LineFontEntity): void;
  get(): IGESData_LineFontEntity;
  delete(): void;
}

  export declare class Handle_IGESData_LineFontEntity_1 extends Handle_IGESData_LineFontEntity {
    constructor();
  }

  export declare class Handle_IGESData_LineFontEntity_2 extends Handle_IGESData_LineFontEntity {
    constructor(thePtr: IGESData_LineFontEntity);
  }

  export declare class Handle_IGESData_LineFontEntity_3 extends Handle_IGESData_LineFontEntity {
    constructor(theHandle: Handle_IGESData_LineFontEntity);
  }

  export declare class Handle_IGESData_LineFontEntity_4 extends Handle_IGESData_LineFontEntity {
    constructor(theHandle: Handle_IGESData_LineFontEntity);
  }

export declare class IGESData_LineFontEntity extends IGESData_IGESEntity {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type IGESData_DefType = {
  IGESData_DefVoid: {};
  IGESData_DefValue: {};
  IGESData_DefReference: {};
  IGESData_DefAny: {};
  IGESData_ErrorVal: {};
  IGESData_ErrorRef: {};
}

export declare type IGESData_DefList = {
  IGESData_DefNone: {};
  IGESData_DefOne: {};
  IGESData_DefSeveral: {};
  IGESData_ErrorOne: {};
  IGESData_ErrorSeveral: {};
}

export declare class IGESData_ReadWriteModule extends Interface_ReaderModule {
  CaseNum(data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  CaseIGES(typenum: Graphic3d_ZLayerId, formnum: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Read(CN: Graphic3d_ZLayerId, data: Handle_Interface_FileReaderData, num: Graphic3d_ZLayerId, ach: Handle_Interface_Check, ent: Handle_Standard_Transient): void;
  ReadOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_ReadWriteModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_ReadWriteModule): void;
  get(): IGESData_ReadWriteModule;
  delete(): void;
}

  export declare class Handle_IGESData_ReadWriteModule_1 extends Handle_IGESData_ReadWriteModule {
    constructor();
  }

  export declare class Handle_IGESData_ReadWriteModule_2 extends Handle_IGESData_ReadWriteModule {
    constructor(thePtr: IGESData_ReadWriteModule);
  }

  export declare class Handle_IGESData_ReadWriteModule_3 extends Handle_IGESData_ReadWriteModule {
    constructor(theHandle: Handle_IGESData_ReadWriteModule);
  }

  export declare class Handle_IGESData_ReadWriteModule_4 extends Handle_IGESData_ReadWriteModule {
    constructor(theHandle: Handle_IGESData_ReadWriteModule);
  }

export declare class Handle_IGESData_UndefinedEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_UndefinedEntity): void;
  get(): IGESData_UndefinedEntity;
  delete(): void;
}

  export declare class Handle_IGESData_UndefinedEntity_1 extends Handle_IGESData_UndefinedEntity {
    constructor();
  }

  export declare class Handle_IGESData_UndefinedEntity_2 extends Handle_IGESData_UndefinedEntity {
    constructor(thePtr: IGESData_UndefinedEntity);
  }

  export declare class Handle_IGESData_UndefinedEntity_3 extends Handle_IGESData_UndefinedEntity {
    constructor(theHandle: Handle_IGESData_UndefinedEntity);
  }

  export declare class Handle_IGESData_UndefinedEntity_4 extends Handle_IGESData_UndefinedEntity {
    constructor(theHandle: Handle_IGESData_UndefinedEntity);
  }

export declare class IGESData_UndefinedEntity extends IGESData_IGESEntity {
  constructor()
  UndefinedContent(): Handle_Interface_UndefinedContent;
  ChangeableContent(): Handle_Interface_UndefinedContent;
  SetNewContent(cont: Handle_Interface_UndefinedContent): void;
  IsOKDirPart(): Standard_Boolean;
  DirStatus(): Graphic3d_ZLayerId;
  SetOKDirPart(): void;
  DefLineFont(): IGESData_DefType;
  DefLevel(): IGESData_DefList;
  DefView(): IGESData_DefList;
  DefColor(): IGESData_DefType;
  HasSubScriptNumber(): Standard_Boolean;
  ReadDir(IR: Handle_IGESData_IGESReaderData, DP: IGESData_DirPart, ach: Handle_Interface_Check): Standard_Boolean;
  ReadOwnParams(IR: Handle_IGESData_IGESReaderData, PR: IGESData_ParamReader): void;
  WriteOwnParams(IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_FileProtocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_FileProtocol): void;
  get(): IGESData_FileProtocol;
  delete(): void;
}

  export declare class Handle_IGESData_FileProtocol_1 extends Handle_IGESData_FileProtocol {
    constructor();
  }

  export declare class Handle_IGESData_FileProtocol_2 extends Handle_IGESData_FileProtocol {
    constructor(thePtr: IGESData_FileProtocol);
  }

  export declare class Handle_IGESData_FileProtocol_3 extends Handle_IGESData_FileProtocol {
    constructor(theHandle: Handle_IGESData_FileProtocol);
  }

  export declare class Handle_IGESData_FileProtocol_4 extends Handle_IGESData_FileProtocol {
    constructor(theHandle: Handle_IGESData_FileProtocol);
  }

export declare class IGESData_FileProtocol extends IGESData_Protocol {
  constructor()
  Add(protocol: Handle_IGESData_Protocol): void;
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_IGESReaderData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_IGESReaderData): void;
  get(): IGESData_IGESReaderData;
  delete(): void;
}

  export declare class Handle_IGESData_IGESReaderData_1 extends Handle_IGESData_IGESReaderData {
    constructor();
  }

  export declare class Handle_IGESData_IGESReaderData_2 extends Handle_IGESData_IGESReaderData {
    constructor(thePtr: IGESData_IGESReaderData);
  }

  export declare class Handle_IGESData_IGESReaderData_3 extends Handle_IGESData_IGESReaderData {
    constructor(theHandle: Handle_IGESData_IGESReaderData);
  }

  export declare class Handle_IGESData_IGESReaderData_4 extends Handle_IGESData_IGESReaderData {
    constructor(theHandle: Handle_IGESData_IGESReaderData);
  }

export declare class Handle_IGESData_IGESModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_IGESModel): void;
  get(): IGESData_IGESModel;
  delete(): void;
}

  export declare class Handle_IGESData_IGESModel_1 extends Handle_IGESData_IGESModel {
    constructor();
  }

  export declare class Handle_IGESData_IGESModel_2 extends Handle_IGESData_IGESModel {
    constructor(thePtr: IGESData_IGESModel);
  }

  export declare class Handle_IGESData_IGESModel_3 extends Handle_IGESData_IGESModel {
    constructor(theHandle: Handle_IGESData_IGESModel);
  }

  export declare class Handle_IGESData_IGESModel_4 extends Handle_IGESData_IGESModel {
    constructor(theHandle: Handle_IGESData_IGESModel);
  }

export declare class IGESData_IGESModel extends Interface_InterfaceModel {
  constructor()
  ClearHeader(): void;
  DumpHeader(S: Standard_OStream, level: Graphic3d_ZLayerId): void;
  StartSection(): Handle_TColStd_HSequenceOfHAsciiString;
  NbStartLines(): Graphic3d_ZLayerId;
  StartLine(num: Graphic3d_ZLayerId): Standard_CString;
  ClearStartSection(): void;
  SetStartSection(list: Handle_TColStd_HSequenceOfHAsciiString, copy: Standard_Boolean): void;
  AddStartLine(line: Standard_CString, atnum: Graphic3d_ZLayerId): void;
  GlobalSection(): IGESData_GlobalSection;
  SetGlobalSection(header: IGESData_GlobalSection): void;
  ApplyStatic(param: Standard_CString): Standard_Boolean;
  Entity(num: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  DNum(ent: Handle_IGESData_IGESEntity): Graphic3d_ZLayerId;
  GetFromAnother(other: Handle_Interface_InterfaceModel): void;
  NewEmptyModel(): Handle_Interface_InterfaceModel;
  VerifyCheck(ach: Handle_Interface_Check): void;
  SetLineWeights(defw: Quantity_AbsorbedDose): void;
  ClearLabels(): void;
  PrintLabel(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  PrintToLog(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  PrintInfo(ent: Handle_Standard_Transient, S: Standard_OStream): void;
  StringLabel(ent: Handle_Standard_Transient): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_FileRecognizer {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_FileRecognizer): void;
  get(): IGESData_FileRecognizer;
  delete(): void;
}

  export declare class Handle_IGESData_FileRecognizer_1 extends Handle_IGESData_FileRecognizer {
    constructor();
  }

  export declare class Handle_IGESData_FileRecognizer_2 extends Handle_IGESData_FileRecognizer {
    constructor(thePtr: IGESData_FileRecognizer);
  }

  export declare class Handle_IGESData_FileRecognizer_3 extends Handle_IGESData_FileRecognizer {
    constructor(theHandle: Handle_IGESData_FileRecognizer);
  }

  export declare class Handle_IGESData_FileRecognizer_4 extends Handle_IGESData_FileRecognizer {
    constructor(theHandle: Handle_IGESData_FileRecognizer);
  }

export declare class IGESData_FileRecognizer extends Standard_Transient {
  Evaluate(akey: IGESData_IGESType, res: Handle_IGESData_IGESEntity): Standard_Boolean;
  Result(): Handle_IGESData_IGESEntity;
  Add(reco: Handle_IGESData_FileRecognizer): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_ColorEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_ColorEntity): void;
  get(): IGESData_ColorEntity;
  delete(): void;
}

  export declare class Handle_IGESData_ColorEntity_1 extends Handle_IGESData_ColorEntity {
    constructor();
  }

  export declare class Handle_IGESData_ColorEntity_2 extends Handle_IGESData_ColorEntity {
    constructor(thePtr: IGESData_ColorEntity);
  }

  export declare class Handle_IGESData_ColorEntity_3 extends Handle_IGESData_ColorEntity {
    constructor(theHandle: Handle_IGESData_ColorEntity);
  }

  export declare class Handle_IGESData_ColorEntity_4 extends Handle_IGESData_ColorEntity {
    constructor(theHandle: Handle_IGESData_ColorEntity);
  }

export declare class IGESData_ColorEntity extends IGESData_IGESEntity {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_SpecificModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_SpecificModule): void;
  get(): IGESData_SpecificModule;
  delete(): void;
}

  export declare class Handle_IGESData_SpecificModule_1 extends Handle_IGESData_SpecificModule {
    constructor();
  }

  export declare class Handle_IGESData_SpecificModule_2 extends Handle_IGESData_SpecificModule {
    constructor(thePtr: IGESData_SpecificModule);
  }

  export declare class Handle_IGESData_SpecificModule_3 extends Handle_IGESData_SpecificModule {
    constructor(theHandle: Handle_IGESData_SpecificModule);
  }

  export declare class Handle_IGESData_SpecificModule_4 extends Handle_IGESData_SpecificModule {
    constructor(theHandle: Handle_IGESData_SpecificModule);
  }

export declare class IGESData_SpecificModule extends Standard_Transient {
  OwnDump(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, dumper: IGESData_IGESDumper, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  OwnCorrect(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESData_IGESEntity extends Standard_Transient {
  IGESType(): IGESData_IGESType;
  TypeNumber(): Graphic3d_ZLayerId;
  FormNumber(): Graphic3d_ZLayerId;
  DirFieldEntity(fieldnum: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  HasStructure(): Standard_Boolean;
  Structure(): Handle_IGESData_IGESEntity;
  DefLineFont(): IGESData_DefType;
  RankLineFont(): Graphic3d_ZLayerId;
  LineFont(): Handle_IGESData_LineFontEntity;
  DefLevel(): IGESData_DefList;
  Level(): Graphic3d_ZLayerId;
  LevelList(): Handle_IGESData_LevelListEntity;
  DefView(): IGESData_DefList;
  View(): Handle_IGESData_ViewKindEntity;
  SingleView(): Handle_IGESData_ViewKindEntity;
  ViewList(): Handle_IGESData_ViewKindEntity;
  HasTransf(): Standard_Boolean;
  Transf(): Handle_IGESData_TransfEntity;
  HasLabelDisplay(): Standard_Boolean;
  LabelDisplay(): Handle_IGESData_LabelDisplayEntity;
  BlankStatus(): Graphic3d_ZLayerId;
  SubordinateStatus(): Graphic3d_ZLayerId;
  UseFlag(): Graphic3d_ZLayerId;
  HierarchyStatus(): Graphic3d_ZLayerId;
  LineWeightNumber(): Graphic3d_ZLayerId;
  LineWeight(): Quantity_AbsorbedDose;
  DefColor(): IGESData_DefType;
  RankColor(): Graphic3d_ZLayerId;
  Color(): Handle_IGESData_ColorEntity;
  CResValues(res1: Standard_CString, res2: Standard_CString): Standard_Boolean;
  HasShortLabel(): Standard_Boolean;
  ShortLabel(): Handle_TCollection_HAsciiString;
  HasSubScriptNumber(): Standard_Boolean;
  SubScriptNumber(): Graphic3d_ZLayerId;
  InitDirFieldEntity(fieldnum: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): void;
  InitTransf(ent: Handle_IGESData_TransfEntity): void;
  InitView(ent: Handle_IGESData_ViewKindEntity): void;
  InitLineFont(ent: Handle_IGESData_LineFontEntity, rank: Graphic3d_ZLayerId): void;
  InitLevel(ent: Handle_IGESData_LevelListEntity, val: Graphic3d_ZLayerId): void;
  InitColor(ent: Handle_IGESData_ColorEntity, rank: Graphic3d_ZLayerId): void;
  InitStatus(blank: Graphic3d_ZLayerId, subordinate: Graphic3d_ZLayerId, useflag: Graphic3d_ZLayerId, hierarchy: Graphic3d_ZLayerId): void;
  SetLabel(label: Handle_TCollection_HAsciiString, sub: Graphic3d_ZLayerId): void;
  InitMisc(str: Handle_IGESData_IGESEntity, lab: Handle_IGESData_LabelDisplayEntity, weightnum: Graphic3d_ZLayerId): void;
  HasOneParent(): Standard_Boolean;
  UniqueParent(): Handle_IGESData_IGESEntity;
  Location(): gp_GTrsf;
  VectorLocation(): gp_GTrsf;
  CompoundLocation(): gp_GTrsf;
  HasName(): Standard_Boolean;
  NameValue(): Handle_TCollection_HAsciiString;
  ArePresentAssociativities(): Standard_Boolean;
  NbAssociativities(): Graphic3d_ZLayerId;
  Associativities(): Interface_EntityIterator;
  NbTypedAssociativities(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  TypedAssociativity(atype: Handle_Standard_Type): Handle_IGESData_IGESEntity;
  Associate(ent: Handle_IGESData_IGESEntity): void;
  Dissociate(ent: Handle_IGESData_IGESEntity): void;
  ArePresentProperties(): Standard_Boolean;
  NbProperties(): Graphic3d_ZLayerId;
  Properties(): Interface_EntityIterator;
  NbTypedProperties(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  TypedProperty(atype: Handle_Standard_Type, anum: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  AddProperty(ent: Handle_IGESData_IGESEntity): void;
  RemoveProperty(ent: Handle_IGESData_IGESEntity): void;
  SetLineWeight(defw: Quantity_AbsorbedDose, maxw: Quantity_AbsorbedDose, gradw: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_IGESEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_IGESEntity): void;
  get(): IGESData_IGESEntity;
  delete(): void;
}

  export declare class Handle_IGESData_IGESEntity_1 extends Handle_IGESData_IGESEntity {
    constructor();
  }

  export declare class Handle_IGESData_IGESEntity_2 extends Handle_IGESData_IGESEntity {
    constructor(thePtr: IGESData_IGESEntity);
  }

  export declare class Handle_IGESData_IGESEntity_3 extends Handle_IGESData_IGESEntity {
    constructor(theHandle: Handle_IGESData_IGESEntity);
  }

  export declare class Handle_IGESData_IGESEntity_4 extends Handle_IGESData_IGESEntity {
    constructor(theHandle: Handle_IGESData_IGESEntity);
  }

export declare class Handle_IGESData_Protocol {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_Protocol): void;
  get(): IGESData_Protocol;
  delete(): void;
}

  export declare class Handle_IGESData_Protocol_1 extends Handle_IGESData_Protocol {
    constructor();
  }

  export declare class Handle_IGESData_Protocol_2 extends Handle_IGESData_Protocol {
    constructor(thePtr: IGESData_Protocol);
  }

  export declare class Handle_IGESData_Protocol_3 extends Handle_IGESData_Protocol {
    constructor(theHandle: Handle_IGESData_Protocol);
  }

  export declare class Handle_IGESData_Protocol_4 extends Handle_IGESData_Protocol {
    constructor(theHandle: Handle_IGESData_Protocol);
  }

export declare class IGESData_Protocol extends Interface_Protocol {
  constructor()
  NbResources(): Graphic3d_ZLayerId;
  Resource(num: Graphic3d_ZLayerId): Handle_Interface_Protocol;
  TypeNumber(atype: Handle_Standard_Type): Graphic3d_ZLayerId;
  NewModel(): Handle_Interface_InterfaceModel;
  IsSuitableModel(model: Handle_Interface_InterfaceModel): Standard_Boolean;
  UnknownEntity(): Handle_Standard_Transient;
  IsUnknownEntity(ent: Handle_Standard_Transient): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESData_NodeOfWriterLib extends Standard_Transient {
  constructor()
  AddNode(anode: Handle_IGESData_GlobalNodeOfWriterLib): void;
  Module(): Handle_IGESData_ReadWriteModule;
  Protocol(): Handle_IGESData_Protocol;
  Next(): Handle_IGESData_NodeOfWriterLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_NodeOfWriterLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_NodeOfWriterLib): void;
  get(): IGESData_NodeOfWriterLib;
  delete(): void;
}

  export declare class Handle_IGESData_NodeOfWriterLib_1 extends Handle_IGESData_NodeOfWriterLib {
    constructor();
  }

  export declare class Handle_IGESData_NodeOfWriterLib_2 extends Handle_IGESData_NodeOfWriterLib {
    constructor(thePtr: IGESData_NodeOfWriterLib);
  }

  export declare class Handle_IGESData_NodeOfWriterLib_3 extends Handle_IGESData_NodeOfWriterLib {
    constructor(theHandle: Handle_IGESData_NodeOfWriterLib);
  }

  export declare class Handle_IGESData_NodeOfWriterLib_4 extends Handle_IGESData_NodeOfWriterLib {
    constructor(theHandle: Handle_IGESData_NodeOfWriterLib);
  }

export declare class IGESData_BasicEditor {
  Init_1(protocol: Handle_IGESData_Protocol): void;
  Init_2(model: Handle_IGESData_IGESModel, protocol: Handle_IGESData_Protocol): void;
  Model(): Handle_IGESData_IGESModel;
  SetUnitFlag(flag: Graphic3d_ZLayerId): Standard_Boolean;
  SetUnitValue(val: Quantity_AbsorbedDose): Standard_Boolean;
  SetUnitName(name: Standard_CString): Standard_Boolean;
  ApplyUnit(enforce: Standard_Boolean): void;
  ComputeStatus(): void;
  AutoCorrect(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  AutoCorrectModel(): Graphic3d_ZLayerId;
  static UnitNameFlag(name: Standard_CString): Graphic3d_ZLayerId;
  static UnitFlagValue(flag: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  static UnitFlagName(flag: Graphic3d_ZLayerId): Standard_CString;
  static IGESVersionName(flag: Graphic3d_ZLayerId): Standard_CString;
  static IGESVersionMax(): Graphic3d_ZLayerId;
  static DraftingName(flag: Graphic3d_ZLayerId): Standard_CString;
  static DraftingMax(): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class IGESData_BasicEditor_1 extends IGESData_BasicEditor {
    constructor();
  }

  export declare class IGESData_BasicEditor_2 extends IGESData_BasicEditor {
    constructor(protocol: Handle_IGESData_Protocol);
  }

  export declare class IGESData_BasicEditor_3 extends IGESData_BasicEditor {
    constructor(model: Handle_IGESData_IGESModel, protocol: Handle_IGESData_Protocol);
  }

export declare class Handle_IGESData_GeneralModule {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_GeneralModule): void;
  get(): IGESData_GeneralModule;
  delete(): void;
}

  export declare class Handle_IGESData_GeneralModule_1 extends Handle_IGESData_GeneralModule {
    constructor();
  }

  export declare class Handle_IGESData_GeneralModule_2 extends Handle_IGESData_GeneralModule {
    constructor(thePtr: IGESData_GeneralModule);
  }

  export declare class Handle_IGESData_GeneralModule_3 extends Handle_IGESData_GeneralModule {
    constructor(theHandle: Handle_IGESData_GeneralModule);
  }

  export declare class Handle_IGESData_GeneralModule_4 extends Handle_IGESData_GeneralModule {
    constructor(theHandle: Handle_IGESData_GeneralModule);
  }

export declare class IGESData_GeneralModule extends Interface_GeneralModule {
  FillSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, iter: Interface_EntityIterator): void;
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  ListImpliedCase(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, iter: Interface_EntityIterator): void;
  OwnImpliedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  CheckCase(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  CanCopy(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient): Standard_Boolean;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  CopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient, TC: Interface_CopyTool): void;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  RenewImpliedCase(CN: Graphic3d_ZLayerId, entfrom: Handle_Standard_Transient, entto: Handle_Standard_Transient, TC: Interface_CopyTool): void;
  OwnRenewCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  WhenDeleteCase(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, dispatched: Standard_Boolean): void;
  OwnDeleteCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): void;
  Name(CN: Graphic3d_ZLayerId, ent: Handle_Standard_Transient, shares: Interface_ShareTool): Handle_TCollection_HAsciiString;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESData_DirPart {
  constructor()
  Init(i1: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId, i3: Graphic3d_ZLayerId, i4: Graphic3d_ZLayerId, i5: Graphic3d_ZLayerId, i6: Graphic3d_ZLayerId, i7: Graphic3d_ZLayerId, i8: Graphic3d_ZLayerId, i9: Graphic3d_ZLayerId, i19: Graphic3d_ZLayerId, i11: Graphic3d_ZLayerId, i12: Graphic3d_ZLayerId, i13: Graphic3d_ZLayerId, i14: Graphic3d_ZLayerId, i15: Graphic3d_ZLayerId, i16: Graphic3d_ZLayerId, i17: Graphic3d_ZLayerId, res1: Standard_CString, res2: Standard_CString, label: Standard_CString, subscript: Standard_CString): void;
  Values(i1: Graphic3d_ZLayerId, i2: Graphic3d_ZLayerId, i3: Graphic3d_ZLayerId, i4: Graphic3d_ZLayerId, i5: Graphic3d_ZLayerId, i6: Graphic3d_ZLayerId, i7: Graphic3d_ZLayerId, i8: Graphic3d_ZLayerId, i9: Graphic3d_ZLayerId, i19: Graphic3d_ZLayerId, i11: Graphic3d_ZLayerId, i12: Graphic3d_ZLayerId, i13: Graphic3d_ZLayerId, i14: Graphic3d_ZLayerId, i15: Graphic3d_ZLayerId, i16: Graphic3d_ZLayerId, i17: Graphic3d_ZLayerId, res1: Standard_CString, res2: Standard_CString, label: Standard_CString, subscript: Standard_CString): void;
  Type(): IGESData_IGESType;
  delete(): void;
}

export declare class Handle_IGESData_FreeFormatEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_FreeFormatEntity): void;
  get(): IGESData_FreeFormatEntity;
  delete(): void;
}

  export declare class Handle_IGESData_FreeFormatEntity_1 extends Handle_IGESData_FreeFormatEntity {
    constructor();
  }

  export declare class Handle_IGESData_FreeFormatEntity_2 extends Handle_IGESData_FreeFormatEntity {
    constructor(thePtr: IGESData_FreeFormatEntity);
  }

  export declare class Handle_IGESData_FreeFormatEntity_3 extends Handle_IGESData_FreeFormatEntity {
    constructor(theHandle: Handle_IGESData_FreeFormatEntity);
  }

  export declare class Handle_IGESData_FreeFormatEntity_4 extends Handle_IGESData_FreeFormatEntity {
    constructor(theHandle: Handle_IGESData_FreeFormatEntity);
  }

export declare class IGESData_FreeFormatEntity extends IGESData_UndefinedEntity {
  constructor()
  SetTypeNumber(typenum: Graphic3d_ZLayerId): void;
  SetFormNumber(formnum: Graphic3d_ZLayerId): void;
  NbParams(): Graphic3d_ZLayerId;
  ParamData(num: Graphic3d_ZLayerId, ptype: Interface_ParamType, ent: Handle_IGESData_IGESEntity, val: Handle_TCollection_HAsciiString): Standard_Boolean;
  ParamType(num: Graphic3d_ZLayerId): Interface_ParamType;
  IsParamEntity(num: Graphic3d_ZLayerId): Standard_Boolean;
  ParamEntity(num: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  IsNegativePointer(num: Graphic3d_ZLayerId): Standard_Boolean;
  ParamValue(num: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  NegativePointers(): Handle_TColStd_HSequenceOfInteger;
  AddLiteral_1(ptype: Interface_ParamType, val: Handle_TCollection_HAsciiString): void;
  AddLiteral_2(ptype: Interface_ParamType, val: Standard_CString): void;
  AddEntity(ptype: Interface_ParamType, ent: Handle_IGESData_IGESEntity, negative: Standard_Boolean): void;
  AddEntities(ents: Handle_IGESData_HArray1OfIGESEntity): void;
  AddNegativePointers(list: Handle_TColStd_HSequenceOfInteger): void;
  ClearNegativePointers(): void;
  WriteOwnParams(IW: IGESData_IGESWriter): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_LabelDisplayEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_LabelDisplayEntity): void;
  get(): IGESData_LabelDisplayEntity;
  delete(): void;
}

  export declare class Handle_IGESData_LabelDisplayEntity_1 extends Handle_IGESData_LabelDisplayEntity {
    constructor();
  }

  export declare class Handle_IGESData_LabelDisplayEntity_2 extends Handle_IGESData_LabelDisplayEntity {
    constructor(thePtr: IGESData_LabelDisplayEntity);
  }

  export declare class Handle_IGESData_LabelDisplayEntity_3 extends Handle_IGESData_LabelDisplayEntity {
    constructor(theHandle: Handle_IGESData_LabelDisplayEntity);
  }

  export declare class Handle_IGESData_LabelDisplayEntity_4 extends Handle_IGESData_LabelDisplayEntity {
    constructor(theHandle: Handle_IGESData_LabelDisplayEntity);
  }

export declare class IGESData_LabelDisplayEntity extends IGESData_IGESEntity {
  constructor();
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_TransfEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_TransfEntity): void;
  get(): IGESData_TransfEntity;
  delete(): void;
}

  export declare class Handle_IGESData_TransfEntity_1 extends Handle_IGESData_TransfEntity {
    constructor();
  }

  export declare class Handle_IGESData_TransfEntity_2 extends Handle_IGESData_TransfEntity {
    constructor(thePtr: IGESData_TransfEntity);
  }

  export declare class Handle_IGESData_TransfEntity_3 extends Handle_IGESData_TransfEntity {
    constructor(theHandle: Handle_IGESData_TransfEntity);
  }

  export declare class Handle_IGESData_TransfEntity_4 extends Handle_IGESData_TransfEntity {
    constructor(theHandle: Handle_IGESData_TransfEntity);
  }

export declare class IGESData_TransfEntity extends IGESData_IGESEntity {
  Value(): gp_GTrsf;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_HArray1OfIGESEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_HArray1OfIGESEntity): void;
  get(): IGESData_HArray1OfIGESEntity;
  delete(): void;
}

  export declare class Handle_IGESData_HArray1OfIGESEntity_1 extends Handle_IGESData_HArray1OfIGESEntity {
    constructor();
  }

  export declare class Handle_IGESData_HArray1OfIGESEntity_2 extends Handle_IGESData_HArray1OfIGESEntity {
    constructor(thePtr: IGESData_HArray1OfIGESEntity);
  }

  export declare class Handle_IGESData_HArray1OfIGESEntity_3 extends Handle_IGESData_HArray1OfIGESEntity {
    constructor(theHandle: Handle_IGESData_HArray1OfIGESEntity);
  }

  export declare class Handle_IGESData_HArray1OfIGESEntity_4 extends Handle_IGESData_HArray1OfIGESEntity {
    constructor(theHandle: Handle_IGESData_HArray1OfIGESEntity);
  }

export declare class IGESData_Array1OfDirPart {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: IGESData_DirPart): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: IGESData_Array1OfDirPart): IGESData_Array1OfDirPart;
  Move(theOther: IGESData_Array1OfDirPart): IGESData_Array1OfDirPart;
  First(): IGESData_DirPart;
  ChangeFirst(): IGESData_DirPart;
  Last(): IGESData_DirPart;
  ChangeLast(): IGESData_DirPart;
  Value(theIndex: Standard_Integer): IGESData_DirPart;
  ChangeValue(theIndex: Standard_Integer): IGESData_DirPart;
  SetValue(theIndex: Standard_Integer, theItem: IGESData_DirPart): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class IGESData_Array1OfDirPart_1 extends IGESData_Array1OfDirPart {
    constructor();
  }

  export declare class IGESData_Array1OfDirPart_2 extends IGESData_Array1OfDirPart {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class IGESData_Array1OfDirPart_3 extends IGESData_Array1OfDirPart {
    constructor(theOther: IGESData_Array1OfDirPart);
  }

  export declare class IGESData_Array1OfDirPart_4 extends IGESData_Array1OfDirPart {
    constructor(theOther: IGESData_Array1OfDirPart);
  }

  export declare class IGESData_Array1OfDirPart_5 extends IGESData_Array1OfDirPart {
    constructor(theBegin: IGESData_DirPart, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class IGESData {
  constructor();
  static Init(): void;
  static Protocol(): Handle_IGESData_Protocol;
  delete(): void;
}

export declare class IGESData_GlobalNodeOfSpecificLib extends Standard_Transient {
  constructor()
  Add(amodule: Handle_IGESData_SpecificModule, aprotocol: Handle_IGESData_Protocol): void;
  Module(): Handle_IGESData_SpecificModule;
  Protocol(): Handle_IGESData_Protocol;
  Next(): Handle_IGESData_GlobalNodeOfSpecificLib;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_GlobalNodeOfSpecificLib {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_GlobalNodeOfSpecificLib): void;
  get(): IGESData_GlobalNodeOfSpecificLib;
  delete(): void;
}

  export declare class Handle_IGESData_GlobalNodeOfSpecificLib_1 extends Handle_IGESData_GlobalNodeOfSpecificLib {
    constructor();
  }

  export declare class Handle_IGESData_GlobalNodeOfSpecificLib_2 extends Handle_IGESData_GlobalNodeOfSpecificLib {
    constructor(thePtr: IGESData_GlobalNodeOfSpecificLib);
  }

  export declare class Handle_IGESData_GlobalNodeOfSpecificLib_3 extends Handle_IGESData_GlobalNodeOfSpecificLib {
    constructor(theHandle: Handle_IGESData_GlobalNodeOfSpecificLib);
  }

  export declare class Handle_IGESData_GlobalNodeOfSpecificLib_4 extends Handle_IGESData_GlobalNodeOfSpecificLib {
    constructor(theHandle: Handle_IGESData_GlobalNodeOfSpecificLib);
  }

export declare class IGESData_ToolLocation extends Standard_Transient {
  constructor(amodel: Handle_IGESData_IGESModel, protocol: Handle_IGESData_Protocol)
  Load(): void;
  SetPrecision(prec: Quantity_AbsorbedDose): void;
  SetReference(parent: Handle_IGESData_IGESEntity, child: Handle_IGESData_IGESEntity): void;
  SetParentAssoc(parent: Handle_IGESData_IGESEntity, child: Handle_IGESData_IGESEntity): void;
  ResetDependences(child: Handle_IGESData_IGESEntity): void;
  SetOwnAsDependent(ent: Handle_IGESData_IGESEntity): void;
  IsTransf(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  IsAssociativity(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  HasTransf(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  ExplicitLocation(ent: Handle_IGESData_IGESEntity): gp_GTrsf;
  IsAmbiguous(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  HasParent(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  Parent(ent: Handle_IGESData_IGESEntity): Handle_IGESData_IGESEntity;
  HasParentByAssociativity(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  ParentLocation(ent: Handle_IGESData_IGESEntity): gp_GTrsf;
  EffectiveLocation(ent: Handle_IGESData_IGESEntity): gp_GTrsf;
  AnalyseLocation(loc: gp_GTrsf, result: gp_Trsf): Standard_Boolean;
  static ConvertLocation(prec: Quantity_AbsorbedDose, loc: gp_GTrsf, result: gp_Trsf, uni: Quantity_AbsorbedDose): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_IGESData_ToolLocation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_ToolLocation): void;
  get(): IGESData_ToolLocation;
  delete(): void;
}

  export declare class Handle_IGESData_ToolLocation_1 extends Handle_IGESData_ToolLocation {
    constructor();
  }

  export declare class Handle_IGESData_ToolLocation_2 extends Handle_IGESData_ToolLocation {
    constructor(thePtr: IGESData_ToolLocation);
  }

  export declare class Handle_IGESData_ToolLocation_3 extends Handle_IGESData_ToolLocation {
    constructor(theHandle: Handle_IGESData_ToolLocation);
  }

  export declare class Handle_IGESData_ToolLocation_4 extends Handle_IGESData_ToolLocation {
    constructor(theHandle: Handle_IGESData_ToolLocation);
  }

export declare class IGESData_GlobalSection {
  constructor()
  Init(params: Handle_Interface_ParamSet, ach: Handle_Interface_Check): void;
  CopyRefs(): void;
  Params(): Handle_Interface_ParamSet;
  TranslatedFromHollerith(astr: Handle_TCollection_HAsciiString): Handle_TCollection_HAsciiString;
  Separator(): Standard_Character;
  EndMark(): Standard_Character;
  SendName(): Handle_TCollection_HAsciiString;
  FileName(): Handle_TCollection_HAsciiString;
  SystemId(): Handle_TCollection_HAsciiString;
  InterfaceVersion(): Handle_TCollection_HAsciiString;
  IntegerBits(): Graphic3d_ZLayerId;
  MaxPower10Single(): Graphic3d_ZLayerId;
  MaxDigitsSingle(): Graphic3d_ZLayerId;
  MaxPower10Double(): Graphic3d_ZLayerId;
  MaxDigitsDouble(): Graphic3d_ZLayerId;
  ReceiveName(): Handle_TCollection_HAsciiString;
  Scale(): Quantity_AbsorbedDose;
  UnitFlag(): Graphic3d_ZLayerId;
  UnitName(): Handle_TCollection_HAsciiString;
  LineWeightGrad(): Graphic3d_ZLayerId;
  MaxLineWeight(): Quantity_AbsorbedDose;
  Date(): Handle_TCollection_HAsciiString;
  Resolution(): Quantity_AbsorbedDose;
  MaxCoord(): Quantity_AbsorbedDose;
  HasMaxCoord(): Standard_Boolean;
  AuthorName(): Handle_TCollection_HAsciiString;
  CompanyName(): Handle_TCollection_HAsciiString;
  IGESVersion(): Graphic3d_ZLayerId;
  DraftingStandard(): Graphic3d_ZLayerId;
  LastChangeDate(): Handle_TCollection_HAsciiString;
  HasLastChangeDate(): Standard_Boolean;
  SetLastChangeDate_1(): void;
  ApplicationProtocol(): Handle_TCollection_HAsciiString;
  HasApplicationProtocol(): Standard_Boolean;
  static NewDateString_1(year: Graphic3d_ZLayerId, month: Graphic3d_ZLayerId, day: Graphic3d_ZLayerId, hour: Graphic3d_ZLayerId, minut: Graphic3d_ZLayerId, second: Graphic3d_ZLayerId, mode: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  static NewDateString_2(date: Handle_TCollection_HAsciiString, mode: Graphic3d_ZLayerId): Handle_TCollection_HAsciiString;
  UnitValue(): Quantity_AbsorbedDose;
  SetSeparator(val: Standard_Character): void;
  SetEndMark(val: Standard_Character): void;
  SetSendName(val: Handle_TCollection_HAsciiString): void;
  SetFileName(val: Handle_TCollection_HAsciiString): void;
  SetSystemId(val: Handle_TCollection_HAsciiString): void;
  SetInterfaceVersion(val: Handle_TCollection_HAsciiString): void;
  SetIntegerBits(val: Graphic3d_ZLayerId): void;
  SetMaxPower10Single(val: Graphic3d_ZLayerId): void;
  SetMaxDigitsSingle(val: Graphic3d_ZLayerId): void;
  SetMaxPower10Double(val: Graphic3d_ZLayerId): void;
  SetMaxDigitsDouble(val: Graphic3d_ZLayerId): void;
  SetReceiveName(val: Handle_TCollection_HAsciiString): void;
  SetScale(val: Quantity_AbsorbedDose): void;
  SetUnitFlag(val: Graphic3d_ZLayerId): void;
  SetUnitName(val: Handle_TCollection_HAsciiString): void;
  SetLineWeightGrad(val: Graphic3d_ZLayerId): void;
  SetMaxLineWeight(val: Quantity_AbsorbedDose): void;
  SetDate(val: Handle_TCollection_HAsciiString): void;
  SetResolution(val: Quantity_AbsorbedDose): void;
  SetMaxCoord(val: Quantity_AbsorbedDose): void;
  MaxMaxCoord(val: Quantity_AbsorbedDose): void;
  MaxMaxCoords(xyz: gp_XYZ): void;
  SetAuthorName(val: Handle_TCollection_HAsciiString): void;
  SetCompanyName(val: Handle_TCollection_HAsciiString): void;
  SetIGESVersion(val: Graphic3d_ZLayerId): void;
  SetDraftingStandard(val: Graphic3d_ZLayerId): void;
  SetLastChangeDate_2(val: Handle_TCollection_HAsciiString): void;
  SetApplicationProtocol(val: Handle_TCollection_HAsciiString): void;
  delete(): void;
}

export declare class IGESData_IGESWriter {
  FloatWriter(): Interface_FloatWriter;
  WriteMode(): Graphic3d_ZLayerId;
  SendStartLine(startline: Standard_CString): void;
  SendModel(protocol: Handle_IGESData_Protocol): void;
  SectionS(): void;
  SectionG(header: IGESData_GlobalSection): void;
  SectionsDP(): void;
  SectionT(): void;
  DirPart(anent: Handle_IGESData_IGESEntity): void;
  OwnParams(anent: Handle_IGESData_IGESEntity): void;
  Associativities(anent: Handle_IGESData_IGESEntity): void;
  Properties(anent: Handle_IGESData_IGESEntity): void;
  EndEntity(): void;
  SendVoid(): void;
  Send_1(val: Graphic3d_ZLayerId): void;
  SendBoolean(val: Standard_Boolean): void;
  Send_2(val: Quantity_AbsorbedDose): void;
  Send_3(val: Handle_TCollection_HAsciiString): void;
  Send_4(val: Handle_IGESData_IGESEntity, negative: Standard_Boolean): void;
  SendString(val: Handle_TCollection_HAsciiString): void;
  Send_6(val: gp_XY): void;
  Send_7(val: gp_XYZ): void;
  SectionStrings(numsec: Graphic3d_ZLayerId): Handle_TColStd_HSequenceOfHAsciiString;
  Print(S: Standard_OStream): Standard_Boolean;
  delete(): void;
}

  export declare class IGESData_IGESWriter_1 extends IGESData_IGESWriter {
    constructor(amodel: Handle_IGESData_IGESModel);
  }

  export declare class IGESData_IGESWriter_2 extends IGESData_IGESWriter {
    constructor();
  }

  export declare class IGESData_IGESWriter_3 extends IGESData_IGESWriter {
    constructor(other: IGESData_IGESWriter);
  }

export declare class Handle_IGESData_ViewKindEntity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_ViewKindEntity): void;
  get(): IGESData_ViewKindEntity;
  delete(): void;
}

  export declare class Handle_IGESData_ViewKindEntity_1 extends Handle_IGESData_ViewKindEntity {
    constructor();
  }

  export declare class Handle_IGESData_ViewKindEntity_2 extends Handle_IGESData_ViewKindEntity {
    constructor(thePtr: IGESData_ViewKindEntity);
  }

  export declare class Handle_IGESData_ViewKindEntity_3 extends Handle_IGESData_ViewKindEntity {
    constructor(theHandle: Handle_IGESData_ViewKindEntity);
  }

  export declare class Handle_IGESData_ViewKindEntity_4 extends Handle_IGESData_ViewKindEntity {
    constructor(theHandle: Handle_IGESData_ViewKindEntity);
  }

export declare class IGESData_ViewKindEntity extends IGESData_IGESEntity {
  IsSingle(): Standard_Boolean;
  NbViews(): Graphic3d_ZLayerId;
  ViewItem(num: Graphic3d_ZLayerId): Handle_IGESData_ViewKindEntity;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESData_ParamCursor {
  SetTerm(size: Graphic3d_ZLayerId, autoadv: Standard_Boolean): void;
  SetOne(autoadv: Standard_Boolean): void;
  SetXY(autoadv: Standard_Boolean): void;
  SetXYZ(autoadv: Standard_Boolean): void;
  SetAdvance(advance: Standard_Boolean): void;
  Start(): Graphic3d_ZLayerId;
  Limit(): Graphic3d_ZLayerId;
  Count(): Graphic3d_ZLayerId;
  ItemSize(): Graphic3d_ZLayerId;
  TermSize(): Graphic3d_ZLayerId;
  Offset(): Graphic3d_ZLayerId;
  Advance(): Standard_Boolean;
  delete(): void;
}

  export declare class IGESData_ParamCursor_1 extends IGESData_ParamCursor {
    constructor(num: Graphic3d_ZLayerId);
  }

  export declare class IGESData_ParamCursor_2 extends IGESData_ParamCursor {
    constructor(num: Graphic3d_ZLayerId, nb: Graphic3d_ZLayerId, size: Graphic3d_ZLayerId);
  }

export declare class IGESData_IGESDumper {
  constructor(model: Handle_IGESData_IGESModel, protocol: Handle_IGESData_Protocol)
  PrintDNum(ent: Handle_IGESData_IGESEntity, S: Standard_OStream): void;
  PrintShort(ent: Handle_IGESData_IGESEntity, S: Standard_OStream): void;
  Dump(ent: Handle_IGESData_IGESEntity, S: Standard_OStream, own: Graphic3d_ZLayerId, attached: Graphic3d_ZLayerId): void;
  OwnDump(ent: Handle_IGESData_IGESEntity, S: Standard_OStream, own: Graphic3d_ZLayerId): void;
  delete(): void;
}

export declare class IGESData_SpecificLib {
  static SetGlobal(amodule: Handle_IGESData_SpecificModule, aprotocol: Handle_IGESData_Protocol): void;
  AddProtocol(aprotocol: Handle_Standard_Transient): void;
  Clear(): void;
  SetComplete(): void;
  Select(obj: Handle_IGESData_IGESEntity, module: Handle_IGESData_SpecificModule, CN: Graphic3d_ZLayerId): Standard_Boolean;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Module(): Handle_IGESData_SpecificModule;
  Protocol(): Handle_IGESData_Protocol;
  delete(): void;
}

  export declare class IGESData_SpecificLib_1 extends IGESData_SpecificLib {
    constructor(aprotocol: Handle_IGESData_Protocol);
  }

  export declare class IGESData_SpecificLib_2 extends IGESData_SpecificLib {
    constructor();
  }

export declare class IGESData_ParamReader {
  constructor(list: Handle_Interface_ParamList, ach: Handle_Interface_Check, base: Graphic3d_ZLayerId, nbpar: Graphic3d_ZLayerId, num: Graphic3d_ZLayerId)
  EntityNumber(): Graphic3d_ZLayerId;
  Clear(): void;
  CurrentNumber(): Graphic3d_ZLayerId;
  SetCurrentNumber(num: Graphic3d_ZLayerId): void;
  Stage(): IGESData_ReadStage;
  NextStage(): void;
  EndAll(): void;
  NbParams(): Graphic3d_ZLayerId;
  ParamType(num: Graphic3d_ZLayerId): Interface_ParamType;
  ParamValue(num: Graphic3d_ZLayerId): Standard_CString;
  IsParamDefined(num: Graphic3d_ZLayerId): Standard_Boolean;
  IsParamEntity(num: Graphic3d_ZLayerId): Standard_Boolean;
  ParamNumber(num: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  ParamEntity(IR: Handle_IGESData_IGESReaderData, num: Graphic3d_ZLayerId): Handle_IGESData_IGESEntity;
  Current(): IGESData_ParamCursor;
  CurrentList(nb: Graphic3d_ZLayerId, size: Graphic3d_ZLayerId): IGESData_ParamCursor;
  DefinedElseSkip(): Standard_Boolean;
  ReadInteger_1(PC: IGESData_ParamCursor, val: Graphic3d_ZLayerId): Standard_Boolean;
  ReadInteger_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Graphic3d_ZLayerId): Standard_Boolean;
  ReadBoolean_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: Standard_Boolean, exact: Standard_Boolean): Standard_Boolean;
  ReadBoolean_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Standard_Boolean, exact: Standard_Boolean): Standard_Boolean;
  ReadReal_1(PC: IGESData_ParamCursor, val: Quantity_AbsorbedDose): Standard_Boolean;
  ReadReal_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Quantity_AbsorbedDose): Standard_Boolean;
  ReadXY_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: gp_XY): Standard_Boolean;
  ReadXY_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: gp_XY): Standard_Boolean;
  ReadXYZ_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: gp_XYZ): Standard_Boolean;
  ReadXYZ_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: gp_XYZ): Standard_Boolean;
  ReadText_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: Handle_TCollection_HAsciiString): Standard_Boolean;
  ReadText_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Handle_TCollection_HAsciiString): Standard_Boolean;
  ReadEntity_1(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, aStatus: IGESData_Status, val: Handle_IGESData_IGESEntity, canbenul: Standard_Boolean): Standard_Boolean;
  ReadEntity_2(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, mess: Standard_CString, val: Handle_IGESData_IGESEntity, canbenul: Standard_Boolean): Standard_Boolean;
  ReadEntity_3(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, aStatus: IGESData_Status, type: Handle_Standard_Type, val: Handle_IGESData_IGESEntity, canbenul: Standard_Boolean): Standard_Boolean;
  ReadEntity_5(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, mess: Standard_CString, type: Handle_Standard_Type, val: Handle_IGESData_IGESEntity, canbenul: Standard_Boolean): Standard_Boolean;
  ReadInts_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: Handle_TColStd_HArray1OfInteger, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadInts_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Handle_TColStd_HArray1OfInteger, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadReals_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: Handle_TColStd_HArray1OfReal, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadReals_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Handle_TColStd_HArray1OfReal, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadTexts_1(PC: IGESData_ParamCursor, amsg: Message_Msg, val: Handle_Interface_HArray1OfHAsciiString, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadTexts_2(PC: IGESData_ParamCursor, mess: Standard_CString, val: Handle_Interface_HArray1OfHAsciiString, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadEnts_1(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, amsg: Message_Msg, val: Handle_IGESData_HArray1OfIGESEntity, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadEnts_2(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, mess: Standard_CString, val: Handle_IGESData_HArray1OfIGESEntity, index: Graphic3d_ZLayerId): Standard_Boolean;
  ReadEntList_1(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, amsg: Message_Msg, val: Interface_EntityList, ord: Standard_Boolean): Standard_Boolean;
  ReadEntList_2(IR: Handle_IGESData_IGESReaderData, PC: IGESData_ParamCursor, mess: Standard_CString, val: Interface_EntityList, ord: Standard_Boolean): Standard_Boolean;
  ReadingReal_1(num: Graphic3d_ZLayerId, val: Quantity_AbsorbedDose): Standard_Boolean;
  ReadingReal_2(num: Graphic3d_ZLayerId, mess: Standard_CString, val: Quantity_AbsorbedDose): Standard_Boolean;
  ReadingEntityNumber_1(num: Graphic3d_ZLayerId, val: Graphic3d_ZLayerId): Standard_Boolean;
  ReadingEntityNumber_2(num: Graphic3d_ZLayerId, mess: Standard_CString, val: Graphic3d_ZLayerId): Standard_Boolean;
  SendFail(amsg: Message_Msg): void;
  SendWarning(amsg: Message_Msg): void;
  AddFail_1(afail: Standard_CString, bfail: Standard_CString): void;
  AddFail_2(af: Handle_TCollection_HAsciiString, bf: Handle_TCollection_HAsciiString): void;
  AddWarning_1(awarn: Standard_CString, bwarn: Standard_CString): void;
  AddWarning_2(aw: Handle_TCollection_HAsciiString, bw: Handle_TCollection_HAsciiString): void;
  Mend(pref: Standard_CString): void;
  HasFailed(): Standard_Boolean;
  Check(): Handle_Interface_Check;
  CCheck(): Handle_Interface_Check;
  IsCheckEmpty(): Standard_Boolean;
  delete(): void;
}

export declare class IGESData_DefSwitch {
  constructor()
  SetVoid(): void;
  SetReference(): void;
  SetRank(val: Graphic3d_ZLayerId): void;
  DefType(): IGESData_DefType;
  Value(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class IGESData_WriterLib {
  static SetGlobal(amodule: Handle_IGESData_ReadWriteModule, aprotocol: Handle_IGESData_Protocol): void;
  AddProtocol(aprotocol: Handle_Standard_Transient): void;
  Clear(): void;
  SetComplete(): void;
  Select(obj: Handle_IGESData_IGESEntity, module: Handle_IGESData_ReadWriteModule, CN: Graphic3d_ZLayerId): Standard_Boolean;
  Start(): void;
  More(): Standard_Boolean;
  Next(): void;
  Module(): Handle_IGESData_ReadWriteModule;
  Protocol(): Handle_IGESData_Protocol;
  delete(): void;
}

  export declare class IGESData_WriterLib_1 extends IGESData_WriterLib {
    constructor(aprotocol: Handle_IGESData_Protocol);
  }

  export declare class IGESData_WriterLib_2 extends IGESData_WriterLib {
    constructor();
  }

export declare class Handle_IGESData_DefaultGeneral {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: IGESData_DefaultGeneral): void;
  get(): IGESData_DefaultGeneral;
  delete(): void;
}

  export declare class Handle_IGESData_DefaultGeneral_1 extends Handle_IGESData_DefaultGeneral {
    constructor();
  }

  export declare class Handle_IGESData_DefaultGeneral_2 extends Handle_IGESData_DefaultGeneral {
    constructor(thePtr: IGESData_DefaultGeneral);
  }

  export declare class Handle_IGESData_DefaultGeneral_3 extends Handle_IGESData_DefaultGeneral {
    constructor(theHandle: Handle_IGESData_DefaultGeneral);
  }

  export declare class Handle_IGESData_DefaultGeneral_4 extends Handle_IGESData_DefaultGeneral {
    constructor(theHandle: Handle_IGESData_DefaultGeneral);
  }

export declare class IGESData_DefaultGeneral extends IGESData_GeneralModule {
  constructor()
  OwnSharedCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, iter: Interface_EntityIterator): void;
  DirChecker(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity): IGESData_DirChecker;
  OwnCheckCase(CN: Graphic3d_ZLayerId, ent: Handle_IGESData_IGESEntity, shares: Interface_ShareTool, ach: Handle_Interface_Check): void;
  NewVoid(CN: Graphic3d_ZLayerId, entto: Handle_Standard_Transient): Standard_Boolean;
  OwnCopyCase(CN: Graphic3d_ZLayerId, entfrom: Handle_IGESData_IGESEntity, entto: Handle_IGESData_IGESEntity, TC: Interface_CopyTool): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class IGESData_DirChecker {
  IsSet(): Standard_Boolean;
  SetDefault(): void;
  Structure(crit: IGESData_DefType): void;
  LineFont(crit: IGESData_DefType): void;
  LineWeight(crit: IGESData_DefType): void;
  Color(crit: IGESData_DefType): void;
  GraphicsIgnored(hierarchy: Graphic3d_ZLayerId): void;
  BlankStatusIgnored(): void;
  BlankStatusRequired(val: Graphic3d_ZLayerId): void;
  SubordinateStatusIgnored(): void;
  SubordinateStatusRequired(val: Graphic3d_ZLayerId): void;
  UseFlagIgnored(): void;
  UseFlagRequired(val: Graphic3d_ZLayerId): void;
  HierarchyStatusIgnored(): void;
  HierarchyStatusRequired(val: Graphic3d_ZLayerId): void;
  Check(ach: Handle_Interface_Check, ent: Handle_IGESData_IGESEntity): void;
  CheckTypeAndForm(ach: Handle_Interface_Check, ent: Handle_IGESData_IGESEntity): void;
  Correct(ent: Handle_IGESData_IGESEntity): Standard_Boolean;
  delete(): void;
}

  export declare class IGESData_DirChecker_1 extends IGESData_DirChecker {
    constructor();
  }

  export declare class IGESData_DirChecker_2 extends IGESData_DirChecker {
    constructor(atype: Graphic3d_ZLayerId);
  }

  export declare class IGESData_DirChecker_3 extends IGESData_DirChecker {
    constructor(atype: Graphic3d_ZLayerId, aform: Graphic3d_ZLayerId);
  }

  export declare class IGESData_DirChecker_4 extends IGESData_DirChecker {
    constructor(atype: Graphic3d_ZLayerId, aform1: Graphic3d_ZLayerId, aform2: Graphic3d_ZLayerId);
  }

export declare class Geom2d_BSplineCurve extends Geom2d_BoundedCurve {
  IncreaseDegree(Degree: Graphic3d_ZLayerId): void;
  IncreaseMultiplicity_1(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncreaseMultiplicity_2(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  IncrementMultiplicity(I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId): void;
  InsertKnot(U: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId, ParametricTolerance: Quantity_AbsorbedDose): void;
  InsertKnots(Knots: TColStd_Array1OfReal, Mults: TColStd_Array1OfInteger, ParametricTolerance: Quantity_AbsorbedDose, Add: Standard_Boolean): void;
  RemoveKnot(Index: Graphic3d_ZLayerId, M: Graphic3d_ZLayerId, Tolerance: Quantity_AbsorbedDose): Standard_Boolean;
  InsertPoleAfter(Index: Graphic3d_ZLayerId, P: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  InsertPoleBefore(Index: Graphic3d_ZLayerId, P: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  RemovePole(Index: Graphic3d_ZLayerId): void;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, theTolerance: Quantity_AbsorbedDose): void;
  SetKnot_1(Index: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose): void;
  SetKnots(K: TColStd_Array1OfReal): void;
  SetKnot_2(Index: Graphic3d_ZLayerId, K: Quantity_AbsorbedDose, M: Graphic3d_ZLayerId): void;
  PeriodicNormalization(U: Quantity_AbsorbedDose): void;
  SetPeriodic(): void;
  SetOrigin(Index: Graphic3d_ZLayerId): void;
  SetNotPeriodic(): void;
  SetPole_1(Index: Graphic3d_ZLayerId, P: gp_Pnt2d): void;
  SetPole_2(Index: Graphic3d_ZLayerId, P: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  SetWeight(Index: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  MovePoint(U: Quantity_AbsorbedDose, P: gp_Pnt2d, Index1: Graphic3d_ZLayerId, Index2: Graphic3d_ZLayerId, FirstModifiedPole: Graphic3d_ZLayerId, LastModifiedPole: Graphic3d_ZLayerId): void;
  MovePointAndTangent(U: Quantity_AbsorbedDose, P: gp_Pnt2d, Tangent: gp_Vec2d, Tolerance: Quantity_AbsorbedDose, StartingCondition: Graphic3d_ZLayerId, EndingCondition: Graphic3d_ZLayerId, ErrorStatus: Graphic3d_ZLayerId): void;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsG1(theTf: Quantity_AbsorbedDose, theTl: Quantity_AbsorbedDose, theAngTol: Quantity_AbsorbedDose): Standard_Boolean;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  IsRational(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Degree(): Graphic3d_ZLayerId;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  LocalValue(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId): gp_Pnt2d;
  LocalD0(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt2d): void;
  LocalD1(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt2d, V1: gp_Vec2d): void;
  LocalD2(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  LocalD3(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  LocalDN(U: Quantity_AbsorbedDose, FromK1: Graphic3d_ZLayerId, ToK2: Graphic3d_ZLayerId, N: Graphic3d_ZLayerId): gp_Vec2d;
  EndPoint(): gp_Pnt2d;
  FirstUKnotIndex(): Graphic3d_ZLayerId;
  FirstParameter(): Quantity_AbsorbedDose;
  Knot(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Knots_1(K: TColStd_Array1OfReal): void;
  Knots_2(): TColStd_Array1OfReal;
  KnotSequence_1(K: TColStd_Array1OfReal): void;
  KnotSequence_2(): TColStd_Array1OfReal;
  KnotDistribution(): GeomAbs_BSplKnotDistribution;
  LastUKnotIndex(): Graphic3d_ZLayerId;
  LastParameter(): Quantity_AbsorbedDose;
  LocateU(U: Quantity_AbsorbedDose, ParametricTolerance: Quantity_AbsorbedDose, I1: Graphic3d_ZLayerId, I2: Graphic3d_ZLayerId, WithKnotRepetition: Standard_Boolean): void;
  Multiplicity(Index: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Multiplicities_1(M: TColStd_Array1OfInteger): void;
  Multiplicities_2(): TColStd_Array1OfInteger;
  NbKnots(): Graphic3d_ZLayerId;
  NbPoles(): Graphic3d_ZLayerId;
  Pole(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  Poles_1(P: TColgp_Array1OfPnt2d): void;
  Poles_2(): TColgp_Array1OfPnt2d;
  StartPoint(): gp_Pnt2d;
  Weight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights_1(W: TColStd_Array1OfReal): void;
  Weights_2(): TColStd_Array1OfReal;
  Transform(T: gp_Trsf2d): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  Resolution(ToleranceUV: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_BSplineCurve_1 extends Geom2d_BSplineCurve {
    constructor(Poles: TColgp_Array1OfPnt2d, Knots: TColStd_Array1OfReal, Multiplicities: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean);
  }

  export declare class Geom2d_BSplineCurve_2 extends Geom2d_BSplineCurve {
    constructor(Poles: TColgp_Array1OfPnt2d, Weights: TColStd_Array1OfReal, Knots: TColStd_Array1OfReal, Multiplicities: TColStd_Array1OfInteger, Degree: Graphic3d_ZLayerId, Periodic: Standard_Boolean);
  }

export declare class Handle_Geom2d_BSplineCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_BSplineCurve): void;
  get(): Geom2d_BSplineCurve;
  delete(): void;
}

  export declare class Handle_Geom2d_BSplineCurve_1 extends Handle_Geom2d_BSplineCurve {
    constructor();
  }

  export declare class Handle_Geom2d_BSplineCurve_2 extends Handle_Geom2d_BSplineCurve {
    constructor(thePtr: Geom2d_BSplineCurve);
  }

  export declare class Handle_Geom2d_BSplineCurve_3 extends Handle_Geom2d_BSplineCurve {
    constructor(theHandle: Handle_Geom2d_BSplineCurve);
  }

  export declare class Handle_Geom2d_BSplineCurve_4 extends Handle_Geom2d_BSplineCurve {
    constructor(theHandle: Handle_Geom2d_BSplineCurve);
  }

export declare class Geom2d_Hyperbola extends Geom2d_Conic {
  SetHypr2d(H: gp_Hypr2d): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  Hypr2d(): gp_Hypr2d;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Asymptote1(): gp_Ax2d;
  Asymptote2(): gp_Ax2d;
  ConjugateBranch1(): gp_Hypr2d;
  ConjugateBranch2(): gp_Hypr2d;
  Directrix1(): gp_Ax2d;
  Directrix2(): gp_Ax2d;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt2d;
  Focus2(): gp_Pnt2d;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  OtherBranch(): gp_Hypr2d;
  Parameter(): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Hyperbola_1 extends Geom2d_Hyperbola {
    constructor(H: gp_Hypr2d);
  }

  export declare class Geom2d_Hyperbola_2 extends Geom2d_Hyperbola {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class Geom2d_Hyperbola_3 extends Geom2d_Hyperbola {
    constructor(Axis: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom2d_Hyperbola {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Hyperbola): void;
  get(): Geom2d_Hyperbola;
  delete(): void;
}

  export declare class Handle_Geom2d_Hyperbola_1 extends Handle_Geom2d_Hyperbola {
    constructor();
  }

  export declare class Handle_Geom2d_Hyperbola_2 extends Handle_Geom2d_Hyperbola {
    constructor(thePtr: Geom2d_Hyperbola);
  }

  export declare class Handle_Geom2d_Hyperbola_3 extends Handle_Geom2d_Hyperbola {
    constructor(theHandle: Handle_Geom2d_Hyperbola);
  }

  export declare class Handle_Geom2d_Hyperbola_4 extends Handle_Geom2d_Hyperbola {
    constructor(theHandle: Handle_Geom2d_Hyperbola);
  }

export declare class Geom2d_Direction extends Geom2d_Vector {
  SetCoord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  SetDir2d(V: gp_Dir2d): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  Dir2d(): gp_Dir2d;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  Crossed(Other: Handle_Geom2d_Vector): Quantity_AbsorbedDose;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Direction_1 extends Geom2d_Direction {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose);
  }

  export declare class Geom2d_Direction_2 extends Geom2d_Direction {
    constructor(V: gp_Dir2d);
  }

export declare class Handle_Geom2d_Direction {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Direction): void;
  get(): Geom2d_Direction;
  delete(): void;
}

  export declare class Handle_Geom2d_Direction_1 extends Handle_Geom2d_Direction {
    constructor();
  }

  export declare class Handle_Geom2d_Direction_2 extends Handle_Geom2d_Direction {
    constructor(thePtr: Geom2d_Direction);
  }

  export declare class Handle_Geom2d_Direction_3 extends Handle_Geom2d_Direction {
    constructor(theHandle: Handle_Geom2d_Direction);
  }

  export declare class Handle_Geom2d_Direction_4 extends Handle_Geom2d_Direction {
    constructor(theHandle: Handle_Geom2d_Direction);
  }

export declare class Handle_Geom2d_CartesianPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_CartesianPoint): void;
  get(): Geom2d_CartesianPoint;
  delete(): void;
}

  export declare class Handle_Geom2d_CartesianPoint_1 extends Handle_Geom2d_CartesianPoint {
    constructor();
  }

  export declare class Handle_Geom2d_CartesianPoint_2 extends Handle_Geom2d_CartesianPoint {
    constructor(thePtr: Geom2d_CartesianPoint);
  }

  export declare class Handle_Geom2d_CartesianPoint_3 extends Handle_Geom2d_CartesianPoint {
    constructor(theHandle: Handle_Geom2d_CartesianPoint);
  }

  export declare class Handle_Geom2d_CartesianPoint_4 extends Handle_Geom2d_CartesianPoint {
    constructor(theHandle: Handle_Geom2d_CartesianPoint);
  }

export declare class Geom2d_CartesianPoint extends Geom2d_Point {
  SetCoord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  SetPnt2d(P: gp_Pnt2d): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  Coord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Pnt2d(): gp_Pnt2d;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_CartesianPoint_1 extends Geom2d_CartesianPoint {
    constructor(P: gp_Pnt2d);
  }

  export declare class Geom2d_CartesianPoint_2 extends Geom2d_CartesianPoint {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom2d_Circle {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Circle): void;
  get(): Geom2d_Circle;
  delete(): void;
}

  export declare class Handle_Geom2d_Circle_1 extends Handle_Geom2d_Circle {
    constructor();
  }

  export declare class Handle_Geom2d_Circle_2 extends Handle_Geom2d_Circle {
    constructor(thePtr: Geom2d_Circle);
  }

  export declare class Handle_Geom2d_Circle_3 extends Handle_Geom2d_Circle {
    constructor(theHandle: Handle_Geom2d_Circle);
  }

  export declare class Handle_Geom2d_Circle_4 extends Handle_Geom2d_Circle {
    constructor(theHandle: Handle_Geom2d_Circle);
  }

export declare class Geom2d_Circle extends Geom2d_Conic {
  SetCirc2d(C: gp_Circ2d): void;
  SetRadius(R: Quantity_AbsorbedDose): void;
  Circ2d(): gp_Circ2d;
  Radius(): Quantity_AbsorbedDose;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Eccentricity(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Circle_1 extends Geom2d_Circle {
    constructor(C: gp_Circ2d);
  }

  export declare class Geom2d_Circle_2 extends Geom2d_Circle {
    constructor(A: gp_Ax2d, Radius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class Geom2d_Circle_3 extends Geom2d_Circle {
    constructor(A: gp_Ax22d, Radius: Quantity_AbsorbedDose);
  }

export declare class Geom2d_Geometry extends Standard_Transient {
  Mirror_1(P: gp_Pnt2d): void;
  Mirror_2(A: gp_Ax2d): void;
  Rotate(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  Scale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  Translate_1(V: gp_Vec2d): void;
  Translate_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  Transform(T: gp_Trsf2d): void;
  Mirrored_1(P: gp_Pnt2d): Handle_Geom2d_Geometry;
  Mirrored_2(A: gp_Ax2d): Handle_Geom2d_Geometry;
  Rotated(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): Handle_Geom2d_Geometry;
  Scaled(P: gp_Pnt2d, S: Quantity_AbsorbedDose): Handle_Geom2d_Geometry;
  Transformed(T: gp_Trsf2d): Handle_Geom2d_Geometry;
  Translated_1(V: gp_Vec2d): Handle_Geom2d_Geometry;
  Translated_2(P1: gp_Pnt2d, P2: gp_Pnt2d): Handle_Geom2d_Geometry;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_Geometry {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Geometry): void;
  get(): Geom2d_Geometry;
  delete(): void;
}

  export declare class Handle_Geom2d_Geometry_1 extends Handle_Geom2d_Geometry {
    constructor();
  }

  export declare class Handle_Geom2d_Geometry_2 extends Handle_Geom2d_Geometry {
    constructor(thePtr: Geom2d_Geometry);
  }

  export declare class Handle_Geom2d_Geometry_3 extends Handle_Geom2d_Geometry {
    constructor(theHandle: Handle_Geom2d_Geometry);
  }

  export declare class Handle_Geom2d_Geometry_4 extends Handle_Geom2d_Geometry {
    constructor(theHandle: Handle_Geom2d_Geometry);
  }

export declare class Handle_Geom2d_Curve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Curve): void;
  get(): Geom2d_Curve;
  delete(): void;
}

  export declare class Handle_Geom2d_Curve_1 extends Handle_Geom2d_Curve {
    constructor();
  }

  export declare class Handle_Geom2d_Curve_2 extends Handle_Geom2d_Curve {
    constructor(thePtr: Geom2d_Curve);
  }

  export declare class Handle_Geom2d_Curve_3 extends Handle_Geom2d_Curve {
    constructor(theHandle: Handle_Geom2d_Curve);
  }

  export declare class Handle_Geom2d_Curve_4 extends Handle_Geom2d_Curve {
    constructor(theHandle: Handle_Geom2d_Curve);
  }

export declare class Geom2d_Curve extends Geom2d_Geometry {
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf2d): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf2d): Quantity_AbsorbedDose;
  Reversed(): Handle_Geom2d_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Value(U: Quantity_AbsorbedDose): gp_Pnt2d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Geom2d_Ellipse extends Geom2d_Conic {
  SetElips2d(E: gp_Elips2d): void;
  SetMajorRadius(MajorRadius: Quantity_AbsorbedDose): void;
  SetMinorRadius(MinorRadius: Quantity_AbsorbedDose): void;
  Elips2d(): gp_Elips2d;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Directrix1(): gp_Ax2d;
  Directrix2(): gp_Ax2d;
  Eccentricity(): Quantity_AbsorbedDose;
  Focal(): Quantity_AbsorbedDose;
  Focus1(): gp_Pnt2d;
  Focus2(): gp_Pnt2d;
  MajorRadius(): Quantity_AbsorbedDose;
  MinorRadius(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Ellipse_1 extends Geom2d_Ellipse {
    constructor(E: gp_Elips2d);
  }

  export declare class Geom2d_Ellipse_2 extends Geom2d_Ellipse {
    constructor(MajorAxis: gp_Ax2d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class Geom2d_Ellipse_3 extends Geom2d_Ellipse {
    constructor(Axis: gp_Ax22d, MajorRadius: Quantity_AbsorbedDose, MinorRadius: Quantity_AbsorbedDose);
  }

export declare class Handle_Geom2d_Ellipse {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Ellipse): void;
  get(): Geom2d_Ellipse;
  delete(): void;
}

  export declare class Handle_Geom2d_Ellipse_1 extends Handle_Geom2d_Ellipse {
    constructor();
  }

  export declare class Handle_Geom2d_Ellipse_2 extends Handle_Geom2d_Ellipse {
    constructor(thePtr: Geom2d_Ellipse);
  }

  export declare class Handle_Geom2d_Ellipse_3 extends Handle_Geom2d_Ellipse {
    constructor(theHandle: Handle_Geom2d_Ellipse);
  }

  export declare class Handle_Geom2d_Ellipse_4 extends Handle_Geom2d_Ellipse {
    constructor(theHandle: Handle_Geom2d_Ellipse);
  }

export declare class Geom2d_AxisPlacement extends Geom2d_Geometry {
  Reverse(): void;
  Reversed(): Handle_Geom2d_AxisPlacement;
  SetAxis(A: gp_Ax2d): void;
  SetDirection(V: gp_Dir2d): void;
  SetLocation(P: gp_Pnt2d): void;
  Angle(Other: Handle_Geom2d_AxisPlacement): Quantity_AbsorbedDose;
  Ax2d(): gp_Ax2d;
  Direction(): gp_Dir2d;
  Location(): gp_Pnt2d;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_AxisPlacement_1 extends Geom2d_AxisPlacement {
    constructor(A: gp_Ax2d);
  }

  export declare class Geom2d_AxisPlacement_2 extends Geom2d_AxisPlacement {
    constructor(P: gp_Pnt2d, V: gp_Dir2d);
  }

export declare class Handle_Geom2d_AxisPlacement {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_AxisPlacement): void;
  get(): Geom2d_AxisPlacement;
  delete(): void;
}

  export declare class Handle_Geom2d_AxisPlacement_1 extends Handle_Geom2d_AxisPlacement {
    constructor();
  }

  export declare class Handle_Geom2d_AxisPlacement_2 extends Handle_Geom2d_AxisPlacement {
    constructor(thePtr: Geom2d_AxisPlacement);
  }

  export declare class Handle_Geom2d_AxisPlacement_3 extends Handle_Geom2d_AxisPlacement {
    constructor(theHandle: Handle_Geom2d_AxisPlacement);
  }

  export declare class Handle_Geom2d_AxisPlacement_4 extends Handle_Geom2d_AxisPlacement {
    constructor(theHandle: Handle_Geom2d_AxisPlacement);
  }

export declare class Geom2d_Parabola extends Geom2d_Conic {
  SetFocal(Focal: Quantity_AbsorbedDose): void;
  SetParab2d(Prb: gp_Parab2d): void;
  Parab2d(): gp_Parab2d;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Directrix(): gp_Ax2d;
  Eccentricity(): Quantity_AbsorbedDose;
  Focus(): gp_Pnt2d;
  Focal(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf2d): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf2d): Quantity_AbsorbedDose;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Parabola_1 extends Geom2d_Parabola {
    constructor(Prb: gp_Parab2d);
  }

  export declare class Geom2d_Parabola_2 extends Geom2d_Parabola {
    constructor(MirrorAxis: gp_Ax2d, Focal: Quantity_AbsorbedDose, Sense: Standard_Boolean);
  }

  export declare class Geom2d_Parabola_3 extends Geom2d_Parabola {
    constructor(Axis: gp_Ax22d, Focal: Quantity_AbsorbedDose);
  }

  export declare class Geom2d_Parabola_4 extends Geom2d_Parabola {
    constructor(D: gp_Ax2d, F: gp_Pnt2d);
  }

export declare class Handle_Geom2d_Parabola {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Parabola): void;
  get(): Geom2d_Parabola;
  delete(): void;
}

  export declare class Handle_Geom2d_Parabola_1 extends Handle_Geom2d_Parabola {
    constructor();
  }

  export declare class Handle_Geom2d_Parabola_2 extends Handle_Geom2d_Parabola {
    constructor(thePtr: Geom2d_Parabola);
  }

  export declare class Handle_Geom2d_Parabola_3 extends Handle_Geom2d_Parabola {
    constructor(theHandle: Handle_Geom2d_Parabola);
  }

  export declare class Handle_Geom2d_Parabola_4 extends Handle_Geom2d_Parabola {
    constructor(theHandle: Handle_Geom2d_Parabola);
  }

export declare class Geom2d_TrimmedCurve extends Geom2d_BoundedCurve {
  constructor(C: Handle_Geom2d_Curve, U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Sense: Standard_Boolean, theAdjustPeriodic: Standard_Boolean)
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  SetTrim(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose, Sense: Standard_Boolean, theAdjustPeriodic: Standard_Boolean): void;
  BasisCurve(): Handle_Geom2d_Curve;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  EndPoint(): gp_Pnt2d;
  FirstParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  StartPoint(): gp_Pnt2d;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf2d): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf2d): Quantity_AbsorbedDose;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_TrimmedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_TrimmedCurve): void;
  get(): Geom2d_TrimmedCurve;
  delete(): void;
}

  export declare class Handle_Geom2d_TrimmedCurve_1 extends Handle_Geom2d_TrimmedCurve {
    constructor();
  }

  export declare class Handle_Geom2d_TrimmedCurve_2 extends Handle_Geom2d_TrimmedCurve {
    constructor(thePtr: Geom2d_TrimmedCurve);
  }

  export declare class Handle_Geom2d_TrimmedCurve_3 extends Handle_Geom2d_TrimmedCurve {
    constructor(theHandle: Handle_Geom2d_TrimmedCurve);
  }

  export declare class Handle_Geom2d_TrimmedCurve_4 extends Handle_Geom2d_TrimmedCurve {
    constructor(theHandle: Handle_Geom2d_TrimmedCurve);
  }

export declare class Geom2d_BezierCurve extends Geom2d_BoundedCurve {
  Increase(Degree: Graphic3d_ZLayerId): void;
  InsertPoleAfter(Index: Graphic3d_ZLayerId, P: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  InsertPoleBefore(Index: Graphic3d_ZLayerId, P: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  RemovePole(Index: Graphic3d_ZLayerId): void;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Segment(U1: Quantity_AbsorbedDose, U2: Quantity_AbsorbedDose): void;
  SetPole_1(Index: Graphic3d_ZLayerId, P: gp_Pnt2d): void;
  SetPole_2(Index: Graphic3d_ZLayerId, P: gp_Pnt2d, Weight: Quantity_AbsorbedDose): void;
  SetWeight(Index: Graphic3d_ZLayerId, Weight: Quantity_AbsorbedDose): void;
  IsClosed(): Standard_Boolean;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  IsRational(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Degree(): Graphic3d_ZLayerId;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  EndPoint(): gp_Pnt2d;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  NbPoles(): Graphic3d_ZLayerId;
  Pole(Index: Graphic3d_ZLayerId): gp_Pnt2d;
  Poles_1(P: TColgp_Array1OfPnt2d): void;
  Poles_2(): TColgp_Array1OfPnt2d;
  StartPoint(): gp_Pnt2d;
  Weight(Index: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Weights_1(W: TColStd_Array1OfReal): void;
  Weights_2(): TColStd_Array1OfReal;
  Transform(T: gp_Trsf2d): void;
  static MaxDegree(): Graphic3d_ZLayerId;
  Resolution(ToleranceUV: Quantity_AbsorbedDose, UTolerance: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_BezierCurve_1 extends Geom2d_BezierCurve {
    constructor(CurvePoles: TColgp_Array1OfPnt2d);
  }

  export declare class Geom2d_BezierCurve_2 extends Geom2d_BezierCurve {
    constructor(CurvePoles: TColgp_Array1OfPnt2d, PoleWeights: TColStd_Array1OfReal);
  }

export declare class Handle_Geom2d_BezierCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_BezierCurve): void;
  get(): Geom2d_BezierCurve;
  delete(): void;
}

  export declare class Handle_Geom2d_BezierCurve_1 extends Handle_Geom2d_BezierCurve {
    constructor();
  }

  export declare class Handle_Geom2d_BezierCurve_2 extends Handle_Geom2d_BezierCurve {
    constructor(thePtr: Geom2d_BezierCurve);
  }

  export declare class Handle_Geom2d_BezierCurve_3 extends Handle_Geom2d_BezierCurve {
    constructor(theHandle: Handle_Geom2d_BezierCurve);
  }

  export declare class Handle_Geom2d_BezierCurve_4 extends Handle_Geom2d_BezierCurve {
    constructor(theHandle: Handle_Geom2d_BezierCurve);
  }

export declare class Handle_Geom2d_UndefinedValue {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_UndefinedValue): void;
  get(): Geom2d_UndefinedValue;
  delete(): void;
}

  export declare class Handle_Geom2d_UndefinedValue_1 extends Handle_Geom2d_UndefinedValue {
    constructor();
  }

  export declare class Handle_Geom2d_UndefinedValue_2 extends Handle_Geom2d_UndefinedValue {
    constructor(thePtr: Geom2d_UndefinedValue);
  }

  export declare class Handle_Geom2d_UndefinedValue_3 extends Handle_Geom2d_UndefinedValue {
    constructor(theHandle: Handle_Geom2d_UndefinedValue);
  }

  export declare class Handle_Geom2d_UndefinedValue_4 extends Handle_Geom2d_UndefinedValue {
    constructor(theHandle: Handle_Geom2d_UndefinedValue);
  }

export declare class Geom2d_UndefinedValue extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Geom2d_UndefinedValue;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_UndefinedValue_1 extends Geom2d_UndefinedValue {
    constructor();
  }

  export declare class Geom2d_UndefinedValue_2 extends Geom2d_UndefinedValue {
    constructor(theMessage: Standard_CString);
  }

export declare class Geom2d_VectorWithMagnitude extends Geom2d_Vector {
  SetCoord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  SetVec2d(V: gp_Vec2d): void;
  SetX(X: Quantity_AbsorbedDose): void;
  SetY(Y: Quantity_AbsorbedDose): void;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  Add(Other: Handle_Geom2d_Vector): void;
  Added(Other: Handle_Geom2d_Vector): Handle_Geom2d_VectorWithMagnitude;
  Crossed(Other: Handle_Geom2d_Vector): Quantity_AbsorbedDose;
  Divide(Scalar: Quantity_AbsorbedDose): void;
  Divided(Scalar: Quantity_AbsorbedDose): Handle_Geom2d_VectorWithMagnitude;
  Multiplied(Scalar: Quantity_AbsorbedDose): Handle_Geom2d_VectorWithMagnitude;
  Multiply(Scalar: Quantity_AbsorbedDose): void;
  Normalize(): void;
  Normalized(): Handle_Geom2d_VectorWithMagnitude;
  Subtract(Other: Handle_Geom2d_Vector): void;
  Subtracted(Other: Handle_Geom2d_Vector): Handle_Geom2d_VectorWithMagnitude;
  Transform(T: gp_Trsf2d): void;
  Copy(): Handle_Geom2d_Geometry;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_VectorWithMagnitude_1 extends Geom2d_VectorWithMagnitude {
    constructor(V: gp_Vec2d);
  }

  export declare class Geom2d_VectorWithMagnitude_2 extends Geom2d_VectorWithMagnitude {
    constructor(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose);
  }

  export declare class Geom2d_VectorWithMagnitude_3 extends Geom2d_VectorWithMagnitude {
    constructor(P1: gp_Pnt2d, P2: gp_Pnt2d);
  }

export declare class Handle_Geom2d_VectorWithMagnitude {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_VectorWithMagnitude): void;
  get(): Geom2d_VectorWithMagnitude;
  delete(): void;
}

  export declare class Handle_Geom2d_VectorWithMagnitude_1 extends Handle_Geom2d_VectorWithMagnitude {
    constructor();
  }

  export declare class Handle_Geom2d_VectorWithMagnitude_2 extends Handle_Geom2d_VectorWithMagnitude {
    constructor(thePtr: Geom2d_VectorWithMagnitude);
  }

  export declare class Handle_Geom2d_VectorWithMagnitude_3 extends Handle_Geom2d_VectorWithMagnitude {
    constructor(theHandle: Handle_Geom2d_VectorWithMagnitude);
  }

  export declare class Handle_Geom2d_VectorWithMagnitude_4 extends Handle_Geom2d_VectorWithMagnitude {
    constructor(theHandle: Handle_Geom2d_VectorWithMagnitude);
  }

export declare class Geom2d_OffsetCurve extends Geom2d_Curve {
  constructor(C: Handle_Geom2d_Curve, Offset: Quantity_AbsorbedDose, isNotCheckC0: Standard_Boolean)
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  SetBasisCurve(C: Handle_Geom2d_Curve, isNotCheckC0: Standard_Boolean): void;
  SetOffsetValue(D: Quantity_AbsorbedDose): void;
  BasisCurve(): Handle_Geom2d_Curve;
  Continuity(): GeomAbs_Shape;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Offset(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Transform(T: gp_Trsf2d): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf2d): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf2d): Quantity_AbsorbedDose;
  Copy(): Handle_Geom2d_Geometry;
  GetBasisCurveContinuity(): GeomAbs_Shape;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_OffsetCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_OffsetCurve): void;
  get(): Geom2d_OffsetCurve;
  delete(): void;
}

  export declare class Handle_Geom2d_OffsetCurve_1 extends Handle_Geom2d_OffsetCurve {
    constructor();
  }

  export declare class Handle_Geom2d_OffsetCurve_2 extends Handle_Geom2d_OffsetCurve {
    constructor(thePtr: Geom2d_OffsetCurve);
  }

  export declare class Handle_Geom2d_OffsetCurve_3 extends Handle_Geom2d_OffsetCurve {
    constructor(theHandle: Handle_Geom2d_OffsetCurve);
  }

  export declare class Handle_Geom2d_OffsetCurve_4 extends Handle_Geom2d_OffsetCurve {
    constructor(theHandle: Handle_Geom2d_OffsetCurve);
  }

export declare class Geom2d_Line extends Geom2d_Curve {
  SetLin2d(L: gp_Lin2d): void;
  SetDirection(V: gp_Dir2d): void;
  Direction(): gp_Dir2d;
  SetLocation(P: gp_Pnt2d): void;
  Location(): gp_Pnt2d;
  SetPosition(A: gp_Ax2d): void;
  Position(): gp_Ax2d;
  Lin2d(): gp_Lin2d;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  IsPeriodic(): Standard_Boolean;
  Continuity(): GeomAbs_Shape;
  Distance(P: gp_Pnt2d): Quantity_AbsorbedDose;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  D0(U: Quantity_AbsorbedDose, P: gp_Pnt2d): void;
  D1(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d): void;
  D2(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d): void;
  D3(U: Quantity_AbsorbedDose, P: gp_Pnt2d, V1: gp_Vec2d, V2: gp_Vec2d, V3: gp_Vec2d): void;
  DN(U: Quantity_AbsorbedDose, N: Graphic3d_ZLayerId): gp_Vec2d;
  Transform(T: gp_Trsf2d): void;
  TransformedParameter(U: Quantity_AbsorbedDose, T: gp_Trsf2d): Quantity_AbsorbedDose;
  ParametricTransformation(T: gp_Trsf2d): Quantity_AbsorbedDose;
  Copy(): Handle_Geom2d_Geometry;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Line_1 extends Geom2d_Line {
    constructor(A: gp_Ax2d);
  }

  export declare class Geom2d_Line_2 extends Geom2d_Line {
    constructor(L: gp_Lin2d);
  }

  export declare class Geom2d_Line_3 extends Geom2d_Line {
    constructor(P: gp_Pnt2d, V: gp_Dir2d);
  }

export declare class Handle_Geom2d_Line {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Line): void;
  get(): Geom2d_Line;
  delete(): void;
}

  export declare class Handle_Geom2d_Line_1 extends Handle_Geom2d_Line {
    constructor();
  }

  export declare class Handle_Geom2d_Line_2 extends Handle_Geom2d_Line {
    constructor(thePtr: Geom2d_Line);
  }

  export declare class Handle_Geom2d_Line_3 extends Handle_Geom2d_Line {
    constructor(theHandle: Handle_Geom2d_Line);
  }

  export declare class Handle_Geom2d_Line_4 extends Handle_Geom2d_Line {
    constructor(theHandle: Handle_Geom2d_Line);
  }

export declare class Geom2d_Vector extends Geom2d_Geometry {
  Reverse(): void;
  Reversed(): Handle_Geom2d_Vector;
  Angle(Other: Handle_Geom2d_Vector): Quantity_AbsorbedDose;
  Coord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Magnitude(): Quantity_AbsorbedDose;
  SquareMagnitude(): Quantity_AbsorbedDose;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Crossed(Other: Handle_Geom2d_Vector): Quantity_AbsorbedDose;
  Dot(Other: Handle_Geom2d_Vector): Quantity_AbsorbedDose;
  Vec2d(): gp_Vec2d;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_Vector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Vector): void;
  get(): Geom2d_Vector;
  delete(): void;
}

  export declare class Handle_Geom2d_Vector_1 extends Handle_Geom2d_Vector {
    constructor();
  }

  export declare class Handle_Geom2d_Vector_2 extends Handle_Geom2d_Vector {
    constructor(thePtr: Geom2d_Vector);
  }

  export declare class Handle_Geom2d_Vector_3 extends Handle_Geom2d_Vector {
    constructor(theHandle: Handle_Geom2d_Vector);
  }

  export declare class Handle_Geom2d_Vector_4 extends Handle_Geom2d_Vector {
    constructor(theHandle: Handle_Geom2d_Vector);
  }

export declare class Geom2d_Conic extends Geom2d_Curve {
  SetAxis(theA: gp_Ax22d): void;
  SetXAxis(theAX: gp_Ax2d): void;
  SetYAxis(theAY: gp_Ax2d): void;
  SetLocation(theP: gp_Pnt2d): void;
  XAxis(): gp_Ax2d;
  YAxis(): gp_Ax2d;
  Eccentricity(): Quantity_AbsorbedDose;
  Location(): gp_Pnt2d;
  Position(): gp_Ax22d;
  Reverse(): void;
  ReversedParameter(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  IsCN(N: Graphic3d_ZLayerId): Standard_Boolean;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_Conic {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Conic): void;
  get(): Geom2d_Conic;
  delete(): void;
}

  export declare class Handle_Geom2d_Conic_1 extends Handle_Geom2d_Conic {
    constructor();
  }

  export declare class Handle_Geom2d_Conic_2 extends Handle_Geom2d_Conic {
    constructor(thePtr: Geom2d_Conic);
  }

  export declare class Handle_Geom2d_Conic_3 extends Handle_Geom2d_Conic {
    constructor(theHandle: Handle_Geom2d_Conic);
  }

  export declare class Handle_Geom2d_Conic_4 extends Handle_Geom2d_Conic {
    constructor(theHandle: Handle_Geom2d_Conic);
  }

export declare class Handle_Geom2d_Transformation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Transformation): void;
  get(): Geom2d_Transformation;
  delete(): void;
}

  export declare class Handle_Geom2d_Transformation_1 extends Handle_Geom2d_Transformation {
    constructor();
  }

  export declare class Handle_Geom2d_Transformation_2 extends Handle_Geom2d_Transformation {
    constructor(thePtr: Geom2d_Transformation);
  }

  export declare class Handle_Geom2d_Transformation_3 extends Handle_Geom2d_Transformation {
    constructor(theHandle: Handle_Geom2d_Transformation);
  }

  export declare class Handle_Geom2d_Transformation_4 extends Handle_Geom2d_Transformation {
    constructor(theHandle: Handle_Geom2d_Transformation);
  }

export declare class Geom2d_Transformation extends Standard_Transient {
  SetMirror_1(P: gp_Pnt2d): void;
  SetMirror_2(A: gp_Ax2d): void;
  SetRotation(P: gp_Pnt2d, Ang: Quantity_AbsorbedDose): void;
  SetScale(P: gp_Pnt2d, S: Quantity_AbsorbedDose): void;
  SetTransformation_1(FromSystem1: gp_Ax2d, ToSystem2: gp_Ax2d): void;
  SetTransformation_2(ToSystem: gp_Ax2d): void;
  SetTranslation_1(V: gp_Vec2d): void;
  SetTranslation_2(P1: gp_Pnt2d, P2: gp_Pnt2d): void;
  SetTrsf2d(T: gp_Trsf2d): void;
  IsNegative(): Standard_Boolean;
  Form(): gp_TrsfForm;
  ScaleFactor(): Quantity_AbsorbedDose;
  Trsf2d(): gp_Trsf2d;
  Value(Row: Graphic3d_ZLayerId, Col: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Invert(): void;
  Inverted(): Handle_Geom2d_Transformation;
  Multiplied(Other: Handle_Geom2d_Transformation): Handle_Geom2d_Transformation;
  Multiply(Other: Handle_Geom2d_Transformation): void;
  Power(N: Graphic3d_ZLayerId): void;
  Powered(N: Graphic3d_ZLayerId): Handle_Geom2d_Transformation;
  PreMultiply(Other: Handle_Geom2d_Transformation): void;
  Transforms(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Copy(): Handle_Geom2d_Transformation;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_Transformation_1 extends Geom2d_Transformation {
    constructor();
  }

  export declare class Geom2d_Transformation_2 extends Geom2d_Transformation {
    constructor(T: gp_Trsf2d);
  }

export declare class Handle_Geom2d_BoundedCurve {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_BoundedCurve): void;
  get(): Geom2d_BoundedCurve;
  delete(): void;
}

  export declare class Handle_Geom2d_BoundedCurve_1 extends Handle_Geom2d_BoundedCurve {
    constructor();
  }

  export declare class Handle_Geom2d_BoundedCurve_2 extends Handle_Geom2d_BoundedCurve {
    constructor(thePtr: Geom2d_BoundedCurve);
  }

  export declare class Handle_Geom2d_BoundedCurve_3 extends Handle_Geom2d_BoundedCurve {
    constructor(theHandle: Handle_Geom2d_BoundedCurve);
  }

  export declare class Handle_Geom2d_BoundedCurve_4 extends Handle_Geom2d_BoundedCurve {
    constructor(theHandle: Handle_Geom2d_BoundedCurve);
  }

export declare class Geom2d_BoundedCurve extends Geom2d_Curve {
  EndPoint(): gp_Pnt2d;
  StartPoint(): gp_Pnt2d;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_UndefinedDerivative {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_UndefinedDerivative): void;
  get(): Geom2d_UndefinedDerivative;
  delete(): void;
}

  export declare class Handle_Geom2d_UndefinedDerivative_1 extends Handle_Geom2d_UndefinedDerivative {
    constructor();
  }

  export declare class Handle_Geom2d_UndefinedDerivative_2 extends Handle_Geom2d_UndefinedDerivative {
    constructor(thePtr: Geom2d_UndefinedDerivative);
  }

  export declare class Handle_Geom2d_UndefinedDerivative_3 extends Handle_Geom2d_UndefinedDerivative {
    constructor(theHandle: Handle_Geom2d_UndefinedDerivative);
  }

  export declare class Handle_Geom2d_UndefinedDerivative_4 extends Handle_Geom2d_UndefinedDerivative {
    constructor(theHandle: Handle_Geom2d_UndefinedDerivative);
  }

export declare class Geom2d_UndefinedDerivative extends Standard_DomainError {
  static Raise_1(theMessage: Standard_CString): void;
  static Raise_2(theMessage: Standard_SStream): void;
  static NewInstance(theMessage: Standard_CString): Handle_Geom2d_UndefinedDerivative;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class Geom2d_UndefinedDerivative_1 extends Geom2d_UndefinedDerivative {
    constructor();
  }

  export declare class Geom2d_UndefinedDerivative_2 extends Geom2d_UndefinedDerivative {
    constructor(theMessage: Standard_CString);
  }

export declare class Geom2d_Point extends Geom2d_Geometry {
  Coord(X: Quantity_AbsorbedDose, Y: Quantity_AbsorbedDose): void;
  Pnt2d(): gp_Pnt2d;
  X(): Quantity_AbsorbedDose;
  Y(): Quantity_AbsorbedDose;
  Distance(Other: Handle_Geom2d_Point): Quantity_AbsorbedDose;
  SquareDistance(Other: Handle_Geom2d_Point): Quantity_AbsorbedDose;
  DumpJson(theOStream: Standard_OStream, theDepth: Graphic3d_ZLayerId): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_Geom2d_Point {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: Geom2d_Point): void;
  get(): Geom2d_Point;
  delete(): void;
}

  export declare class Handle_Geom2d_Point_1 extends Handle_Geom2d_Point {
    constructor();
  }

  export declare class Handle_Geom2d_Point_2 extends Handle_Geom2d_Point {
    constructor(thePtr: Geom2d_Point);
  }

  export declare class Handle_Geom2d_Point_3 extends Handle_Geom2d_Point {
    constructor(theHandle: Handle_Geom2d_Point);
  }

  export declare class Handle_Geom2d_Point_4 extends Handle_Geom2d_Point {
    constructor(theHandle: Handle_Geom2d_Point);
  }

export declare class Handle_StepFEA_FeaGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaGroup): void;
  get(): StepFEA_FeaGroup;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaGroup_1 extends Handle_StepFEA_FeaGroup {
    constructor();
  }

  export declare class Handle_StepFEA_FeaGroup_2 extends Handle_StepFEA_FeaGroup {
    constructor(thePtr: StepFEA_FeaGroup);
  }

  export declare class Handle_StepFEA_FeaGroup_3 extends Handle_StepFEA_FeaGroup {
    constructor(theHandle: Handle_StepFEA_FeaGroup);
  }

  export declare class Handle_StepFEA_FeaGroup_4 extends Handle_StepFEA_FeaGroup {
    constructor(theHandle: Handle_StepFEA_FeaGroup);
  }

export declare class StepFEA_FeaGroup extends StepBasic_Group {
  constructor()
  Init(aGroup_Name: Handle_TCollection_HAsciiString, aGroup_Description: Handle_TCollection_HAsciiString, aModelRef: Handle_StepFEA_FeaModel): void;
  ModelRef(): Handle_StepFEA_FeaModel;
  SetModelRef(ModelRef: Handle_StepFEA_FeaModel): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaMassDensity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaMassDensity): void;
  get(): StepFEA_FeaMassDensity;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaMassDensity_1 extends Handle_StepFEA_FeaMassDensity {
    constructor();
  }

  export declare class Handle_StepFEA_FeaMassDensity_2 extends Handle_StepFEA_FeaMassDensity {
    constructor(thePtr: StepFEA_FeaMassDensity);
  }

  export declare class Handle_StepFEA_FeaMassDensity_3 extends Handle_StepFEA_FeaMassDensity {
    constructor(theHandle: Handle_StepFEA_FeaMassDensity);
  }

  export declare class Handle_StepFEA_FeaMassDensity_4 extends Handle_StepFEA_FeaMassDensity {
    constructor(theHandle: Handle_StepFEA_FeaMassDensity);
  }

export declare class StepFEA_FeaMassDensity extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstant: Quantity_AbsorbedDose): void;
  FeaConstant(): Quantity_AbsorbedDose;
  SetFeaConstant(FeaConstant: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_ConstantSurface3dElementCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ConstantSurface3dElementCoordinateSystem): void;
  get(): StepFEA_ConstantSurface3dElementCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_1 extends Handle_StepFEA_ConstantSurface3dElementCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_2 extends Handle_StepFEA_ConstantSurface3dElementCoordinateSystem {
    constructor(thePtr: StepFEA_ConstantSurface3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_3 extends Handle_StepFEA_ConstantSurface3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ConstantSurface3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_4 extends Handle_StepFEA_ConstantSurface3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ConstantSurface3dElementCoordinateSystem);
  }

export declare class StepFEA_ConstantSurface3dElementCoordinateSystem extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aAxis: Graphic3d_ZLayerId, aAngle: Quantity_AbsorbedDose): void;
  Axis(): Graphic3d_ZLayerId;
  SetAxis(Axis: Graphic3d_ZLayerId): void;
  Angle(): Quantity_AbsorbedDose;
  SetAngle(Angle: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare type StepFEA_EnumeratedDegreeOfFreedom = {
  StepFEA_XTranslation: {};
  StepFEA_YTranslation: {};
  StepFEA_ZTranslation: {};
  StepFEA_XRotation: {};
  StepFEA_YRotation: {};
  StepFEA_ZRotation: {};
  StepFEA_Warp: {};
}

export declare class StepFEA_FreedomAndCoefficient extends Standard_Transient {
  constructor()
  Init(aFreedom: StepFEA_DegreeOfFreedom, aA: StepElement_MeasureOrUnspecifiedValue): void;
  Freedom(): StepFEA_DegreeOfFreedom;
  SetFreedom(Freedom: StepFEA_DegreeOfFreedom): void;
  A(): StepElement_MeasureOrUnspecifiedValue;
  SetA(A: StepElement_MeasureOrUnspecifiedValue): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FreedomAndCoefficient {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FreedomAndCoefficient): void;
  get(): StepFEA_FreedomAndCoefficient;
  delete(): void;
}

  export declare class Handle_StepFEA_FreedomAndCoefficient_1 extends Handle_StepFEA_FreedomAndCoefficient {
    constructor();
  }

  export declare class Handle_StepFEA_FreedomAndCoefficient_2 extends Handle_StepFEA_FreedomAndCoefficient {
    constructor(thePtr: StepFEA_FreedomAndCoefficient);
  }

  export declare class Handle_StepFEA_FreedomAndCoefficient_3 extends Handle_StepFEA_FreedomAndCoefficient {
    constructor(theHandle: Handle_StepFEA_FreedomAndCoefficient);
  }

  export declare class Handle_StepFEA_FreedomAndCoefficient_4 extends Handle_StepFEA_FreedomAndCoefficient {
    constructor(theHandle: Handle_StepFEA_FreedomAndCoefficient);
  }

export declare class StepFEA_SymmetricTensor23d extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetIsotropicSymmetricTensor23d(aVal: Quantity_AbsorbedDose): void;
  IsotropicSymmetricTensor23d(): Quantity_AbsorbedDose;
  SetOrthotropicSymmetricTensor23d(aVal: Handle_TColStd_HArray1OfReal): void;
  OrthotropicSymmetricTensor23d(): Handle_TColStd_HArray1OfReal;
  SetAnisotropicSymmetricTensor23d(aVal: Handle_TColStd_HArray1OfReal): void;
  AnisotropicSymmetricTensor23d(): Handle_TColStd_HArray1OfReal;
  delete(): void;
}

export declare class StepFEA_Node extends StepFEA_NodeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_Node {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_Node): void;
  get(): StepFEA_Node;
  delete(): void;
}

  export declare class Handle_StepFEA_Node_1 extends Handle_StepFEA_Node {
    constructor();
  }

  export declare class Handle_StepFEA_Node_2 extends Handle_StepFEA_Node {
    constructor(thePtr: StepFEA_Node);
  }

  export declare class Handle_StepFEA_Node_3 extends Handle_StepFEA_Node {
    constructor(theHandle: Handle_StepFEA_Node);
  }

  export declare class Handle_StepFEA_Node_4 extends Handle_StepFEA_Node {
    constructor(theHandle: Handle_StepFEA_Node);
  }

export declare class Handle_StepFEA_ElementGeometricRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ElementGeometricRelationship): void;
  get(): StepFEA_ElementGeometricRelationship;
  delete(): void;
}

  export declare class Handle_StepFEA_ElementGeometricRelationship_1 extends Handle_StepFEA_ElementGeometricRelationship {
    constructor();
  }

  export declare class Handle_StepFEA_ElementGeometricRelationship_2 extends Handle_StepFEA_ElementGeometricRelationship {
    constructor(thePtr: StepFEA_ElementGeometricRelationship);
  }

  export declare class Handle_StepFEA_ElementGeometricRelationship_3 extends Handle_StepFEA_ElementGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_ElementGeometricRelationship);
  }

  export declare class Handle_StepFEA_ElementGeometricRelationship_4 extends Handle_StepFEA_ElementGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_ElementGeometricRelationship);
  }

export declare class StepFEA_ElementGeometricRelationship extends Standard_Transient {
  constructor()
  Init(aElementRef: StepFEA_ElementOrElementGroup, aItem: Handle_StepElement_AnalysisItemWithinRepresentation, aAspect: StepElement_ElementAspect): void;
  ElementRef(): StepFEA_ElementOrElementGroup;
  SetElementRef(ElementRef: StepFEA_ElementOrElementGroup): void;
  Item(): Handle_StepElement_AnalysisItemWithinRepresentation;
  SetItem(Item: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  Aspect(): StepElement_ElementAspect;
  SetAspect(Aspect: StepElement_ElementAspect): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_FeaLinearElasticity extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor43d): void;
  FeaConstants(): StepFEA_SymmetricTensor43d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor43d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaLinearElasticity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaLinearElasticity): void;
  get(): StepFEA_FeaLinearElasticity;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaLinearElasticity_1 extends Handle_StepFEA_FeaLinearElasticity {
    constructor();
  }

  export declare class Handle_StepFEA_FeaLinearElasticity_2 extends Handle_StepFEA_FeaLinearElasticity {
    constructor(thePtr: StepFEA_FeaLinearElasticity);
  }

  export declare class Handle_StepFEA_FeaLinearElasticity_3 extends Handle_StepFEA_FeaLinearElasticity {
    constructor(theHandle: Handle_StepFEA_FeaLinearElasticity);
  }

  export declare class Handle_StepFEA_FeaLinearElasticity_4 extends Handle_StepFEA_FeaLinearElasticity {
    constructor(theHandle: Handle_StepFEA_FeaLinearElasticity);
  }

export declare class StepFEA_FeaShellMembraneBendingCouplingStiffness extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor42d): void;
  FeaConstants(): StepFEA_SymmetricTensor42d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor42d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaShellMembraneBendingCouplingStiffness): void;
  get(): StepFEA_FeaShellMembraneBendingCouplingStiffness;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_1 extends Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness {
    constructor();
  }

  export declare class Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_2 extends Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness {
    constructor(thePtr: StepFEA_FeaShellMembraneBendingCouplingStiffness);
  }

  export declare class Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_3 extends Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness);
  }

  export declare class Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_4 extends Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness);
  }

export declare class Handle_StepFEA_HSequenceOfCurve3dElementProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HSequenceOfCurve3dElementProperty): void;
  get(): StepFEA_HSequenceOfCurve3dElementProperty;
  delete(): void;
}

  export declare class Handle_StepFEA_HSequenceOfCurve3dElementProperty_1 extends Handle_StepFEA_HSequenceOfCurve3dElementProperty {
    constructor();
  }

  export declare class Handle_StepFEA_HSequenceOfCurve3dElementProperty_2 extends Handle_StepFEA_HSequenceOfCurve3dElementProperty {
    constructor(thePtr: StepFEA_HSequenceOfCurve3dElementProperty);
  }

  export declare class Handle_StepFEA_HSequenceOfCurve3dElementProperty_3 extends Handle_StepFEA_HSequenceOfCurve3dElementProperty {
    constructor(theHandle: Handle_StepFEA_HSequenceOfCurve3dElementProperty);
  }

  export declare class Handle_StepFEA_HSequenceOfCurve3dElementProperty_4 extends Handle_StepFEA_HSequenceOfCurve3dElementProperty {
    constructor(theHandle: Handle_StepFEA_HSequenceOfCurve3dElementProperty);
  }

export declare class StepFEA_Curve3dElementRepresentation extends StepFEA_ElementRepresentation {
  constructor()
  Init(aRepresentation_Name: Handle_TCollection_HAsciiString, aRepresentation_Items: Handle_StepRepr_HArray1OfRepresentationItem, aRepresentation_ContextOfItems: Handle_StepRepr_RepresentationContext, aElementRepresentation_NodeList: Handle_StepFEA_HArray1OfNodeRepresentation, aModelRef: Handle_StepFEA_FeaModel3d, aElementDescriptor: Handle_StepElement_Curve3dElementDescriptor, aProperty: Handle_StepFEA_Curve3dElementProperty, aMaterial: Handle_StepElement_ElementMaterial): void;
  ModelRef(): Handle_StepFEA_FeaModel3d;
  SetModelRef(ModelRef: Handle_StepFEA_FeaModel3d): void;
  ElementDescriptor(): Handle_StepElement_Curve3dElementDescriptor;
  SetElementDescriptor(ElementDescriptor: Handle_StepElement_Curve3dElementDescriptor): void;
  Property(): Handle_StepFEA_Curve3dElementProperty;
  SetProperty(Property: Handle_StepFEA_Curve3dElementProperty): void;
  Material(): Handle_StepElement_ElementMaterial;
  SetMaterial(Material: Handle_StepElement_ElementMaterial): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_Curve3dElementRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_Curve3dElementRepresentation): void;
  get(): StepFEA_Curve3dElementRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_Curve3dElementRepresentation_1 extends Handle_StepFEA_Curve3dElementRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_Curve3dElementRepresentation_2 extends Handle_StepFEA_Curve3dElementRepresentation {
    constructor(thePtr: StepFEA_Curve3dElementRepresentation);
  }

  export declare class Handle_StepFEA_Curve3dElementRepresentation_3 extends Handle_StepFEA_Curve3dElementRepresentation {
    constructor(theHandle: Handle_StepFEA_Curve3dElementRepresentation);
  }

  export declare class Handle_StepFEA_Curve3dElementRepresentation_4 extends Handle_StepFEA_Curve3dElementRepresentation {
    constructor(theHandle: Handle_StepFEA_Curve3dElementRepresentation);
  }

export declare class Handle_StepFEA_Volume3dElementRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_Volume3dElementRepresentation): void;
  get(): StepFEA_Volume3dElementRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_Volume3dElementRepresentation_1 extends Handle_StepFEA_Volume3dElementRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_Volume3dElementRepresentation_2 extends Handle_StepFEA_Volume3dElementRepresentation {
    constructor(thePtr: StepFEA_Volume3dElementRepresentation);
  }

  export declare class Handle_StepFEA_Volume3dElementRepresentation_3 extends Handle_StepFEA_Volume3dElementRepresentation {
    constructor(theHandle: Handle_StepFEA_Volume3dElementRepresentation);
  }

  export declare class Handle_StepFEA_Volume3dElementRepresentation_4 extends Handle_StepFEA_Volume3dElementRepresentation {
    constructor(theHandle: Handle_StepFEA_Volume3dElementRepresentation);
  }

export declare class StepFEA_Volume3dElementRepresentation extends StepFEA_ElementRepresentation {
  constructor()
  Init(aRepresentation_Name: Handle_TCollection_HAsciiString, aRepresentation_Items: Handle_StepRepr_HArray1OfRepresentationItem, aRepresentation_ContextOfItems: Handle_StepRepr_RepresentationContext, aElementRepresentation_NodeList: Handle_StepFEA_HArray1OfNodeRepresentation, aModelRef: Handle_StepFEA_FeaModel3d, aElementDescriptor: Handle_StepElement_Volume3dElementDescriptor, aMaterial: Handle_StepElement_ElementMaterial): void;
  ModelRef(): Handle_StepFEA_FeaModel3d;
  SetModelRef(ModelRef: Handle_StepFEA_FeaModel3d): void;
  ElementDescriptor(): Handle_StepElement_Volume3dElementDescriptor;
  SetElementDescriptor(ElementDescriptor: Handle_StepElement_Volume3dElementDescriptor): void;
  Material(): Handle_StepElement_ElementMaterial;
  SetMaterial(Material: Handle_StepElement_ElementMaterial): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_DegreeOfFreedom extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  CaseMem(ent: Handle_StepData_SelectMember): Graphic3d_ZLayerId;
  NewMember(): Handle_StepData_SelectMember;
  SetEnumeratedDegreeOfFreedom(aVal: StepFEA_EnumeratedDegreeOfFreedom): void;
  EnumeratedDegreeOfFreedom(): StepFEA_EnumeratedDegreeOfFreedom;
  SetApplicationDefinedDegreeOfFreedom(aVal: Handle_TCollection_HAsciiString): void;
  ApplicationDefinedDegreeOfFreedom(): Handle_TCollection_HAsciiString;
  delete(): void;
}

export declare class StepFEA_SymmetricTensor22d extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AnisotropicSymmetricTensor22d(): Handle_TColStd_HArray1OfReal;
  delete(): void;
}

export declare class Handle_StepFEA_HSequenceOfElementGeometricRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HSequenceOfElementGeometricRelationship): void;
  get(): StepFEA_HSequenceOfElementGeometricRelationship;
  delete(): void;
}

  export declare class Handle_StepFEA_HSequenceOfElementGeometricRelationship_1 extends Handle_StepFEA_HSequenceOfElementGeometricRelationship {
    constructor();
  }

  export declare class Handle_StepFEA_HSequenceOfElementGeometricRelationship_2 extends Handle_StepFEA_HSequenceOfElementGeometricRelationship {
    constructor(thePtr: StepFEA_HSequenceOfElementGeometricRelationship);
  }

  export declare class Handle_StepFEA_HSequenceOfElementGeometricRelationship_3 extends Handle_StepFEA_HSequenceOfElementGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_HSequenceOfElementGeometricRelationship);
  }

  export declare class Handle_StepFEA_HSequenceOfElementGeometricRelationship_4 extends Handle_StepFEA_HSequenceOfElementGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_HSequenceOfElementGeometricRelationship);
  }

export declare class Handle_StepFEA_HArray1OfCurveElementEndOffset {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HArray1OfCurveElementEndOffset): void;
  get(): StepFEA_HArray1OfCurveElementEndOffset;
  delete(): void;
}

  export declare class Handle_StepFEA_HArray1OfCurveElementEndOffset_1 extends Handle_StepFEA_HArray1OfCurveElementEndOffset {
    constructor();
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementEndOffset_2 extends Handle_StepFEA_HArray1OfCurveElementEndOffset {
    constructor(thePtr: StepFEA_HArray1OfCurveElementEndOffset);
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementEndOffset_3 extends Handle_StepFEA_HArray1OfCurveElementEndOffset {
    constructor(theHandle: Handle_StepFEA_HArray1OfCurveElementEndOffset);
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementEndOffset_4 extends Handle_StepFEA_HArray1OfCurveElementEndOffset {
    constructor(theHandle: Handle_StepFEA_HArray1OfCurveElementEndOffset);
  }

export declare class Handle_StepFEA_NodeDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_NodeDefinition): void;
  get(): StepFEA_NodeDefinition;
  delete(): void;
}

  export declare class Handle_StepFEA_NodeDefinition_1 extends Handle_StepFEA_NodeDefinition {
    constructor();
  }

  export declare class Handle_StepFEA_NodeDefinition_2 extends Handle_StepFEA_NodeDefinition {
    constructor(thePtr: StepFEA_NodeDefinition);
  }

  export declare class Handle_StepFEA_NodeDefinition_3 extends Handle_StepFEA_NodeDefinition {
    constructor(theHandle: Handle_StepFEA_NodeDefinition);
  }

  export declare class Handle_StepFEA_NodeDefinition_4 extends Handle_StepFEA_NodeDefinition {
    constructor(theHandle: Handle_StepFEA_NodeDefinition);
  }

export declare class StepFEA_NodeDefinition extends StepRepr_ShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_ParametricSurface3dElementCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ParametricSurface3dElementCoordinateSystem): void;
  get(): StepFEA_ParametricSurface3dElementCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_1 extends Handle_StepFEA_ParametricSurface3dElementCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_2 extends Handle_StepFEA_ParametricSurface3dElementCoordinateSystem {
    constructor(thePtr: StepFEA_ParametricSurface3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_3 extends Handle_StepFEA_ParametricSurface3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ParametricSurface3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_4 extends Handle_StepFEA_ParametricSurface3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ParametricSurface3dElementCoordinateSystem);
  }

export declare class StepFEA_ParametricSurface3dElementCoordinateSystem extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aAxis: Graphic3d_ZLayerId, aAngle: Quantity_AbsorbedDose): void;
  Axis(): Graphic3d_ZLayerId;
  SetAxis(Axis: Graphic3d_ZLayerId): void;
  Angle(): Quantity_AbsorbedDose;
  SetAngle(Angle: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_HArray1OfCurveElementEndRelease {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HArray1OfCurveElementEndRelease): void;
  get(): StepFEA_HArray1OfCurveElementEndRelease;
  delete(): void;
}

  export declare class Handle_StepFEA_HArray1OfCurveElementEndRelease_1 extends Handle_StepFEA_HArray1OfCurveElementEndRelease {
    constructor();
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementEndRelease_2 extends Handle_StepFEA_HArray1OfCurveElementEndRelease {
    constructor(thePtr: StepFEA_HArray1OfCurveElementEndRelease);
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementEndRelease_3 extends Handle_StepFEA_HArray1OfCurveElementEndRelease {
    constructor(theHandle: Handle_StepFEA_HArray1OfCurveElementEndRelease);
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementEndRelease_4 extends Handle_StepFEA_HArray1OfCurveElementEndRelease {
    constructor(theHandle: Handle_StepFEA_HArray1OfCurveElementEndRelease);
  }

export declare class StepFEA_FeaModelDefinition extends StepRepr_ShapeAspect {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaModelDefinition {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaModelDefinition): void;
  get(): StepFEA_FeaModelDefinition;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaModelDefinition_1 extends Handle_StepFEA_FeaModelDefinition {
    constructor();
  }

  export declare class Handle_StepFEA_FeaModelDefinition_2 extends Handle_StepFEA_FeaModelDefinition {
    constructor(thePtr: StepFEA_FeaModelDefinition);
  }

  export declare class Handle_StepFEA_FeaModelDefinition_3 extends Handle_StepFEA_FeaModelDefinition {
    constructor(theHandle: Handle_StepFEA_FeaModelDefinition);
  }

  export declare class Handle_StepFEA_FeaModelDefinition_4 extends Handle_StepFEA_FeaModelDefinition {
    constructor(theHandle: Handle_StepFEA_FeaModelDefinition);
  }

export declare class StepFEA_FeaModel extends StepRepr_Representation {
  constructor()
  Init(aRepresentation_Name: Handle_TCollection_HAsciiString, aRepresentation_Items: Handle_StepRepr_HArray1OfRepresentationItem, aRepresentation_ContextOfItems: Handle_StepRepr_RepresentationContext, aCreatingSoftware: Handle_TCollection_HAsciiString, aIntendedAnalysisCode: Handle_TColStd_HArray1OfAsciiString, aDescription: Handle_TCollection_HAsciiString, aAnalysisType: Handle_TCollection_HAsciiString): void;
  CreatingSoftware(): Handle_TCollection_HAsciiString;
  SetCreatingSoftware(CreatingSoftware: Handle_TCollection_HAsciiString): void;
  IntendedAnalysisCode(): Handle_TColStd_HArray1OfAsciiString;
  SetIntendedAnalysisCode(IntendedAnalysisCode: Handle_TColStd_HArray1OfAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  AnalysisType(): Handle_TCollection_HAsciiString;
  SetAnalysisType(AnalysisType: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaModel {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaModel): void;
  get(): StepFEA_FeaModel;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaModel_1 extends Handle_StepFEA_FeaModel {
    constructor();
  }

  export declare class Handle_StepFEA_FeaModel_2 extends Handle_StepFEA_FeaModel {
    constructor(thePtr: StepFEA_FeaModel);
  }

  export declare class Handle_StepFEA_FeaModel_3 extends Handle_StepFEA_FeaModel {
    constructor(theHandle: Handle_StepFEA_FeaModel);
  }

  export declare class Handle_StepFEA_FeaModel_4 extends Handle_StepFEA_FeaModel {
    constructor(theHandle: Handle_StepFEA_FeaModel);
  }

export declare class Handle_StepFEA_GeometricNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_GeometricNode): void;
  get(): StepFEA_GeometricNode;
  delete(): void;
}

  export declare class Handle_StepFEA_GeometricNode_1 extends Handle_StepFEA_GeometricNode {
    constructor();
  }

  export declare class Handle_StepFEA_GeometricNode_2 extends Handle_StepFEA_GeometricNode {
    constructor(thePtr: StepFEA_GeometricNode);
  }

  export declare class Handle_StepFEA_GeometricNode_3 extends Handle_StepFEA_GeometricNode {
    constructor(theHandle: Handle_StepFEA_GeometricNode);
  }

  export declare class Handle_StepFEA_GeometricNode_4 extends Handle_StepFEA_GeometricNode {
    constructor(theHandle: Handle_StepFEA_GeometricNode);
  }

export declare class StepFEA_GeometricNode extends StepFEA_NodeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_HArray1OfElementRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HArray1OfElementRepresentation): void;
  get(): StepFEA_HArray1OfElementRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_HArray1OfElementRepresentation_1 extends Handle_StepFEA_HArray1OfElementRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_HArray1OfElementRepresentation_2 extends Handle_StepFEA_HArray1OfElementRepresentation {
    constructor(thePtr: StepFEA_HArray1OfElementRepresentation);
  }

  export declare class Handle_StepFEA_HArray1OfElementRepresentation_3 extends Handle_StepFEA_HArray1OfElementRepresentation {
    constructor(theHandle: Handle_StepFEA_HArray1OfElementRepresentation);
  }

  export declare class Handle_StepFEA_HArray1OfElementRepresentation_4 extends Handle_StepFEA_HArray1OfElementRepresentation {
    constructor(theHandle: Handle_StepFEA_HArray1OfElementRepresentation);
  }

export declare class Handle_StepFEA_Curve3dElementProperty {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_Curve3dElementProperty): void;
  get(): StepFEA_Curve3dElementProperty;
  delete(): void;
}

  export declare class Handle_StepFEA_Curve3dElementProperty_1 extends Handle_StepFEA_Curve3dElementProperty {
    constructor();
  }

  export declare class Handle_StepFEA_Curve3dElementProperty_2 extends Handle_StepFEA_Curve3dElementProperty {
    constructor(thePtr: StepFEA_Curve3dElementProperty);
  }

  export declare class Handle_StepFEA_Curve3dElementProperty_3 extends Handle_StepFEA_Curve3dElementProperty {
    constructor(theHandle: Handle_StepFEA_Curve3dElementProperty);
  }

  export declare class Handle_StepFEA_Curve3dElementProperty_4 extends Handle_StepFEA_Curve3dElementProperty {
    constructor(theHandle: Handle_StepFEA_Curve3dElementProperty);
  }

export declare class StepFEA_Curve3dElementProperty extends Standard_Transient {
  constructor()
  Init(aPropertyId: Handle_TCollection_HAsciiString, aDescription: Handle_TCollection_HAsciiString, aIntervalDefinitions: Handle_StepFEA_HArray1OfCurveElementInterval, aEndOffsets: Handle_StepFEA_HArray1OfCurveElementEndOffset, aEndReleases: Handle_StepFEA_HArray1OfCurveElementEndRelease): void;
  PropertyId(): Handle_TCollection_HAsciiString;
  SetPropertyId(PropertyId: Handle_TCollection_HAsciiString): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  IntervalDefinitions(): Handle_StepFEA_HArray1OfCurveElementInterval;
  SetIntervalDefinitions(IntervalDefinitions: Handle_StepFEA_HArray1OfCurveElementInterval): void;
  EndOffsets(): Handle_StepFEA_HArray1OfCurveElementEndOffset;
  SetEndOffsets(EndOffsets: Handle_StepFEA_HArray1OfCurveElementEndOffset): void;
  EndReleases(): Handle_StepFEA_HArray1OfCurveElementEndRelease;
  SetEndReleases(EndReleases: Handle_StepFEA_HArray1OfCurveElementEndRelease): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_HArray1OfCurveElementInterval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HArray1OfCurveElementInterval): void;
  get(): StepFEA_HArray1OfCurveElementInterval;
  delete(): void;
}

  export declare class Handle_StepFEA_HArray1OfCurveElementInterval_1 extends Handle_StepFEA_HArray1OfCurveElementInterval {
    constructor();
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementInterval_2 extends Handle_StepFEA_HArray1OfCurveElementInterval {
    constructor(thePtr: StepFEA_HArray1OfCurveElementInterval);
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementInterval_3 extends Handle_StepFEA_HArray1OfCurveElementInterval {
    constructor(theHandle: Handle_StepFEA_HArray1OfCurveElementInterval);
  }

  export declare class Handle_StepFEA_HArray1OfCurveElementInterval_4 extends Handle_StepFEA_HArray1OfCurveElementInterval {
    constructor(theHandle: Handle_StepFEA_HArray1OfCurveElementInterval);
  }

export declare class Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion): void;
  get(): StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_1 extends Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion {
    constructor();
  }

  export declare class Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_2 extends Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion {
    constructor(thePtr: StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion);
  }

  export declare class Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_3 extends Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion {
    constructor(theHandle: Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion);
  }

  export declare class Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_4 extends Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion {
    constructor(theHandle: Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion);
  }

export declare class StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor23d): void;
  FeaConstants(): StepFEA_SymmetricTensor23d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor23d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_FeaShellShearStiffness extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor22d): void;
  FeaConstants(): StepFEA_SymmetricTensor22d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor22d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaShellShearStiffness {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaShellShearStiffness): void;
  get(): StepFEA_FeaShellShearStiffness;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaShellShearStiffness_1 extends Handle_StepFEA_FeaShellShearStiffness {
    constructor();
  }

  export declare class Handle_StepFEA_FeaShellShearStiffness_2 extends Handle_StepFEA_FeaShellShearStiffness {
    constructor(thePtr: StepFEA_FeaShellShearStiffness);
  }

  export declare class Handle_StepFEA_FeaShellShearStiffness_3 extends Handle_StepFEA_FeaShellShearStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellShearStiffness);
  }

  export declare class Handle_StepFEA_FeaShellShearStiffness_4 extends Handle_StepFEA_FeaShellShearStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellShearStiffness);
  }

export declare class StepFEA_DummyNode extends StepFEA_NodeRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_DummyNode {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_DummyNode): void;
  get(): StepFEA_DummyNode;
  delete(): void;
}

  export declare class Handle_StepFEA_DummyNode_1 extends Handle_StepFEA_DummyNode {
    constructor();
  }

  export declare class Handle_StepFEA_DummyNode_2 extends Handle_StepFEA_DummyNode {
    constructor(thePtr: StepFEA_DummyNode);
  }

  export declare class Handle_StepFEA_DummyNode_3 extends Handle_StepFEA_DummyNode {
    constructor(theHandle: Handle_StepFEA_DummyNode);
  }

  export declare class Handle_StepFEA_DummyNode_4 extends Handle_StepFEA_DummyNode {
    constructor(theHandle: Handle_StepFEA_DummyNode);
  }

export declare class StepFEA_FeaAxis2Placement3d extends StepGeom_Axis2Placement3d {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aPlacement_Location: Handle_StepGeom_CartesianPoint, hasAxis2Placement3d_Axis: Standard_Boolean, aAxis2Placement3d_Axis: Handle_StepGeom_Direction, hasAxis2Placement3d_RefDirection: Standard_Boolean, aAxis2Placement3d_RefDirection: Handle_StepGeom_Direction, aSystemType: StepFEA_CoordinateSystemType, aDescription: Handle_TCollection_HAsciiString): void;
  SystemType(): StepFEA_CoordinateSystemType;
  SetSystemType(SystemType: StepFEA_CoordinateSystemType): void;
  Description(): Handle_TCollection_HAsciiString;
  SetDescription(Description: Handle_TCollection_HAsciiString): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaAxis2Placement3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaAxis2Placement3d): void;
  get(): StepFEA_FeaAxis2Placement3d;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaAxis2Placement3d_1 extends Handle_StepFEA_FeaAxis2Placement3d {
    constructor();
  }

  export declare class Handle_StepFEA_FeaAxis2Placement3d_2 extends Handle_StepFEA_FeaAxis2Placement3d {
    constructor(thePtr: StepFEA_FeaAxis2Placement3d);
  }

  export declare class Handle_StepFEA_FeaAxis2Placement3d_3 extends Handle_StepFEA_FeaAxis2Placement3d {
    constructor(theHandle: Handle_StepFEA_FeaAxis2Placement3d);
  }

  export declare class Handle_StepFEA_FeaAxis2Placement3d_4 extends Handle_StepFEA_FeaAxis2Placement3d {
    constructor(theHandle: Handle_StepFEA_FeaAxis2Placement3d);
  }

export declare class StepFEA_FeaParametricPoint extends StepGeom_Point {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aCoordinates: Handle_TColStd_HArray1OfReal): void;
  Coordinates(): Handle_TColStd_HArray1OfReal;
  SetCoordinates(Coordinates: Handle_TColStd_HArray1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaParametricPoint {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaParametricPoint): void;
  get(): StepFEA_FeaParametricPoint;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaParametricPoint_1 extends Handle_StepFEA_FeaParametricPoint {
    constructor();
  }

  export declare class Handle_StepFEA_FeaParametricPoint_2 extends Handle_StepFEA_FeaParametricPoint {
    constructor(thePtr: StepFEA_FeaParametricPoint);
  }

  export declare class Handle_StepFEA_FeaParametricPoint_3 extends Handle_StepFEA_FeaParametricPoint {
    constructor(theHandle: Handle_StepFEA_FeaParametricPoint);
  }

  export declare class Handle_StepFEA_FeaParametricPoint_4 extends Handle_StepFEA_FeaParametricPoint {
    constructor(theHandle: Handle_StepFEA_FeaParametricPoint);
  }

export declare class StepFEA_FeaRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaRepresentationItem): void;
  get(): StepFEA_FeaRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaRepresentationItem_1 extends Handle_StepFEA_FeaRepresentationItem {
    constructor();
  }

  export declare class Handle_StepFEA_FeaRepresentationItem_2 extends Handle_StepFEA_FeaRepresentationItem {
    constructor(thePtr: StepFEA_FeaRepresentationItem);
  }

  export declare class Handle_StepFEA_FeaRepresentationItem_3 extends Handle_StepFEA_FeaRepresentationItem {
    constructor(theHandle: Handle_StepFEA_FeaRepresentationItem);
  }

  export declare class Handle_StepFEA_FeaRepresentationItem_4 extends Handle_StepFEA_FeaRepresentationItem {
    constructor(theHandle: Handle_StepFEA_FeaRepresentationItem);
  }

export declare class Handle_StepFEA_FeaShellBendingStiffness {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaShellBendingStiffness): void;
  get(): StepFEA_FeaShellBendingStiffness;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaShellBendingStiffness_1 extends Handle_StepFEA_FeaShellBendingStiffness {
    constructor();
  }

  export declare class Handle_StepFEA_FeaShellBendingStiffness_2 extends Handle_StepFEA_FeaShellBendingStiffness {
    constructor(thePtr: StepFEA_FeaShellBendingStiffness);
  }

  export declare class Handle_StepFEA_FeaShellBendingStiffness_3 extends Handle_StepFEA_FeaShellBendingStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellBendingStiffness);
  }

  export declare class Handle_StepFEA_FeaShellBendingStiffness_4 extends Handle_StepFEA_FeaShellBendingStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellBendingStiffness);
  }

export declare class StepFEA_FeaShellBendingStiffness extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor42d): void;
  FeaConstants(): StepFEA_SymmetricTensor42d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor42d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_Surface3dElementRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_Surface3dElementRepresentation): void;
  get(): StepFEA_Surface3dElementRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_Surface3dElementRepresentation_1 extends Handle_StepFEA_Surface3dElementRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_Surface3dElementRepresentation_2 extends Handle_StepFEA_Surface3dElementRepresentation {
    constructor(thePtr: StepFEA_Surface3dElementRepresentation);
  }

  export declare class Handle_StepFEA_Surface3dElementRepresentation_3 extends Handle_StepFEA_Surface3dElementRepresentation {
    constructor(theHandle: Handle_StepFEA_Surface3dElementRepresentation);
  }

  export declare class Handle_StepFEA_Surface3dElementRepresentation_4 extends Handle_StepFEA_Surface3dElementRepresentation {
    constructor(theHandle: Handle_StepFEA_Surface3dElementRepresentation);
  }

export declare class StepFEA_Surface3dElementRepresentation extends StepFEA_ElementRepresentation {
  constructor()
  Init(aRepresentation_Name: Handle_TCollection_HAsciiString, aRepresentation_Items: Handle_StepRepr_HArray1OfRepresentationItem, aRepresentation_ContextOfItems: Handle_StepRepr_RepresentationContext, aElementRepresentation_NodeList: Handle_StepFEA_HArray1OfNodeRepresentation, aModelRef: Handle_StepFEA_FeaModel3d, aElementDescriptor: Handle_StepElement_Surface3dElementDescriptor, aProperty: Handle_StepElement_SurfaceElementProperty, aMaterial: Handle_StepElement_ElementMaterial): void;
  ModelRef(): Handle_StepFEA_FeaModel3d;
  SetModelRef(ModelRef: Handle_StepFEA_FeaModel3d): void;
  ElementDescriptor(): Handle_StepElement_Surface3dElementDescriptor;
  SetElementDescriptor(ElementDescriptor: Handle_StepElement_Surface3dElementDescriptor): void;
  Property(): Handle_StepElement_SurfaceElementProperty;
  SetProperty(Property: Handle_StepElement_SurfaceElementProperty): void;
  Material(): Handle_StepElement_ElementMaterial;
  SetMaterial(Material: Handle_StepElement_ElementMaterial): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_DegreeOfFreedomMember extends StepData_SelectNamed {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_DegreeOfFreedomMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_DegreeOfFreedomMember): void;
  get(): StepFEA_DegreeOfFreedomMember;
  delete(): void;
}

  export declare class Handle_StepFEA_DegreeOfFreedomMember_1 extends Handle_StepFEA_DegreeOfFreedomMember {
    constructor();
  }

  export declare class Handle_StepFEA_DegreeOfFreedomMember_2 extends Handle_StepFEA_DegreeOfFreedomMember {
    constructor(thePtr: StepFEA_DegreeOfFreedomMember);
  }

  export declare class Handle_StepFEA_DegreeOfFreedomMember_3 extends Handle_StepFEA_DegreeOfFreedomMember {
    constructor(theHandle: Handle_StepFEA_DegreeOfFreedomMember);
  }

  export declare class Handle_StepFEA_DegreeOfFreedomMember_4 extends Handle_StepFEA_DegreeOfFreedomMember {
    constructor(theHandle: Handle_StepFEA_DegreeOfFreedomMember);
  }

export declare type StepFEA_CurveEdge = {
  StepFEA_ElementEdge: {};
}

export declare class StepFEA_CurveElementEndRelease extends Standard_Transient {
  constructor()
  Init(aCoordinateSystem: StepFEA_CurveElementEndCoordinateSystem, aReleases: Handle_StepElement_HArray1OfCurveElementEndReleasePacket): void;
  CoordinateSystem(): StepFEA_CurveElementEndCoordinateSystem;
  SetCoordinateSystem(CoordinateSystem: StepFEA_CurveElementEndCoordinateSystem): void;
  Releases(): Handle_StepElement_HArray1OfCurveElementEndReleasePacket;
  SetReleases(Releases: Handle_StepElement_HArray1OfCurveElementEndReleasePacket): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_CurveElementEndRelease {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_CurveElementEndRelease): void;
  get(): StepFEA_CurveElementEndRelease;
  delete(): void;
}

  export declare class Handle_StepFEA_CurveElementEndRelease_1 extends Handle_StepFEA_CurveElementEndRelease {
    constructor();
  }

  export declare class Handle_StepFEA_CurveElementEndRelease_2 extends Handle_StepFEA_CurveElementEndRelease {
    constructor(thePtr: StepFEA_CurveElementEndRelease);
  }

  export declare class Handle_StepFEA_CurveElementEndRelease_3 extends Handle_StepFEA_CurveElementEndRelease {
    constructor(theHandle: Handle_StepFEA_CurveElementEndRelease);
  }

  export declare class Handle_StepFEA_CurveElementEndRelease_4 extends Handle_StepFEA_CurveElementEndRelease {
    constructor(theHandle: Handle_StepFEA_CurveElementEndRelease);
  }

export declare type StepFEA_CoordinateSystemType = {
  StepFEA_Cartesian: {};
  StepFEA_Cylindrical: {};
  StepFEA_Spherical: {};
}

export declare class StepFEA_FeaCurveSectionGeometricRelationship extends Standard_Transient {
  constructor()
  Init(aSectionRef: Handle_StepElement_CurveElementSectionDefinition, aItem: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  SectionRef(): Handle_StepElement_CurveElementSectionDefinition;
  SetSectionRef(SectionRef: Handle_StepElement_CurveElementSectionDefinition): void;
  Item(): Handle_StepElement_AnalysisItemWithinRepresentation;
  SetItem(Item: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaCurveSectionGeometricRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaCurveSectionGeometricRelationship): void;
  get(): StepFEA_FeaCurveSectionGeometricRelationship;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaCurveSectionGeometricRelationship_1 extends Handle_StepFEA_FeaCurveSectionGeometricRelationship {
    constructor();
  }

  export declare class Handle_StepFEA_FeaCurveSectionGeometricRelationship_2 extends Handle_StepFEA_FeaCurveSectionGeometricRelationship {
    constructor(thePtr: StepFEA_FeaCurveSectionGeometricRelationship);
  }

  export declare class Handle_StepFEA_FeaCurveSectionGeometricRelationship_3 extends Handle_StepFEA_FeaCurveSectionGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_FeaCurveSectionGeometricRelationship);
  }

  export declare class Handle_StepFEA_FeaCurveSectionGeometricRelationship_4 extends Handle_StepFEA_FeaCurveSectionGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_FeaCurveSectionGeometricRelationship);
  }

export declare class Handle_StepFEA_ElementGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ElementGroup): void;
  get(): StepFEA_ElementGroup;
  delete(): void;
}

  export declare class Handle_StepFEA_ElementGroup_1 extends Handle_StepFEA_ElementGroup {
    constructor();
  }

  export declare class Handle_StepFEA_ElementGroup_2 extends Handle_StepFEA_ElementGroup {
    constructor(thePtr: StepFEA_ElementGroup);
  }

  export declare class Handle_StepFEA_ElementGroup_3 extends Handle_StepFEA_ElementGroup {
    constructor(theHandle: Handle_StepFEA_ElementGroup);
  }

  export declare class Handle_StepFEA_ElementGroup_4 extends Handle_StepFEA_ElementGroup {
    constructor(theHandle: Handle_StepFEA_ElementGroup);
  }

export declare class StepFEA_ElementGroup extends StepFEA_FeaGroup {
  constructor()
  Init(aGroup_Name: Handle_TCollection_HAsciiString, aGroup_Description: Handle_TCollection_HAsciiString, aFeaGroup_ModelRef: Handle_StepFEA_FeaModel, aElements: Handle_StepFEA_HArray1OfElementRepresentation): void;
  Elements(): Handle_StepFEA_HArray1OfElementRepresentation;
  SetElements(Elements: Handle_StepFEA_HArray1OfElementRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_SymmetricTensor43dMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_SymmetricTensor43dMember): void;
  get(): StepFEA_SymmetricTensor43dMember;
  delete(): void;
}

  export declare class Handle_StepFEA_SymmetricTensor43dMember_1 extends Handle_StepFEA_SymmetricTensor43dMember {
    constructor();
  }

  export declare class Handle_StepFEA_SymmetricTensor43dMember_2 extends Handle_StepFEA_SymmetricTensor43dMember {
    constructor(thePtr: StepFEA_SymmetricTensor43dMember);
  }

  export declare class Handle_StepFEA_SymmetricTensor43dMember_3 extends Handle_StepFEA_SymmetricTensor43dMember {
    constructor(theHandle: Handle_StepFEA_SymmetricTensor43dMember);
  }

  export declare class Handle_StepFEA_SymmetricTensor43dMember_4 extends Handle_StepFEA_SymmetricTensor43dMember {
    constructor(theHandle: Handle_StepFEA_SymmetricTensor43dMember);
  }

export declare class StepFEA_SymmetricTensor43dMember extends StepData_SelectArrReal {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_CurveElementIntervalLinearlyVarying extends StepFEA_CurveElementInterval {
  constructor()
  Init(aCurveElementInterval_FinishPosition: Handle_StepFEA_CurveElementLocation, aCurveElementInterval_EuAngles: Handle_StepBasic_EulerAngles, aSections: Handle_StepElement_HArray1OfCurveElementSectionDefinition): void;
  Sections(): Handle_StepElement_HArray1OfCurveElementSectionDefinition;
  SetSections(Sections: Handle_StepElement_HArray1OfCurveElementSectionDefinition): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_CurveElementIntervalLinearlyVarying {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_CurveElementIntervalLinearlyVarying): void;
  get(): StepFEA_CurveElementIntervalLinearlyVarying;
  delete(): void;
}

  export declare class Handle_StepFEA_CurveElementIntervalLinearlyVarying_1 extends Handle_StepFEA_CurveElementIntervalLinearlyVarying {
    constructor();
  }

  export declare class Handle_StepFEA_CurveElementIntervalLinearlyVarying_2 extends Handle_StepFEA_CurveElementIntervalLinearlyVarying {
    constructor(thePtr: StepFEA_CurveElementIntervalLinearlyVarying);
  }

  export declare class Handle_StepFEA_CurveElementIntervalLinearlyVarying_3 extends Handle_StepFEA_CurveElementIntervalLinearlyVarying {
    constructor(theHandle: Handle_StepFEA_CurveElementIntervalLinearlyVarying);
  }

  export declare class Handle_StepFEA_CurveElementIntervalLinearlyVarying_4 extends Handle_StepFEA_CurveElementIntervalLinearlyVarying {
    constructor(theHandle: Handle_StepFEA_CurveElementIntervalLinearlyVarying);
  }

export declare class StepFEA_NodeRepresentation extends StepRepr_Representation {
  constructor()
  Init(aRepresentation_Name: Handle_TCollection_HAsciiString, aRepresentation_Items: Handle_StepRepr_HArray1OfRepresentationItem, aRepresentation_ContextOfItems: Handle_StepRepr_RepresentationContext, aModelRef: Handle_StepFEA_FeaModel): void;
  ModelRef(): Handle_StepFEA_FeaModel;
  SetModelRef(ModelRef: Handle_StepFEA_FeaModel): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_NodeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_NodeRepresentation): void;
  get(): StepFEA_NodeRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_NodeRepresentation_1 extends Handle_StepFEA_NodeRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_NodeRepresentation_2 extends Handle_StepFEA_NodeRepresentation {
    constructor(thePtr: StepFEA_NodeRepresentation);
  }

  export declare class Handle_StepFEA_NodeRepresentation_3 extends Handle_StepFEA_NodeRepresentation {
    constructor(theHandle: Handle_StepFEA_NodeRepresentation);
  }

  export declare class Handle_StepFEA_NodeRepresentation_4 extends Handle_StepFEA_NodeRepresentation {
    constructor(theHandle: Handle_StepFEA_NodeRepresentation);
  }

export declare class Handle_StepFEA_NodeGroup {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_NodeGroup): void;
  get(): StepFEA_NodeGroup;
  delete(): void;
}

  export declare class Handle_StepFEA_NodeGroup_1 extends Handle_StepFEA_NodeGroup {
    constructor();
  }

  export declare class Handle_StepFEA_NodeGroup_2 extends Handle_StepFEA_NodeGroup {
    constructor(thePtr: StepFEA_NodeGroup);
  }

  export declare class Handle_StepFEA_NodeGroup_3 extends Handle_StepFEA_NodeGroup {
    constructor(theHandle: Handle_StepFEA_NodeGroup);
  }

  export declare class Handle_StepFEA_NodeGroup_4 extends Handle_StepFEA_NodeGroup {
    constructor(theHandle: Handle_StepFEA_NodeGroup);
  }

export declare class StepFEA_NodeGroup extends StepFEA_FeaGroup {
  constructor()
  Init(aGroup_Name: Handle_TCollection_HAsciiString, aGroup_Description: Handle_TCollection_HAsciiString, aFeaGroup_ModelRef: Handle_StepFEA_FeaModel, aNodes: Handle_StepFEA_HArray1OfNodeRepresentation): void;
  Nodes(): Handle_StepFEA_HArray1OfNodeRepresentation;
  SetNodes(Nodes: Handle_StepFEA_HArray1OfNodeRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_NodeWithSolutionCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_NodeWithSolutionCoordinateSystem): void;
  get(): StepFEA_NodeWithSolutionCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_NodeWithSolutionCoordinateSystem_1 extends Handle_StepFEA_NodeWithSolutionCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_NodeWithSolutionCoordinateSystem_2 extends Handle_StepFEA_NodeWithSolutionCoordinateSystem {
    constructor(thePtr: StepFEA_NodeWithSolutionCoordinateSystem);
  }

  export declare class Handle_StepFEA_NodeWithSolutionCoordinateSystem_3 extends Handle_StepFEA_NodeWithSolutionCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_NodeWithSolutionCoordinateSystem);
  }

  export declare class Handle_StepFEA_NodeWithSolutionCoordinateSystem_4 extends Handle_StepFEA_NodeWithSolutionCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_NodeWithSolutionCoordinateSystem);
  }

export declare class StepFEA_NodeWithSolutionCoordinateSystem extends StepFEA_Node {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_HArray1OfNodeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HArray1OfNodeRepresentation): void;
  get(): StepFEA_HArray1OfNodeRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_HArray1OfNodeRepresentation_1 extends Handle_StepFEA_HArray1OfNodeRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_HArray1OfNodeRepresentation_2 extends Handle_StepFEA_HArray1OfNodeRepresentation {
    constructor(thePtr: StepFEA_HArray1OfNodeRepresentation);
  }

  export declare class Handle_StepFEA_HArray1OfNodeRepresentation_3 extends Handle_StepFEA_HArray1OfNodeRepresentation {
    constructor(theHandle: Handle_StepFEA_HArray1OfNodeRepresentation);
  }

  export declare class Handle_StepFEA_HArray1OfNodeRepresentation_4 extends Handle_StepFEA_HArray1OfNodeRepresentation {
    constructor(theHandle: Handle_StepFEA_HArray1OfNodeRepresentation);
  }

export declare class Handle_StepFEA_FeaMaterialPropertyRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaMaterialPropertyRepresentation): void;
  get(): StepFEA_FeaMaterialPropertyRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentation_1 extends Handle_StepFEA_FeaMaterialPropertyRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentation_2 extends Handle_StepFEA_FeaMaterialPropertyRepresentation {
    constructor(thePtr: StepFEA_FeaMaterialPropertyRepresentation);
  }

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentation_3 extends Handle_StepFEA_FeaMaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepFEA_FeaMaterialPropertyRepresentation);
  }

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentation_4 extends Handle_StepFEA_FeaMaterialPropertyRepresentation {
    constructor(theHandle: Handle_StepFEA_FeaMaterialPropertyRepresentation);
  }

export declare class StepFEA_FeaMaterialPropertyRepresentation extends StepRepr_MaterialPropertyRepresentation {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_ElementRepresentation extends StepRepr_Representation {
  constructor()
  Init(aRepresentation_Name: Handle_TCollection_HAsciiString, aRepresentation_Items: Handle_StepRepr_HArray1OfRepresentationItem, aRepresentation_ContextOfItems: Handle_StepRepr_RepresentationContext, aNodeList: Handle_StepFEA_HArray1OfNodeRepresentation): void;
  NodeList(): Handle_StepFEA_HArray1OfNodeRepresentation;
  SetNodeList(NodeList: Handle_StepFEA_HArray1OfNodeRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_ElementRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ElementRepresentation): void;
  get(): StepFEA_ElementRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_ElementRepresentation_1 extends Handle_StepFEA_ElementRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_ElementRepresentation_2 extends Handle_StepFEA_ElementRepresentation {
    constructor(thePtr: StepFEA_ElementRepresentation);
  }

  export declare class Handle_StepFEA_ElementRepresentation_3 extends Handle_StepFEA_ElementRepresentation {
    constructor(theHandle: Handle_StepFEA_ElementRepresentation);
  }

  export declare class Handle_StepFEA_ElementRepresentation_4 extends Handle_StepFEA_ElementRepresentation {
    constructor(theHandle: Handle_StepFEA_ElementRepresentation);
  }

export declare class Handle_StepFEA_HSequenceOfNodeRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HSequenceOfNodeRepresentation): void;
  get(): StepFEA_HSequenceOfNodeRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_HSequenceOfNodeRepresentation_1 extends Handle_StepFEA_HSequenceOfNodeRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_HSequenceOfNodeRepresentation_2 extends Handle_StepFEA_HSequenceOfNodeRepresentation {
    constructor(thePtr: StepFEA_HSequenceOfNodeRepresentation);
  }

  export declare class Handle_StepFEA_HSequenceOfNodeRepresentation_3 extends Handle_StepFEA_HSequenceOfNodeRepresentation {
    constructor(theHandle: Handle_StepFEA_HSequenceOfNodeRepresentation);
  }

  export declare class Handle_StepFEA_HSequenceOfNodeRepresentation_4 extends Handle_StepFEA_HSequenceOfNodeRepresentation {
    constructor(theHandle: Handle_StepFEA_HSequenceOfNodeRepresentation);
  }

export declare class StepFEA_CurveElementEndCoordinateSystem extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  FeaAxis2Placement3d(): Handle_StepFEA_FeaAxis2Placement3d;
  AlignedCurve3dElementCoordinateSystem(): Handle_StepFEA_AlignedCurve3dElementCoordinateSystem;
  ParametricCurve3dElementCoordinateSystem(): Handle_StepFEA_ParametricCurve3dElementCoordinateSystem;
  delete(): void;
}

export declare class Handle_StepFEA_FeaMaterialPropertyRepresentationItem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaMaterialPropertyRepresentationItem): void;
  get(): StepFEA_FeaMaterialPropertyRepresentationItem;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentationItem_1 extends Handle_StepFEA_FeaMaterialPropertyRepresentationItem {
    constructor();
  }

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentationItem_2 extends Handle_StepFEA_FeaMaterialPropertyRepresentationItem {
    constructor(thePtr: StepFEA_FeaMaterialPropertyRepresentationItem);
  }

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentationItem_3 extends Handle_StepFEA_FeaMaterialPropertyRepresentationItem {
    constructor(theHandle: Handle_StepFEA_FeaMaterialPropertyRepresentationItem);
  }

  export declare class Handle_StepFEA_FeaMaterialPropertyRepresentationItem_4 extends Handle_StepFEA_FeaMaterialPropertyRepresentationItem {
    constructor(theHandle: Handle_StepFEA_FeaMaterialPropertyRepresentationItem);
  }

export declare class StepFEA_FeaMaterialPropertyRepresentationItem extends StepRepr_RepresentationItem {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_HArray1OfDegreeOfFreedom {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HArray1OfDegreeOfFreedom): void;
  get(): StepFEA_HArray1OfDegreeOfFreedom;
  delete(): void;
}

  export declare class Handle_StepFEA_HArray1OfDegreeOfFreedom_1 extends Handle_StepFEA_HArray1OfDegreeOfFreedom {
    constructor();
  }

  export declare class Handle_StepFEA_HArray1OfDegreeOfFreedom_2 extends Handle_StepFEA_HArray1OfDegreeOfFreedom {
    constructor(thePtr: StepFEA_HArray1OfDegreeOfFreedom);
  }

  export declare class Handle_StepFEA_HArray1OfDegreeOfFreedom_3 extends Handle_StepFEA_HArray1OfDegreeOfFreedom {
    constructor(theHandle: Handle_StepFEA_HArray1OfDegreeOfFreedom);
  }

  export declare class Handle_StepFEA_HArray1OfDegreeOfFreedom_4 extends Handle_StepFEA_HArray1OfDegreeOfFreedom {
    constructor(theHandle: Handle_StepFEA_HArray1OfDegreeOfFreedom);
  }

export declare class StepFEA_FeaModel3d extends StepFEA_FeaModel {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaModel3d {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaModel3d): void;
  get(): StepFEA_FeaModel3d;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaModel3d_1 extends Handle_StepFEA_FeaModel3d {
    constructor();
  }

  export declare class Handle_StepFEA_FeaModel3d_2 extends Handle_StepFEA_FeaModel3d {
    constructor(thePtr: StepFEA_FeaModel3d);
  }

  export declare class Handle_StepFEA_FeaModel3d_3 extends Handle_StepFEA_FeaModel3d {
    constructor(theHandle: Handle_StepFEA_FeaModel3d);
  }

  export declare class Handle_StepFEA_FeaModel3d_4 extends Handle_StepFEA_FeaModel3d {
    constructor(theHandle: Handle_StepFEA_FeaModel3d);
  }

export declare class StepFEA_ParametricCurve3dElementCoordinateSystem extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aDirection: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection): void;
  Direction(): Handle_StepFEA_ParametricCurve3dElementCoordinateDirection;
  SetDirection(Direction: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ParametricCurve3dElementCoordinateSystem): void;
  get(): StepFEA_ParametricCurve3dElementCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_1 extends Handle_StepFEA_ParametricCurve3dElementCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_2 extends Handle_StepFEA_ParametricCurve3dElementCoordinateSystem {
    constructor(thePtr: StepFEA_ParametricCurve3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_3 extends Handle_StepFEA_ParametricCurve3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ParametricCurve3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_4 extends Handle_StepFEA_ParametricCurve3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ParametricCurve3dElementCoordinateSystem);
  }

export declare class StepFEA_AlignedCurve3dElementCoordinateSystem extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aCoordinateSystem: Handle_StepFEA_FeaAxis2Placement3d): void;
  CoordinateSystem(): Handle_StepFEA_FeaAxis2Placement3d;
  SetCoordinateSystem(CoordinateSystem: Handle_StepFEA_FeaAxis2Placement3d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_AlignedCurve3dElementCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_AlignedCurve3dElementCoordinateSystem): void;
  get(): StepFEA_AlignedCurve3dElementCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_1 extends Handle_StepFEA_AlignedCurve3dElementCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_2 extends Handle_StepFEA_AlignedCurve3dElementCoordinateSystem {
    constructor(thePtr: StepFEA_AlignedCurve3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_3 extends Handle_StepFEA_AlignedCurve3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_AlignedCurve3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_4 extends Handle_StepFEA_AlignedCurve3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_AlignedCurve3dElementCoordinateSystem);
  }

export declare class StepFEA_SymmetricTensor42d extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  AnisotropicSymmetricTensor42d(): Handle_TColStd_HArray1OfReal;
  delete(): void;
}

export declare class Handle_StepFEA_FeaMoistureAbsorption {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaMoistureAbsorption): void;
  get(): StepFEA_FeaMoistureAbsorption;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaMoistureAbsorption_1 extends Handle_StepFEA_FeaMoistureAbsorption {
    constructor();
  }

  export declare class Handle_StepFEA_FeaMoistureAbsorption_2 extends Handle_StepFEA_FeaMoistureAbsorption {
    constructor(thePtr: StepFEA_FeaMoistureAbsorption);
  }

  export declare class Handle_StepFEA_FeaMoistureAbsorption_3 extends Handle_StepFEA_FeaMoistureAbsorption {
    constructor(theHandle: Handle_StepFEA_FeaMoistureAbsorption);
  }

  export declare class Handle_StepFEA_FeaMoistureAbsorption_4 extends Handle_StepFEA_FeaMoistureAbsorption {
    constructor(theHandle: Handle_StepFEA_FeaMoistureAbsorption);
  }

export declare class StepFEA_FeaMoistureAbsorption extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor23d): void;
  FeaConstants(): StepFEA_SymmetricTensor23d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor23d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_CurveElementLocation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_CurveElementLocation): void;
  get(): StepFEA_CurveElementLocation;
  delete(): void;
}

  export declare class Handle_StepFEA_CurveElementLocation_1 extends Handle_StepFEA_CurveElementLocation {
    constructor();
  }

  export declare class Handle_StepFEA_CurveElementLocation_2 extends Handle_StepFEA_CurveElementLocation {
    constructor(thePtr: StepFEA_CurveElementLocation);
  }

  export declare class Handle_StepFEA_CurveElementLocation_3 extends Handle_StepFEA_CurveElementLocation {
    constructor(theHandle: Handle_StepFEA_CurveElementLocation);
  }

  export declare class Handle_StepFEA_CurveElementLocation_4 extends Handle_StepFEA_CurveElementLocation {
    constructor(theHandle: Handle_StepFEA_CurveElementLocation);
  }

export declare class StepFEA_CurveElementLocation extends Standard_Transient {
  constructor()
  Init(aCoordinate: Handle_StepFEA_FeaParametricPoint): void;
  Coordinate(): Handle_StepFEA_FeaParametricPoint;
  SetCoordinate(Coordinate: Handle_StepFEA_FeaParametricPoint): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_ElementOrElementGroup extends StepData_SelectType {
  constructor()
  CaseNum(ent: Handle_Standard_Transient): Graphic3d_ZLayerId;
  ElementRepresentation(): Handle_StepFEA_ElementRepresentation;
  ElementGroup(): Handle_StepFEA_ElementGroup;
  delete(): void;
}

export declare class Handle_StepFEA_CurveElementIntervalConstant {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_CurveElementIntervalConstant): void;
  get(): StepFEA_CurveElementIntervalConstant;
  delete(): void;
}

  export declare class Handle_StepFEA_CurveElementIntervalConstant_1 extends Handle_StepFEA_CurveElementIntervalConstant {
    constructor();
  }

  export declare class Handle_StepFEA_CurveElementIntervalConstant_2 extends Handle_StepFEA_CurveElementIntervalConstant {
    constructor(thePtr: StepFEA_CurveElementIntervalConstant);
  }

  export declare class Handle_StepFEA_CurveElementIntervalConstant_3 extends Handle_StepFEA_CurveElementIntervalConstant {
    constructor(theHandle: Handle_StepFEA_CurveElementIntervalConstant);
  }

  export declare class Handle_StepFEA_CurveElementIntervalConstant_4 extends Handle_StepFEA_CurveElementIntervalConstant {
    constructor(theHandle: Handle_StepFEA_CurveElementIntervalConstant);
  }

export declare class StepFEA_CurveElementIntervalConstant extends StepFEA_CurveElementInterval {
  constructor()
  Init(aCurveElementInterval_FinishPosition: Handle_StepFEA_CurveElementLocation, aCurveElementInterval_EuAngles: Handle_StepBasic_EulerAngles, aSection: Handle_StepElement_CurveElementSectionDefinition): void;
  Section(): Handle_StepElement_CurveElementSectionDefinition;
  SetSection(Section: Handle_StepElement_CurveElementSectionDefinition): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_CurveElementEndOffset extends Standard_Transient {
  constructor()
  Init(aCoordinateSystem: StepFEA_CurveElementEndCoordinateSystem, aOffsetVector: Handle_TColStd_HArray1OfReal): void;
  CoordinateSystem(): StepFEA_CurveElementEndCoordinateSystem;
  SetCoordinateSystem(CoordinateSystem: StepFEA_CurveElementEndCoordinateSystem): void;
  OffsetVector(): Handle_TColStd_HArray1OfReal;
  SetOffsetVector(OffsetVector: Handle_TColStd_HArray1OfReal): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_CurveElementEndOffset {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_CurveElementEndOffset): void;
  get(): StepFEA_CurveElementEndOffset;
  delete(): void;
}

  export declare class Handle_StepFEA_CurveElementEndOffset_1 extends Handle_StepFEA_CurveElementEndOffset {
    constructor();
  }

  export declare class Handle_StepFEA_CurveElementEndOffset_2 extends Handle_StepFEA_CurveElementEndOffset {
    constructor(thePtr: StepFEA_CurveElementEndOffset);
  }

  export declare class Handle_StepFEA_CurveElementEndOffset_3 extends Handle_StepFEA_CurveElementEndOffset {
    constructor(theHandle: Handle_StepFEA_CurveElementEndOffset);
  }

  export declare class Handle_StepFEA_CurveElementEndOffset_4 extends Handle_StepFEA_CurveElementEndOffset {
    constructor(theHandle: Handle_StepFEA_CurveElementEndOffset);
  }

export declare type StepFEA_UnspecifiedValue = {
  StepFEA_Unspecified: {};
}

export declare class StepFEA_NodeSet extends StepGeom_GeometricRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aNodes: Handle_StepFEA_HArray1OfNodeRepresentation): void;
  Nodes(): Handle_StepFEA_HArray1OfNodeRepresentation;
  SetNodes(Nodes: Handle_StepFEA_HArray1OfNodeRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_NodeSet {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_NodeSet): void;
  get(): StepFEA_NodeSet;
  delete(): void;
}

  export declare class Handle_StepFEA_NodeSet_1 extends Handle_StepFEA_NodeSet {
    constructor();
  }

  export declare class Handle_StepFEA_NodeSet_2 extends Handle_StepFEA_NodeSet {
    constructor(thePtr: StepFEA_NodeSet);
  }

  export declare class Handle_StepFEA_NodeSet_3 extends Handle_StepFEA_NodeSet {
    constructor(theHandle: Handle_StepFEA_NodeSet);
  }

  export declare class Handle_StepFEA_NodeSet_4 extends Handle_StepFEA_NodeSet {
    constructor(theHandle: Handle_StepFEA_NodeSet);
  }

export declare type StepFEA_ElementVolume = {
  StepFEA_Volume: {};
}

export declare class Handle_StepFEA_NodeWithVector {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_NodeWithVector): void;
  get(): StepFEA_NodeWithVector;
  delete(): void;
}

  export declare class Handle_StepFEA_NodeWithVector_1 extends Handle_StepFEA_NodeWithVector {
    constructor();
  }

  export declare class Handle_StepFEA_NodeWithVector_2 extends Handle_StepFEA_NodeWithVector {
    constructor(thePtr: StepFEA_NodeWithVector);
  }

  export declare class Handle_StepFEA_NodeWithVector_3 extends Handle_StepFEA_NodeWithVector {
    constructor(theHandle: Handle_StepFEA_NodeWithVector);
  }

  export declare class Handle_StepFEA_NodeWithVector_4 extends Handle_StepFEA_NodeWithVector {
    constructor(theHandle: Handle_StepFEA_NodeWithVector);
  }

export declare class StepFEA_NodeWithVector extends StepFEA_Node {
  constructor()
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_CurveElementInterval extends Standard_Transient {
  constructor()
  Init(aFinishPosition: Handle_StepFEA_CurveElementLocation, aEuAngles: Handle_StepBasic_EulerAngles): void;
  FinishPosition(): Handle_StepFEA_CurveElementLocation;
  SetFinishPosition(FinishPosition: Handle_StepFEA_CurveElementLocation): void;
  EuAngles(): Handle_StepBasic_EulerAngles;
  SetEuAngles(EuAngles: Handle_StepBasic_EulerAngles): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_CurveElementInterval {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_CurveElementInterval): void;
  get(): StepFEA_CurveElementInterval;
  delete(): void;
}

  export declare class Handle_StepFEA_CurveElementInterval_1 extends Handle_StepFEA_CurveElementInterval {
    constructor();
  }

  export declare class Handle_StepFEA_CurveElementInterval_2 extends Handle_StepFEA_CurveElementInterval {
    constructor(thePtr: StepFEA_CurveElementInterval);
  }

  export declare class Handle_StepFEA_CurveElementInterval_3 extends Handle_StepFEA_CurveElementInterval {
    constructor(theHandle: Handle_StepFEA_CurveElementInterval);
  }

  export declare class Handle_StepFEA_CurveElementInterval_4 extends Handle_StepFEA_CurveElementInterval {
    constructor(theHandle: Handle_StepFEA_CurveElementInterval);
  }

export declare class StepFEA_FeaSurfaceSectionGeometricRelationship extends Standard_Transient {
  constructor()
  Init(aSectionRef: Handle_StepElement_SurfaceSection, aItem: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  SectionRef(): Handle_StepElement_SurfaceSection;
  SetSectionRef(SectionRef: Handle_StepElement_SurfaceSection): void;
  Item(): Handle_StepElement_AnalysisItemWithinRepresentation;
  SetItem(Item: Handle_StepElement_AnalysisItemWithinRepresentation): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaSurfaceSectionGeometricRelationship {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaSurfaceSectionGeometricRelationship): void;
  get(): StepFEA_FeaSurfaceSectionGeometricRelationship;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_1 extends Handle_StepFEA_FeaSurfaceSectionGeometricRelationship {
    constructor();
  }

  export declare class Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_2 extends Handle_StepFEA_FeaSurfaceSectionGeometricRelationship {
    constructor(thePtr: StepFEA_FeaSurfaceSectionGeometricRelationship);
  }

  export declare class Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_3 extends Handle_StepFEA_FeaSurfaceSectionGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_FeaSurfaceSectionGeometricRelationship);
  }

  export declare class Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_4 extends Handle_StepFEA_FeaSurfaceSectionGeometricRelationship {
    constructor(theHandle: Handle_StepFEA_FeaSurfaceSectionGeometricRelationship);
  }

export declare class StepFEA_FeaAreaDensity extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstant: Quantity_AbsorbedDose): void;
  FeaConstant(): Quantity_AbsorbedDose;
  SetFeaConstant(FeaConstant: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FeaAreaDensity {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaAreaDensity): void;
  get(): StepFEA_FeaAreaDensity;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaAreaDensity_1 extends Handle_StepFEA_FeaAreaDensity {
    constructor();
  }

  export declare class Handle_StepFEA_FeaAreaDensity_2 extends Handle_StepFEA_FeaAreaDensity {
    constructor(thePtr: StepFEA_FeaAreaDensity);
  }

  export declare class Handle_StepFEA_FeaAreaDensity_3 extends Handle_StepFEA_FeaAreaDensity {
    constructor(theHandle: Handle_StepFEA_FeaAreaDensity);
  }

  export declare class Handle_StepFEA_FeaAreaDensity_4 extends Handle_StepFEA_FeaAreaDensity {
    constructor(theHandle: Handle_StepFEA_FeaAreaDensity);
  }

export declare class Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ArbitraryVolume3dElementCoordinateSystem): void;
  get(): StepFEA_ArbitraryVolume3dElementCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_1 extends Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_2 extends Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem {
    constructor(thePtr: StepFEA_ArbitraryVolume3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_3 extends Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_4 extends Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem);
  }

export declare class StepFEA_ArbitraryVolume3dElementCoordinateSystem extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aCoordinateSystem: Handle_StepFEA_FeaAxis2Placement3d): void;
  CoordinateSystem(): Handle_StepFEA_FeaAxis2Placement3d;
  SetCoordinateSystem(CoordinateSystem: Handle_StepFEA_FeaAxis2Placement3d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_ParametricCurve3dElementCoordinateDirection extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aOrientation: Handle_StepGeom_Direction): void;
  Orientation(): Handle_StepGeom_Direction;
  SetOrientation(Orientation: Handle_StepGeom_Direction): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateDirection {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_ParametricCurve3dElementCoordinateDirection): void;
  get(): StepFEA_ParametricCurve3dElementCoordinateDirection;
  delete(): void;
}

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_1 extends Handle_StepFEA_ParametricCurve3dElementCoordinateDirection {
    constructor();
  }

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_2 extends Handle_StepFEA_ParametricCurve3dElementCoordinateDirection {
    constructor(thePtr: StepFEA_ParametricCurve3dElementCoordinateDirection);
  }

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_3 extends Handle_StepFEA_ParametricCurve3dElementCoordinateDirection {
    constructor(theHandle: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection);
  }

  export declare class Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_4 extends Handle_StepFEA_ParametricCurve3dElementCoordinateDirection {
    constructor(theHandle: Handle_StepFEA_ParametricCurve3dElementCoordinateDirection);
  }

export declare class Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaSecantCoefficientOfLinearThermalExpansion): void;
  get(): StepFEA_FeaSecantCoefficientOfLinearThermalExpansion;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_1 extends Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion {
    constructor();
  }

  export declare class Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_2 extends Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion {
    constructor(thePtr: StepFEA_FeaSecantCoefficientOfLinearThermalExpansion);
  }

  export declare class Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_3 extends Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion {
    constructor(theHandle: Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion);
  }

  export declare class Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_4 extends Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion {
    constructor(theHandle: Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion);
  }

export declare class StepFEA_FeaSecantCoefficientOfLinearThermalExpansion extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor23d, aReferenceTemperature: Quantity_AbsorbedDose): void;
  FeaConstants(): StepFEA_SymmetricTensor23d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor23d): void;
  ReferenceTemperature(): Quantity_AbsorbedDose;
  SetReferenceTemperature(ReferenceTemperature: Quantity_AbsorbedDose): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_FreedomsList {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FreedomsList): void;
  get(): StepFEA_FreedomsList;
  delete(): void;
}

  export declare class Handle_StepFEA_FreedomsList_1 extends Handle_StepFEA_FreedomsList {
    constructor();
  }

  export declare class Handle_StepFEA_FreedomsList_2 extends Handle_StepFEA_FreedomsList {
    constructor(thePtr: StepFEA_FreedomsList);
  }

  export declare class Handle_StepFEA_FreedomsList_3 extends Handle_StepFEA_FreedomsList {
    constructor(theHandle: Handle_StepFEA_FreedomsList);
  }

  export declare class Handle_StepFEA_FreedomsList_4 extends Handle_StepFEA_FreedomsList {
    constructor(theHandle: Handle_StepFEA_FreedomsList);
  }

export declare class StepFEA_FreedomsList extends Standard_Transient {
  constructor()
  Init(aFreedoms: Handle_StepFEA_HArray1OfDegreeOfFreedom): void;
  Freedoms(): Handle_StepFEA_HArray1OfDegreeOfFreedom;
  SetFreedoms(Freedoms: Handle_StepFEA_HArray1OfDegreeOfFreedom): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class StepFEA_SymmetricTensor23dMember extends StepData_SelectArrReal {
  constructor()
  HasName(): Standard_Boolean;
  Name(): Standard_CString;
  SetName(name: Standard_CString): Standard_Boolean;
  Matches(name: Standard_CString): Standard_Boolean;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_SymmetricTensor23dMember {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_SymmetricTensor23dMember): void;
  get(): StepFEA_SymmetricTensor23dMember;
  delete(): void;
}

  export declare class Handle_StepFEA_SymmetricTensor23dMember_1 extends Handle_StepFEA_SymmetricTensor23dMember {
    constructor();
  }

  export declare class Handle_StepFEA_SymmetricTensor23dMember_2 extends Handle_StepFEA_SymmetricTensor23dMember {
    constructor(thePtr: StepFEA_SymmetricTensor23dMember);
  }

  export declare class Handle_StepFEA_SymmetricTensor23dMember_3 extends Handle_StepFEA_SymmetricTensor23dMember {
    constructor(theHandle: Handle_StepFEA_SymmetricTensor23dMember);
  }

  export declare class Handle_StepFEA_SymmetricTensor23dMember_4 extends Handle_StepFEA_SymmetricTensor23dMember {
    constructor(theHandle: Handle_StepFEA_SymmetricTensor23dMember);
  }

export declare class Handle_StepFEA_FeaShellMembraneStiffness {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_FeaShellMembraneStiffness): void;
  get(): StepFEA_FeaShellMembraneStiffness;
  delete(): void;
}

  export declare class Handle_StepFEA_FeaShellMembraneStiffness_1 extends Handle_StepFEA_FeaShellMembraneStiffness {
    constructor();
  }

  export declare class Handle_StepFEA_FeaShellMembraneStiffness_2 extends Handle_StepFEA_FeaShellMembraneStiffness {
    constructor(thePtr: StepFEA_FeaShellMembraneStiffness);
  }

  export declare class Handle_StepFEA_FeaShellMembraneStiffness_3 extends Handle_StepFEA_FeaShellMembraneStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellMembraneStiffness);
  }

  export declare class Handle_StepFEA_FeaShellMembraneStiffness_4 extends Handle_StepFEA_FeaShellMembraneStiffness {
    constructor(theHandle: Handle_StepFEA_FeaShellMembraneStiffness);
  }

export declare class StepFEA_FeaShellMembraneStiffness extends StepFEA_FeaMaterialPropertyRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aFeaConstants: StepFEA_SymmetricTensor42d): void;
  FeaConstants(): StepFEA_SymmetricTensor42d;
  SetFeaConstants(FeaConstants: StepFEA_SymmetricTensor42d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_StepFEA_HSequenceOfElementRepresentation {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_HSequenceOfElementRepresentation): void;
  get(): StepFEA_HSequenceOfElementRepresentation;
  delete(): void;
}

  export declare class Handle_StepFEA_HSequenceOfElementRepresentation_1 extends Handle_StepFEA_HSequenceOfElementRepresentation {
    constructor();
  }

  export declare class Handle_StepFEA_HSequenceOfElementRepresentation_2 extends Handle_StepFEA_HSequenceOfElementRepresentation {
    constructor(thePtr: StepFEA_HSequenceOfElementRepresentation);
  }

  export declare class Handle_StepFEA_HSequenceOfElementRepresentation_3 extends Handle_StepFEA_HSequenceOfElementRepresentation {
    constructor(theHandle: Handle_StepFEA_HSequenceOfElementRepresentation);
  }

  export declare class Handle_StepFEA_HSequenceOfElementRepresentation_4 extends Handle_StepFEA_HSequenceOfElementRepresentation {
    constructor(theHandle: Handle_StepFEA_HSequenceOfElementRepresentation);
  }

export declare class StepFEA_Array1OfDegreeOfFreedom {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: StepFEA_DegreeOfFreedom): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: StepFEA_Array1OfDegreeOfFreedom): StepFEA_Array1OfDegreeOfFreedom;
  Move(theOther: StepFEA_Array1OfDegreeOfFreedom): StepFEA_Array1OfDegreeOfFreedom;
  First(): StepFEA_DegreeOfFreedom;
  ChangeFirst(): StepFEA_DegreeOfFreedom;
  Last(): StepFEA_DegreeOfFreedom;
  ChangeLast(): StepFEA_DegreeOfFreedom;
  Value(theIndex: Standard_Integer): StepFEA_DegreeOfFreedom;
  ChangeValue(theIndex: Standard_Integer): StepFEA_DegreeOfFreedom;
  SetValue(theIndex: Standard_Integer, theItem: StepFEA_DegreeOfFreedom): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class StepFEA_Array1OfDegreeOfFreedom_1 extends StepFEA_Array1OfDegreeOfFreedom {
    constructor();
  }

  export declare class StepFEA_Array1OfDegreeOfFreedom_2 extends StepFEA_Array1OfDegreeOfFreedom {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class StepFEA_Array1OfDegreeOfFreedom_3 extends StepFEA_Array1OfDegreeOfFreedom {
    constructor(theOther: StepFEA_Array1OfDegreeOfFreedom);
  }

  export declare class StepFEA_Array1OfDegreeOfFreedom_4 extends StepFEA_Array1OfDegreeOfFreedom {
    constructor(theOther: StepFEA_Array1OfDegreeOfFreedom);
  }

  export declare class StepFEA_Array1OfDegreeOfFreedom_5 extends StepFEA_Array1OfDegreeOfFreedom {
    constructor(theBegin: StepFEA_DegreeOfFreedom, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_StepFEA_AlignedSurface3dElementCoordinateSystem {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: StepFEA_AlignedSurface3dElementCoordinateSystem): void;
  get(): StepFEA_AlignedSurface3dElementCoordinateSystem;
  delete(): void;
}

  export declare class Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_1 extends Handle_StepFEA_AlignedSurface3dElementCoordinateSystem {
    constructor();
  }

  export declare class Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_2 extends Handle_StepFEA_AlignedSurface3dElementCoordinateSystem {
    constructor(thePtr: StepFEA_AlignedSurface3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_3 extends Handle_StepFEA_AlignedSurface3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_AlignedSurface3dElementCoordinateSystem);
  }

  export declare class Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_4 extends Handle_StepFEA_AlignedSurface3dElementCoordinateSystem {
    constructor(theHandle: Handle_StepFEA_AlignedSurface3dElementCoordinateSystem);
  }

export declare class StepFEA_AlignedSurface3dElementCoordinateSystem extends StepFEA_FeaRepresentationItem {
  constructor()
  Init(aRepresentationItem_Name: Handle_TCollection_HAsciiString, aCoordinateSystem: Handle_StepFEA_FeaAxis2Placement3d): void;
  CoordinateSystem(): Handle_StepFEA_FeaAxis2Placement3d;
  SetCoordinateSystem(CoordinateSystem: Handle_StepFEA_FeaAxis2Placement3d): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class BOPTools_SetMapHasher {
  constructor();
  static HashCode(theSet: BOPTools_Set, theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  static IsEqual(aSet1: BOPTools_Set, aSet2: BOPTools_Set): Standard_Boolean;
  delete(): void;
}

export declare class BOPTools_ListOfConnexityBlock extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BOPTools_ListOfConnexityBlock): BOPTools_ListOfConnexityBlock;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BOPTools_ConnexityBlock;
  First_2(): BOPTools_ConnexityBlock;
  Last_1(): BOPTools_ConnexityBlock;
  Last_2(): BOPTools_ConnexityBlock;
  Append_1(theItem: BOPTools_ConnexityBlock): BOPTools_ConnexityBlock;
  Append_3(theOther: BOPTools_ListOfConnexityBlock): void;
  Prepend_1(theItem: BOPTools_ConnexityBlock): BOPTools_ConnexityBlock;
  Prepend_2(theOther: BOPTools_ListOfConnexityBlock): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BOPTools_ListOfConnexityBlock_1 extends BOPTools_ListOfConnexityBlock {
    constructor();
  }

  export declare class BOPTools_ListOfConnexityBlock_2 extends BOPTools_ListOfConnexityBlock {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPTools_ListOfConnexityBlock_3 extends BOPTools_ListOfConnexityBlock {
    constructor(theOther: BOPTools_ListOfConnexityBlock);
  }

export declare class BOPTools_AlgoTools3D {
  constructor();
  static DoSplitSEAMOnFace_1(theESplit: TopoDS_Edge, theFace: TopoDS_Face): Standard_Boolean;
  static DoSplitSEAMOnFace_2(theEOrigin: TopoDS_Edge, theESplit: TopoDS_Edge, theFace: TopoDS_Face): Standard_Boolean;
  static GetNormalToFaceOnEdge_1(aE: TopoDS_Edge, aF: TopoDS_Face, aT: Quantity_AbsorbedDose, aD: gp_Dir, theContext: Handle_IntTools_Context): void;
  static GetNormalToFaceOnEdge_2(aE: TopoDS_Edge, aF: TopoDS_Face, aD: gp_Dir, theContext: Handle_IntTools_Context): void;
  static SenseFlag(aNF1: gp_Dir, aNF2: gp_Dir): Graphic3d_ZLayerId;
  static GetNormalToSurface(aS: Handle_Geom_Surface, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, aD: gp_Dir): Standard_Boolean;
  static GetApproxNormalToFaceOnEdge_1(aE: TopoDS_Edge, aF: TopoDS_Face, aT: Quantity_AbsorbedDose, aPx: gp_Pnt, aD: gp_Dir, theContext: Handle_IntTools_Context): Standard_Boolean;
  static GetApproxNormalToFaceOnEdge_2(theE: TopoDS_Edge, theF: TopoDS_Face, aT: Quantity_AbsorbedDose, aP: gp_Pnt, aDNF: gp_Dir, aDt2D: Quantity_AbsorbedDose): Standard_Boolean;
  static GetApproxNormalToFaceOnEdge_3(theE: TopoDS_Edge, theF: TopoDS_Face, aT: Quantity_AbsorbedDose, aDt2D: Quantity_AbsorbedDose, aP: gp_Pnt, aDNF: gp_Dir, theContext: Handle_IntTools_Context): Standard_Boolean;
  static PointNearEdge_1(aE: TopoDS_Edge, aF: TopoDS_Face, aT: Quantity_AbsorbedDose, aDt2D: Quantity_AbsorbedDose, aP2D: gp_Pnt2d, aPx: gp_Pnt, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static PointNearEdge_2(aE: TopoDS_Edge, aF: TopoDS_Face, aT: Quantity_AbsorbedDose, aDt2D: Quantity_AbsorbedDose, aP2D: gp_Pnt2d, aPx: gp_Pnt): Graphic3d_ZLayerId;
  static PointNearEdge_3(aE: TopoDS_Edge, aF: TopoDS_Face, aT: Quantity_AbsorbedDose, aP2D: gp_Pnt2d, aPx: gp_Pnt, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static PointNearEdge_4(aE: TopoDS_Edge, aF: TopoDS_Face, aP2D: gp_Pnt2d, aPx: gp_Pnt, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static MinStepIn2d(): Quantity_AbsorbedDose;
  static IsEmptyShape(aS: TopoDS_Shape): Standard_Boolean;
  static OrientEdgeOnFace(aE: TopoDS_Edge, aF: TopoDS_Face, aER: TopoDS_Edge): void;
  static PointInFace_1(theF: TopoDS_Face, theP: gp_Pnt, theP2D: gp_Pnt2d, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static PointInFace_2(theF: TopoDS_Face, theE: TopoDS_Edge, theT: Quantity_AbsorbedDose, theDt2D: Quantity_AbsorbedDose, theP: gp_Pnt, theP2D: gp_Pnt2d, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static PointInFace_3(theF: TopoDS_Face, theL: Handle_Geom2d_Curve, theP: gp_Pnt, theP2D: gp_Pnt2d, theContext: Handle_IntTools_Context, theDt2D: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class BOPTools_AlgoTools {
  constructor();
  static DTolerance(): Quantity_AbsorbedDose;
  static ComputeVV_1(theV: TopoDS_Vertex, theP: gp_Pnt, theTolP: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static ComputeVV_2(theV1: TopoDS_Vertex, theV2: TopoDS_Vertex, theFuzz: Quantity_AbsorbedDose): Graphic3d_ZLayerId;
  static MakeVertex(theLV: TopTools_ListOfShape, theV: TopoDS_Vertex): void;
  static MakeNewVertex_1(aP1: gp_Pnt, aTol: Quantity_AbsorbedDose, aNewVertex: TopoDS_Vertex): void;
  static MakeNewVertex_2(aV1: TopoDS_Vertex, aV2: TopoDS_Vertex, aNewVertex: TopoDS_Vertex): void;
  static MakeNewVertex_3(aE1: TopoDS_Edge, aP1: Quantity_AbsorbedDose, aE2: TopoDS_Edge, aP2: Quantity_AbsorbedDose, aNewVertex: TopoDS_Vertex): void;
  static MakeNewVertex_4(aE1: TopoDS_Edge, aP1: Quantity_AbsorbedDose, aF2: TopoDS_Face, aNewVertex: TopoDS_Vertex): void;
  static UpdateVertex_1(aIC: IntTools_Curve, aT: Quantity_AbsorbedDose, aV: TopoDS_Vertex): void;
  static UpdateVertex_2(aE: TopoDS_Edge, aT: Quantity_AbsorbedDose, aV: TopoDS_Vertex): void;
  static UpdateVertex_3(aVF: TopoDS_Vertex, aVN: TopoDS_Vertex): void;
  static MakeEdge(theCurve: IntTools_Curve, theV1: TopoDS_Vertex, theT1: Quantity_AbsorbedDose, theV2: TopoDS_Vertex, theT2: Quantity_AbsorbedDose, theTolR3D: Quantity_AbsorbedDose, theE: TopoDS_Edge): void;
  static CopyEdge(theEdge: TopoDS_Edge): TopoDS_Edge;
  static MakeSplitEdge(aE1: TopoDS_Edge, aV1: TopoDS_Vertex, aP1: Quantity_AbsorbedDose, aV2: TopoDS_Vertex, aP2: Quantity_AbsorbedDose, aNewEdge: TopoDS_Edge): void;
  static MakeSectEdge(aIC: IntTools_Curve, aV1: TopoDS_Vertex, aP1: Quantity_AbsorbedDose, aV2: TopoDS_Vertex, aP2: Quantity_AbsorbedDose, aNewEdge: TopoDS_Edge): void;
  static ComputeState_1(thePoint: gp_Pnt, theSolid: TopoDS_Solid, theTol: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): TopAbs_State;
  static ComputeState_2(theVertex: TopoDS_Vertex, theSolid: TopoDS_Solid, theTol: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): TopAbs_State;
  static ComputeState_3(theEdge: TopoDS_Edge, theSolid: TopoDS_Solid, theTol: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): TopAbs_State;
  static ComputeState_4(theFace: TopoDS_Face, theSolid: TopoDS_Solid, theTol: Quantity_AbsorbedDose, theBounds: TopTools_IndexedMapOfShape, theContext: Handle_IntTools_Context): TopAbs_State;
  static ComputeStateByOnePoint(theShape: TopoDS_Shape, theSolid: TopoDS_Solid, theTol: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): TopAbs_State;
  static GetFaceOff(theEdge: TopoDS_Edge, theFace: TopoDS_Face, theLCEF: BOPTools_ListOfCoupleOfShape, theFaceOff: TopoDS_Face, theContext: Handle_IntTools_Context): Standard_Boolean;
  static IsInternalFace_1(theFace: TopoDS_Face, theEdge: TopoDS_Edge, theFace1: TopoDS_Face, theFace2: TopoDS_Face, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static IsInternalFace_2(theFace: TopoDS_Face, theEdge: TopoDS_Edge, theLF: TopTools_ListOfShape, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static IsInternalFace_3(theFace: TopoDS_Face, theSolid: TopoDS_Solid, theMEF: TopTools_IndexedDataMapOfShapeListOfShape, theTol: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): Standard_Boolean;
  static MakePCurve(theE: TopoDS_Edge, theF1: TopoDS_Face, theF2: TopoDS_Face, theCurve: IntTools_Curve, thePC1: Standard_Boolean, thePC2: Standard_Boolean, theContext: Handle_IntTools_Context): void;
  static IsHole(theW: TopoDS_Shape, theF: TopoDS_Shape): Standard_Boolean;
  static IsSplitToReverse_1(theSplit: TopoDS_Shape, theShape: TopoDS_Shape, theContext: Handle_IntTools_Context, theError: Graphic3d_ZLayerId): Standard_Boolean;
  static IsSplitToReverseWithWarn(theSplit: TopoDS_Shape, theShape: TopoDS_Shape, theContext: Handle_IntTools_Context, theReport: Handle_Message_Report): Standard_Boolean;
  static IsSplitToReverse_2(theSplit: TopoDS_Face, theShape: TopoDS_Face, theContext: Handle_IntTools_Context, theError: Graphic3d_ZLayerId): Standard_Boolean;
  static IsSplitToReverse_3(theSplit: TopoDS_Edge, theShape: TopoDS_Edge, theContext: Handle_IntTools_Context, theError: Graphic3d_ZLayerId): Standard_Boolean;
  static Sense(theF1: TopoDS_Face, theF2: TopoDS_Face, theContext: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static MakeConnexityBlock(theLS: TopTools_ListOfShape, theMapAvoid: TopTools_IndexedMapOfShape, theLSCB: TopTools_ListOfShape, theAllocator: Handle_NCollection_BaseAllocator): void;
  static MakeConnexityBlocks_1(theS: TopoDS_Shape, theConnectionType: TopAbs_ShapeEnum, theElementType: TopAbs_ShapeEnum, theLCB: TopTools_ListOfShape): void;
  static MakeConnexityBlocks_2(theS: TopoDS_Shape, theConnectionType: TopAbs_ShapeEnum, theElementType: TopAbs_ShapeEnum, theLCB: TopTools_ListOfListOfShape, theConnectionMap: TopTools_IndexedDataMapOfShapeListOfShape): void;
  static MakeConnexityBlocks_3(theLS: TopTools_ListOfShape, theConnectionType: TopAbs_ShapeEnum, theElementType: TopAbs_ShapeEnum, theLCB: BOPTools_ListOfConnexityBlock): void;
  static OrientEdgesOnWire(theWire: TopoDS_Shape): void;
  static OrientFacesOnShell(theShell: TopoDS_Shape): void;
  static CorrectTolerances(theS: TopoDS_Shape, theMapToAvoid: TopTools_IndexedMapOfShape, theTolMax: Quantity_AbsorbedDose, theRunParallel: Standard_Boolean): void;
  static CorrectCurveOnSurface(theS: TopoDS_Shape, theMapToAvoid: TopTools_IndexedMapOfShape, theTolMax: Quantity_AbsorbedDose, theRunParallel: Standard_Boolean): void;
  static CorrectPointOnCurve(theS: TopoDS_Shape, theMapToAvoid: TopTools_IndexedMapOfShape, theTolMax: Quantity_AbsorbedDose, theRunParallel: Standard_Boolean): void;
  static CorrectShapeTolerances(theS: TopoDS_Shape, theMapToAvoid: TopTools_IndexedMapOfShape, theRunParallel: Standard_Boolean): void;
  static AreFacesSameDomain(theF1: TopoDS_Face, theF2: TopoDS_Face, theContext: Handle_IntTools_Context, theFuzz: Quantity_AbsorbedDose): Standard_Boolean;
  static GetEdgeOff(theEdge: TopoDS_Edge, theFace: TopoDS_Face, theEdgeOff: TopoDS_Edge): Standard_Boolean;
  static GetEdgeOnFace(theEdge: TopoDS_Edge, theFace: TopoDS_Face, theEdgeOnF: TopoDS_Edge): Standard_Boolean;
  static CorrectRange_1(aE1: TopoDS_Edge, aE2: TopoDS_Edge, aSR: IntTools_Range, aNewSR: IntTools_Range): void;
  static CorrectRange_2(aE: TopoDS_Edge, aF: TopoDS_Face, aSR: IntTools_Range, aNewSR: IntTools_Range): void;
  static IsMicroEdge(theEdge: TopoDS_Edge, theContext: Handle_IntTools_Context, theCheckSplittable: Standard_Boolean): Standard_Boolean;
  static IsInvertedSolid(theSolid: TopoDS_Solid): Standard_Boolean;
  static ComputeTolerance(theFace: TopoDS_Face, theEdge: TopoDS_Edge, theMaxDist: Quantity_AbsorbedDose, theMaxPar: Quantity_AbsorbedDose): Standard_Boolean;
  static MakeContainer(theType: TopAbs_ShapeEnum, theShape: TopoDS_Shape): void;
  static PointOnEdge(aEdge: TopoDS_Edge, aPrm: Quantity_AbsorbedDose, aP: gp_Pnt): void;
  static IsBlockInOnFace(aShR: IntTools_Range, aF: TopoDS_Face, aE: TopoDS_Edge, aContext: Handle_IntTools_Context): Standard_Boolean;
  static Dimensions(theS: TopoDS_Shape, theDMin: Graphic3d_ZLayerId, theDMax: Graphic3d_ZLayerId): void;
  static Dimension(theS: TopoDS_Shape): Graphic3d_ZLayerId;
  static TreatCompound(theS: TopoDS_Shape, theList: TopTools_ListOfShape, theMap: TopTools_MapOfShape): void;
  static IsOpenShell(theShell: TopoDS_Shell): Standard_Boolean;
  delete(): void;
}

export declare class BOPTools_AlgoTools2D {
  constructor();
  static BuildPCurveForEdgeOnFace(aE: TopoDS_Edge, aF: TopoDS_Face, theContext: Handle_IntTools_Context): void;
  static EdgeTangent(anE: TopoDS_Edge, aT: Quantity_AbsorbedDose, Tau: gp_Vec): Standard_Boolean;
  static PointOnSurface(aE: TopoDS_Edge, aF: TopoDS_Face, aT: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, V: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): void;
  static CurveOnSurface_1(aE: TopoDS_Edge, aF: TopoDS_Face, aC: Handle_Geom2d_Curve, aToler: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): void;
  static CurveOnSurface_2(aE: TopoDS_Edge, aF: TopoDS_Face, aC: Handle_Geom2d_Curve, aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose, aToler: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): void;
  static HasCurveOnSurface_1(aE: TopoDS_Edge, aF: TopoDS_Face, aC: Handle_Geom2d_Curve, aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose, aToler: Quantity_AbsorbedDose): Standard_Boolean;
  static HasCurveOnSurface_2(aE: TopoDS_Edge, aF: TopoDS_Face): Standard_Boolean;
  static AdjustPCurveOnFace_1(theF: TopoDS_Face, theC3D: Handle_Geom_Curve, theC2D: Handle_Geom2d_Curve, theC2DA: Handle_Geom2d_Curve, theContext: Handle_IntTools_Context): void;
  static AdjustPCurveOnFace_2(theF: TopoDS_Face, theFirst: Quantity_AbsorbedDose, theLast: Quantity_AbsorbedDose, theC2D: Handle_Geom2d_Curve, theC2DA: Handle_Geom2d_Curve, theContext: Handle_IntTools_Context): void;
  static AdjustPCurveOnSurf(aF: BRepAdaptor_Surface, aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose, aC2D: Handle_Geom2d_Curve, aC2DA: Handle_Geom2d_Curve): void;
  static IntermediatePoint_1(aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  static IntermediatePoint_2(anE: TopoDS_Edge): Quantity_AbsorbedDose;
  static Make2D(aE: TopoDS_Edge, aF: TopoDS_Face, aC: Handle_Geom2d_Curve, aFirst: Quantity_AbsorbedDose, aLast: Quantity_AbsorbedDose, aToler: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): void;
  static MakePCurveOnFace_1(aF: TopoDS_Face, C3D: Handle_Geom_Curve, aC: Handle_Geom2d_Curve, aToler: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): void;
  static MakePCurveOnFace_2(aF: TopoDS_Face, C3D: Handle_Geom_Curve, aT1: Quantity_AbsorbedDose, aT2: Quantity_AbsorbedDose, aC: Handle_Geom2d_Curve, aToler: Quantity_AbsorbedDose, theContext: Handle_IntTools_Context): void;
  static AttachExistingPCurve(aEold: TopoDS_Edge, aEnew: TopoDS_Edge, aF: TopoDS_Face, aCtx: Handle_IntTools_Context): Graphic3d_ZLayerId;
  static IsEdgeIsoline(theE: TopoDS_Edge, theF: TopoDS_Face, isTheUIso: Standard_Boolean, isTheVIso: Standard_Boolean): void;
  delete(): void;
}

export declare class BOPTools_IndexedDataMapOfSetShape extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPTools_IndexedDataMapOfSetShape): void;
  Assign(theOther: BOPTools_IndexedDataMapOfSetShape): BOPTools_IndexedDataMapOfSetShape;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: BOPTools_Set, theItem: TopoDS_Shape): Standard_Integer;
  Contains(theKey1: BOPTools_Set): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: BOPTools_Set, theItem: TopoDS_Shape): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: BOPTools_Set): void;
  FindKey(theIndex: Standard_Integer): BOPTools_Set;
  FindFromIndex(theIndex: Standard_Integer): TopoDS_Shape;
  ChangeFromIndex(theIndex: Standard_Integer): TopoDS_Shape;
  FindIndex(theKey1: BOPTools_Set): Standard_Integer;
  ChangeFromKey(theKey1: BOPTools_Set): TopoDS_Shape;
  Seek(theKey1: BOPTools_Set): TopoDS_Shape;
  ChangeSeek(theKey1: BOPTools_Set): TopoDS_Shape;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class BOPTools_IndexedDataMapOfSetShape_1 extends BOPTools_IndexedDataMapOfSetShape {
    constructor();
  }

  export declare class BOPTools_IndexedDataMapOfSetShape_2 extends BOPTools_IndexedDataMapOfSetShape {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPTools_IndexedDataMapOfSetShape_3 extends BOPTools_IndexedDataMapOfSetShape {
    constructor(theOther: BOPTools_IndexedDataMapOfSetShape);
  }

export declare class BOPTools_ListOfCoupleOfShape extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: BOPTools_ListOfCoupleOfShape): BOPTools_ListOfCoupleOfShape;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): BOPTools_CoupleOfShape;
  First_2(): BOPTools_CoupleOfShape;
  Last_1(): BOPTools_CoupleOfShape;
  Last_2(): BOPTools_CoupleOfShape;
  Append_1(theItem: BOPTools_CoupleOfShape): BOPTools_CoupleOfShape;
  Append_3(theOther: BOPTools_ListOfCoupleOfShape): void;
  Prepend_1(theItem: BOPTools_CoupleOfShape): BOPTools_CoupleOfShape;
  Prepend_2(theOther: BOPTools_ListOfCoupleOfShape): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class BOPTools_ListOfCoupleOfShape_1 extends BOPTools_ListOfCoupleOfShape {
    constructor();
  }

  export declare class BOPTools_ListOfCoupleOfShape_2 extends BOPTools_ListOfCoupleOfShape {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPTools_ListOfCoupleOfShape_3 extends BOPTools_ListOfCoupleOfShape {
    constructor(theOther: BOPTools_ListOfCoupleOfShape);
  }

export declare class BOPTools_CoupleOfShape {
  constructor()
  SetShape1(theShape: TopoDS_Shape): void;
  Shape1(): TopoDS_Shape;
  SetShape2(theShape: TopoDS_Shape): void;
  Shape2(): TopoDS_Shape;
  delete(): void;
}

export declare class BOPTools_Set {
  Assign(Other: BOPTools_Set): BOPTools_Set;
  Shape(): TopoDS_Shape;
  Add(theS: TopoDS_Shape, theType: TopAbs_ShapeEnum): void;
  NbShapes(): Graphic3d_ZLayerId;
  IsEqual(aOther: BOPTools_Set): Standard_Boolean;
  HashCode(theUpperBound: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  delete(): void;
}

  export declare class BOPTools_Set_1 extends BOPTools_Set {
    constructor();
  }

  export declare class BOPTools_Set_2 extends BOPTools_Set {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPTools_Set_3 extends BOPTools_Set {
    constructor(theOther: BOPTools_Set);
  }

export declare class BOPTools_MapOfSet extends NCollection_BaseMap {
  cbegin(): any;
  cend(): any;
  Exchange(theOther: BOPTools_MapOfSet): void;
  Assign(theOther: BOPTools_MapOfSet): BOPTools_MapOfSet;
  ReSize(N: Standard_Integer): void;
  Add(K: BOPTools_Set): Standard_Boolean;
  Added(K: BOPTools_Set): BOPTools_Set;
  Contains_1(K: BOPTools_Set): Standard_Boolean;
  Remove(K: BOPTools_Set): Standard_Boolean;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  IsEqual(theOther: BOPTools_MapOfSet): Standard_Boolean;
  Contains_2(theOther: BOPTools_MapOfSet): Standard_Boolean;
  Union(theLeft: BOPTools_MapOfSet, theRight: BOPTools_MapOfSet): void;
  Unite(theOther: BOPTools_MapOfSet): Standard_Boolean;
  HasIntersection(theMap: BOPTools_MapOfSet): Standard_Boolean;
  Intersection(theLeft: BOPTools_MapOfSet, theRight: BOPTools_MapOfSet): void;
  Intersect(theOther: BOPTools_MapOfSet): Standard_Boolean;
  Subtraction(theLeft: BOPTools_MapOfSet, theRight: BOPTools_MapOfSet): void;
  Subtract(theOther: BOPTools_MapOfSet): Standard_Boolean;
  Difference(theLeft: BOPTools_MapOfSet, theRight: BOPTools_MapOfSet): void;
  Differ(theOther: BOPTools_MapOfSet): Standard_Boolean;
  delete(): void;
}

  export declare class BOPTools_MapOfSet_1 extends BOPTools_MapOfSet {
    constructor();
  }

  export declare class BOPTools_MapOfSet_2 extends BOPTools_MapOfSet {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class BOPTools_MapOfSet_3 extends BOPTools_MapOfSet {
    constructor(theOther: BOPTools_MapOfSet);
  }

export declare class BOPTools_ConnexityBlock {
  Shapes(): TopTools_ListOfShape;
  ChangeShapes(): TopTools_ListOfShape;
  SetRegular(theFlag: Standard_Boolean): void;
  IsRegular(): Standard_Boolean;
  Loops(): TopTools_ListOfShape;
  ChangeLoops(): TopTools_ListOfShape;
  delete(): void;
}

  export declare class BOPTools_ConnexityBlock_1 extends BOPTools_ConnexityBlock {
    constructor();
  }

  export declare class BOPTools_ConnexityBlock_2 extends BOPTools_ConnexityBlock {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

export declare class ChFiDS_FaceInterference {
  constructor()
  SetInterference(LineIndex: Graphic3d_ZLayerId, Trans: TopAbs_Orientation, PCurv1: Handle_Geom2d_Curve, PCurv2: Handle_Geom2d_Curve): void;
  SetTransition(Trans: TopAbs_Orientation): void;
  SetFirstParameter(U1: Quantity_AbsorbedDose): void;
  SetLastParameter(U1: Quantity_AbsorbedDose): void;
  SetParameter(U1: Quantity_AbsorbedDose, IsFirst: Standard_Boolean): void;
  LineIndex(): Graphic3d_ZLayerId;
  SetLineIndex(I: Graphic3d_ZLayerId): void;
  Transition(): TopAbs_Orientation;
  PCurveOnFace(): Handle_Geom2d_Curve;
  PCurveOnSurf(): Handle_Geom2d_Curve;
  ChangePCurveOnFace(): Handle_Geom2d_Curve;
  ChangePCurveOnSurf(): Handle_Geom2d_Curve;
  FirstParameter(): Quantity_AbsorbedDose;
  LastParameter(): Quantity_AbsorbedDose;
  Parameter(IsFirst: Standard_Boolean): Quantity_AbsorbedDose;
  delete(): void;
}

export declare class Handle_ChFiDS_ChamfSpine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_ChamfSpine): void;
  get(): ChFiDS_ChamfSpine;
  delete(): void;
}

  export declare class Handle_ChFiDS_ChamfSpine_1 extends Handle_ChFiDS_ChamfSpine {
    constructor();
  }

  export declare class Handle_ChFiDS_ChamfSpine_2 extends Handle_ChFiDS_ChamfSpine {
    constructor(thePtr: ChFiDS_ChamfSpine);
  }

  export declare class Handle_ChFiDS_ChamfSpine_3 extends Handle_ChFiDS_ChamfSpine {
    constructor(theHandle: Handle_ChFiDS_ChamfSpine);
  }

  export declare class Handle_ChFiDS_ChamfSpine_4 extends Handle_ChFiDS_ChamfSpine {
    constructor(theHandle: Handle_ChFiDS_ChamfSpine);
  }

export declare class ChFiDS_ChamfSpine extends ChFiDS_Spine {
  SetDist(Dis: Quantity_AbsorbedDose): void;
  GetDist(Dis: Quantity_AbsorbedDose): void;
  SetDists(Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose): void;
  Dists(Dis1: Quantity_AbsorbedDose, Dis2: Quantity_AbsorbedDose): void;
  GetDistAngle(Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose): void;
  SetDistAngle(Dis: Quantity_AbsorbedDose, Angle: Quantity_AbsorbedDose): void;
  SetMode(theMode: ChFiDS_ChamfMode): void;
  IsChamfer(): ChFiDS_ChamfMethod;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ChFiDS_ChamfSpine_1 extends ChFiDS_ChamfSpine {
    constructor();
  }

  export declare class ChFiDS_ChamfSpine_2 extends ChFiDS_ChamfSpine {
    constructor(Tol: Quantity_AbsorbedDose);
  }

export declare class Handle_ChFiDS_HElSpine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_HElSpine): void;
  get(): ChFiDS_HElSpine;
  delete(): void;
}

  export declare class Handle_ChFiDS_HElSpine_1 extends Handle_ChFiDS_HElSpine {
    constructor();
  }

  export declare class Handle_ChFiDS_HElSpine_2 extends Handle_ChFiDS_HElSpine {
    constructor(thePtr: ChFiDS_HElSpine);
  }

  export declare class Handle_ChFiDS_HElSpine_3 extends Handle_ChFiDS_HElSpine {
    constructor(theHandle: Handle_ChFiDS_HElSpine);
  }

  export declare class Handle_ChFiDS_HElSpine_4 extends Handle_ChFiDS_HElSpine {
    constructor(theHandle: Handle_ChFiDS_HElSpine);
  }

export declare class ChFiDS_HElSpine extends Adaptor3d_HCurve {
  Set(C: ChFiDS_ElSpine): void;
  Curve(): Adaptor3d_Curve;
  GetCurve(): Adaptor3d_Curve;
  ChangeCurve(): ChFiDS_ElSpine;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ChFiDS_HElSpine_1 extends ChFiDS_HElSpine {
    constructor();
  }

  export declare class ChFiDS_HElSpine_2 extends ChFiDS_HElSpine {
    constructor(C: ChFiDS_ElSpine);
  }

export declare type ChFiDS_ChamfMethod = {
  ChFiDS_Sym: {};
  ChFiDS_TwoDist: {};
  ChFiDS_DistAngle: {};
}

export declare class ChFiDS_IndexedDataMapOfVertexListOfStripe extends NCollection_BaseMap {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Exchange(theOther: ChFiDS_IndexedDataMapOfVertexListOfStripe): void;
  Assign(theOther: ChFiDS_IndexedDataMapOfVertexListOfStripe): ChFiDS_IndexedDataMapOfVertexListOfStripe;
  ReSize(N: Standard_Integer): void;
  Add(theKey1: TopoDS_Vertex, theItem: ChFiDS_ListOfStripe): Standard_Integer;
  Contains(theKey1: TopoDS_Vertex): Standard_Boolean;
  Substitute(theIndex: Standard_Integer, theKey1: TopoDS_Vertex, theItem: ChFiDS_ListOfStripe): void;
  Swap(theIndex1: Standard_Integer, theIndex2: Standard_Integer): void;
  RemoveLast(): void;
  RemoveFromIndex(theIndex: Standard_Integer): void;
  RemoveKey(theKey1: TopoDS_Vertex): void;
  FindKey(theIndex: Standard_Integer): TopoDS_Vertex;
  FindFromIndex(theIndex: Standard_Integer): ChFiDS_ListOfStripe;
  ChangeFromIndex(theIndex: Standard_Integer): ChFiDS_ListOfStripe;
  FindIndex(theKey1: TopoDS_Vertex): Standard_Integer;
  ChangeFromKey(theKey1: TopoDS_Vertex): ChFiDS_ListOfStripe;
  Seek(theKey1: TopoDS_Vertex): ChFiDS_ListOfStripe;
  ChangeSeek(theKey1: TopoDS_Vertex): ChFiDS_ListOfStripe;
  Clear_1(doReleaseMemory: Standard_Boolean): void;
  Clear_2(theAllocator: Handle_NCollection_BaseAllocator): void;
  Size(): Standard_Integer;
  delete(): void;
}

  export declare class ChFiDS_IndexedDataMapOfVertexListOfStripe_1 extends ChFiDS_IndexedDataMapOfVertexListOfStripe {
    constructor();
  }

  export declare class ChFiDS_IndexedDataMapOfVertexListOfStripe_2 extends ChFiDS_IndexedDataMapOfVertexListOfStripe {
    constructor(theNbBuckets: Standard_Integer, theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class ChFiDS_IndexedDataMapOfVertexListOfStripe_3 extends ChFiDS_IndexedDataMapOfVertexListOfStripe {
    constructor(theOther: ChFiDS_IndexedDataMapOfVertexListOfStripe);
  }

export declare class ChFiDS_ElSpine extends Adaptor3d_Curve {
  constructor()
  FirstParameter_1(): Quantity_AbsorbedDose;
  LastParameter_1(): Quantity_AbsorbedDose;
  GetSavedFirstParameter(): Quantity_AbsorbedDose;
  GetSavedLastParameter(): Quantity_AbsorbedDose;
  Continuity(): GeomAbs_Shape;
  NbIntervals(S: GeomAbs_Shape): Graphic3d_ZLayerId;
  Intervals(T: TColStd_Array1OfReal, S: GeomAbs_Shape): void;
  Trim(First: Quantity_AbsorbedDose, Last: Quantity_AbsorbedDose, Tol: Quantity_AbsorbedDose): Handle_Adaptor3d_HCurve;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  GetType(): GeomAbs_CurveType;
  IsPeriodic(): Standard_Boolean;
  SetPeriodic(I: Standard_Boolean): void;
  Period(): Quantity_AbsorbedDose;
  Value(AbsC: Quantity_AbsorbedDose): gp_Pnt;
  D0(AbsC: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(AbsC: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(AbsC: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  D3(AbsC: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec, V3: gp_Vec): void;
  FirstParameter_2(P: Quantity_AbsorbedDose): void;
  LastParameter_2(P: Quantity_AbsorbedDose): void;
  SaveFirstParameter(): void;
  SaveLastParameter(): void;
  SetOrigin(O: Quantity_AbsorbedDose): void;
  FirstPointAndTgt(P: gp_Pnt, T: gp_Vec): void;
  LastPointAndTgt(P: gp_Pnt, T: gp_Vec): void;
  NbVertices(): Graphic3d_ZLayerId;
  VertexWithTangent(Index: Graphic3d_ZLayerId): gp_Ax1;
  SetFirstPointAndTgt(P: gp_Pnt, T: gp_Vec): void;
  SetLastPointAndTgt(P: gp_Pnt, T: gp_Vec): void;
  AddVertexWithTangent(anAx1: gp_Ax1): void;
  SetCurve(C: Handle_Geom_Curve): void;
  Previous(): Handle_ChFiDS_SurfData;
  ChangePrevious(): Handle_ChFiDS_SurfData;
  Next(): Handle_ChFiDS_SurfData;
  ChangeNext(): Handle_ChFiDS_SurfData;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  Ellipse(): gp_Elips;
  Hyperbola(): gp_Hypr;
  Parabola(): gp_Parab;
  Bezier(): Handle_Geom_BezierCurve;
  BSpline(): Handle_Geom_BSplineCurve;
  delete(): void;
}

export declare class Handle_ChFiDS_Spine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_Spine): void;
  get(): ChFiDS_Spine;
  delete(): void;
}

  export declare class Handle_ChFiDS_Spine_1 extends Handle_ChFiDS_Spine {
    constructor();
  }

  export declare class Handle_ChFiDS_Spine_2 extends Handle_ChFiDS_Spine {
    constructor(thePtr: ChFiDS_Spine);
  }

  export declare class Handle_ChFiDS_Spine_3 extends Handle_ChFiDS_Spine {
    constructor(theHandle: Handle_ChFiDS_Spine);
  }

  export declare class Handle_ChFiDS_Spine_4 extends Handle_ChFiDS_Spine {
    constructor(theHandle: Handle_ChFiDS_Spine);
  }

export declare class ChFiDS_Spine extends Standard_Transient {
  SetEdges(E: TopoDS_Edge): void;
  SetOffsetEdges(E: TopoDS_Edge): void;
  PutInFirst(E: TopoDS_Edge): void;
  PutInFirstOffset(E: TopoDS_Edge): void;
  NbEdges(): Graphic3d_ZLayerId;
  Edges(I: Graphic3d_ZLayerId): TopoDS_Edge;
  OffsetEdges(I: Graphic3d_ZLayerId): TopoDS_Edge;
  SetFirstStatus(S: ChFiDS_State): void;
  SetLastStatus(S: ChFiDS_State): void;
  AppendElSpine(Els: Handle_ChFiDS_HElSpine): void;
  AppendOffsetElSpine(Els: Handle_ChFiDS_HElSpine): void;
  ElSpine_1(IE: Graphic3d_ZLayerId): Handle_ChFiDS_HElSpine;
  ElSpine_2(E: TopoDS_Edge): Handle_ChFiDS_HElSpine;
  ElSpine_3(W: Quantity_AbsorbedDose): Handle_ChFiDS_HElSpine;
  ChangeElSpines(): ChFiDS_ListOfHElSpine;
  ChangeOffsetElSpines(): ChFiDS_ListOfHElSpine;
  Reset(AllData: Standard_Boolean): void;
  SplitDone_1(): Standard_Boolean;
  SplitDone_2(B: Standard_Boolean): void;
  Load(): void;
  Resolution(R3d: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  IsClosed(): Standard_Boolean;
  FirstParameter_1(): Quantity_AbsorbedDose;
  LastParameter_1(): Quantity_AbsorbedDose;
  SetFirstParameter(Par: Quantity_AbsorbedDose): void;
  SetLastParameter(Par: Quantity_AbsorbedDose): void;
  FirstParameter_2(IndexSpine: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  LastParameter_2(IndexSpine: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Length(IndexSpine: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  IsPeriodic(): Standard_Boolean;
  Period(): Quantity_AbsorbedDose;
  Absc_1(U: Quantity_AbsorbedDose): Quantity_AbsorbedDose;
  Absc_2(U: Quantity_AbsorbedDose, I: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Parameter_1(AbsC: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, Oriented: Standard_Boolean): void;
  Parameter_2(Index: Graphic3d_ZLayerId, AbsC: Quantity_AbsorbedDose, U: Quantity_AbsorbedDose, Oriented: Standard_Boolean): void;
  Value(AbsC: Quantity_AbsorbedDose): gp_Pnt;
  D0(AbsC: Quantity_AbsorbedDose, P: gp_Pnt): void;
  D1(AbsC: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec): void;
  D2(AbsC: Quantity_AbsorbedDose, P: gp_Pnt, V1: gp_Vec, V2: gp_Vec): void;
  SetCurrent(Index: Graphic3d_ZLayerId): void;
  CurrentElementarySpine(Index: Graphic3d_ZLayerId): BRepAdaptor_Curve;
  CurrentIndexOfElementarySpine(): Graphic3d_ZLayerId;
  GetType(): GeomAbs_CurveType;
  Line(): gp_Lin;
  Circle(): gp_Circ;
  FirstStatus(): ChFiDS_State;
  LastStatus(): ChFiDS_State;
  Status(IsFirst: Standard_Boolean): ChFiDS_State;
  GetTypeOfConcavity(): ChFiDS_TypeOfConcavity;
  SetStatus(S: ChFiDS_State, IsFirst: Standard_Boolean): void;
  SetTypeOfConcavity(theType: ChFiDS_TypeOfConcavity): void;
  IsTangencyExtremity(IsFirst: Standard_Boolean): Standard_Boolean;
  SetTangencyExtremity(IsTangency: Standard_Boolean, IsFirst: Standard_Boolean): void;
  Absc_3(V: TopoDS_Vertex): Quantity_AbsorbedDose;
  FirstVertex(): TopoDS_Vertex;
  LastVertex(): TopoDS_Vertex;
  SetFirstTgt(W: Quantity_AbsorbedDose): void;
  SetLastTgt(W: Quantity_AbsorbedDose): void;
  HasFirstTgt(): Standard_Boolean;
  HasLastTgt(): Standard_Boolean;
  SetReference_1(W: Quantity_AbsorbedDose): void;
  SetReference_2(I: Graphic3d_ZLayerId): void;
  Index_1(W: Quantity_AbsorbedDose, Forward: Standard_Boolean): Graphic3d_ZLayerId;
  Index_2(E: TopoDS_Edge): Graphic3d_ZLayerId;
  UnsetReference(): void;
  SetErrorStatus(state: ChFiDS_ErrorStatus): void;
  ErrorStatus(): ChFiDS_ErrorStatus;
  Mode(): ChFiDS_ChamfMode;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ChFiDS_Spine_1 extends ChFiDS_Spine {
    constructor();
  }

  export declare class ChFiDS_Spine_2 extends ChFiDS_Spine {
    constructor(Tol: Quantity_AbsorbedDose);
  }

export declare type ChFiDS_ChamfMode = {
  ChFiDS_ClassicChamfer: {};
  ChFiDS_ConstThroatChamfer: {};
  ChFiDS_ConstThroatWithPenetrationChamfer: {};
}

export declare type ChFiDS_State = {
  ChFiDS_OnSame: {};
  ChFiDS_OnDiff: {};
  ChFiDS_AllSame: {};
  ChFiDS_BreakPoint: {};
  ChFiDS_FreeBoundary: {};
  ChFiDS_Closed: {};
  ChFiDS_Tangent: {};
}

export declare class ChFiDS_Map {
  constructor()
  Fill(S: TopoDS_Shape, T1: TopAbs_ShapeEnum, T2: TopAbs_ShapeEnum): void;
  Contains(S: TopoDS_Shape): Standard_Boolean;
  FindFromKey(S: TopoDS_Shape): TopTools_ListOfShape;
  FindFromIndex(I: Graphic3d_ZLayerId): TopTools_ListOfShape;
  delete(): void;
}

export declare type ChFiDS_ErrorStatus = {
  ChFiDS_Ok: {};
  ChFiDS_Error: {};
  ChFiDS_WalkingFailure: {};
  ChFiDS_StartsolFailure: {};
  ChFiDS_TwistedSurface: {};
}

export declare class Handle_ChFiDS_FilSpine {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_FilSpine): void;
  get(): ChFiDS_FilSpine;
  delete(): void;
}

  export declare class Handle_ChFiDS_FilSpine_1 extends Handle_ChFiDS_FilSpine {
    constructor();
  }

  export declare class Handle_ChFiDS_FilSpine_2 extends Handle_ChFiDS_FilSpine {
    constructor(thePtr: ChFiDS_FilSpine);
  }

  export declare class Handle_ChFiDS_FilSpine_3 extends Handle_ChFiDS_FilSpine {
    constructor(theHandle: Handle_ChFiDS_FilSpine);
  }

  export declare class Handle_ChFiDS_FilSpine_4 extends Handle_ChFiDS_FilSpine {
    constructor(theHandle: Handle_ChFiDS_FilSpine);
  }

export declare class ChFiDS_FilSpine extends ChFiDS_Spine {
  Reset(AllData: Standard_Boolean): void;
  SetRadius_1(Radius: Quantity_AbsorbedDose, E: TopoDS_Edge): void;
  UnSetRadius_1(E: TopoDS_Edge): void;
  SetRadius_2(Radius: Quantity_AbsorbedDose, V: TopoDS_Vertex): void;
  UnSetRadius_2(V: TopoDS_Vertex): void;
  SetRadius_3(UandR: gp_XY, IinC: Graphic3d_ZLayerId): void;
  SetRadius_4(Radius: Quantity_AbsorbedDose): void;
  SetRadius_5(C: Handle_Law_Function, IinC: Graphic3d_ZLayerId): void;
  IsConstant_1(): Standard_Boolean;
  IsConstant_2(IE: Graphic3d_ZLayerId): Standard_Boolean;
  Radius_1(): Quantity_AbsorbedDose;
  Radius_2(IE: Graphic3d_ZLayerId): Quantity_AbsorbedDose;
  Radius_3(E: TopoDS_Edge): Quantity_AbsorbedDose;
  AppendElSpine(Els: Handle_ChFiDS_HElSpine): void;
  Law(Els: Handle_ChFiDS_HElSpine): Handle_Law_Composite;
  ChangeLaw(E: TopoDS_Edge): Handle_Law_Function;
  MaxRadFromSeqAndLaws(): Quantity_AbsorbedDose;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

  export declare class ChFiDS_FilSpine_1 extends ChFiDS_FilSpine {
    constructor();
  }

  export declare class ChFiDS_FilSpine_2 extends ChFiDS_FilSpine {
    constructor(Tol: Quantity_AbsorbedDose);
  }

export declare class ChFiDS_CommonPoint {
  constructor()
  Reset(): void;
  SetVertex(theVertex: TopoDS_Vertex): void;
  SetArc(Tol: Quantity_AbsorbedDose, A: TopoDS_Edge, Param: Quantity_AbsorbedDose, TArc: TopAbs_Orientation): void;
  SetParameter(Param: Quantity_AbsorbedDose): void;
  SetPoint(thePoint: gp_Pnt): void;
  SetVector(theVector: gp_Vec): void;
  SetTolerance(Tol: Quantity_AbsorbedDose): void;
  Tolerance(): Quantity_AbsorbedDose;
  IsVertex(): Standard_Boolean;
  Vertex(): TopoDS_Vertex;
  IsOnArc(): Standard_Boolean;
  Arc(): TopoDS_Edge;
  TransitionOnArc(): TopAbs_Orientation;
  ParameterOnArc(): Quantity_AbsorbedDose;
  Parameter(): Quantity_AbsorbedDose;
  Point(): gp_Pnt;
  HasVector(): Standard_Boolean;
  Vector(): gp_Vec;
  delete(): void;
}

export declare type ChFiDS_TypeOfConcavity = {
  ChFiDS_Concave: {};
  ChFiDS_Convex: {};
  ChFiDS_Tangential: {};
  ChFiDS_FreeBound: {};
  ChFiDS_Other: {};
}

export declare class ChFiDS_SurfData extends Standard_Transient {
  constructor()
  Copy(Other: Handle_ChFiDS_SurfData): void;
  IndexOfS1(): Graphic3d_ZLayerId;
  IndexOfS2(): Graphic3d_ZLayerId;
  IsOnCurve1(): Standard_Boolean;
  IsOnCurve2(): Standard_Boolean;
  IndexOfC1(): Graphic3d_ZLayerId;
  IndexOfC2(): Graphic3d_ZLayerId;
  Surf(): Graphic3d_ZLayerId;
  Orientation(): TopAbs_Orientation;
  InterferenceOnS1(): ChFiDS_FaceInterference;
  InterferenceOnS2(): ChFiDS_FaceInterference;
  VertexFirstOnS1(): ChFiDS_CommonPoint;
  VertexFirstOnS2(): ChFiDS_CommonPoint;
  VertexLastOnS1(): ChFiDS_CommonPoint;
  VertexLastOnS2(): ChFiDS_CommonPoint;
  ChangeIndexOfS1(Index: Graphic3d_ZLayerId): void;
  ChangeIndexOfS2(Index: Graphic3d_ZLayerId): void;
  ChangeSurf(Index: Graphic3d_ZLayerId): void;
  SetIndexOfC1(Index: Graphic3d_ZLayerId): void;
  SetIndexOfC2(Index: Graphic3d_ZLayerId): void;
  ChangeOrientation(): TopAbs_Orientation;
  ChangeInterferenceOnS1(): ChFiDS_FaceInterference;
  ChangeInterferenceOnS2(): ChFiDS_FaceInterference;
  ChangeVertexFirstOnS1(): ChFiDS_CommonPoint;
  ChangeVertexFirstOnS2(): ChFiDS_CommonPoint;
  ChangeVertexLastOnS1(): ChFiDS_CommonPoint;
  ChangeVertexLastOnS2(): ChFiDS_CommonPoint;
  Interference(OnS: Graphic3d_ZLayerId): ChFiDS_FaceInterference;
  ChangeInterference(OnS: Graphic3d_ZLayerId): ChFiDS_FaceInterference;
  Index(OfS: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  Vertex(First: Standard_Boolean, OnS: Graphic3d_ZLayerId): ChFiDS_CommonPoint;
  ChangeVertex(First: Standard_Boolean, OnS: Graphic3d_ZLayerId): ChFiDS_CommonPoint;
  IsOnCurve(OnS: Graphic3d_ZLayerId): Standard_Boolean;
  IndexOfC(OnS: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  FirstSpineParam_1(): Quantity_AbsorbedDose;
  LastSpineParam_1(): Quantity_AbsorbedDose;
  FirstSpineParam_2(Par: Quantity_AbsorbedDose): void;
  LastSpineParam_2(Par: Quantity_AbsorbedDose): void;
  FirstExtensionValue_1(): Quantity_AbsorbedDose;
  LastExtensionValue_1(): Quantity_AbsorbedDose;
  FirstExtensionValue_2(Extend: Quantity_AbsorbedDose): void;
  LastExtensionValue_2(Extend: Quantity_AbsorbedDose): void;
  Simul(): Handle_Standard_Transient;
  SetSimul(S: Handle_Standard_Transient): void;
  ResetSimul(): void;
  Get2dPoints_1(First: Standard_Boolean, OnS: Graphic3d_ZLayerId): gp_Pnt2d;
  Get2dPoints_2(P2df1: gp_Pnt2d, P2dl1: gp_Pnt2d, P2df2: gp_Pnt2d, P2dl2: gp_Pnt2d): void;
  Set2dPoints(P2df1: gp_Pnt2d, P2dl1: gp_Pnt2d, P2df2: gp_Pnt2d, P2dl2: gp_Pnt2d): void;
  TwistOnS1_1(): Standard_Boolean;
  TwistOnS2_1(): Standard_Boolean;
  TwistOnS1_2(T: Standard_Boolean): void;
  TwistOnS2_2(T: Standard_Boolean): void;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class Handle_ChFiDS_SurfData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_SurfData): void;
  get(): ChFiDS_SurfData;
  delete(): void;
}

  export declare class Handle_ChFiDS_SurfData_1 extends Handle_ChFiDS_SurfData {
    constructor();
  }

  export declare class Handle_ChFiDS_SurfData_2 extends Handle_ChFiDS_SurfData {
    constructor(thePtr: ChFiDS_SurfData);
  }

  export declare class Handle_ChFiDS_SurfData_3 extends Handle_ChFiDS_SurfData {
    constructor(theHandle: Handle_ChFiDS_SurfData);
  }

  export declare class Handle_ChFiDS_SurfData_4 extends Handle_ChFiDS_SurfData {
    constructor(theHandle: Handle_ChFiDS_SurfData);
  }

export declare class ChFiDS_StripeMap {
  constructor()
  Add(V: TopoDS_Vertex, F: Handle_ChFiDS_Stripe): void;
  Extent(): Graphic3d_ZLayerId;
  FindFromKey(V: TopoDS_Vertex): ChFiDS_ListOfStripe;
  FindFromIndex(I: Graphic3d_ZLayerId): ChFiDS_ListOfStripe;
  FindKey(I: Graphic3d_ZLayerId): TopoDS_Vertex;
  Clear(): void;
  delete(): void;
}

export declare class ChFiDS_SecArray1 {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Init(theValue: ChFiDS_CircSection): void;
  Size(): Standard_Integer;
  Length(): Standard_Integer;
  IsEmpty(): Standard_Boolean;
  Lower(): Standard_Integer;
  Upper(): Standard_Integer;
  IsDeletable(): Standard_Boolean;
  IsAllocated(): Standard_Boolean;
  Assign(theOther: ChFiDS_SecArray1): ChFiDS_SecArray1;
  Move(theOther: ChFiDS_SecArray1): ChFiDS_SecArray1;
  First(): ChFiDS_CircSection;
  ChangeFirst(): ChFiDS_CircSection;
  Last(): ChFiDS_CircSection;
  ChangeLast(): ChFiDS_CircSection;
  Value(theIndex: Standard_Integer): ChFiDS_CircSection;
  ChangeValue(theIndex: Standard_Integer): ChFiDS_CircSection;
  SetValue(theIndex: Standard_Integer, theItem: ChFiDS_CircSection): void;
  Resize(theLower: Standard_Integer, theUpper: Standard_Integer, theToCopyData: Standard_Boolean): void;
  delete(): void;
}

  export declare class ChFiDS_SecArray1_1 extends ChFiDS_SecArray1 {
    constructor();
  }

  export declare class ChFiDS_SecArray1_2 extends ChFiDS_SecArray1 {
    constructor(theLower: Standard_Integer, theUpper: Standard_Integer);
  }

  export declare class ChFiDS_SecArray1_3 extends ChFiDS_SecArray1 {
    constructor(theOther: ChFiDS_SecArray1);
  }

  export declare class ChFiDS_SecArray1_4 extends ChFiDS_SecArray1 {
    constructor(theOther: ChFiDS_SecArray1);
  }

  export declare class ChFiDS_SecArray1_5 extends ChFiDS_SecArray1 {
    constructor(theBegin: ChFiDS_CircSection, theLower: Standard_Integer, theUpper: Standard_Integer);
  }

export declare class Handle_ChFiDS_SecHArray1 {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_SecHArray1): void;
  get(): ChFiDS_SecHArray1;
  delete(): void;
}

  export declare class Handle_ChFiDS_SecHArray1_1 extends Handle_ChFiDS_SecHArray1 {
    constructor();
  }

  export declare class Handle_ChFiDS_SecHArray1_2 extends Handle_ChFiDS_SecHArray1 {
    constructor(thePtr: ChFiDS_SecHArray1);
  }

  export declare class Handle_ChFiDS_SecHArray1_3 extends Handle_ChFiDS_SecHArray1 {
    constructor(theHandle: Handle_ChFiDS_SecHArray1);
  }

  export declare class Handle_ChFiDS_SecHArray1_4 extends Handle_ChFiDS_SecHArray1 {
    constructor(theHandle: Handle_ChFiDS_SecHArray1);
  }

export declare class ChFiDS_Regul {
  constructor()
  SetCurve(IC: Graphic3d_ZLayerId): void;
  SetS1(IS1: Graphic3d_ZLayerId, IsFace: Standard_Boolean): void;
  SetS2(IS2: Graphic3d_ZLayerId, IsFace: Standard_Boolean): void;
  IsSurface1(): Standard_Boolean;
  IsSurface2(): Standard_Boolean;
  Curve(): Graphic3d_ZLayerId;
  S1(): Graphic3d_ZLayerId;
  S2(): Graphic3d_ZLayerId;
  delete(): void;
}

export declare class ChFiDS_Regularities extends NCollection_BaseList {
  begin(): any;
  end(): any;
  cbegin(): any;
  cend(): any;
  Size(): Standard_Integer;
  Assign(theOther: ChFiDS_Regularities): ChFiDS_Regularities;
  Clear(theAllocator: Handle_NCollection_BaseAllocator): void;
  First_1(): ChFiDS_Regul;
  First_2(): ChFiDS_Regul;
  Last_1(): ChFiDS_Regul;
  Last_2(): ChFiDS_Regul;
  Append_1(theItem: ChFiDS_Regul): ChFiDS_Regul;
  Append_3(theOther: ChFiDS_Regularities): void;
  Prepend_1(theItem: ChFiDS_Regul): ChFiDS_Regul;
  Prepend_2(theOther: ChFiDS_Regularities): void;
  RemoveFirst(): void;
  Reverse(): void;
  delete(): void;
}

  export declare class ChFiDS_Regularities_1 extends ChFiDS_Regularities {
    constructor();
  }

  export declare class ChFiDS_Regularities_2 extends ChFiDS_Regularities {
    constructor(theAllocator: Handle_NCollection_BaseAllocator);
  }

  export declare class ChFiDS_Regularities_3 extends ChFiDS_Regularities {
    constructor(theOther: ChFiDS_Regularities);
  }

export declare class Handle_ChFiDS_HData {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_HData): void;
  get(): ChFiDS_HData;
  delete(): void;
}

  export declare class Handle_ChFiDS_HData_1 extends Handle_ChFiDS_HData {
    constructor();
  }

  export declare class Handle_ChFiDS_HData_2 extends Handle_ChFiDS_HData {
    constructor(thePtr: ChFiDS_HData);
  }

  export declare class Handle_ChFiDS_HData_3 extends Handle_ChFiDS_HData {
    constructor(theHandle: Handle_ChFiDS_HData);
  }

  export declare class Handle_ChFiDS_HData_4 extends Handle_ChFiDS_HData {
    constructor(theHandle: Handle_ChFiDS_HData);
  }

export declare class Handle_ChFiDS_Stripe {
  Nullify(): void;
  IsNull(): boolean;
  reset(thePtr: ChFiDS_Stripe): void;
  get(): ChFiDS_Stripe;
  delete(): void;
}

  export declare class Handle_ChFiDS_Stripe_1 extends Handle_ChFiDS_Stripe {
    constructor();
  }

  export declare class Handle_ChFiDS_Stripe_2 extends Handle_ChFiDS_Stripe {
    constructor(thePtr: ChFiDS_Stripe);
  }

  export declare class Handle_ChFiDS_Stripe_3 extends Handle_ChFiDS_Stripe {
    constructor(theHandle: Handle_ChFiDS_Stripe);
  }

  export declare class Handle_ChFiDS_Stripe_4 extends Handle_ChFiDS_Stripe {
    constructor(theHandle: Handle_ChFiDS_Stripe);
  }

export declare class ChFiDS_Stripe extends Standard_Transient {
  constructor()
  Reset(): void;
  SetOfSurfData(): Handle_ChFiDS_HData;
  Spine(): Handle_ChFiDS_Spine;
  OrientationOnFace1_1(): TopAbs_Orientation;
  OrientationOnFace2_1(): TopAbs_Orientation;
  Choix_1(): Graphic3d_ZLayerId;
  ChangeSetOfSurfData(): Handle_ChFiDS_HData;
  ChangeSpine(): Handle_ChFiDS_Spine;
  OrientationOnFace1_2(Or1: TopAbs_Orientation): void;
  OrientationOnFace2_2(Or2: TopAbs_Orientation): void;
  Choix_2(C: Graphic3d_ZLayerId): void;
  FirstParameters(Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose): void;
  LastParameters(Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose): void;
  ChangeFirstParameters(Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose): void;
  ChangeLastParameters(Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose): void;
  FirstCurve(): Graphic3d_ZLayerId;
  LastCurve(): Graphic3d_ZLayerId;
  ChangeFirstCurve(Index: Graphic3d_ZLayerId): void;
  ChangeLastCurve(Index: Graphic3d_ZLayerId): void;
  FirstPCurve(): Handle_Geom2d_Curve;
  LastPCurve(): Handle_Geom2d_Curve;
  ChangeFirstPCurve(): Handle_Geom2d_Curve;
  ChangeLastPCurve(): Handle_Geom2d_Curve;
  FirstPCurveOrientation_1(): TopAbs_Orientation;
  LastPCurveOrientation_1(): TopAbs_Orientation;
  FirstPCurveOrientation_2(O: TopAbs_Orientation): void;
  LastPCurveOrientation_2(O: TopAbs_Orientation): void;
  IndexFirstPointOnS1(): Graphic3d_ZLayerId;
  IndexFirstPointOnS2(): Graphic3d_ZLayerId;
  IndexLastPointOnS1(): Graphic3d_ZLayerId;
  IndexLastPointOnS2(): Graphic3d_ZLayerId;
  ChangeIndexFirstPointOnS1(Index: Graphic3d_ZLayerId): void;
  ChangeIndexFirstPointOnS2(Index: Graphic3d_ZLayerId): void;
  ChangeIndexLastPointOnS1(Index: Graphic3d_ZLayerId): void;
  ChangeIndexLastPointOnS2(Index: Graphic3d_ZLayerId): void;
  Parameters(First: Standard_Boolean, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose): void;
  SetParameters(First: Standard_Boolean, Pdeb: Quantity_AbsorbedDose, Pfin: Quantity_AbsorbedDose): void;
  Curve(First: Standard_Boolean): Graphic3d_ZLayerId;
  SetCurve(Index: Graphic3d_ZLayerId, First: Standard_Boolean): void;
  PCurve(First: Standard_Boolean): Handle_Geom2d_Curve;
  ChangePCurve(First: Standard_Boolean): Handle_Geom2d_Curve;
  Orientation_1(OnS: Graphic3d_ZLayerId): TopAbs_Orientation;
  SetOrientation_1(Or: TopAbs_Orientation, OnS: Graphic3d_ZLayerId): void;
  Orientation_2(First: Standard_Boolean): TopAbs_Orientation;
  SetOrientation_2(Or: TopAbs_Orientation, First: Standard_Boolean): void;
  IndexPoint(First: Standard_Boolean, OnS: Graphic3d_ZLayerId): Graphic3d_ZLayerId;
  SetIndexPoint(Index: Graphic3d_ZLayerId, First: Standard_Boolean, OnS: Graphic3d_ZLayerId): void;
  SolidIndex(): Graphic3d_ZLayerId;
  SetSolidIndex(Index: Graphic3d_ZLayerId): void;
  InDS(First: Standard_Boolean, Nb: Graphic3d_ZLayerId): void;
  IsInDS(First: Standard_Boolean): Graphic3d_ZLayerId;
  static get_type_name(): Standard_Character;
  static get_type_descriptor(): Handle_Standard_Type;
  DynamicType(): Handle_Standard_Type;
  delete(): void;
}

export declare class ChFiDS_CircSection {
  constructor()
  Set_1(C: gp_Circ, F: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose): void;
  Set_2(C: gp_Lin, F: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose): void;
  Get_1(C: gp_Circ, F: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose): void;
  Get_2(C: gp_Lin, F: Quantity_AbsorbedDose, L: Quantity_AbsorbedDose): void;
  delete(): void;
}

export declare class VrmlAPI_Writer {
  constructor()
  ResetToDefaults(): void;
  Drawer(): Handle_VrmlConverter_Drawer;
  SetDeflection(aDef: Quantity_AbsorbedDose): void;
  SetRepresentation(aRep: VrmlAPI_RepresentationOfShape): void;
  SetTransparencyToMaterial(aMaterial: Handle_Vrml_Material, aTransparency: Quantity_AbsorbedDose): void;
  SetShininessToMaterial(aMaterial: Handle_Vrml_Material, aShininess: Quantity_AbsorbedDose): void;
  SetAmbientColorToMaterial(aMaterial: Handle_Vrml_Material, Color: Handle_Quantity_HArray1OfColor): void;
  SetDiffuseColorToMaterial(aMaterial: Handle_Vrml_Material, Color: Handle_Quantity_HArray1OfColor): void;
  SetSpecularColorToMaterial(aMaterial: Handle_Vrml_Material, Color: Handle_Quantity_HArray1OfColor): void;
  SetEmissiveColorToMaterial(aMaterial: Handle_Vrml_Material, Color: Handle_Quantity_HArray1OfColor): void;
  GetRepresentation(): VrmlAPI_RepresentationOfShape;
  GetFrontMaterial(): Handle_Vrml_Material;
  GetPointsMaterial(): Handle_Vrml_Material;
  GetUisoMaterial(): Handle_Vrml_Material;
  GetVisoMaterial(): Handle_Vrml_Material;
  GetLineMaterial(): Handle_Vrml_Material;
  GetWireMaterial(): Handle_Vrml_Material;
  GetFreeBoundsMaterial(): Handle_Vrml_Material;
  GetUnfreeBoundsMaterial(): Handle_Vrml_Material;
  Write(aShape: TopoDS_Shape, aFile: Standard_CString, aVersion: Graphic3d_ZLayerId): Standard_Boolean;
  WriteDoc(theDoc: Handle_TDocStd_Document, theFile: Standard_CString, theScale: Quantity_AbsorbedDose): Standard_Boolean;
  delete(): void;
}

export declare type VrmlAPI_RepresentationOfShape = {
  VrmlAPI_ShadedRepresentation: {};
  VrmlAPI_WireFrameRepresentation: {};
  VrmlAPI_BothRepresentation: {};
}

export declare class VrmlAPI {
  constructor();
  static Write(aShape: TopoDS_Shape, aFileName: Standard_CString, aVersion: Graphic3d_ZLayerId): Standard_Boolean;
  delete(): void;
}

type Standard_Boolean = boolean;
type Standard_Byte = number;
type Standard_Character = number;
type Standard_CString = string;
type Standard_Integer = number;
type Standard_Real = number;
type Standard_ShortReal = number;
type Standard_Size = number;

declare namespace FS {
  interface Lookup {
      path: string;
      node: FSNode;
  }

  interface FSStream {}
  interface FSNode {}
  interface ErrnoError {}

  let ignorePermissions: boolean;
  let trackingDelegate: any;
  let tracking: any;
  let genericErrors: any;

  //
  // paths
  //
  function lookupPath(path: string, opts: any): Lookup;
  function getPath(node: FSNode): string;

  //
  // nodes
  //
  function isFile(mode: number): boolean;
  function isDir(mode: number): boolean;
  function isLink(mode: number): boolean;
  function isChrdev(mode: number): boolean;
  function isBlkdev(mode: number): boolean;
  function isFIFO(mode: number): boolean;
  function isSocket(mode: number): boolean;

  //
  // devices
  //
  function major(dev: number): number;
  function minor(dev: number): number;
  function makedev(ma: number, mi: number): number;
  function registerDevice(dev: number, ops: any): void;

  //
  // core
  //
  function syncfs(populate: boolean, callback: (e: any) => any): void;
  function syncfs(callback: (e: any) => any, populate?: boolean): void;
  function mount(type: any, opts: any, mountpoint: string): any;
  function unmount(mountpoint: string): void;

  function mkdir(path: string, mode?: number): any;
  function mkdev(path: string, mode?: number, dev?: number): any;
  function symlink(oldpath: string, newpath: string): any;
  function rename(old_path: string, new_path: string): void;
  function rmdir(path: string): void;
  function readdir(path: string): any;
  function unlink(path: string): void;
  function readlink(path: string): string;
  function stat(path: string, dontFollow?: boolean): any;
  function lstat(path: string): any;
  function chmod(path: string, mode: number, dontFollow?: boolean): void;
  function lchmod(path: string, mode: number): void;
  function fchmod(fd: number, mode: number): void;
  function chown(path: string, uid: number, gid: number, dontFollow?: boolean): void;
  function lchown(path: string, uid: number, gid: number): void;
  function fchown(fd: number, uid: number, gid: number): void;
  function truncate(path: string, len: number): void;
  function ftruncate(fd: number, len: number): void;
  function utime(path: string, atime: number, mtime: number): void;
  function open(path: string, flags: string, mode?: number, fd_start?: number, fd_end?: number): FSStream;
  function close(stream: FSStream): void;
  function llseek(stream: FSStream, offset: number, whence: number): any;
  function read(stream: FSStream, buffer: ArrayBufferView, offset: number, length: number, position?: number): number;
  function write(
      stream: FSStream,
      buffer: ArrayBufferView,
      offset: number,
      length: number,
      position?: number,
      canOwn?: boolean,
  ): number;
  function allocate(stream: FSStream, offset: number, length: number): void;
  function mmap(
      stream: FSStream,
      buffer: ArrayBufferView,
      offset: number,
      length: number,
      position: number,
      prot: number,
      flags: number,
  ): any;
  function ioctl(stream: FSStream, cmd: any, arg: any): any;
  function readFile(path: string, opts: { encoding: 'binary'; flags?: string }): Uint8Array;
  function readFile(path: string, opts: { encoding: 'utf8'; flags?: string }): string;
  function readFile(path: string, opts?: { flags?: string }): Uint8Array;
  function writeFile(path: string, data: string | ArrayBufferView, opts?: { flags?: string }): void;

  //
  // module-level FS code
  //
  function cwd(): string;
  function chdir(path: string): void;
  function init(
      input: null | (() => number | null),
      output: null | ((c: number) => any),
      error: null | ((c: number) => any),
  ): void;

  function createLazyFile(
      parent: string | FSNode,
      name: string,
      url: string,
      canRead: boolean,
      canWrite: boolean,
  ): FSNode;
  function createPreloadedFile(
      parent: string | FSNode,
      name: string,
      url: string,
      canRead: boolean,
      canWrite: boolean,
      onload?: () => void,
      onerror?: () => void,
      dontCreateFile?: boolean,
      canOwn?: boolean,
  ): void;
  function createDataFile(
      parent: string | FSNode,
      name: string,
      data: ArrayBufferView | string,
      canRead: boolean,
      canWrite: boolean,
      canOwn: boolean,
  ): FSNode;
  interface AnalysisResults {
    isRoot: boolean,
    exists: boolean,
    error: Error,
    name: string,
    path: any,
    object: any,
    parentExists: boolean,
    parentPath: any,
    parentObject: any
  }
  function analyzePath(path: string): AnalysisResults;
}


export type OpenCascadeInstance = {FS: typeof FS} & {
  Handle_TObj_Model: typeof Handle_TObj_Model;
  Handle_TObj_Model_1: typeof Handle_TObj_Model_1;
  Handle_TObj_Model_2: typeof Handle_TObj_Model_2;
  Handle_TObj_Model_3: typeof Handle_TObj_Model_3;
  Handle_TObj_Model_4: typeof Handle_TObj_Model_4;
  TObj_Model: typeof TObj_Model;
  TObj_Application: typeof TObj_Application;
  Handle_TObj_Application: typeof Handle_TObj_Application;
  Handle_TObj_Application_1: typeof Handle_TObj_Application_1;
  Handle_TObj_Application_2: typeof Handle_TObj_Application_2;
  Handle_TObj_Application_3: typeof Handle_TObj_Application_3;
  Handle_TObj_Application_4: typeof Handle_TObj_Application_4;
  Handle_TObj_TObject: typeof Handle_TObj_TObject;
  Handle_TObj_TObject_1: typeof Handle_TObj_TObject_1;
  Handle_TObj_TObject_2: typeof Handle_TObj_TObject_2;
  Handle_TObj_TObject_3: typeof Handle_TObj_TObject_3;
  Handle_TObj_TObject_4: typeof Handle_TObj_TObject_4;
  TObj_TObject: typeof TObj_TObject;
  Handle_TObj_OcafObjectIterator: typeof Handle_TObj_OcafObjectIterator;
  Handle_TObj_OcafObjectIterator_1: typeof Handle_TObj_OcafObjectIterator_1;
  Handle_TObj_OcafObjectIterator_2: typeof Handle_TObj_OcafObjectIterator_2;
  Handle_TObj_OcafObjectIterator_3: typeof Handle_TObj_OcafObjectIterator_3;
  Handle_TObj_OcafObjectIterator_4: typeof Handle_TObj_OcafObjectIterator_4;
  TObj_OcafObjectIterator: typeof TObj_OcafObjectIterator;
  Handle_TObj_HSequenceOfObject: typeof Handle_TObj_HSequenceOfObject;
  Handle_TObj_HSequenceOfObject_1: typeof Handle_TObj_HSequenceOfObject_1;
  Handle_TObj_HSequenceOfObject_2: typeof Handle_TObj_HSequenceOfObject_2;
  Handle_TObj_HSequenceOfObject_3: typeof Handle_TObj_HSequenceOfObject_3;
  Handle_TObj_HSequenceOfObject_4: typeof Handle_TObj_HSequenceOfObject_4;
  TObj_ModelIterator: typeof TObj_ModelIterator;
  Handle_TObj_ModelIterator: typeof Handle_TObj_ModelIterator;
  Handle_TObj_ModelIterator_1: typeof Handle_TObj_ModelIterator_1;
  Handle_TObj_ModelIterator_2: typeof Handle_TObj_ModelIterator_2;
  Handle_TObj_ModelIterator_3: typeof Handle_TObj_ModelIterator_3;
  Handle_TObj_ModelIterator_4: typeof Handle_TObj_ModelIterator_4;
  TObj_HiddenPartition: typeof TObj_HiddenPartition;
  Handle_TObj_HiddenPartition: typeof Handle_TObj_HiddenPartition;
  Handle_TObj_HiddenPartition_1: typeof Handle_TObj_HiddenPartition_1;
  Handle_TObj_HiddenPartition_2: typeof Handle_TObj_HiddenPartition_2;
  Handle_TObj_HiddenPartition_3: typeof Handle_TObj_HiddenPartition_3;
  Handle_TObj_HiddenPartition_4: typeof Handle_TObj_HiddenPartition_4;
  Handle_TObj_ObjectIterator: typeof Handle_TObj_ObjectIterator;
  Handle_TObj_ObjectIterator_1: typeof Handle_TObj_ObjectIterator_1;
  Handle_TObj_ObjectIterator_2: typeof Handle_TObj_ObjectIterator_2;
  Handle_TObj_ObjectIterator_3: typeof Handle_TObj_ObjectIterator_3;
  Handle_TObj_ObjectIterator_4: typeof Handle_TObj_ObjectIterator_4;
  TObj_ObjectIterator: typeof TObj_ObjectIterator;
  Handle_TObj_TIntSparseArray: typeof Handle_TObj_TIntSparseArray;
  Handle_TObj_TIntSparseArray_1: typeof Handle_TObj_TIntSparseArray_1;
  Handle_TObj_TIntSparseArray_2: typeof Handle_TObj_TIntSparseArray_2;
  Handle_TObj_TIntSparseArray_3: typeof Handle_TObj_TIntSparseArray_3;
  Handle_TObj_TIntSparseArray_4: typeof Handle_TObj_TIntSparseArray_4;
  TObj_TIntSparseArray: typeof TObj_TIntSparseArray;
  Handle_TObj_TXYZ: typeof Handle_TObj_TXYZ;
  Handle_TObj_TXYZ_1: typeof Handle_TObj_TXYZ_1;
  Handle_TObj_TXYZ_2: typeof Handle_TObj_TXYZ_2;
  Handle_TObj_TXYZ_3: typeof Handle_TObj_TXYZ_3;
  Handle_TObj_TXYZ_4: typeof Handle_TObj_TXYZ_4;
  TObj_TXYZ: typeof TObj_TXYZ;
  Handle_TObj_ReferenceIterator: typeof Handle_TObj_ReferenceIterator;
  Handle_TObj_ReferenceIterator_1: typeof Handle_TObj_ReferenceIterator_1;
  Handle_TObj_ReferenceIterator_2: typeof Handle_TObj_ReferenceIterator_2;
  Handle_TObj_ReferenceIterator_3: typeof Handle_TObj_ReferenceIterator_3;
  Handle_TObj_ReferenceIterator_4: typeof Handle_TObj_ReferenceIterator_4;
  TObj_ReferenceIterator: typeof TObj_ReferenceIterator;
  TObj_Object: typeof TObj_Object;
  Handle_TObj_Object: typeof Handle_TObj_Object;
  Handle_TObj_Object_1: typeof Handle_TObj_Object_1;
  Handle_TObj_Object_2: typeof Handle_TObj_Object_2;
  Handle_TObj_Object_3: typeof Handle_TObj_Object_3;
  Handle_TObj_Object_4: typeof Handle_TObj_Object_4;
  TObj_LabelIterator: typeof TObj_LabelIterator;
  Handle_TObj_LabelIterator: typeof Handle_TObj_LabelIterator;
  Handle_TObj_LabelIterator_1: typeof Handle_TObj_LabelIterator_1;
  Handle_TObj_LabelIterator_2: typeof Handle_TObj_LabelIterator_2;
  Handle_TObj_LabelIterator_3: typeof Handle_TObj_LabelIterator_3;
  Handle_TObj_LabelIterator_4: typeof Handle_TObj_LabelIterator_4;
  TObj_TModel: typeof TObj_TModel;
  Handle_TObj_TModel: typeof Handle_TObj_TModel;
  Handle_TObj_TModel_1: typeof Handle_TObj_TModel_1;
  Handle_TObj_TModel_2: typeof Handle_TObj_TModel_2;
  Handle_TObj_TModel_3: typeof Handle_TObj_TModel_3;
  Handle_TObj_TModel_4: typeof Handle_TObj_TModel_4;
  TObj_SequenceIterator: typeof TObj_SequenceIterator;
  Handle_TObj_SequenceIterator: typeof Handle_TObj_SequenceIterator;
  Handle_TObj_SequenceIterator_1: typeof Handle_TObj_SequenceIterator_1;
  Handle_TObj_SequenceIterator_2: typeof Handle_TObj_SequenceIterator_2;
  Handle_TObj_SequenceIterator_3: typeof Handle_TObj_SequenceIterator_3;
  Handle_TObj_SequenceIterator_4: typeof Handle_TObj_SequenceIterator_4;
  TObj_Persistence: typeof TObj_Persistence;
  TObj_CheckModel: typeof TObj_CheckModel;
  Handle_TObj_CheckModel: typeof Handle_TObj_CheckModel;
  Handle_TObj_CheckModel_1: typeof Handle_TObj_CheckModel_1;
  Handle_TObj_CheckModel_2: typeof Handle_TObj_CheckModel_2;
  Handle_TObj_CheckModel_3: typeof Handle_TObj_CheckModel_3;
  Handle_TObj_CheckModel_4: typeof Handle_TObj_CheckModel_4;
  TObj_Partition: typeof TObj_Partition;
  Handle_TObj_Partition: typeof Handle_TObj_Partition;
  Handle_TObj_Partition_1: typeof Handle_TObj_Partition_1;
  Handle_TObj_Partition_2: typeof Handle_TObj_Partition_2;
  Handle_TObj_Partition_3: typeof Handle_TObj_Partition_3;
  Handle_TObj_Partition_4: typeof Handle_TObj_Partition_4;
  TObj_TNameContainer: typeof TObj_TNameContainer;
  Handle_TObj_TNameContainer: typeof Handle_TObj_TNameContainer;
  Handle_TObj_TNameContainer_1: typeof Handle_TObj_TNameContainer_1;
  Handle_TObj_TNameContainer_2: typeof Handle_TObj_TNameContainer_2;
  Handle_TObj_TNameContainer_3: typeof Handle_TObj_TNameContainer_3;
  Handle_TObj_TNameContainer_4: typeof Handle_TObj_TNameContainer_4;
  TObj_TReference: typeof TObj_TReference;
  Handle_TObj_TReference: typeof Handle_TObj_TReference;
  Handle_TObj_TReference_1: typeof Handle_TObj_TReference_1;
  Handle_TObj_TReference_2: typeof Handle_TObj_TReference_2;
  Handle_TObj_TReference_3: typeof Handle_TObj_TReference_3;
  Handle_TObj_TReference_4: typeof Handle_TObj_TReference_4;
  TObj_Assistant: typeof TObj_Assistant;
  GeomLib_Check2dBSplineCurve: typeof GeomLib_Check2dBSplineCurve;
  GeomLib_IsPlanarSurface: typeof GeomLib_IsPlanarSurface;
  GeomLib_CheckBSplineCurve: typeof GeomLib_CheckBSplineCurve;
  GeomLib_PolyFunc: typeof GeomLib_PolyFunc;
  GeomLib_Interpolate: typeof GeomLib_Interpolate;
  GeomLib_MakeCurvefromApprox: typeof GeomLib_MakeCurvefromApprox;
  GeomLib_LogSample: typeof GeomLib_LogSample;
  GeomLib_DenominatorMultiplier: typeof GeomLib_DenominatorMultiplier;
  GeomLib_InterpolationErrors: GeomLib_InterpolationErrors;
  GeomLib_Tool: typeof GeomLib_Tool;
  GeomLib: typeof GeomLib;
  GeomLib_Array1OfMat: typeof GeomLib_Array1OfMat;
  GeomLib_Array1OfMat_1: typeof GeomLib_Array1OfMat_1;
  GeomLib_Array1OfMat_2: typeof GeomLib_Array1OfMat_2;
  GeomLib_Array1OfMat_3: typeof GeomLib_Array1OfMat_3;
  GeomLib_Array1OfMat_4: typeof GeomLib_Array1OfMat_4;
  GeomLib_Array1OfMat_5: typeof GeomLib_Array1OfMat_5;
  GeomLib_CheckCurveOnSurface: typeof GeomLib_CheckCurveOnSurface;
  GeomLib_CheckCurveOnSurface_1: typeof GeomLib_CheckCurveOnSurface_1;
  GeomLib_CheckCurveOnSurface_2: typeof GeomLib_CheckCurveOnSurface_2;
  BiTgte_ContactType: BiTgte_ContactType;
  BiTgte_CurveOnEdge: typeof BiTgte_CurveOnEdge;
  BiTgte_CurveOnEdge_1: typeof BiTgte_CurveOnEdge_1;
  BiTgte_CurveOnEdge_2: typeof BiTgte_CurveOnEdge_2;
  BiTgte_CurveOnVertex: typeof BiTgte_CurveOnVertex;
  BiTgte_CurveOnVertex_1: typeof BiTgte_CurveOnVertex_1;
  BiTgte_CurveOnVertex_2: typeof BiTgte_CurveOnVertex_2;
  BiTgte_HCurveOnEdge: typeof BiTgte_HCurveOnEdge;
  BiTgte_HCurveOnEdge_1: typeof BiTgte_HCurveOnEdge_1;
  BiTgte_HCurveOnEdge_2: typeof BiTgte_HCurveOnEdge_2;
  Handle_BiTgte_HCurveOnEdge: typeof Handle_BiTgte_HCurveOnEdge;
  Handle_BiTgte_HCurveOnEdge_1: typeof Handle_BiTgte_HCurveOnEdge_1;
  Handle_BiTgte_HCurveOnEdge_2: typeof Handle_BiTgte_HCurveOnEdge_2;
  Handle_BiTgte_HCurveOnEdge_3: typeof Handle_BiTgte_HCurveOnEdge_3;
  Handle_BiTgte_HCurveOnEdge_4: typeof Handle_BiTgte_HCurveOnEdge_4;
  BiTgte_Blend: typeof BiTgte_Blend;
  BiTgte_Blend_1: typeof BiTgte_Blend_1;
  BiTgte_Blend_2: typeof BiTgte_Blend_2;
  Handle_BiTgte_HCurveOnVertex: typeof Handle_BiTgte_HCurveOnVertex;
  Handle_BiTgte_HCurveOnVertex_1: typeof Handle_BiTgte_HCurveOnVertex_1;
  Handle_BiTgte_HCurveOnVertex_2: typeof Handle_BiTgte_HCurveOnVertex_2;
  Handle_BiTgte_HCurveOnVertex_3: typeof Handle_BiTgte_HCurveOnVertex_3;
  Handle_BiTgte_HCurveOnVertex_4: typeof Handle_BiTgte_HCurveOnVertex_4;
  BiTgte_HCurveOnVertex: typeof BiTgte_HCurveOnVertex;
  BiTgte_HCurveOnVertex_1: typeof BiTgte_HCurveOnVertex_1;
  BiTgte_HCurveOnVertex_2: typeof BiTgte_HCurveOnVertex_2;
  TopOpeBRepDS_PointData: typeof TopOpeBRepDS_PointData;
  TopOpeBRepDS_PointData_1: typeof TopOpeBRepDS_PointData_1;
  TopOpeBRepDS_PointData_2: typeof TopOpeBRepDS_PointData_2;
  TopOpeBRepDS_PointData_3: typeof TopOpeBRepDS_PointData_3;
  TopOpeBRepDS_ShapeShapeInterference: typeof TopOpeBRepDS_ShapeShapeInterference;
  Handle_TopOpeBRepDS_ShapeShapeInterference: typeof Handle_TopOpeBRepDS_ShapeShapeInterference;
  Handle_TopOpeBRepDS_ShapeShapeInterference_1: typeof Handle_TopOpeBRepDS_ShapeShapeInterference_1;
  Handle_TopOpeBRepDS_ShapeShapeInterference_2: typeof Handle_TopOpeBRepDS_ShapeShapeInterference_2;
  Handle_TopOpeBRepDS_ShapeShapeInterference_3: typeof Handle_TopOpeBRepDS_ShapeShapeInterference_3;
  Handle_TopOpeBRepDS_ShapeShapeInterference_4: typeof Handle_TopOpeBRepDS_ShapeShapeInterference_4;
  TopOpeBRepDS_Filter: typeof TopOpeBRepDS_Filter;
  TopOpeBRepDS_EdgeInterferenceTool: typeof TopOpeBRepDS_EdgeInterferenceTool;
  TopOpeBRepDS_CurveIterator: typeof TopOpeBRepDS_CurveIterator;
  TopOpeBRepDS_IndexedDataMapOfVertexPoint: typeof TopOpeBRepDS_IndexedDataMapOfVertexPoint;
  TopOpeBRepDS_IndexedDataMapOfVertexPoint_1: typeof TopOpeBRepDS_IndexedDataMapOfVertexPoint_1;
  TopOpeBRepDS_IndexedDataMapOfVertexPoint_2: typeof TopOpeBRepDS_IndexedDataMapOfVertexPoint_2;
  TopOpeBRepDS_IndexedDataMapOfVertexPoint_3: typeof TopOpeBRepDS_IndexedDataMapOfVertexPoint_3;
  TopOpeBRepDS_Surface: typeof TopOpeBRepDS_Surface;
  TopOpeBRepDS_Surface_1: typeof TopOpeBRepDS_Surface_1;
  TopOpeBRepDS_Surface_2: typeof TopOpeBRepDS_Surface_2;
  TopOpeBRepDS_Surface_3: typeof TopOpeBRepDS_Surface_3;
  TopOpeBRepDS_Point: typeof TopOpeBRepDS_Point;
  TopOpeBRepDS_Point_1: typeof TopOpeBRepDS_Point_1;
  TopOpeBRepDS_Point_2: typeof TopOpeBRepDS_Point_2;
  TopOpeBRepDS_Point_3: typeof TopOpeBRepDS_Point_3;
  TopOpeBRepDS_Transition: typeof TopOpeBRepDS_Transition;
  TopOpeBRepDS_Transition_1: typeof TopOpeBRepDS_Transition_1;
  TopOpeBRepDS_Transition_2: typeof TopOpeBRepDS_Transition_2;
  TopOpeBRepDS_Transition_3: typeof TopOpeBRepDS_Transition_3;
  TopOpeBRepDS_IndexedDataMapOfShapeWithState: typeof TopOpeBRepDS_IndexedDataMapOfShapeWithState;
  TopOpeBRepDS_IndexedDataMapOfShapeWithState_1: typeof TopOpeBRepDS_IndexedDataMapOfShapeWithState_1;
  TopOpeBRepDS_IndexedDataMapOfShapeWithState_2: typeof TopOpeBRepDS_IndexedDataMapOfShapeWithState_2;
  TopOpeBRepDS_IndexedDataMapOfShapeWithState_3: typeof TopOpeBRepDS_IndexedDataMapOfShapeWithState_3;
  TopOpeBRepDS_PointIterator: typeof TopOpeBRepDS_PointIterator;
  TopOpeBRepDS_Reducer: typeof TopOpeBRepDS_Reducer;
  TopOpeBRepDS_Dumper: typeof TopOpeBRepDS_Dumper;
  Handle_TopOpeBRepDS_Check: typeof Handle_TopOpeBRepDS_Check;
  Handle_TopOpeBRepDS_Check_1: typeof Handle_TopOpeBRepDS_Check_1;
  Handle_TopOpeBRepDS_Check_2: typeof Handle_TopOpeBRepDS_Check_2;
  Handle_TopOpeBRepDS_Check_3: typeof Handle_TopOpeBRepDS_Check_3;
  Handle_TopOpeBRepDS_Check_4: typeof Handle_TopOpeBRepDS_Check_4;
  TopOpeBRepDS_Check: typeof TopOpeBRepDS_Check;
  TopOpeBRepDS_Check_1: typeof TopOpeBRepDS_Check_1;
  TopOpeBRepDS_Check_2: typeof TopOpeBRepDS_Check_2;
  TopOpeBRepDS_Marker: typeof TopOpeBRepDS_Marker;
  Handle_TopOpeBRepDS_Marker: typeof Handle_TopOpeBRepDS_Marker;
  Handle_TopOpeBRepDS_Marker_1: typeof Handle_TopOpeBRepDS_Marker_1;
  Handle_TopOpeBRepDS_Marker_2: typeof Handle_TopOpeBRepDS_Marker_2;
  Handle_TopOpeBRepDS_Marker_3: typeof Handle_TopOpeBRepDS_Marker_3;
  Handle_TopOpeBRepDS_Marker_4: typeof Handle_TopOpeBRepDS_Marker_4;
  TopOpeBRepDS_CurveData: typeof TopOpeBRepDS_CurveData;
  TopOpeBRepDS_CurveData_1: typeof TopOpeBRepDS_CurveData_1;
  TopOpeBRepDS_CurveData_2: typeof TopOpeBRepDS_CurveData_2;
  TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State: typeof TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State;
  TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_1: typeof TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_1;
  TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_2: typeof TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_2;
  TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_3: typeof TopOpeBRepDS_DataMapOfShapeListOfShapeOn1State_3;
  TopOpeBRepDS_DataStructure: typeof TopOpeBRepDS_DataStructure;
  TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference: typeof TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference;
  TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_1: typeof TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_1;
  TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_2: typeof TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_2;
  TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_3: typeof TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_3;
  TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_4: typeof TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_4;
  TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_5: typeof TopOpeBRepDS_Array1OfDataMapOfIntegerListOfInterference_5;
  TopOpeBRepDS_EIR: typeof TopOpeBRepDS_EIR;
  TopOpeBRepDS_HDataStructure: typeof TopOpeBRepDS_HDataStructure;
  Handle_TopOpeBRepDS_HDataStructure: typeof Handle_TopOpeBRepDS_HDataStructure;
  Handle_TopOpeBRepDS_HDataStructure_1: typeof Handle_TopOpeBRepDS_HDataStructure_1;
  Handle_TopOpeBRepDS_HDataStructure_2: typeof Handle_TopOpeBRepDS_HDataStructure_2;
  Handle_TopOpeBRepDS_HDataStructure_3: typeof Handle_TopOpeBRepDS_HDataStructure_3;
  Handle_TopOpeBRepDS_HDataStructure_4: typeof Handle_TopOpeBRepDS_HDataStructure_4;
  TopOpeBRepDS_ShapeData: typeof TopOpeBRepDS_ShapeData;
  Handle_TopOpeBRepDS_EdgeVertexInterference: typeof Handle_TopOpeBRepDS_EdgeVertexInterference;
  Handle_TopOpeBRepDS_EdgeVertexInterference_1: typeof Handle_TopOpeBRepDS_EdgeVertexInterference_1;
  Handle_TopOpeBRepDS_EdgeVertexInterference_2: typeof Handle_TopOpeBRepDS_EdgeVertexInterference_2;
  Handle_TopOpeBRepDS_EdgeVertexInterference_3: typeof Handle_TopOpeBRepDS_EdgeVertexInterference_3;
  Handle_TopOpeBRepDS_EdgeVertexInterference_4: typeof Handle_TopOpeBRepDS_EdgeVertexInterference_4;
  TopOpeBRepDS_EdgeVertexInterference: typeof TopOpeBRepDS_EdgeVertexInterference;
  TopOpeBRepDS_EdgeVertexInterference_1: typeof TopOpeBRepDS_EdgeVertexInterference_1;
  TopOpeBRepDS_EdgeVertexInterference_2: typeof TopOpeBRepDS_EdgeVertexInterference_2;
  TopOpeBRepDS_InterferenceTool: typeof TopOpeBRepDS_InterferenceTool;
  TopOpeBRepDS_GeometryData: typeof TopOpeBRepDS_GeometryData;
  TopOpeBRepDS_GeometryData_1: typeof TopOpeBRepDS_GeometryData_1;
  TopOpeBRepDS_GeometryData_2: typeof TopOpeBRepDS_GeometryData_2;
  Handle_TopOpeBRepDS_FaceEdgeInterference: typeof Handle_TopOpeBRepDS_FaceEdgeInterference;
  Handle_TopOpeBRepDS_FaceEdgeInterference_1: typeof Handle_TopOpeBRepDS_FaceEdgeInterference_1;
  Handle_TopOpeBRepDS_FaceEdgeInterference_2: typeof Handle_TopOpeBRepDS_FaceEdgeInterference_2;
  Handle_TopOpeBRepDS_FaceEdgeInterference_3: typeof Handle_TopOpeBRepDS_FaceEdgeInterference_3;
  Handle_TopOpeBRepDS_FaceEdgeInterference_4: typeof Handle_TopOpeBRepDS_FaceEdgeInterference_4;
  TopOpeBRepDS_FaceEdgeInterference: typeof TopOpeBRepDS_FaceEdgeInterference;
  TopOpeBRepDS_ShapeWithState: typeof TopOpeBRepDS_ShapeWithState;
  TopOpeBRepDS_DataMapOfCheckStatus: typeof TopOpeBRepDS_DataMapOfCheckStatus;
  TopOpeBRepDS_DataMapOfCheckStatus_1: typeof TopOpeBRepDS_DataMapOfCheckStatus_1;
  TopOpeBRepDS_DataMapOfCheckStatus_2: typeof TopOpeBRepDS_DataMapOfCheckStatus_2;
  TopOpeBRepDS_DataMapOfCheckStatus_3: typeof TopOpeBRepDS_DataMapOfCheckStatus_3;
  TopOpeBRepDS_SolidSurfaceInterference: typeof TopOpeBRepDS_SolidSurfaceInterference;
  Handle_TopOpeBRepDS_SolidSurfaceInterference: typeof Handle_TopOpeBRepDS_SolidSurfaceInterference;
  Handle_TopOpeBRepDS_SolidSurfaceInterference_1: typeof Handle_TopOpeBRepDS_SolidSurfaceInterference_1;
  Handle_TopOpeBRepDS_SolidSurfaceInterference_2: typeof Handle_TopOpeBRepDS_SolidSurfaceInterference_2;
  Handle_TopOpeBRepDS_SolidSurfaceInterference_3: typeof Handle_TopOpeBRepDS_SolidSurfaceInterference_3;
  Handle_TopOpeBRepDS_SolidSurfaceInterference_4: typeof Handle_TopOpeBRepDS_SolidSurfaceInterference_4;
  Handle_TopOpeBRepDS_CurvePointInterference: typeof Handle_TopOpeBRepDS_CurvePointInterference;
  Handle_TopOpeBRepDS_CurvePointInterference_1: typeof Handle_TopOpeBRepDS_CurvePointInterference_1;
  Handle_TopOpeBRepDS_CurvePointInterference_2: typeof Handle_TopOpeBRepDS_CurvePointInterference_2;
  Handle_TopOpeBRepDS_CurvePointInterference_3: typeof Handle_TopOpeBRepDS_CurvePointInterference_3;
  Handle_TopOpeBRepDS_CurvePointInterference_4: typeof Handle_TopOpeBRepDS_CurvePointInterference_4;
  TopOpeBRepDS_CurvePointInterference: typeof TopOpeBRepDS_CurvePointInterference;
  Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference: typeof Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference;
  Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_1: typeof Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_1;
  Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_2: typeof Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_2;
  Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_3: typeof Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_3;
  Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_4: typeof Handle_TopOpeBRepDS_HArray1OfDataMapOfIntegerListOfInterference_4;
  TopOpeBRepDS_MapOfShapeData: typeof TopOpeBRepDS_MapOfShapeData;
  TopOpeBRepDS_MapOfShapeData_1: typeof TopOpeBRepDS_MapOfShapeData_1;
  TopOpeBRepDS_MapOfShapeData_2: typeof TopOpeBRepDS_MapOfShapeData_2;
  TopOpeBRepDS_MapOfShapeData_3: typeof TopOpeBRepDS_MapOfShapeData_3;
  TopOpeBRepDS_Interference: typeof TopOpeBRepDS_Interference;
  TopOpeBRepDS_Interference_1: typeof TopOpeBRepDS_Interference_1;
  TopOpeBRepDS_Interference_2: typeof TopOpeBRepDS_Interference_2;
  TopOpeBRepDS_Interference_3: typeof TopOpeBRepDS_Interference_3;
  Handle_TopOpeBRepDS_Interference: typeof Handle_TopOpeBRepDS_Interference;
  Handle_TopOpeBRepDS_Interference_1: typeof Handle_TopOpeBRepDS_Interference_1;
  Handle_TopOpeBRepDS_Interference_2: typeof Handle_TopOpeBRepDS_Interference_2;
  Handle_TopOpeBRepDS_Interference_3: typeof Handle_TopOpeBRepDS_Interference_3;
  Handle_TopOpeBRepDS_Interference_4: typeof Handle_TopOpeBRepDS_Interference_4;
  TopOpeBRepDS_MapOfPoint: typeof TopOpeBRepDS_MapOfPoint;
  TopOpeBRepDS_MapOfPoint_1: typeof TopOpeBRepDS_MapOfPoint_1;
  TopOpeBRepDS_MapOfPoint_2: typeof TopOpeBRepDS_MapOfPoint_2;
  TopOpeBRepDS_MapOfPoint_3: typeof TopOpeBRepDS_MapOfPoint_3;
  TopOpeBRepDS_DoubleMapOfIntegerShape: typeof TopOpeBRepDS_DoubleMapOfIntegerShape;
  TopOpeBRepDS_DoubleMapOfIntegerShape_1: typeof TopOpeBRepDS_DoubleMapOfIntegerShape_1;
  TopOpeBRepDS_DoubleMapOfIntegerShape_2: typeof TopOpeBRepDS_DoubleMapOfIntegerShape_2;
  TopOpeBRepDS_DoubleMapOfIntegerShape_3: typeof TopOpeBRepDS_DoubleMapOfIntegerShape_3;
  TopOpeBRepDS_Association: typeof TopOpeBRepDS_Association;
  Handle_TopOpeBRepDS_Association: typeof Handle_TopOpeBRepDS_Association;
  Handle_TopOpeBRepDS_Association_1: typeof Handle_TopOpeBRepDS_Association_1;
  Handle_TopOpeBRepDS_Association_2: typeof Handle_TopOpeBRepDS_Association_2;
  Handle_TopOpeBRepDS_Association_3: typeof Handle_TopOpeBRepDS_Association_3;
  Handle_TopOpeBRepDS_Association_4: typeof Handle_TopOpeBRepDS_Association_4;
  TopOpeBRepDS_Kind: TopOpeBRepDS_Kind;
  TopOpeBRepDS_Curve: typeof TopOpeBRepDS_Curve;
  TopOpeBRepDS_Curve_1: typeof TopOpeBRepDS_Curve_1;
  TopOpeBRepDS_Curve_2: typeof TopOpeBRepDS_Curve_2;
  TopOpeBRepDS_BuildTool: typeof TopOpeBRepDS_BuildTool;
  TopOpeBRepDS_BuildTool_1: typeof TopOpeBRepDS_BuildTool_1;
  TopOpeBRepDS_BuildTool_2: typeof TopOpeBRepDS_BuildTool_2;
  TopOpeBRepDS_BuildTool_3: typeof TopOpeBRepDS_BuildTool_3;
  TopOpeBRepDS_Edge3dInterferenceTool: typeof TopOpeBRepDS_Edge3dInterferenceTool;
  TopOpeBRepDS_SurfaceExplorer: typeof TopOpeBRepDS_SurfaceExplorer;
  TopOpeBRepDS_SurfaceExplorer_1: typeof TopOpeBRepDS_SurfaceExplorer_1;
  TopOpeBRepDS_SurfaceExplorer_2: typeof TopOpeBRepDS_SurfaceExplorer_2;
  TopOpeBRepDS_MapOfIntegerShapeData: typeof TopOpeBRepDS_MapOfIntegerShapeData;
  TopOpeBRepDS_MapOfIntegerShapeData_1: typeof TopOpeBRepDS_MapOfIntegerShapeData_1;
  TopOpeBRepDS_MapOfIntegerShapeData_2: typeof TopOpeBRepDS_MapOfIntegerShapeData_2;
  TopOpeBRepDS_MapOfIntegerShapeData_3: typeof TopOpeBRepDS_MapOfIntegerShapeData_3;
  TopOpeBRepDS_PointExplorer: typeof TopOpeBRepDS_PointExplorer;
  TopOpeBRepDS_PointExplorer_1: typeof TopOpeBRepDS_PointExplorer_1;
  TopOpeBRepDS_PointExplorer_2: typeof TopOpeBRepDS_PointExplorer_2;
  TopOpeBRepDS_MapOfCurve: typeof TopOpeBRepDS_MapOfCurve;
  TopOpeBRepDS_MapOfCurve_1: typeof TopOpeBRepDS_MapOfCurve_1;
  TopOpeBRepDS_MapOfCurve_2: typeof TopOpeBRepDS_MapOfCurve_2;
  TopOpeBRepDS_MapOfCurve_3: typeof TopOpeBRepDS_MapOfCurve_3;
  TopOpeBRepDS_FIR: typeof TopOpeBRepDS_FIR;
  TopOpeBRepDS_Explorer: typeof TopOpeBRepDS_Explorer;
  TopOpeBRepDS_Explorer_1: typeof TopOpeBRepDS_Explorer_1;
  TopOpeBRepDS_Explorer_2: typeof TopOpeBRepDS_Explorer_2;
  TopOpeBRepDS_SurfaceCurveInterference: typeof TopOpeBRepDS_SurfaceCurveInterference;
  TopOpeBRepDS_SurfaceCurveInterference_1: typeof TopOpeBRepDS_SurfaceCurveInterference_1;
  TopOpeBRepDS_SurfaceCurveInterference_2: typeof TopOpeBRepDS_SurfaceCurveInterference_2;
  TopOpeBRepDS_SurfaceCurveInterference_3: typeof TopOpeBRepDS_SurfaceCurveInterference_3;
  Handle_TopOpeBRepDS_SurfaceCurveInterference: typeof Handle_TopOpeBRepDS_SurfaceCurveInterference;
  Handle_TopOpeBRepDS_SurfaceCurveInterference_1: typeof Handle_TopOpeBRepDS_SurfaceCurveInterference_1;
  Handle_TopOpeBRepDS_SurfaceCurveInterference_2: typeof Handle_TopOpeBRepDS_SurfaceCurveInterference_2;
  Handle_TopOpeBRepDS_SurfaceCurveInterference_3: typeof Handle_TopOpeBRepDS_SurfaceCurveInterference_3;
  Handle_TopOpeBRepDS_SurfaceCurveInterference_4: typeof Handle_TopOpeBRepDS_SurfaceCurveInterference_4;
  TopOpeBRepDS_MapOfSurface: typeof TopOpeBRepDS_MapOfSurface;
  TopOpeBRepDS_MapOfSurface_1: typeof TopOpeBRepDS_MapOfSurface_1;
  TopOpeBRepDS_MapOfSurface_2: typeof TopOpeBRepDS_MapOfSurface_2;
  TopOpeBRepDS_MapOfSurface_3: typeof TopOpeBRepDS_MapOfSurface_3;
  TopOpeBRepDS_DataMapOfIntegerListOfInterference: typeof TopOpeBRepDS_DataMapOfIntegerListOfInterference;
  TopOpeBRepDS_DataMapOfIntegerListOfInterference_1: typeof TopOpeBRepDS_DataMapOfIntegerListOfInterference_1;
  TopOpeBRepDS_DataMapOfIntegerListOfInterference_2: typeof TopOpeBRepDS_DataMapOfIntegerListOfInterference_2;
  TopOpeBRepDS_DataMapOfIntegerListOfInterference_3: typeof TopOpeBRepDS_DataMapOfIntegerListOfInterference_3;
  TopOpeBRepDS_CurveExplorer: typeof TopOpeBRepDS_CurveExplorer;
  TopOpeBRepDS_CurveExplorer_1: typeof TopOpeBRepDS_CurveExplorer_1;
  TopOpeBRepDS_CurveExplorer_2: typeof TopOpeBRepDS_CurveExplorer_2;
  TopOpeBRepDS_Config: TopOpeBRepDS_Config;
  TopOpeBRepDS_CheckStatus: TopOpeBRepDS_CheckStatus;
  TopOpeBRepDS: typeof TopOpeBRepDS;
  TopOpeBRepDS_GapTool: typeof TopOpeBRepDS_GapTool;
  TopOpeBRepDS_GapTool_1: typeof TopOpeBRepDS_GapTool_1;
  TopOpeBRepDS_GapTool_2: typeof TopOpeBRepDS_GapTool_2;
  Handle_TopOpeBRepDS_GapTool: typeof Handle_TopOpeBRepDS_GapTool;
  Handle_TopOpeBRepDS_GapTool_1: typeof Handle_TopOpeBRepDS_GapTool_1;
  Handle_TopOpeBRepDS_GapTool_2: typeof Handle_TopOpeBRepDS_GapTool_2;
  Handle_TopOpeBRepDS_GapTool_3: typeof Handle_TopOpeBRepDS_GapTool_3;
  Handle_TopOpeBRepDS_GapTool_4: typeof Handle_TopOpeBRepDS_GapTool_4;
  TopOpeBRepDS_TKI: typeof TopOpeBRepDS_TKI;
  TopOpeBRepDS_GapFiller: typeof TopOpeBRepDS_GapFiller;
  TopOpeBRepDS_DataMapOfShapeState: typeof TopOpeBRepDS_DataMapOfShapeState;
  TopOpeBRepDS_DataMapOfShapeState_1: typeof TopOpeBRepDS_DataMapOfShapeState_1;
  TopOpeBRepDS_DataMapOfShapeState_2: typeof TopOpeBRepDS_DataMapOfShapeState_2;
  TopOpeBRepDS_DataMapOfShapeState_3: typeof TopOpeBRepDS_DataMapOfShapeState_3;
  TopOpeBRepDS_TOOL: typeof TopOpeBRepDS_TOOL;
  TopOpeBRepDS_FaceInterferenceTool: typeof TopOpeBRepDS_FaceInterferenceTool;
  TopOpeBRepDS_SurfaceData: typeof TopOpeBRepDS_SurfaceData;
  TopOpeBRepDS_SurfaceData_1: typeof TopOpeBRepDS_SurfaceData_1;
  TopOpeBRepDS_SurfaceData_2: typeof TopOpeBRepDS_SurfaceData_2;
  TopOpeBRepDS_ListOfShapeOn1State: typeof TopOpeBRepDS_ListOfShapeOn1State;
  TopOpeBRepDS_SurfaceIterator: typeof TopOpeBRepDS_SurfaceIterator;
  TopOpeBRepDS_InterferenceIterator: typeof TopOpeBRepDS_InterferenceIterator;
  TopOpeBRepDS_InterferenceIterator_1: typeof TopOpeBRepDS_InterferenceIterator_1;
  TopOpeBRepDS_InterferenceIterator_2: typeof TopOpeBRepDS_InterferenceIterator_2;
  Handle_XmlXCAFDrivers_DocumentStorageDriver: typeof Handle_XmlXCAFDrivers_DocumentStorageDriver;
  Handle_XmlXCAFDrivers_DocumentStorageDriver_1: typeof Handle_XmlXCAFDrivers_DocumentStorageDriver_1;
  Handle_XmlXCAFDrivers_DocumentStorageDriver_2: typeof Handle_XmlXCAFDrivers_DocumentStorageDriver_2;
  Handle_XmlXCAFDrivers_DocumentStorageDriver_3: typeof Handle_XmlXCAFDrivers_DocumentStorageDriver_3;
  Handle_XmlXCAFDrivers_DocumentStorageDriver_4: typeof Handle_XmlXCAFDrivers_DocumentStorageDriver_4;
  XmlXCAFDrivers_DocumentStorageDriver: typeof XmlXCAFDrivers_DocumentStorageDriver;
  XmlXCAFDrivers: typeof XmlXCAFDrivers;
  Handle_XmlXCAFDrivers_DocumentRetrievalDriver: typeof Handle_XmlXCAFDrivers_DocumentRetrievalDriver;
  Handle_XmlXCAFDrivers_DocumentRetrievalDriver_1: typeof Handle_XmlXCAFDrivers_DocumentRetrievalDriver_1;
  Handle_XmlXCAFDrivers_DocumentRetrievalDriver_2: typeof Handle_XmlXCAFDrivers_DocumentRetrievalDriver_2;
  Handle_XmlXCAFDrivers_DocumentRetrievalDriver_3: typeof Handle_XmlXCAFDrivers_DocumentRetrievalDriver_3;
  Handle_XmlXCAFDrivers_DocumentRetrievalDriver_4: typeof Handle_XmlXCAFDrivers_DocumentRetrievalDriver_4;
  XmlXCAFDrivers_DocumentRetrievalDriver: typeof XmlXCAFDrivers_DocumentRetrievalDriver;
  Handle_XmlMDocStd_XLinkDriver: typeof Handle_XmlMDocStd_XLinkDriver;
  Handle_XmlMDocStd_XLinkDriver_1: typeof Handle_XmlMDocStd_XLinkDriver_1;
  Handle_XmlMDocStd_XLinkDriver_2: typeof Handle_XmlMDocStd_XLinkDriver_2;
  Handle_XmlMDocStd_XLinkDriver_3: typeof Handle_XmlMDocStd_XLinkDriver_3;
  Handle_XmlMDocStd_XLinkDriver_4: typeof Handle_XmlMDocStd_XLinkDriver_4;
  XmlMDocStd_XLinkDriver: typeof XmlMDocStd_XLinkDriver;
  XmlMDocStd: typeof XmlMDocStd;
  ElSLib: typeof ElSLib;
  CSLib_NormalPolyDef: typeof CSLib_NormalPolyDef;
  CSLib_NormalStatus: CSLib_NormalStatus;
  CSLib: typeof CSLib;
  CSLib_DerivativeStatus: CSLib_DerivativeStatus;
  CSLib_Class2d: typeof CSLib_Class2d;
  CSLib_Class2d_1: typeof CSLib_Class2d_1;
  CSLib_Class2d_2: typeof CSLib_Class2d_2;
  XmlObjMgt_RRelocationTable: typeof XmlObjMgt_RRelocationTable;
  XmlObjMgt_SRelocationTable: typeof XmlObjMgt_SRelocationTable;
  XmlObjMgt_Array1: typeof XmlObjMgt_Array1;
  XmlObjMgt_Array1_1: typeof XmlObjMgt_Array1_1;
  XmlObjMgt_Array1_2: typeof XmlObjMgt_Array1_2;
  XmlObjMgt: typeof XmlObjMgt;
  XmlObjMgt_Persistent: typeof XmlObjMgt_Persistent;
  XmlObjMgt_Persistent_1: typeof XmlObjMgt_Persistent_1;
  XmlObjMgt_Persistent_2: typeof XmlObjMgt_Persistent_2;
  XmlObjMgt_Persistent_3: typeof XmlObjMgt_Persistent_3;
  XmlObjMgt_GP: typeof XmlObjMgt_GP;
  Graphic3d_Texture1D: typeof Graphic3d_Texture1D;
  Handle_Graphic3d_Texture1D: typeof Handle_Graphic3d_Texture1D;
  Handle_Graphic3d_Texture1D_1: typeof Handle_Graphic3d_Texture1D_1;
  Handle_Graphic3d_Texture1D_2: typeof Handle_Graphic3d_Texture1D_2;
  Handle_Graphic3d_Texture1D_3: typeof Handle_Graphic3d_Texture1D_3;
  Handle_Graphic3d_Texture1D_4: typeof Handle_Graphic3d_Texture1D_4;
  Graphic3d_BvhCStructureSetTrsfPers: typeof Graphic3d_BvhCStructureSetTrsfPers;
  Handle_Graphic3d_GroupDefinitionError: typeof Handle_Graphic3d_GroupDefinitionError;
  Handle_Graphic3d_GroupDefinitionError_1: typeof Handle_Graphic3d_GroupDefinitionError_1;
  Handle_Graphic3d_GroupDefinitionError_2: typeof Handle_Graphic3d_GroupDefinitionError_2;
  Handle_Graphic3d_GroupDefinitionError_3: typeof Handle_Graphic3d_GroupDefinitionError_3;
  Handle_Graphic3d_GroupDefinitionError_4: typeof Handle_Graphic3d_GroupDefinitionError_4;
  Graphic3d_GroupDefinitionError: typeof Graphic3d_GroupDefinitionError;
  Graphic3d_GroupDefinitionError_1: typeof Graphic3d_GroupDefinitionError_1;
  Graphic3d_GroupDefinitionError_2: typeof Graphic3d_GroupDefinitionError_2;
  Graphic3d_FrameStatsDataTmp: typeof Graphic3d_FrameStatsDataTmp;
  Graphic3d_FrameStatsData: typeof Graphic3d_FrameStatsData;
  Graphic3d_Texture1Dsegment: typeof Graphic3d_Texture1Dsegment;
  Graphic3d_Texture1Dsegment_1: typeof Graphic3d_Texture1Dsegment_1;
  Graphic3d_Texture1Dsegment_2: typeof Graphic3d_Texture1Dsegment_2;
  Graphic3d_Texture1Dsegment_3: typeof Graphic3d_Texture1Dsegment_3;
  Handle_Graphic3d_Texture1Dsegment: typeof Handle_Graphic3d_Texture1Dsegment;
  Handle_Graphic3d_Texture1Dsegment_1: typeof Handle_Graphic3d_Texture1Dsegment_1;
  Handle_Graphic3d_Texture1Dsegment_2: typeof Handle_Graphic3d_Texture1Dsegment_2;
  Handle_Graphic3d_Texture1Dsegment_3: typeof Handle_Graphic3d_Texture1Dsegment_3;
  Handle_Graphic3d_Texture1Dsegment_4: typeof Handle_Graphic3d_Texture1Dsegment_4;
  Graphic3d_TypeOfConnection: Graphic3d_TypeOfConnection;
  Graphic3d_RenderingMode: Graphic3d_RenderingMode;
  Handle_Graphic3d_ArrayOfSegments: typeof Handle_Graphic3d_ArrayOfSegments;
  Handle_Graphic3d_ArrayOfSegments_1: typeof Handle_Graphic3d_ArrayOfSegments_1;
  Handle_Graphic3d_ArrayOfSegments_2: typeof Handle_Graphic3d_ArrayOfSegments_2;
  Handle_Graphic3d_ArrayOfSegments_3: typeof Handle_Graphic3d_ArrayOfSegments_3;
  Handle_Graphic3d_ArrayOfSegments_4: typeof Handle_Graphic3d_ArrayOfSegments_4;
  Graphic3d_ArrayOfSegments: typeof Graphic3d_ArrayOfSegments;
  Graphic3d_ArrayOfSegments_1: typeof Graphic3d_ArrayOfSegments_1;
  Graphic3d_ArrayOfSegments_2: typeof Graphic3d_ArrayOfSegments_2;
  Graphic3d_LightSet: typeof Graphic3d_LightSet;
  Handle_Graphic3d_LightSet: typeof Handle_Graphic3d_LightSet;
  Handle_Graphic3d_LightSet_1: typeof Handle_Graphic3d_LightSet_1;
  Handle_Graphic3d_LightSet_2: typeof Handle_Graphic3d_LightSet_2;
  Handle_Graphic3d_LightSet_3: typeof Handle_Graphic3d_LightSet_3;
  Handle_Graphic3d_LightSet_4: typeof Handle_Graphic3d_LightSet_4;
  Handle_Graphic3d_Texture2Dmanual: typeof Handle_Graphic3d_Texture2Dmanual;
  Handle_Graphic3d_Texture2Dmanual_1: typeof Handle_Graphic3d_Texture2Dmanual_1;
  Handle_Graphic3d_Texture2Dmanual_2: typeof Handle_Graphic3d_Texture2Dmanual_2;
  Handle_Graphic3d_Texture2Dmanual_3: typeof Handle_Graphic3d_Texture2Dmanual_3;
  Handle_Graphic3d_Texture2Dmanual_4: typeof Handle_Graphic3d_Texture2Dmanual_4;
  Graphic3d_Texture2Dmanual: typeof Graphic3d_Texture2Dmanual;
  Graphic3d_Texture2Dmanual_1: typeof Graphic3d_Texture2Dmanual_1;
  Graphic3d_Texture2Dmanual_2: typeof Graphic3d_Texture2Dmanual_2;
  Graphic3d_Texture2Dmanual_3: typeof Graphic3d_Texture2Dmanual_3;
  Graphic3d_PresentationAttributes: typeof Graphic3d_PresentationAttributes;
  Handle_Graphic3d_PresentationAttributes: typeof Handle_Graphic3d_PresentationAttributes;
  Handle_Graphic3d_PresentationAttributes_1: typeof Handle_Graphic3d_PresentationAttributes_1;
  Handle_Graphic3d_PresentationAttributes_2: typeof Handle_Graphic3d_PresentationAttributes_2;
  Handle_Graphic3d_PresentationAttributes_3: typeof Handle_Graphic3d_PresentationAttributes_3;
  Handle_Graphic3d_PresentationAttributes_4: typeof Handle_Graphic3d_PresentationAttributes_4;
  Graphic3d_ClipPlane: typeof Graphic3d_ClipPlane;
  Graphic3d_ClipPlane_1: typeof Graphic3d_ClipPlane_1;
  Graphic3d_ClipPlane_2: typeof Graphic3d_ClipPlane_2;
  Graphic3d_ClipPlane_3: typeof Graphic3d_ClipPlane_3;
  Graphic3d_ClipPlane_4: typeof Graphic3d_ClipPlane_4;
  Graphic3d_ClipState: Graphic3d_ClipState;
  Handle_Graphic3d_ClipPlane: typeof Handle_Graphic3d_ClipPlane;
  Handle_Graphic3d_ClipPlane_1: typeof Handle_Graphic3d_ClipPlane_1;
  Handle_Graphic3d_ClipPlane_2: typeof Handle_Graphic3d_ClipPlane_2;
  Handle_Graphic3d_ClipPlane_3: typeof Handle_Graphic3d_ClipPlane_3;
  Handle_Graphic3d_ClipPlane_4: typeof Handle_Graphic3d_ClipPlane_4;
  Graphic3d_TypeOfAnswer: Graphic3d_TypeOfAnswer;
  Graphic3d_MaterialAspect: typeof Graphic3d_MaterialAspect;
  Graphic3d_MaterialAspect_1: typeof Graphic3d_MaterialAspect_1;
  Graphic3d_MaterialAspect_2: typeof Graphic3d_MaterialAspect_2;
  Handle_Graphic3d_Camera: typeof Handle_Graphic3d_Camera;
  Handle_Graphic3d_Camera_1: typeof Handle_Graphic3d_Camera_1;
  Handle_Graphic3d_Camera_2: typeof Handle_Graphic3d_Camera_2;
  Handle_Graphic3d_Camera_3: typeof Handle_Graphic3d_Camera_3;
  Handle_Graphic3d_Camera_4: typeof Handle_Graphic3d_Camera_4;
  Graphic3d_Camera: typeof Graphic3d_Camera;
  Graphic3d_Camera_1: typeof Graphic3d_Camera_1;
  Graphic3d_Camera_2: typeof Graphic3d_Camera_2;
  Graphic3d_RenderingParams: typeof Graphic3d_RenderingParams;
  Graphic3d_BufferType: Graphic3d_BufferType;
  Graphic3d_HorizontalTextAlignment: Graphic3d_HorizontalTextAlignment;
  Graphic3d_TypeOfBackfacingModel: Graphic3d_TypeOfBackfacingModel;
  Graphic3d_Layer: typeof Graphic3d_Layer;
  Graphic3d_ArrayOfIndexedMapOfStructure: typeof Graphic3d_ArrayOfIndexedMapOfStructure;
  Graphic3d_ArrayOfIndexedMapOfStructure_1: typeof Graphic3d_ArrayOfIndexedMapOfStructure_1;
  Graphic3d_ArrayOfIndexedMapOfStructure_2: typeof Graphic3d_ArrayOfIndexedMapOfStructure_2;
  Graphic3d_ArrayOfIndexedMapOfStructure_3: typeof Graphic3d_ArrayOfIndexedMapOfStructure_3;
  Graphic3d_ArrayOfIndexedMapOfStructure_4: typeof Graphic3d_ArrayOfIndexedMapOfStructure_4;
  Graphic3d_ArrayOfIndexedMapOfStructure_5: typeof Graphic3d_ArrayOfIndexedMapOfStructure_5;
  Handle_Graphic3d_TextureMap: typeof Handle_Graphic3d_TextureMap;
  Handle_Graphic3d_TextureMap_1: typeof Handle_Graphic3d_TextureMap_1;
  Handle_Graphic3d_TextureMap_2: typeof Handle_Graphic3d_TextureMap_2;
  Handle_Graphic3d_TextureMap_3: typeof Handle_Graphic3d_TextureMap_3;
  Handle_Graphic3d_TextureMap_4: typeof Handle_Graphic3d_TextureMap_4;
  Graphic3d_TextureMap: typeof Graphic3d_TextureMap;
  Graphic3d_NameOfTextureEnv: Graphic3d_NameOfTextureEnv;
  Graphic3d_DiagnosticInfo: Graphic3d_DiagnosticInfo;
  Handle_Graphic3d_BoundBuffer: typeof Handle_Graphic3d_BoundBuffer;
  Handle_Graphic3d_BoundBuffer_1: typeof Handle_Graphic3d_BoundBuffer_1;
  Handle_Graphic3d_BoundBuffer_2: typeof Handle_Graphic3d_BoundBuffer_2;
  Handle_Graphic3d_BoundBuffer_3: typeof Handle_Graphic3d_BoundBuffer_3;
  Handle_Graphic3d_BoundBuffer_4: typeof Handle_Graphic3d_BoundBuffer_4;
  Graphic3d_BoundBuffer: typeof Graphic3d_BoundBuffer;
  Graphic3d_FrameStats: typeof Graphic3d_FrameStats;
  Graphic3d_MediaTexture: typeof Graphic3d_MediaTexture;
  Graphic3d_CullingTool: typeof Graphic3d_CullingTool;
  Handle_Graphic3d_CubeMapSeparate: typeof Handle_Graphic3d_CubeMapSeparate;
  Handle_Graphic3d_CubeMapSeparate_1: typeof Handle_Graphic3d_CubeMapSeparate_1;
  Handle_Graphic3d_CubeMapSeparate_2: typeof Handle_Graphic3d_CubeMapSeparate_2;
  Handle_Graphic3d_CubeMapSeparate_3: typeof Handle_Graphic3d_CubeMapSeparate_3;
  Handle_Graphic3d_CubeMapSeparate_4: typeof Handle_Graphic3d_CubeMapSeparate_4;
  Graphic3d_CubeMapSeparate: typeof Graphic3d_CubeMapSeparate;
  Graphic3d_CubeMapSeparate_1: typeof Graphic3d_CubeMapSeparate_1;
  Graphic3d_CubeMapSeparate_2: typeof Graphic3d_CubeMapSeparate_2;
  Graphic3d_MaterialDefinitionError: typeof Graphic3d_MaterialDefinitionError;
  Graphic3d_MaterialDefinitionError_1: typeof Graphic3d_MaterialDefinitionError_1;
  Graphic3d_MaterialDefinitionError_2: typeof Graphic3d_MaterialDefinitionError_2;
  Handle_Graphic3d_MaterialDefinitionError: typeof Handle_Graphic3d_MaterialDefinitionError;
  Handle_Graphic3d_MaterialDefinitionError_1: typeof Handle_Graphic3d_MaterialDefinitionError_1;
  Handle_Graphic3d_MaterialDefinitionError_2: typeof Handle_Graphic3d_MaterialDefinitionError_2;
  Handle_Graphic3d_MaterialDefinitionError_3: typeof Handle_Graphic3d_MaterialDefinitionError_3;
  Handle_Graphic3d_MaterialDefinitionError_4: typeof Handle_Graphic3d_MaterialDefinitionError_4;
  Graphic3d_TextureUnit: Graphic3d_TextureUnit;
  Handle_Graphic3d_ShaderAttribute: typeof Handle_Graphic3d_ShaderAttribute;
  Handle_Graphic3d_ShaderAttribute_1: typeof Handle_Graphic3d_ShaderAttribute_1;
  Handle_Graphic3d_ShaderAttribute_2: typeof Handle_Graphic3d_ShaderAttribute_2;
  Handle_Graphic3d_ShaderAttribute_3: typeof Handle_Graphic3d_ShaderAttribute_3;
  Handle_Graphic3d_ShaderAttribute_4: typeof Handle_Graphic3d_ShaderAttribute_4;
  Graphic3d_ShaderAttribute: typeof Graphic3d_ShaderAttribute;
  Graphic3d_ArrayOfPrimitives: typeof Graphic3d_ArrayOfPrimitives;
  Handle_Graphic3d_ArrayOfPrimitives: typeof Handle_Graphic3d_ArrayOfPrimitives;
  Handle_Graphic3d_ArrayOfPrimitives_1: typeof Handle_Graphic3d_ArrayOfPrimitives_1;
  Handle_Graphic3d_ArrayOfPrimitives_2: typeof Handle_Graphic3d_ArrayOfPrimitives_2;
  Handle_Graphic3d_ArrayOfPrimitives_3: typeof Handle_Graphic3d_ArrayOfPrimitives_3;
  Handle_Graphic3d_ArrayOfPrimitives_4: typeof Handle_Graphic3d_ArrayOfPrimitives_4;
  Handle_Graphic3d_DataStructureManager: typeof Handle_Graphic3d_DataStructureManager;
  Handle_Graphic3d_DataStructureManager_1: typeof Handle_Graphic3d_DataStructureManager_1;
  Handle_Graphic3d_DataStructureManager_2: typeof Handle_Graphic3d_DataStructureManager_2;
  Handle_Graphic3d_DataStructureManager_3: typeof Handle_Graphic3d_DataStructureManager_3;
  Handle_Graphic3d_DataStructureManager_4: typeof Handle_Graphic3d_DataStructureManager_4;
  Graphic3d_DataStructureManager: typeof Graphic3d_DataStructureManager;
  Graphic3d_Structure: typeof Graphic3d_Structure;
  Graphic3d_Aspects: typeof Graphic3d_Aspects;
  Handle_Graphic3d_Aspects: typeof Handle_Graphic3d_Aspects;
  Handle_Graphic3d_Aspects_1: typeof Handle_Graphic3d_Aspects_1;
  Handle_Graphic3d_Aspects_2: typeof Handle_Graphic3d_Aspects_2;
  Handle_Graphic3d_Aspects_3: typeof Handle_Graphic3d_Aspects_3;
  Handle_Graphic3d_Aspects_4: typeof Handle_Graphic3d_Aspects_4;
  Graphic3d_TypeOfComposition: Graphic3d_TypeOfComposition;
  Graphic3d_NameOfMaterial: Graphic3d_NameOfMaterial;
  Graphic3d_LevelOfTextureAnisotropy: Graphic3d_LevelOfTextureAnisotropy;
  Graphic3d_TypeOfShaderObject: Graphic3d_TypeOfShaderObject;
  Handle_Graphic3d_ArrayOfTriangleStrips: typeof Handle_Graphic3d_ArrayOfTriangleStrips;
  Handle_Graphic3d_ArrayOfTriangleStrips_1: typeof Handle_Graphic3d_ArrayOfTriangleStrips_1;
  Handle_Graphic3d_ArrayOfTriangleStrips_2: typeof Handle_Graphic3d_ArrayOfTriangleStrips_2;
  Handle_Graphic3d_ArrayOfTriangleStrips_3: typeof Handle_Graphic3d_ArrayOfTriangleStrips_3;
  Handle_Graphic3d_ArrayOfTriangleStrips_4: typeof Handle_Graphic3d_ArrayOfTriangleStrips_4;
  Graphic3d_ArrayOfTriangleStrips: typeof Graphic3d_ArrayOfTriangleStrips;
  Graphic3d_ArrayOfTriangleStrips_1: typeof Graphic3d_ArrayOfTriangleStrips_1;
  Graphic3d_ArrayOfTriangleStrips_2: typeof Graphic3d_ArrayOfTriangleStrips_2;
  Graphic3d_NameOfTexture2D: Graphic3d_NameOfTexture2D;
  Graphic3d_TransformPers: typeof Graphic3d_TransformPers;
  Graphic3d_TransformPers_1: typeof Graphic3d_TransformPers_1;
  Graphic3d_TransformPers_2: typeof Graphic3d_TransformPers_2;
  Graphic3d_TransformPers_3: typeof Graphic3d_TransformPers_3;
  Handle_Graphic3d_TransformPers: typeof Handle_Graphic3d_TransformPers;
  Handle_Graphic3d_TransformPers_1: typeof Handle_Graphic3d_TransformPers_1;
  Handle_Graphic3d_TransformPers_2: typeof Handle_Graphic3d_TransformPers_2;
  Handle_Graphic3d_TransformPers_3: typeof Handle_Graphic3d_TransformPers_3;
  Handle_Graphic3d_TransformPers_4: typeof Handle_Graphic3d_TransformPers_4;
  Handle_Graphic3d_ArrayOfPoints: typeof Handle_Graphic3d_ArrayOfPoints;
  Handle_Graphic3d_ArrayOfPoints_1: typeof Handle_Graphic3d_ArrayOfPoints_1;
  Handle_Graphic3d_ArrayOfPoints_2: typeof Handle_Graphic3d_ArrayOfPoints_2;
  Handle_Graphic3d_ArrayOfPoints_3: typeof Handle_Graphic3d_ArrayOfPoints_3;
  Handle_Graphic3d_ArrayOfPoints_4: typeof Handle_Graphic3d_ArrayOfPoints_4;
  Graphic3d_ArrayOfPoints: typeof Graphic3d_ArrayOfPoints;
  Graphic3d_ArrayOfPoints_1: typeof Graphic3d_ArrayOfPoints_1;
  Graphic3d_ArrayOfPoints_2: typeof Graphic3d_ArrayOfPoints_2;
  Graphic3d_FresnelModel: Graphic3d_FresnelModel;
  Graphic3d_Fresnel: typeof Graphic3d_Fresnel;
  Graphic3d_BSDF: typeof Graphic3d_BSDF;
  Graphic3d_TypeOfStructure: Graphic3d_TypeOfStructure;
  Graphic3d_ArrayOfTriangleFans: typeof Graphic3d_ArrayOfTriangleFans;
  Graphic3d_ArrayOfTriangleFans_1: typeof Graphic3d_ArrayOfTriangleFans_1;
  Graphic3d_ArrayOfTriangleFans_2: typeof Graphic3d_ArrayOfTriangleFans_2;
  Handle_Graphic3d_ArrayOfTriangleFans: typeof Handle_Graphic3d_ArrayOfTriangleFans;
  Handle_Graphic3d_ArrayOfTriangleFans_1: typeof Handle_Graphic3d_ArrayOfTriangleFans_1;
  Handle_Graphic3d_ArrayOfTriangleFans_2: typeof Handle_Graphic3d_ArrayOfTriangleFans_2;
  Handle_Graphic3d_ArrayOfTriangleFans_3: typeof Handle_Graphic3d_ArrayOfTriangleFans_3;
  Handle_Graphic3d_ArrayOfTriangleFans_4: typeof Handle_Graphic3d_ArrayOfTriangleFans_4;
  Handle_Graphic3d_ArrayOfPolylines: typeof Handle_Graphic3d_ArrayOfPolylines;
  Handle_Graphic3d_ArrayOfPolylines_1: typeof Handle_Graphic3d_ArrayOfPolylines_1;
  Handle_Graphic3d_ArrayOfPolylines_2: typeof Handle_Graphic3d_ArrayOfPolylines_2;
  Handle_Graphic3d_ArrayOfPolylines_3: typeof Handle_Graphic3d_ArrayOfPolylines_3;
  Handle_Graphic3d_ArrayOfPolylines_4: typeof Handle_Graphic3d_ArrayOfPolylines_4;
  Graphic3d_ArrayOfPolylines: typeof Graphic3d_ArrayOfPolylines;
  Graphic3d_ArrayOfPolylines_1: typeof Graphic3d_ArrayOfPolylines_1;
  Graphic3d_ArrayOfPolylines_2: typeof Graphic3d_ArrayOfPolylines_2;
  Graphic3d_TypeOfTexture: Graphic3d_TypeOfTexture;
  Graphic3d_ToneMappingMethod: Graphic3d_ToneMappingMethod;
  Graphic3d_GroupAspect: Graphic3d_GroupAspect;
  Handle_Graphic3d_Text: typeof Handle_Graphic3d_Text;
  Handle_Graphic3d_Text_1: typeof Handle_Graphic3d_Text_1;
  Handle_Graphic3d_Text_2: typeof Handle_Graphic3d_Text_2;
  Handle_Graphic3d_Text_3: typeof Handle_Graphic3d_Text_3;
  Handle_Graphic3d_Text_4: typeof Handle_Graphic3d_Text_4;
  Graphic3d_Text: typeof Graphic3d_Text;
  Graphic3d_ZLayerSettings: typeof Graphic3d_ZLayerSettings;
  Graphic3d_ZLayerSetting: Graphic3d_ZLayerSetting;
  Handle_Graphic3d_AspectText3d: typeof Handle_Graphic3d_AspectText3d;
  Handle_Graphic3d_AspectText3d_1: typeof Handle_Graphic3d_AspectText3d_1;
  Handle_Graphic3d_AspectText3d_2: typeof Handle_Graphic3d_AspectText3d_2;
  Handle_Graphic3d_AspectText3d_3: typeof Handle_Graphic3d_AspectText3d_3;
  Handle_Graphic3d_AspectText3d_4: typeof Handle_Graphic3d_AspectText3d_4;
  Graphic3d_AspectText3d: typeof Graphic3d_AspectText3d;
  Graphic3d_AspectText3d_1: typeof Graphic3d_AspectText3d_1;
  Graphic3d_AspectText3d_2: typeof Graphic3d_AspectText3d_2;
  Graphic3d_TypeOfReflection: Graphic3d_TypeOfReflection;
  Handle_Graphic3d_AspectFillArea3d: typeof Handle_Graphic3d_AspectFillArea3d;
  Handle_Graphic3d_AspectFillArea3d_1: typeof Handle_Graphic3d_AspectFillArea3d_1;
  Handle_Graphic3d_AspectFillArea3d_2: typeof Handle_Graphic3d_AspectFillArea3d_2;
  Handle_Graphic3d_AspectFillArea3d_3: typeof Handle_Graphic3d_AspectFillArea3d_3;
  Handle_Graphic3d_AspectFillArea3d_4: typeof Handle_Graphic3d_AspectFillArea3d_4;
  Graphic3d_AspectFillArea3d: typeof Graphic3d_AspectFillArea3d;
  Graphic3d_AspectFillArea3d_1: typeof Graphic3d_AspectFillArea3d_1;
  Graphic3d_AspectFillArea3d_2: typeof Graphic3d_AspectFillArea3d_2;
  Handle_Graphic3d_AspectLine3d: typeof Handle_Graphic3d_AspectLine3d;
  Handle_Graphic3d_AspectLine3d_1: typeof Handle_Graphic3d_AspectLine3d_1;
  Handle_Graphic3d_AspectLine3d_2: typeof Handle_Graphic3d_AspectLine3d_2;
  Handle_Graphic3d_AspectLine3d_3: typeof Handle_Graphic3d_AspectLine3d_3;
  Handle_Graphic3d_AspectLine3d_4: typeof Handle_Graphic3d_AspectLine3d_4;
  Graphic3d_AspectLine3d: typeof Graphic3d_AspectLine3d;
  Graphic3d_AspectLine3d_1: typeof Graphic3d_AspectLine3d_1;
  Graphic3d_AspectLine3d_2: typeof Graphic3d_AspectLine3d_2;
  Graphic3d_TypeOfBackground: Graphic3d_TypeOfBackground;
  Handle_Graphic3d_ViewAffinity: typeof Handle_Graphic3d_ViewAffinity;
  Handle_Graphic3d_ViewAffinity_1: typeof Handle_Graphic3d_ViewAffinity_1;
  Handle_Graphic3d_ViewAffinity_2: typeof Handle_Graphic3d_ViewAffinity_2;
  Handle_Graphic3d_ViewAffinity_3: typeof Handle_Graphic3d_ViewAffinity_3;
  Handle_Graphic3d_ViewAffinity_4: typeof Handle_Graphic3d_ViewAffinity_4;
  Graphic3d_ViewAffinity: typeof Graphic3d_ViewAffinity;
  Graphic3d_CubeMapOrder: typeof Graphic3d_CubeMapOrder;
  Graphic3d_CubeMapOrder_1: typeof Graphic3d_CubeMapOrder_1;
  Graphic3d_CubeMapOrder_2: typeof Graphic3d_CubeMapOrder_2;
  Graphic3d_CubeMapOrder_3: typeof Graphic3d_CubeMapOrder_3;
  Graphic3d_ValidatedCubeMapOrder: typeof Graphic3d_ValidatedCubeMapOrder;
  Graphic3d_TypeOfVisualization: Graphic3d_TypeOfVisualization;
  Graphic3d_CStructure: typeof Graphic3d_CStructure;
  Handle_Graphic3d_CStructure: typeof Handle_Graphic3d_CStructure;
  Handle_Graphic3d_CStructure_1: typeof Handle_Graphic3d_CStructure_1;
  Handle_Graphic3d_CStructure_2: typeof Handle_Graphic3d_CStructure_2;
  Handle_Graphic3d_CStructure_3: typeof Handle_Graphic3d_CStructure_3;
  Handle_Graphic3d_CStructure_4: typeof Handle_Graphic3d_CStructure_4;
  Handle_Graphic3d_StructureDefinitionError: typeof Handle_Graphic3d_StructureDefinitionError;
  Handle_Graphic3d_StructureDefinitionError_1: typeof Handle_Graphic3d_StructureDefinitionError_1;
  Handle_Graphic3d_StructureDefinitionError_2: typeof Handle_Graphic3d_StructureDefinitionError_2;
  Handle_Graphic3d_StructureDefinitionError_3: typeof Handle_Graphic3d_StructureDefinitionError_3;
  Handle_Graphic3d_StructureDefinitionError_4: typeof Handle_Graphic3d_StructureDefinitionError_4;
  Graphic3d_StructureDefinitionError: typeof Graphic3d_StructureDefinitionError;
  Graphic3d_StructureDefinitionError_1: typeof Graphic3d_StructureDefinitionError_1;
  Graphic3d_StructureDefinitionError_2: typeof Graphic3d_StructureDefinitionError_2;
  Graphic3d_TypeOfShadingModel: Graphic3d_TypeOfShadingModel;
  Graphic3d_CappingFlags: Graphic3d_CappingFlags;
  Graphic3d_NameOfTexturePlane: Graphic3d_NameOfTexturePlane;
  Graphic3d_WorldViewProjState: typeof Graphic3d_WorldViewProjState;
  Graphic3d_WorldViewProjState_1: typeof Graphic3d_WorldViewProjState_1;
  Graphic3d_WorldViewProjState_2: typeof Graphic3d_WorldViewProjState_2;
  Graphic3d_TextPath: Graphic3d_TextPath;
  Graphic3d_MutableIndexBuffer: typeof Graphic3d_MutableIndexBuffer;
  Graphic3d_AttribBuffer: typeof Graphic3d_AttribBuffer;
  Graphic3d_VerticalTextAlignment: Graphic3d_VerticalTextAlignment;
  Handle_Graphic3d_IndexBuffer: typeof Handle_Graphic3d_IndexBuffer;
  Handle_Graphic3d_IndexBuffer_1: typeof Handle_Graphic3d_IndexBuffer_1;
  Handle_Graphic3d_IndexBuffer_2: typeof Handle_Graphic3d_IndexBuffer_2;
  Handle_Graphic3d_IndexBuffer_3: typeof Handle_Graphic3d_IndexBuffer_3;
  Handle_Graphic3d_IndexBuffer_4: typeof Handle_Graphic3d_IndexBuffer_4;
  Graphic3d_IndexBuffer: typeof Graphic3d_IndexBuffer;
  Graphic3d_TypeOfMaterial: Graphic3d_TypeOfMaterial;
  Graphic3d_TypeOfTextureFilter: Graphic3d_TypeOfTextureFilter;
  Graphic3d_Mat4d: typeof Graphic3d_Mat4d;
  Handle_Graphic3d_ArrayOfQuadrangleStrips: typeof Handle_Graphic3d_ArrayOfQuadrangleStrips;
  Handle_Graphic3d_ArrayOfQuadrangleStrips_1: typeof Handle_Graphic3d_ArrayOfQuadrangleStrips_1;
  Handle_Graphic3d_ArrayOfQuadrangleStrips_2: typeof Handle_Graphic3d_ArrayOfQuadrangleStrips_2;
  Handle_Graphic3d_ArrayOfQuadrangleStrips_3: typeof Handle_Graphic3d_ArrayOfQuadrangleStrips_3;
  Handle_Graphic3d_ArrayOfQuadrangleStrips_4: typeof Handle_Graphic3d_ArrayOfQuadrangleStrips_4;
  Graphic3d_ArrayOfQuadrangleStrips: typeof Graphic3d_ArrayOfQuadrangleStrips;
  Graphic3d_ArrayOfQuadrangleStrips_1: typeof Graphic3d_ArrayOfQuadrangleStrips_1;
  Graphic3d_ArrayOfQuadrangleStrips_2: typeof Graphic3d_ArrayOfQuadrangleStrips_2;
  Handle_Graphic3d_Group: typeof Handle_Graphic3d_Group;
  Handle_Graphic3d_Group_1: typeof Handle_Graphic3d_Group_1;
  Handle_Graphic3d_Group_2: typeof Handle_Graphic3d_Group_2;
  Handle_Graphic3d_Group_3: typeof Handle_Graphic3d_Group_3;
  Handle_Graphic3d_Group_4: typeof Handle_Graphic3d_Group_4;
  Graphic3d_Group: typeof Graphic3d_Group;
  Graphic3d_ArrayOfQuadrangles: typeof Graphic3d_ArrayOfQuadrangles;
  Graphic3d_ArrayOfQuadrangles_1: typeof Graphic3d_ArrayOfQuadrangles_1;
  Graphic3d_ArrayOfQuadrangles_2: typeof Graphic3d_ArrayOfQuadrangles_2;
  Handle_Graphic3d_ArrayOfQuadrangles: typeof Handle_Graphic3d_ArrayOfQuadrangles;
  Handle_Graphic3d_ArrayOfQuadrangles_1: typeof Handle_Graphic3d_ArrayOfQuadrangles_1;
  Handle_Graphic3d_ArrayOfQuadrangles_2: typeof Handle_Graphic3d_ArrayOfQuadrangles_2;
  Handle_Graphic3d_ArrayOfQuadrangles_3: typeof Handle_Graphic3d_ArrayOfQuadrangles_3;
  Handle_Graphic3d_ArrayOfQuadrangles_4: typeof Handle_Graphic3d_ArrayOfQuadrangles_4;
  Graphic3d_GraphicDriver: typeof Graphic3d_GraphicDriver;
  Handle_Graphic3d_GraphicDriver: typeof Handle_Graphic3d_GraphicDriver;
  Handle_Graphic3d_GraphicDriver_1: typeof Handle_Graphic3d_GraphicDriver_1;
  Handle_Graphic3d_GraphicDriver_2: typeof Handle_Graphic3d_GraphicDriver_2;
  Handle_Graphic3d_GraphicDriver_3: typeof Handle_Graphic3d_GraphicDriver_3;
  Handle_Graphic3d_GraphicDriver_4: typeof Handle_Graphic3d_GraphicDriver_4;
  Graphic3d_TypeOfTextureMode: Graphic3d_TypeOfTextureMode;
  Handle_Graphic3d_TransformError: typeof Handle_Graphic3d_TransformError;
  Handle_Graphic3d_TransformError_1: typeof Handle_Graphic3d_TransformError_1;
  Handle_Graphic3d_TransformError_2: typeof Handle_Graphic3d_TransformError_2;
  Handle_Graphic3d_TransformError_3: typeof Handle_Graphic3d_TransformError_3;
  Handle_Graphic3d_TransformError_4: typeof Handle_Graphic3d_TransformError_4;
  Graphic3d_TransformError: typeof Graphic3d_TransformError;
  Graphic3d_TransformError_1: typeof Graphic3d_TransformError_1;
  Graphic3d_TransformError_2: typeof Graphic3d_TransformError_2;
  Graphic3d_TextureEnv: typeof Graphic3d_TextureEnv;
  Graphic3d_TextureEnv_1: typeof Graphic3d_TextureEnv_1;
  Graphic3d_TextureEnv_2: typeof Graphic3d_TextureEnv_2;
  Graphic3d_TextureEnv_3: typeof Graphic3d_TextureEnv_3;
  Handle_Graphic3d_TextureEnv: typeof Handle_Graphic3d_TextureEnv;
  Handle_Graphic3d_TextureEnv_1: typeof Handle_Graphic3d_TextureEnv_1;
  Handle_Graphic3d_TextureEnv_2: typeof Handle_Graphic3d_TextureEnv_2;
  Handle_Graphic3d_TextureEnv_3: typeof Handle_Graphic3d_TextureEnv_3;
  Handle_Graphic3d_TextureEnv_4: typeof Handle_Graphic3d_TextureEnv_4;
  Graphic3d_CView: typeof Graphic3d_CView;
  Handle_Graphic3d_CView: typeof Handle_Graphic3d_CView;
  Handle_Graphic3d_CView_1: typeof Handle_Graphic3d_CView_1;
  Handle_Graphic3d_CView_2: typeof Handle_Graphic3d_CView_2;
  Handle_Graphic3d_CView_3: typeof Handle_Graphic3d_CView_3;
  Handle_Graphic3d_CView_4: typeof Handle_Graphic3d_CView_4;
  Graphic3d_TypeOfData: Graphic3d_TypeOfData;
  Graphic3d_TypeOfAttribute: Graphic3d_TypeOfAttribute;
  Handle_Graphic3d_Buffer: typeof Handle_Graphic3d_Buffer;
  Handle_Graphic3d_Buffer_1: typeof Handle_Graphic3d_Buffer_1;
  Handle_Graphic3d_Buffer_2: typeof Handle_Graphic3d_Buffer_2;
  Handle_Graphic3d_Buffer_3: typeof Handle_Graphic3d_Buffer_3;
  Handle_Graphic3d_Buffer_4: typeof Handle_Graphic3d_Buffer_4;
  Graphic3d_Buffer: typeof Graphic3d_Buffer;
  Graphic3d_Attribute: typeof Graphic3d_Attribute;
  Graphic3d_Array1OfAttribute: typeof Graphic3d_Array1OfAttribute;
  Graphic3d_Array1OfAttribute_1: typeof Graphic3d_Array1OfAttribute_1;
  Graphic3d_Array1OfAttribute_2: typeof Graphic3d_Array1OfAttribute_2;
  Graphic3d_Array1OfAttribute_3: typeof Graphic3d_Array1OfAttribute_3;
  Graphic3d_Array1OfAttribute_4: typeof Graphic3d_Array1OfAttribute_4;
  Graphic3d_Array1OfAttribute_5: typeof Graphic3d_Array1OfAttribute_5;
  Graphic3d_SequenceOfHClipPlane: typeof Graphic3d_SequenceOfHClipPlane;
  Handle_Graphic3d_SequenceOfHClipPlane: typeof Handle_Graphic3d_SequenceOfHClipPlane;
  Handle_Graphic3d_SequenceOfHClipPlane_1: typeof Handle_Graphic3d_SequenceOfHClipPlane_1;
  Handle_Graphic3d_SequenceOfHClipPlane_2: typeof Handle_Graphic3d_SequenceOfHClipPlane_2;
  Handle_Graphic3d_SequenceOfHClipPlane_3: typeof Handle_Graphic3d_SequenceOfHClipPlane_3;
  Handle_Graphic3d_SequenceOfHClipPlane_4: typeof Handle_Graphic3d_SequenceOfHClipPlane_4;
  Graphic3d_ArrayOfPolygons: typeof Graphic3d_ArrayOfPolygons;
  Graphic3d_ArrayOfPolygons_1: typeof Graphic3d_ArrayOfPolygons_1;
  Graphic3d_ArrayOfPolygons_2: typeof Graphic3d_ArrayOfPolygons_2;
  Handle_Graphic3d_ArrayOfPolygons: typeof Handle_Graphic3d_ArrayOfPolygons;
  Handle_Graphic3d_ArrayOfPolygons_1: typeof Handle_Graphic3d_ArrayOfPolygons_1;
  Handle_Graphic3d_ArrayOfPolygons_2: typeof Handle_Graphic3d_ArrayOfPolygons_2;
  Handle_Graphic3d_ArrayOfPolygons_3: typeof Handle_Graphic3d_ArrayOfPolygons_3;
  Handle_Graphic3d_ArrayOfPolygons_4: typeof Handle_Graphic3d_ArrayOfPolygons_4;
  Handle_Graphic3d_PriorityDefinitionError: typeof Handle_Graphic3d_PriorityDefinitionError;
  Handle_Graphic3d_PriorityDefinitionError_1: typeof Handle_Graphic3d_PriorityDefinitionError_1;
  Handle_Graphic3d_PriorityDefinitionError_2: typeof Handle_Graphic3d_PriorityDefinitionError_2;
  Handle_Graphic3d_PriorityDefinitionError_3: typeof Handle_Graphic3d_PriorityDefinitionError_3;
  Handle_Graphic3d_PriorityDefinitionError_4: typeof Handle_Graphic3d_PriorityDefinitionError_4;
  Graphic3d_PriorityDefinitionError: typeof Graphic3d_PriorityDefinitionError;
  Graphic3d_PriorityDefinitionError_1: typeof Graphic3d_PriorityDefinitionError_1;
  Graphic3d_PriorityDefinitionError_2: typeof Graphic3d_PriorityDefinitionError_2;
  Graphic3d_PolygonOffset: typeof Graphic3d_PolygonOffset;
  Graphic3d_ShaderProgram: typeof Graphic3d_ShaderProgram;
  Handle_Graphic3d_ShaderProgram: typeof Handle_Graphic3d_ShaderProgram;
  Handle_Graphic3d_ShaderProgram_1: typeof Handle_Graphic3d_ShaderProgram_1;
  Handle_Graphic3d_ShaderProgram_2: typeof Handle_Graphic3d_ShaderProgram_2;
  Handle_Graphic3d_ShaderProgram_3: typeof Handle_Graphic3d_ShaderProgram_3;
  Handle_Graphic3d_ShaderProgram_4: typeof Handle_Graphic3d_ShaderProgram_4;
  Graphic3d_AspectMarker3d: typeof Graphic3d_AspectMarker3d;
  Graphic3d_AspectMarker3d_1: typeof Graphic3d_AspectMarker3d_1;
  Graphic3d_AspectMarker3d_2: typeof Graphic3d_AspectMarker3d_2;
  Graphic3d_AspectMarker3d_3: typeof Graphic3d_AspectMarker3d_3;
  Graphic3d_AspectMarker3d_4: typeof Graphic3d_AspectMarker3d_4;
  Handle_Graphic3d_AspectMarker3d: typeof Handle_Graphic3d_AspectMarker3d;
  Handle_Graphic3d_AspectMarker3d_1: typeof Handle_Graphic3d_AspectMarker3d_1;
  Handle_Graphic3d_AspectMarker3d_2: typeof Handle_Graphic3d_AspectMarker3d_2;
  Handle_Graphic3d_AspectMarker3d_3: typeof Handle_Graphic3d_AspectMarker3d_3;
  Handle_Graphic3d_AspectMarker3d_4: typeof Handle_Graphic3d_AspectMarker3d_4;
  Graphic3d_AxisAspect: typeof Graphic3d_AxisAspect;
  Graphic3d_GraduatedTrihedron: typeof Graphic3d_GraduatedTrihedron;
  Graphic3d_BufferRange: typeof Graphic3d_BufferRange;
  Graphic3d_BufferRange_1: typeof Graphic3d_BufferRange_1;
  Graphic3d_BufferRange_2: typeof Graphic3d_BufferRange_2;
  Graphic3d_CubeMapSide: Graphic3d_CubeMapSide;
  Graphic3d_TypeOfPrimitiveArray: Graphic3d_TypeOfPrimitiveArray;
  Handle_Graphic3d_ShaderObject: typeof Handle_Graphic3d_ShaderObject;
  Handle_Graphic3d_ShaderObject_1: typeof Handle_Graphic3d_ShaderObject_1;
  Handle_Graphic3d_ShaderObject_2: typeof Handle_Graphic3d_ShaderObject_2;
  Handle_Graphic3d_ShaderObject_3: typeof Handle_Graphic3d_ShaderObject_3;
  Handle_Graphic3d_ShaderObject_4: typeof Handle_Graphic3d_ShaderObject_4;
  Graphic3d_ShaderObject: typeof Graphic3d_ShaderObject;
  Graphic3d_TextureParams: typeof Graphic3d_TextureParams;
  Handle_Graphic3d_TextureParams: typeof Handle_Graphic3d_TextureParams;
  Handle_Graphic3d_TextureParams_1: typeof Handle_Graphic3d_TextureParams_1;
  Handle_Graphic3d_TextureParams_2: typeof Handle_Graphic3d_TextureParams_2;
  Handle_Graphic3d_TextureParams_3: typeof Handle_Graphic3d_TextureParams_3;
  Handle_Graphic3d_TextureParams_4: typeof Handle_Graphic3d_TextureParams_4;
  Handle_Graphic3d_ArrayOfTriangles: typeof Handle_Graphic3d_ArrayOfTriangles;
  Handle_Graphic3d_ArrayOfTriangles_1: typeof Handle_Graphic3d_ArrayOfTriangles_1;
  Handle_Graphic3d_ArrayOfTriangles_2: typeof Handle_Graphic3d_ArrayOfTriangles_2;
  Handle_Graphic3d_ArrayOfTriangles_3: typeof Handle_Graphic3d_ArrayOfTriangles_3;
  Handle_Graphic3d_ArrayOfTriangles_4: typeof Handle_Graphic3d_ArrayOfTriangles_4;
  Graphic3d_ArrayOfTriangles: typeof Graphic3d_ArrayOfTriangles;
  Graphic3d_ArrayOfTriangles_1: typeof Graphic3d_ArrayOfTriangles_1;
  Graphic3d_ArrayOfTriangles_2: typeof Graphic3d_ArrayOfTriangles_2;
  Handle_Graphic3d_Texture1Dmanual: typeof Handle_Graphic3d_Texture1Dmanual;
  Handle_Graphic3d_Texture1Dmanual_1: typeof Handle_Graphic3d_Texture1Dmanual_1;
  Handle_Graphic3d_Texture1Dmanual_2: typeof Handle_Graphic3d_Texture1Dmanual_2;
  Handle_Graphic3d_Texture1Dmanual_3: typeof Handle_Graphic3d_Texture1Dmanual_3;
  Handle_Graphic3d_Texture1Dmanual_4: typeof Handle_Graphic3d_Texture1Dmanual_4;
  Graphic3d_Texture1Dmanual: typeof Graphic3d_Texture1Dmanual;
  Graphic3d_Texture1Dmanual_1: typeof Graphic3d_Texture1Dmanual_1;
  Graphic3d_Texture1Dmanual_2: typeof Graphic3d_Texture1Dmanual_2;
  Graphic3d_Texture1Dmanual_3: typeof Graphic3d_Texture1Dmanual_3;
  Graphic3d_TypeOfLimit: Graphic3d_TypeOfLimit;
  Graphic3d_TransModeFlags: Graphic3d_TransModeFlags;
  Graphic3d_StereoMode: Graphic3d_StereoMode;
  Graphic3d_BvhCStructureSet: typeof Graphic3d_BvhCStructureSet;
  Graphic3d_CubeMapPacked: typeof Graphic3d_CubeMapPacked;
  Graphic3d_CubeMapPacked_1: typeof Graphic3d_CubeMapPacked_1;
  Graphic3d_CubeMapPacked_2: typeof Graphic3d_CubeMapPacked_2;
  Handle_Graphic3d_CubeMapPacked: typeof Handle_Graphic3d_CubeMapPacked;
  Handle_Graphic3d_CubeMapPacked_1: typeof Handle_Graphic3d_CubeMapPacked_1;
  Handle_Graphic3d_CubeMapPacked_2: typeof Handle_Graphic3d_CubeMapPacked_2;
  Handle_Graphic3d_CubeMapPacked_3: typeof Handle_Graphic3d_CubeMapPacked_3;
  Handle_Graphic3d_CubeMapPacked_4: typeof Handle_Graphic3d_CubeMapPacked_4;
  Handle_Graphic3d_StructureManager: typeof Handle_Graphic3d_StructureManager;
  Handle_Graphic3d_StructureManager_1: typeof Handle_Graphic3d_StructureManager_1;
  Handle_Graphic3d_StructureManager_2: typeof Handle_Graphic3d_StructureManager_2;
  Handle_Graphic3d_StructureManager_3: typeof Handle_Graphic3d_StructureManager_3;
  Handle_Graphic3d_StructureManager_4: typeof Handle_Graphic3d_StructureManager_4;
  Graphic3d_StructureManager: typeof Graphic3d_StructureManager;
  Handle_Graphic3d_MarkerImage: typeof Handle_Graphic3d_MarkerImage;
  Handle_Graphic3d_MarkerImage_1: typeof Handle_Graphic3d_MarkerImage_1;
  Handle_Graphic3d_MarkerImage_2: typeof Handle_Graphic3d_MarkerImage_2;
  Handle_Graphic3d_MarkerImage_3: typeof Handle_Graphic3d_MarkerImage_3;
  Handle_Graphic3d_MarkerImage_4: typeof Handle_Graphic3d_MarkerImage_4;
  Graphic3d_MarkerImage: typeof Graphic3d_MarkerImage;
  Graphic3d_MarkerImage_1: typeof Graphic3d_MarkerImage_1;
  Graphic3d_MarkerImage_2: typeof Graphic3d_MarkerImage_2;
  Graphic3d_CTexture: typeof Graphic3d_CTexture;
  Handle_Graphic3d_Texture2D: typeof Handle_Graphic3d_Texture2D;
  Handle_Graphic3d_Texture2D_1: typeof Handle_Graphic3d_Texture2D_1;
  Handle_Graphic3d_Texture2D_2: typeof Handle_Graphic3d_Texture2D_2;
  Handle_Graphic3d_Texture2D_3: typeof Handle_Graphic3d_Texture2D_3;
  Handle_Graphic3d_Texture2D_4: typeof Handle_Graphic3d_Texture2D_4;
  Graphic3d_Texture2D: typeof Graphic3d_Texture2D;
  Graphic3d_ValueInterface: typeof Graphic3d_ValueInterface;
  Graphic3d_ShaderVariable: typeof Graphic3d_ShaderVariable;
  Handle_Graphic3d_ShaderVariable: typeof Handle_Graphic3d_ShaderVariable;
  Handle_Graphic3d_ShaderVariable_1: typeof Handle_Graphic3d_ShaderVariable_1;
  Handle_Graphic3d_ShaderVariable_2: typeof Handle_Graphic3d_ShaderVariable_2;
  Handle_Graphic3d_ShaderVariable_3: typeof Handle_Graphic3d_ShaderVariable_3;
  Handle_Graphic3d_ShaderVariable_4: typeof Handle_Graphic3d_ShaderVariable_4;
  Graphic3d_Mat4: typeof Graphic3d_Mat4;
  Graphic3d_AlphaMode: Graphic3d_AlphaMode;
  Handle_Graphic3d_CubeMap: typeof Handle_Graphic3d_CubeMap;
  Handle_Graphic3d_CubeMap_1: typeof Handle_Graphic3d_CubeMap_1;
  Handle_Graphic3d_CubeMap_2: typeof Handle_Graphic3d_CubeMap_2;
  Handle_Graphic3d_CubeMap_3: typeof Handle_Graphic3d_CubeMap_3;
  Handle_Graphic3d_CubeMap_4: typeof Handle_Graphic3d_CubeMap_4;
  Handle_Graphic3d_HatchStyle: typeof Handle_Graphic3d_HatchStyle;
  Handle_Graphic3d_HatchStyle_1: typeof Handle_Graphic3d_HatchStyle_1;
  Handle_Graphic3d_HatchStyle_2: typeof Handle_Graphic3d_HatchStyle_2;
  Handle_Graphic3d_HatchStyle_3: typeof Handle_Graphic3d_HatchStyle_3;
  Handle_Graphic3d_HatchStyle_4: typeof Handle_Graphic3d_HatchStyle_4;
  Graphic3d_HatchStyle: typeof Graphic3d_HatchStyle;
  Graphic3d_HatchStyle_1: typeof Graphic3d_HatchStyle_1;
  Graphic3d_HatchStyle_2: typeof Graphic3d_HatchStyle_2;
  Graphic3d_RenderTransparentMethod: Graphic3d_RenderTransparentMethod;
  Graphic3d_PBRMaterial: typeof Graphic3d_PBRMaterial;
  Graphic3d_PBRMaterial_1: typeof Graphic3d_PBRMaterial_1;
  Graphic3d_PBRMaterial_2: typeof Graphic3d_PBRMaterial_2;
  Graphic3d_Vertex: typeof Graphic3d_Vertex;
  Graphic3d_Vertex_1: typeof Graphic3d_Vertex_1;
  Graphic3d_Vertex_2: typeof Graphic3d_Vertex_2;
  Graphic3d_Vertex_3: typeof Graphic3d_Vertex_3;
  Graphic3d_FrameStatsCounter: Graphic3d_FrameStatsCounter;
  Handle_Graphic3d_CLight: typeof Handle_Graphic3d_CLight;
  Handle_Graphic3d_CLight_1: typeof Handle_Graphic3d_CLight_1;
  Handle_Graphic3d_CLight_2: typeof Handle_Graphic3d_CLight_2;
  Handle_Graphic3d_CLight_3: typeof Handle_Graphic3d_CLight_3;
  Handle_Graphic3d_CLight_4: typeof Handle_Graphic3d_CLight_4;
  Graphic3d_CLight: typeof Graphic3d_CLight;
  Graphic3d_CameraTile: typeof Graphic3d_CameraTile;
  Graphic3d_TextureSetBits: Graphic3d_TextureSetBits;
  Graphic3d_NameOfTexture1D: Graphic3d_NameOfTexture1D;
  Graphic3d_TextureSet: typeof Graphic3d_TextureSet;
  Graphic3d_TextureSet_1: typeof Graphic3d_TextureSet_1;
  Graphic3d_TextureSet_2: typeof Graphic3d_TextureSet_2;
  Graphic3d_TextureSet_3: typeof Graphic3d_TextureSet_3;
  Handle_Graphic3d_TextureRoot: typeof Handle_Graphic3d_TextureRoot;
  Handle_Graphic3d_TextureRoot_1: typeof Handle_Graphic3d_TextureRoot_1;
  Handle_Graphic3d_TextureRoot_2: typeof Handle_Graphic3d_TextureRoot_2;
  Handle_Graphic3d_TextureRoot_3: typeof Handle_Graphic3d_TextureRoot_3;
  Handle_Graphic3d_TextureRoot_4: typeof Handle_Graphic3d_TextureRoot_4;
  Graphic3d_TextureRoot: typeof Graphic3d_TextureRoot;
  Graphic3d_FrameStatsTimer: Graphic3d_FrameStatsTimer;
  Graphic3d_TypeOfLightSource: Graphic3d_TypeOfLightSource;
  Graphic3d_Texture2Dplane: typeof Graphic3d_Texture2Dplane;
  Graphic3d_Texture2Dplane_1: typeof Graphic3d_Texture2Dplane_1;
  Graphic3d_Texture2Dplane_2: typeof Graphic3d_Texture2Dplane_2;
  Graphic3d_Texture2Dplane_3: typeof Graphic3d_Texture2Dplane_3;
  Handle_Graphic3d_Texture2Dplane: typeof Handle_Graphic3d_Texture2Dplane;
  Handle_Graphic3d_Texture2Dplane_1: typeof Handle_Graphic3d_Texture2Dplane_1;
  Handle_Graphic3d_Texture2Dplane_2: typeof Handle_Graphic3d_Texture2Dplane_2;
  Handle_Graphic3d_Texture2Dplane_3: typeof Handle_Graphic3d_Texture2Dplane_3;
  Handle_Graphic3d_Texture2Dplane_4: typeof Handle_Graphic3d_Texture2Dplane_4;
  PCDM_ReadWriter_1: typeof PCDM_ReadWriter_1;
  PCDM_SequenceOfReference: typeof PCDM_SequenceOfReference;
  PCDM_SequenceOfReference_1: typeof PCDM_SequenceOfReference_1;
  PCDM_SequenceOfReference_2: typeof PCDM_SequenceOfReference_2;
  PCDM_SequenceOfReference_3: typeof PCDM_SequenceOfReference_3;
  PCDM_Reference: typeof PCDM_Reference;
  PCDM_Reference_1: typeof PCDM_Reference_1;
  PCDM_Reference_2: typeof PCDM_Reference_2;
  PCDM_StoreStatus: PCDM_StoreStatus;
  PCDM_ReaderStatus: PCDM_ReaderStatus;
  PCDM_Reader: typeof PCDM_Reader;
  Handle_PCDM_DriverError: typeof Handle_PCDM_DriverError;
  Handle_PCDM_DriverError_1: typeof Handle_PCDM_DriverError_1;
  Handle_PCDM_DriverError_2: typeof Handle_PCDM_DriverError_2;
  Handle_PCDM_DriverError_3: typeof Handle_PCDM_DriverError_3;
  Handle_PCDM_DriverError_4: typeof Handle_PCDM_DriverError_4;
  PCDM_DriverError: typeof PCDM_DriverError;
  PCDM_DriverError_1: typeof PCDM_DriverError_1;
  PCDM_DriverError_2: typeof PCDM_DriverError_2;
  PCDM: typeof PCDM;
  Handle_PCDM_RetrievalDriver: typeof Handle_PCDM_RetrievalDriver;
  Handle_PCDM_RetrievalDriver_1: typeof Handle_PCDM_RetrievalDriver_1;
  Handle_PCDM_RetrievalDriver_2: typeof Handle_PCDM_RetrievalDriver_2;
  Handle_PCDM_RetrievalDriver_3: typeof Handle_PCDM_RetrievalDriver_3;
  Handle_PCDM_RetrievalDriver_4: typeof Handle_PCDM_RetrievalDriver_4;
  PCDM_RetrievalDriver: typeof PCDM_RetrievalDriver;
  PCDM_ReferenceIterator: typeof PCDM_ReferenceIterator;
  Handle_PCDM_ReferenceIterator: typeof Handle_PCDM_ReferenceIterator;
  Handle_PCDM_ReferenceIterator_1: typeof Handle_PCDM_ReferenceIterator_1;
  Handle_PCDM_ReferenceIterator_2: typeof Handle_PCDM_ReferenceIterator_2;
  Handle_PCDM_ReferenceIterator_3: typeof Handle_PCDM_ReferenceIterator_3;
  Handle_PCDM_ReferenceIterator_4: typeof Handle_PCDM_ReferenceIterator_4;
  PCDM_Writer: typeof PCDM_Writer;
  Handle_PCDM_Writer: typeof Handle_PCDM_Writer;
  Handle_PCDM_Writer_1: typeof Handle_PCDM_Writer_1;
  Handle_PCDM_Writer_2: typeof Handle_PCDM_Writer_2;
  Handle_PCDM_Writer_3: typeof Handle_PCDM_Writer_3;
  Handle_PCDM_Writer_4: typeof Handle_PCDM_Writer_4;
  Handle_PCDM_StorageDriver: typeof Handle_PCDM_StorageDriver;
  Handle_PCDM_StorageDriver_1: typeof Handle_PCDM_StorageDriver_1;
  Handle_PCDM_StorageDriver_2: typeof Handle_PCDM_StorageDriver_2;
  Handle_PCDM_StorageDriver_3: typeof Handle_PCDM_StorageDriver_3;
  Handle_PCDM_StorageDriver_4: typeof Handle_PCDM_StorageDriver_4;
  PCDM_StorageDriver: typeof PCDM_StorageDriver;
  PCDM_Document: typeof PCDM_Document;
  Handle_PCDM_Document: typeof Handle_PCDM_Document;
  Handle_PCDM_Document_1: typeof Handle_PCDM_Document_1;
  Handle_PCDM_Document_2: typeof Handle_PCDM_Document_2;
  Handle_PCDM_Document_3: typeof Handle_PCDM_Document_3;
  Handle_PCDM_Document_4: typeof Handle_PCDM_Document_4;
  PCDM_ReadWriter: typeof PCDM_ReadWriter;
  Handle_PCDM_ReadWriter: typeof Handle_PCDM_ReadWriter;
  Handle_PCDM_ReadWriter_1: typeof Handle_PCDM_ReadWriter_1;
  Handle_PCDM_ReadWriter_2: typeof Handle_PCDM_ReadWriter_2;
  Handle_PCDM_ReadWriter_3: typeof Handle_PCDM_ReadWriter_3;
  Handle_PCDM_ReadWriter_4: typeof Handle_PCDM_ReadWriter_4;
  PCDM_TypeOfFileDriver: PCDM_TypeOfFileDriver;
  PCDM_DOMHeaderParser: typeof PCDM_DOMHeaderParser;
  StepToGeom: typeof StepToGeom;
  GeomAPI_ProjectPointOnSurf: typeof GeomAPI_ProjectPointOnSurf;
  GeomAPI_ProjectPointOnSurf_1: typeof GeomAPI_ProjectPointOnSurf_1;
  GeomAPI_ProjectPointOnSurf_2: typeof GeomAPI_ProjectPointOnSurf_2;
  GeomAPI_ProjectPointOnSurf_3: typeof GeomAPI_ProjectPointOnSurf_3;
  GeomAPI_ProjectPointOnSurf_4: typeof GeomAPI_ProjectPointOnSurf_4;
  GeomAPI_ProjectPointOnSurf_5: typeof GeomAPI_ProjectPointOnSurf_5;
  GeomAPI_PointsToBSplineSurface: typeof GeomAPI_PointsToBSplineSurface;
  GeomAPI_PointsToBSplineSurface_1: typeof GeomAPI_PointsToBSplineSurface_1;
  GeomAPI_PointsToBSplineSurface_2: typeof GeomAPI_PointsToBSplineSurface_2;
  GeomAPI_PointsToBSplineSurface_3: typeof GeomAPI_PointsToBSplineSurface_3;
  GeomAPI_PointsToBSplineSurface_4: typeof GeomAPI_PointsToBSplineSurface_4;
  GeomAPI_PointsToBSplineSurface_5: typeof GeomAPI_PointsToBSplineSurface_5;
  GeomAPI_PointsToBSpline: typeof GeomAPI_PointsToBSpline;
  GeomAPI_PointsToBSpline_1: typeof GeomAPI_PointsToBSpline_1;
  GeomAPI_PointsToBSpline_2: typeof GeomAPI_PointsToBSpline_2;
  GeomAPI_PointsToBSpline_3: typeof GeomAPI_PointsToBSpline_3;
  GeomAPI_PointsToBSpline_4: typeof GeomAPI_PointsToBSpline_4;
  GeomAPI_PointsToBSpline_5: typeof GeomAPI_PointsToBSpline_5;
  GeomAPI_ExtremaSurfaceSurface: typeof GeomAPI_ExtremaSurfaceSurface;
  GeomAPI_ExtremaSurfaceSurface_1: typeof GeomAPI_ExtremaSurfaceSurface_1;
  GeomAPI_ExtremaSurfaceSurface_2: typeof GeomAPI_ExtremaSurfaceSurface_2;
  GeomAPI_ExtremaSurfaceSurface_3: typeof GeomAPI_ExtremaSurfaceSurface_3;
  GeomAPI_Interpolate: typeof GeomAPI_Interpolate;
  GeomAPI_Interpolate_1: typeof GeomAPI_Interpolate_1;
  GeomAPI_Interpolate_2: typeof GeomAPI_Interpolate_2;
  GeomAPI_ExtremaCurveCurve: typeof GeomAPI_ExtremaCurveCurve;
  GeomAPI_ExtremaCurveCurve_1: typeof GeomAPI_ExtremaCurveCurve_1;
  GeomAPI_ExtremaCurveCurve_2: typeof GeomAPI_ExtremaCurveCurve_2;
  GeomAPI_ExtremaCurveCurve_3: typeof GeomAPI_ExtremaCurveCurve_3;
  GeomAPI_IntCS: typeof GeomAPI_IntCS;
  GeomAPI_IntCS_1: typeof GeomAPI_IntCS_1;
  GeomAPI_IntCS_2: typeof GeomAPI_IntCS_2;
  GeomAPI_ProjectPointOnCurve: typeof GeomAPI_ProjectPointOnCurve;
  GeomAPI_ProjectPointOnCurve_1: typeof GeomAPI_ProjectPointOnCurve_1;
  GeomAPI_ProjectPointOnCurve_2: typeof GeomAPI_ProjectPointOnCurve_2;
  GeomAPI_ProjectPointOnCurve_3: typeof GeomAPI_ProjectPointOnCurve_3;
  GeomAPI_ExtremaCurveSurface: typeof GeomAPI_ExtremaCurveSurface;
  GeomAPI_ExtremaCurveSurface_1: typeof GeomAPI_ExtremaCurveSurface_1;
  GeomAPI_ExtremaCurveSurface_2: typeof GeomAPI_ExtremaCurveSurface_2;
  GeomAPI_ExtremaCurveSurface_3: typeof GeomAPI_ExtremaCurveSurface_3;
  GeomAPI: typeof GeomAPI;
  GeomAPI_IntSS: typeof GeomAPI_IntSS;
  GeomAPI_IntSS_1: typeof GeomAPI_IntSS_1;
  GeomAPI_IntSS_2: typeof GeomAPI_IntSS_2;
  Handle_STEPSelections_SelectGSCurves: typeof Handle_STEPSelections_SelectGSCurves;
  Handle_STEPSelections_SelectGSCurves_1: typeof Handle_STEPSelections_SelectGSCurves_1;
  Handle_STEPSelections_SelectGSCurves_2: typeof Handle_STEPSelections_SelectGSCurves_2;
  Handle_STEPSelections_SelectGSCurves_3: typeof Handle_STEPSelections_SelectGSCurves_3;
  Handle_STEPSelections_SelectGSCurves_4: typeof Handle_STEPSelections_SelectGSCurves_4;
  STEPSelections_SelectGSCurves: typeof STEPSelections_SelectGSCurves;
  Handle_STEPSelections_SelectInstances: typeof Handle_STEPSelections_SelectInstances;
  Handle_STEPSelections_SelectInstances_1: typeof Handle_STEPSelections_SelectInstances_1;
  Handle_STEPSelections_SelectInstances_2: typeof Handle_STEPSelections_SelectInstances_2;
  Handle_STEPSelections_SelectInstances_3: typeof Handle_STEPSelections_SelectInstances_3;
  Handle_STEPSelections_SelectInstances_4: typeof Handle_STEPSelections_SelectInstances_4;
  STEPSelections_SelectInstances: typeof STEPSelections_SelectInstances;
  Handle_STEPSelections_AssemblyComponent: typeof Handle_STEPSelections_AssemblyComponent;
  Handle_STEPSelections_AssemblyComponent_1: typeof Handle_STEPSelections_AssemblyComponent_1;
  Handle_STEPSelections_AssemblyComponent_2: typeof Handle_STEPSelections_AssemblyComponent_2;
  Handle_STEPSelections_AssemblyComponent_3: typeof Handle_STEPSelections_AssemblyComponent_3;
  Handle_STEPSelections_AssemblyComponent_4: typeof Handle_STEPSelections_AssemblyComponent_4;
  STEPSelections_AssemblyComponent: typeof STEPSelections_AssemblyComponent;
  STEPSelections_AssemblyComponent_1: typeof STEPSelections_AssemblyComponent_1;
  STEPSelections_AssemblyComponent_2: typeof STEPSelections_AssemblyComponent_2;
  STEPSelections_SelectDerived: typeof STEPSelections_SelectDerived;
  Handle_STEPSelections_SelectDerived: typeof Handle_STEPSelections_SelectDerived;
  Handle_STEPSelections_SelectDerived_1: typeof Handle_STEPSelections_SelectDerived_1;
  Handle_STEPSelections_SelectDerived_2: typeof Handle_STEPSelections_SelectDerived_2;
  Handle_STEPSelections_SelectDerived_3: typeof Handle_STEPSelections_SelectDerived_3;
  Handle_STEPSelections_SelectDerived_4: typeof Handle_STEPSelections_SelectDerived_4;
  Handle_STEPSelections_HSequenceOfAssemblyLink: typeof Handle_STEPSelections_HSequenceOfAssemblyLink;
  Handle_STEPSelections_HSequenceOfAssemblyLink_1: typeof Handle_STEPSelections_HSequenceOfAssemblyLink_1;
  Handle_STEPSelections_HSequenceOfAssemblyLink_2: typeof Handle_STEPSelections_HSequenceOfAssemblyLink_2;
  Handle_STEPSelections_HSequenceOfAssemblyLink_3: typeof Handle_STEPSelections_HSequenceOfAssemblyLink_3;
  Handle_STEPSelections_HSequenceOfAssemblyLink_4: typeof Handle_STEPSelections_HSequenceOfAssemblyLink_4;
  Handle_STEPSelections_SelectAssembly: typeof Handle_STEPSelections_SelectAssembly;
  Handle_STEPSelections_SelectAssembly_1: typeof Handle_STEPSelections_SelectAssembly_1;
  Handle_STEPSelections_SelectAssembly_2: typeof Handle_STEPSelections_SelectAssembly_2;
  Handle_STEPSelections_SelectAssembly_3: typeof Handle_STEPSelections_SelectAssembly_3;
  Handle_STEPSelections_SelectAssembly_4: typeof Handle_STEPSelections_SelectAssembly_4;
  STEPSelections_SelectAssembly: typeof STEPSelections_SelectAssembly;
  Handle_STEPSelections_SelectFaces: typeof Handle_STEPSelections_SelectFaces;
  Handle_STEPSelections_SelectFaces_1: typeof Handle_STEPSelections_SelectFaces_1;
  Handle_STEPSelections_SelectFaces_2: typeof Handle_STEPSelections_SelectFaces_2;
  Handle_STEPSelections_SelectFaces_3: typeof Handle_STEPSelections_SelectFaces_3;
  Handle_STEPSelections_SelectFaces_4: typeof Handle_STEPSelections_SelectFaces_4;
  STEPSelections_SelectFaces: typeof STEPSelections_SelectFaces;
  STEPSelections_AssemblyLink: typeof STEPSelections_AssemblyLink;
  STEPSelections_AssemblyLink_1: typeof STEPSelections_AssemblyLink_1;
  STEPSelections_AssemblyLink_2: typeof STEPSelections_AssemblyLink_2;
  Handle_STEPSelections_AssemblyLink: typeof Handle_STEPSelections_AssemblyLink;
  Handle_STEPSelections_AssemblyLink_1: typeof Handle_STEPSelections_AssemblyLink_1;
  Handle_STEPSelections_AssemblyLink_2: typeof Handle_STEPSelections_AssemblyLink_2;
  Handle_STEPSelections_AssemblyLink_3: typeof Handle_STEPSelections_AssemblyLink_3;
  Handle_STEPSelections_AssemblyLink_4: typeof Handle_STEPSelections_AssemblyLink_4;
  STEPSelections_AssemblyExplorer: typeof STEPSelections_AssemblyExplorer;
  STEPSelections_SelectForTransfer: typeof STEPSelections_SelectForTransfer;
  STEPSelections_SelectForTransfer_1: typeof STEPSelections_SelectForTransfer_1;
  STEPSelections_SelectForTransfer_2: typeof STEPSelections_SelectForTransfer_2;
  Handle_STEPSelections_SelectForTransfer: typeof Handle_STEPSelections_SelectForTransfer;
  Handle_STEPSelections_SelectForTransfer_1: typeof Handle_STEPSelections_SelectForTransfer_1;
  Handle_STEPSelections_SelectForTransfer_2: typeof Handle_STEPSelections_SelectForTransfer_2;
  Handle_STEPSelections_SelectForTransfer_3: typeof Handle_STEPSelections_SelectForTransfer_3;
  Handle_STEPSelections_SelectForTransfer_4: typeof Handle_STEPSelections_SelectForTransfer_4;
  PLib_DoubleJacobiPolynomial: typeof PLib_DoubleJacobiPolynomial;
  PLib_DoubleJacobiPolynomial_1: typeof PLib_DoubleJacobiPolynomial_1;
  PLib_DoubleJacobiPolynomial_2: typeof PLib_DoubleJacobiPolynomial_2;
  PLib: typeof PLib;
  PLib_HermitJacobi: typeof PLib_HermitJacobi;
  Handle_PLib_HermitJacobi: typeof Handle_PLib_HermitJacobi;
  Handle_PLib_HermitJacobi_1: typeof Handle_PLib_HermitJacobi_1;
  Handle_PLib_HermitJacobi_2: typeof Handle_PLib_HermitJacobi_2;
  Handle_PLib_HermitJacobi_3: typeof Handle_PLib_HermitJacobi_3;
  Handle_PLib_HermitJacobi_4: typeof Handle_PLib_HermitJacobi_4;
  PLib_JacobiPolynomial: typeof PLib_JacobiPolynomial;
  Handle_PLib_JacobiPolynomial: typeof Handle_PLib_JacobiPolynomial;
  Handle_PLib_JacobiPolynomial_1: typeof Handle_PLib_JacobiPolynomial_1;
  Handle_PLib_JacobiPolynomial_2: typeof Handle_PLib_JacobiPolynomial_2;
  Handle_PLib_JacobiPolynomial_3: typeof Handle_PLib_JacobiPolynomial_3;
  Handle_PLib_JacobiPolynomial_4: typeof Handle_PLib_JacobiPolynomial_4;
  Handle_PLib_Base: typeof Handle_PLib_Base;
  Handle_PLib_Base_1: typeof Handle_PLib_Base_1;
  Handle_PLib_Base_2: typeof Handle_PLib_Base_2;
  Handle_PLib_Base_3: typeof Handle_PLib_Base_3;
  Handle_PLib_Base_4: typeof Handle_PLib_Base_4;
  PLib_Base: typeof PLib_Base;
  gp_QuaternionNLerp: typeof gp_QuaternionNLerp;
  gp_QuaternionNLerp_1: typeof gp_QuaternionNLerp_1;
  gp_QuaternionNLerp_2: typeof gp_QuaternionNLerp_2;
  gp_Quaternion: typeof gp_Quaternion;
  gp_Quaternion_1: typeof gp_Quaternion_1;
  gp_Quaternion_2: typeof gp_Quaternion_2;
  gp_Quaternion_3: typeof gp_Quaternion_3;
  gp_Quaternion_4: typeof gp_Quaternion_4;
  gp_Quaternion_5: typeof gp_Quaternion_5;
  gp_Quaternion_6: typeof gp_Quaternion_6;
  gp_Sphere: typeof gp_Sphere;
  gp_Sphere_1: typeof gp_Sphere_1;
  gp_Sphere_2: typeof gp_Sphere_2;
  gp_Ax2: typeof gp_Ax2;
  gp_Ax2_1: typeof gp_Ax2_1;
  gp_Ax2_2: typeof gp_Ax2_2;
  gp_Ax2_3: typeof gp_Ax2_3;
  gp_Elips: typeof gp_Elips;
  gp_Elips_1: typeof gp_Elips_1;
  gp_Elips_2: typeof gp_Elips_2;
  gp_XY: typeof gp_XY;
  gp_XY_1: typeof gp_XY_1;
  gp_XY_2: typeof gp_XY_2;
  gp_Ax3: typeof gp_Ax3;
  gp_Ax3_1: typeof gp_Ax3_1;
  gp_Ax3_2: typeof gp_Ax3_2;
  gp_Ax3_3: typeof gp_Ax3_3;
  gp_Ax3_4: typeof gp_Ax3_4;
  gp_Parab2d: typeof gp_Parab2d;
  gp_Parab2d_1: typeof gp_Parab2d_1;
  gp_Parab2d_2: typeof gp_Parab2d_2;
  gp_Parab2d_3: typeof gp_Parab2d_3;
  gp_Parab2d_4: typeof gp_Parab2d_4;
  gp_GTrsf: typeof gp_GTrsf;
  gp_GTrsf_1: typeof gp_GTrsf_1;
  gp_GTrsf_2: typeof gp_GTrsf_2;
  gp_GTrsf_3: typeof gp_GTrsf_3;
  gp_Circ2d: typeof gp_Circ2d;
  gp_Circ2d_1: typeof gp_Circ2d_1;
  gp_Circ2d_2: typeof gp_Circ2d_2;
  gp_Circ2d_3: typeof gp_Circ2d_3;
  gp_Ax22d: typeof gp_Ax22d;
  gp_Ax22d_1: typeof gp_Ax22d_1;
  gp_Ax22d_2: typeof gp_Ax22d_2;
  gp_Ax22d_3: typeof gp_Ax22d_3;
  gp_Ax22d_4: typeof gp_Ax22d_4;
  gp_Ax2d: typeof gp_Ax2d;
  gp_Ax2d_1: typeof gp_Ax2d_1;
  gp_Ax2d_2: typeof gp_Ax2d_2;
  gp_Elips2d: typeof gp_Elips2d;
  gp_Elips2d_1: typeof gp_Elips2d_1;
  gp_Elips2d_2: typeof gp_Elips2d_2;
  gp_Elips2d_3: typeof gp_Elips2d_3;
  gp_Pnt2d: typeof gp_Pnt2d;
  gp_Pnt2d_1: typeof gp_Pnt2d_1;
  gp_Pnt2d_2: typeof gp_Pnt2d_2;
  gp_Pnt2d_3: typeof gp_Pnt2d_3;
  gp_Vec: typeof gp_Vec;
  gp_Vec_1: typeof gp_Vec_1;
  gp_Vec_2: typeof gp_Vec_2;
  gp_Vec_3: typeof gp_Vec_3;
  gp_Vec_4: typeof gp_Vec_4;
  gp_Vec_5: typeof gp_Vec_5;
  gp_TrsfForm: gp_TrsfForm;
  gp_Hypr2d: typeof gp_Hypr2d;
  gp_Hypr2d_1: typeof gp_Hypr2d_1;
  gp_Hypr2d_2: typeof gp_Hypr2d_2;
  gp_Hypr2d_3: typeof gp_Hypr2d_3;
  gp_Ax1: typeof gp_Ax1;
  gp_Ax1_1: typeof gp_Ax1_1;
  gp_Ax1_2: typeof gp_Ax1_2;
  gp_XYZ: typeof gp_XYZ;
  gp_XYZ_1: typeof gp_XYZ_1;
  gp_XYZ_2: typeof gp_XYZ_2;
  gp_Torus: typeof gp_Torus;
  gp_Torus_1: typeof gp_Torus_1;
  gp_Torus_2: typeof gp_Torus_2;
  gp_Cylinder: typeof gp_Cylinder;
  gp_Cylinder_1: typeof gp_Cylinder_1;
  gp_Cylinder_2: typeof gp_Cylinder_2;
  gp_GTrsf2d: typeof gp_GTrsf2d;
  gp_GTrsf2d_1: typeof gp_GTrsf2d_1;
  gp_GTrsf2d_2: typeof gp_GTrsf2d_2;
  gp_GTrsf2d_3: typeof gp_GTrsf2d_3;
  gp_Trsf: typeof gp_Trsf;
  gp_Trsf_1: typeof gp_Trsf_1;
  gp_Trsf_2: typeof gp_Trsf_2;
  gp_Pnt: typeof gp_Pnt;
  gp_Pnt_1: typeof gp_Pnt_1;
  gp_Pnt_2: typeof gp_Pnt_2;
  gp_Pnt_3: typeof gp_Pnt_3;
  gp_Trsf2d: typeof gp_Trsf2d;
  gp_Trsf2d_1: typeof gp_Trsf2d_1;
  gp_Trsf2d_2: typeof gp_Trsf2d_2;
  Handle_gp_VectorWithNullMagnitude: typeof Handle_gp_VectorWithNullMagnitude;
  Handle_gp_VectorWithNullMagnitude_1: typeof Handle_gp_VectorWithNullMagnitude_1;
  Handle_gp_VectorWithNullMagnitude_2: typeof Handle_gp_VectorWithNullMagnitude_2;
  Handle_gp_VectorWithNullMagnitude_3: typeof Handle_gp_VectorWithNullMagnitude_3;
  Handle_gp_VectorWithNullMagnitude_4: typeof Handle_gp_VectorWithNullMagnitude_4;
  gp_QuaternionSLerp: typeof gp_QuaternionSLerp;
  gp_QuaternionSLerp_1: typeof gp_QuaternionSLerp_1;
  gp_QuaternionSLerp_2: typeof gp_QuaternionSLerp_2;
  gp: typeof gp;
  gp_Lin: typeof gp_Lin;
  gp_Lin_1: typeof gp_Lin_1;
  gp_Lin_2: typeof gp_Lin_2;
  gp_Lin_3: typeof gp_Lin_3;
  gp_Vec2d: typeof gp_Vec2d;
  gp_Vec2d_1: typeof gp_Vec2d_1;
  gp_Vec2d_2: typeof gp_Vec2d_2;
  gp_Vec2d_3: typeof gp_Vec2d_3;
  gp_Vec2d_4: typeof gp_Vec2d_4;
  gp_Vec2d_5: typeof gp_Vec2d_5;
  gp_TrsfNLerp: typeof gp_TrsfNLerp;
  gp_TrsfNLerp_1: typeof gp_TrsfNLerp_1;
  gp_TrsfNLerp_2: typeof gp_TrsfNLerp_2;
  gp_Pln: typeof gp_Pln;
  gp_Pln_1: typeof gp_Pln_1;
  gp_Pln_2: typeof gp_Pln_2;
  gp_Pln_3: typeof gp_Pln_3;
  gp_Pln_4: typeof gp_Pln_4;
  gp_EulerSequence: gp_EulerSequence;
  gp_Mat: typeof gp_Mat;
  gp_Mat_1: typeof gp_Mat_1;
  gp_Mat_2: typeof gp_Mat_2;
  gp_Mat_3: typeof gp_Mat_3;
  gp_Cone: typeof gp_Cone;
  gp_Cone_1: typeof gp_Cone_1;
  gp_Cone_2: typeof gp_Cone_2;
  gp_Dir: typeof gp_Dir;
  gp_Dir_1: typeof gp_Dir_1;
  gp_Dir_2: typeof gp_Dir_2;
  gp_Dir_3: typeof gp_Dir_3;
  gp_Dir_4: typeof gp_Dir_4;
  gp_Lin2d: typeof gp_Lin2d;
  gp_Lin2d_1: typeof gp_Lin2d_1;
  gp_Lin2d_2: typeof gp_Lin2d_2;
  gp_Lin2d_3: typeof gp_Lin2d_3;
  gp_Lin2d_4: typeof gp_Lin2d_4;
  gp_Hypr: typeof gp_Hypr;
  gp_Hypr_1: typeof gp_Hypr_1;
  gp_Hypr_2: typeof gp_Hypr_2;
  gp_Circ: typeof gp_Circ;
  gp_Circ_1: typeof gp_Circ_1;
  gp_Circ_2: typeof gp_Circ_2;
  gp_Dir2d: typeof gp_Dir2d;
  gp_Dir2d_1: typeof gp_Dir2d_1;
  gp_Dir2d_2: typeof gp_Dir2d_2;
  gp_Dir2d_3: typeof gp_Dir2d_3;
  gp_Dir2d_4: typeof gp_Dir2d_4;
  gp_Parab: typeof gp_Parab;
  gp_Parab_1: typeof gp_Parab_1;
  gp_Parab_2: typeof gp_Parab_2;
  gp_Parab_3: typeof gp_Parab_3;
  gp_Mat2d: typeof gp_Mat2d;
  gp_Mat2d_1: typeof gp_Mat2d_1;
  gp_Mat2d_2: typeof gp_Mat2d_2;
  AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute: typeof AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute;
  AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_1: typeof AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_1;
  AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_2: typeof AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_2;
  AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_3: typeof AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_3;
  AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_4: typeof AppDef_ParLeastSquareOfMyGradientbisOfBSplineCompute_4;
  AppDef_Compute: typeof AppDef_Compute;
  AppDef_Compute_1: typeof AppDef_Compute_1;
  AppDef_Compute_2: typeof AppDef_Compute_2;
  AppDef_Compute_3: typeof AppDef_Compute_3;
  AppDef_Compute_4: typeof AppDef_Compute_4;
  AppDef_BSplineCompute: typeof AppDef_BSplineCompute;
  AppDef_BSplineCompute_1: typeof AppDef_BSplineCompute_1;
  AppDef_BSplineCompute_2: typeof AppDef_BSplineCompute_2;
  AppDef_BSplineCompute_3: typeof AppDef_BSplineCompute_3;
  AppDef_BSplineCompute_4: typeof AppDef_BSplineCompute_4;
  AppDef_Gradient_BFGSOfTheGradient: typeof AppDef_Gradient_BFGSOfTheGradient;
  AppDef_TheGradient: typeof AppDef_TheGradient;
  AppDef_LinearCriteria: typeof AppDef_LinearCriteria;
  Handle_AppDef_LinearCriteria: typeof Handle_AppDef_LinearCriteria;
  Handle_AppDef_LinearCriteria_1: typeof Handle_AppDef_LinearCriteria_1;
  Handle_AppDef_LinearCriteria_2: typeof Handle_AppDef_LinearCriteria_2;
  Handle_AppDef_LinearCriteria_3: typeof Handle_AppDef_LinearCriteria_3;
  Handle_AppDef_LinearCriteria_4: typeof Handle_AppDef_LinearCriteria_4;
  AppDef_MultiLine: typeof AppDef_MultiLine;
  AppDef_MultiLine_1: typeof AppDef_MultiLine_1;
  AppDef_MultiLine_2: typeof AppDef_MultiLine_2;
  AppDef_MultiLine_3: typeof AppDef_MultiLine_3;
  AppDef_MultiLine_4: typeof AppDef_MultiLine_4;
  AppDef_MultiLine_5: typeof AppDef_MultiLine_5;
  AppDef_ParLeastSquareOfTheGradient: typeof AppDef_ParLeastSquareOfTheGradient;
  AppDef_ParLeastSquareOfTheGradient_1: typeof AppDef_ParLeastSquareOfTheGradient_1;
  AppDef_ParLeastSquareOfTheGradient_2: typeof AppDef_ParLeastSquareOfTheGradient_2;
  AppDef_ParLeastSquareOfTheGradient_3: typeof AppDef_ParLeastSquareOfTheGradient_3;
  AppDef_ParLeastSquareOfTheGradient_4: typeof AppDef_ParLeastSquareOfTheGradient_4;
  AppDef_ResConstraintOfTheGradient: typeof AppDef_ResConstraintOfTheGradient;
  AppDef_MyGradientbisOfBSplineCompute: typeof AppDef_MyGradientbisOfBSplineCompute;
  AppDef_MultiPointConstraint: typeof AppDef_MultiPointConstraint;
  AppDef_MultiPointConstraint_1: typeof AppDef_MultiPointConstraint_1;
  AppDef_MultiPointConstraint_2: typeof AppDef_MultiPointConstraint_2;
  AppDef_MultiPointConstraint_3: typeof AppDef_MultiPointConstraint_3;
  AppDef_MultiPointConstraint_4: typeof AppDef_MultiPointConstraint_4;
  AppDef_MultiPointConstraint_5: typeof AppDef_MultiPointConstraint_5;
  AppDef_MultiPointConstraint_6: typeof AppDef_MultiPointConstraint_6;
  AppDef_MultiPointConstraint_7: typeof AppDef_MultiPointConstraint_7;
  AppDef_MultiPointConstraint_8: typeof AppDef_MultiPointConstraint_8;
  AppDef_MultiPointConstraint_9: typeof AppDef_MultiPointConstraint_9;
  AppDef_MultiPointConstraint_10: typeof AppDef_MultiPointConstraint_10;
  AppDef_MultiPointConstraint_11: typeof AppDef_MultiPointConstraint_11;
  AppDef_BSpGradient_BFGSOfMyBSplGradientOfBSplineCompute: typeof AppDef_BSpGradient_BFGSOfMyBSplGradientOfBSplineCompute;
  AppDef_ParFunctionOfMyGradientbisOfBSplineCompute: typeof AppDef_ParFunctionOfMyGradientbisOfBSplineCompute;
  AppDef_MyLineTool: typeof AppDef_MyLineTool;
  AppDef_TheFunction: typeof AppDef_TheFunction;
  AppDef_SmoothCriterion: typeof AppDef_SmoothCriterion;
  Handle_AppDef_SmoothCriterion: typeof Handle_AppDef_SmoothCriterion;
  Handle_AppDef_SmoothCriterion_1: typeof Handle_AppDef_SmoothCriterion_1;
  Handle_AppDef_SmoothCriterion_2: typeof Handle_AppDef_SmoothCriterion_2;
  Handle_AppDef_SmoothCriterion_3: typeof Handle_AppDef_SmoothCriterion_3;
  Handle_AppDef_SmoothCriterion_4: typeof Handle_AppDef_SmoothCriterion_4;
  AppDef_Variational: typeof AppDef_Variational;
  AppDef_MyGradientOfCompute: typeof AppDef_MyGradientOfCompute;
  AppDef_Gradient_BFGSOfMyGradientbisOfBSplineCompute: typeof AppDef_Gradient_BFGSOfMyGradientbisOfBSplineCompute;
  AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute: typeof AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute;
  AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_1: typeof AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_1;
  AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_2: typeof AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_2;
  AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_3: typeof AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_3;
  AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_4: typeof AppDef_BSpParLeastSquareOfMyBSplGradientOfBSplineCompute_4;
  AppDef_ParFunctionOfMyGradientOfCompute: typeof AppDef_ParFunctionOfMyGradientOfCompute;
  AppDef_ParLeastSquareOfMyGradientOfCompute: typeof AppDef_ParLeastSquareOfMyGradientOfCompute;
  AppDef_ParLeastSquareOfMyGradientOfCompute_1: typeof AppDef_ParLeastSquareOfMyGradientOfCompute_1;
  AppDef_ParLeastSquareOfMyGradientOfCompute_2: typeof AppDef_ParLeastSquareOfMyGradientOfCompute_2;
  AppDef_ParLeastSquareOfMyGradientOfCompute_3: typeof AppDef_ParLeastSquareOfMyGradientOfCompute_3;
  AppDef_ParLeastSquareOfMyGradientOfCompute_4: typeof AppDef_ParLeastSquareOfMyGradientOfCompute_4;
  AppDef_TheResol: typeof AppDef_TheResol;
  AppDef_MyBSplGradientOfBSplineCompute: typeof AppDef_MyBSplGradientOfBSplineCompute;
  AppDef_MyBSplGradientOfBSplineCompute_1: typeof AppDef_MyBSplGradientOfBSplineCompute_1;
  AppDef_MyBSplGradientOfBSplineCompute_2: typeof AppDef_MyBSplGradientOfBSplineCompute_2;
  Handle_AppDef_HArray1OfMultiPointConstraint: typeof Handle_AppDef_HArray1OfMultiPointConstraint;
  Handle_AppDef_HArray1OfMultiPointConstraint_1: typeof Handle_AppDef_HArray1OfMultiPointConstraint_1;
  Handle_AppDef_HArray1OfMultiPointConstraint_2: typeof Handle_AppDef_HArray1OfMultiPointConstraint_2;
  Handle_AppDef_HArray1OfMultiPointConstraint_3: typeof Handle_AppDef_HArray1OfMultiPointConstraint_3;
  Handle_AppDef_HArray1OfMultiPointConstraint_4: typeof Handle_AppDef_HArray1OfMultiPointConstraint_4;
  AppDef_BSpParFunctionOfMyBSplGradientOfBSplineCompute: typeof AppDef_BSpParFunctionOfMyBSplGradientOfBSplineCompute;
  AppDef_ResConstraintOfMyGradientOfCompute: typeof AppDef_ResConstraintOfMyGradientOfCompute;
  AppDef_Gradient_BFGSOfMyGradientOfCompute: typeof AppDef_Gradient_BFGSOfMyGradientOfCompute;
  AppDef_TheLeastSquares: typeof AppDef_TheLeastSquares;
  AppDef_TheLeastSquares_1: typeof AppDef_TheLeastSquares_1;
  AppDef_TheLeastSquares_2: typeof AppDef_TheLeastSquares_2;
  AppDef_TheLeastSquares_3: typeof AppDef_TheLeastSquares_3;
  AppDef_TheLeastSquares_4: typeof AppDef_TheLeastSquares_4;
  AppDef_ResConstraintOfMyGradientbisOfBSplineCompute: typeof AppDef_ResConstraintOfMyGradientbisOfBSplineCompute;
  AppDef_ParFunctionOfTheGradient: typeof AppDef_ParFunctionOfTheGradient;
  AppDef_Array1OfMultiPointConstraint: typeof AppDef_Array1OfMultiPointConstraint;
  AppDef_Array1OfMultiPointConstraint_1: typeof AppDef_Array1OfMultiPointConstraint_1;
  AppDef_Array1OfMultiPointConstraint_2: typeof AppDef_Array1OfMultiPointConstraint_2;
  AppDef_Array1OfMultiPointConstraint_3: typeof AppDef_Array1OfMultiPointConstraint_3;
  AppDef_Array1OfMultiPointConstraint_4: typeof AppDef_Array1OfMultiPointConstraint_4;
  AppDef_Array1OfMultiPointConstraint_5: typeof AppDef_Array1OfMultiPointConstraint_5;
  TopAbs: typeof TopAbs;
  TopAbs_Orientation: TopAbs_Orientation;
  TopAbs_State: TopAbs_State;
  TopAbs_ShapeEnum: TopAbs_ShapeEnum;
  gce_MakeDir2d: typeof gce_MakeDir2d;
  gce_MakeDir2d_1: typeof gce_MakeDir2d_1;
  gce_MakeDir2d_2: typeof gce_MakeDir2d_2;
  gce_MakeDir2d_3: typeof gce_MakeDir2d_3;
  gce_MakeDir2d_4: typeof gce_MakeDir2d_4;
  gce_MakeMirror: typeof gce_MakeMirror;
  gce_MakeMirror_1: typeof gce_MakeMirror_1;
  gce_MakeMirror_2: typeof gce_MakeMirror_2;
  gce_MakeMirror_3: typeof gce_MakeMirror_3;
  gce_MakeMirror_4: typeof gce_MakeMirror_4;
  gce_MakeMirror_5: typeof gce_MakeMirror_5;
  gce_MakeMirror_6: typeof gce_MakeMirror_6;
  gce_MakeElips: typeof gce_MakeElips;
  gce_MakeElips_1: typeof gce_MakeElips_1;
  gce_MakeElips_2: typeof gce_MakeElips_2;
  gce_MakeMirror2d: typeof gce_MakeMirror2d;
  gce_MakeMirror2d_1: typeof gce_MakeMirror2d_1;
  gce_MakeMirror2d_2: typeof gce_MakeMirror2d_2;
  gce_MakeMirror2d_3: typeof gce_MakeMirror2d_3;
  gce_MakeMirror2d_4: typeof gce_MakeMirror2d_4;
  gce_MakeElips2d: typeof gce_MakeElips2d;
  gce_MakeElips2d_1: typeof gce_MakeElips2d_1;
  gce_MakeElips2d_2: typeof gce_MakeElips2d_2;
  gce_MakeElips2d_3: typeof gce_MakeElips2d_3;
  gce_MakeParab: typeof gce_MakeParab;
  gce_MakeParab_1: typeof gce_MakeParab_1;
  gce_MakeParab_2: typeof gce_MakeParab_2;
  gce_MakeCirc: typeof gce_MakeCirc;
  gce_MakeCirc_1: typeof gce_MakeCirc_1;
  gce_MakeCirc_2: typeof gce_MakeCirc_2;
  gce_MakeCirc_3: typeof gce_MakeCirc_3;
  gce_MakeCirc_4: typeof gce_MakeCirc_4;
  gce_MakeCirc_5: typeof gce_MakeCirc_5;
  gce_MakeCirc_6: typeof gce_MakeCirc_6;
  gce_MakeCirc_7: typeof gce_MakeCirc_7;
  gce_MakeCirc_8: typeof gce_MakeCirc_8;
  gce_MakeTranslation: typeof gce_MakeTranslation;
  gce_MakeTranslation_1: typeof gce_MakeTranslation_1;
  gce_MakeTranslation_2: typeof gce_MakeTranslation_2;
  gce_MakeParab2d: typeof gce_MakeParab2d;
  gce_MakeParab2d_1: typeof gce_MakeParab2d_1;
  gce_MakeParab2d_2: typeof gce_MakeParab2d_2;
  gce_MakeParab2d_3: typeof gce_MakeParab2d_3;
  gce_MakeParab2d_4: typeof gce_MakeParab2d_4;
  gce_MakePln: typeof gce_MakePln;
  gce_MakePln_1: typeof gce_MakePln_1;
  gce_MakePln_2: typeof gce_MakePln_2;
  gce_MakePln_3: typeof gce_MakePln_3;
  gce_MakePln_4: typeof gce_MakePln_4;
  gce_MakePln_5: typeof gce_MakePln_5;
  gce_MakePln_6: typeof gce_MakePln_6;
  gce_MakePln_7: typeof gce_MakePln_7;
  gce_MakePln_8: typeof gce_MakePln_8;
  gce_MakeCylinder: typeof gce_MakeCylinder;
  gce_MakeCylinder_1: typeof gce_MakeCylinder_1;
  gce_MakeCylinder_2: typeof gce_MakeCylinder_2;
  gce_MakeCylinder_3: typeof gce_MakeCylinder_3;
  gce_MakeCylinder_4: typeof gce_MakeCylinder_4;
  gce_MakeCylinder_5: typeof gce_MakeCylinder_5;
  gce_MakeCylinder_6: typeof gce_MakeCylinder_6;
  gce_MakeHypr2d: typeof gce_MakeHypr2d;
  gce_MakeHypr2d_1: typeof gce_MakeHypr2d_1;
  gce_MakeHypr2d_2: typeof gce_MakeHypr2d_2;
  gce_MakeHypr2d_3: typeof gce_MakeHypr2d_3;
  gce_MakeHypr: typeof gce_MakeHypr;
  gce_MakeHypr_1: typeof gce_MakeHypr_1;
  gce_MakeHypr_2: typeof gce_MakeHypr_2;
  gce_MakeCone: typeof gce_MakeCone;
  gce_MakeCone_1: typeof gce_MakeCone_1;
  gce_MakeCone_2: typeof gce_MakeCone_2;
  gce_MakeCone_3: typeof gce_MakeCone_3;
  gce_MakeCone_4: typeof gce_MakeCone_4;
  gce_MakeCone_5: typeof gce_MakeCone_5;
  gce_MakeCone_6: typeof gce_MakeCone_6;
  gce_MakeCone_7: typeof gce_MakeCone_7;
  gce_MakeLin: typeof gce_MakeLin;
  gce_MakeLin_1: typeof gce_MakeLin_1;
  gce_MakeLin_2: typeof gce_MakeLin_2;
  gce_MakeLin_3: typeof gce_MakeLin_3;
  gce_MakeLin_4: typeof gce_MakeLin_4;
  gce_MakeScale: typeof gce_MakeScale;
  gce_MakeScale2d: typeof gce_MakeScale2d;
  gce_MakeCirc2d: typeof gce_MakeCirc2d;
  gce_MakeCirc2d_1: typeof gce_MakeCirc2d_1;
  gce_MakeCirc2d_2: typeof gce_MakeCirc2d_2;
  gce_MakeCirc2d_3: typeof gce_MakeCirc2d_3;
  gce_MakeCirc2d_4: typeof gce_MakeCirc2d_4;
  gce_MakeCirc2d_5: typeof gce_MakeCirc2d_5;
  gce_MakeCirc2d_6: typeof gce_MakeCirc2d_6;
  gce_MakeCirc2d_7: typeof gce_MakeCirc2d_7;
  gce_MakeRotation2d: typeof gce_MakeRotation2d;
  gce_MakeDir: typeof gce_MakeDir;
  gce_MakeDir_1: typeof gce_MakeDir_1;
  gce_MakeDir_2: typeof gce_MakeDir_2;
  gce_MakeDir_3: typeof gce_MakeDir_3;
  gce_MakeDir_4: typeof gce_MakeDir_4;
  gce_ErrorType: gce_ErrorType;
  gce_MakeLin2d: typeof gce_MakeLin2d;
  gce_MakeLin2d_1: typeof gce_MakeLin2d_1;
  gce_MakeLin2d_2: typeof gce_MakeLin2d_2;
  gce_MakeLin2d_3: typeof gce_MakeLin2d_3;
  gce_MakeLin2d_4: typeof gce_MakeLin2d_4;
  gce_MakeLin2d_5: typeof gce_MakeLin2d_5;
  gce_MakeLin2d_6: typeof gce_MakeLin2d_6;
  gce_MakeRotation: typeof gce_MakeRotation;
  gce_MakeRotation_1: typeof gce_MakeRotation_1;
  gce_MakeRotation_2: typeof gce_MakeRotation_2;
  gce_MakeRotation_3: typeof gce_MakeRotation_3;
  gce_Root: typeof gce_Root;
  gce_MakeTranslation2d: typeof gce_MakeTranslation2d;
  gce_MakeTranslation2d_1: typeof gce_MakeTranslation2d_1;
  gce_MakeTranslation2d_2: typeof gce_MakeTranslation2d_2;
  Precision: typeof Precision;
  Handle_StdSelect_FaceFilter: typeof Handle_StdSelect_FaceFilter;
  Handle_StdSelect_FaceFilter_1: typeof Handle_StdSelect_FaceFilter_1;
  Handle_StdSelect_FaceFilter_2: typeof Handle_StdSelect_FaceFilter_2;
  Handle_StdSelect_FaceFilter_3: typeof Handle_StdSelect_FaceFilter_3;
  Handle_StdSelect_FaceFilter_4: typeof Handle_StdSelect_FaceFilter_4;
  StdSelect_FaceFilter: typeof StdSelect_FaceFilter;
  StdSelect_TypeOfSelectionImage: StdSelect_TypeOfSelectionImage;
  StdSelect_Shape: typeof StdSelect_Shape;
  Handle_StdSelect_Shape: typeof Handle_StdSelect_Shape;
  Handle_StdSelect_Shape_1: typeof Handle_StdSelect_Shape_1;
  Handle_StdSelect_Shape_2: typeof Handle_StdSelect_Shape_2;
  Handle_StdSelect_Shape_3: typeof Handle_StdSelect_Shape_3;
  Handle_StdSelect_Shape_4: typeof Handle_StdSelect_Shape_4;
  StdSelect_BRepOwner: typeof StdSelect_BRepOwner;
  StdSelect_BRepOwner_1: typeof StdSelect_BRepOwner_1;
  StdSelect_BRepOwner_2: typeof StdSelect_BRepOwner_2;
  StdSelect_BRepOwner_3: typeof StdSelect_BRepOwner_3;
  Handle_StdSelect_BRepOwner: typeof Handle_StdSelect_BRepOwner;
  Handle_StdSelect_BRepOwner_1: typeof Handle_StdSelect_BRepOwner_1;
  Handle_StdSelect_BRepOwner_2: typeof Handle_StdSelect_BRepOwner_2;
  Handle_StdSelect_BRepOwner_3: typeof Handle_StdSelect_BRepOwner_3;
  Handle_StdSelect_BRepOwner_4: typeof Handle_StdSelect_BRepOwner_4;
  StdSelect_TypeOfEdge: StdSelect_TypeOfEdge;
  StdSelect_BRepSelectionTool: typeof StdSelect_BRepSelectionTool;
  StdSelect: typeof StdSelect;
  StdSelect_TypeOfFace: StdSelect_TypeOfFace;
  Handle_StdSelect_EdgeFilter: typeof Handle_StdSelect_EdgeFilter;
  Handle_StdSelect_EdgeFilter_1: typeof Handle_StdSelect_EdgeFilter_1;
  Handle_StdSelect_EdgeFilter_2: typeof Handle_StdSelect_EdgeFilter_2;
  Handle_StdSelect_EdgeFilter_3: typeof Handle_StdSelect_EdgeFilter_3;
  Handle_StdSelect_EdgeFilter_4: typeof Handle_StdSelect_EdgeFilter_4;
  StdSelect_EdgeFilter: typeof StdSelect_EdgeFilter;
  StdSelect_ShapeTypeFilter: typeof StdSelect_ShapeTypeFilter;
  Handle_StdSelect_ShapeTypeFilter: typeof Handle_StdSelect_ShapeTypeFilter;
  Handle_StdSelect_ShapeTypeFilter_1: typeof Handle_StdSelect_ShapeTypeFilter_1;
  Handle_StdSelect_ShapeTypeFilter_2: typeof Handle_StdSelect_ShapeTypeFilter_2;
  Handle_StdSelect_ShapeTypeFilter_3: typeof Handle_StdSelect_ShapeTypeFilter_3;
  Handle_StdSelect_ShapeTypeFilter_4: typeof Handle_StdSelect_ShapeTypeFilter_4;
  BinMXCAFDoc_DatumDriver: typeof BinMXCAFDoc_DatumDriver;
  Handle_BinMXCAFDoc_DatumDriver: typeof Handle_BinMXCAFDoc_DatumDriver;
  Handle_BinMXCAFDoc_DatumDriver_1: typeof Handle_BinMXCAFDoc_DatumDriver_1;
  Handle_BinMXCAFDoc_DatumDriver_2: typeof Handle_BinMXCAFDoc_DatumDriver_2;
  Handle_BinMXCAFDoc_DatumDriver_3: typeof Handle_BinMXCAFDoc_DatumDriver_3;
  Handle_BinMXCAFDoc_DatumDriver_4: typeof Handle_BinMXCAFDoc_DatumDriver_4;
  BinMXCAFDoc_LocationDriver: typeof BinMXCAFDoc_LocationDriver;
  Handle_BinMXCAFDoc_LocationDriver: typeof Handle_BinMXCAFDoc_LocationDriver;
  Handle_BinMXCAFDoc_LocationDriver_1: typeof Handle_BinMXCAFDoc_LocationDriver_1;
  Handle_BinMXCAFDoc_LocationDriver_2: typeof Handle_BinMXCAFDoc_LocationDriver_2;
  Handle_BinMXCAFDoc_LocationDriver_3: typeof Handle_BinMXCAFDoc_LocationDriver_3;
  Handle_BinMXCAFDoc_LocationDriver_4: typeof Handle_BinMXCAFDoc_LocationDriver_4;
  Handle_BinMXCAFDoc_AssemblyItemRefDriver: typeof Handle_BinMXCAFDoc_AssemblyItemRefDriver;
  Handle_BinMXCAFDoc_AssemblyItemRefDriver_1: typeof Handle_BinMXCAFDoc_AssemblyItemRefDriver_1;
  Handle_BinMXCAFDoc_AssemblyItemRefDriver_2: typeof Handle_BinMXCAFDoc_AssemblyItemRefDriver_2;
  Handle_BinMXCAFDoc_AssemblyItemRefDriver_3: typeof Handle_BinMXCAFDoc_AssemblyItemRefDriver_3;
  Handle_BinMXCAFDoc_AssemblyItemRefDriver_4: typeof Handle_BinMXCAFDoc_AssemblyItemRefDriver_4;
  BinMXCAFDoc_AssemblyItemRefDriver: typeof BinMXCAFDoc_AssemblyItemRefDriver;
  Handle_BinMXCAFDoc_NoteDriver: typeof Handle_BinMXCAFDoc_NoteDriver;
  Handle_BinMXCAFDoc_NoteDriver_1: typeof Handle_BinMXCAFDoc_NoteDriver_1;
  Handle_BinMXCAFDoc_NoteDriver_2: typeof Handle_BinMXCAFDoc_NoteDriver_2;
  Handle_BinMXCAFDoc_NoteDriver_3: typeof Handle_BinMXCAFDoc_NoteDriver_3;
  Handle_BinMXCAFDoc_NoteDriver_4: typeof Handle_BinMXCAFDoc_NoteDriver_4;
  BinMXCAFDoc_NoteDriver: typeof BinMXCAFDoc_NoteDriver;
  Handle_BinMXCAFDoc_GraphNodeDriver: typeof Handle_BinMXCAFDoc_GraphNodeDriver;
  Handle_BinMXCAFDoc_GraphNodeDriver_1: typeof Handle_BinMXCAFDoc_GraphNodeDriver_1;
  Handle_BinMXCAFDoc_GraphNodeDriver_2: typeof Handle_BinMXCAFDoc_GraphNodeDriver_2;
  Handle_BinMXCAFDoc_GraphNodeDriver_3: typeof Handle_BinMXCAFDoc_GraphNodeDriver_3;
  Handle_BinMXCAFDoc_GraphNodeDriver_4: typeof Handle_BinMXCAFDoc_GraphNodeDriver_4;
  BinMXCAFDoc_GraphNodeDriver: typeof BinMXCAFDoc_GraphNodeDriver;
  BinMXCAFDoc_NoteCommentDriver: typeof BinMXCAFDoc_NoteCommentDriver;
  Handle_BinMXCAFDoc_NoteCommentDriver: typeof Handle_BinMXCAFDoc_NoteCommentDriver;
  Handle_BinMXCAFDoc_NoteCommentDriver_1: typeof Handle_BinMXCAFDoc_NoteCommentDriver_1;
  Handle_BinMXCAFDoc_NoteCommentDriver_2: typeof Handle_BinMXCAFDoc_NoteCommentDriver_2;
  Handle_BinMXCAFDoc_NoteCommentDriver_3: typeof Handle_BinMXCAFDoc_NoteCommentDriver_3;
  Handle_BinMXCAFDoc_NoteCommentDriver_4: typeof Handle_BinMXCAFDoc_NoteCommentDriver_4;
  BinMXCAFDoc_NoteBinDataDriver: typeof BinMXCAFDoc_NoteBinDataDriver;
  Handle_BinMXCAFDoc_NoteBinDataDriver: typeof Handle_BinMXCAFDoc_NoteBinDataDriver;
  Handle_BinMXCAFDoc_NoteBinDataDriver_1: typeof Handle_BinMXCAFDoc_NoteBinDataDriver_1;
  Handle_BinMXCAFDoc_NoteBinDataDriver_2: typeof Handle_BinMXCAFDoc_NoteBinDataDriver_2;
  Handle_BinMXCAFDoc_NoteBinDataDriver_3: typeof Handle_BinMXCAFDoc_NoteBinDataDriver_3;
  Handle_BinMXCAFDoc_NoteBinDataDriver_4: typeof Handle_BinMXCAFDoc_NoteBinDataDriver_4;
  Handle_BinMXCAFDoc_MaterialDriver: typeof Handle_BinMXCAFDoc_MaterialDriver;
  Handle_BinMXCAFDoc_MaterialDriver_1: typeof Handle_BinMXCAFDoc_MaterialDriver_1;
  Handle_BinMXCAFDoc_MaterialDriver_2: typeof Handle_BinMXCAFDoc_MaterialDriver_2;
  Handle_BinMXCAFDoc_MaterialDriver_3: typeof Handle_BinMXCAFDoc_MaterialDriver_3;
  Handle_BinMXCAFDoc_MaterialDriver_4: typeof Handle_BinMXCAFDoc_MaterialDriver_4;
  BinMXCAFDoc_MaterialDriver: typeof BinMXCAFDoc_MaterialDriver;
  BinMXCAFDoc_ColorDriver: typeof BinMXCAFDoc_ColorDriver;
  Handle_BinMXCAFDoc_ColorDriver: typeof Handle_BinMXCAFDoc_ColorDriver;
  Handle_BinMXCAFDoc_ColorDriver_1: typeof Handle_BinMXCAFDoc_ColorDriver_1;
  Handle_BinMXCAFDoc_ColorDriver_2: typeof Handle_BinMXCAFDoc_ColorDriver_2;
  Handle_BinMXCAFDoc_ColorDriver_3: typeof Handle_BinMXCAFDoc_ColorDriver_3;
  Handle_BinMXCAFDoc_ColorDriver_4: typeof Handle_BinMXCAFDoc_ColorDriver_4;
  BinMXCAFDoc: typeof BinMXCAFDoc;
  BinMXCAFDoc_VisMaterialDriver: typeof BinMXCAFDoc_VisMaterialDriver;
  Handle_BinMXCAFDoc_VisMaterialDriver: typeof Handle_BinMXCAFDoc_VisMaterialDriver;
  Handle_BinMXCAFDoc_VisMaterialDriver_1: typeof Handle_BinMXCAFDoc_VisMaterialDriver_1;
  Handle_BinMXCAFDoc_VisMaterialDriver_2: typeof Handle_BinMXCAFDoc_VisMaterialDriver_2;
  Handle_BinMXCAFDoc_VisMaterialDriver_3: typeof Handle_BinMXCAFDoc_VisMaterialDriver_3;
  Handle_BinMXCAFDoc_VisMaterialDriver_4: typeof Handle_BinMXCAFDoc_VisMaterialDriver_4;
  Handle_BinMXCAFDoc_DimTolDriver: typeof Handle_BinMXCAFDoc_DimTolDriver;
  Handle_BinMXCAFDoc_DimTolDriver_1: typeof Handle_BinMXCAFDoc_DimTolDriver_1;
  Handle_BinMXCAFDoc_DimTolDriver_2: typeof Handle_BinMXCAFDoc_DimTolDriver_2;
  Handle_BinMXCAFDoc_DimTolDriver_3: typeof Handle_BinMXCAFDoc_DimTolDriver_3;
  Handle_BinMXCAFDoc_DimTolDriver_4: typeof Handle_BinMXCAFDoc_DimTolDriver_4;
  BinMXCAFDoc_DimTolDriver: typeof BinMXCAFDoc_DimTolDriver;
  Handle_BinMXCAFDoc_CentroidDriver: typeof Handle_BinMXCAFDoc_CentroidDriver;
  Handle_BinMXCAFDoc_CentroidDriver_1: typeof Handle_BinMXCAFDoc_CentroidDriver_1;
  Handle_BinMXCAFDoc_CentroidDriver_2: typeof Handle_BinMXCAFDoc_CentroidDriver_2;
  Handle_BinMXCAFDoc_CentroidDriver_3: typeof Handle_BinMXCAFDoc_CentroidDriver_3;
  Handle_BinMXCAFDoc_CentroidDriver_4: typeof Handle_BinMXCAFDoc_CentroidDriver_4;
  BinMXCAFDoc_CentroidDriver: typeof BinMXCAFDoc_CentroidDriver;
  Handle_BinMXCAFDoc_VisMaterialToolDriver: typeof Handle_BinMXCAFDoc_VisMaterialToolDriver;
  Handle_BinMXCAFDoc_VisMaterialToolDriver_1: typeof Handle_BinMXCAFDoc_VisMaterialToolDriver_1;
  Handle_BinMXCAFDoc_VisMaterialToolDriver_2: typeof Handle_BinMXCAFDoc_VisMaterialToolDriver_2;
  Handle_BinMXCAFDoc_VisMaterialToolDriver_3: typeof Handle_BinMXCAFDoc_VisMaterialToolDriver_3;
  Handle_BinMXCAFDoc_VisMaterialToolDriver_4: typeof Handle_BinMXCAFDoc_VisMaterialToolDriver_4;
  BinMXCAFDoc_VisMaterialToolDriver: typeof BinMXCAFDoc_VisMaterialToolDriver;
  BlendFunc_ConstThroat: typeof BlendFunc_ConstThroat;
  BlendFunc_EvolRad: typeof BlendFunc_EvolRad;
  BlendFunc_ConstThroatWithPenetrationInv: typeof BlendFunc_ConstThroatWithPenetrationInv;
  BlendFunc_GenChamfInv: typeof BlendFunc_GenChamfInv;
  BlendFunc_GenChamfer: typeof BlendFunc_GenChamfer;
  BlendFunc_ChamfInv: typeof BlendFunc_ChamfInv;
  BlendFunc_RuledInv: typeof BlendFunc_RuledInv;
  BlendFunc_ChAsym: typeof BlendFunc_ChAsym;
  BlendFunc_ChAsymInv: typeof BlendFunc_ChAsymInv;
  BlendFunc_Ruled: typeof BlendFunc_Ruled;
  BlendFunc_ConstRad: typeof BlendFunc_ConstRad;
  BlendFunc_ConstThroatWithPenetration: typeof BlendFunc_ConstThroatWithPenetration;
  BlendFunc_SectionShape: BlendFunc_SectionShape;
  BlendFunc_Chamfer: typeof BlendFunc_Chamfer;
  BlendFunc_ConstThroatInv: typeof BlendFunc_ConstThroatInv;
  BlendFunc: typeof BlendFunc;
  BlendFunc_CSCircular: typeof BlendFunc_CSCircular;
  BlendFunc_Tensor: typeof BlendFunc_Tensor;
  BlendFunc_Corde: typeof BlendFunc_Corde;
  BlendFunc_ConstRadInv: typeof BlendFunc_ConstRadInv;
  BlendFunc_EvolRadInv: typeof BlendFunc_EvolRadInv;
  BlendFunc_CSConstRad: typeof BlendFunc_CSConstRad;
  Handle_StepDimTol_RunoutZoneDefinition: typeof Handle_StepDimTol_RunoutZoneDefinition;
  Handle_StepDimTol_RunoutZoneDefinition_1: typeof Handle_StepDimTol_RunoutZoneDefinition_1;
  Handle_StepDimTol_RunoutZoneDefinition_2: typeof Handle_StepDimTol_RunoutZoneDefinition_2;
  Handle_StepDimTol_RunoutZoneDefinition_3: typeof Handle_StepDimTol_RunoutZoneDefinition_3;
  Handle_StepDimTol_RunoutZoneDefinition_4: typeof Handle_StepDimTol_RunoutZoneDefinition_4;
  StepDimTol_RunoutZoneDefinition: typeof StepDimTol_RunoutZoneDefinition;
  StepDimTol_CommonDatum: typeof StepDimTol_CommonDatum;
  Handle_StepDimTol_CommonDatum: typeof Handle_StepDimTol_CommonDatum;
  Handle_StepDimTol_CommonDatum_1: typeof Handle_StepDimTol_CommonDatum_1;
  Handle_StepDimTol_CommonDatum_2: typeof Handle_StepDimTol_CommonDatum_2;
  Handle_StepDimTol_CommonDatum_3: typeof Handle_StepDimTol_CommonDatum_3;
  Handle_StepDimTol_CommonDatum_4: typeof Handle_StepDimTol_CommonDatum_4;
  StepDimTol_ToleranceZoneDefinition: typeof StepDimTol_ToleranceZoneDefinition;
  Handle_StepDimTol_ToleranceZoneDefinition: typeof Handle_StepDimTol_ToleranceZoneDefinition;
  Handle_StepDimTol_ToleranceZoneDefinition_1: typeof Handle_StepDimTol_ToleranceZoneDefinition_1;
  Handle_StepDimTol_ToleranceZoneDefinition_2: typeof Handle_StepDimTol_ToleranceZoneDefinition_2;
  Handle_StepDimTol_ToleranceZoneDefinition_3: typeof Handle_StepDimTol_ToleranceZoneDefinition_3;
  Handle_StepDimTol_ToleranceZoneDefinition_4: typeof Handle_StepDimTol_ToleranceZoneDefinition_4;
  Handle_StepDimTol_HArray1OfDatumReference: typeof Handle_StepDimTol_HArray1OfDatumReference;
  Handle_StepDimTol_HArray1OfDatumReference_1: typeof Handle_StepDimTol_HArray1OfDatumReference_1;
  Handle_StepDimTol_HArray1OfDatumReference_2: typeof Handle_StepDimTol_HArray1OfDatumReference_2;
  Handle_StepDimTol_HArray1OfDatumReference_3: typeof Handle_StepDimTol_HArray1OfDatumReference_3;
  Handle_StepDimTol_HArray1OfDatumReference_4: typeof Handle_StepDimTol_HArray1OfDatumReference_4;
  StepDimTol_PlacedDatumTargetFeature: typeof StepDimTol_PlacedDatumTargetFeature;
  Handle_StepDimTol_PlacedDatumTargetFeature: typeof Handle_StepDimTol_PlacedDatumTargetFeature;
  Handle_StepDimTol_PlacedDatumTargetFeature_1: typeof Handle_StepDimTol_PlacedDatumTargetFeature_1;
  Handle_StepDimTol_PlacedDatumTargetFeature_2: typeof Handle_StepDimTol_PlacedDatumTargetFeature_2;
  Handle_StepDimTol_PlacedDatumTargetFeature_3: typeof Handle_StepDimTol_PlacedDatumTargetFeature_3;
  Handle_StepDimTol_PlacedDatumTargetFeature_4: typeof Handle_StepDimTol_PlacedDatumTargetFeature_4;
  Handle_StepDimTol_HArray1OfDatumSystemOrReference: typeof Handle_StepDimTol_HArray1OfDatumSystemOrReference;
  Handle_StepDimTol_HArray1OfDatumSystemOrReference_1: typeof Handle_StepDimTol_HArray1OfDatumSystemOrReference_1;
  Handle_StepDimTol_HArray1OfDatumSystemOrReference_2: typeof Handle_StepDimTol_HArray1OfDatumSystemOrReference_2;
  Handle_StepDimTol_HArray1OfDatumSystemOrReference_3: typeof Handle_StepDimTol_HArray1OfDatumSystemOrReference_3;
  Handle_StepDimTol_HArray1OfDatumSystemOrReference_4: typeof Handle_StepDimTol_HArray1OfDatumSystemOrReference_4;
  StepDimTol_ToleranceZone: typeof StepDimTol_ToleranceZone;
  Handle_StepDimTol_ToleranceZone: typeof Handle_StepDimTol_ToleranceZone;
  Handle_StepDimTol_ToleranceZone_1: typeof Handle_StepDimTol_ToleranceZone_1;
  Handle_StepDimTol_ToleranceZone_2: typeof Handle_StepDimTol_ToleranceZone_2;
  Handle_StepDimTol_ToleranceZone_3: typeof Handle_StepDimTol_ToleranceZone_3;
  Handle_StepDimTol_ToleranceZone_4: typeof Handle_StepDimTol_ToleranceZone_4;
  StepDimTol_GeometricToleranceRelationship: typeof StepDimTol_GeometricToleranceRelationship;
  Handle_StepDimTol_GeometricToleranceRelationship: typeof Handle_StepDimTol_GeometricToleranceRelationship;
  Handle_StepDimTol_GeometricToleranceRelationship_1: typeof Handle_StepDimTol_GeometricToleranceRelationship_1;
  Handle_StepDimTol_GeometricToleranceRelationship_2: typeof Handle_StepDimTol_GeometricToleranceRelationship_2;
  Handle_StepDimTol_GeometricToleranceRelationship_3: typeof Handle_StepDimTol_GeometricToleranceRelationship_3;
  Handle_StepDimTol_GeometricToleranceRelationship_4: typeof Handle_StepDimTol_GeometricToleranceRelationship_4;
  StepDimTol_Array1OfGeometricToleranceModifier: typeof StepDimTol_Array1OfGeometricToleranceModifier;
  StepDimTol_Array1OfGeometricToleranceModifier_1: typeof StepDimTol_Array1OfGeometricToleranceModifier_1;
  StepDimTol_Array1OfGeometricToleranceModifier_2: typeof StepDimTol_Array1OfGeometricToleranceModifier_2;
  StepDimTol_Array1OfGeometricToleranceModifier_3: typeof StepDimTol_Array1OfGeometricToleranceModifier_3;
  StepDimTol_Array1OfGeometricToleranceModifier_4: typeof StepDimTol_Array1OfGeometricToleranceModifier_4;
  StepDimTol_Array1OfGeometricToleranceModifier_5: typeof StepDimTol_Array1OfGeometricToleranceModifier_5;
  Handle_StepDimTol_HArray1OfToleranceZoneTarget: typeof Handle_StepDimTol_HArray1OfToleranceZoneTarget;
  Handle_StepDimTol_HArray1OfToleranceZoneTarget_1: typeof Handle_StepDimTol_HArray1OfToleranceZoneTarget_1;
  Handle_StepDimTol_HArray1OfToleranceZoneTarget_2: typeof Handle_StepDimTol_HArray1OfToleranceZoneTarget_2;
  Handle_StepDimTol_HArray1OfToleranceZoneTarget_3: typeof Handle_StepDimTol_HArray1OfToleranceZoneTarget_3;
  Handle_StepDimTol_HArray1OfToleranceZoneTarget_4: typeof Handle_StepDimTol_HArray1OfToleranceZoneTarget_4;
  StepDimTol_ToleranceZoneTarget: typeof StepDimTol_ToleranceZoneTarget;
  StepDimTol_LineProfileTolerance: typeof StepDimTol_LineProfileTolerance;
  Handle_StepDimTol_LineProfileTolerance: typeof Handle_StepDimTol_LineProfileTolerance;
  Handle_StepDimTol_LineProfileTolerance_1: typeof Handle_StepDimTol_LineProfileTolerance_1;
  Handle_StepDimTol_LineProfileTolerance_2: typeof Handle_StepDimTol_LineProfileTolerance_2;
  Handle_StepDimTol_LineProfileTolerance_3: typeof Handle_StepDimTol_LineProfileTolerance_3;
  Handle_StepDimTol_LineProfileTolerance_4: typeof Handle_StepDimTol_LineProfileTolerance_4;
  StepDimTol_AreaUnitType: StepDimTol_AreaUnitType;
  Handle_StepDimTol_ToleranceZoneForm: typeof Handle_StepDimTol_ToleranceZoneForm;
  Handle_StepDimTol_ToleranceZoneForm_1: typeof Handle_StepDimTol_ToleranceZoneForm_1;
  Handle_StepDimTol_ToleranceZoneForm_2: typeof Handle_StepDimTol_ToleranceZoneForm_2;
  Handle_StepDimTol_ToleranceZoneForm_3: typeof Handle_StepDimTol_ToleranceZoneForm_3;
  Handle_StepDimTol_ToleranceZoneForm_4: typeof Handle_StepDimTol_ToleranceZoneForm_4;
  StepDimTol_ToleranceZoneForm: typeof StepDimTol_ToleranceZoneForm;
  StepDimTol_StraightnessTolerance: typeof StepDimTol_StraightnessTolerance;
  Handle_StepDimTol_StraightnessTolerance: typeof Handle_StepDimTol_StraightnessTolerance;
  Handle_StepDimTol_StraightnessTolerance_1: typeof Handle_StepDimTol_StraightnessTolerance_1;
  Handle_StepDimTol_StraightnessTolerance_2: typeof Handle_StepDimTol_StraightnessTolerance_2;
  Handle_StepDimTol_StraightnessTolerance_3: typeof Handle_StepDimTol_StraightnessTolerance_3;
  Handle_StepDimTol_StraightnessTolerance_4: typeof Handle_StepDimTol_StraightnessTolerance_4;
  Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol;
  Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMaxTol_4;
  StepDimTol_GeoTolAndGeoTolWthMaxTol: typeof StepDimTol_GeoTolAndGeoTolWthMaxTol;
  StepDimTol_ModifiedGeometricTolerance: typeof StepDimTol_ModifiedGeometricTolerance;
  Handle_StepDimTol_ModifiedGeometricTolerance: typeof Handle_StepDimTol_ModifiedGeometricTolerance;
  Handle_StepDimTol_ModifiedGeometricTolerance_1: typeof Handle_StepDimTol_ModifiedGeometricTolerance_1;
  Handle_StepDimTol_ModifiedGeometricTolerance_2: typeof Handle_StepDimTol_ModifiedGeometricTolerance_2;
  Handle_StepDimTol_ModifiedGeometricTolerance_3: typeof Handle_StepDimTol_ModifiedGeometricTolerance_3;
  Handle_StepDimTol_ModifiedGeometricTolerance_4: typeof Handle_StepDimTol_ModifiedGeometricTolerance_4;
  StepDimTol_Array1OfToleranceZoneTarget: typeof StepDimTol_Array1OfToleranceZoneTarget;
  StepDimTol_Array1OfToleranceZoneTarget_1: typeof StepDimTol_Array1OfToleranceZoneTarget_1;
  StepDimTol_Array1OfToleranceZoneTarget_2: typeof StepDimTol_Array1OfToleranceZoneTarget_2;
  StepDimTol_Array1OfToleranceZoneTarget_3: typeof StepDimTol_Array1OfToleranceZoneTarget_3;
  StepDimTol_Array1OfToleranceZoneTarget_4: typeof StepDimTol_Array1OfToleranceZoneTarget_4;
  StepDimTol_Array1OfToleranceZoneTarget_5: typeof StepDimTol_Array1OfToleranceZoneTarget_5;
  StepDimTol_UnequallyDisposedGeometricTolerance: typeof StepDimTol_UnequallyDisposedGeometricTolerance;
  Handle_StepDimTol_UnequallyDisposedGeometricTolerance: typeof Handle_StepDimTol_UnequallyDisposedGeometricTolerance;
  Handle_StepDimTol_UnequallyDisposedGeometricTolerance_1: typeof Handle_StepDimTol_UnequallyDisposedGeometricTolerance_1;
  Handle_StepDimTol_UnequallyDisposedGeometricTolerance_2: typeof Handle_StepDimTol_UnequallyDisposedGeometricTolerance_2;
  Handle_StepDimTol_UnequallyDisposedGeometricTolerance_3: typeof Handle_StepDimTol_UnequallyDisposedGeometricTolerance_3;
  Handle_StepDimTol_UnequallyDisposedGeometricTolerance_4: typeof Handle_StepDimTol_UnequallyDisposedGeometricTolerance_4;
  StepDimTol_Array1OfDatumReferenceModifier: typeof StepDimTol_Array1OfDatumReferenceModifier;
  StepDimTol_Array1OfDatumReferenceModifier_1: typeof StepDimTol_Array1OfDatumReferenceModifier_1;
  StepDimTol_Array1OfDatumReferenceModifier_2: typeof StepDimTol_Array1OfDatumReferenceModifier_2;
  StepDimTol_Array1OfDatumReferenceModifier_3: typeof StepDimTol_Array1OfDatumReferenceModifier_3;
  StepDimTol_Array1OfDatumReferenceModifier_4: typeof StepDimTol_Array1OfDatumReferenceModifier_4;
  StepDimTol_Array1OfDatumReferenceModifier_5: typeof StepDimTol_Array1OfDatumReferenceModifier_5;
  Handle_StepDimTol_RunoutZoneOrientation: typeof Handle_StepDimTol_RunoutZoneOrientation;
  Handle_StepDimTol_RunoutZoneOrientation_1: typeof Handle_StepDimTol_RunoutZoneOrientation_1;
  Handle_StepDimTol_RunoutZoneOrientation_2: typeof Handle_StepDimTol_RunoutZoneOrientation_2;
  Handle_StepDimTol_RunoutZoneOrientation_3: typeof Handle_StepDimTol_RunoutZoneOrientation_3;
  Handle_StepDimTol_RunoutZoneOrientation_4: typeof Handle_StepDimTol_RunoutZoneOrientation_4;
  StepDimTol_RunoutZoneOrientation: typeof StepDimTol_RunoutZoneOrientation;
  Handle_StepDimTol_HArray1OfDatumReferenceModifier: typeof Handle_StepDimTol_HArray1OfDatumReferenceModifier;
  Handle_StepDimTol_HArray1OfDatumReferenceModifier_1: typeof Handle_StepDimTol_HArray1OfDatumReferenceModifier_1;
  Handle_StepDimTol_HArray1OfDatumReferenceModifier_2: typeof Handle_StepDimTol_HArray1OfDatumReferenceModifier_2;
  Handle_StepDimTol_HArray1OfDatumReferenceModifier_3: typeof Handle_StepDimTol_HArray1OfDatumReferenceModifier_3;
  Handle_StepDimTol_HArray1OfDatumReferenceModifier_4: typeof Handle_StepDimTol_HArray1OfDatumReferenceModifier_4;
  Handle_StepDimTol_DatumReferenceModifierWithValue: typeof Handle_StepDimTol_DatumReferenceModifierWithValue;
  Handle_StepDimTol_DatumReferenceModifierWithValue_1: typeof Handle_StepDimTol_DatumReferenceModifierWithValue_1;
  Handle_StepDimTol_DatumReferenceModifierWithValue_2: typeof Handle_StepDimTol_DatumReferenceModifierWithValue_2;
  Handle_StepDimTol_DatumReferenceModifierWithValue_3: typeof Handle_StepDimTol_DatumReferenceModifierWithValue_3;
  Handle_StepDimTol_DatumReferenceModifierWithValue_4: typeof Handle_StepDimTol_DatumReferenceModifierWithValue_4;
  StepDimTol_DatumReferenceModifierWithValue: typeof StepDimTol_DatumReferenceModifierWithValue;
  StepDimTol_DatumFeature: typeof StepDimTol_DatumFeature;
  Handle_StepDimTol_DatumFeature: typeof Handle_StepDimTol_DatumFeature;
  Handle_StepDimTol_DatumFeature_1: typeof Handle_StepDimTol_DatumFeature_1;
  Handle_StepDimTol_DatumFeature_2: typeof Handle_StepDimTol_DatumFeature_2;
  Handle_StepDimTol_DatumFeature_3: typeof Handle_StepDimTol_DatumFeature_3;
  Handle_StepDimTol_DatumFeature_4: typeof Handle_StepDimTol_DatumFeature_4;
  StepDimTol_GeometricTolerance: typeof StepDimTol_GeometricTolerance;
  Handle_StepDimTol_GeometricTolerance: typeof Handle_StepDimTol_GeometricTolerance;
  Handle_StepDimTol_GeometricTolerance_1: typeof Handle_StepDimTol_GeometricTolerance_1;
  Handle_StepDimTol_GeometricTolerance_2: typeof Handle_StepDimTol_GeometricTolerance_2;
  Handle_StepDimTol_GeometricTolerance_3: typeof Handle_StepDimTol_GeometricTolerance_3;
  Handle_StepDimTol_GeometricTolerance_4: typeof Handle_StepDimTol_GeometricTolerance_4;
  Handle_StepDimTol_GeometricToleranceWithMaximumTolerance: typeof Handle_StepDimTol_GeometricToleranceWithMaximumTolerance;
  Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_1: typeof Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_1;
  Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_2: typeof Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_2;
  Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_3: typeof Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_3;
  Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_4: typeof Handle_StepDimTol_GeometricToleranceWithMaximumTolerance_4;
  StepDimTol_GeometricToleranceWithMaximumTolerance: typeof StepDimTol_GeometricToleranceWithMaximumTolerance;
  StepDimTol_SimpleDatumReferenceModifierMember: typeof StepDimTol_SimpleDatumReferenceModifierMember;
  Handle_StepDimTol_SimpleDatumReferenceModifierMember: typeof Handle_StepDimTol_SimpleDatumReferenceModifierMember;
  Handle_StepDimTol_SimpleDatumReferenceModifierMember_1: typeof Handle_StepDimTol_SimpleDatumReferenceModifierMember_1;
  Handle_StepDimTol_SimpleDatumReferenceModifierMember_2: typeof Handle_StepDimTol_SimpleDatumReferenceModifierMember_2;
  Handle_StepDimTol_SimpleDatumReferenceModifierMember_3: typeof Handle_StepDimTol_SimpleDatumReferenceModifierMember_3;
  Handle_StepDimTol_SimpleDatumReferenceModifierMember_4: typeof Handle_StepDimTol_SimpleDatumReferenceModifierMember_4;
  Handle_StepDimTol_HArray1OfGeometricToleranceModifier: typeof Handle_StepDimTol_HArray1OfGeometricToleranceModifier;
  Handle_StepDimTol_HArray1OfGeometricToleranceModifier_1: typeof Handle_StepDimTol_HArray1OfGeometricToleranceModifier_1;
  Handle_StepDimTol_HArray1OfGeometricToleranceModifier_2: typeof Handle_StepDimTol_HArray1OfGeometricToleranceModifier_2;
  Handle_StepDimTol_HArray1OfGeometricToleranceModifier_3: typeof Handle_StepDimTol_HArray1OfGeometricToleranceModifier_3;
  Handle_StepDimTol_HArray1OfGeometricToleranceModifier_4: typeof Handle_StepDimTol_HArray1OfGeometricToleranceModifier_4;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRef: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRef;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRef_4;
  StepDimTol_GeoTolAndGeoTolWthDatRef: typeof StepDimTol_GeoTolAndGeoTolWthDatRef;
  Handle_StepDimTol_NonUniformZoneDefinition: typeof Handle_StepDimTol_NonUniformZoneDefinition;
  Handle_StepDimTol_NonUniformZoneDefinition_1: typeof Handle_StepDimTol_NonUniformZoneDefinition_1;
  Handle_StepDimTol_NonUniformZoneDefinition_2: typeof Handle_StepDimTol_NonUniformZoneDefinition_2;
  Handle_StepDimTol_NonUniformZoneDefinition_3: typeof Handle_StepDimTol_NonUniformZoneDefinition_3;
  Handle_StepDimTol_NonUniformZoneDefinition_4: typeof Handle_StepDimTol_NonUniformZoneDefinition_4;
  StepDimTol_NonUniformZoneDefinition: typeof StepDimTol_NonUniformZoneDefinition;
  Handle_StepDimTol_PerpendicularityTolerance: typeof Handle_StepDimTol_PerpendicularityTolerance;
  Handle_StepDimTol_PerpendicularityTolerance_1: typeof Handle_StepDimTol_PerpendicularityTolerance_1;
  Handle_StepDimTol_PerpendicularityTolerance_2: typeof Handle_StepDimTol_PerpendicularityTolerance_2;
  Handle_StepDimTol_PerpendicularityTolerance_3: typeof Handle_StepDimTol_PerpendicularityTolerance_3;
  Handle_StepDimTol_PerpendicularityTolerance_4: typeof Handle_StepDimTol_PerpendicularityTolerance_4;
  StepDimTol_PerpendicularityTolerance: typeof StepDimTol_PerpendicularityTolerance;
  StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol: typeof StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndUneqDisGeoTol_4;
  Handle_StepDimTol_TotalRunoutTolerance: typeof Handle_StepDimTol_TotalRunoutTolerance;
  Handle_StepDimTol_TotalRunoutTolerance_1: typeof Handle_StepDimTol_TotalRunoutTolerance_1;
  Handle_StepDimTol_TotalRunoutTolerance_2: typeof Handle_StepDimTol_TotalRunoutTolerance_2;
  Handle_StepDimTol_TotalRunoutTolerance_3: typeof Handle_StepDimTol_TotalRunoutTolerance_3;
  Handle_StepDimTol_TotalRunoutTolerance_4: typeof Handle_StepDimTol_TotalRunoutTolerance_4;
  StepDimTol_TotalRunoutTolerance: typeof StepDimTol_TotalRunoutTolerance;
  Handle_StepDimTol_ParallelismTolerance: typeof Handle_StepDimTol_ParallelismTolerance;
  Handle_StepDimTol_ParallelismTolerance_1: typeof Handle_StepDimTol_ParallelismTolerance_1;
  Handle_StepDimTol_ParallelismTolerance_2: typeof Handle_StepDimTol_ParallelismTolerance_2;
  Handle_StepDimTol_ParallelismTolerance_3: typeof Handle_StepDimTol_ParallelismTolerance_3;
  Handle_StepDimTol_ParallelismTolerance_4: typeof Handle_StepDimTol_ParallelismTolerance_4;
  StepDimTol_ParallelismTolerance: typeof StepDimTol_ParallelismTolerance;
  Handle_StepDimTol_ProjectedZoneDefinition: typeof Handle_StepDimTol_ProjectedZoneDefinition;
  Handle_StepDimTol_ProjectedZoneDefinition_1: typeof Handle_StepDimTol_ProjectedZoneDefinition_1;
  Handle_StepDimTol_ProjectedZoneDefinition_2: typeof Handle_StepDimTol_ProjectedZoneDefinition_2;
  Handle_StepDimTol_ProjectedZoneDefinition_3: typeof Handle_StepDimTol_ProjectedZoneDefinition_3;
  Handle_StepDimTol_ProjectedZoneDefinition_4: typeof Handle_StepDimTol_ProjectedZoneDefinition_4;
  StepDimTol_ProjectedZoneDefinition: typeof StepDimTol_ProjectedZoneDefinition;
  Handle_StepDimTol_GeoTolAndGeoTolWthMod: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMod;
  Handle_StepDimTol_GeoTolAndGeoTolWthMod_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMod_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthMod_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMod_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthMod_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMod_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthMod_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthMod_4;
  StepDimTol_GeoTolAndGeoTolWthMod: typeof StepDimTol_GeoTolAndGeoTolWthMod;
  StepDimTol_DatumReferenceCompartment: typeof StepDimTol_DatumReferenceCompartment;
  Handle_StepDimTol_DatumReferenceCompartment: typeof Handle_StepDimTol_DatumReferenceCompartment;
  Handle_StepDimTol_DatumReferenceCompartment_1: typeof Handle_StepDimTol_DatumReferenceCompartment_1;
  Handle_StepDimTol_DatumReferenceCompartment_2: typeof Handle_StepDimTol_DatumReferenceCompartment_2;
  Handle_StepDimTol_DatumReferenceCompartment_3: typeof Handle_StepDimTol_DatumReferenceCompartment_3;
  Handle_StepDimTol_DatumReferenceCompartment_4: typeof Handle_StepDimTol_DatumReferenceCompartment_4;
  Handle_StepDimTol_GeometricToleranceWithModifiers: typeof Handle_StepDimTol_GeometricToleranceWithModifiers;
  Handle_StepDimTol_GeometricToleranceWithModifiers_1: typeof Handle_StepDimTol_GeometricToleranceWithModifiers_1;
  Handle_StepDimTol_GeometricToleranceWithModifiers_2: typeof Handle_StepDimTol_GeometricToleranceWithModifiers_2;
  Handle_StepDimTol_GeometricToleranceWithModifiers_3: typeof Handle_StepDimTol_GeometricToleranceWithModifiers_3;
  Handle_StepDimTol_GeometricToleranceWithModifiers_4: typeof Handle_StepDimTol_GeometricToleranceWithModifiers_4;
  StepDimTol_GeometricToleranceWithModifiers: typeof StepDimTol_GeometricToleranceWithModifiers;
  StepDimTol_Array1OfDatumSystemOrReference: typeof StepDimTol_Array1OfDatumSystemOrReference;
  StepDimTol_Array1OfDatumSystemOrReference_1: typeof StepDimTol_Array1OfDatumSystemOrReference_1;
  StepDimTol_Array1OfDatumSystemOrReference_2: typeof StepDimTol_Array1OfDatumSystemOrReference_2;
  StepDimTol_Array1OfDatumSystemOrReference_3: typeof StepDimTol_Array1OfDatumSystemOrReference_3;
  StepDimTol_Array1OfDatumSystemOrReference_4: typeof StepDimTol_Array1OfDatumSystemOrReference_4;
  StepDimTol_Array1OfDatumSystemOrReference_5: typeof StepDimTol_Array1OfDatumSystemOrReference_5;
  StepDimTol_DatumReferenceElement: typeof StepDimTol_DatumReferenceElement;
  Handle_StepDimTol_DatumReferenceElement: typeof Handle_StepDimTol_DatumReferenceElement;
  Handle_StepDimTol_DatumReferenceElement_1: typeof Handle_StepDimTol_DatumReferenceElement_1;
  Handle_StepDimTol_DatumReferenceElement_2: typeof Handle_StepDimTol_DatumReferenceElement_2;
  Handle_StepDimTol_DatumReferenceElement_3: typeof Handle_StepDimTol_DatumReferenceElement_3;
  Handle_StepDimTol_DatumReferenceElement_4: typeof Handle_StepDimTol_DatumReferenceElement_4;
  Handle_StepDimTol_GeometricToleranceWithDatumReference: typeof Handle_StepDimTol_GeometricToleranceWithDatumReference;
  Handle_StepDimTol_GeometricToleranceWithDatumReference_1: typeof Handle_StepDimTol_GeometricToleranceWithDatumReference_1;
  Handle_StepDimTol_GeometricToleranceWithDatumReference_2: typeof Handle_StepDimTol_GeometricToleranceWithDatumReference_2;
  Handle_StepDimTol_GeometricToleranceWithDatumReference_3: typeof Handle_StepDimTol_GeometricToleranceWithDatumReference_3;
  Handle_StepDimTol_GeometricToleranceWithDatumReference_4: typeof Handle_StepDimTol_GeometricToleranceWithDatumReference_4;
  StepDimTol_GeometricToleranceWithDatumReference: typeof StepDimTol_GeometricToleranceWithDatumReference;
  StepDimTol_DatumReference: typeof StepDimTol_DatumReference;
  Handle_StepDimTol_DatumReference: typeof Handle_StepDimTol_DatumReference;
  Handle_StepDimTol_DatumReference_1: typeof Handle_StepDimTol_DatumReference_1;
  Handle_StepDimTol_DatumReference_2: typeof Handle_StepDimTol_DatumReference_2;
  Handle_StepDimTol_DatumReference_3: typeof Handle_StepDimTol_DatumReference_3;
  Handle_StepDimTol_DatumReference_4: typeof Handle_StepDimTol_DatumReference_4;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod_4;
  StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod: typeof StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMod;
  StepDimTol_SimpleDatumReferenceModifier: StepDimTol_SimpleDatumReferenceModifier;
  Handle_StepDimTol_HArray1OfDatumReferenceElement: typeof Handle_StepDimTol_HArray1OfDatumReferenceElement;
  Handle_StepDimTol_HArray1OfDatumReferenceElement_1: typeof Handle_StepDimTol_HArray1OfDatumReferenceElement_1;
  Handle_StepDimTol_HArray1OfDatumReferenceElement_2: typeof Handle_StepDimTol_HArray1OfDatumReferenceElement_2;
  Handle_StepDimTol_HArray1OfDatumReferenceElement_3: typeof Handle_StepDimTol_HArray1OfDatumReferenceElement_3;
  Handle_StepDimTol_HArray1OfDatumReferenceElement_4: typeof Handle_StepDimTol_HArray1OfDatumReferenceElement_4;
  Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit: typeof Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit;
  Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_1: typeof Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_1;
  Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_2: typeof Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_2;
  Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_3: typeof Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_3;
  Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_4: typeof Handle_StepDimTol_GeometricToleranceWithDefinedAreaUnit_4;
  StepDimTol_GeometricToleranceWithDefinedAreaUnit: typeof StepDimTol_GeometricToleranceWithDefinedAreaUnit;
  Handle_StepDimTol_DatumTarget: typeof Handle_StepDimTol_DatumTarget;
  Handle_StepDimTol_DatumTarget_1: typeof Handle_StepDimTol_DatumTarget_1;
  Handle_StepDimTol_DatumTarget_2: typeof Handle_StepDimTol_DatumTarget_2;
  Handle_StepDimTol_DatumTarget_3: typeof Handle_StepDimTol_DatumTarget_3;
  Handle_StepDimTol_DatumTarget_4: typeof Handle_StepDimTol_DatumTarget_4;
  StepDimTol_DatumTarget: typeof StepDimTol_DatumTarget;
  StepDimTol_PositionTolerance: typeof StepDimTol_PositionTolerance;
  Handle_StepDimTol_PositionTolerance: typeof Handle_StepDimTol_PositionTolerance;
  Handle_StepDimTol_PositionTolerance_1: typeof Handle_StepDimTol_PositionTolerance_1;
  Handle_StepDimTol_PositionTolerance_2: typeof Handle_StepDimTol_PositionTolerance_2;
  Handle_StepDimTol_PositionTolerance_3: typeof Handle_StepDimTol_PositionTolerance_3;
  Handle_StepDimTol_PositionTolerance_4: typeof Handle_StepDimTol_PositionTolerance_4;
  StepDimTol_LimitCondition: StepDimTol_LimitCondition;
  StepDimTol_RoundnessTolerance: typeof StepDimTol_RoundnessTolerance;
  Handle_StepDimTol_RoundnessTolerance: typeof Handle_StepDimTol_RoundnessTolerance;
  Handle_StepDimTol_RoundnessTolerance_1: typeof Handle_StepDimTol_RoundnessTolerance_1;
  Handle_StepDimTol_RoundnessTolerance_2: typeof Handle_StepDimTol_RoundnessTolerance_2;
  Handle_StepDimTol_RoundnessTolerance_3: typeof Handle_StepDimTol_RoundnessTolerance_3;
  Handle_StepDimTol_RoundnessTolerance_4: typeof Handle_StepDimTol_RoundnessTolerance_4;
  Handle_StepDimTol_CoaxialityTolerance: typeof Handle_StepDimTol_CoaxialityTolerance;
  Handle_StepDimTol_CoaxialityTolerance_1: typeof Handle_StepDimTol_CoaxialityTolerance_1;
  Handle_StepDimTol_CoaxialityTolerance_2: typeof Handle_StepDimTol_CoaxialityTolerance_2;
  Handle_StepDimTol_CoaxialityTolerance_3: typeof Handle_StepDimTol_CoaxialityTolerance_3;
  Handle_StepDimTol_CoaxialityTolerance_4: typeof Handle_StepDimTol_CoaxialityTolerance_4;
  StepDimTol_CoaxialityTolerance: typeof StepDimTol_CoaxialityTolerance;
  StepDimTol_DatumSystemOrReference: typeof StepDimTol_DatumSystemOrReference;
  Handle_StepDimTol_CircularRunoutTolerance: typeof Handle_StepDimTol_CircularRunoutTolerance;
  Handle_StepDimTol_CircularRunoutTolerance_1: typeof Handle_StepDimTol_CircularRunoutTolerance_1;
  Handle_StepDimTol_CircularRunoutTolerance_2: typeof Handle_StepDimTol_CircularRunoutTolerance_2;
  Handle_StepDimTol_CircularRunoutTolerance_3: typeof Handle_StepDimTol_CircularRunoutTolerance_3;
  Handle_StepDimTol_CircularRunoutTolerance_4: typeof Handle_StepDimTol_CircularRunoutTolerance_4;
  StepDimTol_CircularRunoutTolerance: typeof StepDimTol_CircularRunoutTolerance;
  Handle_StepDimTol_DatumSystem: typeof Handle_StepDimTol_DatumSystem;
  Handle_StepDimTol_DatumSystem_1: typeof Handle_StepDimTol_DatumSystem_1;
  Handle_StepDimTol_DatumSystem_2: typeof Handle_StepDimTol_DatumSystem_2;
  Handle_StepDimTol_DatumSystem_3: typeof Handle_StepDimTol_DatumSystem_3;
  Handle_StepDimTol_DatumSystem_4: typeof Handle_StepDimTol_DatumSystem_4;
  StepDimTol_DatumSystem: typeof StepDimTol_DatumSystem;
  StepDimTol_GeometricToleranceModifier: StepDimTol_GeometricToleranceModifier;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol_4;
  StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol: typeof StepDimTol_GeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol;
  Handle_StepDimTol_FlatnessTolerance: typeof Handle_StepDimTol_FlatnessTolerance;
  Handle_StepDimTol_FlatnessTolerance_1: typeof Handle_StepDimTol_FlatnessTolerance_1;
  Handle_StepDimTol_FlatnessTolerance_2: typeof Handle_StepDimTol_FlatnessTolerance_2;
  Handle_StepDimTol_FlatnessTolerance_3: typeof Handle_StepDimTol_FlatnessTolerance_3;
  Handle_StepDimTol_FlatnessTolerance_4: typeof Handle_StepDimTol_FlatnessTolerance_4;
  StepDimTol_FlatnessTolerance: typeof StepDimTol_FlatnessTolerance;
  Handle_StepDimTol_AngularityTolerance: typeof Handle_StepDimTol_AngularityTolerance;
  Handle_StepDimTol_AngularityTolerance_1: typeof Handle_StepDimTol_AngularityTolerance_1;
  Handle_StepDimTol_AngularityTolerance_2: typeof Handle_StepDimTol_AngularityTolerance_2;
  Handle_StepDimTol_AngularityTolerance_3: typeof Handle_StepDimTol_AngularityTolerance_3;
  Handle_StepDimTol_AngularityTolerance_4: typeof Handle_StepDimTol_AngularityTolerance_4;
  StepDimTol_AngularityTolerance: typeof StepDimTol_AngularityTolerance;
  StepDimTol_CylindricityTolerance: typeof StepDimTol_CylindricityTolerance;
  Handle_StepDimTol_CylindricityTolerance: typeof Handle_StepDimTol_CylindricityTolerance;
  Handle_StepDimTol_CylindricityTolerance_1: typeof Handle_StepDimTol_CylindricityTolerance_1;
  Handle_StepDimTol_CylindricityTolerance_2: typeof Handle_StepDimTol_CylindricityTolerance_2;
  Handle_StepDimTol_CylindricityTolerance_3: typeof Handle_StepDimTol_CylindricityTolerance_3;
  Handle_StepDimTol_CylindricityTolerance_4: typeof Handle_StepDimTol_CylindricityTolerance_4;
  StepDimTol_GeometricToleranceTarget: typeof StepDimTol_GeometricToleranceTarget;
  StepDimTol_DatumReferenceModifierType: StepDimTol_DatumReferenceModifierType;
  StepDimTol_ShapeToleranceSelect: typeof StepDimTol_ShapeToleranceSelect;
  StepDimTol_Datum: typeof StepDimTol_Datum;
  Handle_StepDimTol_Datum: typeof Handle_StepDimTol_Datum;
  Handle_StepDimTol_Datum_1: typeof Handle_StepDimTol_Datum_1;
  Handle_StepDimTol_Datum_2: typeof Handle_StepDimTol_Datum_2;
  Handle_StepDimTol_Datum_3: typeof Handle_StepDimTol_Datum_3;
  Handle_StepDimTol_Datum_4: typeof Handle_StepDimTol_Datum_4;
  Handle_StepDimTol_HArray1OfDatumReferenceCompartment: typeof Handle_StepDimTol_HArray1OfDatumReferenceCompartment;
  Handle_StepDimTol_HArray1OfDatumReferenceCompartment_1: typeof Handle_StepDimTol_HArray1OfDatumReferenceCompartment_1;
  Handle_StepDimTol_HArray1OfDatumReferenceCompartment_2: typeof Handle_StepDimTol_HArray1OfDatumReferenceCompartment_2;
  Handle_StepDimTol_HArray1OfDatumReferenceCompartment_3: typeof Handle_StepDimTol_HArray1OfDatumReferenceCompartment_3;
  Handle_StepDimTol_HArray1OfDatumReferenceCompartment_4: typeof Handle_StepDimTol_HArray1OfDatumReferenceCompartment_4;
  StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol: typeof StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_1: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_1;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_2: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_2;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_3: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_3;
  Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_4: typeof Handle_StepDimTol_GeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol_4;
  Handle_StepDimTol_SymmetryTolerance: typeof Handle_StepDimTol_SymmetryTolerance;
  Handle_StepDimTol_SymmetryTolerance_1: typeof Handle_StepDimTol_SymmetryTolerance_1;
  Handle_StepDimTol_SymmetryTolerance_2: typeof Handle_StepDimTol_SymmetryTolerance_2;
  Handle_StepDimTol_SymmetryTolerance_3: typeof Handle_StepDimTol_SymmetryTolerance_3;
  Handle_StepDimTol_SymmetryTolerance_4: typeof Handle_StepDimTol_SymmetryTolerance_4;
  StepDimTol_SymmetryTolerance: typeof StepDimTol_SymmetryTolerance;
  StepDimTol_DatumReferenceModifier: typeof StepDimTol_DatumReferenceModifier;
  StepDimTol_GeometricToleranceWithDefinedUnit: typeof StepDimTol_GeometricToleranceWithDefinedUnit;
  Handle_StepDimTol_GeometricToleranceWithDefinedUnit: typeof Handle_StepDimTol_GeometricToleranceWithDefinedUnit;
  Handle_StepDimTol_GeometricToleranceWithDefinedUnit_1: typeof Handle_StepDimTol_GeometricToleranceWithDefinedUnit_1;
  Handle_StepDimTol_GeometricToleranceWithDefinedUnit_2: typeof Handle_StepDimTol_GeometricToleranceWithDefinedUnit_2;
  Handle_StepDimTol_GeometricToleranceWithDefinedUnit_3: typeof Handle_StepDimTol_GeometricToleranceWithDefinedUnit_3;
  Handle_StepDimTol_GeometricToleranceWithDefinedUnit_4: typeof Handle_StepDimTol_GeometricToleranceWithDefinedUnit_4;
  Handle_StepDimTol_SurfaceProfileTolerance: typeof Handle_StepDimTol_SurfaceProfileTolerance;
  Handle_StepDimTol_SurfaceProfileTolerance_1: typeof Handle_StepDimTol_SurfaceProfileTolerance_1;
  Handle_StepDimTol_SurfaceProfileTolerance_2: typeof Handle_StepDimTol_SurfaceProfileTolerance_2;
  Handle_StepDimTol_SurfaceProfileTolerance_3: typeof Handle_StepDimTol_SurfaceProfileTolerance_3;
  Handle_StepDimTol_SurfaceProfileTolerance_4: typeof Handle_StepDimTol_SurfaceProfileTolerance_4;
  StepDimTol_SurfaceProfileTolerance: typeof StepDimTol_SurfaceProfileTolerance;
  StepDimTol_GeneralDatumReference: typeof StepDimTol_GeneralDatumReference;
  Handle_StepDimTol_GeneralDatumReference: typeof Handle_StepDimTol_GeneralDatumReference;
  Handle_StepDimTol_GeneralDatumReference_1: typeof Handle_StepDimTol_GeneralDatumReference_1;
  Handle_StepDimTol_GeneralDatumReference_2: typeof Handle_StepDimTol_GeneralDatumReference_2;
  Handle_StepDimTol_GeneralDatumReference_3: typeof Handle_StepDimTol_GeneralDatumReference_3;
  Handle_StepDimTol_GeneralDatumReference_4: typeof Handle_StepDimTol_GeneralDatumReference_4;
  StepDimTol_DatumOrCommonDatum: typeof StepDimTol_DatumOrCommonDatum;
  StepDimTol_GeometricToleranceType: StepDimTol_GeometricToleranceType;
  Handle_StepDimTol_ConcentricityTolerance: typeof Handle_StepDimTol_ConcentricityTolerance;
  Handle_StepDimTol_ConcentricityTolerance_1: typeof Handle_StepDimTol_ConcentricityTolerance_1;
  Handle_StepDimTol_ConcentricityTolerance_2: typeof Handle_StepDimTol_ConcentricityTolerance_2;
  Handle_StepDimTol_ConcentricityTolerance_3: typeof Handle_StepDimTol_ConcentricityTolerance_3;
  Handle_StepDimTol_ConcentricityTolerance_4: typeof Handle_StepDimTol_ConcentricityTolerance_4;
  StepDimTol_ConcentricityTolerance: typeof StepDimTol_ConcentricityTolerance;
  AppStdL_Application: typeof AppStdL_Application;
  Handle_AppStdL_Application: typeof Handle_AppStdL_Application;
  Handle_AppStdL_Application_1: typeof Handle_AppStdL_Application_1;
  Handle_AppStdL_Application_2: typeof Handle_AppStdL_Application_2;
  Handle_AppStdL_Application_3: typeof Handle_AppStdL_Application_3;
  Handle_AppStdL_Application_4: typeof Handle_AppStdL_Application_4;
  TopOpeBRep_EdgesIntersector: typeof TopOpeBRep_EdgesIntersector;
  TopOpeBRep_FacesFiller: typeof TopOpeBRep_FacesFiller;
  TopOpeBRep_Array1OfLineInter: typeof TopOpeBRep_Array1OfLineInter;
  TopOpeBRep_Array1OfLineInter_1: typeof TopOpeBRep_Array1OfLineInter_1;
  TopOpeBRep_Array1OfLineInter_2: typeof TopOpeBRep_Array1OfLineInter_2;
  TopOpeBRep_Array1OfLineInter_3: typeof TopOpeBRep_Array1OfLineInter_3;
  TopOpeBRep_Array1OfLineInter_4: typeof TopOpeBRep_Array1OfLineInter_4;
  TopOpeBRep_Array1OfLineInter_5: typeof TopOpeBRep_Array1OfLineInter_5;
  TopOpeBRep_Array1OfVPointInter: typeof TopOpeBRep_Array1OfVPointInter;
  TopOpeBRep_Array1OfVPointInter_1: typeof TopOpeBRep_Array1OfVPointInter_1;
  TopOpeBRep_Array1OfVPointInter_2: typeof TopOpeBRep_Array1OfVPointInter_2;
  TopOpeBRep_Array1OfVPointInter_3: typeof TopOpeBRep_Array1OfVPointInter_3;
  TopOpeBRep_Array1OfVPointInter_4: typeof TopOpeBRep_Array1OfVPointInter_4;
  TopOpeBRep_Array1OfVPointInter_5: typeof TopOpeBRep_Array1OfVPointInter_5;
  TopOpeBRep_Hctxff2d: typeof TopOpeBRep_Hctxff2d;
  Handle_TopOpeBRep_Hctxff2d: typeof Handle_TopOpeBRep_Hctxff2d;
  Handle_TopOpeBRep_Hctxff2d_1: typeof Handle_TopOpeBRep_Hctxff2d_1;
  Handle_TopOpeBRep_Hctxff2d_2: typeof Handle_TopOpeBRep_Hctxff2d_2;
  Handle_TopOpeBRep_Hctxff2d_3: typeof Handle_TopOpeBRep_Hctxff2d_3;
  Handle_TopOpeBRep_Hctxff2d_4: typeof Handle_TopOpeBRep_Hctxff2d_4;
  TopOpeBRep_FaceEdgeFiller: typeof TopOpeBRep_FaceEdgeFiller;
  TopOpeBRep_P2Dstatus: TopOpeBRep_P2Dstatus;
  TopOpeBRep_Hctxee2d: typeof TopOpeBRep_Hctxee2d;
  Handle_TopOpeBRep_Hctxee2d: typeof Handle_TopOpeBRep_Hctxee2d;
  Handle_TopOpeBRep_Hctxee2d_1: typeof Handle_TopOpeBRep_Hctxee2d_1;
  Handle_TopOpeBRep_Hctxee2d_2: typeof Handle_TopOpeBRep_Hctxee2d_2;
  Handle_TopOpeBRep_Hctxee2d_3: typeof Handle_TopOpeBRep_Hctxee2d_3;
  Handle_TopOpeBRep_Hctxee2d_4: typeof Handle_TopOpeBRep_Hctxee2d_4;
  Handle_TopOpeBRep_HArray1OfLineInter: typeof Handle_TopOpeBRep_HArray1OfLineInter;
  Handle_TopOpeBRep_HArray1OfLineInter_1: typeof Handle_TopOpeBRep_HArray1OfLineInter_1;
  Handle_TopOpeBRep_HArray1OfLineInter_2: typeof Handle_TopOpeBRep_HArray1OfLineInter_2;
  Handle_TopOpeBRep_HArray1OfLineInter_3: typeof Handle_TopOpeBRep_HArray1OfLineInter_3;
  Handle_TopOpeBRep_HArray1OfLineInter_4: typeof Handle_TopOpeBRep_HArray1OfLineInter_4;
  TopOpeBRep_EdgesFiller: typeof TopOpeBRep_EdgesFiller;
  TopOpeBRep_DSFiller: typeof TopOpeBRep_DSFiller;
  TopOpeBRep_VPointInterIterator: typeof TopOpeBRep_VPointInterIterator;
  TopOpeBRep_VPointInterIterator_1: typeof TopOpeBRep_VPointInterIterator_1;
  TopOpeBRep_VPointInterIterator_2: typeof TopOpeBRep_VPointInterIterator_2;
  TopOpeBRep_VPointInter: typeof TopOpeBRep_VPointInter;
  TopOpeBRep_PointGeomTool: typeof TopOpeBRep_PointGeomTool;
  TopOpeBRep_FacesIntersector: typeof TopOpeBRep_FacesIntersector;
  TopOpeBRep_ShapeIntersector2d: typeof TopOpeBRep_ShapeIntersector2d;
  TopOpeBRep_WPointInterIterator: typeof TopOpeBRep_WPointInterIterator;
  TopOpeBRep_WPointInterIterator_1: typeof TopOpeBRep_WPointInterIterator_1;
  TopOpeBRep_WPointInterIterator_2: typeof TopOpeBRep_WPointInterIterator_2;
  TopOpeBRep_GeomTool: typeof TopOpeBRep_GeomTool;
  TopOpeBRep_SequenceOfPoint2d: typeof TopOpeBRep_SequenceOfPoint2d;
  TopOpeBRep_SequenceOfPoint2d_1: typeof TopOpeBRep_SequenceOfPoint2d_1;
  TopOpeBRep_SequenceOfPoint2d_2: typeof TopOpeBRep_SequenceOfPoint2d_2;
  TopOpeBRep_SequenceOfPoint2d_3: typeof TopOpeBRep_SequenceOfPoint2d_3;
  TopOpeBRep_FaceEdgeIntersector: typeof TopOpeBRep_FaceEdgeIntersector;
  TopOpeBRep_FFTransitionTool: typeof TopOpeBRep_FFTransitionTool;
  TopOpeBRep_VPointInterClassifier: typeof TopOpeBRep_VPointInterClassifier;
  Handle_TopOpeBRep_HArray1OfVPointInter: typeof Handle_TopOpeBRep_HArray1OfVPointInter;
  Handle_TopOpeBRep_HArray1OfVPointInter_1: typeof Handle_TopOpeBRep_HArray1OfVPointInter_1;
  Handle_TopOpeBRep_HArray1OfVPointInter_2: typeof Handle_TopOpeBRep_HArray1OfVPointInter_2;
  Handle_TopOpeBRep_HArray1OfVPointInter_3: typeof Handle_TopOpeBRep_HArray1OfVPointInter_3;
  Handle_TopOpeBRep_HArray1OfVPointInter_4: typeof Handle_TopOpeBRep_HArray1OfVPointInter_4;
  TopOpeBRep: typeof TopOpeBRep;
  TopOpeBRep_PointClassifier: typeof TopOpeBRep_PointClassifier;
  TopOpeBRep_ListOfBipoint: typeof TopOpeBRep_ListOfBipoint;
  TopOpeBRep_ListOfBipoint_1: typeof TopOpeBRep_ListOfBipoint_1;
  TopOpeBRep_ListOfBipoint_2: typeof TopOpeBRep_ListOfBipoint_2;
  TopOpeBRep_ListOfBipoint_3: typeof TopOpeBRep_ListOfBipoint_3;
  TopOpeBRep_WPointInter: typeof TopOpeBRep_WPointInter;
  Handle_TopOpeBRep_FFDumper: typeof Handle_TopOpeBRep_FFDumper;
  Handle_TopOpeBRep_FFDumper_1: typeof Handle_TopOpeBRep_FFDumper_1;
  Handle_TopOpeBRep_FFDumper_2: typeof Handle_TopOpeBRep_FFDumper_2;
  Handle_TopOpeBRep_FFDumper_3: typeof Handle_TopOpeBRep_FFDumper_3;
  Handle_TopOpeBRep_FFDumper_4: typeof Handle_TopOpeBRep_FFDumper_4;
  TopOpeBRep_FFDumper: typeof TopOpeBRep_FFDumper;
  TopOpeBRep_TypeLineCurve: TopOpeBRep_TypeLineCurve;
  TopOpeBRep_Point2d: typeof TopOpeBRep_Point2d;
  TopOpeBRep_Bipoint: typeof TopOpeBRep_Bipoint;
  TopOpeBRep_Bipoint_1: typeof TopOpeBRep_Bipoint_1;
  TopOpeBRep_Bipoint_2: typeof TopOpeBRep_Bipoint_2;
  TopOpeBRep_ShapeScanner: typeof TopOpeBRep_ShapeScanner;
  TopOpeBRep_ShapeIntersector: typeof TopOpeBRep_ShapeIntersector;
  TopOpeBRep_LineInter: typeof TopOpeBRep_LineInter;
  TopBas_TestInterference: typeof TopBas_TestInterference;
  TopBas_TestInterference_1: typeof TopBas_TestInterference_1;
  TopBas_TestInterference_2: typeof TopBas_TestInterference_2;
  TopBas_ListOfTestInterference: typeof TopBas_ListOfTestInterference;
  TopBas_ListOfTestInterference_1: typeof TopBas_ListOfTestInterference_1;
  TopBas_ListOfTestInterference_2: typeof TopBas_ListOfTestInterference_2;
  TopBas_ListOfTestInterference_3: typeof TopBas_ListOfTestInterference_3;
  Geom2dLProp_NumericCurInf2d: typeof Geom2dLProp_NumericCurInf2d;
  Geom2dLProp_CLProps2d: typeof Geom2dLProp_CLProps2d;
  Geom2dLProp_CLProps2d_1: typeof Geom2dLProp_CLProps2d_1;
  Geom2dLProp_CLProps2d_2: typeof Geom2dLProp_CLProps2d_2;
  Geom2dLProp_CLProps2d_3: typeof Geom2dLProp_CLProps2d_3;
  Geom2dLProp_FuncCurExt: typeof Geom2dLProp_FuncCurExt;
  Geom2dLProp_Curve2dTool: typeof Geom2dLProp_Curve2dTool;
  Geom2dLProp_FuncCurNul: typeof Geom2dLProp_FuncCurNul;
  Geom2dLProp_CurAndInf2d: typeof Geom2dLProp_CurAndInf2d;
  ChFi3d_FilBuilder: typeof ChFi3d_FilBuilder;
  ChFi3d: typeof ChFi3d;
  ChFi3d_SearchSing: typeof ChFi3d_SearchSing;
  ChFi3d_ChBuilder: typeof ChFi3d_ChBuilder;
  ChFi3d_Builder: typeof ChFi3d_Builder;
  ChFi3d_FilletShape: ChFi3d_FilletShape;
  BRepBlend_SurfRstEvolRad: typeof BRepBlend_SurfRstEvolRad;
  BRepBlend_RstRstLineBuilder: typeof BRepBlend_RstRstLineBuilder;
  BRepBlend_SurfPointConstRadInv: typeof BRepBlend_SurfPointConstRadInv;
  BRepBlend_Walking: typeof BRepBlend_Walking;
  BRepBlend_AppSurf: typeof BRepBlend_AppSurf;
  BRepBlend_AppSurf_1: typeof BRepBlend_AppSurf_1;
  BRepBlend_AppSurf_2: typeof BRepBlend_AppSurf_2;
  BRepBlend_HCurve2dTool: typeof BRepBlend_HCurve2dTool;
  BRepBlend_CurvPointRadInv: typeof BRepBlend_CurvPointRadInv;
  BRepBlend_AppFuncRstRst: typeof BRepBlend_AppFuncRstRst;
  Handle_BRepBlend_AppFuncRstRst: typeof Handle_BRepBlend_AppFuncRstRst;
  Handle_BRepBlend_AppFuncRstRst_1: typeof Handle_BRepBlend_AppFuncRstRst_1;
  Handle_BRepBlend_AppFuncRstRst_2: typeof Handle_BRepBlend_AppFuncRstRst_2;
  Handle_BRepBlend_AppFuncRstRst_3: typeof Handle_BRepBlend_AppFuncRstRst_3;
  Handle_BRepBlend_AppFuncRstRst_4: typeof Handle_BRepBlend_AppFuncRstRst_4;
  BRepBlend_AppSurface: typeof BRepBlend_AppSurface;
  BRepBlend_PointOnRst: typeof BRepBlend_PointOnRst;
  BRepBlend_PointOnRst_1: typeof BRepBlend_PointOnRst_1;
  BRepBlend_PointOnRst_2: typeof BRepBlend_PointOnRst_2;
  BRepBlend_SequenceOfPointOnRst: typeof BRepBlend_SequenceOfPointOnRst;
  BRepBlend_SequenceOfPointOnRst_1: typeof BRepBlend_SequenceOfPointOnRst_1;
  BRepBlend_SequenceOfPointOnRst_2: typeof BRepBlend_SequenceOfPointOnRst_2;
  BRepBlend_SequenceOfPointOnRst_3: typeof BRepBlend_SequenceOfPointOnRst_3;
  BRepBlend_RstRstConstRad: typeof BRepBlend_RstRstConstRad;
  BRepBlend_SurfCurvConstRadInv: typeof BRepBlend_SurfCurvConstRadInv;
  BRepBlend_AppFuncRst: typeof BRepBlend_AppFuncRst;
  Handle_BRepBlend_AppFuncRst: typeof Handle_BRepBlend_AppFuncRst;
  Handle_BRepBlend_AppFuncRst_1: typeof Handle_BRepBlend_AppFuncRst_1;
  Handle_BRepBlend_AppFuncRst_2: typeof Handle_BRepBlend_AppFuncRst_2;
  Handle_BRepBlend_AppFuncRst_3: typeof Handle_BRepBlend_AppFuncRst_3;
  Handle_BRepBlend_AppFuncRst_4: typeof Handle_BRepBlend_AppFuncRst_4;
  BRepBlend_RstRstEvolRad: typeof BRepBlend_RstRstEvolRad;
  BRepBlend_Extremity: typeof BRepBlend_Extremity;
  BRepBlend_Extremity_1: typeof BRepBlend_Extremity_1;
  BRepBlend_Extremity_2: typeof BRepBlend_Extremity_2;
  BRepBlend_Extremity_3: typeof BRepBlend_Extremity_3;
  BRepBlend_Extremity_4: typeof BRepBlend_Extremity_4;
  BRepBlend_Line: typeof BRepBlend_Line;
  Handle_BRepBlend_Line: typeof Handle_BRepBlend_Line;
  Handle_BRepBlend_Line_1: typeof Handle_BRepBlend_Line_1;
  Handle_BRepBlend_Line_2: typeof Handle_BRepBlend_Line_2;
  Handle_BRepBlend_Line_3: typeof Handle_BRepBlend_Line_3;
  Handle_BRepBlend_Line_4: typeof Handle_BRepBlend_Line_4;
  BRepBlend_HCurveTool: typeof BRepBlend_HCurveTool;
  BRepBlend_AppFuncRoot: typeof BRepBlend_AppFuncRoot;
  Handle_BRepBlend_AppFuncRoot: typeof Handle_BRepBlend_AppFuncRoot;
  Handle_BRepBlend_AppFuncRoot_1: typeof Handle_BRepBlend_AppFuncRoot_1;
  Handle_BRepBlend_AppFuncRoot_2: typeof Handle_BRepBlend_AppFuncRoot_2;
  Handle_BRepBlend_AppFuncRoot_3: typeof Handle_BRepBlend_AppFuncRoot_3;
  Handle_BRepBlend_AppFuncRoot_4: typeof Handle_BRepBlend_AppFuncRoot_4;
  BRepBlend_SurfPointEvolRadInv: typeof BRepBlend_SurfPointEvolRadInv;
  BRepBlend_CSWalking: typeof BRepBlend_CSWalking;
  BRepBlend_SurfRstLineBuilder: typeof BRepBlend_SurfRstLineBuilder;
  BRepBlend_BlendTool: typeof BRepBlend_BlendTool;
  Handle_BRepBlend_AppFunc: typeof Handle_BRepBlend_AppFunc;
  Handle_BRepBlend_AppFunc_1: typeof Handle_BRepBlend_AppFunc_1;
  Handle_BRepBlend_AppFunc_2: typeof Handle_BRepBlend_AppFunc_2;
  Handle_BRepBlend_AppFunc_3: typeof Handle_BRepBlend_AppFunc_3;
  Handle_BRepBlend_AppFunc_4: typeof Handle_BRepBlend_AppFunc_4;
  BRepBlend_AppFunc: typeof BRepBlend_AppFunc;
  BRepBlend_SurfRstConstRad: typeof BRepBlend_SurfRstConstRad;
  BRepBlend_SurfCurvEvolRadInv: typeof BRepBlend_SurfCurvEvolRadInv;
  TopExp_Explorer: typeof TopExp_Explorer;
  TopExp_Explorer_1: typeof TopExp_Explorer_1;
  TopExp_Explorer_2: typeof TopExp_Explorer_2;
  TopExp: typeof TopExp;
  RWStepDimTol_RWProjectedZoneDefinition: typeof RWStepDimTol_RWProjectedZoneDefinition;
  RWStepDimTol_RWGeoTolAndGeoTolWthDatRef: typeof RWStepDimTol_RWGeoTolAndGeoTolWthDatRef;
  RWStepDimTol_RWGeometricToleranceWithMaximumTolerance: typeof RWStepDimTol_RWGeometricToleranceWithMaximumTolerance;
  RWStepDimTol_RWPositionTolerance: typeof RWStepDimTol_RWPositionTolerance;
  RWStepDimTol_RWToleranceZone: typeof RWStepDimTol_RWToleranceZone;
  RWStepDimTol_RWDatumReferenceModifierWithValue: typeof RWStepDimTol_RWDatumReferenceModifierWithValue;
  RWStepDimTol_RWTotalRunoutTolerance: typeof RWStepDimTol_RWTotalRunoutTolerance;
  RWStepDimTol_RWGeometricTolerance: typeof RWStepDimTol_RWGeometricTolerance;
  RWStepDimTol_RWRunoutZoneDefinition: typeof RWStepDimTol_RWRunoutZoneDefinition;
  RWStepDimTol_RWStraightnessTolerance: typeof RWStepDimTol_RWStraightnessTolerance;
  RWStepDimTol_RWLineProfileTolerance: typeof RWStepDimTol_RWLineProfileTolerance;
  RWStepDimTol_RWRunoutZoneOrientation: typeof RWStepDimTol_RWRunoutZoneOrientation;
  RWStepDimTol_RWGeometricToleranceRelationship: typeof RWStepDimTol_RWGeometricToleranceRelationship;
  RWStepDimTol_RWNonUniformZoneDefinition: typeof RWStepDimTol_RWNonUniformZoneDefinition;
  RWStepDimTol_RWDatumFeature: typeof RWStepDimTol_RWDatumFeature;
  RWStepDimTol_RWDatumReferenceElement: typeof RWStepDimTol_RWDatumReferenceElement;
  RWStepDimTol_RWCylindricityTolerance: typeof RWStepDimTol_RWCylindricityTolerance;
  RWStepDimTol_RWSurfaceProfileTolerance: typeof RWStepDimTol_RWSurfaceProfileTolerance;
  RWStepDimTol_RWGeometricToleranceWithDefinedAreaUnit: typeof RWStepDimTol_RWGeometricToleranceWithDefinedAreaUnit;
  RWStepDimTol_RWGeoTolAndGeoTolWthMod: typeof RWStepDimTol_RWGeoTolAndGeoTolWthMod;
  RWStepDimTol_RWCircularRunoutTolerance: typeof RWStepDimTol_RWCircularRunoutTolerance;
  RWStepDimTol_RWGeneralDatumReference: typeof RWStepDimTol_RWGeneralDatumReference;
  RWStepDimTol_RWToleranceZoneDefinition: typeof RWStepDimTol_RWToleranceZoneDefinition;
  RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol: typeof RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndGeoTolWthMaxTol;
  RWStepDimTol_RWGeometricToleranceWithDatumReference: typeof RWStepDimTol_RWGeometricToleranceWithDatumReference;
  RWStepDimTol_RWToleranceZoneForm: typeof RWStepDimTol_RWToleranceZoneForm;
  RWStepDimTol_RWPlacedDatumTargetFeature: typeof RWStepDimTol_RWPlacedDatumTargetFeature;
  RWStepDimTol_RWAngularityTolerance: typeof RWStepDimTol_RWAngularityTolerance;
  RWStepDimTol_RWCommonDatum: typeof RWStepDimTol_RWCommonDatum;
  RWStepDimTol_RWGeometricToleranceWithModifiers: typeof RWStepDimTol_RWGeometricToleranceWithModifiers;
  RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol: typeof RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndModGeoTolAndPosTol;
  RWStepDimTol_RWPerpendicularityTolerance: typeof RWStepDimTol_RWPerpendicularityTolerance;
  RWStepDimTol_RWDatumSystem: typeof RWStepDimTol_RWDatumSystem;
  RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndUneqDisGeoTol: typeof RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndUneqDisGeoTol;
  RWStepDimTol_RWGeometricToleranceWithDefinedUnit: typeof RWStepDimTol_RWGeometricToleranceWithDefinedUnit;
  RWStepDimTol_RWUnequallyDisposedGeometricTolerance: typeof RWStepDimTol_RWUnequallyDisposedGeometricTolerance;
  RWStepDimTol_RWGeoTolAndGeoTolWthMaxTol: typeof RWStepDimTol_RWGeoTolAndGeoTolWthMaxTol;
  RWStepDimTol_RWCoaxialityTolerance: typeof RWStepDimTol_RWCoaxialityTolerance;
  RWStepDimTol_RWConcentricityTolerance: typeof RWStepDimTol_RWConcentricityTolerance;
  RWStepDimTol_RWRoundnessTolerance: typeof RWStepDimTol_RWRoundnessTolerance;
  RWStepDimTol_RWDatumReference: typeof RWStepDimTol_RWDatumReference;
  RWStepDimTol_RWSymmetryTolerance: typeof RWStepDimTol_RWSymmetryTolerance;
  RWStepDimTol_RWFlatnessTolerance: typeof RWStepDimTol_RWFlatnessTolerance;
  RWStepDimTol_RWDatumReferenceCompartment: typeof RWStepDimTol_RWDatumReferenceCompartment;
  RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndGeoTolWthMod: typeof RWStepDimTol_RWGeoTolAndGeoTolWthDatRefAndGeoTolWthMod;
  RWStepDimTol_RWParallelismTolerance: typeof RWStepDimTol_RWParallelismTolerance;
  RWStepDimTol_RWModifiedGeometricTolerance: typeof RWStepDimTol_RWModifiedGeometricTolerance;
  RWStepDimTol_RWDatumTarget: typeof RWStepDimTol_RWDatumTarget;
  RWStepDimTol_RWDatum: typeof RWStepDimTol_RWDatum;
  BndLib: typeof BndLib;
  BndLib_Add2dCurve: typeof BndLib_Add2dCurve;
  BndLib_AddSurface: typeof BndLib_AddSurface;
  BndLib_Add3dCurve: typeof BndLib_Add3dCurve;
  HLRAlgo_PolyInternalSegment: typeof HLRAlgo_PolyInternalSegment;
  HLRAlgo_PolyInternalNode: typeof HLRAlgo_PolyInternalNode;
  Handle_HLRAlgo_PolyInternalNode: typeof Handle_HLRAlgo_PolyInternalNode;
  Handle_HLRAlgo_PolyInternalNode_1: typeof Handle_HLRAlgo_PolyInternalNode_1;
  Handle_HLRAlgo_PolyInternalNode_2: typeof Handle_HLRAlgo_PolyInternalNode_2;
  Handle_HLRAlgo_PolyInternalNode_3: typeof Handle_HLRAlgo_PolyInternalNode_3;
  Handle_HLRAlgo_PolyInternalNode_4: typeof Handle_HLRAlgo_PolyInternalNode_4;
  Handle_HLRAlgo_EdgesBlock: typeof Handle_HLRAlgo_EdgesBlock;
  Handle_HLRAlgo_EdgesBlock_1: typeof Handle_HLRAlgo_EdgesBlock_1;
  Handle_HLRAlgo_EdgesBlock_2: typeof Handle_HLRAlgo_EdgesBlock_2;
  Handle_HLRAlgo_EdgesBlock_3: typeof Handle_HLRAlgo_EdgesBlock_3;
  Handle_HLRAlgo_EdgesBlock_4: typeof Handle_HLRAlgo_EdgesBlock_4;
  HLRAlgo_EdgesBlock: typeof HLRAlgo_EdgesBlock;
  HLRAlgo: typeof HLRAlgo;
  HLRAlgo_PolyMask: HLRAlgo_PolyMask;
  HLRAlgo_EdgeIterator: typeof HLRAlgo_EdgeIterator;
  Handle_HLRAlgo_HArray1OfPISeg: typeof Handle_HLRAlgo_HArray1OfPISeg;
  Handle_HLRAlgo_HArray1OfPISeg_1: typeof Handle_HLRAlgo_HArray1OfPISeg_1;
  Handle_HLRAlgo_HArray1OfPISeg_2: typeof Handle_HLRAlgo_HArray1OfPISeg_2;
  Handle_HLRAlgo_HArray1OfPISeg_3: typeof Handle_HLRAlgo_HArray1OfPISeg_3;
  Handle_HLRAlgo_HArray1OfPISeg_4: typeof Handle_HLRAlgo_HArray1OfPISeg_4;
  HLRAlgo_PolyShellData: typeof HLRAlgo_PolyShellData;
  Handle_HLRAlgo_PolyShellData: typeof Handle_HLRAlgo_PolyShellData;
  Handle_HLRAlgo_PolyShellData_1: typeof Handle_HLRAlgo_PolyShellData_1;
  Handle_HLRAlgo_PolyShellData_2: typeof Handle_HLRAlgo_PolyShellData_2;
  Handle_HLRAlgo_PolyShellData_3: typeof Handle_HLRAlgo_PolyShellData_3;
  Handle_HLRAlgo_PolyShellData_4: typeof Handle_HLRAlgo_PolyShellData_4;
  HLRAlgo_Array1OfTData: typeof HLRAlgo_Array1OfTData;
  HLRAlgo_Array1OfTData_1: typeof HLRAlgo_Array1OfTData_1;
  HLRAlgo_Array1OfTData_2: typeof HLRAlgo_Array1OfTData_2;
  HLRAlgo_Array1OfTData_3: typeof HLRAlgo_Array1OfTData_3;
  HLRAlgo_Array1OfTData_4: typeof HLRAlgo_Array1OfTData_4;
  HLRAlgo_Array1OfTData_5: typeof HLRAlgo_Array1OfTData_5;
  Handle_HLRAlgo_HArray1OfPINod: typeof Handle_HLRAlgo_HArray1OfPINod;
  Handle_HLRAlgo_HArray1OfPINod_1: typeof Handle_HLRAlgo_HArray1OfPINod_1;
  Handle_HLRAlgo_HArray1OfPINod_2: typeof Handle_HLRAlgo_HArray1OfPINod_2;
  Handle_HLRAlgo_HArray1OfPINod_3: typeof Handle_HLRAlgo_HArray1OfPINod_3;
  Handle_HLRAlgo_HArray1OfPINod_4: typeof Handle_HLRAlgo_HArray1OfPINod_4;
  HLRAlgo_Coincidence: typeof HLRAlgo_Coincidence;
  HLRAlgo_BiPoint: typeof HLRAlgo_BiPoint;
  HLRAlgo_BiPoint_1: typeof HLRAlgo_BiPoint_1;
  HLRAlgo_BiPoint_2: typeof HLRAlgo_BiPoint_2;
  HLRAlgo_BiPoint_3: typeof HLRAlgo_BiPoint_3;
  HLRAlgo_BiPoint_4: typeof HLRAlgo_BiPoint_4;
  HLRAlgo_BiPoint_5: typeof HLRAlgo_BiPoint_5;
  HLRAlgo_BiPoint_6: typeof HLRAlgo_BiPoint_6;
  HLRAlgo_BiPoint_7: typeof HLRAlgo_BiPoint_7;
  HLRAlgo_Projector: typeof HLRAlgo_Projector;
  HLRAlgo_Projector_1: typeof HLRAlgo_Projector_1;
  HLRAlgo_Projector_2: typeof HLRAlgo_Projector_2;
  HLRAlgo_Projector_3: typeof HLRAlgo_Projector_3;
  HLRAlgo_Projector_4: typeof HLRAlgo_Projector_4;
  HLRAlgo_Projector_5: typeof HLRAlgo_Projector_5;
  HLRAlgo_PolyHidingData: typeof HLRAlgo_PolyHidingData;
  Handle_HLRAlgo_PolyData: typeof Handle_HLRAlgo_PolyData;
  Handle_HLRAlgo_PolyData_1: typeof Handle_HLRAlgo_PolyData_1;
  Handle_HLRAlgo_PolyData_2: typeof Handle_HLRAlgo_PolyData_2;
  Handle_HLRAlgo_PolyData_3: typeof Handle_HLRAlgo_PolyData_3;
  Handle_HLRAlgo_PolyData_4: typeof Handle_HLRAlgo_PolyData_4;
  HLRAlgo_PolyData: typeof HLRAlgo_PolyData;
  Handle_HLRAlgo_WiresBlock: typeof Handle_HLRAlgo_WiresBlock;
  Handle_HLRAlgo_WiresBlock_1: typeof Handle_HLRAlgo_WiresBlock_1;
  Handle_HLRAlgo_WiresBlock_2: typeof Handle_HLRAlgo_WiresBlock_2;
  Handle_HLRAlgo_WiresBlock_3: typeof Handle_HLRAlgo_WiresBlock_3;
  Handle_HLRAlgo_WiresBlock_4: typeof Handle_HLRAlgo_WiresBlock_4;
  HLRAlgo_WiresBlock: typeof HLRAlgo_WiresBlock;
  Handle_HLRAlgo_PolyInternalData: typeof Handle_HLRAlgo_PolyInternalData;
  Handle_HLRAlgo_PolyInternalData_1: typeof Handle_HLRAlgo_PolyInternalData_1;
  Handle_HLRAlgo_PolyInternalData_2: typeof Handle_HLRAlgo_PolyInternalData_2;
  Handle_HLRAlgo_PolyInternalData_3: typeof Handle_HLRAlgo_PolyInternalData_3;
  Handle_HLRAlgo_PolyInternalData_4: typeof Handle_HLRAlgo_PolyInternalData_4;
  HLRAlgo_PolyInternalData: typeof HLRAlgo_PolyInternalData;
  HLRAlgo_TriangleData: typeof HLRAlgo_TriangleData;
  HLRAlgo_EdgeStatus: typeof HLRAlgo_EdgeStatus;
  HLRAlgo_EdgeStatus_1: typeof HLRAlgo_EdgeStatus_1;
  HLRAlgo_EdgeStatus_2: typeof HLRAlgo_EdgeStatus_2;
  HLRAlgo_Array1OfPISeg: typeof HLRAlgo_Array1OfPISeg;
  HLRAlgo_Array1OfPISeg_1: typeof HLRAlgo_Array1OfPISeg_1;
  HLRAlgo_Array1OfPISeg_2: typeof HLRAlgo_Array1OfPISeg_2;
  HLRAlgo_Array1OfPISeg_3: typeof HLRAlgo_Array1OfPISeg_3;
  HLRAlgo_Array1OfPISeg_4: typeof HLRAlgo_Array1OfPISeg_4;
  HLRAlgo_Array1OfPISeg_5: typeof HLRAlgo_Array1OfPISeg_5;
  HLRAlgo_PolyAlgo: typeof HLRAlgo_PolyAlgo;
  Handle_HLRAlgo_PolyAlgo: typeof Handle_HLRAlgo_PolyAlgo;
  Handle_HLRAlgo_PolyAlgo_1: typeof Handle_HLRAlgo_PolyAlgo_1;
  Handle_HLRAlgo_PolyAlgo_2: typeof Handle_HLRAlgo_PolyAlgo_2;
  Handle_HLRAlgo_PolyAlgo_3: typeof Handle_HLRAlgo_PolyAlgo_3;
  Handle_HLRAlgo_PolyAlgo_4: typeof Handle_HLRAlgo_PolyAlgo_4;
  Handle_HLRAlgo_HArray1OfPHDat: typeof Handle_HLRAlgo_HArray1OfPHDat;
  Handle_HLRAlgo_HArray1OfPHDat_1: typeof Handle_HLRAlgo_HArray1OfPHDat_1;
  Handle_HLRAlgo_HArray1OfPHDat_2: typeof Handle_HLRAlgo_HArray1OfPHDat_2;
  Handle_HLRAlgo_HArray1OfPHDat_3: typeof Handle_HLRAlgo_HArray1OfPHDat_3;
  Handle_HLRAlgo_HArray1OfPHDat_4: typeof Handle_HLRAlgo_HArray1OfPHDat_4;
  HLRAlgo_Interference: typeof HLRAlgo_Interference;
  HLRAlgo_Interference_1: typeof HLRAlgo_Interference_1;
  HLRAlgo_Interference_2: typeof HLRAlgo_Interference_2;
  HLRAlgo_InterferenceList: typeof HLRAlgo_InterferenceList;
  HLRAlgo_InterferenceList_1: typeof HLRAlgo_InterferenceList_1;
  HLRAlgo_InterferenceList_2: typeof HLRAlgo_InterferenceList_2;
  HLRAlgo_InterferenceList_3: typeof HLRAlgo_InterferenceList_3;
  Handle_HLRAlgo_HArray1OfTData: typeof Handle_HLRAlgo_HArray1OfTData;
  Handle_HLRAlgo_HArray1OfTData_1: typeof Handle_HLRAlgo_HArray1OfTData_1;
  Handle_HLRAlgo_HArray1OfTData_2: typeof Handle_HLRAlgo_HArray1OfTData_2;
  Handle_HLRAlgo_HArray1OfTData_3: typeof Handle_HLRAlgo_HArray1OfTData_3;
  Handle_HLRAlgo_HArray1OfTData_4: typeof Handle_HLRAlgo_HArray1OfTData_4;
  HLRAlgo_Array1OfPHDat: typeof HLRAlgo_Array1OfPHDat;
  HLRAlgo_Array1OfPHDat_1: typeof HLRAlgo_Array1OfPHDat_1;
  HLRAlgo_Array1OfPHDat_2: typeof HLRAlgo_Array1OfPHDat_2;
  HLRAlgo_Array1OfPHDat_3: typeof HLRAlgo_Array1OfPHDat_3;
  HLRAlgo_Array1OfPHDat_4: typeof HLRAlgo_Array1OfPHDat_4;
  HLRAlgo_Array1OfPHDat_5: typeof HLRAlgo_Array1OfPHDat_5;
  HLRAlgo_Intersection: typeof HLRAlgo_Intersection;
  HLRAlgo_Intersection_1: typeof HLRAlgo_Intersection_1;
  HLRAlgo_Intersection_2: typeof HLRAlgo_Intersection_2;
  HLRAlgo_ListOfBPoint: typeof HLRAlgo_ListOfBPoint;
  HLRAlgo_ListOfBPoint_1: typeof HLRAlgo_ListOfBPoint_1;
  HLRAlgo_ListOfBPoint_2: typeof HLRAlgo_ListOfBPoint_2;
  HLRAlgo_ListOfBPoint_3: typeof HLRAlgo_ListOfBPoint_3;
  BinLDrivers_DocumentRetrievalDriver: typeof BinLDrivers_DocumentRetrievalDriver;
  Handle_BinLDrivers_DocumentRetrievalDriver: typeof Handle_BinLDrivers_DocumentRetrievalDriver;
  Handle_BinLDrivers_DocumentRetrievalDriver_1: typeof Handle_BinLDrivers_DocumentRetrievalDriver_1;
  Handle_BinLDrivers_DocumentRetrievalDriver_2: typeof Handle_BinLDrivers_DocumentRetrievalDriver_2;
  Handle_BinLDrivers_DocumentRetrievalDriver_3: typeof Handle_BinLDrivers_DocumentRetrievalDriver_3;
  Handle_BinLDrivers_DocumentRetrievalDriver_4: typeof Handle_BinLDrivers_DocumentRetrievalDriver_4;
  Handle_BinLDrivers_DocumentStorageDriver: typeof Handle_BinLDrivers_DocumentStorageDriver;
  Handle_BinLDrivers_DocumentStorageDriver_1: typeof Handle_BinLDrivers_DocumentStorageDriver_1;
  Handle_BinLDrivers_DocumentStorageDriver_2: typeof Handle_BinLDrivers_DocumentStorageDriver_2;
  Handle_BinLDrivers_DocumentStorageDriver_3: typeof Handle_BinLDrivers_DocumentStorageDriver_3;
  Handle_BinLDrivers_DocumentStorageDriver_4: typeof Handle_BinLDrivers_DocumentStorageDriver_4;
  BinLDrivers_DocumentStorageDriver: typeof BinLDrivers_DocumentStorageDriver;
  BinLDrivers_Marker: BinLDrivers_Marker;
  BinLDrivers: typeof BinLDrivers;
  BinLDrivers_VectorOfDocumentSection: typeof BinLDrivers_VectorOfDocumentSection;
  BinLDrivers_VectorOfDocumentSection_1: typeof BinLDrivers_VectorOfDocumentSection_1;
  BinLDrivers_VectorOfDocumentSection_2: typeof BinLDrivers_VectorOfDocumentSection_2;
  BinLDrivers_DocumentSection: typeof BinLDrivers_DocumentSection;
  BinLDrivers_DocumentSection_1: typeof BinLDrivers_DocumentSection_1;
  BinLDrivers_DocumentSection_2: typeof BinLDrivers_DocumentSection_2;
  TopoDSToStep_MakeFacetedBrep: typeof TopoDSToStep_MakeFacetedBrep;
  TopoDSToStep_MakeFacetedBrep_1: typeof TopoDSToStep_MakeFacetedBrep_1;
  TopoDSToStep_MakeFacetedBrep_2: typeof TopoDSToStep_MakeFacetedBrep_2;
  TopoDSToStep_MakeStepFace: typeof TopoDSToStep_MakeStepFace;
  TopoDSToStep_MakeStepFace_1: typeof TopoDSToStep_MakeStepFace_1;
  TopoDSToStep_MakeStepFace_2: typeof TopoDSToStep_MakeStepFace_2;
  TopoDSToStep_FacetedTool: typeof TopoDSToStep_FacetedTool;
  TopoDSToStep_BuilderError: TopoDSToStep_BuilderError;
  TopoDSToStep_MakeFaceError: TopoDSToStep_MakeFaceError;
  TopoDSToStep_MakeVertexError: TopoDSToStep_MakeVertexError;
  TopoDSToStep_MakeShellBasedSurfaceModel: typeof TopoDSToStep_MakeShellBasedSurfaceModel;
  TopoDSToStep_MakeShellBasedSurfaceModel_1: typeof TopoDSToStep_MakeShellBasedSurfaceModel_1;
  TopoDSToStep_MakeShellBasedSurfaceModel_2: typeof TopoDSToStep_MakeShellBasedSurfaceModel_2;
  TopoDSToStep_MakeShellBasedSurfaceModel_3: typeof TopoDSToStep_MakeShellBasedSurfaceModel_3;
  TopoDSToStep_MakeStepWire: typeof TopoDSToStep_MakeStepWire;
  TopoDSToStep_MakeStepWire_1: typeof TopoDSToStep_MakeStepWire_1;
  TopoDSToStep_MakeStepWire_2: typeof TopoDSToStep_MakeStepWire_2;
  TopoDSToStep_MakeBrepWithVoids: typeof TopoDSToStep_MakeBrepWithVoids;
  TopoDSToStep: typeof TopoDSToStep;
  TopoDSToStep_Tool: typeof TopoDSToStep_Tool;
  TopoDSToStep_Tool_1: typeof TopoDSToStep_Tool_1;
  TopoDSToStep_Tool_2: typeof TopoDSToStep_Tool_2;
  TopoDSToStep_Root: typeof TopoDSToStep_Root;
  TopoDSToStep_MakeWireError: TopoDSToStep_MakeWireError;
  TopoDSToStep_MakeGeometricCurveSet: typeof TopoDSToStep_MakeGeometricCurveSet;
  TopoDSToStep_MakeStepEdge: typeof TopoDSToStep_MakeStepEdge;
  TopoDSToStep_MakeStepEdge_1: typeof TopoDSToStep_MakeStepEdge_1;
  TopoDSToStep_MakeStepEdge_2: typeof TopoDSToStep_MakeStepEdge_2;
  TopoDSToStep_MakeManifoldSolidBrep: typeof TopoDSToStep_MakeManifoldSolidBrep;
  TopoDSToStep_MakeManifoldSolidBrep_1: typeof TopoDSToStep_MakeManifoldSolidBrep_1;
  TopoDSToStep_MakeManifoldSolidBrep_2: typeof TopoDSToStep_MakeManifoldSolidBrep_2;
  TopoDSToStep_MakeFacetedBrepAndBrepWithVoids: typeof TopoDSToStep_MakeFacetedBrepAndBrepWithVoids;
  TopoDSToStep_FacetedError: TopoDSToStep_FacetedError;
  TopoDSToStep_Builder: typeof TopoDSToStep_Builder;
  TopoDSToStep_Builder_1: typeof TopoDSToStep_Builder_1;
  TopoDSToStep_Builder_2: typeof TopoDSToStep_Builder_2;
  TopoDSToStep_MakeEdgeError: TopoDSToStep_MakeEdgeError;
  TopoDSToStep_WireframeBuilder: typeof TopoDSToStep_WireframeBuilder;
  TopoDSToStep_WireframeBuilder_1: typeof TopoDSToStep_WireframeBuilder_1;
  TopoDSToStep_WireframeBuilder_2: typeof TopoDSToStep_WireframeBuilder_2;
  TopoDSToStep_MakeStepVertex: typeof TopoDSToStep_MakeStepVertex;
  TopoDSToStep_MakeStepVertex_1: typeof TopoDSToStep_MakeStepVertex_1;
  TopoDSToStep_MakeStepVertex_2: typeof TopoDSToStep_MakeStepVertex_2;
  RWStepFEA_RWFeaAxis2Placement3d: typeof RWStepFEA_RWFeaAxis2Placement3d;
  RWStepFEA_RWParametricSurface3dElementCoordinateSystem: typeof RWStepFEA_RWParametricSurface3dElementCoordinateSystem;
  RWStepFEA_RWFeaMaterialPropertyRepresentation: typeof RWStepFEA_RWFeaMaterialPropertyRepresentation;
  RWStepFEA_RWFeaShellShearStiffness: typeof RWStepFEA_RWFeaShellShearStiffness;
  RWStepFEA_RWCurveElementEndRelease: typeof RWStepFEA_RWCurveElementEndRelease;
  RWStepFEA_RWParametricCurve3dElementCoordinateSystem: typeof RWStepFEA_RWParametricCurve3dElementCoordinateSystem;
  RWStepFEA_RWCurveElementLocation: typeof RWStepFEA_RWCurveElementLocation;
  RWStepFEA_RWElementRepresentation: typeof RWStepFEA_RWElementRepresentation;
  RWStepFEA_RWFeaShellMembraneStiffness: typeof RWStepFEA_RWFeaShellMembraneStiffness;
  RWStepFEA_RWCurveElementIntervalLinearlyVarying: typeof RWStepFEA_RWCurveElementIntervalLinearlyVarying;
  RWStepFEA_RWFeaSecantCoefficientOfLinearThermalExpansion: typeof RWStepFEA_RWFeaSecantCoefficientOfLinearThermalExpansion;
  RWStepFEA_RWFeaMaterialPropertyRepresentationItem: typeof RWStepFEA_RWFeaMaterialPropertyRepresentationItem;
  RWStepFEA_RWCurve3dElementRepresentation: typeof RWStepFEA_RWCurve3dElementRepresentation;
  RWStepFEA_RWAlignedSurface3dElementCoordinateSystem: typeof RWStepFEA_RWAlignedSurface3dElementCoordinateSystem;
  RWStepFEA_RWNodeWithVector: typeof RWStepFEA_RWNodeWithVector;
  RWStepFEA_RWFeaTangentialCoefficientOfLinearThermalExpansion: typeof RWStepFEA_RWFeaTangentialCoefficientOfLinearThermalExpansion;
  RWStepFEA_RWElementGeometricRelationship: typeof RWStepFEA_RWElementGeometricRelationship;
  RWStepFEA_RWSurface3dElementRepresentation: typeof RWStepFEA_RWSurface3dElementRepresentation;
  RWStepFEA_RWCurve3dElementProperty: typeof RWStepFEA_RWCurve3dElementProperty;
  RWStepFEA_RWNodeRepresentation: typeof RWStepFEA_RWNodeRepresentation;
  RWStepFEA_RWNodeSet: typeof RWStepFEA_RWNodeSet;
  RWStepFEA_RWFeaParametricPoint: typeof RWStepFEA_RWFeaParametricPoint;
  RWStepFEA_RWFeaGroup: typeof RWStepFEA_RWFeaGroup;
  RWStepFEA_RWArbitraryVolume3dElementCoordinateSystem: typeof RWStepFEA_RWArbitraryVolume3dElementCoordinateSystem;
  RWStepFEA_RWParametricCurve3dElementCoordinateDirection: typeof RWStepFEA_RWParametricCurve3dElementCoordinateDirection;
  RWStepFEA_RWVolume3dElementRepresentation: typeof RWStepFEA_RWVolume3dElementRepresentation;
  RWStepFEA_RWDummyNode: typeof RWStepFEA_RWDummyNode;
  RWStepFEA_RWAlignedCurve3dElementCoordinateSystem: typeof RWStepFEA_RWAlignedCurve3dElementCoordinateSystem;
  RWStepFEA_RWFeaCurveSectionGeometricRelationship: typeof RWStepFEA_RWFeaCurveSectionGeometricRelationship;
  RWStepFEA_RWNodeWithSolutionCoordinateSystem: typeof RWStepFEA_RWNodeWithSolutionCoordinateSystem;
  RWStepFEA_RWNode: typeof RWStepFEA_RWNode;
  RWStepFEA_RWFeaModel3d: typeof RWStepFEA_RWFeaModel3d;
  RWStepFEA_RWCurveElementInterval: typeof RWStepFEA_RWCurveElementInterval;
  RWStepFEA_RWFeaShellMembraneBendingCouplingStiffness: typeof RWStepFEA_RWFeaShellMembraneBendingCouplingStiffness;
  RWStepFEA_RWFeaModelDefinition: typeof RWStepFEA_RWFeaModelDefinition;
  RWStepFEA_RWFeaSurfaceSectionGeometricRelationship: typeof RWStepFEA_RWFeaSurfaceSectionGeometricRelationship;
  RWStepFEA_RWFeaAreaDensity: typeof RWStepFEA_RWFeaAreaDensity;
  RWStepFEA_RWFeaMassDensity: typeof RWStepFEA_RWFeaMassDensity;
  RWStepFEA_RWGeometricNode: typeof RWStepFEA_RWGeometricNode;
  RWStepFEA_RWElementGroup: typeof RWStepFEA_RWElementGroup;
  RWStepFEA_RWFeaLinearElasticity: typeof RWStepFEA_RWFeaLinearElasticity;
  RWStepFEA_RWFreedomsList: typeof RWStepFEA_RWFreedomsList;
  RWStepFEA_RWNodeDefinition: typeof RWStepFEA_RWNodeDefinition;
  RWStepFEA_RWCurveElementEndOffset: typeof RWStepFEA_RWCurveElementEndOffset;
  RWStepFEA_RWFeaMoistureAbsorption: typeof RWStepFEA_RWFeaMoistureAbsorption;
  RWStepFEA_RWFreedomAndCoefficient: typeof RWStepFEA_RWFreedomAndCoefficient;
  RWStepFEA_RWFeaShellBendingStiffness: typeof RWStepFEA_RWFeaShellBendingStiffness;
  RWStepFEA_RWFeaModel: typeof RWStepFEA_RWFeaModel;
  RWStepFEA_RWNodeGroup: typeof RWStepFEA_RWNodeGroup;
  RWStepFEA_RWCurveElementIntervalConstant: typeof RWStepFEA_RWCurveElementIntervalConstant;
  RWStepFEA_RWConstantSurface3dElementCoordinateSystem: typeof RWStepFEA_RWConstantSurface3dElementCoordinateSystem;
  RWStepFEA_RWFeaRepresentationItem: typeof RWStepFEA_RWFeaRepresentationItem;
  Handle_Law_S: typeof Handle_Law_S;
  Handle_Law_S_1: typeof Handle_Law_S_1;
  Handle_Law_S_2: typeof Handle_Law_S_2;
  Handle_Law_S_3: typeof Handle_Law_S_3;
  Handle_Law_S_4: typeof Handle_Law_S_4;
  Law_S: typeof Law_S;
  Handle_Law_Function: typeof Handle_Law_Function;
  Handle_Law_Function_1: typeof Handle_Law_Function_1;
  Handle_Law_Function_2: typeof Handle_Law_Function_2;
  Handle_Law_Function_3: typeof Handle_Law_Function_3;
  Handle_Law_Function_4: typeof Handle_Law_Function_4;
  Law_Function: typeof Law_Function;
  Law: typeof Law;
  Handle_Law_BSpline: typeof Handle_Law_BSpline;
  Handle_Law_BSpline_1: typeof Handle_Law_BSpline_1;
  Handle_Law_BSpline_2: typeof Handle_Law_BSpline_2;
  Handle_Law_BSpline_3: typeof Handle_Law_BSpline_3;
  Handle_Law_BSpline_4: typeof Handle_Law_BSpline_4;
  Law_BSpline: typeof Law_BSpline;
  Law_BSpline_1: typeof Law_BSpline_1;
  Law_BSpline_2: typeof Law_BSpline_2;
  Law_Interpol: typeof Law_Interpol;
  Handle_Law_Interpol: typeof Handle_Law_Interpol;
  Handle_Law_Interpol_1: typeof Handle_Law_Interpol_1;
  Handle_Law_Interpol_2: typeof Handle_Law_Interpol_2;
  Handle_Law_Interpol_3: typeof Handle_Law_Interpol_3;
  Handle_Law_Interpol_4: typeof Handle_Law_Interpol_4;
  Law_BSplineKnotSplitting: typeof Law_BSplineKnotSplitting;
  Law_Linear: typeof Law_Linear;
  Handle_Law_Linear: typeof Handle_Law_Linear;
  Handle_Law_Linear_1: typeof Handle_Law_Linear_1;
  Handle_Law_Linear_2: typeof Handle_Law_Linear_2;
  Handle_Law_Linear_3: typeof Handle_Law_Linear_3;
  Handle_Law_Linear_4: typeof Handle_Law_Linear_4;
  Law_BSpFunc: typeof Law_BSpFunc;
  Law_BSpFunc_1: typeof Law_BSpFunc_1;
  Law_BSpFunc_2: typeof Law_BSpFunc_2;
  Handle_Law_BSpFunc: typeof Handle_Law_BSpFunc;
  Handle_Law_BSpFunc_1: typeof Handle_Law_BSpFunc_1;
  Handle_Law_BSpFunc_2: typeof Handle_Law_BSpFunc_2;
  Handle_Law_BSpFunc_3: typeof Handle_Law_BSpFunc_3;
  Handle_Law_BSpFunc_4: typeof Handle_Law_BSpFunc_4;
  Law_Constant: typeof Law_Constant;
  Handle_Law_Constant: typeof Handle_Law_Constant;
  Handle_Law_Constant_1: typeof Handle_Law_Constant_1;
  Handle_Law_Constant_2: typeof Handle_Law_Constant_2;
  Handle_Law_Constant_3: typeof Handle_Law_Constant_3;
  Handle_Law_Constant_4: typeof Handle_Law_Constant_4;
  Handle_Law_Composite: typeof Handle_Law_Composite;
  Handle_Law_Composite_1: typeof Handle_Law_Composite_1;
  Handle_Law_Composite_2: typeof Handle_Law_Composite_2;
  Handle_Law_Composite_3: typeof Handle_Law_Composite_3;
  Handle_Law_Composite_4: typeof Handle_Law_Composite_4;
  Law_Composite: typeof Law_Composite;
  Law_Composite_1: typeof Law_Composite_1;
  Law_Composite_2: typeof Law_Composite_2;
  IntCurvesFace_Intersector: typeof IntCurvesFace_Intersector;
  IntCurvesFace_ShapeIntersector: typeof IntCurvesFace_ShapeIntersector;
  Handle_IGESSelect_DispPerSingleView: typeof Handle_IGESSelect_DispPerSingleView;
  Handle_IGESSelect_DispPerSingleView_1: typeof Handle_IGESSelect_DispPerSingleView_1;
  Handle_IGESSelect_DispPerSingleView_2: typeof Handle_IGESSelect_DispPerSingleView_2;
  Handle_IGESSelect_DispPerSingleView_3: typeof Handle_IGESSelect_DispPerSingleView_3;
  Handle_IGESSelect_DispPerSingleView_4: typeof Handle_IGESSelect_DispPerSingleView_4;
  IGESSelect_DispPerSingleView: typeof IGESSelect_DispPerSingleView;
  IGESSelect_Activator: typeof IGESSelect_Activator;
  Handle_IGESSelect_Activator: typeof Handle_IGESSelect_Activator;
  Handle_IGESSelect_Activator_1: typeof Handle_IGESSelect_Activator_1;
  Handle_IGESSelect_Activator_2: typeof Handle_IGESSelect_Activator_2;
  Handle_IGESSelect_Activator_3: typeof Handle_IGESSelect_Activator_3;
  Handle_IGESSelect_Activator_4: typeof Handle_IGESSelect_Activator_4;
  Handle_IGESSelect_SelectSingleViewFrom: typeof Handle_IGESSelect_SelectSingleViewFrom;
  Handle_IGESSelect_SelectSingleViewFrom_1: typeof Handle_IGESSelect_SelectSingleViewFrom_1;
  Handle_IGESSelect_SelectSingleViewFrom_2: typeof Handle_IGESSelect_SelectSingleViewFrom_2;
  Handle_IGESSelect_SelectSingleViewFrom_3: typeof Handle_IGESSelect_SelectSingleViewFrom_3;
  Handle_IGESSelect_SelectSingleViewFrom_4: typeof Handle_IGESSelect_SelectSingleViewFrom_4;
  IGESSelect_SelectSingleViewFrom: typeof IGESSelect_SelectSingleViewFrom;
  Handle_IGESSelect_SelectBypassGroup: typeof Handle_IGESSelect_SelectBypassGroup;
  Handle_IGESSelect_SelectBypassGroup_1: typeof Handle_IGESSelect_SelectBypassGroup_1;
  Handle_IGESSelect_SelectBypassGroup_2: typeof Handle_IGESSelect_SelectBypassGroup_2;
  Handle_IGESSelect_SelectBypassGroup_3: typeof Handle_IGESSelect_SelectBypassGroup_3;
  Handle_IGESSelect_SelectBypassGroup_4: typeof Handle_IGESSelect_SelectBypassGroup_4;
  IGESSelect_SelectBypassGroup: typeof IGESSelect_SelectBypassGroup;
  Handle_IGESSelect_AddFileComment: typeof Handle_IGESSelect_AddFileComment;
  Handle_IGESSelect_AddFileComment_1: typeof Handle_IGESSelect_AddFileComment_1;
  Handle_IGESSelect_AddFileComment_2: typeof Handle_IGESSelect_AddFileComment_2;
  Handle_IGESSelect_AddFileComment_3: typeof Handle_IGESSelect_AddFileComment_3;
  Handle_IGESSelect_AddFileComment_4: typeof Handle_IGESSelect_AddFileComment_4;
  IGESSelect_AddFileComment: typeof IGESSelect_AddFileComment;
  IGESSelect_DispPerDrawing: typeof IGESSelect_DispPerDrawing;
  Handle_IGESSelect_DispPerDrawing: typeof Handle_IGESSelect_DispPerDrawing;
  Handle_IGESSelect_DispPerDrawing_1: typeof Handle_IGESSelect_DispPerDrawing_1;
  Handle_IGESSelect_DispPerDrawing_2: typeof Handle_IGESSelect_DispPerDrawing_2;
  Handle_IGESSelect_DispPerDrawing_3: typeof Handle_IGESSelect_DispPerDrawing_3;
  Handle_IGESSelect_DispPerDrawing_4: typeof Handle_IGESSelect_DispPerDrawing_4;
  IGESSelect_IGESTypeForm: typeof IGESSelect_IGESTypeForm;
  Handle_IGESSelect_IGESTypeForm: typeof Handle_IGESSelect_IGESTypeForm;
  Handle_IGESSelect_IGESTypeForm_1: typeof Handle_IGESSelect_IGESTypeForm_1;
  Handle_IGESSelect_IGESTypeForm_2: typeof Handle_IGESSelect_IGESTypeForm_2;
  Handle_IGESSelect_IGESTypeForm_3: typeof Handle_IGESSelect_IGESTypeForm_3;
  Handle_IGESSelect_IGESTypeForm_4: typeof Handle_IGESSelect_IGESTypeForm_4;
  IGESSelect_SelectDrawingFrom: typeof IGESSelect_SelectDrawingFrom;
  Handle_IGESSelect_SelectDrawingFrom: typeof Handle_IGESSelect_SelectDrawingFrom;
  Handle_IGESSelect_SelectDrawingFrom_1: typeof Handle_IGESSelect_SelectDrawingFrom_1;
  Handle_IGESSelect_SelectDrawingFrom_2: typeof Handle_IGESSelect_SelectDrawingFrom_2;
  Handle_IGESSelect_SelectDrawingFrom_3: typeof Handle_IGESSelect_SelectDrawingFrom_3;
  Handle_IGESSelect_SelectDrawingFrom_4: typeof Handle_IGESSelect_SelectDrawingFrom_4;
  IGESSelect_SelectBypassSubfigure: typeof IGESSelect_SelectBypassSubfigure;
  Handle_IGESSelect_SelectBypassSubfigure: typeof Handle_IGESSelect_SelectBypassSubfigure;
  Handle_IGESSelect_SelectBypassSubfigure_1: typeof Handle_IGESSelect_SelectBypassSubfigure_1;
  Handle_IGESSelect_SelectBypassSubfigure_2: typeof Handle_IGESSelect_SelectBypassSubfigure_2;
  Handle_IGESSelect_SelectBypassSubfigure_3: typeof Handle_IGESSelect_SelectBypassSubfigure_3;
  Handle_IGESSelect_SelectBypassSubfigure_4: typeof Handle_IGESSelect_SelectBypassSubfigure_4;
  Handle_IGESSelect_UpdateLastChange: typeof Handle_IGESSelect_UpdateLastChange;
  Handle_IGESSelect_UpdateLastChange_1: typeof Handle_IGESSelect_UpdateLastChange_1;
  Handle_IGESSelect_UpdateLastChange_2: typeof Handle_IGESSelect_UpdateLastChange_2;
  Handle_IGESSelect_UpdateLastChange_3: typeof Handle_IGESSelect_UpdateLastChange_3;
  Handle_IGESSelect_UpdateLastChange_4: typeof Handle_IGESSelect_UpdateLastChange_4;
  IGESSelect_UpdateLastChange: typeof IGESSelect_UpdateLastChange;
  Handle_IGESSelect_SelectName: typeof Handle_IGESSelect_SelectName;
  Handle_IGESSelect_SelectName_1: typeof Handle_IGESSelect_SelectName_1;
  Handle_IGESSelect_SelectName_2: typeof Handle_IGESSelect_SelectName_2;
  Handle_IGESSelect_SelectName_3: typeof Handle_IGESSelect_SelectName_3;
  Handle_IGESSelect_SelectName_4: typeof Handle_IGESSelect_SelectName_4;
  IGESSelect_SelectName: typeof IGESSelect_SelectName;
  Handle_IGESSelect_SelectBasicGeom: typeof Handle_IGESSelect_SelectBasicGeom;
  Handle_IGESSelect_SelectBasicGeom_1: typeof Handle_IGESSelect_SelectBasicGeom_1;
  Handle_IGESSelect_SelectBasicGeom_2: typeof Handle_IGESSelect_SelectBasicGeom_2;
  Handle_IGESSelect_SelectBasicGeom_3: typeof Handle_IGESSelect_SelectBasicGeom_3;
  Handle_IGESSelect_SelectBasicGeom_4: typeof Handle_IGESSelect_SelectBasicGeom_4;
  Handle_IGESSelect_SelectVisibleStatus: typeof Handle_IGESSelect_SelectVisibleStatus;
  Handle_IGESSelect_SelectVisibleStatus_1: typeof Handle_IGESSelect_SelectVisibleStatus_1;
  Handle_IGESSelect_SelectVisibleStatus_2: typeof Handle_IGESSelect_SelectVisibleStatus_2;
  Handle_IGESSelect_SelectVisibleStatus_3: typeof Handle_IGESSelect_SelectVisibleStatus_3;
  Handle_IGESSelect_SelectVisibleStatus_4: typeof Handle_IGESSelect_SelectVisibleStatus_4;
  IGESSelect_SelectVisibleStatus: typeof IGESSelect_SelectVisibleStatus;
  Handle_IGESSelect_ChangeLevelNumber: typeof Handle_IGESSelect_ChangeLevelNumber;
  Handle_IGESSelect_ChangeLevelNumber_1: typeof Handle_IGESSelect_ChangeLevelNumber_1;
  Handle_IGESSelect_ChangeLevelNumber_2: typeof Handle_IGESSelect_ChangeLevelNumber_2;
  Handle_IGESSelect_ChangeLevelNumber_3: typeof Handle_IGESSelect_ChangeLevelNumber_3;
  Handle_IGESSelect_ChangeLevelNumber_4: typeof Handle_IGESSelect_ChangeLevelNumber_4;
  IGESSelect_ChangeLevelNumber: typeof IGESSelect_ChangeLevelNumber;
  Handle_IGESSelect_SelectFromSingleView: typeof Handle_IGESSelect_SelectFromSingleView;
  Handle_IGESSelect_SelectFromSingleView_1: typeof Handle_IGESSelect_SelectFromSingleView_1;
  Handle_IGESSelect_SelectFromSingleView_2: typeof Handle_IGESSelect_SelectFromSingleView_2;
  Handle_IGESSelect_SelectFromSingleView_3: typeof Handle_IGESSelect_SelectFromSingleView_3;
  Handle_IGESSelect_SelectFromSingleView_4: typeof Handle_IGESSelect_SelectFromSingleView_4;
  IGESSelect_SelectFromSingleView: typeof IGESSelect_SelectFromSingleView;
  IGESSelect_SelectFromDrawing: typeof IGESSelect_SelectFromDrawing;
  Handle_IGESSelect_SelectFromDrawing: typeof Handle_IGESSelect_SelectFromDrawing;
  Handle_IGESSelect_SelectFromDrawing_1: typeof Handle_IGESSelect_SelectFromDrawing_1;
  Handle_IGESSelect_SelectFromDrawing_2: typeof Handle_IGESSelect_SelectFromDrawing_2;
  Handle_IGESSelect_SelectFromDrawing_3: typeof Handle_IGESSelect_SelectFromDrawing_3;
  Handle_IGESSelect_SelectFromDrawing_4: typeof Handle_IGESSelect_SelectFromDrawing_4;
  Handle_IGESSelect_RemoveCurves: typeof Handle_IGESSelect_RemoveCurves;
  Handle_IGESSelect_RemoveCurves_1: typeof Handle_IGESSelect_RemoveCurves_1;
  Handle_IGESSelect_RemoveCurves_2: typeof Handle_IGESSelect_RemoveCurves_2;
  Handle_IGESSelect_RemoveCurves_3: typeof Handle_IGESSelect_RemoveCurves_3;
  Handle_IGESSelect_RemoveCurves_4: typeof Handle_IGESSelect_RemoveCurves_4;
  IGESSelect_RemoveCurves: typeof IGESSelect_RemoveCurves;
  IGESSelect_ModelModifier: typeof IGESSelect_ModelModifier;
  Handle_IGESSelect_ModelModifier: typeof Handle_IGESSelect_ModelModifier;
  Handle_IGESSelect_ModelModifier_1: typeof Handle_IGESSelect_ModelModifier_1;
  Handle_IGESSelect_ModelModifier_2: typeof Handle_IGESSelect_ModelModifier_2;
  Handle_IGESSelect_ModelModifier_3: typeof Handle_IGESSelect_ModelModifier_3;
  Handle_IGESSelect_ModelModifier_4: typeof Handle_IGESSelect_ModelModifier_4;
  Handle_IGESSelect_SetLabel: typeof Handle_IGESSelect_SetLabel;
  Handle_IGESSelect_SetLabel_1: typeof Handle_IGESSelect_SetLabel_1;
  Handle_IGESSelect_SetLabel_2: typeof Handle_IGESSelect_SetLabel_2;
  Handle_IGESSelect_SetLabel_3: typeof Handle_IGESSelect_SetLabel_3;
  Handle_IGESSelect_SetLabel_4: typeof Handle_IGESSelect_SetLabel_4;
  IGESSelect_SetLabel: typeof IGESSelect_SetLabel;
  Handle_IGESSelect_SplineToBSpline: typeof Handle_IGESSelect_SplineToBSpline;
  Handle_IGESSelect_SplineToBSpline_1: typeof Handle_IGESSelect_SplineToBSpline_1;
  Handle_IGESSelect_SplineToBSpline_2: typeof Handle_IGESSelect_SplineToBSpline_2;
  Handle_IGESSelect_SplineToBSpline_3: typeof Handle_IGESSelect_SplineToBSpline_3;
  Handle_IGESSelect_SplineToBSpline_4: typeof Handle_IGESSelect_SplineToBSpline_4;
  IGESSelect_SplineToBSpline: typeof IGESSelect_SplineToBSpline;
  IGESSelect_SignColor: typeof IGESSelect_SignColor;
  Handle_IGESSelect_SignColor: typeof Handle_IGESSelect_SignColor;
  Handle_IGESSelect_SignColor_1: typeof Handle_IGESSelect_SignColor_1;
  Handle_IGESSelect_SignColor_2: typeof Handle_IGESSelect_SignColor_2;
  Handle_IGESSelect_SignColor_3: typeof Handle_IGESSelect_SignColor_3;
  Handle_IGESSelect_SignColor_4: typeof Handle_IGESSelect_SignColor_4;
  Handle_IGESSelect_ViewSorter: typeof Handle_IGESSelect_ViewSorter;
  Handle_IGESSelect_ViewSorter_1: typeof Handle_IGESSelect_ViewSorter_1;
  Handle_IGESSelect_ViewSorter_2: typeof Handle_IGESSelect_ViewSorter_2;
  Handle_IGESSelect_ViewSorter_3: typeof Handle_IGESSelect_ViewSorter_3;
  Handle_IGESSelect_ViewSorter_4: typeof Handle_IGESSelect_ViewSorter_4;
  IGESSelect_ViewSorter: typeof IGESSelect_ViewSorter;
  Handle_IGESSelect_RebuildGroups: typeof Handle_IGESSelect_RebuildGroups;
  Handle_IGESSelect_RebuildGroups_1: typeof Handle_IGESSelect_RebuildGroups_1;
  Handle_IGESSelect_RebuildGroups_2: typeof Handle_IGESSelect_RebuildGroups_2;
  Handle_IGESSelect_RebuildGroups_3: typeof Handle_IGESSelect_RebuildGroups_3;
  Handle_IGESSelect_RebuildGroups_4: typeof Handle_IGESSelect_RebuildGroups_4;
  IGESSelect_RebuildGroups: typeof IGESSelect_RebuildGroups;
  Handle_IGESSelect_SelectFaces: typeof Handle_IGESSelect_SelectFaces;
  Handle_IGESSelect_SelectFaces_1: typeof Handle_IGESSelect_SelectFaces_1;
  Handle_IGESSelect_SelectFaces_2: typeof Handle_IGESSelect_SelectFaces_2;
  Handle_IGESSelect_SelectFaces_3: typeof Handle_IGESSelect_SelectFaces_3;
  Handle_IGESSelect_SelectFaces_4: typeof Handle_IGESSelect_SelectFaces_4;
  IGESSelect_SelectFaces: typeof IGESSelect_SelectFaces;
  Handle_IGESSelect_Dumper: typeof Handle_IGESSelect_Dumper;
  Handle_IGESSelect_Dumper_1: typeof Handle_IGESSelect_Dumper_1;
  Handle_IGESSelect_Dumper_2: typeof Handle_IGESSelect_Dumper_2;
  Handle_IGESSelect_Dumper_3: typeof Handle_IGESSelect_Dumper_3;
  Handle_IGESSelect_Dumper_4: typeof Handle_IGESSelect_Dumper_4;
  IGESSelect_Dumper: typeof IGESSelect_Dumper;
  IGESSelect_UpdateFileName: typeof IGESSelect_UpdateFileName;
  Handle_IGESSelect_UpdateFileName: typeof Handle_IGESSelect_UpdateFileName;
  Handle_IGESSelect_UpdateFileName_1: typeof Handle_IGESSelect_UpdateFileName_1;
  Handle_IGESSelect_UpdateFileName_2: typeof Handle_IGESSelect_UpdateFileName_2;
  Handle_IGESSelect_UpdateFileName_3: typeof Handle_IGESSelect_UpdateFileName_3;
  Handle_IGESSelect_UpdateFileName_4: typeof Handle_IGESSelect_UpdateFileName_4;
  Handle_IGESSelect_WorkLibrary: typeof Handle_IGESSelect_WorkLibrary;
  Handle_IGESSelect_WorkLibrary_1: typeof Handle_IGESSelect_WorkLibrary_1;
  Handle_IGESSelect_WorkLibrary_2: typeof Handle_IGESSelect_WorkLibrary_2;
  Handle_IGESSelect_WorkLibrary_3: typeof Handle_IGESSelect_WorkLibrary_3;
  Handle_IGESSelect_WorkLibrary_4: typeof Handle_IGESSelect_WorkLibrary_4;
  IGESSelect_WorkLibrary: typeof IGESSelect_WorkLibrary;
  IGESSelect_SetGlobalParameter: typeof IGESSelect_SetGlobalParameter;
  Handle_IGESSelect_SetGlobalParameter: typeof Handle_IGESSelect_SetGlobalParameter;
  Handle_IGESSelect_SetGlobalParameter_1: typeof Handle_IGESSelect_SetGlobalParameter_1;
  Handle_IGESSelect_SetGlobalParameter_2: typeof Handle_IGESSelect_SetGlobalParameter_2;
  Handle_IGESSelect_SetGlobalParameter_3: typeof Handle_IGESSelect_SetGlobalParameter_3;
  Handle_IGESSelect_SetGlobalParameter_4: typeof Handle_IGESSelect_SetGlobalParameter_4;
  Handle_IGESSelect_AddGroup: typeof Handle_IGESSelect_AddGroup;
  Handle_IGESSelect_AddGroup_1: typeof Handle_IGESSelect_AddGroup_1;
  Handle_IGESSelect_AddGroup_2: typeof Handle_IGESSelect_AddGroup_2;
  Handle_IGESSelect_AddGroup_3: typeof Handle_IGESSelect_AddGroup_3;
  Handle_IGESSelect_AddGroup_4: typeof Handle_IGESSelect_AddGroup_4;
  IGESSelect_AddGroup: typeof IGESSelect_AddGroup;
  Handle_IGESSelect_CounterOfLevelNumber: typeof Handle_IGESSelect_CounterOfLevelNumber;
  Handle_IGESSelect_CounterOfLevelNumber_1: typeof Handle_IGESSelect_CounterOfLevelNumber_1;
  Handle_IGESSelect_CounterOfLevelNumber_2: typeof Handle_IGESSelect_CounterOfLevelNumber_2;
  Handle_IGESSelect_CounterOfLevelNumber_3: typeof Handle_IGESSelect_CounterOfLevelNumber_3;
  Handle_IGESSelect_CounterOfLevelNumber_4: typeof Handle_IGESSelect_CounterOfLevelNumber_4;
  IGESSelect_CounterOfLevelNumber: typeof IGESSelect_CounterOfLevelNumber;
  Handle_IGESSelect_AutoCorrect: typeof Handle_IGESSelect_AutoCorrect;
  Handle_IGESSelect_AutoCorrect_1: typeof Handle_IGESSelect_AutoCorrect_1;
  Handle_IGESSelect_AutoCorrect_2: typeof Handle_IGESSelect_AutoCorrect_2;
  Handle_IGESSelect_AutoCorrect_3: typeof Handle_IGESSelect_AutoCorrect_3;
  Handle_IGESSelect_AutoCorrect_4: typeof Handle_IGESSelect_AutoCorrect_4;
  IGESSelect_AutoCorrect: typeof IGESSelect_AutoCorrect;
  IGESSelect_FloatFormat: typeof IGESSelect_FloatFormat;
  Handle_IGESSelect_FloatFormat: typeof Handle_IGESSelect_FloatFormat;
  Handle_IGESSelect_FloatFormat_1: typeof Handle_IGESSelect_FloatFormat_1;
  Handle_IGESSelect_FloatFormat_2: typeof Handle_IGESSelect_FloatFormat_2;
  Handle_IGESSelect_FloatFormat_3: typeof Handle_IGESSelect_FloatFormat_3;
  Handle_IGESSelect_FloatFormat_4: typeof Handle_IGESSelect_FloatFormat_4;
  Handle_IGESSelect_ComputeStatus: typeof Handle_IGESSelect_ComputeStatus;
  Handle_IGESSelect_ComputeStatus_1: typeof Handle_IGESSelect_ComputeStatus_1;
  Handle_IGESSelect_ComputeStatus_2: typeof Handle_IGESSelect_ComputeStatus_2;
  Handle_IGESSelect_ComputeStatus_3: typeof Handle_IGESSelect_ComputeStatus_3;
  Handle_IGESSelect_ComputeStatus_4: typeof Handle_IGESSelect_ComputeStatus_4;
  IGESSelect_ComputeStatus: typeof IGESSelect_ComputeStatus;
  IGESSelect_IGESName: typeof IGESSelect_IGESName;
  Handle_IGESSelect_IGESName: typeof Handle_IGESSelect_IGESName;
  Handle_IGESSelect_IGESName_1: typeof Handle_IGESSelect_IGESName_1;
  Handle_IGESSelect_IGESName_2: typeof Handle_IGESSelect_IGESName_2;
  Handle_IGESSelect_IGESName_3: typeof Handle_IGESSelect_IGESName_3;
  Handle_IGESSelect_IGESName_4: typeof Handle_IGESSelect_IGESName_4;
  IGESSelect: typeof IGESSelect;
  IGESSelect_SetVersion5: typeof IGESSelect_SetVersion5;
  Handle_IGESSelect_SetVersion5: typeof Handle_IGESSelect_SetVersion5;
  Handle_IGESSelect_SetVersion5_1: typeof Handle_IGESSelect_SetVersion5_1;
  Handle_IGESSelect_SetVersion5_2: typeof Handle_IGESSelect_SetVersion5_2;
  Handle_IGESSelect_SetVersion5_3: typeof Handle_IGESSelect_SetVersion5_3;
  Handle_IGESSelect_SetVersion5_4: typeof Handle_IGESSelect_SetVersion5_4;
  Handle_IGESSelect_UpdateCreationDate: typeof Handle_IGESSelect_UpdateCreationDate;
  Handle_IGESSelect_UpdateCreationDate_1: typeof Handle_IGESSelect_UpdateCreationDate_1;
  Handle_IGESSelect_UpdateCreationDate_2: typeof Handle_IGESSelect_UpdateCreationDate_2;
  Handle_IGESSelect_UpdateCreationDate_3: typeof Handle_IGESSelect_UpdateCreationDate_3;
  Handle_IGESSelect_UpdateCreationDate_4: typeof Handle_IGESSelect_UpdateCreationDate_4;
  IGESSelect_UpdateCreationDate: typeof IGESSelect_UpdateCreationDate;
  Handle_IGESSelect_SignStatus: typeof Handle_IGESSelect_SignStatus;
  Handle_IGESSelect_SignStatus_1: typeof Handle_IGESSelect_SignStatus_1;
  Handle_IGESSelect_SignStatus_2: typeof Handle_IGESSelect_SignStatus_2;
  Handle_IGESSelect_SignStatus_3: typeof Handle_IGESSelect_SignStatus_3;
  Handle_IGESSelect_SignStatus_4: typeof Handle_IGESSelect_SignStatus_4;
  IGESSelect_SignStatus: typeof IGESSelect_SignStatus;
  IGESSelect_SignLevelNumber: typeof IGESSelect_SignLevelNumber;
  Handle_IGESSelect_SignLevelNumber: typeof Handle_IGESSelect_SignLevelNumber;
  Handle_IGESSelect_SignLevelNumber_1: typeof Handle_IGESSelect_SignLevelNumber_1;
  Handle_IGESSelect_SignLevelNumber_2: typeof Handle_IGESSelect_SignLevelNumber_2;
  Handle_IGESSelect_SignLevelNumber_3: typeof Handle_IGESSelect_SignLevelNumber_3;
  Handle_IGESSelect_SignLevelNumber_4: typeof Handle_IGESSelect_SignLevelNumber_4;
  IGESSelect_EditHeader: typeof IGESSelect_EditHeader;
  Handle_IGESSelect_EditHeader: typeof Handle_IGESSelect_EditHeader;
  Handle_IGESSelect_EditHeader_1: typeof Handle_IGESSelect_EditHeader_1;
  Handle_IGESSelect_EditHeader_2: typeof Handle_IGESSelect_EditHeader_2;
  Handle_IGESSelect_EditHeader_3: typeof Handle_IGESSelect_EditHeader_3;
  Handle_IGESSelect_EditHeader_4: typeof Handle_IGESSelect_EditHeader_4;
  IGESSelect_SelectLevelNumber: typeof IGESSelect_SelectLevelNumber;
  Handle_IGESSelect_SelectLevelNumber: typeof Handle_IGESSelect_SelectLevelNumber;
  Handle_IGESSelect_SelectLevelNumber_1: typeof Handle_IGESSelect_SelectLevelNumber_1;
  Handle_IGESSelect_SelectLevelNumber_2: typeof Handle_IGESSelect_SelectLevelNumber_2;
  Handle_IGESSelect_SelectLevelNumber_3: typeof Handle_IGESSelect_SelectLevelNumber_3;
  Handle_IGESSelect_SelectLevelNumber_4: typeof Handle_IGESSelect_SelectLevelNumber_4;
  IGESSelect_ChangeLevelList: typeof IGESSelect_ChangeLevelList;
  Handle_IGESSelect_ChangeLevelList: typeof Handle_IGESSelect_ChangeLevelList;
  Handle_IGESSelect_ChangeLevelList_1: typeof Handle_IGESSelect_ChangeLevelList_1;
  Handle_IGESSelect_ChangeLevelList_2: typeof Handle_IGESSelect_ChangeLevelList_2;
  Handle_IGESSelect_ChangeLevelList_3: typeof Handle_IGESSelect_ChangeLevelList_3;
  Handle_IGESSelect_ChangeLevelList_4: typeof Handle_IGESSelect_ChangeLevelList_4;
  IGESSelect_SelectPCurves: typeof IGESSelect_SelectPCurves;
  Handle_IGESSelect_SelectPCurves: typeof Handle_IGESSelect_SelectPCurves;
  Handle_IGESSelect_SelectPCurves_1: typeof Handle_IGESSelect_SelectPCurves_1;
  Handle_IGESSelect_SelectPCurves_2: typeof Handle_IGESSelect_SelectPCurves_2;
  Handle_IGESSelect_SelectPCurves_3: typeof Handle_IGESSelect_SelectPCurves_3;
  Handle_IGESSelect_SelectPCurves_4: typeof Handle_IGESSelect_SelectPCurves_4;
  Handle_IGESSelect_FileModifier: typeof Handle_IGESSelect_FileModifier;
  Handle_IGESSelect_FileModifier_1: typeof Handle_IGESSelect_FileModifier_1;
  Handle_IGESSelect_FileModifier_2: typeof Handle_IGESSelect_FileModifier_2;
  Handle_IGESSelect_FileModifier_3: typeof Handle_IGESSelect_FileModifier_3;
  Handle_IGESSelect_FileModifier_4: typeof Handle_IGESSelect_FileModifier_4;
  IGESSelect_FileModifier: typeof IGESSelect_FileModifier;
  Handle_IGESSelect_RebuildDrawings: typeof Handle_IGESSelect_RebuildDrawings;
  Handle_IGESSelect_RebuildDrawings_1: typeof Handle_IGESSelect_RebuildDrawings_1;
  Handle_IGESSelect_RebuildDrawings_2: typeof Handle_IGESSelect_RebuildDrawings_2;
  Handle_IGESSelect_RebuildDrawings_3: typeof Handle_IGESSelect_RebuildDrawings_3;
  Handle_IGESSelect_RebuildDrawings_4: typeof Handle_IGESSelect_RebuildDrawings_4;
  IGESSelect_RebuildDrawings: typeof IGESSelect_RebuildDrawings;
  Handle_IGESSelect_EditDirPart: typeof Handle_IGESSelect_EditDirPart;
  Handle_IGESSelect_EditDirPart_1: typeof Handle_IGESSelect_EditDirPart_1;
  Handle_IGESSelect_EditDirPart_2: typeof Handle_IGESSelect_EditDirPart_2;
  Handle_IGESSelect_EditDirPart_3: typeof Handle_IGESSelect_EditDirPart_3;
  Handle_IGESSelect_EditDirPart_4: typeof Handle_IGESSelect_EditDirPart_4;
  IGESSelect_EditDirPart: typeof IGESSelect_EditDirPart;
  IGESSelect_SelectSubordinate: typeof IGESSelect_SelectSubordinate;
  Handle_IGESSelect_SelectSubordinate: typeof Handle_IGESSelect_SelectSubordinate;
  Handle_IGESSelect_SelectSubordinate_1: typeof Handle_IGESSelect_SelectSubordinate_1;
  Handle_IGESSelect_SelectSubordinate_2: typeof Handle_IGESSelect_SelectSubordinate_2;
  Handle_IGESSelect_SelectSubordinate_3: typeof Handle_IGESSelect_SelectSubordinate_3;
  Handle_IGESSelect_SelectSubordinate_4: typeof Handle_IGESSelect_SelectSubordinate_4;
  IntCurve_PConic: typeof IntCurve_PConic;
  IntCurve_PConic_1: typeof IntCurve_PConic_1;
  IntCurve_PConic_2: typeof IntCurve_PConic_2;
  IntCurve_PConic_3: typeof IntCurve_PConic_3;
  IntCurve_PConic_4: typeof IntCurve_PConic_4;
  IntCurve_PConic_5: typeof IntCurve_PConic_5;
  IntCurve_PConic_6: typeof IntCurve_PConic_6;
  IntCurve_ProjectOnPConicTool: typeof IntCurve_ProjectOnPConicTool;
  IntCurve_IConicTool: typeof IntCurve_IConicTool;
  IntCurve_IConicTool_1: typeof IntCurve_IConicTool_1;
  IntCurve_IConicTool_2: typeof IntCurve_IConicTool_2;
  IntCurve_IConicTool_3: typeof IntCurve_IConicTool_3;
  IntCurve_IConicTool_4: typeof IntCurve_IConicTool_4;
  IntCurve_IConicTool_5: typeof IntCurve_IConicTool_5;
  IntCurve_IConicTool_6: typeof IntCurve_IConicTool_6;
  IntCurve_IConicTool_7: typeof IntCurve_IConicTool_7;
  IntCurve_IntConicConic: typeof IntCurve_IntConicConic;
  IntCurve_IntConicConic_1: typeof IntCurve_IntConicConic_1;
  IntCurve_IntConicConic_2: typeof IntCurve_IntConicConic_2;
  IntCurve_IntConicConic_3: typeof IntCurve_IntConicConic_3;
  IntCurve_IntConicConic_4: typeof IntCurve_IntConicConic_4;
  IntCurve_IntConicConic_5: typeof IntCurve_IntConicConic_5;
  IntCurve_IntConicConic_6: typeof IntCurve_IntConicConic_6;
  IntCurve_IntConicConic_7: typeof IntCurve_IntConicConic_7;
  IntCurve_IntConicConic_8: typeof IntCurve_IntConicConic_8;
  IntCurve_IntConicConic_9: typeof IntCurve_IntConicConic_9;
  IntCurve_IntConicConic_10: typeof IntCurve_IntConicConic_10;
  IntCurve_IntConicConic_11: typeof IntCurve_IntConicConic_11;
  IntCurve_IntConicConic_12: typeof IntCurve_IntConicConic_12;
  IntCurve_IntConicConic_13: typeof IntCurve_IntConicConic_13;
  IntCurve_IntConicConic_14: typeof IntCurve_IntConicConic_14;
  IntCurve_IntConicConic_15: typeof IntCurve_IntConicConic_15;
  IntCurve_IntConicConic_16: typeof IntCurve_IntConicConic_16;
  IntCurve_IntImpConicParConic: typeof IntCurve_IntImpConicParConic;
  IntCurve_IntImpConicParConic_1: typeof IntCurve_IntImpConicParConic_1;
  IntCurve_IntImpConicParConic_2: typeof IntCurve_IntImpConicParConic_2;
  PeriodicInterval: typeof PeriodicInterval;
  PeriodicInterval_1: typeof PeriodicInterval_1;
  PeriodicInterval_2: typeof PeriodicInterval_2;
  PeriodicInterval_3: typeof PeriodicInterval_3;
  Interval: typeof Interval;
  Interval_1: typeof Interval_1;
  Interval_2: typeof Interval_2;
  Interval_3: typeof Interval_3;
  Interval_4: typeof Interval_4;
  IntCurve_PConicTool: typeof IntCurve_PConicTool;
  IntCurve_MyImpParToolOfIntImpConicParConic: typeof IntCurve_MyImpParToolOfIntImpConicParConic;
  BRepPrim_Wedge: typeof BRepPrim_Wedge;
  BRepPrim_Wedge_1: typeof BRepPrim_Wedge_1;
  BRepPrim_Wedge_2: typeof BRepPrim_Wedge_2;
  BRepPrim_Wedge_3: typeof BRepPrim_Wedge_3;
  BRepPrim_Wedge_4: typeof BRepPrim_Wedge_4;
  BRepPrim_FaceBuilder: typeof BRepPrim_FaceBuilder;
  BRepPrim_FaceBuilder_1: typeof BRepPrim_FaceBuilder_1;
  BRepPrim_FaceBuilder_2: typeof BRepPrim_FaceBuilder_2;
  BRepPrim_FaceBuilder_3: typeof BRepPrim_FaceBuilder_3;
  BRepPrim_Sphere: typeof BRepPrim_Sphere;
  BRepPrim_Sphere_1: typeof BRepPrim_Sphere_1;
  BRepPrim_Sphere_2: typeof BRepPrim_Sphere_2;
  BRepPrim_Sphere_3: typeof BRepPrim_Sphere_3;
  BRepPrim_Direction: BRepPrim_Direction;
  BRepPrim_OneAxis: typeof BRepPrim_OneAxis;
  BRepPrim_Builder: typeof BRepPrim_Builder;
  BRepPrim_Builder_1: typeof BRepPrim_Builder_1;
  BRepPrim_Builder_2: typeof BRepPrim_Builder_2;
  BRepPrim_Revolution: typeof BRepPrim_Revolution;
  BRepPrim_Cone: typeof BRepPrim_Cone;
  BRepPrim_Cone_1: typeof BRepPrim_Cone_1;
  BRepPrim_Cone_2: typeof BRepPrim_Cone_2;
  BRepPrim_Cone_3: typeof BRepPrim_Cone_3;
  BRepPrim_Cone_4: typeof BRepPrim_Cone_4;
  BRepPrim_Cone_5: typeof BRepPrim_Cone_5;
  BRepPrim_Cone_6: typeof BRepPrim_Cone_6;
  BRepPrim_Cone_7: typeof BRepPrim_Cone_7;
  BRepPrim_Cylinder: typeof BRepPrim_Cylinder;
  BRepPrim_Cylinder_1: typeof BRepPrim_Cylinder_1;
  BRepPrim_Cylinder_2: typeof BRepPrim_Cylinder_2;
  BRepPrim_Cylinder_3: typeof BRepPrim_Cylinder_3;
  BRepPrim_Cylinder_4: typeof BRepPrim_Cylinder_4;
  BRepPrim_Cylinder_5: typeof BRepPrim_Cylinder_5;
  BRepPrim_Cylinder_6: typeof BRepPrim_Cylinder_6;
  BRepPrim_GWedge: typeof BRepPrim_GWedge;
  BRepPrim_GWedge_1: typeof BRepPrim_GWedge_1;
  BRepPrim_GWedge_2: typeof BRepPrim_GWedge_2;
  BRepPrim_GWedge_3: typeof BRepPrim_GWedge_3;
  BRepPrim_GWedge_4: typeof BRepPrim_GWedge_4;
  BRepPrim_Torus: typeof BRepPrim_Torus;
  BRepPrim_Torus_1: typeof BRepPrim_Torus_1;
  BRepPrim_Torus_2: typeof BRepPrim_Torus_2;
  BRepPrim_Torus_3: typeof BRepPrim_Torus_3;
  IntWalk_PWalking: typeof IntWalk_PWalking;
  IntWalk_PWalking_1: typeof IntWalk_PWalking_1;
  IntWalk_PWalking_2: typeof IntWalk_PWalking_2;
  IntWalk_TheFunctionOfTheInt2S: typeof IntWalk_TheFunctionOfTheInt2S;
  IntWalk_StatusDeflection: IntWalk_StatusDeflection;
  IntWalk_WalkingData: typeof IntWalk_WalkingData;
  IntWalk_TheInt2S: typeof IntWalk_TheInt2S;
  IntWalk_TheInt2S_1: typeof IntWalk_TheInt2S_1;
  IntWalk_TheInt2S_2: typeof IntWalk_TheInt2S_2;
  Message_HArrayOfMsg: typeof Message_HArrayOfMsg;
  Message_HArrayOfMsg_2: typeof Message_HArrayOfMsg_2;
  Message_HArrayOfMsg_3: typeof Message_HArrayOfMsg_3;
  Message_PrinterOStream: typeof Message_PrinterOStream;
  Message_PrinterOStream_1: typeof Message_PrinterOStream_1;
  Message_PrinterOStream_2: typeof Message_PrinterOStream_2;
  Handle_Message_PrinterOStream: typeof Handle_Message_PrinterOStream;
  Handle_Message_PrinterOStream_1: typeof Handle_Message_PrinterOStream_1;
  Handle_Message_PrinterOStream_2: typeof Handle_Message_PrinterOStream_2;
  Handle_Message_PrinterOStream_3: typeof Handle_Message_PrinterOStream_3;
  Handle_Message_PrinterOStream_4: typeof Handle_Message_PrinterOStream_4;
  Message_ProgressRange: typeof Message_ProgressRange;
  Message_ProgressRange_1: typeof Message_ProgressRange_1;
  Message_ProgressRange_2: typeof Message_ProgressRange_2;
  Message_Status: Message_Status;
  Message_AttributeMeter: typeof Message_AttributeMeter;
  Handle_Message_Algorithm: typeof Handle_Message_Algorithm;
  Handle_Message_Algorithm_1: typeof Handle_Message_Algorithm_1;
  Handle_Message_Algorithm_2: typeof Handle_Message_Algorithm_2;
  Handle_Message_Algorithm_3: typeof Handle_Message_Algorithm_3;
  Handle_Message_Algorithm_4: typeof Handle_Message_Algorithm_4;
  Message_Algorithm: typeof Message_Algorithm;
  Message_StatusType: Message_StatusType;
  Handle_Message_AlertExtended: typeof Handle_Message_AlertExtended;
  Handle_Message_AlertExtended_1: typeof Handle_Message_AlertExtended_1;
  Handle_Message_AlertExtended_2: typeof Handle_Message_AlertExtended_2;
  Handle_Message_AlertExtended_3: typeof Handle_Message_AlertExtended_3;
  Handle_Message_AlertExtended_4: typeof Handle_Message_AlertExtended_4;
  Message_AlertExtended: typeof Message_AlertExtended;
  Handle_Message_Messenger: typeof Handle_Message_Messenger;
  Handle_Message_Messenger_1: typeof Handle_Message_Messenger_1;
  Handle_Message_Messenger_2: typeof Handle_Message_Messenger_2;
  Handle_Message_Messenger_3: typeof Handle_Message_Messenger_3;
  Handle_Message_Messenger_4: typeof Handle_Message_Messenger_4;
  Message_Messenger: typeof Message_Messenger;
  Message_Messenger_1: typeof Message_Messenger_1;
  Message_Messenger_2: typeof Message_Messenger_2;
  Message: typeof Message;
  Message_MsgFile: typeof Message_MsgFile;
  Message_Alert: typeof Message_Alert;
  Handle_Message_Alert: typeof Handle_Message_Alert;
  Handle_Message_Alert_1: typeof Handle_Message_Alert_1;
  Handle_Message_Alert_2: typeof Handle_Message_Alert_2;
  Handle_Message_Alert_3: typeof Handle_Message_Alert_3;
  Handle_Message_Alert_4: typeof Handle_Message_Alert_4;
  Message_AttributeObject: typeof Message_AttributeObject;
  Handle_Message_Report: typeof Handle_Message_Report;
  Handle_Message_Report_1: typeof Handle_Message_Report_1;
  Handle_Message_Report_2: typeof Handle_Message_Report_2;
  Handle_Message_Report_3: typeof Handle_Message_Report_3;
  Handle_Message_Report_4: typeof Handle_Message_Report_4;
  Message_Report: typeof Message_Report;
  Handle_Message_Attribute: typeof Handle_Message_Attribute;
  Handle_Message_Attribute_1: typeof Handle_Message_Attribute_1;
  Handle_Message_Attribute_2: typeof Handle_Message_Attribute_2;
  Handle_Message_Attribute_3: typeof Handle_Message_Attribute_3;
  Handle_Message_Attribute_4: typeof Handle_Message_Attribute_4;
  Message_Attribute: typeof Message_Attribute;
  Message_ProgressSentry: typeof Message_ProgressSentry;
  Message_ProgressIndicator: typeof Message_ProgressIndicator;
  Handle_Message_ProgressIndicator: typeof Handle_Message_ProgressIndicator;
  Handle_Message_ProgressIndicator_1: typeof Handle_Message_ProgressIndicator_1;
  Handle_Message_ProgressIndicator_2: typeof Handle_Message_ProgressIndicator_2;
  Handle_Message_ProgressIndicator_3: typeof Handle_Message_ProgressIndicator_3;
  Handle_Message_ProgressIndicator_4: typeof Handle_Message_ProgressIndicator_4;
  Message_Gravity: Message_Gravity;
  Message_MetricType: Message_MetricType;
  Message_Level: typeof Message_Level;
  Message_ConsoleColor: Message_ConsoleColor;
  Handle_Message_PrinterToReport: typeof Handle_Message_PrinterToReport;
  Handle_Message_PrinterToReport_1: typeof Handle_Message_PrinterToReport_1;
  Handle_Message_PrinterToReport_2: typeof Handle_Message_PrinterToReport_2;
  Handle_Message_PrinterToReport_3: typeof Handle_Message_PrinterToReport_3;
  Handle_Message_PrinterToReport_4: typeof Handle_Message_PrinterToReport_4;
  Message_PrinterToReport: typeof Message_PrinterToReport;
  Message_ListOfMsg: typeof Message_ListOfMsg;
  Message_ListOfMsg_1: typeof Message_ListOfMsg_1;
  Message_ListOfMsg_2: typeof Message_ListOfMsg_2;
  Message_ListOfMsg_3: typeof Message_ListOfMsg_3;
  Message_ProgressScope: typeof Message_ProgressScope;
  Message_ProgressScope_1: typeof Message_ProgressScope_1;
  Message_ProgressScope_2: typeof Message_ProgressScope_2;
  Message_ProgressScope_4: typeof Message_ProgressScope_4;
  Message_ExecStatus: typeof Message_ExecStatus;
  Message_ExecStatus_1: typeof Message_ExecStatus_1;
  Message_ExecStatus_2: typeof Message_ExecStatus_2;
  Message_Msg: typeof Message_Msg;
  Message_Msg_1: typeof Message_Msg_1;
  Message_Msg_2: typeof Message_Msg_2;
  Message_Msg_3: typeof Message_Msg_3;
  Message_Msg_4: typeof Message_Msg_4;
  Handle_Message_CompositeAlerts: typeof Handle_Message_CompositeAlerts;
  Handle_Message_CompositeAlerts_1: typeof Handle_Message_CompositeAlerts_1;
  Handle_Message_CompositeAlerts_2: typeof Handle_Message_CompositeAlerts_2;
  Handle_Message_CompositeAlerts_3: typeof Handle_Message_CompositeAlerts_3;
  Handle_Message_CompositeAlerts_4: typeof Handle_Message_CompositeAlerts_4;
  Message_CompositeAlerts: typeof Message_CompositeAlerts;
  Handle_Message_Printer: typeof Handle_Message_Printer;
  Handle_Message_Printer_1: typeof Handle_Message_Printer_1;
  Handle_Message_Printer_2: typeof Handle_Message_Printer_2;
  Handle_Message_Printer_3: typeof Handle_Message_Printer_3;
  Handle_Message_Printer_4: typeof Handle_Message_Printer_4;
  Message_Printer: typeof Message_Printer;
  Message_PrinterSystemLog: typeof Message_PrinterSystemLog;
  Handle_Message_PrinterSystemLog: typeof Handle_Message_PrinterSystemLog;
  Handle_Message_PrinterSystemLog_1: typeof Handle_Message_PrinterSystemLog_1;
  Handle_Message_PrinterSystemLog_2: typeof Handle_Message_PrinterSystemLog_2;
  Handle_Message_PrinterSystemLog_3: typeof Handle_Message_PrinterSystemLog_3;
  Handle_Message_PrinterSystemLog_4: typeof Handle_Message_PrinterSystemLog_4;
  Handle_BRepMesh_DiscretRoot: typeof Handle_BRepMesh_DiscretRoot;
  Handle_BRepMesh_DiscretRoot_1: typeof Handle_BRepMesh_DiscretRoot_1;
  Handle_BRepMesh_DiscretRoot_2: typeof Handle_BRepMesh_DiscretRoot_2;
  Handle_BRepMesh_DiscretRoot_3: typeof Handle_BRepMesh_DiscretRoot_3;
  Handle_BRepMesh_DiscretRoot_4: typeof Handle_BRepMesh_DiscretRoot_4;
  BRepMesh_DiscretRoot: typeof BRepMesh_DiscretRoot;
  BRepMesh_EdgeTessellationExtractor: typeof BRepMesh_EdgeTessellationExtractor;
  BRepMesh_DiscretFactory: typeof BRepMesh_DiscretFactory;
  BRepMesh_UVParamRangeSplitter: typeof BRepMesh_UVParamRangeSplitter;
  BRepMesh_ConstrainedBaseMeshAlgo: typeof BRepMesh_ConstrainedBaseMeshAlgo;
  BRepMesh_ShapeVisitor: typeof BRepMesh_ShapeVisitor;
  BRepMesh_ShapeTool: typeof BRepMesh_ShapeTool;
  BRepMesh_BaseMeshAlgo: typeof BRepMesh_BaseMeshAlgo;
  BRepMesh_ModelHealer: typeof BRepMesh_ModelHealer;
  BRepMesh_ModelBuilder: typeof BRepMesh_ModelBuilder;
  BRepMesh_DegreeOfFreedom: BRepMesh_DegreeOfFreedom;
  BRepMesh_Triangle: typeof BRepMesh_Triangle;
  BRepMesh_Triangle_1: typeof BRepMesh_Triangle_1;
  BRepMesh_Triangle_2: typeof BRepMesh_Triangle_2;
  BRepMesh_DelabellaMeshAlgoFactory: typeof BRepMesh_DelabellaMeshAlgoFactory;
  BRepMesh_Classifier: typeof BRepMesh_Classifier;
  BRepMesh_DefaultRangeSplitter: typeof BRepMesh_DefaultRangeSplitter;
  BRepMesh_IncrementalMesh: typeof BRepMesh_IncrementalMesh;
  BRepMesh_IncrementalMesh_1: typeof BRepMesh_IncrementalMesh_1;
  BRepMesh_IncrementalMesh_2: typeof BRepMesh_IncrementalMesh_2;
  BRepMesh_IncrementalMesh_3: typeof BRepMesh_IncrementalMesh_3;
  BRepMesh_CurveTessellator: typeof BRepMesh_CurveTessellator;
  BRepMesh_CurveTessellator_1: typeof BRepMesh_CurveTessellator_1;
  BRepMesh_CurveTessellator_2: typeof BRepMesh_CurveTessellator_2;
  BRepMesh_Context: typeof BRepMesh_Context;
  BRepMesh_SphereRangeSplitter: typeof BRepMesh_SphereRangeSplitter;
  BRepMesh_BoundaryParamsRangeSplitter: typeof BRepMesh_BoundaryParamsRangeSplitter;
  BRepMesh_CircleTool: typeof BRepMesh_CircleTool;
  BRepMesh_CircleTool_1: typeof BRepMesh_CircleTool_1;
  BRepMesh_CircleTool_2: typeof BRepMesh_CircleTool_2;
  BRepMesh_EdgeDiscret: typeof BRepMesh_EdgeDiscret;
  BRepMesh_SelectorOfDataStructureOfDelaun: typeof BRepMesh_SelectorOfDataStructureOfDelaun;
  BRepMesh_SelectorOfDataStructureOfDelaun_1: typeof BRepMesh_SelectorOfDataStructureOfDelaun_1;
  BRepMesh_SelectorOfDataStructureOfDelaun_2: typeof BRepMesh_SelectorOfDataStructureOfDelaun_2;
  BRepMesh_ModelPreProcessor: typeof BRepMesh_ModelPreProcessor;
  BRepMesh_DataStructureOfDelaun: typeof BRepMesh_DataStructureOfDelaun;
  BRepMesh_CircleInspector: typeof BRepMesh_CircleInspector;
  BRepMesh_DelabellaBaseMeshAlgo: typeof BRepMesh_DelabellaBaseMeshAlgo;
  BRepMesh_Delaun: typeof BRepMesh_Delaun;
  BRepMesh_Delaun_1: typeof BRepMesh_Delaun_1;
  BRepMesh_Delaun_2: typeof BRepMesh_Delaun_2;
  BRepMesh_Delaun_3: typeof BRepMesh_Delaun_3;
  BRepMesh_Delaun_4: typeof BRepMesh_Delaun_4;
  BRepMesh_Delaun_5: typeof BRepMesh_Delaun_5;
  BRepMesh_Edge: typeof BRepMesh_Edge;
  BRepMesh_Edge_1: typeof BRepMesh_Edge_1;
  BRepMesh_Edge_2: typeof BRepMesh_Edge_2;
  BRepMesh_VertexInspector: typeof BRepMesh_VertexInspector;
  BRepMesh_CustomBaseMeshAlgo: typeof BRepMesh_CustomBaseMeshAlgo;
  BRepMesh_PairOfIndex: typeof BRepMesh_PairOfIndex;
  BRepMesh_OrientedEdge: typeof BRepMesh_OrientedEdge;
  BRepMesh_OrientedEdge_1: typeof BRepMesh_OrientedEdge_1;
  BRepMesh_OrientedEdge_2: typeof BRepMesh_OrientedEdge_2;
  BRepMesh_VertexTool: typeof BRepMesh_VertexTool;
  BRepMesh_MeshTool: typeof BRepMesh_MeshTool;
  BRepMesh_Vertex: typeof BRepMesh_Vertex;
  BRepMesh_Vertex_1: typeof BRepMesh_Vertex_1;
  BRepMesh_Vertex_2: typeof BRepMesh_Vertex_2;
  BRepMesh_Vertex_3: typeof BRepMesh_Vertex_3;
  BRepMesh_ModelPostProcessor: typeof BRepMesh_ModelPostProcessor;
  BRepMesh_FastDiscret: typeof BRepMesh_FastDiscret;
  BRepMesh_GeomTool: typeof BRepMesh_GeomTool;
  BRepMesh_GeomTool_1: typeof BRepMesh_GeomTool_1;
  BRepMesh_GeomTool_2: typeof BRepMesh_GeomTool_2;
  BRepMesh_Circle: typeof BRepMesh_Circle;
  BRepMesh_Circle_1: typeof BRepMesh_Circle_1;
  BRepMesh_Circle_2: typeof BRepMesh_Circle_2;
  BRepMesh_MeshAlgoFactory: typeof BRepMesh_MeshAlgoFactory;
  BRepMesh_FaceDiscret: typeof BRepMesh_FaceDiscret;
  BRepMesh_CylinderRangeSplitter: typeof BRepMesh_CylinderRangeSplitter;
  BRepMesh_DelaunayBaseMeshAlgo: typeof BRepMesh_DelaunayBaseMeshAlgo;
  BRepMesh_FactoryError: BRepMesh_FactoryError;
  BRepMesh_ConeRangeSplitter: typeof BRepMesh_ConeRangeSplitter;
  BRepMesh_Deflection: typeof BRepMesh_Deflection;
  BRepMesh_TorusRangeSplitter: typeof BRepMesh_TorusRangeSplitter;
  BRepMesh_FaceChecker: typeof BRepMesh_FaceChecker;
  BRepMesh_NURBSRangeSplitter: typeof BRepMesh_NURBSRangeSplitter;
  Handle_Quantity_DateDefinitionError: typeof Handle_Quantity_DateDefinitionError;
  Handle_Quantity_DateDefinitionError_1: typeof Handle_Quantity_DateDefinitionError_1;
  Handle_Quantity_DateDefinitionError_2: typeof Handle_Quantity_DateDefinitionError_2;
  Handle_Quantity_DateDefinitionError_3: typeof Handle_Quantity_DateDefinitionError_3;
  Handle_Quantity_DateDefinitionError_4: typeof Handle_Quantity_DateDefinitionError_4;
  Quantity_DateDefinitionError: typeof Quantity_DateDefinitionError;
  Quantity_DateDefinitionError_1: typeof Quantity_DateDefinitionError_1;
  Quantity_DateDefinitionError_2: typeof Quantity_DateDefinitionError_2;
  Quantity_PhysicalQuantity: Quantity_PhysicalQuantity;
  Quantity_TypeOfColor: Quantity_TypeOfColor;
  Quantity_ColorHasher: typeof Quantity_ColorHasher;
  Quantity_NameOfColor: Quantity_NameOfColor;
  Handle_Quantity_HArray1OfColor: typeof Handle_Quantity_HArray1OfColor;
  Handle_Quantity_HArray1OfColor_1: typeof Handle_Quantity_HArray1OfColor_1;
  Handle_Quantity_HArray1OfColor_2: typeof Handle_Quantity_HArray1OfColor_2;
  Handle_Quantity_HArray1OfColor_3: typeof Handle_Quantity_HArray1OfColor_3;
  Handle_Quantity_HArray1OfColor_4: typeof Handle_Quantity_HArray1OfColor_4;
  Quantity_Array1OfColor: typeof Quantity_Array1OfColor;
  Quantity_Array1OfColor_1: typeof Quantity_Array1OfColor_1;
  Quantity_Array1OfColor_2: typeof Quantity_Array1OfColor_2;
  Quantity_Array1OfColor_3: typeof Quantity_Array1OfColor_3;
  Quantity_Array1OfColor_4: typeof Quantity_Array1OfColor_4;
  Quantity_Array1OfColor_5: typeof Quantity_Array1OfColor_5;
  Quantity_Date: typeof Quantity_Date;
  Quantity_Date_1: typeof Quantity_Date_1;
  Quantity_Date_2: typeof Quantity_Date_2;
  Quantity_Color: typeof Quantity_Color;
  Quantity_Color_1: typeof Quantity_Color_1;
  Quantity_Color_2: typeof Quantity_Color_2;
  Quantity_Color_3: typeof Quantity_Color_3;
  Quantity_Color_4: typeof Quantity_Color_4;
  Quantity_Array2OfColor: typeof Quantity_Array2OfColor;
  Quantity_Array2OfColor_1: typeof Quantity_Array2OfColor_1;
  Quantity_Array2OfColor_2: typeof Quantity_Array2OfColor_2;
  Quantity_Array2OfColor_3: typeof Quantity_Array2OfColor_3;
  Quantity_Array2OfColor_4: typeof Quantity_Array2OfColor_4;
  Quantity_Array2OfColor_5: typeof Quantity_Array2OfColor_5;
  Quantity_ColorRGBAHasher: typeof Quantity_ColorRGBAHasher;
  Quantity_Period: typeof Quantity_Period;
  Quantity_Period_1: typeof Quantity_Period_1;
  Quantity_Period_2: typeof Quantity_Period_2;
  Quantity_ColorRGBA: typeof Quantity_ColorRGBA;
  Quantity_ColorRGBA_1: typeof Quantity_ColorRGBA_1;
  Quantity_ColorRGBA_2: typeof Quantity_ColorRGBA_2;
  Quantity_ColorRGBA_3: typeof Quantity_ColorRGBA_3;
  Quantity_ColorRGBA_4: typeof Quantity_ColorRGBA_4;
  Quantity_ColorRGBA_5: typeof Quantity_ColorRGBA_5;
  Handle_Quantity_PeriodDefinitionError: typeof Handle_Quantity_PeriodDefinitionError;
  Handle_Quantity_PeriodDefinitionError_1: typeof Handle_Quantity_PeriodDefinitionError_1;
  Handle_Quantity_PeriodDefinitionError_2: typeof Handle_Quantity_PeriodDefinitionError_2;
  Handle_Quantity_PeriodDefinitionError_3: typeof Handle_Quantity_PeriodDefinitionError_3;
  Handle_Quantity_PeriodDefinitionError_4: typeof Handle_Quantity_PeriodDefinitionError_4;
  Quantity_PeriodDefinitionError: typeof Quantity_PeriodDefinitionError;
  Quantity_PeriodDefinitionError_1: typeof Quantity_PeriodDefinitionError_1;
  Quantity_PeriodDefinitionError_2: typeof Quantity_PeriodDefinitionError_2;
  GCPnts_QuasiUniformDeflection: typeof GCPnts_QuasiUniformDeflection;
  GCPnts_QuasiUniformDeflection_1: typeof GCPnts_QuasiUniformDeflection_1;
  GCPnts_QuasiUniformDeflection_2: typeof GCPnts_QuasiUniformDeflection_2;
  GCPnts_QuasiUniformDeflection_3: typeof GCPnts_QuasiUniformDeflection_3;
  GCPnts_QuasiUniformDeflection_4: typeof GCPnts_QuasiUniformDeflection_4;
  GCPnts_QuasiUniformDeflection_5: typeof GCPnts_QuasiUniformDeflection_5;
  GCPnts_QuasiUniformAbscissa: typeof GCPnts_QuasiUniformAbscissa;
  GCPnts_QuasiUniformAbscissa_1: typeof GCPnts_QuasiUniformAbscissa_1;
  GCPnts_QuasiUniformAbscissa_2: typeof GCPnts_QuasiUniformAbscissa_2;
  GCPnts_QuasiUniformAbscissa_3: typeof GCPnts_QuasiUniformAbscissa_3;
  GCPnts_QuasiUniformAbscissa_4: typeof GCPnts_QuasiUniformAbscissa_4;
  GCPnts_QuasiUniformAbscissa_5: typeof GCPnts_QuasiUniformAbscissa_5;
  GCPnts_DeflectionType: GCPnts_DeflectionType;
  GCPnts_UniformDeflection: typeof GCPnts_UniformDeflection;
  GCPnts_UniformDeflection_1: typeof GCPnts_UniformDeflection_1;
  GCPnts_UniformDeflection_2: typeof GCPnts_UniformDeflection_2;
  GCPnts_UniformDeflection_3: typeof GCPnts_UniformDeflection_3;
  GCPnts_UniformDeflection_4: typeof GCPnts_UniformDeflection_4;
  GCPnts_UniformDeflection_5: typeof GCPnts_UniformDeflection_5;
  GCPnts_AbscissaType: GCPnts_AbscissaType;
  GCPnts_UniformAbscissa: typeof GCPnts_UniformAbscissa;
  GCPnts_UniformAbscissa_1: typeof GCPnts_UniformAbscissa_1;
  GCPnts_UniformAbscissa_2: typeof GCPnts_UniformAbscissa_2;
  GCPnts_UniformAbscissa_3: typeof GCPnts_UniformAbscissa_3;
  GCPnts_UniformAbscissa_4: typeof GCPnts_UniformAbscissa_4;
  GCPnts_UniformAbscissa_5: typeof GCPnts_UniformAbscissa_5;
  GCPnts_UniformAbscissa_6: typeof GCPnts_UniformAbscissa_6;
  GCPnts_UniformAbscissa_7: typeof GCPnts_UniformAbscissa_7;
  GCPnts_UniformAbscissa_8: typeof GCPnts_UniformAbscissa_8;
  GCPnts_UniformAbscissa_9: typeof GCPnts_UniformAbscissa_9;
  GCPnts_DistFunction2dMV: typeof GCPnts_DistFunction2dMV;
  GCPnts_TangentialDeflection: typeof GCPnts_TangentialDeflection;
  GCPnts_TangentialDeflection_1: typeof GCPnts_TangentialDeflection_1;
  GCPnts_TangentialDeflection_2: typeof GCPnts_TangentialDeflection_2;
  GCPnts_TangentialDeflection_3: typeof GCPnts_TangentialDeflection_3;
  GCPnts_TangentialDeflection_4: typeof GCPnts_TangentialDeflection_4;
  GCPnts_TangentialDeflection_5: typeof GCPnts_TangentialDeflection_5;
  GCPnts_DistFunctionMV: typeof GCPnts_DistFunctionMV;
  GCPnts_AbscissaPoint: typeof GCPnts_AbscissaPoint;
  GCPnts_AbscissaPoint_1: typeof GCPnts_AbscissaPoint_1;
  GCPnts_AbscissaPoint_2: typeof GCPnts_AbscissaPoint_2;
  GCPnts_AbscissaPoint_3: typeof GCPnts_AbscissaPoint_3;
  GCPnts_AbscissaPoint_4: typeof GCPnts_AbscissaPoint_4;
  GCPnts_AbscissaPoint_5: typeof GCPnts_AbscissaPoint_5;
  GCPnts_AbscissaPoint_6: typeof GCPnts_AbscissaPoint_6;
  GCPnts_AbscissaPoint_7: typeof GCPnts_AbscissaPoint_7;
  GCPnts_AbscissaPoint_8: typeof GCPnts_AbscissaPoint_8;
  GCPnts_AbscissaPoint_9: typeof GCPnts_AbscissaPoint_9;
  GeomLProp: typeof GeomLProp;
  GeomLProp_SLProps: typeof GeomLProp_SLProps;
  GeomLProp_SLProps_1: typeof GeomLProp_SLProps_1;
  GeomLProp_SLProps_2: typeof GeomLProp_SLProps_2;
  GeomLProp_SLProps_3: typeof GeomLProp_SLProps_3;
  GeomLProp_CurveTool: typeof GeomLProp_CurveTool;
  GeomLProp_SurfaceTool: typeof GeomLProp_SurfaceTool;
  GeomLProp_CLProps: typeof GeomLProp_CLProps;
  GeomLProp_CLProps_1: typeof GeomLProp_CLProps_1;
  GeomLProp_CLProps_2: typeof GeomLProp_CLProps_2;
  GeomLProp_CLProps_3: typeof GeomLProp_CLProps_3;
  Handle_BinXCAFDrivers_DocumentRetrievalDriver: typeof Handle_BinXCAFDrivers_DocumentRetrievalDriver;
  Handle_BinXCAFDrivers_DocumentRetrievalDriver_1: typeof Handle_BinXCAFDrivers_DocumentRetrievalDriver_1;
  Handle_BinXCAFDrivers_DocumentRetrievalDriver_2: typeof Handle_BinXCAFDrivers_DocumentRetrievalDriver_2;
  Handle_BinXCAFDrivers_DocumentRetrievalDriver_3: typeof Handle_BinXCAFDrivers_DocumentRetrievalDriver_3;
  Handle_BinXCAFDrivers_DocumentRetrievalDriver_4: typeof Handle_BinXCAFDrivers_DocumentRetrievalDriver_4;
  BinXCAFDrivers_DocumentRetrievalDriver: typeof BinXCAFDrivers_DocumentRetrievalDriver;
  BinXCAFDrivers: typeof BinXCAFDrivers;
  Handle_BinXCAFDrivers_DocumentStorageDriver: typeof Handle_BinXCAFDrivers_DocumentStorageDriver;
  Handle_BinXCAFDrivers_DocumentStorageDriver_1: typeof Handle_BinXCAFDrivers_DocumentStorageDriver_1;
  Handle_BinXCAFDrivers_DocumentStorageDriver_2: typeof Handle_BinXCAFDrivers_DocumentStorageDriver_2;
  Handle_BinXCAFDrivers_DocumentStorageDriver_3: typeof Handle_BinXCAFDrivers_DocumentStorageDriver_3;
  Handle_BinXCAFDrivers_DocumentStorageDriver_4: typeof Handle_BinXCAFDrivers_DocumentStorageDriver_4;
  BinXCAFDrivers_DocumentStorageDriver: typeof BinXCAFDrivers_DocumentStorageDriver;
  Handle_IGESDimen_DimensionUnits: typeof Handle_IGESDimen_DimensionUnits;
  Handle_IGESDimen_DimensionUnits_1: typeof Handle_IGESDimen_DimensionUnits_1;
  Handle_IGESDimen_DimensionUnits_2: typeof Handle_IGESDimen_DimensionUnits_2;
  Handle_IGESDimen_DimensionUnits_3: typeof Handle_IGESDimen_DimensionUnits_3;
  Handle_IGESDimen_DimensionUnits_4: typeof Handle_IGESDimen_DimensionUnits_4;
  IGESDimen_DimensionUnits: typeof IGESDimen_DimensionUnits;
  IGESDimen_PointDimension: typeof IGESDimen_PointDimension;
  Handle_IGESDimen_PointDimension: typeof Handle_IGESDimen_PointDimension;
  Handle_IGESDimen_PointDimension_1: typeof Handle_IGESDimen_PointDimension_1;
  Handle_IGESDimen_PointDimension_2: typeof Handle_IGESDimen_PointDimension_2;
  Handle_IGESDimen_PointDimension_3: typeof Handle_IGESDimen_PointDimension_3;
  Handle_IGESDimen_PointDimension_4: typeof Handle_IGESDimen_PointDimension_4;
  IGESDimen_SpecificModule: typeof IGESDimen_SpecificModule;
  Handle_IGESDimen_SpecificModule: typeof Handle_IGESDimen_SpecificModule;
  Handle_IGESDimen_SpecificModule_1: typeof Handle_IGESDimen_SpecificModule_1;
  Handle_IGESDimen_SpecificModule_2: typeof Handle_IGESDimen_SpecificModule_2;
  Handle_IGESDimen_SpecificModule_3: typeof Handle_IGESDimen_SpecificModule_3;
  Handle_IGESDimen_SpecificModule_4: typeof Handle_IGESDimen_SpecificModule_4;
  IGESDimen_ToolRadiusDimension: typeof IGESDimen_ToolRadiusDimension;
  IGESDimen_CenterLine: typeof IGESDimen_CenterLine;
  Handle_IGESDimen_CenterLine: typeof Handle_IGESDimen_CenterLine;
  Handle_IGESDimen_CenterLine_1: typeof Handle_IGESDimen_CenterLine_1;
  Handle_IGESDimen_CenterLine_2: typeof Handle_IGESDimen_CenterLine_2;
  Handle_IGESDimen_CenterLine_3: typeof Handle_IGESDimen_CenterLine_3;
  Handle_IGESDimen_CenterLine_4: typeof Handle_IGESDimen_CenterLine_4;
  Handle_IGESDimen_Protocol: typeof Handle_IGESDimen_Protocol;
  Handle_IGESDimen_Protocol_1: typeof Handle_IGESDimen_Protocol_1;
  Handle_IGESDimen_Protocol_2: typeof Handle_IGESDimen_Protocol_2;
  Handle_IGESDimen_Protocol_3: typeof Handle_IGESDimen_Protocol_3;
  Handle_IGESDimen_Protocol_4: typeof Handle_IGESDimen_Protocol_4;
  IGESDimen_Protocol: typeof IGESDimen_Protocol;
  Handle_IGESDimen_NewDimensionedGeometry: typeof Handle_IGESDimen_NewDimensionedGeometry;
  Handle_IGESDimen_NewDimensionedGeometry_1: typeof Handle_IGESDimen_NewDimensionedGeometry_1;
  Handle_IGESDimen_NewDimensionedGeometry_2: typeof Handle_IGESDimen_NewDimensionedGeometry_2;
  Handle_IGESDimen_NewDimensionedGeometry_3: typeof Handle_IGESDimen_NewDimensionedGeometry_3;
  Handle_IGESDimen_NewDimensionedGeometry_4: typeof Handle_IGESDimen_NewDimensionedGeometry_4;
  IGESDimen_NewDimensionedGeometry: typeof IGESDimen_NewDimensionedGeometry;
  IGESDimen_LeaderArrow: typeof IGESDimen_LeaderArrow;
  Handle_IGESDimen_LeaderArrow: typeof Handle_IGESDimen_LeaderArrow;
  Handle_IGESDimen_LeaderArrow_1: typeof Handle_IGESDimen_LeaderArrow_1;
  Handle_IGESDimen_LeaderArrow_2: typeof Handle_IGESDimen_LeaderArrow_2;
  Handle_IGESDimen_LeaderArrow_3: typeof Handle_IGESDimen_LeaderArrow_3;
  Handle_IGESDimen_LeaderArrow_4: typeof Handle_IGESDimen_LeaderArrow_4;
  Handle_IGESDimen_SectionedArea: typeof Handle_IGESDimen_SectionedArea;
  Handle_IGESDimen_SectionedArea_1: typeof Handle_IGESDimen_SectionedArea_1;
  Handle_IGESDimen_SectionedArea_2: typeof Handle_IGESDimen_SectionedArea_2;
  Handle_IGESDimen_SectionedArea_3: typeof Handle_IGESDimen_SectionedArea_3;
  Handle_IGESDimen_SectionedArea_4: typeof Handle_IGESDimen_SectionedArea_4;
  IGESDimen_SectionedArea: typeof IGESDimen_SectionedArea;
  IGESDimen_ToolCurveDimension: typeof IGESDimen_ToolCurveDimension;
  IGESDimen_ToolDimensionUnits: typeof IGESDimen_ToolDimensionUnits;
  IGESDimen_GeneralModule: typeof IGESDimen_GeneralModule;
  Handle_IGESDimen_GeneralModule: typeof Handle_IGESDimen_GeneralModule;
  Handle_IGESDimen_GeneralModule_1: typeof Handle_IGESDimen_GeneralModule_1;
  Handle_IGESDimen_GeneralModule_2: typeof Handle_IGESDimen_GeneralModule_2;
  Handle_IGESDimen_GeneralModule_3: typeof Handle_IGESDimen_GeneralModule_3;
  Handle_IGESDimen_GeneralModule_4: typeof Handle_IGESDimen_GeneralModule_4;
  IGESDimen_ToolLinearDimension: typeof IGESDimen_ToolLinearDimension;
  IGESDimen_ToolSectionedArea: typeof IGESDimen_ToolSectionedArea;
  IGESDimen_DimensionDisplayData: typeof IGESDimen_DimensionDisplayData;
  Handle_IGESDimen_DimensionDisplayData: typeof Handle_IGESDimen_DimensionDisplayData;
  Handle_IGESDimen_DimensionDisplayData_1: typeof Handle_IGESDimen_DimensionDisplayData_1;
  Handle_IGESDimen_DimensionDisplayData_2: typeof Handle_IGESDimen_DimensionDisplayData_2;
  Handle_IGESDimen_DimensionDisplayData_3: typeof Handle_IGESDimen_DimensionDisplayData_3;
  Handle_IGESDimen_DimensionDisplayData_4: typeof Handle_IGESDimen_DimensionDisplayData_4;
  IGESDimen_ToolNewDimensionedGeometry: typeof IGESDimen_ToolNewDimensionedGeometry;
  IGESDimen_ToolDimensionDisplayData: typeof IGESDimen_ToolDimensionDisplayData;
  IGESDimen_GeneralSymbol: typeof IGESDimen_GeneralSymbol;
  Handle_IGESDimen_GeneralSymbol: typeof Handle_IGESDimen_GeneralSymbol;
  Handle_IGESDimen_GeneralSymbol_1: typeof Handle_IGESDimen_GeneralSymbol_1;
  Handle_IGESDimen_GeneralSymbol_2: typeof Handle_IGESDimen_GeneralSymbol_2;
  Handle_IGESDimen_GeneralSymbol_3: typeof Handle_IGESDimen_GeneralSymbol_3;
  Handle_IGESDimen_GeneralSymbol_4: typeof Handle_IGESDimen_GeneralSymbol_4;
  IGESDimen_ToolSection: typeof IGESDimen_ToolSection;
  Handle_IGESDimen_WitnessLine: typeof Handle_IGESDimen_WitnessLine;
  Handle_IGESDimen_WitnessLine_1: typeof Handle_IGESDimen_WitnessLine_1;
  Handle_IGESDimen_WitnessLine_2: typeof Handle_IGESDimen_WitnessLine_2;
  Handle_IGESDimen_WitnessLine_3: typeof Handle_IGESDimen_WitnessLine_3;
  Handle_IGESDimen_WitnessLine_4: typeof Handle_IGESDimen_WitnessLine_4;
  IGESDimen_WitnessLine: typeof IGESDimen_WitnessLine;
  IGESDimen_ToolDiameterDimension: typeof IGESDimen_ToolDiameterDimension;
  Handle_IGESDimen_BasicDimension: typeof Handle_IGESDimen_BasicDimension;
  Handle_IGESDimen_BasicDimension_1: typeof Handle_IGESDimen_BasicDimension_1;
  Handle_IGESDimen_BasicDimension_2: typeof Handle_IGESDimen_BasicDimension_2;
  Handle_IGESDimen_BasicDimension_3: typeof Handle_IGESDimen_BasicDimension_3;
  Handle_IGESDimen_BasicDimension_4: typeof Handle_IGESDimen_BasicDimension_4;
  IGESDimen_BasicDimension: typeof IGESDimen_BasicDimension;
  Handle_IGESDimen_DiameterDimension: typeof Handle_IGESDimen_DiameterDimension;
  Handle_IGESDimen_DiameterDimension_1: typeof Handle_IGESDimen_DiameterDimension_1;
  Handle_IGESDimen_DiameterDimension_2: typeof Handle_IGESDimen_DiameterDimension_2;
  Handle_IGESDimen_DiameterDimension_3: typeof Handle_IGESDimen_DiameterDimension_3;
  Handle_IGESDimen_DiameterDimension_4: typeof Handle_IGESDimen_DiameterDimension_4;
  IGESDimen_DiameterDimension: typeof IGESDimen_DiameterDimension;
  IGESDimen_ToolOrdinateDimension: typeof IGESDimen_ToolOrdinateDimension;
  Handle_IGESDimen_NewGeneralNote: typeof Handle_IGESDimen_NewGeneralNote;
  Handle_IGESDimen_NewGeneralNote_1: typeof Handle_IGESDimen_NewGeneralNote_1;
  Handle_IGESDimen_NewGeneralNote_2: typeof Handle_IGESDimen_NewGeneralNote_2;
  Handle_IGESDimen_NewGeneralNote_3: typeof Handle_IGESDimen_NewGeneralNote_3;
  Handle_IGESDimen_NewGeneralNote_4: typeof Handle_IGESDimen_NewGeneralNote_4;
  IGESDimen_NewGeneralNote: typeof IGESDimen_NewGeneralNote;
  IGESDimen_ToolGeneralSymbol: typeof IGESDimen_ToolGeneralSymbol;
  IGESDimen_OrdinateDimension: typeof IGESDimen_OrdinateDimension;
  Handle_IGESDimen_OrdinateDimension: typeof Handle_IGESDimen_OrdinateDimension;
  Handle_IGESDimen_OrdinateDimension_1: typeof Handle_IGESDimen_OrdinateDimension_1;
  Handle_IGESDimen_OrdinateDimension_2: typeof Handle_IGESDimen_OrdinateDimension_2;
  Handle_IGESDimen_OrdinateDimension_3: typeof Handle_IGESDimen_OrdinateDimension_3;
  Handle_IGESDimen_OrdinateDimension_4: typeof Handle_IGESDimen_OrdinateDimension_4;
  Handle_IGESDimen_GeneralNote: typeof Handle_IGESDimen_GeneralNote;
  Handle_IGESDimen_GeneralNote_1: typeof Handle_IGESDimen_GeneralNote_1;
  Handle_IGESDimen_GeneralNote_2: typeof Handle_IGESDimen_GeneralNote_2;
  Handle_IGESDimen_GeneralNote_3: typeof Handle_IGESDimen_GeneralNote_3;
  Handle_IGESDimen_GeneralNote_4: typeof Handle_IGESDimen_GeneralNote_4;
  IGESDimen_GeneralNote: typeof IGESDimen_GeneralNote;
  IGESDimen_ToolGeneralNote: typeof IGESDimen_ToolGeneralNote;
  IGESDimen_ToolCenterLine: typeof IGESDimen_ToolCenterLine;
  Handle_IGESDimen_RadiusDimension: typeof Handle_IGESDimen_RadiusDimension;
  Handle_IGESDimen_RadiusDimension_1: typeof Handle_IGESDimen_RadiusDimension_1;
  Handle_IGESDimen_RadiusDimension_2: typeof Handle_IGESDimen_RadiusDimension_2;
  Handle_IGESDimen_RadiusDimension_3: typeof Handle_IGESDimen_RadiusDimension_3;
  Handle_IGESDimen_RadiusDimension_4: typeof Handle_IGESDimen_RadiusDimension_4;
  IGESDimen_RadiusDimension: typeof IGESDimen_RadiusDimension;
  IGESDimen_ToolAngularDimension: typeof IGESDimen_ToolAngularDimension;
  Handle_IGESDimen_Section: typeof Handle_IGESDimen_Section;
  Handle_IGESDimen_Section_1: typeof Handle_IGESDimen_Section_1;
  Handle_IGESDimen_Section_2: typeof Handle_IGESDimen_Section_2;
  Handle_IGESDimen_Section_3: typeof Handle_IGESDimen_Section_3;
  Handle_IGESDimen_Section_4: typeof Handle_IGESDimen_Section_4;
  IGESDimen_Section: typeof IGESDimen_Section;
  IGESDimen: typeof IGESDimen;
  Handle_IGESDimen_FlagNote: typeof Handle_IGESDimen_FlagNote;
  Handle_IGESDimen_FlagNote_1: typeof Handle_IGESDimen_FlagNote_1;
  Handle_IGESDimen_FlagNote_2: typeof Handle_IGESDimen_FlagNote_2;
  Handle_IGESDimen_FlagNote_3: typeof Handle_IGESDimen_FlagNote_3;
  Handle_IGESDimen_FlagNote_4: typeof Handle_IGESDimen_FlagNote_4;
  IGESDimen_FlagNote: typeof IGESDimen_FlagNote;
  IGESDimen_ToolFlagNote: typeof IGESDimen_ToolFlagNote;
  IGESDimen_AngularDimension: typeof IGESDimen_AngularDimension;
  Handle_IGESDimen_AngularDimension: typeof Handle_IGESDimen_AngularDimension;
  Handle_IGESDimen_AngularDimension_1: typeof Handle_IGESDimen_AngularDimension_1;
  Handle_IGESDimen_AngularDimension_2: typeof Handle_IGESDimen_AngularDimension_2;
  Handle_IGESDimen_AngularDimension_3: typeof Handle_IGESDimen_AngularDimension_3;
  Handle_IGESDimen_AngularDimension_4: typeof Handle_IGESDimen_AngularDimension_4;
  IGESDimen_ToolNewGeneralNote: typeof IGESDimen_ToolNewGeneralNote;
  Handle_IGESDimen_GeneralLabel: typeof Handle_IGESDimen_GeneralLabel;
  Handle_IGESDimen_GeneralLabel_1: typeof Handle_IGESDimen_GeneralLabel_1;
  Handle_IGESDimen_GeneralLabel_2: typeof Handle_IGESDimen_GeneralLabel_2;
  Handle_IGESDimen_GeneralLabel_3: typeof Handle_IGESDimen_GeneralLabel_3;
  Handle_IGESDimen_GeneralLabel_4: typeof Handle_IGESDimen_GeneralLabel_4;
  IGESDimen_GeneralLabel: typeof IGESDimen_GeneralLabel;
  IGESDimen_ReadWriteModule: typeof IGESDimen_ReadWriteModule;
  Handle_IGESDimen_ReadWriteModule: typeof Handle_IGESDimen_ReadWriteModule;
  Handle_IGESDimen_ReadWriteModule_1: typeof Handle_IGESDimen_ReadWriteModule_1;
  Handle_IGESDimen_ReadWriteModule_2: typeof Handle_IGESDimen_ReadWriteModule_2;
  Handle_IGESDimen_ReadWriteModule_3: typeof Handle_IGESDimen_ReadWriteModule_3;
  Handle_IGESDimen_ReadWriteModule_4: typeof Handle_IGESDimen_ReadWriteModule_4;
  IGESDimen_ToolDimensionedGeometry: typeof IGESDimen_ToolDimensionedGeometry;
  IGESDimen_ToolGeneralLabel: typeof IGESDimen_ToolGeneralLabel;
  IGESDimen_DimensionTolerance: typeof IGESDimen_DimensionTolerance;
  Handle_IGESDimen_DimensionTolerance: typeof Handle_IGESDimen_DimensionTolerance;
  Handle_IGESDimen_DimensionTolerance_1: typeof Handle_IGESDimen_DimensionTolerance_1;
  Handle_IGESDimen_DimensionTolerance_2: typeof Handle_IGESDimen_DimensionTolerance_2;
  Handle_IGESDimen_DimensionTolerance_3: typeof Handle_IGESDimen_DimensionTolerance_3;
  Handle_IGESDimen_DimensionTolerance_4: typeof Handle_IGESDimen_DimensionTolerance_4;
  IGESDimen_ToolDimensionTolerance: typeof IGESDimen_ToolDimensionTolerance;
  Handle_IGESDimen_LinearDimension: typeof Handle_IGESDimen_LinearDimension;
  Handle_IGESDimen_LinearDimension_1: typeof Handle_IGESDimen_LinearDimension_1;
  Handle_IGESDimen_LinearDimension_2: typeof Handle_IGESDimen_LinearDimension_2;
  Handle_IGESDimen_LinearDimension_3: typeof Handle_IGESDimen_LinearDimension_3;
  Handle_IGESDimen_LinearDimension_4: typeof Handle_IGESDimen_LinearDimension_4;
  IGESDimen_LinearDimension: typeof IGESDimen_LinearDimension;
  IGESDimen_CurveDimension: typeof IGESDimen_CurveDimension;
  Handle_IGESDimen_CurveDimension: typeof Handle_IGESDimen_CurveDimension;
  Handle_IGESDimen_CurveDimension_1: typeof Handle_IGESDimen_CurveDimension_1;
  Handle_IGESDimen_CurveDimension_2: typeof Handle_IGESDimen_CurveDimension_2;
  Handle_IGESDimen_CurveDimension_3: typeof Handle_IGESDimen_CurveDimension_3;
  Handle_IGESDimen_CurveDimension_4: typeof Handle_IGESDimen_CurveDimension_4;
  Handle_IGESDimen_HArray1OfLeaderArrow: typeof Handle_IGESDimen_HArray1OfLeaderArrow;
  Handle_IGESDimen_HArray1OfLeaderArrow_1: typeof Handle_IGESDimen_HArray1OfLeaderArrow_1;
  Handle_IGESDimen_HArray1OfLeaderArrow_2: typeof Handle_IGESDimen_HArray1OfLeaderArrow_2;
  Handle_IGESDimen_HArray1OfLeaderArrow_3: typeof Handle_IGESDimen_HArray1OfLeaderArrow_3;
  Handle_IGESDimen_HArray1OfLeaderArrow_4: typeof Handle_IGESDimen_HArray1OfLeaderArrow_4;
  IGESDimen_DimensionedGeometry: typeof IGESDimen_DimensionedGeometry;
  Handle_IGESDimen_DimensionedGeometry: typeof Handle_IGESDimen_DimensionedGeometry;
  Handle_IGESDimen_DimensionedGeometry_1: typeof Handle_IGESDimen_DimensionedGeometry_1;
  Handle_IGESDimen_DimensionedGeometry_2: typeof Handle_IGESDimen_DimensionedGeometry_2;
  Handle_IGESDimen_DimensionedGeometry_3: typeof Handle_IGESDimen_DimensionedGeometry_3;
  Handle_IGESDimen_DimensionedGeometry_4: typeof Handle_IGESDimen_DimensionedGeometry_4;
  Handle_IGESDimen_HArray1OfGeneralNote: typeof Handle_IGESDimen_HArray1OfGeneralNote;
  Handle_IGESDimen_HArray1OfGeneralNote_1: typeof Handle_IGESDimen_HArray1OfGeneralNote_1;
  Handle_IGESDimen_HArray1OfGeneralNote_2: typeof Handle_IGESDimen_HArray1OfGeneralNote_2;
  Handle_IGESDimen_HArray1OfGeneralNote_3: typeof Handle_IGESDimen_HArray1OfGeneralNote_3;
  Handle_IGESDimen_HArray1OfGeneralNote_4: typeof Handle_IGESDimen_HArray1OfGeneralNote_4;
  IGESDimen_ToolBasicDimension: typeof IGESDimen_ToolBasicDimension;
  IGESDimen_ToolPointDimension: typeof IGESDimen_ToolPointDimension;
  IGESDimen_ToolWitnessLine: typeof IGESDimen_ToolWitnessLine;
  IGESDimen_ToolLeaderArrow: typeof IGESDimen_ToolLeaderArrow;
  XCAFApp_Application: typeof XCAFApp_Application;
  Handle_XCAFApp_Application: typeof Handle_XCAFApp_Application;
  Handle_XCAFApp_Application_1: typeof Handle_XCAFApp_Application_1;
  Handle_XCAFApp_Application_2: typeof Handle_XCAFApp_Application_2;
  Handle_XCAFApp_Application_3: typeof Handle_XCAFApp_Application_3;
  Handle_XCAFApp_Application_4: typeof Handle_XCAFApp_Application_4;
  Handle_TColStd_HSequenceOfHExtendedString: typeof Handle_TColStd_HSequenceOfHExtendedString;
  Handle_TColStd_HSequenceOfHExtendedString_1: typeof Handle_TColStd_HSequenceOfHExtendedString_1;
  Handle_TColStd_HSequenceOfHExtendedString_2: typeof Handle_TColStd_HSequenceOfHExtendedString_2;
  Handle_TColStd_HSequenceOfHExtendedString_3: typeof Handle_TColStd_HSequenceOfHExtendedString_3;
  Handle_TColStd_HSequenceOfHExtendedString_4: typeof Handle_TColStd_HSequenceOfHExtendedString_4;
  Handle_TColStd_HSequenceOfTransient: typeof Handle_TColStd_HSequenceOfTransient;
  Handle_TColStd_HSequenceOfTransient_1: typeof Handle_TColStd_HSequenceOfTransient_1;
  Handle_TColStd_HSequenceOfTransient_2: typeof Handle_TColStd_HSequenceOfTransient_2;
  Handle_TColStd_HSequenceOfTransient_3: typeof Handle_TColStd_HSequenceOfTransient_3;
  Handle_TColStd_HSequenceOfTransient_4: typeof Handle_TColStd_HSequenceOfTransient_4;
  TColStd_MapRealHasher: typeof TColStd_MapRealHasher;
  TColStd_MapOfInteger: typeof TColStd_MapOfInteger;
  TColStd_MapOfInteger_1: typeof TColStd_MapOfInteger_1;
  TColStd_MapOfInteger_2: typeof TColStd_MapOfInteger_2;
  TColStd_MapOfInteger_3: typeof TColStd_MapOfInteger_3;
  TColStd_DataMapOfIntegerInteger: typeof TColStd_DataMapOfIntegerInteger;
  TColStd_DataMapOfIntegerInteger_1: typeof TColStd_DataMapOfIntegerInteger_1;
  TColStd_DataMapOfIntegerInteger_2: typeof TColStd_DataMapOfIntegerInteger_2;
  TColStd_DataMapOfIntegerInteger_3: typeof TColStd_DataMapOfIntegerInteger_3;
  TColStd_IndexedMapOfReal: typeof TColStd_IndexedMapOfReal;
  TColStd_IndexedMapOfReal_1: typeof TColStd_IndexedMapOfReal_1;
  TColStd_IndexedMapOfReal_2: typeof TColStd_IndexedMapOfReal_2;
  TColStd_IndexedMapOfReal_3: typeof TColStd_IndexedMapOfReal_3;
  TColStd_Array1OfExtendedString: typeof TColStd_Array1OfExtendedString;
  TColStd_Array1OfExtendedString_1: typeof TColStd_Array1OfExtendedString_1;
  TColStd_Array1OfExtendedString_2: typeof TColStd_Array1OfExtendedString_2;
  TColStd_Array1OfExtendedString_3: typeof TColStd_Array1OfExtendedString_3;
  TColStd_Array1OfExtendedString_4: typeof TColStd_Array1OfExtendedString_4;
  TColStd_Array1OfExtendedString_5: typeof TColStd_Array1OfExtendedString_5;
  Handle_TColStd_HSequenceOfExtendedString: typeof Handle_TColStd_HSequenceOfExtendedString;
  Handle_TColStd_HSequenceOfExtendedString_1: typeof Handle_TColStd_HSequenceOfExtendedString_1;
  Handle_TColStd_HSequenceOfExtendedString_2: typeof Handle_TColStd_HSequenceOfExtendedString_2;
  Handle_TColStd_HSequenceOfExtendedString_3: typeof Handle_TColStd_HSequenceOfExtendedString_3;
  Handle_TColStd_HSequenceOfExtendedString_4: typeof Handle_TColStd_HSequenceOfExtendedString_4;
  TColStd_SequenceOfExtendedString: typeof TColStd_SequenceOfExtendedString;
  TColStd_SequenceOfExtendedString_1: typeof TColStd_SequenceOfExtendedString_1;
  TColStd_SequenceOfExtendedString_2: typeof TColStd_SequenceOfExtendedString_2;
  TColStd_SequenceOfExtendedString_3: typeof TColStd_SequenceOfExtendedString_3;
  TColStd_Array1OfBoolean: typeof TColStd_Array1OfBoolean;
  TColStd_Array1OfBoolean_1: typeof TColStd_Array1OfBoolean_1;
  TColStd_Array1OfBoolean_2: typeof TColStd_Array1OfBoolean_2;
  TColStd_Array1OfBoolean_3: typeof TColStd_Array1OfBoolean_3;
  TColStd_Array1OfBoolean_4: typeof TColStd_Array1OfBoolean_4;
  TColStd_Array1OfBoolean_5: typeof TColStd_Array1OfBoolean_5;
  TColStd_SequenceOfBoolean: typeof TColStd_SequenceOfBoolean;
  TColStd_SequenceOfBoolean_1: typeof TColStd_SequenceOfBoolean_1;
  TColStd_SequenceOfBoolean_2: typeof TColStd_SequenceOfBoolean_2;
  TColStd_SequenceOfBoolean_3: typeof TColStd_SequenceOfBoolean_3;
  Handle_TColStd_HArray2OfInteger: typeof Handle_TColStd_HArray2OfInteger;
  Handle_TColStd_HArray2OfInteger_1: typeof Handle_TColStd_HArray2OfInteger_1;
  Handle_TColStd_HArray2OfInteger_2: typeof Handle_TColStd_HArray2OfInteger_2;
  Handle_TColStd_HArray2OfInteger_3: typeof Handle_TColStd_HArray2OfInteger_3;
  Handle_TColStd_HArray2OfInteger_4: typeof Handle_TColStd_HArray2OfInteger_4;
  Handle_TColStd_HArray1OfByte: typeof Handle_TColStd_HArray1OfByte;
  Handle_TColStd_HArray1OfByte_1: typeof Handle_TColStd_HArray1OfByte_1;
  Handle_TColStd_HArray1OfByte_2: typeof Handle_TColStd_HArray1OfByte_2;
  Handle_TColStd_HArray1OfByte_3: typeof Handle_TColStd_HArray1OfByte_3;
  Handle_TColStd_HArray1OfByte_4: typeof Handle_TColStd_HArray1OfByte_4;
  Handle_TColStd_HArray1OfExtendedString: typeof Handle_TColStd_HArray1OfExtendedString;
  Handle_TColStd_HArray1OfExtendedString_1: typeof Handle_TColStd_HArray1OfExtendedString_1;
  Handle_TColStd_HArray1OfExtendedString_2: typeof Handle_TColStd_HArray1OfExtendedString_2;
  Handle_TColStd_HArray1OfExtendedString_3: typeof Handle_TColStd_HArray1OfExtendedString_3;
  Handle_TColStd_HArray1OfExtendedString_4: typeof Handle_TColStd_HArray1OfExtendedString_4;
  TColStd_Array1OfInteger: typeof TColStd_Array1OfInteger;
  TColStd_Array1OfInteger_1: typeof TColStd_Array1OfInteger_1;
  TColStd_Array1OfInteger_2: typeof TColStd_Array1OfInteger_2;
  TColStd_Array1OfInteger_3: typeof TColStd_Array1OfInteger_3;
  TColStd_Array1OfInteger_4: typeof TColStd_Array1OfInteger_4;
  TColStd_Array1OfInteger_5: typeof TColStd_Array1OfInteger_5;
  TColStd_SequenceOfAddress: typeof TColStd_SequenceOfAddress;
  TColStd_SequenceOfAddress_1: typeof TColStd_SequenceOfAddress_1;
  TColStd_SequenceOfAddress_2: typeof TColStd_SequenceOfAddress_2;
  TColStd_SequenceOfAddress_3: typeof TColStd_SequenceOfAddress_3;
  Handle_TColStd_HSequenceOfReal: typeof Handle_TColStd_HSequenceOfReal;
  Handle_TColStd_HSequenceOfReal_1: typeof Handle_TColStd_HSequenceOfReal_1;
  Handle_TColStd_HSequenceOfReal_2: typeof Handle_TColStd_HSequenceOfReal_2;
  Handle_TColStd_HSequenceOfReal_3: typeof Handle_TColStd_HSequenceOfReal_3;
  Handle_TColStd_HSequenceOfReal_4: typeof Handle_TColStd_HSequenceOfReal_4;
  TColStd_DataMapOfStringInteger: typeof TColStd_DataMapOfStringInteger;
  TColStd_DataMapOfStringInteger_1: typeof TColStd_DataMapOfStringInteger_1;
  TColStd_DataMapOfStringInteger_2: typeof TColStd_DataMapOfStringInteger_2;
  TColStd_DataMapOfStringInteger_3: typeof TColStd_DataMapOfStringInteger_3;
  TColStd_Array1OfByte: typeof TColStd_Array1OfByte;
  TColStd_Array1OfByte_1: typeof TColStd_Array1OfByte_1;
  TColStd_Array1OfByte_2: typeof TColStd_Array1OfByte_2;
  TColStd_Array1OfByte_3: typeof TColStd_Array1OfByte_3;
  TColStd_Array1OfByte_4: typeof TColStd_Array1OfByte_4;
  TColStd_Array1OfByte_5: typeof TColStd_Array1OfByte_5;
  TColStd_MapOfAsciiString: typeof TColStd_MapOfAsciiString;
  TColStd_MapOfAsciiString_1: typeof TColStd_MapOfAsciiString_1;
  TColStd_MapOfAsciiString_2: typeof TColStd_MapOfAsciiString_2;
  TColStd_MapOfAsciiString_3: typeof TColStd_MapOfAsciiString_3;
  TColStd_PackedMapOfInteger: typeof TColStd_PackedMapOfInteger;
  TColStd_PackedMapOfInteger_1: typeof TColStd_PackedMapOfInteger_1;
  TColStd_PackedMapOfInteger_2: typeof TColStd_PackedMapOfInteger_2;
  TColStd_Array1OfListOfInteger: typeof TColStd_Array1OfListOfInteger;
  TColStd_Array1OfListOfInteger_1: typeof TColStd_Array1OfListOfInteger_1;
  TColStd_Array1OfListOfInteger_2: typeof TColStd_Array1OfListOfInteger_2;
  TColStd_Array1OfListOfInteger_3: typeof TColStd_Array1OfListOfInteger_3;
  TColStd_Array1OfListOfInteger_4: typeof TColStd_Array1OfListOfInteger_4;
  TColStd_Array1OfListOfInteger_5: typeof TColStd_Array1OfListOfInteger_5;
  Handle_TColStd_HArray2OfTransient: typeof Handle_TColStd_HArray2OfTransient;
  Handle_TColStd_HArray2OfTransient_1: typeof Handle_TColStd_HArray2OfTransient_1;
  Handle_TColStd_HArray2OfTransient_2: typeof Handle_TColStd_HArray2OfTransient_2;
  Handle_TColStd_HArray2OfTransient_3: typeof Handle_TColStd_HArray2OfTransient_3;
  Handle_TColStd_HArray2OfTransient_4: typeof Handle_TColStd_HArray2OfTransient_4;
  Handle_TColStd_HArray2OfReal: typeof Handle_TColStd_HArray2OfReal;
  Handle_TColStd_HArray2OfReal_1: typeof Handle_TColStd_HArray2OfReal_1;
  Handle_TColStd_HArray2OfReal_2: typeof Handle_TColStd_HArray2OfReal_2;
  Handle_TColStd_HArray2OfReal_3: typeof Handle_TColStd_HArray2OfReal_3;
  Handle_TColStd_HArray2OfReal_4: typeof Handle_TColStd_HArray2OfReal_4;
  TColStd_Array2OfReal: typeof TColStd_Array2OfReal;
  TColStd_Array2OfReal_1: typeof TColStd_Array2OfReal_1;
  TColStd_Array2OfReal_2: typeof TColStd_Array2OfReal_2;
  TColStd_Array2OfReal_3: typeof TColStd_Array2OfReal_3;
  TColStd_Array2OfReal_4: typeof TColStd_Array2OfReal_4;
  TColStd_Array2OfReal_5: typeof TColStd_Array2OfReal_5;
  Handle_TColStd_HArray1OfCharacter: typeof Handle_TColStd_HArray1OfCharacter;
  Handle_TColStd_HArray1OfCharacter_1: typeof Handle_TColStd_HArray1OfCharacter_1;
  Handle_TColStd_HArray1OfCharacter_2: typeof Handle_TColStd_HArray1OfCharacter_2;
  Handle_TColStd_HArray1OfCharacter_3: typeof Handle_TColStd_HArray1OfCharacter_3;
  Handle_TColStd_HArray1OfCharacter_4: typeof Handle_TColStd_HArray1OfCharacter_4;
  TColStd_SequenceOfAsciiString: typeof TColStd_SequenceOfAsciiString;
  TColStd_SequenceOfAsciiString_1: typeof TColStd_SequenceOfAsciiString_1;
  TColStd_SequenceOfAsciiString_2: typeof TColStd_SequenceOfAsciiString_2;
  TColStd_SequenceOfAsciiString_3: typeof TColStd_SequenceOfAsciiString_3;
  TColStd_DataMapOfIntegerListOfInteger: typeof TColStd_DataMapOfIntegerListOfInteger;
  TColStd_DataMapOfIntegerListOfInteger_1: typeof TColStd_DataMapOfIntegerListOfInteger_1;
  TColStd_DataMapOfIntegerListOfInteger_2: typeof TColStd_DataMapOfIntegerListOfInteger_2;
  TColStd_DataMapOfIntegerListOfInteger_3: typeof TColStd_DataMapOfIntegerListOfInteger_3;
  Handle_TColStd_HArray2OfBoolean: typeof Handle_TColStd_HArray2OfBoolean;
  Handle_TColStd_HArray2OfBoolean_1: typeof Handle_TColStd_HArray2OfBoolean_1;
  Handle_TColStd_HArray2OfBoolean_2: typeof Handle_TColStd_HArray2OfBoolean_2;
  Handle_TColStd_HArray2OfBoolean_3: typeof Handle_TColStd_HArray2OfBoolean_3;
  Handle_TColStd_HArray2OfBoolean_4: typeof Handle_TColStd_HArray2OfBoolean_4;
  Handle_TColStd_HArray1OfInteger: typeof Handle_TColStd_HArray1OfInteger;
  Handle_TColStd_HArray1OfInteger_1: typeof Handle_TColStd_HArray1OfInteger_1;
  Handle_TColStd_HArray1OfInteger_2: typeof Handle_TColStd_HArray1OfInteger_2;
  Handle_TColStd_HArray1OfInteger_3: typeof Handle_TColStd_HArray1OfInteger_3;
  Handle_TColStd_HArray1OfInteger_4: typeof Handle_TColStd_HArray1OfInteger_4;
  TColStd_DataMapOfAsciiStringInteger: typeof TColStd_DataMapOfAsciiStringInteger;
  TColStd_DataMapOfAsciiStringInteger_1: typeof TColStd_DataMapOfAsciiStringInteger_1;
  TColStd_DataMapOfAsciiStringInteger_2: typeof TColStd_DataMapOfAsciiStringInteger_2;
  TColStd_DataMapOfAsciiStringInteger_3: typeof TColStd_DataMapOfAsciiStringInteger_3;
  TColStd_ListOfInteger: typeof TColStd_ListOfInteger;
  TColStd_ListOfInteger_1: typeof TColStd_ListOfInteger_1;
  TColStd_ListOfInteger_2: typeof TColStd_ListOfInteger_2;
  TColStd_ListOfInteger_3: typeof TColStd_ListOfInteger_3;
  TColStd_ListOfAsciiString: typeof TColStd_ListOfAsciiString;
  TColStd_ListOfAsciiString_1: typeof TColStd_ListOfAsciiString_1;
  TColStd_ListOfAsciiString_2: typeof TColStd_ListOfAsciiString_2;
  TColStd_ListOfAsciiString_3: typeof TColStd_ListOfAsciiString_3;
  TColStd_SequenceOfReal: typeof TColStd_SequenceOfReal;
  TColStd_SequenceOfReal_1: typeof TColStd_SequenceOfReal_1;
  TColStd_SequenceOfReal_2: typeof TColStd_SequenceOfReal_2;
  TColStd_SequenceOfReal_3: typeof TColStd_SequenceOfReal_3;
  Handle_TColStd_HArray2OfCharacter: typeof Handle_TColStd_HArray2OfCharacter;
  Handle_TColStd_HArray2OfCharacter_1: typeof Handle_TColStd_HArray2OfCharacter_1;
  Handle_TColStd_HArray2OfCharacter_2: typeof Handle_TColStd_HArray2OfCharacter_2;
  Handle_TColStd_HArray2OfCharacter_3: typeof Handle_TColStd_HArray2OfCharacter_3;
  Handle_TColStd_HArray2OfCharacter_4: typeof Handle_TColStd_HArray2OfCharacter_4;
  TColStd_Array1OfAsciiString: typeof TColStd_Array1OfAsciiString;
  TColStd_Array1OfAsciiString_1: typeof TColStd_Array1OfAsciiString_1;
  TColStd_Array1OfAsciiString_2: typeof TColStd_Array1OfAsciiString_2;
  TColStd_Array1OfAsciiString_3: typeof TColStd_Array1OfAsciiString_3;
  TColStd_Array1OfAsciiString_4: typeof TColStd_Array1OfAsciiString_4;
  TColStd_Array1OfAsciiString_5: typeof TColStd_Array1OfAsciiString_5;
  Handle_TColStd_HSequenceOfAsciiString: typeof Handle_TColStd_HSequenceOfAsciiString;
  Handle_TColStd_HSequenceOfAsciiString_1: typeof Handle_TColStd_HSequenceOfAsciiString_1;
  Handle_TColStd_HSequenceOfAsciiString_2: typeof Handle_TColStd_HSequenceOfAsciiString_2;
  Handle_TColStd_HSequenceOfAsciiString_3: typeof Handle_TColStd_HSequenceOfAsciiString_3;
  Handle_TColStd_HSequenceOfAsciiString_4: typeof Handle_TColStd_HSequenceOfAsciiString_4;
  TColStd_IndexedDataMapOfStringString: typeof TColStd_IndexedDataMapOfStringString;
  TColStd_IndexedDataMapOfStringString_1: typeof TColStd_IndexedDataMapOfStringString_1;
  TColStd_IndexedDataMapOfStringString_2: typeof TColStd_IndexedDataMapOfStringString_2;
  TColStd_IndexedDataMapOfStringString_3: typeof TColStd_IndexedDataMapOfStringString_3;
  Handle_TColStd_HArray1OfAsciiString: typeof Handle_TColStd_HArray1OfAsciiString;
  Handle_TColStd_HArray1OfAsciiString_1: typeof Handle_TColStd_HArray1OfAsciiString_1;
  Handle_TColStd_HArray1OfAsciiString_2: typeof Handle_TColStd_HArray1OfAsciiString_2;
  Handle_TColStd_HArray1OfAsciiString_3: typeof Handle_TColStd_HArray1OfAsciiString_3;
  Handle_TColStd_HArray1OfAsciiString_4: typeof Handle_TColStd_HArray1OfAsciiString_4;
  TColStd_HPackedMapOfInteger: typeof TColStd_HPackedMapOfInteger;
  TColStd_HPackedMapOfInteger_1: typeof TColStd_HPackedMapOfInteger_1;
  TColStd_HPackedMapOfInteger_2: typeof TColStd_HPackedMapOfInteger_2;
  Handle_TColStd_HPackedMapOfInteger: typeof Handle_TColStd_HPackedMapOfInteger;
  Handle_TColStd_HPackedMapOfInteger_1: typeof Handle_TColStd_HPackedMapOfInteger_1;
  Handle_TColStd_HPackedMapOfInteger_2: typeof Handle_TColStd_HPackedMapOfInteger_2;
  Handle_TColStd_HPackedMapOfInteger_3: typeof Handle_TColStd_HPackedMapOfInteger_3;
  Handle_TColStd_HPackedMapOfInteger_4: typeof Handle_TColStd_HPackedMapOfInteger_4;
  Handle_TColStd_HArray1OfListOfInteger: typeof Handle_TColStd_HArray1OfListOfInteger;
  Handle_TColStd_HArray1OfListOfInteger_1: typeof Handle_TColStd_HArray1OfListOfInteger_1;
  Handle_TColStd_HArray1OfListOfInteger_2: typeof Handle_TColStd_HArray1OfListOfInteger_2;
  Handle_TColStd_HArray1OfListOfInteger_3: typeof Handle_TColStd_HArray1OfListOfInteger_3;
  Handle_TColStd_HArray1OfListOfInteger_4: typeof Handle_TColStd_HArray1OfListOfInteger_4;
  TColStd_IndexedMapOfInteger: typeof TColStd_IndexedMapOfInteger;
  TColStd_IndexedMapOfInteger_1: typeof TColStd_IndexedMapOfInteger_1;
  TColStd_IndexedMapOfInteger_2: typeof TColStd_IndexedMapOfInteger_2;
  TColStd_IndexedMapOfInteger_3: typeof TColStd_IndexedMapOfInteger_3;
  TColStd_Array1OfCharacter: typeof TColStd_Array1OfCharacter;
  TColStd_Array1OfCharacter_1: typeof TColStd_Array1OfCharacter_1;
  TColStd_Array1OfCharacter_2: typeof TColStd_Array1OfCharacter_2;
  TColStd_Array1OfCharacter_3: typeof TColStd_Array1OfCharacter_3;
  TColStd_Array1OfCharacter_4: typeof TColStd_Array1OfCharacter_4;
  TColStd_Array1OfCharacter_5: typeof TColStd_Array1OfCharacter_5;
  Handle_TColStd_HSequenceOfInteger: typeof Handle_TColStd_HSequenceOfInteger;
  Handle_TColStd_HSequenceOfInteger_1: typeof Handle_TColStd_HSequenceOfInteger_1;
  Handle_TColStd_HSequenceOfInteger_2: typeof Handle_TColStd_HSequenceOfInteger_2;
  Handle_TColStd_HSequenceOfInteger_3: typeof Handle_TColStd_HSequenceOfInteger_3;
  Handle_TColStd_HSequenceOfInteger_4: typeof Handle_TColStd_HSequenceOfInteger_4;
  Handle_TColStd_HArray1OfTransient: typeof Handle_TColStd_HArray1OfTransient;
  Handle_TColStd_HArray1OfTransient_1: typeof Handle_TColStd_HArray1OfTransient_1;
  Handle_TColStd_HArray1OfTransient_2: typeof Handle_TColStd_HArray1OfTransient_2;
  Handle_TColStd_HArray1OfTransient_3: typeof Handle_TColStd_HArray1OfTransient_3;
  Handle_TColStd_HArray1OfTransient_4: typeof Handle_TColStd_HArray1OfTransient_4;
  TColStd_ListOfReal: typeof TColStd_ListOfReal;
  TColStd_ListOfReal_1: typeof TColStd_ListOfReal_1;
  TColStd_ListOfReal_2: typeof TColStd_ListOfReal_2;
  TColStd_ListOfReal_3: typeof TColStd_ListOfReal_3;
  Handle_TColStd_HSequenceOfHAsciiString: typeof Handle_TColStd_HSequenceOfHAsciiString;
  Handle_TColStd_HSequenceOfHAsciiString_1: typeof Handle_TColStd_HSequenceOfHAsciiString_1;
  Handle_TColStd_HSequenceOfHAsciiString_2: typeof Handle_TColStd_HSequenceOfHAsciiString_2;
  Handle_TColStd_HSequenceOfHAsciiString_3: typeof Handle_TColStd_HSequenceOfHAsciiString_3;
  Handle_TColStd_HSequenceOfHAsciiString_4: typeof Handle_TColStd_HSequenceOfHAsciiString_4;
  TColStd_Array2OfBoolean: typeof TColStd_Array2OfBoolean;
  TColStd_Array2OfBoolean_1: typeof TColStd_Array2OfBoolean_1;
  TColStd_Array2OfBoolean_2: typeof TColStd_Array2OfBoolean_2;
  TColStd_Array2OfBoolean_3: typeof TColStd_Array2OfBoolean_3;
  TColStd_Array2OfBoolean_4: typeof TColStd_Array2OfBoolean_4;
  TColStd_Array2OfBoolean_5: typeof TColStd_Array2OfBoolean_5;
  TColStd_Array2OfInteger: typeof TColStd_Array2OfInteger;
  TColStd_Array2OfInteger_1: typeof TColStd_Array2OfInteger_1;
  TColStd_Array2OfInteger_2: typeof TColStd_Array2OfInteger_2;
  TColStd_Array2OfInteger_3: typeof TColStd_Array2OfInteger_3;
  TColStd_Array2OfInteger_4: typeof TColStd_Array2OfInteger_4;
  TColStd_Array2OfInteger_5: typeof TColStd_Array2OfInteger_5;
  TColStd_MapOfReal: typeof TColStd_MapOfReal;
  TColStd_MapOfReal_1: typeof TColStd_MapOfReal_1;
  TColStd_MapOfReal_2: typeof TColStd_MapOfReal_2;
  TColStd_MapOfReal_3: typeof TColStd_MapOfReal_3;
  Handle_TColStd_HArray1OfBoolean: typeof Handle_TColStd_HArray1OfBoolean;
  Handle_TColStd_HArray1OfBoolean_1: typeof Handle_TColStd_HArray1OfBoolean_1;
  Handle_TColStd_HArray1OfBoolean_2: typeof Handle_TColStd_HArray1OfBoolean_2;
  Handle_TColStd_HArray1OfBoolean_3: typeof Handle_TColStd_HArray1OfBoolean_3;
  Handle_TColStd_HArray1OfBoolean_4: typeof Handle_TColStd_HArray1OfBoolean_4;
  TColStd_Array1OfReal: typeof TColStd_Array1OfReal;
  TColStd_Array1OfReal_1: typeof TColStd_Array1OfReal_1;
  TColStd_Array1OfReal_2: typeof TColStd_Array1OfReal_2;
  TColStd_Array1OfReal_3: typeof TColStd_Array1OfReal_3;
  TColStd_Array1OfReal_4: typeof TColStd_Array1OfReal_4;
  TColStd_Array1OfReal_5: typeof TColStd_Array1OfReal_5;
  Handle_TColStd_HArray1OfReal: typeof Handle_TColStd_HArray1OfReal;
  Handle_TColStd_HArray1OfReal_1: typeof Handle_TColStd_HArray1OfReal_1;
  Handle_TColStd_HArray1OfReal_2: typeof Handle_TColStd_HArray1OfReal_2;
  Handle_TColStd_HArray1OfReal_3: typeof Handle_TColStd_HArray1OfReal_3;
  Handle_TColStd_HArray1OfReal_4: typeof Handle_TColStd_HArray1OfReal_4;
  TColStd_SequenceOfInteger: typeof TColStd_SequenceOfInteger;
  TColStd_SequenceOfInteger_1: typeof TColStd_SequenceOfInteger_1;
  TColStd_SequenceOfInteger_2: typeof TColStd_SequenceOfInteger_2;
  TColStd_SequenceOfInteger_3: typeof TColStd_SequenceOfInteger_3;
  TColStd_DataMapOfIntegerReal: typeof TColStd_DataMapOfIntegerReal;
  TColStd_DataMapOfIntegerReal_1: typeof TColStd_DataMapOfIntegerReal_1;
  TColStd_DataMapOfIntegerReal_2: typeof TColStd_DataMapOfIntegerReal_2;
  TColStd_DataMapOfIntegerReal_3: typeof TColStd_DataMapOfIntegerReal_3;
  TColStd_Array2OfCharacter: typeof TColStd_Array2OfCharacter;
  TColStd_Array2OfCharacter_1: typeof TColStd_Array2OfCharacter_1;
  TColStd_Array2OfCharacter_2: typeof TColStd_Array2OfCharacter_2;
  TColStd_Array2OfCharacter_3: typeof TColStd_Array2OfCharacter_3;
  TColStd_Array2OfCharacter_4: typeof TColStd_Array2OfCharacter_4;
  TColStd_Array2OfCharacter_5: typeof TColStd_Array2OfCharacter_5;
  TColStd_MapIntegerHasher: typeof TColStd_MapIntegerHasher;
  Aspect_Touch: typeof Aspect_Touch;
  Aspect_Touch_1: typeof Aspect_Touch_1;
  Aspect_Touch_2: typeof Aspect_Touch_2;
  Aspect_Touch_3: typeof Aspect_Touch_3;
  Aspect_GridType: Aspect_GridType;
  Aspect_XRHapticActionData: typeof Aspect_XRHapticActionData;
  Aspect_DisplayConnectionDefinitionError: typeof Aspect_DisplayConnectionDefinitionError;
  Aspect_DisplayConnectionDefinitionError_1: typeof Aspect_DisplayConnectionDefinitionError_1;
  Aspect_DisplayConnectionDefinitionError_2: typeof Aspect_DisplayConnectionDefinitionError_2;
  Handle_Aspect_DisplayConnectionDefinitionError: typeof Handle_Aspect_DisplayConnectionDefinitionError;
  Handle_Aspect_DisplayConnectionDefinitionError_1: typeof Handle_Aspect_DisplayConnectionDefinitionError_1;
  Handle_Aspect_DisplayConnectionDefinitionError_2: typeof Handle_Aspect_DisplayConnectionDefinitionError_2;
  Handle_Aspect_DisplayConnectionDefinitionError_3: typeof Handle_Aspect_DisplayConnectionDefinitionError_3;
  Handle_Aspect_DisplayConnectionDefinitionError_4: typeof Handle_Aspect_DisplayConnectionDefinitionError_4;
  Aspect_GridDrawMode: Aspect_GridDrawMode;
  Aspect_XRDigitalActionData: typeof Aspect_XRDigitalActionData;
  Aspect_TypeOfHighlightMethod: Aspect_TypeOfHighlightMethod;
  Aspect_Background: typeof Aspect_Background;
  Aspect_Background_1: typeof Aspect_Background_1;
  Aspect_Background_2: typeof Aspect_Background_2;
  Aspect_TrackedDevicePoseArray: typeof Aspect_TrackedDevicePoseArray;
  Aspect_TrackedDevicePoseArray_1: typeof Aspect_TrackedDevicePoseArray_1;
  Aspect_TrackedDevicePoseArray_2: typeof Aspect_TrackedDevicePoseArray_2;
  Aspect_TrackedDevicePoseArray_3: typeof Aspect_TrackedDevicePoseArray_3;
  Aspect_TrackedDevicePoseArray_4: typeof Aspect_TrackedDevicePoseArray_4;
  Aspect_TrackedDevicePoseArray_5: typeof Aspect_TrackedDevicePoseArray_5;
  Aspect_TrackedDevicePose: typeof Aspect_TrackedDevicePose;
  Aspect_GraphicsLibrary: Aspect_GraphicsLibrary;
  Aspect_AspectFillAreaDefinitionError: typeof Aspect_AspectFillAreaDefinitionError;
  Aspect_AspectFillAreaDefinitionError_1: typeof Aspect_AspectFillAreaDefinitionError_1;
  Aspect_AspectFillAreaDefinitionError_2: typeof Aspect_AspectFillAreaDefinitionError_2;
  Handle_Aspect_AspectFillAreaDefinitionError: typeof Handle_Aspect_AspectFillAreaDefinitionError;
  Handle_Aspect_AspectFillAreaDefinitionError_1: typeof Handle_Aspect_AspectFillAreaDefinitionError_1;
  Handle_Aspect_AspectFillAreaDefinitionError_2: typeof Handle_Aspect_AspectFillAreaDefinitionError_2;
  Handle_Aspect_AspectFillAreaDefinitionError_3: typeof Handle_Aspect_AspectFillAreaDefinitionError_3;
  Handle_Aspect_AspectFillAreaDefinitionError_4: typeof Handle_Aspect_AspectFillAreaDefinitionError_4;
  Aspect_SequenceOfColor: typeof Aspect_SequenceOfColor;
  Aspect_SequenceOfColor_1: typeof Aspect_SequenceOfColor_1;
  Aspect_SequenceOfColor_2: typeof Aspect_SequenceOfColor_2;
  Aspect_SequenceOfColor_3: typeof Aspect_SequenceOfColor_3;
  Handle_Aspect_DisplayConnection: typeof Handle_Aspect_DisplayConnection;
  Handle_Aspect_DisplayConnection_1: typeof Handle_Aspect_DisplayConnection_1;
  Handle_Aspect_DisplayConnection_2: typeof Handle_Aspect_DisplayConnection_2;
  Handle_Aspect_DisplayConnection_3: typeof Handle_Aspect_DisplayConnection_3;
  Handle_Aspect_DisplayConnection_4: typeof Handle_Aspect_DisplayConnection_4;
  Aspect_DisplayConnection: typeof Aspect_DisplayConnection;
  Aspect_GenId: typeof Aspect_GenId;
  Aspect_GenId_1: typeof Aspect_GenId_1;
  Aspect_GenId_2: typeof Aspect_GenId_2;
  Handle_Aspect_RectangularGrid: typeof Handle_Aspect_RectangularGrid;
  Handle_Aspect_RectangularGrid_1: typeof Handle_Aspect_RectangularGrid_1;
  Handle_Aspect_RectangularGrid_2: typeof Handle_Aspect_RectangularGrid_2;
  Handle_Aspect_RectangularGrid_3: typeof Handle_Aspect_RectangularGrid_3;
  Handle_Aspect_RectangularGrid_4: typeof Handle_Aspect_RectangularGrid_4;
  Aspect_RectangularGrid: typeof Aspect_RectangularGrid;
  Handle_Aspect_CircularGrid: typeof Handle_Aspect_CircularGrid;
  Handle_Aspect_CircularGrid_1: typeof Handle_Aspect_CircularGrid_1;
  Handle_Aspect_CircularGrid_2: typeof Handle_Aspect_CircularGrid_2;
  Handle_Aspect_CircularGrid_3: typeof Handle_Aspect_CircularGrid_3;
  Handle_Aspect_CircularGrid_4: typeof Handle_Aspect_CircularGrid_4;
  Aspect_CircularGrid: typeof Aspect_CircularGrid;
  Aspect_ScrollDelta: typeof Aspect_ScrollDelta;
  Aspect_ScrollDelta_1: typeof Aspect_ScrollDelta_1;
  Aspect_ScrollDelta_2: typeof Aspect_ScrollDelta_2;
  Aspect_ScrollDelta_3: typeof Aspect_ScrollDelta_3;
  Handle_Aspect_GraphicDeviceDefinitionError: typeof Handle_Aspect_GraphicDeviceDefinitionError;
  Handle_Aspect_GraphicDeviceDefinitionError_1: typeof Handle_Aspect_GraphicDeviceDefinitionError_1;
  Handle_Aspect_GraphicDeviceDefinitionError_2: typeof Handle_Aspect_GraphicDeviceDefinitionError_2;
  Handle_Aspect_GraphicDeviceDefinitionError_3: typeof Handle_Aspect_GraphicDeviceDefinitionError_3;
  Handle_Aspect_GraphicDeviceDefinitionError_4: typeof Handle_Aspect_GraphicDeviceDefinitionError_4;
  Aspect_GraphicDeviceDefinitionError: typeof Aspect_GraphicDeviceDefinitionError;
  Aspect_GraphicDeviceDefinitionError_1: typeof Aspect_GraphicDeviceDefinitionError_1;
  Aspect_GraphicDeviceDefinitionError_2: typeof Aspect_GraphicDeviceDefinitionError_2;
  Handle_Aspect_IdentDefinitionError: typeof Handle_Aspect_IdentDefinitionError;
  Handle_Aspect_IdentDefinitionError_1: typeof Handle_Aspect_IdentDefinitionError_1;
  Handle_Aspect_IdentDefinitionError_2: typeof Handle_Aspect_IdentDefinitionError_2;
  Handle_Aspect_IdentDefinitionError_3: typeof Handle_Aspect_IdentDefinitionError_3;
  Handle_Aspect_IdentDefinitionError_4: typeof Handle_Aspect_IdentDefinitionError_4;
  Aspect_IdentDefinitionError: typeof Aspect_IdentDefinitionError;
  Aspect_IdentDefinitionError_1: typeof Aspect_IdentDefinitionError_1;
  Aspect_IdentDefinitionError_2: typeof Aspect_IdentDefinitionError_2;
  Handle_Aspect_Grid: typeof Handle_Aspect_Grid;
  Handle_Aspect_Grid_1: typeof Handle_Aspect_Grid_1;
  Handle_Aspect_Grid_2: typeof Handle_Aspect_Grid_2;
  Handle_Aspect_Grid_3: typeof Handle_Aspect_Grid_3;
  Handle_Aspect_Grid_4: typeof Handle_Aspect_Grid_4;
  Aspect_Grid: typeof Aspect_Grid;
  Aspect_XRTrackedDeviceRole: Aspect_XRTrackedDeviceRole;
  Aspect_HatchStyle: Aspect_HatchStyle;
  Aspect_TypeOfColorScaleOrientation: Aspect_TypeOfColorScaleOrientation;
  Aspect_VKeySet: typeof Aspect_VKeySet;
  Aspect_WidthOfLine: Aspect_WidthOfLine;
  Aspect_TypeOfDeflection: Aspect_TypeOfDeflection;
  Aspect_XRGenericAction: Aspect_XRGenericAction;
  Aspect_XRActionType: Aspect_XRActionType;
  Aspect_XAtom: Aspect_XAtom;
  Aspect_VKeyBasic: Aspect_VKeyBasic;
  Handle_Aspect_Window: typeof Handle_Aspect_Window;
  Handle_Aspect_Window_1: typeof Handle_Aspect_Window_1;
  Handle_Aspect_Window_2: typeof Handle_Aspect_Window_2;
  Handle_Aspect_Window_3: typeof Handle_Aspect_Window_3;
  Handle_Aspect_Window_4: typeof Handle_Aspect_Window_4;
  Aspect_Window: typeof Aspect_Window;
  Aspect_TypeOfTriedronPosition: Aspect_TypeOfTriedronPosition;
  Aspect_XRAnalogActionData: typeof Aspect_XRAnalogActionData;
  Aspect_FillMethod: Aspect_FillMethod;
  Aspect_TypeOfColorScalePosition: Aspect_TypeOfColorScalePosition;
  Aspect_OpenVRSession: typeof Aspect_OpenVRSession;
  Aspect_XRSession: typeof Aspect_XRSession;
  Aspect_GradientBackground: typeof Aspect_GradientBackground;
  Aspect_GradientBackground_1: typeof Aspect_GradientBackground_1;
  Aspect_GradientBackground_2: typeof Aspect_GradientBackground_2;
  Handle_Aspect_WindowDefinitionError: typeof Handle_Aspect_WindowDefinitionError;
  Handle_Aspect_WindowDefinitionError_1: typeof Handle_Aspect_WindowDefinitionError_1;
  Handle_Aspect_WindowDefinitionError_2: typeof Handle_Aspect_WindowDefinitionError_2;
  Handle_Aspect_WindowDefinitionError_3: typeof Handle_Aspect_WindowDefinitionError_3;
  Handle_Aspect_WindowDefinitionError_4: typeof Handle_Aspect_WindowDefinitionError_4;
  Aspect_WindowDefinitionError: typeof Aspect_WindowDefinitionError;
  Aspect_WindowDefinitionError_1: typeof Aspect_WindowDefinitionError_1;
  Aspect_WindowDefinitionError_2: typeof Aspect_WindowDefinitionError_2;
  Aspect_TypeOfDisplayText: Aspect_TypeOfDisplayText;
  Handle_Aspect_NeutralWindow: typeof Handle_Aspect_NeutralWindow;
  Handle_Aspect_NeutralWindow_1: typeof Handle_Aspect_NeutralWindow_1;
  Handle_Aspect_NeutralWindow_2: typeof Handle_Aspect_NeutralWindow_2;
  Handle_Aspect_NeutralWindow_3: typeof Handle_Aspect_NeutralWindow_3;
  Handle_Aspect_NeutralWindow_4: typeof Handle_Aspect_NeutralWindow_4;
  Aspect_NeutralWindow: typeof Aspect_NeutralWindow;
  Aspect_InteriorStyle: Aspect_InteriorStyle;
  Aspect_GradientFillMethod: Aspect_GradientFillMethod;
  Aspect_AspectLineDefinitionError: typeof Aspect_AspectLineDefinitionError;
  Aspect_AspectLineDefinitionError_1: typeof Aspect_AspectLineDefinitionError_1;
  Aspect_AspectLineDefinitionError_2: typeof Aspect_AspectLineDefinitionError_2;
  Handle_Aspect_AspectLineDefinitionError: typeof Handle_Aspect_AspectLineDefinitionError;
  Handle_Aspect_AspectLineDefinitionError_1: typeof Handle_Aspect_AspectLineDefinitionError_1;
  Handle_Aspect_AspectLineDefinitionError_2: typeof Handle_Aspect_AspectLineDefinitionError_2;
  Handle_Aspect_AspectLineDefinitionError_3: typeof Handle_Aspect_AspectLineDefinitionError_3;
  Handle_Aspect_AspectLineDefinitionError_4: typeof Handle_Aspect_AspectLineDefinitionError_4;
  Aspect_TypeOfStyleText: Aspect_TypeOfStyleText;
  Aspect_ColorSpace: Aspect_ColorSpace;
  Aspect_XRPoseActionData: typeof Aspect_XRPoseActionData;
  Aspect_TypeOfFacingModel: Aspect_TypeOfFacingModel;
  Aspect_Eye: Aspect_Eye;
  Aspect_TypeOfColorScaleData: Aspect_TypeOfColorScaleData;
  Aspect_XRAction: typeof Aspect_XRAction;
  Aspect_AspectMarkerDefinitionError: typeof Aspect_AspectMarkerDefinitionError;
  Aspect_AspectMarkerDefinitionError_1: typeof Aspect_AspectMarkerDefinitionError_1;
  Aspect_AspectMarkerDefinitionError_2: typeof Aspect_AspectMarkerDefinitionError_2;
  Handle_Aspect_AspectMarkerDefinitionError: typeof Handle_Aspect_AspectMarkerDefinitionError;
  Handle_Aspect_AspectMarkerDefinitionError_1: typeof Handle_Aspect_AspectMarkerDefinitionError_1;
  Handle_Aspect_AspectMarkerDefinitionError_2: typeof Handle_Aspect_AspectMarkerDefinitionError_2;
  Handle_Aspect_AspectMarkerDefinitionError_3: typeof Handle_Aspect_AspectMarkerDefinitionError_3;
  Handle_Aspect_AspectMarkerDefinitionError_4: typeof Handle_Aspect_AspectMarkerDefinitionError_4;
  Aspect_TypeOfMarker: Aspect_TypeOfMarker;
  Aspect_TypeOfLine: Aspect_TypeOfLine;
  Aspect_TypeOfResize: Aspect_TypeOfResize;
  Handle_Aspect_WindowError: typeof Handle_Aspect_WindowError;
  Handle_Aspect_WindowError_1: typeof Handle_Aspect_WindowError_1;
  Handle_Aspect_WindowError_2: typeof Handle_Aspect_WindowError_2;
  Handle_Aspect_WindowError_3: typeof Handle_Aspect_WindowError_3;
  Handle_Aspect_WindowError_4: typeof Handle_Aspect_WindowError_4;
  Aspect_WindowError: typeof Aspect_WindowError;
  Aspect_WindowError_1: typeof Aspect_WindowError_1;
  Aspect_WindowError_2: typeof Aspect_WindowError_2;
  Aspect_XRActionSet: typeof Aspect_XRActionSet;
  Hatch_SequenceOfParameter: typeof Hatch_SequenceOfParameter;
  Hatch_SequenceOfParameter_1: typeof Hatch_SequenceOfParameter_1;
  Hatch_SequenceOfParameter_2: typeof Hatch_SequenceOfParameter_2;
  Hatch_SequenceOfParameter_3: typeof Hatch_SequenceOfParameter_3;
  Hatch_LineForm: Hatch_LineForm;
  Hatch_SequenceOfLine: typeof Hatch_SequenceOfLine;
  Hatch_SequenceOfLine_1: typeof Hatch_SequenceOfLine_1;
  Hatch_SequenceOfLine_2: typeof Hatch_SequenceOfLine_2;
  Hatch_SequenceOfLine_3: typeof Hatch_SequenceOfLine_3;
  Hatch_Parameter: typeof Hatch_Parameter;
  Hatch_Parameter_1: typeof Hatch_Parameter_1;
  Hatch_Parameter_2: typeof Hatch_Parameter_2;
  Hatch_Hatcher: typeof Hatch_Hatcher;
  Hatch_Line: typeof Hatch_Line;
  Hatch_Line_1: typeof Hatch_Line_1;
  Hatch_Line_2: typeof Hatch_Line_2;
  PrsDim_LengthDimension: typeof PrsDim_LengthDimension;
  PrsDim_LengthDimension_1: typeof PrsDim_LengthDimension_1;
  PrsDim_LengthDimension_2: typeof PrsDim_LengthDimension_2;
  PrsDim_LengthDimension_3: typeof PrsDim_LengthDimension_3;
  PrsDim_LengthDimension_4: typeof PrsDim_LengthDimension_4;
  PrsDim_LengthDimension_5: typeof PrsDim_LengthDimension_5;
  Handle_PrsDim_LengthDimension: typeof Handle_PrsDim_LengthDimension;
  Handle_PrsDim_LengthDimension_1: typeof Handle_PrsDim_LengthDimension_1;
  Handle_PrsDim_LengthDimension_2: typeof Handle_PrsDim_LengthDimension_2;
  Handle_PrsDim_LengthDimension_3: typeof Handle_PrsDim_LengthDimension_3;
  Handle_PrsDim_LengthDimension_4: typeof Handle_PrsDim_LengthDimension_4;
  PrsDim_KindOfSurface: PrsDim_KindOfSurface;
  PrsDim_KindOfRelation: PrsDim_KindOfRelation;
  PrsDim_AngleDimension: typeof PrsDim_AngleDimension;
  PrsDim_AngleDimension_1: typeof PrsDim_AngleDimension_1;
  PrsDim_AngleDimension_2: typeof PrsDim_AngleDimension_2;
  PrsDim_AngleDimension_3: typeof PrsDim_AngleDimension_3;
  PrsDim_AngleDimension_4: typeof PrsDim_AngleDimension_4;
  PrsDim_AngleDimension_5: typeof PrsDim_AngleDimension_5;
  PrsDim_AngleDimension_6: typeof PrsDim_AngleDimension_6;
  Handle_PrsDim_AngleDimension: typeof Handle_PrsDim_AngleDimension;
  Handle_PrsDim_AngleDimension_1: typeof Handle_PrsDim_AngleDimension_1;
  Handle_PrsDim_AngleDimension_2: typeof Handle_PrsDim_AngleDimension_2;
  Handle_PrsDim_AngleDimension_3: typeof Handle_PrsDim_AngleDimension_3;
  Handle_PrsDim_AngleDimension_4: typeof Handle_PrsDim_AngleDimension_4;
  PrsDim_DimensionSelectionMode: PrsDim_DimensionSelectionMode;
  Handle_PrsDim_MidPointRelation: typeof Handle_PrsDim_MidPointRelation;
  Handle_PrsDim_MidPointRelation_1: typeof Handle_PrsDim_MidPointRelation_1;
  Handle_PrsDim_MidPointRelation_2: typeof Handle_PrsDim_MidPointRelation_2;
  Handle_PrsDim_MidPointRelation_3: typeof Handle_PrsDim_MidPointRelation_3;
  Handle_PrsDim_MidPointRelation_4: typeof Handle_PrsDim_MidPointRelation_4;
  PrsDim_MidPointRelation: typeof PrsDim_MidPointRelation;
  Handle_PrsDim_DiameterDimension: typeof Handle_PrsDim_DiameterDimension;
  Handle_PrsDim_DiameterDimension_1: typeof Handle_PrsDim_DiameterDimension_1;
  Handle_PrsDim_DiameterDimension_2: typeof Handle_PrsDim_DiameterDimension_2;
  Handle_PrsDim_DiameterDimension_3: typeof Handle_PrsDim_DiameterDimension_3;
  Handle_PrsDim_DiameterDimension_4: typeof Handle_PrsDim_DiameterDimension_4;
  PrsDim_DiameterDimension: typeof PrsDim_DiameterDimension;
  PrsDim_DiameterDimension_1: typeof PrsDim_DiameterDimension_1;
  PrsDim_DiameterDimension_2: typeof PrsDim_DiameterDimension_2;
  PrsDim_DiameterDimension_3: typeof PrsDim_DiameterDimension_3;
  PrsDim_DiameterDimension_4: typeof PrsDim_DiameterDimension_4;
  PrsDim_OffsetDimension: typeof PrsDim_OffsetDimension;
  Handle_PrsDim_OffsetDimension: typeof Handle_PrsDim_OffsetDimension;
  Handle_PrsDim_OffsetDimension_1: typeof Handle_PrsDim_OffsetDimension_1;
  Handle_PrsDim_OffsetDimension_2: typeof Handle_PrsDim_OffsetDimension_2;
  Handle_PrsDim_OffsetDimension_3: typeof Handle_PrsDim_OffsetDimension_3;
  Handle_PrsDim_OffsetDimension_4: typeof Handle_PrsDim_OffsetDimension_4;
  PrsDim_MinRadiusDimension: typeof PrsDim_MinRadiusDimension;
  PrsDim_MinRadiusDimension_1: typeof PrsDim_MinRadiusDimension_1;
  PrsDim_MinRadiusDimension_2: typeof PrsDim_MinRadiusDimension_2;
  Handle_PrsDim_MinRadiusDimension: typeof Handle_PrsDim_MinRadiusDimension;
  Handle_PrsDim_MinRadiusDimension_1: typeof Handle_PrsDim_MinRadiusDimension_1;
  Handle_PrsDim_MinRadiusDimension_2: typeof Handle_PrsDim_MinRadiusDimension_2;
  Handle_PrsDim_MinRadiusDimension_3: typeof Handle_PrsDim_MinRadiusDimension_3;
  Handle_PrsDim_MinRadiusDimension_4: typeof Handle_PrsDim_MinRadiusDimension_4;
  PrsDim_EqualDistanceRelation: typeof PrsDim_EqualDistanceRelation;
  Handle_PrsDim_EqualDistanceRelation: typeof Handle_PrsDim_EqualDistanceRelation;
  Handle_PrsDim_EqualDistanceRelation_1: typeof Handle_PrsDim_EqualDistanceRelation_1;
  Handle_PrsDim_EqualDistanceRelation_2: typeof Handle_PrsDim_EqualDistanceRelation_2;
  Handle_PrsDim_EqualDistanceRelation_3: typeof Handle_PrsDim_EqualDistanceRelation_3;
  Handle_PrsDim_EqualDistanceRelation_4: typeof Handle_PrsDim_EqualDistanceRelation_4;
  Handle_PrsDim_Dimension: typeof Handle_PrsDim_Dimension;
  Handle_PrsDim_Dimension_1: typeof Handle_PrsDim_Dimension_1;
  Handle_PrsDim_Dimension_2: typeof Handle_PrsDim_Dimension_2;
  Handle_PrsDim_Dimension_3: typeof Handle_PrsDim_Dimension_3;
  Handle_PrsDim_Dimension_4: typeof Handle_PrsDim_Dimension_4;
  PrsDim_TypeOfAngleArrowVisibility: PrsDim_TypeOfAngleArrowVisibility;
  Handle_PrsDim_DimensionOwner: typeof Handle_PrsDim_DimensionOwner;
  Handle_PrsDim_DimensionOwner_1: typeof Handle_PrsDim_DimensionOwner_1;
  Handle_PrsDim_DimensionOwner_2: typeof Handle_PrsDim_DimensionOwner_2;
  Handle_PrsDim_DimensionOwner_3: typeof Handle_PrsDim_DimensionOwner_3;
  Handle_PrsDim_DimensionOwner_4: typeof Handle_PrsDim_DimensionOwner_4;
  PrsDim_DimensionOwner: typeof PrsDim_DimensionOwner;
  PrsDim_EllipseRadiusDimension: typeof PrsDim_EllipseRadiusDimension;
  Handle_PrsDim_EllipseRadiusDimension: typeof Handle_PrsDim_EllipseRadiusDimension;
  Handle_PrsDim_EllipseRadiusDimension_1: typeof Handle_PrsDim_EllipseRadiusDimension_1;
  Handle_PrsDim_EllipseRadiusDimension_2: typeof Handle_PrsDim_EllipseRadiusDimension_2;
  Handle_PrsDim_EllipseRadiusDimension_3: typeof Handle_PrsDim_EllipseRadiusDimension_3;
  Handle_PrsDim_EllipseRadiusDimension_4: typeof Handle_PrsDim_EllipseRadiusDimension_4;
  Handle_PrsDim_PerpendicularRelation: typeof Handle_PrsDim_PerpendicularRelation;
  Handle_PrsDim_PerpendicularRelation_1: typeof Handle_PrsDim_PerpendicularRelation_1;
  Handle_PrsDim_PerpendicularRelation_2: typeof Handle_PrsDim_PerpendicularRelation_2;
  Handle_PrsDim_PerpendicularRelation_3: typeof Handle_PrsDim_PerpendicularRelation_3;
  Handle_PrsDim_PerpendicularRelation_4: typeof Handle_PrsDim_PerpendicularRelation_4;
  PrsDim_PerpendicularRelation: typeof PrsDim_PerpendicularRelation;
  PrsDim_PerpendicularRelation_1: typeof PrsDim_PerpendicularRelation_1;
  PrsDim_PerpendicularRelation_2: typeof PrsDim_PerpendicularRelation_2;
  PrsDim_DisplaySpecialSymbol: PrsDim_DisplaySpecialSymbol;
  PrsDim_MaxRadiusDimension: typeof PrsDim_MaxRadiusDimension;
  PrsDim_MaxRadiusDimension_1: typeof PrsDim_MaxRadiusDimension_1;
  PrsDim_MaxRadiusDimension_2: typeof PrsDim_MaxRadiusDimension_2;
  Handle_PrsDim_MaxRadiusDimension: typeof Handle_PrsDim_MaxRadiusDimension;
  Handle_PrsDim_MaxRadiusDimension_1: typeof Handle_PrsDim_MaxRadiusDimension_1;
  Handle_PrsDim_MaxRadiusDimension_2: typeof Handle_PrsDim_MaxRadiusDimension_2;
  Handle_PrsDim_MaxRadiusDimension_3: typeof Handle_PrsDim_MaxRadiusDimension_3;
  Handle_PrsDim_MaxRadiusDimension_4: typeof Handle_PrsDim_MaxRadiusDimension_4;
  PrsDim_EqualRadiusRelation: typeof PrsDim_EqualRadiusRelation;
  Handle_PrsDim_EqualRadiusRelation: typeof Handle_PrsDim_EqualRadiusRelation;
  Handle_PrsDim_EqualRadiusRelation_1: typeof Handle_PrsDim_EqualRadiusRelation_1;
  Handle_PrsDim_EqualRadiusRelation_2: typeof Handle_PrsDim_EqualRadiusRelation_2;
  Handle_PrsDim_EqualRadiusRelation_3: typeof Handle_PrsDim_EqualRadiusRelation_3;
  Handle_PrsDim_EqualRadiusRelation_4: typeof Handle_PrsDim_EqualRadiusRelation_4;
  PrsDim_Chamf2dDimension: typeof PrsDim_Chamf2dDimension;
  PrsDim_Chamf2dDimension_1: typeof PrsDim_Chamf2dDimension_1;
  PrsDim_Chamf2dDimension_2: typeof PrsDim_Chamf2dDimension_2;
  Handle_PrsDim_Chamf2dDimension: typeof Handle_PrsDim_Chamf2dDimension;
  Handle_PrsDim_Chamf2dDimension_1: typeof Handle_PrsDim_Chamf2dDimension_1;
  Handle_PrsDim_Chamf2dDimension_2: typeof Handle_PrsDim_Chamf2dDimension_2;
  Handle_PrsDim_Chamf2dDimension_3: typeof Handle_PrsDim_Chamf2dDimension_3;
  Handle_PrsDim_Chamf2dDimension_4: typeof Handle_PrsDim_Chamf2dDimension_4;
  Handle_PrsDim_RadiusDimension: typeof Handle_PrsDim_RadiusDimension;
  Handle_PrsDim_RadiusDimension_1: typeof Handle_PrsDim_RadiusDimension_1;
  Handle_PrsDim_RadiusDimension_2: typeof Handle_PrsDim_RadiusDimension_2;
  Handle_PrsDim_RadiusDimension_3: typeof Handle_PrsDim_RadiusDimension_3;
  Handle_PrsDim_RadiusDimension_4: typeof Handle_PrsDim_RadiusDimension_4;
  PrsDim_RadiusDimension: typeof PrsDim_RadiusDimension;
  PrsDim_RadiusDimension_1: typeof PrsDim_RadiusDimension_1;
  PrsDim_RadiusDimension_2: typeof PrsDim_RadiusDimension_2;
  PrsDim_RadiusDimension_3: typeof PrsDim_RadiusDimension_3;
  Handle_PrsDim_ParallelRelation: typeof Handle_PrsDim_ParallelRelation;
  Handle_PrsDim_ParallelRelation_1: typeof Handle_PrsDim_ParallelRelation_1;
  Handle_PrsDim_ParallelRelation_2: typeof Handle_PrsDim_ParallelRelation_2;
  Handle_PrsDim_ParallelRelation_3: typeof Handle_PrsDim_ParallelRelation_3;
  Handle_PrsDim_ParallelRelation_4: typeof Handle_PrsDim_ParallelRelation_4;
  PrsDim_ParallelRelation: typeof PrsDim_ParallelRelation;
  PrsDim_ParallelRelation_1: typeof PrsDim_ParallelRelation_1;
  PrsDim_ParallelRelation_2: typeof PrsDim_ParallelRelation_2;
  PrsDim: typeof PrsDim;
  PrsDim_IdenticRelation: typeof PrsDim_IdenticRelation;
  Handle_PrsDim_IdenticRelation: typeof Handle_PrsDim_IdenticRelation;
  Handle_PrsDim_IdenticRelation_1: typeof Handle_PrsDim_IdenticRelation_1;
  Handle_PrsDim_IdenticRelation_2: typeof Handle_PrsDim_IdenticRelation_2;
  Handle_PrsDim_IdenticRelation_3: typeof Handle_PrsDim_IdenticRelation_3;
  Handle_PrsDim_IdenticRelation_4: typeof Handle_PrsDim_IdenticRelation_4;
  PrsDim_ConcentricRelation: typeof PrsDim_ConcentricRelation;
  Handle_PrsDim_ConcentricRelation: typeof Handle_PrsDim_ConcentricRelation;
  Handle_PrsDim_ConcentricRelation_1: typeof Handle_PrsDim_ConcentricRelation_1;
  Handle_PrsDim_ConcentricRelation_2: typeof Handle_PrsDim_ConcentricRelation_2;
  Handle_PrsDim_ConcentricRelation_3: typeof Handle_PrsDim_ConcentricRelation_3;
  Handle_PrsDim_ConcentricRelation_4: typeof Handle_PrsDim_ConcentricRelation_4;
  PrsDim_TypeOfAngle: PrsDim_TypeOfAngle;
  PrsDim_SymmetricRelation: typeof PrsDim_SymmetricRelation;
  Handle_PrsDim_SymmetricRelation: typeof Handle_PrsDim_SymmetricRelation;
  Handle_PrsDim_SymmetricRelation_1: typeof Handle_PrsDim_SymmetricRelation_1;
  Handle_PrsDim_SymmetricRelation_2: typeof Handle_PrsDim_SymmetricRelation_2;
  Handle_PrsDim_SymmetricRelation_3: typeof Handle_PrsDim_SymmetricRelation_3;
  Handle_PrsDim_SymmetricRelation_4: typeof Handle_PrsDim_SymmetricRelation_4;
  Handle_PrsDim_FixRelation: typeof Handle_PrsDim_FixRelation;
  Handle_PrsDim_FixRelation_1: typeof Handle_PrsDim_FixRelation_1;
  Handle_PrsDim_FixRelation_2: typeof Handle_PrsDim_FixRelation_2;
  Handle_PrsDim_FixRelation_3: typeof Handle_PrsDim_FixRelation_3;
  Handle_PrsDim_FixRelation_4: typeof Handle_PrsDim_FixRelation_4;
  PrsDim_FixRelation: typeof PrsDim_FixRelation;
  PrsDim_FixRelation_1: typeof PrsDim_FixRelation_1;
  PrsDim_FixRelation_2: typeof PrsDim_FixRelation_2;
  PrsDim_FixRelation_3: typeof PrsDim_FixRelation_3;
  PrsDim_FixRelation_4: typeof PrsDim_FixRelation_4;
  Handle_PrsDim_Chamf3dDimension: typeof Handle_PrsDim_Chamf3dDimension;
  Handle_PrsDim_Chamf3dDimension_1: typeof Handle_PrsDim_Chamf3dDimension_1;
  Handle_PrsDim_Chamf3dDimension_2: typeof Handle_PrsDim_Chamf3dDimension_2;
  Handle_PrsDim_Chamf3dDimension_3: typeof Handle_PrsDim_Chamf3dDimension_3;
  Handle_PrsDim_Chamf3dDimension_4: typeof Handle_PrsDim_Chamf3dDimension_4;
  PrsDim_Chamf3dDimension: typeof PrsDim_Chamf3dDimension;
  PrsDim_Chamf3dDimension_1: typeof PrsDim_Chamf3dDimension_1;
  PrsDim_Chamf3dDimension_2: typeof PrsDim_Chamf3dDimension_2;
  PrsDim_KindOfDimension: PrsDim_KindOfDimension;
  Handle_PrsDim_TangentRelation: typeof Handle_PrsDim_TangentRelation;
  Handle_PrsDim_TangentRelation_1: typeof Handle_PrsDim_TangentRelation_1;
  Handle_PrsDim_TangentRelation_2: typeof Handle_PrsDim_TangentRelation_2;
  Handle_PrsDim_TangentRelation_3: typeof Handle_PrsDim_TangentRelation_3;
  Handle_PrsDim_TangentRelation_4: typeof Handle_PrsDim_TangentRelation_4;
  PrsDim_TangentRelation: typeof PrsDim_TangentRelation;
  Handle_PrsDim_Relation: typeof Handle_PrsDim_Relation;
  Handle_PrsDim_Relation_1: typeof Handle_PrsDim_Relation_1;
  Handle_PrsDim_Relation_2: typeof Handle_PrsDim_Relation_2;
  Handle_PrsDim_Relation_3: typeof Handle_PrsDim_Relation_3;
  Handle_PrsDim_Relation_4: typeof Handle_PrsDim_Relation_4;
  PrsDim_Relation: typeof PrsDim_Relation;
  PrsDim_TypeOfDist: PrsDim_TypeOfDist;
  ElCLib: typeof ElCLib;
  BRepFeat_RibSlot: typeof BRepFeat_RibSlot;
  BRepFeat_SplitShape: typeof BRepFeat_SplitShape;
  BRepFeat_SplitShape_1: typeof BRepFeat_SplitShape_1;
  BRepFeat_SplitShape_2: typeof BRepFeat_SplitShape_2;
  BRepFeat_Gluer: typeof BRepFeat_Gluer;
  BRepFeat_Gluer_1: typeof BRepFeat_Gluer_1;
  BRepFeat_Gluer_2: typeof BRepFeat_Gluer_2;
  BRepFeat_Builder: typeof BRepFeat_Builder;
  BRepFeat_MakePrism: typeof BRepFeat_MakePrism;
  BRepFeat_MakePrism_1: typeof BRepFeat_MakePrism_1;
  BRepFeat_MakePrism_2: typeof BRepFeat_MakePrism_2;
  BRepFeat_PerfSelection: BRepFeat_PerfSelection;
  BRepFeat_StatusError: BRepFeat_StatusError;
  BRepFeat_MakePipe: typeof BRepFeat_MakePipe;
  BRepFeat_MakePipe_1: typeof BRepFeat_MakePipe_1;
  BRepFeat_MakePipe_2: typeof BRepFeat_MakePipe_2;
  BRepFeat_MakeDPrism: typeof BRepFeat_MakeDPrism;
  BRepFeat_MakeDPrism_1: typeof BRepFeat_MakeDPrism_1;
  BRepFeat_MakeDPrism_2: typeof BRepFeat_MakeDPrism_2;
  BRepFeat_MakeRevol: typeof BRepFeat_MakeRevol;
  BRepFeat_MakeRevol_1: typeof BRepFeat_MakeRevol_1;
  BRepFeat_MakeRevol_2: typeof BRepFeat_MakeRevol_2;
  BRepFeat_Form: typeof BRepFeat_Form;
  BRepFeat_Status: BRepFeat_Status;
  BRepFeat_MakeCylindricalHole: typeof BRepFeat_MakeCylindricalHole;
  BRepFeat_MakeRevolutionForm: typeof BRepFeat_MakeRevolutionForm;
  BRepFeat_MakeRevolutionForm_1: typeof BRepFeat_MakeRevolutionForm_1;
  BRepFeat_MakeRevolutionForm_2: typeof BRepFeat_MakeRevolutionForm_2;
  GeomToIGES_GeomPoint: typeof GeomToIGES_GeomPoint;
  GeomToIGES_GeomPoint_1: typeof GeomToIGES_GeomPoint_1;
  GeomToIGES_GeomPoint_2: typeof GeomToIGES_GeomPoint_2;
  GeomToIGES_GeomVector: typeof GeomToIGES_GeomVector;
  GeomToIGES_GeomVector_1: typeof GeomToIGES_GeomVector_1;
  GeomToIGES_GeomVector_2: typeof GeomToIGES_GeomVector_2;
  GeomToIGES_GeomCurve: typeof GeomToIGES_GeomCurve;
  GeomToIGES_GeomCurve_1: typeof GeomToIGES_GeomCurve_1;
  GeomToIGES_GeomCurve_2: typeof GeomToIGES_GeomCurve_2;
  GeomToIGES_GeomSurface: typeof GeomToIGES_GeomSurface;
  GeomToIGES_GeomSurface_1: typeof GeomToIGES_GeomSurface_1;
  GeomToIGES_GeomSurface_2: typeof GeomToIGES_GeomSurface_2;
  GeomToIGES_GeomEntity: typeof GeomToIGES_GeomEntity;
  GeomToIGES_GeomEntity_1: typeof GeomToIGES_GeomEntity_1;
  GeomToIGES_GeomEntity_2: typeof GeomToIGES_GeomEntity_2;
  Handle_PrsMgr_Presentation: typeof Handle_PrsMgr_Presentation;
  Handle_PrsMgr_Presentation_1: typeof Handle_PrsMgr_Presentation_1;
  Handle_PrsMgr_Presentation_2: typeof Handle_PrsMgr_Presentation_2;
  Handle_PrsMgr_Presentation_3: typeof Handle_PrsMgr_Presentation_3;
  Handle_PrsMgr_Presentation_4: typeof Handle_PrsMgr_Presentation_4;
  PrsMgr_Presentation: typeof PrsMgr_Presentation;
  Handle_PrsMgr_PresentableObject: typeof Handle_PrsMgr_PresentableObject;
  Handle_PrsMgr_PresentableObject_1: typeof Handle_PrsMgr_PresentableObject_1;
  Handle_PrsMgr_PresentableObject_2: typeof Handle_PrsMgr_PresentableObject_2;
  Handle_PrsMgr_PresentableObject_3: typeof Handle_PrsMgr_PresentableObject_3;
  Handle_PrsMgr_PresentableObject_4: typeof Handle_PrsMgr_PresentableObject_4;
  PrsMgr_PresentableObject: typeof PrsMgr_PresentableObject;
  PrsMgr_PresentationManager: typeof PrsMgr_PresentationManager;
  Handle_PrsMgr_PresentationManager: typeof Handle_PrsMgr_PresentationManager;
  Handle_PrsMgr_PresentationManager_1: typeof Handle_PrsMgr_PresentationManager_1;
  Handle_PrsMgr_PresentationManager_2: typeof Handle_PrsMgr_PresentationManager_2;
  Handle_PrsMgr_PresentationManager_3: typeof Handle_PrsMgr_PresentationManager_3;
  Handle_PrsMgr_PresentationManager_4: typeof Handle_PrsMgr_PresentationManager_4;
  PrsMgr_TypeOfPresentation3d: PrsMgr_TypeOfPresentation3d;
  Handle_VrmlData_Faceted: typeof Handle_VrmlData_Faceted;
  Handle_VrmlData_Faceted_1: typeof Handle_VrmlData_Faceted_1;
  Handle_VrmlData_Faceted_2: typeof Handle_VrmlData_Faceted_2;
  Handle_VrmlData_Faceted_3: typeof Handle_VrmlData_Faceted_3;
  Handle_VrmlData_Faceted_4: typeof Handle_VrmlData_Faceted_4;
  VrmlData_Faceted: typeof VrmlData_Faceted;
  VrmlData_Normal: typeof VrmlData_Normal;
  VrmlData_Normal_1: typeof VrmlData_Normal_1;
  VrmlData_Normal_2: typeof VrmlData_Normal_2;
  Handle_VrmlData_Normal: typeof Handle_VrmlData_Normal;
  Handle_VrmlData_Normal_1: typeof Handle_VrmlData_Normal_1;
  Handle_VrmlData_Normal_2: typeof Handle_VrmlData_Normal_2;
  Handle_VrmlData_Normal_3: typeof Handle_VrmlData_Normal_3;
  Handle_VrmlData_Normal_4: typeof Handle_VrmlData_Normal_4;
  Handle_VrmlData_Sphere: typeof Handle_VrmlData_Sphere;
  Handle_VrmlData_Sphere_1: typeof Handle_VrmlData_Sphere_1;
  Handle_VrmlData_Sphere_2: typeof Handle_VrmlData_Sphere_2;
  Handle_VrmlData_Sphere_3: typeof Handle_VrmlData_Sphere_3;
  Handle_VrmlData_Sphere_4: typeof Handle_VrmlData_Sphere_4;
  VrmlData_Sphere: typeof VrmlData_Sphere;
  VrmlData_Sphere_1: typeof VrmlData_Sphere_1;
  VrmlData_Sphere_2: typeof VrmlData_Sphere_2;
  VrmlData_Material: typeof VrmlData_Material;
  VrmlData_Material_1: typeof VrmlData_Material_1;
  VrmlData_Material_2: typeof VrmlData_Material_2;
  Handle_VrmlData_Material: typeof Handle_VrmlData_Material;
  Handle_VrmlData_Material_1: typeof Handle_VrmlData_Material_1;
  Handle_VrmlData_Material_2: typeof Handle_VrmlData_Material_2;
  Handle_VrmlData_Material_3: typeof Handle_VrmlData_Material_3;
  Handle_VrmlData_Material_4: typeof Handle_VrmlData_Material_4;
  Handle_VrmlData_Cylinder: typeof Handle_VrmlData_Cylinder;
  Handle_VrmlData_Cylinder_1: typeof Handle_VrmlData_Cylinder_1;
  Handle_VrmlData_Cylinder_2: typeof Handle_VrmlData_Cylinder_2;
  Handle_VrmlData_Cylinder_3: typeof Handle_VrmlData_Cylinder_3;
  Handle_VrmlData_Cylinder_4: typeof Handle_VrmlData_Cylinder_4;
  VrmlData_Cylinder: typeof VrmlData_Cylinder;
  VrmlData_Cylinder_1: typeof VrmlData_Cylinder_1;
  VrmlData_Cylinder_2: typeof VrmlData_Cylinder_2;
  VrmlData_Node: typeof VrmlData_Node;
  Handle_VrmlData_Node: typeof Handle_VrmlData_Node;
  Handle_VrmlData_Node_1: typeof Handle_VrmlData_Node_1;
  Handle_VrmlData_Node_2: typeof Handle_VrmlData_Node_2;
  Handle_VrmlData_Node_3: typeof Handle_VrmlData_Node_3;
  Handle_VrmlData_Node_4: typeof Handle_VrmlData_Node_4;
  Handle_VrmlData_Appearance: typeof Handle_VrmlData_Appearance;
  Handle_VrmlData_Appearance_1: typeof Handle_VrmlData_Appearance_1;
  Handle_VrmlData_Appearance_2: typeof Handle_VrmlData_Appearance_2;
  Handle_VrmlData_Appearance_3: typeof Handle_VrmlData_Appearance_3;
  Handle_VrmlData_Appearance_4: typeof Handle_VrmlData_Appearance_4;
  VrmlData_Appearance: typeof VrmlData_Appearance;
  VrmlData_Appearance_1: typeof VrmlData_Appearance_1;
  VrmlData_Appearance_2: typeof VrmlData_Appearance_2;
  VrmlData_Color: typeof VrmlData_Color;
  VrmlData_Color_1: typeof VrmlData_Color_1;
  VrmlData_Color_2: typeof VrmlData_Color_2;
  Handle_VrmlData_Color: typeof Handle_VrmlData_Color;
  Handle_VrmlData_Color_1: typeof Handle_VrmlData_Color_1;
  Handle_VrmlData_Color_2: typeof Handle_VrmlData_Color_2;
  Handle_VrmlData_Color_3: typeof Handle_VrmlData_Color_3;
  Handle_VrmlData_Color_4: typeof Handle_VrmlData_Color_4;
  VrmlData_Group: typeof VrmlData_Group;
  VrmlData_Group_1: typeof VrmlData_Group_1;
  VrmlData_Group_2: typeof VrmlData_Group_2;
  Handle_VrmlData_Group: typeof Handle_VrmlData_Group;
  Handle_VrmlData_Group_1: typeof Handle_VrmlData_Group_1;
  Handle_VrmlData_Group_2: typeof Handle_VrmlData_Group_2;
  Handle_VrmlData_Group_3: typeof Handle_VrmlData_Group_3;
  Handle_VrmlData_Group_4: typeof Handle_VrmlData_Group_4;
  Handle_VrmlData_UnknownNode: typeof Handle_VrmlData_UnknownNode;
  Handle_VrmlData_UnknownNode_1: typeof Handle_VrmlData_UnknownNode_1;
  Handle_VrmlData_UnknownNode_2: typeof Handle_VrmlData_UnknownNode_2;
  Handle_VrmlData_UnknownNode_3: typeof Handle_VrmlData_UnknownNode_3;
  Handle_VrmlData_UnknownNode_4: typeof Handle_VrmlData_UnknownNode_4;
  VrmlData_UnknownNode: typeof VrmlData_UnknownNode;
  VrmlData_UnknownNode_1: typeof VrmlData_UnknownNode_1;
  VrmlData_UnknownNode_2: typeof VrmlData_UnknownNode_2;
  Handle_VrmlData_IndexedFaceSet: typeof Handle_VrmlData_IndexedFaceSet;
  Handle_VrmlData_IndexedFaceSet_1: typeof Handle_VrmlData_IndexedFaceSet_1;
  Handle_VrmlData_IndexedFaceSet_2: typeof Handle_VrmlData_IndexedFaceSet_2;
  Handle_VrmlData_IndexedFaceSet_3: typeof Handle_VrmlData_IndexedFaceSet_3;
  Handle_VrmlData_IndexedFaceSet_4: typeof Handle_VrmlData_IndexedFaceSet_4;
  VrmlData_Geometry: typeof VrmlData_Geometry;
  Handle_VrmlData_Geometry: typeof Handle_VrmlData_Geometry;
  Handle_VrmlData_Geometry_1: typeof Handle_VrmlData_Geometry_1;
  Handle_VrmlData_Geometry_2: typeof Handle_VrmlData_Geometry_2;
  Handle_VrmlData_Geometry_3: typeof Handle_VrmlData_Geometry_3;
  Handle_VrmlData_Geometry_4: typeof Handle_VrmlData_Geometry_4;
  VrmlData_ArrayVec3d: typeof VrmlData_ArrayVec3d;
  Handle_VrmlData_ArrayVec3d: typeof Handle_VrmlData_ArrayVec3d;
  Handle_VrmlData_ArrayVec3d_1: typeof Handle_VrmlData_ArrayVec3d_1;
  Handle_VrmlData_ArrayVec3d_2: typeof Handle_VrmlData_ArrayVec3d_2;
  Handle_VrmlData_ArrayVec3d_3: typeof Handle_VrmlData_ArrayVec3d_3;
  Handle_VrmlData_ArrayVec3d_4: typeof Handle_VrmlData_ArrayVec3d_4;
  Handle_VrmlData_Texture: typeof Handle_VrmlData_Texture;
  Handle_VrmlData_Texture_1: typeof Handle_VrmlData_Texture_1;
  Handle_VrmlData_Texture_2: typeof Handle_VrmlData_Texture_2;
  Handle_VrmlData_Texture_3: typeof Handle_VrmlData_Texture_3;
  Handle_VrmlData_Texture_4: typeof Handle_VrmlData_Texture_4;
  VrmlData_Texture: typeof VrmlData_Texture;
  VrmlData_Box: typeof VrmlData_Box;
  VrmlData_Box_1: typeof VrmlData_Box_1;
  VrmlData_Box_2: typeof VrmlData_Box_2;
  Handle_VrmlData_Box: typeof Handle_VrmlData_Box;
  Handle_VrmlData_Box_1: typeof Handle_VrmlData_Box_1;
  Handle_VrmlData_Box_2: typeof Handle_VrmlData_Box_2;
  Handle_VrmlData_Box_3: typeof Handle_VrmlData_Box_3;
  Handle_VrmlData_Box_4: typeof Handle_VrmlData_Box_4;
  Handle_VrmlData_WorldInfo: typeof Handle_VrmlData_WorldInfo;
  Handle_VrmlData_WorldInfo_1: typeof Handle_VrmlData_WorldInfo_1;
  Handle_VrmlData_WorldInfo_2: typeof Handle_VrmlData_WorldInfo_2;
  Handle_VrmlData_WorldInfo_3: typeof Handle_VrmlData_WorldInfo_3;
  Handle_VrmlData_WorldInfo_4: typeof Handle_VrmlData_WorldInfo_4;
  VrmlData_WorldInfo: typeof VrmlData_WorldInfo;
  VrmlData_WorldInfo_1: typeof VrmlData_WorldInfo_1;
  VrmlData_WorldInfo_2: typeof VrmlData_WorldInfo_2;
  VrmlData_ShapeConvert: typeof VrmlData_ShapeConvert;
  VrmlData_TextureTransform: typeof VrmlData_TextureTransform;
  Handle_VrmlData_TextureTransform: typeof Handle_VrmlData_TextureTransform;
  Handle_VrmlData_TextureTransform_1: typeof Handle_VrmlData_TextureTransform_1;
  Handle_VrmlData_TextureTransform_2: typeof Handle_VrmlData_TextureTransform_2;
  Handle_VrmlData_TextureTransform_3: typeof Handle_VrmlData_TextureTransform_3;
  Handle_VrmlData_TextureTransform_4: typeof Handle_VrmlData_TextureTransform_4;
  Handle_VrmlData_ShapeNode: typeof Handle_VrmlData_ShapeNode;
  Handle_VrmlData_ShapeNode_1: typeof Handle_VrmlData_ShapeNode_1;
  Handle_VrmlData_ShapeNode_2: typeof Handle_VrmlData_ShapeNode_2;
  Handle_VrmlData_ShapeNode_3: typeof Handle_VrmlData_ShapeNode_3;
  Handle_VrmlData_ShapeNode_4: typeof Handle_VrmlData_ShapeNode_4;
  VrmlData_ShapeNode: typeof VrmlData_ShapeNode;
  VrmlData_ShapeNode_1: typeof VrmlData_ShapeNode_1;
  VrmlData_ShapeNode_2: typeof VrmlData_ShapeNode_2;
  Handle_VrmlData_IndexedLineSet: typeof Handle_VrmlData_IndexedLineSet;
  Handle_VrmlData_IndexedLineSet_1: typeof Handle_VrmlData_IndexedLineSet_1;
  Handle_VrmlData_IndexedLineSet_2: typeof Handle_VrmlData_IndexedLineSet_2;
  Handle_VrmlData_IndexedLineSet_3: typeof Handle_VrmlData_IndexedLineSet_3;
  Handle_VrmlData_IndexedLineSet_4: typeof Handle_VrmlData_IndexedLineSet_4;
  VrmlData_TextureCoordinate: typeof VrmlData_TextureCoordinate;
  VrmlData_TextureCoordinate_1: typeof VrmlData_TextureCoordinate_1;
  VrmlData_TextureCoordinate_2: typeof VrmlData_TextureCoordinate_2;
  Handle_VrmlData_TextureCoordinate: typeof Handle_VrmlData_TextureCoordinate;
  Handle_VrmlData_TextureCoordinate_1: typeof Handle_VrmlData_TextureCoordinate_1;
  Handle_VrmlData_TextureCoordinate_2: typeof Handle_VrmlData_TextureCoordinate_2;
  Handle_VrmlData_TextureCoordinate_3: typeof Handle_VrmlData_TextureCoordinate_3;
  Handle_VrmlData_TextureCoordinate_4: typeof Handle_VrmlData_TextureCoordinate_4;
  VrmlData_ErrorStatus: VrmlData_ErrorStatus;
  Handle_VrmlData_Coordinate: typeof Handle_VrmlData_Coordinate;
  Handle_VrmlData_Coordinate_1: typeof Handle_VrmlData_Coordinate_1;
  Handle_VrmlData_Coordinate_2: typeof Handle_VrmlData_Coordinate_2;
  Handle_VrmlData_Coordinate_3: typeof Handle_VrmlData_Coordinate_3;
  Handle_VrmlData_Coordinate_4: typeof Handle_VrmlData_Coordinate_4;
  VrmlData_Coordinate: typeof VrmlData_Coordinate;
  VrmlData_Coordinate_1: typeof VrmlData_Coordinate_1;
  VrmlData_Coordinate_2: typeof VrmlData_Coordinate_2;
  Handle_VrmlData_Cone: typeof Handle_VrmlData_Cone;
  Handle_VrmlData_Cone_1: typeof Handle_VrmlData_Cone_1;
  Handle_VrmlData_Cone_2: typeof Handle_VrmlData_Cone_2;
  Handle_VrmlData_Cone_3: typeof Handle_VrmlData_Cone_3;
  Handle_VrmlData_Cone_4: typeof Handle_VrmlData_Cone_4;
  VrmlData_Cone: typeof VrmlData_Cone;
  VrmlData_Cone_1: typeof VrmlData_Cone_1;
  VrmlData_Cone_2: typeof VrmlData_Cone_2;
  Handle_VrmlData_ImageTexture: typeof Handle_VrmlData_ImageTexture;
  Handle_VrmlData_ImageTexture_1: typeof Handle_VrmlData_ImageTexture_1;
  Handle_VrmlData_ImageTexture_2: typeof Handle_VrmlData_ImageTexture_2;
  Handle_VrmlData_ImageTexture_3: typeof Handle_VrmlData_ImageTexture_3;
  Handle_VrmlData_ImageTexture_4: typeof Handle_VrmlData_ImageTexture_4;
  VrmlData_ImageTexture: typeof VrmlData_ImageTexture;
  VrmlData_ImageTexture_1: typeof VrmlData_ImageTexture_1;
  VrmlData_ImageTexture_2: typeof VrmlData_ImageTexture_2;
  VrmlData_InBuffer: typeof VrmlData_InBuffer;
  Handle_BinMNaming_NamingDriver: typeof Handle_BinMNaming_NamingDriver;
  Handle_BinMNaming_NamingDriver_1: typeof Handle_BinMNaming_NamingDriver_1;
  Handle_BinMNaming_NamingDriver_2: typeof Handle_BinMNaming_NamingDriver_2;
  Handle_BinMNaming_NamingDriver_3: typeof Handle_BinMNaming_NamingDriver_3;
  Handle_BinMNaming_NamingDriver_4: typeof Handle_BinMNaming_NamingDriver_4;
  BinMNaming_NamingDriver: typeof BinMNaming_NamingDriver;
  BinMNaming: typeof BinMNaming;
  Handle_BinMNaming_NamedShapeDriver: typeof Handle_BinMNaming_NamedShapeDriver;
  Handle_BinMNaming_NamedShapeDriver_1: typeof Handle_BinMNaming_NamedShapeDriver_1;
  Handle_BinMNaming_NamedShapeDriver_2: typeof Handle_BinMNaming_NamedShapeDriver_2;
  Handle_BinMNaming_NamedShapeDriver_3: typeof Handle_BinMNaming_NamedShapeDriver_3;
  Handle_BinMNaming_NamedShapeDriver_4: typeof Handle_BinMNaming_NamedShapeDriver_4;
  BinMNaming_NamedShapeDriver: typeof BinMNaming_NamedShapeDriver;
  ShapePersistent: typeof ShapePersistent;
  ShapePersistent_HSequence: typeof ShapePersistent_HSequence;
  ShapePersistent_HArray1: typeof ShapePersistent_HArray1;
  ShapePersistent_HArray2: typeof ShapePersistent_HArray2;
  ShapePersistent_TriangleMode: ShapePersistent_TriangleMode;
  STEPConstruct_PointHasher: typeof STEPConstruct_PointHasher;
  STEPConstruct_ExternRefs: typeof STEPConstruct_ExternRefs;
  STEPConstruct_ExternRefs_1: typeof STEPConstruct_ExternRefs_1;
  STEPConstruct_ExternRefs_2: typeof STEPConstruct_ExternRefs_2;
  STEPConstruct_ContextTool: typeof STEPConstruct_ContextTool;
  STEPConstruct_ContextTool_1: typeof STEPConstruct_ContextTool_1;
  STEPConstruct_ContextTool_2: typeof STEPConstruct_ContextTool_2;
  STEPConstruct_Styles: typeof STEPConstruct_Styles;
  STEPConstruct_Styles_1: typeof STEPConstruct_Styles_1;
  STEPConstruct_Styles_2: typeof STEPConstruct_Styles_2;
  STEPConstruct_Part: typeof STEPConstruct_Part;
  STEPConstruct_UnitContext: typeof STEPConstruct_UnitContext;
  STEPConstruct_Tool: typeof STEPConstruct_Tool;
  STEPConstruct_Tool_1: typeof STEPConstruct_Tool_1;
  STEPConstruct_Tool_2: typeof STEPConstruct_Tool_2;
  STEPConstruct_AP203Context: typeof STEPConstruct_AP203Context;
  STEPConstruct_Assembly: typeof STEPConstruct_Assembly;
  STEPConstruct: typeof STEPConstruct;
  STEPConstruct_ValidationProps: typeof STEPConstruct_ValidationProps;
  STEPConstruct_ValidationProps_1: typeof STEPConstruct_ValidationProps_1;
  STEPConstruct_ValidationProps_2: typeof STEPConstruct_ValidationProps_2;
  StdDrivers: typeof StdDrivers;
  StdDrivers_DocumentRetrievalDriver: typeof StdDrivers_DocumentRetrievalDriver;
  BRepMAT2d_Explorer: typeof BRepMAT2d_Explorer;
  BRepMAT2d_Explorer_1: typeof BRepMAT2d_Explorer_1;
  BRepMAT2d_Explorer_2: typeof BRepMAT2d_Explorer_2;
  BRepMAT2d_DataMapOfShapeSequenceOfBasicElt: typeof BRepMAT2d_DataMapOfShapeSequenceOfBasicElt;
  BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_1: typeof BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_1;
  BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_2: typeof BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_2;
  BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_3: typeof BRepMAT2d_DataMapOfShapeSequenceOfBasicElt_3;
  BRepMAT2d_BisectingLocus: typeof BRepMAT2d_BisectingLocus;
  BRepMAT2d_LinkTopoBilo: typeof BRepMAT2d_LinkTopoBilo;
  BRepMAT2d_LinkTopoBilo_1: typeof BRepMAT2d_LinkTopoBilo_1;
  BRepMAT2d_LinkTopoBilo_2: typeof BRepMAT2d_LinkTopoBilo_2;
  TShort_Array1OfShortReal: typeof TShort_Array1OfShortReal;
  TShort_Array1OfShortReal_1: typeof TShort_Array1OfShortReal_1;
  TShort_Array1OfShortReal_2: typeof TShort_Array1OfShortReal_2;
  TShort_Array1OfShortReal_3: typeof TShort_Array1OfShortReal_3;
  TShort_Array1OfShortReal_4: typeof TShort_Array1OfShortReal_4;
  TShort_Array1OfShortReal_5: typeof TShort_Array1OfShortReal_5;
  Handle_TShort_HArray1OfShortReal: typeof Handle_TShort_HArray1OfShortReal;
  Handle_TShort_HArray1OfShortReal_1: typeof Handle_TShort_HArray1OfShortReal_1;
  Handle_TShort_HArray1OfShortReal_2: typeof Handle_TShort_HArray1OfShortReal_2;
  Handle_TShort_HArray1OfShortReal_3: typeof Handle_TShort_HArray1OfShortReal_3;
  Handle_TShort_HArray1OfShortReal_4: typeof Handle_TShort_HArray1OfShortReal_4;
  TShort_Array2OfShortReal: typeof TShort_Array2OfShortReal;
  TShort_Array2OfShortReal_1: typeof TShort_Array2OfShortReal_1;
  TShort_Array2OfShortReal_2: typeof TShort_Array2OfShortReal_2;
  TShort_Array2OfShortReal_3: typeof TShort_Array2OfShortReal_3;
  TShort_Array2OfShortReal_4: typeof TShort_Array2OfShortReal_4;
  TShort_Array2OfShortReal_5: typeof TShort_Array2OfShortReal_5;
  Handle_TShort_HSequenceOfShortReal: typeof Handle_TShort_HSequenceOfShortReal;
  Handle_TShort_HSequenceOfShortReal_1: typeof Handle_TShort_HSequenceOfShortReal_1;
  Handle_TShort_HSequenceOfShortReal_2: typeof Handle_TShort_HSequenceOfShortReal_2;
  Handle_TShort_HSequenceOfShortReal_3: typeof Handle_TShort_HSequenceOfShortReal_3;
  Handle_TShort_HSequenceOfShortReal_4: typeof Handle_TShort_HSequenceOfShortReal_4;
  TShort_SequenceOfShortReal: typeof TShort_SequenceOfShortReal;
  TShort_SequenceOfShortReal_1: typeof TShort_SequenceOfShortReal_1;
  TShort_SequenceOfShortReal_2: typeof TShort_SequenceOfShortReal_2;
  TShort_SequenceOfShortReal_3: typeof TShort_SequenceOfShortReal_3;
  Handle_TShort_HArray2OfShortReal: typeof Handle_TShort_HArray2OfShortReal;
  Handle_TShort_HArray2OfShortReal_1: typeof Handle_TShort_HArray2OfShortReal_1;
  Handle_TShort_HArray2OfShortReal_2: typeof Handle_TShort_HArray2OfShortReal_2;
  Handle_TShort_HArray2OfShortReal_3: typeof Handle_TShort_HArray2OfShortReal_3;
  Handle_TShort_HArray2OfShortReal_4: typeof Handle_TShort_HArray2OfShortReal_4;
  Convert_SphereToBSplineSurface: typeof Convert_SphereToBSplineSurface;
  Convert_SphereToBSplineSurface_1: typeof Convert_SphereToBSplineSurface_1;
  Convert_SphereToBSplineSurface_2: typeof Convert_SphereToBSplineSurface_2;
  Convert_SphereToBSplineSurface_3: typeof Convert_SphereToBSplineSurface_3;
  Convert_CompPolynomialToPoles: typeof Convert_CompPolynomialToPoles;
  Convert_CompPolynomialToPoles_1: typeof Convert_CompPolynomialToPoles_1;
  Convert_CompPolynomialToPoles_2: typeof Convert_CompPolynomialToPoles_2;
  Convert_CompPolynomialToPoles_3: typeof Convert_CompPolynomialToPoles_3;
  Convert_ElementarySurfaceToBSplineSurface: typeof Convert_ElementarySurfaceToBSplineSurface;
  Convert_ParameterisationType: Convert_ParameterisationType;
  Convert_EllipseToBSplineCurve: typeof Convert_EllipseToBSplineCurve;
  Convert_EllipseToBSplineCurve_1: typeof Convert_EllipseToBSplineCurve_1;
  Convert_EllipseToBSplineCurve_2: typeof Convert_EllipseToBSplineCurve_2;
  Convert_TorusToBSplineSurface: typeof Convert_TorusToBSplineSurface;
  Convert_TorusToBSplineSurface_1: typeof Convert_TorusToBSplineSurface_1;
  Convert_TorusToBSplineSurface_2: typeof Convert_TorusToBSplineSurface_2;
  Convert_TorusToBSplineSurface_3: typeof Convert_TorusToBSplineSurface_3;
  Convert_CylinderToBSplineSurface: typeof Convert_CylinderToBSplineSurface;
  Convert_CylinderToBSplineSurface_1: typeof Convert_CylinderToBSplineSurface_1;
  Convert_CylinderToBSplineSurface_2: typeof Convert_CylinderToBSplineSurface_2;
  Convert_GridPolynomialToPoles: typeof Convert_GridPolynomialToPoles;
  Convert_GridPolynomialToPoles_1: typeof Convert_GridPolynomialToPoles_1;
  Convert_GridPolynomialToPoles_2: typeof Convert_GridPolynomialToPoles_2;
  Convert_ConeToBSplineSurface: typeof Convert_ConeToBSplineSurface;
  Convert_ConeToBSplineSurface_1: typeof Convert_ConeToBSplineSurface_1;
  Convert_ConeToBSplineSurface_2: typeof Convert_ConeToBSplineSurface_2;
  Convert_ConicToBSplineCurve: typeof Convert_ConicToBSplineCurve;
  Convert_CompBezierCurves2dToBSplineCurve2d: typeof Convert_CompBezierCurves2dToBSplineCurve2d;
  Convert_HyperbolaToBSplineCurve: typeof Convert_HyperbolaToBSplineCurve;
  Convert_CircleToBSplineCurve: typeof Convert_CircleToBSplineCurve;
  Convert_CircleToBSplineCurve_1: typeof Convert_CircleToBSplineCurve_1;
  Convert_CircleToBSplineCurve_2: typeof Convert_CircleToBSplineCurve_2;
  Convert_ParabolaToBSplineCurve: typeof Convert_ParabolaToBSplineCurve;
  Convert_CompBezierCurvesToBSplineCurve: typeof Convert_CompBezierCurvesToBSplineCurve;
  AppParCurves: typeof AppParCurves;
  Handle_AppParCurves_HArray1OfMultiPoint: typeof Handle_AppParCurves_HArray1OfMultiPoint;
  Handle_AppParCurves_HArray1OfMultiPoint_1: typeof Handle_AppParCurves_HArray1OfMultiPoint_1;
  Handle_AppParCurves_HArray1OfMultiPoint_2: typeof Handle_AppParCurves_HArray1OfMultiPoint_2;
  Handle_AppParCurves_HArray1OfMultiPoint_3: typeof Handle_AppParCurves_HArray1OfMultiPoint_3;
  Handle_AppParCurves_HArray1OfMultiPoint_4: typeof Handle_AppParCurves_HArray1OfMultiPoint_4;
  Handle_AppParCurves_HArray1OfMultiBSpCurve: typeof Handle_AppParCurves_HArray1OfMultiBSpCurve;
  Handle_AppParCurves_HArray1OfMultiBSpCurve_1: typeof Handle_AppParCurves_HArray1OfMultiBSpCurve_1;
  Handle_AppParCurves_HArray1OfMultiBSpCurve_2: typeof Handle_AppParCurves_HArray1OfMultiBSpCurve_2;
  Handle_AppParCurves_HArray1OfMultiBSpCurve_3: typeof Handle_AppParCurves_HArray1OfMultiBSpCurve_3;
  Handle_AppParCurves_HArray1OfMultiBSpCurve_4: typeof Handle_AppParCurves_HArray1OfMultiBSpCurve_4;
  AppParCurves_Array1OfMultiPoint: typeof AppParCurves_Array1OfMultiPoint;
  AppParCurves_Array1OfMultiPoint_1: typeof AppParCurves_Array1OfMultiPoint_1;
  AppParCurves_Array1OfMultiPoint_2: typeof AppParCurves_Array1OfMultiPoint_2;
  AppParCurves_Array1OfMultiPoint_3: typeof AppParCurves_Array1OfMultiPoint_3;
  AppParCurves_Array1OfMultiPoint_4: typeof AppParCurves_Array1OfMultiPoint_4;
  AppParCurves_Array1OfMultiPoint_5: typeof AppParCurves_Array1OfMultiPoint_5;
  AppParCurves_ConstraintCouple: typeof AppParCurves_ConstraintCouple;
  AppParCurves_ConstraintCouple_1: typeof AppParCurves_ConstraintCouple_1;
  AppParCurves_ConstraintCouple_2: typeof AppParCurves_ConstraintCouple_2;
  AppParCurves_Array1OfConstraintCouple: typeof AppParCurves_Array1OfConstraintCouple;
  AppParCurves_Array1OfConstraintCouple_1: typeof AppParCurves_Array1OfConstraintCouple_1;
  AppParCurves_Array1OfConstraintCouple_2: typeof AppParCurves_Array1OfConstraintCouple_2;
  AppParCurves_Array1OfConstraintCouple_3: typeof AppParCurves_Array1OfConstraintCouple_3;
  AppParCurves_Array1OfConstraintCouple_4: typeof AppParCurves_Array1OfConstraintCouple_4;
  AppParCurves_Array1OfConstraintCouple_5: typeof AppParCurves_Array1OfConstraintCouple_5;
  AppParCurves_Array1OfMultiCurve: typeof AppParCurves_Array1OfMultiCurve;
  AppParCurves_Array1OfMultiCurve_1: typeof AppParCurves_Array1OfMultiCurve_1;
  AppParCurves_Array1OfMultiCurve_2: typeof AppParCurves_Array1OfMultiCurve_2;
  AppParCurves_Array1OfMultiCurve_3: typeof AppParCurves_Array1OfMultiCurve_3;
  AppParCurves_Array1OfMultiCurve_4: typeof AppParCurves_Array1OfMultiCurve_4;
  AppParCurves_Array1OfMultiCurve_5: typeof AppParCurves_Array1OfMultiCurve_5;
  AppParCurves_SequenceOfMultiCurve: typeof AppParCurves_SequenceOfMultiCurve;
  AppParCurves_SequenceOfMultiCurve_1: typeof AppParCurves_SequenceOfMultiCurve_1;
  AppParCurves_SequenceOfMultiCurve_2: typeof AppParCurves_SequenceOfMultiCurve_2;
  AppParCurves_SequenceOfMultiCurve_3: typeof AppParCurves_SequenceOfMultiCurve_3;
  AppParCurves_MultiPoint: typeof AppParCurves_MultiPoint;
  AppParCurves_MultiPoint_1: typeof AppParCurves_MultiPoint_1;
  AppParCurves_MultiPoint_2: typeof AppParCurves_MultiPoint_2;
  AppParCurves_MultiPoint_3: typeof AppParCurves_MultiPoint_3;
  AppParCurves_MultiPoint_4: typeof AppParCurves_MultiPoint_4;
  AppParCurves_MultiPoint_5: typeof AppParCurves_MultiPoint_5;
  Handle_AppParCurves_HArray1OfMultiCurve: typeof Handle_AppParCurves_HArray1OfMultiCurve;
  Handle_AppParCurves_HArray1OfMultiCurve_1: typeof Handle_AppParCurves_HArray1OfMultiCurve_1;
  Handle_AppParCurves_HArray1OfMultiCurve_2: typeof Handle_AppParCurves_HArray1OfMultiCurve_2;
  Handle_AppParCurves_HArray1OfMultiCurve_3: typeof Handle_AppParCurves_HArray1OfMultiCurve_3;
  Handle_AppParCurves_HArray1OfMultiCurve_4: typeof Handle_AppParCurves_HArray1OfMultiCurve_4;
  AppParCurves_Constraint: AppParCurves_Constraint;
  Handle_AppParCurves_HArray1OfConstraintCouple: typeof Handle_AppParCurves_HArray1OfConstraintCouple;
  Handle_AppParCurves_HArray1OfConstraintCouple_1: typeof Handle_AppParCurves_HArray1OfConstraintCouple_1;
  Handle_AppParCurves_HArray1OfConstraintCouple_2: typeof Handle_AppParCurves_HArray1OfConstraintCouple_2;
  Handle_AppParCurves_HArray1OfConstraintCouple_3: typeof Handle_AppParCurves_HArray1OfConstraintCouple_3;
  Handle_AppParCurves_HArray1OfConstraintCouple_4: typeof Handle_AppParCurves_HArray1OfConstraintCouple_4;
  AppParCurves_Array1OfMultiBSpCurve: typeof AppParCurves_Array1OfMultiBSpCurve;
  AppParCurves_Array1OfMultiBSpCurve_1: typeof AppParCurves_Array1OfMultiBSpCurve_1;
  AppParCurves_Array1OfMultiBSpCurve_2: typeof AppParCurves_Array1OfMultiBSpCurve_2;
  AppParCurves_Array1OfMultiBSpCurve_3: typeof AppParCurves_Array1OfMultiBSpCurve_3;
  AppParCurves_Array1OfMultiBSpCurve_4: typeof AppParCurves_Array1OfMultiBSpCurve_4;
  AppParCurves_Array1OfMultiBSpCurve_5: typeof AppParCurves_Array1OfMultiBSpCurve_5;
  AppParCurves_MultiBSpCurve: typeof AppParCurves_MultiBSpCurve;
  AppParCurves_MultiBSpCurve_1: typeof AppParCurves_MultiBSpCurve_1;
  AppParCurves_MultiBSpCurve_2: typeof AppParCurves_MultiBSpCurve_2;
  AppParCurves_MultiBSpCurve_3: typeof AppParCurves_MultiBSpCurve_3;
  AppParCurves_MultiBSpCurve_4: typeof AppParCurves_MultiBSpCurve_4;
  AppParCurves_SequenceOfMultiBSpCurve: typeof AppParCurves_SequenceOfMultiBSpCurve;
  AppParCurves_SequenceOfMultiBSpCurve_1: typeof AppParCurves_SequenceOfMultiBSpCurve_1;
  AppParCurves_SequenceOfMultiBSpCurve_2: typeof AppParCurves_SequenceOfMultiBSpCurve_2;
  AppParCurves_SequenceOfMultiBSpCurve_3: typeof AppParCurves_SequenceOfMultiBSpCurve_3;
  AppParCurves_MultiCurve: typeof AppParCurves_MultiCurve;
  AppParCurves_MultiCurve_1: typeof AppParCurves_MultiCurve_1;
  AppParCurves_MultiCurve_2: typeof AppParCurves_MultiCurve_2;
  AppParCurves_MultiCurve_3: typeof AppParCurves_MultiCurve_3;
  Font_SystemFont: typeof Font_SystemFont;
  Handle_Font_SystemFont: typeof Handle_Font_SystemFont;
  Handle_Font_SystemFont_1: typeof Handle_Font_SystemFont_1;
  Handle_Font_SystemFont_2: typeof Handle_Font_SystemFont_2;
  Handle_Font_SystemFont_3: typeof Handle_Font_SystemFont_3;
  Handle_Font_SystemFont_4: typeof Handle_Font_SystemFont_4;
  Font_UnicodeSubset: Font_UnicodeSubset;
  Handle_Font_FTLibrary: typeof Handle_Font_FTLibrary;
  Handle_Font_FTLibrary_1: typeof Handle_Font_FTLibrary_1;
  Handle_Font_FTLibrary_2: typeof Handle_Font_FTLibrary_2;
  Handle_Font_FTLibrary_3: typeof Handle_Font_FTLibrary_3;
  Handle_Font_FTLibrary_4: typeof Handle_Font_FTLibrary_4;
  Font_FTLibrary: typeof Font_FTLibrary;
  Font_FontAspect: Font_FontAspect;
  Font_StrictLevel: Font_StrictLevel;
  Font_Rect: typeof Font_Rect;
  Font_FontMgr: typeof Font_FontMgr;
  Handle_Font_FontMgr: typeof Handle_Font_FontMgr;
  Handle_Font_FontMgr_1: typeof Handle_Font_FontMgr_1;
  Handle_Font_FontMgr_2: typeof Handle_Font_FontMgr_2;
  Handle_Font_FontMgr_3: typeof Handle_Font_FontMgr_3;
  Handle_Font_FontMgr_4: typeof Handle_Font_FontMgr_4;
  Font_FTFontParams: typeof Font_FTFontParams;
  Font_FTFontParams_1: typeof Font_FTFontParams_1;
  Font_FTFontParams_2: typeof Font_FTFontParams_2;
  Font_FTFont: typeof Font_FTFont;
  Handle_Font_FTFont: typeof Handle_Font_FTFont;
  Handle_Font_FTFont_1: typeof Handle_Font_FTFont_1;
  Handle_Font_FTFont_2: typeof Handle_Font_FTFont_2;
  Handle_Font_FTFont_3: typeof Handle_Font_FTFont_3;
  Handle_Font_FTFont_4: typeof Handle_Font_FTFont_4;
  Font_TextFormatter: typeof Font_TextFormatter;
  Handle_Font_TextFormatter: typeof Handle_Font_TextFormatter;
  Handle_Font_TextFormatter_1: typeof Handle_Font_TextFormatter_1;
  Handle_Font_TextFormatter_2: typeof Handle_Font_TextFormatter_2;
  Handle_Font_TextFormatter_3: typeof Handle_Font_TextFormatter_3;
  Handle_Font_TextFormatter_4: typeof Handle_Font_TextFormatter_4;
  StepSelect_StepType: typeof StepSelect_StepType;
  Handle_StepSelect_StepType: typeof Handle_StepSelect_StepType;
  Handle_StepSelect_StepType_1: typeof Handle_StepSelect_StepType_1;
  Handle_StepSelect_StepType_2: typeof Handle_StepSelect_StepType_2;
  Handle_StepSelect_StepType_3: typeof Handle_StepSelect_StepType_3;
  Handle_StepSelect_StepType_4: typeof Handle_StepSelect_StepType_4;
  Handle_StepSelect_WorkLibrary: typeof Handle_StepSelect_WorkLibrary;
  Handle_StepSelect_WorkLibrary_1: typeof Handle_StepSelect_WorkLibrary_1;
  Handle_StepSelect_WorkLibrary_2: typeof Handle_StepSelect_WorkLibrary_2;
  Handle_StepSelect_WorkLibrary_3: typeof Handle_StepSelect_WorkLibrary_3;
  Handle_StepSelect_WorkLibrary_4: typeof Handle_StepSelect_WorkLibrary_4;
  StepSelect_WorkLibrary: typeof StepSelect_WorkLibrary;
  StepSelect_ModelModifier: typeof StepSelect_ModelModifier;
  Handle_StepSelect_ModelModifier: typeof Handle_StepSelect_ModelModifier;
  Handle_StepSelect_ModelModifier_1: typeof Handle_StepSelect_ModelModifier_1;
  Handle_StepSelect_ModelModifier_2: typeof Handle_StepSelect_ModelModifier_2;
  Handle_StepSelect_ModelModifier_3: typeof Handle_StepSelect_ModelModifier_3;
  Handle_StepSelect_ModelModifier_4: typeof Handle_StepSelect_ModelModifier_4;
  Handle_StepSelect_FloatFormat: typeof Handle_StepSelect_FloatFormat;
  Handle_StepSelect_FloatFormat_1: typeof Handle_StepSelect_FloatFormat_1;
  Handle_StepSelect_FloatFormat_2: typeof Handle_StepSelect_FloatFormat_2;
  Handle_StepSelect_FloatFormat_3: typeof Handle_StepSelect_FloatFormat_3;
  Handle_StepSelect_FloatFormat_4: typeof Handle_StepSelect_FloatFormat_4;
  StepSelect_FloatFormat: typeof StepSelect_FloatFormat;
  StepSelect_FileModifier: typeof StepSelect_FileModifier;
  Handle_StepSelect_FileModifier: typeof Handle_StepSelect_FileModifier;
  Handle_StepSelect_FileModifier_1: typeof Handle_StepSelect_FileModifier_1;
  Handle_StepSelect_FileModifier_2: typeof Handle_StepSelect_FileModifier_2;
  Handle_StepSelect_FileModifier_3: typeof Handle_StepSelect_FileModifier_3;
  Handle_StepSelect_FileModifier_4: typeof Handle_StepSelect_FileModifier_4;
  StepSelect_Activator: typeof StepSelect_Activator;
  Handle_StepSelect_Activator: typeof Handle_StepSelect_Activator;
  Handle_StepSelect_Activator_1: typeof Handle_StepSelect_Activator_1;
  Handle_StepSelect_Activator_2: typeof Handle_StepSelect_Activator_2;
  Handle_StepSelect_Activator_3: typeof Handle_StepSelect_Activator_3;
  Handle_StepSelect_Activator_4: typeof Handle_StepSelect_Activator_4;
  BRepToIGES_BRWire: typeof BRepToIGES_BRWire;
  BRepToIGES_BRWire_1: typeof BRepToIGES_BRWire_1;
  BRepToIGES_BRWire_2: typeof BRepToIGES_BRWire_2;
  BRepToIGES_BREntity: typeof BRepToIGES_BREntity;
  BRepToIGES_BRSolid: typeof BRepToIGES_BRSolid;
  BRepToIGES_BRSolid_1: typeof BRepToIGES_BRSolid_1;
  BRepToIGES_BRSolid_2: typeof BRepToIGES_BRSolid_2;
  BRepToIGES_BRShell: typeof BRepToIGES_BRShell;
  BRepToIGES_BRShell_1: typeof BRepToIGES_BRShell_1;
  BRepToIGES_BRShell_2: typeof BRepToIGES_BRShell_2;
  IntAna_Int3Pln: typeof IntAna_Int3Pln;
  IntAna_Int3Pln_1: typeof IntAna_Int3Pln_1;
  IntAna_Int3Pln_2: typeof IntAna_Int3Pln_2;
  IntAna_ResultType: IntAna_ResultType;
  IntAna_IntConicQuad: typeof IntAna_IntConicQuad;
  IntAna_IntConicQuad_1: typeof IntAna_IntConicQuad_1;
  IntAna_IntConicQuad_2: typeof IntAna_IntConicQuad_2;
  IntAna_IntConicQuad_3: typeof IntAna_IntConicQuad_3;
  IntAna_IntConicQuad_4: typeof IntAna_IntConicQuad_4;
  IntAna_IntConicQuad_5: typeof IntAna_IntConicQuad_5;
  IntAna_IntConicQuad_6: typeof IntAna_IntConicQuad_6;
  IntAna_IntConicQuad_7: typeof IntAna_IntConicQuad_7;
  IntAna_IntConicQuad_8: typeof IntAna_IntConicQuad_8;
  IntAna_IntConicQuad_9: typeof IntAna_IntConicQuad_9;
  IntAna_IntConicQuad_10: typeof IntAna_IntConicQuad_10;
  IntAna_IntConicQuad_11: typeof IntAna_IntConicQuad_11;
  IntAna_IntQuadQuad: typeof IntAna_IntQuadQuad;
  IntAna_IntQuadQuad_1: typeof IntAna_IntQuadQuad_1;
  IntAna_IntQuadQuad_2: typeof IntAna_IntQuadQuad_2;
  IntAna_IntQuadQuad_3: typeof IntAna_IntQuadQuad_3;
  IntAna_IntLinTorus: typeof IntAna_IntLinTorus;
  IntAna_IntLinTorus_1: typeof IntAna_IntLinTorus_1;
  IntAna_IntLinTorus_2: typeof IntAna_IntLinTorus_2;
  IntAna_QuadQuadGeo: typeof IntAna_QuadQuadGeo;
  IntAna_QuadQuadGeo_1: typeof IntAna_QuadQuadGeo_1;
  IntAna_QuadQuadGeo_2: typeof IntAna_QuadQuadGeo_2;
  IntAna_QuadQuadGeo_3: typeof IntAna_QuadQuadGeo_3;
  IntAna_QuadQuadGeo_4: typeof IntAna_QuadQuadGeo_4;
  IntAna_QuadQuadGeo_5: typeof IntAna_QuadQuadGeo_5;
  IntAna_QuadQuadGeo_6: typeof IntAna_QuadQuadGeo_6;
  IntAna_QuadQuadGeo_7: typeof IntAna_QuadQuadGeo_7;
  IntAna_QuadQuadGeo_8: typeof IntAna_QuadQuadGeo_8;
  IntAna_QuadQuadGeo_9: typeof IntAna_QuadQuadGeo_9;
  IntAna_QuadQuadGeo_10: typeof IntAna_QuadQuadGeo_10;
  IntAna_QuadQuadGeo_11: typeof IntAna_QuadQuadGeo_11;
  IntAna_QuadQuadGeo_12: typeof IntAna_QuadQuadGeo_12;
  IntAna_QuadQuadGeo_13: typeof IntAna_QuadQuadGeo_13;
  IntAna_QuadQuadGeo_14: typeof IntAna_QuadQuadGeo_14;
  IntAna_QuadQuadGeo_15: typeof IntAna_QuadQuadGeo_15;
  IntAna_QuadQuadGeo_16: typeof IntAna_QuadQuadGeo_16;
  IntAna_Curve: typeof IntAna_Curve;
  IntAna_ListOfCurve: typeof IntAna_ListOfCurve;
  IntAna_ListOfCurve_1: typeof IntAna_ListOfCurve_1;
  IntAna_ListOfCurve_2: typeof IntAna_ListOfCurve_2;
  IntAna_ListOfCurve_3: typeof IntAna_ListOfCurve_3;
  IntAna_Quadric: typeof IntAna_Quadric;
  IntAna_Quadric_1: typeof IntAna_Quadric_1;
  IntAna_Quadric_2: typeof IntAna_Quadric_2;
  IntAna_Quadric_3: typeof IntAna_Quadric_3;
  IntAna_Quadric_4: typeof IntAna_Quadric_4;
  IntAna_Quadric_5: typeof IntAna_Quadric_5;
  TPrsStd_AISPresentation: typeof TPrsStd_AISPresentation;
  Handle_TPrsStd_AISPresentation: typeof Handle_TPrsStd_AISPresentation;
  Handle_TPrsStd_AISPresentation_1: typeof Handle_TPrsStd_AISPresentation_1;
  Handle_TPrsStd_AISPresentation_2: typeof Handle_TPrsStd_AISPresentation_2;
  Handle_TPrsStd_AISPresentation_3: typeof Handle_TPrsStd_AISPresentation_3;
  Handle_TPrsStd_AISPresentation_4: typeof Handle_TPrsStd_AISPresentation_4;
  TPrsStd_ConstraintDriver: typeof TPrsStd_ConstraintDriver;
  Handle_TPrsStd_ConstraintDriver: typeof Handle_TPrsStd_ConstraintDriver;
  Handle_TPrsStd_ConstraintDriver_1: typeof Handle_TPrsStd_ConstraintDriver_1;
  Handle_TPrsStd_ConstraintDriver_2: typeof Handle_TPrsStd_ConstraintDriver_2;
  Handle_TPrsStd_ConstraintDriver_3: typeof Handle_TPrsStd_ConstraintDriver_3;
  Handle_TPrsStd_ConstraintDriver_4: typeof Handle_TPrsStd_ConstraintDriver_4;
  TPrsStd_Driver: typeof TPrsStd_Driver;
  Handle_TPrsStd_Driver: typeof Handle_TPrsStd_Driver;
  Handle_TPrsStd_Driver_1: typeof Handle_TPrsStd_Driver_1;
  Handle_TPrsStd_Driver_2: typeof Handle_TPrsStd_Driver_2;
  Handle_TPrsStd_Driver_3: typeof Handle_TPrsStd_Driver_3;
  Handle_TPrsStd_Driver_4: typeof Handle_TPrsStd_Driver_4;
  TPrsStd_GeometryDriver: typeof TPrsStd_GeometryDriver;
  Handle_TPrsStd_GeometryDriver: typeof Handle_TPrsStd_GeometryDriver;
  Handle_TPrsStd_GeometryDriver_1: typeof Handle_TPrsStd_GeometryDriver_1;
  Handle_TPrsStd_GeometryDriver_2: typeof Handle_TPrsStd_GeometryDriver_2;
  Handle_TPrsStd_GeometryDriver_3: typeof Handle_TPrsStd_GeometryDriver_3;
  Handle_TPrsStd_GeometryDriver_4: typeof Handle_TPrsStd_GeometryDriver_4;
  TPrsStd_PointDriver: typeof TPrsStd_PointDriver;
  Handle_TPrsStd_PointDriver: typeof Handle_TPrsStd_PointDriver;
  Handle_TPrsStd_PointDriver_1: typeof Handle_TPrsStd_PointDriver_1;
  Handle_TPrsStd_PointDriver_2: typeof Handle_TPrsStd_PointDriver_2;
  Handle_TPrsStd_PointDriver_3: typeof Handle_TPrsStd_PointDriver_3;
  Handle_TPrsStd_PointDriver_4: typeof Handle_TPrsStd_PointDriver_4;
  TPrsStd_ConstraintTools: typeof TPrsStd_ConstraintTools;
  Handle_TPrsStd_PlaneDriver: typeof Handle_TPrsStd_PlaneDriver;
  Handle_TPrsStd_PlaneDriver_1: typeof Handle_TPrsStd_PlaneDriver_1;
  Handle_TPrsStd_PlaneDriver_2: typeof Handle_TPrsStd_PlaneDriver_2;
  Handle_TPrsStd_PlaneDriver_3: typeof Handle_TPrsStd_PlaneDriver_3;
  Handle_TPrsStd_PlaneDriver_4: typeof Handle_TPrsStd_PlaneDriver_4;
  TPrsStd_PlaneDriver: typeof TPrsStd_PlaneDriver;
  TPrsStd_NamedShapeDriver: typeof TPrsStd_NamedShapeDriver;
  Handle_TPrsStd_NamedShapeDriver: typeof Handle_TPrsStd_NamedShapeDriver;
  Handle_TPrsStd_NamedShapeDriver_1: typeof Handle_TPrsStd_NamedShapeDriver_1;
  Handle_TPrsStd_NamedShapeDriver_2: typeof Handle_TPrsStd_NamedShapeDriver_2;
  Handle_TPrsStd_NamedShapeDriver_3: typeof Handle_TPrsStd_NamedShapeDriver_3;
  Handle_TPrsStd_NamedShapeDriver_4: typeof Handle_TPrsStd_NamedShapeDriver_4;
  TPrsStd_AxisDriver: typeof TPrsStd_AxisDriver;
  Handle_TPrsStd_AxisDriver: typeof Handle_TPrsStd_AxisDriver;
  Handle_TPrsStd_AxisDriver_1: typeof Handle_TPrsStd_AxisDriver_1;
  Handle_TPrsStd_AxisDriver_2: typeof Handle_TPrsStd_AxisDriver_2;
  Handle_TPrsStd_AxisDriver_3: typeof Handle_TPrsStd_AxisDriver_3;
  Handle_TPrsStd_AxisDriver_4: typeof Handle_TPrsStd_AxisDriver_4;
  TPrsStd_AISViewer: typeof TPrsStd_AISViewer;
  Handle_TPrsStd_AISViewer: typeof Handle_TPrsStd_AISViewer;
  Handle_TPrsStd_AISViewer_1: typeof Handle_TPrsStd_AISViewer_1;
  Handle_TPrsStd_AISViewer_2: typeof Handle_TPrsStd_AISViewer_2;
  Handle_TPrsStd_AISViewer_3: typeof Handle_TPrsStd_AISViewer_3;
  Handle_TPrsStd_AISViewer_4: typeof Handle_TPrsStd_AISViewer_4;
  Handle_TPrsStd_DriverTable: typeof Handle_TPrsStd_DriverTable;
  Handle_TPrsStd_DriverTable_1: typeof Handle_TPrsStd_DriverTable_1;
  Handle_TPrsStd_DriverTable_2: typeof Handle_TPrsStd_DriverTable_2;
  Handle_TPrsStd_DriverTable_3: typeof Handle_TPrsStd_DriverTable_3;
  Handle_TPrsStd_DriverTable_4: typeof Handle_TPrsStd_DriverTable_4;
  TPrsStd_DriverTable: typeof TPrsStd_DriverTable;
  GeomAbs_CurveType: GeomAbs_CurveType;
  GeomAbs_BSplKnotDistribution: GeomAbs_BSplKnotDistribution;
  GeomAbs_Shape: GeomAbs_Shape;
  GeomAbs_JoinType: GeomAbs_JoinType;
  GeomAbs_SurfaceType: GeomAbs_SurfaceType;
  GeomAbs_IsoType: GeomAbs_IsoType;
  Handle_Bisector_BisecCC: typeof Handle_Bisector_BisecCC;
  Handle_Bisector_BisecCC_1: typeof Handle_Bisector_BisecCC_1;
  Handle_Bisector_BisecCC_2: typeof Handle_Bisector_BisecCC_2;
  Handle_Bisector_BisecCC_3: typeof Handle_Bisector_BisecCC_3;
  Handle_Bisector_BisecCC_4: typeof Handle_Bisector_BisecCC_4;
  Bisector_BisecCC: typeof Bisector_BisecCC;
  Bisector_BisecCC_1: typeof Bisector_BisecCC_1;
  Bisector_BisecCC_2: typeof Bisector_BisecCC_2;
  Bisector_BisecAna: typeof Bisector_BisecAna;
  Handle_Bisector_BisecAna: typeof Handle_Bisector_BisecAna;
  Handle_Bisector_BisecAna_1: typeof Handle_Bisector_BisecAna_1;
  Handle_Bisector_BisecAna_2: typeof Handle_Bisector_BisecAna_2;
  Handle_Bisector_BisecAna_3: typeof Handle_Bisector_BisecAna_3;
  Handle_Bisector_BisecAna_4: typeof Handle_Bisector_BisecAna_4;
  Bisector_FunctionInter: typeof Bisector_FunctionInter;
  Bisector_FunctionInter_1: typeof Bisector_FunctionInter_1;
  Bisector_FunctionInter_2: typeof Bisector_FunctionInter_2;
  Bisector: typeof Bisector;
  Bisector_FunctionH: typeof Bisector_FunctionH;
  Bisector_Bisec: typeof Bisector_Bisec;
  Bisector_Inter: typeof Bisector_Inter;
  Bisector_Inter_1: typeof Bisector_Inter_1;
  Bisector_Inter_2: typeof Bisector_Inter_2;
  Bisector_BisecPC: typeof Bisector_BisecPC;
  Bisector_BisecPC_1: typeof Bisector_BisecPC_1;
  Bisector_BisecPC_2: typeof Bisector_BisecPC_2;
  Bisector_BisecPC_3: typeof Bisector_BisecPC_3;
  Handle_Bisector_BisecPC: typeof Handle_Bisector_BisecPC;
  Handle_Bisector_BisecPC_1: typeof Handle_Bisector_BisecPC_1;
  Handle_Bisector_BisecPC_2: typeof Handle_Bisector_BisecPC_2;
  Handle_Bisector_BisecPC_3: typeof Handle_Bisector_BisecPC_3;
  Handle_Bisector_BisecPC_4: typeof Handle_Bisector_BisecPC_4;
  Bisector_PolyBis: typeof Bisector_PolyBis;
  Handle_Bisector_Curve: typeof Handle_Bisector_Curve;
  Handle_Bisector_Curve_1: typeof Handle_Bisector_Curve_1;
  Handle_Bisector_Curve_2: typeof Handle_Bisector_Curve_2;
  Handle_Bisector_Curve_3: typeof Handle_Bisector_Curve_3;
  Handle_Bisector_Curve_4: typeof Handle_Bisector_Curve_4;
  Bisector_Curve: typeof Bisector_Curve;
  Bisector_PointOnBis: typeof Bisector_PointOnBis;
  Bisector_PointOnBis_1: typeof Bisector_PointOnBis_1;
  Bisector_PointOnBis_2: typeof Bisector_PointOnBis_2;
  Geom2dAPI_InterCurveCurve: typeof Geom2dAPI_InterCurveCurve;
  Geom2dAPI_InterCurveCurve_1: typeof Geom2dAPI_InterCurveCurve_1;
  Geom2dAPI_InterCurveCurve_2: typeof Geom2dAPI_InterCurveCurve_2;
  Geom2dAPI_InterCurveCurve_3: typeof Geom2dAPI_InterCurveCurve_3;
  Geom2dAPI_Interpolate: typeof Geom2dAPI_Interpolate;
  Geom2dAPI_Interpolate_1: typeof Geom2dAPI_Interpolate_1;
  Geom2dAPI_Interpolate_2: typeof Geom2dAPI_Interpolate_2;
  Geom2dAPI_ProjectPointOnCurve: typeof Geom2dAPI_ProjectPointOnCurve;
  Geom2dAPI_ProjectPointOnCurve_1: typeof Geom2dAPI_ProjectPointOnCurve_1;
  Geom2dAPI_ProjectPointOnCurve_2: typeof Geom2dAPI_ProjectPointOnCurve_2;
  Geom2dAPI_ProjectPointOnCurve_3: typeof Geom2dAPI_ProjectPointOnCurve_3;
  Geom2dAPI_PointsToBSpline: typeof Geom2dAPI_PointsToBSpline;
  Geom2dAPI_PointsToBSpline_1: typeof Geom2dAPI_PointsToBSpline_1;
  Geom2dAPI_PointsToBSpline_2: typeof Geom2dAPI_PointsToBSpline_2;
  Geom2dAPI_PointsToBSpline_3: typeof Geom2dAPI_PointsToBSpline_3;
  Geom2dAPI_PointsToBSpline_4: typeof Geom2dAPI_PointsToBSpline_4;
  Geom2dAPI_PointsToBSpline_5: typeof Geom2dAPI_PointsToBSpline_5;
  Geom2dAPI_PointsToBSpline_6: typeof Geom2dAPI_PointsToBSpline_6;
  Geom2dAPI_ExtremaCurveCurve: typeof Geom2dAPI_ExtremaCurveCurve;
  RWStepAP242_RWItemIdentifiedRepresentationUsage: typeof RWStepAP242_RWItemIdentifiedRepresentationUsage;
  RWStepAP242_RWDraughtingModelItemAssociation: typeof RWStepAP242_RWDraughtingModelItemAssociation;
  RWStepAP242_RWGeometricItemSpecificUsage: typeof RWStepAP242_RWGeometricItemSpecificUsage;
  RWStepAP242_RWIdAttribute: typeof RWStepAP242_RWIdAttribute;
  Handle_IGESDefs_GenericData: typeof Handle_IGESDefs_GenericData;
  Handle_IGESDefs_GenericData_1: typeof Handle_IGESDefs_GenericData_1;
  Handle_IGESDefs_GenericData_2: typeof Handle_IGESDefs_GenericData_2;
  Handle_IGESDefs_GenericData_3: typeof Handle_IGESDefs_GenericData_3;
  Handle_IGESDefs_GenericData_4: typeof Handle_IGESDefs_GenericData_4;
  IGESDefs_GenericData: typeof IGESDefs_GenericData;
  IGESDefs_ToolMacroDef: typeof IGESDefs_ToolMacroDef;
  IGESDefs_AttributeDef: typeof IGESDefs_AttributeDef;
  Handle_IGESDefs_AttributeDef: typeof Handle_IGESDefs_AttributeDef;
  Handle_IGESDefs_AttributeDef_1: typeof Handle_IGESDefs_AttributeDef_1;
  Handle_IGESDefs_AttributeDef_2: typeof Handle_IGESDefs_AttributeDef_2;
  Handle_IGESDefs_AttributeDef_3: typeof Handle_IGESDefs_AttributeDef_3;
  Handle_IGESDefs_AttributeDef_4: typeof Handle_IGESDefs_AttributeDef_4;
  IGESDefs_ToolAttributeDef: typeof IGESDefs_ToolAttributeDef;
  Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate: typeof Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate;
  Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_1: typeof Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_1;
  Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_2: typeof Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_2;
  Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_3: typeof Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_3;
  Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_4: typeof Handle_IGESDefs_HArray1OfHArray1OfTextDisplayTemplate_4;
  IGESDefs_HArray1OfHArray1OfTextDisplayTemplate: typeof IGESDefs_HArray1OfHArray1OfTextDisplayTemplate;
  Handle_IGESDefs_ReadWriteModule: typeof Handle_IGESDefs_ReadWriteModule;
  Handle_IGESDefs_ReadWriteModule_1: typeof Handle_IGESDefs_ReadWriteModule_1;
  Handle_IGESDefs_ReadWriteModule_2: typeof Handle_IGESDefs_ReadWriteModule_2;
  Handle_IGESDefs_ReadWriteModule_3: typeof Handle_IGESDefs_ReadWriteModule_3;
  Handle_IGESDefs_ReadWriteModule_4: typeof Handle_IGESDefs_ReadWriteModule_4;
  IGESDefs_ReadWriteModule: typeof IGESDefs_ReadWriteModule;
  Handle_IGESDefs_TabularData: typeof Handle_IGESDefs_TabularData;
  Handle_IGESDefs_TabularData_1: typeof Handle_IGESDefs_TabularData_1;
  Handle_IGESDefs_TabularData_2: typeof Handle_IGESDefs_TabularData_2;
  Handle_IGESDefs_TabularData_3: typeof Handle_IGESDefs_TabularData_3;
  Handle_IGESDefs_TabularData_4: typeof Handle_IGESDefs_TabularData_4;
  IGESDefs_TabularData: typeof IGESDefs_TabularData;
  IGESDefs_MacroDef: typeof IGESDefs_MacroDef;
  Handle_IGESDefs_MacroDef: typeof Handle_IGESDefs_MacroDef;
  Handle_IGESDefs_MacroDef_1: typeof Handle_IGESDefs_MacroDef_1;
  Handle_IGESDefs_MacroDef_2: typeof Handle_IGESDefs_MacroDef_2;
  Handle_IGESDefs_MacroDef_3: typeof Handle_IGESDefs_MacroDef_3;
  Handle_IGESDefs_MacroDef_4: typeof Handle_IGESDefs_MacroDef_4;
  IGESDefs_ToolAssociativityDef: typeof IGESDefs_ToolAssociativityDef;
  IGESDefs_ToolUnitsData: typeof IGESDefs_ToolUnitsData;
  Handle_IGESDefs_AttributeTable: typeof Handle_IGESDefs_AttributeTable;
  Handle_IGESDefs_AttributeTable_1: typeof Handle_IGESDefs_AttributeTable_1;
  Handle_IGESDefs_AttributeTable_2: typeof Handle_IGESDefs_AttributeTable_2;
  Handle_IGESDefs_AttributeTable_3: typeof Handle_IGESDefs_AttributeTable_3;
  Handle_IGESDefs_AttributeTable_4: typeof Handle_IGESDefs_AttributeTable_4;
  IGESDefs_AttributeTable: typeof IGESDefs_AttributeTable;
  IGESDefs: typeof IGESDefs;
  IGESDefs_ToolAttributeTable: typeof IGESDefs_ToolAttributeTable;
  IGESDefs_SpecificModule: typeof IGESDefs_SpecificModule;
  Handle_IGESDefs_SpecificModule: typeof Handle_IGESDefs_SpecificModule;
  Handle_IGESDefs_SpecificModule_1: typeof Handle_IGESDefs_SpecificModule_1;
  Handle_IGESDefs_SpecificModule_2: typeof Handle_IGESDefs_SpecificModule_2;
  Handle_IGESDefs_SpecificModule_3: typeof Handle_IGESDefs_SpecificModule_3;
  Handle_IGESDefs_SpecificModule_4: typeof Handle_IGESDefs_SpecificModule_4;
  Handle_IGESDefs_UnitsData: typeof Handle_IGESDefs_UnitsData;
  Handle_IGESDefs_UnitsData_1: typeof Handle_IGESDefs_UnitsData_1;
  Handle_IGESDefs_UnitsData_2: typeof Handle_IGESDefs_UnitsData_2;
  Handle_IGESDefs_UnitsData_3: typeof Handle_IGESDefs_UnitsData_3;
  Handle_IGESDefs_UnitsData_4: typeof Handle_IGESDefs_UnitsData_4;
  IGESDefs_UnitsData: typeof IGESDefs_UnitsData;
  Handle_IGESDefs_AssociativityDef: typeof Handle_IGESDefs_AssociativityDef;
  Handle_IGESDefs_AssociativityDef_1: typeof Handle_IGESDefs_AssociativityDef_1;
  Handle_IGESDefs_AssociativityDef_2: typeof Handle_IGESDefs_AssociativityDef_2;
  Handle_IGESDefs_AssociativityDef_3: typeof Handle_IGESDefs_AssociativityDef_3;
  Handle_IGESDefs_AssociativityDef_4: typeof Handle_IGESDefs_AssociativityDef_4;
  IGESDefs_AssociativityDef: typeof IGESDefs_AssociativityDef;
  IGESDefs_ToolGenericData: typeof IGESDefs_ToolGenericData;
  IGESDefs_ToolTabularData: typeof IGESDefs_ToolTabularData;
  IGESDefs_Protocol: typeof IGESDefs_Protocol;
  Handle_IGESDefs_Protocol: typeof Handle_IGESDefs_Protocol;
  Handle_IGESDefs_Protocol_1: typeof Handle_IGESDefs_Protocol_1;
  Handle_IGESDefs_Protocol_2: typeof Handle_IGESDefs_Protocol_2;
  Handle_IGESDefs_Protocol_3: typeof Handle_IGESDefs_Protocol_3;
  Handle_IGESDefs_Protocol_4: typeof Handle_IGESDefs_Protocol_4;
  IGESDefs_GeneralModule: typeof IGESDefs_GeneralModule;
  Handle_IGESDefs_GeneralModule: typeof Handle_IGESDefs_GeneralModule;
  Handle_IGESDefs_GeneralModule_1: typeof Handle_IGESDefs_GeneralModule_1;
  Handle_IGESDefs_GeneralModule_2: typeof Handle_IGESDefs_GeneralModule_2;
  Handle_IGESDefs_GeneralModule_3: typeof Handle_IGESDefs_GeneralModule_3;
  Handle_IGESDefs_GeneralModule_4: typeof Handle_IGESDefs_GeneralModule_4;
  Handle_IGESDefs_HArray1OfTabularData: typeof Handle_IGESDefs_HArray1OfTabularData;
  Handle_IGESDefs_HArray1OfTabularData_1: typeof Handle_IGESDefs_HArray1OfTabularData_1;
  Handle_IGESDefs_HArray1OfTabularData_2: typeof Handle_IGESDefs_HArray1OfTabularData_2;
  Handle_IGESDefs_HArray1OfTabularData_3: typeof Handle_IGESDefs_HArray1OfTabularData_3;
  Handle_IGESDefs_HArray1OfTabularData_4: typeof Handle_IGESDefs_HArray1OfTabularData_4;
  IntCurveSurface_TheCSFunctionOfHInter: typeof IntCurveSurface_TheCSFunctionOfHInter;
  IntCurveSurface_IntersectionSegment: typeof IntCurveSurface_IntersectionSegment;
  IntCurveSurface_IntersectionSegment_1: typeof IntCurveSurface_IntersectionSegment_1;
  IntCurveSurface_IntersectionSegment_2: typeof IntCurveSurface_IntersectionSegment_2;
  IntCurveSurface_TheExactHInter: typeof IntCurveSurface_TheExactHInter;
  IntCurveSurface_TheExactHInter_1: typeof IntCurveSurface_TheExactHInter_1;
  IntCurveSurface_TheExactHInter_2: typeof IntCurveSurface_TheExactHInter_2;
  IntCurveSurface_SequenceOfSeg: typeof IntCurveSurface_SequenceOfSeg;
  IntCurveSurface_SequenceOfSeg_1: typeof IntCurveSurface_SequenceOfSeg_1;
  IntCurveSurface_SequenceOfSeg_2: typeof IntCurveSurface_SequenceOfSeg_2;
  IntCurveSurface_SequenceOfSeg_3: typeof IntCurveSurface_SequenceOfSeg_3;
  IntCurveSurface_TheQuadCurvFuncOfTheQuadCurvExactHInter: typeof IntCurveSurface_TheQuadCurvFuncOfTheQuadCurvExactHInter;
  IntCurveSurface_ThePolygonToolOfHInter: typeof IntCurveSurface_ThePolygonToolOfHInter;
  IntCurveSurface_ThePolyhedronToolOfHInter: typeof IntCurveSurface_ThePolyhedronToolOfHInter;
  IntCurveSurface_TransitionOnCurve: IntCurveSurface_TransitionOnCurve;
  IntCurveSurface_IntersectionPoint: typeof IntCurveSurface_IntersectionPoint;
  IntCurveSurface_IntersectionPoint_1: typeof IntCurveSurface_IntersectionPoint_1;
  IntCurveSurface_IntersectionPoint_2: typeof IntCurveSurface_IntersectionPoint_2;
  IntCurveSurface_SequenceOfPnt: typeof IntCurveSurface_SequenceOfPnt;
  IntCurveSurface_SequenceOfPnt_1: typeof IntCurveSurface_SequenceOfPnt_1;
  IntCurveSurface_SequenceOfPnt_2: typeof IntCurveSurface_SequenceOfPnt_2;
  IntCurveSurface_SequenceOfPnt_3: typeof IntCurveSurface_SequenceOfPnt_3;
  IntCurveSurface_ThePolygonOfHInter: typeof IntCurveSurface_ThePolygonOfHInter;
  IntCurveSurface_ThePolygonOfHInter_1: typeof IntCurveSurface_ThePolygonOfHInter_1;
  IntCurveSurface_ThePolygonOfHInter_2: typeof IntCurveSurface_ThePolygonOfHInter_2;
  IntCurveSurface_ThePolygonOfHInter_3: typeof IntCurveSurface_ThePolygonOfHInter_3;
  IntCurveSurface_TheInterferenceOfHInter: typeof IntCurveSurface_TheInterferenceOfHInter;
  IntCurveSurface_TheInterferenceOfHInter_1: typeof IntCurveSurface_TheInterferenceOfHInter_1;
  IntCurveSurface_TheInterferenceOfHInter_2: typeof IntCurveSurface_TheInterferenceOfHInter_2;
  IntCurveSurface_TheInterferenceOfHInter_3: typeof IntCurveSurface_TheInterferenceOfHInter_3;
  IntCurveSurface_TheInterferenceOfHInter_4: typeof IntCurveSurface_TheInterferenceOfHInter_4;
  IntCurveSurface_TheInterferenceOfHInter_5: typeof IntCurveSurface_TheInterferenceOfHInter_5;
  IntCurveSurface_TheInterferenceOfHInter_6: typeof IntCurveSurface_TheInterferenceOfHInter_6;
  IntCurveSurface_TheInterferenceOfHInter_7: typeof IntCurveSurface_TheInterferenceOfHInter_7;
  IntCurveSurface_HInter: typeof IntCurveSurface_HInter;
  IntCurveSurface_TheHCurveTool: typeof IntCurveSurface_TheHCurveTool;
  IntCurveSurface_Intersection: typeof IntCurveSurface_Intersection;
  IntCurveSurface_TheQuadCurvExactHInter: typeof IntCurveSurface_TheQuadCurvExactHInter;
  StdStorage_HeaderData: typeof StdStorage_HeaderData;
  Handle_StdStorage_HeaderData: typeof Handle_StdStorage_HeaderData;
  Handle_StdStorage_HeaderData_1: typeof Handle_StdStorage_HeaderData_1;
  Handle_StdStorage_HeaderData_2: typeof Handle_StdStorage_HeaderData_2;
  Handle_StdStorage_HeaderData_3: typeof Handle_StdStorage_HeaderData_3;
  Handle_StdStorage_HeaderData_4: typeof Handle_StdStorage_HeaderData_4;
  Handle_StdStorage_HSequenceOfRoots: typeof Handle_StdStorage_HSequenceOfRoots;
  Handle_StdStorage_HSequenceOfRoots_1: typeof Handle_StdStorage_HSequenceOfRoots_1;
  Handle_StdStorage_HSequenceOfRoots_2: typeof Handle_StdStorage_HSequenceOfRoots_2;
  Handle_StdStorage_HSequenceOfRoots_3: typeof Handle_StdStorage_HSequenceOfRoots_3;
  Handle_StdStorage_HSequenceOfRoots_4: typeof Handle_StdStorage_HSequenceOfRoots_4;
  StdStorage: typeof StdStorage;
  StdStorage_BucketIterator: typeof StdStorage_BucketIterator;
  StdStorage_BucketOfPersistent: typeof StdStorage_BucketOfPersistent;
  StdStorage_Bucket: typeof StdStorage_Bucket;
  StdStorage_Bucket_1: typeof StdStorage_Bucket_1;
  StdStorage_Bucket_2: typeof StdStorage_Bucket_2;
  Handle_StdStorage_TypeData: typeof Handle_StdStorage_TypeData;
  Handle_StdStorage_TypeData_1: typeof Handle_StdStorage_TypeData_1;
  Handle_StdStorage_TypeData_2: typeof Handle_StdStorage_TypeData_2;
  Handle_StdStorage_TypeData_3: typeof Handle_StdStorage_TypeData_3;
  Handle_StdStorage_TypeData_4: typeof Handle_StdStorage_TypeData_4;
  StdStorage_TypeData: typeof StdStorage_TypeData;
  StdStorage_RootData: typeof StdStorage_RootData;
  Handle_StdStorage_RootData: typeof Handle_StdStorage_RootData;
  Handle_StdStorage_RootData_1: typeof Handle_StdStorage_RootData_1;
  Handle_StdStorage_RootData_2: typeof Handle_StdStorage_RootData_2;
  Handle_StdStorage_RootData_3: typeof Handle_StdStorage_RootData_3;
  Handle_StdStorage_RootData_4: typeof Handle_StdStorage_RootData_4;
  Handle_StdStorage_Root: typeof Handle_StdStorage_Root;
  Handle_StdStorage_Root_1: typeof Handle_StdStorage_Root_1;
  Handle_StdStorage_Root_2: typeof Handle_StdStorage_Root_2;
  Handle_StdStorage_Root_3: typeof Handle_StdStorage_Root_3;
  Handle_StdStorage_Root_4: typeof Handle_StdStorage_Root_4;
  StdStorage_Root: typeof StdStorage_Root;
  StdStorage_Root_1: typeof StdStorage_Root_1;
  StdStorage_Root_2: typeof StdStorage_Root_2;
  StdStorage_Data: typeof StdStorage_Data;
  Handle_Select3D_SensitiveSegment: typeof Handle_Select3D_SensitiveSegment;
  Handle_Select3D_SensitiveSegment_1: typeof Handle_Select3D_SensitiveSegment_1;
  Handle_Select3D_SensitiveSegment_2: typeof Handle_Select3D_SensitiveSegment_2;
  Handle_Select3D_SensitiveSegment_3: typeof Handle_Select3D_SensitiveSegment_3;
  Handle_Select3D_SensitiveSegment_4: typeof Handle_Select3D_SensitiveSegment_4;
  Select3D_SensitiveSegment: typeof Select3D_SensitiveSegment;
  Select3D_TypeOfSensitivity: Select3D_TypeOfSensitivity;
  Select3D_SensitiveSet: typeof Select3D_SensitiveSet;
  Handle_Select3D_SensitiveSet: typeof Handle_Select3D_SensitiveSet;
  Handle_Select3D_SensitiveSet_1: typeof Handle_Select3D_SensitiveSet_1;
  Handle_Select3D_SensitiveSet_2: typeof Handle_Select3D_SensitiveSet_2;
  Handle_Select3D_SensitiveSet_3: typeof Handle_Select3D_SensitiveSet_3;
  Handle_Select3D_SensitiveSet_4: typeof Handle_Select3D_SensitiveSet_4;
  Handle_Select3D_SensitiveCircle: typeof Handle_Select3D_SensitiveCircle;
  Handle_Select3D_SensitiveCircle_1: typeof Handle_Select3D_SensitiveCircle_1;
  Handle_Select3D_SensitiveCircle_2: typeof Handle_Select3D_SensitiveCircle_2;
  Handle_Select3D_SensitiveCircle_3: typeof Handle_Select3D_SensitiveCircle_3;
  Handle_Select3D_SensitiveCircle_4: typeof Handle_Select3D_SensitiveCircle_4;
  Select3D_SensitiveCircle: typeof Select3D_SensitiveCircle;
  Select3D_SensitiveCircle_1: typeof Select3D_SensitiveCircle_1;
  Select3D_SensitiveCircle_2: typeof Select3D_SensitiveCircle_2;
  Select3D_SensitiveCircle_3: typeof Select3D_SensitiveCircle_3;
  Select3D_SensitiveCircle_4: typeof Select3D_SensitiveCircle_4;
  Select3D_PointData: typeof Select3D_PointData;
  Handle_Select3D_SensitiveWire: typeof Handle_Select3D_SensitiveWire;
  Handle_Select3D_SensitiveWire_1: typeof Handle_Select3D_SensitiveWire_1;
  Handle_Select3D_SensitiveWire_2: typeof Handle_Select3D_SensitiveWire_2;
  Handle_Select3D_SensitiveWire_3: typeof Handle_Select3D_SensitiveWire_3;
  Handle_Select3D_SensitiveWire_4: typeof Handle_Select3D_SensitiveWire_4;
  Select3D_SensitiveWire: typeof Select3D_SensitiveWire;
  Handle_Select3D_SensitivePrimitiveArray: typeof Handle_Select3D_SensitivePrimitiveArray;
  Handle_Select3D_SensitivePrimitiveArray_1: typeof Handle_Select3D_SensitivePrimitiveArray_1;
  Handle_Select3D_SensitivePrimitiveArray_2: typeof Handle_Select3D_SensitivePrimitiveArray_2;
  Handle_Select3D_SensitivePrimitiveArray_3: typeof Handle_Select3D_SensitivePrimitiveArray_3;
  Handle_Select3D_SensitivePrimitiveArray_4: typeof Handle_Select3D_SensitivePrimitiveArray_4;
  Select3D_SensitivePrimitiveArray: typeof Select3D_SensitivePrimitiveArray;
  Select3D_SensitiveFace: typeof Select3D_SensitiveFace;
  Select3D_SensitiveFace_1: typeof Select3D_SensitiveFace_1;
  Select3D_SensitiveFace_2: typeof Select3D_SensitiveFace_2;
  Handle_Select3D_SensitiveFace: typeof Handle_Select3D_SensitiveFace;
  Handle_Select3D_SensitiveFace_1: typeof Handle_Select3D_SensitiveFace_1;
  Handle_Select3D_SensitiveFace_2: typeof Handle_Select3D_SensitiveFace_2;
  Handle_Select3D_SensitiveFace_3: typeof Handle_Select3D_SensitiveFace_3;
  Handle_Select3D_SensitiveFace_4: typeof Handle_Select3D_SensitiveFace_4;
  Handle_Select3D_InteriorSensitivePointSet: typeof Handle_Select3D_InteriorSensitivePointSet;
  Handle_Select3D_InteriorSensitivePointSet_1: typeof Handle_Select3D_InteriorSensitivePointSet_1;
  Handle_Select3D_InteriorSensitivePointSet_2: typeof Handle_Select3D_InteriorSensitivePointSet_2;
  Handle_Select3D_InteriorSensitivePointSet_3: typeof Handle_Select3D_InteriorSensitivePointSet_3;
  Handle_Select3D_InteriorSensitivePointSet_4: typeof Handle_Select3D_InteriorSensitivePointSet_4;
  Select3D_InteriorSensitivePointSet: typeof Select3D_InteriorSensitivePointSet;
  Select3D_SensitivePoly: typeof Select3D_SensitivePoly;
  Select3D_SensitivePoly_1: typeof Select3D_SensitivePoly_1;
  Select3D_SensitivePoly_2: typeof Select3D_SensitivePoly_2;
  Select3D_SensitivePoly_3: typeof Select3D_SensitivePoly_3;
  Handle_Select3D_SensitivePoly: typeof Handle_Select3D_SensitivePoly;
  Handle_Select3D_SensitivePoly_1: typeof Handle_Select3D_SensitivePoly_1;
  Handle_Select3D_SensitivePoly_2: typeof Handle_Select3D_SensitivePoly_2;
  Handle_Select3D_SensitivePoly_3: typeof Handle_Select3D_SensitivePoly_3;
  Handle_Select3D_SensitivePoly_4: typeof Handle_Select3D_SensitivePoly_4;
  Select3D_Pnt: typeof Select3D_Pnt;
  Select3D_SensitiveBox: typeof Select3D_SensitiveBox;
  Select3D_SensitiveBox_1: typeof Select3D_SensitiveBox_1;
  Select3D_SensitiveBox_2: typeof Select3D_SensitiveBox_2;
  Handle_Select3D_SensitiveBox: typeof Handle_Select3D_SensitiveBox;
  Handle_Select3D_SensitiveBox_1: typeof Handle_Select3D_SensitiveBox_1;
  Handle_Select3D_SensitiveBox_2: typeof Handle_Select3D_SensitiveBox_2;
  Handle_Select3D_SensitiveBox_3: typeof Handle_Select3D_SensitiveBox_3;
  Handle_Select3D_SensitiveBox_4: typeof Handle_Select3D_SensitiveBox_4;
  Select3D_BVHIndexBuffer: typeof Select3D_BVHIndexBuffer;
  Handle_Select3D_BVHIndexBuffer: typeof Handle_Select3D_BVHIndexBuffer;
  Handle_Select3D_BVHIndexBuffer_1: typeof Handle_Select3D_BVHIndexBuffer_1;
  Handle_Select3D_BVHIndexBuffer_2: typeof Handle_Select3D_BVHIndexBuffer_2;
  Handle_Select3D_BVHIndexBuffer_3: typeof Handle_Select3D_BVHIndexBuffer_3;
  Handle_Select3D_BVHIndexBuffer_4: typeof Handle_Select3D_BVHIndexBuffer_4;
  Handle_Select3D_SensitiveEntity: typeof Handle_Select3D_SensitiveEntity;
  Handle_Select3D_SensitiveEntity_1: typeof Handle_Select3D_SensitiveEntity_1;
  Handle_Select3D_SensitiveEntity_2: typeof Handle_Select3D_SensitiveEntity_2;
  Handle_Select3D_SensitiveEntity_3: typeof Handle_Select3D_SensitiveEntity_3;
  Handle_Select3D_SensitiveEntity_4: typeof Handle_Select3D_SensitiveEntity_4;
  Select3D_SensitiveEntity: typeof Select3D_SensitiveEntity;
  Select3D_SensitiveGroup: typeof Select3D_SensitiveGroup;
  Select3D_SensitiveGroup_1: typeof Select3D_SensitiveGroup_1;
  Select3D_SensitiveGroup_2: typeof Select3D_SensitiveGroup_2;
  Handle_Select3D_SensitiveGroup: typeof Handle_Select3D_SensitiveGroup;
  Handle_Select3D_SensitiveGroup_1: typeof Handle_Select3D_SensitiveGroup_1;
  Handle_Select3D_SensitiveGroup_2: typeof Handle_Select3D_SensitiveGroup_2;
  Handle_Select3D_SensitiveGroup_3: typeof Handle_Select3D_SensitiveGroup_3;
  Handle_Select3D_SensitiveGroup_4: typeof Handle_Select3D_SensitiveGroup_4;
  Handle_Select3D_SensitivePoint: typeof Handle_Select3D_SensitivePoint;
  Handle_Select3D_SensitivePoint_1: typeof Handle_Select3D_SensitivePoint_1;
  Handle_Select3D_SensitivePoint_2: typeof Handle_Select3D_SensitivePoint_2;
  Handle_Select3D_SensitivePoint_3: typeof Handle_Select3D_SensitivePoint_3;
  Handle_Select3D_SensitivePoint_4: typeof Handle_Select3D_SensitivePoint_4;
  Select3D_SensitivePoint: typeof Select3D_SensitivePoint;
  Handle_Select3D_SensitiveCurve: typeof Handle_Select3D_SensitiveCurve;
  Handle_Select3D_SensitiveCurve_1: typeof Handle_Select3D_SensitiveCurve_1;
  Handle_Select3D_SensitiveCurve_2: typeof Handle_Select3D_SensitiveCurve_2;
  Handle_Select3D_SensitiveCurve_3: typeof Handle_Select3D_SensitiveCurve_3;
  Handle_Select3D_SensitiveCurve_4: typeof Handle_Select3D_SensitiveCurve_4;
  Select3D_SensitiveCurve: typeof Select3D_SensitiveCurve;
  Select3D_SensitiveCurve_1: typeof Select3D_SensitiveCurve_1;
  Select3D_SensitiveCurve_2: typeof Select3D_SensitiveCurve_2;
  Select3D_SensitiveCurve_3: typeof Select3D_SensitiveCurve_3;
  Handle_Select3D_SensitiveTriangulation: typeof Handle_Select3D_SensitiveTriangulation;
  Handle_Select3D_SensitiveTriangulation_1: typeof Handle_Select3D_SensitiveTriangulation_1;
  Handle_Select3D_SensitiveTriangulation_2: typeof Handle_Select3D_SensitiveTriangulation_2;
  Handle_Select3D_SensitiveTriangulation_3: typeof Handle_Select3D_SensitiveTriangulation_3;
  Handle_Select3D_SensitiveTriangulation_4: typeof Handle_Select3D_SensitiveTriangulation_4;
  Select3D_SensitiveTriangulation: typeof Select3D_SensitiveTriangulation;
  Select3D_SensitiveTriangulation_1: typeof Select3D_SensitiveTriangulation_1;
  Select3D_SensitiveTriangulation_2: typeof Select3D_SensitiveTriangulation_2;
  Handle_Select3D_SensitiveTriangle: typeof Handle_Select3D_SensitiveTriangle;
  Handle_Select3D_SensitiveTriangle_1: typeof Handle_Select3D_SensitiveTriangle_1;
  Handle_Select3D_SensitiveTriangle_2: typeof Handle_Select3D_SensitiveTriangle_2;
  Handle_Select3D_SensitiveTriangle_3: typeof Handle_Select3D_SensitiveTriangle_3;
  Handle_Select3D_SensitiveTriangle_4: typeof Handle_Select3D_SensitiveTriangle_4;
  Select3D_SensitiveTriangle: typeof Select3D_SensitiveTriangle;
  Extrema_PCFOfEPCOfExtPC: typeof Extrema_PCFOfEPCOfExtPC;
  Extrema_PCFOfEPCOfExtPC_1: typeof Extrema_PCFOfEPCOfExtPC_1;
  Extrema_PCFOfEPCOfExtPC_2: typeof Extrema_PCFOfEPCOfExtPC_2;
  Extrema_LocEPCOfLocateExtPC: typeof Extrema_LocEPCOfLocateExtPC;
  Extrema_LocEPCOfLocateExtPC_1: typeof Extrema_LocEPCOfLocateExtPC_1;
  Extrema_LocEPCOfLocateExtPC_2: typeof Extrema_LocEPCOfLocateExtPC_2;
  Extrema_LocEPCOfLocateExtPC_3: typeof Extrema_LocEPCOfLocateExtPC_3;
  Extrema_ExtPC: typeof Extrema_ExtPC;
  Extrema_ExtPC_1: typeof Extrema_ExtPC_1;
  Extrema_ExtPC_2: typeof Extrema_ExtPC_2;
  Extrema_ExtPC_3: typeof Extrema_ExtPC_3;
  Extrema_PCLocFOfLocEPCOfLocateExtPC2d: typeof Extrema_PCLocFOfLocEPCOfLocateExtPC2d;
  Extrema_PCLocFOfLocEPCOfLocateExtPC2d_1: typeof Extrema_PCLocFOfLocEPCOfLocateExtPC2d_1;
  Extrema_PCLocFOfLocEPCOfLocateExtPC2d_2: typeof Extrema_PCLocFOfLocEPCOfLocateExtPC2d_2;
  Extrema_ELPCOfLocateExtPC2d: typeof Extrema_ELPCOfLocateExtPC2d;
  Extrema_ELPCOfLocateExtPC2d_1: typeof Extrema_ELPCOfLocateExtPC2d_1;
  Extrema_ELPCOfLocateExtPC2d_2: typeof Extrema_ELPCOfLocateExtPC2d_2;
  Extrema_ELPCOfLocateExtPC2d_3: typeof Extrema_ELPCOfLocateExtPC2d_3;
  Extrema_Array1OfPOnSurf: typeof Extrema_Array1OfPOnSurf;
  Extrema_Array1OfPOnSurf_1: typeof Extrema_Array1OfPOnSurf_1;
  Extrema_Array1OfPOnSurf_2: typeof Extrema_Array1OfPOnSurf_2;
  Extrema_Array1OfPOnSurf_3: typeof Extrema_Array1OfPOnSurf_3;
  Extrema_Array1OfPOnSurf_4: typeof Extrema_Array1OfPOnSurf_4;
  Extrema_Array1OfPOnSurf_5: typeof Extrema_Array1OfPOnSurf_5;
  Extrema_SequenceOfPOnCurv: typeof Extrema_SequenceOfPOnCurv;
  Extrema_SequenceOfPOnCurv_1: typeof Extrema_SequenceOfPOnCurv_1;
  Extrema_SequenceOfPOnCurv_2: typeof Extrema_SequenceOfPOnCurv_2;
  Extrema_SequenceOfPOnCurv_3: typeof Extrema_SequenceOfPOnCurv_3;
  Extrema_FuncPSNorm: typeof Extrema_FuncPSNorm;
  Extrema_FuncPSNorm_1: typeof Extrema_FuncPSNorm_1;
  Extrema_FuncPSNorm_2: typeof Extrema_FuncPSNorm_2;
  Extrema_ExtCS: typeof Extrema_ExtCS;
  Extrema_ExtCS_1: typeof Extrema_ExtCS_1;
  Extrema_ExtCS_2: typeof Extrema_ExtCS_2;
  Extrema_ExtCS_3: typeof Extrema_ExtCS_3;
  Extrema_EPCOfELPCOfLocateExtPC2d: typeof Extrema_EPCOfELPCOfLocateExtPC2d;
  Extrema_EPCOfELPCOfLocateExtPC2d_1: typeof Extrema_EPCOfELPCOfLocateExtPC2d_1;
  Extrema_EPCOfELPCOfLocateExtPC2d_2: typeof Extrema_EPCOfELPCOfLocateExtPC2d_2;
  Extrema_EPCOfELPCOfLocateExtPC2d_3: typeof Extrema_EPCOfELPCOfLocateExtPC2d_3;
  Extrema_ExtElSS: typeof Extrema_ExtElSS;
  Extrema_ExtElSS_1: typeof Extrema_ExtElSS_1;
  Extrema_ExtElSS_2: typeof Extrema_ExtElSS_2;
  Extrema_ExtElSS_3: typeof Extrema_ExtElSS_3;
  Extrema_ExtElSS_4: typeof Extrema_ExtElSS_4;
  Extrema_ExtElSS_5: typeof Extrema_ExtElSS_5;
  Extrema_ExtElSS_6: typeof Extrema_ExtElSS_6;
  Extrema_ExtElSS_7: typeof Extrema_ExtElSS_7;
  Extrema_CCLocFOfLocECC: typeof Extrema_CCLocFOfLocECC;
  Extrema_CCLocFOfLocECC_1: typeof Extrema_CCLocFOfLocECC_1;
  Extrema_CCLocFOfLocECC_2: typeof Extrema_CCLocFOfLocECC_2;
  Extrema_ELPCOfLocateExtPC: typeof Extrema_ELPCOfLocateExtPC;
  Extrema_ELPCOfLocateExtPC_1: typeof Extrema_ELPCOfLocateExtPC_1;
  Extrema_ELPCOfLocateExtPC_2: typeof Extrema_ELPCOfLocateExtPC_2;
  Extrema_ELPCOfLocateExtPC_3: typeof Extrema_ELPCOfLocateExtPC_3;
  Extrema_ECC2d: typeof Extrema_ECC2d;
  Extrema_ECC2d_1: typeof Extrema_ECC2d_1;
  Extrema_ECC2d_2: typeof Extrema_ECC2d_2;
  Extrema_ECC2d_3: typeof Extrema_ECC2d_3;
  Extrema_FuncExtSS: typeof Extrema_FuncExtSS;
  Extrema_FuncExtSS_1: typeof Extrema_FuncExtSS_1;
  Extrema_FuncExtSS_2: typeof Extrema_FuncExtSS_2;
  Extrema_ExtPElS: typeof Extrema_ExtPElS;
  Extrema_ExtPElS_1: typeof Extrema_ExtPElS_1;
  Extrema_ExtPElS_2: typeof Extrema_ExtPElS_2;
  Extrema_ExtPElS_3: typeof Extrema_ExtPElS_3;
  Extrema_ExtPElS_4: typeof Extrema_ExtPElS_4;
  Extrema_ExtPElS_5: typeof Extrema_ExtPElS_5;
  Extrema_ExtPElS_6: typeof Extrema_ExtPElS_6;
  Extrema_GenLocateExtPS: typeof Extrema_GenLocateExtPS;
  Extrema_ExtElC: typeof Extrema_ExtElC;
  Extrema_ExtElC_1: typeof Extrema_ExtElC_1;
  Extrema_ExtElC_2: typeof Extrema_ExtElC_2;
  Extrema_ExtElC_3: typeof Extrema_ExtElC_3;
  Extrema_ExtElC_4: typeof Extrema_ExtElC_4;
  Extrema_ExtElC_5: typeof Extrema_ExtElC_5;
  Extrema_ExtElC_6: typeof Extrema_ExtElC_6;
  Extrema_ExtElC_7: typeof Extrema_ExtElC_7;
  Extrema_LocECC: typeof Extrema_LocECC;
  Extrema_LocateExtPC2d: typeof Extrema_LocateExtPC2d;
  Extrema_LocateExtPC2d_1: typeof Extrema_LocateExtPC2d_1;
  Extrema_LocateExtPC2d_2: typeof Extrema_LocateExtPC2d_2;
  Extrema_LocateExtPC2d_3: typeof Extrema_LocateExtPC2d_3;
  Extrema_Array2OfPOnSurfParams: typeof Extrema_Array2OfPOnSurfParams;
  Extrema_Array2OfPOnSurfParams_1: typeof Extrema_Array2OfPOnSurfParams_1;
  Extrema_Array2OfPOnSurfParams_2: typeof Extrema_Array2OfPOnSurfParams_2;
  Extrema_Array2OfPOnSurfParams_3: typeof Extrema_Array2OfPOnSurfParams_3;
  Extrema_Array2OfPOnSurfParams_4: typeof Extrema_Array2OfPOnSurfParams_4;
  Extrema_Array2OfPOnSurfParams_5: typeof Extrema_Array2OfPOnSurfParams_5;
  Extrema_FuncPSDist: typeof Extrema_FuncPSDist;
  Extrema_ExtCC: typeof Extrema_ExtCC;
  Extrema_ExtCC_1: typeof Extrema_ExtCC_1;
  Extrema_ExtCC_2: typeof Extrema_ExtCC_2;
  Extrema_ExtCC_3: typeof Extrema_ExtCC_3;
  Extrema_ExtPS: typeof Extrema_ExtPS;
  Extrema_ExtPS_1: typeof Extrema_ExtPS_1;
  Extrema_ExtPS_2: typeof Extrema_ExtPS_2;
  Extrema_ExtPS_3: typeof Extrema_ExtPS_3;
  Handle_Extrema_HArray2OfPOnCurv: typeof Handle_Extrema_HArray2OfPOnCurv;
  Handle_Extrema_HArray2OfPOnCurv_1: typeof Handle_Extrema_HArray2OfPOnCurv_1;
  Handle_Extrema_HArray2OfPOnCurv_2: typeof Handle_Extrema_HArray2OfPOnCurv_2;
  Handle_Extrema_HArray2OfPOnCurv_3: typeof Handle_Extrema_HArray2OfPOnCurv_3;
  Handle_Extrema_HArray2OfPOnCurv_4: typeof Handle_Extrema_HArray2OfPOnCurv_4;
  Handle_Extrema_HArray1OfPOnSurf: typeof Handle_Extrema_HArray1OfPOnSurf;
  Handle_Extrema_HArray1OfPOnSurf_1: typeof Handle_Extrema_HArray1OfPOnSurf_1;
  Handle_Extrema_HArray1OfPOnSurf_2: typeof Handle_Extrema_HArray1OfPOnSurf_2;
  Handle_Extrema_HArray1OfPOnSurf_3: typeof Handle_Extrema_HArray1OfPOnSurf_3;
  Handle_Extrema_HArray1OfPOnSurf_4: typeof Handle_Extrema_HArray1OfPOnSurf_4;
  Extrema_ElementType: Extrema_ElementType;
  Extrema_ExtPC2d: typeof Extrema_ExtPC2d;
  Extrema_ExtPC2d_1: typeof Extrema_ExtPC2d_1;
  Extrema_ExtPC2d_2: typeof Extrema_ExtPC2d_2;
  Extrema_ExtPC2d_3: typeof Extrema_ExtPC2d_3;
  Extrema_GlobOptFuncCCC0: typeof Extrema_GlobOptFuncCCC0;
  Extrema_GlobOptFuncCCC0_1: typeof Extrema_GlobOptFuncCCC0_1;
  Extrema_GlobOptFuncCCC0_2: typeof Extrema_GlobOptFuncCCC0_2;
  Extrema_GlobOptFuncCCC2: typeof Extrema_GlobOptFuncCCC2;
  Extrema_GlobOptFuncCCC2_1: typeof Extrema_GlobOptFuncCCC2_1;
  Extrema_GlobOptFuncCCC2_2: typeof Extrema_GlobOptFuncCCC2_2;
  Extrema_GlobOptFuncCCC1: typeof Extrema_GlobOptFuncCCC1;
  Extrema_GlobOptFuncCCC1_1: typeof Extrema_GlobOptFuncCCC1_1;
  Extrema_GlobOptFuncCCC1_2: typeof Extrema_GlobOptFuncCCC1_2;
  Extrema_Array2OfPOnCurv2d: typeof Extrema_Array2OfPOnCurv2d;
  Extrema_Array2OfPOnCurv2d_1: typeof Extrema_Array2OfPOnCurv2d_1;
  Extrema_Array2OfPOnCurv2d_2: typeof Extrema_Array2OfPOnCurv2d_2;
  Extrema_Array2OfPOnCurv2d_3: typeof Extrema_Array2OfPOnCurv2d_3;
  Extrema_Array2OfPOnCurv2d_4: typeof Extrema_Array2OfPOnCurv2d_4;
  Extrema_Array2OfPOnCurv2d_5: typeof Extrema_Array2OfPOnCurv2d_5;
  Extrema_GlobOptFuncCQuadric: typeof Extrema_GlobOptFuncCQuadric;
  Extrema_GlobOptFuncCQuadric_1: typeof Extrema_GlobOptFuncCQuadric_1;
  Extrema_GlobOptFuncCQuadric_2: typeof Extrema_GlobOptFuncCQuadric_2;
  Extrema_GlobOptFuncCQuadric_3: typeof Extrema_GlobOptFuncCQuadric_3;
  Extrema_SequenceOfPOnSurf: typeof Extrema_SequenceOfPOnSurf;
  Extrema_SequenceOfPOnSurf_1: typeof Extrema_SequenceOfPOnSurf_1;
  Extrema_SequenceOfPOnSurf_2: typeof Extrema_SequenceOfPOnSurf_2;
  Extrema_SequenceOfPOnSurf_3: typeof Extrema_SequenceOfPOnSurf_3;
  Extrema_PCFOfEPCOfExtPC2d: typeof Extrema_PCFOfEPCOfExtPC2d;
  Extrema_PCFOfEPCOfExtPC2d_1: typeof Extrema_PCFOfEPCOfExtPC2d_1;
  Extrema_PCFOfEPCOfExtPC2d_2: typeof Extrema_PCFOfEPCOfExtPC2d_2;
  Handle_Extrema_HArray2OfPOnSurfParams: typeof Handle_Extrema_HArray2OfPOnSurfParams;
  Handle_Extrema_HArray2OfPOnSurfParams_1: typeof Handle_Extrema_HArray2OfPOnSurfParams_1;
  Handle_Extrema_HArray2OfPOnSurfParams_2: typeof Handle_Extrema_HArray2OfPOnSurfParams_2;
  Handle_Extrema_HArray2OfPOnSurfParams_3: typeof Handle_Extrema_HArray2OfPOnSurfParams_3;
  Handle_Extrema_HArray2OfPOnSurfParams_4: typeof Handle_Extrema_HArray2OfPOnSurfParams_4;
  Handle_Extrema_HArray2OfPOnSurf: typeof Handle_Extrema_HArray2OfPOnSurf;
  Handle_Extrema_HArray2OfPOnSurf_1: typeof Handle_Extrema_HArray2OfPOnSurf_1;
  Handle_Extrema_HArray2OfPOnSurf_2: typeof Handle_Extrema_HArray2OfPOnSurf_2;
  Handle_Extrema_HArray2OfPOnSurf_3: typeof Handle_Extrema_HArray2OfPOnSurf_3;
  Handle_Extrema_HArray2OfPOnSurf_4: typeof Handle_Extrema_HArray2OfPOnSurf_4;
  Extrema_ExtElC2d: typeof Extrema_ExtElC2d;
  Extrema_ExtElC2d_1: typeof Extrema_ExtElC2d_1;
  Extrema_ExtElC2d_2: typeof Extrema_ExtElC2d_2;
  Extrema_ExtElC2d_3: typeof Extrema_ExtElC2d_3;
  Extrema_ExtElC2d_4: typeof Extrema_ExtElC2d_4;
  Extrema_ExtElC2d_5: typeof Extrema_ExtElC2d_5;
  Extrema_ExtElC2d_6: typeof Extrema_ExtElC2d_6;
  Extrema_ExtElC2d_7: typeof Extrema_ExtElC2d_7;
  Extrema_ExtElC2d_8: typeof Extrema_ExtElC2d_8;
  Extrema_ExtElC2d_9: typeof Extrema_ExtElC2d_9;
  Extrema_ExtElC2d_10: typeof Extrema_ExtElC2d_10;
  Extrema_GenLocateExtSS: typeof Extrema_GenLocateExtSS;
  Extrema_GenLocateExtSS_1: typeof Extrema_GenLocateExtSS_1;
  Extrema_GenLocateExtSS_2: typeof Extrema_GenLocateExtSS_2;
  Handle_Extrema_HArray1OfPOnCurv2d: typeof Handle_Extrema_HArray1OfPOnCurv2d;
  Handle_Extrema_HArray1OfPOnCurv2d_1: typeof Handle_Extrema_HArray1OfPOnCurv2d_1;
  Handle_Extrema_HArray1OfPOnCurv2d_2: typeof Handle_Extrema_HArray1OfPOnCurv2d_2;
  Handle_Extrema_HArray1OfPOnCurv2d_3: typeof Handle_Extrema_HArray1OfPOnCurv2d_3;
  Handle_Extrema_HArray1OfPOnCurv2d_4: typeof Handle_Extrema_HArray1OfPOnCurv2d_4;
  Extrema_GenExtSS: typeof Extrema_GenExtSS;
  Extrema_GenExtSS_1: typeof Extrema_GenExtSS_1;
  Extrema_GenExtSS_2: typeof Extrema_GenExtSS_2;
  Extrema_GenExtSS_3: typeof Extrema_GenExtSS_3;
  Extrema_POnCurv2d: typeof Extrema_POnCurv2d;
  Extrema_POnCurv2d_1: typeof Extrema_POnCurv2d_1;
  Extrema_POnCurv2d_2: typeof Extrema_POnCurv2d_2;
  Extrema_Array1OfPOnCurv: typeof Extrema_Array1OfPOnCurv;
  Extrema_Array1OfPOnCurv_1: typeof Extrema_Array1OfPOnCurv_1;
  Extrema_Array1OfPOnCurv_2: typeof Extrema_Array1OfPOnCurv_2;
  Extrema_Array1OfPOnCurv_3: typeof Extrema_Array1OfPOnCurv_3;
  Extrema_Array1OfPOnCurv_4: typeof Extrema_Array1OfPOnCurv_4;
  Extrema_Array1OfPOnCurv_5: typeof Extrema_Array1OfPOnCurv_5;
  Extrema_PCLocFOfLocEPCOfLocateExtPC: typeof Extrema_PCLocFOfLocEPCOfLocateExtPC;
  Extrema_PCLocFOfLocEPCOfLocateExtPC_1: typeof Extrema_PCLocFOfLocEPCOfLocateExtPC_1;
  Extrema_PCLocFOfLocEPCOfLocateExtPC_2: typeof Extrema_PCLocFOfLocEPCOfLocateExtPC_2;
  Extrema_EPCOfExtPC: typeof Extrema_EPCOfExtPC;
  Extrema_EPCOfExtPC_1: typeof Extrema_EPCOfExtPC_1;
  Extrema_EPCOfExtPC_2: typeof Extrema_EPCOfExtPC_2;
  Extrema_EPCOfExtPC_3: typeof Extrema_EPCOfExtPC_3;
  Handle_Extrema_ExtPExtS: typeof Handle_Extrema_ExtPExtS;
  Handle_Extrema_ExtPExtS_1: typeof Handle_Extrema_ExtPExtS_1;
  Handle_Extrema_ExtPExtS_2: typeof Handle_Extrema_ExtPExtS_2;
  Handle_Extrema_ExtPExtS_3: typeof Handle_Extrema_ExtPExtS_3;
  Handle_Extrema_ExtPExtS_4: typeof Handle_Extrema_ExtPExtS_4;
  Extrema_ExtPExtS: typeof Extrema_ExtPExtS;
  Extrema_ExtPExtS_1: typeof Extrema_ExtPExtS_1;
  Extrema_ExtPExtS_2: typeof Extrema_ExtPExtS_2;
  Extrema_ExtPExtS_3: typeof Extrema_ExtPExtS_3;
  Extrema_ExtSS: typeof Extrema_ExtSS;
  Extrema_ExtSS_1: typeof Extrema_ExtSS_1;
  Extrema_ExtSS_2: typeof Extrema_ExtSS_2;
  Extrema_ExtSS_3: typeof Extrema_ExtSS_3;
  Extrema_PCFOfEPCOfELPCOfLocateExtPC2d: typeof Extrema_PCFOfEPCOfELPCOfLocateExtPC2d;
  Extrema_PCFOfEPCOfELPCOfLocateExtPC2d_1: typeof Extrema_PCFOfEPCOfELPCOfLocateExtPC2d_1;
  Extrema_PCFOfEPCOfELPCOfLocateExtPC2d_2: typeof Extrema_PCFOfEPCOfELPCOfLocateExtPC2d_2;
  Extrema_ExtElCS: typeof Extrema_ExtElCS;
  Extrema_ExtElCS_1: typeof Extrema_ExtElCS_1;
  Extrema_ExtElCS_2: typeof Extrema_ExtElCS_2;
  Extrema_ExtElCS_3: typeof Extrema_ExtElCS_3;
  Extrema_ExtElCS_4: typeof Extrema_ExtElCS_4;
  Extrema_ExtElCS_5: typeof Extrema_ExtElCS_5;
  Extrema_ExtElCS_6: typeof Extrema_ExtElCS_6;
  Extrema_ExtElCS_7: typeof Extrema_ExtElCS_7;
  Extrema_ExtElCS_8: typeof Extrema_ExtElCS_8;
  Extrema_ExtElCS_9: typeof Extrema_ExtElCS_9;
  Extrema_ExtElCS_10: typeof Extrema_ExtElCS_10;
  Extrema_ExtElCS_11: typeof Extrema_ExtElCS_11;
  Extrema_ExtElCS_12: typeof Extrema_ExtElCS_12;
  Extrema_LocateExtPC: typeof Extrema_LocateExtPC;
  Extrema_LocateExtPC_1: typeof Extrema_LocateExtPC_1;
  Extrema_LocateExtPC_2: typeof Extrema_LocateExtPC_2;
  Extrema_LocateExtPC_3: typeof Extrema_LocateExtPC_3;
  Extrema_ExtPElC: typeof Extrema_ExtPElC;
  Extrema_ExtPElC_1: typeof Extrema_ExtPElC_1;
  Extrema_ExtPElC_2: typeof Extrema_ExtPElC_2;
  Extrema_ExtPElC_3: typeof Extrema_ExtPElC_3;
  Extrema_ExtPElC_4: typeof Extrema_ExtPElC_4;
  Extrema_ExtPElC_5: typeof Extrema_ExtPElC_5;
  Extrema_ExtPElC_6: typeof Extrema_ExtPElC_6;
  Extrema_POnCurv: typeof Extrema_POnCurv;
  Extrema_POnCurv_1: typeof Extrema_POnCurv_1;
  Extrema_POnCurv_2: typeof Extrema_POnCurv_2;
  Extrema_EPCOfELPCOfLocateExtPC: typeof Extrema_EPCOfELPCOfLocateExtPC;
  Extrema_EPCOfELPCOfLocateExtPC_1: typeof Extrema_EPCOfELPCOfLocateExtPC_1;
  Extrema_EPCOfELPCOfLocateExtPC_2: typeof Extrema_EPCOfELPCOfLocateExtPC_2;
  Extrema_EPCOfELPCOfLocateExtPC_3: typeof Extrema_EPCOfELPCOfLocateExtPC_3;
  Extrema_ECC: typeof Extrema_ECC;
  Extrema_ECC_1: typeof Extrema_ECC_1;
  Extrema_ECC_2: typeof Extrema_ECC_2;
  Extrema_ECC_3: typeof Extrema_ECC_3;
  Extrema_ExtCC2d: typeof Extrema_ExtCC2d;
  Extrema_ExtCC2d_1: typeof Extrema_ExtCC2d_1;
  Extrema_ExtCC2d_2: typeof Extrema_ExtCC2d_2;
  Extrema_ExtCC2d_3: typeof Extrema_ExtCC2d_3;
  Extrema_Array2OfPOnCurv: typeof Extrema_Array2OfPOnCurv;
  Extrema_Array2OfPOnCurv_1: typeof Extrema_Array2OfPOnCurv_1;
  Extrema_Array2OfPOnCurv_2: typeof Extrema_Array2OfPOnCurv_2;
  Extrema_Array2OfPOnCurv_3: typeof Extrema_Array2OfPOnCurv_3;
  Extrema_Array2OfPOnCurv_4: typeof Extrema_Array2OfPOnCurv_4;
  Extrema_Array2OfPOnCurv_5: typeof Extrema_Array2OfPOnCurv_5;
  Extrema_Curve2dTool: typeof Extrema_Curve2dTool;
  Extrema_GenExtCS: typeof Extrema_GenExtCS;
  Extrema_GenExtCS_1: typeof Extrema_GenExtCS_1;
  Extrema_GenExtCS_2: typeof Extrema_GenExtCS_2;
  Extrema_GenExtCS_3: typeof Extrema_GenExtCS_3;
  Extrema_Array2OfPOnSurf: typeof Extrema_Array2OfPOnSurf;
  Extrema_Array2OfPOnSurf_1: typeof Extrema_Array2OfPOnSurf_1;
  Extrema_Array2OfPOnSurf_2: typeof Extrema_Array2OfPOnSurf_2;
  Extrema_Array2OfPOnSurf_3: typeof Extrema_Array2OfPOnSurf_3;
  Extrema_Array2OfPOnSurf_4: typeof Extrema_Array2OfPOnSurf_4;
  Extrema_Array2OfPOnSurf_5: typeof Extrema_Array2OfPOnSurf_5;
  Extrema_LocECC2d: typeof Extrema_LocECC2d;
  Extrema_LocEPCOfLocateExtPC2d: typeof Extrema_LocEPCOfLocateExtPC2d;
  Extrema_LocEPCOfLocateExtPC2d_1: typeof Extrema_LocEPCOfLocateExtPC2d_1;
  Extrema_LocEPCOfLocateExtPC2d_2: typeof Extrema_LocEPCOfLocateExtPC2d_2;
  Extrema_LocEPCOfLocateExtPC2d_3: typeof Extrema_LocEPCOfLocateExtPC2d_3;
  Extrema_FuncExtCS: typeof Extrema_FuncExtCS;
  Extrema_FuncExtCS_1: typeof Extrema_FuncExtCS_1;
  Extrema_FuncExtCS_2: typeof Extrema_FuncExtCS_2;
  Extrema_LocateExtCC2d: typeof Extrema_LocateExtCC2d;
  Extrema_ExtPElC2d: typeof Extrema_ExtPElC2d;
  Extrema_ExtPElC2d_1: typeof Extrema_ExtPElC2d_1;
  Extrema_ExtPElC2d_2: typeof Extrema_ExtPElC2d_2;
  Extrema_ExtPElC2d_3: typeof Extrema_ExtPElC2d_3;
  Extrema_ExtPElC2d_4: typeof Extrema_ExtPElC2d_4;
  Extrema_ExtPElC2d_5: typeof Extrema_ExtPElC2d_5;
  Extrema_ExtPElC2d_6: typeof Extrema_ExtPElC2d_6;
  Extrema_SequenceOfPOnCurv2d: typeof Extrema_SequenceOfPOnCurv2d;
  Extrema_SequenceOfPOnCurv2d_1: typeof Extrema_SequenceOfPOnCurv2d_1;
  Extrema_SequenceOfPOnCurv2d_2: typeof Extrema_SequenceOfPOnCurv2d_2;
  Extrema_SequenceOfPOnCurv2d_3: typeof Extrema_SequenceOfPOnCurv2d_3;
  Extrema_EPCOfExtPC2d: typeof Extrema_EPCOfExtPC2d;
  Extrema_EPCOfExtPC2d_1: typeof Extrema_EPCOfExtPC2d_1;
  Extrema_EPCOfExtPC2d_2: typeof Extrema_EPCOfExtPC2d_2;
  Extrema_EPCOfExtPC2d_3: typeof Extrema_EPCOfExtPC2d_3;
  Extrema_ExtAlgo: Extrema_ExtAlgo;
  Handle_Extrema_ExtPRevS: typeof Handle_Extrema_ExtPRevS;
  Handle_Extrema_ExtPRevS_1: typeof Handle_Extrema_ExtPRevS_1;
  Handle_Extrema_ExtPRevS_2: typeof Handle_Extrema_ExtPRevS_2;
  Handle_Extrema_ExtPRevS_3: typeof Handle_Extrema_ExtPRevS_3;
  Handle_Extrema_ExtPRevS_4: typeof Handle_Extrema_ExtPRevS_4;
  Extrema_ExtPRevS: typeof Extrema_ExtPRevS;
  Extrema_ExtPRevS_1: typeof Extrema_ExtPRevS_1;
  Extrema_ExtPRevS_2: typeof Extrema_ExtPRevS_2;
  Extrema_ExtPRevS_3: typeof Extrema_ExtPRevS_3;
  Extrema_Array1OfPOnCurv2d: typeof Extrema_Array1OfPOnCurv2d;
  Extrema_Array1OfPOnCurv2d_1: typeof Extrema_Array1OfPOnCurv2d_1;
  Extrema_Array1OfPOnCurv2d_2: typeof Extrema_Array1OfPOnCurv2d_2;
  Extrema_Array1OfPOnCurv2d_3: typeof Extrema_Array1OfPOnCurv2d_3;
  Extrema_Array1OfPOnCurv2d_4: typeof Extrema_Array1OfPOnCurv2d_4;
  Extrema_Array1OfPOnCurv2d_5: typeof Extrema_Array1OfPOnCurv2d_5;
  Extrema_GlobOptFuncCS: typeof Extrema_GlobOptFuncCS;
  Handle_Extrema_HArray2OfPOnCurv2d: typeof Handle_Extrema_HArray2OfPOnCurv2d;
  Handle_Extrema_HArray2OfPOnCurv2d_1: typeof Handle_Extrema_HArray2OfPOnCurv2d_1;
  Handle_Extrema_HArray2OfPOnCurv2d_2: typeof Handle_Extrema_HArray2OfPOnCurv2d_2;
  Handle_Extrema_HArray2OfPOnCurv2d_3: typeof Handle_Extrema_HArray2OfPOnCurv2d_3;
  Handle_Extrema_HArray2OfPOnCurv2d_4: typeof Handle_Extrema_HArray2OfPOnCurv2d_4;
  Extrema_GlobOptFuncConicS: typeof Extrema_GlobOptFuncConicS;
  Extrema_GlobOptFuncConicS_1: typeof Extrema_GlobOptFuncConicS_1;
  Extrema_GlobOptFuncConicS_2: typeof Extrema_GlobOptFuncConicS_2;
  Extrema_GlobOptFuncConicS_3: typeof Extrema_GlobOptFuncConicS_3;
  Extrema_CurveTool: typeof Extrema_CurveTool;
  Extrema_ExtFlag: Extrema_ExtFlag;
  Extrema_GenExtPS: typeof Extrema_GenExtPS;
  Extrema_GenExtPS_1: typeof Extrema_GenExtPS_1;
  Extrema_GenExtPS_2: typeof Extrema_GenExtPS_2;
  Extrema_GenExtPS_3: typeof Extrema_GenExtPS_3;
  Extrema_POnSurf: typeof Extrema_POnSurf;
  Extrema_POnSurf_1: typeof Extrema_POnSurf_1;
  Extrema_POnSurf_2: typeof Extrema_POnSurf_2;
  Extrema_HUBTreeOfSphere: typeof Extrema_HUBTreeOfSphere;
  Extrema_HUBTreeOfSphere_2: typeof Extrema_HUBTreeOfSphere_2;
  Extrema_HUBTreeOfSphere_3: typeof Extrema_HUBTreeOfSphere_3;
  Extrema_PCFOfEPCOfELPCOfLocateExtPC: typeof Extrema_PCFOfEPCOfELPCOfLocateExtPC;
  Extrema_PCFOfEPCOfELPCOfLocateExtPC_1: typeof Extrema_PCFOfEPCOfELPCOfLocateExtPC_1;
  Extrema_PCFOfEPCOfELPCOfLocateExtPC_2: typeof Extrema_PCFOfEPCOfELPCOfLocateExtPC_2;
  Extrema_GenLocateExtCS: typeof Extrema_GenLocateExtCS;
  Extrema_GenLocateExtCS_1: typeof Extrema_GenLocateExtCS_1;
  Extrema_GenLocateExtCS_2: typeof Extrema_GenLocateExtCS_2;
  Extrema_POnSurfParams: typeof Extrema_POnSurfParams;
  Extrema_POnSurfParams_1: typeof Extrema_POnSurfParams_1;
  Extrema_POnSurfParams_2: typeof Extrema_POnSurfParams_2;
  Extrema_CCLocFOfLocECC2d: typeof Extrema_CCLocFOfLocECC2d;
  Extrema_CCLocFOfLocECC2d_1: typeof Extrema_CCLocFOfLocECC2d_1;
  Extrema_CCLocFOfLocECC2d_2: typeof Extrema_CCLocFOfLocECC2d_2;
  Handle_Extrema_HArray1OfPOnCurv: typeof Handle_Extrema_HArray1OfPOnCurv;
  Handle_Extrema_HArray1OfPOnCurv_1: typeof Handle_Extrema_HArray1OfPOnCurv_1;
  Handle_Extrema_HArray1OfPOnCurv_2: typeof Handle_Extrema_HArray1OfPOnCurv_2;
  Handle_Extrema_HArray1OfPOnCurv_3: typeof Handle_Extrema_HArray1OfPOnCurv_3;
  Handle_Extrema_HArray1OfPOnCurv_4: typeof Handle_Extrema_HArray1OfPOnCurv_4;
  Extrema_LocateExtCC: typeof Extrema_LocateExtCC;
  BinDrivers_Marker: BinDrivers_Marker;
  Handle_BinDrivers_DocumentStorageDriver: typeof Handle_BinDrivers_DocumentStorageDriver;
  Handle_BinDrivers_DocumentStorageDriver_1: typeof Handle_BinDrivers_DocumentStorageDriver_1;
  Handle_BinDrivers_DocumentStorageDriver_2: typeof Handle_BinDrivers_DocumentStorageDriver_2;
  Handle_BinDrivers_DocumentStorageDriver_3: typeof Handle_BinDrivers_DocumentStorageDriver_3;
  Handle_BinDrivers_DocumentStorageDriver_4: typeof Handle_BinDrivers_DocumentStorageDriver_4;
  BinDrivers_DocumentStorageDriver: typeof BinDrivers_DocumentStorageDriver;
  BinDrivers_DocumentRetrievalDriver: typeof BinDrivers_DocumentRetrievalDriver;
  Handle_BinDrivers_DocumentRetrievalDriver: typeof Handle_BinDrivers_DocumentRetrievalDriver;
  Handle_BinDrivers_DocumentRetrievalDriver_1: typeof Handle_BinDrivers_DocumentRetrievalDriver_1;
  Handle_BinDrivers_DocumentRetrievalDriver_2: typeof Handle_BinDrivers_DocumentRetrievalDriver_2;
  Handle_BinDrivers_DocumentRetrievalDriver_3: typeof Handle_BinDrivers_DocumentRetrievalDriver_3;
  Handle_BinDrivers_DocumentRetrievalDriver_4: typeof Handle_BinDrivers_DocumentRetrievalDriver_4;
  BinDrivers: typeof BinDrivers;
  BRepBuilderAPI_BndBoxTreeSelector: typeof BRepBuilderAPI_BndBoxTreeSelector;
  BRepBuilderAPI_ModifyShape: typeof BRepBuilderAPI_ModifyShape;
  BRepBuilderAPI_MakeShell: typeof BRepBuilderAPI_MakeShell;
  BRepBuilderAPI_MakeShell_1: typeof BRepBuilderAPI_MakeShell_1;
  BRepBuilderAPI_MakeShell_2: typeof BRepBuilderAPI_MakeShell_2;
  BRepBuilderAPI_MakeShell_3: typeof BRepBuilderAPI_MakeShell_3;
  Handle_BRepBuilderAPI_Sewing: typeof Handle_BRepBuilderAPI_Sewing;
  Handle_BRepBuilderAPI_Sewing_1: typeof Handle_BRepBuilderAPI_Sewing_1;
  Handle_BRepBuilderAPI_Sewing_2: typeof Handle_BRepBuilderAPI_Sewing_2;
  Handle_BRepBuilderAPI_Sewing_3: typeof Handle_BRepBuilderAPI_Sewing_3;
  Handle_BRepBuilderAPI_Sewing_4: typeof Handle_BRepBuilderAPI_Sewing_4;
  BRepBuilderAPI_Sewing: typeof BRepBuilderAPI_Sewing;
  BRepBuilderAPI_NurbsConvert: typeof BRepBuilderAPI_NurbsConvert;
  BRepBuilderAPI_NurbsConvert_1: typeof BRepBuilderAPI_NurbsConvert_1;
  BRepBuilderAPI_NurbsConvert_2: typeof BRepBuilderAPI_NurbsConvert_2;
  BRepBuilderAPI_EdgeError: BRepBuilderAPI_EdgeError;
  BRepBuilderAPI_MakeEdge2d: typeof BRepBuilderAPI_MakeEdge2d;
  BRepBuilderAPI_MakeEdge2d_1: typeof BRepBuilderAPI_MakeEdge2d_1;
  BRepBuilderAPI_MakeEdge2d_2: typeof BRepBuilderAPI_MakeEdge2d_2;
  BRepBuilderAPI_MakeEdge2d_3: typeof BRepBuilderAPI_MakeEdge2d_3;
  BRepBuilderAPI_MakeEdge2d_4: typeof BRepBuilderAPI_MakeEdge2d_4;
  BRepBuilderAPI_MakeEdge2d_5: typeof BRepBuilderAPI_MakeEdge2d_5;
  BRepBuilderAPI_MakeEdge2d_6: typeof BRepBuilderAPI_MakeEdge2d_6;
  BRepBuilderAPI_MakeEdge2d_7: typeof BRepBuilderAPI_MakeEdge2d_7;
  BRepBuilderAPI_MakeEdge2d_8: typeof BRepBuilderAPI_MakeEdge2d_8;
  BRepBuilderAPI_MakeEdge2d_9: typeof BRepBuilderAPI_MakeEdge2d_9;
  BRepBuilderAPI_MakeEdge2d_10: typeof BRepBuilderAPI_MakeEdge2d_10;
  BRepBuilderAPI_MakeEdge2d_11: typeof BRepBuilderAPI_MakeEdge2d_11;
  BRepBuilderAPI_MakeEdge2d_12: typeof BRepBuilderAPI_MakeEdge2d_12;
  BRepBuilderAPI_MakeEdge2d_13: typeof BRepBuilderAPI_MakeEdge2d_13;
  BRepBuilderAPI_MakeEdge2d_14: typeof BRepBuilderAPI_MakeEdge2d_14;
  BRepBuilderAPI_MakeEdge2d_15: typeof BRepBuilderAPI_MakeEdge2d_15;
  BRepBuilderAPI_MakeEdge2d_16: typeof BRepBuilderAPI_MakeEdge2d_16;
  BRepBuilderAPI_MakeEdge2d_17: typeof BRepBuilderAPI_MakeEdge2d_17;
  BRepBuilderAPI_MakeEdge2d_18: typeof BRepBuilderAPI_MakeEdge2d_18;
  BRepBuilderAPI_MakeEdge2d_19: typeof BRepBuilderAPI_MakeEdge2d_19;
  BRepBuilderAPI_MakeEdge2d_20: typeof BRepBuilderAPI_MakeEdge2d_20;
  BRepBuilderAPI_MakeEdge2d_21: typeof BRepBuilderAPI_MakeEdge2d_21;
  BRepBuilderAPI_MakeEdge2d_22: typeof BRepBuilderAPI_MakeEdge2d_22;
  BRepBuilderAPI_MakeEdge2d_23: typeof BRepBuilderAPI_MakeEdge2d_23;
  BRepBuilderAPI_MakeEdge2d_24: typeof BRepBuilderAPI_MakeEdge2d_24;
  BRepBuilderAPI_MakeEdge2d_25: typeof BRepBuilderAPI_MakeEdge2d_25;
  BRepBuilderAPI_MakeEdge2d_26: typeof BRepBuilderAPI_MakeEdge2d_26;
  BRepBuilderAPI_MakeEdge2d_27: typeof BRepBuilderAPI_MakeEdge2d_27;
  BRepBuilderAPI_MakeEdge2d_28: typeof BRepBuilderAPI_MakeEdge2d_28;
  BRepBuilderAPI_ShapeModification: BRepBuilderAPI_ShapeModification;
  BRepBuilderAPI_ShellError: BRepBuilderAPI_ShellError;
  BRepBuilderAPI_MakeSolid: typeof BRepBuilderAPI_MakeSolid;
  BRepBuilderAPI_MakeSolid_1: typeof BRepBuilderAPI_MakeSolid_1;
  BRepBuilderAPI_MakeSolid_2: typeof BRepBuilderAPI_MakeSolid_2;
  BRepBuilderAPI_MakeSolid_3: typeof BRepBuilderAPI_MakeSolid_3;
  BRepBuilderAPI_MakeSolid_4: typeof BRepBuilderAPI_MakeSolid_4;
  BRepBuilderAPI_MakeSolid_5: typeof BRepBuilderAPI_MakeSolid_5;
  BRepBuilderAPI_MakeSolid_6: typeof BRepBuilderAPI_MakeSolid_6;
  BRepBuilderAPI_MakeSolid_7: typeof BRepBuilderAPI_MakeSolid_7;
  BRepBuilderAPI_MakeVertex: typeof BRepBuilderAPI_MakeVertex;
  BRepBuilderAPI_PipeError: BRepBuilderAPI_PipeError;
  BRepBuilderAPI_Command: typeof BRepBuilderAPI_Command;
  BRepBuilderAPI_FaceError: BRepBuilderAPI_FaceError;
  Handle_BRepBuilderAPI_FastSewing: typeof Handle_BRepBuilderAPI_FastSewing;
  Handle_BRepBuilderAPI_FastSewing_1: typeof Handle_BRepBuilderAPI_FastSewing_1;
  Handle_BRepBuilderAPI_FastSewing_2: typeof Handle_BRepBuilderAPI_FastSewing_2;
  Handle_BRepBuilderAPI_FastSewing_3: typeof Handle_BRepBuilderAPI_FastSewing_3;
  Handle_BRepBuilderAPI_FastSewing_4: typeof Handle_BRepBuilderAPI_FastSewing_4;
  BRepBuilderAPI_FastSewing: typeof BRepBuilderAPI_FastSewing;
  BRepBuilderAPI_Transform: typeof BRepBuilderAPI_Transform;
  BRepBuilderAPI_Transform_1: typeof BRepBuilderAPI_Transform_1;
  BRepBuilderAPI_Transform_2: typeof BRepBuilderAPI_Transform_2;
  BRepBuilderAPI_Collect: typeof BRepBuilderAPI_Collect;
  BRepBuilderAPI_MakePolygon: typeof BRepBuilderAPI_MakePolygon;
  BRepBuilderAPI_MakePolygon_1: typeof BRepBuilderAPI_MakePolygon_1;
  BRepBuilderAPI_MakePolygon_2: typeof BRepBuilderAPI_MakePolygon_2;
  BRepBuilderAPI_MakePolygon_3: typeof BRepBuilderAPI_MakePolygon_3;
  BRepBuilderAPI_MakePolygon_4: typeof BRepBuilderAPI_MakePolygon_4;
  BRepBuilderAPI_MakePolygon_5: typeof BRepBuilderAPI_MakePolygon_5;
  BRepBuilderAPI_MakePolygon_6: typeof BRepBuilderAPI_MakePolygon_6;
  BRepBuilderAPI_MakePolygon_7: typeof BRepBuilderAPI_MakePolygon_7;
  VectorOfPoint: typeof VectorOfPoint;
  VectorOfPoint_1: typeof VectorOfPoint_1;
  VectorOfPoint_2: typeof VectorOfPoint_2;
  BRepBuilderAPI_VertexInspector: typeof BRepBuilderAPI_VertexInspector;
  BRepBuilderAPI_MakeWire: typeof BRepBuilderAPI_MakeWire;
  BRepBuilderAPI_MakeWire_1: typeof BRepBuilderAPI_MakeWire_1;
  BRepBuilderAPI_MakeWire_2: typeof BRepBuilderAPI_MakeWire_2;
  BRepBuilderAPI_MakeWire_3: typeof BRepBuilderAPI_MakeWire_3;
  BRepBuilderAPI_MakeWire_4: typeof BRepBuilderAPI_MakeWire_4;
  BRepBuilderAPI_MakeWire_5: typeof BRepBuilderAPI_MakeWire_5;
  BRepBuilderAPI_MakeWire_6: typeof BRepBuilderAPI_MakeWire_6;
  BRepBuilderAPI_MakeWire_7: typeof BRepBuilderAPI_MakeWire_7;
  BRepBuilderAPI_GTransform: typeof BRepBuilderAPI_GTransform;
  BRepBuilderAPI_GTransform_1: typeof BRepBuilderAPI_GTransform_1;
  BRepBuilderAPI_GTransform_2: typeof BRepBuilderAPI_GTransform_2;
  BRepBuilderAPI_WireError: BRepBuilderAPI_WireError;
  BRepBuilderAPI_FindPlane: typeof BRepBuilderAPI_FindPlane;
  BRepBuilderAPI_FindPlane_1: typeof BRepBuilderAPI_FindPlane_1;
  BRepBuilderAPI_FindPlane_2: typeof BRepBuilderAPI_FindPlane_2;
  BRepBuilderAPI_MakeShape: typeof BRepBuilderAPI_MakeShape;
  BRepBuilderAPI_TransitionMode: BRepBuilderAPI_TransitionMode;
  BRepBuilderAPI_Copy: typeof BRepBuilderAPI_Copy;
  BRepBuilderAPI_Copy_1: typeof BRepBuilderAPI_Copy_1;
  BRepBuilderAPI_Copy_2: typeof BRepBuilderAPI_Copy_2;
  BRepBuilderAPI_MakeEdge: typeof BRepBuilderAPI_MakeEdge;
  BRepBuilderAPI_MakeEdge_1: typeof BRepBuilderAPI_MakeEdge_1;
  BRepBuilderAPI_MakeEdge_2: typeof BRepBuilderAPI_MakeEdge_2;
  BRepBuilderAPI_MakeEdge_3: typeof BRepBuilderAPI_MakeEdge_3;
  BRepBuilderAPI_MakeEdge_4: typeof BRepBuilderAPI_MakeEdge_4;
  BRepBuilderAPI_MakeEdge_5: typeof BRepBuilderAPI_MakeEdge_5;
  BRepBuilderAPI_MakeEdge_6: typeof BRepBuilderAPI_MakeEdge_6;
  BRepBuilderAPI_MakeEdge_7: typeof BRepBuilderAPI_MakeEdge_7;
  BRepBuilderAPI_MakeEdge_8: typeof BRepBuilderAPI_MakeEdge_8;
  BRepBuilderAPI_MakeEdge_9: typeof BRepBuilderAPI_MakeEdge_9;
  BRepBuilderAPI_MakeEdge_10: typeof BRepBuilderAPI_MakeEdge_10;
  BRepBuilderAPI_MakeEdge_11: typeof BRepBuilderAPI_MakeEdge_11;
  BRepBuilderAPI_MakeEdge_12: typeof BRepBuilderAPI_MakeEdge_12;
  BRepBuilderAPI_MakeEdge_13: typeof BRepBuilderAPI_MakeEdge_13;
  BRepBuilderAPI_MakeEdge_14: typeof BRepBuilderAPI_MakeEdge_14;
  BRepBuilderAPI_MakeEdge_15: typeof BRepBuilderAPI_MakeEdge_15;
  BRepBuilderAPI_MakeEdge_16: typeof BRepBuilderAPI_MakeEdge_16;
  BRepBuilderAPI_MakeEdge_17: typeof BRepBuilderAPI_MakeEdge_17;
  BRepBuilderAPI_MakeEdge_18: typeof BRepBuilderAPI_MakeEdge_18;
  BRepBuilderAPI_MakeEdge_19: typeof BRepBuilderAPI_MakeEdge_19;
  BRepBuilderAPI_MakeEdge_20: typeof BRepBuilderAPI_MakeEdge_20;
  BRepBuilderAPI_MakeEdge_21: typeof BRepBuilderAPI_MakeEdge_21;
  BRepBuilderAPI_MakeEdge_22: typeof BRepBuilderAPI_MakeEdge_22;
  BRepBuilderAPI_MakeEdge_23: typeof BRepBuilderAPI_MakeEdge_23;
  BRepBuilderAPI_MakeEdge_24: typeof BRepBuilderAPI_MakeEdge_24;
  BRepBuilderAPI_MakeEdge_25: typeof BRepBuilderAPI_MakeEdge_25;
  BRepBuilderAPI_MakeEdge_26: typeof BRepBuilderAPI_MakeEdge_26;
  BRepBuilderAPI_MakeEdge_27: typeof BRepBuilderAPI_MakeEdge_27;
  BRepBuilderAPI_MakeEdge_28: typeof BRepBuilderAPI_MakeEdge_28;
  BRepBuilderAPI_MakeEdge_29: typeof BRepBuilderAPI_MakeEdge_29;
  BRepBuilderAPI_MakeEdge_30: typeof BRepBuilderAPI_MakeEdge_30;
  BRepBuilderAPI_MakeEdge_31: typeof BRepBuilderAPI_MakeEdge_31;
  BRepBuilderAPI_MakeEdge_32: typeof BRepBuilderAPI_MakeEdge_32;
  BRepBuilderAPI_MakeEdge_33: typeof BRepBuilderAPI_MakeEdge_33;
  BRepBuilderAPI_MakeEdge_34: typeof BRepBuilderAPI_MakeEdge_34;
  BRepBuilderAPI_MakeEdge_35: typeof BRepBuilderAPI_MakeEdge_35;
  BRepBuilderAPI_MakeFace: typeof BRepBuilderAPI_MakeFace;
  BRepBuilderAPI_MakeFace_1: typeof BRepBuilderAPI_MakeFace_1;
  BRepBuilderAPI_MakeFace_2: typeof BRepBuilderAPI_MakeFace_2;
  BRepBuilderAPI_MakeFace_3: typeof BRepBuilderAPI_MakeFace_3;
  BRepBuilderAPI_MakeFace_4: typeof BRepBuilderAPI_MakeFace_4;
  BRepBuilderAPI_MakeFace_5: typeof BRepBuilderAPI_MakeFace_5;
  BRepBuilderAPI_MakeFace_6: typeof BRepBuilderAPI_MakeFace_6;
  BRepBuilderAPI_MakeFace_7: typeof BRepBuilderAPI_MakeFace_7;
  BRepBuilderAPI_MakeFace_8: typeof BRepBuilderAPI_MakeFace_8;
  BRepBuilderAPI_MakeFace_9: typeof BRepBuilderAPI_MakeFace_9;
  BRepBuilderAPI_MakeFace_10: typeof BRepBuilderAPI_MakeFace_10;
  BRepBuilderAPI_MakeFace_11: typeof BRepBuilderAPI_MakeFace_11;
  BRepBuilderAPI_MakeFace_12: typeof BRepBuilderAPI_MakeFace_12;
  BRepBuilderAPI_MakeFace_13: typeof BRepBuilderAPI_MakeFace_13;
  BRepBuilderAPI_MakeFace_14: typeof BRepBuilderAPI_MakeFace_14;
  BRepBuilderAPI_MakeFace_15: typeof BRepBuilderAPI_MakeFace_15;
  BRepBuilderAPI_MakeFace_16: typeof BRepBuilderAPI_MakeFace_16;
  BRepBuilderAPI_MakeFace_17: typeof BRepBuilderAPI_MakeFace_17;
  BRepBuilderAPI_MakeFace_18: typeof BRepBuilderAPI_MakeFace_18;
  BRepBuilderAPI_MakeFace_19: typeof BRepBuilderAPI_MakeFace_19;
  BRepBuilderAPI_MakeFace_20: typeof BRepBuilderAPI_MakeFace_20;
  BRepBuilderAPI_MakeFace_21: typeof BRepBuilderAPI_MakeFace_21;
  BRepBuilderAPI_MakeFace_22: typeof BRepBuilderAPI_MakeFace_22;
  BRepBuilderAPI: typeof BRepBuilderAPI;
  BRepLib: typeof BRepLib;
  BRepLib_MakeSolid: typeof BRepLib_MakeSolid;
  BRepLib_MakeSolid_1: typeof BRepLib_MakeSolid_1;
  BRepLib_MakeSolid_2: typeof BRepLib_MakeSolid_2;
  BRepLib_MakeSolid_3: typeof BRepLib_MakeSolid_3;
  BRepLib_MakeSolid_4: typeof BRepLib_MakeSolid_4;
  BRepLib_MakeSolid_5: typeof BRepLib_MakeSolid_5;
  BRepLib_MakeSolid_6: typeof BRepLib_MakeSolid_6;
  BRepLib_MakeSolid_7: typeof BRepLib_MakeSolid_7;
  BRepLib_MakeFace: typeof BRepLib_MakeFace;
  BRepLib_MakeFace_1: typeof BRepLib_MakeFace_1;
  BRepLib_MakeFace_2: typeof BRepLib_MakeFace_2;
  BRepLib_MakeFace_3: typeof BRepLib_MakeFace_3;
  BRepLib_MakeFace_4: typeof BRepLib_MakeFace_4;
  BRepLib_MakeFace_5: typeof BRepLib_MakeFace_5;
  BRepLib_MakeFace_6: typeof BRepLib_MakeFace_6;
  BRepLib_MakeFace_7: typeof BRepLib_MakeFace_7;
  BRepLib_MakeFace_8: typeof BRepLib_MakeFace_8;
  BRepLib_MakeFace_9: typeof BRepLib_MakeFace_9;
  BRepLib_MakeFace_10: typeof BRepLib_MakeFace_10;
  BRepLib_MakeFace_11: typeof BRepLib_MakeFace_11;
  BRepLib_MakeFace_12: typeof BRepLib_MakeFace_12;
  BRepLib_MakeFace_13: typeof BRepLib_MakeFace_13;
  BRepLib_MakeFace_14: typeof BRepLib_MakeFace_14;
  BRepLib_MakeFace_15: typeof BRepLib_MakeFace_15;
  BRepLib_MakeFace_16: typeof BRepLib_MakeFace_16;
  BRepLib_MakeFace_17: typeof BRepLib_MakeFace_17;
  BRepLib_MakeFace_18: typeof BRepLib_MakeFace_18;
  BRepLib_MakeFace_19: typeof BRepLib_MakeFace_19;
  BRepLib_MakeFace_20: typeof BRepLib_MakeFace_20;
  BRepLib_MakeFace_21: typeof BRepLib_MakeFace_21;
  BRepLib_MakeFace_22: typeof BRepLib_MakeFace_22;
  BRepLib_MakeShape: typeof BRepLib_MakeShape;
  BRepLib_FaceError: BRepLib_FaceError;
  BRepLib_MakePolygon: typeof BRepLib_MakePolygon;
  BRepLib_MakePolygon_1: typeof BRepLib_MakePolygon_1;
  BRepLib_MakePolygon_2: typeof BRepLib_MakePolygon_2;
  BRepLib_MakePolygon_3: typeof BRepLib_MakePolygon_3;
  BRepLib_MakePolygon_4: typeof BRepLib_MakePolygon_4;
  BRepLib_MakePolygon_5: typeof BRepLib_MakePolygon_5;
  BRepLib_MakePolygon_6: typeof BRepLib_MakePolygon_6;
  BRepLib_MakePolygon_7: typeof BRepLib_MakePolygon_7;
  BRepLib_MakeVertex: typeof BRepLib_MakeVertex;
  BRepLib_MakeWire: typeof BRepLib_MakeWire;
  BRepLib_MakeWire_1: typeof BRepLib_MakeWire_1;
  BRepLib_MakeWire_2: typeof BRepLib_MakeWire_2;
  BRepLib_MakeWire_3: typeof BRepLib_MakeWire_3;
  BRepLib_MakeWire_4: typeof BRepLib_MakeWire_4;
  BRepLib_MakeWire_5: typeof BRepLib_MakeWire_5;
  BRepLib_MakeWire_6: typeof BRepLib_MakeWire_6;
  BRepLib_MakeWire_7: typeof BRepLib_MakeWire_7;
  BRepLib_FuseEdges: typeof BRepLib_FuseEdges;
  BRepLib_FindSurface: typeof BRepLib_FindSurface;
  BRepLib_FindSurface_1: typeof BRepLib_FindSurface_1;
  BRepLib_FindSurface_2: typeof BRepLib_FindSurface_2;
  BRepLib_ShapeModification: BRepLib_ShapeModification;
  BRepLib_CheckCurveOnSurface: typeof BRepLib_CheckCurveOnSurface;
  BRepLib_CheckCurveOnSurface_1: typeof BRepLib_CheckCurveOnSurface_1;
  BRepLib_CheckCurveOnSurface_2: typeof BRepLib_CheckCurveOnSurface_2;
  BRepLib_ShellError: BRepLib_ShellError;
  BRepLib_MakeEdge2d: typeof BRepLib_MakeEdge2d;
  BRepLib_MakeEdge2d_1: typeof BRepLib_MakeEdge2d_1;
  BRepLib_MakeEdge2d_2: typeof BRepLib_MakeEdge2d_2;
  BRepLib_MakeEdge2d_3: typeof BRepLib_MakeEdge2d_3;
  BRepLib_MakeEdge2d_4: typeof BRepLib_MakeEdge2d_4;
  BRepLib_MakeEdge2d_5: typeof BRepLib_MakeEdge2d_5;
  BRepLib_MakeEdge2d_6: typeof BRepLib_MakeEdge2d_6;
  BRepLib_MakeEdge2d_7: typeof BRepLib_MakeEdge2d_7;
  BRepLib_MakeEdge2d_8: typeof BRepLib_MakeEdge2d_8;
  BRepLib_MakeEdge2d_9: typeof BRepLib_MakeEdge2d_9;
  BRepLib_MakeEdge2d_10: typeof BRepLib_MakeEdge2d_10;
  BRepLib_MakeEdge2d_11: typeof BRepLib_MakeEdge2d_11;
  BRepLib_MakeEdge2d_12: typeof BRepLib_MakeEdge2d_12;
  BRepLib_MakeEdge2d_13: typeof BRepLib_MakeEdge2d_13;
  BRepLib_MakeEdge2d_14: typeof BRepLib_MakeEdge2d_14;
  BRepLib_MakeEdge2d_15: typeof BRepLib_MakeEdge2d_15;
  BRepLib_MakeEdge2d_16: typeof BRepLib_MakeEdge2d_16;
  BRepLib_MakeEdge2d_17: typeof BRepLib_MakeEdge2d_17;
  BRepLib_MakeEdge2d_18: typeof BRepLib_MakeEdge2d_18;
  BRepLib_MakeEdge2d_19: typeof BRepLib_MakeEdge2d_19;
  BRepLib_MakeEdge2d_20: typeof BRepLib_MakeEdge2d_20;
  BRepLib_MakeEdge2d_21: typeof BRepLib_MakeEdge2d_21;
  BRepLib_MakeEdge2d_22: typeof BRepLib_MakeEdge2d_22;
  BRepLib_MakeEdge2d_23: typeof BRepLib_MakeEdge2d_23;
  BRepLib_MakeEdge2d_24: typeof BRepLib_MakeEdge2d_24;
  BRepLib_MakeEdge2d_25: typeof BRepLib_MakeEdge2d_25;
  BRepLib_MakeEdge2d_26: typeof BRepLib_MakeEdge2d_26;
  BRepLib_MakeEdge2d_27: typeof BRepLib_MakeEdge2d_27;
  BRepLib_MakeEdge2d_28: typeof BRepLib_MakeEdge2d_28;
  BRepLib_Command: typeof BRepLib_Command;
  BRepLib_MakeShell: typeof BRepLib_MakeShell;
  BRepLib_MakeShell_1: typeof BRepLib_MakeShell_1;
  BRepLib_MakeShell_2: typeof BRepLib_MakeShell_2;
  BRepLib_MakeShell_3: typeof BRepLib_MakeShell_3;
  BRepLib_MakeEdge: typeof BRepLib_MakeEdge;
  BRepLib_MakeEdge_1: typeof BRepLib_MakeEdge_1;
  BRepLib_MakeEdge_2: typeof BRepLib_MakeEdge_2;
  BRepLib_MakeEdge_3: typeof BRepLib_MakeEdge_3;
  BRepLib_MakeEdge_4: typeof BRepLib_MakeEdge_4;
  BRepLib_MakeEdge_5: typeof BRepLib_MakeEdge_5;
  BRepLib_MakeEdge_6: typeof BRepLib_MakeEdge_6;
  BRepLib_MakeEdge_7: typeof BRepLib_MakeEdge_7;
  BRepLib_MakeEdge_8: typeof BRepLib_MakeEdge_8;
  BRepLib_MakeEdge_9: typeof BRepLib_MakeEdge_9;
  BRepLib_MakeEdge_10: typeof BRepLib_MakeEdge_10;
  BRepLib_MakeEdge_11: typeof BRepLib_MakeEdge_11;
  BRepLib_MakeEdge_12: typeof BRepLib_MakeEdge_12;
  BRepLib_MakeEdge_13: typeof BRepLib_MakeEdge_13;
  BRepLib_MakeEdge_14: typeof BRepLib_MakeEdge_14;
  BRepLib_MakeEdge_15: typeof BRepLib_MakeEdge_15;
  BRepLib_MakeEdge_16: typeof BRepLib_MakeEdge_16;
  BRepLib_MakeEdge_17: typeof BRepLib_MakeEdge_17;
  BRepLib_MakeEdge_18: typeof BRepLib_MakeEdge_18;
  BRepLib_MakeEdge_19: typeof BRepLib_MakeEdge_19;
  BRepLib_MakeEdge_20: typeof BRepLib_MakeEdge_20;
  BRepLib_MakeEdge_21: typeof BRepLib_MakeEdge_21;
  BRepLib_MakeEdge_22: typeof BRepLib_MakeEdge_22;
  BRepLib_MakeEdge_23: typeof BRepLib_MakeEdge_23;
  BRepLib_MakeEdge_24: typeof BRepLib_MakeEdge_24;
  BRepLib_MakeEdge_25: typeof BRepLib_MakeEdge_25;
  BRepLib_MakeEdge_26: typeof BRepLib_MakeEdge_26;
  BRepLib_MakeEdge_27: typeof BRepLib_MakeEdge_27;
  BRepLib_MakeEdge_28: typeof BRepLib_MakeEdge_28;
  BRepLib_MakeEdge_29: typeof BRepLib_MakeEdge_29;
  BRepLib_MakeEdge_30: typeof BRepLib_MakeEdge_30;
  BRepLib_MakeEdge_31: typeof BRepLib_MakeEdge_31;
  BRepLib_MakeEdge_32: typeof BRepLib_MakeEdge_32;
  BRepLib_MakeEdge_33: typeof BRepLib_MakeEdge_33;
  BRepLib_MakeEdge_34: typeof BRepLib_MakeEdge_34;
  BRepLib_MakeEdge_35: typeof BRepLib_MakeEdge_35;
  BRepLib_WireError: BRepLib_WireError;
  BRepLib_EdgeError: BRepLib_EdgeError;
  IGESDraw_NetworkSubfigureDef: typeof IGESDraw_NetworkSubfigureDef;
  Handle_IGESDraw_NetworkSubfigureDef: typeof Handle_IGESDraw_NetworkSubfigureDef;
  Handle_IGESDraw_NetworkSubfigureDef_1: typeof Handle_IGESDraw_NetworkSubfigureDef_1;
  Handle_IGESDraw_NetworkSubfigureDef_2: typeof Handle_IGESDraw_NetworkSubfigureDef_2;
  Handle_IGESDraw_NetworkSubfigureDef_3: typeof Handle_IGESDraw_NetworkSubfigureDef_3;
  Handle_IGESDraw_NetworkSubfigureDef_4: typeof Handle_IGESDraw_NetworkSubfigureDef_4;
  IGESDraw_ViewsVisible: typeof IGESDraw_ViewsVisible;
  Handle_IGESDraw_ViewsVisible: typeof Handle_IGESDraw_ViewsVisible;
  Handle_IGESDraw_ViewsVisible_1: typeof Handle_IGESDraw_ViewsVisible_1;
  Handle_IGESDraw_ViewsVisible_2: typeof Handle_IGESDraw_ViewsVisible_2;
  Handle_IGESDraw_ViewsVisible_3: typeof Handle_IGESDraw_ViewsVisible_3;
  Handle_IGESDraw_ViewsVisible_4: typeof Handle_IGESDraw_ViewsVisible_4;
  IGESDraw_GeneralModule: typeof IGESDraw_GeneralModule;
  Handle_IGESDraw_GeneralModule: typeof Handle_IGESDraw_GeneralModule;
  Handle_IGESDraw_GeneralModule_1: typeof Handle_IGESDraw_GeneralModule_1;
  Handle_IGESDraw_GeneralModule_2: typeof Handle_IGESDraw_GeneralModule_2;
  Handle_IGESDraw_GeneralModule_3: typeof Handle_IGESDraw_GeneralModule_3;
  Handle_IGESDraw_GeneralModule_4: typeof Handle_IGESDraw_GeneralModule_4;
  Handle_IGESDraw_Protocol: typeof Handle_IGESDraw_Protocol;
  Handle_IGESDraw_Protocol_1: typeof Handle_IGESDraw_Protocol_1;
  Handle_IGESDraw_Protocol_2: typeof Handle_IGESDraw_Protocol_2;
  Handle_IGESDraw_Protocol_3: typeof Handle_IGESDraw_Protocol_3;
  Handle_IGESDraw_Protocol_4: typeof Handle_IGESDraw_Protocol_4;
  IGESDraw_Protocol: typeof IGESDraw_Protocol;
  IGESDraw_ToolLabelDisplay: typeof IGESDraw_ToolLabelDisplay;
  Handle_IGESDraw_PerspectiveView: typeof Handle_IGESDraw_PerspectiveView;
  Handle_IGESDraw_PerspectiveView_1: typeof Handle_IGESDraw_PerspectiveView_1;
  Handle_IGESDraw_PerspectiveView_2: typeof Handle_IGESDraw_PerspectiveView_2;
  Handle_IGESDraw_PerspectiveView_3: typeof Handle_IGESDraw_PerspectiveView_3;
  Handle_IGESDraw_PerspectiveView_4: typeof Handle_IGESDraw_PerspectiveView_4;
  IGESDraw_PerspectiveView: typeof IGESDraw_PerspectiveView;
  IGESDraw_ToolViewsVisible: typeof IGESDraw_ToolViewsVisible;
  IGESDraw_ToolSegmentedViewsVisible: typeof IGESDraw_ToolSegmentedViewsVisible;
  Handle_IGESDraw_Planar: typeof Handle_IGESDraw_Planar;
  Handle_IGESDraw_Planar_1: typeof Handle_IGESDraw_Planar_1;
  Handle_IGESDraw_Planar_2: typeof Handle_IGESDraw_Planar_2;
  Handle_IGESDraw_Planar_3: typeof Handle_IGESDraw_Planar_3;
  Handle_IGESDraw_Planar_4: typeof Handle_IGESDraw_Planar_4;
  IGESDraw_Planar: typeof IGESDraw_Planar;
  IGESDraw: typeof IGESDraw;
  Handle_IGESDraw_ConnectPoint: typeof Handle_IGESDraw_ConnectPoint;
  Handle_IGESDraw_ConnectPoint_1: typeof Handle_IGESDraw_ConnectPoint_1;
  Handle_IGESDraw_ConnectPoint_2: typeof Handle_IGESDraw_ConnectPoint_2;
  Handle_IGESDraw_ConnectPoint_3: typeof Handle_IGESDraw_ConnectPoint_3;
  Handle_IGESDraw_ConnectPoint_4: typeof Handle_IGESDraw_ConnectPoint_4;
  IGESDraw_ConnectPoint: typeof IGESDraw_ConnectPoint;
  Handle_IGESDraw_HArray1OfConnectPoint: typeof Handle_IGESDraw_HArray1OfConnectPoint;
  Handle_IGESDraw_HArray1OfConnectPoint_1: typeof Handle_IGESDraw_HArray1OfConnectPoint_1;
  Handle_IGESDraw_HArray1OfConnectPoint_2: typeof Handle_IGESDraw_HArray1OfConnectPoint_2;
  Handle_IGESDraw_HArray1OfConnectPoint_3: typeof Handle_IGESDraw_HArray1OfConnectPoint_3;
  Handle_IGESDraw_HArray1OfConnectPoint_4: typeof Handle_IGESDraw_HArray1OfConnectPoint_4;
  IGESDraw_ToolPlanar: typeof IGESDraw_ToolPlanar;
  IGESDraw_SegmentedViewsVisible: typeof IGESDraw_SegmentedViewsVisible;
  Handle_IGESDraw_SegmentedViewsVisible: typeof Handle_IGESDraw_SegmentedViewsVisible;
  Handle_IGESDraw_SegmentedViewsVisible_1: typeof Handle_IGESDraw_SegmentedViewsVisible_1;
  Handle_IGESDraw_SegmentedViewsVisible_2: typeof Handle_IGESDraw_SegmentedViewsVisible_2;
  Handle_IGESDraw_SegmentedViewsVisible_3: typeof Handle_IGESDraw_SegmentedViewsVisible_3;
  Handle_IGESDraw_SegmentedViewsVisible_4: typeof Handle_IGESDraw_SegmentedViewsVisible_4;
  IGESDraw_ToolView: typeof IGESDraw_ToolView;
  Handle_IGESDraw_ViewsVisibleWithAttr: typeof Handle_IGESDraw_ViewsVisibleWithAttr;
  Handle_IGESDraw_ViewsVisibleWithAttr_1: typeof Handle_IGESDraw_ViewsVisibleWithAttr_1;
  Handle_IGESDraw_ViewsVisibleWithAttr_2: typeof Handle_IGESDraw_ViewsVisibleWithAttr_2;
  Handle_IGESDraw_ViewsVisibleWithAttr_3: typeof Handle_IGESDraw_ViewsVisibleWithAttr_3;
  Handle_IGESDraw_ViewsVisibleWithAttr_4: typeof Handle_IGESDraw_ViewsVisibleWithAttr_4;
  IGESDraw_ViewsVisibleWithAttr: typeof IGESDraw_ViewsVisibleWithAttr;
  IGESDraw_ToolViewsVisibleWithAttr: typeof IGESDraw_ToolViewsVisibleWithAttr;
  Handle_IGESDraw_NetworkSubfigure: typeof Handle_IGESDraw_NetworkSubfigure;
  Handle_IGESDraw_NetworkSubfigure_1: typeof Handle_IGESDraw_NetworkSubfigure_1;
  Handle_IGESDraw_NetworkSubfigure_2: typeof Handle_IGESDraw_NetworkSubfigure_2;
  Handle_IGESDraw_NetworkSubfigure_3: typeof Handle_IGESDraw_NetworkSubfigure_3;
  Handle_IGESDraw_NetworkSubfigure_4: typeof Handle_IGESDraw_NetworkSubfigure_4;
  IGESDraw_NetworkSubfigure: typeof IGESDraw_NetworkSubfigure;
  IGESDraw_ToolConnectPoint: typeof IGESDraw_ToolConnectPoint;
  Handle_IGESDraw_HArray1OfViewKindEntity: typeof Handle_IGESDraw_HArray1OfViewKindEntity;
  Handle_IGESDraw_HArray1OfViewKindEntity_1: typeof Handle_IGESDraw_HArray1OfViewKindEntity_1;
  Handle_IGESDraw_HArray1OfViewKindEntity_2: typeof Handle_IGESDraw_HArray1OfViewKindEntity_2;
  Handle_IGESDraw_HArray1OfViewKindEntity_3: typeof Handle_IGESDraw_HArray1OfViewKindEntity_3;
  Handle_IGESDraw_HArray1OfViewKindEntity_4: typeof Handle_IGESDraw_HArray1OfViewKindEntity_4;
  IGESDraw_DrawingWithRotation: typeof IGESDraw_DrawingWithRotation;
  Handle_IGESDraw_DrawingWithRotation: typeof Handle_IGESDraw_DrawingWithRotation;
  Handle_IGESDraw_DrawingWithRotation_1: typeof Handle_IGESDraw_DrawingWithRotation_1;
  Handle_IGESDraw_DrawingWithRotation_2: typeof Handle_IGESDraw_DrawingWithRotation_2;
  Handle_IGESDraw_DrawingWithRotation_3: typeof Handle_IGESDraw_DrawingWithRotation_3;
  Handle_IGESDraw_DrawingWithRotation_4: typeof Handle_IGESDraw_DrawingWithRotation_4;
  Handle_IGESDraw_CircArraySubfigure: typeof Handle_IGESDraw_CircArraySubfigure;
  Handle_IGESDraw_CircArraySubfigure_1: typeof Handle_IGESDraw_CircArraySubfigure_1;
  Handle_IGESDraw_CircArraySubfigure_2: typeof Handle_IGESDraw_CircArraySubfigure_2;
  Handle_IGESDraw_CircArraySubfigure_3: typeof Handle_IGESDraw_CircArraySubfigure_3;
  Handle_IGESDraw_CircArraySubfigure_4: typeof Handle_IGESDraw_CircArraySubfigure_4;
  IGESDraw_CircArraySubfigure: typeof IGESDraw_CircArraySubfigure;
  IGESDraw_ToolCircArraySubfigure: typeof IGESDraw_ToolCircArraySubfigure;
  IGESDraw_View: typeof IGESDraw_View;
  Handle_IGESDraw_View: typeof Handle_IGESDraw_View;
  Handle_IGESDraw_View_1: typeof Handle_IGESDraw_View_1;
  Handle_IGESDraw_View_2: typeof Handle_IGESDraw_View_2;
  Handle_IGESDraw_View_3: typeof Handle_IGESDraw_View_3;
  Handle_IGESDraw_View_4: typeof Handle_IGESDraw_View_4;
  IGESDraw_SpecificModule: typeof IGESDraw_SpecificModule;
  Handle_IGESDraw_SpecificModule: typeof Handle_IGESDraw_SpecificModule;
  Handle_IGESDraw_SpecificModule_1: typeof Handle_IGESDraw_SpecificModule_1;
  Handle_IGESDraw_SpecificModule_2: typeof Handle_IGESDraw_SpecificModule_2;
  Handle_IGESDraw_SpecificModule_3: typeof Handle_IGESDraw_SpecificModule_3;
  Handle_IGESDraw_SpecificModule_4: typeof Handle_IGESDraw_SpecificModule_4;
  IGESDraw_RectArraySubfigure: typeof IGESDraw_RectArraySubfigure;
  Handle_IGESDraw_RectArraySubfigure: typeof Handle_IGESDraw_RectArraySubfigure;
  Handle_IGESDraw_RectArraySubfigure_1: typeof Handle_IGESDraw_RectArraySubfigure_1;
  Handle_IGESDraw_RectArraySubfigure_2: typeof Handle_IGESDraw_RectArraySubfigure_2;
  Handle_IGESDraw_RectArraySubfigure_3: typeof Handle_IGESDraw_RectArraySubfigure_3;
  Handle_IGESDraw_RectArraySubfigure_4: typeof Handle_IGESDraw_RectArraySubfigure_4;
  IGESDraw_ToolNetworkSubfigure: typeof IGESDraw_ToolNetworkSubfigure;
  IGESDraw_ReadWriteModule: typeof IGESDraw_ReadWriteModule;
  Handle_IGESDraw_ReadWriteModule: typeof Handle_IGESDraw_ReadWriteModule;
  Handle_IGESDraw_ReadWriteModule_1: typeof Handle_IGESDraw_ReadWriteModule_1;
  Handle_IGESDraw_ReadWriteModule_2: typeof Handle_IGESDraw_ReadWriteModule_2;
  Handle_IGESDraw_ReadWriteModule_3: typeof Handle_IGESDraw_ReadWriteModule_3;
  Handle_IGESDraw_ReadWriteModule_4: typeof Handle_IGESDraw_ReadWriteModule_4;
  IGESDraw_ToolDrawing: typeof IGESDraw_ToolDrawing;
  Handle_IGESDraw_Drawing: typeof Handle_IGESDraw_Drawing;
  Handle_IGESDraw_Drawing_1: typeof Handle_IGESDraw_Drawing_1;
  Handle_IGESDraw_Drawing_2: typeof Handle_IGESDraw_Drawing_2;
  Handle_IGESDraw_Drawing_3: typeof Handle_IGESDraw_Drawing_3;
  Handle_IGESDraw_Drawing_4: typeof Handle_IGESDraw_Drawing_4;
  IGESDraw_Drawing: typeof IGESDraw_Drawing;
  IGESDraw_ToolDrawingWithRotation: typeof IGESDraw_ToolDrawingWithRotation;
  IGESDraw_ToolPerspectiveView: typeof IGESDraw_ToolPerspectiveView;
  Handle_IGESDraw_LabelDisplay: typeof Handle_IGESDraw_LabelDisplay;
  Handle_IGESDraw_LabelDisplay_1: typeof Handle_IGESDraw_LabelDisplay_1;
  Handle_IGESDraw_LabelDisplay_2: typeof Handle_IGESDraw_LabelDisplay_2;
  Handle_IGESDraw_LabelDisplay_3: typeof Handle_IGESDraw_LabelDisplay_3;
  Handle_IGESDraw_LabelDisplay_4: typeof Handle_IGESDraw_LabelDisplay_4;
  IGESDraw_LabelDisplay: typeof IGESDraw_LabelDisplay;
  IGESDraw_ToolNetworkSubfigureDef: typeof IGESDraw_ToolNetworkSubfigureDef;
  IGESDraw_ToolRectArraySubfigure: typeof IGESDraw_ToolRectArraySubfigure;
  XSAlgo: typeof XSAlgo;
  XSAlgo_Caller: XSAlgo_Caller;
  Handle_XSAlgo_ToolContainer: typeof Handle_XSAlgo_ToolContainer;
  Handle_XSAlgo_ToolContainer_1: typeof Handle_XSAlgo_ToolContainer_1;
  Handle_XSAlgo_ToolContainer_2: typeof Handle_XSAlgo_ToolContainer_2;
  Handle_XSAlgo_ToolContainer_3: typeof Handle_XSAlgo_ToolContainer_3;
  Handle_XSAlgo_ToolContainer_4: typeof Handle_XSAlgo_ToolContainer_4;
  XSAlgo_ToolContainer: typeof XSAlgo_ToolContainer;
  Handle_XSAlgo_AlgoContainer: typeof Handle_XSAlgo_AlgoContainer;
  Handle_XSAlgo_AlgoContainer_1: typeof Handle_XSAlgo_AlgoContainer_1;
  Handle_XSAlgo_AlgoContainer_2: typeof Handle_XSAlgo_AlgoContainer_2;
  Handle_XSAlgo_AlgoContainer_3: typeof Handle_XSAlgo_AlgoContainer_3;
  Handle_XSAlgo_AlgoContainer_4: typeof Handle_XSAlgo_AlgoContainer_4;
  XSAlgo_AlgoContainer: typeof XSAlgo_AlgoContainer;
  IGESGeom_BSplineCurve: typeof IGESGeom_BSplineCurve;
  Handle_IGESGeom_BSplineCurve: typeof Handle_IGESGeom_BSplineCurve;
  Handle_IGESGeom_BSplineCurve_1: typeof Handle_IGESGeom_BSplineCurve_1;
  Handle_IGESGeom_BSplineCurve_2: typeof Handle_IGESGeom_BSplineCurve_2;
  Handle_IGESGeom_BSplineCurve_3: typeof Handle_IGESGeom_BSplineCurve_3;
  Handle_IGESGeom_BSplineCurve_4: typeof Handle_IGESGeom_BSplineCurve_4;
  IGESGeom_ToolDirection: typeof IGESGeom_ToolDirection;
  IGESGeom_ToolOffsetCurve: typeof IGESGeom_ToolOffsetCurve;
  IGESGeom_ToolCompositeCurve: typeof IGESGeom_ToolCompositeCurve;
  IGESGeom_ToolRuledSurface: typeof IGESGeom_ToolRuledSurface;
  IGESGeom_ReadWriteModule: typeof IGESGeom_ReadWriteModule;
  Handle_IGESGeom_ReadWriteModule: typeof Handle_IGESGeom_ReadWriteModule;
  Handle_IGESGeom_ReadWriteModule_1: typeof Handle_IGESGeom_ReadWriteModule_1;
  Handle_IGESGeom_ReadWriteModule_2: typeof Handle_IGESGeom_ReadWriteModule_2;
  Handle_IGESGeom_ReadWriteModule_3: typeof Handle_IGESGeom_ReadWriteModule_3;
  Handle_IGESGeom_ReadWriteModule_4: typeof Handle_IGESGeom_ReadWriteModule_4;
  IGESGeom_ToolBoundedSurface: typeof IGESGeom_ToolBoundedSurface;
  IGESGeom_ToolConicArc: typeof IGESGeom_ToolConicArc;
  IGESGeom_ToolBoundary: typeof IGESGeom_ToolBoundary;
  Handle_IGESGeom_Point: typeof Handle_IGESGeom_Point;
  Handle_IGESGeom_Point_1: typeof Handle_IGESGeom_Point_1;
  Handle_IGESGeom_Point_2: typeof Handle_IGESGeom_Point_2;
  Handle_IGESGeom_Point_3: typeof Handle_IGESGeom_Point_3;
  Handle_IGESGeom_Point_4: typeof Handle_IGESGeom_Point_4;
  IGESGeom_Point: typeof IGESGeom_Point;
  IGESGeom_ToolOffsetSurface: typeof IGESGeom_ToolOffsetSurface;
  Handle_IGESGeom_RuledSurface: typeof Handle_IGESGeom_RuledSurface;
  Handle_IGESGeom_RuledSurface_1: typeof Handle_IGESGeom_RuledSurface_1;
  Handle_IGESGeom_RuledSurface_2: typeof Handle_IGESGeom_RuledSurface_2;
  Handle_IGESGeom_RuledSurface_3: typeof Handle_IGESGeom_RuledSurface_3;
  Handle_IGESGeom_RuledSurface_4: typeof Handle_IGESGeom_RuledSurface_4;
  IGESGeom_RuledSurface: typeof IGESGeom_RuledSurface;
  IGESGeom_TrimmedSurface: typeof IGESGeom_TrimmedSurface;
  Handle_IGESGeom_TrimmedSurface: typeof Handle_IGESGeom_TrimmedSurface;
  Handle_IGESGeom_TrimmedSurface_1: typeof Handle_IGESGeom_TrimmedSurface_1;
  Handle_IGESGeom_TrimmedSurface_2: typeof Handle_IGESGeom_TrimmedSurface_2;
  Handle_IGESGeom_TrimmedSurface_3: typeof Handle_IGESGeom_TrimmedSurface_3;
  Handle_IGESGeom_TrimmedSurface_4: typeof Handle_IGESGeom_TrimmedSurface_4;
  IGESGeom_ToolCurveOnSurface: typeof IGESGeom_ToolCurveOnSurface;
  Handle_IGESGeom_CurveOnSurface: typeof Handle_IGESGeom_CurveOnSurface;
  Handle_IGESGeom_CurveOnSurface_1: typeof Handle_IGESGeom_CurveOnSurface_1;
  Handle_IGESGeom_CurveOnSurface_2: typeof Handle_IGESGeom_CurveOnSurface_2;
  Handle_IGESGeom_CurveOnSurface_3: typeof Handle_IGESGeom_CurveOnSurface_3;
  Handle_IGESGeom_CurveOnSurface_4: typeof Handle_IGESGeom_CurveOnSurface_4;
  IGESGeom_CurveOnSurface: typeof IGESGeom_CurveOnSurface;
  IGESGeom_CompositeCurve: typeof IGESGeom_CompositeCurve;
  Handle_IGESGeom_CompositeCurve: typeof Handle_IGESGeom_CompositeCurve;
  Handle_IGESGeom_CompositeCurve_1: typeof Handle_IGESGeom_CompositeCurve_1;
  Handle_IGESGeom_CompositeCurve_2: typeof Handle_IGESGeom_CompositeCurve_2;
  Handle_IGESGeom_CompositeCurve_3: typeof Handle_IGESGeom_CompositeCurve_3;
  Handle_IGESGeom_CompositeCurve_4: typeof Handle_IGESGeom_CompositeCurve_4;
  IGESGeom_ToolFlash: typeof IGESGeom_ToolFlash;
  Handle_IGESGeom_Line: typeof Handle_IGESGeom_Line;
  Handle_IGESGeom_Line_1: typeof Handle_IGESGeom_Line_1;
  Handle_IGESGeom_Line_2: typeof Handle_IGESGeom_Line_2;
  Handle_IGESGeom_Line_3: typeof Handle_IGESGeom_Line_3;
  Handle_IGESGeom_Line_4: typeof Handle_IGESGeom_Line_4;
  IGESGeom_Line: typeof IGESGeom_Line;
  IGESGeom_GeneralModule: typeof IGESGeom_GeneralModule;
  Handle_IGESGeom_GeneralModule: typeof Handle_IGESGeom_GeneralModule;
  Handle_IGESGeom_GeneralModule_1: typeof Handle_IGESGeom_GeneralModule_1;
  Handle_IGESGeom_GeneralModule_2: typeof Handle_IGESGeom_GeneralModule_2;
  Handle_IGESGeom_GeneralModule_3: typeof Handle_IGESGeom_GeneralModule_3;
  Handle_IGESGeom_GeneralModule_4: typeof Handle_IGESGeom_GeneralModule_4;
  IGESGeom_ToolTransformationMatrix: typeof IGESGeom_ToolTransformationMatrix;
  IGESGeom_CircularArc: typeof IGESGeom_CircularArc;
  Handle_IGESGeom_CircularArc: typeof Handle_IGESGeom_CircularArc;
  Handle_IGESGeom_CircularArc_1: typeof Handle_IGESGeom_CircularArc_1;
  Handle_IGESGeom_CircularArc_2: typeof Handle_IGESGeom_CircularArc_2;
  Handle_IGESGeom_CircularArc_3: typeof Handle_IGESGeom_CircularArc_3;
  Handle_IGESGeom_CircularArc_4: typeof Handle_IGESGeom_CircularArc_4;
  IGESGeom_TransformationMatrix: typeof IGESGeom_TransformationMatrix;
  Handle_IGESGeom_TransformationMatrix: typeof Handle_IGESGeom_TransformationMatrix;
  Handle_IGESGeom_TransformationMatrix_1: typeof Handle_IGESGeom_TransformationMatrix_1;
  Handle_IGESGeom_TransformationMatrix_2: typeof Handle_IGESGeom_TransformationMatrix_2;
  Handle_IGESGeom_TransformationMatrix_3: typeof Handle_IGESGeom_TransformationMatrix_3;
  Handle_IGESGeom_TransformationMatrix_4: typeof Handle_IGESGeom_TransformationMatrix_4;
  IGESGeom_ToolCopiousData: typeof IGESGeom_ToolCopiousData;
  IGESGeom_ToolSurfaceOfRevolution: typeof IGESGeom_ToolSurfaceOfRevolution;
  IGESGeom_ToolBSplineSurface: typeof IGESGeom_ToolBSplineSurface;
  Handle_IGESGeom_HArray1OfTransformationMatrix: typeof Handle_IGESGeom_HArray1OfTransformationMatrix;
  Handle_IGESGeom_HArray1OfTransformationMatrix_1: typeof Handle_IGESGeom_HArray1OfTransformationMatrix_1;
  Handle_IGESGeom_HArray1OfTransformationMatrix_2: typeof Handle_IGESGeom_HArray1OfTransformationMatrix_2;
  Handle_IGESGeom_HArray1OfTransformationMatrix_3: typeof Handle_IGESGeom_HArray1OfTransformationMatrix_3;
  Handle_IGESGeom_HArray1OfTransformationMatrix_4: typeof Handle_IGESGeom_HArray1OfTransformationMatrix_4;
  Handle_IGESGeom_SpecificModule: typeof Handle_IGESGeom_SpecificModule;
  Handle_IGESGeom_SpecificModule_1: typeof Handle_IGESGeom_SpecificModule_1;
  Handle_IGESGeom_SpecificModule_2: typeof Handle_IGESGeom_SpecificModule_2;
  Handle_IGESGeom_SpecificModule_3: typeof Handle_IGESGeom_SpecificModule_3;
  Handle_IGESGeom_SpecificModule_4: typeof Handle_IGESGeom_SpecificModule_4;
  IGESGeom_SpecificModule: typeof IGESGeom_SpecificModule;
  Handle_IGESGeom_HArray1OfCurveOnSurface: typeof Handle_IGESGeom_HArray1OfCurveOnSurface;
  Handle_IGESGeom_HArray1OfCurveOnSurface_1: typeof Handle_IGESGeom_HArray1OfCurveOnSurface_1;
  Handle_IGESGeom_HArray1OfCurveOnSurface_2: typeof Handle_IGESGeom_HArray1OfCurveOnSurface_2;
  Handle_IGESGeom_HArray1OfCurveOnSurface_3: typeof Handle_IGESGeom_HArray1OfCurveOnSurface_3;
  Handle_IGESGeom_HArray1OfCurveOnSurface_4: typeof Handle_IGESGeom_HArray1OfCurveOnSurface_4;
  IGESGeom_ToolPoint: typeof IGESGeom_ToolPoint;
  IGESGeom_Plane: typeof IGESGeom_Plane;
  Handle_IGESGeom_Plane: typeof Handle_IGESGeom_Plane;
  Handle_IGESGeom_Plane_1: typeof Handle_IGESGeom_Plane_1;
  Handle_IGESGeom_Plane_2: typeof Handle_IGESGeom_Plane_2;
  Handle_IGESGeom_Plane_3: typeof Handle_IGESGeom_Plane_3;
  Handle_IGESGeom_Plane_4: typeof Handle_IGESGeom_Plane_4;
  IGESGeom_TabulatedCylinder: typeof IGESGeom_TabulatedCylinder;
  Handle_IGESGeom_TabulatedCylinder: typeof Handle_IGESGeom_TabulatedCylinder;
  Handle_IGESGeom_TabulatedCylinder_1: typeof Handle_IGESGeom_TabulatedCylinder_1;
  Handle_IGESGeom_TabulatedCylinder_2: typeof Handle_IGESGeom_TabulatedCylinder_2;
  Handle_IGESGeom_TabulatedCylinder_3: typeof Handle_IGESGeom_TabulatedCylinder_3;
  Handle_IGESGeom_TabulatedCylinder_4: typeof Handle_IGESGeom_TabulatedCylinder_4;
  Handle_IGESGeom_CopiousData: typeof Handle_IGESGeom_CopiousData;
  Handle_IGESGeom_CopiousData_1: typeof Handle_IGESGeom_CopiousData_1;
  Handle_IGESGeom_CopiousData_2: typeof Handle_IGESGeom_CopiousData_2;
  Handle_IGESGeom_CopiousData_3: typeof Handle_IGESGeom_CopiousData_3;
  Handle_IGESGeom_CopiousData_4: typeof Handle_IGESGeom_CopiousData_4;
  IGESGeom_CopiousData: typeof IGESGeom_CopiousData;
  IGESGeom_SplineSurface: typeof IGESGeom_SplineSurface;
  Handle_IGESGeom_SplineSurface: typeof Handle_IGESGeom_SplineSurface;
  Handle_IGESGeom_SplineSurface_1: typeof Handle_IGESGeom_SplineSurface_1;
  Handle_IGESGeom_SplineSurface_2: typeof Handle_IGESGeom_SplineSurface_2;
  Handle_IGESGeom_SplineSurface_3: typeof Handle_IGESGeom_SplineSurface_3;
  Handle_IGESGeom_SplineSurface_4: typeof Handle_IGESGeom_SplineSurface_4;
  IGESGeom_ToolPlane: typeof IGESGeom_ToolPlane;
  Handle_IGESGeom_SplineCurve: typeof Handle_IGESGeom_SplineCurve;
  Handle_IGESGeom_SplineCurve_1: typeof Handle_IGESGeom_SplineCurve_1;
  Handle_IGESGeom_SplineCurve_2: typeof Handle_IGESGeom_SplineCurve_2;
  Handle_IGESGeom_SplineCurve_3: typeof Handle_IGESGeom_SplineCurve_3;
  Handle_IGESGeom_SplineCurve_4: typeof Handle_IGESGeom_SplineCurve_4;
  IGESGeom_SplineCurve: typeof IGESGeom_SplineCurve;
  IGESGeom: typeof IGESGeom;
  Handle_IGESGeom_OffsetCurve: typeof Handle_IGESGeom_OffsetCurve;
  Handle_IGESGeom_OffsetCurve_1: typeof Handle_IGESGeom_OffsetCurve_1;
  Handle_IGESGeom_OffsetCurve_2: typeof Handle_IGESGeom_OffsetCurve_2;
  Handle_IGESGeom_OffsetCurve_3: typeof Handle_IGESGeom_OffsetCurve_3;
  Handle_IGESGeom_OffsetCurve_4: typeof Handle_IGESGeom_OffsetCurve_4;
  IGESGeom_OffsetCurve: typeof IGESGeom_OffsetCurve;
  IGESGeom_ToolTrimmedSurface: typeof IGESGeom_ToolTrimmedSurface;
  IGESGeom_ToolTabulatedCylinder: typeof IGESGeom_ToolTabulatedCylinder;
  IGESGeom_ToolSplineSurface: typeof IGESGeom_ToolSplineSurface;
  IGESGeom_BSplineSurface: typeof IGESGeom_BSplineSurface;
  Handle_IGESGeom_BSplineSurface: typeof Handle_IGESGeom_BSplineSurface;
  Handle_IGESGeom_BSplineSurface_1: typeof Handle_IGESGeom_BSplineSurface_1;
  Handle_IGESGeom_BSplineSurface_2: typeof Handle_IGESGeom_BSplineSurface_2;
  Handle_IGESGeom_BSplineSurface_3: typeof Handle_IGESGeom_BSplineSurface_3;
  Handle_IGESGeom_BSplineSurface_4: typeof Handle_IGESGeom_BSplineSurface_4;
  IGESGeom_SurfaceOfRevolution: typeof IGESGeom_SurfaceOfRevolution;
  Handle_IGESGeom_SurfaceOfRevolution: typeof Handle_IGESGeom_SurfaceOfRevolution;
  Handle_IGESGeom_SurfaceOfRevolution_1: typeof Handle_IGESGeom_SurfaceOfRevolution_1;
  Handle_IGESGeom_SurfaceOfRevolution_2: typeof Handle_IGESGeom_SurfaceOfRevolution_2;
  Handle_IGESGeom_SurfaceOfRevolution_3: typeof Handle_IGESGeom_SurfaceOfRevolution_3;
  Handle_IGESGeom_SurfaceOfRevolution_4: typeof Handle_IGESGeom_SurfaceOfRevolution_4;
  Handle_IGESGeom_Direction: typeof Handle_IGESGeom_Direction;
  Handle_IGESGeom_Direction_1: typeof Handle_IGESGeom_Direction_1;
  Handle_IGESGeom_Direction_2: typeof Handle_IGESGeom_Direction_2;
  Handle_IGESGeom_Direction_3: typeof Handle_IGESGeom_Direction_3;
  Handle_IGESGeom_Direction_4: typeof Handle_IGESGeom_Direction_4;
  IGESGeom_Direction: typeof IGESGeom_Direction;
  IGESGeom_ToolCircularArc: typeof IGESGeom_ToolCircularArc;
  Handle_IGESGeom_Protocol: typeof Handle_IGESGeom_Protocol;
  Handle_IGESGeom_Protocol_1: typeof Handle_IGESGeom_Protocol_1;
  Handle_IGESGeom_Protocol_2: typeof Handle_IGESGeom_Protocol_2;
  Handle_IGESGeom_Protocol_3: typeof Handle_IGESGeom_Protocol_3;
  Handle_IGESGeom_Protocol_4: typeof Handle_IGESGeom_Protocol_4;
  IGESGeom_Protocol: typeof IGESGeom_Protocol;
  Handle_IGESGeom_Boundary: typeof Handle_IGESGeom_Boundary;
  Handle_IGESGeom_Boundary_1: typeof Handle_IGESGeom_Boundary_1;
  Handle_IGESGeom_Boundary_2: typeof Handle_IGESGeom_Boundary_2;
  Handle_IGESGeom_Boundary_3: typeof Handle_IGESGeom_Boundary_3;
  Handle_IGESGeom_Boundary_4: typeof Handle_IGESGeom_Boundary_4;
  IGESGeom_Boundary: typeof IGESGeom_Boundary;
  IGESGeom_ToolSplineCurve: typeof IGESGeom_ToolSplineCurve;
  IGESGeom_ToolLine: typeof IGESGeom_ToolLine;
  Handle_IGESGeom_BoundedSurface: typeof Handle_IGESGeom_BoundedSurface;
  Handle_IGESGeom_BoundedSurface_1: typeof Handle_IGESGeom_BoundedSurface_1;
  Handle_IGESGeom_BoundedSurface_2: typeof Handle_IGESGeom_BoundedSurface_2;
  Handle_IGESGeom_BoundedSurface_3: typeof Handle_IGESGeom_BoundedSurface_3;
  Handle_IGESGeom_BoundedSurface_4: typeof Handle_IGESGeom_BoundedSurface_4;
  IGESGeom_BoundedSurface: typeof IGESGeom_BoundedSurface;
  Handle_IGESGeom_HArray1OfBoundary: typeof Handle_IGESGeom_HArray1OfBoundary;
  Handle_IGESGeom_HArray1OfBoundary_1: typeof Handle_IGESGeom_HArray1OfBoundary_1;
  Handle_IGESGeom_HArray1OfBoundary_2: typeof Handle_IGESGeom_HArray1OfBoundary_2;
  Handle_IGESGeom_HArray1OfBoundary_3: typeof Handle_IGESGeom_HArray1OfBoundary_3;
  Handle_IGESGeom_HArray1OfBoundary_4: typeof Handle_IGESGeom_HArray1OfBoundary_4;
  IGESGeom_Flash: typeof IGESGeom_Flash;
  Handle_IGESGeom_Flash: typeof Handle_IGESGeom_Flash;
  Handle_IGESGeom_Flash_1: typeof Handle_IGESGeom_Flash_1;
  Handle_IGESGeom_Flash_2: typeof Handle_IGESGeom_Flash_2;
  Handle_IGESGeom_Flash_3: typeof Handle_IGESGeom_Flash_3;
  Handle_IGESGeom_Flash_4: typeof Handle_IGESGeom_Flash_4;
  IGESGeom_ToolBSplineCurve: typeof IGESGeom_ToolBSplineCurve;
  IGESGeom_OffsetSurface: typeof IGESGeom_OffsetSurface;
  Handle_IGESGeom_OffsetSurface: typeof Handle_IGESGeom_OffsetSurface;
  Handle_IGESGeom_OffsetSurface_1: typeof Handle_IGESGeom_OffsetSurface_1;
  Handle_IGESGeom_OffsetSurface_2: typeof Handle_IGESGeom_OffsetSurface_2;
  Handle_IGESGeom_OffsetSurface_3: typeof Handle_IGESGeom_OffsetSurface_3;
  Handle_IGESGeom_OffsetSurface_4: typeof Handle_IGESGeom_OffsetSurface_4;
  Handle_IGESGeom_ConicArc: typeof Handle_IGESGeom_ConicArc;
  Handle_IGESGeom_ConicArc_1: typeof Handle_IGESGeom_ConicArc_1;
  Handle_IGESGeom_ConicArc_2: typeof Handle_IGESGeom_ConicArc_2;
  Handle_IGESGeom_ConicArc_3: typeof Handle_IGESGeom_ConicArc_3;
  Handle_IGESGeom_ConicArc_4: typeof Handle_IGESGeom_ConicArc_4;
  IGESGeom_ConicArc: typeof IGESGeom_ConicArc;
  TFunction_Iterator: typeof TFunction_Iterator;
  TFunction_Iterator_1: typeof TFunction_Iterator_1;
  TFunction_Iterator_2: typeof TFunction_Iterator_2;
  TFunction_Driver: typeof TFunction_Driver;
  Handle_TFunction_Driver: typeof Handle_TFunction_Driver;
  Handle_TFunction_Driver_1: typeof Handle_TFunction_Driver_1;
  Handle_TFunction_Driver_2: typeof Handle_TFunction_Driver_2;
  Handle_TFunction_Driver_3: typeof Handle_TFunction_Driver_3;
  Handle_TFunction_Driver_4: typeof Handle_TFunction_Driver_4;
  TFunction_DataMapOfLabelListOfLabel: typeof TFunction_DataMapOfLabelListOfLabel;
  TFunction_DataMapOfLabelListOfLabel_1: typeof TFunction_DataMapOfLabelListOfLabel_1;
  TFunction_DataMapOfLabelListOfLabel_2: typeof TFunction_DataMapOfLabelListOfLabel_2;
  TFunction_DataMapOfLabelListOfLabel_3: typeof TFunction_DataMapOfLabelListOfLabel_3;
  Handle_TFunction_DriverTable: typeof Handle_TFunction_DriverTable;
  Handle_TFunction_DriverTable_1: typeof Handle_TFunction_DriverTable_1;
  Handle_TFunction_DriverTable_2: typeof Handle_TFunction_DriverTable_2;
  Handle_TFunction_DriverTable_3: typeof Handle_TFunction_DriverTable_3;
  Handle_TFunction_DriverTable_4: typeof Handle_TFunction_DriverTable_4;
  TFunction_DriverTable: typeof TFunction_DriverTable;
  TFunction_DoubleMapOfIntegerLabel: typeof TFunction_DoubleMapOfIntegerLabel;
  TFunction_DoubleMapOfIntegerLabel_1: typeof TFunction_DoubleMapOfIntegerLabel_1;
  TFunction_DoubleMapOfIntegerLabel_2: typeof TFunction_DoubleMapOfIntegerLabel_2;
  TFunction_DoubleMapOfIntegerLabel_3: typeof TFunction_DoubleMapOfIntegerLabel_3;
  Handle_TFunction_HArray1OfDataMapOfGUIDDriver: typeof Handle_TFunction_HArray1OfDataMapOfGUIDDriver;
  Handle_TFunction_HArray1OfDataMapOfGUIDDriver_1: typeof Handle_TFunction_HArray1OfDataMapOfGUIDDriver_1;
  Handle_TFunction_HArray1OfDataMapOfGUIDDriver_2: typeof Handle_TFunction_HArray1OfDataMapOfGUIDDriver_2;
  Handle_TFunction_HArray1OfDataMapOfGUIDDriver_3: typeof Handle_TFunction_HArray1OfDataMapOfGUIDDriver_3;
  Handle_TFunction_HArray1OfDataMapOfGUIDDriver_4: typeof Handle_TFunction_HArray1OfDataMapOfGUIDDriver_4;
  TFunction_IFunction: typeof TFunction_IFunction;
  TFunction_IFunction_1: typeof TFunction_IFunction_1;
  TFunction_IFunction_2: typeof TFunction_IFunction_2;
  TFunction_GraphNode: typeof TFunction_GraphNode;
  Handle_TFunction_GraphNode: typeof Handle_TFunction_GraphNode;
  Handle_TFunction_GraphNode_1: typeof Handle_TFunction_GraphNode_1;
  Handle_TFunction_GraphNode_2: typeof Handle_TFunction_GraphNode_2;
  Handle_TFunction_GraphNode_3: typeof Handle_TFunction_GraphNode_3;
  Handle_TFunction_GraphNode_4: typeof Handle_TFunction_GraphNode_4;
  TFunction_Array1OfDataMapOfGUIDDriver: typeof TFunction_Array1OfDataMapOfGUIDDriver;
  TFunction_Array1OfDataMapOfGUIDDriver_1: typeof TFunction_Array1OfDataMapOfGUIDDriver_1;
  TFunction_Array1OfDataMapOfGUIDDriver_2: typeof TFunction_Array1OfDataMapOfGUIDDriver_2;
  TFunction_Array1OfDataMapOfGUIDDriver_3: typeof TFunction_Array1OfDataMapOfGUIDDriver_3;
  TFunction_Array1OfDataMapOfGUIDDriver_4: typeof TFunction_Array1OfDataMapOfGUIDDriver_4;
  TFunction_Array1OfDataMapOfGUIDDriver_5: typeof TFunction_Array1OfDataMapOfGUIDDriver_5;
  TFunction_Scope: typeof TFunction_Scope;
  Handle_TFunction_Scope: typeof Handle_TFunction_Scope;
  Handle_TFunction_Scope_1: typeof Handle_TFunction_Scope_1;
  Handle_TFunction_Scope_2: typeof Handle_TFunction_Scope_2;
  Handle_TFunction_Scope_3: typeof Handle_TFunction_Scope_3;
  Handle_TFunction_Scope_4: typeof Handle_TFunction_Scope_4;
  Handle_TFunction_Logbook: typeof Handle_TFunction_Logbook;
  Handle_TFunction_Logbook_1: typeof Handle_TFunction_Logbook_1;
  Handle_TFunction_Logbook_2: typeof Handle_TFunction_Logbook_2;
  Handle_TFunction_Logbook_3: typeof Handle_TFunction_Logbook_3;
  Handle_TFunction_Logbook_4: typeof Handle_TFunction_Logbook_4;
  TFunction_Logbook: typeof TFunction_Logbook;
  TFunction_ExecutionStatus: TFunction_ExecutionStatus;
  Handle_TFunction_Function: typeof Handle_TFunction_Function;
  Handle_TFunction_Function_1: typeof Handle_TFunction_Function_1;
  Handle_TFunction_Function_2: typeof Handle_TFunction_Function_2;
  Handle_TFunction_Function_3: typeof Handle_TFunction_Function_3;
  Handle_TFunction_Function_4: typeof Handle_TFunction_Function_4;
  TFunction_Function: typeof TFunction_Function;
  StdObject_Shape: typeof StdObject_Shape;
  StdObject_Location: typeof StdObject_Location;
  Sweep_NumShapeIterator: typeof Sweep_NumShapeIterator;
  Sweep_NumShapeTool: typeof Sweep_NumShapeTool;
  Sweep_NumShape: typeof Sweep_NumShape;
  Sweep_NumShape_1: typeof Sweep_NumShape_1;
  Sweep_NumShape_2: typeof Sweep_NumShape_2;
  RWStepVisual_RWDraughtingModel: typeof RWStepVisual_RWDraughtingModel;
  RWStepVisual_RWSurfaceStyleTransparent: typeof RWStepVisual_RWSurfaceStyleTransparent;
  RWStepVisual_RWAnnotationCurveOccurrenceAndGeomReprItem: typeof RWStepVisual_RWAnnotationCurveOccurrenceAndGeomReprItem;
  RWStepVisual_RWCurveStyleFont: typeof RWStepVisual_RWCurveStyleFont;
  RWStepVisual_RWCoordinatesList: typeof RWStepVisual_RWCoordinatesList;
  RWStepVisual_RWAreaInSet: typeof RWStepVisual_RWAreaInSet;
  RWStepVisual_RWAnnotationFillAreaOccurrence: typeof RWStepVisual_RWAnnotationFillAreaOccurrence;
  RWStepVisual_RWPresentationLayerAssignment: typeof RWStepVisual_RWPresentationLayerAssignment;
  RWStepVisual_RWPlanarBox: typeof RWStepVisual_RWPlanarBox;
  RWStepVisual_RWDraughtingCallout: typeof RWStepVisual_RWDraughtingCallout;
  RWStepVisual_RWAnnotationFillArea: typeof RWStepVisual_RWAnnotationFillArea;
  RWStepVisual_RWPreDefinedCurveFont: typeof RWStepVisual_RWPreDefinedCurveFont;
  RWStepVisual_RWDraughtingPreDefinedColour: typeof RWStepVisual_RWDraughtingPreDefinedColour;
  RWStepVisual_RWSurfaceStyleUsage: typeof RWStepVisual_RWSurfaceStyleUsage;
  RWStepVisual_RWPlanarExtent: typeof RWStepVisual_RWPlanarExtent;
  RWStepVisual_RWStyledItem: typeof RWStepVisual_RWStyledItem;
  RWStepVisual_RWAnnotationOccurrence: typeof RWStepVisual_RWAnnotationOccurrence;
  RWStepVisual_RWPointStyle: typeof RWStepVisual_RWPointStyle;
  RWStepVisual_RWSurfaceStyleRenderingWithProperties: typeof RWStepVisual_RWSurfaceStyleRenderingWithProperties;
  RWStepVisual_RWSurfaceStyleBoundary: typeof RWStepVisual_RWSurfaceStyleBoundary;
  RWStepVisual_RWInvisibility: typeof RWStepVisual_RWInvisibility;
  RWStepVisual_RWMechanicalDesignGeometricPresentationRepresentation: typeof RWStepVisual_RWMechanicalDesignGeometricPresentationRepresentation;
  RWStepVisual_RWAnnotationCurveOccurrence: typeof RWStepVisual_RWAnnotationCurveOccurrence;
  RWStepVisual_RWSurfaceStyleRendering: typeof RWStepVisual_RWSurfaceStyleRendering;
  RWStepVisual_RWSurfaceStyleParameterLine: typeof RWStepVisual_RWSurfaceStyleParameterLine;
  RWStepVisual_RWCompositeText: typeof RWStepVisual_RWCompositeText;
  RWStepVisual_RWCameraImage: typeof RWStepVisual_RWCameraImage;
  RWStepVisual_RWTemplate: typeof RWStepVisual_RWTemplate;
  RWStepVisual_RWTessellatedAnnotationOccurrence: typeof RWStepVisual_RWTessellatedAnnotationOccurrence;
  RWStepVisual_RWCameraModelD3MultiClipping: typeof RWStepVisual_RWCameraModelD3MultiClipping;
  RWStepVisual_RWColourRgb: typeof RWStepVisual_RWColourRgb;
  RWStepVisual_RWCurveStyleFontPattern: typeof RWStepVisual_RWCurveStyleFontPattern;
  RWStepVisual_RWTextStyleWithBoxCharacteristics: typeof RWStepVisual_RWTextStyleWithBoxCharacteristics;
  RWStepVisual_RWPresentationView: typeof RWStepVisual_RWPresentationView;
  RWStepVisual_RWTextLiteral: typeof RWStepVisual_RWTextLiteral;
  RWStepVisual_RWFillAreaStyleColour: typeof RWStepVisual_RWFillAreaStyleColour;
  RWStepVisual_RWSurfaceStyleControlGrid: typeof RWStepVisual_RWSurfaceStyleControlGrid;
  RWStepVisual_RWAnnotationPlane: typeof RWStepVisual_RWAnnotationPlane;
  RWStepVisual_RWViewVolume: typeof RWStepVisual_RWViewVolume;
  RWStepVisual_RWCurveStyle: typeof RWStepVisual_RWCurveStyle;
  RWStepVisual_RWTessellatedCurveSet: typeof RWStepVisual_RWTessellatedCurveSet;
  RWStepVisual_RWCameraModelD3: typeof RWStepVisual_RWCameraModelD3;
  RWStepVisual_RWContextDependentInvisibility: typeof RWStepVisual_RWContextDependentInvisibility;
  RWStepVisual_RWTessellatedItem: typeof RWStepVisual_RWTessellatedItem;
  RWStepVisual_RWOverRidingStyledItem: typeof RWStepVisual_RWOverRidingStyledItem;
  RWStepVisual_RWCameraUsage: typeof RWStepVisual_RWCameraUsage;
  RWStepVisual_RWCompositeTextWithExtent: typeof RWStepVisual_RWCompositeTextWithExtent;
  RWStepVisual_RWTessellatedGeometricSet: typeof RWStepVisual_RWTessellatedGeometricSet;
  RWStepVisual_RWPresentationSet: typeof RWStepVisual_RWPresentationSet;
  RWStepVisual_RWCameraModelD3MultiClippingUnion: typeof RWStepVisual_RWCameraModelD3MultiClippingUnion;
  RWStepVisual_RWPresentedItemRepresentation: typeof RWStepVisual_RWPresentedItemRepresentation;
  RWStepVisual_RWCharacterizedObjAndRepresentationAndDraughtingModel: typeof RWStepVisual_RWCharacterizedObjAndRepresentationAndDraughtingModel;
  RWStepVisual_RWCameraModelD2: typeof RWStepVisual_RWCameraModelD2;
  RWStepVisual_RWPresentationArea: typeof RWStepVisual_RWPresentationArea;
  RWStepVisual_RWSurfaceStyleFillArea: typeof RWStepVisual_RWSurfaceStyleFillArea;
  RWStepVisual_RWPresentationStyleByContext: typeof RWStepVisual_RWPresentationStyleByContext;
  RWStepVisual_RWPresentationLayerUsage: typeof RWStepVisual_RWPresentationLayerUsage;
  RWStepVisual_RWTextStyle: typeof RWStepVisual_RWTextStyle;
  RWStepVisual_RWCameraModel: typeof RWStepVisual_RWCameraModel;
  RWStepVisual_RWPreDefinedColour: typeof RWStepVisual_RWPreDefinedColour;
  RWStepVisual_RWPresentationSize: typeof RWStepVisual_RWPresentationSize;
  RWStepVisual_RWMechanicalDesignGeometricPresentationArea: typeof RWStepVisual_RWMechanicalDesignGeometricPresentationArea;
  RWStepVisual_RWBackgroundColour: typeof RWStepVisual_RWBackgroundColour;
  RWStepVisual_RWContextDependentOverRidingStyledItem: typeof RWStepVisual_RWContextDependentOverRidingStyledItem;
  RWStepVisual_RWFillAreaStyle: typeof RWStepVisual_RWFillAreaStyle;
  RWStepVisual_RWExternallyDefinedCurveFont: typeof RWStepVisual_RWExternallyDefinedCurveFont;
  RWStepVisual_RWSurfaceStyleReflectanceAmbient: typeof RWStepVisual_RWSurfaceStyleReflectanceAmbient;
  RWStepVisual_RWPreDefinedItem: typeof RWStepVisual_RWPreDefinedItem;
  RWStepVisual_RWCameraModelD3MultiClippingIntersection: typeof RWStepVisual_RWCameraModelD3MultiClippingIntersection;
  RWStepVisual_RWTemplateInstance: typeof RWStepVisual_RWTemplateInstance;
  RWStepVisual_RWTextStyleForDefinedFont: typeof RWStepVisual_RWTextStyleForDefinedFont;
  RWStepVisual_RWSurfaceStyleSegmentationCurve: typeof RWStepVisual_RWSurfaceStyleSegmentationCurve;
  RWStepVisual_RWDraughtingPreDefinedCurveFont: typeof RWStepVisual_RWDraughtingPreDefinedCurveFont;
  RWStepVisual_RWColour: typeof RWStepVisual_RWColour;
  RWStepVisual_RWSurfaceStyleSilhouette: typeof RWStepVisual_RWSurfaceStyleSilhouette;
  RWStepVisual_RWPresentationStyleAssignment: typeof RWStepVisual_RWPresentationStyleAssignment;
  RWStepVisual_RWPresentationRepresentation: typeof RWStepVisual_RWPresentationRepresentation;
  RWStepVisual_RWColourSpecification: typeof RWStepVisual_RWColourSpecification;
  RWStepVisual_RWSurfaceSideStyle: typeof RWStepVisual_RWSurfaceSideStyle;
  BRepAlgo_FaceRestrictor: typeof BRepAlgo_FaceRestrictor;
  BRepAlgo: typeof BRepAlgo;
  BRepAlgo_Image: typeof BRepAlgo_Image;
  BRepAlgo_BooleanOperation: typeof BRepAlgo_BooleanOperation;
  BRepAlgo_Common: typeof BRepAlgo_Common;
  BRepAlgo_AsDes: typeof BRepAlgo_AsDes;
  Handle_BRepAlgo_AsDes: typeof Handle_BRepAlgo_AsDes;
  Handle_BRepAlgo_AsDes_1: typeof Handle_BRepAlgo_AsDes_1;
  Handle_BRepAlgo_AsDes_2: typeof Handle_BRepAlgo_AsDes_2;
  Handle_BRepAlgo_AsDes_3: typeof Handle_BRepAlgo_AsDes_3;
  Handle_BRepAlgo_AsDes_4: typeof Handle_BRepAlgo_AsDes_4;
  BRepAlgo_CheckStatus: BRepAlgo_CheckStatus;
  BRepAlgo_NormalProjection: typeof BRepAlgo_NormalProjection;
  BRepAlgo_NormalProjection_1: typeof BRepAlgo_NormalProjection_1;
  BRepAlgo_NormalProjection_2: typeof BRepAlgo_NormalProjection_2;
  BRepAlgo_Cut: typeof BRepAlgo_Cut;
  BRepAlgo_Fuse: typeof BRepAlgo_Fuse;
  BRepAlgo_Section: typeof BRepAlgo_Section;
  BRepAlgo_Section_1: typeof BRepAlgo_Section_1;
  BRepAlgo_Section_2: typeof BRepAlgo_Section_2;
  BRepAlgo_Section_3: typeof BRepAlgo_Section_3;
  BRepAlgo_Section_4: typeof BRepAlgo_Section_4;
  BRepAlgo_Section_5: typeof BRepAlgo_Section_5;
  BRepAlgo_Tool: typeof BRepAlgo_Tool;
  BRepAlgo_Loop: typeof BRepAlgo_Loop;
  BinMDF: typeof BinMDF;
  BinMDF_ReferenceDriver: typeof BinMDF_ReferenceDriver;
  Handle_BinMDF_ReferenceDriver: typeof Handle_BinMDF_ReferenceDriver;
  Handle_BinMDF_ReferenceDriver_1: typeof Handle_BinMDF_ReferenceDriver_1;
  Handle_BinMDF_ReferenceDriver_2: typeof Handle_BinMDF_ReferenceDriver_2;
  Handle_BinMDF_ReferenceDriver_3: typeof Handle_BinMDF_ReferenceDriver_3;
  Handle_BinMDF_ReferenceDriver_4: typeof Handle_BinMDF_ReferenceDriver_4;
  BinMDF_DerivedDriver: typeof BinMDF_DerivedDriver;
  Handle_BinMDF_TagSourceDriver: typeof Handle_BinMDF_TagSourceDriver;
  Handle_BinMDF_TagSourceDriver_1: typeof Handle_BinMDF_TagSourceDriver_1;
  Handle_BinMDF_TagSourceDriver_2: typeof Handle_BinMDF_TagSourceDriver_2;
  Handle_BinMDF_TagSourceDriver_3: typeof Handle_BinMDF_TagSourceDriver_3;
  Handle_BinMDF_TagSourceDriver_4: typeof Handle_BinMDF_TagSourceDriver_4;
  BinMDF_TagSourceDriver: typeof BinMDF_TagSourceDriver;
  Handle_BinMDF_ADriver: typeof Handle_BinMDF_ADriver;
  Handle_BinMDF_ADriver_1: typeof Handle_BinMDF_ADriver_1;
  Handle_BinMDF_ADriver_2: typeof Handle_BinMDF_ADriver_2;
  Handle_BinMDF_ADriver_3: typeof Handle_BinMDF_ADriver_3;
  Handle_BinMDF_ADriver_4: typeof Handle_BinMDF_ADriver_4;
  BinMDF_ADriver: typeof BinMDF_ADriver;
  BinMDF_ADriverTable: typeof BinMDF_ADriverTable;
  Handle_BinMDF_ADriverTable: typeof Handle_BinMDF_ADriverTable;
  Handle_BinMDF_ADriverTable_1: typeof Handle_BinMDF_ADriverTable_1;
  Handle_BinMDF_ADriverTable_2: typeof Handle_BinMDF_ADriverTable_2;
  Handle_BinMDF_ADriverTable_3: typeof Handle_BinMDF_ADriverTable_3;
  Handle_BinMDF_ADriverTable_4: typeof Handle_BinMDF_ADriverTable_4;
  IGESSolid_ToolFace: typeof IGESSolid_ToolFace;
  IGESSolid_ToolShell: typeof IGESSolid_ToolShell;
  IGESSolid_ToolConicalSurface: typeof IGESSolid_ToolConicalSurface;
  IGESSolid_ToolEdgeList: typeof IGESSolid_ToolEdgeList;
  Handle_IGESSolid_Block: typeof Handle_IGESSolid_Block;
  Handle_IGESSolid_Block_1: typeof Handle_IGESSolid_Block_1;
  Handle_IGESSolid_Block_2: typeof Handle_IGESSolid_Block_2;
  Handle_IGESSolid_Block_3: typeof Handle_IGESSolid_Block_3;
  Handle_IGESSolid_Block_4: typeof Handle_IGESSolid_Block_4;
  IGESSolid_Block: typeof IGESSolid_Block;
  Handle_IGESSolid_ToroidalSurface: typeof Handle_IGESSolid_ToroidalSurface;
  Handle_IGESSolid_ToroidalSurface_1: typeof Handle_IGESSolid_ToroidalSurface_1;
  Handle_IGESSolid_ToroidalSurface_2: typeof Handle_IGESSolid_ToroidalSurface_2;
  Handle_IGESSolid_ToroidalSurface_3: typeof Handle_IGESSolid_ToroidalSurface_3;
  Handle_IGESSolid_ToroidalSurface_4: typeof Handle_IGESSolid_ToroidalSurface_4;
  IGESSolid_ToroidalSurface: typeof IGESSolid_ToroidalSurface;
  IGESSolid_Shell: typeof IGESSolid_Shell;
  Handle_IGESSolid_Shell: typeof Handle_IGESSolid_Shell;
  Handle_IGESSolid_Shell_1: typeof Handle_IGESSolid_Shell_1;
  Handle_IGESSolid_Shell_2: typeof Handle_IGESSolid_Shell_2;
  Handle_IGESSolid_Shell_3: typeof Handle_IGESSolid_Shell_3;
  Handle_IGESSolid_Shell_4: typeof Handle_IGESSolid_Shell_4;
  IGESSolid_Loop: typeof IGESSolid_Loop;
  Handle_IGESSolid_Loop: typeof Handle_IGESSolid_Loop;
  Handle_IGESSolid_Loop_1: typeof Handle_IGESSolid_Loop_1;
  Handle_IGESSolid_Loop_2: typeof Handle_IGESSolid_Loop_2;
  Handle_IGESSolid_Loop_3: typeof Handle_IGESSolid_Loop_3;
  Handle_IGESSolid_Loop_4: typeof Handle_IGESSolid_Loop_4;
  IGESSolid_ToolVertexList: typeof IGESSolid_ToolVertexList;
  IGESSolid_ToolLoop: typeof IGESSolid_ToolLoop;
  IGESSolid_ToolSolidOfLinearExtrusion: typeof IGESSolid_ToolSolidOfLinearExtrusion;
  IGESSolid_ToolSphericalSurface: typeof IGESSolid_ToolSphericalSurface;
  IGESSolid_SolidInstance: typeof IGESSolid_SolidInstance;
  Handle_IGESSolid_SolidInstance: typeof Handle_IGESSolid_SolidInstance;
  Handle_IGESSolid_SolidInstance_1: typeof Handle_IGESSolid_SolidInstance_1;
  Handle_IGESSolid_SolidInstance_2: typeof Handle_IGESSolid_SolidInstance_2;
  Handle_IGESSolid_SolidInstance_3: typeof Handle_IGESSolid_SolidInstance_3;
  Handle_IGESSolid_SolidInstance_4: typeof Handle_IGESSolid_SolidInstance_4;
  IGESSolid_ToolCylindricalSurface: typeof IGESSolid_ToolCylindricalSurface;
  Handle_IGESSolid_Cylinder: typeof Handle_IGESSolid_Cylinder;
  Handle_IGESSolid_Cylinder_1: typeof Handle_IGESSolid_Cylinder_1;
  Handle_IGESSolid_Cylinder_2: typeof Handle_IGESSolid_Cylinder_2;
  Handle_IGESSolid_Cylinder_3: typeof Handle_IGESSolid_Cylinder_3;
  Handle_IGESSolid_Cylinder_4: typeof Handle_IGESSolid_Cylinder_4;
  IGESSolid_Cylinder: typeof IGESSolid_Cylinder;
  Handle_IGESSolid_SolidOfRevolution: typeof Handle_IGESSolid_SolidOfRevolution;
  Handle_IGESSolid_SolidOfRevolution_1: typeof Handle_IGESSolid_SolidOfRevolution_1;
  Handle_IGESSolid_SolidOfRevolution_2: typeof Handle_IGESSolid_SolidOfRevolution_2;
  Handle_IGESSolid_SolidOfRevolution_3: typeof Handle_IGESSolid_SolidOfRevolution_3;
  Handle_IGESSolid_SolidOfRevolution_4: typeof Handle_IGESSolid_SolidOfRevolution_4;
  IGESSolid_SolidOfRevolution: typeof IGESSolid_SolidOfRevolution;
  IGESSolid_ToolToroidalSurface: typeof IGESSolid_ToolToroidalSurface;
  Handle_IGESSolid_GeneralModule: typeof Handle_IGESSolid_GeneralModule;
  Handle_IGESSolid_GeneralModule_1: typeof Handle_IGESSolid_GeneralModule_1;
  Handle_IGESSolid_GeneralModule_2: typeof Handle_IGESSolid_GeneralModule_2;
  Handle_IGESSolid_GeneralModule_3: typeof Handle_IGESSolid_GeneralModule_3;
  Handle_IGESSolid_GeneralModule_4: typeof Handle_IGESSolid_GeneralModule_4;
  IGESSolid_GeneralModule: typeof IGESSolid_GeneralModule;
  Handle_IGESSolid_HArray1OfFace: typeof Handle_IGESSolid_HArray1OfFace;
  Handle_IGESSolid_HArray1OfFace_1: typeof Handle_IGESSolid_HArray1OfFace_1;
  Handle_IGESSolid_HArray1OfFace_2: typeof Handle_IGESSolid_HArray1OfFace_2;
  Handle_IGESSolid_HArray1OfFace_3: typeof Handle_IGESSolid_HArray1OfFace_3;
  Handle_IGESSolid_HArray1OfFace_4: typeof Handle_IGESSolid_HArray1OfFace_4;
  IGESSolid_Protocol: typeof IGESSolid_Protocol;
  Handle_IGESSolid_Protocol: typeof Handle_IGESSolid_Protocol;
  Handle_IGESSolid_Protocol_1: typeof Handle_IGESSolid_Protocol_1;
  Handle_IGESSolid_Protocol_2: typeof Handle_IGESSolid_Protocol_2;
  Handle_IGESSolid_Protocol_3: typeof Handle_IGESSolid_Protocol_3;
  Handle_IGESSolid_Protocol_4: typeof Handle_IGESSolid_Protocol_4;
  Handle_IGESSolid_ManifoldSolid: typeof Handle_IGESSolid_ManifoldSolid;
  Handle_IGESSolid_ManifoldSolid_1: typeof Handle_IGESSolid_ManifoldSolid_1;
  Handle_IGESSolid_ManifoldSolid_2: typeof Handle_IGESSolid_ManifoldSolid_2;
  Handle_IGESSolid_ManifoldSolid_3: typeof Handle_IGESSolid_ManifoldSolid_3;
  Handle_IGESSolid_ManifoldSolid_4: typeof Handle_IGESSolid_ManifoldSolid_4;
  IGESSolid_ManifoldSolid: typeof IGESSolid_ManifoldSolid;
  IGESSolid_ToolBlock: typeof IGESSolid_ToolBlock;
  IGESSolid_ToolEllipsoid: typeof IGESSolid_ToolEllipsoid;
  Handle_IGESSolid_Face: typeof Handle_IGESSolid_Face;
  Handle_IGESSolid_Face_1: typeof Handle_IGESSolid_Face_1;
  Handle_IGESSolid_Face_2: typeof Handle_IGESSolid_Face_2;
  Handle_IGESSolid_Face_3: typeof Handle_IGESSolid_Face_3;
  Handle_IGESSolid_Face_4: typeof Handle_IGESSolid_Face_4;
  IGESSolid_Face: typeof IGESSolid_Face;
  Handle_IGESSolid_Ellipsoid: typeof Handle_IGESSolid_Ellipsoid;
  Handle_IGESSolid_Ellipsoid_1: typeof Handle_IGESSolid_Ellipsoid_1;
  Handle_IGESSolid_Ellipsoid_2: typeof Handle_IGESSolid_Ellipsoid_2;
  Handle_IGESSolid_Ellipsoid_3: typeof Handle_IGESSolid_Ellipsoid_3;
  Handle_IGESSolid_Ellipsoid_4: typeof Handle_IGESSolid_Ellipsoid_4;
  IGESSolid_Ellipsoid: typeof IGESSolid_Ellipsoid;
  Handle_IGESSolid_PlaneSurface: typeof Handle_IGESSolid_PlaneSurface;
  Handle_IGESSolid_PlaneSurface_1: typeof Handle_IGESSolid_PlaneSurface_1;
  Handle_IGESSolid_PlaneSurface_2: typeof Handle_IGESSolid_PlaneSurface_2;
  Handle_IGESSolid_PlaneSurface_3: typeof Handle_IGESSolid_PlaneSurface_3;
  Handle_IGESSolid_PlaneSurface_4: typeof Handle_IGESSolid_PlaneSurface_4;
  IGESSolid_PlaneSurface: typeof IGESSolid_PlaneSurface;
  IGESSolid_SelectedComponent: typeof IGESSolid_SelectedComponent;
  Handle_IGESSolid_SelectedComponent: typeof Handle_IGESSolid_SelectedComponent;
  Handle_IGESSolid_SelectedComponent_1: typeof Handle_IGESSolid_SelectedComponent_1;
  Handle_IGESSolid_SelectedComponent_2: typeof Handle_IGESSolid_SelectedComponent_2;
  Handle_IGESSolid_SelectedComponent_3: typeof Handle_IGESSolid_SelectedComponent_3;
  Handle_IGESSolid_SelectedComponent_4: typeof Handle_IGESSolid_SelectedComponent_4;
  IGESSolid: typeof IGESSolid;
  IGESSolid_ToolSelectedComponent: typeof IGESSolid_ToolSelectedComponent;
  IGESSolid_SolidAssembly: typeof IGESSolid_SolidAssembly;
  Handle_IGESSolid_SolidAssembly: typeof Handle_IGESSolid_SolidAssembly;
  Handle_IGESSolid_SolidAssembly_1: typeof Handle_IGESSolid_SolidAssembly_1;
  Handle_IGESSolid_SolidAssembly_2: typeof Handle_IGESSolid_SolidAssembly_2;
  Handle_IGESSolid_SolidAssembly_3: typeof Handle_IGESSolid_SolidAssembly_3;
  Handle_IGESSolid_SolidAssembly_4: typeof Handle_IGESSolid_SolidAssembly_4;
  IGESSolid_ToolSolidOfRevolution: typeof IGESSolid_ToolSolidOfRevolution;
  IGESSolid_ToolRightAngularWedge: typeof IGESSolid_ToolRightAngularWedge;
  IGESSolid_SpecificModule: typeof IGESSolid_SpecificModule;
  Handle_IGESSolid_SpecificModule: typeof Handle_IGESSolid_SpecificModule;
  Handle_IGESSolid_SpecificModule_1: typeof Handle_IGESSolid_SpecificModule_1;
  Handle_IGESSolid_SpecificModule_2: typeof Handle_IGESSolid_SpecificModule_2;
  Handle_IGESSolid_SpecificModule_3: typeof Handle_IGESSolid_SpecificModule_3;
  Handle_IGESSolid_SpecificModule_4: typeof Handle_IGESSolid_SpecificModule_4;
  IGESSolid_CylindricalSurface: typeof IGESSolid_CylindricalSurface;
  Handle_IGESSolid_CylindricalSurface: typeof Handle_IGESSolid_CylindricalSurface;
  Handle_IGESSolid_CylindricalSurface_1: typeof Handle_IGESSolid_CylindricalSurface_1;
  Handle_IGESSolid_CylindricalSurface_2: typeof Handle_IGESSolid_CylindricalSurface_2;
  Handle_IGESSolid_CylindricalSurface_3: typeof Handle_IGESSolid_CylindricalSurface_3;
  Handle_IGESSolid_CylindricalSurface_4: typeof Handle_IGESSolid_CylindricalSurface_4;
  IGESSolid_BooleanTree: typeof IGESSolid_BooleanTree;
  Handle_IGESSolid_BooleanTree: typeof Handle_IGESSolid_BooleanTree;
  Handle_IGESSolid_BooleanTree_1: typeof Handle_IGESSolid_BooleanTree_1;
  Handle_IGESSolid_BooleanTree_2: typeof Handle_IGESSolid_BooleanTree_2;
  Handle_IGESSolid_BooleanTree_3: typeof Handle_IGESSolid_BooleanTree_3;
  Handle_IGESSolid_BooleanTree_4: typeof Handle_IGESSolid_BooleanTree_4;
  IGESSolid_ToolManifoldSolid: typeof IGESSolid_ToolManifoldSolid;
  Handle_IGESSolid_ConicalSurface: typeof Handle_IGESSolid_ConicalSurface;
  Handle_IGESSolid_ConicalSurface_1: typeof Handle_IGESSolid_ConicalSurface_1;
  Handle_IGESSolid_ConicalSurface_2: typeof Handle_IGESSolid_ConicalSurface_2;
  Handle_IGESSolid_ConicalSurface_3: typeof Handle_IGESSolid_ConicalSurface_3;
  Handle_IGESSolid_ConicalSurface_4: typeof Handle_IGESSolid_ConicalSurface_4;
  IGESSolid_ConicalSurface: typeof IGESSolid_ConicalSurface;
  IGESSolid_ToolSolidAssembly: typeof IGESSolid_ToolSolidAssembly;
  IGESSolid_ToolBooleanTree: typeof IGESSolid_ToolBooleanTree;
  IGESSolid_ToolPlaneSurface: typeof IGESSolid_ToolPlaneSurface;
  Handle_IGESSolid_RightAngularWedge: typeof Handle_IGESSolid_RightAngularWedge;
  Handle_IGESSolid_RightAngularWedge_1: typeof Handle_IGESSolid_RightAngularWedge_1;
  Handle_IGESSolid_RightAngularWedge_2: typeof Handle_IGESSolid_RightAngularWedge_2;
  Handle_IGESSolid_RightAngularWedge_3: typeof Handle_IGESSolid_RightAngularWedge_3;
  Handle_IGESSolid_RightAngularWedge_4: typeof Handle_IGESSolid_RightAngularWedge_4;
  IGESSolid_RightAngularWedge: typeof IGESSolid_RightAngularWedge;
  Handle_IGESSolid_Sphere: typeof Handle_IGESSolid_Sphere;
  Handle_IGESSolid_Sphere_1: typeof Handle_IGESSolid_Sphere_1;
  Handle_IGESSolid_Sphere_2: typeof Handle_IGESSolid_Sphere_2;
  Handle_IGESSolid_Sphere_3: typeof Handle_IGESSolid_Sphere_3;
  Handle_IGESSolid_Sphere_4: typeof Handle_IGESSolid_Sphere_4;
  IGESSolid_Sphere: typeof IGESSolid_Sphere;
  IGESSolid_ReadWriteModule: typeof IGESSolid_ReadWriteModule;
  Handle_IGESSolid_ReadWriteModule: typeof Handle_IGESSolid_ReadWriteModule;
  Handle_IGESSolid_ReadWriteModule_1: typeof Handle_IGESSolid_ReadWriteModule_1;
  Handle_IGESSolid_ReadWriteModule_2: typeof Handle_IGESSolid_ReadWriteModule_2;
  Handle_IGESSolid_ReadWriteModule_3: typeof Handle_IGESSolid_ReadWriteModule_3;
  Handle_IGESSolid_ReadWriteModule_4: typeof Handle_IGESSolid_ReadWriteModule_4;
  IGESSolid_ConeFrustum: typeof IGESSolid_ConeFrustum;
  Handle_IGESSolid_ConeFrustum: typeof Handle_IGESSolid_ConeFrustum;
  Handle_IGESSolid_ConeFrustum_1: typeof Handle_IGESSolid_ConeFrustum_1;
  Handle_IGESSolid_ConeFrustum_2: typeof Handle_IGESSolid_ConeFrustum_2;
  Handle_IGESSolid_ConeFrustum_3: typeof Handle_IGESSolid_ConeFrustum_3;
  Handle_IGESSolid_ConeFrustum_4: typeof Handle_IGESSolid_ConeFrustum_4;
  IGESSolid_Torus: typeof IGESSolid_Torus;
  Handle_IGESSolid_Torus: typeof Handle_IGESSolid_Torus;
  Handle_IGESSolid_Torus_1: typeof Handle_IGESSolid_Torus_1;
  Handle_IGESSolid_Torus_2: typeof Handle_IGESSolid_Torus_2;
  Handle_IGESSolid_Torus_3: typeof Handle_IGESSolid_Torus_3;
  Handle_IGESSolid_Torus_4: typeof Handle_IGESSolid_Torus_4;
  IGESSolid_VertexList: typeof IGESSolid_VertexList;
  Handle_IGESSolid_VertexList: typeof Handle_IGESSolid_VertexList;
  Handle_IGESSolid_VertexList_1: typeof Handle_IGESSolid_VertexList_1;
  Handle_IGESSolid_VertexList_2: typeof Handle_IGESSolid_VertexList_2;
  Handle_IGESSolid_VertexList_3: typeof Handle_IGESSolid_VertexList_3;
  Handle_IGESSolid_VertexList_4: typeof Handle_IGESSolid_VertexList_4;
  IGESSolid_ToolCylinder: typeof IGESSolid_ToolCylinder;
  Handle_IGESSolid_HArray1OfLoop: typeof Handle_IGESSolid_HArray1OfLoop;
  Handle_IGESSolid_HArray1OfLoop_1: typeof Handle_IGESSolid_HArray1OfLoop_1;
  Handle_IGESSolid_HArray1OfLoop_2: typeof Handle_IGESSolid_HArray1OfLoop_2;
  Handle_IGESSolid_HArray1OfLoop_3: typeof Handle_IGESSolid_HArray1OfLoop_3;
  Handle_IGESSolid_HArray1OfLoop_4: typeof Handle_IGESSolid_HArray1OfLoop_4;
  IGESSolid_EdgeList: typeof IGESSolid_EdgeList;
  Handle_IGESSolid_EdgeList: typeof Handle_IGESSolid_EdgeList;
  Handle_IGESSolid_EdgeList_1: typeof Handle_IGESSolid_EdgeList_1;
  Handle_IGESSolid_EdgeList_2: typeof Handle_IGESSolid_EdgeList_2;
  Handle_IGESSolid_EdgeList_3: typeof Handle_IGESSolid_EdgeList_3;
  Handle_IGESSolid_EdgeList_4: typeof Handle_IGESSolid_EdgeList_4;
  IGESSolid_ToolConeFrustum: typeof IGESSolid_ToolConeFrustum;
  IGESSolid_SphericalSurface: typeof IGESSolid_SphericalSurface;
  Handle_IGESSolid_SphericalSurface: typeof Handle_IGESSolid_SphericalSurface;
  Handle_IGESSolid_SphericalSurface_1: typeof Handle_IGESSolid_SphericalSurface_1;
  Handle_IGESSolid_SphericalSurface_2: typeof Handle_IGESSolid_SphericalSurface_2;
  Handle_IGESSolid_SphericalSurface_3: typeof Handle_IGESSolid_SphericalSurface_3;
  Handle_IGESSolid_SphericalSurface_4: typeof Handle_IGESSolid_SphericalSurface_4;
  IGESSolid_TopoBuilder: typeof IGESSolid_TopoBuilder;
  Handle_IGESSolid_HArray1OfShell: typeof Handle_IGESSolid_HArray1OfShell;
  Handle_IGESSolid_HArray1OfShell_1: typeof Handle_IGESSolid_HArray1OfShell_1;
  Handle_IGESSolid_HArray1OfShell_2: typeof Handle_IGESSolid_HArray1OfShell_2;
  Handle_IGESSolid_HArray1OfShell_3: typeof Handle_IGESSolid_HArray1OfShell_3;
  Handle_IGESSolid_HArray1OfShell_4: typeof Handle_IGESSolid_HArray1OfShell_4;
  Handle_IGESSolid_HArray1OfVertexList: typeof Handle_IGESSolid_HArray1OfVertexList;
  Handle_IGESSolid_HArray1OfVertexList_1: typeof Handle_IGESSolid_HArray1OfVertexList_1;
  Handle_IGESSolid_HArray1OfVertexList_2: typeof Handle_IGESSolid_HArray1OfVertexList_2;
  Handle_IGESSolid_HArray1OfVertexList_3: typeof Handle_IGESSolid_HArray1OfVertexList_3;
  Handle_IGESSolid_HArray1OfVertexList_4: typeof Handle_IGESSolid_HArray1OfVertexList_4;
  IGESSolid_ToolSphere: typeof IGESSolid_ToolSphere;
  IGESSolid_ToolTorus: typeof IGESSolid_ToolTorus;
  Handle_IGESSolid_SolidOfLinearExtrusion: typeof Handle_IGESSolid_SolidOfLinearExtrusion;
  Handle_IGESSolid_SolidOfLinearExtrusion_1: typeof Handle_IGESSolid_SolidOfLinearExtrusion_1;
  Handle_IGESSolid_SolidOfLinearExtrusion_2: typeof Handle_IGESSolid_SolidOfLinearExtrusion_2;
  Handle_IGESSolid_SolidOfLinearExtrusion_3: typeof Handle_IGESSolid_SolidOfLinearExtrusion_3;
  Handle_IGESSolid_SolidOfLinearExtrusion_4: typeof Handle_IGESSolid_SolidOfLinearExtrusion_4;
  IGESSolid_SolidOfLinearExtrusion: typeof IGESSolid_SolidOfLinearExtrusion;
  IGESSolid_ToolSolidInstance: typeof IGESSolid_ToolSolidInstance;
  BRepPreviewAPI_MakeBox: typeof BRepPreviewAPI_MakeBox;
  LocOpe_CurveShapeIntersector: typeof LocOpe_CurveShapeIntersector;
  LocOpe_CurveShapeIntersector_1: typeof LocOpe_CurveShapeIntersector_1;
  LocOpe_CurveShapeIntersector_2: typeof LocOpe_CurveShapeIntersector_2;
  LocOpe_CurveShapeIntersector_3: typeof LocOpe_CurveShapeIntersector_3;
  LocOpe_Generator: typeof LocOpe_Generator;
  LocOpe_Generator_1: typeof LocOpe_Generator_1;
  LocOpe_Generator_2: typeof LocOpe_Generator_2;
  LocOpe_SequenceOfLin: typeof LocOpe_SequenceOfLin;
  LocOpe_SequenceOfLin_1: typeof LocOpe_SequenceOfLin_1;
  LocOpe_SequenceOfLin_2: typeof LocOpe_SequenceOfLin_2;
  LocOpe_SequenceOfLin_3: typeof LocOpe_SequenceOfLin_3;
  Handle_LocOpe_GeneratedShape: typeof Handle_LocOpe_GeneratedShape;
  Handle_LocOpe_GeneratedShape_1: typeof Handle_LocOpe_GeneratedShape_1;
  Handle_LocOpe_GeneratedShape_2: typeof Handle_LocOpe_GeneratedShape_2;
  Handle_LocOpe_GeneratedShape_3: typeof Handle_LocOpe_GeneratedShape_3;
  Handle_LocOpe_GeneratedShape_4: typeof Handle_LocOpe_GeneratedShape_4;
  LocOpe_GeneratedShape: typeof LocOpe_GeneratedShape;
  LocOpe_Gluer: typeof LocOpe_Gluer;
  LocOpe_Gluer_1: typeof LocOpe_Gluer_1;
  LocOpe_Gluer_2: typeof LocOpe_Gluer_2;
  LocOpe_Prism: typeof LocOpe_Prism;
  LocOpe_Prism_1: typeof LocOpe_Prism_1;
  LocOpe_Prism_2: typeof LocOpe_Prism_2;
  LocOpe_Prism_3: typeof LocOpe_Prism_3;
  LocOpe_BuildWires: typeof LocOpe_BuildWires;
  LocOpe_BuildWires_1: typeof LocOpe_BuildWires_1;
  LocOpe_BuildWires_2: typeof LocOpe_BuildWires_2;
  LocOpe: typeof LocOpe;
  LocOpe_PntFace: typeof LocOpe_PntFace;
  LocOpe_PntFace_1: typeof LocOpe_PntFace_1;
  LocOpe_PntFace_2: typeof LocOpe_PntFace_2;
  LocOpe_SequenceOfPntFace: typeof LocOpe_SequenceOfPntFace;
  LocOpe_SequenceOfPntFace_1: typeof LocOpe_SequenceOfPntFace_1;
  LocOpe_SequenceOfPntFace_2: typeof LocOpe_SequenceOfPntFace_2;
  LocOpe_SequenceOfPntFace_3: typeof LocOpe_SequenceOfPntFace_3;
  LocOpe_GluedShape: typeof LocOpe_GluedShape;
  LocOpe_GluedShape_1: typeof LocOpe_GluedShape_1;
  LocOpe_GluedShape_2: typeof LocOpe_GluedShape_2;
  Handle_LocOpe_GluedShape: typeof Handle_LocOpe_GluedShape;
  Handle_LocOpe_GluedShape_1: typeof Handle_LocOpe_GluedShape_1;
  Handle_LocOpe_GluedShape_2: typeof Handle_LocOpe_GluedShape_2;
  Handle_LocOpe_GluedShape_3: typeof Handle_LocOpe_GluedShape_3;
  Handle_LocOpe_GluedShape_4: typeof Handle_LocOpe_GluedShape_4;
  LocOpe_SplitShape: typeof LocOpe_SplitShape;
  LocOpe_SplitShape_1: typeof LocOpe_SplitShape_1;
  LocOpe_SplitShape_2: typeof LocOpe_SplitShape_2;
  LocOpe_Pipe: typeof LocOpe_Pipe;
  LocOpe_Spliter: typeof LocOpe_Spliter;
  LocOpe_Spliter_1: typeof LocOpe_Spliter_1;
  LocOpe_Spliter_2: typeof LocOpe_Spliter_2;
  LocOpe_LinearForm: typeof LocOpe_LinearForm;
  LocOpe_LinearForm_1: typeof LocOpe_LinearForm_1;
  LocOpe_LinearForm_2: typeof LocOpe_LinearForm_2;
  LocOpe_LinearForm_3: typeof LocOpe_LinearForm_3;
  LocOpe_SplitDrafts: typeof LocOpe_SplitDrafts;
  LocOpe_SplitDrafts_1: typeof LocOpe_SplitDrafts_1;
  LocOpe_SplitDrafts_2: typeof LocOpe_SplitDrafts_2;
  Handle_LocOpe_WiresOnShape: typeof Handle_LocOpe_WiresOnShape;
  Handle_LocOpe_WiresOnShape_1: typeof Handle_LocOpe_WiresOnShape_1;
  Handle_LocOpe_WiresOnShape_2: typeof Handle_LocOpe_WiresOnShape_2;
  Handle_LocOpe_WiresOnShape_3: typeof Handle_LocOpe_WiresOnShape_3;
  Handle_LocOpe_WiresOnShape_4: typeof Handle_LocOpe_WiresOnShape_4;
  LocOpe_WiresOnShape: typeof LocOpe_WiresOnShape;
  LocOpe_DPrism: typeof LocOpe_DPrism;
  LocOpe_DPrism_1: typeof LocOpe_DPrism_1;
  LocOpe_DPrism_2: typeof LocOpe_DPrism_2;
  LocOpe_FindEdges: typeof LocOpe_FindEdges;
  LocOpe_FindEdges_1: typeof LocOpe_FindEdges_1;
  LocOpe_FindEdges_2: typeof LocOpe_FindEdges_2;
  LocOpe_FindEdgesInFace: typeof LocOpe_FindEdgesInFace;
  LocOpe_FindEdgesInFace_1: typeof LocOpe_FindEdgesInFace_1;
  LocOpe_FindEdgesInFace_2: typeof LocOpe_FindEdgesInFace_2;
  LocOpe_CSIntersector: typeof LocOpe_CSIntersector;
  LocOpe_CSIntersector_1: typeof LocOpe_CSIntersector_1;
  LocOpe_CSIntersector_2: typeof LocOpe_CSIntersector_2;
  LocOpe_SequenceOfCirc: typeof LocOpe_SequenceOfCirc;
  LocOpe_SequenceOfCirc_1: typeof LocOpe_SequenceOfCirc_1;
  LocOpe_SequenceOfCirc_2: typeof LocOpe_SequenceOfCirc_2;
  LocOpe_SequenceOfCirc_3: typeof LocOpe_SequenceOfCirc_3;
  LocOpe_Operation: LocOpe_Operation;
  LocOpe_BuildShape: typeof LocOpe_BuildShape;
  LocOpe_BuildShape_1: typeof LocOpe_BuildShape_1;
  LocOpe_BuildShape_2: typeof LocOpe_BuildShape_2;
  LocOpe_DataMapOfShapePnt: typeof LocOpe_DataMapOfShapePnt;
  LocOpe_DataMapOfShapePnt_1: typeof LocOpe_DataMapOfShapePnt_1;
  LocOpe_DataMapOfShapePnt_2: typeof LocOpe_DataMapOfShapePnt_2;
  LocOpe_DataMapOfShapePnt_3: typeof LocOpe_DataMapOfShapePnt_3;
  MAT2d_DataMapOfBiIntInteger: typeof MAT2d_DataMapOfBiIntInteger;
  MAT2d_DataMapOfBiIntInteger_1: typeof MAT2d_DataMapOfBiIntInteger_1;
  MAT2d_DataMapOfBiIntInteger_2: typeof MAT2d_DataMapOfBiIntInteger_2;
  MAT2d_DataMapOfBiIntInteger_3: typeof MAT2d_DataMapOfBiIntInteger_3;
  Handle_MAT2d_Connexion: typeof Handle_MAT2d_Connexion;
  Handle_MAT2d_Connexion_1: typeof Handle_MAT2d_Connexion_1;
  Handle_MAT2d_Connexion_2: typeof Handle_MAT2d_Connexion_2;
  Handle_MAT2d_Connexion_3: typeof Handle_MAT2d_Connexion_3;
  Handle_MAT2d_Connexion_4: typeof Handle_MAT2d_Connexion_4;
  MAT2d_Connexion: typeof MAT2d_Connexion;
  MAT2d_Connexion_1: typeof MAT2d_Connexion_1;
  MAT2d_Connexion_2: typeof MAT2d_Connexion_2;
  MAT2d_MapBiIntHasher: typeof MAT2d_MapBiIntHasher;
  MAT2d_MiniPath: typeof MAT2d_MiniPath;
  MAT2d_DataMapOfIntegerPnt2d: typeof MAT2d_DataMapOfIntegerPnt2d;
  MAT2d_DataMapOfIntegerPnt2d_1: typeof MAT2d_DataMapOfIntegerPnt2d_1;
  MAT2d_DataMapOfIntegerPnt2d_2: typeof MAT2d_DataMapOfIntegerPnt2d_2;
  MAT2d_DataMapOfIntegerPnt2d_3: typeof MAT2d_DataMapOfIntegerPnt2d_3;
  MAT2d_DataMapOfIntegerBisec: typeof MAT2d_DataMapOfIntegerBisec;
  MAT2d_DataMapOfIntegerBisec_1: typeof MAT2d_DataMapOfIntegerBisec_1;
  MAT2d_DataMapOfIntegerBisec_2: typeof MAT2d_DataMapOfIntegerBisec_2;
  MAT2d_DataMapOfIntegerBisec_3: typeof MAT2d_DataMapOfIntegerBisec_3;
  MAT2d_SequenceOfSequenceOfGeometry: typeof MAT2d_SequenceOfSequenceOfGeometry;
  MAT2d_SequenceOfSequenceOfGeometry_1: typeof MAT2d_SequenceOfSequenceOfGeometry_1;
  MAT2d_SequenceOfSequenceOfGeometry_2: typeof MAT2d_SequenceOfSequenceOfGeometry_2;
  MAT2d_SequenceOfSequenceOfGeometry_3: typeof MAT2d_SequenceOfSequenceOfGeometry_3;
  MAT2d_DataMapOfIntegerSequenceOfConnexion: typeof MAT2d_DataMapOfIntegerSequenceOfConnexion;
  MAT2d_DataMapOfIntegerSequenceOfConnexion_1: typeof MAT2d_DataMapOfIntegerSequenceOfConnexion_1;
  MAT2d_DataMapOfIntegerSequenceOfConnexion_2: typeof MAT2d_DataMapOfIntegerSequenceOfConnexion_2;
  MAT2d_DataMapOfIntegerSequenceOfConnexion_3: typeof MAT2d_DataMapOfIntegerSequenceOfConnexion_3;
  MAT2d_Tool2d: typeof MAT2d_Tool2d;
  MAT2d_BiInt: typeof MAT2d_BiInt;
  MAT2d_DataMapOfIntegerVec2d: typeof MAT2d_DataMapOfIntegerVec2d;
  MAT2d_DataMapOfIntegerVec2d_1: typeof MAT2d_DataMapOfIntegerVec2d_1;
  MAT2d_DataMapOfIntegerVec2d_2: typeof MAT2d_DataMapOfIntegerVec2d_2;
  MAT2d_DataMapOfIntegerVec2d_3: typeof MAT2d_DataMapOfIntegerVec2d_3;
  MAT2d_SequenceOfSequenceOfCurve: typeof MAT2d_SequenceOfSequenceOfCurve;
  MAT2d_SequenceOfSequenceOfCurve_1: typeof MAT2d_SequenceOfSequenceOfCurve_1;
  MAT2d_SequenceOfSequenceOfCurve_2: typeof MAT2d_SequenceOfSequenceOfCurve_2;
  MAT2d_SequenceOfSequenceOfCurve_3: typeof MAT2d_SequenceOfSequenceOfCurve_3;
  MAT2d_DataMapOfBiIntSequenceOfInteger: typeof MAT2d_DataMapOfBiIntSequenceOfInteger;
  MAT2d_DataMapOfBiIntSequenceOfInteger_1: typeof MAT2d_DataMapOfBiIntSequenceOfInteger_1;
  MAT2d_DataMapOfBiIntSequenceOfInteger_2: typeof MAT2d_DataMapOfBiIntSequenceOfInteger_2;
  MAT2d_DataMapOfBiIntSequenceOfInteger_3: typeof MAT2d_DataMapOfBiIntSequenceOfInteger_3;
  MAT2d_Mat2d: typeof MAT2d_Mat2d;
  MAT2d_Circuit: typeof MAT2d_Circuit;
  Handle_MAT2d_Circuit: typeof Handle_MAT2d_Circuit;
  Handle_MAT2d_Circuit_1: typeof Handle_MAT2d_Circuit_1;
  Handle_MAT2d_Circuit_2: typeof Handle_MAT2d_Circuit_2;
  Handle_MAT2d_Circuit_3: typeof Handle_MAT2d_Circuit_3;
  Handle_MAT2d_Circuit_4: typeof Handle_MAT2d_Circuit_4;
  Handle_BRep_PointRepresentation: typeof Handle_BRep_PointRepresentation;
  Handle_BRep_PointRepresentation_1: typeof Handle_BRep_PointRepresentation_1;
  Handle_BRep_PointRepresentation_2: typeof Handle_BRep_PointRepresentation_2;
  Handle_BRep_PointRepresentation_3: typeof Handle_BRep_PointRepresentation_3;
  Handle_BRep_PointRepresentation_4: typeof Handle_BRep_PointRepresentation_4;
  BRep_PointRepresentation: typeof BRep_PointRepresentation;
  Handle_BRep_PolygonOnClosedTriangulation: typeof Handle_BRep_PolygonOnClosedTriangulation;
  Handle_BRep_PolygonOnClosedTriangulation_1: typeof Handle_BRep_PolygonOnClosedTriangulation_1;
  Handle_BRep_PolygonOnClosedTriangulation_2: typeof Handle_BRep_PolygonOnClosedTriangulation_2;
  Handle_BRep_PolygonOnClosedTriangulation_3: typeof Handle_BRep_PolygonOnClosedTriangulation_3;
  Handle_BRep_PolygonOnClosedTriangulation_4: typeof Handle_BRep_PolygonOnClosedTriangulation_4;
  BRep_PolygonOnClosedTriangulation: typeof BRep_PolygonOnClosedTriangulation;
  Handle_BRep_PolygonOnTriangulation: typeof Handle_BRep_PolygonOnTriangulation;
  Handle_BRep_PolygonOnTriangulation_1: typeof Handle_BRep_PolygonOnTriangulation_1;
  Handle_BRep_PolygonOnTriangulation_2: typeof Handle_BRep_PolygonOnTriangulation_2;
  Handle_BRep_PolygonOnTriangulation_3: typeof Handle_BRep_PolygonOnTriangulation_3;
  Handle_BRep_PolygonOnTriangulation_4: typeof Handle_BRep_PolygonOnTriangulation_4;
  BRep_PolygonOnTriangulation: typeof BRep_PolygonOnTriangulation;
  Handle_BRep_CurveOnClosedSurface: typeof Handle_BRep_CurveOnClosedSurface;
  Handle_BRep_CurveOnClosedSurface_1: typeof Handle_BRep_CurveOnClosedSurface_1;
  Handle_BRep_CurveOnClosedSurface_2: typeof Handle_BRep_CurveOnClosedSurface_2;
  Handle_BRep_CurveOnClosedSurface_3: typeof Handle_BRep_CurveOnClosedSurface_3;
  Handle_BRep_CurveOnClosedSurface_4: typeof Handle_BRep_CurveOnClosedSurface_4;
  BRep_CurveOnClosedSurface: typeof BRep_CurveOnClosedSurface;
  BRep_Tool: typeof BRep_Tool;
  BRep_TEdge: typeof BRep_TEdge;
  Handle_BRep_TEdge: typeof Handle_BRep_TEdge;
  Handle_BRep_TEdge_1: typeof Handle_BRep_TEdge_1;
  Handle_BRep_TEdge_2: typeof Handle_BRep_TEdge_2;
  Handle_BRep_TEdge_3: typeof Handle_BRep_TEdge_3;
  Handle_BRep_TEdge_4: typeof Handle_BRep_TEdge_4;
  BRep_PolygonOnClosedSurface: typeof BRep_PolygonOnClosedSurface;
  Handle_BRep_PolygonOnClosedSurface: typeof Handle_BRep_PolygonOnClosedSurface;
  Handle_BRep_PolygonOnClosedSurface_1: typeof Handle_BRep_PolygonOnClosedSurface_1;
  Handle_BRep_PolygonOnClosedSurface_2: typeof Handle_BRep_PolygonOnClosedSurface_2;
  Handle_BRep_PolygonOnClosedSurface_3: typeof Handle_BRep_PolygonOnClosedSurface_3;
  Handle_BRep_PolygonOnClosedSurface_4: typeof Handle_BRep_PolygonOnClosedSurface_4;
  BRep_PointOnSurface: typeof BRep_PointOnSurface;
  Handle_BRep_PointOnSurface: typeof Handle_BRep_PointOnSurface;
  Handle_BRep_PointOnSurface_1: typeof Handle_BRep_PointOnSurface_1;
  Handle_BRep_PointOnSurface_2: typeof Handle_BRep_PointOnSurface_2;
  Handle_BRep_PointOnSurface_3: typeof Handle_BRep_PointOnSurface_3;
  Handle_BRep_PointOnSurface_4: typeof Handle_BRep_PointOnSurface_4;
  BRep_GCurve: typeof BRep_GCurve;
  Handle_BRep_GCurve: typeof Handle_BRep_GCurve;
  Handle_BRep_GCurve_1: typeof Handle_BRep_GCurve_1;
  Handle_BRep_GCurve_2: typeof Handle_BRep_GCurve_2;
  Handle_BRep_GCurve_3: typeof Handle_BRep_GCurve_3;
  Handle_BRep_GCurve_4: typeof Handle_BRep_GCurve_4;
  Handle_BRep_CurveRepresentation: typeof Handle_BRep_CurveRepresentation;
  Handle_BRep_CurveRepresentation_1: typeof Handle_BRep_CurveRepresentation_1;
  Handle_BRep_CurveRepresentation_2: typeof Handle_BRep_CurveRepresentation_2;
  Handle_BRep_CurveRepresentation_3: typeof Handle_BRep_CurveRepresentation_3;
  Handle_BRep_CurveRepresentation_4: typeof Handle_BRep_CurveRepresentation_4;
  BRep_CurveRepresentation: typeof BRep_CurveRepresentation;
  BRep_PointOnCurveOnSurface: typeof BRep_PointOnCurveOnSurface;
  Handle_BRep_PointOnCurveOnSurface: typeof Handle_BRep_PointOnCurveOnSurface;
  Handle_BRep_PointOnCurveOnSurface_1: typeof Handle_BRep_PointOnCurveOnSurface_1;
  Handle_BRep_PointOnCurveOnSurface_2: typeof Handle_BRep_PointOnCurveOnSurface_2;
  Handle_BRep_PointOnCurveOnSurface_3: typeof Handle_BRep_PointOnCurveOnSurface_3;
  Handle_BRep_PointOnCurveOnSurface_4: typeof Handle_BRep_PointOnCurveOnSurface_4;
  BRep_Curve3D: typeof BRep_Curve3D;
  Handle_BRep_Curve3D: typeof Handle_BRep_Curve3D;
  Handle_BRep_Curve3D_1: typeof Handle_BRep_Curve3D_1;
  Handle_BRep_Curve3D_2: typeof Handle_BRep_Curve3D_2;
  Handle_BRep_Curve3D_3: typeof Handle_BRep_Curve3D_3;
  Handle_BRep_Curve3D_4: typeof Handle_BRep_Curve3D_4;
  Handle_BRep_PolygonOnSurface: typeof Handle_BRep_PolygonOnSurface;
  Handle_BRep_PolygonOnSurface_1: typeof Handle_BRep_PolygonOnSurface_1;
  Handle_BRep_PolygonOnSurface_2: typeof Handle_BRep_PolygonOnSurface_2;
  Handle_BRep_PolygonOnSurface_3: typeof Handle_BRep_PolygonOnSurface_3;
  Handle_BRep_PolygonOnSurface_4: typeof Handle_BRep_PolygonOnSurface_4;
  BRep_PolygonOnSurface: typeof BRep_PolygonOnSurface;
  BRep_Polygon3D: typeof BRep_Polygon3D;
  Handle_BRep_Polygon3D: typeof Handle_BRep_Polygon3D;
  Handle_BRep_Polygon3D_1: typeof Handle_BRep_Polygon3D_1;
  Handle_BRep_Polygon3D_2: typeof Handle_BRep_Polygon3D_2;
  Handle_BRep_Polygon3D_3: typeof Handle_BRep_Polygon3D_3;
  Handle_BRep_Polygon3D_4: typeof Handle_BRep_Polygon3D_4;
  BRep_Builder: typeof BRep_Builder;
  BRep_CurveOn2Surfaces: typeof BRep_CurveOn2Surfaces;
  Handle_BRep_CurveOn2Surfaces: typeof Handle_BRep_CurveOn2Surfaces;
  Handle_BRep_CurveOn2Surfaces_1: typeof Handle_BRep_CurveOn2Surfaces_1;
  Handle_BRep_CurveOn2Surfaces_2: typeof Handle_BRep_CurveOn2Surfaces_2;
  Handle_BRep_CurveOn2Surfaces_3: typeof Handle_BRep_CurveOn2Surfaces_3;
  Handle_BRep_CurveOn2Surfaces_4: typeof Handle_BRep_CurveOn2Surfaces_4;
  Handle_BRep_PointOnCurve: typeof Handle_BRep_PointOnCurve;
  Handle_BRep_PointOnCurve_1: typeof Handle_BRep_PointOnCurve_1;
  Handle_BRep_PointOnCurve_2: typeof Handle_BRep_PointOnCurve_2;
  Handle_BRep_PointOnCurve_3: typeof Handle_BRep_PointOnCurve_3;
  Handle_BRep_PointOnCurve_4: typeof Handle_BRep_PointOnCurve_4;
  BRep_PointOnCurve: typeof BRep_PointOnCurve;
  Handle_BRep_TFace: typeof Handle_BRep_TFace;
  Handle_BRep_TFace_1: typeof Handle_BRep_TFace_1;
  Handle_BRep_TFace_2: typeof Handle_BRep_TFace_2;
  Handle_BRep_TFace_3: typeof Handle_BRep_TFace_3;
  Handle_BRep_TFace_4: typeof Handle_BRep_TFace_4;
  BRep_TFace: typeof BRep_TFace;
  BRep_PointsOnSurface: typeof BRep_PointsOnSurface;
  Handle_BRep_PointsOnSurface: typeof Handle_BRep_PointsOnSurface;
  Handle_BRep_PointsOnSurface_1: typeof Handle_BRep_PointsOnSurface_1;
  Handle_BRep_PointsOnSurface_2: typeof Handle_BRep_PointsOnSurface_2;
  Handle_BRep_PointsOnSurface_3: typeof Handle_BRep_PointsOnSurface_3;
  Handle_BRep_PointsOnSurface_4: typeof Handle_BRep_PointsOnSurface_4;
  BRep_CurveOnSurface: typeof BRep_CurveOnSurface;
  Handle_BRep_CurveOnSurface: typeof Handle_BRep_CurveOnSurface;
  Handle_BRep_CurveOnSurface_1: typeof Handle_BRep_CurveOnSurface_1;
  Handle_BRep_CurveOnSurface_2: typeof Handle_BRep_CurveOnSurface_2;
  Handle_BRep_CurveOnSurface_3: typeof Handle_BRep_CurveOnSurface_3;
  Handle_BRep_CurveOnSurface_4: typeof Handle_BRep_CurveOnSurface_4;
  Handle_BRep_TVertex: typeof Handle_BRep_TVertex;
  Handle_BRep_TVertex_1: typeof Handle_BRep_TVertex_1;
  Handle_BRep_TVertex_2: typeof Handle_BRep_TVertex_2;
  Handle_BRep_TVertex_3: typeof Handle_BRep_TVertex_3;
  Handle_BRep_TVertex_4: typeof Handle_BRep_TVertex_4;
  BRep_TVertex: typeof BRep_TVertex;
  IGESToBRep_BRepEntity: typeof IGESToBRep_BRepEntity;
  IGESToBRep_BRepEntity_1: typeof IGESToBRep_BRepEntity_1;
  IGESToBRep_BRepEntity_2: typeof IGESToBRep_BRepEntity_2;
  IGESToBRep_BRepEntity_3: typeof IGESToBRep_BRepEntity_3;
  IGESToBRep_TopoCurve: typeof IGESToBRep_TopoCurve;
  IGESToBRep_TopoCurve_1: typeof IGESToBRep_TopoCurve_1;
  IGESToBRep_TopoCurve_2: typeof IGESToBRep_TopoCurve_2;
  IGESToBRep_TopoCurve_3: typeof IGESToBRep_TopoCurve_3;
  IGESToBRep_TopoCurve_4: typeof IGESToBRep_TopoCurve_4;
  IGESToBRep_BasicSurface: typeof IGESToBRep_BasicSurface;
  IGESToBRep_BasicSurface_1: typeof IGESToBRep_BasicSurface_1;
  IGESToBRep_BasicSurface_2: typeof IGESToBRep_BasicSurface_2;
  IGESToBRep_BasicSurface_3: typeof IGESToBRep_BasicSurface_3;
  Handle_IGESToBRep_AlgoContainer: typeof Handle_IGESToBRep_AlgoContainer;
  Handle_IGESToBRep_AlgoContainer_1: typeof Handle_IGESToBRep_AlgoContainer_1;
  Handle_IGESToBRep_AlgoContainer_2: typeof Handle_IGESToBRep_AlgoContainer_2;
  Handle_IGESToBRep_AlgoContainer_3: typeof Handle_IGESToBRep_AlgoContainer_3;
  Handle_IGESToBRep_AlgoContainer_4: typeof Handle_IGESToBRep_AlgoContainer_4;
  IGESToBRep_AlgoContainer: typeof IGESToBRep_AlgoContainer;
  IGESToBRep_Reader: typeof IGESToBRep_Reader;
  Handle_IGESToBRep_ToolContainer: typeof Handle_IGESToBRep_ToolContainer;
  Handle_IGESToBRep_ToolContainer_1: typeof Handle_IGESToBRep_ToolContainer_1;
  Handle_IGESToBRep_ToolContainer_2: typeof Handle_IGESToBRep_ToolContainer_2;
  Handle_IGESToBRep_ToolContainer_3: typeof Handle_IGESToBRep_ToolContainer_3;
  Handle_IGESToBRep_ToolContainer_4: typeof Handle_IGESToBRep_ToolContainer_4;
  IGESToBRep_ToolContainer: typeof IGESToBRep_ToolContainer;
  IGESToBRep_CurveAndSurface: typeof IGESToBRep_CurveAndSurface;
  IGESToBRep_CurveAndSurface_1: typeof IGESToBRep_CurveAndSurface_1;
  IGESToBRep_CurveAndSurface_2: typeof IGESToBRep_CurveAndSurface_2;
  IGESToBRep_IGESBoundary: typeof IGESToBRep_IGESBoundary;
  IGESToBRep_IGESBoundary_1: typeof IGESToBRep_IGESBoundary_1;
  IGESToBRep_IGESBoundary_2: typeof IGESToBRep_IGESBoundary_2;
  Handle_IGESToBRep_IGESBoundary: typeof Handle_IGESToBRep_IGESBoundary;
  Handle_IGESToBRep_IGESBoundary_1: typeof Handle_IGESToBRep_IGESBoundary_1;
  Handle_IGESToBRep_IGESBoundary_2: typeof Handle_IGESToBRep_IGESBoundary_2;
  Handle_IGESToBRep_IGESBoundary_3: typeof Handle_IGESToBRep_IGESBoundary_3;
  Handle_IGESToBRep_IGESBoundary_4: typeof Handle_IGESToBRep_IGESBoundary_4;
  IGESToBRep_BasicCurve: typeof IGESToBRep_BasicCurve;
  IGESToBRep_BasicCurve_1: typeof IGESToBRep_BasicCurve_1;
  IGESToBRep_BasicCurve_2: typeof IGESToBRep_BasicCurve_2;
  IGESToBRep_BasicCurve_3: typeof IGESToBRep_BasicCurve_3;
  IGESToBRep: typeof IGESToBRep;
  Handle_IGESToBRep_Actor: typeof Handle_IGESToBRep_Actor;
  Handle_IGESToBRep_Actor_1: typeof Handle_IGESToBRep_Actor_1;
  Handle_IGESToBRep_Actor_2: typeof Handle_IGESToBRep_Actor_2;
  Handle_IGESToBRep_Actor_3: typeof Handle_IGESToBRep_Actor_3;
  Handle_IGESToBRep_Actor_4: typeof Handle_IGESToBRep_Actor_4;
  IGESToBRep_Actor: typeof IGESToBRep_Actor;
  XCAFDimTolObjects_DimensionType: XCAFDimTolObjects_DimensionType;
  XCAFDimTolObjects_GeomToleranceModifiersSequence: typeof XCAFDimTolObjects_GeomToleranceModifiersSequence;
  XCAFDimTolObjects_GeomToleranceModifiersSequence_1: typeof XCAFDimTolObjects_GeomToleranceModifiersSequence_1;
  XCAFDimTolObjects_GeomToleranceModifiersSequence_2: typeof XCAFDimTolObjects_GeomToleranceModifiersSequence_2;
  XCAFDimTolObjects_GeomToleranceModifiersSequence_3: typeof XCAFDimTolObjects_GeomToleranceModifiersSequence_3;
  XCAFDimTolObjects_DimensionModifiersSequence: typeof XCAFDimTolObjects_DimensionModifiersSequence;
  XCAFDimTolObjects_DimensionModifiersSequence_1: typeof XCAFDimTolObjects_DimensionModifiersSequence_1;
  XCAFDimTolObjects_DimensionModifiersSequence_2: typeof XCAFDimTolObjects_DimensionModifiersSequence_2;
  XCAFDimTolObjects_DimensionModifiersSequence_3: typeof XCAFDimTolObjects_DimensionModifiersSequence_3;
  XCAFDimTolObjects_DimensionGrade: XCAFDimTolObjects_DimensionGrade;
  XCAFDimTolObjects_GeomToleranceZoneModif: XCAFDimTolObjects_GeomToleranceZoneModif;
  XCAFDimTolObjects_GeomToleranceModif: XCAFDimTolObjects_GeomToleranceModif;
  XCAFDimTolObjects_GeomToleranceTypeValue: XCAFDimTolObjects_GeomToleranceTypeValue;
  XCAFDimTolObjects_DimensionFormVariance: XCAFDimTolObjects_DimensionFormVariance;
  XCAFDimTolObjects_DimensionObject: typeof XCAFDimTolObjects_DimensionObject;
  XCAFDimTolObjects_DimensionObject_1: typeof XCAFDimTolObjects_DimensionObject_1;
  XCAFDimTolObjects_DimensionObject_2: typeof XCAFDimTolObjects_DimensionObject_2;
  Handle_XCAFDimTolObjects_DimensionObject: typeof Handle_XCAFDimTolObjects_DimensionObject;
  Handle_XCAFDimTolObjects_DimensionObject_1: typeof Handle_XCAFDimTolObjects_DimensionObject_1;
  Handle_XCAFDimTolObjects_DimensionObject_2: typeof Handle_XCAFDimTolObjects_DimensionObject_2;
  Handle_XCAFDimTolObjects_DimensionObject_3: typeof Handle_XCAFDimTolObjects_DimensionObject_3;
  Handle_XCAFDimTolObjects_DimensionObject_4: typeof Handle_XCAFDimTolObjects_DimensionObject_4;
  XCAFDimTolObjects_DatumModifWithValue: XCAFDimTolObjects_DatumModifWithValue;
  XCAFDimTolObjects_DatumSingleModif: XCAFDimTolObjects_DatumSingleModif;
  XCAFDimTolObjects_ToleranceZoneAffectedPlane: XCAFDimTolObjects_ToleranceZoneAffectedPlane;
  XCAFDimTolObjects_Tool: typeof XCAFDimTolObjects_Tool;
  XCAFDimTolObjects_GeomToleranceType: XCAFDimTolObjects_GeomToleranceType;
  XCAFDimTolObjects_DatumTargetType: XCAFDimTolObjects_DatumTargetType;
  XCAFDimTolObjects_GeomToleranceObject: typeof XCAFDimTolObjects_GeomToleranceObject;
  XCAFDimTolObjects_GeomToleranceObject_1: typeof XCAFDimTolObjects_GeomToleranceObject_1;
  XCAFDimTolObjects_GeomToleranceObject_2: typeof XCAFDimTolObjects_GeomToleranceObject_2;
  Handle_XCAFDimTolObjects_GeomToleranceObject: typeof Handle_XCAFDimTolObjects_GeomToleranceObject;
  Handle_XCAFDimTolObjects_GeomToleranceObject_1: typeof Handle_XCAFDimTolObjects_GeomToleranceObject_1;
  Handle_XCAFDimTolObjects_GeomToleranceObject_2: typeof Handle_XCAFDimTolObjects_GeomToleranceObject_2;
  Handle_XCAFDimTolObjects_GeomToleranceObject_3: typeof Handle_XCAFDimTolObjects_GeomToleranceObject_3;
  Handle_XCAFDimTolObjects_GeomToleranceObject_4: typeof Handle_XCAFDimTolObjects_GeomToleranceObject_4;
  XCAFDimTolObjects_GeomToleranceMatReqModif: XCAFDimTolObjects_GeomToleranceMatReqModif;
  XCAFDimTolObjects_DimensionQualifier: XCAFDimTolObjects_DimensionQualifier;
  XCAFDimTolObjects_DimensionModif: XCAFDimTolObjects_DimensionModif;
  Handle_XCAFDimTolObjects_DatumObject: typeof Handle_XCAFDimTolObjects_DatumObject;
  Handle_XCAFDimTolObjects_DatumObject_1: typeof Handle_XCAFDimTolObjects_DatumObject_1;
  Handle_XCAFDimTolObjects_DatumObject_2: typeof Handle_XCAFDimTolObjects_DatumObject_2;
  Handle_XCAFDimTolObjects_DatumObject_3: typeof Handle_XCAFDimTolObjects_DatumObject_3;
  Handle_XCAFDimTolObjects_DatumObject_4: typeof Handle_XCAFDimTolObjects_DatumObject_4;
  XCAFDimTolObjects_DatumObject: typeof XCAFDimTolObjects_DatumObject;
  XCAFDimTolObjects_DatumObject_1: typeof XCAFDimTolObjects_DatumObject_1;
  XCAFDimTolObjects_DatumObject_2: typeof XCAFDimTolObjects_DatumObject_2;
  Handle_IFSelect_SelectInList: typeof Handle_IFSelect_SelectInList;
  Handle_IFSelect_SelectInList_1: typeof Handle_IFSelect_SelectInList_1;
  Handle_IFSelect_SelectInList_2: typeof Handle_IFSelect_SelectInList_2;
  Handle_IFSelect_SelectInList_3: typeof Handle_IFSelect_SelectInList_3;
  Handle_IFSelect_SelectInList_4: typeof Handle_IFSelect_SelectInList_4;
  IFSelect_SelectInList: typeof IFSelect_SelectInList;
  IFSelect_ParamEditor: typeof IFSelect_ParamEditor;
  Handle_IFSelect_ParamEditor: typeof Handle_IFSelect_ParamEditor;
  Handle_IFSelect_ParamEditor_1: typeof Handle_IFSelect_ParamEditor_1;
  Handle_IFSelect_ParamEditor_2: typeof Handle_IFSelect_ParamEditor_2;
  Handle_IFSelect_ParamEditor_3: typeof Handle_IFSelect_ParamEditor_3;
  Handle_IFSelect_ParamEditor_4: typeof Handle_IFSelect_ParamEditor_4;
  IFSelect_SelectEntityNumber: typeof IFSelect_SelectEntityNumber;
  Handle_IFSelect_SelectEntityNumber: typeof Handle_IFSelect_SelectEntityNumber;
  Handle_IFSelect_SelectEntityNumber_1: typeof Handle_IFSelect_SelectEntityNumber_1;
  Handle_IFSelect_SelectEntityNumber_2: typeof Handle_IFSelect_SelectEntityNumber_2;
  Handle_IFSelect_SelectEntityNumber_3: typeof Handle_IFSelect_SelectEntityNumber_3;
  Handle_IFSelect_SelectEntityNumber_4: typeof Handle_IFSelect_SelectEntityNumber_4;
  Handle_IFSelect_IntParam: typeof Handle_IFSelect_IntParam;
  Handle_IFSelect_IntParam_1: typeof Handle_IFSelect_IntParam_1;
  Handle_IFSelect_IntParam_2: typeof Handle_IFSelect_IntParam_2;
  Handle_IFSelect_IntParam_3: typeof Handle_IFSelect_IntParam_3;
  Handle_IFSelect_IntParam_4: typeof Handle_IFSelect_IntParam_4;
  IFSelect_SelectSignature: typeof IFSelect_SelectSignature;
  IFSelect_SelectSignature_1: typeof IFSelect_SelectSignature_1;
  IFSelect_SelectSignature_2: typeof IFSelect_SelectSignature_2;
  IFSelect_SelectSignature_3: typeof IFSelect_SelectSignature_3;
  Handle_IFSelect_SelectSignature: typeof Handle_IFSelect_SelectSignature;
  Handle_IFSelect_SelectSignature_1: typeof Handle_IFSelect_SelectSignature_1;
  Handle_IFSelect_SelectSignature_2: typeof Handle_IFSelect_SelectSignature_2;
  Handle_IFSelect_SelectSignature_3: typeof Handle_IFSelect_SelectSignature_3;
  Handle_IFSelect_SelectSignature_4: typeof Handle_IFSelect_SelectSignature_4;
  IFSelect_SelectSharing: typeof IFSelect_SelectSharing;
  Handle_IFSelect_SelectSharing: typeof Handle_IFSelect_SelectSharing;
  Handle_IFSelect_SelectSharing_1: typeof Handle_IFSelect_SelectSharing_1;
  Handle_IFSelect_SelectSharing_2: typeof Handle_IFSelect_SelectSharing_2;
  Handle_IFSelect_SelectSharing_3: typeof Handle_IFSelect_SelectSharing_3;
  Handle_IFSelect_SelectSharing_4: typeof Handle_IFSelect_SelectSharing_4;
  IFSelect_ContextWrite: typeof IFSelect_ContextWrite;
  IFSelect_ContextWrite_1: typeof IFSelect_ContextWrite_1;
  IFSelect_ContextWrite_2: typeof IFSelect_ContextWrite_2;
  Handle_IFSelect_Activator: typeof Handle_IFSelect_Activator;
  Handle_IFSelect_Activator_1: typeof Handle_IFSelect_Activator_1;
  Handle_IFSelect_Activator_2: typeof Handle_IFSelect_Activator_2;
  Handle_IFSelect_Activator_3: typeof Handle_IFSelect_Activator_3;
  Handle_IFSelect_Activator_4: typeof Handle_IFSelect_Activator_4;
  IFSelect_Activator: typeof IFSelect_Activator;
  Handle_IFSelect_SelectFlag: typeof Handle_IFSelect_SelectFlag;
  Handle_IFSelect_SelectFlag_1: typeof Handle_IFSelect_SelectFlag_1;
  Handle_IFSelect_SelectFlag_2: typeof Handle_IFSelect_SelectFlag_2;
  Handle_IFSelect_SelectFlag_3: typeof Handle_IFSelect_SelectFlag_3;
  Handle_IFSelect_SelectFlag_4: typeof Handle_IFSelect_SelectFlag_4;
  IFSelect_SelectFlag: typeof IFSelect_SelectFlag;
  Handle_IFSelect_HSeqOfSelection: typeof Handle_IFSelect_HSeqOfSelection;
  Handle_IFSelect_HSeqOfSelection_1: typeof Handle_IFSelect_HSeqOfSelection_1;
  Handle_IFSelect_HSeqOfSelection_2: typeof Handle_IFSelect_HSeqOfSelection_2;
  Handle_IFSelect_HSeqOfSelection_3: typeof Handle_IFSelect_HSeqOfSelection_3;
  Handle_IFSelect_HSeqOfSelection_4: typeof Handle_IFSelect_HSeqOfSelection_4;
  Handle_IFSelect_SelectIncorrectEntities: typeof Handle_IFSelect_SelectIncorrectEntities;
  Handle_IFSelect_SelectIncorrectEntities_1: typeof Handle_IFSelect_SelectIncorrectEntities_1;
  Handle_IFSelect_SelectIncorrectEntities_2: typeof Handle_IFSelect_SelectIncorrectEntities_2;
  Handle_IFSelect_SelectIncorrectEntities_3: typeof Handle_IFSelect_SelectIncorrectEntities_3;
  Handle_IFSelect_SelectIncorrectEntities_4: typeof Handle_IFSelect_SelectIncorrectEntities_4;
  IFSelect_SelectIncorrectEntities: typeof IFSelect_SelectIncorrectEntities;
  IFSelect_SelectRootComps: typeof IFSelect_SelectRootComps;
  Handle_IFSelect_SelectRootComps: typeof Handle_IFSelect_SelectRootComps;
  Handle_IFSelect_SelectRootComps_1: typeof Handle_IFSelect_SelectRootComps_1;
  Handle_IFSelect_SelectRootComps_2: typeof Handle_IFSelect_SelectRootComps_2;
  Handle_IFSelect_SelectRootComps_3: typeof Handle_IFSelect_SelectRootComps_3;
  Handle_IFSelect_SelectRootComps_4: typeof Handle_IFSelect_SelectRootComps_4;
  Handle_IFSelect_GeneralModifier: typeof Handle_IFSelect_GeneralModifier;
  Handle_IFSelect_GeneralModifier_1: typeof Handle_IFSelect_GeneralModifier_1;
  Handle_IFSelect_GeneralModifier_2: typeof Handle_IFSelect_GeneralModifier_2;
  Handle_IFSelect_GeneralModifier_3: typeof Handle_IFSelect_GeneralModifier_3;
  Handle_IFSelect_GeneralModifier_4: typeof Handle_IFSelect_GeneralModifier_4;
  IFSelect_GeneralModifier: typeof IFSelect_GeneralModifier;
  IFSelect_SessionDumper: typeof IFSelect_SessionDumper;
  Handle_IFSelect_SessionDumper: typeof Handle_IFSelect_SessionDumper;
  Handle_IFSelect_SessionDumper_1: typeof Handle_IFSelect_SessionDumper_1;
  Handle_IFSelect_SessionDumper_2: typeof Handle_IFSelect_SessionDumper_2;
  Handle_IFSelect_SessionDumper_3: typeof Handle_IFSelect_SessionDumper_3;
  Handle_IFSelect_SessionDumper_4: typeof Handle_IFSelect_SessionDumper_4;
  IFSelect_GraphCounter: typeof IFSelect_GraphCounter;
  Handle_IFSelect_GraphCounter: typeof Handle_IFSelect_GraphCounter;
  Handle_IFSelect_GraphCounter_1: typeof Handle_IFSelect_GraphCounter_1;
  Handle_IFSelect_GraphCounter_2: typeof Handle_IFSelect_GraphCounter_2;
  Handle_IFSelect_GraphCounter_3: typeof Handle_IFSelect_GraphCounter_3;
  Handle_IFSelect_GraphCounter_4: typeof Handle_IFSelect_GraphCounter_4;
  IFSelect_SelectType: typeof IFSelect_SelectType;
  IFSelect_SelectType_1: typeof IFSelect_SelectType_1;
  IFSelect_SelectType_2: typeof IFSelect_SelectType_2;
  Handle_IFSelect_SelectType: typeof Handle_IFSelect_SelectType;
  Handle_IFSelect_SelectType_1: typeof Handle_IFSelect_SelectType_1;
  Handle_IFSelect_SelectType_2: typeof Handle_IFSelect_SelectType_2;
  Handle_IFSelect_SelectType_3: typeof Handle_IFSelect_SelectType_3;
  Handle_IFSelect_SelectType_4: typeof Handle_IFSelect_SelectType_4;
  IFSelect_PacketList: typeof IFSelect_PacketList;
  Handle_IFSelect_PacketList: typeof Handle_IFSelect_PacketList;
  Handle_IFSelect_PacketList_1: typeof Handle_IFSelect_PacketList_1;
  Handle_IFSelect_PacketList_2: typeof Handle_IFSelect_PacketList_2;
  Handle_IFSelect_PacketList_3: typeof Handle_IFSelect_PacketList_3;
  Handle_IFSelect_PacketList_4: typeof Handle_IFSelect_PacketList_4;
  IFSelect_ModifEditForm: typeof IFSelect_ModifEditForm;
  Handle_IFSelect_ModifEditForm: typeof Handle_IFSelect_ModifEditForm;
  Handle_IFSelect_ModifEditForm_1: typeof Handle_IFSelect_ModifEditForm_1;
  Handle_IFSelect_ModifEditForm_2: typeof Handle_IFSelect_ModifEditForm_2;
  Handle_IFSelect_ModifEditForm_3: typeof Handle_IFSelect_ModifEditForm_3;
  Handle_IFSelect_ModifEditForm_4: typeof Handle_IFSelect_ModifEditForm_4;
  IFSelect_SelectShared: typeof IFSelect_SelectShared;
  Handle_IFSelect_SelectShared: typeof Handle_IFSelect_SelectShared;
  Handle_IFSelect_SelectShared_1: typeof Handle_IFSelect_SelectShared_1;
  Handle_IFSelect_SelectShared_2: typeof Handle_IFSelect_SelectShared_2;
  Handle_IFSelect_SelectShared_3: typeof Handle_IFSelect_SelectShared_3;
  Handle_IFSelect_SelectShared_4: typeof Handle_IFSelect_SelectShared_4;
  IFSelect_ShareOutResult: typeof IFSelect_ShareOutResult;
  IFSelect_ShareOutResult_1: typeof IFSelect_ShareOutResult_1;
  IFSelect_ShareOutResult_2: typeof IFSelect_ShareOutResult_2;
  IFSelect_ShareOutResult_3: typeof IFSelect_ShareOutResult_3;
  IFSelect_ShareOutResult_4: typeof IFSelect_ShareOutResult_4;
  IFSelect_Editor: typeof IFSelect_Editor;
  Handle_IFSelect_Editor: typeof Handle_IFSelect_Editor;
  Handle_IFSelect_Editor_1: typeof Handle_IFSelect_Editor_1;
  Handle_IFSelect_Editor_2: typeof Handle_IFSelect_Editor_2;
  Handle_IFSelect_Editor_3: typeof Handle_IFSelect_Editor_3;
  Handle_IFSelect_Editor_4: typeof Handle_IFSelect_Editor_4;
  Handle_IFSelect_ModifReorder: typeof Handle_IFSelect_ModifReorder;
  Handle_IFSelect_ModifReorder_1: typeof Handle_IFSelect_ModifReorder_1;
  Handle_IFSelect_ModifReorder_2: typeof Handle_IFSelect_ModifReorder_2;
  Handle_IFSelect_ModifReorder_3: typeof Handle_IFSelect_ModifReorder_3;
  Handle_IFSelect_ModifReorder_4: typeof Handle_IFSelect_ModifReorder_4;
  IFSelect_ModifReorder: typeof IFSelect_ModifReorder;
  Handle_IFSelect_SelectExtract: typeof Handle_IFSelect_SelectExtract;
  Handle_IFSelect_SelectExtract_1: typeof Handle_IFSelect_SelectExtract_1;
  Handle_IFSelect_SelectExtract_2: typeof Handle_IFSelect_SelectExtract_2;
  Handle_IFSelect_SelectExtract_3: typeof Handle_IFSelect_SelectExtract_3;
  Handle_IFSelect_SelectExtract_4: typeof Handle_IFSelect_SelectExtract_4;
  IFSelect_SelectExtract: typeof IFSelect_SelectExtract;
  Handle_IFSelect_WorkSession: typeof Handle_IFSelect_WorkSession;
  Handle_IFSelect_WorkSession_1: typeof Handle_IFSelect_WorkSession_1;
  Handle_IFSelect_WorkSession_2: typeof Handle_IFSelect_WorkSession_2;
  Handle_IFSelect_WorkSession_3: typeof Handle_IFSelect_WorkSession_3;
  Handle_IFSelect_WorkSession_4: typeof Handle_IFSelect_WorkSession_4;
  IFSelect_WorkSession: typeof IFSelect_WorkSession;
  IFSelect_Modifier: typeof IFSelect_Modifier;
  Handle_IFSelect_Modifier: typeof Handle_IFSelect_Modifier;
  Handle_IFSelect_Modifier_1: typeof Handle_IFSelect_Modifier_1;
  Handle_IFSelect_Modifier_2: typeof Handle_IFSelect_Modifier_2;
  Handle_IFSelect_Modifier_3: typeof Handle_IFSelect_Modifier_3;
  Handle_IFSelect_Modifier_4: typeof Handle_IFSelect_Modifier_4;
  Handle_IFSelect_ListEditor: typeof Handle_IFSelect_ListEditor;
  Handle_IFSelect_ListEditor_1: typeof Handle_IFSelect_ListEditor_1;
  Handle_IFSelect_ListEditor_2: typeof Handle_IFSelect_ListEditor_2;
  Handle_IFSelect_ListEditor_3: typeof Handle_IFSelect_ListEditor_3;
  Handle_IFSelect_ListEditor_4: typeof Handle_IFSelect_ListEditor_4;
  IFSelect_ListEditor: typeof IFSelect_ListEditor;
  IFSelect_ListEditor_1: typeof IFSelect_ListEditor_1;
  IFSelect_ListEditor_2: typeof IFSelect_ListEditor_2;
  IFSelect_SelectRange: typeof IFSelect_SelectRange;
  Handle_IFSelect_SelectRange: typeof Handle_IFSelect_SelectRange;
  Handle_IFSelect_SelectRange_1: typeof Handle_IFSelect_SelectRange_1;
  Handle_IFSelect_SelectRange_2: typeof Handle_IFSelect_SelectRange_2;
  Handle_IFSelect_SelectRange_3: typeof Handle_IFSelect_SelectRange_3;
  Handle_IFSelect_SelectRange_4: typeof Handle_IFSelect_SelectRange_4;
  Handle_IFSelect_ShareOut: typeof Handle_IFSelect_ShareOut;
  Handle_IFSelect_ShareOut_1: typeof Handle_IFSelect_ShareOut_1;
  Handle_IFSelect_ShareOut_2: typeof Handle_IFSelect_ShareOut_2;
  Handle_IFSelect_ShareOut_3: typeof Handle_IFSelect_ShareOut_3;
  Handle_IFSelect_ShareOut_4: typeof Handle_IFSelect_ShareOut_4;
  IFSelect_ShareOut: typeof IFSelect_ShareOut;
  Handle_IFSelect_EditForm: typeof Handle_IFSelect_EditForm;
  Handle_IFSelect_EditForm_1: typeof Handle_IFSelect_EditForm_1;
  Handle_IFSelect_EditForm_2: typeof Handle_IFSelect_EditForm_2;
  Handle_IFSelect_EditForm_3: typeof Handle_IFSelect_EditForm_3;
  Handle_IFSelect_EditForm_4: typeof Handle_IFSelect_EditForm_4;
  IFSelect_Signature: typeof IFSelect_Signature;
  Handle_IFSelect_Signature: typeof Handle_IFSelect_Signature;
  Handle_IFSelect_Signature_1: typeof Handle_IFSelect_Signature_1;
  Handle_IFSelect_Signature_2: typeof Handle_IFSelect_Signature_2;
  Handle_IFSelect_Signature_3: typeof Handle_IFSelect_Signature_3;
  Handle_IFSelect_Signature_4: typeof Handle_IFSelect_Signature_4;
  IFSelect_SelectionIterator: typeof IFSelect_SelectionIterator;
  IFSelect_SelectionIterator_1: typeof IFSelect_SelectionIterator_1;
  IFSelect_SelectionIterator_2: typeof IFSelect_SelectionIterator_2;
  Handle_IFSelect_DispPerCount: typeof Handle_IFSelect_DispPerCount;
  Handle_IFSelect_DispPerCount_1: typeof Handle_IFSelect_DispPerCount_1;
  Handle_IFSelect_DispPerCount_2: typeof Handle_IFSelect_DispPerCount_2;
  Handle_IFSelect_DispPerCount_3: typeof Handle_IFSelect_DispPerCount_3;
  Handle_IFSelect_DispPerCount_4: typeof Handle_IFSelect_DispPerCount_4;
  IFSelect_DispPerCount: typeof IFSelect_DispPerCount;
  Handle_IFSelect_SelectControl: typeof Handle_IFSelect_SelectControl;
  Handle_IFSelect_SelectControl_1: typeof Handle_IFSelect_SelectControl_1;
  Handle_IFSelect_SelectControl_2: typeof Handle_IFSelect_SelectControl_2;
  Handle_IFSelect_SelectControl_3: typeof Handle_IFSelect_SelectControl_3;
  Handle_IFSelect_SelectControl_4: typeof Handle_IFSelect_SelectControl_4;
  IFSelect_SelectControl: typeof IFSelect_SelectControl;
  IFSelect_SelectSignedShared: typeof IFSelect_SelectSignedShared;
  Handle_IFSelect_SelectSignedShared: typeof Handle_IFSelect_SelectSignedShared;
  Handle_IFSelect_SelectSignedShared_1: typeof Handle_IFSelect_SelectSignedShared_1;
  Handle_IFSelect_SelectSignedShared_2: typeof Handle_IFSelect_SelectSignedShared_2;
  Handle_IFSelect_SelectSignedShared_3: typeof Handle_IFSelect_SelectSignedShared_3;
  Handle_IFSelect_SelectSignedShared_4: typeof Handle_IFSelect_SelectSignedShared_4;
  IFSelect_Selection: typeof IFSelect_Selection;
  Handle_IFSelect_Selection: typeof Handle_IFSelect_Selection;
  Handle_IFSelect_Selection_1: typeof Handle_IFSelect_Selection_1;
  Handle_IFSelect_Selection_2: typeof Handle_IFSelect_Selection_2;
  Handle_IFSelect_Selection_3: typeof Handle_IFSelect_Selection_3;
  Handle_IFSelect_Selection_4: typeof Handle_IFSelect_Selection_4;
  IFSelect_BasicDumper: typeof IFSelect_BasicDumper;
  Handle_IFSelect_BasicDumper: typeof Handle_IFSelect_BasicDumper;
  Handle_IFSelect_BasicDumper_1: typeof Handle_IFSelect_BasicDumper_1;
  Handle_IFSelect_BasicDumper_2: typeof Handle_IFSelect_BasicDumper_2;
  Handle_IFSelect_BasicDumper_3: typeof Handle_IFSelect_BasicDumper_3;
  Handle_IFSelect_BasicDumper_4: typeof Handle_IFSelect_BasicDumper_4;
  Handle_IFSelect_SelectCombine: typeof Handle_IFSelect_SelectCombine;
  Handle_IFSelect_SelectCombine_1: typeof Handle_IFSelect_SelectCombine_1;
  Handle_IFSelect_SelectCombine_2: typeof Handle_IFSelect_SelectCombine_2;
  Handle_IFSelect_SelectCombine_3: typeof Handle_IFSelect_SelectCombine_3;
  Handle_IFSelect_SelectCombine_4: typeof Handle_IFSelect_SelectCombine_4;
  IFSelect_SelectCombine: typeof IFSelect_SelectCombine;
  Handle_IFSelect_SelectDiff: typeof Handle_IFSelect_SelectDiff;
  Handle_IFSelect_SelectDiff_1: typeof Handle_IFSelect_SelectDiff_1;
  Handle_IFSelect_SelectDiff_2: typeof Handle_IFSelect_SelectDiff_2;
  Handle_IFSelect_SelectDiff_3: typeof Handle_IFSelect_SelectDiff_3;
  Handle_IFSelect_SelectDiff_4: typeof Handle_IFSelect_SelectDiff_4;
  IFSelect_SelectDiff: typeof IFSelect_SelectDiff;
  IFSelect_Functions: typeof IFSelect_Functions;
  Handle_IFSelect_SelectSignedSharing: typeof Handle_IFSelect_SelectSignedSharing;
  Handle_IFSelect_SelectSignedSharing_1: typeof Handle_IFSelect_SelectSignedSharing_1;
  Handle_IFSelect_SelectSignedSharing_2: typeof Handle_IFSelect_SelectSignedSharing_2;
  Handle_IFSelect_SelectSignedSharing_3: typeof Handle_IFSelect_SelectSignedSharing_3;
  Handle_IFSelect_SelectSignedSharing_4: typeof Handle_IFSelect_SelectSignedSharing_4;
  IFSelect_SelectSignedSharing: typeof IFSelect_SelectSignedSharing;
  Handle_IFSelect_Transformer: typeof Handle_IFSelect_Transformer;
  Handle_IFSelect_Transformer_1: typeof Handle_IFSelect_Transformer_1;
  Handle_IFSelect_Transformer_2: typeof Handle_IFSelect_Transformer_2;
  Handle_IFSelect_Transformer_3: typeof Handle_IFSelect_Transformer_3;
  Handle_IFSelect_Transformer_4: typeof Handle_IFSelect_Transformer_4;
  IFSelect_Transformer: typeof IFSelect_Transformer;
  IFSelect: typeof IFSelect;
  IFSelect_CheckCounter: typeof IFSelect_CheckCounter;
  Handle_IFSelect_CheckCounter: typeof Handle_IFSelect_CheckCounter;
  Handle_IFSelect_CheckCounter_1: typeof Handle_IFSelect_CheckCounter_1;
  Handle_IFSelect_CheckCounter_2: typeof Handle_IFSelect_CheckCounter_2;
  Handle_IFSelect_CheckCounter_3: typeof Handle_IFSelect_CheckCounter_3;
  Handle_IFSelect_CheckCounter_4: typeof Handle_IFSelect_CheckCounter_4;
  Handle_IFSelect_SelectAnyType: typeof Handle_IFSelect_SelectAnyType;
  Handle_IFSelect_SelectAnyType_1: typeof Handle_IFSelect_SelectAnyType_1;
  Handle_IFSelect_SelectAnyType_2: typeof Handle_IFSelect_SelectAnyType_2;
  Handle_IFSelect_SelectAnyType_3: typeof Handle_IFSelect_SelectAnyType_3;
  Handle_IFSelect_SelectAnyType_4: typeof Handle_IFSelect_SelectAnyType_4;
  IFSelect_SelectAnyType: typeof IFSelect_SelectAnyType;
  Handle_IFSelect_SelectDeduct: typeof Handle_IFSelect_SelectDeduct;
  Handle_IFSelect_SelectDeduct_1: typeof Handle_IFSelect_SelectDeduct_1;
  Handle_IFSelect_SelectDeduct_2: typeof Handle_IFSelect_SelectDeduct_2;
  Handle_IFSelect_SelectDeduct_3: typeof Handle_IFSelect_SelectDeduct_3;
  Handle_IFSelect_SelectDeduct_4: typeof Handle_IFSelect_SelectDeduct_4;
  IFSelect_SelectDeduct: typeof IFSelect_SelectDeduct;
  Handle_IFSelect_SignAncestor: typeof Handle_IFSelect_SignAncestor;
  Handle_IFSelect_SignAncestor_1: typeof Handle_IFSelect_SignAncestor_1;
  Handle_IFSelect_SignAncestor_2: typeof Handle_IFSelect_SignAncestor_2;
  Handle_IFSelect_SignAncestor_3: typeof Handle_IFSelect_SignAncestor_3;
  Handle_IFSelect_SignAncestor_4: typeof Handle_IFSelect_SignAncestor_4;
  IFSelect_SignAncestor: typeof IFSelect_SignAncestor;
  Handle_IFSelect_SignMultiple: typeof Handle_IFSelect_SignMultiple;
  Handle_IFSelect_SignMultiple_1: typeof Handle_IFSelect_SignMultiple_1;
  Handle_IFSelect_SignMultiple_2: typeof Handle_IFSelect_SignMultiple_2;
  Handle_IFSelect_SignMultiple_3: typeof Handle_IFSelect_SignMultiple_3;
  Handle_IFSelect_SignMultiple_4: typeof Handle_IFSelect_SignMultiple_4;
  IFSelect_SignMultiple: typeof IFSelect_SignMultiple;
  Handle_IFSelect_DispPerSignature: typeof Handle_IFSelect_DispPerSignature;
  Handle_IFSelect_DispPerSignature_1: typeof Handle_IFSelect_DispPerSignature_1;
  Handle_IFSelect_DispPerSignature_2: typeof Handle_IFSelect_DispPerSignature_2;
  Handle_IFSelect_DispPerSignature_3: typeof Handle_IFSelect_DispPerSignature_3;
  Handle_IFSelect_DispPerSignature_4: typeof Handle_IFSelect_DispPerSignature_4;
  IFSelect_DispPerSignature: typeof IFSelect_DispPerSignature;
  IFSelect_SignType: typeof IFSelect_SignType;
  Handle_IFSelect_SignType: typeof Handle_IFSelect_SignType;
  Handle_IFSelect_SignType_1: typeof Handle_IFSelect_SignType_1;
  Handle_IFSelect_SignType_2: typeof Handle_IFSelect_SignType_2;
  Handle_IFSelect_SignType_3: typeof Handle_IFSelect_SignType_3;
  Handle_IFSelect_SignType_4: typeof Handle_IFSelect_SignType_4;
  Handle_IFSelect_Dispatch: typeof Handle_IFSelect_Dispatch;
  Handle_IFSelect_Dispatch_1: typeof Handle_IFSelect_Dispatch_1;
  Handle_IFSelect_Dispatch_2: typeof Handle_IFSelect_Dispatch_2;
  Handle_IFSelect_Dispatch_3: typeof Handle_IFSelect_Dispatch_3;
  Handle_IFSelect_Dispatch_4: typeof Handle_IFSelect_Dispatch_4;
  IFSelect_Dispatch: typeof IFSelect_Dispatch;
  Handle_IFSelect_TransformStandard: typeof Handle_IFSelect_TransformStandard;
  Handle_IFSelect_TransformStandard_1: typeof Handle_IFSelect_TransformStandard_1;
  Handle_IFSelect_TransformStandard_2: typeof Handle_IFSelect_TransformStandard_2;
  Handle_IFSelect_TransformStandard_3: typeof Handle_IFSelect_TransformStandard_3;
  Handle_IFSelect_TransformStandard_4: typeof Handle_IFSelect_TransformStandard_4;
  IFSelect_TransformStandard: typeof IFSelect_TransformStandard;
  IFSelect_SelectUnion: typeof IFSelect_SelectUnion;
  Handle_IFSelect_SelectUnion: typeof Handle_IFSelect_SelectUnion;
  Handle_IFSelect_SelectUnion_1: typeof Handle_IFSelect_SelectUnion_1;
  Handle_IFSelect_SelectUnion_2: typeof Handle_IFSelect_SelectUnion_2;
  Handle_IFSelect_SelectUnion_3: typeof Handle_IFSelect_SelectUnion_3;
  Handle_IFSelect_SelectUnion_4: typeof Handle_IFSelect_SelectUnion_4;
  Handle_IFSelect_SelectUnknownEntities: typeof Handle_IFSelect_SelectUnknownEntities;
  Handle_IFSelect_SelectUnknownEntities_1: typeof Handle_IFSelect_SelectUnknownEntities_1;
  Handle_IFSelect_SelectUnknownEntities_2: typeof Handle_IFSelect_SelectUnknownEntities_2;
  Handle_IFSelect_SelectUnknownEntities_3: typeof Handle_IFSelect_SelectUnknownEntities_3;
  Handle_IFSelect_SelectUnknownEntities_4: typeof Handle_IFSelect_SelectUnknownEntities_4;
  IFSelect_SelectUnknownEntities: typeof IFSelect_SelectUnknownEntities;
  IFSelect_PrintCount: IFSelect_PrintCount;
  IFSelect_AppliedModifiers: typeof IFSelect_AppliedModifiers;
  Handle_IFSelect_AppliedModifiers: typeof Handle_IFSelect_AppliedModifiers;
  Handle_IFSelect_AppliedModifiers_1: typeof Handle_IFSelect_AppliedModifiers_1;
  Handle_IFSelect_AppliedModifiers_2: typeof Handle_IFSelect_AppliedModifiers_2;
  Handle_IFSelect_AppliedModifiers_3: typeof Handle_IFSelect_AppliedModifiers_3;
  Handle_IFSelect_AppliedModifiers_4: typeof Handle_IFSelect_AppliedModifiers_4;
  IFSelect_SelectSuite: typeof IFSelect_SelectSuite;
  Handle_IFSelect_SelectSuite: typeof Handle_IFSelect_SelectSuite;
  Handle_IFSelect_SelectSuite_1: typeof Handle_IFSelect_SelectSuite_1;
  Handle_IFSelect_SelectSuite_2: typeof Handle_IFSelect_SelectSuite_2;
  Handle_IFSelect_SelectSuite_3: typeof Handle_IFSelect_SelectSuite_3;
  Handle_IFSelect_SelectSuite_4: typeof Handle_IFSelect_SelectSuite_4;
  IFSelect_EditValue: IFSelect_EditValue;
  IFSelect_SelectSent: typeof IFSelect_SelectSent;
  Handle_IFSelect_SelectSent: typeof Handle_IFSelect_SelectSent;
  Handle_IFSelect_SelectSent_1: typeof Handle_IFSelect_SelectSent_1;
  Handle_IFSelect_SelectSent_2: typeof Handle_IFSelect_SelectSent_2;
  Handle_IFSelect_SelectSent_3: typeof Handle_IFSelect_SelectSent_3;
  Handle_IFSelect_SelectSent_4: typeof Handle_IFSelect_SelectSent_4;
  IFSelect_PrintFail: IFSelect_PrintFail;
  Handle_IFSelect_SignCounter: typeof Handle_IFSelect_SignCounter;
  Handle_IFSelect_SignCounter_1: typeof Handle_IFSelect_SignCounter_1;
  Handle_IFSelect_SignCounter_2: typeof Handle_IFSelect_SignCounter_2;
  Handle_IFSelect_SignCounter_3: typeof Handle_IFSelect_SignCounter_3;
  Handle_IFSelect_SignCounter_4: typeof Handle_IFSelect_SignCounter_4;
  IFSelect_SignCounter: typeof IFSelect_SignCounter;
  IFSelect_SignCounter_1: typeof IFSelect_SignCounter_1;
  IFSelect_SignCounter_2: typeof IFSelect_SignCounter_2;
  IFSelect_DispGlobal: typeof IFSelect_DispGlobal;
  Handle_IFSelect_DispGlobal: typeof Handle_IFSelect_DispGlobal;
  Handle_IFSelect_DispGlobal_1: typeof Handle_IFSelect_DispGlobal_1;
  Handle_IFSelect_DispGlobal_2: typeof Handle_IFSelect_DispGlobal_2;
  Handle_IFSelect_DispGlobal_3: typeof Handle_IFSelect_DispGlobal_3;
  Handle_IFSelect_DispGlobal_4: typeof Handle_IFSelect_DispGlobal_4;
  Handle_IFSelect_SignValidity: typeof Handle_IFSelect_SignValidity;
  Handle_IFSelect_SignValidity_1: typeof Handle_IFSelect_SignValidity_1;
  Handle_IFSelect_SignValidity_2: typeof Handle_IFSelect_SignValidity_2;
  Handle_IFSelect_SignValidity_3: typeof Handle_IFSelect_SignValidity_3;
  Handle_IFSelect_SignValidity_4: typeof Handle_IFSelect_SignValidity_4;
  IFSelect_SignValidity: typeof IFSelect_SignValidity;
  Handle_IFSelect_SelectIntersection: typeof Handle_IFSelect_SelectIntersection;
  Handle_IFSelect_SelectIntersection_1: typeof Handle_IFSelect_SelectIntersection_1;
  Handle_IFSelect_SelectIntersection_2: typeof Handle_IFSelect_SelectIntersection_2;
  Handle_IFSelect_SelectIntersection_3: typeof Handle_IFSelect_SelectIntersection_3;
  Handle_IFSelect_SelectIntersection_4: typeof Handle_IFSelect_SelectIntersection_4;
  IFSelect_SelectIntersection: typeof IFSelect_SelectIntersection;
  Handle_IFSelect_SelectModelRoots: typeof Handle_IFSelect_SelectModelRoots;
  Handle_IFSelect_SelectModelRoots_1: typeof Handle_IFSelect_SelectModelRoots_1;
  Handle_IFSelect_SelectModelRoots_2: typeof Handle_IFSelect_SelectModelRoots_2;
  Handle_IFSelect_SelectModelRoots_3: typeof Handle_IFSelect_SelectModelRoots_3;
  Handle_IFSelect_SelectModelRoots_4: typeof Handle_IFSelect_SelectModelRoots_4;
  IFSelect_SelectModelRoots: typeof IFSelect_SelectModelRoots;
  Handle_IFSelect_SignatureList: typeof Handle_IFSelect_SignatureList;
  Handle_IFSelect_SignatureList_1: typeof Handle_IFSelect_SignatureList_1;
  Handle_IFSelect_SignatureList_2: typeof Handle_IFSelect_SignatureList_2;
  Handle_IFSelect_SignatureList_3: typeof Handle_IFSelect_SignatureList_3;
  Handle_IFSelect_SignatureList_4: typeof Handle_IFSelect_SignatureList_4;
  IFSelect_SignatureList: typeof IFSelect_SignatureList;
  Handle_IFSelect_DispPerFiles: typeof Handle_IFSelect_DispPerFiles;
  Handle_IFSelect_DispPerFiles_1: typeof Handle_IFSelect_DispPerFiles_1;
  Handle_IFSelect_DispPerFiles_2: typeof Handle_IFSelect_DispPerFiles_2;
  Handle_IFSelect_DispPerFiles_3: typeof Handle_IFSelect_DispPerFiles_3;
  Handle_IFSelect_DispPerFiles_4: typeof Handle_IFSelect_DispPerFiles_4;
  IFSelect_DispPerFiles: typeof IFSelect_DispPerFiles;
  IFSelect_Act: typeof IFSelect_Act;
  Handle_IFSelect_Act: typeof Handle_IFSelect_Act;
  Handle_IFSelect_Act_1: typeof Handle_IFSelect_Act_1;
  Handle_IFSelect_Act_2: typeof Handle_IFSelect_Act_2;
  Handle_IFSelect_Act_3: typeof Handle_IFSelect_Act_3;
  Handle_IFSelect_Act_4: typeof Handle_IFSelect_Act_4;
  Handle_IFSelect_WorkLibrary: typeof Handle_IFSelect_WorkLibrary;
  Handle_IFSelect_WorkLibrary_1: typeof Handle_IFSelect_WorkLibrary_1;
  Handle_IFSelect_WorkLibrary_2: typeof Handle_IFSelect_WorkLibrary_2;
  Handle_IFSelect_WorkLibrary_3: typeof Handle_IFSelect_WorkLibrary_3;
  Handle_IFSelect_WorkLibrary_4: typeof Handle_IFSelect_WorkLibrary_4;
  IFSelect_WorkLibrary: typeof IFSelect_WorkLibrary;
  IFSelect_SelectModelEntities: typeof IFSelect_SelectModelEntities;
  Handle_IFSelect_SelectModelEntities: typeof Handle_IFSelect_SelectModelEntities;
  Handle_IFSelect_SelectModelEntities_1: typeof Handle_IFSelect_SelectModelEntities_1;
  Handle_IFSelect_SelectModelEntities_2: typeof Handle_IFSelect_SelectModelEntities_2;
  Handle_IFSelect_SelectModelEntities_3: typeof Handle_IFSelect_SelectModelEntities_3;
  Handle_IFSelect_SelectModelEntities_4: typeof Handle_IFSelect_SelectModelEntities_4;
  IFSelect_ReturnStatus: IFSelect_ReturnStatus;
  Handle_IFSelect_DispPerOne: typeof Handle_IFSelect_DispPerOne;
  Handle_IFSelect_DispPerOne_1: typeof Handle_IFSelect_DispPerOne_1;
  Handle_IFSelect_DispPerOne_2: typeof Handle_IFSelect_DispPerOne_2;
  Handle_IFSelect_DispPerOne_3: typeof Handle_IFSelect_DispPerOne_3;
  Handle_IFSelect_DispPerOne_4: typeof Handle_IFSelect_DispPerOne_4;
  IFSelect_DispPerOne: typeof IFSelect_DispPerOne;
  Handle_IFSelect_SignCategory: typeof Handle_IFSelect_SignCategory;
  Handle_IFSelect_SignCategory_1: typeof Handle_IFSelect_SignCategory_1;
  Handle_IFSelect_SignCategory_2: typeof Handle_IFSelect_SignCategory_2;
  Handle_IFSelect_SignCategory_3: typeof Handle_IFSelect_SignCategory_3;
  Handle_IFSelect_SignCategory_4: typeof Handle_IFSelect_SignCategory_4;
  IFSelect_SignCategory: typeof IFSelect_SignCategory;
  Handle_IFSelect_SelectAnyList: typeof Handle_IFSelect_SelectAnyList;
  Handle_IFSelect_SelectAnyList_1: typeof Handle_IFSelect_SelectAnyList_1;
  Handle_IFSelect_SelectAnyList_2: typeof Handle_IFSelect_SelectAnyList_2;
  Handle_IFSelect_SelectAnyList_3: typeof Handle_IFSelect_SelectAnyList_3;
  Handle_IFSelect_SelectAnyList_4: typeof Handle_IFSelect_SelectAnyList_4;
  IFSelect_SelectAnyList: typeof IFSelect_SelectAnyList;
  IFSelect_SelectRoots: typeof IFSelect_SelectRoots;
  Handle_IFSelect_SelectRoots: typeof Handle_IFSelect_SelectRoots;
  Handle_IFSelect_SelectRoots_1: typeof Handle_IFSelect_SelectRoots_1;
  Handle_IFSelect_SelectRoots_2: typeof Handle_IFSelect_SelectRoots_2;
  Handle_IFSelect_SelectRoots_3: typeof Handle_IFSelect_SelectRoots_3;
  Handle_IFSelect_SelectRoots_4: typeof Handle_IFSelect_SelectRoots_4;
  IFSelect_ModelCopier: typeof IFSelect_ModelCopier;
  Handle_IFSelect_ModelCopier: typeof Handle_IFSelect_ModelCopier;
  Handle_IFSelect_ModelCopier_1: typeof Handle_IFSelect_ModelCopier_1;
  Handle_IFSelect_ModelCopier_2: typeof Handle_IFSelect_ModelCopier_2;
  Handle_IFSelect_ModelCopier_3: typeof Handle_IFSelect_ModelCopier_3;
  Handle_IFSelect_ModelCopier_4: typeof Handle_IFSelect_ModelCopier_4;
  IFSelect_SessionFile: typeof IFSelect_SessionFile;
  IFSelect_SessionFile_1: typeof IFSelect_SessionFile_1;
  IFSelect_SessionFile_2: typeof IFSelect_SessionFile_2;
  IFSelect_SessionPilot: typeof IFSelect_SessionPilot;
  Handle_IFSelect_SessionPilot: typeof Handle_IFSelect_SessionPilot;
  Handle_IFSelect_SessionPilot_1: typeof Handle_IFSelect_SessionPilot_1;
  Handle_IFSelect_SessionPilot_2: typeof Handle_IFSelect_SessionPilot_2;
  Handle_IFSelect_SessionPilot_3: typeof Handle_IFSelect_SessionPilot_3;
  Handle_IFSelect_SessionPilot_4: typeof Handle_IFSelect_SessionPilot_4;
  IFSelect_RemainMode: IFSelect_RemainMode;
  Handle_IFSelect_SelectExplore: typeof Handle_IFSelect_SelectExplore;
  Handle_IFSelect_SelectExplore_1: typeof Handle_IFSelect_SelectExplore_1;
  Handle_IFSelect_SelectExplore_2: typeof Handle_IFSelect_SelectExplore_2;
  Handle_IFSelect_SelectExplore_3: typeof Handle_IFSelect_SelectExplore_3;
  Handle_IFSelect_SelectExplore_4: typeof Handle_IFSelect_SelectExplore_4;
  IFSelect_SelectExplore: typeof IFSelect_SelectExplore;
  Handle_IFSelect_SelectErrorEntities: typeof Handle_IFSelect_SelectErrorEntities;
  Handle_IFSelect_SelectErrorEntities_1: typeof Handle_IFSelect_SelectErrorEntities_1;
  Handle_IFSelect_SelectErrorEntities_2: typeof Handle_IFSelect_SelectErrorEntities_2;
  Handle_IFSelect_SelectErrorEntities_3: typeof Handle_IFSelect_SelectErrorEntities_3;
  Handle_IFSelect_SelectErrorEntities_4: typeof Handle_IFSelect_SelectErrorEntities_4;
  IFSelect_SelectErrorEntities: typeof IFSelect_SelectErrorEntities;
  Handle_IFSelect_SelectPointed: typeof Handle_IFSelect_SelectPointed;
  Handle_IFSelect_SelectPointed_1: typeof Handle_IFSelect_SelectPointed_1;
  Handle_IFSelect_SelectPointed_2: typeof Handle_IFSelect_SelectPointed_2;
  Handle_IFSelect_SelectPointed_3: typeof Handle_IFSelect_SelectPointed_3;
  Handle_IFSelect_SelectPointed_4: typeof Handle_IFSelect_SelectPointed_4;
  IFSelect_SelectPointed: typeof IFSelect_SelectPointed;
  IFSelect_SelectBase: typeof IFSelect_SelectBase;
  Handle_IFSelect_SelectBase: typeof Handle_IFSelect_SelectBase;
  Handle_IFSelect_SelectBase_1: typeof Handle_IFSelect_SelectBase_1;
  Handle_IFSelect_SelectBase_2: typeof Handle_IFSelect_SelectBase_2;
  Handle_IFSelect_SelectBase_3: typeof Handle_IFSelect_SelectBase_3;
  Handle_IFSelect_SelectBase_4: typeof Handle_IFSelect_SelectBase_4;
  RWStl_Reader: typeof RWStl_Reader;
  RWStl: typeof RWStl;
  Handle_HeaderSection_Protocol: typeof Handle_HeaderSection_Protocol;
  Handle_HeaderSection_Protocol_1: typeof Handle_HeaderSection_Protocol_1;
  Handle_HeaderSection_Protocol_2: typeof Handle_HeaderSection_Protocol_2;
  Handle_HeaderSection_Protocol_3: typeof Handle_HeaderSection_Protocol_3;
  Handle_HeaderSection_Protocol_4: typeof Handle_HeaderSection_Protocol_4;
  HeaderSection_Protocol: typeof HeaderSection_Protocol;
  Handle_HeaderSection_FileDescription: typeof Handle_HeaderSection_FileDescription;
  Handle_HeaderSection_FileDescription_1: typeof Handle_HeaderSection_FileDescription_1;
  Handle_HeaderSection_FileDescription_2: typeof Handle_HeaderSection_FileDescription_2;
  Handle_HeaderSection_FileDescription_3: typeof Handle_HeaderSection_FileDescription_3;
  Handle_HeaderSection_FileDescription_4: typeof Handle_HeaderSection_FileDescription_4;
  HeaderSection_FileDescription: typeof HeaderSection_FileDescription;
  Handle_HeaderSection_FileSchema: typeof Handle_HeaderSection_FileSchema;
  Handle_HeaderSection_FileSchema_1: typeof Handle_HeaderSection_FileSchema_1;
  Handle_HeaderSection_FileSchema_2: typeof Handle_HeaderSection_FileSchema_2;
  Handle_HeaderSection_FileSchema_3: typeof Handle_HeaderSection_FileSchema_3;
  Handle_HeaderSection_FileSchema_4: typeof Handle_HeaderSection_FileSchema_4;
  HeaderSection_FileSchema: typeof HeaderSection_FileSchema;
  HeaderSection_FileName: typeof HeaderSection_FileName;
  Handle_HeaderSection_FileName: typeof Handle_HeaderSection_FileName;
  Handle_HeaderSection_FileName_1: typeof Handle_HeaderSection_FileName_1;
  Handle_HeaderSection_FileName_2: typeof Handle_HeaderSection_FileName_2;
  Handle_HeaderSection_FileName_3: typeof Handle_HeaderSection_FileName_3;
  Handle_HeaderSection_FileName_4: typeof Handle_HeaderSection_FileName_4;
  HeaderSection: typeof HeaderSection;
  IGESConvGeom_GeomBuilder: typeof IGESConvGeom_GeomBuilder;
  IGESConvGeom: typeof IGESConvGeom;
  IntTools_ListOfSurfaceRangeSample: typeof IntTools_ListOfSurfaceRangeSample;
  IntTools_ListOfSurfaceRangeSample_1: typeof IntTools_ListOfSurfaceRangeSample_1;
  IntTools_ListOfSurfaceRangeSample_2: typeof IntTools_ListOfSurfaceRangeSample_2;
  IntTools_ListOfSurfaceRangeSample_3: typeof IntTools_ListOfSurfaceRangeSample_3;
  IntTools_CurveRangeLocalizeData: typeof IntTools_CurveRangeLocalizeData;
  IntTools_Tools: typeof IntTools_Tools;
  IntTools_DataMapOfSurfaceSampleBox: typeof IntTools_DataMapOfSurfaceSampleBox;
  IntTools_DataMapOfSurfaceSampleBox_1: typeof IntTools_DataMapOfSurfaceSampleBox_1;
  IntTools_DataMapOfSurfaceSampleBox_2: typeof IntTools_DataMapOfSurfaceSampleBox_2;
  IntTools_DataMapOfSurfaceSampleBox_3: typeof IntTools_DataMapOfSurfaceSampleBox_3;
  IntTools_WLineTool: typeof IntTools_WLineTool;
  IntTools_MapOfSurfaceSample: typeof IntTools_MapOfSurfaceSample;
  IntTools_MapOfSurfaceSample_1: typeof IntTools_MapOfSurfaceSample_1;
  IntTools_MapOfSurfaceSample_2: typeof IntTools_MapOfSurfaceSample_2;
  IntTools_MapOfSurfaceSample_3: typeof IntTools_MapOfSurfaceSample_3;
  IntTools_ListOfCurveRangeSample: typeof IntTools_ListOfCurveRangeSample;
  IntTools_ListOfCurveRangeSample_1: typeof IntTools_ListOfCurveRangeSample_1;
  IntTools_ListOfCurveRangeSample_2: typeof IntTools_ListOfCurveRangeSample_2;
  IntTools_ListOfCurveRangeSample_3: typeof IntTools_ListOfCurveRangeSample_3;
  IntTools_Array1OfRoots: typeof IntTools_Array1OfRoots;
  IntTools_Array1OfRoots_1: typeof IntTools_Array1OfRoots_1;
  IntTools_Array1OfRoots_2: typeof IntTools_Array1OfRoots_2;
  IntTools_Array1OfRoots_3: typeof IntTools_Array1OfRoots_3;
  IntTools_Array1OfRoots_4: typeof IntTools_Array1OfRoots_4;
  IntTools_Array1OfRoots_5: typeof IntTools_Array1OfRoots_5;
  IntTools_EdgeEdge: typeof IntTools_EdgeEdge;
  IntTools_EdgeEdge_1: typeof IntTools_EdgeEdge_1;
  IntTools_EdgeEdge_2: typeof IntTools_EdgeEdge_2;
  IntTools_EdgeEdge_3: typeof IntTools_EdgeEdge_3;
  IntTools_CurveRangeSampleMapHasher: typeof IntTools_CurveRangeSampleMapHasher;
  Handle_IntTools_Context: typeof Handle_IntTools_Context;
  Handle_IntTools_Context_1: typeof Handle_IntTools_Context_1;
  Handle_IntTools_Context_2: typeof Handle_IntTools_Context_2;
  Handle_IntTools_Context_3: typeof Handle_IntTools_Context_3;
  Handle_IntTools_Context_4: typeof Handle_IntTools_Context_4;
  IntTools_SequenceOfRoots: typeof IntTools_SequenceOfRoots;
  IntTools_SequenceOfRoots_1: typeof IntTools_SequenceOfRoots_1;
  IntTools_SequenceOfRoots_2: typeof IntTools_SequenceOfRoots_2;
  IntTools_SequenceOfRoots_3: typeof IntTools_SequenceOfRoots_3;
  IntTools_SurfaceRangeLocalizeData: typeof IntTools_SurfaceRangeLocalizeData;
  IntTools_SurfaceRangeLocalizeData_1: typeof IntTools_SurfaceRangeLocalizeData_1;
  IntTools_SurfaceRangeLocalizeData_2: typeof IntTools_SurfaceRangeLocalizeData_2;
  IntTools_SurfaceRangeLocalizeData_3: typeof IntTools_SurfaceRangeLocalizeData_3;
  IntTools_DataMapOfCurveSampleBox: typeof IntTools_DataMapOfCurveSampleBox;
  IntTools_DataMapOfCurveSampleBox_1: typeof IntTools_DataMapOfCurveSampleBox_1;
  IntTools_DataMapOfCurveSampleBox_2: typeof IntTools_DataMapOfCurveSampleBox_2;
  IntTools_DataMapOfCurveSampleBox_3: typeof IntTools_DataMapOfCurveSampleBox_3;
  IntTools_EdgeFace: typeof IntTools_EdgeFace;
  IntTools_BaseRangeSample: typeof IntTools_BaseRangeSample;
  IntTools_BaseRangeSample_1: typeof IntTools_BaseRangeSample_1;
  IntTools_BaseRangeSample_2: typeof IntTools_BaseRangeSample_2;
  IntTools_PntOn2Faces: typeof IntTools_PntOn2Faces;
  IntTools_PntOn2Faces_1: typeof IntTools_PntOn2Faces_1;
  IntTools_PntOn2Faces_2: typeof IntTools_PntOn2Faces_2;
  IntTools_FaceFace: typeof IntTools_FaceFace;
  IntTools: typeof IntTools;
  IntTools_MarkedRangeSet: typeof IntTools_MarkedRangeSet;
  IntTools_MarkedRangeSet_1: typeof IntTools_MarkedRangeSet_1;
  IntTools_MarkedRangeSet_2: typeof IntTools_MarkedRangeSet_2;
  IntTools_MarkedRangeSet_3: typeof IntTools_MarkedRangeSet_3;
  IntTools_MapOfCurveSample: typeof IntTools_MapOfCurveSample;
  IntTools_MapOfCurveSample_1: typeof IntTools_MapOfCurveSample_1;
  IntTools_MapOfCurveSample_2: typeof IntTools_MapOfCurveSample_2;
  IntTools_MapOfCurveSample_3: typeof IntTools_MapOfCurveSample_3;
  IntTools_SequenceOfCurves: typeof IntTools_SequenceOfCurves;
  IntTools_SequenceOfCurves_1: typeof IntTools_SequenceOfCurves_1;
  IntTools_SequenceOfCurves_2: typeof IntTools_SequenceOfCurves_2;
  IntTools_SequenceOfCurves_3: typeof IntTools_SequenceOfCurves_3;
  Handle_IntTools_TopolTool: typeof Handle_IntTools_TopolTool;
  Handle_IntTools_TopolTool_1: typeof Handle_IntTools_TopolTool_1;
  Handle_IntTools_TopolTool_2: typeof Handle_IntTools_TopolTool_2;
  Handle_IntTools_TopolTool_3: typeof Handle_IntTools_TopolTool_3;
  Handle_IntTools_TopolTool_4: typeof Handle_IntTools_TopolTool_4;
  IntTools_TopolTool: typeof IntTools_TopolTool;
  IntTools_TopolTool_1: typeof IntTools_TopolTool_1;
  IntTools_TopolTool_2: typeof IntTools_TopolTool_2;
  IntTools_CurveRangeSample: typeof IntTools_CurveRangeSample;
  IntTools_CurveRangeSample_1: typeof IntTools_CurveRangeSample_1;
  IntTools_CurveRangeSample_2: typeof IntTools_CurveRangeSample_2;
  IntTools_Array1OfRange: typeof IntTools_Array1OfRange;
  IntTools_Array1OfRange_1: typeof IntTools_Array1OfRange_1;
  IntTools_Array1OfRange_2: typeof IntTools_Array1OfRange_2;
  IntTools_Array1OfRange_3: typeof IntTools_Array1OfRange_3;
  IntTools_Array1OfRange_4: typeof IntTools_Array1OfRange_4;
  IntTools_Array1OfRange_5: typeof IntTools_Array1OfRange_5;
  IntTools_ShrunkRange: typeof IntTools_ShrunkRange;
  IntTools_FClass2d: typeof IntTools_FClass2d;
  IntTools_FClass2d_1: typeof IntTools_FClass2d_1;
  IntTools_FClass2d_2: typeof IntTools_FClass2d_2;
  IntTools_SequenceOfCommonPrts: typeof IntTools_SequenceOfCommonPrts;
  IntTools_SequenceOfCommonPrts_1: typeof IntTools_SequenceOfCommonPrts_1;
  IntTools_SequenceOfCommonPrts_2: typeof IntTools_SequenceOfCommonPrts_2;
  IntTools_SequenceOfCommonPrts_3: typeof IntTools_SequenceOfCommonPrts_3;
  IntTools_SurfaceRangeSample: typeof IntTools_SurfaceRangeSample;
  IntTools_SurfaceRangeSample_1: typeof IntTools_SurfaceRangeSample_1;
  IntTools_SurfaceRangeSample_2: typeof IntTools_SurfaceRangeSample_2;
  IntTools_SurfaceRangeSample_3: typeof IntTools_SurfaceRangeSample_3;
  IntTools_SurfaceRangeSample_4: typeof IntTools_SurfaceRangeSample_4;
  IntTools_Root: typeof IntTools_Root;
  IntTools_Root_1: typeof IntTools_Root_1;
  IntTools_Root_2: typeof IntTools_Root_2;
  IntTools_CArray1OfReal: typeof IntTools_CArray1OfReal;
  IntTools_CArray1OfReal_1: typeof IntTools_CArray1OfReal_1;
  IntTools_CArray1OfReal_2: typeof IntTools_CArray1OfReal_2;
  IntTools_CommonPrt: typeof IntTools_CommonPrt;
  IntTools_CommonPrt_1: typeof IntTools_CommonPrt_1;
  IntTools_CommonPrt_2: typeof IntTools_CommonPrt_2;
  IntTools_Curve: typeof IntTools_Curve;
  IntTools_Curve_1: typeof IntTools_Curve_1;
  IntTools_Curve_2: typeof IntTools_Curve_2;
  IntTools_BeanFaceIntersector: typeof IntTools_BeanFaceIntersector;
  IntTools_BeanFaceIntersector_1: typeof IntTools_BeanFaceIntersector_1;
  IntTools_BeanFaceIntersector_2: typeof IntTools_BeanFaceIntersector_2;
  IntTools_BeanFaceIntersector_3: typeof IntTools_BeanFaceIntersector_3;
  IntTools_BeanFaceIntersector_4: typeof IntTools_BeanFaceIntersector_4;
  IntTools_SequenceOfPntOn2Faces: typeof IntTools_SequenceOfPntOn2Faces;
  IntTools_SequenceOfPntOn2Faces_1: typeof IntTools_SequenceOfPntOn2Faces_1;
  IntTools_SequenceOfPntOn2Faces_2: typeof IntTools_SequenceOfPntOn2Faces_2;
  IntTools_SequenceOfPntOn2Faces_3: typeof IntTools_SequenceOfPntOn2Faces_3;
  IntTools_SequenceOfRanges: typeof IntTools_SequenceOfRanges;
  IntTools_SequenceOfRanges_1: typeof IntTools_SequenceOfRanges_1;
  IntTools_SequenceOfRanges_2: typeof IntTools_SequenceOfRanges_2;
  IntTools_SequenceOfRanges_3: typeof IntTools_SequenceOfRanges_3;
  IntTools_SurfaceRangeSampleMapHasher: typeof IntTools_SurfaceRangeSampleMapHasher;
  IntTools_ListOfBox: typeof IntTools_ListOfBox;
  IntTools_ListOfBox_1: typeof IntTools_ListOfBox_1;
  IntTools_ListOfBox_2: typeof IntTools_ListOfBox_2;
  IntTools_ListOfBox_3: typeof IntTools_ListOfBox_3;
  IntTools_Range: typeof IntTools_Range;
  IntTools_Range_1: typeof IntTools_Range_1;
  IntTools_Range_2: typeof IntTools_Range_2;
  IntTools_CArray1OfInteger: typeof IntTools_CArray1OfInteger;
  IntTools_CArray1OfInteger_1: typeof IntTools_CArray1OfInteger_1;
  IntTools_CArray1OfInteger_2: typeof IntTools_CArray1OfInteger_2;
  BinTools_CurveSet: typeof BinTools_CurveSet;
  BinTools_Curve2dSet: typeof BinTools_Curve2dSet;
  BinTools_ShapeSet: typeof BinTools_ShapeSet;
  BinTools: typeof BinTools;
  BinTools_LocationSet: typeof BinTools_LocationSet;
  BinTools_SurfaceSet: typeof BinTools_SurfaceSet;
  Plugin: typeof Plugin;
  Plugin_MapOfFunctions: typeof Plugin_MapOfFunctions;
  Plugin_MapOfFunctions_1: typeof Plugin_MapOfFunctions_1;
  Plugin_MapOfFunctions_2: typeof Plugin_MapOfFunctions_2;
  Plugin_MapOfFunctions_3: typeof Plugin_MapOfFunctions_3;
  Plugin_Failure: typeof Plugin_Failure;
  Plugin_Failure_1: typeof Plugin_Failure_1;
  Plugin_Failure_2: typeof Plugin_Failure_2;
  Handle_Plugin_Failure: typeof Handle_Plugin_Failure;
  Handle_Plugin_Failure_1: typeof Handle_Plugin_Failure_1;
  Handle_Plugin_Failure_2: typeof Handle_Plugin_Failure_2;
  Handle_Plugin_Failure_3: typeof Handle_Plugin_Failure_3;
  Handle_Plugin_Failure_4: typeof Handle_Plugin_Failure_4;
  Handle_Units_UnitsSystem: typeof Handle_Units_UnitsSystem;
  Handle_Units_UnitsSystem_1: typeof Handle_Units_UnitsSystem_1;
  Handle_Units_UnitsSystem_2: typeof Handle_Units_UnitsSystem_2;
  Handle_Units_UnitsSystem_3: typeof Handle_Units_UnitsSystem_3;
  Handle_Units_UnitsSystem_4: typeof Handle_Units_UnitsSystem_4;
  Units_UnitsSystem: typeof Units_UnitsSystem;
  Units_UnitsSystem_1: typeof Units_UnitsSystem_1;
  Units_UnitsSystem_2: typeof Units_UnitsSystem_2;
  Handle_Units_NoSuchType: typeof Handle_Units_NoSuchType;
  Handle_Units_NoSuchType_1: typeof Handle_Units_NoSuchType_1;
  Handle_Units_NoSuchType_2: typeof Handle_Units_NoSuchType_2;
  Handle_Units_NoSuchType_3: typeof Handle_Units_NoSuchType_3;
  Handle_Units_NoSuchType_4: typeof Handle_Units_NoSuchType_4;
  Units_NoSuchType: typeof Units_NoSuchType;
  Units_NoSuchType_1: typeof Units_NoSuchType_1;
  Units_NoSuchType_2: typeof Units_NoSuchType_2;
  Units_UnitSentence: typeof Units_UnitSentence;
  Units_UnitSentence_1: typeof Units_UnitSentence_1;
  Units_UnitSentence_2: typeof Units_UnitSentence_2;
  Handle_Units_Quantity: typeof Handle_Units_Quantity;
  Handle_Units_Quantity_1: typeof Handle_Units_Quantity_1;
  Handle_Units_Quantity_2: typeof Handle_Units_Quantity_2;
  Handle_Units_Quantity_3: typeof Handle_Units_Quantity_3;
  Handle_Units_Quantity_4: typeof Handle_Units_Quantity_4;
  Units_Quantity: typeof Units_Quantity;
  Handle_Units_QuantitiesSequence: typeof Handle_Units_QuantitiesSequence;
  Handle_Units_QuantitiesSequence_1: typeof Handle_Units_QuantitiesSequence_1;
  Handle_Units_QuantitiesSequence_2: typeof Handle_Units_QuantitiesSequence_2;
  Handle_Units_QuantitiesSequence_3: typeof Handle_Units_QuantitiesSequence_3;
  Handle_Units_QuantitiesSequence_4: typeof Handle_Units_QuantitiesSequence_4;
  Units_MathSentence: typeof Units_MathSentence;
  Handle_Units_Token: typeof Handle_Units_Token;
  Handle_Units_Token_1: typeof Handle_Units_Token_1;
  Handle_Units_Token_2: typeof Handle_Units_Token_2;
  Handle_Units_Token_3: typeof Handle_Units_Token_3;
  Handle_Units_Token_4: typeof Handle_Units_Token_4;
  Units_Token: typeof Units_Token;
  Units_Token_1: typeof Units_Token_1;
  Units_Token_2: typeof Units_Token_2;
  Units_Token_3: typeof Units_Token_3;
  Units_Token_4: typeof Units_Token_4;
  Units_Token_5: typeof Units_Token_5;
  Units_Token_6: typeof Units_Token_6;
  Handle_Units_TokensSequence: typeof Handle_Units_TokensSequence;
  Handle_Units_TokensSequence_1: typeof Handle_Units_TokensSequence_1;
  Handle_Units_TokensSequence_2: typeof Handle_Units_TokensSequence_2;
  Handle_Units_TokensSequence_3: typeof Handle_Units_TokensSequence_3;
  Handle_Units_TokensSequence_4: typeof Handle_Units_TokensSequence_4;
  Units_Sentence: typeof Units_Sentence;
  Handle_Units_ShiftedToken: typeof Handle_Units_ShiftedToken;
  Handle_Units_ShiftedToken_1: typeof Handle_Units_ShiftedToken_1;
  Handle_Units_ShiftedToken_2: typeof Handle_Units_ShiftedToken_2;
  Handle_Units_ShiftedToken_3: typeof Handle_Units_ShiftedToken_3;
  Handle_Units_ShiftedToken_4: typeof Handle_Units_ShiftedToken_4;
  Units_ShiftedToken: typeof Units_ShiftedToken;
  Handle_Units_UnitsSequence: typeof Handle_Units_UnitsSequence;
  Handle_Units_UnitsSequence_1: typeof Handle_Units_UnitsSequence_1;
  Handle_Units_UnitsSequence_2: typeof Handle_Units_UnitsSequence_2;
  Handle_Units_UnitsSequence_3: typeof Handle_Units_UnitsSequence_3;
  Handle_Units_UnitsSequence_4: typeof Handle_Units_UnitsSequence_4;
  Handle_Units_ShiftedUnit: typeof Handle_Units_ShiftedUnit;
  Handle_Units_ShiftedUnit_1: typeof Handle_Units_ShiftedUnit_1;
  Handle_Units_ShiftedUnit_2: typeof Handle_Units_ShiftedUnit_2;
  Handle_Units_ShiftedUnit_3: typeof Handle_Units_ShiftedUnit_3;
  Handle_Units_ShiftedUnit_4: typeof Handle_Units_ShiftedUnit_4;
  Units_ShiftedUnit: typeof Units_ShiftedUnit;
  Units_ShiftedUnit_1: typeof Units_ShiftedUnit_1;
  Units_ShiftedUnit_2: typeof Units_ShiftedUnit_2;
  Units_ShiftedUnit_3: typeof Units_ShiftedUnit_3;
  Units_Explorer: typeof Units_Explorer;
  Units_Explorer_1: typeof Units_Explorer_1;
  Units_Explorer_2: typeof Units_Explorer_2;
  Units_Explorer_3: typeof Units_Explorer_3;
  Units_Explorer_4: typeof Units_Explorer_4;
  Units_Explorer_5: typeof Units_Explorer_5;
  Handle_Units_Dimensions: typeof Handle_Units_Dimensions;
  Handle_Units_Dimensions_1: typeof Handle_Units_Dimensions_1;
  Handle_Units_Dimensions_2: typeof Handle_Units_Dimensions_2;
  Handle_Units_Dimensions_3: typeof Handle_Units_Dimensions_3;
  Handle_Units_Dimensions_4: typeof Handle_Units_Dimensions_4;
  Units_Dimensions: typeof Units_Dimensions;
  Units_NoSuchUnit: typeof Units_NoSuchUnit;
  Units_NoSuchUnit_1: typeof Units_NoSuchUnit_1;
  Units_NoSuchUnit_2: typeof Units_NoSuchUnit_2;
  Handle_Units_NoSuchUnit: typeof Handle_Units_NoSuchUnit;
  Handle_Units_NoSuchUnit_1: typeof Handle_Units_NoSuchUnit_1;
  Handle_Units_NoSuchUnit_2: typeof Handle_Units_NoSuchUnit_2;
  Handle_Units_NoSuchUnit_3: typeof Handle_Units_NoSuchUnit_3;
  Handle_Units_NoSuchUnit_4: typeof Handle_Units_NoSuchUnit_4;
  Handle_Units_UnitsLexicon: typeof Handle_Units_UnitsLexicon;
  Handle_Units_UnitsLexicon_1: typeof Handle_Units_UnitsLexicon_1;
  Handle_Units_UnitsLexicon_2: typeof Handle_Units_UnitsLexicon_2;
  Handle_Units_UnitsLexicon_3: typeof Handle_Units_UnitsLexicon_3;
  Handle_Units_UnitsLexicon_4: typeof Handle_Units_UnitsLexicon_4;
  Units_UnitsLexicon: typeof Units_UnitsLexicon;
  Handle_Units_Lexicon: typeof Handle_Units_Lexicon;
  Handle_Units_Lexicon_1: typeof Handle_Units_Lexicon_1;
  Handle_Units_Lexicon_2: typeof Handle_Units_Lexicon_2;
  Handle_Units_Lexicon_3: typeof Handle_Units_Lexicon_3;
  Handle_Units_Lexicon_4: typeof Handle_Units_Lexicon_4;
  Units_Lexicon: typeof Units_Lexicon;
  Units_UnitsDictionary: typeof Units_UnitsDictionary;
  Handle_Units_UnitsDictionary: typeof Handle_Units_UnitsDictionary;
  Handle_Units_UnitsDictionary_1: typeof Handle_Units_UnitsDictionary_1;
  Handle_Units_UnitsDictionary_2: typeof Handle_Units_UnitsDictionary_2;
  Handle_Units_UnitsDictionary_3: typeof Handle_Units_UnitsDictionary_3;
  Handle_Units_UnitsDictionary_4: typeof Handle_Units_UnitsDictionary_4;
  Units_Unit: typeof Units_Unit;
  Units_Unit_1: typeof Units_Unit_1;
  Units_Unit_2: typeof Units_Unit_2;
  Units_Unit_3: typeof Units_Unit_3;
  Handle_Units_Unit: typeof Handle_Units_Unit;
  Handle_Units_Unit_1: typeof Handle_Units_Unit_1;
  Handle_Units_Unit_2: typeof Handle_Units_Unit_2;
  Handle_Units_Unit_3: typeof Handle_Units_Unit_3;
  Handle_Units_Unit_4: typeof Handle_Units_Unit_4;
  Units_Measurement: typeof Units_Measurement;
  Units_Measurement_1: typeof Units_Measurement_1;
  Units_Measurement_2: typeof Units_Measurement_2;
  Units_Measurement_3: typeof Units_Measurement_3;
  Units: typeof Units;
  ShapeCustom_SweptToElementary: typeof ShapeCustom_SweptToElementary;
  Handle_ShapeCustom_SweptToElementary: typeof Handle_ShapeCustom_SweptToElementary;
  Handle_ShapeCustom_SweptToElementary_1: typeof Handle_ShapeCustom_SweptToElementary_1;
  Handle_ShapeCustom_SweptToElementary_2: typeof Handle_ShapeCustom_SweptToElementary_2;
  Handle_ShapeCustom_SweptToElementary_3: typeof Handle_ShapeCustom_SweptToElementary_3;
  Handle_ShapeCustom_SweptToElementary_4: typeof Handle_ShapeCustom_SweptToElementary_4;
  ShapeCustom_Curve: typeof ShapeCustom_Curve;
  ShapeCustom_Curve_1: typeof ShapeCustom_Curve_1;
  ShapeCustom_Curve_2: typeof ShapeCustom_Curve_2;
  Handle_ShapeCustom_ConvertToBSpline: typeof Handle_ShapeCustom_ConvertToBSpline;
  Handle_ShapeCustom_ConvertToBSpline_1: typeof Handle_ShapeCustom_ConvertToBSpline_1;
  Handle_ShapeCustom_ConvertToBSpline_2: typeof Handle_ShapeCustom_ConvertToBSpline_2;
  Handle_ShapeCustom_ConvertToBSpline_3: typeof Handle_ShapeCustom_ConvertToBSpline_3;
  Handle_ShapeCustom_ConvertToBSpline_4: typeof Handle_ShapeCustom_ConvertToBSpline_4;
  ShapeCustom_ConvertToBSpline: typeof ShapeCustom_ConvertToBSpline;
  Handle_ShapeCustom_ConvertToRevolution: typeof Handle_ShapeCustom_ConvertToRevolution;
  Handle_ShapeCustom_ConvertToRevolution_1: typeof Handle_ShapeCustom_ConvertToRevolution_1;
  Handle_ShapeCustom_ConvertToRevolution_2: typeof Handle_ShapeCustom_ConvertToRevolution_2;
  Handle_ShapeCustom_ConvertToRevolution_3: typeof Handle_ShapeCustom_ConvertToRevolution_3;
  Handle_ShapeCustom_ConvertToRevolution_4: typeof Handle_ShapeCustom_ConvertToRevolution_4;
  ShapeCustom_ConvertToRevolution: typeof ShapeCustom_ConvertToRevolution;
  Handle_ShapeCustom_RestrictionParameters: typeof Handle_ShapeCustom_RestrictionParameters;
  Handle_ShapeCustom_RestrictionParameters_1: typeof Handle_ShapeCustom_RestrictionParameters_1;
  Handle_ShapeCustom_RestrictionParameters_2: typeof Handle_ShapeCustom_RestrictionParameters_2;
  Handle_ShapeCustom_RestrictionParameters_3: typeof Handle_ShapeCustom_RestrictionParameters_3;
  Handle_ShapeCustom_RestrictionParameters_4: typeof Handle_ShapeCustom_RestrictionParameters_4;
  ShapeCustom_RestrictionParameters: typeof ShapeCustom_RestrictionParameters;
  ShapeCustom: typeof ShapeCustom;
  ShapeCustom_DirectModification: typeof ShapeCustom_DirectModification;
  Handle_ShapeCustom_DirectModification: typeof Handle_ShapeCustom_DirectModification;
  Handle_ShapeCustom_DirectModification_1: typeof Handle_ShapeCustom_DirectModification_1;
  Handle_ShapeCustom_DirectModification_2: typeof Handle_ShapeCustom_DirectModification_2;
  Handle_ShapeCustom_DirectModification_3: typeof Handle_ShapeCustom_DirectModification_3;
  Handle_ShapeCustom_DirectModification_4: typeof Handle_ShapeCustom_DirectModification_4;
  ShapeCustom_Modification: typeof ShapeCustom_Modification;
  Handle_ShapeCustom_Modification: typeof Handle_ShapeCustom_Modification;
  Handle_ShapeCustom_Modification_1: typeof Handle_ShapeCustom_Modification_1;
  Handle_ShapeCustom_Modification_2: typeof Handle_ShapeCustom_Modification_2;
  Handle_ShapeCustom_Modification_3: typeof Handle_ShapeCustom_Modification_3;
  Handle_ShapeCustom_Modification_4: typeof Handle_ShapeCustom_Modification_4;
  ShapeCustom_BSplineRestriction: typeof ShapeCustom_BSplineRestriction;
  ShapeCustom_BSplineRestriction_1: typeof ShapeCustom_BSplineRestriction_1;
  ShapeCustom_BSplineRestriction_2: typeof ShapeCustom_BSplineRestriction_2;
  ShapeCustom_BSplineRestriction_3: typeof ShapeCustom_BSplineRestriction_3;
  Handle_ShapeCustom_BSplineRestriction: typeof Handle_ShapeCustom_BSplineRestriction;
  Handle_ShapeCustom_BSplineRestriction_1: typeof Handle_ShapeCustom_BSplineRestriction_1;
  Handle_ShapeCustom_BSplineRestriction_2: typeof Handle_ShapeCustom_BSplineRestriction_2;
  Handle_ShapeCustom_BSplineRestriction_3: typeof Handle_ShapeCustom_BSplineRestriction_3;
  Handle_ShapeCustom_BSplineRestriction_4: typeof Handle_ShapeCustom_BSplineRestriction_4;
  ShapeCustom_TrsfModification: typeof ShapeCustom_TrsfModification;
  Handle_ShapeCustom_TrsfModification: typeof Handle_ShapeCustom_TrsfModification;
  Handle_ShapeCustom_TrsfModification_1: typeof Handle_ShapeCustom_TrsfModification_1;
  Handle_ShapeCustom_TrsfModification_2: typeof Handle_ShapeCustom_TrsfModification_2;
  Handle_ShapeCustom_TrsfModification_3: typeof Handle_ShapeCustom_TrsfModification_3;
  Handle_ShapeCustom_TrsfModification_4: typeof Handle_ShapeCustom_TrsfModification_4;
  ShapeCustom_Surface: typeof ShapeCustom_Surface;
  ShapeCustom_Surface_1: typeof ShapeCustom_Surface_1;
  ShapeCustom_Surface_2: typeof ShapeCustom_Surface_2;
  ShapeCustom_Curve2d: typeof ShapeCustom_Curve2d;
  BRepGProp_Face: typeof BRepGProp_Face;
  BRepGProp_Face_1: typeof BRepGProp_Face_1;
  BRepGProp_Face_2: typeof BRepGProp_Face_2;
  BRepGProp: typeof BRepGProp;
  BRepGProp_MeshCinert: typeof BRepGProp_MeshCinert;
  BRepGProp_Sinert: typeof BRepGProp_Sinert;
  BRepGProp_Sinert_1: typeof BRepGProp_Sinert_1;
  BRepGProp_Sinert_2: typeof BRepGProp_Sinert_2;
  BRepGProp_Sinert_3: typeof BRepGProp_Sinert_3;
  BRepGProp_Sinert_4: typeof BRepGProp_Sinert_4;
  BRepGProp_Sinert_5: typeof BRepGProp_Sinert_5;
  BRepGProp_Vinert: typeof BRepGProp_Vinert;
  BRepGProp_Vinert_1: typeof BRepGProp_Vinert_1;
  BRepGProp_Vinert_2: typeof BRepGProp_Vinert_2;
  BRepGProp_Vinert_3: typeof BRepGProp_Vinert_3;
  BRepGProp_Vinert_4: typeof BRepGProp_Vinert_4;
  BRepGProp_Vinert_5: typeof BRepGProp_Vinert_5;
  BRepGProp_Vinert_6: typeof BRepGProp_Vinert_6;
  BRepGProp_Vinert_7: typeof BRepGProp_Vinert_7;
  BRepGProp_Vinert_8: typeof BRepGProp_Vinert_8;
  BRepGProp_Vinert_9: typeof BRepGProp_Vinert_9;
  BRepGProp_Vinert_10: typeof BRepGProp_Vinert_10;
  BRepGProp_Vinert_11: typeof BRepGProp_Vinert_11;
  BRepGProp_Vinert_12: typeof BRepGProp_Vinert_12;
  BRepGProp_Vinert_13: typeof BRepGProp_Vinert_13;
  BRepGProp_MeshProps: typeof BRepGProp_MeshProps;
  BRepGProp_Domain: typeof BRepGProp_Domain;
  BRepGProp_Domain_1: typeof BRepGProp_Domain_1;
  BRepGProp_Domain_2: typeof BRepGProp_Domain_2;
  BRepGProp_Cinert: typeof BRepGProp_Cinert;
  BRepGProp_Cinert_1: typeof BRepGProp_Cinert_1;
  BRepGProp_Cinert_2: typeof BRepGProp_Cinert_2;
  BRepGProp_EdgeTool: typeof BRepGProp_EdgeTool;
  BRepGProp_TFunction: typeof BRepGProp_TFunction;
  BRepGProp_UFunction: typeof BRepGProp_UFunction;
  TopOpeBRepTool_IndexedDataMapOfShapeBox2d: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox2d;
  TopOpeBRepTool_IndexedDataMapOfShapeBox2d_1: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox2d_1;
  TopOpeBRepTool_IndexedDataMapOfShapeBox2d_2: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox2d_2;
  TopOpeBRepTool_IndexedDataMapOfShapeBox2d_3: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox2d_3;
  TopOpeBRepTool_ShapeTool: typeof TopOpeBRepTool_ShapeTool;
  TopOpeBRepTool_C2DF: typeof TopOpeBRepTool_C2DF;
  TopOpeBRepTool_C2DF_1: typeof TopOpeBRepTool_C2DF_1;
  TopOpeBRepTool_C2DF_2: typeof TopOpeBRepTool_C2DF_2;
  TopOpeBRepTool_FuseEdges: typeof TopOpeBRepTool_FuseEdges;
  TopOpeBRepTool_OutCurveType: TopOpeBRepTool_OutCurveType;
  TopOpeBRepTool_PurgeInternalEdges: typeof TopOpeBRepTool_PurgeInternalEdges;
  TopOpeBRepTool_DataMapOfOrientedShapeC2DF: typeof TopOpeBRepTool_DataMapOfOrientedShapeC2DF;
  TopOpeBRepTool_DataMapOfOrientedShapeC2DF_1: typeof TopOpeBRepTool_DataMapOfOrientedShapeC2DF_1;
  TopOpeBRepTool_DataMapOfOrientedShapeC2DF_2: typeof TopOpeBRepTool_DataMapOfOrientedShapeC2DF_2;
  TopOpeBRepTool_DataMapOfOrientedShapeC2DF_3: typeof TopOpeBRepTool_DataMapOfOrientedShapeC2DF_3;
  TopOpeBRepTool_DataMapOfShapeListOfC2DF: typeof TopOpeBRepTool_DataMapOfShapeListOfC2DF;
  TopOpeBRepTool_DataMapOfShapeListOfC2DF_1: typeof TopOpeBRepTool_DataMapOfShapeListOfC2DF_1;
  TopOpeBRepTool_DataMapOfShapeListOfC2DF_2: typeof TopOpeBRepTool_DataMapOfShapeListOfC2DF_2;
  TopOpeBRepTool_DataMapOfShapeListOfC2DF_3: typeof TopOpeBRepTool_DataMapOfShapeListOfC2DF_3;
  TopOpeBRepTool_ShapeClassifier: typeof TopOpeBRepTool_ShapeClassifier;
  TopOpeBRepTool_ShapeClassifier_1: typeof TopOpeBRepTool_ShapeClassifier_1;
  TopOpeBRepTool_ShapeClassifier_2: typeof TopOpeBRepTool_ShapeClassifier_2;
  TopOpeBRepTool_connexity: typeof TopOpeBRepTool_connexity;
  TopOpeBRepTool_connexity_1: typeof TopOpeBRepTool_connexity_1;
  TopOpeBRepTool_connexity_2: typeof TopOpeBRepTool_connexity_2;
  TopOpeBRepTool_SolidClassifier: typeof TopOpeBRepTool_SolidClassifier;
  TopOpeBRepTool_DataMapOfShapeface: typeof TopOpeBRepTool_DataMapOfShapeface;
  TopOpeBRepTool_DataMapOfShapeface_1: typeof TopOpeBRepTool_DataMapOfShapeface_1;
  TopOpeBRepTool_DataMapOfShapeface_2: typeof TopOpeBRepTool_DataMapOfShapeface_2;
  TopOpeBRepTool_DataMapOfShapeface_3: typeof TopOpeBRepTool_DataMapOfShapeface_3;
  TopOpeBRepTool_face: typeof TopOpeBRepTool_face;
  TopOpeBRepTool_CLASSI: typeof TopOpeBRepTool_CLASSI;
  TopOpeBRepTool_AncestorsTool: typeof TopOpeBRepTool_AncestorsTool;
  TopOpeBRepTool_TOOL: typeof TopOpeBRepTool_TOOL;
  TopOpeBRepTool_CORRISO: typeof TopOpeBRepTool_CORRISO;
  TopOpeBRepTool_CORRISO_1: typeof TopOpeBRepTool_CORRISO_1;
  TopOpeBRepTool_CORRISO_2: typeof TopOpeBRepTool_CORRISO_2;
  TopOpeBRepTool_BoxSort: typeof TopOpeBRepTool_BoxSort;
  TopOpeBRepTool_BoxSort_1: typeof TopOpeBRepTool_BoxSort_1;
  TopOpeBRepTool_BoxSort_2: typeof TopOpeBRepTool_BoxSort_2;
  TopOpeBRepTool_REGUS: typeof TopOpeBRepTool_REGUS;
  TopOpeBRepTool_GeomTool: typeof TopOpeBRepTool_GeomTool;
  TopOpeBRepTool_CurveTool: typeof TopOpeBRepTool_CurveTool;
  TopOpeBRepTool_CurveTool_1: typeof TopOpeBRepTool_CurveTool_1;
  TopOpeBRepTool_CurveTool_2: typeof TopOpeBRepTool_CurveTool_2;
  TopOpeBRepTool_CurveTool_3: typeof TopOpeBRepTool_CurveTool_3;
  TopOpeBRepTool_mkTondgE: typeof TopOpeBRepTool_mkTondgE;
  TopOpeBRepTool_IndexedDataMapOfShapeBox: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox;
  TopOpeBRepTool_IndexedDataMapOfShapeBox_1: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox_1;
  TopOpeBRepTool_IndexedDataMapOfShapeBox_2: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox_2;
  TopOpeBRepTool_IndexedDataMapOfShapeBox_3: typeof TopOpeBRepTool_IndexedDataMapOfShapeBox_3;
  TopOpeBRepTool_ShapeExplorer: typeof TopOpeBRepTool_ShapeExplorer;
  TopOpeBRepTool_ShapeExplorer_1: typeof TopOpeBRepTool_ShapeExplorer_1;
  TopOpeBRepTool_ShapeExplorer_2: typeof TopOpeBRepTool_ShapeExplorer_2;
  TopOpeBRepTool_makeTransition: typeof TopOpeBRepTool_makeTransition;
  TopOpeBRepTool_REGUW: typeof TopOpeBRepTool_REGUW;
  TopOpeBRepTool_IndexedDataMapOfShapeconnexity: typeof TopOpeBRepTool_IndexedDataMapOfShapeconnexity;
  TopOpeBRepTool_IndexedDataMapOfShapeconnexity_1: typeof TopOpeBRepTool_IndexedDataMapOfShapeconnexity_1;
  TopOpeBRepTool_IndexedDataMapOfShapeconnexity_2: typeof TopOpeBRepTool_IndexedDataMapOfShapeconnexity_2;
  TopOpeBRepTool_IndexedDataMapOfShapeconnexity_3: typeof TopOpeBRepTool_IndexedDataMapOfShapeconnexity_3;
  TopOpeBRepTool_ListOfC2DF: typeof TopOpeBRepTool_ListOfC2DF;
  TopOpeBRepTool_ListOfC2DF_1: typeof TopOpeBRepTool_ListOfC2DF_1;
  TopOpeBRepTool_ListOfC2DF_2: typeof TopOpeBRepTool_ListOfC2DF_2;
  TopOpeBRepTool_ListOfC2DF_3: typeof TopOpeBRepTool_ListOfC2DF_3;
  TopOpeBRepTool: typeof TopOpeBRepTool;
  TopOpeBRepTool_HBoxTool: typeof TopOpeBRepTool_HBoxTool;
  Handle_TopOpeBRepTool_HBoxTool: typeof Handle_TopOpeBRepTool_HBoxTool;
  Handle_TopOpeBRepTool_HBoxTool_1: typeof Handle_TopOpeBRepTool_HBoxTool_1;
  Handle_TopOpeBRepTool_HBoxTool_2: typeof Handle_TopOpeBRepTool_HBoxTool_2;
  Handle_TopOpeBRepTool_HBoxTool_3: typeof Handle_TopOpeBRepTool_HBoxTool_3;
  Handle_TopOpeBRepTool_HBoxTool_4: typeof Handle_TopOpeBRepTool_HBoxTool_4;
  Handle_StepData_GeneralModule: typeof Handle_StepData_GeneralModule;
  Handle_StepData_GeneralModule_1: typeof Handle_StepData_GeneralModule_1;
  Handle_StepData_GeneralModule_2: typeof Handle_StepData_GeneralModule_2;
  Handle_StepData_GeneralModule_3: typeof Handle_StepData_GeneralModule_3;
  Handle_StepData_GeneralModule_4: typeof Handle_StepData_GeneralModule_4;
  StepData_SelectType: typeof StepData_SelectType;
  StepData_ReadWriteModule: typeof StepData_ReadWriteModule;
  Handle_StepData_ReadWriteModule: typeof Handle_StepData_ReadWriteModule;
  Handle_StepData_ReadWriteModule_1: typeof Handle_StepData_ReadWriteModule_1;
  Handle_StepData_ReadWriteModule_2: typeof Handle_StepData_ReadWriteModule_2;
  Handle_StepData_ReadWriteModule_3: typeof Handle_StepData_ReadWriteModule_3;
  Handle_StepData_ReadWriteModule_4: typeof Handle_StepData_ReadWriteModule_4;
  StepData_FieldList: typeof StepData_FieldList;
  StepData_StepModel: typeof StepData_StepModel;
  Handle_StepData_StepModel: typeof Handle_StepData_StepModel;
  Handle_StepData_StepModel_1: typeof Handle_StepData_StepModel_1;
  Handle_StepData_StepModel_2: typeof Handle_StepData_StepModel_2;
  Handle_StepData_StepModel_3: typeof Handle_StepData_StepModel_3;
  Handle_StepData_StepModel_4: typeof Handle_StepData_StepModel_4;
  StepData_Field: typeof StepData_Field;
  StepData_Field_1: typeof StepData_Field_1;
  StepData_Field_2: typeof StepData_Field_2;
  Handle_StepData_GlobalNodeOfWriterLib: typeof Handle_StepData_GlobalNodeOfWriterLib;
  Handle_StepData_GlobalNodeOfWriterLib_1: typeof Handle_StepData_GlobalNodeOfWriterLib_1;
  Handle_StepData_GlobalNodeOfWriterLib_2: typeof Handle_StepData_GlobalNodeOfWriterLib_2;
  Handle_StepData_GlobalNodeOfWriterLib_3: typeof Handle_StepData_GlobalNodeOfWriterLib_3;
  Handle_StepData_GlobalNodeOfWriterLib_4: typeof Handle_StepData_GlobalNodeOfWriterLib_4;
  StepData_GlobalNodeOfWriterLib: typeof StepData_GlobalNodeOfWriterLib;
  Handle_StepData_Described: typeof Handle_StepData_Described;
  Handle_StepData_Described_1: typeof Handle_StepData_Described_1;
  Handle_StepData_Described_2: typeof Handle_StepData_Described_2;
  Handle_StepData_Described_3: typeof Handle_StepData_Described_3;
  Handle_StepData_Described_4: typeof Handle_StepData_Described_4;
  StepData_Described: typeof StepData_Described;
  StepData_FieldListN: typeof StepData_FieldListN;
  StepData_FieldListD: typeof StepData_FieldListD;
  StepData_PDescr: typeof StepData_PDescr;
  Handle_StepData_PDescr: typeof Handle_StepData_PDescr;
  Handle_StepData_PDescr_1: typeof Handle_StepData_PDescr_1;
  Handle_StepData_PDescr_2: typeof Handle_StepData_PDescr_2;
  Handle_StepData_PDescr_3: typeof Handle_StepData_PDescr_3;
  Handle_StepData_PDescr_4: typeof Handle_StepData_PDescr_4;
  StepData_FieldList1: typeof StepData_FieldList1;
  Handle_StepData_ECDescr: typeof Handle_StepData_ECDescr;
  Handle_StepData_ECDescr_1: typeof Handle_StepData_ECDescr_1;
  Handle_StepData_ECDescr_2: typeof Handle_StepData_ECDescr_2;
  Handle_StepData_ECDescr_3: typeof Handle_StepData_ECDescr_3;
  Handle_StepData_ECDescr_4: typeof Handle_StepData_ECDescr_4;
  StepData_ECDescr: typeof StepData_ECDescr;
  Handle_StepData_FreeFormEntity: typeof Handle_StepData_FreeFormEntity;
  Handle_StepData_FreeFormEntity_1: typeof Handle_StepData_FreeFormEntity_1;
  Handle_StepData_FreeFormEntity_2: typeof Handle_StepData_FreeFormEntity_2;
  Handle_StepData_FreeFormEntity_3: typeof Handle_StepData_FreeFormEntity_3;
  Handle_StepData_FreeFormEntity_4: typeof Handle_StepData_FreeFormEntity_4;
  StepData_Array1OfField: typeof StepData_Array1OfField;
  StepData_Array1OfField_1: typeof StepData_Array1OfField_1;
  StepData_Array1OfField_2: typeof StepData_Array1OfField_2;
  StepData_Array1OfField_3: typeof StepData_Array1OfField_3;
  StepData_Array1OfField_4: typeof StepData_Array1OfField_4;
  StepData_Array1OfField_5: typeof StepData_Array1OfField_5;
  StepData_StepReaderTool: typeof StepData_StepReaderTool;
  Handle_StepData_SelectInt: typeof Handle_StepData_SelectInt;
  Handle_StepData_SelectInt_1: typeof Handle_StepData_SelectInt_1;
  Handle_StepData_SelectInt_2: typeof Handle_StepData_SelectInt_2;
  Handle_StepData_SelectInt_3: typeof Handle_StepData_SelectInt_3;
  Handle_StepData_SelectInt_4: typeof Handle_StepData_SelectInt_4;
  StepData_SelectInt: typeof StepData_SelectInt;
  Handle_StepData_ESDescr: typeof Handle_StepData_ESDescr;
  Handle_StepData_ESDescr_1: typeof Handle_StepData_ESDescr_1;
  Handle_StepData_ESDescr_2: typeof Handle_StepData_ESDescr_2;
  Handle_StepData_ESDescr_3: typeof Handle_StepData_ESDescr_3;
  Handle_StepData_ESDescr_4: typeof Handle_StepData_ESDescr_4;
  StepData_ESDescr: typeof StepData_ESDescr;
  Handle_StepData_EDescr: typeof Handle_StepData_EDescr;
  Handle_StepData_EDescr_1: typeof Handle_StepData_EDescr_1;
  Handle_StepData_EDescr_2: typeof Handle_StepData_EDescr_2;
  Handle_StepData_EDescr_3: typeof Handle_StepData_EDescr_3;
  Handle_StepData_EDescr_4: typeof Handle_StepData_EDescr_4;
  StepData_EDescr: typeof StepData_EDescr;
  Handle_StepData_SelectArrReal: typeof Handle_StepData_SelectArrReal;
  Handle_StepData_SelectArrReal_1: typeof Handle_StepData_SelectArrReal_1;
  Handle_StepData_SelectArrReal_2: typeof Handle_StepData_SelectArrReal_2;
  Handle_StepData_SelectArrReal_3: typeof Handle_StepData_SelectArrReal_3;
  Handle_StepData_SelectArrReal_4: typeof Handle_StepData_SelectArrReal_4;
  StepData_SelectArrReal: typeof StepData_SelectArrReal;
  StepData_Simple: typeof StepData_Simple;
  Handle_StepData_Simple: typeof Handle_StepData_Simple;
  Handle_StepData_Simple_1: typeof Handle_StepData_Simple_1;
  Handle_StepData_Simple_2: typeof Handle_StepData_Simple_2;
  Handle_StepData_Simple_3: typeof Handle_StepData_Simple_3;
  Handle_StepData_Simple_4: typeof Handle_StepData_Simple_4;
  StepData_FileRecognizer: typeof StepData_FileRecognizer;
  Handle_StepData_FileRecognizer: typeof Handle_StepData_FileRecognizer;
  Handle_StepData_FileRecognizer_1: typeof Handle_StepData_FileRecognizer_1;
  Handle_StepData_FileRecognizer_2: typeof Handle_StepData_FileRecognizer_2;
  Handle_StepData_FileRecognizer_3: typeof Handle_StepData_FileRecognizer_3;
  Handle_StepData_FileRecognizer_4: typeof Handle_StepData_FileRecognizer_4;
  Handle_StepData_StepReaderData: typeof Handle_StepData_StepReaderData;
  Handle_StepData_StepReaderData_1: typeof Handle_StepData_StepReaderData_1;
  Handle_StepData_StepReaderData_2: typeof Handle_StepData_StepReaderData_2;
  Handle_StepData_StepReaderData_3: typeof Handle_StepData_StepReaderData_3;
  Handle_StepData_StepReaderData_4: typeof Handle_StepData_StepReaderData_4;
  StepData_StepReaderData: typeof StepData_StepReaderData;
  Handle_StepData_HArray1OfField: typeof Handle_StepData_HArray1OfField;
  Handle_StepData_HArray1OfField_1: typeof Handle_StepData_HArray1OfField_1;
  Handle_StepData_HArray1OfField_2: typeof Handle_StepData_HArray1OfField_2;
  Handle_StepData_HArray1OfField_3: typeof Handle_StepData_HArray1OfField_3;
  Handle_StepData_HArray1OfField_4: typeof Handle_StepData_HArray1OfField_4;
  Handle_StepData_Plex: typeof Handle_StepData_Plex;
  Handle_StepData_Plex_1: typeof Handle_StepData_Plex_1;
  Handle_StepData_Plex_2: typeof Handle_StepData_Plex_2;
  Handle_StepData_Plex_3: typeof Handle_StepData_Plex_3;
  Handle_StepData_Plex_4: typeof Handle_StepData_Plex_4;
  StepData_Plex: typeof StepData_Plex;
  StepData_FileProtocol: typeof StepData_FileProtocol;
  Handle_StepData_FileProtocol: typeof Handle_StepData_FileProtocol;
  Handle_StepData_FileProtocol_1: typeof Handle_StepData_FileProtocol_1;
  Handle_StepData_FileProtocol_2: typeof Handle_StepData_FileProtocol_2;
  Handle_StepData_FileProtocol_3: typeof Handle_StepData_FileProtocol_3;
  Handle_StepData_FileProtocol_4: typeof Handle_StepData_FileProtocol_4;
  StepData_StepDumper: typeof StepData_StepDumper;
  StepData_SelectNamed: typeof StepData_SelectNamed;
  Handle_StepData_SelectNamed: typeof Handle_StepData_SelectNamed;
  Handle_StepData_SelectNamed_1: typeof Handle_StepData_SelectNamed_1;
  Handle_StepData_SelectNamed_2: typeof Handle_StepData_SelectNamed_2;
  Handle_StepData_SelectNamed_3: typeof Handle_StepData_SelectNamed_3;
  Handle_StepData_SelectNamed_4: typeof Handle_StepData_SelectNamed_4;
  StepData_EnumTool: typeof StepData_EnumTool;
  StepData_Logical: StepData_Logical;
  StepData_Protocol: typeof StepData_Protocol;
  Handle_StepData_Protocol: typeof Handle_StepData_Protocol;
  Handle_StepData_Protocol_1: typeof Handle_StepData_Protocol_1;
  Handle_StepData_Protocol_2: typeof Handle_StepData_Protocol_2;
  Handle_StepData_Protocol_3: typeof Handle_StepData_Protocol_3;
  Handle_StepData_Protocol_4: typeof Handle_StepData_Protocol_4;
  StepData_StepWriter: typeof StepData_StepWriter;
  Handle_StepData_DefaultGeneral: typeof Handle_StepData_DefaultGeneral;
  Handle_StepData_DefaultGeneral_1: typeof Handle_StepData_DefaultGeneral_1;
  Handle_StepData_DefaultGeneral_2: typeof Handle_StepData_DefaultGeneral_2;
  Handle_StepData_DefaultGeneral_3: typeof Handle_StepData_DefaultGeneral_3;
  Handle_StepData_DefaultGeneral_4: typeof Handle_StepData_DefaultGeneral_4;
  Handle_StepData_UndefinedEntity: typeof Handle_StepData_UndefinedEntity;
  Handle_StepData_UndefinedEntity_1: typeof Handle_StepData_UndefinedEntity_1;
  Handle_StepData_UndefinedEntity_2: typeof Handle_StepData_UndefinedEntity_2;
  Handle_StepData_UndefinedEntity_3: typeof Handle_StepData_UndefinedEntity_3;
  Handle_StepData_UndefinedEntity_4: typeof Handle_StepData_UndefinedEntity_4;
  Handle_StepData_NodeOfWriterLib: typeof Handle_StepData_NodeOfWriterLib;
  Handle_StepData_NodeOfWriterLib_1: typeof Handle_StepData_NodeOfWriterLib_1;
  Handle_StepData_NodeOfWriterLib_2: typeof Handle_StepData_NodeOfWriterLib_2;
  Handle_StepData_NodeOfWriterLib_3: typeof Handle_StepData_NodeOfWriterLib_3;
  Handle_StepData_NodeOfWriterLib_4: typeof Handle_StepData_NodeOfWriterLib_4;
  StepData_NodeOfWriterLib: typeof StepData_NodeOfWriterLib;
  StepData: typeof StepData;
  StepData_WriterLib: typeof StepData_WriterLib;
  StepData_WriterLib_1: typeof StepData_WriterLib_1;
  StepData_WriterLib_2: typeof StepData_WriterLib_2;
  Handle_StepData_SelectReal: typeof Handle_StepData_SelectReal;
  Handle_StepData_SelectReal_1: typeof Handle_StepData_SelectReal_1;
  Handle_StepData_SelectReal_2: typeof Handle_StepData_SelectReal_2;
  Handle_StepData_SelectReal_3: typeof Handle_StepData_SelectReal_3;
  Handle_StepData_SelectReal_4: typeof Handle_StepData_SelectReal_4;
  StepData_SelectReal: typeof StepData_SelectReal;
  StepData_SelectMember: typeof StepData_SelectMember;
  Handle_StepData_SelectMember: typeof Handle_StepData_SelectMember;
  Handle_StepData_SelectMember_1: typeof Handle_StepData_SelectMember_1;
  Handle_StepData_SelectMember_2: typeof Handle_StepData_SelectMember_2;
  Handle_StepData_SelectMember_3: typeof Handle_StepData_SelectMember_3;
  Handle_StepData_SelectMember_4: typeof Handle_StepData_SelectMember_4;
  Adaptor3d_CurveOnSurface: typeof Adaptor3d_CurveOnSurface;
  Adaptor3d_CurveOnSurface_1: typeof Adaptor3d_CurveOnSurface_1;
  Adaptor3d_CurveOnSurface_2: typeof Adaptor3d_CurveOnSurface_2;
  Adaptor3d_CurveOnSurface_3: typeof Adaptor3d_CurveOnSurface_3;
  Adaptor3d_HSurfaceTool: typeof Adaptor3d_HSurfaceTool;
  Adaptor3d_HCurve: typeof Adaptor3d_HCurve;
  Handle_Adaptor3d_HCurve: typeof Handle_Adaptor3d_HCurve;
  Handle_Adaptor3d_HCurve_1: typeof Handle_Adaptor3d_HCurve_1;
  Handle_Adaptor3d_HCurve_2: typeof Handle_Adaptor3d_HCurve_2;
  Handle_Adaptor3d_HCurve_3: typeof Handle_Adaptor3d_HCurve_3;
  Handle_Adaptor3d_HCurve_4: typeof Handle_Adaptor3d_HCurve_4;
  Adaptor3d_Surface: typeof Adaptor3d_Surface;
  Adaptor3d_Curve: typeof Adaptor3d_Curve;
  Handle_Adaptor3d_HSurface: typeof Handle_Adaptor3d_HSurface;
  Handle_Adaptor3d_HSurface_1: typeof Handle_Adaptor3d_HSurface_1;
  Handle_Adaptor3d_HSurface_2: typeof Handle_Adaptor3d_HSurface_2;
  Handle_Adaptor3d_HSurface_3: typeof Handle_Adaptor3d_HSurface_3;
  Handle_Adaptor3d_HSurface_4: typeof Handle_Adaptor3d_HSurface_4;
  Adaptor3d_HSurface: typeof Adaptor3d_HSurface;
  Handle_Adaptor3d_TopolTool: typeof Handle_Adaptor3d_TopolTool;
  Handle_Adaptor3d_TopolTool_1: typeof Handle_Adaptor3d_TopolTool_1;
  Handle_Adaptor3d_TopolTool_2: typeof Handle_Adaptor3d_TopolTool_2;
  Handle_Adaptor3d_TopolTool_3: typeof Handle_Adaptor3d_TopolTool_3;
  Handle_Adaptor3d_TopolTool_4: typeof Handle_Adaptor3d_TopolTool_4;
  Adaptor3d_TopolTool: typeof Adaptor3d_TopolTool;
  Adaptor3d_TopolTool_1: typeof Adaptor3d_TopolTool_1;
  Adaptor3d_TopolTool_2: typeof Adaptor3d_TopolTool_2;
  Adaptor3d_HVertex: typeof Adaptor3d_HVertex;
  Adaptor3d_HVertex_1: typeof Adaptor3d_HVertex_1;
  Adaptor3d_HVertex_2: typeof Adaptor3d_HVertex_2;
  Handle_Adaptor3d_HVertex: typeof Handle_Adaptor3d_HVertex;
  Handle_Adaptor3d_HVertex_1: typeof Handle_Adaptor3d_HVertex_1;
  Handle_Adaptor3d_HVertex_2: typeof Handle_Adaptor3d_HVertex_2;
  Handle_Adaptor3d_HVertex_3: typeof Handle_Adaptor3d_HVertex_3;
  Handle_Adaptor3d_HVertex_4: typeof Handle_Adaptor3d_HVertex_4;
  Adaptor3d_HCurveOnSurface: typeof Adaptor3d_HCurveOnSurface;
  Adaptor3d_HCurveOnSurface_1: typeof Adaptor3d_HCurveOnSurface_1;
  Adaptor3d_HCurveOnSurface_2: typeof Adaptor3d_HCurveOnSurface_2;
  Handle_Adaptor3d_HCurveOnSurface: typeof Handle_Adaptor3d_HCurveOnSurface;
  Handle_Adaptor3d_HCurveOnSurface_1: typeof Handle_Adaptor3d_HCurveOnSurface_1;
  Handle_Adaptor3d_HCurveOnSurface_2: typeof Handle_Adaptor3d_HCurveOnSurface_2;
  Handle_Adaptor3d_HCurveOnSurface_3: typeof Handle_Adaptor3d_HCurveOnSurface_3;
  Handle_Adaptor3d_HCurveOnSurface_4: typeof Handle_Adaptor3d_HCurveOnSurface_4;
  Adaptor3d_InterFunc: typeof Adaptor3d_InterFunc;
  Handle_Adaptor3d_HIsoCurve: typeof Handle_Adaptor3d_HIsoCurve;
  Handle_Adaptor3d_HIsoCurve_1: typeof Handle_Adaptor3d_HIsoCurve_1;
  Handle_Adaptor3d_HIsoCurve_2: typeof Handle_Adaptor3d_HIsoCurve_2;
  Handle_Adaptor3d_HIsoCurve_3: typeof Handle_Adaptor3d_HIsoCurve_3;
  Handle_Adaptor3d_HIsoCurve_4: typeof Handle_Adaptor3d_HIsoCurve_4;
  Adaptor3d_HIsoCurve: typeof Adaptor3d_HIsoCurve;
  Adaptor3d_HIsoCurve_1: typeof Adaptor3d_HIsoCurve_1;
  Adaptor3d_HIsoCurve_2: typeof Adaptor3d_HIsoCurve_2;
  Adaptor3d_IsoCurve: typeof Adaptor3d_IsoCurve;
  Adaptor3d_IsoCurve_1: typeof Adaptor3d_IsoCurve_1;
  Adaptor3d_IsoCurve_2: typeof Adaptor3d_IsoCurve_2;
  Adaptor3d_IsoCurve_3: typeof Adaptor3d_IsoCurve_3;
  Adaptor3d_IsoCurve_4: typeof Adaptor3d_IsoCurve_4;
  Vrml_ShapeHints: typeof Vrml_ShapeHints;
  Handle_Vrml_IndexedLineSet: typeof Handle_Vrml_IndexedLineSet;
  Handle_Vrml_IndexedLineSet_1: typeof Handle_Vrml_IndexedLineSet_1;
  Handle_Vrml_IndexedLineSet_2: typeof Handle_Vrml_IndexedLineSet_2;
  Handle_Vrml_IndexedLineSet_3: typeof Handle_Vrml_IndexedLineSet_3;
  Handle_Vrml_IndexedLineSet_4: typeof Handle_Vrml_IndexedLineSet_4;
  Vrml_IndexedLineSet: typeof Vrml_IndexedLineSet;
  Vrml_IndexedLineSet_1: typeof Vrml_IndexedLineSet_1;
  Vrml_IndexedLineSet_2: typeof Vrml_IndexedLineSet_2;
  Vrml_Switch: typeof Vrml_Switch;
  Vrml_MaterialBindingAndNormalBinding: Vrml_MaterialBindingAndNormalBinding;
  Vrml_Info: typeof Vrml_Info;
  Vrml_SeparatorRenderCulling: Vrml_SeparatorRenderCulling;
  Vrml_PointLight: typeof Vrml_PointLight;
  Vrml_PointLight_1: typeof Vrml_PointLight_1;
  Vrml_PointLight_2: typeof Vrml_PointLight_2;
  Vrml_VertexOrdering: Vrml_VertexOrdering;
  Vrml_SFImageNumber: Vrml_SFImageNumber;
  Vrml_AsciiTextJustification: Vrml_AsciiTextJustification;
  Vrml_DirectionalLight: typeof Vrml_DirectionalLight;
  Vrml_DirectionalLight_1: typeof Vrml_DirectionalLight_1;
  Vrml_DirectionalLight_2: typeof Vrml_DirectionalLight_2;
  Vrml: typeof Vrml;
  Vrml_ConeParts: Vrml_ConeParts;
  Vrml_Cube: typeof Vrml_Cube;
  Vrml_Scale: typeof Vrml_Scale;
  Vrml_Scale_1: typeof Vrml_Scale_1;
  Vrml_Scale_2: typeof Vrml_Scale_2;
  Vrml_PerspectiveCamera: typeof Vrml_PerspectiveCamera;
  Vrml_PerspectiveCamera_1: typeof Vrml_PerspectiveCamera_1;
  Vrml_PerspectiveCamera_2: typeof Vrml_PerspectiveCamera_2;
  Vrml_Transform: typeof Vrml_Transform;
  Vrml_Transform_1: typeof Vrml_Transform_1;
  Vrml_Transform_2: typeof Vrml_Transform_2;
  Vrml_Texture2Transform: typeof Vrml_Texture2Transform;
  Vrml_Texture2Transform_1: typeof Vrml_Texture2Transform_1;
  Vrml_Texture2Transform_2: typeof Vrml_Texture2Transform_2;
  Vrml_FontStyleFamily: Vrml_FontStyleFamily;
  Vrml_Group: typeof Vrml_Group;
  Vrml_OrthographicCamera: typeof Vrml_OrthographicCamera;
  Vrml_OrthographicCamera_1: typeof Vrml_OrthographicCamera_1;
  Vrml_OrthographicCamera_2: typeof Vrml_OrthographicCamera_2;
  Handle_Vrml_TextureCoordinate2: typeof Handle_Vrml_TextureCoordinate2;
  Handle_Vrml_TextureCoordinate2_1: typeof Handle_Vrml_TextureCoordinate2_1;
  Handle_Vrml_TextureCoordinate2_2: typeof Handle_Vrml_TextureCoordinate2_2;
  Handle_Vrml_TextureCoordinate2_3: typeof Handle_Vrml_TextureCoordinate2_3;
  Handle_Vrml_TextureCoordinate2_4: typeof Handle_Vrml_TextureCoordinate2_4;
  Vrml_TextureCoordinate2: typeof Vrml_TextureCoordinate2;
  Vrml_TextureCoordinate2_1: typeof Vrml_TextureCoordinate2_1;
  Vrml_TextureCoordinate2_2: typeof Vrml_TextureCoordinate2_2;
  Vrml_Texture2Wrap: Vrml_Texture2Wrap;
  Vrml_LOD: typeof Vrml_LOD;
  Vrml_LOD_1: typeof Vrml_LOD_1;
  Vrml_LOD_2: typeof Vrml_LOD_2;
  Handle_Vrml_LOD: typeof Handle_Vrml_LOD;
  Handle_Vrml_LOD_1: typeof Handle_Vrml_LOD_1;
  Handle_Vrml_LOD_2: typeof Handle_Vrml_LOD_2;
  Handle_Vrml_LOD_3: typeof Handle_Vrml_LOD_3;
  Handle_Vrml_LOD_4: typeof Handle_Vrml_LOD_4;
  Vrml_FaceType: Vrml_FaceType;
  Vrml_PointSet: typeof Vrml_PointSet;
  Vrml_Material: typeof Vrml_Material;
  Vrml_Material_1: typeof Vrml_Material_1;
  Vrml_Material_2: typeof Vrml_Material_2;
  Handle_Vrml_Material: typeof Handle_Vrml_Material;
  Handle_Vrml_Material_1: typeof Handle_Vrml_Material_1;
  Handle_Vrml_Material_2: typeof Handle_Vrml_Material_2;
  Handle_Vrml_Material_3: typeof Handle_Vrml_Material_3;
  Handle_Vrml_Material_4: typeof Handle_Vrml_Material_4;
  Vrml_WWWInline: typeof Vrml_WWWInline;
  Vrml_WWWInline_1: typeof Vrml_WWWInline_1;
  Vrml_WWWInline_2: typeof Vrml_WWWInline_2;
  Handle_Vrml_Coordinate3: typeof Handle_Vrml_Coordinate3;
  Handle_Vrml_Coordinate3_1: typeof Handle_Vrml_Coordinate3_1;
  Handle_Vrml_Coordinate3_2: typeof Handle_Vrml_Coordinate3_2;
  Handle_Vrml_Coordinate3_3: typeof Handle_Vrml_Coordinate3_3;
  Handle_Vrml_Coordinate3_4: typeof Handle_Vrml_Coordinate3_4;
  Vrml_Coordinate3: typeof Vrml_Coordinate3;
  Vrml_Coordinate3_1: typeof Vrml_Coordinate3_1;
  Vrml_Coordinate3_2: typeof Vrml_Coordinate3_2;
  Vrml_ShapeType: Vrml_ShapeType;
  Vrml_MaterialBinding: typeof Vrml_MaterialBinding;
  Vrml_MaterialBinding_1: typeof Vrml_MaterialBinding_1;
  Vrml_MaterialBinding_2: typeof Vrml_MaterialBinding_2;
  Handle_Vrml_IndexedFaceSet: typeof Handle_Vrml_IndexedFaceSet;
  Handle_Vrml_IndexedFaceSet_1: typeof Handle_Vrml_IndexedFaceSet_1;
  Handle_Vrml_IndexedFaceSet_2: typeof Handle_Vrml_IndexedFaceSet_2;
  Handle_Vrml_IndexedFaceSet_3: typeof Handle_Vrml_IndexedFaceSet_3;
  Handle_Vrml_IndexedFaceSet_4: typeof Handle_Vrml_IndexedFaceSet_4;
  Vrml_IndexedFaceSet: typeof Vrml_IndexedFaceSet;
  Vrml_IndexedFaceSet_1: typeof Vrml_IndexedFaceSet_1;
  Vrml_IndexedFaceSet_2: typeof Vrml_IndexedFaceSet_2;
  Vrml_Separator: typeof Vrml_Separator;
  Vrml_Separator_1: typeof Vrml_Separator_1;
  Vrml_Separator_2: typeof Vrml_Separator_2;
  Vrml_Cylinder: typeof Vrml_Cylinder;
  Vrml_Rotation: typeof Vrml_Rotation;
  Vrml_Rotation_1: typeof Vrml_Rotation_1;
  Vrml_Rotation_2: typeof Vrml_Rotation_2;
  Vrml_Translation: typeof Vrml_Translation;
  Vrml_Translation_1: typeof Vrml_Translation_1;
  Vrml_Translation_2: typeof Vrml_Translation_2;
  Vrml_CylinderParts: Vrml_CylinderParts;
  Vrml_SpotLight: typeof Vrml_SpotLight;
  Vrml_SpotLight_1: typeof Vrml_SpotLight_1;
  Vrml_SpotLight_2: typeof Vrml_SpotLight_2;
  Handle_Vrml_SFImage: typeof Handle_Vrml_SFImage;
  Handle_Vrml_SFImage_1: typeof Handle_Vrml_SFImage_1;
  Handle_Vrml_SFImage_2: typeof Handle_Vrml_SFImage_2;
  Handle_Vrml_SFImage_3: typeof Handle_Vrml_SFImage_3;
  Handle_Vrml_SFImage_4: typeof Handle_Vrml_SFImage_4;
  Vrml_SFImage: typeof Vrml_SFImage;
  Vrml_SFImage_1: typeof Vrml_SFImage_1;
  Vrml_SFImage_2: typeof Vrml_SFImage_2;
  Vrml_Cone: typeof Vrml_Cone;
  Handle_Vrml_Normal: typeof Handle_Vrml_Normal;
  Handle_Vrml_Normal_1: typeof Handle_Vrml_Normal_1;
  Handle_Vrml_Normal_2: typeof Handle_Vrml_Normal_2;
  Handle_Vrml_Normal_3: typeof Handle_Vrml_Normal_3;
  Handle_Vrml_Normal_4: typeof Handle_Vrml_Normal_4;
  Vrml_Normal: typeof Vrml_Normal;
  Vrml_Normal_1: typeof Vrml_Normal_1;
  Vrml_Normal_2: typeof Vrml_Normal_2;
  Vrml_TransformSeparator: typeof Vrml_TransformSeparator;
  Vrml_Sphere: typeof Vrml_Sphere;
  Vrml_AsciiText: typeof Vrml_AsciiText;
  Vrml_AsciiText_1: typeof Vrml_AsciiText_1;
  Vrml_AsciiText_2: typeof Vrml_AsciiText_2;
  Handle_Vrml_AsciiText: typeof Handle_Vrml_AsciiText;
  Handle_Vrml_AsciiText_1: typeof Handle_Vrml_AsciiText_1;
  Handle_Vrml_AsciiText_2: typeof Handle_Vrml_AsciiText_2;
  Handle_Vrml_AsciiText_3: typeof Handle_Vrml_AsciiText_3;
  Handle_Vrml_AsciiText_4: typeof Handle_Vrml_AsciiText_4;
  Vrml_MatrixTransform: typeof Vrml_MatrixTransform;
  Vrml_MatrixTransform_1: typeof Vrml_MatrixTransform_1;
  Vrml_MatrixTransform_2: typeof Vrml_MatrixTransform_2;
  Vrml_WWWAnchor: typeof Vrml_WWWAnchor;
  Vrml_Texture2: typeof Vrml_Texture2;
  Vrml_Texture2_1: typeof Vrml_Texture2_1;
  Vrml_Texture2_2: typeof Vrml_Texture2_2;
  Vrml_FontStyle: typeof Vrml_FontStyle;
  Vrml_NormalBinding: typeof Vrml_NormalBinding;
  Vrml_NormalBinding_1: typeof Vrml_NormalBinding_1;
  Vrml_NormalBinding_2: typeof Vrml_NormalBinding_2;
  Vrml_Instancing: typeof Vrml_Instancing;
  Vrml_SFRotation: typeof Vrml_SFRotation;
  Vrml_SFRotation_1: typeof Vrml_SFRotation_1;
  Vrml_SFRotation_2: typeof Vrml_SFRotation_2;
  Vrml_FontStyleStyle: Vrml_FontStyleStyle;
  Vrml_WWWAnchorMap: Vrml_WWWAnchorMap;
  IGESCAFControl_Reader: typeof IGESCAFControl_Reader;
  IGESCAFControl_Reader_1: typeof IGESCAFControl_Reader_1;
  IGESCAFControl_Reader_2: typeof IGESCAFControl_Reader_2;
  IGESCAFControl_Writer: typeof IGESCAFControl_Writer;
  IGESCAFControl_Writer_1: typeof IGESCAFControl_Writer_1;
  IGESCAFControl_Writer_2: typeof IGESCAFControl_Writer_2;
  IGESCAFControl: typeof IGESCAFControl;
  GeomConvert_BSplineSurfaceKnotSplitting: typeof GeomConvert_BSplineSurfaceKnotSplitting;
  GeomConvert_CompCurveToBSplineCurve: typeof GeomConvert_CompCurveToBSplineCurve;
  GeomConvert_CompCurveToBSplineCurve_1: typeof GeomConvert_CompCurveToBSplineCurve_1;
  GeomConvert_CompCurveToBSplineCurve_2: typeof GeomConvert_CompCurveToBSplineCurve_2;
  GeomConvert_ApproxCurve: typeof GeomConvert_ApproxCurve;
  GeomConvert_ApproxCurve_1: typeof GeomConvert_ApproxCurve_1;
  GeomConvert_ApproxCurve_2: typeof GeomConvert_ApproxCurve_2;
  GeomConvert_CompBezierSurfacesToBSplineSurface: typeof GeomConvert_CompBezierSurfacesToBSplineSurface;
  GeomConvert_CompBezierSurfacesToBSplineSurface_1: typeof GeomConvert_CompBezierSurfacesToBSplineSurface_1;
  GeomConvert_CompBezierSurfacesToBSplineSurface_2: typeof GeomConvert_CompBezierSurfacesToBSplineSurface_2;
  GeomConvert_CompBezierSurfacesToBSplineSurface_3: typeof GeomConvert_CompBezierSurfacesToBSplineSurface_3;
  GeomConvert: typeof GeomConvert;
  GeomConvert_BSplineSurfaceToBezierSurface: typeof GeomConvert_BSplineSurfaceToBezierSurface;
  GeomConvert_BSplineSurfaceToBezierSurface_1: typeof GeomConvert_BSplineSurfaceToBezierSurface_1;
  GeomConvert_BSplineSurfaceToBezierSurface_2: typeof GeomConvert_BSplineSurfaceToBezierSurface_2;
  GeomConvert_BSplineCurveKnotSplitting: typeof GeomConvert_BSplineCurveKnotSplitting;
  GeomConvert_BSplineCurveToBezierCurve: typeof GeomConvert_BSplineCurveToBezierCurve;
  GeomConvert_BSplineCurveToBezierCurve_1: typeof GeomConvert_BSplineCurveToBezierCurve_1;
  GeomConvert_BSplineCurveToBezierCurve_2: typeof GeomConvert_BSplineCurveToBezierCurve_2;
  GeomConvert_ApproxSurface: typeof GeomConvert_ApproxSurface;
  GeomConvert_ApproxSurface_1: typeof GeomConvert_ApproxSurface_1;
  GeomConvert_ApproxSurface_2: typeof GeomConvert_ApproxSurface_2;
  DsgPrs_SymbPresentation: typeof DsgPrs_SymbPresentation;
  DsgPrs_EllipseRadiusPresentation: typeof DsgPrs_EllipseRadiusPresentation;
  DsgPrs_FilletRadiusPresentation: typeof DsgPrs_FilletRadiusPresentation;
  DsgPrs_TangentPresentation: typeof DsgPrs_TangentPresentation;
  DsgPrs_XYZAxisPresentation: typeof DsgPrs_XYZAxisPresentation;
  DsgPrs_ConcentricPresentation: typeof DsgPrs_ConcentricPresentation;
  DsgPrs_ShadedPlanePresentation: typeof DsgPrs_ShadedPlanePresentation;
  DsgPrs_Chamf2dPresentation: typeof DsgPrs_Chamf2dPresentation;
  DsgPrs_DiameterPresentation: typeof DsgPrs_DiameterPresentation;
  DsgPrs_DatumPrs: typeof DsgPrs_DatumPrs;
  DsgPrs_ParalPresentation: typeof DsgPrs_ParalPresentation;
  DsgPrs_SymmetricPresentation: typeof DsgPrs_SymmetricPresentation;
  DsgPrs_PerpenPresentation: typeof DsgPrs_PerpenPresentation;
  DsgPrs: typeof DsgPrs;
  DsgPrs_OffsetPresentation: typeof DsgPrs_OffsetPresentation;
  DsgPrs_EqualDistancePresentation: typeof DsgPrs_EqualDistancePresentation;
  DsgPrs_MidPointPresentation: typeof DsgPrs_MidPointPresentation;
  DsgPrs_ArrowSide: DsgPrs_ArrowSide;
  DsgPrs_AnglePresentation: typeof DsgPrs_AnglePresentation;
  DsgPrs_FixPresentation: typeof DsgPrs_FixPresentation;
  DsgPrs_IdenticPresentation: typeof DsgPrs_IdenticPresentation;
  DsgPrs_EqualRadiusPresentation: typeof DsgPrs_EqualRadiusPresentation;
  DsgPrs_ShapeDirPresentation: typeof DsgPrs_ShapeDirPresentation;
  DsgPrs_LengthPresentation: typeof DsgPrs_LengthPresentation;
  DsgPrs_XYZPlanePresentation: typeof DsgPrs_XYZPlanePresentation;
  AdvApp2Var_CriterionType: AdvApp2Var_CriterionType;
  Namelist: typeof Namelist;
  Vardesc: typeof Vardesc;
  AdvApp2Var_SequenceOfStrip: typeof AdvApp2Var_SequenceOfStrip;
  AdvApp2Var_SequenceOfStrip_1: typeof AdvApp2Var_SequenceOfStrip_1;
  AdvApp2Var_SequenceOfStrip_2: typeof AdvApp2Var_SequenceOfStrip_2;
  AdvApp2Var_SequenceOfStrip_3: typeof AdvApp2Var_SequenceOfStrip_3;
  AdvApp2Var_CriterionRepartition: AdvApp2Var_CriterionRepartition;
  mlgdrtl_1_: typeof mlgdrtl_1_;
  mmapgs1_1_: typeof mmapgs1_1_;
  maovpar_1_: typeof maovpar_1_;
  mmjcobi_1_: typeof mmjcobi_1_;
  mmapgs0_1_: typeof mmapgs0_1_;
  minombr_1_: typeof minombr_1_;
  mmapgss_1_: typeof mmapgss_1_;
  maovpch_1_: typeof maovpch_1_;
  mmapgs2_1_: typeof mmapgs2_1_;
  mdnombr_1_: typeof mdnombr_1_;
  mmcmcnp_1_: typeof mmcmcnp_1_;
  RWStepShape_RWTransitionalShapeRepresentation: typeof RWStepShape_RWTransitionalShapeRepresentation;
  RWStepShape_RWShapeDimensionRepresentation: typeof RWStepShape_RWShapeDimensionRepresentation;
  RWStepShape_RWConnectedEdgeSet: typeof RWStepShape_RWConnectedEdgeSet;
  RWStepShape_RWShellBasedSurfaceModel: typeof RWStepShape_RWShellBasedSurfaceModel;
  RWStepShape_RWOrientedClosedShell: typeof RWStepShape_RWOrientedClosedShell;
  RWStepShape_RWShapeRepresentation: typeof RWStepShape_RWShapeRepresentation;
  RWStepShape_RWBoxedHalfSpace: typeof RWStepShape_RWBoxedHalfSpace;
  RWStepShape_RWHalfSpaceSolid: typeof RWStepShape_RWHalfSpaceSolid;
  RWStepShape_RWVertexPoint: typeof RWStepShape_RWVertexPoint;
  RWStepShape_RWContextDependentShapeRepresentation: typeof RWStepShape_RWContextDependentShapeRepresentation;
  RWStepShape_RWValueFormatTypeQualifier: typeof RWStepShape_RWValueFormatTypeQualifier;
  RWStepShape_RWDimensionalCharacteristicRepresentation: typeof RWStepShape_RWDimensionalCharacteristicRepresentation;
  RWStepShape_RWToleranceValue: typeof RWStepShape_RWToleranceValue;
  RWStepShape_RWSeamEdge: typeof RWStepShape_RWSeamEdge;
  RWStepShape_RWTorus: typeof RWStepShape_RWTorus;
  RWStepShape_RWDefinitionalRepresentationAndShapeRepresentation: typeof RWStepShape_RWDefinitionalRepresentationAndShapeRepresentation;
  RWStepShape_RWDimensionalSizeWithPath: typeof RWStepShape_RWDimensionalSizeWithPath;
  RWStepShape_RWGeometricallyBoundedSurfaceShapeRepresentation: typeof RWStepShape_RWGeometricallyBoundedSurfaceShapeRepresentation;
  RWStepShape_RWOrientedOpenShell: typeof RWStepShape_RWOrientedOpenShell;
  RWStepShape_RWSolidModel: typeof RWStepShape_RWSolidModel;
  RWStepShape_RWOrientedPath: typeof RWStepShape_RWOrientedPath;
  RWStepShape_RWSweptFaceSolid: typeof RWStepShape_RWSweptFaceSolid;
  RWStepShape_RWManifoldSurfaceShapeRepresentation: typeof RWStepShape_RWManifoldSurfaceShapeRepresentation;
  RWStepShape_RWQualifiedRepresentationItem: typeof RWStepShape_RWQualifiedRepresentationItem;
  RWStepShape_RWSolidReplica: typeof RWStepShape_RWSolidReplica;
  RWStepShape_RWManifoldSolidBrep: typeof RWStepShape_RWManifoldSolidBrep;
  RWStepShape_RWAngularLocation: typeof RWStepShape_RWAngularLocation;
  RWStepShape_RWMeasureQualification: typeof RWStepShape_RWMeasureQualification;
  RWStepShape_RWExtrudedAreaSolid: typeof RWStepShape_RWExtrudedAreaSolid;
  RWStepShape_RWSphere: typeof RWStepShape_RWSphere;
  RWStepShape_RWEdgeBasedWireframeModel: typeof RWStepShape_RWEdgeBasedWireframeModel;
  RWStepShape_RWFaceOuterBound: typeof RWStepShape_RWFaceOuterBound;
  RWStepShape_RWClosedShell: typeof RWStepShape_RWClosedShell;
  RWStepShape_RWFacetedBrepShapeRepresentation: typeof RWStepShape_RWFacetedBrepShapeRepresentation;
  RWStepShape_RWCsgSolid: typeof RWStepShape_RWCsgSolid;
  RWStepShape_RWNonManifoldSurfaceShapeRepresentation: typeof RWStepShape_RWNonManifoldSurfaceShapeRepresentation;
  RWStepShape_RWFaceBasedSurfaceModel: typeof RWStepShape_RWFaceBasedSurfaceModel;
  RWStepShape_RWTypeQualifier: typeof RWStepShape_RWTypeQualifier;
  RWStepShape_RWPrecisionQualifier: typeof RWStepShape_RWPrecisionQualifier;
  RWStepShape_RWAdvancedBrepShapeRepresentation: typeof RWStepShape_RWAdvancedBrepShapeRepresentation;
  RWStepShape_RWConnectedFaceShapeRepresentation: typeof RWStepShape_RWConnectedFaceShapeRepresentation;
  RWStepShape_RWTopologicalRepresentationItem: typeof RWStepShape_RWTopologicalRepresentationItem;
  RWStepShape_RWPolyLoop: typeof RWStepShape_RWPolyLoop;
  RWStepShape_RWSubedge: typeof RWStepShape_RWSubedge;
  RWStepShape_RWVertexLoop: typeof RWStepShape_RWVertexLoop;
  RWStepShape_RWPlusMinusTolerance: typeof RWStepShape_RWPlusMinusTolerance;
  RWStepShape_RWFaceSurface: typeof RWStepShape_RWFaceSurface;
  RWStepShape_RWConnectedFaceSet: typeof RWStepShape_RWConnectedFaceSet;
  RWStepShape_RWOrientedFace: typeof RWStepShape_RWOrientedFace;
  RWStepShape_RWBooleanResult: typeof RWStepShape_RWBooleanResult;
  RWStepShape_RWExtrudedFaceSolid: typeof RWStepShape_RWExtrudedFaceSolid;
  RWStepShape_RWDimensionalLocationWithPath: typeof RWStepShape_RWDimensionalLocationWithPath;
  RWStepShape_RWPointRepresentation: typeof RWStepShape_RWPointRepresentation;
  RWStepShape_RWGeometricallyBoundedWireframeShapeRepresentation: typeof RWStepShape_RWGeometricallyBoundedWireframeShapeRepresentation;
  RWStepShape_RWGeometricCurveSet: typeof RWStepShape_RWGeometricCurveSet;
  RWStepShape_RWCsgShapeRepresentation: typeof RWStepShape_RWCsgShapeRepresentation;
  RWStepShape_RWSweptAreaSolid: typeof RWStepShape_RWSweptAreaSolid;
  RWStepShape_RWShapeDefinitionRepresentation: typeof RWStepShape_RWShapeDefinitionRepresentation;
  RWStepShape_RWFace: typeof RWStepShape_RWFace;
  RWStepShape_RWLimitsAndFits: typeof RWStepShape_RWLimitsAndFits;
  RWStepShape_RWOpenShell: typeof RWStepShape_RWOpenShell;
  RWStepShape_RWLoop: typeof RWStepShape_RWLoop;
  RWStepShape_RWRightAngularWedge: typeof RWStepShape_RWRightAngularWedge;
  RWStepShape_RWSubface: typeof RWStepShape_RWSubface;
  RWStepShape_RWFacetedBrep: typeof RWStepShape_RWFacetedBrep;
  RWStepShape_RWRightCircularCylinder: typeof RWStepShape_RWRightCircularCylinder;
  RWStepShape_RWCompoundShapeRepresentation: typeof RWStepShape_RWCompoundShapeRepresentation;
  RWStepShape_RWLoopAndPath: typeof RWStepShape_RWLoopAndPath;
  RWStepShape_RWRightCircularCone: typeof RWStepShape_RWRightCircularCone;
  RWStepShape_RWPath: typeof RWStepShape_RWPath;
  RWStepShape_RWAngularSize: typeof RWStepShape_RWAngularSize;
  RWStepShape_RWEdge: typeof RWStepShape_RWEdge;
  RWStepShape_RWDimensionalLocation: typeof RWStepShape_RWDimensionalLocation;
  RWStepShape_RWAdvancedFace: typeof RWStepShape_RWAdvancedFace;
  RWStepShape_RWEdgeBasedWireframeShapeRepresentation: typeof RWStepShape_RWEdgeBasedWireframeShapeRepresentation;
  RWStepShape_RWBlock: typeof RWStepShape_RWBlock;
  RWStepShape_RWConnectedFaceSubSet: typeof RWStepShape_RWConnectedFaceSubSet;
  RWStepShape_RWOrientedEdge: typeof RWStepShape_RWOrientedEdge;
  RWStepShape_RWBoxDomain: typeof RWStepShape_RWBoxDomain;
  RWStepShape_RWShapeRepresentationWithParameters: typeof RWStepShape_RWShapeRepresentationWithParameters;
  RWStepShape_RWVertex: typeof RWStepShape_RWVertex;
  RWStepShape_RWFacetedBrepAndBrepWithVoids: typeof RWStepShape_RWFacetedBrepAndBrepWithVoids;
  RWStepShape_RWRevolvedFaceSolid: typeof RWStepShape_RWRevolvedFaceSolid;
  RWStepShape_RWMeasureRepresentationItemAndQualifiedRepresentationItem: typeof RWStepShape_RWMeasureRepresentationItemAndQualifiedRepresentationItem;
  RWStepShape_RWRevolvedAreaSolid: typeof RWStepShape_RWRevolvedAreaSolid;
  RWStepShape_RWDimensionalSize: typeof RWStepShape_RWDimensionalSize;
  RWStepShape_RWGeometricSet: typeof RWStepShape_RWGeometricSet;
  XmlMDataStd_UAttributeDriver: typeof XmlMDataStd_UAttributeDriver;
  Handle_XmlMDataStd_UAttributeDriver: typeof Handle_XmlMDataStd_UAttributeDriver;
  Handle_XmlMDataStd_UAttributeDriver_1: typeof Handle_XmlMDataStd_UAttributeDriver_1;
  Handle_XmlMDataStd_UAttributeDriver_2: typeof Handle_XmlMDataStd_UAttributeDriver_2;
  Handle_XmlMDataStd_UAttributeDriver_3: typeof Handle_XmlMDataStd_UAttributeDriver_3;
  Handle_XmlMDataStd_UAttributeDriver_4: typeof Handle_XmlMDataStd_UAttributeDriver_4;
  XmlMDataStd: typeof XmlMDataStd;
  Handle_XmlMDataStd_ExtStringArrayDriver: typeof Handle_XmlMDataStd_ExtStringArrayDriver;
  Handle_XmlMDataStd_ExtStringArrayDriver_1: typeof Handle_XmlMDataStd_ExtStringArrayDriver_1;
  Handle_XmlMDataStd_ExtStringArrayDriver_2: typeof Handle_XmlMDataStd_ExtStringArrayDriver_2;
  Handle_XmlMDataStd_ExtStringArrayDriver_3: typeof Handle_XmlMDataStd_ExtStringArrayDriver_3;
  Handle_XmlMDataStd_ExtStringArrayDriver_4: typeof Handle_XmlMDataStd_ExtStringArrayDriver_4;
  XmlMDataStd_ExtStringArrayDriver: typeof XmlMDataStd_ExtStringArrayDriver;
  XmlMDataStd_RealDriver: typeof XmlMDataStd_RealDriver;
  Handle_XmlMDataStd_RealDriver: typeof Handle_XmlMDataStd_RealDriver;
  Handle_XmlMDataStd_RealDriver_1: typeof Handle_XmlMDataStd_RealDriver_1;
  Handle_XmlMDataStd_RealDriver_2: typeof Handle_XmlMDataStd_RealDriver_2;
  Handle_XmlMDataStd_RealDriver_3: typeof Handle_XmlMDataStd_RealDriver_3;
  Handle_XmlMDataStd_RealDriver_4: typeof Handle_XmlMDataStd_RealDriver_4;
  XmlMDataStd_ReferenceArrayDriver: typeof XmlMDataStd_ReferenceArrayDriver;
  Handle_XmlMDataStd_ReferenceArrayDriver: typeof Handle_XmlMDataStd_ReferenceArrayDriver;
  Handle_XmlMDataStd_ReferenceArrayDriver_1: typeof Handle_XmlMDataStd_ReferenceArrayDriver_1;
  Handle_XmlMDataStd_ReferenceArrayDriver_2: typeof Handle_XmlMDataStd_ReferenceArrayDriver_2;
  Handle_XmlMDataStd_ReferenceArrayDriver_3: typeof Handle_XmlMDataStd_ReferenceArrayDriver_3;
  Handle_XmlMDataStd_ReferenceArrayDriver_4: typeof Handle_XmlMDataStd_ReferenceArrayDriver_4;
  Handle_XmlMDataStd_GenericEmptyDriver: typeof Handle_XmlMDataStd_GenericEmptyDriver;
  Handle_XmlMDataStd_GenericEmptyDriver_1: typeof Handle_XmlMDataStd_GenericEmptyDriver_1;
  Handle_XmlMDataStd_GenericEmptyDriver_2: typeof Handle_XmlMDataStd_GenericEmptyDriver_2;
  Handle_XmlMDataStd_GenericEmptyDriver_3: typeof Handle_XmlMDataStd_GenericEmptyDriver_3;
  Handle_XmlMDataStd_GenericEmptyDriver_4: typeof Handle_XmlMDataStd_GenericEmptyDriver_4;
  XmlMDataStd_GenericEmptyDriver: typeof XmlMDataStd_GenericEmptyDriver;
  Handle_XmlMDataStd_BooleanArrayDriver: typeof Handle_XmlMDataStd_BooleanArrayDriver;
  Handle_XmlMDataStd_BooleanArrayDriver_1: typeof Handle_XmlMDataStd_BooleanArrayDriver_1;
  Handle_XmlMDataStd_BooleanArrayDriver_2: typeof Handle_XmlMDataStd_BooleanArrayDriver_2;
  Handle_XmlMDataStd_BooleanArrayDriver_3: typeof Handle_XmlMDataStd_BooleanArrayDriver_3;
  Handle_XmlMDataStd_BooleanArrayDriver_4: typeof Handle_XmlMDataStd_BooleanArrayDriver_4;
  XmlMDataStd_BooleanArrayDriver: typeof XmlMDataStd_BooleanArrayDriver;
  XmlMDataStd_IntPackedMapDriver: typeof XmlMDataStd_IntPackedMapDriver;
  Handle_XmlMDataStd_IntPackedMapDriver: typeof Handle_XmlMDataStd_IntPackedMapDriver;
  Handle_XmlMDataStd_IntPackedMapDriver_1: typeof Handle_XmlMDataStd_IntPackedMapDriver_1;
  Handle_XmlMDataStd_IntPackedMapDriver_2: typeof Handle_XmlMDataStd_IntPackedMapDriver_2;
  Handle_XmlMDataStd_IntPackedMapDriver_3: typeof Handle_XmlMDataStd_IntPackedMapDriver_3;
  Handle_XmlMDataStd_IntPackedMapDriver_4: typeof Handle_XmlMDataStd_IntPackedMapDriver_4;
  Handle_XmlMDataStd_RealArrayDriver: typeof Handle_XmlMDataStd_RealArrayDriver;
  Handle_XmlMDataStd_RealArrayDriver_1: typeof Handle_XmlMDataStd_RealArrayDriver_1;
  Handle_XmlMDataStd_RealArrayDriver_2: typeof Handle_XmlMDataStd_RealArrayDriver_2;
  Handle_XmlMDataStd_RealArrayDriver_3: typeof Handle_XmlMDataStd_RealArrayDriver_3;
  Handle_XmlMDataStd_RealArrayDriver_4: typeof Handle_XmlMDataStd_RealArrayDriver_4;
  XmlMDataStd_RealArrayDriver: typeof XmlMDataStd_RealArrayDriver;
  Handle_XmlMDataStd_IntegerListDriver: typeof Handle_XmlMDataStd_IntegerListDriver;
  Handle_XmlMDataStd_IntegerListDriver_1: typeof Handle_XmlMDataStd_IntegerListDriver_1;
  Handle_XmlMDataStd_IntegerListDriver_2: typeof Handle_XmlMDataStd_IntegerListDriver_2;
  Handle_XmlMDataStd_IntegerListDriver_3: typeof Handle_XmlMDataStd_IntegerListDriver_3;
  Handle_XmlMDataStd_IntegerListDriver_4: typeof Handle_XmlMDataStd_IntegerListDriver_4;
  XmlMDataStd_IntegerListDriver: typeof XmlMDataStd_IntegerListDriver;
  Handle_XmlMDataStd_TreeNodeDriver: typeof Handle_XmlMDataStd_TreeNodeDriver;
  Handle_XmlMDataStd_TreeNodeDriver_1: typeof Handle_XmlMDataStd_TreeNodeDriver_1;
  Handle_XmlMDataStd_TreeNodeDriver_2: typeof Handle_XmlMDataStd_TreeNodeDriver_2;
  Handle_XmlMDataStd_TreeNodeDriver_3: typeof Handle_XmlMDataStd_TreeNodeDriver_3;
  Handle_XmlMDataStd_TreeNodeDriver_4: typeof Handle_XmlMDataStd_TreeNodeDriver_4;
  XmlMDataStd_TreeNodeDriver: typeof XmlMDataStd_TreeNodeDriver;
  Handle_XmlMDataStd_IntegerDriver: typeof Handle_XmlMDataStd_IntegerDriver;
  Handle_XmlMDataStd_IntegerDriver_1: typeof Handle_XmlMDataStd_IntegerDriver_1;
  Handle_XmlMDataStd_IntegerDriver_2: typeof Handle_XmlMDataStd_IntegerDriver_2;
  Handle_XmlMDataStd_IntegerDriver_3: typeof Handle_XmlMDataStd_IntegerDriver_3;
  Handle_XmlMDataStd_IntegerDriver_4: typeof Handle_XmlMDataStd_IntegerDriver_4;
  XmlMDataStd_IntegerDriver: typeof XmlMDataStd_IntegerDriver;
  XmlMDataStd_AsciiStringDriver: typeof XmlMDataStd_AsciiStringDriver;
  Handle_XmlMDataStd_AsciiStringDriver: typeof Handle_XmlMDataStd_AsciiStringDriver;
  Handle_XmlMDataStd_AsciiStringDriver_1: typeof Handle_XmlMDataStd_AsciiStringDriver_1;
  Handle_XmlMDataStd_AsciiStringDriver_2: typeof Handle_XmlMDataStd_AsciiStringDriver_2;
  Handle_XmlMDataStd_AsciiStringDriver_3: typeof Handle_XmlMDataStd_AsciiStringDriver_3;
  Handle_XmlMDataStd_AsciiStringDriver_4: typeof Handle_XmlMDataStd_AsciiStringDriver_4;
  Handle_XmlMDataStd_VariableDriver: typeof Handle_XmlMDataStd_VariableDriver;
  Handle_XmlMDataStd_VariableDriver_1: typeof Handle_XmlMDataStd_VariableDriver_1;
  Handle_XmlMDataStd_VariableDriver_2: typeof Handle_XmlMDataStd_VariableDriver_2;
  Handle_XmlMDataStd_VariableDriver_3: typeof Handle_XmlMDataStd_VariableDriver_3;
  Handle_XmlMDataStd_VariableDriver_4: typeof Handle_XmlMDataStd_VariableDriver_4;
  XmlMDataStd_VariableDriver: typeof XmlMDataStd_VariableDriver;
  Handle_XmlMDataStd_ExpressionDriver: typeof Handle_XmlMDataStd_ExpressionDriver;
  Handle_XmlMDataStd_ExpressionDriver_1: typeof Handle_XmlMDataStd_ExpressionDriver_1;
  Handle_XmlMDataStd_ExpressionDriver_2: typeof Handle_XmlMDataStd_ExpressionDriver_2;
  Handle_XmlMDataStd_ExpressionDriver_3: typeof Handle_XmlMDataStd_ExpressionDriver_3;
  Handle_XmlMDataStd_ExpressionDriver_4: typeof Handle_XmlMDataStd_ExpressionDriver_4;
  XmlMDataStd_ExpressionDriver: typeof XmlMDataStd_ExpressionDriver;
  Handle_XmlMDataStd_RealListDriver: typeof Handle_XmlMDataStd_RealListDriver;
  Handle_XmlMDataStd_RealListDriver_1: typeof Handle_XmlMDataStd_RealListDriver_1;
  Handle_XmlMDataStd_RealListDriver_2: typeof Handle_XmlMDataStd_RealListDriver_2;
  Handle_XmlMDataStd_RealListDriver_3: typeof Handle_XmlMDataStd_RealListDriver_3;
  Handle_XmlMDataStd_RealListDriver_4: typeof Handle_XmlMDataStd_RealListDriver_4;
  XmlMDataStd_RealListDriver: typeof XmlMDataStd_RealListDriver;
  XmlMDataStd_GenericExtStringDriver: typeof XmlMDataStd_GenericExtStringDriver;
  Handle_XmlMDataStd_GenericExtStringDriver: typeof Handle_XmlMDataStd_GenericExtStringDriver;
  Handle_XmlMDataStd_GenericExtStringDriver_1: typeof Handle_XmlMDataStd_GenericExtStringDriver_1;
  Handle_XmlMDataStd_GenericExtStringDriver_2: typeof Handle_XmlMDataStd_GenericExtStringDriver_2;
  Handle_XmlMDataStd_GenericExtStringDriver_3: typeof Handle_XmlMDataStd_GenericExtStringDriver_3;
  Handle_XmlMDataStd_GenericExtStringDriver_4: typeof Handle_XmlMDataStd_GenericExtStringDriver_4;
  XmlMDataStd_ExtStringListDriver: typeof XmlMDataStd_ExtStringListDriver;
  Handle_XmlMDataStd_ExtStringListDriver: typeof Handle_XmlMDataStd_ExtStringListDriver;
  Handle_XmlMDataStd_ExtStringListDriver_1: typeof Handle_XmlMDataStd_ExtStringListDriver_1;
  Handle_XmlMDataStd_ExtStringListDriver_2: typeof Handle_XmlMDataStd_ExtStringListDriver_2;
  Handle_XmlMDataStd_ExtStringListDriver_3: typeof Handle_XmlMDataStd_ExtStringListDriver_3;
  Handle_XmlMDataStd_ExtStringListDriver_4: typeof Handle_XmlMDataStd_ExtStringListDriver_4;
  XmlMDataStd_ByteArrayDriver: typeof XmlMDataStd_ByteArrayDriver;
  Handle_XmlMDataStd_ByteArrayDriver: typeof Handle_XmlMDataStd_ByteArrayDriver;
  Handle_XmlMDataStd_ByteArrayDriver_1: typeof Handle_XmlMDataStd_ByteArrayDriver_1;
  Handle_XmlMDataStd_ByteArrayDriver_2: typeof Handle_XmlMDataStd_ByteArrayDriver_2;
  Handle_XmlMDataStd_ByteArrayDriver_3: typeof Handle_XmlMDataStd_ByteArrayDriver_3;
  Handle_XmlMDataStd_ByteArrayDriver_4: typeof Handle_XmlMDataStd_ByteArrayDriver_4;
  XmlMDataStd_NamedDataDriver: typeof XmlMDataStd_NamedDataDriver;
  Handle_XmlMDataStd_NamedDataDriver: typeof Handle_XmlMDataStd_NamedDataDriver;
  Handle_XmlMDataStd_NamedDataDriver_1: typeof Handle_XmlMDataStd_NamedDataDriver_1;
  Handle_XmlMDataStd_NamedDataDriver_2: typeof Handle_XmlMDataStd_NamedDataDriver_2;
  Handle_XmlMDataStd_NamedDataDriver_3: typeof Handle_XmlMDataStd_NamedDataDriver_3;
  Handle_XmlMDataStd_NamedDataDriver_4: typeof Handle_XmlMDataStd_NamedDataDriver_4;
  XmlMDataStd_ReferenceListDriver: typeof XmlMDataStd_ReferenceListDriver;
  Handle_XmlMDataStd_ReferenceListDriver: typeof Handle_XmlMDataStd_ReferenceListDriver;
  Handle_XmlMDataStd_ReferenceListDriver_1: typeof Handle_XmlMDataStd_ReferenceListDriver_1;
  Handle_XmlMDataStd_ReferenceListDriver_2: typeof Handle_XmlMDataStd_ReferenceListDriver_2;
  Handle_XmlMDataStd_ReferenceListDriver_3: typeof Handle_XmlMDataStd_ReferenceListDriver_3;
  Handle_XmlMDataStd_ReferenceListDriver_4: typeof Handle_XmlMDataStd_ReferenceListDriver_4;
  Handle_XmlMDataStd_IntegerArrayDriver: typeof Handle_XmlMDataStd_IntegerArrayDriver;
  Handle_XmlMDataStd_IntegerArrayDriver_1: typeof Handle_XmlMDataStd_IntegerArrayDriver_1;
  Handle_XmlMDataStd_IntegerArrayDriver_2: typeof Handle_XmlMDataStd_IntegerArrayDriver_2;
  Handle_XmlMDataStd_IntegerArrayDriver_3: typeof Handle_XmlMDataStd_IntegerArrayDriver_3;
  Handle_XmlMDataStd_IntegerArrayDriver_4: typeof Handle_XmlMDataStd_IntegerArrayDriver_4;
  XmlMDataStd_IntegerArrayDriver: typeof XmlMDataStd_IntegerArrayDriver;
  Handle_XmlMDataStd_BooleanListDriver: typeof Handle_XmlMDataStd_BooleanListDriver;
  Handle_XmlMDataStd_BooleanListDriver_1: typeof Handle_XmlMDataStd_BooleanListDriver_1;
  Handle_XmlMDataStd_BooleanListDriver_2: typeof Handle_XmlMDataStd_BooleanListDriver_2;
  Handle_XmlMDataStd_BooleanListDriver_3: typeof Handle_XmlMDataStd_BooleanListDriver_3;
  Handle_XmlMDataStd_BooleanListDriver_4: typeof Handle_XmlMDataStd_BooleanListDriver_4;
  XmlMDataStd_BooleanListDriver: typeof XmlMDataStd_BooleanListDriver;
  ApproxInt_SvSurfaces: typeof ApproxInt_SvSurfaces;
  ApproxInt_KnotTools: typeof ApproxInt_KnotTools;
  NCollection_BaseList: typeof NCollection_BaseList;
  NCollection_BaseMap: typeof NCollection_BaseMap;
  Handle_NCollection_WinHeapAllocator: typeof Handle_NCollection_WinHeapAllocator;
  Handle_NCollection_WinHeapAllocator_1: typeof Handle_NCollection_WinHeapAllocator_1;
  Handle_NCollection_WinHeapAllocator_2: typeof Handle_NCollection_WinHeapAllocator_2;
  Handle_NCollection_WinHeapAllocator_3: typeof Handle_NCollection_WinHeapAllocator_3;
  Handle_NCollection_WinHeapAllocator_4: typeof Handle_NCollection_WinHeapAllocator_4;
  NCollection_WinHeapAllocator: typeof NCollection_WinHeapAllocator;
  NCollection_HeapAllocator: typeof NCollection_HeapAllocator;
  Handle_NCollection_HeapAllocator: typeof Handle_NCollection_HeapAllocator;
  Handle_NCollection_HeapAllocator_1: typeof Handle_NCollection_HeapAllocator_1;
  Handle_NCollection_HeapAllocator_2: typeof Handle_NCollection_HeapAllocator_2;
  Handle_NCollection_HeapAllocator_3: typeof Handle_NCollection_HeapAllocator_3;
  Handle_NCollection_HeapAllocator_4: typeof Handle_NCollection_HeapAllocator_4;
  Handle_NCollection_BaseAllocator: typeof Handle_NCollection_BaseAllocator;
  Handle_NCollection_BaseAllocator_1: typeof Handle_NCollection_BaseAllocator_1;
  Handle_NCollection_BaseAllocator_2: typeof Handle_NCollection_BaseAllocator_2;
  Handle_NCollection_BaseAllocator_3: typeof Handle_NCollection_BaseAllocator_3;
  Handle_NCollection_BaseAllocator_4: typeof Handle_NCollection_BaseAllocator_4;
  NCollection_BaseAllocator: typeof NCollection_BaseAllocator;
  NCollection_BaseSequence: typeof NCollection_BaseSequence;
  NCollection_AccAllocator: typeof NCollection_AccAllocator;
  Handle_NCollection_AccAllocator: typeof Handle_NCollection_AccAllocator;
  Handle_NCollection_AccAllocator_1: typeof Handle_NCollection_AccAllocator_1;
  Handle_NCollection_AccAllocator_2: typeof Handle_NCollection_AccAllocator_2;
  Handle_NCollection_AccAllocator_3: typeof Handle_NCollection_AccAllocator_3;
  Handle_NCollection_AccAllocator_4: typeof Handle_NCollection_AccAllocator_4;
  NCollection_BaseVector: typeof NCollection_BaseVector;
  NCollection_Buffer: typeof NCollection_Buffer;
  Handle_NCollection_Buffer: typeof Handle_NCollection_Buffer;
  Handle_NCollection_Buffer_1: typeof Handle_NCollection_Buffer_1;
  Handle_NCollection_Buffer_2: typeof Handle_NCollection_Buffer_2;
  Handle_NCollection_Buffer_3: typeof Handle_NCollection_Buffer_3;
  Handle_NCollection_Buffer_4: typeof Handle_NCollection_Buffer_4;
  NCollection_AlignedAllocator: typeof NCollection_AlignedAllocator;
  Handle_NCollection_AlignedAllocator: typeof Handle_NCollection_AlignedAllocator;
  Handle_NCollection_AlignedAllocator_1: typeof Handle_NCollection_AlignedAllocator_1;
  Handle_NCollection_AlignedAllocator_2: typeof Handle_NCollection_AlignedAllocator_2;
  Handle_NCollection_AlignedAllocator_3: typeof Handle_NCollection_AlignedAllocator_3;
  Handle_NCollection_AlignedAllocator_4: typeof Handle_NCollection_AlignedAllocator_4;
  NCollection_SparseArrayBase: typeof NCollection_SparseArrayBase;
  NCollection_UtfWideString: typeof NCollection_UtfWideString;
  NCollection_UtfWideString_1: typeof NCollection_UtfWideString_1;
  NCollection_UtfWideString_2: typeof NCollection_UtfWideString_2;
  NCollection_UtfWideString_3: typeof NCollection_UtfWideString_3;
  NCollection_UtfWideString_4: typeof NCollection_UtfWideString_4;
  NCollection_UtfWideString_5: typeof NCollection_UtfWideString_5;
  NCollection_UtfWideString_6: typeof NCollection_UtfWideString_6;
  NCollection_UtfWideString_7: typeof NCollection_UtfWideString_7;
  NCollection_Utf16String: typeof NCollection_Utf16String;
  NCollection_Utf16String_1: typeof NCollection_Utf16String_1;
  NCollection_Utf16String_2: typeof NCollection_Utf16String_2;
  NCollection_Utf16String_3: typeof NCollection_Utf16String_3;
  NCollection_Utf16String_4: typeof NCollection_Utf16String_4;
  NCollection_Utf16String_5: typeof NCollection_Utf16String_5;
  NCollection_Utf16String_6: typeof NCollection_Utf16String_6;
  NCollection_Utf16String_7: typeof NCollection_Utf16String_7;
  NCollection_Utf8String: typeof NCollection_Utf8String;
  NCollection_Utf8String_1: typeof NCollection_Utf8String_1;
  NCollection_Utf8String_2: typeof NCollection_Utf8String_2;
  NCollection_Utf8String_3: typeof NCollection_Utf8String_3;
  NCollection_Utf8String_4: typeof NCollection_Utf8String_4;
  NCollection_Utf8String_5: typeof NCollection_Utf8String_5;
  NCollection_Utf8String_6: typeof NCollection_Utf8String_6;
  NCollection_Utf8String_7: typeof NCollection_Utf8String_7;
  NCollection_Utf32String: typeof NCollection_Utf32String;
  NCollection_Utf32String_1: typeof NCollection_Utf32String_1;
  NCollection_Utf32String_2: typeof NCollection_Utf32String_2;
  NCollection_Utf32String_3: typeof NCollection_Utf32String_3;
  NCollection_Utf32String_4: typeof NCollection_Utf32String_4;
  NCollection_Utf32String_5: typeof NCollection_Utf32String_5;
  NCollection_Utf32String_6: typeof NCollection_Utf32String_6;
  NCollection_Utf32String_7: typeof NCollection_Utf32String_7;
  NCollection_CellFilter_Action: NCollection_CellFilter_Action;
  NCollection_CellFilter_InspectorXYZ: typeof NCollection_CellFilter_InspectorXYZ;
  NCollection_CellFilter_InspectorXY: typeof NCollection_CellFilter_InspectorXY;
  NCollection_UtfStringTool: typeof NCollection_UtfStringTool;
  NCollection_IncAllocator: typeof NCollection_IncAllocator;
  Handle_NCollection_IncAllocator: typeof Handle_NCollection_IncAllocator;
  Handle_NCollection_IncAllocator_1: typeof Handle_NCollection_IncAllocator_1;
  Handle_NCollection_IncAllocator_2: typeof Handle_NCollection_IncAllocator_2;
  Handle_NCollection_IncAllocator_3: typeof Handle_NCollection_IncAllocator_3;
  Handle_NCollection_IncAllocator_4: typeof Handle_NCollection_IncAllocator_4;
  Handle_TColGeom_HArray1OfBSplineCurve: typeof Handle_TColGeom_HArray1OfBSplineCurve;
  Handle_TColGeom_HArray1OfBSplineCurve_1: typeof Handle_TColGeom_HArray1OfBSplineCurve_1;
  Handle_TColGeom_HArray1OfBSplineCurve_2: typeof Handle_TColGeom_HArray1OfBSplineCurve_2;
  Handle_TColGeom_HArray1OfBSplineCurve_3: typeof Handle_TColGeom_HArray1OfBSplineCurve_3;
  Handle_TColGeom_HArray1OfBSplineCurve_4: typeof Handle_TColGeom_HArray1OfBSplineCurve_4;
  Handle_TColGeom_HArray1OfSurface: typeof Handle_TColGeom_HArray1OfSurface;
  Handle_TColGeom_HArray1OfSurface_1: typeof Handle_TColGeom_HArray1OfSurface_1;
  Handle_TColGeom_HArray1OfSurface_2: typeof Handle_TColGeom_HArray1OfSurface_2;
  Handle_TColGeom_HArray1OfSurface_3: typeof Handle_TColGeom_HArray1OfSurface_3;
  Handle_TColGeom_HArray1OfSurface_4: typeof Handle_TColGeom_HArray1OfSurface_4;
  Handle_TColGeom_HArray2OfSurface: typeof Handle_TColGeom_HArray2OfSurface;
  Handle_TColGeom_HArray2OfSurface_1: typeof Handle_TColGeom_HArray2OfSurface_1;
  Handle_TColGeom_HArray2OfSurface_2: typeof Handle_TColGeom_HArray2OfSurface_2;
  Handle_TColGeom_HArray2OfSurface_3: typeof Handle_TColGeom_HArray2OfSurface_3;
  Handle_TColGeom_HArray2OfSurface_4: typeof Handle_TColGeom_HArray2OfSurface_4;
  Handle_TColGeom_HArray1OfCurve: typeof Handle_TColGeom_HArray1OfCurve;
  Handle_TColGeom_HArray1OfCurve_1: typeof Handle_TColGeom_HArray1OfCurve_1;
  Handle_TColGeom_HArray1OfCurve_2: typeof Handle_TColGeom_HArray1OfCurve_2;
  Handle_TColGeom_HArray1OfCurve_3: typeof Handle_TColGeom_HArray1OfCurve_3;
  Handle_TColGeom_HArray1OfCurve_4: typeof Handle_TColGeom_HArray1OfCurve_4;
  Handle_TColGeom_HArray1OfBezierCurve: typeof Handle_TColGeom_HArray1OfBezierCurve;
  Handle_TColGeom_HArray1OfBezierCurve_1: typeof Handle_TColGeom_HArray1OfBezierCurve_1;
  Handle_TColGeom_HArray1OfBezierCurve_2: typeof Handle_TColGeom_HArray1OfBezierCurve_2;
  Handle_TColGeom_HArray1OfBezierCurve_3: typeof Handle_TColGeom_HArray1OfBezierCurve_3;
  Handle_TColGeom_HArray1OfBezierCurve_4: typeof Handle_TColGeom_HArray1OfBezierCurve_4;
  Handle_TColGeom_HSequenceOfBoundedCurve: typeof Handle_TColGeom_HSequenceOfBoundedCurve;
  Handle_TColGeom_HSequenceOfBoundedCurve_1: typeof Handle_TColGeom_HSequenceOfBoundedCurve_1;
  Handle_TColGeom_HSequenceOfBoundedCurve_2: typeof Handle_TColGeom_HSequenceOfBoundedCurve_2;
  Handle_TColGeom_HSequenceOfBoundedCurve_3: typeof Handle_TColGeom_HSequenceOfBoundedCurve_3;
  Handle_TColGeom_HSequenceOfBoundedCurve_4: typeof Handle_TColGeom_HSequenceOfBoundedCurve_4;
  Handle_TColGeom_HSequenceOfCurve: typeof Handle_TColGeom_HSequenceOfCurve;
  Handle_TColGeom_HSequenceOfCurve_1: typeof Handle_TColGeom_HSequenceOfCurve_1;
  Handle_TColGeom_HSequenceOfCurve_2: typeof Handle_TColGeom_HSequenceOfCurve_2;
  Handle_TColGeom_HSequenceOfCurve_3: typeof Handle_TColGeom_HSequenceOfCurve_3;
  Handle_TColGeom_HSequenceOfCurve_4: typeof Handle_TColGeom_HSequenceOfCurve_4;
  Handle_BinMDataStd_RealListDriver: typeof Handle_BinMDataStd_RealListDriver;
  Handle_BinMDataStd_RealListDriver_1: typeof Handle_BinMDataStd_RealListDriver_1;
  Handle_BinMDataStd_RealListDriver_2: typeof Handle_BinMDataStd_RealListDriver_2;
  Handle_BinMDataStd_RealListDriver_3: typeof Handle_BinMDataStd_RealListDriver_3;
  Handle_BinMDataStd_RealListDriver_4: typeof Handle_BinMDataStd_RealListDriver_4;
  BinMDataStd_RealListDriver: typeof BinMDataStd_RealListDriver;
  BinMDataStd_RealArrayDriver: typeof BinMDataStd_RealArrayDriver;
  Handle_BinMDataStd_RealArrayDriver: typeof Handle_BinMDataStd_RealArrayDriver;
  Handle_BinMDataStd_RealArrayDriver_1: typeof Handle_BinMDataStd_RealArrayDriver_1;
  Handle_BinMDataStd_RealArrayDriver_2: typeof Handle_BinMDataStd_RealArrayDriver_2;
  Handle_BinMDataStd_RealArrayDriver_3: typeof Handle_BinMDataStd_RealArrayDriver_3;
  Handle_BinMDataStd_RealArrayDriver_4: typeof Handle_BinMDataStd_RealArrayDriver_4;
  Handle_BinMDataStd_ByteArrayDriver: typeof Handle_BinMDataStd_ByteArrayDriver;
  Handle_BinMDataStd_ByteArrayDriver_1: typeof Handle_BinMDataStd_ByteArrayDriver_1;
  Handle_BinMDataStd_ByteArrayDriver_2: typeof Handle_BinMDataStd_ByteArrayDriver_2;
  Handle_BinMDataStd_ByteArrayDriver_3: typeof Handle_BinMDataStd_ByteArrayDriver_3;
  Handle_BinMDataStd_ByteArrayDriver_4: typeof Handle_BinMDataStd_ByteArrayDriver_4;
  BinMDataStd_ByteArrayDriver: typeof BinMDataStd_ByteArrayDriver;
  BinMDataStd_GenericEmptyDriver: typeof BinMDataStd_GenericEmptyDriver;
  Handle_BinMDataStd_GenericEmptyDriver: typeof Handle_BinMDataStd_GenericEmptyDriver;
  Handle_BinMDataStd_GenericEmptyDriver_1: typeof Handle_BinMDataStd_GenericEmptyDriver_1;
  Handle_BinMDataStd_GenericEmptyDriver_2: typeof Handle_BinMDataStd_GenericEmptyDriver_2;
  Handle_BinMDataStd_GenericEmptyDriver_3: typeof Handle_BinMDataStd_GenericEmptyDriver_3;
  Handle_BinMDataStd_GenericEmptyDriver_4: typeof Handle_BinMDataStd_GenericEmptyDriver_4;
  Handle_BinMDataStd_TreeNodeDriver: typeof Handle_BinMDataStd_TreeNodeDriver;
  Handle_BinMDataStd_TreeNodeDriver_1: typeof Handle_BinMDataStd_TreeNodeDriver_1;
  Handle_BinMDataStd_TreeNodeDriver_2: typeof Handle_BinMDataStd_TreeNodeDriver_2;
  Handle_BinMDataStd_TreeNodeDriver_3: typeof Handle_BinMDataStd_TreeNodeDriver_3;
  Handle_BinMDataStd_TreeNodeDriver_4: typeof Handle_BinMDataStd_TreeNodeDriver_4;
  BinMDataStd_TreeNodeDriver: typeof BinMDataStd_TreeNodeDriver;
  BinMDataStd_BooleanListDriver: typeof BinMDataStd_BooleanListDriver;
  Handle_BinMDataStd_BooleanListDriver: typeof Handle_BinMDataStd_BooleanListDriver;
  Handle_BinMDataStd_BooleanListDriver_1: typeof Handle_BinMDataStd_BooleanListDriver_1;
  Handle_BinMDataStd_BooleanListDriver_2: typeof Handle_BinMDataStd_BooleanListDriver_2;
  Handle_BinMDataStd_BooleanListDriver_3: typeof Handle_BinMDataStd_BooleanListDriver_3;
  Handle_BinMDataStd_BooleanListDriver_4: typeof Handle_BinMDataStd_BooleanListDriver_4;
  Handle_BinMDataStd_UAttributeDriver: typeof Handle_BinMDataStd_UAttributeDriver;
  Handle_BinMDataStd_UAttributeDriver_1: typeof Handle_BinMDataStd_UAttributeDriver_1;
  Handle_BinMDataStd_UAttributeDriver_2: typeof Handle_BinMDataStd_UAttributeDriver_2;
  Handle_BinMDataStd_UAttributeDriver_3: typeof Handle_BinMDataStd_UAttributeDriver_3;
  Handle_BinMDataStd_UAttributeDriver_4: typeof Handle_BinMDataStd_UAttributeDriver_4;
  BinMDataStd_UAttributeDriver: typeof BinMDataStd_UAttributeDriver;
  Handle_BinMDataStd_ReferenceListDriver: typeof Handle_BinMDataStd_ReferenceListDriver;
  Handle_BinMDataStd_ReferenceListDriver_1: typeof Handle_BinMDataStd_ReferenceListDriver_1;
  Handle_BinMDataStd_ReferenceListDriver_2: typeof Handle_BinMDataStd_ReferenceListDriver_2;
  Handle_BinMDataStd_ReferenceListDriver_3: typeof Handle_BinMDataStd_ReferenceListDriver_3;
  Handle_BinMDataStd_ReferenceListDriver_4: typeof Handle_BinMDataStd_ReferenceListDriver_4;
  BinMDataStd_ReferenceListDriver: typeof BinMDataStd_ReferenceListDriver;
  BinMDataStd_VariableDriver: typeof BinMDataStd_VariableDriver;
  Handle_BinMDataStd_VariableDriver: typeof Handle_BinMDataStd_VariableDriver;
  Handle_BinMDataStd_VariableDriver_1: typeof Handle_BinMDataStd_VariableDriver_1;
  Handle_BinMDataStd_VariableDriver_2: typeof Handle_BinMDataStd_VariableDriver_2;
  Handle_BinMDataStd_VariableDriver_3: typeof Handle_BinMDataStd_VariableDriver_3;
  Handle_BinMDataStd_VariableDriver_4: typeof Handle_BinMDataStd_VariableDriver_4;
  Handle_BinMDataStd_RealDriver: typeof Handle_BinMDataStd_RealDriver;
  Handle_BinMDataStd_RealDriver_1: typeof Handle_BinMDataStd_RealDriver_1;
  Handle_BinMDataStd_RealDriver_2: typeof Handle_BinMDataStd_RealDriver_2;
  Handle_BinMDataStd_RealDriver_3: typeof Handle_BinMDataStd_RealDriver_3;
  Handle_BinMDataStd_RealDriver_4: typeof Handle_BinMDataStd_RealDriver_4;
  BinMDataStd_RealDriver: typeof BinMDataStd_RealDriver;
  BinMDataStd_IntegerArrayDriver: typeof BinMDataStd_IntegerArrayDriver;
  Handle_BinMDataStd_IntegerArrayDriver: typeof Handle_BinMDataStd_IntegerArrayDriver;
  Handle_BinMDataStd_IntegerArrayDriver_1: typeof Handle_BinMDataStd_IntegerArrayDriver_1;
  Handle_BinMDataStd_IntegerArrayDriver_2: typeof Handle_BinMDataStd_IntegerArrayDriver_2;
  Handle_BinMDataStd_IntegerArrayDriver_3: typeof Handle_BinMDataStd_IntegerArrayDriver_3;
  Handle_BinMDataStd_IntegerArrayDriver_4: typeof Handle_BinMDataStd_IntegerArrayDriver_4;
  Handle_BinMDataStd_GenericExtStringDriver: typeof Handle_BinMDataStd_GenericExtStringDriver;
  Handle_BinMDataStd_GenericExtStringDriver_1: typeof Handle_BinMDataStd_GenericExtStringDriver_1;
  Handle_BinMDataStd_GenericExtStringDriver_2: typeof Handle_BinMDataStd_GenericExtStringDriver_2;
  Handle_BinMDataStd_GenericExtStringDriver_3: typeof Handle_BinMDataStd_GenericExtStringDriver_3;
  Handle_BinMDataStd_GenericExtStringDriver_4: typeof Handle_BinMDataStd_GenericExtStringDriver_4;
  BinMDataStd_GenericExtStringDriver: typeof BinMDataStd_GenericExtStringDriver;
  Handle_BinMDataStd_AsciiStringDriver: typeof Handle_BinMDataStd_AsciiStringDriver;
  Handle_BinMDataStd_AsciiStringDriver_1: typeof Handle_BinMDataStd_AsciiStringDriver_1;
  Handle_BinMDataStd_AsciiStringDriver_2: typeof Handle_BinMDataStd_AsciiStringDriver_2;
  Handle_BinMDataStd_AsciiStringDriver_3: typeof Handle_BinMDataStd_AsciiStringDriver_3;
  Handle_BinMDataStd_AsciiStringDriver_4: typeof Handle_BinMDataStd_AsciiStringDriver_4;
  BinMDataStd_AsciiStringDriver: typeof BinMDataStd_AsciiStringDriver;
  Handle_BinMDataStd_ExpressionDriver: typeof Handle_BinMDataStd_ExpressionDriver;
  Handle_BinMDataStd_ExpressionDriver_1: typeof Handle_BinMDataStd_ExpressionDriver_1;
  Handle_BinMDataStd_ExpressionDriver_2: typeof Handle_BinMDataStd_ExpressionDriver_2;
  Handle_BinMDataStd_ExpressionDriver_3: typeof Handle_BinMDataStd_ExpressionDriver_3;
  Handle_BinMDataStd_ExpressionDriver_4: typeof Handle_BinMDataStd_ExpressionDriver_4;
  BinMDataStd_ExpressionDriver: typeof BinMDataStd_ExpressionDriver;
  BinMDataStd: typeof BinMDataStd;
  Handle_BinMDataStd_IntegerListDriver: typeof Handle_BinMDataStd_IntegerListDriver;
  Handle_BinMDataStd_IntegerListDriver_1: typeof Handle_BinMDataStd_IntegerListDriver_1;
  Handle_BinMDataStd_IntegerListDriver_2: typeof Handle_BinMDataStd_IntegerListDriver_2;
  Handle_BinMDataStd_IntegerListDriver_3: typeof Handle_BinMDataStd_IntegerListDriver_3;
  Handle_BinMDataStd_IntegerListDriver_4: typeof Handle_BinMDataStd_IntegerListDriver_4;
  BinMDataStd_IntegerListDriver: typeof BinMDataStd_IntegerListDriver;
  Handle_BinMDataStd_ReferenceArrayDriver: typeof Handle_BinMDataStd_ReferenceArrayDriver;
  Handle_BinMDataStd_ReferenceArrayDriver_1: typeof Handle_BinMDataStd_ReferenceArrayDriver_1;
  Handle_BinMDataStd_ReferenceArrayDriver_2: typeof Handle_BinMDataStd_ReferenceArrayDriver_2;
  Handle_BinMDataStd_ReferenceArrayDriver_3: typeof Handle_BinMDataStd_ReferenceArrayDriver_3;
  Handle_BinMDataStd_ReferenceArrayDriver_4: typeof Handle_BinMDataStd_ReferenceArrayDriver_4;
  BinMDataStd_ReferenceArrayDriver: typeof BinMDataStd_ReferenceArrayDriver;
  BinMDataStd_BooleanArrayDriver: typeof BinMDataStd_BooleanArrayDriver;
  Handle_BinMDataStd_BooleanArrayDriver: typeof Handle_BinMDataStd_BooleanArrayDriver;
  Handle_BinMDataStd_BooleanArrayDriver_1: typeof Handle_BinMDataStd_BooleanArrayDriver_1;
  Handle_BinMDataStd_BooleanArrayDriver_2: typeof Handle_BinMDataStd_BooleanArrayDriver_2;
  Handle_BinMDataStd_BooleanArrayDriver_3: typeof Handle_BinMDataStd_BooleanArrayDriver_3;
  Handle_BinMDataStd_BooleanArrayDriver_4: typeof Handle_BinMDataStd_BooleanArrayDriver_4;
  BinMDataStd_NamedDataDriver: typeof BinMDataStd_NamedDataDriver;
  Handle_BinMDataStd_NamedDataDriver: typeof Handle_BinMDataStd_NamedDataDriver;
  Handle_BinMDataStd_NamedDataDriver_1: typeof Handle_BinMDataStd_NamedDataDriver_1;
  Handle_BinMDataStd_NamedDataDriver_2: typeof Handle_BinMDataStd_NamedDataDriver_2;
  Handle_BinMDataStd_NamedDataDriver_3: typeof Handle_BinMDataStd_NamedDataDriver_3;
  Handle_BinMDataStd_NamedDataDriver_4: typeof Handle_BinMDataStd_NamedDataDriver_4;
  BinMDataStd_ExtStringListDriver: typeof BinMDataStd_ExtStringListDriver;
  Handle_BinMDataStd_ExtStringListDriver: typeof Handle_BinMDataStd_ExtStringListDriver;
  Handle_BinMDataStd_ExtStringListDriver_1: typeof Handle_BinMDataStd_ExtStringListDriver_1;
  Handle_BinMDataStd_ExtStringListDriver_2: typeof Handle_BinMDataStd_ExtStringListDriver_2;
  Handle_BinMDataStd_ExtStringListDriver_3: typeof Handle_BinMDataStd_ExtStringListDriver_3;
  Handle_BinMDataStd_ExtStringListDriver_4: typeof Handle_BinMDataStd_ExtStringListDriver_4;
  BinMDataStd_ExtStringArrayDriver: typeof BinMDataStd_ExtStringArrayDriver;
  Handle_BinMDataStd_ExtStringArrayDriver: typeof Handle_BinMDataStd_ExtStringArrayDriver;
  Handle_BinMDataStd_ExtStringArrayDriver_1: typeof Handle_BinMDataStd_ExtStringArrayDriver_1;
  Handle_BinMDataStd_ExtStringArrayDriver_2: typeof Handle_BinMDataStd_ExtStringArrayDriver_2;
  Handle_BinMDataStd_ExtStringArrayDriver_3: typeof Handle_BinMDataStd_ExtStringArrayDriver_3;
  Handle_BinMDataStd_ExtStringArrayDriver_4: typeof Handle_BinMDataStd_ExtStringArrayDriver_4;
  Handle_BinMDataStd_IntPackedMapDriver: typeof Handle_BinMDataStd_IntPackedMapDriver;
  Handle_BinMDataStd_IntPackedMapDriver_1: typeof Handle_BinMDataStd_IntPackedMapDriver_1;
  Handle_BinMDataStd_IntPackedMapDriver_2: typeof Handle_BinMDataStd_IntPackedMapDriver_2;
  Handle_BinMDataStd_IntPackedMapDriver_3: typeof Handle_BinMDataStd_IntPackedMapDriver_3;
  Handle_BinMDataStd_IntPackedMapDriver_4: typeof Handle_BinMDataStd_IntPackedMapDriver_4;
  BinMDataStd_IntPackedMapDriver: typeof BinMDataStd_IntPackedMapDriver;
  BinMDataStd_IntegerDriver: typeof BinMDataStd_IntegerDriver;
  Handle_BinMDataStd_IntegerDriver: typeof Handle_BinMDataStd_IntegerDriver;
  Handle_BinMDataStd_IntegerDriver_1: typeof Handle_BinMDataStd_IntegerDriver_1;
  Handle_BinMDataStd_IntegerDriver_2: typeof Handle_BinMDataStd_IntegerDriver_2;
  Handle_BinMDataStd_IntegerDriver_3: typeof Handle_BinMDataStd_IntegerDriver_3;
  Handle_BinMDataStd_IntegerDriver_4: typeof Handle_BinMDataStd_IntegerDriver_4;
  Blend_AppFunction: typeof Blend_AppFunction;
  Blend_SurfPointFuncInv: typeof Blend_SurfPointFuncInv;
  Blend_Status: Blend_Status;
  Blend_Point: typeof Blend_Point;
  Blend_Point_1: typeof Blend_Point_1;
  Blend_Point_2: typeof Blend_Point_2;
  Blend_Point_3: typeof Blend_Point_3;
  Blend_Point_4: typeof Blend_Point_4;
  Blend_Point_5: typeof Blend_Point_5;
  Blend_Point_6: typeof Blend_Point_6;
  Blend_Point_7: typeof Blend_Point_7;
  Blend_Point_8: typeof Blend_Point_8;
  Blend_Point_9: typeof Blend_Point_9;
  Blend_RstRstFunction: typeof Blend_RstRstFunction;
  Blend_DecrochStatus: Blend_DecrochStatus;
  Blend_CSFunction: typeof Blend_CSFunction;
  Blend_SurfRstFunction: typeof Blend_SurfRstFunction;
  Blend_CurvPointFuncInv: typeof Blend_CurvPointFuncInv;
  Blend_SurfCurvFuncInv: typeof Blend_SurfCurvFuncInv;
  Blend_FuncInv: typeof Blend_FuncInv;
  Blend_Function: typeof Blend_Function;
  Blend_SequenceOfPoint: typeof Blend_SequenceOfPoint;
  Blend_SequenceOfPoint_1: typeof Blend_SequenceOfPoint_1;
  Blend_SequenceOfPoint_2: typeof Blend_SequenceOfPoint_2;
  Blend_SequenceOfPoint_3: typeof Blend_SequenceOfPoint_3;
  RWStepElement_RWElementDescriptor: typeof RWStepElement_RWElementDescriptor;
  RWStepElement_RWVolume3dElementDescriptor: typeof RWStepElement_RWVolume3dElementDescriptor;
  RWStepElement_RWSurfaceElementProperty: typeof RWStepElement_RWSurfaceElementProperty;
  RWStepElement_RWElementMaterial: typeof RWStepElement_RWElementMaterial;
  RWStepElement_RWSurfaceSectionFieldConstant: typeof RWStepElement_RWSurfaceSectionFieldConstant;
  RWStepElement_RWSurfaceSectionFieldVarying: typeof RWStepElement_RWSurfaceSectionFieldVarying;
  RWStepElement_RWSurface3dElementDescriptor: typeof RWStepElement_RWSurface3dElementDescriptor;
  RWStepElement_RWAnalysisItemWithinRepresentation: typeof RWStepElement_RWAnalysisItemWithinRepresentation;
  RWStepElement_RWCurve3dElementDescriptor: typeof RWStepElement_RWCurve3dElementDescriptor;
  RWStepElement_RWSurfaceSection: typeof RWStepElement_RWSurfaceSection;
  RWStepElement_RWCurveElementSectionDefinition: typeof RWStepElement_RWCurveElementSectionDefinition;
  RWStepElement_RWUniformSurfaceSection: typeof RWStepElement_RWUniformSurfaceSection;
  RWStepElement_RWCurveElementEndReleasePacket: typeof RWStepElement_RWCurveElementEndReleasePacket;
  RWStepElement_RWSurfaceSectionField: typeof RWStepElement_RWSurfaceSectionField;
  RWStepElement_RWCurveElementSectionDerivedDefinitions: typeof RWStepElement_RWCurveElementSectionDerivedDefinitions;
  WNT_OrientationType: WNT_OrientationType;
  Handle_WNT_ClassDefinitionError: typeof Handle_WNT_ClassDefinitionError;
  Handle_WNT_ClassDefinitionError_1: typeof Handle_WNT_ClassDefinitionError_1;
  Handle_WNT_ClassDefinitionError_2: typeof Handle_WNT_ClassDefinitionError_2;
  Handle_WNT_ClassDefinitionError_3: typeof Handle_WNT_ClassDefinitionError_3;
  Handle_WNT_ClassDefinitionError_4: typeof Handle_WNT_ClassDefinitionError_4;
  WNT_ClassDefinitionError: typeof WNT_ClassDefinitionError;
  WNT_ClassDefinitionError_1: typeof WNT_ClassDefinitionError_1;
  WNT_ClassDefinitionError_2: typeof WNT_ClassDefinitionError_2;
  LDOM_CharReference: typeof LDOM_CharReference;
  LDOM_NodeList: typeof LDOM_NodeList;
  LDOM_NodeList_1: typeof LDOM_NodeList_1;
  LDOM_NodeList_2: typeof LDOM_NodeList_2;
  LDOM_CDATASection: typeof LDOM_CDATASection;
  LDOM_CDATASection_1: typeof LDOM_CDATASection_1;
  LDOM_CDATASection_2: typeof LDOM_CDATASection_2;
  LDOM_XmlReader: typeof LDOM_XmlReader;
  LDOM_Text: typeof LDOM_Text;
  LDOM_Text_1: typeof LDOM_Text_1;
  LDOM_Text_2: typeof LDOM_Text_2;
  LDOM_MemManager: typeof LDOM_MemManager;
  Handle_LDOM_MemManager: typeof Handle_LDOM_MemManager;
  Handle_LDOM_MemManager_1: typeof Handle_LDOM_MemManager_1;
  Handle_LDOM_MemManager_2: typeof Handle_LDOM_MemManager_2;
  Handle_LDOM_MemManager_3: typeof Handle_LDOM_MemManager_3;
  Handle_LDOM_MemManager_4: typeof Handle_LDOM_MemManager_4;
  LDOM_Attr: typeof LDOM_Attr;
  LDOM_Attr_1: typeof LDOM_Attr_1;
  LDOM_Attr_2: typeof LDOM_Attr_2;
  LDOM_OSStream: typeof LDOM_OSStream;
  LDOM_SBuffer: typeof LDOM_SBuffer;
  LDOMBasicString: typeof LDOMBasicString;
  LDOMBasicString_1: typeof LDOMBasicString_1;
  LDOMBasicString_2: typeof LDOMBasicString_2;
  LDOMBasicString_3: typeof LDOMBasicString_3;
  LDOMBasicString_4: typeof LDOMBasicString_4;
  LDOMBasicString_5: typeof LDOMBasicString_5;
  LDOMBasicString_6: typeof LDOMBasicString_6;
  LDOM_BasicText: typeof LDOM_BasicText;
  LDOM_CharacterData: typeof LDOM_CharacterData;
  LDOM_CharacterData_1: typeof LDOM_CharacterData_1;
  LDOM_CharacterData_2: typeof LDOM_CharacterData_2;
  LDOM_BasicAttribute: typeof LDOM_BasicAttribute;
  LDOM_Node: typeof LDOM_Node;
  LDOM_Node_1: typeof LDOM_Node_1;
  LDOM_Node_2: typeof LDOM_Node_2;
  LDOM_LDOMImplementation: typeof LDOM_LDOMImplementation;
  LDOMParser: typeof LDOMParser;
  LDOM_Element: typeof LDOM_Element;
  LDOM_Element_1: typeof LDOM_Element_1;
  LDOM_Element_2: typeof LDOM_Element_2;
  LDOM_DocumentType: typeof LDOM_DocumentType;
  LDOM_BasicNode: typeof LDOM_BasicNode;
  LDOM_Comment: typeof LDOM_Comment;
  LDOM_Comment_1: typeof LDOM_Comment_1;
  LDOM_Comment_2: typeof LDOM_Comment_2;
  LDOM_XmlWriter: typeof LDOM_XmlWriter;
  LDOM_BasicElement: typeof LDOM_BasicElement;
  LDOM_Document: typeof LDOM_Document;
  LDOM_Document_1: typeof LDOM_Document_1;
  LDOM_Document_2: typeof LDOM_Document_2;
  LDOMString: typeof LDOMString;
  LDOMString_1: typeof LDOMString_1;
  LDOMString_2: typeof LDOMString_2;
  LDOMString_3: typeof LDOMString_3;
  LDOMString_4: typeof LDOMString_4;
  IGESGraph_TextFontDef: typeof IGESGraph_TextFontDef;
  Handle_IGESGraph_TextFontDef: typeof Handle_IGESGraph_TextFontDef;
  Handle_IGESGraph_TextFontDef_1: typeof Handle_IGESGraph_TextFontDef_1;
  Handle_IGESGraph_TextFontDef_2: typeof Handle_IGESGraph_TextFontDef_2;
  Handle_IGESGraph_TextFontDef_3: typeof Handle_IGESGraph_TextFontDef_3;
  Handle_IGESGraph_TextFontDef_4: typeof Handle_IGESGraph_TextFontDef_4;
  IGESGraph_IntercharacterSpacing: typeof IGESGraph_IntercharacterSpacing;
  Handle_IGESGraph_IntercharacterSpacing: typeof Handle_IGESGraph_IntercharacterSpacing;
  Handle_IGESGraph_IntercharacterSpacing_1: typeof Handle_IGESGraph_IntercharacterSpacing_1;
  Handle_IGESGraph_IntercharacterSpacing_2: typeof Handle_IGESGraph_IntercharacterSpacing_2;
  Handle_IGESGraph_IntercharacterSpacing_3: typeof Handle_IGESGraph_IntercharacterSpacing_3;
  Handle_IGESGraph_IntercharacterSpacing_4: typeof Handle_IGESGraph_IntercharacterSpacing_4;
  IGESGraph_ReadWriteModule: typeof IGESGraph_ReadWriteModule;
  Handle_IGESGraph_ReadWriteModule: typeof Handle_IGESGraph_ReadWriteModule;
  Handle_IGESGraph_ReadWriteModule_1: typeof Handle_IGESGraph_ReadWriteModule_1;
  Handle_IGESGraph_ReadWriteModule_2: typeof Handle_IGESGraph_ReadWriteModule_2;
  Handle_IGESGraph_ReadWriteModule_3: typeof Handle_IGESGraph_ReadWriteModule_3;
  Handle_IGESGraph_ReadWriteModule_4: typeof Handle_IGESGraph_ReadWriteModule_4;
  IGESGraph_TextDisplayTemplate: typeof IGESGraph_TextDisplayTemplate;
  Handle_IGESGraph_TextDisplayTemplate: typeof Handle_IGESGraph_TextDisplayTemplate;
  Handle_IGESGraph_TextDisplayTemplate_1: typeof Handle_IGESGraph_TextDisplayTemplate_1;
  Handle_IGESGraph_TextDisplayTemplate_2: typeof Handle_IGESGraph_TextDisplayTemplate_2;
  Handle_IGESGraph_TextDisplayTemplate_3: typeof Handle_IGESGraph_TextDisplayTemplate_3;
  Handle_IGESGraph_TextDisplayTemplate_4: typeof Handle_IGESGraph_TextDisplayTemplate_4;
  IGESGraph_SpecificModule: typeof IGESGraph_SpecificModule;
  Handle_IGESGraph_SpecificModule: typeof Handle_IGESGraph_SpecificModule;
  Handle_IGESGraph_SpecificModule_1: typeof Handle_IGESGraph_SpecificModule_1;
  Handle_IGESGraph_SpecificModule_2: typeof Handle_IGESGraph_SpecificModule_2;
  Handle_IGESGraph_SpecificModule_3: typeof Handle_IGESGraph_SpecificModule_3;
  Handle_IGESGraph_SpecificModule_4: typeof Handle_IGESGraph_SpecificModule_4;
  IGESGraph_LineFontPredefined: typeof IGESGraph_LineFontPredefined;
  Handle_IGESGraph_LineFontPredefined: typeof Handle_IGESGraph_LineFontPredefined;
  Handle_IGESGraph_LineFontPredefined_1: typeof Handle_IGESGraph_LineFontPredefined_1;
  Handle_IGESGraph_LineFontPredefined_2: typeof Handle_IGESGraph_LineFontPredefined_2;
  Handle_IGESGraph_LineFontPredefined_3: typeof Handle_IGESGraph_LineFontPredefined_3;
  Handle_IGESGraph_LineFontPredefined_4: typeof Handle_IGESGraph_LineFontPredefined_4;
  Handle_IGESGraph_DrawingSize: typeof Handle_IGESGraph_DrawingSize;
  Handle_IGESGraph_DrawingSize_1: typeof Handle_IGESGraph_DrawingSize_1;
  Handle_IGESGraph_DrawingSize_2: typeof Handle_IGESGraph_DrawingSize_2;
  Handle_IGESGraph_DrawingSize_3: typeof Handle_IGESGraph_DrawingSize_3;
  Handle_IGESGraph_DrawingSize_4: typeof Handle_IGESGraph_DrawingSize_4;
  IGESGraph_DrawingSize: typeof IGESGraph_DrawingSize;
  IGESGraph_ToolUniformRectGrid: typeof IGESGraph_ToolUniformRectGrid;
  IGESGraph: typeof IGESGraph;
  Handle_IGESGraph_Protocol: typeof Handle_IGESGraph_Protocol;
  Handle_IGESGraph_Protocol_1: typeof Handle_IGESGraph_Protocol_1;
  Handle_IGESGraph_Protocol_2: typeof Handle_IGESGraph_Protocol_2;
  Handle_IGESGraph_Protocol_3: typeof Handle_IGESGraph_Protocol_3;
  Handle_IGESGraph_Protocol_4: typeof Handle_IGESGraph_Protocol_4;
  IGESGraph_Protocol: typeof IGESGraph_Protocol;
  IGESGraph_ToolIntercharacterSpacing: typeof IGESGraph_ToolIntercharacterSpacing;
  IGESGraph_ToolLineFontPredefined: typeof IGESGraph_ToolLineFontPredefined;
  IGESGraph_ToolPick: typeof IGESGraph_ToolPick;
  Handle_IGESGraph_LineFontDefTemplate: typeof Handle_IGESGraph_LineFontDefTemplate;
  Handle_IGESGraph_LineFontDefTemplate_1: typeof Handle_IGESGraph_LineFontDefTemplate_1;
  Handle_IGESGraph_LineFontDefTemplate_2: typeof Handle_IGESGraph_LineFontDefTemplate_2;
  Handle_IGESGraph_LineFontDefTemplate_3: typeof Handle_IGESGraph_LineFontDefTemplate_3;
  Handle_IGESGraph_LineFontDefTemplate_4: typeof Handle_IGESGraph_LineFontDefTemplate_4;
  IGESGraph_LineFontDefTemplate: typeof IGESGraph_LineFontDefTemplate;
  IGESGraph_ToolLineFontDefTemplate: typeof IGESGraph_ToolLineFontDefTemplate;
  IGESGraph_GeneralModule: typeof IGESGraph_GeneralModule;
  Handle_IGESGraph_GeneralModule: typeof Handle_IGESGraph_GeneralModule;
  Handle_IGESGraph_GeneralModule_1: typeof Handle_IGESGraph_GeneralModule_1;
  Handle_IGESGraph_GeneralModule_2: typeof Handle_IGESGraph_GeneralModule_2;
  Handle_IGESGraph_GeneralModule_3: typeof Handle_IGESGraph_GeneralModule_3;
  Handle_IGESGraph_GeneralModule_4: typeof Handle_IGESGraph_GeneralModule_4;
  IGESGraph_DrawingUnits: typeof IGESGraph_DrawingUnits;
  Handle_IGESGraph_DrawingUnits: typeof Handle_IGESGraph_DrawingUnits;
  Handle_IGESGraph_DrawingUnits_1: typeof Handle_IGESGraph_DrawingUnits_1;
  Handle_IGESGraph_DrawingUnits_2: typeof Handle_IGESGraph_DrawingUnits_2;
  Handle_IGESGraph_DrawingUnits_3: typeof Handle_IGESGraph_DrawingUnits_3;
  Handle_IGESGraph_DrawingUnits_4: typeof Handle_IGESGraph_DrawingUnits_4;
  IGESGraph_ToolHighLight: typeof IGESGraph_ToolHighLight;
  Handle_IGESGraph_NominalSize: typeof Handle_IGESGraph_NominalSize;
  Handle_IGESGraph_NominalSize_1: typeof Handle_IGESGraph_NominalSize_1;
  Handle_IGESGraph_NominalSize_2: typeof Handle_IGESGraph_NominalSize_2;
  Handle_IGESGraph_NominalSize_3: typeof Handle_IGESGraph_NominalSize_3;
  Handle_IGESGraph_NominalSize_4: typeof Handle_IGESGraph_NominalSize_4;
  IGESGraph_NominalSize: typeof IGESGraph_NominalSize;
  IGESGraph_ToolTextDisplayTemplate: typeof IGESGraph_ToolTextDisplayTemplate;
  Handle_IGESGraph_Pick: typeof Handle_IGESGraph_Pick;
  Handle_IGESGraph_Pick_1: typeof Handle_IGESGraph_Pick_1;
  Handle_IGESGraph_Pick_2: typeof Handle_IGESGraph_Pick_2;
  Handle_IGESGraph_Pick_3: typeof Handle_IGESGraph_Pick_3;
  Handle_IGESGraph_Pick_4: typeof Handle_IGESGraph_Pick_4;
  IGESGraph_Pick: typeof IGESGraph_Pick;
  IGESGraph_HighLight: typeof IGESGraph_HighLight;
  Handle_IGESGraph_HighLight: typeof Handle_IGESGraph_HighLight;
  Handle_IGESGraph_HighLight_1: typeof Handle_IGESGraph_HighLight_1;
  Handle_IGESGraph_HighLight_2: typeof Handle_IGESGraph_HighLight_2;
  Handle_IGESGraph_HighLight_3: typeof Handle_IGESGraph_HighLight_3;
  Handle_IGESGraph_HighLight_4: typeof Handle_IGESGraph_HighLight_4;
  IGESGraph_LineFontDefPattern: typeof IGESGraph_LineFontDefPattern;
  Handle_IGESGraph_LineFontDefPattern: typeof Handle_IGESGraph_LineFontDefPattern;
  Handle_IGESGraph_LineFontDefPattern_1: typeof Handle_IGESGraph_LineFontDefPattern_1;
  Handle_IGESGraph_LineFontDefPattern_2: typeof Handle_IGESGraph_LineFontDefPattern_2;
  Handle_IGESGraph_LineFontDefPattern_3: typeof Handle_IGESGraph_LineFontDefPattern_3;
  Handle_IGESGraph_LineFontDefPattern_4: typeof Handle_IGESGraph_LineFontDefPattern_4;
  IGESGraph_ToolDefinitionLevel: typeof IGESGraph_ToolDefinitionLevel;
  Handle_IGESGraph_HArray1OfTextFontDef: typeof Handle_IGESGraph_HArray1OfTextFontDef;
  Handle_IGESGraph_HArray1OfTextFontDef_1: typeof Handle_IGESGraph_HArray1OfTextFontDef_1;
  Handle_IGESGraph_HArray1OfTextFontDef_2: typeof Handle_IGESGraph_HArray1OfTextFontDef_2;
  Handle_IGESGraph_HArray1OfTextFontDef_3: typeof Handle_IGESGraph_HArray1OfTextFontDef_3;
  Handle_IGESGraph_HArray1OfTextFontDef_4: typeof Handle_IGESGraph_HArray1OfTextFontDef_4;
  IGESGraph_ToolNominalSize: typeof IGESGraph_ToolNominalSize;
  IGESGraph_ToolTextFontDef: typeof IGESGraph_ToolTextFontDef;
  Handle_IGESGraph_HArray1OfTextDisplayTemplate: typeof Handle_IGESGraph_HArray1OfTextDisplayTemplate;
  Handle_IGESGraph_HArray1OfTextDisplayTemplate_1: typeof Handle_IGESGraph_HArray1OfTextDisplayTemplate_1;
  Handle_IGESGraph_HArray1OfTextDisplayTemplate_2: typeof Handle_IGESGraph_HArray1OfTextDisplayTemplate_2;
  Handle_IGESGraph_HArray1OfTextDisplayTemplate_3: typeof Handle_IGESGraph_HArray1OfTextDisplayTemplate_3;
  Handle_IGESGraph_HArray1OfTextDisplayTemplate_4: typeof Handle_IGESGraph_HArray1OfTextDisplayTemplate_4;
  IGESGraph_ToolLineFontDefPattern: typeof IGESGraph_ToolLineFontDefPattern;
  Handle_IGESGraph_HArray1OfColor: typeof Handle_IGESGraph_HArray1OfColor;
  Handle_IGESGraph_HArray1OfColor_1: typeof Handle_IGESGraph_HArray1OfColor_1;
  Handle_IGESGraph_HArray1OfColor_2: typeof Handle_IGESGraph_HArray1OfColor_2;
  Handle_IGESGraph_HArray1OfColor_3: typeof Handle_IGESGraph_HArray1OfColor_3;
  Handle_IGESGraph_HArray1OfColor_4: typeof Handle_IGESGraph_HArray1OfColor_4;
  IGESGraph_DefinitionLevel: typeof IGESGraph_DefinitionLevel;
  Handle_IGESGraph_DefinitionLevel: typeof Handle_IGESGraph_DefinitionLevel;
  Handle_IGESGraph_DefinitionLevel_1: typeof Handle_IGESGraph_DefinitionLevel_1;
  Handle_IGESGraph_DefinitionLevel_2: typeof Handle_IGESGraph_DefinitionLevel_2;
  Handle_IGESGraph_DefinitionLevel_3: typeof Handle_IGESGraph_DefinitionLevel_3;
  Handle_IGESGraph_DefinitionLevel_4: typeof Handle_IGESGraph_DefinitionLevel_4;
  Handle_IGESGraph_UniformRectGrid: typeof Handle_IGESGraph_UniformRectGrid;
  Handle_IGESGraph_UniformRectGrid_1: typeof Handle_IGESGraph_UniformRectGrid_1;
  Handle_IGESGraph_UniformRectGrid_2: typeof Handle_IGESGraph_UniformRectGrid_2;
  Handle_IGESGraph_UniformRectGrid_3: typeof Handle_IGESGraph_UniformRectGrid_3;
  Handle_IGESGraph_UniformRectGrid_4: typeof Handle_IGESGraph_UniformRectGrid_4;
  IGESGraph_UniformRectGrid: typeof IGESGraph_UniformRectGrid;
  IGESGraph_ToolColor: typeof IGESGraph_ToolColor;
  IGESGraph_ToolDrawingUnits: typeof IGESGraph_ToolDrawingUnits;
  Handle_IGESGraph_Color: typeof Handle_IGESGraph_Color;
  Handle_IGESGraph_Color_1: typeof Handle_IGESGraph_Color_1;
  Handle_IGESGraph_Color_2: typeof Handle_IGESGraph_Color_2;
  Handle_IGESGraph_Color_3: typeof Handle_IGESGraph_Color_3;
  Handle_IGESGraph_Color_4: typeof Handle_IGESGraph_Color_4;
  IGESGraph_Color: typeof IGESGraph_Color;
  IGESGraph_ToolDrawingSize: typeof IGESGraph_ToolDrawingSize;
  Intrv_Interval: typeof Intrv_Interval;
  Intrv_Interval_1: typeof Intrv_Interval_1;
  Intrv_Interval_2: typeof Intrv_Interval_2;
  Intrv_Interval_3: typeof Intrv_Interval_3;
  Intrv_Position: Intrv_Position;
  Intrv_SequenceOfInterval: typeof Intrv_SequenceOfInterval;
  Intrv_SequenceOfInterval_1: typeof Intrv_SequenceOfInterval_1;
  Intrv_SequenceOfInterval_2: typeof Intrv_SequenceOfInterval_2;
  Intrv_SequenceOfInterval_3: typeof Intrv_SequenceOfInterval_3;
  Intrv_Intervals: typeof Intrv_Intervals;
  Intrv_Intervals_1: typeof Intrv_Intervals_1;
  Intrv_Intervals_2: typeof Intrv_Intervals_2;
  Handle_XCAFNoteObjects_NoteObject: typeof Handle_XCAFNoteObjects_NoteObject;
  Handle_XCAFNoteObjects_NoteObject_1: typeof Handle_XCAFNoteObjects_NoteObject_1;
  Handle_XCAFNoteObjects_NoteObject_2: typeof Handle_XCAFNoteObjects_NoteObject_2;
  Handle_XCAFNoteObjects_NoteObject_3: typeof Handle_XCAFNoteObjects_NoteObject_3;
  Handle_XCAFNoteObjects_NoteObject_4: typeof Handle_XCAFNoteObjects_NoteObject_4;
  XCAFNoteObjects_NoteObject: typeof XCAFNoteObjects_NoteObject;
  XCAFNoteObjects_NoteObject_1: typeof XCAFNoteObjects_NoteObject_1;
  XCAFNoteObjects_NoteObject_2: typeof XCAFNoteObjects_NoteObject_2;
  Geom2dHatch_MapOfElements: typeof Geom2dHatch_MapOfElements;
  Geom2dHatch_MapOfElements_1: typeof Geom2dHatch_MapOfElements_1;
  Geom2dHatch_MapOfElements_2: typeof Geom2dHatch_MapOfElements_2;
  Geom2dHatch_MapOfElements_3: typeof Geom2dHatch_MapOfElements_3;
  Geom2dHatch_Hatchings: typeof Geom2dHatch_Hatchings;
  Geom2dHatch_Hatchings_1: typeof Geom2dHatch_Hatchings_1;
  Geom2dHatch_Hatchings_2: typeof Geom2dHatch_Hatchings_2;
  Geom2dHatch_Hatchings_3: typeof Geom2dHatch_Hatchings_3;
  Geom2dHatch_Hatcher: typeof Geom2dHatch_Hatcher;
  Geom2dHatch_Hatching: typeof Geom2dHatch_Hatching;
  Geom2dHatch_Hatching_1: typeof Geom2dHatch_Hatching_1;
  Geom2dHatch_Hatching_2: typeof Geom2dHatch_Hatching_2;
  Geom2dHatch_Intersector: typeof Geom2dHatch_Intersector;
  Geom2dHatch_Intersector_1: typeof Geom2dHatch_Intersector_1;
  Geom2dHatch_Intersector_2: typeof Geom2dHatch_Intersector_2;
  Geom2dHatch_Element: typeof Geom2dHatch_Element;
  Geom2dHatch_Element_1: typeof Geom2dHatch_Element_1;
  Geom2dHatch_Element_2: typeof Geom2dHatch_Element_2;
  Geom2dHatch_FClass2dOfClassifier: typeof Geom2dHatch_FClass2dOfClassifier;
  Geom2dHatch_Classifier: typeof Geom2dHatch_Classifier;
  Geom2dHatch_Classifier_1: typeof Geom2dHatch_Classifier_1;
  Geom2dHatch_Classifier_2: typeof Geom2dHatch_Classifier_2;
  Geom2dHatch_Elements: typeof Geom2dHatch_Elements;
  Geom2dHatch_Elements_1: typeof Geom2dHatch_Elements_1;
  Geom2dHatch_Elements_2: typeof Geom2dHatch_Elements_2;
  IntAna2d_AnaIntersection: typeof IntAna2d_AnaIntersection;
  IntAna2d_AnaIntersection_1: typeof IntAna2d_AnaIntersection_1;
  IntAna2d_AnaIntersection_2: typeof IntAna2d_AnaIntersection_2;
  IntAna2d_AnaIntersection_3: typeof IntAna2d_AnaIntersection_3;
  IntAna2d_AnaIntersection_4: typeof IntAna2d_AnaIntersection_4;
  IntAna2d_AnaIntersection_5: typeof IntAna2d_AnaIntersection_5;
  IntAna2d_AnaIntersection_6: typeof IntAna2d_AnaIntersection_6;
  IntAna2d_AnaIntersection_7: typeof IntAna2d_AnaIntersection_7;
  IntAna2d_AnaIntersection_8: typeof IntAna2d_AnaIntersection_8;
  IntAna2d_AnaIntersection_9: typeof IntAna2d_AnaIntersection_9;
  MyDirectPolynomialRoots: typeof MyDirectPolynomialRoots;
  MyDirectPolynomialRoots_1: typeof MyDirectPolynomialRoots_1;
  MyDirectPolynomialRoots_2: typeof MyDirectPolynomialRoots_2;
  IntAna2d_IntPoint: typeof IntAna2d_IntPoint;
  IntAna2d_IntPoint_1: typeof IntAna2d_IntPoint_1;
  IntAna2d_IntPoint_2: typeof IntAna2d_IntPoint_2;
  IntAna2d_IntPoint_3: typeof IntAna2d_IntPoint_3;
  IntAna2d_Conic: typeof IntAna2d_Conic;
  IntAna2d_Conic_1: typeof IntAna2d_Conic_1;
  IntAna2d_Conic_2: typeof IntAna2d_Conic_2;
  IntAna2d_Conic_3: typeof IntAna2d_Conic_3;
  IntAna2d_Conic_4: typeof IntAna2d_Conic_4;
  IntAna2d_Conic_5: typeof IntAna2d_Conic_5;
  BRepFilletAPI_LocalOperation: typeof BRepFilletAPI_LocalOperation;
  BRepFilletAPI_MakeFillet: typeof BRepFilletAPI_MakeFillet;
  BRepFilletAPI_MakeFillet2d: typeof BRepFilletAPI_MakeFillet2d;
  BRepFilletAPI_MakeFillet2d_1: typeof BRepFilletAPI_MakeFillet2d_1;
  BRepFilletAPI_MakeFillet2d_2: typeof BRepFilletAPI_MakeFillet2d_2;
  BRepFilletAPI_MakeChamfer: typeof BRepFilletAPI_MakeChamfer;
  SelectMgr_TypeOfDepthTolerance: SelectMgr_TypeOfDepthTolerance;
  SelectMgr_BaseFrustum: typeof SelectMgr_BaseFrustum;
  Handle_SelectMgr_AndFilter: typeof Handle_SelectMgr_AndFilter;
  Handle_SelectMgr_AndFilter_1: typeof Handle_SelectMgr_AndFilter_1;
  Handle_SelectMgr_AndFilter_2: typeof Handle_SelectMgr_AndFilter_2;
  Handle_SelectMgr_AndFilter_3: typeof Handle_SelectMgr_AndFilter_3;
  Handle_SelectMgr_AndFilter_4: typeof Handle_SelectMgr_AndFilter_4;
  SelectMgr_AndFilter: typeof SelectMgr_AndFilter;
  SelectMgr_BVHThreadPool: typeof SelectMgr_BVHThreadPool;
  SelectMgr_SelectionManager: typeof SelectMgr_SelectionManager;
  Handle_SelectMgr_SelectionManager: typeof Handle_SelectMgr_SelectionManager;
  Handle_SelectMgr_SelectionManager_1: typeof Handle_SelectMgr_SelectionManager_1;
  Handle_SelectMgr_SelectionManager_2: typeof Handle_SelectMgr_SelectionManager_2;
  Handle_SelectMgr_SelectionManager_3: typeof Handle_SelectMgr_SelectionManager_3;
  Handle_SelectMgr_SelectionManager_4: typeof Handle_SelectMgr_SelectionManager_4;
  Handle_SelectMgr_AndOrFilter: typeof Handle_SelectMgr_AndOrFilter;
  Handle_SelectMgr_AndOrFilter_1: typeof Handle_SelectMgr_AndOrFilter_1;
  Handle_SelectMgr_AndOrFilter_2: typeof Handle_SelectMgr_AndOrFilter_2;
  Handle_SelectMgr_AndOrFilter_3: typeof Handle_SelectMgr_AndOrFilter_3;
  Handle_SelectMgr_AndOrFilter_4: typeof Handle_SelectMgr_AndOrFilter_4;
  SelectMgr_AndOrFilter: typeof SelectMgr_AndOrFilter;
  SelectMgr_TriangularFrustum: typeof SelectMgr_TriangularFrustum;
  SelectMgr_SortCriterion: typeof SelectMgr_SortCriterion;
  SelectMgr_TypeOfBVHUpdate: SelectMgr_TypeOfBVHUpdate;
  SelectMgr: typeof SelectMgr;
  SelectMgr_ToleranceMap: typeof SelectMgr_ToleranceMap;
  SelectMgr_StateOfSelection: SelectMgr_StateOfSelection;
  SelectMgr_SelectingVolumeManager: typeof SelectMgr_SelectingVolumeManager;
  SelectMgr_SelectionImageFiller: typeof SelectMgr_SelectionImageFiller;
  SelectMgr_TypeOfUpdate: SelectMgr_TypeOfUpdate;
  SelectMgr_Selection: typeof SelectMgr_Selection;
  Handle_SelectMgr_Selection: typeof Handle_SelectMgr_Selection;
  Handle_SelectMgr_Selection_1: typeof Handle_SelectMgr_Selection_1;
  Handle_SelectMgr_Selection_2: typeof Handle_SelectMgr_Selection_2;
  Handle_SelectMgr_Selection_3: typeof Handle_SelectMgr_Selection_3;
  Handle_SelectMgr_Selection_4: typeof Handle_SelectMgr_Selection_4;
  SelectMgr_OrFilter: typeof SelectMgr_OrFilter;
  Handle_SelectMgr_OrFilter: typeof Handle_SelectMgr_OrFilter;
  Handle_SelectMgr_OrFilter_1: typeof Handle_SelectMgr_OrFilter_1;
  Handle_SelectMgr_OrFilter_2: typeof Handle_SelectMgr_OrFilter_2;
  Handle_SelectMgr_OrFilter_3: typeof Handle_SelectMgr_OrFilter_3;
  Handle_SelectMgr_OrFilter_4: typeof Handle_SelectMgr_OrFilter_4;
  SelectMgr_Filter: typeof SelectMgr_Filter;
  Handle_SelectMgr_Filter: typeof Handle_SelectMgr_Filter;
  Handle_SelectMgr_Filter_1: typeof Handle_SelectMgr_Filter_1;
  Handle_SelectMgr_Filter_2: typeof Handle_SelectMgr_Filter_2;
  Handle_SelectMgr_Filter_3: typeof Handle_SelectMgr_Filter_3;
  Handle_SelectMgr_Filter_4: typeof Handle_SelectMgr_Filter_4;
  SelectMgr_SelectableObjectSet: typeof SelectMgr_SelectableObjectSet;
  Handle_SelectMgr_SelectableObject: typeof Handle_SelectMgr_SelectableObject;
  Handle_SelectMgr_SelectableObject_1: typeof Handle_SelectMgr_SelectableObject_1;
  Handle_SelectMgr_SelectableObject_2: typeof Handle_SelectMgr_SelectableObject_2;
  Handle_SelectMgr_SelectableObject_3: typeof Handle_SelectMgr_SelectableObject_3;
  Handle_SelectMgr_SelectableObject_4: typeof Handle_SelectMgr_SelectableObject_4;
  SelectMgr_SelectableObject: typeof SelectMgr_SelectableObject;
  SelectMgr_FilterType: SelectMgr_FilterType;
  SelectMgr_SensitiveEntitySet: typeof SelectMgr_SensitiveEntitySet;
  SelectMgr_CompositionFilter: typeof SelectMgr_CompositionFilter;
  Handle_SelectMgr_CompositionFilter: typeof Handle_SelectMgr_CompositionFilter;
  Handle_SelectMgr_CompositionFilter_1: typeof Handle_SelectMgr_CompositionFilter_1;
  Handle_SelectMgr_CompositionFilter_2: typeof Handle_SelectMgr_CompositionFilter_2;
  Handle_SelectMgr_CompositionFilter_3: typeof Handle_SelectMgr_CompositionFilter_3;
  Handle_SelectMgr_CompositionFilter_4: typeof Handle_SelectMgr_CompositionFilter_4;
  SelectMgr_SensitiveEntity: typeof SelectMgr_SensitiveEntity;
  Handle_SelectMgr_SensitiveEntity: typeof Handle_SelectMgr_SensitiveEntity;
  Handle_SelectMgr_SensitiveEntity_1: typeof Handle_SelectMgr_SensitiveEntity_1;
  Handle_SelectMgr_SensitiveEntity_2: typeof Handle_SelectMgr_SensitiveEntity_2;
  Handle_SelectMgr_SensitiveEntity_3: typeof Handle_SelectMgr_SensitiveEntity_3;
  Handle_SelectMgr_SensitiveEntity_4: typeof Handle_SelectMgr_SensitiveEntity_4;
  Handle_SelectMgr_ViewerSelector: typeof Handle_SelectMgr_ViewerSelector;
  Handle_SelectMgr_ViewerSelector_1: typeof Handle_SelectMgr_ViewerSelector_1;
  Handle_SelectMgr_ViewerSelector_2: typeof Handle_SelectMgr_ViewerSelector_2;
  Handle_SelectMgr_ViewerSelector_3: typeof Handle_SelectMgr_ViewerSelector_3;
  Handle_SelectMgr_ViewerSelector_4: typeof Handle_SelectMgr_ViewerSelector_4;
  SelectMgr_ViewerSelector: typeof SelectMgr_ViewerSelector;
  SelectMgr_TriangularFrustumSet: typeof SelectMgr_TriangularFrustumSet;
  SelectMgr_PickingStrategy: SelectMgr_PickingStrategy;
  SelectMgr_EntityOwner: typeof SelectMgr_EntityOwner;
  SelectMgr_EntityOwner_1: typeof SelectMgr_EntityOwner_1;
  SelectMgr_EntityOwner_2: typeof SelectMgr_EntityOwner_2;
  SelectMgr_EntityOwner_3: typeof SelectMgr_EntityOwner_3;
  Handle_SelectMgr_EntityOwner: typeof Handle_SelectMgr_EntityOwner;
  Handle_SelectMgr_EntityOwner_1: typeof Handle_SelectMgr_EntityOwner_1;
  Handle_SelectMgr_EntityOwner_2: typeof Handle_SelectMgr_EntityOwner_2;
  Handle_SelectMgr_EntityOwner_3: typeof Handle_SelectMgr_EntityOwner_3;
  Handle_SelectMgr_EntityOwner_4: typeof Handle_SelectMgr_EntityOwner_4;
  SelectMgr_ViewerSelector3d: typeof SelectMgr_ViewerSelector3d;
  Handle_SelectMgr_ViewerSelector3d: typeof Handle_SelectMgr_ViewerSelector3d;
  Handle_SelectMgr_ViewerSelector3d_1: typeof Handle_SelectMgr_ViewerSelector3d_1;
  Handle_SelectMgr_ViewerSelector3d_2: typeof Handle_SelectMgr_ViewerSelector3d_2;
  Handle_SelectMgr_ViewerSelector3d_3: typeof Handle_SelectMgr_ViewerSelector3d_3;
  Handle_SelectMgr_ViewerSelector3d_4: typeof Handle_SelectMgr_ViewerSelector3d_4;
  SelectMgr_FrustumBuilder: typeof SelectMgr_FrustumBuilder;
  Handle_SelectMgr_FrustumBuilder: typeof Handle_SelectMgr_FrustumBuilder;
  Handle_SelectMgr_FrustumBuilder_1: typeof Handle_SelectMgr_FrustumBuilder_1;
  Handle_SelectMgr_FrustumBuilder_2: typeof Handle_SelectMgr_FrustumBuilder_2;
  Handle_SelectMgr_FrustumBuilder_3: typeof Handle_SelectMgr_FrustumBuilder_3;
  Handle_SelectMgr_FrustumBuilder_4: typeof Handle_SelectMgr_FrustumBuilder_4;
  SelectMgr_RectangularFrustum: typeof SelectMgr_RectangularFrustum;
  SelectMgr_ViewClipRange: typeof SelectMgr_ViewClipRange;
  Handle_TransferBRep_HSequenceOfTransferResultInfo: typeof Handle_TransferBRep_HSequenceOfTransferResultInfo;
  Handle_TransferBRep_HSequenceOfTransferResultInfo_1: typeof Handle_TransferBRep_HSequenceOfTransferResultInfo_1;
  Handle_TransferBRep_HSequenceOfTransferResultInfo_2: typeof Handle_TransferBRep_HSequenceOfTransferResultInfo_2;
  Handle_TransferBRep_HSequenceOfTransferResultInfo_3: typeof Handle_TransferBRep_HSequenceOfTransferResultInfo_3;
  Handle_TransferBRep_HSequenceOfTransferResultInfo_4: typeof Handle_TransferBRep_HSequenceOfTransferResultInfo_4;
  TransferBRep_ShapeInfo: typeof TransferBRep_ShapeInfo;
  Handle_TransferBRep_ShapeMapper: typeof Handle_TransferBRep_ShapeMapper;
  Handle_TransferBRep_ShapeMapper_1: typeof Handle_TransferBRep_ShapeMapper_1;
  Handle_TransferBRep_ShapeMapper_2: typeof Handle_TransferBRep_ShapeMapper_2;
  Handle_TransferBRep_ShapeMapper_3: typeof Handle_TransferBRep_ShapeMapper_3;
  Handle_TransferBRep_ShapeMapper_4: typeof Handle_TransferBRep_ShapeMapper_4;
  TransferBRep_ShapeMapper: typeof TransferBRep_ShapeMapper;
  Handle_TransferBRep_ShapeListBinder: typeof Handle_TransferBRep_ShapeListBinder;
  Handle_TransferBRep_ShapeListBinder_1: typeof Handle_TransferBRep_ShapeListBinder_1;
  Handle_TransferBRep_ShapeListBinder_2: typeof Handle_TransferBRep_ShapeListBinder_2;
  Handle_TransferBRep_ShapeListBinder_3: typeof Handle_TransferBRep_ShapeListBinder_3;
  Handle_TransferBRep_ShapeListBinder_4: typeof Handle_TransferBRep_ShapeListBinder_4;
  TransferBRep_ShapeListBinder: typeof TransferBRep_ShapeListBinder;
  TransferBRep_ShapeListBinder_1: typeof TransferBRep_ShapeListBinder_1;
  TransferBRep_ShapeListBinder_2: typeof TransferBRep_ShapeListBinder_2;
  TransferBRep_Reader: typeof TransferBRep_Reader;
  Handle_TransferBRep_OrientedShapeMapper: typeof Handle_TransferBRep_OrientedShapeMapper;
  Handle_TransferBRep_OrientedShapeMapper_1: typeof Handle_TransferBRep_OrientedShapeMapper_1;
  Handle_TransferBRep_OrientedShapeMapper_2: typeof Handle_TransferBRep_OrientedShapeMapper_2;
  Handle_TransferBRep_OrientedShapeMapper_3: typeof Handle_TransferBRep_OrientedShapeMapper_3;
  Handle_TransferBRep_OrientedShapeMapper_4: typeof Handle_TransferBRep_OrientedShapeMapper_4;
  TransferBRep_OrientedShapeMapper: typeof TransferBRep_OrientedShapeMapper;
  TransferBRep_TransferResultInfo: typeof TransferBRep_TransferResultInfo;
  Handle_TransferBRep_TransferResultInfo: typeof Handle_TransferBRep_TransferResultInfo;
  Handle_TransferBRep_TransferResultInfo_1: typeof Handle_TransferBRep_TransferResultInfo_1;
  Handle_TransferBRep_TransferResultInfo_2: typeof Handle_TransferBRep_TransferResultInfo_2;
  Handle_TransferBRep_TransferResultInfo_3: typeof Handle_TransferBRep_TransferResultInfo_3;
  Handle_TransferBRep_TransferResultInfo_4: typeof Handle_TransferBRep_TransferResultInfo_4;
  TransferBRep_BinderOfShape: typeof TransferBRep_BinderOfShape;
  TransferBRep_BinderOfShape_1: typeof TransferBRep_BinderOfShape_1;
  TransferBRep_BinderOfShape_2: typeof TransferBRep_BinderOfShape_2;
  Handle_TransferBRep_BinderOfShape: typeof Handle_TransferBRep_BinderOfShape;
  Handle_TransferBRep_BinderOfShape_1: typeof Handle_TransferBRep_BinderOfShape_1;
  Handle_TransferBRep_BinderOfShape_2: typeof Handle_TransferBRep_BinderOfShape_2;
  Handle_TransferBRep_BinderOfShape_3: typeof Handle_TransferBRep_BinderOfShape_3;
  Handle_TransferBRep_BinderOfShape_4: typeof Handle_TransferBRep_BinderOfShape_4;
  Handle_TransferBRep_ShapeBinder: typeof Handle_TransferBRep_ShapeBinder;
  Handle_TransferBRep_ShapeBinder_1: typeof Handle_TransferBRep_ShapeBinder_1;
  Handle_TransferBRep_ShapeBinder_2: typeof Handle_TransferBRep_ShapeBinder_2;
  Handle_TransferBRep_ShapeBinder_3: typeof Handle_TransferBRep_ShapeBinder_3;
  Handle_TransferBRep_ShapeBinder_4: typeof Handle_TransferBRep_ShapeBinder_4;
  TransferBRep_ShapeBinder: typeof TransferBRep_ShapeBinder;
  TransferBRep_ShapeBinder_1: typeof TransferBRep_ShapeBinder_1;
  TransferBRep_ShapeBinder_2: typeof TransferBRep_ShapeBinder_2;
  HLRBRep_FaceIterator: typeof HLRBRep_FaceIterator;
  Handle_HLRBRep_Data: typeof Handle_HLRBRep_Data;
  Handle_HLRBRep_Data_1: typeof Handle_HLRBRep_Data_1;
  Handle_HLRBRep_Data_2: typeof Handle_HLRBRep_Data_2;
  Handle_HLRBRep_Data_3: typeof Handle_HLRBRep_Data_3;
  Handle_HLRBRep_Data_4: typeof Handle_HLRBRep_Data_4;
  HLRBRep_Data: typeof HLRBRep_Data;
  HLRBRep_EdgeFaceTool: typeof HLRBRep_EdgeFaceTool;
  HLRBRep_ShapeBounds: typeof HLRBRep_ShapeBounds;
  HLRBRep_ShapeBounds_1: typeof HLRBRep_ShapeBounds_1;
  HLRBRep_ShapeBounds_2: typeof HLRBRep_ShapeBounds_2;
  HLRBRep_ShapeBounds_3: typeof HLRBRep_ShapeBounds_3;
  HLRBRep_HLRToShape: typeof HLRBRep_HLRToShape;
  HLRBRep_TheInterferenceOfInterCSurf: typeof HLRBRep_TheInterferenceOfInterCSurf;
  HLRBRep_TheInterferenceOfInterCSurf_1: typeof HLRBRep_TheInterferenceOfInterCSurf_1;
  HLRBRep_TheInterferenceOfInterCSurf_2: typeof HLRBRep_TheInterferenceOfInterCSurf_2;
  HLRBRep_TheInterferenceOfInterCSurf_3: typeof HLRBRep_TheInterferenceOfInterCSurf_3;
  HLRBRep_TheInterferenceOfInterCSurf_4: typeof HLRBRep_TheInterferenceOfInterCSurf_4;
  HLRBRep_TheInterferenceOfInterCSurf_5: typeof HLRBRep_TheInterferenceOfInterCSurf_5;
  HLRBRep_TheInterferenceOfInterCSurf_6: typeof HLRBRep_TheInterferenceOfInterCSurf_6;
  HLRBRep_TheInterferenceOfInterCSurf_7: typeof HLRBRep_TheInterferenceOfInterCSurf_7;
  HLRBRep_CurveTool: typeof HLRBRep_CurveTool;
  HLRBRep_CInter: typeof HLRBRep_CInter;
  HLRBRep_CInter_1: typeof HLRBRep_CInter_1;
  HLRBRep_CInter_2: typeof HLRBRep_CInter_2;
  HLRBRep_CInter_3: typeof HLRBRep_CInter_3;
  HLRBRep_CInter_4: typeof HLRBRep_CInter_4;
  HLRBRep_CInter_5: typeof HLRBRep_CInter_5;
  HLRBRep_CInter_6: typeof HLRBRep_CInter_6;
  HLRBRep_CInter_7: typeof HLRBRep_CInter_7;
  HLRBRep_Algo: typeof HLRBRep_Algo;
  HLRBRep_Algo_1: typeof HLRBRep_Algo_1;
  HLRBRep_Algo_2: typeof HLRBRep_Algo_2;
  Handle_HLRBRep_Algo: typeof Handle_HLRBRep_Algo;
  Handle_HLRBRep_Algo_1: typeof Handle_HLRBRep_Algo_1;
  Handle_HLRBRep_Algo_2: typeof Handle_HLRBRep_Algo_2;
  Handle_HLRBRep_Algo_3: typeof Handle_HLRBRep_Algo_3;
  Handle_HLRBRep_Algo_4: typeof Handle_HLRBRep_Algo_4;
  HLRBRep_ListOfBPoint: typeof HLRBRep_ListOfBPoint;
  HLRBRep_ListOfBPoint_1: typeof HLRBRep_ListOfBPoint_1;
  HLRBRep_ListOfBPoint_2: typeof HLRBRep_ListOfBPoint_2;
  HLRBRep_ListOfBPoint_3: typeof HLRBRep_ListOfBPoint_3;
  HLRBRep_ThePolygonOfInterCSurf: typeof HLRBRep_ThePolygonOfInterCSurf;
  HLRBRep_ThePolygonOfInterCSurf_1: typeof HLRBRep_ThePolygonOfInterCSurf_1;
  HLRBRep_ThePolygonOfInterCSurf_2: typeof HLRBRep_ThePolygonOfInterCSurf_2;
  HLRBRep_ThePolygonOfInterCSurf_3: typeof HLRBRep_ThePolygonOfInterCSurf_3;
  HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter: typeof HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter;
  HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter_1: typeof HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter_1;
  HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter_2: typeof HLRBRep_PCLocFOfTheLocateExtPCOfTheProjPCurOfCInter_2;
  HLRBRep_CLPropsATool: typeof HLRBRep_CLPropsATool;
  HLRBRep_SLProps: typeof HLRBRep_SLProps;
  HLRBRep_SLProps_1: typeof HLRBRep_SLProps_1;
  HLRBRep_SLProps_2: typeof HLRBRep_SLProps_2;
  HLRBRep_SLProps_3: typeof HLRBRep_SLProps_3;
  HLRBRep_TheCSFunctionOfInterCSurf: typeof HLRBRep_TheCSFunctionOfInterCSurf;
  HLRBRep_TheDistBetweenPCurvesOfTheIntPCurvePCurveOfCInter: typeof HLRBRep_TheDistBetweenPCurvesOfTheIntPCurvePCurveOfCInter;
  HLRBRep_InterCSurf: typeof HLRBRep_InterCSurf;
  HLRBRep_TheIntPCurvePCurveOfCInter: typeof HLRBRep_TheIntPCurvePCurveOfCInter;
  HLRBRep_ListOfBPnt2D: typeof HLRBRep_ListOfBPnt2D;
  HLRBRep_ListOfBPnt2D_1: typeof HLRBRep_ListOfBPnt2D_1;
  HLRBRep_ListOfBPnt2D_2: typeof HLRBRep_ListOfBPnt2D_2;
  HLRBRep_ListOfBPnt2D_3: typeof HLRBRep_ListOfBPnt2D_3;
  HLRBRep_SLPropsATool: typeof HLRBRep_SLPropsATool;
  Handle_HLRBRep_InternalAlgo: typeof Handle_HLRBRep_InternalAlgo;
  Handle_HLRBRep_InternalAlgo_1: typeof Handle_HLRBRep_InternalAlgo_1;
  Handle_HLRBRep_InternalAlgo_2: typeof Handle_HLRBRep_InternalAlgo_2;
  Handle_HLRBRep_InternalAlgo_3: typeof Handle_HLRBRep_InternalAlgo_3;
  Handle_HLRBRep_InternalAlgo_4: typeof Handle_HLRBRep_InternalAlgo_4;
  HLRBRep_InternalAlgo: typeof HLRBRep_InternalAlgo;
  HLRBRep_InternalAlgo_1: typeof HLRBRep_InternalAlgo_1;
  HLRBRep_InternalAlgo_2: typeof HLRBRep_InternalAlgo_2;
  HLRBRep_Array1OfFData: typeof HLRBRep_Array1OfFData;
  HLRBRep_Array1OfFData_1: typeof HLRBRep_Array1OfFData_1;
  HLRBRep_Array1OfFData_2: typeof HLRBRep_Array1OfFData_2;
  HLRBRep_Array1OfFData_3: typeof HLRBRep_Array1OfFData_3;
  HLRBRep_Array1OfFData_4: typeof HLRBRep_Array1OfFData_4;
  HLRBRep_Array1OfFData_5: typeof HLRBRep_Array1OfFData_5;
  HLRBRep_IntConicCurveOfCInter: typeof HLRBRep_IntConicCurveOfCInter;
  HLRBRep_IntConicCurveOfCInter_1: typeof HLRBRep_IntConicCurveOfCInter_1;
  HLRBRep_IntConicCurveOfCInter_2: typeof HLRBRep_IntConicCurveOfCInter_2;
  HLRBRep_IntConicCurveOfCInter_3: typeof HLRBRep_IntConicCurveOfCInter_3;
  HLRBRep_IntConicCurveOfCInter_4: typeof HLRBRep_IntConicCurveOfCInter_4;
  HLRBRep_IntConicCurveOfCInter_5: typeof HLRBRep_IntConicCurveOfCInter_5;
  HLRBRep_IntConicCurveOfCInter_6: typeof HLRBRep_IntConicCurveOfCInter_6;
  HLRBRep_SeqOfShapeBounds: typeof HLRBRep_SeqOfShapeBounds;
  HLRBRep_SeqOfShapeBounds_1: typeof HLRBRep_SeqOfShapeBounds_1;
  HLRBRep_SeqOfShapeBounds_2: typeof HLRBRep_SeqOfShapeBounds_2;
  HLRBRep_SeqOfShapeBounds_3: typeof HLRBRep_SeqOfShapeBounds_3;
  HLRBRep_BCurveTool: typeof HLRBRep_BCurveTool;
  HLRBRep_EdgeInterferenceTool: typeof HLRBRep_EdgeInterferenceTool;
  HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter: typeof HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter;
  HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_1: typeof HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_1;
  HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_2: typeof HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_2;
  HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_3: typeof HLRBRep_TheLocateExtPCOfTheProjPCurOfCInter_3;
  HLRBRep_ThePolygon2dOfTheIntPCurvePCurveOfCInter: typeof HLRBRep_ThePolygon2dOfTheIntPCurvePCurveOfCInter;
  HLRBRep_PolyHLRToShape: typeof HLRBRep_PolyHLRToShape;
  HLRBRep_TypeOfResultingEdge: HLRBRep_TypeOfResultingEdge;
  HLRBRep_FaceData: typeof HLRBRep_FaceData;
  HLRBRep_BiPoint: typeof HLRBRep_BiPoint;
  HLRBRep_BiPoint_1: typeof HLRBRep_BiPoint_1;
  HLRBRep_BiPoint_2: typeof HLRBRep_BiPoint_2;
  HLRBRep_ThePolygonToolOfInterCSurf: typeof HLRBRep_ThePolygonToolOfInterCSurf;
  HLRBRep_AreaLimit: typeof HLRBRep_AreaLimit;
  Handle_HLRBRep_AreaLimit: typeof Handle_HLRBRep_AreaLimit;
  Handle_HLRBRep_AreaLimit_1: typeof Handle_HLRBRep_AreaLimit_1;
  Handle_HLRBRep_AreaLimit_2: typeof Handle_HLRBRep_AreaLimit_2;
  Handle_HLRBRep_AreaLimit_3: typeof Handle_HLRBRep_AreaLimit_3;
  Handle_HLRBRep_AreaLimit_4: typeof Handle_HLRBRep_AreaLimit_4;
  HLRBRep_TheProjPCurOfCInter: typeof HLRBRep_TheProjPCurOfCInter;
  HLRBRep_ThePolyhedronToolOfInterCSurf: typeof HLRBRep_ThePolyhedronToolOfInterCSurf;
  HLRBRep_BiPnt2D: typeof HLRBRep_BiPnt2D;
  HLRBRep_BiPnt2D_1: typeof HLRBRep_BiPnt2D_1;
  HLRBRep_BiPnt2D_2: typeof HLRBRep_BiPnt2D_2;
  HLRBRep_BiPnt2D_3: typeof HLRBRep_BiPnt2D_3;
  HLRBRep_EdgeData: typeof HLRBRep_EdgeData;
  HLRBRep_Curve: typeof HLRBRep_Curve;
  HLRBRep_LineTool: typeof HLRBRep_LineTool;
  HLRBRep_Hider: typeof HLRBRep_Hider;
  HLRBRep_ExactIntersectionPointOfTheIntPCurvePCurveOfCInter: typeof HLRBRep_ExactIntersectionPointOfTheIntPCurvePCurveOfCInter;
  HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter: typeof HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter;
  HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter_1: typeof HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter_1;
  HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter_2: typeof HLRBRep_TheIntersectorOfTheIntConicCurveOfCInter_2;
  HLRBRep_ShapeToHLR: typeof HLRBRep_ShapeToHLR;
  HLRBRep_EdgeIList: typeof HLRBRep_EdgeIList;
  HLRBRep: typeof HLRBRep;
  HLRBRep_TheIntConicCurveOfCInter: typeof HLRBRep_TheIntConicCurveOfCInter;
  HLRBRep_TheIntConicCurveOfCInter_1: typeof HLRBRep_TheIntConicCurveOfCInter_1;
  HLRBRep_TheIntConicCurveOfCInter_2: typeof HLRBRep_TheIntConicCurveOfCInter_2;
  HLRBRep_TheIntConicCurveOfCInter_3: typeof HLRBRep_TheIntConicCurveOfCInter_3;
  HLRBRep_TheIntConicCurveOfCInter_4: typeof HLRBRep_TheIntConicCurveOfCInter_4;
  HLRBRep_TheIntConicCurveOfCInter_5: typeof HLRBRep_TheIntConicCurveOfCInter_5;
  HLRBRep_TheIntConicCurveOfCInter_6: typeof HLRBRep_TheIntConicCurveOfCInter_6;
  HLRBRep_Array1OfEData: typeof HLRBRep_Array1OfEData;
  HLRBRep_Array1OfEData_1: typeof HLRBRep_Array1OfEData_1;
  HLRBRep_Array1OfEData_2: typeof HLRBRep_Array1OfEData_2;
  HLRBRep_Array1OfEData_3: typeof HLRBRep_Array1OfEData_3;
  HLRBRep_Array1OfEData_4: typeof HLRBRep_Array1OfEData_4;
  HLRBRep_Array1OfEData_5: typeof HLRBRep_Array1OfEData_5;
  HLRBRep_EdgeBuilder: typeof HLRBRep_EdgeBuilder;
  HLRBRep_TheQuadCurvFuncOfTheQuadCurvExactInterCSurf: typeof HLRBRep_TheQuadCurvFuncOfTheQuadCurvExactInterCSurf;
  HLRBRep_PolyAlgo: typeof HLRBRep_PolyAlgo;
  HLRBRep_PolyAlgo_1: typeof HLRBRep_PolyAlgo_1;
  HLRBRep_PolyAlgo_2: typeof HLRBRep_PolyAlgo_2;
  HLRBRep_PolyAlgo_3: typeof HLRBRep_PolyAlgo_3;
  Handle_HLRBRep_PolyAlgo: typeof Handle_HLRBRep_PolyAlgo;
  Handle_HLRBRep_PolyAlgo_1: typeof Handle_HLRBRep_PolyAlgo_1;
  Handle_HLRBRep_PolyAlgo_2: typeof Handle_HLRBRep_PolyAlgo_2;
  Handle_HLRBRep_PolyAlgo_3: typeof Handle_HLRBRep_PolyAlgo_3;
  Handle_HLRBRep_PolyAlgo_4: typeof Handle_HLRBRep_PolyAlgo_4;
  HLRBRep_TheExactInterCSurf: typeof HLRBRep_TheExactInterCSurf;
  HLRBRep_TheExactInterCSurf_1: typeof HLRBRep_TheExactInterCSurf_1;
  HLRBRep_TheExactInterCSurf_2: typeof HLRBRep_TheExactInterCSurf_2;
  HLRBRep_MyImpParToolOfTheIntersectorOfTheIntConicCurveOfCInter: typeof HLRBRep_MyImpParToolOfTheIntersectorOfTheIntConicCurveOfCInter;
  HLRBRep_SurfaceTool: typeof HLRBRep_SurfaceTool;
  HLRBRep_VertexList: typeof HLRBRep_VertexList;
  HLRBRep_TheQuadCurvExactInterCSurf: typeof HLRBRep_TheQuadCurvExactInterCSurf;
  XCAFPrs_DocumentIdIterator: typeof XCAFPrs_DocumentIdIterator;
  XCAFPrs_DataMapOfStyleShape: typeof XCAFPrs_DataMapOfStyleShape;
  XCAFPrs_DataMapOfStyleShape_1: typeof XCAFPrs_DataMapOfStyleShape_1;
  XCAFPrs_DataMapOfStyleShape_2: typeof XCAFPrs_DataMapOfStyleShape_2;
  XCAFPrs_DataMapOfStyleShape_3: typeof XCAFPrs_DataMapOfStyleShape_3;
  XCAFPrs_Texture: typeof XCAFPrs_Texture;
  XCAFPrs_IndexedDataMapOfShapeStyle: typeof XCAFPrs_IndexedDataMapOfShapeStyle;
  XCAFPrs_IndexedDataMapOfShapeStyle_1: typeof XCAFPrs_IndexedDataMapOfShapeStyle_1;
  XCAFPrs_IndexedDataMapOfShapeStyle_2: typeof XCAFPrs_IndexedDataMapOfShapeStyle_2;
  XCAFPrs_IndexedDataMapOfShapeStyle_3: typeof XCAFPrs_IndexedDataMapOfShapeStyle_3;
  XCAFPrs_DocumentNode: typeof XCAFPrs_DocumentNode;
  XCAFPrs: typeof XCAFPrs;
  Handle_XCAFPrs_AISObject: typeof Handle_XCAFPrs_AISObject;
  Handle_XCAFPrs_AISObject_1: typeof Handle_XCAFPrs_AISObject_1;
  Handle_XCAFPrs_AISObject_2: typeof Handle_XCAFPrs_AISObject_2;
  Handle_XCAFPrs_AISObject_3: typeof Handle_XCAFPrs_AISObject_3;
  Handle_XCAFPrs_AISObject_4: typeof Handle_XCAFPrs_AISObject_4;
  XCAFPrs_AISObject: typeof XCAFPrs_AISObject;
  XCAFPrs_DocumentExplorer: typeof XCAFPrs_DocumentExplorer;
  XCAFPrs_DocumentExplorer_1: typeof XCAFPrs_DocumentExplorer_1;
  XCAFPrs_DocumentExplorer_2: typeof XCAFPrs_DocumentExplorer_2;
  XCAFPrs_DocumentExplorer_3: typeof XCAFPrs_DocumentExplorer_3;
  XCAFPrs_Driver: typeof XCAFPrs_Driver;
  Handle_XCAFPrs_Driver: typeof Handle_XCAFPrs_Driver;
  Handle_XCAFPrs_Driver_1: typeof Handle_XCAFPrs_Driver_1;
  Handle_XCAFPrs_Driver_2: typeof Handle_XCAFPrs_Driver_2;
  Handle_XCAFPrs_Driver_3: typeof Handle_XCAFPrs_Driver_3;
  Handle_XCAFPrs_Driver_4: typeof Handle_XCAFPrs_Driver_4;
  XCAFPrs_Style: typeof XCAFPrs_Style;
  Handle_XmlMDataXtd_PresentationDriver: typeof Handle_XmlMDataXtd_PresentationDriver;
  Handle_XmlMDataXtd_PresentationDriver_1: typeof Handle_XmlMDataXtd_PresentationDriver_1;
  Handle_XmlMDataXtd_PresentationDriver_2: typeof Handle_XmlMDataXtd_PresentationDriver_2;
  Handle_XmlMDataXtd_PresentationDriver_3: typeof Handle_XmlMDataXtd_PresentationDriver_3;
  Handle_XmlMDataXtd_PresentationDriver_4: typeof Handle_XmlMDataXtd_PresentationDriver_4;
  XmlMDataXtd_PresentationDriver: typeof XmlMDataXtd_PresentationDriver;
  Handle_XmlMDataXtd_TriangulationDriver: typeof Handle_XmlMDataXtd_TriangulationDriver;
  Handle_XmlMDataXtd_TriangulationDriver_1: typeof Handle_XmlMDataXtd_TriangulationDriver_1;
  Handle_XmlMDataXtd_TriangulationDriver_2: typeof Handle_XmlMDataXtd_TriangulationDriver_2;
  Handle_XmlMDataXtd_TriangulationDriver_3: typeof Handle_XmlMDataXtd_TriangulationDriver_3;
  Handle_XmlMDataXtd_TriangulationDriver_4: typeof Handle_XmlMDataXtd_TriangulationDriver_4;
  XmlMDataXtd_TriangulationDriver: typeof XmlMDataXtd_TriangulationDriver;
  Handle_XmlMDataXtd_PatternStdDriver: typeof Handle_XmlMDataXtd_PatternStdDriver;
  Handle_XmlMDataXtd_PatternStdDriver_1: typeof Handle_XmlMDataXtd_PatternStdDriver_1;
  Handle_XmlMDataXtd_PatternStdDriver_2: typeof Handle_XmlMDataXtd_PatternStdDriver_2;
  Handle_XmlMDataXtd_PatternStdDriver_3: typeof Handle_XmlMDataXtd_PatternStdDriver_3;
  Handle_XmlMDataXtd_PatternStdDriver_4: typeof Handle_XmlMDataXtd_PatternStdDriver_4;
  XmlMDataXtd_PatternStdDriver: typeof XmlMDataXtd_PatternStdDriver;
  XmlMDataXtd_ConstraintDriver: typeof XmlMDataXtd_ConstraintDriver;
  Handle_XmlMDataXtd_ConstraintDriver: typeof Handle_XmlMDataXtd_ConstraintDriver;
  Handle_XmlMDataXtd_ConstraintDriver_1: typeof Handle_XmlMDataXtd_ConstraintDriver_1;
  Handle_XmlMDataXtd_ConstraintDriver_2: typeof Handle_XmlMDataXtd_ConstraintDriver_2;
  Handle_XmlMDataXtd_ConstraintDriver_3: typeof Handle_XmlMDataXtd_ConstraintDriver_3;
  Handle_XmlMDataXtd_ConstraintDriver_4: typeof Handle_XmlMDataXtd_ConstraintDriver_4;
  XmlMDataXtd_PositionDriver: typeof XmlMDataXtd_PositionDriver;
  Handle_XmlMDataXtd_PositionDriver: typeof Handle_XmlMDataXtd_PositionDriver;
  Handle_XmlMDataXtd_PositionDriver_1: typeof Handle_XmlMDataXtd_PositionDriver_1;
  Handle_XmlMDataXtd_PositionDriver_2: typeof Handle_XmlMDataXtd_PositionDriver_2;
  Handle_XmlMDataXtd_PositionDriver_3: typeof Handle_XmlMDataXtd_PositionDriver_3;
  Handle_XmlMDataXtd_PositionDriver_4: typeof Handle_XmlMDataXtd_PositionDriver_4;
  XmlMDataXtd: typeof XmlMDataXtd;
  Handle_XmlMDataXtd_GeometryDriver: typeof Handle_XmlMDataXtd_GeometryDriver;
  Handle_XmlMDataXtd_GeometryDriver_1: typeof Handle_XmlMDataXtd_GeometryDriver_1;
  Handle_XmlMDataXtd_GeometryDriver_2: typeof Handle_XmlMDataXtd_GeometryDriver_2;
  Handle_XmlMDataXtd_GeometryDriver_3: typeof Handle_XmlMDataXtd_GeometryDriver_3;
  Handle_XmlMDataXtd_GeometryDriver_4: typeof Handle_XmlMDataXtd_GeometryDriver_4;
  XmlMDataXtd_GeometryDriver: typeof XmlMDataXtd_GeometryDriver;
  TDocStd_Application: typeof TDocStd_Application;
  Handle_TDocStd_Application: typeof Handle_TDocStd_Application;
  Handle_TDocStd_Application_1: typeof Handle_TDocStd_Application_1;
  Handle_TDocStd_Application_2: typeof Handle_TDocStd_Application_2;
  Handle_TDocStd_Application_3: typeof Handle_TDocStd_Application_3;
  Handle_TDocStd_Application_4: typeof Handle_TDocStd_Application_4;
  TDocStd_XLink: typeof TDocStd_XLink;
  Handle_TDocStd_XLink: typeof Handle_TDocStd_XLink;
  Handle_TDocStd_XLink_1: typeof Handle_TDocStd_XLink_1;
  Handle_TDocStd_XLink_2: typeof Handle_TDocStd_XLink_2;
  Handle_TDocStd_XLink_3: typeof Handle_TDocStd_XLink_3;
  Handle_TDocStd_XLink_4: typeof Handle_TDocStd_XLink_4;
  TDocStd: typeof TDocStd;
  TDocStd_ApplicationDelta: typeof TDocStd_ApplicationDelta;
  Handle_TDocStd_ApplicationDelta: typeof Handle_TDocStd_ApplicationDelta;
  Handle_TDocStd_ApplicationDelta_1: typeof Handle_TDocStd_ApplicationDelta_1;
  Handle_TDocStd_ApplicationDelta_2: typeof Handle_TDocStd_ApplicationDelta_2;
  Handle_TDocStd_ApplicationDelta_3: typeof Handle_TDocStd_ApplicationDelta_3;
  Handle_TDocStd_ApplicationDelta_4: typeof Handle_TDocStd_ApplicationDelta_4;
  TDocStd_XLinkIterator: typeof TDocStd_XLinkIterator;
  TDocStd_XLinkIterator_1: typeof TDocStd_XLinkIterator_1;
  TDocStd_XLinkIterator_2: typeof TDocStd_XLinkIterator_2;
  Handle_TDocStd_MultiTransactionManager: typeof Handle_TDocStd_MultiTransactionManager;
  Handle_TDocStd_MultiTransactionManager_1: typeof Handle_TDocStd_MultiTransactionManager_1;
  Handle_TDocStd_MultiTransactionManager_2: typeof Handle_TDocStd_MultiTransactionManager_2;
  Handle_TDocStd_MultiTransactionManager_3: typeof Handle_TDocStd_MultiTransactionManager_3;
  Handle_TDocStd_MultiTransactionManager_4: typeof Handle_TDocStd_MultiTransactionManager_4;
  TDocStd_MultiTransactionManager: typeof TDocStd_MultiTransactionManager;
  TDocStd_Document: typeof TDocStd_Document;
  Handle_TDocStd_Document: typeof Handle_TDocStd_Document;
  Handle_TDocStd_Document_1: typeof Handle_TDocStd_Document_1;
  Handle_TDocStd_Document_2: typeof Handle_TDocStd_Document_2;
  Handle_TDocStd_Document_3: typeof Handle_TDocStd_Document_3;
  Handle_TDocStd_Document_4: typeof Handle_TDocStd_Document_4;
  TDocStd_Context: typeof TDocStd_Context;
  Handle_TDocStd_Owner: typeof Handle_TDocStd_Owner;
  Handle_TDocStd_Owner_1: typeof Handle_TDocStd_Owner_1;
  Handle_TDocStd_Owner_2: typeof Handle_TDocStd_Owner_2;
  Handle_TDocStd_Owner_3: typeof Handle_TDocStd_Owner_3;
  Handle_TDocStd_Owner_4: typeof Handle_TDocStd_Owner_4;
  TDocStd_Owner: typeof TDocStd_Owner;
  TDocStd_LabelIDMapDataMap: typeof TDocStd_LabelIDMapDataMap;
  TDocStd_LabelIDMapDataMap_1: typeof TDocStd_LabelIDMapDataMap_1;
  TDocStd_LabelIDMapDataMap_2: typeof TDocStd_LabelIDMapDataMap_2;
  TDocStd_LabelIDMapDataMap_3: typeof TDocStd_LabelIDMapDataMap_3;
  TDocStd_XLinkTool: typeof TDocStd_XLinkTool;
  TDocStd_CompoundDelta: typeof TDocStd_CompoundDelta;
  Handle_TDocStd_CompoundDelta: typeof Handle_TDocStd_CompoundDelta;
  Handle_TDocStd_CompoundDelta_1: typeof Handle_TDocStd_CompoundDelta_1;
  Handle_TDocStd_CompoundDelta_2: typeof Handle_TDocStd_CompoundDelta_2;
  Handle_TDocStd_CompoundDelta_3: typeof Handle_TDocStd_CompoundDelta_3;
  Handle_TDocStd_CompoundDelta_4: typeof Handle_TDocStd_CompoundDelta_4;
  TDocStd_XLinkRoot: typeof TDocStd_XLinkRoot;
  Handle_TDocStd_XLinkRoot: typeof Handle_TDocStd_XLinkRoot;
  Handle_TDocStd_XLinkRoot_1: typeof Handle_TDocStd_XLinkRoot_1;
  Handle_TDocStd_XLinkRoot_2: typeof Handle_TDocStd_XLinkRoot_2;
  Handle_TDocStd_XLinkRoot_3: typeof Handle_TDocStd_XLinkRoot_3;
  Handle_TDocStd_XLinkRoot_4: typeof Handle_TDocStd_XLinkRoot_4;
  TDocStd_PathParser: typeof TDocStd_PathParser;
  TDocStd_Modified: typeof TDocStd_Modified;
  Handle_TDocStd_Modified: typeof Handle_TDocStd_Modified;
  Handle_TDocStd_Modified_1: typeof Handle_TDocStd_Modified_1;
  Handle_TDocStd_Modified_2: typeof Handle_TDocStd_Modified_2;
  Handle_TDocStd_Modified_3: typeof Handle_TDocStd_Modified_3;
  Handle_TDocStd_Modified_4: typeof Handle_TDocStd_Modified_4;
  SelectBasics_PickResult: typeof SelectBasics_PickResult;
  SelectBasics_PickResult_1: typeof SelectBasics_PickResult_1;
  SelectBasics_PickResult_2: typeof SelectBasics_PickResult_2;
  SelectBasics_SelectingVolumeManager: typeof SelectBasics_SelectingVolumeManager;
  SelectBasics: typeof SelectBasics;
  StepAP209_Construct: typeof StepAP209_Construct;
  StepAP209_Construct_1: typeof StepAP209_Construct_1;
  StepAP209_Construct_2: typeof StepAP209_Construct_2;
  Geom2dToIGES_Geom2dCurve: typeof Geom2dToIGES_Geom2dCurve;
  Geom2dToIGES_Geom2dCurve_1: typeof Geom2dToIGES_Geom2dCurve_1;
  Geom2dToIGES_Geom2dCurve_2: typeof Geom2dToIGES_Geom2dCurve_2;
  Geom2dToIGES_Geom2dPoint: typeof Geom2dToIGES_Geom2dPoint;
  Geom2dToIGES_Geom2dPoint_1: typeof Geom2dToIGES_Geom2dPoint_1;
  Geom2dToIGES_Geom2dPoint_2: typeof Geom2dToIGES_Geom2dPoint_2;
  Geom2dToIGES_Geom2dVector: typeof Geom2dToIGES_Geom2dVector;
  Geom2dToIGES_Geom2dVector_1: typeof Geom2dToIGES_Geom2dVector_1;
  Geom2dToIGES_Geom2dVector_2: typeof Geom2dToIGES_Geom2dVector_2;
  Geom2dToIGES_Geom2dEntity: typeof Geom2dToIGES_Geom2dEntity;
  Geom2dToIGES_Geom2dEntity_1: typeof Geom2dToIGES_Geom2dEntity_1;
  Geom2dToIGES_Geom2dEntity_2: typeof Geom2dToIGES_Geom2dEntity_2;
  BRepClass3d_Intersector3d: typeof BRepClass3d_Intersector3d;
  BRepClass3d_SolidClassifier: typeof BRepClass3d_SolidClassifier;
  BRepClass3d_SolidClassifier_1: typeof BRepClass3d_SolidClassifier_1;
  BRepClass3d_SolidClassifier_2: typeof BRepClass3d_SolidClassifier_2;
  BRepClass3d_SolidClassifier_3: typeof BRepClass3d_SolidClassifier_3;
  BRepClass3d_SolidPassiveClassifier: typeof BRepClass3d_SolidPassiveClassifier;
  BRepClass3d_MapOfInter: typeof BRepClass3d_MapOfInter;
  BRepClass3d_MapOfInter_1: typeof BRepClass3d_MapOfInter_1;
  BRepClass3d_MapOfInter_2: typeof BRepClass3d_MapOfInter_2;
  BRepClass3d_MapOfInter_3: typeof BRepClass3d_MapOfInter_3;
  BRepClass3d_BndBoxTreeSelectorPoint: typeof BRepClass3d_BndBoxTreeSelectorPoint;
  BRepClass3d_BndBoxTreeSelectorLine: typeof BRepClass3d_BndBoxTreeSelectorLine;
  BRepClass3d_SolidExplorer: typeof BRepClass3d_SolidExplorer;
  BRepClass3d_SolidExplorer_1: typeof BRepClass3d_SolidExplorer_1;
  BRepClass3d_SolidExplorer_2: typeof BRepClass3d_SolidExplorer_2;
  BRepClass3d: typeof BRepClass3d;
  BRepClass3d_SClassifier: typeof BRepClass3d_SClassifier;
  BRepClass3d_SClassifier_1: typeof BRepClass3d_SClassifier_1;
  BRepClass3d_SClassifier_2: typeof BRepClass3d_SClassifier_2;
  UnitsAPI_SystemUnits: UnitsAPI_SystemUnits;
  UnitsAPI: typeof UnitsAPI;
  IntRes2d_IntersectionSegment: typeof IntRes2d_IntersectionSegment;
  IntRes2d_IntersectionSegment_1: typeof IntRes2d_IntersectionSegment_1;
  IntRes2d_IntersectionSegment_2: typeof IntRes2d_IntersectionSegment_2;
  IntRes2d_IntersectionSegment_3: typeof IntRes2d_IntersectionSegment_3;
  IntRes2d_IntersectionSegment_4: typeof IntRes2d_IntersectionSegment_4;
  IntRes2d_TypeTrans: IntRes2d_TypeTrans;
  IntRes2d_Position: IntRes2d_Position;
  IntRes2d_Transition: typeof IntRes2d_Transition;
  IntRes2d_Transition_1: typeof IntRes2d_Transition_1;
  IntRes2d_Transition_2: typeof IntRes2d_Transition_2;
  IntRes2d_Transition_3: typeof IntRes2d_Transition_3;
  IntRes2d_Transition_4: typeof IntRes2d_Transition_4;
  IntRes2d_SequenceOfIntersectionPoint: typeof IntRes2d_SequenceOfIntersectionPoint;
  IntRes2d_SequenceOfIntersectionPoint_1: typeof IntRes2d_SequenceOfIntersectionPoint_1;
  IntRes2d_SequenceOfIntersectionPoint_2: typeof IntRes2d_SequenceOfIntersectionPoint_2;
  IntRes2d_SequenceOfIntersectionPoint_3: typeof IntRes2d_SequenceOfIntersectionPoint_3;
  IntRes2d_Domain: typeof IntRes2d_Domain;
  IntRes2d_Domain_1: typeof IntRes2d_Domain_1;
  IntRes2d_Domain_2: typeof IntRes2d_Domain_2;
  IntRes2d_Domain_3: typeof IntRes2d_Domain_3;
  IntRes2d_Situation: IntRes2d_Situation;
  IntRes2d_IntersectionPoint: typeof IntRes2d_IntersectionPoint;
  IntRes2d_IntersectionPoint_1: typeof IntRes2d_IntersectionPoint_1;
  IntRes2d_IntersectionPoint_2: typeof IntRes2d_IntersectionPoint_2;
  IntRes2d_SequenceOfIntersectionSegment: typeof IntRes2d_SequenceOfIntersectionSegment;
  IntRes2d_SequenceOfIntersectionSegment_1: typeof IntRes2d_SequenceOfIntersectionSegment_1;
  IntRes2d_SequenceOfIntersectionSegment_2: typeof IntRes2d_SequenceOfIntersectionSegment_2;
  IntRes2d_SequenceOfIntersectionSegment_3: typeof IntRes2d_SequenceOfIntersectionSegment_3;
  IntRes2d_Intersection: typeof IntRes2d_Intersection;
  Geom2dConvert: typeof Geom2dConvert;
  Geom2dConvert_BSplineCurveKnotSplitting: typeof Geom2dConvert_BSplineCurveKnotSplitting;
  Geom2dConvert_CompCurveToBSplineCurve: typeof Geom2dConvert_CompCurveToBSplineCurve;
  Geom2dConvert_CompCurveToBSplineCurve_1: typeof Geom2dConvert_CompCurveToBSplineCurve_1;
  Geom2dConvert_CompCurveToBSplineCurve_2: typeof Geom2dConvert_CompCurveToBSplineCurve_2;
  Geom2dConvert_ApproxCurve: typeof Geom2dConvert_ApproxCurve;
  Geom2dConvert_ApproxCurve_1: typeof Geom2dConvert_ApproxCurve_1;
  Geom2dConvert_ApproxCurve_2: typeof Geom2dConvert_ApproxCurve_2;
  Geom2dConvert_BSplineCurveToBezierCurve: typeof Geom2dConvert_BSplineCurveToBezierCurve;
  Geom2dConvert_BSplineCurveToBezierCurve_1: typeof Geom2dConvert_BSplineCurveToBezierCurve_1;
  Geom2dConvert_BSplineCurveToBezierCurve_2: typeof Geom2dConvert_BSplineCurveToBezierCurve_2;
  BinMDataXtd_PositionDriver: typeof BinMDataXtd_PositionDriver;
  Handle_BinMDataXtd_PositionDriver: typeof Handle_BinMDataXtd_PositionDriver;
  Handle_BinMDataXtd_PositionDriver_1: typeof Handle_BinMDataXtd_PositionDriver_1;
  Handle_BinMDataXtd_PositionDriver_2: typeof Handle_BinMDataXtd_PositionDriver_2;
  Handle_BinMDataXtd_PositionDriver_3: typeof Handle_BinMDataXtd_PositionDriver_3;
  Handle_BinMDataXtd_PositionDriver_4: typeof Handle_BinMDataXtd_PositionDriver_4;
  Handle_BinMDataXtd_GeometryDriver: typeof Handle_BinMDataXtd_GeometryDriver;
  Handle_BinMDataXtd_GeometryDriver_1: typeof Handle_BinMDataXtd_GeometryDriver_1;
  Handle_BinMDataXtd_GeometryDriver_2: typeof Handle_BinMDataXtd_GeometryDriver_2;
  Handle_BinMDataXtd_GeometryDriver_3: typeof Handle_BinMDataXtd_GeometryDriver_3;
  Handle_BinMDataXtd_GeometryDriver_4: typeof Handle_BinMDataXtd_GeometryDriver_4;
  BinMDataXtd_GeometryDriver: typeof BinMDataXtd_GeometryDriver;
  Handle_BinMDataXtd_PatternStdDriver: typeof Handle_BinMDataXtd_PatternStdDriver;
  Handle_BinMDataXtd_PatternStdDriver_1: typeof Handle_BinMDataXtd_PatternStdDriver_1;
  Handle_BinMDataXtd_PatternStdDriver_2: typeof Handle_BinMDataXtd_PatternStdDriver_2;
  Handle_BinMDataXtd_PatternStdDriver_3: typeof Handle_BinMDataXtd_PatternStdDriver_3;
  Handle_BinMDataXtd_PatternStdDriver_4: typeof Handle_BinMDataXtd_PatternStdDriver_4;
  BinMDataXtd_PatternStdDriver: typeof BinMDataXtd_PatternStdDriver;
  BinMDataXtd_TriangulationDriver: typeof BinMDataXtd_TriangulationDriver;
  Handle_BinMDataXtd_TriangulationDriver: typeof Handle_BinMDataXtd_TriangulationDriver;
  Handle_BinMDataXtd_TriangulationDriver_1: typeof Handle_BinMDataXtd_TriangulationDriver_1;
  Handle_BinMDataXtd_TriangulationDriver_2: typeof Handle_BinMDataXtd_TriangulationDriver_2;
  Handle_BinMDataXtd_TriangulationDriver_3: typeof Handle_BinMDataXtd_TriangulationDriver_3;
  Handle_BinMDataXtd_TriangulationDriver_4: typeof Handle_BinMDataXtd_TriangulationDriver_4;
  BinMDataXtd: typeof BinMDataXtd;
  Handle_BinMDataXtd_ConstraintDriver: typeof Handle_BinMDataXtd_ConstraintDriver;
  Handle_BinMDataXtd_ConstraintDriver_1: typeof Handle_BinMDataXtd_ConstraintDriver_1;
  Handle_BinMDataXtd_ConstraintDriver_2: typeof Handle_BinMDataXtd_ConstraintDriver_2;
  Handle_BinMDataXtd_ConstraintDriver_3: typeof Handle_BinMDataXtd_ConstraintDriver_3;
  Handle_BinMDataXtd_ConstraintDriver_4: typeof Handle_BinMDataXtd_ConstraintDriver_4;
  BinMDataXtd_ConstraintDriver: typeof BinMDataXtd_ConstraintDriver;
  BinMDataXtd_PresentationDriver: typeof BinMDataXtd_PresentationDriver;
  Handle_BinMDataXtd_PresentationDriver: typeof Handle_BinMDataXtd_PresentationDriver;
  Handle_BinMDataXtd_PresentationDriver_1: typeof Handle_BinMDataXtd_PresentationDriver_1;
  Handle_BinMDataXtd_PresentationDriver_2: typeof Handle_BinMDataXtd_PresentationDriver_2;
  Handle_BinMDataXtd_PresentationDriver_3: typeof Handle_BinMDataXtd_PresentationDriver_3;
  Handle_BinMDataXtd_PresentationDriver_4: typeof Handle_BinMDataXtd_PresentationDriver_4;
  BRepSweep_Translation: typeof BRepSweep_Translation;
  BRepSweep_Prism: typeof BRepSweep_Prism;
  BRepSweep_Prism_1: typeof BRepSweep_Prism_1;
  BRepSweep_Prism_2: typeof BRepSweep_Prism_2;
  BRepSweep_Revol: typeof BRepSweep_Revol;
  BRepSweep_Revol_1: typeof BRepSweep_Revol_1;
  BRepSweep_Revol_2: typeof BRepSweep_Revol_2;
  BRepSweep_Rotation: typeof BRepSweep_Rotation;
  BRepSweep_Builder: typeof BRepSweep_Builder;
  BRepSweep_Iterator: typeof BRepSweep_Iterator;
  BRepSweep_Trsf: typeof BRepSweep_Trsf;
  BRepSweep_NumLinearRegularSweep: typeof BRepSweep_NumLinearRegularSweep;
  BRepSweep_Tool: typeof BRepSweep_Tool;
  UnitsMethods: typeof UnitsMethods;
  Adaptor2d_HCurve2d: typeof Adaptor2d_HCurve2d;
  Handle_Adaptor2d_HCurve2d: typeof Handle_Adaptor2d_HCurve2d;
  Handle_Adaptor2d_HCurve2d_1: typeof Handle_Adaptor2d_HCurve2d_1;
  Handle_Adaptor2d_HCurve2d_2: typeof Handle_Adaptor2d_HCurve2d_2;
  Handle_Adaptor2d_HCurve2d_3: typeof Handle_Adaptor2d_HCurve2d_3;
  Handle_Adaptor2d_HCurve2d_4: typeof Handle_Adaptor2d_HCurve2d_4;
  Adaptor2d_OffsetCurve: typeof Adaptor2d_OffsetCurve;
  Adaptor2d_OffsetCurve_1: typeof Adaptor2d_OffsetCurve_1;
  Adaptor2d_OffsetCurve_2: typeof Adaptor2d_OffsetCurve_2;
  Adaptor2d_OffsetCurve_3: typeof Adaptor2d_OffsetCurve_3;
  Adaptor2d_OffsetCurve_4: typeof Adaptor2d_OffsetCurve_4;
  Adaptor2d_HLine2d: typeof Adaptor2d_HLine2d;
  Adaptor2d_HLine2d_1: typeof Adaptor2d_HLine2d_1;
  Adaptor2d_HLine2d_2: typeof Adaptor2d_HLine2d_2;
  Handle_Adaptor2d_HLine2d: typeof Handle_Adaptor2d_HLine2d;
  Handle_Adaptor2d_HLine2d_1: typeof Handle_Adaptor2d_HLine2d_1;
  Handle_Adaptor2d_HLine2d_2: typeof Handle_Adaptor2d_HLine2d_2;
  Handle_Adaptor2d_HLine2d_3: typeof Handle_Adaptor2d_HLine2d_3;
  Handle_Adaptor2d_HLine2d_4: typeof Handle_Adaptor2d_HLine2d_4;
  Adaptor2d_Line2d: typeof Adaptor2d_Line2d;
  Adaptor2d_Line2d_1: typeof Adaptor2d_Line2d_1;
  Adaptor2d_Line2d_2: typeof Adaptor2d_Line2d_2;
  Handle_Adaptor2d_HOffsetCurve: typeof Handle_Adaptor2d_HOffsetCurve;
  Handle_Adaptor2d_HOffsetCurve_1: typeof Handle_Adaptor2d_HOffsetCurve_1;
  Handle_Adaptor2d_HOffsetCurve_2: typeof Handle_Adaptor2d_HOffsetCurve_2;
  Handle_Adaptor2d_HOffsetCurve_3: typeof Handle_Adaptor2d_HOffsetCurve_3;
  Handle_Adaptor2d_HOffsetCurve_4: typeof Handle_Adaptor2d_HOffsetCurve_4;
  Adaptor2d_HOffsetCurve: typeof Adaptor2d_HOffsetCurve;
  Adaptor2d_HOffsetCurve_1: typeof Adaptor2d_HOffsetCurve_1;
  Adaptor2d_HOffsetCurve_2: typeof Adaptor2d_HOffsetCurve_2;
  Adaptor2d_Curve2d: typeof Adaptor2d_Curve2d;
  BRepProj_Projection: typeof BRepProj_Projection;
  BRepProj_Projection_1: typeof BRepProj_Projection_1;
  BRepProj_Projection_2: typeof BRepProj_Projection_2;
  HatchGen_PointsOnElement: typeof HatchGen_PointsOnElement;
  HatchGen_PointsOnElement_1: typeof HatchGen_PointsOnElement_1;
  HatchGen_PointsOnElement_2: typeof HatchGen_PointsOnElement_2;
  HatchGen_PointsOnElement_3: typeof HatchGen_PointsOnElement_3;
  HatchGen_PointOnElement: typeof HatchGen_PointOnElement;
  HatchGen_PointOnElement_1: typeof HatchGen_PointOnElement_1;
  HatchGen_PointOnElement_2: typeof HatchGen_PointOnElement_2;
  HatchGen_IntersectionPoint: typeof HatchGen_IntersectionPoint;
  HatchGen_ErrorStatus: HatchGen_ErrorStatus;
  HatchGen_PointsOnHatching: typeof HatchGen_PointsOnHatching;
  HatchGen_PointsOnHatching_1: typeof HatchGen_PointsOnHatching_1;
  HatchGen_PointsOnHatching_2: typeof HatchGen_PointsOnHatching_2;
  HatchGen_PointsOnHatching_3: typeof HatchGen_PointsOnHatching_3;
  HatchGen_IntersectionType: HatchGen_IntersectionType;
  HatchGen_Domain: typeof HatchGen_Domain;
  HatchGen_Domain_1: typeof HatchGen_Domain_1;
  HatchGen_Domain_2: typeof HatchGen_Domain_2;
  HatchGen_Domain_3: typeof HatchGen_Domain_3;
  HatchGen_Domains: typeof HatchGen_Domains;
  HatchGen_Domains_1: typeof HatchGen_Domains_1;
  HatchGen_Domains_2: typeof HatchGen_Domains_2;
  HatchGen_Domains_3: typeof HatchGen_Domains_3;
  HatchGen_PointOnHatching: typeof HatchGen_PointOnHatching;
  HatchGen_PointOnHatching_1: typeof HatchGen_PointOnHatching_1;
  HatchGen_PointOnHatching_2: typeof HatchGen_PointOnHatching_2;
  IMeshData_PCurve: typeof IMeshData_PCurve;
  IMeshData_Curve: typeof IMeshData_Curve;
  IMeshData_StatusOwner: typeof IMeshData_StatusOwner;
  IMeshData_Shape: typeof IMeshData_Shape;
  IMeshData_TessellatedShape: typeof IMeshData_TessellatedShape;
  IMeshData_Model: typeof IMeshData_Model;
  IMeshData_ParametersList: typeof IMeshData_ParametersList;
  IMeshData_Status: IMeshData_Status;
  Handle_XmlMNaming_NamingDriver: typeof Handle_XmlMNaming_NamingDriver;
  Handle_XmlMNaming_NamingDriver_1: typeof Handle_XmlMNaming_NamingDriver_1;
  Handle_XmlMNaming_NamingDriver_2: typeof Handle_XmlMNaming_NamingDriver_2;
  Handle_XmlMNaming_NamingDriver_3: typeof Handle_XmlMNaming_NamingDriver_3;
  Handle_XmlMNaming_NamingDriver_4: typeof Handle_XmlMNaming_NamingDriver_4;
  XmlMNaming_NamingDriver: typeof XmlMNaming_NamingDriver;
  Handle_XmlMNaming_NamedShapeDriver: typeof Handle_XmlMNaming_NamedShapeDriver;
  Handle_XmlMNaming_NamedShapeDriver_1: typeof Handle_XmlMNaming_NamedShapeDriver_1;
  Handle_XmlMNaming_NamedShapeDriver_2: typeof Handle_XmlMNaming_NamedShapeDriver_2;
  Handle_XmlMNaming_NamedShapeDriver_3: typeof Handle_XmlMNaming_NamedShapeDriver_3;
  Handle_XmlMNaming_NamedShapeDriver_4: typeof Handle_XmlMNaming_NamedShapeDriver_4;
  XmlMNaming_NamedShapeDriver: typeof XmlMNaming_NamedShapeDriver;
  XmlMNaming_Shape1: typeof XmlMNaming_Shape1;
  XmlMNaming_Shape1_1: typeof XmlMNaming_Shape1_1;
  XmlMNaming_Shape1_2: typeof XmlMNaming_Shape1_2;
  XmlMNaming: typeof XmlMNaming;
  FilletSurf_Builder: typeof FilletSurf_Builder;
  FilletSurf_StatusType: FilletSurf_StatusType;
  FilletSurf_ErrorTypeStatus: FilletSurf_ErrorTypeStatus;
  FilletSurf_InternalBuilder: typeof FilletSurf_InternalBuilder;
  FilletSurf_StatusDone: FilletSurf_StatusDone;
  Handle_StepShape_EdgeCurve: typeof Handle_StepShape_EdgeCurve;
  Handle_StepShape_EdgeCurve_1: typeof Handle_StepShape_EdgeCurve_1;
  Handle_StepShape_EdgeCurve_2: typeof Handle_StepShape_EdgeCurve_2;
  Handle_StepShape_EdgeCurve_3: typeof Handle_StepShape_EdgeCurve_3;
  Handle_StepShape_EdgeCurve_4: typeof Handle_StepShape_EdgeCurve_4;
  StepShape_EdgeCurve: typeof StepShape_EdgeCurve;
  Handle_StepShape_Block: typeof Handle_StepShape_Block;
  Handle_StepShape_Block_1: typeof Handle_StepShape_Block_1;
  Handle_StepShape_Block_2: typeof Handle_StepShape_Block_2;
  Handle_StepShape_Block_3: typeof Handle_StepShape_Block_3;
  Handle_StepShape_Block_4: typeof Handle_StepShape_Block_4;
  StepShape_Block: typeof StepShape_Block;
  StepShape_ReversibleTopologyItem: typeof StepShape_ReversibleTopologyItem;
  Handle_StepShape_DimensionalCharacteristicRepresentation: typeof Handle_StepShape_DimensionalCharacteristicRepresentation;
  Handle_StepShape_DimensionalCharacteristicRepresentation_1: typeof Handle_StepShape_DimensionalCharacteristicRepresentation_1;
  Handle_StepShape_DimensionalCharacteristicRepresentation_2: typeof Handle_StepShape_DimensionalCharacteristicRepresentation_2;
  Handle_StepShape_DimensionalCharacteristicRepresentation_3: typeof Handle_StepShape_DimensionalCharacteristicRepresentation_3;
  Handle_StepShape_DimensionalCharacteristicRepresentation_4: typeof Handle_StepShape_DimensionalCharacteristicRepresentation_4;
  StepShape_DimensionalCharacteristicRepresentation: typeof StepShape_DimensionalCharacteristicRepresentation;
  Handle_StepShape_ExtrudedAreaSolid: typeof Handle_StepShape_ExtrudedAreaSolid;
  Handle_StepShape_ExtrudedAreaSolid_1: typeof Handle_StepShape_ExtrudedAreaSolid_1;
  Handle_StepShape_ExtrudedAreaSolid_2: typeof Handle_StepShape_ExtrudedAreaSolid_2;
  Handle_StepShape_ExtrudedAreaSolid_3: typeof Handle_StepShape_ExtrudedAreaSolid_3;
  Handle_StepShape_ExtrudedAreaSolid_4: typeof Handle_StepShape_ExtrudedAreaSolid_4;
  StepShape_ExtrudedAreaSolid: typeof StepShape_ExtrudedAreaSolid;
  StepShape_SweptFaceSolid: typeof StepShape_SweptFaceSolid;
  Handle_StepShape_SweptFaceSolid: typeof Handle_StepShape_SweptFaceSolid;
  Handle_StepShape_SweptFaceSolid_1: typeof Handle_StepShape_SweptFaceSolid_1;
  Handle_StepShape_SweptFaceSolid_2: typeof Handle_StepShape_SweptFaceSolid_2;
  Handle_StepShape_SweptFaceSolid_3: typeof Handle_StepShape_SweptFaceSolid_3;
  Handle_StepShape_SweptFaceSolid_4: typeof Handle_StepShape_SweptFaceSolid_4;
  StepShape_DirectedDimensionalLocation: typeof StepShape_DirectedDimensionalLocation;
  Handle_StepShape_DirectedDimensionalLocation: typeof Handle_StepShape_DirectedDimensionalLocation;
  Handle_StepShape_DirectedDimensionalLocation_1: typeof Handle_StepShape_DirectedDimensionalLocation_1;
  Handle_StepShape_DirectedDimensionalLocation_2: typeof Handle_StepShape_DirectedDimensionalLocation_2;
  Handle_StepShape_DirectedDimensionalLocation_3: typeof Handle_StepShape_DirectedDimensionalLocation_3;
  Handle_StepShape_DirectedDimensionalLocation_4: typeof Handle_StepShape_DirectedDimensionalLocation_4;
  StepShape_GeometricSetSelect: typeof StepShape_GeometricSetSelect;
  Handle_StepShape_VertexPoint: typeof Handle_StepShape_VertexPoint;
  Handle_StepShape_VertexPoint_1: typeof Handle_StepShape_VertexPoint_1;
  Handle_StepShape_VertexPoint_2: typeof Handle_StepShape_VertexPoint_2;
  Handle_StepShape_VertexPoint_3: typeof Handle_StepShape_VertexPoint_3;
  Handle_StepShape_VertexPoint_4: typeof Handle_StepShape_VertexPoint_4;
  StepShape_VertexPoint: typeof StepShape_VertexPoint;
  Handle_StepShape_HArray1OfOrientedClosedShell: typeof Handle_StepShape_HArray1OfOrientedClosedShell;
  Handle_StepShape_HArray1OfOrientedClosedShell_1: typeof Handle_StepShape_HArray1OfOrientedClosedShell_1;
  Handle_StepShape_HArray1OfOrientedClosedShell_2: typeof Handle_StepShape_HArray1OfOrientedClosedShell_2;
  Handle_StepShape_HArray1OfOrientedClosedShell_3: typeof Handle_StepShape_HArray1OfOrientedClosedShell_3;
  Handle_StepShape_HArray1OfOrientedClosedShell_4: typeof Handle_StepShape_HArray1OfOrientedClosedShell_4;
  StepShape_ManifoldSurfaceShapeRepresentation: typeof StepShape_ManifoldSurfaceShapeRepresentation;
  Handle_StepShape_ManifoldSurfaceShapeRepresentation: typeof Handle_StepShape_ManifoldSurfaceShapeRepresentation;
  Handle_StepShape_ManifoldSurfaceShapeRepresentation_1: typeof Handle_StepShape_ManifoldSurfaceShapeRepresentation_1;
  Handle_StepShape_ManifoldSurfaceShapeRepresentation_2: typeof Handle_StepShape_ManifoldSurfaceShapeRepresentation_2;
  Handle_StepShape_ManifoldSurfaceShapeRepresentation_3: typeof Handle_StepShape_ManifoldSurfaceShapeRepresentation_3;
  Handle_StepShape_ManifoldSurfaceShapeRepresentation_4: typeof Handle_StepShape_ManifoldSurfaceShapeRepresentation_4;
  Handle_StepShape_HArray1OfShell: typeof Handle_StepShape_HArray1OfShell;
  Handle_StepShape_HArray1OfShell_1: typeof Handle_StepShape_HArray1OfShell_1;
  Handle_StepShape_HArray1OfShell_2: typeof Handle_StepShape_HArray1OfShell_2;
  Handle_StepShape_HArray1OfShell_3: typeof Handle_StepShape_HArray1OfShell_3;
  Handle_StepShape_HArray1OfShell_4: typeof Handle_StepShape_HArray1OfShell_4;
  StepShape_RevolvedAreaSolid: typeof StepShape_RevolvedAreaSolid;
  Handle_StepShape_RevolvedAreaSolid: typeof Handle_StepShape_RevolvedAreaSolid;
  Handle_StepShape_RevolvedAreaSolid_1: typeof Handle_StepShape_RevolvedAreaSolid_1;
  Handle_StepShape_RevolvedAreaSolid_2: typeof Handle_StepShape_RevolvedAreaSolid_2;
  Handle_StepShape_RevolvedAreaSolid_3: typeof Handle_StepShape_RevolvedAreaSolid_3;
  Handle_StepShape_RevolvedAreaSolid_4: typeof Handle_StepShape_RevolvedAreaSolid_4;
  StepShape_FaceSurface: typeof StepShape_FaceSurface;
  Handle_StepShape_FaceSurface: typeof Handle_StepShape_FaceSurface;
  Handle_StepShape_FaceSurface_1: typeof Handle_StepShape_FaceSurface_1;
  Handle_StepShape_FaceSurface_2: typeof Handle_StepShape_FaceSurface_2;
  Handle_StepShape_FaceSurface_3: typeof Handle_StepShape_FaceSurface_3;
  Handle_StepShape_FaceSurface_4: typeof Handle_StepShape_FaceSurface_4;
  Handle_StepShape_FaceBound: typeof Handle_StepShape_FaceBound;
  Handle_StepShape_FaceBound_1: typeof Handle_StepShape_FaceBound_1;
  Handle_StepShape_FaceBound_2: typeof Handle_StepShape_FaceBound_2;
  Handle_StepShape_FaceBound_3: typeof Handle_StepShape_FaceBound_3;
  Handle_StepShape_FaceBound_4: typeof Handle_StepShape_FaceBound_4;
  StepShape_FaceBound: typeof StepShape_FaceBound;
  StepShape_Loop: typeof StepShape_Loop;
  Handle_StepShape_Loop: typeof Handle_StepShape_Loop;
  Handle_StepShape_Loop_1: typeof Handle_StepShape_Loop_1;
  Handle_StepShape_Loop_2: typeof Handle_StepShape_Loop_2;
  Handle_StepShape_Loop_3: typeof Handle_StepShape_Loop_3;
  Handle_StepShape_Loop_4: typeof Handle_StepShape_Loop_4;
  StepShape_Shell: typeof StepShape_Shell;
  StepShape_HalfSpaceSolid: typeof StepShape_HalfSpaceSolid;
  Handle_StepShape_HalfSpaceSolid: typeof Handle_StepShape_HalfSpaceSolid;
  Handle_StepShape_HalfSpaceSolid_1: typeof Handle_StepShape_HalfSpaceSolid_1;
  Handle_StepShape_HalfSpaceSolid_2: typeof Handle_StepShape_HalfSpaceSolid_2;
  Handle_StepShape_HalfSpaceSolid_3: typeof Handle_StepShape_HalfSpaceSolid_3;
  Handle_StepShape_HalfSpaceSolid_4: typeof Handle_StepShape_HalfSpaceSolid_4;
  StepShape_BoxedHalfSpace: typeof StepShape_BoxedHalfSpace;
  Handle_StepShape_BoxedHalfSpace: typeof Handle_StepShape_BoxedHalfSpace;
  Handle_StepShape_BoxedHalfSpace_1: typeof Handle_StepShape_BoxedHalfSpace_1;
  Handle_StepShape_BoxedHalfSpace_2: typeof Handle_StepShape_BoxedHalfSpace_2;
  Handle_StepShape_BoxedHalfSpace_3: typeof Handle_StepShape_BoxedHalfSpace_3;
  Handle_StepShape_BoxedHalfSpace_4: typeof Handle_StepShape_BoxedHalfSpace_4;
  StepShape_ShapeDimensionRepresentationItem: typeof StepShape_ShapeDimensionRepresentationItem;
  Handle_StepShape_FacetedBrepAndBrepWithVoids: typeof Handle_StepShape_FacetedBrepAndBrepWithVoids;
  Handle_StepShape_FacetedBrepAndBrepWithVoids_1: typeof Handle_StepShape_FacetedBrepAndBrepWithVoids_1;
  Handle_StepShape_FacetedBrepAndBrepWithVoids_2: typeof Handle_StepShape_FacetedBrepAndBrepWithVoids_2;
  Handle_StepShape_FacetedBrepAndBrepWithVoids_3: typeof Handle_StepShape_FacetedBrepAndBrepWithVoids_3;
  Handle_StepShape_FacetedBrepAndBrepWithVoids_4: typeof Handle_StepShape_FacetedBrepAndBrepWithVoids_4;
  StepShape_FacetedBrepAndBrepWithVoids: typeof StepShape_FacetedBrepAndBrepWithVoids;
  Handle_StepShape_ConnectedEdgeSet: typeof Handle_StepShape_ConnectedEdgeSet;
  Handle_StepShape_ConnectedEdgeSet_1: typeof Handle_StepShape_ConnectedEdgeSet_1;
  Handle_StepShape_ConnectedEdgeSet_2: typeof Handle_StepShape_ConnectedEdgeSet_2;
  Handle_StepShape_ConnectedEdgeSet_3: typeof Handle_StepShape_ConnectedEdgeSet_3;
  Handle_StepShape_ConnectedEdgeSet_4: typeof Handle_StepShape_ConnectedEdgeSet_4;
  StepShape_ConnectedEdgeSet: typeof StepShape_ConnectedEdgeSet;
  Handle_StepShape_LoopAndPath: typeof Handle_StepShape_LoopAndPath;
  Handle_StepShape_LoopAndPath_1: typeof Handle_StepShape_LoopAndPath_1;
  Handle_StepShape_LoopAndPath_2: typeof Handle_StepShape_LoopAndPath_2;
  Handle_StepShape_LoopAndPath_3: typeof Handle_StepShape_LoopAndPath_3;
  Handle_StepShape_LoopAndPath_4: typeof Handle_StepShape_LoopAndPath_4;
  StepShape_LoopAndPath: typeof StepShape_LoopAndPath;
  Handle_StepShape_BrepWithVoids: typeof Handle_StepShape_BrepWithVoids;
  Handle_StepShape_BrepWithVoids_1: typeof Handle_StepShape_BrepWithVoids_1;
  Handle_StepShape_BrepWithVoids_2: typeof Handle_StepShape_BrepWithVoids_2;
  Handle_StepShape_BrepWithVoids_3: typeof Handle_StepShape_BrepWithVoids_3;
  Handle_StepShape_BrepWithVoids_4: typeof Handle_StepShape_BrepWithVoids_4;
  StepShape_BrepWithVoids: typeof StepShape_BrepWithVoids;
  StepShape_NonManifoldSurfaceShapeRepresentation: typeof StepShape_NonManifoldSurfaceShapeRepresentation;
  Handle_StepShape_NonManifoldSurfaceShapeRepresentation: typeof Handle_StepShape_NonManifoldSurfaceShapeRepresentation;
  Handle_StepShape_NonManifoldSurfaceShapeRepresentation_1: typeof Handle_StepShape_NonManifoldSurfaceShapeRepresentation_1;
  Handle_StepShape_NonManifoldSurfaceShapeRepresentation_2: typeof Handle_StepShape_NonManifoldSurfaceShapeRepresentation_2;
  Handle_StepShape_NonManifoldSurfaceShapeRepresentation_3: typeof Handle_StepShape_NonManifoldSurfaceShapeRepresentation_3;
  Handle_StepShape_NonManifoldSurfaceShapeRepresentation_4: typeof Handle_StepShape_NonManifoldSurfaceShapeRepresentation_4;
  Handle_StepShape_RightCircularCone: typeof Handle_StepShape_RightCircularCone;
  Handle_StepShape_RightCircularCone_1: typeof Handle_StepShape_RightCircularCone_1;
  Handle_StepShape_RightCircularCone_2: typeof Handle_StepShape_RightCircularCone_2;
  Handle_StepShape_RightCircularCone_3: typeof Handle_StepShape_RightCircularCone_3;
  Handle_StepShape_RightCircularCone_4: typeof Handle_StepShape_RightCircularCone_4;
  StepShape_RightCircularCone: typeof StepShape_RightCircularCone;
  Handle_StepShape_RightAngularWedge: typeof Handle_StepShape_RightAngularWedge;
  Handle_StepShape_RightAngularWedge_1: typeof Handle_StepShape_RightAngularWedge_1;
  Handle_StepShape_RightAngularWedge_2: typeof Handle_StepShape_RightAngularWedge_2;
  Handle_StepShape_RightAngularWedge_3: typeof Handle_StepShape_RightAngularWedge_3;
  Handle_StepShape_RightAngularWedge_4: typeof Handle_StepShape_RightAngularWedge_4;
  StepShape_RightAngularWedge: typeof StepShape_RightAngularWedge;
  StepShape_RevolvedFaceSolid: typeof StepShape_RevolvedFaceSolid;
  Handle_StepShape_RevolvedFaceSolid: typeof Handle_StepShape_RevolvedFaceSolid;
  Handle_StepShape_RevolvedFaceSolid_1: typeof Handle_StepShape_RevolvedFaceSolid_1;
  Handle_StepShape_RevolvedFaceSolid_2: typeof Handle_StepShape_RevolvedFaceSolid_2;
  Handle_StepShape_RevolvedFaceSolid_3: typeof Handle_StepShape_RevolvedFaceSolid_3;
  Handle_StepShape_RevolvedFaceSolid_4: typeof Handle_StepShape_RevolvedFaceSolid_4;
  StepShape_TransitionalShapeRepresentation: typeof StepShape_TransitionalShapeRepresentation;
  Handle_StepShape_TransitionalShapeRepresentation: typeof Handle_StepShape_TransitionalShapeRepresentation;
  Handle_StepShape_TransitionalShapeRepresentation_1: typeof Handle_StepShape_TransitionalShapeRepresentation_1;
  Handle_StepShape_TransitionalShapeRepresentation_2: typeof Handle_StepShape_TransitionalShapeRepresentation_2;
  Handle_StepShape_TransitionalShapeRepresentation_3: typeof Handle_StepShape_TransitionalShapeRepresentation_3;
  Handle_StepShape_TransitionalShapeRepresentation_4: typeof Handle_StepShape_TransitionalShapeRepresentation_4;
  Handle_StepShape_Path: typeof Handle_StepShape_Path;
  Handle_StepShape_Path_1: typeof Handle_StepShape_Path_1;
  Handle_StepShape_Path_2: typeof Handle_StepShape_Path_2;
  Handle_StepShape_Path_3: typeof Handle_StepShape_Path_3;
  Handle_StepShape_Path_4: typeof Handle_StepShape_Path_4;
  StepShape_Path: typeof StepShape_Path;
  Handle_StepShape_HArray1OfFaceBound: typeof Handle_StepShape_HArray1OfFaceBound;
  Handle_StepShape_HArray1OfFaceBound_1: typeof Handle_StepShape_HArray1OfFaceBound_1;
  Handle_StepShape_HArray1OfFaceBound_2: typeof Handle_StepShape_HArray1OfFaceBound_2;
  Handle_StepShape_HArray1OfFaceBound_3: typeof Handle_StepShape_HArray1OfFaceBound_3;
  Handle_StepShape_HArray1OfFaceBound_4: typeof Handle_StepShape_HArray1OfFaceBound_4;
  StepShape_AngleRelator: StepShape_AngleRelator;
  Handle_StepShape_HArray1OfValueQualifier: typeof Handle_StepShape_HArray1OfValueQualifier;
  Handle_StepShape_HArray1OfValueQualifier_1: typeof Handle_StepShape_HArray1OfValueQualifier_1;
  Handle_StepShape_HArray1OfValueQualifier_2: typeof Handle_StepShape_HArray1OfValueQualifier_2;
  Handle_StepShape_HArray1OfValueQualifier_3: typeof Handle_StepShape_HArray1OfValueQualifier_3;
  Handle_StepShape_HArray1OfValueQualifier_4: typeof Handle_StepShape_HArray1OfValueQualifier_4;
  Handle_StepShape_AngularLocation: typeof Handle_StepShape_AngularLocation;
  Handle_StepShape_AngularLocation_1: typeof Handle_StepShape_AngularLocation_1;
  Handle_StepShape_AngularLocation_2: typeof Handle_StepShape_AngularLocation_2;
  Handle_StepShape_AngularLocation_3: typeof Handle_StepShape_AngularLocation_3;
  Handle_StepShape_AngularLocation_4: typeof Handle_StepShape_AngularLocation_4;
  StepShape_AngularLocation: typeof StepShape_AngularLocation;
  StepShape_SweptAreaSolid: typeof StepShape_SweptAreaSolid;
  Handle_StepShape_SweptAreaSolid: typeof Handle_StepShape_SweptAreaSolid;
  Handle_StepShape_SweptAreaSolid_1: typeof Handle_StepShape_SweptAreaSolid_1;
  Handle_StepShape_SweptAreaSolid_2: typeof Handle_StepShape_SweptAreaSolid_2;
  Handle_StepShape_SweptAreaSolid_3: typeof Handle_StepShape_SweptAreaSolid_3;
  Handle_StepShape_SweptAreaSolid_4: typeof Handle_StepShape_SweptAreaSolid_4;
  Handle_StepShape_PolyLoop: typeof Handle_StepShape_PolyLoop;
  Handle_StepShape_PolyLoop_1: typeof Handle_StepShape_PolyLoop_1;
  Handle_StepShape_PolyLoop_2: typeof Handle_StepShape_PolyLoop_2;
  Handle_StepShape_PolyLoop_3: typeof Handle_StepShape_PolyLoop_3;
  Handle_StepShape_PolyLoop_4: typeof Handle_StepShape_PolyLoop_4;
  StepShape_PolyLoop: typeof StepShape_PolyLoop;
  StepShape_CompoundShapeRepresentation: typeof StepShape_CompoundShapeRepresentation;
  Handle_StepShape_CompoundShapeRepresentation: typeof Handle_StepShape_CompoundShapeRepresentation;
  Handle_StepShape_CompoundShapeRepresentation_1: typeof Handle_StepShape_CompoundShapeRepresentation_1;
  Handle_StepShape_CompoundShapeRepresentation_2: typeof Handle_StepShape_CompoundShapeRepresentation_2;
  Handle_StepShape_CompoundShapeRepresentation_3: typeof Handle_StepShape_CompoundShapeRepresentation_3;
  Handle_StepShape_CompoundShapeRepresentation_4: typeof Handle_StepShape_CompoundShapeRepresentation_4;
  StepShape_EdgeBasedWireframeShapeRepresentation: typeof StepShape_EdgeBasedWireframeShapeRepresentation;
  Handle_StepShape_EdgeBasedWireframeShapeRepresentation: typeof Handle_StepShape_EdgeBasedWireframeShapeRepresentation;
  Handle_StepShape_EdgeBasedWireframeShapeRepresentation_1: typeof Handle_StepShape_EdgeBasedWireframeShapeRepresentation_1;
  Handle_StepShape_EdgeBasedWireframeShapeRepresentation_2: typeof Handle_StepShape_EdgeBasedWireframeShapeRepresentation_2;
  Handle_StepShape_EdgeBasedWireframeShapeRepresentation_3: typeof Handle_StepShape_EdgeBasedWireframeShapeRepresentation_3;
  Handle_StepShape_EdgeBasedWireframeShapeRepresentation_4: typeof Handle_StepShape_EdgeBasedWireframeShapeRepresentation_4;
  Handle_StepShape_HArray1OfEdge: typeof Handle_StepShape_HArray1OfEdge;
  Handle_StepShape_HArray1OfEdge_1: typeof Handle_StepShape_HArray1OfEdge_1;
  Handle_StepShape_HArray1OfEdge_2: typeof Handle_StepShape_HArray1OfEdge_2;
  Handle_StepShape_HArray1OfEdge_3: typeof Handle_StepShape_HArray1OfEdge_3;
  Handle_StepShape_HArray1OfEdge_4: typeof Handle_StepShape_HArray1OfEdge_4;
  Handle_StepShape_OrientedPath: typeof Handle_StepShape_OrientedPath;
  Handle_StepShape_OrientedPath_1: typeof Handle_StepShape_OrientedPath_1;
  Handle_StepShape_OrientedPath_2: typeof Handle_StepShape_OrientedPath_2;
  Handle_StepShape_OrientedPath_3: typeof Handle_StepShape_OrientedPath_3;
  Handle_StepShape_OrientedPath_4: typeof Handle_StepShape_OrientedPath_4;
  StepShape_OrientedPath: typeof StepShape_OrientedPath;
  Handle_StepShape_Subface: typeof Handle_StepShape_Subface;
  Handle_StepShape_Subface_1: typeof Handle_StepShape_Subface_1;
  Handle_StepShape_Subface_2: typeof Handle_StepShape_Subface_2;
  Handle_StepShape_Subface_3: typeof Handle_StepShape_Subface_3;
  Handle_StepShape_Subface_4: typeof Handle_StepShape_Subface_4;
  StepShape_Subface: typeof StepShape_Subface;
  Handle_StepShape_DimensionalLocation: typeof Handle_StepShape_DimensionalLocation;
  Handle_StepShape_DimensionalLocation_1: typeof Handle_StepShape_DimensionalLocation_1;
  Handle_StepShape_DimensionalLocation_2: typeof Handle_StepShape_DimensionalLocation_2;
  Handle_StepShape_DimensionalLocation_3: typeof Handle_StepShape_DimensionalLocation_3;
  Handle_StepShape_DimensionalLocation_4: typeof Handle_StepShape_DimensionalLocation_4;
  StepShape_DimensionalLocation: typeof StepShape_DimensionalLocation;
  StepShape_CsgPrimitive: typeof StepShape_CsgPrimitive;
  Handle_StepShape_Sphere: typeof Handle_StepShape_Sphere;
  Handle_StepShape_Sphere_1: typeof Handle_StepShape_Sphere_1;
  Handle_StepShape_Sphere_2: typeof Handle_StepShape_Sphere_2;
  Handle_StepShape_Sphere_3: typeof Handle_StepShape_Sphere_3;
  Handle_StepShape_Sphere_4: typeof Handle_StepShape_Sphere_4;
  StepShape_Sphere: typeof StepShape_Sphere;
  StepShape_Array1OfShapeDimensionRepresentationItem: typeof StepShape_Array1OfShapeDimensionRepresentationItem;
  StepShape_Array1OfShapeDimensionRepresentationItem_1: typeof StepShape_Array1OfShapeDimensionRepresentationItem_1;
  StepShape_Array1OfShapeDimensionRepresentationItem_2: typeof StepShape_Array1OfShapeDimensionRepresentationItem_2;
  StepShape_Array1OfShapeDimensionRepresentationItem_3: typeof StepShape_Array1OfShapeDimensionRepresentationItem_3;
  StepShape_Array1OfShapeDimensionRepresentationItem_4: typeof StepShape_Array1OfShapeDimensionRepresentationItem_4;
  StepShape_Array1OfShapeDimensionRepresentationItem_5: typeof StepShape_Array1OfShapeDimensionRepresentationItem_5;
  Handle_StepShape_ConnectedFaceSubSet: typeof Handle_StepShape_ConnectedFaceSubSet;
  Handle_StepShape_ConnectedFaceSubSet_1: typeof Handle_StepShape_ConnectedFaceSubSet_1;
  Handle_StepShape_ConnectedFaceSubSet_2: typeof Handle_StepShape_ConnectedFaceSubSet_2;
  Handle_StepShape_ConnectedFaceSubSet_3: typeof Handle_StepShape_ConnectedFaceSubSet_3;
  Handle_StepShape_ConnectedFaceSubSet_4: typeof Handle_StepShape_ConnectedFaceSubSet_4;
  StepShape_ConnectedFaceSubSet: typeof StepShape_ConnectedFaceSubSet;
  Handle_StepShape_HArray1OfConnectedFaceSet: typeof Handle_StepShape_HArray1OfConnectedFaceSet;
  Handle_StepShape_HArray1OfConnectedFaceSet_1: typeof Handle_StepShape_HArray1OfConnectedFaceSet_1;
  Handle_StepShape_HArray1OfConnectedFaceSet_2: typeof Handle_StepShape_HArray1OfConnectedFaceSet_2;
  Handle_StepShape_HArray1OfConnectedFaceSet_3: typeof Handle_StepShape_HArray1OfConnectedFaceSet_3;
  Handle_StepShape_HArray1OfConnectedFaceSet_4: typeof Handle_StepShape_HArray1OfConnectedFaceSet_4;
  StepShape_CsgShapeRepresentation: typeof StepShape_CsgShapeRepresentation;
  Handle_StepShape_CsgShapeRepresentation: typeof Handle_StepShape_CsgShapeRepresentation;
  Handle_StepShape_CsgShapeRepresentation_1: typeof Handle_StepShape_CsgShapeRepresentation_1;
  Handle_StepShape_CsgShapeRepresentation_2: typeof Handle_StepShape_CsgShapeRepresentation_2;
  Handle_StepShape_CsgShapeRepresentation_3: typeof Handle_StepShape_CsgShapeRepresentation_3;
  Handle_StepShape_CsgShapeRepresentation_4: typeof Handle_StepShape_CsgShapeRepresentation_4;
  StepShape_ContextDependentShapeRepresentation: typeof StepShape_ContextDependentShapeRepresentation;
  Handle_StepShape_ContextDependentShapeRepresentation: typeof Handle_StepShape_ContextDependentShapeRepresentation;
  Handle_StepShape_ContextDependentShapeRepresentation_1: typeof Handle_StepShape_ContextDependentShapeRepresentation_1;
  Handle_StepShape_ContextDependentShapeRepresentation_2: typeof Handle_StepShape_ContextDependentShapeRepresentation_2;
  Handle_StepShape_ContextDependentShapeRepresentation_3: typeof Handle_StepShape_ContextDependentShapeRepresentation_3;
  Handle_StepShape_ContextDependentShapeRepresentation_4: typeof Handle_StepShape_ContextDependentShapeRepresentation_4;
  StepShape_CsgSelect: typeof StepShape_CsgSelect;
  StepShape_Array1OfValueQualifier: typeof StepShape_Array1OfValueQualifier;
  StepShape_Array1OfValueQualifier_1: typeof StepShape_Array1OfValueQualifier_1;
  StepShape_Array1OfValueQualifier_2: typeof StepShape_Array1OfValueQualifier_2;
  StepShape_Array1OfValueQualifier_3: typeof StepShape_Array1OfValueQualifier_3;
  StepShape_Array1OfValueQualifier_4: typeof StepShape_Array1OfValueQualifier_4;
  StepShape_Array1OfValueQualifier_5: typeof StepShape_Array1OfValueQualifier_5;
  Handle_StepShape_HArray1OfFace: typeof Handle_StepShape_HArray1OfFace;
  Handle_StepShape_HArray1OfFace_1: typeof Handle_StepShape_HArray1OfFace_1;
  Handle_StepShape_HArray1OfFace_2: typeof Handle_StepShape_HArray1OfFace_2;
  Handle_StepShape_HArray1OfFace_3: typeof Handle_StepShape_HArray1OfFace_3;
  Handle_StepShape_HArray1OfFace_4: typeof Handle_StepShape_HArray1OfFace_4;
  Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation: typeof Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation;
  Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_1: typeof Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_1;
  Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_2: typeof Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_2;
  Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_3: typeof Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_3;
  Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_4: typeof Handle_StepShape_DefinitionalRepresentationAndShapeRepresentation_4;
  StepShape_DefinitionalRepresentationAndShapeRepresentation: typeof StepShape_DefinitionalRepresentationAndShapeRepresentation;
  StepShape_ManifoldSolidBrep: typeof StepShape_ManifoldSolidBrep;
  Handle_StepShape_ManifoldSolidBrep: typeof Handle_StepShape_ManifoldSolidBrep;
  Handle_StepShape_ManifoldSolidBrep_1: typeof Handle_StepShape_ManifoldSolidBrep_1;
  Handle_StepShape_ManifoldSolidBrep_2: typeof Handle_StepShape_ManifoldSolidBrep_2;
  Handle_StepShape_ManifoldSolidBrep_3: typeof Handle_StepShape_ManifoldSolidBrep_3;
  Handle_StepShape_ManifoldSolidBrep_4: typeof Handle_StepShape_ManifoldSolidBrep_4;
  StepShape_ToleranceMethodDefinition: typeof StepShape_ToleranceMethodDefinition;
  StepShape_DimensionalLocationWithPath: typeof StepShape_DimensionalLocationWithPath;
  Handle_StepShape_DimensionalLocationWithPath: typeof Handle_StepShape_DimensionalLocationWithPath;
  Handle_StepShape_DimensionalLocationWithPath_1: typeof Handle_StepShape_DimensionalLocationWithPath_1;
  Handle_StepShape_DimensionalLocationWithPath_2: typeof Handle_StepShape_DimensionalLocationWithPath_2;
  Handle_StepShape_DimensionalLocationWithPath_3: typeof Handle_StepShape_DimensionalLocationWithPath_3;
  Handle_StepShape_DimensionalLocationWithPath_4: typeof Handle_StepShape_DimensionalLocationWithPath_4;
  Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation: typeof Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation;
  Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_1: typeof Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_1;
  Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_2: typeof Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_2;
  Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_3: typeof Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_3;
  Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_4: typeof Handle_StepShape_GeometricallyBoundedWireframeShapeRepresentation_4;
  StepShape_GeometricallyBoundedWireframeShapeRepresentation: typeof StepShape_GeometricallyBoundedWireframeShapeRepresentation;
  Handle_StepShape_ExtrudedFaceSolid: typeof Handle_StepShape_ExtrudedFaceSolid;
  Handle_StepShape_ExtrudedFaceSolid_1: typeof Handle_StepShape_ExtrudedFaceSolid_1;
  Handle_StepShape_ExtrudedFaceSolid_2: typeof Handle_StepShape_ExtrudedFaceSolid_2;
  Handle_StepShape_ExtrudedFaceSolid_3: typeof Handle_StepShape_ExtrudedFaceSolid_3;
  Handle_StepShape_ExtrudedFaceSolid_4: typeof Handle_StepShape_ExtrudedFaceSolid_4;
  StepShape_ExtrudedFaceSolid: typeof StepShape_ExtrudedFaceSolid;
  StepShape_DimensionalSize: typeof StepShape_DimensionalSize;
  Handle_StepShape_DimensionalSize: typeof Handle_StepShape_DimensionalSize;
  Handle_StepShape_DimensionalSize_1: typeof Handle_StepShape_DimensionalSize_1;
  Handle_StepShape_DimensionalSize_2: typeof Handle_StepShape_DimensionalSize_2;
  Handle_StepShape_DimensionalSize_3: typeof Handle_StepShape_DimensionalSize_3;
  Handle_StepShape_DimensionalSize_4: typeof Handle_StepShape_DimensionalSize_4;
  Handle_StepShape_GeometricSet: typeof Handle_StepShape_GeometricSet;
  Handle_StepShape_GeometricSet_1: typeof Handle_StepShape_GeometricSet_1;
  Handle_StepShape_GeometricSet_2: typeof Handle_StepShape_GeometricSet_2;
  Handle_StepShape_GeometricSet_3: typeof Handle_StepShape_GeometricSet_3;
  Handle_StepShape_GeometricSet_4: typeof Handle_StepShape_GeometricSet_4;
  StepShape_GeometricSet: typeof StepShape_GeometricSet;
  StepShape_PlusMinusTolerance: typeof StepShape_PlusMinusTolerance;
  Handle_StepShape_PlusMinusTolerance: typeof Handle_StepShape_PlusMinusTolerance;
  Handle_StepShape_PlusMinusTolerance_1: typeof Handle_StepShape_PlusMinusTolerance_1;
  Handle_StepShape_PlusMinusTolerance_2: typeof Handle_StepShape_PlusMinusTolerance_2;
  Handle_StepShape_PlusMinusTolerance_3: typeof Handle_StepShape_PlusMinusTolerance_3;
  Handle_StepShape_PlusMinusTolerance_4: typeof Handle_StepShape_PlusMinusTolerance_4;
  Handle_StepShape_LimitsAndFits: typeof Handle_StepShape_LimitsAndFits;
  Handle_StepShape_LimitsAndFits_1: typeof Handle_StepShape_LimitsAndFits_1;
  Handle_StepShape_LimitsAndFits_2: typeof Handle_StepShape_LimitsAndFits_2;
  Handle_StepShape_LimitsAndFits_3: typeof Handle_StepShape_LimitsAndFits_3;
  Handle_StepShape_LimitsAndFits_4: typeof Handle_StepShape_LimitsAndFits_4;
  StepShape_LimitsAndFits: typeof StepShape_LimitsAndFits;
  StepShape_ShapeRepresentation: typeof StepShape_ShapeRepresentation;
  Handle_StepShape_ShapeRepresentation: typeof Handle_StepShape_ShapeRepresentation;
  Handle_StepShape_ShapeRepresentation_1: typeof Handle_StepShape_ShapeRepresentation_1;
  Handle_StepShape_ShapeRepresentation_2: typeof Handle_StepShape_ShapeRepresentation_2;
  Handle_StepShape_ShapeRepresentation_3: typeof Handle_StepShape_ShapeRepresentation_3;
  Handle_StepShape_ShapeRepresentation_4: typeof Handle_StepShape_ShapeRepresentation_4;
  StepShape_SolidModel: typeof StepShape_SolidModel;
  Handle_StepShape_SolidModel: typeof Handle_StepShape_SolidModel;
  Handle_StepShape_SolidModel_1: typeof Handle_StepShape_SolidModel_1;
  Handle_StepShape_SolidModel_2: typeof Handle_StepShape_SolidModel_2;
  Handle_StepShape_SolidModel_3: typeof Handle_StepShape_SolidModel_3;
  Handle_StepShape_SolidModel_4: typeof Handle_StepShape_SolidModel_4;
  StepShape_PrecisionQualifier: typeof StepShape_PrecisionQualifier;
  Handle_StepShape_PrecisionQualifier: typeof Handle_StepShape_PrecisionQualifier;
  Handle_StepShape_PrecisionQualifier_1: typeof Handle_StepShape_PrecisionQualifier_1;
  Handle_StepShape_PrecisionQualifier_2: typeof Handle_StepShape_PrecisionQualifier_2;
  Handle_StepShape_PrecisionQualifier_3: typeof Handle_StepShape_PrecisionQualifier_3;
  Handle_StepShape_PrecisionQualifier_4: typeof Handle_StepShape_PrecisionQualifier_4;
  Handle_StepShape_FaceOuterBound: typeof Handle_StepShape_FaceOuterBound;
  Handle_StepShape_FaceOuterBound_1: typeof Handle_StepShape_FaceOuterBound_1;
  Handle_StepShape_FaceOuterBound_2: typeof Handle_StepShape_FaceOuterBound_2;
  Handle_StepShape_FaceOuterBound_3: typeof Handle_StepShape_FaceOuterBound_3;
  Handle_StepShape_FaceOuterBound_4: typeof Handle_StepShape_FaceOuterBound_4;
  StepShape_FaceOuterBound: typeof StepShape_FaceOuterBound;
  StepShape_SolidReplica: typeof StepShape_SolidReplica;
  Handle_StepShape_SolidReplica: typeof Handle_StepShape_SolidReplica;
  Handle_StepShape_SolidReplica_1: typeof Handle_StepShape_SolidReplica_1;
  Handle_StepShape_SolidReplica_2: typeof Handle_StepShape_SolidReplica_2;
  Handle_StepShape_SolidReplica_3: typeof Handle_StepShape_SolidReplica_3;
  Handle_StepShape_SolidReplica_4: typeof Handle_StepShape_SolidReplica_4;
  StepShape_ShapeRepresentationWithParameters: typeof StepShape_ShapeRepresentationWithParameters;
  Handle_StepShape_ShapeRepresentationWithParameters: typeof Handle_StepShape_ShapeRepresentationWithParameters;
  Handle_StepShape_ShapeRepresentationWithParameters_1: typeof Handle_StepShape_ShapeRepresentationWithParameters_1;
  Handle_StepShape_ShapeRepresentationWithParameters_2: typeof Handle_StepShape_ShapeRepresentationWithParameters_2;
  Handle_StepShape_ShapeRepresentationWithParameters_3: typeof Handle_StepShape_ShapeRepresentationWithParameters_3;
  Handle_StepShape_ShapeRepresentationWithParameters_4: typeof Handle_StepShape_ShapeRepresentationWithParameters_4;
  Handle_StepShape_OrientedOpenShell: typeof Handle_StepShape_OrientedOpenShell;
  Handle_StepShape_OrientedOpenShell_1: typeof Handle_StepShape_OrientedOpenShell_1;
  Handle_StepShape_OrientedOpenShell_2: typeof Handle_StepShape_OrientedOpenShell_2;
  Handle_StepShape_OrientedOpenShell_3: typeof Handle_StepShape_OrientedOpenShell_3;
  Handle_StepShape_OrientedOpenShell_4: typeof Handle_StepShape_OrientedOpenShell_4;
  StepShape_OrientedOpenShell: typeof StepShape_OrientedOpenShell;
  StepShape_RightCircularCylinder: typeof StepShape_RightCircularCylinder;
  Handle_StepShape_RightCircularCylinder: typeof Handle_StepShape_RightCircularCylinder;
  Handle_StepShape_RightCircularCylinder_1: typeof Handle_StepShape_RightCircularCylinder_1;
  Handle_StepShape_RightCircularCylinder_2: typeof Handle_StepShape_RightCircularCylinder_2;
  Handle_StepShape_RightCircularCylinder_3: typeof Handle_StepShape_RightCircularCylinder_3;
  Handle_StepShape_RightCircularCylinder_4: typeof Handle_StepShape_RightCircularCylinder_4;
  Handle_StepShape_ShapeDefinitionRepresentation: typeof Handle_StepShape_ShapeDefinitionRepresentation;
  Handle_StepShape_ShapeDefinitionRepresentation_1: typeof Handle_StepShape_ShapeDefinitionRepresentation_1;
  Handle_StepShape_ShapeDefinitionRepresentation_2: typeof Handle_StepShape_ShapeDefinitionRepresentation_2;
  Handle_StepShape_ShapeDefinitionRepresentation_3: typeof Handle_StepShape_ShapeDefinitionRepresentation_3;
  Handle_StepShape_ShapeDefinitionRepresentation_4: typeof Handle_StepShape_ShapeDefinitionRepresentation_4;
  StepShape_ShapeDefinitionRepresentation: typeof StepShape_ShapeDefinitionRepresentation;
  StepShape_GeometricCurveSet: typeof StepShape_GeometricCurveSet;
  Handle_StepShape_GeometricCurveSet: typeof Handle_StepShape_GeometricCurveSet;
  Handle_StepShape_GeometricCurveSet_1: typeof Handle_StepShape_GeometricCurveSet_1;
  Handle_StepShape_GeometricCurveSet_2: typeof Handle_StepShape_GeometricCurveSet_2;
  Handle_StepShape_GeometricCurveSet_3: typeof Handle_StepShape_GeometricCurveSet_3;
  Handle_StepShape_GeometricCurveSet_4: typeof Handle_StepShape_GeometricCurveSet_4;
  Handle_StepShape_QualifiedRepresentationItem: typeof Handle_StepShape_QualifiedRepresentationItem;
  Handle_StepShape_QualifiedRepresentationItem_1: typeof Handle_StepShape_QualifiedRepresentationItem_1;
  Handle_StepShape_QualifiedRepresentationItem_2: typeof Handle_StepShape_QualifiedRepresentationItem_2;
  Handle_StepShape_QualifiedRepresentationItem_3: typeof Handle_StepShape_QualifiedRepresentationItem_3;
  Handle_StepShape_QualifiedRepresentationItem_4: typeof Handle_StepShape_QualifiedRepresentationItem_4;
  StepShape_QualifiedRepresentationItem: typeof StepShape_QualifiedRepresentationItem;
  Handle_StepShape_OrientedFace: typeof Handle_StepShape_OrientedFace;
  Handle_StepShape_OrientedFace_1: typeof Handle_StepShape_OrientedFace_1;
  Handle_StepShape_OrientedFace_2: typeof Handle_StepShape_OrientedFace_2;
  Handle_StepShape_OrientedFace_3: typeof Handle_StepShape_OrientedFace_3;
  Handle_StepShape_OrientedFace_4: typeof Handle_StepShape_OrientedFace_4;
  StepShape_OrientedFace: typeof StepShape_OrientedFace;
  Handle_StepShape_HArray1OfConnectedEdgeSet: typeof Handle_StepShape_HArray1OfConnectedEdgeSet;
  Handle_StepShape_HArray1OfConnectedEdgeSet_1: typeof Handle_StepShape_HArray1OfConnectedEdgeSet_1;
  Handle_StepShape_HArray1OfConnectedEdgeSet_2: typeof Handle_StepShape_HArray1OfConnectedEdgeSet_2;
  Handle_StepShape_HArray1OfConnectedEdgeSet_3: typeof Handle_StepShape_HArray1OfConnectedEdgeSet_3;
  Handle_StepShape_HArray1OfConnectedEdgeSet_4: typeof Handle_StepShape_HArray1OfConnectedEdgeSet_4;
  Handle_StepShape_OrientedEdge: typeof Handle_StepShape_OrientedEdge;
  Handle_StepShape_OrientedEdge_1: typeof Handle_StepShape_OrientedEdge_1;
  Handle_StepShape_OrientedEdge_2: typeof Handle_StepShape_OrientedEdge_2;
  Handle_StepShape_OrientedEdge_3: typeof Handle_StepShape_OrientedEdge_3;
  Handle_StepShape_OrientedEdge_4: typeof Handle_StepShape_OrientedEdge_4;
  StepShape_OrientedEdge: typeof StepShape_OrientedEdge;
  StepShape_Vertex: typeof StepShape_Vertex;
  Handle_StepShape_Vertex: typeof Handle_StepShape_Vertex;
  Handle_StepShape_Vertex_1: typeof Handle_StepShape_Vertex_1;
  Handle_StepShape_Vertex_2: typeof Handle_StepShape_Vertex_2;
  Handle_StepShape_Vertex_3: typeof Handle_StepShape_Vertex_3;
  Handle_StepShape_Vertex_4: typeof Handle_StepShape_Vertex_4;
  StepShape_AdvancedFace: typeof StepShape_AdvancedFace;
  Handle_StepShape_AdvancedFace: typeof Handle_StepShape_AdvancedFace;
  Handle_StepShape_AdvancedFace_1: typeof Handle_StepShape_AdvancedFace_1;
  Handle_StepShape_AdvancedFace_2: typeof Handle_StepShape_AdvancedFace_2;
  Handle_StepShape_AdvancedFace_3: typeof Handle_StepShape_AdvancedFace_3;
  Handle_StepShape_AdvancedFace_4: typeof Handle_StepShape_AdvancedFace_4;
  StepShape_AdvancedBrepShapeRepresentation: typeof StepShape_AdvancedBrepShapeRepresentation;
  Handle_StepShape_AdvancedBrepShapeRepresentation: typeof Handle_StepShape_AdvancedBrepShapeRepresentation;
  Handle_StepShape_AdvancedBrepShapeRepresentation_1: typeof Handle_StepShape_AdvancedBrepShapeRepresentation_1;
  Handle_StepShape_AdvancedBrepShapeRepresentation_2: typeof Handle_StepShape_AdvancedBrepShapeRepresentation_2;
  Handle_StepShape_AdvancedBrepShapeRepresentation_3: typeof Handle_StepShape_AdvancedBrepShapeRepresentation_3;
  Handle_StepShape_AdvancedBrepShapeRepresentation_4: typeof Handle_StepShape_AdvancedBrepShapeRepresentation_4;
  Handle_StepShape_HArray1OfOrientedEdge: typeof Handle_StepShape_HArray1OfOrientedEdge;
  Handle_StepShape_HArray1OfOrientedEdge_1: typeof Handle_StepShape_HArray1OfOrientedEdge_1;
  Handle_StepShape_HArray1OfOrientedEdge_2: typeof Handle_StepShape_HArray1OfOrientedEdge_2;
  Handle_StepShape_HArray1OfOrientedEdge_3: typeof Handle_StepShape_HArray1OfOrientedEdge_3;
  Handle_StepShape_HArray1OfOrientedEdge_4: typeof Handle_StepShape_HArray1OfOrientedEdge_4;
  StepShape_OrientedClosedShell: typeof StepShape_OrientedClosedShell;
  Handle_StepShape_OrientedClosedShell: typeof Handle_StepShape_OrientedClosedShell;
  Handle_StepShape_OrientedClosedShell_1: typeof Handle_StepShape_OrientedClosedShell_1;
  Handle_StepShape_OrientedClosedShell_2: typeof Handle_StepShape_OrientedClosedShell_2;
  Handle_StepShape_OrientedClosedShell_3: typeof Handle_StepShape_OrientedClosedShell_3;
  Handle_StepShape_OrientedClosedShell_4: typeof Handle_StepShape_OrientedClosedShell_4;
  StepShape_ValueQualifier: typeof StepShape_ValueQualifier;
  StepShape_BooleanOperand: typeof StepShape_BooleanOperand;
  StepShape_Array1OfShell: typeof StepShape_Array1OfShell;
  StepShape_Array1OfShell_1: typeof StepShape_Array1OfShell_1;
  StepShape_Array1OfShell_2: typeof StepShape_Array1OfShell_2;
  StepShape_Array1OfShell_3: typeof StepShape_Array1OfShell_3;
  StepShape_Array1OfShell_4: typeof StepShape_Array1OfShell_4;
  StepShape_Array1OfShell_5: typeof StepShape_Array1OfShell_5;
  Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem: typeof Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem;
  Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_1: typeof Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_1;
  Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_2: typeof Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_2;
  Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_3: typeof Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_3;
  Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_4: typeof Handle_StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem_4;
  StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem: typeof StepShape_MeasureRepresentationItemAndQualifiedRepresentationItem;
  StepShape_BooleanResult: typeof StepShape_BooleanResult;
  Handle_StepShape_BooleanResult: typeof Handle_StepShape_BooleanResult;
  Handle_StepShape_BooleanResult_1: typeof Handle_StepShape_BooleanResult_1;
  Handle_StepShape_BooleanResult_2: typeof Handle_StepShape_BooleanResult_2;
  Handle_StepShape_BooleanResult_3: typeof Handle_StepShape_BooleanResult_3;
  Handle_StepShape_BooleanResult_4: typeof Handle_StepShape_BooleanResult_4;
  StepShape_FacetedBrepShapeRepresentation: typeof StepShape_FacetedBrepShapeRepresentation;
  Handle_StepShape_FacetedBrepShapeRepresentation: typeof Handle_StepShape_FacetedBrepShapeRepresentation;
  Handle_StepShape_FacetedBrepShapeRepresentation_1: typeof Handle_StepShape_FacetedBrepShapeRepresentation_1;
  Handle_StepShape_FacetedBrepShapeRepresentation_2: typeof Handle_StepShape_FacetedBrepShapeRepresentation_2;
  Handle_StepShape_FacetedBrepShapeRepresentation_3: typeof Handle_StepShape_FacetedBrepShapeRepresentation_3;
  Handle_StepShape_FacetedBrepShapeRepresentation_4: typeof Handle_StepShape_FacetedBrepShapeRepresentation_4;
  Handle_StepShape_HArray1OfShapeDimensionRepresentationItem: typeof Handle_StepShape_HArray1OfShapeDimensionRepresentationItem;
  Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_1: typeof Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_1;
  Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_2: typeof Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_2;
  Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_3: typeof Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_3;
  Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_4: typeof Handle_StepShape_HArray1OfShapeDimensionRepresentationItem_4;
  Handle_StepShape_EdgeLoop: typeof Handle_StepShape_EdgeLoop;
  Handle_StepShape_EdgeLoop_1: typeof Handle_StepShape_EdgeLoop_1;
  Handle_StepShape_EdgeLoop_2: typeof Handle_StepShape_EdgeLoop_2;
  Handle_StepShape_EdgeLoop_3: typeof Handle_StepShape_EdgeLoop_3;
  Handle_StepShape_EdgeLoop_4: typeof Handle_StepShape_EdgeLoop_4;
  StepShape_EdgeLoop: typeof StepShape_EdgeLoop;
  Handle_StepShape_ToleranceValue: typeof Handle_StepShape_ToleranceValue;
  Handle_StepShape_ToleranceValue_1: typeof Handle_StepShape_ToleranceValue_1;
  Handle_StepShape_ToleranceValue_2: typeof Handle_StepShape_ToleranceValue_2;
  Handle_StepShape_ToleranceValue_3: typeof Handle_StepShape_ToleranceValue_3;
  Handle_StepShape_ToleranceValue_4: typeof Handle_StepShape_ToleranceValue_4;
  StepShape_ToleranceValue: typeof StepShape_ToleranceValue;
  Handle_StepShape_HArray1OfGeometricSetSelect: typeof Handle_StepShape_HArray1OfGeometricSetSelect;
  Handle_StepShape_HArray1OfGeometricSetSelect_1: typeof Handle_StepShape_HArray1OfGeometricSetSelect_1;
  Handle_StepShape_HArray1OfGeometricSetSelect_2: typeof Handle_StepShape_HArray1OfGeometricSetSelect_2;
  Handle_StepShape_HArray1OfGeometricSetSelect_3: typeof Handle_StepShape_HArray1OfGeometricSetSelect_3;
  Handle_StepShape_HArray1OfGeometricSetSelect_4: typeof Handle_StepShape_HArray1OfGeometricSetSelect_4;
  StepShape_ConnectedFaceSet: typeof StepShape_ConnectedFaceSet;
  Handle_StepShape_ConnectedFaceSet: typeof Handle_StepShape_ConnectedFaceSet;
  Handle_StepShape_ConnectedFaceSet_1: typeof Handle_StepShape_ConnectedFaceSet_1;
  Handle_StepShape_ConnectedFaceSet_2: typeof Handle_StepShape_ConnectedFaceSet_2;
  Handle_StepShape_ConnectedFaceSet_3: typeof Handle_StepShape_ConnectedFaceSet_3;
  Handle_StepShape_ConnectedFaceSet_4: typeof Handle_StepShape_ConnectedFaceSet_4;
  StepShape_DimensionalCharacteristic: typeof StepShape_DimensionalCharacteristic;
  StepShape_TopologicalRepresentationItem: typeof StepShape_TopologicalRepresentationItem;
  Handle_StepShape_TopologicalRepresentationItem: typeof Handle_StepShape_TopologicalRepresentationItem;
  Handle_StepShape_TopologicalRepresentationItem_1: typeof Handle_StepShape_TopologicalRepresentationItem_1;
  Handle_StepShape_TopologicalRepresentationItem_2: typeof Handle_StepShape_TopologicalRepresentationItem_2;
  Handle_StepShape_TopologicalRepresentationItem_3: typeof Handle_StepShape_TopologicalRepresentationItem_3;
  Handle_StepShape_TopologicalRepresentationItem_4: typeof Handle_StepShape_TopologicalRepresentationItem_4;
  Handle_StepShape_ConnectedFaceShapeRepresentation: typeof Handle_StepShape_ConnectedFaceShapeRepresentation;
  Handle_StepShape_ConnectedFaceShapeRepresentation_1: typeof Handle_StepShape_ConnectedFaceShapeRepresentation_1;
  Handle_StepShape_ConnectedFaceShapeRepresentation_2: typeof Handle_StepShape_ConnectedFaceShapeRepresentation_2;
  Handle_StepShape_ConnectedFaceShapeRepresentation_3: typeof Handle_StepShape_ConnectedFaceShapeRepresentation_3;
  Handle_StepShape_ConnectedFaceShapeRepresentation_4: typeof Handle_StepShape_ConnectedFaceShapeRepresentation_4;
  StepShape_ConnectedFaceShapeRepresentation: typeof StepShape_ConnectedFaceShapeRepresentation;
  Handle_StepShape_VertexLoop: typeof Handle_StepShape_VertexLoop;
  Handle_StepShape_VertexLoop_1: typeof Handle_StepShape_VertexLoop_1;
  Handle_StepShape_VertexLoop_2: typeof Handle_StepShape_VertexLoop_2;
  Handle_StepShape_VertexLoop_3: typeof Handle_StepShape_VertexLoop_3;
  Handle_StepShape_VertexLoop_4: typeof Handle_StepShape_VertexLoop_4;
  StepShape_VertexLoop: typeof StepShape_VertexLoop;
  Handle_StepShape_FacetedBrep: typeof Handle_StepShape_FacetedBrep;
  Handle_StepShape_FacetedBrep_1: typeof Handle_StepShape_FacetedBrep_1;
  Handle_StepShape_FacetedBrep_2: typeof Handle_StepShape_FacetedBrep_2;
  Handle_StepShape_FacetedBrep_3: typeof Handle_StepShape_FacetedBrep_3;
  Handle_StepShape_FacetedBrep_4: typeof Handle_StepShape_FacetedBrep_4;
  StepShape_FacetedBrep: typeof StepShape_FacetedBrep;
  Handle_StepShape_MeasureQualification: typeof Handle_StepShape_MeasureQualification;
  Handle_StepShape_MeasureQualification_1: typeof Handle_StepShape_MeasureQualification_1;
  Handle_StepShape_MeasureQualification_2: typeof Handle_StepShape_MeasureQualification_2;
  Handle_StepShape_MeasureQualification_3: typeof Handle_StepShape_MeasureQualification_3;
  Handle_StepShape_MeasureQualification_4: typeof Handle_StepShape_MeasureQualification_4;
  StepShape_MeasureQualification: typeof StepShape_MeasureQualification;
  Handle_StepShape_OpenShell: typeof Handle_StepShape_OpenShell;
  Handle_StepShape_OpenShell_1: typeof Handle_StepShape_OpenShell_1;
  Handle_StepShape_OpenShell_2: typeof Handle_StepShape_OpenShell_2;
  Handle_StepShape_OpenShell_3: typeof Handle_StepShape_OpenShell_3;
  Handle_StepShape_OpenShell_4: typeof Handle_StepShape_OpenShell_4;
  StepShape_OpenShell: typeof StepShape_OpenShell;
  Handle_StepShape_SeamEdge: typeof Handle_StepShape_SeamEdge;
  Handle_StepShape_SeamEdge_1: typeof Handle_StepShape_SeamEdge_1;
  Handle_StepShape_SeamEdge_2: typeof Handle_StepShape_SeamEdge_2;
  Handle_StepShape_SeamEdge_3: typeof Handle_StepShape_SeamEdge_3;
  Handle_StepShape_SeamEdge_4: typeof Handle_StepShape_SeamEdge_4;
  StepShape_SeamEdge: typeof StepShape_SeamEdge;
  StepShape_Face: typeof StepShape_Face;
  Handle_StepShape_Face: typeof Handle_StepShape_Face;
  Handle_StepShape_Face_1: typeof Handle_StepShape_Face_1;
  Handle_StepShape_Face_2: typeof Handle_StepShape_Face_2;
  Handle_StepShape_Face_3: typeof Handle_StepShape_Face_3;
  Handle_StepShape_Face_4: typeof Handle_StepShape_Face_4;
  StepShape_SurfaceModel: typeof StepShape_SurfaceModel;
  StepShape_Torus: typeof StepShape_Torus;
  Handle_StepShape_Torus: typeof Handle_StepShape_Torus;
  Handle_StepShape_Torus_1: typeof Handle_StepShape_Torus_1;
  Handle_StepShape_Torus_2: typeof Handle_StepShape_Torus_2;
  Handle_StepShape_Torus_3: typeof Handle_StepShape_Torus_3;
  Handle_StepShape_Torus_4: typeof Handle_StepShape_Torus_4;
  Handle_StepShape_ShapeDimensionRepresentation: typeof Handle_StepShape_ShapeDimensionRepresentation;
  Handle_StepShape_ShapeDimensionRepresentation_1: typeof Handle_StepShape_ShapeDimensionRepresentation_1;
  Handle_StepShape_ShapeDimensionRepresentation_2: typeof Handle_StepShape_ShapeDimensionRepresentation_2;
  Handle_StepShape_ShapeDimensionRepresentation_3: typeof Handle_StepShape_ShapeDimensionRepresentation_3;
  Handle_StepShape_ShapeDimensionRepresentation_4: typeof Handle_StepShape_ShapeDimensionRepresentation_4;
  StepShape_ShapeDimensionRepresentation: typeof StepShape_ShapeDimensionRepresentation;
  StepShape_TypeQualifier: typeof StepShape_TypeQualifier;
  Handle_StepShape_TypeQualifier: typeof Handle_StepShape_TypeQualifier;
  Handle_StepShape_TypeQualifier_1: typeof Handle_StepShape_TypeQualifier_1;
  Handle_StepShape_TypeQualifier_2: typeof Handle_StepShape_TypeQualifier_2;
  Handle_StepShape_TypeQualifier_3: typeof Handle_StepShape_TypeQualifier_3;
  Handle_StepShape_TypeQualifier_4: typeof Handle_StepShape_TypeQualifier_4;
  Handle_StepShape_EdgeBasedWireframeModel: typeof Handle_StepShape_EdgeBasedWireframeModel;
  Handle_StepShape_EdgeBasedWireframeModel_1: typeof Handle_StepShape_EdgeBasedWireframeModel_1;
  Handle_StepShape_EdgeBasedWireframeModel_2: typeof Handle_StepShape_EdgeBasedWireframeModel_2;
  Handle_StepShape_EdgeBasedWireframeModel_3: typeof Handle_StepShape_EdgeBasedWireframeModel_3;
  Handle_StepShape_EdgeBasedWireframeModel_4: typeof Handle_StepShape_EdgeBasedWireframeModel_4;
  StepShape_EdgeBasedWireframeModel: typeof StepShape_EdgeBasedWireframeModel;
  Handle_StepShape_ClosedShell: typeof Handle_StepShape_ClosedShell;
  Handle_StepShape_ClosedShell_1: typeof Handle_StepShape_ClosedShell_1;
  Handle_StepShape_ClosedShell_2: typeof Handle_StepShape_ClosedShell_2;
  Handle_StepShape_ClosedShell_3: typeof Handle_StepShape_ClosedShell_3;
  Handle_StepShape_ClosedShell_4: typeof Handle_StepShape_ClosedShell_4;
  StepShape_ClosedShell: typeof StepShape_ClosedShell;
  StepShape_ValueFormatTypeQualifier: typeof StepShape_ValueFormatTypeQualifier;
  Handle_StepShape_ValueFormatTypeQualifier: typeof Handle_StepShape_ValueFormatTypeQualifier;
  Handle_StepShape_ValueFormatTypeQualifier_1: typeof Handle_StepShape_ValueFormatTypeQualifier_1;
  Handle_StepShape_ValueFormatTypeQualifier_2: typeof Handle_StepShape_ValueFormatTypeQualifier_2;
  Handle_StepShape_ValueFormatTypeQualifier_3: typeof Handle_StepShape_ValueFormatTypeQualifier_3;
  Handle_StepShape_ValueFormatTypeQualifier_4: typeof Handle_StepShape_ValueFormatTypeQualifier_4;
  StepShape_BoxDomain: typeof StepShape_BoxDomain;
  Handle_StepShape_BoxDomain: typeof Handle_StepShape_BoxDomain;
  Handle_StepShape_BoxDomain_1: typeof Handle_StepShape_BoxDomain_1;
  Handle_StepShape_BoxDomain_2: typeof Handle_StepShape_BoxDomain_2;
  Handle_StepShape_BoxDomain_3: typeof Handle_StepShape_BoxDomain_3;
  Handle_StepShape_BoxDomain_4: typeof Handle_StepShape_BoxDomain_4;
  StepShape_Array1OfGeometricSetSelect: typeof StepShape_Array1OfGeometricSetSelect;
  StepShape_Array1OfGeometricSetSelect_1: typeof StepShape_Array1OfGeometricSetSelect_1;
  StepShape_Array1OfGeometricSetSelect_2: typeof StepShape_Array1OfGeometricSetSelect_2;
  StepShape_Array1OfGeometricSetSelect_3: typeof StepShape_Array1OfGeometricSetSelect_3;
  StepShape_Array1OfGeometricSetSelect_4: typeof StepShape_Array1OfGeometricSetSelect_4;
  StepShape_Array1OfGeometricSetSelect_5: typeof StepShape_Array1OfGeometricSetSelect_5;
  Handle_StepShape_Edge: typeof Handle_StepShape_Edge;
  Handle_StepShape_Edge_1: typeof Handle_StepShape_Edge_1;
  Handle_StepShape_Edge_2: typeof Handle_StepShape_Edge_2;
  Handle_StepShape_Edge_3: typeof Handle_StepShape_Edge_3;
  Handle_StepShape_Edge_4: typeof Handle_StepShape_Edge_4;
  StepShape_Edge: typeof StepShape_Edge;
  StepShape_CsgSolid: typeof StepShape_CsgSolid;
  Handle_StepShape_CsgSolid: typeof Handle_StepShape_CsgSolid;
  Handle_StepShape_CsgSolid_1: typeof Handle_StepShape_CsgSolid_1;
  Handle_StepShape_CsgSolid_2: typeof Handle_StepShape_CsgSolid_2;
  Handle_StepShape_CsgSolid_3: typeof Handle_StepShape_CsgSolid_3;
  Handle_StepShape_CsgSolid_4: typeof Handle_StepShape_CsgSolid_4;
  Handle_StepShape_DimensionalSizeWithPath: typeof Handle_StepShape_DimensionalSizeWithPath;
  Handle_StepShape_DimensionalSizeWithPath_1: typeof Handle_StepShape_DimensionalSizeWithPath_1;
  Handle_StepShape_DimensionalSizeWithPath_2: typeof Handle_StepShape_DimensionalSizeWithPath_2;
  Handle_StepShape_DimensionalSizeWithPath_3: typeof Handle_StepShape_DimensionalSizeWithPath_3;
  Handle_StepShape_DimensionalSizeWithPath_4: typeof Handle_StepShape_DimensionalSizeWithPath_4;
  StepShape_DimensionalSizeWithPath: typeof StepShape_DimensionalSizeWithPath;
  StepShape_BooleanOperator: StepShape_BooleanOperator;
  StepShape_Subedge: typeof StepShape_Subedge;
  Handle_StepShape_Subedge: typeof Handle_StepShape_Subedge;
  Handle_StepShape_Subedge_1: typeof Handle_StepShape_Subedge_1;
  Handle_StepShape_Subedge_2: typeof Handle_StepShape_Subedge_2;
  Handle_StepShape_Subedge_3: typeof Handle_StepShape_Subedge_3;
  Handle_StepShape_Subedge_4: typeof Handle_StepShape_Subedge_4;
  StepShape_FaceBasedSurfaceModel: typeof StepShape_FaceBasedSurfaceModel;
  Handle_StepShape_FaceBasedSurfaceModel: typeof Handle_StepShape_FaceBasedSurfaceModel;
  Handle_StepShape_FaceBasedSurfaceModel_1: typeof Handle_StepShape_FaceBasedSurfaceModel_1;
  Handle_StepShape_FaceBasedSurfaceModel_2: typeof Handle_StepShape_FaceBasedSurfaceModel_2;
  Handle_StepShape_FaceBasedSurfaceModel_3: typeof Handle_StepShape_FaceBasedSurfaceModel_3;
  Handle_StepShape_FaceBasedSurfaceModel_4: typeof Handle_StepShape_FaceBasedSurfaceModel_4;
  Handle_StepShape_AngularSize: typeof Handle_StepShape_AngularSize;
  Handle_StepShape_AngularSize_1: typeof Handle_StepShape_AngularSize_1;
  Handle_StepShape_AngularSize_2: typeof Handle_StepShape_AngularSize_2;
  Handle_StepShape_AngularSize_3: typeof Handle_StepShape_AngularSize_3;
  Handle_StepShape_AngularSize_4: typeof Handle_StepShape_AngularSize_4;
  StepShape_AngularSize: typeof StepShape_AngularSize;
  Handle_StepShape_ShellBasedSurfaceModel: typeof Handle_StepShape_ShellBasedSurfaceModel;
  Handle_StepShape_ShellBasedSurfaceModel_1: typeof Handle_StepShape_ShellBasedSurfaceModel_1;
  Handle_StepShape_ShellBasedSurfaceModel_2: typeof Handle_StepShape_ShellBasedSurfaceModel_2;
  Handle_StepShape_ShellBasedSurfaceModel_3: typeof Handle_StepShape_ShellBasedSurfaceModel_3;
  Handle_StepShape_ShellBasedSurfaceModel_4: typeof Handle_StepShape_ShellBasedSurfaceModel_4;
  StepShape_ShellBasedSurfaceModel: typeof StepShape_ShellBasedSurfaceModel;
  Handle_StepShape_PointRepresentation: typeof Handle_StepShape_PointRepresentation;
  Handle_StepShape_PointRepresentation_1: typeof Handle_StepShape_PointRepresentation_1;
  Handle_StepShape_PointRepresentation_2: typeof Handle_StepShape_PointRepresentation_2;
  Handle_StepShape_PointRepresentation_3: typeof Handle_StepShape_PointRepresentation_3;
  Handle_StepShape_PointRepresentation_4: typeof Handle_StepShape_PointRepresentation_4;
  StepShape_PointRepresentation: typeof StepShape_PointRepresentation;
  StepShape_GeometricallyBoundedSurfaceShapeRepresentation: typeof StepShape_GeometricallyBoundedSurfaceShapeRepresentation;
  Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation: typeof Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation;
  Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_1: typeof Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_1;
  Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_2: typeof Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_2;
  Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_3: typeof Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_3;
  Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_4: typeof Handle_StepShape_GeometricallyBoundedSurfaceShapeRepresentation_4;
  BOPAlgo_BuilderSolid: typeof BOPAlgo_BuilderSolid;
  BOPAlgo_BuilderSolid_1: typeof BOPAlgo_BuilderSolid_1;
  BOPAlgo_BuilderSolid_2: typeof BOPAlgo_BuilderSolid_2;
  BOPAlgo_ListOfCheckResult: typeof BOPAlgo_ListOfCheckResult;
  BOPAlgo_ListOfCheckResult_1: typeof BOPAlgo_ListOfCheckResult_1;
  BOPAlgo_ListOfCheckResult_2: typeof BOPAlgo_ListOfCheckResult_2;
  BOPAlgo_ListOfCheckResult_3: typeof BOPAlgo_ListOfCheckResult_3;
  BOPAlgo_MakePeriodic: typeof BOPAlgo_MakePeriodic;
  BOPAlgo_CheckerSI: typeof BOPAlgo_CheckerSI;
  BOPAlgo_SectionAttribute: typeof BOPAlgo_SectionAttribute;
  BOPAlgo_SectionAttribute_1: typeof BOPAlgo_SectionAttribute_1;
  BOPAlgo_SectionAttribute_2: typeof BOPAlgo_SectionAttribute_2;
  BOPAlgo_BOP: typeof BOPAlgo_BOP;
  BOPAlgo_BOP_1: typeof BOPAlgo_BOP_1;
  BOPAlgo_BOP_2: typeof BOPAlgo_BOP_2;
  BOPAlgo_BuilderShape: typeof BOPAlgo_BuilderShape;
  BOPAlgo_Operation: BOPAlgo_Operation;
  BOPAlgo_MakerVolume: typeof BOPAlgo_MakerVolume;
  BOPAlgo_MakerVolume_1: typeof BOPAlgo_MakerVolume_1;
  BOPAlgo_MakerVolume_2: typeof BOPAlgo_MakerVolume_2;
  BOPAlgo_Section: typeof BOPAlgo_Section;
  BOPAlgo_Section_1: typeof BOPAlgo_Section_1;
  BOPAlgo_Section_2: typeof BOPAlgo_Section_2;
  BOPAlgo_WireSplitter: typeof BOPAlgo_WireSplitter;
  BOPAlgo_WireSplitter_1: typeof BOPAlgo_WireSplitter_1;
  BOPAlgo_WireSplitter_2: typeof BOPAlgo_WireSplitter_2;
  BOPAlgo_Builder: typeof BOPAlgo_Builder;
  BOPAlgo_Builder_1: typeof BOPAlgo_Builder_1;
  BOPAlgo_Builder_2: typeof BOPAlgo_Builder_2;
  BOPAlgo_BuilderFace: typeof BOPAlgo_BuilderFace;
  BOPAlgo_BuilderFace_1: typeof BOPAlgo_BuilderFace_1;
  BOPAlgo_BuilderFace_2: typeof BOPAlgo_BuilderFace_2;
  BOPAlgo_Algo: typeof BOPAlgo_Algo;
  BOPAlgo_RemoveFeatures: typeof BOPAlgo_RemoveFeatures;
  BOPAlgo_ListOfEdgeInfo: typeof BOPAlgo_ListOfEdgeInfo;
  BOPAlgo_ListOfEdgeInfo_1: typeof BOPAlgo_ListOfEdgeInfo_1;
  BOPAlgo_ListOfEdgeInfo_2: typeof BOPAlgo_ListOfEdgeInfo_2;
  BOPAlgo_ListOfEdgeInfo_3: typeof BOPAlgo_ListOfEdgeInfo_3;
  BOPAlgo_EdgeInfo: typeof BOPAlgo_EdgeInfo;
  BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo: typeof BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo;
  BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_1: typeof BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_1;
  BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_2: typeof BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_2;
  BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_3: typeof BOPAlgo_IndexedDataMapOfShapeListOfEdgeInfo_3;
  BOPAlgo_BuilderArea: typeof BOPAlgo_BuilderArea;
  BOPAlgo_CheckStatus: BOPAlgo_CheckStatus;
  BOPAlgo_ArgumentAnalyzer: typeof BOPAlgo_ArgumentAnalyzer;
  BOPAlgo_MakeConnected: typeof BOPAlgo_MakeConnected;
  BOPAlgo_WireEdgeSet: typeof BOPAlgo_WireEdgeSet;
  BOPAlgo_WireEdgeSet_1: typeof BOPAlgo_WireEdgeSet_1;
  BOPAlgo_WireEdgeSet_2: typeof BOPAlgo_WireEdgeSet_2;
  BOPAlgo_ShellSplitter: typeof BOPAlgo_ShellSplitter;
  BOPAlgo_ShellSplitter_1: typeof BOPAlgo_ShellSplitter_1;
  BOPAlgo_ShellSplitter_2: typeof BOPAlgo_ShellSplitter_2;
  BOPAlgo_CellsBuilder: typeof BOPAlgo_CellsBuilder;
  BOPAlgo_CellsBuilder_1: typeof BOPAlgo_CellsBuilder_1;
  BOPAlgo_CellsBuilder_2: typeof BOPAlgo_CellsBuilder_2;
  BOPAlgo_Options: typeof BOPAlgo_Options;
  BOPAlgo_Options_1: typeof BOPAlgo_Options_1;
  BOPAlgo_Options_2: typeof BOPAlgo_Options_2;
  BOPAlgo_CheckResult: typeof BOPAlgo_CheckResult;
  BOPAlgo_AlertNoFiller: typeof BOPAlgo_AlertNoFiller;
  BOPAlgo_AlertIntersectionFailed: typeof BOPAlgo_AlertIntersectionFailed;
  BOPAlgo_AlertBuilderFailed: typeof BOPAlgo_AlertBuilderFailed;
  BOPAlgo_AlertUnableToMakeClosedEdgeOnFace: typeof BOPAlgo_AlertUnableToMakeClosedEdgeOnFace;
  BOPAlgo_AlertUnknownShape: typeof BOPAlgo_AlertUnknownShape;
  BOPAlgo_AlertBOPNotAllowed: typeof BOPAlgo_AlertBOPNotAllowed;
  BOPAlgo_AlertRemoveFeaturesFailed: typeof BOPAlgo_AlertRemoveFeaturesFailed;
  BOPAlgo_AlertUnableToMakePeriodic: typeof BOPAlgo_AlertUnableToMakePeriodic;
  BOPAlgo_AlertBadPositioning: typeof BOPAlgo_AlertBadPositioning;
  BOPAlgo_AlertBuildingPCurveFailed: typeof BOPAlgo_AlertBuildingPCurveFailed;
  BOPAlgo_AlertMultipleArguments: typeof BOPAlgo_AlertMultipleArguments;
  BOPAlgo_AlertMultiDimensionalArguments: typeof BOPAlgo_AlertMultiDimensionalArguments;
  BOPAlgo_AlertNoPeriodicityRequired: typeof BOPAlgo_AlertNoPeriodicityRequired;
  BOPAlgo_AlertUnableToRemoveTheFeature: typeof BOPAlgo_AlertUnableToRemoveTheFeature;
  BOPAlgo_AlertUnableToRepeat: typeof BOPAlgo_AlertUnableToRepeat;
  BOPAlgo_AlertBOPNotSet: typeof BOPAlgo_AlertBOPNotSet;
  BOPAlgo_AlertRemovalOfIBForSolidsFailed: typeof BOPAlgo_AlertRemovalOfIBForSolidsFailed;
  BOPAlgo_AlertEmptyShape: typeof BOPAlgo_AlertEmptyShape;
  BOPAlgo_AlertSelfInterferingShape: typeof BOPAlgo_AlertSelfInterferingShape;
  BOPAlgo_AlertRemovalOfIBForFacesFailed: typeof BOPAlgo_AlertRemovalOfIBForFacesFailed;
  BOPAlgo_AlertUnableToOrientTheShape: typeof BOPAlgo_AlertUnableToOrientTheShape;
  BOPAlgo_AlertNullInputShapes: typeof BOPAlgo_AlertNullInputShapes;
  BOPAlgo_AlertShapeIsNotPeriodic: typeof BOPAlgo_AlertShapeIsNotPeriodic;
  BOPAlgo_AlertNotSplittableEdge: typeof BOPAlgo_AlertNotSplittableEdge;
  BOPAlgo_AlertUnsupportedType: typeof BOPAlgo_AlertUnsupportedType;
  BOPAlgo_AlertUnableToTrim: typeof BOPAlgo_AlertUnableToTrim;
  BOPAlgo_AlertRemovalOfIBForMDimShapes: typeof BOPAlgo_AlertRemovalOfIBForMDimShapes;
  BOPAlgo_AlertFaceBuilderUnusedEdges: typeof BOPAlgo_AlertFaceBuilderUnusedEdges;
  BOPAlgo_AlertUnableToMakeIdentical: typeof BOPAlgo_AlertUnableToMakeIdentical;
  BOPAlgo_AlertPostTreatFF: typeof BOPAlgo_AlertPostTreatFF;
  BOPAlgo_AlertAcquiredSelfIntersection: typeof BOPAlgo_AlertAcquiredSelfIntersection;
  BOPAlgo_AlertSolidBuilderFailed: typeof BOPAlgo_AlertSolidBuilderFailed;
  BOPAlgo_AlertSolidBuilderUnusedFaces: typeof BOPAlgo_AlertSolidBuilderUnusedFaces;
  BOPAlgo_AlertUnableToGlue: typeof BOPAlgo_AlertUnableToGlue;
  BOPAlgo_AlertShellSplitterFailed: typeof BOPAlgo_AlertShellSplitterFailed;
  BOPAlgo_AlertNoFacesToRemove: typeof BOPAlgo_AlertNoFacesToRemove;
  BOPAlgo_AlertTooSmallEdge: typeof BOPAlgo_AlertTooSmallEdge;
  BOPAlgo_AlertTooFewArguments: typeof BOPAlgo_AlertTooFewArguments;
  BOPAlgo_AlertIntersectionOfPairOfShapesFailed: typeof BOPAlgo_AlertIntersectionOfPairOfShapesFailed;
  BOPAlgo_AlertRemovalOfIBForEdgesFailed: typeof BOPAlgo_AlertRemovalOfIBForEdgesFailed;
  BOPAlgo_GlueEnum: BOPAlgo_GlueEnum;
  BOPAlgo_Tools: typeof BOPAlgo_Tools;
  BOPAlgo_ToolsProvider: typeof BOPAlgo_ToolsProvider;
  BOPAlgo_ToolsProvider_1: typeof BOPAlgo_ToolsProvider_1;
  BOPAlgo_ToolsProvider_2: typeof BOPAlgo_ToolsProvider_2;
  BOPAlgo_Splitter: typeof BOPAlgo_Splitter;
  BOPAlgo_Splitter_1: typeof BOPAlgo_Splitter_1;
  BOPAlgo_Splitter_2: typeof BOPAlgo_Splitter_2;
  ShapeProcessAPI_ApplySequence: typeof ShapeProcessAPI_ApplySequence;
  RWStepGeom_RWBSplineCurveWithKnotsAndRationalBSplineCurve: typeof RWStepGeom_RWBSplineCurveWithKnotsAndRationalBSplineCurve;
  RWStepGeom_RWBezierSurface: typeof RWStepGeom_RWBezierSurface;
  RWStepGeom_RWBezierSurfaceAndRationalBSplineSurface: typeof RWStepGeom_RWBezierSurfaceAndRationalBSplineSurface;
  RWStepGeom_RWBSplineSurfaceWithKnotsAndRationalBSplineSurface: typeof RWStepGeom_RWBSplineSurfaceWithKnotsAndRationalBSplineSurface;
  RWStepGeom_RWParabola: typeof RWStepGeom_RWParabola;
  RWStepGeom_RWOuterBoundaryCurve: typeof RWStepGeom_RWOuterBoundaryCurve;
  RWStepGeom_RWCircle: typeof RWStepGeom_RWCircle;
  RWStepGeom_RWPointReplica: typeof RWStepGeom_RWPointReplica;
  RWStepGeom_RWSurfacePatch: typeof RWStepGeom_RWSurfacePatch;
  RWStepGeom_RWDirection: typeof RWStepGeom_RWDirection;
  RWStepGeom_RWGeometricRepresentationContextAndParametricRepresentationContext: typeof RWStepGeom_RWGeometricRepresentationContextAndParametricRepresentationContext;
  RWStepGeom_RWUniformCurve: typeof RWStepGeom_RWUniformCurve;
  RWStepGeom_RWConic: typeof RWStepGeom_RWConic;
  RWStepGeom_RWSurfaceCurve: typeof RWStepGeom_RWSurfaceCurve;
  RWStepGeom_RWCurveReplica: typeof RWStepGeom_RWCurveReplica;
  RWStepGeom_RWBSplineCurve: typeof RWStepGeom_RWBSplineCurve;
  RWStepGeom_RWBezierCurve: typeof RWStepGeom_RWBezierCurve;
  RWStepGeom_RWBSplineSurfaceWithKnots: typeof RWStepGeom_RWBSplineSurfaceWithKnots;
  RWStepGeom_RWSurfaceReplica: typeof RWStepGeom_RWSurfaceReplica;
  RWStepGeom_RWCylindricalSurface: typeof RWStepGeom_RWCylindricalSurface;
  RWStepGeom_RWEllipse: typeof RWStepGeom_RWEllipse;
  RWStepGeom_RWOffsetSurface: typeof RWStepGeom_RWOffsetSurface;
  RWStepGeom_RWAxis2Placement3d: typeof RWStepGeom_RWAxis2Placement3d;
  RWStepGeom_RWUniformCurveAndRationalBSplineCurve: typeof RWStepGeom_RWUniformCurveAndRationalBSplineCurve;
  RWStepGeom_RWUniformSurface: typeof RWStepGeom_RWUniformSurface;
  RWStepGeom_RWBoundaryCurve: typeof RWStepGeom_RWBoundaryCurve;
  RWStepGeom_RWElementarySurface: typeof RWStepGeom_RWElementarySurface;
  RWStepGeom_RWSurfaceOfRevolution: typeof RWStepGeom_RWSurfaceOfRevolution;
  RWStepGeom_RWPlane: typeof RWStepGeom_RWPlane;
  RWStepGeom_RWOffsetCurve3d: typeof RWStepGeom_RWOffsetCurve3d;
  RWStepGeom_RWHyperbola: typeof RWStepGeom_RWHyperbola;
  RWStepGeom_RWBezierCurveAndRationalBSplineCurve: typeof RWStepGeom_RWBezierCurveAndRationalBSplineCurve;
  RWStepGeom_RWQuasiUniformSurface: typeof RWStepGeom_RWQuasiUniformSurface;
  RWStepGeom_RWCompositeCurveOnSurface: typeof RWStepGeom_RWCompositeCurveOnSurface;
  RWStepGeom_RWConicalSurface: typeof RWStepGeom_RWConicalSurface;
  RWStepGeom_RWPoint: typeof RWStepGeom_RWPoint;
  RWStepGeom_RWPointOnCurve: typeof RWStepGeom_RWPointOnCurve;
  RWStepGeom_RWRationalBSplineSurface: typeof RWStepGeom_RWRationalBSplineSurface;
  RWStepGeom_RWCurveBoundedSurface: typeof RWStepGeom_RWCurveBoundedSurface;
  RWStepGeom_RWEvaluatedDegeneratePcurve: typeof RWStepGeom_RWEvaluatedDegeneratePcurve;
  RWStepGeom_RWToroidalSurface: typeof RWStepGeom_RWToroidalSurface;
  RWStepGeom_RWIntersectionCurve: typeof RWStepGeom_RWIntersectionCurve;
  RWStepGeom_RWQuasiUniformCurve: typeof RWStepGeom_RWQuasiUniformCurve;
  RWStepGeom_RWSurface: typeof RWStepGeom_RWSurface;
  RWStepGeom_RWSurfaceCurveAndBoundedCurve: typeof RWStepGeom_RWSurfaceCurveAndBoundedCurve;
  RWStepGeom_RWPointOnSurface: typeof RWStepGeom_RWPointOnSurface;
  RWStepGeom_RWCartesianTransformationOperator: typeof RWStepGeom_RWCartesianTransformationOperator;
  RWStepGeom_RWAxis1Placement: typeof RWStepGeom_RWAxis1Placement;
  RWStepGeom_RWQuasiUniformCurveAndRationalBSplineCurve: typeof RWStepGeom_RWQuasiUniformCurveAndRationalBSplineCurve;
  RWStepGeom_RWDegenerateToroidalSurface: typeof RWStepGeom_RWDegenerateToroidalSurface;
  RWStepGeom_RWBoundedCurve: typeof RWStepGeom_RWBoundedCurve;
  RWStepGeom_RWSeamCurve: typeof RWStepGeom_RWSeamCurve;
  RWStepGeom_RWQuasiUniformSurfaceAndRationalBSplineSurface: typeof RWStepGeom_RWQuasiUniformSurfaceAndRationalBSplineSurface;
  RWStepGeom_RWGeometricRepresentationContextAndGlobalUnitAssignedContext: typeof RWStepGeom_RWGeometricRepresentationContextAndGlobalUnitAssignedContext;
  RWStepGeom_RWGeometricRepresentationItem: typeof RWStepGeom_RWGeometricRepresentationItem;
  RWStepGeom_RWCartesianPoint: typeof RWStepGeom_RWCartesianPoint;
  RWStepGeom_RWRationalBSplineCurve: typeof RWStepGeom_RWRationalBSplineCurve;
  RWStepGeom_RWRectangularTrimmedSurface: typeof RWStepGeom_RWRectangularTrimmedSurface;
  RWStepGeom_RWOrientedSurface: typeof RWStepGeom_RWOrientedSurface;
  RWStepGeom_RWCartesianTransformationOperator3d: typeof RWStepGeom_RWCartesianTransformationOperator3d;
  RWStepGeom_RWRectangularCompositeSurface: typeof RWStepGeom_RWRectangularCompositeSurface;
  RWStepGeom_RWSurfaceOfLinearExtrusion: typeof RWStepGeom_RWSurfaceOfLinearExtrusion;
  RWStepGeom_RWReparametrisedCompositeCurveSegment: typeof RWStepGeom_RWReparametrisedCompositeCurveSegment;
  RWStepGeom_RWCompositeCurveSegment: typeof RWStepGeom_RWCompositeCurveSegment;
  RWStepGeom_RWBSplineCurveWithKnots: typeof RWStepGeom_RWBSplineCurveWithKnots;
  RWStepGeom_RWVector: typeof RWStepGeom_RWVector;
  RWStepGeom_RWAxis2Placement2d: typeof RWStepGeom_RWAxis2Placement2d;
  RWStepGeom_RWUniformSurfaceAndRationalBSplineSurface: typeof RWStepGeom_RWUniformSurfaceAndRationalBSplineSurface;
  RWStepGeom_RWSphericalSurface: typeof RWStepGeom_RWSphericalSurface;
  RWStepGeom_RWCompositeCurve: typeof RWStepGeom_RWCompositeCurve;
  RWStepGeom_RWCurve: typeof RWStepGeom_RWCurve;
  RWStepGeom_RWPcurve: typeof RWStepGeom_RWPcurve;
  RWStepGeom_RWPlacement: typeof RWStepGeom_RWPlacement;
  RWStepGeom_RWLine: typeof RWStepGeom_RWLine;
  RWStepGeom_RWGeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx: typeof RWStepGeom_RWGeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx;
  RWStepGeom_RWPolyline: typeof RWStepGeom_RWPolyline;
  RWStepGeom_RWSweptSurface: typeof RWStepGeom_RWSweptSurface;
  RWStepGeom_RWGeometricRepresentationContext: typeof RWStepGeom_RWGeometricRepresentationContext;
  RWStepGeom_RWTrimmedCurve: typeof RWStepGeom_RWTrimmedCurve;
  RWStepGeom_RWDegeneratePcurve: typeof RWStepGeom_RWDegeneratePcurve;
  RWStepGeom_RWBSplineSurface: typeof RWStepGeom_RWBSplineSurface;
  RWStepGeom_RWBoundedSurface: typeof RWStepGeom_RWBoundedSurface;
  AppBlend_Approx: typeof AppBlend_Approx;
  Handle_HLRTopoBRep_OutLiner: typeof Handle_HLRTopoBRep_OutLiner;
  Handle_HLRTopoBRep_OutLiner_1: typeof Handle_HLRTopoBRep_OutLiner_1;
  Handle_HLRTopoBRep_OutLiner_2: typeof Handle_HLRTopoBRep_OutLiner_2;
  Handle_HLRTopoBRep_OutLiner_3: typeof Handle_HLRTopoBRep_OutLiner_3;
  Handle_HLRTopoBRep_OutLiner_4: typeof Handle_HLRTopoBRep_OutLiner_4;
  HLRTopoBRep_OutLiner: typeof HLRTopoBRep_OutLiner;
  HLRTopoBRep_OutLiner_1: typeof HLRTopoBRep_OutLiner_1;
  HLRTopoBRep_OutLiner_2: typeof HLRTopoBRep_OutLiner_2;
  HLRTopoBRep_OutLiner_3: typeof HLRTopoBRep_OutLiner_3;
  HLRTopoBRep_ListOfVData: typeof HLRTopoBRep_ListOfVData;
  HLRTopoBRep_ListOfVData_1: typeof HLRTopoBRep_ListOfVData_1;
  HLRTopoBRep_ListOfVData_2: typeof HLRTopoBRep_ListOfVData_2;
  HLRTopoBRep_ListOfVData_3: typeof HLRTopoBRep_ListOfVData_3;
  HLRTopoBRep_DSFiller: typeof HLRTopoBRep_DSFiller;
  HLRTopoBRep_FaceIsoLiner: typeof HLRTopoBRep_FaceIsoLiner;
  HLRTopoBRep_FaceData: typeof HLRTopoBRep_FaceData;
  HLRTopoBRep_Data: typeof HLRTopoBRep_Data;
  HLRTopoBRep_MapOfShapeListOfVData: typeof HLRTopoBRep_MapOfShapeListOfVData;
  HLRTopoBRep_MapOfShapeListOfVData_1: typeof HLRTopoBRep_MapOfShapeListOfVData_1;
  HLRTopoBRep_MapOfShapeListOfVData_2: typeof HLRTopoBRep_MapOfShapeListOfVData_2;
  HLRTopoBRep_MapOfShapeListOfVData_3: typeof HLRTopoBRep_MapOfShapeListOfVData_3;
  HLRTopoBRep_VData: typeof HLRTopoBRep_VData;
  HLRTopoBRep_VData_1: typeof HLRTopoBRep_VData_1;
  HLRTopoBRep_VData_2: typeof HLRTopoBRep_VData_2;
  HLRTopoBRep_DataMapOfShapeFaceData: typeof HLRTopoBRep_DataMapOfShapeFaceData;
  HLRTopoBRep_DataMapOfShapeFaceData_1: typeof HLRTopoBRep_DataMapOfShapeFaceData_1;
  HLRTopoBRep_DataMapOfShapeFaceData_2: typeof HLRTopoBRep_DataMapOfShapeFaceData_2;
  HLRTopoBRep_DataMapOfShapeFaceData_3: typeof HLRTopoBRep_DataMapOfShapeFaceData_3;
  Handle_FEmTool_ProfileMatrix: typeof Handle_FEmTool_ProfileMatrix;
  Handle_FEmTool_ProfileMatrix_1: typeof Handle_FEmTool_ProfileMatrix_1;
  Handle_FEmTool_ProfileMatrix_2: typeof Handle_FEmTool_ProfileMatrix_2;
  Handle_FEmTool_ProfileMatrix_3: typeof Handle_FEmTool_ProfileMatrix_3;
  Handle_FEmTool_ProfileMatrix_4: typeof Handle_FEmTool_ProfileMatrix_4;
  FEmTool_ProfileMatrix: typeof FEmTool_ProfileMatrix;
  Handle_FEmTool_SparseMatrix: typeof Handle_FEmTool_SparseMatrix;
  Handle_FEmTool_SparseMatrix_1: typeof Handle_FEmTool_SparseMatrix_1;
  Handle_FEmTool_SparseMatrix_2: typeof Handle_FEmTool_SparseMatrix_2;
  Handle_FEmTool_SparseMatrix_3: typeof Handle_FEmTool_SparseMatrix_3;
  Handle_FEmTool_SparseMatrix_4: typeof Handle_FEmTool_SparseMatrix_4;
  FEmTool_SparseMatrix: typeof FEmTool_SparseMatrix;
  FEmTool_SeqOfLinConstr: typeof FEmTool_SeqOfLinConstr;
  FEmTool_SeqOfLinConstr_1: typeof FEmTool_SeqOfLinConstr_1;
  FEmTool_SeqOfLinConstr_2: typeof FEmTool_SeqOfLinConstr_2;
  FEmTool_SeqOfLinConstr_3: typeof FEmTool_SeqOfLinConstr_3;
  FEmTool_Assembly: typeof FEmTool_Assembly;
  FEmTool_LinearTension: typeof FEmTool_LinearTension;
  Handle_FEmTool_LinearTension: typeof Handle_FEmTool_LinearTension;
  Handle_FEmTool_LinearTension_1: typeof Handle_FEmTool_LinearTension_1;
  Handle_FEmTool_LinearTension_2: typeof Handle_FEmTool_LinearTension_2;
  Handle_FEmTool_LinearTension_3: typeof Handle_FEmTool_LinearTension_3;
  Handle_FEmTool_LinearTension_4: typeof Handle_FEmTool_LinearTension_4;
  Handle_FEmTool_HAssemblyTable: typeof Handle_FEmTool_HAssemblyTable;
  Handle_FEmTool_HAssemblyTable_1: typeof Handle_FEmTool_HAssemblyTable_1;
  Handle_FEmTool_HAssemblyTable_2: typeof Handle_FEmTool_HAssemblyTable_2;
  Handle_FEmTool_HAssemblyTable_3: typeof Handle_FEmTool_HAssemblyTable_3;
  Handle_FEmTool_HAssemblyTable_4: typeof Handle_FEmTool_HAssemblyTable_4;
  Handle_FEmTool_Curve: typeof Handle_FEmTool_Curve;
  Handle_FEmTool_Curve_1: typeof Handle_FEmTool_Curve_1;
  Handle_FEmTool_Curve_2: typeof Handle_FEmTool_Curve_2;
  Handle_FEmTool_Curve_3: typeof Handle_FEmTool_Curve_3;
  Handle_FEmTool_Curve_4: typeof Handle_FEmTool_Curve_4;
  FEmTool_Curve: typeof FEmTool_Curve;
  Handle_FEmTool_ElementaryCriterion: typeof Handle_FEmTool_ElementaryCriterion;
  Handle_FEmTool_ElementaryCriterion_1: typeof Handle_FEmTool_ElementaryCriterion_1;
  Handle_FEmTool_ElementaryCriterion_2: typeof Handle_FEmTool_ElementaryCriterion_2;
  Handle_FEmTool_ElementaryCriterion_3: typeof Handle_FEmTool_ElementaryCriterion_3;
  Handle_FEmTool_ElementaryCriterion_4: typeof Handle_FEmTool_ElementaryCriterion_4;
  FEmTool_ElementaryCriterion: typeof FEmTool_ElementaryCriterion;
  FEmTool_ElementsOfRefMatrix: typeof FEmTool_ElementsOfRefMatrix;
  Handle_FEmTool_LinearJerk: typeof Handle_FEmTool_LinearJerk;
  Handle_FEmTool_LinearJerk_1: typeof Handle_FEmTool_LinearJerk_1;
  Handle_FEmTool_LinearJerk_2: typeof Handle_FEmTool_LinearJerk_2;
  Handle_FEmTool_LinearJerk_3: typeof Handle_FEmTool_LinearJerk_3;
  Handle_FEmTool_LinearJerk_4: typeof Handle_FEmTool_LinearJerk_4;
  FEmTool_LinearJerk: typeof FEmTool_LinearJerk;
  Handle_FEmTool_LinearFlexion: typeof Handle_FEmTool_LinearFlexion;
  Handle_FEmTool_LinearFlexion_1: typeof Handle_FEmTool_LinearFlexion_1;
  Handle_FEmTool_LinearFlexion_2: typeof Handle_FEmTool_LinearFlexion_2;
  Handle_FEmTool_LinearFlexion_3: typeof Handle_FEmTool_LinearFlexion_3;
  Handle_FEmTool_LinearFlexion_4: typeof Handle_FEmTool_LinearFlexion_4;
  FEmTool_LinearFlexion: typeof FEmTool_LinearFlexion;
  IGESBasic_ToolOrderedGroupWithoutBackP: typeof IGESBasic_ToolOrderedGroupWithoutBackP;
  IGESBasic_ExternalReferenceFile: typeof IGESBasic_ExternalReferenceFile;
  Handle_IGESBasic_ExternalReferenceFile: typeof Handle_IGESBasic_ExternalReferenceFile;
  Handle_IGESBasic_ExternalReferenceFile_1: typeof Handle_IGESBasic_ExternalReferenceFile_1;
  Handle_IGESBasic_ExternalReferenceFile_2: typeof Handle_IGESBasic_ExternalReferenceFile_2;
  Handle_IGESBasic_ExternalReferenceFile_3: typeof Handle_IGESBasic_ExternalReferenceFile_3;
  Handle_IGESBasic_ExternalReferenceFile_4: typeof Handle_IGESBasic_ExternalReferenceFile_4;
  IGESBasic_ToolExternalRefName: typeof IGESBasic_ToolExternalRefName;
  Handle_IGESBasic_HArray1OfHArray1OfReal: typeof Handle_IGESBasic_HArray1OfHArray1OfReal;
  Handle_IGESBasic_HArray1OfHArray1OfReal_1: typeof Handle_IGESBasic_HArray1OfHArray1OfReal_1;
  Handle_IGESBasic_HArray1OfHArray1OfReal_2: typeof Handle_IGESBasic_HArray1OfHArray1OfReal_2;
  Handle_IGESBasic_HArray1OfHArray1OfReal_3: typeof Handle_IGESBasic_HArray1OfHArray1OfReal_3;
  Handle_IGESBasic_HArray1OfHArray1OfReal_4: typeof Handle_IGESBasic_HArray1OfHArray1OfReal_4;
  IGESBasic_HArray1OfHArray1OfReal: typeof IGESBasic_HArray1OfHArray1OfReal;
  IGESBasic_ExternalRefFileName: typeof IGESBasic_ExternalRefFileName;
  Handle_IGESBasic_ExternalRefFileName: typeof Handle_IGESBasic_ExternalRefFileName;
  Handle_IGESBasic_ExternalRefFileName_1: typeof Handle_IGESBasic_ExternalRefFileName_1;
  Handle_IGESBasic_ExternalRefFileName_2: typeof Handle_IGESBasic_ExternalRefFileName_2;
  Handle_IGESBasic_ExternalRefFileName_3: typeof Handle_IGESBasic_ExternalRefFileName_3;
  Handle_IGESBasic_ExternalRefFileName_4: typeof Handle_IGESBasic_ExternalRefFileName_4;
  Handle_IGESBasic_ReadWriteModule: typeof Handle_IGESBasic_ReadWriteModule;
  Handle_IGESBasic_ReadWriteModule_1: typeof Handle_IGESBasic_ReadWriteModule_1;
  Handle_IGESBasic_ReadWriteModule_2: typeof Handle_IGESBasic_ReadWriteModule_2;
  Handle_IGESBasic_ReadWriteModule_3: typeof Handle_IGESBasic_ReadWriteModule_3;
  Handle_IGESBasic_ReadWriteModule_4: typeof Handle_IGESBasic_ReadWriteModule_4;
  IGESBasic_ReadWriteModule: typeof IGESBasic_ReadWriteModule;
  IGESBasic_ToolExternalReferenceFile: typeof IGESBasic_ToolExternalReferenceFile;
  IGESBasic_HArray1OfHArray1OfInteger: typeof IGESBasic_HArray1OfHArray1OfInteger;
  Handle_IGESBasic_HArray1OfHArray1OfInteger: typeof Handle_IGESBasic_HArray1OfHArray1OfInteger;
  Handle_IGESBasic_HArray1OfHArray1OfInteger_1: typeof Handle_IGESBasic_HArray1OfHArray1OfInteger_1;
  Handle_IGESBasic_HArray1OfHArray1OfInteger_2: typeof Handle_IGESBasic_HArray1OfHArray1OfInteger_2;
  Handle_IGESBasic_HArray1OfHArray1OfInteger_3: typeof Handle_IGESBasic_HArray1OfHArray1OfInteger_3;
  Handle_IGESBasic_HArray1OfHArray1OfInteger_4: typeof Handle_IGESBasic_HArray1OfHArray1OfInteger_4;
  IGESBasic_ToolExternalRefLibName: typeof IGESBasic_ToolExternalRefLibName;
  Handle_IGESBasic_HArray1OfHArray1OfIGESEntity: typeof Handle_IGESBasic_HArray1OfHArray1OfIGESEntity;
  Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_1: typeof Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_1;
  Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_2: typeof Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_2;
  Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_3: typeof Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_3;
  Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_4: typeof Handle_IGESBasic_HArray1OfHArray1OfIGESEntity_4;
  IGESBasic_HArray1OfHArray1OfIGESEntity: typeof IGESBasic_HArray1OfHArray1OfIGESEntity;
  IGESBasic_ExternalRefFileIndex: typeof IGESBasic_ExternalRefFileIndex;
  Handle_IGESBasic_ExternalRefFileIndex: typeof Handle_IGESBasic_ExternalRefFileIndex;
  Handle_IGESBasic_ExternalRefFileIndex_1: typeof Handle_IGESBasic_ExternalRefFileIndex_1;
  Handle_IGESBasic_ExternalRefFileIndex_2: typeof Handle_IGESBasic_ExternalRefFileIndex_2;
  Handle_IGESBasic_ExternalRefFileIndex_3: typeof Handle_IGESBasic_ExternalRefFileIndex_3;
  Handle_IGESBasic_ExternalRefFileIndex_4: typeof Handle_IGESBasic_ExternalRefFileIndex_4;
  IGESBasic_ExternalRefName: typeof IGESBasic_ExternalRefName;
  Handle_IGESBasic_ExternalRefName: typeof Handle_IGESBasic_ExternalRefName;
  Handle_IGESBasic_ExternalRefName_1: typeof Handle_IGESBasic_ExternalRefName_1;
  Handle_IGESBasic_ExternalRefName_2: typeof Handle_IGESBasic_ExternalRefName_2;
  Handle_IGESBasic_ExternalRefName_3: typeof Handle_IGESBasic_ExternalRefName_3;
  Handle_IGESBasic_ExternalRefName_4: typeof Handle_IGESBasic_ExternalRefName_4;
  IGESBasic_ToolOrderedGroup: typeof IGESBasic_ToolOrderedGroup;
  IGESBasic_ToolExternalRefFileName: typeof IGESBasic_ToolExternalRefFileName;
  IGESBasic_ToolExternalRefFileIndex: typeof IGESBasic_ToolExternalRefFileIndex;
  IGESBasic_ExternalRefLibName: typeof IGESBasic_ExternalRefLibName;
  Handle_IGESBasic_ExternalRefLibName: typeof Handle_IGESBasic_ExternalRefLibName;
  Handle_IGESBasic_ExternalRefLibName_1: typeof Handle_IGESBasic_ExternalRefLibName_1;
  Handle_IGESBasic_ExternalRefLibName_2: typeof Handle_IGESBasic_ExternalRefLibName_2;
  Handle_IGESBasic_ExternalRefLibName_3: typeof Handle_IGESBasic_ExternalRefLibName_3;
  Handle_IGESBasic_ExternalRefLibName_4: typeof Handle_IGESBasic_ExternalRefLibName_4;
  Handle_IGESBasic_HArray1OfHArray1OfXYZ: typeof Handle_IGESBasic_HArray1OfHArray1OfXYZ;
  Handle_IGESBasic_HArray1OfHArray1OfXYZ_1: typeof Handle_IGESBasic_HArray1OfHArray1OfXYZ_1;
  Handle_IGESBasic_HArray1OfHArray1OfXYZ_2: typeof Handle_IGESBasic_HArray1OfHArray1OfXYZ_2;
  Handle_IGESBasic_HArray1OfHArray1OfXYZ_3: typeof Handle_IGESBasic_HArray1OfHArray1OfXYZ_3;
  Handle_IGESBasic_HArray1OfHArray1OfXYZ_4: typeof Handle_IGESBasic_HArray1OfHArray1OfXYZ_4;
  IGESBasic_HArray1OfHArray1OfXYZ: typeof IGESBasic_HArray1OfHArray1OfXYZ;
  IGESBasic_SingularSubfigure: typeof IGESBasic_SingularSubfigure;
  Handle_IGESBasic_SingularSubfigure: typeof Handle_IGESBasic_SingularSubfigure;
  Handle_IGESBasic_SingularSubfigure_1: typeof Handle_IGESBasic_SingularSubfigure_1;
  Handle_IGESBasic_SingularSubfigure_2: typeof Handle_IGESBasic_SingularSubfigure_2;
  Handle_IGESBasic_SingularSubfigure_3: typeof Handle_IGESBasic_SingularSubfigure_3;
  Handle_IGESBasic_SingularSubfigure_4: typeof Handle_IGESBasic_SingularSubfigure_4;
  IGESBasic_SpecificModule: typeof IGESBasic_SpecificModule;
  Handle_IGESBasic_SpecificModule: typeof Handle_IGESBasic_SpecificModule;
  Handle_IGESBasic_SpecificModule_1: typeof Handle_IGESBasic_SpecificModule_1;
  Handle_IGESBasic_SpecificModule_2: typeof Handle_IGESBasic_SpecificModule_2;
  Handle_IGESBasic_SpecificModule_3: typeof Handle_IGESBasic_SpecificModule_3;
  Handle_IGESBasic_SpecificModule_4: typeof Handle_IGESBasic_SpecificModule_4;
  IGESBasic_ToolExternalRefFile: typeof IGESBasic_ToolExternalRefFile;
  IGESBasic_GroupWithoutBackP: typeof IGESBasic_GroupWithoutBackP;
  Handle_IGESBasic_GroupWithoutBackP: typeof Handle_IGESBasic_GroupWithoutBackP;
  Handle_IGESBasic_GroupWithoutBackP_1: typeof Handle_IGESBasic_GroupWithoutBackP_1;
  Handle_IGESBasic_GroupWithoutBackP_2: typeof Handle_IGESBasic_GroupWithoutBackP_2;
  Handle_IGESBasic_GroupWithoutBackP_3: typeof Handle_IGESBasic_GroupWithoutBackP_3;
  Handle_IGESBasic_GroupWithoutBackP_4: typeof Handle_IGESBasic_GroupWithoutBackP_4;
  IGESBasic_OrderedGroup: typeof IGESBasic_OrderedGroup;
  Handle_IGESBasic_OrderedGroup: typeof Handle_IGESBasic_OrderedGroup;
  Handle_IGESBasic_OrderedGroup_1: typeof Handle_IGESBasic_OrderedGroup_1;
  Handle_IGESBasic_OrderedGroup_2: typeof Handle_IGESBasic_OrderedGroup_2;
  Handle_IGESBasic_OrderedGroup_3: typeof Handle_IGESBasic_OrderedGroup_3;
  Handle_IGESBasic_OrderedGroup_4: typeof Handle_IGESBasic_OrderedGroup_4;
  Handle_IGESBasic_SubfigureDef: typeof Handle_IGESBasic_SubfigureDef;
  Handle_IGESBasic_SubfigureDef_1: typeof Handle_IGESBasic_SubfigureDef_1;
  Handle_IGESBasic_SubfigureDef_2: typeof Handle_IGESBasic_SubfigureDef_2;
  Handle_IGESBasic_SubfigureDef_3: typeof Handle_IGESBasic_SubfigureDef_3;
  Handle_IGESBasic_SubfigureDef_4: typeof Handle_IGESBasic_SubfigureDef_4;
  IGESBasic_SubfigureDef: typeof IGESBasic_SubfigureDef;
  IGESBasic_Group: typeof IGESBasic_Group;
  IGESBasic_Group_1: typeof IGESBasic_Group_1;
  IGESBasic_Group_2: typeof IGESBasic_Group_2;
  Handle_IGESBasic_Group: typeof Handle_IGESBasic_Group;
  Handle_IGESBasic_Group_1: typeof Handle_IGESBasic_Group_1;
  Handle_IGESBasic_Group_2: typeof Handle_IGESBasic_Group_2;
  Handle_IGESBasic_Group_3: typeof Handle_IGESBasic_Group_3;
  Handle_IGESBasic_Group_4: typeof Handle_IGESBasic_Group_4;
  IGESBasic_ToolGroupWithoutBackP: typeof IGESBasic_ToolGroupWithoutBackP;
  Handle_IGESBasic_HArray1OfLineFontEntity: typeof Handle_IGESBasic_HArray1OfLineFontEntity;
  Handle_IGESBasic_HArray1OfLineFontEntity_1: typeof Handle_IGESBasic_HArray1OfLineFontEntity_1;
  Handle_IGESBasic_HArray1OfLineFontEntity_2: typeof Handle_IGESBasic_HArray1OfLineFontEntity_2;
  Handle_IGESBasic_HArray1OfLineFontEntity_3: typeof Handle_IGESBasic_HArray1OfLineFontEntity_3;
  Handle_IGESBasic_HArray1OfLineFontEntity_4: typeof Handle_IGESBasic_HArray1OfLineFontEntity_4;
  IGESBasic_ToolName: typeof IGESBasic_ToolName;
  IGESBasic_Hierarchy: typeof IGESBasic_Hierarchy;
  Handle_IGESBasic_Hierarchy: typeof Handle_IGESBasic_Hierarchy;
  Handle_IGESBasic_Hierarchy_1: typeof Handle_IGESBasic_Hierarchy_1;
  Handle_IGESBasic_Hierarchy_2: typeof Handle_IGESBasic_Hierarchy_2;
  Handle_IGESBasic_Hierarchy_3: typeof Handle_IGESBasic_Hierarchy_3;
  Handle_IGESBasic_Hierarchy_4: typeof Handle_IGESBasic_Hierarchy_4;
  IGESBasic_SingleParent: typeof IGESBasic_SingleParent;
  Handle_IGESBasic_SingleParent: typeof Handle_IGESBasic_SingleParent;
  Handle_IGESBasic_SingleParent_1: typeof Handle_IGESBasic_SingleParent_1;
  Handle_IGESBasic_SingleParent_2: typeof Handle_IGESBasic_SingleParent_2;
  Handle_IGESBasic_SingleParent_3: typeof Handle_IGESBasic_SingleParent_3;
  Handle_IGESBasic_SingleParent_4: typeof Handle_IGESBasic_SingleParent_4;
  IGESBasic_ToolSingleParent: typeof IGESBasic_ToolSingleParent;
  Handle_IGESBasic_HArray2OfHArray1OfReal: typeof Handle_IGESBasic_HArray2OfHArray1OfReal;
  Handle_IGESBasic_HArray2OfHArray1OfReal_1: typeof Handle_IGESBasic_HArray2OfHArray1OfReal_1;
  Handle_IGESBasic_HArray2OfHArray1OfReal_2: typeof Handle_IGESBasic_HArray2OfHArray1OfReal_2;
  Handle_IGESBasic_HArray2OfHArray1OfReal_3: typeof Handle_IGESBasic_HArray2OfHArray1OfReal_3;
  Handle_IGESBasic_HArray2OfHArray1OfReal_4: typeof Handle_IGESBasic_HArray2OfHArray1OfReal_4;
  IGESBasic_GeneralModule: typeof IGESBasic_GeneralModule;
  Handle_IGESBasic_GeneralModule: typeof Handle_IGESBasic_GeneralModule;
  Handle_IGESBasic_GeneralModule_1: typeof Handle_IGESBasic_GeneralModule_1;
  Handle_IGESBasic_GeneralModule_2: typeof Handle_IGESBasic_GeneralModule_2;
  Handle_IGESBasic_GeneralModule_3: typeof Handle_IGESBasic_GeneralModule_3;
  Handle_IGESBasic_GeneralModule_4: typeof Handle_IGESBasic_GeneralModule_4;
  IGESBasic_ToolGroup: typeof IGESBasic_ToolGroup;
  Handle_IGESBasic_AssocGroupType: typeof Handle_IGESBasic_AssocGroupType;
  Handle_IGESBasic_AssocGroupType_1: typeof Handle_IGESBasic_AssocGroupType_1;
  Handle_IGESBasic_AssocGroupType_2: typeof Handle_IGESBasic_AssocGroupType_2;
  Handle_IGESBasic_AssocGroupType_3: typeof Handle_IGESBasic_AssocGroupType_3;
  Handle_IGESBasic_AssocGroupType_4: typeof Handle_IGESBasic_AssocGroupType_4;
  IGESBasic_AssocGroupType: typeof IGESBasic_AssocGroupType;
  Handle_IGESBasic_Name: typeof Handle_IGESBasic_Name;
  Handle_IGESBasic_Name_1: typeof Handle_IGESBasic_Name_1;
  Handle_IGESBasic_Name_2: typeof Handle_IGESBasic_Name_2;
  Handle_IGESBasic_Name_3: typeof Handle_IGESBasic_Name_3;
  Handle_IGESBasic_Name_4: typeof Handle_IGESBasic_Name_4;
  IGESBasic_Name: typeof IGESBasic_Name;
  IGESBasic_HArray1OfHArray1OfXY: typeof IGESBasic_HArray1OfHArray1OfXY;
  Handle_IGESBasic_HArray1OfHArray1OfXY: typeof Handle_IGESBasic_HArray1OfHArray1OfXY;
  Handle_IGESBasic_HArray1OfHArray1OfXY_1: typeof Handle_IGESBasic_HArray1OfHArray1OfXY_1;
  Handle_IGESBasic_HArray1OfHArray1OfXY_2: typeof Handle_IGESBasic_HArray1OfHArray1OfXY_2;
  Handle_IGESBasic_HArray1OfHArray1OfXY_3: typeof Handle_IGESBasic_HArray1OfHArray1OfXY_3;
  Handle_IGESBasic_HArray1OfHArray1OfXY_4: typeof Handle_IGESBasic_HArray1OfHArray1OfXY_4;
  Handle_IGESBasic_ExternalRefFile: typeof Handle_IGESBasic_ExternalRefFile;
  Handle_IGESBasic_ExternalRefFile_1: typeof Handle_IGESBasic_ExternalRefFile_1;
  Handle_IGESBasic_ExternalRefFile_2: typeof Handle_IGESBasic_ExternalRefFile_2;
  Handle_IGESBasic_ExternalRefFile_3: typeof Handle_IGESBasic_ExternalRefFile_3;
  Handle_IGESBasic_ExternalRefFile_4: typeof Handle_IGESBasic_ExternalRefFile_4;
  IGESBasic_ExternalRefFile: typeof IGESBasic_ExternalRefFile;
  IGESBasic_ToolSingularSubfigure: typeof IGESBasic_ToolSingularSubfigure;
  IGESBasic_ToolAssocGroupType: typeof IGESBasic_ToolAssocGroupType;
  IGESBasic_ToolHierarchy: typeof IGESBasic_ToolHierarchy;
  IGESBasic: typeof IGESBasic;
  IGESBasic_Protocol: typeof IGESBasic_Protocol;
  Handle_IGESBasic_Protocol: typeof Handle_IGESBasic_Protocol;
  Handle_IGESBasic_Protocol_1: typeof Handle_IGESBasic_Protocol_1;
  Handle_IGESBasic_Protocol_2: typeof Handle_IGESBasic_Protocol_2;
  Handle_IGESBasic_Protocol_3: typeof Handle_IGESBasic_Protocol_3;
  Handle_IGESBasic_Protocol_4: typeof Handle_IGESBasic_Protocol_4;
  IGESBasic_ToolSubfigureDef: typeof IGESBasic_ToolSubfigureDef;
  IGESBasic_OrderedGroupWithoutBackP: typeof IGESBasic_OrderedGroupWithoutBackP;
  Handle_IGESBasic_OrderedGroupWithoutBackP: typeof Handle_IGESBasic_OrderedGroupWithoutBackP;
  Handle_IGESBasic_OrderedGroupWithoutBackP_1: typeof Handle_IGESBasic_OrderedGroupWithoutBackP_1;
  Handle_IGESBasic_OrderedGroupWithoutBackP_2: typeof Handle_IGESBasic_OrderedGroupWithoutBackP_2;
  Handle_IGESBasic_OrderedGroupWithoutBackP_3: typeof Handle_IGESBasic_OrderedGroupWithoutBackP_3;
  Handle_IGESBasic_OrderedGroupWithoutBackP_4: typeof Handle_IGESBasic_OrderedGroupWithoutBackP_4;
  Handle_StepBasic_PlaneAngleUnit: typeof Handle_StepBasic_PlaneAngleUnit;
  Handle_StepBasic_PlaneAngleUnit_1: typeof Handle_StepBasic_PlaneAngleUnit_1;
  Handle_StepBasic_PlaneAngleUnit_2: typeof Handle_StepBasic_PlaneAngleUnit_2;
  Handle_StepBasic_PlaneAngleUnit_3: typeof Handle_StepBasic_PlaneAngleUnit_3;
  Handle_StepBasic_PlaneAngleUnit_4: typeof Handle_StepBasic_PlaneAngleUnit_4;
  StepBasic_PlaneAngleUnit: typeof StepBasic_PlaneAngleUnit;
  StepBasic_Source: StepBasic_Source;
  Handle_StepBasic_ContractType: typeof Handle_StepBasic_ContractType;
  Handle_StepBasic_ContractType_1: typeof Handle_StepBasic_ContractType_1;
  Handle_StepBasic_ContractType_2: typeof Handle_StepBasic_ContractType_2;
  Handle_StepBasic_ContractType_3: typeof Handle_StepBasic_ContractType_3;
  Handle_StepBasic_ContractType_4: typeof Handle_StepBasic_ContractType_4;
  StepBasic_ContractType: typeof StepBasic_ContractType;
  Handle_StepBasic_ExternallyDefinedItem: typeof Handle_StepBasic_ExternallyDefinedItem;
  Handle_StepBasic_ExternallyDefinedItem_1: typeof Handle_StepBasic_ExternallyDefinedItem_1;
  Handle_StepBasic_ExternallyDefinedItem_2: typeof Handle_StepBasic_ExternallyDefinedItem_2;
  Handle_StepBasic_ExternallyDefinedItem_3: typeof Handle_StepBasic_ExternallyDefinedItem_3;
  Handle_StepBasic_ExternallyDefinedItem_4: typeof Handle_StepBasic_ExternallyDefinedItem_4;
  StepBasic_ExternallyDefinedItem: typeof StepBasic_ExternallyDefinedItem;
  StepBasic_ExternalIdentificationAssignment: typeof StepBasic_ExternalIdentificationAssignment;
  Handle_StepBasic_ExternalIdentificationAssignment: typeof Handle_StepBasic_ExternalIdentificationAssignment;
  Handle_StepBasic_ExternalIdentificationAssignment_1: typeof Handle_StepBasic_ExternalIdentificationAssignment_1;
  Handle_StepBasic_ExternalIdentificationAssignment_2: typeof Handle_StepBasic_ExternalIdentificationAssignment_2;
  Handle_StepBasic_ExternalIdentificationAssignment_3: typeof Handle_StepBasic_ExternalIdentificationAssignment_3;
  Handle_StepBasic_ExternalIdentificationAssignment_4: typeof Handle_StepBasic_ExternalIdentificationAssignment_4;
  StepBasic_SecurityClassificationAssignment: typeof StepBasic_SecurityClassificationAssignment;
  Handle_StepBasic_SecurityClassificationAssignment: typeof Handle_StepBasic_SecurityClassificationAssignment;
  Handle_StepBasic_SecurityClassificationAssignment_1: typeof Handle_StepBasic_SecurityClassificationAssignment_1;
  Handle_StepBasic_SecurityClassificationAssignment_2: typeof Handle_StepBasic_SecurityClassificationAssignment_2;
  Handle_StepBasic_SecurityClassificationAssignment_3: typeof Handle_StepBasic_SecurityClassificationAssignment_3;
  Handle_StepBasic_SecurityClassificationAssignment_4: typeof Handle_StepBasic_SecurityClassificationAssignment_4;
  Handle_StepBasic_OrganizationalAddress: typeof Handle_StepBasic_OrganizationalAddress;
  Handle_StepBasic_OrganizationalAddress_1: typeof Handle_StepBasic_OrganizationalAddress_1;
  Handle_StepBasic_OrganizationalAddress_2: typeof Handle_StepBasic_OrganizationalAddress_2;
  Handle_StepBasic_OrganizationalAddress_3: typeof Handle_StepBasic_OrganizationalAddress_3;
  Handle_StepBasic_OrganizationalAddress_4: typeof Handle_StepBasic_OrganizationalAddress_4;
  StepBasic_OrganizationalAddress: typeof StepBasic_OrganizationalAddress;
  StepBasic_ProductDefinition: typeof StepBasic_ProductDefinition;
  Handle_StepBasic_ProductDefinition: typeof Handle_StepBasic_ProductDefinition;
  Handle_StepBasic_ProductDefinition_1: typeof Handle_StepBasic_ProductDefinition_1;
  Handle_StepBasic_ProductDefinition_2: typeof Handle_StepBasic_ProductDefinition_2;
  Handle_StepBasic_ProductDefinition_3: typeof Handle_StepBasic_ProductDefinition_3;
  Handle_StepBasic_ProductDefinition_4: typeof Handle_StepBasic_ProductDefinition_4;
  Handle_StepBasic_PersonAndOrganization: typeof Handle_StepBasic_PersonAndOrganization;
  Handle_StepBasic_PersonAndOrganization_1: typeof Handle_StepBasic_PersonAndOrganization_1;
  Handle_StepBasic_PersonAndOrganization_2: typeof Handle_StepBasic_PersonAndOrganization_2;
  Handle_StepBasic_PersonAndOrganization_3: typeof Handle_StepBasic_PersonAndOrganization_3;
  Handle_StepBasic_PersonAndOrganization_4: typeof Handle_StepBasic_PersonAndOrganization_4;
  StepBasic_PersonAndOrganization: typeof StepBasic_PersonAndOrganization;
  Handle_StepBasic_HArray1OfPerson: typeof Handle_StepBasic_HArray1OfPerson;
  Handle_StepBasic_HArray1OfPerson_1: typeof Handle_StepBasic_HArray1OfPerson_1;
  Handle_StepBasic_HArray1OfPerson_2: typeof Handle_StepBasic_HArray1OfPerson_2;
  Handle_StepBasic_HArray1OfPerson_3: typeof Handle_StepBasic_HArray1OfPerson_3;
  Handle_StepBasic_HArray1OfPerson_4: typeof Handle_StepBasic_HArray1OfPerson_4;
  StepBasic_SecurityClassification: typeof StepBasic_SecurityClassification;
  Handle_StepBasic_SecurityClassification: typeof Handle_StepBasic_SecurityClassification;
  Handle_StepBasic_SecurityClassification_1: typeof Handle_StepBasic_SecurityClassification_1;
  Handle_StepBasic_SecurityClassification_2: typeof Handle_StepBasic_SecurityClassification_2;
  Handle_StepBasic_SecurityClassification_3: typeof Handle_StepBasic_SecurityClassification_3;
  Handle_StepBasic_SecurityClassification_4: typeof Handle_StepBasic_SecurityClassification_4;
  Handle_StepBasic_MechanicalContext: typeof Handle_StepBasic_MechanicalContext;
  Handle_StepBasic_MechanicalContext_1: typeof Handle_StepBasic_MechanicalContext_1;
  Handle_StepBasic_MechanicalContext_2: typeof Handle_StepBasic_MechanicalContext_2;
  Handle_StepBasic_MechanicalContext_3: typeof Handle_StepBasic_MechanicalContext_3;
  Handle_StepBasic_MechanicalContext_4: typeof Handle_StepBasic_MechanicalContext_4;
  StepBasic_MechanicalContext: typeof StepBasic_MechanicalContext;
  StepBasic_PlaneAngleMeasureWithUnit: typeof StepBasic_PlaneAngleMeasureWithUnit;
  Handle_StepBasic_PlaneAngleMeasureWithUnit: typeof Handle_StepBasic_PlaneAngleMeasureWithUnit;
  Handle_StepBasic_PlaneAngleMeasureWithUnit_1: typeof Handle_StepBasic_PlaneAngleMeasureWithUnit_1;
  Handle_StepBasic_PlaneAngleMeasureWithUnit_2: typeof Handle_StepBasic_PlaneAngleMeasureWithUnit_2;
  Handle_StepBasic_PlaneAngleMeasureWithUnit_3: typeof Handle_StepBasic_PlaneAngleMeasureWithUnit_3;
  Handle_StepBasic_PlaneAngleMeasureWithUnit_4: typeof Handle_StepBasic_PlaneAngleMeasureWithUnit_4;
  StepBasic_SiPrefix: StepBasic_SiPrefix;
  StepBasic_ProductDefinitionFormationRelationship: typeof StepBasic_ProductDefinitionFormationRelationship;
  Handle_StepBasic_ProductDefinitionFormationRelationship: typeof Handle_StepBasic_ProductDefinitionFormationRelationship;
  Handle_StepBasic_ProductDefinitionFormationRelationship_1: typeof Handle_StepBasic_ProductDefinitionFormationRelationship_1;
  Handle_StepBasic_ProductDefinitionFormationRelationship_2: typeof Handle_StepBasic_ProductDefinitionFormationRelationship_2;
  Handle_StepBasic_ProductDefinitionFormationRelationship_3: typeof Handle_StepBasic_ProductDefinitionFormationRelationship_3;
  Handle_StepBasic_ProductDefinitionFormationRelationship_4: typeof Handle_StepBasic_ProductDefinitionFormationRelationship_4;
  StepBasic_ProductCategory: typeof StepBasic_ProductCategory;
  Handle_StepBasic_ProductCategory: typeof Handle_StepBasic_ProductCategory;
  Handle_StepBasic_ProductCategory_1: typeof Handle_StepBasic_ProductCategory_1;
  Handle_StepBasic_ProductCategory_2: typeof Handle_StepBasic_ProductCategory_2;
  Handle_StepBasic_ProductCategory_3: typeof Handle_StepBasic_ProductCategory_3;
  Handle_StepBasic_ProductCategory_4: typeof Handle_StepBasic_ProductCategory_4;
  Handle_StepBasic_MassMeasureWithUnit: typeof Handle_StepBasic_MassMeasureWithUnit;
  Handle_StepBasic_MassMeasureWithUnit_1: typeof Handle_StepBasic_MassMeasureWithUnit_1;
  Handle_StepBasic_MassMeasureWithUnit_2: typeof Handle_StepBasic_MassMeasureWithUnit_2;
  Handle_StepBasic_MassMeasureWithUnit_3: typeof Handle_StepBasic_MassMeasureWithUnit_3;
  Handle_StepBasic_MassMeasureWithUnit_4: typeof Handle_StepBasic_MassMeasureWithUnit_4;
  StepBasic_MassMeasureWithUnit: typeof StepBasic_MassMeasureWithUnit;
  Handle_StepBasic_ConversionBasedUnitAndTimeUnit: typeof Handle_StepBasic_ConversionBasedUnitAndTimeUnit;
  Handle_StepBasic_ConversionBasedUnitAndTimeUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndTimeUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndTimeUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndTimeUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndTimeUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndTimeUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndTimeUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndTimeUnit_4;
  StepBasic_ConversionBasedUnitAndTimeUnit: typeof StepBasic_ConversionBasedUnitAndTimeUnit;
  Handle_StepBasic_CalendarDate: typeof Handle_StepBasic_CalendarDate;
  Handle_StepBasic_CalendarDate_1: typeof Handle_StepBasic_CalendarDate_1;
  Handle_StepBasic_CalendarDate_2: typeof Handle_StepBasic_CalendarDate_2;
  Handle_StepBasic_CalendarDate_3: typeof Handle_StepBasic_CalendarDate_3;
  Handle_StepBasic_CalendarDate_4: typeof Handle_StepBasic_CalendarDate_4;
  StepBasic_CalendarDate: typeof StepBasic_CalendarDate;
  StepBasic_NameAssignment: typeof StepBasic_NameAssignment;
  Handle_StepBasic_NameAssignment: typeof Handle_StepBasic_NameAssignment;
  Handle_StepBasic_NameAssignment_1: typeof Handle_StepBasic_NameAssignment_1;
  Handle_StepBasic_NameAssignment_2: typeof Handle_StepBasic_NameAssignment_2;
  Handle_StepBasic_NameAssignment_3: typeof Handle_StepBasic_NameAssignment_3;
  Handle_StepBasic_NameAssignment_4: typeof Handle_StepBasic_NameAssignment_4;
  Handle_StepBasic_TimeMeasureWithUnit: typeof Handle_StepBasic_TimeMeasureWithUnit;
  Handle_StepBasic_TimeMeasureWithUnit_1: typeof Handle_StepBasic_TimeMeasureWithUnit_1;
  Handle_StepBasic_TimeMeasureWithUnit_2: typeof Handle_StepBasic_TimeMeasureWithUnit_2;
  Handle_StepBasic_TimeMeasureWithUnit_3: typeof Handle_StepBasic_TimeMeasureWithUnit_3;
  Handle_StepBasic_TimeMeasureWithUnit_4: typeof Handle_StepBasic_TimeMeasureWithUnit_4;
  StepBasic_TimeMeasureWithUnit: typeof StepBasic_TimeMeasureWithUnit;
  Handle_StepBasic_ProductContext: typeof Handle_StepBasic_ProductContext;
  Handle_StepBasic_ProductContext_1: typeof Handle_StepBasic_ProductContext_1;
  Handle_StepBasic_ProductContext_2: typeof Handle_StepBasic_ProductContext_2;
  Handle_StepBasic_ProductContext_3: typeof Handle_StepBasic_ProductContext_3;
  Handle_StepBasic_ProductContext_4: typeof Handle_StepBasic_ProductContext_4;
  StepBasic_ProductContext: typeof StepBasic_ProductContext;
  Handle_StepBasic_AreaUnit: typeof Handle_StepBasic_AreaUnit;
  Handle_StepBasic_AreaUnit_1: typeof Handle_StepBasic_AreaUnit_1;
  Handle_StepBasic_AreaUnit_2: typeof Handle_StepBasic_AreaUnit_2;
  Handle_StepBasic_AreaUnit_3: typeof Handle_StepBasic_AreaUnit_3;
  Handle_StepBasic_AreaUnit_4: typeof Handle_StepBasic_AreaUnit_4;
  StepBasic_AreaUnit: typeof StepBasic_AreaUnit;
  Handle_StepBasic_ProductDefinitionFormation: typeof Handle_StepBasic_ProductDefinitionFormation;
  Handle_StepBasic_ProductDefinitionFormation_1: typeof Handle_StepBasic_ProductDefinitionFormation_1;
  Handle_StepBasic_ProductDefinitionFormation_2: typeof Handle_StepBasic_ProductDefinitionFormation_2;
  Handle_StepBasic_ProductDefinitionFormation_3: typeof Handle_StepBasic_ProductDefinitionFormation_3;
  Handle_StepBasic_ProductDefinitionFormation_4: typeof Handle_StepBasic_ProductDefinitionFormation_4;
  StepBasic_ProductDefinitionFormation: typeof StepBasic_ProductDefinitionFormation;
  Handle_StepBasic_VersionedActionRequest: typeof Handle_StepBasic_VersionedActionRequest;
  Handle_StepBasic_VersionedActionRequest_1: typeof Handle_StepBasic_VersionedActionRequest_1;
  Handle_StepBasic_VersionedActionRequest_2: typeof Handle_StepBasic_VersionedActionRequest_2;
  Handle_StepBasic_VersionedActionRequest_3: typeof Handle_StepBasic_VersionedActionRequest_3;
  Handle_StepBasic_VersionedActionRequest_4: typeof Handle_StepBasic_VersionedActionRequest_4;
  StepBasic_VersionedActionRequest: typeof StepBasic_VersionedActionRequest;
  Handle_StepBasic_GroupAssignment: typeof Handle_StepBasic_GroupAssignment;
  Handle_StepBasic_GroupAssignment_1: typeof Handle_StepBasic_GroupAssignment_1;
  Handle_StepBasic_GroupAssignment_2: typeof Handle_StepBasic_GroupAssignment_2;
  Handle_StepBasic_GroupAssignment_3: typeof Handle_StepBasic_GroupAssignment_3;
  Handle_StepBasic_GroupAssignment_4: typeof Handle_StepBasic_GroupAssignment_4;
  StepBasic_GroupAssignment: typeof StepBasic_GroupAssignment;
  StepBasic_Approval: typeof StepBasic_Approval;
  Handle_StepBasic_Approval: typeof Handle_StepBasic_Approval;
  Handle_StepBasic_Approval_1: typeof Handle_StepBasic_Approval_1;
  Handle_StepBasic_Approval_2: typeof Handle_StepBasic_Approval_2;
  Handle_StepBasic_Approval_3: typeof Handle_StepBasic_Approval_3;
  Handle_StepBasic_Approval_4: typeof Handle_StepBasic_Approval_4;
  Handle_StepBasic_SiUnitAndLengthUnit: typeof Handle_StepBasic_SiUnitAndLengthUnit;
  Handle_StepBasic_SiUnitAndLengthUnit_1: typeof Handle_StepBasic_SiUnitAndLengthUnit_1;
  Handle_StepBasic_SiUnitAndLengthUnit_2: typeof Handle_StepBasic_SiUnitAndLengthUnit_2;
  Handle_StepBasic_SiUnitAndLengthUnit_3: typeof Handle_StepBasic_SiUnitAndLengthUnit_3;
  Handle_StepBasic_SiUnitAndLengthUnit_4: typeof Handle_StepBasic_SiUnitAndLengthUnit_4;
  StepBasic_SiUnitAndLengthUnit: typeof StepBasic_SiUnitAndLengthUnit;
  Handle_StepBasic_CoordinatedUniversalTimeOffset: typeof Handle_StepBasic_CoordinatedUniversalTimeOffset;
  Handle_StepBasic_CoordinatedUniversalTimeOffset_1: typeof Handle_StepBasic_CoordinatedUniversalTimeOffset_1;
  Handle_StepBasic_CoordinatedUniversalTimeOffset_2: typeof Handle_StepBasic_CoordinatedUniversalTimeOffset_2;
  Handle_StepBasic_CoordinatedUniversalTimeOffset_3: typeof Handle_StepBasic_CoordinatedUniversalTimeOffset_3;
  Handle_StepBasic_CoordinatedUniversalTimeOffset_4: typeof Handle_StepBasic_CoordinatedUniversalTimeOffset_4;
  StepBasic_CoordinatedUniversalTimeOffset: typeof StepBasic_CoordinatedUniversalTimeOffset;
  StepBasic_ExternalSource: typeof StepBasic_ExternalSource;
  Handle_StepBasic_ExternalSource: typeof Handle_StepBasic_ExternalSource;
  Handle_StepBasic_ExternalSource_1: typeof Handle_StepBasic_ExternalSource_1;
  Handle_StepBasic_ExternalSource_2: typeof Handle_StepBasic_ExternalSource_2;
  Handle_StepBasic_ExternalSource_3: typeof Handle_StepBasic_ExternalSource_3;
  Handle_StepBasic_ExternalSource_4: typeof Handle_StepBasic_ExternalSource_4;
  StepBasic_DerivedUnit: typeof StepBasic_DerivedUnit;
  Handle_StepBasic_DerivedUnit: typeof Handle_StepBasic_DerivedUnit;
  Handle_StepBasic_DerivedUnit_1: typeof Handle_StepBasic_DerivedUnit_1;
  Handle_StepBasic_DerivedUnit_2: typeof Handle_StepBasic_DerivedUnit_2;
  Handle_StepBasic_DerivedUnit_3: typeof Handle_StepBasic_DerivedUnit_3;
  Handle_StepBasic_DerivedUnit_4: typeof Handle_StepBasic_DerivedUnit_4;
  StepBasic_AheadOrBehind: StepBasic_AheadOrBehind;
  StepBasic_DocumentFile: typeof StepBasic_DocumentFile;
  Handle_StepBasic_DocumentFile: typeof Handle_StepBasic_DocumentFile;
  Handle_StepBasic_DocumentFile_1: typeof Handle_StepBasic_DocumentFile_1;
  Handle_StepBasic_DocumentFile_2: typeof Handle_StepBasic_DocumentFile_2;
  Handle_StepBasic_DocumentFile_3: typeof Handle_StepBasic_DocumentFile_3;
  Handle_StepBasic_DocumentFile_4: typeof Handle_StepBasic_DocumentFile_4;
  Handle_StepBasic_ApprovalStatus: typeof Handle_StepBasic_ApprovalStatus;
  Handle_StepBasic_ApprovalStatus_1: typeof Handle_StepBasic_ApprovalStatus_1;
  Handle_StepBasic_ApprovalStatus_2: typeof Handle_StepBasic_ApprovalStatus_2;
  Handle_StepBasic_ApprovalStatus_3: typeof Handle_StepBasic_ApprovalStatus_3;
  Handle_StepBasic_ApprovalStatus_4: typeof Handle_StepBasic_ApprovalStatus_4;
  StepBasic_ApprovalStatus: typeof StepBasic_ApprovalStatus;
  StepBasic_DocumentUsageConstraint: typeof StepBasic_DocumentUsageConstraint;
  Handle_StepBasic_DocumentUsageConstraint: typeof Handle_StepBasic_DocumentUsageConstraint;
  Handle_StepBasic_DocumentUsageConstraint_1: typeof Handle_StepBasic_DocumentUsageConstraint_1;
  Handle_StepBasic_DocumentUsageConstraint_2: typeof Handle_StepBasic_DocumentUsageConstraint_2;
  Handle_StepBasic_DocumentUsageConstraint_3: typeof Handle_StepBasic_DocumentUsageConstraint_3;
  Handle_StepBasic_DocumentUsageConstraint_4: typeof Handle_StepBasic_DocumentUsageConstraint_4;
  Handle_StepBasic_IdentificationAssignment: typeof Handle_StepBasic_IdentificationAssignment;
  Handle_StepBasic_IdentificationAssignment_1: typeof Handle_StepBasic_IdentificationAssignment_1;
  Handle_StepBasic_IdentificationAssignment_2: typeof Handle_StepBasic_IdentificationAssignment_2;
  Handle_StepBasic_IdentificationAssignment_3: typeof Handle_StepBasic_IdentificationAssignment_3;
  Handle_StepBasic_IdentificationAssignment_4: typeof Handle_StepBasic_IdentificationAssignment_4;
  StepBasic_IdentificationAssignment: typeof StepBasic_IdentificationAssignment;
  Handle_StepBasic_ConversionBasedUnitAndRatioUnit: typeof Handle_StepBasic_ConversionBasedUnitAndRatioUnit;
  Handle_StepBasic_ConversionBasedUnitAndRatioUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndRatioUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndRatioUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndRatioUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndRatioUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndRatioUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndRatioUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndRatioUnit_4;
  StepBasic_ConversionBasedUnitAndRatioUnit: typeof StepBasic_ConversionBasedUnitAndRatioUnit;
  Handle_StepBasic_ProductDefinitionRelationship: typeof Handle_StepBasic_ProductDefinitionRelationship;
  Handle_StepBasic_ProductDefinitionRelationship_1: typeof Handle_StepBasic_ProductDefinitionRelationship_1;
  Handle_StepBasic_ProductDefinitionRelationship_2: typeof Handle_StepBasic_ProductDefinitionRelationship_2;
  Handle_StepBasic_ProductDefinitionRelationship_3: typeof Handle_StepBasic_ProductDefinitionRelationship_3;
  Handle_StepBasic_ProductDefinitionRelationship_4: typeof Handle_StepBasic_ProductDefinitionRelationship_4;
  StepBasic_ProductDefinitionRelationship: typeof StepBasic_ProductDefinitionRelationship;
  Handle_StepBasic_HArray1OfProduct: typeof Handle_StepBasic_HArray1OfProduct;
  Handle_StepBasic_HArray1OfProduct_1: typeof Handle_StepBasic_HArray1OfProduct_1;
  Handle_StepBasic_HArray1OfProduct_2: typeof Handle_StepBasic_HArray1OfProduct_2;
  Handle_StepBasic_HArray1OfProduct_3: typeof Handle_StepBasic_HArray1OfProduct_3;
  Handle_StepBasic_HArray1OfProduct_4: typeof Handle_StepBasic_HArray1OfProduct_4;
  Handle_StepBasic_Certification: typeof Handle_StepBasic_Certification;
  Handle_StepBasic_Certification_1: typeof Handle_StepBasic_Certification_1;
  Handle_StepBasic_Certification_2: typeof Handle_StepBasic_Certification_2;
  Handle_StepBasic_Certification_3: typeof Handle_StepBasic_Certification_3;
  Handle_StepBasic_Certification_4: typeof Handle_StepBasic_Certification_4;
  StepBasic_Certification: typeof StepBasic_Certification;
  StepBasic_DimensionalExponents: typeof StepBasic_DimensionalExponents;
  Handle_StepBasic_DimensionalExponents: typeof Handle_StepBasic_DimensionalExponents;
  Handle_StepBasic_DimensionalExponents_1: typeof Handle_StepBasic_DimensionalExponents_1;
  Handle_StepBasic_DimensionalExponents_2: typeof Handle_StepBasic_DimensionalExponents_2;
  Handle_StepBasic_DimensionalExponents_3: typeof Handle_StepBasic_DimensionalExponents_3;
  Handle_StepBasic_DimensionalExponents_4: typeof Handle_StepBasic_DimensionalExponents_4;
  StepBasic_Document: typeof StepBasic_Document;
  Handle_StepBasic_Document: typeof Handle_StepBasic_Document;
  Handle_StepBasic_Document_1: typeof Handle_StepBasic_Document_1;
  Handle_StepBasic_Document_2: typeof Handle_StepBasic_Document_2;
  Handle_StepBasic_Document_3: typeof Handle_StepBasic_Document_3;
  Handle_StepBasic_Document_4: typeof Handle_StepBasic_Document_4;
  StepBasic_OrganizationAssignment: typeof StepBasic_OrganizationAssignment;
  Handle_StepBasic_OrganizationAssignment: typeof Handle_StepBasic_OrganizationAssignment;
  Handle_StepBasic_OrganizationAssignment_1: typeof Handle_StepBasic_OrganizationAssignment_1;
  Handle_StepBasic_OrganizationAssignment_2: typeof Handle_StepBasic_OrganizationAssignment_2;
  Handle_StepBasic_OrganizationAssignment_3: typeof Handle_StepBasic_OrganizationAssignment_3;
  Handle_StepBasic_OrganizationAssignment_4: typeof Handle_StepBasic_OrganizationAssignment_4;
  Handle_StepBasic_SizeMember: typeof Handle_StepBasic_SizeMember;
  Handle_StepBasic_SizeMember_1: typeof Handle_StepBasic_SizeMember_1;
  Handle_StepBasic_SizeMember_2: typeof Handle_StepBasic_SizeMember_2;
  Handle_StepBasic_SizeMember_3: typeof Handle_StepBasic_SizeMember_3;
  Handle_StepBasic_SizeMember_4: typeof Handle_StepBasic_SizeMember_4;
  StepBasic_SizeMember: typeof StepBasic_SizeMember;
  Handle_StepBasic_PersonAndOrganizationAssignment: typeof Handle_StepBasic_PersonAndOrganizationAssignment;
  Handle_StepBasic_PersonAndOrganizationAssignment_1: typeof Handle_StepBasic_PersonAndOrganizationAssignment_1;
  Handle_StepBasic_PersonAndOrganizationAssignment_2: typeof Handle_StepBasic_PersonAndOrganizationAssignment_2;
  Handle_StepBasic_PersonAndOrganizationAssignment_3: typeof Handle_StepBasic_PersonAndOrganizationAssignment_3;
  Handle_StepBasic_PersonAndOrganizationAssignment_4: typeof Handle_StepBasic_PersonAndOrganizationAssignment_4;
  StepBasic_PersonAndOrganizationAssignment: typeof StepBasic_PersonAndOrganizationAssignment;
  Handle_StepBasic_HArray1OfApproval: typeof Handle_StepBasic_HArray1OfApproval;
  Handle_StepBasic_HArray1OfApproval_1: typeof Handle_StepBasic_HArray1OfApproval_1;
  Handle_StepBasic_HArray1OfApproval_2: typeof Handle_StepBasic_HArray1OfApproval_2;
  Handle_StepBasic_HArray1OfApproval_3: typeof Handle_StepBasic_HArray1OfApproval_3;
  Handle_StepBasic_HArray1OfApproval_4: typeof Handle_StepBasic_HArray1OfApproval_4;
  StepBasic_ApplicationContextElement: typeof StepBasic_ApplicationContextElement;
  Handle_StepBasic_ApplicationContextElement: typeof Handle_StepBasic_ApplicationContextElement;
  Handle_StepBasic_ApplicationContextElement_1: typeof Handle_StepBasic_ApplicationContextElement_1;
  Handle_StepBasic_ApplicationContextElement_2: typeof Handle_StepBasic_ApplicationContextElement_2;
  Handle_StepBasic_ApplicationContextElement_3: typeof Handle_StepBasic_ApplicationContextElement_3;
  Handle_StepBasic_ApplicationContextElement_4: typeof Handle_StepBasic_ApplicationContextElement_4;
  Handle_StepBasic_HArray1OfDerivedUnitElement: typeof Handle_StepBasic_HArray1OfDerivedUnitElement;
  Handle_StepBasic_HArray1OfDerivedUnitElement_1: typeof Handle_StepBasic_HArray1OfDerivedUnitElement_1;
  Handle_StepBasic_HArray1OfDerivedUnitElement_2: typeof Handle_StepBasic_HArray1OfDerivedUnitElement_2;
  Handle_StepBasic_HArray1OfDerivedUnitElement_3: typeof Handle_StepBasic_HArray1OfDerivedUnitElement_3;
  Handle_StepBasic_HArray1OfDerivedUnitElement_4: typeof Handle_StepBasic_HArray1OfDerivedUnitElement_4;
  Handle_StepBasic_CertificationAssignment: typeof Handle_StepBasic_CertificationAssignment;
  Handle_StepBasic_CertificationAssignment_1: typeof Handle_StepBasic_CertificationAssignment_1;
  Handle_StepBasic_CertificationAssignment_2: typeof Handle_StepBasic_CertificationAssignment_2;
  Handle_StepBasic_CertificationAssignment_3: typeof Handle_StepBasic_CertificationAssignment_3;
  Handle_StepBasic_CertificationAssignment_4: typeof Handle_StepBasic_CertificationAssignment_4;
  StepBasic_CertificationAssignment: typeof StepBasic_CertificationAssignment;
  Handle_StepBasic_HArray1OfProductContext: typeof Handle_StepBasic_HArray1OfProductContext;
  Handle_StepBasic_HArray1OfProductContext_1: typeof Handle_StepBasic_HArray1OfProductContext_1;
  Handle_StepBasic_HArray1OfProductContext_2: typeof Handle_StepBasic_HArray1OfProductContext_2;
  Handle_StepBasic_HArray1OfProductContext_3: typeof Handle_StepBasic_HArray1OfProductContext_3;
  Handle_StepBasic_HArray1OfProductContext_4: typeof Handle_StepBasic_HArray1OfProductContext_4;
  Handle_StepBasic_CharacterizedObject: typeof Handle_StepBasic_CharacterizedObject;
  Handle_StepBasic_CharacterizedObject_1: typeof Handle_StepBasic_CharacterizedObject_1;
  Handle_StepBasic_CharacterizedObject_2: typeof Handle_StepBasic_CharacterizedObject_2;
  Handle_StepBasic_CharacterizedObject_3: typeof Handle_StepBasic_CharacterizedObject_3;
  Handle_StepBasic_CharacterizedObject_4: typeof Handle_StepBasic_CharacterizedObject_4;
  StepBasic_CharacterizedObject: typeof StepBasic_CharacterizedObject;
  Handle_StepBasic_GeneralProperty: typeof Handle_StepBasic_GeneralProperty;
  Handle_StepBasic_GeneralProperty_1: typeof Handle_StepBasic_GeneralProperty_1;
  Handle_StepBasic_GeneralProperty_2: typeof Handle_StepBasic_GeneralProperty_2;
  Handle_StepBasic_GeneralProperty_3: typeof Handle_StepBasic_GeneralProperty_3;
  Handle_StepBasic_GeneralProperty_4: typeof Handle_StepBasic_GeneralProperty_4;
  StepBasic_GeneralProperty: typeof StepBasic_GeneralProperty;
  StepBasic_Organization: typeof StepBasic_Organization;
  Handle_StepBasic_Organization: typeof Handle_StepBasic_Organization;
  Handle_StepBasic_Organization_1: typeof Handle_StepBasic_Organization_1;
  Handle_StepBasic_Organization_2: typeof Handle_StepBasic_Organization_2;
  Handle_StepBasic_Organization_3: typeof Handle_StepBasic_Organization_3;
  Handle_StepBasic_Organization_4: typeof Handle_StepBasic_Organization_4;
  StepBasic_EffectivityAssignment: typeof StepBasic_EffectivityAssignment;
  Handle_StepBasic_EffectivityAssignment: typeof Handle_StepBasic_EffectivityAssignment;
  Handle_StepBasic_EffectivityAssignment_1: typeof Handle_StepBasic_EffectivityAssignment_1;
  Handle_StepBasic_EffectivityAssignment_2: typeof Handle_StepBasic_EffectivityAssignment_2;
  Handle_StepBasic_EffectivityAssignment_3: typeof Handle_StepBasic_EffectivityAssignment_3;
  Handle_StepBasic_EffectivityAssignment_4: typeof Handle_StepBasic_EffectivityAssignment_4;
  StepBasic_SiUnitAndRatioUnit: typeof StepBasic_SiUnitAndRatioUnit;
  Handle_StepBasic_SiUnitAndRatioUnit: typeof Handle_StepBasic_SiUnitAndRatioUnit;
  Handle_StepBasic_SiUnitAndRatioUnit_1: typeof Handle_StepBasic_SiUnitAndRatioUnit_1;
  Handle_StepBasic_SiUnitAndRatioUnit_2: typeof Handle_StepBasic_SiUnitAndRatioUnit_2;
  Handle_StepBasic_SiUnitAndRatioUnit_3: typeof Handle_StepBasic_SiUnitAndRatioUnit_3;
  Handle_StepBasic_SiUnitAndRatioUnit_4: typeof Handle_StepBasic_SiUnitAndRatioUnit_4;
  StepBasic_PersonAndOrganizationRole: typeof StepBasic_PersonAndOrganizationRole;
  Handle_StepBasic_PersonAndOrganizationRole: typeof Handle_StepBasic_PersonAndOrganizationRole;
  Handle_StepBasic_PersonAndOrganizationRole_1: typeof Handle_StepBasic_PersonAndOrganizationRole_1;
  Handle_StepBasic_PersonAndOrganizationRole_2: typeof Handle_StepBasic_PersonAndOrganizationRole_2;
  Handle_StepBasic_PersonAndOrganizationRole_3: typeof Handle_StepBasic_PersonAndOrganizationRole_3;
  Handle_StepBasic_PersonAndOrganizationRole_4: typeof Handle_StepBasic_PersonAndOrganizationRole_4;
  Handle_StepBasic_RatioMeasureWithUnit: typeof Handle_StepBasic_RatioMeasureWithUnit;
  Handle_StepBasic_RatioMeasureWithUnit_1: typeof Handle_StepBasic_RatioMeasureWithUnit_1;
  Handle_StepBasic_RatioMeasureWithUnit_2: typeof Handle_StepBasic_RatioMeasureWithUnit_2;
  Handle_StepBasic_RatioMeasureWithUnit_3: typeof Handle_StepBasic_RatioMeasureWithUnit_3;
  Handle_StepBasic_RatioMeasureWithUnit_4: typeof Handle_StepBasic_RatioMeasureWithUnit_4;
  StepBasic_RatioMeasureWithUnit: typeof StepBasic_RatioMeasureWithUnit;
  StepBasic_ProductDefinitionReference: typeof StepBasic_ProductDefinitionReference;
  Handle_StepBasic_ProductDefinitionReference: typeof Handle_StepBasic_ProductDefinitionReference;
  Handle_StepBasic_ProductDefinitionReference_1: typeof Handle_StepBasic_ProductDefinitionReference_1;
  Handle_StepBasic_ProductDefinitionReference_2: typeof Handle_StepBasic_ProductDefinitionReference_2;
  Handle_StepBasic_ProductDefinitionReference_3: typeof Handle_StepBasic_ProductDefinitionReference_3;
  Handle_StepBasic_ProductDefinitionReference_4: typeof Handle_StepBasic_ProductDefinitionReference_4;
  Handle_StepBasic_ApprovalRole: typeof Handle_StepBasic_ApprovalRole;
  Handle_StepBasic_ApprovalRole_1: typeof Handle_StepBasic_ApprovalRole_1;
  Handle_StepBasic_ApprovalRole_2: typeof Handle_StepBasic_ApprovalRole_2;
  Handle_StepBasic_ApprovalRole_3: typeof Handle_StepBasic_ApprovalRole_3;
  Handle_StepBasic_ApprovalRole_4: typeof Handle_StepBasic_ApprovalRole_4;
  StepBasic_ApprovalRole: typeof StepBasic_ApprovalRole;
  Handle_StepBasic_DateAndTime: typeof Handle_StepBasic_DateAndTime;
  Handle_StepBasic_DateAndTime_1: typeof Handle_StepBasic_DateAndTime_1;
  Handle_StepBasic_DateAndTime_2: typeof Handle_StepBasic_DateAndTime_2;
  Handle_StepBasic_DateAndTime_3: typeof Handle_StepBasic_DateAndTime_3;
  Handle_StepBasic_DateAndTime_4: typeof Handle_StepBasic_DateAndTime_4;
  StepBasic_DateAndTime: typeof StepBasic_DateAndTime;
  Handle_StepBasic_DigitalDocument: typeof Handle_StepBasic_DigitalDocument;
  Handle_StepBasic_DigitalDocument_1: typeof Handle_StepBasic_DigitalDocument_1;
  Handle_StepBasic_DigitalDocument_2: typeof Handle_StepBasic_DigitalDocument_2;
  Handle_StepBasic_DigitalDocument_3: typeof Handle_StepBasic_DigitalDocument_3;
  Handle_StepBasic_DigitalDocument_4: typeof Handle_StepBasic_DigitalDocument_4;
  StepBasic_DigitalDocument: typeof StepBasic_DigitalDocument;
  StepBasic_ThermodynamicTemperatureUnit: typeof StepBasic_ThermodynamicTemperatureUnit;
  Handle_StepBasic_ThermodynamicTemperatureUnit: typeof Handle_StepBasic_ThermodynamicTemperatureUnit;
  Handle_StepBasic_ThermodynamicTemperatureUnit_1: typeof Handle_StepBasic_ThermodynamicTemperatureUnit_1;
  Handle_StepBasic_ThermodynamicTemperatureUnit_2: typeof Handle_StepBasic_ThermodynamicTemperatureUnit_2;
  Handle_StepBasic_ThermodynamicTemperatureUnit_3: typeof Handle_StepBasic_ThermodynamicTemperatureUnit_3;
  Handle_StepBasic_ThermodynamicTemperatureUnit_4: typeof Handle_StepBasic_ThermodynamicTemperatureUnit_4;
  Handle_StepBasic_ActionAssignment: typeof Handle_StepBasic_ActionAssignment;
  Handle_StepBasic_ActionAssignment_1: typeof Handle_StepBasic_ActionAssignment_1;
  Handle_StepBasic_ActionAssignment_2: typeof Handle_StepBasic_ActionAssignment_2;
  Handle_StepBasic_ActionAssignment_3: typeof Handle_StepBasic_ActionAssignment_3;
  Handle_StepBasic_ActionAssignment_4: typeof Handle_StepBasic_ActionAssignment_4;
  StepBasic_ActionAssignment: typeof StepBasic_ActionAssignment;
  Handle_StepBasic_HArray1OfDocument: typeof Handle_StepBasic_HArray1OfDocument;
  Handle_StepBasic_HArray1OfDocument_1: typeof Handle_StepBasic_HArray1OfDocument_1;
  Handle_StepBasic_HArray1OfDocument_2: typeof Handle_StepBasic_HArray1OfDocument_2;
  Handle_StepBasic_HArray1OfDocument_3: typeof Handle_StepBasic_HArray1OfDocument_3;
  Handle_StepBasic_HArray1OfDocument_4: typeof Handle_StepBasic_HArray1OfDocument_4;
  StepBasic_DesignContext: typeof StepBasic_DesignContext;
  Handle_StepBasic_DesignContext: typeof Handle_StepBasic_DesignContext;
  Handle_StepBasic_DesignContext_1: typeof Handle_StepBasic_DesignContext_1;
  Handle_StepBasic_DesignContext_2: typeof Handle_StepBasic_DesignContext_2;
  Handle_StepBasic_DesignContext_3: typeof Handle_StepBasic_DesignContext_3;
  Handle_StepBasic_DesignContext_4: typeof Handle_StepBasic_DesignContext_4;
  Handle_StepBasic_SecurityClassificationLevel: typeof Handle_StepBasic_SecurityClassificationLevel;
  Handle_StepBasic_SecurityClassificationLevel_1: typeof Handle_StepBasic_SecurityClassificationLevel_1;
  Handle_StepBasic_SecurityClassificationLevel_2: typeof Handle_StepBasic_SecurityClassificationLevel_2;
  Handle_StepBasic_SecurityClassificationLevel_3: typeof Handle_StepBasic_SecurityClassificationLevel_3;
  Handle_StepBasic_SecurityClassificationLevel_4: typeof Handle_StepBasic_SecurityClassificationLevel_4;
  StepBasic_SecurityClassificationLevel: typeof StepBasic_SecurityClassificationLevel;
  Handle_StepBasic_DocumentType: typeof Handle_StepBasic_DocumentType;
  Handle_StepBasic_DocumentType_1: typeof Handle_StepBasic_DocumentType_1;
  Handle_StepBasic_DocumentType_2: typeof Handle_StepBasic_DocumentType_2;
  Handle_StepBasic_DocumentType_3: typeof Handle_StepBasic_DocumentType_3;
  Handle_StepBasic_DocumentType_4: typeof Handle_StepBasic_DocumentType_4;
  StepBasic_DocumentType: typeof StepBasic_DocumentType;
  Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation: typeof Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation;
  Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_1: typeof Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_1;
  Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_2: typeof Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_2;
  Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_3: typeof Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_3;
  Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_4: typeof Handle_StepBasic_ProductDefinitionReferenceWithLocalRepresentation_4;
  StepBasic_ProductDefinitionReferenceWithLocalRepresentation: typeof StepBasic_ProductDefinitionReferenceWithLocalRepresentation;
  StepBasic_WeekOfYearAndDayDate: typeof StepBasic_WeekOfYearAndDayDate;
  Handle_StepBasic_WeekOfYearAndDayDate: typeof Handle_StepBasic_WeekOfYearAndDayDate;
  Handle_StepBasic_WeekOfYearAndDayDate_1: typeof Handle_StepBasic_WeekOfYearAndDayDate_1;
  Handle_StepBasic_WeekOfYearAndDayDate_2: typeof Handle_StepBasic_WeekOfYearAndDayDate_2;
  Handle_StepBasic_WeekOfYearAndDayDate_3: typeof Handle_StepBasic_WeekOfYearAndDayDate_3;
  Handle_StepBasic_WeekOfYearAndDayDate_4: typeof Handle_StepBasic_WeekOfYearAndDayDate_4;
  StepBasic_ActionRequestSolution: typeof StepBasic_ActionRequestSolution;
  Handle_StepBasic_ActionRequestSolution: typeof Handle_StepBasic_ActionRequestSolution;
  Handle_StepBasic_ActionRequestSolution_1: typeof Handle_StepBasic_ActionRequestSolution_1;
  Handle_StepBasic_ActionRequestSolution_2: typeof Handle_StepBasic_ActionRequestSolution_2;
  Handle_StepBasic_ActionRequestSolution_3: typeof Handle_StepBasic_ActionRequestSolution_3;
  Handle_StepBasic_ActionRequestSolution_4: typeof Handle_StepBasic_ActionRequestSolution_4;
  Handle_StepBasic_Person: typeof Handle_StepBasic_Person;
  Handle_StepBasic_Person_1: typeof Handle_StepBasic_Person_1;
  Handle_StepBasic_Person_2: typeof Handle_StepBasic_Person_2;
  Handle_StepBasic_Person_3: typeof Handle_StepBasic_Person_3;
  Handle_StepBasic_Person_4: typeof Handle_StepBasic_Person_4;
  StepBasic_Person: typeof StepBasic_Person;
  Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit: typeof Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit;
  Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_1: typeof Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_1;
  Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_2: typeof Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_2;
  Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_3: typeof Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_3;
  Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_4: typeof Handle_StepBasic_HArray1OfUncertaintyMeasureWithUnit_4;
  Handle_StepBasic_IdentificationRole: typeof Handle_StepBasic_IdentificationRole;
  Handle_StepBasic_IdentificationRole_1: typeof Handle_StepBasic_IdentificationRole_1;
  Handle_StepBasic_IdentificationRole_2: typeof Handle_StepBasic_IdentificationRole_2;
  Handle_StepBasic_IdentificationRole_3: typeof Handle_StepBasic_IdentificationRole_3;
  Handle_StepBasic_IdentificationRole_4: typeof Handle_StepBasic_IdentificationRole_4;
  StepBasic_IdentificationRole: typeof StepBasic_IdentificationRole;
  StepBasic_ProductCategoryRelationship: typeof StepBasic_ProductCategoryRelationship;
  Handle_StepBasic_ProductCategoryRelationship: typeof Handle_StepBasic_ProductCategoryRelationship;
  Handle_StepBasic_ProductCategoryRelationship_1: typeof Handle_StepBasic_ProductCategoryRelationship_1;
  Handle_StepBasic_ProductCategoryRelationship_2: typeof Handle_StepBasic_ProductCategoryRelationship_2;
  Handle_StepBasic_ProductCategoryRelationship_3: typeof Handle_StepBasic_ProductCategoryRelationship_3;
  Handle_StepBasic_ProductCategoryRelationship_4: typeof Handle_StepBasic_ProductCategoryRelationship_4;
  Handle_StepBasic_ConversionBasedUnit: typeof Handle_StepBasic_ConversionBasedUnit;
  Handle_StepBasic_ConversionBasedUnit_1: typeof Handle_StepBasic_ConversionBasedUnit_1;
  Handle_StepBasic_ConversionBasedUnit_2: typeof Handle_StepBasic_ConversionBasedUnit_2;
  Handle_StepBasic_ConversionBasedUnit_3: typeof Handle_StepBasic_ConversionBasedUnit_3;
  Handle_StepBasic_ConversionBasedUnit_4: typeof Handle_StepBasic_ConversionBasedUnit_4;
  StepBasic_ConversionBasedUnit: typeof StepBasic_ConversionBasedUnit;
  StepBasic_ApprovalAssignment: typeof StepBasic_ApprovalAssignment;
  Handle_StepBasic_ApprovalAssignment: typeof Handle_StepBasic_ApprovalAssignment;
  Handle_StepBasic_ApprovalAssignment_1: typeof Handle_StepBasic_ApprovalAssignment_1;
  Handle_StepBasic_ApprovalAssignment_2: typeof Handle_StepBasic_ApprovalAssignment_2;
  Handle_StepBasic_ApprovalAssignment_3: typeof Handle_StepBasic_ApprovalAssignment_3;
  Handle_StepBasic_ApprovalAssignment_4: typeof Handle_StepBasic_ApprovalAssignment_4;
  Handle_StepBasic_HArray1OfNamedUnit: typeof Handle_StepBasic_HArray1OfNamedUnit;
  Handle_StepBasic_HArray1OfNamedUnit_1: typeof Handle_StepBasic_HArray1OfNamedUnit_1;
  Handle_StepBasic_HArray1OfNamedUnit_2: typeof Handle_StepBasic_HArray1OfNamedUnit_2;
  Handle_StepBasic_HArray1OfNamedUnit_3: typeof Handle_StepBasic_HArray1OfNamedUnit_3;
  Handle_StepBasic_HArray1OfNamedUnit_4: typeof Handle_StepBasic_HArray1OfNamedUnit_4;
  Handle_StepBasic_HArray1OfProductDefinition: typeof Handle_StepBasic_HArray1OfProductDefinition;
  Handle_StepBasic_HArray1OfProductDefinition_1: typeof Handle_StepBasic_HArray1OfProductDefinition_1;
  Handle_StepBasic_HArray1OfProductDefinition_2: typeof Handle_StepBasic_HArray1OfProductDefinition_2;
  Handle_StepBasic_HArray1OfProductDefinition_3: typeof Handle_StepBasic_HArray1OfProductDefinition_3;
  Handle_StepBasic_HArray1OfProductDefinition_4: typeof Handle_StepBasic_HArray1OfProductDefinition_4;
  Handle_StepBasic_ProductType: typeof Handle_StepBasic_ProductType;
  Handle_StepBasic_ProductType_1: typeof Handle_StepBasic_ProductType_1;
  Handle_StepBasic_ProductType_2: typeof Handle_StepBasic_ProductType_2;
  Handle_StepBasic_ProductType_3: typeof Handle_StepBasic_ProductType_3;
  Handle_StepBasic_ProductType_4: typeof Handle_StepBasic_ProductType_4;
  StepBasic_ProductType: typeof StepBasic_ProductType;
  StepBasic_SiUnit: typeof StepBasic_SiUnit;
  Handle_StepBasic_SiUnit: typeof Handle_StepBasic_SiUnit;
  Handle_StepBasic_SiUnit_1: typeof Handle_StepBasic_SiUnit_1;
  Handle_StepBasic_SiUnit_2: typeof Handle_StepBasic_SiUnit_2;
  Handle_StepBasic_SiUnit_3: typeof Handle_StepBasic_SiUnit_3;
  Handle_StepBasic_SiUnit_4: typeof Handle_StepBasic_SiUnit_4;
  StepBasic_SiUnitAndSolidAngleUnit: typeof StepBasic_SiUnitAndSolidAngleUnit;
  Handle_StepBasic_SiUnitAndSolidAngleUnit: typeof Handle_StepBasic_SiUnitAndSolidAngleUnit;
  Handle_StepBasic_SiUnitAndSolidAngleUnit_1: typeof Handle_StepBasic_SiUnitAndSolidAngleUnit_1;
  Handle_StepBasic_SiUnitAndSolidAngleUnit_2: typeof Handle_StepBasic_SiUnitAndSolidAngleUnit_2;
  Handle_StepBasic_SiUnitAndSolidAngleUnit_3: typeof Handle_StepBasic_SiUnitAndSolidAngleUnit_3;
  Handle_StepBasic_SiUnitAndSolidAngleUnit_4: typeof Handle_StepBasic_SiUnitAndSolidAngleUnit_4;
  StepBasic_Date: typeof StepBasic_Date;
  Handle_StepBasic_Date: typeof Handle_StepBasic_Date;
  Handle_StepBasic_Date_1: typeof Handle_StepBasic_Date_1;
  Handle_StepBasic_Date_2: typeof Handle_StepBasic_Date_2;
  Handle_StepBasic_Date_3: typeof Handle_StepBasic_Date_3;
  Handle_StepBasic_Date_4: typeof Handle_StepBasic_Date_4;
  StepBasic_ConversionBasedUnitAndMassUnit: typeof StepBasic_ConversionBasedUnitAndMassUnit;
  Handle_StepBasic_ConversionBasedUnitAndMassUnit: typeof Handle_StepBasic_ConversionBasedUnitAndMassUnit;
  Handle_StepBasic_ConversionBasedUnitAndMassUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndMassUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndMassUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndMassUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndMassUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndMassUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndMassUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndMassUnit_4;
  StepBasic_SiUnitName: StepBasic_SiUnitName;
  StepBasic_SolidAngleMeasureWithUnit: typeof StepBasic_SolidAngleMeasureWithUnit;
  Handle_StepBasic_SolidAngleMeasureWithUnit: typeof Handle_StepBasic_SolidAngleMeasureWithUnit;
  Handle_StepBasic_SolidAngleMeasureWithUnit_1: typeof Handle_StepBasic_SolidAngleMeasureWithUnit_1;
  Handle_StepBasic_SolidAngleMeasureWithUnit_2: typeof Handle_StepBasic_SolidAngleMeasureWithUnit_2;
  Handle_StepBasic_SolidAngleMeasureWithUnit_3: typeof Handle_StepBasic_SolidAngleMeasureWithUnit_3;
  Handle_StepBasic_SolidAngleMeasureWithUnit_4: typeof Handle_StepBasic_SolidAngleMeasureWithUnit_4;
  Handle_StepBasic_OrdinalDate: typeof Handle_StepBasic_OrdinalDate;
  Handle_StepBasic_OrdinalDate_1: typeof Handle_StepBasic_OrdinalDate_1;
  Handle_StepBasic_OrdinalDate_2: typeof Handle_StepBasic_OrdinalDate_2;
  Handle_StepBasic_OrdinalDate_3: typeof Handle_StepBasic_OrdinalDate_3;
  Handle_StepBasic_OrdinalDate_4: typeof Handle_StepBasic_OrdinalDate_4;
  StepBasic_OrdinalDate: typeof StepBasic_OrdinalDate;
  Handle_StepBasic_SiUnitAndTimeUnit: typeof Handle_StepBasic_SiUnitAndTimeUnit;
  Handle_StepBasic_SiUnitAndTimeUnit_1: typeof Handle_StepBasic_SiUnitAndTimeUnit_1;
  Handle_StepBasic_SiUnitAndTimeUnit_2: typeof Handle_StepBasic_SiUnitAndTimeUnit_2;
  Handle_StepBasic_SiUnitAndTimeUnit_3: typeof Handle_StepBasic_SiUnitAndTimeUnit_3;
  Handle_StepBasic_SiUnitAndTimeUnit_4: typeof Handle_StepBasic_SiUnitAndTimeUnit_4;
  StepBasic_SiUnitAndTimeUnit: typeof StepBasic_SiUnitAndTimeUnit;
  StepBasic_MassUnit: typeof StepBasic_MassUnit;
  Handle_StepBasic_MassUnit: typeof Handle_StepBasic_MassUnit;
  Handle_StepBasic_MassUnit_1: typeof Handle_StepBasic_MassUnit_1;
  Handle_StepBasic_MassUnit_2: typeof Handle_StepBasic_MassUnit_2;
  Handle_StepBasic_MassUnit_3: typeof Handle_StepBasic_MassUnit_3;
  Handle_StepBasic_MassUnit_4: typeof Handle_StepBasic_MassUnit_4;
  Handle_StepBasic_DateAssignment: typeof Handle_StepBasic_DateAssignment;
  Handle_StepBasic_DateAssignment_1: typeof Handle_StepBasic_DateAssignment_1;
  Handle_StepBasic_DateAssignment_2: typeof Handle_StepBasic_DateAssignment_2;
  Handle_StepBasic_DateAssignment_3: typeof Handle_StepBasic_DateAssignment_3;
  Handle_StepBasic_DateAssignment_4: typeof Handle_StepBasic_DateAssignment_4;
  StepBasic_DateAssignment: typeof StepBasic_DateAssignment;
  Handle_StepBasic_ProductConceptContext: typeof Handle_StepBasic_ProductConceptContext;
  Handle_StepBasic_ProductConceptContext_1: typeof Handle_StepBasic_ProductConceptContext_1;
  Handle_StepBasic_ProductConceptContext_2: typeof Handle_StepBasic_ProductConceptContext_2;
  Handle_StepBasic_ProductConceptContext_3: typeof Handle_StepBasic_ProductConceptContext_3;
  Handle_StepBasic_ProductConceptContext_4: typeof Handle_StepBasic_ProductConceptContext_4;
  StepBasic_ProductConceptContext: typeof StepBasic_ProductConceptContext;
  StepBasic_ApprovalRelationship: typeof StepBasic_ApprovalRelationship;
  Handle_StepBasic_ApprovalRelationship: typeof Handle_StepBasic_ApprovalRelationship;
  Handle_StepBasic_ApprovalRelationship_1: typeof Handle_StepBasic_ApprovalRelationship_1;
  Handle_StepBasic_ApprovalRelationship_2: typeof Handle_StepBasic_ApprovalRelationship_2;
  Handle_StepBasic_ApprovalRelationship_3: typeof Handle_StepBasic_ApprovalRelationship_3;
  Handle_StepBasic_ApprovalRelationship_4: typeof Handle_StepBasic_ApprovalRelationship_4;
  Handle_StepBasic_ConversionBasedUnitAndLengthUnit: typeof Handle_StepBasic_ConversionBasedUnitAndLengthUnit;
  Handle_StepBasic_ConversionBasedUnitAndLengthUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndLengthUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndLengthUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndLengthUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndLengthUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndLengthUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndLengthUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndLengthUnit_4;
  StepBasic_ConversionBasedUnitAndLengthUnit: typeof StepBasic_ConversionBasedUnitAndLengthUnit;
  StepBasic_ObjectRole: typeof StepBasic_ObjectRole;
  Handle_StepBasic_ObjectRole: typeof Handle_StepBasic_ObjectRole;
  Handle_StepBasic_ObjectRole_1: typeof Handle_StepBasic_ObjectRole_1;
  Handle_StepBasic_ObjectRole_2: typeof Handle_StepBasic_ObjectRole_2;
  Handle_StepBasic_ObjectRole_3: typeof Handle_StepBasic_ObjectRole_3;
  Handle_StepBasic_ObjectRole_4: typeof Handle_StepBasic_ObjectRole_4;
  StepBasic_PersonOrganizationSelect: typeof StepBasic_PersonOrganizationSelect;
  StepBasic_DocumentProductEquivalence: typeof StepBasic_DocumentProductEquivalence;
  Handle_StepBasic_DocumentProductEquivalence: typeof Handle_StepBasic_DocumentProductEquivalence;
  Handle_StepBasic_DocumentProductEquivalence_1: typeof Handle_StepBasic_DocumentProductEquivalence_1;
  Handle_StepBasic_DocumentProductEquivalence_2: typeof Handle_StepBasic_DocumentProductEquivalence_2;
  Handle_StepBasic_DocumentProductEquivalence_3: typeof Handle_StepBasic_DocumentProductEquivalence_3;
  Handle_StepBasic_DocumentProductEquivalence_4: typeof Handle_StepBasic_DocumentProductEquivalence_4;
  Handle_StepBasic_ApprovalDateTime: typeof Handle_StepBasic_ApprovalDateTime;
  Handle_StepBasic_ApprovalDateTime_1: typeof Handle_StepBasic_ApprovalDateTime_1;
  Handle_StepBasic_ApprovalDateTime_2: typeof Handle_StepBasic_ApprovalDateTime_2;
  Handle_StepBasic_ApprovalDateTime_3: typeof Handle_StepBasic_ApprovalDateTime_3;
  Handle_StepBasic_ApprovalDateTime_4: typeof Handle_StepBasic_ApprovalDateTime_4;
  StepBasic_ApprovalDateTime: typeof StepBasic_ApprovalDateTime;
  Handle_StepBasic_DocumentRelationship: typeof Handle_StepBasic_DocumentRelationship;
  Handle_StepBasic_DocumentRelationship_1: typeof Handle_StepBasic_DocumentRelationship_1;
  Handle_StepBasic_DocumentRelationship_2: typeof Handle_StepBasic_DocumentRelationship_2;
  Handle_StepBasic_DocumentRelationship_3: typeof Handle_StepBasic_DocumentRelationship_3;
  Handle_StepBasic_DocumentRelationship_4: typeof Handle_StepBasic_DocumentRelationship_4;
  StepBasic_DocumentRelationship: typeof StepBasic_DocumentRelationship;
  StepBasic_ConversionBasedUnitAndAreaUnit: typeof StepBasic_ConversionBasedUnitAndAreaUnit;
  Handle_StepBasic_ConversionBasedUnitAndAreaUnit: typeof Handle_StepBasic_ConversionBasedUnitAndAreaUnit;
  Handle_StepBasic_ConversionBasedUnitAndAreaUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndAreaUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndAreaUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndAreaUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndAreaUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndAreaUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndAreaUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndAreaUnit_4;
  Handle_StepBasic_HArray1OfOrganization: typeof Handle_StepBasic_HArray1OfOrganization;
  Handle_StepBasic_HArray1OfOrganization_1: typeof Handle_StepBasic_HArray1OfOrganization_1;
  Handle_StepBasic_HArray1OfOrganization_2: typeof Handle_StepBasic_HArray1OfOrganization_2;
  Handle_StepBasic_HArray1OfOrganization_3: typeof Handle_StepBasic_HArray1OfOrganization_3;
  Handle_StepBasic_HArray1OfOrganization_4: typeof Handle_StepBasic_HArray1OfOrganization_4;
  StepBasic_ProductRelatedProductCategory: typeof StepBasic_ProductRelatedProductCategory;
  Handle_StepBasic_ProductRelatedProductCategory: typeof Handle_StepBasic_ProductRelatedProductCategory;
  Handle_StepBasic_ProductRelatedProductCategory_1: typeof Handle_StepBasic_ProductRelatedProductCategory_1;
  Handle_StepBasic_ProductRelatedProductCategory_2: typeof Handle_StepBasic_ProductRelatedProductCategory_2;
  Handle_StepBasic_ProductRelatedProductCategory_3: typeof Handle_StepBasic_ProductRelatedProductCategory_3;
  Handle_StepBasic_ProductRelatedProductCategory_4: typeof Handle_StepBasic_ProductRelatedProductCategory_4;
  StepBasic_Action: typeof StepBasic_Action;
  Handle_StepBasic_Action: typeof Handle_StepBasic_Action;
  Handle_StepBasic_Action_1: typeof Handle_StepBasic_Action_1;
  Handle_StepBasic_Action_2: typeof Handle_StepBasic_Action_2;
  Handle_StepBasic_Action_3: typeof Handle_StepBasic_Action_3;
  Handle_StepBasic_Action_4: typeof Handle_StepBasic_Action_4;
  Handle_StepBasic_Group: typeof Handle_StepBasic_Group;
  Handle_StepBasic_Group_1: typeof Handle_StepBasic_Group_1;
  Handle_StepBasic_Group_2: typeof Handle_StepBasic_Group_2;
  Handle_StepBasic_Group_3: typeof Handle_StepBasic_Group_3;
  Handle_StepBasic_Group_4: typeof Handle_StepBasic_Group_4;
  StepBasic_Group: typeof StepBasic_Group;
  Handle_StepBasic_LengthMeasureWithUnit: typeof Handle_StepBasic_LengthMeasureWithUnit;
  Handle_StepBasic_LengthMeasureWithUnit_1: typeof Handle_StepBasic_LengthMeasureWithUnit_1;
  Handle_StepBasic_LengthMeasureWithUnit_2: typeof Handle_StepBasic_LengthMeasureWithUnit_2;
  Handle_StepBasic_LengthMeasureWithUnit_3: typeof Handle_StepBasic_LengthMeasureWithUnit_3;
  Handle_StepBasic_LengthMeasureWithUnit_4: typeof Handle_StepBasic_LengthMeasureWithUnit_4;
  StepBasic_LengthMeasureWithUnit: typeof StepBasic_LengthMeasureWithUnit;
  StepBasic_SizeSelect: typeof StepBasic_SizeSelect;
  Handle_StepBasic_ProductDefinitionEffectivity: typeof Handle_StepBasic_ProductDefinitionEffectivity;
  Handle_StepBasic_ProductDefinitionEffectivity_1: typeof Handle_StepBasic_ProductDefinitionEffectivity_1;
  Handle_StepBasic_ProductDefinitionEffectivity_2: typeof Handle_StepBasic_ProductDefinitionEffectivity_2;
  Handle_StepBasic_ProductDefinitionEffectivity_3: typeof Handle_StepBasic_ProductDefinitionEffectivity_3;
  Handle_StepBasic_ProductDefinitionEffectivity_4: typeof Handle_StepBasic_ProductDefinitionEffectivity_4;
  StepBasic_ProductDefinitionEffectivity: typeof StepBasic_ProductDefinitionEffectivity;
  Handle_StepBasic_Address: typeof Handle_StepBasic_Address;
  Handle_StepBasic_Address_1: typeof Handle_StepBasic_Address_1;
  Handle_StepBasic_Address_2: typeof Handle_StepBasic_Address_2;
  Handle_StepBasic_Address_3: typeof Handle_StepBasic_Address_3;
  Handle_StepBasic_Address_4: typeof Handle_StepBasic_Address_4;
  StepBasic_Address: typeof StepBasic_Address;
  Handle_StepBasic_DocumentReference: typeof Handle_StepBasic_DocumentReference;
  Handle_StepBasic_DocumentReference_1: typeof Handle_StepBasic_DocumentReference_1;
  Handle_StepBasic_DocumentReference_2: typeof Handle_StepBasic_DocumentReference_2;
  Handle_StepBasic_DocumentReference_3: typeof Handle_StepBasic_DocumentReference_3;
  Handle_StepBasic_DocumentReference_4: typeof Handle_StepBasic_DocumentReference_4;
  StepBasic_DocumentReference: typeof StepBasic_DocumentReference;
  StepBasic_PersonalAddress: typeof StepBasic_PersonalAddress;
  Handle_StepBasic_PersonalAddress: typeof Handle_StepBasic_PersonalAddress;
  Handle_StepBasic_PersonalAddress_1: typeof Handle_StepBasic_PersonalAddress_1;
  Handle_StepBasic_PersonalAddress_2: typeof Handle_StepBasic_PersonalAddress_2;
  Handle_StepBasic_PersonalAddress_3: typeof Handle_StepBasic_PersonalAddress_3;
  Handle_StepBasic_PersonalAddress_4: typeof Handle_StepBasic_PersonalAddress_4;
  StepBasic_SiUnitAndThermodynamicTemperatureUnit: typeof StepBasic_SiUnitAndThermodynamicTemperatureUnit;
  Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit: typeof Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit;
  Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_1: typeof Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_1;
  Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_2: typeof Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_2;
  Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_3: typeof Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_3;
  Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_4: typeof Handle_StepBasic_SiUnitAndThermodynamicTemperatureUnit_4;
  StepBasic_OrganizationRole: typeof StepBasic_OrganizationRole;
  Handle_StepBasic_OrganizationRole: typeof Handle_StepBasic_OrganizationRole;
  Handle_StepBasic_OrganizationRole_1: typeof Handle_StepBasic_OrganizationRole_1;
  Handle_StepBasic_OrganizationRole_2: typeof Handle_StepBasic_OrganizationRole_2;
  Handle_StepBasic_OrganizationRole_3: typeof Handle_StepBasic_OrganizationRole_3;
  Handle_StepBasic_OrganizationRole_4: typeof Handle_StepBasic_OrganizationRole_4;
  StepBasic_ProductDefinitionContext: typeof StepBasic_ProductDefinitionContext;
  Handle_StepBasic_ProductDefinitionContext: typeof Handle_StepBasic_ProductDefinitionContext;
  Handle_StepBasic_ProductDefinitionContext_1: typeof Handle_StepBasic_ProductDefinitionContext_1;
  Handle_StepBasic_ProductDefinitionContext_2: typeof Handle_StepBasic_ProductDefinitionContext_2;
  Handle_StepBasic_ProductDefinitionContext_3: typeof Handle_StepBasic_ProductDefinitionContext_3;
  Handle_StepBasic_ProductDefinitionContext_4: typeof Handle_StepBasic_ProductDefinitionContext_4;
  StepBasic_VolumeUnit: typeof StepBasic_VolumeUnit;
  Handle_StepBasic_VolumeUnit: typeof Handle_StepBasic_VolumeUnit;
  Handle_StepBasic_VolumeUnit_1: typeof Handle_StepBasic_VolumeUnit_1;
  Handle_StepBasic_VolumeUnit_2: typeof Handle_StepBasic_VolumeUnit_2;
  Handle_StepBasic_VolumeUnit_3: typeof Handle_StepBasic_VolumeUnit_3;
  Handle_StepBasic_VolumeUnit_4: typeof Handle_StepBasic_VolumeUnit_4;
  Handle_StepBasic_DocumentRepresentationType: typeof Handle_StepBasic_DocumentRepresentationType;
  Handle_StepBasic_DocumentRepresentationType_1: typeof Handle_StepBasic_DocumentRepresentationType_1;
  Handle_StepBasic_DocumentRepresentationType_2: typeof Handle_StepBasic_DocumentRepresentationType_2;
  Handle_StepBasic_DocumentRepresentationType_3: typeof Handle_StepBasic_DocumentRepresentationType_3;
  Handle_StepBasic_DocumentRepresentationType_4: typeof Handle_StepBasic_DocumentRepresentationType_4;
  StepBasic_DocumentRepresentationType: typeof StepBasic_DocumentRepresentationType;
  Handle_StepBasic_LocalTime: typeof Handle_StepBasic_LocalTime;
  Handle_StepBasic_LocalTime_1: typeof Handle_StepBasic_LocalTime_1;
  Handle_StepBasic_LocalTime_2: typeof Handle_StepBasic_LocalTime_2;
  Handle_StepBasic_LocalTime_3: typeof Handle_StepBasic_LocalTime_3;
  Handle_StepBasic_LocalTime_4: typeof Handle_StepBasic_LocalTime_4;
  StepBasic_LocalTime: typeof StepBasic_LocalTime;
  StepBasic_DateTimeRole: typeof StepBasic_DateTimeRole;
  Handle_StepBasic_DateTimeRole: typeof Handle_StepBasic_DateTimeRole;
  Handle_StepBasic_DateTimeRole_1: typeof Handle_StepBasic_DateTimeRole_1;
  Handle_StepBasic_DateTimeRole_2: typeof Handle_StepBasic_DateTimeRole_2;
  Handle_StepBasic_DateTimeRole_3: typeof Handle_StepBasic_DateTimeRole_3;
  Handle_StepBasic_DateTimeRole_4: typeof Handle_StepBasic_DateTimeRole_4;
  StepBasic_DateTimeSelect: typeof StepBasic_DateTimeSelect;
  StepBasic_NamedUnit: typeof StepBasic_NamedUnit;
  Handle_StepBasic_NamedUnit: typeof Handle_StepBasic_NamedUnit;
  Handle_StepBasic_NamedUnit_1: typeof Handle_StepBasic_NamedUnit_1;
  Handle_StepBasic_NamedUnit_2: typeof Handle_StepBasic_NamedUnit_2;
  Handle_StepBasic_NamedUnit_3: typeof Handle_StepBasic_NamedUnit_3;
  Handle_StepBasic_NamedUnit_4: typeof Handle_StepBasic_NamedUnit_4;
  StepBasic_ProductDefinitionOrReference: typeof StepBasic_ProductDefinitionOrReference;
  StepBasic_ConversionBasedUnitAndPlaneAngleUnit: typeof StepBasic_ConversionBasedUnitAndPlaneAngleUnit;
  Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit: typeof Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit;
  Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndPlaneAngleUnit_4;
  StepBasic_ProductOrFormationOrDefinition: typeof StepBasic_ProductOrFormationOrDefinition;
  StepBasic_MeasureWithUnit: typeof StepBasic_MeasureWithUnit;
  Handle_StepBasic_MeasureWithUnit: typeof Handle_StepBasic_MeasureWithUnit;
  Handle_StepBasic_MeasureWithUnit_1: typeof Handle_StepBasic_MeasureWithUnit_1;
  Handle_StepBasic_MeasureWithUnit_2: typeof Handle_StepBasic_MeasureWithUnit_2;
  Handle_StepBasic_MeasureWithUnit_3: typeof Handle_StepBasic_MeasureWithUnit_3;
  Handle_StepBasic_MeasureWithUnit_4: typeof Handle_StepBasic_MeasureWithUnit_4;
  Handle_StepBasic_RoleAssociation: typeof Handle_StepBasic_RoleAssociation;
  Handle_StepBasic_RoleAssociation_1: typeof Handle_StepBasic_RoleAssociation_1;
  Handle_StepBasic_RoleAssociation_2: typeof Handle_StepBasic_RoleAssociation_2;
  Handle_StepBasic_RoleAssociation_3: typeof Handle_StepBasic_RoleAssociation_3;
  Handle_StepBasic_RoleAssociation_4: typeof Handle_StepBasic_RoleAssociation_4;
  StepBasic_RoleAssociation: typeof StepBasic_RoleAssociation;
  StepBasic_DateAndTimeAssignment: typeof StepBasic_DateAndTimeAssignment;
  Handle_StepBasic_DateAndTimeAssignment: typeof Handle_StepBasic_DateAndTimeAssignment;
  Handle_StepBasic_DateAndTimeAssignment_1: typeof Handle_StepBasic_DateAndTimeAssignment_1;
  Handle_StepBasic_DateAndTimeAssignment_2: typeof Handle_StepBasic_DateAndTimeAssignment_2;
  Handle_StepBasic_DateAndTimeAssignment_3: typeof Handle_StepBasic_DateAndTimeAssignment_3;
  Handle_StepBasic_DateAndTimeAssignment_4: typeof Handle_StepBasic_DateAndTimeAssignment_4;
  StepBasic_Unit: typeof StepBasic_Unit;
  Handle_StepBasic_ActionRequestAssignment: typeof Handle_StepBasic_ActionRequestAssignment;
  Handle_StepBasic_ActionRequestAssignment_1: typeof Handle_StepBasic_ActionRequestAssignment_1;
  Handle_StepBasic_ActionRequestAssignment_2: typeof Handle_StepBasic_ActionRequestAssignment_2;
  Handle_StepBasic_ActionRequestAssignment_3: typeof Handle_StepBasic_ActionRequestAssignment_3;
  Handle_StepBasic_ActionRequestAssignment_4: typeof Handle_StepBasic_ActionRequestAssignment_4;
  StepBasic_ActionRequestAssignment: typeof StepBasic_ActionRequestAssignment;
  Handle_StepBasic_SiUnitAndPlaneAngleUnit: typeof Handle_StepBasic_SiUnitAndPlaneAngleUnit;
  Handle_StepBasic_SiUnitAndPlaneAngleUnit_1: typeof Handle_StepBasic_SiUnitAndPlaneAngleUnit_1;
  Handle_StepBasic_SiUnitAndPlaneAngleUnit_2: typeof Handle_StepBasic_SiUnitAndPlaneAngleUnit_2;
  Handle_StepBasic_SiUnitAndPlaneAngleUnit_3: typeof Handle_StepBasic_SiUnitAndPlaneAngleUnit_3;
  Handle_StepBasic_SiUnitAndPlaneAngleUnit_4: typeof Handle_StepBasic_SiUnitAndPlaneAngleUnit_4;
  StepBasic_SiUnitAndPlaneAngleUnit: typeof StepBasic_SiUnitAndPlaneAngleUnit;
  Handle_StepBasic_SiUnitAndMassUnit: typeof Handle_StepBasic_SiUnitAndMassUnit;
  Handle_StepBasic_SiUnitAndMassUnit_1: typeof Handle_StepBasic_SiUnitAndMassUnit_1;
  Handle_StepBasic_SiUnitAndMassUnit_2: typeof Handle_StepBasic_SiUnitAndMassUnit_2;
  Handle_StepBasic_SiUnitAndMassUnit_3: typeof Handle_StepBasic_SiUnitAndMassUnit_3;
  Handle_StepBasic_SiUnitAndMassUnit_4: typeof Handle_StepBasic_SiUnitAndMassUnit_4;
  StepBasic_SiUnitAndMassUnit: typeof StepBasic_SiUnitAndMassUnit;
  Handle_StepBasic_ApplicationProtocolDefinition: typeof Handle_StepBasic_ApplicationProtocolDefinition;
  Handle_StepBasic_ApplicationProtocolDefinition_1: typeof Handle_StepBasic_ApplicationProtocolDefinition_1;
  Handle_StepBasic_ApplicationProtocolDefinition_2: typeof Handle_StepBasic_ApplicationProtocolDefinition_2;
  Handle_StepBasic_ApplicationProtocolDefinition_3: typeof Handle_StepBasic_ApplicationProtocolDefinition_3;
  Handle_StepBasic_ApplicationProtocolDefinition_4: typeof Handle_StepBasic_ApplicationProtocolDefinition_4;
  StepBasic_ApplicationProtocolDefinition: typeof StepBasic_ApplicationProtocolDefinition;
  StepBasic_LengthUnit: typeof StepBasic_LengthUnit;
  Handle_StepBasic_LengthUnit: typeof Handle_StepBasic_LengthUnit;
  Handle_StepBasic_LengthUnit_1: typeof Handle_StepBasic_LengthUnit_1;
  Handle_StepBasic_LengthUnit_2: typeof Handle_StepBasic_LengthUnit_2;
  Handle_StepBasic_LengthUnit_3: typeof Handle_StepBasic_LengthUnit_3;
  Handle_StepBasic_LengthUnit_4: typeof Handle_StepBasic_LengthUnit_4;
  StepBasic_ActionMethod: typeof StepBasic_ActionMethod;
  Handle_StepBasic_ActionMethod: typeof Handle_StepBasic_ActionMethod;
  Handle_StepBasic_ActionMethod_1: typeof Handle_StepBasic_ActionMethod_1;
  Handle_StepBasic_ActionMethod_2: typeof Handle_StepBasic_ActionMethod_2;
  Handle_StepBasic_ActionMethod_3: typeof Handle_StepBasic_ActionMethod_3;
  Handle_StepBasic_ActionMethod_4: typeof Handle_StepBasic_ActionMethod_4;
  StepBasic_RatioUnit: typeof StepBasic_RatioUnit;
  Handle_StepBasic_RatioUnit: typeof Handle_StepBasic_RatioUnit;
  Handle_StepBasic_RatioUnit_1: typeof Handle_StepBasic_RatioUnit_1;
  Handle_StepBasic_RatioUnit_2: typeof Handle_StepBasic_RatioUnit_2;
  Handle_StepBasic_RatioUnit_3: typeof Handle_StepBasic_RatioUnit_3;
  Handle_StepBasic_RatioUnit_4: typeof Handle_StepBasic_RatioUnit_4;
  StepBasic_DateRole: typeof StepBasic_DateRole;
  Handle_StepBasic_DateRole: typeof Handle_StepBasic_DateRole;
  Handle_StepBasic_DateRole_1: typeof Handle_StepBasic_DateRole_1;
  Handle_StepBasic_DateRole_2: typeof Handle_StepBasic_DateRole_2;
  Handle_StepBasic_DateRole_3: typeof Handle_StepBasic_DateRole_3;
  Handle_StepBasic_DateRole_4: typeof Handle_StepBasic_DateRole_4;
  Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource: typeof Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource;
  Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_1: typeof Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_1;
  Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_2: typeof Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_2;
  Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_3: typeof Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_3;
  Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_4: typeof Handle_StepBasic_ProductDefinitionFormationWithSpecifiedSource_4;
  StepBasic_ProductDefinitionFormationWithSpecifiedSource: typeof StepBasic_ProductDefinitionFormationWithSpecifiedSource;
  StepBasic_SiUnitAndVolumeUnit: typeof StepBasic_SiUnitAndVolumeUnit;
  Handle_StepBasic_SiUnitAndVolumeUnit: typeof Handle_StepBasic_SiUnitAndVolumeUnit;
  Handle_StepBasic_SiUnitAndVolumeUnit_1: typeof Handle_StepBasic_SiUnitAndVolumeUnit_1;
  Handle_StepBasic_SiUnitAndVolumeUnit_2: typeof Handle_StepBasic_SiUnitAndVolumeUnit_2;
  Handle_StepBasic_SiUnitAndVolumeUnit_3: typeof Handle_StepBasic_SiUnitAndVolumeUnit_3;
  Handle_StepBasic_SiUnitAndVolumeUnit_4: typeof Handle_StepBasic_SiUnitAndVolumeUnit_4;
  Handle_StepBasic_UncertaintyMeasureWithUnit: typeof Handle_StepBasic_UncertaintyMeasureWithUnit;
  Handle_StepBasic_UncertaintyMeasureWithUnit_1: typeof Handle_StepBasic_UncertaintyMeasureWithUnit_1;
  Handle_StepBasic_UncertaintyMeasureWithUnit_2: typeof Handle_StepBasic_UncertaintyMeasureWithUnit_2;
  Handle_StepBasic_UncertaintyMeasureWithUnit_3: typeof Handle_StepBasic_UncertaintyMeasureWithUnit_3;
  Handle_StepBasic_UncertaintyMeasureWithUnit_4: typeof Handle_StepBasic_UncertaintyMeasureWithUnit_4;
  StepBasic_UncertaintyMeasureWithUnit: typeof StepBasic_UncertaintyMeasureWithUnit;
  StepBasic_MeasureValueMember: typeof StepBasic_MeasureValueMember;
  Handle_StepBasic_MeasureValueMember: typeof Handle_StepBasic_MeasureValueMember;
  Handle_StepBasic_MeasureValueMember_1: typeof Handle_StepBasic_MeasureValueMember_1;
  Handle_StepBasic_MeasureValueMember_2: typeof Handle_StepBasic_MeasureValueMember_2;
  Handle_StepBasic_MeasureValueMember_3: typeof Handle_StepBasic_MeasureValueMember_3;
  Handle_StepBasic_MeasureValueMember_4: typeof Handle_StepBasic_MeasureValueMember_4;
  StepBasic_Contract: typeof StepBasic_Contract;
  Handle_StepBasic_Contract: typeof Handle_StepBasic_Contract;
  Handle_StepBasic_Contract_1: typeof Handle_StepBasic_Contract_1;
  Handle_StepBasic_Contract_2: typeof Handle_StepBasic_Contract_2;
  Handle_StepBasic_Contract_3: typeof Handle_StepBasic_Contract_3;
  Handle_StepBasic_Contract_4: typeof Handle_StepBasic_Contract_4;
  StepBasic_SourceItem: typeof StepBasic_SourceItem;
  StepBasic_SiUnitAndAreaUnit: typeof StepBasic_SiUnitAndAreaUnit;
  Handle_StepBasic_SiUnitAndAreaUnit: typeof Handle_StepBasic_SiUnitAndAreaUnit;
  Handle_StepBasic_SiUnitAndAreaUnit_1: typeof Handle_StepBasic_SiUnitAndAreaUnit_1;
  Handle_StepBasic_SiUnitAndAreaUnit_2: typeof Handle_StepBasic_SiUnitAndAreaUnit_2;
  Handle_StepBasic_SiUnitAndAreaUnit_3: typeof Handle_StepBasic_SiUnitAndAreaUnit_3;
  Handle_StepBasic_SiUnitAndAreaUnit_4: typeof Handle_StepBasic_SiUnitAndAreaUnit_4;
  StepBasic_Product: typeof StepBasic_Product;
  Handle_StepBasic_Product: typeof Handle_StepBasic_Product;
  Handle_StepBasic_Product_1: typeof Handle_StepBasic_Product_1;
  Handle_StepBasic_Product_2: typeof Handle_StepBasic_Product_2;
  Handle_StepBasic_Product_3: typeof Handle_StepBasic_Product_3;
  Handle_StepBasic_Product_4: typeof Handle_StepBasic_Product_4;
  Handle_StepBasic_DerivedUnitElement: typeof Handle_StepBasic_DerivedUnitElement;
  Handle_StepBasic_DerivedUnitElement_1: typeof Handle_StepBasic_DerivedUnitElement_1;
  Handle_StepBasic_DerivedUnitElement_2: typeof Handle_StepBasic_DerivedUnitElement_2;
  Handle_StepBasic_DerivedUnitElement_3: typeof Handle_StepBasic_DerivedUnitElement_3;
  Handle_StepBasic_DerivedUnitElement_4: typeof Handle_StepBasic_DerivedUnitElement_4;
  StepBasic_DerivedUnitElement: typeof StepBasic_DerivedUnitElement;
  StepBasic_Effectivity: typeof StepBasic_Effectivity;
  Handle_StepBasic_Effectivity: typeof Handle_StepBasic_Effectivity;
  Handle_StepBasic_Effectivity_1: typeof Handle_StepBasic_Effectivity_1;
  Handle_StepBasic_Effectivity_2: typeof Handle_StepBasic_Effectivity_2;
  Handle_StepBasic_Effectivity_3: typeof Handle_StepBasic_Effectivity_3;
  Handle_StepBasic_Effectivity_4: typeof Handle_StepBasic_Effectivity_4;
  StepBasic_DocumentProductAssociation: typeof StepBasic_DocumentProductAssociation;
  Handle_StepBasic_DocumentProductAssociation: typeof Handle_StepBasic_DocumentProductAssociation;
  Handle_StepBasic_DocumentProductAssociation_1: typeof Handle_StepBasic_DocumentProductAssociation_1;
  Handle_StepBasic_DocumentProductAssociation_2: typeof Handle_StepBasic_DocumentProductAssociation_2;
  Handle_StepBasic_DocumentProductAssociation_3: typeof Handle_StepBasic_DocumentProductAssociation_3;
  Handle_StepBasic_DocumentProductAssociation_4: typeof Handle_StepBasic_DocumentProductAssociation_4;
  Handle_StepBasic_ApplicationContext: typeof Handle_StepBasic_ApplicationContext;
  Handle_StepBasic_ApplicationContext_1: typeof Handle_StepBasic_ApplicationContext_1;
  Handle_StepBasic_ApplicationContext_2: typeof Handle_StepBasic_ApplicationContext_2;
  Handle_StepBasic_ApplicationContext_3: typeof Handle_StepBasic_ApplicationContext_3;
  Handle_StepBasic_ApplicationContext_4: typeof Handle_StepBasic_ApplicationContext_4;
  StepBasic_ApplicationContext: typeof StepBasic_ApplicationContext;
  StepBasic_GroupRelationship: typeof StepBasic_GroupRelationship;
  Handle_StepBasic_GroupRelationship: typeof Handle_StepBasic_GroupRelationship;
  Handle_StepBasic_GroupRelationship_1: typeof Handle_StepBasic_GroupRelationship_1;
  Handle_StepBasic_GroupRelationship_2: typeof Handle_StepBasic_GroupRelationship_2;
  Handle_StepBasic_GroupRelationship_3: typeof Handle_StepBasic_GroupRelationship_3;
  Handle_StepBasic_GroupRelationship_4: typeof Handle_StepBasic_GroupRelationship_4;
  StepBasic_RoleSelect: typeof StepBasic_RoleSelect;
  Handle_StepBasic_EulerAngles: typeof Handle_StepBasic_EulerAngles;
  Handle_StepBasic_EulerAngles_1: typeof Handle_StepBasic_EulerAngles_1;
  Handle_StepBasic_EulerAngles_2: typeof Handle_StepBasic_EulerAngles_2;
  Handle_StepBasic_EulerAngles_3: typeof Handle_StepBasic_EulerAngles_3;
  Handle_StepBasic_EulerAngles_4: typeof Handle_StepBasic_EulerAngles_4;
  StepBasic_EulerAngles: typeof StepBasic_EulerAngles;
  Handle_StepBasic_PhysicallyModeledProductDefinition: typeof Handle_StepBasic_PhysicallyModeledProductDefinition;
  Handle_StepBasic_PhysicallyModeledProductDefinition_1: typeof Handle_StepBasic_PhysicallyModeledProductDefinition_1;
  Handle_StepBasic_PhysicallyModeledProductDefinition_2: typeof Handle_StepBasic_PhysicallyModeledProductDefinition_2;
  Handle_StepBasic_PhysicallyModeledProductDefinition_3: typeof Handle_StepBasic_PhysicallyModeledProductDefinition_3;
  Handle_StepBasic_PhysicallyModeledProductDefinition_4: typeof Handle_StepBasic_PhysicallyModeledProductDefinition_4;
  StepBasic_PhysicallyModeledProductDefinition: typeof StepBasic_PhysicallyModeledProductDefinition;
  Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit: typeof Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit;
  Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndSolidAngleUnit_4;
  StepBasic_ConversionBasedUnitAndSolidAngleUnit: typeof StepBasic_ConversionBasedUnitAndSolidAngleUnit;
  StepBasic_ConversionBasedUnitAndVolumeUnit: typeof StepBasic_ConversionBasedUnitAndVolumeUnit;
  Handle_StepBasic_ConversionBasedUnitAndVolumeUnit: typeof Handle_StepBasic_ConversionBasedUnitAndVolumeUnit;
  Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_1: typeof Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_1;
  Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_2: typeof Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_2;
  Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_3: typeof Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_3;
  Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_4: typeof Handle_StepBasic_ConversionBasedUnitAndVolumeUnit_4;
  Handle_StepBasic_TimeUnit: typeof Handle_StepBasic_TimeUnit;
  Handle_StepBasic_TimeUnit_1: typeof Handle_StepBasic_TimeUnit_1;
  Handle_StepBasic_TimeUnit_2: typeof Handle_StepBasic_TimeUnit_2;
  Handle_StepBasic_TimeUnit_3: typeof Handle_StepBasic_TimeUnit_3;
  Handle_StepBasic_TimeUnit_4: typeof Handle_StepBasic_TimeUnit_4;
  StepBasic_TimeUnit: typeof StepBasic_TimeUnit;
  StepBasic_ProductDefinitionWithAssociatedDocuments: typeof StepBasic_ProductDefinitionWithAssociatedDocuments;
  Handle_StepBasic_ProductDefinitionWithAssociatedDocuments: typeof Handle_StepBasic_ProductDefinitionWithAssociatedDocuments;
  Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_1: typeof Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_1;
  Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_2: typeof Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_2;
  Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_3: typeof Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_3;
  Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_4: typeof Handle_StepBasic_ProductDefinitionWithAssociatedDocuments_4;
  Handle_StepBasic_ContractAssignment: typeof Handle_StepBasic_ContractAssignment;
  Handle_StepBasic_ContractAssignment_1: typeof Handle_StepBasic_ContractAssignment_1;
  Handle_StepBasic_ContractAssignment_2: typeof Handle_StepBasic_ContractAssignment_2;
  Handle_StepBasic_ContractAssignment_3: typeof Handle_StepBasic_ContractAssignment_3;
  Handle_StepBasic_ContractAssignment_4: typeof Handle_StepBasic_ContractAssignment_4;
  StepBasic_ContractAssignment: typeof StepBasic_ContractAssignment;
  Handle_StepBasic_CertificationType: typeof Handle_StepBasic_CertificationType;
  Handle_StepBasic_CertificationType_1: typeof Handle_StepBasic_CertificationType_1;
  Handle_StepBasic_CertificationType_2: typeof Handle_StepBasic_CertificationType_2;
  Handle_StepBasic_CertificationType_3: typeof Handle_StepBasic_CertificationType_3;
  Handle_StepBasic_CertificationType_4: typeof Handle_StepBasic_CertificationType_4;
  StepBasic_CertificationType: typeof StepBasic_CertificationType;
  StepBasic_ApprovalPersonOrganization: typeof StepBasic_ApprovalPersonOrganization;
  Handle_StepBasic_ApprovalPersonOrganization: typeof Handle_StepBasic_ApprovalPersonOrganization;
  Handle_StepBasic_ApprovalPersonOrganization_1: typeof Handle_StepBasic_ApprovalPersonOrganization_1;
  Handle_StepBasic_ApprovalPersonOrganization_2: typeof Handle_StepBasic_ApprovalPersonOrganization_2;
  Handle_StepBasic_ApprovalPersonOrganization_3: typeof Handle_StepBasic_ApprovalPersonOrganization_3;
  Handle_StepBasic_ApprovalPersonOrganization_4: typeof Handle_StepBasic_ApprovalPersonOrganization_4;
  StepBasic_SolidAngleUnit: typeof StepBasic_SolidAngleUnit;
  Handle_StepBasic_SolidAngleUnit: typeof Handle_StepBasic_SolidAngleUnit;
  Handle_StepBasic_SolidAngleUnit_1: typeof Handle_StepBasic_SolidAngleUnit_1;
  Handle_StepBasic_SolidAngleUnit_2: typeof Handle_StepBasic_SolidAngleUnit_2;
  Handle_StepBasic_SolidAngleUnit_3: typeof Handle_StepBasic_SolidAngleUnit_3;
  Handle_StepBasic_SolidAngleUnit_4: typeof Handle_StepBasic_SolidAngleUnit_4;
  Geom2dEvaluator_OffsetCurve: typeof Geom2dEvaluator_OffsetCurve;
  Geom2dEvaluator_OffsetCurve_1: typeof Geom2dEvaluator_OffsetCurve_1;
  Geom2dEvaluator_OffsetCurve_2: typeof Geom2dEvaluator_OffsetCurve_2;
  Handle_Geom2dEvaluator_OffsetCurve: typeof Handle_Geom2dEvaluator_OffsetCurve;
  Handle_Geom2dEvaluator_OffsetCurve_1: typeof Handle_Geom2dEvaluator_OffsetCurve_1;
  Handle_Geom2dEvaluator_OffsetCurve_2: typeof Handle_Geom2dEvaluator_OffsetCurve_2;
  Handle_Geom2dEvaluator_OffsetCurve_3: typeof Handle_Geom2dEvaluator_OffsetCurve_3;
  Handle_Geom2dEvaluator_OffsetCurve_4: typeof Handle_Geom2dEvaluator_OffsetCurve_4;
  Handle_Geom2dEvaluator_Curve: typeof Handle_Geom2dEvaluator_Curve;
  Handle_Geom2dEvaluator_Curve_1: typeof Handle_Geom2dEvaluator_Curve_1;
  Handle_Geom2dEvaluator_Curve_2: typeof Handle_Geom2dEvaluator_Curve_2;
  Handle_Geom2dEvaluator_Curve_3: typeof Handle_Geom2dEvaluator_Curve_3;
  Handle_Geom2dEvaluator_Curve_4: typeof Handle_Geom2dEvaluator_Curve_4;
  Geom2dEvaluator_Curve: typeof Geom2dEvaluator_Curve;
  BinMFunction: typeof BinMFunction;
  BinMFunction_FunctionDriver: typeof BinMFunction_FunctionDriver;
  Handle_BinMFunction_FunctionDriver: typeof Handle_BinMFunction_FunctionDriver;
  Handle_BinMFunction_FunctionDriver_1: typeof Handle_BinMFunction_FunctionDriver_1;
  Handle_BinMFunction_FunctionDriver_2: typeof Handle_BinMFunction_FunctionDriver_2;
  Handle_BinMFunction_FunctionDriver_3: typeof Handle_BinMFunction_FunctionDriver_3;
  Handle_BinMFunction_FunctionDriver_4: typeof Handle_BinMFunction_FunctionDriver_4;
  Handle_BinMFunction_GraphNodeDriver: typeof Handle_BinMFunction_GraphNodeDriver;
  Handle_BinMFunction_GraphNodeDriver_1: typeof Handle_BinMFunction_GraphNodeDriver_1;
  Handle_BinMFunction_GraphNodeDriver_2: typeof Handle_BinMFunction_GraphNodeDriver_2;
  Handle_BinMFunction_GraphNodeDriver_3: typeof Handle_BinMFunction_GraphNodeDriver_3;
  Handle_BinMFunction_GraphNodeDriver_4: typeof Handle_BinMFunction_GraphNodeDriver_4;
  BinMFunction_GraphNodeDriver: typeof BinMFunction_GraphNodeDriver;
  Handle_BinMFunction_ScopeDriver: typeof Handle_BinMFunction_ScopeDriver;
  Handle_BinMFunction_ScopeDriver_1: typeof Handle_BinMFunction_ScopeDriver_1;
  Handle_BinMFunction_ScopeDriver_2: typeof Handle_BinMFunction_ScopeDriver_2;
  Handle_BinMFunction_ScopeDriver_3: typeof Handle_BinMFunction_ScopeDriver_3;
  Handle_BinMFunction_ScopeDriver_4: typeof Handle_BinMFunction_ScopeDriver_4;
  BinMFunction_ScopeDriver: typeof BinMFunction_ScopeDriver;
  BRepPrimAPI_MakeHalfSpace: typeof BRepPrimAPI_MakeHalfSpace;
  BRepPrimAPI_MakeHalfSpace_1: typeof BRepPrimAPI_MakeHalfSpace_1;
  BRepPrimAPI_MakeHalfSpace_2: typeof BRepPrimAPI_MakeHalfSpace_2;
  BRepPrimAPI_MakeOneAxis: typeof BRepPrimAPI_MakeOneAxis;
  BRepPrimAPI_MakeWedge: typeof BRepPrimAPI_MakeWedge;
  BRepPrimAPI_MakeWedge_1: typeof BRepPrimAPI_MakeWedge_1;
  BRepPrimAPI_MakeWedge_2: typeof BRepPrimAPI_MakeWedge_2;
  BRepPrimAPI_MakeWedge_3: typeof BRepPrimAPI_MakeWedge_3;
  BRepPrimAPI_MakeWedge_4: typeof BRepPrimAPI_MakeWedge_4;
  BRepPrimAPI_MakeCylinder: typeof BRepPrimAPI_MakeCylinder;
  BRepPrimAPI_MakeCylinder_1: typeof BRepPrimAPI_MakeCylinder_1;
  BRepPrimAPI_MakeCylinder_2: typeof BRepPrimAPI_MakeCylinder_2;
  BRepPrimAPI_MakeCylinder_3: typeof BRepPrimAPI_MakeCylinder_3;
  BRepPrimAPI_MakeCylinder_4: typeof BRepPrimAPI_MakeCylinder_4;
  BRepPrimAPI_MakeRevol: typeof BRepPrimAPI_MakeRevol;
  BRepPrimAPI_MakeRevol_1: typeof BRepPrimAPI_MakeRevol_1;
  BRepPrimAPI_MakeRevol_2: typeof BRepPrimAPI_MakeRevol_2;
  BRepPrimAPI_MakeCone: typeof BRepPrimAPI_MakeCone;
  BRepPrimAPI_MakeCone_1: typeof BRepPrimAPI_MakeCone_1;
  BRepPrimAPI_MakeCone_2: typeof BRepPrimAPI_MakeCone_2;
  BRepPrimAPI_MakeCone_3: typeof BRepPrimAPI_MakeCone_3;
  BRepPrimAPI_MakeCone_4: typeof BRepPrimAPI_MakeCone_4;
  BRepPrimAPI_MakeTorus: typeof BRepPrimAPI_MakeTorus;
  BRepPrimAPI_MakeTorus_1: typeof BRepPrimAPI_MakeTorus_1;
  BRepPrimAPI_MakeTorus_2: typeof BRepPrimAPI_MakeTorus_2;
  BRepPrimAPI_MakeTorus_3: typeof BRepPrimAPI_MakeTorus_3;
  BRepPrimAPI_MakeTorus_4: typeof BRepPrimAPI_MakeTorus_4;
  BRepPrimAPI_MakeTorus_5: typeof BRepPrimAPI_MakeTorus_5;
  BRepPrimAPI_MakeTorus_6: typeof BRepPrimAPI_MakeTorus_6;
  BRepPrimAPI_MakeTorus_7: typeof BRepPrimAPI_MakeTorus_7;
  BRepPrimAPI_MakeTorus_8: typeof BRepPrimAPI_MakeTorus_8;
  BRepPrimAPI_MakeBox: typeof BRepPrimAPI_MakeBox;
  BRepPrimAPI_MakeBox_1: typeof BRepPrimAPI_MakeBox_1;
  BRepPrimAPI_MakeBox_2: typeof BRepPrimAPI_MakeBox_2;
  BRepPrimAPI_MakeBox_3: typeof BRepPrimAPI_MakeBox_3;
  BRepPrimAPI_MakeBox_4: typeof BRepPrimAPI_MakeBox_4;
  BRepPrimAPI_MakeBox_5: typeof BRepPrimAPI_MakeBox_5;
  BRepPrimAPI_MakePrism: typeof BRepPrimAPI_MakePrism;
  BRepPrimAPI_MakePrism_1: typeof BRepPrimAPI_MakePrism_1;
  BRepPrimAPI_MakePrism_2: typeof BRepPrimAPI_MakePrism_2;
  BRepPrimAPI_MakeSweep: typeof BRepPrimAPI_MakeSweep;
  BRepPrimAPI_MakeSphere: typeof BRepPrimAPI_MakeSphere;
  BRepPrimAPI_MakeSphere_1: typeof BRepPrimAPI_MakeSphere_1;
  BRepPrimAPI_MakeSphere_2: typeof BRepPrimAPI_MakeSphere_2;
  BRepPrimAPI_MakeSphere_3: typeof BRepPrimAPI_MakeSphere_3;
  BRepPrimAPI_MakeSphere_4: typeof BRepPrimAPI_MakeSphere_4;
  BRepPrimAPI_MakeSphere_5: typeof BRepPrimAPI_MakeSphere_5;
  BRepPrimAPI_MakeSphere_6: typeof BRepPrimAPI_MakeSphere_6;
  BRepPrimAPI_MakeSphere_7: typeof BRepPrimAPI_MakeSphere_7;
  BRepPrimAPI_MakeSphere_8: typeof BRepPrimAPI_MakeSphere_8;
  BRepPrimAPI_MakeSphere_9: typeof BRepPrimAPI_MakeSphere_9;
  BRepPrimAPI_MakeSphere_10: typeof BRepPrimAPI_MakeSphere_10;
  BRepPrimAPI_MakeSphere_11: typeof BRepPrimAPI_MakeSphere_11;
  BRepPrimAPI_MakeSphere_12: typeof BRepPrimAPI_MakeSphere_12;
  BRepPrimAPI_MakeRevolution: typeof BRepPrimAPI_MakeRevolution;
  BRepPrimAPI_MakeRevolution_1: typeof BRepPrimAPI_MakeRevolution_1;
  BRepPrimAPI_MakeRevolution_2: typeof BRepPrimAPI_MakeRevolution_2;
  BRepPrimAPI_MakeRevolution_3: typeof BRepPrimAPI_MakeRevolution_3;
  BRepPrimAPI_MakeRevolution_4: typeof BRepPrimAPI_MakeRevolution_4;
  BRepPrimAPI_MakeRevolution_5: typeof BRepPrimAPI_MakeRevolution_5;
  BRepPrimAPI_MakeRevolution_6: typeof BRepPrimAPI_MakeRevolution_6;
  BRepPrimAPI_MakeRevolution_7: typeof BRepPrimAPI_MakeRevolution_7;
  BRepPrimAPI_MakeRevolution_8: typeof BRepPrimAPI_MakeRevolution_8;
  CDM_ReferenceIterator: typeof CDM_ReferenceIterator;
  Handle_CDM_Reference: typeof Handle_CDM_Reference;
  Handle_CDM_Reference_1: typeof Handle_CDM_Reference_1;
  Handle_CDM_Reference_2: typeof Handle_CDM_Reference_2;
  Handle_CDM_Reference_3: typeof Handle_CDM_Reference_3;
  Handle_CDM_Reference_4: typeof Handle_CDM_Reference_4;
  CDM_Reference: typeof CDM_Reference;
  Handle_CDM_MetaData: typeof Handle_CDM_MetaData;
  Handle_CDM_MetaData_1: typeof Handle_CDM_MetaData_1;
  Handle_CDM_MetaData_2: typeof Handle_CDM_MetaData_2;
  Handle_CDM_MetaData_3: typeof Handle_CDM_MetaData_3;
  Handle_CDM_MetaData_4: typeof Handle_CDM_MetaData_4;
  CDM_MetaData: typeof CDM_MetaData;
  CDM_Document: typeof CDM_Document;
  Handle_CDM_Document: typeof Handle_CDM_Document;
  Handle_CDM_Document_1: typeof Handle_CDM_Document_1;
  Handle_CDM_Document_2: typeof Handle_CDM_Document_2;
  Handle_CDM_Document_3: typeof Handle_CDM_Document_3;
  Handle_CDM_Document_4: typeof Handle_CDM_Document_4;
  CDM_CanCloseStatus: CDM_CanCloseStatus;
  Handle_CDM_Application: typeof Handle_CDM_Application;
  Handle_CDM_Application_1: typeof Handle_CDM_Application_1;
  Handle_CDM_Application_2: typeof Handle_CDM_Application_2;
  Handle_CDM_Application_3: typeof Handle_CDM_Application_3;
  Handle_CDM_Application_4: typeof Handle_CDM_Application_4;
  CDM_Application: typeof CDM_Application;
  IGESAppli_FlowLineSpec: typeof IGESAppli_FlowLineSpec;
  Handle_IGESAppli_FlowLineSpec: typeof Handle_IGESAppli_FlowLineSpec;
  Handle_IGESAppli_FlowLineSpec_1: typeof Handle_IGESAppli_FlowLineSpec_1;
  Handle_IGESAppli_FlowLineSpec_2: typeof Handle_IGESAppli_FlowLineSpec_2;
  Handle_IGESAppli_FlowLineSpec_3: typeof Handle_IGESAppli_FlowLineSpec_3;
  Handle_IGESAppli_FlowLineSpec_4: typeof Handle_IGESAppli_FlowLineSpec_4;
  Handle_IGESAppli_PWBArtworkStackup: typeof Handle_IGESAppli_PWBArtworkStackup;
  Handle_IGESAppli_PWBArtworkStackup_1: typeof Handle_IGESAppli_PWBArtworkStackup_1;
  Handle_IGESAppli_PWBArtworkStackup_2: typeof Handle_IGESAppli_PWBArtworkStackup_2;
  Handle_IGESAppli_PWBArtworkStackup_3: typeof Handle_IGESAppli_PWBArtworkStackup_3;
  Handle_IGESAppli_PWBArtworkStackup_4: typeof Handle_IGESAppli_PWBArtworkStackup_4;
  IGESAppli_PWBArtworkStackup: typeof IGESAppli_PWBArtworkStackup;
  IGESAppli_ToolFlowLineSpec: typeof IGESAppli_ToolFlowLineSpec;
  Handle_IGESAppli_PipingFlow: typeof Handle_IGESAppli_PipingFlow;
  Handle_IGESAppli_PipingFlow_1: typeof Handle_IGESAppli_PipingFlow_1;
  Handle_IGESAppli_PipingFlow_2: typeof Handle_IGESAppli_PipingFlow_2;
  Handle_IGESAppli_PipingFlow_3: typeof Handle_IGESAppli_PipingFlow_3;
  Handle_IGESAppli_PipingFlow_4: typeof Handle_IGESAppli_PipingFlow_4;
  IGESAppli_PipingFlow: typeof IGESAppli_PipingFlow;
  Handle_IGESAppli_NodalConstraint: typeof Handle_IGESAppli_NodalConstraint;
  Handle_IGESAppli_NodalConstraint_1: typeof Handle_IGESAppli_NodalConstraint_1;
  Handle_IGESAppli_NodalConstraint_2: typeof Handle_IGESAppli_NodalConstraint_2;
  Handle_IGESAppli_NodalConstraint_3: typeof Handle_IGESAppli_NodalConstraint_3;
  Handle_IGESAppli_NodalConstraint_4: typeof Handle_IGESAppli_NodalConstraint_4;
  IGESAppli_NodalConstraint: typeof IGESAppli_NodalConstraint;
  IGESAppli_ToolDrilledHole: typeof IGESAppli_ToolDrilledHole;
  IGESAppli_ToolNodalDisplAndRot: typeof IGESAppli_ToolNodalDisplAndRot;
  Handle_IGESAppli_DrilledHole: typeof Handle_IGESAppli_DrilledHole;
  Handle_IGESAppli_DrilledHole_1: typeof Handle_IGESAppli_DrilledHole_1;
  Handle_IGESAppli_DrilledHole_2: typeof Handle_IGESAppli_DrilledHole_2;
  Handle_IGESAppli_DrilledHole_3: typeof Handle_IGESAppli_DrilledHole_3;
  Handle_IGESAppli_DrilledHole_4: typeof Handle_IGESAppli_DrilledHole_4;
  IGESAppli_DrilledHole: typeof IGESAppli_DrilledHole;
  IGESAppli_PartNumber: typeof IGESAppli_PartNumber;
  Handle_IGESAppli_PartNumber: typeof Handle_IGESAppli_PartNumber;
  Handle_IGESAppli_PartNumber_1: typeof Handle_IGESAppli_PartNumber_1;
  Handle_IGESAppli_PartNumber_2: typeof Handle_IGESAppli_PartNumber_2;
  Handle_IGESAppli_PartNumber_3: typeof Handle_IGESAppli_PartNumber_3;
  Handle_IGESAppli_PartNumber_4: typeof Handle_IGESAppli_PartNumber_4;
  Handle_IGESAppli_HArray1OfNode: typeof Handle_IGESAppli_HArray1OfNode;
  Handle_IGESAppli_HArray1OfNode_1: typeof Handle_IGESAppli_HArray1OfNode_1;
  Handle_IGESAppli_HArray1OfNode_2: typeof Handle_IGESAppli_HArray1OfNode_2;
  Handle_IGESAppli_HArray1OfNode_3: typeof Handle_IGESAppli_HArray1OfNode_3;
  Handle_IGESAppli_HArray1OfNode_4: typeof Handle_IGESAppli_HArray1OfNode_4;
  IGESAppli_ToolNodalResults: typeof IGESAppli_ToolNodalResults;
  Handle_IGESAppli_Flow: typeof Handle_IGESAppli_Flow;
  Handle_IGESAppli_Flow_1: typeof Handle_IGESAppli_Flow_1;
  Handle_IGESAppli_Flow_2: typeof Handle_IGESAppli_Flow_2;
  Handle_IGESAppli_Flow_3: typeof Handle_IGESAppli_Flow_3;
  Handle_IGESAppli_Flow_4: typeof Handle_IGESAppli_Flow_4;
  IGESAppli_Flow: typeof IGESAppli_Flow;
  Handle_IGESAppli_RegionRestriction: typeof Handle_IGESAppli_RegionRestriction;
  Handle_IGESAppli_RegionRestriction_1: typeof Handle_IGESAppli_RegionRestriction_1;
  Handle_IGESAppli_RegionRestriction_2: typeof Handle_IGESAppli_RegionRestriction_2;
  Handle_IGESAppli_RegionRestriction_3: typeof Handle_IGESAppli_RegionRestriction_3;
  Handle_IGESAppli_RegionRestriction_4: typeof Handle_IGESAppli_RegionRestriction_4;
  IGESAppli_RegionRestriction: typeof IGESAppli_RegionRestriction;
  IGESAppli_ToolPartNumber: typeof IGESAppli_ToolPartNumber;
  Handle_IGESAppli_LevelFunction: typeof Handle_IGESAppli_LevelFunction;
  Handle_IGESAppli_LevelFunction_1: typeof Handle_IGESAppli_LevelFunction_1;
  Handle_IGESAppli_LevelFunction_2: typeof Handle_IGESAppli_LevelFunction_2;
  Handle_IGESAppli_LevelFunction_3: typeof Handle_IGESAppli_LevelFunction_3;
  Handle_IGESAppli_LevelFunction_4: typeof Handle_IGESAppli_LevelFunction_4;
  IGESAppli_LevelFunction: typeof IGESAppli_LevelFunction;
  IGESAppli_PinNumber: typeof IGESAppli_PinNumber;
  Handle_IGESAppli_PinNumber: typeof Handle_IGESAppli_PinNumber;
  Handle_IGESAppli_PinNumber_1: typeof Handle_IGESAppli_PinNumber_1;
  Handle_IGESAppli_PinNumber_2: typeof Handle_IGESAppli_PinNumber_2;
  Handle_IGESAppli_PinNumber_3: typeof Handle_IGESAppli_PinNumber_3;
  Handle_IGESAppli_PinNumber_4: typeof Handle_IGESAppli_PinNumber_4;
  Handle_IGESAppli_NodalResults: typeof Handle_IGESAppli_NodalResults;
  Handle_IGESAppli_NodalResults_1: typeof Handle_IGESAppli_NodalResults_1;
  Handle_IGESAppli_NodalResults_2: typeof Handle_IGESAppli_NodalResults_2;
  Handle_IGESAppli_NodalResults_3: typeof Handle_IGESAppli_NodalResults_3;
  Handle_IGESAppli_NodalResults_4: typeof Handle_IGESAppli_NodalResults_4;
  IGESAppli_NodalResults: typeof IGESAppli_NodalResults;
  Handle_IGESAppli_ReadWriteModule: typeof Handle_IGESAppli_ReadWriteModule;
  Handle_IGESAppli_ReadWriteModule_1: typeof Handle_IGESAppli_ReadWriteModule_1;
  Handle_IGESAppli_ReadWriteModule_2: typeof Handle_IGESAppli_ReadWriteModule_2;
  Handle_IGESAppli_ReadWriteModule_3: typeof Handle_IGESAppli_ReadWriteModule_3;
  Handle_IGESAppli_ReadWriteModule_4: typeof Handle_IGESAppli_ReadWriteModule_4;
  IGESAppli_ReadWriteModule: typeof IGESAppli_ReadWriteModule;
  IGESAppli_LevelToPWBLayerMap: typeof IGESAppli_LevelToPWBLayerMap;
  Handle_IGESAppli_LevelToPWBLayerMap: typeof Handle_IGESAppli_LevelToPWBLayerMap;
  Handle_IGESAppli_LevelToPWBLayerMap_1: typeof Handle_IGESAppli_LevelToPWBLayerMap_1;
  Handle_IGESAppli_LevelToPWBLayerMap_2: typeof Handle_IGESAppli_LevelToPWBLayerMap_2;
  Handle_IGESAppli_LevelToPWBLayerMap_3: typeof Handle_IGESAppli_LevelToPWBLayerMap_3;
  Handle_IGESAppli_LevelToPWBLayerMap_4: typeof Handle_IGESAppli_LevelToPWBLayerMap_4;
  IGESAppli_GeneralModule: typeof IGESAppli_GeneralModule;
  Handle_IGESAppli_GeneralModule: typeof Handle_IGESAppli_GeneralModule;
  Handle_IGESAppli_GeneralModule_1: typeof Handle_IGESAppli_GeneralModule_1;
  Handle_IGESAppli_GeneralModule_2: typeof Handle_IGESAppli_GeneralModule_2;
  Handle_IGESAppli_GeneralModule_3: typeof Handle_IGESAppli_GeneralModule_3;
  Handle_IGESAppli_GeneralModule_4: typeof Handle_IGESAppli_GeneralModule_4;
  IGESAppli_ToolPWBDrilledHole: typeof IGESAppli_ToolPWBDrilledHole;
  IGESAppli_ToolFiniteElement: typeof IGESAppli_ToolFiniteElement;
  IGESAppli_ToolNode: typeof IGESAppli_ToolNode;
  Handle_IGESAppli_HArray1OfFlow: typeof Handle_IGESAppli_HArray1OfFlow;
  Handle_IGESAppli_HArray1OfFlow_1: typeof Handle_IGESAppli_HArray1OfFlow_1;
  Handle_IGESAppli_HArray1OfFlow_2: typeof Handle_IGESAppli_HArray1OfFlow_2;
  Handle_IGESAppli_HArray1OfFlow_3: typeof Handle_IGESAppli_HArray1OfFlow_3;
  Handle_IGESAppli_HArray1OfFlow_4: typeof Handle_IGESAppli_HArray1OfFlow_4;
  IGESAppli_ToolReferenceDesignator: typeof IGESAppli_ToolReferenceDesignator;
  IGESAppli_ToolElementResults: typeof IGESAppli_ToolElementResults;
  Handle_IGESAppli_ElementResults: typeof Handle_IGESAppli_ElementResults;
  Handle_IGESAppli_ElementResults_1: typeof Handle_IGESAppli_ElementResults_1;
  Handle_IGESAppli_ElementResults_2: typeof Handle_IGESAppli_ElementResults_2;
  Handle_IGESAppli_ElementResults_3: typeof Handle_IGESAppli_ElementResults_3;
  Handle_IGESAppli_ElementResults_4: typeof Handle_IGESAppli_ElementResults_4;
  IGESAppli_ElementResults: typeof IGESAppli_ElementResults;
  IGESAppli_ToolLevelFunction: typeof IGESAppli_ToolLevelFunction;
  IGESAppli_ToolLevelToPWBLayerMap: typeof IGESAppli_ToolLevelToPWBLayerMap;
  IGESAppli: typeof IGESAppli;
  IGESAppli_NodalDisplAndRot: typeof IGESAppli_NodalDisplAndRot;
  Handle_IGESAppli_NodalDisplAndRot: typeof Handle_IGESAppli_NodalDisplAndRot;
  Handle_IGESAppli_NodalDisplAndRot_1: typeof Handle_IGESAppli_NodalDisplAndRot_1;
  Handle_IGESAppli_NodalDisplAndRot_2: typeof Handle_IGESAppli_NodalDisplAndRot_2;
  Handle_IGESAppli_NodalDisplAndRot_3: typeof Handle_IGESAppli_NodalDisplAndRot_3;
  Handle_IGESAppli_NodalDisplAndRot_4: typeof Handle_IGESAppli_NodalDisplAndRot_4;
  IGESAppli_ToolPinNumber: typeof IGESAppli_ToolPinNumber;
  IGESAppli_ToolPipingFlow: typeof IGESAppli_ToolPipingFlow;
  IGESAppli_ReferenceDesignator: typeof IGESAppli_ReferenceDesignator;
  Handle_IGESAppli_ReferenceDesignator: typeof Handle_IGESAppli_ReferenceDesignator;
  Handle_IGESAppli_ReferenceDesignator_1: typeof Handle_IGESAppli_ReferenceDesignator_1;
  Handle_IGESAppli_ReferenceDesignator_2: typeof Handle_IGESAppli_ReferenceDesignator_2;
  Handle_IGESAppli_ReferenceDesignator_3: typeof Handle_IGESAppli_ReferenceDesignator_3;
  Handle_IGESAppli_ReferenceDesignator_4: typeof Handle_IGESAppli_ReferenceDesignator_4;
  IGESAppli_ToolPWBArtworkStackup: typeof IGESAppli_ToolPWBArtworkStackup;
  Handle_IGESAppli_SpecificModule: typeof Handle_IGESAppli_SpecificModule;
  Handle_IGESAppli_SpecificModule_1: typeof Handle_IGESAppli_SpecificModule_1;
  Handle_IGESAppli_SpecificModule_2: typeof Handle_IGESAppli_SpecificModule_2;
  Handle_IGESAppli_SpecificModule_3: typeof Handle_IGESAppli_SpecificModule_3;
  Handle_IGESAppli_SpecificModule_4: typeof Handle_IGESAppli_SpecificModule_4;
  IGESAppli_SpecificModule: typeof IGESAppli_SpecificModule;
  Handle_IGESAppli_FiniteElement: typeof Handle_IGESAppli_FiniteElement;
  Handle_IGESAppli_FiniteElement_1: typeof Handle_IGESAppli_FiniteElement_1;
  Handle_IGESAppli_FiniteElement_2: typeof Handle_IGESAppli_FiniteElement_2;
  Handle_IGESAppli_FiniteElement_3: typeof Handle_IGESAppli_FiniteElement_3;
  Handle_IGESAppli_FiniteElement_4: typeof Handle_IGESAppli_FiniteElement_4;
  IGESAppli_FiniteElement: typeof IGESAppli_FiniteElement;
  Handle_IGESAppli_Protocol: typeof Handle_IGESAppli_Protocol;
  Handle_IGESAppli_Protocol_1: typeof Handle_IGESAppli_Protocol_1;
  Handle_IGESAppli_Protocol_2: typeof Handle_IGESAppli_Protocol_2;
  Handle_IGESAppli_Protocol_3: typeof Handle_IGESAppli_Protocol_3;
  Handle_IGESAppli_Protocol_4: typeof Handle_IGESAppli_Protocol_4;
  IGESAppli_Protocol: typeof IGESAppli_Protocol;
  Handle_IGESAppli_HArray1OfFiniteElement: typeof Handle_IGESAppli_HArray1OfFiniteElement;
  Handle_IGESAppli_HArray1OfFiniteElement_1: typeof Handle_IGESAppli_HArray1OfFiniteElement_1;
  Handle_IGESAppli_HArray1OfFiniteElement_2: typeof Handle_IGESAppli_HArray1OfFiniteElement_2;
  Handle_IGESAppli_HArray1OfFiniteElement_3: typeof Handle_IGESAppli_HArray1OfFiniteElement_3;
  Handle_IGESAppli_HArray1OfFiniteElement_4: typeof Handle_IGESAppli_HArray1OfFiniteElement_4;
  IGESAppli_ToolRegionRestriction: typeof IGESAppli_ToolRegionRestriction;
  IGESAppli_ToolFlow: typeof IGESAppli_ToolFlow;
  IGESAppli_Node: typeof IGESAppli_Node;
  Handle_IGESAppli_Node: typeof Handle_IGESAppli_Node;
  Handle_IGESAppli_Node_1: typeof Handle_IGESAppli_Node_1;
  Handle_IGESAppli_Node_2: typeof Handle_IGESAppli_Node_2;
  Handle_IGESAppli_Node_3: typeof Handle_IGESAppli_Node_3;
  Handle_IGESAppli_Node_4: typeof Handle_IGESAppli_Node_4;
  IGESAppli_ToolLineWidening: typeof IGESAppli_ToolLineWidening;
  IGESAppli_ToolNodalConstraint: typeof IGESAppli_ToolNodalConstraint;
  IGESAppli_PWBDrilledHole: typeof IGESAppli_PWBDrilledHole;
  Handle_IGESAppli_PWBDrilledHole: typeof Handle_IGESAppli_PWBDrilledHole;
  Handle_IGESAppli_PWBDrilledHole_1: typeof Handle_IGESAppli_PWBDrilledHole_1;
  Handle_IGESAppli_PWBDrilledHole_2: typeof Handle_IGESAppli_PWBDrilledHole_2;
  Handle_IGESAppli_PWBDrilledHole_3: typeof Handle_IGESAppli_PWBDrilledHole_3;
  Handle_IGESAppli_PWBDrilledHole_4: typeof Handle_IGESAppli_PWBDrilledHole_4;
  IGESAppli_LineWidening: typeof IGESAppli_LineWidening;
  Handle_IGESAppli_LineWidening: typeof Handle_IGESAppli_LineWidening;
  Handle_IGESAppli_LineWidening_1: typeof Handle_IGESAppli_LineWidening_1;
  Handle_IGESAppli_LineWidening_2: typeof Handle_IGESAppli_LineWidening_2;
  Handle_IGESAppli_LineWidening_3: typeof Handle_IGESAppli_LineWidening_3;
  Handle_IGESAppli_LineWidening_4: typeof Handle_IGESAppli_LineWidening_4;
  TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo: typeof TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo;
  TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_1: typeof TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_1;
  TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_2: typeof TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_2;
  TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_3: typeof TopOpeBRepBuild_IndexedDataMapOfShapeVertexInfo_3;
  TopOpeBRepBuild_HBuilder: typeof TopOpeBRepBuild_HBuilder;
  Handle_TopOpeBRepBuild_HBuilder: typeof Handle_TopOpeBRepBuild_HBuilder;
  Handle_TopOpeBRepBuild_HBuilder_1: typeof Handle_TopOpeBRepBuild_HBuilder_1;
  Handle_TopOpeBRepBuild_HBuilder_2: typeof Handle_TopOpeBRepBuild_HBuilder_2;
  Handle_TopOpeBRepBuild_HBuilder_3: typeof Handle_TopOpeBRepBuild_HBuilder_3;
  Handle_TopOpeBRepBuild_HBuilder_4: typeof Handle_TopOpeBRepBuild_HBuilder_4;
  TopOpeBRepBuild_WireEdgeSet: typeof TopOpeBRepBuild_WireEdgeSet;
  TopOpeBRepBuild_Area3dBuilder: typeof TopOpeBRepBuild_Area3dBuilder;
  TopOpeBRepBuild_Area3dBuilder_1: typeof TopOpeBRepBuild_Area3dBuilder_1;
  TopOpeBRepBuild_Area3dBuilder_2: typeof TopOpeBRepBuild_Area3dBuilder_2;
  TopOpeBRepBuild_Area1dBuilder: typeof TopOpeBRepBuild_Area1dBuilder;
  TopOpeBRepBuild_Area1dBuilder_1: typeof TopOpeBRepBuild_Area1dBuilder_1;
  TopOpeBRepBuild_Area1dBuilder_2: typeof TopOpeBRepBuild_Area1dBuilder_2;
  TopOpeBRepBuild_BlockIterator: typeof TopOpeBRepBuild_BlockIterator;
  TopOpeBRepBuild_BlockIterator_1: typeof TopOpeBRepBuild_BlockIterator_1;
  TopOpeBRepBuild_BlockIterator_2: typeof TopOpeBRepBuild_BlockIterator_2;
  TopOpeBRepBuild_LoopClassifier: typeof TopOpeBRepBuild_LoopClassifier;
  TopOpeBRepBuild_BlockBuilder: typeof TopOpeBRepBuild_BlockBuilder;
  TopOpeBRepBuild_BlockBuilder_1: typeof TopOpeBRepBuild_BlockBuilder_1;
  TopOpeBRepBuild_BlockBuilder_2: typeof TopOpeBRepBuild_BlockBuilder_2;
  TopOpeBRepBuild_VertexInfo: typeof TopOpeBRepBuild_VertexInfo;
  TopOpeBRepBuild_GTopo: typeof TopOpeBRepBuild_GTopo;
  TopOpeBRepBuild_GTopo_1: typeof TopOpeBRepBuild_GTopo_1;
  TopOpeBRepBuild_GTopo_2: typeof TopOpeBRepBuild_GTopo_2;
  TopOpeBRepBuild_ShellToSolid: typeof TopOpeBRepBuild_ShellToSolid;
  TopOpeBRepBuild_WireEdgeClassifier: typeof TopOpeBRepBuild_WireEdgeClassifier;
  TopOpeBRepBuild_FaceBuilder: typeof TopOpeBRepBuild_FaceBuilder;
  TopOpeBRepBuild_FaceBuilder_1: typeof TopOpeBRepBuild_FaceBuilder_1;
  TopOpeBRepBuild_FaceBuilder_2: typeof TopOpeBRepBuild_FaceBuilder_2;
  TopOpeBRepBuild_GTool: typeof TopOpeBRepBuild_GTool;
  TopOpeBRepBuild_BuilderON: typeof TopOpeBRepBuild_BuilderON;
  TopOpeBRepBuild_BuilderON_1: typeof TopOpeBRepBuild_BuilderON_1;
  TopOpeBRepBuild_BuilderON_2: typeof TopOpeBRepBuild_BuilderON_2;
  TopOpeBRepBuild_Tools2d: typeof TopOpeBRepBuild_Tools2d;
  TopOpeBRepBuild_FaceAreaBuilder: typeof TopOpeBRepBuild_FaceAreaBuilder;
  TopOpeBRepBuild_FaceAreaBuilder_1: typeof TopOpeBRepBuild_FaceAreaBuilder_1;
  TopOpeBRepBuild_FaceAreaBuilder_2: typeof TopOpeBRepBuild_FaceAreaBuilder_2;
  TopOpeBRepBuild_CorrectFace2d: typeof TopOpeBRepBuild_CorrectFace2d;
  TopOpeBRepBuild_CorrectFace2d_1: typeof TopOpeBRepBuild_CorrectFace2d_1;
  TopOpeBRepBuild_CorrectFace2d_2: typeof TopOpeBRepBuild_CorrectFace2d_2;
  TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape: typeof TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape;
  TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_1: typeof TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_1;
  TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_2: typeof TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_2;
  TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_3: typeof TopOpeBRepBuild_DataMapOfShapeListOfShapeListOfShape_3;
  TopOpeBRepBuild_EdgeBuilder: typeof TopOpeBRepBuild_EdgeBuilder;
  TopOpeBRepBuild_EdgeBuilder_1: typeof TopOpeBRepBuild_EdgeBuilder_1;
  TopOpeBRepBuild_EdgeBuilder_2: typeof TopOpeBRepBuild_EdgeBuilder_2;
  TopOpeBRepBuild_ShellFaceClassifier: typeof TopOpeBRepBuild_ShellFaceClassifier;
  TopOpeBRepBuild_CompositeClassifier: typeof TopOpeBRepBuild_CompositeClassifier;
  TopOpeBRepBuild_ListOfShapeListOfShape: typeof TopOpeBRepBuild_ListOfShapeListOfShape;
  TopOpeBRepBuild_ListOfShapeListOfShape_1: typeof TopOpeBRepBuild_ListOfShapeListOfShape_1;
  TopOpeBRepBuild_ListOfShapeListOfShape_2: typeof TopOpeBRepBuild_ListOfShapeListOfShape_2;
  TopOpeBRepBuild_ListOfShapeListOfShape_3: typeof TopOpeBRepBuild_ListOfShapeListOfShape_3;
  TopOpeBRepBuild_Tools: typeof TopOpeBRepBuild_Tools;
  TopOpeBRepBuild_LoopSet: typeof TopOpeBRepBuild_LoopSet;
  TopOpeBRepBuild_SolidAreaBuilder: typeof TopOpeBRepBuild_SolidAreaBuilder;
  TopOpeBRepBuild_SolidAreaBuilder_1: typeof TopOpeBRepBuild_SolidAreaBuilder_1;
  TopOpeBRepBuild_SolidAreaBuilder_2: typeof TopOpeBRepBuild_SolidAreaBuilder_2;
  TopOpeBRepBuild_GIter: typeof TopOpeBRepBuild_GIter;
  TopOpeBRepBuild_GIter_1: typeof TopOpeBRepBuild_GIter_1;
  TopOpeBRepBuild_GIter_2: typeof TopOpeBRepBuild_GIter_2;
  TopOpeBRepBuild_FuseFace: typeof TopOpeBRepBuild_FuseFace;
  TopOpeBRepBuild_FuseFace_1: typeof TopOpeBRepBuild_FuseFace_1;
  TopOpeBRepBuild_FuseFace_2: typeof TopOpeBRepBuild_FuseFace_2;
  TopOpeBRepBuild_LoopEnum: TopOpeBRepBuild_LoopEnum;
  TopOpeBRepBuild_WireToFace: typeof TopOpeBRepBuild_WireToFace;
  Handle_TopOpeBRepBuild_Loop: typeof Handle_TopOpeBRepBuild_Loop;
  Handle_TopOpeBRepBuild_Loop_1: typeof Handle_TopOpeBRepBuild_Loop_1;
  Handle_TopOpeBRepBuild_Loop_2: typeof Handle_TopOpeBRepBuild_Loop_2;
  Handle_TopOpeBRepBuild_Loop_3: typeof Handle_TopOpeBRepBuild_Loop_3;
  Handle_TopOpeBRepBuild_Loop_4: typeof Handle_TopOpeBRepBuild_Loop_4;
  TopOpeBRepBuild_Loop: typeof TopOpeBRepBuild_Loop;
  TopOpeBRepBuild_Loop_1: typeof TopOpeBRepBuild_Loop_1;
  TopOpeBRepBuild_Loop_2: typeof TopOpeBRepBuild_Loop_2;
  TopOpeBRepBuild_AreaBuilder: typeof TopOpeBRepBuild_AreaBuilder;
  TopOpeBRepBuild_AreaBuilder_1: typeof TopOpeBRepBuild_AreaBuilder_1;
  TopOpeBRepBuild_AreaBuilder_2: typeof TopOpeBRepBuild_AreaBuilder_2;
  TopOpeBRepBuild_Area2dBuilder: typeof TopOpeBRepBuild_Area2dBuilder;
  TopOpeBRepBuild_Area2dBuilder_1: typeof TopOpeBRepBuild_Area2dBuilder_1;
  TopOpeBRepBuild_Area2dBuilder_2: typeof TopOpeBRepBuild_Area2dBuilder_2;
  TopOpeBRepBuild_ShapeListOfShape: typeof TopOpeBRepBuild_ShapeListOfShape;
  TopOpeBRepBuild_ShapeListOfShape_1: typeof TopOpeBRepBuild_ShapeListOfShape_1;
  TopOpeBRepBuild_ShapeListOfShape_2: typeof TopOpeBRepBuild_ShapeListOfShape_2;
  TopOpeBRepBuild_ShapeListOfShape_3: typeof TopOpeBRepBuild_ShapeListOfShape_3;
  TopOpeBRepBuild_ListOfListOfLoop: typeof TopOpeBRepBuild_ListOfListOfLoop;
  TopOpeBRepBuild_ListOfListOfLoop_1: typeof TopOpeBRepBuild_ListOfListOfLoop_1;
  TopOpeBRepBuild_ListOfListOfLoop_2: typeof TopOpeBRepBuild_ListOfListOfLoop_2;
  TopOpeBRepBuild_ListOfListOfLoop_3: typeof TopOpeBRepBuild_ListOfListOfLoop_3;
  TopOpeBRepBuild_ShapeSet: typeof TopOpeBRepBuild_ShapeSet;
  TopOpeBRepBuild_SolidBuilder: typeof TopOpeBRepBuild_SolidBuilder;
  TopOpeBRepBuild_SolidBuilder_1: typeof TopOpeBRepBuild_SolidBuilder_1;
  TopOpeBRepBuild_SolidBuilder_2: typeof TopOpeBRepBuild_SolidBuilder_2;
  Handle_TopOpeBRepBuild_Pave: typeof Handle_TopOpeBRepBuild_Pave;
  Handle_TopOpeBRepBuild_Pave_1: typeof Handle_TopOpeBRepBuild_Pave_1;
  Handle_TopOpeBRepBuild_Pave_2: typeof Handle_TopOpeBRepBuild_Pave_2;
  Handle_TopOpeBRepBuild_Pave_3: typeof Handle_TopOpeBRepBuild_Pave_3;
  Handle_TopOpeBRepBuild_Pave_4: typeof Handle_TopOpeBRepBuild_Pave_4;
  TopOpeBRepBuild_Pave: typeof TopOpeBRepBuild_Pave;
  TopOpeBRepBuild_ShellFaceSet: typeof TopOpeBRepBuild_ShellFaceSet;
  TopOpeBRepBuild_ShellFaceSet_1: typeof TopOpeBRepBuild_ShellFaceSet_1;
  TopOpeBRepBuild_ShellFaceSet_2: typeof TopOpeBRepBuild_ShellFaceSet_2;
  TopOpeBRepBuild_PaveClassifier: typeof TopOpeBRepBuild_PaveClassifier;
  TopOpeBRepBuild_PaveSet: typeof TopOpeBRepBuild_PaveSet;
  XmlMXCAFDoc_VisMaterialDriver: typeof XmlMXCAFDoc_VisMaterialDriver;
  Handle_XmlMXCAFDoc_VisMaterialDriver: typeof Handle_XmlMXCAFDoc_VisMaterialDriver;
  Handle_XmlMXCAFDoc_VisMaterialDriver_1: typeof Handle_XmlMXCAFDoc_VisMaterialDriver_1;
  Handle_XmlMXCAFDoc_VisMaterialDriver_2: typeof Handle_XmlMXCAFDoc_VisMaterialDriver_2;
  Handle_XmlMXCAFDoc_VisMaterialDriver_3: typeof Handle_XmlMXCAFDoc_VisMaterialDriver_3;
  Handle_XmlMXCAFDoc_VisMaterialDriver_4: typeof Handle_XmlMXCAFDoc_VisMaterialDriver_4;
  XmlMXCAFDoc: typeof XmlMXCAFDoc;
  Handle_XmlMXCAFDoc_AssemblyItemRefDriver: typeof Handle_XmlMXCAFDoc_AssemblyItemRefDriver;
  Handle_XmlMXCAFDoc_AssemblyItemRefDriver_1: typeof Handle_XmlMXCAFDoc_AssemblyItemRefDriver_1;
  Handle_XmlMXCAFDoc_AssemblyItemRefDriver_2: typeof Handle_XmlMXCAFDoc_AssemblyItemRefDriver_2;
  Handle_XmlMXCAFDoc_AssemblyItemRefDriver_3: typeof Handle_XmlMXCAFDoc_AssemblyItemRefDriver_3;
  Handle_XmlMXCAFDoc_AssemblyItemRefDriver_4: typeof Handle_XmlMXCAFDoc_AssemblyItemRefDriver_4;
  XmlMXCAFDoc_AssemblyItemRefDriver: typeof XmlMXCAFDoc_AssemblyItemRefDriver;
  Handle_XmlMXCAFDoc_VisMaterialToolDriver: typeof Handle_XmlMXCAFDoc_VisMaterialToolDriver;
  Handle_XmlMXCAFDoc_VisMaterialToolDriver_1: typeof Handle_XmlMXCAFDoc_VisMaterialToolDriver_1;
  Handle_XmlMXCAFDoc_VisMaterialToolDriver_2: typeof Handle_XmlMXCAFDoc_VisMaterialToolDriver_2;
  Handle_XmlMXCAFDoc_VisMaterialToolDriver_3: typeof Handle_XmlMXCAFDoc_VisMaterialToolDriver_3;
  Handle_XmlMXCAFDoc_VisMaterialToolDriver_4: typeof Handle_XmlMXCAFDoc_VisMaterialToolDriver_4;
  XmlMXCAFDoc_VisMaterialToolDriver: typeof XmlMXCAFDoc_VisMaterialToolDriver;
  XmlMXCAFDoc_DatumDriver: typeof XmlMXCAFDoc_DatumDriver;
  Handle_XmlMXCAFDoc_DatumDriver: typeof Handle_XmlMXCAFDoc_DatumDriver;
  Handle_XmlMXCAFDoc_DatumDriver_1: typeof Handle_XmlMXCAFDoc_DatumDriver_1;
  Handle_XmlMXCAFDoc_DatumDriver_2: typeof Handle_XmlMXCAFDoc_DatumDriver_2;
  Handle_XmlMXCAFDoc_DatumDriver_3: typeof Handle_XmlMXCAFDoc_DatumDriver_3;
  Handle_XmlMXCAFDoc_DatumDriver_4: typeof Handle_XmlMXCAFDoc_DatumDriver_4;
  XmlMXCAFDoc_NoteBinDataDriver: typeof XmlMXCAFDoc_NoteBinDataDriver;
  Handle_XmlMXCAFDoc_NoteBinDataDriver: typeof Handle_XmlMXCAFDoc_NoteBinDataDriver;
  Handle_XmlMXCAFDoc_NoteBinDataDriver_1: typeof Handle_XmlMXCAFDoc_NoteBinDataDriver_1;
  Handle_XmlMXCAFDoc_NoteBinDataDriver_2: typeof Handle_XmlMXCAFDoc_NoteBinDataDriver_2;
  Handle_XmlMXCAFDoc_NoteBinDataDriver_3: typeof Handle_XmlMXCAFDoc_NoteBinDataDriver_3;
  Handle_XmlMXCAFDoc_NoteBinDataDriver_4: typeof Handle_XmlMXCAFDoc_NoteBinDataDriver_4;
  XmlMXCAFDoc_NoteCommentDriver: typeof XmlMXCAFDoc_NoteCommentDriver;
  Handle_XmlMXCAFDoc_NoteCommentDriver: typeof Handle_XmlMXCAFDoc_NoteCommentDriver;
  Handle_XmlMXCAFDoc_NoteCommentDriver_1: typeof Handle_XmlMXCAFDoc_NoteCommentDriver_1;
  Handle_XmlMXCAFDoc_NoteCommentDriver_2: typeof Handle_XmlMXCAFDoc_NoteCommentDriver_2;
  Handle_XmlMXCAFDoc_NoteCommentDriver_3: typeof Handle_XmlMXCAFDoc_NoteCommentDriver_3;
  Handle_XmlMXCAFDoc_NoteCommentDriver_4: typeof Handle_XmlMXCAFDoc_NoteCommentDriver_4;
  Handle_XmlMXCAFDoc_GraphNodeDriver: typeof Handle_XmlMXCAFDoc_GraphNodeDriver;
  Handle_XmlMXCAFDoc_GraphNodeDriver_1: typeof Handle_XmlMXCAFDoc_GraphNodeDriver_1;
  Handle_XmlMXCAFDoc_GraphNodeDriver_2: typeof Handle_XmlMXCAFDoc_GraphNodeDriver_2;
  Handle_XmlMXCAFDoc_GraphNodeDriver_3: typeof Handle_XmlMXCAFDoc_GraphNodeDriver_3;
  Handle_XmlMXCAFDoc_GraphNodeDriver_4: typeof Handle_XmlMXCAFDoc_GraphNodeDriver_4;
  XmlMXCAFDoc_GraphNodeDriver: typeof XmlMXCAFDoc_GraphNodeDriver;
  XmlMXCAFDoc_NoteDriver: typeof XmlMXCAFDoc_NoteDriver;
  Handle_XmlMXCAFDoc_NoteDriver: typeof Handle_XmlMXCAFDoc_NoteDriver;
  Handle_XmlMXCAFDoc_NoteDriver_1: typeof Handle_XmlMXCAFDoc_NoteDriver_1;
  Handle_XmlMXCAFDoc_NoteDriver_2: typeof Handle_XmlMXCAFDoc_NoteDriver_2;
  Handle_XmlMXCAFDoc_NoteDriver_3: typeof Handle_XmlMXCAFDoc_NoteDriver_3;
  Handle_XmlMXCAFDoc_NoteDriver_4: typeof Handle_XmlMXCAFDoc_NoteDriver_4;
  XmlMXCAFDoc_MaterialDriver: typeof XmlMXCAFDoc_MaterialDriver;
  Handle_XmlMXCAFDoc_MaterialDriver: typeof Handle_XmlMXCAFDoc_MaterialDriver;
  Handle_XmlMXCAFDoc_MaterialDriver_1: typeof Handle_XmlMXCAFDoc_MaterialDriver_1;
  Handle_XmlMXCAFDoc_MaterialDriver_2: typeof Handle_XmlMXCAFDoc_MaterialDriver_2;
  Handle_XmlMXCAFDoc_MaterialDriver_3: typeof Handle_XmlMXCAFDoc_MaterialDriver_3;
  Handle_XmlMXCAFDoc_MaterialDriver_4: typeof Handle_XmlMXCAFDoc_MaterialDriver_4;
  XmlMXCAFDoc_ColorDriver: typeof XmlMXCAFDoc_ColorDriver;
  Handle_XmlMXCAFDoc_ColorDriver: typeof Handle_XmlMXCAFDoc_ColorDriver;
  Handle_XmlMXCAFDoc_ColorDriver_1: typeof Handle_XmlMXCAFDoc_ColorDriver_1;
  Handle_XmlMXCAFDoc_ColorDriver_2: typeof Handle_XmlMXCAFDoc_ColorDriver_2;
  Handle_XmlMXCAFDoc_ColorDriver_3: typeof Handle_XmlMXCAFDoc_ColorDriver_3;
  Handle_XmlMXCAFDoc_ColorDriver_4: typeof Handle_XmlMXCAFDoc_ColorDriver_4;
  XmlMXCAFDoc_LocationDriver: typeof XmlMXCAFDoc_LocationDriver;
  Handle_XmlMXCAFDoc_LocationDriver: typeof Handle_XmlMXCAFDoc_LocationDriver;
  Handle_XmlMXCAFDoc_LocationDriver_1: typeof Handle_XmlMXCAFDoc_LocationDriver_1;
  Handle_XmlMXCAFDoc_LocationDriver_2: typeof Handle_XmlMXCAFDoc_LocationDriver_2;
  Handle_XmlMXCAFDoc_LocationDriver_3: typeof Handle_XmlMXCAFDoc_LocationDriver_3;
  Handle_XmlMXCAFDoc_LocationDriver_4: typeof Handle_XmlMXCAFDoc_LocationDriver_4;
  Handle_XmlMXCAFDoc_CentroidDriver: typeof Handle_XmlMXCAFDoc_CentroidDriver;
  Handle_XmlMXCAFDoc_CentroidDriver_1: typeof Handle_XmlMXCAFDoc_CentroidDriver_1;
  Handle_XmlMXCAFDoc_CentroidDriver_2: typeof Handle_XmlMXCAFDoc_CentroidDriver_2;
  Handle_XmlMXCAFDoc_CentroidDriver_3: typeof Handle_XmlMXCAFDoc_CentroidDriver_3;
  Handle_XmlMXCAFDoc_CentroidDriver_4: typeof Handle_XmlMXCAFDoc_CentroidDriver_4;
  XmlMXCAFDoc_CentroidDriver: typeof XmlMXCAFDoc_CentroidDriver;
  XmlMXCAFDoc_DimTolDriver: typeof XmlMXCAFDoc_DimTolDriver;
  Handle_XmlMXCAFDoc_DimTolDriver: typeof Handle_XmlMXCAFDoc_DimTolDriver;
  Handle_XmlMXCAFDoc_DimTolDriver_1: typeof Handle_XmlMXCAFDoc_DimTolDriver_1;
  Handle_XmlMXCAFDoc_DimTolDriver_2: typeof Handle_XmlMXCAFDoc_DimTolDriver_2;
  Handle_XmlMXCAFDoc_DimTolDriver_3: typeof Handle_XmlMXCAFDoc_DimTolDriver_3;
  Handle_XmlMXCAFDoc_DimTolDriver_4: typeof Handle_XmlMXCAFDoc_DimTolDriver_4;
  NLPlate_HPG3Constraint: typeof NLPlate_HPG3Constraint;
  Handle_NLPlate_HPG3Constraint: typeof Handle_NLPlate_HPG3Constraint;
  Handle_NLPlate_HPG3Constraint_1: typeof Handle_NLPlate_HPG3Constraint_1;
  Handle_NLPlate_HPG3Constraint_2: typeof Handle_NLPlate_HPG3Constraint_2;
  Handle_NLPlate_HPG3Constraint_3: typeof Handle_NLPlate_HPG3Constraint_3;
  Handle_NLPlate_HPG3Constraint_4: typeof Handle_NLPlate_HPG3Constraint_4;
  Handle_NLPlate_HPG2Constraint: typeof Handle_NLPlate_HPG2Constraint;
  Handle_NLPlate_HPG2Constraint_1: typeof Handle_NLPlate_HPG2Constraint_1;
  Handle_NLPlate_HPG2Constraint_2: typeof Handle_NLPlate_HPG2Constraint_2;
  Handle_NLPlate_HPG2Constraint_3: typeof Handle_NLPlate_HPG2Constraint_3;
  Handle_NLPlate_HPG2Constraint_4: typeof Handle_NLPlate_HPG2Constraint_4;
  NLPlate_HPG2Constraint: typeof NLPlate_HPG2Constraint;
  NLPlate_HPG1Constraint: typeof NLPlate_HPG1Constraint;
  Handle_NLPlate_HPG1Constraint: typeof Handle_NLPlate_HPG1Constraint;
  Handle_NLPlate_HPG1Constraint_1: typeof Handle_NLPlate_HPG1Constraint_1;
  Handle_NLPlate_HPG1Constraint_2: typeof Handle_NLPlate_HPG1Constraint_2;
  Handle_NLPlate_HPG1Constraint_3: typeof Handle_NLPlate_HPG1Constraint_3;
  Handle_NLPlate_HPG1Constraint_4: typeof Handle_NLPlate_HPG1Constraint_4;
  Handle_NLPlate_HGPPConstraint: typeof Handle_NLPlate_HGPPConstraint;
  Handle_NLPlate_HGPPConstraint_1: typeof Handle_NLPlate_HGPPConstraint_1;
  Handle_NLPlate_HGPPConstraint_2: typeof Handle_NLPlate_HGPPConstraint_2;
  Handle_NLPlate_HGPPConstraint_3: typeof Handle_NLPlate_HGPPConstraint_3;
  Handle_NLPlate_HGPPConstraint_4: typeof Handle_NLPlate_HGPPConstraint_4;
  NLPlate_HGPPConstraint: typeof NLPlate_HGPPConstraint;
  Handle_NLPlate_HPG0G1Constraint: typeof Handle_NLPlate_HPG0G1Constraint;
  Handle_NLPlate_HPG0G1Constraint_1: typeof Handle_NLPlate_HPG0G1Constraint_1;
  Handle_NLPlate_HPG0G1Constraint_2: typeof Handle_NLPlate_HPG0G1Constraint_2;
  Handle_NLPlate_HPG0G1Constraint_3: typeof Handle_NLPlate_HPG0G1Constraint_3;
  Handle_NLPlate_HPG0G1Constraint_4: typeof Handle_NLPlate_HPG0G1Constraint_4;
  NLPlate_HPG0G1Constraint: typeof NLPlate_HPG0G1Constraint;
  NLPlate_HPG0Constraint: typeof NLPlate_HPG0Constraint;
  Handle_NLPlate_HPG0Constraint: typeof Handle_NLPlate_HPG0Constraint;
  Handle_NLPlate_HPG0Constraint_1: typeof Handle_NLPlate_HPG0Constraint_1;
  Handle_NLPlate_HPG0Constraint_2: typeof Handle_NLPlate_HPG0Constraint_2;
  Handle_NLPlate_HPG0Constraint_3: typeof Handle_NLPlate_HPG0Constraint_3;
  Handle_NLPlate_HPG0Constraint_4: typeof Handle_NLPlate_HPG0Constraint_4;
  NLPlate_HPG0G3Constraint: typeof NLPlate_HPG0G3Constraint;
  Handle_NLPlate_HPG0G3Constraint: typeof Handle_NLPlate_HPG0G3Constraint;
  Handle_NLPlate_HPG0G3Constraint_1: typeof Handle_NLPlate_HPG0G3Constraint_1;
  Handle_NLPlate_HPG0G3Constraint_2: typeof Handle_NLPlate_HPG0G3Constraint_2;
  Handle_NLPlate_HPG0G3Constraint_3: typeof Handle_NLPlate_HPG0G3Constraint_3;
  Handle_NLPlate_HPG0G3Constraint_4: typeof Handle_NLPlate_HPG0G3Constraint_4;
  NLPlate_NLPlate: typeof NLPlate_NLPlate;
  NLPlate_HPG0G2Constraint: typeof NLPlate_HPG0G2Constraint;
  Handle_NLPlate_HPG0G2Constraint: typeof Handle_NLPlate_HPG0G2Constraint;
  Handle_NLPlate_HPG0G2Constraint_1: typeof Handle_NLPlate_HPG0G2Constraint_1;
  Handle_NLPlate_HPG0G2Constraint_2: typeof Handle_NLPlate_HPG0G2Constraint_2;
  Handle_NLPlate_HPG0G2Constraint_3: typeof Handle_NLPlate_HPG0G2Constraint_3;
  Handle_NLPlate_HPG0G2Constraint_4: typeof Handle_NLPlate_HPG0G2Constraint_4;
  NLPlate_StackOfPlate: typeof NLPlate_StackOfPlate;
  NLPlate_StackOfPlate_1: typeof NLPlate_StackOfPlate_1;
  NLPlate_StackOfPlate_2: typeof NLPlate_StackOfPlate_2;
  NLPlate_StackOfPlate_3: typeof NLPlate_StackOfPlate_3;
  TNaming_SameShapeIterator: typeof TNaming_SameShapeIterator;
  TNaming_ShapesSet: typeof TNaming_ShapesSet;
  TNaming_ShapesSet_1: typeof TNaming_ShapesSet_1;
  TNaming_ShapesSet_2: typeof TNaming_ShapesSet_2;
  TNaming: typeof TNaming;
  TNaming_Naming: typeof TNaming_Naming;
  Handle_TNaming_Naming: typeof Handle_TNaming_Naming;
  Handle_TNaming_Naming_1: typeof Handle_TNaming_Naming_1;
  Handle_TNaming_Naming_2: typeof Handle_TNaming_Naming_2;
  Handle_TNaming_Naming_3: typeof Handle_TNaming_Naming_3;
  Handle_TNaming_Naming_4: typeof Handle_TNaming_Naming_4;
  TNaming_Builder: typeof TNaming_Builder;
  TNaming_IteratorOnShapesSet: typeof TNaming_IteratorOnShapesSet;
  TNaming_IteratorOnShapesSet_1: typeof TNaming_IteratorOnShapesSet_1;
  TNaming_IteratorOnShapesSet_2: typeof TNaming_IteratorOnShapesSet_2;
  TNaming_DataMapOfShapePtrRefShape: typeof TNaming_DataMapOfShapePtrRefShape;
  TNaming_DataMapOfShapePtrRefShape_1: typeof TNaming_DataMapOfShapePtrRefShape_1;
  TNaming_DataMapOfShapePtrRefShape_2: typeof TNaming_DataMapOfShapePtrRefShape_2;
  TNaming_DataMapOfShapePtrRefShape_3: typeof TNaming_DataMapOfShapePtrRefShape_3;
  TNaming_DeltaOnRemoval: typeof TNaming_DeltaOnRemoval;
  Handle_TNaming_DeltaOnRemoval: typeof Handle_TNaming_DeltaOnRemoval;
  Handle_TNaming_DeltaOnRemoval_1: typeof Handle_TNaming_DeltaOnRemoval_1;
  Handle_TNaming_DeltaOnRemoval_2: typeof Handle_TNaming_DeltaOnRemoval_2;
  Handle_TNaming_DeltaOnRemoval_3: typeof Handle_TNaming_DeltaOnRemoval_3;
  Handle_TNaming_DeltaOnRemoval_4: typeof Handle_TNaming_DeltaOnRemoval_4;
  TNaming_Scope: typeof TNaming_Scope;
  TNaming_Scope_1: typeof TNaming_Scope_1;
  TNaming_Scope_2: typeof TNaming_Scope_2;
  TNaming_Scope_3: typeof TNaming_Scope_3;
  TNaming_Iterator: typeof TNaming_Iterator;
  TNaming_Iterator_1: typeof TNaming_Iterator_1;
  TNaming_Iterator_2: typeof TNaming_Iterator_2;
  TNaming_Iterator_3: typeof TNaming_Iterator_3;
  TNaming_ListOfMapOfShape: typeof TNaming_ListOfMapOfShape;
  TNaming_ListOfMapOfShape_1: typeof TNaming_ListOfMapOfShape_1;
  TNaming_ListOfMapOfShape_2: typeof TNaming_ListOfMapOfShape_2;
  TNaming_ListOfMapOfShape_3: typeof TNaming_ListOfMapOfShape_3;
  TNaming_Localizer: typeof TNaming_Localizer;
  TNaming_DataMapOfShapeShapesSet: typeof TNaming_DataMapOfShapeShapesSet;
  TNaming_DataMapOfShapeShapesSet_1: typeof TNaming_DataMapOfShapeShapesSet_1;
  TNaming_DataMapOfShapeShapesSet_2: typeof TNaming_DataMapOfShapeShapesSet_2;
  TNaming_DataMapOfShapeShapesSet_3: typeof TNaming_DataMapOfShapeShapesSet_3;
  TNaming_Selector: typeof TNaming_Selector;
  TNaming_NewShapeIterator: typeof TNaming_NewShapeIterator;
  TNaming_NewShapeIterator_1: typeof TNaming_NewShapeIterator_1;
  TNaming_NewShapeIterator_2: typeof TNaming_NewShapeIterator_2;
  TNaming_NewShapeIterator_3: typeof TNaming_NewShapeIterator_3;
  TNaming_NewShapeIterator_4: typeof TNaming_NewShapeIterator_4;
  TNaming_TranslateTool: typeof TNaming_TranslateTool;
  Handle_TNaming_TranslateTool: typeof Handle_TNaming_TranslateTool;
  Handle_TNaming_TranslateTool_1: typeof Handle_TNaming_TranslateTool_1;
  Handle_TNaming_TranslateTool_2: typeof Handle_TNaming_TranslateTool_2;
  Handle_TNaming_TranslateTool_3: typeof Handle_TNaming_TranslateTool_3;
  Handle_TNaming_TranslateTool_4: typeof Handle_TNaming_TranslateTool_4;
  TNaming_CopyShape: typeof TNaming_CopyShape;
  TNaming_UsedShapes: typeof TNaming_UsedShapes;
  Handle_TNaming_UsedShapes: typeof Handle_TNaming_UsedShapes;
  Handle_TNaming_UsedShapes_1: typeof Handle_TNaming_UsedShapes_1;
  Handle_TNaming_UsedShapes_2: typeof Handle_TNaming_UsedShapes_2;
  Handle_TNaming_UsedShapes_3: typeof Handle_TNaming_UsedShapes_3;
  Handle_TNaming_UsedShapes_4: typeof Handle_TNaming_UsedShapes_4;
  TNaming_OldShapeIterator: typeof TNaming_OldShapeIterator;
  TNaming_OldShapeIterator_1: typeof TNaming_OldShapeIterator_1;
  TNaming_OldShapeIterator_2: typeof TNaming_OldShapeIterator_2;
  TNaming_OldShapeIterator_3: typeof TNaming_OldShapeIterator_3;
  TNaming_OldShapeIterator_4: typeof TNaming_OldShapeIterator_4;
  TNaming_Translator: typeof TNaming_Translator;
  TNaming_Identifier: typeof TNaming_Identifier;
  TNaming_Identifier_1: typeof TNaming_Identifier_1;
  TNaming_Identifier_2: typeof TNaming_Identifier_2;
  TNaming_RefShape: typeof TNaming_RefShape;
  TNaming_RefShape_1: typeof TNaming_RefShape_1;
  TNaming_RefShape_2: typeof TNaming_RefShape_2;
  TNaming_ListOfIndexedDataMapOfShapeListOfShape: typeof TNaming_ListOfIndexedDataMapOfShapeListOfShape;
  TNaming_ListOfIndexedDataMapOfShapeListOfShape_1: typeof TNaming_ListOfIndexedDataMapOfShapeListOfShape_1;
  TNaming_ListOfIndexedDataMapOfShapeListOfShape_2: typeof TNaming_ListOfIndexedDataMapOfShapeListOfShape_2;
  TNaming_ListOfIndexedDataMapOfShapeListOfShape_3: typeof TNaming_ListOfIndexedDataMapOfShapeListOfShape_3;
  TNaming_Tool: typeof TNaming_Tool;
  TNaming_NamingTool: typeof TNaming_NamingTool;
  TNaming_Name: typeof TNaming_Name;
  TNaming_NameType: TNaming_NameType;
  TNaming_Evolution: TNaming_Evolution;
  Handle_TNaming_NamedShape: typeof Handle_TNaming_NamedShape;
  Handle_TNaming_NamedShape_1: typeof Handle_TNaming_NamedShape_1;
  Handle_TNaming_NamedShape_2: typeof Handle_TNaming_NamedShape_2;
  Handle_TNaming_NamedShape_3: typeof Handle_TNaming_NamedShape_3;
  Handle_TNaming_NamedShape_4: typeof Handle_TNaming_NamedShape_4;
  TNaming_NamedShape: typeof TNaming_NamedShape;
  TNaming_DeltaOnModification: typeof TNaming_DeltaOnModification;
  Handle_TNaming_DeltaOnModification: typeof Handle_TNaming_DeltaOnModification;
  Handle_TNaming_DeltaOnModification_1: typeof Handle_TNaming_DeltaOnModification_1;
  Handle_TNaming_DeltaOnModification_2: typeof Handle_TNaming_DeltaOnModification_2;
  Handle_TNaming_DeltaOnModification_3: typeof Handle_TNaming_DeltaOnModification_3;
  Handle_TNaming_DeltaOnModification_4: typeof Handle_TNaming_DeltaOnModification_4;
  Handle_ShapeAnalysis_FreeBoundData: typeof Handle_ShapeAnalysis_FreeBoundData;
  Handle_ShapeAnalysis_FreeBoundData_1: typeof Handle_ShapeAnalysis_FreeBoundData_1;
  Handle_ShapeAnalysis_FreeBoundData_2: typeof Handle_ShapeAnalysis_FreeBoundData_2;
  Handle_ShapeAnalysis_FreeBoundData_3: typeof Handle_ShapeAnalysis_FreeBoundData_3;
  Handle_ShapeAnalysis_FreeBoundData_4: typeof Handle_ShapeAnalysis_FreeBoundData_4;
  ShapeAnalysis_FreeBoundData: typeof ShapeAnalysis_FreeBoundData;
  ShapeAnalysis_FreeBoundData_1: typeof ShapeAnalysis_FreeBoundData_1;
  ShapeAnalysis_FreeBoundData_2: typeof ShapeAnalysis_FreeBoundData_2;
  Handle_ShapeAnalysis_HSequenceOfFreeBounds: typeof Handle_ShapeAnalysis_HSequenceOfFreeBounds;
  Handle_ShapeAnalysis_HSequenceOfFreeBounds_1: typeof Handle_ShapeAnalysis_HSequenceOfFreeBounds_1;
  Handle_ShapeAnalysis_HSequenceOfFreeBounds_2: typeof Handle_ShapeAnalysis_HSequenceOfFreeBounds_2;
  Handle_ShapeAnalysis_HSequenceOfFreeBounds_3: typeof Handle_ShapeAnalysis_HSequenceOfFreeBounds_3;
  Handle_ShapeAnalysis_HSequenceOfFreeBounds_4: typeof Handle_ShapeAnalysis_HSequenceOfFreeBounds_4;
  Handle_ShapeAnalysis_TransferParameters: typeof Handle_ShapeAnalysis_TransferParameters;
  Handle_ShapeAnalysis_TransferParameters_1: typeof Handle_ShapeAnalysis_TransferParameters_1;
  Handle_ShapeAnalysis_TransferParameters_2: typeof Handle_ShapeAnalysis_TransferParameters_2;
  Handle_ShapeAnalysis_TransferParameters_3: typeof Handle_ShapeAnalysis_TransferParameters_3;
  Handle_ShapeAnalysis_TransferParameters_4: typeof Handle_ShapeAnalysis_TransferParameters_4;
  ShapeAnalysis_TransferParameters: typeof ShapeAnalysis_TransferParameters;
  ShapeAnalysis_TransferParameters_1: typeof ShapeAnalysis_TransferParameters_1;
  ShapeAnalysis_TransferParameters_2: typeof ShapeAnalysis_TransferParameters_2;
  ShapeAnalysis_ShapeTolerance: typeof ShapeAnalysis_ShapeTolerance;
  ShapeAnalysis_WireOrder: typeof ShapeAnalysis_WireOrder;
  ShapeAnalysis_WireOrder_1: typeof ShapeAnalysis_WireOrder_1;
  ShapeAnalysis_WireOrder_2: typeof ShapeAnalysis_WireOrder_2;
  ShapeAnalysis_Shell: typeof ShapeAnalysis_Shell;
  ShapeAnalysis_Wire: typeof ShapeAnalysis_Wire;
  ShapeAnalysis_Wire_1: typeof ShapeAnalysis_Wire_1;
  ShapeAnalysis_Wire_2: typeof ShapeAnalysis_Wire_2;
  ShapeAnalysis_Wire_3: typeof ShapeAnalysis_Wire_3;
  Handle_ShapeAnalysis_Wire: typeof Handle_ShapeAnalysis_Wire;
  Handle_ShapeAnalysis_Wire_1: typeof Handle_ShapeAnalysis_Wire_1;
  Handle_ShapeAnalysis_Wire_2: typeof Handle_ShapeAnalysis_Wire_2;
  Handle_ShapeAnalysis_Wire_3: typeof Handle_ShapeAnalysis_Wire_3;
  Handle_ShapeAnalysis_Wire_4: typeof Handle_ShapeAnalysis_Wire_4;
  ShapeAnalysis: typeof ShapeAnalysis;
  ShapeAnalysis_TransferParametersProj: typeof ShapeAnalysis_TransferParametersProj;
  ShapeAnalysis_TransferParametersProj_1: typeof ShapeAnalysis_TransferParametersProj_1;
  ShapeAnalysis_TransferParametersProj_2: typeof ShapeAnalysis_TransferParametersProj_2;
  Handle_ShapeAnalysis_TransferParametersProj: typeof Handle_ShapeAnalysis_TransferParametersProj;
  Handle_ShapeAnalysis_TransferParametersProj_1: typeof Handle_ShapeAnalysis_TransferParametersProj_1;
  Handle_ShapeAnalysis_TransferParametersProj_2: typeof Handle_ShapeAnalysis_TransferParametersProj_2;
  Handle_ShapeAnalysis_TransferParametersProj_3: typeof Handle_ShapeAnalysis_TransferParametersProj_3;
  Handle_ShapeAnalysis_TransferParametersProj_4: typeof Handle_ShapeAnalysis_TransferParametersProj_4;
  ShapeAnalysis_Curve: typeof ShapeAnalysis_Curve;
  ShapeAnalysis_ShapeContents: typeof ShapeAnalysis_ShapeContents;
  ShapeAnalysis_CheckSmallFace: typeof ShapeAnalysis_CheckSmallFace;
  ShapeAnalysis_BoxBndTreeSelector: typeof ShapeAnalysis_BoxBndTreeSelector;
  ShapeAnalysis_Geom: typeof ShapeAnalysis_Geom;
  ShapeAnalysis_FreeBoundsProperties: typeof ShapeAnalysis_FreeBoundsProperties;
  ShapeAnalysis_FreeBoundsProperties_1: typeof ShapeAnalysis_FreeBoundsProperties_1;
  ShapeAnalysis_FreeBoundsProperties_2: typeof ShapeAnalysis_FreeBoundsProperties_2;
  ShapeAnalysis_FreeBoundsProperties_3: typeof ShapeAnalysis_FreeBoundsProperties_3;
  Handle_ShapeAnalysis_Surface: typeof Handle_ShapeAnalysis_Surface;
  Handle_ShapeAnalysis_Surface_1: typeof Handle_ShapeAnalysis_Surface_1;
  Handle_ShapeAnalysis_Surface_2: typeof Handle_ShapeAnalysis_Surface_2;
  Handle_ShapeAnalysis_Surface_3: typeof Handle_ShapeAnalysis_Surface_3;
  Handle_ShapeAnalysis_Surface_4: typeof Handle_ShapeAnalysis_Surface_4;
  ShapeAnalysis_Surface: typeof ShapeAnalysis_Surface;
  ShapeAnalysis_Edge: typeof ShapeAnalysis_Edge;
  ShapeAnalysis_DataMapOfShapeListOfReal: typeof ShapeAnalysis_DataMapOfShapeListOfReal;
  ShapeAnalysis_DataMapOfShapeListOfReal_1: typeof ShapeAnalysis_DataMapOfShapeListOfReal_1;
  ShapeAnalysis_DataMapOfShapeListOfReal_2: typeof ShapeAnalysis_DataMapOfShapeListOfReal_2;
  ShapeAnalysis_DataMapOfShapeListOfReal_3: typeof ShapeAnalysis_DataMapOfShapeListOfReal_3;
  ShapeAnalysis_WireVertex: typeof ShapeAnalysis_WireVertex;
  ShapeAnalysis_FreeBounds: typeof ShapeAnalysis_FreeBounds;
  ShapeAnalysis_FreeBounds_1: typeof ShapeAnalysis_FreeBounds_1;
  ShapeAnalysis_FreeBounds_2: typeof ShapeAnalysis_FreeBounds_2;
  ShapeAnalysis_FreeBounds_3: typeof ShapeAnalysis_FreeBounds_3;
  Handle_StepAP214_HArray1OfExternalIdentificationItem: typeof Handle_StepAP214_HArray1OfExternalIdentificationItem;
  Handle_StepAP214_HArray1OfExternalIdentificationItem_1: typeof Handle_StepAP214_HArray1OfExternalIdentificationItem_1;
  Handle_StepAP214_HArray1OfExternalIdentificationItem_2: typeof Handle_StepAP214_HArray1OfExternalIdentificationItem_2;
  Handle_StepAP214_HArray1OfExternalIdentificationItem_3: typeof Handle_StepAP214_HArray1OfExternalIdentificationItem_3;
  Handle_StepAP214_HArray1OfExternalIdentificationItem_4: typeof Handle_StepAP214_HArray1OfExternalIdentificationItem_4;
  Handle_StepAP214_AppliedSecurityClassificationAssignment: typeof Handle_StepAP214_AppliedSecurityClassificationAssignment;
  Handle_StepAP214_AppliedSecurityClassificationAssignment_1: typeof Handle_StepAP214_AppliedSecurityClassificationAssignment_1;
  Handle_StepAP214_AppliedSecurityClassificationAssignment_2: typeof Handle_StepAP214_AppliedSecurityClassificationAssignment_2;
  Handle_StepAP214_AppliedSecurityClassificationAssignment_3: typeof Handle_StepAP214_AppliedSecurityClassificationAssignment_3;
  Handle_StepAP214_AppliedSecurityClassificationAssignment_4: typeof Handle_StepAP214_AppliedSecurityClassificationAssignment_4;
  StepAP214_AppliedSecurityClassificationAssignment: typeof StepAP214_AppliedSecurityClassificationAssignment;
  StepAP214_AutoDesignDatedItem: typeof StepAP214_AutoDesignDatedItem;
  Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect: typeof Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect;
  Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_1: typeof Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_1;
  Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_2: typeof Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_2;
  Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_3: typeof Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_3;
  Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_4: typeof Handle_StepAP214_HArray1OfAutoDesignPresentedItemSelect_4;
  Handle_StepAP214_HArray1OfAutoDesignDatedItem: typeof Handle_StepAP214_HArray1OfAutoDesignDatedItem;
  Handle_StepAP214_HArray1OfAutoDesignDatedItem_1: typeof Handle_StepAP214_HArray1OfAutoDesignDatedItem_1;
  Handle_StepAP214_HArray1OfAutoDesignDatedItem_2: typeof Handle_StepAP214_HArray1OfAutoDesignDatedItem_2;
  Handle_StepAP214_HArray1OfAutoDesignDatedItem_3: typeof Handle_StepAP214_HArray1OfAutoDesignDatedItem_3;
  Handle_StepAP214_HArray1OfAutoDesignDatedItem_4: typeof Handle_StepAP214_HArray1OfAutoDesignDatedItem_4;
  Handle_StepAP214_HArray1OfPersonAndOrganizationItem: typeof Handle_StepAP214_HArray1OfPersonAndOrganizationItem;
  Handle_StepAP214_HArray1OfPersonAndOrganizationItem_1: typeof Handle_StepAP214_HArray1OfPersonAndOrganizationItem_1;
  Handle_StepAP214_HArray1OfPersonAndOrganizationItem_2: typeof Handle_StepAP214_HArray1OfPersonAndOrganizationItem_2;
  Handle_StepAP214_HArray1OfPersonAndOrganizationItem_3: typeof Handle_StepAP214_HArray1OfPersonAndOrganizationItem_3;
  Handle_StepAP214_HArray1OfPersonAndOrganizationItem_4: typeof Handle_StepAP214_HArray1OfPersonAndOrganizationItem_4;
  StepAP214_Array1OfDocumentReferenceItem: typeof StepAP214_Array1OfDocumentReferenceItem;
  StepAP214_Array1OfDocumentReferenceItem_1: typeof StepAP214_Array1OfDocumentReferenceItem_1;
  StepAP214_Array1OfDocumentReferenceItem_2: typeof StepAP214_Array1OfDocumentReferenceItem_2;
  StepAP214_Array1OfDocumentReferenceItem_3: typeof StepAP214_Array1OfDocumentReferenceItem_3;
  StepAP214_Array1OfDocumentReferenceItem_4: typeof StepAP214_Array1OfDocumentReferenceItem_4;
  StepAP214_Array1OfDocumentReferenceItem_5: typeof StepAP214_Array1OfDocumentReferenceItem_5;
  Handle_StepAP214_AppliedDateAssignment: typeof Handle_StepAP214_AppliedDateAssignment;
  Handle_StepAP214_AppliedDateAssignment_1: typeof Handle_StepAP214_AppliedDateAssignment_1;
  Handle_StepAP214_AppliedDateAssignment_2: typeof Handle_StepAP214_AppliedDateAssignment_2;
  Handle_StepAP214_AppliedDateAssignment_3: typeof Handle_StepAP214_AppliedDateAssignment_3;
  Handle_StepAP214_AppliedDateAssignment_4: typeof Handle_StepAP214_AppliedDateAssignment_4;
  StepAP214_AppliedDateAssignment: typeof StepAP214_AppliedDateAssignment;
  StepAP214_AutoDesignGroupedItem: typeof StepAP214_AutoDesignGroupedItem;
  StepAP214_Array1OfOrganizationItem: typeof StepAP214_Array1OfOrganizationItem;
  StepAP214_Array1OfOrganizationItem_1: typeof StepAP214_Array1OfOrganizationItem_1;
  StepAP214_Array1OfOrganizationItem_2: typeof StepAP214_Array1OfOrganizationItem_2;
  StepAP214_Array1OfOrganizationItem_3: typeof StepAP214_Array1OfOrganizationItem_3;
  StepAP214_Array1OfOrganizationItem_4: typeof StepAP214_Array1OfOrganizationItem_4;
  StepAP214_Array1OfOrganizationItem_5: typeof StepAP214_Array1OfOrganizationItem_5;
  Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem;
  Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_1: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_1;
  Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_2: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_2;
  Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_3: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_3;
  Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_4: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndTimeItem_4;
  StepAP214_Array1OfExternalIdentificationItem: typeof StepAP214_Array1OfExternalIdentificationItem;
  StepAP214_Array1OfExternalIdentificationItem_1: typeof StepAP214_Array1OfExternalIdentificationItem_1;
  StepAP214_Array1OfExternalIdentificationItem_2: typeof StepAP214_Array1OfExternalIdentificationItem_2;
  StepAP214_Array1OfExternalIdentificationItem_3: typeof StepAP214_Array1OfExternalIdentificationItem_3;
  StepAP214_Array1OfExternalIdentificationItem_4: typeof StepAP214_Array1OfExternalIdentificationItem_4;
  StepAP214_Array1OfExternalIdentificationItem_5: typeof StepAP214_Array1OfExternalIdentificationItem_5;
  StepAP214_Array1OfAutoDesignDateAndPersonItem: typeof StepAP214_Array1OfAutoDesignDateAndPersonItem;
  StepAP214_Array1OfAutoDesignDateAndPersonItem_1: typeof StepAP214_Array1OfAutoDesignDateAndPersonItem_1;
  StepAP214_Array1OfAutoDesignDateAndPersonItem_2: typeof StepAP214_Array1OfAutoDesignDateAndPersonItem_2;
  StepAP214_Array1OfAutoDesignDateAndPersonItem_3: typeof StepAP214_Array1OfAutoDesignDateAndPersonItem_3;
  StepAP214_Array1OfAutoDesignDateAndPersonItem_4: typeof StepAP214_Array1OfAutoDesignDateAndPersonItem_4;
  StepAP214_Array1OfAutoDesignDateAndPersonItem_5: typeof StepAP214_Array1OfAutoDesignDateAndPersonItem_5;
  StepAP214_RepItemGroup: typeof StepAP214_RepItemGroup;
  Handle_StepAP214_RepItemGroup: typeof Handle_StepAP214_RepItemGroup;
  Handle_StepAP214_RepItemGroup_1: typeof Handle_StepAP214_RepItemGroup_1;
  Handle_StepAP214_RepItemGroup_2: typeof Handle_StepAP214_RepItemGroup_2;
  Handle_StepAP214_RepItemGroup_3: typeof Handle_StepAP214_RepItemGroup_3;
  Handle_StepAP214_RepItemGroup_4: typeof Handle_StepAP214_RepItemGroup_4;
  StepAP214_AppliedPersonAndOrganizationAssignment: typeof StepAP214_AppliedPersonAndOrganizationAssignment;
  Handle_StepAP214_AppliedPersonAndOrganizationAssignment: typeof Handle_StepAP214_AppliedPersonAndOrganizationAssignment;
  Handle_StepAP214_AppliedPersonAndOrganizationAssignment_1: typeof Handle_StepAP214_AppliedPersonAndOrganizationAssignment_1;
  Handle_StepAP214_AppliedPersonAndOrganizationAssignment_2: typeof Handle_StepAP214_AppliedPersonAndOrganizationAssignment_2;
  Handle_StepAP214_AppliedPersonAndOrganizationAssignment_3: typeof Handle_StepAP214_AppliedPersonAndOrganizationAssignment_3;
  Handle_StepAP214_AppliedPersonAndOrganizationAssignment_4: typeof Handle_StepAP214_AppliedPersonAndOrganizationAssignment_4;
  StepAP214_AppliedPresentedItem: typeof StepAP214_AppliedPresentedItem;
  Handle_StepAP214_AppliedPresentedItem: typeof Handle_StepAP214_AppliedPresentedItem;
  Handle_StepAP214_AppliedPresentedItem_1: typeof Handle_StepAP214_AppliedPresentedItem_1;
  Handle_StepAP214_AppliedPresentedItem_2: typeof Handle_StepAP214_AppliedPresentedItem_2;
  Handle_StepAP214_AppliedPresentedItem_3: typeof Handle_StepAP214_AppliedPresentedItem_3;
  Handle_StepAP214_AppliedPresentedItem_4: typeof Handle_StepAP214_AppliedPresentedItem_4;
  Handle_StepAP214_AppliedApprovalAssignment: typeof Handle_StepAP214_AppliedApprovalAssignment;
  Handle_StepAP214_AppliedApprovalAssignment_1: typeof Handle_StepAP214_AppliedApprovalAssignment_1;
  Handle_StepAP214_AppliedApprovalAssignment_2: typeof Handle_StepAP214_AppliedApprovalAssignment_2;
  Handle_StepAP214_AppliedApprovalAssignment_3: typeof Handle_StepAP214_AppliedApprovalAssignment_3;
  Handle_StepAP214_AppliedApprovalAssignment_4: typeof Handle_StepAP214_AppliedApprovalAssignment_4;
  StepAP214_AppliedApprovalAssignment: typeof StepAP214_AppliedApprovalAssignment;
  Handle_StepAP214_Protocol: typeof Handle_StepAP214_Protocol;
  Handle_StepAP214_Protocol_1: typeof Handle_StepAP214_Protocol_1;
  Handle_StepAP214_Protocol_2: typeof Handle_StepAP214_Protocol_2;
  Handle_StepAP214_Protocol_3: typeof Handle_StepAP214_Protocol_3;
  Handle_StepAP214_Protocol_4: typeof Handle_StepAP214_Protocol_4;
  StepAP214_Protocol: typeof StepAP214_Protocol;
  Handle_StepAP214_AppliedDocumentReference: typeof Handle_StepAP214_AppliedDocumentReference;
  Handle_StepAP214_AppliedDocumentReference_1: typeof Handle_StepAP214_AppliedDocumentReference_1;
  Handle_StepAP214_AppliedDocumentReference_2: typeof Handle_StepAP214_AppliedDocumentReference_2;
  Handle_StepAP214_AppliedDocumentReference_3: typeof Handle_StepAP214_AppliedDocumentReference_3;
  Handle_StepAP214_AppliedDocumentReference_4: typeof Handle_StepAP214_AppliedDocumentReference_4;
  StepAP214_AppliedDocumentReference: typeof StepAP214_AppliedDocumentReference;
  Handle_StepAP214_ExternallyDefinedGeneralProperty: typeof Handle_StepAP214_ExternallyDefinedGeneralProperty;
  Handle_StepAP214_ExternallyDefinedGeneralProperty_1: typeof Handle_StepAP214_ExternallyDefinedGeneralProperty_1;
  Handle_StepAP214_ExternallyDefinedGeneralProperty_2: typeof Handle_StepAP214_ExternallyDefinedGeneralProperty_2;
  Handle_StepAP214_ExternallyDefinedGeneralProperty_3: typeof Handle_StepAP214_ExternallyDefinedGeneralProperty_3;
  Handle_StepAP214_ExternallyDefinedGeneralProperty_4: typeof Handle_StepAP214_ExternallyDefinedGeneralProperty_4;
  StepAP214_ExternallyDefinedGeneralProperty: typeof StepAP214_ExternallyDefinedGeneralProperty;
  StepAP214_Array1OfPersonAndOrganizationItem: typeof StepAP214_Array1OfPersonAndOrganizationItem;
  StepAP214_Array1OfPersonAndOrganizationItem_1: typeof StepAP214_Array1OfPersonAndOrganizationItem_1;
  StepAP214_Array1OfPersonAndOrganizationItem_2: typeof StepAP214_Array1OfPersonAndOrganizationItem_2;
  StepAP214_Array1OfPersonAndOrganizationItem_3: typeof StepAP214_Array1OfPersonAndOrganizationItem_3;
  StepAP214_Array1OfPersonAndOrganizationItem_4: typeof StepAP214_Array1OfPersonAndOrganizationItem_4;
  StepAP214_Array1OfPersonAndOrganizationItem_5: typeof StepAP214_Array1OfPersonAndOrganizationItem_5;
  Handle_StepAP214_AutoDesignDateAndPersonAssignment: typeof Handle_StepAP214_AutoDesignDateAndPersonAssignment;
  Handle_StepAP214_AutoDesignDateAndPersonAssignment_1: typeof Handle_StepAP214_AutoDesignDateAndPersonAssignment_1;
  Handle_StepAP214_AutoDesignDateAndPersonAssignment_2: typeof Handle_StepAP214_AutoDesignDateAndPersonAssignment_2;
  Handle_StepAP214_AutoDesignDateAndPersonAssignment_3: typeof Handle_StepAP214_AutoDesignDateAndPersonAssignment_3;
  Handle_StepAP214_AutoDesignDateAndPersonAssignment_4: typeof Handle_StepAP214_AutoDesignDateAndPersonAssignment_4;
  StepAP214_AutoDesignDateAndPersonAssignment: typeof StepAP214_AutoDesignDateAndPersonAssignment;
  StepAP214_OrganizationItem: typeof StepAP214_OrganizationItem;
  Handle_StepAP214_HArray1OfApprovalItem: typeof Handle_StepAP214_HArray1OfApprovalItem;
  Handle_StepAP214_HArray1OfApprovalItem_1: typeof Handle_StepAP214_HArray1OfApprovalItem_1;
  Handle_StepAP214_HArray1OfApprovalItem_2: typeof Handle_StepAP214_HArray1OfApprovalItem_2;
  Handle_StepAP214_HArray1OfApprovalItem_3: typeof Handle_StepAP214_HArray1OfApprovalItem_3;
  Handle_StepAP214_HArray1OfApprovalItem_4: typeof Handle_StepAP214_HArray1OfApprovalItem_4;
  StepAP214_Array1OfDateItem: typeof StepAP214_Array1OfDateItem;
  StepAP214_Array1OfDateItem_1: typeof StepAP214_Array1OfDateItem_1;
  StepAP214_Array1OfDateItem_2: typeof StepAP214_Array1OfDateItem_2;
  StepAP214_Array1OfDateItem_3: typeof StepAP214_Array1OfDateItem_3;
  StepAP214_Array1OfDateItem_4: typeof StepAP214_Array1OfDateItem_4;
  StepAP214_Array1OfDateItem_5: typeof StepAP214_Array1OfDateItem_5;
  StepAP214_AutoDesignDateAndPersonItem: typeof StepAP214_AutoDesignDateAndPersonItem;
  StepAP214_Array1OfAutoDesignGroupedItem: typeof StepAP214_Array1OfAutoDesignGroupedItem;
  StepAP214_Array1OfAutoDesignGroupedItem_1: typeof StepAP214_Array1OfAutoDesignGroupedItem_1;
  StepAP214_Array1OfAutoDesignGroupedItem_2: typeof StepAP214_Array1OfAutoDesignGroupedItem_2;
  StepAP214_Array1OfAutoDesignGroupedItem_3: typeof StepAP214_Array1OfAutoDesignGroupedItem_3;
  StepAP214_Array1OfAutoDesignGroupedItem_4: typeof StepAP214_Array1OfAutoDesignGroupedItem_4;
  StepAP214_Array1OfAutoDesignGroupedItem_5: typeof StepAP214_Array1OfAutoDesignGroupedItem_5;
  StepAP214_DocumentReferenceItem: typeof StepAP214_DocumentReferenceItem;
  Handle_StepAP214_HArray1OfSecurityClassificationItem: typeof Handle_StepAP214_HArray1OfSecurityClassificationItem;
  Handle_StepAP214_HArray1OfSecurityClassificationItem_1: typeof Handle_StepAP214_HArray1OfSecurityClassificationItem_1;
  Handle_StepAP214_HArray1OfSecurityClassificationItem_2: typeof Handle_StepAP214_HArray1OfSecurityClassificationItem_2;
  Handle_StepAP214_HArray1OfSecurityClassificationItem_3: typeof Handle_StepAP214_HArray1OfSecurityClassificationItem_3;
  Handle_StepAP214_HArray1OfSecurityClassificationItem_4: typeof Handle_StepAP214_HArray1OfSecurityClassificationItem_4;
  StepAP214_Array1OfAutoDesignDateAndTimeItem: typeof StepAP214_Array1OfAutoDesignDateAndTimeItem;
  StepAP214_Array1OfAutoDesignDateAndTimeItem_1: typeof StepAP214_Array1OfAutoDesignDateAndTimeItem_1;
  StepAP214_Array1OfAutoDesignDateAndTimeItem_2: typeof StepAP214_Array1OfAutoDesignDateAndTimeItem_2;
  StepAP214_Array1OfAutoDesignDateAndTimeItem_3: typeof StepAP214_Array1OfAutoDesignDateAndTimeItem_3;
  StepAP214_Array1OfAutoDesignDateAndTimeItem_4: typeof StepAP214_Array1OfAutoDesignDateAndTimeItem_4;
  StepAP214_Array1OfAutoDesignDateAndTimeItem_5: typeof StepAP214_Array1OfAutoDesignDateAndTimeItem_5;
  Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem: typeof Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem;
  Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_1: typeof Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_1;
  Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_2: typeof Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_2;
  Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_3: typeof Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_3;
  Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_4: typeof Handle_StepAP214_HArray1OfAutoDesignGeneralOrgItem_4;
  Handle_StepAP214_HArray1OfDocumentReferenceItem: typeof Handle_StepAP214_HArray1OfDocumentReferenceItem;
  Handle_StepAP214_HArray1OfDocumentReferenceItem_1: typeof Handle_StepAP214_HArray1OfDocumentReferenceItem_1;
  Handle_StepAP214_HArray1OfDocumentReferenceItem_2: typeof Handle_StepAP214_HArray1OfDocumentReferenceItem_2;
  Handle_StepAP214_HArray1OfDocumentReferenceItem_3: typeof Handle_StepAP214_HArray1OfDocumentReferenceItem_3;
  Handle_StepAP214_HArray1OfDocumentReferenceItem_4: typeof Handle_StepAP214_HArray1OfDocumentReferenceItem_4;
  Handle_StepAP214_AppliedOrganizationAssignment: typeof Handle_StepAP214_AppliedOrganizationAssignment;
  Handle_StepAP214_AppliedOrganizationAssignment_1: typeof Handle_StepAP214_AppliedOrganizationAssignment_1;
  Handle_StepAP214_AppliedOrganizationAssignment_2: typeof Handle_StepAP214_AppliedOrganizationAssignment_2;
  Handle_StepAP214_AppliedOrganizationAssignment_3: typeof Handle_StepAP214_AppliedOrganizationAssignment_3;
  Handle_StepAP214_AppliedOrganizationAssignment_4: typeof Handle_StepAP214_AppliedOrganizationAssignment_4;
  StepAP214_AppliedOrganizationAssignment: typeof StepAP214_AppliedOrganizationAssignment;
  StepAP214_AppliedGroupAssignment: typeof StepAP214_AppliedGroupAssignment;
  Handle_StepAP214_AppliedGroupAssignment: typeof Handle_StepAP214_AppliedGroupAssignment;
  Handle_StepAP214_AppliedGroupAssignment_1: typeof Handle_StepAP214_AppliedGroupAssignment_1;
  Handle_StepAP214_AppliedGroupAssignment_2: typeof Handle_StepAP214_AppliedGroupAssignment_2;
  Handle_StepAP214_AppliedGroupAssignment_3: typeof Handle_StepAP214_AppliedGroupAssignment_3;
  Handle_StepAP214_AppliedGroupAssignment_4: typeof Handle_StepAP214_AppliedGroupAssignment_4;
  Handle_StepAP214_AutoDesignApprovalAssignment: typeof Handle_StepAP214_AutoDesignApprovalAssignment;
  Handle_StepAP214_AutoDesignApprovalAssignment_1: typeof Handle_StepAP214_AutoDesignApprovalAssignment_1;
  Handle_StepAP214_AutoDesignApprovalAssignment_2: typeof Handle_StepAP214_AutoDesignApprovalAssignment_2;
  Handle_StepAP214_AutoDesignApprovalAssignment_3: typeof Handle_StepAP214_AutoDesignApprovalAssignment_3;
  Handle_StepAP214_AutoDesignApprovalAssignment_4: typeof Handle_StepAP214_AutoDesignApprovalAssignment_4;
  StepAP214_AutoDesignApprovalAssignment: typeof StepAP214_AutoDesignApprovalAssignment;
  Handle_StepAP214_HArray1OfOrganizationItem: typeof Handle_StepAP214_HArray1OfOrganizationItem;
  Handle_StepAP214_HArray1OfOrganizationItem_1: typeof Handle_StepAP214_HArray1OfOrganizationItem_1;
  Handle_StepAP214_HArray1OfOrganizationItem_2: typeof Handle_StepAP214_HArray1OfOrganizationItem_2;
  Handle_StepAP214_HArray1OfOrganizationItem_3: typeof Handle_StepAP214_HArray1OfOrganizationItem_3;
  Handle_StepAP214_HArray1OfOrganizationItem_4: typeof Handle_StepAP214_HArray1OfOrganizationItem_4;
  Handle_StepAP214_HArray1OfAutoDesignReferencingItem: typeof Handle_StepAP214_HArray1OfAutoDesignReferencingItem;
  Handle_StepAP214_HArray1OfAutoDesignReferencingItem_1: typeof Handle_StepAP214_HArray1OfAutoDesignReferencingItem_1;
  Handle_StepAP214_HArray1OfAutoDesignReferencingItem_2: typeof Handle_StepAP214_HArray1OfAutoDesignReferencingItem_2;
  Handle_StepAP214_HArray1OfAutoDesignReferencingItem_3: typeof Handle_StepAP214_HArray1OfAutoDesignReferencingItem_3;
  Handle_StepAP214_HArray1OfAutoDesignReferencingItem_4: typeof Handle_StepAP214_HArray1OfAutoDesignReferencingItem_4;
  StepAP214: typeof StepAP214;
  Handle_StepAP214_AutoDesignNominalDateAssignment: typeof Handle_StepAP214_AutoDesignNominalDateAssignment;
  Handle_StepAP214_AutoDesignNominalDateAssignment_1: typeof Handle_StepAP214_AutoDesignNominalDateAssignment_1;
  Handle_StepAP214_AutoDesignNominalDateAssignment_2: typeof Handle_StepAP214_AutoDesignNominalDateAssignment_2;
  Handle_StepAP214_AutoDesignNominalDateAssignment_3: typeof Handle_StepAP214_AutoDesignNominalDateAssignment_3;
  Handle_StepAP214_AutoDesignNominalDateAssignment_4: typeof Handle_StepAP214_AutoDesignNominalDateAssignment_4;
  StepAP214_AutoDesignNominalDateAssignment: typeof StepAP214_AutoDesignNominalDateAssignment;
  Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem;
  Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_1: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_1;
  Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_2: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_2;
  Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_3: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_3;
  Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_4: typeof Handle_StepAP214_HArray1OfAutoDesignDateAndPersonItem_4;
  Handle_StepAP214_AutoDesignDocumentReference: typeof Handle_StepAP214_AutoDesignDocumentReference;
  Handle_StepAP214_AutoDesignDocumentReference_1: typeof Handle_StepAP214_AutoDesignDocumentReference_1;
  Handle_StepAP214_AutoDesignDocumentReference_2: typeof Handle_StepAP214_AutoDesignDocumentReference_2;
  Handle_StepAP214_AutoDesignDocumentReference_3: typeof Handle_StepAP214_AutoDesignDocumentReference_3;
  Handle_StepAP214_AutoDesignDocumentReference_4: typeof Handle_StepAP214_AutoDesignDocumentReference_4;
  StepAP214_AutoDesignDocumentReference: typeof StepAP214_AutoDesignDocumentReference;
  Handle_StepAP214_HArray1OfAutoDesignGroupedItem: typeof Handle_StepAP214_HArray1OfAutoDesignGroupedItem;
  Handle_StepAP214_HArray1OfAutoDesignGroupedItem_1: typeof Handle_StepAP214_HArray1OfAutoDesignGroupedItem_1;
  Handle_StepAP214_HArray1OfAutoDesignGroupedItem_2: typeof Handle_StepAP214_HArray1OfAutoDesignGroupedItem_2;
  Handle_StepAP214_HArray1OfAutoDesignGroupedItem_3: typeof Handle_StepAP214_HArray1OfAutoDesignGroupedItem_3;
  Handle_StepAP214_HArray1OfAutoDesignGroupedItem_4: typeof Handle_StepAP214_HArray1OfAutoDesignGroupedItem_4;
  StepAP214_Array1OfAutoDesignPresentedItemSelect: typeof StepAP214_Array1OfAutoDesignPresentedItemSelect;
  StepAP214_Array1OfAutoDesignPresentedItemSelect_1: typeof StepAP214_Array1OfAutoDesignPresentedItemSelect_1;
  StepAP214_Array1OfAutoDesignPresentedItemSelect_2: typeof StepAP214_Array1OfAutoDesignPresentedItemSelect_2;
  StepAP214_Array1OfAutoDesignPresentedItemSelect_3: typeof StepAP214_Array1OfAutoDesignPresentedItemSelect_3;
  StepAP214_Array1OfAutoDesignPresentedItemSelect_4: typeof StepAP214_Array1OfAutoDesignPresentedItemSelect_4;
  StepAP214_Array1OfAutoDesignPresentedItemSelect_5: typeof StepAP214_Array1OfAutoDesignPresentedItemSelect_5;
  StepAP214_Array1OfAutoDesignReferencingItem: typeof StepAP214_Array1OfAutoDesignReferencingItem;
  StepAP214_Array1OfAutoDesignReferencingItem_1: typeof StepAP214_Array1OfAutoDesignReferencingItem_1;
  StepAP214_Array1OfAutoDesignReferencingItem_2: typeof StepAP214_Array1OfAutoDesignReferencingItem_2;
  StepAP214_Array1OfAutoDesignReferencingItem_3: typeof StepAP214_Array1OfAutoDesignReferencingItem_3;
  StepAP214_Array1OfAutoDesignReferencingItem_4: typeof StepAP214_Array1OfAutoDesignReferencingItem_4;
  StepAP214_Array1OfAutoDesignReferencingItem_5: typeof StepAP214_Array1OfAutoDesignReferencingItem_5;
  StepAP214_Array1OfAutoDesignGeneralOrgItem: typeof StepAP214_Array1OfAutoDesignGeneralOrgItem;
  StepAP214_Array1OfAutoDesignGeneralOrgItem_1: typeof StepAP214_Array1OfAutoDesignGeneralOrgItem_1;
  StepAP214_Array1OfAutoDesignGeneralOrgItem_2: typeof StepAP214_Array1OfAutoDesignGeneralOrgItem_2;
  StepAP214_Array1OfAutoDesignGeneralOrgItem_3: typeof StepAP214_Array1OfAutoDesignGeneralOrgItem_3;
  StepAP214_Array1OfAutoDesignGeneralOrgItem_4: typeof StepAP214_Array1OfAutoDesignGeneralOrgItem_4;
  StepAP214_Array1OfAutoDesignGeneralOrgItem_5: typeof StepAP214_Array1OfAutoDesignGeneralOrgItem_5;
  StepAP214_AutoDesignOrganizationItem: typeof StepAP214_AutoDesignOrganizationItem;
  Handle_StepAP214_AutoDesignGroupAssignment: typeof Handle_StepAP214_AutoDesignGroupAssignment;
  Handle_StepAP214_AutoDesignGroupAssignment_1: typeof Handle_StepAP214_AutoDesignGroupAssignment_1;
  Handle_StepAP214_AutoDesignGroupAssignment_2: typeof Handle_StepAP214_AutoDesignGroupAssignment_2;
  Handle_StepAP214_AutoDesignGroupAssignment_3: typeof Handle_StepAP214_AutoDesignGroupAssignment_3;
  Handle_StepAP214_AutoDesignGroupAssignment_4: typeof Handle_StepAP214_AutoDesignGroupAssignment_4;
  StepAP214_AutoDesignGroupAssignment: typeof StepAP214_AutoDesignGroupAssignment;
  StepAP214_PersonAndOrganizationItem: typeof StepAP214_PersonAndOrganizationItem;
  StepAP214_AutoDesignDateAndTimeItem: typeof StepAP214_AutoDesignDateAndTimeItem;
  StepAP214_AutoDesignOrganizationAssignment: typeof StepAP214_AutoDesignOrganizationAssignment;
  Handle_StepAP214_AutoDesignOrganizationAssignment: typeof Handle_StepAP214_AutoDesignOrganizationAssignment;
  Handle_StepAP214_AutoDesignOrganizationAssignment_1: typeof Handle_StepAP214_AutoDesignOrganizationAssignment_1;
  Handle_StepAP214_AutoDesignOrganizationAssignment_2: typeof Handle_StepAP214_AutoDesignOrganizationAssignment_2;
  Handle_StepAP214_AutoDesignOrganizationAssignment_3: typeof Handle_StepAP214_AutoDesignOrganizationAssignment_3;
  Handle_StepAP214_AutoDesignOrganizationAssignment_4: typeof Handle_StepAP214_AutoDesignOrganizationAssignment_4;
  StepAP214_GroupItem: typeof StepAP214_GroupItem;
  StepAP214_ExternalIdentificationItem: typeof StepAP214_ExternalIdentificationItem;
  StepAP214_Array1OfDateAndTimeItem: typeof StepAP214_Array1OfDateAndTimeItem;
  StepAP214_Array1OfDateAndTimeItem_1: typeof StepAP214_Array1OfDateAndTimeItem_1;
  StepAP214_Array1OfDateAndTimeItem_2: typeof StepAP214_Array1OfDateAndTimeItem_2;
  StepAP214_Array1OfDateAndTimeItem_3: typeof StepAP214_Array1OfDateAndTimeItem_3;
  StepAP214_Array1OfDateAndTimeItem_4: typeof StepAP214_Array1OfDateAndTimeItem_4;
  StepAP214_Array1OfDateAndTimeItem_5: typeof StepAP214_Array1OfDateAndTimeItem_5;
  Handle_StepAP214_ExternallyDefinedClass: typeof Handle_StepAP214_ExternallyDefinedClass;
  Handle_StepAP214_ExternallyDefinedClass_1: typeof Handle_StepAP214_ExternallyDefinedClass_1;
  Handle_StepAP214_ExternallyDefinedClass_2: typeof Handle_StepAP214_ExternallyDefinedClass_2;
  Handle_StepAP214_ExternallyDefinedClass_3: typeof Handle_StepAP214_ExternallyDefinedClass_3;
  Handle_StepAP214_ExternallyDefinedClass_4: typeof Handle_StepAP214_ExternallyDefinedClass_4;
  StepAP214_ExternallyDefinedClass: typeof StepAP214_ExternallyDefinedClass;
  StepAP214_AutoDesignPersonAndOrganizationAssignment: typeof StepAP214_AutoDesignPersonAndOrganizationAssignment;
  Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment: typeof Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment;
  Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_1: typeof Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_1;
  Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_2: typeof Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_2;
  Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_3: typeof Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_3;
  Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_4: typeof Handle_StepAP214_AutoDesignPersonAndOrganizationAssignment_4;
  Handle_StepAP214_AutoDesignPresentedItem: typeof Handle_StepAP214_AutoDesignPresentedItem;
  Handle_StepAP214_AutoDesignPresentedItem_1: typeof Handle_StepAP214_AutoDesignPresentedItem_1;
  Handle_StepAP214_AutoDesignPresentedItem_2: typeof Handle_StepAP214_AutoDesignPresentedItem_2;
  Handle_StepAP214_AutoDesignPresentedItem_3: typeof Handle_StepAP214_AutoDesignPresentedItem_3;
  Handle_StepAP214_AutoDesignPresentedItem_4: typeof Handle_StepAP214_AutoDesignPresentedItem_4;
  StepAP214_AutoDesignPresentedItem: typeof StepAP214_AutoDesignPresentedItem;
  StepAP214_Class: typeof StepAP214_Class;
  Handle_StepAP214_Class: typeof Handle_StepAP214_Class;
  Handle_StepAP214_Class_1: typeof Handle_StepAP214_Class_1;
  Handle_StepAP214_Class_2: typeof Handle_StepAP214_Class_2;
  Handle_StepAP214_Class_3: typeof Handle_StepAP214_Class_3;
  Handle_StepAP214_Class_4: typeof Handle_StepAP214_Class_4;
  Handle_StepAP214_HArray1OfPresentedItemSelect: typeof Handle_StepAP214_HArray1OfPresentedItemSelect;
  Handle_StepAP214_HArray1OfPresentedItemSelect_1: typeof Handle_StepAP214_HArray1OfPresentedItemSelect_1;
  Handle_StepAP214_HArray1OfPresentedItemSelect_2: typeof Handle_StepAP214_HArray1OfPresentedItemSelect_2;
  Handle_StepAP214_HArray1OfPresentedItemSelect_3: typeof Handle_StepAP214_HArray1OfPresentedItemSelect_3;
  Handle_StepAP214_HArray1OfPresentedItemSelect_4: typeof Handle_StepAP214_HArray1OfPresentedItemSelect_4;
  StepAP214_AutoDesignPresentedItemSelect: typeof StepAP214_AutoDesignPresentedItemSelect;
  StepAP214_AutoDesignReferencingItem: typeof StepAP214_AutoDesignReferencingItem;
  StepAP214_Array1OfPresentedItemSelect: typeof StepAP214_Array1OfPresentedItemSelect;
  StepAP214_Array1OfPresentedItemSelect_1: typeof StepAP214_Array1OfPresentedItemSelect_1;
  StepAP214_Array1OfPresentedItemSelect_2: typeof StepAP214_Array1OfPresentedItemSelect_2;
  StepAP214_Array1OfPresentedItemSelect_3: typeof StepAP214_Array1OfPresentedItemSelect_3;
  StepAP214_Array1OfPresentedItemSelect_4: typeof StepAP214_Array1OfPresentedItemSelect_4;
  StepAP214_Array1OfPresentedItemSelect_5: typeof StepAP214_Array1OfPresentedItemSelect_5;
  Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment: typeof Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment;
  Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_1: typeof Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_1;
  Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_2: typeof Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_2;
  Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_3: typeof Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_3;
  Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_4: typeof Handle_StepAP214_AutoDesignNominalDateAndTimeAssignment_4;
  StepAP214_AutoDesignNominalDateAndTimeAssignment: typeof StepAP214_AutoDesignNominalDateAndTimeAssignment;
  Handle_StepAP214_AutoDesignSecurityClassificationAssignment: typeof Handle_StepAP214_AutoDesignSecurityClassificationAssignment;
  Handle_StepAP214_AutoDesignSecurityClassificationAssignment_1: typeof Handle_StepAP214_AutoDesignSecurityClassificationAssignment_1;
  Handle_StepAP214_AutoDesignSecurityClassificationAssignment_2: typeof Handle_StepAP214_AutoDesignSecurityClassificationAssignment_2;
  Handle_StepAP214_AutoDesignSecurityClassificationAssignment_3: typeof Handle_StepAP214_AutoDesignSecurityClassificationAssignment_3;
  Handle_StepAP214_AutoDesignSecurityClassificationAssignment_4: typeof Handle_StepAP214_AutoDesignSecurityClassificationAssignment_4;
  StepAP214_AutoDesignSecurityClassificationAssignment: typeof StepAP214_AutoDesignSecurityClassificationAssignment;
  Handle_StepAP214_AutoDesignActualDateAndTimeAssignment: typeof Handle_StepAP214_AutoDesignActualDateAndTimeAssignment;
  Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_1: typeof Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_1;
  Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_2: typeof Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_2;
  Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_3: typeof Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_3;
  Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_4: typeof Handle_StepAP214_AutoDesignActualDateAndTimeAssignment_4;
  StepAP214_AutoDesignActualDateAndTimeAssignment: typeof StepAP214_AutoDesignActualDateAndTimeAssignment;
  Handle_StepAP214_AutoDesignActualDateAssignment: typeof Handle_StepAP214_AutoDesignActualDateAssignment;
  Handle_StepAP214_AutoDesignActualDateAssignment_1: typeof Handle_StepAP214_AutoDesignActualDateAssignment_1;
  Handle_StepAP214_AutoDesignActualDateAssignment_2: typeof Handle_StepAP214_AutoDesignActualDateAssignment_2;
  Handle_StepAP214_AutoDesignActualDateAssignment_3: typeof Handle_StepAP214_AutoDesignActualDateAssignment_3;
  Handle_StepAP214_AutoDesignActualDateAssignment_4: typeof Handle_StepAP214_AutoDesignActualDateAssignment_4;
  StepAP214_AutoDesignActualDateAssignment: typeof StepAP214_AutoDesignActualDateAssignment;
  StepAP214_AutoDesignGeneralOrgItem: typeof StepAP214_AutoDesignGeneralOrgItem;
  Handle_StepAP214_HArray1OfGroupItem: typeof Handle_StepAP214_HArray1OfGroupItem;
  Handle_StepAP214_HArray1OfGroupItem_1: typeof Handle_StepAP214_HArray1OfGroupItem_1;
  Handle_StepAP214_HArray1OfGroupItem_2: typeof Handle_StepAP214_HArray1OfGroupItem_2;
  Handle_StepAP214_HArray1OfGroupItem_3: typeof Handle_StepAP214_HArray1OfGroupItem_3;
  Handle_StepAP214_HArray1OfGroupItem_4: typeof Handle_StepAP214_HArray1OfGroupItem_4;
  StepAP214_Array1OfSecurityClassificationItem: typeof StepAP214_Array1OfSecurityClassificationItem;
  StepAP214_Array1OfSecurityClassificationItem_1: typeof StepAP214_Array1OfSecurityClassificationItem_1;
  StepAP214_Array1OfSecurityClassificationItem_2: typeof StepAP214_Array1OfSecurityClassificationItem_2;
  StepAP214_Array1OfSecurityClassificationItem_3: typeof StepAP214_Array1OfSecurityClassificationItem_3;
  StepAP214_Array1OfSecurityClassificationItem_4: typeof StepAP214_Array1OfSecurityClassificationItem_4;
  StepAP214_Array1OfSecurityClassificationItem_5: typeof StepAP214_Array1OfSecurityClassificationItem_5;
  StepAP214_AppliedExternalIdentificationAssignment: typeof StepAP214_AppliedExternalIdentificationAssignment;
  Handle_StepAP214_AppliedExternalIdentificationAssignment: typeof Handle_StepAP214_AppliedExternalIdentificationAssignment;
  Handle_StepAP214_AppliedExternalIdentificationAssignment_1: typeof Handle_StepAP214_AppliedExternalIdentificationAssignment_1;
  Handle_StepAP214_AppliedExternalIdentificationAssignment_2: typeof Handle_StepAP214_AppliedExternalIdentificationAssignment_2;
  Handle_StepAP214_AppliedExternalIdentificationAssignment_3: typeof Handle_StepAP214_AppliedExternalIdentificationAssignment_3;
  Handle_StepAP214_AppliedExternalIdentificationAssignment_4: typeof Handle_StepAP214_AppliedExternalIdentificationAssignment_4;
  StepAP214_ApprovalItem: typeof StepAP214_ApprovalItem;
  StepAP214_PresentedItemSelect: typeof StepAP214_PresentedItemSelect;
  StepAP214_Array1OfAutoDesignDatedItem: typeof StepAP214_Array1OfAutoDesignDatedItem;
  StepAP214_Array1OfAutoDesignDatedItem_1: typeof StepAP214_Array1OfAutoDesignDatedItem_1;
  StepAP214_Array1OfAutoDesignDatedItem_2: typeof StepAP214_Array1OfAutoDesignDatedItem_2;
  StepAP214_Array1OfAutoDesignDatedItem_3: typeof StepAP214_Array1OfAutoDesignDatedItem_3;
  StepAP214_Array1OfAutoDesignDatedItem_4: typeof StepAP214_Array1OfAutoDesignDatedItem_4;
  StepAP214_Array1OfAutoDesignDatedItem_5: typeof StepAP214_Array1OfAutoDesignDatedItem_5;
  StepAP214_Array1OfGroupItem: typeof StepAP214_Array1OfGroupItem;
  StepAP214_Array1OfGroupItem_1: typeof StepAP214_Array1OfGroupItem_1;
  StepAP214_Array1OfGroupItem_2: typeof StepAP214_Array1OfGroupItem_2;
  StepAP214_Array1OfGroupItem_3: typeof StepAP214_Array1OfGroupItem_3;
  StepAP214_Array1OfGroupItem_4: typeof StepAP214_Array1OfGroupItem_4;
  StepAP214_Array1OfGroupItem_5: typeof StepAP214_Array1OfGroupItem_5;
  Handle_StepAP214_HArray1OfDateItem: typeof Handle_StepAP214_HArray1OfDateItem;
  Handle_StepAP214_HArray1OfDateItem_1: typeof Handle_StepAP214_HArray1OfDateItem_1;
  Handle_StepAP214_HArray1OfDateItem_2: typeof Handle_StepAP214_HArray1OfDateItem_2;
  Handle_StepAP214_HArray1OfDateItem_3: typeof Handle_StepAP214_HArray1OfDateItem_3;
  Handle_StepAP214_HArray1OfDateItem_4: typeof Handle_StepAP214_HArray1OfDateItem_4;
  StepAP214_DateAndTimeItem: typeof StepAP214_DateAndTimeItem;
  StepAP214_DateItem: typeof StepAP214_DateItem;
  StepAP214_Array1OfApprovalItem: typeof StepAP214_Array1OfApprovalItem;
  StepAP214_Array1OfApprovalItem_1: typeof StepAP214_Array1OfApprovalItem_1;
  StepAP214_Array1OfApprovalItem_2: typeof StepAP214_Array1OfApprovalItem_2;
  StepAP214_Array1OfApprovalItem_3: typeof StepAP214_Array1OfApprovalItem_3;
  StepAP214_Array1OfApprovalItem_4: typeof StepAP214_Array1OfApprovalItem_4;
  StepAP214_Array1OfApprovalItem_5: typeof StepAP214_Array1OfApprovalItem_5;
  Handle_StepAP214_HArray1OfDateAndTimeItem: typeof Handle_StepAP214_HArray1OfDateAndTimeItem;
  Handle_StepAP214_HArray1OfDateAndTimeItem_1: typeof Handle_StepAP214_HArray1OfDateAndTimeItem_1;
  Handle_StepAP214_HArray1OfDateAndTimeItem_2: typeof Handle_StepAP214_HArray1OfDateAndTimeItem_2;
  Handle_StepAP214_HArray1OfDateAndTimeItem_3: typeof Handle_StepAP214_HArray1OfDateAndTimeItem_3;
  Handle_StepAP214_HArray1OfDateAndTimeItem_4: typeof Handle_StepAP214_HArray1OfDateAndTimeItem_4;
  StepAP214_SecurityClassificationItem: typeof StepAP214_SecurityClassificationItem;
  Handle_StepAP214_AppliedDateAndTimeAssignment: typeof Handle_StepAP214_AppliedDateAndTimeAssignment;
  Handle_StepAP214_AppliedDateAndTimeAssignment_1: typeof Handle_StepAP214_AppliedDateAndTimeAssignment_1;
  Handle_StepAP214_AppliedDateAndTimeAssignment_2: typeof Handle_StepAP214_AppliedDateAndTimeAssignment_2;
  Handle_StepAP214_AppliedDateAndTimeAssignment_3: typeof Handle_StepAP214_AppliedDateAndTimeAssignment_3;
  Handle_StepAP214_AppliedDateAndTimeAssignment_4: typeof Handle_StepAP214_AppliedDateAndTimeAssignment_4;
  StepAP214_AppliedDateAndTimeAssignment: typeof StepAP214_AppliedDateAndTimeAssignment;
  LProp3d_CLProps: typeof LProp3d_CLProps;
  LProp3d_CLProps_1: typeof LProp3d_CLProps_1;
  LProp3d_CLProps_2: typeof LProp3d_CLProps_2;
  LProp3d_CLProps_3: typeof LProp3d_CLProps_3;
  LProp3d_SLProps: typeof LProp3d_SLProps;
  LProp3d_SLProps_1: typeof LProp3d_SLProps_1;
  LProp3d_SLProps_2: typeof LProp3d_SLProps_2;
  LProp3d_SLProps_3: typeof LProp3d_SLProps_3;
  LProp3d_SurfaceTool: typeof LProp3d_SurfaceTool;
  LProp3d_CurveTool: typeof LProp3d_CurveTool;
  GccAna_Circ2d3Tan: typeof GccAna_Circ2d3Tan;
  GccAna_Circ2d3Tan_1: typeof GccAna_Circ2d3Tan_1;
  GccAna_Circ2d3Tan_2: typeof GccAna_Circ2d3Tan_2;
  GccAna_Circ2d3Tan_3: typeof GccAna_Circ2d3Tan_3;
  GccAna_Circ2d3Tan_4: typeof GccAna_Circ2d3Tan_4;
  GccAna_Circ2d3Tan_5: typeof GccAna_Circ2d3Tan_5;
  GccAna_Circ2d3Tan_6: typeof GccAna_Circ2d3Tan_6;
  GccAna_Circ2d3Tan_7: typeof GccAna_Circ2d3Tan_7;
  GccAna_Circ2d3Tan_8: typeof GccAna_Circ2d3Tan_8;
  GccAna_Circ2d3Tan_9: typeof GccAna_Circ2d3Tan_9;
  GccAna_Circ2d3Tan_10: typeof GccAna_Circ2d3Tan_10;
  GccAna_Lin2dTanPer: typeof GccAna_Lin2dTanPer;
  GccAna_Lin2dTanPer_1: typeof GccAna_Lin2dTanPer_1;
  GccAna_Lin2dTanPer_2: typeof GccAna_Lin2dTanPer_2;
  GccAna_Lin2dTanPer_3: typeof GccAna_Lin2dTanPer_3;
  GccAna_Lin2dTanPer_4: typeof GccAna_Lin2dTanPer_4;
  GccAna_Circ2dBisec: typeof GccAna_Circ2dBisec;
  GccAna_Circ2dTanOnRad: typeof GccAna_Circ2dTanOnRad;
  GccAna_Circ2dTanOnRad_1: typeof GccAna_Circ2dTanOnRad_1;
  GccAna_Circ2dTanOnRad_2: typeof GccAna_Circ2dTanOnRad_2;
  GccAna_Circ2dTanOnRad_3: typeof GccAna_Circ2dTanOnRad_3;
  GccAna_Circ2dTanOnRad_4: typeof GccAna_Circ2dTanOnRad_4;
  GccAna_Circ2dTanOnRad_5: typeof GccAna_Circ2dTanOnRad_5;
  GccAna_Circ2dTanOnRad_6: typeof GccAna_Circ2dTanOnRad_6;
  GccAna_NoSolution: typeof GccAna_NoSolution;
  GccAna_NoSolution_1: typeof GccAna_NoSolution_1;
  GccAna_NoSolution_2: typeof GccAna_NoSolution_2;
  Handle_GccAna_NoSolution: typeof Handle_GccAna_NoSolution;
  Handle_GccAna_NoSolution_1: typeof Handle_GccAna_NoSolution_1;
  Handle_GccAna_NoSolution_2: typeof Handle_GccAna_NoSolution_2;
  Handle_GccAna_NoSolution_3: typeof Handle_GccAna_NoSolution_3;
  Handle_GccAna_NoSolution_4: typeof Handle_GccAna_NoSolution_4;
  GccAna_Lin2dTanObl: typeof GccAna_Lin2dTanObl;
  GccAna_Lin2dTanObl_1: typeof GccAna_Lin2dTanObl_1;
  GccAna_Lin2dTanObl_2: typeof GccAna_Lin2dTanObl_2;
  GccAna_Lin2dTanPar: typeof GccAna_Lin2dTanPar;
  GccAna_Lin2dTanPar_1: typeof GccAna_Lin2dTanPar_1;
  GccAna_Lin2dTanPar_2: typeof GccAna_Lin2dTanPar_2;
  GccAna_Circ2d2TanRad: typeof GccAna_Circ2d2TanRad;
  GccAna_Circ2d2TanRad_1: typeof GccAna_Circ2d2TanRad_1;
  GccAna_Circ2d2TanRad_2: typeof GccAna_Circ2d2TanRad_2;
  GccAna_Circ2d2TanRad_3: typeof GccAna_Circ2d2TanRad_3;
  GccAna_Circ2d2TanRad_4: typeof GccAna_Circ2d2TanRad_4;
  GccAna_Circ2d2TanRad_5: typeof GccAna_Circ2d2TanRad_5;
  GccAna_Circ2d2TanRad_6: typeof GccAna_Circ2d2TanRad_6;
  GccAna_Lin2dBisec: typeof GccAna_Lin2dBisec;
  GccAna_CircLin2dBisec: typeof GccAna_CircLin2dBisec;
  GccAna_Circ2d2TanOn: typeof GccAna_Circ2d2TanOn;
  GccAna_Circ2d2TanOn_1: typeof GccAna_Circ2d2TanOn_1;
  GccAna_Circ2d2TanOn_2: typeof GccAna_Circ2d2TanOn_2;
  GccAna_Circ2d2TanOn_3: typeof GccAna_Circ2d2TanOn_3;
  GccAna_Circ2d2TanOn_4: typeof GccAna_Circ2d2TanOn_4;
  GccAna_Circ2d2TanOn_5: typeof GccAna_Circ2d2TanOn_5;
  GccAna_Circ2d2TanOn_6: typeof GccAna_Circ2d2TanOn_6;
  GccAna_Circ2d2TanOn_7: typeof GccAna_Circ2d2TanOn_7;
  GccAna_Circ2d2TanOn_8: typeof GccAna_Circ2d2TanOn_8;
  GccAna_Circ2d2TanOn_9: typeof GccAna_Circ2d2TanOn_9;
  GccAna_Circ2d2TanOn_10: typeof GccAna_Circ2d2TanOn_10;
  GccAna_Circ2d2TanOn_11: typeof GccAna_Circ2d2TanOn_11;
  GccAna_Circ2d2TanOn_12: typeof GccAna_Circ2d2TanOn_12;
  GccAna_LinPnt2dBisec: typeof GccAna_LinPnt2dBisec;
  GccAna_Circ2dTanCen: typeof GccAna_Circ2dTanCen;
  GccAna_Circ2dTanCen_1: typeof GccAna_Circ2dTanCen_1;
  GccAna_Circ2dTanCen_2: typeof GccAna_Circ2dTanCen_2;
  GccAna_Circ2dTanCen_3: typeof GccAna_Circ2dTanCen_3;
  GccAna_Pnt2dBisec: typeof GccAna_Pnt2dBisec;
  GccAna_CircPnt2dBisec: typeof GccAna_CircPnt2dBisec;
  GccAna_CircPnt2dBisec_1: typeof GccAna_CircPnt2dBisec_1;
  GccAna_CircPnt2dBisec_2: typeof GccAna_CircPnt2dBisec_2;
  GccAna_Lin2d2Tan: typeof GccAna_Lin2d2Tan;
  GccAna_Lin2d2Tan_1: typeof GccAna_Lin2d2Tan_1;
  GccAna_Lin2d2Tan_2: typeof GccAna_Lin2d2Tan_2;
  GccAna_Lin2d2Tan_3: typeof GccAna_Lin2d2Tan_3;
  StdPrs_Volume: StdPrs_Volume;
  StdPrs_WFRestrictedFace: typeof StdPrs_WFRestrictedFace;
  Handle_StdPrs_BRepFont: typeof Handle_StdPrs_BRepFont;
  Handle_StdPrs_BRepFont_1: typeof Handle_StdPrs_BRepFont_1;
  Handle_StdPrs_BRepFont_2: typeof Handle_StdPrs_BRepFont_2;
  Handle_StdPrs_BRepFont_3: typeof Handle_StdPrs_BRepFont_3;
  Handle_StdPrs_BRepFont_4: typeof Handle_StdPrs_BRepFont_4;
  StdPrs_BRepFont: typeof StdPrs_BRepFont;
  StdPrs_BRepFont_1: typeof StdPrs_BRepFont_1;
  StdPrs_BRepFont_2: typeof StdPrs_BRepFont_2;
  StdPrs_BRepFont_3: typeof StdPrs_BRepFont_3;
  StdPrs_ShadedShape: typeof StdPrs_ShadedShape;
  StdPrs_BRepTextBuilder: typeof StdPrs_BRepTextBuilder;
  StdPrs_HLRShape: typeof StdPrs_HLRShape;
  StdPrs_WFDeflectionRestrictedFace: typeof StdPrs_WFDeflectionRestrictedFace;
  StdPrs_WFSurface: typeof StdPrs_WFSurface;
  StdPrs_ToolRFace: typeof StdPrs_ToolRFace;
  StdPrs_ToolRFace_1: typeof StdPrs_ToolRFace_1;
  StdPrs_ToolRFace_2: typeof StdPrs_ToolRFace_2;
  StdPrs_ToolTriangulatedShape: typeof StdPrs_ToolTriangulatedShape;
  StdPrs_ShadedSurface: typeof StdPrs_ShadedSurface;
  StdPrs_ToolVertex: typeof StdPrs_ToolVertex;
  StdPrs_HLRToolShape: typeof StdPrs_HLRToolShape;
  StdPrs_WFShape: typeof StdPrs_WFShape;
  StdPrs_Plane: typeof StdPrs_Plane;
  StdPrs_DeflectionCurve: typeof StdPrs_DeflectionCurve;
  StdPrs_WFPoleSurface: typeof StdPrs_WFPoleSurface;
  StdPrs_PoleCurve: typeof StdPrs_PoleCurve;
  StdPrs_HLRPolyShape: typeof StdPrs_HLRPolyShape;
  StdPrs_Curve: typeof StdPrs_Curve;
  StdPrs_Isolines: typeof StdPrs_Isolines;
  StdPrs_ToolPoint: typeof StdPrs_ToolPoint;
  StdPrs_HLRShapeI: typeof StdPrs_HLRShapeI;
  StdPrs_WFDeflectionSurface: typeof StdPrs_WFDeflectionSurface;
  StdPrs_ShapeTool: typeof StdPrs_ShapeTool;
  ShapeUpgrade: typeof ShapeUpgrade;
  ShapeUpgrade_ShapeDivideAngle: typeof ShapeUpgrade_ShapeDivideAngle;
  ShapeUpgrade_ShapeDivideAngle_1: typeof ShapeUpgrade_ShapeDivideAngle_1;
  ShapeUpgrade_ShapeDivideAngle_2: typeof ShapeUpgrade_ShapeDivideAngle_2;
  ShapeUpgrade_SplitSurfaceArea: typeof ShapeUpgrade_SplitSurfaceArea;
  Handle_ShapeUpgrade_SplitSurfaceArea: typeof Handle_ShapeUpgrade_SplitSurfaceArea;
  Handle_ShapeUpgrade_SplitSurfaceArea_1: typeof Handle_ShapeUpgrade_SplitSurfaceArea_1;
  Handle_ShapeUpgrade_SplitSurfaceArea_2: typeof Handle_ShapeUpgrade_SplitSurfaceArea_2;
  Handle_ShapeUpgrade_SplitSurfaceArea_3: typeof Handle_ShapeUpgrade_SplitSurfaceArea_3;
  Handle_ShapeUpgrade_SplitSurfaceArea_4: typeof Handle_ShapeUpgrade_SplitSurfaceArea_4;
  Handle_ShapeUpgrade_ConvertCurve3dToBezier: typeof Handle_ShapeUpgrade_ConvertCurve3dToBezier;
  Handle_ShapeUpgrade_ConvertCurve3dToBezier_1: typeof Handle_ShapeUpgrade_ConvertCurve3dToBezier_1;
  Handle_ShapeUpgrade_ConvertCurve3dToBezier_2: typeof Handle_ShapeUpgrade_ConvertCurve3dToBezier_2;
  Handle_ShapeUpgrade_ConvertCurve3dToBezier_3: typeof Handle_ShapeUpgrade_ConvertCurve3dToBezier_3;
  Handle_ShapeUpgrade_ConvertCurve3dToBezier_4: typeof Handle_ShapeUpgrade_ConvertCurve3dToBezier_4;
  ShapeUpgrade_ConvertCurve3dToBezier: typeof ShapeUpgrade_ConvertCurve3dToBezier;
  ShapeUpgrade_WireDivide: typeof ShapeUpgrade_WireDivide;
  Handle_ShapeUpgrade_WireDivide: typeof Handle_ShapeUpgrade_WireDivide;
  Handle_ShapeUpgrade_WireDivide_1: typeof Handle_ShapeUpgrade_WireDivide_1;
  Handle_ShapeUpgrade_WireDivide_2: typeof Handle_ShapeUpgrade_WireDivide_2;
  Handle_ShapeUpgrade_WireDivide_3: typeof Handle_ShapeUpgrade_WireDivide_3;
  Handle_ShapeUpgrade_WireDivide_4: typeof Handle_ShapeUpgrade_WireDivide_4;
  ShapeUpgrade_SplitSurface: typeof ShapeUpgrade_SplitSurface;
  Handle_ShapeUpgrade_SplitSurface: typeof Handle_ShapeUpgrade_SplitSurface;
  Handle_ShapeUpgrade_SplitSurface_1: typeof Handle_ShapeUpgrade_SplitSurface_1;
  Handle_ShapeUpgrade_SplitSurface_2: typeof Handle_ShapeUpgrade_SplitSurface_2;
  Handle_ShapeUpgrade_SplitSurface_3: typeof Handle_ShapeUpgrade_SplitSurface_3;
  Handle_ShapeUpgrade_SplitSurface_4: typeof Handle_ShapeUpgrade_SplitSurface_4;
  ShapeUpgrade_SplitSurfaceContinuity: typeof ShapeUpgrade_SplitSurfaceContinuity;
  Handle_ShapeUpgrade_SplitSurfaceContinuity: typeof Handle_ShapeUpgrade_SplitSurfaceContinuity;
  Handle_ShapeUpgrade_SplitSurfaceContinuity_1: typeof Handle_ShapeUpgrade_SplitSurfaceContinuity_1;
  Handle_ShapeUpgrade_SplitSurfaceContinuity_2: typeof Handle_ShapeUpgrade_SplitSurfaceContinuity_2;
  Handle_ShapeUpgrade_SplitSurfaceContinuity_3: typeof Handle_ShapeUpgrade_SplitSurfaceContinuity_3;
  Handle_ShapeUpgrade_SplitSurfaceContinuity_4: typeof Handle_ShapeUpgrade_SplitSurfaceContinuity_4;
  SubSequenceOfEdges: typeof SubSequenceOfEdges;
  Handle_ShapeUpgrade_UnifySameDomain: typeof Handle_ShapeUpgrade_UnifySameDomain;
  Handle_ShapeUpgrade_UnifySameDomain_1: typeof Handle_ShapeUpgrade_UnifySameDomain_1;
  Handle_ShapeUpgrade_UnifySameDomain_2: typeof Handle_ShapeUpgrade_UnifySameDomain_2;
  Handle_ShapeUpgrade_UnifySameDomain_3: typeof Handle_ShapeUpgrade_UnifySameDomain_3;
  Handle_ShapeUpgrade_UnifySameDomain_4: typeof Handle_ShapeUpgrade_UnifySameDomain_4;
  ShapeUpgrade_UnifySameDomain: typeof ShapeUpgrade_UnifySameDomain;
  ShapeUpgrade_UnifySameDomain_1: typeof ShapeUpgrade_UnifySameDomain_1;
  ShapeUpgrade_UnifySameDomain_2: typeof ShapeUpgrade_UnifySameDomain_2;
  ShapeUpgrade_EdgeDivide: typeof ShapeUpgrade_EdgeDivide;
  Handle_ShapeUpgrade_EdgeDivide: typeof Handle_ShapeUpgrade_EdgeDivide;
  Handle_ShapeUpgrade_EdgeDivide_1: typeof Handle_ShapeUpgrade_EdgeDivide_1;
  Handle_ShapeUpgrade_EdgeDivide_2: typeof Handle_ShapeUpgrade_EdgeDivide_2;
  Handle_ShapeUpgrade_EdgeDivide_3: typeof Handle_ShapeUpgrade_EdgeDivide_3;
  Handle_ShapeUpgrade_EdgeDivide_4: typeof Handle_ShapeUpgrade_EdgeDivide_4;
  Handle_ShapeUpgrade_FixSmallBezierCurves: typeof Handle_ShapeUpgrade_FixSmallBezierCurves;
  Handle_ShapeUpgrade_FixSmallBezierCurves_1: typeof Handle_ShapeUpgrade_FixSmallBezierCurves_1;
  Handle_ShapeUpgrade_FixSmallBezierCurves_2: typeof Handle_ShapeUpgrade_FixSmallBezierCurves_2;
  Handle_ShapeUpgrade_FixSmallBezierCurves_3: typeof Handle_ShapeUpgrade_FixSmallBezierCurves_3;
  Handle_ShapeUpgrade_FixSmallBezierCurves_4: typeof Handle_ShapeUpgrade_FixSmallBezierCurves_4;
  ShapeUpgrade_FixSmallBezierCurves: typeof ShapeUpgrade_FixSmallBezierCurves;
  Handle_ShapeUpgrade_SplitCurve3d: typeof Handle_ShapeUpgrade_SplitCurve3d;
  Handle_ShapeUpgrade_SplitCurve3d_1: typeof Handle_ShapeUpgrade_SplitCurve3d_1;
  Handle_ShapeUpgrade_SplitCurve3d_2: typeof Handle_ShapeUpgrade_SplitCurve3d_2;
  Handle_ShapeUpgrade_SplitCurve3d_3: typeof Handle_ShapeUpgrade_SplitCurve3d_3;
  Handle_ShapeUpgrade_SplitCurve3d_4: typeof Handle_ShapeUpgrade_SplitCurve3d_4;
  ShapeUpgrade_SplitCurve3d: typeof ShapeUpgrade_SplitCurve3d;
  Handle_ShapeUpgrade_RemoveLocations: typeof Handle_ShapeUpgrade_RemoveLocations;
  Handle_ShapeUpgrade_RemoveLocations_1: typeof Handle_ShapeUpgrade_RemoveLocations_1;
  Handle_ShapeUpgrade_RemoveLocations_2: typeof Handle_ShapeUpgrade_RemoveLocations_2;
  Handle_ShapeUpgrade_RemoveLocations_3: typeof Handle_ShapeUpgrade_RemoveLocations_3;
  Handle_ShapeUpgrade_RemoveLocations_4: typeof Handle_ShapeUpgrade_RemoveLocations_4;
  ShapeUpgrade_RemoveLocations: typeof ShapeUpgrade_RemoveLocations;
  Handle_ShapeUpgrade_FaceDivide: typeof Handle_ShapeUpgrade_FaceDivide;
  Handle_ShapeUpgrade_FaceDivide_1: typeof Handle_ShapeUpgrade_FaceDivide_1;
  Handle_ShapeUpgrade_FaceDivide_2: typeof Handle_ShapeUpgrade_FaceDivide_2;
  Handle_ShapeUpgrade_FaceDivide_3: typeof Handle_ShapeUpgrade_FaceDivide_3;
  Handle_ShapeUpgrade_FaceDivide_4: typeof Handle_ShapeUpgrade_FaceDivide_4;
  ShapeUpgrade_FaceDivide: typeof ShapeUpgrade_FaceDivide;
  ShapeUpgrade_FaceDivide_1: typeof ShapeUpgrade_FaceDivide_1;
  ShapeUpgrade_FaceDivide_2: typeof ShapeUpgrade_FaceDivide_2;
  ShapeUpgrade_ShapeDivide: typeof ShapeUpgrade_ShapeDivide;
  ShapeUpgrade_ShapeDivide_1: typeof ShapeUpgrade_ShapeDivide_1;
  ShapeUpgrade_ShapeDivide_2: typeof ShapeUpgrade_ShapeDivide_2;
  ShapeUpgrade_SplitCurve2d: typeof ShapeUpgrade_SplitCurve2d;
  Handle_ShapeUpgrade_SplitCurve2d: typeof Handle_ShapeUpgrade_SplitCurve2d;
  Handle_ShapeUpgrade_SplitCurve2d_1: typeof Handle_ShapeUpgrade_SplitCurve2d_1;
  Handle_ShapeUpgrade_SplitCurve2d_2: typeof Handle_ShapeUpgrade_SplitCurve2d_2;
  Handle_ShapeUpgrade_SplitCurve2d_3: typeof Handle_ShapeUpgrade_SplitCurve2d_3;
  Handle_ShapeUpgrade_SplitCurve2d_4: typeof Handle_ShapeUpgrade_SplitCurve2d_4;
  ShapeUpgrade_ShapeDivideClosed: typeof ShapeUpgrade_ShapeDivideClosed;
  Handle_ShapeUpgrade_SplitSurfaceAngle: typeof Handle_ShapeUpgrade_SplitSurfaceAngle;
  Handle_ShapeUpgrade_SplitSurfaceAngle_1: typeof Handle_ShapeUpgrade_SplitSurfaceAngle_1;
  Handle_ShapeUpgrade_SplitSurfaceAngle_2: typeof Handle_ShapeUpgrade_SplitSurfaceAngle_2;
  Handle_ShapeUpgrade_SplitSurfaceAngle_3: typeof Handle_ShapeUpgrade_SplitSurfaceAngle_3;
  Handle_ShapeUpgrade_SplitSurfaceAngle_4: typeof Handle_ShapeUpgrade_SplitSurfaceAngle_4;
  ShapeUpgrade_SplitSurfaceAngle: typeof ShapeUpgrade_SplitSurfaceAngle;
  ShapeUpgrade_FixSmallCurves: typeof ShapeUpgrade_FixSmallCurves;
  Handle_ShapeUpgrade_FixSmallCurves: typeof Handle_ShapeUpgrade_FixSmallCurves;
  Handle_ShapeUpgrade_FixSmallCurves_1: typeof Handle_ShapeUpgrade_FixSmallCurves_1;
  Handle_ShapeUpgrade_FixSmallCurves_2: typeof Handle_ShapeUpgrade_FixSmallCurves_2;
  Handle_ShapeUpgrade_FixSmallCurves_3: typeof Handle_ShapeUpgrade_FixSmallCurves_3;
  Handle_ShapeUpgrade_FixSmallCurves_4: typeof Handle_ShapeUpgrade_FixSmallCurves_4;
  Handle_ShapeUpgrade_ConvertCurve2dToBezier: typeof Handle_ShapeUpgrade_ConvertCurve2dToBezier;
  Handle_ShapeUpgrade_ConvertCurve2dToBezier_1: typeof Handle_ShapeUpgrade_ConvertCurve2dToBezier_1;
  Handle_ShapeUpgrade_ConvertCurve2dToBezier_2: typeof Handle_ShapeUpgrade_ConvertCurve2dToBezier_2;
  Handle_ShapeUpgrade_ConvertCurve2dToBezier_3: typeof Handle_ShapeUpgrade_ConvertCurve2dToBezier_3;
  Handle_ShapeUpgrade_ConvertCurve2dToBezier_4: typeof Handle_ShapeUpgrade_ConvertCurve2dToBezier_4;
  ShapeUpgrade_ConvertCurve2dToBezier: typeof ShapeUpgrade_ConvertCurve2dToBezier;
  ShapeUpgrade_Tool: typeof ShapeUpgrade_Tool;
  Handle_ShapeUpgrade_Tool: typeof Handle_ShapeUpgrade_Tool;
  Handle_ShapeUpgrade_Tool_1: typeof Handle_ShapeUpgrade_Tool_1;
  Handle_ShapeUpgrade_Tool_2: typeof Handle_ShapeUpgrade_Tool_2;
  Handle_ShapeUpgrade_Tool_3: typeof Handle_ShapeUpgrade_Tool_3;
  Handle_ShapeUpgrade_Tool_4: typeof Handle_ShapeUpgrade_Tool_4;
  ShapeUpgrade_FaceDivideArea: typeof ShapeUpgrade_FaceDivideArea;
  ShapeUpgrade_FaceDivideArea_1: typeof ShapeUpgrade_FaceDivideArea_1;
  ShapeUpgrade_FaceDivideArea_2: typeof ShapeUpgrade_FaceDivideArea_2;
  Handle_ShapeUpgrade_FaceDivideArea: typeof Handle_ShapeUpgrade_FaceDivideArea;
  Handle_ShapeUpgrade_FaceDivideArea_1: typeof Handle_ShapeUpgrade_FaceDivideArea_1;
  Handle_ShapeUpgrade_FaceDivideArea_2: typeof Handle_ShapeUpgrade_FaceDivideArea_2;
  Handle_ShapeUpgrade_FaceDivideArea_3: typeof Handle_ShapeUpgrade_FaceDivideArea_3;
  Handle_ShapeUpgrade_FaceDivideArea_4: typeof Handle_ShapeUpgrade_FaceDivideArea_4;
  ShapeUpgrade_RemoveInternalWires: typeof ShapeUpgrade_RemoveInternalWires;
  ShapeUpgrade_RemoveInternalWires_1: typeof ShapeUpgrade_RemoveInternalWires_1;
  ShapeUpgrade_RemoveInternalWires_2: typeof ShapeUpgrade_RemoveInternalWires_2;
  Handle_ShapeUpgrade_RemoveInternalWires: typeof Handle_ShapeUpgrade_RemoveInternalWires;
  Handle_ShapeUpgrade_RemoveInternalWires_1: typeof Handle_ShapeUpgrade_RemoveInternalWires_1;
  Handle_ShapeUpgrade_RemoveInternalWires_2: typeof Handle_ShapeUpgrade_RemoveInternalWires_2;
  Handle_ShapeUpgrade_RemoveInternalWires_3: typeof Handle_ShapeUpgrade_RemoveInternalWires_3;
  Handle_ShapeUpgrade_RemoveInternalWires_4: typeof Handle_ShapeUpgrade_RemoveInternalWires_4;
  ShapeUpgrade_ShapeConvertToBezier: typeof ShapeUpgrade_ShapeConvertToBezier;
  ShapeUpgrade_ShapeConvertToBezier_1: typeof ShapeUpgrade_ShapeConvertToBezier_1;
  ShapeUpgrade_ShapeConvertToBezier_2: typeof ShapeUpgrade_ShapeConvertToBezier_2;
  ShapeUpgrade_ShapeDivideArea: typeof ShapeUpgrade_ShapeDivideArea;
  ShapeUpgrade_ShapeDivideArea_1: typeof ShapeUpgrade_ShapeDivideArea_1;
  ShapeUpgrade_ShapeDivideArea_2: typeof ShapeUpgrade_ShapeDivideArea_2;
  ShapeUpgrade_ShellSewing: typeof ShapeUpgrade_ShellSewing;
  Handle_ShapeUpgrade_ClosedEdgeDivide: typeof Handle_ShapeUpgrade_ClosedEdgeDivide;
  Handle_ShapeUpgrade_ClosedEdgeDivide_1: typeof Handle_ShapeUpgrade_ClosedEdgeDivide_1;
  Handle_ShapeUpgrade_ClosedEdgeDivide_2: typeof Handle_ShapeUpgrade_ClosedEdgeDivide_2;
  Handle_ShapeUpgrade_ClosedEdgeDivide_3: typeof Handle_ShapeUpgrade_ClosedEdgeDivide_3;
  Handle_ShapeUpgrade_ClosedEdgeDivide_4: typeof Handle_ShapeUpgrade_ClosedEdgeDivide_4;
  ShapeUpgrade_ClosedEdgeDivide: typeof ShapeUpgrade_ClosedEdgeDivide;
  ShapeUpgrade_SplitCurve3dContinuity: typeof ShapeUpgrade_SplitCurve3dContinuity;
  Handle_ShapeUpgrade_SplitCurve3dContinuity: typeof Handle_ShapeUpgrade_SplitCurve3dContinuity;
  Handle_ShapeUpgrade_SplitCurve3dContinuity_1: typeof Handle_ShapeUpgrade_SplitCurve3dContinuity_1;
  Handle_ShapeUpgrade_SplitCurve3dContinuity_2: typeof Handle_ShapeUpgrade_SplitCurve3dContinuity_2;
  Handle_ShapeUpgrade_SplitCurve3dContinuity_3: typeof Handle_ShapeUpgrade_SplitCurve3dContinuity_3;
  Handle_ShapeUpgrade_SplitCurve3dContinuity_4: typeof Handle_ShapeUpgrade_SplitCurve3dContinuity_4;
  Handle_ShapeUpgrade_ClosedFaceDivide: typeof Handle_ShapeUpgrade_ClosedFaceDivide;
  Handle_ShapeUpgrade_ClosedFaceDivide_1: typeof Handle_ShapeUpgrade_ClosedFaceDivide_1;
  Handle_ShapeUpgrade_ClosedFaceDivide_2: typeof Handle_ShapeUpgrade_ClosedFaceDivide_2;
  Handle_ShapeUpgrade_ClosedFaceDivide_3: typeof Handle_ShapeUpgrade_ClosedFaceDivide_3;
  Handle_ShapeUpgrade_ClosedFaceDivide_4: typeof Handle_ShapeUpgrade_ClosedFaceDivide_4;
  ShapeUpgrade_ClosedFaceDivide: typeof ShapeUpgrade_ClosedFaceDivide;
  ShapeUpgrade_ClosedFaceDivide_1: typeof ShapeUpgrade_ClosedFaceDivide_1;
  ShapeUpgrade_ClosedFaceDivide_2: typeof ShapeUpgrade_ClosedFaceDivide_2;
  ShapeUpgrade_ConvertSurfaceToBezierBasis: typeof ShapeUpgrade_ConvertSurfaceToBezierBasis;
  Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis: typeof Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis;
  Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_1: typeof Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_1;
  Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_2: typeof Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_2;
  Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_3: typeof Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_3;
  Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_4: typeof Handle_ShapeUpgrade_ConvertSurfaceToBezierBasis_4;
  Handle_ShapeUpgrade_SplitCurve2dContinuity: typeof Handle_ShapeUpgrade_SplitCurve2dContinuity;
  Handle_ShapeUpgrade_SplitCurve2dContinuity_1: typeof Handle_ShapeUpgrade_SplitCurve2dContinuity_1;
  Handle_ShapeUpgrade_SplitCurve2dContinuity_2: typeof Handle_ShapeUpgrade_SplitCurve2dContinuity_2;
  Handle_ShapeUpgrade_SplitCurve2dContinuity_3: typeof Handle_ShapeUpgrade_SplitCurve2dContinuity_3;
  Handle_ShapeUpgrade_SplitCurve2dContinuity_4: typeof Handle_ShapeUpgrade_SplitCurve2dContinuity_4;
  ShapeUpgrade_SplitCurve2dContinuity: typeof ShapeUpgrade_SplitCurve2dContinuity;
  ShapeUpgrade_ShapeDivideContinuity: typeof ShapeUpgrade_ShapeDivideContinuity;
  ShapeUpgrade_ShapeDivideContinuity_1: typeof ShapeUpgrade_ShapeDivideContinuity_1;
  ShapeUpgrade_ShapeDivideContinuity_2: typeof ShapeUpgrade_ShapeDivideContinuity_2;
  ShapeUpgrade_ShapeDivideClosedEdges: typeof ShapeUpgrade_ShapeDivideClosedEdges;
  ShapeUpgrade_SplitCurve: typeof ShapeUpgrade_SplitCurve;
  Handle_ShapeUpgrade_SplitCurve: typeof Handle_ShapeUpgrade_SplitCurve;
  Handle_ShapeUpgrade_SplitCurve_1: typeof Handle_ShapeUpgrade_SplitCurve_1;
  Handle_ShapeUpgrade_SplitCurve_2: typeof Handle_ShapeUpgrade_SplitCurve_2;
  Handle_ShapeUpgrade_SplitCurve_3: typeof Handle_ShapeUpgrade_SplitCurve_3;
  Handle_ShapeUpgrade_SplitCurve_4: typeof Handle_ShapeUpgrade_SplitCurve_4;
  BRepTools_MapOfVertexPnt2d: typeof BRepTools_MapOfVertexPnt2d;
  BRepTools_MapOfVertexPnt2d_1: typeof BRepTools_MapOfVertexPnt2d_1;
  BRepTools_MapOfVertexPnt2d_2: typeof BRepTools_MapOfVertexPnt2d_2;
  BRepTools_MapOfVertexPnt2d_3: typeof BRepTools_MapOfVertexPnt2d_3;
  Handle_BRepTools_TrsfModification: typeof Handle_BRepTools_TrsfModification;
  Handle_BRepTools_TrsfModification_1: typeof Handle_BRepTools_TrsfModification_1;
  Handle_BRepTools_TrsfModification_2: typeof Handle_BRepTools_TrsfModification_2;
  Handle_BRepTools_TrsfModification_3: typeof Handle_BRepTools_TrsfModification_3;
  Handle_BRepTools_TrsfModification_4: typeof Handle_BRepTools_TrsfModification_4;
  BRepTools_TrsfModification: typeof BRepTools_TrsfModification;
  BRepTools_ShapeSet: typeof BRepTools_ShapeSet;
  BRepTools_ShapeSet_1: typeof BRepTools_ShapeSet_1;
  BRepTools_ShapeSet_2: typeof BRepTools_ShapeSet_2;
  BRepTools_ReShape: typeof BRepTools_ReShape;
  Handle_BRepTools_ReShape: typeof Handle_BRepTools_ReShape;
  Handle_BRepTools_ReShape_1: typeof Handle_BRepTools_ReShape_1;
  Handle_BRepTools_ReShape_2: typeof Handle_BRepTools_ReShape_2;
  Handle_BRepTools_ReShape_3: typeof Handle_BRepTools_ReShape_3;
  Handle_BRepTools_ReShape_4: typeof Handle_BRepTools_ReShape_4;
  BRepTools_GTrsfModification: typeof BRepTools_GTrsfModification;
  Handle_BRepTools_GTrsfModification: typeof Handle_BRepTools_GTrsfModification;
  Handle_BRepTools_GTrsfModification_1: typeof Handle_BRepTools_GTrsfModification_1;
  Handle_BRepTools_GTrsfModification_2: typeof Handle_BRepTools_GTrsfModification_2;
  Handle_BRepTools_GTrsfModification_3: typeof Handle_BRepTools_GTrsfModification_3;
  Handle_BRepTools_GTrsfModification_4: typeof Handle_BRepTools_GTrsfModification_4;
  BRepTools_Modification: typeof BRepTools_Modification;
  Handle_BRepTools_Modification: typeof Handle_BRepTools_Modification;
  Handle_BRepTools_Modification_1: typeof Handle_BRepTools_Modification_1;
  Handle_BRepTools_Modification_2: typeof Handle_BRepTools_Modification_2;
  Handle_BRepTools_Modification_3: typeof Handle_BRepTools_Modification_3;
  Handle_BRepTools_Modification_4: typeof Handle_BRepTools_Modification_4;
  BRepTools: typeof BRepTools;
  BRepTools_WireExplorer: typeof BRepTools_WireExplorer;
  BRepTools_WireExplorer_1: typeof BRepTools_WireExplorer_1;
  BRepTools_WireExplorer_2: typeof BRepTools_WireExplorer_2;
  BRepTools_WireExplorer_3: typeof BRepTools_WireExplorer_3;
  Handle_BRepTools_History: typeof Handle_BRepTools_History;
  Handle_BRepTools_History_1: typeof Handle_BRepTools_History_1;
  Handle_BRepTools_History_2: typeof Handle_BRepTools_History_2;
  Handle_BRepTools_History_3: typeof Handle_BRepTools_History_3;
  Handle_BRepTools_History_4: typeof Handle_BRepTools_History_4;
  BRepTools_History: typeof BRepTools_History;
  BRepTools_Quilt: typeof BRepTools_Quilt;
  BRepTools_Substitution: typeof BRepTools_Substitution;
  BRepTools_Modifier: typeof BRepTools_Modifier;
  BRepTools_Modifier_1: typeof BRepTools_Modifier_1;
  BRepTools_Modifier_2: typeof BRepTools_Modifier_2;
  BRepTools_Modifier_3: typeof BRepTools_Modifier_3;
  BRepTools_NurbsConvertModification: typeof BRepTools_NurbsConvertModification;
  Handle_BRepTools_NurbsConvertModification: typeof Handle_BRepTools_NurbsConvertModification;
  Handle_BRepTools_NurbsConvertModification_1: typeof Handle_BRepTools_NurbsConvertModification_1;
  Handle_BRepTools_NurbsConvertModification_2: typeof Handle_BRepTools_NurbsConvertModification_2;
  Handle_BRepTools_NurbsConvertModification_3: typeof Handle_BRepTools_NurbsConvertModification_3;
  Handle_BRepTools_NurbsConvertModification_4: typeof Handle_BRepTools_NurbsConvertModification_4;
  Handle_Geom_BezierCurve: typeof Handle_Geom_BezierCurve;
  Handle_Geom_BezierCurve_1: typeof Handle_Geom_BezierCurve_1;
  Handle_Geom_BezierCurve_2: typeof Handle_Geom_BezierCurve_2;
  Handle_Geom_BezierCurve_3: typeof Handle_Geom_BezierCurve_3;
  Handle_Geom_BezierCurve_4: typeof Handle_Geom_BezierCurve_4;
  Geom_BezierCurve: typeof Geom_BezierCurve;
  Geom_BezierCurve_1: typeof Geom_BezierCurve_1;
  Geom_BezierCurve_2: typeof Geom_BezierCurve_2;
  Geom_BoundedSurface: typeof Geom_BoundedSurface;
  Handle_Geom_BoundedSurface: typeof Handle_Geom_BoundedSurface;
  Handle_Geom_BoundedSurface_1: typeof Handle_Geom_BoundedSurface_1;
  Handle_Geom_BoundedSurface_2: typeof Handle_Geom_BoundedSurface_2;
  Handle_Geom_BoundedSurface_3: typeof Handle_Geom_BoundedSurface_3;
  Handle_Geom_BoundedSurface_4: typeof Handle_Geom_BoundedSurface_4;
  Geom_SweptSurface: typeof Geom_SweptSurface;
  Handle_Geom_SweptSurface: typeof Handle_Geom_SweptSurface;
  Handle_Geom_SweptSurface_1: typeof Handle_Geom_SweptSurface_1;
  Handle_Geom_SweptSurface_2: typeof Handle_Geom_SweptSurface_2;
  Handle_Geom_SweptSurface_3: typeof Handle_Geom_SweptSurface_3;
  Handle_Geom_SweptSurface_4: typeof Handle_Geom_SweptSurface_4;
  Handle_Geom_Plane: typeof Handle_Geom_Plane;
  Handle_Geom_Plane_1: typeof Handle_Geom_Plane_1;
  Handle_Geom_Plane_2: typeof Handle_Geom_Plane_2;
  Handle_Geom_Plane_3: typeof Handle_Geom_Plane_3;
  Handle_Geom_Plane_4: typeof Handle_Geom_Plane_4;
  Geom_Plane: typeof Geom_Plane;
  Geom_Plane_1: typeof Geom_Plane_1;
  Geom_Plane_2: typeof Geom_Plane_2;
  Geom_Plane_3: typeof Geom_Plane_3;
  Geom_Plane_4: typeof Geom_Plane_4;
  Handle_Geom_Geometry: typeof Handle_Geom_Geometry;
  Handle_Geom_Geometry_1: typeof Handle_Geom_Geometry_1;
  Handle_Geom_Geometry_2: typeof Handle_Geom_Geometry_2;
  Handle_Geom_Geometry_3: typeof Handle_Geom_Geometry_3;
  Handle_Geom_Geometry_4: typeof Handle_Geom_Geometry_4;
  Geom_Geometry: typeof Geom_Geometry;
  Handle_Geom_BSplineSurface: typeof Handle_Geom_BSplineSurface;
  Handle_Geom_BSplineSurface_1: typeof Handle_Geom_BSplineSurface_1;
  Handle_Geom_BSplineSurface_2: typeof Handle_Geom_BSplineSurface_2;
  Handle_Geom_BSplineSurface_3: typeof Handle_Geom_BSplineSurface_3;
  Handle_Geom_BSplineSurface_4: typeof Handle_Geom_BSplineSurface_4;
  Geom_BSplineSurface: typeof Geom_BSplineSurface;
  Geom_BSplineSurface_1: typeof Geom_BSplineSurface_1;
  Geom_BSplineSurface_2: typeof Geom_BSplineSurface_2;
  Handle_Geom_UndefinedValue: typeof Handle_Geom_UndefinedValue;
  Handle_Geom_UndefinedValue_1: typeof Handle_Geom_UndefinedValue_1;
  Handle_Geom_UndefinedValue_2: typeof Handle_Geom_UndefinedValue_2;
  Handle_Geom_UndefinedValue_3: typeof Handle_Geom_UndefinedValue_3;
  Handle_Geom_UndefinedValue_4: typeof Handle_Geom_UndefinedValue_4;
  Geom_UndefinedValue: typeof Geom_UndefinedValue;
  Geom_UndefinedValue_1: typeof Geom_UndefinedValue_1;
  Geom_UndefinedValue_2: typeof Geom_UndefinedValue_2;
  Handle_Geom_AxisPlacement: typeof Handle_Geom_AxisPlacement;
  Handle_Geom_AxisPlacement_1: typeof Handle_Geom_AxisPlacement_1;
  Handle_Geom_AxisPlacement_2: typeof Handle_Geom_AxisPlacement_2;
  Handle_Geom_AxisPlacement_3: typeof Handle_Geom_AxisPlacement_3;
  Handle_Geom_AxisPlacement_4: typeof Handle_Geom_AxisPlacement_4;
  Geom_AxisPlacement: typeof Geom_AxisPlacement;
  Handle_Geom_BSplineCurve: typeof Handle_Geom_BSplineCurve;
  Handle_Geom_BSplineCurve_1: typeof Handle_Geom_BSplineCurve_1;
  Handle_Geom_BSplineCurve_2: typeof Handle_Geom_BSplineCurve_2;
  Handle_Geom_BSplineCurve_3: typeof Handle_Geom_BSplineCurve_3;
  Handle_Geom_BSplineCurve_4: typeof Handle_Geom_BSplineCurve_4;
  Geom_BSplineCurve: typeof Geom_BSplineCurve;
  Geom_BSplineCurve_1: typeof Geom_BSplineCurve_1;
  Geom_BSplineCurve_2: typeof Geom_BSplineCurve_2;
  Handle_Geom_TrimmedCurve: typeof Handle_Geom_TrimmedCurve;
  Handle_Geom_TrimmedCurve_1: typeof Handle_Geom_TrimmedCurve_1;
  Handle_Geom_TrimmedCurve_2: typeof Handle_Geom_TrimmedCurve_2;
  Handle_Geom_TrimmedCurve_3: typeof Handle_Geom_TrimmedCurve_3;
  Handle_Geom_TrimmedCurve_4: typeof Handle_Geom_TrimmedCurve_4;
  Geom_TrimmedCurve: typeof Geom_TrimmedCurve;
  Handle_Geom_Direction: typeof Handle_Geom_Direction;
  Handle_Geom_Direction_1: typeof Handle_Geom_Direction_1;
  Handle_Geom_Direction_2: typeof Handle_Geom_Direction_2;
  Handle_Geom_Direction_3: typeof Handle_Geom_Direction_3;
  Handle_Geom_Direction_4: typeof Handle_Geom_Direction_4;
  Geom_Direction: typeof Geom_Direction;
  Geom_Direction_1: typeof Geom_Direction_1;
  Geom_Direction_2: typeof Geom_Direction_2;
  Geom_ConicalSurface: typeof Geom_ConicalSurface;
  Geom_ConicalSurface_1: typeof Geom_ConicalSurface_1;
  Geom_ConicalSurface_2: typeof Geom_ConicalSurface_2;
  Handle_Geom_ConicalSurface: typeof Handle_Geom_ConicalSurface;
  Handle_Geom_ConicalSurface_1: typeof Handle_Geom_ConicalSurface_1;
  Handle_Geom_ConicalSurface_2: typeof Handle_Geom_ConicalSurface_2;
  Handle_Geom_ConicalSurface_3: typeof Handle_Geom_ConicalSurface_3;
  Handle_Geom_ConicalSurface_4: typeof Handle_Geom_ConicalSurface_4;
  Handle_Geom_SurfaceOfLinearExtrusion: typeof Handle_Geom_SurfaceOfLinearExtrusion;
  Handle_Geom_SurfaceOfLinearExtrusion_1: typeof Handle_Geom_SurfaceOfLinearExtrusion_1;
  Handle_Geom_SurfaceOfLinearExtrusion_2: typeof Handle_Geom_SurfaceOfLinearExtrusion_2;
  Handle_Geom_SurfaceOfLinearExtrusion_3: typeof Handle_Geom_SurfaceOfLinearExtrusion_3;
  Handle_Geom_SurfaceOfLinearExtrusion_4: typeof Handle_Geom_SurfaceOfLinearExtrusion_4;
  Geom_SurfaceOfLinearExtrusion: typeof Geom_SurfaceOfLinearExtrusion;
  Handle_Geom_Conic: typeof Handle_Geom_Conic;
  Handle_Geom_Conic_1: typeof Handle_Geom_Conic_1;
  Handle_Geom_Conic_2: typeof Handle_Geom_Conic_2;
  Handle_Geom_Conic_3: typeof Handle_Geom_Conic_3;
  Handle_Geom_Conic_4: typeof Handle_Geom_Conic_4;
  Geom_Conic: typeof Geom_Conic;
  Geom_OffsetCurve: typeof Geom_OffsetCurve;
  Handle_Geom_OffsetCurve: typeof Handle_Geom_OffsetCurve;
  Handle_Geom_OffsetCurve_1: typeof Handle_Geom_OffsetCurve_1;
  Handle_Geom_OffsetCurve_2: typeof Handle_Geom_OffsetCurve_2;
  Handle_Geom_OffsetCurve_3: typeof Handle_Geom_OffsetCurve_3;
  Handle_Geom_OffsetCurve_4: typeof Handle_Geom_OffsetCurve_4;
  Handle_Geom_VectorWithMagnitude: typeof Handle_Geom_VectorWithMagnitude;
  Handle_Geom_VectorWithMagnitude_1: typeof Handle_Geom_VectorWithMagnitude_1;
  Handle_Geom_VectorWithMagnitude_2: typeof Handle_Geom_VectorWithMagnitude_2;
  Handle_Geom_VectorWithMagnitude_3: typeof Handle_Geom_VectorWithMagnitude_3;
  Handle_Geom_VectorWithMagnitude_4: typeof Handle_Geom_VectorWithMagnitude_4;
  Geom_VectorWithMagnitude: typeof Geom_VectorWithMagnitude;
  Geom_VectorWithMagnitude_1: typeof Geom_VectorWithMagnitude_1;
  Geom_VectorWithMagnitude_2: typeof Geom_VectorWithMagnitude_2;
  Geom_VectorWithMagnitude_3: typeof Geom_VectorWithMagnitude_3;
  Geom_Circle: typeof Geom_Circle;
  Geom_Circle_1: typeof Geom_Circle_1;
  Geom_Circle_2: typeof Geom_Circle_2;
  Handle_Geom_Circle: typeof Handle_Geom_Circle;
  Handle_Geom_Circle_1: typeof Handle_Geom_Circle_1;
  Handle_Geom_Circle_2: typeof Handle_Geom_Circle_2;
  Handle_Geom_Circle_3: typeof Handle_Geom_Circle_3;
  Handle_Geom_Circle_4: typeof Handle_Geom_Circle_4;
  Handle_Geom_Line: typeof Handle_Geom_Line;
  Handle_Geom_Line_1: typeof Handle_Geom_Line_1;
  Handle_Geom_Line_2: typeof Handle_Geom_Line_2;
  Handle_Geom_Line_3: typeof Handle_Geom_Line_3;
  Handle_Geom_Line_4: typeof Handle_Geom_Line_4;
  Geom_Line: typeof Geom_Line;
  Geom_Line_1: typeof Geom_Line_1;
  Geom_Line_2: typeof Geom_Line_2;
  Geom_Line_3: typeof Geom_Line_3;
  Geom_Transformation: typeof Geom_Transformation;
  Geom_Transformation_1: typeof Geom_Transformation_1;
  Geom_Transformation_2: typeof Geom_Transformation_2;
  Handle_Geom_Transformation: typeof Handle_Geom_Transformation;
  Handle_Geom_Transformation_1: typeof Handle_Geom_Transformation_1;
  Handle_Geom_Transformation_2: typeof Handle_Geom_Transformation_2;
  Handle_Geom_Transformation_3: typeof Handle_Geom_Transformation_3;
  Handle_Geom_Transformation_4: typeof Handle_Geom_Transformation_4;
  Geom_SphericalSurface: typeof Geom_SphericalSurface;
  Geom_SphericalSurface_1: typeof Geom_SphericalSurface_1;
  Geom_SphericalSurface_2: typeof Geom_SphericalSurface_2;
  Handle_Geom_SphericalSurface: typeof Handle_Geom_SphericalSurface;
  Handle_Geom_SphericalSurface_1: typeof Handle_Geom_SphericalSurface_1;
  Handle_Geom_SphericalSurface_2: typeof Handle_Geom_SphericalSurface_2;
  Handle_Geom_SphericalSurface_3: typeof Handle_Geom_SphericalSurface_3;
  Handle_Geom_SphericalSurface_4: typeof Handle_Geom_SphericalSurface_4;
  Geom_UndefinedDerivative: typeof Geom_UndefinedDerivative;
  Geom_UndefinedDerivative_1: typeof Geom_UndefinedDerivative_1;
  Geom_UndefinedDerivative_2: typeof Geom_UndefinedDerivative_2;
  Handle_Geom_UndefinedDerivative: typeof Handle_Geom_UndefinedDerivative;
  Handle_Geom_UndefinedDerivative_1: typeof Handle_Geom_UndefinedDerivative_1;
  Handle_Geom_UndefinedDerivative_2: typeof Handle_Geom_UndefinedDerivative_2;
  Handle_Geom_UndefinedDerivative_3: typeof Handle_Geom_UndefinedDerivative_3;
  Handle_Geom_UndefinedDerivative_4: typeof Handle_Geom_UndefinedDerivative_4;
  Handle_Geom_Axis2Placement: typeof Handle_Geom_Axis2Placement;
  Handle_Geom_Axis2Placement_1: typeof Handle_Geom_Axis2Placement_1;
  Handle_Geom_Axis2Placement_2: typeof Handle_Geom_Axis2Placement_2;
  Handle_Geom_Axis2Placement_3: typeof Handle_Geom_Axis2Placement_3;
  Handle_Geom_Axis2Placement_4: typeof Handle_Geom_Axis2Placement_4;
  Geom_Axis2Placement: typeof Geom_Axis2Placement;
  Geom_Axis2Placement_1: typeof Geom_Axis2Placement_1;
  Geom_Axis2Placement_2: typeof Geom_Axis2Placement_2;
  Handle_Geom_CartesianPoint: typeof Handle_Geom_CartesianPoint;
  Handle_Geom_CartesianPoint_1: typeof Handle_Geom_CartesianPoint_1;
  Handle_Geom_CartesianPoint_2: typeof Handle_Geom_CartesianPoint_2;
  Handle_Geom_CartesianPoint_3: typeof Handle_Geom_CartesianPoint_3;
  Handle_Geom_CartesianPoint_4: typeof Handle_Geom_CartesianPoint_4;
  Geom_CartesianPoint: typeof Geom_CartesianPoint;
  Geom_CartesianPoint_1: typeof Geom_CartesianPoint_1;
  Geom_CartesianPoint_2: typeof Geom_CartesianPoint_2;
  Handle_Geom_OsculatingSurface: typeof Handle_Geom_OsculatingSurface;
  Handle_Geom_OsculatingSurface_1: typeof Handle_Geom_OsculatingSurface_1;
  Handle_Geom_OsculatingSurface_2: typeof Handle_Geom_OsculatingSurface_2;
  Handle_Geom_OsculatingSurface_3: typeof Handle_Geom_OsculatingSurface_3;
  Handle_Geom_OsculatingSurface_4: typeof Handle_Geom_OsculatingSurface_4;
  Geom_OsculatingSurface: typeof Geom_OsculatingSurface;
  Geom_OsculatingSurface_1: typeof Geom_OsculatingSurface_1;
  Geom_OsculatingSurface_2: typeof Geom_OsculatingSurface_2;
  Handle_Geom_Vector: typeof Handle_Geom_Vector;
  Handle_Geom_Vector_1: typeof Handle_Geom_Vector_1;
  Handle_Geom_Vector_2: typeof Handle_Geom_Vector_2;
  Handle_Geom_Vector_3: typeof Handle_Geom_Vector_3;
  Handle_Geom_Vector_4: typeof Handle_Geom_Vector_4;
  Geom_Vector: typeof Geom_Vector;
  Handle_Geom_Ellipse: typeof Handle_Geom_Ellipse;
  Handle_Geom_Ellipse_1: typeof Handle_Geom_Ellipse_1;
  Handle_Geom_Ellipse_2: typeof Handle_Geom_Ellipse_2;
  Handle_Geom_Ellipse_3: typeof Handle_Geom_Ellipse_3;
  Handle_Geom_Ellipse_4: typeof Handle_Geom_Ellipse_4;
  Geom_Ellipse: typeof Geom_Ellipse;
  Geom_Ellipse_1: typeof Geom_Ellipse_1;
  Geom_Ellipse_2: typeof Geom_Ellipse_2;
  Handle_Geom_Parabola: typeof Handle_Geom_Parabola;
  Handle_Geom_Parabola_1: typeof Handle_Geom_Parabola_1;
  Handle_Geom_Parabola_2: typeof Handle_Geom_Parabola_2;
  Handle_Geom_Parabola_3: typeof Handle_Geom_Parabola_3;
  Handle_Geom_Parabola_4: typeof Handle_Geom_Parabola_4;
  Geom_Parabola: typeof Geom_Parabola;
  Geom_Parabola_1: typeof Geom_Parabola_1;
  Geom_Parabola_2: typeof Geom_Parabola_2;
  Geom_Parabola_3: typeof Geom_Parabola_3;
  Handle_Geom_BezierSurface: typeof Handle_Geom_BezierSurface;
  Handle_Geom_BezierSurface_1: typeof Handle_Geom_BezierSurface_1;
  Handle_Geom_BezierSurface_2: typeof Handle_Geom_BezierSurface_2;
  Handle_Geom_BezierSurface_3: typeof Handle_Geom_BezierSurface_3;
  Handle_Geom_BezierSurface_4: typeof Handle_Geom_BezierSurface_4;
  Geom_BezierSurface: typeof Geom_BezierSurface;
  Geom_BezierSurface_1: typeof Geom_BezierSurface_1;
  Geom_BezierSurface_2: typeof Geom_BezierSurface_2;
  Handle_Geom_Point: typeof Handle_Geom_Point;
  Handle_Geom_Point_1: typeof Handle_Geom_Point_1;
  Handle_Geom_Point_2: typeof Handle_Geom_Point_2;
  Handle_Geom_Point_3: typeof Handle_Geom_Point_3;
  Handle_Geom_Point_4: typeof Handle_Geom_Point_4;
  Geom_Point: typeof Geom_Point;
  Geom_BoundedCurve: typeof Geom_BoundedCurve;
  Handle_Geom_BoundedCurve: typeof Handle_Geom_BoundedCurve;
  Handle_Geom_BoundedCurve_1: typeof Handle_Geom_BoundedCurve_1;
  Handle_Geom_BoundedCurve_2: typeof Handle_Geom_BoundedCurve_2;
  Handle_Geom_BoundedCurve_3: typeof Handle_Geom_BoundedCurve_3;
  Handle_Geom_BoundedCurve_4: typeof Handle_Geom_BoundedCurve_4;
  Handle_Geom_Curve: typeof Handle_Geom_Curve;
  Handle_Geom_Curve_1: typeof Handle_Geom_Curve_1;
  Handle_Geom_Curve_2: typeof Handle_Geom_Curve_2;
  Handle_Geom_Curve_3: typeof Handle_Geom_Curve_3;
  Handle_Geom_Curve_4: typeof Handle_Geom_Curve_4;
  Geom_Curve: typeof Geom_Curve;
  Geom_RectangularTrimmedSurface: typeof Geom_RectangularTrimmedSurface;
  Geom_RectangularTrimmedSurface_1: typeof Geom_RectangularTrimmedSurface_1;
  Geom_RectangularTrimmedSurface_2: typeof Geom_RectangularTrimmedSurface_2;
  Handle_Geom_RectangularTrimmedSurface: typeof Handle_Geom_RectangularTrimmedSurface;
  Handle_Geom_RectangularTrimmedSurface_1: typeof Handle_Geom_RectangularTrimmedSurface_1;
  Handle_Geom_RectangularTrimmedSurface_2: typeof Handle_Geom_RectangularTrimmedSurface_2;
  Handle_Geom_RectangularTrimmedSurface_3: typeof Handle_Geom_RectangularTrimmedSurface_3;
  Handle_Geom_RectangularTrimmedSurface_4: typeof Handle_Geom_RectangularTrimmedSurface_4;
  Geom_Surface: typeof Geom_Surface;
  Handle_Geom_Surface: typeof Handle_Geom_Surface;
  Handle_Geom_Surface_1: typeof Handle_Geom_Surface_1;
  Handle_Geom_Surface_2: typeof Handle_Geom_Surface_2;
  Handle_Geom_Surface_3: typeof Handle_Geom_Surface_3;
  Handle_Geom_Surface_4: typeof Handle_Geom_Surface_4;
  Handle_Geom_Hyperbola: typeof Handle_Geom_Hyperbola;
  Handle_Geom_Hyperbola_1: typeof Handle_Geom_Hyperbola_1;
  Handle_Geom_Hyperbola_2: typeof Handle_Geom_Hyperbola_2;
  Handle_Geom_Hyperbola_3: typeof Handle_Geom_Hyperbola_3;
  Handle_Geom_Hyperbola_4: typeof Handle_Geom_Hyperbola_4;
  Geom_Hyperbola: typeof Geom_Hyperbola;
  Geom_Hyperbola_1: typeof Geom_Hyperbola_1;
  Geom_Hyperbola_2: typeof Geom_Hyperbola_2;
  Handle_Geom_HSequenceOfBSplineSurface: typeof Handle_Geom_HSequenceOfBSplineSurface;
  Handle_Geom_HSequenceOfBSplineSurface_1: typeof Handle_Geom_HSequenceOfBSplineSurface_1;
  Handle_Geom_HSequenceOfBSplineSurface_2: typeof Handle_Geom_HSequenceOfBSplineSurface_2;
  Handle_Geom_HSequenceOfBSplineSurface_3: typeof Handle_Geom_HSequenceOfBSplineSurface_3;
  Handle_Geom_HSequenceOfBSplineSurface_4: typeof Handle_Geom_HSequenceOfBSplineSurface_4;
  Geom_ToroidalSurface: typeof Geom_ToroidalSurface;
  Geom_ToroidalSurface_1: typeof Geom_ToroidalSurface_1;
  Geom_ToroidalSurface_2: typeof Geom_ToroidalSurface_2;
  Handle_Geom_ToroidalSurface: typeof Handle_Geom_ToroidalSurface;
  Handle_Geom_ToroidalSurface_1: typeof Handle_Geom_ToroidalSurface_1;
  Handle_Geom_ToroidalSurface_2: typeof Handle_Geom_ToroidalSurface_2;
  Handle_Geom_ToroidalSurface_3: typeof Handle_Geom_ToroidalSurface_3;
  Handle_Geom_ToroidalSurface_4: typeof Handle_Geom_ToroidalSurface_4;
  Geom_Axis1Placement: typeof Geom_Axis1Placement;
  Geom_Axis1Placement_1: typeof Geom_Axis1Placement_1;
  Geom_Axis1Placement_2: typeof Geom_Axis1Placement_2;
  Handle_Geom_Axis1Placement: typeof Handle_Geom_Axis1Placement;
  Handle_Geom_Axis1Placement_1: typeof Handle_Geom_Axis1Placement_1;
  Handle_Geom_Axis1Placement_2: typeof Handle_Geom_Axis1Placement_2;
  Handle_Geom_Axis1Placement_3: typeof Handle_Geom_Axis1Placement_3;
  Handle_Geom_Axis1Placement_4: typeof Handle_Geom_Axis1Placement_4;
  Geom_CylindricalSurface: typeof Geom_CylindricalSurface;
  Geom_CylindricalSurface_1: typeof Geom_CylindricalSurface_1;
  Geom_CylindricalSurface_2: typeof Geom_CylindricalSurface_2;
  Handle_Geom_CylindricalSurface: typeof Handle_Geom_CylindricalSurface;
  Handle_Geom_CylindricalSurface_1: typeof Handle_Geom_CylindricalSurface_1;
  Handle_Geom_CylindricalSurface_2: typeof Handle_Geom_CylindricalSurface_2;
  Handle_Geom_CylindricalSurface_3: typeof Handle_Geom_CylindricalSurface_3;
  Handle_Geom_CylindricalSurface_4: typeof Handle_Geom_CylindricalSurface_4;
  Geom_OffsetSurface: typeof Geom_OffsetSurface;
  Handle_Geom_OffsetSurface: typeof Handle_Geom_OffsetSurface;
  Handle_Geom_OffsetSurface_1: typeof Handle_Geom_OffsetSurface_1;
  Handle_Geom_OffsetSurface_2: typeof Handle_Geom_OffsetSurface_2;
  Handle_Geom_OffsetSurface_3: typeof Handle_Geom_OffsetSurface_3;
  Handle_Geom_OffsetSurface_4: typeof Handle_Geom_OffsetSurface_4;
  Handle_Geom_SurfaceOfRevolution: typeof Handle_Geom_SurfaceOfRevolution;
  Handle_Geom_SurfaceOfRevolution_1: typeof Handle_Geom_SurfaceOfRevolution_1;
  Handle_Geom_SurfaceOfRevolution_2: typeof Handle_Geom_SurfaceOfRevolution_2;
  Handle_Geom_SurfaceOfRevolution_3: typeof Handle_Geom_SurfaceOfRevolution_3;
  Handle_Geom_SurfaceOfRevolution_4: typeof Handle_Geom_SurfaceOfRevolution_4;
  Geom_SurfaceOfRevolution: typeof Geom_SurfaceOfRevolution;
  Geom_ElementarySurface: typeof Geom_ElementarySurface;
  Handle_Geom_ElementarySurface: typeof Handle_Geom_ElementarySurface;
  Handle_Geom_ElementarySurface_1: typeof Handle_Geom_ElementarySurface_1;
  Handle_Geom_ElementarySurface_2: typeof Handle_Geom_ElementarySurface_2;
  Handle_Geom_ElementarySurface_3: typeof Handle_Geom_ElementarySurface_3;
  Handle_Geom_ElementarySurface_4: typeof Handle_Geom_ElementarySurface_4;
  ExprIntrp_Analysis: typeof ExprIntrp_Analysis;
  Handle_ExprIntrp_GenExp: typeof Handle_ExprIntrp_GenExp;
  Handle_ExprIntrp_GenExp_1: typeof Handle_ExprIntrp_GenExp_1;
  Handle_ExprIntrp_GenExp_2: typeof Handle_ExprIntrp_GenExp_2;
  Handle_ExprIntrp_GenExp_3: typeof Handle_ExprIntrp_GenExp_3;
  Handle_ExprIntrp_GenExp_4: typeof Handle_ExprIntrp_GenExp_4;
  ExprIntrp_GenExp: typeof ExprIntrp_GenExp;
  ExprIntrp: typeof ExprIntrp;
  ExprIntrp_SyntaxError: typeof ExprIntrp_SyntaxError;
  ExprIntrp_SyntaxError_1: typeof ExprIntrp_SyntaxError_1;
  ExprIntrp_SyntaxError_2: typeof ExprIntrp_SyntaxError_2;
  Handle_ExprIntrp_SyntaxError: typeof Handle_ExprIntrp_SyntaxError;
  Handle_ExprIntrp_SyntaxError_1: typeof Handle_ExprIntrp_SyntaxError_1;
  Handle_ExprIntrp_SyntaxError_2: typeof Handle_ExprIntrp_SyntaxError_2;
  Handle_ExprIntrp_SyntaxError_3: typeof Handle_ExprIntrp_SyntaxError_3;
  Handle_ExprIntrp_SyntaxError_4: typeof Handle_ExprIntrp_SyntaxError_4;
  ExprIntrp_GenRel: typeof ExprIntrp_GenRel;
  Handle_ExprIntrp_GenRel: typeof Handle_ExprIntrp_GenRel;
  Handle_ExprIntrp_GenRel_1: typeof Handle_ExprIntrp_GenRel_1;
  Handle_ExprIntrp_GenRel_2: typeof Handle_ExprIntrp_GenRel_2;
  Handle_ExprIntrp_GenRel_3: typeof Handle_ExprIntrp_GenRel_3;
  Handle_ExprIntrp_GenRel_4: typeof Handle_ExprIntrp_GenRel_4;
  Handle_ExprIntrp_GenFct: typeof Handle_ExprIntrp_GenFct;
  Handle_ExprIntrp_GenFct_1: typeof Handle_ExprIntrp_GenFct_1;
  Handle_ExprIntrp_GenFct_2: typeof Handle_ExprIntrp_GenFct_2;
  Handle_ExprIntrp_GenFct_3: typeof Handle_ExprIntrp_GenFct_3;
  Handle_ExprIntrp_GenFct_4: typeof Handle_ExprIntrp_GenFct_4;
  ExprIntrp_GenFct: typeof ExprIntrp_GenFct;
  ExprIntrp_Generator: typeof ExprIntrp_Generator;
  Handle_ExprIntrp_Generator: typeof Handle_ExprIntrp_Generator;
  Handle_ExprIntrp_Generator_1: typeof Handle_ExprIntrp_Generator_1;
  Handle_ExprIntrp_Generator_2: typeof Handle_ExprIntrp_Generator_2;
  Handle_ExprIntrp_Generator_3: typeof Handle_ExprIntrp_Generator_3;
  Handle_ExprIntrp_Generator_4: typeof Handle_ExprIntrp_Generator_4;
  Handle_STEPControl_Controller: typeof Handle_STEPControl_Controller;
  Handle_STEPControl_Controller_1: typeof Handle_STEPControl_Controller_1;
  Handle_STEPControl_Controller_2: typeof Handle_STEPControl_Controller_2;
  Handle_STEPControl_Controller_3: typeof Handle_STEPControl_Controller_3;
  Handle_STEPControl_Controller_4: typeof Handle_STEPControl_Controller_4;
  STEPControl_Controller: typeof STEPControl_Controller;
  Handle_STEPControl_ActorRead: typeof Handle_STEPControl_ActorRead;
  Handle_STEPControl_ActorRead_1: typeof Handle_STEPControl_ActorRead_1;
  Handle_STEPControl_ActorRead_2: typeof Handle_STEPControl_ActorRead_2;
  Handle_STEPControl_ActorRead_3: typeof Handle_STEPControl_ActorRead_3;
  Handle_STEPControl_ActorRead_4: typeof Handle_STEPControl_ActorRead_4;
  STEPControl_ActorRead: typeof STEPControl_ActorRead;
  STEPControl_Writer: typeof STEPControl_Writer;
  STEPControl_Writer_1: typeof STEPControl_Writer_1;
  STEPControl_Writer_2: typeof STEPControl_Writer_2;
  Handle_STEPControl_ActorWrite: typeof Handle_STEPControl_ActorWrite;
  Handle_STEPControl_ActorWrite_1: typeof Handle_STEPControl_ActorWrite_1;
  Handle_STEPControl_ActorWrite_2: typeof Handle_STEPControl_ActorWrite_2;
  Handle_STEPControl_ActorWrite_3: typeof Handle_STEPControl_ActorWrite_3;
  Handle_STEPControl_ActorWrite_4: typeof Handle_STEPControl_ActorWrite_4;
  STEPControl_ActorWrite: typeof STEPControl_ActorWrite;
  STEPControl_Reader: typeof STEPControl_Reader;
  STEPControl_Reader_1: typeof STEPControl_Reader_1;
  STEPControl_Reader_2: typeof STEPControl_Reader_2;
  STEPControl_StepModelType: STEPControl_StepModelType;
  Handle_BRepTopAdaptor_HVertex: typeof Handle_BRepTopAdaptor_HVertex;
  Handle_BRepTopAdaptor_HVertex_1: typeof Handle_BRepTopAdaptor_HVertex_1;
  Handle_BRepTopAdaptor_HVertex_2: typeof Handle_BRepTopAdaptor_HVertex_2;
  Handle_BRepTopAdaptor_HVertex_3: typeof Handle_BRepTopAdaptor_HVertex_3;
  Handle_BRepTopAdaptor_HVertex_4: typeof Handle_BRepTopAdaptor_HVertex_4;
  BRepTopAdaptor_HVertex: typeof BRepTopAdaptor_HVertex;
  BRepTopAdaptor_Tool: typeof BRepTopAdaptor_Tool;
  BRepTopAdaptor_Tool_1: typeof BRepTopAdaptor_Tool_1;
  BRepTopAdaptor_Tool_2: typeof BRepTopAdaptor_Tool_2;
  BRepTopAdaptor_Tool_3: typeof BRepTopAdaptor_Tool_3;
  BRepTopAdaptor_MapOfShapeTool: typeof BRepTopAdaptor_MapOfShapeTool;
  BRepTopAdaptor_MapOfShapeTool_1: typeof BRepTopAdaptor_MapOfShapeTool_1;
  BRepTopAdaptor_MapOfShapeTool_2: typeof BRepTopAdaptor_MapOfShapeTool_2;
  BRepTopAdaptor_MapOfShapeTool_3: typeof BRepTopAdaptor_MapOfShapeTool_3;
  BRepTopAdaptor_FClass2d: typeof BRepTopAdaptor_FClass2d;
  BRepTopAdaptor_TopolTool: typeof BRepTopAdaptor_TopolTool;
  BRepTopAdaptor_TopolTool_1: typeof BRepTopAdaptor_TopolTool_1;
  BRepTopAdaptor_TopolTool_2: typeof BRepTopAdaptor_TopolTool_2;
  Handle_BRepTopAdaptor_TopolTool: typeof Handle_BRepTopAdaptor_TopolTool;
  Handle_BRepTopAdaptor_TopolTool_1: typeof Handle_BRepTopAdaptor_TopolTool_1;
  Handle_BRepTopAdaptor_TopolTool_2: typeof Handle_BRepTopAdaptor_TopolTool_2;
  Handle_BRepTopAdaptor_TopolTool_3: typeof Handle_BRepTopAdaptor_TopolTool_3;
  Handle_BRepTopAdaptor_TopolTool_4: typeof Handle_BRepTopAdaptor_TopolTool_4;
  BRepApprox_TheMultiLineToolOfApprox: typeof BRepApprox_TheMultiLineToolOfApprox;
  BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox: typeof BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox;
  BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox_1: typeof BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox_1;
  BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox_2: typeof BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox_2;
  BRepApprox_BSpParFunctionOfMyBSplGradientOfTheComputeLineOfApprox: typeof BRepApprox_BSpParFunctionOfMyBSplGradientOfTheComputeLineOfApprox;
  BRepApprox_ThePrmPrmSvSurfacesOfApprox: typeof BRepApprox_ThePrmPrmSvSurfacesOfApprox;
  BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox: typeof BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox;
  BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_1: typeof BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_1;
  BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_2: typeof BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_2;
  BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_3: typeof BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_3;
  BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_4: typeof BRepApprox_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfApprox_4;
  BRepApprox_MyBSplGradientOfTheComputeLineOfApprox: typeof BRepApprox_MyBSplGradientOfTheComputeLineOfApprox;
  BRepApprox_MyBSplGradientOfTheComputeLineOfApprox_1: typeof BRepApprox_MyBSplGradientOfTheComputeLineOfApprox_1;
  BRepApprox_MyBSplGradientOfTheComputeLineOfApprox_2: typeof BRepApprox_MyBSplGradientOfTheComputeLineOfApprox_2;
  BRepApprox_BSpGradient_BFGSOfMyBSplGradientOfTheComputeLineOfApprox: typeof BRepApprox_BSpGradient_BFGSOfMyBSplGradientOfTheComputeLineOfApprox;
  BRepApprox_SurfaceTool: typeof BRepApprox_SurfaceTool;
  BRepApprox_ApproxLine: typeof BRepApprox_ApproxLine;
  BRepApprox_ApproxLine_1: typeof BRepApprox_ApproxLine_1;
  BRepApprox_ApproxLine_2: typeof BRepApprox_ApproxLine_2;
  Handle_BRepApprox_ApproxLine: typeof Handle_BRepApprox_ApproxLine;
  Handle_BRepApprox_ApproxLine_1: typeof Handle_BRepApprox_ApproxLine_1;
  Handle_BRepApprox_ApproxLine_2: typeof Handle_BRepApprox_ApproxLine_2;
  Handle_BRepApprox_ApproxLine_3: typeof Handle_BRepApprox_ApproxLine_3;
  Handle_BRepApprox_ApproxLine_4: typeof Handle_BRepApprox_ApproxLine_4;
  BRepApprox_MyGradientbisOfTheComputeLineOfApprox: typeof BRepApprox_MyGradientbisOfTheComputeLineOfApprox;
  BRepApprox_ParFunctionOfMyGradientbisOfTheComputeLineOfApprox: typeof BRepApprox_ParFunctionOfMyGradientbisOfTheComputeLineOfApprox;
  BRepApprox_MyGradientOfTheComputeLineBezierOfApprox: typeof BRepApprox_MyGradientOfTheComputeLineBezierOfApprox;
  BRepApprox_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfApprox: typeof BRepApprox_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfApprox;
  BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox: typeof BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox;
  BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_1: typeof BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_1;
  BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_2: typeof BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_2;
  BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_3: typeof BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox_3;
  BRepApprox_TheComputeLineOfApprox: typeof BRepApprox_TheComputeLineOfApprox;
  BRepApprox_TheComputeLineOfApprox_1: typeof BRepApprox_TheComputeLineOfApprox_1;
  BRepApprox_TheComputeLineOfApprox_2: typeof BRepApprox_TheComputeLineOfApprox_2;
  BRepApprox_TheComputeLineOfApprox_3: typeof BRepApprox_TheComputeLineOfApprox_3;
  BRepApprox_TheComputeLineOfApprox_4: typeof BRepApprox_TheComputeLineOfApprox_4;
  BRepApprox_TheImpPrmSvSurfacesOfApprox: typeof BRepApprox_TheImpPrmSvSurfacesOfApprox;
  BRepApprox_TheImpPrmSvSurfacesOfApprox_1: typeof BRepApprox_TheImpPrmSvSurfacesOfApprox_1;
  BRepApprox_TheImpPrmSvSurfacesOfApprox_2: typeof BRepApprox_TheImpPrmSvSurfacesOfApprox_2;
  BRepApprox_ParFunctionOfMyGradientOfTheComputeLineBezierOfApprox: typeof BRepApprox_ParFunctionOfMyGradientOfTheComputeLineBezierOfApprox;
  BRepApprox_TheMultiLineOfApprox: typeof BRepApprox_TheMultiLineOfApprox;
  BRepApprox_TheMultiLineOfApprox_1: typeof BRepApprox_TheMultiLineOfApprox_1;
  BRepApprox_TheMultiLineOfApprox_2: typeof BRepApprox_TheMultiLineOfApprox_2;
  BRepApprox_TheMultiLineOfApprox_3: typeof BRepApprox_TheMultiLineOfApprox_3;
  BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox: typeof BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox;
  BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_1: typeof BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_1;
  BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_2: typeof BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_2;
  BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_3: typeof BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_3;
  BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_4: typeof BRepApprox_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfApprox_4;
  BRepApprox_Gradient_BFGSOfMyGradientbisOfTheComputeLineOfApprox: typeof BRepApprox_Gradient_BFGSOfMyGradientbisOfTheComputeLineOfApprox;
  BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox: typeof BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox;
  BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_1: typeof BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_1;
  BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_2: typeof BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_2;
  BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_3: typeof BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_3;
  BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_4: typeof BRepApprox_ParLeastSquareOfMyGradientbisOfTheComputeLineOfApprox_4;
  BRepApprox_Gradient_BFGSOfMyGradientOfTheComputeLineBezierOfApprox: typeof BRepApprox_Gradient_BFGSOfMyGradientOfTheComputeLineBezierOfApprox;
  BRepApprox_TheComputeLineBezierOfApprox: typeof BRepApprox_TheComputeLineBezierOfApprox;
  BRepApprox_TheComputeLineBezierOfApprox_1: typeof BRepApprox_TheComputeLineBezierOfApprox_1;
  BRepApprox_TheComputeLineBezierOfApprox_2: typeof BRepApprox_TheComputeLineBezierOfApprox_2;
  BRepApprox_TheComputeLineBezierOfApprox_3: typeof BRepApprox_TheComputeLineBezierOfApprox_3;
  BRepApprox_TheComputeLineBezierOfApprox_4: typeof BRepApprox_TheComputeLineBezierOfApprox_4;
  IntStart_SITopolTool: typeof IntStart_SITopolTool;
  Handle_IntStart_SITopolTool: typeof Handle_IntStart_SITopolTool;
  Handle_IntStart_SITopolTool_1: typeof Handle_IntStart_SITopolTool_1;
  Handle_IntStart_SITopolTool_2: typeof Handle_IntStart_SITopolTool_2;
  Handle_IntStart_SITopolTool_3: typeof Handle_IntStart_SITopolTool_3;
  Handle_IntStart_SITopolTool_4: typeof Handle_IntStart_SITopolTool_4;
  Intf_InterferencePolygon2d: typeof Intf_InterferencePolygon2d;
  Intf_InterferencePolygon2d_1: typeof Intf_InterferencePolygon2d_1;
  Intf_InterferencePolygon2d_2: typeof Intf_InterferencePolygon2d_2;
  Intf_InterferencePolygon2d_3: typeof Intf_InterferencePolygon2d_3;
  Intf_PIType: Intf_PIType;
  Intf_Array1OfLin: typeof Intf_Array1OfLin;
  Intf_Array1OfLin_1: typeof Intf_Array1OfLin_1;
  Intf_Array1OfLin_2: typeof Intf_Array1OfLin_2;
  Intf_Array1OfLin_3: typeof Intf_Array1OfLin_3;
  Intf_Array1OfLin_4: typeof Intf_Array1OfLin_4;
  Intf_Array1OfLin_5: typeof Intf_Array1OfLin_5;
  Intf_SectionLine: typeof Intf_SectionLine;
  Intf_SectionLine_1: typeof Intf_SectionLine_1;
  Intf_SectionLine_2: typeof Intf_SectionLine_2;
  Intf_Interference: typeof Intf_Interference;
  Intf_Tool: typeof Intf_Tool;
  Intf_SeqOfSectionPoint: typeof Intf_SeqOfSectionPoint;
  Intf_SeqOfSectionPoint_1: typeof Intf_SeqOfSectionPoint_1;
  Intf_SeqOfSectionPoint_2: typeof Intf_SeqOfSectionPoint_2;
  Intf_SeqOfSectionPoint_3: typeof Intf_SeqOfSectionPoint_3;
  Intf_SeqOfTangentZone: typeof Intf_SeqOfTangentZone;
  Intf_SeqOfTangentZone_1: typeof Intf_SeqOfTangentZone_1;
  Intf_SeqOfTangentZone_2: typeof Intf_SeqOfTangentZone_2;
  Intf_SeqOfTangentZone_3: typeof Intf_SeqOfTangentZone_3;
  Intf_TangentZone: typeof Intf_TangentZone;
  Intf_SeqOfSectionLine: typeof Intf_SeqOfSectionLine;
  Intf_SeqOfSectionLine_1: typeof Intf_SeqOfSectionLine_1;
  Intf_SeqOfSectionLine_2: typeof Intf_SeqOfSectionLine_2;
  Intf_SeqOfSectionLine_3: typeof Intf_SeqOfSectionLine_3;
  Intf_SectionPoint: typeof Intf_SectionPoint;
  Intf_SectionPoint_1: typeof Intf_SectionPoint_1;
  Intf_SectionPoint_2: typeof Intf_SectionPoint_2;
  Intf_SectionPoint_3: typeof Intf_SectionPoint_3;
  Intf: typeof Intf;
  Intf_Polygon2d: typeof Intf_Polygon2d;
  Handle_APIHeaderSection_EditHeader: typeof Handle_APIHeaderSection_EditHeader;
  Handle_APIHeaderSection_EditHeader_1: typeof Handle_APIHeaderSection_EditHeader_1;
  Handle_APIHeaderSection_EditHeader_2: typeof Handle_APIHeaderSection_EditHeader_2;
  Handle_APIHeaderSection_EditHeader_3: typeof Handle_APIHeaderSection_EditHeader_3;
  Handle_APIHeaderSection_EditHeader_4: typeof Handle_APIHeaderSection_EditHeader_4;
  APIHeaderSection_EditHeader: typeof APIHeaderSection_EditHeader;
  APIHeaderSection_MakeHeader: typeof APIHeaderSection_MakeHeader;
  APIHeaderSection_MakeHeader_1: typeof APIHeaderSection_MakeHeader_1;
  APIHeaderSection_MakeHeader_2: typeof APIHeaderSection_MakeHeader_2;
  BRepIntCurveSurface_Inter: typeof BRepIntCurveSurface_Inter;
  GProp_PGProps: typeof GProp_PGProps;
  GProp_PGProps_1: typeof GProp_PGProps_1;
  GProp_PGProps_2: typeof GProp_PGProps_2;
  GProp_PGProps_3: typeof GProp_PGProps_3;
  GProp_PGProps_4: typeof GProp_PGProps_4;
  GProp_PGProps_5: typeof GProp_PGProps_5;
  GProp_EquaType: GProp_EquaType;
  GProp_ValueType: GProp_ValueType;
  GProp: typeof GProp;
  GProp_GProps: typeof GProp_GProps;
  GProp_GProps_1: typeof GProp_GProps_1;
  GProp_GProps_2: typeof GProp_GProps_2;
  GProp_CelGProps: typeof GProp_CelGProps;
  GProp_CelGProps_1: typeof GProp_CelGProps_1;
  GProp_CelGProps_2: typeof GProp_CelGProps_2;
  GProp_CelGProps_3: typeof GProp_CelGProps_3;
  GProp_CelGProps_4: typeof GProp_CelGProps_4;
  GProp_VelGProps: typeof GProp_VelGProps;
  GProp_VelGProps_1: typeof GProp_VelGProps_1;
  GProp_VelGProps_2: typeof GProp_VelGProps_2;
  GProp_VelGProps_3: typeof GProp_VelGProps_3;
  GProp_VelGProps_4: typeof GProp_VelGProps_4;
  GProp_VelGProps_5: typeof GProp_VelGProps_5;
  Handle_GProp_UndefinedAxis: typeof Handle_GProp_UndefinedAxis;
  Handle_GProp_UndefinedAxis_1: typeof Handle_GProp_UndefinedAxis_1;
  Handle_GProp_UndefinedAxis_2: typeof Handle_GProp_UndefinedAxis_2;
  Handle_GProp_UndefinedAxis_3: typeof Handle_GProp_UndefinedAxis_3;
  Handle_GProp_UndefinedAxis_4: typeof Handle_GProp_UndefinedAxis_4;
  GProp_UndefinedAxis: typeof GProp_UndefinedAxis;
  GProp_UndefinedAxis_1: typeof GProp_UndefinedAxis_1;
  GProp_UndefinedAxis_2: typeof GProp_UndefinedAxis_2;
  GProp_PEquation: typeof GProp_PEquation;
  GProp_SelGProps: typeof GProp_SelGProps;
  GProp_SelGProps_1: typeof GProp_SelGProps_1;
  GProp_SelGProps_2: typeof GProp_SelGProps_2;
  GProp_SelGProps_3: typeof GProp_SelGProps_3;
  GProp_SelGProps_4: typeof GProp_SelGProps_4;
  GProp_SelGProps_5: typeof GProp_SelGProps_5;
  GProp_PrincipalProps: typeof GProp_PrincipalProps;
  GCE2d_MakeSegment: typeof GCE2d_MakeSegment;
  GCE2d_MakeSegment_1: typeof GCE2d_MakeSegment_1;
  GCE2d_MakeSegment_2: typeof GCE2d_MakeSegment_2;
  GCE2d_MakeSegment_3: typeof GCE2d_MakeSegment_3;
  GCE2d_MakeSegment_4: typeof GCE2d_MakeSegment_4;
  GCE2d_MakeSegment_5: typeof GCE2d_MakeSegment_5;
  GCE2d_MakeEllipse: typeof GCE2d_MakeEllipse;
  GCE2d_MakeEllipse_1: typeof GCE2d_MakeEllipse_1;
  GCE2d_MakeEllipse_2: typeof GCE2d_MakeEllipse_2;
  GCE2d_MakeEllipse_3: typeof GCE2d_MakeEllipse_3;
  GCE2d_MakeEllipse_4: typeof GCE2d_MakeEllipse_4;
  GCE2d_MakeHyperbola: typeof GCE2d_MakeHyperbola;
  GCE2d_MakeHyperbola_1: typeof GCE2d_MakeHyperbola_1;
  GCE2d_MakeHyperbola_2: typeof GCE2d_MakeHyperbola_2;
  GCE2d_MakeHyperbola_3: typeof GCE2d_MakeHyperbola_3;
  GCE2d_MakeHyperbola_4: typeof GCE2d_MakeHyperbola_4;
  GCE2d_MakeLine: typeof GCE2d_MakeLine;
  GCE2d_MakeLine_1: typeof GCE2d_MakeLine_1;
  GCE2d_MakeLine_2: typeof GCE2d_MakeLine_2;
  GCE2d_MakeLine_3: typeof GCE2d_MakeLine_3;
  GCE2d_MakeLine_4: typeof GCE2d_MakeLine_4;
  GCE2d_MakeLine_5: typeof GCE2d_MakeLine_5;
  GCE2d_MakeLine_6: typeof GCE2d_MakeLine_6;
  GCE2d_MakeArcOfCircle: typeof GCE2d_MakeArcOfCircle;
  GCE2d_MakeArcOfCircle_1: typeof GCE2d_MakeArcOfCircle_1;
  GCE2d_MakeArcOfCircle_2: typeof GCE2d_MakeArcOfCircle_2;
  GCE2d_MakeArcOfCircle_3: typeof GCE2d_MakeArcOfCircle_3;
  GCE2d_MakeArcOfCircle_4: typeof GCE2d_MakeArcOfCircle_4;
  GCE2d_MakeArcOfCircle_5: typeof GCE2d_MakeArcOfCircle_5;
  GCE2d_MakeRotation: typeof GCE2d_MakeRotation;
  GCE2d_MakeParabola: typeof GCE2d_MakeParabola;
  GCE2d_MakeParabola_1: typeof GCE2d_MakeParabola_1;
  GCE2d_MakeParabola_2: typeof GCE2d_MakeParabola_2;
  GCE2d_MakeParabola_3: typeof GCE2d_MakeParabola_3;
  GCE2d_MakeParabola_4: typeof GCE2d_MakeParabola_4;
  GCE2d_MakeParabola_5: typeof GCE2d_MakeParabola_5;
  GCE2d_MakeTranslation: typeof GCE2d_MakeTranslation;
  GCE2d_MakeTranslation_1: typeof GCE2d_MakeTranslation_1;
  GCE2d_MakeTranslation_2: typeof GCE2d_MakeTranslation_2;
  GCE2d_MakeArcOfHyperbola: typeof GCE2d_MakeArcOfHyperbola;
  GCE2d_MakeArcOfHyperbola_1: typeof GCE2d_MakeArcOfHyperbola_1;
  GCE2d_MakeArcOfHyperbola_2: typeof GCE2d_MakeArcOfHyperbola_2;
  GCE2d_MakeArcOfHyperbola_3: typeof GCE2d_MakeArcOfHyperbola_3;
  GCE2d_MakeCircle: typeof GCE2d_MakeCircle;
  GCE2d_MakeCircle_1: typeof GCE2d_MakeCircle_1;
  GCE2d_MakeCircle_2: typeof GCE2d_MakeCircle_2;
  GCE2d_MakeCircle_3: typeof GCE2d_MakeCircle_3;
  GCE2d_MakeCircle_4: typeof GCE2d_MakeCircle_4;
  GCE2d_MakeCircle_5: typeof GCE2d_MakeCircle_5;
  GCE2d_MakeCircle_6: typeof GCE2d_MakeCircle_6;
  GCE2d_MakeCircle_7: typeof GCE2d_MakeCircle_7;
  GCE2d_MakeCircle_8: typeof GCE2d_MakeCircle_8;
  GCE2d_MakeArcOfParabola: typeof GCE2d_MakeArcOfParabola;
  GCE2d_MakeArcOfParabola_1: typeof GCE2d_MakeArcOfParabola_1;
  GCE2d_MakeArcOfParabola_2: typeof GCE2d_MakeArcOfParabola_2;
  GCE2d_MakeArcOfParabola_3: typeof GCE2d_MakeArcOfParabola_3;
  GCE2d_MakeArcOfEllipse: typeof GCE2d_MakeArcOfEllipse;
  GCE2d_MakeArcOfEllipse_1: typeof GCE2d_MakeArcOfEllipse_1;
  GCE2d_MakeArcOfEllipse_2: typeof GCE2d_MakeArcOfEllipse_2;
  GCE2d_MakeArcOfEllipse_3: typeof GCE2d_MakeArcOfEllipse_3;
  GCE2d_MakeScale: typeof GCE2d_MakeScale;
  GCE2d_MakeMirror: typeof GCE2d_MakeMirror;
  GCE2d_MakeMirror_1: typeof GCE2d_MakeMirror_1;
  GCE2d_MakeMirror_2: typeof GCE2d_MakeMirror_2;
  GCE2d_MakeMirror_3: typeof GCE2d_MakeMirror_3;
  GCE2d_MakeMirror_4: typeof GCE2d_MakeMirror_4;
  GCE2d_Root: typeof GCE2d_Root;
  StepToTopoDS: typeof StepToTopoDS;
  StepToTopoDS_PointPair: typeof StepToTopoDS_PointPair;
  StepToTopoDS_TranslateFaceError: StepToTopoDS_TranslateFaceError;
  StepToTopoDS_CartesianPointHasher: typeof StepToTopoDS_CartesianPointHasher;
  StepToTopoDS_PointEdgeMap: typeof StepToTopoDS_PointEdgeMap;
  StepToTopoDS_PointEdgeMap_1: typeof StepToTopoDS_PointEdgeMap_1;
  StepToTopoDS_PointEdgeMap_2: typeof StepToTopoDS_PointEdgeMap_2;
  StepToTopoDS_PointEdgeMap_3: typeof StepToTopoDS_PointEdgeMap_3;
  StepToTopoDS_TranslateEdge: typeof StepToTopoDS_TranslateEdge;
  StepToTopoDS_TranslateEdge_1: typeof StepToTopoDS_TranslateEdge_1;
  StepToTopoDS_TranslateEdge_2: typeof StepToTopoDS_TranslateEdge_2;
  StepToTopoDS_TranslateFace: typeof StepToTopoDS_TranslateFace;
  StepToTopoDS_TranslateFace_1: typeof StepToTopoDS_TranslateFace_1;
  StepToTopoDS_TranslateFace_2: typeof StepToTopoDS_TranslateFace_2;
  StepToTopoDS_TranslateShellError: StepToTopoDS_TranslateShellError;
  StepToTopoDS_DataMapOfRINames: typeof StepToTopoDS_DataMapOfRINames;
  StepToTopoDS_DataMapOfRINames_1: typeof StepToTopoDS_DataMapOfRINames_1;
  StepToTopoDS_DataMapOfRINames_2: typeof StepToTopoDS_DataMapOfRINames_2;
  StepToTopoDS_DataMapOfRINames_3: typeof StepToTopoDS_DataMapOfRINames_3;
  StepToTopoDS_TranslateVertexError: StepToTopoDS_TranslateVertexError;
  StepToTopoDS_MakeTransformed: typeof StepToTopoDS_MakeTransformed;
  StepToTopoDS_TranslateShell: typeof StepToTopoDS_TranslateShell;
  StepToTopoDS_PointPairHasher: typeof StepToTopoDS_PointPairHasher;
  StepToTopoDS_TranslateCompositeCurve: typeof StepToTopoDS_TranslateCompositeCurve;
  StepToTopoDS_TranslateCompositeCurve_1: typeof StepToTopoDS_TranslateCompositeCurve_1;
  StepToTopoDS_TranslateCompositeCurve_2: typeof StepToTopoDS_TranslateCompositeCurve_2;
  StepToTopoDS_TranslateCompositeCurve_3: typeof StepToTopoDS_TranslateCompositeCurve_3;
  StepToTopoDS_TranslateEdgeError: StepToTopoDS_TranslateEdgeError;
  StepToTopoDS_GeometricTool: typeof StepToTopoDS_GeometricTool;
  StepToTopoDS_TranslateEdgeLoopError: StepToTopoDS_TranslateEdgeLoopError;
  StepToTopoDS_TranslatePolyLoop: typeof StepToTopoDS_TranslatePolyLoop;
  StepToTopoDS_TranslatePolyLoop_1: typeof StepToTopoDS_TranslatePolyLoop_1;
  StepToTopoDS_TranslatePolyLoop_2: typeof StepToTopoDS_TranslatePolyLoop_2;
  StepToTopoDS_TranslateCurveBoundedSurface: typeof StepToTopoDS_TranslateCurveBoundedSurface;
  StepToTopoDS_TranslateCurveBoundedSurface_1: typeof StepToTopoDS_TranslateCurveBoundedSurface_1;
  StepToTopoDS_TranslateCurveBoundedSurface_2: typeof StepToTopoDS_TranslateCurveBoundedSurface_2;
  StepToTopoDS_BuilderError: StepToTopoDS_BuilderError;
  StepToTopoDS_TranslateEdgeLoop: typeof StepToTopoDS_TranslateEdgeLoop;
  StepToTopoDS_TranslateEdgeLoop_1: typeof StepToTopoDS_TranslateEdgeLoop_1;
  StepToTopoDS_TranslateEdgeLoop_2: typeof StepToTopoDS_TranslateEdgeLoop_2;
  StepToTopoDS_GeometricToolError: StepToTopoDS_GeometricToolError;
  StepToTopoDS_TranslatePolyLoopError: StepToTopoDS_TranslatePolyLoopError;
  StepToTopoDS_TranslateVertex: typeof StepToTopoDS_TranslateVertex;
  StepToTopoDS_TranslateVertex_1: typeof StepToTopoDS_TranslateVertex_1;
  StepToTopoDS_TranslateVertex_2: typeof StepToTopoDS_TranslateVertex_2;
  StepToTopoDS_Root: typeof StepToTopoDS_Root;
  StepToTopoDS_Tool: typeof StepToTopoDS_Tool;
  StepToTopoDS_Tool_1: typeof StepToTopoDS_Tool_1;
  StepToTopoDS_Tool_2: typeof StepToTopoDS_Tool_2;
  StepToTopoDS_TranslateVertexLoop: typeof StepToTopoDS_TranslateVertexLoop;
  StepToTopoDS_TranslateVertexLoop_1: typeof StepToTopoDS_TranslateVertexLoop_1;
  StepToTopoDS_TranslateVertexLoop_2: typeof StepToTopoDS_TranslateVertexLoop_2;
  StepToTopoDS_NMTool: typeof StepToTopoDS_NMTool;
  StepToTopoDS_NMTool_1: typeof StepToTopoDS_NMTool_1;
  StepToTopoDS_NMTool_2: typeof StepToTopoDS_NMTool_2;
  StepToTopoDS_Builder: typeof StepToTopoDS_Builder;
  StepToTopoDS_TranslateVertexLoopError: StepToTopoDS_TranslateVertexLoopError;
  Handle_BinMDocStd_XLinkDriver: typeof Handle_BinMDocStd_XLinkDriver;
  Handle_BinMDocStd_XLinkDriver_1: typeof Handle_BinMDocStd_XLinkDriver_1;
  Handle_BinMDocStd_XLinkDriver_2: typeof Handle_BinMDocStd_XLinkDriver_2;
  Handle_BinMDocStd_XLinkDriver_3: typeof Handle_BinMDocStd_XLinkDriver_3;
  Handle_BinMDocStd_XLinkDriver_4: typeof Handle_BinMDocStd_XLinkDriver_4;
  BinMDocStd_XLinkDriver: typeof BinMDocStd_XLinkDriver;
  BinMDocStd: typeof BinMDocStd;
  ProjLib_PrjResolve: typeof ProjLib_PrjResolve;
  ProjLib_ComputeApproxOnPolarSurface: typeof ProjLib_ComputeApproxOnPolarSurface;
  ProjLib_ComputeApproxOnPolarSurface_1: typeof ProjLib_ComputeApproxOnPolarSurface_1;
  ProjLib_ComputeApproxOnPolarSurface_2: typeof ProjLib_ComputeApproxOnPolarSurface_2;
  ProjLib_ComputeApproxOnPolarSurface_3: typeof ProjLib_ComputeApproxOnPolarSurface_3;
  ProjLib_ComputeApproxOnPolarSurface_4: typeof ProjLib_ComputeApproxOnPolarSurface_4;
  Handle_ProjLib_HProjectedCurve: typeof Handle_ProjLib_HProjectedCurve;
  Handle_ProjLib_HProjectedCurve_1: typeof Handle_ProjLib_HProjectedCurve_1;
  Handle_ProjLib_HProjectedCurve_2: typeof Handle_ProjLib_HProjectedCurve_2;
  Handle_ProjLib_HProjectedCurve_3: typeof Handle_ProjLib_HProjectedCurve_3;
  Handle_ProjLib_HProjectedCurve_4: typeof Handle_ProjLib_HProjectedCurve_4;
  ProjLib_HProjectedCurve: typeof ProjLib_HProjectedCurve;
  ProjLib_HProjectedCurve_1: typeof ProjLib_HProjectedCurve_1;
  ProjLib_HProjectedCurve_2: typeof ProjLib_HProjectedCurve_2;
  ProjLib_Cone: typeof ProjLib_Cone;
  ProjLib_Cone_1: typeof ProjLib_Cone_1;
  ProjLib_Cone_2: typeof ProjLib_Cone_2;
  ProjLib_Cone_3: typeof ProjLib_Cone_3;
  ProjLib_Cone_4: typeof ProjLib_Cone_4;
  Handle_ProjLib_HCompProjectedCurve: typeof Handle_ProjLib_HCompProjectedCurve;
  Handle_ProjLib_HCompProjectedCurve_1: typeof Handle_ProjLib_HCompProjectedCurve_1;
  Handle_ProjLib_HCompProjectedCurve_2: typeof Handle_ProjLib_HCompProjectedCurve_2;
  Handle_ProjLib_HCompProjectedCurve_3: typeof Handle_ProjLib_HCompProjectedCurve_3;
  Handle_ProjLib_HCompProjectedCurve_4: typeof Handle_ProjLib_HCompProjectedCurve_4;
  ProjLib_HCompProjectedCurve: typeof ProjLib_HCompProjectedCurve;
  ProjLib_HCompProjectedCurve_1: typeof ProjLib_HCompProjectedCurve_1;
  ProjLib_HCompProjectedCurve_2: typeof ProjLib_HCompProjectedCurve_2;
  ProjLib_Torus: typeof ProjLib_Torus;
  ProjLib_Torus_1: typeof ProjLib_Torus_1;
  ProjLib_Torus_2: typeof ProjLib_Torus_2;
  ProjLib_Torus_3: typeof ProjLib_Torus_3;
  ProjLib_CompProjectedCurve: typeof ProjLib_CompProjectedCurve;
  ProjLib_CompProjectedCurve_1: typeof ProjLib_CompProjectedCurve_1;
  ProjLib_CompProjectedCurve_2: typeof ProjLib_CompProjectedCurve_2;
  ProjLib_CompProjectedCurve_3: typeof ProjLib_CompProjectedCurve_3;
  ProjLib_PrjFunc: typeof ProjLib_PrjFunc;
  ProjLib: typeof ProjLib;
  ProjLib_Sphere: typeof ProjLib_Sphere;
  ProjLib_Sphere_1: typeof ProjLib_Sphere_1;
  ProjLib_Sphere_2: typeof ProjLib_Sphere_2;
  ProjLib_Sphere_3: typeof ProjLib_Sphere_3;
  ProjLib_Projector: typeof ProjLib_Projector;
  ProjLib_Cylinder: typeof ProjLib_Cylinder;
  ProjLib_Cylinder_1: typeof ProjLib_Cylinder_1;
  ProjLib_Cylinder_2: typeof ProjLib_Cylinder_2;
  ProjLib_Cylinder_3: typeof ProjLib_Cylinder_3;
  ProjLib_Cylinder_4: typeof ProjLib_Cylinder_4;
  ProjLib_Cylinder_5: typeof ProjLib_Cylinder_5;
  ProjLib_ComputeApprox: typeof ProjLib_ComputeApprox;
  ProjLib_ComputeApprox_1: typeof ProjLib_ComputeApprox_1;
  ProjLib_ComputeApprox_2: typeof ProjLib_ComputeApprox_2;
  ProjLib_ProjectOnPlane: typeof ProjLib_ProjectOnPlane;
  ProjLib_ProjectOnPlane_1: typeof ProjLib_ProjectOnPlane_1;
  ProjLib_ProjectOnPlane_2: typeof ProjLib_ProjectOnPlane_2;
  ProjLib_ProjectOnPlane_3: typeof ProjLib_ProjectOnPlane_3;
  ProjLib_ProjectedCurve: typeof ProjLib_ProjectedCurve;
  ProjLib_ProjectedCurve_1: typeof ProjLib_ProjectedCurve_1;
  ProjLib_ProjectedCurve_2: typeof ProjLib_ProjectedCurve_2;
  ProjLib_ProjectedCurve_3: typeof ProjLib_ProjectedCurve_3;
  ProjLib_ProjectedCurve_4: typeof ProjLib_ProjectedCurve_4;
  ProjLib_Plane: typeof ProjLib_Plane;
  ProjLib_Plane_1: typeof ProjLib_Plane_1;
  ProjLib_Plane_2: typeof ProjLib_Plane_2;
  ProjLib_Plane_3: typeof ProjLib_Plane_3;
  ProjLib_Plane_4: typeof ProjLib_Plane_4;
  ProjLib_Plane_5: typeof ProjLib_Plane_5;
  ProjLib_Plane_6: typeof ProjLib_Plane_6;
  ProjLib_Plane_7: typeof ProjLib_Plane_7;
  Handle_ProjLib_HSequenceOfHSequenceOfPnt: typeof Handle_ProjLib_HSequenceOfHSequenceOfPnt;
  Handle_ProjLib_HSequenceOfHSequenceOfPnt_1: typeof Handle_ProjLib_HSequenceOfHSequenceOfPnt_1;
  Handle_ProjLib_HSequenceOfHSequenceOfPnt_2: typeof Handle_ProjLib_HSequenceOfHSequenceOfPnt_2;
  Handle_ProjLib_HSequenceOfHSequenceOfPnt_3: typeof Handle_ProjLib_HSequenceOfHSequenceOfPnt_3;
  Handle_ProjLib_HSequenceOfHSequenceOfPnt_4: typeof Handle_ProjLib_HSequenceOfHSequenceOfPnt_4;
  OSD_SharedLibrary: typeof OSD_SharedLibrary;
  OSD_SharedLibrary_1: typeof OSD_SharedLibrary_1;
  OSD_SharedLibrary_2: typeof OSD_SharedLibrary_2;
  OSD_Exception_INVALID_DISPOSITION: typeof OSD_Exception_INVALID_DISPOSITION;
  OSD_Exception_INVALID_DISPOSITION_1: typeof OSD_Exception_INVALID_DISPOSITION_1;
  OSD_Exception_INVALID_DISPOSITION_2: typeof OSD_Exception_INVALID_DISPOSITION_2;
  Handle_OSD_Exception_INVALID_DISPOSITION: typeof Handle_OSD_Exception_INVALID_DISPOSITION;
  Handle_OSD_Exception_INVALID_DISPOSITION_1: typeof Handle_OSD_Exception_INVALID_DISPOSITION_1;
  Handle_OSD_Exception_INVALID_DISPOSITION_2: typeof Handle_OSD_Exception_INVALID_DISPOSITION_2;
  Handle_OSD_Exception_INVALID_DISPOSITION_3: typeof Handle_OSD_Exception_INVALID_DISPOSITION_3;
  Handle_OSD_Exception_INVALID_DISPOSITION_4: typeof Handle_OSD_Exception_INVALID_DISPOSITION_4;
  OSD_WhoAmI: OSD_WhoAmI;
  OSD_SIGBUS: typeof OSD_SIGBUS;
  OSD_SIGBUS_1: typeof OSD_SIGBUS_1;
  OSD_SIGBUS_2: typeof OSD_SIGBUS_2;
  Handle_OSD_SIGBUS: typeof Handle_OSD_SIGBUS;
  Handle_OSD_SIGBUS_1: typeof Handle_OSD_SIGBUS_1;
  Handle_OSD_SIGBUS_2: typeof Handle_OSD_SIGBUS_2;
  Handle_OSD_SIGBUS_3: typeof Handle_OSD_SIGBUS_3;
  Handle_OSD_SIGBUS_4: typeof Handle_OSD_SIGBUS_4;
  OSD_Process: typeof OSD_Process;
  OSD_Thread: typeof OSD_Thread;
  OSD_Thread_1: typeof OSD_Thread_1;
  OSD_Thread_2: typeof OSD_Thread_2;
  OSD_Thread_3: typeof OSD_Thread_3;
  OSD_SIGSEGV: typeof OSD_SIGSEGV;
  OSD_SIGSEGV_1: typeof OSD_SIGSEGV_1;
  OSD_SIGSEGV_2: typeof OSD_SIGSEGV_2;
  Handle_OSD_SIGSEGV: typeof Handle_OSD_SIGSEGV;
  Handle_OSD_SIGSEGV_1: typeof Handle_OSD_SIGSEGV_1;
  Handle_OSD_SIGSEGV_2: typeof Handle_OSD_SIGSEGV_2;
  Handle_OSD_SIGSEGV_3: typeof Handle_OSD_SIGSEGV_3;
  Handle_OSD_SIGSEGV_4: typeof Handle_OSD_SIGSEGV_4;
  Handle_OSD_Signal: typeof Handle_OSD_Signal;
  Handle_OSD_Signal_1: typeof Handle_OSD_Signal_1;
  Handle_OSD_Signal_2: typeof Handle_OSD_Signal_2;
  Handle_OSD_Signal_3: typeof Handle_OSD_Signal_3;
  Handle_OSD_Signal_4: typeof Handle_OSD_Signal_4;
  OSD_Signal: typeof OSD_Signal;
  OSD_Signal_1: typeof OSD_Signal_1;
  OSD_Signal_2: typeof OSD_Signal_2;
  Handle_OSD_Exception_PRIV_INSTRUCTION: typeof Handle_OSD_Exception_PRIV_INSTRUCTION;
  Handle_OSD_Exception_PRIV_INSTRUCTION_1: typeof Handle_OSD_Exception_PRIV_INSTRUCTION_1;
  Handle_OSD_Exception_PRIV_INSTRUCTION_2: typeof Handle_OSD_Exception_PRIV_INSTRUCTION_2;
  Handle_OSD_Exception_PRIV_INSTRUCTION_3: typeof Handle_OSD_Exception_PRIV_INSTRUCTION_3;
  Handle_OSD_Exception_PRIV_INSTRUCTION_4: typeof Handle_OSD_Exception_PRIV_INSTRUCTION_4;
  OSD_Exception_PRIV_INSTRUCTION: typeof OSD_Exception_PRIV_INSTRUCTION;
  OSD_Exception_PRIV_INSTRUCTION_1: typeof OSD_Exception_PRIV_INSTRUCTION_1;
  OSD_Exception_PRIV_INSTRUCTION_2: typeof OSD_Exception_PRIV_INSTRUCTION_2;
  OSD_Disk: typeof OSD_Disk;
  OSD_Disk_1: typeof OSD_Disk_1;
  OSD_Disk_2: typeof OSD_Disk_2;
  OSD_Disk_3: typeof OSD_Disk_3;
  OSD_SIGINT: typeof OSD_SIGINT;
  OSD_SIGINT_1: typeof OSD_SIGINT_1;
  OSD_SIGINT_2: typeof OSD_SIGINT_2;
  Handle_OSD_SIGINT: typeof Handle_OSD_SIGINT;
  Handle_OSD_SIGINT_1: typeof Handle_OSD_SIGINT_1;
  Handle_OSD_SIGINT_2: typeof Handle_OSD_SIGINT_2;
  Handle_OSD_SIGINT_3: typeof Handle_OSD_SIGINT_3;
  Handle_OSD_SIGINT_4: typeof Handle_OSD_SIGINT_4;
  OSD_OpenMode: OSD_OpenMode;
  OSD_Exception_STATUS_NO_MEMORY: typeof OSD_Exception_STATUS_NO_MEMORY;
  OSD_Exception_STATUS_NO_MEMORY_1: typeof OSD_Exception_STATUS_NO_MEMORY_1;
  OSD_Exception_STATUS_NO_MEMORY_2: typeof OSD_Exception_STATUS_NO_MEMORY_2;
  Handle_OSD_Exception_STATUS_NO_MEMORY: typeof Handle_OSD_Exception_STATUS_NO_MEMORY;
  Handle_OSD_Exception_STATUS_NO_MEMORY_1: typeof Handle_OSD_Exception_STATUS_NO_MEMORY_1;
  Handle_OSD_Exception_STATUS_NO_MEMORY_2: typeof Handle_OSD_Exception_STATUS_NO_MEMORY_2;
  Handle_OSD_Exception_STATUS_NO_MEMORY_3: typeof Handle_OSD_Exception_STATUS_NO_MEMORY_3;
  Handle_OSD_Exception_STATUS_NO_MEMORY_4: typeof Handle_OSD_Exception_STATUS_NO_MEMORY_4;
  Handle_OSD_Exception_FLT_UNDERFLOW: typeof Handle_OSD_Exception_FLT_UNDERFLOW;
  Handle_OSD_Exception_FLT_UNDERFLOW_1: typeof Handle_OSD_Exception_FLT_UNDERFLOW_1;
  Handle_OSD_Exception_FLT_UNDERFLOW_2: typeof Handle_OSD_Exception_FLT_UNDERFLOW_2;
  Handle_OSD_Exception_FLT_UNDERFLOW_3: typeof Handle_OSD_Exception_FLT_UNDERFLOW_3;
  Handle_OSD_Exception_FLT_UNDERFLOW_4: typeof Handle_OSD_Exception_FLT_UNDERFLOW_4;
  OSD_Exception_FLT_UNDERFLOW: typeof OSD_Exception_FLT_UNDERFLOW;
  OSD_Exception_FLT_UNDERFLOW_1: typeof OSD_Exception_FLT_UNDERFLOW_1;
  OSD_Exception_FLT_UNDERFLOW_2: typeof OSD_Exception_FLT_UNDERFLOW_2;
  OSD_Exception_INT_OVERFLOW: typeof OSD_Exception_INT_OVERFLOW;
  OSD_Exception_INT_OVERFLOW_1: typeof OSD_Exception_INT_OVERFLOW_1;
  OSD_Exception_INT_OVERFLOW_2: typeof OSD_Exception_INT_OVERFLOW_2;
  Handle_OSD_Exception_INT_OVERFLOW: typeof Handle_OSD_Exception_INT_OVERFLOW;
  Handle_OSD_Exception_INT_OVERFLOW_1: typeof Handle_OSD_Exception_INT_OVERFLOW_1;
  Handle_OSD_Exception_INT_OVERFLOW_2: typeof Handle_OSD_Exception_INT_OVERFLOW_2;
  Handle_OSD_Exception_INT_OVERFLOW_3: typeof Handle_OSD_Exception_INT_OVERFLOW_3;
  Handle_OSD_Exception_INT_OVERFLOW_4: typeof Handle_OSD_Exception_INT_OVERFLOW_4;
  OSD: typeof OSD;
  OSD_Exception_IN_PAGE_ERROR: typeof OSD_Exception_IN_PAGE_ERROR;
  OSD_Exception_IN_PAGE_ERROR_1: typeof OSD_Exception_IN_PAGE_ERROR_1;
  OSD_Exception_IN_PAGE_ERROR_2: typeof OSD_Exception_IN_PAGE_ERROR_2;
  Handle_OSD_Exception_IN_PAGE_ERROR: typeof Handle_OSD_Exception_IN_PAGE_ERROR;
  Handle_OSD_Exception_IN_PAGE_ERROR_1: typeof Handle_OSD_Exception_IN_PAGE_ERROR_1;
  Handle_OSD_Exception_IN_PAGE_ERROR_2: typeof Handle_OSD_Exception_IN_PAGE_ERROR_2;
  Handle_OSD_Exception_IN_PAGE_ERROR_3: typeof Handle_OSD_Exception_IN_PAGE_ERROR_3;
  Handle_OSD_Exception_IN_PAGE_ERROR_4: typeof Handle_OSD_Exception_IN_PAGE_ERROR_4;
  OSD_OEMType: OSD_OEMType;
  OSD_MemInfo: typeof OSD_MemInfo;
  OSD_SysType: OSD_SysType;
  OSD_Exception_ILLEGAL_INSTRUCTION: typeof OSD_Exception_ILLEGAL_INSTRUCTION;
  OSD_Exception_ILLEGAL_INSTRUCTION_1: typeof OSD_Exception_ILLEGAL_INSTRUCTION_1;
  OSD_Exception_ILLEGAL_INSTRUCTION_2: typeof OSD_Exception_ILLEGAL_INSTRUCTION_2;
  Handle_OSD_Exception_ILLEGAL_INSTRUCTION: typeof Handle_OSD_Exception_ILLEGAL_INSTRUCTION;
  Handle_OSD_Exception_ILLEGAL_INSTRUCTION_1: typeof Handle_OSD_Exception_ILLEGAL_INSTRUCTION_1;
  Handle_OSD_Exception_ILLEGAL_INSTRUCTION_2: typeof Handle_OSD_Exception_ILLEGAL_INSTRUCTION_2;
  Handle_OSD_Exception_ILLEGAL_INSTRUCTION_3: typeof Handle_OSD_Exception_ILLEGAL_INSTRUCTION_3;
  Handle_OSD_Exception_ILLEGAL_INSTRUCTION_4: typeof Handle_OSD_Exception_ILLEGAL_INSTRUCTION_4;
  OSD_ThreadPool: typeof OSD_ThreadPool;
  OSD_FileIterator: typeof OSD_FileIterator;
  OSD_FileIterator_1: typeof OSD_FileIterator_1;
  OSD_FileIterator_2: typeof OSD_FileIterator_2;
  OSD_SIGILL: typeof OSD_SIGILL;
  OSD_SIGILL_1: typeof OSD_SIGILL_1;
  OSD_SIGILL_2: typeof OSD_SIGILL_2;
  Handle_OSD_SIGILL: typeof Handle_OSD_SIGILL;
  Handle_OSD_SIGILL_1: typeof Handle_OSD_SIGILL_1;
  Handle_OSD_SIGILL_2: typeof Handle_OSD_SIGILL_2;
  Handle_OSD_SIGILL_3: typeof Handle_OSD_SIGILL_3;
  Handle_OSD_SIGILL_4: typeof Handle_OSD_SIGILL_4;
  OSD_SIGHUP: typeof OSD_SIGHUP;
  OSD_SIGHUP_1: typeof OSD_SIGHUP_1;
  OSD_SIGHUP_2: typeof OSD_SIGHUP_2;
  Handle_OSD_SIGHUP: typeof Handle_OSD_SIGHUP;
  Handle_OSD_SIGHUP_1: typeof Handle_OSD_SIGHUP_1;
  Handle_OSD_SIGHUP_2: typeof Handle_OSD_SIGHUP_2;
  Handle_OSD_SIGHUP_3: typeof Handle_OSD_SIGHUP_3;
  Handle_OSD_SIGHUP_4: typeof Handle_OSD_SIGHUP_4;
  OSD_Exception_FLT_INVALID_OPERATION: typeof OSD_Exception_FLT_INVALID_OPERATION;
  OSD_Exception_FLT_INVALID_OPERATION_1: typeof OSD_Exception_FLT_INVALID_OPERATION_1;
  OSD_Exception_FLT_INVALID_OPERATION_2: typeof OSD_Exception_FLT_INVALID_OPERATION_2;
  Handle_OSD_Exception_FLT_INVALID_OPERATION: typeof Handle_OSD_Exception_FLT_INVALID_OPERATION;
  Handle_OSD_Exception_FLT_INVALID_OPERATION_1: typeof Handle_OSD_Exception_FLT_INVALID_OPERATION_1;
  Handle_OSD_Exception_FLT_INVALID_OPERATION_2: typeof Handle_OSD_Exception_FLT_INVALID_OPERATION_2;
  Handle_OSD_Exception_FLT_INVALID_OPERATION_3: typeof Handle_OSD_Exception_FLT_INVALID_OPERATION_3;
  Handle_OSD_Exception_FLT_INVALID_OPERATION_4: typeof Handle_OSD_Exception_FLT_INVALID_OPERATION_4;
  OSD_Directory: typeof OSD_Directory;
  OSD_Directory_1: typeof OSD_Directory_1;
  OSD_Directory_2: typeof OSD_Directory_2;
  OSD_Error: typeof OSD_Error;
  OSD_Host: typeof OSD_Host;
  OSD_LockType: OSD_LockType;
  OSD_Exception_FLT_DENORMAL_OPERAND: typeof OSD_Exception_FLT_DENORMAL_OPERAND;
  OSD_Exception_FLT_DENORMAL_OPERAND_1: typeof OSD_Exception_FLT_DENORMAL_OPERAND_1;
  OSD_Exception_FLT_DENORMAL_OPERAND_2: typeof OSD_Exception_FLT_DENORMAL_OPERAND_2;
  Handle_OSD_Exception_FLT_DENORMAL_OPERAND: typeof Handle_OSD_Exception_FLT_DENORMAL_OPERAND;
  Handle_OSD_Exception_FLT_DENORMAL_OPERAND_1: typeof Handle_OSD_Exception_FLT_DENORMAL_OPERAND_1;
  Handle_OSD_Exception_FLT_DENORMAL_OPERAND_2: typeof Handle_OSD_Exception_FLT_DENORMAL_OPERAND_2;
  Handle_OSD_Exception_FLT_DENORMAL_OPERAND_3: typeof Handle_OSD_Exception_FLT_DENORMAL_OPERAND_3;
  Handle_OSD_Exception_FLT_DENORMAL_OPERAND_4: typeof Handle_OSD_Exception_FLT_DENORMAL_OPERAND_4;
  OSD_Environment: typeof OSD_Environment;
  OSD_Environment_1: typeof OSD_Environment_1;
  OSD_Environment_2: typeof OSD_Environment_2;
  OSD_Environment_3: typeof OSD_Environment_3;
  Handle_OSD_SIGSYS: typeof Handle_OSD_SIGSYS;
  Handle_OSD_SIGSYS_1: typeof Handle_OSD_SIGSYS_1;
  Handle_OSD_SIGSYS_2: typeof Handle_OSD_SIGSYS_2;
  Handle_OSD_SIGSYS_3: typeof Handle_OSD_SIGSYS_3;
  Handle_OSD_SIGSYS_4: typeof Handle_OSD_SIGSYS_4;
  OSD_SIGSYS: typeof OSD_SIGSYS;
  OSD_SIGSYS_1: typeof OSD_SIGSYS_1;
  OSD_SIGSYS_2: typeof OSD_SIGSYS_2;
  Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED: typeof Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED;
  Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_1: typeof Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_1;
  Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_2: typeof Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_2;
  Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_3: typeof Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_3;
  Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_4: typeof Handle_OSD_Exception_ARRAY_BOUNDS_EXCEEDED_4;
  OSD_Exception_ARRAY_BOUNDS_EXCEEDED: typeof OSD_Exception_ARRAY_BOUNDS_EXCEEDED;
  OSD_Exception_ARRAY_BOUNDS_EXCEEDED_1: typeof OSD_Exception_ARRAY_BOUNDS_EXCEEDED_1;
  OSD_Exception_ARRAY_BOUNDS_EXCEEDED_2: typeof OSD_Exception_ARRAY_BOUNDS_EXCEEDED_2;
  OSD_Protection: typeof OSD_Protection;
  OSD_Protection_1: typeof OSD_Protection_1;
  OSD_Protection_2: typeof OSD_Protection_2;
  Handle_OSD_Exception: typeof Handle_OSD_Exception;
  Handle_OSD_Exception_1: typeof Handle_OSD_Exception_1;
  Handle_OSD_Exception_2: typeof Handle_OSD_Exception_2;
  Handle_OSD_Exception_3: typeof Handle_OSD_Exception_3;
  Handle_OSD_Exception_4: typeof Handle_OSD_Exception_4;
  OSD_Exception: typeof OSD_Exception;
  OSD_Exception_1: typeof OSD_Exception_1;
  OSD_Exception_2: typeof OSD_Exception_2;
  OSD_Exception_CTRL_BREAK: typeof OSD_Exception_CTRL_BREAK;
  OSD_Exception_CTRL_BREAK_1: typeof OSD_Exception_CTRL_BREAK_1;
  OSD_Exception_CTRL_BREAK_2: typeof OSD_Exception_CTRL_BREAK_2;
  Handle_OSD_Exception_CTRL_BREAK: typeof Handle_OSD_Exception_CTRL_BREAK;
  Handle_OSD_Exception_CTRL_BREAK_1: typeof Handle_OSD_Exception_CTRL_BREAK_1;
  Handle_OSD_Exception_CTRL_BREAK_2: typeof Handle_OSD_Exception_CTRL_BREAK_2;
  Handle_OSD_Exception_CTRL_BREAK_3: typeof Handle_OSD_Exception_CTRL_BREAK_3;
  Handle_OSD_Exception_CTRL_BREAK_4: typeof Handle_OSD_Exception_CTRL_BREAK_4;
  OSD_Chronometer: typeof OSD_Chronometer;
  Handle_OSD_Exception_INT_DIVIDE_BY_ZERO: typeof Handle_OSD_Exception_INT_DIVIDE_BY_ZERO;
  Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_1: typeof Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_1;
  Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_2: typeof Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_2;
  Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_3: typeof Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_3;
  Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_4: typeof Handle_OSD_Exception_INT_DIVIDE_BY_ZERO_4;
  OSD_Exception_INT_DIVIDE_BY_ZERO: typeof OSD_Exception_INT_DIVIDE_BY_ZERO;
  OSD_Exception_INT_DIVIDE_BY_ZERO_1: typeof OSD_Exception_INT_DIVIDE_BY_ZERO_1;
  OSD_Exception_INT_DIVIDE_BY_ZERO_2: typeof OSD_Exception_INT_DIVIDE_BY_ZERO_2;
  OSD_MAllocHook: typeof OSD_MAllocHook;
  Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO: typeof Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO;
  Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_1: typeof Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_1;
  Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_2: typeof Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_2;
  Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_3: typeof Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_3;
  Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_4: typeof Handle_OSD_Exception_FLT_DIVIDE_BY_ZERO_4;
  OSD_Exception_FLT_DIVIDE_BY_ZERO: typeof OSD_Exception_FLT_DIVIDE_BY_ZERO;
  OSD_Exception_FLT_DIVIDE_BY_ZERO_1: typeof OSD_Exception_FLT_DIVIDE_BY_ZERO_1;
  OSD_Exception_FLT_DIVIDE_BY_ZERO_2: typeof OSD_Exception_FLT_DIVIDE_BY_ZERO_2;
  OSD_Timer: typeof OSD_Timer;
  OSD_DirectoryIterator: typeof OSD_DirectoryIterator;
  OSD_DirectoryIterator_1: typeof OSD_DirectoryIterator_1;
  OSD_DirectoryIterator_2: typeof OSD_DirectoryIterator_2;
  OSD_KindFile: OSD_KindFile;
  OSD_SIGKILL: typeof OSD_SIGKILL;
  OSD_SIGKILL_1: typeof OSD_SIGKILL_1;
  OSD_SIGKILL_2: typeof OSD_SIGKILL_2;
  Handle_OSD_SIGKILL: typeof Handle_OSD_SIGKILL;
  Handle_OSD_SIGKILL_1: typeof Handle_OSD_SIGKILL_1;
  Handle_OSD_SIGKILL_2: typeof Handle_OSD_SIGKILL_2;
  Handle_OSD_SIGKILL_3: typeof Handle_OSD_SIGKILL_3;
  Handle_OSD_SIGKILL_4: typeof Handle_OSD_SIGKILL_4;
  OSD_PerfMeter: typeof OSD_PerfMeter;
  OSD_PerfMeter_1: typeof OSD_PerfMeter_1;
  OSD_PerfMeter_2: typeof OSD_PerfMeter_2;
  Handle_OSD_Exception_FLT_OVERFLOW: typeof Handle_OSD_Exception_FLT_OVERFLOW;
  Handle_OSD_Exception_FLT_OVERFLOW_1: typeof Handle_OSD_Exception_FLT_OVERFLOW_1;
  Handle_OSD_Exception_FLT_OVERFLOW_2: typeof Handle_OSD_Exception_FLT_OVERFLOW_2;
  Handle_OSD_Exception_FLT_OVERFLOW_3: typeof Handle_OSD_Exception_FLT_OVERFLOW_3;
  Handle_OSD_Exception_FLT_OVERFLOW_4: typeof Handle_OSD_Exception_FLT_OVERFLOW_4;
  OSD_Exception_FLT_OVERFLOW: typeof OSD_Exception_FLT_OVERFLOW;
  OSD_Exception_FLT_OVERFLOW_1: typeof OSD_Exception_FLT_OVERFLOW_1;
  OSD_Exception_FLT_OVERFLOW_2: typeof OSD_Exception_FLT_OVERFLOW_2;
  Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION: typeof Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION;
  Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_1: typeof Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_1;
  Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_2: typeof Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_2;
  Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_3: typeof Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_3;
  Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_4: typeof Handle_OSD_Exception_NONCONTINUABLE_EXCEPTION_4;
  OSD_Exception_NONCONTINUABLE_EXCEPTION: typeof OSD_Exception_NONCONTINUABLE_EXCEPTION;
  OSD_Exception_NONCONTINUABLE_EXCEPTION_1: typeof OSD_Exception_NONCONTINUABLE_EXCEPTION_1;
  OSD_Exception_NONCONTINUABLE_EXCEPTION_2: typeof OSD_Exception_NONCONTINUABLE_EXCEPTION_2;
  OSD_Exception_FLT_INEXACT_RESULT: typeof OSD_Exception_FLT_INEXACT_RESULT;
  OSD_Exception_FLT_INEXACT_RESULT_1: typeof OSD_Exception_FLT_INEXACT_RESULT_1;
  OSD_Exception_FLT_INEXACT_RESULT_2: typeof OSD_Exception_FLT_INEXACT_RESULT_2;
  Handle_OSD_Exception_FLT_INEXACT_RESULT: typeof Handle_OSD_Exception_FLT_INEXACT_RESULT;
  Handle_OSD_Exception_FLT_INEXACT_RESULT_1: typeof Handle_OSD_Exception_FLT_INEXACT_RESULT_1;
  Handle_OSD_Exception_FLT_INEXACT_RESULT_2: typeof Handle_OSD_Exception_FLT_INEXACT_RESULT_2;
  Handle_OSD_Exception_FLT_INEXACT_RESULT_3: typeof Handle_OSD_Exception_FLT_INEXACT_RESULT_3;
  Handle_OSD_Exception_FLT_INEXACT_RESULT_4: typeof Handle_OSD_Exception_FLT_INEXACT_RESULT_4;
  OSD_FromWhere: OSD_FromWhere;
  OSD_LoadMode: OSD_LoadMode;
  OSD_OSDError: typeof OSD_OSDError;
  OSD_OSDError_1: typeof OSD_OSDError_1;
  OSD_OSDError_2: typeof OSD_OSDError_2;
  Handle_OSD_OSDError: typeof Handle_OSD_OSDError;
  Handle_OSD_OSDError_1: typeof Handle_OSD_OSDError_1;
  Handle_OSD_OSDError_2: typeof Handle_OSD_OSDError_2;
  Handle_OSD_OSDError_3: typeof Handle_OSD_OSDError_3;
  Handle_OSD_OSDError_4: typeof Handle_OSD_OSDError_4;
  OSD_SignalMode: OSD_SignalMode;
  Handle_OSD_Exception_STACK_OVERFLOW: typeof Handle_OSD_Exception_STACK_OVERFLOW;
  Handle_OSD_Exception_STACK_OVERFLOW_1: typeof Handle_OSD_Exception_STACK_OVERFLOW_1;
  Handle_OSD_Exception_STACK_OVERFLOW_2: typeof Handle_OSD_Exception_STACK_OVERFLOW_2;
  Handle_OSD_Exception_STACK_OVERFLOW_3: typeof Handle_OSD_Exception_STACK_OVERFLOW_3;
  Handle_OSD_Exception_STACK_OVERFLOW_4: typeof Handle_OSD_Exception_STACK_OVERFLOW_4;
  OSD_Exception_STACK_OVERFLOW: typeof OSD_Exception_STACK_OVERFLOW;
  OSD_Exception_STACK_OVERFLOW_1: typeof OSD_Exception_STACK_OVERFLOW_1;
  OSD_Exception_STACK_OVERFLOW_2: typeof OSD_Exception_STACK_OVERFLOW_2;
  OSD_SIGQUIT: typeof OSD_SIGQUIT;
  OSD_SIGQUIT_1: typeof OSD_SIGQUIT_1;
  OSD_SIGQUIT_2: typeof OSD_SIGQUIT_2;
  Handle_OSD_SIGQUIT: typeof Handle_OSD_SIGQUIT;
  Handle_OSD_SIGQUIT_1: typeof Handle_OSD_SIGQUIT_1;
  Handle_OSD_SIGQUIT_2: typeof Handle_OSD_SIGQUIT_2;
  Handle_OSD_SIGQUIT_3: typeof Handle_OSD_SIGQUIT_3;
  Handle_OSD_SIGQUIT_4: typeof Handle_OSD_SIGQUIT_4;
  OSD_Parallel: typeof OSD_Parallel;
  Handle_OSD_Exception_FLT_STACK_CHECK: typeof Handle_OSD_Exception_FLT_STACK_CHECK;
  Handle_OSD_Exception_FLT_STACK_CHECK_1: typeof Handle_OSD_Exception_FLT_STACK_CHECK_1;
  Handle_OSD_Exception_FLT_STACK_CHECK_2: typeof Handle_OSD_Exception_FLT_STACK_CHECK_2;
  Handle_OSD_Exception_FLT_STACK_CHECK_3: typeof Handle_OSD_Exception_FLT_STACK_CHECK_3;
  Handle_OSD_Exception_FLT_STACK_CHECK_4: typeof Handle_OSD_Exception_FLT_STACK_CHECK_4;
  OSD_Exception_FLT_STACK_CHECK: typeof OSD_Exception_FLT_STACK_CHECK;
  OSD_Exception_FLT_STACK_CHECK_1: typeof OSD_Exception_FLT_STACK_CHECK_1;
  OSD_Exception_FLT_STACK_CHECK_2: typeof OSD_Exception_FLT_STACK_CHECK_2;
  OSD_SingleProtection: OSD_SingleProtection;
  OSD_Exception_ACCESS_VIOLATION: typeof OSD_Exception_ACCESS_VIOLATION;
  OSD_Exception_ACCESS_VIOLATION_1: typeof OSD_Exception_ACCESS_VIOLATION_1;
  OSD_Exception_ACCESS_VIOLATION_2: typeof OSD_Exception_ACCESS_VIOLATION_2;
  Handle_OSD_Exception_ACCESS_VIOLATION: typeof Handle_OSD_Exception_ACCESS_VIOLATION;
  Handle_OSD_Exception_ACCESS_VIOLATION_1: typeof Handle_OSD_Exception_ACCESS_VIOLATION_1;
  Handle_OSD_Exception_ACCESS_VIOLATION_2: typeof Handle_OSD_Exception_ACCESS_VIOLATION_2;
  Handle_OSD_Exception_ACCESS_VIOLATION_3: typeof Handle_OSD_Exception_ACCESS_VIOLATION_3;
  Handle_OSD_Exception_ACCESS_VIOLATION_4: typeof Handle_OSD_Exception_ACCESS_VIOLATION_4;
  Plate_SequenceOfLinearXYZConstraint: typeof Plate_SequenceOfLinearXYZConstraint;
  Plate_SequenceOfLinearXYZConstraint_1: typeof Plate_SequenceOfLinearXYZConstraint_1;
  Plate_SequenceOfLinearXYZConstraint_2: typeof Plate_SequenceOfLinearXYZConstraint_2;
  Plate_SequenceOfLinearXYZConstraint_3: typeof Plate_SequenceOfLinearXYZConstraint_3;
  Plate_FreeGtoCConstraint: typeof Plate_FreeGtoCConstraint;
  Plate_FreeGtoCConstraint_1: typeof Plate_FreeGtoCConstraint_1;
  Plate_FreeGtoCConstraint_2: typeof Plate_FreeGtoCConstraint_2;
  Plate_FreeGtoCConstraint_3: typeof Plate_FreeGtoCConstraint_3;
  Plate_LinearXYZConstraint: typeof Plate_LinearXYZConstraint;
  Plate_LinearXYZConstraint_1: typeof Plate_LinearXYZConstraint_1;
  Plate_LinearXYZConstraint_2: typeof Plate_LinearXYZConstraint_2;
  Plate_LinearXYZConstraint_3: typeof Plate_LinearXYZConstraint_3;
  Plate_LinearXYZConstraint_4: typeof Plate_LinearXYZConstraint_4;
  Plate_D3: typeof Plate_D3;
  Plate_D3_1: typeof Plate_D3_1;
  Plate_D3_2: typeof Plate_D3_2;
  Plate_Plate: typeof Plate_Plate;
  Plate_Plate_1: typeof Plate_Plate_1;
  Plate_Plate_2: typeof Plate_Plate_2;
  Plate_D1: typeof Plate_D1;
  Plate_D1_1: typeof Plate_D1_1;
  Plate_D1_2: typeof Plate_D1_2;
  Plate_D2: typeof Plate_D2;
  Plate_D2_1: typeof Plate_D2_1;
  Plate_D2_2: typeof Plate_D2_2;
  Plate_Array1OfPinpointConstraint: typeof Plate_Array1OfPinpointConstraint;
  Plate_Array1OfPinpointConstraint_1: typeof Plate_Array1OfPinpointConstraint_1;
  Plate_Array1OfPinpointConstraint_2: typeof Plate_Array1OfPinpointConstraint_2;
  Plate_Array1OfPinpointConstraint_3: typeof Plate_Array1OfPinpointConstraint_3;
  Plate_Array1OfPinpointConstraint_4: typeof Plate_Array1OfPinpointConstraint_4;
  Plate_Array1OfPinpointConstraint_5: typeof Plate_Array1OfPinpointConstraint_5;
  Plate_LinearScalarConstraint: typeof Plate_LinearScalarConstraint;
  Plate_LinearScalarConstraint_1: typeof Plate_LinearScalarConstraint_1;
  Plate_LinearScalarConstraint_2: typeof Plate_LinearScalarConstraint_2;
  Plate_LinearScalarConstraint_3: typeof Plate_LinearScalarConstraint_3;
  Plate_LinearScalarConstraint_4: typeof Plate_LinearScalarConstraint_4;
  Plate_LinearScalarConstraint_5: typeof Plate_LinearScalarConstraint_5;
  Plate_SequenceOfLinearScalarConstraint: typeof Plate_SequenceOfLinearScalarConstraint;
  Plate_SequenceOfLinearScalarConstraint_1: typeof Plate_SequenceOfLinearScalarConstraint_1;
  Plate_SequenceOfLinearScalarConstraint_2: typeof Plate_SequenceOfLinearScalarConstraint_2;
  Plate_SequenceOfLinearScalarConstraint_3: typeof Plate_SequenceOfLinearScalarConstraint_3;
  Plate_SampledCurveConstraint: typeof Plate_SampledCurveConstraint;
  Plate_PinpointConstraint: typeof Plate_PinpointConstraint;
  Plate_PinpointConstraint_1: typeof Plate_PinpointConstraint_1;
  Plate_PinpointConstraint_2: typeof Plate_PinpointConstraint_2;
  Plate_GlobalTranslationConstraint: typeof Plate_GlobalTranslationConstraint;
  Plate_PlaneConstraint: typeof Plate_PlaneConstraint;
  Plate_SequenceOfPinpointConstraint: typeof Plate_SequenceOfPinpointConstraint;
  Plate_SequenceOfPinpointConstraint_1: typeof Plate_SequenceOfPinpointConstraint_1;
  Plate_SequenceOfPinpointConstraint_2: typeof Plate_SequenceOfPinpointConstraint_2;
  Plate_SequenceOfPinpointConstraint_3: typeof Plate_SequenceOfPinpointConstraint_3;
  Handle_Plate_HArray1OfPinpointConstraint: typeof Handle_Plate_HArray1OfPinpointConstraint;
  Handle_Plate_HArray1OfPinpointConstraint_1: typeof Handle_Plate_HArray1OfPinpointConstraint_1;
  Handle_Plate_HArray1OfPinpointConstraint_2: typeof Handle_Plate_HArray1OfPinpointConstraint_2;
  Handle_Plate_HArray1OfPinpointConstraint_3: typeof Handle_Plate_HArray1OfPinpointConstraint_3;
  Handle_Plate_HArray1OfPinpointConstraint_4: typeof Handle_Plate_HArray1OfPinpointConstraint_4;
  Plate_GtoCConstraint: typeof Plate_GtoCConstraint;
  Plate_GtoCConstraint_1: typeof Plate_GtoCConstraint_1;
  Plate_GtoCConstraint_2: typeof Plate_GtoCConstraint_2;
  Plate_GtoCConstraint_3: typeof Plate_GtoCConstraint_3;
  Plate_GtoCConstraint_4: typeof Plate_GtoCConstraint_4;
  Plate_GtoCConstraint_5: typeof Plate_GtoCConstraint_5;
  Plate_GtoCConstraint_6: typeof Plate_GtoCConstraint_6;
  Plate_GtoCConstraint_7: typeof Plate_GtoCConstraint_7;
  Plate_LineConstraint: typeof Plate_LineConstraint;
  StdLDrivers: typeof StdLDrivers;
  StdLDrivers_DocumentRetrievalDriver: typeof StdLDrivers_DocumentRetrievalDriver;
  LocalAnalysis_CurveContinuity: typeof LocalAnalysis_CurveContinuity;
  LocalAnalysis_StatusErrorType: LocalAnalysis_StatusErrorType;
  LocalAnalysis: typeof LocalAnalysis;
  LocalAnalysis_SurfaceContinuity: typeof LocalAnalysis_SurfaceContinuity;
  LocalAnalysis_SurfaceContinuity_1: typeof LocalAnalysis_SurfaceContinuity_1;
  LocalAnalysis_SurfaceContinuity_2: typeof LocalAnalysis_SurfaceContinuity_2;
  LocalAnalysis_SurfaceContinuity_3: typeof LocalAnalysis_SurfaceContinuity_3;
  CDF_SubComponentStatus: CDF_SubComponentStatus;
  CDF_Directory: typeof CDF_Directory;
  Handle_CDF_Directory: typeof Handle_CDF_Directory;
  Handle_CDF_Directory_1: typeof Handle_CDF_Directory_1;
  Handle_CDF_Directory_2: typeof Handle_CDF_Directory_2;
  Handle_CDF_Directory_3: typeof Handle_CDF_Directory_3;
  Handle_CDF_Directory_4: typeof Handle_CDF_Directory_4;
  Handle_CDF_MetaDataDriver: typeof Handle_CDF_MetaDataDriver;
  Handle_CDF_MetaDataDriver_1: typeof Handle_CDF_MetaDataDriver_1;
  Handle_CDF_MetaDataDriver_2: typeof Handle_CDF_MetaDataDriver_2;
  Handle_CDF_MetaDataDriver_3: typeof Handle_CDF_MetaDataDriver_3;
  Handle_CDF_MetaDataDriver_4: typeof Handle_CDF_MetaDataDriver_4;
  CDF_MetaDataDriver: typeof CDF_MetaDataDriver;
  CDF_Store: typeof CDF_Store;
  CDF_StoreSetNameStatus: CDF_StoreSetNameStatus;
  CDF_TryStoreStatus: CDF_TryStoreStatus;
  Handle_CDF_StoreList: typeof Handle_CDF_StoreList;
  Handle_CDF_StoreList_1: typeof Handle_CDF_StoreList_1;
  Handle_CDF_StoreList_2: typeof Handle_CDF_StoreList_2;
  Handle_CDF_StoreList_3: typeof Handle_CDF_StoreList_3;
  Handle_CDF_StoreList_4: typeof Handle_CDF_StoreList_4;
  CDF_StoreList: typeof CDF_StoreList;
  CDF_Application: typeof CDF_Application;
  Handle_CDF_Application: typeof Handle_CDF_Application;
  Handle_CDF_Application_1: typeof Handle_CDF_Application_1;
  Handle_CDF_Application_2: typeof Handle_CDF_Application_2;
  Handle_CDF_Application_3: typeof Handle_CDF_Application_3;
  Handle_CDF_Application_4: typeof Handle_CDF_Application_4;
  Handle_CDF_FWOSDriver: typeof Handle_CDF_FWOSDriver;
  Handle_CDF_FWOSDriver_1: typeof Handle_CDF_FWOSDriver_1;
  Handle_CDF_FWOSDriver_2: typeof Handle_CDF_FWOSDriver_2;
  Handle_CDF_FWOSDriver_3: typeof Handle_CDF_FWOSDriver_3;
  Handle_CDF_FWOSDriver_4: typeof Handle_CDF_FWOSDriver_4;
  CDF_FWOSDriver: typeof CDF_FWOSDriver;
  CDF_TypeOfActivation: CDF_TypeOfActivation;
  CDF_MetaDataDriverFactory: typeof CDF_MetaDataDriverFactory;
  Handle_CDF_MetaDataDriverFactory: typeof Handle_CDF_MetaDataDriverFactory;
  Handle_CDF_MetaDataDriverFactory_1: typeof Handle_CDF_MetaDataDriverFactory_1;
  Handle_CDF_MetaDataDriverFactory_2: typeof Handle_CDF_MetaDataDriverFactory_2;
  Handle_CDF_MetaDataDriverFactory_3: typeof Handle_CDF_MetaDataDriverFactory_3;
  Handle_CDF_MetaDataDriverFactory_4: typeof Handle_CDF_MetaDataDriverFactory_4;
  CDF_MetaDataDriverError: typeof CDF_MetaDataDriverError;
  CDF_MetaDataDriverError_1: typeof CDF_MetaDataDriverError_1;
  CDF_MetaDataDriverError_2: typeof CDF_MetaDataDriverError_2;
  Handle_CDF_MetaDataDriverError: typeof Handle_CDF_MetaDataDriverError;
  Handle_CDF_MetaDataDriverError_1: typeof Handle_CDF_MetaDataDriverError_1;
  Handle_CDF_MetaDataDriverError_2: typeof Handle_CDF_MetaDataDriverError_2;
  Handle_CDF_MetaDataDriverError_3: typeof Handle_CDF_MetaDataDriverError_3;
  Handle_CDF_MetaDataDriverError_4: typeof Handle_CDF_MetaDataDriverError_4;
  XCAFView_Object: typeof XCAFView_Object;
  XCAFView_Object_1: typeof XCAFView_Object_1;
  XCAFView_Object_2: typeof XCAFView_Object_2;
  Handle_XCAFView_Object: typeof Handle_XCAFView_Object;
  Handle_XCAFView_Object_1: typeof Handle_XCAFView_Object_1;
  Handle_XCAFView_Object_2: typeof Handle_XCAFView_Object_2;
  Handle_XCAFView_Object_3: typeof Handle_XCAFView_Object_3;
  Handle_XCAFView_Object_4: typeof Handle_XCAFView_Object_4;
  XCAFView_ProjectionType: XCAFView_ProjectionType;
  GeomToStep_MakeToroidalSurface: typeof GeomToStep_MakeToroidalSurface;
  GeomToStep_MakeConic: typeof GeomToStep_MakeConic;
  GeomToStep_MakeConic_1: typeof GeomToStep_MakeConic_1;
  GeomToStep_MakeConic_2: typeof GeomToStep_MakeConic_2;
  GeomToStep_MakeParabola: typeof GeomToStep_MakeParabola;
  GeomToStep_MakeParabola_1: typeof GeomToStep_MakeParabola_1;
  GeomToStep_MakeParabola_2: typeof GeomToStep_MakeParabola_2;
  GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve: typeof GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve;
  GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve_1: typeof GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve_1;
  GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve_2: typeof GeomToStep_MakeBSplineCurveWithKnotsAndRationalBSplineCurve_2;
  GeomToStep_MakeEllipse: typeof GeomToStep_MakeEllipse;
  GeomToStep_MakeEllipse_1: typeof GeomToStep_MakeEllipse_1;
  GeomToStep_MakeEllipse_2: typeof GeomToStep_MakeEllipse_2;
  GeomToStep_MakeEllipse_3: typeof GeomToStep_MakeEllipse_3;
  GeomToStep_MakeSphericalSurface: typeof GeomToStep_MakeSphericalSurface;
  GeomToStep_MakeSurfaceOfLinearExtrusion: typeof GeomToStep_MakeSurfaceOfLinearExtrusion;
  GeomToStep_MakeSurface: typeof GeomToStep_MakeSurface;
  GeomToStep_MakeSurfaceOfRevolution: typeof GeomToStep_MakeSurfaceOfRevolution;
  GeomToStep_MakeCircle: typeof GeomToStep_MakeCircle;
  GeomToStep_MakeCircle_1: typeof GeomToStep_MakeCircle_1;
  GeomToStep_MakeCircle_2: typeof GeomToStep_MakeCircle_2;
  GeomToStep_MakeCircle_3: typeof GeomToStep_MakeCircle_3;
  GeomToStep_MakeAxis2Placement2d: typeof GeomToStep_MakeAxis2Placement2d;
  GeomToStep_MakeAxis2Placement2d_1: typeof GeomToStep_MakeAxis2Placement2d_1;
  GeomToStep_MakeAxis2Placement2d_2: typeof GeomToStep_MakeAxis2Placement2d_2;
  GeomToStep_MakePolyline: typeof GeomToStep_MakePolyline;
  GeomToStep_MakePolyline_1: typeof GeomToStep_MakePolyline_1;
  GeomToStep_MakePolyline_2: typeof GeomToStep_MakePolyline_2;
  GeomToStep_MakeConicalSurface: typeof GeomToStep_MakeConicalSurface;
  GeomToStep_MakeRectangularTrimmedSurface: typeof GeomToStep_MakeRectangularTrimmedSurface;
  GeomToStep_MakeLine: typeof GeomToStep_MakeLine;
  GeomToStep_MakeLine_1: typeof GeomToStep_MakeLine_1;
  GeomToStep_MakeLine_2: typeof GeomToStep_MakeLine_2;
  GeomToStep_MakeLine_3: typeof GeomToStep_MakeLine_3;
  GeomToStep_MakeLine_4: typeof GeomToStep_MakeLine_4;
  GeomToStep_MakeCurve: typeof GeomToStep_MakeCurve;
  GeomToStep_MakeCurve_1: typeof GeomToStep_MakeCurve_1;
  GeomToStep_MakeCurve_2: typeof GeomToStep_MakeCurve_2;
  GeomToStep_MakeCartesianPoint: typeof GeomToStep_MakeCartesianPoint;
  GeomToStep_MakeCartesianPoint_1: typeof GeomToStep_MakeCartesianPoint_1;
  GeomToStep_MakeCartesianPoint_2: typeof GeomToStep_MakeCartesianPoint_2;
  GeomToStep_MakeCartesianPoint_3: typeof GeomToStep_MakeCartesianPoint_3;
  GeomToStep_MakeCartesianPoint_4: typeof GeomToStep_MakeCartesianPoint_4;
  GeomToStep_MakeBoundedSurface: typeof GeomToStep_MakeBoundedSurface;
  GeomToStep_MakeBSplineSurfaceWithKnotsAndRationalBSplineSurface: typeof GeomToStep_MakeBSplineSurfaceWithKnotsAndRationalBSplineSurface;
  GeomToStep_MakePlane: typeof GeomToStep_MakePlane;
  GeomToStep_MakePlane_1: typeof GeomToStep_MakePlane_1;
  GeomToStep_MakePlane_2: typeof GeomToStep_MakePlane_2;
  GeomToStep_MakeAxis1Placement: typeof GeomToStep_MakeAxis1Placement;
  GeomToStep_MakeAxis1Placement_1: typeof GeomToStep_MakeAxis1Placement_1;
  GeomToStep_MakeAxis1Placement_2: typeof GeomToStep_MakeAxis1Placement_2;
  GeomToStep_MakeAxis1Placement_3: typeof GeomToStep_MakeAxis1Placement_3;
  GeomToStep_MakeAxis1Placement_4: typeof GeomToStep_MakeAxis1Placement_4;
  GeomToStep_MakeBoundedCurve: typeof GeomToStep_MakeBoundedCurve;
  GeomToStep_MakeBoundedCurve_1: typeof GeomToStep_MakeBoundedCurve_1;
  GeomToStep_MakeBoundedCurve_2: typeof GeomToStep_MakeBoundedCurve_2;
  GeomToStep_MakeBSplineSurfaceWithKnots: typeof GeomToStep_MakeBSplineSurfaceWithKnots;
  GeomToStep_MakeHyperbola: typeof GeomToStep_MakeHyperbola;
  GeomToStep_MakeHyperbola_1: typeof GeomToStep_MakeHyperbola_1;
  GeomToStep_MakeHyperbola_2: typeof GeomToStep_MakeHyperbola_2;
  GeomToStep_MakeVector: typeof GeomToStep_MakeVector;
  GeomToStep_MakeVector_1: typeof GeomToStep_MakeVector_1;
  GeomToStep_MakeVector_2: typeof GeomToStep_MakeVector_2;
  GeomToStep_MakeVector_3: typeof GeomToStep_MakeVector_3;
  GeomToStep_MakeVector_4: typeof GeomToStep_MakeVector_4;
  GeomToStep_MakeSweptSurface: typeof GeomToStep_MakeSweptSurface;
  GeomToStep_Root: typeof GeomToStep_Root;
  GeomToStep_MakeCylindricalSurface: typeof GeomToStep_MakeCylindricalSurface;
  GeomToStep_MakeBSplineCurveWithKnots: typeof GeomToStep_MakeBSplineCurveWithKnots;
  GeomToStep_MakeBSplineCurveWithKnots_1: typeof GeomToStep_MakeBSplineCurveWithKnots_1;
  GeomToStep_MakeBSplineCurveWithKnots_2: typeof GeomToStep_MakeBSplineCurveWithKnots_2;
  GeomToStep_MakeAxis2Placement3d: typeof GeomToStep_MakeAxis2Placement3d;
  GeomToStep_MakeAxis2Placement3d_1: typeof GeomToStep_MakeAxis2Placement3d_1;
  GeomToStep_MakeAxis2Placement3d_2: typeof GeomToStep_MakeAxis2Placement3d_2;
  GeomToStep_MakeAxis2Placement3d_3: typeof GeomToStep_MakeAxis2Placement3d_3;
  GeomToStep_MakeAxis2Placement3d_4: typeof GeomToStep_MakeAxis2Placement3d_4;
  GeomToStep_MakeAxis2Placement3d_5: typeof GeomToStep_MakeAxis2Placement3d_5;
  GeomToStep_MakeElementarySurface: typeof GeomToStep_MakeElementarySurface;
  GeomToStep_MakeDirection: typeof GeomToStep_MakeDirection;
  GeomToStep_MakeDirection_1: typeof GeomToStep_MakeDirection_1;
  GeomToStep_MakeDirection_2: typeof GeomToStep_MakeDirection_2;
  GeomToStep_MakeDirection_3: typeof GeomToStep_MakeDirection_3;
  GeomToStep_MakeDirection_4: typeof GeomToStep_MakeDirection_4;
  Geom2dAdaptor_Curve: typeof Geom2dAdaptor_Curve;
  Geom2dAdaptor_Curve_1: typeof Geom2dAdaptor_Curve_1;
  Geom2dAdaptor_Curve_2: typeof Geom2dAdaptor_Curve_2;
  Geom2dAdaptor_Curve_3: typeof Geom2dAdaptor_Curve_3;
  Geom2dAdaptor: typeof Geom2dAdaptor;
  Geom2dAdaptor_GHCurve: typeof Geom2dAdaptor_GHCurve;
  Geom2dAdaptor_GHCurve_1: typeof Geom2dAdaptor_GHCurve_1;
  Geom2dAdaptor_GHCurve_2: typeof Geom2dAdaptor_GHCurve_2;
  Handle_Geom2dAdaptor_GHCurve: typeof Handle_Geom2dAdaptor_GHCurve;
  Handle_Geom2dAdaptor_GHCurve_1: typeof Handle_Geom2dAdaptor_GHCurve_1;
  Handle_Geom2dAdaptor_GHCurve_2: typeof Handle_Geom2dAdaptor_GHCurve_2;
  Handle_Geom2dAdaptor_GHCurve_3: typeof Handle_Geom2dAdaptor_GHCurve_3;
  Handle_Geom2dAdaptor_GHCurve_4: typeof Handle_Geom2dAdaptor_GHCurve_4;
  Geom2dAdaptor_HCurve: typeof Geom2dAdaptor_HCurve;
  Geom2dAdaptor_HCurve_1: typeof Geom2dAdaptor_HCurve_1;
  Geom2dAdaptor_HCurve_2: typeof Geom2dAdaptor_HCurve_2;
  Geom2dAdaptor_HCurve_3: typeof Geom2dAdaptor_HCurve_3;
  Geom2dAdaptor_HCurve_4: typeof Geom2dAdaptor_HCurve_4;
  Handle_Geom2dAdaptor_HCurve: typeof Handle_Geom2dAdaptor_HCurve;
  Handle_Geom2dAdaptor_HCurve_1: typeof Handle_Geom2dAdaptor_HCurve_1;
  Handle_Geom2dAdaptor_HCurve_2: typeof Handle_Geom2dAdaptor_HCurve_2;
  Handle_Geom2dAdaptor_HCurve_3: typeof Handle_Geom2dAdaptor_HCurve_3;
  Handle_Geom2dAdaptor_HCurve_4: typeof Handle_Geom2dAdaptor_HCurve_4;
  Contap_Line: typeof Contap_Line;
  Contap_Point: typeof Contap_Point;
  Contap_Point_1: typeof Contap_Point_1;
  Contap_Point_2: typeof Contap_Point_2;
  Contap_TFunction: Contap_TFunction;
  Contap_ContAna: typeof Contap_ContAna;
  Contap_TheIWalking: typeof Contap_TheIWalking;
  Contap_ThePathPointOfTheSearch: typeof Contap_ThePathPointOfTheSearch;
  Contap_ThePathPointOfTheSearch_1: typeof Contap_ThePathPointOfTheSearch_1;
  Contap_ThePathPointOfTheSearch_2: typeof Contap_ThePathPointOfTheSearch_2;
  Contap_ThePathPointOfTheSearch_3: typeof Contap_ThePathPointOfTheSearch_3;
  Contap_ArcFunction: typeof Contap_ArcFunction;
  Contap_TheSequenceOfPoint: typeof Contap_TheSequenceOfPoint;
  Contap_TheSequenceOfPoint_1: typeof Contap_TheSequenceOfPoint_1;
  Contap_TheSequenceOfPoint_2: typeof Contap_TheSequenceOfPoint_2;
  Contap_TheSequenceOfPoint_3: typeof Contap_TheSequenceOfPoint_3;
  Handle_Contap_TheHSequenceOfPoint: typeof Handle_Contap_TheHSequenceOfPoint;
  Handle_Contap_TheHSequenceOfPoint_1: typeof Handle_Contap_TheHSequenceOfPoint_1;
  Handle_Contap_TheHSequenceOfPoint_2: typeof Handle_Contap_TheHSequenceOfPoint_2;
  Handle_Contap_TheHSequenceOfPoint_3: typeof Handle_Contap_TheHSequenceOfPoint_3;
  Handle_Contap_TheHSequenceOfPoint_4: typeof Handle_Contap_TheHSequenceOfPoint_4;
  Contap_TheSequenceOfLine: typeof Contap_TheSequenceOfLine;
  Contap_TheSequenceOfLine_1: typeof Contap_TheSequenceOfLine_1;
  Contap_TheSequenceOfLine_2: typeof Contap_TheSequenceOfLine_2;
  Contap_TheSequenceOfLine_3: typeof Contap_TheSequenceOfLine_3;
  Contap_TheSearch: typeof Contap_TheSearch;
  Contap_SequenceOfPathPointOfTheSearch: typeof Contap_SequenceOfPathPointOfTheSearch;
  Contap_SequenceOfPathPointOfTheSearch_1: typeof Contap_SequenceOfPathPointOfTheSearch_1;
  Contap_SequenceOfPathPointOfTheSearch_2: typeof Contap_SequenceOfPathPointOfTheSearch_2;
  Contap_SequenceOfPathPointOfTheSearch_3: typeof Contap_SequenceOfPathPointOfTheSearch_3;
  Contap_SurfProps: typeof Contap_SurfProps;
  Contap_TheSearchInside: typeof Contap_TheSearchInside;
  Contap_TheSearchInside_1: typeof Contap_TheSearchInside_1;
  Contap_TheSearchInside_2: typeof Contap_TheSearchInside_2;
  Contap_SequenceOfSegmentOfTheSearch: typeof Contap_SequenceOfSegmentOfTheSearch;
  Contap_SequenceOfSegmentOfTheSearch_1: typeof Contap_SequenceOfSegmentOfTheSearch_1;
  Contap_SequenceOfSegmentOfTheSearch_2: typeof Contap_SequenceOfSegmentOfTheSearch_2;
  Contap_SequenceOfSegmentOfTheSearch_3: typeof Contap_SequenceOfSegmentOfTheSearch_3;
  Contap_HContTool: typeof Contap_HContTool;
  Contap_IType: Contap_IType;
  Contap_SurfFunction: typeof Contap_SurfFunction;
  Contap_TheSegmentOfTheSearch: typeof Contap_TheSegmentOfTheSearch;
  Handle_Contap_TheIWLineOfTheIWalking: typeof Handle_Contap_TheIWLineOfTheIWalking;
  Handle_Contap_TheIWLineOfTheIWalking_1: typeof Handle_Contap_TheIWLineOfTheIWalking_1;
  Handle_Contap_TheIWLineOfTheIWalking_2: typeof Handle_Contap_TheIWLineOfTheIWalking_2;
  Handle_Contap_TheIWLineOfTheIWalking_3: typeof Handle_Contap_TheIWLineOfTheIWalking_3;
  Handle_Contap_TheIWLineOfTheIWalking_4: typeof Handle_Contap_TheIWLineOfTheIWalking_4;
  Contap_TheIWLineOfTheIWalking: typeof Contap_TheIWLineOfTheIWalking;
  Contap_HCurve2dTool: typeof Contap_HCurve2dTool;
  Contap_Contour: typeof Contap_Contour;
  Contap_Contour_1: typeof Contap_Contour_1;
  Contap_Contour_2: typeof Contap_Contour_2;
  Contap_Contour_3: typeof Contap_Contour_3;
  Contap_Contour_4: typeof Contap_Contour_4;
  Contap_Contour_5: typeof Contap_Contour_5;
  Contap_Contour_6: typeof Contap_Contour_6;
  Contap_Contour_7: typeof Contap_Contour_7;
  IGESControl_Reader: typeof IGESControl_Reader;
  IGESControl_Reader_1: typeof IGESControl_Reader_1;
  IGESControl_Reader_2: typeof IGESControl_Reader_2;
  Handle_IGESControl_ToolContainer: typeof Handle_IGESControl_ToolContainer;
  Handle_IGESControl_ToolContainer_1: typeof Handle_IGESControl_ToolContainer_1;
  Handle_IGESControl_ToolContainer_2: typeof Handle_IGESControl_ToolContainer_2;
  Handle_IGESControl_ToolContainer_3: typeof Handle_IGESControl_ToolContainer_3;
  Handle_IGESControl_ToolContainer_4: typeof Handle_IGESControl_ToolContainer_4;
  IGESControl_ToolContainer: typeof IGESControl_ToolContainer;
  IGESControl_AlgoContainer: typeof IGESControl_AlgoContainer;
  Handle_IGESControl_AlgoContainer: typeof Handle_IGESControl_AlgoContainer;
  Handle_IGESControl_AlgoContainer_1: typeof Handle_IGESControl_AlgoContainer_1;
  Handle_IGESControl_AlgoContainer_2: typeof Handle_IGESControl_AlgoContainer_2;
  Handle_IGESControl_AlgoContainer_3: typeof Handle_IGESControl_AlgoContainer_3;
  Handle_IGESControl_AlgoContainer_4: typeof Handle_IGESControl_AlgoContainer_4;
  Handle_IGESControl_IGESBoundary: typeof Handle_IGESControl_IGESBoundary;
  Handle_IGESControl_IGESBoundary_1: typeof Handle_IGESControl_IGESBoundary_1;
  Handle_IGESControl_IGESBoundary_2: typeof Handle_IGESControl_IGESBoundary_2;
  Handle_IGESControl_IGESBoundary_3: typeof Handle_IGESControl_IGESBoundary_3;
  Handle_IGESControl_IGESBoundary_4: typeof Handle_IGESControl_IGESBoundary_4;
  IGESControl_IGESBoundary: typeof IGESControl_IGESBoundary;
  IGESControl_IGESBoundary_1: typeof IGESControl_IGESBoundary_1;
  IGESControl_IGESBoundary_2: typeof IGESControl_IGESBoundary_2;
  IGESControl_Writer: typeof IGESControl_Writer;
  IGESControl_Writer_1: typeof IGESControl_Writer_1;
  IGESControl_Writer_2: typeof IGESControl_Writer_2;
  IGESControl_Writer_3: typeof IGESControl_Writer_3;
  IGESControl_ActorWrite: typeof IGESControl_ActorWrite;
  Handle_IGESControl_ActorWrite: typeof Handle_IGESControl_ActorWrite;
  Handle_IGESControl_ActorWrite_1: typeof Handle_IGESControl_ActorWrite_1;
  Handle_IGESControl_ActorWrite_2: typeof Handle_IGESControl_ActorWrite_2;
  Handle_IGESControl_ActorWrite_3: typeof Handle_IGESControl_ActorWrite_3;
  Handle_IGESControl_ActorWrite_4: typeof Handle_IGESControl_ActorWrite_4;
  IGESControl_Controller: typeof IGESControl_Controller;
  Handle_IGESControl_Controller: typeof Handle_IGESControl_Controller;
  Handle_IGESControl_Controller_1: typeof Handle_IGESControl_Controller_1;
  Handle_IGESControl_Controller_2: typeof Handle_IGESControl_Controller_2;
  Handle_IGESControl_Controller_3: typeof Handle_IGESControl_Controller_3;
  Handle_IGESControl_Controller_4: typeof Handle_IGESControl_Controller_4;
  XSControl: typeof XSControl;
  XSControl_SignTransferStatus: typeof XSControl_SignTransferStatus;
  XSControl_SignTransferStatus_1: typeof XSControl_SignTransferStatus_1;
  XSControl_SignTransferStatus_2: typeof XSControl_SignTransferStatus_2;
  Handle_XSControl_SignTransferStatus: typeof Handle_XSControl_SignTransferStatus;
  Handle_XSControl_SignTransferStatus_1: typeof Handle_XSControl_SignTransferStatus_1;
  Handle_XSControl_SignTransferStatus_2: typeof Handle_XSControl_SignTransferStatus_2;
  Handle_XSControl_SignTransferStatus_3: typeof Handle_XSControl_SignTransferStatus_3;
  Handle_XSControl_SignTransferStatus_4: typeof Handle_XSControl_SignTransferStatus_4;
  XSControl_Functions: typeof XSControl_Functions;
  XSControl_TransferWriter: typeof XSControl_TransferWriter;
  Handle_XSControl_TransferWriter: typeof Handle_XSControl_TransferWriter;
  Handle_XSControl_TransferWriter_1: typeof Handle_XSControl_TransferWriter_1;
  Handle_XSControl_TransferWriter_2: typeof Handle_XSControl_TransferWriter_2;
  Handle_XSControl_TransferWriter_3: typeof Handle_XSControl_TransferWriter_3;
  Handle_XSControl_TransferWriter_4: typeof Handle_XSControl_TransferWriter_4;
  XSControl_SelectForTransfer: typeof XSControl_SelectForTransfer;
  XSControl_SelectForTransfer_1: typeof XSControl_SelectForTransfer_1;
  XSControl_SelectForTransfer_2: typeof XSControl_SelectForTransfer_2;
  Handle_XSControl_SelectForTransfer: typeof Handle_XSControl_SelectForTransfer;
  Handle_XSControl_SelectForTransfer_1: typeof Handle_XSControl_SelectForTransfer_1;
  Handle_XSControl_SelectForTransfer_2: typeof Handle_XSControl_SelectForTransfer_2;
  Handle_XSControl_SelectForTransfer_3: typeof Handle_XSControl_SelectForTransfer_3;
  Handle_XSControl_SelectForTransfer_4: typeof Handle_XSControl_SelectForTransfer_4;
  Handle_XSControl_ConnectedShapes: typeof Handle_XSControl_ConnectedShapes;
  Handle_XSControl_ConnectedShapes_1: typeof Handle_XSControl_ConnectedShapes_1;
  Handle_XSControl_ConnectedShapes_2: typeof Handle_XSControl_ConnectedShapes_2;
  Handle_XSControl_ConnectedShapes_3: typeof Handle_XSControl_ConnectedShapes_3;
  Handle_XSControl_ConnectedShapes_4: typeof Handle_XSControl_ConnectedShapes_4;
  XSControl_ConnectedShapes: typeof XSControl_ConnectedShapes;
  XSControl_ConnectedShapes_1: typeof XSControl_ConnectedShapes_1;
  XSControl_ConnectedShapes_2: typeof XSControl_ConnectedShapes_2;
  XSControl_FuncShape: typeof XSControl_FuncShape;
  XSControl_Utils: typeof XSControl_Utils;
  Handle_XSControl_WorkSession: typeof Handle_XSControl_WorkSession;
  Handle_XSControl_WorkSession_1: typeof Handle_XSControl_WorkSession_1;
  Handle_XSControl_WorkSession_2: typeof Handle_XSControl_WorkSession_2;
  Handle_XSControl_WorkSession_3: typeof Handle_XSControl_WorkSession_3;
  Handle_XSControl_WorkSession_4: typeof Handle_XSControl_WorkSession_4;
  XSControl_WorkSession: typeof XSControl_WorkSession;
  Handle_XSControl_Vars: typeof Handle_XSControl_Vars;
  Handle_XSControl_Vars_1: typeof Handle_XSControl_Vars_1;
  Handle_XSControl_Vars_2: typeof Handle_XSControl_Vars_2;
  Handle_XSControl_Vars_3: typeof Handle_XSControl_Vars_3;
  Handle_XSControl_Vars_4: typeof Handle_XSControl_Vars_4;
  XSControl_Vars: typeof XSControl_Vars;
  Handle_XSControl_Controller: typeof Handle_XSControl_Controller;
  Handle_XSControl_Controller_1: typeof Handle_XSControl_Controller_1;
  Handle_XSControl_Controller_2: typeof Handle_XSControl_Controller_2;
  Handle_XSControl_Controller_3: typeof Handle_XSControl_Controller_3;
  Handle_XSControl_Controller_4: typeof Handle_XSControl_Controller_4;
  XSControl_Controller: typeof XSControl_Controller;
  XSControl_Reader: typeof XSControl_Reader;
  XSControl_Reader_1: typeof XSControl_Reader_1;
  XSControl_Reader_2: typeof XSControl_Reader_2;
  XSControl_Reader_3: typeof XSControl_Reader_3;
  XSControl_TransferReader: typeof XSControl_TransferReader;
  Handle_XSControl_TransferReader: typeof Handle_XSControl_TransferReader;
  Handle_XSControl_TransferReader_1: typeof Handle_XSControl_TransferReader_1;
  Handle_XSControl_TransferReader_2: typeof Handle_XSControl_TransferReader_2;
  Handle_XSControl_TransferReader_3: typeof Handle_XSControl_TransferReader_3;
  Handle_XSControl_TransferReader_4: typeof Handle_XSControl_TransferReader_4;
  XSControl_Writer: typeof XSControl_Writer;
  XSControl_Writer_1: typeof XSControl_Writer_1;
  XSControl_Writer_2: typeof XSControl_Writer_2;
  XSControl_Writer_3: typeof XSControl_Writer_3;
  StepVisual_CameraModelD3MultiClippingUnionSelect: typeof StepVisual_CameraModelD3MultiClippingUnionSelect;
  Handle_StepVisual_ContextDependentOverRidingStyledItem: typeof Handle_StepVisual_ContextDependentOverRidingStyledItem;
  Handle_StepVisual_ContextDependentOverRidingStyledItem_1: typeof Handle_StepVisual_ContextDependentOverRidingStyledItem_1;
  Handle_StepVisual_ContextDependentOverRidingStyledItem_2: typeof Handle_StepVisual_ContextDependentOverRidingStyledItem_2;
  Handle_StepVisual_ContextDependentOverRidingStyledItem_3: typeof Handle_StepVisual_ContextDependentOverRidingStyledItem_3;
  Handle_StepVisual_ContextDependentOverRidingStyledItem_4: typeof Handle_StepVisual_ContextDependentOverRidingStyledItem_4;
  StepVisual_ContextDependentOverRidingStyledItem: typeof StepVisual_ContextDependentOverRidingStyledItem;
  StepVisual_PresentationRepresentationSelect: typeof StepVisual_PresentationRepresentationSelect;
  Handle_StepVisual_HArray1OfStyleContextSelect: typeof Handle_StepVisual_HArray1OfStyleContextSelect;
  Handle_StepVisual_HArray1OfStyleContextSelect_1: typeof Handle_StepVisual_HArray1OfStyleContextSelect_1;
  Handle_StepVisual_HArray1OfStyleContextSelect_2: typeof Handle_StepVisual_HArray1OfStyleContextSelect_2;
  Handle_StepVisual_HArray1OfStyleContextSelect_3: typeof Handle_StepVisual_HArray1OfStyleContextSelect_3;
  Handle_StepVisual_HArray1OfStyleContextSelect_4: typeof Handle_StepVisual_HArray1OfStyleContextSelect_4;
  Handle_StepVisual_AnnotationTextOccurrence: typeof Handle_StepVisual_AnnotationTextOccurrence;
  Handle_StepVisual_AnnotationTextOccurrence_1: typeof Handle_StepVisual_AnnotationTextOccurrence_1;
  Handle_StepVisual_AnnotationTextOccurrence_2: typeof Handle_StepVisual_AnnotationTextOccurrence_2;
  Handle_StepVisual_AnnotationTextOccurrence_3: typeof Handle_StepVisual_AnnotationTextOccurrence_3;
  Handle_StepVisual_AnnotationTextOccurrence_4: typeof Handle_StepVisual_AnnotationTextOccurrence_4;
  StepVisual_AnnotationTextOccurrence: typeof StepVisual_AnnotationTextOccurrence;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_1: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_1;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_2: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_2;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_3: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_3;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_4: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingUnionSelect_4;
  StepVisual_AreaInSet: typeof StepVisual_AreaInSet;
  Handle_StepVisual_AreaInSet: typeof Handle_StepVisual_AreaInSet;
  Handle_StepVisual_AreaInSet_1: typeof Handle_StepVisual_AreaInSet_1;
  Handle_StepVisual_AreaInSet_2: typeof Handle_StepVisual_AreaInSet_2;
  Handle_StepVisual_AreaInSet_3: typeof Handle_StepVisual_AreaInSet_3;
  Handle_StepVisual_AreaInSet_4: typeof Handle_StepVisual_AreaInSet_4;
  StepVisual_CurveStyleFontSelect: typeof StepVisual_CurveStyleFontSelect;
  Handle_StepVisual_CameraModelD3MultiClipping: typeof Handle_StepVisual_CameraModelD3MultiClipping;
  Handle_StepVisual_CameraModelD3MultiClipping_1: typeof Handle_StepVisual_CameraModelD3MultiClipping_1;
  Handle_StepVisual_CameraModelD3MultiClipping_2: typeof Handle_StepVisual_CameraModelD3MultiClipping_2;
  Handle_StepVisual_CameraModelD3MultiClipping_3: typeof Handle_StepVisual_CameraModelD3MultiClipping_3;
  Handle_StepVisual_CameraModelD3MultiClipping_4: typeof Handle_StepVisual_CameraModelD3MultiClipping_4;
  StepVisual_CameraModelD3MultiClipping: typeof StepVisual_CameraModelD3MultiClipping;
  StepVisual_Array1OfDraughtingCalloutElement: typeof StepVisual_Array1OfDraughtingCalloutElement;
  StepVisual_Array1OfDraughtingCalloutElement_1: typeof StepVisual_Array1OfDraughtingCalloutElement_1;
  StepVisual_Array1OfDraughtingCalloutElement_2: typeof StepVisual_Array1OfDraughtingCalloutElement_2;
  StepVisual_Array1OfDraughtingCalloutElement_3: typeof StepVisual_Array1OfDraughtingCalloutElement_3;
  StepVisual_Array1OfDraughtingCalloutElement_4: typeof StepVisual_Array1OfDraughtingCalloutElement_4;
  StepVisual_Array1OfDraughtingCalloutElement_5: typeof StepVisual_Array1OfDraughtingCalloutElement_5;
  StepVisual_Array1OfFillStyleSelect: typeof StepVisual_Array1OfFillStyleSelect;
  StepVisual_Array1OfFillStyleSelect_1: typeof StepVisual_Array1OfFillStyleSelect_1;
  StepVisual_Array1OfFillStyleSelect_2: typeof StepVisual_Array1OfFillStyleSelect_2;
  StepVisual_Array1OfFillStyleSelect_3: typeof StepVisual_Array1OfFillStyleSelect_3;
  StepVisual_Array1OfFillStyleSelect_4: typeof StepVisual_Array1OfFillStyleSelect_4;
  StepVisual_Array1OfFillStyleSelect_5: typeof StepVisual_Array1OfFillStyleSelect_5;
  StepVisual_Array1OfSurfaceStyleElementSelect: typeof StepVisual_Array1OfSurfaceStyleElementSelect;
  StepVisual_Array1OfSurfaceStyleElementSelect_1: typeof StepVisual_Array1OfSurfaceStyleElementSelect_1;
  StepVisual_Array1OfSurfaceStyleElementSelect_2: typeof StepVisual_Array1OfSurfaceStyleElementSelect_2;
  StepVisual_Array1OfSurfaceStyleElementSelect_3: typeof StepVisual_Array1OfSurfaceStyleElementSelect_3;
  StepVisual_Array1OfSurfaceStyleElementSelect_4: typeof StepVisual_Array1OfSurfaceStyleElementSelect_4;
  StepVisual_Array1OfSurfaceStyleElementSelect_5: typeof StepVisual_Array1OfSurfaceStyleElementSelect_5;
  Handle_StepVisual_ColourSpecification: typeof Handle_StepVisual_ColourSpecification;
  Handle_StepVisual_ColourSpecification_1: typeof Handle_StepVisual_ColourSpecification_1;
  Handle_StepVisual_ColourSpecification_2: typeof Handle_StepVisual_ColourSpecification_2;
  Handle_StepVisual_ColourSpecification_3: typeof Handle_StepVisual_ColourSpecification_3;
  Handle_StepVisual_ColourSpecification_4: typeof Handle_StepVisual_ColourSpecification_4;
  StepVisual_ColourSpecification: typeof StepVisual_ColourSpecification;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_1: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_1;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_2: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_2;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_3: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_3;
  Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_4: typeof Handle_StepVisual_HArray1OfCameraModelD3MultiClippingInterectionSelect_4;
  StepVisual_BoxCharacteristicSelect: typeof StepVisual_BoxCharacteristicSelect;
  StepVisual_PresentationStyleByContext: typeof StepVisual_PresentationStyleByContext;
  Handle_StepVisual_PresentationStyleByContext: typeof Handle_StepVisual_PresentationStyleByContext;
  Handle_StepVisual_PresentationStyleByContext_1: typeof Handle_StepVisual_PresentationStyleByContext_1;
  Handle_StepVisual_PresentationStyleByContext_2: typeof Handle_StepVisual_PresentationStyleByContext_2;
  Handle_StepVisual_PresentationStyleByContext_3: typeof Handle_StepVisual_PresentationStyleByContext_3;
  Handle_StepVisual_PresentationStyleByContext_4: typeof Handle_StepVisual_PresentationStyleByContext_4;
  StepVisual_NullStyleMember: typeof StepVisual_NullStyleMember;
  Handle_StepVisual_NullStyleMember: typeof Handle_StepVisual_NullStyleMember;
  Handle_StepVisual_NullStyleMember_1: typeof Handle_StepVisual_NullStyleMember_1;
  Handle_StepVisual_NullStyleMember_2: typeof Handle_StepVisual_NullStyleMember_2;
  Handle_StepVisual_NullStyleMember_3: typeof Handle_StepVisual_NullStyleMember_3;
  Handle_StepVisual_NullStyleMember_4: typeof Handle_StepVisual_NullStyleMember_4;
  StepVisual_PresentationSize: typeof StepVisual_PresentationSize;
  Handle_StepVisual_PresentationSize: typeof Handle_StepVisual_PresentationSize;
  Handle_StepVisual_PresentationSize_1: typeof Handle_StepVisual_PresentationSize_1;
  Handle_StepVisual_PresentationSize_2: typeof Handle_StepVisual_PresentationSize_2;
  Handle_StepVisual_PresentationSize_3: typeof Handle_StepVisual_PresentationSize_3;
  Handle_StepVisual_PresentationSize_4: typeof Handle_StepVisual_PresentationSize_4;
  StepVisual_SurfaceStyleElementSelect: typeof StepVisual_SurfaceStyleElementSelect;
  StepVisual_PresentationSizeAssignmentSelect: typeof StepVisual_PresentationSizeAssignmentSelect;
  StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel: typeof StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel;
  Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel: typeof Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel;
  Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_1: typeof Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_1;
  Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_2: typeof Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_2;
  Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_3: typeof Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_3;
  Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_4: typeof Handle_StepVisual_CharacterizedObjAndRepresentationAndDraughtingModel_4;
  Handle_StepVisual_PresentationRepresentation: typeof Handle_StepVisual_PresentationRepresentation;
  Handle_StepVisual_PresentationRepresentation_1: typeof Handle_StepVisual_PresentationRepresentation_1;
  Handle_StepVisual_PresentationRepresentation_2: typeof Handle_StepVisual_PresentationRepresentation_2;
  Handle_StepVisual_PresentationRepresentation_3: typeof Handle_StepVisual_PresentationRepresentation_3;
  Handle_StepVisual_PresentationRepresentation_4: typeof Handle_StepVisual_PresentationRepresentation_4;
  StepVisual_PresentationRepresentation: typeof StepVisual_PresentationRepresentation;
  Handle_StepVisual_HArray1OfLayeredItem: typeof Handle_StepVisual_HArray1OfLayeredItem;
  Handle_StepVisual_HArray1OfLayeredItem_1: typeof Handle_StepVisual_HArray1OfLayeredItem_1;
  Handle_StepVisual_HArray1OfLayeredItem_2: typeof Handle_StepVisual_HArray1OfLayeredItem_2;
  Handle_StepVisual_HArray1OfLayeredItem_3: typeof Handle_StepVisual_HArray1OfLayeredItem_3;
  Handle_StepVisual_HArray1OfLayeredItem_4: typeof Handle_StepVisual_HArray1OfLayeredItem_4;
  StepVisual_StyleContextSelect: typeof StepVisual_StyleContextSelect;
  StepVisual_AnnotationCurveOccurrenceAndGeomReprItem: typeof StepVisual_AnnotationCurveOccurrenceAndGeomReprItem;
  Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem: typeof Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem;
  Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_1: typeof Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_1;
  Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_2: typeof Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_2;
  Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_3: typeof Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_3;
  Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_4: typeof Handle_StepVisual_AnnotationCurveOccurrenceAndGeomReprItem_4;
  Handle_StepVisual_MechanicalDesignGeometricPresentationArea: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationArea;
  Handle_StepVisual_MechanicalDesignGeometricPresentationArea_1: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationArea_1;
  Handle_StepVisual_MechanicalDesignGeometricPresentationArea_2: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationArea_2;
  Handle_StepVisual_MechanicalDesignGeometricPresentationArea_3: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationArea_3;
  Handle_StepVisual_MechanicalDesignGeometricPresentationArea_4: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationArea_4;
  StepVisual_MechanicalDesignGeometricPresentationArea: typeof StepVisual_MechanicalDesignGeometricPresentationArea;
  StepVisual_MarkerSelect: typeof StepVisual_MarkerSelect;
  StepVisual_TextStyleWithBoxCharacteristics: typeof StepVisual_TextStyleWithBoxCharacteristics;
  Handle_StepVisual_TextStyleWithBoxCharacteristics: typeof Handle_StepVisual_TextStyleWithBoxCharacteristics;
  Handle_StepVisual_TextStyleWithBoxCharacteristics_1: typeof Handle_StepVisual_TextStyleWithBoxCharacteristics_1;
  Handle_StepVisual_TextStyleWithBoxCharacteristics_2: typeof Handle_StepVisual_TextStyleWithBoxCharacteristics_2;
  Handle_StepVisual_TextStyleWithBoxCharacteristics_3: typeof Handle_StepVisual_TextStyleWithBoxCharacteristics_3;
  Handle_StepVisual_TextStyleWithBoxCharacteristics_4: typeof Handle_StepVisual_TextStyleWithBoxCharacteristics_4;
  StepVisual_Array1OfPresentationStyleSelect: typeof StepVisual_Array1OfPresentationStyleSelect;
  StepVisual_Array1OfPresentationStyleSelect_1: typeof StepVisual_Array1OfPresentationStyleSelect_1;
  StepVisual_Array1OfPresentationStyleSelect_2: typeof StepVisual_Array1OfPresentationStyleSelect_2;
  StepVisual_Array1OfPresentationStyleSelect_3: typeof StepVisual_Array1OfPresentationStyleSelect_3;
  StepVisual_Array1OfPresentationStyleSelect_4: typeof StepVisual_Array1OfPresentationStyleSelect_4;
  StepVisual_Array1OfPresentationStyleSelect_5: typeof StepVisual_Array1OfPresentationStyleSelect_5;
  StepVisual_Array1OfLayeredItem: typeof StepVisual_Array1OfLayeredItem;
  StepVisual_Array1OfLayeredItem_1: typeof StepVisual_Array1OfLayeredItem_1;
  StepVisual_Array1OfLayeredItem_2: typeof StepVisual_Array1OfLayeredItem_2;
  StepVisual_Array1OfLayeredItem_3: typeof StepVisual_Array1OfLayeredItem_3;
  StepVisual_Array1OfLayeredItem_4: typeof StepVisual_Array1OfLayeredItem_4;
  StepVisual_Array1OfLayeredItem_5: typeof StepVisual_Array1OfLayeredItem_5;
  Handle_StepVisual_PresentationSet: typeof Handle_StepVisual_PresentationSet;
  Handle_StepVisual_PresentationSet_1: typeof Handle_StepVisual_PresentationSet_1;
  Handle_StepVisual_PresentationSet_2: typeof Handle_StepVisual_PresentationSet_2;
  Handle_StepVisual_PresentationSet_3: typeof Handle_StepVisual_PresentationSet_3;
  Handle_StepVisual_PresentationSet_4: typeof Handle_StepVisual_PresentationSet_4;
  StepVisual_PresentationSet: typeof StepVisual_PresentationSet;
  Handle_StepVisual_OverRidingStyledItem: typeof Handle_StepVisual_OverRidingStyledItem;
  Handle_StepVisual_OverRidingStyledItem_1: typeof Handle_StepVisual_OverRidingStyledItem_1;
  Handle_StepVisual_OverRidingStyledItem_2: typeof Handle_StepVisual_OverRidingStyledItem_2;
  Handle_StepVisual_OverRidingStyledItem_3: typeof Handle_StepVisual_OverRidingStyledItem_3;
  Handle_StepVisual_OverRidingStyledItem_4: typeof Handle_StepVisual_OverRidingStyledItem_4;
  StepVisual_OverRidingStyledItem: typeof StepVisual_OverRidingStyledItem;
  StepVisual_Array1OfTextOrCharacter: typeof StepVisual_Array1OfTextOrCharacter;
  StepVisual_Array1OfTextOrCharacter_1: typeof StepVisual_Array1OfTextOrCharacter_1;
  StepVisual_Array1OfTextOrCharacter_2: typeof StepVisual_Array1OfTextOrCharacter_2;
  StepVisual_Array1OfTextOrCharacter_3: typeof StepVisual_Array1OfTextOrCharacter_3;
  StepVisual_Array1OfTextOrCharacter_4: typeof StepVisual_Array1OfTextOrCharacter_4;
  StepVisual_Array1OfTextOrCharacter_5: typeof StepVisual_Array1OfTextOrCharacter_5;
  Handle_StepVisual_HArray1OfRenderingPropertiesSelect: typeof Handle_StepVisual_HArray1OfRenderingPropertiesSelect;
  Handle_StepVisual_HArray1OfRenderingPropertiesSelect_1: typeof Handle_StepVisual_HArray1OfRenderingPropertiesSelect_1;
  Handle_StepVisual_HArray1OfRenderingPropertiesSelect_2: typeof Handle_StepVisual_HArray1OfRenderingPropertiesSelect_2;
  Handle_StepVisual_HArray1OfRenderingPropertiesSelect_3: typeof Handle_StepVisual_HArray1OfRenderingPropertiesSelect_3;
  Handle_StepVisual_HArray1OfRenderingPropertiesSelect_4: typeof Handle_StepVisual_HArray1OfRenderingPropertiesSelect_4;
  StepVisual_CameraModelD3MultiClippingUnion: typeof StepVisual_CameraModelD3MultiClippingUnion;
  Handle_StepVisual_CameraModelD3MultiClippingUnion: typeof Handle_StepVisual_CameraModelD3MultiClippingUnion;
  Handle_StepVisual_CameraModelD3MultiClippingUnion_1: typeof Handle_StepVisual_CameraModelD3MultiClippingUnion_1;
  Handle_StepVisual_CameraModelD3MultiClippingUnion_2: typeof Handle_StepVisual_CameraModelD3MultiClippingUnion_2;
  Handle_StepVisual_CameraModelD3MultiClippingUnion_3: typeof Handle_StepVisual_CameraModelD3MultiClippingUnion_3;
  Handle_StepVisual_CameraModelD3MultiClippingUnion_4: typeof Handle_StepVisual_CameraModelD3MultiClippingUnion_4;
  StepVisual_Array1OfStyleContextSelect: typeof StepVisual_Array1OfStyleContextSelect;
  StepVisual_Array1OfStyleContextSelect_1: typeof StepVisual_Array1OfStyleContextSelect_1;
  StepVisual_Array1OfStyleContextSelect_2: typeof StepVisual_Array1OfStyleContextSelect_2;
  StepVisual_Array1OfStyleContextSelect_3: typeof StepVisual_Array1OfStyleContextSelect_3;
  StepVisual_Array1OfStyleContextSelect_4: typeof StepVisual_Array1OfStyleContextSelect_4;
  StepVisual_Array1OfStyleContextSelect_5: typeof StepVisual_Array1OfStyleContextSelect_5;
  Handle_StepVisual_TessellatedItem: typeof Handle_StepVisual_TessellatedItem;
  Handle_StepVisual_TessellatedItem_1: typeof Handle_StepVisual_TessellatedItem_1;
  Handle_StepVisual_TessellatedItem_2: typeof Handle_StepVisual_TessellatedItem_2;
  Handle_StepVisual_TessellatedItem_3: typeof Handle_StepVisual_TessellatedItem_3;
  Handle_StepVisual_TessellatedItem_4: typeof Handle_StepVisual_TessellatedItem_4;
  StepVisual_TessellatedItem: typeof StepVisual_TessellatedItem;
  StepVisual_SurfaceSide: StepVisual_SurfaceSide;
  StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect: typeof StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect;
  StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_1: typeof StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_1;
  StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_2: typeof StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_2;
  StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_3: typeof StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_3;
  StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_4: typeof StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_4;
  StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_5: typeof StepVisual_Array1OfCameraModelD3MultiClippingInterectionSelect_5;
  Handle_StepVisual_PlanarBox: typeof Handle_StepVisual_PlanarBox;
  Handle_StepVisual_PlanarBox_1: typeof Handle_StepVisual_PlanarBox_1;
  Handle_StepVisual_PlanarBox_2: typeof Handle_StepVisual_PlanarBox_2;
  Handle_StepVisual_PlanarBox_3: typeof Handle_StepVisual_PlanarBox_3;
  Handle_StepVisual_PlanarBox_4: typeof Handle_StepVisual_PlanarBox_4;
  StepVisual_PlanarBox: typeof StepVisual_PlanarBox;
  StepVisual_CameraModel: typeof StepVisual_CameraModel;
  Handle_StepVisual_CameraModel: typeof Handle_StepVisual_CameraModel;
  Handle_StepVisual_CameraModel_1: typeof Handle_StepVisual_CameraModel_1;
  Handle_StepVisual_CameraModel_2: typeof Handle_StepVisual_CameraModel_2;
  Handle_StepVisual_CameraModel_3: typeof Handle_StepVisual_CameraModel_3;
  Handle_StepVisual_CameraModel_4: typeof Handle_StepVisual_CameraModel_4;
  StepVisual_DraughtingPreDefinedColour: typeof StepVisual_DraughtingPreDefinedColour;
  Handle_StepVisual_DraughtingPreDefinedColour: typeof Handle_StepVisual_DraughtingPreDefinedColour;
  Handle_StepVisual_DraughtingPreDefinedColour_1: typeof Handle_StepVisual_DraughtingPreDefinedColour_1;
  Handle_StepVisual_DraughtingPreDefinedColour_2: typeof Handle_StepVisual_DraughtingPreDefinedColour_2;
  Handle_StepVisual_DraughtingPreDefinedColour_3: typeof Handle_StepVisual_DraughtingPreDefinedColour_3;
  Handle_StepVisual_DraughtingPreDefinedColour_4: typeof Handle_StepVisual_DraughtingPreDefinedColour_4;
  StepVisual_CameraModelD3MultiClippingInterectionSelect: typeof StepVisual_CameraModelD3MultiClippingInterectionSelect;
  Handle_StepVisual_HArray1OfCurveStyleFontPattern: typeof Handle_StepVisual_HArray1OfCurveStyleFontPattern;
  Handle_StepVisual_HArray1OfCurveStyleFontPattern_1: typeof Handle_StepVisual_HArray1OfCurveStyleFontPattern_1;
  Handle_StepVisual_HArray1OfCurveStyleFontPattern_2: typeof Handle_StepVisual_HArray1OfCurveStyleFontPattern_2;
  Handle_StepVisual_HArray1OfCurveStyleFontPattern_3: typeof Handle_StepVisual_HArray1OfCurveStyleFontPattern_3;
  Handle_StepVisual_HArray1OfCurveStyleFontPattern_4: typeof Handle_StepVisual_HArray1OfCurveStyleFontPattern_4;
  Handle_StepVisual_PresentationStyleAssignment: typeof Handle_StepVisual_PresentationStyleAssignment;
  Handle_StepVisual_PresentationStyleAssignment_1: typeof Handle_StepVisual_PresentationStyleAssignment_1;
  Handle_StepVisual_PresentationStyleAssignment_2: typeof Handle_StepVisual_PresentationStyleAssignment_2;
  Handle_StepVisual_PresentationStyleAssignment_3: typeof Handle_StepVisual_PresentationStyleAssignment_3;
  Handle_StepVisual_PresentationStyleAssignment_4: typeof Handle_StepVisual_PresentationStyleAssignment_4;
  StepVisual_PresentationStyleAssignment: typeof StepVisual_PresentationStyleAssignment;
  StepVisual_Array1OfDirectionCountSelect: typeof StepVisual_Array1OfDirectionCountSelect;
  StepVisual_Array1OfDirectionCountSelect_1: typeof StepVisual_Array1OfDirectionCountSelect_1;
  StepVisual_Array1OfDirectionCountSelect_2: typeof StepVisual_Array1OfDirectionCountSelect_2;
  StepVisual_Array1OfDirectionCountSelect_3: typeof StepVisual_Array1OfDirectionCountSelect_3;
  StepVisual_Array1OfDirectionCountSelect_4: typeof StepVisual_Array1OfDirectionCountSelect_4;
  StepVisual_Array1OfDirectionCountSelect_5: typeof StepVisual_Array1OfDirectionCountSelect_5;
  StepVisual_Invisibility: typeof StepVisual_Invisibility;
  Handle_StepVisual_Invisibility: typeof Handle_StepVisual_Invisibility;
  Handle_StepVisual_Invisibility_1: typeof Handle_StepVisual_Invisibility_1;
  Handle_StepVisual_Invisibility_2: typeof Handle_StepVisual_Invisibility_2;
  Handle_StepVisual_Invisibility_3: typeof Handle_StepVisual_Invisibility_3;
  Handle_StepVisual_Invisibility_4: typeof Handle_StepVisual_Invisibility_4;
  StepVisual_PresentationLayerAssignment: typeof StepVisual_PresentationLayerAssignment;
  Handle_StepVisual_PresentationLayerAssignment: typeof Handle_StepVisual_PresentationLayerAssignment;
  Handle_StepVisual_PresentationLayerAssignment_1: typeof Handle_StepVisual_PresentationLayerAssignment_1;
  Handle_StepVisual_PresentationLayerAssignment_2: typeof Handle_StepVisual_PresentationLayerAssignment_2;
  Handle_StepVisual_PresentationLayerAssignment_3: typeof Handle_StepVisual_PresentationLayerAssignment_3;
  Handle_StepVisual_PresentationLayerAssignment_4: typeof Handle_StepVisual_PresentationLayerAssignment_4;
  Handle_StepVisual_ExternallyDefinedCurveFont: typeof Handle_StepVisual_ExternallyDefinedCurveFont;
  Handle_StepVisual_ExternallyDefinedCurveFont_1: typeof Handle_StepVisual_ExternallyDefinedCurveFont_1;
  Handle_StepVisual_ExternallyDefinedCurveFont_2: typeof Handle_StepVisual_ExternallyDefinedCurveFont_2;
  Handle_StepVisual_ExternallyDefinedCurveFont_3: typeof Handle_StepVisual_ExternallyDefinedCurveFont_3;
  Handle_StepVisual_ExternallyDefinedCurveFont_4: typeof Handle_StepVisual_ExternallyDefinedCurveFont_4;
  StepVisual_ExternallyDefinedCurveFont: typeof StepVisual_ExternallyDefinedCurveFont;
  Handle_StepVisual_ColourRgb: typeof Handle_StepVisual_ColourRgb;
  Handle_StepVisual_ColourRgb_1: typeof Handle_StepVisual_ColourRgb_1;
  Handle_StepVisual_ColourRgb_2: typeof Handle_StepVisual_ColourRgb_2;
  Handle_StepVisual_ColourRgb_3: typeof Handle_StepVisual_ColourRgb_3;
  Handle_StepVisual_ColourRgb_4: typeof Handle_StepVisual_ColourRgb_4;
  StepVisual_ColourRgb: typeof StepVisual_ColourRgb;
  StepVisual_SurfaceStyleReflectanceAmbient: typeof StepVisual_SurfaceStyleReflectanceAmbient;
  Handle_StepVisual_SurfaceStyleReflectanceAmbient: typeof Handle_StepVisual_SurfaceStyleReflectanceAmbient;
  Handle_StepVisual_SurfaceStyleReflectanceAmbient_1: typeof Handle_StepVisual_SurfaceStyleReflectanceAmbient_1;
  Handle_StepVisual_SurfaceStyleReflectanceAmbient_2: typeof Handle_StepVisual_SurfaceStyleReflectanceAmbient_2;
  Handle_StepVisual_SurfaceStyleReflectanceAmbient_3: typeof Handle_StepVisual_SurfaceStyleReflectanceAmbient_3;
  Handle_StepVisual_SurfaceStyleReflectanceAmbient_4: typeof Handle_StepVisual_SurfaceStyleReflectanceAmbient_4;
  Handle_StepVisual_AnnotationFillAreaOccurrence: typeof Handle_StepVisual_AnnotationFillAreaOccurrence;
  Handle_StepVisual_AnnotationFillAreaOccurrence_1: typeof Handle_StepVisual_AnnotationFillAreaOccurrence_1;
  Handle_StepVisual_AnnotationFillAreaOccurrence_2: typeof Handle_StepVisual_AnnotationFillAreaOccurrence_2;
  Handle_StepVisual_AnnotationFillAreaOccurrence_3: typeof Handle_StepVisual_AnnotationFillAreaOccurrence_3;
  Handle_StepVisual_AnnotationFillAreaOccurrence_4: typeof Handle_StepVisual_AnnotationFillAreaOccurrence_4;
  StepVisual_AnnotationFillAreaOccurrence: typeof StepVisual_AnnotationFillAreaOccurrence;
  Handle_StepVisual_HArray1OfPresentationStyleSelect: typeof Handle_StepVisual_HArray1OfPresentationStyleSelect;
  Handle_StepVisual_HArray1OfPresentationStyleSelect_1: typeof Handle_StepVisual_HArray1OfPresentationStyleSelect_1;
  Handle_StepVisual_HArray1OfPresentationStyleSelect_2: typeof Handle_StepVisual_HArray1OfPresentationStyleSelect_2;
  Handle_StepVisual_HArray1OfPresentationStyleSelect_3: typeof Handle_StepVisual_HArray1OfPresentationStyleSelect_3;
  Handle_StepVisual_HArray1OfPresentationStyleSelect_4: typeof Handle_StepVisual_HArray1OfPresentationStyleSelect_4;
  StepVisual_MarkerType: StepVisual_MarkerType;
  StepVisual_ShadingSurfaceMethod: StepVisual_ShadingSurfaceMethod;
  StepVisual_PointStyle: typeof StepVisual_PointStyle;
  Handle_StepVisual_PointStyle: typeof Handle_StepVisual_PointStyle;
  Handle_StepVisual_PointStyle_1: typeof Handle_StepVisual_PointStyle_1;
  Handle_StepVisual_PointStyle_2: typeof Handle_StepVisual_PointStyle_2;
  Handle_StepVisual_PointStyle_3: typeof Handle_StepVisual_PointStyle_3;
  Handle_StepVisual_PointStyle_4: typeof Handle_StepVisual_PointStyle_4;
  Handle_StepVisual_CurveStyleFont: typeof Handle_StepVisual_CurveStyleFont;
  Handle_StepVisual_CurveStyleFont_1: typeof Handle_StepVisual_CurveStyleFont_1;
  Handle_StepVisual_CurveStyleFont_2: typeof Handle_StepVisual_CurveStyleFont_2;
  Handle_StepVisual_CurveStyleFont_3: typeof Handle_StepVisual_CurveStyleFont_3;
  Handle_StepVisual_CurveStyleFont_4: typeof Handle_StepVisual_CurveStyleFont_4;
  StepVisual_CurveStyleFont: typeof StepVisual_CurveStyleFont;
  StepVisual_CameraImage: typeof StepVisual_CameraImage;
  Handle_StepVisual_CameraImage: typeof Handle_StepVisual_CameraImage;
  Handle_StepVisual_CameraImage_1: typeof Handle_StepVisual_CameraImage_1;
  Handle_StepVisual_CameraImage_2: typeof Handle_StepVisual_CameraImage_2;
  Handle_StepVisual_CameraImage_3: typeof Handle_StepVisual_CameraImage_3;
  Handle_StepVisual_CameraImage_4: typeof Handle_StepVisual_CameraImage_4;
  StepVisual_TextPath: StepVisual_TextPath;
  StepVisual_AnnotationText: typeof StepVisual_AnnotationText;
  Handle_StepVisual_AnnotationText: typeof Handle_StepVisual_AnnotationText;
  Handle_StepVisual_AnnotationText_1: typeof Handle_StepVisual_AnnotationText_1;
  Handle_StepVisual_AnnotationText_2: typeof Handle_StepVisual_AnnotationText_2;
  Handle_StepVisual_AnnotationText_3: typeof Handle_StepVisual_AnnotationText_3;
  Handle_StepVisual_AnnotationText_4: typeof Handle_StepVisual_AnnotationText_4;
  Handle_StepVisual_CameraModelD2: typeof Handle_StepVisual_CameraModelD2;
  Handle_StepVisual_CameraModelD2_1: typeof Handle_StepVisual_CameraModelD2_1;
  Handle_StepVisual_CameraModelD2_2: typeof Handle_StepVisual_CameraModelD2_2;
  Handle_StepVisual_CameraModelD2_3: typeof Handle_StepVisual_CameraModelD2_3;
  Handle_StepVisual_CameraModelD2_4: typeof Handle_StepVisual_CameraModelD2_4;
  StepVisual_CameraModelD2: typeof StepVisual_CameraModelD2;
  StepVisual_PreDefinedTextFont: typeof StepVisual_PreDefinedTextFont;
  Handle_StepVisual_PreDefinedTextFont: typeof Handle_StepVisual_PreDefinedTextFont;
  Handle_StepVisual_PreDefinedTextFont_1: typeof Handle_StepVisual_PreDefinedTextFont_1;
  Handle_StepVisual_PreDefinedTextFont_2: typeof Handle_StepVisual_PreDefinedTextFont_2;
  Handle_StepVisual_PreDefinedTextFont_3: typeof Handle_StepVisual_PreDefinedTextFont_3;
  Handle_StepVisual_PreDefinedTextFont_4: typeof Handle_StepVisual_PreDefinedTextFont_4;
  StepVisual_SurfaceStyleSilhouette: typeof StepVisual_SurfaceStyleSilhouette;
  Handle_StepVisual_SurfaceStyleSilhouette: typeof Handle_StepVisual_SurfaceStyleSilhouette;
  Handle_StepVisual_SurfaceStyleSilhouette_1: typeof Handle_StepVisual_SurfaceStyleSilhouette_1;
  Handle_StepVisual_SurfaceStyleSilhouette_2: typeof Handle_StepVisual_SurfaceStyleSilhouette_2;
  Handle_StepVisual_SurfaceStyleSilhouette_3: typeof Handle_StepVisual_SurfaceStyleSilhouette_3;
  Handle_StepVisual_SurfaceStyleSilhouette_4: typeof Handle_StepVisual_SurfaceStyleSilhouette_4;
  Handle_StepVisual_DraughtingModel: typeof Handle_StepVisual_DraughtingModel;
  Handle_StepVisual_DraughtingModel_1: typeof Handle_StepVisual_DraughtingModel_1;
  Handle_StepVisual_DraughtingModel_2: typeof Handle_StepVisual_DraughtingModel_2;
  Handle_StepVisual_DraughtingModel_3: typeof Handle_StepVisual_DraughtingModel_3;
  Handle_StepVisual_DraughtingModel_4: typeof Handle_StepVisual_DraughtingModel_4;
  StepVisual_DraughtingModel: typeof StepVisual_DraughtingModel;
  Handle_StepVisual_FillAreaStyle: typeof Handle_StepVisual_FillAreaStyle;
  Handle_StepVisual_FillAreaStyle_1: typeof Handle_StepVisual_FillAreaStyle_1;
  Handle_StepVisual_FillAreaStyle_2: typeof Handle_StepVisual_FillAreaStyle_2;
  Handle_StepVisual_FillAreaStyle_3: typeof Handle_StepVisual_FillAreaStyle_3;
  Handle_StepVisual_FillAreaStyle_4: typeof Handle_StepVisual_FillAreaStyle_4;
  StepVisual_FillAreaStyle: typeof StepVisual_FillAreaStyle;
  StepVisual_InvisibleItem: typeof StepVisual_InvisibleItem;
  Handle_StepVisual_HArray1OfSurfaceStyleElementSelect: typeof Handle_StepVisual_HArray1OfSurfaceStyleElementSelect;
  Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_1: typeof Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_1;
  Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_2: typeof Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_2;
  Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_3: typeof Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_3;
  Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_4: typeof Handle_StepVisual_HArray1OfSurfaceStyleElementSelect_4;
  StepVisual_SurfaceStyleBoundary: typeof StepVisual_SurfaceStyleBoundary;
  Handle_StepVisual_SurfaceStyleBoundary: typeof Handle_StepVisual_SurfaceStyleBoundary;
  Handle_StepVisual_SurfaceStyleBoundary_1: typeof Handle_StepVisual_SurfaceStyleBoundary_1;
  Handle_StepVisual_SurfaceStyleBoundary_2: typeof Handle_StepVisual_SurfaceStyleBoundary_2;
  Handle_StepVisual_SurfaceStyleBoundary_3: typeof Handle_StepVisual_SurfaceStyleBoundary_3;
  Handle_StepVisual_SurfaceStyleBoundary_4: typeof Handle_StepVisual_SurfaceStyleBoundary_4;
  Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation;
  Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_1: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_1;
  Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_2: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_2;
  Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_3: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_3;
  Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_4: typeof Handle_StepVisual_MechanicalDesignGeometricPresentationRepresentation_4;
  StepVisual_MechanicalDesignGeometricPresentationRepresentation: typeof StepVisual_MechanicalDesignGeometricPresentationRepresentation;
  StepVisual_TextStyle: typeof StepVisual_TextStyle;
  Handle_StepVisual_TextStyle: typeof Handle_StepVisual_TextStyle;
  Handle_StepVisual_TextStyle_1: typeof Handle_StepVisual_TextStyle_1;
  Handle_StepVisual_TextStyle_2: typeof Handle_StepVisual_TextStyle_2;
  Handle_StepVisual_TextStyle_3: typeof Handle_StepVisual_TextStyle_3;
  Handle_StepVisual_TextStyle_4: typeof Handle_StepVisual_TextStyle_4;
  StepVisual_AnnotationOccurrence: typeof StepVisual_AnnotationOccurrence;
  Handle_StepVisual_AnnotationOccurrence: typeof Handle_StepVisual_AnnotationOccurrence;
  Handle_StepVisual_AnnotationOccurrence_1: typeof Handle_StepVisual_AnnotationOccurrence_1;
  Handle_StepVisual_AnnotationOccurrence_2: typeof Handle_StepVisual_AnnotationOccurrence_2;
  Handle_StepVisual_AnnotationOccurrence_3: typeof Handle_StepVisual_AnnotationOccurrence_3;
  Handle_StepVisual_AnnotationOccurrence_4: typeof Handle_StepVisual_AnnotationOccurrence_4;
  Handle_StepVisual_TextStyleForDefinedFont: typeof Handle_StepVisual_TextStyleForDefinedFont;
  Handle_StepVisual_TextStyleForDefinedFont_1: typeof Handle_StepVisual_TextStyleForDefinedFont_1;
  Handle_StepVisual_TextStyleForDefinedFont_2: typeof Handle_StepVisual_TextStyleForDefinedFont_2;
  Handle_StepVisual_TextStyleForDefinedFont_3: typeof Handle_StepVisual_TextStyleForDefinedFont_3;
  Handle_StepVisual_TextStyleForDefinedFont_4: typeof Handle_StepVisual_TextStyleForDefinedFont_4;
  StepVisual_TextStyleForDefinedFont: typeof StepVisual_TextStyleForDefinedFont;
  StepVisual_Array1OfInvisibleItem: typeof StepVisual_Array1OfInvisibleItem;
  StepVisual_Array1OfInvisibleItem_1: typeof StepVisual_Array1OfInvisibleItem_1;
  StepVisual_Array1OfInvisibleItem_2: typeof StepVisual_Array1OfInvisibleItem_2;
  StepVisual_Array1OfInvisibleItem_3: typeof StepVisual_Array1OfInvisibleItem_3;
  StepVisual_Array1OfInvisibleItem_4: typeof StepVisual_Array1OfInvisibleItem_4;
  StepVisual_Array1OfInvisibleItem_5: typeof StepVisual_Array1OfInvisibleItem_5;
  StepVisual_ViewVolume: typeof StepVisual_ViewVolume;
  Handle_StepVisual_ViewVolume: typeof Handle_StepVisual_ViewVolume;
  Handle_StepVisual_ViewVolume_1: typeof Handle_StepVisual_ViewVolume_1;
  Handle_StepVisual_ViewVolume_2: typeof Handle_StepVisual_ViewVolume_2;
  Handle_StepVisual_ViewVolume_3: typeof Handle_StepVisual_ViewVolume_3;
  Handle_StepVisual_ViewVolume_4: typeof Handle_StepVisual_ViewVolume_4;
  Handle_StepVisual_SurfaceStyleRendering: typeof Handle_StepVisual_SurfaceStyleRendering;
  Handle_StepVisual_SurfaceStyleRendering_1: typeof Handle_StepVisual_SurfaceStyleRendering_1;
  Handle_StepVisual_SurfaceStyleRendering_2: typeof Handle_StepVisual_SurfaceStyleRendering_2;
  Handle_StepVisual_SurfaceStyleRendering_3: typeof Handle_StepVisual_SurfaceStyleRendering_3;
  Handle_StepVisual_SurfaceStyleRendering_4: typeof Handle_StepVisual_SurfaceStyleRendering_4;
  StepVisual_SurfaceStyleRendering: typeof StepVisual_SurfaceStyleRendering;
  StepVisual_Array1OfBoxCharacteristicSelect: typeof StepVisual_Array1OfBoxCharacteristicSelect;
  StepVisual_Array1OfBoxCharacteristicSelect_1: typeof StepVisual_Array1OfBoxCharacteristicSelect_1;
  StepVisual_Array1OfBoxCharacteristicSelect_2: typeof StepVisual_Array1OfBoxCharacteristicSelect_2;
  StepVisual_Array1OfBoxCharacteristicSelect_3: typeof StepVisual_Array1OfBoxCharacteristicSelect_3;
  StepVisual_Array1OfBoxCharacteristicSelect_4: typeof StepVisual_Array1OfBoxCharacteristicSelect_4;
  StepVisual_Array1OfBoxCharacteristicSelect_5: typeof StepVisual_Array1OfBoxCharacteristicSelect_5;
  StepVisual_CurveStyleFontPattern: typeof StepVisual_CurveStyleFontPattern;
  Handle_StepVisual_CurveStyleFontPattern: typeof Handle_StepVisual_CurveStyleFontPattern;
  Handle_StepVisual_CurveStyleFontPattern_1: typeof Handle_StepVisual_CurveStyleFontPattern_1;
  Handle_StepVisual_CurveStyleFontPattern_2: typeof Handle_StepVisual_CurveStyleFontPattern_2;
  Handle_StepVisual_CurveStyleFontPattern_3: typeof Handle_StepVisual_CurveStyleFontPattern_3;
  Handle_StepVisual_CurveStyleFontPattern_4: typeof Handle_StepVisual_CurveStyleFontPattern_4;
  StepVisual_CentralOrParallel: StepVisual_CentralOrParallel;
  Handle_StepVisual_SurfaceStyleParameterLine: typeof Handle_StepVisual_SurfaceStyleParameterLine;
  Handle_StepVisual_SurfaceStyleParameterLine_1: typeof Handle_StepVisual_SurfaceStyleParameterLine_1;
  Handle_StepVisual_SurfaceStyleParameterLine_2: typeof Handle_StepVisual_SurfaceStyleParameterLine_2;
  Handle_StepVisual_SurfaceStyleParameterLine_3: typeof Handle_StepVisual_SurfaceStyleParameterLine_3;
  Handle_StepVisual_SurfaceStyleParameterLine_4: typeof Handle_StepVisual_SurfaceStyleParameterLine_4;
  StepVisual_SurfaceStyleParameterLine: typeof StepVisual_SurfaceStyleParameterLine;
  Handle_StepVisual_PresentationView: typeof Handle_StepVisual_PresentationView;
  Handle_StepVisual_PresentationView_1: typeof Handle_StepVisual_PresentationView_1;
  Handle_StepVisual_PresentationView_2: typeof Handle_StepVisual_PresentationView_2;
  Handle_StepVisual_PresentationView_3: typeof Handle_StepVisual_PresentationView_3;
  Handle_StepVisual_PresentationView_4: typeof Handle_StepVisual_PresentationView_4;
  StepVisual_PresentationView: typeof StepVisual_PresentationView;
  Handle_StepVisual_CameraModelD3MultiClippingIntersection: typeof Handle_StepVisual_CameraModelD3MultiClippingIntersection;
  Handle_StepVisual_CameraModelD3MultiClippingIntersection_1: typeof Handle_StepVisual_CameraModelD3MultiClippingIntersection_1;
  Handle_StepVisual_CameraModelD3MultiClippingIntersection_2: typeof Handle_StepVisual_CameraModelD3MultiClippingIntersection_2;
  Handle_StepVisual_CameraModelD3MultiClippingIntersection_3: typeof Handle_StepVisual_CameraModelD3MultiClippingIntersection_3;
  Handle_StepVisual_CameraModelD3MultiClippingIntersection_4: typeof Handle_StepVisual_CameraModelD3MultiClippingIntersection_4;
  StepVisual_CameraModelD3MultiClippingIntersection: typeof StepVisual_CameraModelD3MultiClippingIntersection;
  StepVisual_Template: typeof StepVisual_Template;
  Handle_StepVisual_Template: typeof Handle_StepVisual_Template;
  Handle_StepVisual_Template_1: typeof Handle_StepVisual_Template_1;
  Handle_StepVisual_Template_2: typeof Handle_StepVisual_Template_2;
  Handle_StepVisual_Template_3: typeof Handle_StepVisual_Template_3;
  Handle_StepVisual_Template_4: typeof Handle_StepVisual_Template_4;
  StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect: typeof StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect;
  StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_1: typeof StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_1;
  StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_2: typeof StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_2;
  StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_3: typeof StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_3;
  StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_4: typeof StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_4;
  StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_5: typeof StepVisual_Array1OfCameraModelD3MultiClippingUnionSelect_5;
  StepVisual_ContextDependentInvisibility: typeof StepVisual_ContextDependentInvisibility;
  Handle_StepVisual_ContextDependentInvisibility: typeof Handle_StepVisual_ContextDependentInvisibility;
  Handle_StepVisual_ContextDependentInvisibility_1: typeof Handle_StepVisual_ContextDependentInvisibility_1;
  Handle_StepVisual_ContextDependentInvisibility_2: typeof Handle_StepVisual_ContextDependentInvisibility_2;
  Handle_StepVisual_ContextDependentInvisibility_3: typeof Handle_StepVisual_ContextDependentInvisibility_3;
  Handle_StepVisual_ContextDependentInvisibility_4: typeof Handle_StepVisual_ContextDependentInvisibility_4;
  Handle_StepVisual_CameraImage2dWithScale: typeof Handle_StepVisual_CameraImage2dWithScale;
  Handle_StepVisual_CameraImage2dWithScale_1: typeof Handle_StepVisual_CameraImage2dWithScale_1;
  Handle_StepVisual_CameraImage2dWithScale_2: typeof Handle_StepVisual_CameraImage2dWithScale_2;
  Handle_StepVisual_CameraImage2dWithScale_3: typeof Handle_StepVisual_CameraImage2dWithScale_3;
  Handle_StepVisual_CameraImage2dWithScale_4: typeof Handle_StepVisual_CameraImage2dWithScale_4;
  StepVisual_CameraImage2dWithScale: typeof StepVisual_CameraImage2dWithScale;
  Handle_StepVisual_CameraUsage: typeof Handle_StepVisual_CameraUsage;
  Handle_StepVisual_CameraUsage_1: typeof Handle_StepVisual_CameraUsage_1;
  Handle_StepVisual_CameraUsage_2: typeof Handle_StepVisual_CameraUsage_2;
  Handle_StepVisual_CameraUsage_3: typeof Handle_StepVisual_CameraUsage_3;
  Handle_StepVisual_CameraUsage_4: typeof Handle_StepVisual_CameraUsage_4;
  StepVisual_CameraUsage: typeof StepVisual_CameraUsage;
  StepVisual_Array1OfAnnotationPlaneElement: typeof StepVisual_Array1OfAnnotationPlaneElement;
  StepVisual_Array1OfAnnotationPlaneElement_1: typeof StepVisual_Array1OfAnnotationPlaneElement_1;
  StepVisual_Array1OfAnnotationPlaneElement_2: typeof StepVisual_Array1OfAnnotationPlaneElement_2;
  StepVisual_Array1OfAnnotationPlaneElement_3: typeof StepVisual_Array1OfAnnotationPlaneElement_3;
  StepVisual_Array1OfAnnotationPlaneElement_4: typeof StepVisual_Array1OfAnnotationPlaneElement_4;
  StepVisual_Array1OfAnnotationPlaneElement_5: typeof StepVisual_Array1OfAnnotationPlaneElement_5;
  Handle_StepVisual_CurveStyle: typeof Handle_StepVisual_CurveStyle;
  Handle_StepVisual_CurveStyle_1: typeof Handle_StepVisual_CurveStyle_1;
  Handle_StepVisual_CurveStyle_2: typeof Handle_StepVisual_CurveStyle_2;
  Handle_StepVisual_CurveStyle_3: typeof Handle_StepVisual_CurveStyle_3;
  Handle_StepVisual_CurveStyle_4: typeof Handle_StepVisual_CurveStyle_4;
  StepVisual_CurveStyle: typeof StepVisual_CurveStyle;
  StepVisual_CompositeTextWithExtent: typeof StepVisual_CompositeTextWithExtent;
  Handle_StepVisual_CompositeTextWithExtent: typeof Handle_StepVisual_CompositeTextWithExtent;
  Handle_StepVisual_CompositeTextWithExtent_1: typeof Handle_StepVisual_CompositeTextWithExtent_1;
  Handle_StepVisual_CompositeTextWithExtent_2: typeof Handle_StepVisual_CompositeTextWithExtent_2;
  Handle_StepVisual_CompositeTextWithExtent_3: typeof Handle_StepVisual_CompositeTextWithExtent_3;
  Handle_StepVisual_CompositeTextWithExtent_4: typeof Handle_StepVisual_CompositeTextWithExtent_4;
  StepVisual_AnnotationPlaneElement: typeof StepVisual_AnnotationPlaneElement;
  Handle_StepVisual_HArray1OfTextOrCharacter: typeof Handle_StepVisual_HArray1OfTextOrCharacter;
  Handle_StepVisual_HArray1OfTextOrCharacter_1: typeof Handle_StepVisual_HArray1OfTextOrCharacter_1;
  Handle_StepVisual_HArray1OfTextOrCharacter_2: typeof Handle_StepVisual_HArray1OfTextOrCharacter_2;
  Handle_StepVisual_HArray1OfTextOrCharacter_3: typeof Handle_StepVisual_HArray1OfTextOrCharacter_3;
  Handle_StepVisual_HArray1OfTextOrCharacter_4: typeof Handle_StepVisual_HArray1OfTextOrCharacter_4;
  Handle_StepVisual_HArray1OfBoxCharacteristicSelect: typeof Handle_StepVisual_HArray1OfBoxCharacteristicSelect;
  Handle_StepVisual_HArray1OfBoxCharacteristicSelect_1: typeof Handle_StepVisual_HArray1OfBoxCharacteristicSelect_1;
  Handle_StepVisual_HArray1OfBoxCharacteristicSelect_2: typeof Handle_StepVisual_HArray1OfBoxCharacteristicSelect_2;
  Handle_StepVisual_HArray1OfBoxCharacteristicSelect_3: typeof Handle_StepVisual_HArray1OfBoxCharacteristicSelect_3;
  Handle_StepVisual_HArray1OfBoxCharacteristicSelect_4: typeof Handle_StepVisual_HArray1OfBoxCharacteristicSelect_4;
  Handle_StepVisual_HArray1OfDraughtingCalloutElement: typeof Handle_StepVisual_HArray1OfDraughtingCalloutElement;
  Handle_StepVisual_HArray1OfDraughtingCalloutElement_1: typeof Handle_StepVisual_HArray1OfDraughtingCalloutElement_1;
  Handle_StepVisual_HArray1OfDraughtingCalloutElement_2: typeof Handle_StepVisual_HArray1OfDraughtingCalloutElement_2;
  Handle_StepVisual_HArray1OfDraughtingCalloutElement_3: typeof Handle_StepVisual_HArray1OfDraughtingCalloutElement_3;
  Handle_StepVisual_HArray1OfDraughtingCalloutElement_4: typeof Handle_StepVisual_HArray1OfDraughtingCalloutElement_4;
  Handle_StepVisual_TessellatedAnnotationOccurrence: typeof Handle_StepVisual_TessellatedAnnotationOccurrence;
  Handle_StepVisual_TessellatedAnnotationOccurrence_1: typeof Handle_StepVisual_TessellatedAnnotationOccurrence_1;
  Handle_StepVisual_TessellatedAnnotationOccurrence_2: typeof Handle_StepVisual_TessellatedAnnotationOccurrence_2;
  Handle_StepVisual_TessellatedAnnotationOccurrence_3: typeof Handle_StepVisual_TessellatedAnnotationOccurrence_3;
  Handle_StepVisual_TessellatedAnnotationOccurrence_4: typeof Handle_StepVisual_TessellatedAnnotationOccurrence_4;
  StepVisual_TessellatedAnnotationOccurrence: typeof StepVisual_TessellatedAnnotationOccurrence;
  Handle_StepVisual_AnnotationPlane: typeof Handle_StepVisual_AnnotationPlane;
  Handle_StepVisual_AnnotationPlane_1: typeof Handle_StepVisual_AnnotationPlane_1;
  Handle_StepVisual_AnnotationPlane_2: typeof Handle_StepVisual_AnnotationPlane_2;
  Handle_StepVisual_AnnotationPlane_3: typeof Handle_StepVisual_AnnotationPlane_3;
  Handle_StepVisual_AnnotationPlane_4: typeof Handle_StepVisual_AnnotationPlane_4;
  StepVisual_AnnotationPlane: typeof StepVisual_AnnotationPlane;
  Handle_StepVisual_SurfaceStyleRenderingWithProperties: typeof Handle_StepVisual_SurfaceStyleRenderingWithProperties;
  Handle_StepVisual_SurfaceStyleRenderingWithProperties_1: typeof Handle_StepVisual_SurfaceStyleRenderingWithProperties_1;
  Handle_StepVisual_SurfaceStyleRenderingWithProperties_2: typeof Handle_StepVisual_SurfaceStyleRenderingWithProperties_2;
  Handle_StepVisual_SurfaceStyleRenderingWithProperties_3: typeof Handle_StepVisual_SurfaceStyleRenderingWithProperties_3;
  Handle_StepVisual_SurfaceStyleRenderingWithProperties_4: typeof Handle_StepVisual_SurfaceStyleRenderingWithProperties_4;
  StepVisual_SurfaceStyleRenderingWithProperties: typeof StepVisual_SurfaceStyleRenderingWithProperties;
  StepVisual_PresentationStyleSelect: typeof StepVisual_PresentationStyleSelect;
  StepVisual_StyledItem: typeof StepVisual_StyledItem;
  Handle_StepVisual_StyledItem: typeof Handle_StepVisual_StyledItem;
  Handle_StepVisual_StyledItem_1: typeof Handle_StepVisual_StyledItem_1;
  Handle_StepVisual_StyledItem_2: typeof Handle_StepVisual_StyledItem_2;
  Handle_StepVisual_StyledItem_3: typeof Handle_StepVisual_StyledItem_3;
  Handle_StepVisual_StyledItem_4: typeof Handle_StepVisual_StyledItem_4;
  StepVisual_AnnotationCurveOccurrence: typeof StepVisual_AnnotationCurveOccurrence;
  Handle_StepVisual_AnnotationCurveOccurrence: typeof Handle_StepVisual_AnnotationCurveOccurrence;
  Handle_StepVisual_AnnotationCurveOccurrence_1: typeof Handle_StepVisual_AnnotationCurveOccurrence_1;
  Handle_StepVisual_AnnotationCurveOccurrence_2: typeof Handle_StepVisual_AnnotationCurveOccurrence_2;
  Handle_StepVisual_AnnotationCurveOccurrence_3: typeof Handle_StepVisual_AnnotationCurveOccurrence_3;
  Handle_StepVisual_AnnotationCurveOccurrence_4: typeof Handle_StepVisual_AnnotationCurveOccurrence_4;
  Handle_StepVisual_HArray1OfInvisibleItem: typeof Handle_StepVisual_HArray1OfInvisibleItem;
  Handle_StepVisual_HArray1OfInvisibleItem_1: typeof Handle_StepVisual_HArray1OfInvisibleItem_1;
  Handle_StepVisual_HArray1OfInvisibleItem_2: typeof Handle_StepVisual_HArray1OfInvisibleItem_2;
  Handle_StepVisual_HArray1OfInvisibleItem_3: typeof Handle_StepVisual_HArray1OfInvisibleItem_3;
  Handle_StepVisual_HArray1OfInvisibleItem_4: typeof Handle_StepVisual_HArray1OfInvisibleItem_4;
  StepVisual_CompositeText: typeof StepVisual_CompositeText;
  Handle_StepVisual_CompositeText: typeof Handle_StepVisual_CompositeText;
  Handle_StepVisual_CompositeText_1: typeof Handle_StepVisual_CompositeText_1;
  Handle_StepVisual_CompositeText_2: typeof Handle_StepVisual_CompositeText_2;
  Handle_StepVisual_CompositeText_3: typeof Handle_StepVisual_CompositeText_3;
  Handle_StepVisual_CompositeText_4: typeof Handle_StepVisual_CompositeText_4;
  StepVisual_PresentedItem: typeof StepVisual_PresentedItem;
  Handle_StepVisual_PresentedItem: typeof Handle_StepVisual_PresentedItem;
  Handle_StepVisual_PresentedItem_1: typeof Handle_StepVisual_PresentedItem_1;
  Handle_StepVisual_PresentedItem_2: typeof Handle_StepVisual_PresentedItem_2;
  Handle_StepVisual_PresentedItem_3: typeof Handle_StepVisual_PresentedItem_3;
  Handle_StepVisual_PresentedItem_4: typeof Handle_StepVisual_PresentedItem_4;
  StepVisual_AreaOrView: typeof StepVisual_AreaOrView;
  Handle_StepVisual_HArray1OfFillStyleSelect: typeof Handle_StepVisual_HArray1OfFillStyleSelect;
  Handle_StepVisual_HArray1OfFillStyleSelect_1: typeof Handle_StepVisual_HArray1OfFillStyleSelect_1;
  Handle_StepVisual_HArray1OfFillStyleSelect_2: typeof Handle_StepVisual_HArray1OfFillStyleSelect_2;
  Handle_StepVisual_HArray1OfFillStyleSelect_3: typeof Handle_StepVisual_HArray1OfFillStyleSelect_3;
  Handle_StepVisual_HArray1OfFillStyleSelect_4: typeof Handle_StepVisual_HArray1OfFillStyleSelect_4;
  StepVisual_RenderingPropertiesSelect: typeof StepVisual_RenderingPropertiesSelect;
  StepVisual_CameraImage3dWithScale: typeof StepVisual_CameraImage3dWithScale;
  Handle_StepVisual_CameraImage3dWithScale: typeof Handle_StepVisual_CameraImage3dWithScale;
  Handle_StepVisual_CameraImage3dWithScale_1: typeof Handle_StepVisual_CameraImage3dWithScale_1;
  Handle_StepVisual_CameraImage3dWithScale_2: typeof Handle_StepVisual_CameraImage3dWithScale_2;
  Handle_StepVisual_CameraImage3dWithScale_3: typeof Handle_StepVisual_CameraImage3dWithScale_3;
  Handle_StepVisual_CameraImage3dWithScale_4: typeof Handle_StepVisual_CameraImage3dWithScale_4;
  Handle_StepVisual_FillAreaStyleColour: typeof Handle_StepVisual_FillAreaStyleColour;
  Handle_StepVisual_FillAreaStyleColour_1: typeof Handle_StepVisual_FillAreaStyleColour_1;
  Handle_StepVisual_FillAreaStyleColour_2: typeof Handle_StepVisual_FillAreaStyleColour_2;
  Handle_StepVisual_FillAreaStyleColour_3: typeof Handle_StepVisual_FillAreaStyleColour_3;
  Handle_StepVisual_FillAreaStyleColour_4: typeof Handle_StepVisual_FillAreaStyleColour_4;
  StepVisual_FillAreaStyleColour: typeof StepVisual_FillAreaStyleColour;
  Handle_StepVisual_HArray1OfDirectionCountSelect: typeof Handle_StepVisual_HArray1OfDirectionCountSelect;
  Handle_StepVisual_HArray1OfDirectionCountSelect_1: typeof Handle_StepVisual_HArray1OfDirectionCountSelect_1;
  Handle_StepVisual_HArray1OfDirectionCountSelect_2: typeof Handle_StepVisual_HArray1OfDirectionCountSelect_2;
  Handle_StepVisual_HArray1OfDirectionCountSelect_3: typeof Handle_StepVisual_HArray1OfDirectionCountSelect_3;
  Handle_StepVisual_HArray1OfDirectionCountSelect_4: typeof Handle_StepVisual_HArray1OfDirectionCountSelect_4;
  StepVisual_SurfaceStyleTransparent: typeof StepVisual_SurfaceStyleTransparent;
  Handle_StepVisual_SurfaceStyleTransparent: typeof Handle_StepVisual_SurfaceStyleTransparent;
  Handle_StepVisual_SurfaceStyleTransparent_1: typeof Handle_StepVisual_SurfaceStyleTransparent_1;
  Handle_StepVisual_SurfaceStyleTransparent_2: typeof Handle_StepVisual_SurfaceStyleTransparent_2;
  Handle_StepVisual_SurfaceStyleTransparent_3: typeof Handle_StepVisual_SurfaceStyleTransparent_3;
  Handle_StepVisual_SurfaceStyleTransparent_4: typeof Handle_StepVisual_SurfaceStyleTransparent_4;
  StepVisual_DraughtingCallout: typeof StepVisual_DraughtingCallout;
  Handle_StepVisual_DraughtingCallout: typeof Handle_StepVisual_DraughtingCallout;
  Handle_StepVisual_DraughtingCallout_1: typeof Handle_StepVisual_DraughtingCallout_1;
  Handle_StepVisual_DraughtingCallout_2: typeof Handle_StepVisual_DraughtingCallout_2;
  Handle_StepVisual_DraughtingCallout_3: typeof Handle_StepVisual_DraughtingCallout_3;
  Handle_StepVisual_DraughtingCallout_4: typeof Handle_StepVisual_DraughtingCallout_4;
  StepVisual_DraughtingCalloutElement: typeof StepVisual_DraughtingCalloutElement;
  Handle_StepVisual_Colour: typeof Handle_StepVisual_Colour;
  Handle_StepVisual_Colour_1: typeof Handle_StepVisual_Colour_1;
  Handle_StepVisual_Colour_2: typeof Handle_StepVisual_Colour_2;
  Handle_StepVisual_Colour_3: typeof Handle_StepVisual_Colour_3;
  Handle_StepVisual_Colour_4: typeof Handle_StepVisual_Colour_4;
  StepVisual_Colour: typeof StepVisual_Colour;
  Handle_StepVisual_SurfaceSideStyle: typeof Handle_StepVisual_SurfaceSideStyle;
  Handle_StepVisual_SurfaceSideStyle_1: typeof Handle_StepVisual_SurfaceSideStyle_1;
  Handle_StepVisual_SurfaceSideStyle_2: typeof Handle_StepVisual_SurfaceSideStyle_2;
  Handle_StepVisual_SurfaceSideStyle_3: typeof Handle_StepVisual_SurfaceSideStyle_3;
  Handle_StepVisual_SurfaceSideStyle_4: typeof Handle_StepVisual_SurfaceSideStyle_4;
  StepVisual_SurfaceSideStyle: typeof StepVisual_SurfaceSideStyle;
  Handle_StepVisual_HArray1OfPresentationStyleAssignment: typeof Handle_StepVisual_HArray1OfPresentationStyleAssignment;
  Handle_StepVisual_HArray1OfPresentationStyleAssignment_1: typeof Handle_StepVisual_HArray1OfPresentationStyleAssignment_1;
  Handle_StepVisual_HArray1OfPresentationStyleAssignment_2: typeof Handle_StepVisual_HArray1OfPresentationStyleAssignment_2;
  Handle_StepVisual_HArray1OfPresentationStyleAssignment_3: typeof Handle_StepVisual_HArray1OfPresentationStyleAssignment_3;
  Handle_StepVisual_HArray1OfPresentationStyleAssignment_4: typeof Handle_StepVisual_HArray1OfPresentationStyleAssignment_4;
  Handle_StepVisual_PreDefinedItem: typeof Handle_StepVisual_PreDefinedItem;
  Handle_StepVisual_PreDefinedItem_1: typeof Handle_StepVisual_PreDefinedItem_1;
  Handle_StepVisual_PreDefinedItem_2: typeof Handle_StepVisual_PreDefinedItem_2;
  Handle_StepVisual_PreDefinedItem_3: typeof Handle_StepVisual_PreDefinedItem_3;
  Handle_StepVisual_PreDefinedItem_4: typeof Handle_StepVisual_PreDefinedItem_4;
  StepVisual_PreDefinedItem: typeof StepVisual_PreDefinedItem;
  StepVisual_TextOrCharacter: typeof StepVisual_TextOrCharacter;
  StepVisual_PreDefinedColour: typeof StepVisual_PreDefinedColour;
  Handle_StepVisual_PreDefinedColour: typeof Handle_StepVisual_PreDefinedColour;
  Handle_StepVisual_PreDefinedColour_1: typeof Handle_StepVisual_PreDefinedColour_1;
  Handle_StepVisual_PreDefinedColour_2: typeof Handle_StepVisual_PreDefinedColour_2;
  Handle_StepVisual_PreDefinedColour_3: typeof Handle_StepVisual_PreDefinedColour_3;
  Handle_StepVisual_PreDefinedColour_4: typeof Handle_StepVisual_PreDefinedColour_4;
  Handle_StepVisual_AnnotationFillArea: typeof Handle_StepVisual_AnnotationFillArea;
  Handle_StepVisual_AnnotationFillArea_1: typeof Handle_StepVisual_AnnotationFillArea_1;
  Handle_StepVisual_AnnotationFillArea_2: typeof Handle_StepVisual_AnnotationFillArea_2;
  Handle_StepVisual_AnnotationFillArea_3: typeof Handle_StepVisual_AnnotationFillArea_3;
  Handle_StepVisual_AnnotationFillArea_4: typeof Handle_StepVisual_AnnotationFillArea_4;
  StepVisual_AnnotationFillArea: typeof StepVisual_AnnotationFillArea;
  Handle_StepVisual_CoordinatesList: typeof Handle_StepVisual_CoordinatesList;
  Handle_StepVisual_CoordinatesList_1: typeof Handle_StepVisual_CoordinatesList_1;
  Handle_StepVisual_CoordinatesList_2: typeof Handle_StepVisual_CoordinatesList_2;
  Handle_StepVisual_CoordinatesList_3: typeof Handle_StepVisual_CoordinatesList_3;
  Handle_StepVisual_CoordinatesList_4: typeof Handle_StepVisual_CoordinatesList_4;
  StepVisual_CoordinatesList: typeof StepVisual_CoordinatesList;
  StepVisual_FillStyleSelect: typeof StepVisual_FillStyleSelect;
  Handle_StepVisual_TessellatedGeometricSet: typeof Handle_StepVisual_TessellatedGeometricSet;
  Handle_StepVisual_TessellatedGeometricSet_1: typeof Handle_StepVisual_TessellatedGeometricSet_1;
  Handle_StepVisual_TessellatedGeometricSet_2: typeof Handle_StepVisual_TessellatedGeometricSet_2;
  Handle_StepVisual_TessellatedGeometricSet_3: typeof Handle_StepVisual_TessellatedGeometricSet_3;
  Handle_StepVisual_TessellatedGeometricSet_4: typeof Handle_StepVisual_TessellatedGeometricSet_4;
  StepVisual_TessellatedGeometricSet: typeof StepVisual_TessellatedGeometricSet;
  StepVisual_BackgroundColour: typeof StepVisual_BackgroundColour;
  Handle_StepVisual_BackgroundColour: typeof Handle_StepVisual_BackgroundColour;
  Handle_StepVisual_BackgroundColour_1: typeof Handle_StepVisual_BackgroundColour_1;
  Handle_StepVisual_BackgroundColour_2: typeof Handle_StepVisual_BackgroundColour_2;
  Handle_StepVisual_BackgroundColour_3: typeof Handle_StepVisual_BackgroundColour_3;
  Handle_StepVisual_BackgroundColour_4: typeof Handle_StepVisual_BackgroundColour_4;
  StepVisual_Array1OfRenderingPropertiesSelect: typeof StepVisual_Array1OfRenderingPropertiesSelect;
  StepVisual_Array1OfRenderingPropertiesSelect_1: typeof StepVisual_Array1OfRenderingPropertiesSelect_1;
  StepVisual_Array1OfRenderingPropertiesSelect_2: typeof StepVisual_Array1OfRenderingPropertiesSelect_2;
  StepVisual_Array1OfRenderingPropertiesSelect_3: typeof StepVisual_Array1OfRenderingPropertiesSelect_3;
  StepVisual_Array1OfRenderingPropertiesSelect_4: typeof StepVisual_Array1OfRenderingPropertiesSelect_4;
  StepVisual_Array1OfRenderingPropertiesSelect_5: typeof StepVisual_Array1OfRenderingPropertiesSelect_5;
  Handle_StepVisual_PreDefinedCurveFont: typeof Handle_StepVisual_PreDefinedCurveFont;
  Handle_StepVisual_PreDefinedCurveFont_1: typeof Handle_StepVisual_PreDefinedCurveFont_1;
  Handle_StepVisual_PreDefinedCurveFont_2: typeof Handle_StepVisual_PreDefinedCurveFont_2;
  Handle_StepVisual_PreDefinedCurveFont_3: typeof Handle_StepVisual_PreDefinedCurveFont_3;
  Handle_StepVisual_PreDefinedCurveFont_4: typeof Handle_StepVisual_PreDefinedCurveFont_4;
  StepVisual_PreDefinedCurveFont: typeof StepVisual_PreDefinedCurveFont;
  StepVisual_TessellatedCurveSet: typeof StepVisual_TessellatedCurveSet;
  Handle_StepVisual_TessellatedCurveSet: typeof Handle_StepVisual_TessellatedCurveSet;
  Handle_StepVisual_TessellatedCurveSet_1: typeof Handle_StepVisual_TessellatedCurveSet_1;
  Handle_StepVisual_TessellatedCurveSet_2: typeof Handle_StepVisual_TessellatedCurveSet_2;
  Handle_StepVisual_TessellatedCurveSet_3: typeof Handle_StepVisual_TessellatedCurveSet_3;
  Handle_StepVisual_TessellatedCurveSet_4: typeof Handle_StepVisual_TessellatedCurveSet_4;
  Handle_StepVisual_SurfaceStyleControlGrid: typeof Handle_StepVisual_SurfaceStyleControlGrid;
  Handle_StepVisual_SurfaceStyleControlGrid_1: typeof Handle_StepVisual_SurfaceStyleControlGrid_1;
  Handle_StepVisual_SurfaceStyleControlGrid_2: typeof Handle_StepVisual_SurfaceStyleControlGrid_2;
  Handle_StepVisual_SurfaceStyleControlGrid_3: typeof Handle_StepVisual_SurfaceStyleControlGrid_3;
  Handle_StepVisual_SurfaceStyleControlGrid_4: typeof Handle_StepVisual_SurfaceStyleControlGrid_4;
  StepVisual_SurfaceStyleControlGrid: typeof StepVisual_SurfaceStyleControlGrid;
  StepVisual_DirectionCountSelect: typeof StepVisual_DirectionCountSelect;
  Handle_StepVisual_CameraModelD3: typeof Handle_StepVisual_CameraModelD3;
  Handle_StepVisual_CameraModelD3_1: typeof Handle_StepVisual_CameraModelD3_1;
  Handle_StepVisual_CameraModelD3_2: typeof Handle_StepVisual_CameraModelD3_2;
  Handle_StepVisual_CameraModelD3_3: typeof Handle_StepVisual_CameraModelD3_3;
  Handle_StepVisual_CameraModelD3_4: typeof Handle_StepVisual_CameraModelD3_4;
  StepVisual_CameraModelD3: typeof StepVisual_CameraModelD3;
  Handle_StepVisual_HArray1OfAnnotationPlaneElement: typeof Handle_StepVisual_HArray1OfAnnotationPlaneElement;
  Handle_StepVisual_HArray1OfAnnotationPlaneElement_1: typeof Handle_StepVisual_HArray1OfAnnotationPlaneElement_1;
  Handle_StepVisual_HArray1OfAnnotationPlaneElement_2: typeof Handle_StepVisual_HArray1OfAnnotationPlaneElement_2;
  Handle_StepVisual_HArray1OfAnnotationPlaneElement_3: typeof Handle_StepVisual_HArray1OfAnnotationPlaneElement_3;
  Handle_StepVisual_HArray1OfAnnotationPlaneElement_4: typeof Handle_StepVisual_HArray1OfAnnotationPlaneElement_4;
  StepVisual_ExternallyDefinedTextFont: typeof StepVisual_ExternallyDefinedTextFont;
  Handle_StepVisual_ExternallyDefinedTextFont: typeof Handle_StepVisual_ExternallyDefinedTextFont;
  Handle_StepVisual_ExternallyDefinedTextFont_1: typeof Handle_StepVisual_ExternallyDefinedTextFont_1;
  Handle_StepVisual_ExternallyDefinedTextFont_2: typeof Handle_StepVisual_ExternallyDefinedTextFont_2;
  Handle_StepVisual_ExternallyDefinedTextFont_3: typeof Handle_StepVisual_ExternallyDefinedTextFont_3;
  Handle_StepVisual_ExternallyDefinedTextFont_4: typeof Handle_StepVisual_ExternallyDefinedTextFont_4;
  Handle_StepVisual_PresentedItemRepresentation: typeof Handle_StepVisual_PresentedItemRepresentation;
  Handle_StepVisual_PresentedItemRepresentation_1: typeof Handle_StepVisual_PresentedItemRepresentation_1;
  Handle_StepVisual_PresentedItemRepresentation_2: typeof Handle_StepVisual_PresentedItemRepresentation_2;
  Handle_StepVisual_PresentedItemRepresentation_3: typeof Handle_StepVisual_PresentedItemRepresentation_3;
  Handle_StepVisual_PresentedItemRepresentation_4: typeof Handle_StepVisual_PresentedItemRepresentation_4;
  StepVisual_PresentedItemRepresentation: typeof StepVisual_PresentedItemRepresentation;
  StepVisual_LayeredItem: typeof StepVisual_LayeredItem;
  StepVisual_MarkerMember: typeof StepVisual_MarkerMember;
  Handle_StepVisual_MarkerMember: typeof Handle_StepVisual_MarkerMember;
  Handle_StepVisual_MarkerMember_1: typeof Handle_StepVisual_MarkerMember_1;
  Handle_StepVisual_MarkerMember_2: typeof Handle_StepVisual_MarkerMember_2;
  Handle_StepVisual_MarkerMember_3: typeof Handle_StepVisual_MarkerMember_3;
  Handle_StepVisual_MarkerMember_4: typeof Handle_StepVisual_MarkerMember_4;
  StepVisual_FontSelect: typeof StepVisual_FontSelect;
  StepVisual_PresentationLayerUsage: typeof StepVisual_PresentationLayerUsage;
  Handle_StepVisual_PresentationLayerUsage: typeof Handle_StepVisual_PresentationLayerUsage;
  Handle_StepVisual_PresentationLayerUsage_1: typeof Handle_StepVisual_PresentationLayerUsage_1;
  Handle_StepVisual_PresentationLayerUsage_2: typeof Handle_StepVisual_PresentationLayerUsage_2;
  Handle_StepVisual_PresentationLayerUsage_3: typeof Handle_StepVisual_PresentationLayerUsage_3;
  Handle_StepVisual_PresentationLayerUsage_4: typeof Handle_StepVisual_PresentationLayerUsage_4;
  StepVisual_PresentationArea: typeof StepVisual_PresentationArea;
  Handle_StepVisual_PresentationArea: typeof Handle_StepVisual_PresentationArea;
  Handle_StepVisual_PresentationArea_1: typeof Handle_StepVisual_PresentationArea_1;
  Handle_StepVisual_PresentationArea_2: typeof Handle_StepVisual_PresentationArea_2;
  Handle_StepVisual_PresentationArea_3: typeof Handle_StepVisual_PresentationArea_3;
  Handle_StepVisual_PresentationArea_4: typeof Handle_StepVisual_PresentationArea_4;
  StepVisual_TextLiteral: typeof StepVisual_TextLiteral;
  Handle_StepVisual_TextLiteral: typeof Handle_StepVisual_TextLiteral;
  Handle_StepVisual_TextLiteral_1: typeof Handle_StepVisual_TextLiteral_1;
  Handle_StepVisual_TextLiteral_2: typeof Handle_StepVisual_TextLiteral_2;
  Handle_StepVisual_TextLiteral_3: typeof Handle_StepVisual_TextLiteral_3;
  Handle_StepVisual_TextLiteral_4: typeof Handle_StepVisual_TextLiteral_4;
  StepVisual_StyledItemTarget: typeof StepVisual_StyledItemTarget;
  Handle_StepVisual_SurfaceStyleFillArea: typeof Handle_StepVisual_SurfaceStyleFillArea;
  Handle_StepVisual_SurfaceStyleFillArea_1: typeof Handle_StepVisual_SurfaceStyleFillArea_1;
  Handle_StepVisual_SurfaceStyleFillArea_2: typeof Handle_StepVisual_SurfaceStyleFillArea_2;
  Handle_StepVisual_SurfaceStyleFillArea_3: typeof Handle_StepVisual_SurfaceStyleFillArea_3;
  Handle_StepVisual_SurfaceStyleFillArea_4: typeof Handle_StepVisual_SurfaceStyleFillArea_4;
  StepVisual_SurfaceStyleFillArea: typeof StepVisual_SurfaceStyleFillArea;
  Handle_StepVisual_TemplateInstance: typeof Handle_StepVisual_TemplateInstance;
  Handle_StepVisual_TemplateInstance_1: typeof Handle_StepVisual_TemplateInstance_1;
  Handle_StepVisual_TemplateInstance_2: typeof Handle_StepVisual_TemplateInstance_2;
  Handle_StepVisual_TemplateInstance_3: typeof Handle_StepVisual_TemplateInstance_3;
  Handle_StepVisual_TemplateInstance_4: typeof Handle_StepVisual_TemplateInstance_4;
  StepVisual_TemplateInstance: typeof StepVisual_TemplateInstance;
  StepVisual_SurfaceStyleUsage: typeof StepVisual_SurfaceStyleUsage;
  Handle_StepVisual_SurfaceStyleUsage: typeof Handle_StepVisual_SurfaceStyleUsage;
  Handle_StepVisual_SurfaceStyleUsage_1: typeof Handle_StepVisual_SurfaceStyleUsage_1;
  Handle_StepVisual_SurfaceStyleUsage_2: typeof Handle_StepVisual_SurfaceStyleUsage_2;
  Handle_StepVisual_SurfaceStyleUsage_3: typeof Handle_StepVisual_SurfaceStyleUsage_3;
  Handle_StepVisual_SurfaceStyleUsage_4: typeof Handle_StepVisual_SurfaceStyleUsage_4;
  Handle_StepVisual_DraughtingAnnotationOccurrence: typeof Handle_StepVisual_DraughtingAnnotationOccurrence;
  Handle_StepVisual_DraughtingAnnotationOccurrence_1: typeof Handle_StepVisual_DraughtingAnnotationOccurrence_1;
  Handle_StepVisual_DraughtingAnnotationOccurrence_2: typeof Handle_StepVisual_DraughtingAnnotationOccurrence_2;
  Handle_StepVisual_DraughtingAnnotationOccurrence_3: typeof Handle_StepVisual_DraughtingAnnotationOccurrence_3;
  Handle_StepVisual_DraughtingAnnotationOccurrence_4: typeof Handle_StepVisual_DraughtingAnnotationOccurrence_4;
  StepVisual_DraughtingAnnotationOccurrence: typeof StepVisual_DraughtingAnnotationOccurrence;
  StepVisual_NullStyle: StepVisual_NullStyle;
  Handle_StepVisual_DraughtingPreDefinedCurveFont: typeof Handle_StepVisual_DraughtingPreDefinedCurveFont;
  Handle_StepVisual_DraughtingPreDefinedCurveFont_1: typeof Handle_StepVisual_DraughtingPreDefinedCurveFont_1;
  Handle_StepVisual_DraughtingPreDefinedCurveFont_2: typeof Handle_StepVisual_DraughtingPreDefinedCurveFont_2;
  Handle_StepVisual_DraughtingPreDefinedCurveFont_3: typeof Handle_StepVisual_DraughtingPreDefinedCurveFont_3;
  Handle_StepVisual_DraughtingPreDefinedCurveFont_4: typeof Handle_StepVisual_DraughtingPreDefinedCurveFont_4;
  StepVisual_DraughtingPreDefinedCurveFont: typeof StepVisual_DraughtingPreDefinedCurveFont;
  StepVisual_SurfaceStyleSegmentationCurve: typeof StepVisual_SurfaceStyleSegmentationCurve;
  Handle_StepVisual_SurfaceStyleSegmentationCurve: typeof Handle_StepVisual_SurfaceStyleSegmentationCurve;
  Handle_StepVisual_SurfaceStyleSegmentationCurve_1: typeof Handle_StepVisual_SurfaceStyleSegmentationCurve_1;
  Handle_StepVisual_SurfaceStyleSegmentationCurve_2: typeof Handle_StepVisual_SurfaceStyleSegmentationCurve_2;
  Handle_StepVisual_SurfaceStyleSegmentationCurve_3: typeof Handle_StepVisual_SurfaceStyleSegmentationCurve_3;
  Handle_StepVisual_SurfaceStyleSegmentationCurve_4: typeof Handle_StepVisual_SurfaceStyleSegmentationCurve_4;
  Handle_StepVisual_PlanarExtent: typeof Handle_StepVisual_PlanarExtent;
  Handle_StepVisual_PlanarExtent_1: typeof Handle_StepVisual_PlanarExtent_1;
  Handle_StepVisual_PlanarExtent_2: typeof Handle_StepVisual_PlanarExtent_2;
  Handle_StepVisual_PlanarExtent_3: typeof Handle_StepVisual_PlanarExtent_3;
  Handle_StepVisual_PlanarExtent_4: typeof Handle_StepVisual_PlanarExtent_4;
  StepVisual_PlanarExtent: typeof StepVisual_PlanarExtent;
  StepVisual_InvisibilityContext: typeof StepVisual_InvisibilityContext;
  Standard_LicenseNotFound: typeof Standard_LicenseNotFound;
  Standard_LicenseNotFound_1: typeof Standard_LicenseNotFound_1;
  Standard_LicenseNotFound_2: typeof Standard_LicenseNotFound_2;
  Handle_Standard_LicenseNotFound: typeof Handle_Standard_LicenseNotFound;
  Handle_Standard_LicenseNotFound_1: typeof Handle_Standard_LicenseNotFound_1;
  Handle_Standard_LicenseNotFound_2: typeof Handle_Standard_LicenseNotFound_2;
  Handle_Standard_LicenseNotFound_3: typeof Handle_Standard_LicenseNotFound_3;
  Handle_Standard_LicenseNotFound_4: typeof Handle_Standard_LicenseNotFound_4;
  Standard: typeof Standard;
  Handle_Standard_Overflow: typeof Handle_Standard_Overflow;
  Handle_Standard_Overflow_1: typeof Handle_Standard_Overflow_1;
  Handle_Standard_Overflow_2: typeof Handle_Standard_Overflow_2;
  Handle_Standard_Overflow_3: typeof Handle_Standard_Overflow_3;
  Handle_Standard_Overflow_4: typeof Handle_Standard_Overflow_4;
  Standard_Overflow: typeof Standard_Overflow;
  Standard_Overflow_1: typeof Standard_Overflow_1;
  Standard_Overflow_2: typeof Standard_Overflow_2;
  Standard_NullObject: typeof Standard_NullObject;
  Standard_NullObject_1: typeof Standard_NullObject_1;
  Standard_NullObject_2: typeof Standard_NullObject_2;
  Handle_Standard_NullObject: typeof Handle_Standard_NullObject;
  Handle_Standard_NullObject_1: typeof Handle_Standard_NullObject_1;
  Handle_Standard_NullObject_2: typeof Handle_Standard_NullObject_2;
  Handle_Standard_NullObject_3: typeof Handle_Standard_NullObject_3;
  Handle_Standard_NullObject_4: typeof Handle_Standard_NullObject_4;
  Standard_NullValue: typeof Standard_NullValue;
  Standard_NullValue_1: typeof Standard_NullValue_1;
  Standard_NullValue_2: typeof Standard_NullValue_2;
  Handle_Standard_NullValue: typeof Handle_Standard_NullValue;
  Handle_Standard_NullValue_1: typeof Handle_Standard_NullValue_1;
  Handle_Standard_NullValue_2: typeof Handle_Standard_NullValue_2;
  Handle_Standard_NullValue_3: typeof Handle_Standard_NullValue_3;
  Handle_Standard_NullValue_4: typeof Handle_Standard_NullValue_4;
  Standard_Type: typeof Standard_Type;
  Handle_Standard_Type: typeof Handle_Standard_Type;
  Handle_Standard_Type_1: typeof Handle_Standard_Type_1;
  Handle_Standard_Type_2: typeof Handle_Standard_Type_2;
  Handle_Standard_Type_3: typeof Handle_Standard_Type_3;
  Handle_Standard_Type_4: typeof Handle_Standard_Type_4;
  Handle_Standard_DomainError: typeof Handle_Standard_DomainError;
  Handle_Standard_DomainError_1: typeof Handle_Standard_DomainError_1;
  Handle_Standard_DomainError_2: typeof Handle_Standard_DomainError_2;
  Handle_Standard_DomainError_3: typeof Handle_Standard_DomainError_3;
  Handle_Standard_DomainError_4: typeof Handle_Standard_DomainError_4;
  Standard_DomainError: typeof Standard_DomainError;
  Standard_DomainError_1: typeof Standard_DomainError_1;
  Standard_DomainError_2: typeof Standard_DomainError_2;
  Handle_Standard_ConstructionError: typeof Handle_Standard_ConstructionError;
  Handle_Standard_ConstructionError_1: typeof Handle_Standard_ConstructionError_1;
  Handle_Standard_ConstructionError_2: typeof Handle_Standard_ConstructionError_2;
  Handle_Standard_ConstructionError_3: typeof Handle_Standard_ConstructionError_3;
  Handle_Standard_ConstructionError_4: typeof Handle_Standard_ConstructionError_4;
  Standard_ConstructionError: typeof Standard_ConstructionError;
  Standard_ConstructionError_1: typeof Standard_ConstructionError_1;
  Standard_ConstructionError_2: typeof Standard_ConstructionError_2;
  Standard_TypeMismatch: typeof Standard_TypeMismatch;
  Standard_TypeMismatch_1: typeof Standard_TypeMismatch_1;
  Standard_TypeMismatch_2: typeof Standard_TypeMismatch_2;
  Handle_Standard_TypeMismatch: typeof Handle_Standard_TypeMismatch;
  Handle_Standard_TypeMismatch_1: typeof Handle_Standard_TypeMismatch_1;
  Handle_Standard_TypeMismatch_2: typeof Handle_Standard_TypeMismatch_2;
  Handle_Standard_TypeMismatch_3: typeof Handle_Standard_TypeMismatch_3;
  Handle_Standard_TypeMismatch_4: typeof Handle_Standard_TypeMismatch_4;
  Standard_RangeError: typeof Standard_RangeError;
  Standard_RangeError_1: typeof Standard_RangeError_1;
  Standard_RangeError_2: typeof Standard_RangeError_2;
  Handle_Standard_RangeError: typeof Handle_Standard_RangeError;
  Handle_Standard_RangeError_1: typeof Handle_Standard_RangeError_1;
  Handle_Standard_RangeError_2: typeof Handle_Standard_RangeError_2;
  Handle_Standard_RangeError_3: typeof Handle_Standard_RangeError_3;
  Handle_Standard_RangeError_4: typeof Handle_Standard_RangeError_4;
  Handle_Standard_DivideByZero: typeof Handle_Standard_DivideByZero;
  Handle_Standard_DivideByZero_1: typeof Handle_Standard_DivideByZero_1;
  Handle_Standard_DivideByZero_2: typeof Handle_Standard_DivideByZero_2;
  Handle_Standard_DivideByZero_3: typeof Handle_Standard_DivideByZero_3;
  Handle_Standard_DivideByZero_4: typeof Handle_Standard_DivideByZero_4;
  Standard_DivideByZero: typeof Standard_DivideByZero;
  Standard_DivideByZero_1: typeof Standard_DivideByZero_1;
  Standard_DivideByZero_2: typeof Standard_DivideByZero_2;
  Standard_NegativeValue: typeof Standard_NegativeValue;
  Standard_NegativeValue_1: typeof Standard_NegativeValue_1;
  Standard_NegativeValue_2: typeof Standard_NegativeValue_2;
  Handle_Standard_NegativeValue: typeof Handle_Standard_NegativeValue;
  Handle_Standard_NegativeValue_1: typeof Handle_Standard_NegativeValue_1;
  Handle_Standard_NegativeValue_2: typeof Handle_Standard_NegativeValue_2;
  Handle_Standard_NegativeValue_3: typeof Handle_Standard_NegativeValue_3;
  Handle_Standard_NegativeValue_4: typeof Handle_Standard_NegativeValue_4;
  Handle_Standard_TooManyUsers: typeof Handle_Standard_TooManyUsers;
  Handle_Standard_TooManyUsers_1: typeof Handle_Standard_TooManyUsers_1;
  Handle_Standard_TooManyUsers_2: typeof Handle_Standard_TooManyUsers_2;
  Handle_Standard_TooManyUsers_3: typeof Handle_Standard_TooManyUsers_3;
  Handle_Standard_TooManyUsers_4: typeof Handle_Standard_TooManyUsers_4;
  Standard_TooManyUsers: typeof Standard_TooManyUsers;
  Standard_TooManyUsers_1: typeof Standard_TooManyUsers_1;
  Standard_TooManyUsers_2: typeof Standard_TooManyUsers_2;
  Standard_ArrayStreamBuffer: typeof Standard_ArrayStreamBuffer;
  Standard_OutOfMemory: typeof Standard_OutOfMemory;
  Handle_Standard_OutOfMemory: typeof Handle_Standard_OutOfMemory;
  Handle_Standard_OutOfMemory_1: typeof Handle_Standard_OutOfMemory_1;
  Handle_Standard_OutOfMemory_2: typeof Handle_Standard_OutOfMemory_2;
  Handle_Standard_OutOfMemory_3: typeof Handle_Standard_OutOfMemory_3;
  Handle_Standard_OutOfMemory_4: typeof Handle_Standard_OutOfMemory_4;
  Handle_Standard_DimensionError: typeof Handle_Standard_DimensionError;
  Handle_Standard_DimensionError_1: typeof Handle_Standard_DimensionError_1;
  Handle_Standard_DimensionError_2: typeof Handle_Standard_DimensionError_2;
  Handle_Standard_DimensionError_3: typeof Handle_Standard_DimensionError_3;
  Handle_Standard_DimensionError_4: typeof Handle_Standard_DimensionError_4;
  Standard_DimensionError: typeof Standard_DimensionError;
  Standard_DimensionError_1: typeof Standard_DimensionError_1;
  Standard_DimensionError_2: typeof Standard_DimensionError_2;
  Standard_DumpValue: typeof Standard_DumpValue;
  Standard_DumpValue_1: typeof Standard_DumpValue_1;
  Standard_DumpValue_2: typeof Standard_DumpValue_2;
  Standard_JsonKey: Standard_JsonKey;
  Standard_Persistent: typeof Standard_Persistent;
  Standard_Mutex: typeof Standard_Mutex;
  Standard_Transient: typeof Standard_Transient;
  Standard_Transient_1: typeof Standard_Transient_1;
  Standard_Transient_2: typeof Standard_Transient_2;
  Handle_Standard_Transient: typeof Handle_Standard_Transient;
  Handle_Standard_Transient_1: typeof Handle_Standard_Transient_1;
  Handle_Standard_Transient_2: typeof Handle_Standard_Transient_2;
  Handle_Standard_Transient_3: typeof Handle_Standard_Transient_3;
  Handle_Standard_Transient_4: typeof Handle_Standard_Transient_4;
  Standard_GUID: typeof Standard_GUID;
  Standard_GUID_1: typeof Standard_GUID_1;
  Standard_GUID_2: typeof Standard_GUID_2;
  Standard_GUID_3: typeof Standard_GUID_3;
  Standard_GUID_4: typeof Standard_GUID_4;
  Standard_GUID_5: typeof Standard_GUID_5;
  Standard_GUID_6: typeof Standard_GUID_6;
  Standard_AbortiveTransaction: typeof Standard_AbortiveTransaction;
  Standard_AbortiveTransaction_1: typeof Standard_AbortiveTransaction_1;
  Standard_AbortiveTransaction_2: typeof Standard_AbortiveTransaction_2;
  Handle_Standard_AbortiveTransaction: typeof Handle_Standard_AbortiveTransaction;
  Handle_Standard_AbortiveTransaction_1: typeof Handle_Standard_AbortiveTransaction_1;
  Handle_Standard_AbortiveTransaction_2: typeof Handle_Standard_AbortiveTransaction_2;
  Handle_Standard_AbortiveTransaction_3: typeof Handle_Standard_AbortiveTransaction_3;
  Handle_Standard_AbortiveTransaction_4: typeof Handle_Standard_AbortiveTransaction_4;
  Handle_Standard_Failure: typeof Handle_Standard_Failure;
  Handle_Standard_Failure_1: typeof Handle_Standard_Failure_1;
  Handle_Standard_Failure_2: typeof Handle_Standard_Failure_2;
  Handle_Standard_Failure_3: typeof Handle_Standard_Failure_3;
  Handle_Standard_Failure_4: typeof Handle_Standard_Failure_4;
  Standard_Failure: typeof Standard_Failure;
  Standard_Failure_1: typeof Standard_Failure_1;
  Standard_Failure_2: typeof Standard_Failure_2;
  Standard_Failure_3: typeof Standard_Failure_3;
  Standard_ReadBuffer: typeof Standard_ReadBuffer;
  Standard_NumericError: typeof Standard_NumericError;
  Standard_NumericError_1: typeof Standard_NumericError_1;
  Standard_NumericError_2: typeof Standard_NumericError_2;
  Handle_Standard_NumericError: typeof Handle_Standard_NumericError;
  Handle_Standard_NumericError_1: typeof Handle_Standard_NumericError_1;
  Handle_Standard_NumericError_2: typeof Handle_Standard_NumericError_2;
  Handle_Standard_NumericError_3: typeof Handle_Standard_NumericError_3;
  Handle_Standard_NumericError_4: typeof Handle_Standard_NumericError_4;
  Handle_Standard_LicenseError: typeof Handle_Standard_LicenseError;
  Handle_Standard_LicenseError_1: typeof Handle_Standard_LicenseError_1;
  Handle_Standard_LicenseError_2: typeof Handle_Standard_LicenseError_2;
  Handle_Standard_LicenseError_3: typeof Handle_Standard_LicenseError_3;
  Handle_Standard_LicenseError_4: typeof Handle_Standard_LicenseError_4;
  Standard_LicenseError: typeof Standard_LicenseError;
  Standard_LicenseError_1: typeof Standard_LicenseError_1;
  Standard_LicenseError_2: typeof Standard_LicenseError_2;
  Standard_ReadLineBuffer: typeof Standard_ReadLineBuffer;
  Standard_CLocaleSentry: typeof Standard_CLocaleSentry;
  Standard_OutOfRange: typeof Standard_OutOfRange;
  Standard_OutOfRange_1: typeof Standard_OutOfRange_1;
  Standard_OutOfRange_2: typeof Standard_OutOfRange_2;
  Handle_Standard_OutOfRange: typeof Handle_Standard_OutOfRange;
  Handle_Standard_OutOfRange_1: typeof Handle_Standard_OutOfRange_1;
  Handle_Standard_OutOfRange_2: typeof Handle_Standard_OutOfRange_2;
  Handle_Standard_OutOfRange_3: typeof Handle_Standard_OutOfRange_3;
  Handle_Standard_OutOfRange_4: typeof Handle_Standard_OutOfRange_4;
  Standard_MMgrRaw: typeof Standard_MMgrRaw;
  Standard_Condition: typeof Standard_Condition;
  Handle_Standard_NoSuchObject: typeof Handle_Standard_NoSuchObject;
  Handle_Standard_NoSuchObject_1: typeof Handle_Standard_NoSuchObject_1;
  Handle_Standard_NoSuchObject_2: typeof Handle_Standard_NoSuchObject_2;
  Handle_Standard_NoSuchObject_3: typeof Handle_Standard_NoSuchObject_3;
  Handle_Standard_NoSuchObject_4: typeof Handle_Standard_NoSuchObject_4;
  Standard_NoSuchObject: typeof Standard_NoSuchObject;
  Standard_NoSuchObject_1: typeof Standard_NoSuchObject_1;
  Standard_NoSuchObject_2: typeof Standard_NoSuchObject_2;
  Handle_Standard_MultiplyDefined: typeof Handle_Standard_MultiplyDefined;
  Handle_Standard_MultiplyDefined_1: typeof Handle_Standard_MultiplyDefined_1;
  Handle_Standard_MultiplyDefined_2: typeof Handle_Standard_MultiplyDefined_2;
  Handle_Standard_MultiplyDefined_3: typeof Handle_Standard_MultiplyDefined_3;
  Handle_Standard_MultiplyDefined_4: typeof Handle_Standard_MultiplyDefined_4;
  Standard_MultiplyDefined: typeof Standard_MultiplyDefined;
  Standard_MultiplyDefined_1: typeof Standard_MultiplyDefined_1;
  Standard_MultiplyDefined_2: typeof Standard_MultiplyDefined_2;
  Handle_Standard_Underflow: typeof Handle_Standard_Underflow;
  Handle_Standard_Underflow_1: typeof Handle_Standard_Underflow_1;
  Handle_Standard_Underflow_2: typeof Handle_Standard_Underflow_2;
  Handle_Standard_Underflow_3: typeof Handle_Standard_Underflow_3;
  Handle_Standard_Underflow_4: typeof Handle_Standard_Underflow_4;
  Standard_Underflow: typeof Standard_Underflow;
  Standard_Underflow_1: typeof Standard_Underflow_1;
  Standard_Underflow_2: typeof Standard_Underflow_2;
  Handle_Standard_NoMoreObject: typeof Handle_Standard_NoMoreObject;
  Handle_Standard_NoMoreObject_1: typeof Handle_Standard_NoMoreObject_1;
  Handle_Standard_NoMoreObject_2: typeof Handle_Standard_NoMoreObject_2;
  Handle_Standard_NoMoreObject_3: typeof Handle_Standard_NoMoreObject_3;
  Handle_Standard_NoMoreObject_4: typeof Handle_Standard_NoMoreObject_4;
  Standard_NoMoreObject: typeof Standard_NoMoreObject;
  Standard_NoMoreObject_1: typeof Standard_NoMoreObject_1;
  Standard_NoMoreObject_2: typeof Standard_NoMoreObject_2;
  Standard_HandlerStatus: Standard_HandlerStatus;
  Handle_Standard_ProgramError: typeof Handle_Standard_ProgramError;
  Handle_Standard_ProgramError_1: typeof Handle_Standard_ProgramError_1;
  Handle_Standard_ProgramError_2: typeof Handle_Standard_ProgramError_2;
  Handle_Standard_ProgramError_3: typeof Handle_Standard_ProgramError_3;
  Handle_Standard_ProgramError_4: typeof Handle_Standard_ProgramError_4;
  Standard_ProgramError: typeof Standard_ProgramError;
  Standard_ProgramError_1: typeof Standard_ProgramError_1;
  Standard_ProgramError_2: typeof Standard_ProgramError_2;
  Handle_Standard_NotImplemented: typeof Handle_Standard_NotImplemented;
  Handle_Standard_NotImplemented_1: typeof Handle_Standard_NotImplemented_1;
  Handle_Standard_NotImplemented_2: typeof Handle_Standard_NotImplemented_2;
  Handle_Standard_NotImplemented_3: typeof Handle_Standard_NotImplemented_3;
  Handle_Standard_NotImplemented_4: typeof Handle_Standard_NotImplemented_4;
  Standard_NotImplemented: typeof Standard_NotImplemented;
  Standard_NotImplemented_1: typeof Standard_NotImplemented_1;
  Standard_NotImplemented_2: typeof Standard_NotImplemented_2;
  Standard_MMgrOpt: typeof Standard_MMgrOpt;
  Standard_ImmutableObject: typeof Standard_ImmutableObject;
  Standard_ImmutableObject_1: typeof Standard_ImmutableObject_1;
  Standard_ImmutableObject_2: typeof Standard_ImmutableObject_2;
  Handle_Standard_ImmutableObject: typeof Handle_Standard_ImmutableObject;
  Handle_Standard_ImmutableObject_1: typeof Handle_Standard_ImmutableObject_1;
  Handle_Standard_ImmutableObject_2: typeof Handle_Standard_ImmutableObject_2;
  Handle_Standard_ImmutableObject_3: typeof Handle_Standard_ImmutableObject_3;
  Handle_Standard_ImmutableObject_4: typeof Handle_Standard_ImmutableObject_4;
  Standard_MMgrRoot: typeof Standard_MMgrRoot;
  Standard_DimensionMismatch: typeof Standard_DimensionMismatch;
  Standard_DimensionMismatch_1: typeof Standard_DimensionMismatch_1;
  Standard_DimensionMismatch_2: typeof Standard_DimensionMismatch_2;
  Handle_Standard_DimensionMismatch: typeof Handle_Standard_DimensionMismatch;
  Handle_Standard_DimensionMismatch_1: typeof Handle_Standard_DimensionMismatch_1;
  Handle_Standard_DimensionMismatch_2: typeof Handle_Standard_DimensionMismatch_2;
  Handle_Standard_DimensionMismatch_3: typeof Handle_Standard_DimensionMismatch_3;
  Handle_Standard_DimensionMismatch_4: typeof Handle_Standard_DimensionMismatch_4;
  Standard_MMgrTBBalloc: typeof Standard_MMgrTBBalloc;
  RWStepRepr_RWConstructiveGeometryRepresentation: typeof RWStepRepr_RWConstructiveGeometryRepresentation;
  RWStepRepr_RWCentreOfSymmetry: typeof RWStepRepr_RWCentreOfSymmetry;
  RWStepRepr_RWPropertyDefinition: typeof RWStepRepr_RWPropertyDefinition;
  RWStepRepr_RWCompGroupShAspAndCompShAspAndDatumFeatAndShAsp: typeof RWStepRepr_RWCompGroupShAspAndCompShAspAndDatumFeatAndShAsp;
  RWStepRepr_RWDescriptiveRepresentationItem: typeof RWStepRepr_RWDescriptiveRepresentationItem;
  RWStepRepr_RWItemDefinedTransformation: typeof RWStepRepr_RWItemDefinedTransformation;
  RWStepRepr_RWIntegerRepresentationItem: typeof RWStepRepr_RWIntegerRepresentationItem;
  RWStepRepr_RWGlobalUncertaintyAssignedContext: typeof RWStepRepr_RWGlobalUncertaintyAssignedContext;
  RWStepRepr_RWBetweenShapeAspect: typeof RWStepRepr_RWBetweenShapeAspect;
  RWStepRepr_RWMeasureRepresentationItem: typeof RWStepRepr_RWMeasureRepresentationItem;
  RWStepRepr_RWMappedItem: typeof RWStepRepr_RWMappedItem;
  RWStepRepr_RWCompositeShapeAspect: typeof RWStepRepr_RWCompositeShapeAspect;
  RWStepRepr_RWReprItemAndPlaneAngleMeasureWithUnitAndQRI: typeof RWStepRepr_RWReprItemAndPlaneAngleMeasureWithUnitAndQRI;
  RWStepRepr_RWProductConcept: typeof RWStepRepr_RWProductConcept;
  RWStepRepr_RWDerivedShapeAspect: typeof RWStepRepr_RWDerivedShapeAspect;
  RWStepRepr_RWParametricRepresentationContext: typeof RWStepRepr_RWParametricRepresentationContext;
  RWStepRepr_RWDefinitionalRepresentation: typeof RWStepRepr_RWDefinitionalRepresentation;
  RWStepRepr_RWCharacterizedRepresentation: typeof RWStepRepr_RWCharacterizedRepresentation;
  RWStepRepr_RWRepresentationRelationship: typeof RWStepRepr_RWRepresentationRelationship;
  RWStepRepr_RWTangent: typeof RWStepRepr_RWTangent;
  RWStepRepr_RWMaterialDesignation: typeof RWStepRepr_RWMaterialDesignation;
  RWStepRepr_RWShapeAspect: typeof RWStepRepr_RWShapeAspect;
  RWStepRepr_RWAssemblyComponentUsageSubstitute: typeof RWStepRepr_RWAssemblyComponentUsageSubstitute;
  RWStepRepr_RWRepresentation: typeof RWStepRepr_RWRepresentation;
  RWStepRepr_RWReprItemAndPlaneAngleMeasureWithUnit: typeof RWStepRepr_RWReprItemAndPlaneAngleMeasureWithUnit;
  RWStepRepr_RWShapeAspectDerivingRelationship: typeof RWStepRepr_RWShapeAspectDerivingRelationship;
  RWStepRepr_RWContinuosShapeAspect: typeof RWStepRepr_RWContinuosShapeAspect;
  RWStepRepr_RWShapeAspectTransition: typeof RWStepRepr_RWShapeAspectTransition;
  RWStepRepr_RWValueRepresentationItem: typeof RWStepRepr_RWValueRepresentationItem;
  RWStepRepr_RWFunctionallyDefinedTransformation: typeof RWStepRepr_RWFunctionallyDefinedTransformation;
  RWStepRepr_RWRepresentationItem: typeof RWStepRepr_RWRepresentationItem;
  RWStepRepr_RWRepresentationContext: typeof RWStepRepr_RWRepresentationContext;
  RWStepRepr_RWParallelOffset: typeof RWStepRepr_RWParallelOffset;
  RWStepRepr_RWMaterialPropertyRepresentation: typeof RWStepRepr_RWMaterialPropertyRepresentation;
  RWStepRepr_RWStructuralResponseProperty: typeof RWStepRepr_RWStructuralResponseProperty;
  RWStepRepr_RWReprItemAndLengthMeasureWithUnit: typeof RWStepRepr_RWReprItemAndLengthMeasureWithUnit;
  RWStepRepr_RWCompositeGroupShapeAspect: typeof RWStepRepr_RWCompositeGroupShapeAspect;
  RWStepRepr_RWShapeRepresentationRelationshipWithTransformation: typeof RWStepRepr_RWShapeRepresentationRelationshipWithTransformation;
  RWStepRepr_RWShapeAspectRelationship: typeof RWStepRepr_RWShapeAspectRelationship;
  RWStepRepr_RWConfigurationItem: typeof RWStepRepr_RWConfigurationItem;
  RWStepRepr_RWFeatureForDatumTargetRelationship: typeof RWStepRepr_RWFeatureForDatumTargetRelationship;
  RWStepRepr_RWRepresentationRelationshipWithTransformation: typeof RWStepRepr_RWRepresentationRelationshipWithTransformation;
  RWStepRepr_RWStructuralResponsePropertyDefinitionRepresentation: typeof RWStepRepr_RWStructuralResponsePropertyDefinitionRepresentation;
  RWStepRepr_RWConfigurationEffectivity: typeof RWStepRepr_RWConfigurationEffectivity;
  RWStepRepr_RWApex: typeof RWStepRepr_RWApex;
  RWStepRepr_RWProductDefinitionShape: typeof RWStepRepr_RWProductDefinitionShape;
  RWStepRepr_RWReprItemAndLengthMeasureWithUnitAndQRI: typeof RWStepRepr_RWReprItemAndLengthMeasureWithUnitAndQRI;
  RWStepRepr_RWCompoundRepresentationItem: typeof RWStepRepr_RWCompoundRepresentationItem;
  RWStepRepr_RWAllAroundShapeAspect: typeof RWStepRepr_RWAllAroundShapeAspect;
  RWStepRepr_RWConfigurationDesign: typeof RWStepRepr_RWConfigurationDesign;
  RWStepRepr_RWAssemblyComponentUsage: typeof RWStepRepr_RWAssemblyComponentUsage;
  RWStepRepr_RWPropertyDefinitionRelationship: typeof RWStepRepr_RWPropertyDefinitionRelationship;
  RWStepRepr_RWMaterialProperty: typeof RWStepRepr_RWMaterialProperty;
  RWStepRepr_RWQuantifiedAssemblyComponentUsage: typeof RWStepRepr_RWQuantifiedAssemblyComponentUsage;
  RWStepRepr_RWGeometricAlignment: typeof RWStepRepr_RWGeometricAlignment;
  RWStepRepr_RWCompShAspAndDatumFeatAndShAsp: typeof RWStepRepr_RWCompShAspAndDatumFeatAndShAsp;
  RWStepRepr_RWConstructiveGeometryRepresentationRelationship: typeof RWStepRepr_RWConstructiveGeometryRepresentationRelationship;
  RWStepRepr_RWDataEnvironment: typeof RWStepRepr_RWDataEnvironment;
  RWStepRepr_RWGlobalUnitAssignedContext: typeof RWStepRepr_RWGlobalUnitAssignedContext;
  RWStepRepr_RWRepresentationMap: typeof RWStepRepr_RWRepresentationMap;
  RWStepRepr_RWExtension: typeof RWStepRepr_RWExtension;
  RWStepRepr_RWSpecifiedHigherUsageOccurrence: typeof RWStepRepr_RWSpecifiedHigherUsageOccurrence;
  RWStepRepr_RWPerpendicularTo: typeof RWStepRepr_RWPerpendicularTo;
  RWStepRepr_RWPropertyDefinitionRepresentation: typeof RWStepRepr_RWPropertyDefinitionRepresentation;
  RWStepRepr_RWMakeFromUsageOption: typeof RWStepRepr_RWMakeFromUsageOption;
  Handle_BRepCheck_Shell: typeof Handle_BRepCheck_Shell;
  Handle_BRepCheck_Shell_1: typeof Handle_BRepCheck_Shell_1;
  Handle_BRepCheck_Shell_2: typeof Handle_BRepCheck_Shell_2;
  Handle_BRepCheck_Shell_3: typeof Handle_BRepCheck_Shell_3;
  Handle_BRepCheck_Shell_4: typeof Handle_BRepCheck_Shell_4;
  BRepCheck_Shell: typeof BRepCheck_Shell;
  Handle_BRepCheck_Result: typeof Handle_BRepCheck_Result;
  Handle_BRepCheck_Result_1: typeof Handle_BRepCheck_Result_1;
  Handle_BRepCheck_Result_2: typeof Handle_BRepCheck_Result_2;
  Handle_BRepCheck_Result_3: typeof Handle_BRepCheck_Result_3;
  Handle_BRepCheck_Result_4: typeof Handle_BRepCheck_Result_4;
  BRepCheck_Result: typeof BRepCheck_Result;
  BRepCheck_Edge: typeof BRepCheck_Edge;
  Handle_BRepCheck_Edge: typeof Handle_BRepCheck_Edge;
  Handle_BRepCheck_Edge_1: typeof Handle_BRepCheck_Edge_1;
  Handle_BRepCheck_Edge_2: typeof Handle_BRepCheck_Edge_2;
  Handle_BRepCheck_Edge_3: typeof Handle_BRepCheck_Edge_3;
  Handle_BRepCheck_Edge_4: typeof Handle_BRepCheck_Edge_4;
  BRepCheck_Analyzer: typeof BRepCheck_Analyzer;
  Handle_BRepCheck_Wire: typeof Handle_BRepCheck_Wire;
  Handle_BRepCheck_Wire_1: typeof Handle_BRepCheck_Wire_1;
  Handle_BRepCheck_Wire_2: typeof Handle_BRepCheck_Wire_2;
  Handle_BRepCheck_Wire_3: typeof Handle_BRepCheck_Wire_3;
  Handle_BRepCheck_Wire_4: typeof Handle_BRepCheck_Wire_4;
  BRepCheck_Wire: typeof BRepCheck_Wire;
  BRepCheck_Solid: typeof BRepCheck_Solid;
  Handle_BRepCheck_Solid: typeof Handle_BRepCheck_Solid;
  Handle_BRepCheck_Solid_1: typeof Handle_BRepCheck_Solid_1;
  Handle_BRepCheck_Solid_2: typeof Handle_BRepCheck_Solid_2;
  Handle_BRepCheck_Solid_3: typeof Handle_BRepCheck_Solid_3;
  Handle_BRepCheck_Solid_4: typeof Handle_BRepCheck_Solid_4;
  Handle_BRepCheck_Face: typeof Handle_BRepCheck_Face;
  Handle_BRepCheck_Face_1: typeof Handle_BRepCheck_Face_1;
  Handle_BRepCheck_Face_2: typeof Handle_BRepCheck_Face_2;
  Handle_BRepCheck_Face_3: typeof Handle_BRepCheck_Face_3;
  Handle_BRepCheck_Face_4: typeof Handle_BRepCheck_Face_4;
  BRepCheck_Face: typeof BRepCheck_Face;
  BRepCheck_Status: BRepCheck_Status;
  BRepCheck_DataMapOfShapeListOfStatus: typeof BRepCheck_DataMapOfShapeListOfStatus;
  BRepCheck_DataMapOfShapeListOfStatus_1: typeof BRepCheck_DataMapOfShapeListOfStatus_1;
  BRepCheck_DataMapOfShapeListOfStatus_2: typeof BRepCheck_DataMapOfShapeListOfStatus_2;
  BRepCheck_DataMapOfShapeListOfStatus_3: typeof BRepCheck_DataMapOfShapeListOfStatus_3;
  Handle_BRepCheck_Vertex: typeof Handle_BRepCheck_Vertex;
  Handle_BRepCheck_Vertex_1: typeof Handle_BRepCheck_Vertex_1;
  Handle_BRepCheck_Vertex_2: typeof Handle_BRepCheck_Vertex_2;
  Handle_BRepCheck_Vertex_3: typeof Handle_BRepCheck_Vertex_3;
  Handle_BRepCheck_Vertex_4: typeof Handle_BRepCheck_Vertex_4;
  BRepCheck_Vertex: typeof BRepCheck_Vertex;
  BRepCheck: typeof BRepCheck;
  BRepCheck_ListOfStatus: typeof BRepCheck_ListOfStatus;
  BRepCheck_ListOfStatus_1: typeof BRepCheck_ListOfStatus_1;
  BRepCheck_ListOfStatus_2: typeof BRepCheck_ListOfStatus_2;
  BRepCheck_ListOfStatus_3: typeof BRepCheck_ListOfStatus_3;
  BRepBndLib: typeof BRepBndLib;
  Interface_Protocol: typeof Interface_Protocol;
  Handle_Interface_Protocol: typeof Handle_Interface_Protocol;
  Handle_Interface_Protocol_1: typeof Handle_Interface_Protocol_1;
  Handle_Interface_Protocol_2: typeof Handle_Interface_Protocol_2;
  Handle_Interface_Protocol_3: typeof Handle_Interface_Protocol_3;
  Handle_Interface_Protocol_4: typeof Handle_Interface_Protocol_4;
  Handle_Interface_HGraph: typeof Handle_Interface_HGraph;
  Handle_Interface_HGraph_1: typeof Handle_Interface_HGraph_1;
  Handle_Interface_HGraph_2: typeof Handle_Interface_HGraph_2;
  Handle_Interface_HGraph_3: typeof Handle_Interface_HGraph_3;
  Handle_Interface_HGraph_4: typeof Handle_Interface_HGraph_4;
  Interface_DataState: Interface_DataState;
  Interface_NodeOfReaderLib: typeof Interface_NodeOfReaderLib;
  Handle_Interface_NodeOfReaderLib: typeof Handle_Interface_NodeOfReaderLib;
  Handle_Interface_NodeOfReaderLib_1: typeof Handle_Interface_NodeOfReaderLib_1;
  Handle_Interface_NodeOfReaderLib_2: typeof Handle_Interface_NodeOfReaderLib_2;
  Handle_Interface_NodeOfReaderLib_3: typeof Handle_Interface_NodeOfReaderLib_3;
  Handle_Interface_NodeOfReaderLib_4: typeof Handle_Interface_NodeOfReaderLib_4;
  Interface_EntityIterator: typeof Interface_EntityIterator;
  Interface_EntityIterator_1: typeof Interface_EntityIterator_1;
  Interface_EntityIterator_2: typeof Interface_EntityIterator_2;
  Interface_CopyTool: typeof Interface_CopyTool;
  Interface_CopyTool_1: typeof Interface_CopyTool_1;
  Interface_CopyTool_2: typeof Interface_CopyTool_2;
  Interface_CopyTool_3: typeof Interface_CopyTool_3;
  Interface_EntityList: typeof Interface_EntityList;
  Interface_CheckIterator: typeof Interface_CheckIterator;
  Interface_CheckIterator_1: typeof Interface_CheckIterator_1;
  Interface_CheckIterator_2: typeof Interface_CheckIterator_2;
  Handle_Interface_GlobalNodeOfGeneralLib: typeof Handle_Interface_GlobalNodeOfGeneralLib;
  Handle_Interface_GlobalNodeOfGeneralLib_1: typeof Handle_Interface_GlobalNodeOfGeneralLib_1;
  Handle_Interface_GlobalNodeOfGeneralLib_2: typeof Handle_Interface_GlobalNodeOfGeneralLib_2;
  Handle_Interface_GlobalNodeOfGeneralLib_3: typeof Handle_Interface_GlobalNodeOfGeneralLib_3;
  Handle_Interface_GlobalNodeOfGeneralLib_4: typeof Handle_Interface_GlobalNodeOfGeneralLib_4;
  Interface_GlobalNodeOfGeneralLib: typeof Interface_GlobalNodeOfGeneralLib;
  Interface_MapAsciiStringHasher: typeof Interface_MapAsciiStringHasher;
  Interface_Category: typeof Interface_Category;
  Interface_Category_1: typeof Interface_Category_1;
  Interface_Category_2: typeof Interface_Category_2;
  Interface_Category_3: typeof Interface_Category_3;
  Interface_ShareTool: typeof Interface_ShareTool;
  Interface_ShareTool_1: typeof Interface_ShareTool_1;
  Interface_ShareTool_2: typeof Interface_ShareTool_2;
  Interface_ShareTool_3: typeof Interface_ShareTool_3;
  Interface_ShareTool_4: typeof Interface_ShareTool_4;
  Interface_ShareTool_5: typeof Interface_ShareTool_5;
  Interface_ShareTool_6: typeof Interface_ShareTool_6;
  Handle_Interface_InterfaceError: typeof Handle_Interface_InterfaceError;
  Handle_Interface_InterfaceError_1: typeof Handle_Interface_InterfaceError_1;
  Handle_Interface_InterfaceError_2: typeof Handle_Interface_InterfaceError_2;
  Handle_Interface_InterfaceError_3: typeof Handle_Interface_InterfaceError_3;
  Handle_Interface_InterfaceError_4: typeof Handle_Interface_InterfaceError_4;
  Interface_InterfaceError: typeof Interface_InterfaceError;
  Interface_InterfaceError_1: typeof Interface_InterfaceError_1;
  Interface_InterfaceError_2: typeof Interface_InterfaceError_2;
  Interface_FileReaderTool: typeof Interface_FileReaderTool;
  Handle_Interface_ReportEntity: typeof Handle_Interface_ReportEntity;
  Handle_Interface_ReportEntity_1: typeof Handle_Interface_ReportEntity_1;
  Handle_Interface_ReportEntity_2: typeof Handle_Interface_ReportEntity_2;
  Handle_Interface_ReportEntity_3: typeof Handle_Interface_ReportEntity_3;
  Handle_Interface_ReportEntity_4: typeof Handle_Interface_ReportEntity_4;
  Interface_ReportEntity: typeof Interface_ReportEntity;
  Interface_ReportEntity_1: typeof Interface_ReportEntity_1;
  Interface_ReportEntity_2: typeof Interface_ReportEntity_2;
  Interface_BitMap: typeof Interface_BitMap;
  Interface_BitMap_1: typeof Interface_BitMap_1;
  Interface_BitMap_2: typeof Interface_BitMap_2;
  Interface_BitMap_3: typeof Interface_BitMap_3;
  Interface_UndefinedContent: typeof Interface_UndefinedContent;
  Handle_Interface_UndefinedContent: typeof Handle_Interface_UndefinedContent;
  Handle_Interface_UndefinedContent_1: typeof Handle_Interface_UndefinedContent_1;
  Handle_Interface_UndefinedContent_2: typeof Handle_Interface_UndefinedContent_2;
  Handle_Interface_UndefinedContent_3: typeof Handle_Interface_UndefinedContent_3;
  Handle_Interface_UndefinedContent_4: typeof Handle_Interface_UndefinedContent_4;
  Interface_ParamList: typeof Interface_ParamList;
  Handle_Interface_ParamList: typeof Handle_Interface_ParamList;
  Handle_Interface_ParamList_1: typeof Handle_Interface_ParamList_1;
  Handle_Interface_ParamList_2: typeof Handle_Interface_ParamList_2;
  Handle_Interface_ParamList_3: typeof Handle_Interface_ParamList_3;
  Handle_Interface_ParamList_4: typeof Handle_Interface_ParamList_4;
  Handle_Interface_Check: typeof Handle_Interface_Check;
  Handle_Interface_Check_1: typeof Handle_Interface_Check_1;
  Handle_Interface_Check_2: typeof Handle_Interface_Check_2;
  Handle_Interface_Check_3: typeof Handle_Interface_Check_3;
  Handle_Interface_Check_4: typeof Handle_Interface_Check_4;
  Interface_Check: typeof Interface_Check;
  Interface_Check_1: typeof Interface_Check_1;
  Interface_Check_2: typeof Interface_Check_2;
  Interface_FloatWriter: typeof Interface_FloatWriter;
  Interface_CheckFailure: typeof Interface_CheckFailure;
  Interface_CheckFailure_1: typeof Interface_CheckFailure_1;
  Interface_CheckFailure_2: typeof Interface_CheckFailure_2;
  Handle_Interface_CheckFailure: typeof Handle_Interface_CheckFailure;
  Handle_Interface_CheckFailure_1: typeof Handle_Interface_CheckFailure_1;
  Handle_Interface_CheckFailure_2: typeof Handle_Interface_CheckFailure_2;
  Handle_Interface_CheckFailure_3: typeof Handle_Interface_CheckFailure_3;
  Handle_Interface_CheckFailure_4: typeof Handle_Interface_CheckFailure_4;
  Interface_Array1OfFileParameter: typeof Interface_Array1OfFileParameter;
  Interface_Array1OfFileParameter_1: typeof Interface_Array1OfFileParameter_1;
  Interface_Array1OfFileParameter_2: typeof Interface_Array1OfFileParameter_2;
  Interface_Array1OfFileParameter_3: typeof Interface_Array1OfFileParameter_3;
  Interface_Array1OfFileParameter_4: typeof Interface_Array1OfFileParameter_4;
  Interface_Array1OfFileParameter_5: typeof Interface_Array1OfFileParameter_5;
  Handle_Interface_SignLabel: typeof Handle_Interface_SignLabel;
  Handle_Interface_SignLabel_1: typeof Handle_Interface_SignLabel_1;
  Handle_Interface_SignLabel_2: typeof Handle_Interface_SignLabel_2;
  Handle_Interface_SignLabel_3: typeof Handle_Interface_SignLabel_3;
  Handle_Interface_SignLabel_4: typeof Handle_Interface_SignLabel_4;
  Interface_SignLabel: typeof Interface_SignLabel;
  Handle_Interface_InterfaceMismatch: typeof Handle_Interface_InterfaceMismatch;
  Handle_Interface_InterfaceMismatch_1: typeof Handle_Interface_InterfaceMismatch_1;
  Handle_Interface_InterfaceMismatch_2: typeof Handle_Interface_InterfaceMismatch_2;
  Handle_Interface_InterfaceMismatch_3: typeof Handle_Interface_InterfaceMismatch_3;
  Handle_Interface_InterfaceMismatch_4: typeof Handle_Interface_InterfaceMismatch_4;
  Interface_InterfaceMismatch: typeof Interface_InterfaceMismatch;
  Interface_InterfaceMismatch_1: typeof Interface_InterfaceMismatch_1;
  Interface_InterfaceMismatch_2: typeof Interface_InterfaceMismatch_2;
  Interface_CopyControl: typeof Interface_CopyControl;
  Handle_Interface_CopyControl: typeof Handle_Interface_CopyControl;
  Handle_Interface_CopyControl_1: typeof Handle_Interface_CopyControl_1;
  Handle_Interface_CopyControl_2: typeof Handle_Interface_CopyControl_2;
  Handle_Interface_CopyControl_3: typeof Handle_Interface_CopyControl_3;
  Handle_Interface_CopyControl_4: typeof Handle_Interface_CopyControl_4;
  Interface_MSG: typeof Interface_MSG;
  Interface_MSG_1: typeof Interface_MSG_1;
  Interface_MSG_2: typeof Interface_MSG_2;
  Interface_MSG_3: typeof Interface_MSG_3;
  Interface_MSG_4: typeof Interface_MSG_4;
  Interface_MSG_5: typeof Interface_MSG_5;
  Interface_MSG_6: typeof Interface_MSG_6;
  Interface_ParamType: Interface_ParamType;
  Handle_Interface_InterfaceModel: typeof Handle_Interface_InterfaceModel;
  Handle_Interface_InterfaceModel_1: typeof Handle_Interface_InterfaceModel_1;
  Handle_Interface_InterfaceModel_2: typeof Handle_Interface_InterfaceModel_2;
  Handle_Interface_InterfaceModel_3: typeof Handle_Interface_InterfaceModel_3;
  Handle_Interface_InterfaceModel_4: typeof Handle_Interface_InterfaceModel_4;
  Interface_InterfaceModel: typeof Interface_InterfaceModel;
  Handle_Interface_CopyMap: typeof Handle_Interface_CopyMap;
  Handle_Interface_CopyMap_1: typeof Handle_Interface_CopyMap_1;
  Handle_Interface_CopyMap_2: typeof Handle_Interface_CopyMap_2;
  Handle_Interface_CopyMap_3: typeof Handle_Interface_CopyMap_3;
  Handle_Interface_CopyMap_4: typeof Handle_Interface_CopyMap_4;
  Interface_CopyMap: typeof Interface_CopyMap;
  Handle_Interface_HArray1OfHAsciiString: typeof Handle_Interface_HArray1OfHAsciiString;
  Handle_Interface_HArray1OfHAsciiString_1: typeof Handle_Interface_HArray1OfHAsciiString_1;
  Handle_Interface_HArray1OfHAsciiString_2: typeof Handle_Interface_HArray1OfHAsciiString_2;
  Handle_Interface_HArray1OfHAsciiString_3: typeof Handle_Interface_HArray1OfHAsciiString_3;
  Handle_Interface_HArray1OfHAsciiString_4: typeof Handle_Interface_HArray1OfHAsciiString_4;
  Interface_GraphContent: typeof Interface_GraphContent;
  Interface_GraphContent_1: typeof Interface_GraphContent_1;
  Interface_GraphContent_2: typeof Interface_GraphContent_2;
  Interface_GraphContent_3: typeof Interface_GraphContent_3;
  Interface_GraphContent_4: typeof Interface_GraphContent_4;
  Interface_GeneralLib: typeof Interface_GeneralLib;
  Interface_GeneralLib_1: typeof Interface_GeneralLib_1;
  Interface_GeneralLib_2: typeof Interface_GeneralLib_2;
  Interface_CheckTool: typeof Interface_CheckTool;
  Interface_CheckTool_1: typeof Interface_CheckTool_1;
  Interface_CheckTool_2: typeof Interface_CheckTool_2;
  Interface_CheckTool_3: typeof Interface_CheckTool_3;
  Interface_CheckTool_4: typeof Interface_CheckTool_4;
  Handle_Interface_FileReaderData: typeof Handle_Interface_FileReaderData;
  Handle_Interface_FileReaderData_1: typeof Handle_Interface_FileReaderData_1;
  Handle_Interface_FileReaderData_2: typeof Handle_Interface_FileReaderData_2;
  Handle_Interface_FileReaderData_3: typeof Handle_Interface_FileReaderData_3;
  Handle_Interface_FileReaderData_4: typeof Handle_Interface_FileReaderData_4;
  Interface_IntVal: typeof Interface_IntVal;
  Handle_Interface_IntVal: typeof Handle_Interface_IntVal;
  Handle_Interface_IntVal_1: typeof Handle_Interface_IntVal_1;
  Handle_Interface_IntVal_2: typeof Handle_Interface_IntVal_2;
  Handle_Interface_IntVal_3: typeof Handle_Interface_IntVal_3;
  Handle_Interface_IntVal_4: typeof Handle_Interface_IntVal_4;
  Handle_Interface_NodeOfGeneralLib: typeof Handle_Interface_NodeOfGeneralLib;
  Handle_Interface_NodeOfGeneralLib_1: typeof Handle_Interface_NodeOfGeneralLib_1;
  Handle_Interface_NodeOfGeneralLib_2: typeof Handle_Interface_NodeOfGeneralLib_2;
  Handle_Interface_NodeOfGeneralLib_3: typeof Handle_Interface_NodeOfGeneralLib_3;
  Handle_Interface_NodeOfGeneralLib_4: typeof Handle_Interface_NodeOfGeneralLib_4;
  Interface_NodeOfGeneralLib: typeof Interface_NodeOfGeneralLib;
  Interface_FileParameter: typeof Interface_FileParameter;
  Interface_STAT: typeof Interface_STAT;
  Interface_STAT_1: typeof Interface_STAT_1;
  Interface_STAT_2: typeof Interface_STAT_2;
  Interface_LineBuffer: typeof Interface_LineBuffer;
  Handle_Interface_SignType: typeof Handle_Interface_SignType;
  Handle_Interface_SignType_1: typeof Handle_Interface_SignType_1;
  Handle_Interface_SignType_2: typeof Handle_Interface_SignType_2;
  Handle_Interface_SignType_3: typeof Handle_Interface_SignType_3;
  Handle_Interface_SignType_4: typeof Handle_Interface_SignType_4;
  Interface_SignType: typeof Interface_SignType;
  Interface_ShareFlags: typeof Interface_ShareFlags;
  Interface_ShareFlags_1: typeof Interface_ShareFlags_1;
  Interface_ShareFlags_2: typeof Interface_ShareFlags_2;
  Interface_ShareFlags_3: typeof Interface_ShareFlags_3;
  Interface_ShareFlags_4: typeof Interface_ShareFlags_4;
  Interface_ShareFlags_5: typeof Interface_ShareFlags_5;
  Interface_IndexedMapOfAsciiString: typeof Interface_IndexedMapOfAsciiString;
  Interface_IndexedMapOfAsciiString_1: typeof Interface_IndexedMapOfAsciiString_1;
  Interface_IndexedMapOfAsciiString_2: typeof Interface_IndexedMapOfAsciiString_2;
  Interface_IndexedMapOfAsciiString_3: typeof Interface_IndexedMapOfAsciiString_3;
  Interface_ReaderModule: typeof Interface_ReaderModule;
  Handle_Interface_ReaderModule: typeof Handle_Interface_ReaderModule;
  Handle_Interface_ReaderModule_1: typeof Handle_Interface_ReaderModule_1;
  Handle_Interface_ReaderModule_2: typeof Handle_Interface_ReaderModule_2;
  Handle_Interface_ReaderModule_3: typeof Handle_Interface_ReaderModule_3;
  Handle_Interface_ReaderModule_4: typeof Handle_Interface_ReaderModule_4;
  Interface_CheckStatus: Interface_CheckStatus;
  Interface_EntityCluster: typeof Interface_EntityCluster;
  Interface_EntityCluster_1: typeof Interface_EntityCluster_1;
  Interface_EntityCluster_2: typeof Interface_EntityCluster_2;
  Interface_EntityCluster_3: typeof Interface_EntityCluster_3;
  Interface_EntityCluster_4: typeof Interface_EntityCluster_4;
  Handle_Interface_EntityCluster: typeof Handle_Interface_EntityCluster;
  Handle_Interface_EntityCluster_1: typeof Handle_Interface_EntityCluster_1;
  Handle_Interface_EntityCluster_2: typeof Handle_Interface_EntityCluster_2;
  Handle_Interface_EntityCluster_3: typeof Handle_Interface_EntityCluster_3;
  Handle_Interface_EntityCluster_4: typeof Handle_Interface_EntityCluster_4;
  Handle_Interface_HSequenceOfCheck: typeof Handle_Interface_HSequenceOfCheck;
  Handle_Interface_HSequenceOfCheck_1: typeof Handle_Interface_HSequenceOfCheck_1;
  Handle_Interface_HSequenceOfCheck_2: typeof Handle_Interface_HSequenceOfCheck_2;
  Handle_Interface_HSequenceOfCheck_3: typeof Handle_Interface_HSequenceOfCheck_3;
  Handle_Interface_HSequenceOfCheck_4: typeof Handle_Interface_HSequenceOfCheck_4;
  Interface_IntList: typeof Interface_IntList;
  Interface_IntList_1: typeof Interface_IntList_1;
  Interface_IntList_2: typeof Interface_IntList_2;
  Interface_IntList_3: typeof Interface_IntList_3;
  Interface_Static: typeof Interface_Static;
  Interface_Static_1: typeof Interface_Static_1;
  Interface_Static_2: typeof Interface_Static_2;
  Handle_Interface_Static: typeof Handle_Interface_Static;
  Handle_Interface_Static_1: typeof Handle_Interface_Static_1;
  Handle_Interface_Static_2: typeof Handle_Interface_Static_2;
  Handle_Interface_Static_3: typeof Handle_Interface_Static_3;
  Handle_Interface_Static_4: typeof Handle_Interface_Static_4;
  Handle_Interface_GlobalNodeOfReaderLib: typeof Handle_Interface_GlobalNodeOfReaderLib;
  Handle_Interface_GlobalNodeOfReaderLib_1: typeof Handle_Interface_GlobalNodeOfReaderLib_1;
  Handle_Interface_GlobalNodeOfReaderLib_2: typeof Handle_Interface_GlobalNodeOfReaderLib_2;
  Handle_Interface_GlobalNodeOfReaderLib_3: typeof Handle_Interface_GlobalNodeOfReaderLib_3;
  Handle_Interface_GlobalNodeOfReaderLib_4: typeof Handle_Interface_GlobalNodeOfReaderLib_4;
  Interface_GlobalNodeOfReaderLib: typeof Interface_GlobalNodeOfReaderLib;
  Interface_GTool: typeof Interface_GTool;
  Interface_GTool_1: typeof Interface_GTool_1;
  Interface_GTool_2: typeof Interface_GTool_2;
  Handle_Interface_GTool: typeof Handle_Interface_GTool;
  Handle_Interface_GTool_1: typeof Handle_Interface_GTool_1;
  Handle_Interface_GTool_2: typeof Handle_Interface_GTool_2;
  Handle_Interface_GTool_3: typeof Handle_Interface_GTool_3;
  Handle_Interface_GTool_4: typeof Handle_Interface_GTool_4;
  Interface_ParamSet: typeof Interface_ParamSet;
  Handle_Interface_ParamSet: typeof Handle_Interface_ParamSet;
  Handle_Interface_ParamSet_1: typeof Handle_Interface_ParamSet_1;
  Handle_Interface_ParamSet_2: typeof Handle_Interface_ParamSet_2;
  Handle_Interface_ParamSet_3: typeof Handle_Interface_ParamSet_3;
  Handle_Interface_ParamSet_4: typeof Handle_Interface_ParamSet_4;
  Handle_Interface_TypedValue: typeof Handle_Interface_TypedValue;
  Handle_Interface_TypedValue_1: typeof Handle_Interface_TypedValue_1;
  Handle_Interface_TypedValue_2: typeof Handle_Interface_TypedValue_2;
  Handle_Interface_TypedValue_3: typeof Handle_Interface_TypedValue_3;
  Handle_Interface_TypedValue_4: typeof Handle_Interface_TypedValue_4;
  Interface_TypedValue: typeof Interface_TypedValue;
  Handle_Interface_GeneralModule: typeof Handle_Interface_GeneralModule;
  Handle_Interface_GeneralModule_1: typeof Handle_Interface_GeneralModule_1;
  Handle_Interface_GeneralModule_2: typeof Handle_Interface_GeneralModule_2;
  Handle_Interface_GeneralModule_3: typeof Handle_Interface_GeneralModule_3;
  Handle_Interface_GeneralModule_4: typeof Handle_Interface_GeneralModule_4;
  Interface_ReaderLib: typeof Interface_ReaderLib;
  Interface_ReaderLib_1: typeof Interface_ReaderLib_1;
  Interface_ReaderLib_2: typeof Interface_ReaderLib_2;
  V3d_Viewer: typeof V3d_Viewer;
  V3d_Viewer_1: typeof V3d_Viewer_1;
  V3d_Viewer_2: typeof V3d_Viewer_2;
  Handle_V3d_Viewer: typeof Handle_V3d_Viewer;
  Handle_V3d_Viewer_1: typeof Handle_V3d_Viewer_1;
  Handle_V3d_Viewer_2: typeof Handle_V3d_Viewer_2;
  Handle_V3d_Viewer_3: typeof Handle_V3d_Viewer_3;
  Handle_V3d_Viewer_4: typeof Handle_V3d_Viewer_4;
  V3d: typeof V3d;
  V3d_BadValue: typeof V3d_BadValue;
  V3d_BadValue_1: typeof V3d_BadValue_1;
  V3d_BadValue_2: typeof V3d_BadValue_2;
  Handle_V3d_BadValue: typeof Handle_V3d_BadValue;
  Handle_V3d_BadValue_1: typeof Handle_V3d_BadValue_1;
  Handle_V3d_BadValue_2: typeof Handle_V3d_BadValue_2;
  Handle_V3d_BadValue_3: typeof Handle_V3d_BadValue_3;
  Handle_V3d_BadValue_4: typeof Handle_V3d_BadValue_4;
  Handle_V3d_PositionLight: typeof Handle_V3d_PositionLight;
  Handle_V3d_PositionLight_1: typeof Handle_V3d_PositionLight_1;
  Handle_V3d_PositionLight_2: typeof Handle_V3d_PositionLight_2;
  Handle_V3d_PositionLight_3: typeof Handle_V3d_PositionLight_3;
  Handle_V3d_PositionLight_4: typeof Handle_V3d_PositionLight_4;
  V3d_PositionLight: typeof V3d_PositionLight;
  V3d_ImageDumpOptions: typeof V3d_ImageDumpOptions;
  V3d_Plane: typeof V3d_Plane;
  Handle_V3d_Plane: typeof Handle_V3d_Plane;
  Handle_V3d_Plane_1: typeof Handle_V3d_Plane_1;
  Handle_V3d_Plane_2: typeof Handle_V3d_Plane_2;
  Handle_V3d_Plane_3: typeof Handle_V3d_Plane_3;
  Handle_V3d_Plane_4: typeof Handle_V3d_Plane_4;
  V3d_TypeOfAxe: V3d_TypeOfAxe;
  V3d_StereoDumpOptions: V3d_StereoDumpOptions;
  V3d_TypeOfPickLight: V3d_TypeOfPickLight;
  V3d_TypeOfVisualization: V3d_TypeOfVisualization;
  Handle_V3d_SpotLight: typeof Handle_V3d_SpotLight;
  Handle_V3d_SpotLight_1: typeof Handle_V3d_SpotLight_1;
  Handle_V3d_SpotLight_2: typeof Handle_V3d_SpotLight_2;
  Handle_V3d_SpotLight_3: typeof Handle_V3d_SpotLight_3;
  Handle_V3d_SpotLight_4: typeof Handle_V3d_SpotLight_4;
  V3d_SpotLight: typeof V3d_SpotLight;
  V3d_SpotLight_1: typeof V3d_SpotLight_1;
  V3d_SpotLight_2: typeof V3d_SpotLight_2;
  V3d_RectangularGrid: typeof V3d_RectangularGrid;
  Handle_V3d_RectangularGrid: typeof Handle_V3d_RectangularGrid;
  Handle_V3d_RectangularGrid_1: typeof Handle_V3d_RectangularGrid_1;
  Handle_V3d_RectangularGrid_2: typeof Handle_V3d_RectangularGrid_2;
  Handle_V3d_RectangularGrid_3: typeof Handle_V3d_RectangularGrid_3;
  Handle_V3d_RectangularGrid_4: typeof Handle_V3d_RectangularGrid_4;
  V3d_TypeOfPickCamera: V3d_TypeOfPickCamera;
  V3d_PositionalLight: typeof V3d_PositionalLight;
  Handle_V3d_PositionalLight: typeof Handle_V3d_PositionalLight;
  Handle_V3d_PositionalLight_1: typeof Handle_V3d_PositionalLight_1;
  Handle_V3d_PositionalLight_2: typeof Handle_V3d_PositionalLight_2;
  Handle_V3d_PositionalLight_3: typeof Handle_V3d_PositionalLight_3;
  Handle_V3d_PositionalLight_4: typeof Handle_V3d_PositionalLight_4;
  Handle_V3d_UnMapped: typeof Handle_V3d_UnMapped;
  Handle_V3d_UnMapped_1: typeof Handle_V3d_UnMapped_1;
  Handle_V3d_UnMapped_2: typeof Handle_V3d_UnMapped_2;
  Handle_V3d_UnMapped_3: typeof Handle_V3d_UnMapped_3;
  Handle_V3d_UnMapped_4: typeof Handle_V3d_UnMapped_4;
  V3d_UnMapped: typeof V3d_UnMapped;
  V3d_UnMapped_1: typeof V3d_UnMapped_1;
  V3d_UnMapped_2: typeof V3d_UnMapped_2;
  V3d_AmbientLight: typeof V3d_AmbientLight;
  Handle_V3d_AmbientLight: typeof Handle_V3d_AmbientLight;
  Handle_V3d_AmbientLight_1: typeof Handle_V3d_AmbientLight_1;
  Handle_V3d_AmbientLight_2: typeof Handle_V3d_AmbientLight_2;
  Handle_V3d_AmbientLight_3: typeof Handle_V3d_AmbientLight_3;
  Handle_V3d_AmbientLight_4: typeof Handle_V3d_AmbientLight_4;
  Handle_V3d_View: typeof Handle_V3d_View;
  Handle_V3d_View_1: typeof Handle_V3d_View_1;
  Handle_V3d_View_2: typeof Handle_V3d_View_2;
  Handle_V3d_View_3: typeof Handle_V3d_View_3;
  Handle_V3d_View_4: typeof Handle_V3d_View_4;
  V3d_View: typeof V3d_View;
  V3d_View_1: typeof V3d_View_1;
  V3d_View_2: typeof V3d_View_2;
  V3d_TypeOfOrientation: V3d_TypeOfOrientation;
  V3d_TypeOfRepresentation: V3d_TypeOfRepresentation;
  Handle_V3d_DirectionalLight: typeof Handle_V3d_DirectionalLight;
  Handle_V3d_DirectionalLight_1: typeof Handle_V3d_DirectionalLight_1;
  Handle_V3d_DirectionalLight_2: typeof Handle_V3d_DirectionalLight_2;
  Handle_V3d_DirectionalLight_3: typeof Handle_V3d_DirectionalLight_3;
  Handle_V3d_DirectionalLight_4: typeof Handle_V3d_DirectionalLight_4;
  V3d_DirectionalLight: typeof V3d_DirectionalLight;
  V3d_DirectionalLight_1: typeof V3d_DirectionalLight_1;
  V3d_DirectionalLight_2: typeof V3d_DirectionalLight_2;
  V3d_TypeOfView: V3d_TypeOfView;
  Handle_V3d_CircularGrid: typeof Handle_V3d_CircularGrid;
  Handle_V3d_CircularGrid_1: typeof Handle_V3d_CircularGrid_1;
  Handle_V3d_CircularGrid_2: typeof Handle_V3d_CircularGrid_2;
  Handle_V3d_CircularGrid_3: typeof Handle_V3d_CircularGrid_3;
  Handle_V3d_CircularGrid_4: typeof Handle_V3d_CircularGrid_4;
  V3d_CircularGrid: typeof V3d_CircularGrid;
  V3d_Trihedron: typeof V3d_Trihedron;
  Handle_V3d_Trihedron: typeof Handle_V3d_Trihedron;
  Handle_V3d_Trihedron_1: typeof Handle_V3d_Trihedron_1;
  Handle_V3d_Trihedron_2: typeof Handle_V3d_Trihedron_2;
  Handle_V3d_Trihedron_3: typeof Handle_V3d_Trihedron_3;
  Handle_V3d_Trihedron_4: typeof Handle_V3d_Trihedron_4;
  V3d_TypeOfBackfacingModel: V3d_TypeOfBackfacingModel;
  AppCont_Function: typeof AppCont_Function;
  AppCont_LeastSquare: typeof AppCont_LeastSquare;
  PeriodicityInfo: typeof PeriodicityInfo;
  StdPersistent_PPrsStd: typeof StdPersistent_PPrsStd;
  StdPersistent_DataXtd: typeof StdPersistent_DataXtd;
  StdPersistent: typeof StdPersistent;
  StdPersistent_Naming: typeof StdPersistent_Naming;
  StdPersistent_DataXtd_Constraint: typeof StdPersistent_DataXtd_Constraint;
  Handle_StdPersistent_HArray1OfShape1: typeof Handle_StdPersistent_HArray1OfShape1;
  Handle_StdPersistent_HArray1OfShape1_1: typeof Handle_StdPersistent_HArray1OfShape1_1;
  Handle_StdPersistent_HArray1OfShape1_2: typeof Handle_StdPersistent_HArray1OfShape1_2;
  Handle_StdPersistent_HArray1OfShape1_3: typeof Handle_StdPersistent_HArray1OfShape1_3;
  Handle_StdPersistent_HArray1OfShape1_4: typeof Handle_StdPersistent_HArray1OfShape1_4;
  StdPersistent_HArray1: typeof StdPersistent_HArray1;
  StdPersistent_TopoDS: typeof StdPersistent_TopoDS;
  StdPersistent_DataXtd_PatternStd: typeof StdPersistent_DataXtd_PatternStd;
  ChFi2d: typeof ChFi2d;
  ChFi2d_ChamferAPI: typeof ChFi2d_ChamferAPI;
  ChFi2d_ChamferAPI_1: typeof ChFi2d_ChamferAPI_1;
  ChFi2d_ChamferAPI_2: typeof ChFi2d_ChamferAPI_2;
  ChFi2d_ChamferAPI_3: typeof ChFi2d_ChamferAPI_3;
  ChFi2d_Builder: typeof ChFi2d_Builder;
  ChFi2d_Builder_1: typeof ChFi2d_Builder_1;
  ChFi2d_Builder_2: typeof ChFi2d_Builder_2;
  ChFi2d_ConstructionError: ChFi2d_ConstructionError;
  ChFi2d_AnaFilletAlgo: typeof ChFi2d_AnaFilletAlgo;
  ChFi2d_AnaFilletAlgo_1: typeof ChFi2d_AnaFilletAlgo_1;
  ChFi2d_AnaFilletAlgo_2: typeof ChFi2d_AnaFilletAlgo_2;
  ChFi2d_AnaFilletAlgo_3: typeof ChFi2d_AnaFilletAlgo_3;
  FilletPoint: typeof FilletPoint;
  ChFi2d_FilletAlgo: typeof ChFi2d_FilletAlgo;
  ChFi2d_FilletAlgo_1: typeof ChFi2d_FilletAlgo_1;
  ChFi2d_FilletAlgo_2: typeof ChFi2d_FilletAlgo_2;
  ChFi2d_FilletAlgo_3: typeof ChFi2d_FilletAlgo_3;
  ChFi2d_FilletAPI: typeof ChFi2d_FilletAPI;
  ChFi2d_FilletAPI_1: typeof ChFi2d_FilletAPI_1;
  ChFi2d_FilletAPI_2: typeof ChFi2d_FilletAPI_2;
  ChFi2d_FilletAPI_3: typeof ChFi2d_FilletAPI_3;
  Handle_VrmlConverter_Drawer: typeof Handle_VrmlConverter_Drawer;
  Handle_VrmlConverter_Drawer_1: typeof Handle_VrmlConverter_Drawer_1;
  Handle_VrmlConverter_Drawer_2: typeof Handle_VrmlConverter_Drawer_2;
  Handle_VrmlConverter_Drawer_3: typeof Handle_VrmlConverter_Drawer_3;
  Handle_VrmlConverter_Drawer_4: typeof Handle_VrmlConverter_Drawer_4;
  VrmlConverter_Drawer: typeof VrmlConverter_Drawer;
  VrmlConverter_ShadedShape: typeof VrmlConverter_ShadedShape;
  VrmlConverter_Curve: typeof VrmlConverter_Curve;
  Handle_VrmlConverter_PointAspect: typeof Handle_VrmlConverter_PointAspect;
  Handle_VrmlConverter_PointAspect_1: typeof Handle_VrmlConverter_PointAspect_1;
  Handle_VrmlConverter_PointAspect_2: typeof Handle_VrmlConverter_PointAspect_2;
  Handle_VrmlConverter_PointAspect_3: typeof Handle_VrmlConverter_PointAspect_3;
  Handle_VrmlConverter_PointAspect_4: typeof Handle_VrmlConverter_PointAspect_4;
  VrmlConverter_PointAspect: typeof VrmlConverter_PointAspect;
  VrmlConverter_PointAspect_1: typeof VrmlConverter_PointAspect_1;
  VrmlConverter_PointAspect_2: typeof VrmlConverter_PointAspect_2;
  VrmlConverter_TypeOfLight: VrmlConverter_TypeOfLight;
  VrmlConverter_TypeOfCamera: VrmlConverter_TypeOfCamera;
  VrmlConverter_IsoAspect: typeof VrmlConverter_IsoAspect;
  VrmlConverter_IsoAspect_1: typeof VrmlConverter_IsoAspect_1;
  VrmlConverter_IsoAspect_2: typeof VrmlConverter_IsoAspect_2;
  Handle_VrmlConverter_IsoAspect: typeof Handle_VrmlConverter_IsoAspect;
  Handle_VrmlConverter_IsoAspect_1: typeof Handle_VrmlConverter_IsoAspect_1;
  Handle_VrmlConverter_IsoAspect_2: typeof Handle_VrmlConverter_IsoAspect_2;
  Handle_VrmlConverter_IsoAspect_3: typeof Handle_VrmlConverter_IsoAspect_3;
  Handle_VrmlConverter_IsoAspect_4: typeof Handle_VrmlConverter_IsoAspect_4;
  VrmlConverter_HLRShape: typeof VrmlConverter_HLRShape;
  VrmlConverter_WFRestrictedFace: typeof VrmlConverter_WFRestrictedFace;
  Handle_VrmlConverter_Projector: typeof Handle_VrmlConverter_Projector;
  Handle_VrmlConverter_Projector_1: typeof Handle_VrmlConverter_Projector_1;
  Handle_VrmlConverter_Projector_2: typeof Handle_VrmlConverter_Projector_2;
  Handle_VrmlConverter_Projector_3: typeof Handle_VrmlConverter_Projector_3;
  Handle_VrmlConverter_Projector_4: typeof Handle_VrmlConverter_Projector_4;
  VrmlConverter_Projector: typeof VrmlConverter_Projector;
  VrmlConverter_WFDeflectionShape: typeof VrmlConverter_WFDeflectionShape;
  VrmlConverter_WFShape: typeof VrmlConverter_WFShape;
  VrmlConverter_DeflectionCurve: typeof VrmlConverter_DeflectionCurve;
  VrmlConverter_LineAspect: typeof VrmlConverter_LineAspect;
  VrmlConverter_LineAspect_1: typeof VrmlConverter_LineAspect_1;
  VrmlConverter_LineAspect_2: typeof VrmlConverter_LineAspect_2;
  Handle_VrmlConverter_LineAspect: typeof Handle_VrmlConverter_LineAspect;
  Handle_VrmlConverter_LineAspect_1: typeof Handle_VrmlConverter_LineAspect_1;
  Handle_VrmlConverter_LineAspect_2: typeof Handle_VrmlConverter_LineAspect_2;
  Handle_VrmlConverter_LineAspect_3: typeof Handle_VrmlConverter_LineAspect_3;
  Handle_VrmlConverter_LineAspect_4: typeof Handle_VrmlConverter_LineAspect_4;
  VrmlConverter_WFDeflectionRestrictedFace: typeof VrmlConverter_WFDeflectionRestrictedFace;
  VrmlConverter_ShadingAspect: typeof VrmlConverter_ShadingAspect;
  Handle_VrmlConverter_ShadingAspect: typeof Handle_VrmlConverter_ShadingAspect;
  Handle_VrmlConverter_ShadingAspect_1: typeof Handle_VrmlConverter_ShadingAspect_1;
  Handle_VrmlConverter_ShadingAspect_2: typeof Handle_VrmlConverter_ShadingAspect_2;
  Handle_VrmlConverter_ShadingAspect_3: typeof Handle_VrmlConverter_ShadingAspect_3;
  Handle_VrmlConverter_ShadingAspect_4: typeof Handle_VrmlConverter_ShadingAspect_4;
  GeomTools_SurfaceSet: typeof GeomTools_SurfaceSet;
  Handle_GeomTools_UndefinedTypeHandler: typeof Handle_GeomTools_UndefinedTypeHandler;
  Handle_GeomTools_UndefinedTypeHandler_1: typeof Handle_GeomTools_UndefinedTypeHandler_1;
  Handle_GeomTools_UndefinedTypeHandler_2: typeof Handle_GeomTools_UndefinedTypeHandler_2;
  Handle_GeomTools_UndefinedTypeHandler_3: typeof Handle_GeomTools_UndefinedTypeHandler_3;
  Handle_GeomTools_UndefinedTypeHandler_4: typeof Handle_GeomTools_UndefinedTypeHandler_4;
  GeomTools_CurveSet: typeof GeomTools_CurveSet;
  GeomTools: typeof GeomTools;
  GeomTools_Curve2dSet: typeof GeomTools_Curve2dSet;
  Handle_MAT_TListNodeOfListOfEdge: typeof Handle_MAT_TListNodeOfListOfEdge;
  Handle_MAT_TListNodeOfListOfEdge_1: typeof Handle_MAT_TListNodeOfListOfEdge_1;
  Handle_MAT_TListNodeOfListOfEdge_2: typeof Handle_MAT_TListNodeOfListOfEdge_2;
  Handle_MAT_TListNodeOfListOfEdge_3: typeof Handle_MAT_TListNodeOfListOfEdge_3;
  Handle_MAT_TListNodeOfListOfEdge_4: typeof Handle_MAT_TListNodeOfListOfEdge_4;
  MAT_TListNodeOfListOfEdge: typeof MAT_TListNodeOfListOfEdge;
  MAT_TListNodeOfListOfEdge_1: typeof MAT_TListNodeOfListOfEdge_1;
  MAT_TListNodeOfListOfEdge_2: typeof MAT_TListNodeOfListOfEdge_2;
  Handle_MAT_Graph: typeof Handle_MAT_Graph;
  Handle_MAT_Graph_1: typeof Handle_MAT_Graph_1;
  Handle_MAT_Graph_2: typeof Handle_MAT_Graph_2;
  Handle_MAT_Graph_3: typeof Handle_MAT_Graph_3;
  Handle_MAT_Graph_4: typeof Handle_MAT_Graph_4;
  MAT_Graph: typeof MAT_Graph;
  MAT_ListOfEdge: typeof MAT_ListOfEdge;
  Handle_MAT_ListOfEdge: typeof Handle_MAT_ListOfEdge;
  Handle_MAT_ListOfEdge_1: typeof Handle_MAT_ListOfEdge_1;
  Handle_MAT_ListOfEdge_2: typeof Handle_MAT_ListOfEdge_2;
  Handle_MAT_ListOfEdge_3: typeof Handle_MAT_ListOfEdge_3;
  Handle_MAT_ListOfEdge_4: typeof Handle_MAT_ListOfEdge_4;
  Handle_MAT_Bisector: typeof Handle_MAT_Bisector;
  Handle_MAT_Bisector_1: typeof Handle_MAT_Bisector_1;
  Handle_MAT_Bisector_2: typeof Handle_MAT_Bisector_2;
  Handle_MAT_Bisector_3: typeof Handle_MAT_Bisector_3;
  Handle_MAT_Bisector_4: typeof Handle_MAT_Bisector_4;
  MAT_Bisector: typeof MAT_Bisector;
  Handle_MAT_TListNodeOfListOfBisector: typeof Handle_MAT_TListNodeOfListOfBisector;
  Handle_MAT_TListNodeOfListOfBisector_1: typeof Handle_MAT_TListNodeOfListOfBisector_1;
  Handle_MAT_TListNodeOfListOfBisector_2: typeof Handle_MAT_TListNodeOfListOfBisector_2;
  Handle_MAT_TListNodeOfListOfBisector_3: typeof Handle_MAT_TListNodeOfListOfBisector_3;
  Handle_MAT_TListNodeOfListOfBisector_4: typeof Handle_MAT_TListNodeOfListOfBisector_4;
  MAT_TListNodeOfListOfBisector: typeof MAT_TListNodeOfListOfBisector;
  MAT_TListNodeOfListOfBisector_1: typeof MAT_TListNodeOfListOfBisector_1;
  MAT_TListNodeOfListOfBisector_2: typeof MAT_TListNodeOfListOfBisector_2;
  Handle_MAT_Node: typeof Handle_MAT_Node;
  Handle_MAT_Node_1: typeof Handle_MAT_Node_1;
  Handle_MAT_Node_2: typeof Handle_MAT_Node_2;
  Handle_MAT_Node_3: typeof Handle_MAT_Node_3;
  Handle_MAT_Node_4: typeof Handle_MAT_Node_4;
  MAT_Node: typeof MAT_Node;
  MAT_Zone: typeof MAT_Zone;
  MAT_Zone_1: typeof MAT_Zone_1;
  MAT_Zone_2: typeof MAT_Zone_2;
  Handle_MAT_Zone: typeof Handle_MAT_Zone;
  Handle_MAT_Zone_1: typeof Handle_MAT_Zone_1;
  Handle_MAT_Zone_2: typeof Handle_MAT_Zone_2;
  Handle_MAT_Zone_3: typeof Handle_MAT_Zone_3;
  Handle_MAT_Zone_4: typeof Handle_MAT_Zone_4;
  MAT_ListOfBisector: typeof MAT_ListOfBisector;
  Handle_MAT_ListOfBisector: typeof Handle_MAT_ListOfBisector;
  Handle_MAT_ListOfBisector_1: typeof Handle_MAT_ListOfBisector_1;
  Handle_MAT_ListOfBisector_2: typeof Handle_MAT_ListOfBisector_2;
  Handle_MAT_ListOfBisector_3: typeof Handle_MAT_ListOfBisector_3;
  Handle_MAT_ListOfBisector_4: typeof Handle_MAT_ListOfBisector_4;
  MAT_Side: MAT_Side;
  MAT_BasicElt: typeof MAT_BasicElt;
  Handle_MAT_BasicElt: typeof Handle_MAT_BasicElt;
  Handle_MAT_BasicElt_1: typeof Handle_MAT_BasicElt_1;
  Handle_MAT_BasicElt_2: typeof Handle_MAT_BasicElt_2;
  Handle_MAT_BasicElt_3: typeof Handle_MAT_BasicElt_3;
  Handle_MAT_BasicElt_4: typeof Handle_MAT_BasicElt_4;
  Handle_MAT_Edge: typeof Handle_MAT_Edge;
  Handle_MAT_Edge_1: typeof Handle_MAT_Edge_1;
  Handle_MAT_Edge_2: typeof Handle_MAT_Edge_2;
  Handle_MAT_Edge_3: typeof Handle_MAT_Edge_3;
  Handle_MAT_Edge_4: typeof Handle_MAT_Edge_4;
  MAT_Edge: typeof MAT_Edge;
  MAT_Arc: typeof MAT_Arc;
  Handle_MAT_Arc: typeof Handle_MAT_Arc;
  Handle_MAT_Arc_1: typeof Handle_MAT_Arc_1;
  Handle_MAT_Arc_2: typeof Handle_MAT_Arc_2;
  Handle_MAT_Arc_3: typeof Handle_MAT_Arc_3;
  Handle_MAT_Arc_4: typeof Handle_MAT_Arc_4;
  StdLPersistent_NamedData: typeof StdLPersistent_NamedData;
  StdLPersistent_Void: typeof StdLPersistent_Void;
  StdLPersistent_Data: typeof StdLPersistent_Data;
  StdLPersistent: typeof StdLPersistent;
  StdLPersistent_Document: typeof StdLPersistent_Document;
  StdLPersistent_Value: typeof StdLPersistent_Value;
  StdLPersistent_HString: typeof StdLPersistent_HString;
  StdLPersistent_Dependency: typeof StdLPersistent_Dependency;
  StdLPersistent_Real: typeof StdLPersistent_Real;
  StdLPersistent_XLink: typeof StdLPersistent_XLink;
  StdLPersistent_Variable: typeof StdLPersistent_Variable;
  StdLPersistent_Collection: typeof StdLPersistent_Collection;
  StdLPersistent_HArray1: typeof StdLPersistent_HArray1;
  Handle_StdLPersistent_HArray1OfPersistent: typeof Handle_StdLPersistent_HArray1OfPersistent;
  Handle_StdLPersistent_HArray1OfPersistent_1: typeof Handle_StdLPersistent_HArray1OfPersistent_1;
  Handle_StdLPersistent_HArray1OfPersistent_2: typeof Handle_StdLPersistent_HArray1OfPersistent_2;
  Handle_StdLPersistent_HArray1OfPersistent_3: typeof Handle_StdLPersistent_HArray1OfPersistent_3;
  Handle_StdLPersistent_HArray1OfPersistent_4: typeof Handle_StdLPersistent_HArray1OfPersistent_4;
  StdLPersistent_Function: typeof StdLPersistent_Function;
  Handle_StdLPersistent_HArray2OfPersistent: typeof Handle_StdLPersistent_HArray2OfPersistent;
  Handle_StdLPersistent_HArray2OfPersistent_1: typeof Handle_StdLPersistent_HArray2OfPersistent_1;
  Handle_StdLPersistent_HArray2OfPersistent_2: typeof Handle_StdLPersistent_HArray2OfPersistent_2;
  Handle_StdLPersistent_HArray2OfPersistent_3: typeof Handle_StdLPersistent_HArray2OfPersistent_3;
  Handle_StdLPersistent_HArray2OfPersistent_4: typeof Handle_StdLPersistent_HArray2OfPersistent_4;
  StdLPersistent_HArray2: typeof StdLPersistent_HArray2;
  StdLPersistent_TreeNode: typeof StdLPersistent_TreeNode;
  Handle_GeomEvaluator_Surface: typeof Handle_GeomEvaluator_Surface;
  Handle_GeomEvaluator_Surface_1: typeof Handle_GeomEvaluator_Surface_1;
  Handle_GeomEvaluator_Surface_2: typeof Handle_GeomEvaluator_Surface_2;
  Handle_GeomEvaluator_Surface_3: typeof Handle_GeomEvaluator_Surface_3;
  Handle_GeomEvaluator_Surface_4: typeof Handle_GeomEvaluator_Surface_4;
  GeomEvaluator_Surface: typeof GeomEvaluator_Surface;
  GeomEvaluator_Curve: typeof GeomEvaluator_Curve;
  Handle_GeomEvaluator_Curve: typeof Handle_GeomEvaluator_Curve;
  Handle_GeomEvaluator_Curve_1: typeof Handle_GeomEvaluator_Curve_1;
  Handle_GeomEvaluator_Curve_2: typeof Handle_GeomEvaluator_Curve_2;
  Handle_GeomEvaluator_Curve_3: typeof Handle_GeomEvaluator_Curve_3;
  Handle_GeomEvaluator_Curve_4: typeof Handle_GeomEvaluator_Curve_4;
  GeomEvaluator_SurfaceOfExtrusion: typeof GeomEvaluator_SurfaceOfExtrusion;
  GeomEvaluator_SurfaceOfExtrusion_1: typeof GeomEvaluator_SurfaceOfExtrusion_1;
  GeomEvaluator_SurfaceOfExtrusion_2: typeof GeomEvaluator_SurfaceOfExtrusion_2;
  Handle_GeomEvaluator_SurfaceOfExtrusion: typeof Handle_GeomEvaluator_SurfaceOfExtrusion;
  Handle_GeomEvaluator_SurfaceOfExtrusion_1: typeof Handle_GeomEvaluator_SurfaceOfExtrusion_1;
  Handle_GeomEvaluator_SurfaceOfExtrusion_2: typeof Handle_GeomEvaluator_SurfaceOfExtrusion_2;
  Handle_GeomEvaluator_SurfaceOfExtrusion_3: typeof Handle_GeomEvaluator_SurfaceOfExtrusion_3;
  Handle_GeomEvaluator_SurfaceOfExtrusion_4: typeof Handle_GeomEvaluator_SurfaceOfExtrusion_4;
  Handle_GeomEvaluator_OffsetCurve: typeof Handle_GeomEvaluator_OffsetCurve;
  Handle_GeomEvaluator_OffsetCurve_1: typeof Handle_GeomEvaluator_OffsetCurve_1;
  Handle_GeomEvaluator_OffsetCurve_2: typeof Handle_GeomEvaluator_OffsetCurve_2;
  Handle_GeomEvaluator_OffsetCurve_3: typeof Handle_GeomEvaluator_OffsetCurve_3;
  Handle_GeomEvaluator_OffsetCurve_4: typeof Handle_GeomEvaluator_OffsetCurve_4;
  GeomEvaluator_OffsetCurve: typeof GeomEvaluator_OffsetCurve;
  GeomEvaluator_OffsetCurve_1: typeof GeomEvaluator_OffsetCurve_1;
  GeomEvaluator_OffsetCurve_2: typeof GeomEvaluator_OffsetCurve_2;
  GeomEvaluator_SurfaceOfRevolution: typeof GeomEvaluator_SurfaceOfRevolution;
  GeomEvaluator_SurfaceOfRevolution_1: typeof GeomEvaluator_SurfaceOfRevolution_1;
  GeomEvaluator_SurfaceOfRevolution_2: typeof GeomEvaluator_SurfaceOfRevolution_2;
  Handle_GeomEvaluator_SurfaceOfRevolution: typeof Handle_GeomEvaluator_SurfaceOfRevolution;
  Handle_GeomEvaluator_SurfaceOfRevolution_1: typeof Handle_GeomEvaluator_SurfaceOfRevolution_1;
  Handle_GeomEvaluator_SurfaceOfRevolution_2: typeof Handle_GeomEvaluator_SurfaceOfRevolution_2;
  Handle_GeomEvaluator_SurfaceOfRevolution_3: typeof Handle_GeomEvaluator_SurfaceOfRevolution_3;
  Handle_GeomEvaluator_SurfaceOfRevolution_4: typeof Handle_GeomEvaluator_SurfaceOfRevolution_4;
  GeomEvaluator_OffsetSurface: typeof GeomEvaluator_OffsetSurface;
  GeomEvaluator_OffsetSurface_1: typeof GeomEvaluator_OffsetSurface_1;
  GeomEvaluator_OffsetSurface_2: typeof GeomEvaluator_OffsetSurface_2;
  Handle_GeomEvaluator_OffsetSurface: typeof Handle_GeomEvaluator_OffsetSurface;
  Handle_GeomEvaluator_OffsetSurface_1: typeof Handle_GeomEvaluator_OffsetSurface_1;
  Handle_GeomEvaluator_OffsetSurface_2: typeof Handle_GeomEvaluator_OffsetSurface_2;
  Handle_GeomEvaluator_OffsetSurface_3: typeof Handle_GeomEvaluator_OffsetSurface_3;
  Handle_GeomEvaluator_OffsetSurface_4: typeof Handle_GeomEvaluator_OffsetSurface_4;
  Handle_ShapeBuild_ReShape: typeof Handle_ShapeBuild_ReShape;
  Handle_ShapeBuild_ReShape_1: typeof Handle_ShapeBuild_ReShape_1;
  Handle_ShapeBuild_ReShape_2: typeof Handle_ShapeBuild_ReShape_2;
  Handle_ShapeBuild_ReShape_3: typeof Handle_ShapeBuild_ReShape_3;
  Handle_ShapeBuild_ReShape_4: typeof Handle_ShapeBuild_ReShape_4;
  ShapeBuild_ReShape: typeof ShapeBuild_ReShape;
  ShapeBuild_Edge: typeof ShapeBuild_Edge;
  ShapeBuild: typeof ShapeBuild;
  ShapeBuild_Vertex: typeof ShapeBuild_Vertex;
  RWObj_Material: typeof RWObj_Material;
  RWObj_SubMesh: typeof RWObj_SubMesh;
  RWObj_MtlReader: typeof RWObj_MtlReader;
  RWObj: typeof RWObj;
  RWObj_CafReader: typeof RWObj_CafReader;
  RWObj_SubMeshReason: RWObj_SubMeshReason;
  RWObj_IShapeReceiver: typeof RWObj_IShapeReceiver;
  RWObj_TriangulationReader: typeof RWObj_TriangulationReader;
  RWObj_Reader: typeof RWObj_Reader;
  Geom2dGcc_CurveTool: typeof Geom2dGcc_CurveTool;
  Geom2dGcc_Circ2d2TanRad: typeof Geom2dGcc_Circ2d2TanRad;
  Geom2dGcc_Circ2d2TanRad_1: typeof Geom2dGcc_Circ2d2TanRad_1;
  Geom2dGcc_Circ2d2TanRad_2: typeof Geom2dGcc_Circ2d2TanRad_2;
  Geom2dGcc_Circ2d2TanRad_3: typeof Geom2dGcc_Circ2d2TanRad_3;
  Geom2dGcc_Lin2dTanOblIter: typeof Geom2dGcc_Lin2dTanOblIter;
  Geom2dGcc_Circ2d3TanIter: typeof Geom2dGcc_Circ2d3TanIter;
  Geom2dGcc_Circ2d3TanIter_1: typeof Geom2dGcc_Circ2d3TanIter_1;
  Geom2dGcc_Circ2d3TanIter_2: typeof Geom2dGcc_Circ2d3TanIter_2;
  Geom2dGcc_Circ2d3TanIter_3: typeof Geom2dGcc_Circ2d3TanIter_3;
  Geom2dGcc_Circ2d3TanIter_4: typeof Geom2dGcc_Circ2d3TanIter_4;
  Geom2dGcc_Circ2d3TanIter_5: typeof Geom2dGcc_Circ2d3TanIter_5;
  Geom2dGcc_Circ2d3TanIter_6: typeof Geom2dGcc_Circ2d3TanIter_6;
  Geom2dGcc_Circ2d3TanIter_7: typeof Geom2dGcc_Circ2d3TanIter_7;
  Geom2dGcc_Circ2d3TanIter_8: typeof Geom2dGcc_Circ2d3TanIter_8;
  Geom2dGcc_Circ2d3TanIter_9: typeof Geom2dGcc_Circ2d3TanIter_9;
  Geom2dGcc_Circ2d3TanIter_10: typeof Geom2dGcc_Circ2d3TanIter_10;
  Geom2dGcc_Type3: Geom2dGcc_Type3;
  Geom2dGcc_Circ2d2TanRadGeo: typeof Geom2dGcc_Circ2d2TanRadGeo;
  Geom2dGcc_Circ2d2TanRadGeo_1: typeof Geom2dGcc_Circ2d2TanRadGeo_1;
  Geom2dGcc_Circ2d2TanRadGeo_2: typeof Geom2dGcc_Circ2d2TanRadGeo_2;
  Geom2dGcc_Circ2d2TanRadGeo_3: typeof Geom2dGcc_Circ2d2TanRadGeo_3;
  Geom2dGcc_Circ2d2TanRadGeo_4: typeof Geom2dGcc_Circ2d2TanRadGeo_4;
  Geom2dGcc_QCurve: typeof Geom2dGcc_QCurve;
  Geom2dGcc_Circ2d3Tan: typeof Geom2dGcc_Circ2d3Tan;
  Geom2dGcc_Circ2d3Tan_1: typeof Geom2dGcc_Circ2d3Tan_1;
  Geom2dGcc_Circ2d3Tan_2: typeof Geom2dGcc_Circ2d3Tan_2;
  Geom2dGcc_Circ2d3Tan_3: typeof Geom2dGcc_Circ2d3Tan_3;
  Geom2dGcc_Circ2d3Tan_4: typeof Geom2dGcc_Circ2d3Tan_4;
  Geom2dGcc_Circ2dTanOnRadGeo: typeof Geom2dGcc_Circ2dTanOnRadGeo;
  Geom2dGcc_Circ2dTanOnRadGeo_1: typeof Geom2dGcc_Circ2dTanOnRadGeo_1;
  Geom2dGcc_Circ2dTanOnRadGeo_2: typeof Geom2dGcc_Circ2dTanOnRadGeo_2;
  Geom2dGcc_Circ2dTanOnRadGeo_3: typeof Geom2dGcc_Circ2dTanOnRadGeo_3;
  Geom2dGcc_Circ2dTanOnRadGeo_4: typeof Geom2dGcc_Circ2dTanOnRadGeo_4;
  Geom2dGcc_Circ2dTanOnRadGeo_5: typeof Geom2dGcc_Circ2dTanOnRadGeo_5;
  Geom2dGcc_Circ2dTanOnRadGeo_6: typeof Geom2dGcc_Circ2dTanOnRadGeo_6;
  Geom2dGcc_Type2: Geom2dGcc_Type2;
  Geom2dGcc_Circ2d2TanOnGeo: typeof Geom2dGcc_Circ2d2TanOnGeo;
  Geom2dGcc_Circ2d2TanOnGeo_1: typeof Geom2dGcc_Circ2d2TanOnGeo_1;
  Geom2dGcc_Circ2d2TanOnGeo_2: typeof Geom2dGcc_Circ2d2TanOnGeo_2;
  Geom2dGcc_Circ2d2TanOnGeo_3: typeof Geom2dGcc_Circ2d2TanOnGeo_3;
  Geom2dGcc_Circ2d2TanOnGeo_4: typeof Geom2dGcc_Circ2d2TanOnGeo_4;
  Geom2dGcc_Circ2d2TanOnGeo_5: typeof Geom2dGcc_Circ2d2TanOnGeo_5;
  Geom2dGcc_Circ2d2TanOnGeo_6: typeof Geom2dGcc_Circ2d2TanOnGeo_6;
  Geom2dGcc_Circ2dTanOnRad: typeof Geom2dGcc_Circ2dTanOnRad;
  Geom2dGcc_Circ2dTanOnRad_1: typeof Geom2dGcc_Circ2dTanOnRad_1;
  Geom2dGcc_Circ2dTanOnRad_2: typeof Geom2dGcc_Circ2dTanOnRad_2;
  Geom2dGcc_Lin2d2Tan: typeof Geom2dGcc_Lin2d2Tan;
  Geom2dGcc_Lin2d2Tan_1: typeof Geom2dGcc_Lin2d2Tan_1;
  Geom2dGcc_Lin2d2Tan_2: typeof Geom2dGcc_Lin2d2Tan_2;
  Geom2dGcc_Lin2d2Tan_3: typeof Geom2dGcc_Lin2d2Tan_3;
  Geom2dGcc_Lin2d2Tan_4: typeof Geom2dGcc_Lin2d2Tan_4;
  Geom2dGcc_IsParallel: typeof Geom2dGcc_IsParallel;
  Geom2dGcc_IsParallel_1: typeof Geom2dGcc_IsParallel_1;
  Geom2dGcc_IsParallel_2: typeof Geom2dGcc_IsParallel_2;
  Handle_Geom2dGcc_IsParallel: typeof Handle_Geom2dGcc_IsParallel;
  Handle_Geom2dGcc_IsParallel_1: typeof Handle_Geom2dGcc_IsParallel_1;
  Handle_Geom2dGcc_IsParallel_2: typeof Handle_Geom2dGcc_IsParallel_2;
  Handle_Geom2dGcc_IsParallel_3: typeof Handle_Geom2dGcc_IsParallel_3;
  Handle_Geom2dGcc_IsParallel_4: typeof Handle_Geom2dGcc_IsParallel_4;
  Geom2dGcc_FunctionTanObl: typeof Geom2dGcc_FunctionTanObl;
  Geom2dGcc_FunctionTanCirCu: typeof Geom2dGcc_FunctionTanCirCu;
  Geom2dGcc_Lin2dTanObl: typeof Geom2dGcc_Lin2dTanObl;
  Geom2dGcc_Lin2dTanObl_1: typeof Geom2dGcc_Lin2dTanObl_1;
  Geom2dGcc_Lin2dTanObl_2: typeof Geom2dGcc_Lin2dTanObl_2;
  Geom2dGcc_Circ2d2TanOnIter: typeof Geom2dGcc_Circ2d2TanOnIter;
  Geom2dGcc_Circ2d2TanOnIter_1: typeof Geom2dGcc_Circ2d2TanOnIter_1;
  Geom2dGcc_Circ2d2TanOnIter_2: typeof Geom2dGcc_Circ2d2TanOnIter_2;
  Geom2dGcc_Circ2d2TanOnIter_3: typeof Geom2dGcc_Circ2d2TanOnIter_3;
  Geom2dGcc_Circ2d2TanOnIter_4: typeof Geom2dGcc_Circ2d2TanOnIter_4;
  Geom2dGcc_Circ2d2TanOnIter_5: typeof Geom2dGcc_Circ2d2TanOnIter_5;
  Geom2dGcc_Circ2d2TanOnIter_6: typeof Geom2dGcc_Circ2d2TanOnIter_6;
  Geom2dGcc_Circ2d2TanOnIter_7: typeof Geom2dGcc_Circ2d2TanOnIter_7;
  Geom2dGcc_Circ2d2TanOnIter_8: typeof Geom2dGcc_Circ2d2TanOnIter_8;
  Geom2dGcc_Circ2d2TanOnIter_9: typeof Geom2dGcc_Circ2d2TanOnIter_9;
  Geom2dGcc_Circ2d2TanOnIter_10: typeof Geom2dGcc_Circ2d2TanOnIter_10;
  Geom2dGcc_Circ2d2TanOnIter_11: typeof Geom2dGcc_Circ2d2TanOnIter_11;
  Geom2dGcc_Circ2d2TanOnIter_12: typeof Geom2dGcc_Circ2d2TanOnIter_12;
  Geom2dGcc_Circ2d2TanOn: typeof Geom2dGcc_Circ2d2TanOn;
  Geom2dGcc_Circ2d2TanOn_1: typeof Geom2dGcc_Circ2d2TanOn_1;
  Geom2dGcc_Circ2d2TanOn_2: typeof Geom2dGcc_Circ2d2TanOn_2;
  Geom2dGcc_Circ2d2TanOn_3: typeof Geom2dGcc_Circ2d2TanOn_3;
  Geom2dGcc_Circ2dTanCen: typeof Geom2dGcc_Circ2dTanCen;
  Geom2dGcc_Type1: Geom2dGcc_Type1;
  Geom2dGcc_FunctionTanCuCuOnCu: typeof Geom2dGcc_FunctionTanCuCuOnCu;
  Geom2dGcc_FunctionTanCuCuOnCu_1: typeof Geom2dGcc_FunctionTanCuCuOnCu_1;
  Geom2dGcc_FunctionTanCuCuOnCu_2: typeof Geom2dGcc_FunctionTanCuCuOnCu_2;
  Geom2dGcc_FunctionTanCuCuOnCu_3: typeof Geom2dGcc_FunctionTanCuCuOnCu_3;
  Geom2dGcc_FunctionTanCuCuOnCu_4: typeof Geom2dGcc_FunctionTanCuCuOnCu_4;
  Geom2dGcc_FunctionTanCuCuOnCu_5: typeof Geom2dGcc_FunctionTanCuCuOnCu_5;
  Geom2dGcc_FunctionTanCuCuOnCu_6: typeof Geom2dGcc_FunctionTanCuCuOnCu_6;
  Geom2dGcc_FunctionTanCuCuOnCu_7: typeof Geom2dGcc_FunctionTanCuCuOnCu_7;
  Geom2dGcc_FunctionTanCuCuOnCu_8: typeof Geom2dGcc_FunctionTanCuCuOnCu_8;
  Geom2dGcc_FunctionTanCuCuOnCu_9: typeof Geom2dGcc_FunctionTanCuCuOnCu_9;
  Geom2dGcc_FunctionTanCuCuOnCu_10: typeof Geom2dGcc_FunctionTanCuCuOnCu_10;
  Geom2dGcc_FunctionTanCuCuOnCu_11: typeof Geom2dGcc_FunctionTanCuCuOnCu_11;
  Geom2dGcc_FunctionTanCuCuOnCu_12: typeof Geom2dGcc_FunctionTanCuCuOnCu_12;
  Geom2dGcc_FunctionTanCuCu: typeof Geom2dGcc_FunctionTanCuCu;
  Geom2dGcc_FunctionTanCuCu_1: typeof Geom2dGcc_FunctionTanCuCu_1;
  Geom2dGcc_FunctionTanCuCu_2: typeof Geom2dGcc_FunctionTanCuCu_2;
  Geom2dGcc_Lin2d2TanIter: typeof Geom2dGcc_Lin2d2TanIter;
  Geom2dGcc_Lin2d2TanIter_1: typeof Geom2dGcc_Lin2d2TanIter_1;
  Geom2dGcc_Lin2d2TanIter_2: typeof Geom2dGcc_Lin2d2TanIter_2;
  Geom2dGcc_Lin2d2TanIter_3: typeof Geom2dGcc_Lin2d2TanIter_3;
  Geom2dGcc_Circ2dTanCenGeo: typeof Geom2dGcc_Circ2dTanCenGeo;
  Geom2dGcc_FunctionTanCuPnt: typeof Geom2dGcc_FunctionTanCuPnt;
  Geom2dGcc: typeof Geom2dGcc;
  Geom2dGcc_QualifiedCurve: typeof Geom2dGcc_QualifiedCurve;
  XmlLDrivers_DocumentRetrievalDriver: typeof XmlLDrivers_DocumentRetrievalDriver;
  Handle_XmlLDrivers_DocumentRetrievalDriver: typeof Handle_XmlLDrivers_DocumentRetrievalDriver;
  Handle_XmlLDrivers_DocumentRetrievalDriver_1: typeof Handle_XmlLDrivers_DocumentRetrievalDriver_1;
  Handle_XmlLDrivers_DocumentRetrievalDriver_2: typeof Handle_XmlLDrivers_DocumentRetrievalDriver_2;
  Handle_XmlLDrivers_DocumentRetrievalDriver_3: typeof Handle_XmlLDrivers_DocumentRetrievalDriver_3;
  Handle_XmlLDrivers_DocumentRetrievalDriver_4: typeof Handle_XmlLDrivers_DocumentRetrievalDriver_4;
  XmlLDrivers_DocumentStorageDriver: typeof XmlLDrivers_DocumentStorageDriver;
  Handle_XmlLDrivers_DocumentStorageDriver: typeof Handle_XmlLDrivers_DocumentStorageDriver;
  Handle_XmlLDrivers_DocumentStorageDriver_1: typeof Handle_XmlLDrivers_DocumentStorageDriver_1;
  Handle_XmlLDrivers_DocumentStorageDriver_2: typeof Handle_XmlLDrivers_DocumentStorageDriver_2;
  Handle_XmlLDrivers_DocumentStorageDriver_3: typeof Handle_XmlLDrivers_DocumentStorageDriver_3;
  Handle_XmlLDrivers_DocumentStorageDriver_4: typeof Handle_XmlLDrivers_DocumentStorageDriver_4;
  XmlLDrivers: typeof XmlLDrivers;
  XmlLDrivers_NamespaceDef: typeof XmlLDrivers_NamespaceDef;
  XmlLDrivers_NamespaceDef_1: typeof XmlLDrivers_NamespaceDef_1;
  XmlLDrivers_NamespaceDef_2: typeof XmlLDrivers_NamespaceDef_2;
  XmlLDrivers_SequenceOfNamespaceDef: typeof XmlLDrivers_SequenceOfNamespaceDef;
  XmlLDrivers_SequenceOfNamespaceDef_1: typeof XmlLDrivers_SequenceOfNamespaceDef_1;
  XmlLDrivers_SequenceOfNamespaceDef_2: typeof XmlLDrivers_SequenceOfNamespaceDef_2;
  XmlLDrivers_SequenceOfNamespaceDef_3: typeof XmlLDrivers_SequenceOfNamespaceDef_3;
  BVH_TreeBaseTransient: typeof BVH_TreeBaseTransient;
  BVH_BinaryTree: typeof BVH_BinaryTree;
  BVH_QuadTree: typeof BVH_QuadTree;
  BVH_Properties: typeof BVH_Properties;
  BVH_BuildThread: typeof BVH_BuildThread;
  BVH_BuildTool: typeof BVH_BuildTool;
  Handle_BVH_BuildThread: typeof Handle_BVH_BuildThread;
  Handle_BVH_BuildThread_1: typeof Handle_BVH_BuildThread_1;
  Handle_BVH_BuildThread_2: typeof Handle_BVH_BuildThread_2;
  Handle_BVH_BuildThread_3: typeof Handle_BVH_BuildThread_3;
  Handle_BVH_BuildThread_4: typeof Handle_BVH_BuildThread_4;
  BVH_ObjectTransient: typeof BVH_ObjectTransient;
  BVH_BuilderTransient: typeof BVH_BuilderTransient;
  BVH_BuildQueue: typeof BVH_BuildQueue;
  GccEnt_QualifiedLin: typeof GccEnt_QualifiedLin;
  GccEnt_Position: GccEnt_Position;
  GccEnt_BadQualifier: typeof GccEnt_BadQualifier;
  GccEnt_BadQualifier_1: typeof GccEnt_BadQualifier_1;
  GccEnt_BadQualifier_2: typeof GccEnt_BadQualifier_2;
  Handle_GccEnt_BadQualifier: typeof Handle_GccEnt_BadQualifier;
  Handle_GccEnt_BadQualifier_1: typeof Handle_GccEnt_BadQualifier_1;
  Handle_GccEnt_BadQualifier_2: typeof Handle_GccEnt_BadQualifier_2;
  Handle_GccEnt_BadQualifier_3: typeof Handle_GccEnt_BadQualifier_3;
  Handle_GccEnt_BadQualifier_4: typeof Handle_GccEnt_BadQualifier_4;
  GccEnt: typeof GccEnt;
  GccEnt_Array1OfPosition: typeof GccEnt_Array1OfPosition;
  GccEnt_Array1OfPosition_1: typeof GccEnt_Array1OfPosition_1;
  GccEnt_Array1OfPosition_2: typeof GccEnt_Array1OfPosition_2;
  GccEnt_Array1OfPosition_3: typeof GccEnt_Array1OfPosition_3;
  GccEnt_Array1OfPosition_4: typeof GccEnt_Array1OfPosition_4;
  GccEnt_Array1OfPosition_5: typeof GccEnt_Array1OfPosition_5;
  GccEnt_QualifiedCirc: typeof GccEnt_QualifiedCirc;
  BRepAlgoAPI_Section: typeof BRepAlgoAPI_Section;
  BRepAlgoAPI_Section_1: typeof BRepAlgoAPI_Section_1;
  BRepAlgoAPI_Section_2: typeof BRepAlgoAPI_Section_2;
  BRepAlgoAPI_Section_3: typeof BRepAlgoAPI_Section_3;
  BRepAlgoAPI_Section_4: typeof BRepAlgoAPI_Section_4;
  BRepAlgoAPI_Section_5: typeof BRepAlgoAPI_Section_5;
  BRepAlgoAPI_Section_6: typeof BRepAlgoAPI_Section_6;
  BRepAlgoAPI_Section_7: typeof BRepAlgoAPI_Section_7;
  BRepAlgoAPI_Section_8: typeof BRepAlgoAPI_Section_8;
  BRepAlgoAPI_BuilderAlgo: typeof BRepAlgoAPI_BuilderAlgo;
  BRepAlgoAPI_BuilderAlgo_1: typeof BRepAlgoAPI_BuilderAlgo_1;
  BRepAlgoAPI_BuilderAlgo_2: typeof BRepAlgoAPI_BuilderAlgo_2;
  BRepAlgoAPI_Defeaturing: typeof BRepAlgoAPI_Defeaturing;
  BRepAlgoAPI_BooleanOperation: typeof BRepAlgoAPI_BooleanOperation;
  BRepAlgoAPI_BooleanOperation_1: typeof BRepAlgoAPI_BooleanOperation_1;
  BRepAlgoAPI_BooleanOperation_2: typeof BRepAlgoAPI_BooleanOperation_2;
  BRepAlgoAPI_Common: typeof BRepAlgoAPI_Common;
  BRepAlgoAPI_Common_1: typeof BRepAlgoAPI_Common_1;
  BRepAlgoAPI_Common_2: typeof BRepAlgoAPI_Common_2;
  BRepAlgoAPI_Common_3: typeof BRepAlgoAPI_Common_3;
  BRepAlgoAPI_Common_4: typeof BRepAlgoAPI_Common_4;
  BRepAlgoAPI_Fuse: typeof BRepAlgoAPI_Fuse;
  BRepAlgoAPI_Fuse_1: typeof BRepAlgoAPI_Fuse_1;
  BRepAlgoAPI_Fuse_2: typeof BRepAlgoAPI_Fuse_2;
  BRepAlgoAPI_Fuse_3: typeof BRepAlgoAPI_Fuse_3;
  BRepAlgoAPI_Fuse_4: typeof BRepAlgoAPI_Fuse_4;
  BRepAlgoAPI_Algo: typeof BRepAlgoAPI_Algo;
  BRepAlgoAPI_Cut: typeof BRepAlgoAPI_Cut;
  BRepAlgoAPI_Cut_1: typeof BRepAlgoAPI_Cut_1;
  BRepAlgoAPI_Cut_2: typeof BRepAlgoAPI_Cut_2;
  BRepAlgoAPI_Cut_3: typeof BRepAlgoAPI_Cut_3;
  BRepAlgoAPI_Cut_4: typeof BRepAlgoAPI_Cut_4;
  BRepAlgoAPI_Splitter: typeof BRepAlgoAPI_Splitter;
  BRepAlgoAPI_Splitter_1: typeof BRepAlgoAPI_Splitter_1;
  BRepAlgoAPI_Splitter_2: typeof BRepAlgoAPI_Splitter_2;
  BRepAlgoAPI_Check: typeof BRepAlgoAPI_Check;
  BRepAlgoAPI_Check_1: typeof BRepAlgoAPI_Check_1;
  BRepAlgoAPI_Check_2: typeof BRepAlgoAPI_Check_2;
  BRepAlgoAPI_Check_3: typeof BRepAlgoAPI_Check_3;
  RWHeaderSection_RWFileSchema: typeof RWHeaderSection_RWFileSchema;
  RWHeaderSection_RWFileDescription: typeof RWHeaderSection_RWFileDescription;
  Handle_RWHeaderSection_GeneralModule: typeof Handle_RWHeaderSection_GeneralModule;
  Handle_RWHeaderSection_GeneralModule_1: typeof Handle_RWHeaderSection_GeneralModule_1;
  Handle_RWHeaderSection_GeneralModule_2: typeof Handle_RWHeaderSection_GeneralModule_2;
  Handle_RWHeaderSection_GeneralModule_3: typeof Handle_RWHeaderSection_GeneralModule_3;
  Handle_RWHeaderSection_GeneralModule_4: typeof Handle_RWHeaderSection_GeneralModule_4;
  RWHeaderSection_ReadWriteModule: typeof RWHeaderSection_ReadWriteModule;
  Handle_RWHeaderSection_ReadWriteModule: typeof Handle_RWHeaderSection_ReadWriteModule;
  Handle_RWHeaderSection_ReadWriteModule_1: typeof Handle_RWHeaderSection_ReadWriteModule_1;
  Handle_RWHeaderSection_ReadWriteModule_2: typeof Handle_RWHeaderSection_ReadWriteModule_2;
  Handle_RWHeaderSection_ReadWriteModule_3: typeof Handle_RWHeaderSection_ReadWriteModule_3;
  Handle_RWHeaderSection_ReadWriteModule_4: typeof Handle_RWHeaderSection_ReadWriteModule_4;
  RWHeaderSection: typeof RWHeaderSection;
  RWHeaderSection_RWFileName: typeof RWHeaderSection_RWFileName;
  Handle_MoniTool_TypedValue: typeof Handle_MoniTool_TypedValue;
  Handle_MoniTool_TypedValue_1: typeof Handle_MoniTool_TypedValue_1;
  Handle_MoniTool_TypedValue_2: typeof Handle_MoniTool_TypedValue_2;
  Handle_MoniTool_TypedValue_3: typeof Handle_MoniTool_TypedValue_3;
  Handle_MoniTool_TypedValue_4: typeof Handle_MoniTool_TypedValue_4;
  MoniTool_TypedValue: typeof MoniTool_TypedValue;
  MoniTool_TypedValue_1: typeof MoniTool_TypedValue_1;
  MoniTool_TypedValue_2: typeof MoniTool_TypedValue_2;
  MoniTool_DataInfo: typeof MoniTool_DataInfo;
  MoniTool_ElemHasher: typeof MoniTool_ElemHasher;
  MoniTool_TransientElem: typeof MoniTool_TransientElem;
  Handle_MoniTool_TransientElem: typeof Handle_MoniTool_TransientElem;
  Handle_MoniTool_TransientElem_1: typeof Handle_MoniTool_TransientElem_1;
  Handle_MoniTool_TransientElem_2: typeof Handle_MoniTool_TransientElem_2;
  Handle_MoniTool_TransientElem_3: typeof Handle_MoniTool_TransientElem_3;
  Handle_MoniTool_TransientElem_4: typeof Handle_MoniTool_TransientElem_4;
  MoniTool_MTHasher: typeof MoniTool_MTHasher;
  MoniTool_AttrList: typeof MoniTool_AttrList;
  MoniTool_AttrList_1: typeof MoniTool_AttrList_1;
  MoniTool_AttrList_2: typeof MoniTool_AttrList_2;
  MoniTool_ValueType: MoniTool_ValueType;
  MoniTool_TimerSentry: typeof MoniTool_TimerSentry;
  MoniTool_TimerSentry_1: typeof MoniTool_TimerSentry_1;
  MoniTool_TimerSentry_2: typeof MoniTool_TimerSentry_2;
  MoniTool_IntVal: typeof MoniTool_IntVal;
  Handle_MoniTool_IntVal: typeof Handle_MoniTool_IntVal;
  Handle_MoniTool_IntVal_1: typeof Handle_MoniTool_IntVal_1;
  Handle_MoniTool_IntVal_2: typeof Handle_MoniTool_IntVal_2;
  Handle_MoniTool_IntVal_3: typeof Handle_MoniTool_IntVal_3;
  Handle_MoniTool_IntVal_4: typeof Handle_MoniTool_IntVal_4;
  MoniTool_Stat: typeof MoniTool_Stat;
  MoniTool_Stat_1: typeof MoniTool_Stat_1;
  MoniTool_Stat_2: typeof MoniTool_Stat_2;
  Handle_MoniTool_Element: typeof Handle_MoniTool_Element;
  Handle_MoniTool_Element_1: typeof Handle_MoniTool_Element_1;
  Handle_MoniTool_Element_2: typeof Handle_MoniTool_Element_2;
  Handle_MoniTool_Element_3: typeof Handle_MoniTool_Element_3;
  Handle_MoniTool_Element_4: typeof Handle_MoniTool_Element_4;
  MoniTool_Element: typeof MoniTool_Element;
  MoniTool_RealVal: typeof MoniTool_RealVal;
  Handle_MoniTool_RealVal: typeof Handle_MoniTool_RealVal;
  Handle_MoniTool_RealVal_1: typeof Handle_MoniTool_RealVal_1;
  Handle_MoniTool_RealVal_2: typeof Handle_MoniTool_RealVal_2;
  Handle_MoniTool_RealVal_3: typeof Handle_MoniTool_RealVal_3;
  Handle_MoniTool_RealVal_4: typeof Handle_MoniTool_RealVal_4;
  Handle_MoniTool_HSequenceOfElement: typeof Handle_MoniTool_HSequenceOfElement;
  Handle_MoniTool_HSequenceOfElement_1: typeof Handle_MoniTool_HSequenceOfElement_1;
  Handle_MoniTool_HSequenceOfElement_2: typeof Handle_MoniTool_HSequenceOfElement_2;
  Handle_MoniTool_HSequenceOfElement_3: typeof Handle_MoniTool_HSequenceOfElement_3;
  Handle_MoniTool_HSequenceOfElement_4: typeof Handle_MoniTool_HSequenceOfElement_4;
  Handle_MoniTool_Timer: typeof Handle_MoniTool_Timer;
  Handle_MoniTool_Timer_1: typeof Handle_MoniTool_Timer_1;
  Handle_MoniTool_Timer_2: typeof Handle_MoniTool_Timer_2;
  Handle_MoniTool_Timer_3: typeof Handle_MoniTool_Timer_3;
  Handle_MoniTool_Timer_4: typeof Handle_MoniTool_Timer_4;
  MoniTool_Timer: typeof MoniTool_Timer;
  Handle_MoniTool_SignText: typeof Handle_MoniTool_SignText;
  Handle_MoniTool_SignText_1: typeof Handle_MoniTool_SignText_1;
  Handle_MoniTool_SignText_2: typeof Handle_MoniTool_SignText_2;
  Handle_MoniTool_SignText_3: typeof Handle_MoniTool_SignText_3;
  Handle_MoniTool_SignText_4: typeof Handle_MoniTool_SignText_4;
  MoniTool_SignText: typeof MoniTool_SignText;
  Handle_MoniTool_SignShape: typeof Handle_MoniTool_SignShape;
  Handle_MoniTool_SignShape_1: typeof Handle_MoniTool_SignShape_1;
  Handle_MoniTool_SignShape_2: typeof Handle_MoniTool_SignShape_2;
  Handle_MoniTool_SignShape_3: typeof Handle_MoniTool_SignShape_3;
  Handle_MoniTool_SignShape_4: typeof Handle_MoniTool_SignShape_4;
  MoniTool_SignShape: typeof MoniTool_SignShape;
  MoniTool_CaseData: typeof MoniTool_CaseData;
  Handle_MoniTool_CaseData: typeof Handle_MoniTool_CaseData;
  Handle_MoniTool_CaseData_1: typeof Handle_MoniTool_CaseData_1;
  Handle_MoniTool_CaseData_2: typeof Handle_MoniTool_CaseData_2;
  Handle_MoniTool_CaseData_3: typeof Handle_MoniTool_CaseData_3;
  Handle_MoniTool_CaseData_4: typeof Handle_MoniTool_CaseData_4;
  Handle_Media_Timer: typeof Handle_Media_Timer;
  Handle_Media_Timer_1: typeof Handle_Media_Timer_1;
  Handle_Media_Timer_2: typeof Handle_Media_Timer_2;
  Handle_Media_Timer_3: typeof Handle_Media_Timer_3;
  Handle_Media_Timer_4: typeof Handle_Media_Timer_4;
  IFGraph_AllShared: typeof IFGraph_AllShared;
  IFGraph_AllShared_1: typeof IFGraph_AllShared_1;
  IFGraph_AllShared_2: typeof IFGraph_AllShared_2;
  IFGraph_SubPartsIterator: typeof IFGraph_SubPartsIterator;
  IFGraph_SubPartsIterator_1: typeof IFGraph_SubPartsIterator_1;
  IFGraph_SubPartsIterator_2: typeof IFGraph_SubPartsIterator_2;
  IFGraph_SCRoots: typeof IFGraph_SCRoots;
  IFGraph_SCRoots_1: typeof IFGraph_SCRoots_1;
  IFGraph_SCRoots_2: typeof IFGraph_SCRoots_2;
  IFGraph_Cumulate: typeof IFGraph_Cumulate;
  IFGraph_StrongComponants: typeof IFGraph_StrongComponants;
  IFGraph_ExternalSources: typeof IFGraph_ExternalSources;
  IFGraph_Compare: typeof IFGraph_Compare;
  IFGraph_Articulations: typeof IFGraph_Articulations;
  IFGraph_ConnectedComponants: typeof IFGraph_ConnectedComponants;
  IFGraph_AllConnected: typeof IFGraph_AllConnected;
  IFGraph_AllConnected_1: typeof IFGraph_AllConnected_1;
  IFGraph_AllConnected_2: typeof IFGraph_AllConnected_2;
  IFGraph_Cycles: typeof IFGraph_Cycles;
  IFGraph_Cycles_1: typeof IFGraph_Cycles_1;
  IFGraph_Cycles_2: typeof IFGraph_Cycles_2;
  GeomFill_Line: typeof GeomFill_Line;
  GeomFill_Line_1: typeof GeomFill_Line_1;
  GeomFill_Line_2: typeof GeomFill_Line_2;
  Handle_GeomFill_Line: typeof Handle_GeomFill_Line;
  Handle_GeomFill_Line_1: typeof Handle_GeomFill_Line_1;
  Handle_GeomFill_Line_2: typeof Handle_GeomFill_Line_2;
  Handle_GeomFill_Line_3: typeof Handle_GeomFill_Line_3;
  Handle_GeomFill_Line_4: typeof Handle_GeomFill_Line_4;
  GeomFill_TrihedronLaw: typeof GeomFill_TrihedronLaw;
  Handle_GeomFill_TrihedronLaw: typeof Handle_GeomFill_TrihedronLaw;
  Handle_GeomFill_TrihedronLaw_1: typeof Handle_GeomFill_TrihedronLaw_1;
  Handle_GeomFill_TrihedronLaw_2: typeof Handle_GeomFill_TrihedronLaw_2;
  Handle_GeomFill_TrihedronLaw_3: typeof Handle_GeomFill_TrihedronLaw_3;
  Handle_GeomFill_TrihedronLaw_4: typeof Handle_GeomFill_TrihedronLaw_4;
  GeomFill_QuasiAngularConvertor: typeof GeomFill_QuasiAngularConvertor;
  GeomFill_AppSurf: typeof GeomFill_AppSurf;
  GeomFill_AppSurf_1: typeof GeomFill_AppSurf_1;
  GeomFill_AppSurf_2: typeof GeomFill_AppSurf_2;
  Handle_GeomFill_CoonsAlgPatch: typeof Handle_GeomFill_CoonsAlgPatch;
  Handle_GeomFill_CoonsAlgPatch_1: typeof Handle_GeomFill_CoonsAlgPatch_1;
  Handle_GeomFill_CoonsAlgPatch_2: typeof Handle_GeomFill_CoonsAlgPatch_2;
  Handle_GeomFill_CoonsAlgPatch_3: typeof Handle_GeomFill_CoonsAlgPatch_3;
  Handle_GeomFill_CoonsAlgPatch_4: typeof Handle_GeomFill_CoonsAlgPatch_4;
  GeomFill_CoonsAlgPatch: typeof GeomFill_CoonsAlgPatch;
  GeomFill_PolynomialConvertor: typeof GeomFill_PolynomialConvertor;
  Handle_GeomFill_HSequenceOfAx2: typeof Handle_GeomFill_HSequenceOfAx2;
  Handle_GeomFill_HSequenceOfAx2_1: typeof Handle_GeomFill_HSequenceOfAx2_1;
  Handle_GeomFill_HSequenceOfAx2_2: typeof Handle_GeomFill_HSequenceOfAx2_2;
  Handle_GeomFill_HSequenceOfAx2_3: typeof Handle_GeomFill_HSequenceOfAx2_3;
  Handle_GeomFill_HSequenceOfAx2_4: typeof Handle_GeomFill_HSequenceOfAx2_4;
  GeomFill_SimpleBound: typeof GeomFill_SimpleBound;
  Handle_GeomFill_SimpleBound: typeof Handle_GeomFill_SimpleBound;
  Handle_GeomFill_SimpleBound_1: typeof Handle_GeomFill_SimpleBound_1;
  Handle_GeomFill_SimpleBound_2: typeof Handle_GeomFill_SimpleBound_2;
  Handle_GeomFill_SimpleBound_3: typeof Handle_GeomFill_SimpleBound_3;
  Handle_GeomFill_SimpleBound_4: typeof Handle_GeomFill_SimpleBound_4;
  Handle_GeomFill_DiscreteTrihedron: typeof Handle_GeomFill_DiscreteTrihedron;
  Handle_GeomFill_DiscreteTrihedron_1: typeof Handle_GeomFill_DiscreteTrihedron_1;
  Handle_GeomFill_DiscreteTrihedron_2: typeof Handle_GeomFill_DiscreteTrihedron_2;
  Handle_GeomFill_DiscreteTrihedron_3: typeof Handle_GeomFill_DiscreteTrihedron_3;
  Handle_GeomFill_DiscreteTrihedron_4: typeof Handle_GeomFill_DiscreteTrihedron_4;
  GeomFill_DiscreteTrihedron: typeof GeomFill_DiscreteTrihedron;
  Handle_GeomFill_LocationLaw: typeof Handle_GeomFill_LocationLaw;
  Handle_GeomFill_LocationLaw_1: typeof Handle_GeomFill_LocationLaw_1;
  Handle_GeomFill_LocationLaw_2: typeof Handle_GeomFill_LocationLaw_2;
  Handle_GeomFill_LocationLaw_3: typeof Handle_GeomFill_LocationLaw_3;
  Handle_GeomFill_LocationLaw_4: typeof Handle_GeomFill_LocationLaw_4;
  GeomFill_LocationLaw: typeof GeomFill_LocationLaw;
  GeomFill_BoundWithSurf: typeof GeomFill_BoundWithSurf;
  Handle_GeomFill_BoundWithSurf: typeof Handle_GeomFill_BoundWithSurf;
  Handle_GeomFill_BoundWithSurf_1: typeof Handle_GeomFill_BoundWithSurf_1;
  Handle_GeomFill_BoundWithSurf_2: typeof Handle_GeomFill_BoundWithSurf_2;
  Handle_GeomFill_BoundWithSurf_3: typeof Handle_GeomFill_BoundWithSurf_3;
  Handle_GeomFill_BoundWithSurf_4: typeof Handle_GeomFill_BoundWithSurf_4;
  GeomFill_DraftTrihedron: typeof GeomFill_DraftTrihedron;
  Handle_GeomFill_DraftTrihedron: typeof Handle_GeomFill_DraftTrihedron;
  Handle_GeomFill_DraftTrihedron_1: typeof Handle_GeomFill_DraftTrihedron_1;
  Handle_GeomFill_DraftTrihedron_2: typeof Handle_GeomFill_DraftTrihedron_2;
  Handle_GeomFill_DraftTrihedron_3: typeof Handle_GeomFill_DraftTrihedron_3;
  Handle_GeomFill_DraftTrihedron_4: typeof Handle_GeomFill_DraftTrihedron_4;
  GeomFill_Trihedron: GeomFill_Trihedron;
  GeomFill_PlanFunc: typeof GeomFill_PlanFunc;
  GeomFill_FunctionGuide: typeof GeomFill_FunctionGuide;
  GeomFill_Generator: typeof GeomFill_Generator;
  GeomFill_Boundary: typeof GeomFill_Boundary;
  Handle_GeomFill_Boundary: typeof Handle_GeomFill_Boundary;
  Handle_GeomFill_Boundary_1: typeof Handle_GeomFill_Boundary_1;
  Handle_GeomFill_Boundary_2: typeof Handle_GeomFill_Boundary_2;
  Handle_GeomFill_Boundary_3: typeof Handle_GeomFill_Boundary_3;
  Handle_GeomFill_Boundary_4: typeof Handle_GeomFill_Boundary_4;
  Handle_GeomFill_NSections: typeof Handle_GeomFill_NSections;
  Handle_GeomFill_NSections_1: typeof Handle_GeomFill_NSections_1;
  Handle_GeomFill_NSections_2: typeof Handle_GeomFill_NSections_2;
  Handle_GeomFill_NSections_3: typeof Handle_GeomFill_NSections_3;
  Handle_GeomFill_NSections_4: typeof Handle_GeomFill_NSections_4;
  GeomFill_Coons: typeof GeomFill_Coons;
  GeomFill_Coons_1: typeof GeomFill_Coons_1;
  GeomFill_Coons_2: typeof GeomFill_Coons_2;
  GeomFill_Coons_3: typeof GeomFill_Coons_3;
  Handle_GeomFill_TgtOnCoons: typeof Handle_GeomFill_TgtOnCoons;
  Handle_GeomFill_TgtOnCoons_1: typeof Handle_GeomFill_TgtOnCoons_1;
  Handle_GeomFill_TgtOnCoons_2: typeof Handle_GeomFill_TgtOnCoons_2;
  Handle_GeomFill_TgtOnCoons_3: typeof Handle_GeomFill_TgtOnCoons_3;
  Handle_GeomFill_TgtOnCoons_4: typeof Handle_GeomFill_TgtOnCoons_4;
  GeomFill_TgtOnCoons: typeof GeomFill_TgtOnCoons;
  GeomFill_AppSweep: typeof GeomFill_AppSweep;
  GeomFill_AppSweep_1: typeof GeomFill_AppSweep_1;
  GeomFill_AppSweep_2: typeof GeomFill_AppSweep_2;
  GeomFill_BSplineCurves: typeof GeomFill_BSplineCurves;
  GeomFill_BSplineCurves_1: typeof GeomFill_BSplineCurves_1;
  GeomFill_BSplineCurves_2: typeof GeomFill_BSplineCurves_2;
  GeomFill_BSplineCurves_3: typeof GeomFill_BSplineCurves_3;
  GeomFill_BSplineCurves_4: typeof GeomFill_BSplineCurves_4;
  GeomFill: typeof GeomFill;
  GeomFill_LocFunction: typeof GeomFill_LocFunction;
  GeomFill_Profiler: typeof GeomFill_Profiler;
  Handle_GeomFill_LocationGuide: typeof Handle_GeomFill_LocationGuide;
  Handle_GeomFill_LocationGuide_1: typeof Handle_GeomFill_LocationGuide_1;
  Handle_GeomFill_LocationGuide_2: typeof Handle_GeomFill_LocationGuide_2;
  Handle_GeomFill_LocationGuide_3: typeof Handle_GeomFill_LocationGuide_3;
  Handle_GeomFill_LocationGuide_4: typeof Handle_GeomFill_LocationGuide_4;
  GeomFill_LocationGuide: typeof GeomFill_LocationGuide;
  GeomFill_ConstrainedFilling: typeof GeomFill_ConstrainedFilling;
  Handle_GeomFill_EvolvedSection: typeof Handle_GeomFill_EvolvedSection;
  Handle_GeomFill_EvolvedSection_1: typeof Handle_GeomFill_EvolvedSection_1;
  Handle_GeomFill_EvolvedSection_2: typeof Handle_GeomFill_EvolvedSection_2;
  Handle_GeomFill_EvolvedSection_3: typeof Handle_GeomFill_EvolvedSection_3;
  Handle_GeomFill_EvolvedSection_4: typeof Handle_GeomFill_EvolvedSection_4;
  GeomFill_EvolvedSection: typeof GeomFill_EvolvedSection;
  GeomFill_Frenet: typeof GeomFill_Frenet;
  Handle_GeomFill_Frenet: typeof Handle_GeomFill_Frenet;
  Handle_GeomFill_Frenet_1: typeof Handle_GeomFill_Frenet_1;
  Handle_GeomFill_Frenet_2: typeof Handle_GeomFill_Frenet_2;
  Handle_GeomFill_Frenet_3: typeof Handle_GeomFill_Frenet_3;
  Handle_GeomFill_Frenet_4: typeof Handle_GeomFill_Frenet_4;
  GeomFill_ConstantBiNormal: typeof GeomFill_ConstantBiNormal;
  Handle_GeomFill_ConstantBiNormal: typeof Handle_GeomFill_ConstantBiNormal;
  Handle_GeomFill_ConstantBiNormal_1: typeof Handle_GeomFill_ConstantBiNormal_1;
  Handle_GeomFill_ConstantBiNormal_2: typeof Handle_GeomFill_ConstantBiNormal_2;
  Handle_GeomFill_ConstantBiNormal_3: typeof Handle_GeomFill_ConstantBiNormal_3;
  Handle_GeomFill_ConstantBiNormal_4: typeof Handle_GeomFill_ConstantBiNormal_4;
  GeomFill_BezierCurves: typeof GeomFill_BezierCurves;
  GeomFill_BezierCurves_1: typeof GeomFill_BezierCurves_1;
  GeomFill_BezierCurves_2: typeof GeomFill_BezierCurves_2;
  GeomFill_BezierCurves_3: typeof GeomFill_BezierCurves_3;
  GeomFill_BezierCurves_4: typeof GeomFill_BezierCurves_4;
  Handle_GeomFill_SectionLaw: typeof Handle_GeomFill_SectionLaw;
  Handle_GeomFill_SectionLaw_1: typeof Handle_GeomFill_SectionLaw_1;
  Handle_GeomFill_SectionLaw_2: typeof Handle_GeomFill_SectionLaw_2;
  Handle_GeomFill_SectionLaw_3: typeof Handle_GeomFill_SectionLaw_3;
  Handle_GeomFill_SectionLaw_4: typeof Handle_GeomFill_SectionLaw_4;
  GeomFill_SectionLaw: typeof GeomFill_SectionLaw;
  Handle_GeomFill_HArray1OfLocationLaw: typeof Handle_GeomFill_HArray1OfLocationLaw;
  Handle_GeomFill_HArray1OfLocationLaw_1: typeof Handle_GeomFill_HArray1OfLocationLaw_1;
  Handle_GeomFill_HArray1OfLocationLaw_2: typeof Handle_GeomFill_HArray1OfLocationLaw_2;
  Handle_GeomFill_HArray1OfLocationLaw_3: typeof Handle_GeomFill_HArray1OfLocationLaw_3;
  Handle_GeomFill_HArray1OfLocationLaw_4: typeof Handle_GeomFill_HArray1OfLocationLaw_4;
  GeomFill_Pipe: typeof GeomFill_Pipe;
  GeomFill_Pipe_1: typeof GeomFill_Pipe_1;
  GeomFill_Pipe_2: typeof GeomFill_Pipe_2;
  GeomFill_Pipe_3: typeof GeomFill_Pipe_3;
  GeomFill_Pipe_4: typeof GeomFill_Pipe_4;
  GeomFill_Pipe_5: typeof GeomFill_Pipe_5;
  GeomFill_Pipe_6: typeof GeomFill_Pipe_6;
  GeomFill_Pipe_7: typeof GeomFill_Pipe_7;
  GeomFill_Pipe_8: typeof GeomFill_Pipe_8;
  GeomFill_Pipe_9: typeof GeomFill_Pipe_9;
  GeomFill_Pipe_10: typeof GeomFill_Pipe_10;
  GeomFill_Sweep: typeof GeomFill_Sweep;
  GeomFill_SweepFunction: typeof GeomFill_SweepFunction;
  Handle_GeomFill_SweepFunction: typeof Handle_GeomFill_SweepFunction;
  Handle_GeomFill_SweepFunction_1: typeof Handle_GeomFill_SweepFunction_1;
  Handle_GeomFill_SweepFunction_2: typeof Handle_GeomFill_SweepFunction_2;
  Handle_GeomFill_SweepFunction_3: typeof Handle_GeomFill_SweepFunction_3;
  Handle_GeomFill_SweepFunction_4: typeof Handle_GeomFill_SweepFunction_4;
  GeomFill_TgtField: typeof GeomFill_TgtField;
  Handle_GeomFill_TgtField: typeof Handle_GeomFill_TgtField;
  Handle_GeomFill_TgtField_1: typeof Handle_GeomFill_TgtField_1;
  Handle_GeomFill_TgtField_2: typeof Handle_GeomFill_TgtField_2;
  Handle_GeomFill_TgtField_3: typeof Handle_GeomFill_TgtField_3;
  Handle_GeomFill_TgtField_4: typeof Handle_GeomFill_TgtField_4;
  Handle_GeomFill_HArray1OfSectionLaw: typeof Handle_GeomFill_HArray1OfSectionLaw;
  Handle_GeomFill_HArray1OfSectionLaw_1: typeof Handle_GeomFill_HArray1OfSectionLaw_1;
  Handle_GeomFill_HArray1OfSectionLaw_2: typeof Handle_GeomFill_HArray1OfSectionLaw_2;
  Handle_GeomFill_HArray1OfSectionLaw_3: typeof Handle_GeomFill_HArray1OfSectionLaw_3;
  Handle_GeomFill_HArray1OfSectionLaw_4: typeof Handle_GeomFill_HArray1OfSectionLaw_4;
  GeomFill_Stretch: typeof GeomFill_Stretch;
  GeomFill_Stretch_1: typeof GeomFill_Stretch_1;
  GeomFill_Stretch_2: typeof GeomFill_Stretch_2;
  GeomFill_Stretch_3: typeof GeomFill_Stretch_3;
  GeomFill_GuideTrihedronAC: typeof GeomFill_GuideTrihedronAC;
  Handle_GeomFill_GuideTrihedronAC: typeof Handle_GeomFill_GuideTrihedronAC;
  Handle_GeomFill_GuideTrihedronAC_1: typeof Handle_GeomFill_GuideTrihedronAC_1;
  Handle_GeomFill_GuideTrihedronAC_2: typeof Handle_GeomFill_GuideTrihedronAC_2;
  Handle_GeomFill_GuideTrihedronAC_3: typeof Handle_GeomFill_GuideTrihedronAC_3;
  Handle_GeomFill_GuideTrihedronAC_4: typeof Handle_GeomFill_GuideTrihedronAC_4;
  GeomFill_SequenceOfTrsf: typeof GeomFill_SequenceOfTrsf;
  GeomFill_SequenceOfTrsf_1: typeof GeomFill_SequenceOfTrsf_1;
  GeomFill_SequenceOfTrsf_2: typeof GeomFill_SequenceOfTrsf_2;
  GeomFill_SequenceOfTrsf_3: typeof GeomFill_SequenceOfTrsf_3;
  Handle_GeomFill_UniformSection: typeof Handle_GeomFill_UniformSection;
  Handle_GeomFill_UniformSection_1: typeof Handle_GeomFill_UniformSection_1;
  Handle_GeomFill_UniformSection_2: typeof Handle_GeomFill_UniformSection_2;
  Handle_GeomFill_UniformSection_3: typeof Handle_GeomFill_UniformSection_3;
  Handle_GeomFill_UniformSection_4: typeof Handle_GeomFill_UniformSection_4;
  GeomFill_UniformSection: typeof GeomFill_UniformSection;
  Handle_GeomFill_CurveAndTrihedron: typeof Handle_GeomFill_CurveAndTrihedron;
  Handle_GeomFill_CurveAndTrihedron_1: typeof Handle_GeomFill_CurveAndTrihedron_1;
  Handle_GeomFill_CurveAndTrihedron_2: typeof Handle_GeomFill_CurveAndTrihedron_2;
  Handle_GeomFill_CurveAndTrihedron_3: typeof Handle_GeomFill_CurveAndTrihedron_3;
  Handle_GeomFill_CurveAndTrihedron_4: typeof Handle_GeomFill_CurveAndTrihedron_4;
  GeomFill_CurveAndTrihedron: typeof GeomFill_CurveAndTrihedron;
  GeomFill_CornerState: typeof GeomFill_CornerState;
  GeomFill_SnglrFunc: typeof GeomFill_SnglrFunc;
  Handle_GeomFill_DegeneratedBound: typeof Handle_GeomFill_DegeneratedBound;
  Handle_GeomFill_DegeneratedBound_1: typeof Handle_GeomFill_DegeneratedBound_1;
  Handle_GeomFill_DegeneratedBound_2: typeof Handle_GeomFill_DegeneratedBound_2;
  Handle_GeomFill_DegeneratedBound_3: typeof Handle_GeomFill_DegeneratedBound_3;
  Handle_GeomFill_DegeneratedBound_4: typeof Handle_GeomFill_DegeneratedBound_4;
  GeomFill_DegeneratedBound: typeof GeomFill_DegeneratedBound;
  GeomFill_SectionGenerator: typeof GeomFill_SectionGenerator;
  GeomFill_Filling: typeof GeomFill_Filling;
  Handle_GeomFill_Fixed: typeof Handle_GeomFill_Fixed;
  Handle_GeomFill_Fixed_1: typeof Handle_GeomFill_Fixed_1;
  Handle_GeomFill_Fixed_2: typeof Handle_GeomFill_Fixed_2;
  Handle_GeomFill_Fixed_3: typeof Handle_GeomFill_Fixed_3;
  Handle_GeomFill_Fixed_4: typeof Handle_GeomFill_Fixed_4;
  GeomFill_Fixed: typeof GeomFill_Fixed;
  GeomFill_SequenceOfAx2: typeof GeomFill_SequenceOfAx2;
  GeomFill_SequenceOfAx2_1: typeof GeomFill_SequenceOfAx2_1;
  GeomFill_SequenceOfAx2_2: typeof GeomFill_SequenceOfAx2_2;
  GeomFill_SequenceOfAx2_3: typeof GeomFill_SequenceOfAx2_3;
  GeomFill_SectionPlacement: typeof GeomFill_SectionPlacement;
  Handle_GeomFill_LocationDraft: typeof Handle_GeomFill_LocationDraft;
  Handle_GeomFill_LocationDraft_1: typeof Handle_GeomFill_LocationDraft_1;
  Handle_GeomFill_LocationDraft_2: typeof Handle_GeomFill_LocationDraft_2;
  Handle_GeomFill_LocationDraft_3: typeof Handle_GeomFill_LocationDraft_3;
  Handle_GeomFill_LocationDraft_4: typeof Handle_GeomFill_LocationDraft_4;
  GeomFill_LocationDraft: typeof GeomFill_LocationDraft;
  GeomFill_CircularBlendFunc: typeof GeomFill_CircularBlendFunc;
  Handle_GeomFill_CircularBlendFunc: typeof Handle_GeomFill_CircularBlendFunc;
  Handle_GeomFill_CircularBlendFunc_1: typeof Handle_GeomFill_CircularBlendFunc_1;
  Handle_GeomFill_CircularBlendFunc_2: typeof Handle_GeomFill_CircularBlendFunc_2;
  Handle_GeomFill_CircularBlendFunc_3: typeof Handle_GeomFill_CircularBlendFunc_3;
  Handle_GeomFill_CircularBlendFunc_4: typeof Handle_GeomFill_CircularBlendFunc_4;
  GeomFill_FillingStyle: GeomFill_FillingStyle;
  GeomFill_CorrectedFrenet: typeof GeomFill_CorrectedFrenet;
  GeomFill_CorrectedFrenet_1: typeof GeomFill_CorrectedFrenet_1;
  GeomFill_CorrectedFrenet_2: typeof GeomFill_CorrectedFrenet_2;
  Handle_GeomFill_CorrectedFrenet: typeof Handle_GeomFill_CorrectedFrenet;
  Handle_GeomFill_CorrectedFrenet_1: typeof Handle_GeomFill_CorrectedFrenet_1;
  Handle_GeomFill_CorrectedFrenet_2: typeof Handle_GeomFill_CorrectedFrenet_2;
  Handle_GeomFill_CorrectedFrenet_3: typeof Handle_GeomFill_CorrectedFrenet_3;
  Handle_GeomFill_CorrectedFrenet_4: typeof Handle_GeomFill_CorrectedFrenet_4;
  GeomFill_GuideTrihedronPlan: typeof GeomFill_GuideTrihedronPlan;
  Handle_GeomFill_GuideTrihedronPlan: typeof Handle_GeomFill_GuideTrihedronPlan;
  Handle_GeomFill_GuideTrihedronPlan_1: typeof Handle_GeomFill_GuideTrihedronPlan_1;
  Handle_GeomFill_GuideTrihedronPlan_2: typeof Handle_GeomFill_GuideTrihedronPlan_2;
  Handle_GeomFill_GuideTrihedronPlan_3: typeof Handle_GeomFill_GuideTrihedronPlan_3;
  Handle_GeomFill_GuideTrihedronPlan_4: typeof Handle_GeomFill_GuideTrihedronPlan_4;
  GeomFill_Curved: typeof GeomFill_Curved;
  GeomFill_Curved_1: typeof GeomFill_Curved_1;
  GeomFill_Curved_2: typeof GeomFill_Curved_2;
  GeomFill_Curved_3: typeof GeomFill_Curved_3;
  GeomFill_Curved_4: typeof GeomFill_Curved_4;
  GeomFill_Curved_5: typeof GeomFill_Curved_5;
  GeomFill_FunctionDraft: typeof GeomFill_FunctionDraft;
  GeomFill_Tensor: typeof GeomFill_Tensor;
  Handle_GeomFill_TrihedronWithGuide: typeof Handle_GeomFill_TrihedronWithGuide;
  Handle_GeomFill_TrihedronWithGuide_1: typeof Handle_GeomFill_TrihedronWithGuide_1;
  Handle_GeomFill_TrihedronWithGuide_2: typeof Handle_GeomFill_TrihedronWithGuide_2;
  Handle_GeomFill_TrihedronWithGuide_3: typeof Handle_GeomFill_TrihedronWithGuide_3;
  Handle_GeomFill_TrihedronWithGuide_4: typeof Handle_GeomFill_TrihedronWithGuide_4;
  GeomFill_TrihedronWithGuide: typeof GeomFill_TrihedronWithGuide;
  GeomFill_Darboux: typeof GeomFill_Darboux;
  Handle_GeomFill_Darboux: typeof Handle_GeomFill_Darboux;
  Handle_GeomFill_Darboux_1: typeof Handle_GeomFill_Darboux_1;
  Handle_GeomFill_Darboux_2: typeof Handle_GeomFill_Darboux_2;
  Handle_GeomFill_Darboux_3: typeof Handle_GeomFill_Darboux_3;
  Handle_GeomFill_Darboux_4: typeof Handle_GeomFill_Darboux_4;
  GeomFill_ApproxStyle: GeomFill_ApproxStyle;
  GeomFill_PipeError: GeomFill_PipeError;
  IntPatch_ImpPrmIntersection: typeof IntPatch_ImpPrmIntersection;
  IntPatch_ImpPrmIntersection_1: typeof IntPatch_ImpPrmIntersection_1;
  IntPatch_ImpPrmIntersection_2: typeof IntPatch_ImpPrmIntersection_2;
  IntPatch_TheSearchInside: typeof IntPatch_TheSearchInside;
  IntPatch_TheSearchInside_1: typeof IntPatch_TheSearchInside_1;
  IntPatch_TheSearchInside_2: typeof IntPatch_TheSearchInside_2;
  IntPatch_InterferencePolyhedron: typeof IntPatch_InterferencePolyhedron;
  IntPatch_InterferencePolyhedron_1: typeof IntPatch_InterferencePolyhedron_1;
  IntPatch_InterferencePolyhedron_2: typeof IntPatch_InterferencePolyhedron_2;
  IntPatch_InterferencePolyhedron_3: typeof IntPatch_InterferencePolyhedron_3;
  IntPatch_LineConstructor: typeof IntPatch_LineConstructor;
  IntPatch_ALine: typeof IntPatch_ALine;
  IntPatch_ALine_1: typeof IntPatch_ALine_1;
  IntPatch_ALine_2: typeof IntPatch_ALine_2;
  IntPatch_ALine_3: typeof IntPatch_ALine_3;
  Handle_IntPatch_ALine: typeof Handle_IntPatch_ALine;
  Handle_IntPatch_ALine_1: typeof Handle_IntPatch_ALine_1;
  Handle_IntPatch_ALine_2: typeof Handle_IntPatch_ALine_2;
  Handle_IntPatch_ALine_3: typeof Handle_IntPatch_ALine_3;
  Handle_IntPatch_ALine_4: typeof Handle_IntPatch_ALine_4;
  IntPatch_SequenceOfSegmentOfTheSOnBounds: typeof IntPatch_SequenceOfSegmentOfTheSOnBounds;
  IntPatch_SequenceOfSegmentOfTheSOnBounds_1: typeof IntPatch_SequenceOfSegmentOfTheSOnBounds_1;
  IntPatch_SequenceOfSegmentOfTheSOnBounds_2: typeof IntPatch_SequenceOfSegmentOfTheSOnBounds_2;
  IntPatch_SequenceOfSegmentOfTheSOnBounds_3: typeof IntPatch_SequenceOfSegmentOfTheSOnBounds_3;
  IntPatch_HInterTool: typeof IntPatch_HInterTool;
  IntPatch_ImpImpIntersection: typeof IntPatch_ImpImpIntersection;
  IntPatch_ImpImpIntersection_1: typeof IntPatch_ImpImpIntersection_1;
  IntPatch_ImpImpIntersection_2: typeof IntPatch_ImpImpIntersection_2;
  IntPatch_PolyhedronTool: typeof IntPatch_PolyhedronTool;
  IntPatch_PolyArc: typeof IntPatch_PolyArc;
  IntPatch_ThePathPointOfTheSOnBounds: typeof IntPatch_ThePathPointOfTheSOnBounds;
  IntPatch_ThePathPointOfTheSOnBounds_1: typeof IntPatch_ThePathPointOfTheSOnBounds_1;
  IntPatch_ThePathPointOfTheSOnBounds_2: typeof IntPatch_ThePathPointOfTheSOnBounds_2;
  IntPatch_ThePathPointOfTheSOnBounds_3: typeof IntPatch_ThePathPointOfTheSOnBounds_3;
  IntPatch_Point: typeof IntPatch_Point;
  Handle_IntPatch_GLine: typeof Handle_IntPatch_GLine;
  Handle_IntPatch_GLine_1: typeof Handle_IntPatch_GLine_1;
  Handle_IntPatch_GLine_2: typeof Handle_IntPatch_GLine_2;
  Handle_IntPatch_GLine_3: typeof Handle_IntPatch_GLine_3;
  Handle_IntPatch_GLine_4: typeof Handle_IntPatch_GLine_4;
  IntPatch_GLine: typeof IntPatch_GLine;
  IntPatch_GLine_1: typeof IntPatch_GLine_1;
  IntPatch_GLine_2: typeof IntPatch_GLine_2;
  IntPatch_GLine_3: typeof IntPatch_GLine_3;
  IntPatch_GLine_4: typeof IntPatch_GLine_4;
  IntPatch_GLine_5: typeof IntPatch_GLine_5;
  IntPatch_GLine_6: typeof IntPatch_GLine_6;
  IntPatch_GLine_7: typeof IntPatch_GLine_7;
  IntPatch_GLine_8: typeof IntPatch_GLine_8;
  IntPatch_GLine_9: typeof IntPatch_GLine_9;
  IntPatch_GLine_10: typeof IntPatch_GLine_10;
  IntPatch_GLine_11: typeof IntPatch_GLine_11;
  IntPatch_GLine_12: typeof IntPatch_GLine_12;
  IntPatch_GLine_13: typeof IntPatch_GLine_13;
  IntPatch_GLine_14: typeof IntPatch_GLine_14;
  IntPatch_GLine_15: typeof IntPatch_GLine_15;
  IntPatch_PrmPrmIntersection: typeof IntPatch_PrmPrmIntersection;
  IntPatch_RstInt: typeof IntPatch_RstInt;
  IntPatch_SpecPntType: IntPatch_SpecPntType;
  IntPatch_TheIWalking: typeof IntPatch_TheIWalking;
  IntPatch_SpecialPoints: typeof IntPatch_SpecialPoints;
  IntPatch_TheSOnBounds: typeof IntPatch_TheSOnBounds;
  IntPatch_TheIWLineOfTheIWalking: typeof IntPatch_TheIWLineOfTheIWalking;
  Handle_IntPatch_TheIWLineOfTheIWalking: typeof Handle_IntPatch_TheIWLineOfTheIWalking;
  Handle_IntPatch_TheIWLineOfTheIWalking_1: typeof Handle_IntPatch_TheIWLineOfTheIWalking_1;
  Handle_IntPatch_TheIWLineOfTheIWalking_2: typeof Handle_IntPatch_TheIWLineOfTheIWalking_2;
  Handle_IntPatch_TheIWLineOfTheIWalking_3: typeof Handle_IntPatch_TheIWLineOfTheIWalking_3;
  Handle_IntPatch_TheIWLineOfTheIWalking_4: typeof Handle_IntPatch_TheIWLineOfTheIWalking_4;
  IntPatch_PolyLine: typeof IntPatch_PolyLine;
  IntPatch_PolyLine_1: typeof IntPatch_PolyLine_1;
  IntPatch_PolyLine_2: typeof IntPatch_PolyLine_2;
  IntPatch_CSFunction: typeof IntPatch_CSFunction;
  IntPatch_SequenceOfPoint: typeof IntPatch_SequenceOfPoint;
  IntPatch_SequenceOfPoint_1: typeof IntPatch_SequenceOfPoint_1;
  IntPatch_SequenceOfPoint_2: typeof IntPatch_SequenceOfPoint_2;
  IntPatch_SequenceOfPoint_3: typeof IntPatch_SequenceOfPoint_3;
  Handle_IntPatch_RLine: typeof Handle_IntPatch_RLine;
  Handle_IntPatch_RLine_1: typeof Handle_IntPatch_RLine_1;
  Handle_IntPatch_RLine_2: typeof Handle_IntPatch_RLine_2;
  Handle_IntPatch_RLine_3: typeof Handle_IntPatch_RLine_3;
  Handle_IntPatch_RLine_4: typeof Handle_IntPatch_RLine_4;
  IntPatch_CurvIntSurf: typeof IntPatch_CurvIntSurf;
  IntPatch_CurvIntSurf_1: typeof IntPatch_CurvIntSurf_1;
  IntPatch_CurvIntSurf_2: typeof IntPatch_CurvIntSurf_2;
  IntPatch_TheSurfFunction: typeof IntPatch_TheSurfFunction;
  IntPatch_TheSurfFunction_1: typeof IntPatch_TheSurfFunction_1;
  IntPatch_TheSurfFunction_2: typeof IntPatch_TheSurfFunction_2;
  IntPatch_TheSurfFunction_3: typeof IntPatch_TheSurfFunction_3;
  IntPatch_ALineToWLine: typeof IntPatch_ALineToWLine;
  IntPatch_WLine: typeof IntPatch_WLine;
  IntPatch_WLine_1: typeof IntPatch_WLine_1;
  IntPatch_WLine_2: typeof IntPatch_WLine_2;
  IntPatch_WLine_3: typeof IntPatch_WLine_3;
  Handle_IntPatch_WLine: typeof Handle_IntPatch_WLine;
  Handle_IntPatch_WLine_1: typeof Handle_IntPatch_WLine_1;
  Handle_IntPatch_WLine_2: typeof Handle_IntPatch_WLine_2;
  Handle_IntPatch_WLine_3: typeof Handle_IntPatch_WLine_3;
  Handle_IntPatch_WLine_4: typeof Handle_IntPatch_WLine_4;
  IntPatch_Intersection: typeof IntPatch_Intersection;
  IntPatch_Intersection_1: typeof IntPatch_Intersection_1;
  IntPatch_Intersection_2: typeof IntPatch_Intersection_2;
  IntPatch_Intersection_3: typeof IntPatch_Intersection_3;
  IntPatch_PrmPrmIntersection_T3Bits: typeof IntPatch_PrmPrmIntersection_T3Bits;
  IntPatch_TheSegmentOfTheSOnBounds: typeof IntPatch_TheSegmentOfTheSOnBounds;
  IntPatch_SequenceOfPathPointOfTheSOnBounds: typeof IntPatch_SequenceOfPathPointOfTheSOnBounds;
  IntPatch_SequenceOfPathPointOfTheSOnBounds_1: typeof IntPatch_SequenceOfPathPointOfTheSOnBounds_1;
  IntPatch_SequenceOfPathPointOfTheSOnBounds_2: typeof IntPatch_SequenceOfPathPointOfTheSOnBounds_2;
  IntPatch_SequenceOfPathPointOfTheSOnBounds_3: typeof IntPatch_SequenceOfPathPointOfTheSOnBounds_3;
  IntPatch_IType: IntPatch_IType;
  IntPatch_ArcFunction: typeof IntPatch_ArcFunction;
  IntPatch_Line: typeof IntPatch_Line;
  Handle_IntPatch_Line: typeof Handle_IntPatch_Line;
  Handle_IntPatch_Line_1: typeof Handle_IntPatch_Line_1;
  Handle_IntPatch_Line_2: typeof Handle_IntPatch_Line_2;
  Handle_IntPatch_Line_3: typeof Handle_IntPatch_Line_3;
  Handle_IntPatch_Line_4: typeof Handle_IntPatch_Line_4;
  IntPatch_HCurve2dTool: typeof IntPatch_HCurve2dTool;
  IntPatch_WLineTool: typeof IntPatch_WLineTool;
  IntPatch_Polygo: typeof IntPatch_Polygo;
  IntPatch_PointLine: typeof IntPatch_PointLine;
  Handle_IntPatch_PointLine: typeof Handle_IntPatch_PointLine;
  Handle_IntPatch_PointLine_1: typeof Handle_IntPatch_PointLine_1;
  Handle_IntPatch_PointLine_2: typeof Handle_IntPatch_PointLine_2;
  Handle_IntPatch_PointLine_3: typeof Handle_IntPatch_PointLine_3;
  Handle_IntPatch_PointLine_4: typeof Handle_IntPatch_PointLine_4;
  Handle_GccInt_BElips: typeof Handle_GccInt_BElips;
  Handle_GccInt_BElips_1: typeof Handle_GccInt_BElips_1;
  Handle_GccInt_BElips_2: typeof Handle_GccInt_BElips_2;
  Handle_GccInt_BElips_3: typeof Handle_GccInt_BElips_3;
  Handle_GccInt_BElips_4: typeof Handle_GccInt_BElips_4;
  GccInt_BElips: typeof GccInt_BElips;
  GccInt_BPoint: typeof GccInt_BPoint;
  Handle_GccInt_BPoint: typeof Handle_GccInt_BPoint;
  Handle_GccInt_BPoint_1: typeof Handle_GccInt_BPoint_1;
  Handle_GccInt_BPoint_2: typeof Handle_GccInt_BPoint_2;
  Handle_GccInt_BPoint_3: typeof Handle_GccInt_BPoint_3;
  Handle_GccInt_BPoint_4: typeof Handle_GccInt_BPoint_4;
  GccInt_BParab: typeof GccInt_BParab;
  Handle_GccInt_BParab: typeof Handle_GccInt_BParab;
  Handle_GccInt_BParab_1: typeof Handle_GccInt_BParab_1;
  Handle_GccInt_BParab_2: typeof Handle_GccInt_BParab_2;
  Handle_GccInt_BParab_3: typeof Handle_GccInt_BParab_3;
  Handle_GccInt_BParab_4: typeof Handle_GccInt_BParab_4;
  GccInt_Bisec: typeof GccInt_Bisec;
  Handle_GccInt_Bisec: typeof Handle_GccInt_Bisec;
  Handle_GccInt_Bisec_1: typeof Handle_GccInt_Bisec_1;
  Handle_GccInt_Bisec_2: typeof Handle_GccInt_Bisec_2;
  Handle_GccInt_Bisec_3: typeof Handle_GccInt_Bisec_3;
  Handle_GccInt_Bisec_4: typeof Handle_GccInt_Bisec_4;
  Handle_GccInt_BHyper: typeof Handle_GccInt_BHyper;
  Handle_GccInt_BHyper_1: typeof Handle_GccInt_BHyper_1;
  Handle_GccInt_BHyper_2: typeof Handle_GccInt_BHyper_2;
  Handle_GccInt_BHyper_3: typeof Handle_GccInt_BHyper_3;
  Handle_GccInt_BHyper_4: typeof Handle_GccInt_BHyper_4;
  GccInt_BHyper: typeof GccInt_BHyper;
  GccInt_BLine: typeof GccInt_BLine;
  Handle_GccInt_BLine: typeof Handle_GccInt_BLine;
  Handle_GccInt_BLine_1: typeof Handle_GccInt_BLine_1;
  Handle_GccInt_BLine_2: typeof Handle_GccInt_BLine_2;
  Handle_GccInt_BLine_3: typeof Handle_GccInt_BLine_3;
  Handle_GccInt_BLine_4: typeof Handle_GccInt_BLine_4;
  GccInt_IType: GccInt_IType;
  GccInt_BCirc: typeof GccInt_BCirc;
  Handle_GccInt_BCirc: typeof Handle_GccInt_BCirc;
  Handle_GccInt_BCirc_1: typeof Handle_GccInt_BCirc_1;
  Handle_GccInt_BCirc_2: typeof Handle_GccInt_BCirc_2;
  Handle_GccInt_BCirc_3: typeof Handle_GccInt_BCirc_3;
  Handle_GccInt_BCirc_4: typeof Handle_GccInt_BCirc_4;
  Handle_StdFail_UndefinedValue: typeof Handle_StdFail_UndefinedValue;
  Handle_StdFail_UndefinedValue_1: typeof Handle_StdFail_UndefinedValue_1;
  Handle_StdFail_UndefinedValue_2: typeof Handle_StdFail_UndefinedValue_2;
  Handle_StdFail_UndefinedValue_3: typeof Handle_StdFail_UndefinedValue_3;
  Handle_StdFail_UndefinedValue_4: typeof Handle_StdFail_UndefinedValue_4;
  StdFail_UndefinedValue: typeof StdFail_UndefinedValue;
  StdFail_UndefinedValue_1: typeof StdFail_UndefinedValue_1;
  StdFail_UndefinedValue_2: typeof StdFail_UndefinedValue_2;
  StdFail_Undefined: typeof StdFail_Undefined;
  StdFail_Undefined_1: typeof StdFail_Undefined_1;
  StdFail_Undefined_2: typeof StdFail_Undefined_2;
  Handle_StdFail_Undefined: typeof Handle_StdFail_Undefined;
  Handle_StdFail_Undefined_1: typeof Handle_StdFail_Undefined_1;
  Handle_StdFail_Undefined_2: typeof Handle_StdFail_Undefined_2;
  Handle_StdFail_Undefined_3: typeof Handle_StdFail_Undefined_3;
  Handle_StdFail_Undefined_4: typeof Handle_StdFail_Undefined_4;
  Handle_StdFail_InfiniteSolutions: typeof Handle_StdFail_InfiniteSolutions;
  Handle_StdFail_InfiniteSolutions_1: typeof Handle_StdFail_InfiniteSolutions_1;
  Handle_StdFail_InfiniteSolutions_2: typeof Handle_StdFail_InfiniteSolutions_2;
  Handle_StdFail_InfiniteSolutions_3: typeof Handle_StdFail_InfiniteSolutions_3;
  Handle_StdFail_InfiniteSolutions_4: typeof Handle_StdFail_InfiniteSolutions_4;
  StdFail_InfiniteSolutions: typeof StdFail_InfiniteSolutions;
  StdFail_InfiniteSolutions_1: typeof StdFail_InfiniteSolutions_1;
  StdFail_InfiniteSolutions_2: typeof StdFail_InfiniteSolutions_2;
  StdFail_NotDone: typeof StdFail_NotDone;
  StdFail_NotDone_1: typeof StdFail_NotDone_1;
  StdFail_NotDone_2: typeof StdFail_NotDone_2;
  Handle_StdFail_NotDone: typeof Handle_StdFail_NotDone;
  Handle_StdFail_NotDone_1: typeof Handle_StdFail_NotDone_1;
  Handle_StdFail_NotDone_2: typeof Handle_StdFail_NotDone_2;
  Handle_StdFail_NotDone_3: typeof Handle_StdFail_NotDone_3;
  Handle_StdFail_NotDone_4: typeof Handle_StdFail_NotDone_4;
  Handle_StdFail_UndefinedDerivative: typeof Handle_StdFail_UndefinedDerivative;
  Handle_StdFail_UndefinedDerivative_1: typeof Handle_StdFail_UndefinedDerivative_1;
  Handle_StdFail_UndefinedDerivative_2: typeof Handle_StdFail_UndefinedDerivative_2;
  Handle_StdFail_UndefinedDerivative_3: typeof Handle_StdFail_UndefinedDerivative_3;
  Handle_StdFail_UndefinedDerivative_4: typeof Handle_StdFail_UndefinedDerivative_4;
  StdFail_UndefinedDerivative: typeof StdFail_UndefinedDerivative;
  StdFail_UndefinedDerivative_1: typeof StdFail_UndefinedDerivative_1;
  StdFail_UndefinedDerivative_2: typeof StdFail_UndefinedDerivative_2;
  Transfer_StatusExec: Transfer_StatusExec;
  Transfer_ResultFromModel: typeof Transfer_ResultFromModel;
  Handle_Transfer_ResultFromModel: typeof Handle_Transfer_ResultFromModel;
  Handle_Transfer_ResultFromModel_1: typeof Handle_Transfer_ResultFromModel_1;
  Handle_Transfer_ResultFromModel_2: typeof Handle_Transfer_ResultFromModel_2;
  Handle_Transfer_ResultFromModel_3: typeof Handle_Transfer_ResultFromModel_3;
  Handle_Transfer_ResultFromModel_4: typeof Handle_Transfer_ResultFromModel_4;
  Handle_Transfer_Binder: typeof Handle_Transfer_Binder;
  Handle_Transfer_Binder_1: typeof Handle_Transfer_Binder_1;
  Handle_Transfer_Binder_2: typeof Handle_Transfer_Binder_2;
  Handle_Transfer_Binder_3: typeof Handle_Transfer_Binder_3;
  Handle_Transfer_Binder_4: typeof Handle_Transfer_Binder_4;
  Transfer_Binder: typeof Transfer_Binder;
  Transfer_UndefMode: Transfer_UndefMode;
  Transfer_FindHasher: typeof Transfer_FindHasher;
  Transfer_DataInfo: typeof Transfer_DataInfo;
  Handle_Transfer_FinderProcess: typeof Handle_Transfer_FinderProcess;
  Handle_Transfer_FinderProcess_1: typeof Handle_Transfer_FinderProcess_1;
  Handle_Transfer_FinderProcess_2: typeof Handle_Transfer_FinderProcess_2;
  Handle_Transfer_FinderProcess_3: typeof Handle_Transfer_FinderProcess_3;
  Handle_Transfer_FinderProcess_4: typeof Handle_Transfer_FinderProcess_4;
  Transfer_FinderProcess: typeof Transfer_FinderProcess;
  Transfer_IteratorOfProcessForFinder: typeof Transfer_IteratorOfProcessForFinder;
  Handle_Transfer_ActorDispatch: typeof Handle_Transfer_ActorDispatch;
  Handle_Transfer_ActorDispatch_1: typeof Handle_Transfer_ActorDispatch_1;
  Handle_Transfer_ActorDispatch_2: typeof Handle_Transfer_ActorDispatch_2;
  Handle_Transfer_ActorDispatch_3: typeof Handle_Transfer_ActorDispatch_3;
  Handle_Transfer_ActorDispatch_4: typeof Handle_Transfer_ActorDispatch_4;
  Transfer_ActorDispatch: typeof Transfer_ActorDispatch;
  Transfer_ActorDispatch_1: typeof Transfer_ActorDispatch_1;
  Transfer_ActorDispatch_2: typeof Transfer_ActorDispatch_2;
  Transfer_ActorDispatch_3: typeof Transfer_ActorDispatch_3;
  Transfer_StatusResult: Transfer_StatusResult;
  Handle_Transfer_TransferDeadLoop: typeof Handle_Transfer_TransferDeadLoop;
  Handle_Transfer_TransferDeadLoop_1: typeof Handle_Transfer_TransferDeadLoop_1;
  Handle_Transfer_TransferDeadLoop_2: typeof Handle_Transfer_TransferDeadLoop_2;
  Handle_Transfer_TransferDeadLoop_3: typeof Handle_Transfer_TransferDeadLoop_3;
  Handle_Transfer_TransferDeadLoop_4: typeof Handle_Transfer_TransferDeadLoop_4;
  Transfer_TransferDeadLoop: typeof Transfer_TransferDeadLoop;
  Transfer_TransferDeadLoop_1: typeof Transfer_TransferDeadLoop_1;
  Transfer_TransferDeadLoop_2: typeof Transfer_TransferDeadLoop_2;
  Transfer_ProcessForFinder: typeof Transfer_ProcessForFinder;
  Transfer_ProcessForFinder_1: typeof Transfer_ProcessForFinder_1;
  Transfer_ProcessForFinder_2: typeof Transfer_ProcessForFinder_2;
  Handle_Transfer_ProcessForFinder: typeof Handle_Transfer_ProcessForFinder;
  Handle_Transfer_ProcessForFinder_1: typeof Handle_Transfer_ProcessForFinder_1;
  Handle_Transfer_ProcessForFinder_2: typeof Handle_Transfer_ProcessForFinder_2;
  Handle_Transfer_ProcessForFinder_3: typeof Handle_Transfer_ProcessForFinder_3;
  Handle_Transfer_ProcessForFinder_4: typeof Handle_Transfer_ProcessForFinder_4;
  Handle_Transfer_TransientProcess: typeof Handle_Transfer_TransientProcess;
  Handle_Transfer_TransientProcess_1: typeof Handle_Transfer_TransientProcess_1;
  Handle_Transfer_TransientProcess_2: typeof Handle_Transfer_TransientProcess_2;
  Handle_Transfer_TransientProcess_3: typeof Handle_Transfer_TransientProcess_3;
  Handle_Transfer_TransientProcess_4: typeof Handle_Transfer_TransientProcess_4;
  Transfer_TransientProcess: typeof Transfer_TransientProcess;
  Transfer_ActorOfFinderProcess: typeof Transfer_ActorOfFinderProcess;
  Handle_Transfer_ActorOfFinderProcess: typeof Handle_Transfer_ActorOfFinderProcess;
  Handle_Transfer_ActorOfFinderProcess_1: typeof Handle_Transfer_ActorOfFinderProcess_1;
  Handle_Transfer_ActorOfFinderProcess_2: typeof Handle_Transfer_ActorOfFinderProcess_2;
  Handle_Transfer_ActorOfFinderProcess_3: typeof Handle_Transfer_ActorOfFinderProcess_3;
  Handle_Transfer_ActorOfFinderProcess_4: typeof Handle_Transfer_ActorOfFinderProcess_4;
  Handle_Transfer_MapContainer: typeof Handle_Transfer_MapContainer;
  Handle_Transfer_MapContainer_1: typeof Handle_Transfer_MapContainer_1;
  Handle_Transfer_MapContainer_2: typeof Handle_Transfer_MapContainer_2;
  Handle_Transfer_MapContainer_3: typeof Handle_Transfer_MapContainer_3;
  Handle_Transfer_MapContainer_4: typeof Handle_Transfer_MapContainer_4;
  Transfer_MapContainer: typeof Transfer_MapContainer;
  Transfer_TransferInput: typeof Transfer_TransferInput;
  Handle_Transfer_HSequenceOfBinder: typeof Handle_Transfer_HSequenceOfBinder;
  Handle_Transfer_HSequenceOfBinder_1: typeof Handle_Transfer_HSequenceOfBinder_1;
  Handle_Transfer_HSequenceOfBinder_2: typeof Handle_Transfer_HSequenceOfBinder_2;
  Handle_Transfer_HSequenceOfBinder_3: typeof Handle_Transfer_HSequenceOfBinder_3;
  Handle_Transfer_HSequenceOfBinder_4: typeof Handle_Transfer_HSequenceOfBinder_4;
  Handle_Transfer_HSequenceOfFinder: typeof Handle_Transfer_HSequenceOfFinder;
  Handle_Transfer_HSequenceOfFinder_1: typeof Handle_Transfer_HSequenceOfFinder_1;
  Handle_Transfer_HSequenceOfFinder_2: typeof Handle_Transfer_HSequenceOfFinder_2;
  Handle_Transfer_HSequenceOfFinder_3: typeof Handle_Transfer_HSequenceOfFinder_3;
  Handle_Transfer_HSequenceOfFinder_4: typeof Handle_Transfer_HSequenceOfFinder_4;
  Handle_Transfer_ActorOfProcessForFinder: typeof Handle_Transfer_ActorOfProcessForFinder;
  Handle_Transfer_ActorOfProcessForFinder_1: typeof Handle_Transfer_ActorOfProcessForFinder_1;
  Handle_Transfer_ActorOfProcessForFinder_2: typeof Handle_Transfer_ActorOfProcessForFinder_2;
  Handle_Transfer_ActorOfProcessForFinder_3: typeof Handle_Transfer_ActorOfProcessForFinder_3;
  Handle_Transfer_ActorOfProcessForFinder_4: typeof Handle_Transfer_ActorOfProcessForFinder_4;
  Transfer_ActorOfProcessForFinder: typeof Transfer_ActorOfProcessForFinder;
  Transfer_IteratorOfProcessForTransient: typeof Transfer_IteratorOfProcessForTransient;
  Transfer_TransferIterator: typeof Transfer_TransferIterator;
  Handle_Transfer_TransientMapper: typeof Handle_Transfer_TransientMapper;
  Handle_Transfer_TransientMapper_1: typeof Handle_Transfer_TransientMapper_1;
  Handle_Transfer_TransientMapper_2: typeof Handle_Transfer_TransientMapper_2;
  Handle_Transfer_TransientMapper_3: typeof Handle_Transfer_TransientMapper_3;
  Handle_Transfer_TransientMapper_4: typeof Handle_Transfer_TransientMapper_4;
  Transfer_TransientMapper: typeof Transfer_TransientMapper;
  Transfer_BinderOfTransientInteger: typeof Transfer_BinderOfTransientInteger;
  Handle_Transfer_BinderOfTransientInteger: typeof Handle_Transfer_BinderOfTransientInteger;
  Handle_Transfer_BinderOfTransientInteger_1: typeof Handle_Transfer_BinderOfTransientInteger_1;
  Handle_Transfer_BinderOfTransientInteger_2: typeof Handle_Transfer_BinderOfTransientInteger_2;
  Handle_Transfer_BinderOfTransientInteger_3: typeof Handle_Transfer_BinderOfTransientInteger_3;
  Handle_Transfer_BinderOfTransientInteger_4: typeof Handle_Transfer_BinderOfTransientInteger_4;
  Handle_Transfer_TransientListBinder: typeof Handle_Transfer_TransientListBinder;
  Handle_Transfer_TransientListBinder_1: typeof Handle_Transfer_TransientListBinder_1;
  Handle_Transfer_TransientListBinder_2: typeof Handle_Transfer_TransientListBinder_2;
  Handle_Transfer_TransientListBinder_3: typeof Handle_Transfer_TransientListBinder_3;
  Handle_Transfer_TransientListBinder_4: typeof Handle_Transfer_TransientListBinder_4;
  Transfer_TransientListBinder: typeof Transfer_TransientListBinder;
  Transfer_TransientListBinder_1: typeof Transfer_TransientListBinder_1;
  Transfer_TransientListBinder_2: typeof Transfer_TransientListBinder_2;
  Transfer_TransferOutput: typeof Transfer_TransferOutput;
  Transfer_TransferOutput_1: typeof Transfer_TransferOutput_1;
  Transfer_TransferOutput_2: typeof Transfer_TransferOutput_2;
  Transfer_ActorOfTransientProcess: typeof Transfer_ActorOfTransientProcess;
  Handle_Transfer_ActorOfTransientProcess: typeof Handle_Transfer_ActorOfTransientProcess;
  Handle_Transfer_ActorOfTransientProcess_1: typeof Handle_Transfer_ActorOfTransientProcess_1;
  Handle_Transfer_ActorOfTransientProcess_2: typeof Handle_Transfer_ActorOfTransientProcess_2;
  Handle_Transfer_ActorOfTransientProcess_3: typeof Handle_Transfer_ActorOfTransientProcess_3;
  Handle_Transfer_ActorOfTransientProcess_4: typeof Handle_Transfer_ActorOfTransientProcess_4;
  Transfer_TransferFailure: typeof Transfer_TransferFailure;
  Transfer_TransferFailure_1: typeof Transfer_TransferFailure_1;
  Transfer_TransferFailure_2: typeof Transfer_TransferFailure_2;
  Handle_Transfer_TransferFailure: typeof Handle_Transfer_TransferFailure;
  Handle_Transfer_TransferFailure_1: typeof Handle_Transfer_TransferFailure_1;
  Handle_Transfer_TransferFailure_2: typeof Handle_Transfer_TransferFailure_2;
  Handle_Transfer_TransferFailure_3: typeof Handle_Transfer_TransferFailure_3;
  Handle_Transfer_TransferFailure_4: typeof Handle_Transfer_TransferFailure_4;
  Handle_Transfer_DispatchControl: typeof Handle_Transfer_DispatchControl;
  Handle_Transfer_DispatchControl_1: typeof Handle_Transfer_DispatchControl_1;
  Handle_Transfer_DispatchControl_2: typeof Handle_Transfer_DispatchControl_2;
  Handle_Transfer_DispatchControl_3: typeof Handle_Transfer_DispatchControl_3;
  Handle_Transfer_DispatchControl_4: typeof Handle_Transfer_DispatchControl_4;
  Transfer_DispatchControl: typeof Transfer_DispatchControl;
  Transfer_ProcessForTransient: typeof Transfer_ProcessForTransient;
  Transfer_ProcessForTransient_1: typeof Transfer_ProcessForTransient_1;
  Transfer_ProcessForTransient_2: typeof Transfer_ProcessForTransient_2;
  Handle_Transfer_ProcessForTransient: typeof Handle_Transfer_ProcessForTransient;
  Handle_Transfer_ProcessForTransient_1: typeof Handle_Transfer_ProcessForTransient_1;
  Handle_Transfer_ProcessForTransient_2: typeof Handle_Transfer_ProcessForTransient_2;
  Handle_Transfer_ProcessForTransient_3: typeof Handle_Transfer_ProcessForTransient_3;
  Handle_Transfer_ProcessForTransient_4: typeof Handle_Transfer_ProcessForTransient_4;
  Handle_Transfer_SimpleBinderOfTransient: typeof Handle_Transfer_SimpleBinderOfTransient;
  Handle_Transfer_SimpleBinderOfTransient_1: typeof Handle_Transfer_SimpleBinderOfTransient_1;
  Handle_Transfer_SimpleBinderOfTransient_2: typeof Handle_Transfer_SimpleBinderOfTransient_2;
  Handle_Transfer_SimpleBinderOfTransient_3: typeof Handle_Transfer_SimpleBinderOfTransient_3;
  Handle_Transfer_SimpleBinderOfTransient_4: typeof Handle_Transfer_SimpleBinderOfTransient_4;
  Transfer_SimpleBinderOfTransient: typeof Transfer_SimpleBinderOfTransient;
  Transfer_Finder: typeof Transfer_Finder;
  Handle_Transfer_Finder: typeof Handle_Transfer_Finder;
  Handle_Transfer_Finder_1: typeof Handle_Transfer_Finder_1;
  Handle_Transfer_Finder_2: typeof Handle_Transfer_Finder_2;
  Handle_Transfer_Finder_3: typeof Handle_Transfer_Finder_3;
  Handle_Transfer_Finder_4: typeof Handle_Transfer_Finder_4;
  Transfer_ActorOfProcessForTransient: typeof Transfer_ActorOfProcessForTransient;
  Handle_Transfer_ActorOfProcessForTransient: typeof Handle_Transfer_ActorOfProcessForTransient;
  Handle_Transfer_ActorOfProcessForTransient_1: typeof Handle_Transfer_ActorOfProcessForTransient_1;
  Handle_Transfer_ActorOfProcessForTransient_2: typeof Handle_Transfer_ActorOfProcessForTransient_2;
  Handle_Transfer_ActorOfProcessForTransient_3: typeof Handle_Transfer_ActorOfProcessForTransient_3;
  Handle_Transfer_ActorOfProcessForTransient_4: typeof Handle_Transfer_ActorOfProcessForTransient_4;
  Handle_Transfer_MultipleBinder: typeof Handle_Transfer_MultipleBinder;
  Handle_Transfer_MultipleBinder_1: typeof Handle_Transfer_MultipleBinder_1;
  Handle_Transfer_MultipleBinder_2: typeof Handle_Transfer_MultipleBinder_2;
  Handle_Transfer_MultipleBinder_3: typeof Handle_Transfer_MultipleBinder_3;
  Handle_Transfer_MultipleBinder_4: typeof Handle_Transfer_MultipleBinder_4;
  Transfer_MultipleBinder: typeof Transfer_MultipleBinder;
  Handle_Transfer_VoidBinder: typeof Handle_Transfer_VoidBinder;
  Handle_Transfer_VoidBinder_1: typeof Handle_Transfer_VoidBinder_1;
  Handle_Transfer_VoidBinder_2: typeof Handle_Transfer_VoidBinder_2;
  Handle_Transfer_VoidBinder_3: typeof Handle_Transfer_VoidBinder_3;
  Handle_Transfer_VoidBinder_4: typeof Handle_Transfer_VoidBinder_4;
  Transfer_VoidBinder: typeof Transfer_VoidBinder;
  Transfer_TransferDispatch: typeof Transfer_TransferDispatch;
  Transfer_TransferDispatch_1: typeof Transfer_TransferDispatch_1;
  Transfer_TransferDispatch_2: typeof Transfer_TransferDispatch_2;
  Transfer_TransferDispatch_3: typeof Transfer_TransferDispatch_3;
  Handle_Transfer_ResultFromTransient: typeof Handle_Transfer_ResultFromTransient;
  Handle_Transfer_ResultFromTransient_1: typeof Handle_Transfer_ResultFromTransient_1;
  Handle_Transfer_ResultFromTransient_2: typeof Handle_Transfer_ResultFromTransient_2;
  Handle_Transfer_ResultFromTransient_3: typeof Handle_Transfer_ResultFromTransient_3;
  Handle_Transfer_ResultFromTransient_4: typeof Handle_Transfer_ResultFromTransient_4;
  Transfer_ResultFromTransient: typeof Transfer_ResultFromTransient;
  BRepExtrema_TriangleSet: typeof BRepExtrema_TriangleSet;
  BRepExtrema_TriangleSet_1: typeof BRepExtrema_TriangleSet_1;
  BRepExtrema_TriangleSet_2: typeof BRepExtrema_TriangleSet_2;
  BRepExtrema_ShapeList: typeof BRepExtrema_ShapeList;
  BRepExtrema_ShapeList_1: typeof BRepExtrema_ShapeList_1;
  BRepExtrema_ShapeList_2: typeof BRepExtrema_ShapeList_2;
  Handle_BRepExtrema_TriangleSet: typeof Handle_BRepExtrema_TriangleSet;
  Handle_BRepExtrema_TriangleSet_1: typeof Handle_BRepExtrema_TriangleSet_1;
  Handle_BRepExtrema_TriangleSet_2: typeof Handle_BRepExtrema_TriangleSet_2;
  Handle_BRepExtrema_TriangleSet_3: typeof Handle_BRepExtrema_TriangleSet_3;
  Handle_BRepExtrema_TriangleSet_4: typeof Handle_BRepExtrema_TriangleSet_4;
  BRepExtrema_ExtPF: typeof BRepExtrema_ExtPF;
  BRepExtrema_ExtPF_1: typeof BRepExtrema_ExtPF_1;
  BRepExtrema_ExtPF_2: typeof BRepExtrema_ExtPF_2;
  BRepExtrema_ExtPC: typeof BRepExtrema_ExtPC;
  BRepExtrema_ExtPC_1: typeof BRepExtrema_ExtPC_1;
  BRepExtrema_ExtPC_2: typeof BRepExtrema_ExtPC_2;
  BRepExtrema_SelfIntersection: typeof BRepExtrema_SelfIntersection;
  BRepExtrema_SelfIntersection_1: typeof BRepExtrema_SelfIntersection_1;
  BRepExtrema_SelfIntersection_2: typeof BRepExtrema_SelfIntersection_2;
  BRepExtrema_SupportType: BRepExtrema_SupportType;
  BRepExtrema_Poly: typeof BRepExtrema_Poly;
  BRepExtrema_SolutionElem: typeof BRepExtrema_SolutionElem;
  BRepExtrema_SolutionElem_1: typeof BRepExtrema_SolutionElem_1;
  BRepExtrema_SolutionElem_2: typeof BRepExtrema_SolutionElem_2;
  BRepExtrema_SolutionElem_3: typeof BRepExtrema_SolutionElem_3;
  BRepExtrema_SolutionElem_4: typeof BRepExtrema_SolutionElem_4;
  BRepExtrema_SeqOfSolution: typeof BRepExtrema_SeqOfSolution;
  BRepExtrema_SeqOfSolution_1: typeof BRepExtrema_SeqOfSolution_1;
  BRepExtrema_SeqOfSolution_2: typeof BRepExtrema_SeqOfSolution_2;
  BRepExtrema_SeqOfSolution_3: typeof BRepExtrema_SeqOfSolution_3;
  BRepExtrema_OverlapTool: typeof BRepExtrema_OverlapTool;
  BRepExtrema_OverlapTool_1: typeof BRepExtrema_OverlapTool_1;
  BRepExtrema_OverlapTool_2: typeof BRepExtrema_OverlapTool_2;
  Handle_BRepExtrema_UnCompatibleShape: typeof Handle_BRepExtrema_UnCompatibleShape;
  Handle_BRepExtrema_UnCompatibleShape_1: typeof Handle_BRepExtrema_UnCompatibleShape_1;
  Handle_BRepExtrema_UnCompatibleShape_2: typeof Handle_BRepExtrema_UnCompatibleShape_2;
  Handle_BRepExtrema_UnCompatibleShape_3: typeof Handle_BRepExtrema_UnCompatibleShape_3;
  Handle_BRepExtrema_UnCompatibleShape_4: typeof Handle_BRepExtrema_UnCompatibleShape_4;
  BRepExtrema_UnCompatibleShape: typeof BRepExtrema_UnCompatibleShape;
  BRepExtrema_UnCompatibleShape_1: typeof BRepExtrema_UnCompatibleShape_1;
  BRepExtrema_UnCompatibleShape_2: typeof BRepExtrema_UnCompatibleShape_2;
  BRepExtrema_ExtCF: typeof BRepExtrema_ExtCF;
  BRepExtrema_ExtCF_1: typeof BRepExtrema_ExtCF_1;
  BRepExtrema_ExtCF_2: typeof BRepExtrema_ExtCF_2;
  BRepExtrema_ShapeProximity: typeof BRepExtrema_ShapeProximity;
  BRepExtrema_ShapeProximity_1: typeof BRepExtrema_ShapeProximity_1;
  BRepExtrema_ShapeProximity_2: typeof BRepExtrema_ShapeProximity_2;
  BRepExtrema_ExtCC: typeof BRepExtrema_ExtCC;
  BRepExtrema_ExtCC_1: typeof BRepExtrema_ExtCC_1;
  BRepExtrema_ExtCC_2: typeof BRepExtrema_ExtCC_2;
  BRepExtrema_DistanceSS: typeof BRepExtrema_DistanceSS;
  BRepExtrema_DistanceSS_1: typeof BRepExtrema_DistanceSS_1;
  BRepExtrema_DistanceSS_2: typeof BRepExtrema_DistanceSS_2;
  BRepExtrema_ElementFilter: typeof BRepExtrema_ElementFilter;
  BRepExtrema_DistShapeShape: typeof BRepExtrema_DistShapeShape;
  BRepExtrema_DistShapeShape_1: typeof BRepExtrema_DistShapeShape_1;
  BRepExtrema_DistShapeShape_2: typeof BRepExtrema_DistShapeShape_2;
  BRepExtrema_DistShapeShape_3: typeof BRepExtrema_DistShapeShape_3;
  BRepExtrema_ExtFF: typeof BRepExtrema_ExtFF;
  BRepExtrema_ExtFF_1: typeof BRepExtrema_ExtFF_1;
  BRepExtrema_ExtFF_2: typeof BRepExtrema_ExtFF_2;
  TopTools_DataMapOfOrientedShapeInteger: typeof TopTools_DataMapOfOrientedShapeInteger;
  TopTools_DataMapOfOrientedShapeInteger_1: typeof TopTools_DataMapOfOrientedShapeInteger_1;
  TopTools_DataMapOfOrientedShapeInteger_2: typeof TopTools_DataMapOfOrientedShapeInteger_2;
  TopTools_DataMapOfOrientedShapeInteger_3: typeof TopTools_DataMapOfOrientedShapeInteger_3;
  TopTools_IndexedMapOfShape: typeof TopTools_IndexedMapOfShape;
  TopTools_IndexedMapOfShape_1: typeof TopTools_IndexedMapOfShape_1;
  TopTools_IndexedMapOfShape_2: typeof TopTools_IndexedMapOfShape_2;
  TopTools_IndexedMapOfShape_3: typeof TopTools_IndexedMapOfShape_3;
  TopTools_DataMapOfShapeBox: typeof TopTools_DataMapOfShapeBox;
  TopTools_DataMapOfShapeBox_1: typeof TopTools_DataMapOfShapeBox_1;
  TopTools_DataMapOfShapeBox_2: typeof TopTools_DataMapOfShapeBox_2;
  TopTools_DataMapOfShapeBox_3: typeof TopTools_DataMapOfShapeBox_3;
  TopTools_Array2OfShape: typeof TopTools_Array2OfShape;
  TopTools_Array2OfShape_1: typeof TopTools_Array2OfShape_1;
  TopTools_Array2OfShape_2: typeof TopTools_Array2OfShape_2;
  TopTools_Array2OfShape_3: typeof TopTools_Array2OfShape_3;
  TopTools_Array2OfShape_4: typeof TopTools_Array2OfShape_4;
  TopTools_Array2OfShape_5: typeof TopTools_Array2OfShape_5;
  Handle_TopTools_HArray1OfShape: typeof Handle_TopTools_HArray1OfShape;
  Handle_TopTools_HArray1OfShape_1: typeof Handle_TopTools_HArray1OfShape_1;
  Handle_TopTools_HArray1OfShape_2: typeof Handle_TopTools_HArray1OfShape_2;
  Handle_TopTools_HArray1OfShape_3: typeof Handle_TopTools_HArray1OfShape_3;
  Handle_TopTools_HArray1OfShape_4: typeof Handle_TopTools_HArray1OfShape_4;
  Handle_TopTools_HSequenceOfShape: typeof Handle_TopTools_HSequenceOfShape;
  Handle_TopTools_HSequenceOfShape_1: typeof Handle_TopTools_HSequenceOfShape_1;
  Handle_TopTools_HSequenceOfShape_2: typeof Handle_TopTools_HSequenceOfShape_2;
  Handle_TopTools_HSequenceOfShape_3: typeof Handle_TopTools_HSequenceOfShape_3;
  Handle_TopTools_HSequenceOfShape_4: typeof Handle_TopTools_HSequenceOfShape_4;
  TopTools_ShapeSet: typeof TopTools_ShapeSet;
  TopTools_IndexedDataMapOfShapeShape: typeof TopTools_IndexedDataMapOfShapeShape;
  TopTools_IndexedDataMapOfShapeShape_1: typeof TopTools_IndexedDataMapOfShapeShape_1;
  TopTools_IndexedDataMapOfShapeShape_2: typeof TopTools_IndexedDataMapOfShapeShape_2;
  TopTools_IndexedDataMapOfShapeShape_3: typeof TopTools_IndexedDataMapOfShapeShape_3;
  TopTools_OrientedShapeMapHasher: typeof TopTools_OrientedShapeMapHasher;
  TopTools_MutexForShapeProvider: typeof TopTools_MutexForShapeProvider;
  TopTools_Array1OfListOfShape: typeof TopTools_Array1OfListOfShape;
  TopTools_Array1OfListOfShape_1: typeof TopTools_Array1OfListOfShape_1;
  TopTools_Array1OfListOfShape_2: typeof TopTools_Array1OfListOfShape_2;
  TopTools_Array1OfListOfShape_3: typeof TopTools_Array1OfListOfShape_3;
  TopTools_Array1OfListOfShape_4: typeof TopTools_Array1OfListOfShape_4;
  TopTools_Array1OfListOfShape_5: typeof TopTools_Array1OfListOfShape_5;
  TopTools_ShapeMapHasher: typeof TopTools_ShapeMapHasher;
  TopTools_DataMapOfShapeReal: typeof TopTools_DataMapOfShapeReal;
  TopTools_DataMapOfShapeReal_1: typeof TopTools_DataMapOfShapeReal_1;
  TopTools_DataMapOfShapeReal_2: typeof TopTools_DataMapOfShapeReal_2;
  TopTools_DataMapOfShapeReal_3: typeof TopTools_DataMapOfShapeReal_3;
  TopTools_IndexedMapOfOrientedShape: typeof TopTools_IndexedMapOfOrientedShape;
  TopTools_IndexedMapOfOrientedShape_1: typeof TopTools_IndexedMapOfOrientedShape_1;
  TopTools_IndexedMapOfOrientedShape_2: typeof TopTools_IndexedMapOfOrientedShape_2;
  TopTools_IndexedMapOfOrientedShape_3: typeof TopTools_IndexedMapOfOrientedShape_3;
  TopTools_DataMapOfShapeListOfShape: typeof TopTools_DataMapOfShapeListOfShape;
  TopTools_DataMapOfShapeListOfShape_1: typeof TopTools_DataMapOfShapeListOfShape_1;
  TopTools_DataMapOfShapeListOfShape_2: typeof TopTools_DataMapOfShapeListOfShape_2;
  TopTools_DataMapOfShapeListOfShape_3: typeof TopTools_DataMapOfShapeListOfShape_3;
  Handle_TopTools_HArray1OfListOfShape: typeof Handle_TopTools_HArray1OfListOfShape;
  Handle_TopTools_HArray1OfListOfShape_1: typeof Handle_TopTools_HArray1OfListOfShape_1;
  Handle_TopTools_HArray1OfListOfShape_2: typeof Handle_TopTools_HArray1OfListOfShape_2;
  Handle_TopTools_HArray1OfListOfShape_3: typeof Handle_TopTools_HArray1OfListOfShape_3;
  Handle_TopTools_HArray1OfListOfShape_4: typeof Handle_TopTools_HArray1OfListOfShape_4;
  TopTools_Array1OfShape: typeof TopTools_Array1OfShape;
  TopTools_Array1OfShape_1: typeof TopTools_Array1OfShape_1;
  TopTools_Array1OfShape_2: typeof TopTools_Array1OfShape_2;
  TopTools_Array1OfShape_3: typeof TopTools_Array1OfShape_3;
  TopTools_Array1OfShape_4: typeof TopTools_Array1OfShape_4;
  TopTools_Array1OfShape_5: typeof TopTools_Array1OfShape_5;
  Handle_TopTools_HArray2OfShape: typeof Handle_TopTools_HArray2OfShape;
  Handle_TopTools_HArray2OfShape_1: typeof Handle_TopTools_HArray2OfShape_1;
  Handle_TopTools_HArray2OfShape_2: typeof Handle_TopTools_HArray2OfShape_2;
  Handle_TopTools_HArray2OfShape_3: typeof Handle_TopTools_HArray2OfShape_3;
  Handle_TopTools_HArray2OfShape_4: typeof Handle_TopTools_HArray2OfShape_4;
  TopTools: typeof TopTools;
  TopTools_MapOfShape: typeof TopTools_MapOfShape;
  TopTools_MapOfShape_1: typeof TopTools_MapOfShape_1;
  TopTools_MapOfShape_2: typeof TopTools_MapOfShape_2;
  TopTools_MapOfShape_3: typeof TopTools_MapOfShape_3;
  TopTools_MapOfOrientedShape: typeof TopTools_MapOfOrientedShape;
  TopTools_MapOfOrientedShape_1: typeof TopTools_MapOfOrientedShape_1;
  TopTools_MapOfOrientedShape_2: typeof TopTools_MapOfOrientedShape_2;
  TopTools_MapOfOrientedShape_3: typeof TopTools_MapOfOrientedShape_3;
  TopTools_DataMapOfShapeShape: typeof TopTools_DataMapOfShapeShape;
  TopTools_DataMapOfShapeShape_1: typeof TopTools_DataMapOfShapeShape_1;
  TopTools_DataMapOfShapeShape_2: typeof TopTools_DataMapOfShapeShape_2;
  TopTools_DataMapOfShapeShape_3: typeof TopTools_DataMapOfShapeShape_3;
  TopTools_DataMapOfShapeSequenceOfShape: typeof TopTools_DataMapOfShapeSequenceOfShape;
  TopTools_DataMapOfShapeSequenceOfShape_1: typeof TopTools_DataMapOfShapeSequenceOfShape_1;
  TopTools_DataMapOfShapeSequenceOfShape_2: typeof TopTools_DataMapOfShapeSequenceOfShape_2;
  TopTools_DataMapOfShapeSequenceOfShape_3: typeof TopTools_DataMapOfShapeSequenceOfShape_3;
  TopTools_ListOfShape: typeof TopTools_ListOfShape;
  TopTools_ListOfShape_1: typeof TopTools_ListOfShape_1;
  TopTools_ListOfShape_2: typeof TopTools_ListOfShape_2;
  TopTools_ListOfShape_3: typeof TopTools_ListOfShape_3;
  TopTools_SequenceOfShape: typeof TopTools_SequenceOfShape;
  TopTools_SequenceOfShape_1: typeof TopTools_SequenceOfShape_1;
  TopTools_SequenceOfShape_2: typeof TopTools_SequenceOfShape_2;
  TopTools_SequenceOfShape_3: typeof TopTools_SequenceOfShape_3;
  TopTools_DataMapOfShapeListOfInteger: typeof TopTools_DataMapOfShapeListOfInteger;
  TopTools_DataMapOfShapeListOfInteger_1: typeof TopTools_DataMapOfShapeListOfInteger_1;
  TopTools_DataMapOfShapeListOfInteger_2: typeof TopTools_DataMapOfShapeListOfInteger_2;
  TopTools_DataMapOfShapeListOfInteger_3: typeof TopTools_DataMapOfShapeListOfInteger_3;
  TopTools_DataMapOfOrientedShapeShape: typeof TopTools_DataMapOfOrientedShapeShape;
  TopTools_DataMapOfOrientedShapeShape_1: typeof TopTools_DataMapOfOrientedShapeShape_1;
  TopTools_DataMapOfOrientedShapeShape_2: typeof TopTools_DataMapOfOrientedShapeShape_2;
  TopTools_DataMapOfOrientedShapeShape_3: typeof TopTools_DataMapOfOrientedShapeShape_3;
  TopTools_IndexedDataMapOfShapeListOfShape: typeof TopTools_IndexedDataMapOfShapeListOfShape;
  TopTools_IndexedDataMapOfShapeListOfShape_1: typeof TopTools_IndexedDataMapOfShapeListOfShape_1;
  TopTools_IndexedDataMapOfShapeListOfShape_2: typeof TopTools_IndexedDataMapOfShapeListOfShape_2;
  TopTools_IndexedDataMapOfShapeListOfShape_3: typeof TopTools_IndexedDataMapOfShapeListOfShape_3;
  TopTools_DataMapOfIntegerListOfShape: typeof TopTools_DataMapOfIntegerListOfShape;
  TopTools_DataMapOfIntegerListOfShape_1: typeof TopTools_DataMapOfIntegerListOfShape_1;
  TopTools_DataMapOfIntegerListOfShape_2: typeof TopTools_DataMapOfIntegerListOfShape_2;
  TopTools_DataMapOfIntegerListOfShape_3: typeof TopTools_DataMapOfIntegerListOfShape_3;
  TopTools_ListOfListOfShape: typeof TopTools_ListOfListOfShape;
  TopTools_ListOfListOfShape_1: typeof TopTools_ListOfListOfShape_1;
  TopTools_ListOfListOfShape_2: typeof TopTools_ListOfListOfShape_2;
  TopTools_ListOfListOfShape_3: typeof TopTools_ListOfListOfShape_3;
  TopTools_LocationSet: typeof TopTools_LocationSet;
  TopTools_DataMapOfShapeInteger: typeof TopTools_DataMapOfShapeInteger;
  TopTools_DataMapOfShapeInteger_1: typeof TopTools_DataMapOfShapeInteger_1;
  TopTools_DataMapOfShapeInteger_2: typeof TopTools_DataMapOfShapeInteger_2;
  TopTools_DataMapOfShapeInteger_3: typeof TopTools_DataMapOfShapeInteger_3;
  TopTools_DataMapOfIntegerShape: typeof TopTools_DataMapOfIntegerShape;
  TopTools_DataMapOfIntegerShape_1: typeof TopTools_DataMapOfIntegerShape_1;
  TopTools_DataMapOfIntegerShape_2: typeof TopTools_DataMapOfIntegerShape_2;
  TopTools_DataMapOfIntegerShape_3: typeof TopTools_DataMapOfIntegerShape_3;
  TopTools_IndexedDataMapOfShapeAddress: typeof TopTools_IndexedDataMapOfShapeAddress;
  TopTools_IndexedDataMapOfShapeAddress_1: typeof TopTools_IndexedDataMapOfShapeAddress_1;
  TopTools_IndexedDataMapOfShapeAddress_2: typeof TopTools_IndexedDataMapOfShapeAddress_2;
  TopTools_IndexedDataMapOfShapeAddress_3: typeof TopTools_IndexedDataMapOfShapeAddress_3;
  TopTools_IndexedDataMapOfShapeReal: typeof TopTools_IndexedDataMapOfShapeReal;
  TopTools_IndexedDataMapOfShapeReal_1: typeof TopTools_IndexedDataMapOfShapeReal_1;
  TopTools_IndexedDataMapOfShapeReal_2: typeof TopTools_IndexedDataMapOfShapeReal_2;
  TopTools_IndexedDataMapOfShapeReal_3: typeof TopTools_IndexedDataMapOfShapeReal_3;
  RWStepAP214_RWAutoDesignDocumentReference: typeof RWStepAP214_RWAutoDesignDocumentReference;
  RWStepAP214_RWAutoDesignActualDateAndTimeAssignment: typeof RWStepAP214_RWAutoDesignActualDateAndTimeAssignment;
  RWStepAP214_RWAutoDesignActualDateAssignment: typeof RWStepAP214_RWAutoDesignActualDateAssignment;
  RWStepAP214_RWAutoDesignPersonAndOrganizationAssignment: typeof RWStepAP214_RWAutoDesignPersonAndOrganizationAssignment;
  Handle_RWStepAP214_GeneralModule: typeof Handle_RWStepAP214_GeneralModule;
  Handle_RWStepAP214_GeneralModule_1: typeof Handle_RWStepAP214_GeneralModule_1;
  Handle_RWStepAP214_GeneralModule_2: typeof Handle_RWStepAP214_GeneralModule_2;
  Handle_RWStepAP214_GeneralModule_3: typeof Handle_RWStepAP214_GeneralModule_3;
  Handle_RWStepAP214_GeneralModule_4: typeof Handle_RWStepAP214_GeneralModule_4;
  RWStepAP214_RWAppliedDateAssignment: typeof RWStepAP214_RWAppliedDateAssignment;
  RWStepAP214_RWAutoDesignDateAndPersonAssignment: typeof RWStepAP214_RWAutoDesignDateAndPersonAssignment;
  RWStepAP214_RWClass: typeof RWStepAP214_RWClass;
  RWStepAP214_RWAutoDesignSecurityClassificationAssignment: typeof RWStepAP214_RWAutoDesignSecurityClassificationAssignment;
  RWStepAP214_RWAutoDesignOrganizationAssignment: typeof RWStepAP214_RWAutoDesignOrganizationAssignment;
  RWStepAP214_RWAutoDesignPresentedItem: typeof RWStepAP214_RWAutoDesignPresentedItem;
  RWStepAP214_RWRepItemGroup: typeof RWStepAP214_RWRepItemGroup;
  RWStepAP214_RWAutoDesignNominalDateAndTimeAssignment: typeof RWStepAP214_RWAutoDesignNominalDateAndTimeAssignment;
  RWStepAP214_RWAppliedGroupAssignment: typeof RWStepAP214_RWAppliedGroupAssignment;
  RWStepAP214_RWAppliedPersonAndOrganizationAssignment: typeof RWStepAP214_RWAppliedPersonAndOrganizationAssignment;
  RWStepAP214_RWAutoDesignNominalDateAssignment: typeof RWStepAP214_RWAutoDesignNominalDateAssignment;
  RWStepAP214_RWAppliedDocumentReference: typeof RWStepAP214_RWAppliedDocumentReference;
  RWStepAP214_RWExternallyDefinedClass: typeof RWStepAP214_RWExternallyDefinedClass;
  RWStepAP214_RWExternallyDefinedGeneralProperty: typeof RWStepAP214_RWExternallyDefinedGeneralProperty;
  RWStepAP214_RWAutoDesignGroupAssignment: typeof RWStepAP214_RWAutoDesignGroupAssignment;
  RWStepAP214_RWAutoDesignApprovalAssignment: typeof RWStepAP214_RWAutoDesignApprovalAssignment;
  RWStepAP214: typeof RWStepAP214;
  RWStepAP214_RWAppliedExternalIdentificationAssignment: typeof RWStepAP214_RWAppliedExternalIdentificationAssignment;
  RWStepAP214_RWAppliedApprovalAssignment: typeof RWStepAP214_RWAppliedApprovalAssignment;
  RWStepAP214_RWAppliedDateAndTimeAssignment: typeof RWStepAP214_RWAppliedDateAndTimeAssignment;
  RWStepAP214_RWAppliedSecurityClassificationAssignment: typeof RWStepAP214_RWAppliedSecurityClassificationAssignment;
  RWStepAP214_RWAppliedOrganizationAssignment: typeof RWStepAP214_RWAppliedOrganizationAssignment;
  Handle_RWStepAP214_ReadWriteModule: typeof Handle_RWStepAP214_ReadWriteModule;
  Handle_RWStepAP214_ReadWriteModule_1: typeof Handle_RWStepAP214_ReadWriteModule_1;
  Handle_RWStepAP214_ReadWriteModule_2: typeof Handle_RWStepAP214_ReadWriteModule_2;
  Handle_RWStepAP214_ReadWriteModule_3: typeof Handle_RWStepAP214_ReadWriteModule_3;
  Handle_RWStepAP214_ReadWriteModule_4: typeof Handle_RWStepAP214_ReadWriteModule_4;
  RWStepAP214_ReadWriteModule: typeof RWStepAP214_ReadWriteModule;
  RWStepAP214_RWAppliedPresentedItem: typeof RWStepAP214_RWAppliedPresentedItem;
  BRepFill_Evolved: typeof BRepFill_Evolved;
  BRepFill_Evolved_1: typeof BRepFill_Evolved_1;
  BRepFill_Evolved_2: typeof BRepFill_Evolved_2;
  BRepFill_Evolved_3: typeof BRepFill_Evolved_3;
  BRepFill_CompatibleWires: typeof BRepFill_CompatibleWires;
  BRepFill_CompatibleWires_1: typeof BRepFill_CompatibleWires_1;
  BRepFill_CompatibleWires_2: typeof BRepFill_CompatibleWires_2;
  BRepFill_Draft: typeof BRepFill_Draft;
  BRepFill_IndexedDataMapOfOrientedShapeListOfShape: typeof BRepFill_IndexedDataMapOfOrientedShapeListOfShape;
  BRepFill_IndexedDataMapOfOrientedShapeListOfShape_1: typeof BRepFill_IndexedDataMapOfOrientedShapeListOfShape_1;
  BRepFill_IndexedDataMapOfOrientedShapeListOfShape_2: typeof BRepFill_IndexedDataMapOfOrientedShapeListOfShape_2;
  BRepFill_IndexedDataMapOfOrientedShapeListOfShape_3: typeof BRepFill_IndexedDataMapOfOrientedShapeListOfShape_3;
  BRepFill_Filling: typeof BRepFill_Filling;
  BRepFill_EdgeFaceAndOrder: typeof BRepFill_EdgeFaceAndOrder;
  BRepFill_EdgeFaceAndOrder_1: typeof BRepFill_EdgeFaceAndOrder_1;
  BRepFill_EdgeFaceAndOrder_2: typeof BRepFill_EdgeFaceAndOrder_2;
  BRepFill_ListOfOffsetWire: typeof BRepFill_ListOfOffsetWire;
  BRepFill_ListOfOffsetWire_1: typeof BRepFill_ListOfOffsetWire_1;
  BRepFill_ListOfOffsetWire_2: typeof BRepFill_ListOfOffsetWire_2;
  BRepFill_ListOfOffsetWire_3: typeof BRepFill_ListOfOffsetWire_3;
  Handle_BRepFill_SectionLaw: typeof Handle_BRepFill_SectionLaw;
  Handle_BRepFill_SectionLaw_1: typeof Handle_BRepFill_SectionLaw_1;
  Handle_BRepFill_SectionLaw_2: typeof Handle_BRepFill_SectionLaw_2;
  Handle_BRepFill_SectionLaw_3: typeof Handle_BRepFill_SectionLaw_3;
  Handle_BRepFill_SectionLaw_4: typeof Handle_BRepFill_SectionLaw_4;
  BRepFill_SectionLaw: typeof BRepFill_SectionLaw;
  Handle_BRepFill_ShapeLaw: typeof Handle_BRepFill_ShapeLaw;
  Handle_BRepFill_ShapeLaw_1: typeof Handle_BRepFill_ShapeLaw_1;
  Handle_BRepFill_ShapeLaw_2: typeof Handle_BRepFill_ShapeLaw_2;
  Handle_BRepFill_ShapeLaw_3: typeof Handle_BRepFill_ShapeLaw_3;
  Handle_BRepFill_ShapeLaw_4: typeof Handle_BRepFill_ShapeLaw_4;
  BRepFill_ShapeLaw: typeof BRepFill_ShapeLaw;
  BRepFill_ShapeLaw_1: typeof BRepFill_ShapeLaw_1;
  BRepFill_ShapeLaw_2: typeof BRepFill_ShapeLaw_2;
  BRepFill_ShapeLaw_3: typeof BRepFill_ShapeLaw_3;
  BRepFill_DataMapOfShapeDataMapOfShapeListOfShape: typeof BRepFill_DataMapOfShapeDataMapOfShapeListOfShape;
  BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_1: typeof BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_1;
  BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_2: typeof BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_2;
  BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_3: typeof BRepFill_DataMapOfShapeDataMapOfShapeListOfShape_3;
  BRepFill_DataMapOfShapeSequenceOfPnt: typeof BRepFill_DataMapOfShapeSequenceOfPnt;
  BRepFill_DataMapOfShapeSequenceOfPnt_1: typeof BRepFill_DataMapOfShapeSequenceOfPnt_1;
  BRepFill_DataMapOfShapeSequenceOfPnt_2: typeof BRepFill_DataMapOfShapeSequenceOfPnt_2;
  BRepFill_DataMapOfShapeSequenceOfPnt_3: typeof BRepFill_DataMapOfShapeSequenceOfPnt_3;
  Handle_BRepFill_ACRLaw: typeof Handle_BRepFill_ACRLaw;
  Handle_BRepFill_ACRLaw_1: typeof Handle_BRepFill_ACRLaw_1;
  Handle_BRepFill_ACRLaw_2: typeof Handle_BRepFill_ACRLaw_2;
  Handle_BRepFill_ACRLaw_3: typeof Handle_BRepFill_ACRLaw_3;
  Handle_BRepFill_ACRLaw_4: typeof Handle_BRepFill_ACRLaw_4;
  BRepFill_ACRLaw: typeof BRepFill_ACRLaw;
  BRepFill_Pipe: typeof BRepFill_Pipe;
  BRepFill_Pipe_1: typeof BRepFill_Pipe_1;
  BRepFill_Pipe_2: typeof BRepFill_Pipe_2;
  BRepFill_SectionPlacement: typeof BRepFill_SectionPlacement;
  BRepFill_SectionPlacement_1: typeof BRepFill_SectionPlacement_1;
  BRepFill_SectionPlacement_2: typeof BRepFill_SectionPlacement_2;
  BRepFill_ComputeCLine: typeof BRepFill_ComputeCLine;
  BRepFill_ComputeCLine_1: typeof BRepFill_ComputeCLine_1;
  BRepFill_ComputeCLine_2: typeof BRepFill_ComputeCLine_2;
  BRepFill_AdvancedEvolved: typeof BRepFill_AdvancedEvolved;
  BRepFill_TrimShellCorner: typeof BRepFill_TrimShellCorner;
  BRepFill_CurveConstraint: typeof BRepFill_CurveConstraint;
  BRepFill_CurveConstraint_1: typeof BRepFill_CurveConstraint_1;
  BRepFill_CurveConstraint_2: typeof BRepFill_CurveConstraint_2;
  Handle_BRepFill_CurveConstraint: typeof Handle_BRepFill_CurveConstraint;
  Handle_BRepFill_CurveConstraint_1: typeof Handle_BRepFill_CurveConstraint_1;
  Handle_BRepFill_CurveConstraint_2: typeof Handle_BRepFill_CurveConstraint_2;
  Handle_BRepFill_CurveConstraint_3: typeof Handle_BRepFill_CurveConstraint_3;
  Handle_BRepFill_CurveConstraint_4: typeof Handle_BRepFill_CurveConstraint_4;
  BRepFill_SequenceOfSection: typeof BRepFill_SequenceOfSection;
  BRepFill_SequenceOfSection_1: typeof BRepFill_SequenceOfSection_1;
  BRepFill_SequenceOfSection_2: typeof BRepFill_SequenceOfSection_2;
  BRepFill_SequenceOfSection_3: typeof BRepFill_SequenceOfSection_3;
  BRepFill_Edge3DLaw: typeof BRepFill_Edge3DLaw;
  Handle_BRepFill_Edge3DLaw: typeof Handle_BRepFill_Edge3DLaw;
  Handle_BRepFill_Edge3DLaw_1: typeof Handle_BRepFill_Edge3DLaw_1;
  Handle_BRepFill_Edge3DLaw_2: typeof Handle_BRepFill_Edge3DLaw_2;
  Handle_BRepFill_Edge3DLaw_3: typeof Handle_BRepFill_Edge3DLaw_3;
  Handle_BRepFill_Edge3DLaw_4: typeof Handle_BRepFill_Edge3DLaw_4;
  BRepFill: typeof BRepFill;
  BRepFill_FaceAndOrder: typeof BRepFill_FaceAndOrder;
  BRepFill_FaceAndOrder_1: typeof BRepFill_FaceAndOrder_1;
  BRepFill_FaceAndOrder_2: typeof BRepFill_FaceAndOrder_2;
  BRepFill_Sweep: typeof BRepFill_Sweep;
  BRepFill_Generator: typeof BRepFill_Generator;
  BRepFill_SequenceOfEdgeFaceAndOrder: typeof BRepFill_SequenceOfEdgeFaceAndOrder;
  BRepFill_SequenceOfEdgeFaceAndOrder_1: typeof BRepFill_SequenceOfEdgeFaceAndOrder_1;
  BRepFill_SequenceOfEdgeFaceAndOrder_2: typeof BRepFill_SequenceOfEdgeFaceAndOrder_2;
  BRepFill_SequenceOfEdgeFaceAndOrder_3: typeof BRepFill_SequenceOfEdgeFaceAndOrder_3;
  Handle_BRepFill_PipeShell: typeof Handle_BRepFill_PipeShell;
  Handle_BRepFill_PipeShell_1: typeof Handle_BRepFill_PipeShell_1;
  Handle_BRepFill_PipeShell_2: typeof Handle_BRepFill_PipeShell_2;
  Handle_BRepFill_PipeShell_3: typeof Handle_BRepFill_PipeShell_3;
  Handle_BRepFill_PipeShell_4: typeof Handle_BRepFill_PipeShell_4;
  BRepFill_PipeShell: typeof BRepFill_PipeShell;
  BRepFill_TrimSurfaceTool: typeof BRepFill_TrimSurfaceTool;
  BRepFill_ApproxSeewing: typeof BRepFill_ApproxSeewing;
  BRepFill_ApproxSeewing_1: typeof BRepFill_ApproxSeewing_1;
  BRepFill_ApproxSeewing_2: typeof BRepFill_ApproxSeewing_2;
  BRepFill_MultiLine: typeof BRepFill_MultiLine;
  BRepFill_MultiLine_1: typeof BRepFill_MultiLine_1;
  BRepFill_MultiLine_2: typeof BRepFill_MultiLine_2;
  BRepFill_OffsetWire: typeof BRepFill_OffsetWire;
  BRepFill_OffsetWire_1: typeof BRepFill_OffsetWire_1;
  BRepFill_OffsetWire_2: typeof BRepFill_OffsetWire_2;
  BRepFill_EdgeOnSurfLaw: typeof BRepFill_EdgeOnSurfLaw;
  Handle_BRepFill_EdgeOnSurfLaw: typeof Handle_BRepFill_EdgeOnSurfLaw;
  Handle_BRepFill_EdgeOnSurfLaw_1: typeof Handle_BRepFill_EdgeOnSurfLaw_1;
  Handle_BRepFill_EdgeOnSurfLaw_2: typeof Handle_BRepFill_EdgeOnSurfLaw_2;
  Handle_BRepFill_EdgeOnSurfLaw_3: typeof Handle_BRepFill_EdgeOnSurfLaw_3;
  Handle_BRepFill_EdgeOnSurfLaw_4: typeof Handle_BRepFill_EdgeOnSurfLaw_4;
  BRepFill_TrimEdgeTool: typeof BRepFill_TrimEdgeTool;
  BRepFill_TrimEdgeTool_1: typeof BRepFill_TrimEdgeTool_1;
  BRepFill_TrimEdgeTool_2: typeof BRepFill_TrimEdgeTool_2;
  BRepFill_TypeOfContact: BRepFill_TypeOfContact;
  BRepFill_DataMapOfOrientedShapeListOfShape: typeof BRepFill_DataMapOfOrientedShapeListOfShape;
  BRepFill_DataMapOfOrientedShapeListOfShape_1: typeof BRepFill_DataMapOfOrientedShapeListOfShape_1;
  BRepFill_DataMapOfOrientedShapeListOfShape_2: typeof BRepFill_DataMapOfOrientedShapeListOfShape_2;
  BRepFill_DataMapOfOrientedShapeListOfShape_3: typeof BRepFill_DataMapOfOrientedShapeListOfShape_3;
  BRepFill_SequenceOfFaceAndOrder: typeof BRepFill_SequenceOfFaceAndOrder;
  BRepFill_SequenceOfFaceAndOrder_1: typeof BRepFill_SequenceOfFaceAndOrder_1;
  BRepFill_SequenceOfFaceAndOrder_2: typeof BRepFill_SequenceOfFaceAndOrder_2;
  BRepFill_SequenceOfFaceAndOrder_3: typeof BRepFill_SequenceOfFaceAndOrder_3;
  BRepFill_DataMapOfShapeSequenceOfReal: typeof BRepFill_DataMapOfShapeSequenceOfReal;
  BRepFill_DataMapOfShapeSequenceOfReal_1: typeof BRepFill_DataMapOfShapeSequenceOfReal_1;
  BRepFill_DataMapOfShapeSequenceOfReal_2: typeof BRepFill_DataMapOfShapeSequenceOfReal_2;
  BRepFill_DataMapOfShapeSequenceOfReal_3: typeof BRepFill_DataMapOfShapeSequenceOfReal_3;
  BRepFill_OffsetAncestors: typeof BRepFill_OffsetAncestors;
  BRepFill_OffsetAncestors_1: typeof BRepFill_OffsetAncestors_1;
  BRepFill_OffsetAncestors_2: typeof BRepFill_OffsetAncestors_2;
  Handle_BRepFill_DraftLaw: typeof Handle_BRepFill_DraftLaw;
  Handle_BRepFill_DraftLaw_1: typeof Handle_BRepFill_DraftLaw_1;
  Handle_BRepFill_DraftLaw_2: typeof Handle_BRepFill_DraftLaw_2;
  Handle_BRepFill_DraftLaw_3: typeof Handle_BRepFill_DraftLaw_3;
  Handle_BRepFill_DraftLaw_4: typeof Handle_BRepFill_DraftLaw_4;
  BRepFill_DraftLaw: typeof BRepFill_DraftLaw;
  Handle_BRepFill_LocationLaw: typeof Handle_BRepFill_LocationLaw;
  Handle_BRepFill_LocationLaw_1: typeof Handle_BRepFill_LocationLaw_1;
  Handle_BRepFill_LocationLaw_2: typeof Handle_BRepFill_LocationLaw_2;
  Handle_BRepFill_LocationLaw_3: typeof Handle_BRepFill_LocationLaw_3;
  Handle_BRepFill_LocationLaw_4: typeof Handle_BRepFill_LocationLaw_4;
  BRepFill_LocationLaw: typeof BRepFill_LocationLaw;
  BRepFill_Section: typeof BRepFill_Section;
  BRepFill_Section_1: typeof BRepFill_Section_1;
  BRepFill_Section_2: typeof BRepFill_Section_2;
  BRepFill_TransitionStyle: BRepFill_TransitionStyle;
  Handle_BRepFill_NSections: typeof Handle_BRepFill_NSections;
  Handle_BRepFill_NSections_1: typeof Handle_BRepFill_NSections_1;
  Handle_BRepFill_NSections_2: typeof Handle_BRepFill_NSections_2;
  Handle_BRepFill_NSections_3: typeof Handle_BRepFill_NSections_3;
  Handle_BRepFill_NSections_4: typeof Handle_BRepFill_NSections_4;
  BRepFill_NSections: typeof BRepFill_NSections;
  BRepFill_NSections_1: typeof BRepFill_NSections_1;
  BRepFill_NSections_2: typeof BRepFill_NSections_2;
  Bnd_SeqOfBox: typeof Bnd_SeqOfBox;
  Bnd_SeqOfBox_1: typeof Bnd_SeqOfBox_1;
  Bnd_SeqOfBox_2: typeof Bnd_SeqOfBox_2;
  Bnd_SeqOfBox_3: typeof Bnd_SeqOfBox_3;
  Handle_Bnd_HArray1OfBox2d: typeof Handle_Bnd_HArray1OfBox2d;
  Handle_Bnd_HArray1OfBox2d_1: typeof Handle_Bnd_HArray1OfBox2d_1;
  Handle_Bnd_HArray1OfBox2d_2: typeof Handle_Bnd_HArray1OfBox2d_2;
  Handle_Bnd_HArray1OfBox2d_3: typeof Handle_Bnd_HArray1OfBox2d_3;
  Handle_Bnd_HArray1OfBox2d_4: typeof Handle_Bnd_HArray1OfBox2d_4;
  Bnd_B2f: typeof Bnd_B2f;
  Bnd_B2f_1: typeof Bnd_B2f_1;
  Bnd_B2f_2: typeof Bnd_B2f_2;
  Bnd_Array1OfSphere: typeof Bnd_Array1OfSphere;
  Bnd_Array1OfSphere_1: typeof Bnd_Array1OfSphere_1;
  Bnd_Array1OfSphere_2: typeof Bnd_Array1OfSphere_2;
  Bnd_Array1OfSphere_3: typeof Bnd_Array1OfSphere_3;
  Bnd_Array1OfSphere_4: typeof Bnd_Array1OfSphere_4;
  Bnd_Array1OfSphere_5: typeof Bnd_Array1OfSphere_5;
  Bnd_Range: typeof Bnd_Range;
  Bnd_Range_1: typeof Bnd_Range_1;
  Bnd_Range_2: typeof Bnd_Range_2;
  Bnd_B3d: typeof Bnd_B3d;
  Bnd_B3d_1: typeof Bnd_B3d_1;
  Bnd_B3d_2: typeof Bnd_B3d_2;
  Bnd_Tools: typeof Bnd_Tools;
  Bnd_BoundSortBox: typeof Bnd_BoundSortBox;
  Handle_Bnd_HArray1OfSphere: typeof Handle_Bnd_HArray1OfSphere;
  Handle_Bnd_HArray1OfSphere_1: typeof Handle_Bnd_HArray1OfSphere_1;
  Handle_Bnd_HArray1OfSphere_2: typeof Handle_Bnd_HArray1OfSphere_2;
  Handle_Bnd_HArray1OfSphere_3: typeof Handle_Bnd_HArray1OfSphere_3;
  Handle_Bnd_HArray1OfSphere_4: typeof Handle_Bnd_HArray1OfSphere_4;
  Bnd_OBB: typeof Bnd_OBB;
  Bnd_OBB_1: typeof Bnd_OBB_1;
  Bnd_OBB_2: typeof Bnd_OBB_2;
  Bnd_OBB_3: typeof Bnd_OBB_3;
  Bnd_Box2d: typeof Bnd_Box2d;
  Bnd_B2d: typeof Bnd_B2d;
  Bnd_B2d_1: typeof Bnd_B2d_1;
  Bnd_B2d_2: typeof Bnd_B2d_2;
  Bnd_Box: typeof Bnd_Box;
  Bnd_Box_1: typeof Bnd_Box_1;
  Bnd_Box_2: typeof Bnd_Box_2;
  Bnd_Sphere: typeof Bnd_Sphere;
  Bnd_Sphere_1: typeof Bnd_Sphere_1;
  Bnd_Sphere_2: typeof Bnd_Sphere_2;
  Bnd_B3f: typeof Bnd_B3f;
  Bnd_B3f_1: typeof Bnd_B3f_1;
  Bnd_B3f_2: typeof Bnd_B3f_2;
  Bnd_Array1OfBox2d: typeof Bnd_Array1OfBox2d;
  Bnd_Array1OfBox2d_1: typeof Bnd_Array1OfBox2d_1;
  Bnd_Array1OfBox2d_2: typeof Bnd_Array1OfBox2d_2;
  Bnd_Array1OfBox2d_3: typeof Bnd_Array1OfBox2d_3;
  Bnd_Array1OfBox2d_4: typeof Bnd_Array1OfBox2d_4;
  Bnd_Array1OfBox2d_5: typeof Bnd_Array1OfBox2d_5;
  Bnd_BoundSortBox2d: typeof Bnd_BoundSortBox2d;
  Bnd_Array1OfBox: typeof Bnd_Array1OfBox;
  Bnd_Array1OfBox_1: typeof Bnd_Array1OfBox_1;
  Bnd_Array1OfBox_2: typeof Bnd_Array1OfBox_2;
  Bnd_Array1OfBox_3: typeof Bnd_Array1OfBox_3;
  Bnd_Array1OfBox_4: typeof Bnd_Array1OfBox_4;
  Bnd_Array1OfBox_5: typeof Bnd_Array1OfBox_5;
  Handle_Bnd_HArray1OfBox: typeof Handle_Bnd_HArray1OfBox;
  Handle_Bnd_HArray1OfBox_1: typeof Handle_Bnd_HArray1OfBox_1;
  Handle_Bnd_HArray1OfBox_2: typeof Handle_Bnd_HArray1OfBox_2;
  Handle_Bnd_HArray1OfBox_3: typeof Handle_Bnd_HArray1OfBox_3;
  Handle_Bnd_HArray1OfBox_4: typeof Handle_Bnd_HArray1OfBox_4;
  BRepClass_Intersector: typeof BRepClass_Intersector;
  BRepClass_FClass2dOfFClassifier: typeof BRepClass_FClass2dOfFClassifier;
  BRepClass_Edge: typeof BRepClass_Edge;
  BRepClass_Edge_1: typeof BRepClass_Edge_1;
  BRepClass_Edge_2: typeof BRepClass_Edge_2;
  BRepClass_FacePassiveClassifier: typeof BRepClass_FacePassiveClassifier;
  BRepClass_FClassifier: typeof BRepClass_FClassifier;
  BRepClass_FClassifier_1: typeof BRepClass_FClassifier_1;
  BRepClass_FClassifier_2: typeof BRepClass_FClassifier_2;
  BRepClass_FaceExplorer: typeof BRepClass_FaceExplorer;
  BRepClass_FaceClassifier: typeof BRepClass_FaceClassifier;
  BRepClass_FaceClassifier_1: typeof BRepClass_FaceClassifier_1;
  BRepClass_FaceClassifier_2: typeof BRepClass_FaceClassifier_2;
  BRepClass_FaceClassifier_3: typeof BRepClass_FaceClassifier_3;
  BRepClass_FaceClassifier_4: typeof BRepClass_FaceClassifier_4;
  ChFiKPart_ComputeData: typeof ChFiKPart_ComputeData;
  GeomAdaptor_SurfaceOfLinearExtrusion: typeof GeomAdaptor_SurfaceOfLinearExtrusion;
  GeomAdaptor_SurfaceOfLinearExtrusion_1: typeof GeomAdaptor_SurfaceOfLinearExtrusion_1;
  GeomAdaptor_SurfaceOfLinearExtrusion_2: typeof GeomAdaptor_SurfaceOfLinearExtrusion_2;
  GeomAdaptor_SurfaceOfLinearExtrusion_3: typeof GeomAdaptor_SurfaceOfLinearExtrusion_3;
  Handle_GeomAdaptor_GHSurface: typeof Handle_GeomAdaptor_GHSurface;
  Handle_GeomAdaptor_GHSurface_1: typeof Handle_GeomAdaptor_GHSurface_1;
  Handle_GeomAdaptor_GHSurface_2: typeof Handle_GeomAdaptor_GHSurface_2;
  Handle_GeomAdaptor_GHSurface_3: typeof Handle_GeomAdaptor_GHSurface_3;
  Handle_GeomAdaptor_GHSurface_4: typeof Handle_GeomAdaptor_GHSurface_4;
  GeomAdaptor_GHSurface: typeof GeomAdaptor_GHSurface;
  GeomAdaptor_GHSurface_1: typeof GeomAdaptor_GHSurface_1;
  GeomAdaptor_GHSurface_2: typeof GeomAdaptor_GHSurface_2;
  GeomAdaptor_HSurfaceOfLinearExtrusion: typeof GeomAdaptor_HSurfaceOfLinearExtrusion;
  GeomAdaptor_HSurfaceOfLinearExtrusion_1: typeof GeomAdaptor_HSurfaceOfLinearExtrusion_1;
  GeomAdaptor_HSurfaceOfLinearExtrusion_2: typeof GeomAdaptor_HSurfaceOfLinearExtrusion_2;
  Handle_GeomAdaptor_HSurfaceOfLinearExtrusion: typeof Handle_GeomAdaptor_HSurfaceOfLinearExtrusion;
  Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_1: typeof Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_1;
  Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_2: typeof Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_2;
  Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_3: typeof Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_3;
  Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_4: typeof Handle_GeomAdaptor_HSurfaceOfLinearExtrusion_4;
  GeomAdaptor_Surface: typeof GeomAdaptor_Surface;
  GeomAdaptor_Surface_1: typeof GeomAdaptor_Surface_1;
  GeomAdaptor_Surface_2: typeof GeomAdaptor_Surface_2;
  GeomAdaptor_Surface_3: typeof GeomAdaptor_Surface_3;
  Handle_GeomAdaptor_HSurface: typeof Handle_GeomAdaptor_HSurface;
  Handle_GeomAdaptor_HSurface_1: typeof Handle_GeomAdaptor_HSurface_1;
  Handle_GeomAdaptor_HSurface_2: typeof Handle_GeomAdaptor_HSurface_2;
  Handle_GeomAdaptor_HSurface_3: typeof Handle_GeomAdaptor_HSurface_3;
  Handle_GeomAdaptor_HSurface_4: typeof Handle_GeomAdaptor_HSurface_4;
  GeomAdaptor_HSurface: typeof GeomAdaptor_HSurface;
  GeomAdaptor_HSurface_1: typeof GeomAdaptor_HSurface_1;
  GeomAdaptor_HSurface_2: typeof GeomAdaptor_HSurface_2;
  GeomAdaptor_HSurface_3: typeof GeomAdaptor_HSurface_3;
  GeomAdaptor_HSurface_4: typeof GeomAdaptor_HSurface_4;
  GeomAdaptor: typeof GeomAdaptor;
  GeomAdaptor_SurfaceOfRevolution: typeof GeomAdaptor_SurfaceOfRevolution;
  GeomAdaptor_SurfaceOfRevolution_1: typeof GeomAdaptor_SurfaceOfRevolution_1;
  GeomAdaptor_SurfaceOfRevolution_2: typeof GeomAdaptor_SurfaceOfRevolution_2;
  GeomAdaptor_SurfaceOfRevolution_3: typeof GeomAdaptor_SurfaceOfRevolution_3;
  GeomAdaptor_HSurfaceOfRevolution: typeof GeomAdaptor_HSurfaceOfRevolution;
  GeomAdaptor_HSurfaceOfRevolution_1: typeof GeomAdaptor_HSurfaceOfRevolution_1;
  GeomAdaptor_HSurfaceOfRevolution_2: typeof GeomAdaptor_HSurfaceOfRevolution_2;
  Handle_GeomAdaptor_HSurfaceOfRevolution: typeof Handle_GeomAdaptor_HSurfaceOfRevolution;
  Handle_GeomAdaptor_HSurfaceOfRevolution_1: typeof Handle_GeomAdaptor_HSurfaceOfRevolution_1;
  Handle_GeomAdaptor_HSurfaceOfRevolution_2: typeof Handle_GeomAdaptor_HSurfaceOfRevolution_2;
  Handle_GeomAdaptor_HSurfaceOfRevolution_3: typeof Handle_GeomAdaptor_HSurfaceOfRevolution_3;
  Handle_GeomAdaptor_HSurfaceOfRevolution_4: typeof Handle_GeomAdaptor_HSurfaceOfRevolution_4;
  Handle_GeomAdaptor_HCurve: typeof Handle_GeomAdaptor_HCurve;
  Handle_GeomAdaptor_HCurve_1: typeof Handle_GeomAdaptor_HCurve_1;
  Handle_GeomAdaptor_HCurve_2: typeof Handle_GeomAdaptor_HCurve_2;
  Handle_GeomAdaptor_HCurve_3: typeof Handle_GeomAdaptor_HCurve_3;
  Handle_GeomAdaptor_HCurve_4: typeof Handle_GeomAdaptor_HCurve_4;
  GeomAdaptor_HCurve: typeof GeomAdaptor_HCurve;
  GeomAdaptor_HCurve_1: typeof GeomAdaptor_HCurve_1;
  GeomAdaptor_HCurve_2: typeof GeomAdaptor_HCurve_2;
  GeomAdaptor_HCurve_3: typeof GeomAdaptor_HCurve_3;
  GeomAdaptor_HCurve_4: typeof GeomAdaptor_HCurve_4;
  GeomAdaptor_GHCurve: typeof GeomAdaptor_GHCurve;
  GeomAdaptor_GHCurve_1: typeof GeomAdaptor_GHCurve_1;
  GeomAdaptor_GHCurve_2: typeof GeomAdaptor_GHCurve_2;
  Handle_GeomAdaptor_GHCurve: typeof Handle_GeomAdaptor_GHCurve;
  Handle_GeomAdaptor_GHCurve_1: typeof Handle_GeomAdaptor_GHCurve_1;
  Handle_GeomAdaptor_GHCurve_2: typeof Handle_GeomAdaptor_GHCurve_2;
  Handle_GeomAdaptor_GHCurve_3: typeof Handle_GeomAdaptor_GHCurve_3;
  Handle_GeomAdaptor_GHCurve_4: typeof Handle_GeomAdaptor_GHCurve_4;
  GeomAdaptor_Curve: typeof GeomAdaptor_Curve;
  GeomAdaptor_Curve_1: typeof GeomAdaptor_Curve_1;
  GeomAdaptor_Curve_2: typeof GeomAdaptor_Curve_2;
  GeomAdaptor_Curve_3: typeof GeomAdaptor_Curve_3;
  GC_MakeTrimmedCylinder: typeof GC_MakeTrimmedCylinder;
  GC_MakeTrimmedCylinder_1: typeof GC_MakeTrimmedCylinder_1;
  GC_MakeTrimmedCylinder_2: typeof GC_MakeTrimmedCylinder_2;
  GC_MakeTrimmedCylinder_3: typeof GC_MakeTrimmedCylinder_3;
  GC_MakeSegment: typeof GC_MakeSegment;
  GC_MakeSegment_1: typeof GC_MakeSegment_1;
  GC_MakeSegment_2: typeof GC_MakeSegment_2;
  GC_MakeSegment_3: typeof GC_MakeSegment_3;
  GC_MakeSegment_4: typeof GC_MakeSegment_4;
  GC_MakeArcOfHyperbola: typeof GC_MakeArcOfHyperbola;
  GC_MakeArcOfHyperbola_1: typeof GC_MakeArcOfHyperbola_1;
  GC_MakeArcOfHyperbola_2: typeof GC_MakeArcOfHyperbola_2;
  GC_MakeArcOfHyperbola_3: typeof GC_MakeArcOfHyperbola_3;
  GC_MakeTrimmedCone: typeof GC_MakeTrimmedCone;
  GC_MakeTrimmedCone_1: typeof GC_MakeTrimmedCone_1;
  GC_MakeTrimmedCone_2: typeof GC_MakeTrimmedCone_2;
  GC_MakeCylindricalSurface: typeof GC_MakeCylindricalSurface;
  GC_MakeCylindricalSurface_1: typeof GC_MakeCylindricalSurface_1;
  GC_MakeCylindricalSurface_2: typeof GC_MakeCylindricalSurface_2;
  GC_MakeCylindricalSurface_3: typeof GC_MakeCylindricalSurface_3;
  GC_MakeCylindricalSurface_4: typeof GC_MakeCylindricalSurface_4;
  GC_MakeCylindricalSurface_5: typeof GC_MakeCylindricalSurface_5;
  GC_MakeCylindricalSurface_6: typeof GC_MakeCylindricalSurface_6;
  GC_MakeCylindricalSurface_7: typeof GC_MakeCylindricalSurface_7;
  GC_MakeLine: typeof GC_MakeLine;
  GC_MakeLine_1: typeof GC_MakeLine_1;
  GC_MakeLine_2: typeof GC_MakeLine_2;
  GC_MakeLine_3: typeof GC_MakeLine_3;
  GC_MakeLine_4: typeof GC_MakeLine_4;
  GC_MakeLine_5: typeof GC_MakeLine_5;
  GC_MakeCircle: typeof GC_MakeCircle;
  GC_MakeCircle_1: typeof GC_MakeCircle_1;
  GC_MakeCircle_2: typeof GC_MakeCircle_2;
  GC_MakeCircle_3: typeof GC_MakeCircle_3;
  GC_MakeCircle_4: typeof GC_MakeCircle_4;
  GC_MakeCircle_5: typeof GC_MakeCircle_5;
  GC_MakeCircle_6: typeof GC_MakeCircle_6;
  GC_MakeCircle_7: typeof GC_MakeCircle_7;
  GC_MakeCircle_8: typeof GC_MakeCircle_8;
  GC_MakeTranslation: typeof GC_MakeTranslation;
  GC_MakeTranslation_1: typeof GC_MakeTranslation_1;
  GC_MakeTranslation_2: typeof GC_MakeTranslation_2;
  GC_MakeArcOfEllipse: typeof GC_MakeArcOfEllipse;
  GC_MakeArcOfEllipse_1: typeof GC_MakeArcOfEllipse_1;
  GC_MakeArcOfEllipse_2: typeof GC_MakeArcOfEllipse_2;
  GC_MakeArcOfEllipse_3: typeof GC_MakeArcOfEllipse_3;
  GC_MakeArcOfCircle: typeof GC_MakeArcOfCircle;
  GC_MakeArcOfCircle_1: typeof GC_MakeArcOfCircle_1;
  GC_MakeArcOfCircle_2: typeof GC_MakeArcOfCircle_2;
  GC_MakeArcOfCircle_3: typeof GC_MakeArcOfCircle_3;
  GC_MakeArcOfCircle_4: typeof GC_MakeArcOfCircle_4;
  GC_MakeArcOfCircle_5: typeof GC_MakeArcOfCircle_5;
  GC_MakeConicalSurface: typeof GC_MakeConicalSurface;
  GC_MakeConicalSurface_1: typeof GC_MakeConicalSurface_1;
  GC_MakeConicalSurface_2: typeof GC_MakeConicalSurface_2;
  GC_MakeConicalSurface_3: typeof GC_MakeConicalSurface_3;
  GC_MakeConicalSurface_4: typeof GC_MakeConicalSurface_4;
  GC_MakeMirror: typeof GC_MakeMirror;
  GC_MakeMirror_1: typeof GC_MakeMirror_1;
  GC_MakeMirror_2: typeof GC_MakeMirror_2;
  GC_MakeMirror_3: typeof GC_MakeMirror_3;
  GC_MakeMirror_4: typeof GC_MakeMirror_4;
  GC_MakeMirror_5: typeof GC_MakeMirror_5;
  GC_MakeMirror_6: typeof GC_MakeMirror_6;
  GC_MakeScale: typeof GC_MakeScale;
  GC_MakeRotation: typeof GC_MakeRotation;
  GC_MakeRotation_1: typeof GC_MakeRotation_1;
  GC_MakeRotation_2: typeof GC_MakeRotation_2;
  GC_MakeRotation_3: typeof GC_MakeRotation_3;
  GC_MakeHyperbola: typeof GC_MakeHyperbola;
  GC_MakeHyperbola_1: typeof GC_MakeHyperbola_1;
  GC_MakeHyperbola_2: typeof GC_MakeHyperbola_2;
  GC_MakeHyperbola_3: typeof GC_MakeHyperbola_3;
  GC_MakePlane: typeof GC_MakePlane;
  GC_MakePlane_1: typeof GC_MakePlane_1;
  GC_MakePlane_2: typeof GC_MakePlane_2;
  GC_MakePlane_3: typeof GC_MakePlane_3;
  GC_MakePlane_4: typeof GC_MakePlane_4;
  GC_MakePlane_5: typeof GC_MakePlane_5;
  GC_MakePlane_6: typeof GC_MakePlane_6;
  GC_MakePlane_7: typeof GC_MakePlane_7;
  GC_Root: typeof GC_Root;
  GC_MakeEllipse: typeof GC_MakeEllipse;
  GC_MakeEllipse_1: typeof GC_MakeEllipse_1;
  GC_MakeEllipse_2: typeof GC_MakeEllipse_2;
  GC_MakeEllipse_3: typeof GC_MakeEllipse_3;
  GC_MakeArcOfParabola: typeof GC_MakeArcOfParabola;
  GC_MakeArcOfParabola_1: typeof GC_MakeArcOfParabola_1;
  GC_MakeArcOfParabola_2: typeof GC_MakeArcOfParabola_2;
  GC_MakeArcOfParabola_3: typeof GC_MakeArcOfParabola_3;
  TopLoc_Location: typeof TopLoc_Location;
  TopLoc_Location_1: typeof TopLoc_Location_1;
  TopLoc_Location_2: typeof TopLoc_Location_2;
  TopLoc_Location_3: typeof TopLoc_Location_3;
  TopLoc_MapLocationHasher: typeof TopLoc_MapLocationHasher;
  Handle_TopLoc_Datum3D: typeof Handle_TopLoc_Datum3D;
  Handle_TopLoc_Datum3D_1: typeof Handle_TopLoc_Datum3D_1;
  Handle_TopLoc_Datum3D_2: typeof Handle_TopLoc_Datum3D_2;
  Handle_TopLoc_Datum3D_3: typeof Handle_TopLoc_Datum3D_3;
  Handle_TopLoc_Datum3D_4: typeof Handle_TopLoc_Datum3D_4;
  TopLoc_Datum3D: typeof TopLoc_Datum3D;
  TopLoc_Datum3D_1: typeof TopLoc_Datum3D_1;
  TopLoc_Datum3D_2: typeof TopLoc_Datum3D_2;
  TopLoc_IndexedMapOfLocation: typeof TopLoc_IndexedMapOfLocation;
  TopLoc_IndexedMapOfLocation_1: typeof TopLoc_IndexedMapOfLocation_1;
  TopLoc_IndexedMapOfLocation_2: typeof TopLoc_IndexedMapOfLocation_2;
  TopLoc_IndexedMapOfLocation_3: typeof TopLoc_IndexedMapOfLocation_3;
  TopLoc_ItemLocation: typeof TopLoc_ItemLocation;
  TopLoc_SListNodeOfItemLocation: typeof TopLoc_SListNodeOfItemLocation;
  Handle_TopLoc_SListNodeOfItemLocation: typeof Handle_TopLoc_SListNodeOfItemLocation;
  Handle_TopLoc_SListNodeOfItemLocation_1: typeof Handle_TopLoc_SListNodeOfItemLocation_1;
  Handle_TopLoc_SListNodeOfItemLocation_2: typeof Handle_TopLoc_SListNodeOfItemLocation_2;
  Handle_TopLoc_SListNodeOfItemLocation_3: typeof Handle_TopLoc_SListNodeOfItemLocation_3;
  Handle_TopLoc_SListNodeOfItemLocation_4: typeof Handle_TopLoc_SListNodeOfItemLocation_4;
  TopLoc_SListOfItemLocation: typeof TopLoc_SListOfItemLocation;
  TopLoc_SListOfItemLocation_1: typeof TopLoc_SListOfItemLocation_1;
  TopLoc_SListOfItemLocation_2: typeof TopLoc_SListOfItemLocation_2;
  TopLoc_SListOfItemLocation_3: typeof TopLoc_SListOfItemLocation_3;
  TopLoc_SListOfItemLocation_4: typeof TopLoc_SListOfItemLocation_4;
  TopLoc_MapOfLocation: typeof TopLoc_MapOfLocation;
  TopLoc_MapOfLocation_1: typeof TopLoc_MapOfLocation_1;
  TopLoc_MapOfLocation_2: typeof TopLoc_MapOfLocation_2;
  TopLoc_MapOfLocation_3: typeof TopLoc_MapOfLocation_3;
  FSD_Base64Decoder: typeof FSD_Base64Decoder;
  Handle_FSD_File: typeof Handle_FSD_File;
  Handle_FSD_File_1: typeof Handle_FSD_File_1;
  Handle_FSD_File_2: typeof Handle_FSD_File_2;
  Handle_FSD_File_3: typeof Handle_FSD_File_3;
  Handle_FSD_File_4: typeof Handle_FSD_File_4;
  Handle_FSD_CmpFile: typeof Handle_FSD_CmpFile;
  Handle_FSD_CmpFile_1: typeof Handle_FSD_CmpFile_1;
  Handle_FSD_CmpFile_2: typeof Handle_FSD_CmpFile_2;
  Handle_FSD_CmpFile_3: typeof Handle_FSD_CmpFile_3;
  Handle_FSD_CmpFile_4: typeof Handle_FSD_CmpFile_4;
  FSD_CmpFile: typeof FSD_CmpFile;
  Handle_FSD_BinaryFile: typeof Handle_FSD_BinaryFile;
  Handle_FSD_BinaryFile_1: typeof Handle_FSD_BinaryFile_1;
  Handle_FSD_BinaryFile_2: typeof Handle_FSD_BinaryFile_2;
  Handle_FSD_BinaryFile_3: typeof Handle_FSD_BinaryFile_3;
  Handle_FSD_BinaryFile_4: typeof Handle_FSD_BinaryFile_4;
  FSD_FileHeader: typeof FSD_FileHeader;
  TCollection_Side: TCollection_Side;
  TCollection_ExtendedString: typeof TCollection_ExtendedString;
  TCollection_ExtendedString_1: typeof TCollection_ExtendedString_1;
  TCollection_ExtendedString_2: typeof TCollection_ExtendedString_2;
  TCollection_ExtendedString_3: typeof TCollection_ExtendedString_3;
  TCollection_ExtendedString_4: typeof TCollection_ExtendedString_4;
  TCollection_ExtendedString_5: typeof TCollection_ExtendedString_5;
  TCollection_ExtendedString_6: typeof TCollection_ExtendedString_6;
  TCollection_ExtendedString_7: typeof TCollection_ExtendedString_7;
  TCollection_ExtendedString_8: typeof TCollection_ExtendedString_8;
  TCollection_ExtendedString_9: typeof TCollection_ExtendedString_9;
  TCollection_ExtendedString_10: typeof TCollection_ExtendedString_10;
  TCollection_ExtendedString_11: typeof TCollection_ExtendedString_11;
  TCollection_ExtendedString_12: typeof TCollection_ExtendedString_12;
  Handle_TCollection_MapNode: typeof Handle_TCollection_MapNode;
  Handle_TCollection_MapNode_1: typeof Handle_TCollection_MapNode_1;
  Handle_TCollection_MapNode_2: typeof Handle_TCollection_MapNode_2;
  Handle_TCollection_MapNode_3: typeof Handle_TCollection_MapNode_3;
  Handle_TCollection_MapNode_4: typeof Handle_TCollection_MapNode_4;
  TCollection_MapNode: typeof TCollection_MapNode;
  TCollection_BaseSequence: typeof TCollection_BaseSequence;
  TCollection: typeof TCollection;
  TCollection_SeqNode: typeof TCollection_SeqNode;
  Handle_TCollection_SeqNode: typeof Handle_TCollection_SeqNode;
  Handle_TCollection_SeqNode_1: typeof Handle_TCollection_SeqNode_1;
  Handle_TCollection_SeqNode_2: typeof Handle_TCollection_SeqNode_2;
  Handle_TCollection_SeqNode_3: typeof Handle_TCollection_SeqNode_3;
  Handle_TCollection_SeqNode_4: typeof Handle_TCollection_SeqNode_4;
  TCollection_BasicMapIterator: typeof TCollection_BasicMapIterator;
  TCollection_BasicMap: typeof TCollection_BasicMap;
  Handle_TCollection_HAsciiString: typeof Handle_TCollection_HAsciiString;
  Handle_TCollection_HAsciiString_1: typeof Handle_TCollection_HAsciiString_1;
  Handle_TCollection_HAsciiString_2: typeof Handle_TCollection_HAsciiString_2;
  Handle_TCollection_HAsciiString_3: typeof Handle_TCollection_HAsciiString_3;
  Handle_TCollection_HAsciiString_4: typeof Handle_TCollection_HAsciiString_4;
  TCollection_HAsciiString: typeof TCollection_HAsciiString;
  TCollection_HAsciiString_1: typeof TCollection_HAsciiString_1;
  TCollection_HAsciiString_2: typeof TCollection_HAsciiString_2;
  TCollection_HAsciiString_3: typeof TCollection_HAsciiString_3;
  TCollection_HAsciiString_4: typeof TCollection_HAsciiString_4;
  TCollection_HAsciiString_5: typeof TCollection_HAsciiString_5;
  TCollection_HAsciiString_6: typeof TCollection_HAsciiString_6;
  TCollection_HAsciiString_7: typeof TCollection_HAsciiString_7;
  TCollection_HAsciiString_8: typeof TCollection_HAsciiString_8;
  TCollection_HAsciiString_9: typeof TCollection_HAsciiString_9;
  TCollection_AsciiString: typeof TCollection_AsciiString;
  TCollection_AsciiString_1: typeof TCollection_AsciiString_1;
  TCollection_AsciiString_2: typeof TCollection_AsciiString_2;
  TCollection_AsciiString_3: typeof TCollection_AsciiString_3;
  TCollection_AsciiString_4: typeof TCollection_AsciiString_4;
  TCollection_AsciiString_5: typeof TCollection_AsciiString_5;
  TCollection_AsciiString_6: typeof TCollection_AsciiString_6;
  TCollection_AsciiString_7: typeof TCollection_AsciiString_7;
  TCollection_AsciiString_8: typeof TCollection_AsciiString_8;
  TCollection_AsciiString_9: typeof TCollection_AsciiString_9;
  TCollection_AsciiString_10: typeof TCollection_AsciiString_10;
  TCollection_AsciiString_11: typeof TCollection_AsciiString_11;
  TCollection_AsciiString_12: typeof TCollection_AsciiString_12;
  TCollection_AsciiString_13: typeof TCollection_AsciiString_13;
  TCollection_AsciiString_14: typeof TCollection_AsciiString_14;
  TCollection_HExtendedString: typeof TCollection_HExtendedString;
  TCollection_HExtendedString_1: typeof TCollection_HExtendedString_1;
  TCollection_HExtendedString_2: typeof TCollection_HExtendedString_2;
  TCollection_HExtendedString_3: typeof TCollection_HExtendedString_3;
  TCollection_HExtendedString_4: typeof TCollection_HExtendedString_4;
  TCollection_HExtendedString_5: typeof TCollection_HExtendedString_5;
  TCollection_HExtendedString_6: typeof TCollection_HExtendedString_6;
  TCollection_HExtendedString_7: typeof TCollection_HExtendedString_7;
  TCollection_HExtendedString_8: typeof TCollection_HExtendedString_8;
  Handle_TCollection_HExtendedString: typeof Handle_TCollection_HExtendedString;
  Handle_TCollection_HExtendedString_1: typeof Handle_TCollection_HExtendedString_1;
  Handle_TCollection_HExtendedString_2: typeof Handle_TCollection_HExtendedString_2;
  Handle_TCollection_HExtendedString_3: typeof Handle_TCollection_HExtendedString_3;
  Handle_TCollection_HExtendedString_4: typeof Handle_TCollection_HExtendedString_4;
  BRepOffset_DataMapOfShapeOffset: typeof BRepOffset_DataMapOfShapeOffset;
  BRepOffset_DataMapOfShapeOffset_1: typeof BRepOffset_DataMapOfShapeOffset_1;
  BRepOffset_DataMapOfShapeOffset_2: typeof BRepOffset_DataMapOfShapeOffset_2;
  BRepOffset_DataMapOfShapeOffset_3: typeof BRepOffset_DataMapOfShapeOffset_3;
  BRepOffset_Inter2d: typeof BRepOffset_Inter2d;
  BRepOffset_ListOfInterval: typeof BRepOffset_ListOfInterval;
  BRepOffset_ListOfInterval_1: typeof BRepOffset_ListOfInterval_1;
  BRepOffset_ListOfInterval_2: typeof BRepOffset_ListOfInterval_2;
  BRepOffset_ListOfInterval_3: typeof BRepOffset_ListOfInterval_3;
  BRepOffset_Error: BRepOffset_Error;
  BRepOffset_DataMapOfShapeMapOfShape: typeof BRepOffset_DataMapOfShapeMapOfShape;
  BRepOffset_DataMapOfShapeMapOfShape_1: typeof BRepOffset_DataMapOfShapeMapOfShape_1;
  BRepOffset_DataMapOfShapeMapOfShape_2: typeof BRepOffset_DataMapOfShapeMapOfShape_2;
  BRepOffset_DataMapOfShapeMapOfShape_3: typeof BRepOffset_DataMapOfShapeMapOfShape_3;
  BRepOffset_Analyse: typeof BRepOffset_Analyse;
  BRepOffset_Analyse_1: typeof BRepOffset_Analyse_1;
  BRepOffset_Analyse_2: typeof BRepOffset_Analyse_2;
  BRepOffset_DataMapOfShapeListOfInterval: typeof BRepOffset_DataMapOfShapeListOfInterval;
  BRepOffset_DataMapOfShapeListOfInterval_1: typeof BRepOffset_DataMapOfShapeListOfInterval_1;
  BRepOffset_DataMapOfShapeListOfInterval_2: typeof BRepOffset_DataMapOfShapeListOfInterval_2;
  BRepOffset_DataMapOfShapeListOfInterval_3: typeof BRepOffset_DataMapOfShapeListOfInterval_3;
  BRepOffset_Mode: BRepOffset_Mode;
  BRepOffset_Status: BRepOffset_Status;
  BRepOffset_Inter3d: typeof BRepOffset_Inter3d;
  BRepOffset_Offset: typeof BRepOffset_Offset;
  BRepOffset_Offset_1: typeof BRepOffset_Offset_1;
  BRepOffset_Offset_2: typeof BRepOffset_Offset_2;
  BRepOffset_Offset_3: typeof BRepOffset_Offset_3;
  BRepOffset_Offset_4: typeof BRepOffset_Offset_4;
  BRepOffset_Offset_5: typeof BRepOffset_Offset_5;
  BRepOffset_Offset_6: typeof BRepOffset_Offset_6;
  BRepOffset_Interval: typeof BRepOffset_Interval;
  BRepOffset_Interval_1: typeof BRepOffset_Interval_1;
  BRepOffset_Interval_2: typeof BRepOffset_Interval_2;
  BRepOffset: typeof BRepOffset;
  BRepOffset_MakeLoops: typeof BRepOffset_MakeLoops;
  BRepOffset_SimpleOffset: typeof BRepOffset_SimpleOffset;
  Handle_BRepOffset_SimpleOffset: typeof Handle_BRepOffset_SimpleOffset;
  Handle_BRepOffset_SimpleOffset_1: typeof Handle_BRepOffset_SimpleOffset_1;
  Handle_BRepOffset_SimpleOffset_2: typeof Handle_BRepOffset_SimpleOffset_2;
  Handle_BRepOffset_SimpleOffset_3: typeof Handle_BRepOffset_SimpleOffset_3;
  Handle_BRepOffset_SimpleOffset_4: typeof Handle_BRepOffset_SimpleOffset_4;
  BRepOffset_MakeSimpleOffset: typeof BRepOffset_MakeSimpleOffset;
  BRepOffset_MakeSimpleOffset_1: typeof BRepOffset_MakeSimpleOffset_1;
  BRepOffset_MakeSimpleOffset_2: typeof BRepOffset_MakeSimpleOffset_2;
  BRepOffsetSimple_Status: BRepOffsetSimple_Status;
  BRepOffset_Tool: typeof BRepOffset_Tool;
  Handle_StepElement_HArray1OfVolumeElementPurpose: typeof Handle_StepElement_HArray1OfVolumeElementPurpose;
  Handle_StepElement_HArray1OfVolumeElementPurpose_1: typeof Handle_StepElement_HArray1OfVolumeElementPurpose_1;
  Handle_StepElement_HArray1OfVolumeElementPurpose_2: typeof Handle_StepElement_HArray1OfVolumeElementPurpose_2;
  Handle_StepElement_HArray1OfVolumeElementPurpose_3: typeof Handle_StepElement_HArray1OfVolumeElementPurpose_3;
  Handle_StepElement_HArray1OfVolumeElementPurpose_4: typeof Handle_StepElement_HArray1OfVolumeElementPurpose_4;
  StepElement_ElementAspect: typeof StepElement_ElementAspect;
  Handle_StepElement_Surface3dElementDescriptor: typeof Handle_StepElement_Surface3dElementDescriptor;
  Handle_StepElement_Surface3dElementDescriptor_1: typeof Handle_StepElement_Surface3dElementDescriptor_1;
  Handle_StepElement_Surface3dElementDescriptor_2: typeof Handle_StepElement_Surface3dElementDescriptor_2;
  Handle_StepElement_Surface3dElementDescriptor_3: typeof Handle_StepElement_Surface3dElementDescriptor_3;
  Handle_StepElement_Surface3dElementDescriptor_4: typeof Handle_StepElement_Surface3dElementDescriptor_4;
  StepElement_Surface3dElementDescriptor: typeof StepElement_Surface3dElementDescriptor;
  StepElement_EnumeratedCurveElementFreedom: StepElement_EnumeratedCurveElementFreedom;
  StepElement_CurveElementPurposeMember: typeof StepElement_CurveElementPurposeMember;
  Handle_StepElement_CurveElementPurposeMember: typeof Handle_StepElement_CurveElementPurposeMember;
  Handle_StepElement_CurveElementPurposeMember_1: typeof Handle_StepElement_CurveElementPurposeMember_1;
  Handle_StepElement_CurveElementPurposeMember_2: typeof Handle_StepElement_CurveElementPurposeMember_2;
  Handle_StepElement_CurveElementPurposeMember_3: typeof Handle_StepElement_CurveElementPurposeMember_3;
  Handle_StepElement_CurveElementPurposeMember_4: typeof Handle_StepElement_CurveElementPurposeMember_4;
  StepElement_Array1OfVolumeElementPurpose: typeof StepElement_Array1OfVolumeElementPurpose;
  StepElement_Array1OfVolumeElementPurpose_1: typeof StepElement_Array1OfVolumeElementPurpose_1;
  StepElement_Array1OfVolumeElementPurpose_2: typeof StepElement_Array1OfVolumeElementPurpose_2;
  StepElement_Array1OfVolumeElementPurpose_3: typeof StepElement_Array1OfVolumeElementPurpose_3;
  StepElement_Array1OfVolumeElementPurpose_4: typeof StepElement_Array1OfVolumeElementPurpose_4;
  StepElement_Array1OfVolumeElementPurpose_5: typeof StepElement_Array1OfVolumeElementPurpose_5;
  StepElement_SurfaceSectionFieldConstant: typeof StepElement_SurfaceSectionFieldConstant;
  Handle_StepElement_SurfaceSectionFieldConstant: typeof Handle_StepElement_SurfaceSectionFieldConstant;
  Handle_StepElement_SurfaceSectionFieldConstant_1: typeof Handle_StepElement_SurfaceSectionFieldConstant_1;
  Handle_StepElement_SurfaceSectionFieldConstant_2: typeof Handle_StepElement_SurfaceSectionFieldConstant_2;
  Handle_StepElement_SurfaceSectionFieldConstant_3: typeof Handle_StepElement_SurfaceSectionFieldConstant_3;
  Handle_StepElement_SurfaceSectionFieldConstant_4: typeof Handle_StepElement_SurfaceSectionFieldConstant_4;
  Handle_StepElement_SurfaceElementPurposeMember: typeof Handle_StepElement_SurfaceElementPurposeMember;
  Handle_StepElement_SurfaceElementPurposeMember_1: typeof Handle_StepElement_SurfaceElementPurposeMember_1;
  Handle_StepElement_SurfaceElementPurposeMember_2: typeof Handle_StepElement_SurfaceElementPurposeMember_2;
  Handle_StepElement_SurfaceElementPurposeMember_3: typeof Handle_StepElement_SurfaceElementPurposeMember_3;
  Handle_StepElement_SurfaceElementPurposeMember_4: typeof Handle_StepElement_SurfaceElementPurposeMember_4;
  StepElement_SurfaceElementPurposeMember: typeof StepElement_SurfaceElementPurposeMember;
  Handle_StepElement_HArray2OfCurveElementPurposeMember: typeof Handle_StepElement_HArray2OfCurveElementPurposeMember;
  Handle_StepElement_HArray2OfCurveElementPurposeMember_1: typeof Handle_StepElement_HArray2OfCurveElementPurposeMember_1;
  Handle_StepElement_HArray2OfCurveElementPurposeMember_2: typeof Handle_StepElement_HArray2OfCurveElementPurposeMember_2;
  Handle_StepElement_HArray2OfCurveElementPurposeMember_3: typeof Handle_StepElement_HArray2OfCurveElementPurposeMember_3;
  Handle_StepElement_HArray2OfCurveElementPurposeMember_4: typeof Handle_StepElement_HArray2OfCurveElementPurposeMember_4;
  StepElement_ElementOrder: StepElement_ElementOrder;
  StepElement_VolumeElementPurpose: typeof StepElement_VolumeElementPurpose;
  Handle_StepElement_HArray2OfSurfaceElementPurpose: typeof Handle_StepElement_HArray2OfSurfaceElementPurpose;
  Handle_StepElement_HArray2OfSurfaceElementPurpose_1: typeof Handle_StepElement_HArray2OfSurfaceElementPurpose_1;
  Handle_StepElement_HArray2OfSurfaceElementPurpose_2: typeof Handle_StepElement_HArray2OfSurfaceElementPurpose_2;
  Handle_StepElement_HArray2OfSurfaceElementPurpose_3: typeof Handle_StepElement_HArray2OfSurfaceElementPurpose_3;
  Handle_StepElement_HArray2OfSurfaceElementPurpose_4: typeof Handle_StepElement_HArray2OfSurfaceElementPurpose_4;
  StepElement_CurveEdge: StepElement_CurveEdge;
  StepElement_Element2dShape: StepElement_Element2dShape;
  StepElement_Array2OfSurfaceElementPurpose: typeof StepElement_Array2OfSurfaceElementPurpose;
  StepElement_Array2OfSurfaceElementPurpose_1: typeof StepElement_Array2OfSurfaceElementPurpose_1;
  StepElement_Array2OfSurfaceElementPurpose_2: typeof StepElement_Array2OfSurfaceElementPurpose_2;
  StepElement_Array2OfSurfaceElementPurpose_3: typeof StepElement_Array2OfSurfaceElementPurpose_3;
  StepElement_Array2OfSurfaceElementPurpose_4: typeof StepElement_Array2OfSurfaceElementPurpose_4;
  StepElement_Array2OfSurfaceElementPurpose_5: typeof StepElement_Array2OfSurfaceElementPurpose_5;
  StepElement_EnumeratedSurfaceElementPurpose: StepElement_EnumeratedSurfaceElementPurpose;
  Handle_StepElement_HSequenceOfElementMaterial: typeof Handle_StepElement_HSequenceOfElementMaterial;
  Handle_StepElement_HSequenceOfElementMaterial_1: typeof Handle_StepElement_HSequenceOfElementMaterial_1;
  Handle_StepElement_HSequenceOfElementMaterial_2: typeof Handle_StepElement_HSequenceOfElementMaterial_2;
  Handle_StepElement_HSequenceOfElementMaterial_3: typeof Handle_StepElement_HSequenceOfElementMaterial_3;
  Handle_StepElement_HSequenceOfElementMaterial_4: typeof Handle_StepElement_HSequenceOfElementMaterial_4;
  Handle_StepElement_HArray1OfCurveElementSectionDefinition: typeof Handle_StepElement_HArray1OfCurveElementSectionDefinition;
  Handle_StepElement_HArray1OfCurveElementSectionDefinition_1: typeof Handle_StepElement_HArray1OfCurveElementSectionDefinition_1;
  Handle_StepElement_HArray1OfCurveElementSectionDefinition_2: typeof Handle_StepElement_HArray1OfCurveElementSectionDefinition_2;
  Handle_StepElement_HArray1OfCurveElementSectionDefinition_3: typeof Handle_StepElement_HArray1OfCurveElementSectionDefinition_3;
  Handle_StepElement_HArray1OfCurveElementSectionDefinition_4: typeof Handle_StepElement_HArray1OfCurveElementSectionDefinition_4;
  Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue: typeof Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue;
  Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_1: typeof Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_1;
  Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_2: typeof Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_2;
  Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_3: typeof Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_3;
  Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_4: typeof Handle_StepElement_HArray1OfMeasureOrUnspecifiedValue_4;
  StepElement_ElementAspectMember: typeof StepElement_ElementAspectMember;
  Handle_StepElement_ElementAspectMember: typeof Handle_StepElement_ElementAspectMember;
  Handle_StepElement_ElementAspectMember_1: typeof Handle_StepElement_ElementAspectMember_1;
  Handle_StepElement_ElementAspectMember_2: typeof Handle_StepElement_ElementAspectMember_2;
  Handle_StepElement_ElementAspectMember_3: typeof Handle_StepElement_ElementAspectMember_3;
  Handle_StepElement_ElementAspectMember_4: typeof Handle_StepElement_ElementAspectMember_4;
  Handle_StepElement_HArray1OfVolumeElementPurposeMember: typeof Handle_StepElement_HArray1OfVolumeElementPurposeMember;
  Handle_StepElement_HArray1OfVolumeElementPurposeMember_1: typeof Handle_StepElement_HArray1OfVolumeElementPurposeMember_1;
  Handle_StepElement_HArray1OfVolumeElementPurposeMember_2: typeof Handle_StepElement_HArray1OfVolumeElementPurposeMember_2;
  Handle_StepElement_HArray1OfVolumeElementPurposeMember_3: typeof Handle_StepElement_HArray1OfVolumeElementPurposeMember_3;
  Handle_StepElement_HArray1OfVolumeElementPurposeMember_4: typeof Handle_StepElement_HArray1OfVolumeElementPurposeMember_4;
  StepElement_Array1OfMeasureOrUnspecifiedValue: typeof StepElement_Array1OfMeasureOrUnspecifiedValue;
  StepElement_Array1OfMeasureOrUnspecifiedValue_1: typeof StepElement_Array1OfMeasureOrUnspecifiedValue_1;
  StepElement_Array1OfMeasureOrUnspecifiedValue_2: typeof StepElement_Array1OfMeasureOrUnspecifiedValue_2;
  StepElement_Array1OfMeasureOrUnspecifiedValue_3: typeof StepElement_Array1OfMeasureOrUnspecifiedValue_3;
  StepElement_Array1OfMeasureOrUnspecifiedValue_4: typeof StepElement_Array1OfMeasureOrUnspecifiedValue_4;
  StepElement_Array1OfMeasureOrUnspecifiedValue_5: typeof StepElement_Array1OfMeasureOrUnspecifiedValue_5;
  Handle_StepElement_CurveElementEndReleasePacket: typeof Handle_StepElement_CurveElementEndReleasePacket;
  Handle_StepElement_CurveElementEndReleasePacket_1: typeof Handle_StepElement_CurveElementEndReleasePacket_1;
  Handle_StepElement_CurveElementEndReleasePacket_2: typeof Handle_StepElement_CurveElementEndReleasePacket_2;
  Handle_StepElement_CurveElementEndReleasePacket_3: typeof Handle_StepElement_CurveElementEndReleasePacket_3;
  Handle_StepElement_CurveElementEndReleasePacket_4: typeof Handle_StepElement_CurveElementEndReleasePacket_4;
  StepElement_CurveElementEndReleasePacket: typeof StepElement_CurveElementEndReleasePacket;
  Handle_StepElement_MeasureOrUnspecifiedValueMember: typeof Handle_StepElement_MeasureOrUnspecifiedValueMember;
  Handle_StepElement_MeasureOrUnspecifiedValueMember_1: typeof Handle_StepElement_MeasureOrUnspecifiedValueMember_1;
  Handle_StepElement_MeasureOrUnspecifiedValueMember_2: typeof Handle_StepElement_MeasureOrUnspecifiedValueMember_2;
  Handle_StepElement_MeasureOrUnspecifiedValueMember_3: typeof Handle_StepElement_MeasureOrUnspecifiedValueMember_3;
  Handle_StepElement_MeasureOrUnspecifiedValueMember_4: typeof Handle_StepElement_MeasureOrUnspecifiedValueMember_4;
  StepElement_MeasureOrUnspecifiedValueMember: typeof StepElement_MeasureOrUnspecifiedValueMember;
  StepElement_Curve3dElementDescriptor: typeof StepElement_Curve3dElementDescriptor;
  Handle_StepElement_Curve3dElementDescriptor: typeof Handle_StepElement_Curve3dElementDescriptor;
  Handle_StepElement_Curve3dElementDescriptor_1: typeof Handle_StepElement_Curve3dElementDescriptor_1;
  Handle_StepElement_Curve3dElementDescriptor_2: typeof Handle_StepElement_Curve3dElementDescriptor_2;
  Handle_StepElement_Curve3dElementDescriptor_3: typeof Handle_StepElement_Curve3dElementDescriptor_3;
  Handle_StepElement_Curve3dElementDescriptor_4: typeof Handle_StepElement_Curve3dElementDescriptor_4;
  StepElement_UniformSurfaceSection: typeof StepElement_UniformSurfaceSection;
  Handle_StepElement_UniformSurfaceSection: typeof Handle_StepElement_UniformSurfaceSection;
  Handle_StepElement_UniformSurfaceSection_1: typeof Handle_StepElement_UniformSurfaceSection_1;
  Handle_StepElement_UniformSurfaceSection_2: typeof Handle_StepElement_UniformSurfaceSection_2;
  Handle_StepElement_UniformSurfaceSection_3: typeof Handle_StepElement_UniformSurfaceSection_3;
  Handle_StepElement_UniformSurfaceSection_4: typeof Handle_StepElement_UniformSurfaceSection_4;
  Handle_StepElement_HArray1OfSurfaceSection: typeof Handle_StepElement_HArray1OfSurfaceSection;
  Handle_StepElement_HArray1OfSurfaceSection_1: typeof Handle_StepElement_HArray1OfSurfaceSection_1;
  Handle_StepElement_HArray1OfSurfaceSection_2: typeof Handle_StepElement_HArray1OfSurfaceSection_2;
  Handle_StepElement_HArray1OfSurfaceSection_3: typeof Handle_StepElement_HArray1OfSurfaceSection_3;
  Handle_StepElement_HArray1OfSurfaceSection_4: typeof Handle_StepElement_HArray1OfSurfaceSection_4;
  Handle_StepElement_Volume3dElementDescriptor: typeof Handle_StepElement_Volume3dElementDescriptor;
  Handle_StepElement_Volume3dElementDescriptor_1: typeof Handle_StepElement_Volume3dElementDescriptor_1;
  Handle_StepElement_Volume3dElementDescriptor_2: typeof Handle_StepElement_Volume3dElementDescriptor_2;
  Handle_StepElement_Volume3dElementDescriptor_3: typeof Handle_StepElement_Volume3dElementDescriptor_3;
  Handle_StepElement_Volume3dElementDescriptor_4: typeof Handle_StepElement_Volume3dElementDescriptor_4;
  StepElement_Volume3dElementDescriptor: typeof StepElement_Volume3dElementDescriptor;
  StepElement_AnalysisItemWithinRepresentation: typeof StepElement_AnalysisItemWithinRepresentation;
  Handle_StepElement_AnalysisItemWithinRepresentation: typeof Handle_StepElement_AnalysisItemWithinRepresentation;
  Handle_StepElement_AnalysisItemWithinRepresentation_1: typeof Handle_StepElement_AnalysisItemWithinRepresentation_1;
  Handle_StepElement_AnalysisItemWithinRepresentation_2: typeof Handle_StepElement_AnalysisItemWithinRepresentation_2;
  Handle_StepElement_AnalysisItemWithinRepresentation_3: typeof Handle_StepElement_AnalysisItemWithinRepresentation_3;
  Handle_StepElement_AnalysisItemWithinRepresentation_4: typeof Handle_StepElement_AnalysisItemWithinRepresentation_4;
  Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember: typeof Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember;
  Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_1: typeof Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_1;
  Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_2: typeof Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_2;
  Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_3: typeof Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_3;
  Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_4: typeof Handle_StepElement_HArray1OfHSequenceOfCurveElementPurposeMember_4;
  Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember: typeof Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember;
  Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_1: typeof Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_1;
  Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_2: typeof Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_2;
  Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_3: typeof Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_3;
  Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_4: typeof Handle_StepElement_HArray1OfHSequenceOfSurfaceElementPurposeMember_4;
  StepElement_ElementVolume: StepElement_ElementVolume;
  StepElement_MeasureOrUnspecifiedValue: typeof StepElement_MeasureOrUnspecifiedValue;
  StepElement_CurveElementPurpose: typeof StepElement_CurveElementPurpose;
  StepElement_Volume3dElementShape: StepElement_Volume3dElementShape;
  Handle_StepElement_HArray1OfCurveElementEndReleasePacket: typeof Handle_StepElement_HArray1OfCurveElementEndReleasePacket;
  Handle_StepElement_HArray1OfCurveElementEndReleasePacket_1: typeof Handle_StepElement_HArray1OfCurveElementEndReleasePacket_1;
  Handle_StepElement_HArray1OfCurveElementEndReleasePacket_2: typeof Handle_StepElement_HArray1OfCurveElementEndReleasePacket_2;
  Handle_StepElement_HArray1OfCurveElementEndReleasePacket_3: typeof Handle_StepElement_HArray1OfCurveElementEndReleasePacket_3;
  Handle_StepElement_HArray1OfCurveElementEndReleasePacket_4: typeof Handle_StepElement_HArray1OfCurveElementEndReleasePacket_4;
  StepElement_CurveElementFreedom: typeof StepElement_CurveElementFreedom;
  StepElement_ElementMaterial: typeof StepElement_ElementMaterial;
  Handle_StepElement_ElementMaterial: typeof Handle_StepElement_ElementMaterial;
  Handle_StepElement_ElementMaterial_1: typeof Handle_StepElement_ElementMaterial_1;
  Handle_StepElement_ElementMaterial_2: typeof Handle_StepElement_ElementMaterial_2;
  Handle_StepElement_ElementMaterial_3: typeof Handle_StepElement_ElementMaterial_3;
  Handle_StepElement_ElementMaterial_4: typeof Handle_StepElement_ElementMaterial_4;
  StepElement_SurfaceElementPurpose: typeof StepElement_SurfaceElementPurpose;
  StepElement_SurfaceElementProperty: typeof StepElement_SurfaceElementProperty;
  Handle_StepElement_SurfaceElementProperty: typeof Handle_StepElement_SurfaceElementProperty;
  Handle_StepElement_SurfaceElementProperty_1: typeof Handle_StepElement_SurfaceElementProperty_1;
  Handle_StepElement_SurfaceElementProperty_2: typeof Handle_StepElement_SurfaceElementProperty_2;
  Handle_StepElement_SurfaceElementProperty_3: typeof Handle_StepElement_SurfaceElementProperty_3;
  Handle_StepElement_SurfaceElementProperty_4: typeof Handle_StepElement_SurfaceElementProperty_4;
  Handle_StepElement_HSequenceOfSurfaceElementPurposeMember: typeof Handle_StepElement_HSequenceOfSurfaceElementPurposeMember;
  Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_1: typeof Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_1;
  Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_2: typeof Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_2;
  Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_3: typeof Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_3;
  Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_4: typeof Handle_StepElement_HSequenceOfSurfaceElementPurposeMember_4;
  StepElement_EnumeratedVolumeElementPurpose: StepElement_EnumeratedVolumeElementPurpose;
  Handle_StepElement_VolumeElementPurposeMember: typeof Handle_StepElement_VolumeElementPurposeMember;
  Handle_StepElement_VolumeElementPurposeMember_1: typeof Handle_StepElement_VolumeElementPurposeMember_1;
  Handle_StepElement_VolumeElementPurposeMember_2: typeof Handle_StepElement_VolumeElementPurposeMember_2;
  Handle_StepElement_VolumeElementPurposeMember_3: typeof Handle_StepElement_VolumeElementPurposeMember_3;
  Handle_StepElement_VolumeElementPurposeMember_4: typeof Handle_StepElement_VolumeElementPurposeMember_4;
  StepElement_VolumeElementPurposeMember: typeof StepElement_VolumeElementPurposeMember;
  StepElement_SurfaceSectionFieldVarying: typeof StepElement_SurfaceSectionFieldVarying;
  Handle_StepElement_SurfaceSectionFieldVarying: typeof Handle_StepElement_SurfaceSectionFieldVarying;
  Handle_StepElement_SurfaceSectionFieldVarying_1: typeof Handle_StepElement_SurfaceSectionFieldVarying_1;
  Handle_StepElement_SurfaceSectionFieldVarying_2: typeof Handle_StepElement_SurfaceSectionFieldVarying_2;
  Handle_StepElement_SurfaceSectionFieldVarying_3: typeof Handle_StepElement_SurfaceSectionFieldVarying_3;
  Handle_StepElement_SurfaceSectionFieldVarying_4: typeof Handle_StepElement_SurfaceSectionFieldVarying_4;
  Handle_StepElement_HArray2OfSurfaceElementPurposeMember: typeof Handle_StepElement_HArray2OfSurfaceElementPurposeMember;
  Handle_StepElement_HArray2OfSurfaceElementPurposeMember_1: typeof Handle_StepElement_HArray2OfSurfaceElementPurposeMember_1;
  Handle_StepElement_HArray2OfSurfaceElementPurposeMember_2: typeof Handle_StepElement_HArray2OfSurfaceElementPurposeMember_2;
  Handle_StepElement_HArray2OfSurfaceElementPurposeMember_3: typeof Handle_StepElement_HArray2OfSurfaceElementPurposeMember_3;
  Handle_StepElement_HArray2OfSurfaceElementPurposeMember_4: typeof Handle_StepElement_HArray2OfSurfaceElementPurposeMember_4;
  Handle_StepElement_HSequenceOfCurveElementPurposeMember: typeof Handle_StepElement_HSequenceOfCurveElementPurposeMember;
  Handle_StepElement_HSequenceOfCurveElementPurposeMember_1: typeof Handle_StepElement_HSequenceOfCurveElementPurposeMember_1;
  Handle_StepElement_HSequenceOfCurveElementPurposeMember_2: typeof Handle_StepElement_HSequenceOfCurveElementPurposeMember_2;
  Handle_StepElement_HSequenceOfCurveElementPurposeMember_3: typeof Handle_StepElement_HSequenceOfCurveElementPurposeMember_3;
  Handle_StepElement_HSequenceOfCurveElementPurposeMember_4: typeof Handle_StepElement_HSequenceOfCurveElementPurposeMember_4;
  Handle_StepElement_CurveElementFreedomMember: typeof Handle_StepElement_CurveElementFreedomMember;
  Handle_StepElement_CurveElementFreedomMember_1: typeof Handle_StepElement_CurveElementFreedomMember_1;
  Handle_StepElement_CurveElementFreedomMember_2: typeof Handle_StepElement_CurveElementFreedomMember_2;
  Handle_StepElement_CurveElementFreedomMember_3: typeof Handle_StepElement_CurveElementFreedomMember_3;
  Handle_StepElement_CurveElementFreedomMember_4: typeof Handle_StepElement_CurveElementFreedomMember_4;
  StepElement_CurveElementFreedomMember: typeof StepElement_CurveElementFreedomMember;
  Handle_StepElement_ElementDescriptor: typeof Handle_StepElement_ElementDescriptor;
  Handle_StepElement_ElementDescriptor_1: typeof Handle_StepElement_ElementDescriptor_1;
  Handle_StepElement_ElementDescriptor_2: typeof Handle_StepElement_ElementDescriptor_2;
  Handle_StepElement_ElementDescriptor_3: typeof Handle_StepElement_ElementDescriptor_3;
  Handle_StepElement_ElementDescriptor_4: typeof Handle_StepElement_ElementDescriptor_4;
  StepElement_ElementDescriptor: typeof StepElement_ElementDescriptor;
  StepElement_SurfaceSection: typeof StepElement_SurfaceSection;
  Handle_StepElement_SurfaceSection: typeof Handle_StepElement_SurfaceSection;
  Handle_StepElement_SurfaceSection_1: typeof Handle_StepElement_SurfaceSection_1;
  Handle_StepElement_SurfaceSection_2: typeof Handle_StepElement_SurfaceSection_2;
  Handle_StepElement_SurfaceSection_3: typeof Handle_StepElement_SurfaceSection_3;
  Handle_StepElement_SurfaceSection_4: typeof Handle_StepElement_SurfaceSection_4;
  Handle_StepElement_HSequenceOfCurveElementSectionDefinition: typeof Handle_StepElement_HSequenceOfCurveElementSectionDefinition;
  Handle_StepElement_HSequenceOfCurveElementSectionDefinition_1: typeof Handle_StepElement_HSequenceOfCurveElementSectionDefinition_1;
  Handle_StepElement_HSequenceOfCurveElementSectionDefinition_2: typeof Handle_StepElement_HSequenceOfCurveElementSectionDefinition_2;
  Handle_StepElement_HSequenceOfCurveElementSectionDefinition_3: typeof Handle_StepElement_HSequenceOfCurveElementSectionDefinition_3;
  Handle_StepElement_HSequenceOfCurveElementSectionDefinition_4: typeof Handle_StepElement_HSequenceOfCurveElementSectionDefinition_4;
  StepElement_EnumeratedCurveElementPurpose: StepElement_EnumeratedCurveElementPurpose;
  Handle_StepElement_SurfaceSectionField: typeof Handle_StepElement_SurfaceSectionField;
  Handle_StepElement_SurfaceSectionField_1: typeof Handle_StepElement_SurfaceSectionField_1;
  Handle_StepElement_SurfaceSectionField_2: typeof Handle_StepElement_SurfaceSectionField_2;
  Handle_StepElement_SurfaceSectionField_3: typeof Handle_StepElement_SurfaceSectionField_3;
  Handle_StepElement_SurfaceSectionField_4: typeof Handle_StepElement_SurfaceSectionField_4;
  StepElement_SurfaceSectionField: typeof StepElement_SurfaceSectionField;
  StepElement_UnspecifiedValue: StepElement_UnspecifiedValue;
  Handle_StepElement_CurveElementSectionDerivedDefinitions: typeof Handle_StepElement_CurveElementSectionDerivedDefinitions;
  Handle_StepElement_CurveElementSectionDerivedDefinitions_1: typeof Handle_StepElement_CurveElementSectionDerivedDefinitions_1;
  Handle_StepElement_CurveElementSectionDerivedDefinitions_2: typeof Handle_StepElement_CurveElementSectionDerivedDefinitions_2;
  Handle_StepElement_CurveElementSectionDerivedDefinitions_3: typeof Handle_StepElement_CurveElementSectionDerivedDefinitions_3;
  Handle_StepElement_CurveElementSectionDerivedDefinitions_4: typeof Handle_StepElement_CurveElementSectionDerivedDefinitions_4;
  StepElement_CurveElementSectionDerivedDefinitions: typeof StepElement_CurveElementSectionDerivedDefinitions;
  StepElement_CurveElementSectionDefinition: typeof StepElement_CurveElementSectionDefinition;
  Handle_StepElement_CurveElementSectionDefinition: typeof Handle_StepElement_CurveElementSectionDefinition;
  Handle_StepElement_CurveElementSectionDefinition_1: typeof Handle_StepElement_CurveElementSectionDefinition_1;
  Handle_StepElement_CurveElementSectionDefinition_2: typeof Handle_StepElement_CurveElementSectionDefinition_2;
  Handle_StepElement_CurveElementSectionDefinition_3: typeof Handle_StepElement_CurveElementSectionDefinition_3;
  Handle_StepElement_CurveElementSectionDefinition_4: typeof Handle_StepElement_CurveElementSectionDefinition_4;
  TColgp_SequenceOfVec: typeof TColgp_SequenceOfVec;
  TColgp_SequenceOfVec_1: typeof TColgp_SequenceOfVec_1;
  TColgp_SequenceOfVec_2: typeof TColgp_SequenceOfVec_2;
  TColgp_SequenceOfVec_3: typeof TColgp_SequenceOfVec_3;
  TColgp_Array2OfXY: typeof TColgp_Array2OfXY;
  TColgp_Array2OfXY_1: typeof TColgp_Array2OfXY_1;
  TColgp_Array2OfXY_2: typeof TColgp_Array2OfXY_2;
  TColgp_Array2OfXY_3: typeof TColgp_Array2OfXY_3;
  TColgp_Array2OfXY_4: typeof TColgp_Array2OfXY_4;
  TColgp_Array2OfXY_5: typeof TColgp_Array2OfXY_5;
  TColgp_Array1OfDir2d: typeof TColgp_Array1OfDir2d;
  TColgp_Array1OfDir2d_1: typeof TColgp_Array1OfDir2d_1;
  TColgp_Array1OfDir2d_2: typeof TColgp_Array1OfDir2d_2;
  TColgp_Array1OfDir2d_3: typeof TColgp_Array1OfDir2d_3;
  TColgp_Array1OfDir2d_4: typeof TColgp_Array1OfDir2d_4;
  TColgp_Array1OfDir2d_5: typeof TColgp_Array1OfDir2d_5;
  Handle_TColgp_HArray2OfVec2d: typeof Handle_TColgp_HArray2OfVec2d;
  Handle_TColgp_HArray2OfVec2d_1: typeof Handle_TColgp_HArray2OfVec2d_1;
  Handle_TColgp_HArray2OfVec2d_2: typeof Handle_TColgp_HArray2OfVec2d_2;
  Handle_TColgp_HArray2OfVec2d_3: typeof Handle_TColgp_HArray2OfVec2d_3;
  Handle_TColgp_HArray2OfVec2d_4: typeof Handle_TColgp_HArray2OfVec2d_4;
  Handle_TColgp_HSequenceOfXYZ: typeof Handle_TColgp_HSequenceOfXYZ;
  Handle_TColgp_HSequenceOfXYZ_1: typeof Handle_TColgp_HSequenceOfXYZ_1;
  Handle_TColgp_HSequenceOfXYZ_2: typeof Handle_TColgp_HSequenceOfXYZ_2;
  Handle_TColgp_HSequenceOfXYZ_3: typeof Handle_TColgp_HSequenceOfXYZ_3;
  Handle_TColgp_HSequenceOfXYZ_4: typeof Handle_TColgp_HSequenceOfXYZ_4;
  TColgp_Array1OfXY: typeof TColgp_Array1OfXY;
  TColgp_Array1OfXY_1: typeof TColgp_Array1OfXY_1;
  TColgp_Array1OfXY_2: typeof TColgp_Array1OfXY_2;
  TColgp_Array1OfXY_3: typeof TColgp_Array1OfXY_3;
  TColgp_Array1OfXY_4: typeof TColgp_Array1OfXY_4;
  TColgp_Array1OfXY_5: typeof TColgp_Array1OfXY_5;
  Handle_TColgp_HArray1OfLin2d: typeof Handle_TColgp_HArray1OfLin2d;
  Handle_TColgp_HArray1OfLin2d_1: typeof Handle_TColgp_HArray1OfLin2d_1;
  Handle_TColgp_HArray1OfLin2d_2: typeof Handle_TColgp_HArray1OfLin2d_2;
  Handle_TColgp_HArray1OfLin2d_3: typeof Handle_TColgp_HArray1OfLin2d_3;
  Handle_TColgp_HArray1OfLin2d_4: typeof Handle_TColgp_HArray1OfLin2d_4;
  TColgp_Array1OfVec2d: typeof TColgp_Array1OfVec2d;
  TColgp_Array1OfVec2d_1: typeof TColgp_Array1OfVec2d_1;
  TColgp_Array1OfVec2d_2: typeof TColgp_Array1OfVec2d_2;
  TColgp_Array1OfVec2d_3: typeof TColgp_Array1OfVec2d_3;
  TColgp_Array1OfVec2d_4: typeof TColgp_Array1OfVec2d_4;
  TColgp_Array1OfVec2d_5: typeof TColgp_Array1OfVec2d_5;
  TColgp_SequenceOfXYZ: typeof TColgp_SequenceOfXYZ;
  TColgp_SequenceOfXYZ_1: typeof TColgp_SequenceOfXYZ_1;
  TColgp_SequenceOfXYZ_2: typeof TColgp_SequenceOfXYZ_2;
  TColgp_SequenceOfXYZ_3: typeof TColgp_SequenceOfXYZ_3;
  TColgp_SequenceOfAx1: typeof TColgp_SequenceOfAx1;
  TColgp_SequenceOfAx1_1: typeof TColgp_SequenceOfAx1_1;
  TColgp_SequenceOfAx1_2: typeof TColgp_SequenceOfAx1_2;
  TColgp_SequenceOfAx1_3: typeof TColgp_SequenceOfAx1_3;
  TColgp_Array2OfPnt2d: typeof TColgp_Array2OfPnt2d;
  TColgp_Array2OfPnt2d_1: typeof TColgp_Array2OfPnt2d_1;
  TColgp_Array2OfPnt2d_2: typeof TColgp_Array2OfPnt2d_2;
  TColgp_Array2OfPnt2d_3: typeof TColgp_Array2OfPnt2d_3;
  TColgp_Array2OfPnt2d_4: typeof TColgp_Array2OfPnt2d_4;
  TColgp_Array2OfPnt2d_5: typeof TColgp_Array2OfPnt2d_5;
  Handle_TColgp_HArray1OfPnt2d: typeof Handle_TColgp_HArray1OfPnt2d;
  Handle_TColgp_HArray1OfPnt2d_1: typeof Handle_TColgp_HArray1OfPnt2d_1;
  Handle_TColgp_HArray1OfPnt2d_2: typeof Handle_TColgp_HArray1OfPnt2d_2;
  Handle_TColgp_HArray1OfPnt2d_3: typeof Handle_TColgp_HArray1OfPnt2d_3;
  Handle_TColgp_HArray1OfPnt2d_4: typeof Handle_TColgp_HArray1OfPnt2d_4;
  Handle_TColgp_HArray1OfVec2d: typeof Handle_TColgp_HArray1OfVec2d;
  Handle_TColgp_HArray1OfVec2d_1: typeof Handle_TColgp_HArray1OfVec2d_1;
  Handle_TColgp_HArray1OfVec2d_2: typeof Handle_TColgp_HArray1OfVec2d_2;
  Handle_TColgp_HArray1OfVec2d_3: typeof Handle_TColgp_HArray1OfVec2d_3;
  Handle_TColgp_HArray1OfVec2d_4: typeof Handle_TColgp_HArray1OfVec2d_4;
  Handle_TColgp_HArray2OfXY: typeof Handle_TColgp_HArray2OfXY;
  Handle_TColgp_HArray2OfXY_1: typeof Handle_TColgp_HArray2OfXY_1;
  Handle_TColgp_HArray2OfXY_2: typeof Handle_TColgp_HArray2OfXY_2;
  Handle_TColgp_HArray2OfXY_3: typeof Handle_TColgp_HArray2OfXY_3;
  Handle_TColgp_HArray2OfXY_4: typeof Handle_TColgp_HArray2OfXY_4;
  TColgp_SequenceOfDir2d: typeof TColgp_SequenceOfDir2d;
  TColgp_SequenceOfDir2d_1: typeof TColgp_SequenceOfDir2d_1;
  TColgp_SequenceOfDir2d_2: typeof TColgp_SequenceOfDir2d_2;
  TColgp_SequenceOfDir2d_3: typeof TColgp_SequenceOfDir2d_3;
  Handle_TColgp_HArray1OfPnt: typeof Handle_TColgp_HArray1OfPnt;
  Handle_TColgp_HArray1OfPnt_1: typeof Handle_TColgp_HArray1OfPnt_1;
  Handle_TColgp_HArray1OfPnt_2: typeof Handle_TColgp_HArray1OfPnt_2;
  Handle_TColgp_HArray1OfPnt_3: typeof Handle_TColgp_HArray1OfPnt_3;
  Handle_TColgp_HArray1OfPnt_4: typeof Handle_TColgp_HArray1OfPnt_4;
  Handle_TColgp_HArray2OfVec: typeof Handle_TColgp_HArray2OfVec;
  Handle_TColgp_HArray2OfVec_1: typeof Handle_TColgp_HArray2OfVec_1;
  Handle_TColgp_HArray2OfVec_2: typeof Handle_TColgp_HArray2OfVec_2;
  Handle_TColgp_HArray2OfVec_3: typeof Handle_TColgp_HArray2OfVec_3;
  Handle_TColgp_HArray2OfVec_4: typeof Handle_TColgp_HArray2OfVec_4;
  TColgp_SequenceOfVec2d: typeof TColgp_SequenceOfVec2d;
  TColgp_SequenceOfVec2d_1: typeof TColgp_SequenceOfVec2d_1;
  TColgp_SequenceOfVec2d_2: typeof TColgp_SequenceOfVec2d_2;
  TColgp_SequenceOfVec2d_3: typeof TColgp_SequenceOfVec2d_3;
  Handle_TColgp_HSequenceOfVec2d: typeof Handle_TColgp_HSequenceOfVec2d;
  Handle_TColgp_HSequenceOfVec2d_1: typeof Handle_TColgp_HSequenceOfVec2d_1;
  Handle_TColgp_HSequenceOfVec2d_2: typeof Handle_TColgp_HSequenceOfVec2d_2;
  Handle_TColgp_HSequenceOfVec2d_3: typeof Handle_TColgp_HSequenceOfVec2d_3;
  Handle_TColgp_HSequenceOfVec2d_4: typeof Handle_TColgp_HSequenceOfVec2d_4;
  TColgp_SequenceOfDir: typeof TColgp_SequenceOfDir;
  TColgp_SequenceOfDir_1: typeof TColgp_SequenceOfDir_1;
  TColgp_SequenceOfDir_2: typeof TColgp_SequenceOfDir_2;
  TColgp_SequenceOfDir_3: typeof TColgp_SequenceOfDir_3;
  TColgp_Array1OfPnt: typeof TColgp_Array1OfPnt;
  TColgp_Array1OfPnt_1: typeof TColgp_Array1OfPnt_1;
  TColgp_Array1OfPnt_2: typeof TColgp_Array1OfPnt_2;
  TColgp_Array1OfPnt_3: typeof TColgp_Array1OfPnt_3;
  TColgp_Array1OfPnt_4: typeof TColgp_Array1OfPnt_4;
  TColgp_Array1OfPnt_5: typeof TColgp_Array1OfPnt_5;
  Handle_TColgp_HArray1OfXY: typeof Handle_TColgp_HArray1OfXY;
  Handle_TColgp_HArray1OfXY_1: typeof Handle_TColgp_HArray1OfXY_1;
  Handle_TColgp_HArray1OfXY_2: typeof Handle_TColgp_HArray1OfXY_2;
  Handle_TColgp_HArray1OfXY_3: typeof Handle_TColgp_HArray1OfXY_3;
  Handle_TColgp_HArray1OfXY_4: typeof Handle_TColgp_HArray1OfXY_4;
  Handle_TColgp_HSequenceOfDir2d: typeof Handle_TColgp_HSequenceOfDir2d;
  Handle_TColgp_HSequenceOfDir2d_1: typeof Handle_TColgp_HSequenceOfDir2d_1;
  Handle_TColgp_HSequenceOfDir2d_2: typeof Handle_TColgp_HSequenceOfDir2d_2;
  Handle_TColgp_HSequenceOfDir2d_3: typeof Handle_TColgp_HSequenceOfDir2d_3;
  Handle_TColgp_HSequenceOfDir2d_4: typeof Handle_TColgp_HSequenceOfDir2d_4;
  TColgp_Array1OfXYZ: typeof TColgp_Array1OfXYZ;
  TColgp_Array1OfXYZ_1: typeof TColgp_Array1OfXYZ_1;
  TColgp_Array1OfXYZ_2: typeof TColgp_Array1OfXYZ_2;
  TColgp_Array1OfXYZ_3: typeof TColgp_Array1OfXYZ_3;
  TColgp_Array1OfXYZ_4: typeof TColgp_Array1OfXYZ_4;
  TColgp_Array1OfXYZ_5: typeof TColgp_Array1OfXYZ_5;
  TColgp_Array2OfLin2d: typeof TColgp_Array2OfLin2d;
  TColgp_Array2OfLin2d_1: typeof TColgp_Array2OfLin2d_1;
  TColgp_Array2OfLin2d_2: typeof TColgp_Array2OfLin2d_2;
  TColgp_Array2OfLin2d_3: typeof TColgp_Array2OfLin2d_3;
  TColgp_Array2OfLin2d_4: typeof TColgp_Array2OfLin2d_4;
  TColgp_Array2OfLin2d_5: typeof TColgp_Array2OfLin2d_5;
  Handle_TColgp_HArray1OfDir2d: typeof Handle_TColgp_HArray1OfDir2d;
  Handle_TColgp_HArray1OfDir2d_1: typeof Handle_TColgp_HArray1OfDir2d_1;
  Handle_TColgp_HArray1OfDir2d_2: typeof Handle_TColgp_HArray1OfDir2d_2;
  Handle_TColgp_HArray1OfDir2d_3: typeof Handle_TColgp_HArray1OfDir2d_3;
  Handle_TColgp_HArray1OfDir2d_4: typeof Handle_TColgp_HArray1OfDir2d_4;
  TColgp_Array1OfPnt2d: typeof TColgp_Array1OfPnt2d;
  TColgp_Array1OfPnt2d_1: typeof TColgp_Array1OfPnt2d_1;
  TColgp_Array1OfPnt2d_2: typeof TColgp_Array1OfPnt2d_2;
  TColgp_Array1OfPnt2d_3: typeof TColgp_Array1OfPnt2d_3;
  TColgp_Array1OfPnt2d_4: typeof TColgp_Array1OfPnt2d_4;
  TColgp_Array1OfPnt2d_5: typeof TColgp_Array1OfPnt2d_5;
  TColgp_Array1OfCirc2d: typeof TColgp_Array1OfCirc2d;
  TColgp_Array1OfCirc2d_1: typeof TColgp_Array1OfCirc2d_1;
  TColgp_Array1OfCirc2d_2: typeof TColgp_Array1OfCirc2d_2;
  TColgp_Array1OfCirc2d_3: typeof TColgp_Array1OfCirc2d_3;
  TColgp_Array1OfCirc2d_4: typeof TColgp_Array1OfCirc2d_4;
  TColgp_Array1OfCirc2d_5: typeof TColgp_Array1OfCirc2d_5;
  TColgp_Array1OfDir: typeof TColgp_Array1OfDir;
  TColgp_Array1OfDir_1: typeof TColgp_Array1OfDir_1;
  TColgp_Array1OfDir_2: typeof TColgp_Array1OfDir_2;
  TColgp_Array1OfDir_3: typeof TColgp_Array1OfDir_3;
  TColgp_Array1OfDir_4: typeof TColgp_Array1OfDir_4;
  TColgp_Array1OfDir_5: typeof TColgp_Array1OfDir_5;
  TColgp_Array2OfCirc2d: typeof TColgp_Array2OfCirc2d;
  TColgp_Array2OfCirc2d_1: typeof TColgp_Array2OfCirc2d_1;
  TColgp_Array2OfCirc2d_2: typeof TColgp_Array2OfCirc2d_2;
  TColgp_Array2OfCirc2d_3: typeof TColgp_Array2OfCirc2d_3;
  TColgp_Array2OfCirc2d_4: typeof TColgp_Array2OfCirc2d_4;
  TColgp_Array2OfCirc2d_5: typeof TColgp_Array2OfCirc2d_5;
  TColgp_Array2OfDir: typeof TColgp_Array2OfDir;
  TColgp_Array2OfDir_1: typeof TColgp_Array2OfDir_1;
  TColgp_Array2OfDir_2: typeof TColgp_Array2OfDir_2;
  TColgp_Array2OfDir_3: typeof TColgp_Array2OfDir_3;
  TColgp_Array2OfDir_4: typeof TColgp_Array2OfDir_4;
  TColgp_Array2OfDir_5: typeof TColgp_Array2OfDir_5;
  TColgp_Array1OfVec: typeof TColgp_Array1OfVec;
  TColgp_Array1OfVec_1: typeof TColgp_Array1OfVec_1;
  TColgp_Array1OfVec_2: typeof TColgp_Array1OfVec_2;
  TColgp_Array1OfVec_3: typeof TColgp_Array1OfVec_3;
  TColgp_Array1OfVec_4: typeof TColgp_Array1OfVec_4;
  TColgp_Array1OfVec_5: typeof TColgp_Array1OfVec_5;
  Handle_TColgp_HArray2OfPnt2d: typeof Handle_TColgp_HArray2OfPnt2d;
  Handle_TColgp_HArray2OfPnt2d_1: typeof Handle_TColgp_HArray2OfPnt2d_1;
  Handle_TColgp_HArray2OfPnt2d_2: typeof Handle_TColgp_HArray2OfPnt2d_2;
  Handle_TColgp_HArray2OfPnt2d_3: typeof Handle_TColgp_HArray2OfPnt2d_3;
  Handle_TColgp_HArray2OfPnt2d_4: typeof Handle_TColgp_HArray2OfPnt2d_4;
  Handle_TColgp_HArray1OfVec: typeof Handle_TColgp_HArray1OfVec;
  Handle_TColgp_HArray1OfVec_1: typeof Handle_TColgp_HArray1OfVec_1;
  Handle_TColgp_HArray1OfVec_2: typeof Handle_TColgp_HArray1OfVec_2;
  Handle_TColgp_HArray1OfVec_3: typeof Handle_TColgp_HArray1OfVec_3;
  Handle_TColgp_HArray1OfVec_4: typeof Handle_TColgp_HArray1OfVec_4;
  Handle_TColgp_HSequenceOfDir: typeof Handle_TColgp_HSequenceOfDir;
  Handle_TColgp_HSequenceOfDir_1: typeof Handle_TColgp_HSequenceOfDir_1;
  Handle_TColgp_HSequenceOfDir_2: typeof Handle_TColgp_HSequenceOfDir_2;
  Handle_TColgp_HSequenceOfDir_3: typeof Handle_TColgp_HSequenceOfDir_3;
  Handle_TColgp_HSequenceOfDir_4: typeof Handle_TColgp_HSequenceOfDir_4;
  Handle_TColgp_HArray2OfLin2d: typeof Handle_TColgp_HArray2OfLin2d;
  Handle_TColgp_HArray2OfLin2d_1: typeof Handle_TColgp_HArray2OfLin2d_1;
  Handle_TColgp_HArray2OfLin2d_2: typeof Handle_TColgp_HArray2OfLin2d_2;
  Handle_TColgp_HArray2OfLin2d_3: typeof Handle_TColgp_HArray2OfLin2d_3;
  Handle_TColgp_HArray2OfLin2d_4: typeof Handle_TColgp_HArray2OfLin2d_4;
  Handle_TColgp_HSequenceOfPnt2d: typeof Handle_TColgp_HSequenceOfPnt2d;
  Handle_TColgp_HSequenceOfPnt2d_1: typeof Handle_TColgp_HSequenceOfPnt2d_1;
  Handle_TColgp_HSequenceOfPnt2d_2: typeof Handle_TColgp_HSequenceOfPnt2d_2;
  Handle_TColgp_HSequenceOfPnt2d_3: typeof Handle_TColgp_HSequenceOfPnt2d_3;
  Handle_TColgp_HSequenceOfPnt2d_4: typeof Handle_TColgp_HSequenceOfPnt2d_4;
  Handle_TColgp_HSequenceOfXY: typeof Handle_TColgp_HSequenceOfXY;
  Handle_TColgp_HSequenceOfXY_1: typeof Handle_TColgp_HSequenceOfXY_1;
  Handle_TColgp_HSequenceOfXY_2: typeof Handle_TColgp_HSequenceOfXY_2;
  Handle_TColgp_HSequenceOfXY_3: typeof Handle_TColgp_HSequenceOfXY_3;
  Handle_TColgp_HSequenceOfXY_4: typeof Handle_TColgp_HSequenceOfXY_4;
  TColgp_Array2OfXYZ: typeof TColgp_Array2OfXYZ;
  TColgp_Array2OfXYZ_1: typeof TColgp_Array2OfXYZ_1;
  TColgp_Array2OfXYZ_2: typeof TColgp_Array2OfXYZ_2;
  TColgp_Array2OfXYZ_3: typeof TColgp_Array2OfXYZ_3;
  TColgp_Array2OfXYZ_4: typeof TColgp_Array2OfXYZ_4;
  TColgp_Array2OfXYZ_5: typeof TColgp_Array2OfXYZ_5;
  Handle_TColgp_HArray2OfPnt: typeof Handle_TColgp_HArray2OfPnt;
  Handle_TColgp_HArray2OfPnt_1: typeof Handle_TColgp_HArray2OfPnt_1;
  Handle_TColgp_HArray2OfPnt_2: typeof Handle_TColgp_HArray2OfPnt_2;
  Handle_TColgp_HArray2OfPnt_3: typeof Handle_TColgp_HArray2OfPnt_3;
  Handle_TColgp_HArray2OfPnt_4: typeof Handle_TColgp_HArray2OfPnt_4;
  TColgp_SequenceOfPnt: typeof TColgp_SequenceOfPnt;
  TColgp_SequenceOfPnt_1: typeof TColgp_SequenceOfPnt_1;
  TColgp_SequenceOfPnt_2: typeof TColgp_SequenceOfPnt_2;
  TColgp_SequenceOfPnt_3: typeof TColgp_SequenceOfPnt_3;
  Handle_TColgp_HSequenceOfPnt: typeof Handle_TColgp_HSequenceOfPnt;
  Handle_TColgp_HSequenceOfPnt_1: typeof Handle_TColgp_HSequenceOfPnt_1;
  Handle_TColgp_HSequenceOfPnt_2: typeof Handle_TColgp_HSequenceOfPnt_2;
  Handle_TColgp_HSequenceOfPnt_3: typeof Handle_TColgp_HSequenceOfPnt_3;
  Handle_TColgp_HSequenceOfPnt_4: typeof Handle_TColgp_HSequenceOfPnt_4;
  Handle_TColgp_HArray1OfDir: typeof Handle_TColgp_HArray1OfDir;
  Handle_TColgp_HArray1OfDir_1: typeof Handle_TColgp_HArray1OfDir_1;
  Handle_TColgp_HArray1OfDir_2: typeof Handle_TColgp_HArray1OfDir_2;
  Handle_TColgp_HArray1OfDir_3: typeof Handle_TColgp_HArray1OfDir_3;
  Handle_TColgp_HArray1OfDir_4: typeof Handle_TColgp_HArray1OfDir_4;
  TColgp_Array2OfDir2d: typeof TColgp_Array2OfDir2d;
  TColgp_Array2OfDir2d_1: typeof TColgp_Array2OfDir2d_1;
  TColgp_Array2OfDir2d_2: typeof TColgp_Array2OfDir2d_2;
  TColgp_Array2OfDir2d_3: typeof TColgp_Array2OfDir2d_3;
  TColgp_Array2OfDir2d_4: typeof TColgp_Array2OfDir2d_4;
  TColgp_Array2OfDir2d_5: typeof TColgp_Array2OfDir2d_5;
  TColgp_Array2OfVec: typeof TColgp_Array2OfVec;
  TColgp_Array2OfVec_1: typeof TColgp_Array2OfVec_1;
  TColgp_Array2OfVec_2: typeof TColgp_Array2OfVec_2;
  TColgp_Array2OfVec_3: typeof TColgp_Array2OfVec_3;
  TColgp_Array2OfVec_4: typeof TColgp_Array2OfVec_4;
  TColgp_Array2OfVec_5: typeof TColgp_Array2OfVec_5;
  TColgp_Array2OfVec2d: typeof TColgp_Array2OfVec2d;
  TColgp_Array2OfVec2d_1: typeof TColgp_Array2OfVec2d_1;
  TColgp_Array2OfVec2d_2: typeof TColgp_Array2OfVec2d_2;
  TColgp_Array2OfVec2d_3: typeof TColgp_Array2OfVec2d_3;
  TColgp_Array2OfVec2d_4: typeof TColgp_Array2OfVec2d_4;
  TColgp_Array2OfVec2d_5: typeof TColgp_Array2OfVec2d_5;
  Handle_TColgp_HArray1OfXYZ: typeof Handle_TColgp_HArray1OfXYZ;
  Handle_TColgp_HArray1OfXYZ_1: typeof Handle_TColgp_HArray1OfXYZ_1;
  Handle_TColgp_HArray1OfXYZ_2: typeof Handle_TColgp_HArray1OfXYZ_2;
  Handle_TColgp_HArray1OfXYZ_3: typeof Handle_TColgp_HArray1OfXYZ_3;
  Handle_TColgp_HArray1OfXYZ_4: typeof Handle_TColgp_HArray1OfXYZ_4;
  Handle_TColgp_HArray2OfCirc2d: typeof Handle_TColgp_HArray2OfCirc2d;
  Handle_TColgp_HArray2OfCirc2d_1: typeof Handle_TColgp_HArray2OfCirc2d_1;
  Handle_TColgp_HArray2OfCirc2d_2: typeof Handle_TColgp_HArray2OfCirc2d_2;
  Handle_TColgp_HArray2OfCirc2d_3: typeof Handle_TColgp_HArray2OfCirc2d_3;
  Handle_TColgp_HArray2OfCirc2d_4: typeof Handle_TColgp_HArray2OfCirc2d_4;
  TColgp_Array2OfPnt: typeof TColgp_Array2OfPnt;
  TColgp_Array2OfPnt_1: typeof TColgp_Array2OfPnt_1;
  TColgp_Array2OfPnt_2: typeof TColgp_Array2OfPnt_2;
  TColgp_Array2OfPnt_3: typeof TColgp_Array2OfPnt_3;
  TColgp_Array2OfPnt_4: typeof TColgp_Array2OfPnt_4;
  TColgp_Array2OfPnt_5: typeof TColgp_Array2OfPnt_5;
  TColgp_SequenceOfPnt2d: typeof TColgp_SequenceOfPnt2d;
  TColgp_SequenceOfPnt2d_1: typeof TColgp_SequenceOfPnt2d_1;
  TColgp_SequenceOfPnt2d_2: typeof TColgp_SequenceOfPnt2d_2;
  TColgp_SequenceOfPnt2d_3: typeof TColgp_SequenceOfPnt2d_3;
  Handle_TColgp_HArray2OfDir: typeof Handle_TColgp_HArray2OfDir;
  Handle_TColgp_HArray2OfDir_1: typeof Handle_TColgp_HArray2OfDir_1;
  Handle_TColgp_HArray2OfDir_2: typeof Handle_TColgp_HArray2OfDir_2;
  Handle_TColgp_HArray2OfDir_3: typeof Handle_TColgp_HArray2OfDir_3;
  Handle_TColgp_HArray2OfDir_4: typeof Handle_TColgp_HArray2OfDir_4;
  Handle_TColgp_HArray1OfCirc2d: typeof Handle_TColgp_HArray1OfCirc2d;
  Handle_TColgp_HArray1OfCirc2d_1: typeof Handle_TColgp_HArray1OfCirc2d_1;
  Handle_TColgp_HArray1OfCirc2d_2: typeof Handle_TColgp_HArray1OfCirc2d_2;
  Handle_TColgp_HArray1OfCirc2d_3: typeof Handle_TColgp_HArray1OfCirc2d_3;
  Handle_TColgp_HArray1OfCirc2d_4: typeof Handle_TColgp_HArray1OfCirc2d_4;
  Handle_TColgp_HArray2OfDir2d: typeof Handle_TColgp_HArray2OfDir2d;
  Handle_TColgp_HArray2OfDir2d_1: typeof Handle_TColgp_HArray2OfDir2d_1;
  Handle_TColgp_HArray2OfDir2d_2: typeof Handle_TColgp_HArray2OfDir2d_2;
  Handle_TColgp_HArray2OfDir2d_3: typeof Handle_TColgp_HArray2OfDir2d_3;
  Handle_TColgp_HArray2OfDir2d_4: typeof Handle_TColgp_HArray2OfDir2d_4;
  TColgp_SequenceOfXY: typeof TColgp_SequenceOfXY;
  TColgp_SequenceOfXY_1: typeof TColgp_SequenceOfXY_1;
  TColgp_SequenceOfXY_2: typeof TColgp_SequenceOfXY_2;
  TColgp_SequenceOfXY_3: typeof TColgp_SequenceOfXY_3;
  TColgp_Array1OfLin2d: typeof TColgp_Array1OfLin2d;
  TColgp_Array1OfLin2d_1: typeof TColgp_Array1OfLin2d_1;
  TColgp_Array1OfLin2d_2: typeof TColgp_Array1OfLin2d_2;
  TColgp_Array1OfLin2d_3: typeof TColgp_Array1OfLin2d_3;
  TColgp_Array1OfLin2d_4: typeof TColgp_Array1OfLin2d_4;
  TColgp_Array1OfLin2d_5: typeof TColgp_Array1OfLin2d_5;
  Handle_TColgp_HSequenceOfVec: typeof Handle_TColgp_HSequenceOfVec;
  Handle_TColgp_HSequenceOfVec_1: typeof Handle_TColgp_HSequenceOfVec_1;
  Handle_TColgp_HSequenceOfVec_2: typeof Handle_TColgp_HSequenceOfVec_2;
  Handle_TColgp_HSequenceOfVec_3: typeof Handle_TColgp_HSequenceOfVec_3;
  Handle_TColgp_HSequenceOfVec_4: typeof Handle_TColgp_HSequenceOfVec_4;
  Handle_TColgp_HArray2OfXYZ: typeof Handle_TColgp_HArray2OfXYZ;
  Handle_TColgp_HArray2OfXYZ_1: typeof Handle_TColgp_HArray2OfXYZ_1;
  Handle_TColgp_HArray2OfXYZ_2: typeof Handle_TColgp_HArray2OfXYZ_2;
  Handle_TColgp_HArray2OfXYZ_3: typeof Handle_TColgp_HArray2OfXYZ_3;
  Handle_TColgp_HArray2OfXYZ_4: typeof Handle_TColgp_HArray2OfXYZ_4;
  FairCurve_BattenLaw: typeof FairCurve_BattenLaw;
  FairCurve_EnergyOfBatten: typeof FairCurve_EnergyOfBatten;
  FairCurve_AnalysisCode: FairCurve_AnalysisCode;
  FairCurve_EnergyOfMVC: typeof FairCurve_EnergyOfMVC;
  FairCurve_Newton: typeof FairCurve_Newton;
  FairCurve_DistributionOfTension: typeof FairCurve_DistributionOfTension;
  FairCurve_DistributionOfSagging: typeof FairCurve_DistributionOfSagging;
  FairCurve_DistributionOfEnergy: typeof FairCurve_DistributionOfEnergy;
  FairCurve_MinimalVariation: typeof FairCurve_MinimalVariation;
  FairCurve_DistributionOfJerk: typeof FairCurve_DistributionOfJerk;
  FairCurve_Energy: typeof FairCurve_Energy;
  FairCurve_Batten: typeof FairCurve_Batten;
  AIS_PointCloudOwner: typeof AIS_PointCloudOwner;
  Handle_AIS_PointCloud: typeof Handle_AIS_PointCloud;
  Handle_AIS_PointCloud_1: typeof Handle_AIS_PointCloud_1;
  Handle_AIS_PointCloud_2: typeof Handle_AIS_PointCloud_2;
  Handle_AIS_PointCloud_3: typeof Handle_AIS_PointCloud_3;
  Handle_AIS_PointCloud_4: typeof Handle_AIS_PointCloud_4;
  AIS_PointCloud: typeof AIS_PointCloud;
  Handle_AIS_Triangulation: typeof Handle_AIS_Triangulation;
  Handle_AIS_Triangulation_1: typeof Handle_AIS_Triangulation_1;
  Handle_AIS_Triangulation_2: typeof Handle_AIS_Triangulation_2;
  Handle_AIS_Triangulation_3: typeof Handle_AIS_Triangulation_3;
  Handle_AIS_Triangulation_4: typeof Handle_AIS_Triangulation_4;
  AIS_Triangulation: typeof AIS_Triangulation;
  Handle_AIS_Shape: typeof Handle_AIS_Shape;
  Handle_AIS_Shape_1: typeof Handle_AIS_Shape_1;
  Handle_AIS_Shape_2: typeof Handle_AIS_Shape_2;
  Handle_AIS_Shape_3: typeof Handle_AIS_Shape_3;
  Handle_AIS_Shape_4: typeof Handle_AIS_Shape_4;
  AIS_Shape: typeof AIS_Shape;
  Handle_AIS_BadEdgeFilter: typeof Handle_AIS_BadEdgeFilter;
  Handle_AIS_BadEdgeFilter_1: typeof Handle_AIS_BadEdgeFilter_1;
  Handle_AIS_BadEdgeFilter_2: typeof Handle_AIS_BadEdgeFilter_2;
  Handle_AIS_BadEdgeFilter_3: typeof Handle_AIS_BadEdgeFilter_3;
  Handle_AIS_BadEdgeFilter_4: typeof Handle_AIS_BadEdgeFilter_4;
  AIS_BadEdgeFilter: typeof AIS_BadEdgeFilter;
  Handle_AIS_AttributeFilter: typeof Handle_AIS_AttributeFilter;
  Handle_AIS_AttributeFilter_1: typeof Handle_AIS_AttributeFilter_1;
  Handle_AIS_AttributeFilter_2: typeof Handle_AIS_AttributeFilter_2;
  Handle_AIS_AttributeFilter_3: typeof Handle_AIS_AttributeFilter_3;
  Handle_AIS_AttributeFilter_4: typeof Handle_AIS_AttributeFilter_4;
  AIS_AttributeFilter: typeof AIS_AttributeFilter;
  AIS_AttributeFilter_1: typeof AIS_AttributeFilter_1;
  AIS_AttributeFilter_2: typeof AIS_AttributeFilter_2;
  AIS_AttributeFilter_3: typeof AIS_AttributeFilter_3;
  Handle_AIS_Plane: typeof Handle_AIS_Plane;
  Handle_AIS_Plane_1: typeof Handle_AIS_Plane_1;
  Handle_AIS_Plane_2: typeof Handle_AIS_Plane_2;
  Handle_AIS_Plane_3: typeof Handle_AIS_Plane_3;
  Handle_AIS_Plane_4: typeof Handle_AIS_Plane_4;
  AIS_Plane: typeof AIS_Plane;
  AIS_Plane_1: typeof AIS_Plane_1;
  AIS_Plane_2: typeof AIS_Plane_2;
  AIS_Plane_3: typeof AIS_Plane_3;
  AIS_Plane_4: typeof AIS_Plane_4;
  AIS_TypeOfAxis: AIS_TypeOfAxis;
  AIS_Line: typeof AIS_Line;
  AIS_Line_1: typeof AIS_Line_1;
  AIS_Line_2: typeof AIS_Line_2;
  Handle_AIS_Line: typeof Handle_AIS_Line;
  Handle_AIS_Line_1: typeof Handle_AIS_Line_1;
  Handle_AIS_Line_2: typeof Handle_AIS_Line_2;
  Handle_AIS_Line_3: typeof Handle_AIS_Line_3;
  Handle_AIS_Line_4: typeof Handle_AIS_Line_4;
  Handle_AIS_ManipulatorOwner: typeof Handle_AIS_ManipulatorOwner;
  Handle_AIS_ManipulatorOwner_1: typeof Handle_AIS_ManipulatorOwner_1;
  Handle_AIS_ManipulatorOwner_2: typeof Handle_AIS_ManipulatorOwner_2;
  Handle_AIS_ManipulatorOwner_3: typeof Handle_AIS_ManipulatorOwner_3;
  Handle_AIS_ManipulatorOwner_4: typeof Handle_AIS_ManipulatorOwner_4;
  AIS_ManipulatorOwner: typeof AIS_ManipulatorOwner;
  Handle_AIS_ConnectedInteractive: typeof Handle_AIS_ConnectedInteractive;
  Handle_AIS_ConnectedInteractive_1: typeof Handle_AIS_ConnectedInteractive_1;
  Handle_AIS_ConnectedInteractive_2: typeof Handle_AIS_ConnectedInteractive_2;
  Handle_AIS_ConnectedInteractive_3: typeof Handle_AIS_ConnectedInteractive_3;
  Handle_AIS_ConnectedInteractive_4: typeof Handle_AIS_ConnectedInteractive_4;
  AIS_ConnectedInteractive: typeof AIS_ConnectedInteractive;
  Handle_AIS_Selection: typeof Handle_AIS_Selection;
  Handle_AIS_Selection_1: typeof Handle_AIS_Selection_1;
  Handle_AIS_Selection_2: typeof Handle_AIS_Selection_2;
  Handle_AIS_Selection_3: typeof Handle_AIS_Selection_3;
  Handle_AIS_Selection_4: typeof Handle_AIS_Selection_4;
  AIS_Selection: typeof AIS_Selection;
  AIS_InteractiveContext: typeof AIS_InteractiveContext;
  Handle_AIS_InteractiveContext: typeof Handle_AIS_InteractiveContext;
  Handle_AIS_InteractiveContext_1: typeof Handle_AIS_InteractiveContext_1;
  Handle_AIS_InteractiveContext_2: typeof Handle_AIS_InteractiveContext_2;
  Handle_AIS_InteractiveContext_3: typeof Handle_AIS_InteractiveContext_3;
  Handle_AIS_InteractiveContext_4: typeof Handle_AIS_InteractiveContext_4;
  AIS_StatusOfPick: AIS_StatusOfPick;
  AIS_ViewCubeOwner: typeof AIS_ViewCubeOwner;
  AIS_ViewCube: typeof AIS_ViewCube;
  AIS_TrihedronSelectionMode: AIS_TrihedronSelectionMode;
  AIS_DisplayStatus: AIS_DisplayStatus;
  AIS_TypeOfPlane: AIS_TypeOfPlane;
  AIS_DataMapofIntegerListOfinteractive: typeof AIS_DataMapofIntegerListOfinteractive;
  AIS_DataMapofIntegerListOfinteractive_1: typeof AIS_DataMapofIntegerListOfinteractive_1;
  AIS_DataMapofIntegerListOfinteractive_2: typeof AIS_DataMapofIntegerListOfinteractive_2;
  AIS_DataMapofIntegerListOfinteractive_3: typeof AIS_DataMapofIntegerListOfinteractive_3;
  AIS_Axis: typeof AIS_Axis;
  AIS_Axis_1: typeof AIS_Axis_1;
  AIS_Axis_2: typeof AIS_Axis_2;
  AIS_Axis_3: typeof AIS_Axis_3;
  Handle_AIS_Axis: typeof Handle_AIS_Axis;
  Handle_AIS_Axis_1: typeof Handle_AIS_Axis_1;
  Handle_AIS_Axis_2: typeof Handle_AIS_Axis_2;
  Handle_AIS_Axis_3: typeof Handle_AIS_Axis_3;
  Handle_AIS_Axis_4: typeof Handle_AIS_Axis_4;
  AIS_SelectStatus: AIS_SelectStatus;
  Handle_AIS_ColorScale: typeof Handle_AIS_ColorScale;
  Handle_AIS_ColorScale_1: typeof Handle_AIS_ColorScale_1;
  Handle_AIS_ColorScale_2: typeof Handle_AIS_ColorScale_2;
  Handle_AIS_ColorScale_3: typeof Handle_AIS_ColorScale_3;
  Handle_AIS_ColorScale_4: typeof Handle_AIS_ColorScale_4;
  AIS_ColorScale: typeof AIS_ColorScale;
  Handle_AIS_GlobalStatus: typeof Handle_AIS_GlobalStatus;
  Handle_AIS_GlobalStatus_1: typeof Handle_AIS_GlobalStatus_1;
  Handle_AIS_GlobalStatus_2: typeof Handle_AIS_GlobalStatus_2;
  Handle_AIS_GlobalStatus_3: typeof Handle_AIS_GlobalStatus_3;
  Handle_AIS_GlobalStatus_4: typeof Handle_AIS_GlobalStatus_4;
  AIS_GlobalStatus: typeof AIS_GlobalStatus;
  AIS_GlobalStatus_1: typeof AIS_GlobalStatus_1;
  AIS_GlobalStatus_2: typeof AIS_GlobalStatus_2;
  AIS_WalkDelta: typeof AIS_WalkDelta;
  AIS_WalkTranslation: AIS_WalkTranslation;
  AIS_WalkRotation: AIS_WalkRotation;
  AIS_WalkPart: typeof AIS_WalkPart;
  Handle_AIS_C0RegularityFilter: typeof Handle_AIS_C0RegularityFilter;
  Handle_AIS_C0RegularityFilter_1: typeof Handle_AIS_C0RegularityFilter_1;
  Handle_AIS_C0RegularityFilter_2: typeof Handle_AIS_C0RegularityFilter_2;
  Handle_AIS_C0RegularityFilter_3: typeof Handle_AIS_C0RegularityFilter_3;
  Handle_AIS_C0RegularityFilter_4: typeof Handle_AIS_C0RegularityFilter_4;
  AIS_C0RegularityFilter: typeof AIS_C0RegularityFilter;
  AIS_TrihedronOwner: typeof AIS_TrihedronOwner;
  Handle_AIS_TrihedronOwner: typeof Handle_AIS_TrihedronOwner;
  Handle_AIS_TrihedronOwner_1: typeof Handle_AIS_TrihedronOwner_1;
  Handle_AIS_TrihedronOwner_2: typeof Handle_AIS_TrihedronOwner_2;
  Handle_AIS_TrihedronOwner_3: typeof Handle_AIS_TrihedronOwner_3;
  Handle_AIS_TrihedronOwner_4: typeof Handle_AIS_TrihedronOwner_4;
  AIS_ConnectStatus: AIS_ConnectStatus;
  AIS_RubberBand: typeof AIS_RubberBand;
  AIS_RubberBand_1: typeof AIS_RubberBand_1;
  AIS_RubberBand_2: typeof AIS_RubberBand_2;
  AIS_RubberBand_3: typeof AIS_RubberBand_3;
  Handle_AIS_RubberBand: typeof Handle_AIS_RubberBand;
  Handle_AIS_RubberBand_1: typeof Handle_AIS_RubberBand_1;
  Handle_AIS_RubberBand_2: typeof Handle_AIS_RubberBand_2;
  Handle_AIS_RubberBand_3: typeof Handle_AIS_RubberBand_3;
  Handle_AIS_RubberBand_4: typeof Handle_AIS_RubberBand_4;
  AIS_TypeOfIso: AIS_TypeOfIso;
  Handle_AIS_Animation: typeof Handle_AIS_Animation;
  Handle_AIS_Animation_1: typeof Handle_AIS_Animation_1;
  Handle_AIS_Animation_2: typeof Handle_AIS_Animation_2;
  Handle_AIS_Animation_3: typeof Handle_AIS_Animation_3;
  Handle_AIS_Animation_4: typeof Handle_AIS_Animation_4;
  AIS_AnimationProgress: typeof AIS_AnimationProgress;
  AIS_Animation: typeof AIS_Animation;
  AIS_StatusOfDetection: AIS_StatusOfDetection;
  AIS_MultipleConnectedInteractive: typeof AIS_MultipleConnectedInteractive;
  Handle_AIS_MultipleConnectedInteractive: typeof Handle_AIS_MultipleConnectedInteractive;
  Handle_AIS_MultipleConnectedInteractive_1: typeof Handle_AIS_MultipleConnectedInteractive_1;
  Handle_AIS_MultipleConnectedInteractive_2: typeof Handle_AIS_MultipleConnectedInteractive_2;
  Handle_AIS_MultipleConnectedInteractive_3: typeof Handle_AIS_MultipleConnectedInteractive_3;
  Handle_AIS_MultipleConnectedInteractive_4: typeof Handle_AIS_MultipleConnectedInteractive_4;
  Handle_AIS_AnimationObject: typeof Handle_AIS_AnimationObject;
  Handle_AIS_AnimationObject_1: typeof Handle_AIS_AnimationObject_1;
  Handle_AIS_AnimationObject_2: typeof Handle_AIS_AnimationObject_2;
  Handle_AIS_AnimationObject_3: typeof Handle_AIS_AnimationObject_3;
  Handle_AIS_AnimationObject_4: typeof Handle_AIS_AnimationObject_4;
  AIS_AnimationObject: typeof AIS_AnimationObject;
  Handle_AIS_InteractiveObject: typeof Handle_AIS_InteractiveObject;
  Handle_AIS_InteractiveObject_1: typeof Handle_AIS_InteractiveObject_1;
  Handle_AIS_InteractiveObject_2: typeof Handle_AIS_InteractiveObject_2;
  Handle_AIS_InteractiveObject_3: typeof Handle_AIS_InteractiveObject_3;
  Handle_AIS_InteractiveObject_4: typeof Handle_AIS_InteractiveObject_4;
  AIS_InteractiveObject: typeof AIS_InteractiveObject;
  AIS_Trihedron: typeof AIS_Trihedron;
  Handle_AIS_Trihedron: typeof Handle_AIS_Trihedron;
  Handle_AIS_Trihedron_1: typeof Handle_AIS_Trihedron_1;
  Handle_AIS_Trihedron_2: typeof Handle_AIS_Trihedron_2;
  Handle_AIS_Trihedron_3: typeof Handle_AIS_Trihedron_3;
  Handle_AIS_Trihedron_4: typeof Handle_AIS_Trihedron_4;
  Handle_AIS_TypeFilter: typeof Handle_AIS_TypeFilter;
  Handle_AIS_TypeFilter_1: typeof Handle_AIS_TypeFilter_1;
  Handle_AIS_TypeFilter_2: typeof Handle_AIS_TypeFilter_2;
  Handle_AIS_TypeFilter_3: typeof Handle_AIS_TypeFilter_3;
  Handle_AIS_TypeFilter_4: typeof Handle_AIS_TypeFilter_4;
  AIS_TypeFilter: typeof AIS_TypeFilter;
  AIS_ViewController: typeof AIS_ViewController;
  AIS_DragAction: AIS_DragAction;
  AIS_ColoredDrawer: typeof AIS_ColoredDrawer;
  Handle_AIS_ColoredDrawer: typeof Handle_AIS_ColoredDrawer;
  Handle_AIS_ColoredDrawer_1: typeof Handle_AIS_ColoredDrawer_1;
  Handle_AIS_ColoredDrawer_2: typeof Handle_AIS_ColoredDrawer_2;
  Handle_AIS_ColoredDrawer_3: typeof Handle_AIS_ColoredDrawer_3;
  Handle_AIS_ColoredDrawer_4: typeof Handle_AIS_ColoredDrawer_4;
  AIS_XRTrackedDevice: typeof AIS_XRTrackedDevice;
  AIS_XRTrackedDevice_1: typeof AIS_XRTrackedDevice_1;
  AIS_XRTrackedDevice_2: typeof AIS_XRTrackedDevice_2;
  Handle_AIS_Point: typeof Handle_AIS_Point;
  Handle_AIS_Point_1: typeof Handle_AIS_Point_1;
  Handle_AIS_Point_2: typeof Handle_AIS_Point_2;
  Handle_AIS_Point_3: typeof Handle_AIS_Point_3;
  Handle_AIS_Point_4: typeof Handle_AIS_Point_4;
  AIS_Point: typeof AIS_Point;
  AIS_ManipulatorMode: AIS_ManipulatorMode;
  AIS_MediaPlayer: typeof AIS_MediaPlayer;
  AIS_Manipulator: typeof AIS_Manipulator;
  AIS_Manipulator_1: typeof AIS_Manipulator_1;
  AIS_Manipulator_2: typeof AIS_Manipulator_2;
  Handle_AIS_ManipulatorObjectSequence: typeof Handle_AIS_ManipulatorObjectSequence;
  Handle_AIS_ManipulatorObjectSequence_1: typeof Handle_AIS_ManipulatorObjectSequence_1;
  Handle_AIS_ManipulatorObjectSequence_2: typeof Handle_AIS_ManipulatorObjectSequence_2;
  Handle_AIS_ManipulatorObjectSequence_3: typeof Handle_AIS_ManipulatorObjectSequence_3;
  Handle_AIS_ManipulatorObjectSequence_4: typeof Handle_AIS_ManipulatorObjectSequence_4;
  Handle_AIS_Manipulator: typeof Handle_AIS_Manipulator;
  Handle_AIS_Manipulator_1: typeof Handle_AIS_Manipulator_1;
  Handle_AIS_Manipulator_2: typeof Handle_AIS_Manipulator_2;
  Handle_AIS_Manipulator_3: typeof Handle_AIS_Manipulator_3;
  Handle_AIS_Manipulator_4: typeof Handle_AIS_Manipulator_4;
  AIS_CameraFrustum: typeof AIS_CameraFrustum;
  AIS: typeof AIS;
  AIS_GraphicTool: typeof AIS_GraphicTool;
  Handle_AIS_TextLabel: typeof Handle_AIS_TextLabel;
  Handle_AIS_TextLabel_1: typeof Handle_AIS_TextLabel_1;
  Handle_AIS_TextLabel_2: typeof Handle_AIS_TextLabel_2;
  Handle_AIS_TextLabel_3: typeof Handle_AIS_TextLabel_3;
  Handle_AIS_TextLabel_4: typeof Handle_AIS_TextLabel_4;
  AIS_TextLabel: typeof AIS_TextLabel;
  AIS_ClearMode: AIS_ClearMode;
  AIS_DisplayMode: AIS_DisplayMode;
  AIS_ColoredShape: typeof AIS_ColoredShape;
  AIS_ColoredShape_1: typeof AIS_ColoredShape_1;
  AIS_ColoredShape_2: typeof AIS_ColoredShape_2;
  Handle_AIS_ColoredShape: typeof Handle_AIS_ColoredShape;
  Handle_AIS_ColoredShape_1: typeof Handle_AIS_ColoredShape_1;
  Handle_AIS_ColoredShape_2: typeof Handle_AIS_ColoredShape_2;
  Handle_AIS_ColoredShape_3: typeof Handle_AIS_ColoredShape_3;
  Handle_AIS_ColoredShape_4: typeof Handle_AIS_ColoredShape_4;
  AIS_Circle: typeof AIS_Circle;
  AIS_Circle_1: typeof AIS_Circle_1;
  AIS_Circle_2: typeof AIS_Circle_2;
  Handle_AIS_Circle: typeof Handle_AIS_Circle;
  Handle_AIS_Circle_1: typeof Handle_AIS_Circle_1;
  Handle_AIS_Circle_2: typeof Handle_AIS_Circle_2;
  Handle_AIS_Circle_3: typeof Handle_AIS_Circle_3;
  Handle_AIS_Circle_4: typeof Handle_AIS_Circle_4;
  Handle_AIS_AnimationCamera: typeof Handle_AIS_AnimationCamera;
  Handle_AIS_AnimationCamera_1: typeof Handle_AIS_AnimationCamera_1;
  Handle_AIS_AnimationCamera_2: typeof Handle_AIS_AnimationCamera_2;
  Handle_AIS_AnimationCamera_3: typeof Handle_AIS_AnimationCamera_3;
  Handle_AIS_AnimationCamera_4: typeof Handle_AIS_AnimationCamera_4;
  AIS_AnimationCamera: typeof AIS_AnimationCamera;
  AIS_NavigationMode: AIS_NavigationMode;
  Handle_AIS_SignatureFilter: typeof Handle_AIS_SignatureFilter;
  Handle_AIS_SignatureFilter_1: typeof Handle_AIS_SignatureFilter_1;
  Handle_AIS_SignatureFilter_2: typeof Handle_AIS_SignatureFilter_2;
  Handle_AIS_SignatureFilter_3: typeof Handle_AIS_SignatureFilter_3;
  Handle_AIS_SignatureFilter_4: typeof Handle_AIS_SignatureFilter_4;
  AIS_SignatureFilter: typeof AIS_SignatureFilter;
  AIS_PlaneTrihedron: typeof AIS_PlaneTrihedron;
  Handle_AIS_PlaneTrihedron: typeof Handle_AIS_PlaneTrihedron;
  Handle_AIS_PlaneTrihedron_1: typeof Handle_AIS_PlaneTrihedron_1;
  Handle_AIS_PlaneTrihedron_2: typeof Handle_AIS_PlaneTrihedron_2;
  Handle_AIS_PlaneTrihedron_3: typeof Handle_AIS_PlaneTrihedron_3;
  Handle_AIS_PlaneTrihedron_4: typeof Handle_AIS_PlaneTrihedron_4;
  AIS_RotationMode: AIS_RotationMode;
  Handle_AIS_ExclusionFilter: typeof Handle_AIS_ExclusionFilter;
  Handle_AIS_ExclusionFilter_1: typeof Handle_AIS_ExclusionFilter_1;
  Handle_AIS_ExclusionFilter_2: typeof Handle_AIS_ExclusionFilter_2;
  Handle_AIS_ExclusionFilter_3: typeof Handle_AIS_ExclusionFilter_3;
  Handle_AIS_ExclusionFilter_4: typeof Handle_AIS_ExclusionFilter_4;
  AIS_ExclusionFilter: typeof AIS_ExclusionFilter;
  AIS_ExclusionFilter_1: typeof AIS_ExclusionFilter_1;
  AIS_ExclusionFilter_2: typeof AIS_ExclusionFilter_2;
  AIS_ExclusionFilter_3: typeof AIS_ExclusionFilter_3;
  AIS_ViewSelectionTool: AIS_ViewSelectionTool;
  AIS_ViewInputBufferType: AIS_ViewInputBufferType;
  AIS_ViewInputBuffer: typeof AIS_ViewInputBuffer;
  AIS_MouseGesture: AIS_MouseGesture;
  AIS_SelectionModesConcurrency: AIS_SelectionModesConcurrency;
  AIS_TypeOfAttribute: AIS_TypeOfAttribute;
  AIS_KindOfInteractive: AIS_KindOfInteractive;
  Handle_AIS_TexturedShape: typeof Handle_AIS_TexturedShape;
  Handle_AIS_TexturedShape_1: typeof Handle_AIS_TexturedShape_1;
  Handle_AIS_TexturedShape_2: typeof Handle_AIS_TexturedShape_2;
  Handle_AIS_TexturedShape_3: typeof Handle_AIS_TexturedShape_3;
  Handle_AIS_TexturedShape_4: typeof Handle_AIS_TexturedShape_4;
  AIS_TexturedShape: typeof AIS_TexturedShape;
  BinObjMgt_RRelocationTable: typeof BinObjMgt_RRelocationTable;
  BinObjMgt_Persistent: typeof BinObjMgt_Persistent;
  IMeshTools_MeshAlgo: typeof IMeshTools_MeshAlgo;
  IMeshTools_ShapeExplorer: typeof IMeshTools_ShapeExplorer;
  IMeshTools_Context: typeof IMeshTools_Context;
  IMeshTools_ModelAlgo: typeof IMeshTools_ModelAlgo;
  IMeshTools_ModelBuilder: typeof IMeshTools_ModelBuilder;
  IMeshTools_CurveTessellator: typeof IMeshTools_CurveTessellator;
  IMeshTools_MeshBuilder: typeof IMeshTools_MeshBuilder;
  IMeshTools_MeshBuilder_1: typeof IMeshTools_MeshBuilder_1;
  IMeshTools_MeshBuilder_2: typeof IMeshTools_MeshBuilder_2;
  IMeshTools_Parameters: typeof IMeshTools_Parameters;
  IMeshTools_ShapeVisitor: typeof IMeshTools_ShapeVisitor;
  IMeshTools_MeshAlgoType: IMeshTools_MeshAlgoType;
  IMeshTools_MeshAlgoFactory: typeof IMeshTools_MeshAlgoFactory;
  CPnts_AbscissaPoint: typeof CPnts_AbscissaPoint;
  CPnts_AbscissaPoint_1: typeof CPnts_AbscissaPoint_1;
  CPnts_AbscissaPoint_2: typeof CPnts_AbscissaPoint_2;
  CPnts_AbscissaPoint_3: typeof CPnts_AbscissaPoint_3;
  CPnts_AbscissaPoint_4: typeof CPnts_AbscissaPoint_4;
  CPnts_AbscissaPoint_5: typeof CPnts_AbscissaPoint_5;
  CPnts_MyRootFunction: typeof CPnts_MyRootFunction;
  CPnts_UniformDeflection: typeof CPnts_UniformDeflection;
  CPnts_UniformDeflection_1: typeof CPnts_UniformDeflection_1;
  CPnts_UniformDeflection_2: typeof CPnts_UniformDeflection_2;
  CPnts_UniformDeflection_3: typeof CPnts_UniformDeflection_3;
  CPnts_UniformDeflection_4: typeof CPnts_UniformDeflection_4;
  CPnts_UniformDeflection_5: typeof CPnts_UniformDeflection_5;
  CPnts_MyGaussFunction: typeof CPnts_MyGaussFunction;
  TopoDS_Solid: typeof TopoDS_Solid;
  Handle_TopoDS_FrozenShape: typeof Handle_TopoDS_FrozenShape;
  Handle_TopoDS_FrozenShape_1: typeof Handle_TopoDS_FrozenShape_1;
  Handle_TopoDS_FrozenShape_2: typeof Handle_TopoDS_FrozenShape_2;
  Handle_TopoDS_FrozenShape_3: typeof Handle_TopoDS_FrozenShape_3;
  Handle_TopoDS_FrozenShape_4: typeof Handle_TopoDS_FrozenShape_4;
  TopoDS_FrozenShape: typeof TopoDS_FrozenShape;
  TopoDS_FrozenShape_1: typeof TopoDS_FrozenShape_1;
  TopoDS_FrozenShape_2: typeof TopoDS_FrozenShape_2;
  Handle_TopoDS_TVertex: typeof Handle_TopoDS_TVertex;
  Handle_TopoDS_TVertex_1: typeof Handle_TopoDS_TVertex_1;
  Handle_TopoDS_TVertex_2: typeof Handle_TopoDS_TVertex_2;
  Handle_TopoDS_TVertex_3: typeof Handle_TopoDS_TVertex_3;
  Handle_TopoDS_TVertex_4: typeof Handle_TopoDS_TVertex_4;
  TopoDS_TVertex: typeof TopoDS_TVertex;
  TopoDS_TCompSolid: typeof TopoDS_TCompSolid;
  Handle_TopoDS_TCompSolid: typeof Handle_TopoDS_TCompSolid;
  Handle_TopoDS_TCompSolid_1: typeof Handle_TopoDS_TCompSolid_1;
  Handle_TopoDS_TCompSolid_2: typeof Handle_TopoDS_TCompSolid_2;
  Handle_TopoDS_TCompSolid_3: typeof Handle_TopoDS_TCompSolid_3;
  Handle_TopoDS_TCompSolid_4: typeof Handle_TopoDS_TCompSolid_4;
  TopoDS_AlertAttribute: typeof TopoDS_AlertAttribute;
  TopoDS_Shell: typeof TopoDS_Shell;
  TopoDS_CompSolid: typeof TopoDS_CompSolid;
  TopoDS_AlertWithShape: typeof TopoDS_AlertWithShape;
  TopoDS_Shape: typeof TopoDS_Shape;
  Handle_TopoDS_TShell: typeof Handle_TopoDS_TShell;
  Handle_TopoDS_TShell_1: typeof Handle_TopoDS_TShell_1;
  Handle_TopoDS_TShell_2: typeof Handle_TopoDS_TShell_2;
  Handle_TopoDS_TShell_3: typeof Handle_TopoDS_TShell_3;
  Handle_TopoDS_TShell_4: typeof Handle_TopoDS_TShell_4;
  TopoDS_TShell: typeof TopoDS_TShell;
  Handle_TopoDS_TFace: typeof Handle_TopoDS_TFace;
  Handle_TopoDS_TFace_1: typeof Handle_TopoDS_TFace_1;
  Handle_TopoDS_TFace_2: typeof Handle_TopoDS_TFace_2;
  Handle_TopoDS_TFace_3: typeof Handle_TopoDS_TFace_3;
  Handle_TopoDS_TFace_4: typeof Handle_TopoDS_TFace_4;
  TopoDS_TFace: typeof TopoDS_TFace;
  TopoDS_LockedShape: typeof TopoDS_LockedShape;
  TopoDS_LockedShape_1: typeof TopoDS_LockedShape_1;
  TopoDS_LockedShape_2: typeof TopoDS_LockedShape_2;
  Handle_TopoDS_LockedShape: typeof Handle_TopoDS_LockedShape;
  Handle_TopoDS_LockedShape_1: typeof Handle_TopoDS_LockedShape_1;
  Handle_TopoDS_LockedShape_2: typeof Handle_TopoDS_LockedShape_2;
  Handle_TopoDS_LockedShape_3: typeof Handle_TopoDS_LockedShape_3;
  Handle_TopoDS_LockedShape_4: typeof Handle_TopoDS_LockedShape_4;
  TopoDS_TCompound: typeof TopoDS_TCompound;
  Handle_TopoDS_TCompound: typeof Handle_TopoDS_TCompound;
  Handle_TopoDS_TCompound_1: typeof Handle_TopoDS_TCompound_1;
  Handle_TopoDS_TCompound_2: typeof Handle_TopoDS_TCompound_2;
  Handle_TopoDS_TCompound_3: typeof Handle_TopoDS_TCompound_3;
  Handle_TopoDS_TCompound_4: typeof Handle_TopoDS_TCompound_4;
  TopoDS_TShape: typeof TopoDS_TShape;
  Handle_TopoDS_TShape: typeof Handle_TopoDS_TShape;
  Handle_TopoDS_TShape_1: typeof Handle_TopoDS_TShape_1;
  Handle_TopoDS_TShape_2: typeof Handle_TopoDS_TShape_2;
  Handle_TopoDS_TShape_3: typeof Handle_TopoDS_TShape_3;
  Handle_TopoDS_TShape_4: typeof Handle_TopoDS_TShape_4;
  TopoDS_Face: typeof TopoDS_Face;
  TopoDS_TEdge: typeof TopoDS_TEdge;
  Handle_TopoDS_TEdge: typeof Handle_TopoDS_TEdge;
  Handle_TopoDS_TEdge_1: typeof Handle_TopoDS_TEdge_1;
  Handle_TopoDS_TEdge_2: typeof Handle_TopoDS_TEdge_2;
  Handle_TopoDS_TEdge_3: typeof Handle_TopoDS_TEdge_3;
  Handle_TopoDS_TEdge_4: typeof Handle_TopoDS_TEdge_4;
  TopoDS_Builder: typeof TopoDS_Builder;
  TopoDS_UnCompatibleShapes: typeof TopoDS_UnCompatibleShapes;
  TopoDS_UnCompatibleShapes_1: typeof TopoDS_UnCompatibleShapes_1;
  TopoDS_UnCompatibleShapes_2: typeof TopoDS_UnCompatibleShapes_2;
  Handle_TopoDS_UnCompatibleShapes: typeof Handle_TopoDS_UnCompatibleShapes;
  Handle_TopoDS_UnCompatibleShapes_1: typeof Handle_TopoDS_UnCompatibleShapes_1;
  Handle_TopoDS_UnCompatibleShapes_2: typeof Handle_TopoDS_UnCompatibleShapes_2;
  Handle_TopoDS_UnCompatibleShapes_3: typeof Handle_TopoDS_UnCompatibleShapes_3;
  Handle_TopoDS_UnCompatibleShapes_4: typeof Handle_TopoDS_UnCompatibleShapes_4;
  TopoDS_TSolid: typeof TopoDS_TSolid;
  Handle_TopoDS_TSolid: typeof Handle_TopoDS_TSolid;
  Handle_TopoDS_TSolid_1: typeof Handle_TopoDS_TSolid_1;
  Handle_TopoDS_TSolid_2: typeof Handle_TopoDS_TSolid_2;
  Handle_TopoDS_TSolid_3: typeof Handle_TopoDS_TSolid_3;
  Handle_TopoDS_TSolid_4: typeof Handle_TopoDS_TSolid_4;
  TopoDS_Edge: typeof TopoDS_Edge;
  TopoDS: typeof TopoDS;
  Handle_TopoDS_TWire: typeof Handle_TopoDS_TWire;
  Handle_TopoDS_TWire_1: typeof Handle_TopoDS_TWire_1;
  Handle_TopoDS_TWire_2: typeof Handle_TopoDS_TWire_2;
  Handle_TopoDS_TWire_3: typeof Handle_TopoDS_TWire_3;
  Handle_TopoDS_TWire_4: typeof Handle_TopoDS_TWire_4;
  TopoDS_TWire: typeof TopoDS_TWire;
  TopoDS_Wire: typeof TopoDS_Wire;
  Handle_TopoDS_HShape: typeof Handle_TopoDS_HShape;
  Handle_TopoDS_HShape_1: typeof Handle_TopoDS_HShape_1;
  Handle_TopoDS_HShape_2: typeof Handle_TopoDS_HShape_2;
  Handle_TopoDS_HShape_3: typeof Handle_TopoDS_HShape_3;
  Handle_TopoDS_HShape_4: typeof Handle_TopoDS_HShape_4;
  TopoDS_HShape: typeof TopoDS_HShape;
  TopoDS_HShape_1: typeof TopoDS_HShape_1;
  TopoDS_HShape_2: typeof TopoDS_HShape_2;
  TopoDS_Vertex: typeof TopoDS_Vertex;
  TopoDS_Iterator: typeof TopoDS_Iterator;
  TopoDS_Iterator_1: typeof TopoDS_Iterator_1;
  TopoDS_Iterator_2: typeof TopoDS_Iterator_2;
  TopoDS_Compound: typeof TopoDS_Compound;
  GeomInt_ResConstraintOfMyGradientOfTheComputeLineBezierOfWLApprox: typeof GeomInt_ResConstraintOfMyGradientOfTheComputeLineBezierOfWLApprox;
  GeomInt: typeof GeomInt;
  GeomInt_Gradient_BFGSOfMyGradientOfTheComputeLineBezierOfWLApprox: typeof GeomInt_Gradient_BFGSOfMyGradientOfTheComputeLineBezierOfWLApprox;
  GeomInt_BSpParFunctionOfMyBSplGradientOfTheComputeLineOfWLApprox: typeof GeomInt_BSpParFunctionOfMyBSplGradientOfTheComputeLineOfWLApprox;
  GeomInt_MyGradientOfTheComputeLineBezierOfWLApprox: typeof GeomInt_MyGradientOfTheComputeLineBezierOfWLApprox;
  GeomInt_WLApprox: typeof GeomInt_WLApprox;
  GeomInt_IntSS: typeof GeomInt_IntSS;
  GeomInt_IntSS_1: typeof GeomInt_IntSS_1;
  GeomInt_IntSS_2: typeof GeomInt_IntSS_2;
  GeomInt_SequenceOfParameterAndOrientation: typeof GeomInt_SequenceOfParameterAndOrientation;
  GeomInt_SequenceOfParameterAndOrientation_1: typeof GeomInt_SequenceOfParameterAndOrientation_1;
  GeomInt_SequenceOfParameterAndOrientation_2: typeof GeomInt_SequenceOfParameterAndOrientation_2;
  GeomInt_SequenceOfParameterAndOrientation_3: typeof GeomInt_SequenceOfParameterAndOrientation_3;
  GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox: typeof GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox;
  GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_1: typeof GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_1;
  GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_2: typeof GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_2;
  GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_3: typeof GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_3;
  GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_4: typeof GeomInt_BSpParLeastSquareOfMyBSplGradientOfTheComputeLineOfWLApprox_4;
  GeomInt_LineConstructor: typeof GeomInt_LineConstructor;
  GeomInt_BSpGradient_BFGSOfMyBSplGradientOfTheComputeLineOfWLApprox: typeof GeomInt_BSpGradient_BFGSOfMyBSplGradientOfTheComputeLineOfWLApprox;
  GeomInt_LineTool: typeof GeomInt_LineTool;
  GeomInt_TheMultiLineOfWLApprox: typeof GeomInt_TheMultiLineOfWLApprox;
  GeomInt_TheMultiLineOfWLApprox_1: typeof GeomInt_TheMultiLineOfWLApprox_1;
  GeomInt_TheMultiLineOfWLApprox_2: typeof GeomInt_TheMultiLineOfWLApprox_2;
  GeomInt_TheMultiLineOfWLApprox_3: typeof GeomInt_TheMultiLineOfWLApprox_3;
  GeomInt_ParFunctionOfMyGradientbisOfTheComputeLineOfWLApprox: typeof GeomInt_ParFunctionOfMyGradientbisOfTheComputeLineOfWLApprox;
  GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox: typeof GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox;
  GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox_1: typeof GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox_1;
  GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox_2: typeof GeomInt_TheInt2SOfThePrmPrmSvSurfacesOfWLApprox_2;
  GeomInt_TheImpPrmSvSurfacesOfWLApprox: typeof GeomInt_TheImpPrmSvSurfacesOfWLApprox;
  GeomInt_TheImpPrmSvSurfacesOfWLApprox_1: typeof GeomInt_TheImpPrmSvSurfacesOfWLApprox_1;
  GeomInt_TheImpPrmSvSurfacesOfWLApprox_2: typeof GeomInt_TheImpPrmSvSurfacesOfWLApprox_2;
  GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox: typeof GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox;
  GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_1: typeof GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_1;
  GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_2: typeof GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_2;
  GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_3: typeof GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_3;
  GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_4: typeof GeomInt_ParLeastSquareOfMyGradientOfTheComputeLineBezierOfWLApprox_4;
  GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox: typeof GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox;
  GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_1: typeof GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_1;
  GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_2: typeof GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_2;
  GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_3: typeof GeomInt_TheZerImpFuncOfTheImpPrmSvSurfacesOfWLApprox_3;
  GeomInt_TheComputeLineOfWLApprox: typeof GeomInt_TheComputeLineOfWLApprox;
  GeomInt_TheComputeLineOfWLApprox_1: typeof GeomInt_TheComputeLineOfWLApprox_1;
  GeomInt_TheComputeLineOfWLApprox_2: typeof GeomInt_TheComputeLineOfWLApprox_2;
  GeomInt_TheComputeLineOfWLApprox_3: typeof GeomInt_TheComputeLineOfWLApprox_3;
  GeomInt_TheComputeLineOfWLApprox_4: typeof GeomInt_TheComputeLineOfWLApprox_4;
  GeomInt_VectorOfReal: typeof GeomInt_VectorOfReal;
  GeomInt_VectorOfReal_1: typeof GeomInt_VectorOfReal_1;
  GeomInt_VectorOfReal_2: typeof GeomInt_VectorOfReal_2;
  GeomInt_ParameterAndOrientation: typeof GeomInt_ParameterAndOrientation;
  GeomInt_ParameterAndOrientation_1: typeof GeomInt_ParameterAndOrientation_1;
  GeomInt_ParameterAndOrientation_2: typeof GeomInt_ParameterAndOrientation_2;
  GeomInt_ThePrmPrmSvSurfacesOfWLApprox: typeof GeomInt_ThePrmPrmSvSurfacesOfWLApprox;
  GeomInt_TheComputeLineBezierOfWLApprox: typeof GeomInt_TheComputeLineBezierOfWLApprox;
  GeomInt_TheComputeLineBezierOfWLApprox_1: typeof GeomInt_TheComputeLineBezierOfWLApprox_1;
  GeomInt_TheComputeLineBezierOfWLApprox_2: typeof GeomInt_TheComputeLineBezierOfWLApprox_2;
  GeomInt_TheComputeLineBezierOfWLApprox_3: typeof GeomInt_TheComputeLineBezierOfWLApprox_3;
  GeomInt_TheComputeLineBezierOfWLApprox_4: typeof GeomInt_TheComputeLineBezierOfWLApprox_4;
  GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox: typeof GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox;
  GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox_1: typeof GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox_1;
  GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox_2: typeof GeomInt_MyBSplGradientOfTheComputeLineOfWLApprox_2;
  GeomInt_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfWLApprox: typeof GeomInt_TheFunctionOfTheInt2SOfThePrmPrmSvSurfacesOfWLApprox;
  GeomInt_ResConstraintOfMyGradientbisOfTheComputeLineOfWLApprox: typeof GeomInt_ResConstraintOfMyGradientbisOfTheComputeLineOfWLApprox;
  GeomInt_ParFunctionOfMyGradientOfTheComputeLineBezierOfWLApprox: typeof GeomInt_ParFunctionOfMyGradientOfTheComputeLineBezierOfWLApprox;
  GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox: typeof GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox;
  GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_1: typeof GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_1;
  GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_2: typeof GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_2;
  GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_3: typeof GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_3;
  GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_4: typeof GeomInt_ParLeastSquareOfMyGradientbisOfTheComputeLineOfWLApprox_4;
  GeomInt_MyGradientbisOfTheComputeLineOfWLApprox: typeof GeomInt_MyGradientbisOfTheComputeLineOfWLApprox;
  GeomInt_TheMultiLineToolOfWLApprox: typeof GeomInt_TheMultiLineToolOfWLApprox;
  GeomInt_Gradient_BFGSOfMyGradientbisOfTheComputeLineOfWLApprox: typeof GeomInt_Gradient_BFGSOfMyGradientbisOfTheComputeLineOfWLApprox;
  LProp_SequenceOfCIType: typeof LProp_SequenceOfCIType;
  LProp_SequenceOfCIType_1: typeof LProp_SequenceOfCIType_1;
  LProp_SequenceOfCIType_2: typeof LProp_SequenceOfCIType_2;
  LProp_SequenceOfCIType_3: typeof LProp_SequenceOfCIType_3;
  LProp_CurAndInf: typeof LProp_CurAndInf;
  LProp_CIType: LProp_CIType;
  LProp_NotDefined: typeof LProp_NotDefined;
  LProp_NotDefined_1: typeof LProp_NotDefined_1;
  LProp_NotDefined_2: typeof LProp_NotDefined_2;
  Handle_LProp_NotDefined: typeof Handle_LProp_NotDefined;
  Handle_LProp_NotDefined_1: typeof Handle_LProp_NotDefined_1;
  Handle_LProp_NotDefined_2: typeof Handle_LProp_NotDefined_2;
  Handle_LProp_NotDefined_3: typeof Handle_LProp_NotDefined_3;
  Handle_LProp_NotDefined_4: typeof Handle_LProp_NotDefined_4;
  Handle_LProp_BadContinuity: typeof Handle_LProp_BadContinuity;
  Handle_LProp_BadContinuity_1: typeof Handle_LProp_BadContinuity_1;
  Handle_LProp_BadContinuity_2: typeof Handle_LProp_BadContinuity_2;
  Handle_LProp_BadContinuity_3: typeof Handle_LProp_BadContinuity_3;
  Handle_LProp_BadContinuity_4: typeof Handle_LProp_BadContinuity_4;
  LProp_BadContinuity: typeof LProp_BadContinuity;
  LProp_BadContinuity_1: typeof LProp_BadContinuity_1;
  LProp_BadContinuity_2: typeof LProp_BadContinuity_2;
  LProp_AnalyticCurInf: typeof LProp_AnalyticCurInf;
  LProp_Status: LProp_Status;
  BSplCLib: typeof BSplCLib;
  Handle_BSplCLib_Cache: typeof Handle_BSplCLib_Cache;
  Handle_BSplCLib_Cache_1: typeof Handle_BSplCLib_Cache_1;
  Handle_BSplCLib_Cache_2: typeof Handle_BSplCLib_Cache_2;
  Handle_BSplCLib_Cache_3: typeof Handle_BSplCLib_Cache_3;
  Handle_BSplCLib_Cache_4: typeof Handle_BSplCLib_Cache_4;
  BSplCLib_Cache: typeof BSplCLib_Cache;
  BSplCLib_Cache_1: typeof BSplCLib_Cache_1;
  BSplCLib_Cache_2: typeof BSplCLib_Cache_2;
  BSplCLib_EvaluatorFunction: typeof BSplCLib_EvaluatorFunction;
  BSplCLib_KnotDistribution: BSplCLib_KnotDistribution;
  BSplCLib_MultDistribution: BSplCLib_MultDistribution;
  BSplCLib_CacheParams: typeof BSplCLib_CacheParams;
  Approx_FitAndDivide2d: typeof Approx_FitAndDivide2d;
  Approx_FitAndDivide2d_1: typeof Approx_FitAndDivide2d_1;
  Approx_FitAndDivide2d_2: typeof Approx_FitAndDivide2d_2;
  Approx_MCurvesToBSpCurve: typeof Approx_MCurvesToBSpCurve;
  Approx_FitAndDivide: typeof Approx_FitAndDivide;
  Approx_FitAndDivide_1: typeof Approx_FitAndDivide_1;
  Approx_FitAndDivide_2: typeof Approx_FitAndDivide_2;
  Approx_CurveOnSurface: typeof Approx_CurveOnSurface;
  Approx_CurveOnSurface_1: typeof Approx_CurveOnSurface_1;
  Approx_CurveOnSurface_2: typeof Approx_CurveOnSurface_2;
  Approx_Status: Approx_Status;
  Approx_SameParameter: typeof Approx_SameParameter;
  Approx_SameParameter_1: typeof Approx_SameParameter_1;
  Approx_SameParameter_2: typeof Approx_SameParameter_2;
  Approx_SameParameter_3: typeof Approx_SameParameter_3;
  Approx_ParametrizationType: Approx_ParametrizationType;
  Approx_CurvlinFunc: typeof Approx_CurvlinFunc;
  Approx_CurvlinFunc_1: typeof Approx_CurvlinFunc_1;
  Approx_CurvlinFunc_2: typeof Approx_CurvlinFunc_2;
  Approx_CurvlinFunc_3: typeof Approx_CurvlinFunc_3;
  Handle_Approx_CurvlinFunc: typeof Handle_Approx_CurvlinFunc;
  Handle_Approx_CurvlinFunc_1: typeof Handle_Approx_CurvlinFunc_1;
  Handle_Approx_CurvlinFunc_2: typeof Handle_Approx_CurvlinFunc_2;
  Handle_Approx_CurvlinFunc_3: typeof Handle_Approx_CurvlinFunc_3;
  Handle_Approx_CurvlinFunc_4: typeof Handle_Approx_CurvlinFunc_4;
  Approx_SweepFunction: typeof Approx_SweepFunction;
  Handle_Approx_SweepFunction: typeof Handle_Approx_SweepFunction;
  Handle_Approx_SweepFunction_1: typeof Handle_Approx_SweepFunction_1;
  Handle_Approx_SweepFunction_2: typeof Handle_Approx_SweepFunction_2;
  Handle_Approx_SweepFunction_3: typeof Handle_Approx_SweepFunction_3;
  Handle_Approx_SweepFunction_4: typeof Handle_Approx_SweepFunction_4;
  Handle_Approx_HArray1OfAdHSurface: typeof Handle_Approx_HArray1OfAdHSurface;
  Handle_Approx_HArray1OfAdHSurface_1: typeof Handle_Approx_HArray1OfAdHSurface_1;
  Handle_Approx_HArray1OfAdHSurface_2: typeof Handle_Approx_HArray1OfAdHSurface_2;
  Handle_Approx_HArray1OfAdHSurface_3: typeof Handle_Approx_HArray1OfAdHSurface_3;
  Handle_Approx_HArray1OfAdHSurface_4: typeof Handle_Approx_HArray1OfAdHSurface_4;
  Approx_Array1OfGTrsf2d: typeof Approx_Array1OfGTrsf2d;
  Approx_Array1OfGTrsf2d_1: typeof Approx_Array1OfGTrsf2d_1;
  Approx_Array1OfGTrsf2d_2: typeof Approx_Array1OfGTrsf2d_2;
  Approx_Array1OfGTrsf2d_3: typeof Approx_Array1OfGTrsf2d_3;
  Approx_Array1OfGTrsf2d_4: typeof Approx_Array1OfGTrsf2d_4;
  Approx_Array1OfGTrsf2d_5: typeof Approx_Array1OfGTrsf2d_5;
  Approx_CurvilinearParameter: typeof Approx_CurvilinearParameter;
  Approx_CurvilinearParameter_1: typeof Approx_CurvilinearParameter_1;
  Approx_CurvilinearParameter_2: typeof Approx_CurvilinearParameter_2;
  Approx_CurvilinearParameter_3: typeof Approx_CurvilinearParameter_3;
  Approx_Curve2d: typeof Approx_Curve2d;
  Approx_Curve3d: typeof Approx_Curve3d;
  Handle_Approx_HArray1OfGTrsf2d: typeof Handle_Approx_HArray1OfGTrsf2d;
  Handle_Approx_HArray1OfGTrsf2d_1: typeof Handle_Approx_HArray1OfGTrsf2d_1;
  Handle_Approx_HArray1OfGTrsf2d_2: typeof Handle_Approx_HArray1OfGTrsf2d_2;
  Handle_Approx_HArray1OfGTrsf2d_3: typeof Handle_Approx_HArray1OfGTrsf2d_3;
  Handle_Approx_HArray1OfGTrsf2d_4: typeof Handle_Approx_HArray1OfGTrsf2d_4;
  Approx_SweepApproximation: typeof Approx_SweepApproximation;
  IntImp_ConstIsoparametric: IntImp_ConstIsoparametric;
  Handle_ShapeProcess_Context: typeof Handle_ShapeProcess_Context;
  Handle_ShapeProcess_Context_1: typeof Handle_ShapeProcess_Context_1;
  Handle_ShapeProcess_Context_2: typeof Handle_ShapeProcess_Context_2;
  Handle_ShapeProcess_Context_3: typeof Handle_ShapeProcess_Context_3;
  Handle_ShapeProcess_Context_4: typeof Handle_ShapeProcess_Context_4;
  ShapeProcess_Context: typeof ShapeProcess_Context;
  ShapeProcess_Context_1: typeof ShapeProcess_Context_1;
  ShapeProcess_Context_2: typeof ShapeProcess_Context_2;
  Handle_ShapeProcess_Operator: typeof Handle_ShapeProcess_Operator;
  Handle_ShapeProcess_Operator_1: typeof Handle_ShapeProcess_Operator_1;
  Handle_ShapeProcess_Operator_2: typeof Handle_ShapeProcess_Operator_2;
  Handle_ShapeProcess_Operator_3: typeof Handle_ShapeProcess_Operator_3;
  Handle_ShapeProcess_Operator_4: typeof Handle_ShapeProcess_Operator_4;
  ShapeProcess_Operator: typeof ShapeProcess_Operator;
  ShapeProcess: typeof ShapeProcess;
  ShapeProcess_UOperator: typeof ShapeProcess_UOperator;
  Handle_ShapeProcess_UOperator: typeof Handle_ShapeProcess_UOperator;
  Handle_ShapeProcess_UOperator_1: typeof Handle_ShapeProcess_UOperator_1;
  Handle_ShapeProcess_UOperator_2: typeof Handle_ShapeProcess_UOperator_2;
  Handle_ShapeProcess_UOperator_3: typeof Handle_ShapeProcess_UOperator_3;
  Handle_ShapeProcess_UOperator_4: typeof Handle_ShapeProcess_UOperator_4;
  Handle_ShapeProcess_ShapeContext: typeof Handle_ShapeProcess_ShapeContext;
  Handle_ShapeProcess_ShapeContext_1: typeof Handle_ShapeProcess_ShapeContext_1;
  Handle_ShapeProcess_ShapeContext_2: typeof Handle_ShapeProcess_ShapeContext_2;
  Handle_ShapeProcess_ShapeContext_3: typeof Handle_ShapeProcess_ShapeContext_3;
  Handle_ShapeProcess_ShapeContext_4: typeof Handle_ShapeProcess_ShapeContext_4;
  ShapeProcess_ShapeContext: typeof ShapeProcess_ShapeContext;
  ShapeProcess_ShapeContext_1: typeof ShapeProcess_ShapeContext_1;
  ShapeProcess_ShapeContext_2: typeof ShapeProcess_ShapeContext_2;
  ShapeProcess_OperLibrary: typeof ShapeProcess_OperLibrary;
  XmlDrivers: typeof XmlDrivers;
  Handle_XmlDrivers_DocumentStorageDriver: typeof Handle_XmlDrivers_DocumentStorageDriver;
  Handle_XmlDrivers_DocumentStorageDriver_1: typeof Handle_XmlDrivers_DocumentStorageDriver_1;
  Handle_XmlDrivers_DocumentStorageDriver_2: typeof Handle_XmlDrivers_DocumentStorageDriver_2;
  Handle_XmlDrivers_DocumentStorageDriver_3: typeof Handle_XmlDrivers_DocumentStorageDriver_3;
  Handle_XmlDrivers_DocumentStorageDriver_4: typeof Handle_XmlDrivers_DocumentStorageDriver_4;
  XmlDrivers_DocumentStorageDriver: typeof XmlDrivers_DocumentStorageDriver;
  Handle_XmlDrivers_DocumentRetrievalDriver: typeof Handle_XmlDrivers_DocumentRetrievalDriver;
  Handle_XmlDrivers_DocumentRetrievalDriver_1: typeof Handle_XmlDrivers_DocumentRetrievalDriver_1;
  Handle_XmlDrivers_DocumentRetrievalDriver_2: typeof Handle_XmlDrivers_DocumentRetrievalDriver_2;
  Handle_XmlDrivers_DocumentRetrievalDriver_3: typeof Handle_XmlDrivers_DocumentRetrievalDriver_3;
  Handle_XmlDrivers_DocumentRetrievalDriver_4: typeof Handle_XmlDrivers_DocumentRetrievalDriver_4;
  XmlDrivers_DocumentRetrievalDriver: typeof XmlDrivers_DocumentRetrievalDriver;
  StepAP242_ItemIdentifiedRepresentationUsageDefinition: typeof StepAP242_ItemIdentifiedRepresentationUsageDefinition;
  Handle_StepAP242_DraughtingModelItemAssociation: typeof Handle_StepAP242_DraughtingModelItemAssociation;
  Handle_StepAP242_DraughtingModelItemAssociation_1: typeof Handle_StepAP242_DraughtingModelItemAssociation_1;
  Handle_StepAP242_DraughtingModelItemAssociation_2: typeof Handle_StepAP242_DraughtingModelItemAssociation_2;
  Handle_StepAP242_DraughtingModelItemAssociation_3: typeof Handle_StepAP242_DraughtingModelItemAssociation_3;
  Handle_StepAP242_DraughtingModelItemAssociation_4: typeof Handle_StepAP242_DraughtingModelItemAssociation_4;
  StepAP242_DraughtingModelItemAssociation: typeof StepAP242_DraughtingModelItemAssociation;
  Handle_StepAP242_ItemIdentifiedRepresentationUsage: typeof Handle_StepAP242_ItemIdentifiedRepresentationUsage;
  Handle_StepAP242_ItemIdentifiedRepresentationUsage_1: typeof Handle_StepAP242_ItemIdentifiedRepresentationUsage_1;
  Handle_StepAP242_ItemIdentifiedRepresentationUsage_2: typeof Handle_StepAP242_ItemIdentifiedRepresentationUsage_2;
  Handle_StepAP242_ItemIdentifiedRepresentationUsage_3: typeof Handle_StepAP242_ItemIdentifiedRepresentationUsage_3;
  Handle_StepAP242_ItemIdentifiedRepresentationUsage_4: typeof Handle_StepAP242_ItemIdentifiedRepresentationUsage_4;
  StepAP242_ItemIdentifiedRepresentationUsage: typeof StepAP242_ItemIdentifiedRepresentationUsage;
  StepAP242_IdAttributeSelect: typeof StepAP242_IdAttributeSelect;
  StepAP242_GeometricItemSpecificUsage: typeof StepAP242_GeometricItemSpecificUsage;
  Handle_StepAP242_GeometricItemSpecificUsage: typeof Handle_StepAP242_GeometricItemSpecificUsage;
  Handle_StepAP242_GeometricItemSpecificUsage_1: typeof Handle_StepAP242_GeometricItemSpecificUsage_1;
  Handle_StepAP242_GeometricItemSpecificUsage_2: typeof Handle_StepAP242_GeometricItemSpecificUsage_2;
  Handle_StepAP242_GeometricItemSpecificUsage_3: typeof Handle_StepAP242_GeometricItemSpecificUsage_3;
  Handle_StepAP242_GeometricItemSpecificUsage_4: typeof Handle_StepAP242_GeometricItemSpecificUsage_4;
  Handle_StepAP242_IdAttribute: typeof Handle_StepAP242_IdAttribute;
  Handle_StepAP242_IdAttribute_1: typeof Handle_StepAP242_IdAttribute_1;
  Handle_StepAP242_IdAttribute_2: typeof Handle_StepAP242_IdAttribute_2;
  Handle_StepAP242_IdAttribute_3: typeof Handle_StepAP242_IdAttribute_3;
  Handle_StepAP242_IdAttribute_4: typeof Handle_StepAP242_IdAttribute_4;
  StepAP242_IdAttribute: typeof StepAP242_IdAttribute;
  Geom2dInt_GInter: typeof Geom2dInt_GInter;
  Geom2dInt_GInter_1: typeof Geom2dInt_GInter_1;
  Geom2dInt_GInter_2: typeof Geom2dInt_GInter_2;
  Geom2dInt_GInter_3: typeof Geom2dInt_GInter_3;
  Geom2dInt_GInter_4: typeof Geom2dInt_GInter_4;
  Geom2dInt_GInter_5: typeof Geom2dInt_GInter_5;
  Geom2dInt_GInter_6: typeof Geom2dInt_GInter_6;
  Geom2dInt_GInter_7: typeof Geom2dInt_GInter_7;
  Geom2dInt_ExactIntersectionPointOfTheIntPCurvePCurveOfGInter: typeof Geom2dInt_ExactIntersectionPointOfTheIntPCurvePCurveOfGInter;
  Geom2dInt_MyImpParToolOfTheIntersectorOfTheIntConicCurveOfGInter: typeof Geom2dInt_MyImpParToolOfTheIntersectorOfTheIntConicCurveOfGInter;
  Geom2dInt_TheIntPCurvePCurveOfGInter: typeof Geom2dInt_TheIntPCurvePCurveOfGInter;
  Geom2dInt_IntConicCurveOfGInter: typeof Geom2dInt_IntConicCurveOfGInter;
  Geom2dInt_IntConicCurveOfGInter_1: typeof Geom2dInt_IntConicCurveOfGInter_1;
  Geom2dInt_IntConicCurveOfGInter_2: typeof Geom2dInt_IntConicCurveOfGInter_2;
  Geom2dInt_IntConicCurveOfGInter_3: typeof Geom2dInt_IntConicCurveOfGInter_3;
  Geom2dInt_IntConicCurveOfGInter_4: typeof Geom2dInt_IntConicCurveOfGInter_4;
  Geom2dInt_IntConicCurveOfGInter_5: typeof Geom2dInt_IntConicCurveOfGInter_5;
  Geom2dInt_IntConicCurveOfGInter_6: typeof Geom2dInt_IntConicCurveOfGInter_6;
  Geom2dInt_TheProjPCurOfGInter: typeof Geom2dInt_TheProjPCurOfGInter;
  Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter: typeof Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter;
  Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_1: typeof Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_1;
  Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_2: typeof Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_2;
  Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_3: typeof Geom2dInt_TheLocateExtPCOfTheProjPCurOfGInter_3;
  Geom2dInt_Geom2dCurveTool: typeof Geom2dInt_Geom2dCurveTool;
  Geom2dInt_TheIntConicCurveOfGInter: typeof Geom2dInt_TheIntConicCurveOfGInter;
  Geom2dInt_TheIntConicCurveOfGInter_1: typeof Geom2dInt_TheIntConicCurveOfGInter_1;
  Geom2dInt_TheIntConicCurveOfGInter_2: typeof Geom2dInt_TheIntConicCurveOfGInter_2;
  Geom2dInt_TheIntConicCurveOfGInter_3: typeof Geom2dInt_TheIntConicCurveOfGInter_3;
  Geom2dInt_TheIntConicCurveOfGInter_4: typeof Geom2dInt_TheIntConicCurveOfGInter_4;
  Geom2dInt_TheIntConicCurveOfGInter_5: typeof Geom2dInt_TheIntConicCurveOfGInter_5;
  Geom2dInt_TheIntConicCurveOfGInter_6: typeof Geom2dInt_TheIntConicCurveOfGInter_6;
  Geom2dInt_ThePolygon2dOfTheIntPCurvePCurveOfGInter: typeof Geom2dInt_ThePolygon2dOfTheIntPCurvePCurveOfGInter;
  Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter: typeof Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter;
  Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter_1: typeof Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter_1;
  Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter_2: typeof Geom2dInt_TheIntersectorOfTheIntConicCurveOfGInter_2;
  Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter: typeof Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter;
  Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter_1: typeof Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter_1;
  Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter_2: typeof Geom2dInt_PCLocFOfTheLocateExtPCOfTheProjPCurOfGInter_2;
  Geom2dInt_TheCurveLocatorOfTheProjPCurOfGInter: typeof Geom2dInt_TheCurveLocatorOfTheProjPCurOfGInter;
  Geom2dInt_TheDistBetweenPCurvesOfTheIntPCurvePCurveOfGInter: typeof Geom2dInt_TheDistBetweenPCurvesOfTheIntPCurvePCurveOfGInter;
  STEPCAFControl_GDTProperty: typeof STEPCAFControl_GDTProperty;
  STEPCAFControl_ExternFile: typeof STEPCAFControl_ExternFile;
  Handle_STEPCAFControl_ExternFile: typeof Handle_STEPCAFControl_ExternFile;
  Handle_STEPCAFControl_ExternFile_1: typeof Handle_STEPCAFControl_ExternFile_1;
  Handle_STEPCAFControl_ExternFile_2: typeof Handle_STEPCAFControl_ExternFile_2;
  Handle_STEPCAFControl_ExternFile_3: typeof Handle_STEPCAFControl_ExternFile_3;
  Handle_STEPCAFControl_ExternFile_4: typeof Handle_STEPCAFControl_ExternFile_4;
  Handle_STEPCAFControl_ActorWrite: typeof Handle_STEPCAFControl_ActorWrite;
  Handle_STEPCAFControl_ActorWrite_1: typeof Handle_STEPCAFControl_ActorWrite_1;
  Handle_STEPCAFControl_ActorWrite_2: typeof Handle_STEPCAFControl_ActorWrite_2;
  Handle_STEPCAFControl_ActorWrite_3: typeof Handle_STEPCAFControl_ActorWrite_3;
  Handle_STEPCAFControl_ActorWrite_4: typeof Handle_STEPCAFControl_ActorWrite_4;
  STEPCAFControl_ActorWrite: typeof STEPCAFControl_ActorWrite;
  STEPCAFControl_Reader: typeof STEPCAFControl_Reader;
  STEPCAFControl_Reader_1: typeof STEPCAFControl_Reader_1;
  STEPCAFControl_Reader_2: typeof STEPCAFControl_Reader_2;
  STEPCAFControl_DataMapOfLabelShape: typeof STEPCAFControl_DataMapOfLabelShape;
  STEPCAFControl_DataMapOfLabelShape_1: typeof STEPCAFControl_DataMapOfLabelShape_1;
  STEPCAFControl_DataMapOfLabelShape_2: typeof STEPCAFControl_DataMapOfLabelShape_2;
  STEPCAFControl_DataMapOfLabelShape_3: typeof STEPCAFControl_DataMapOfLabelShape_3;
  Handle_STEPCAFControl_Controller: typeof Handle_STEPCAFControl_Controller;
  Handle_STEPCAFControl_Controller_1: typeof Handle_STEPCAFControl_Controller_1;
  Handle_STEPCAFControl_Controller_2: typeof Handle_STEPCAFControl_Controller_2;
  Handle_STEPCAFControl_Controller_3: typeof Handle_STEPCAFControl_Controller_3;
  Handle_STEPCAFControl_Controller_4: typeof Handle_STEPCAFControl_Controller_4;
  STEPCAFControl_Controller: typeof STEPCAFControl_Controller;
  STEPCAFControl_Writer: typeof STEPCAFControl_Writer;
  STEPCAFControl_Writer_1: typeof STEPCAFControl_Writer_1;
  STEPCAFControl_Writer_2: typeof STEPCAFControl_Writer_2;
  Handle_BSplSLib_Cache: typeof Handle_BSplSLib_Cache;
  Handle_BSplSLib_Cache_1: typeof Handle_BSplSLib_Cache_1;
  Handle_BSplSLib_Cache_2: typeof Handle_BSplSLib_Cache_2;
  Handle_BSplSLib_Cache_3: typeof Handle_BSplSLib_Cache_3;
  Handle_BSplSLib_Cache_4: typeof Handle_BSplSLib_Cache_4;
  BSplSLib_Cache: typeof BSplSLib_Cache;
  BSplSLib: typeof BSplSLib;
  BSplSLib_EvaluatorFunction: typeof BSplSLib_EvaluatorFunction;
  TopTrans_Array2OfOrientation: typeof TopTrans_Array2OfOrientation;
  TopTrans_Array2OfOrientation_1: typeof TopTrans_Array2OfOrientation_1;
  TopTrans_Array2OfOrientation_2: typeof TopTrans_Array2OfOrientation_2;
  TopTrans_Array2OfOrientation_3: typeof TopTrans_Array2OfOrientation_3;
  TopTrans_Array2OfOrientation_4: typeof TopTrans_Array2OfOrientation_4;
  TopTrans_Array2OfOrientation_5: typeof TopTrans_Array2OfOrientation_5;
  TopTrans_CurveTransition: typeof TopTrans_CurveTransition;
  TopTrans_SurfaceTransition: typeof TopTrans_SurfaceTransition;
  BRepLProp_SLProps: typeof BRepLProp_SLProps;
  BRepLProp_SLProps_1: typeof BRepLProp_SLProps_1;
  BRepLProp_SLProps_2: typeof BRepLProp_SLProps_2;
  BRepLProp_SLProps_3: typeof BRepLProp_SLProps_3;
  BRepLProp_CurveTool: typeof BRepLProp_CurveTool;
  BRepLProp: typeof BRepLProp;
  BRepLProp_CLProps: typeof BRepLProp_CLProps;
  BRepLProp_CLProps_1: typeof BRepLProp_CLProps_1;
  BRepLProp_CLProps_2: typeof BRepLProp_CLProps_2;
  BRepLProp_CLProps_3: typeof BRepLProp_CLProps_3;
  BRepLProp_SurfaceTool: typeof BRepLProp_SurfaceTool;
  Resource_DataMapOfAsciiStringExtendedString: typeof Resource_DataMapOfAsciiStringExtendedString;
  Resource_DataMapOfAsciiStringExtendedString_1: typeof Resource_DataMapOfAsciiStringExtendedString_1;
  Resource_DataMapOfAsciiStringExtendedString_2: typeof Resource_DataMapOfAsciiStringExtendedString_2;
  Resource_DataMapOfAsciiStringExtendedString_3: typeof Resource_DataMapOfAsciiStringExtendedString_3;
  Handle_Resource_Manager: typeof Handle_Resource_Manager;
  Handle_Resource_Manager_1: typeof Handle_Resource_Manager_1;
  Handle_Resource_Manager_2: typeof Handle_Resource_Manager_2;
  Handle_Resource_Manager_3: typeof Handle_Resource_Manager_3;
  Handle_Resource_Manager_4: typeof Handle_Resource_Manager_4;
  Resource_Manager: typeof Resource_Manager;
  Resource_Manager_1: typeof Resource_Manager_1;
  Resource_Manager_2: typeof Resource_Manager_2;
  Resource_FormatType: Resource_FormatType;
  Resource_LexicalCompare: typeof Resource_LexicalCompare;
  Resource_DataMapOfAsciiStringAsciiString: typeof Resource_DataMapOfAsciiStringAsciiString;
  Resource_DataMapOfAsciiStringAsciiString_1: typeof Resource_DataMapOfAsciiStringAsciiString_1;
  Resource_DataMapOfAsciiStringAsciiString_2: typeof Resource_DataMapOfAsciiStringAsciiString_2;
  Resource_DataMapOfAsciiStringAsciiString_3: typeof Resource_DataMapOfAsciiStringAsciiString_3;
  Resource_NoSuchResource: typeof Resource_NoSuchResource;
  Resource_NoSuchResource_1: typeof Resource_NoSuchResource_1;
  Resource_NoSuchResource_2: typeof Resource_NoSuchResource_2;
  Handle_Resource_NoSuchResource: typeof Handle_Resource_NoSuchResource;
  Handle_Resource_NoSuchResource_1: typeof Handle_Resource_NoSuchResource_1;
  Handle_Resource_NoSuchResource_2: typeof Handle_Resource_NoSuchResource_2;
  Handle_Resource_NoSuchResource_3: typeof Handle_Resource_NoSuchResource_3;
  Handle_Resource_NoSuchResource_4: typeof Handle_Resource_NoSuchResource_4;
  Resource_Unicode: typeof Resource_Unicode;
  Handle_BinTObjDrivers_ReferenceDriver: typeof Handle_BinTObjDrivers_ReferenceDriver;
  Handle_BinTObjDrivers_ReferenceDriver_1: typeof Handle_BinTObjDrivers_ReferenceDriver_1;
  Handle_BinTObjDrivers_ReferenceDriver_2: typeof Handle_BinTObjDrivers_ReferenceDriver_2;
  Handle_BinTObjDrivers_ReferenceDriver_3: typeof Handle_BinTObjDrivers_ReferenceDriver_3;
  Handle_BinTObjDrivers_ReferenceDriver_4: typeof Handle_BinTObjDrivers_ReferenceDriver_4;
  BinTObjDrivers_ReferenceDriver: typeof BinTObjDrivers_ReferenceDriver;
  BinTObjDrivers: typeof BinTObjDrivers;
  Handle_BinTObjDrivers_DocumentRetrievalDriver: typeof Handle_BinTObjDrivers_DocumentRetrievalDriver;
  Handle_BinTObjDrivers_DocumentRetrievalDriver_1: typeof Handle_BinTObjDrivers_DocumentRetrievalDriver_1;
  Handle_BinTObjDrivers_DocumentRetrievalDriver_2: typeof Handle_BinTObjDrivers_DocumentRetrievalDriver_2;
  Handle_BinTObjDrivers_DocumentRetrievalDriver_3: typeof Handle_BinTObjDrivers_DocumentRetrievalDriver_3;
  Handle_BinTObjDrivers_DocumentRetrievalDriver_4: typeof Handle_BinTObjDrivers_DocumentRetrievalDriver_4;
  BinTObjDrivers_DocumentRetrievalDriver: typeof BinTObjDrivers_DocumentRetrievalDriver;
  Handle_BinTObjDrivers_ObjectDriver: typeof Handle_BinTObjDrivers_ObjectDriver;
  Handle_BinTObjDrivers_ObjectDriver_1: typeof Handle_BinTObjDrivers_ObjectDriver_1;
  Handle_BinTObjDrivers_ObjectDriver_2: typeof Handle_BinTObjDrivers_ObjectDriver_2;
  Handle_BinTObjDrivers_ObjectDriver_3: typeof Handle_BinTObjDrivers_ObjectDriver_3;
  Handle_BinTObjDrivers_ObjectDriver_4: typeof Handle_BinTObjDrivers_ObjectDriver_4;
  BinTObjDrivers_ObjectDriver: typeof BinTObjDrivers_ObjectDriver;
  Handle_BinTObjDrivers_DocumentStorageDriver: typeof Handle_BinTObjDrivers_DocumentStorageDriver;
  Handle_BinTObjDrivers_DocumentStorageDriver_1: typeof Handle_BinTObjDrivers_DocumentStorageDriver_1;
  Handle_BinTObjDrivers_DocumentStorageDriver_2: typeof Handle_BinTObjDrivers_DocumentStorageDriver_2;
  Handle_BinTObjDrivers_DocumentStorageDriver_3: typeof Handle_BinTObjDrivers_DocumentStorageDriver_3;
  Handle_BinTObjDrivers_DocumentStorageDriver_4: typeof Handle_BinTObjDrivers_DocumentStorageDriver_4;
  BinTObjDrivers_DocumentStorageDriver: typeof BinTObjDrivers_DocumentStorageDriver;
  Handle_BinTObjDrivers_ModelDriver: typeof Handle_BinTObjDrivers_ModelDriver;
  Handle_BinTObjDrivers_ModelDriver_1: typeof Handle_BinTObjDrivers_ModelDriver_1;
  Handle_BinTObjDrivers_ModelDriver_2: typeof Handle_BinTObjDrivers_ModelDriver_2;
  Handle_BinTObjDrivers_ModelDriver_3: typeof Handle_BinTObjDrivers_ModelDriver_3;
  Handle_BinTObjDrivers_ModelDriver_4: typeof Handle_BinTObjDrivers_ModelDriver_4;
  BinTObjDrivers_ModelDriver: typeof BinTObjDrivers_ModelDriver;
  Handle_BinTObjDrivers_IntSparseArrayDriver: typeof Handle_BinTObjDrivers_IntSparseArrayDriver;
  Handle_BinTObjDrivers_IntSparseArrayDriver_1: typeof Handle_BinTObjDrivers_IntSparseArrayDriver_1;
  Handle_BinTObjDrivers_IntSparseArrayDriver_2: typeof Handle_BinTObjDrivers_IntSparseArrayDriver_2;
  Handle_BinTObjDrivers_IntSparseArrayDriver_3: typeof Handle_BinTObjDrivers_IntSparseArrayDriver_3;
  Handle_BinTObjDrivers_IntSparseArrayDriver_4: typeof Handle_BinTObjDrivers_IntSparseArrayDriver_4;
  BinTObjDrivers_IntSparseArrayDriver: typeof BinTObjDrivers_IntSparseArrayDriver;
  BinTObjDrivers_XYZDriver: typeof BinTObjDrivers_XYZDriver;
  Handle_BinTObjDrivers_XYZDriver: typeof Handle_BinTObjDrivers_XYZDriver;
  Handle_BinTObjDrivers_XYZDriver_1: typeof Handle_BinTObjDrivers_XYZDriver_1;
  Handle_BinTObjDrivers_XYZDriver_2: typeof Handle_BinTObjDrivers_XYZDriver_2;
  Handle_BinTObjDrivers_XYZDriver_3: typeof Handle_BinTObjDrivers_XYZDriver_3;
  Handle_BinTObjDrivers_XYZDriver_4: typeof Handle_BinTObjDrivers_XYZDriver_4;
  StepRepr_ValueRange: typeof StepRepr_ValueRange;
  Handle_StepRepr_ValueRange: typeof Handle_StepRepr_ValueRange;
  Handle_StepRepr_ValueRange_1: typeof Handle_StepRepr_ValueRange_1;
  Handle_StepRepr_ValueRange_2: typeof Handle_StepRepr_ValueRange_2;
  Handle_StepRepr_ValueRange_3: typeof Handle_StepRepr_ValueRange_3;
  Handle_StepRepr_ValueRange_4: typeof Handle_StepRepr_ValueRange_4;
  Handle_StepRepr_ConfigurationDesign: typeof Handle_StepRepr_ConfigurationDesign;
  Handle_StepRepr_ConfigurationDesign_1: typeof Handle_StepRepr_ConfigurationDesign_1;
  Handle_StepRepr_ConfigurationDesign_2: typeof Handle_StepRepr_ConfigurationDesign_2;
  Handle_StepRepr_ConfigurationDesign_3: typeof Handle_StepRepr_ConfigurationDesign_3;
  Handle_StepRepr_ConfigurationDesign_4: typeof Handle_StepRepr_ConfigurationDesign_4;
  StepRepr_ConfigurationDesign: typeof StepRepr_ConfigurationDesign;
  StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp: typeof StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp;
  Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp: typeof Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp;
  Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_1: typeof Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_1;
  Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_2: typeof Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_2;
  Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_3: typeof Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_3;
  Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_4: typeof Handle_StepRepr_CompGroupShAspAndCompShAspAndDatumFeatAndShAsp_4;
  StepRepr_ReprItemAndMeasureWithUnit: typeof StepRepr_ReprItemAndMeasureWithUnit;
  Handle_StepRepr_ReprItemAndMeasureWithUnit: typeof Handle_StepRepr_ReprItemAndMeasureWithUnit;
  Handle_StepRepr_ReprItemAndMeasureWithUnit_1: typeof Handle_StepRepr_ReprItemAndMeasureWithUnit_1;
  Handle_StepRepr_ReprItemAndMeasureWithUnit_2: typeof Handle_StepRepr_ReprItemAndMeasureWithUnit_2;
  Handle_StepRepr_ReprItemAndMeasureWithUnit_3: typeof Handle_StepRepr_ReprItemAndMeasureWithUnit_3;
  Handle_StepRepr_ReprItemAndMeasureWithUnit_4: typeof Handle_StepRepr_ReprItemAndMeasureWithUnit_4;
  Handle_StepRepr_QuantifiedAssemblyComponentUsage: typeof Handle_StepRepr_QuantifiedAssemblyComponentUsage;
  Handle_StepRepr_QuantifiedAssemblyComponentUsage_1: typeof Handle_StepRepr_QuantifiedAssemblyComponentUsage_1;
  Handle_StepRepr_QuantifiedAssemblyComponentUsage_2: typeof Handle_StepRepr_QuantifiedAssemblyComponentUsage_2;
  Handle_StepRepr_QuantifiedAssemblyComponentUsage_3: typeof Handle_StepRepr_QuantifiedAssemblyComponentUsage_3;
  Handle_StepRepr_QuantifiedAssemblyComponentUsage_4: typeof Handle_StepRepr_QuantifiedAssemblyComponentUsage_4;
  StepRepr_QuantifiedAssemblyComponentUsage: typeof StepRepr_QuantifiedAssemblyComponentUsage;
  Handle_StepRepr_ParametricRepresentationContext: typeof Handle_StepRepr_ParametricRepresentationContext;
  Handle_StepRepr_ParametricRepresentationContext_1: typeof Handle_StepRepr_ParametricRepresentationContext_1;
  Handle_StepRepr_ParametricRepresentationContext_2: typeof Handle_StepRepr_ParametricRepresentationContext_2;
  Handle_StepRepr_ParametricRepresentationContext_3: typeof Handle_StepRepr_ParametricRepresentationContext_3;
  Handle_StepRepr_ParametricRepresentationContext_4: typeof Handle_StepRepr_ParametricRepresentationContext_4;
  StepRepr_ParametricRepresentationContext: typeof StepRepr_ParametricRepresentationContext;
  Handle_StepRepr_NextAssemblyUsageOccurrence: typeof Handle_StepRepr_NextAssemblyUsageOccurrence;
  Handle_StepRepr_NextAssemblyUsageOccurrence_1: typeof Handle_StepRepr_NextAssemblyUsageOccurrence_1;
  Handle_StepRepr_NextAssemblyUsageOccurrence_2: typeof Handle_StepRepr_NextAssemblyUsageOccurrence_2;
  Handle_StepRepr_NextAssemblyUsageOccurrence_3: typeof Handle_StepRepr_NextAssemblyUsageOccurrence_3;
  Handle_StepRepr_NextAssemblyUsageOccurrence_4: typeof Handle_StepRepr_NextAssemblyUsageOccurrence_4;
  StepRepr_NextAssemblyUsageOccurrence: typeof StepRepr_NextAssemblyUsageOccurrence;
  Handle_StepRepr_Tangent: typeof Handle_StepRepr_Tangent;
  Handle_StepRepr_Tangent_1: typeof Handle_StepRepr_Tangent_1;
  Handle_StepRepr_Tangent_2: typeof Handle_StepRepr_Tangent_2;
  Handle_StepRepr_Tangent_3: typeof Handle_StepRepr_Tangent_3;
  Handle_StepRepr_Tangent_4: typeof Handle_StepRepr_Tangent_4;
  StepRepr_Tangent: typeof StepRepr_Tangent;
  Handle_StepRepr_StructuralResponseProperty: typeof Handle_StepRepr_StructuralResponseProperty;
  Handle_StepRepr_StructuralResponseProperty_1: typeof Handle_StepRepr_StructuralResponseProperty_1;
  Handle_StepRepr_StructuralResponseProperty_2: typeof Handle_StepRepr_StructuralResponseProperty_2;
  Handle_StepRepr_StructuralResponseProperty_3: typeof Handle_StepRepr_StructuralResponseProperty_3;
  Handle_StepRepr_StructuralResponseProperty_4: typeof Handle_StepRepr_StructuralResponseProperty_4;
  StepRepr_StructuralResponseProperty: typeof StepRepr_StructuralResponseProperty;
  StepRepr_CompositeShapeAspect: typeof StepRepr_CompositeShapeAspect;
  Handle_StepRepr_CompositeShapeAspect: typeof Handle_StepRepr_CompositeShapeAspect;
  Handle_StepRepr_CompositeShapeAspect_1: typeof Handle_StepRepr_CompositeShapeAspect_1;
  Handle_StepRepr_CompositeShapeAspect_2: typeof Handle_StepRepr_CompositeShapeAspect_2;
  Handle_StepRepr_CompositeShapeAspect_3: typeof Handle_StepRepr_CompositeShapeAspect_3;
  Handle_StepRepr_CompositeShapeAspect_4: typeof Handle_StepRepr_CompositeShapeAspect_4;
  Handle_StepRepr_PropertyDefinitionRepresentation: typeof Handle_StepRepr_PropertyDefinitionRepresentation;
  Handle_StepRepr_PropertyDefinitionRepresentation_1: typeof Handle_StepRepr_PropertyDefinitionRepresentation_1;
  Handle_StepRepr_PropertyDefinitionRepresentation_2: typeof Handle_StepRepr_PropertyDefinitionRepresentation_2;
  Handle_StepRepr_PropertyDefinitionRepresentation_3: typeof Handle_StepRepr_PropertyDefinitionRepresentation_3;
  Handle_StepRepr_PropertyDefinitionRepresentation_4: typeof Handle_StepRepr_PropertyDefinitionRepresentation_4;
  StepRepr_PropertyDefinitionRepresentation: typeof StepRepr_PropertyDefinitionRepresentation;
  StepRepr_FeatureForDatumTargetRelationship: typeof StepRepr_FeatureForDatumTargetRelationship;
  Handle_StepRepr_FeatureForDatumTargetRelationship: typeof Handle_StepRepr_FeatureForDatumTargetRelationship;
  Handle_StepRepr_FeatureForDatumTargetRelationship_1: typeof Handle_StepRepr_FeatureForDatumTargetRelationship_1;
  Handle_StepRepr_FeatureForDatumTargetRelationship_2: typeof Handle_StepRepr_FeatureForDatumTargetRelationship_2;
  Handle_StepRepr_FeatureForDatumTargetRelationship_3: typeof Handle_StepRepr_FeatureForDatumTargetRelationship_3;
  Handle_StepRepr_FeatureForDatumTargetRelationship_4: typeof Handle_StepRepr_FeatureForDatumTargetRelationship_4;
  Handle_StepRepr_HArray1OfMaterialPropertyRepresentation: typeof Handle_StepRepr_HArray1OfMaterialPropertyRepresentation;
  Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_1: typeof Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_1;
  Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_2: typeof Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_2;
  Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_3: typeof Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_3;
  Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_4: typeof Handle_StepRepr_HArray1OfMaterialPropertyRepresentation_4;
  Handle_StepRepr_DataEnvironment: typeof Handle_StepRepr_DataEnvironment;
  Handle_StepRepr_DataEnvironment_1: typeof Handle_StepRepr_DataEnvironment_1;
  Handle_StepRepr_DataEnvironment_2: typeof Handle_StepRepr_DataEnvironment_2;
  Handle_StepRepr_DataEnvironment_3: typeof Handle_StepRepr_DataEnvironment_3;
  Handle_StepRepr_DataEnvironment_4: typeof Handle_StepRepr_DataEnvironment_4;
  StepRepr_DataEnvironment: typeof StepRepr_DataEnvironment;
  Handle_StepRepr_ParallelOffset: typeof Handle_StepRepr_ParallelOffset;
  Handle_StepRepr_ParallelOffset_1: typeof Handle_StepRepr_ParallelOffset_1;
  Handle_StepRepr_ParallelOffset_2: typeof Handle_StepRepr_ParallelOffset_2;
  Handle_StepRepr_ParallelOffset_3: typeof Handle_StepRepr_ParallelOffset_3;
  Handle_StepRepr_ParallelOffset_4: typeof Handle_StepRepr_ParallelOffset_4;
  StepRepr_ParallelOffset: typeof StepRepr_ParallelOffset;
  StepRepr_MappedItem: typeof StepRepr_MappedItem;
  Handle_StepRepr_MappedItem: typeof Handle_StepRepr_MappedItem;
  Handle_StepRepr_MappedItem_1: typeof Handle_StepRepr_MappedItem_1;
  Handle_StepRepr_MappedItem_2: typeof Handle_StepRepr_MappedItem_2;
  Handle_StepRepr_MappedItem_3: typeof Handle_StepRepr_MappedItem_3;
  Handle_StepRepr_MappedItem_4: typeof Handle_StepRepr_MappedItem_4;
  StepRepr_ReprItemAndMeasureWithUnitAndQRI: typeof StepRepr_ReprItemAndMeasureWithUnitAndQRI;
  Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI: typeof Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI;
  Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_1: typeof Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_1;
  Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_2: typeof Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_2;
  Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_3: typeof Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_3;
  Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_4: typeof Handle_StepRepr_ReprItemAndMeasureWithUnitAndQRI_4;
  Handle_StepRepr_BetweenShapeAspect: typeof Handle_StepRepr_BetweenShapeAspect;
  Handle_StepRepr_BetweenShapeAspect_1: typeof Handle_StepRepr_BetweenShapeAspect_1;
  Handle_StepRepr_BetweenShapeAspect_2: typeof Handle_StepRepr_BetweenShapeAspect_2;
  Handle_StepRepr_BetweenShapeAspect_3: typeof Handle_StepRepr_BetweenShapeAspect_3;
  Handle_StepRepr_BetweenShapeAspect_4: typeof Handle_StepRepr_BetweenShapeAspect_4;
  StepRepr_BetweenShapeAspect: typeof StepRepr_BetweenShapeAspect;
  Handle_StepRepr_RepresentationRelationship: typeof Handle_StepRepr_RepresentationRelationship;
  Handle_StepRepr_RepresentationRelationship_1: typeof Handle_StepRepr_RepresentationRelationship_1;
  Handle_StepRepr_RepresentationRelationship_2: typeof Handle_StepRepr_RepresentationRelationship_2;
  Handle_StepRepr_RepresentationRelationship_3: typeof Handle_StepRepr_RepresentationRelationship_3;
  Handle_StepRepr_RepresentationRelationship_4: typeof Handle_StepRepr_RepresentationRelationship_4;
  StepRepr_RepresentationRelationship: typeof StepRepr_RepresentationRelationship;
  Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation: typeof Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation;
  Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_1: typeof Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_1;
  Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_2: typeof Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_2;
  Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_3: typeof Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_3;
  Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_4: typeof Handle_StepRepr_HSequenceOfMaterialPropertyRepresentation_4;
  Handle_StepRepr_PerpendicularTo: typeof Handle_StepRepr_PerpendicularTo;
  Handle_StepRepr_PerpendicularTo_1: typeof Handle_StepRepr_PerpendicularTo_1;
  Handle_StepRepr_PerpendicularTo_2: typeof Handle_StepRepr_PerpendicularTo_2;
  Handle_StepRepr_PerpendicularTo_3: typeof Handle_StepRepr_PerpendicularTo_3;
  Handle_StepRepr_PerpendicularTo_4: typeof Handle_StepRepr_PerpendicularTo_4;
  StepRepr_PerpendicularTo: typeof StepRepr_PerpendicularTo;
  StepRepr_RepresentationRelationshipWithTransformation: typeof StepRepr_RepresentationRelationshipWithTransformation;
  Handle_StepRepr_RepresentationRelationshipWithTransformation: typeof Handle_StepRepr_RepresentationRelationshipWithTransformation;
  Handle_StepRepr_RepresentationRelationshipWithTransformation_1: typeof Handle_StepRepr_RepresentationRelationshipWithTransformation_1;
  Handle_StepRepr_RepresentationRelationshipWithTransformation_2: typeof Handle_StepRepr_RepresentationRelationshipWithTransformation_2;
  Handle_StepRepr_RepresentationRelationshipWithTransformation_3: typeof Handle_StepRepr_RepresentationRelationshipWithTransformation_3;
  Handle_StepRepr_RepresentationRelationshipWithTransformation_4: typeof Handle_StepRepr_RepresentationRelationshipWithTransformation_4;
  StepRepr_PromissoryUsageOccurrence: typeof StepRepr_PromissoryUsageOccurrence;
  Handle_StepRepr_PromissoryUsageOccurrence: typeof Handle_StepRepr_PromissoryUsageOccurrence;
  Handle_StepRepr_PromissoryUsageOccurrence_1: typeof Handle_StepRepr_PromissoryUsageOccurrence_1;
  Handle_StepRepr_PromissoryUsageOccurrence_2: typeof Handle_StepRepr_PromissoryUsageOccurrence_2;
  Handle_StepRepr_PromissoryUsageOccurrence_3: typeof Handle_StepRepr_PromissoryUsageOccurrence_3;
  Handle_StepRepr_PromissoryUsageOccurrence_4: typeof Handle_StepRepr_PromissoryUsageOccurrence_4;
  StepRepr_ProductDefinitionUsage: typeof StepRepr_ProductDefinitionUsage;
  Handle_StepRepr_ProductDefinitionUsage: typeof Handle_StepRepr_ProductDefinitionUsage;
  Handle_StepRepr_ProductDefinitionUsage_1: typeof Handle_StepRepr_ProductDefinitionUsage_1;
  Handle_StepRepr_ProductDefinitionUsage_2: typeof Handle_StepRepr_ProductDefinitionUsage_2;
  Handle_StepRepr_ProductDefinitionUsage_3: typeof Handle_StepRepr_ProductDefinitionUsage_3;
  Handle_StepRepr_ProductDefinitionUsage_4: typeof Handle_StepRepr_ProductDefinitionUsage_4;
  Handle_StepRepr_MaterialDesignation: typeof Handle_StepRepr_MaterialDesignation;
  Handle_StepRepr_MaterialDesignation_1: typeof Handle_StepRepr_MaterialDesignation_1;
  Handle_StepRepr_MaterialDesignation_2: typeof Handle_StepRepr_MaterialDesignation_2;
  Handle_StepRepr_MaterialDesignation_3: typeof Handle_StepRepr_MaterialDesignation_3;
  Handle_StepRepr_MaterialDesignation_4: typeof Handle_StepRepr_MaterialDesignation_4;
  StepRepr_MaterialDesignation: typeof StepRepr_MaterialDesignation;
  StepRepr_MaterialPropertyRepresentation: typeof StepRepr_MaterialPropertyRepresentation;
  Handle_StepRepr_MaterialPropertyRepresentation: typeof Handle_StepRepr_MaterialPropertyRepresentation;
  Handle_StepRepr_MaterialPropertyRepresentation_1: typeof Handle_StepRepr_MaterialPropertyRepresentation_1;
  Handle_StepRepr_MaterialPropertyRepresentation_2: typeof Handle_StepRepr_MaterialPropertyRepresentation_2;
  Handle_StepRepr_MaterialPropertyRepresentation_3: typeof Handle_StepRepr_MaterialPropertyRepresentation_3;
  Handle_StepRepr_MaterialPropertyRepresentation_4: typeof Handle_StepRepr_MaterialPropertyRepresentation_4;
  Handle_StepRepr_HSequenceOfRepresentationItem: typeof Handle_StepRepr_HSequenceOfRepresentationItem;
  Handle_StepRepr_HSequenceOfRepresentationItem_1: typeof Handle_StepRepr_HSequenceOfRepresentationItem_1;
  Handle_StepRepr_HSequenceOfRepresentationItem_2: typeof Handle_StepRepr_HSequenceOfRepresentationItem_2;
  Handle_StepRepr_HSequenceOfRepresentationItem_3: typeof Handle_StepRepr_HSequenceOfRepresentationItem_3;
  Handle_StepRepr_HSequenceOfRepresentationItem_4: typeof Handle_StepRepr_HSequenceOfRepresentationItem_4;
  Handle_StepRepr_GlobalUnitAssignedContext: typeof Handle_StepRepr_GlobalUnitAssignedContext;
  Handle_StepRepr_GlobalUnitAssignedContext_1: typeof Handle_StepRepr_GlobalUnitAssignedContext_1;
  Handle_StepRepr_GlobalUnitAssignedContext_2: typeof Handle_StepRepr_GlobalUnitAssignedContext_2;
  Handle_StepRepr_GlobalUnitAssignedContext_3: typeof Handle_StepRepr_GlobalUnitAssignedContext_3;
  Handle_StepRepr_GlobalUnitAssignedContext_4: typeof Handle_StepRepr_GlobalUnitAssignedContext_4;
  StepRepr_GlobalUnitAssignedContext: typeof StepRepr_GlobalUnitAssignedContext;
  Handle_StepRepr_Extension: typeof Handle_StepRepr_Extension;
  Handle_StepRepr_Extension_1: typeof Handle_StepRepr_Extension_1;
  Handle_StepRepr_Extension_2: typeof Handle_StepRepr_Extension_2;
  Handle_StepRepr_Extension_3: typeof Handle_StepRepr_Extension_3;
  Handle_StepRepr_Extension_4: typeof Handle_StepRepr_Extension_4;
  StepRepr_Extension: typeof StepRepr_Extension;
  StepRepr_ReprItemAndLengthMeasureWithUnit: typeof StepRepr_ReprItemAndLengthMeasureWithUnit;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnit: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnit;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_1: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_1;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_2: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_2;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_3: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_3;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_4: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnit_4;
  Handle_StepRepr_PropertyDefinitionRelationship: typeof Handle_StepRepr_PropertyDefinitionRelationship;
  Handle_StepRepr_PropertyDefinitionRelationship_1: typeof Handle_StepRepr_PropertyDefinitionRelationship_1;
  Handle_StepRepr_PropertyDefinitionRelationship_2: typeof Handle_StepRepr_PropertyDefinitionRelationship_2;
  Handle_StepRepr_PropertyDefinitionRelationship_3: typeof Handle_StepRepr_PropertyDefinitionRelationship_3;
  Handle_StepRepr_PropertyDefinitionRelationship_4: typeof Handle_StepRepr_PropertyDefinitionRelationship_4;
  StepRepr_PropertyDefinitionRelationship: typeof StepRepr_PropertyDefinitionRelationship;
  StepRepr_SpecifiedHigherUsageOccurrence: typeof StepRepr_SpecifiedHigherUsageOccurrence;
  Handle_StepRepr_SpecifiedHigherUsageOccurrence: typeof Handle_StepRepr_SpecifiedHigherUsageOccurrence;
  Handle_StepRepr_SpecifiedHigherUsageOccurrence_1: typeof Handle_StepRepr_SpecifiedHigherUsageOccurrence_1;
  Handle_StepRepr_SpecifiedHigherUsageOccurrence_2: typeof Handle_StepRepr_SpecifiedHigherUsageOccurrence_2;
  Handle_StepRepr_SpecifiedHigherUsageOccurrence_3: typeof Handle_StepRepr_SpecifiedHigherUsageOccurrence_3;
  Handle_StepRepr_SpecifiedHigherUsageOccurrence_4: typeof Handle_StepRepr_SpecifiedHigherUsageOccurrence_4;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_1: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_1;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_2: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_2;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_3: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_3;
  Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_4: typeof Handle_StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI_4;
  StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI: typeof StepRepr_ReprItemAndLengthMeasureWithUnitAndQRI;
  Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation: typeof Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation;
  Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_1: typeof Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_1;
  Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_2: typeof Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_2;
  Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_3: typeof Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_3;
  Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_4: typeof Handle_StepRepr_HArray1OfPropertyDefinitionRepresentation_4;
  StepRepr_AssemblyComponentUsageSubstitute: typeof StepRepr_AssemblyComponentUsageSubstitute;
  Handle_StepRepr_AssemblyComponentUsageSubstitute: typeof Handle_StepRepr_AssemblyComponentUsageSubstitute;
  Handle_StepRepr_AssemblyComponentUsageSubstitute_1: typeof Handle_StepRepr_AssemblyComponentUsageSubstitute_1;
  Handle_StepRepr_AssemblyComponentUsageSubstitute_2: typeof Handle_StepRepr_AssemblyComponentUsageSubstitute_2;
  Handle_StepRepr_AssemblyComponentUsageSubstitute_3: typeof Handle_StepRepr_AssemblyComponentUsageSubstitute_3;
  Handle_StepRepr_AssemblyComponentUsageSubstitute_4: typeof Handle_StepRepr_AssemblyComponentUsageSubstitute_4;
  StepRepr_CharacterizedDefinition: typeof StepRepr_CharacterizedDefinition;
  Handle_StepRepr_CharacterizedRepresentation: typeof Handle_StepRepr_CharacterizedRepresentation;
  Handle_StepRepr_CharacterizedRepresentation_1: typeof Handle_StepRepr_CharacterizedRepresentation_1;
  Handle_StepRepr_CharacterizedRepresentation_2: typeof Handle_StepRepr_CharacterizedRepresentation_2;
  Handle_StepRepr_CharacterizedRepresentation_3: typeof Handle_StepRepr_CharacterizedRepresentation_3;
  Handle_StepRepr_CharacterizedRepresentation_4: typeof Handle_StepRepr_CharacterizedRepresentation_4;
  StepRepr_CharacterizedRepresentation: typeof StepRepr_CharacterizedRepresentation;
  Handle_StepRepr_AssemblyComponentUsage: typeof Handle_StepRepr_AssemblyComponentUsage;
  Handle_StepRepr_AssemblyComponentUsage_1: typeof Handle_StepRepr_AssemblyComponentUsage_1;
  Handle_StepRepr_AssemblyComponentUsage_2: typeof Handle_StepRepr_AssemblyComponentUsage_2;
  Handle_StepRepr_AssemblyComponentUsage_3: typeof Handle_StepRepr_AssemblyComponentUsage_3;
  Handle_StepRepr_AssemblyComponentUsage_4: typeof Handle_StepRepr_AssemblyComponentUsage_4;
  StepRepr_AssemblyComponentUsage: typeof StepRepr_AssemblyComponentUsage;
  StepRepr_DefinitionalRepresentation: typeof StepRepr_DefinitionalRepresentation;
  Handle_StepRepr_DefinitionalRepresentation: typeof Handle_StepRepr_DefinitionalRepresentation;
  Handle_StepRepr_DefinitionalRepresentation_1: typeof Handle_StepRepr_DefinitionalRepresentation_1;
  Handle_StepRepr_DefinitionalRepresentation_2: typeof Handle_StepRepr_DefinitionalRepresentation_2;
  Handle_StepRepr_DefinitionalRepresentation_3: typeof Handle_StepRepr_DefinitionalRepresentation_3;
  Handle_StepRepr_DefinitionalRepresentation_4: typeof Handle_StepRepr_DefinitionalRepresentation_4;
  StepRepr_GeometricAlignment: typeof StepRepr_GeometricAlignment;
  Handle_StepRepr_GeometricAlignment: typeof Handle_StepRepr_GeometricAlignment;
  Handle_StepRepr_GeometricAlignment_1: typeof Handle_StepRepr_GeometricAlignment_1;
  Handle_StepRepr_GeometricAlignment_2: typeof Handle_StepRepr_GeometricAlignment_2;
  Handle_StepRepr_GeometricAlignment_3: typeof Handle_StepRepr_GeometricAlignment_3;
  Handle_StepRepr_GeometricAlignment_4: typeof Handle_StepRepr_GeometricAlignment_4;
  StepRepr_ConfigurationEffectivity: typeof StepRepr_ConfigurationEffectivity;
  Handle_StepRepr_ConfigurationEffectivity: typeof Handle_StepRepr_ConfigurationEffectivity;
  Handle_StepRepr_ConfigurationEffectivity_1: typeof Handle_StepRepr_ConfigurationEffectivity_1;
  Handle_StepRepr_ConfigurationEffectivity_2: typeof Handle_StepRepr_ConfigurationEffectivity_2;
  Handle_StepRepr_ConfigurationEffectivity_3: typeof Handle_StepRepr_ConfigurationEffectivity_3;
  Handle_StepRepr_ConfigurationEffectivity_4: typeof Handle_StepRepr_ConfigurationEffectivity_4;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_1: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_1;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_2: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_2;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_3: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_3;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_4: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnit_4;
  StepRepr_ReprItemAndPlaneAngleMeasureWithUnit: typeof StepRepr_ReprItemAndPlaneAngleMeasureWithUnit;
  StepRepr_MaterialProperty: typeof StepRepr_MaterialProperty;
  Handle_StepRepr_MaterialProperty: typeof Handle_StepRepr_MaterialProperty;
  Handle_StepRepr_MaterialProperty_1: typeof Handle_StepRepr_MaterialProperty_1;
  Handle_StepRepr_MaterialProperty_2: typeof Handle_StepRepr_MaterialProperty_2;
  Handle_StepRepr_MaterialProperty_3: typeof Handle_StepRepr_MaterialProperty_3;
  Handle_StepRepr_MaterialProperty_4: typeof Handle_StepRepr_MaterialProperty_4;
  Handle_StepRepr_CentreOfSymmetry: typeof Handle_StepRepr_CentreOfSymmetry;
  Handle_StepRepr_CentreOfSymmetry_1: typeof Handle_StepRepr_CentreOfSymmetry_1;
  Handle_StepRepr_CentreOfSymmetry_2: typeof Handle_StepRepr_CentreOfSymmetry_2;
  Handle_StepRepr_CentreOfSymmetry_3: typeof Handle_StepRepr_CentreOfSymmetry_3;
  Handle_StepRepr_CentreOfSymmetry_4: typeof Handle_StepRepr_CentreOfSymmetry_4;
  StepRepr_CentreOfSymmetry: typeof StepRepr_CentreOfSymmetry;
  StepRepr_ShapeDefinition: typeof StepRepr_ShapeDefinition;
  StepRepr_ExternallyDefinedRepresentation: typeof StepRepr_ExternallyDefinedRepresentation;
  Handle_StepRepr_ExternallyDefinedRepresentation: typeof Handle_StepRepr_ExternallyDefinedRepresentation;
  Handle_StepRepr_ExternallyDefinedRepresentation_1: typeof Handle_StepRepr_ExternallyDefinedRepresentation_1;
  Handle_StepRepr_ExternallyDefinedRepresentation_2: typeof Handle_StepRepr_ExternallyDefinedRepresentation_2;
  Handle_StepRepr_ExternallyDefinedRepresentation_3: typeof Handle_StepRepr_ExternallyDefinedRepresentation_3;
  Handle_StepRepr_ExternallyDefinedRepresentation_4: typeof Handle_StepRepr_ExternallyDefinedRepresentation_4;
  StepRepr_DescriptiveRepresentationItem: typeof StepRepr_DescriptiveRepresentationItem;
  Handle_StepRepr_DescriptiveRepresentationItem: typeof Handle_StepRepr_DescriptiveRepresentationItem;
  Handle_StepRepr_DescriptiveRepresentationItem_1: typeof Handle_StepRepr_DescriptiveRepresentationItem_1;
  Handle_StepRepr_DescriptiveRepresentationItem_2: typeof Handle_StepRepr_DescriptiveRepresentationItem_2;
  Handle_StepRepr_DescriptiveRepresentationItem_3: typeof Handle_StepRepr_DescriptiveRepresentationItem_3;
  Handle_StepRepr_DescriptiveRepresentationItem_4: typeof Handle_StepRepr_DescriptiveRepresentationItem_4;
  Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation: typeof Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation;
  Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_1: typeof Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_1;
  Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_2: typeof Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_2;
  Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_3: typeof Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_3;
  Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_4: typeof Handle_StepRepr_StructuralResponsePropertyDefinitionRepresentation_4;
  StepRepr_StructuralResponsePropertyDefinitionRepresentation: typeof StepRepr_StructuralResponsePropertyDefinitionRepresentation;
  StepRepr_ProductConcept: typeof StepRepr_ProductConcept;
  Handle_StepRepr_ProductConcept: typeof Handle_StepRepr_ProductConcept;
  Handle_StepRepr_ProductConcept_1: typeof Handle_StepRepr_ProductConcept_1;
  Handle_StepRepr_ProductConcept_2: typeof Handle_StepRepr_ProductConcept_2;
  Handle_StepRepr_ProductConcept_3: typeof Handle_StepRepr_ProductConcept_3;
  Handle_StepRepr_ProductConcept_4: typeof Handle_StepRepr_ProductConcept_4;
  StepRepr_RepresentedDefinition: typeof StepRepr_RepresentedDefinition;
  StepRepr_GlobalUncertaintyAssignedContext: typeof StepRepr_GlobalUncertaintyAssignedContext;
  Handle_StepRepr_GlobalUncertaintyAssignedContext: typeof Handle_StepRepr_GlobalUncertaintyAssignedContext;
  Handle_StepRepr_GlobalUncertaintyAssignedContext_1: typeof Handle_StepRepr_GlobalUncertaintyAssignedContext_1;
  Handle_StepRepr_GlobalUncertaintyAssignedContext_2: typeof Handle_StepRepr_GlobalUncertaintyAssignedContext_2;
  Handle_StepRepr_GlobalUncertaintyAssignedContext_3: typeof Handle_StepRepr_GlobalUncertaintyAssignedContext_3;
  Handle_StepRepr_GlobalUncertaintyAssignedContext_4: typeof Handle_StepRepr_GlobalUncertaintyAssignedContext_4;
  Handle_StepRepr_CompShAspAndDatumFeatAndShAsp: typeof Handle_StepRepr_CompShAspAndDatumFeatAndShAsp;
  Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_1: typeof Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_1;
  Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_2: typeof Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_2;
  Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_3: typeof Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_3;
  Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_4: typeof Handle_StepRepr_CompShAspAndDatumFeatAndShAsp_4;
  StepRepr_CompShAspAndDatumFeatAndShAsp: typeof StepRepr_CompShAspAndDatumFeatAndShAsp;
  StepRepr_ConstructiveGeometryRepresentationRelationship: typeof StepRepr_ConstructiveGeometryRepresentationRelationship;
  Handle_StepRepr_ConstructiveGeometryRepresentationRelationship: typeof Handle_StepRepr_ConstructiveGeometryRepresentationRelationship;
  Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_1: typeof Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_1;
  Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_2: typeof Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_2;
  Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_3: typeof Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_3;
  Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_4: typeof Handle_StepRepr_ConstructiveGeometryRepresentationRelationship_4;
  Handle_StepRepr_ProductDefinitionShape: typeof Handle_StepRepr_ProductDefinitionShape;
  Handle_StepRepr_ProductDefinitionShape_1: typeof Handle_StepRepr_ProductDefinitionShape_1;
  Handle_StepRepr_ProductDefinitionShape_2: typeof Handle_StepRepr_ProductDefinitionShape_2;
  Handle_StepRepr_ProductDefinitionShape_3: typeof Handle_StepRepr_ProductDefinitionShape_3;
  Handle_StepRepr_ProductDefinitionShape_4: typeof Handle_StepRepr_ProductDefinitionShape_4;
  StepRepr_ProductDefinitionShape: typeof StepRepr_ProductDefinitionShape;
  Handle_StepRepr_ValueRepresentationItem: typeof Handle_StepRepr_ValueRepresentationItem;
  Handle_StepRepr_ValueRepresentationItem_1: typeof Handle_StepRepr_ValueRepresentationItem_1;
  Handle_StepRepr_ValueRepresentationItem_2: typeof Handle_StepRepr_ValueRepresentationItem_2;
  Handle_StepRepr_ValueRepresentationItem_3: typeof Handle_StepRepr_ValueRepresentationItem_3;
  Handle_StepRepr_ValueRepresentationItem_4: typeof Handle_StepRepr_ValueRepresentationItem_4;
  StepRepr_ValueRepresentationItem: typeof StepRepr_ValueRepresentationItem;
  StepRepr_Apex: typeof StepRepr_Apex;
  Handle_StepRepr_Apex: typeof Handle_StepRepr_Apex;
  Handle_StepRepr_Apex_1: typeof Handle_StepRepr_Apex_1;
  Handle_StepRepr_Apex_2: typeof Handle_StepRepr_Apex_2;
  Handle_StepRepr_Apex_3: typeof Handle_StepRepr_Apex_3;
  Handle_StepRepr_Apex_4: typeof Handle_StepRepr_Apex_4;
  Handle_StepRepr_FunctionallyDefinedTransformation: typeof Handle_StepRepr_FunctionallyDefinedTransformation;
  Handle_StepRepr_FunctionallyDefinedTransformation_1: typeof Handle_StepRepr_FunctionallyDefinedTransformation_1;
  Handle_StepRepr_FunctionallyDefinedTransformation_2: typeof Handle_StepRepr_FunctionallyDefinedTransformation_2;
  Handle_StepRepr_FunctionallyDefinedTransformation_3: typeof Handle_StepRepr_FunctionallyDefinedTransformation_3;
  Handle_StepRepr_FunctionallyDefinedTransformation_4: typeof Handle_StepRepr_FunctionallyDefinedTransformation_4;
  StepRepr_FunctionallyDefinedTransformation: typeof StepRepr_FunctionallyDefinedTransformation;
  Handle_StepRepr_RepresentationMap: typeof Handle_StepRepr_RepresentationMap;
  Handle_StepRepr_RepresentationMap_1: typeof Handle_StepRepr_RepresentationMap_1;
  Handle_StepRepr_RepresentationMap_2: typeof Handle_StepRepr_RepresentationMap_2;
  Handle_StepRepr_RepresentationMap_3: typeof Handle_StepRepr_RepresentationMap_3;
  Handle_StepRepr_RepresentationMap_4: typeof Handle_StepRepr_RepresentationMap_4;
  StepRepr_RepresentationMap: typeof StepRepr_RepresentationMap;
  Handle_StepRepr_RepresentationItem: typeof Handle_StepRepr_RepresentationItem;
  Handle_StepRepr_RepresentationItem_1: typeof Handle_StepRepr_RepresentationItem_1;
  Handle_StepRepr_RepresentationItem_2: typeof Handle_StepRepr_RepresentationItem_2;
  Handle_StepRepr_RepresentationItem_3: typeof Handle_StepRepr_RepresentationItem_3;
  Handle_StepRepr_RepresentationItem_4: typeof Handle_StepRepr_RepresentationItem_4;
  StepRepr_RepresentationItem: typeof StepRepr_RepresentationItem;
  StepRepr_AllAroundShapeAspect: typeof StepRepr_AllAroundShapeAspect;
  Handle_StepRepr_AllAroundShapeAspect: typeof Handle_StepRepr_AllAroundShapeAspect;
  Handle_StepRepr_AllAroundShapeAspect_1: typeof Handle_StepRepr_AllAroundShapeAspect_1;
  Handle_StepRepr_AllAroundShapeAspect_2: typeof Handle_StepRepr_AllAroundShapeAspect_2;
  Handle_StepRepr_AllAroundShapeAspect_3: typeof Handle_StepRepr_AllAroundShapeAspect_3;
  Handle_StepRepr_AllAroundShapeAspect_4: typeof Handle_StepRepr_AllAroundShapeAspect_4;
  Handle_StepRepr_ConstructiveGeometryRepresentation: typeof Handle_StepRepr_ConstructiveGeometryRepresentation;
  Handle_StepRepr_ConstructiveGeometryRepresentation_1: typeof Handle_StepRepr_ConstructiveGeometryRepresentation_1;
  Handle_StepRepr_ConstructiveGeometryRepresentation_2: typeof Handle_StepRepr_ConstructiveGeometryRepresentation_2;
  Handle_StepRepr_ConstructiveGeometryRepresentation_3: typeof Handle_StepRepr_ConstructiveGeometryRepresentation_3;
  Handle_StepRepr_ConstructiveGeometryRepresentation_4: typeof Handle_StepRepr_ConstructiveGeometryRepresentation_4;
  StepRepr_ConstructiveGeometryRepresentation: typeof StepRepr_ConstructiveGeometryRepresentation;
  Handle_StepRepr_Representation: typeof Handle_StepRepr_Representation;
  Handle_StepRepr_Representation_1: typeof Handle_StepRepr_Representation_1;
  Handle_StepRepr_Representation_2: typeof Handle_StepRepr_Representation_2;
  Handle_StepRepr_Representation_3: typeof Handle_StepRepr_Representation_3;
  Handle_StepRepr_Representation_4: typeof Handle_StepRepr_Representation_4;
  StepRepr_Representation: typeof StepRepr_Representation;
  StepRepr_CompositeGroupShapeAspect: typeof StepRepr_CompositeGroupShapeAspect;
  Handle_StepRepr_CompositeGroupShapeAspect: typeof Handle_StepRepr_CompositeGroupShapeAspect;
  Handle_StepRepr_CompositeGroupShapeAspect_1: typeof Handle_StepRepr_CompositeGroupShapeAspect_1;
  Handle_StepRepr_CompositeGroupShapeAspect_2: typeof Handle_StepRepr_CompositeGroupShapeAspect_2;
  Handle_StepRepr_CompositeGroupShapeAspect_3: typeof Handle_StepRepr_CompositeGroupShapeAspect_3;
  Handle_StepRepr_CompositeGroupShapeAspect_4: typeof Handle_StepRepr_CompositeGroupShapeAspect_4;
  StepRepr_ShapeRepresentationRelationshipWithTransformation: typeof StepRepr_ShapeRepresentationRelationshipWithTransformation;
  Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation: typeof Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation;
  Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_1: typeof Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_1;
  Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_2: typeof Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_2;
  Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_3: typeof Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_3;
  Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_4: typeof Handle_StepRepr_ShapeRepresentationRelationshipWithTransformation_4;
  Handle_StepRepr_ShapeAspectTransition: typeof Handle_StepRepr_ShapeAspectTransition;
  Handle_StepRepr_ShapeAspectTransition_1: typeof Handle_StepRepr_ShapeAspectTransition_1;
  Handle_StepRepr_ShapeAspectTransition_2: typeof Handle_StepRepr_ShapeAspectTransition_2;
  Handle_StepRepr_ShapeAspectTransition_3: typeof Handle_StepRepr_ShapeAspectTransition_3;
  Handle_StepRepr_ShapeAspectTransition_4: typeof Handle_StepRepr_ShapeAspectTransition_4;
  StepRepr_ShapeAspectTransition: typeof StepRepr_ShapeAspectTransition;
  StepRepr_IntegerRepresentationItem: typeof StepRepr_IntegerRepresentationItem;
  Handle_StepRepr_IntegerRepresentationItem: typeof Handle_StepRepr_IntegerRepresentationItem;
  Handle_StepRepr_IntegerRepresentationItem_1: typeof Handle_StepRepr_IntegerRepresentationItem_1;
  Handle_StepRepr_IntegerRepresentationItem_2: typeof Handle_StepRepr_IntegerRepresentationItem_2;
  Handle_StepRepr_IntegerRepresentationItem_3: typeof Handle_StepRepr_IntegerRepresentationItem_3;
  Handle_StepRepr_IntegerRepresentationItem_4: typeof Handle_StepRepr_IntegerRepresentationItem_4;
  StepRepr_ConfigurationDesignItem: typeof StepRepr_ConfigurationDesignItem;
  StepRepr_DerivedShapeAspect: typeof StepRepr_DerivedShapeAspect;
  Handle_StepRepr_DerivedShapeAspect: typeof Handle_StepRepr_DerivedShapeAspect;
  Handle_StepRepr_DerivedShapeAspect_1: typeof Handle_StepRepr_DerivedShapeAspect_1;
  Handle_StepRepr_DerivedShapeAspect_2: typeof Handle_StepRepr_DerivedShapeAspect_2;
  Handle_StepRepr_DerivedShapeAspect_3: typeof Handle_StepRepr_DerivedShapeAspect_3;
  Handle_StepRepr_DerivedShapeAspect_4: typeof Handle_StepRepr_DerivedShapeAspect_4;
  Handle_StepRepr_CompoundRepresentationItem: typeof Handle_StepRepr_CompoundRepresentationItem;
  Handle_StepRepr_CompoundRepresentationItem_1: typeof Handle_StepRepr_CompoundRepresentationItem_1;
  Handle_StepRepr_CompoundRepresentationItem_2: typeof Handle_StepRepr_CompoundRepresentationItem_2;
  Handle_StepRepr_CompoundRepresentationItem_3: typeof Handle_StepRepr_CompoundRepresentationItem_3;
  Handle_StepRepr_CompoundRepresentationItem_4: typeof Handle_StepRepr_CompoundRepresentationItem_4;
  StepRepr_CompoundRepresentationItem: typeof StepRepr_CompoundRepresentationItem;
  StepRepr_ItemDefinedTransformation: typeof StepRepr_ItemDefinedTransformation;
  Handle_StepRepr_ItemDefinedTransformation: typeof Handle_StepRepr_ItemDefinedTransformation;
  Handle_StepRepr_ItemDefinedTransformation_1: typeof Handle_StepRepr_ItemDefinedTransformation_1;
  Handle_StepRepr_ItemDefinedTransformation_2: typeof Handle_StepRepr_ItemDefinedTransformation_2;
  Handle_StepRepr_ItemDefinedTransformation_3: typeof Handle_StepRepr_ItemDefinedTransformation_3;
  Handle_StepRepr_ItemDefinedTransformation_4: typeof Handle_StepRepr_ItemDefinedTransformation_4;
  StepRepr_ShapeAspectDerivingRelationship: typeof StepRepr_ShapeAspectDerivingRelationship;
  Handle_StepRepr_ShapeAspectDerivingRelationship: typeof Handle_StepRepr_ShapeAspectDerivingRelationship;
  Handle_StepRepr_ShapeAspectDerivingRelationship_1: typeof Handle_StepRepr_ShapeAspectDerivingRelationship_1;
  Handle_StepRepr_ShapeAspectDerivingRelationship_2: typeof Handle_StepRepr_ShapeAspectDerivingRelationship_2;
  Handle_StepRepr_ShapeAspectDerivingRelationship_3: typeof Handle_StepRepr_ShapeAspectDerivingRelationship_3;
  Handle_StepRepr_ShapeAspectDerivingRelationship_4: typeof Handle_StepRepr_ShapeAspectDerivingRelationship_4;
  StepRepr_ShapeRepresentationRelationship: typeof StepRepr_ShapeRepresentationRelationship;
  Handle_StepRepr_ShapeRepresentationRelationship: typeof Handle_StepRepr_ShapeRepresentationRelationship;
  Handle_StepRepr_ShapeRepresentationRelationship_1: typeof Handle_StepRepr_ShapeRepresentationRelationship_1;
  Handle_StepRepr_ShapeRepresentationRelationship_2: typeof Handle_StepRepr_ShapeRepresentationRelationship_2;
  Handle_StepRepr_ShapeRepresentationRelationship_3: typeof Handle_StepRepr_ShapeRepresentationRelationship_3;
  Handle_StepRepr_ShapeRepresentationRelationship_4: typeof Handle_StepRepr_ShapeRepresentationRelationship_4;
  StepRepr_ShapeAspect: typeof StepRepr_ShapeAspect;
  Handle_StepRepr_ShapeAspect: typeof Handle_StepRepr_ShapeAspect;
  Handle_StepRepr_ShapeAspect_1: typeof Handle_StepRepr_ShapeAspect_1;
  Handle_StepRepr_ShapeAspect_2: typeof Handle_StepRepr_ShapeAspect_2;
  Handle_StepRepr_ShapeAspect_3: typeof Handle_StepRepr_ShapeAspect_3;
  Handle_StepRepr_ShapeAspect_4: typeof Handle_StepRepr_ShapeAspect_4;
  Handle_StepRepr_ContinuosShapeAspect: typeof Handle_StepRepr_ContinuosShapeAspect;
  Handle_StepRepr_ContinuosShapeAspect_1: typeof Handle_StepRepr_ContinuosShapeAspect_1;
  Handle_StepRepr_ContinuosShapeAspect_2: typeof Handle_StepRepr_ContinuosShapeAspect_2;
  Handle_StepRepr_ContinuosShapeAspect_3: typeof Handle_StepRepr_ContinuosShapeAspect_3;
  Handle_StepRepr_ContinuosShapeAspect_4: typeof Handle_StepRepr_ContinuosShapeAspect_4;
  StepRepr_ContinuosShapeAspect: typeof StepRepr_ContinuosShapeAspect;
  Handle_StepRepr_HArray1OfRepresentationItem: typeof Handle_StepRepr_HArray1OfRepresentationItem;
  Handle_StepRepr_HArray1OfRepresentationItem_1: typeof Handle_StepRepr_HArray1OfRepresentationItem_1;
  Handle_StepRepr_HArray1OfRepresentationItem_2: typeof Handle_StepRepr_HArray1OfRepresentationItem_2;
  Handle_StepRepr_HArray1OfRepresentationItem_3: typeof Handle_StepRepr_HArray1OfRepresentationItem_3;
  Handle_StepRepr_HArray1OfRepresentationItem_4: typeof Handle_StepRepr_HArray1OfRepresentationItem_4;
  StepRepr_RepresentationContext: typeof StepRepr_RepresentationContext;
  Handle_StepRepr_RepresentationContext: typeof Handle_StepRepr_RepresentationContext;
  Handle_StepRepr_RepresentationContext_1: typeof Handle_StepRepr_RepresentationContext_1;
  Handle_StepRepr_RepresentationContext_2: typeof Handle_StepRepr_RepresentationContext_2;
  Handle_StepRepr_RepresentationContext_3: typeof Handle_StepRepr_RepresentationContext_3;
  Handle_StepRepr_RepresentationContext_4: typeof Handle_StepRepr_RepresentationContext_4;
  Handle_StepRepr_HArray1OfShapeAspect: typeof Handle_StepRepr_HArray1OfShapeAspect;
  Handle_StepRepr_HArray1OfShapeAspect_1: typeof Handle_StepRepr_HArray1OfShapeAspect_1;
  Handle_StepRepr_HArray1OfShapeAspect_2: typeof Handle_StepRepr_HArray1OfShapeAspect_2;
  Handle_StepRepr_HArray1OfShapeAspect_3: typeof Handle_StepRepr_HArray1OfShapeAspect_3;
  Handle_StepRepr_HArray1OfShapeAspect_4: typeof Handle_StepRepr_HArray1OfShapeAspect_4;
  StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI: typeof StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_1: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_1;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_2: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_2;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_3: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_3;
  Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_4: typeof Handle_StepRepr_ReprItemAndPlaneAngleMeasureWithUnitAndQRI_4;
  StepRepr_ShapeAspectRelationship: typeof StepRepr_ShapeAspectRelationship;
  Handle_StepRepr_ShapeAspectRelationship: typeof Handle_StepRepr_ShapeAspectRelationship;
  Handle_StepRepr_ShapeAspectRelationship_1: typeof Handle_StepRepr_ShapeAspectRelationship_1;
  Handle_StepRepr_ShapeAspectRelationship_2: typeof Handle_StepRepr_ShapeAspectRelationship_2;
  Handle_StepRepr_ShapeAspectRelationship_3: typeof Handle_StepRepr_ShapeAspectRelationship_3;
  Handle_StepRepr_ShapeAspectRelationship_4: typeof Handle_StepRepr_ShapeAspectRelationship_4;
  StepRepr_ConfigurationItem: typeof StepRepr_ConfigurationItem;
  Handle_StepRepr_ConfigurationItem: typeof Handle_StepRepr_ConfigurationItem;
  Handle_StepRepr_ConfigurationItem_1: typeof Handle_StepRepr_ConfigurationItem_1;
  Handle_StepRepr_ConfigurationItem_2: typeof Handle_StepRepr_ConfigurationItem_2;
  Handle_StepRepr_ConfigurationItem_3: typeof Handle_StepRepr_ConfigurationItem_3;
  Handle_StepRepr_ConfigurationItem_4: typeof Handle_StepRepr_ConfigurationItem_4;
  StepRepr_Transformation: typeof StepRepr_Transformation;
  StepRepr_PropertyDefinition: typeof StepRepr_PropertyDefinition;
  Handle_StepRepr_PropertyDefinition: typeof Handle_StepRepr_PropertyDefinition;
  Handle_StepRepr_PropertyDefinition_1: typeof Handle_StepRepr_PropertyDefinition_1;
  Handle_StepRepr_PropertyDefinition_2: typeof Handle_StepRepr_PropertyDefinition_2;
  Handle_StepRepr_PropertyDefinition_3: typeof Handle_StepRepr_PropertyDefinition_3;
  Handle_StepRepr_PropertyDefinition_4: typeof Handle_StepRepr_PropertyDefinition_4;
  Handle_StepRepr_MakeFromUsageOption: typeof Handle_StepRepr_MakeFromUsageOption;
  Handle_StepRepr_MakeFromUsageOption_1: typeof Handle_StepRepr_MakeFromUsageOption_1;
  Handle_StepRepr_MakeFromUsageOption_2: typeof Handle_StepRepr_MakeFromUsageOption_2;
  Handle_StepRepr_MakeFromUsageOption_3: typeof Handle_StepRepr_MakeFromUsageOption_3;
  Handle_StepRepr_MakeFromUsageOption_4: typeof Handle_StepRepr_MakeFromUsageOption_4;
  StepRepr_MakeFromUsageOption: typeof StepRepr_MakeFromUsageOption;
  Handle_StepRepr_SuppliedPartRelationship: typeof Handle_StepRepr_SuppliedPartRelationship;
  Handle_StepRepr_SuppliedPartRelationship_1: typeof Handle_StepRepr_SuppliedPartRelationship_1;
  Handle_StepRepr_SuppliedPartRelationship_2: typeof Handle_StepRepr_SuppliedPartRelationship_2;
  Handle_StepRepr_SuppliedPartRelationship_3: typeof Handle_StepRepr_SuppliedPartRelationship_3;
  Handle_StepRepr_SuppliedPartRelationship_4: typeof Handle_StepRepr_SuppliedPartRelationship_4;
  StepRepr_SuppliedPartRelationship: typeof StepRepr_SuppliedPartRelationship;
  StepRepr_MeasureRepresentationItem: typeof StepRepr_MeasureRepresentationItem;
  Handle_StepRepr_MeasureRepresentationItem: typeof Handle_StepRepr_MeasureRepresentationItem;
  Handle_StepRepr_MeasureRepresentationItem_1: typeof Handle_StepRepr_MeasureRepresentationItem_1;
  Handle_StepRepr_MeasureRepresentationItem_2: typeof Handle_StepRepr_MeasureRepresentationItem_2;
  Handle_StepRepr_MeasureRepresentationItem_3: typeof Handle_StepRepr_MeasureRepresentationItem_3;
  Handle_StepRepr_MeasureRepresentationItem_4: typeof Handle_StepRepr_MeasureRepresentationItem_4;
  StlAPI: typeof StlAPI;
  StlAPI_Reader: typeof StlAPI_Reader;
  StlAPI_Writer: typeof StlAPI_Writer;
  ShapeExtend_Explorer: typeof ShapeExtend_Explorer;
  Handle_ShapeExtend_BasicMsgRegistrator: typeof Handle_ShapeExtend_BasicMsgRegistrator;
  Handle_ShapeExtend_BasicMsgRegistrator_1: typeof Handle_ShapeExtend_BasicMsgRegistrator_1;
  Handle_ShapeExtend_BasicMsgRegistrator_2: typeof Handle_ShapeExtend_BasicMsgRegistrator_2;
  Handle_ShapeExtend_BasicMsgRegistrator_3: typeof Handle_ShapeExtend_BasicMsgRegistrator_3;
  Handle_ShapeExtend_BasicMsgRegistrator_4: typeof Handle_ShapeExtend_BasicMsgRegistrator_4;
  ShapeExtend_BasicMsgRegistrator: typeof ShapeExtend_BasicMsgRegistrator;
  Handle_ShapeExtend_CompositeSurface: typeof Handle_ShapeExtend_CompositeSurface;
  Handle_ShapeExtend_CompositeSurface_1: typeof Handle_ShapeExtend_CompositeSurface_1;
  Handle_ShapeExtend_CompositeSurface_2: typeof Handle_ShapeExtend_CompositeSurface_2;
  Handle_ShapeExtend_CompositeSurface_3: typeof Handle_ShapeExtend_CompositeSurface_3;
  Handle_ShapeExtend_CompositeSurface_4: typeof Handle_ShapeExtend_CompositeSurface_4;
  ShapeExtend_CompositeSurface: typeof ShapeExtend_CompositeSurface;
  ShapeExtend_CompositeSurface_1: typeof ShapeExtend_CompositeSurface_1;
  ShapeExtend_CompositeSurface_2: typeof ShapeExtend_CompositeSurface_2;
  ShapeExtend_CompositeSurface_3: typeof ShapeExtend_CompositeSurface_3;
  ShapeExtend_WireData: typeof ShapeExtend_WireData;
  ShapeExtend_WireData_1: typeof ShapeExtend_WireData_1;
  ShapeExtend_WireData_2: typeof ShapeExtend_WireData_2;
  Handle_ShapeExtend_WireData: typeof Handle_ShapeExtend_WireData;
  Handle_ShapeExtend_WireData_1: typeof Handle_ShapeExtend_WireData_1;
  Handle_ShapeExtend_WireData_2: typeof Handle_ShapeExtend_WireData_2;
  Handle_ShapeExtend_WireData_3: typeof Handle_ShapeExtend_WireData_3;
  Handle_ShapeExtend_WireData_4: typeof Handle_ShapeExtend_WireData_4;
  ShapeExtend_Parametrisation: ShapeExtend_Parametrisation;
  Handle_ShapeExtend_ComplexCurve: typeof Handle_ShapeExtend_ComplexCurve;
  Handle_ShapeExtend_ComplexCurve_1: typeof Handle_ShapeExtend_ComplexCurve_1;
  Handle_ShapeExtend_ComplexCurve_2: typeof Handle_ShapeExtend_ComplexCurve_2;
  Handle_ShapeExtend_ComplexCurve_3: typeof Handle_ShapeExtend_ComplexCurve_3;
  Handle_ShapeExtend_ComplexCurve_4: typeof Handle_ShapeExtend_ComplexCurve_4;
  ShapeExtend_ComplexCurve: typeof ShapeExtend_ComplexCurve;
  ShapeExtend_Status: ShapeExtend_Status;
  ShapeExtend: typeof ShapeExtend;
  Handle_ShapeExtend_MsgRegistrator: typeof Handle_ShapeExtend_MsgRegistrator;
  Handle_ShapeExtend_MsgRegistrator_1: typeof Handle_ShapeExtend_MsgRegistrator_1;
  Handle_ShapeExtend_MsgRegistrator_2: typeof Handle_ShapeExtend_MsgRegistrator_2;
  Handle_ShapeExtend_MsgRegistrator_3: typeof Handle_ShapeExtend_MsgRegistrator_3;
  Handle_ShapeExtend_MsgRegistrator_4: typeof Handle_ShapeExtend_MsgRegistrator_4;
  ShapeExtend_MsgRegistrator: typeof ShapeExtend_MsgRegistrator;
  ShapeExtend_DataMapOfShapeListOfMsg: typeof ShapeExtend_DataMapOfShapeListOfMsg;
  ShapeExtend_DataMapOfShapeListOfMsg_1: typeof ShapeExtend_DataMapOfShapeListOfMsg_1;
  ShapeExtend_DataMapOfShapeListOfMsg_2: typeof ShapeExtend_DataMapOfShapeListOfMsg_2;
  ShapeExtend_DataMapOfShapeListOfMsg_3: typeof ShapeExtend_DataMapOfShapeListOfMsg_3;
  BOPDS_MapOfPave: typeof BOPDS_MapOfPave;
  BOPDS_MapOfPave_1: typeof BOPDS_MapOfPave_1;
  BOPDS_MapOfPave_2: typeof BOPDS_MapOfPave_2;
  BOPDS_MapOfPave_3: typeof BOPDS_MapOfPave_3;
  BOPDS_PaveMapHasher: typeof BOPDS_PaveMapHasher;
  BOPDS_VectorOfInterfEF: typeof BOPDS_VectorOfInterfEF;
  BOPDS_VectorOfInterfEF_1: typeof BOPDS_VectorOfInterfEF_1;
  BOPDS_VectorOfInterfEF_2: typeof BOPDS_VectorOfInterfEF_2;
  BOPDS_VectorOfInterfFF: typeof BOPDS_VectorOfInterfFF;
  BOPDS_VectorOfInterfFF_1: typeof BOPDS_VectorOfInterfFF_1;
  BOPDS_VectorOfInterfFF_2: typeof BOPDS_VectorOfInterfFF_2;
  BOPDS_VectorOfInterfFZ: typeof BOPDS_VectorOfInterfFZ;
  BOPDS_VectorOfInterfFZ_1: typeof BOPDS_VectorOfInterfFZ_1;
  BOPDS_VectorOfInterfFZ_2: typeof BOPDS_VectorOfInterfFZ_2;
  BOPDS_Tools: typeof BOPDS_Tools;
  BOPDS_VectorOfInterfVF: typeof BOPDS_VectorOfInterfVF;
  BOPDS_VectorOfInterfVF_1: typeof BOPDS_VectorOfInterfVF_1;
  BOPDS_VectorOfInterfVF_2: typeof BOPDS_VectorOfInterfVF_2;
  BOPDS_VectorOfPair: typeof BOPDS_VectorOfPair;
  BOPDS_VectorOfPair_1: typeof BOPDS_VectorOfPair_1;
  BOPDS_VectorOfPair_2: typeof BOPDS_VectorOfPair_2;
  BOPDS_VectorOfListOfPaveBlock: typeof BOPDS_VectorOfListOfPaveBlock;
  BOPDS_VectorOfListOfPaveBlock_1: typeof BOPDS_VectorOfListOfPaveBlock_1;
  BOPDS_VectorOfListOfPaveBlock_2: typeof BOPDS_VectorOfListOfPaveBlock_2;
  BOPDS_SubIterator: typeof BOPDS_SubIterator;
  BOPDS_SubIterator_1: typeof BOPDS_SubIterator_1;
  BOPDS_SubIterator_2: typeof BOPDS_SubIterator_2;
  BOPDS_PairMapHasher: typeof BOPDS_PairMapHasher;
  BOPDS_VectorOfPoint: typeof BOPDS_VectorOfPoint;
  BOPDS_VectorOfPoint_1: typeof BOPDS_VectorOfPoint_1;
  BOPDS_VectorOfPoint_2: typeof BOPDS_VectorOfPoint_2;
  BOPDS_VectorOfInterfZZ: typeof BOPDS_VectorOfInterfZZ;
  BOPDS_VectorOfInterfZZ_1: typeof BOPDS_VectorOfInterfZZ_1;
  BOPDS_VectorOfInterfZZ_2: typeof BOPDS_VectorOfInterfZZ_2;
  BOPDS_PaveBlock: typeof BOPDS_PaveBlock;
  BOPDS_PaveBlock_1: typeof BOPDS_PaveBlock_1;
  BOPDS_PaveBlock_2: typeof BOPDS_PaveBlock_2;
  Handle_BOPDS_PaveBlock: typeof Handle_BOPDS_PaveBlock;
  Handle_BOPDS_PaveBlock_1: typeof Handle_BOPDS_PaveBlock_1;
  Handle_BOPDS_PaveBlock_2: typeof Handle_BOPDS_PaveBlock_2;
  Handle_BOPDS_PaveBlock_3: typeof Handle_BOPDS_PaveBlock_3;
  Handle_BOPDS_PaveBlock_4: typeof Handle_BOPDS_PaveBlock_4;
  BOPDS_VectorOfInterfVZ: typeof BOPDS_VectorOfInterfVZ;
  BOPDS_VectorOfInterfVZ_1: typeof BOPDS_VectorOfInterfVZ_1;
  BOPDS_VectorOfInterfVZ_2: typeof BOPDS_VectorOfInterfVZ_2;
  BOPDS_ListOfPave: typeof BOPDS_ListOfPave;
  BOPDS_ListOfPave_1: typeof BOPDS_ListOfPave_1;
  BOPDS_ListOfPave_2: typeof BOPDS_ListOfPave_2;
  BOPDS_ListOfPave_3: typeof BOPDS_ListOfPave_3;
  BOPDS_DS: typeof BOPDS_DS;
  BOPDS_DS_1: typeof BOPDS_DS_1;
  BOPDS_DS_2: typeof BOPDS_DS_2;
  BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks: typeof BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks;
  BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_1: typeof BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_1;
  BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_2: typeof BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_2;
  BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_3: typeof BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks_3;
  BOPDS_Pair: typeof BOPDS_Pair;
  BOPDS_Pair_1: typeof BOPDS_Pair_1;
  BOPDS_Pair_2: typeof BOPDS_Pair_2;
  BOPDS_VectorOfVectorOfPair: typeof BOPDS_VectorOfVectorOfPair;
  BOPDS_VectorOfVectorOfPair_1: typeof BOPDS_VectorOfVectorOfPair_1;
  BOPDS_VectorOfVectorOfPair_2: typeof BOPDS_VectorOfVectorOfPair_2;
  BOPDS_CoupleOfPaveBlocks: typeof BOPDS_CoupleOfPaveBlocks;
  BOPDS_CoupleOfPaveBlocks_1: typeof BOPDS_CoupleOfPaveBlocks_1;
  BOPDS_CoupleOfPaveBlocks_2: typeof BOPDS_CoupleOfPaveBlocks_2;
  BOPDS_VectorOfInterfVE: typeof BOPDS_VectorOfInterfVE;
  BOPDS_VectorOfInterfVE_1: typeof BOPDS_VectorOfInterfVE_1;
  BOPDS_VectorOfInterfVE_2: typeof BOPDS_VectorOfInterfVE_2;
  BOPDS_Curve: typeof BOPDS_Curve;
  BOPDS_Curve_1: typeof BOPDS_Curve_1;
  BOPDS_Curve_2: typeof BOPDS_Curve_2;
  BOPDS_VectorOfFaceInfo: typeof BOPDS_VectorOfFaceInfo;
  BOPDS_VectorOfFaceInfo_1: typeof BOPDS_VectorOfFaceInfo_1;
  BOPDS_VectorOfFaceInfo_2: typeof BOPDS_VectorOfFaceInfo_2;
  BOPDS_VectorOfInterfEE: typeof BOPDS_VectorOfInterfEE;
  BOPDS_VectorOfInterfEE_1: typeof BOPDS_VectorOfInterfEE_1;
  BOPDS_VectorOfInterfEE_2: typeof BOPDS_VectorOfInterfEE_2;
  BOPDS_Point: typeof BOPDS_Point;
  BOPDS_VectorOfCurve: typeof BOPDS_VectorOfCurve;
  BOPDS_VectorOfCurve_1: typeof BOPDS_VectorOfCurve_1;
  BOPDS_VectorOfCurve_2: typeof BOPDS_VectorOfCurve_2;
  BOPDS_VectorOfPave: typeof BOPDS_VectorOfPave;
  BOPDS_VectorOfPave_1: typeof BOPDS_VectorOfPave_1;
  BOPDS_VectorOfPave_2: typeof BOPDS_VectorOfPave_2;
  BOPDS_VectorOfPave_3: typeof BOPDS_VectorOfPave_3;
  BOPDS_VectorOfPave_4: typeof BOPDS_VectorOfPave_4;
  BOPDS_VectorOfPave_5: typeof BOPDS_VectorOfPave_5;
  BOPDS_FaceInfo: typeof BOPDS_FaceInfo;
  BOPDS_FaceInfo_1: typeof BOPDS_FaceInfo_1;
  BOPDS_FaceInfo_2: typeof BOPDS_FaceInfo_2;
  BOPDS_MapOfPair: typeof BOPDS_MapOfPair;
  BOPDS_MapOfPair_1: typeof BOPDS_MapOfPair_1;
  BOPDS_MapOfPair_2: typeof BOPDS_MapOfPair_2;
  BOPDS_MapOfPair_3: typeof BOPDS_MapOfPair_3;
  BOPDS_VectorOfInterfEZ: typeof BOPDS_VectorOfInterfEZ;
  BOPDS_VectorOfInterfEZ_1: typeof BOPDS_VectorOfInterfEZ_1;
  BOPDS_VectorOfInterfEZ_2: typeof BOPDS_VectorOfInterfEZ_2;
  BOPDS_ShapeInfo: typeof BOPDS_ShapeInfo;
  BOPDS_ShapeInfo_1: typeof BOPDS_ShapeInfo_1;
  BOPDS_ShapeInfo_2: typeof BOPDS_ShapeInfo_2;
  BOPDS_Pave: typeof BOPDS_Pave;
  BOPDS_CommonBlock: typeof BOPDS_CommonBlock;
  BOPDS_CommonBlock_1: typeof BOPDS_CommonBlock_1;
  BOPDS_CommonBlock_2: typeof BOPDS_CommonBlock_2;
  Handle_BOPDS_CommonBlock: typeof Handle_BOPDS_CommonBlock;
  Handle_BOPDS_CommonBlock_1: typeof Handle_BOPDS_CommonBlock_1;
  Handle_BOPDS_CommonBlock_2: typeof Handle_BOPDS_CommonBlock_2;
  Handle_BOPDS_CommonBlock_3: typeof Handle_BOPDS_CommonBlock_3;
  Handle_BOPDS_CommonBlock_4: typeof Handle_BOPDS_CommonBlock_4;
  BOPDS_InterfVV: typeof BOPDS_InterfVV;
  BOPDS_InterfVV_1: typeof BOPDS_InterfVV_1;
  BOPDS_InterfVV_2: typeof BOPDS_InterfVV_2;
  BOPDS_InterfFZ: typeof BOPDS_InterfFZ;
  BOPDS_InterfFZ_1: typeof BOPDS_InterfFZ_1;
  BOPDS_InterfFZ_2: typeof BOPDS_InterfFZ_2;
  BOPDS_InterfZZ: typeof BOPDS_InterfZZ;
  BOPDS_InterfZZ_1: typeof BOPDS_InterfZZ_1;
  BOPDS_InterfZZ_2: typeof BOPDS_InterfZZ_2;
  BOPDS_InterfFF: typeof BOPDS_InterfFF;
  BOPDS_Interf: typeof BOPDS_Interf;
  BOPDS_InterfVE: typeof BOPDS_InterfVE;
  BOPDS_InterfVE_1: typeof BOPDS_InterfVE_1;
  BOPDS_InterfVE_2: typeof BOPDS_InterfVE_2;
  BOPDS_InterfVF: typeof BOPDS_InterfVF;
  BOPDS_InterfVF_1: typeof BOPDS_InterfVF_1;
  BOPDS_InterfVF_2: typeof BOPDS_InterfVF_2;
  BOPDS_InterfEE: typeof BOPDS_InterfEE;
  BOPDS_InterfEE_1: typeof BOPDS_InterfEE_1;
  BOPDS_InterfEE_2: typeof BOPDS_InterfEE_2;
  BOPDS_InterfEF: typeof BOPDS_InterfEF;
  BOPDS_InterfEF_1: typeof BOPDS_InterfEF_1;
  BOPDS_InterfEF_2: typeof BOPDS_InterfEF_2;
  BOPDS_InterfEZ: typeof BOPDS_InterfEZ;
  BOPDS_InterfEZ_1: typeof BOPDS_InterfEZ_1;
  BOPDS_InterfEZ_2: typeof BOPDS_InterfEZ_2;
  BOPDS_InterfVZ: typeof BOPDS_InterfVZ;
  BOPDS_InterfVZ_1: typeof BOPDS_InterfVZ_1;
  BOPDS_InterfVZ_2: typeof BOPDS_InterfVZ_2;
  BOPDS_VectorOfIndexRange: typeof BOPDS_VectorOfIndexRange;
  BOPDS_VectorOfIndexRange_1: typeof BOPDS_VectorOfIndexRange_1;
  BOPDS_VectorOfIndexRange_2: typeof BOPDS_VectorOfIndexRange_2;
  BOPDS_VectorOfInterfVV: typeof BOPDS_VectorOfInterfVV;
  BOPDS_VectorOfInterfVV_1: typeof BOPDS_VectorOfInterfVV_1;
  BOPDS_VectorOfInterfVV_2: typeof BOPDS_VectorOfInterfVV_2;
  BOPDS_VectorOfShapeInfo: typeof BOPDS_VectorOfShapeInfo;
  BOPDS_VectorOfShapeInfo_1: typeof BOPDS_VectorOfShapeInfo_1;
  BOPDS_VectorOfShapeInfo_2: typeof BOPDS_VectorOfShapeInfo_2;
  BOPDS_IndexRange: typeof BOPDS_IndexRange;
  BOPDS_DataMapOfIntegerListOfPaveBlock: typeof BOPDS_DataMapOfIntegerListOfPaveBlock;
  BOPDS_DataMapOfIntegerListOfPaveBlock_1: typeof BOPDS_DataMapOfIntegerListOfPaveBlock_1;
  BOPDS_DataMapOfIntegerListOfPaveBlock_2: typeof BOPDS_DataMapOfIntegerListOfPaveBlock_2;
  BOPDS_DataMapOfIntegerListOfPaveBlock_3: typeof BOPDS_DataMapOfIntegerListOfPaveBlock_3;
  BOPDS_DataMapOfShapeCoupleOfPaveBlocks: typeof BOPDS_DataMapOfShapeCoupleOfPaveBlocks;
  BOPDS_DataMapOfShapeCoupleOfPaveBlocks_1: typeof BOPDS_DataMapOfShapeCoupleOfPaveBlocks_1;
  BOPDS_DataMapOfShapeCoupleOfPaveBlocks_2: typeof BOPDS_DataMapOfShapeCoupleOfPaveBlocks_2;
  BOPDS_DataMapOfShapeCoupleOfPaveBlocks_3: typeof BOPDS_DataMapOfShapeCoupleOfPaveBlocks_3;
  Hermit: typeof Hermit;
  ShapeAlgo_AlgoContainer: typeof ShapeAlgo_AlgoContainer;
  Handle_ShapeAlgo_AlgoContainer: typeof Handle_ShapeAlgo_AlgoContainer;
  Handle_ShapeAlgo_AlgoContainer_1: typeof Handle_ShapeAlgo_AlgoContainer_1;
  Handle_ShapeAlgo_AlgoContainer_2: typeof Handle_ShapeAlgo_AlgoContainer_2;
  Handle_ShapeAlgo_AlgoContainer_3: typeof Handle_ShapeAlgo_AlgoContainer_3;
  Handle_ShapeAlgo_AlgoContainer_4: typeof Handle_ShapeAlgo_AlgoContainer_4;
  ShapeAlgo: typeof ShapeAlgo;
  Handle_ShapeAlgo_ToolContainer: typeof Handle_ShapeAlgo_ToolContainer;
  Handle_ShapeAlgo_ToolContainer_1: typeof Handle_ShapeAlgo_ToolContainer_1;
  Handle_ShapeAlgo_ToolContainer_2: typeof Handle_ShapeAlgo_ToolContainer_2;
  Handle_ShapeAlgo_ToolContainer_3: typeof Handle_ShapeAlgo_ToolContainer_3;
  Handle_ShapeAlgo_ToolContainer_4: typeof Handle_ShapeAlgo_ToolContainer_4;
  ShapeAlgo_ToolContainer: typeof ShapeAlgo_ToolContainer;
  Handle_TColGeom2d_HSequenceOfBoundedCurve: typeof Handle_TColGeom2d_HSequenceOfBoundedCurve;
  Handle_TColGeom2d_HSequenceOfBoundedCurve_1: typeof Handle_TColGeom2d_HSequenceOfBoundedCurve_1;
  Handle_TColGeom2d_HSequenceOfBoundedCurve_2: typeof Handle_TColGeom2d_HSequenceOfBoundedCurve_2;
  Handle_TColGeom2d_HSequenceOfBoundedCurve_3: typeof Handle_TColGeom2d_HSequenceOfBoundedCurve_3;
  Handle_TColGeom2d_HSequenceOfBoundedCurve_4: typeof Handle_TColGeom2d_HSequenceOfBoundedCurve_4;
  Handle_TColGeom2d_HArray1OfCurve: typeof Handle_TColGeom2d_HArray1OfCurve;
  Handle_TColGeom2d_HArray1OfCurve_1: typeof Handle_TColGeom2d_HArray1OfCurve_1;
  Handle_TColGeom2d_HArray1OfCurve_2: typeof Handle_TColGeom2d_HArray1OfCurve_2;
  Handle_TColGeom2d_HArray1OfCurve_3: typeof Handle_TColGeom2d_HArray1OfCurve_3;
  Handle_TColGeom2d_HArray1OfCurve_4: typeof Handle_TColGeom2d_HArray1OfCurve_4;
  Handle_TColGeom2d_HArray1OfBSplineCurve: typeof Handle_TColGeom2d_HArray1OfBSplineCurve;
  Handle_TColGeom2d_HArray1OfBSplineCurve_1: typeof Handle_TColGeom2d_HArray1OfBSplineCurve_1;
  Handle_TColGeom2d_HArray1OfBSplineCurve_2: typeof Handle_TColGeom2d_HArray1OfBSplineCurve_2;
  Handle_TColGeom2d_HArray1OfBSplineCurve_3: typeof Handle_TColGeom2d_HArray1OfBSplineCurve_3;
  Handle_TColGeom2d_HArray1OfBSplineCurve_4: typeof Handle_TColGeom2d_HArray1OfBSplineCurve_4;
  Handle_TColGeom2d_HArray1OfBezierCurve: typeof Handle_TColGeom2d_HArray1OfBezierCurve;
  Handle_TColGeom2d_HArray1OfBezierCurve_1: typeof Handle_TColGeom2d_HArray1OfBezierCurve_1;
  Handle_TColGeom2d_HArray1OfBezierCurve_2: typeof Handle_TColGeom2d_HArray1OfBezierCurve_2;
  Handle_TColGeom2d_HArray1OfBezierCurve_3: typeof Handle_TColGeom2d_HArray1OfBezierCurve_3;
  Handle_TColGeom2d_HArray1OfBezierCurve_4: typeof Handle_TColGeom2d_HArray1OfBezierCurve_4;
  Handle_TColGeom2d_HSequenceOfCurve: typeof Handle_TColGeom2d_HSequenceOfCurve;
  Handle_TColGeom2d_HSequenceOfCurve_1: typeof Handle_TColGeom2d_HSequenceOfCurve_1;
  Handle_TColGeom2d_HSequenceOfCurve_2: typeof Handle_TColGeom2d_HSequenceOfCurve_2;
  Handle_TColGeom2d_HSequenceOfCurve_3: typeof Handle_TColGeom2d_HSequenceOfCurve_3;
  Handle_TColGeom2d_HSequenceOfCurve_4: typeof Handle_TColGeom2d_HSequenceOfCurve_4;
  GeomPlate_Array1OfSequenceOfReal: typeof GeomPlate_Array1OfSequenceOfReal;
  GeomPlate_Array1OfSequenceOfReal_1: typeof GeomPlate_Array1OfSequenceOfReal_1;
  GeomPlate_Array1OfSequenceOfReal_2: typeof GeomPlate_Array1OfSequenceOfReal_2;
  GeomPlate_Array1OfSequenceOfReal_3: typeof GeomPlate_Array1OfSequenceOfReal_3;
  GeomPlate_Array1OfSequenceOfReal_4: typeof GeomPlate_Array1OfSequenceOfReal_4;
  GeomPlate_Array1OfSequenceOfReal_5: typeof GeomPlate_Array1OfSequenceOfReal_5;
  GeomPlate_SequenceOfAij: typeof GeomPlate_SequenceOfAij;
  GeomPlate_SequenceOfAij_1: typeof GeomPlate_SequenceOfAij_1;
  GeomPlate_SequenceOfAij_2: typeof GeomPlate_SequenceOfAij_2;
  GeomPlate_SequenceOfAij_3: typeof GeomPlate_SequenceOfAij_3;
  GeomPlate_PlateG1Criterion: typeof GeomPlate_PlateG1Criterion;
  Handle_GeomPlate_PointConstraint: typeof Handle_GeomPlate_PointConstraint;
  Handle_GeomPlate_PointConstraint_1: typeof Handle_GeomPlate_PointConstraint_1;
  Handle_GeomPlate_PointConstraint_2: typeof Handle_GeomPlate_PointConstraint_2;
  Handle_GeomPlate_PointConstraint_3: typeof Handle_GeomPlate_PointConstraint_3;
  Handle_GeomPlate_PointConstraint_4: typeof Handle_GeomPlate_PointConstraint_4;
  GeomPlate_PointConstraint: typeof GeomPlate_PointConstraint;
  GeomPlate_PointConstraint_1: typeof GeomPlate_PointConstraint_1;
  GeomPlate_PointConstraint_2: typeof GeomPlate_PointConstraint_2;
  GeomPlate_PlateG0Criterion: typeof GeomPlate_PlateG0Criterion;
  GeomPlate_BuildPlateSurface: typeof GeomPlate_BuildPlateSurface;
  GeomPlate_BuildPlateSurface_1: typeof GeomPlate_BuildPlateSurface_1;
  GeomPlate_BuildPlateSurface_2: typeof GeomPlate_BuildPlateSurface_2;
  GeomPlate_BuildPlateSurface_3: typeof GeomPlate_BuildPlateSurface_3;
  Handle_GeomPlate_HSequenceOfCurveConstraint: typeof Handle_GeomPlate_HSequenceOfCurveConstraint;
  Handle_GeomPlate_HSequenceOfCurveConstraint_1: typeof Handle_GeomPlate_HSequenceOfCurveConstraint_1;
  Handle_GeomPlate_HSequenceOfCurveConstraint_2: typeof Handle_GeomPlate_HSequenceOfCurveConstraint_2;
  Handle_GeomPlate_HSequenceOfCurveConstraint_3: typeof Handle_GeomPlate_HSequenceOfCurveConstraint_3;
  Handle_GeomPlate_HSequenceOfCurveConstraint_4: typeof Handle_GeomPlate_HSequenceOfCurveConstraint_4;
  Handle_GeomPlate_HSequenceOfPointConstraint: typeof Handle_GeomPlate_HSequenceOfPointConstraint;
  Handle_GeomPlate_HSequenceOfPointConstraint_1: typeof Handle_GeomPlate_HSequenceOfPointConstraint_1;
  Handle_GeomPlate_HSequenceOfPointConstraint_2: typeof Handle_GeomPlate_HSequenceOfPointConstraint_2;
  Handle_GeomPlate_HSequenceOfPointConstraint_3: typeof Handle_GeomPlate_HSequenceOfPointConstraint_3;
  Handle_GeomPlate_HSequenceOfPointConstraint_4: typeof Handle_GeomPlate_HSequenceOfPointConstraint_4;
  GeomPlate_BuildAveragePlane: typeof GeomPlate_BuildAveragePlane;
  GeomPlate_BuildAveragePlane_1: typeof GeomPlate_BuildAveragePlane_1;
  GeomPlate_BuildAveragePlane_2: typeof GeomPlate_BuildAveragePlane_2;
  GeomPlate_Aij: typeof GeomPlate_Aij;
  GeomPlate_Aij_1: typeof GeomPlate_Aij_1;
  GeomPlate_Aij_2: typeof GeomPlate_Aij_2;
  Handle_GeomPlate_HArray1OfHCurve: typeof Handle_GeomPlate_HArray1OfHCurve;
  Handle_GeomPlate_HArray1OfHCurve_1: typeof Handle_GeomPlate_HArray1OfHCurve_1;
  Handle_GeomPlate_HArray1OfHCurve_2: typeof Handle_GeomPlate_HArray1OfHCurve_2;
  Handle_GeomPlate_HArray1OfHCurve_3: typeof Handle_GeomPlate_HArray1OfHCurve_3;
  Handle_GeomPlate_HArray1OfHCurve_4: typeof Handle_GeomPlate_HArray1OfHCurve_4;
  Handle_GeomPlate_CurveConstraint: typeof Handle_GeomPlate_CurveConstraint;
  Handle_GeomPlate_CurveConstraint_1: typeof Handle_GeomPlate_CurveConstraint_1;
  Handle_GeomPlate_CurveConstraint_2: typeof Handle_GeomPlate_CurveConstraint_2;
  Handle_GeomPlate_CurveConstraint_3: typeof Handle_GeomPlate_CurveConstraint_3;
  Handle_GeomPlate_CurveConstraint_4: typeof Handle_GeomPlate_CurveConstraint_4;
  GeomPlate_CurveConstraint: typeof GeomPlate_CurveConstraint;
  GeomPlate_CurveConstraint_1: typeof GeomPlate_CurveConstraint_1;
  GeomPlate_CurveConstraint_2: typeof GeomPlate_CurveConstraint_2;
  GeomPlate_Surface: typeof GeomPlate_Surface;
  Handle_GeomPlate_Surface: typeof Handle_GeomPlate_Surface;
  Handle_GeomPlate_Surface_1: typeof Handle_GeomPlate_Surface_1;
  Handle_GeomPlate_Surface_2: typeof Handle_GeomPlate_Surface_2;
  Handle_GeomPlate_Surface_3: typeof Handle_GeomPlate_Surface_3;
  Handle_GeomPlate_Surface_4: typeof Handle_GeomPlate_Surface_4;
  GeomPlate_MakeApprox: typeof GeomPlate_MakeApprox;
  GeomPlate_MakeApprox_1: typeof GeomPlate_MakeApprox_1;
  GeomPlate_MakeApprox_2: typeof GeomPlate_MakeApprox_2;
  Handle_GeomPlate_HArray1OfSequenceOfReal: typeof Handle_GeomPlate_HArray1OfSequenceOfReal;
  Handle_GeomPlate_HArray1OfSequenceOfReal_1: typeof Handle_GeomPlate_HArray1OfSequenceOfReal_1;
  Handle_GeomPlate_HArray1OfSequenceOfReal_2: typeof Handle_GeomPlate_HArray1OfSequenceOfReal_2;
  Handle_GeomPlate_HArray1OfSequenceOfReal_3: typeof Handle_GeomPlate_HArray1OfSequenceOfReal_3;
  Handle_GeomPlate_HArray1OfSequenceOfReal_4: typeof Handle_GeomPlate_HArray1OfSequenceOfReal_4;
  Handle_ShapeFix_SplitCommonVertex: typeof Handle_ShapeFix_SplitCommonVertex;
  Handle_ShapeFix_SplitCommonVertex_1: typeof Handle_ShapeFix_SplitCommonVertex_1;
  Handle_ShapeFix_SplitCommonVertex_2: typeof Handle_ShapeFix_SplitCommonVertex_2;
  Handle_ShapeFix_SplitCommonVertex_3: typeof Handle_ShapeFix_SplitCommonVertex_3;
  Handle_ShapeFix_SplitCommonVertex_4: typeof Handle_ShapeFix_SplitCommonVertex_4;
  ShapeFix_SplitCommonVertex: typeof ShapeFix_SplitCommonVertex;
  ShapeFix_Face: typeof ShapeFix_Face;
  ShapeFix_Face_1: typeof ShapeFix_Face_1;
  ShapeFix_Face_2: typeof ShapeFix_Face_2;
  Handle_ShapeFix_Face: typeof Handle_ShapeFix_Face;
  Handle_ShapeFix_Face_1: typeof Handle_ShapeFix_Face_1;
  Handle_ShapeFix_Face_2: typeof Handle_ShapeFix_Face_2;
  Handle_ShapeFix_Face_3: typeof Handle_ShapeFix_Face_3;
  Handle_ShapeFix_Face_4: typeof Handle_ShapeFix_Face_4;
  ShapeFix_Wireframe: typeof ShapeFix_Wireframe;
  ShapeFix_Wireframe_1: typeof ShapeFix_Wireframe_1;
  ShapeFix_Wireframe_2: typeof ShapeFix_Wireframe_2;
  Handle_ShapeFix_Wireframe: typeof Handle_ShapeFix_Wireframe;
  Handle_ShapeFix_Wireframe_1: typeof Handle_ShapeFix_Wireframe_1;
  Handle_ShapeFix_Wireframe_2: typeof Handle_ShapeFix_Wireframe_2;
  Handle_ShapeFix_Wireframe_3: typeof Handle_ShapeFix_Wireframe_3;
  Handle_ShapeFix_Wireframe_4: typeof Handle_ShapeFix_Wireframe_4;
  ShapeFix_DataMapOfShapeBox2d: typeof ShapeFix_DataMapOfShapeBox2d;
  ShapeFix_DataMapOfShapeBox2d_1: typeof ShapeFix_DataMapOfShapeBox2d_1;
  ShapeFix_DataMapOfShapeBox2d_2: typeof ShapeFix_DataMapOfShapeBox2d_2;
  ShapeFix_DataMapOfShapeBox2d_3: typeof ShapeFix_DataMapOfShapeBox2d_3;
  ShapeFix_Wire: typeof ShapeFix_Wire;
  ShapeFix_Wire_1: typeof ShapeFix_Wire_1;
  ShapeFix_Wire_2: typeof ShapeFix_Wire_2;
  Handle_ShapeFix_Wire: typeof Handle_ShapeFix_Wire;
  Handle_ShapeFix_Wire_1: typeof Handle_ShapeFix_Wire_1;
  Handle_ShapeFix_Wire_2: typeof Handle_ShapeFix_Wire_2;
  Handle_ShapeFix_Wire_3: typeof Handle_ShapeFix_Wire_3;
  Handle_ShapeFix_Wire_4: typeof Handle_ShapeFix_Wire_4;
  ShapeFix_FixSmallSolid: typeof ShapeFix_FixSmallSolid;
  Handle_ShapeFix_FixSmallSolid: typeof Handle_ShapeFix_FixSmallSolid;
  Handle_ShapeFix_FixSmallSolid_1: typeof Handle_ShapeFix_FixSmallSolid_1;
  Handle_ShapeFix_FixSmallSolid_2: typeof Handle_ShapeFix_FixSmallSolid_2;
  Handle_ShapeFix_FixSmallSolid_3: typeof Handle_ShapeFix_FixSmallSolid_3;
  Handle_ShapeFix_FixSmallSolid_4: typeof Handle_ShapeFix_FixSmallSolid_4;
  ShapeFix_ShapeTolerance: typeof ShapeFix_ShapeTolerance;
  ShapeFix_Solid: typeof ShapeFix_Solid;
  ShapeFix_Solid_1: typeof ShapeFix_Solid_1;
  ShapeFix_Solid_2: typeof ShapeFix_Solid_2;
  Handle_ShapeFix_Solid: typeof Handle_ShapeFix_Solid;
  Handle_ShapeFix_Solid_1: typeof Handle_ShapeFix_Solid_1;
  Handle_ShapeFix_Solid_2: typeof Handle_ShapeFix_Solid_2;
  Handle_ShapeFix_Solid_3: typeof Handle_ShapeFix_Solid_3;
  Handle_ShapeFix_Solid_4: typeof Handle_ShapeFix_Solid_4;
  ShapeFix_FaceConnect: typeof ShapeFix_FaceConnect;
  ShapeFix_IntersectionTool: typeof ShapeFix_IntersectionTool;
  ShapeFix_ComposeShell: typeof ShapeFix_ComposeShell;
  Handle_ShapeFix_ComposeShell: typeof Handle_ShapeFix_ComposeShell;
  Handle_ShapeFix_ComposeShell_1: typeof Handle_ShapeFix_ComposeShell_1;
  Handle_ShapeFix_ComposeShell_2: typeof Handle_ShapeFix_ComposeShell_2;
  Handle_ShapeFix_ComposeShell_3: typeof Handle_ShapeFix_ComposeShell_3;
  Handle_ShapeFix_ComposeShell_4: typeof Handle_ShapeFix_ComposeShell_4;
  ShapeFix_FixSmallFace: typeof ShapeFix_FixSmallFace;
  Handle_ShapeFix_FixSmallFace: typeof Handle_ShapeFix_FixSmallFace;
  Handle_ShapeFix_FixSmallFace_1: typeof Handle_ShapeFix_FixSmallFace_1;
  Handle_ShapeFix_FixSmallFace_2: typeof Handle_ShapeFix_FixSmallFace_2;
  Handle_ShapeFix_FixSmallFace_3: typeof Handle_ShapeFix_FixSmallFace_3;
  Handle_ShapeFix_FixSmallFace_4: typeof Handle_ShapeFix_FixSmallFace_4;
  ShapeFix_SequenceOfWireSegment: typeof ShapeFix_SequenceOfWireSegment;
  ShapeFix_SequenceOfWireSegment_1: typeof ShapeFix_SequenceOfWireSegment_1;
  ShapeFix_SequenceOfWireSegment_2: typeof ShapeFix_SequenceOfWireSegment_2;
  ShapeFix_SequenceOfWireSegment_3: typeof ShapeFix_SequenceOfWireSegment_3;
  ShapeFix_Edge: typeof ShapeFix_Edge;
  Handle_ShapeFix_Edge: typeof Handle_ShapeFix_Edge;
  Handle_ShapeFix_Edge_1: typeof Handle_ShapeFix_Edge_1;
  Handle_ShapeFix_Edge_2: typeof Handle_ShapeFix_Edge_2;
  Handle_ShapeFix_Edge_3: typeof Handle_ShapeFix_Edge_3;
  Handle_ShapeFix_Edge_4: typeof Handle_ShapeFix_Edge_4;
  ShapeFix_FreeBounds: typeof ShapeFix_FreeBounds;
  ShapeFix_FreeBounds_1: typeof ShapeFix_FreeBounds_1;
  ShapeFix_FreeBounds_2: typeof ShapeFix_FreeBounds_2;
  ShapeFix_FreeBounds_3: typeof ShapeFix_FreeBounds_3;
  ShapeFix_WireVertex: typeof ShapeFix_WireVertex;
  ShapeFix_SplitTool: typeof ShapeFix_SplitTool;
  Handle_ShapeFix_Root: typeof Handle_ShapeFix_Root;
  Handle_ShapeFix_Root_1: typeof Handle_ShapeFix_Root_1;
  Handle_ShapeFix_Root_2: typeof Handle_ShapeFix_Root_2;
  Handle_ShapeFix_Root_3: typeof Handle_ShapeFix_Root_3;
  Handle_ShapeFix_Root_4: typeof Handle_ShapeFix_Root_4;
  ShapeFix_Root: typeof ShapeFix_Root;
  ShapeFix_Shape: typeof ShapeFix_Shape;
  ShapeFix_Shape_1: typeof ShapeFix_Shape_1;
  ShapeFix_Shape_2: typeof ShapeFix_Shape_2;
  Handle_ShapeFix_Shape: typeof Handle_ShapeFix_Shape;
  Handle_ShapeFix_Shape_1: typeof Handle_ShapeFix_Shape_1;
  Handle_ShapeFix_Shape_2: typeof Handle_ShapeFix_Shape_2;
  Handle_ShapeFix_Shape_3: typeof Handle_ShapeFix_Shape_3;
  Handle_ShapeFix_Shape_4: typeof Handle_ShapeFix_Shape_4;
  ShapeFix_Shell: typeof ShapeFix_Shell;
  ShapeFix_Shell_1: typeof ShapeFix_Shell_1;
  ShapeFix_Shell_2: typeof ShapeFix_Shell_2;
  Handle_ShapeFix_Shell: typeof Handle_ShapeFix_Shell;
  Handle_ShapeFix_Shell_1: typeof Handle_ShapeFix_Shell_1;
  Handle_ShapeFix_Shell_2: typeof Handle_ShapeFix_Shell_2;
  Handle_ShapeFix_Shell_3: typeof Handle_ShapeFix_Shell_3;
  Handle_ShapeFix_Shell_4: typeof Handle_ShapeFix_Shell_4;
  ShapeFix: typeof ShapeFix;
  ShapeFix_EdgeConnect: typeof ShapeFix_EdgeConnect;
  ShapeFix_EdgeProjAux: typeof ShapeFix_EdgeProjAux;
  ShapeFix_EdgeProjAux_1: typeof ShapeFix_EdgeProjAux_1;
  ShapeFix_EdgeProjAux_2: typeof ShapeFix_EdgeProjAux_2;
  Handle_ShapeFix_EdgeProjAux: typeof Handle_ShapeFix_EdgeProjAux;
  Handle_ShapeFix_EdgeProjAux_1: typeof Handle_ShapeFix_EdgeProjAux_1;
  Handle_ShapeFix_EdgeProjAux_2: typeof Handle_ShapeFix_EdgeProjAux_2;
  Handle_ShapeFix_EdgeProjAux_3: typeof Handle_ShapeFix_EdgeProjAux_3;
  Handle_ShapeFix_EdgeProjAux_4: typeof Handle_ShapeFix_EdgeProjAux_4;
  math_Gauss: typeof math_Gauss;
  math_Status: math_Status;
  math_FunctionSetWithDerivatives: typeof math_FunctionSetWithDerivatives;
  math_BracketedRoot: typeof math_BracketedRoot;
  math_Powell: typeof math_Powell;
  math_ValueAndWeight: typeof math_ValueAndWeight;
  math_ValueAndWeight_1: typeof math_ValueAndWeight_1;
  math_ValueAndWeight_2: typeof math_ValueAndWeight_2;
  math_BullardGenerator: typeof math_BullardGenerator;
  math_BracketMinimum: typeof math_BracketMinimum;
  math_BracketMinimum_1: typeof math_BracketMinimum_1;
  math_BracketMinimum_2: typeof math_BracketMinimum_2;
  math_BracketMinimum_3: typeof math_BracketMinimum_3;
  math_BracketMinimum_4: typeof math_BracketMinimum_4;
  math_Uzawa: typeof math_Uzawa;
  math_Uzawa_1: typeof math_Uzawa_1;
  math_Uzawa_2: typeof math_Uzawa_2;
  math_TrigonometricFunctionRoots: typeof math_TrigonometricFunctionRoots;
  math_TrigonometricFunctionRoots_1: typeof math_TrigonometricFunctionRoots_1;
  math_TrigonometricFunctionRoots_2: typeof math_TrigonometricFunctionRoots_2;
  math_TrigonometricFunctionRoots_3: typeof math_TrigonometricFunctionRoots_3;
  math_FunctionWithDerivative: typeof math_FunctionWithDerivative;
  math_ComputeKronrodPointsAndWeights: typeof math_ComputeKronrodPointsAndWeights;
  math_GaussSingleIntegration: typeof math_GaussSingleIntegration;
  math_GaussSingleIntegration_1: typeof math_GaussSingleIntegration_1;
  math_GaussSingleIntegration_2: typeof math_GaussSingleIntegration_2;
  math_GaussSingleIntegration_3: typeof math_GaussSingleIntegration_3;
  PSO_Particle: typeof PSO_Particle;
  math_PSOParticlesPool: typeof math_PSOParticlesPool;
  math_FunctionSample: typeof math_FunctionSample;
  math_Array1OfValueAndWeight: typeof math_Array1OfValueAndWeight;
  math_Array1OfValueAndWeight_1: typeof math_Array1OfValueAndWeight_1;
  math_Array1OfValueAndWeight_2: typeof math_Array1OfValueAndWeight_2;
  math_Array1OfValueAndWeight_3: typeof math_Array1OfValueAndWeight_3;
  math_Array1OfValueAndWeight_4: typeof math_Array1OfValueAndWeight_4;
  math_Array1OfValueAndWeight_5: typeof math_Array1OfValueAndWeight_5;
  math_GaussMultipleIntegration: typeof math_GaussMultipleIntegration;
  math: typeof math;
  math_FunctionSetRoot: typeof math_FunctionSetRoot;
  math_FunctionSetRoot_1: typeof math_FunctionSetRoot_1;
  math_FunctionSetRoot_2: typeof math_FunctionSetRoot_2;
  math_NotSquare: typeof math_NotSquare;
  math_NotSquare_1: typeof math_NotSquare_1;
  math_NotSquare_2: typeof math_NotSquare_2;
  Handle_math_NotSquare: typeof Handle_math_NotSquare;
  Handle_math_NotSquare_1: typeof Handle_math_NotSquare_1;
  Handle_math_NotSquare_2: typeof Handle_math_NotSquare_2;
  Handle_math_NotSquare_3: typeof Handle_math_NotSquare_3;
  Handle_math_NotSquare_4: typeof Handle_math_NotSquare_4;
  math_BissecNewton: typeof math_BissecNewton;
  math_BFGS: typeof math_BFGS;
  math_FRPR: typeof math_FRPR;
  math_GlobOptMin: typeof math_GlobOptMin;
  math_DirectPolynomialRoots: typeof math_DirectPolynomialRoots;
  math_DirectPolynomialRoots_1: typeof math_DirectPolynomialRoots_1;
  math_DirectPolynomialRoots_2: typeof math_DirectPolynomialRoots_2;
  math_DirectPolynomialRoots_3: typeof math_DirectPolynomialRoots_3;
  math_DirectPolynomialRoots_4: typeof math_DirectPolynomialRoots_4;
  math_Jacobi: typeof math_Jacobi;
  math_BrentMinimum: typeof math_BrentMinimum;
  math_BrentMinimum_1: typeof math_BrentMinimum_1;
  math_BrentMinimum_2: typeof math_BrentMinimum_2;
  math_GaussSetIntegration: typeof math_GaussSetIntegration;
  math_TrigonometricEquationFunction: typeof math_TrigonometricEquationFunction;
  math_KronrodSingleIntegration: typeof math_KronrodSingleIntegration;
  math_KronrodSingleIntegration_1: typeof math_KronrodSingleIntegration_1;
  math_KronrodSingleIntegration_2: typeof math_KronrodSingleIntegration_2;
  math_KronrodSingleIntegration_3: typeof math_KronrodSingleIntegration_3;
  math_FunctionRoot: typeof math_FunctionRoot;
  math_FunctionRoot_1: typeof math_FunctionRoot_1;
  math_FunctionRoot_2: typeof math_FunctionRoot_2;
  math_SVD: typeof math_SVD;
  math_MultipleVarFunction: typeof math_MultipleVarFunction;
  math_GaussLeastSquare: typeof math_GaussLeastSquare;
  math_FunctionAllRoots: typeof math_FunctionAllRoots;
  math_EigenValuesSearcher: typeof math_EigenValuesSearcher;
  math_PSO: typeof math_PSO;
  math_Function: typeof math_Function;
  math_NewtonFunctionRoot: typeof math_NewtonFunctionRoot;
  math_NewtonFunctionRoot_1: typeof math_NewtonFunctionRoot_1;
  math_NewtonFunctionRoot_2: typeof math_NewtonFunctionRoot_2;
  math_NewtonFunctionRoot_3: typeof math_NewtonFunctionRoot_3;
  math_FunctionRoots: typeof math_FunctionRoots;
  math_MultipleVarFunctionWithHessian: typeof math_MultipleVarFunctionWithHessian;
  Handle_math_SingularMatrix: typeof Handle_math_SingularMatrix;
  Handle_math_SingularMatrix_1: typeof Handle_math_SingularMatrix_1;
  Handle_math_SingularMatrix_2: typeof Handle_math_SingularMatrix_2;
  Handle_math_SingularMatrix_3: typeof Handle_math_SingularMatrix_3;
  Handle_math_SingularMatrix_4: typeof Handle_math_SingularMatrix_4;
  math_SingularMatrix: typeof math_SingularMatrix;
  math_SingularMatrix_1: typeof math_SingularMatrix_1;
  math_SingularMatrix_2: typeof math_SingularMatrix_2;
  math_FunctionSet: typeof math_FunctionSet;
  math_MultipleVarFunctionWithGradient: typeof math_MultipleVarFunctionWithGradient;
  math_ComputeGaussPointsAndWeights: typeof math_ComputeGaussPointsAndWeights;
  math_DoubleTab: typeof math_DoubleTab;
  math_DoubleTab_1: typeof math_DoubleTab_1;
  math_DoubleTab_2: typeof math_DoubleTab_2;
  math_DoubleTab_3: typeof math_DoubleTab_3;
  math_Crout: typeof math_Crout;
  Image_SupportedFormats: typeof Image_SupportedFormats;
  Handle_Image_AlienPixMap: typeof Handle_Image_AlienPixMap;
  Handle_Image_AlienPixMap_1: typeof Handle_Image_AlienPixMap_1;
  Handle_Image_AlienPixMap_2: typeof Handle_Image_AlienPixMap_2;
  Handle_Image_AlienPixMap_3: typeof Handle_Image_AlienPixMap_3;
  Handle_Image_AlienPixMap_4: typeof Handle_Image_AlienPixMap_4;
  Image_AlienPixMap: typeof Image_AlienPixMap;
  Image_VideoRecorder: typeof Image_VideoRecorder;
  Handle_Image_VideoRecorder: typeof Handle_Image_VideoRecorder;
  Handle_Image_VideoRecorder_1: typeof Handle_Image_VideoRecorder_1;
  Handle_Image_VideoRecorder_2: typeof Handle_Image_VideoRecorder_2;
  Handle_Image_VideoRecorder_3: typeof Handle_Image_VideoRecorder_3;
  Handle_Image_VideoRecorder_4: typeof Handle_Image_VideoRecorder_4;
  Image_VideoParams: typeof Image_VideoParams;
  Image_Format: Image_Format;
  Image_DDSParser: typeof Image_DDSParser;
  Handle_Image_PixMap: typeof Handle_Image_PixMap;
  Handle_Image_PixMap_1: typeof Handle_Image_PixMap_1;
  Handle_Image_PixMap_2: typeof Handle_Image_PixMap_2;
  Handle_Image_PixMap_3: typeof Handle_Image_PixMap_3;
  Handle_Image_PixMap_4: typeof Handle_Image_PixMap_4;
  Image_PixMap: typeof Image_PixMap;
  Image_Texture: typeof Image_Texture;
  Image_Texture_1: typeof Image_Texture_1;
  Image_Texture_2: typeof Image_Texture_2;
  Image_Texture_3: typeof Image_Texture_3;
  Image_CompressedFormat: Image_CompressedFormat;
  Image_PixMapData: typeof Image_PixMapData;
  Handle_Image_PixMapData: typeof Handle_Image_PixMapData;
  Handle_Image_PixMapData_1: typeof Handle_Image_PixMapData_1;
  Handle_Image_PixMapData_2: typeof Handle_Image_PixMapData_2;
  Handle_Image_PixMapData_3: typeof Handle_Image_PixMapData_3;
  Handle_Image_PixMapData_4: typeof Handle_Image_PixMapData_4;
  Image_ColorBGRF: typeof Image_ColorBGRF;
  Image_ColorRGF: typeof Image_ColorRGF;
  Image_ColorBGR32: typeof Image_ColorBGR32;
  Image_ColorBGR: typeof Image_ColorBGR;
  Image_ColorRGBF: typeof Image_ColorRGBF;
  Image_ColorRGB: typeof Image_ColorRGB;
  Image_ColorRGBA: typeof Image_ColorRGBA;
  Image_ColorRGB32: typeof Image_ColorRGB32;
  Image_ColorBGRA: typeof Image_ColorBGRA;
  Image_ColorBGRAF: typeof Image_ColorBGRAF;
  Image_ColorRGBAF: typeof Image_ColorRGBAF;
  Image_CompressedPixMap: typeof Image_CompressedPixMap;
  Handle_Image_Diff: typeof Handle_Image_Diff;
  Handle_Image_Diff_1: typeof Handle_Image_Diff_1;
  Handle_Image_Diff_2: typeof Handle_Image_Diff_2;
  Handle_Image_Diff_3: typeof Handle_Image_Diff_3;
  Handle_Image_Diff_4: typeof Handle_Image_Diff_4;
  Image_Diff: typeof Image_Diff;
  GeomProjLib: typeof GeomProjLib;
  Handle_TDataStd_Tick: typeof Handle_TDataStd_Tick;
  Handle_TDataStd_Tick_1: typeof Handle_TDataStd_Tick_1;
  Handle_TDataStd_Tick_2: typeof Handle_TDataStd_Tick_2;
  Handle_TDataStd_Tick_3: typeof Handle_TDataStd_Tick_3;
  Handle_TDataStd_Tick_4: typeof Handle_TDataStd_Tick_4;
  TDataStd_Tick: typeof TDataStd_Tick;
  TDataStd_DataMapOfStringByte: typeof TDataStd_DataMapOfStringByte;
  TDataStd_DataMapOfStringByte_1: typeof TDataStd_DataMapOfStringByte_1;
  TDataStd_DataMapOfStringByte_2: typeof TDataStd_DataMapOfStringByte_2;
  TDataStd_DataMapOfStringByte_3: typeof TDataStd_DataMapOfStringByte_3;
  Handle_TDataStd_UAttribute: typeof Handle_TDataStd_UAttribute;
  Handle_TDataStd_UAttribute_1: typeof Handle_TDataStd_UAttribute_1;
  Handle_TDataStd_UAttribute_2: typeof Handle_TDataStd_UAttribute_2;
  Handle_TDataStd_UAttribute_3: typeof Handle_TDataStd_UAttribute_3;
  Handle_TDataStd_UAttribute_4: typeof Handle_TDataStd_UAttribute_4;
  TDataStd_UAttribute: typeof TDataStd_UAttribute;
  Handle_TDataStd_DeltaOnModificationOfRealArray: typeof Handle_TDataStd_DeltaOnModificationOfRealArray;
  Handle_TDataStd_DeltaOnModificationOfRealArray_1: typeof Handle_TDataStd_DeltaOnModificationOfRealArray_1;
  Handle_TDataStd_DeltaOnModificationOfRealArray_2: typeof Handle_TDataStd_DeltaOnModificationOfRealArray_2;
  Handle_TDataStd_DeltaOnModificationOfRealArray_3: typeof Handle_TDataStd_DeltaOnModificationOfRealArray_3;
  Handle_TDataStd_DeltaOnModificationOfRealArray_4: typeof Handle_TDataStd_DeltaOnModificationOfRealArray_4;
  TDataStd_DeltaOnModificationOfRealArray: typeof TDataStd_DeltaOnModificationOfRealArray;
  Handle_TDataStd_DeltaOnModificationOfExtStringArray: typeof Handle_TDataStd_DeltaOnModificationOfExtStringArray;
  Handle_TDataStd_DeltaOnModificationOfExtStringArray_1: typeof Handle_TDataStd_DeltaOnModificationOfExtStringArray_1;
  Handle_TDataStd_DeltaOnModificationOfExtStringArray_2: typeof Handle_TDataStd_DeltaOnModificationOfExtStringArray_2;
  Handle_TDataStd_DeltaOnModificationOfExtStringArray_3: typeof Handle_TDataStd_DeltaOnModificationOfExtStringArray_3;
  Handle_TDataStd_DeltaOnModificationOfExtStringArray_4: typeof Handle_TDataStd_DeltaOnModificationOfExtStringArray_4;
  TDataStd_DeltaOnModificationOfExtStringArray: typeof TDataStd_DeltaOnModificationOfExtStringArray;
  Handle_TDataStd_HDataMapOfStringHArray1OfReal: typeof Handle_TDataStd_HDataMapOfStringHArray1OfReal;
  Handle_TDataStd_HDataMapOfStringHArray1OfReal_1: typeof Handle_TDataStd_HDataMapOfStringHArray1OfReal_1;
  Handle_TDataStd_HDataMapOfStringHArray1OfReal_2: typeof Handle_TDataStd_HDataMapOfStringHArray1OfReal_2;
  Handle_TDataStd_HDataMapOfStringHArray1OfReal_3: typeof Handle_TDataStd_HDataMapOfStringHArray1OfReal_3;
  Handle_TDataStd_HDataMapOfStringHArray1OfReal_4: typeof Handle_TDataStd_HDataMapOfStringHArray1OfReal_4;
  TDataStd_HDataMapOfStringHArray1OfReal: typeof TDataStd_HDataMapOfStringHArray1OfReal;
  TDataStd_HDataMapOfStringHArray1OfReal_1: typeof TDataStd_HDataMapOfStringHArray1OfReal_1;
  TDataStd_HDataMapOfStringHArray1OfReal_2: typeof TDataStd_HDataMapOfStringHArray1OfReal_2;
  TDataStd_HDataMapOfStringByte: typeof TDataStd_HDataMapOfStringByte;
  TDataStd_HDataMapOfStringByte_1: typeof TDataStd_HDataMapOfStringByte_1;
  TDataStd_HDataMapOfStringByte_2: typeof TDataStd_HDataMapOfStringByte_2;
  Handle_TDataStd_HDataMapOfStringByte: typeof Handle_TDataStd_HDataMapOfStringByte;
  Handle_TDataStd_HDataMapOfStringByte_1: typeof Handle_TDataStd_HDataMapOfStringByte_1;
  Handle_TDataStd_HDataMapOfStringByte_2: typeof Handle_TDataStd_HDataMapOfStringByte_2;
  Handle_TDataStd_HDataMapOfStringByte_3: typeof Handle_TDataStd_HDataMapOfStringByte_3;
  Handle_TDataStd_HDataMapOfStringByte_4: typeof Handle_TDataStd_HDataMapOfStringByte_4;
  Handle_TDataStd_Integer: typeof Handle_TDataStd_Integer;
  Handle_TDataStd_Integer_1: typeof Handle_TDataStd_Integer_1;
  Handle_TDataStd_Integer_2: typeof Handle_TDataStd_Integer_2;
  Handle_TDataStd_Integer_3: typeof Handle_TDataStd_Integer_3;
  Handle_TDataStd_Integer_4: typeof Handle_TDataStd_Integer_4;
  TDataStd_Integer: typeof TDataStd_Integer;
  TDataStd_IntegerList: typeof TDataStd_IntegerList;
  Handle_TDataStd_IntegerList: typeof Handle_TDataStd_IntegerList;
  Handle_TDataStd_IntegerList_1: typeof Handle_TDataStd_IntegerList_1;
  Handle_TDataStd_IntegerList_2: typeof Handle_TDataStd_IntegerList_2;
  Handle_TDataStd_IntegerList_3: typeof Handle_TDataStd_IntegerList_3;
  Handle_TDataStd_IntegerList_4: typeof Handle_TDataStd_IntegerList_4;
  TDataStd_NoteBook: typeof TDataStd_NoteBook;
  Handle_TDataStd_NoteBook: typeof Handle_TDataStd_NoteBook;
  Handle_TDataStd_NoteBook_1: typeof Handle_TDataStd_NoteBook_1;
  Handle_TDataStd_NoteBook_2: typeof Handle_TDataStd_NoteBook_2;
  Handle_TDataStd_NoteBook_3: typeof Handle_TDataStd_NoteBook_3;
  Handle_TDataStd_NoteBook_4: typeof Handle_TDataStd_NoteBook_4;
  Handle_TDataStd_AsciiString: typeof Handle_TDataStd_AsciiString;
  Handle_TDataStd_AsciiString_1: typeof Handle_TDataStd_AsciiString_1;
  Handle_TDataStd_AsciiString_2: typeof Handle_TDataStd_AsciiString_2;
  Handle_TDataStd_AsciiString_3: typeof Handle_TDataStd_AsciiString_3;
  Handle_TDataStd_AsciiString_4: typeof Handle_TDataStd_AsciiString_4;
  TDataStd_AsciiString: typeof TDataStd_AsciiString;
  TDataStd_DataMapOfStringString: typeof TDataStd_DataMapOfStringString;
  TDataStd_DataMapOfStringString_1: typeof TDataStd_DataMapOfStringString_1;
  TDataStd_DataMapOfStringString_2: typeof TDataStd_DataMapOfStringString_2;
  TDataStd_DataMapOfStringString_3: typeof TDataStd_DataMapOfStringString_3;
  TDataStd_LabelArray1: typeof TDataStd_LabelArray1;
  TDataStd_LabelArray1_1: typeof TDataStd_LabelArray1_1;
  TDataStd_LabelArray1_2: typeof TDataStd_LabelArray1_2;
  TDataStd_LabelArray1_3: typeof TDataStd_LabelArray1_3;
  TDataStd_LabelArray1_4: typeof TDataStd_LabelArray1_4;
  TDataStd_LabelArray1_5: typeof TDataStd_LabelArray1_5;
  TDataStd_ChildNodeIterator: typeof TDataStd_ChildNodeIterator;
  TDataStd_ChildNodeIterator_1: typeof TDataStd_ChildNodeIterator_1;
  TDataStd_ChildNodeIterator_2: typeof TDataStd_ChildNodeIterator_2;
  Handle_TDataStd_Variable: typeof Handle_TDataStd_Variable;
  Handle_TDataStd_Variable_1: typeof Handle_TDataStd_Variable_1;
  Handle_TDataStd_Variable_2: typeof Handle_TDataStd_Variable_2;
  Handle_TDataStd_Variable_3: typeof Handle_TDataStd_Variable_3;
  Handle_TDataStd_Variable_4: typeof Handle_TDataStd_Variable_4;
  TDataStd_Variable: typeof TDataStd_Variable;
  TDataStd_ExtStringList: typeof TDataStd_ExtStringList;
  Handle_TDataStd_ExtStringList: typeof Handle_TDataStd_ExtStringList;
  Handle_TDataStd_ExtStringList_1: typeof Handle_TDataStd_ExtStringList_1;
  Handle_TDataStd_ExtStringList_2: typeof Handle_TDataStd_ExtStringList_2;
  Handle_TDataStd_ExtStringList_3: typeof Handle_TDataStd_ExtStringList_3;
  Handle_TDataStd_ExtStringList_4: typeof Handle_TDataStd_ExtStringList_4;
  TDataStd_ListOfByte: typeof TDataStd_ListOfByte;
  TDataStd_ListOfByte_1: typeof TDataStd_ListOfByte_1;
  TDataStd_ListOfByte_2: typeof TDataStd_ListOfByte_2;
  TDataStd_ListOfByte_3: typeof TDataStd_ListOfByte_3;
  TDataStd_ReferenceArray: typeof TDataStd_ReferenceArray;
  Handle_TDataStd_ReferenceArray: typeof Handle_TDataStd_ReferenceArray;
  Handle_TDataStd_ReferenceArray_1: typeof Handle_TDataStd_ReferenceArray_1;
  Handle_TDataStd_ReferenceArray_2: typeof Handle_TDataStd_ReferenceArray_2;
  Handle_TDataStd_ReferenceArray_3: typeof Handle_TDataStd_ReferenceArray_3;
  Handle_TDataStd_ReferenceArray_4: typeof Handle_TDataStd_ReferenceArray_4;
  Handle_TDataStd_TreeNode: typeof Handle_TDataStd_TreeNode;
  Handle_TDataStd_TreeNode_1: typeof Handle_TDataStd_TreeNode_1;
  Handle_TDataStd_TreeNode_2: typeof Handle_TDataStd_TreeNode_2;
  Handle_TDataStd_TreeNode_3: typeof Handle_TDataStd_TreeNode_3;
  Handle_TDataStd_TreeNode_4: typeof Handle_TDataStd_TreeNode_4;
  TDataStd_TreeNode: typeof TDataStd_TreeNode;
  TDataStd_IntegerArray: typeof TDataStd_IntegerArray;
  Handle_TDataStd_IntegerArray: typeof Handle_TDataStd_IntegerArray;
  Handle_TDataStd_IntegerArray_1: typeof Handle_TDataStd_IntegerArray_1;
  Handle_TDataStd_IntegerArray_2: typeof Handle_TDataStd_IntegerArray_2;
  Handle_TDataStd_IntegerArray_3: typeof Handle_TDataStd_IntegerArray_3;
  Handle_TDataStd_IntegerArray_4: typeof Handle_TDataStd_IntegerArray_4;
  TDataStd_ListOfExtendedString: typeof TDataStd_ListOfExtendedString;
  TDataStd_ListOfExtendedString_1: typeof TDataStd_ListOfExtendedString_1;
  TDataStd_ListOfExtendedString_2: typeof TDataStd_ListOfExtendedString_2;
  TDataStd_ListOfExtendedString_3: typeof TDataStd_ListOfExtendedString_3;
  Handle_TDataStd_DeltaOnModificationOfByteArray: typeof Handle_TDataStd_DeltaOnModificationOfByteArray;
  Handle_TDataStd_DeltaOnModificationOfByteArray_1: typeof Handle_TDataStd_DeltaOnModificationOfByteArray_1;
  Handle_TDataStd_DeltaOnModificationOfByteArray_2: typeof Handle_TDataStd_DeltaOnModificationOfByteArray_2;
  Handle_TDataStd_DeltaOnModificationOfByteArray_3: typeof Handle_TDataStd_DeltaOnModificationOfByteArray_3;
  Handle_TDataStd_DeltaOnModificationOfByteArray_4: typeof Handle_TDataStd_DeltaOnModificationOfByteArray_4;
  TDataStd_DeltaOnModificationOfByteArray: typeof TDataStd_DeltaOnModificationOfByteArray;
  TDataStd_Relation: typeof TDataStd_Relation;
  Handle_TDataStd_Relation: typeof Handle_TDataStd_Relation;
  Handle_TDataStd_Relation_1: typeof Handle_TDataStd_Relation_1;
  Handle_TDataStd_Relation_2: typeof Handle_TDataStd_Relation_2;
  Handle_TDataStd_Relation_3: typeof Handle_TDataStd_Relation_3;
  Handle_TDataStd_Relation_4: typeof Handle_TDataStd_Relation_4;
  TDataStd_GenericEmpty: typeof TDataStd_GenericEmpty;
  Handle_TDataStd_GenericEmpty: typeof Handle_TDataStd_GenericEmpty;
  Handle_TDataStd_GenericEmpty_1: typeof Handle_TDataStd_GenericEmpty_1;
  Handle_TDataStd_GenericEmpty_2: typeof Handle_TDataStd_GenericEmpty_2;
  Handle_TDataStd_GenericEmpty_3: typeof Handle_TDataStd_GenericEmpty_3;
  Handle_TDataStd_GenericEmpty_4: typeof Handle_TDataStd_GenericEmpty_4;
  Handle_TDataStd_Current: typeof Handle_TDataStd_Current;
  Handle_TDataStd_Current_1: typeof Handle_TDataStd_Current_1;
  Handle_TDataStd_Current_2: typeof Handle_TDataStd_Current_2;
  Handle_TDataStd_Current_3: typeof Handle_TDataStd_Current_3;
  Handle_TDataStd_Current_4: typeof Handle_TDataStd_Current_4;
  TDataStd_Current: typeof TDataStd_Current;
  TDataStd_Name: typeof TDataStd_Name;
  Handle_TDataStd_Name: typeof Handle_TDataStd_Name;
  Handle_TDataStd_Name_1: typeof Handle_TDataStd_Name_1;
  Handle_TDataStd_Name_2: typeof Handle_TDataStd_Name_2;
  Handle_TDataStd_Name_3: typeof Handle_TDataStd_Name_3;
  Handle_TDataStd_Name_4: typeof Handle_TDataStd_Name_4;
  Handle_TDataStd_NamedData: typeof Handle_TDataStd_NamedData;
  Handle_TDataStd_NamedData_1: typeof Handle_TDataStd_NamedData_1;
  Handle_TDataStd_NamedData_2: typeof Handle_TDataStd_NamedData_2;
  Handle_TDataStd_NamedData_3: typeof Handle_TDataStd_NamedData_3;
  Handle_TDataStd_NamedData_4: typeof Handle_TDataStd_NamedData_4;
  TDataStd_NamedData: typeof TDataStd_NamedData;
  Handle_TDataStd_Directory: typeof Handle_TDataStd_Directory;
  Handle_TDataStd_Directory_1: typeof Handle_TDataStd_Directory_1;
  Handle_TDataStd_Directory_2: typeof Handle_TDataStd_Directory_2;
  Handle_TDataStd_Directory_3: typeof Handle_TDataStd_Directory_3;
  Handle_TDataStd_Directory_4: typeof Handle_TDataStd_Directory_4;
  TDataStd_Directory: typeof TDataStd_Directory;
  TDataStd_Comment: typeof TDataStd_Comment;
  Handle_TDataStd_Comment: typeof Handle_TDataStd_Comment;
  Handle_TDataStd_Comment_1: typeof Handle_TDataStd_Comment_1;
  Handle_TDataStd_Comment_2: typeof Handle_TDataStd_Comment_2;
  Handle_TDataStd_Comment_3: typeof Handle_TDataStd_Comment_3;
  Handle_TDataStd_Comment_4: typeof Handle_TDataStd_Comment_4;
  Handle_TDataStd_GenericExtString: typeof Handle_TDataStd_GenericExtString;
  Handle_TDataStd_GenericExtString_1: typeof Handle_TDataStd_GenericExtString_1;
  Handle_TDataStd_GenericExtString_2: typeof Handle_TDataStd_GenericExtString_2;
  Handle_TDataStd_GenericExtString_3: typeof Handle_TDataStd_GenericExtString_3;
  Handle_TDataStd_GenericExtString_4: typeof Handle_TDataStd_GenericExtString_4;
  TDataStd_GenericExtString: typeof TDataStd_GenericExtString;
  Handle_TDataStd_ReferenceList: typeof Handle_TDataStd_ReferenceList;
  Handle_TDataStd_ReferenceList_1: typeof Handle_TDataStd_ReferenceList_1;
  Handle_TDataStd_ReferenceList_2: typeof Handle_TDataStd_ReferenceList_2;
  Handle_TDataStd_ReferenceList_3: typeof Handle_TDataStd_ReferenceList_3;
  Handle_TDataStd_ReferenceList_4: typeof Handle_TDataStd_ReferenceList_4;
  TDataStd_ReferenceList: typeof TDataStd_ReferenceList;
  Handle_TDataStd_HLabelArray1: typeof Handle_TDataStd_HLabelArray1;
  Handle_TDataStd_HLabelArray1_1: typeof Handle_TDataStd_HLabelArray1_1;
  Handle_TDataStd_HLabelArray1_2: typeof Handle_TDataStd_HLabelArray1_2;
  Handle_TDataStd_HLabelArray1_3: typeof Handle_TDataStd_HLabelArray1_3;
  Handle_TDataStd_HLabelArray1_4: typeof Handle_TDataStd_HLabelArray1_4;
  TDataStd_HDataMapOfStringString: typeof TDataStd_HDataMapOfStringString;
  TDataStd_HDataMapOfStringString_1: typeof TDataStd_HDataMapOfStringString_1;
  TDataStd_HDataMapOfStringString_2: typeof TDataStd_HDataMapOfStringString_2;
  Handle_TDataStd_HDataMapOfStringString: typeof Handle_TDataStd_HDataMapOfStringString;
  Handle_TDataStd_HDataMapOfStringString_1: typeof Handle_TDataStd_HDataMapOfStringString_1;
  Handle_TDataStd_HDataMapOfStringString_2: typeof Handle_TDataStd_HDataMapOfStringString_2;
  Handle_TDataStd_HDataMapOfStringString_3: typeof Handle_TDataStd_HDataMapOfStringString_3;
  Handle_TDataStd_HDataMapOfStringString_4: typeof Handle_TDataStd_HDataMapOfStringString_4;
  TDataStd_HDataMapOfStringHArray1OfInteger: typeof TDataStd_HDataMapOfStringHArray1OfInteger;
  TDataStd_HDataMapOfStringHArray1OfInteger_1: typeof TDataStd_HDataMapOfStringHArray1OfInteger_1;
  TDataStd_HDataMapOfStringHArray1OfInteger_2: typeof TDataStd_HDataMapOfStringHArray1OfInteger_2;
  Handle_TDataStd_HDataMapOfStringHArray1OfInteger: typeof Handle_TDataStd_HDataMapOfStringHArray1OfInteger;
  Handle_TDataStd_HDataMapOfStringHArray1OfInteger_1: typeof Handle_TDataStd_HDataMapOfStringHArray1OfInteger_1;
  Handle_TDataStd_HDataMapOfStringHArray1OfInteger_2: typeof Handle_TDataStd_HDataMapOfStringHArray1OfInteger_2;
  Handle_TDataStd_HDataMapOfStringHArray1OfInteger_3: typeof Handle_TDataStd_HDataMapOfStringHArray1OfInteger_3;
  Handle_TDataStd_HDataMapOfStringHArray1OfInteger_4: typeof Handle_TDataStd_HDataMapOfStringHArray1OfInteger_4;
  TDataStd: typeof TDataStd;
  Handle_TDataStd_HDataMapOfStringReal: typeof Handle_TDataStd_HDataMapOfStringReal;
  Handle_TDataStd_HDataMapOfStringReal_1: typeof Handle_TDataStd_HDataMapOfStringReal_1;
  Handle_TDataStd_HDataMapOfStringReal_2: typeof Handle_TDataStd_HDataMapOfStringReal_2;
  Handle_TDataStd_HDataMapOfStringReal_3: typeof Handle_TDataStd_HDataMapOfStringReal_3;
  Handle_TDataStd_HDataMapOfStringReal_4: typeof Handle_TDataStd_HDataMapOfStringReal_4;
  TDataStd_HDataMapOfStringReal: typeof TDataStd_HDataMapOfStringReal;
  TDataStd_HDataMapOfStringReal_1: typeof TDataStd_HDataMapOfStringReal_1;
  TDataStd_HDataMapOfStringReal_2: typeof TDataStd_HDataMapOfStringReal_2;
  TDataStd_ExtStringArray: typeof TDataStd_ExtStringArray;
  Handle_TDataStd_ExtStringArray: typeof Handle_TDataStd_ExtStringArray;
  Handle_TDataStd_ExtStringArray_1: typeof Handle_TDataStd_ExtStringArray_1;
  Handle_TDataStd_ExtStringArray_2: typeof Handle_TDataStd_ExtStringArray_2;
  Handle_TDataStd_ExtStringArray_3: typeof Handle_TDataStd_ExtStringArray_3;
  Handle_TDataStd_ExtStringArray_4: typeof Handle_TDataStd_ExtStringArray_4;
  TDataStd_DataMapOfStringReal: typeof TDataStd_DataMapOfStringReal;
  TDataStd_DataMapOfStringReal_1: typeof TDataStd_DataMapOfStringReal_1;
  TDataStd_DataMapOfStringReal_2: typeof TDataStd_DataMapOfStringReal_2;
  TDataStd_DataMapOfStringReal_3: typeof TDataStd_DataMapOfStringReal_3;
  Handle_TDataStd_RealArray: typeof Handle_TDataStd_RealArray;
  Handle_TDataStd_RealArray_1: typeof Handle_TDataStd_RealArray_1;
  Handle_TDataStd_RealArray_2: typeof Handle_TDataStd_RealArray_2;
  Handle_TDataStd_RealArray_3: typeof Handle_TDataStd_RealArray_3;
  Handle_TDataStd_RealArray_4: typeof Handle_TDataStd_RealArray_4;
  TDataStd_RealArray: typeof TDataStd_RealArray;
  TDataStd_Expression: typeof TDataStd_Expression;
  Handle_TDataStd_Expression: typeof Handle_TDataStd_Expression;
  Handle_TDataStd_Expression_1: typeof Handle_TDataStd_Expression_1;
  Handle_TDataStd_Expression_2: typeof Handle_TDataStd_Expression_2;
  Handle_TDataStd_Expression_3: typeof Handle_TDataStd_Expression_3;
  Handle_TDataStd_Expression_4: typeof Handle_TDataStd_Expression_4;
  Handle_TDataStd_DeltaOnModificationOfIntPackedMap: typeof Handle_TDataStd_DeltaOnModificationOfIntPackedMap;
  Handle_TDataStd_DeltaOnModificationOfIntPackedMap_1: typeof Handle_TDataStd_DeltaOnModificationOfIntPackedMap_1;
  Handle_TDataStd_DeltaOnModificationOfIntPackedMap_2: typeof Handle_TDataStd_DeltaOnModificationOfIntPackedMap_2;
  Handle_TDataStd_DeltaOnModificationOfIntPackedMap_3: typeof Handle_TDataStd_DeltaOnModificationOfIntPackedMap_3;
  Handle_TDataStd_DeltaOnModificationOfIntPackedMap_4: typeof Handle_TDataStd_DeltaOnModificationOfIntPackedMap_4;
  TDataStd_DeltaOnModificationOfIntPackedMap: typeof TDataStd_DeltaOnModificationOfIntPackedMap;
  TDataStd_BooleanArray: typeof TDataStd_BooleanArray;
  Handle_TDataStd_BooleanArray: typeof Handle_TDataStd_BooleanArray;
  Handle_TDataStd_BooleanArray_1: typeof Handle_TDataStd_BooleanArray_1;
  Handle_TDataStd_BooleanArray_2: typeof Handle_TDataStd_BooleanArray_2;
  Handle_TDataStd_BooleanArray_3: typeof Handle_TDataStd_BooleanArray_3;
  Handle_TDataStd_BooleanArray_4: typeof Handle_TDataStd_BooleanArray_4;
  TDataStd_IntPackedMap: typeof TDataStd_IntPackedMap;
  Handle_TDataStd_IntPackedMap: typeof Handle_TDataStd_IntPackedMap;
  Handle_TDataStd_IntPackedMap_1: typeof Handle_TDataStd_IntPackedMap_1;
  Handle_TDataStd_IntPackedMap_2: typeof Handle_TDataStd_IntPackedMap_2;
  Handle_TDataStd_IntPackedMap_3: typeof Handle_TDataStd_IntPackedMap_3;
  Handle_TDataStd_IntPackedMap_4: typeof Handle_TDataStd_IntPackedMap_4;
  Handle_TDataStd_HDataMapOfStringInteger: typeof Handle_TDataStd_HDataMapOfStringInteger;
  Handle_TDataStd_HDataMapOfStringInteger_1: typeof Handle_TDataStd_HDataMapOfStringInteger_1;
  Handle_TDataStd_HDataMapOfStringInteger_2: typeof Handle_TDataStd_HDataMapOfStringInteger_2;
  Handle_TDataStd_HDataMapOfStringInteger_3: typeof Handle_TDataStd_HDataMapOfStringInteger_3;
  Handle_TDataStd_HDataMapOfStringInteger_4: typeof Handle_TDataStd_HDataMapOfStringInteger_4;
  TDataStd_HDataMapOfStringInteger: typeof TDataStd_HDataMapOfStringInteger;
  TDataStd_HDataMapOfStringInteger_1: typeof TDataStd_HDataMapOfStringInteger_1;
  TDataStd_HDataMapOfStringInteger_2: typeof TDataStd_HDataMapOfStringInteger_2;
  Handle_TDataStd_ByteArray: typeof Handle_TDataStd_ByteArray;
  Handle_TDataStd_ByteArray_1: typeof Handle_TDataStd_ByteArray_1;
  Handle_TDataStd_ByteArray_2: typeof Handle_TDataStd_ByteArray_2;
  Handle_TDataStd_ByteArray_3: typeof Handle_TDataStd_ByteArray_3;
  Handle_TDataStd_ByteArray_4: typeof Handle_TDataStd_ByteArray_4;
  TDataStd_ByteArray: typeof TDataStd_ByteArray;
  Handle_TDataStd_BooleanList: typeof Handle_TDataStd_BooleanList;
  Handle_TDataStd_BooleanList_1: typeof Handle_TDataStd_BooleanList_1;
  Handle_TDataStd_BooleanList_2: typeof Handle_TDataStd_BooleanList_2;
  Handle_TDataStd_BooleanList_3: typeof Handle_TDataStd_BooleanList_3;
  Handle_TDataStd_BooleanList_4: typeof Handle_TDataStd_BooleanList_4;
  TDataStd_BooleanList: typeof TDataStd_BooleanList;
  TDataStd_RealList: typeof TDataStd_RealList;
  Handle_TDataStd_RealList: typeof Handle_TDataStd_RealList;
  Handle_TDataStd_RealList_1: typeof Handle_TDataStd_RealList_1;
  Handle_TDataStd_RealList_2: typeof Handle_TDataStd_RealList_2;
  Handle_TDataStd_RealList_3: typeof Handle_TDataStd_RealList_3;
  Handle_TDataStd_RealList_4: typeof Handle_TDataStd_RealList_4;
  TDataStd_DeltaOnModificationOfIntArray: typeof TDataStd_DeltaOnModificationOfIntArray;
  Handle_TDataStd_DeltaOnModificationOfIntArray: typeof Handle_TDataStd_DeltaOnModificationOfIntArray;
  Handle_TDataStd_DeltaOnModificationOfIntArray_1: typeof Handle_TDataStd_DeltaOnModificationOfIntArray_1;
  Handle_TDataStd_DeltaOnModificationOfIntArray_2: typeof Handle_TDataStd_DeltaOnModificationOfIntArray_2;
  Handle_TDataStd_DeltaOnModificationOfIntArray_3: typeof Handle_TDataStd_DeltaOnModificationOfIntArray_3;
  Handle_TDataStd_DeltaOnModificationOfIntArray_4: typeof Handle_TDataStd_DeltaOnModificationOfIntArray_4;
  TDataStd_RealEnum: TDataStd_RealEnum;
  Handle_TDataStd_Real: typeof Handle_TDataStd_Real;
  Handle_TDataStd_Real_1: typeof Handle_TDataStd_Real_1;
  Handle_TDataStd_Real_2: typeof Handle_TDataStd_Real_2;
  Handle_TDataStd_Real_3: typeof Handle_TDataStd_Real_3;
  Handle_TDataStd_Real_4: typeof Handle_TDataStd_Real_4;
  TDataStd_Real: typeof TDataStd_Real;
  Handle_StepAP203_HArray1OfCertifiedItem: typeof Handle_StepAP203_HArray1OfCertifiedItem;
  Handle_StepAP203_HArray1OfCertifiedItem_1: typeof Handle_StepAP203_HArray1OfCertifiedItem_1;
  Handle_StepAP203_HArray1OfCertifiedItem_2: typeof Handle_StepAP203_HArray1OfCertifiedItem_2;
  Handle_StepAP203_HArray1OfCertifiedItem_3: typeof Handle_StepAP203_HArray1OfCertifiedItem_3;
  Handle_StepAP203_HArray1OfCertifiedItem_4: typeof Handle_StepAP203_HArray1OfCertifiedItem_4;
  Handle_StepAP203_ChangeRequest: typeof Handle_StepAP203_ChangeRequest;
  Handle_StepAP203_ChangeRequest_1: typeof Handle_StepAP203_ChangeRequest_1;
  Handle_StepAP203_ChangeRequest_2: typeof Handle_StepAP203_ChangeRequest_2;
  Handle_StepAP203_ChangeRequest_3: typeof Handle_StepAP203_ChangeRequest_3;
  Handle_StepAP203_ChangeRequest_4: typeof Handle_StepAP203_ChangeRequest_4;
  StepAP203_ChangeRequest: typeof StepAP203_ChangeRequest;
  Handle_StepAP203_CcDesignSecurityClassification: typeof Handle_StepAP203_CcDesignSecurityClassification;
  Handle_StepAP203_CcDesignSecurityClassification_1: typeof Handle_StepAP203_CcDesignSecurityClassification_1;
  Handle_StepAP203_CcDesignSecurityClassification_2: typeof Handle_StepAP203_CcDesignSecurityClassification_2;
  Handle_StepAP203_CcDesignSecurityClassification_3: typeof Handle_StepAP203_CcDesignSecurityClassification_3;
  Handle_StepAP203_CcDesignSecurityClassification_4: typeof Handle_StepAP203_CcDesignSecurityClassification_4;
  StepAP203_CcDesignSecurityClassification: typeof StepAP203_CcDesignSecurityClassification;
  Handle_StepAP203_CcDesignSpecificationReference: typeof Handle_StepAP203_CcDesignSpecificationReference;
  Handle_StepAP203_CcDesignSpecificationReference_1: typeof Handle_StepAP203_CcDesignSpecificationReference_1;
  Handle_StepAP203_CcDesignSpecificationReference_2: typeof Handle_StepAP203_CcDesignSpecificationReference_2;
  Handle_StepAP203_CcDesignSpecificationReference_3: typeof Handle_StepAP203_CcDesignSpecificationReference_3;
  Handle_StepAP203_CcDesignSpecificationReference_4: typeof Handle_StepAP203_CcDesignSpecificationReference_4;
  StepAP203_CcDesignSpecificationReference: typeof StepAP203_CcDesignSpecificationReference;
  StepAP203_Array1OfWorkItem: typeof StepAP203_Array1OfWorkItem;
  StepAP203_Array1OfWorkItem_1: typeof StepAP203_Array1OfWorkItem_1;
  StepAP203_Array1OfWorkItem_2: typeof StepAP203_Array1OfWorkItem_2;
  StepAP203_Array1OfWorkItem_3: typeof StepAP203_Array1OfWorkItem_3;
  StepAP203_Array1OfWorkItem_4: typeof StepAP203_Array1OfWorkItem_4;
  StepAP203_Array1OfWorkItem_5: typeof StepAP203_Array1OfWorkItem_5;
  StepAP203_Array1OfCertifiedItem: typeof StepAP203_Array1OfCertifiedItem;
  StepAP203_Array1OfCertifiedItem_1: typeof StepAP203_Array1OfCertifiedItem_1;
  StepAP203_Array1OfCertifiedItem_2: typeof StepAP203_Array1OfCertifiedItem_2;
  StepAP203_Array1OfCertifiedItem_3: typeof StepAP203_Array1OfCertifiedItem_3;
  StepAP203_Array1OfCertifiedItem_4: typeof StepAP203_Array1OfCertifiedItem_4;
  StepAP203_Array1OfCertifiedItem_5: typeof StepAP203_Array1OfCertifiedItem_5;
  StepAP203_StartWork: typeof StepAP203_StartWork;
  Handle_StepAP203_StartWork: typeof Handle_StepAP203_StartWork;
  Handle_StepAP203_StartWork_1: typeof Handle_StepAP203_StartWork_1;
  Handle_StepAP203_StartWork_2: typeof Handle_StepAP203_StartWork_2;
  Handle_StepAP203_StartWork_3: typeof Handle_StepAP203_StartWork_3;
  Handle_StepAP203_StartWork_4: typeof Handle_StepAP203_StartWork_4;
  Handle_StepAP203_CcDesignDateAndTimeAssignment: typeof Handle_StepAP203_CcDesignDateAndTimeAssignment;
  Handle_StepAP203_CcDesignDateAndTimeAssignment_1: typeof Handle_StepAP203_CcDesignDateAndTimeAssignment_1;
  Handle_StepAP203_CcDesignDateAndTimeAssignment_2: typeof Handle_StepAP203_CcDesignDateAndTimeAssignment_2;
  Handle_StepAP203_CcDesignDateAndTimeAssignment_3: typeof Handle_StepAP203_CcDesignDateAndTimeAssignment_3;
  Handle_StepAP203_CcDesignDateAndTimeAssignment_4: typeof Handle_StepAP203_CcDesignDateAndTimeAssignment_4;
  StepAP203_CcDesignDateAndTimeAssignment: typeof StepAP203_CcDesignDateAndTimeAssignment;
  StepAP203_Array1OfStartRequestItem: typeof StepAP203_Array1OfStartRequestItem;
  StepAP203_Array1OfStartRequestItem_1: typeof StepAP203_Array1OfStartRequestItem_1;
  StepAP203_Array1OfStartRequestItem_2: typeof StepAP203_Array1OfStartRequestItem_2;
  StepAP203_Array1OfStartRequestItem_3: typeof StepAP203_Array1OfStartRequestItem_3;
  StepAP203_Array1OfStartRequestItem_4: typeof StepAP203_Array1OfStartRequestItem_4;
  StepAP203_Array1OfStartRequestItem_5: typeof StepAP203_Array1OfStartRequestItem_5;
  Handle_StepAP203_HArray1OfChangeRequestItem: typeof Handle_StepAP203_HArray1OfChangeRequestItem;
  Handle_StepAP203_HArray1OfChangeRequestItem_1: typeof Handle_StepAP203_HArray1OfChangeRequestItem_1;
  Handle_StepAP203_HArray1OfChangeRequestItem_2: typeof Handle_StepAP203_HArray1OfChangeRequestItem_2;
  Handle_StepAP203_HArray1OfChangeRequestItem_3: typeof Handle_StepAP203_HArray1OfChangeRequestItem_3;
  Handle_StepAP203_HArray1OfChangeRequestItem_4: typeof Handle_StepAP203_HArray1OfChangeRequestItem_4;
  StepAP203_DateTimeItem: typeof StepAP203_DateTimeItem;
  Handle_StepAP203_StartRequest: typeof Handle_StepAP203_StartRequest;
  Handle_StepAP203_StartRequest_1: typeof Handle_StepAP203_StartRequest_1;
  Handle_StepAP203_StartRequest_2: typeof Handle_StepAP203_StartRequest_2;
  Handle_StepAP203_StartRequest_3: typeof Handle_StepAP203_StartRequest_3;
  Handle_StepAP203_StartRequest_4: typeof Handle_StepAP203_StartRequest_4;
  StepAP203_StartRequest: typeof StepAP203_StartRequest;
  StepAP203_Array1OfClassifiedItem: typeof StepAP203_Array1OfClassifiedItem;
  StepAP203_Array1OfClassifiedItem_1: typeof StepAP203_Array1OfClassifiedItem_1;
  StepAP203_Array1OfClassifiedItem_2: typeof StepAP203_Array1OfClassifiedItem_2;
  StepAP203_Array1OfClassifiedItem_3: typeof StepAP203_Array1OfClassifiedItem_3;
  StepAP203_Array1OfClassifiedItem_4: typeof StepAP203_Array1OfClassifiedItem_4;
  StepAP203_Array1OfClassifiedItem_5: typeof StepAP203_Array1OfClassifiedItem_5;
  StepAP203_CertifiedItem: typeof StepAP203_CertifiedItem;
  Handle_StepAP203_HArray1OfDateTimeItem: typeof Handle_StepAP203_HArray1OfDateTimeItem;
  Handle_StepAP203_HArray1OfDateTimeItem_1: typeof Handle_StepAP203_HArray1OfDateTimeItem_1;
  Handle_StepAP203_HArray1OfDateTimeItem_2: typeof Handle_StepAP203_HArray1OfDateTimeItem_2;
  Handle_StepAP203_HArray1OfDateTimeItem_3: typeof Handle_StepAP203_HArray1OfDateTimeItem_3;
  Handle_StepAP203_HArray1OfDateTimeItem_4: typeof Handle_StepAP203_HArray1OfDateTimeItem_4;
  StepAP203_ClassifiedItem: typeof StepAP203_ClassifiedItem;
  StepAP203_Array1OfContractedItem: typeof StepAP203_Array1OfContractedItem;
  StepAP203_Array1OfContractedItem_1: typeof StepAP203_Array1OfContractedItem_1;
  StepAP203_Array1OfContractedItem_2: typeof StepAP203_Array1OfContractedItem_2;
  StepAP203_Array1OfContractedItem_3: typeof StepAP203_Array1OfContractedItem_3;
  StepAP203_Array1OfContractedItem_4: typeof StepAP203_Array1OfContractedItem_4;
  StepAP203_Array1OfContractedItem_5: typeof StepAP203_Array1OfContractedItem_5;
  StepAP203_PersonOrganizationItem: typeof StepAP203_PersonOrganizationItem;
  Handle_StepAP203_HArray1OfStartRequestItem: typeof Handle_StepAP203_HArray1OfStartRequestItem;
  Handle_StepAP203_HArray1OfStartRequestItem_1: typeof Handle_StepAP203_HArray1OfStartRequestItem_1;
  Handle_StepAP203_HArray1OfStartRequestItem_2: typeof Handle_StepAP203_HArray1OfStartRequestItem_2;
  Handle_StepAP203_HArray1OfStartRequestItem_3: typeof Handle_StepAP203_HArray1OfStartRequestItem_3;
  Handle_StepAP203_HArray1OfStartRequestItem_4: typeof Handle_StepAP203_HArray1OfStartRequestItem_4;
  StepAP203_Array1OfChangeRequestItem: typeof StepAP203_Array1OfChangeRequestItem;
  StepAP203_Array1OfChangeRequestItem_1: typeof StepAP203_Array1OfChangeRequestItem_1;
  StepAP203_Array1OfChangeRequestItem_2: typeof StepAP203_Array1OfChangeRequestItem_2;
  StepAP203_Array1OfChangeRequestItem_3: typeof StepAP203_Array1OfChangeRequestItem_3;
  StepAP203_Array1OfChangeRequestItem_4: typeof StepAP203_Array1OfChangeRequestItem_4;
  StepAP203_Array1OfChangeRequestItem_5: typeof StepAP203_Array1OfChangeRequestItem_5;
  StepAP203_Change: typeof StepAP203_Change;
  Handle_StepAP203_Change: typeof Handle_StepAP203_Change;
  Handle_StepAP203_Change_1: typeof Handle_StepAP203_Change_1;
  Handle_StepAP203_Change_2: typeof Handle_StepAP203_Change_2;
  Handle_StepAP203_Change_3: typeof Handle_StepAP203_Change_3;
  Handle_StepAP203_Change_4: typeof Handle_StepAP203_Change_4;
  Handle_StepAP203_HArray1OfPersonOrganizationItem: typeof Handle_StepAP203_HArray1OfPersonOrganizationItem;
  Handle_StepAP203_HArray1OfPersonOrganizationItem_1: typeof Handle_StepAP203_HArray1OfPersonOrganizationItem_1;
  Handle_StepAP203_HArray1OfPersonOrganizationItem_2: typeof Handle_StepAP203_HArray1OfPersonOrganizationItem_2;
  Handle_StepAP203_HArray1OfPersonOrganizationItem_3: typeof Handle_StepAP203_HArray1OfPersonOrganizationItem_3;
  Handle_StepAP203_HArray1OfPersonOrganizationItem_4: typeof Handle_StepAP203_HArray1OfPersonOrganizationItem_4;
  StepAP203_SpecifiedItem: typeof StepAP203_SpecifiedItem;
  StepAP203_Array1OfSpecifiedItem: typeof StepAP203_Array1OfSpecifiedItem;
  StepAP203_Array1OfSpecifiedItem_1: typeof StepAP203_Array1OfSpecifiedItem_1;
  StepAP203_Array1OfSpecifiedItem_2: typeof StepAP203_Array1OfSpecifiedItem_2;
  StepAP203_Array1OfSpecifiedItem_3: typeof StepAP203_Array1OfSpecifiedItem_3;
  StepAP203_Array1OfSpecifiedItem_4: typeof StepAP203_Array1OfSpecifiedItem_4;
  StepAP203_Array1OfSpecifiedItem_5: typeof StepAP203_Array1OfSpecifiedItem_5;
  Handle_StepAP203_HArray1OfSpecifiedItem: typeof Handle_StepAP203_HArray1OfSpecifiedItem;
  Handle_StepAP203_HArray1OfSpecifiedItem_1: typeof Handle_StepAP203_HArray1OfSpecifiedItem_1;
  Handle_StepAP203_HArray1OfSpecifiedItem_2: typeof Handle_StepAP203_HArray1OfSpecifiedItem_2;
  Handle_StepAP203_HArray1OfSpecifiedItem_3: typeof Handle_StepAP203_HArray1OfSpecifiedItem_3;
  Handle_StepAP203_HArray1OfSpecifiedItem_4: typeof Handle_StepAP203_HArray1OfSpecifiedItem_4;
  Handle_StepAP203_HArray1OfContractedItem: typeof Handle_StepAP203_HArray1OfContractedItem;
  Handle_StepAP203_HArray1OfContractedItem_1: typeof Handle_StepAP203_HArray1OfContractedItem_1;
  Handle_StepAP203_HArray1OfContractedItem_2: typeof Handle_StepAP203_HArray1OfContractedItem_2;
  Handle_StepAP203_HArray1OfContractedItem_3: typeof Handle_StepAP203_HArray1OfContractedItem_3;
  Handle_StepAP203_HArray1OfContractedItem_4: typeof Handle_StepAP203_HArray1OfContractedItem_4;
  Handle_StepAP203_HArray1OfApprovedItem: typeof Handle_StepAP203_HArray1OfApprovedItem;
  Handle_StepAP203_HArray1OfApprovedItem_1: typeof Handle_StepAP203_HArray1OfApprovedItem_1;
  Handle_StepAP203_HArray1OfApprovedItem_2: typeof Handle_StepAP203_HArray1OfApprovedItem_2;
  Handle_StepAP203_HArray1OfApprovedItem_3: typeof Handle_StepAP203_HArray1OfApprovedItem_3;
  Handle_StepAP203_HArray1OfApprovedItem_4: typeof Handle_StepAP203_HArray1OfApprovedItem_4;
  StepAP203_ChangeRequestItem: typeof StepAP203_ChangeRequestItem;
  Handle_StepAP203_HArray1OfWorkItem: typeof Handle_StepAP203_HArray1OfWorkItem;
  Handle_StepAP203_HArray1OfWorkItem_1: typeof Handle_StepAP203_HArray1OfWorkItem_1;
  Handle_StepAP203_HArray1OfWorkItem_2: typeof Handle_StepAP203_HArray1OfWorkItem_2;
  Handle_StepAP203_HArray1OfWorkItem_3: typeof Handle_StepAP203_HArray1OfWorkItem_3;
  Handle_StepAP203_HArray1OfWorkItem_4: typeof Handle_StepAP203_HArray1OfWorkItem_4;
  StepAP203_Array1OfDateTimeItem: typeof StepAP203_Array1OfDateTimeItem;
  StepAP203_Array1OfDateTimeItem_1: typeof StepAP203_Array1OfDateTimeItem_1;
  StepAP203_Array1OfDateTimeItem_2: typeof StepAP203_Array1OfDateTimeItem_2;
  StepAP203_Array1OfDateTimeItem_3: typeof StepAP203_Array1OfDateTimeItem_3;
  StepAP203_Array1OfDateTimeItem_4: typeof StepAP203_Array1OfDateTimeItem_4;
  StepAP203_Array1OfDateTimeItem_5: typeof StepAP203_Array1OfDateTimeItem_5;
  StepAP203_StartRequestItem: typeof StepAP203_StartRequestItem;
  StepAP203_ContractedItem: typeof StepAP203_ContractedItem;
  Handle_StepAP203_CcDesignApproval: typeof Handle_StepAP203_CcDesignApproval;
  Handle_StepAP203_CcDesignApproval_1: typeof Handle_StepAP203_CcDesignApproval_1;
  Handle_StepAP203_CcDesignApproval_2: typeof Handle_StepAP203_CcDesignApproval_2;
  Handle_StepAP203_CcDesignApproval_3: typeof Handle_StepAP203_CcDesignApproval_3;
  Handle_StepAP203_CcDesignApproval_4: typeof Handle_StepAP203_CcDesignApproval_4;
  StepAP203_CcDesignApproval: typeof StepAP203_CcDesignApproval;
  StepAP203_WorkItem: typeof StepAP203_WorkItem;
  StepAP203_Array1OfPersonOrganizationItem: typeof StepAP203_Array1OfPersonOrganizationItem;
  StepAP203_Array1OfPersonOrganizationItem_1: typeof StepAP203_Array1OfPersonOrganizationItem_1;
  StepAP203_Array1OfPersonOrganizationItem_2: typeof StepAP203_Array1OfPersonOrganizationItem_2;
  StepAP203_Array1OfPersonOrganizationItem_3: typeof StepAP203_Array1OfPersonOrganizationItem_3;
  StepAP203_Array1OfPersonOrganizationItem_4: typeof StepAP203_Array1OfPersonOrganizationItem_4;
  StepAP203_Array1OfPersonOrganizationItem_5: typeof StepAP203_Array1OfPersonOrganizationItem_5;
  Handle_StepAP203_HArray1OfClassifiedItem: typeof Handle_StepAP203_HArray1OfClassifiedItem;
  Handle_StepAP203_HArray1OfClassifiedItem_1: typeof Handle_StepAP203_HArray1OfClassifiedItem_1;
  Handle_StepAP203_HArray1OfClassifiedItem_2: typeof Handle_StepAP203_HArray1OfClassifiedItem_2;
  Handle_StepAP203_HArray1OfClassifiedItem_3: typeof Handle_StepAP203_HArray1OfClassifiedItem_3;
  Handle_StepAP203_HArray1OfClassifiedItem_4: typeof Handle_StepAP203_HArray1OfClassifiedItem_4;
  StepAP203_Array1OfApprovedItem: typeof StepAP203_Array1OfApprovedItem;
  StepAP203_Array1OfApprovedItem_1: typeof StepAP203_Array1OfApprovedItem_1;
  StepAP203_Array1OfApprovedItem_2: typeof StepAP203_Array1OfApprovedItem_2;
  StepAP203_Array1OfApprovedItem_3: typeof StepAP203_Array1OfApprovedItem_3;
  StepAP203_Array1OfApprovedItem_4: typeof StepAP203_Array1OfApprovedItem_4;
  StepAP203_Array1OfApprovedItem_5: typeof StepAP203_Array1OfApprovedItem_5;
  StepAP203_ApprovedItem: typeof StepAP203_ApprovedItem;
  StepAP203_CcDesignCertification: typeof StepAP203_CcDesignCertification;
  Handle_StepAP203_CcDesignCertification: typeof Handle_StepAP203_CcDesignCertification;
  Handle_StepAP203_CcDesignCertification_1: typeof Handle_StepAP203_CcDesignCertification_1;
  Handle_StepAP203_CcDesignCertification_2: typeof Handle_StepAP203_CcDesignCertification_2;
  Handle_StepAP203_CcDesignCertification_3: typeof Handle_StepAP203_CcDesignCertification_3;
  Handle_StepAP203_CcDesignCertification_4: typeof Handle_StepAP203_CcDesignCertification_4;
  StepAP203_CcDesignContract: typeof StepAP203_CcDesignContract;
  Handle_StepAP203_CcDesignContract: typeof Handle_StepAP203_CcDesignContract;
  Handle_StepAP203_CcDesignContract_1: typeof Handle_StepAP203_CcDesignContract_1;
  Handle_StepAP203_CcDesignContract_2: typeof Handle_StepAP203_CcDesignContract_2;
  Handle_StepAP203_CcDesignContract_3: typeof Handle_StepAP203_CcDesignContract_3;
  Handle_StepAP203_CcDesignContract_4: typeof Handle_StepAP203_CcDesignContract_4;
  Handle_StepAP203_CcDesignPersonAndOrganizationAssignment: typeof Handle_StepAP203_CcDesignPersonAndOrganizationAssignment;
  Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_1: typeof Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_1;
  Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_2: typeof Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_2;
  Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_3: typeof Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_3;
  Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_4: typeof Handle_StepAP203_CcDesignPersonAndOrganizationAssignment_4;
  StepAP203_CcDesignPersonAndOrganizationAssignment: typeof StepAP203_CcDesignPersonAndOrganizationAssignment;
  BRepAdaptor_HCurve2d: typeof BRepAdaptor_HCurve2d;
  BRepAdaptor_HCurve2d_1: typeof BRepAdaptor_HCurve2d_1;
  BRepAdaptor_HCurve2d_2: typeof BRepAdaptor_HCurve2d_2;
  Handle_BRepAdaptor_HCurve2d: typeof Handle_BRepAdaptor_HCurve2d;
  Handle_BRepAdaptor_HCurve2d_1: typeof Handle_BRepAdaptor_HCurve2d_1;
  Handle_BRepAdaptor_HCurve2d_2: typeof Handle_BRepAdaptor_HCurve2d_2;
  Handle_BRepAdaptor_HCurve2d_3: typeof Handle_BRepAdaptor_HCurve2d_3;
  Handle_BRepAdaptor_HCurve2d_4: typeof Handle_BRepAdaptor_HCurve2d_4;
  BRepAdaptor_HCurve: typeof BRepAdaptor_HCurve;
  BRepAdaptor_HCurve_1: typeof BRepAdaptor_HCurve_1;
  BRepAdaptor_HCurve_2: typeof BRepAdaptor_HCurve_2;
  Handle_BRepAdaptor_HCurve: typeof Handle_BRepAdaptor_HCurve;
  Handle_BRepAdaptor_HCurve_1: typeof Handle_BRepAdaptor_HCurve_1;
  Handle_BRepAdaptor_HCurve_2: typeof Handle_BRepAdaptor_HCurve_2;
  Handle_BRepAdaptor_HCurve_3: typeof Handle_BRepAdaptor_HCurve_3;
  Handle_BRepAdaptor_HCurve_4: typeof Handle_BRepAdaptor_HCurve_4;
  BRepAdaptor_Curve2d: typeof BRepAdaptor_Curve2d;
  BRepAdaptor_Curve2d_1: typeof BRepAdaptor_Curve2d_1;
  BRepAdaptor_Curve2d_2: typeof BRepAdaptor_Curve2d_2;
  BRepAdaptor_Curve: typeof BRepAdaptor_Curve;
  BRepAdaptor_Curve_1: typeof BRepAdaptor_Curve_1;
  BRepAdaptor_Curve_2: typeof BRepAdaptor_Curve_2;
  BRepAdaptor_Curve_3: typeof BRepAdaptor_Curve_3;
  BRepAdaptor_Array1OfCurve: typeof BRepAdaptor_Array1OfCurve;
  BRepAdaptor_Array1OfCurve_1: typeof BRepAdaptor_Array1OfCurve_1;
  BRepAdaptor_Array1OfCurve_2: typeof BRepAdaptor_Array1OfCurve_2;
  BRepAdaptor_Array1OfCurve_3: typeof BRepAdaptor_Array1OfCurve_3;
  BRepAdaptor_Array1OfCurve_4: typeof BRepAdaptor_Array1OfCurve_4;
  BRepAdaptor_Array1OfCurve_5: typeof BRepAdaptor_Array1OfCurve_5;
  Handle_BRepAdaptor_HArray1OfCurve: typeof Handle_BRepAdaptor_HArray1OfCurve;
  Handle_BRepAdaptor_HArray1OfCurve_1: typeof Handle_BRepAdaptor_HArray1OfCurve_1;
  Handle_BRepAdaptor_HArray1OfCurve_2: typeof Handle_BRepAdaptor_HArray1OfCurve_2;
  Handle_BRepAdaptor_HArray1OfCurve_3: typeof Handle_BRepAdaptor_HArray1OfCurve_3;
  Handle_BRepAdaptor_HArray1OfCurve_4: typeof Handle_BRepAdaptor_HArray1OfCurve_4;
  BRepAdaptor_CompCurve: typeof BRepAdaptor_CompCurve;
  BRepAdaptor_CompCurve_1: typeof BRepAdaptor_CompCurve_1;
  BRepAdaptor_CompCurve_2: typeof BRepAdaptor_CompCurve_2;
  BRepAdaptor_CompCurve_3: typeof BRepAdaptor_CompCurve_3;
  BRepAdaptor_Surface: typeof BRepAdaptor_Surface;
  BRepAdaptor_Surface_1: typeof BRepAdaptor_Surface_1;
  BRepAdaptor_Surface_2: typeof BRepAdaptor_Surface_2;
  Handle_BRepAdaptor_HSurface: typeof Handle_BRepAdaptor_HSurface;
  Handle_BRepAdaptor_HSurface_1: typeof Handle_BRepAdaptor_HSurface_1;
  Handle_BRepAdaptor_HSurface_2: typeof Handle_BRepAdaptor_HSurface_2;
  Handle_BRepAdaptor_HSurface_3: typeof Handle_BRepAdaptor_HSurface_3;
  Handle_BRepAdaptor_HSurface_4: typeof Handle_BRepAdaptor_HSurface_4;
  BRepAdaptor_HSurface: typeof BRepAdaptor_HSurface;
  BRepAdaptor_HSurface_1: typeof BRepAdaptor_HSurface_1;
  BRepAdaptor_HSurface_2: typeof BRepAdaptor_HSurface_2;
  BRepAdaptor_HCompCurve: typeof BRepAdaptor_HCompCurve;
  BRepAdaptor_HCompCurve_1: typeof BRepAdaptor_HCompCurve_1;
  BRepAdaptor_HCompCurve_2: typeof BRepAdaptor_HCompCurve_2;
  Handle_BRepAdaptor_HCompCurve: typeof Handle_BRepAdaptor_HCompCurve;
  Handle_BRepAdaptor_HCompCurve_1: typeof Handle_BRepAdaptor_HCompCurve_1;
  Handle_BRepAdaptor_HCompCurve_2: typeof Handle_BRepAdaptor_HCompCurve_2;
  Handle_BRepAdaptor_HCompCurve_3: typeof Handle_BRepAdaptor_HCompCurve_3;
  Handle_BRepAdaptor_HCompCurve_4: typeof Handle_BRepAdaptor_HCompCurve_4;
  TDF_CopyTool: typeof TDF_CopyTool;
  TDF_Delta: typeof TDF_Delta;
  Handle_TDF_Delta: typeof Handle_TDF_Delta;
  Handle_TDF_Delta_1: typeof Handle_TDF_Delta_1;
  Handle_TDF_Delta_2: typeof Handle_TDF_Delta_2;
  Handle_TDF_Delta_3: typeof Handle_TDF_Delta_3;
  Handle_TDF_Delta_4: typeof Handle_TDF_Delta_4;
  TDF_DefaultDeltaOnRemoval: typeof TDF_DefaultDeltaOnRemoval;
  Handle_TDF_DefaultDeltaOnRemoval: typeof Handle_TDF_DefaultDeltaOnRemoval;
  Handle_TDF_DefaultDeltaOnRemoval_1: typeof Handle_TDF_DefaultDeltaOnRemoval_1;
  Handle_TDF_DefaultDeltaOnRemoval_2: typeof Handle_TDF_DefaultDeltaOnRemoval_2;
  Handle_TDF_DefaultDeltaOnRemoval_3: typeof Handle_TDF_DefaultDeltaOnRemoval_3;
  Handle_TDF_DefaultDeltaOnRemoval_4: typeof Handle_TDF_DefaultDeltaOnRemoval_4;
  TDF_AttributeIterator: typeof TDF_AttributeIterator;
  TDF_AttributeIterator_1: typeof TDF_AttributeIterator_1;
  TDF_AttributeIterator_2: typeof TDF_AttributeIterator_2;
  TDF_AttributeIterator_3: typeof TDF_AttributeIterator_3;
  TDF_ClosureTool: typeof TDF_ClosureTool;
  TDF_DeltaOnModification: typeof TDF_DeltaOnModification;
  Handle_TDF_DeltaOnModification: typeof Handle_TDF_DeltaOnModification;
  Handle_TDF_DeltaOnModification_1: typeof Handle_TDF_DeltaOnModification_1;
  Handle_TDF_DeltaOnModification_2: typeof Handle_TDF_DeltaOnModification_2;
  Handle_TDF_DeltaOnModification_3: typeof Handle_TDF_DeltaOnModification_3;
  Handle_TDF_DeltaOnModification_4: typeof Handle_TDF_DeltaOnModification_4;
  TDF_Data: typeof TDF_Data;
  Handle_TDF_Data: typeof Handle_TDF_Data;
  Handle_TDF_Data_1: typeof Handle_TDF_Data_1;
  Handle_TDF_Data_2: typeof Handle_TDF_Data_2;
  Handle_TDF_Data_3: typeof Handle_TDF_Data_3;
  Handle_TDF_Data_4: typeof Handle_TDF_Data_4;
  Handle_TDF_DeltaOnRemoval: typeof Handle_TDF_DeltaOnRemoval;
  Handle_TDF_DeltaOnRemoval_1: typeof Handle_TDF_DeltaOnRemoval_1;
  Handle_TDF_DeltaOnRemoval_2: typeof Handle_TDF_DeltaOnRemoval_2;
  Handle_TDF_DeltaOnRemoval_3: typeof Handle_TDF_DeltaOnRemoval_3;
  Handle_TDF_DeltaOnRemoval_4: typeof Handle_TDF_DeltaOnRemoval_4;
  TDF_DeltaOnRemoval: typeof TDF_DeltaOnRemoval;
  TDF_ChildIDIterator: typeof TDF_ChildIDIterator;
  TDF_ChildIDIterator_1: typeof TDF_ChildIDIterator_1;
  TDF_ChildIDIterator_2: typeof TDF_ChildIDIterator_2;
  TDF_GUIDProgIDMap: typeof TDF_GUIDProgIDMap;
  TDF_GUIDProgIDMap_1: typeof TDF_GUIDProgIDMap_1;
  TDF_GUIDProgIDMap_2: typeof TDF_GUIDProgIDMap_2;
  TDF_GUIDProgIDMap_3: typeof TDF_GUIDProgIDMap_3;
  Handle_TDF_DefaultDeltaOnModification: typeof Handle_TDF_DefaultDeltaOnModification;
  Handle_TDF_DefaultDeltaOnModification_1: typeof Handle_TDF_DefaultDeltaOnModification_1;
  Handle_TDF_DefaultDeltaOnModification_2: typeof Handle_TDF_DefaultDeltaOnModification_2;
  Handle_TDF_DefaultDeltaOnModification_3: typeof Handle_TDF_DefaultDeltaOnModification_3;
  Handle_TDF_DefaultDeltaOnModification_4: typeof Handle_TDF_DefaultDeltaOnModification_4;
  TDF_DefaultDeltaOnModification: typeof TDF_DefaultDeltaOnModification;
  TDF_LabelIntegerMap: typeof TDF_LabelIntegerMap;
  TDF_LabelIntegerMap_1: typeof TDF_LabelIntegerMap_1;
  TDF_LabelIntegerMap_2: typeof TDF_LabelIntegerMap_2;
  TDF_LabelIntegerMap_3: typeof TDF_LabelIntegerMap_3;
  TDF_CopyLabel: typeof TDF_CopyLabel;
  TDF_CopyLabel_1: typeof TDF_CopyLabel_1;
  TDF_CopyLabel_2: typeof TDF_CopyLabel_2;
  Handle_TDF_RelocationTable: typeof Handle_TDF_RelocationTable;
  Handle_TDF_RelocationTable_1: typeof Handle_TDF_RelocationTable_1;
  Handle_TDF_RelocationTable_2: typeof Handle_TDF_RelocationTable_2;
  Handle_TDF_RelocationTable_3: typeof Handle_TDF_RelocationTable_3;
  Handle_TDF_RelocationTable_4: typeof Handle_TDF_RelocationTable_4;
  TDF_RelocationTable: typeof TDF_RelocationTable;
  TDF_DerivedAttribute: typeof TDF_DerivedAttribute;
  TDF_ClosureMode: typeof TDF_ClosureMode;
  TDF_LabelSequence: typeof TDF_LabelSequence;
  TDF_LabelSequence_1: typeof TDF_LabelSequence_1;
  TDF_LabelSequence_2: typeof TDF_LabelSequence_2;
  TDF_LabelSequence_3: typeof TDF_LabelSequence_3;
  TDF_LabelDataMap: typeof TDF_LabelDataMap;
  TDF_LabelDataMap_1: typeof TDF_LabelDataMap_1;
  TDF_LabelDataMap_2: typeof TDF_LabelDataMap_2;
  TDF_LabelDataMap_3: typeof TDF_LabelDataMap_3;
  TDF_LabelIndexedMap: typeof TDF_LabelIndexedMap;
  TDF_LabelIndexedMap_1: typeof TDF_LabelIndexedMap_1;
  TDF_LabelIndexedMap_2: typeof TDF_LabelIndexedMap_2;
  TDF_LabelIndexedMap_3: typeof TDF_LabelIndexedMap_3;
  TDF_LabelDoubleMap: typeof TDF_LabelDoubleMap;
  TDF_LabelDoubleMap_1: typeof TDF_LabelDoubleMap_1;
  TDF_LabelDoubleMap_2: typeof TDF_LabelDoubleMap_2;
  TDF_LabelDoubleMap_3: typeof TDF_LabelDoubleMap_3;
  Handle_TDF_HAttributeArray1: typeof Handle_TDF_HAttributeArray1;
  Handle_TDF_HAttributeArray1_1: typeof Handle_TDF_HAttributeArray1_1;
  Handle_TDF_HAttributeArray1_2: typeof Handle_TDF_HAttributeArray1_2;
  Handle_TDF_HAttributeArray1_3: typeof Handle_TDF_HAttributeArray1_3;
  Handle_TDF_HAttributeArray1_4: typeof Handle_TDF_HAttributeArray1_4;
  TDF_LabelMapHasher: typeof TDF_LabelMapHasher;
  TDF_DeltaOnForget: typeof TDF_DeltaOnForget;
  Handle_TDF_DeltaOnForget: typeof Handle_TDF_DeltaOnForget;
  Handle_TDF_DeltaOnForget_1: typeof Handle_TDF_DeltaOnForget_1;
  Handle_TDF_DeltaOnForget_2: typeof Handle_TDF_DeltaOnForget_2;
  Handle_TDF_DeltaOnForget_3: typeof Handle_TDF_DeltaOnForget_3;
  Handle_TDF_DeltaOnForget_4: typeof Handle_TDF_DeltaOnForget_4;
  TDF_DeltaOnResume: typeof TDF_DeltaOnResume;
  Handle_TDF_DeltaOnResume: typeof Handle_TDF_DeltaOnResume;
  Handle_TDF_DeltaOnResume_1: typeof Handle_TDF_DeltaOnResume_1;
  Handle_TDF_DeltaOnResume_2: typeof Handle_TDF_DeltaOnResume_2;
  Handle_TDF_DeltaOnResume_3: typeof Handle_TDF_DeltaOnResume_3;
  Handle_TDF_DeltaOnResume_4: typeof Handle_TDF_DeltaOnResume_4;
  TDF_LabelMap: typeof TDF_LabelMap;
  TDF_LabelMap_1: typeof TDF_LabelMap_1;
  TDF_LabelMap_2: typeof TDF_LabelMap_2;
  TDF_LabelMap_3: typeof TDF_LabelMap_3;
  TDF_IDFilter: typeof TDF_IDFilter;
  TDF_AttributeDelta: typeof TDF_AttributeDelta;
  Handle_TDF_AttributeDelta: typeof Handle_TDF_AttributeDelta;
  Handle_TDF_AttributeDelta_1: typeof Handle_TDF_AttributeDelta_1;
  Handle_TDF_AttributeDelta_2: typeof Handle_TDF_AttributeDelta_2;
  Handle_TDF_AttributeDelta_3: typeof Handle_TDF_AttributeDelta_3;
  Handle_TDF_AttributeDelta_4: typeof Handle_TDF_AttributeDelta_4;
  TDF_LabelList: typeof TDF_LabelList;
  TDF_LabelList_1: typeof TDF_LabelList_1;
  TDF_LabelList_2: typeof TDF_LabelList_2;
  TDF_LabelList_3: typeof TDF_LabelList_3;
  TDF_Tool: typeof TDF_Tool;
  TDF_IDMap: typeof TDF_IDMap;
  TDF_IDMap_1: typeof TDF_IDMap_1;
  TDF_IDMap_2: typeof TDF_IDMap_2;
  TDF_IDMap_3: typeof TDF_IDMap_3;
  TDF_Label: typeof TDF_Label;
  TDF_ComparisonTool: typeof TDF_ComparisonTool;
  TDF_IDList: typeof TDF_IDList;
  TDF_IDList_1: typeof TDF_IDList_1;
  TDF_IDList_2: typeof TDF_IDList_2;
  TDF_IDList_3: typeof TDF_IDList_3;
  TDF_Attribute: typeof TDF_Attribute;
  Handle_TDF_Attribute: typeof Handle_TDF_Attribute;
  Handle_TDF_Attribute_1: typeof Handle_TDF_Attribute_1;
  Handle_TDF_Attribute_2: typeof Handle_TDF_Attribute_2;
  Handle_TDF_Attribute_3: typeof Handle_TDF_Attribute_3;
  Handle_TDF_Attribute_4: typeof Handle_TDF_Attribute_4;
  TDF_ChildIterator: typeof TDF_ChildIterator;
  TDF_ChildIterator_1: typeof TDF_ChildIterator_1;
  TDF_ChildIterator_2: typeof TDF_ChildIterator_2;
  Handle_TDF_Reference: typeof Handle_TDF_Reference;
  Handle_TDF_Reference_1: typeof Handle_TDF_Reference_1;
  Handle_TDF_Reference_2: typeof Handle_TDF_Reference_2;
  Handle_TDF_Reference_3: typeof Handle_TDF_Reference_3;
  Handle_TDF_Reference_4: typeof Handle_TDF_Reference_4;
  TDF_Reference: typeof TDF_Reference;
  Handle_TDF_TagSource: typeof Handle_TDF_TagSource;
  Handle_TDF_TagSource_1: typeof Handle_TDF_TagSource_1;
  Handle_TDF_TagSource_2: typeof Handle_TDF_TagSource_2;
  Handle_TDF_TagSource_3: typeof Handle_TDF_TagSource_3;
  Handle_TDF_TagSource_4: typeof Handle_TDF_TagSource_4;
  TDF_TagSource: typeof TDF_TagSource;
  TDF_Transaction: typeof TDF_Transaction;
  TDF_Transaction_1: typeof TDF_Transaction_1;
  TDF_Transaction_2: typeof TDF_Transaction_2;
  TDF: typeof TDF;
  Handle_TDF_DeltaOnAddition: typeof Handle_TDF_DeltaOnAddition;
  Handle_TDF_DeltaOnAddition_1: typeof Handle_TDF_DeltaOnAddition_1;
  Handle_TDF_DeltaOnAddition_2: typeof Handle_TDF_DeltaOnAddition_2;
  Handle_TDF_DeltaOnAddition_3: typeof Handle_TDF_DeltaOnAddition_3;
  Handle_TDF_DeltaOnAddition_4: typeof Handle_TDF_DeltaOnAddition_4;
  TDF_DeltaOnAddition: typeof TDF_DeltaOnAddition;
  TDF_DataSet: typeof TDF_DataSet;
  Handle_TDF_DataSet: typeof Handle_TDF_DataSet;
  Handle_TDF_DataSet_1: typeof Handle_TDF_DataSet_1;
  Handle_TDF_DataSet_2: typeof Handle_TDF_DataSet_2;
  Handle_TDF_DataSet_3: typeof Handle_TDF_DataSet_3;
  Handle_TDF_DataSet_4: typeof Handle_TDF_DataSet_4;
  Poly_MakeLoops: typeof Poly_MakeLoops;
  Poly_MakeLoops3D: typeof Poly_MakeLoops3D;
  Poly_MakeLoops2D: typeof Poly_MakeLoops2D;
  Handle_Poly_PolygonOnTriangulation: typeof Handle_Poly_PolygonOnTriangulation;
  Handle_Poly_PolygonOnTriangulation_1: typeof Handle_Poly_PolygonOnTriangulation_1;
  Handle_Poly_PolygonOnTriangulation_2: typeof Handle_Poly_PolygonOnTriangulation_2;
  Handle_Poly_PolygonOnTriangulation_3: typeof Handle_Poly_PolygonOnTriangulation_3;
  Handle_Poly_PolygonOnTriangulation_4: typeof Handle_Poly_PolygonOnTriangulation_4;
  Poly_PolygonOnTriangulation: typeof Poly_PolygonOnTriangulation;
  Poly_PolygonOnTriangulation_1: typeof Poly_PolygonOnTriangulation_1;
  Poly_PolygonOnTriangulation_2: typeof Poly_PolygonOnTriangulation_2;
  Poly_PolygonOnTriangulation_3: typeof Poly_PolygonOnTriangulation_3;
  Poly_CoherentTriangle: typeof Poly_CoherentTriangle;
  Poly_CoherentTriangle_1: typeof Poly_CoherentTriangle_1;
  Poly_CoherentTriangle_2: typeof Poly_CoherentTriangle_2;
  Poly: typeof Poly;
  Poly_Polygon3D: typeof Poly_Polygon3D;
  Poly_Polygon3D_1: typeof Poly_Polygon3D_1;
  Poly_Polygon3D_2: typeof Poly_Polygon3D_2;
  Poly_Polygon3D_3: typeof Poly_Polygon3D_3;
  Handle_Poly_Polygon3D: typeof Handle_Poly_Polygon3D;
  Handle_Poly_Polygon3D_1: typeof Handle_Poly_Polygon3D_1;
  Handle_Poly_Polygon3D_2: typeof Handle_Poly_Polygon3D_2;
  Handle_Poly_Polygon3D_3: typeof Handle_Poly_Polygon3D_3;
  Handle_Poly_Polygon3D_4: typeof Handle_Poly_Polygon3D_4;
  Poly_CoherentLink: typeof Poly_CoherentLink;
  Poly_CoherentLink_1: typeof Poly_CoherentLink_1;
  Poly_CoherentLink_2: typeof Poly_CoherentLink_2;
  Poly_CoherentLink_3: typeof Poly_CoherentLink_3;
  Poly_Polygon2D: typeof Poly_Polygon2D;
  Poly_Polygon2D_1: typeof Poly_Polygon2D_1;
  Poly_Polygon2D_2: typeof Poly_Polygon2D_2;
  Handle_Poly_Polygon2D: typeof Handle_Poly_Polygon2D;
  Handle_Poly_Polygon2D_1: typeof Handle_Poly_Polygon2D_1;
  Handle_Poly_Polygon2D_2: typeof Handle_Poly_Polygon2D_2;
  Handle_Poly_Polygon2D_3: typeof Handle_Poly_Polygon2D_3;
  Handle_Poly_Polygon2D_4: typeof Handle_Poly_Polygon2D_4;
  Poly_Triangulation: typeof Poly_Triangulation;
  Poly_Triangulation_1: typeof Poly_Triangulation_1;
  Poly_Triangulation_2: typeof Poly_Triangulation_2;
  Poly_Triangulation_3: typeof Poly_Triangulation_3;
  Poly_Triangulation_4: typeof Poly_Triangulation_4;
  Handle_Poly_Triangulation: typeof Handle_Poly_Triangulation;
  Handle_Poly_Triangulation_1: typeof Handle_Poly_Triangulation_1;
  Handle_Poly_Triangulation_2: typeof Handle_Poly_Triangulation_2;
  Handle_Poly_Triangulation_3: typeof Handle_Poly_Triangulation_3;
  Handle_Poly_Triangulation_4: typeof Handle_Poly_Triangulation_4;
  Poly_Triangle: typeof Poly_Triangle;
  Poly_Triangle_1: typeof Poly_Triangle_1;
  Poly_Triangle_2: typeof Poly_Triangle_2;
  Poly_Connect: typeof Poly_Connect;
  Poly_Connect_1: typeof Poly_Connect_1;
  Poly_Connect_2: typeof Poly_Connect_2;
  Poly_Array1OfTriangle: typeof Poly_Array1OfTriangle;
  Poly_Array1OfTriangle_1: typeof Poly_Array1OfTriangle_1;
  Poly_Array1OfTriangle_2: typeof Poly_Array1OfTriangle_2;
  Poly_Array1OfTriangle_3: typeof Poly_Array1OfTriangle_3;
  Poly_Array1OfTriangle_4: typeof Poly_Array1OfTriangle_4;
  Poly_Array1OfTriangle_5: typeof Poly_Array1OfTriangle_5;
  Poly_CoherentTriangulation: typeof Poly_CoherentTriangulation;
  Poly_CoherentTriangulation_1: typeof Poly_CoherentTriangulation_1;
  Poly_CoherentTriangulation_2: typeof Poly_CoherentTriangulation_2;
  Handle_Poly_CoherentTriangulation: typeof Handle_Poly_CoherentTriangulation;
  Handle_Poly_CoherentTriangulation_1: typeof Handle_Poly_CoherentTriangulation_1;
  Handle_Poly_CoherentTriangulation_2: typeof Handle_Poly_CoherentTriangulation_2;
  Handle_Poly_CoherentTriangulation_3: typeof Handle_Poly_CoherentTriangulation_3;
  Handle_Poly_CoherentTriangulation_4: typeof Handle_Poly_CoherentTriangulation_4;
  Handle_Poly_HArray1OfTriangle: typeof Handle_Poly_HArray1OfTriangle;
  Handle_Poly_HArray1OfTriangle_1: typeof Handle_Poly_HArray1OfTriangle_1;
  Handle_Poly_HArray1OfTriangle_2: typeof Handle_Poly_HArray1OfTriangle_2;
  Handle_Poly_HArray1OfTriangle_3: typeof Handle_Poly_HArray1OfTriangle_3;
  Handle_Poly_HArray1OfTriangle_4: typeof Handle_Poly_HArray1OfTriangle_4;
  Poly_CoherentNode: typeof Poly_CoherentNode;
  Poly_CoherentNode_1: typeof Poly_CoherentNode_1;
  Poly_CoherentNode_2: typeof Poly_CoherentNode_2;
  Storage_SolveMode: Storage_SolveMode;
  Storage_PType: typeof Storage_PType;
  Storage_PType_1: typeof Storage_PType_1;
  Storage_PType_2: typeof Storage_PType_2;
  Storage_PType_3: typeof Storage_PType_3;
  Storage_StreamFormatError: typeof Storage_StreamFormatError;
  Storage_StreamFormatError_1: typeof Storage_StreamFormatError_1;
  Storage_StreamFormatError_2: typeof Storage_StreamFormatError_2;
  Handle_Storage_StreamFormatError: typeof Handle_Storage_StreamFormatError;
  Handle_Storage_StreamFormatError_1: typeof Handle_Storage_StreamFormatError_1;
  Handle_Storage_StreamFormatError_2: typeof Handle_Storage_StreamFormatError_2;
  Handle_Storage_StreamFormatError_3: typeof Handle_Storage_StreamFormatError_3;
  Handle_Storage_StreamFormatError_4: typeof Handle_Storage_StreamFormatError_4;
  Handle_Storage_StreamModeError: typeof Handle_Storage_StreamModeError;
  Handle_Storage_StreamModeError_1: typeof Handle_Storage_StreamModeError_1;
  Handle_Storage_StreamModeError_2: typeof Handle_Storage_StreamModeError_2;
  Handle_Storage_StreamModeError_3: typeof Handle_Storage_StreamModeError_3;
  Handle_Storage_StreamModeError_4: typeof Handle_Storage_StreamModeError_4;
  Storage_StreamModeError: typeof Storage_StreamModeError;
  Storage_StreamModeError_1: typeof Storage_StreamModeError_1;
  Storage_StreamModeError_2: typeof Storage_StreamModeError_2;
  Storage_StreamTypeMismatchError: typeof Storage_StreamTypeMismatchError;
  Storage_StreamTypeMismatchError_1: typeof Storage_StreamTypeMismatchError_1;
  Storage_StreamTypeMismatchError_2: typeof Storage_StreamTypeMismatchError_2;
  Handle_Storage_StreamTypeMismatchError: typeof Handle_Storage_StreamTypeMismatchError;
  Handle_Storage_StreamTypeMismatchError_1: typeof Handle_Storage_StreamTypeMismatchError_1;
  Handle_Storage_StreamTypeMismatchError_2: typeof Handle_Storage_StreamTypeMismatchError_2;
  Handle_Storage_StreamTypeMismatchError_3: typeof Handle_Storage_StreamTypeMismatchError_3;
  Handle_Storage_StreamTypeMismatchError_4: typeof Handle_Storage_StreamTypeMismatchError_4;
  Handle_Storage_HPArray: typeof Handle_Storage_HPArray;
  Handle_Storage_HPArray_1: typeof Handle_Storage_HPArray_1;
  Handle_Storage_HPArray_2: typeof Handle_Storage_HPArray_2;
  Handle_Storage_HPArray_3: typeof Handle_Storage_HPArray_3;
  Handle_Storage_HPArray_4: typeof Handle_Storage_HPArray_4;
  Handle_Storage_InternalData: typeof Handle_Storage_InternalData;
  Handle_Storage_InternalData_1: typeof Handle_Storage_InternalData_1;
  Handle_Storage_InternalData_2: typeof Handle_Storage_InternalData_2;
  Handle_Storage_InternalData_3: typeof Handle_Storage_InternalData_3;
  Handle_Storage_InternalData_4: typeof Handle_Storage_InternalData_4;
  Storage_InternalData: typeof Storage_InternalData;
  Storage_StreamReadError: typeof Storage_StreamReadError;
  Storage_StreamReadError_1: typeof Storage_StreamReadError_1;
  Storage_StreamReadError_2: typeof Storage_StreamReadError_2;
  Handle_Storage_StreamReadError: typeof Handle_Storage_StreamReadError;
  Handle_Storage_StreamReadError_1: typeof Handle_Storage_StreamReadError_1;
  Handle_Storage_StreamReadError_2: typeof Handle_Storage_StreamReadError_2;
  Handle_Storage_StreamReadError_3: typeof Handle_Storage_StreamReadError_3;
  Handle_Storage_StreamReadError_4: typeof Handle_Storage_StreamReadError_4;
  Handle_Storage_StreamWriteError: typeof Handle_Storage_StreamWriteError;
  Handle_Storage_StreamWriteError_1: typeof Handle_Storage_StreamWriteError_1;
  Handle_Storage_StreamWriteError_2: typeof Handle_Storage_StreamWriteError_2;
  Handle_Storage_StreamWriteError_3: typeof Handle_Storage_StreamWriteError_3;
  Handle_Storage_StreamWriteError_4: typeof Handle_Storage_StreamWriteError_4;
  Storage_StreamWriteError: typeof Storage_StreamWriteError;
  Storage_StreamWriteError_1: typeof Storage_StreamWriteError_1;
  Storage_StreamWriteError_2: typeof Storage_StreamWriteError_2;
  Storage_Root: typeof Storage_Root;
  Storage_Root_1: typeof Storage_Root_1;
  Storage_Root_2: typeof Storage_Root_2;
  Storage_Root_3: typeof Storage_Root_3;
  Handle_Storage_Root: typeof Handle_Storage_Root;
  Handle_Storage_Root_1: typeof Handle_Storage_Root_1;
  Handle_Storage_Root_2: typeof Handle_Storage_Root_2;
  Handle_Storage_Root_3: typeof Handle_Storage_Root_3;
  Handle_Storage_Root_4: typeof Handle_Storage_Root_4;
  Storage_Data: typeof Storage_Data;
  Handle_Storage_Data: typeof Handle_Storage_Data;
  Handle_Storage_Data_1: typeof Handle_Storage_Data_1;
  Handle_Storage_Data_2: typeof Handle_Storage_Data_2;
  Handle_Storage_Data_3: typeof Handle_Storage_Data_3;
  Handle_Storage_Data_4: typeof Handle_Storage_Data_4;
  Storage_BucketIterator: typeof Storage_BucketIterator;
  Storage_BucketOfPersistent: typeof Storage_BucketOfPersistent;
  Storage_Bucket: typeof Storage_Bucket;
  Storage_Bucket_1: typeof Storage_Bucket_1;
  Storage_Bucket_2: typeof Storage_Bucket_2;
  Storage_HeaderData: typeof Storage_HeaderData;
  Handle_Storage_HeaderData: typeof Handle_Storage_HeaderData;
  Handle_Storage_HeaderData_1: typeof Handle_Storage_HeaderData_1;
  Handle_Storage_HeaderData_2: typeof Handle_Storage_HeaderData_2;
  Handle_Storage_HeaderData_3: typeof Handle_Storage_HeaderData_3;
  Handle_Storage_HeaderData_4: typeof Handle_Storage_HeaderData_4;
  Handle_Storage_RootData: typeof Handle_Storage_RootData;
  Handle_Storage_RootData_1: typeof Handle_Storage_RootData_1;
  Handle_Storage_RootData_2: typeof Handle_Storage_RootData_2;
  Handle_Storage_RootData_3: typeof Handle_Storage_RootData_3;
  Handle_Storage_RootData_4: typeof Handle_Storage_RootData_4;
  Storage_RootData: typeof Storage_RootData;
  Storage: typeof Storage;
  Storage_OpenMode: Storage_OpenMode;
  Storage_TypedCallBack: typeof Storage_TypedCallBack;
  Storage_TypedCallBack_1: typeof Storage_TypedCallBack_1;
  Storage_TypedCallBack_2: typeof Storage_TypedCallBack_2;
  Handle_Storage_TypedCallBack: typeof Handle_Storage_TypedCallBack;
  Handle_Storage_TypedCallBack_1: typeof Handle_Storage_TypedCallBack_1;
  Handle_Storage_TypedCallBack_2: typeof Handle_Storage_TypedCallBack_2;
  Handle_Storage_TypedCallBack_3: typeof Handle_Storage_TypedCallBack_3;
  Handle_Storage_TypedCallBack_4: typeof Handle_Storage_TypedCallBack_4;
  Storage_Error: Storage_Error;
  Handle_Storage_HArrayOfCallBack: typeof Handle_Storage_HArrayOfCallBack;
  Handle_Storage_HArrayOfCallBack_1: typeof Handle_Storage_HArrayOfCallBack_1;
  Handle_Storage_HArrayOfCallBack_2: typeof Handle_Storage_HArrayOfCallBack_2;
  Handle_Storage_HArrayOfCallBack_3: typeof Handle_Storage_HArrayOfCallBack_3;
  Handle_Storage_HArrayOfCallBack_4: typeof Handle_Storage_HArrayOfCallBack_4;
  Storage_Schema: typeof Storage_Schema;
  Handle_Storage_Schema: typeof Handle_Storage_Schema;
  Handle_Storage_Schema_1: typeof Handle_Storage_Schema_1;
  Handle_Storage_Schema_2: typeof Handle_Storage_Schema_2;
  Handle_Storage_Schema_3: typeof Handle_Storage_Schema_3;
  Handle_Storage_Schema_4: typeof Handle_Storage_Schema_4;
  Storage_StreamUnknownTypeError: typeof Storage_StreamUnknownTypeError;
  Storage_StreamUnknownTypeError_1: typeof Storage_StreamUnknownTypeError_1;
  Storage_StreamUnknownTypeError_2: typeof Storage_StreamUnknownTypeError_2;
  Handle_Storage_StreamUnknownTypeError: typeof Handle_Storage_StreamUnknownTypeError;
  Handle_Storage_StreamUnknownTypeError_1: typeof Handle_Storage_StreamUnknownTypeError_1;
  Handle_Storage_StreamUnknownTypeError_2: typeof Handle_Storage_StreamUnknownTypeError_2;
  Handle_Storage_StreamUnknownTypeError_3: typeof Handle_Storage_StreamUnknownTypeError_3;
  Handle_Storage_StreamUnknownTypeError_4: typeof Handle_Storage_StreamUnknownTypeError_4;
  Handle_Storage_HArrayOfSchema: typeof Handle_Storage_HArrayOfSchema;
  Handle_Storage_HArrayOfSchema_1: typeof Handle_Storage_HArrayOfSchema_1;
  Handle_Storage_HArrayOfSchema_2: typeof Handle_Storage_HArrayOfSchema_2;
  Handle_Storage_HArrayOfSchema_3: typeof Handle_Storage_HArrayOfSchema_3;
  Handle_Storage_HArrayOfSchema_4: typeof Handle_Storage_HArrayOfSchema_4;
  Storage_TypeData: typeof Storage_TypeData;
  Handle_Storage_TypeData: typeof Handle_Storage_TypeData;
  Handle_Storage_TypeData_1: typeof Handle_Storage_TypeData_1;
  Handle_Storage_TypeData_2: typeof Handle_Storage_TypeData_2;
  Handle_Storage_TypeData_3: typeof Handle_Storage_TypeData_3;
  Handle_Storage_TypeData_4: typeof Handle_Storage_TypeData_4;
  Handle_Storage_BaseDriver: typeof Handle_Storage_BaseDriver;
  Handle_Storage_BaseDriver_1: typeof Handle_Storage_BaseDriver_1;
  Handle_Storage_BaseDriver_2: typeof Handle_Storage_BaseDriver_2;
  Handle_Storage_BaseDriver_3: typeof Handle_Storage_BaseDriver_3;
  Handle_Storage_BaseDriver_4: typeof Handle_Storage_BaseDriver_4;
  Storage_DefaultCallBack: typeof Storage_DefaultCallBack;
  Handle_Storage_DefaultCallBack: typeof Handle_Storage_DefaultCallBack;
  Handle_Storage_DefaultCallBack_1: typeof Handle_Storage_DefaultCallBack_1;
  Handle_Storage_DefaultCallBack_2: typeof Handle_Storage_DefaultCallBack_2;
  Handle_Storage_DefaultCallBack_3: typeof Handle_Storage_DefaultCallBack_3;
  Handle_Storage_DefaultCallBack_4: typeof Handle_Storage_DefaultCallBack_4;
  Storage_StreamExtCharParityError: typeof Storage_StreamExtCharParityError;
  Storage_StreamExtCharParityError_1: typeof Storage_StreamExtCharParityError_1;
  Storage_StreamExtCharParityError_2: typeof Storage_StreamExtCharParityError_2;
  Handle_Storage_StreamExtCharParityError: typeof Handle_Storage_StreamExtCharParityError;
  Handle_Storage_StreamExtCharParityError_1: typeof Handle_Storage_StreamExtCharParityError_1;
  Handle_Storage_StreamExtCharParityError_2: typeof Handle_Storage_StreamExtCharParityError_2;
  Handle_Storage_StreamExtCharParityError_3: typeof Handle_Storage_StreamExtCharParityError_3;
  Handle_Storage_StreamExtCharParityError_4: typeof Handle_Storage_StreamExtCharParityError_4;
  Handle_Storage_CallBack: typeof Handle_Storage_CallBack;
  Handle_Storage_CallBack_1: typeof Handle_Storage_CallBack_1;
  Handle_Storage_CallBack_2: typeof Handle_Storage_CallBack_2;
  Handle_Storage_CallBack_3: typeof Handle_Storage_CallBack_3;
  Handle_Storage_CallBack_4: typeof Handle_Storage_CallBack_4;
  Storage_CallBack: typeof Storage_CallBack;
  Handle_Storage_HSeqOfRoot: typeof Handle_Storage_HSeqOfRoot;
  Handle_Storage_HSeqOfRoot_1: typeof Handle_Storage_HSeqOfRoot_1;
  Handle_Storage_HSeqOfRoot_2: typeof Handle_Storage_HSeqOfRoot_2;
  Handle_Storage_HSeqOfRoot_3: typeof Handle_Storage_HSeqOfRoot_3;
  Handle_Storage_HSeqOfRoot_4: typeof Handle_Storage_HSeqOfRoot_4;
  IntImpParGen: typeof IntImpParGen;
  Handle_XmlMDF_ReferenceDriver: typeof Handle_XmlMDF_ReferenceDriver;
  Handle_XmlMDF_ReferenceDriver_1: typeof Handle_XmlMDF_ReferenceDriver_1;
  Handle_XmlMDF_ReferenceDriver_2: typeof Handle_XmlMDF_ReferenceDriver_2;
  Handle_XmlMDF_ReferenceDriver_3: typeof Handle_XmlMDF_ReferenceDriver_3;
  Handle_XmlMDF_ReferenceDriver_4: typeof Handle_XmlMDF_ReferenceDriver_4;
  XmlMDF_ReferenceDriver: typeof XmlMDF_ReferenceDriver;
  XmlMDF_TagSourceDriver: typeof XmlMDF_TagSourceDriver;
  Handle_XmlMDF_TagSourceDriver: typeof Handle_XmlMDF_TagSourceDriver;
  Handle_XmlMDF_TagSourceDriver_1: typeof Handle_XmlMDF_TagSourceDriver_1;
  Handle_XmlMDF_TagSourceDriver_2: typeof Handle_XmlMDF_TagSourceDriver_2;
  Handle_XmlMDF_TagSourceDriver_3: typeof Handle_XmlMDF_TagSourceDriver_3;
  Handle_XmlMDF_TagSourceDriver_4: typeof Handle_XmlMDF_TagSourceDriver_4;
  XmlMDF_ADriver: typeof XmlMDF_ADriver;
  Handle_XmlMDF_ADriver: typeof Handle_XmlMDF_ADriver;
  Handle_XmlMDF_ADriver_1: typeof Handle_XmlMDF_ADriver_1;
  Handle_XmlMDF_ADriver_2: typeof Handle_XmlMDF_ADriver_2;
  Handle_XmlMDF_ADriver_3: typeof Handle_XmlMDF_ADriver_3;
  Handle_XmlMDF_ADriver_4: typeof Handle_XmlMDF_ADriver_4;
  Handle_XmlMDF_ADriverTable: typeof Handle_XmlMDF_ADriverTable;
  Handle_XmlMDF_ADriverTable_1: typeof Handle_XmlMDF_ADriverTable_1;
  Handle_XmlMDF_ADriverTable_2: typeof Handle_XmlMDF_ADriverTable_2;
  Handle_XmlMDF_ADriverTable_3: typeof Handle_XmlMDF_ADriverTable_3;
  Handle_XmlMDF_ADriverTable_4: typeof Handle_XmlMDF_ADriverTable_4;
  XmlMDF_ADriverTable: typeof XmlMDF_ADriverTable;
  XmlMDF: typeof XmlMDF;
  XmlMDF_DerivedDriver: typeof XmlMDF_DerivedDriver;
  RWMesh_CoordinateSystem: RWMesh_CoordinateSystem;
  RWMesh_MaterialMap: typeof RWMesh_MaterialMap;
  RWMesh_CoordinateSystemConverter: typeof RWMesh_CoordinateSystemConverter;
  RWMesh_NodeAttributes: typeof RWMesh_NodeAttributes;
  RWMesh_NodeAttributeMap: typeof RWMesh_NodeAttributeMap;
  RWMesh_NodeAttributeMap_1: typeof RWMesh_NodeAttributeMap_1;
  RWMesh_NodeAttributeMap_2: typeof RWMesh_NodeAttributeMap_2;
  RWMesh_NodeAttributeMap_3: typeof RWMesh_NodeAttributeMap_3;
  RWMesh_FaceIterator: typeof RWMesh_FaceIterator;
  RWMesh_CafReaderStatusEx: RWMesh_CafReaderStatusEx;
  RWMesh_CafReader: typeof RWMesh_CafReader;
  IntSurf_Transition: typeof IntSurf_Transition;
  IntSurf_Transition_1: typeof IntSurf_Transition_1;
  IntSurf_Transition_2: typeof IntSurf_Transition_2;
  IntSurf_Transition_3: typeof IntSurf_Transition_3;
  IntSurf_PathPointTool: typeof IntSurf_PathPointTool;
  IntSurf_InteriorPoint: typeof IntSurf_InteriorPoint;
  IntSurf_InteriorPoint_1: typeof IntSurf_InteriorPoint_1;
  IntSurf_InteriorPoint_2: typeof IntSurf_InteriorPoint_2;
  IntSurf_ListOfPntOn2S: typeof IntSurf_ListOfPntOn2S;
  IntSurf_ListOfPntOn2S_1: typeof IntSurf_ListOfPntOn2S_1;
  IntSurf_ListOfPntOn2S_2: typeof IntSurf_ListOfPntOn2S_2;
  IntSurf_ListOfPntOn2S_3: typeof IntSurf_ListOfPntOn2S_3;
  IntSurf_SequenceOfPathPoint: typeof IntSurf_SequenceOfPathPoint;
  IntSurf_SequenceOfPathPoint_1: typeof IntSurf_SequenceOfPathPoint_1;
  IntSurf_SequenceOfPathPoint_2: typeof IntSurf_SequenceOfPathPoint_2;
  IntSurf_SequenceOfPathPoint_3: typeof IntSurf_SequenceOfPathPoint_3;
  IntSurf_Couple: typeof IntSurf_Couple;
  IntSurf_Couple_1: typeof IntSurf_Couple_1;
  IntSurf_Couple_2: typeof IntSurf_Couple_2;
  IntSurf: typeof IntSurf;
  IntSurf_Situation: IntSurf_Situation;
  IntSurf_LineOn2S: typeof IntSurf_LineOn2S;
  Handle_IntSurf_LineOn2S: typeof Handle_IntSurf_LineOn2S;
  Handle_IntSurf_LineOn2S_1: typeof Handle_IntSurf_LineOn2S_1;
  Handle_IntSurf_LineOn2S_2: typeof Handle_IntSurf_LineOn2S_2;
  Handle_IntSurf_LineOn2S_3: typeof Handle_IntSurf_LineOn2S_3;
  Handle_IntSurf_LineOn2S_4: typeof Handle_IntSurf_LineOn2S_4;
  IntSurf_PathPoint: typeof IntSurf_PathPoint;
  IntSurf_PathPoint_1: typeof IntSurf_PathPoint_1;
  IntSurf_PathPoint_2: typeof IntSurf_PathPoint_2;
  IntSurf_SequenceOfCouple: typeof IntSurf_SequenceOfCouple;
  IntSurf_SequenceOfCouple_1: typeof IntSurf_SequenceOfCouple_1;
  IntSurf_SequenceOfCouple_2: typeof IntSurf_SequenceOfCouple_2;
  IntSurf_SequenceOfCouple_3: typeof IntSurf_SequenceOfCouple_3;
  IntSurf_PntOn2S: typeof IntSurf_PntOn2S;
  IntSurf_Quadric: typeof IntSurf_Quadric;
  IntSurf_Quadric_1: typeof IntSurf_Quadric_1;
  IntSurf_Quadric_2: typeof IntSurf_Quadric_2;
  IntSurf_Quadric_3: typeof IntSurf_Quadric_3;
  IntSurf_Quadric_4: typeof IntSurf_Quadric_4;
  IntSurf_Quadric_5: typeof IntSurf_Quadric_5;
  IntSurf_Quadric_6: typeof IntSurf_Quadric_6;
  IntSurf_TypeTrans: IntSurf_TypeTrans;
  IntSurf_InteriorPointTool: typeof IntSurf_InteriorPointTool;
  IntSurf_QuadricTool: typeof IntSurf_QuadricTool;
  IntSurf_SequenceOfPntOn2S: typeof IntSurf_SequenceOfPntOn2S;
  IntSurf_SequenceOfPntOn2S_1: typeof IntSurf_SequenceOfPntOn2S_1;
  IntSurf_SequenceOfPntOn2S_2: typeof IntSurf_SequenceOfPntOn2S_2;
  IntSurf_SequenceOfPntOn2S_3: typeof IntSurf_SequenceOfPntOn2S_3;
  IntSurf_SequenceOfInteriorPoint: typeof IntSurf_SequenceOfInteriorPoint;
  IntSurf_SequenceOfInteriorPoint_1: typeof IntSurf_SequenceOfInteriorPoint_1;
  IntSurf_SequenceOfInteriorPoint_2: typeof IntSurf_SequenceOfInteriorPoint_2;
  IntSurf_SequenceOfInteriorPoint_3: typeof IntSurf_SequenceOfInteriorPoint_3;
  XCAFDoc_Area: typeof XCAFDoc_Area;
  Handle_XCAFDoc_Area: typeof Handle_XCAFDoc_Area;
  Handle_XCAFDoc_Area_1: typeof Handle_XCAFDoc_Area_1;
  Handle_XCAFDoc_Area_2: typeof Handle_XCAFDoc_Area_2;
  Handle_XCAFDoc_Area_3: typeof Handle_XCAFDoc_Area_3;
  Handle_XCAFDoc_Area_4: typeof Handle_XCAFDoc_Area_4;
  XCAFDoc_LayerTool: typeof XCAFDoc_LayerTool;
  Handle_XCAFDoc_LayerTool: typeof Handle_XCAFDoc_LayerTool;
  Handle_XCAFDoc_LayerTool_1: typeof Handle_XCAFDoc_LayerTool_1;
  Handle_XCAFDoc_LayerTool_2: typeof Handle_XCAFDoc_LayerTool_2;
  Handle_XCAFDoc_LayerTool_3: typeof Handle_XCAFDoc_LayerTool_3;
  Handle_XCAFDoc_LayerTool_4: typeof Handle_XCAFDoc_LayerTool_4;
  XCAFDoc_MaterialTool: typeof XCAFDoc_MaterialTool;
  Handle_XCAFDoc_MaterialTool: typeof Handle_XCAFDoc_MaterialTool;
  Handle_XCAFDoc_MaterialTool_1: typeof Handle_XCAFDoc_MaterialTool_1;
  Handle_XCAFDoc_MaterialTool_2: typeof Handle_XCAFDoc_MaterialTool_2;
  Handle_XCAFDoc_MaterialTool_3: typeof Handle_XCAFDoc_MaterialTool_3;
  Handle_XCAFDoc_MaterialTool_4: typeof Handle_XCAFDoc_MaterialTool_4;
  XCAFDoc_AssemblyItemRef: typeof XCAFDoc_AssemblyItemRef;
  Handle_XCAFDoc_AssemblyItemRef: typeof Handle_XCAFDoc_AssemblyItemRef;
  Handle_XCAFDoc_AssemblyItemRef_1: typeof Handle_XCAFDoc_AssemblyItemRef_1;
  Handle_XCAFDoc_AssemblyItemRef_2: typeof Handle_XCAFDoc_AssemblyItemRef_2;
  Handle_XCAFDoc_AssemblyItemRef_3: typeof Handle_XCAFDoc_AssemblyItemRef_3;
  Handle_XCAFDoc_AssemblyItemRef_4: typeof Handle_XCAFDoc_AssemblyItemRef_4;
  Handle_XCAFDoc_DocumentTool: typeof Handle_XCAFDoc_DocumentTool;
  Handle_XCAFDoc_DocumentTool_1: typeof Handle_XCAFDoc_DocumentTool_1;
  Handle_XCAFDoc_DocumentTool_2: typeof Handle_XCAFDoc_DocumentTool_2;
  Handle_XCAFDoc_DocumentTool_3: typeof Handle_XCAFDoc_DocumentTool_3;
  Handle_XCAFDoc_DocumentTool_4: typeof Handle_XCAFDoc_DocumentTool_4;
  XCAFDoc_DocumentTool: typeof XCAFDoc_DocumentTool;
  XCAFDoc_ClippingPlaneTool: typeof XCAFDoc_ClippingPlaneTool;
  Handle_XCAFDoc_ClippingPlaneTool: typeof Handle_XCAFDoc_ClippingPlaneTool;
  Handle_XCAFDoc_ClippingPlaneTool_1: typeof Handle_XCAFDoc_ClippingPlaneTool_1;
  Handle_XCAFDoc_ClippingPlaneTool_2: typeof Handle_XCAFDoc_ClippingPlaneTool_2;
  Handle_XCAFDoc_ClippingPlaneTool_3: typeof Handle_XCAFDoc_ClippingPlaneTool_3;
  Handle_XCAFDoc_ClippingPlaneTool_4: typeof Handle_XCAFDoc_ClippingPlaneTool_4;
  XCAFDoc_VisMaterialCommon: typeof XCAFDoc_VisMaterialCommon;
  XCAFDoc_ColorType: XCAFDoc_ColorType;
  Handle_XCAFDoc_Datum: typeof Handle_XCAFDoc_Datum;
  Handle_XCAFDoc_Datum_1: typeof Handle_XCAFDoc_Datum_1;
  Handle_XCAFDoc_Datum_2: typeof Handle_XCAFDoc_Datum_2;
  Handle_XCAFDoc_Datum_3: typeof Handle_XCAFDoc_Datum_3;
  Handle_XCAFDoc_Datum_4: typeof Handle_XCAFDoc_Datum_4;
  XCAFDoc_Datum: typeof XCAFDoc_Datum;
  XCAFDoc_Material: typeof XCAFDoc_Material;
  Handle_XCAFDoc_Material: typeof Handle_XCAFDoc_Material;
  Handle_XCAFDoc_Material_1: typeof Handle_XCAFDoc_Material_1;
  Handle_XCAFDoc_Material_2: typeof Handle_XCAFDoc_Material_2;
  Handle_XCAFDoc_Material_3: typeof Handle_XCAFDoc_Material_3;
  Handle_XCAFDoc_Material_4: typeof Handle_XCAFDoc_Material_4;
  Handle_XCAFDoc_Note: typeof Handle_XCAFDoc_Note;
  Handle_XCAFDoc_Note_1: typeof Handle_XCAFDoc_Note_1;
  Handle_XCAFDoc_Note_2: typeof Handle_XCAFDoc_Note_2;
  Handle_XCAFDoc_Note_3: typeof Handle_XCAFDoc_Note_3;
  Handle_XCAFDoc_Note_4: typeof Handle_XCAFDoc_Note_4;
  XCAFDoc_Note: typeof XCAFDoc_Note;
  Handle_XCAFDoc_GraphNode: typeof Handle_XCAFDoc_GraphNode;
  Handle_XCAFDoc_GraphNode_1: typeof Handle_XCAFDoc_GraphNode_1;
  Handle_XCAFDoc_GraphNode_2: typeof Handle_XCAFDoc_GraphNode_2;
  Handle_XCAFDoc_GraphNode_3: typeof Handle_XCAFDoc_GraphNode_3;
  Handle_XCAFDoc_GraphNode_4: typeof Handle_XCAFDoc_GraphNode_4;
  XCAFDoc_GraphNode: typeof XCAFDoc_GraphNode;
  Handle_XCAFDoc_NotesTool: typeof Handle_XCAFDoc_NotesTool;
  Handle_XCAFDoc_NotesTool_1: typeof Handle_XCAFDoc_NotesTool_1;
  Handle_XCAFDoc_NotesTool_2: typeof Handle_XCAFDoc_NotesTool_2;
  Handle_XCAFDoc_NotesTool_3: typeof Handle_XCAFDoc_NotesTool_3;
  Handle_XCAFDoc_NotesTool_4: typeof Handle_XCAFDoc_NotesTool_4;
  XCAFDoc_NotesTool: typeof XCAFDoc_NotesTool;
  XCAFDoc_VisMaterialPBR: typeof XCAFDoc_VisMaterialPBR;
  XCAFDoc_AssemblyItemId: typeof XCAFDoc_AssemblyItemId;
  XCAFDoc_AssemblyItemId_1: typeof XCAFDoc_AssemblyItemId_1;
  XCAFDoc_AssemblyItemId_2: typeof XCAFDoc_AssemblyItemId_2;
  XCAFDoc_AssemblyItemId_3: typeof XCAFDoc_AssemblyItemId_3;
  XCAFDoc_Editor: typeof XCAFDoc_Editor;
  Handle_XCAFDoc_Color: typeof Handle_XCAFDoc_Color;
  Handle_XCAFDoc_Color_1: typeof Handle_XCAFDoc_Color_1;
  Handle_XCAFDoc_Color_2: typeof Handle_XCAFDoc_Color_2;
  Handle_XCAFDoc_Color_3: typeof Handle_XCAFDoc_Color_3;
  Handle_XCAFDoc_Color_4: typeof Handle_XCAFDoc_Color_4;
  XCAFDoc_Color: typeof XCAFDoc_Color;
  Handle_XCAFDoc_GeomTolerance: typeof Handle_XCAFDoc_GeomTolerance;
  Handle_XCAFDoc_GeomTolerance_1: typeof Handle_XCAFDoc_GeomTolerance_1;
  Handle_XCAFDoc_GeomTolerance_2: typeof Handle_XCAFDoc_GeomTolerance_2;
  Handle_XCAFDoc_GeomTolerance_3: typeof Handle_XCAFDoc_GeomTolerance_3;
  Handle_XCAFDoc_GeomTolerance_4: typeof Handle_XCAFDoc_GeomTolerance_4;
  Handle_XCAFDoc_VisMaterial: typeof Handle_XCAFDoc_VisMaterial;
  Handle_XCAFDoc_VisMaterial_1: typeof Handle_XCAFDoc_VisMaterial_1;
  Handle_XCAFDoc_VisMaterial_2: typeof Handle_XCAFDoc_VisMaterial_2;
  Handle_XCAFDoc_VisMaterial_3: typeof Handle_XCAFDoc_VisMaterial_3;
  Handle_XCAFDoc_VisMaterial_4: typeof Handle_XCAFDoc_VisMaterial_4;
  XCAFDoc_VisMaterial: typeof XCAFDoc_VisMaterial;
  Handle_XCAFDoc_Volume: typeof Handle_XCAFDoc_Volume;
  Handle_XCAFDoc_Volume_1: typeof Handle_XCAFDoc_Volume_1;
  Handle_XCAFDoc_Volume_2: typeof Handle_XCAFDoc_Volume_2;
  Handle_XCAFDoc_Volume_3: typeof Handle_XCAFDoc_Volume_3;
  Handle_XCAFDoc_Volume_4: typeof Handle_XCAFDoc_Volume_4;
  XCAFDoc_Volume: typeof XCAFDoc_Volume;
  Handle_XCAFDoc_NoteComment: typeof Handle_XCAFDoc_NoteComment;
  Handle_XCAFDoc_NoteComment_1: typeof Handle_XCAFDoc_NoteComment_1;
  Handle_XCAFDoc_NoteComment_2: typeof Handle_XCAFDoc_NoteComment_2;
  Handle_XCAFDoc_NoteComment_3: typeof Handle_XCAFDoc_NoteComment_3;
  Handle_XCAFDoc_NoteComment_4: typeof Handle_XCAFDoc_NoteComment_4;
  XCAFDoc_NoteComment: typeof XCAFDoc_NoteComment;
  XCAFDoc_Dimension: typeof XCAFDoc_Dimension;
  Handle_XCAFDoc_Dimension: typeof Handle_XCAFDoc_Dimension;
  Handle_XCAFDoc_Dimension_1: typeof Handle_XCAFDoc_Dimension_1;
  Handle_XCAFDoc_Dimension_2: typeof Handle_XCAFDoc_Dimension_2;
  Handle_XCAFDoc_Dimension_3: typeof Handle_XCAFDoc_Dimension_3;
  Handle_XCAFDoc_Dimension_4: typeof Handle_XCAFDoc_Dimension_4;
  Handle_XCAFDoc_ColorTool: typeof Handle_XCAFDoc_ColorTool;
  Handle_XCAFDoc_ColorTool_1: typeof Handle_XCAFDoc_ColorTool_1;
  Handle_XCAFDoc_ColorTool_2: typeof Handle_XCAFDoc_ColorTool_2;
  Handle_XCAFDoc_ColorTool_3: typeof Handle_XCAFDoc_ColorTool_3;
  Handle_XCAFDoc_ColorTool_4: typeof Handle_XCAFDoc_ColorTool_4;
  XCAFDoc_ColorTool: typeof XCAFDoc_ColorTool;
  Handle_XCAFDoc_Centroid: typeof Handle_XCAFDoc_Centroid;
  Handle_XCAFDoc_Centroid_1: typeof Handle_XCAFDoc_Centroid_1;
  Handle_XCAFDoc_Centroid_2: typeof Handle_XCAFDoc_Centroid_2;
  Handle_XCAFDoc_Centroid_3: typeof Handle_XCAFDoc_Centroid_3;
  Handle_XCAFDoc_Centroid_4: typeof Handle_XCAFDoc_Centroid_4;
  XCAFDoc_Centroid: typeof XCAFDoc_Centroid;
  Handle_XCAFDoc_DimTolTool: typeof Handle_XCAFDoc_DimTolTool;
  Handle_XCAFDoc_DimTolTool_1: typeof Handle_XCAFDoc_DimTolTool_1;
  Handle_XCAFDoc_DimTolTool_2: typeof Handle_XCAFDoc_DimTolTool_2;
  Handle_XCAFDoc_DimTolTool_3: typeof Handle_XCAFDoc_DimTolTool_3;
  Handle_XCAFDoc_DimTolTool_4: typeof Handle_XCAFDoc_DimTolTool_4;
  XCAFDoc_DimTolTool: typeof XCAFDoc_DimTolTool;
  XCAFDoc_ShapeMapTool: typeof XCAFDoc_ShapeMapTool;
  Handle_XCAFDoc_ShapeMapTool: typeof Handle_XCAFDoc_ShapeMapTool;
  Handle_XCAFDoc_ShapeMapTool_1: typeof Handle_XCAFDoc_ShapeMapTool_1;
  Handle_XCAFDoc_ShapeMapTool_2: typeof Handle_XCAFDoc_ShapeMapTool_2;
  Handle_XCAFDoc_ShapeMapTool_3: typeof Handle_XCAFDoc_ShapeMapTool_3;
  Handle_XCAFDoc_ShapeMapTool_4: typeof Handle_XCAFDoc_ShapeMapTool_4;
  XCAFDoc_DataMapOfShapeLabel: typeof XCAFDoc_DataMapOfShapeLabel;
  XCAFDoc_DataMapOfShapeLabel_1: typeof XCAFDoc_DataMapOfShapeLabel_1;
  XCAFDoc_DataMapOfShapeLabel_2: typeof XCAFDoc_DataMapOfShapeLabel_2;
  XCAFDoc_DataMapOfShapeLabel_3: typeof XCAFDoc_DataMapOfShapeLabel_3;
  XCAFDoc_ShapeTool: typeof XCAFDoc_ShapeTool;
  Handle_XCAFDoc_ShapeTool: typeof Handle_XCAFDoc_ShapeTool;
  Handle_XCAFDoc_ShapeTool_1: typeof Handle_XCAFDoc_ShapeTool_1;
  Handle_XCAFDoc_ShapeTool_2: typeof Handle_XCAFDoc_ShapeTool_2;
  Handle_XCAFDoc_ShapeTool_3: typeof Handle_XCAFDoc_ShapeTool_3;
  Handle_XCAFDoc_ShapeTool_4: typeof Handle_XCAFDoc_ShapeTool_4;
  Handle_XCAFDoc_VisMaterialTool: typeof Handle_XCAFDoc_VisMaterialTool;
  Handle_XCAFDoc_VisMaterialTool_1: typeof Handle_XCAFDoc_VisMaterialTool_1;
  Handle_XCAFDoc_VisMaterialTool_2: typeof Handle_XCAFDoc_VisMaterialTool_2;
  Handle_XCAFDoc_VisMaterialTool_3: typeof Handle_XCAFDoc_VisMaterialTool_3;
  Handle_XCAFDoc_VisMaterialTool_4: typeof Handle_XCAFDoc_VisMaterialTool_4;
  XCAFDoc_VisMaterialTool: typeof XCAFDoc_VisMaterialTool;
  Handle_XCAFDoc_NoteBalloon: typeof Handle_XCAFDoc_NoteBalloon;
  Handle_XCAFDoc_NoteBalloon_1: typeof Handle_XCAFDoc_NoteBalloon_1;
  Handle_XCAFDoc_NoteBalloon_2: typeof Handle_XCAFDoc_NoteBalloon_2;
  Handle_XCAFDoc_NoteBalloon_3: typeof Handle_XCAFDoc_NoteBalloon_3;
  Handle_XCAFDoc_NoteBalloon_4: typeof Handle_XCAFDoc_NoteBalloon_4;
  XCAFDoc_NoteBalloon: typeof XCAFDoc_NoteBalloon;
  Handle_XCAFDoc_ViewTool: typeof Handle_XCAFDoc_ViewTool;
  Handle_XCAFDoc_ViewTool_1: typeof Handle_XCAFDoc_ViewTool_1;
  Handle_XCAFDoc_ViewTool_2: typeof Handle_XCAFDoc_ViewTool_2;
  Handle_XCAFDoc_ViewTool_3: typeof Handle_XCAFDoc_ViewTool_3;
  Handle_XCAFDoc_ViewTool_4: typeof Handle_XCAFDoc_ViewTool_4;
  XCAFDoc_ViewTool: typeof XCAFDoc_ViewTool;
  Handle_XCAFDoc_View: typeof Handle_XCAFDoc_View;
  Handle_XCAFDoc_View_1: typeof Handle_XCAFDoc_View_1;
  Handle_XCAFDoc_View_2: typeof Handle_XCAFDoc_View_2;
  Handle_XCAFDoc_View_3: typeof Handle_XCAFDoc_View_3;
  Handle_XCAFDoc_View_4: typeof Handle_XCAFDoc_View_4;
  XCAFDoc_View: typeof XCAFDoc_View;
  Handle_XCAFDoc_Location: typeof Handle_XCAFDoc_Location;
  Handle_XCAFDoc_Location_1: typeof Handle_XCAFDoc_Location_1;
  Handle_XCAFDoc_Location_2: typeof Handle_XCAFDoc_Location_2;
  Handle_XCAFDoc_Location_3: typeof Handle_XCAFDoc_Location_3;
  Handle_XCAFDoc_Location_4: typeof Handle_XCAFDoc_Location_4;
  XCAFDoc_Location: typeof XCAFDoc_Location;
  XCAFDoc_NoteBinData: typeof XCAFDoc_NoteBinData;
  Handle_XCAFDoc_NoteBinData: typeof Handle_XCAFDoc_NoteBinData;
  Handle_XCAFDoc_NoteBinData_1: typeof Handle_XCAFDoc_NoteBinData_1;
  Handle_XCAFDoc_NoteBinData_2: typeof Handle_XCAFDoc_NoteBinData_2;
  Handle_XCAFDoc_NoteBinData_3: typeof Handle_XCAFDoc_NoteBinData_3;
  Handle_XCAFDoc_NoteBinData_4: typeof Handle_XCAFDoc_NoteBinData_4;
  XCAFDoc_DimTol: typeof XCAFDoc_DimTol;
  Handle_XCAFDoc_DimTol: typeof Handle_XCAFDoc_DimTol;
  Handle_XCAFDoc_DimTol_1: typeof Handle_XCAFDoc_DimTol_1;
  Handle_XCAFDoc_DimTol_2: typeof Handle_XCAFDoc_DimTol_2;
  Handle_XCAFDoc_DimTol_3: typeof Handle_XCAFDoc_DimTol_3;
  Handle_XCAFDoc_DimTol_4: typeof Handle_XCAFDoc_DimTol_4;
  XCAFDoc: typeof XCAFDoc;
  Handle_STEPEdit_EditContext: typeof Handle_STEPEdit_EditContext;
  Handle_STEPEdit_EditContext_1: typeof Handle_STEPEdit_EditContext_1;
  Handle_STEPEdit_EditContext_2: typeof Handle_STEPEdit_EditContext_2;
  Handle_STEPEdit_EditContext_3: typeof Handle_STEPEdit_EditContext_3;
  Handle_STEPEdit_EditContext_4: typeof Handle_STEPEdit_EditContext_4;
  STEPEdit_EditContext: typeof STEPEdit_EditContext;
  STEPEdit: typeof STEPEdit;
  STEPEdit_EditSDR: typeof STEPEdit_EditSDR;
  Handle_STEPEdit_EditSDR: typeof Handle_STEPEdit_EditSDR;
  Handle_STEPEdit_EditSDR_1: typeof Handle_STEPEdit_EditSDR_1;
  Handle_STEPEdit_EditSDR_2: typeof Handle_STEPEdit_EditSDR_2;
  Handle_STEPEdit_EditSDR_3: typeof Handle_STEPEdit_EditSDR_3;
  Handle_STEPEdit_EditSDR_4: typeof Handle_STEPEdit_EditSDR_4;
  BRepToIGESBRep_Entity: typeof BRepToIGESBRep_Entity;
  AppStd_Application: typeof AppStd_Application;
  Handle_AppStd_Application: typeof Handle_AppStd_Application;
  Handle_AppStd_Application_1: typeof Handle_AppStd_Application_1;
  Handle_AppStd_Application_2: typeof Handle_AppStd_Application_2;
  Handle_AppStd_Application_3: typeof Handle_AppStd_Application_3;
  Handle_AppStd_Application_4: typeof Handle_AppStd_Application_4;
  Prs3d_TypeOfHLR: Prs3d_TypeOfHLR;
  Prs3d_DatumAxes: Prs3d_DatumAxes;
  Handle_Prs3d_BasicAspect: typeof Handle_Prs3d_BasicAspect;
  Handle_Prs3d_BasicAspect_1: typeof Handle_Prs3d_BasicAspect_1;
  Handle_Prs3d_BasicAspect_2: typeof Handle_Prs3d_BasicAspect_2;
  Handle_Prs3d_BasicAspect_3: typeof Handle_Prs3d_BasicAspect_3;
  Handle_Prs3d_BasicAspect_4: typeof Handle_Prs3d_BasicAspect_4;
  Prs3d_BasicAspect: typeof Prs3d_BasicAspect;
  Prs3d_Text: typeof Prs3d_Text;
  Prs3d_Arrow: typeof Prs3d_Arrow;
  Handle_Prs3d_PlaneAspect: typeof Handle_Prs3d_PlaneAspect;
  Handle_Prs3d_PlaneAspect_1: typeof Handle_Prs3d_PlaneAspect_1;
  Handle_Prs3d_PlaneAspect_2: typeof Handle_Prs3d_PlaneAspect_2;
  Handle_Prs3d_PlaneAspect_3: typeof Handle_Prs3d_PlaneAspect_3;
  Handle_Prs3d_PlaneAspect_4: typeof Handle_Prs3d_PlaneAspect_4;
  Prs3d_PlaneAspect: typeof Prs3d_PlaneAspect;
  Prs3d_DimensionUnits: typeof Prs3d_DimensionUnits;
  Prs3d_DimensionUnits_1: typeof Prs3d_DimensionUnits_1;
  Prs3d_DimensionUnits_2: typeof Prs3d_DimensionUnits_2;
  Prs3d_BndBox: typeof Prs3d_BndBox;
  Prs3d_DatumParts: Prs3d_DatumParts;
  Prs3d_TextAspect: typeof Prs3d_TextAspect;
  Prs3d_TextAspect_1: typeof Prs3d_TextAspect_1;
  Prs3d_TextAspect_2: typeof Prs3d_TextAspect_2;
  Handle_Prs3d_TextAspect: typeof Handle_Prs3d_TextAspect;
  Handle_Prs3d_TextAspect_1: typeof Handle_Prs3d_TextAspect_1;
  Handle_Prs3d_TextAspect_2: typeof Handle_Prs3d_TextAspect_2;
  Handle_Prs3d_TextAspect_3: typeof Handle_Prs3d_TextAspect_3;
  Handle_Prs3d_TextAspect_4: typeof Handle_Prs3d_TextAspect_4;
  Prs3d_ToolSector: typeof Prs3d_ToolSector;
  Prs3d_ToolTorus: typeof Prs3d_ToolTorus;
  Prs3d_ToolTorus_1: typeof Prs3d_ToolTorus_1;
  Prs3d_ToolTorus_2: typeof Prs3d_ToolTorus_2;
  Prs3d_ToolTorus_3: typeof Prs3d_ToolTorus_3;
  Prs3d_ToolTorus_4: typeof Prs3d_ToolTorus_4;
  Prs3d_DimensionArrowOrientation: Prs3d_DimensionArrowOrientation;
  Handle_Prs3d_LineAspect: typeof Handle_Prs3d_LineAspect;
  Handle_Prs3d_LineAspect_1: typeof Handle_Prs3d_LineAspect_1;
  Handle_Prs3d_LineAspect_2: typeof Handle_Prs3d_LineAspect_2;
  Handle_Prs3d_LineAspect_3: typeof Handle_Prs3d_LineAspect_3;
  Handle_Prs3d_LineAspect_4: typeof Handle_Prs3d_LineAspect_4;
  Prs3d_LineAspect: typeof Prs3d_LineAspect;
  Prs3d_LineAspect_1: typeof Prs3d_LineAspect_1;
  Prs3d_LineAspect_2: typeof Prs3d_LineAspect_2;
  Prs3d_ToolDisk: typeof Prs3d_ToolDisk;
  Prs3d_ShadingAspect: typeof Prs3d_ShadingAspect;
  Prs3d_ShadingAspect_1: typeof Prs3d_ShadingAspect_1;
  Prs3d_ShadingAspect_2: typeof Prs3d_ShadingAspect_2;
  Handle_Prs3d_ShadingAspect: typeof Handle_Prs3d_ShadingAspect;
  Handle_Prs3d_ShadingAspect_1: typeof Handle_Prs3d_ShadingAspect_1;
  Handle_Prs3d_ShadingAspect_2: typeof Handle_Prs3d_ShadingAspect_2;
  Handle_Prs3d_ShadingAspect_3: typeof Handle_Prs3d_ShadingAspect_3;
  Handle_Prs3d_ShadingAspect_4: typeof Handle_Prs3d_ShadingAspect_4;
  Handle_Prs3d_PresentationShadow: typeof Handle_Prs3d_PresentationShadow;
  Handle_Prs3d_PresentationShadow_1: typeof Handle_Prs3d_PresentationShadow_1;
  Handle_Prs3d_PresentationShadow_2: typeof Handle_Prs3d_PresentationShadow_2;
  Handle_Prs3d_PresentationShadow_3: typeof Handle_Prs3d_PresentationShadow_3;
  Handle_Prs3d_PresentationShadow_4: typeof Handle_Prs3d_PresentationShadow_4;
  Prs3d_PresentationShadow: typeof Prs3d_PresentationShadow;
  Prs3d_TypeOfHighlight: Prs3d_TypeOfHighlight;
  Handle_Prs3d_IsoAspect: typeof Handle_Prs3d_IsoAspect;
  Handle_Prs3d_IsoAspect_1: typeof Handle_Prs3d_IsoAspect_1;
  Handle_Prs3d_IsoAspect_2: typeof Handle_Prs3d_IsoAspect_2;
  Handle_Prs3d_IsoAspect_3: typeof Handle_Prs3d_IsoAspect_3;
  Handle_Prs3d_IsoAspect_4: typeof Handle_Prs3d_IsoAspect_4;
  Prs3d_IsoAspect: typeof Prs3d_IsoAspect;
  Prs3d_VertexDrawMode: Prs3d_VertexDrawMode;
  Prs3d_DatumAspect: typeof Prs3d_DatumAspect;
  Handle_Prs3d_DatumAspect: typeof Handle_Prs3d_DatumAspect;
  Handle_Prs3d_DatumAspect_1: typeof Handle_Prs3d_DatumAspect_1;
  Handle_Prs3d_DatumAspect_2: typeof Handle_Prs3d_DatumAspect_2;
  Handle_Prs3d_DatumAspect_3: typeof Handle_Prs3d_DatumAspect_3;
  Handle_Prs3d_DatumAspect_4: typeof Handle_Prs3d_DatumAspect_4;
  Prs3d: typeof Prs3d;
  Prs3d_DatumAttribute: Prs3d_DatumAttribute;
  Prs3d_TypeOfLinePicking: Prs3d_TypeOfLinePicking;
  Prs3d_DatumMode: Prs3d_DatumMode;
  Prs3d_DimensionTextVerticalPosition: Prs3d_DimensionTextVerticalPosition;
  Prs3d_DimensionAspect: typeof Prs3d_DimensionAspect;
  Handle_Prs3d_DimensionAspect: typeof Handle_Prs3d_DimensionAspect;
  Handle_Prs3d_DimensionAspect_1: typeof Handle_Prs3d_DimensionAspect_1;
  Handle_Prs3d_DimensionAspect_2: typeof Handle_Prs3d_DimensionAspect_2;
  Handle_Prs3d_DimensionAspect_3: typeof Handle_Prs3d_DimensionAspect_3;
  Handle_Prs3d_DimensionAspect_4: typeof Handle_Prs3d_DimensionAspect_4;
  Handle_Prs3d_ArrowAspect: typeof Handle_Prs3d_ArrowAspect;
  Handle_Prs3d_ArrowAspect_1: typeof Handle_Prs3d_ArrowAspect_1;
  Handle_Prs3d_ArrowAspect_2: typeof Handle_Prs3d_ArrowAspect_2;
  Handle_Prs3d_ArrowAspect_3: typeof Handle_Prs3d_ArrowAspect_3;
  Handle_Prs3d_ArrowAspect_4: typeof Handle_Prs3d_ArrowAspect_4;
  Prs3d_ArrowAspect: typeof Prs3d_ArrowAspect;
  Prs3d_ArrowAspect_1: typeof Prs3d_ArrowAspect_1;
  Prs3d_ArrowAspect_2: typeof Prs3d_ArrowAspect_2;
  Prs3d_ArrowAspect_3: typeof Prs3d_ArrowAspect_3;
  Prs3d_InvalidAngle: typeof Prs3d_InvalidAngle;
  Prs3d_InvalidAngle_1: typeof Prs3d_InvalidAngle_1;
  Prs3d_InvalidAngle_2: typeof Prs3d_InvalidAngle_2;
  Handle_Prs3d_InvalidAngle: typeof Handle_Prs3d_InvalidAngle;
  Handle_Prs3d_InvalidAngle_1: typeof Handle_Prs3d_InvalidAngle_1;
  Handle_Prs3d_InvalidAngle_2: typeof Handle_Prs3d_InvalidAngle_2;
  Handle_Prs3d_InvalidAngle_3: typeof Handle_Prs3d_InvalidAngle_3;
  Handle_Prs3d_InvalidAngle_4: typeof Handle_Prs3d_InvalidAngle_4;
  Prs3d_ToolCylinder: typeof Prs3d_ToolCylinder;
  Prs3d_Root: typeof Prs3d_Root;
  Prs3d_ToolSphere: typeof Prs3d_ToolSphere;
  Prs3d_DimensionTextHorizontalPosition: Prs3d_DimensionTextHorizontalPosition;
  Handle_Prs3d_Drawer: typeof Handle_Prs3d_Drawer;
  Handle_Prs3d_Drawer_1: typeof Handle_Prs3d_Drawer_1;
  Handle_Prs3d_Drawer_2: typeof Handle_Prs3d_Drawer_2;
  Handle_Prs3d_Drawer_3: typeof Handle_Prs3d_Drawer_3;
  Handle_Prs3d_Drawer_4: typeof Handle_Prs3d_Drawer_4;
  Prs3d_Drawer: typeof Prs3d_Drawer;
  Handle_Prs3d_PointAspect: typeof Handle_Prs3d_PointAspect;
  Handle_Prs3d_PointAspect_1: typeof Handle_Prs3d_PointAspect_1;
  Handle_Prs3d_PointAspect_2: typeof Handle_Prs3d_PointAspect_2;
  Handle_Prs3d_PointAspect_3: typeof Handle_Prs3d_PointAspect_3;
  Handle_Prs3d_PointAspect_4: typeof Handle_Prs3d_PointAspect_4;
  Prs3d_PointAspect: typeof Prs3d_PointAspect;
  Prs3d_PointAspect_1: typeof Prs3d_PointAspect_1;
  Prs3d_PointAspect_2: typeof Prs3d_PointAspect_2;
  Prs3d_PointAspect_3: typeof Prs3d_PointAspect_3;
  HLRAppli_ReflectLines: typeof HLRAppli_ReflectLines;
  BRepOffsetAPI_MakeEvolved: typeof BRepOffsetAPI_MakeEvolved;
  BRepOffsetAPI_MakeEvolved_1: typeof BRepOffsetAPI_MakeEvolved_1;
  BRepOffsetAPI_MakeEvolved_2: typeof BRepOffsetAPI_MakeEvolved_2;
  BRepOffsetAPI_MiddlePath: typeof BRepOffsetAPI_MiddlePath;
  BRepOffsetAPI_ThruSections: typeof BRepOffsetAPI_ThruSections;
  BRepOffsetAPI_SequenceOfSequenceOfShape: typeof BRepOffsetAPI_SequenceOfSequenceOfShape;
  BRepOffsetAPI_SequenceOfSequenceOfShape_1: typeof BRepOffsetAPI_SequenceOfSequenceOfShape_1;
  BRepOffsetAPI_SequenceOfSequenceOfShape_2: typeof BRepOffsetAPI_SequenceOfSequenceOfShape_2;
  BRepOffsetAPI_SequenceOfSequenceOfShape_3: typeof BRepOffsetAPI_SequenceOfSequenceOfShape_3;
  BRepOffsetAPI_MakeThickSolid: typeof BRepOffsetAPI_MakeThickSolid;
  BRepOffsetAPI_MakeThickSolid_1: typeof BRepOffsetAPI_MakeThickSolid_1;
  BRepOffsetAPI_MakeThickSolid_2: typeof BRepOffsetAPI_MakeThickSolid_2;
  BRepOffsetAPI_SequenceOfSequenceOfReal: typeof BRepOffsetAPI_SequenceOfSequenceOfReal;
  BRepOffsetAPI_SequenceOfSequenceOfReal_1: typeof BRepOffsetAPI_SequenceOfSequenceOfReal_1;
  BRepOffsetAPI_SequenceOfSequenceOfReal_2: typeof BRepOffsetAPI_SequenceOfSequenceOfReal_2;
  BRepOffsetAPI_SequenceOfSequenceOfReal_3: typeof BRepOffsetAPI_SequenceOfSequenceOfReal_3;
  BRepOffsetAPI_MakeDraft: typeof BRepOffsetAPI_MakeDraft;
  BRepOffsetAPI_MakeFilling: typeof BRepOffsetAPI_MakeFilling;
  BRepOffsetAPI_DraftAngle: typeof BRepOffsetAPI_DraftAngle;
  BRepOffsetAPI_DraftAngle_1: typeof BRepOffsetAPI_DraftAngle_1;
  BRepOffsetAPI_DraftAngle_2: typeof BRepOffsetAPI_DraftAngle_2;
  BRepOffsetAPI_NormalProjection: typeof BRepOffsetAPI_NormalProjection;
  BRepOffsetAPI_NormalProjection_1: typeof BRepOffsetAPI_NormalProjection_1;
  BRepOffsetAPI_NormalProjection_2: typeof BRepOffsetAPI_NormalProjection_2;
  BRepOffsetAPI_MakePipe: typeof BRepOffsetAPI_MakePipe;
  BRepOffsetAPI_MakePipe_1: typeof BRepOffsetAPI_MakePipe_1;
  BRepOffsetAPI_MakePipe_2: typeof BRepOffsetAPI_MakePipe_2;
  BRepOffsetAPI_MakeOffset: typeof BRepOffsetAPI_MakeOffset;
  BRepOffsetAPI_MakeOffset_1: typeof BRepOffsetAPI_MakeOffset_1;
  BRepOffsetAPI_MakeOffset_2: typeof BRepOffsetAPI_MakeOffset_2;
  BRepOffsetAPI_MakeOffset_3: typeof BRepOffsetAPI_MakeOffset_3;
  BRepOffsetAPI_MakePipeShell: typeof BRepOffsetAPI_MakePipeShell;
  BRepOffsetAPI_MakeOffsetShape: typeof BRepOffsetAPI_MakeOffsetShape;
  BRepOffsetAPI_MakeOffsetShape_1: typeof BRepOffsetAPI_MakeOffsetShape_1;
  BRepOffsetAPI_MakeOffsetShape_2: typeof BRepOffsetAPI_MakeOffsetShape_2;
  RWGltf_GltfAccessorCompType: RWGltf_GltfAccessorCompType;
  RWGltf_GltfSceneNodeMap: typeof RWGltf_GltfSceneNodeMap;
  RWGltf_GltfMaterialMap: typeof RWGltf_GltfMaterialMap;
  RWGltf_GltfPrimitiveMode: RWGltf_GltfPrimitiveMode;
  RWGltf_GltfAccessor: typeof RWGltf_GltfAccessor;
  RWGltf_CafWriter: typeof RWGltf_CafWriter;
  RWGltf_GltfBufferViewTarget: RWGltf_GltfBufferViewTarget;
  RWGltf_WriterTrsfFormat: RWGltf_WriterTrsfFormat;
  RWGltf_CafReader: typeof RWGltf_CafReader;
  RWGltf_GltfSharedIStream: typeof RWGltf_GltfSharedIStream;
  RWGltf_PrimitiveArrayReader: typeof RWGltf_PrimitiveArrayReader;
  RWGltf_MaterialCommon: typeof RWGltf_MaterialCommon;
  RWGltf_MaterialMetallicRoughness: typeof RWGltf_MaterialMetallicRoughness;
  RWGltf_TriangulationReader: typeof RWGltf_TriangulationReader;
  RWGltf_GltfArrayType: RWGltf_GltfArrayType;
  RWGltf_GltfPrimArrayData: typeof RWGltf_GltfPrimArrayData;
  RWGltf_GltfPrimArrayData_1: typeof RWGltf_GltfPrimArrayData_1;
  RWGltf_GltfPrimArrayData_2: typeof RWGltf_GltfPrimArrayData_2;
  RWGltf_GltfFace: typeof RWGltf_GltfFace;
  RWGltf_GltfLatePrimitiveArray: typeof RWGltf_GltfLatePrimitiveArray;
  RWGltf_GltfRootElement: RWGltf_GltfRootElement;
  RWGltf_GltfAlphaMode: RWGltf_GltfAlphaMode;
  RWGltf_GltfOStreamWriter: typeof RWGltf_GltfOStreamWriter;
  RWGltf_GltfBufferView: typeof RWGltf_GltfBufferView;
  RWGltf_GltfAccessorLayout: RWGltf_GltfAccessorLayout;
  StepGeom_CompositeCurve: typeof StepGeom_CompositeCurve;
  Handle_StepGeom_CompositeCurve: typeof Handle_StepGeom_CompositeCurve;
  Handle_StepGeom_CompositeCurve_1: typeof Handle_StepGeom_CompositeCurve_1;
  Handle_StepGeom_CompositeCurve_2: typeof Handle_StepGeom_CompositeCurve_2;
  Handle_StepGeom_CompositeCurve_3: typeof Handle_StepGeom_CompositeCurve_3;
  Handle_StepGeom_CompositeCurve_4: typeof Handle_StepGeom_CompositeCurve_4;
  StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface: typeof StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface;
  Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface: typeof Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface;
  Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_1: typeof Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_1;
  Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_2: typeof Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_2;
  Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_3: typeof Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_3;
  Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_4: typeof Handle_StepGeom_QuasiUniformSurfaceAndRationalBSplineSurface_4;
  Handle_StepGeom_Parabola: typeof Handle_StepGeom_Parabola;
  Handle_StepGeom_Parabola_1: typeof Handle_StepGeom_Parabola_1;
  Handle_StepGeom_Parabola_2: typeof Handle_StepGeom_Parabola_2;
  Handle_StepGeom_Parabola_3: typeof Handle_StepGeom_Parabola_3;
  Handle_StepGeom_Parabola_4: typeof Handle_StepGeom_Parabola_4;
  StepGeom_Parabola: typeof StepGeom_Parabola;
  StepGeom_RectangularTrimmedSurface: typeof StepGeom_RectangularTrimmedSurface;
  Handle_StepGeom_RectangularTrimmedSurface: typeof Handle_StepGeom_RectangularTrimmedSurface;
  Handle_StepGeom_RectangularTrimmedSurface_1: typeof Handle_StepGeom_RectangularTrimmedSurface_1;
  Handle_StepGeom_RectangularTrimmedSurface_2: typeof Handle_StepGeom_RectangularTrimmedSurface_2;
  Handle_StepGeom_RectangularTrimmedSurface_3: typeof Handle_StepGeom_RectangularTrimmedSurface_3;
  Handle_StepGeom_RectangularTrimmedSurface_4: typeof Handle_StepGeom_RectangularTrimmedSurface_4;
  StepGeom_TransitionCode: StepGeom_TransitionCode;
  Handle_StepGeom_ConicalSurface: typeof Handle_StepGeom_ConicalSurface;
  Handle_StepGeom_ConicalSurface_1: typeof Handle_StepGeom_ConicalSurface_1;
  Handle_StepGeom_ConicalSurface_2: typeof Handle_StepGeom_ConicalSurface_2;
  Handle_StepGeom_ConicalSurface_3: typeof Handle_StepGeom_ConicalSurface_3;
  Handle_StepGeom_ConicalSurface_4: typeof Handle_StepGeom_ConicalSurface_4;
  StepGeom_ConicalSurface: typeof StepGeom_ConicalSurface;
  Handle_StepGeom_Polyline: typeof Handle_StepGeom_Polyline;
  Handle_StepGeom_Polyline_1: typeof Handle_StepGeom_Polyline_1;
  Handle_StepGeom_Polyline_2: typeof Handle_StepGeom_Polyline_2;
  Handle_StepGeom_Polyline_3: typeof Handle_StepGeom_Polyline_3;
  Handle_StepGeom_Polyline_4: typeof Handle_StepGeom_Polyline_4;
  StepGeom_Polyline: typeof StepGeom_Polyline;
  StepGeom_CartesianTransformationOperator3d: typeof StepGeom_CartesianTransformationOperator3d;
  Handle_StepGeom_CartesianTransformationOperator3d: typeof Handle_StepGeom_CartesianTransformationOperator3d;
  Handle_StepGeom_CartesianTransformationOperator3d_1: typeof Handle_StepGeom_CartesianTransformationOperator3d_1;
  Handle_StepGeom_CartesianTransformationOperator3d_2: typeof Handle_StepGeom_CartesianTransformationOperator3d_2;
  Handle_StepGeom_CartesianTransformationOperator3d_3: typeof Handle_StepGeom_CartesianTransformationOperator3d_3;
  Handle_StepGeom_CartesianTransformationOperator3d_4: typeof Handle_StepGeom_CartesianTransformationOperator3d_4;
  Handle_StepGeom_SurfaceOfLinearExtrusion: typeof Handle_StepGeom_SurfaceOfLinearExtrusion;
  Handle_StepGeom_SurfaceOfLinearExtrusion_1: typeof Handle_StepGeom_SurfaceOfLinearExtrusion_1;
  Handle_StepGeom_SurfaceOfLinearExtrusion_2: typeof Handle_StepGeom_SurfaceOfLinearExtrusion_2;
  Handle_StepGeom_SurfaceOfLinearExtrusion_3: typeof Handle_StepGeom_SurfaceOfLinearExtrusion_3;
  Handle_StepGeom_SurfaceOfLinearExtrusion_4: typeof Handle_StepGeom_SurfaceOfLinearExtrusion_4;
  StepGeom_SurfaceOfLinearExtrusion: typeof StepGeom_SurfaceOfLinearExtrusion;
  StepGeom_BezierSurfaceAndRationalBSplineSurface: typeof StepGeom_BezierSurfaceAndRationalBSplineSurface;
  Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface: typeof Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface;
  Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_1: typeof Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_1;
  Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_2: typeof Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_2;
  Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_3: typeof Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_3;
  Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_4: typeof Handle_StepGeom_BezierSurfaceAndRationalBSplineSurface_4;
  StepGeom_BSplineCurveForm: StepGeom_BSplineCurveForm;
  Handle_StepGeom_HArray1OfPcurveOrSurface: typeof Handle_StepGeom_HArray1OfPcurveOrSurface;
  Handle_StepGeom_HArray1OfPcurveOrSurface_1: typeof Handle_StepGeom_HArray1OfPcurveOrSurface_1;
  Handle_StepGeom_HArray1OfPcurveOrSurface_2: typeof Handle_StepGeom_HArray1OfPcurveOrSurface_2;
  Handle_StepGeom_HArray1OfPcurveOrSurface_3: typeof Handle_StepGeom_HArray1OfPcurveOrSurface_3;
  Handle_StepGeom_HArray1OfPcurveOrSurface_4: typeof Handle_StepGeom_HArray1OfPcurveOrSurface_4;
  StepGeom_GeometricRepresentationItem: typeof StepGeom_GeometricRepresentationItem;
  Handle_StepGeom_GeometricRepresentationItem: typeof Handle_StepGeom_GeometricRepresentationItem;
  Handle_StepGeom_GeometricRepresentationItem_1: typeof Handle_StepGeom_GeometricRepresentationItem_1;
  Handle_StepGeom_GeometricRepresentationItem_2: typeof Handle_StepGeom_GeometricRepresentationItem_2;
  Handle_StepGeom_GeometricRepresentationItem_3: typeof Handle_StepGeom_GeometricRepresentationItem_3;
  Handle_StepGeom_GeometricRepresentationItem_4: typeof Handle_StepGeom_GeometricRepresentationItem_4;
  Handle_StepGeom_HArray1OfTrimmingSelect: typeof Handle_StepGeom_HArray1OfTrimmingSelect;
  Handle_StepGeom_HArray1OfTrimmingSelect_1: typeof Handle_StepGeom_HArray1OfTrimmingSelect_1;
  Handle_StepGeom_HArray1OfTrimmingSelect_2: typeof Handle_StepGeom_HArray1OfTrimmingSelect_2;
  Handle_StepGeom_HArray1OfTrimmingSelect_3: typeof Handle_StepGeom_HArray1OfTrimmingSelect_3;
  Handle_StepGeom_HArray1OfTrimmingSelect_4: typeof Handle_StepGeom_HArray1OfTrimmingSelect_4;
  StepGeom_SurfaceCurveAndBoundedCurve: typeof StepGeom_SurfaceCurveAndBoundedCurve;
  Handle_StepGeom_SurfaceCurveAndBoundedCurve: typeof Handle_StepGeom_SurfaceCurveAndBoundedCurve;
  Handle_StepGeom_SurfaceCurveAndBoundedCurve_1: typeof Handle_StepGeom_SurfaceCurveAndBoundedCurve_1;
  Handle_StepGeom_SurfaceCurveAndBoundedCurve_2: typeof Handle_StepGeom_SurfaceCurveAndBoundedCurve_2;
  Handle_StepGeom_SurfaceCurveAndBoundedCurve_3: typeof Handle_StepGeom_SurfaceCurveAndBoundedCurve_3;
  Handle_StepGeom_SurfaceCurveAndBoundedCurve_4: typeof Handle_StepGeom_SurfaceCurveAndBoundedCurve_4;
  StepGeom_Curve: typeof StepGeom_Curve;
  Handle_StepGeom_Curve: typeof Handle_StepGeom_Curve;
  Handle_StepGeom_Curve_1: typeof Handle_StepGeom_Curve_1;
  Handle_StepGeom_Curve_2: typeof Handle_StepGeom_Curve_2;
  Handle_StepGeom_Curve_3: typeof Handle_StepGeom_Curve_3;
  Handle_StepGeom_Curve_4: typeof Handle_StepGeom_Curve_4;
  StepGeom_ReparametrisedCompositeCurveSegment: typeof StepGeom_ReparametrisedCompositeCurveSegment;
  Handle_StepGeom_ReparametrisedCompositeCurveSegment: typeof Handle_StepGeom_ReparametrisedCompositeCurveSegment;
  Handle_StepGeom_ReparametrisedCompositeCurveSegment_1: typeof Handle_StepGeom_ReparametrisedCompositeCurveSegment_1;
  Handle_StepGeom_ReparametrisedCompositeCurveSegment_2: typeof Handle_StepGeom_ReparametrisedCompositeCurveSegment_2;
  Handle_StepGeom_ReparametrisedCompositeCurveSegment_3: typeof Handle_StepGeom_ReparametrisedCompositeCurveSegment_3;
  Handle_StepGeom_ReparametrisedCompositeCurveSegment_4: typeof Handle_StepGeom_ReparametrisedCompositeCurveSegment_4;
  Handle_StepGeom_HArray1OfCurve: typeof Handle_StepGeom_HArray1OfCurve;
  Handle_StepGeom_HArray1OfCurve_1: typeof Handle_StepGeom_HArray1OfCurve_1;
  Handle_StepGeom_HArray1OfCurve_2: typeof Handle_StepGeom_HArray1OfCurve_2;
  Handle_StepGeom_HArray1OfCurve_3: typeof Handle_StepGeom_HArray1OfCurve_3;
  Handle_StepGeom_HArray1OfCurve_4: typeof Handle_StepGeom_HArray1OfCurve_4;
  StepGeom_BSplineSurfaceForm: StepGeom_BSplineSurfaceForm;
  StepGeom_SurfaceReplica: typeof StepGeom_SurfaceReplica;
  Handle_StepGeom_SurfaceReplica: typeof Handle_StepGeom_SurfaceReplica;
  Handle_StepGeom_SurfaceReplica_1: typeof Handle_StepGeom_SurfaceReplica_1;
  Handle_StepGeom_SurfaceReplica_2: typeof Handle_StepGeom_SurfaceReplica_2;
  Handle_StepGeom_SurfaceReplica_3: typeof Handle_StepGeom_SurfaceReplica_3;
  Handle_StepGeom_SurfaceReplica_4: typeof Handle_StepGeom_SurfaceReplica_4;
  StepGeom_TrimmingPreference: StepGeom_TrimmingPreference;
  Handle_StepGeom_DegenerateToroidalSurface: typeof Handle_StepGeom_DegenerateToroidalSurface;
  Handle_StepGeom_DegenerateToroidalSurface_1: typeof Handle_StepGeom_DegenerateToroidalSurface_1;
  Handle_StepGeom_DegenerateToroidalSurface_2: typeof Handle_StepGeom_DegenerateToroidalSurface_2;
  Handle_StepGeom_DegenerateToroidalSurface_3: typeof Handle_StepGeom_DegenerateToroidalSurface_3;
  Handle_StepGeom_DegenerateToroidalSurface_4: typeof Handle_StepGeom_DegenerateToroidalSurface_4;
  StepGeom_DegenerateToroidalSurface: typeof StepGeom_DegenerateToroidalSurface;
  Handle_StepGeom_UniformCurve: typeof Handle_StepGeom_UniformCurve;
  Handle_StepGeom_UniformCurve_1: typeof Handle_StepGeom_UniformCurve_1;
  Handle_StepGeom_UniformCurve_2: typeof Handle_StepGeom_UniformCurve_2;
  Handle_StepGeom_UniformCurve_3: typeof Handle_StepGeom_UniformCurve_3;
  Handle_StepGeom_UniformCurve_4: typeof Handle_StepGeom_UniformCurve_4;
  StepGeom_UniformCurve: typeof StepGeom_UniformCurve;
  StepGeom_Point: typeof StepGeom_Point;
  Handle_StepGeom_Point: typeof Handle_StepGeom_Point;
  Handle_StepGeom_Point_1: typeof Handle_StepGeom_Point_1;
  Handle_StepGeom_Point_2: typeof Handle_StepGeom_Point_2;
  Handle_StepGeom_Point_3: typeof Handle_StepGeom_Point_3;
  Handle_StepGeom_Point_4: typeof Handle_StepGeom_Point_4;
  StepGeom_GeometricRepresentationContextAndParametricRepresentationContext: typeof StepGeom_GeometricRepresentationContextAndParametricRepresentationContext;
  Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext: typeof Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext;
  Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_1: typeof Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_1;
  Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_2: typeof Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_2;
  Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_3: typeof Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_3;
  Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_4: typeof Handle_StepGeom_GeometricRepresentationContextAndParametricRepresentationContext_4;
  StepGeom_Axis1Placement: typeof StepGeom_Axis1Placement;
  Handle_StepGeom_Axis1Placement: typeof Handle_StepGeom_Axis1Placement;
  Handle_StepGeom_Axis1Placement_1: typeof Handle_StepGeom_Axis1Placement_1;
  Handle_StepGeom_Axis1Placement_2: typeof Handle_StepGeom_Axis1Placement_2;
  Handle_StepGeom_Axis1Placement_3: typeof Handle_StepGeom_Axis1Placement_3;
  Handle_StepGeom_Axis1Placement_4: typeof Handle_StepGeom_Axis1Placement_4;
  StepGeom_Pcurve: typeof StepGeom_Pcurve;
  Handle_StepGeom_Pcurve: typeof Handle_StepGeom_Pcurve;
  Handle_StepGeom_Pcurve_1: typeof Handle_StepGeom_Pcurve_1;
  Handle_StepGeom_Pcurve_2: typeof Handle_StepGeom_Pcurve_2;
  Handle_StepGeom_Pcurve_3: typeof Handle_StepGeom_Pcurve_3;
  Handle_StepGeom_Pcurve_4: typeof Handle_StepGeom_Pcurve_4;
  StepGeom_VectorOrDirection: typeof StepGeom_VectorOrDirection;
  StepGeom_Line: typeof StepGeom_Line;
  Handle_StepGeom_Line: typeof Handle_StepGeom_Line;
  Handle_StepGeom_Line_1: typeof Handle_StepGeom_Line_1;
  Handle_StepGeom_Line_2: typeof Handle_StepGeom_Line_2;
  Handle_StepGeom_Line_3: typeof Handle_StepGeom_Line_3;
  Handle_StepGeom_Line_4: typeof Handle_StepGeom_Line_4;
  Handle_StepGeom_Plane: typeof Handle_StepGeom_Plane;
  Handle_StepGeom_Plane_1: typeof Handle_StepGeom_Plane_1;
  Handle_StepGeom_Plane_2: typeof Handle_StepGeom_Plane_2;
  Handle_StepGeom_Plane_3: typeof Handle_StepGeom_Plane_3;
  Handle_StepGeom_Plane_4: typeof Handle_StepGeom_Plane_4;
  StepGeom_Plane: typeof StepGeom_Plane;
  Handle_StepGeom_CurveBoundedSurface: typeof Handle_StepGeom_CurveBoundedSurface;
  Handle_StepGeom_CurveBoundedSurface_1: typeof Handle_StepGeom_CurveBoundedSurface_1;
  Handle_StepGeom_CurveBoundedSurface_2: typeof Handle_StepGeom_CurveBoundedSurface_2;
  Handle_StepGeom_CurveBoundedSurface_3: typeof Handle_StepGeom_CurveBoundedSurface_3;
  Handle_StepGeom_CurveBoundedSurface_4: typeof Handle_StepGeom_CurveBoundedSurface_4;
  StepGeom_CurveBoundedSurface: typeof StepGeom_CurveBoundedSurface;
  StepGeom_CylindricalSurface: typeof StepGeom_CylindricalSurface;
  Handle_StepGeom_CylindricalSurface: typeof Handle_StepGeom_CylindricalSurface;
  Handle_StepGeom_CylindricalSurface_1: typeof Handle_StepGeom_CylindricalSurface_1;
  Handle_StepGeom_CylindricalSurface_2: typeof Handle_StepGeom_CylindricalSurface_2;
  Handle_StepGeom_CylindricalSurface_3: typeof Handle_StepGeom_CylindricalSurface_3;
  Handle_StepGeom_CylindricalSurface_4: typeof Handle_StepGeom_CylindricalSurface_4;
  StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx: typeof StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx;
  Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx: typeof Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx;
  Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_1: typeof Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_1;
  Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_2: typeof Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_2;
  Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_3: typeof Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_3;
  Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_4: typeof Handle_StepGeom_GeomRepContextAndGlobUnitAssCtxAndGlobUncertaintyAssCtx_4;
  StepGeom_QuasiUniformSurface: typeof StepGeom_QuasiUniformSurface;
  Handle_StepGeom_QuasiUniformSurface: typeof Handle_StepGeom_QuasiUniformSurface;
  Handle_StepGeom_QuasiUniformSurface_1: typeof Handle_StepGeom_QuasiUniformSurface_1;
  Handle_StepGeom_QuasiUniformSurface_2: typeof Handle_StepGeom_QuasiUniformSurface_2;
  Handle_StepGeom_QuasiUniformSurface_3: typeof Handle_StepGeom_QuasiUniformSurface_3;
  Handle_StepGeom_QuasiUniformSurface_4: typeof Handle_StepGeom_QuasiUniformSurface_4;
  Handle_StepGeom_Vector: typeof Handle_StepGeom_Vector;
  Handle_StepGeom_Vector_1: typeof Handle_StepGeom_Vector_1;
  Handle_StepGeom_Vector_2: typeof Handle_StepGeom_Vector_2;
  Handle_StepGeom_Vector_3: typeof Handle_StepGeom_Vector_3;
  Handle_StepGeom_Vector_4: typeof Handle_StepGeom_Vector_4;
  StepGeom_Vector: typeof StepGeom_Vector;
  StepGeom_QuasiUniformCurveAndRationalBSplineCurve: typeof StepGeom_QuasiUniformCurveAndRationalBSplineCurve;
  Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve: typeof Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve;
  Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_1: typeof Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_1;
  Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_2: typeof Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_2;
  Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_3: typeof Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_3;
  Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_4: typeof Handle_StepGeom_QuasiUniformCurveAndRationalBSplineCurve_4;
  Handle_StepGeom_SphericalSurface: typeof Handle_StepGeom_SphericalSurface;
  Handle_StepGeom_SphericalSurface_1: typeof Handle_StepGeom_SphericalSurface_1;
  Handle_StepGeom_SphericalSurface_2: typeof Handle_StepGeom_SphericalSurface_2;
  Handle_StepGeom_SphericalSurface_3: typeof Handle_StepGeom_SphericalSurface_3;
  Handle_StepGeom_SphericalSurface_4: typeof Handle_StepGeom_SphericalSurface_4;
  StepGeom_SphericalSurface: typeof StepGeom_SphericalSurface;
  StepGeom_Axis2Placement3d: typeof StepGeom_Axis2Placement3d;
  Handle_StepGeom_Axis2Placement3d: typeof Handle_StepGeom_Axis2Placement3d;
  Handle_StepGeom_Axis2Placement3d_1: typeof Handle_StepGeom_Axis2Placement3d_1;
  Handle_StepGeom_Axis2Placement3d_2: typeof Handle_StepGeom_Axis2Placement3d_2;
  Handle_StepGeom_Axis2Placement3d_3: typeof Handle_StepGeom_Axis2Placement3d_3;
  Handle_StepGeom_Axis2Placement3d_4: typeof Handle_StepGeom_Axis2Placement3d_4;
  Handle_StepGeom_HArray2OfSurfacePatch: typeof Handle_StepGeom_HArray2OfSurfacePatch;
  Handle_StepGeom_HArray2OfSurfacePatch_1: typeof Handle_StepGeom_HArray2OfSurfacePatch_1;
  Handle_StepGeom_HArray2OfSurfacePatch_2: typeof Handle_StepGeom_HArray2OfSurfacePatch_2;
  Handle_StepGeom_HArray2OfSurfacePatch_3: typeof Handle_StepGeom_HArray2OfSurfacePatch_3;
  Handle_StepGeom_HArray2OfSurfacePatch_4: typeof Handle_StepGeom_HArray2OfSurfacePatch_4;
  Handle_StepGeom_BoundedCurve: typeof Handle_StepGeom_BoundedCurve;
  Handle_StepGeom_BoundedCurve_1: typeof Handle_StepGeom_BoundedCurve_1;
  Handle_StepGeom_BoundedCurve_2: typeof Handle_StepGeom_BoundedCurve_2;
  Handle_StepGeom_BoundedCurve_3: typeof Handle_StepGeom_BoundedCurve_3;
  Handle_StepGeom_BoundedCurve_4: typeof Handle_StepGeom_BoundedCurve_4;
  StepGeom_BoundedCurve: typeof StepGeom_BoundedCurve;
  StepGeom_TrimmedCurve: typeof StepGeom_TrimmedCurve;
  Handle_StepGeom_TrimmedCurve: typeof Handle_StepGeom_TrimmedCurve;
  Handle_StepGeom_TrimmedCurve_1: typeof Handle_StepGeom_TrimmedCurve_1;
  Handle_StepGeom_TrimmedCurve_2: typeof Handle_StepGeom_TrimmedCurve_2;
  Handle_StepGeom_TrimmedCurve_3: typeof Handle_StepGeom_TrimmedCurve_3;
  Handle_StepGeom_TrimmedCurve_4: typeof Handle_StepGeom_TrimmedCurve_4;
  Handle_StepGeom_SurfacePatch: typeof Handle_StepGeom_SurfacePatch;
  Handle_StepGeom_SurfacePatch_1: typeof Handle_StepGeom_SurfacePatch_1;
  Handle_StepGeom_SurfacePatch_2: typeof Handle_StepGeom_SurfacePatch_2;
  Handle_StepGeom_SurfacePatch_3: typeof Handle_StepGeom_SurfacePatch_3;
  Handle_StepGeom_SurfacePatch_4: typeof Handle_StepGeom_SurfacePatch_4;
  StepGeom_SurfacePatch: typeof StepGeom_SurfacePatch;
  StepGeom_Ellipse: typeof StepGeom_Ellipse;
  Handle_StepGeom_Ellipse: typeof Handle_StepGeom_Ellipse;
  Handle_StepGeom_Ellipse_1: typeof Handle_StepGeom_Ellipse_1;
  Handle_StepGeom_Ellipse_2: typeof Handle_StepGeom_Ellipse_2;
  Handle_StepGeom_Ellipse_3: typeof Handle_StepGeom_Ellipse_3;
  Handle_StepGeom_Ellipse_4: typeof Handle_StepGeom_Ellipse_4;
  StepGeom_BezierCurve: typeof StepGeom_BezierCurve;
  Handle_StepGeom_BezierCurve: typeof Handle_StepGeom_BezierCurve;
  Handle_StepGeom_BezierCurve_1: typeof Handle_StepGeom_BezierCurve_1;
  Handle_StepGeom_BezierCurve_2: typeof Handle_StepGeom_BezierCurve_2;
  Handle_StepGeom_BezierCurve_3: typeof Handle_StepGeom_BezierCurve_3;
  Handle_StepGeom_BezierCurve_4: typeof Handle_StepGeom_BezierCurve_4;
  Handle_StepGeom_CartesianPoint: typeof Handle_StepGeom_CartesianPoint;
  Handle_StepGeom_CartesianPoint_1: typeof Handle_StepGeom_CartesianPoint_1;
  Handle_StepGeom_CartesianPoint_2: typeof Handle_StepGeom_CartesianPoint_2;
  Handle_StepGeom_CartesianPoint_3: typeof Handle_StepGeom_CartesianPoint_3;
  Handle_StepGeom_CartesianPoint_4: typeof Handle_StepGeom_CartesianPoint_4;
  StepGeom_CartesianPoint: typeof StepGeom_CartesianPoint;
  StepGeom_BSplineCurve: typeof StepGeom_BSplineCurve;
  Handle_StepGeom_BSplineCurve: typeof Handle_StepGeom_BSplineCurve;
  Handle_StepGeom_BSplineCurve_1: typeof Handle_StepGeom_BSplineCurve_1;
  Handle_StepGeom_BSplineCurve_2: typeof Handle_StepGeom_BSplineCurve_2;
  Handle_StepGeom_BSplineCurve_3: typeof Handle_StepGeom_BSplineCurve_3;
  Handle_StepGeom_BSplineCurve_4: typeof Handle_StepGeom_BSplineCurve_4;
  StepGeom_Axis2Placement2d: typeof StepGeom_Axis2Placement2d;
  Handle_StepGeom_Axis2Placement2d: typeof Handle_StepGeom_Axis2Placement2d;
  Handle_StepGeom_Axis2Placement2d_1: typeof Handle_StepGeom_Axis2Placement2d_1;
  Handle_StepGeom_Axis2Placement2d_2: typeof Handle_StepGeom_Axis2Placement2d_2;
  Handle_StepGeom_Axis2Placement2d_3: typeof Handle_StepGeom_Axis2Placement2d_3;
  Handle_StepGeom_Axis2Placement2d_4: typeof Handle_StepGeom_Axis2Placement2d_4;
  Handle_StepGeom_QuasiUniformCurve: typeof Handle_StepGeom_QuasiUniformCurve;
  Handle_StepGeom_QuasiUniformCurve_1: typeof Handle_StepGeom_QuasiUniformCurve_1;
  Handle_StepGeom_QuasiUniformCurve_2: typeof Handle_StepGeom_QuasiUniformCurve_2;
  Handle_StepGeom_QuasiUniformCurve_3: typeof Handle_StepGeom_QuasiUniformCurve_3;
  Handle_StepGeom_QuasiUniformCurve_4: typeof Handle_StepGeom_QuasiUniformCurve_4;
  StepGeom_QuasiUniformCurve: typeof StepGeom_QuasiUniformCurve;
  Handle_StepGeom_SurfaceOfRevolution: typeof Handle_StepGeom_SurfaceOfRevolution;
  Handle_StepGeom_SurfaceOfRevolution_1: typeof Handle_StepGeom_SurfaceOfRevolution_1;
  Handle_StepGeom_SurfaceOfRevolution_2: typeof Handle_StepGeom_SurfaceOfRevolution_2;
  Handle_StepGeom_SurfaceOfRevolution_3: typeof Handle_StepGeom_SurfaceOfRevolution_3;
  Handle_StepGeom_SurfaceOfRevolution_4: typeof Handle_StepGeom_SurfaceOfRevolution_4;
  StepGeom_SurfaceOfRevolution: typeof StepGeom_SurfaceOfRevolution;
  StepGeom_SweptSurface: typeof StepGeom_SweptSurface;
  Handle_StepGeom_SweptSurface: typeof Handle_StepGeom_SweptSurface;
  Handle_StepGeom_SweptSurface_1: typeof Handle_StepGeom_SweptSurface_1;
  Handle_StepGeom_SweptSurface_2: typeof Handle_StepGeom_SweptSurface_2;
  Handle_StepGeom_SweptSurface_3: typeof Handle_StepGeom_SweptSurface_3;
  Handle_StepGeom_SweptSurface_4: typeof Handle_StepGeom_SweptSurface_4;
  Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext: typeof Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext;
  Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_1: typeof Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_1;
  Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_2: typeof Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_2;
  Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_3: typeof Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_3;
  Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_4: typeof Handle_StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext_4;
  StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext: typeof StepGeom_GeometricRepresentationContextAndGlobalUnitAssignedContext;
  StepGeom_OrientedSurface: typeof StepGeom_OrientedSurface;
  Handle_StepGeom_OrientedSurface: typeof Handle_StepGeom_OrientedSurface;
  Handle_StepGeom_OrientedSurface_1: typeof Handle_StepGeom_OrientedSurface_1;
  Handle_StepGeom_OrientedSurface_2: typeof Handle_StepGeom_OrientedSurface_2;
  Handle_StepGeom_OrientedSurface_3: typeof Handle_StepGeom_OrientedSurface_3;
  Handle_StepGeom_OrientedSurface_4: typeof Handle_StepGeom_OrientedSurface_4;
  StepGeom_RationalBSplineSurface: typeof StepGeom_RationalBSplineSurface;
  Handle_StepGeom_RationalBSplineSurface: typeof Handle_StepGeom_RationalBSplineSurface;
  Handle_StepGeom_RationalBSplineSurface_1: typeof Handle_StepGeom_RationalBSplineSurface_1;
  Handle_StepGeom_RationalBSplineSurface_2: typeof Handle_StepGeom_RationalBSplineSurface_2;
  Handle_StepGeom_RationalBSplineSurface_3: typeof Handle_StepGeom_RationalBSplineSurface_3;
  Handle_StepGeom_RationalBSplineSurface_4: typeof Handle_StepGeom_RationalBSplineSurface_4;
  StepGeom_Surface: typeof StepGeom_Surface;
  Handle_StepGeom_Surface: typeof Handle_StepGeom_Surface;
  Handle_StepGeom_Surface_1: typeof Handle_StepGeom_Surface_1;
  Handle_StepGeom_Surface_2: typeof Handle_StepGeom_Surface_2;
  Handle_StepGeom_Surface_3: typeof Handle_StepGeom_Surface_3;
  Handle_StepGeom_Surface_4: typeof Handle_StepGeom_Surface_4;
  StepGeom_UniformSurface: typeof StepGeom_UniformSurface;
  Handle_StepGeom_UniformSurface: typeof Handle_StepGeom_UniformSurface;
  Handle_StepGeom_UniformSurface_1: typeof Handle_StepGeom_UniformSurface_1;
  Handle_StepGeom_UniformSurface_2: typeof Handle_StepGeom_UniformSurface_2;
  Handle_StepGeom_UniformSurface_3: typeof Handle_StepGeom_UniformSurface_3;
  Handle_StepGeom_UniformSurface_4: typeof Handle_StepGeom_UniformSurface_4;
  StepGeom_KnotType: StepGeom_KnotType;
  Handle_StepGeom_HArray1OfCartesianPoint: typeof Handle_StepGeom_HArray1OfCartesianPoint;
  Handle_StepGeom_HArray1OfCartesianPoint_1: typeof Handle_StepGeom_HArray1OfCartesianPoint_1;
  Handle_StepGeom_HArray1OfCartesianPoint_2: typeof Handle_StepGeom_HArray1OfCartesianPoint_2;
  Handle_StepGeom_HArray1OfCartesianPoint_3: typeof Handle_StepGeom_HArray1OfCartesianPoint_3;
  Handle_StepGeom_HArray1OfCartesianPoint_4: typeof Handle_StepGeom_HArray1OfCartesianPoint_4;
  StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve: typeof StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve;
  Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve: typeof Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve;
  Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_1: typeof Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_1;
  Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_2: typeof Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_2;
  Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_3: typeof Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_3;
  Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_4: typeof Handle_StepGeom_BSplineCurveWithKnotsAndRationalBSplineCurve_4;
  StepGeom_Axis2Placement: typeof StepGeom_Axis2Placement;
  Handle_StepGeom_HArray2OfCartesianPoint: typeof Handle_StepGeom_HArray2OfCartesianPoint;
  Handle_StepGeom_HArray2OfCartesianPoint_1: typeof Handle_StepGeom_HArray2OfCartesianPoint_1;
  Handle_StepGeom_HArray2OfCartesianPoint_2: typeof Handle_StepGeom_HArray2OfCartesianPoint_2;
  Handle_StepGeom_HArray2OfCartesianPoint_3: typeof Handle_StepGeom_HArray2OfCartesianPoint_3;
  Handle_StepGeom_HArray2OfCartesianPoint_4: typeof Handle_StepGeom_HArray2OfCartesianPoint_4;
  Handle_StepGeom_BSplineCurveWithKnots: typeof Handle_StepGeom_BSplineCurveWithKnots;
  Handle_StepGeom_BSplineCurveWithKnots_1: typeof Handle_StepGeom_BSplineCurveWithKnots_1;
  Handle_StepGeom_BSplineCurveWithKnots_2: typeof Handle_StepGeom_BSplineCurveWithKnots_2;
  Handle_StepGeom_BSplineCurveWithKnots_3: typeof Handle_StepGeom_BSplineCurveWithKnots_3;
  Handle_StepGeom_BSplineCurveWithKnots_4: typeof Handle_StepGeom_BSplineCurveWithKnots_4;
  StepGeom_BSplineCurveWithKnots: typeof StepGeom_BSplineCurveWithKnots;
  Handle_StepGeom_CompositeCurveSegment: typeof Handle_StepGeom_CompositeCurveSegment;
  Handle_StepGeom_CompositeCurveSegment_1: typeof Handle_StepGeom_CompositeCurveSegment_1;
  Handle_StepGeom_CompositeCurveSegment_2: typeof Handle_StepGeom_CompositeCurveSegment_2;
  Handle_StepGeom_CompositeCurveSegment_3: typeof Handle_StepGeom_CompositeCurveSegment_3;
  Handle_StepGeom_CompositeCurveSegment_4: typeof Handle_StepGeom_CompositeCurveSegment_4;
  StepGeom_CompositeCurveSegment: typeof StepGeom_CompositeCurveSegment;
  Handle_StepGeom_RationalBSplineCurve: typeof Handle_StepGeom_RationalBSplineCurve;
  Handle_StepGeom_RationalBSplineCurve_1: typeof Handle_StepGeom_RationalBSplineCurve_1;
  Handle_StepGeom_RationalBSplineCurve_2: typeof Handle_StepGeom_RationalBSplineCurve_2;
  Handle_StepGeom_RationalBSplineCurve_3: typeof Handle_StepGeom_RationalBSplineCurve_3;
  Handle_StepGeom_RationalBSplineCurve_4: typeof Handle_StepGeom_RationalBSplineCurve_4;
  StepGeom_RationalBSplineCurve: typeof StepGeom_RationalBSplineCurve;
  Handle_StepGeom_CartesianTransformationOperator2d: typeof Handle_StepGeom_CartesianTransformationOperator2d;
  Handle_StepGeom_CartesianTransformationOperator2d_1: typeof Handle_StepGeom_CartesianTransformationOperator2d_1;
  Handle_StepGeom_CartesianTransformationOperator2d_2: typeof Handle_StepGeom_CartesianTransformationOperator2d_2;
  Handle_StepGeom_CartesianTransformationOperator2d_3: typeof Handle_StepGeom_CartesianTransformationOperator2d_3;
  Handle_StepGeom_CartesianTransformationOperator2d_4: typeof Handle_StepGeom_CartesianTransformationOperator2d_4;
  StepGeom_CartesianTransformationOperator2d: typeof StepGeom_CartesianTransformationOperator2d;
  Handle_StepGeom_Hyperbola: typeof Handle_StepGeom_Hyperbola;
  Handle_StepGeom_Hyperbola_1: typeof Handle_StepGeom_Hyperbola_1;
  Handle_StepGeom_Hyperbola_2: typeof Handle_StepGeom_Hyperbola_2;
  Handle_StepGeom_Hyperbola_3: typeof Handle_StepGeom_Hyperbola_3;
  Handle_StepGeom_Hyperbola_4: typeof Handle_StepGeom_Hyperbola_4;
  StepGeom_Hyperbola: typeof StepGeom_Hyperbola;
  Handle_StepGeom_HArray1OfBoundaryCurve: typeof Handle_StepGeom_HArray1OfBoundaryCurve;
  Handle_StepGeom_HArray1OfBoundaryCurve_1: typeof Handle_StepGeom_HArray1OfBoundaryCurve_1;
  Handle_StepGeom_HArray1OfBoundaryCurve_2: typeof Handle_StepGeom_HArray1OfBoundaryCurve_2;
  Handle_StepGeom_HArray1OfBoundaryCurve_3: typeof Handle_StepGeom_HArray1OfBoundaryCurve_3;
  Handle_StepGeom_HArray1OfBoundaryCurve_4: typeof Handle_StepGeom_HArray1OfBoundaryCurve_4;
  StepGeom_Array1OfSurfaceBoundary: typeof StepGeom_Array1OfSurfaceBoundary;
  StepGeom_Array1OfSurfaceBoundary_1: typeof StepGeom_Array1OfSurfaceBoundary_1;
  StepGeom_Array1OfSurfaceBoundary_2: typeof StepGeom_Array1OfSurfaceBoundary_2;
  StepGeom_Array1OfSurfaceBoundary_3: typeof StepGeom_Array1OfSurfaceBoundary_3;
  StepGeom_Array1OfSurfaceBoundary_4: typeof StepGeom_Array1OfSurfaceBoundary_4;
  StepGeom_Array1OfSurfaceBoundary_5: typeof StepGeom_Array1OfSurfaceBoundary_5;
  StepGeom_TrimmingSelect: typeof StepGeom_TrimmingSelect;
  StepGeom_BezierSurface: typeof StepGeom_BezierSurface;
  Handle_StepGeom_BezierSurface: typeof Handle_StepGeom_BezierSurface;
  Handle_StepGeom_BezierSurface_1: typeof Handle_StepGeom_BezierSurface_1;
  Handle_StepGeom_BezierSurface_2: typeof Handle_StepGeom_BezierSurface_2;
  Handle_StepGeom_BezierSurface_3: typeof Handle_StepGeom_BezierSurface_3;
  Handle_StepGeom_BezierSurface_4: typeof Handle_StepGeom_BezierSurface_4;
  Handle_StepGeom_SurfaceCurve: typeof Handle_StepGeom_SurfaceCurve;
  Handle_StepGeom_SurfaceCurve_1: typeof Handle_StepGeom_SurfaceCurve_1;
  Handle_StepGeom_SurfaceCurve_2: typeof Handle_StepGeom_SurfaceCurve_2;
  Handle_StepGeom_SurfaceCurve_3: typeof Handle_StepGeom_SurfaceCurve_3;
  Handle_StepGeom_SurfaceCurve_4: typeof Handle_StepGeom_SurfaceCurve_4;
  StepGeom_SurfaceCurve: typeof StepGeom_SurfaceCurve;
  StepGeom_GeometricRepresentationContext: typeof StepGeom_GeometricRepresentationContext;
  Handle_StepGeom_GeometricRepresentationContext: typeof Handle_StepGeom_GeometricRepresentationContext;
  Handle_StepGeom_GeometricRepresentationContext_1: typeof Handle_StepGeom_GeometricRepresentationContext_1;
  Handle_StepGeom_GeometricRepresentationContext_2: typeof Handle_StepGeom_GeometricRepresentationContext_2;
  Handle_StepGeom_GeometricRepresentationContext_3: typeof Handle_StepGeom_GeometricRepresentationContext_3;
  Handle_StepGeom_GeometricRepresentationContext_4: typeof Handle_StepGeom_GeometricRepresentationContext_4;
  StepGeom_DegeneratePcurve: typeof StepGeom_DegeneratePcurve;
  Handle_StepGeom_DegeneratePcurve: typeof Handle_StepGeom_DegeneratePcurve;
  Handle_StepGeom_DegeneratePcurve_1: typeof Handle_StepGeom_DegeneratePcurve_1;
  Handle_StepGeom_DegeneratePcurve_2: typeof Handle_StepGeom_DegeneratePcurve_2;
  Handle_StepGeom_DegeneratePcurve_3: typeof Handle_StepGeom_DegeneratePcurve_3;
  Handle_StepGeom_DegeneratePcurve_4: typeof Handle_StepGeom_DegeneratePcurve_4;
  StepGeom_PreferredSurfaceCurveRepresentation: StepGeom_PreferredSurfaceCurveRepresentation;
  StepGeom_EvaluatedDegeneratePcurve: typeof StepGeom_EvaluatedDegeneratePcurve;
  Handle_StepGeom_EvaluatedDegeneratePcurve: typeof Handle_StepGeom_EvaluatedDegeneratePcurve;
  Handle_StepGeom_EvaluatedDegeneratePcurve_1: typeof Handle_StepGeom_EvaluatedDegeneratePcurve_1;
  Handle_StepGeom_EvaluatedDegeneratePcurve_2: typeof Handle_StepGeom_EvaluatedDegeneratePcurve_2;
  Handle_StepGeom_EvaluatedDegeneratePcurve_3: typeof Handle_StepGeom_EvaluatedDegeneratePcurve_3;
  Handle_StepGeom_EvaluatedDegeneratePcurve_4: typeof Handle_StepGeom_EvaluatedDegeneratePcurve_4;
  Handle_StepGeom_OffsetCurve3d: typeof Handle_StepGeom_OffsetCurve3d;
  Handle_StepGeom_OffsetCurve3d_1: typeof Handle_StepGeom_OffsetCurve3d_1;
  Handle_StepGeom_OffsetCurve3d_2: typeof Handle_StepGeom_OffsetCurve3d_2;
  Handle_StepGeom_OffsetCurve3d_3: typeof Handle_StepGeom_OffsetCurve3d_3;
  Handle_StepGeom_OffsetCurve3d_4: typeof Handle_StepGeom_OffsetCurve3d_4;
  StepGeom_OffsetCurve3d: typeof StepGeom_OffsetCurve3d;
  StepGeom_IntersectionCurve: typeof StepGeom_IntersectionCurve;
  Handle_StepGeom_IntersectionCurve: typeof Handle_StepGeom_IntersectionCurve;
  Handle_StepGeom_IntersectionCurve_1: typeof Handle_StepGeom_IntersectionCurve_1;
  Handle_StepGeom_IntersectionCurve_2: typeof Handle_StepGeom_IntersectionCurve_2;
  Handle_StepGeom_IntersectionCurve_3: typeof Handle_StepGeom_IntersectionCurve_3;
  Handle_StepGeom_IntersectionCurve_4: typeof Handle_StepGeom_IntersectionCurve_4;
  Handle_StepGeom_TrimmingMember: typeof Handle_StepGeom_TrimmingMember;
  Handle_StepGeom_TrimmingMember_1: typeof Handle_StepGeom_TrimmingMember_1;
  Handle_StepGeom_TrimmingMember_2: typeof Handle_StepGeom_TrimmingMember_2;
  Handle_StepGeom_TrimmingMember_3: typeof Handle_StepGeom_TrimmingMember_3;
  Handle_StepGeom_TrimmingMember_4: typeof Handle_StepGeom_TrimmingMember_4;
  StepGeom_TrimmingMember: typeof StepGeom_TrimmingMember;
  Handle_StepGeom_Conic: typeof Handle_StepGeom_Conic;
  Handle_StepGeom_Conic_1: typeof Handle_StepGeom_Conic_1;
  Handle_StepGeom_Conic_2: typeof Handle_StepGeom_Conic_2;
  Handle_StepGeom_Conic_3: typeof Handle_StepGeom_Conic_3;
  Handle_StepGeom_Conic_4: typeof Handle_StepGeom_Conic_4;
  StepGeom_Conic: typeof StepGeom_Conic;
  Handle_StepGeom_RectangularCompositeSurface: typeof Handle_StepGeom_RectangularCompositeSurface;
  Handle_StepGeom_RectangularCompositeSurface_1: typeof Handle_StepGeom_RectangularCompositeSurface_1;
  Handle_StepGeom_RectangularCompositeSurface_2: typeof Handle_StepGeom_RectangularCompositeSurface_2;
  Handle_StepGeom_RectangularCompositeSurface_3: typeof Handle_StepGeom_RectangularCompositeSurface_3;
  Handle_StepGeom_RectangularCompositeSurface_4: typeof Handle_StepGeom_RectangularCompositeSurface_4;
  StepGeom_RectangularCompositeSurface: typeof StepGeom_RectangularCompositeSurface;
  StepGeom_Array1OfPcurveOrSurface: typeof StepGeom_Array1OfPcurveOrSurface;
  StepGeom_Array1OfPcurveOrSurface_1: typeof StepGeom_Array1OfPcurveOrSurface_1;
  StepGeom_Array1OfPcurveOrSurface_2: typeof StepGeom_Array1OfPcurveOrSurface_2;
  StepGeom_Array1OfPcurveOrSurface_3: typeof StepGeom_Array1OfPcurveOrSurface_3;
  StepGeom_Array1OfPcurveOrSurface_4: typeof StepGeom_Array1OfPcurveOrSurface_4;
  StepGeom_Array1OfPcurveOrSurface_5: typeof StepGeom_Array1OfPcurveOrSurface_5;
  Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface: typeof Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface;
  Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_1: typeof Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_1;
  Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_2: typeof Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_2;
  Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_3: typeof Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_3;
  Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_4: typeof Handle_StepGeom_UniformSurfaceAndRationalBSplineSurface_4;
  StepGeom_UniformSurfaceAndRationalBSplineSurface: typeof StepGeom_UniformSurfaceAndRationalBSplineSurface;
  Handle_StepGeom_OuterBoundaryCurve: typeof Handle_StepGeom_OuterBoundaryCurve;
  Handle_StepGeom_OuterBoundaryCurve_1: typeof Handle_StepGeom_OuterBoundaryCurve_1;
  Handle_StepGeom_OuterBoundaryCurve_2: typeof Handle_StepGeom_OuterBoundaryCurve_2;
  Handle_StepGeom_OuterBoundaryCurve_3: typeof Handle_StepGeom_OuterBoundaryCurve_3;
  Handle_StepGeom_OuterBoundaryCurve_4: typeof Handle_StepGeom_OuterBoundaryCurve_4;
  StepGeom_OuterBoundaryCurve: typeof StepGeom_OuterBoundaryCurve;
  StepGeom_UniformCurveAndRationalBSplineCurve: typeof StepGeom_UniformCurveAndRationalBSplineCurve;
  Handle_StepGeom_UniformCurveAndRationalBSplineCurve: typeof Handle_StepGeom_UniformCurveAndRationalBSplineCurve;
  Handle_StepGeom_UniformCurveAndRationalBSplineCurve_1: typeof Handle_StepGeom_UniformCurveAndRationalBSplineCurve_1;
  Handle_StepGeom_UniformCurveAndRationalBSplineCurve_2: typeof Handle_StepGeom_UniformCurveAndRationalBSplineCurve_2;
  Handle_StepGeom_UniformCurveAndRationalBSplineCurve_3: typeof Handle_StepGeom_UniformCurveAndRationalBSplineCurve_3;
  Handle_StepGeom_UniformCurveAndRationalBSplineCurve_4: typeof Handle_StepGeom_UniformCurveAndRationalBSplineCurve_4;
  Handle_StepGeom_PointOnSurface: typeof Handle_StepGeom_PointOnSurface;
  Handle_StepGeom_PointOnSurface_1: typeof Handle_StepGeom_PointOnSurface_1;
  Handle_StepGeom_PointOnSurface_2: typeof Handle_StepGeom_PointOnSurface_2;
  Handle_StepGeom_PointOnSurface_3: typeof Handle_StepGeom_PointOnSurface_3;
  Handle_StepGeom_PointOnSurface_4: typeof Handle_StepGeom_PointOnSurface_4;
  StepGeom_PointOnSurface: typeof StepGeom_PointOnSurface;
  StepGeom_PcurveOrSurface: typeof StepGeom_PcurveOrSurface;
  Handle_StepGeom_Placement: typeof Handle_StepGeom_Placement;
  Handle_StepGeom_Placement_1: typeof Handle_StepGeom_Placement_1;
  Handle_StepGeom_Placement_2: typeof Handle_StepGeom_Placement_2;
  Handle_StepGeom_Placement_3: typeof Handle_StepGeom_Placement_3;
  Handle_StepGeom_Placement_4: typeof Handle_StepGeom_Placement_4;
  StepGeom_Placement: typeof StepGeom_Placement;
  StepGeom_Circle: typeof StepGeom_Circle;
  Handle_StepGeom_Circle: typeof Handle_StepGeom_Circle;
  Handle_StepGeom_Circle_1: typeof Handle_StepGeom_Circle_1;
  Handle_StepGeom_Circle_2: typeof Handle_StepGeom_Circle_2;
  Handle_StepGeom_Circle_3: typeof Handle_StepGeom_Circle_3;
  Handle_StepGeom_Circle_4: typeof Handle_StepGeom_Circle_4;
  StepGeom_BSplineSurface: typeof StepGeom_BSplineSurface;
  Handle_StepGeom_BSplineSurface: typeof Handle_StepGeom_BSplineSurface;
  Handle_StepGeom_BSplineSurface_1: typeof Handle_StepGeom_BSplineSurface_1;
  Handle_StepGeom_BSplineSurface_2: typeof Handle_StepGeom_BSplineSurface_2;
  Handle_StepGeom_BSplineSurface_3: typeof Handle_StepGeom_BSplineSurface_3;
  Handle_StepGeom_BSplineSurface_4: typeof Handle_StepGeom_BSplineSurface_4;
  StepGeom_BSplineSurfaceWithKnots: typeof StepGeom_BSplineSurfaceWithKnots;
  Handle_StepGeom_BSplineSurfaceWithKnots: typeof Handle_StepGeom_BSplineSurfaceWithKnots;
  Handle_StepGeom_BSplineSurfaceWithKnots_1: typeof Handle_StepGeom_BSplineSurfaceWithKnots_1;
  Handle_StepGeom_BSplineSurfaceWithKnots_2: typeof Handle_StepGeom_BSplineSurfaceWithKnots_2;
  Handle_StepGeom_BSplineSurfaceWithKnots_3: typeof Handle_StepGeom_BSplineSurfaceWithKnots_3;
  Handle_StepGeom_BSplineSurfaceWithKnots_4: typeof Handle_StepGeom_BSplineSurfaceWithKnots_4;
  StepGeom_CompositeCurveOnSurface: typeof StepGeom_CompositeCurveOnSurface;
  Handle_StepGeom_CompositeCurveOnSurface: typeof Handle_StepGeom_CompositeCurveOnSurface;
  Handle_StepGeom_CompositeCurveOnSurface_1: typeof Handle_StepGeom_CompositeCurveOnSurface_1;
  Handle_StepGeom_CompositeCurveOnSurface_2: typeof Handle_StepGeom_CompositeCurveOnSurface_2;
  Handle_StepGeom_CompositeCurveOnSurface_3: typeof Handle_StepGeom_CompositeCurveOnSurface_3;
  Handle_StepGeom_CompositeCurveOnSurface_4: typeof Handle_StepGeom_CompositeCurveOnSurface_4;
  StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface: typeof StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface;
  Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface: typeof Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface;
  Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_1: typeof Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_1;
  Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_2: typeof Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_2;
  Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_3: typeof Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_3;
  Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_4: typeof Handle_StepGeom_BSplineSurfaceWithKnotsAndRationalBSplineSurface_4;
  Handle_StepGeom_HArray1OfSurfaceBoundary: typeof Handle_StepGeom_HArray1OfSurfaceBoundary;
  Handle_StepGeom_HArray1OfSurfaceBoundary_1: typeof Handle_StepGeom_HArray1OfSurfaceBoundary_1;
  Handle_StepGeom_HArray1OfSurfaceBoundary_2: typeof Handle_StepGeom_HArray1OfSurfaceBoundary_2;
  Handle_StepGeom_HArray1OfSurfaceBoundary_3: typeof Handle_StepGeom_HArray1OfSurfaceBoundary_3;
  Handle_StepGeom_HArray1OfSurfaceBoundary_4: typeof Handle_StepGeom_HArray1OfSurfaceBoundary_4;
  StepGeom_SeamCurve: typeof StepGeom_SeamCurve;
  Handle_StepGeom_SeamCurve: typeof Handle_StepGeom_SeamCurve;
  Handle_StepGeom_SeamCurve_1: typeof Handle_StepGeom_SeamCurve_1;
  Handle_StepGeom_SeamCurve_2: typeof Handle_StepGeom_SeamCurve_2;
  Handle_StepGeom_SeamCurve_3: typeof Handle_StepGeom_SeamCurve_3;
  Handle_StepGeom_SeamCurve_4: typeof Handle_StepGeom_SeamCurve_4;
  StepGeom_CurveOnSurface: typeof StepGeom_CurveOnSurface;
  Handle_StepGeom_CurveReplica: typeof Handle_StepGeom_CurveReplica;
  Handle_StepGeom_CurveReplica_1: typeof Handle_StepGeom_CurveReplica_1;
  Handle_StepGeom_CurveReplica_2: typeof Handle_StepGeom_CurveReplica_2;
  Handle_StepGeom_CurveReplica_3: typeof Handle_StepGeom_CurveReplica_3;
  Handle_StepGeom_CurveReplica_4: typeof Handle_StepGeom_CurveReplica_4;
  StepGeom_CurveReplica: typeof StepGeom_CurveReplica;
  StepGeom_ToroidalSurface: typeof StepGeom_ToroidalSurface;
  Handle_StepGeom_ToroidalSurface: typeof Handle_StepGeom_ToroidalSurface;
  Handle_StepGeom_ToroidalSurface_1: typeof Handle_StepGeom_ToroidalSurface_1;
  Handle_StepGeom_ToroidalSurface_2: typeof Handle_StepGeom_ToroidalSurface_2;
  Handle_StepGeom_ToroidalSurface_3: typeof Handle_StepGeom_ToroidalSurface_3;
  Handle_StepGeom_ToroidalSurface_4: typeof Handle_StepGeom_ToroidalSurface_4;
  Handle_StepGeom_ElementarySurface: typeof Handle_StepGeom_ElementarySurface;
  Handle_StepGeom_ElementarySurface_1: typeof Handle_StepGeom_ElementarySurface_1;
  Handle_StepGeom_ElementarySurface_2: typeof Handle_StepGeom_ElementarySurface_2;
  Handle_StepGeom_ElementarySurface_3: typeof Handle_StepGeom_ElementarySurface_3;
  Handle_StepGeom_ElementarySurface_4: typeof Handle_StepGeom_ElementarySurface_4;
  StepGeom_ElementarySurface: typeof StepGeom_ElementarySurface;
  Handle_StepGeom_BoundaryCurve: typeof Handle_StepGeom_BoundaryCurve;
  Handle_StepGeom_BoundaryCurve_1: typeof Handle_StepGeom_BoundaryCurve_1;
  Handle_StepGeom_BoundaryCurve_2: typeof Handle_StepGeom_BoundaryCurve_2;
  Handle_StepGeom_BoundaryCurve_3: typeof Handle_StepGeom_BoundaryCurve_3;
  Handle_StepGeom_BoundaryCurve_4: typeof Handle_StepGeom_BoundaryCurve_4;
  StepGeom_BoundaryCurve: typeof StepGeom_BoundaryCurve;
  Handle_StepGeom_BoundedSurface: typeof Handle_StepGeom_BoundedSurface;
  Handle_StepGeom_BoundedSurface_1: typeof Handle_StepGeom_BoundedSurface_1;
  Handle_StepGeom_BoundedSurface_2: typeof Handle_StepGeom_BoundedSurface_2;
  Handle_StepGeom_BoundedSurface_3: typeof Handle_StepGeom_BoundedSurface_3;
  Handle_StepGeom_BoundedSurface_4: typeof Handle_StepGeom_BoundedSurface_4;
  StepGeom_BoundedSurface: typeof StepGeom_BoundedSurface;
  Handle_StepGeom_HArray1OfCompositeCurveSegment: typeof Handle_StepGeom_HArray1OfCompositeCurveSegment;
  Handle_StepGeom_HArray1OfCompositeCurveSegment_1: typeof Handle_StepGeom_HArray1OfCompositeCurveSegment_1;
  Handle_StepGeom_HArray1OfCompositeCurveSegment_2: typeof Handle_StepGeom_HArray1OfCompositeCurveSegment_2;
  Handle_StepGeom_HArray1OfCompositeCurveSegment_3: typeof Handle_StepGeom_HArray1OfCompositeCurveSegment_3;
  Handle_StepGeom_HArray1OfCompositeCurveSegment_4: typeof Handle_StepGeom_HArray1OfCompositeCurveSegment_4;
  StepGeom_SurfaceBoundary: typeof StepGeom_SurfaceBoundary;
  StepGeom_Array1OfTrimmingSelect: typeof StepGeom_Array1OfTrimmingSelect;
  StepGeom_Array1OfTrimmingSelect_1: typeof StepGeom_Array1OfTrimmingSelect_1;
  StepGeom_Array1OfTrimmingSelect_2: typeof StepGeom_Array1OfTrimmingSelect_2;
  StepGeom_Array1OfTrimmingSelect_3: typeof StepGeom_Array1OfTrimmingSelect_3;
  StepGeom_Array1OfTrimmingSelect_4: typeof StepGeom_Array1OfTrimmingSelect_4;
  StepGeom_Array1OfTrimmingSelect_5: typeof StepGeom_Array1OfTrimmingSelect_5;
  Handle_StepGeom_BezierCurveAndRationalBSplineCurve: typeof Handle_StepGeom_BezierCurveAndRationalBSplineCurve;
  Handle_StepGeom_BezierCurveAndRationalBSplineCurve_1: typeof Handle_StepGeom_BezierCurveAndRationalBSplineCurve_1;
  Handle_StepGeom_BezierCurveAndRationalBSplineCurve_2: typeof Handle_StepGeom_BezierCurveAndRationalBSplineCurve_2;
  Handle_StepGeom_BezierCurveAndRationalBSplineCurve_3: typeof Handle_StepGeom_BezierCurveAndRationalBSplineCurve_3;
  Handle_StepGeom_BezierCurveAndRationalBSplineCurve_4: typeof Handle_StepGeom_BezierCurveAndRationalBSplineCurve_4;
  StepGeom_BezierCurveAndRationalBSplineCurve: typeof StepGeom_BezierCurveAndRationalBSplineCurve;
  StepGeom_Direction: typeof StepGeom_Direction;
  Handle_StepGeom_Direction: typeof Handle_StepGeom_Direction;
  Handle_StepGeom_Direction_1: typeof Handle_StepGeom_Direction_1;
  Handle_StepGeom_Direction_2: typeof Handle_StepGeom_Direction_2;
  Handle_StepGeom_Direction_3: typeof Handle_StepGeom_Direction_3;
  Handle_StepGeom_Direction_4: typeof Handle_StepGeom_Direction_4;
  StepGeom_PointReplica: typeof StepGeom_PointReplica;
  Handle_StepGeom_PointReplica: typeof Handle_StepGeom_PointReplica;
  Handle_StepGeom_PointReplica_1: typeof Handle_StepGeom_PointReplica_1;
  Handle_StepGeom_PointReplica_2: typeof Handle_StepGeom_PointReplica_2;
  Handle_StepGeom_PointReplica_3: typeof Handle_StepGeom_PointReplica_3;
  Handle_StepGeom_PointReplica_4: typeof Handle_StepGeom_PointReplica_4;
  Handle_StepGeom_PointOnCurve: typeof Handle_StepGeom_PointOnCurve;
  Handle_StepGeom_PointOnCurve_1: typeof Handle_StepGeom_PointOnCurve_1;
  Handle_StepGeom_PointOnCurve_2: typeof Handle_StepGeom_PointOnCurve_2;
  Handle_StepGeom_PointOnCurve_3: typeof Handle_StepGeom_PointOnCurve_3;
  Handle_StepGeom_PointOnCurve_4: typeof Handle_StepGeom_PointOnCurve_4;
  StepGeom_PointOnCurve: typeof StepGeom_PointOnCurve;
  StepGeom_CartesianTransformationOperator: typeof StepGeom_CartesianTransformationOperator;
  Handle_StepGeom_CartesianTransformationOperator: typeof Handle_StepGeom_CartesianTransformationOperator;
  Handle_StepGeom_CartesianTransformationOperator_1: typeof Handle_StepGeom_CartesianTransformationOperator_1;
  Handle_StepGeom_CartesianTransformationOperator_2: typeof Handle_StepGeom_CartesianTransformationOperator_2;
  Handle_StepGeom_CartesianTransformationOperator_3: typeof Handle_StepGeom_CartesianTransformationOperator_3;
  Handle_StepGeom_CartesianTransformationOperator_4: typeof Handle_StepGeom_CartesianTransformationOperator_4;
  StepGeom_OffsetSurface: typeof StepGeom_OffsetSurface;
  Handle_StepGeom_OffsetSurface: typeof Handle_StepGeom_OffsetSurface;
  Handle_StepGeom_OffsetSurface_1: typeof Handle_StepGeom_OffsetSurface_1;
  Handle_StepGeom_OffsetSurface_2: typeof Handle_StepGeom_OffsetSurface_2;
  Handle_StepGeom_OffsetSurface_3: typeof Handle_StepGeom_OffsetSurface_3;
  Handle_StepGeom_OffsetSurface_4: typeof Handle_StepGeom_OffsetSurface_4;
  Draft_FaceInfo: typeof Draft_FaceInfo;
  Draft_FaceInfo_1: typeof Draft_FaceInfo_1;
  Draft_FaceInfo_2: typeof Draft_FaceInfo_2;
  Draft_IndexedDataMapOfFaceFaceInfo: typeof Draft_IndexedDataMapOfFaceFaceInfo;
  Draft_IndexedDataMapOfFaceFaceInfo_1: typeof Draft_IndexedDataMapOfFaceFaceInfo_1;
  Draft_IndexedDataMapOfFaceFaceInfo_2: typeof Draft_IndexedDataMapOfFaceFaceInfo_2;
  Draft_IndexedDataMapOfFaceFaceInfo_3: typeof Draft_IndexedDataMapOfFaceFaceInfo_3;
  Draft_ErrorStatus: Draft_ErrorStatus;
  Draft_IndexedDataMapOfEdgeEdgeInfo: typeof Draft_IndexedDataMapOfEdgeEdgeInfo;
  Draft_IndexedDataMapOfEdgeEdgeInfo_1: typeof Draft_IndexedDataMapOfEdgeEdgeInfo_1;
  Draft_IndexedDataMapOfEdgeEdgeInfo_2: typeof Draft_IndexedDataMapOfEdgeEdgeInfo_2;
  Draft_IndexedDataMapOfEdgeEdgeInfo_3: typeof Draft_IndexedDataMapOfEdgeEdgeInfo_3;
  Draft_VertexInfo: typeof Draft_VertexInfo;
  Draft_IndexedDataMapOfVertexVertexInfo: typeof Draft_IndexedDataMapOfVertexVertexInfo;
  Draft_IndexedDataMapOfVertexVertexInfo_1: typeof Draft_IndexedDataMapOfVertexVertexInfo_1;
  Draft_IndexedDataMapOfVertexVertexInfo_2: typeof Draft_IndexedDataMapOfVertexVertexInfo_2;
  Draft_IndexedDataMapOfVertexVertexInfo_3: typeof Draft_IndexedDataMapOfVertexVertexInfo_3;
  Draft_EdgeInfo: typeof Draft_EdgeInfo;
  Draft_EdgeInfo_1: typeof Draft_EdgeInfo_1;
  Draft_EdgeInfo_2: typeof Draft_EdgeInfo_2;
  Handle_Draft_Modification: typeof Handle_Draft_Modification;
  Handle_Draft_Modification_1: typeof Handle_Draft_Modification_1;
  Handle_Draft_Modification_2: typeof Handle_Draft_Modification_2;
  Handle_Draft_Modification_3: typeof Handle_Draft_Modification_3;
  Handle_Draft_Modification_4: typeof Handle_Draft_Modification_4;
  Draft_Modification: typeof Draft_Modification;
  Draft: typeof Draft;
  AdvApprox_Cutting: typeof AdvApprox_Cutting;
  AdvApprox_SimpleApprox: typeof AdvApprox_SimpleApprox;
  AdvApprox_DichoCutting: typeof AdvApprox_DichoCutting;
  AdvApprox_PrefCutting: typeof AdvApprox_PrefCutting;
  AdvApprox_ApproxAFunction: typeof AdvApprox_ApproxAFunction;
  AdvApprox_ApproxAFunction_1: typeof AdvApprox_ApproxAFunction_1;
  AdvApprox_ApproxAFunction_2: typeof AdvApprox_ApproxAFunction_2;
  AdvApprox_EvaluatorFunction: typeof AdvApprox_EvaluatorFunction;
  AdvApprox_PrefAndRec: typeof AdvApprox_PrefAndRec;
  StdObjMgt_ReadData: typeof StdObjMgt_ReadData;
  StdObjMgt_Persistent: typeof StdObjMgt_Persistent;
  StdObjMgt_MapOfInstantiators: typeof StdObjMgt_MapOfInstantiators;
  StdObjMgt_WriteData: typeof StdObjMgt_WriteData;
  StdObjMgt_SharedObject: typeof StdObjMgt_SharedObject;
  TopCnx_EdgeFaceTransition: typeof TopCnx_EdgeFaceTransition;
  Handle_Expr_LogOfe: typeof Handle_Expr_LogOfe;
  Handle_Expr_LogOfe_1: typeof Handle_Expr_LogOfe_1;
  Handle_Expr_LogOfe_2: typeof Handle_Expr_LogOfe_2;
  Handle_Expr_LogOfe_3: typeof Handle_Expr_LogOfe_3;
  Handle_Expr_LogOfe_4: typeof Handle_Expr_LogOfe_4;
  Expr_LogOfe: typeof Expr_LogOfe;
  Expr_GeneralFunction: typeof Expr_GeneralFunction;
  Handle_Expr_GeneralFunction: typeof Handle_Expr_GeneralFunction;
  Handle_Expr_GeneralFunction_1: typeof Handle_Expr_GeneralFunction_1;
  Handle_Expr_GeneralFunction_2: typeof Handle_Expr_GeneralFunction_2;
  Handle_Expr_GeneralFunction_3: typeof Handle_Expr_GeneralFunction_3;
  Handle_Expr_GeneralFunction_4: typeof Handle_Expr_GeneralFunction_4;
  Expr_NotEvaluable: typeof Expr_NotEvaluable;
  Expr_NotEvaluable_1: typeof Expr_NotEvaluable_1;
  Expr_NotEvaluable_2: typeof Expr_NotEvaluable_2;
  Handle_Expr_NotEvaluable: typeof Handle_Expr_NotEvaluable;
  Handle_Expr_NotEvaluable_1: typeof Handle_Expr_NotEvaluable_1;
  Handle_Expr_NotEvaluable_2: typeof Handle_Expr_NotEvaluable_2;
  Handle_Expr_NotEvaluable_3: typeof Handle_Expr_NotEvaluable_3;
  Handle_Expr_NotEvaluable_4: typeof Handle_Expr_NotEvaluable_4;
  Expr_LessThan: typeof Expr_LessThan;
  Handle_Expr_LessThan: typeof Handle_Expr_LessThan;
  Handle_Expr_LessThan_1: typeof Handle_Expr_LessThan_1;
  Handle_Expr_LessThan_2: typeof Handle_Expr_LessThan_2;
  Handle_Expr_LessThan_3: typeof Handle_Expr_LessThan_3;
  Handle_Expr_LessThan_4: typeof Handle_Expr_LessThan_4;
  Handle_Expr_NotAssigned: typeof Handle_Expr_NotAssigned;
  Handle_Expr_NotAssigned_1: typeof Handle_Expr_NotAssigned_1;
  Handle_Expr_NotAssigned_2: typeof Handle_Expr_NotAssigned_2;
  Handle_Expr_NotAssigned_3: typeof Handle_Expr_NotAssigned_3;
  Handle_Expr_NotAssigned_4: typeof Handle_Expr_NotAssigned_4;
  Expr_NotAssigned: typeof Expr_NotAssigned;
  Expr_NotAssigned_1: typeof Expr_NotAssigned_1;
  Expr_NotAssigned_2: typeof Expr_NotAssigned_2;
  Expr_Square: typeof Expr_Square;
  Handle_Expr_Square: typeof Handle_Expr_Square;
  Handle_Expr_Square_1: typeof Handle_Expr_Square_1;
  Handle_Expr_Square_2: typeof Handle_Expr_Square_2;
  Handle_Expr_Square_3: typeof Handle_Expr_Square_3;
  Handle_Expr_Square_4: typeof Handle_Expr_Square_4;
  Expr_Difference: typeof Expr_Difference;
  Handle_Expr_Difference: typeof Handle_Expr_Difference;
  Handle_Expr_Difference_1: typeof Handle_Expr_Difference_1;
  Handle_Expr_Difference_2: typeof Handle_Expr_Difference_2;
  Handle_Expr_Difference_3: typeof Handle_Expr_Difference_3;
  Handle_Expr_Difference_4: typeof Handle_Expr_Difference_4;
  Handle_Expr_Product: typeof Handle_Expr_Product;
  Handle_Expr_Product_1: typeof Handle_Expr_Product_1;
  Handle_Expr_Product_2: typeof Handle_Expr_Product_2;
  Handle_Expr_Product_3: typeof Handle_Expr_Product_3;
  Handle_Expr_Product_4: typeof Handle_Expr_Product_4;
  Expr_Product: typeof Expr_Product;
  Expr_Product_1: typeof Expr_Product_1;
  Expr_Product_2: typeof Expr_Product_2;
  Handle_Expr_BinaryExpression: typeof Handle_Expr_BinaryExpression;
  Handle_Expr_BinaryExpression_1: typeof Handle_Expr_BinaryExpression_1;
  Handle_Expr_BinaryExpression_2: typeof Handle_Expr_BinaryExpression_2;
  Handle_Expr_BinaryExpression_3: typeof Handle_Expr_BinaryExpression_3;
  Handle_Expr_BinaryExpression_4: typeof Handle_Expr_BinaryExpression_4;
  Expr_BinaryExpression: typeof Expr_BinaryExpression;
  Expr_GreaterThan: typeof Expr_GreaterThan;
  Handle_Expr_GreaterThan: typeof Handle_Expr_GreaterThan;
  Handle_Expr_GreaterThan_1: typeof Handle_Expr_GreaterThan_1;
  Handle_Expr_GreaterThan_2: typeof Handle_Expr_GreaterThan_2;
  Handle_Expr_GreaterThan_3: typeof Handle_Expr_GreaterThan_3;
  Handle_Expr_GreaterThan_4: typeof Handle_Expr_GreaterThan_4;
  Expr_UnknownIterator: typeof Expr_UnknownIterator;
  Expr_InvalidFunction: typeof Expr_InvalidFunction;
  Expr_InvalidFunction_1: typeof Expr_InvalidFunction_1;
  Expr_InvalidFunction_2: typeof Expr_InvalidFunction_2;
  Handle_Expr_InvalidFunction: typeof Handle_Expr_InvalidFunction;
  Handle_Expr_InvalidFunction_1: typeof Handle_Expr_InvalidFunction_1;
  Handle_Expr_InvalidFunction_2: typeof Handle_Expr_InvalidFunction_2;
  Handle_Expr_InvalidFunction_3: typeof Handle_Expr_InvalidFunction_3;
  Handle_Expr_InvalidFunction_4: typeof Handle_Expr_InvalidFunction_4;
  Handle_Expr_GeneralRelation: typeof Handle_Expr_GeneralRelation;
  Handle_Expr_GeneralRelation_1: typeof Handle_Expr_GeneralRelation_1;
  Handle_Expr_GeneralRelation_2: typeof Handle_Expr_GeneralRelation_2;
  Handle_Expr_GeneralRelation_3: typeof Handle_Expr_GeneralRelation_3;
  Handle_Expr_GeneralRelation_4: typeof Handle_Expr_GeneralRelation_4;
  Expr_GeneralRelation: typeof Expr_GeneralRelation;
  Handle_Expr_Sign: typeof Handle_Expr_Sign;
  Handle_Expr_Sign_1: typeof Handle_Expr_Sign_1;
  Handle_Expr_Sign_2: typeof Handle_Expr_Sign_2;
  Handle_Expr_Sign_3: typeof Handle_Expr_Sign_3;
  Handle_Expr_Sign_4: typeof Handle_Expr_Sign_4;
  Expr_Sign: typeof Expr_Sign;
  Handle_Expr_SystemRelation: typeof Handle_Expr_SystemRelation;
  Handle_Expr_SystemRelation_1: typeof Handle_Expr_SystemRelation_1;
  Handle_Expr_SystemRelation_2: typeof Handle_Expr_SystemRelation_2;
  Handle_Expr_SystemRelation_3: typeof Handle_Expr_SystemRelation_3;
  Handle_Expr_SystemRelation_4: typeof Handle_Expr_SystemRelation_4;
  Expr_SystemRelation: typeof Expr_SystemRelation;
  Expr_ArgCosh: typeof Expr_ArgCosh;
  Handle_Expr_ArgCosh: typeof Handle_Expr_ArgCosh;
  Handle_Expr_ArgCosh_1: typeof Handle_Expr_ArgCosh_1;
  Handle_Expr_ArgCosh_2: typeof Handle_Expr_ArgCosh_2;
  Handle_Expr_ArgCosh_3: typeof Handle_Expr_ArgCosh_3;
  Handle_Expr_ArgCosh_4: typeof Handle_Expr_ArgCosh_4;
  Expr_PolyFunction: typeof Expr_PolyFunction;
  Handle_Expr_PolyFunction: typeof Handle_Expr_PolyFunction;
  Handle_Expr_PolyFunction_1: typeof Handle_Expr_PolyFunction_1;
  Handle_Expr_PolyFunction_2: typeof Handle_Expr_PolyFunction_2;
  Handle_Expr_PolyFunction_3: typeof Handle_Expr_PolyFunction_3;
  Handle_Expr_PolyFunction_4: typeof Handle_Expr_PolyFunction_4;
  Expr_Equal: typeof Expr_Equal;
  Handle_Expr_Equal: typeof Handle_Expr_Equal;
  Handle_Expr_Equal_1: typeof Handle_Expr_Equal_1;
  Handle_Expr_Equal_2: typeof Handle_Expr_Equal_2;
  Handle_Expr_Equal_3: typeof Handle_Expr_Equal_3;
  Handle_Expr_Equal_4: typeof Handle_Expr_Equal_4;
  Handle_Expr_Sinh: typeof Handle_Expr_Sinh;
  Handle_Expr_Sinh_1: typeof Handle_Expr_Sinh_1;
  Handle_Expr_Sinh_2: typeof Handle_Expr_Sinh_2;
  Handle_Expr_Sinh_3: typeof Handle_Expr_Sinh_3;
  Handle_Expr_Sinh_4: typeof Handle_Expr_Sinh_4;
  Expr_Sinh: typeof Expr_Sinh;
  Expr_PolyExpression: typeof Expr_PolyExpression;
  Handle_Expr_PolyExpression: typeof Handle_Expr_PolyExpression;
  Handle_Expr_PolyExpression_1: typeof Handle_Expr_PolyExpression_1;
  Handle_Expr_PolyExpression_2: typeof Handle_Expr_PolyExpression_2;
  Handle_Expr_PolyExpression_3: typeof Handle_Expr_PolyExpression_3;
  Handle_Expr_PolyExpression_4: typeof Handle_Expr_PolyExpression_4;
  Expr_LessThanOrEqual: typeof Expr_LessThanOrEqual;
  Handle_Expr_LessThanOrEqual: typeof Handle_Expr_LessThanOrEqual;
  Handle_Expr_LessThanOrEqual_1: typeof Handle_Expr_LessThanOrEqual_1;
  Handle_Expr_LessThanOrEqual_2: typeof Handle_Expr_LessThanOrEqual_2;
  Handle_Expr_LessThanOrEqual_3: typeof Handle_Expr_LessThanOrEqual_3;
  Handle_Expr_LessThanOrEqual_4: typeof Handle_Expr_LessThanOrEqual_4;
  Expr_FunctionDerivative: typeof Expr_FunctionDerivative;
  Handle_Expr_FunctionDerivative: typeof Handle_Expr_FunctionDerivative;
  Handle_Expr_FunctionDerivative_1: typeof Handle_Expr_FunctionDerivative_1;
  Handle_Expr_FunctionDerivative_2: typeof Handle_Expr_FunctionDerivative_2;
  Handle_Expr_FunctionDerivative_3: typeof Handle_Expr_FunctionDerivative_3;
  Handle_Expr_FunctionDerivative_4: typeof Handle_Expr_FunctionDerivative_4;
  Handle_Expr_UnaryMinus: typeof Handle_Expr_UnaryMinus;
  Handle_Expr_UnaryMinus_1: typeof Handle_Expr_UnaryMinus_1;
  Handle_Expr_UnaryMinus_2: typeof Handle_Expr_UnaryMinus_2;
  Handle_Expr_UnaryMinus_3: typeof Handle_Expr_UnaryMinus_3;
  Handle_Expr_UnaryMinus_4: typeof Handle_Expr_UnaryMinus_4;
  Expr_UnaryMinus: typeof Expr_UnaryMinus;
  Expr_ArgSinh: typeof Expr_ArgSinh;
  Handle_Expr_ArgSinh: typeof Handle_Expr_ArgSinh;
  Handle_Expr_ArgSinh_1: typeof Handle_Expr_ArgSinh_1;
  Handle_Expr_ArgSinh_2: typeof Handle_Expr_ArgSinh_2;
  Handle_Expr_ArgSinh_3: typeof Handle_Expr_ArgSinh_3;
  Handle_Expr_ArgSinh_4: typeof Handle_Expr_ArgSinh_4;
  Expr_NamedConstant: typeof Expr_NamedConstant;
  Handle_Expr_NamedConstant: typeof Handle_Expr_NamedConstant;
  Handle_Expr_NamedConstant_1: typeof Handle_Expr_NamedConstant_1;
  Handle_Expr_NamedConstant_2: typeof Handle_Expr_NamedConstant_2;
  Handle_Expr_NamedConstant_3: typeof Handle_Expr_NamedConstant_3;
  Handle_Expr_NamedConstant_4: typeof Handle_Expr_NamedConstant_4;
  Expr_Absolute: typeof Expr_Absolute;
  Handle_Expr_Absolute: typeof Handle_Expr_Absolute;
  Handle_Expr_Absolute_1: typeof Handle_Expr_Absolute_1;
  Handle_Expr_Absolute_2: typeof Handle_Expr_Absolute_2;
  Handle_Expr_Absolute_3: typeof Handle_Expr_Absolute_3;
  Handle_Expr_Absolute_4: typeof Handle_Expr_Absolute_4;
  Expr_Tangent: typeof Expr_Tangent;
  Handle_Expr_Tangent: typeof Handle_Expr_Tangent;
  Handle_Expr_Tangent_1: typeof Handle_Expr_Tangent_1;
  Handle_Expr_Tangent_2: typeof Handle_Expr_Tangent_2;
  Handle_Expr_Tangent_3: typeof Handle_Expr_Tangent_3;
  Handle_Expr_Tangent_4: typeof Handle_Expr_Tangent_4;
  Handle_Expr_ArgTanh: typeof Handle_Expr_ArgTanh;
  Handle_Expr_ArgTanh_1: typeof Handle_Expr_ArgTanh_1;
  Handle_Expr_ArgTanh_2: typeof Handle_Expr_ArgTanh_2;
  Handle_Expr_ArgTanh_3: typeof Handle_Expr_ArgTanh_3;
  Handle_Expr_ArgTanh_4: typeof Handle_Expr_ArgTanh_4;
  Expr_ArgTanh: typeof Expr_ArgTanh;
  Handle_Expr_NumericValue: typeof Handle_Expr_NumericValue;
  Handle_Expr_NumericValue_1: typeof Handle_Expr_NumericValue_1;
  Handle_Expr_NumericValue_2: typeof Handle_Expr_NumericValue_2;
  Handle_Expr_NumericValue_3: typeof Handle_Expr_NumericValue_3;
  Handle_Expr_NumericValue_4: typeof Handle_Expr_NumericValue_4;
  Expr_NumericValue: typeof Expr_NumericValue;
  Expr_Division: typeof Expr_Division;
  Handle_Expr_Division: typeof Handle_Expr_Division;
  Handle_Expr_Division_1: typeof Handle_Expr_Division_1;
  Handle_Expr_Division_2: typeof Handle_Expr_Division_2;
  Handle_Expr_Division_3: typeof Handle_Expr_Division_3;
  Handle_Expr_Division_4: typeof Handle_Expr_Division_4;
  Handle_Expr_Exponentiate: typeof Handle_Expr_Exponentiate;
  Handle_Expr_Exponentiate_1: typeof Handle_Expr_Exponentiate_1;
  Handle_Expr_Exponentiate_2: typeof Handle_Expr_Exponentiate_2;
  Handle_Expr_Exponentiate_3: typeof Handle_Expr_Exponentiate_3;
  Handle_Expr_Exponentiate_4: typeof Handle_Expr_Exponentiate_4;
  Expr_Exponentiate: typeof Expr_Exponentiate;
  Handle_Expr_Tanh: typeof Handle_Expr_Tanh;
  Handle_Expr_Tanh_1: typeof Handle_Expr_Tanh_1;
  Handle_Expr_Tanh_2: typeof Handle_Expr_Tanh_2;
  Handle_Expr_Tanh_3: typeof Handle_Expr_Tanh_3;
  Handle_Expr_Tanh_4: typeof Handle_Expr_Tanh_4;
  Expr_Tanh: typeof Expr_Tanh;
  Handle_Expr_Sine: typeof Handle_Expr_Sine;
  Handle_Expr_Sine_1: typeof Handle_Expr_Sine_1;
  Handle_Expr_Sine_2: typeof Handle_Expr_Sine_2;
  Handle_Expr_Sine_3: typeof Handle_Expr_Sine_3;
  Handle_Expr_Sine_4: typeof Handle_Expr_Sine_4;
  Expr_Sine: typeof Expr_Sine;
  Expr_RUIterator: typeof Expr_RUIterator;
  Expr_UnaryFunction: typeof Expr_UnaryFunction;
  Handle_Expr_UnaryFunction: typeof Handle_Expr_UnaryFunction;
  Handle_Expr_UnaryFunction_1: typeof Handle_Expr_UnaryFunction_1;
  Handle_Expr_UnaryFunction_2: typeof Handle_Expr_UnaryFunction_2;
  Handle_Expr_UnaryFunction_3: typeof Handle_Expr_UnaryFunction_3;
  Handle_Expr_UnaryFunction_4: typeof Handle_Expr_UnaryFunction_4;
  Expr_InvalidAssignment: typeof Expr_InvalidAssignment;
  Expr_InvalidAssignment_1: typeof Expr_InvalidAssignment_1;
  Expr_InvalidAssignment_2: typeof Expr_InvalidAssignment_2;
  Handle_Expr_InvalidAssignment: typeof Handle_Expr_InvalidAssignment;
  Handle_Expr_InvalidAssignment_1: typeof Handle_Expr_InvalidAssignment_1;
  Handle_Expr_InvalidAssignment_2: typeof Handle_Expr_InvalidAssignment_2;
  Handle_Expr_InvalidAssignment_3: typeof Handle_Expr_InvalidAssignment_3;
  Handle_Expr_InvalidAssignment_4: typeof Handle_Expr_InvalidAssignment_4;
  Expr_RelationIterator: typeof Expr_RelationIterator;
  Handle_Expr_Cosh: typeof Handle_Expr_Cosh;
  Handle_Expr_Cosh_1: typeof Handle_Expr_Cosh_1;
  Handle_Expr_Cosh_2: typeof Handle_Expr_Cosh_2;
  Handle_Expr_Cosh_3: typeof Handle_Expr_Cosh_3;
  Handle_Expr_Cosh_4: typeof Handle_Expr_Cosh_4;
  Expr_Cosh: typeof Expr_Cosh;
  Expr_SquareRoot: typeof Expr_SquareRoot;
  Handle_Expr_SquareRoot: typeof Handle_Expr_SquareRoot;
  Handle_Expr_SquareRoot_1: typeof Handle_Expr_SquareRoot_1;
  Handle_Expr_SquareRoot_2: typeof Handle_Expr_SquareRoot_2;
  Handle_Expr_SquareRoot_3: typeof Handle_Expr_SquareRoot_3;
  Handle_Expr_SquareRoot_4: typeof Handle_Expr_SquareRoot_4;
  Expr_GreaterThanOrEqual: typeof Expr_GreaterThanOrEqual;
  Handle_Expr_GreaterThanOrEqual: typeof Handle_Expr_GreaterThanOrEqual;
  Handle_Expr_GreaterThanOrEqual_1: typeof Handle_Expr_GreaterThanOrEqual_1;
  Handle_Expr_GreaterThanOrEqual_2: typeof Handle_Expr_GreaterThanOrEqual_2;
  Handle_Expr_GreaterThanOrEqual_3: typeof Handle_Expr_GreaterThanOrEqual_3;
  Handle_Expr_GreaterThanOrEqual_4: typeof Handle_Expr_GreaterThanOrEqual_4;
  Handle_Expr_Cosine: typeof Handle_Expr_Cosine;
  Handle_Expr_Cosine_1: typeof Handle_Expr_Cosine_1;
  Handle_Expr_Cosine_2: typeof Handle_Expr_Cosine_2;
  Handle_Expr_Cosine_3: typeof Handle_Expr_Cosine_3;
  Handle_Expr_Cosine_4: typeof Handle_Expr_Cosine_4;
  Expr_Cosine: typeof Expr_Cosine;
  Handle_Expr_NamedFunction: typeof Handle_Expr_NamedFunction;
  Handle_Expr_NamedFunction_1: typeof Handle_Expr_NamedFunction_1;
  Handle_Expr_NamedFunction_2: typeof Handle_Expr_NamedFunction_2;
  Handle_Expr_NamedFunction_3: typeof Handle_Expr_NamedFunction_3;
  Handle_Expr_NamedFunction_4: typeof Handle_Expr_NamedFunction_4;
  Expr_NamedFunction: typeof Expr_NamedFunction;
  Expr_Sum: typeof Expr_Sum;
  Expr_Sum_1: typeof Expr_Sum_1;
  Expr_Sum_2: typeof Expr_Sum_2;
  Handle_Expr_Sum: typeof Handle_Expr_Sum;
  Handle_Expr_Sum_1: typeof Handle_Expr_Sum_1;
  Handle_Expr_Sum_2: typeof Handle_Expr_Sum_2;
  Handle_Expr_Sum_3: typeof Handle_Expr_Sum_3;
  Handle_Expr_Sum_4: typeof Handle_Expr_Sum_4;
  Handle_Expr_NamedUnknown: typeof Handle_Expr_NamedUnknown;
  Handle_Expr_NamedUnknown_1: typeof Handle_Expr_NamedUnknown_1;
  Handle_Expr_NamedUnknown_2: typeof Handle_Expr_NamedUnknown_2;
  Handle_Expr_NamedUnknown_3: typeof Handle_Expr_NamedUnknown_3;
  Handle_Expr_NamedUnknown_4: typeof Handle_Expr_NamedUnknown_4;
  Expr_NamedUnknown: typeof Expr_NamedUnknown;
  Handle_Expr_LogOf10: typeof Handle_Expr_LogOf10;
  Handle_Expr_LogOf10_1: typeof Handle_Expr_LogOf10_1;
  Handle_Expr_LogOf10_2: typeof Handle_Expr_LogOf10_2;
  Handle_Expr_LogOf10_3: typeof Handle_Expr_LogOf10_3;
  Handle_Expr_LogOf10_4: typeof Handle_Expr_LogOf10_4;
  Expr_LogOf10: typeof Expr_LogOf10;
  Expr: typeof Expr;
  Expr_SingleRelation: typeof Expr_SingleRelation;
  Handle_Expr_SingleRelation: typeof Handle_Expr_SingleRelation;
  Handle_Expr_SingleRelation_1: typeof Handle_Expr_SingleRelation_1;
  Handle_Expr_SingleRelation_2: typeof Handle_Expr_SingleRelation_2;
  Handle_Expr_SingleRelation_3: typeof Handle_Expr_SingleRelation_3;
  Handle_Expr_SingleRelation_4: typeof Handle_Expr_SingleRelation_4;
  Expr_BinaryFunction: typeof Expr_BinaryFunction;
  Handle_Expr_BinaryFunction: typeof Handle_Expr_BinaryFunction;
  Handle_Expr_BinaryFunction_1: typeof Handle_Expr_BinaryFunction_1;
  Handle_Expr_BinaryFunction_2: typeof Handle_Expr_BinaryFunction_2;
  Handle_Expr_BinaryFunction_3: typeof Handle_Expr_BinaryFunction_3;
  Handle_Expr_BinaryFunction_4: typeof Handle_Expr_BinaryFunction_4;
  Handle_Expr_Exponential: typeof Handle_Expr_Exponential;
  Handle_Expr_Exponential_1: typeof Handle_Expr_Exponential_1;
  Handle_Expr_Exponential_2: typeof Handle_Expr_Exponential_2;
  Handle_Expr_Exponential_3: typeof Handle_Expr_Exponential_3;
  Handle_Expr_Exponential_4: typeof Handle_Expr_Exponential_4;
  Expr_Exponential: typeof Expr_Exponential;
  Handle_Expr_Different: typeof Handle_Expr_Different;
  Handle_Expr_Different_1: typeof Handle_Expr_Different_1;
  Handle_Expr_Different_2: typeof Handle_Expr_Different_2;
  Handle_Expr_Different_3: typeof Handle_Expr_Different_3;
  Handle_Expr_Different_4: typeof Handle_Expr_Different_4;
  Expr_Different: typeof Expr_Different;
  Expr_ExprFailure: typeof Expr_ExprFailure;
  Expr_ExprFailure_1: typeof Expr_ExprFailure_1;
  Expr_ExprFailure_2: typeof Expr_ExprFailure_2;
  Handle_Expr_ExprFailure: typeof Handle_Expr_ExprFailure;
  Handle_Expr_ExprFailure_1: typeof Handle_Expr_ExprFailure_1;
  Handle_Expr_ExprFailure_2: typeof Handle_Expr_ExprFailure_2;
  Handle_Expr_ExprFailure_3: typeof Handle_Expr_ExprFailure_3;
  Handle_Expr_ExprFailure_4: typeof Handle_Expr_ExprFailure_4;
  Handle_Expr_ArcSine: typeof Handle_Expr_ArcSine;
  Handle_Expr_ArcSine_1: typeof Handle_Expr_ArcSine_1;
  Handle_Expr_ArcSine_2: typeof Handle_Expr_ArcSine_2;
  Handle_Expr_ArcSine_3: typeof Handle_Expr_ArcSine_3;
  Handle_Expr_ArcSine_4: typeof Handle_Expr_ArcSine_4;
  Expr_ArcSine: typeof Expr_ArcSine;
  Expr_GeneralExpression: typeof Expr_GeneralExpression;
  Handle_Expr_GeneralExpression: typeof Handle_Expr_GeneralExpression;
  Handle_Expr_GeneralExpression_1: typeof Handle_Expr_GeneralExpression_1;
  Handle_Expr_GeneralExpression_2: typeof Handle_Expr_GeneralExpression_2;
  Handle_Expr_GeneralExpression_3: typeof Handle_Expr_GeneralExpression_3;
  Handle_Expr_GeneralExpression_4: typeof Handle_Expr_GeneralExpression_4;
  Handle_Expr_ArcCosine: typeof Handle_Expr_ArcCosine;
  Handle_Expr_ArcCosine_1: typeof Handle_Expr_ArcCosine_1;
  Handle_Expr_ArcCosine_2: typeof Handle_Expr_ArcCosine_2;
  Handle_Expr_ArcCosine_3: typeof Handle_Expr_ArcCosine_3;
  Handle_Expr_ArcCosine_4: typeof Handle_Expr_ArcCosine_4;
  Expr_ArcCosine: typeof Expr_ArcCosine;
  Handle_Expr_InvalidOperand: typeof Handle_Expr_InvalidOperand;
  Handle_Expr_InvalidOperand_1: typeof Handle_Expr_InvalidOperand_1;
  Handle_Expr_InvalidOperand_2: typeof Handle_Expr_InvalidOperand_2;
  Handle_Expr_InvalidOperand_3: typeof Handle_Expr_InvalidOperand_3;
  Handle_Expr_InvalidOperand_4: typeof Handle_Expr_InvalidOperand_4;
  Expr_InvalidOperand: typeof Expr_InvalidOperand;
  Expr_InvalidOperand_1: typeof Expr_InvalidOperand_1;
  Expr_InvalidOperand_2: typeof Expr_InvalidOperand_2;
  Expr_NamedExpression: typeof Expr_NamedExpression;
  Handle_Expr_NamedExpression: typeof Handle_Expr_NamedExpression;
  Handle_Expr_NamedExpression_1: typeof Handle_Expr_NamedExpression_1;
  Handle_Expr_NamedExpression_2: typeof Handle_Expr_NamedExpression_2;
  Handle_Expr_NamedExpression_3: typeof Handle_Expr_NamedExpression_3;
  Handle_Expr_NamedExpression_4: typeof Handle_Expr_NamedExpression_4;
  Expr_ArcTangent: typeof Expr_ArcTangent;
  Handle_Expr_ArcTangent: typeof Handle_Expr_ArcTangent;
  Handle_Expr_ArcTangent_1: typeof Handle_Expr_ArcTangent_1;
  Handle_Expr_ArcTangent_2: typeof Handle_Expr_ArcTangent_2;
  Handle_Expr_ArcTangent_3: typeof Handle_Expr_ArcTangent_3;
  Handle_Expr_ArcTangent_4: typeof Handle_Expr_ArcTangent_4;
  Expr_UnaryExpression: typeof Expr_UnaryExpression;
  Handle_Expr_UnaryExpression: typeof Handle_Expr_UnaryExpression;
  Handle_Expr_UnaryExpression_1: typeof Handle_Expr_UnaryExpression_1;
  Handle_Expr_UnaryExpression_2: typeof Handle_Expr_UnaryExpression_2;
  Handle_Expr_UnaryExpression_3: typeof Handle_Expr_UnaryExpression_3;
  Handle_Expr_UnaryExpression_4: typeof Handle_Expr_UnaryExpression_4;
  XmlTObjDrivers_IntSparseArrayDriver: typeof XmlTObjDrivers_IntSparseArrayDriver;
  Handle_XmlTObjDrivers_IntSparseArrayDriver: typeof Handle_XmlTObjDrivers_IntSparseArrayDriver;
  Handle_XmlTObjDrivers_IntSparseArrayDriver_1: typeof Handle_XmlTObjDrivers_IntSparseArrayDriver_1;
  Handle_XmlTObjDrivers_IntSparseArrayDriver_2: typeof Handle_XmlTObjDrivers_IntSparseArrayDriver_2;
  Handle_XmlTObjDrivers_IntSparseArrayDriver_3: typeof Handle_XmlTObjDrivers_IntSparseArrayDriver_3;
  Handle_XmlTObjDrivers_IntSparseArrayDriver_4: typeof Handle_XmlTObjDrivers_IntSparseArrayDriver_4;
  XmlTObjDrivers: typeof XmlTObjDrivers;
  XmlTObjDrivers_DocumentRetrievalDriver: typeof XmlTObjDrivers_DocumentRetrievalDriver;
  Handle_XmlTObjDrivers_DocumentRetrievalDriver: typeof Handle_XmlTObjDrivers_DocumentRetrievalDriver;
  Handle_XmlTObjDrivers_DocumentRetrievalDriver_1: typeof Handle_XmlTObjDrivers_DocumentRetrievalDriver_1;
  Handle_XmlTObjDrivers_DocumentRetrievalDriver_2: typeof Handle_XmlTObjDrivers_DocumentRetrievalDriver_2;
  Handle_XmlTObjDrivers_DocumentRetrievalDriver_3: typeof Handle_XmlTObjDrivers_DocumentRetrievalDriver_3;
  Handle_XmlTObjDrivers_DocumentRetrievalDriver_4: typeof Handle_XmlTObjDrivers_DocumentRetrievalDriver_4;
  XmlTObjDrivers_DocumentStorageDriver: typeof XmlTObjDrivers_DocumentStorageDriver;
  Handle_XmlTObjDrivers_DocumentStorageDriver: typeof Handle_XmlTObjDrivers_DocumentStorageDriver;
  Handle_XmlTObjDrivers_DocumentStorageDriver_1: typeof Handle_XmlTObjDrivers_DocumentStorageDriver_1;
  Handle_XmlTObjDrivers_DocumentStorageDriver_2: typeof Handle_XmlTObjDrivers_DocumentStorageDriver_2;
  Handle_XmlTObjDrivers_DocumentStorageDriver_3: typeof Handle_XmlTObjDrivers_DocumentStorageDriver_3;
  Handle_XmlTObjDrivers_DocumentStorageDriver_4: typeof Handle_XmlTObjDrivers_DocumentStorageDriver_4;
  Handle_XmlTObjDrivers_ModelDriver: typeof Handle_XmlTObjDrivers_ModelDriver;
  Handle_XmlTObjDrivers_ModelDriver_1: typeof Handle_XmlTObjDrivers_ModelDriver_1;
  Handle_XmlTObjDrivers_ModelDriver_2: typeof Handle_XmlTObjDrivers_ModelDriver_2;
  Handle_XmlTObjDrivers_ModelDriver_3: typeof Handle_XmlTObjDrivers_ModelDriver_3;
  Handle_XmlTObjDrivers_ModelDriver_4: typeof Handle_XmlTObjDrivers_ModelDriver_4;
  XmlTObjDrivers_ModelDriver: typeof XmlTObjDrivers_ModelDriver;
  XmlTObjDrivers_ObjectDriver: typeof XmlTObjDrivers_ObjectDriver;
  Handle_XmlTObjDrivers_ObjectDriver: typeof Handle_XmlTObjDrivers_ObjectDriver;
  Handle_XmlTObjDrivers_ObjectDriver_1: typeof Handle_XmlTObjDrivers_ObjectDriver_1;
  Handle_XmlTObjDrivers_ObjectDriver_2: typeof Handle_XmlTObjDrivers_ObjectDriver_2;
  Handle_XmlTObjDrivers_ObjectDriver_3: typeof Handle_XmlTObjDrivers_ObjectDriver_3;
  Handle_XmlTObjDrivers_ObjectDriver_4: typeof Handle_XmlTObjDrivers_ObjectDriver_4;
  XmlTObjDrivers_XYZDriver: typeof XmlTObjDrivers_XYZDriver;
  Handle_XmlTObjDrivers_XYZDriver: typeof Handle_XmlTObjDrivers_XYZDriver;
  Handle_XmlTObjDrivers_XYZDriver_1: typeof Handle_XmlTObjDrivers_XYZDriver_1;
  Handle_XmlTObjDrivers_XYZDriver_2: typeof Handle_XmlTObjDrivers_XYZDriver_2;
  Handle_XmlTObjDrivers_XYZDriver_3: typeof Handle_XmlTObjDrivers_XYZDriver_3;
  Handle_XmlTObjDrivers_XYZDriver_4: typeof Handle_XmlTObjDrivers_XYZDriver_4;
  XmlTObjDrivers_ReferenceDriver: typeof XmlTObjDrivers_ReferenceDriver;
  Handle_XmlTObjDrivers_ReferenceDriver: typeof Handle_XmlTObjDrivers_ReferenceDriver;
  Handle_XmlTObjDrivers_ReferenceDriver_1: typeof Handle_XmlTObjDrivers_ReferenceDriver_1;
  Handle_XmlTObjDrivers_ReferenceDriver_2: typeof Handle_XmlTObjDrivers_ReferenceDriver_2;
  Handle_XmlTObjDrivers_ReferenceDriver_3: typeof Handle_XmlTObjDrivers_ReferenceDriver_3;
  Handle_XmlTObjDrivers_ReferenceDriver_4: typeof Handle_XmlTObjDrivers_ReferenceDriver_4;
  ShapeConstruct: typeof ShapeConstruct;
  ShapeConstruct_Curve: typeof ShapeConstruct_Curve;
  Handle_ShapeConstruct_ProjectCurveOnSurface: typeof Handle_ShapeConstruct_ProjectCurveOnSurface;
  Handle_ShapeConstruct_ProjectCurveOnSurface_1: typeof Handle_ShapeConstruct_ProjectCurveOnSurface_1;
  Handle_ShapeConstruct_ProjectCurveOnSurface_2: typeof Handle_ShapeConstruct_ProjectCurveOnSurface_2;
  Handle_ShapeConstruct_ProjectCurveOnSurface_3: typeof Handle_ShapeConstruct_ProjectCurveOnSurface_3;
  Handle_ShapeConstruct_ProjectCurveOnSurface_4: typeof Handle_ShapeConstruct_ProjectCurveOnSurface_4;
  ShapeConstruct_ProjectCurveOnSurface: typeof ShapeConstruct_ProjectCurveOnSurface;
  ShapeConstruct_MakeTriangulation: typeof ShapeConstruct_MakeTriangulation;
  ShapeConstruct_MakeTriangulation_1: typeof ShapeConstruct_MakeTriangulation_1;
  ShapeConstruct_MakeTriangulation_2: typeof ShapeConstruct_MakeTriangulation_2;
  RWStepBasic_RWSiUnitAndAreaUnit: typeof RWStepBasic_RWSiUnitAndAreaUnit;
  RWStepBasic_RWWeekOfYearAndDayDate: typeof RWStepBasic_RWWeekOfYearAndDayDate;
  RWStepBasic_RWGroupAssignment: typeof RWStepBasic_RWGroupAssignment;
  RWStepBasic_RWConversionBasedUnitAndVolumeUnit: typeof RWStepBasic_RWConversionBasedUnitAndVolumeUnit;
  RWStepBasic_RWSiUnitAndLengthUnit: typeof RWStepBasic_RWSiUnitAndLengthUnit;
  RWStepBasic_RWConversionBasedUnitAndLengthUnit: typeof RWStepBasic_RWConversionBasedUnitAndLengthUnit;
  RWStepBasic_RWCertification: typeof RWStepBasic_RWCertification;
  RWStepBasic_RWSiUnitAndMassUnit: typeof RWStepBasic_RWSiUnitAndMassUnit;
  RWStepBasic_RWProductDefinitionEffectivity: typeof RWStepBasic_RWProductDefinitionEffectivity;
  RWStepBasic_RWOrganization: typeof RWStepBasic_RWOrganization;
  RWStepBasic_RWProductCategory: typeof RWStepBasic_RWProductCategory;
  RWStepBasic_RWMeasureWithUnit: typeof RWStepBasic_RWMeasureWithUnit;
  RWStepBasic_RWPersonalAddress: typeof RWStepBasic_RWPersonalAddress;
  RWStepBasic_RWSiUnit: typeof RWStepBasic_RWSiUnit;
  RWStepBasic_RWLengthUnit: typeof RWStepBasic_RWLengthUnit;
  RWStepBasic_RWConversionBasedUnitAndRatioUnit: typeof RWStepBasic_RWConversionBasedUnitAndRatioUnit;
  RWStepBasic_RWActionMethod: typeof RWStepBasic_RWActionMethod;
  RWStepBasic_RWSiUnitAndSolidAngleUnit: typeof RWStepBasic_RWSiUnitAndSolidAngleUnit;
  RWStepBasic_RWProductDefinitionReferenceWithLocalRepresentation: typeof RWStepBasic_RWProductDefinitionReferenceWithLocalRepresentation;
  RWStepBasic_RWConversionBasedUnitAndPlaneAngleUnit: typeof RWStepBasic_RWConversionBasedUnitAndPlaneAngleUnit;
  RWStepBasic_RWProductDefinitionFormationRelationship: typeof RWStepBasic_RWProductDefinitionFormationRelationship;
  RWStepBasic_RWSecurityClassification: typeof RWStepBasic_RWSecurityClassification;
  RWStepBasic_RWMassMeasureWithUnit: typeof RWStepBasic_RWMassMeasureWithUnit;
  RWStepBasic_RWConversionBasedUnit: typeof RWStepBasic_RWConversionBasedUnit;
  RWStepBasic_RWContractType: typeof RWStepBasic_RWContractType;
  RWStepBasic_RWConversionBasedUnitAndSolidAngleUnit: typeof RWStepBasic_RWConversionBasedUnitAndSolidAngleUnit;
  RWStepBasic_RWExternallyDefinedItem: typeof RWStepBasic_RWExternallyDefinedItem;
  RWStepBasic_RWCertificationAssignment: typeof RWStepBasic_RWCertificationAssignment;
  RWStepBasic_RWContract: typeof RWStepBasic_RWContract;
  RWStepBasic_RWGeneralProperty: typeof RWStepBasic_RWGeneralProperty;
  RWStepBasic_RWActionAssignment: typeof RWStepBasic_RWActionAssignment;
  RWStepBasic_RWDate: typeof RWStepBasic_RWDate;
  RWStepBasic_RWGroup: typeof RWStepBasic_RWGroup;
  RWStepBasic_RWApplicationProtocolDefinition: typeof RWStepBasic_RWApplicationProtocolDefinition;
  RWStepBasic_RWMassUnit: typeof RWStepBasic_RWMassUnit;
  RWStepBasic_RWDocumentUsageConstraint: typeof RWStepBasic_RWDocumentUsageConstraint;
  RWStepBasic_RWProductConceptContext: typeof RWStepBasic_RWProductConceptContext;
  RWStepBasic_RWOrganizationRole: typeof RWStepBasic_RWOrganizationRole;
  RWStepBasic_RWConversionBasedUnitAndAreaUnit: typeof RWStepBasic_RWConversionBasedUnitAndAreaUnit;
  RWStepBasic_RWEffectivityAssignment: typeof RWStepBasic_RWEffectivityAssignment;
  RWStepBasic_RWProductCategoryRelationship: typeof RWStepBasic_RWProductCategoryRelationship;
  RWStepBasic_RWNameAssignment: typeof RWStepBasic_RWNameAssignment;
  RWStepBasic_RWPlaneAngleUnit: typeof RWStepBasic_RWPlaneAngleUnit;
  RWStepBasic_RWDocumentProductAssociation: typeof RWStepBasic_RWDocumentProductAssociation;
  RWStepBasic_RWProductDefinitionFormationWithSpecifiedSource: typeof RWStepBasic_RWProductDefinitionFormationWithSpecifiedSource;
  RWStepBasic_RWGroupRelationship: typeof RWStepBasic_RWGroupRelationship;
  RWStepBasic_RWApprovalRelationship: typeof RWStepBasic_RWApprovalRelationship;
  RWStepBasic_RWLocalTime: typeof RWStepBasic_RWLocalTime;
  RWStepBasic_RWActionRequestAssignment: typeof RWStepBasic_RWActionRequestAssignment;
  RWStepBasic_RWSolidAngleMeasureWithUnit: typeof RWStepBasic_RWSolidAngleMeasureWithUnit;
  RWStepBasic_RWProductDefinitionFormation: typeof RWStepBasic_RWProductDefinitionFormation;
  RWStepBasic_RWDocumentProductEquivalence: typeof RWStepBasic_RWDocumentProductEquivalence;
  RWStepBasic_RWProductDefinitionReference: typeof RWStepBasic_RWProductDefinitionReference;
  RWStepBasic_RWSiUnitAndRatioUnit: typeof RWStepBasic_RWSiUnitAndRatioUnit;
  RWStepBasic_RWPerson: typeof RWStepBasic_RWPerson;
  RWStepBasic_RWDerivedUnit: typeof RWStepBasic_RWDerivedUnit;
  RWStepBasic_RWSiUnitAndTimeUnit: typeof RWStepBasic_RWSiUnitAndTimeUnit;
  RWStepBasic_RWSiUnitAndVolumeUnit: typeof RWStepBasic_RWSiUnitAndVolumeUnit;
  RWStepBasic_RWProductDefinition: typeof RWStepBasic_RWProductDefinition;
  RWStepBasic_RWApplicationContext: typeof RWStepBasic_RWApplicationContext;
  RWStepBasic_RWDerivedUnitElement: typeof RWStepBasic_RWDerivedUnitElement;
  RWStepBasic_RWApprovalStatus: typeof RWStepBasic_RWApprovalStatus;
  RWStepBasic_RWSecurityClassificationLevel: typeof RWStepBasic_RWSecurityClassificationLevel;
  RWStepBasic_RWUncertaintyMeasureWithUnit: typeof RWStepBasic_RWUncertaintyMeasureWithUnit;
  RWStepBasic_RWDateTimeRole: typeof RWStepBasic_RWDateTimeRole;
  RWStepBasic_RWEffectivity: typeof RWStepBasic_RWEffectivity;
  RWStepBasic_RWPersonAndOrganization: typeof RWStepBasic_RWPersonAndOrganization;
  RWStepBasic_RWDateAndTime: typeof RWStepBasic_RWDateAndTime;
  RWStepBasic_RWConversionBasedUnitAndMassUnit: typeof RWStepBasic_RWConversionBasedUnitAndMassUnit;
  RWStepBasic_RWSolidAngleUnit: typeof RWStepBasic_RWSolidAngleUnit;
  RWStepBasic_RWMechanicalContext: typeof RWStepBasic_RWMechanicalContext;
  RWStepBasic_RWApplicationContextElement: typeof RWStepBasic_RWApplicationContextElement;
  RWStepBasic_RWSiUnitAndPlaneAngleUnit: typeof RWStepBasic_RWSiUnitAndPlaneAngleUnit;
  RWStepBasic_RWOrganizationalAddress: typeof RWStepBasic_RWOrganizationalAddress;
  RWStepBasic_RWExternalSource: typeof RWStepBasic_RWExternalSource;
  RWStepBasic_RWProductRelatedProductCategory: typeof RWStepBasic_RWProductRelatedProductCategory;
  RWStepBasic_RWDocument: typeof RWStepBasic_RWDocument;
  RWStepBasic_RWAddress: typeof RWStepBasic_RWAddress;
  RWStepBasic_RWDocumentType: typeof RWStepBasic_RWDocumentType;
  RWStepBasic_RWApprovalPersonOrganization: typeof RWStepBasic_RWApprovalPersonOrganization;
  RWStepBasic_RWProduct: typeof RWStepBasic_RWProduct;
  RWStepBasic_RWDocumentFile: typeof RWStepBasic_RWDocumentFile;
  RWStepBasic_RWPersonAndOrganizationRole: typeof RWStepBasic_RWPersonAndOrganizationRole;
  RWStepBasic_RWApprovalDateTime: typeof RWStepBasic_RWApprovalDateTime;
  RWStepBasic_RWDocumentRepresentationType: typeof RWStepBasic_RWDocumentRepresentationType;
  RWStepBasic_RWDateRole: typeof RWStepBasic_RWDateRole;
  RWStepBasic_RWDocumentRelationship: typeof RWStepBasic_RWDocumentRelationship;
  RWStepBasic_RWContractAssignment: typeof RWStepBasic_RWContractAssignment;
  RWStepBasic_RWApproval: typeof RWStepBasic_RWApproval;
  RWStepBasic_RWIdentificationRole: typeof RWStepBasic_RWIdentificationRole;
  RWStepBasic_RWSiUnitAndThermodynamicTemperatureUnit: typeof RWStepBasic_RWSiUnitAndThermodynamicTemperatureUnit;
  RWStepBasic_RWOrdinalDate: typeof RWStepBasic_RWOrdinalDate;
  RWStepBasic_RWActionRequestSolution: typeof RWStepBasic_RWActionRequestSolution;
  RWStepBasic_RWRoleAssociation: typeof RWStepBasic_RWRoleAssociation;
  RWStepBasic_RWDimensionalExponents: typeof RWStepBasic_RWDimensionalExponents;
  RWStepBasic_RWApprovalRole: typeof RWStepBasic_RWApprovalRole;
  RWStepBasic_RWProductType: typeof RWStepBasic_RWProductType;
  RWStepBasic_RWProductDefinitionRelationship: typeof RWStepBasic_RWProductDefinitionRelationship;
  RWStepBasic_RWThermodynamicTemperatureUnit: typeof RWStepBasic_RWThermodynamicTemperatureUnit;
  RWStepBasic_RWCoordinatedUniversalTimeOffset: typeof RWStepBasic_RWCoordinatedUniversalTimeOffset;
  RWStepBasic_RWExternalIdentificationAssignment: typeof RWStepBasic_RWExternalIdentificationAssignment;
  RWStepBasic_RWAction: typeof RWStepBasic_RWAction;
  RWStepBasic_RWLengthMeasureWithUnit: typeof RWStepBasic_RWLengthMeasureWithUnit;
  RWStepBasic_RWCalendarDate: typeof RWStepBasic_RWCalendarDate;
  RWStepBasic_RWIdentificationAssignment: typeof RWStepBasic_RWIdentificationAssignment;
  RWStepBasic_RWCharacterizedObject: typeof RWStepBasic_RWCharacterizedObject;
  RWStepBasic_RWConversionBasedUnitAndTimeUnit: typeof RWStepBasic_RWConversionBasedUnitAndTimeUnit;
  RWStepBasic_RWVersionedActionRequest: typeof RWStepBasic_RWVersionedActionRequest;
  RWStepBasic_RWCertificationType: typeof RWStepBasic_RWCertificationType;
  RWStepBasic_RWNamedUnit: typeof RWStepBasic_RWNamedUnit;
  RWStepBasic_RWProductDefinitionWithAssociatedDocuments: typeof RWStepBasic_RWProductDefinitionWithAssociatedDocuments;
  RWStepBasic_RWPlaneAngleMeasureWithUnit: typeof RWStepBasic_RWPlaneAngleMeasureWithUnit;
  RWStepBasic_RWRatioMeasureWithUnit: typeof RWStepBasic_RWRatioMeasureWithUnit;
  RWStepBasic_RWProductContext: typeof RWStepBasic_RWProductContext;
  RWStepBasic_RWEulerAngles: typeof RWStepBasic_RWEulerAngles;
  RWStepBasic_RWObjectRole: typeof RWStepBasic_RWObjectRole;
  RWStepBasic_RWProductDefinitionContext: typeof RWStepBasic_RWProductDefinitionContext;
  IntPolyh_Triangle: typeof IntPolyh_Triangle;
  IntPolyh_Triangle_1: typeof IntPolyh_Triangle_1;
  IntPolyh_Triangle_2: typeof IntPolyh_Triangle_2;
  IntPolyh_SeqOfStartPoints: typeof IntPolyh_SeqOfStartPoints;
  IntPolyh_SeqOfStartPoints_1: typeof IntPolyh_SeqOfStartPoints_1;
  IntPolyh_SeqOfStartPoints_2: typeof IntPolyh_SeqOfStartPoints_2;
  IntPolyh_SeqOfStartPoints_3: typeof IntPolyh_SeqOfStartPoints_3;
  IntPolyh_StartPoint: typeof IntPolyh_StartPoint;
  IntPolyh_StartPoint_1: typeof IntPolyh_StartPoint_1;
  IntPolyh_StartPoint_2: typeof IntPolyh_StartPoint_2;
  IntPolyh_Edge: typeof IntPolyh_Edge;
  IntPolyh_Edge_1: typeof IntPolyh_Edge_1;
  IntPolyh_Edge_2: typeof IntPolyh_Edge_2;
  IntPolyh_Couple: typeof IntPolyh_Couple;
  IntPolyh_Couple_1: typeof IntPolyh_Couple_1;
  IntPolyh_Couple_2: typeof IntPolyh_Couple_2;
  IntPolyh_SectionLine: typeof IntPolyh_SectionLine;
  IntPolyh_SectionLine_1: typeof IntPolyh_SectionLine_1;
  IntPolyh_SectionLine_2: typeof IntPolyh_SectionLine_2;
  IntPolyh_Intersection: typeof IntPolyh_Intersection;
  IntPolyh_Intersection_1: typeof IntPolyh_Intersection_1;
  IntPolyh_Intersection_2: typeof IntPolyh_Intersection_2;
  IntPolyh_Intersection_3: typeof IntPolyh_Intersection_3;
  IntPolyh_Tools: typeof IntPolyh_Tools;
  IntPolyh_PointNormal: typeof IntPolyh_PointNormal;
  IntPolyh_Point: typeof IntPolyh_Point;
  IntPolyh_Point_1: typeof IntPolyh_Point_1;
  IntPolyh_Point_2: typeof IntPolyh_Point_2;
  IntPolyh_CoupleMapHasher: typeof IntPolyh_CoupleMapHasher;
  IntPolyh_ListOfCouples: typeof IntPolyh_ListOfCouples;
  IntPolyh_ListOfCouples_1: typeof IntPolyh_ListOfCouples_1;
  IntPolyh_ListOfCouples_2: typeof IntPolyh_ListOfCouples_2;
  IntPolyh_ListOfCouples_3: typeof IntPolyh_ListOfCouples_3;
  RWStepAP203_RWChangeRequest: typeof RWStepAP203_RWChangeRequest;
  RWStepAP203_RWCcDesignApproval: typeof RWStepAP203_RWCcDesignApproval;
  RWStepAP203_RWCcDesignPersonAndOrganizationAssignment: typeof RWStepAP203_RWCcDesignPersonAndOrganizationAssignment;
  RWStepAP203_RWCcDesignContract: typeof RWStepAP203_RWCcDesignContract;
  RWStepAP203_RWStartRequest: typeof RWStepAP203_RWStartRequest;
  RWStepAP203_RWCcDesignSecurityClassification: typeof RWStepAP203_RWCcDesignSecurityClassification;
  RWStepAP203_RWCcDesignCertification: typeof RWStepAP203_RWCcDesignCertification;
  RWStepAP203_RWChange: typeof RWStepAP203_RWChange;
  RWStepAP203_RWStartWork: typeof RWStepAP203_RWStartWork;
  RWStepAP203_RWCcDesignDateAndTimeAssignment: typeof RWStepAP203_RWCcDesignDateAndTimeAssignment;
  RWStepAP203_RWCcDesignSpecificationReference: typeof RWStepAP203_RWCcDesignSpecificationReference;
  TDataXtd_Constraint: typeof TDataXtd_Constraint;
  Handle_TDataXtd_Constraint: typeof Handle_TDataXtd_Constraint;
  Handle_TDataXtd_Constraint_1: typeof Handle_TDataXtd_Constraint_1;
  Handle_TDataXtd_Constraint_2: typeof Handle_TDataXtd_Constraint_2;
  Handle_TDataXtd_Constraint_3: typeof Handle_TDataXtd_Constraint_3;
  Handle_TDataXtd_Constraint_4: typeof Handle_TDataXtd_Constraint_4;
  Handle_TDataXtd_HArray1OfTrsf: typeof Handle_TDataXtd_HArray1OfTrsf;
  Handle_TDataXtd_HArray1OfTrsf_1: typeof Handle_TDataXtd_HArray1OfTrsf_1;
  Handle_TDataXtd_HArray1OfTrsf_2: typeof Handle_TDataXtd_HArray1OfTrsf_2;
  Handle_TDataXtd_HArray1OfTrsf_3: typeof Handle_TDataXtd_HArray1OfTrsf_3;
  Handle_TDataXtd_HArray1OfTrsf_4: typeof Handle_TDataXtd_HArray1OfTrsf_4;
  TDataXtd_Array1OfTrsf: typeof TDataXtd_Array1OfTrsf;
  TDataXtd_Array1OfTrsf_1: typeof TDataXtd_Array1OfTrsf_1;
  TDataXtd_Array1OfTrsf_2: typeof TDataXtd_Array1OfTrsf_2;
  TDataXtd_Array1OfTrsf_3: typeof TDataXtd_Array1OfTrsf_3;
  TDataXtd_Array1OfTrsf_4: typeof TDataXtd_Array1OfTrsf_4;
  TDataXtd_Array1OfTrsf_5: typeof TDataXtd_Array1OfTrsf_5;
  TDataXtd_Geometry: typeof TDataXtd_Geometry;
  Handle_TDataXtd_Geometry: typeof Handle_TDataXtd_Geometry;
  Handle_TDataXtd_Geometry_1: typeof Handle_TDataXtd_Geometry_1;
  Handle_TDataXtd_Geometry_2: typeof Handle_TDataXtd_Geometry_2;
  Handle_TDataXtd_Geometry_3: typeof Handle_TDataXtd_Geometry_3;
  Handle_TDataXtd_Geometry_4: typeof Handle_TDataXtd_Geometry_4;
  TDataXtd_Pattern: typeof TDataXtd_Pattern;
  Handle_TDataXtd_Pattern: typeof Handle_TDataXtd_Pattern;
  Handle_TDataXtd_Pattern_1: typeof Handle_TDataXtd_Pattern_1;
  Handle_TDataXtd_Pattern_2: typeof Handle_TDataXtd_Pattern_2;
  Handle_TDataXtd_Pattern_3: typeof Handle_TDataXtd_Pattern_3;
  Handle_TDataXtd_Pattern_4: typeof Handle_TDataXtd_Pattern_4;
  TDataXtd: typeof TDataXtd;
  TDataXtd_Presentation: typeof TDataXtd_Presentation;
  Handle_TDataXtd_Presentation: typeof Handle_TDataXtd_Presentation;
  Handle_TDataXtd_Presentation_1: typeof Handle_TDataXtd_Presentation_1;
  Handle_TDataXtd_Presentation_2: typeof Handle_TDataXtd_Presentation_2;
  Handle_TDataXtd_Presentation_3: typeof Handle_TDataXtd_Presentation_3;
  Handle_TDataXtd_Presentation_4: typeof Handle_TDataXtd_Presentation_4;
  TDataXtd_Triangulation: typeof TDataXtd_Triangulation;
  Handle_TDataXtd_Triangulation: typeof Handle_TDataXtd_Triangulation;
  Handle_TDataXtd_Triangulation_1: typeof Handle_TDataXtd_Triangulation_1;
  Handle_TDataXtd_Triangulation_2: typeof Handle_TDataXtd_Triangulation_2;
  Handle_TDataXtd_Triangulation_3: typeof Handle_TDataXtd_Triangulation_3;
  Handle_TDataXtd_Triangulation_4: typeof Handle_TDataXtd_Triangulation_4;
  TDataXtd_Axis: typeof TDataXtd_Axis;
  Handle_TDataXtd_Axis: typeof Handle_TDataXtd_Axis;
  Handle_TDataXtd_Axis_1: typeof Handle_TDataXtd_Axis_1;
  Handle_TDataXtd_Axis_2: typeof Handle_TDataXtd_Axis_2;
  Handle_TDataXtd_Axis_3: typeof Handle_TDataXtd_Axis_3;
  Handle_TDataXtd_Axis_4: typeof Handle_TDataXtd_Axis_4;
  Handle_TDataXtd_Shape: typeof Handle_TDataXtd_Shape;
  Handle_TDataXtd_Shape_1: typeof Handle_TDataXtd_Shape_1;
  Handle_TDataXtd_Shape_2: typeof Handle_TDataXtd_Shape_2;
  Handle_TDataXtd_Shape_3: typeof Handle_TDataXtd_Shape_3;
  Handle_TDataXtd_Shape_4: typeof Handle_TDataXtd_Shape_4;
  TDataXtd_Shape: typeof TDataXtd_Shape;
  TDataXtd_GeometryEnum: TDataXtd_GeometryEnum;
  TDataXtd_ConstraintEnum: TDataXtd_ConstraintEnum;
  Handle_TDataXtd_Placement: typeof Handle_TDataXtd_Placement;
  Handle_TDataXtd_Placement_1: typeof Handle_TDataXtd_Placement_1;
  Handle_TDataXtd_Placement_2: typeof Handle_TDataXtd_Placement_2;
  Handle_TDataXtd_Placement_3: typeof Handle_TDataXtd_Placement_3;
  Handle_TDataXtd_Placement_4: typeof Handle_TDataXtd_Placement_4;
  TDataXtd_Placement: typeof TDataXtd_Placement;
  TDataXtd_Plane: typeof TDataXtd_Plane;
  Handle_TDataXtd_Plane: typeof Handle_TDataXtd_Plane;
  Handle_TDataXtd_Plane_1: typeof Handle_TDataXtd_Plane_1;
  Handle_TDataXtd_Plane_2: typeof Handle_TDataXtd_Plane_2;
  Handle_TDataXtd_Plane_3: typeof Handle_TDataXtd_Plane_3;
  Handle_TDataXtd_Plane_4: typeof Handle_TDataXtd_Plane_4;
  Handle_TDataXtd_PatternStd: typeof Handle_TDataXtd_PatternStd;
  Handle_TDataXtd_PatternStd_1: typeof Handle_TDataXtd_PatternStd_1;
  Handle_TDataXtd_PatternStd_2: typeof Handle_TDataXtd_PatternStd_2;
  Handle_TDataXtd_PatternStd_3: typeof Handle_TDataXtd_PatternStd_3;
  Handle_TDataXtd_PatternStd_4: typeof Handle_TDataXtd_PatternStd_4;
  TDataXtd_PatternStd: typeof TDataXtd_PatternStd;
  Handle_TDataXtd_Point: typeof Handle_TDataXtd_Point;
  Handle_TDataXtd_Point_1: typeof Handle_TDataXtd_Point_1;
  Handle_TDataXtd_Point_2: typeof Handle_TDataXtd_Point_2;
  Handle_TDataXtd_Point_3: typeof Handle_TDataXtd_Point_3;
  Handle_TDataXtd_Point_4: typeof Handle_TDataXtd_Point_4;
  TDataXtd_Point: typeof TDataXtd_Point;
  Handle_TDataXtd_Position: typeof Handle_TDataXtd_Position;
  Handle_TDataXtd_Position_1: typeof Handle_TDataXtd_Position_1;
  Handle_TDataXtd_Position_2: typeof Handle_TDataXtd_Position_2;
  Handle_TDataXtd_Position_3: typeof Handle_TDataXtd_Position_3;
  Handle_TDataXtd_Position_4: typeof Handle_TDataXtd_Position_4;
  TDataXtd_Position: typeof TDataXtd_Position;
  XmlMFunction_GraphNodeDriver: typeof XmlMFunction_GraphNodeDriver;
  Handle_XmlMFunction_GraphNodeDriver: typeof Handle_XmlMFunction_GraphNodeDriver;
  Handle_XmlMFunction_GraphNodeDriver_1: typeof Handle_XmlMFunction_GraphNodeDriver_1;
  Handle_XmlMFunction_GraphNodeDriver_2: typeof Handle_XmlMFunction_GraphNodeDriver_2;
  Handle_XmlMFunction_GraphNodeDriver_3: typeof Handle_XmlMFunction_GraphNodeDriver_3;
  Handle_XmlMFunction_GraphNodeDriver_4: typeof Handle_XmlMFunction_GraphNodeDriver_4;
  XmlMFunction: typeof XmlMFunction;
  XmlMFunction_ScopeDriver: typeof XmlMFunction_ScopeDriver;
  Handle_XmlMFunction_ScopeDriver: typeof Handle_XmlMFunction_ScopeDriver;
  Handle_XmlMFunction_ScopeDriver_1: typeof Handle_XmlMFunction_ScopeDriver_1;
  Handle_XmlMFunction_ScopeDriver_2: typeof Handle_XmlMFunction_ScopeDriver_2;
  Handle_XmlMFunction_ScopeDriver_3: typeof Handle_XmlMFunction_ScopeDriver_3;
  Handle_XmlMFunction_ScopeDriver_4: typeof Handle_XmlMFunction_ScopeDriver_4;
  XmlMFunction_FunctionDriver: typeof XmlMFunction_FunctionDriver;
  Handle_XmlMFunction_FunctionDriver: typeof Handle_XmlMFunction_FunctionDriver;
  Handle_XmlMFunction_FunctionDriver_1: typeof Handle_XmlMFunction_FunctionDriver_1;
  Handle_XmlMFunction_FunctionDriver_2: typeof Handle_XmlMFunction_FunctionDriver_2;
  Handle_XmlMFunction_FunctionDriver_3: typeof Handle_XmlMFunction_FunctionDriver_3;
  Handle_XmlMFunction_FunctionDriver_4: typeof Handle_XmlMFunction_FunctionDriver_4;
  IGESData_DefaultSpecific: typeof IGESData_DefaultSpecific;
  Handle_IGESData_DefaultSpecific: typeof Handle_IGESData_DefaultSpecific;
  Handle_IGESData_DefaultSpecific_1: typeof Handle_IGESData_DefaultSpecific_1;
  Handle_IGESData_DefaultSpecific_2: typeof Handle_IGESData_DefaultSpecific_2;
  Handle_IGESData_DefaultSpecific_3: typeof Handle_IGESData_DefaultSpecific_3;
  Handle_IGESData_DefaultSpecific_4: typeof Handle_IGESData_DefaultSpecific_4;
  IGESData_IGESType: typeof IGESData_IGESType;
  IGESData_IGESType_1: typeof IGESData_IGESType_1;
  IGESData_IGESType_2: typeof IGESData_IGESType_2;
  IGESData_GlobalNodeOfWriterLib: typeof IGESData_GlobalNodeOfWriterLib;
  Handle_IGESData_GlobalNodeOfWriterLib: typeof Handle_IGESData_GlobalNodeOfWriterLib;
  Handle_IGESData_GlobalNodeOfWriterLib_1: typeof Handle_IGESData_GlobalNodeOfWriterLib_1;
  Handle_IGESData_GlobalNodeOfWriterLib_2: typeof Handle_IGESData_GlobalNodeOfWriterLib_2;
  Handle_IGESData_GlobalNodeOfWriterLib_3: typeof Handle_IGESData_GlobalNodeOfWriterLib_3;
  Handle_IGESData_GlobalNodeOfWriterLib_4: typeof Handle_IGESData_GlobalNodeOfWriterLib_4;
  IGESData_Status: IGESData_Status;
  IGESData_ReadStage: IGESData_ReadStage;
  IGESData_NodeOfSpecificLib: typeof IGESData_NodeOfSpecificLib;
  Handle_IGESData_NodeOfSpecificLib: typeof Handle_IGESData_NodeOfSpecificLib;
  Handle_IGESData_NodeOfSpecificLib_1: typeof Handle_IGESData_NodeOfSpecificLib_1;
  Handle_IGESData_NodeOfSpecificLib_2: typeof Handle_IGESData_NodeOfSpecificLib_2;
  Handle_IGESData_NodeOfSpecificLib_3: typeof Handle_IGESData_NodeOfSpecificLib_3;
  Handle_IGESData_NodeOfSpecificLib_4: typeof Handle_IGESData_NodeOfSpecificLib_4;
  IGESData_IGESReaderTool: typeof IGESData_IGESReaderTool;
  Handle_IGESData_SingleParentEntity: typeof Handle_IGESData_SingleParentEntity;
  Handle_IGESData_SingleParentEntity_1: typeof Handle_IGESData_SingleParentEntity_1;
  Handle_IGESData_SingleParentEntity_2: typeof Handle_IGESData_SingleParentEntity_2;
  Handle_IGESData_SingleParentEntity_3: typeof Handle_IGESData_SingleParentEntity_3;
  Handle_IGESData_SingleParentEntity_4: typeof Handle_IGESData_SingleParentEntity_4;
  IGESData_SingleParentEntity: typeof IGESData_SingleParentEntity;
  Handle_IGESData_LevelListEntity: typeof Handle_IGESData_LevelListEntity;
  Handle_IGESData_LevelListEntity_1: typeof Handle_IGESData_LevelListEntity_1;
  Handle_IGESData_LevelListEntity_2: typeof Handle_IGESData_LevelListEntity_2;
  Handle_IGESData_LevelListEntity_3: typeof Handle_IGESData_LevelListEntity_3;
  Handle_IGESData_LevelListEntity_4: typeof Handle_IGESData_LevelListEntity_4;
  IGESData_LevelListEntity: typeof IGESData_LevelListEntity;
  Handle_IGESData_NameEntity: typeof Handle_IGESData_NameEntity;
  Handle_IGESData_NameEntity_1: typeof Handle_IGESData_NameEntity_1;
  Handle_IGESData_NameEntity_2: typeof Handle_IGESData_NameEntity_2;
  Handle_IGESData_NameEntity_3: typeof Handle_IGESData_NameEntity_3;
  Handle_IGESData_NameEntity_4: typeof Handle_IGESData_NameEntity_4;
  IGESData_NameEntity: typeof IGESData_NameEntity;
  Handle_IGESData_LineFontEntity: typeof Handle_IGESData_LineFontEntity;
  Handle_IGESData_LineFontEntity_1: typeof Handle_IGESData_LineFontEntity_1;
  Handle_IGESData_LineFontEntity_2: typeof Handle_IGESData_LineFontEntity_2;
  Handle_IGESData_LineFontEntity_3: typeof Handle_IGESData_LineFontEntity_3;
  Handle_IGESData_LineFontEntity_4: typeof Handle_IGESData_LineFontEntity_4;
  IGESData_LineFontEntity: typeof IGESData_LineFontEntity;
  IGESData_DefType: IGESData_DefType;
  IGESData_DefList: IGESData_DefList;
  IGESData_ReadWriteModule: typeof IGESData_ReadWriteModule;
  Handle_IGESData_ReadWriteModule: typeof Handle_IGESData_ReadWriteModule;
  Handle_IGESData_ReadWriteModule_1: typeof Handle_IGESData_ReadWriteModule_1;
  Handle_IGESData_ReadWriteModule_2: typeof Handle_IGESData_ReadWriteModule_2;
  Handle_IGESData_ReadWriteModule_3: typeof Handle_IGESData_ReadWriteModule_3;
  Handle_IGESData_ReadWriteModule_4: typeof Handle_IGESData_ReadWriteModule_4;
  Handle_IGESData_UndefinedEntity: typeof Handle_IGESData_UndefinedEntity;
  Handle_IGESData_UndefinedEntity_1: typeof Handle_IGESData_UndefinedEntity_1;
  Handle_IGESData_UndefinedEntity_2: typeof Handle_IGESData_UndefinedEntity_2;
  Handle_IGESData_UndefinedEntity_3: typeof Handle_IGESData_UndefinedEntity_3;
  Handle_IGESData_UndefinedEntity_4: typeof Handle_IGESData_UndefinedEntity_4;
  IGESData_UndefinedEntity: typeof IGESData_UndefinedEntity;
  Handle_IGESData_FileProtocol: typeof Handle_IGESData_FileProtocol;
  Handle_IGESData_FileProtocol_1: typeof Handle_IGESData_FileProtocol_1;
  Handle_IGESData_FileProtocol_2: typeof Handle_IGESData_FileProtocol_2;
  Handle_IGESData_FileProtocol_3: typeof Handle_IGESData_FileProtocol_3;
  Handle_IGESData_FileProtocol_4: typeof Handle_IGESData_FileProtocol_4;
  IGESData_FileProtocol: typeof IGESData_FileProtocol;
  Handle_IGESData_IGESReaderData: typeof Handle_IGESData_IGESReaderData;
  Handle_IGESData_IGESReaderData_1: typeof Handle_IGESData_IGESReaderData_1;
  Handle_IGESData_IGESReaderData_2: typeof Handle_IGESData_IGESReaderData_2;
  Handle_IGESData_IGESReaderData_3: typeof Handle_IGESData_IGESReaderData_3;
  Handle_IGESData_IGESReaderData_4: typeof Handle_IGESData_IGESReaderData_4;
  Handle_IGESData_IGESModel: typeof Handle_IGESData_IGESModel;
  Handle_IGESData_IGESModel_1: typeof Handle_IGESData_IGESModel_1;
  Handle_IGESData_IGESModel_2: typeof Handle_IGESData_IGESModel_2;
  Handle_IGESData_IGESModel_3: typeof Handle_IGESData_IGESModel_3;
  Handle_IGESData_IGESModel_4: typeof Handle_IGESData_IGESModel_4;
  IGESData_IGESModel: typeof IGESData_IGESModel;
  Handle_IGESData_FileRecognizer: typeof Handle_IGESData_FileRecognizer;
  Handle_IGESData_FileRecognizer_1: typeof Handle_IGESData_FileRecognizer_1;
  Handle_IGESData_FileRecognizer_2: typeof Handle_IGESData_FileRecognizer_2;
  Handle_IGESData_FileRecognizer_3: typeof Handle_IGESData_FileRecognizer_3;
  Handle_IGESData_FileRecognizer_4: typeof Handle_IGESData_FileRecognizer_4;
  IGESData_FileRecognizer: typeof IGESData_FileRecognizer;
  Handle_IGESData_ColorEntity: typeof Handle_IGESData_ColorEntity;
  Handle_IGESData_ColorEntity_1: typeof Handle_IGESData_ColorEntity_1;
  Handle_IGESData_ColorEntity_2: typeof Handle_IGESData_ColorEntity_2;
  Handle_IGESData_ColorEntity_3: typeof Handle_IGESData_ColorEntity_3;
  Handle_IGESData_ColorEntity_4: typeof Handle_IGESData_ColorEntity_4;
  IGESData_ColorEntity: typeof IGESData_ColorEntity;
  Handle_IGESData_SpecificModule: typeof Handle_IGESData_SpecificModule;
  Handle_IGESData_SpecificModule_1: typeof Handle_IGESData_SpecificModule_1;
  Handle_IGESData_SpecificModule_2: typeof Handle_IGESData_SpecificModule_2;
  Handle_IGESData_SpecificModule_3: typeof Handle_IGESData_SpecificModule_3;
  Handle_IGESData_SpecificModule_4: typeof Handle_IGESData_SpecificModule_4;
  IGESData_SpecificModule: typeof IGESData_SpecificModule;
  IGESData_IGESEntity: typeof IGESData_IGESEntity;
  Handle_IGESData_IGESEntity: typeof Handle_IGESData_IGESEntity;
  Handle_IGESData_IGESEntity_1: typeof Handle_IGESData_IGESEntity_1;
  Handle_IGESData_IGESEntity_2: typeof Handle_IGESData_IGESEntity_2;
  Handle_IGESData_IGESEntity_3: typeof Handle_IGESData_IGESEntity_3;
  Handle_IGESData_IGESEntity_4: typeof Handle_IGESData_IGESEntity_4;
  Handle_IGESData_Protocol: typeof Handle_IGESData_Protocol;
  Handle_IGESData_Protocol_1: typeof Handle_IGESData_Protocol_1;
  Handle_IGESData_Protocol_2: typeof Handle_IGESData_Protocol_2;
  Handle_IGESData_Protocol_3: typeof Handle_IGESData_Protocol_3;
  Handle_IGESData_Protocol_4: typeof Handle_IGESData_Protocol_4;
  IGESData_Protocol: typeof IGESData_Protocol;
  IGESData_NodeOfWriterLib: typeof IGESData_NodeOfWriterLib;
  Handle_IGESData_NodeOfWriterLib: typeof Handle_IGESData_NodeOfWriterLib;
  Handle_IGESData_NodeOfWriterLib_1: typeof Handle_IGESData_NodeOfWriterLib_1;
  Handle_IGESData_NodeOfWriterLib_2: typeof Handle_IGESData_NodeOfWriterLib_2;
  Handle_IGESData_NodeOfWriterLib_3: typeof Handle_IGESData_NodeOfWriterLib_3;
  Handle_IGESData_NodeOfWriterLib_4: typeof Handle_IGESData_NodeOfWriterLib_4;
  IGESData_BasicEditor: typeof IGESData_BasicEditor;
  IGESData_BasicEditor_1: typeof IGESData_BasicEditor_1;
  IGESData_BasicEditor_2: typeof IGESData_BasicEditor_2;
  IGESData_BasicEditor_3: typeof IGESData_BasicEditor_3;
  Handle_IGESData_GeneralModule: typeof Handle_IGESData_GeneralModule;
  Handle_IGESData_GeneralModule_1: typeof Handle_IGESData_GeneralModule_1;
  Handle_IGESData_GeneralModule_2: typeof Handle_IGESData_GeneralModule_2;
  Handle_IGESData_GeneralModule_3: typeof Handle_IGESData_GeneralModule_3;
  Handle_IGESData_GeneralModule_4: typeof Handle_IGESData_GeneralModule_4;
  IGESData_GeneralModule: typeof IGESData_GeneralModule;
  IGESData_DirPart: typeof IGESData_DirPart;
  Handle_IGESData_FreeFormatEntity: typeof Handle_IGESData_FreeFormatEntity;
  Handle_IGESData_FreeFormatEntity_1: typeof Handle_IGESData_FreeFormatEntity_1;
  Handle_IGESData_FreeFormatEntity_2: typeof Handle_IGESData_FreeFormatEntity_2;
  Handle_IGESData_FreeFormatEntity_3: typeof Handle_IGESData_FreeFormatEntity_3;
  Handle_IGESData_FreeFormatEntity_4: typeof Handle_IGESData_FreeFormatEntity_4;
  IGESData_FreeFormatEntity: typeof IGESData_FreeFormatEntity;
  Handle_IGESData_LabelDisplayEntity: typeof Handle_IGESData_LabelDisplayEntity;
  Handle_IGESData_LabelDisplayEntity_1: typeof Handle_IGESData_LabelDisplayEntity_1;
  Handle_IGESData_LabelDisplayEntity_2: typeof Handle_IGESData_LabelDisplayEntity_2;
  Handle_IGESData_LabelDisplayEntity_3: typeof Handle_IGESData_LabelDisplayEntity_3;
  Handle_IGESData_LabelDisplayEntity_4: typeof Handle_IGESData_LabelDisplayEntity_4;
  IGESData_LabelDisplayEntity: typeof IGESData_LabelDisplayEntity;
  Handle_IGESData_TransfEntity: typeof Handle_IGESData_TransfEntity;
  Handle_IGESData_TransfEntity_1: typeof Handle_IGESData_TransfEntity_1;
  Handle_IGESData_TransfEntity_2: typeof Handle_IGESData_TransfEntity_2;
  Handle_IGESData_TransfEntity_3: typeof Handle_IGESData_TransfEntity_3;
  Handle_IGESData_TransfEntity_4: typeof Handle_IGESData_TransfEntity_4;
  IGESData_TransfEntity: typeof IGESData_TransfEntity;
  Handle_IGESData_HArray1OfIGESEntity: typeof Handle_IGESData_HArray1OfIGESEntity;
  Handle_IGESData_HArray1OfIGESEntity_1: typeof Handle_IGESData_HArray1OfIGESEntity_1;
  Handle_IGESData_HArray1OfIGESEntity_2: typeof Handle_IGESData_HArray1OfIGESEntity_2;
  Handle_IGESData_HArray1OfIGESEntity_3: typeof Handle_IGESData_HArray1OfIGESEntity_3;
  Handle_IGESData_HArray1OfIGESEntity_4: typeof Handle_IGESData_HArray1OfIGESEntity_4;
  IGESData_Array1OfDirPart: typeof IGESData_Array1OfDirPart;
  IGESData_Array1OfDirPart_1: typeof IGESData_Array1OfDirPart_1;
  IGESData_Array1OfDirPart_2: typeof IGESData_Array1OfDirPart_2;
  IGESData_Array1OfDirPart_3: typeof IGESData_Array1OfDirPart_3;
  IGESData_Array1OfDirPart_4: typeof IGESData_Array1OfDirPart_4;
  IGESData_Array1OfDirPart_5: typeof IGESData_Array1OfDirPart_5;
  IGESData: typeof IGESData;
  IGESData_GlobalNodeOfSpecificLib: typeof IGESData_GlobalNodeOfSpecificLib;
  Handle_IGESData_GlobalNodeOfSpecificLib: typeof Handle_IGESData_GlobalNodeOfSpecificLib;
  Handle_IGESData_GlobalNodeOfSpecificLib_1: typeof Handle_IGESData_GlobalNodeOfSpecificLib_1;
  Handle_IGESData_GlobalNodeOfSpecificLib_2: typeof Handle_IGESData_GlobalNodeOfSpecificLib_2;
  Handle_IGESData_GlobalNodeOfSpecificLib_3: typeof Handle_IGESData_GlobalNodeOfSpecificLib_3;
  Handle_IGESData_GlobalNodeOfSpecificLib_4: typeof Handle_IGESData_GlobalNodeOfSpecificLib_4;
  IGESData_ToolLocation: typeof IGESData_ToolLocation;
  Handle_IGESData_ToolLocation: typeof Handle_IGESData_ToolLocation;
  Handle_IGESData_ToolLocation_1: typeof Handle_IGESData_ToolLocation_1;
  Handle_IGESData_ToolLocation_2: typeof Handle_IGESData_ToolLocation_2;
  Handle_IGESData_ToolLocation_3: typeof Handle_IGESData_ToolLocation_3;
  Handle_IGESData_ToolLocation_4: typeof Handle_IGESData_ToolLocation_4;
  IGESData_GlobalSection: typeof IGESData_GlobalSection;
  IGESData_IGESWriter: typeof IGESData_IGESWriter;
  IGESData_IGESWriter_1: typeof IGESData_IGESWriter_1;
  IGESData_IGESWriter_2: typeof IGESData_IGESWriter_2;
  IGESData_IGESWriter_3: typeof IGESData_IGESWriter_3;
  Handle_IGESData_ViewKindEntity: typeof Handle_IGESData_ViewKindEntity;
  Handle_IGESData_ViewKindEntity_1: typeof Handle_IGESData_ViewKindEntity_1;
  Handle_IGESData_ViewKindEntity_2: typeof Handle_IGESData_ViewKindEntity_2;
  Handle_IGESData_ViewKindEntity_3: typeof Handle_IGESData_ViewKindEntity_3;
  Handle_IGESData_ViewKindEntity_4: typeof Handle_IGESData_ViewKindEntity_4;
  IGESData_ViewKindEntity: typeof IGESData_ViewKindEntity;
  IGESData_ParamCursor: typeof IGESData_ParamCursor;
  IGESData_ParamCursor_1: typeof IGESData_ParamCursor_1;
  IGESData_ParamCursor_2: typeof IGESData_ParamCursor_2;
  IGESData_IGESDumper: typeof IGESData_IGESDumper;
  IGESData_SpecificLib: typeof IGESData_SpecificLib;
  IGESData_SpecificLib_1: typeof IGESData_SpecificLib_1;
  IGESData_SpecificLib_2: typeof IGESData_SpecificLib_2;
  IGESData_ParamReader: typeof IGESData_ParamReader;
  IGESData_DefSwitch: typeof IGESData_DefSwitch;
  IGESData_WriterLib: typeof IGESData_WriterLib;
  IGESData_WriterLib_1: typeof IGESData_WriterLib_1;
  IGESData_WriterLib_2: typeof IGESData_WriterLib_2;
  Handle_IGESData_DefaultGeneral: typeof Handle_IGESData_DefaultGeneral;
  Handle_IGESData_DefaultGeneral_1: typeof Handle_IGESData_DefaultGeneral_1;
  Handle_IGESData_DefaultGeneral_2: typeof Handle_IGESData_DefaultGeneral_2;
  Handle_IGESData_DefaultGeneral_3: typeof Handle_IGESData_DefaultGeneral_3;
  Handle_IGESData_DefaultGeneral_4: typeof Handle_IGESData_DefaultGeneral_4;
  IGESData_DefaultGeneral: typeof IGESData_DefaultGeneral;
  IGESData_DirChecker: typeof IGESData_DirChecker;
  IGESData_DirChecker_1: typeof IGESData_DirChecker_1;
  IGESData_DirChecker_2: typeof IGESData_DirChecker_2;
  IGESData_DirChecker_3: typeof IGESData_DirChecker_3;
  IGESData_DirChecker_4: typeof IGESData_DirChecker_4;
  Geom2d_BSplineCurve: typeof Geom2d_BSplineCurve;
  Geom2d_BSplineCurve_1: typeof Geom2d_BSplineCurve_1;
  Geom2d_BSplineCurve_2: typeof Geom2d_BSplineCurve_2;
  Handle_Geom2d_BSplineCurve: typeof Handle_Geom2d_BSplineCurve;
  Handle_Geom2d_BSplineCurve_1: typeof Handle_Geom2d_BSplineCurve_1;
  Handle_Geom2d_BSplineCurve_2: typeof Handle_Geom2d_BSplineCurve_2;
  Handle_Geom2d_BSplineCurve_3: typeof Handle_Geom2d_BSplineCurve_3;
  Handle_Geom2d_BSplineCurve_4: typeof Handle_Geom2d_BSplineCurve_4;
  Geom2d_Hyperbola: typeof Geom2d_Hyperbola;
  Geom2d_Hyperbola_1: typeof Geom2d_Hyperbola_1;
  Geom2d_Hyperbola_2: typeof Geom2d_Hyperbola_2;
  Geom2d_Hyperbola_3: typeof Geom2d_Hyperbola_3;
  Handle_Geom2d_Hyperbola: typeof Handle_Geom2d_Hyperbola;
  Handle_Geom2d_Hyperbola_1: typeof Handle_Geom2d_Hyperbola_1;
  Handle_Geom2d_Hyperbola_2: typeof Handle_Geom2d_Hyperbola_2;
  Handle_Geom2d_Hyperbola_3: typeof Handle_Geom2d_Hyperbola_3;
  Handle_Geom2d_Hyperbola_4: typeof Handle_Geom2d_Hyperbola_4;
  Geom2d_Direction: typeof Geom2d_Direction;
  Geom2d_Direction_1: typeof Geom2d_Direction_1;
  Geom2d_Direction_2: typeof Geom2d_Direction_2;
  Handle_Geom2d_Direction: typeof Handle_Geom2d_Direction;
  Handle_Geom2d_Direction_1: typeof Handle_Geom2d_Direction_1;
  Handle_Geom2d_Direction_2: typeof Handle_Geom2d_Direction_2;
  Handle_Geom2d_Direction_3: typeof Handle_Geom2d_Direction_3;
  Handle_Geom2d_Direction_4: typeof Handle_Geom2d_Direction_4;
  Handle_Geom2d_CartesianPoint: typeof Handle_Geom2d_CartesianPoint;
  Handle_Geom2d_CartesianPoint_1: typeof Handle_Geom2d_CartesianPoint_1;
  Handle_Geom2d_CartesianPoint_2: typeof Handle_Geom2d_CartesianPoint_2;
  Handle_Geom2d_CartesianPoint_3: typeof Handle_Geom2d_CartesianPoint_3;
  Handle_Geom2d_CartesianPoint_4: typeof Handle_Geom2d_CartesianPoint_4;
  Geom2d_CartesianPoint: typeof Geom2d_CartesianPoint;
  Geom2d_CartesianPoint_1: typeof Geom2d_CartesianPoint_1;
  Geom2d_CartesianPoint_2: typeof Geom2d_CartesianPoint_2;
  Handle_Geom2d_Circle: typeof Handle_Geom2d_Circle;
  Handle_Geom2d_Circle_1: typeof Handle_Geom2d_Circle_1;
  Handle_Geom2d_Circle_2: typeof Handle_Geom2d_Circle_2;
  Handle_Geom2d_Circle_3: typeof Handle_Geom2d_Circle_3;
  Handle_Geom2d_Circle_4: typeof Handle_Geom2d_Circle_4;
  Geom2d_Circle: typeof Geom2d_Circle;
  Geom2d_Circle_1: typeof Geom2d_Circle_1;
  Geom2d_Circle_2: typeof Geom2d_Circle_2;
  Geom2d_Circle_3: typeof Geom2d_Circle_3;
  Geom2d_Geometry: typeof Geom2d_Geometry;
  Handle_Geom2d_Geometry: typeof Handle_Geom2d_Geometry;
  Handle_Geom2d_Geometry_1: typeof Handle_Geom2d_Geometry_1;
  Handle_Geom2d_Geometry_2: typeof Handle_Geom2d_Geometry_2;
  Handle_Geom2d_Geometry_3: typeof Handle_Geom2d_Geometry_3;
  Handle_Geom2d_Geometry_4: typeof Handle_Geom2d_Geometry_4;
  Handle_Geom2d_Curve: typeof Handle_Geom2d_Curve;
  Handle_Geom2d_Curve_1: typeof Handle_Geom2d_Curve_1;
  Handle_Geom2d_Curve_2: typeof Handle_Geom2d_Curve_2;
  Handle_Geom2d_Curve_3: typeof Handle_Geom2d_Curve_3;
  Handle_Geom2d_Curve_4: typeof Handle_Geom2d_Curve_4;
  Geom2d_Curve: typeof Geom2d_Curve;
  Geom2d_Ellipse: typeof Geom2d_Ellipse;
  Geom2d_Ellipse_1: typeof Geom2d_Ellipse_1;
  Geom2d_Ellipse_2: typeof Geom2d_Ellipse_2;
  Geom2d_Ellipse_3: typeof Geom2d_Ellipse_3;
  Handle_Geom2d_Ellipse: typeof Handle_Geom2d_Ellipse;
  Handle_Geom2d_Ellipse_1: typeof Handle_Geom2d_Ellipse_1;
  Handle_Geom2d_Ellipse_2: typeof Handle_Geom2d_Ellipse_2;
  Handle_Geom2d_Ellipse_3: typeof Handle_Geom2d_Ellipse_3;
  Handle_Geom2d_Ellipse_4: typeof Handle_Geom2d_Ellipse_4;
  Geom2d_AxisPlacement: typeof Geom2d_AxisPlacement;
  Geom2d_AxisPlacement_1: typeof Geom2d_AxisPlacement_1;
  Geom2d_AxisPlacement_2: typeof Geom2d_AxisPlacement_2;
  Handle_Geom2d_AxisPlacement: typeof Handle_Geom2d_AxisPlacement;
  Handle_Geom2d_AxisPlacement_1: typeof Handle_Geom2d_AxisPlacement_1;
  Handle_Geom2d_AxisPlacement_2: typeof Handle_Geom2d_AxisPlacement_2;
  Handle_Geom2d_AxisPlacement_3: typeof Handle_Geom2d_AxisPlacement_3;
  Handle_Geom2d_AxisPlacement_4: typeof Handle_Geom2d_AxisPlacement_4;
  Geom2d_Parabola: typeof Geom2d_Parabola;
  Geom2d_Parabola_1: typeof Geom2d_Parabola_1;
  Geom2d_Parabola_2: typeof Geom2d_Parabola_2;
  Geom2d_Parabola_3: typeof Geom2d_Parabola_3;
  Geom2d_Parabola_4: typeof Geom2d_Parabola_4;
  Handle_Geom2d_Parabola: typeof Handle_Geom2d_Parabola;
  Handle_Geom2d_Parabola_1: typeof Handle_Geom2d_Parabola_1;
  Handle_Geom2d_Parabola_2: typeof Handle_Geom2d_Parabola_2;
  Handle_Geom2d_Parabola_3: typeof Handle_Geom2d_Parabola_3;
  Handle_Geom2d_Parabola_4: typeof Handle_Geom2d_Parabola_4;
  Geom2d_TrimmedCurve: typeof Geom2d_TrimmedCurve;
  Handle_Geom2d_TrimmedCurve: typeof Handle_Geom2d_TrimmedCurve;
  Handle_Geom2d_TrimmedCurve_1: typeof Handle_Geom2d_TrimmedCurve_1;
  Handle_Geom2d_TrimmedCurve_2: typeof Handle_Geom2d_TrimmedCurve_2;
  Handle_Geom2d_TrimmedCurve_3: typeof Handle_Geom2d_TrimmedCurve_3;
  Handle_Geom2d_TrimmedCurve_4: typeof Handle_Geom2d_TrimmedCurve_4;
  Geom2d_BezierCurve: typeof Geom2d_BezierCurve;
  Geom2d_BezierCurve_1: typeof Geom2d_BezierCurve_1;
  Geom2d_BezierCurve_2: typeof Geom2d_BezierCurve_2;
  Handle_Geom2d_BezierCurve: typeof Handle_Geom2d_BezierCurve;
  Handle_Geom2d_BezierCurve_1: typeof Handle_Geom2d_BezierCurve_1;
  Handle_Geom2d_BezierCurve_2: typeof Handle_Geom2d_BezierCurve_2;
  Handle_Geom2d_BezierCurve_3: typeof Handle_Geom2d_BezierCurve_3;
  Handle_Geom2d_BezierCurve_4: typeof Handle_Geom2d_BezierCurve_4;
  Handle_Geom2d_UndefinedValue: typeof Handle_Geom2d_UndefinedValue;
  Handle_Geom2d_UndefinedValue_1: typeof Handle_Geom2d_UndefinedValue_1;
  Handle_Geom2d_UndefinedValue_2: typeof Handle_Geom2d_UndefinedValue_2;
  Handle_Geom2d_UndefinedValue_3: typeof Handle_Geom2d_UndefinedValue_3;
  Handle_Geom2d_UndefinedValue_4: typeof Handle_Geom2d_UndefinedValue_4;
  Geom2d_UndefinedValue: typeof Geom2d_UndefinedValue;
  Geom2d_UndefinedValue_1: typeof Geom2d_UndefinedValue_1;
  Geom2d_UndefinedValue_2: typeof Geom2d_UndefinedValue_2;
  Geom2d_VectorWithMagnitude: typeof Geom2d_VectorWithMagnitude;
  Geom2d_VectorWithMagnitude_1: typeof Geom2d_VectorWithMagnitude_1;
  Geom2d_VectorWithMagnitude_2: typeof Geom2d_VectorWithMagnitude_2;
  Geom2d_VectorWithMagnitude_3: typeof Geom2d_VectorWithMagnitude_3;
  Handle_Geom2d_VectorWithMagnitude: typeof Handle_Geom2d_VectorWithMagnitude;
  Handle_Geom2d_VectorWithMagnitude_1: typeof Handle_Geom2d_VectorWithMagnitude_1;
  Handle_Geom2d_VectorWithMagnitude_2: typeof Handle_Geom2d_VectorWithMagnitude_2;
  Handle_Geom2d_VectorWithMagnitude_3: typeof Handle_Geom2d_VectorWithMagnitude_3;
  Handle_Geom2d_VectorWithMagnitude_4: typeof Handle_Geom2d_VectorWithMagnitude_4;
  Geom2d_OffsetCurve: typeof Geom2d_OffsetCurve;
  Handle_Geom2d_OffsetCurve: typeof Handle_Geom2d_OffsetCurve;
  Handle_Geom2d_OffsetCurve_1: typeof Handle_Geom2d_OffsetCurve_1;
  Handle_Geom2d_OffsetCurve_2: typeof Handle_Geom2d_OffsetCurve_2;
  Handle_Geom2d_OffsetCurve_3: typeof Handle_Geom2d_OffsetCurve_3;
  Handle_Geom2d_OffsetCurve_4: typeof Handle_Geom2d_OffsetCurve_4;
  Geom2d_Line: typeof Geom2d_Line;
  Geom2d_Line_1: typeof Geom2d_Line_1;
  Geom2d_Line_2: typeof Geom2d_Line_2;
  Geom2d_Line_3: typeof Geom2d_Line_3;
  Handle_Geom2d_Line: typeof Handle_Geom2d_Line;
  Handle_Geom2d_Line_1: typeof Handle_Geom2d_Line_1;
  Handle_Geom2d_Line_2: typeof Handle_Geom2d_Line_2;
  Handle_Geom2d_Line_3: typeof Handle_Geom2d_Line_3;
  Handle_Geom2d_Line_4: typeof Handle_Geom2d_Line_4;
  Geom2d_Vector: typeof Geom2d_Vector;
  Handle_Geom2d_Vector: typeof Handle_Geom2d_Vector;
  Handle_Geom2d_Vector_1: typeof Handle_Geom2d_Vector_1;
  Handle_Geom2d_Vector_2: typeof Handle_Geom2d_Vector_2;
  Handle_Geom2d_Vector_3: typeof Handle_Geom2d_Vector_3;
  Handle_Geom2d_Vector_4: typeof Handle_Geom2d_Vector_4;
  Geom2d_Conic: typeof Geom2d_Conic;
  Handle_Geom2d_Conic: typeof Handle_Geom2d_Conic;
  Handle_Geom2d_Conic_1: typeof Handle_Geom2d_Conic_1;
  Handle_Geom2d_Conic_2: typeof Handle_Geom2d_Conic_2;
  Handle_Geom2d_Conic_3: typeof Handle_Geom2d_Conic_3;
  Handle_Geom2d_Conic_4: typeof Handle_Geom2d_Conic_4;
  Handle_Geom2d_Transformation: typeof Handle_Geom2d_Transformation;
  Handle_Geom2d_Transformation_1: typeof Handle_Geom2d_Transformation_1;
  Handle_Geom2d_Transformation_2: typeof Handle_Geom2d_Transformation_2;
  Handle_Geom2d_Transformation_3: typeof Handle_Geom2d_Transformation_3;
  Handle_Geom2d_Transformation_4: typeof Handle_Geom2d_Transformation_4;
  Geom2d_Transformation: typeof Geom2d_Transformation;
  Geom2d_Transformation_1: typeof Geom2d_Transformation_1;
  Geom2d_Transformation_2: typeof Geom2d_Transformation_2;
  Handle_Geom2d_BoundedCurve: typeof Handle_Geom2d_BoundedCurve;
  Handle_Geom2d_BoundedCurve_1: typeof Handle_Geom2d_BoundedCurve_1;
  Handle_Geom2d_BoundedCurve_2: typeof Handle_Geom2d_BoundedCurve_2;
  Handle_Geom2d_BoundedCurve_3: typeof Handle_Geom2d_BoundedCurve_3;
  Handle_Geom2d_BoundedCurve_4: typeof Handle_Geom2d_BoundedCurve_4;
  Geom2d_BoundedCurve: typeof Geom2d_BoundedCurve;
  Handle_Geom2d_UndefinedDerivative: typeof Handle_Geom2d_UndefinedDerivative;
  Handle_Geom2d_UndefinedDerivative_1: typeof Handle_Geom2d_UndefinedDerivative_1;
  Handle_Geom2d_UndefinedDerivative_2: typeof Handle_Geom2d_UndefinedDerivative_2;
  Handle_Geom2d_UndefinedDerivative_3: typeof Handle_Geom2d_UndefinedDerivative_3;
  Handle_Geom2d_UndefinedDerivative_4: typeof Handle_Geom2d_UndefinedDerivative_4;
  Geom2d_UndefinedDerivative: typeof Geom2d_UndefinedDerivative;
  Geom2d_UndefinedDerivative_1: typeof Geom2d_UndefinedDerivative_1;
  Geom2d_UndefinedDerivative_2: typeof Geom2d_UndefinedDerivative_2;
  Geom2d_Point: typeof Geom2d_Point;
  Handle_Geom2d_Point: typeof Handle_Geom2d_Point;
  Handle_Geom2d_Point_1: typeof Handle_Geom2d_Point_1;
  Handle_Geom2d_Point_2: typeof Handle_Geom2d_Point_2;
  Handle_Geom2d_Point_3: typeof Handle_Geom2d_Point_3;
  Handle_Geom2d_Point_4: typeof Handle_Geom2d_Point_4;
  Handle_StepFEA_FeaGroup: typeof Handle_StepFEA_FeaGroup;
  Handle_StepFEA_FeaGroup_1: typeof Handle_StepFEA_FeaGroup_1;
  Handle_StepFEA_FeaGroup_2: typeof Handle_StepFEA_FeaGroup_2;
  Handle_StepFEA_FeaGroup_3: typeof Handle_StepFEA_FeaGroup_3;
  Handle_StepFEA_FeaGroup_4: typeof Handle_StepFEA_FeaGroup_4;
  StepFEA_FeaGroup: typeof StepFEA_FeaGroup;
  Handle_StepFEA_FeaMassDensity: typeof Handle_StepFEA_FeaMassDensity;
  Handle_StepFEA_FeaMassDensity_1: typeof Handle_StepFEA_FeaMassDensity_1;
  Handle_StepFEA_FeaMassDensity_2: typeof Handle_StepFEA_FeaMassDensity_2;
  Handle_StepFEA_FeaMassDensity_3: typeof Handle_StepFEA_FeaMassDensity_3;
  Handle_StepFEA_FeaMassDensity_4: typeof Handle_StepFEA_FeaMassDensity_4;
  StepFEA_FeaMassDensity: typeof StepFEA_FeaMassDensity;
  Handle_StepFEA_ConstantSurface3dElementCoordinateSystem: typeof Handle_StepFEA_ConstantSurface3dElementCoordinateSystem;
  Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_1: typeof Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_1;
  Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_2: typeof Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_2;
  Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_3: typeof Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_3;
  Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_4: typeof Handle_StepFEA_ConstantSurface3dElementCoordinateSystem_4;
  StepFEA_ConstantSurface3dElementCoordinateSystem: typeof StepFEA_ConstantSurface3dElementCoordinateSystem;
  StepFEA_EnumeratedDegreeOfFreedom: StepFEA_EnumeratedDegreeOfFreedom;
  StepFEA_FreedomAndCoefficient: typeof StepFEA_FreedomAndCoefficient;
  Handle_StepFEA_FreedomAndCoefficient: typeof Handle_StepFEA_FreedomAndCoefficient;
  Handle_StepFEA_FreedomAndCoefficient_1: typeof Handle_StepFEA_FreedomAndCoefficient_1;
  Handle_StepFEA_FreedomAndCoefficient_2: typeof Handle_StepFEA_FreedomAndCoefficient_2;
  Handle_StepFEA_FreedomAndCoefficient_3: typeof Handle_StepFEA_FreedomAndCoefficient_3;
  Handle_StepFEA_FreedomAndCoefficient_4: typeof Handle_StepFEA_FreedomAndCoefficient_4;
  StepFEA_SymmetricTensor23d: typeof StepFEA_SymmetricTensor23d;
  StepFEA_Node: typeof StepFEA_Node;
  Handle_StepFEA_Node: typeof Handle_StepFEA_Node;
  Handle_StepFEA_Node_1: typeof Handle_StepFEA_Node_1;
  Handle_StepFEA_Node_2: typeof Handle_StepFEA_Node_2;
  Handle_StepFEA_Node_3: typeof Handle_StepFEA_Node_3;
  Handle_StepFEA_Node_4: typeof Handle_StepFEA_Node_4;
  Handle_StepFEA_ElementGeometricRelationship: typeof Handle_StepFEA_ElementGeometricRelationship;
  Handle_StepFEA_ElementGeometricRelationship_1: typeof Handle_StepFEA_ElementGeometricRelationship_1;
  Handle_StepFEA_ElementGeometricRelationship_2: typeof Handle_StepFEA_ElementGeometricRelationship_2;
  Handle_StepFEA_ElementGeometricRelationship_3: typeof Handle_StepFEA_ElementGeometricRelationship_3;
  Handle_StepFEA_ElementGeometricRelationship_4: typeof Handle_StepFEA_ElementGeometricRelationship_4;
  StepFEA_ElementGeometricRelationship: typeof StepFEA_ElementGeometricRelationship;
  StepFEA_FeaLinearElasticity: typeof StepFEA_FeaLinearElasticity;
  Handle_StepFEA_FeaLinearElasticity: typeof Handle_StepFEA_FeaLinearElasticity;
  Handle_StepFEA_FeaLinearElasticity_1: typeof Handle_StepFEA_FeaLinearElasticity_1;
  Handle_StepFEA_FeaLinearElasticity_2: typeof Handle_StepFEA_FeaLinearElasticity_2;
  Handle_StepFEA_FeaLinearElasticity_3: typeof Handle_StepFEA_FeaLinearElasticity_3;
  Handle_StepFEA_FeaLinearElasticity_4: typeof Handle_StepFEA_FeaLinearElasticity_4;
  StepFEA_FeaShellMembraneBendingCouplingStiffness: typeof StepFEA_FeaShellMembraneBendingCouplingStiffness;
  Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness: typeof Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness;
  Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_1: typeof Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_1;
  Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_2: typeof Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_2;
  Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_3: typeof Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_3;
  Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_4: typeof Handle_StepFEA_FeaShellMembraneBendingCouplingStiffness_4;
  Handle_StepFEA_HSequenceOfCurve3dElementProperty: typeof Handle_StepFEA_HSequenceOfCurve3dElementProperty;
  Handle_StepFEA_HSequenceOfCurve3dElementProperty_1: typeof Handle_StepFEA_HSequenceOfCurve3dElementProperty_1;
  Handle_StepFEA_HSequenceOfCurve3dElementProperty_2: typeof Handle_StepFEA_HSequenceOfCurve3dElementProperty_2;
  Handle_StepFEA_HSequenceOfCurve3dElementProperty_3: typeof Handle_StepFEA_HSequenceOfCurve3dElementProperty_3;
  Handle_StepFEA_HSequenceOfCurve3dElementProperty_4: typeof Handle_StepFEA_HSequenceOfCurve3dElementProperty_4;
  StepFEA_Curve3dElementRepresentation: typeof StepFEA_Curve3dElementRepresentation;
  Handle_StepFEA_Curve3dElementRepresentation: typeof Handle_StepFEA_Curve3dElementRepresentation;
  Handle_StepFEA_Curve3dElementRepresentation_1: typeof Handle_StepFEA_Curve3dElementRepresentation_1;
  Handle_StepFEA_Curve3dElementRepresentation_2: typeof Handle_StepFEA_Curve3dElementRepresentation_2;
  Handle_StepFEA_Curve3dElementRepresentation_3: typeof Handle_StepFEA_Curve3dElementRepresentation_3;
  Handle_StepFEA_Curve3dElementRepresentation_4: typeof Handle_StepFEA_Curve3dElementRepresentation_4;
  Handle_StepFEA_Volume3dElementRepresentation: typeof Handle_StepFEA_Volume3dElementRepresentation;
  Handle_StepFEA_Volume3dElementRepresentation_1: typeof Handle_StepFEA_Volume3dElementRepresentation_1;
  Handle_StepFEA_Volume3dElementRepresentation_2: typeof Handle_StepFEA_Volume3dElementRepresentation_2;
  Handle_StepFEA_Volume3dElementRepresentation_3: typeof Handle_StepFEA_Volume3dElementRepresentation_3;
  Handle_StepFEA_Volume3dElementRepresentation_4: typeof Handle_StepFEA_Volume3dElementRepresentation_4;
  StepFEA_Volume3dElementRepresentation: typeof StepFEA_Volume3dElementRepresentation;
  StepFEA_DegreeOfFreedom: typeof StepFEA_DegreeOfFreedom;
  StepFEA_SymmetricTensor22d: typeof StepFEA_SymmetricTensor22d;
  Handle_StepFEA_HSequenceOfElementGeometricRelationship: typeof Handle_StepFEA_HSequenceOfElementGeometricRelationship;
  Handle_StepFEA_HSequenceOfElementGeometricRelationship_1: typeof Handle_StepFEA_HSequenceOfElementGeometricRelationship_1;
  Handle_StepFEA_HSequenceOfElementGeometricRelationship_2: typeof Handle_StepFEA_HSequenceOfElementGeometricRelationship_2;
  Handle_StepFEA_HSequenceOfElementGeometricRelationship_3: typeof Handle_StepFEA_HSequenceOfElementGeometricRelationship_3;
  Handle_StepFEA_HSequenceOfElementGeometricRelationship_4: typeof Handle_StepFEA_HSequenceOfElementGeometricRelationship_4;
  Handle_StepFEA_HArray1OfCurveElementEndOffset: typeof Handle_StepFEA_HArray1OfCurveElementEndOffset;
  Handle_StepFEA_HArray1OfCurveElementEndOffset_1: typeof Handle_StepFEA_HArray1OfCurveElementEndOffset_1;
  Handle_StepFEA_HArray1OfCurveElementEndOffset_2: typeof Handle_StepFEA_HArray1OfCurveElementEndOffset_2;
  Handle_StepFEA_HArray1OfCurveElementEndOffset_3: typeof Handle_StepFEA_HArray1OfCurveElementEndOffset_3;
  Handle_StepFEA_HArray1OfCurveElementEndOffset_4: typeof Handle_StepFEA_HArray1OfCurveElementEndOffset_4;
  Handle_StepFEA_NodeDefinition: typeof Handle_StepFEA_NodeDefinition;
  Handle_StepFEA_NodeDefinition_1: typeof Handle_StepFEA_NodeDefinition_1;
  Handle_StepFEA_NodeDefinition_2: typeof Handle_StepFEA_NodeDefinition_2;
  Handle_StepFEA_NodeDefinition_3: typeof Handle_StepFEA_NodeDefinition_3;
  Handle_StepFEA_NodeDefinition_4: typeof Handle_StepFEA_NodeDefinition_4;
  StepFEA_NodeDefinition: typeof StepFEA_NodeDefinition;
  Handle_StepFEA_ParametricSurface3dElementCoordinateSystem: typeof Handle_StepFEA_ParametricSurface3dElementCoordinateSystem;
  Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_1: typeof Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_1;
  Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_2: typeof Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_2;
  Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_3: typeof Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_3;
  Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_4: typeof Handle_StepFEA_ParametricSurface3dElementCoordinateSystem_4;
  StepFEA_ParametricSurface3dElementCoordinateSystem: typeof StepFEA_ParametricSurface3dElementCoordinateSystem;
  Handle_StepFEA_HArray1OfCurveElementEndRelease: typeof Handle_StepFEA_HArray1OfCurveElementEndRelease;
  Handle_StepFEA_HArray1OfCurveElementEndRelease_1: typeof Handle_StepFEA_HArray1OfCurveElementEndRelease_1;
  Handle_StepFEA_HArray1OfCurveElementEndRelease_2: typeof Handle_StepFEA_HArray1OfCurveElementEndRelease_2;
  Handle_StepFEA_HArray1OfCurveElementEndRelease_3: typeof Handle_StepFEA_HArray1OfCurveElementEndRelease_3;
  Handle_StepFEA_HArray1OfCurveElementEndRelease_4: typeof Handle_StepFEA_HArray1OfCurveElementEndRelease_4;
  StepFEA_FeaModelDefinition: typeof StepFEA_FeaModelDefinition;
  Handle_StepFEA_FeaModelDefinition: typeof Handle_StepFEA_FeaModelDefinition;
  Handle_StepFEA_FeaModelDefinition_1: typeof Handle_StepFEA_FeaModelDefinition_1;
  Handle_StepFEA_FeaModelDefinition_2: typeof Handle_StepFEA_FeaModelDefinition_2;
  Handle_StepFEA_FeaModelDefinition_3: typeof Handle_StepFEA_FeaModelDefinition_3;
  Handle_StepFEA_FeaModelDefinition_4: typeof Handle_StepFEA_FeaModelDefinition_4;
  StepFEA_FeaModel: typeof StepFEA_FeaModel;
  Handle_StepFEA_FeaModel: typeof Handle_StepFEA_FeaModel;
  Handle_StepFEA_FeaModel_1: typeof Handle_StepFEA_FeaModel_1;
  Handle_StepFEA_FeaModel_2: typeof Handle_StepFEA_FeaModel_2;
  Handle_StepFEA_FeaModel_3: typeof Handle_StepFEA_FeaModel_3;
  Handle_StepFEA_FeaModel_4: typeof Handle_StepFEA_FeaModel_4;
  Handle_StepFEA_GeometricNode: typeof Handle_StepFEA_GeometricNode;
  Handle_StepFEA_GeometricNode_1: typeof Handle_StepFEA_GeometricNode_1;
  Handle_StepFEA_GeometricNode_2: typeof Handle_StepFEA_GeometricNode_2;
  Handle_StepFEA_GeometricNode_3: typeof Handle_StepFEA_GeometricNode_3;
  Handle_StepFEA_GeometricNode_4: typeof Handle_StepFEA_GeometricNode_4;
  StepFEA_GeometricNode: typeof StepFEA_GeometricNode;
  Handle_StepFEA_HArray1OfElementRepresentation: typeof Handle_StepFEA_HArray1OfElementRepresentation;
  Handle_StepFEA_HArray1OfElementRepresentation_1: typeof Handle_StepFEA_HArray1OfElementRepresentation_1;
  Handle_StepFEA_HArray1OfElementRepresentation_2: typeof Handle_StepFEA_HArray1OfElementRepresentation_2;
  Handle_StepFEA_HArray1OfElementRepresentation_3: typeof Handle_StepFEA_HArray1OfElementRepresentation_3;
  Handle_StepFEA_HArray1OfElementRepresentation_4: typeof Handle_StepFEA_HArray1OfElementRepresentation_4;
  Handle_StepFEA_Curve3dElementProperty: typeof Handle_StepFEA_Curve3dElementProperty;
  Handle_StepFEA_Curve3dElementProperty_1: typeof Handle_StepFEA_Curve3dElementProperty_1;
  Handle_StepFEA_Curve3dElementProperty_2: typeof Handle_StepFEA_Curve3dElementProperty_2;
  Handle_StepFEA_Curve3dElementProperty_3: typeof Handle_StepFEA_Curve3dElementProperty_3;
  Handle_StepFEA_Curve3dElementProperty_4: typeof Handle_StepFEA_Curve3dElementProperty_4;
  StepFEA_Curve3dElementProperty: typeof StepFEA_Curve3dElementProperty;
  Handle_StepFEA_HArray1OfCurveElementInterval: typeof Handle_StepFEA_HArray1OfCurveElementInterval;
  Handle_StepFEA_HArray1OfCurveElementInterval_1: typeof Handle_StepFEA_HArray1OfCurveElementInterval_1;
  Handle_StepFEA_HArray1OfCurveElementInterval_2: typeof Handle_StepFEA_HArray1OfCurveElementInterval_2;
  Handle_StepFEA_HArray1OfCurveElementInterval_3: typeof Handle_StepFEA_HArray1OfCurveElementInterval_3;
  Handle_StepFEA_HArray1OfCurveElementInterval_4: typeof Handle_StepFEA_HArray1OfCurveElementInterval_4;
  Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion: typeof Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion;
  Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_1: typeof Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_1;
  Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_2: typeof Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_2;
  Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_3: typeof Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_3;
  Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_4: typeof Handle_StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion_4;
  StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion: typeof StepFEA_FeaTangentialCoefficientOfLinearThermalExpansion;
  StepFEA_FeaShellShearStiffness: typeof StepFEA_FeaShellShearStiffness;
  Handle_StepFEA_FeaShellShearStiffness: typeof Handle_StepFEA_FeaShellShearStiffness;
  Handle_StepFEA_FeaShellShearStiffness_1: typeof Handle_StepFEA_FeaShellShearStiffness_1;
  Handle_StepFEA_FeaShellShearStiffness_2: typeof Handle_StepFEA_FeaShellShearStiffness_2;
  Handle_StepFEA_FeaShellShearStiffness_3: typeof Handle_StepFEA_FeaShellShearStiffness_3;
  Handle_StepFEA_FeaShellShearStiffness_4: typeof Handle_StepFEA_FeaShellShearStiffness_4;
  StepFEA_DummyNode: typeof StepFEA_DummyNode;
  Handle_StepFEA_DummyNode: typeof Handle_StepFEA_DummyNode;
  Handle_StepFEA_DummyNode_1: typeof Handle_StepFEA_DummyNode_1;
  Handle_StepFEA_DummyNode_2: typeof Handle_StepFEA_DummyNode_2;
  Handle_StepFEA_DummyNode_3: typeof Handle_StepFEA_DummyNode_3;
  Handle_StepFEA_DummyNode_4: typeof Handle_StepFEA_DummyNode_4;
  StepFEA_FeaAxis2Placement3d: typeof StepFEA_FeaAxis2Placement3d;
  Handle_StepFEA_FeaAxis2Placement3d: typeof Handle_StepFEA_FeaAxis2Placement3d;
  Handle_StepFEA_FeaAxis2Placement3d_1: typeof Handle_StepFEA_FeaAxis2Placement3d_1;
  Handle_StepFEA_FeaAxis2Placement3d_2: typeof Handle_StepFEA_FeaAxis2Placement3d_2;
  Handle_StepFEA_FeaAxis2Placement3d_3: typeof Handle_StepFEA_FeaAxis2Placement3d_3;
  Handle_StepFEA_FeaAxis2Placement3d_4: typeof Handle_StepFEA_FeaAxis2Placement3d_4;
  StepFEA_FeaParametricPoint: typeof StepFEA_FeaParametricPoint;
  Handle_StepFEA_FeaParametricPoint: typeof Handle_StepFEA_FeaParametricPoint;
  Handle_StepFEA_FeaParametricPoint_1: typeof Handle_StepFEA_FeaParametricPoint_1;
  Handle_StepFEA_FeaParametricPoint_2: typeof Handle_StepFEA_FeaParametricPoint_2;
  Handle_StepFEA_FeaParametricPoint_3: typeof Handle_StepFEA_FeaParametricPoint_3;
  Handle_StepFEA_FeaParametricPoint_4: typeof Handle_StepFEA_FeaParametricPoint_4;
  StepFEA_FeaRepresentationItem: typeof StepFEA_FeaRepresentationItem;
  Handle_StepFEA_FeaRepresentationItem: typeof Handle_StepFEA_FeaRepresentationItem;
  Handle_StepFEA_FeaRepresentationItem_1: typeof Handle_StepFEA_FeaRepresentationItem_1;
  Handle_StepFEA_FeaRepresentationItem_2: typeof Handle_StepFEA_FeaRepresentationItem_2;
  Handle_StepFEA_FeaRepresentationItem_3: typeof Handle_StepFEA_FeaRepresentationItem_3;
  Handle_StepFEA_FeaRepresentationItem_4: typeof Handle_StepFEA_FeaRepresentationItem_4;
  Handle_StepFEA_FeaShellBendingStiffness: typeof Handle_StepFEA_FeaShellBendingStiffness;
  Handle_StepFEA_FeaShellBendingStiffness_1: typeof Handle_StepFEA_FeaShellBendingStiffness_1;
  Handle_StepFEA_FeaShellBendingStiffness_2: typeof Handle_StepFEA_FeaShellBendingStiffness_2;
  Handle_StepFEA_FeaShellBendingStiffness_3: typeof Handle_StepFEA_FeaShellBendingStiffness_3;
  Handle_StepFEA_FeaShellBendingStiffness_4: typeof Handle_StepFEA_FeaShellBendingStiffness_4;
  StepFEA_FeaShellBendingStiffness: typeof StepFEA_FeaShellBendingStiffness;
  Handle_StepFEA_Surface3dElementRepresentation: typeof Handle_StepFEA_Surface3dElementRepresentation;
  Handle_StepFEA_Surface3dElementRepresentation_1: typeof Handle_StepFEA_Surface3dElementRepresentation_1;
  Handle_StepFEA_Surface3dElementRepresentation_2: typeof Handle_StepFEA_Surface3dElementRepresentation_2;
  Handle_StepFEA_Surface3dElementRepresentation_3: typeof Handle_StepFEA_Surface3dElementRepresentation_3;
  Handle_StepFEA_Surface3dElementRepresentation_4: typeof Handle_StepFEA_Surface3dElementRepresentation_4;
  StepFEA_Surface3dElementRepresentation: typeof StepFEA_Surface3dElementRepresentation;
  StepFEA_DegreeOfFreedomMember: typeof StepFEA_DegreeOfFreedomMember;
  Handle_StepFEA_DegreeOfFreedomMember: typeof Handle_StepFEA_DegreeOfFreedomMember;
  Handle_StepFEA_DegreeOfFreedomMember_1: typeof Handle_StepFEA_DegreeOfFreedomMember_1;
  Handle_StepFEA_DegreeOfFreedomMember_2: typeof Handle_StepFEA_DegreeOfFreedomMember_2;
  Handle_StepFEA_DegreeOfFreedomMember_3: typeof Handle_StepFEA_DegreeOfFreedomMember_3;
  Handle_StepFEA_DegreeOfFreedomMember_4: typeof Handle_StepFEA_DegreeOfFreedomMember_4;
  StepFEA_CurveEdge: StepFEA_CurveEdge;
  StepFEA_CurveElementEndRelease: typeof StepFEA_CurveElementEndRelease;
  Handle_StepFEA_CurveElementEndRelease: typeof Handle_StepFEA_CurveElementEndRelease;
  Handle_StepFEA_CurveElementEndRelease_1: typeof Handle_StepFEA_CurveElementEndRelease_1;
  Handle_StepFEA_CurveElementEndRelease_2: typeof Handle_StepFEA_CurveElementEndRelease_2;
  Handle_StepFEA_CurveElementEndRelease_3: typeof Handle_StepFEA_CurveElementEndRelease_3;
  Handle_StepFEA_CurveElementEndRelease_4: typeof Handle_StepFEA_CurveElementEndRelease_4;
  StepFEA_CoordinateSystemType: StepFEA_CoordinateSystemType;
  StepFEA_FeaCurveSectionGeometricRelationship: typeof StepFEA_FeaCurveSectionGeometricRelationship;
  Handle_StepFEA_FeaCurveSectionGeometricRelationship: typeof Handle_StepFEA_FeaCurveSectionGeometricRelationship;
  Handle_StepFEA_FeaCurveSectionGeometricRelationship_1: typeof Handle_StepFEA_FeaCurveSectionGeometricRelationship_1;
  Handle_StepFEA_FeaCurveSectionGeometricRelationship_2: typeof Handle_StepFEA_FeaCurveSectionGeometricRelationship_2;
  Handle_StepFEA_FeaCurveSectionGeometricRelationship_3: typeof Handle_StepFEA_FeaCurveSectionGeometricRelationship_3;
  Handle_StepFEA_FeaCurveSectionGeometricRelationship_4: typeof Handle_StepFEA_FeaCurveSectionGeometricRelationship_4;
  Handle_StepFEA_ElementGroup: typeof Handle_StepFEA_ElementGroup;
  Handle_StepFEA_ElementGroup_1: typeof Handle_StepFEA_ElementGroup_1;
  Handle_StepFEA_ElementGroup_2: typeof Handle_StepFEA_ElementGroup_2;
  Handle_StepFEA_ElementGroup_3: typeof Handle_StepFEA_ElementGroup_3;
  Handle_StepFEA_ElementGroup_4: typeof Handle_StepFEA_ElementGroup_4;
  StepFEA_ElementGroup: typeof StepFEA_ElementGroup;
  Handle_StepFEA_SymmetricTensor43dMember: typeof Handle_StepFEA_SymmetricTensor43dMember;
  Handle_StepFEA_SymmetricTensor43dMember_1: typeof Handle_StepFEA_SymmetricTensor43dMember_1;
  Handle_StepFEA_SymmetricTensor43dMember_2: typeof Handle_StepFEA_SymmetricTensor43dMember_2;
  Handle_StepFEA_SymmetricTensor43dMember_3: typeof Handle_StepFEA_SymmetricTensor43dMember_3;
  Handle_StepFEA_SymmetricTensor43dMember_4: typeof Handle_StepFEA_SymmetricTensor43dMember_4;
  StepFEA_SymmetricTensor43dMember: typeof StepFEA_SymmetricTensor43dMember;
  StepFEA_CurveElementIntervalLinearlyVarying: typeof StepFEA_CurveElementIntervalLinearlyVarying;
  Handle_StepFEA_CurveElementIntervalLinearlyVarying: typeof Handle_StepFEA_CurveElementIntervalLinearlyVarying;
  Handle_StepFEA_CurveElementIntervalLinearlyVarying_1: typeof Handle_StepFEA_CurveElementIntervalLinearlyVarying_1;
  Handle_StepFEA_CurveElementIntervalLinearlyVarying_2: typeof Handle_StepFEA_CurveElementIntervalLinearlyVarying_2;
  Handle_StepFEA_CurveElementIntervalLinearlyVarying_3: typeof Handle_StepFEA_CurveElementIntervalLinearlyVarying_3;
  Handle_StepFEA_CurveElementIntervalLinearlyVarying_4: typeof Handle_StepFEA_CurveElementIntervalLinearlyVarying_4;
  StepFEA_NodeRepresentation: typeof StepFEA_NodeRepresentation;
  Handle_StepFEA_NodeRepresentation: typeof Handle_StepFEA_NodeRepresentation;
  Handle_StepFEA_NodeRepresentation_1: typeof Handle_StepFEA_NodeRepresentation_1;
  Handle_StepFEA_NodeRepresentation_2: typeof Handle_StepFEA_NodeRepresentation_2;
  Handle_StepFEA_NodeRepresentation_3: typeof Handle_StepFEA_NodeRepresentation_3;
  Handle_StepFEA_NodeRepresentation_4: typeof Handle_StepFEA_NodeRepresentation_4;
  Handle_StepFEA_NodeGroup: typeof Handle_StepFEA_NodeGroup;
  Handle_StepFEA_NodeGroup_1: typeof Handle_StepFEA_NodeGroup_1;
  Handle_StepFEA_NodeGroup_2: typeof Handle_StepFEA_NodeGroup_2;
  Handle_StepFEA_NodeGroup_3: typeof Handle_StepFEA_NodeGroup_3;
  Handle_StepFEA_NodeGroup_4: typeof Handle_StepFEA_NodeGroup_4;
  StepFEA_NodeGroup: typeof StepFEA_NodeGroup;
  Handle_StepFEA_NodeWithSolutionCoordinateSystem: typeof Handle_StepFEA_NodeWithSolutionCoordinateSystem;
  Handle_StepFEA_NodeWithSolutionCoordinateSystem_1: typeof Handle_StepFEA_NodeWithSolutionCoordinateSystem_1;
  Handle_StepFEA_NodeWithSolutionCoordinateSystem_2: typeof Handle_StepFEA_NodeWithSolutionCoordinateSystem_2;
  Handle_StepFEA_NodeWithSolutionCoordinateSystem_3: typeof Handle_StepFEA_NodeWithSolutionCoordinateSystem_3;
  Handle_StepFEA_NodeWithSolutionCoordinateSystem_4: typeof Handle_StepFEA_NodeWithSolutionCoordinateSystem_4;
  StepFEA_NodeWithSolutionCoordinateSystem: typeof StepFEA_NodeWithSolutionCoordinateSystem;
  Handle_StepFEA_HArray1OfNodeRepresentation: typeof Handle_StepFEA_HArray1OfNodeRepresentation;
  Handle_StepFEA_HArray1OfNodeRepresentation_1: typeof Handle_StepFEA_HArray1OfNodeRepresentation_1;
  Handle_StepFEA_HArray1OfNodeRepresentation_2: typeof Handle_StepFEA_HArray1OfNodeRepresentation_2;
  Handle_StepFEA_HArray1OfNodeRepresentation_3: typeof Handle_StepFEA_HArray1OfNodeRepresentation_3;
  Handle_StepFEA_HArray1OfNodeRepresentation_4: typeof Handle_StepFEA_HArray1OfNodeRepresentation_4;
  Handle_StepFEA_FeaMaterialPropertyRepresentation: typeof Handle_StepFEA_FeaMaterialPropertyRepresentation;
  Handle_StepFEA_FeaMaterialPropertyRepresentation_1: typeof Handle_StepFEA_FeaMaterialPropertyRepresentation_1;
  Handle_StepFEA_FeaMaterialPropertyRepresentation_2: typeof Handle_StepFEA_FeaMaterialPropertyRepresentation_2;
  Handle_StepFEA_FeaMaterialPropertyRepresentation_3: typeof Handle_StepFEA_FeaMaterialPropertyRepresentation_3;
  Handle_StepFEA_FeaMaterialPropertyRepresentation_4: typeof Handle_StepFEA_FeaMaterialPropertyRepresentation_4;
  StepFEA_FeaMaterialPropertyRepresentation: typeof StepFEA_FeaMaterialPropertyRepresentation;
  StepFEA_ElementRepresentation: typeof StepFEA_ElementRepresentation;
  Handle_StepFEA_ElementRepresentation: typeof Handle_StepFEA_ElementRepresentation;
  Handle_StepFEA_ElementRepresentation_1: typeof Handle_StepFEA_ElementRepresentation_1;
  Handle_StepFEA_ElementRepresentation_2: typeof Handle_StepFEA_ElementRepresentation_2;
  Handle_StepFEA_ElementRepresentation_3: typeof Handle_StepFEA_ElementRepresentation_3;
  Handle_StepFEA_ElementRepresentation_4: typeof Handle_StepFEA_ElementRepresentation_4;
  Handle_StepFEA_HSequenceOfNodeRepresentation: typeof Handle_StepFEA_HSequenceOfNodeRepresentation;
  Handle_StepFEA_HSequenceOfNodeRepresentation_1: typeof Handle_StepFEA_HSequenceOfNodeRepresentation_1;
  Handle_StepFEA_HSequenceOfNodeRepresentation_2: typeof Handle_StepFEA_HSequenceOfNodeRepresentation_2;
  Handle_StepFEA_HSequenceOfNodeRepresentation_3: typeof Handle_StepFEA_HSequenceOfNodeRepresentation_3;
  Handle_StepFEA_HSequenceOfNodeRepresentation_4: typeof Handle_StepFEA_HSequenceOfNodeRepresentation_4;
  StepFEA_CurveElementEndCoordinateSystem: typeof StepFEA_CurveElementEndCoordinateSystem;
  Handle_StepFEA_FeaMaterialPropertyRepresentationItem: typeof Handle_StepFEA_FeaMaterialPropertyRepresentationItem;
  Handle_StepFEA_FeaMaterialPropertyRepresentationItem_1: typeof Handle_StepFEA_FeaMaterialPropertyRepresentationItem_1;
  Handle_StepFEA_FeaMaterialPropertyRepresentationItem_2: typeof Handle_StepFEA_FeaMaterialPropertyRepresentationItem_2;
  Handle_StepFEA_FeaMaterialPropertyRepresentationItem_3: typeof Handle_StepFEA_FeaMaterialPropertyRepresentationItem_3;
  Handle_StepFEA_FeaMaterialPropertyRepresentationItem_4: typeof Handle_StepFEA_FeaMaterialPropertyRepresentationItem_4;
  StepFEA_FeaMaterialPropertyRepresentationItem: typeof StepFEA_FeaMaterialPropertyRepresentationItem;
  Handle_StepFEA_HArray1OfDegreeOfFreedom: typeof Handle_StepFEA_HArray1OfDegreeOfFreedom;
  Handle_StepFEA_HArray1OfDegreeOfFreedom_1: typeof Handle_StepFEA_HArray1OfDegreeOfFreedom_1;
  Handle_StepFEA_HArray1OfDegreeOfFreedom_2: typeof Handle_StepFEA_HArray1OfDegreeOfFreedom_2;
  Handle_StepFEA_HArray1OfDegreeOfFreedom_3: typeof Handle_StepFEA_HArray1OfDegreeOfFreedom_3;
  Handle_StepFEA_HArray1OfDegreeOfFreedom_4: typeof Handle_StepFEA_HArray1OfDegreeOfFreedom_4;
  StepFEA_FeaModel3d: typeof StepFEA_FeaModel3d;
  Handle_StepFEA_FeaModel3d: typeof Handle_StepFEA_FeaModel3d;
  Handle_StepFEA_FeaModel3d_1: typeof Handle_StepFEA_FeaModel3d_1;
  Handle_StepFEA_FeaModel3d_2: typeof Handle_StepFEA_FeaModel3d_2;
  Handle_StepFEA_FeaModel3d_3: typeof Handle_StepFEA_FeaModel3d_3;
  Handle_StepFEA_FeaModel3d_4: typeof Handle_StepFEA_FeaModel3d_4;
  StepFEA_ParametricCurve3dElementCoordinateSystem: typeof StepFEA_ParametricCurve3dElementCoordinateSystem;
  Handle_StepFEA_ParametricCurve3dElementCoordinateSystem: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateSystem;
  Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_1: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_1;
  Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_2: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_2;
  Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_3: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_3;
  Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_4: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateSystem_4;
  StepFEA_AlignedCurve3dElementCoordinateSystem: typeof StepFEA_AlignedCurve3dElementCoordinateSystem;
  Handle_StepFEA_AlignedCurve3dElementCoordinateSystem: typeof Handle_StepFEA_AlignedCurve3dElementCoordinateSystem;
  Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_1: typeof Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_1;
  Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_2: typeof Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_2;
  Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_3: typeof Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_3;
  Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_4: typeof Handle_StepFEA_AlignedCurve3dElementCoordinateSystem_4;
  StepFEA_SymmetricTensor42d: typeof StepFEA_SymmetricTensor42d;
  Handle_StepFEA_FeaMoistureAbsorption: typeof Handle_StepFEA_FeaMoistureAbsorption;
  Handle_StepFEA_FeaMoistureAbsorption_1: typeof Handle_StepFEA_FeaMoistureAbsorption_1;
  Handle_StepFEA_FeaMoistureAbsorption_2: typeof Handle_StepFEA_FeaMoistureAbsorption_2;
  Handle_StepFEA_FeaMoistureAbsorption_3: typeof Handle_StepFEA_FeaMoistureAbsorption_3;
  Handle_StepFEA_FeaMoistureAbsorption_4: typeof Handle_StepFEA_FeaMoistureAbsorption_4;
  StepFEA_FeaMoistureAbsorption: typeof StepFEA_FeaMoistureAbsorption;
  Handle_StepFEA_CurveElementLocation: typeof Handle_StepFEA_CurveElementLocation;
  Handle_StepFEA_CurveElementLocation_1: typeof Handle_StepFEA_CurveElementLocation_1;
  Handle_StepFEA_CurveElementLocation_2: typeof Handle_StepFEA_CurveElementLocation_2;
  Handle_StepFEA_CurveElementLocation_3: typeof Handle_StepFEA_CurveElementLocation_3;
  Handle_StepFEA_CurveElementLocation_4: typeof Handle_StepFEA_CurveElementLocation_4;
  StepFEA_CurveElementLocation: typeof StepFEA_CurveElementLocation;
  StepFEA_ElementOrElementGroup: typeof StepFEA_ElementOrElementGroup;
  Handle_StepFEA_CurveElementIntervalConstant: typeof Handle_StepFEA_CurveElementIntervalConstant;
  Handle_StepFEA_CurveElementIntervalConstant_1: typeof Handle_StepFEA_CurveElementIntervalConstant_1;
  Handle_StepFEA_CurveElementIntervalConstant_2: typeof Handle_StepFEA_CurveElementIntervalConstant_2;
  Handle_StepFEA_CurveElementIntervalConstant_3: typeof Handle_StepFEA_CurveElementIntervalConstant_3;
  Handle_StepFEA_CurveElementIntervalConstant_4: typeof Handle_StepFEA_CurveElementIntervalConstant_4;
  StepFEA_CurveElementIntervalConstant: typeof StepFEA_CurveElementIntervalConstant;
  StepFEA_CurveElementEndOffset: typeof StepFEA_CurveElementEndOffset;
  Handle_StepFEA_CurveElementEndOffset: typeof Handle_StepFEA_CurveElementEndOffset;
  Handle_StepFEA_CurveElementEndOffset_1: typeof Handle_StepFEA_CurveElementEndOffset_1;
  Handle_StepFEA_CurveElementEndOffset_2: typeof Handle_StepFEA_CurveElementEndOffset_2;
  Handle_StepFEA_CurveElementEndOffset_3: typeof Handle_StepFEA_CurveElementEndOffset_3;
  Handle_StepFEA_CurveElementEndOffset_4: typeof Handle_StepFEA_CurveElementEndOffset_4;
  StepFEA_UnspecifiedValue: StepFEA_UnspecifiedValue;
  StepFEA_NodeSet: typeof StepFEA_NodeSet;
  Handle_StepFEA_NodeSet: typeof Handle_StepFEA_NodeSet;
  Handle_StepFEA_NodeSet_1: typeof Handle_StepFEA_NodeSet_1;
  Handle_StepFEA_NodeSet_2: typeof Handle_StepFEA_NodeSet_2;
  Handle_StepFEA_NodeSet_3: typeof Handle_StepFEA_NodeSet_3;
  Handle_StepFEA_NodeSet_4: typeof Handle_StepFEA_NodeSet_4;
  StepFEA_ElementVolume: StepFEA_ElementVolume;
  Handle_StepFEA_NodeWithVector: typeof Handle_StepFEA_NodeWithVector;
  Handle_StepFEA_NodeWithVector_1: typeof Handle_StepFEA_NodeWithVector_1;
  Handle_StepFEA_NodeWithVector_2: typeof Handle_StepFEA_NodeWithVector_2;
  Handle_StepFEA_NodeWithVector_3: typeof Handle_StepFEA_NodeWithVector_3;
  Handle_StepFEA_NodeWithVector_4: typeof Handle_StepFEA_NodeWithVector_4;
  StepFEA_NodeWithVector: typeof StepFEA_NodeWithVector;
  StepFEA_CurveElementInterval: typeof StepFEA_CurveElementInterval;
  Handle_StepFEA_CurveElementInterval: typeof Handle_StepFEA_CurveElementInterval;
  Handle_StepFEA_CurveElementInterval_1: typeof Handle_StepFEA_CurveElementInterval_1;
  Handle_StepFEA_CurveElementInterval_2: typeof Handle_StepFEA_CurveElementInterval_2;
  Handle_StepFEA_CurveElementInterval_3: typeof Handle_StepFEA_CurveElementInterval_3;
  Handle_StepFEA_CurveElementInterval_4: typeof Handle_StepFEA_CurveElementInterval_4;
  StepFEA_FeaSurfaceSectionGeometricRelationship: typeof StepFEA_FeaSurfaceSectionGeometricRelationship;
  Handle_StepFEA_FeaSurfaceSectionGeometricRelationship: typeof Handle_StepFEA_FeaSurfaceSectionGeometricRelationship;
  Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_1: typeof Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_1;
  Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_2: typeof Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_2;
  Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_3: typeof Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_3;
  Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_4: typeof Handle_StepFEA_FeaSurfaceSectionGeometricRelationship_4;
  StepFEA_FeaAreaDensity: typeof StepFEA_FeaAreaDensity;
  Handle_StepFEA_FeaAreaDensity: typeof Handle_StepFEA_FeaAreaDensity;
  Handle_StepFEA_FeaAreaDensity_1: typeof Handle_StepFEA_FeaAreaDensity_1;
  Handle_StepFEA_FeaAreaDensity_2: typeof Handle_StepFEA_FeaAreaDensity_2;
  Handle_StepFEA_FeaAreaDensity_3: typeof Handle_StepFEA_FeaAreaDensity_3;
  Handle_StepFEA_FeaAreaDensity_4: typeof Handle_StepFEA_FeaAreaDensity_4;
  Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem: typeof Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem;
  Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_1: typeof Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_1;
  Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_2: typeof Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_2;
  Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_3: typeof Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_3;
  Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_4: typeof Handle_StepFEA_ArbitraryVolume3dElementCoordinateSystem_4;
  StepFEA_ArbitraryVolume3dElementCoordinateSystem: typeof StepFEA_ArbitraryVolume3dElementCoordinateSystem;
  StepFEA_ParametricCurve3dElementCoordinateDirection: typeof StepFEA_ParametricCurve3dElementCoordinateDirection;
  Handle_StepFEA_ParametricCurve3dElementCoordinateDirection: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateDirection;
  Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_1: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_1;
  Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_2: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_2;
  Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_3: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_3;
  Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_4: typeof Handle_StepFEA_ParametricCurve3dElementCoordinateDirection_4;
  Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion: typeof Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion;
  Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_1: typeof Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_1;
  Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_2: typeof Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_2;
  Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_3: typeof Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_3;
  Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_4: typeof Handle_StepFEA_FeaSecantCoefficientOfLinearThermalExpansion_4;
  StepFEA_FeaSecantCoefficientOfLinearThermalExpansion: typeof StepFEA_FeaSecantCoefficientOfLinearThermalExpansion;
  Handle_StepFEA_FreedomsList: typeof Handle_StepFEA_FreedomsList;
  Handle_StepFEA_FreedomsList_1: typeof Handle_StepFEA_FreedomsList_1;
  Handle_StepFEA_FreedomsList_2: typeof Handle_StepFEA_FreedomsList_2;
  Handle_StepFEA_FreedomsList_3: typeof Handle_StepFEA_FreedomsList_3;
  Handle_StepFEA_FreedomsList_4: typeof Handle_StepFEA_FreedomsList_4;
  StepFEA_FreedomsList: typeof StepFEA_FreedomsList;
  StepFEA_SymmetricTensor23dMember: typeof StepFEA_SymmetricTensor23dMember;
  Handle_StepFEA_SymmetricTensor23dMember: typeof Handle_StepFEA_SymmetricTensor23dMember;
  Handle_StepFEA_SymmetricTensor23dMember_1: typeof Handle_StepFEA_SymmetricTensor23dMember_1;
  Handle_StepFEA_SymmetricTensor23dMember_2: typeof Handle_StepFEA_SymmetricTensor23dMember_2;
  Handle_StepFEA_SymmetricTensor23dMember_3: typeof Handle_StepFEA_SymmetricTensor23dMember_3;
  Handle_StepFEA_SymmetricTensor23dMember_4: typeof Handle_StepFEA_SymmetricTensor23dMember_4;
  Handle_StepFEA_FeaShellMembraneStiffness: typeof Handle_StepFEA_FeaShellMembraneStiffness;
  Handle_StepFEA_FeaShellMembraneStiffness_1: typeof Handle_StepFEA_FeaShellMembraneStiffness_1;
  Handle_StepFEA_FeaShellMembraneStiffness_2: typeof Handle_StepFEA_FeaShellMembraneStiffness_2;
  Handle_StepFEA_FeaShellMembraneStiffness_3: typeof Handle_StepFEA_FeaShellMembraneStiffness_3;
  Handle_StepFEA_FeaShellMembraneStiffness_4: typeof Handle_StepFEA_FeaShellMembraneStiffness_4;
  StepFEA_FeaShellMembraneStiffness: typeof StepFEA_FeaShellMembraneStiffness;
  Handle_StepFEA_HSequenceOfElementRepresentation: typeof Handle_StepFEA_HSequenceOfElementRepresentation;
  Handle_StepFEA_HSequenceOfElementRepresentation_1: typeof Handle_StepFEA_HSequenceOfElementRepresentation_1;
  Handle_StepFEA_HSequenceOfElementRepresentation_2: typeof Handle_StepFEA_HSequenceOfElementRepresentation_2;
  Handle_StepFEA_HSequenceOfElementRepresentation_3: typeof Handle_StepFEA_HSequenceOfElementRepresentation_3;
  Handle_StepFEA_HSequenceOfElementRepresentation_4: typeof Handle_StepFEA_HSequenceOfElementRepresentation_4;
  StepFEA_Array1OfDegreeOfFreedom: typeof StepFEA_Array1OfDegreeOfFreedom;
  StepFEA_Array1OfDegreeOfFreedom_1: typeof StepFEA_Array1OfDegreeOfFreedom_1;
  StepFEA_Array1OfDegreeOfFreedom_2: typeof StepFEA_Array1OfDegreeOfFreedom_2;
  StepFEA_Array1OfDegreeOfFreedom_3: typeof StepFEA_Array1OfDegreeOfFreedom_3;
  StepFEA_Array1OfDegreeOfFreedom_4: typeof StepFEA_Array1OfDegreeOfFreedom_4;
  StepFEA_Array1OfDegreeOfFreedom_5: typeof StepFEA_Array1OfDegreeOfFreedom_5;
  Handle_StepFEA_AlignedSurface3dElementCoordinateSystem: typeof Handle_StepFEA_AlignedSurface3dElementCoordinateSystem;
  Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_1: typeof Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_1;
  Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_2: typeof Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_2;
  Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_3: typeof Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_3;
  Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_4: typeof Handle_StepFEA_AlignedSurface3dElementCoordinateSystem_4;
  StepFEA_AlignedSurface3dElementCoordinateSystem: typeof StepFEA_AlignedSurface3dElementCoordinateSystem;
  BOPTools_SetMapHasher: typeof BOPTools_SetMapHasher;
  BOPTools_ListOfConnexityBlock: typeof BOPTools_ListOfConnexityBlock;
  BOPTools_ListOfConnexityBlock_1: typeof BOPTools_ListOfConnexityBlock_1;
  BOPTools_ListOfConnexityBlock_2: typeof BOPTools_ListOfConnexityBlock_2;
  BOPTools_ListOfConnexityBlock_3: typeof BOPTools_ListOfConnexityBlock_3;
  BOPTools_AlgoTools3D: typeof BOPTools_AlgoTools3D;
  BOPTools_AlgoTools: typeof BOPTools_AlgoTools;
  BOPTools_AlgoTools2D: typeof BOPTools_AlgoTools2D;
  BOPTools_IndexedDataMapOfSetShape: typeof BOPTools_IndexedDataMapOfSetShape;
  BOPTools_IndexedDataMapOfSetShape_1: typeof BOPTools_IndexedDataMapOfSetShape_1;
  BOPTools_IndexedDataMapOfSetShape_2: typeof BOPTools_IndexedDataMapOfSetShape_2;
  BOPTools_IndexedDataMapOfSetShape_3: typeof BOPTools_IndexedDataMapOfSetShape_3;
  BOPTools_ListOfCoupleOfShape: typeof BOPTools_ListOfCoupleOfShape;
  BOPTools_ListOfCoupleOfShape_1: typeof BOPTools_ListOfCoupleOfShape_1;
  BOPTools_ListOfCoupleOfShape_2: typeof BOPTools_ListOfCoupleOfShape_2;
  BOPTools_ListOfCoupleOfShape_3: typeof BOPTools_ListOfCoupleOfShape_3;
  BOPTools_CoupleOfShape: typeof BOPTools_CoupleOfShape;
  BOPTools_Set: typeof BOPTools_Set;
  BOPTools_Set_1: typeof BOPTools_Set_1;
  BOPTools_Set_2: typeof BOPTools_Set_2;
  BOPTools_Set_3: typeof BOPTools_Set_3;
  BOPTools_MapOfSet: typeof BOPTools_MapOfSet;
  BOPTools_MapOfSet_1: typeof BOPTools_MapOfSet_1;
  BOPTools_MapOfSet_2: typeof BOPTools_MapOfSet_2;
  BOPTools_MapOfSet_3: typeof BOPTools_MapOfSet_3;
  BOPTools_ConnexityBlock: typeof BOPTools_ConnexityBlock;
  BOPTools_ConnexityBlock_1: typeof BOPTools_ConnexityBlock_1;
  BOPTools_ConnexityBlock_2: typeof BOPTools_ConnexityBlock_2;
  ChFiDS_FaceInterference: typeof ChFiDS_FaceInterference;
  Handle_ChFiDS_ChamfSpine: typeof Handle_ChFiDS_ChamfSpine;
  Handle_ChFiDS_ChamfSpine_1: typeof Handle_ChFiDS_ChamfSpine_1;
  Handle_ChFiDS_ChamfSpine_2: typeof Handle_ChFiDS_ChamfSpine_2;
  Handle_ChFiDS_ChamfSpine_3: typeof Handle_ChFiDS_ChamfSpine_3;
  Handle_ChFiDS_ChamfSpine_4: typeof Handle_ChFiDS_ChamfSpine_4;
  ChFiDS_ChamfSpine: typeof ChFiDS_ChamfSpine;
  ChFiDS_ChamfSpine_1: typeof ChFiDS_ChamfSpine_1;
  ChFiDS_ChamfSpine_2: typeof ChFiDS_ChamfSpine_2;
  Handle_ChFiDS_HElSpine: typeof Handle_ChFiDS_HElSpine;
  Handle_ChFiDS_HElSpine_1: typeof Handle_ChFiDS_HElSpine_1;
  Handle_ChFiDS_HElSpine_2: typeof Handle_ChFiDS_HElSpine_2;
  Handle_ChFiDS_HElSpine_3: typeof Handle_ChFiDS_HElSpine_3;
  Handle_ChFiDS_HElSpine_4: typeof Handle_ChFiDS_HElSpine_4;
  ChFiDS_HElSpine: typeof ChFiDS_HElSpine;
  ChFiDS_HElSpine_1: typeof ChFiDS_HElSpine_1;
  ChFiDS_HElSpine_2: typeof ChFiDS_HElSpine_2;
  ChFiDS_ChamfMethod: ChFiDS_ChamfMethod;
  ChFiDS_IndexedDataMapOfVertexListOfStripe: typeof ChFiDS_IndexedDataMapOfVertexListOfStripe;
  ChFiDS_IndexedDataMapOfVertexListOfStripe_1: typeof ChFiDS_IndexedDataMapOfVertexListOfStripe_1;
  ChFiDS_IndexedDataMapOfVertexListOfStripe_2: typeof ChFiDS_IndexedDataMapOfVertexListOfStripe_2;
  ChFiDS_IndexedDataMapOfVertexListOfStripe_3: typeof ChFiDS_IndexedDataMapOfVertexListOfStripe_3;
  ChFiDS_ElSpine: typeof ChFiDS_ElSpine;
  Handle_ChFiDS_Spine: typeof Handle_ChFiDS_Spine;
  Handle_ChFiDS_Spine_1: typeof Handle_ChFiDS_Spine_1;
  Handle_ChFiDS_Spine_2: typeof Handle_ChFiDS_Spine_2;
  Handle_ChFiDS_Spine_3: typeof Handle_ChFiDS_Spine_3;
  Handle_ChFiDS_Spine_4: typeof Handle_ChFiDS_Spine_4;
  ChFiDS_Spine: typeof ChFiDS_Spine;
  ChFiDS_Spine_1: typeof ChFiDS_Spine_1;
  ChFiDS_Spine_2: typeof ChFiDS_Spine_2;
  ChFiDS_ChamfMode: ChFiDS_ChamfMode;
  ChFiDS_State: ChFiDS_State;
  ChFiDS_Map: typeof ChFiDS_Map;
  ChFiDS_ErrorStatus: ChFiDS_ErrorStatus;
  Handle_ChFiDS_FilSpine: typeof Handle_ChFiDS_FilSpine;
  Handle_ChFiDS_FilSpine_1: typeof Handle_ChFiDS_FilSpine_1;
  Handle_ChFiDS_FilSpine_2: typeof Handle_ChFiDS_FilSpine_2;
  Handle_ChFiDS_FilSpine_3: typeof Handle_ChFiDS_FilSpine_3;
  Handle_ChFiDS_FilSpine_4: typeof Handle_ChFiDS_FilSpine_4;
  ChFiDS_FilSpine: typeof ChFiDS_FilSpine;
  ChFiDS_FilSpine_1: typeof ChFiDS_FilSpine_1;
  ChFiDS_FilSpine_2: typeof ChFiDS_FilSpine_2;
  ChFiDS_CommonPoint: typeof ChFiDS_CommonPoint;
  ChFiDS_TypeOfConcavity: ChFiDS_TypeOfConcavity;
  ChFiDS_SurfData: typeof ChFiDS_SurfData;
  Handle_ChFiDS_SurfData: typeof Handle_ChFiDS_SurfData;
  Handle_ChFiDS_SurfData_1: typeof Handle_ChFiDS_SurfData_1;
  Handle_ChFiDS_SurfData_2: typeof Handle_ChFiDS_SurfData_2;
  Handle_ChFiDS_SurfData_3: typeof Handle_ChFiDS_SurfData_3;
  Handle_ChFiDS_SurfData_4: typeof Handle_ChFiDS_SurfData_4;
  ChFiDS_StripeMap: typeof ChFiDS_StripeMap;
  ChFiDS_SecArray1: typeof ChFiDS_SecArray1;
  ChFiDS_SecArray1_1: typeof ChFiDS_SecArray1_1;
  ChFiDS_SecArray1_2: typeof ChFiDS_SecArray1_2;
  ChFiDS_SecArray1_3: typeof ChFiDS_SecArray1_3;
  ChFiDS_SecArray1_4: typeof ChFiDS_SecArray1_4;
  ChFiDS_SecArray1_5: typeof ChFiDS_SecArray1_5;
  Handle_ChFiDS_SecHArray1: typeof Handle_ChFiDS_SecHArray1;
  Handle_ChFiDS_SecHArray1_1: typeof Handle_ChFiDS_SecHArray1_1;
  Handle_ChFiDS_SecHArray1_2: typeof Handle_ChFiDS_SecHArray1_2;
  Handle_ChFiDS_SecHArray1_3: typeof Handle_ChFiDS_SecHArray1_3;
  Handle_ChFiDS_SecHArray1_4: typeof Handle_ChFiDS_SecHArray1_4;
  ChFiDS_Regul: typeof ChFiDS_Regul;
  ChFiDS_Regularities: typeof ChFiDS_Regularities;
  ChFiDS_Regularities_1: typeof ChFiDS_Regularities_1;
  ChFiDS_Regularities_2: typeof ChFiDS_Regularities_2;
  ChFiDS_Regularities_3: typeof ChFiDS_Regularities_3;
  Handle_ChFiDS_HData: typeof Handle_ChFiDS_HData;
  Handle_ChFiDS_HData_1: typeof Handle_ChFiDS_HData_1;
  Handle_ChFiDS_HData_2: typeof Handle_ChFiDS_HData_2;
  Handle_ChFiDS_HData_3: typeof Handle_ChFiDS_HData_3;
  Handle_ChFiDS_HData_4: typeof Handle_ChFiDS_HData_4;
  Handle_ChFiDS_Stripe: typeof Handle_ChFiDS_Stripe;
  Handle_ChFiDS_Stripe_1: typeof Handle_ChFiDS_Stripe_1;
  Handle_ChFiDS_Stripe_2: typeof Handle_ChFiDS_Stripe_2;
  Handle_ChFiDS_Stripe_3: typeof Handle_ChFiDS_Stripe_3;
  Handle_ChFiDS_Stripe_4: typeof Handle_ChFiDS_Stripe_4;
  ChFiDS_Stripe: typeof ChFiDS_Stripe;
  ChFiDS_CircSection: typeof ChFiDS_CircSection;
  VrmlAPI_Writer: typeof VrmlAPI_Writer;
  VrmlAPI_RepresentationOfShape: VrmlAPI_RepresentationOfShape;
  VrmlAPI: typeof VrmlAPI;
};

declare function init(): Promise<OpenCascadeInstance>;

export default init;
